"use strict";
var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const React = require("react");
require("react-redux");
const ReactDOM = require("react-dom");
var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x["default"] : x;
}
function getAugmentedNamespace(n2) {
  if (n2.__esModule)
    return n2;
  var f2 = n2.default;
  if (typeof f2 == "function") {
    var a = function a2() {
      if (this instanceof a2) {
        var args = [null];
        args.push.apply(args, arguments);
        var Ctor = Function.bind.apply(f2, args);
        return new Ctor();
      }
      return f2.apply(this, arguments);
    };
    a.prototype = f2.prototype;
  } else
    a = {};
  Object.defineProperty(a, "__esModule", { value: true });
  Object.keys(n2).forEach(function(k) {
    var d2 = Object.getOwnPropertyDescriptor(n2, k);
    Object.defineProperty(a, k, d2.get ? d2 : {
      enumerable: true,
      get: function() {
        return n2[k];
      }
    });
  });
  return a;
}
var shortidExports = {};
var shortid$1 = {
  get exports() {
    return shortidExports;
  },
  set exports(v) {
    shortidExports = v;
  }
};
var libExports = {};
var lib = {
  get exports() {
    return libExports;
  },
  set exports(v) {
    libExports = v;
  }
};
var seed = 1;
function getNextValue() {
  seed = (seed * 9301 + 49297) % 233280;
  return seed / 233280;
}
function setSeed$1(_seed_) {
  seed = _seed_;
}
var randomFromSeed$1 = {
  nextValue: getNextValue,
  seed: setSeed$1
};
var randomFromSeed = randomFromSeed$1;
var ORIGINAL = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_-";
var alphabet$2;
var previousSeed;
var shuffled;
function reset() {
  shuffled = false;
}
function setCharacters(_alphabet_) {
  if (!_alphabet_) {
    if (alphabet$2 !== ORIGINAL) {
      alphabet$2 = ORIGINAL;
      reset();
    }
    return;
  }
  if (_alphabet_ === alphabet$2) {
    return;
  }
  if (_alphabet_.length !== ORIGINAL.length) {
    throw new Error("Custom alphabet for shortid must be " + ORIGINAL.length + " unique characters. You submitted " + _alphabet_.length + " characters: " + _alphabet_);
  }
  var unique = _alphabet_.split("").filter(function(item, ind, arr) {
    return ind !== arr.lastIndexOf(item);
  });
  if (unique.length) {
    throw new Error("Custom alphabet for shortid must be " + ORIGINAL.length + " unique characters. These characters were not unique: " + unique.join(", "));
  }
  alphabet$2 = _alphabet_;
  reset();
}
function characters(_alphabet_) {
  setCharacters(_alphabet_);
  return alphabet$2;
}
function setSeed(seed2) {
  randomFromSeed.seed(seed2);
  if (previousSeed !== seed2) {
    reset();
    previousSeed = seed2;
  }
}
function shuffle() {
  if (!alphabet$2) {
    setCharacters(ORIGINAL);
  }
  var sourceArray = alphabet$2.split("");
  var targetArray = [];
  var r = randomFromSeed.nextValue();
  var characterIndex;
  while (sourceArray.length > 0) {
    r = randomFromSeed.nextValue();
    characterIndex = Math.floor(r * sourceArray.length);
    targetArray.push(sourceArray.splice(characterIndex, 1)[0]);
  }
  return targetArray.join("");
}
function getShuffled() {
  if (shuffled) {
    return shuffled;
  }
  shuffled = shuffle();
  return shuffled;
}
function lookup(index) {
  var alphabetShuffled = getShuffled();
  return alphabetShuffled[index];
}
function get() {
  return alphabet$2 || ORIGINAL;
}
var alphabet_1 = {
  get,
  characters,
  seed: setSeed,
  lookup,
  shuffled: getShuffled
};
var crypto$1 = typeof window === "object" && (window.crypto || window.msCrypto);
var randomByte;
if (!crypto$1 || !crypto$1.getRandomValues) {
  randomByte = function(size) {
    var bytes = [];
    for (var i = 0; i < size; i++) {
      bytes.push(Math.floor(Math.random() * 256));
    }
    return bytes;
  };
} else {
  randomByte = function(size) {
    return crypto$1.getRandomValues(new Uint8Array(size));
  };
}
var randomByteBrowser = randomByte;
var format_browser = function(random2, alphabet2, size) {
  var mask = (2 << Math.log(alphabet2.length - 1) / Math.LN2) - 1;
  var step = -~(1.6 * mask * size / alphabet2.length);
  var id = "";
  while (true) {
    var bytes = random2(step);
    var i = step;
    while (i--) {
      id += alphabet2[bytes[i] & mask] || "";
      if (id.length === +size)
        return id;
    }
  }
};
var alphabet$1 = alphabet_1;
var random = randomByteBrowser;
var format = format_browser;
function generate$1(number) {
  var loopCounter = 0;
  var done;
  var str = "";
  while (!done) {
    str = str + format(random, alphabet$1.get(), 1);
    done = number < Math.pow(16, loopCounter + 1);
    loopCounter++;
  }
  return str;
}
var generate_1 = generate$1;
var generate = generate_1;
var REDUCE_TIME = 1567752802062;
var version = 7;
var counter;
var previousSeconds;
function build$1(clusterWorkerId) {
  var str = "";
  var seconds = Math.floor((Date.now() - REDUCE_TIME) * 1e-3);
  if (seconds === previousSeconds) {
    counter++;
  } else {
    counter = 0;
    previousSeconds = seconds;
  }
  str = str + generate(version);
  str = str + generate(clusterWorkerId);
  if (counter > 0) {
    str = str + generate(counter);
  }
  str = str + generate(seconds);
  return str;
}
var build_1 = build$1;
var alphabet = alphabet_1;
function isShortId(id) {
  if (!id || typeof id !== "string" || id.length < 6) {
    return false;
  }
  var nonAlphabetic = new RegExp("[^" + alphabet.get().replace(/[|\\{}()[\]^$+*?.-]/g, "\\$&") + "]");
  return !nonAlphabetic.test(id);
}
var isValid = isShortId;
(function(module2) {
  var alphabet2 = alphabet_1;
  var build3 = build_1;
  var isValid$1 = isValid;
  var clusterWorkerId = 0;
  function seed2(seedValue) {
    alphabet2.seed(seedValue);
    return module2.exports;
  }
  function worker(workerId) {
    clusterWorkerId = workerId;
    return module2.exports;
  }
  function characters2(newCharacters) {
    if (newCharacters !== void 0) {
      alphabet2.characters(newCharacters);
    }
    return alphabet2.shuffled();
  }
  function generate2() {
    return build3(clusterWorkerId);
  }
  module2.exports = generate2;
  module2.exports.generate = generate2;
  module2.exports.seed = seed2;
  module2.exports.worker = worker;
  module2.exports.characters = characters2;
  module2.exports.isValid = isValid$1;
})(lib);
(function(module2) {
  module2.exports = libExports;
})(shortid$1);
const shortid = /* @__PURE__ */ getDefaultExportFromCjs(shortidExports);
var freeGlobal$1 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
var freeSelf$1 = typeof self == "object" && self && self.Object === Object && self;
freeGlobal$1 || freeSelf$1 || Function("return this")();
function isStack$1(item) {
  return item.isStack;
}
function isComponent$1(item) {
  return item.isComponent;
}
function isRoot$1(item) {
  return item.isRoot;
}
const GoldenLayout$3 = "";
var toStr$9 = Object.prototype.toString;
var isArguments$3 = function isArguments(value) {
  var str = toStr$9.call(value);
  var isArgs2 = str === "[object Arguments]";
  if (!isArgs2) {
    isArgs2 = str !== "[object Array]" && value !== null && typeof value === "object" && typeof value.length === "number" && value.length >= 0 && toStr$9.call(value.callee) === "[object Function]";
  }
  return isArgs2;
};
var implementation$b;
var hasRequiredImplementation;
function requireImplementation() {
  if (hasRequiredImplementation)
    return implementation$b;
  hasRequiredImplementation = 1;
  var keysShim2;
  if (!Object.keys) {
    var has2 = Object.prototype.hasOwnProperty;
    var toStr2 = Object.prototype.toString;
    var isArgs2 = isArguments$3;
    var isEnumerable2 = Object.prototype.propertyIsEnumerable;
    var hasDontEnumBug = !isEnumerable2.call({ toString: null }, "toString");
    var hasProtoEnumBug = isEnumerable2.call(function() {
    }, "prototype");
    var dontEnums = [
      "toString",
      "toLocaleString",
      "valueOf",
      "hasOwnProperty",
      "isPrototypeOf",
      "propertyIsEnumerable",
      "constructor"
    ];
    var equalsConstructorPrototype = function(o) {
      var ctor = o.constructor;
      return ctor && ctor.prototype === o;
    };
    var excludedKeys = {
      $applicationCache: true,
      $console: true,
      $external: true,
      $frame: true,
      $frameElement: true,
      $frames: true,
      $innerHeight: true,
      $innerWidth: true,
      $onmozfullscreenchange: true,
      $onmozfullscreenerror: true,
      $outerHeight: true,
      $outerWidth: true,
      $pageXOffset: true,
      $pageYOffset: true,
      $parent: true,
      $scrollLeft: true,
      $scrollTop: true,
      $scrollX: true,
      $scrollY: true,
      $self: true,
      $webkitIndexedDB: true,
      $webkitStorageInfo: true,
      $window: true
    };
    var hasAutomationEqualityBug = function() {
      if (typeof window === "undefined") {
        return false;
      }
      for (var k in window) {
        try {
          if (!excludedKeys["$" + k] && has2.call(window, k) && window[k] !== null && typeof window[k] === "object") {
            try {
              equalsConstructorPrototype(window[k]);
            } catch (e) {
              return true;
            }
          }
        } catch (e) {
          return true;
        }
      }
      return false;
    }();
    var equalsConstructorPrototypeIfNotBuggy = function(o) {
      if (typeof window === "undefined" || !hasAutomationEqualityBug) {
        return equalsConstructorPrototype(o);
      }
      try {
        return equalsConstructorPrototype(o);
      } catch (e) {
        return false;
      }
    };
    keysShim2 = function keys3(object) {
      var isObject2 = object !== null && typeof object === "object";
      var isFunction2 = toStr2.call(object) === "[object Function]";
      var isArguments5 = isArgs2(object);
      var isString3 = isObject2 && toStr2.call(object) === "[object String]";
      var theKeys = [];
      if (!isObject2 && !isFunction2 && !isArguments5) {
        throw new TypeError("Object.keys called on a non-object");
      }
      var skipProto = hasProtoEnumBug && isFunction2;
      if (isString3 && object.length > 0 && !has2.call(object, 0)) {
        for (var i = 0; i < object.length; ++i) {
          theKeys.push(String(i));
        }
      }
      if (isArguments5 && object.length > 0) {
        for (var j = 0; j < object.length; ++j) {
          theKeys.push(String(j));
        }
      } else {
        for (var name2 in object) {
          if (!(skipProto && name2 === "prototype") && has2.call(object, name2)) {
            theKeys.push(String(name2));
          }
        }
      }
      if (hasDontEnumBug) {
        var skipConstructor = equalsConstructorPrototypeIfNotBuggy(object);
        for (var k = 0; k < dontEnums.length; ++k) {
          if (!(skipConstructor && dontEnums[k] === "constructor") && has2.call(object, dontEnums[k])) {
            theKeys.push(dontEnums[k]);
          }
        }
      }
      return theKeys;
    };
  }
  implementation$b = keysShim2;
  return implementation$b;
}
var slice$1 = Array.prototype.slice;
var isArgs = isArguments$3;
var origKeys = Object.keys;
var keysShim = origKeys ? function keys(o) {
  return origKeys(o);
} : requireImplementation();
var originalKeys = Object.keys;
keysShim.shim = function shimObjectKeys() {
  if (Object.keys) {
    var keysWorksWithArguments = function() {
      var args = Object.keys(arguments);
      return args && args.length === arguments.length;
    }(1, 2);
    if (!keysWorksWithArguments) {
      Object.keys = function keys3(object) {
        if (isArgs(object)) {
          return originalKeys(slice$1.call(object));
        }
        return originalKeys(object);
      };
    }
  } else {
    Object.keys = keysShim;
  }
  return Object.keys || keysShim;
};
var objectKeys$2 = keysShim;
var shams$1 = function hasSymbols() {
  if (typeof Symbol !== "function" || typeof Object.getOwnPropertySymbols !== "function") {
    return false;
  }
  if (typeof Symbol.iterator === "symbol") {
    return true;
  }
  var obj = {};
  var sym = Symbol("test");
  var symObj = Object(sym);
  if (typeof sym === "string") {
    return false;
  }
  if (Object.prototype.toString.call(sym) !== "[object Symbol]") {
    return false;
  }
  if (Object.prototype.toString.call(symObj) !== "[object Symbol]") {
    return false;
  }
  var symVal = 42;
  obj[sym] = symVal;
  for (sym in obj) {
    return false;
  }
  if (typeof Object.keys === "function" && Object.keys(obj).length !== 0) {
    return false;
  }
  if (typeof Object.getOwnPropertyNames === "function" && Object.getOwnPropertyNames(obj).length !== 0) {
    return false;
  }
  var syms = Object.getOwnPropertySymbols(obj);
  if (syms.length !== 1 || syms[0] !== sym) {
    return false;
  }
  if (!Object.prototype.propertyIsEnumerable.call(obj, sym)) {
    return false;
  }
  if (typeof Object.getOwnPropertyDescriptor === "function") {
    var descriptor = Object.getOwnPropertyDescriptor(obj, sym);
    if (descriptor.value !== symVal || descriptor.enumerable !== true) {
      return false;
    }
  }
  return true;
};
var origSymbol = typeof Symbol !== "undefined" && Symbol;
var hasSymbolSham = shams$1;
var hasSymbols$5 = function hasNativeSymbols() {
  if (typeof origSymbol !== "function") {
    return false;
  }
  if (typeof Symbol !== "function") {
    return false;
  }
  if (typeof origSymbol("foo") !== "symbol") {
    return false;
  }
  if (typeof Symbol("bar") !== "symbol") {
    return false;
  }
  return hasSymbolSham();
};
var ERROR_MESSAGE = "Function.prototype.bind called on incompatible ";
var slice = Array.prototype.slice;
var toStr$8 = Object.prototype.toString;
var funcType = "[object Function]";
var implementation$a = function bind(that) {
  var target = this;
  if (typeof target !== "function" || toStr$8.call(target) !== funcType) {
    throw new TypeError(ERROR_MESSAGE + target);
  }
  var args = slice.call(arguments, 1);
  var bound2;
  var binder = function() {
    if (this instanceof bound2) {
      var result = target.apply(
        this,
        args.concat(slice.call(arguments))
      );
      if (Object(result) === result) {
        return result;
      }
      return this;
    } else {
      return target.apply(
        that,
        args.concat(slice.call(arguments))
      );
    }
  };
  var boundLength = Math.max(0, target.length - args.length);
  var boundArgs = [];
  for (var i = 0; i < boundLength; i++) {
    boundArgs.push("$" + i);
  }
  bound2 = Function("binder", "return function (" + boundArgs.join(",") + "){ return binder.apply(this,arguments); }")(binder);
  if (target.prototype) {
    var Empty = function Empty2() {
    };
    Empty.prototype = target.prototype;
    bound2.prototype = new Empty();
    Empty.prototype = null;
  }
  return bound2;
};
var implementation$9 = implementation$a;
var functionBind = Function.prototype.bind || implementation$9;
var bind$1 = functionBind;
var src = bind$1.call(Function.call, Object.prototype.hasOwnProperty);
var undefined$1;
var $SyntaxError$1 = SyntaxError;
var $Function = Function;
var $TypeError$2 = TypeError;
var getEvalledConstructor = function(expressionSyntax) {
  try {
    return $Function('"use strict"; return (' + expressionSyntax + ").constructor;")();
  } catch (e) {
  }
};
var $gOPD$2 = Object.getOwnPropertyDescriptor;
if ($gOPD$2) {
  try {
    $gOPD$2({}, "");
  } catch (e) {
    $gOPD$2 = null;
  }
}
var throwTypeError = function() {
  throw new $TypeError$2();
};
var ThrowTypeError = $gOPD$2 ? function() {
  try {
    arguments.callee;
    return throwTypeError;
  } catch (calleeThrows) {
    try {
      return $gOPD$2(arguments, "callee").get;
    } catch (gOPDthrows) {
      return throwTypeError;
    }
  }
}() : throwTypeError;
var hasSymbols$4 = hasSymbols$5();
var getProto$1 = Object.getPrototypeOf || function(x) {
  return x.__proto__;
};
var needsEval = {};
var TypedArray = typeof Uint8Array === "undefined" ? undefined$1 : getProto$1(Uint8Array);
var INTRINSICS = {
  "%AggregateError%": typeof AggregateError === "undefined" ? undefined$1 : AggregateError,
  "%Array%": Array,
  "%ArrayBuffer%": typeof ArrayBuffer === "undefined" ? undefined$1 : ArrayBuffer,
  "%ArrayIteratorPrototype%": hasSymbols$4 ? getProto$1([][Symbol.iterator]()) : undefined$1,
  "%AsyncFromSyncIteratorPrototype%": undefined$1,
  "%AsyncFunction%": needsEval,
  "%AsyncGenerator%": needsEval,
  "%AsyncGeneratorFunction%": needsEval,
  "%AsyncIteratorPrototype%": needsEval,
  "%Atomics%": typeof Atomics === "undefined" ? undefined$1 : Atomics,
  "%BigInt%": typeof BigInt === "undefined" ? undefined$1 : BigInt,
  "%BigInt64Array%": typeof BigInt64Array === "undefined" ? undefined$1 : BigInt64Array,
  "%BigUint64Array%": typeof BigUint64Array === "undefined" ? undefined$1 : BigUint64Array,
  "%Boolean%": Boolean,
  "%DataView%": typeof DataView === "undefined" ? undefined$1 : DataView,
  "%Date%": Date,
  "%decodeURI%": decodeURI,
  "%decodeURIComponent%": decodeURIComponent,
  "%encodeURI%": encodeURI,
  "%encodeURIComponent%": encodeURIComponent,
  "%Error%": Error,
  "%eval%": eval,
  // eslint-disable-line no-eval
  "%EvalError%": EvalError,
  "%Float32Array%": typeof Float32Array === "undefined" ? undefined$1 : Float32Array,
  "%Float64Array%": typeof Float64Array === "undefined" ? undefined$1 : Float64Array,
  "%FinalizationRegistry%": typeof FinalizationRegistry === "undefined" ? undefined$1 : FinalizationRegistry,
  "%Function%": $Function,
  "%GeneratorFunction%": needsEval,
  "%Int8Array%": typeof Int8Array === "undefined" ? undefined$1 : Int8Array,
  "%Int16Array%": typeof Int16Array === "undefined" ? undefined$1 : Int16Array,
  "%Int32Array%": typeof Int32Array === "undefined" ? undefined$1 : Int32Array,
  "%isFinite%": isFinite,
  "%isNaN%": isNaN,
  "%IteratorPrototype%": hasSymbols$4 ? getProto$1(getProto$1([][Symbol.iterator]())) : undefined$1,
  "%JSON%": typeof JSON === "object" ? JSON : undefined$1,
  "%Map%": typeof Map === "undefined" ? undefined$1 : Map,
  "%MapIteratorPrototype%": typeof Map === "undefined" || !hasSymbols$4 ? undefined$1 : getProto$1((/* @__PURE__ */ new Map())[Symbol.iterator]()),
  "%Math%": Math,
  "%Number%": Number,
  "%Object%": Object,
  "%parseFloat%": parseFloat,
  "%parseInt%": parseInt,
  "%Promise%": typeof Promise === "undefined" ? undefined$1 : Promise,
  "%Proxy%": typeof Proxy === "undefined" ? undefined$1 : Proxy,
  "%RangeError%": RangeError,
  "%ReferenceError%": ReferenceError,
  "%Reflect%": typeof Reflect === "undefined" ? undefined$1 : Reflect,
  "%RegExp%": RegExp,
  "%Set%": typeof Set === "undefined" ? undefined$1 : Set,
  "%SetIteratorPrototype%": typeof Set === "undefined" || !hasSymbols$4 ? undefined$1 : getProto$1((/* @__PURE__ */ new Set())[Symbol.iterator]()),
  "%SharedArrayBuffer%": typeof SharedArrayBuffer === "undefined" ? undefined$1 : SharedArrayBuffer,
  "%String%": String,
  "%StringIteratorPrototype%": hasSymbols$4 ? getProto$1(""[Symbol.iterator]()) : undefined$1,
  "%Symbol%": hasSymbols$4 ? Symbol : undefined$1,
  "%SyntaxError%": $SyntaxError$1,
  "%ThrowTypeError%": ThrowTypeError,
  "%TypedArray%": TypedArray,
  "%TypeError%": $TypeError$2,
  "%Uint8Array%": typeof Uint8Array === "undefined" ? undefined$1 : Uint8Array,
  "%Uint8ClampedArray%": typeof Uint8ClampedArray === "undefined" ? undefined$1 : Uint8ClampedArray,
  "%Uint16Array%": typeof Uint16Array === "undefined" ? undefined$1 : Uint16Array,
  "%Uint32Array%": typeof Uint32Array === "undefined" ? undefined$1 : Uint32Array,
  "%URIError%": URIError,
  "%WeakMap%": typeof WeakMap === "undefined" ? undefined$1 : WeakMap,
  "%WeakRef%": typeof WeakRef === "undefined" ? undefined$1 : WeakRef,
  "%WeakSet%": typeof WeakSet === "undefined" ? undefined$1 : WeakSet
};
try {
  null.error;
} catch (e) {
  var errorProto = getProto$1(getProto$1(e));
  INTRINSICS["%Error.prototype%"] = errorProto;
}
var doEval = function doEval2(name2) {
  var value;
  if (name2 === "%AsyncFunction%") {
    value = getEvalledConstructor("async function () {}");
  } else if (name2 === "%GeneratorFunction%") {
    value = getEvalledConstructor("function* () {}");
  } else if (name2 === "%AsyncGeneratorFunction%") {
    value = getEvalledConstructor("async function* () {}");
  } else if (name2 === "%AsyncGenerator%") {
    var fn = doEval2("%AsyncGeneratorFunction%");
    if (fn) {
      value = fn.prototype;
    }
  } else if (name2 === "%AsyncIteratorPrototype%") {
    var gen = doEval2("%AsyncGenerator%");
    if (gen) {
      value = getProto$1(gen.prototype);
    }
  }
  INTRINSICS[name2] = value;
  return value;
};
var LEGACY_ALIASES = {
  "%ArrayBufferPrototype%": ["ArrayBuffer", "prototype"],
  "%ArrayPrototype%": ["Array", "prototype"],
  "%ArrayProto_entries%": ["Array", "prototype", "entries"],
  "%ArrayProto_forEach%": ["Array", "prototype", "forEach"],
  "%ArrayProto_keys%": ["Array", "prototype", "keys"],
  "%ArrayProto_values%": ["Array", "prototype", "values"],
  "%AsyncFunctionPrototype%": ["AsyncFunction", "prototype"],
  "%AsyncGenerator%": ["AsyncGeneratorFunction", "prototype"],
  "%AsyncGeneratorPrototype%": ["AsyncGeneratorFunction", "prototype", "prototype"],
  "%BooleanPrototype%": ["Boolean", "prototype"],
  "%DataViewPrototype%": ["DataView", "prototype"],
  "%DatePrototype%": ["Date", "prototype"],
  "%ErrorPrototype%": ["Error", "prototype"],
  "%EvalErrorPrototype%": ["EvalError", "prototype"],
  "%Float32ArrayPrototype%": ["Float32Array", "prototype"],
  "%Float64ArrayPrototype%": ["Float64Array", "prototype"],
  "%FunctionPrototype%": ["Function", "prototype"],
  "%Generator%": ["GeneratorFunction", "prototype"],
  "%GeneratorPrototype%": ["GeneratorFunction", "prototype", "prototype"],
  "%Int8ArrayPrototype%": ["Int8Array", "prototype"],
  "%Int16ArrayPrototype%": ["Int16Array", "prototype"],
  "%Int32ArrayPrototype%": ["Int32Array", "prototype"],
  "%JSONParse%": ["JSON", "parse"],
  "%JSONStringify%": ["JSON", "stringify"],
  "%MapPrototype%": ["Map", "prototype"],
  "%NumberPrototype%": ["Number", "prototype"],
  "%ObjectPrototype%": ["Object", "prototype"],
  "%ObjProto_toString%": ["Object", "prototype", "toString"],
  "%ObjProto_valueOf%": ["Object", "prototype", "valueOf"],
  "%PromisePrototype%": ["Promise", "prototype"],
  "%PromiseProto_then%": ["Promise", "prototype", "then"],
  "%Promise_all%": ["Promise", "all"],
  "%Promise_reject%": ["Promise", "reject"],
  "%Promise_resolve%": ["Promise", "resolve"],
  "%RangeErrorPrototype%": ["RangeError", "prototype"],
  "%ReferenceErrorPrototype%": ["ReferenceError", "prototype"],
  "%RegExpPrototype%": ["RegExp", "prototype"],
  "%SetPrototype%": ["Set", "prototype"],
  "%SharedArrayBufferPrototype%": ["SharedArrayBuffer", "prototype"],
  "%StringPrototype%": ["String", "prototype"],
  "%SymbolPrototype%": ["Symbol", "prototype"],
  "%SyntaxErrorPrototype%": ["SyntaxError", "prototype"],
  "%TypedArrayPrototype%": ["TypedArray", "prototype"],
  "%TypeErrorPrototype%": ["TypeError", "prototype"],
  "%Uint8ArrayPrototype%": ["Uint8Array", "prototype"],
  "%Uint8ClampedArrayPrototype%": ["Uint8ClampedArray", "prototype"],
  "%Uint16ArrayPrototype%": ["Uint16Array", "prototype"],
  "%Uint32ArrayPrototype%": ["Uint32Array", "prototype"],
  "%URIErrorPrototype%": ["URIError", "prototype"],
  "%WeakMapPrototype%": ["WeakMap", "prototype"],
  "%WeakSetPrototype%": ["WeakSet", "prototype"]
};
var bind2 = functionBind;
var hasOwn$1 = src;
var $concat$1 = bind2.call(Function.call, Array.prototype.concat);
var $spliceApply = bind2.call(Function.apply, Array.prototype.splice);
var $replace$1 = bind2.call(Function.call, String.prototype.replace);
var $strSlice = bind2.call(Function.call, String.prototype.slice);
var $exec$1 = bind2.call(Function.call, RegExp.prototype.exec);
var rePropName$1 = /[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g;
var reEscapeChar$1 = /\\(\\)?/g;
var stringToPath$1 = function stringToPath(string) {
  var first = $strSlice(string, 0, 1);
  var last = $strSlice(string, -1);
  if (first === "%" && last !== "%") {
    throw new $SyntaxError$1("invalid intrinsic syntax, expected closing `%`");
  } else if (last === "%" && first !== "%") {
    throw new $SyntaxError$1("invalid intrinsic syntax, expected opening `%`");
  }
  var result = [];
  $replace$1(string, rePropName$1, function(match, number, quote2, subString) {
    result[result.length] = quote2 ? $replace$1(subString, reEscapeChar$1, "$1") : number || match;
  });
  return result;
};
var getBaseIntrinsic = function getBaseIntrinsic2(name2, allowMissing) {
  var intrinsicName = name2;
  var alias;
  if (hasOwn$1(LEGACY_ALIASES, intrinsicName)) {
    alias = LEGACY_ALIASES[intrinsicName];
    intrinsicName = "%" + alias[0] + "%";
  }
  if (hasOwn$1(INTRINSICS, intrinsicName)) {
    var value = INTRINSICS[intrinsicName];
    if (value === needsEval) {
      value = doEval(intrinsicName);
    }
    if (typeof value === "undefined" && !allowMissing) {
      throw new $TypeError$2("intrinsic " + name2 + " exists, but is not available. Please file an issue!");
    }
    return {
      alias,
      name: intrinsicName,
      value
    };
  }
  throw new $SyntaxError$1("intrinsic " + name2 + " does not exist!");
};
var getIntrinsic = function GetIntrinsic(name2, allowMissing) {
  if (typeof name2 !== "string" || name2.length === 0) {
    throw new $TypeError$2("intrinsic name must be a non-empty string");
  }
  if (arguments.length > 1 && typeof allowMissing !== "boolean") {
    throw new $TypeError$2('"allowMissing" argument must be a boolean');
  }
  if ($exec$1(/^%?[^%]*%?$/, name2) === null) {
    throw new $SyntaxError$1("`%` may not be present anywhere but at the beginning and end of the intrinsic name");
  }
  var parts = stringToPath$1(name2);
  var intrinsicBaseName = parts.length > 0 ? parts[0] : "";
  var intrinsic = getBaseIntrinsic("%" + intrinsicBaseName + "%", allowMissing);
  var intrinsicRealName = intrinsic.name;
  var value = intrinsic.value;
  var skipFurtherCaching = false;
  var alias = intrinsic.alias;
  if (alias) {
    intrinsicBaseName = alias[0];
    $spliceApply(parts, $concat$1([0, 1], alias));
  }
  for (var i = 1, isOwn = true; i < parts.length; i += 1) {
    var part = parts[i];
    var first = $strSlice(part, 0, 1);
    var last = $strSlice(part, -1);
    if ((first === '"' || first === "'" || first === "`" || (last === '"' || last === "'" || last === "`")) && first !== last) {
      throw new $SyntaxError$1("property names with quotes must have matching quotes");
    }
    if (part === "constructor" || !isOwn) {
      skipFurtherCaching = true;
    }
    intrinsicBaseName += "." + part;
    intrinsicRealName = "%" + intrinsicBaseName + "%";
    if (hasOwn$1(INTRINSICS, intrinsicRealName)) {
      value = INTRINSICS[intrinsicRealName];
    } else if (value != null) {
      if (!(part in value)) {
        if (!allowMissing) {
          throw new $TypeError$2("base intrinsic for " + name2 + " exists, but the property is not available.");
        }
        return void 0;
      }
      if ($gOPD$2 && i + 1 >= parts.length) {
        var desc = $gOPD$2(value, part);
        isOwn = !!desc;
        if (isOwn && "get" in desc && !("originalValue" in desc.get)) {
          value = desc.get;
        } else {
          value = value[part];
        }
      } else {
        isOwn = hasOwn$1(value, part);
        value = value[part];
      }
      if (isOwn && !skipFurtherCaching) {
        INTRINSICS[intrinsicRealName] = value;
      }
    }
  }
  return value;
};
var GetIntrinsic$8 = getIntrinsic;
var $defineProperty = GetIntrinsic$8("%Object.defineProperty%", true);
var hasPropertyDescriptors$1 = function hasPropertyDescriptors() {
  if ($defineProperty) {
    try {
      $defineProperty({}, "a", { value: 1 });
      return true;
    } catch (e) {
      return false;
    }
  }
  return false;
};
hasPropertyDescriptors$1.hasArrayLengthDefineBug = function hasArrayLengthDefineBug() {
  if (!hasPropertyDescriptors$1()) {
    return null;
  }
  try {
    return $defineProperty([], "length", { value: 1 }).length !== 1;
  } catch (e) {
    return true;
  }
};
var hasPropertyDescriptors_1 = hasPropertyDescriptors$1;
var keys2 = objectKeys$2;
var hasSymbols$3 = typeof Symbol === "function" && typeof Symbol("foo") === "symbol";
var toStr$7 = Object.prototype.toString;
var concat = Array.prototype.concat;
var origDefineProperty = Object.defineProperty;
var isFunction$2 = function(fn) {
  return typeof fn === "function" && toStr$7.call(fn) === "[object Function]";
};
var hasPropertyDescriptors2 = hasPropertyDescriptors_1();
var supportsDescriptors$2 = origDefineProperty && hasPropertyDescriptors2;
var defineProperty$2 = function(object, name2, value, predicate) {
  if (name2 in object) {
    if (predicate === true) {
      if (object[name2] === value) {
        return;
      }
    } else if (!isFunction$2(predicate) || !predicate()) {
      return;
    }
  }
  if (supportsDescriptors$2) {
    origDefineProperty(object, name2, {
      configurable: true,
      enumerable: false,
      value,
      writable: true
    });
  } else {
    object[name2] = value;
  }
};
var defineProperties$1 = function(object, map) {
  var predicates = arguments.length > 2 ? arguments[2] : {};
  var props = keys2(map);
  if (hasSymbols$3) {
    props = concat.call(props, Object.getOwnPropertySymbols(map));
  }
  for (var i = 0; i < props.length; i += 1) {
    defineProperty$2(object, props[i], map[props[i]], predicates[props[i]]);
  }
};
defineProperties$1.supportsDescriptors = !!supportsDescriptors$2;
var defineProperties_1 = defineProperties$1;
var callBindExports = {};
var callBind$5 = {
  get exports() {
    return callBindExports;
  },
  set exports(v) {
    callBindExports = v;
  }
};
(function(module2) {
  var bind3 = functionBind;
  var GetIntrinsic3 = getIntrinsic;
  var $apply = GetIntrinsic3("%Function.prototype.apply%");
  var $call = GetIntrinsic3("%Function.prototype.call%");
  var $reflectApply = GetIntrinsic3("%Reflect.apply%", true) || bind3.call($call, $apply);
  var $gOPD2 = GetIntrinsic3("%Object.getOwnPropertyDescriptor%", true);
  var $defineProperty2 = GetIntrinsic3("%Object.defineProperty%", true);
  var $max = GetIntrinsic3("%Math.max%");
  if ($defineProperty2) {
    try {
      $defineProperty2({}, "a", { value: 1 });
    } catch (e) {
      $defineProperty2 = null;
    }
  }
  module2.exports = function callBind2(originalFunction) {
    var func = $reflectApply(bind3, $call, arguments);
    if ($gOPD2 && $defineProperty2) {
      var desc = $gOPD2(func, "length");
      if (desc.configurable) {
        $defineProperty2(
          func,
          "length",
          { value: 1 + $max(0, originalFunction.length - (arguments.length - 1)) }
        );
      }
    }
    return func;
  };
  var applyBind = function applyBind2() {
    return $reflectApply(bind3, $apply, arguments);
  };
  if ($defineProperty2) {
    $defineProperty2(module2.exports, "apply", { value: applyBind });
  } else {
    module2.exports.apply = applyBind;
  }
})(callBind$5);
var GetIntrinsic$7 = getIntrinsic;
var callBind$4 = callBindExports;
var $indexOf$1 = callBind$4(GetIntrinsic$7("String.prototype.indexOf"));
var callBound$c = function callBoundIntrinsic(name2, allowMissing) {
  var intrinsic = GetIntrinsic$7(name2, !!allowMissing);
  if (typeof intrinsic === "function" && $indexOf$1(name2, ".prototype.") > -1) {
    return callBind$4(intrinsic);
  }
  return intrinsic;
};
var objectKeys$1 = objectKeys$2;
var hasSymbols$2 = shams$1();
var callBound$b = callBound$c;
var toObject$1 = Object;
var $push = callBound$b("Array.prototype.push");
var $propIsEnumerable = callBound$b("Object.prototype.propertyIsEnumerable");
var originalGetSymbols = hasSymbols$2 ? Object.getOwnPropertySymbols : null;
var implementation$8 = function assign(target, source1) {
  if (target == null) {
    throw new TypeError("target must be an object");
  }
  var to = toObject$1(target);
  if (arguments.length === 1) {
    return to;
  }
  for (var s = 1; s < arguments.length; ++s) {
    var from = toObject$1(arguments[s]);
    var keys3 = objectKeys$1(from);
    var getSymbols = hasSymbols$2 && (Object.getOwnPropertySymbols || originalGetSymbols);
    if (getSymbols) {
      var syms = getSymbols(from);
      for (var j = 0; j < syms.length; ++j) {
        var key = syms[j];
        if ($propIsEnumerable(from, key)) {
          $push(keys3, key);
        }
      }
    }
    for (var i = 0; i < keys3.length; ++i) {
      var nextKey = keys3[i];
      if ($propIsEnumerable(from, nextKey)) {
        var propValue = from[nextKey];
        to[nextKey] = propValue;
      }
    }
  }
  return to;
};
var implementation$7 = implementation$8;
var lacksProperEnumerationOrder = function() {
  if (!Object.assign) {
    return false;
  }
  var str = "abcdefghijklmnopqrst";
  var letters = str.split("");
  var map = {};
  for (var i = 0; i < letters.length; ++i) {
    map[letters[i]] = letters[i];
  }
  var obj = Object.assign({}, map);
  var actual = "";
  for (var k in obj) {
    actual += k;
  }
  return str !== actual;
};
var assignHasPendingExceptions = function() {
  if (!Object.assign || !Object.preventExtensions) {
    return false;
  }
  var thrower = Object.preventExtensions({ 1: 2 });
  try {
    Object.assign(thrower, "xy");
  } catch (e) {
    return thrower[1] === "y";
  }
  return false;
};
var polyfill$4 = function getPolyfill() {
  if (!Object.assign) {
    return implementation$7;
  }
  if (lacksProperEnumerationOrder()) {
    return implementation$7;
  }
  if (assignHasPendingExceptions()) {
    return implementation$7;
  }
  return Object.assign;
};
var define$3 = defineProperties_1;
var getPolyfill$5 = polyfill$4;
var shim$8 = function shimAssign() {
  var polyfill2 = getPolyfill$5();
  define$3(
    Object,
    { assign: polyfill2 },
    { assign: function() {
      return Object.assign !== polyfill2;
    } }
  );
  return polyfill2;
};
var defineProperties = defineProperties_1;
var callBind$3 = callBindExports;
var implementation$6 = implementation$8;
var getPolyfill$4 = polyfill$4;
var shim$7 = shim$8;
var polyfill$3 = callBind$3.apply(getPolyfill$4());
var bound = function assign2(target, source1) {
  return polyfill$3(Object, arguments);
};
defineProperties(bound, {
  getPolyfill: getPolyfill$4,
  implementation: implementation$6,
  shim: shim$7
});
var object_assign = bound;
var implementationExports = {};
var implementation$5 = {
  get exports() {
    return implementationExports;
  },
  set exports(v) {
    implementationExports = v;
  }
};
var functionsHaveNames = function functionsHaveNames2() {
  return typeof function f2() {
  }.name === "string";
};
var gOPD$4 = Object.getOwnPropertyDescriptor;
if (gOPD$4) {
  try {
    gOPD$4([], "length");
  } catch (e) {
    gOPD$4 = null;
  }
}
functionsHaveNames.functionsHaveConfigurableNames = function functionsHaveConfigurableNames() {
  if (!functionsHaveNames() || !gOPD$4) {
    return false;
  }
  var desc = gOPD$4(function() {
  }, "name");
  return !!desc && !!desc.configurable;
};
var $bind = Function.prototype.bind;
functionsHaveNames.boundFunctionsHaveNames = function boundFunctionsHaveNames() {
  return functionsHaveNames() && typeof $bind === "function" && function f2() {
  }.bind().name !== "";
};
var functionsHaveNames_1 = functionsHaveNames;
(function(module2) {
  var functionsHaveConfigurableNames2 = functionsHaveNames_1.functionsHaveConfigurableNames();
  var $Object = Object;
  var $TypeError2 = TypeError;
  module2.exports = function flags2() {
    if (this != null && this !== $Object(this)) {
      throw new $TypeError2("RegExp.prototype.flags getter called on non-object");
    }
    var result = "";
    if (this.hasIndices) {
      result += "d";
    }
    if (this.global) {
      result += "g";
    }
    if (this.ignoreCase) {
      result += "i";
    }
    if (this.multiline) {
      result += "m";
    }
    if (this.dotAll) {
      result += "s";
    }
    if (this.unicode) {
      result += "u";
    }
    if (this.sticky) {
      result += "y";
    }
    return result;
  };
  if (functionsHaveConfigurableNames2 && Object.defineProperty) {
    Object.defineProperty(module2.exports, "name", { value: "get flags" });
  }
})(implementation$5);
var implementation$4 = implementationExports;
var supportsDescriptors$1 = defineProperties_1.supportsDescriptors;
var $gOPD$1 = Object.getOwnPropertyDescriptor;
var polyfill$2 = function getPolyfill2() {
  if (supportsDescriptors$1 && /a/mig.flags === "gim") {
    var descriptor = $gOPD$1(RegExp.prototype, "flags");
    if (descriptor && typeof descriptor.get === "function" && typeof RegExp.prototype.dotAll === "boolean" && typeof RegExp.prototype.hasIndices === "boolean") {
      var calls = "";
      var o = {};
      Object.defineProperty(o, "hasIndices", {
        get: function() {
          calls += "d";
        }
      });
      Object.defineProperty(o, "sticky", {
        get: function() {
          calls += "y";
        }
      });
      if (calls === "dy") {
        return descriptor.get;
      }
    }
  }
  return implementation$4;
};
var supportsDescriptors = defineProperties_1.supportsDescriptors;
var getPolyfill$3 = polyfill$2;
var gOPD$3 = Object.getOwnPropertyDescriptor;
var defineProperty$1 = Object.defineProperty;
var TypeErr = TypeError;
var getProto = Object.getPrototypeOf;
var regex = /a/;
var shim$6 = function shimFlags() {
  if (!supportsDescriptors || !getProto) {
    throw new TypeErr("RegExp.prototype.flags requires a true ES5 environment that supports property descriptors");
  }
  var polyfill2 = getPolyfill$3();
  var proto = getProto(regex);
  var descriptor = gOPD$3(proto, "flags");
  if (!descriptor || descriptor.get !== polyfill2) {
    defineProperty$1(proto, "flags", {
      configurable: true,
      enumerable: false,
      get: polyfill2
    });
  }
  return polyfill2;
};
var define$2 = defineProperties_1;
var callBind$2 = callBindExports;
var implementation$3 = implementationExports;
var getPolyfill$2 = polyfill$2;
var shim$5 = shim$6;
var flagsBound = callBind$2(getPolyfill$2());
define$2(flagsBound, {
  getPolyfill: getPolyfill$2,
  implementation: implementation$3,
  shim: shim$5
});
var regexp_prototype_flags = flagsBound;
var esGetIteratorExports = {};
var esGetIterator = {
  get exports() {
    return esGetIteratorExports;
  },
  set exports(v) {
    esGetIteratorExports = v;
  }
};
var hasSymbols$1 = shams$1;
var shams = function hasToStringTagShams() {
  return hasSymbols$1() && !!Symbol.toStringTag;
};
var hasToStringTag$8 = shams();
var callBound$a = callBound$c;
var $toString$4 = callBound$a("Object.prototype.toString");
var isStandardArguments = function isArguments2(value) {
  if (hasToStringTag$8 && value && typeof value === "object" && Symbol.toStringTag in value) {
    return false;
  }
  return $toString$4(value) === "[object Arguments]";
};
var isLegacyArguments = function isArguments3(value) {
  if (isStandardArguments(value)) {
    return true;
  }
  return value !== null && typeof value === "object" && typeof value.length === "number" && value.length >= 0 && $toString$4(value) !== "[object Array]" && $toString$4(value.callee) === "[object Function]";
};
var supportsStandardArguments = function() {
  return isStandardArguments(arguments);
}();
isStandardArguments.isLegacyArguments = isLegacyArguments;
var isArguments$2 = supportsStandardArguments ? isStandardArguments : isLegacyArguments;
const __viteBrowserExternal = {};
const __viteBrowserExternal$1 = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  default: __viteBrowserExternal
}, Symbol.toStringTag, { value: "Module" }));
const require$$0 = /* @__PURE__ */ getAugmentedNamespace(__viteBrowserExternal$1);
var hasMap = typeof Map === "function" && Map.prototype;
var mapSizeDescriptor = Object.getOwnPropertyDescriptor && hasMap ? Object.getOwnPropertyDescriptor(Map.prototype, "size") : null;
var mapSize = hasMap && mapSizeDescriptor && typeof mapSizeDescriptor.get === "function" ? mapSizeDescriptor.get : null;
var mapForEach = hasMap && Map.prototype.forEach;
var hasSet = typeof Set === "function" && Set.prototype;
var setSizeDescriptor = Object.getOwnPropertyDescriptor && hasSet ? Object.getOwnPropertyDescriptor(Set.prototype, "size") : null;
var setSize = hasSet && setSizeDescriptor && typeof setSizeDescriptor.get === "function" ? setSizeDescriptor.get : null;
var setForEach = hasSet && Set.prototype.forEach;
var hasWeakMap = typeof WeakMap === "function" && WeakMap.prototype;
var weakMapHas = hasWeakMap ? WeakMap.prototype.has : null;
var hasWeakSet = typeof WeakSet === "function" && WeakSet.prototype;
var weakSetHas = hasWeakSet ? WeakSet.prototype.has : null;
var hasWeakRef = typeof WeakRef === "function" && WeakRef.prototype;
var weakRefDeref = hasWeakRef ? WeakRef.prototype.deref : null;
var booleanValueOf = Boolean.prototype.valueOf;
var objectToString$1 = Object.prototype.toString;
var functionToString = Function.prototype.toString;
var $match = String.prototype.match;
var $slice$2 = String.prototype.slice;
var $replace = String.prototype.replace;
var $toUpperCase = String.prototype.toUpperCase;
var $toLowerCase = String.prototype.toLowerCase;
var $test = RegExp.prototype.test;
var $concat = Array.prototype.concat;
var $join = Array.prototype.join;
var $arrSlice = Array.prototype.slice;
var $floor = Math.floor;
var bigIntValueOf$1 = typeof BigInt === "function" ? BigInt.prototype.valueOf : null;
var gOPS = Object.getOwnPropertySymbols;
var symToString = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? Symbol.prototype.toString : null;
var hasShammedSymbols = typeof Symbol === "function" && typeof Symbol.iterator === "object";
var toStringTag = typeof Symbol === "function" && Symbol.toStringTag && (typeof Symbol.toStringTag === hasShammedSymbols ? "object" : "symbol") ? Symbol.toStringTag : null;
var isEnumerable = Object.prototype.propertyIsEnumerable;
var gPO$1 = (typeof Reflect === "function" ? Reflect.getPrototypeOf : Object.getPrototypeOf) || ([].__proto__ === Array.prototype ? function(O) {
  return O.__proto__;
} : null);
function addNumericSeparator(num, str) {
  if (num === Infinity || num === -Infinity || num !== num || num && num > -1e3 && num < 1e3 || $test.call(/e/, str)) {
    return str;
  }
  var sepRegex = /[0-9](?=(?:[0-9]{3})+(?![0-9]))/g;
  if (typeof num === "number") {
    var int = num < 0 ? -$floor(-num) : $floor(num);
    if (int !== num) {
      var intStr = String(int);
      var dec = $slice$2.call(str, intStr.length + 1);
      return $replace.call(intStr, sepRegex, "$&_") + "." + $replace.call($replace.call(dec, /([0-9]{3})/g, "$&_"), /_$/, "");
    }
  }
  return $replace.call(str, sepRegex, "$&_");
}
var utilInspect = require$$0;
var inspectCustom = utilInspect.custom;
var inspectSymbol = isSymbol$3(inspectCustom) ? inspectCustom : null;
var objectInspect = function inspect_(obj, options, depth, seen) {
  var opts = options || {};
  if (has$2(opts, "quoteStyle") && (opts.quoteStyle !== "single" && opts.quoteStyle !== "double")) {
    throw new TypeError('option "quoteStyle" must be "single" or "double"');
  }
  if (has$2(opts, "maxStringLength") && (typeof opts.maxStringLength === "number" ? opts.maxStringLength < 0 && opts.maxStringLength !== Infinity : opts.maxStringLength !== null)) {
    throw new TypeError('option "maxStringLength", if provided, must be a positive integer, Infinity, or `null`');
  }
  var customInspect = has$2(opts, "customInspect") ? opts.customInspect : true;
  if (typeof customInspect !== "boolean" && customInspect !== "symbol") {
    throw new TypeError("option \"customInspect\", if provided, must be `true`, `false`, or `'symbol'`");
  }
  if (has$2(opts, "indent") && opts.indent !== null && opts.indent !== "	" && !(parseInt(opts.indent, 10) === opts.indent && opts.indent > 0)) {
    throw new TypeError('option "indent" must be "\\t", an integer > 0, or `null`');
  }
  if (has$2(opts, "numericSeparator") && typeof opts.numericSeparator !== "boolean") {
    throw new TypeError('option "numericSeparator", if provided, must be `true` or `false`');
  }
  var numericSeparator = opts.numericSeparator;
  if (typeof obj === "undefined") {
    return "undefined";
  }
  if (obj === null) {
    return "null";
  }
  if (typeof obj === "boolean") {
    return obj ? "true" : "false";
  }
  if (typeof obj === "string") {
    return inspectString(obj, opts);
  }
  if (typeof obj === "number") {
    if (obj === 0) {
      return Infinity / obj > 0 ? "0" : "-0";
    }
    var str = String(obj);
    return numericSeparator ? addNumericSeparator(obj, str) : str;
  }
  if (typeof obj === "bigint") {
    var bigIntStr = String(obj) + "n";
    return numericSeparator ? addNumericSeparator(obj, bigIntStr) : bigIntStr;
  }
  var maxDepth = typeof opts.depth === "undefined" ? 5 : opts.depth;
  if (typeof depth === "undefined") {
    depth = 0;
  }
  if (depth >= maxDepth && maxDepth > 0 && typeof obj === "object") {
    return isArray$3(obj) ? "[Array]" : "[Object]";
  }
  var indent = getIndent(opts, depth);
  if (typeof seen === "undefined") {
    seen = [];
  } else if (indexOf(seen, obj) >= 0) {
    return "[Circular]";
  }
  function inspect2(value, from, noIndent) {
    if (from) {
      seen = $arrSlice.call(seen);
      seen.push(from);
    }
    if (noIndent) {
      var newOpts = {
        depth: opts.depth
      };
      if (has$2(opts, "quoteStyle")) {
        newOpts.quoteStyle = opts.quoteStyle;
      }
      return inspect_(value, newOpts, depth + 1, seen);
    }
    return inspect_(value, opts, depth + 1, seen);
  }
  if (typeof obj === "function" && !isRegExp(obj)) {
    var name2 = nameOf(obj);
    var keys3 = arrObjKeys(obj, inspect2);
    return "[Function" + (name2 ? ": " + name2 : " (anonymous)") + "]" + (keys3.length > 0 ? " { " + $join.call(keys3, ", ") + " }" : "");
  }
  if (isSymbol$3(obj)) {
    var symString = hasShammedSymbols ? $replace.call(String(obj), /^(Symbol\(.*\))_[^)]*$/, "$1") : symToString.call(obj);
    return typeof obj === "object" && !hasShammedSymbols ? markBoxed(symString) : symString;
  }
  if (isElement(obj)) {
    var s = "<" + $toLowerCase.call(String(obj.nodeName));
    var attrs = obj.attributes || [];
    for (var i = 0; i < attrs.length; i++) {
      s += " " + attrs[i].name + "=" + wrapQuotes(quote(attrs[i].value), "double", opts);
    }
    s += ">";
    if (obj.childNodes && obj.childNodes.length) {
      s += "...";
    }
    s += "</" + $toLowerCase.call(String(obj.nodeName)) + ">";
    return s;
  }
  if (isArray$3(obj)) {
    if (obj.length === 0) {
      return "[]";
    }
    var xs = arrObjKeys(obj, inspect2);
    if (indent && !singleLineValues(xs)) {
      return "[" + indentedJoin(xs, indent) + "]";
    }
    return "[ " + $join.call(xs, ", ") + " ]";
  }
  if (isError(obj)) {
    var parts = arrObjKeys(obj, inspect2);
    if (!("cause" in Error.prototype) && "cause" in obj && !isEnumerable.call(obj, "cause")) {
      return "{ [" + String(obj) + "] " + $join.call($concat.call("[cause]: " + inspect2(obj.cause), parts), ", ") + " }";
    }
    if (parts.length === 0) {
      return "[" + String(obj) + "]";
    }
    return "{ [" + String(obj) + "] " + $join.call(parts, ", ") + " }";
  }
  if (typeof obj === "object" && customInspect) {
    if (inspectSymbol && typeof obj[inspectSymbol] === "function" && utilInspect) {
      return utilInspect(obj, { depth: maxDepth - depth });
    } else if (customInspect !== "symbol" && typeof obj.inspect === "function") {
      return obj.inspect();
    }
  }
  if (isMap$3(obj)) {
    var mapParts = [];
    if (mapForEach) {
      mapForEach.call(obj, function(value, key) {
        mapParts.push(inspect2(key, obj, true) + " => " + inspect2(value, obj));
      });
    }
    return collectionOf("Map", mapSize.call(obj), mapParts, indent);
  }
  if (isSet$3(obj)) {
    var setParts = [];
    if (setForEach) {
      setForEach.call(obj, function(value) {
        setParts.push(inspect2(value, obj));
      });
    }
    return collectionOf("Set", setSize.call(obj), setParts, indent);
  }
  if (isWeakMap$1(obj)) {
    return weakCollectionOf("WeakMap");
  }
  if (isWeakSet$1(obj)) {
    return weakCollectionOf("WeakSet");
  }
  if (isWeakRef(obj)) {
    return weakCollectionOf("WeakRef");
  }
  if (isNumber$1(obj)) {
    return markBoxed(inspect2(Number(obj)));
  }
  if (isBigInt$1(obj)) {
    return markBoxed(inspect2(bigIntValueOf$1.call(obj)));
  }
  if (isBoolean$1(obj)) {
    return markBoxed(booleanValueOf.call(obj));
  }
  if (isString$3(obj)) {
    return markBoxed(inspect2(String(obj)));
  }
  if (!isDate$1(obj) && !isRegExp(obj)) {
    var ys = arrObjKeys(obj, inspect2);
    var isPlainObject = gPO$1 ? gPO$1(obj) === Object.prototype : obj instanceof Object || obj.constructor === Object;
    var protoTag = obj instanceof Object ? "" : "null prototype";
    var stringTag = !isPlainObject && toStringTag && Object(obj) === obj && toStringTag in obj ? $slice$2.call(toStr$6(obj), 8, -1) : protoTag ? "Object" : "";
    var constructorTag = isPlainObject || typeof obj.constructor !== "function" ? "" : obj.constructor.name ? obj.constructor.name + " " : "";
    var tag = constructorTag + (stringTag || protoTag ? "[" + $join.call($concat.call([], stringTag || [], protoTag || []), ": ") + "] " : "");
    if (ys.length === 0) {
      return tag + "{}";
    }
    if (indent) {
      return tag + "{" + indentedJoin(ys, indent) + "}";
    }
    return tag + "{ " + $join.call(ys, ", ") + " }";
  }
  return String(obj);
};
function wrapQuotes(s, defaultStyle, opts) {
  var quoteChar = (opts.quoteStyle || defaultStyle) === "double" ? '"' : "'";
  return quoteChar + s + quoteChar;
}
function quote(s) {
  return $replace.call(String(s), /"/g, "&quot;");
}
function isArray$3(obj) {
  return toStr$6(obj) === "[object Array]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isDate$1(obj) {
  return toStr$6(obj) === "[object Date]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isRegExp(obj) {
  return toStr$6(obj) === "[object RegExp]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isError(obj) {
  return toStr$6(obj) === "[object Error]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isString$3(obj) {
  return toStr$6(obj) === "[object String]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isNumber$1(obj) {
  return toStr$6(obj) === "[object Number]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isBoolean$1(obj) {
  return toStr$6(obj) === "[object Boolean]" && (!toStringTag || !(typeof obj === "object" && toStringTag in obj));
}
function isSymbol$3(obj) {
  if (hasShammedSymbols) {
    return obj && typeof obj === "object" && obj instanceof Symbol;
  }
  if (typeof obj === "symbol") {
    return true;
  }
  if (!obj || typeof obj !== "object" || !symToString) {
    return false;
  }
  try {
    symToString.call(obj);
    return true;
  } catch (e) {
  }
  return false;
}
function isBigInt$1(obj) {
  if (!obj || typeof obj !== "object" || !bigIntValueOf$1) {
    return false;
  }
  try {
    bigIntValueOf$1.call(obj);
    return true;
  } catch (e) {
  }
  return false;
}
var hasOwn = Object.prototype.hasOwnProperty || function(key) {
  return key in this;
};
function has$2(obj, key) {
  return hasOwn.call(obj, key);
}
function toStr$6(obj) {
  return objectToString$1.call(obj);
}
function nameOf(f2) {
  if (f2.name) {
    return f2.name;
  }
  var m2 = $match.call(functionToString.call(f2), /^function\s*([\w$]+)/);
  if (m2) {
    return m2[1];
  }
  return null;
}
function indexOf(xs, x) {
  if (xs.indexOf) {
    return xs.indexOf(x);
  }
  for (var i = 0, l = xs.length; i < l; i++) {
    if (xs[i] === x) {
      return i;
    }
  }
  return -1;
}
function isMap$3(x) {
  if (!mapSize || !x || typeof x !== "object") {
    return false;
  }
  try {
    mapSize.call(x);
    try {
      setSize.call(x);
    } catch (s) {
      return true;
    }
    return x instanceof Map;
  } catch (e) {
  }
  return false;
}
function isWeakMap$1(x) {
  if (!weakMapHas || !x || typeof x !== "object") {
    return false;
  }
  try {
    weakMapHas.call(x, weakMapHas);
    try {
      weakSetHas.call(x, weakSetHas);
    } catch (s) {
      return true;
    }
    return x instanceof WeakMap;
  } catch (e) {
  }
  return false;
}
function isWeakRef(x) {
  if (!weakRefDeref || !x || typeof x !== "object") {
    return false;
  }
  try {
    weakRefDeref.call(x);
    return true;
  } catch (e) {
  }
  return false;
}
function isSet$3(x) {
  if (!setSize || !x || typeof x !== "object") {
    return false;
  }
  try {
    setSize.call(x);
    try {
      mapSize.call(x);
    } catch (m2) {
      return true;
    }
    return x instanceof Set;
  } catch (e) {
  }
  return false;
}
function isWeakSet$1(x) {
  if (!weakSetHas || !x || typeof x !== "object") {
    return false;
  }
  try {
    weakSetHas.call(x, weakSetHas);
    try {
      weakMapHas.call(x, weakMapHas);
    } catch (s) {
      return true;
    }
    return x instanceof WeakSet;
  } catch (e) {
  }
  return false;
}
function isElement(x) {
  if (!x || typeof x !== "object") {
    return false;
  }
  if (typeof HTMLElement !== "undefined" && x instanceof HTMLElement) {
    return true;
  }
  return typeof x.nodeName === "string" && typeof x.getAttribute === "function";
}
function inspectString(str, opts) {
  if (str.length > opts.maxStringLength) {
    var remaining = str.length - opts.maxStringLength;
    var trailer = "... " + remaining + " more character" + (remaining > 1 ? "s" : "");
    return inspectString($slice$2.call(str, 0, opts.maxStringLength), opts) + trailer;
  }
  var s = $replace.call($replace.call(str, /(['\\])/g, "\\$1"), /[\x00-\x1f]/g, lowbyte);
  return wrapQuotes(s, "single", opts);
}
function lowbyte(c) {
  var n2 = c.charCodeAt(0);
  var x = {
    8: "b",
    9: "t",
    10: "n",
    12: "f",
    13: "r"
  }[n2];
  if (x) {
    return "\\" + x;
  }
  return "\\x" + (n2 < 16 ? "0" : "") + $toUpperCase.call(n2.toString(16));
}
function markBoxed(str) {
  return "Object(" + str + ")";
}
function weakCollectionOf(type) {
  return type + " { ? }";
}
function collectionOf(type, size, entries, indent) {
  var joinedEntries = indent ? indentedJoin(entries, indent) : $join.call(entries, ", ");
  return type + " (" + size + ") {" + joinedEntries + "}";
}
function singleLineValues(xs) {
  for (var i = 0; i < xs.length; i++) {
    if (indexOf(xs[i], "\n") >= 0) {
      return false;
    }
  }
  return true;
}
function getIndent(opts, depth) {
  var baseIndent;
  if (opts.indent === "	") {
    baseIndent = "	";
  } else if (typeof opts.indent === "number" && opts.indent > 0) {
    baseIndent = $join.call(Array(opts.indent + 1), " ");
  } else {
    return null;
  }
  return {
    base: baseIndent,
    prev: $join.call(Array(depth + 1), baseIndent)
  };
}
function indentedJoin(xs, indent) {
  if (xs.length === 0) {
    return "";
  }
  var lineJoiner = "\n" + indent.prev + indent.base;
  return lineJoiner + $join.call(xs, "," + lineJoiner) + "\n" + indent.prev;
}
function arrObjKeys(obj, inspect2) {
  var isArr = isArray$3(obj);
  var xs = [];
  if (isArr) {
    xs.length = obj.length;
    for (var i = 0; i < obj.length; i++) {
      xs[i] = has$2(obj, i) ? inspect2(obj[i], obj) : "";
    }
  }
  var syms = typeof gOPS === "function" ? gOPS(obj) : [];
  var symMap;
  if (hasShammedSymbols) {
    symMap = {};
    for (var k = 0; k < syms.length; k++) {
      symMap["$" + syms[k]] = syms[k];
    }
  }
  for (var key in obj) {
    if (!has$2(obj, key)) {
      continue;
    }
    if (isArr && String(Number(key)) === key && key < obj.length) {
      continue;
    }
    if (hasShammedSymbols && symMap["$" + key] instanceof Symbol) {
      continue;
    } else if ($test.call(/[^\w$]/, key)) {
      xs.push(inspect2(key, obj) + ": " + inspect2(obj[key], obj));
    } else {
      xs.push(key + ": " + inspect2(obj[key], obj));
    }
  }
  if (typeof gOPS === "function") {
    for (var j = 0; j < syms.length; j++) {
      if (isEnumerable.call(obj, syms[j])) {
        xs.push("[" + inspect2(syms[j]) + "]: " + inspect2(obj[syms[j]], obj));
      }
    }
  }
  return xs;
}
var GetIntrinsic$6 = getIntrinsic;
var callBound$9 = callBound$c;
var inspect = objectInspect;
var $TypeError$1 = GetIntrinsic$6("%TypeError%");
var $WeakMap$1 = GetIntrinsic$6("%WeakMap%", true);
var $Map$3 = GetIntrinsic$6("%Map%", true);
var $weakMapGet = callBound$9("WeakMap.prototype.get", true);
var $weakMapSet = callBound$9("WeakMap.prototype.set", true);
var $weakMapHas = callBound$9("WeakMap.prototype.has", true);
var $mapGet$1 = callBound$9("Map.prototype.get", true);
var $mapSet = callBound$9("Map.prototype.set", true);
var $mapHas$5 = callBound$9("Map.prototype.has", true);
var listGetNode = function(list, key) {
  for (var prev = list, curr; (curr = prev.next) !== null; prev = curr) {
    if (curr.key === key) {
      prev.next = curr.next;
      curr.next = list.next;
      list.next = curr;
      return curr;
    }
  }
};
var listGet = function(objects, key) {
  var node = listGetNode(objects, key);
  return node && node.value;
};
var listSet = function(objects, key, value) {
  var node = listGetNode(objects, key);
  if (node) {
    node.value = value;
  } else {
    objects.next = {
      // eslint-disable-line no-param-reassign
      key,
      next: objects.next,
      value
    };
  }
};
var listHas = function(objects, key) {
  return !!listGetNode(objects, key);
};
var sideChannel = function getSideChannel() {
  var $wm;
  var $m;
  var $o;
  var channel2 = {
    assert: function(key) {
      if (!channel2.has(key)) {
        throw new $TypeError$1("Side channel does not contain " + inspect(key));
      }
    },
    get: function(key) {
      if ($WeakMap$1 && key && (typeof key === "object" || typeof key === "function")) {
        if ($wm) {
          return $weakMapGet($wm, key);
        }
      } else if ($Map$3) {
        if ($m) {
          return $mapGet$1($m, key);
        }
      } else {
        if ($o) {
          return listGet($o, key);
        }
      }
    },
    has: function(key) {
      if ($WeakMap$1 && key && (typeof key === "object" || typeof key === "function")) {
        if ($wm) {
          return $weakMapHas($wm, key);
        }
      } else if ($Map$3) {
        if ($m) {
          return $mapHas$5($m, key);
        }
      } else {
        if ($o) {
          return listHas($o, key);
        }
      }
      return false;
    },
    set: function(key, value) {
      if ($WeakMap$1 && key && (typeof key === "object" || typeof key === "function")) {
        if (!$wm) {
          $wm = new $WeakMap$1();
        }
        $weakMapSet($wm, key, value);
      } else if ($Map$3) {
        if (!$m) {
          $m = new $Map$3();
        }
        $mapSet($m, key, value);
      } else {
        if (!$o) {
          $o = { key: {}, next: null };
        }
        listSet($o, key, value);
      }
    }
  };
  return channel2;
};
var GetIntrinsic$5 = getIntrinsic;
var has$1 = src;
var channel = sideChannel();
var $TypeError = GetIntrinsic$5("%TypeError%");
var SLOT$1 = {
  assert: function(O, slot) {
    if (!O || typeof O !== "object" && typeof O !== "function") {
      throw new $TypeError("`O` is not an object");
    }
    if (typeof slot !== "string") {
      throw new $TypeError("`slot` must be a string");
    }
    channel.assert(O);
    if (!SLOT$1.has(O, slot)) {
      throw new $TypeError("`" + slot + "` is not present on `O`");
    }
  },
  get: function(O, slot) {
    if (!O || typeof O !== "object" && typeof O !== "function") {
      throw new $TypeError("`O` is not an object");
    }
    if (typeof slot !== "string") {
      throw new $TypeError("`slot` must be a string");
    }
    var slots = channel.get(O);
    return slots && slots["$" + slot];
  },
  has: function(O, slot) {
    if (!O || typeof O !== "object" && typeof O !== "function") {
      throw new $TypeError("`O` is not an object");
    }
    if (typeof slot !== "string") {
      throw new $TypeError("`slot` must be a string");
    }
    var slots = channel.get(O);
    return !!slots && has$1(slots, "$" + slot);
  },
  set: function(O, slot, V) {
    if (!O || typeof O !== "object" && typeof O !== "function") {
      throw new $TypeError("`O` is not an object");
    }
    if (typeof slot !== "string") {
      throw new $TypeError("`slot` must be a string");
    }
    var slots = channel.get(O);
    if (!slots) {
      slots = {};
      channel.set(O, slots);
    }
    slots["$" + slot] = V;
  }
};
if (Object.freeze) {
  Object.freeze(SLOT$1);
}
var internalSlot = SLOT$1;
var SLOT = internalSlot;
var $SyntaxError = SyntaxError;
var $StopIteration = typeof StopIteration === "object" ? StopIteration : null;
var stopIterationIterator = function getStopIterationIterator(origIterator) {
  if (!$StopIteration) {
    throw new $SyntaxError("this environment lacks StopIteration");
  }
  SLOT.set(origIterator, "[[Done]]", false);
  var siIterator = {
    next: function next() {
      var iterator = SLOT.get(this, "[[Iterator]]");
      var done = SLOT.get(iterator, "[[Done]]");
      try {
        return {
          done,
          value: done ? void 0 : iterator.next()
        };
      } catch (e) {
        SLOT.set(iterator, "[[Done]]", true);
        if (e !== $StopIteration) {
          throw e;
        }
        return {
          done: true,
          value: void 0
        };
      }
    }
  };
  SLOT.set(siIterator, "[[Iterator]]", origIterator);
  return siIterator;
};
var toString$1 = {}.toString;
var isarray = Array.isArray || function(arr) {
  return toString$1.call(arr) == "[object Array]";
};
var strValue = String.prototype.valueOf;
var tryStringObject = function tryStringObject2(value) {
  try {
    strValue.call(value);
    return true;
  } catch (e) {
    return false;
  }
};
var toStr$5 = Object.prototype.toString;
var strClass = "[object String]";
var hasToStringTag$7 = shams();
var isString$2 = function isString(value) {
  if (typeof value === "string") {
    return true;
  }
  if (typeof value !== "object") {
    return false;
  }
  return hasToStringTag$7 ? tryStringObject(value) : toStr$5.call(value) === strClass;
};
var $Map$2 = typeof Map === "function" && Map.prototype ? Map : null;
var $Set$3 = typeof Set === "function" && Set.prototype ? Set : null;
var exported$2;
if (!$Map$2) {
  exported$2 = function isMap3(x) {
    return false;
  };
}
var $mapHas$4 = $Map$2 ? Map.prototype.has : null;
var $setHas$4 = $Set$3 ? Set.prototype.has : null;
if (!exported$2 && !$mapHas$4) {
  exported$2 = function isMap3(x) {
    return false;
  };
}
var isMap$2 = exported$2 || function isMap(x) {
  if (!x || typeof x !== "object") {
    return false;
  }
  try {
    $mapHas$4.call(x);
    if ($setHas$4) {
      try {
        $setHas$4.call(x);
      } catch (e) {
        return true;
      }
    }
    return x instanceof $Map$2;
  } catch (e) {
  }
  return false;
};
var $Map$1 = typeof Map === "function" && Map.prototype ? Map : null;
var $Set$2 = typeof Set === "function" && Set.prototype ? Set : null;
var exported$1;
if (!$Set$2) {
  exported$1 = function isSet3(x) {
    return false;
  };
}
var $mapHas$3 = $Map$1 ? Map.prototype.has : null;
var $setHas$3 = $Set$2 ? Set.prototype.has : null;
if (!exported$1 && !$setHas$3) {
  exported$1 = function isSet3(x) {
    return false;
  };
}
var isSet$2 = exported$1 || function isSet(x) {
  if (!x || typeof x !== "object") {
    return false;
  }
  try {
    $setHas$3.call(x);
    if ($mapHas$3) {
      try {
        $mapHas$3.call(x);
      } catch (e) {
        return true;
      }
    }
    return x instanceof $Set$2;
  } catch (e) {
  }
  return false;
};
var isArguments$1 = isArguments$2;
var getStopIterationIterator2 = stopIterationIterator;
if (hasSymbols$5() || shams$1()) {
  var $iterator = Symbol.iterator;
  esGetIterator.exports = function getIterator2(iterable) {
    if (iterable != null && typeof iterable[$iterator] !== "undefined") {
      return iterable[$iterator]();
    }
    if (isArguments$1(iterable)) {
      return Array.prototype[$iterator].call(iterable);
    }
  };
} else {
  var isArray$2 = isarray;
  var isString$1 = isString$2;
  var GetIntrinsic$4 = getIntrinsic;
  var $Map = GetIntrinsic$4("%Map%", true);
  var $Set$1 = GetIntrinsic$4("%Set%", true);
  var callBound$8 = callBound$c;
  var $arrayPush = callBound$8("Array.prototype.push");
  var $charCodeAt = callBound$8("String.prototype.charCodeAt");
  var $stringSlice = callBound$8("String.prototype.slice");
  var advanceStringIndex = function advanceStringIndex2(S, index) {
    var length = S.length;
    if (index + 1 >= length) {
      return index + 1;
    }
    var first = $charCodeAt(S, index);
    if (first < 55296 || first > 56319) {
      return index + 1;
    }
    var second = $charCodeAt(S, index + 1);
    if (second < 56320 || second > 57343) {
      return index + 1;
    }
    return index + 2;
  };
  var getArrayIterator = function getArrayIterator2(arraylike) {
    var i = 0;
    return {
      next: function next() {
        var done = i >= arraylike.length;
        var value;
        if (!done) {
          value = arraylike[i];
          i += 1;
        }
        return {
          done,
          value
        };
      }
    };
  };
  var getNonCollectionIterator = function getNonCollectionIterator2(iterable, noPrimordialCollections) {
    if (isArray$2(iterable) || isArguments$1(iterable)) {
      return getArrayIterator(iterable);
    }
    if (isString$1(iterable)) {
      var i = 0;
      return {
        next: function next() {
          var nextIndex = advanceStringIndex(iterable, i);
          var value = $stringSlice(iterable, i, nextIndex);
          i = nextIndex;
          return {
            done: nextIndex > iterable.length,
            value
          };
        }
      };
    }
    if (noPrimordialCollections && typeof iterable["_es6-shim iterator_"] !== "undefined") {
      return iterable["_es6-shim iterator_"]();
    }
  };
  if (!$Map && !$Set$1) {
    esGetIterator.exports = function getIterator2(iterable) {
      if (iterable != null) {
        return getNonCollectionIterator(iterable, true);
      }
    };
  } else {
    var isMap$1 = isMap$2;
    var isSet$1 = isSet$2;
    var $mapForEach = callBound$8("Map.prototype.forEach", true);
    var $setForEach = callBound$8("Set.prototype.forEach", true);
    if (typeof process === "undefined" || !process.versions || !process.versions.node) {
      var $mapIterator = callBound$8("Map.prototype.iterator", true);
      var $setIterator = callBound$8("Set.prototype.iterator", true);
    }
    var $mapAtAtIterator = callBound$8("Map.prototype.@@iterator", true) || callBound$8("Map.prototype._es6-shim iterator_", true);
    var $setAtAtIterator = callBound$8("Set.prototype.@@iterator", true) || callBound$8("Set.prototype._es6-shim iterator_", true);
    var getCollectionIterator = function getCollectionIterator2(iterable) {
      if (isMap$1(iterable)) {
        if ($mapIterator) {
          return getStopIterationIterator2($mapIterator(iterable));
        }
        if ($mapAtAtIterator) {
          return $mapAtAtIterator(iterable);
        }
        if ($mapForEach) {
          var entries = [];
          $mapForEach(iterable, function(v, k) {
            $arrayPush(entries, [k, v]);
          });
          return getArrayIterator(entries);
        }
      }
      if (isSet$1(iterable)) {
        if ($setIterator) {
          return getStopIterationIterator2($setIterator(iterable));
        }
        if ($setAtAtIterator) {
          return $setAtAtIterator(iterable);
        }
        if ($setForEach) {
          var values = [];
          $setForEach(iterable, function(v) {
            $arrayPush(values, v);
          });
          return getArrayIterator(values);
        }
      }
    };
    esGetIterator.exports = function getIterator2(iterable) {
      return getCollectionIterator(iterable) || getNonCollectionIterator(iterable);
    };
  }
}
var numberIsNaN = function(value) {
  return value !== value;
};
var implementation$2 = function is(a, b) {
  if (a === 0 && b === 0) {
    return 1 / a === 1 / b;
  }
  if (a === b) {
    return true;
  }
  if (numberIsNaN(a) && numberIsNaN(b)) {
    return true;
  }
  return false;
};
var implementation$1 = implementation$2;
var polyfill$1 = function getPolyfill3() {
  return typeof Object.is === "function" ? Object.is : implementation$1;
};
var getPolyfill$1 = polyfill$1;
var define$1 = defineProperties_1;
var shim$4 = function shimObjectIs() {
  var polyfill2 = getPolyfill$1();
  define$1(Object, { is: polyfill2 }, {
    is: function testObjectIs() {
      return Object.is !== polyfill2;
    }
  });
  return polyfill2;
};
var define = defineProperties_1;
var callBind$1 = callBindExports;
var implementation = implementation$2;
var getPolyfill4 = polyfill$1;
var shim$3 = shim$4;
var polyfill = callBind$1(getPolyfill4(), Object);
define(polyfill, {
  getPolyfill: getPolyfill4,
  implementation,
  shim: shim$3
});
var objectIs = polyfill;
var fnToStr = Function.prototype.toString;
var reflectApply = typeof Reflect === "object" && Reflect !== null && Reflect.apply;
var badArrayLike;
var isCallableMarker;
if (typeof reflectApply === "function" && typeof Object.defineProperty === "function") {
  try {
    badArrayLike = Object.defineProperty({}, "length", {
      get: function() {
        throw isCallableMarker;
      }
    });
    isCallableMarker = {};
    reflectApply(function() {
      throw 42;
    }, null, badArrayLike);
  } catch (_) {
    if (_ !== isCallableMarker) {
      reflectApply = null;
    }
  }
} else {
  reflectApply = null;
}
var constructorRegex = /^\s*class\b/;
var isES6ClassFn = function isES6ClassFunction(value) {
  try {
    var fnStr = fnToStr.call(value);
    return constructorRegex.test(fnStr);
  } catch (e) {
    return false;
  }
};
var tryFunctionObject = function tryFunctionToStr(value) {
  try {
    if (isES6ClassFn(value)) {
      return false;
    }
    fnToStr.call(value);
    return true;
  } catch (e) {
    return false;
  }
};
var toStr$4 = Object.prototype.toString;
var objectClass = "[object Object]";
var fnClass = "[object Function]";
var genClass = "[object GeneratorFunction]";
var ddaClass = "[object HTMLAllCollection]";
var ddaClass2 = "[object HTML document.all class]";
var ddaClass3 = "[object HTMLCollection]";
var hasToStringTag$6 = typeof Symbol === "function" && !!Symbol.toStringTag;
var isIE68 = !(0 in [,]);
var isDDA = function isDocumentDotAll() {
  return false;
};
if (typeof document === "object") {
  var all = document.all;
  if (toStr$4.call(all) === toStr$4.call(document.all)) {
    isDDA = function isDocumentDotAll2(value) {
      if ((isIE68 || !value) && (typeof value === "undefined" || typeof value === "object")) {
        try {
          var str = toStr$4.call(value);
          return (str === ddaClass || str === ddaClass2 || str === ddaClass3 || str === objectClass) && value("") == null;
        } catch (e) {
        }
      }
      return false;
    };
  }
}
var isCallable$1 = reflectApply ? function isCallable(value) {
  if (isDDA(value)) {
    return true;
  }
  if (!value) {
    return false;
  }
  if (typeof value !== "function" && typeof value !== "object") {
    return false;
  }
  try {
    reflectApply(value, null, badArrayLike);
  } catch (e) {
    if (e !== isCallableMarker) {
      return false;
    }
  }
  return !isES6ClassFn(value) && tryFunctionObject(value);
} : function isCallable2(value) {
  if (isDDA(value)) {
    return true;
  }
  if (!value) {
    return false;
  }
  if (typeof value !== "function" && typeof value !== "object") {
    return false;
  }
  if (hasToStringTag$6) {
    return tryFunctionObject(value);
  }
  if (isES6ClassFn(value)) {
    return false;
  }
  var strClass2 = toStr$4.call(value);
  if (strClass2 !== fnClass && strClass2 !== genClass && !/^\[object HTML/.test(strClass2)) {
    return false;
  }
  return tryFunctionObject(value);
};
var isCallable3 = isCallable$1;
var toStr$3 = Object.prototype.toString;
var hasOwnProperty$3 = Object.prototype.hasOwnProperty;
var forEachArray = function forEachArray2(array, iterator, receiver) {
  for (var i = 0, len = array.length; i < len; i++) {
    if (hasOwnProperty$3.call(array, i)) {
      if (receiver == null) {
        iterator(array[i], i, array);
      } else {
        iterator.call(receiver, array[i], i, array);
      }
    }
  }
};
var forEachString = function forEachString2(string, iterator, receiver) {
  for (var i = 0, len = string.length; i < len; i++) {
    if (receiver == null) {
      iterator(string.charAt(i), i, string);
    } else {
      iterator.call(receiver, string.charAt(i), i, string);
    }
  }
};
var forEachObject = function forEachObject2(object, iterator, receiver) {
  for (var k in object) {
    if (hasOwnProperty$3.call(object, k)) {
      if (receiver == null) {
        iterator(object[k], k, object);
      } else {
        iterator.call(receiver, object[k], k, object);
      }
    }
  }
};
var forEach$2 = function forEach(list, iterator, thisArg) {
  if (!isCallable3(iterator)) {
    throw new TypeError("iterator must be a function");
  }
  var receiver;
  if (arguments.length >= 3) {
    receiver = thisArg;
  }
  if (toStr$3.call(list) === "[object Array]") {
    forEachArray(list, iterator, receiver);
  } else if (typeof list === "string") {
    forEachString(list, iterator, receiver);
  } else {
    forEachObject(list, iterator, receiver);
  }
};
var forEach_1 = forEach$2;
var possibleNames = [
  "BigInt64Array",
  "BigUint64Array",
  "Float32Array",
  "Float64Array",
  "Int16Array",
  "Int32Array",
  "Int8Array",
  "Uint16Array",
  "Uint32Array",
  "Uint8Array",
  "Uint8ClampedArray"
];
var g$3 = typeof globalThis === "undefined" ? commonjsGlobal : globalThis;
var availableTypedArrays$2 = function availableTypedArrays() {
  var out = [];
  for (var i = 0; i < possibleNames.length; i++) {
    if (typeof g$3[possibleNames[i]] === "function") {
      out[out.length] = possibleNames[i];
    }
  }
  return out;
};
var GetIntrinsic$3 = getIntrinsic;
var $gOPD = GetIntrinsic$3("%Object.getOwnPropertyDescriptor%", true);
if ($gOPD) {
  try {
    $gOPD([], "length");
  } catch (e) {
    $gOPD = null;
  }
}
var gopd = $gOPD;
var forEach$1 = forEach_1;
var availableTypedArrays$1 = availableTypedArrays$2;
var callBound$7 = callBound$c;
var $toString$3 = callBound$7("Object.prototype.toString");
var hasToStringTag$5 = shams();
var gOPD$2 = gopd;
var g$2 = typeof globalThis === "undefined" ? commonjsGlobal : globalThis;
var typedArrays$1 = availableTypedArrays$1();
var $indexOf = callBound$7("Array.prototype.indexOf", true) || function indexOf2(array, value) {
  for (var i = 0; i < array.length; i += 1) {
    if (array[i] === value) {
      return i;
    }
  }
  return -1;
};
var $slice$1 = callBound$7("String.prototype.slice");
var toStrTags$1 = {};
var getPrototypeOf$1 = Object.getPrototypeOf;
if (hasToStringTag$5 && gOPD$2 && getPrototypeOf$1) {
  forEach$1(typedArrays$1, function(typedArray) {
    var arr = new g$2[typedArray]();
    if (Symbol.toStringTag in arr) {
      var proto = getPrototypeOf$1(arr);
      var descriptor = gOPD$2(proto, Symbol.toStringTag);
      if (!descriptor) {
        var superProto = getPrototypeOf$1(proto);
        descriptor = gOPD$2(superProto, Symbol.toStringTag);
      }
      toStrTags$1[typedArray] = descriptor.get;
    }
  });
}
var tryTypedArrays$1 = function tryAllTypedArrays(value) {
  var anyTrue = false;
  forEach$1(toStrTags$1, function(getter, typedArray) {
    if (!anyTrue) {
      try {
        anyTrue = getter.call(value) === typedArray;
      } catch (e) {
      }
    }
  });
  return anyTrue;
};
var isTypedArray$2 = function isTypedArray(value) {
  if (!value || typeof value !== "object") {
    return false;
  }
  if (!hasToStringTag$5 || !(Symbol.toStringTag in value)) {
    var tag = $slice$1($toString$3(value), 8, -1);
    return $indexOf(typedArrays$1, tag) > -1;
  }
  if (!gOPD$2) {
    return false;
  }
  return tryTypedArrays$1(value);
};
var callBind = callBindExports;
var callBound$6 = callBound$c;
var GetIntrinsic$2 = getIntrinsic;
var isTypedArray$1 = isTypedArray$2;
var $ArrayBuffer = GetIntrinsic$2("ArrayBuffer", true);
var $Float32Array = GetIntrinsic$2("Float32Array", true);
var $byteLength$1 = callBound$6("ArrayBuffer.prototype.byteLength", true);
var abSlice = $ArrayBuffer && !$byteLength$1 && new $ArrayBuffer().slice;
var $abSlice = abSlice && callBind(abSlice);
var isArrayBuffer$1 = $byteLength$1 || $abSlice ? function isArrayBuffer(obj) {
  if (!obj || typeof obj !== "object") {
    return false;
  }
  try {
    if ($byteLength$1) {
      $byteLength$1(obj);
    } else {
      $abSlice(obj, 0);
    }
    return true;
  } catch (e) {
    return false;
  }
} : $Float32Array ? function IsArrayBuffer(obj) {
  try {
    return new $Float32Array(obj).buffer === obj && !isTypedArray$1(obj);
  } catch (e) {
    return typeof obj === "object" && e.name === "RangeError";
  }
} : function isArrayBuffer2(obj) {
  return false;
};
var getDay = Date.prototype.getDay;
var tryDateObject = function tryDateGetDayCall(value) {
  try {
    getDay.call(value);
    return true;
  } catch (e) {
    return false;
  }
};
var toStr$2 = Object.prototype.toString;
var dateClass = "[object Date]";
var hasToStringTag$4 = shams();
var isDateObject = function isDateObject2(value) {
  if (typeof value !== "object" || value === null) {
    return false;
  }
  return hasToStringTag$4 ? tryDateObject(value) : toStr$2.call(value) === dateClass;
};
var callBound$5 = callBound$c;
var hasToStringTag$3 = shams();
var has;
var $exec;
var isRegexMarker;
var badStringifier;
if (hasToStringTag$3) {
  has = callBound$5("Object.prototype.hasOwnProperty");
  $exec = callBound$5("RegExp.prototype.exec");
  isRegexMarker = {};
  var throwRegexMarker = function() {
    throw isRegexMarker;
  };
  badStringifier = {
    toString: throwRegexMarker,
    valueOf: throwRegexMarker
  };
  if (typeof Symbol.toPrimitive === "symbol") {
    badStringifier[Symbol.toPrimitive] = throwRegexMarker;
  }
}
var $toString$2 = callBound$5("Object.prototype.toString");
var gOPD$1 = Object.getOwnPropertyDescriptor;
var regexClass = "[object RegExp]";
var isRegex$1 = hasToStringTag$3 ? function isRegex(value) {
  if (!value || typeof value !== "object") {
    return false;
  }
  var descriptor = gOPD$1(value, "lastIndex");
  var hasLastIndexDataProperty = descriptor && has(descriptor, "value");
  if (!hasLastIndexDataProperty) {
    return false;
  }
  try {
    $exec(value, badStringifier);
  } catch (e) {
    return e === isRegexMarker;
  }
} : function isRegex2(value) {
  if (!value || typeof value !== "object" && typeof value !== "function") {
    return false;
  }
  return $toString$2(value) === regexClass;
};
var callBound$4 = callBound$c;
var $byteLength = callBound$4("SharedArrayBuffer.prototype.byteLength", true);
var isSharedArrayBuffer$1 = $byteLength ? function isSharedArrayBuffer(obj) {
  if (!obj || typeof obj !== "object") {
    return false;
  }
  try {
    $byteLength(obj);
    return true;
  } catch (e) {
    return false;
  }
} : function isSharedArrayBuffer2(obj) {
  return false;
};
var numToStr = Number.prototype.toString;
var tryNumberObject = function tryNumberObject2(value) {
  try {
    numToStr.call(value);
    return true;
  } catch (e) {
    return false;
  }
};
var toStr$1 = Object.prototype.toString;
var numClass = "[object Number]";
var hasToStringTag$2 = shams();
var isNumberObject = function isNumberObject2(value) {
  if (typeof value === "number") {
    return true;
  }
  if (typeof value !== "object") {
    return false;
  }
  return hasToStringTag$2 ? tryNumberObject(value) : toStr$1.call(value) === numClass;
};
var callBound$3 = callBound$c;
var $boolToStr = callBound$3("Boolean.prototype.toString");
var $toString$1 = callBound$3("Object.prototype.toString");
var tryBooleanObject = function booleanBrandCheck(value) {
  try {
    $boolToStr(value);
    return true;
  } catch (e) {
    return false;
  }
};
var boolClass = "[object Boolean]";
var hasToStringTag$1 = shams();
var isBooleanObject = function isBoolean(value) {
  if (typeof value === "boolean") {
    return true;
  }
  if (value === null || typeof value !== "object") {
    return false;
  }
  return hasToStringTag$1 && Symbol.toStringTag in value ? tryBooleanObject(value) : $toString$1(value) === boolClass;
};
var isSymbolExports = {};
var isSymbol$2 = {
  get exports() {
    return isSymbolExports;
  },
  set exports(v) {
    isSymbolExports = v;
  }
};
var toStr = Object.prototype.toString;
var hasSymbols2 = hasSymbols$5();
if (hasSymbols2) {
  var symToStr = Symbol.prototype.toString;
  var symStringRegex = /^Symbol\(.*\)$/;
  var isSymbolObject = function isRealSymbolObject(value) {
    if (typeof value.valueOf() !== "symbol") {
      return false;
    }
    return symStringRegex.test(symToStr.call(value));
  };
  isSymbol$2.exports = function isSymbol2(value) {
    if (typeof value === "symbol") {
      return true;
    }
    if (toStr.call(value) !== "[object Symbol]") {
      return false;
    }
    try {
      return isSymbolObject(value);
    } catch (e) {
      return false;
    }
  };
} else {
  isSymbol$2.exports = function isSymbol2(value) {
    return false;
  };
}
var isBigintExports = {};
var isBigint = {
  get exports() {
    return isBigintExports;
  },
  set exports(v) {
    isBigintExports = v;
  }
};
var $BigInt = typeof BigInt !== "undefined" && BigInt;
var hasBigints = function hasNativeBigInts() {
  return typeof $BigInt === "function" && typeof BigInt === "function" && typeof $BigInt(42) === "bigint" && typeof BigInt(42) === "bigint";
};
var hasBigInts = hasBigints();
if (hasBigInts) {
  var bigIntValueOf = BigInt.prototype.valueOf;
  var tryBigInt = function tryBigIntObject(value) {
    try {
      bigIntValueOf.call(value);
      return true;
    } catch (e) {
    }
    return false;
  };
  isBigint.exports = function isBigInt2(value) {
    if (value === null || typeof value === "undefined" || typeof value === "boolean" || typeof value === "string" || typeof value === "number" || typeof value === "symbol" || typeof value === "function") {
      return false;
    }
    if (typeof value === "bigint") {
      return true;
    }
    return tryBigInt(value);
  };
} else {
  isBigint.exports = function isBigInt2(value) {
    return false;
  };
}
var isString2 = isString$2;
var isNumber = isNumberObject;
var isBoolean2 = isBooleanObject;
var isSymbol$1 = isSymbolExports;
var isBigInt = isBigintExports;
var whichBoxedPrimitive$1 = function whichBoxedPrimitive(value) {
  if (value == null || typeof value !== "object" && typeof value !== "function") {
    return null;
  }
  if (isString2(value)) {
    return "String";
  }
  if (isNumber(value)) {
    return "Number";
  }
  if (isBoolean2(value)) {
    return "Boolean";
  }
  if (isSymbol$1(value)) {
    return "Symbol";
  }
  if (isBigInt(value)) {
    return "BigInt";
  }
};
var $WeakMap = typeof WeakMap === "function" && WeakMap.prototype ? WeakMap : null;
var $WeakSet$1 = typeof WeakSet === "function" && WeakSet.prototype ? WeakSet : null;
var exported;
if (!$WeakMap) {
  exported = function isWeakMap3(x) {
    return false;
  };
}
var $mapHas$2 = $WeakMap ? $WeakMap.prototype.has : null;
var $setHas$2 = $WeakSet$1 ? $WeakSet$1.prototype.has : null;
if (!exported && !$mapHas$2) {
  exported = function isWeakMap3(x) {
    return false;
  };
}
var isWeakmap = exported || function isWeakMap(x) {
  if (!x || typeof x !== "object") {
    return false;
  }
  try {
    $mapHas$2.call(x, $mapHas$2);
    if ($setHas$2) {
      try {
        $setHas$2.call(x, $setHas$2);
      } catch (e) {
        return true;
      }
    }
    return x instanceof $WeakMap;
  } catch (e) {
  }
  return false;
};
var isWeaksetExports = {};
var isWeakset = {
  get exports() {
    return isWeaksetExports;
  },
  set exports(v) {
    isWeaksetExports = v;
  }
};
var GetIntrinsic$1 = getIntrinsic;
var callBound$2 = callBound$c;
var $WeakSet = GetIntrinsic$1("%WeakSet%", true);
var $setHas$1 = callBound$2("WeakSet.prototype.has", true);
if ($setHas$1) {
  var $mapHas$1 = callBound$2("WeakMap.prototype.has", true);
  isWeakset.exports = function isWeakSet2(x) {
    if (!x || typeof x !== "object") {
      return false;
    }
    try {
      $setHas$1(x, $setHas$1);
      if ($mapHas$1) {
        try {
          $mapHas$1(x, $mapHas$1);
        } catch (e) {
          return true;
        }
      }
      return x instanceof $WeakSet;
    } catch (e) {
    }
    return false;
  };
} else {
  isWeakset.exports = function isWeakSet2(x) {
    return false;
  };
}
var isMap2 = isMap$2;
var isSet2 = isSet$2;
var isWeakMap2 = isWeakmap;
var isWeakSet = isWeaksetExports;
var whichCollection$1 = function whichCollection(value) {
  if (value && typeof value === "object") {
    if (isMap2(value)) {
      return "Map";
    }
    if (isSet2(value)) {
      return "Set";
    }
    if (isWeakMap2(value)) {
      return "WeakMap";
    }
    if (isWeakSet(value)) {
      return "WeakSet";
    }
  }
  return false;
};
var forEach2 = forEach_1;
var availableTypedArrays2 = availableTypedArrays$2;
var callBound$1 = callBound$c;
var gOPD = gopd;
var $toString = callBound$1("Object.prototype.toString");
var hasToStringTag = shams();
var g$1 = typeof globalThis === "undefined" ? commonjsGlobal : globalThis;
var typedArrays = availableTypedArrays2();
var $slice = callBound$1("String.prototype.slice");
var toStrTags = {};
var getPrototypeOf = Object.getPrototypeOf;
if (hasToStringTag && gOPD && getPrototypeOf) {
  forEach2(typedArrays, function(typedArray) {
    if (typeof g$1[typedArray] === "function") {
      var arr = new g$1[typedArray]();
      if (Symbol.toStringTag in arr) {
        var proto = getPrototypeOf(arr);
        var descriptor = gOPD(proto, Symbol.toStringTag);
        if (!descriptor) {
          var superProto = getPrototypeOf(proto);
          descriptor = gOPD(superProto, Symbol.toStringTag);
        }
        toStrTags[typedArray] = descriptor.get;
      }
    }
  });
}
var tryTypedArrays = function tryAllTypedArrays2(value) {
  var foundName = false;
  forEach2(toStrTags, function(getter, typedArray) {
    if (!foundName) {
      try {
        var name2 = getter.call(value);
        if (name2 === typedArray) {
          foundName = name2;
        }
      } catch (e) {
      }
    }
  });
  return foundName;
};
var isTypedArray2 = isTypedArray$2;
var whichTypedArray$1 = function whichTypedArray(value) {
  if (!isTypedArray2(value)) {
    return false;
  }
  if (!hasToStringTag || !(Symbol.toStringTag in value)) {
    return $slice($toString(value), 8, -1);
  }
  return tryTypedArrays(value);
};
var assign3 = object_assign;
var callBound = callBound$c;
var flags = regexp_prototype_flags;
var GetIntrinsic2 = getIntrinsic;
var getIterator = esGetIteratorExports;
var getSideChannel2 = sideChannel;
var is2 = objectIs;
var isArguments4 = isArguments$2;
var isArray$1 = isarray;
var isArrayBuffer3 = isArrayBuffer$1;
var isDate = isDateObject;
var isRegex3 = isRegex$1;
var isSharedArrayBuffer3 = isSharedArrayBuffer$1;
var objectKeys = objectKeys$2;
var whichBoxedPrimitive2 = whichBoxedPrimitive$1;
var whichCollection2 = whichCollection$1;
var whichTypedArray2 = whichTypedArray$1;
var byteLength = callBound("ArrayBuffer.prototype.byteLength", true) || function byteLength2(ab) {
  return ab.byteLength;
};
var sabByteLength = callBound("SharedArrayBuffer.prototype.byteLength", true);
var $getTime = callBound("Date.prototype.getTime");
var gPO = Object.getPrototypeOf;
var $objToString = callBound("Object.prototype.toString");
var $Set = GetIntrinsic2("%Set%", true);
var $mapHas = callBound("Map.prototype.has", true);
var $mapGet = callBound("Map.prototype.get", true);
var $mapSize = callBound("Map.prototype.size", true);
var $setAdd = callBound("Set.prototype.add", true);
var $setDelete = callBound("Set.prototype.delete", true);
var $setHas = callBound("Set.prototype.has", true);
var $setSize = callBound("Set.prototype.size", true);
function setHasEqualElement(set3, val1, opts, channel2) {
  var i = getIterator(set3);
  var result;
  while ((result = i.next()) && !result.done) {
    if (internalDeepEqual(val1, result.value, opts, channel2)) {
      $setDelete(set3, result.value);
      return true;
    }
  }
  return false;
}
function findLooseMatchingPrimitives(prim) {
  if (typeof prim === "undefined") {
    return null;
  }
  if (typeof prim === "object") {
    return void 0;
  }
  if (typeof prim === "symbol") {
    return false;
  }
  if (typeof prim === "string" || typeof prim === "number") {
    return +prim === +prim;
  }
  return true;
}
function mapMightHaveLoosePrim(a, b, prim, item, opts, channel2) {
  var altValue = findLooseMatchingPrimitives(prim);
  if (altValue != null) {
    return altValue;
  }
  var curB = $mapGet(b, altValue);
  var looseOpts = assign3({}, opts, { strict: false });
  if (typeof curB === "undefined" && !$mapHas(b, altValue) || !internalDeepEqual(item, curB, looseOpts, channel2)) {
    return false;
  }
  return !$mapHas(a, altValue) && internalDeepEqual(item, curB, looseOpts, channel2);
}
function setMightHaveLoosePrim(a, b, prim) {
  var altValue = findLooseMatchingPrimitives(prim);
  if (altValue != null) {
    return altValue;
  }
  return $setHas(b, altValue) && !$setHas(a, altValue);
}
function mapHasEqualEntry(set3, map, key1, item1, opts, channel2) {
  var i = getIterator(set3);
  var result;
  var key2;
  while ((result = i.next()) && !result.done) {
    key2 = result.value;
    if (
      // eslint-disable-next-line no-use-before-define
      internalDeepEqual(key1, key2, opts, channel2) && internalDeepEqual(item1, $mapGet(map, key2), opts, channel2)
    ) {
      $setDelete(set3, key2);
      return true;
    }
  }
  return false;
}
function internalDeepEqual(actual, expected, options, channel2) {
  var opts = options || {};
  if (opts.strict ? is2(actual, expected) : actual === expected) {
    return true;
  }
  var actualBoxed = whichBoxedPrimitive2(actual);
  var expectedBoxed = whichBoxedPrimitive2(expected);
  if (actualBoxed !== expectedBoxed) {
    return false;
  }
  if (!actual || !expected || typeof actual !== "object" && typeof expected !== "object") {
    return opts.strict ? is2(actual, expected) : actual == expected;
  }
  var hasActual = channel2.has(actual);
  var hasExpected = channel2.has(expected);
  var sentinel;
  if (hasActual && hasExpected) {
    if (channel2.get(actual) === channel2.get(expected)) {
      return true;
    }
  } else {
    sentinel = {};
  }
  if (!hasActual) {
    channel2.set(actual, sentinel);
  }
  if (!hasExpected) {
    channel2.set(expected, sentinel);
  }
  return objEquiv(actual, expected, opts, channel2);
}
function isBuffer(x) {
  if (!x || typeof x !== "object" || typeof x.length !== "number") {
    return false;
  }
  if (typeof x.copy !== "function" || typeof x.slice !== "function") {
    return false;
  }
  if (x.length > 0 && typeof x[0] !== "number") {
    return false;
  }
  return !!(x.constructor && x.constructor.isBuffer && x.constructor.isBuffer(x));
}
function setEquiv(a, b, opts, channel2) {
  if ($setSize(a) !== $setSize(b)) {
    return false;
  }
  var iA = getIterator(a);
  var iB = getIterator(b);
  var resultA;
  var resultB;
  var set3;
  while ((resultA = iA.next()) && !resultA.done) {
    if (resultA.value && typeof resultA.value === "object") {
      if (!set3) {
        set3 = new $Set();
      }
      $setAdd(set3, resultA.value);
    } else if (!$setHas(b, resultA.value)) {
      if (opts.strict) {
        return false;
      }
      if (!setMightHaveLoosePrim(a, b, resultA.value)) {
        return false;
      }
      if (!set3) {
        set3 = new $Set();
      }
      $setAdd(set3, resultA.value);
    }
  }
  if (set3) {
    while ((resultB = iB.next()) && !resultB.done) {
      if (resultB.value && typeof resultB.value === "object") {
        if (!setHasEqualElement(set3, resultB.value, opts.strict, channel2)) {
          return false;
        }
      } else if (!opts.strict && !$setHas(a, resultB.value) && !setHasEqualElement(set3, resultB.value, opts.strict, channel2)) {
        return false;
      }
    }
    return $setSize(set3) === 0;
  }
  return true;
}
function mapEquiv(a, b, opts, channel2) {
  if ($mapSize(a) !== $mapSize(b)) {
    return false;
  }
  var iA = getIterator(a);
  var iB = getIterator(b);
  var resultA;
  var resultB;
  var set3;
  var key;
  var item1;
  var item2;
  while ((resultA = iA.next()) && !resultA.done) {
    key = resultA.value[0];
    item1 = resultA.value[1];
    if (key && typeof key === "object") {
      if (!set3) {
        set3 = new $Set();
      }
      $setAdd(set3, key);
    } else {
      item2 = $mapGet(b, key);
      if (typeof item2 === "undefined" && !$mapHas(b, key) || !internalDeepEqual(item1, item2, opts, channel2)) {
        if (opts.strict) {
          return false;
        }
        if (!mapMightHaveLoosePrim(a, b, key, item1, opts, channel2)) {
          return false;
        }
        if (!set3) {
          set3 = new $Set();
        }
        $setAdd(set3, key);
      }
    }
  }
  if (set3) {
    while ((resultB = iB.next()) && !resultB.done) {
      key = resultB.value[0];
      item2 = resultB.value[1];
      if (key && typeof key === "object") {
        if (!mapHasEqualEntry(set3, a, key, item2, opts, channel2)) {
          return false;
        }
      } else if (!opts.strict && (!a.has(key) || !internalDeepEqual($mapGet(a, key), item2, opts, channel2)) && !mapHasEqualEntry(set3, a, key, item2, assign3({}, opts, { strict: false }), channel2)) {
        return false;
      }
    }
    return $setSize(set3) === 0;
  }
  return true;
}
function objEquiv(a, b, opts, channel2) {
  var i, key;
  if (typeof a !== typeof b) {
    return false;
  }
  if (a == null || b == null) {
    return false;
  }
  if ($objToString(a) !== $objToString(b)) {
    return false;
  }
  if (isArguments4(a) !== isArguments4(b)) {
    return false;
  }
  var aIsArray = isArray$1(a);
  var bIsArray = isArray$1(b);
  if (aIsArray !== bIsArray) {
    return false;
  }
  var aIsError = a instanceof Error;
  var bIsError = b instanceof Error;
  if (aIsError !== bIsError) {
    return false;
  }
  if (aIsError || bIsError) {
    if (a.name !== b.name || a.message !== b.message) {
      return false;
    }
  }
  var aIsRegex = isRegex3(a);
  var bIsRegex = isRegex3(b);
  if (aIsRegex !== bIsRegex) {
    return false;
  }
  if ((aIsRegex || bIsRegex) && (a.source !== b.source || flags(a) !== flags(b))) {
    return false;
  }
  var aIsDate = isDate(a);
  var bIsDate = isDate(b);
  if (aIsDate !== bIsDate) {
    return false;
  }
  if (aIsDate || bIsDate) {
    if ($getTime(a) !== $getTime(b)) {
      return false;
    }
  }
  if (opts.strict && gPO && gPO(a) !== gPO(b)) {
    return false;
  }
  var aWhich = whichTypedArray2(a);
  var bWhich = whichTypedArray2(b);
  if ((aWhich || bWhich) && aWhich !== bWhich) {
    return false;
  }
  var aIsBuffer = isBuffer(a);
  var bIsBuffer = isBuffer(b);
  if (aIsBuffer !== bIsBuffer) {
    return false;
  }
  if (aIsBuffer || bIsBuffer) {
    if (a.length !== b.length) {
      return false;
    }
    for (i = 0; i < a.length; i++) {
      if (a[i] !== b[i]) {
        return false;
      }
    }
    return true;
  }
  var aIsArrayBuffer = isArrayBuffer3(a);
  var bIsArrayBuffer = isArrayBuffer3(b);
  if (aIsArrayBuffer !== bIsArrayBuffer) {
    return false;
  }
  if (aIsArrayBuffer || bIsArrayBuffer) {
    if (byteLength(a) !== byteLength(b)) {
      return false;
    }
    return typeof Uint8Array === "function" && internalDeepEqual(new Uint8Array(a), new Uint8Array(b), opts, channel2);
  }
  var aIsSAB = isSharedArrayBuffer3(a);
  var bIsSAB = isSharedArrayBuffer3(b);
  if (aIsSAB !== bIsSAB) {
    return false;
  }
  if (aIsSAB || bIsSAB) {
    if (sabByteLength(a) !== sabByteLength(b)) {
      return false;
    }
    return typeof Uint8Array === "function" && internalDeepEqual(new Uint8Array(a), new Uint8Array(b), opts, channel2);
  }
  if (typeof a !== typeof b) {
    return false;
  }
  var ka = objectKeys(a);
  var kb = objectKeys(b);
  if (ka.length !== kb.length) {
    return false;
  }
  ka.sort();
  kb.sort();
  for (i = ka.length - 1; i >= 0; i--) {
    if (ka[i] != kb[i]) {
      return false;
    }
  }
  for (i = ka.length - 1; i >= 0; i--) {
    key = ka[i];
    if (!internalDeepEqual(a[key], b[key], opts, channel2)) {
      return false;
    }
  }
  var aCollection = whichCollection2(a);
  var bCollection = whichCollection2(b);
  if (aCollection !== bCollection) {
    return false;
  }
  if (aCollection === "Set" || bCollection === "Set") {
    return setEquiv(a, b, opts, channel2);
  }
  if (aCollection === "Map") {
    return mapEquiv(a, b, opts, channel2);
  }
  return true;
}
var deepEqual = function deepEqual2(a, b, opts) {
  return internalDeepEqual(a, b, opts, getSideChannel2());
};
var lodash_ismatchExports = {};
var lodash_ismatch = {
  get exports() {
    return lodash_ismatchExports;
  },
  set exports(v) {
    lodash_ismatchExports = v;
  }
};
(function(module2, exports2) {
  var LARGE_ARRAY_SIZE = 200;
  var HASH_UNDEFINED2 = "__lodash_hash_undefined__";
  var UNORDERED_COMPARE_FLAG = 1, PARTIAL_COMPARE_FLAG = 2;
  var MAX_SAFE_INTEGER2 = 9007199254740991;
  var argsTag = "[object Arguments]", arrayTag = "[object Array]", boolTag = "[object Boolean]", dateTag = "[object Date]", errorTag = "[object Error]", funcTag2 = "[object Function]", genTag2 = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", objectTag = "[object Object]", promiseTag = "[object Promise]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag2 = "[object Symbol]", weakMapTag = "[object WeakMap]";
  var arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
  var reRegExpChar2 = /[\\^$.*+?()[\]{}|]/g;
  var reIsHostCtor2 = /^\[object .+?Constructor\]$/;
  var reIsUint2 = /^(?:0|[1-9]\d*)$/;
  var typedArrayTags = {};
  typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
  typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag2] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
  var freeGlobal2 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
  var freeSelf2 = typeof self == "object" && self && self.Object === Object && self;
  var root2 = freeGlobal2 || freeSelf2 || Function("return this")();
  var freeExports = exports2 && !exports2.nodeType && exports2;
  var freeModule = freeExports && true && module2 && !module2.nodeType && module2;
  var moduleExports = freeModule && freeModule.exports === freeExports;
  var freeProcess = moduleExports && freeGlobal2.process;
  var nodeUtil = function() {
    try {
      return freeProcess && freeProcess.binding("util");
    } catch (e) {
    }
  }();
  var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
  function arraySome(array, predicate) {
    var index = -1, length = array ? array.length : 0;
    while (++index < length) {
      if (predicate(array[index], index, array)) {
        return true;
      }
    }
    return false;
  }
  function baseTimes(n2, iteratee) {
    var index = -1, result = Array(n2);
    while (++index < n2) {
      result[index] = iteratee(index);
    }
    return result;
  }
  function baseUnary(func) {
    return function(value) {
      return func(value);
    };
  }
  function getValue2(object, key) {
    return object == null ? void 0 : object[key];
  }
  function isHostObject2(value) {
    var result = false;
    if (value != null && typeof value.toString != "function") {
      try {
        result = !!(value + "");
      } catch (e) {
      }
    }
    return result;
  }
  function mapToArray(map) {
    var index = -1, result = Array(map.size);
    map.forEach(function(value, key) {
      result[++index] = [key, value];
    });
    return result;
  }
  function overArg(func, transform) {
    return function(arg) {
      return func(transform(arg));
    };
  }
  function setToArray(set3) {
    var index = -1, result = Array(set3.size);
    set3.forEach(function(value) {
      result[++index] = value;
    });
    return result;
  }
  var arrayProto2 = Array.prototype, funcProto2 = Function.prototype, objectProto2 = Object.prototype;
  var coreJsData2 = root2["__core-js_shared__"];
  var maskSrcKey2 = function() {
    var uid = /[^.]+$/.exec(coreJsData2 && coreJsData2.keys && coreJsData2.keys.IE_PROTO || "");
    return uid ? "Symbol(src)_1." + uid : "";
  }();
  var funcToString2 = funcProto2.toString;
  var hasOwnProperty2 = objectProto2.hasOwnProperty;
  var objectToString2 = objectProto2.toString;
  var reIsNative2 = RegExp(
    "^" + funcToString2.call(hasOwnProperty2).replace(reRegExpChar2, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
  );
  var Symbol2 = root2.Symbol, Uint8Array2 = root2.Uint8Array, propertyIsEnumerable = objectProto2.propertyIsEnumerable, splice2 = arrayProto2.splice;
  var nativeKeys = overArg(Object.keys, Object);
  var DataView2 = getNative2(root2, "DataView"), Map2 = getNative2(root2, "Map"), Promise2 = getNative2(root2, "Promise"), Set2 = getNative2(root2, "Set"), WeakMap2 = getNative2(root2, "WeakMap"), nativeCreate2 = getNative2(Object, "create");
  var dataViewCtorString = toSource2(DataView2), mapCtorString = toSource2(Map2), promiseCtorString = toSource2(Promise2), setCtorString = toSource2(Set2), weakMapCtorString = toSource2(WeakMap2);
  var symbolProto2 = Symbol2 ? Symbol2.prototype : void 0, symbolValueOf = symbolProto2 ? symbolProto2.valueOf : void 0;
  function Hash2(entries) {
    var index = -1, length = entries ? entries.length : 0;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }
  function hashClear2() {
    this.__data__ = nativeCreate2 ? nativeCreate2(null) : {};
  }
  function hashDelete2(key) {
    return this.has(key) && delete this.__data__[key];
  }
  function hashGet2(key) {
    var data = this.__data__;
    if (nativeCreate2) {
      var result = data[key];
      return result === HASH_UNDEFINED2 ? void 0 : result;
    }
    return hasOwnProperty2.call(data, key) ? data[key] : void 0;
  }
  function hashHas2(key) {
    var data = this.__data__;
    return nativeCreate2 ? data[key] !== void 0 : hasOwnProperty2.call(data, key);
  }
  function hashSet2(key, value) {
    var data = this.__data__;
    data[key] = nativeCreate2 && value === void 0 ? HASH_UNDEFINED2 : value;
    return this;
  }
  Hash2.prototype.clear = hashClear2;
  Hash2.prototype["delete"] = hashDelete2;
  Hash2.prototype.get = hashGet2;
  Hash2.prototype.has = hashHas2;
  Hash2.prototype.set = hashSet2;
  function ListCache2(entries) {
    var index = -1, length = entries ? entries.length : 0;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }
  function listCacheClear2() {
    this.__data__ = [];
  }
  function listCacheDelete2(key) {
    var data = this.__data__, index = assocIndexOf2(data, key);
    if (index < 0) {
      return false;
    }
    var lastIndex = data.length - 1;
    if (index == lastIndex) {
      data.pop();
    } else {
      splice2.call(data, index, 1);
    }
    return true;
  }
  function listCacheGet2(key) {
    var data = this.__data__, index = assocIndexOf2(data, key);
    return index < 0 ? void 0 : data[index][1];
  }
  function listCacheHas2(key) {
    return assocIndexOf2(this.__data__, key) > -1;
  }
  function listCacheSet2(key, value) {
    var data = this.__data__, index = assocIndexOf2(data, key);
    if (index < 0) {
      data.push([key, value]);
    } else {
      data[index][1] = value;
    }
    return this;
  }
  ListCache2.prototype.clear = listCacheClear2;
  ListCache2.prototype["delete"] = listCacheDelete2;
  ListCache2.prototype.get = listCacheGet2;
  ListCache2.prototype.has = listCacheHas2;
  ListCache2.prototype.set = listCacheSet2;
  function MapCache2(entries) {
    var index = -1, length = entries ? entries.length : 0;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }
  function mapCacheClear2() {
    this.__data__ = {
      "hash": new Hash2(),
      "map": new (Map2 || ListCache2)(),
      "string": new Hash2()
    };
  }
  function mapCacheDelete2(key) {
    return getMapData2(this, key)["delete"](key);
  }
  function mapCacheGet2(key) {
    return getMapData2(this, key).get(key);
  }
  function mapCacheHas2(key) {
    return getMapData2(this, key).has(key);
  }
  function mapCacheSet2(key, value) {
    getMapData2(this, key).set(key, value);
    return this;
  }
  MapCache2.prototype.clear = mapCacheClear2;
  MapCache2.prototype["delete"] = mapCacheDelete2;
  MapCache2.prototype.get = mapCacheGet2;
  MapCache2.prototype.has = mapCacheHas2;
  MapCache2.prototype.set = mapCacheSet2;
  function SetCache(values) {
    var index = -1, length = values ? values.length : 0;
    this.__data__ = new MapCache2();
    while (++index < length) {
      this.add(values[index]);
    }
  }
  function setCacheAdd(value) {
    this.__data__.set(value, HASH_UNDEFINED2);
    return this;
  }
  function setCacheHas(value) {
    return this.__data__.has(value);
  }
  SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
  SetCache.prototype.has = setCacheHas;
  function Stack(entries) {
    this.__data__ = new ListCache2(entries);
  }
  function stackClear() {
    this.__data__ = new ListCache2();
  }
  function stackDelete(key) {
    return this.__data__["delete"](key);
  }
  function stackGet(key) {
    return this.__data__.get(key);
  }
  function stackHas(key) {
    return this.__data__.has(key);
  }
  function stackSet(key, value) {
    var cache = this.__data__;
    if (cache instanceof ListCache2) {
      var pairs = cache.__data__;
      if (!Map2 || pairs.length < LARGE_ARRAY_SIZE - 1) {
        pairs.push([key, value]);
        return this;
      }
      cache = this.__data__ = new MapCache2(pairs);
    }
    cache.set(key, value);
    return this;
  }
  Stack.prototype.clear = stackClear;
  Stack.prototype["delete"] = stackDelete;
  Stack.prototype.get = stackGet;
  Stack.prototype.has = stackHas;
  Stack.prototype.set = stackSet;
  function arrayLikeKeys(value, inherited) {
    var result = isArray2(value) || isArguments5(value) ? baseTimes(value.length, String) : [];
    var length = result.length, skipIndexes = !!length;
    for (var key in value) {
      if ((inherited || hasOwnProperty2.call(value, key)) && !(skipIndexes && (key == "length" || isIndex2(key, length)))) {
        result.push(key);
      }
    }
    return result;
  }
  function assocIndexOf2(array, key) {
    var length = array.length;
    while (length--) {
      if (eq2(array[length][0], key)) {
        return length;
      }
    }
    return -1;
  }
  function baseGetTag(value) {
    return objectToString2.call(value);
  }
  function baseIsEqual(value, other, customizer, bitmask, stack) {
    if (value === other) {
      return true;
    }
    if (value == null || other == null || !isObject2(value) && !isObjectLike2(other)) {
      return value !== value && other !== other;
    }
    return baseIsEqualDeep(value, other, baseIsEqual, customizer, bitmask, stack);
  }
  function baseIsEqualDeep(object, other, equalFunc, customizer, bitmask, stack) {
    var objIsArr = isArray2(object), othIsArr = isArray2(other), objTag = arrayTag, othTag = arrayTag;
    if (!objIsArr) {
      objTag = getTag(object);
      objTag = objTag == argsTag ? objectTag : objTag;
    }
    if (!othIsArr) {
      othTag = getTag(other);
      othTag = othTag == argsTag ? objectTag : othTag;
    }
    var objIsObj = objTag == objectTag && !isHostObject2(object), othIsObj = othTag == objectTag && !isHostObject2(other), isSameTag = objTag == othTag;
    if (isSameTag && !objIsObj) {
      stack || (stack = new Stack());
      return objIsArr || isTypedArray3(object) ? equalArrays(object, other, equalFunc, customizer, bitmask, stack) : equalByTag(object, other, objTag, equalFunc, customizer, bitmask, stack);
    }
    if (!(bitmask & PARTIAL_COMPARE_FLAG)) {
      var objIsWrapped = objIsObj && hasOwnProperty2.call(object, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty2.call(other, "__wrapped__");
      if (objIsWrapped || othIsWrapped) {
        var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
        stack || (stack = new Stack());
        return equalFunc(objUnwrapped, othUnwrapped, customizer, bitmask, stack);
      }
    }
    if (!isSameTag) {
      return false;
    }
    stack || (stack = new Stack());
    return equalObjects(object, other, equalFunc, customizer, bitmask, stack);
  }
  function baseIsMatch(object, source, matchData, customizer) {
    var index = matchData.length, length = index, noCustomizer = !customizer;
    if (object == null) {
      return !length;
    }
    object = Object(object);
    while (index--) {
      var data = matchData[index];
      if (noCustomizer && data[2] ? data[1] !== object[data[0]] : !(data[0] in object)) {
        return false;
      }
    }
    while (++index < length) {
      data = matchData[index];
      var key = data[0], objValue = object[key], srcValue = data[1];
      if (noCustomizer && data[2]) {
        if (objValue === void 0 && !(key in object)) {
          return false;
        }
      } else {
        var stack = new Stack();
        if (customizer) {
          var result = customizer(objValue, srcValue, key, object, source, stack);
        }
        if (!(result === void 0 ? baseIsEqual(srcValue, objValue, customizer, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG, stack) : result)) {
          return false;
        }
      }
    }
    return true;
  }
  function baseIsNative2(value) {
    if (!isObject2(value) || isMasked2(value)) {
      return false;
    }
    var pattern = isFunction2(value) || isHostObject2(value) ? reIsNative2 : reIsHostCtor2;
    return pattern.test(toSource2(value));
  }
  function baseIsTypedArray(value) {
    return isObjectLike2(value) && isLength(value.length) && !!typedArrayTags[objectToString2.call(value)];
  }
  function baseKeys(object) {
    if (!isPrototype(object)) {
      return nativeKeys(object);
    }
    var result = [];
    for (var key in Object(object)) {
      if (hasOwnProperty2.call(object, key) && key != "constructor") {
        result.push(key);
      }
    }
    return result;
  }
  function equalArrays(array, other, equalFunc, customizer, bitmask, stack) {
    var isPartial = bitmask & PARTIAL_COMPARE_FLAG, arrLength = array.length, othLength = other.length;
    if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
      return false;
    }
    var stacked = stack.get(array);
    if (stacked && stack.get(other)) {
      return stacked == other;
    }
    var index = -1, result = true, seen = bitmask & UNORDERED_COMPARE_FLAG ? new SetCache() : void 0;
    stack.set(array, other);
    stack.set(other, array);
    while (++index < arrLength) {
      var arrValue = array[index], othValue = other[index];
      if (customizer) {
        var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
      }
      if (compared !== void 0) {
        if (compared) {
          continue;
        }
        result = false;
        break;
      }
      if (seen) {
        if (!arraySome(other, function(othValue2, othIndex) {
          if (!seen.has(othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, customizer, bitmask, stack))) {
            return seen.add(othIndex);
          }
        })) {
          result = false;
          break;
        }
      } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, customizer, bitmask, stack))) {
        result = false;
        break;
      }
    }
    stack["delete"](array);
    stack["delete"](other);
    return result;
  }
  function equalByTag(object, other, tag, equalFunc, customizer, bitmask, stack) {
    switch (tag) {
      case dataViewTag:
        if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset) {
          return false;
        }
        object = object.buffer;
        other = other.buffer;
      case arrayBufferTag:
        if (object.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object), new Uint8Array2(other))) {
          return false;
        }
        return true;
      case boolTag:
      case dateTag:
      case numberTag:
        return eq2(+object, +other);
      case errorTag:
        return object.name == other.name && object.message == other.message;
      case regexpTag:
      case stringTag:
        return object == other + "";
      case mapTag:
        var convert2 = mapToArray;
      case setTag:
        var isPartial = bitmask & PARTIAL_COMPARE_FLAG;
        convert2 || (convert2 = setToArray);
        if (object.size != other.size && !isPartial) {
          return false;
        }
        var stacked = stack.get(object);
        if (stacked) {
          return stacked == other;
        }
        bitmask |= UNORDERED_COMPARE_FLAG;
        stack.set(object, other);
        var result = equalArrays(convert2(object), convert2(other), equalFunc, customizer, bitmask, stack);
        stack["delete"](object);
        return result;
      case symbolTag2:
        if (symbolValueOf) {
          return symbolValueOf.call(object) == symbolValueOf.call(other);
        }
    }
    return false;
  }
  function equalObjects(object, other, equalFunc, customizer, bitmask, stack) {
    var isPartial = bitmask & PARTIAL_COMPARE_FLAG, objProps = keys3(object), objLength = objProps.length, othProps = keys3(other), othLength = othProps.length;
    if (objLength != othLength && !isPartial) {
      return false;
    }
    var index = objLength;
    while (index--) {
      var key = objProps[index];
      if (!(isPartial ? key in other : hasOwnProperty2.call(other, key))) {
        return false;
      }
    }
    var stacked = stack.get(object);
    if (stacked && stack.get(other)) {
      return stacked == other;
    }
    var result = true;
    stack.set(object, other);
    stack.set(other, object);
    var skipCtor = isPartial;
    while (++index < objLength) {
      key = objProps[index];
      var objValue = object[key], othValue = other[key];
      if (customizer) {
        var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
      }
      if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, customizer, bitmask, stack) : compared)) {
        result = false;
        break;
      }
      skipCtor || (skipCtor = key == "constructor");
    }
    if (result && !skipCtor) {
      var objCtor = object.constructor, othCtor = other.constructor;
      if (objCtor != othCtor && ("constructor" in object && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
        result = false;
      }
    }
    stack["delete"](object);
    stack["delete"](other);
    return result;
  }
  function getMapData2(map, key) {
    var data = map.__data__;
    return isKeyable2(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
  }
  function getMatchData(object) {
    var result = keys3(object), length = result.length;
    while (length--) {
      var key = result[length], value = object[key];
      result[length] = [key, value, isStrictComparable(value)];
    }
    return result;
  }
  function getNative2(object, key) {
    var value = getValue2(object, key);
    return baseIsNative2(value) ? value : void 0;
  }
  var getTag = baseGetTag;
  if (DataView2 && getTag(new DataView2(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap2 && getTag(new WeakMap2()) != weakMapTag) {
    getTag = function(value) {
      var result = objectToString2.call(value), Ctor = result == objectTag ? value.constructor : void 0, ctorString = Ctor ? toSource2(Ctor) : void 0;
      if (ctorString) {
        switch (ctorString) {
          case dataViewCtorString:
            return dataViewTag;
          case mapCtorString:
            return mapTag;
          case promiseCtorString:
            return promiseTag;
          case setCtorString:
            return setTag;
          case weakMapCtorString:
            return weakMapTag;
        }
      }
      return result;
    };
  }
  function isIndex2(value, length) {
    length = length == null ? MAX_SAFE_INTEGER2 : length;
    return !!length && (typeof value == "number" || reIsUint2.test(value)) && (value > -1 && value % 1 == 0 && value < length);
  }
  function isKeyable2(value) {
    var type = typeof value;
    return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
  }
  function isMasked2(func) {
    return !!maskSrcKey2 && maskSrcKey2 in func;
  }
  function isPrototype(value) {
    var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto2;
    return value === proto;
  }
  function isStrictComparable(value) {
    return value === value && !isObject2(value);
  }
  function toSource2(func) {
    if (func != null) {
      try {
        return funcToString2.call(func);
      } catch (e) {
      }
      try {
        return func + "";
      } catch (e) {
      }
    }
    return "";
  }
  function eq2(value, other) {
    return value === other || value !== value && other !== other;
  }
  function isArguments5(value) {
    return isArrayLikeObject(value) && hasOwnProperty2.call(value, "callee") && (!propertyIsEnumerable.call(value, "callee") || objectToString2.call(value) == argsTag);
  }
  var isArray2 = Array.isArray;
  function isArrayLike(value) {
    return value != null && isLength(value.length) && !isFunction2(value);
  }
  function isArrayLikeObject(value) {
    return isObjectLike2(value) && isArrayLike(value);
  }
  function isFunction2(value) {
    var tag = isObject2(value) ? objectToString2.call(value) : "";
    return tag == funcTag2 || tag == genTag2;
  }
  function isLength(value) {
    return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER2;
  }
  function isObject2(value) {
    var type = typeof value;
    return !!value && (type == "object" || type == "function");
  }
  function isObjectLike2(value) {
    return !!value && typeof value == "object";
  }
  function isMatch(object, source) {
    return object === source || baseIsMatch(object, source, getMatchData(source));
  }
  var isTypedArray3 = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
  function keys3(object) {
    return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
  }
  module2.exports = isMatch;
})(lodash_ismatch, lodash_ismatchExports);
var ERROR$3 = 0;
var WARN$3 = 1;
var INFO$3 = 2;
var DEBUG$3 = 3;
var DEBUG2$3 = 4;
function _defineProperty$E(obj, key, value) {
  key = _toPropertyKey$C(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$C(arg) {
  var key = _toPrimitive$C(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$C(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var silent$3 = () => void 0;
let Logger$6 = class Logger {
  constructor(name2, level) {
    _defineProperty$E(this, "name", void 0);
    _defineProperty$E(this, "prefix", void 0);
    _defineProperty$E(this, "level", void 0);
    _defineProperty$E(this, "error", void 0);
    _defineProperty$E(this, "warn", void 0);
    _defineProperty$E(this, "log", void 0);
    _defineProperty$E(this, "info", void 0);
    _defineProperty$E(this, "debug", void 0);
    _defineProperty$E(this, "debug2", void 0);
    this.name = name2;
    this.prefix = name2 != null ? "[".concat(name2, "]") : "";
    this.error = silent$3;
    this.warn = silent$3;
    this.log = silent$3;
    this.info = silent$3;
    this.debug = silent$3;
    this.debug2 = silent$3;
    this.level = level;
    this.setLogLevel(level);
  }
  setLogLevel(level) {
    if (!Number.isFinite(level)) {
      console.warn("Expected a number for log level. Received: ".concat(level, ". Ignoring"));
      return;
    }
    this.level = level;
    this.error = level >= ERROR$3 ? console.error.bind(console, this.prefix) : silent$3;
    this.warn = level >= WARN$3 ? console.warn.bind(console, this.prefix) : silent$3;
    this.log = level >= INFO$3 ? console.log.bind(console, this.prefix) : silent$3;
    this.info = this.log;
    this.debug = level >= DEBUG$3 ? console.debug.bind(console, this.prefix) : silent$3;
    this.debug2 = level >= DEBUG2$3 ? console.debug.bind(console, this.prefix) : silent$3;
  }
};
const Logger$7 = Logger$6;
function _defineProperty$D(obj, key, value) {
  key = _toPropertyKey$B(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$B(arg) {
  var key = _toPrimitive$B(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$B(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
let DefaultLogger$6 = class DefaultLogger extends Logger$7 {
  constructor() {
    var level = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : INFO$3;
    super(null, level);
    _defineProperty$D(this, "modules", void 0);
    this.modules = {};
  }
  module(name2) {
    if (this.modules[name2] == null) {
      this.modules[name2] = new Logger$7(name2, this.level);
    }
    return this.modules[name2];
  }
  setLogLevel(level) {
    super.setLogLevel(level);
    if (this.modules == null) {
      return;
    }
    var keys3 = Object.keys(this.modules);
    for (var i = 0; i < keys3.length; i += 1) {
      this.modules[keys3[i]].setLogLevel(level);
    }
  }
};
const DefaultLogger$7 = DefaultLogger$6;
var Log$6 = new DefaultLogger$7();
const Log$7 = Log$6;
function _defineProperty$C(obj, key, value) {
  key = _toPropertyKey$A(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$A(arg) {
  var key = _toPrimitive$A(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$A(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
let CanceledPromiseError$2 = class CanceledPromiseError extends Error {
  constructor() {
    super(...arguments);
    _defineProperty$C(this, "isCanceled", true);
  }
};
const CanceledPromiseError$3 = CanceledPromiseError$2;
function _defineProperty$B(obj, key, value) {
  key = _toPropertyKey$z(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$z(arg) {
  var key = _toPrimitive$z(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$z(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
let TimeoutError$2 = class TimeoutError extends Error {
  constructor() {
    super(...arguments);
    _defineProperty$B(this, "isTimeout", true);
  }
};
const TimeoutError$3 = TimeoutError$2;
let PromiseUtils$1 = class PromiseUtils {
  /**
   * Creates a promise that can be canceled by calling the `cancel` function
   * Pass an optional `cleanupFunc` to perform actions on the resolved item after promise is cancelled.
   * @param promise The item to resolve
   * @param cleanup Function to cleanup the resolved item after cancelation. Called after both this promise is cancelled and the wrapped item was resolved (order does not matter).
   */
  static makeCancelable(promise, cleanup) {
    var hasCanceled = false;
    var resolved;
    var rejectFn;
    var wrappedPromise = new Promise((resolve, reject) => {
      rejectFn = reject;
      Promise.resolve(promise).then((val) => {
        if (hasCanceled) {
          if (cleanup) {
            cleanup(val);
          }
        } else {
          resolved = val;
          resolve(val);
        }
      }).catch((error) => reject(error));
    });
    wrappedPromise.cancel = () => {
      hasCanceled = true;
      rejectFn(new CanceledPromiseError$3());
      if (resolved != null && cleanup) {
        cleanup(resolved);
      }
    };
    return wrappedPromise;
  }
  static isCanceled(error) {
    return error instanceof CanceledPromiseError$3;
  }
  static isTimedOut(error) {
    return error instanceof TimeoutError$3;
  }
  /**
   * Wrap a callback call in a Promise + setTimeout.
   * @param timeoutMs
   * @param callback
   */
  static withTimeout(timeoutMs, callback) {
    return new Promise((resolve, reject) => {
      setTimeout(() => {
        try {
          resolve(callback());
        } catch (err) {
          reject(err);
        }
      }, timeoutMs);
    });
  }
};
function _defineProperty$A(obj, key, value) {
  key = _toPropertyKey$y(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$y(arg) {
  var key = _toPrimitive$y(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$y(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class Pending {
  constructor() {
    _defineProperty$A(this, "pending", []);
    _defineProperty$A(this, "resolved", []);
  }
  /**
   * Begins tracking a promise. After the promise has resolved, it's removed from tracking.
   * @param item Item to track.
   * @param cleanup The cleanup function to use when the promise is cancelled
   * @returns CancelablePromise Returns a cancelable promise.
   */
  add(item, cleanup) {
    var promise = PromiseUtils$1.makeCancelable(item, cleanup);
    this.pending.push(promise);
    promise.then(() => {
      this.resolve(promise);
    }, () => {
      this.resolve(promise);
    });
    return promise;
  }
  /**
   * Remove a promise from tracking.
   * @param promise Promise to stop tracking
   */
  remove(promise) {
    for (var i = 0; i < this.pending.length; i += 1) {
      if (this.pending[i] === promise) {
        this.pending.splice(i, 1);
        return;
      }
    }
  }
  resolve(promise) {
    this.remove(promise);
    this.resolved.push(promise);
  }
  /**
   * Cancel all pending promises and remove them from tracking.
   */
  cancel() {
    var allPromises = [...this.pending, ...this.resolved];
    for (var i = 0; i < allPromises.length; i += 1) {
      allPromises[i].cancel();
    }
    this.pending = [];
    this.resolved = [];
  }
}
const Pending$1 = Pending;
function assertNotNull$2(value) {
  if (value == null)
    throw new Error("Value is null or undefined");
}
const lm_root$1 = "_lm_root_1qf9a_3";
const lm_row$1 = "_lm_row_1qf9a_7";
const lm_item$1 = "_lm_item_1qf9a_7";
const lm_content$1 = "_lm_content_1qf9a_11";
const lm_dragging$1 = "_lm_dragging_1qf9a_17";
const lm_maximised$1 = "_lm_maximised_1qf9a_23";
const lm_maximise_placeholder$1 = "_lm_maximise_placeholder_1qf9a_30";
const lm_splitter$1 = "_lm_splitter_1qf9a_34";
const lm_vertical$1 = "_lm_vertical_1qf9a_41";
const lm_drag_handle$1 = "_lm_drag_handle_1qf9a_41";
const lm_horizontal$1 = "_lm_horizontal_1qf9a_46";
const lm_header$1 = "_lm_header_1qf9a_56";
const lm_dropdown_open$1 = "_lm_dropdown_open_1qf9a_63";
const lm_controls$1 = "_lm_controls_1qf9a_69";
const lm_tabs$1 = "_lm_tabs_1qf9a_89";
const lm_tab$1 = "_lm_tab_1qf9a_89";
const lm_title$1 = "_lm_title_1qf9a_104";
const lm_close_tab$1 = "_lm_close_tab_1qf9a_111";
const lm_stack$1 = "_lm_stack_1qf9a_120";
const lm_left$1 = "_lm_left_1qf9a_120";
const lm_right$1 = "_lm_right_1qf9a_121";
const lm_dragProxy$1 = "_lm_dragProxy_1qf9a_125";
const lm_items$1 = "_lm_items_1qf9a_148";
const lm_tabdropdown_list$1 = "_lm_tabdropdown_list_1qf9a_165";
const lm_bottom$1 = "_lm_bottom_1qf9a_192";
const lm_drop_tab_placeholder$1 = "_lm_drop_tab_placeholder_1qf9a_207";
const lm_tabdropdown$1 = "_lm_tabdropdown_1qf9a_165";
const lm_dropTargetIndicator$1 = "_lm_dropTargetIndicator_1qf9a_258";
const lm_inner$1 = "_lm_inner_1qf9a_264";
const lm_transition_indicator$1 = "_lm_transition_indicator_1qf9a_272";
const lm_popin$1 = "_lm_popin_1qf9a_282";
const lm_bg$1 = "_lm_bg_1qf9a_297";
const lm_icon$1 = "_lm_icon_1qf9a_300";
const lm_goldenlayout$1 = "_lm_goldenlayout_1qf9a_304";
const lm_selectable$1 = "_lm_selectable_1qf9a_340";
const lm_active$1 = "_lm_active_1qf9a_370";
const lm_selected$1 = "_lm_selected_1qf9a_388";
const lm_keyboard_active$1 = "_lm_keyboard_active_1qf9a_397";
const lm_popout$1 = "_lm_popout_1qf9a_416";
const lm_maximise$1 = "_lm_maximise_1qf9a_23";
const lm_close$1 = "_lm_close_1qf9a_111";
const lm_tabnextbutton$1 = "_lm_tabnextbutton_1qf9a_425";
const lm_tabpreviousbutton$1 = "_lm_tabpreviousbutton_1qf9a_428";
const lm_title_before$1 = "_lm_title_before_1qf9a_544";
const lm_focusin$1 = "_lm_focusin_1qf9a_568";
const lm_window_blur$1 = "_lm_window_blur_1qf9a_573";
const lm_tabdropdown_search$1 = "_lm_tabdropdown_search_1qf9a_631";
const march$1 = "_march_1qf9a_1";
const app$1 = "_app_1qf9a_712";
const plotly$1 = "_plotly_1qf9a_721";
const GoldenLayout$2 = {
  "tab-height": "28px",
  "drag-border-width": "5px",
  lm_root: lm_root$1,
  lm_row: lm_row$1,
  lm_item: lm_item$1,
  lm_content: lm_content$1,
  lm_dragging: lm_dragging$1,
  lm_maximised: lm_maximised$1,
  lm_maximise_placeholder: lm_maximise_placeholder$1,
  lm_splitter: lm_splitter$1,
  lm_vertical: lm_vertical$1,
  lm_drag_handle: lm_drag_handle$1,
  lm_horizontal: lm_horizontal$1,
  lm_header: lm_header$1,
  lm_dropdown_open: lm_dropdown_open$1,
  lm_controls: lm_controls$1,
  lm_tabs: lm_tabs$1,
  lm_tab: lm_tab$1,
  lm_title: lm_title$1,
  lm_close_tab: lm_close_tab$1,
  lm_stack: lm_stack$1,
  lm_left: lm_left$1,
  lm_right: lm_right$1,
  lm_dragProxy: lm_dragProxy$1,
  lm_items: lm_items$1,
  lm_tabdropdown_list: lm_tabdropdown_list$1,
  lm_bottom: lm_bottom$1,
  lm_drop_tab_placeholder: lm_drop_tab_placeholder$1,
  lm_tabdropdown: lm_tabdropdown$1,
  lm_dropTargetIndicator: lm_dropTargetIndicator$1,
  lm_inner: lm_inner$1,
  lm_transition_indicator: lm_transition_indicator$1,
  lm_popin: lm_popin$1,
  lm_bg: lm_bg$1,
  lm_icon: lm_icon$1,
  lm_goldenlayout: lm_goldenlayout$1,
  lm_selectable: lm_selectable$1,
  lm_active: lm_active$1,
  lm_selected: lm_selected$1,
  lm_keyboard_active: lm_keyboard_active$1,
  lm_popout: lm_popout$1,
  lm_maximise: lm_maximise$1,
  lm_close: lm_close$1,
  lm_tabnextbutton: lm_tabnextbutton$1,
  lm_tabpreviousbutton: lm_tabpreviousbutton$1,
  lm_title_before: lm_title_before$1,
  "editor-unsaved-indicator": "_editor-unsaved-indicator_1qf9a_548",
  "is-unsaved": "_is-unsaved_1qf9a_556",
  lm_focusin: lm_focusin$1,
  lm_window_blur: lm_window_blur$1,
  lm_tabdropdown_search: lm_tabdropdown_search$1,
  march: march$1,
  app: app$1,
  "js-plotly-plot": "_js-plotly-plot_1qf9a_721",
  plotly: plotly$1
};
const GoldenLayoutThemeExport$1 = Object.freeze({
  tabHeight: parseInt(GoldenLayout$2["tab-height"], 10),
  dragBorderWidth: parseInt(GoldenLayout$2["drag-border-width"], 10)
});
function ownKeys$d(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread$b(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$d(Object(source), true).forEach(function(key) {
      _defineProperty$z(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$d(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$z(obj, key, value) {
  key = _toPropertyKey$x(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$x(arg) {
  var key = _toPrimitive$x(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$x(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var log$e = Log$7.module("LayoutUtils");
function isComponentConfig$1(config2) {
  return config2.componentName !== void 0;
}
function isReactComponentConfig$1(config2) {
  var reactConfig = config2;
  return (isComponentConfig$1(config2) && config2.componentName === "lm-react-component" || config2.type === "react-component") && reactConfig.component !== void 0;
}
function isHTMLElement$1(element) {
  return element.focus !== void 0;
}
function isStackItemConfig$1(config2) {
  return config2.type === "stack";
}
let LayoutUtils$1 = class LayoutUtils {
  static activateTab(root2, config2) {
    var stack = LayoutUtils.getStackForRoot(root2, config2, false);
    if (!stack) {
      log$e.error("Could not find stack for config", config2);
      return;
    }
    var contentItem = LayoutUtils.getContentItemInStack(stack, config2);
    if (contentItem) {
      stack.setActiveContentItem(contentItem);
    }
  }
  /**
   * Is the tab with the given config active
   * @param root A GoldenLayout content item with the tab
   * @param config Tab config to match
   * @returns True if the tab is active
   */
  static isActiveTab(root2, config2) {
    var stack = LayoutUtils.getStackForRoot(root2, config2, false);
    if (!stack) {
      log$e.error("Could not find stack for config", config2);
      return false;
    }
    var contentItem = LayoutUtils.getContentItemInStack(stack, config2);
    var activeItem = stack.getActiveContentItem();
    return activeItem === contentItem;
  }
  /**
   * Adds a stack to the root layout specified. Adds to the first row/column with only one item
   * @param parent A GoldenLayout content item to add the stack to
   * @returns The newly created stack.
   */
  static addStack(parent) {
    var columnPreferred = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
    var type = columnPreferred ? "column" : "row";
    if (isRoot$1(parent)) {
      if (parent.contentItems == null || parent.contentItems.length === 0) {
        parent.addChild({
          type
        });
      }
      var child = parent.contentItems[0];
      var _isCorrectType = columnPreferred ? child.isColumn : child.isRow;
      if (!_isCorrectType) {
        parent.removeChild(child, true);
        parent.addChild({
          type
        });
        var maintainFocusElement = document.activeElement;
        parent.contentItems[0].addChild(child);
        if (maintainFocusElement && maintainFocusElement.focus != null) {
          maintainFocusElement.focus();
        }
      }
      return this.addStack(parent.contentItems[0], columnPreferred);
    }
    if (parent.contentItems.length < 2) {
      parent.addChild({
        type: "stack"
      });
      return parent.contentItems[parent.contentItems.length - 1];
    }
    var newParent = parent.contentItems[parent.contentItems.length - 1];
    var isCorrectType = !columnPreferred ? newParent.isColumn : newParent.isRow;
    if (!isCorrectType) {
      parent.addChild({
        type: !columnPreferred ? "column" : "row"
      });
      parent.removeChild(newParent, true);
      parent.contentItems[parent.contentItems.length - 1].addChild(newParent);
      newParent = parent.contentItems[parent.contentItems.length - 1];
    }
    return this.addStack(newParent, !columnPreferred);
  }
  /**
   * Gets the first stack which contains a contentItem with the given config values
   * @param item Golden layout content item to search for the stack
   * @param config The item properties to match
   */
  static getStackForConfig(item) {
    var config2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    var allowEmptyStack = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
    if (allowEmptyStack && isStack$1(item) && item.contentItems.length === 0) {
      return item;
    }
    if (item.contentItems == null) {
      return null;
    }
    for (var i = 0; i < item.contentItems.length; i += 1) {
      var contentItem = item.contentItems[i];
      if (contentItem.isComponent && contentItem.config != null) {
        if (lodash_ismatchExports(contentItem.config, config2)) {
          return item;
        }
      }
      var stack = this.getStackForConfig(contentItem, config2, allowEmptyStack);
      if (stack) {
        return stack;
      }
    }
    return null;
  }
  /**
   * Gets a stack matching the specified config
   * @param root The root GoldenLayout element
   * @param config The item config type to match, eg. { component: 'IrisGridPanel', title: 'Table Name' }
   * @param createIfNecessary Whether to create the stack if it does not exist.
   * @param matchComponentType If the config doesn't match exactly, just find another one of the same component type
   * @param allowEmptyStack If no configs match, search for an empty stack that can be used
   */
  static getStackForRoot(root2, config2) {
    var createIfNecessary = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true;
    var matchComponentType = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
    var allowEmptyStack = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : true;
    var stack = this.getStackForConfig(root2, config2);
    if (!stack && matchComponentType) {
      stack = this.getStackForConfig(root2, {
        component: config2.component
      }, allowEmptyStack);
    }
    if (!stack && createIfNecessary) {
      stack = this.addStack(root2);
    }
    return stack;
  }
  /**
   * Gets a stack matching one of the specified types, creates new stack if necessary
   * @param root The GoldenLayout root to find or create the stack in
   * @param types The array of component types to match
   * @param createIfNecessary Whether to create the stack if it does not exist
   * @param matchComponentType If the config doesn't match exactly, just find another one of the same component type
   * @param allowEmptyStack If no configs match, search for an empty stack that can be used
   */
  static getStackForComponentTypes(root2, types) {
    var createIfNecessary = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true;
    var matchComponentType = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
    var allowEmptyStack = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : true;
    for (var i = 0; i < types.length; i += 1) {
      var component = types[i];
      var isLastType = i === types.length - 1;
      var stack = LayoutUtils.getStackForRoot(root2, {
        component
      }, createIfNecessary && isLastType, matchComponentType, allowEmptyStack);
      if (stack) {
        return stack;
      }
    }
    return null;
  }
  /**
   * Gets first content item with the specified config in stack.
   * @param stack The stack to search for the item
   * @param config The item config type to match, eg. { component: 'IrisGridPanel', title: 'Table Name' }
   * @returns Returns the found content item, null if not found.
   */
  static getContentItemInStack(stack, config2) {
    if (!stack) {
      return null;
    }
    for (var i = 0; i < stack.contentItems.length; i += 1) {
      var contentItem = stack.contentItems[i];
      if (contentItem.isComponent && contentItem.config != null) {
        if (lodash_ismatchExports(contentItem.config, config2)) {
          return contentItem;
        }
      }
    }
    return null;
  }
  /**
   * Removes dynamic props from components in the given config so this config could be serialized
   * @param config Config objec
   * @returns Dehydrated config
   */
  static dehydrateLayoutConfig(config2, dehydrateComponent) {
    if (config2 == null || !config2.length) {
      return [];
    }
    var dehydratedConfig = [];
    for (var i = 0; i < config2.length; i += 1) {
      var itemConfig = config2[i];
      var {
        component,
        content
      } = itemConfig;
      if (component) {
        var dehydratedComponent = dehydrateComponent(component, itemConfig);
        if (dehydratedComponent != null) {
          dehydratedConfig.push(dehydratedComponent);
        } else {
          log$e.debug2('dehydrateLayoutConfig: skipping unmapped component "'.concat(component, '"'));
        }
      } else if (content) {
        var layoutItemConfig = _objectSpread$b(_objectSpread$b({}, itemConfig), {}, {
          content: LayoutUtils.dehydrateLayoutConfig(content, dehydrateComponent)
        });
        dehydratedConfig.push(layoutItemConfig);
      } else {
        dehydratedConfig.push(itemConfig);
      }
    }
    return dehydratedConfig;
  }
  static getTabPoint(glContainer) {
    var {
      tab
    } = glContainer;
    if (tab == null) {
      throw new Error("Cannot get tab for panel container ".concat(glContainer));
    }
    var tabRect = tab.element[0].getBoundingClientRect();
    return [tabRect.left + tabRect.width * 0.5, tabRect.bottom - 8];
  }
  /**
   * Drop minor changes in Layout Configuration for deep comparison
   * @param config Layout Configuration
   *
   * minor changes:
   * 1. sorts in grid
   * 2. quick filters in grid
   * 3. active item
   *
   * item id is also removed
   */
  static dropLayoutMinorChange(config2) {
    for (var i = 0; i < config2.length; i += 1) {
      var itemConfig = config2[i];
      var {
        content
      } = itemConfig;
      if (content !== void 0) {
        if (isStackItemConfig$1(itemConfig)) {
          delete itemConfig.activeItemIndex;
        }
        LayoutUtils.dropLayoutMinorChange(content);
      } else if (isReactComponentConfig$1(itemConfig) && itemConfig.component === "IrisGridPanel") {
        if (itemConfig.props.panelState != null) {
          delete itemConfig.id;
          itemConfig.props.panelState.irisGridState.sorts = [];
          itemConfig.props.panelState.irisGridState.quickFilters = [];
        }
      }
    }
  }
  /**
   * Compare two layouts to see if they are equivalent
   * @param layout1 A Golden Layout config object
   * @param layout2 Another Golden layout config object
   * @param major When true, will ignore "minor" property differences (eg. sorts)
   */
  static isEqual(layout1, layout2) {
    var major = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
    if (major) {
      var layout1Clone = LayoutUtils.cloneLayout(layout1);
      var layout2Clone = LayoutUtils.cloneLayout(layout2);
      LayoutUtils.dropLayoutMinorChange(layout1Clone);
      LayoutUtils.dropLayoutMinorChange(layout2Clone);
      return deepEqual(layout1Clone, layout2Clone);
    }
    return deepEqual(layout1, layout2);
  }
  static cloneLayout(layout) {
    return JSON.parse(JSON.stringify(layout));
  }
  /**
   * Adds dynamic props to components in the given config so this config could be used to initialize a layout
   * @param config Dehydrated config object
   * @param hydrateComponent Function to hydrate the component
   * @returns Hydrated config
   */
  static hydrateLayoutConfig(config2, hydrateComponent) {
    if (config2 == null || !config2.length) {
      return [];
    }
    var hydratedConfig = [];
    for (var i = 0; i < config2.length; i += 1) {
      var itemConfig = config2[i];
      if (isReactComponentConfig$1(itemConfig)) {
        var _itemConfig$id;
        var {
          component,
          props = {}
        } = itemConfig;
        hydratedConfig.push(_objectSpread$b(_objectSpread$b({}, itemConfig), {}, {
          id: (_itemConfig$id = itemConfig === null || itemConfig === void 0 ? void 0 : itemConfig.id) !== null && _itemConfig$id !== void 0 ? _itemConfig$id : shortid(),
          props: hydrateComponent(component, props)
        }));
      } else if (itemConfig.content !== void 0) {
        var contentConfig = LayoutUtils.hydrateLayoutConfig(itemConfig.content, hydrateComponent);
        if (isStackItemConfig$1(itemConfig) && itemConfig.activeItemIndex != null && itemConfig.activeItemIndex >= contentConfig.length) {
          log$e.warn("Fixing bad activeItemIndex!", itemConfig.activeItemIndex, itemConfig);
          itemConfig.activeItemIndex = 0;
        }
        hydratedConfig.push(_objectSpread$b(_objectSpread$b({}, itemConfig), {}, {
          content: contentConfig
        }));
      } else {
        hydratedConfig.push(itemConfig);
      }
    }
    return hydratedConfig;
  }
  /**
   * Opens a component. It will try and open the component in an existing stack of the same component.
   * If `replaceExisting` is true and there is a component found with the same `config.id`, it will replace that component with this one.
   * If `allowStack` is true and there is a component of the same type found, it will open in that stack (potentially covering up a panel).
   * @param root The GoldenLayout root to open the component in
   * @param config The component config definition to open
   * @param replaceExisting Whether it should replace the existing one matching component type and id, or open a new one
   * @param replaceConfig The component config to replace
   * @param createNewStack True to force opening in a new stack, false to try and open in a stack with the same type of component.
   * @param focusElement The element to focus on
   * @param dragEvent Whether component is being created with a drag, mouse event is initial position for drag proxy
   */
  static openComponent() {
    var {
      root: root2,
      config: configParam,
      replaceExisting = true,
      replaceConfig = void 0,
      createNewStack = false,
      focusElement = void 0,
      dragEvent = void 0
    } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    var maintainFocusElement = document.activeElement;
    var config2 = _objectSpread$b({}, configParam);
    if (config2.id == null) {
      config2.id = shortid.generate();
    }
    if (dragEvent) {
      root2 === null || root2 === void 0 ? void 0 : root2.layoutManager.createDragSourceFromEvent(config2, dragEvent);
      return;
    }
    var searchConfig = replaceConfig || {
      id: config2.id,
      component: config2.component
    };
    assertNotNull$2(root2);
    var stack = createNewStack ? LayoutUtils.addStack(root2) : LayoutUtils.getStackForRoot(root2, searchConfig);
    assertNotNull$2(stack);
    var oldContentItem = LayoutUtils.getContentItemInStack(stack, searchConfig);
    if (focusElement != null) {
      var onComponentCreated = (event) => {
        log$e.debug("Component created, focusing element", focusElement);
        stack.off("componentCreated", onComponentCreated);
        var {
          element
        } = event.origin;
        requestAnimationFrame(() => {
          LayoutUtils.focusElement(element[0], focusElement);
        });
      };
      stack.on("componentCreated", onComponentCreated);
    }
    if (replaceExisting && oldContentItem) {
      var index = stack.contentItems.indexOf(oldContentItem);
      stack.addChild(config2, index + 1);
      stack.removeChild(oldContentItem);
      stack.setActiveContentItem(stack.contentItems[index]);
    } else {
      stack.addChild(config2);
    }
    if (focusElement == null && maintainFocusElement && isHTMLElement$1(maintainFocusElement)) {
      maintainFocusElement.focus();
    }
  }
  /**
   * Opens a component in an given stack.
   * If `replaceExisting` is true and there is a component found with the same `config.id`, it will replace that component with this one
   * @param stack The GoldenLayout stack to open the component in
   * @param config The component config definition to open
   * @param replaceExisting Whether it should replace the existing one matching component type and id, or open a new one
   */
  static openComponentInStack(stack, config2) {
    var replaceExisting = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true;
    var maintainFocusElement = document.activeElement;
    var searchConfig = {
      id: config2.id
    };
    var oldContentItem = LayoutUtils.getContentItemInStack(stack, searchConfig);
    if (replaceExisting && oldContentItem && stack) {
      var index = stack === null || stack === void 0 ? void 0 : stack.contentItems.indexOf(oldContentItem);
      stack.addChild(config2, index + 1);
      stack.removeChild(oldContentItem);
      stack.setActiveContentItem(stack.contentItems[index]);
    } else {
      stack === null || stack === void 0 ? void 0 : stack.addChild(config2);
    }
    if (maintainFocusElement && isHTMLElement$1(maintainFocusElement)) {
      maintainFocusElement.focus();
    }
  }
  /**
   * Close the specified component and remove it from the stack it's currently in
   * @param root The GoldenLayout root to search and close the component in
   * @param config The GoldenLayout component config definition to close, eg. { component: 'IrisGridPanel', id: 'table-t' }
   */
  static closeComponent(root2, config2, closeOptions) {
    var stack = LayoutUtils.getStackForRoot(root2, config2, false, false, false);
    if (!stack) {
      log$e.warn("Cannot find stack for component, ignoring close", config2);
      return;
    }
    var oldContentItem = LayoutUtils.getContentItemInStack(stack, config2);
    var maintainFocusElement = document.activeElement;
    if (oldContentItem) {
      if (isComponent$1(oldContentItem)) {
        oldContentItem.container.close(closeOptions);
      } else {
        stack.removeChild(oldContentItem);
      }
    }
    if (maintainFocusElement && document.contains(maintainFocusElement) && isHTMLElement$1(maintainFocusElement)) {
      maintainFocusElement.focus();
    }
  }
  static renameComponent(root2, config2, newTitle) {
    var stack = LayoutUtils.getStackForRoot(root2, config2, false);
    if (!stack) {
      log$e.error("Could not find stack for config", config2);
      return;
    }
    var contentItem = LayoutUtils.getContentItemInStack(stack, config2);
    if (contentItem) {
      contentItem.setTitle(newTitle);
    }
  }
  /**
   * Create a component clone based on the given config
   * @param root The GoldenLayout root to clone the component in
   * @param config The config to clone
   * @returns Clone config
   */
  static cloneComponent(root2, config2) {
    var stack = LayoutUtils.getStackForRoot(root2, config2, false);
    if (!stack) {
      log$e.error("Could not find stack for config", config2);
      return null;
    }
    var {
      props = {}
    } = config2;
    var panelState = LayoutUtils.getPanelComponentState(config2);
    var cloneConfig = {
      type: "react-component",
      component: config2.component,
      props: _objectSpread$b(_objectSpread$b({}, props), {}, {
        panelState
      }),
      title: "".concat(config2.title, " Copy"),
      id: shortid.generate()
    };
    LayoutUtils.openComponentInStack(stack, cloneConfig);
    return cloneConfig;
  }
  /**
   * Get panel component state for the given config
   * @param config Panel config
   * @returns Panel state
   */
  static getPanelComponentState(config2) {
    if (isComponentConfig$1(config2)) {
      var _config$componentStat;
      return (_config$componentStat = config2.componentState) === null || _config$componentStat === void 0 ? void 0 : _config$componentStat.panelState;
    }
    if (isReactComponentConfig$1(config2)) {
      var _config$props;
      return (_config$props = config2.props) === null || _config$props === void 0 ? void 0 : _config$props.panelState;
    }
    return null;
  }
  static makeDefaultLayout() {
    return {
      dimensions: {
        headerHeight: GoldenLayoutThemeExport$1.tabHeight,
        borderWidth: GoldenLayoutThemeExport$1.dragBorderWidth,
        borderGrabWidth: 10
      },
      settings: {
        showPopoutIcon: false,
        showCloseIcon: false,
        constrainDragToContainer: false
      }
    };
  }
  /**
   * Gets a containers root node
   * @param container The Golden Layout container to get the root for
   */
  static getRootFromContainer(container) {
    return container.layoutManager.root;
  }
  /**
   * Gets the config for the panel component given a glContainer
   * @param container The Golden Layout container to get the config for
   */
  static getComponentConfigFromContainer(container) {
    if (container) {
      if (container.tab != null && container.tab.contentItem != null) {
        return container.tab.contentItem.config;
      }
      return container._config;
    }
    return null;
  }
  static getTitleFromContainer(container) {
    if (container != null && container.tab != null && container.tab.contentItem != null) {
      return container.tab.contentItem.config.title;
    }
    return null;
  }
  static getTitleFromTab(tab) {
    if (tab != null && tab.contentItem != null) {
      return tab.contentItem.config.title;
    }
    return null;
  }
  /**
   * Retrieve the panel ID for the provided golden layout container
   * @param glContainer The container to get the panel ID for
   * @returns Panel ID
   */
  static getIdFromContainer(glContainer) {
    var config2 = LayoutUtils.getComponentConfigFromContainer(glContainer);
    if (config2) {
      return config2.id;
    }
    return null;
  }
  /**
   * Retrieve the ID of the panel provided
   * @param panel The panel to get the ID for
   * @returns Panel ID
   */
  static getIdFromPanel(panel) {
    var {
      glContainer
    } = panel.props;
    return LayoutUtils.getIdFromContainer(glContainer);
  }
  /**
   * Get component name from the panel instance
   * @param panel Panel to get component name for
   * @returns Component name or null if unable to retrieve name
   */
  static getComponentNameFromPanel(panel) {
    var {
      glContainer
    } = panel.props;
    var config2 = LayoutUtils.getComponentConfigFromContainer(glContainer);
    if (config2 && isReactComponentConfig$1(config2)) {
      var _config$component;
      return (_config$component = config2.component) !== null && _config$component !== void 0 ? _config$component : null;
    }
    return null;
  }
  /**
   * Get component name for wrapped and un-wrapped components
   * @param component Component to get name for
   * @returns Component name
   * @throws If displayName for the component is not defined
   */
  static getComponentName(component) {
    var _component$WrappedCom, _component$WrappedCom2;
    var name2 = (_component$WrappedCom = (_component$WrappedCom2 = component.WrappedComponent) === null || _component$WrappedCom2 === void 0 ? void 0 : _component$WrappedCom2.displayName) !== null && _component$WrappedCom !== void 0 ? _component$WrappedCom : component.displayName;
    if (name2 == null) {
      throw new Error("Component displayName not defined ".concat(component));
    }
    return name2;
  }
  /**
   * Put focus on the first "input" element (input, button, select, textarea) within an element
   * If element is null or input element not found, does nothing
   * @param element The element to put focus in.
   * @param selector The first element matching this selector will be focused.
   * @returns The element that was focused, null if not focused
   */
  static focusElement(element) {
    var selector = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : LayoutUtils.DEFAULT_FOCUS_SELECTOR;
    if (element == null) {
      return null;
    }
    var focusElement = element.querySelector(selector);
    if (focusElement == null) {
      return null;
    }
    if (isHTMLElement$1(focusElement)) {
      focusElement.focus();
    }
    return focusElement;
  }
  /**
   * Get a promise that initializes when layout is initialized
   * @param layout The layout to await initialization on
   * @returns Promise that resolves when layout is initialized
   */
  static onInitialized(layout) {
    return new Promise((resolve) => {
      if (layout.isInitialised) {
        resolve();
        return;
      }
      var onInit = () => {
        layout.off("initialised", onInit);
        resolve();
      };
      layout.on("initialised", onInit);
    });
  }
};
_defineProperty$z(LayoutUtils$1, "DEFAULT_FOCUS_SELECTOR", "input, select, textarea, button");
const PanelPlaceholder$3 = "";
var PanelPlaceholder$2 = /* @__PURE__ */ React.forwardRef((props, ref) => {
  var component = LayoutUtils$1.getComponentNameFromPanel({
    props
  });
  return /* @__PURE__ */ React.createElement("div", {
    ref,
    className: "panel-placeholder"
  }, 'Component "', component, '" is not registered.');
});
PanelPlaceholder$2.displayName = "PanelPlaceholder";
var propTypesExports = {};
var propTypes = {
  get exports() {
    return propTypesExports;
  },
  set exports(v) {
    propTypesExports = v;
  }
};
var ReactPropTypesSecret$1 = "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED";
var ReactPropTypesSecret_1 = ReactPropTypesSecret$1;
var ReactPropTypesSecret = ReactPropTypesSecret_1;
function emptyFunction() {
}
function emptyFunctionWithReset() {
}
emptyFunctionWithReset.resetWarningCache = emptyFunction;
var factoryWithThrowingShims = function() {
  function shim2(props, propName, componentName, location, propFullName, secret) {
    if (secret === ReactPropTypesSecret) {
      return;
    }
    var err = new Error(
      "Calling PropTypes validators directly is not supported by the `prop-types` package. Use PropTypes.checkPropTypes() to call them. Read more at http://fb.me/use-check-prop-types"
    );
    err.name = "Invariant Violation";
    throw err;
  }
  shim2.isRequired = shim2;
  function getShim() {
    return shim2;
  }
  var ReactPropTypes = {
    array: shim2,
    bigint: shim2,
    bool: shim2,
    func: shim2,
    number: shim2,
    object: shim2,
    string: shim2,
    symbol: shim2,
    any: shim2,
    arrayOf: getShim,
    element: shim2,
    elementType: shim2,
    instanceOf: getShim,
    node: shim2,
    objectOf: getShim,
    oneOf: getShim,
    oneOfType: getShim,
    shape: getShim,
    exact: getShim,
    checkPropTypes: emptyFunctionWithReset,
    resetWarningCache: emptyFunction
  };
  ReactPropTypes.PropTypes = ReactPropTypes;
  return ReactPropTypes;
};
{
  propTypes.exports = factoryWithThrowingShims();
}
const PanelEvent$1 = Object.freeze({
  // Panel has received focus
  FOCUS: "PanelEvent.FOCUS",
  // Panel has been mounted
  MOUNT: "PanelEvent.MOUNT",
  // Panel has been unmounted
  UNMOUNT: "PanelEvent.UNMOUNT",
  // The title of the panel has changed
  TITLE_CHANGED: "PanelEvent.TITLE_CHANGED",
  // Panel was re-opened from a dehydrated state
  REOPEN: "PanelEvent.REOPEN",
  // Panel was deleted
  DELETE: "PanelEvent.DELETE",
  // Panel was cloned/copied
  CLONED: "PanelEvent.CLONED",
  // Panel was closed
  CLOSED: "PanelEvent.CLOSED",
  // Event to open a new panel
  // Plugins will need to register to open based on this event.
  // Multiple plugins could open panels for the same event if desired.
  OPEN: "PanelEvent.OPEN",
  // Event to close a panel that's currently open
  CLOSE: "PanelEvent.CLOSE",
  // Panel is being dragged
  DRAGGING: "PanelEvent.DRAGGING",
  // Panel is dropped
  DROPPED: "PanelEvent.DROPPED"
});
function isWrappedComponent$1(type) {
  return (type === null || type === void 0 ? void 0 : type.WrappedComponent) !== void 0;
}
function ownKeys$c(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread$a(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$c(Object(source), true).forEach(function(key) {
      _defineProperty$y(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$c(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$y(obj, key, value) {
  key = _toPropertyKey$w(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$w(arg) {
  var key = _toPrimitive$w(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$w(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var log$d = Log$7.module("PanelManager");
let PanelManager$1 = class PanelManager {
  /**
   * @param layout The GoldenLayout object to attach to
   * @param hydrateComponent Function to hydrate a panel from a dehydrated state
   * @param dehydrateComponent Function to dehydrate a panel
   * @param openedMap Map of opened panels
   * @param closed Array of closed panels in a dehydrated state
   * @param onPanelsUpdated Triggered when the panels are updated
   */
  constructor(layout) {
    var hydrateComponent = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : (name2, props) => props;
    var dehydrateComponent = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : (name2, config2) => config2;
    var openedMap = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : /* @__PURE__ */ new Map();
    var closed = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : [];
    var onPanelsUpdated = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : () => void 0;
    _defineProperty$y(this, "layout", void 0);
    _defineProperty$y(this, "hydrateComponent", void 0);
    _defineProperty$y(this, "dehydrateComponent", void 0);
    _defineProperty$y(this, "onPanelsUpdated", void 0);
    _defineProperty$y(this, "closed", void 0);
    _defineProperty$y(this, "openedMap", void 0);
    this.handleFocus = this.handleFocus.bind(this);
    this.handleMount = this.handleMount.bind(this);
    this.handleUnmount = this.handleUnmount.bind(this);
    this.handleReopen = this.handleReopen.bind(this);
    this.handleDeleted = this.handleDeleted.bind(this);
    this.handleClosed = this.handleClosed.bind(this);
    this.handleControlClose = this.handleControlClose.bind(this);
    this.layout = layout;
    this.hydrateComponent = hydrateComponent;
    this.dehydrateComponent = dehydrateComponent;
    this.onPanelsUpdated = onPanelsUpdated;
    this.openedMap = new Map(openedMap);
    this.closed = [...closed];
    this.startListening();
  }
  startListening() {
    var {
      eventHub
    } = this.layout;
    eventHub.on(PanelEvent$1.FOCUS, this.handleFocus);
    eventHub.on(PanelEvent$1.MOUNT, this.handleMount);
    eventHub.on(PanelEvent$1.UNMOUNT, this.handleUnmount);
    eventHub.on(PanelEvent$1.REOPEN, this.handleReopen);
    eventHub.on(PanelEvent$1.DELETE, this.handleDeleted);
    eventHub.on(PanelEvent$1.CLOSED, this.handleClosed);
    eventHub.on(PanelEvent$1.CLOSE, this.handleControlClose);
  }
  stopListening() {
    var {
      eventHub
    } = this.layout;
    eventHub.off(PanelEvent$1.FOCUS, this.handleFocus);
    eventHub.off(PanelEvent$1.MOUNT, this.handleMount);
    eventHub.off(PanelEvent$1.UNMOUNT, this.handleUnmount);
    eventHub.off(PanelEvent$1.REOPEN, this.handleReopen);
    eventHub.off(PanelEvent$1.DELETE, this.handleDeleted);
    eventHub.off(PanelEvent$1.CLOSED, this.handleClosed);
    eventHub.off(PanelEvent$1.CLOSE, this.handleControlClose);
  }
  getClosedPanelConfigsOfType(typeString) {
    return this.closed.filter((panel) => panel.component === typeString);
  }
  getOpenedPanels() {
    return Array.from(this.openedMap.values());
  }
  getOpenedPanelConfigs() {
    return this.getOpenedPanels().map((panel) => {
      var {
        glContainer
      } = panel.props;
      return LayoutUtils$1.getComponentConfigFromContainer(glContainer);
    });
  }
  getOpenedPanelConfigsOfType(typeString) {
    return this.getOpenedPanelConfigs().filter((config2) => config2 != null && isReactComponentConfig$1(config2) && config2.component === typeString);
  }
  getOpenedPanelById(panelId) {
    return this.openedMap.get(panelId);
  }
  getContainerByPanelId(panelId) {
    var _ref2;
    var stack = LayoutUtils$1.getStackForConfig(this.layout.root, {
      id: panelId
    });
    return (_ref2 = stack && LayoutUtils$1.getContentItemInStack(stack, {
      id: panelId
    })) !== null && _ref2 !== void 0 ? _ref2 : null;
  }
  getLastUsedPanel(matcher) {
    var opened = this.getOpenedPanels();
    for (var i = opened.length - 1; i >= 0; i -= 1) {
      var _panel = opened[i];
      if (matcher == null || matcher(_panel)) {
        return _panel;
      }
    }
    return void 0;
  }
  getLastUsedPanelOfType(type) {
    return this.getLastUsedPanelOfTypes([type]);
  }
  getLastUsedPanelOfTypes(types) {
    return this.getLastUsedPanel((panel) => types.some((type) => isWrappedComponent$1(type) && panel instanceof type.WrappedComponent || !isWrappedComponent$1(type) && panel instanceof type));
  }
  updatePanel(panel) {
    var panelId = LayoutUtils$1.getIdFromPanel(panel);
    if (panelId == null) {
      log$d.error("updatePanel Panel did not have an ID", panel);
      return;
    }
    log$d.debug2("Updating panel ID ".concat(panelId, " in open panels map"));
    this.openedMap.delete(panelId);
    this.openedMap.set(panelId, panel);
  }
  removePanel(panel) {
    var panelId = LayoutUtils$1.getIdFromPanel(panel);
    if (panelId == null) {
      log$d.error("removePanel Panel did not have an ID", panel);
      return;
    }
    if (!this.openedMap.has(panelId)) {
      log$d.error("Missing panel ID ".concat(panelId, " in open panels map"));
      return;
    }
    if (this.openedMap.get(panelId) !== panel) {
      log$d.debug("Panel argument doesn't match the open panels map entry for ".concat(panelId, ", removePanel ignored"));
      return;
    }
    log$d.debug2("Removing panel ID ".concat(panelId, " from open panels map"));
    this.openedMap.delete(panelId);
  }
  removeClosedPanelConfig(panelConfig) {
    var index = this.closed.findIndex((closedConfig) => closedConfig === panelConfig || closedConfig.id != null && panelConfig.id != null && closedConfig.id === panelConfig.id);
    if (index >= 0) {
      this.closed.splice(index, 1);
    }
  }
  handleFocus(panel) {
    log$d.debug2("Focus: ", panel);
    this.updatePanel(panel);
  }
  handleMount(panel) {
    log$d.debug2("Mount: ", panel);
    this.updatePanel(panel);
    this.sendUpdate();
  }
  handleUnmount(panel) {
    log$d.debug2("Unmount: ", panel);
    this.removePanel(panel);
    this.sendUpdate();
  }
  /**
   *
   * @param panelConfig The config to hydrate and load
   * @param replaceConfig The config to place
   */
  handleReopen(panelConfig, replaceConfig) {
    log$d.debug2("Reopen:", panelConfig, replaceConfig);
    this.removeClosedPanelConfig(panelConfig);
    var {
      component
    } = panelConfig;
    var {
      props
    } = panelConfig;
    props = this.hydrateComponent(component, props);
    var config2 = _objectSpread$a(_objectSpread$a({}, panelConfig), {}, {
      props
    });
    var {
      root: root2
    } = this.layout;
    LayoutUtils$1.openComponent({
      root: root2,
      config: config2,
      replaceConfig
    });
  }
  handleDeleted(panelConfig) {
    log$d.debug2("Deleted:", panelConfig);
    this.removeClosedPanelConfig(panelConfig);
    this.sendUpdate();
  }
  handleClosed(panelId, glContainer) {
    log$d.debug2("Closed: ", panelId);
    this.addClosedPanel(glContainer);
    this.sendUpdate();
  }
  handleControlClose(id) {
    var config2 = {
      id
    };
    var {
      root: root2
    } = this.layout;
    LayoutUtils$1.closeComponent(root2, config2);
  }
  addClosedPanel(glContainer) {
    var config2 = LayoutUtils$1.getComponentConfigFromContainer(glContainer);
    if (config2 && isReactComponentConfig$1(config2)) {
      var dehydratedConfig = this.dehydrateComponent(config2.component, config2);
      if (dehydratedConfig != null) {
        this.closed.push(dehydratedConfig);
      }
    }
  }
  sendUpdate() {
    var {
      closed,
      openedMap
    } = this;
    this.onPanelsUpdated({
      closed: [...closed],
      openedMap: new Map(openedMap)
    });
  }
};
_defineProperty$y(PanelManager$1, "MAX_CLOSED_PANEL_COUNT", 100);
var classnamesExports = {};
var classnames = {
  get exports() {
    return classnamesExports;
  },
  set exports(v) {
    classnamesExports = v;
  }
};
/*!
	Copyright (c) 2018 Jed Watson.
	Licensed under the MIT License (MIT), see
	http://jedwatson.github.io/classnames
*/
(function(module2) {
  (function() {
    var hasOwn2 = {}.hasOwnProperty;
    function classNames() {
      var classes = [];
      for (var i = 0; i < arguments.length; i++) {
        var arg = arguments[i];
        if (!arg)
          continue;
        var argType = typeof arg;
        if (argType === "string" || argType === "number") {
          classes.push(arg);
        } else if (Array.isArray(arg)) {
          if (arg.length) {
            var inner2 = classNames.apply(null, arg);
            if (inner2) {
              classes.push(inner2);
            }
          }
        } else if (argType === "object") {
          if (arg.toString !== Object.prototype.toString && !arg.toString.toString().includes("[native code]")) {
            classes.push(arg.toString());
            continue;
          }
          for (var key in arg) {
            if (hasOwn2.call(arg, key) && arg[key]) {
              classes.push(key);
            }
          }
        }
      }
      return classes.join(" ");
    }
    if (module2.exports) {
      classNames.default = classNames;
      module2.exports = classNames;
    } else {
      window.classNames = classNames;
    }
  })();
})(classnames);
function _extends$1() {
  _extends$1 = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$1.apply(this, arguments);
}
function _objectWithoutPropertiesLoose$1(source, excluded) {
  if (source == null)
    return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0)
      continue;
    target[key] = source[key];
  }
  return target;
}
function _setPrototypeOf(o, p2) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf2(o2, p3) {
    o2.__proto__ = p3;
    return o2;
  };
  return _setPrototypeOf(o, p2);
}
function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}
function hasClass(element, className) {
  if (element.classList)
    return !!className && element.classList.contains(className);
  return (" " + (element.className.baseVal || element.className) + " ").indexOf(" " + className + " ") !== -1;
}
function addClass(element, className) {
  if (element.classList)
    element.classList.add(className);
  else if (!hasClass(element, className))
    if (typeof element.className === "string")
      element.className = element.className + " " + className;
    else
      element.setAttribute("class", (element.className && element.className.baseVal || "") + " " + className);
}
function replaceClassName(origClass, classToRemove) {
  return origClass.replace(new RegExp("(^|\\s)" + classToRemove + "(?:\\s|$)", "g"), "$1").replace(/\s+/g, " ").replace(/^\s*|\s*$/g, "");
}
function removeClass$1(element, className) {
  if (element.classList) {
    element.classList.remove(className);
  } else if (typeof element.className === "string") {
    element.className = replaceClassName(element.className, className);
  } else {
    element.setAttribute("class", replaceClassName(element.className && element.className.baseVal || "", className));
  }
}
const config$1 = {
  disabled: false
};
const TransitionGroupContext = React.createContext(null);
var forceReflow = function forceReflow2(node) {
  return node.scrollTop;
};
var UNMOUNTED = "unmounted";
var EXITED = "exited";
var ENTERING = "entering";
var ENTERED = "entered";
var EXITING = "exiting";
var Transition = /* @__PURE__ */ function(_React$Component) {
  _inheritsLoose(Transition2, _React$Component);
  function Transition2(props, context) {
    var _this;
    _this = _React$Component.call(this, props, context) || this;
    var parentGroup = context;
    var appear = parentGroup && !parentGroup.isMounting ? props.enter : props.appear;
    var initialStatus;
    _this.appearStatus = null;
    if (props.in) {
      if (appear) {
        initialStatus = EXITED;
        _this.appearStatus = ENTERING;
      } else {
        initialStatus = ENTERED;
      }
    } else {
      if (props.unmountOnExit || props.mountOnEnter) {
        initialStatus = UNMOUNTED;
      } else {
        initialStatus = EXITED;
      }
    }
    _this.state = {
      status: initialStatus
    };
    _this.nextCallback = null;
    return _this;
  }
  Transition2.getDerivedStateFromProps = function getDerivedStateFromProps(_ref2, prevState) {
    var nextIn = _ref2.in;
    if (nextIn && prevState.status === UNMOUNTED) {
      return {
        status: EXITED
      };
    }
    return null;
  };
  var _proto = Transition2.prototype;
  _proto.componentDidMount = function componentDidMount() {
    this.updateStatus(true, this.appearStatus);
  };
  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var nextStatus = null;
    if (prevProps !== this.props) {
      var status = this.state.status;
      if (this.props.in) {
        if (status !== ENTERING && status !== ENTERED) {
          nextStatus = ENTERING;
        }
      } else {
        if (status === ENTERING || status === ENTERED) {
          nextStatus = EXITING;
        }
      }
    }
    this.updateStatus(false, nextStatus);
  };
  _proto.componentWillUnmount = function componentWillUnmount() {
    this.cancelNextCallback();
  };
  _proto.getTimeouts = function getTimeouts() {
    var timeout = this.props.timeout;
    var exit, enter, appear;
    exit = enter = appear = timeout;
    if (timeout != null && typeof timeout !== "number") {
      exit = timeout.exit;
      enter = timeout.enter;
      appear = timeout.appear !== void 0 ? timeout.appear : enter;
    }
    return {
      exit,
      enter,
      appear
    };
  };
  _proto.updateStatus = function updateStatus(mounting, nextStatus) {
    if (mounting === void 0) {
      mounting = false;
    }
    if (nextStatus !== null) {
      this.cancelNextCallback();
      if (nextStatus === ENTERING) {
        if (this.props.unmountOnExit || this.props.mountOnEnter) {
          var node = this.props.nodeRef ? this.props.nodeRef.current : ReactDOM.findDOMNode(this);
          if (node)
            forceReflow(node);
        }
        this.performEnter(mounting);
      } else {
        this.performExit();
      }
    } else if (this.props.unmountOnExit && this.state.status === EXITED) {
      this.setState({
        status: UNMOUNTED
      });
    }
  };
  _proto.performEnter = function performEnter(mounting) {
    var _this2 = this;
    var enter = this.props.enter;
    var appearing = this.context ? this.context.isMounting : mounting;
    var _ref2 = this.props.nodeRef ? [appearing] : [ReactDOM.findDOMNode(this), appearing], maybeNode = _ref2[0], maybeAppearing = _ref2[1];
    var timeouts = this.getTimeouts();
    var enterTimeout = appearing ? timeouts.appear : timeouts.enter;
    if (!mounting && !enter || config$1.disabled) {
      this.safeSetState({
        status: ENTERED
      }, function() {
        _this2.props.onEntered(maybeNode);
      });
      return;
    }
    this.props.onEnter(maybeNode, maybeAppearing);
    this.safeSetState({
      status: ENTERING
    }, function() {
      _this2.props.onEntering(maybeNode, maybeAppearing);
      _this2.onTransitionEnd(enterTimeout, function() {
        _this2.safeSetState({
          status: ENTERED
        }, function() {
          _this2.props.onEntered(maybeNode, maybeAppearing);
        });
      });
    });
  };
  _proto.performExit = function performExit() {
    var _this3 = this;
    var exit = this.props.exit;
    var timeouts = this.getTimeouts();
    var maybeNode = this.props.nodeRef ? void 0 : ReactDOM.findDOMNode(this);
    if (!exit || config$1.disabled) {
      this.safeSetState({
        status: EXITED
      }, function() {
        _this3.props.onExited(maybeNode);
      });
      return;
    }
    this.props.onExit(maybeNode);
    this.safeSetState({
      status: EXITING
    }, function() {
      _this3.props.onExiting(maybeNode);
      _this3.onTransitionEnd(timeouts.exit, function() {
        _this3.safeSetState({
          status: EXITED
        }, function() {
          _this3.props.onExited(maybeNode);
        });
      });
    });
  };
  _proto.cancelNextCallback = function cancelNextCallback() {
    if (this.nextCallback !== null) {
      this.nextCallback.cancel();
      this.nextCallback = null;
    }
  };
  _proto.safeSetState = function safeSetState(nextState, callback) {
    callback = this.setNextCallback(callback);
    this.setState(nextState, callback);
  };
  _proto.setNextCallback = function setNextCallback(callback) {
    var _this4 = this;
    var active = true;
    this.nextCallback = function(event) {
      if (active) {
        active = false;
        _this4.nextCallback = null;
        callback(event);
      }
    };
    this.nextCallback.cancel = function() {
      active = false;
    };
    return this.nextCallback;
  };
  _proto.onTransitionEnd = function onTransitionEnd(timeout, handler) {
    this.setNextCallback(handler);
    var node = this.props.nodeRef ? this.props.nodeRef.current : ReactDOM.findDOMNode(this);
    var doesNotHaveTimeoutOrListener = timeout == null && !this.props.addEndListener;
    if (!node || doesNotHaveTimeoutOrListener) {
      setTimeout(this.nextCallback, 0);
      return;
    }
    if (this.props.addEndListener) {
      var _ref3 = this.props.nodeRef ? [this.nextCallback] : [node, this.nextCallback], maybeNode = _ref3[0], maybeNextCallback = _ref3[1];
      this.props.addEndListener(maybeNode, maybeNextCallback);
    }
    if (timeout != null) {
      setTimeout(this.nextCallback, timeout);
    }
  };
  _proto.render = function render3() {
    var status = this.state.status;
    if (status === UNMOUNTED) {
      return null;
    }
    var _this$props = this.props, children = _this$props.children;
    _this$props.in;
    _this$props.mountOnEnter;
    _this$props.unmountOnExit;
    _this$props.appear;
    _this$props.enter;
    _this$props.exit;
    _this$props.timeout;
    _this$props.addEndListener;
    _this$props.onEnter;
    _this$props.onEntering;
    _this$props.onEntered;
    _this$props.onExit;
    _this$props.onExiting;
    _this$props.onExited;
    _this$props.nodeRef;
    var childProps = _objectWithoutPropertiesLoose$1(_this$props, ["children", "in", "mountOnEnter", "unmountOnExit", "appear", "enter", "exit", "timeout", "addEndListener", "onEnter", "onEntering", "onEntered", "onExit", "onExiting", "onExited", "nodeRef"]);
    return (
      // allows for nested Transitions
      /* @__PURE__ */ React.createElement(TransitionGroupContext.Provider, {
        value: null
      }, typeof children === "function" ? children(status, childProps) : React.cloneElement(React.Children.only(children), childProps))
    );
  };
  return Transition2;
}(React.Component);
Transition.contextType = TransitionGroupContext;
Transition.propTypes = {};
function noop$3() {
}
Transition.defaultProps = {
  in: false,
  mountOnEnter: false,
  unmountOnExit: false,
  appear: false,
  enter: true,
  exit: true,
  onEnter: noop$3,
  onEntering: noop$3,
  onEntered: noop$3,
  onExit: noop$3,
  onExiting: noop$3,
  onExited: noop$3
};
Transition.UNMOUNTED = UNMOUNTED;
Transition.EXITED = EXITED;
Transition.ENTERING = ENTERING;
Transition.ENTERED = ENTERED;
Transition.EXITING = EXITING;
const Transition$1 = Transition;
var _addClass = function addClass$1(node, classes) {
  return node && classes && classes.split(" ").forEach(function(c) {
    return addClass(node, c);
  });
};
var removeClass = function removeClass2(node, classes) {
  return node && classes && classes.split(" ").forEach(function(c) {
    return removeClass$1(node, c);
  });
};
var CSSTransition = /* @__PURE__ */ function(_React$Component) {
  _inheritsLoose(CSSTransition2, _React$Component);
  function CSSTransition2() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _this.appliedClasses = {
      appear: {},
      enter: {},
      exit: {}
    };
    _this.onEnter = function(maybeNode, maybeAppearing) {
      var _this$resolveArgument = _this.resolveArguments(maybeNode, maybeAppearing), node = _this$resolveArgument[0], appearing = _this$resolveArgument[1];
      _this.removeClasses(node, "exit");
      _this.addClass(node, appearing ? "appear" : "enter", "base");
      if (_this.props.onEnter) {
        _this.props.onEnter(maybeNode, maybeAppearing);
      }
    };
    _this.onEntering = function(maybeNode, maybeAppearing) {
      var _this$resolveArgument2 = _this.resolveArguments(maybeNode, maybeAppearing), node = _this$resolveArgument2[0], appearing = _this$resolveArgument2[1];
      var type = appearing ? "appear" : "enter";
      _this.addClass(node, type, "active");
      if (_this.props.onEntering) {
        _this.props.onEntering(maybeNode, maybeAppearing);
      }
    };
    _this.onEntered = function(maybeNode, maybeAppearing) {
      var _this$resolveArgument3 = _this.resolveArguments(maybeNode, maybeAppearing), node = _this$resolveArgument3[0], appearing = _this$resolveArgument3[1];
      var type = appearing ? "appear" : "enter";
      _this.removeClasses(node, type);
      _this.addClass(node, type, "done");
      if (_this.props.onEntered) {
        _this.props.onEntered(maybeNode, maybeAppearing);
      }
    };
    _this.onExit = function(maybeNode) {
      var _this$resolveArgument4 = _this.resolveArguments(maybeNode), node = _this$resolveArgument4[0];
      _this.removeClasses(node, "appear");
      _this.removeClasses(node, "enter");
      _this.addClass(node, "exit", "base");
      if (_this.props.onExit) {
        _this.props.onExit(maybeNode);
      }
    };
    _this.onExiting = function(maybeNode) {
      var _this$resolveArgument5 = _this.resolveArguments(maybeNode), node = _this$resolveArgument5[0];
      _this.addClass(node, "exit", "active");
      if (_this.props.onExiting) {
        _this.props.onExiting(maybeNode);
      }
    };
    _this.onExited = function(maybeNode) {
      var _this$resolveArgument6 = _this.resolveArguments(maybeNode), node = _this$resolveArgument6[0];
      _this.removeClasses(node, "exit");
      _this.addClass(node, "exit", "done");
      if (_this.props.onExited) {
        _this.props.onExited(maybeNode);
      }
    };
    _this.resolveArguments = function(maybeNode, maybeAppearing) {
      return _this.props.nodeRef ? [_this.props.nodeRef.current, maybeNode] : [maybeNode, maybeAppearing];
    };
    _this.getClassNames = function(type) {
      var classNames = _this.props.classNames;
      var isStringClassNames = typeof classNames === "string";
      var prefix = isStringClassNames && classNames ? classNames + "-" : "";
      var baseClassName = isStringClassNames ? "" + prefix + type : classNames[type];
      var activeClassName = isStringClassNames ? baseClassName + "-active" : classNames[type + "Active"];
      var doneClassName = isStringClassNames ? baseClassName + "-done" : classNames[type + "Done"];
      return {
        baseClassName,
        activeClassName,
        doneClassName
      };
    };
    return _this;
  }
  var _proto = CSSTransition2.prototype;
  _proto.addClass = function addClass2(node, type, phase) {
    var className = this.getClassNames(type)[phase + "ClassName"];
    var _this$getClassNames = this.getClassNames("enter"), doneClassName = _this$getClassNames.doneClassName;
    if (type === "appear" && phase === "done" && doneClassName) {
      className += " " + doneClassName;
    }
    if (phase === "active") {
      if (node)
        forceReflow(node);
    }
    if (className) {
      this.appliedClasses[type][phase] = className;
      _addClass(node, className);
    }
  };
  _proto.removeClasses = function removeClasses(node, type) {
    var _this$appliedClasses$ = this.appliedClasses[type], baseClassName = _this$appliedClasses$.base, activeClassName = _this$appliedClasses$.active, doneClassName = _this$appliedClasses$.done;
    this.appliedClasses[type] = {};
    if (baseClassName) {
      removeClass(node, baseClassName);
    }
    if (activeClassName) {
      removeClass(node, activeClassName);
    }
    if (doneClassName) {
      removeClass(node, doneClassName);
    }
  };
  _proto.render = function render3() {
    var _this$props = this.props;
    _this$props.classNames;
    var props = _objectWithoutPropertiesLoose$1(_this$props, ["classNames"]);
    return /* @__PURE__ */ React.createElement(Transition$1, _extends$1({}, props, {
      onEnter: this.onEnter,
      onEntered: this.onEntered,
      onEntering: this.onEntering,
      onExit: this.onExit,
      onExiting: this.onExiting,
      onExited: this.onExited
    }));
  };
  return CSSTransition2;
}(React.Component);
CSSTransition.defaultProps = {
  classNames: ""
};
CSSTransition.propTypes = {};
const CSSTransition$1 = CSSTransition;
/**!
 * @fileOverview Kickass library to create and place poppers near their reference elements.
 * @version 1.16.1
 * @license
 * Copyright (c) 2016 Federico Zivolo and contributors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
var isBrowser = typeof window !== "undefined" && typeof document !== "undefined" && typeof navigator !== "undefined";
var timeoutDuration = function() {
  var longerTimeoutBrowsers = ["Edge", "Trident", "Firefox"];
  for (var i = 0; i < longerTimeoutBrowsers.length; i += 1) {
    if (isBrowser && navigator.userAgent.indexOf(longerTimeoutBrowsers[i]) >= 0) {
      return 1;
    }
  }
  return 0;
}();
function microtaskDebounce(fn) {
  var called = false;
  return function() {
    if (called) {
      return;
    }
    called = true;
    window.Promise.resolve().then(function() {
      called = false;
      fn();
    });
  };
}
function taskDebounce(fn) {
  var scheduled = false;
  return function() {
    if (!scheduled) {
      scheduled = true;
      setTimeout(function() {
        scheduled = false;
        fn();
      }, timeoutDuration);
    }
  };
}
var supportsMicroTasks = isBrowser && window.Promise;
var debounce = supportsMicroTasks ? microtaskDebounce : taskDebounce;
function isFunction$1(functionToCheck) {
  var getType = {};
  return functionToCheck && getType.toString.call(functionToCheck) === "[object Function]";
}
function getStyleComputedProperty(element, property) {
  if (element.nodeType !== 1) {
    return [];
  }
  var window2 = element.ownerDocument.defaultView;
  var css2 = window2.getComputedStyle(element, null);
  return property ? css2[property] : css2;
}
function getParentNode(element) {
  if (element.nodeName === "HTML") {
    return element;
  }
  return element.parentNode || element.host;
}
function getScrollParent(element) {
  if (!element) {
    return document.body;
  }
  switch (element.nodeName) {
    case "HTML":
    case "BODY":
      return element.ownerDocument.body;
    case "#document":
      return element.body;
  }
  var _getStyleComputedProp = getStyleComputedProperty(element), overflow = _getStyleComputedProp.overflow, overflowX = _getStyleComputedProp.overflowX, overflowY = _getStyleComputedProp.overflowY;
  if (/(auto|scroll|overlay)/.test(overflow + overflowY + overflowX)) {
    return element;
  }
  return getScrollParent(getParentNode(element));
}
function getReferenceNode(reference) {
  return reference && reference.referenceNode ? reference.referenceNode : reference;
}
var isIE11 = isBrowser && !!(window.MSInputMethodContext && document.documentMode);
var isIE10 = isBrowser && /MSIE 10/.test(navigator.userAgent);
function isIE(version2) {
  if (version2 === 11) {
    return isIE11;
  }
  if (version2 === 10) {
    return isIE10;
  }
  return isIE11 || isIE10;
}
function getOffsetParent(element) {
  if (!element) {
    return document.documentElement;
  }
  var noOffsetParent = isIE(10) ? document.body : null;
  var offsetParent = element.offsetParent || null;
  while (offsetParent === noOffsetParent && element.nextElementSibling) {
    offsetParent = (element = element.nextElementSibling).offsetParent;
  }
  var nodeName = offsetParent && offsetParent.nodeName;
  if (!nodeName || nodeName === "BODY" || nodeName === "HTML") {
    return element ? element.ownerDocument.documentElement : document.documentElement;
  }
  if (["TH", "TD", "TABLE"].indexOf(offsetParent.nodeName) !== -1 && getStyleComputedProperty(offsetParent, "position") === "static") {
    return getOffsetParent(offsetParent);
  }
  return offsetParent;
}
function isOffsetContainer(element) {
  var nodeName = element.nodeName;
  if (nodeName === "BODY") {
    return false;
  }
  return nodeName === "HTML" || getOffsetParent(element.firstElementChild) === element;
}
function getRoot(node) {
  if (node.parentNode !== null) {
    return getRoot(node.parentNode);
  }
  return node;
}
function findCommonOffsetParent(element1, element2) {
  if (!element1 || !element1.nodeType || !element2 || !element2.nodeType) {
    return document.documentElement;
  }
  var order = element1.compareDocumentPosition(element2) & Node.DOCUMENT_POSITION_FOLLOWING;
  var start = order ? element1 : element2;
  var end3 = order ? element2 : element1;
  var range = document.createRange();
  range.setStart(start, 0);
  range.setEnd(end3, 0);
  var commonAncestorContainer = range.commonAncestorContainer;
  if (element1 !== commonAncestorContainer && element2 !== commonAncestorContainer || start.contains(end3)) {
    if (isOffsetContainer(commonAncestorContainer)) {
      return commonAncestorContainer;
    }
    return getOffsetParent(commonAncestorContainer);
  }
  var element1root = getRoot(element1);
  if (element1root.host) {
    return findCommonOffsetParent(element1root.host, element2);
  } else {
    return findCommonOffsetParent(element1, getRoot(element2).host);
  }
}
function getScroll(element) {
  var side = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "top";
  var upperSide = side === "top" ? "scrollTop" : "scrollLeft";
  var nodeName = element.nodeName;
  if (nodeName === "BODY" || nodeName === "HTML") {
    var html = element.ownerDocument.documentElement;
    var scrollingElement = element.ownerDocument.scrollingElement || html;
    return scrollingElement[upperSide];
  }
  return element[upperSide];
}
function includeScroll(rect, element) {
  var subtract = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
  var scrollTop = getScroll(element, "top");
  var scrollLeft = getScroll(element, "left");
  var modifier = subtract ? -1 : 1;
  rect.top += scrollTop * modifier;
  rect.bottom += scrollTop * modifier;
  rect.left += scrollLeft * modifier;
  rect.right += scrollLeft * modifier;
  return rect;
}
function getBordersSize(styles2, axis) {
  var sideA = axis === "x" ? "Left" : "Top";
  var sideB = sideA === "Left" ? "Right" : "Bottom";
  return parseFloat(styles2["border" + sideA + "Width"]) + parseFloat(styles2["border" + sideB + "Width"]);
}
function getSize(axis, body, html, computedStyle) {
  return Math.max(body["offset" + axis], body["scroll" + axis], html["client" + axis], html["offset" + axis], html["scroll" + axis], isIE(10) ? parseInt(html["offset" + axis]) + parseInt(computedStyle["margin" + (axis === "Height" ? "Top" : "Left")]) + parseInt(computedStyle["margin" + (axis === "Height" ? "Bottom" : "Right")]) : 0);
}
function getWindowSizes(document2) {
  var body = document2.body;
  var html = document2.documentElement;
  var computedStyle = isIE(10) && getComputedStyle(html);
  return {
    height: getSize("Height", body, html, computedStyle),
    width: getSize("Width", body, html, computedStyle)
  };
}
var classCallCheck = function(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};
var createClass = function() {
  function defineProperties2(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor)
        descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }
  return function(Constructor, protoProps, staticProps) {
    if (protoProps)
      defineProperties2(Constructor.prototype, protoProps);
    if (staticProps)
      defineProperties2(Constructor, staticProps);
    return Constructor;
  };
}();
var defineProperty = function(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
};
var _extends = Object.assign || function(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];
    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }
  return target;
};
function getClientRect(offsets) {
  return _extends({}, offsets, {
    right: offsets.left + offsets.width,
    bottom: offsets.top + offsets.height
  });
}
function getBoundingClientRect(element) {
  var rect = {};
  try {
    if (isIE(10)) {
      rect = element.getBoundingClientRect();
      var scrollTop = getScroll(element, "top");
      var scrollLeft = getScroll(element, "left");
      rect.top += scrollTop;
      rect.left += scrollLeft;
      rect.bottom += scrollTop;
      rect.right += scrollLeft;
    } else {
      rect = element.getBoundingClientRect();
    }
  } catch (e) {
  }
  var result = {
    left: rect.left,
    top: rect.top,
    width: rect.right - rect.left,
    height: rect.bottom - rect.top
  };
  var sizes = element.nodeName === "HTML" ? getWindowSizes(element.ownerDocument) : {};
  var width = sizes.width || element.clientWidth || result.width;
  var height = sizes.height || element.clientHeight || result.height;
  var horizScrollbar = element.offsetWidth - width;
  var vertScrollbar = element.offsetHeight - height;
  if (horizScrollbar || vertScrollbar) {
    var styles2 = getStyleComputedProperty(element);
    horizScrollbar -= getBordersSize(styles2, "x");
    vertScrollbar -= getBordersSize(styles2, "y");
    result.width -= horizScrollbar;
    result.height -= vertScrollbar;
  }
  return getClientRect(result);
}
function getOffsetRectRelativeToArbitraryNode(children, parent) {
  var fixedPosition = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
  var isIE102 = isIE(10);
  var isHTML = parent.nodeName === "HTML";
  var childrenRect = getBoundingClientRect(children);
  var parentRect = getBoundingClientRect(parent);
  var scrollParent = getScrollParent(children);
  var styles2 = getStyleComputedProperty(parent);
  var borderTopWidth = parseFloat(styles2.borderTopWidth);
  var borderLeftWidth = parseFloat(styles2.borderLeftWidth);
  if (fixedPosition && isHTML) {
    parentRect.top = Math.max(parentRect.top, 0);
    parentRect.left = Math.max(parentRect.left, 0);
  }
  var offsets = getClientRect({
    top: childrenRect.top - parentRect.top - borderTopWidth,
    left: childrenRect.left - parentRect.left - borderLeftWidth,
    width: childrenRect.width,
    height: childrenRect.height
  });
  offsets.marginTop = 0;
  offsets.marginLeft = 0;
  if (!isIE102 && isHTML) {
    var marginTop = parseFloat(styles2.marginTop);
    var marginLeft = parseFloat(styles2.marginLeft);
    offsets.top -= borderTopWidth - marginTop;
    offsets.bottom -= borderTopWidth - marginTop;
    offsets.left -= borderLeftWidth - marginLeft;
    offsets.right -= borderLeftWidth - marginLeft;
    offsets.marginTop = marginTop;
    offsets.marginLeft = marginLeft;
  }
  if (isIE102 && !fixedPosition ? parent.contains(scrollParent) : parent === scrollParent && scrollParent.nodeName !== "BODY") {
    offsets = includeScroll(offsets, parent);
  }
  return offsets;
}
function getViewportOffsetRectRelativeToArtbitraryNode(element) {
  var excludeScroll = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
  var html = element.ownerDocument.documentElement;
  var relativeOffset = getOffsetRectRelativeToArbitraryNode(element, html);
  var width = Math.max(html.clientWidth, window.innerWidth || 0);
  var height = Math.max(html.clientHeight, window.innerHeight || 0);
  var scrollTop = !excludeScroll ? getScroll(html) : 0;
  var scrollLeft = !excludeScroll ? getScroll(html, "left") : 0;
  var offset2 = {
    top: scrollTop - relativeOffset.top + relativeOffset.marginTop,
    left: scrollLeft - relativeOffset.left + relativeOffset.marginLeft,
    width,
    height
  };
  return getClientRect(offset2);
}
function isFixed(element) {
  var nodeName = element.nodeName;
  if (nodeName === "BODY" || nodeName === "HTML") {
    return false;
  }
  if (getStyleComputedProperty(element, "position") === "fixed") {
    return true;
  }
  var parentNode = getParentNode(element);
  if (!parentNode) {
    return false;
  }
  return isFixed(parentNode);
}
function getFixedPositionOffsetParent(element) {
  if (!element || !element.parentElement || isIE()) {
    return document.documentElement;
  }
  var el = element.parentElement;
  while (el && getStyleComputedProperty(el, "transform") === "none") {
    el = el.parentElement;
  }
  return el || document.documentElement;
}
function getBoundaries(popper, reference, padding, boundariesElement) {
  var fixedPosition = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : false;
  var boundaries = { top: 0, left: 0 };
  var offsetParent = fixedPosition ? getFixedPositionOffsetParent(popper) : findCommonOffsetParent(popper, getReferenceNode(reference));
  if (boundariesElement === "viewport") {
    boundaries = getViewportOffsetRectRelativeToArtbitraryNode(offsetParent, fixedPosition);
  } else {
    var boundariesNode = void 0;
    if (boundariesElement === "scrollParent") {
      boundariesNode = getScrollParent(getParentNode(reference));
      if (boundariesNode.nodeName === "BODY") {
        boundariesNode = popper.ownerDocument.documentElement;
      }
    } else if (boundariesElement === "window") {
      boundariesNode = popper.ownerDocument.documentElement;
    } else {
      boundariesNode = boundariesElement;
    }
    var offsets = getOffsetRectRelativeToArbitraryNode(boundariesNode, offsetParent, fixedPosition);
    if (boundariesNode.nodeName === "HTML" && !isFixed(offsetParent)) {
      var _getWindowSizes = getWindowSizes(popper.ownerDocument), height = _getWindowSizes.height, width = _getWindowSizes.width;
      boundaries.top += offsets.top - offsets.marginTop;
      boundaries.bottom = height + offsets.top;
      boundaries.left += offsets.left - offsets.marginLeft;
      boundaries.right = width + offsets.left;
    } else {
      boundaries = offsets;
    }
  }
  padding = padding || 0;
  var isPaddingNumber = typeof padding === "number";
  boundaries.left += isPaddingNumber ? padding : padding.left || 0;
  boundaries.top += isPaddingNumber ? padding : padding.top || 0;
  boundaries.right -= isPaddingNumber ? padding : padding.right || 0;
  boundaries.bottom -= isPaddingNumber ? padding : padding.bottom || 0;
  return boundaries;
}
function getArea(_ref2) {
  var width = _ref2.width, height = _ref2.height;
  return width * height;
}
function computeAutoPlacement(placement, refRect, popper, reference, boundariesElement) {
  var padding = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : 0;
  if (placement.indexOf("auto") === -1) {
    return placement;
  }
  var boundaries = getBoundaries(popper, reference, padding, boundariesElement);
  var rects = {
    top: {
      width: boundaries.width,
      height: refRect.top - boundaries.top
    },
    right: {
      width: boundaries.right - refRect.right,
      height: boundaries.height
    },
    bottom: {
      width: boundaries.width,
      height: boundaries.bottom - refRect.bottom
    },
    left: {
      width: refRect.left - boundaries.left,
      height: boundaries.height
    }
  };
  var sortedAreas = Object.keys(rects).map(function(key) {
    return _extends({
      key
    }, rects[key], {
      area: getArea(rects[key])
    });
  }).sort(function(a, b) {
    return b.area - a.area;
  });
  var filteredAreas = sortedAreas.filter(function(_ref2) {
    var width = _ref2.width, height = _ref2.height;
    return width >= popper.clientWidth && height >= popper.clientHeight;
  });
  var computedPlacement = filteredAreas.length > 0 ? filteredAreas[0].key : sortedAreas[0].key;
  var variation = placement.split("-")[1];
  return computedPlacement + (variation ? "-" + variation : "");
}
function getReferenceOffsets(state, popper, reference) {
  var fixedPosition = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
  var commonOffsetParent = fixedPosition ? getFixedPositionOffsetParent(popper) : findCommonOffsetParent(popper, getReferenceNode(reference));
  return getOffsetRectRelativeToArbitraryNode(reference, commonOffsetParent, fixedPosition);
}
function getOuterSizes(element) {
  var window2 = element.ownerDocument.defaultView;
  var styles2 = window2.getComputedStyle(element);
  var x = parseFloat(styles2.marginTop || 0) + parseFloat(styles2.marginBottom || 0);
  var y = parseFloat(styles2.marginLeft || 0) + parseFloat(styles2.marginRight || 0);
  var result = {
    width: element.offsetWidth + y,
    height: element.offsetHeight + x
  };
  return result;
}
function getOppositePlacement(placement) {
  var hash = { left: "right", right: "left", bottom: "top", top: "bottom" };
  return placement.replace(/left|right|bottom|top/g, function(matched) {
    return hash[matched];
  });
}
function getPopperOffsets(popper, referenceOffsets, placement) {
  placement = placement.split("-")[0];
  var popperRect = getOuterSizes(popper);
  var popperOffsets = {
    width: popperRect.width,
    height: popperRect.height
  };
  var isHoriz = ["right", "left"].indexOf(placement) !== -1;
  var mainSide = isHoriz ? "top" : "left";
  var secondarySide = isHoriz ? "left" : "top";
  var measurement = isHoriz ? "height" : "width";
  var secondaryMeasurement = !isHoriz ? "height" : "width";
  popperOffsets[mainSide] = referenceOffsets[mainSide] + referenceOffsets[measurement] / 2 - popperRect[measurement] / 2;
  if (placement === secondarySide) {
    popperOffsets[secondarySide] = referenceOffsets[secondarySide] - popperRect[secondaryMeasurement];
  } else {
    popperOffsets[secondarySide] = referenceOffsets[getOppositePlacement(secondarySide)];
  }
  return popperOffsets;
}
function find(arr, check) {
  if (Array.prototype.find) {
    return arr.find(check);
  }
  return arr.filter(check)[0];
}
function findIndex(arr, prop, value) {
  if (Array.prototype.findIndex) {
    return arr.findIndex(function(cur) {
      return cur[prop] === value;
    });
  }
  var match = find(arr, function(obj) {
    return obj[prop] === value;
  });
  return arr.indexOf(match);
}
function runModifiers(modifiers2, data, ends) {
  var modifiersToRun = ends === void 0 ? modifiers2 : modifiers2.slice(0, findIndex(modifiers2, "name", ends));
  modifiersToRun.forEach(function(modifier) {
    if (modifier["function"]) {
      console.warn("`modifier.function` is deprecated, use `modifier.fn`!");
    }
    var fn = modifier["function"] || modifier.fn;
    if (modifier.enabled && isFunction$1(fn)) {
      data.offsets.popper = getClientRect(data.offsets.popper);
      data.offsets.reference = getClientRect(data.offsets.reference);
      data = fn(data, modifier);
    }
  });
  return data;
}
function update() {
  if (this.state.isDestroyed) {
    return;
  }
  var data = {
    instance: this,
    styles: {},
    arrowStyles: {},
    attributes: {},
    flipped: false,
    offsets: {}
  };
  data.offsets.reference = getReferenceOffsets(this.state, this.popper, this.reference, this.options.positionFixed);
  data.placement = computeAutoPlacement(this.options.placement, data.offsets.reference, this.popper, this.reference, this.options.modifiers.flip.boundariesElement, this.options.modifiers.flip.padding);
  data.originalPlacement = data.placement;
  data.positionFixed = this.options.positionFixed;
  data.offsets.popper = getPopperOffsets(this.popper, data.offsets.reference, data.placement);
  data.offsets.popper.position = this.options.positionFixed ? "fixed" : "absolute";
  data = runModifiers(this.modifiers, data);
  if (!this.state.isCreated) {
    this.state.isCreated = true;
    this.options.onCreate(data);
  } else {
    this.options.onUpdate(data);
  }
}
function isModifierEnabled(modifiers2, modifierName) {
  return modifiers2.some(function(_ref2) {
    var name2 = _ref2.name, enabled = _ref2.enabled;
    return enabled && name2 === modifierName;
  });
}
function getSupportedPropertyName(property) {
  var prefixes2 = [false, "ms", "Webkit", "Moz", "O"];
  var upperProp = property.charAt(0).toUpperCase() + property.slice(1);
  for (var i = 0; i < prefixes2.length; i++) {
    var prefix = prefixes2[i];
    var toCheck = prefix ? "" + prefix + upperProp : property;
    if (typeof document.body.style[toCheck] !== "undefined") {
      return toCheck;
    }
  }
  return null;
}
function destroy() {
  this.state.isDestroyed = true;
  if (isModifierEnabled(this.modifiers, "applyStyle")) {
    this.popper.removeAttribute("x-placement");
    this.popper.style.position = "";
    this.popper.style.top = "";
    this.popper.style.left = "";
    this.popper.style.right = "";
    this.popper.style.bottom = "";
    this.popper.style.willChange = "";
    this.popper.style[getSupportedPropertyName("transform")] = "";
  }
  this.disableEventListeners();
  if (this.options.removeOnDestroy) {
    this.popper.parentNode.removeChild(this.popper);
  }
  return this;
}
function getWindow(element) {
  var ownerDocument = element.ownerDocument;
  return ownerDocument ? ownerDocument.defaultView : window;
}
function attachToScrollParents(scrollParent, event, callback, scrollParents) {
  var isBody = scrollParent.nodeName === "BODY";
  var target = isBody ? scrollParent.ownerDocument.defaultView : scrollParent;
  target.addEventListener(event, callback, { passive: true });
  if (!isBody) {
    attachToScrollParents(getScrollParent(target.parentNode), event, callback, scrollParents);
  }
  scrollParents.push(target);
}
function setupEventListeners(reference, options, state, updateBound) {
  state.updateBound = updateBound;
  getWindow(reference).addEventListener("resize", state.updateBound, { passive: true });
  var scrollElement = getScrollParent(reference);
  attachToScrollParents(scrollElement, "scroll", state.updateBound, state.scrollParents);
  state.scrollElement = scrollElement;
  state.eventsEnabled = true;
  return state;
}
function enableEventListeners() {
  if (!this.state.eventsEnabled) {
    this.state = setupEventListeners(this.reference, this.options, this.state, this.scheduleUpdate);
  }
}
function removeEventListeners(reference, state) {
  getWindow(reference).removeEventListener("resize", state.updateBound);
  state.scrollParents.forEach(function(target) {
    target.removeEventListener("scroll", state.updateBound);
  });
  state.updateBound = null;
  state.scrollParents = [];
  state.scrollElement = null;
  state.eventsEnabled = false;
  return state;
}
function disableEventListeners() {
  if (this.state.eventsEnabled) {
    cancelAnimationFrame(this.scheduleUpdate);
    this.state = removeEventListeners(this.reference, this.state);
  }
}
function isNumeric(n2) {
  return n2 !== "" && !isNaN(parseFloat(n2)) && isFinite(n2);
}
function setStyles(element, styles2) {
  Object.keys(styles2).forEach(function(prop) {
    var unit = "";
    if (["width", "height", "top", "right", "bottom", "left"].indexOf(prop) !== -1 && isNumeric(styles2[prop])) {
      unit = "px";
    }
    element.style[prop] = styles2[prop] + unit;
  });
}
function setAttributes(element, attributes) {
  Object.keys(attributes).forEach(function(prop) {
    var value = attributes[prop];
    if (value !== false) {
      element.setAttribute(prop, attributes[prop]);
    } else {
      element.removeAttribute(prop);
    }
  });
}
function applyStyle(data) {
  setStyles(data.instance.popper, data.styles);
  setAttributes(data.instance.popper, data.attributes);
  if (data.arrowElement && Object.keys(data.arrowStyles).length) {
    setStyles(data.arrowElement, data.arrowStyles);
  }
  return data;
}
function applyStyleOnLoad(reference, popper, options, modifierOptions, state) {
  var referenceOffsets = getReferenceOffsets(state, popper, reference, options.positionFixed);
  var placement = computeAutoPlacement(options.placement, referenceOffsets, popper, reference, options.modifiers.flip.boundariesElement, options.modifiers.flip.padding);
  popper.setAttribute("x-placement", placement);
  setStyles(popper, { position: options.positionFixed ? "fixed" : "absolute" });
  return options;
}
function getRoundedOffsets(data, shouldRound) {
  var _data$offsets = data.offsets, popper = _data$offsets.popper, reference = _data$offsets.reference;
  var round = Math.round, floor = Math.floor;
  var noRound = function noRound2(v) {
    return v;
  };
  var referenceWidth = round(reference.width);
  var popperWidth = round(popper.width);
  var isVertical = ["left", "right"].indexOf(data.placement) !== -1;
  var isVariation = data.placement.indexOf("-") !== -1;
  var sameWidthParity = referenceWidth % 2 === popperWidth % 2;
  var bothOddWidth = referenceWidth % 2 === 1 && popperWidth % 2 === 1;
  var horizontalToInteger = !shouldRound ? noRound : isVertical || isVariation || sameWidthParity ? round : floor;
  var verticalToInteger = !shouldRound ? noRound : round;
  return {
    left: horizontalToInteger(bothOddWidth && !isVariation && shouldRound ? popper.left - 1 : popper.left),
    top: verticalToInteger(popper.top),
    bottom: verticalToInteger(popper.bottom),
    right: horizontalToInteger(popper.right)
  };
}
var isFirefox = isBrowser && /Firefox/i.test(navigator.userAgent);
function computeStyle(data, options) {
  var x = options.x, y = options.y;
  var popper = data.offsets.popper;
  var legacyGpuAccelerationOption = find(data.instance.modifiers, function(modifier) {
    return modifier.name === "applyStyle";
  }).gpuAcceleration;
  if (legacyGpuAccelerationOption !== void 0) {
    console.warn("WARNING: `gpuAcceleration` option moved to `computeStyle` modifier and will not be supported in future versions of Popper.js!");
  }
  var gpuAcceleration = legacyGpuAccelerationOption !== void 0 ? legacyGpuAccelerationOption : options.gpuAcceleration;
  var offsetParent = getOffsetParent(data.instance.popper);
  var offsetParentRect = getBoundingClientRect(offsetParent);
  var styles2 = {
    position: popper.position
  };
  var offsets = getRoundedOffsets(data, window.devicePixelRatio < 2 || !isFirefox);
  var sideA = x === "bottom" ? "top" : "bottom";
  var sideB = y === "right" ? "left" : "right";
  var prefixedProperty = getSupportedPropertyName("transform");
  var left = void 0, top = void 0;
  if (sideA === "bottom") {
    if (offsetParent.nodeName === "HTML") {
      top = -offsetParent.clientHeight + offsets.bottom;
    } else {
      top = -offsetParentRect.height + offsets.bottom;
    }
  } else {
    top = offsets.top;
  }
  if (sideB === "right") {
    if (offsetParent.nodeName === "HTML") {
      left = -offsetParent.clientWidth + offsets.right;
    } else {
      left = -offsetParentRect.width + offsets.right;
    }
  } else {
    left = offsets.left;
  }
  if (gpuAcceleration && prefixedProperty) {
    styles2[prefixedProperty] = "translate3d(" + left + "px, " + top + "px, 0)";
    styles2[sideA] = 0;
    styles2[sideB] = 0;
    styles2.willChange = "transform";
  } else {
    var invertTop = sideA === "bottom" ? -1 : 1;
    var invertLeft = sideB === "right" ? -1 : 1;
    styles2[sideA] = top * invertTop;
    styles2[sideB] = left * invertLeft;
    styles2.willChange = sideA + ", " + sideB;
  }
  var attributes = {
    "x-placement": data.placement
  };
  data.attributes = _extends({}, attributes, data.attributes);
  data.styles = _extends({}, styles2, data.styles);
  data.arrowStyles = _extends({}, data.offsets.arrow, data.arrowStyles);
  return data;
}
function isModifierRequired(modifiers2, requestingName, requestedName) {
  var requesting = find(modifiers2, function(_ref2) {
    var name2 = _ref2.name;
    return name2 === requestingName;
  });
  var isRequired = !!requesting && modifiers2.some(function(modifier) {
    return modifier.name === requestedName && modifier.enabled && modifier.order < requesting.order;
  });
  if (!isRequired) {
    var _requesting = "`" + requestingName + "`";
    var requested = "`" + requestedName + "`";
    console.warn(requested + " modifier is required by " + _requesting + " modifier in order to work, be sure to include it before " + _requesting + "!");
  }
  return isRequired;
}
function arrow(data, options) {
  var _data$offsets$arrow;
  if (!isModifierRequired(data.instance.modifiers, "arrow", "keepTogether")) {
    return data;
  }
  var arrowElement = options.element;
  if (typeof arrowElement === "string") {
    arrowElement = data.instance.popper.querySelector(arrowElement);
    if (!arrowElement) {
      return data;
    }
  } else {
    if (!data.instance.popper.contains(arrowElement)) {
      console.warn("WARNING: `arrow.element` must be child of its popper element!");
      return data;
    }
  }
  var placement = data.placement.split("-")[0];
  var _data$offsets = data.offsets, popper = _data$offsets.popper, reference = _data$offsets.reference;
  var isVertical = ["left", "right"].indexOf(placement) !== -1;
  var len = isVertical ? "height" : "width";
  var sideCapitalized = isVertical ? "Top" : "Left";
  var side = sideCapitalized.toLowerCase();
  var altSide = isVertical ? "left" : "top";
  var opSide = isVertical ? "bottom" : "right";
  var arrowElementSize = getOuterSizes(arrowElement)[len];
  if (reference[opSide] - arrowElementSize < popper[side]) {
    data.offsets.popper[side] -= popper[side] - (reference[opSide] - arrowElementSize);
  }
  if (reference[side] + arrowElementSize > popper[opSide]) {
    data.offsets.popper[side] += reference[side] + arrowElementSize - popper[opSide];
  }
  data.offsets.popper = getClientRect(data.offsets.popper);
  var center = reference[side] + reference[len] / 2 - arrowElementSize / 2;
  var css2 = getStyleComputedProperty(data.instance.popper);
  var popperMarginSide = parseFloat(css2["margin" + sideCapitalized]);
  var popperBorderSide = parseFloat(css2["border" + sideCapitalized + "Width"]);
  var sideValue = center - data.offsets.popper[side] - popperMarginSide - popperBorderSide;
  sideValue = Math.max(Math.min(popper[len] - arrowElementSize, sideValue), 0);
  data.arrowElement = arrowElement;
  data.offsets.arrow = (_data$offsets$arrow = {}, defineProperty(_data$offsets$arrow, side, Math.round(sideValue)), defineProperty(_data$offsets$arrow, altSide, ""), _data$offsets$arrow);
  return data;
}
function getOppositeVariation(variation) {
  if (variation === "end") {
    return "start";
  } else if (variation === "start") {
    return "end";
  }
  return variation;
}
var placements = ["auto-start", "auto", "auto-end", "top-start", "top", "top-end", "right-start", "right", "right-end", "bottom-end", "bottom", "bottom-start", "left-end", "left", "left-start"];
var validPlacements = placements.slice(3);
function clockwise(placement) {
  var counter2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
  var index = validPlacements.indexOf(placement);
  var arr = validPlacements.slice(index + 1).concat(validPlacements.slice(0, index));
  return counter2 ? arr.reverse() : arr;
}
var BEHAVIORS = {
  FLIP: "flip",
  CLOCKWISE: "clockwise",
  COUNTERCLOCKWISE: "counterclockwise"
};
function flip(data, options) {
  if (isModifierEnabled(data.instance.modifiers, "inner")) {
    return data;
  }
  if (data.flipped && data.placement === data.originalPlacement) {
    return data;
  }
  var boundaries = getBoundaries(data.instance.popper, data.instance.reference, options.padding, options.boundariesElement, data.positionFixed);
  var placement = data.placement.split("-")[0];
  var placementOpposite = getOppositePlacement(placement);
  var variation = data.placement.split("-")[1] || "";
  var flipOrder = [];
  switch (options.behavior) {
    case BEHAVIORS.FLIP:
      flipOrder = [placement, placementOpposite];
      break;
    case BEHAVIORS.CLOCKWISE:
      flipOrder = clockwise(placement);
      break;
    case BEHAVIORS.COUNTERCLOCKWISE:
      flipOrder = clockwise(placement, true);
      break;
    default:
      flipOrder = options.behavior;
  }
  flipOrder.forEach(function(step, index) {
    if (placement !== step || flipOrder.length === index + 1) {
      return data;
    }
    placement = data.placement.split("-")[0];
    placementOpposite = getOppositePlacement(placement);
    var popperOffsets = data.offsets.popper;
    var refOffsets = data.offsets.reference;
    var floor = Math.floor;
    var overlapsRef = placement === "left" && floor(popperOffsets.right) > floor(refOffsets.left) || placement === "right" && floor(popperOffsets.left) < floor(refOffsets.right) || placement === "top" && floor(popperOffsets.bottom) > floor(refOffsets.top) || placement === "bottom" && floor(popperOffsets.top) < floor(refOffsets.bottom);
    var overflowsLeft = floor(popperOffsets.left) < floor(boundaries.left);
    var overflowsRight = floor(popperOffsets.right) > floor(boundaries.right);
    var overflowsTop = floor(popperOffsets.top) < floor(boundaries.top);
    var overflowsBottom = floor(popperOffsets.bottom) > floor(boundaries.bottom);
    var overflowsBoundaries = placement === "left" && overflowsLeft || placement === "right" && overflowsRight || placement === "top" && overflowsTop || placement === "bottom" && overflowsBottom;
    var isVertical = ["top", "bottom"].indexOf(placement) !== -1;
    var flippedVariationByRef = !!options.flipVariations && (isVertical && variation === "start" && overflowsLeft || isVertical && variation === "end" && overflowsRight || !isVertical && variation === "start" && overflowsTop || !isVertical && variation === "end" && overflowsBottom);
    var flippedVariationByContent = !!options.flipVariationsByContent && (isVertical && variation === "start" && overflowsRight || isVertical && variation === "end" && overflowsLeft || !isVertical && variation === "start" && overflowsBottom || !isVertical && variation === "end" && overflowsTop);
    var flippedVariation = flippedVariationByRef || flippedVariationByContent;
    if (overlapsRef || overflowsBoundaries || flippedVariation) {
      data.flipped = true;
      if (overlapsRef || overflowsBoundaries) {
        placement = flipOrder[index + 1];
      }
      if (flippedVariation) {
        variation = getOppositeVariation(variation);
      }
      data.placement = placement + (variation ? "-" + variation : "");
      data.offsets.popper = _extends({}, data.offsets.popper, getPopperOffsets(data.instance.popper, data.offsets.reference, data.placement));
      data = runModifiers(data.instance.modifiers, data, "flip");
    }
  });
  return data;
}
function keepTogether(data) {
  var _data$offsets = data.offsets, popper = _data$offsets.popper, reference = _data$offsets.reference;
  var placement = data.placement.split("-")[0];
  var floor = Math.floor;
  var isVertical = ["top", "bottom"].indexOf(placement) !== -1;
  var side = isVertical ? "right" : "bottom";
  var opSide = isVertical ? "left" : "top";
  var measurement = isVertical ? "width" : "height";
  if (popper[side] < floor(reference[opSide])) {
    data.offsets.popper[opSide] = floor(reference[opSide]) - popper[measurement];
  }
  if (popper[opSide] > floor(reference[side])) {
    data.offsets.popper[opSide] = floor(reference[side]);
  }
  return data;
}
function toValue(str, measurement, popperOffsets, referenceOffsets) {
  var split = str.match(/((?:\-|\+)?\d*\.?\d*)(.*)/);
  var value = +split[1];
  var unit = split[2];
  if (!value) {
    return str;
  }
  if (unit.indexOf("%") === 0) {
    var element = void 0;
    switch (unit) {
      case "%p":
        element = popperOffsets;
        break;
      case "%":
      case "%r":
      default:
        element = referenceOffsets;
    }
    var rect = getClientRect(element);
    return rect[measurement] / 100 * value;
  } else if (unit === "vh" || unit === "vw") {
    var size = void 0;
    if (unit === "vh") {
      size = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
    } else {
      size = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
    }
    return size / 100 * value;
  } else {
    return value;
  }
}
function parseOffset(offset2, popperOffsets, referenceOffsets, basePlacement) {
  var offsets = [0, 0];
  var useHeight = ["right", "left"].indexOf(basePlacement) !== -1;
  var fragments = offset2.split(/(\+|\-)/).map(function(frag) {
    return frag.trim();
  });
  var divider = fragments.indexOf(find(fragments, function(frag) {
    return frag.search(/,|\s/) !== -1;
  }));
  if (fragments[divider] && fragments[divider].indexOf(",") === -1) {
    console.warn("Offsets separated by white space(s) are deprecated, use a comma (,) instead.");
  }
  var splitRegex = /\s*,\s*|\s+/;
  var ops = divider !== -1 ? [fragments.slice(0, divider).concat([fragments[divider].split(splitRegex)[0]]), [fragments[divider].split(splitRegex)[1]].concat(fragments.slice(divider + 1))] : [fragments];
  ops = ops.map(function(op, index) {
    var measurement = (index === 1 ? !useHeight : useHeight) ? "height" : "width";
    var mergeWithPrevious = false;
    return op.reduce(function(a, b) {
      if (a[a.length - 1] === "" && ["+", "-"].indexOf(b) !== -1) {
        a[a.length - 1] = b;
        mergeWithPrevious = true;
        return a;
      } else if (mergeWithPrevious) {
        a[a.length - 1] += b;
        mergeWithPrevious = false;
        return a;
      } else {
        return a.concat(b);
      }
    }, []).map(function(str) {
      return toValue(str, measurement, popperOffsets, referenceOffsets);
    });
  });
  ops.forEach(function(op, index) {
    op.forEach(function(frag, index2) {
      if (isNumeric(frag)) {
        offsets[index] += frag * (op[index2 - 1] === "-" ? -1 : 1);
      }
    });
  });
  return offsets;
}
function offset(data, _ref2) {
  var offset2 = _ref2.offset;
  var placement = data.placement, _data$offsets = data.offsets, popper = _data$offsets.popper, reference = _data$offsets.reference;
  var basePlacement = placement.split("-")[0];
  var offsets = void 0;
  if (isNumeric(+offset2)) {
    offsets = [+offset2, 0];
  } else {
    offsets = parseOffset(offset2, popper, reference, basePlacement);
  }
  if (basePlacement === "left") {
    popper.top += offsets[0];
    popper.left -= offsets[1];
  } else if (basePlacement === "right") {
    popper.top += offsets[0];
    popper.left += offsets[1];
  } else if (basePlacement === "top") {
    popper.left += offsets[0];
    popper.top -= offsets[1];
  } else if (basePlacement === "bottom") {
    popper.left += offsets[0];
    popper.top += offsets[1];
  }
  data.popper = popper;
  return data;
}
function preventOverflow(data, options) {
  var boundariesElement = options.boundariesElement || getOffsetParent(data.instance.popper);
  if (data.instance.reference === boundariesElement) {
    boundariesElement = getOffsetParent(boundariesElement);
  }
  var transformProp = getSupportedPropertyName("transform");
  var popperStyles = data.instance.popper.style;
  var top = popperStyles.top, left = popperStyles.left, transform = popperStyles[transformProp];
  popperStyles.top = "";
  popperStyles.left = "";
  popperStyles[transformProp] = "";
  var boundaries = getBoundaries(data.instance.popper, data.instance.reference, options.padding, boundariesElement, data.positionFixed);
  popperStyles.top = top;
  popperStyles.left = left;
  popperStyles[transformProp] = transform;
  options.boundaries = boundaries;
  var order = options.priority;
  var popper = data.offsets.popper;
  var check = {
    primary: function primary2(placement) {
      var value = popper[placement];
      if (popper[placement] < boundaries[placement] && !options.escapeWithReference) {
        value = Math.max(popper[placement], boundaries[placement]);
      }
      return defineProperty({}, placement, value);
    },
    secondary: function secondary2(placement) {
      var mainSide = placement === "right" ? "left" : "top";
      var value = popper[mainSide];
      if (popper[placement] > boundaries[placement] && !options.escapeWithReference) {
        value = Math.min(popper[mainSide], boundaries[placement] - (placement === "right" ? popper.width : popper.height));
      }
      return defineProperty({}, mainSide, value);
    }
  };
  order.forEach(function(placement) {
    var side = ["left", "top"].indexOf(placement) !== -1 ? "primary" : "secondary";
    popper = _extends({}, popper, check[side](placement));
  });
  data.offsets.popper = popper;
  return data;
}
function shift(data) {
  var placement = data.placement;
  var basePlacement = placement.split("-")[0];
  var shiftvariation = placement.split("-")[1];
  if (shiftvariation) {
    var _data$offsets = data.offsets, reference = _data$offsets.reference, popper = _data$offsets.popper;
    var isVertical = ["bottom", "top"].indexOf(basePlacement) !== -1;
    var side = isVertical ? "left" : "top";
    var measurement = isVertical ? "width" : "height";
    var shiftOffsets = {
      start: defineProperty({}, side, reference[side]),
      end: defineProperty({}, side, reference[side] + reference[measurement] - popper[measurement])
    };
    data.offsets.popper = _extends({}, popper, shiftOffsets[shiftvariation]);
  }
  return data;
}
function hide(data) {
  if (!isModifierRequired(data.instance.modifiers, "hide", "preventOverflow")) {
    return data;
  }
  var refRect = data.offsets.reference;
  var bound2 = find(data.instance.modifiers, function(modifier) {
    return modifier.name === "preventOverflow";
  }).boundaries;
  if (refRect.bottom < bound2.top || refRect.left > bound2.right || refRect.top > bound2.bottom || refRect.right < bound2.left) {
    if (data.hide === true) {
      return data;
    }
    data.hide = true;
    data.attributes["x-out-of-boundaries"] = "";
  } else {
    if (data.hide === false) {
      return data;
    }
    data.hide = false;
    data.attributes["x-out-of-boundaries"] = false;
  }
  return data;
}
function inner(data) {
  var placement = data.placement;
  var basePlacement = placement.split("-")[0];
  var _data$offsets = data.offsets, popper = _data$offsets.popper, reference = _data$offsets.reference;
  var isHoriz = ["left", "right"].indexOf(basePlacement) !== -1;
  var subtractLength = ["top", "left"].indexOf(basePlacement) === -1;
  popper[isHoriz ? "left" : "top"] = reference[basePlacement] - (subtractLength ? popper[isHoriz ? "width" : "height"] : 0);
  data.placement = getOppositePlacement(placement);
  data.offsets.popper = getClientRect(popper);
  return data;
}
var modifiers = {
  /**
   * Modifier used to shift the popper on the start or end of its reference
   * element.<br />
   * It will read the variation of the `placement` property.<br />
   * It can be one either `-end` or `-start`.
   * @memberof modifiers
   * @inner
   */
  shift: {
    /** @prop {number} order=100 - Index used to define the order of execution */
    order: 100,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: shift
  },
  /**
   * The `offset` modifier can shift your popper on both its axis.
   *
   * It accepts the following units:
   * - `px` or unit-less, interpreted as pixels
   * - `%` or `%r`, percentage relative to the length of the reference element
   * - `%p`, percentage relative to the length of the popper element
   * - `vw`, CSS viewport width unit
   * - `vh`, CSS viewport height unit
   *
   * For length is intended the main axis relative to the placement of the popper.<br />
   * This means that if the placement is `top` or `bottom`, the length will be the
   * `width`. In case of `left` or `right`, it will be the `height`.
   *
   * You can provide a single value (as `Number` or `String`), or a pair of values
   * as `String` divided by a comma or one (or more) white spaces.<br />
   * The latter is a deprecated method because it leads to confusion and will be
   * removed in v2.<br />
   * Additionally, it accepts additions and subtractions between different units.
   * Note that multiplications and divisions aren't supported.
   *
   * Valid examples are:
   * ```
   * 10
   * '10%'
   * '10, 10'
   * '10%, 10'
   * '10 + 10%'
   * '10 - 5vh + 3%'
   * '-10px + 5vh, 5px - 6%'
   * ```
   * > **NB**: If you desire to apply offsets to your poppers in a way that may make them overlap
   * > with their reference element, unfortunately, you will have to disable the `flip` modifier.
   * > You can read more on this at this [issue](https://github.com/FezVrasta/popper.js/issues/373).
   *
   * @memberof modifiers
   * @inner
   */
  offset: {
    /** @prop {number} order=200 - Index used to define the order of execution */
    order: 200,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: offset,
    /** @prop {Number|String} offset=0
     * The offset value as described in the modifier description
     */
    offset: 0
  },
  /**
   * Modifier used to prevent the popper from being positioned outside the boundary.
   *
   * A scenario exists where the reference itself is not within the boundaries.<br />
   * We can say it has "escaped the boundaries" — or just "escaped".<br />
   * In this case we need to decide whether the popper should either:
   *
   * - detach from the reference and remain "trapped" in the boundaries, or
   * - if it should ignore the boundary and "escape with its reference"
   *
   * When `escapeWithReference` is set to`true` and reference is completely
   * outside its boundaries, the popper will overflow (or completely leave)
   * the boundaries in order to remain attached to the edge of the reference.
   *
   * @memberof modifiers
   * @inner
   */
  preventOverflow: {
    /** @prop {number} order=300 - Index used to define the order of execution */
    order: 300,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: preventOverflow,
    /**
     * @prop {Array} [priority=['left','right','top','bottom']]
     * Popper will try to prevent overflow following these priorities by default,
     * then, it could overflow on the left and on top of the `boundariesElement`
     */
    priority: ["left", "right", "top", "bottom"],
    /**
     * @prop {number} padding=5
     * Amount of pixel used to define a minimum distance between the boundaries
     * and the popper. This makes sure the popper always has a little padding
     * between the edges of its container
     */
    padding: 5,
    /**
     * @prop {String|HTMLElement} boundariesElement='scrollParent'
     * Boundaries used by the modifier. Can be `scrollParent`, `window`,
     * `viewport` or any DOM element.
     */
    boundariesElement: "scrollParent"
  },
  /**
   * Modifier used to make sure the reference and its popper stay near each other
   * without leaving any gap between the two. Especially useful when the arrow is
   * enabled and you want to ensure that it points to its reference element.
   * It cares only about the first axis. You can still have poppers with margin
   * between the popper and its reference element.
   * @memberof modifiers
   * @inner
   */
  keepTogether: {
    /** @prop {number} order=400 - Index used to define the order of execution */
    order: 400,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: keepTogether
  },
  /**
   * This modifier is used to move the `arrowElement` of the popper to make
   * sure it is positioned between the reference element and its popper element.
   * It will read the outer size of the `arrowElement` node to detect how many
   * pixels of conjunction are needed.
   *
   * It has no effect if no `arrowElement` is provided.
   * @memberof modifiers
   * @inner
   */
  arrow: {
    /** @prop {number} order=500 - Index used to define the order of execution */
    order: 500,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: arrow,
    /** @prop {String|HTMLElement} element='[x-arrow]' - Selector or node used as arrow */
    element: "[x-arrow]"
  },
  /**
   * Modifier used to flip the popper's placement when it starts to overlap its
   * reference element.
   *
   * Requires the `preventOverflow` modifier before it in order to work.
   *
   * **NOTE:** this modifier will interrupt the current update cycle and will
   * restart it if it detects the need to flip the placement.
   * @memberof modifiers
   * @inner
   */
  flip: {
    /** @prop {number} order=600 - Index used to define the order of execution */
    order: 600,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: flip,
    /**
     * @prop {String|Array} behavior='flip'
     * The behavior used to change the popper's placement. It can be one of
     * `flip`, `clockwise`, `counterclockwise` or an array with a list of valid
     * placements (with optional variations)
     */
    behavior: "flip",
    /**
     * @prop {number} padding=5
     * The popper will flip if it hits the edges of the `boundariesElement`
     */
    padding: 5,
    /**
     * @prop {String|HTMLElement} boundariesElement='viewport'
     * The element which will define the boundaries of the popper position.
     * The popper will never be placed outside of the defined boundaries
     * (except if `keepTogether` is enabled)
     */
    boundariesElement: "viewport",
    /**
     * @prop {Boolean} flipVariations=false
     * The popper will switch placement variation between `-start` and `-end` when
     * the reference element overlaps its boundaries.
     *
     * The original placement should have a set variation.
     */
    flipVariations: false,
    /**
     * @prop {Boolean} flipVariationsByContent=false
     * The popper will switch placement variation between `-start` and `-end` when
     * the popper element overlaps its reference boundaries.
     *
     * The original placement should have a set variation.
     */
    flipVariationsByContent: false
  },
  /**
   * Modifier used to make the popper flow toward the inner of the reference element.
   * By default, when this modifier is disabled, the popper will be placed outside
   * the reference element.
   * @memberof modifiers
   * @inner
   */
  inner: {
    /** @prop {number} order=700 - Index used to define the order of execution */
    order: 700,
    /** @prop {Boolean} enabled=false - Whether the modifier is enabled or not */
    enabled: false,
    /** @prop {ModifierFn} */
    fn: inner
  },
  /**
   * Modifier used to hide the popper when its reference element is outside of the
   * popper boundaries. It will set a `x-out-of-boundaries` attribute which can
   * be used to hide with a CSS selector the popper when its reference is
   * out of boundaries.
   *
   * Requires the `preventOverflow` modifier before it in order to work.
   * @memberof modifiers
   * @inner
   */
  hide: {
    /** @prop {number} order=800 - Index used to define the order of execution */
    order: 800,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: hide
  },
  /**
   * Computes the style that will be applied to the popper element to gets
   * properly positioned.
   *
   * Note that this modifier will not touch the DOM, it just prepares the styles
   * so that `applyStyle` modifier can apply it. This separation is useful
   * in case you need to replace `applyStyle` with a custom implementation.
   *
   * This modifier has `850` as `order` value to maintain backward compatibility
   * with previous versions of Popper.js. Expect the modifiers ordering method
   * to change in future major versions of the library.
   *
   * @memberof modifiers
   * @inner
   */
  computeStyle: {
    /** @prop {number} order=850 - Index used to define the order of execution */
    order: 850,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: computeStyle,
    /**
     * @prop {Boolean} gpuAcceleration=true
     * If true, it uses the CSS 3D transformation to position the popper.
     * Otherwise, it will use the `top` and `left` properties
     */
    gpuAcceleration: true,
    /**
     * @prop {string} [x='bottom']
     * Where to anchor the X axis (`bottom` or `top`). AKA X offset origin.
     * Change this if your popper should grow in a direction different from `bottom`
     */
    x: "bottom",
    /**
     * @prop {string} [x='left']
     * Where to anchor the Y axis (`left` or `right`). AKA Y offset origin.
     * Change this if your popper should grow in a direction different from `right`
     */
    y: "right"
  },
  /**
   * Applies the computed styles to the popper element.
   *
   * All the DOM manipulations are limited to this modifier. This is useful in case
   * you want to integrate Popper.js inside a framework or view library and you
   * want to delegate all the DOM manipulations to it.
   *
   * Note that if you disable this modifier, you must make sure the popper element
   * has its position set to `absolute` before Popper.js can do its work!
   *
   * Just disable this modifier and define your own to achieve the desired effect.
   *
   * @memberof modifiers
   * @inner
   */
  applyStyle: {
    /** @prop {number} order=900 - Index used to define the order of execution */
    order: 900,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: applyStyle,
    /** @prop {Function} */
    onLoad: applyStyleOnLoad,
    /**
     * @deprecated since version 1.10.0, the property moved to `computeStyle` modifier
     * @prop {Boolean} gpuAcceleration=true
     * If true, it uses the CSS 3D transformation to position the popper.
     * Otherwise, it will use the `top` and `left` properties
     */
    gpuAcceleration: void 0
  }
};
var Defaults = {
  /**
   * Popper's placement.
   * @prop {Popper.placements} placement='bottom'
   */
  placement: "bottom",
  /**
   * Set this to true if you want popper to position it self in 'fixed' mode
   * @prop {Boolean} positionFixed=false
   */
  positionFixed: false,
  /**
   * Whether events (resize, scroll) are initially enabled.
   * @prop {Boolean} eventsEnabled=true
   */
  eventsEnabled: true,
  /**
   * Set to true if you want to automatically remove the popper when
   * you call the `destroy` method.
   * @prop {Boolean} removeOnDestroy=false
   */
  removeOnDestroy: false,
  /**
   * Callback called when the popper is created.<br />
   * By default, it is set to no-op.<br />
   * Access Popper.js instance with `data.instance`.
   * @prop {onCreate}
   */
  onCreate: function onCreate() {
  },
  /**
   * Callback called when the popper is updated. This callback is not called
   * on the initialization/creation of the popper, but only on subsequent
   * updates.<br />
   * By default, it is set to no-op.<br />
   * Access Popper.js instance with `data.instance`.
   * @prop {onUpdate}
   */
  onUpdate: function onUpdate() {
  },
  /**
   * List of modifiers used to modify the offsets before they are applied to the popper.
   * They provide most of the functionalities of Popper.js.
   * @prop {modifiers}
   */
  modifiers
};
var Popper$3 = function() {
  function Popper2(reference, popper) {
    var _this = this;
    var options = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
    classCallCheck(this, Popper2);
    this.scheduleUpdate = function() {
      return requestAnimationFrame(_this.update);
    };
    this.update = debounce(this.update.bind(this));
    this.options = _extends({}, Popper2.Defaults, options);
    this.state = {
      isDestroyed: false,
      isCreated: false,
      scrollParents: []
    };
    this.reference = reference && reference.jquery ? reference[0] : reference;
    this.popper = popper && popper.jquery ? popper[0] : popper;
    this.options.modifiers = {};
    Object.keys(_extends({}, Popper2.Defaults.modifiers, options.modifiers)).forEach(function(name2) {
      _this.options.modifiers[name2] = _extends({}, Popper2.Defaults.modifiers[name2] || {}, options.modifiers ? options.modifiers[name2] : {});
    });
    this.modifiers = Object.keys(this.options.modifiers).map(function(name2) {
      return _extends({
        name: name2
      }, _this.options.modifiers[name2]);
    }).sort(function(a, b) {
      return a.order - b.order;
    });
    this.modifiers.forEach(function(modifierOptions) {
      if (modifierOptions.enabled && isFunction$1(modifierOptions.onLoad)) {
        modifierOptions.onLoad(_this.reference, _this.popper, _this.options, modifierOptions, _this.state);
      }
    });
    this.update();
    var eventsEnabled = this.options.eventsEnabled;
    if (eventsEnabled) {
      this.enableEventListeners();
    }
    this.state.eventsEnabled = eventsEnabled;
  }
  createClass(Popper2, [{
    key: "update",
    value: function update$$1() {
      return update.call(this);
    }
  }, {
    key: "destroy",
    value: function destroy$$1() {
      return destroy.call(this);
    }
  }, {
    key: "enableEventListeners",
    value: function enableEventListeners$$1() {
      return enableEventListeners.call(this);
    }
  }, {
    key: "disableEventListeners",
    value: function disableEventListeners$$1() {
      return disableEventListeners.call(this);
    }
    /**
     * Schedules an update. It will run on the next UI update available.
     * @method scheduleUpdate
     * @memberof Popper
     */
    /**
     * Collection of utilities useful when writing custom modifiers.
     * Starting from version 1.7, this method is available only if you
     * include `popper-utils.js` before `popper.js`.
     *
     * **DEPRECATION**: This way to access PopperUtils is deprecated
     * and will be removed in v2! Use the PopperUtils module directly instead.
     * Due to the high instability of the methods contained in Utils, we can't
     * guarantee them to follow semver. Use them at your own risk!
     * @static
     * @private
     * @type {Object}
     * @deprecated since version 1.8
     * @member Utils
     * @memberof Popper
     */
  }]);
  return Popper2;
}();
Popper$3.Utils = (typeof window !== "undefined" ? window : global).PopperUtils;
Popper$3.placements = placements;
Popper$3.Defaults = Defaults;
const PopperJs = Popper$3;
function ownKeys$b(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread2$1(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$b(Object(source), true).forEach(function(key) {
      _defineProperty$x(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$b(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _typeof$1(obj) {
  "@babel/helpers - typeof";
  return _typeof$1 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj2) {
    return typeof obj2;
  } : function(obj2) {
    return obj2 && "function" == typeof Symbol && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof$1(obj);
}
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor)
      descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps)
    _defineProperties(Constructor.prototype, protoProps);
  if (staticProps)
    _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _defineProperty$x(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray$1(arr, i) || _nonIterableRest();
}
function _toConsumableArray$1(arr) {
  return _arrayWithoutHoles$1(arr) || _iterableToArray$1(arr) || _unsupportedIterableToArray$1(arr) || _nonIterableSpread$1();
}
function _arrayWithoutHoles$1(arr) {
  if (Array.isArray(arr))
    return _arrayLikeToArray$1(arr);
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr))
    return arr;
}
function _iterableToArray$1(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null)
    return Array.from(iter);
}
function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
  if (_i == null)
    return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _s, _e;
  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);
      if (i && _arr.length === i)
        break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null)
        _i["return"]();
    } finally {
      if (_d)
        throw _e;
    }
  }
  return _arr;
}
function _unsupportedIterableToArray$1(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray$1(o, minLen);
  var n2 = Object.prototype.toString.call(o).slice(8, -1);
  if (n2 === "Object" && o.constructor)
    n2 = o.constructor.name;
  if (n2 === "Map" || n2 === "Set")
    return Array.from(o);
  if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
    return _arrayLikeToArray$1(o, minLen);
}
function _arrayLikeToArray$1(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
function _nonIterableSpread$1() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
var noop = function noop2() {
};
var _WINDOW = {};
var _DOCUMENT = {};
var _MUTATION_OBSERVER = null;
var _PERFORMANCE = {
  mark: noop,
  measure: noop
};
try {
  if (typeof window !== "undefined")
    _WINDOW = window;
  if (typeof document !== "undefined")
    _DOCUMENT = document;
  if (typeof MutationObserver !== "undefined")
    _MUTATION_OBSERVER = MutationObserver;
  if (typeof performance !== "undefined")
    _PERFORMANCE = performance;
} catch (e) {
}
var _ref = _WINDOW.navigator || {}, _ref$userAgent = _ref.userAgent, userAgent = _ref$userAgent === void 0 ? "" : _ref$userAgent;
var WINDOW = _WINDOW;
var DOCUMENT = _DOCUMENT;
var MUTATION_OBSERVER = _MUTATION_OBSERVER;
var PERFORMANCE = _PERFORMANCE;
!!WINDOW.document;
var IS_DOM = !!DOCUMENT.documentElement && !!DOCUMENT.head && typeof DOCUMENT.addEventListener === "function" && typeof DOCUMENT.createElement === "function";
var IS_IE = ~userAgent.indexOf("MSIE") || ~userAgent.indexOf("Trident/");
var _familyProxy, _familyProxy2, _familyProxy3, _familyProxy4, _familyProxy5;
var NAMESPACE_IDENTIFIER = "___FONT_AWESOME___";
var UNITS_IN_GRID = 16;
var DEFAULT_CSS_PREFIX = "fa";
var DEFAULT_REPLACEMENT_CLASS = "svg-inline--fa";
var DATA_FA_I2SVG = "data-fa-i2svg";
var DATA_FA_PSEUDO_ELEMENT = "data-fa-pseudo-element";
var DATA_FA_PSEUDO_ELEMENT_PENDING = "data-fa-pseudo-element-pending";
var DATA_PREFIX = "data-prefix";
var DATA_ICON = "data-icon";
var HTML_CLASS_I2SVG_BASE_CLASS = "fontawesome-i2svg";
var MUTATION_APPROACH_ASYNC = "async";
var TAGNAMES_TO_SKIP_FOR_PSEUDOELEMENTS = ["HTML", "HEAD", "STYLE", "SCRIPT"];
var PRODUCTION$1 = function() {
  try {
    return true;
  } catch (e) {
    return false;
  }
}();
var FAMILY_CLASSIC = "classic";
var FAMILY_SHARP = "sharp";
var FAMILIES = [FAMILY_CLASSIC, FAMILY_SHARP];
function familyProxy(obj) {
  return new Proxy(obj, {
    get: function get3(target, prop) {
      return prop in target ? target[prop] : target[FAMILY_CLASSIC];
    }
  });
}
var PREFIX_TO_STYLE = familyProxy((_familyProxy = {}, _defineProperty$x(_familyProxy, FAMILY_CLASSIC, {
  "fa": "solid",
  "fas": "solid",
  "fa-solid": "solid",
  "far": "regular",
  "fa-regular": "regular",
  "fal": "light",
  "fa-light": "light",
  "fat": "thin",
  "fa-thin": "thin",
  "fad": "duotone",
  "fa-duotone": "duotone",
  "fab": "brands",
  "fa-brands": "brands",
  "fak": "kit",
  "fa-kit": "kit"
}), _defineProperty$x(_familyProxy, FAMILY_SHARP, {
  "fa": "solid",
  "fass": "solid",
  "fa-solid": "solid",
  "fasr": "regular",
  "fa-regular": "regular",
  "fasl": "light",
  "fa-light": "light"
}), _familyProxy));
var STYLE_TO_PREFIX = familyProxy((_familyProxy2 = {}, _defineProperty$x(_familyProxy2, FAMILY_CLASSIC, {
  "solid": "fas",
  "regular": "far",
  "light": "fal",
  "thin": "fat",
  "duotone": "fad",
  "brands": "fab",
  "kit": "fak"
}), _defineProperty$x(_familyProxy2, FAMILY_SHARP, {
  "solid": "fass",
  "regular": "fasr",
  "light": "fasl"
}), _familyProxy2));
var PREFIX_TO_LONG_STYLE = familyProxy((_familyProxy3 = {}, _defineProperty$x(_familyProxy3, FAMILY_CLASSIC, {
  "fab": "fa-brands",
  "fad": "fa-duotone",
  "fak": "fa-kit",
  "fal": "fa-light",
  "far": "fa-regular",
  "fas": "fa-solid",
  "fat": "fa-thin"
}), _defineProperty$x(_familyProxy3, FAMILY_SHARP, {
  "fass": "fa-solid",
  "fasr": "fa-regular",
  "fasl": "fa-light"
}), _familyProxy3));
var LONG_STYLE_TO_PREFIX = familyProxy((_familyProxy4 = {}, _defineProperty$x(_familyProxy4, FAMILY_CLASSIC, {
  "fa-brands": "fab",
  "fa-duotone": "fad",
  "fa-kit": "fak",
  "fa-light": "fal",
  "fa-regular": "far",
  "fa-solid": "fas",
  "fa-thin": "fat"
}), _defineProperty$x(_familyProxy4, FAMILY_SHARP, {
  "fa-solid": "fass",
  "fa-regular": "fasr",
  "fa-light": "fasl"
}), _familyProxy4));
var ICON_SELECTION_SYNTAX_PATTERN = /fa(s|r|l|t|d|b|k|ss|sr|sl)?[\-\ ]/;
var LAYERS_TEXT_CLASSNAME = "fa-layers-text";
var FONT_FAMILY_PATTERN = /Font ?Awesome ?([56 ]*)(Solid|Regular|Light|Thin|Duotone|Brands|Free|Pro|Sharp|Kit)?.*/i;
var FONT_WEIGHT_TO_PREFIX = familyProxy((_familyProxy5 = {}, _defineProperty$x(_familyProxy5, FAMILY_CLASSIC, {
  "900": "fas",
  "400": "far",
  "normal": "far",
  "300": "fal",
  "100": "fat"
}), _defineProperty$x(_familyProxy5, FAMILY_SHARP, {
  "900": "fass",
  "400": "fasr",
  "300": "fasl"
}), _familyProxy5));
var oneToTen = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
var oneToTwenty = oneToTen.concat([11, 12, 13, 14, 15, 16, 17, 18, 19, 20]);
var ATTRIBUTES_WATCHED_FOR_MUTATION = ["class", "data-prefix", "data-icon", "data-fa-transform", "data-fa-mask"];
var DUOTONE_CLASSES = {
  GROUP: "duotone-group",
  SWAP_OPACITY: "swap-opacity",
  PRIMARY: "primary",
  SECONDARY: "secondary"
};
var prefixes = /* @__PURE__ */ new Set();
Object.keys(STYLE_TO_PREFIX[FAMILY_CLASSIC]).map(prefixes.add.bind(prefixes));
Object.keys(STYLE_TO_PREFIX[FAMILY_SHARP]).map(prefixes.add.bind(prefixes));
var RESERVED_CLASSES = [].concat(FAMILIES, _toConsumableArray$1(prefixes), ["2xs", "xs", "sm", "lg", "xl", "2xl", "beat", "border", "fade", "beat-fade", "bounce", "flip-both", "flip-horizontal", "flip-vertical", "flip", "fw", "inverse", "layers-counter", "layers-text", "layers", "li", "pull-left", "pull-right", "pulse", "rotate-180", "rotate-270", "rotate-90", "rotate-by", "shake", "spin-pulse", "spin-reverse", "spin", "stack-1x", "stack-2x", "stack", "ul", DUOTONE_CLASSES.GROUP, DUOTONE_CLASSES.SWAP_OPACITY, DUOTONE_CLASSES.PRIMARY, DUOTONE_CLASSES.SECONDARY]).concat(oneToTen.map(function(n2) {
  return "".concat(n2, "x");
})).concat(oneToTwenty.map(function(n2) {
  return "w-".concat(n2);
}));
var initial = WINDOW.FontAwesomeConfig || {};
function getAttrConfig(attr) {
  var element = DOCUMENT.querySelector("script[" + attr + "]");
  if (element) {
    return element.getAttribute(attr);
  }
}
function coerce(val) {
  if (val === "")
    return true;
  if (val === "false")
    return false;
  if (val === "true")
    return true;
  return val;
}
if (DOCUMENT && typeof DOCUMENT.querySelector === "function") {
  var attrs = [["data-family-prefix", "familyPrefix"], ["data-css-prefix", "cssPrefix"], ["data-family-default", "familyDefault"], ["data-style-default", "styleDefault"], ["data-replacement-class", "replacementClass"], ["data-auto-replace-svg", "autoReplaceSvg"], ["data-auto-add-css", "autoAddCss"], ["data-auto-a11y", "autoA11y"], ["data-search-pseudo-elements", "searchPseudoElements"], ["data-observe-mutations", "observeMutations"], ["data-mutate-approach", "mutateApproach"], ["data-keep-original-source", "keepOriginalSource"], ["data-measure-performance", "measurePerformance"], ["data-show-missing-icons", "showMissingIcons"]];
  attrs.forEach(function(_ref2) {
    var _ref22 = _slicedToArray(_ref2, 2), attr = _ref22[0], key = _ref22[1];
    var val = coerce(getAttrConfig(attr));
    if (val !== void 0 && val !== null) {
      initial[key] = val;
    }
  });
}
var _default = {
  styleDefault: "solid",
  familyDefault: "classic",
  cssPrefix: DEFAULT_CSS_PREFIX,
  replacementClass: DEFAULT_REPLACEMENT_CLASS,
  autoReplaceSvg: true,
  autoAddCss: true,
  autoA11y: true,
  searchPseudoElements: false,
  observeMutations: true,
  mutateApproach: "async",
  keepOriginalSource: true,
  measurePerformance: false,
  showMissingIcons: true
};
if (initial.familyPrefix) {
  initial.cssPrefix = initial.familyPrefix;
}
var _config = _objectSpread2$1(_objectSpread2$1({}, _default), initial);
if (!_config.autoReplaceSvg)
  _config.observeMutations = false;
var config = {};
Object.keys(_default).forEach(function(key) {
  Object.defineProperty(config, key, {
    enumerable: true,
    set: function set3(val) {
      _config[key] = val;
      _onChangeCb.forEach(function(cb) {
        return cb(config);
      });
    },
    get: function get3() {
      return _config[key];
    }
  });
});
Object.defineProperty(config, "familyPrefix", {
  enumerable: true,
  set: function set(val) {
    _config.cssPrefix = val;
    _onChangeCb.forEach(function(cb) {
      return cb(config);
    });
  },
  get: function get2() {
    return _config.cssPrefix;
  }
});
WINDOW.FontAwesomeConfig = config;
var _onChangeCb = [];
function onChange(cb) {
  _onChangeCb.push(cb);
  return function() {
    _onChangeCb.splice(_onChangeCb.indexOf(cb), 1);
  };
}
var d = UNITS_IN_GRID;
var meaninglessTransform = {
  size: 16,
  x: 0,
  y: 0,
  rotate: 0,
  flipX: false,
  flipY: false
};
function insertCss(css2) {
  if (!css2 || !IS_DOM) {
    return;
  }
  var style = DOCUMENT.createElement("style");
  style.setAttribute("type", "text/css");
  style.innerHTML = css2;
  var headChildren = DOCUMENT.head.childNodes;
  var beforeChild = null;
  for (var i = headChildren.length - 1; i > -1; i--) {
    var child = headChildren[i];
    var tagName = (child.tagName || "").toUpperCase();
    if (["STYLE", "LINK"].indexOf(tagName) > -1) {
      beforeChild = child;
    }
  }
  DOCUMENT.head.insertBefore(style, beforeChild);
  return css2;
}
var idPool = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
function nextUniqueId() {
  var size = 12;
  var id = "";
  while (size-- > 0) {
    id += idPool[Math.random() * 62 | 0];
  }
  return id;
}
function toArray(obj) {
  var array = [];
  for (var i = (obj || []).length >>> 0; i--; ) {
    array[i] = obj[i];
  }
  return array;
}
function classArray(node) {
  if (node.classList) {
    return toArray(node.classList);
  } else {
    return (node.getAttribute("class") || "").split(" ").filter(function(i) {
      return i;
    });
  }
}
function htmlEscape(str) {
  return "".concat(str).replace(/&/g, "&amp;").replace(/"/g, "&quot;").replace(/'/g, "&#39;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
}
function joinAttributes(attributes) {
  return Object.keys(attributes || {}).reduce(function(acc, attributeName) {
    return acc + "".concat(attributeName, '="').concat(htmlEscape(attributes[attributeName]), '" ');
  }, "").trim();
}
function joinStyles(styles2) {
  return Object.keys(styles2 || {}).reduce(function(acc, styleName) {
    return acc + "".concat(styleName, ": ").concat(styles2[styleName].trim(), ";");
  }, "");
}
function transformIsMeaningful(transform) {
  return transform.size !== meaninglessTransform.size || transform.x !== meaninglessTransform.x || transform.y !== meaninglessTransform.y || transform.rotate !== meaninglessTransform.rotate || transform.flipX || transform.flipY;
}
function transformForSvg(_ref2) {
  var transform = _ref2.transform, containerWidth = _ref2.containerWidth, iconWidth = _ref2.iconWidth;
  var outer = {
    transform: "translate(".concat(containerWidth / 2, " 256)")
  };
  var innerTranslate = "translate(".concat(transform.x * 32, ", ").concat(transform.y * 32, ") ");
  var innerScale = "scale(".concat(transform.size / 16 * (transform.flipX ? -1 : 1), ", ").concat(transform.size / 16 * (transform.flipY ? -1 : 1), ") ");
  var innerRotate = "rotate(".concat(transform.rotate, " 0 0)");
  var inner2 = {
    transform: "".concat(innerTranslate, " ").concat(innerScale, " ").concat(innerRotate)
  };
  var path = {
    transform: "translate(".concat(iconWidth / 2 * -1, " -256)")
  };
  return {
    outer,
    inner: inner2,
    path
  };
}
function transformForCss(_ref2) {
  var transform = _ref2.transform, _ref2$width = _ref2.width, width = _ref2$width === void 0 ? UNITS_IN_GRID : _ref2$width, _ref2$height = _ref2.height, height = _ref2$height === void 0 ? UNITS_IN_GRID : _ref2$height, _ref2$startCentered = _ref2.startCentered, startCentered = _ref2$startCentered === void 0 ? false : _ref2$startCentered;
  var val = "";
  if (startCentered && IS_IE) {
    val += "translate(".concat(transform.x / d - width / 2, "em, ").concat(transform.y / d - height / 2, "em) ");
  } else if (startCentered) {
    val += "translate(calc(-50% + ".concat(transform.x / d, "em), calc(-50% + ").concat(transform.y / d, "em)) ");
  } else {
    val += "translate(".concat(transform.x / d, "em, ").concat(transform.y / d, "em) ");
  }
  val += "scale(".concat(transform.size / d * (transform.flipX ? -1 : 1), ", ").concat(transform.size / d * (transform.flipY ? -1 : 1), ") ");
  val += "rotate(".concat(transform.rotate, "deg) ");
  return val;
}
var baseStyles = ':root, :host {\n  --fa-font-solid: normal 900 1em/1 "Font Awesome 6 Solid";\n  --fa-font-regular: normal 400 1em/1 "Font Awesome 6 Regular";\n  --fa-font-light: normal 300 1em/1 "Font Awesome 6 Light";\n  --fa-font-thin: normal 100 1em/1 "Font Awesome 6 Thin";\n  --fa-font-duotone: normal 900 1em/1 "Font Awesome 6 Duotone";\n  --fa-font-sharp-solid: normal 900 1em/1 "Font Awesome 6 Sharp";\n  --fa-font-sharp-regular: normal 400 1em/1 "Font Awesome 6 Sharp";\n  --fa-font-sharp-light: normal 300 1em/1 "Font Awesome 6 Sharp";\n  --fa-font-brands: normal 400 1em/1 "Font Awesome 6 Brands";\n}\n\nsvg:not(:root).svg-inline--fa, svg:not(:host).svg-inline--fa {\n  overflow: visible;\n  box-sizing: content-box;\n}\n\n.svg-inline--fa {\n  display: var(--fa-display, inline-block);\n  height: 1em;\n  overflow: visible;\n  vertical-align: -0.125em;\n}\n.svg-inline--fa.fa-2xs {\n  vertical-align: 0.1em;\n}\n.svg-inline--fa.fa-xs {\n  vertical-align: 0em;\n}\n.svg-inline--fa.fa-sm {\n  vertical-align: -0.0714285705em;\n}\n.svg-inline--fa.fa-lg {\n  vertical-align: -0.2em;\n}\n.svg-inline--fa.fa-xl {\n  vertical-align: -0.25em;\n}\n.svg-inline--fa.fa-2xl {\n  vertical-align: -0.3125em;\n}\n.svg-inline--fa.fa-pull-left {\n  margin-right: var(--fa-pull-margin, 0.3em);\n  width: auto;\n}\n.svg-inline--fa.fa-pull-right {\n  margin-left: var(--fa-pull-margin, 0.3em);\n  width: auto;\n}\n.svg-inline--fa.fa-li {\n  width: var(--fa-li-width, 2em);\n  top: 0.25em;\n}\n.svg-inline--fa.fa-fw {\n  width: var(--fa-fw-width, 1.25em);\n}\n\n.fa-layers svg.svg-inline--fa {\n  bottom: 0;\n  left: 0;\n  margin: auto;\n  position: absolute;\n  right: 0;\n  top: 0;\n}\n\n.fa-layers-counter, .fa-layers-text {\n  display: inline-block;\n  position: absolute;\n  text-align: center;\n}\n\n.fa-layers {\n  display: inline-block;\n  height: 1em;\n  position: relative;\n  text-align: center;\n  vertical-align: -0.125em;\n  width: 1em;\n}\n.fa-layers svg.svg-inline--fa {\n  -webkit-transform-origin: center center;\n          transform-origin: center center;\n}\n\n.fa-layers-text {\n  left: 50%;\n  top: 50%;\n  -webkit-transform: translate(-50%, -50%);\n          transform: translate(-50%, -50%);\n  -webkit-transform-origin: center center;\n          transform-origin: center center;\n}\n\n.fa-layers-counter {\n  background-color: var(--fa-counter-background-color, #ff253a);\n  border-radius: var(--fa-counter-border-radius, 1em);\n  box-sizing: border-box;\n  color: var(--fa-inverse, #fff);\n  line-height: var(--fa-counter-line-height, 1);\n  max-width: var(--fa-counter-max-width, 5em);\n  min-width: var(--fa-counter-min-width, 1.5em);\n  overflow: hidden;\n  padding: var(--fa-counter-padding, 0.25em 0.5em);\n  right: var(--fa-right, 0);\n  text-overflow: ellipsis;\n  top: var(--fa-top, 0);\n  -webkit-transform: scale(var(--fa-counter-scale, 0.25));\n          transform: scale(var(--fa-counter-scale, 0.25));\n  -webkit-transform-origin: top right;\n          transform-origin: top right;\n}\n\n.fa-layers-bottom-right {\n  bottom: var(--fa-bottom, 0);\n  right: var(--fa-right, 0);\n  top: auto;\n  -webkit-transform: scale(var(--fa-layers-scale, 0.25));\n          transform: scale(var(--fa-layers-scale, 0.25));\n  -webkit-transform-origin: bottom right;\n          transform-origin: bottom right;\n}\n\n.fa-layers-bottom-left {\n  bottom: var(--fa-bottom, 0);\n  left: var(--fa-left, 0);\n  right: auto;\n  top: auto;\n  -webkit-transform: scale(var(--fa-layers-scale, 0.25));\n          transform: scale(var(--fa-layers-scale, 0.25));\n  -webkit-transform-origin: bottom left;\n          transform-origin: bottom left;\n}\n\n.fa-layers-top-right {\n  top: var(--fa-top, 0);\n  right: var(--fa-right, 0);\n  -webkit-transform: scale(var(--fa-layers-scale, 0.25));\n          transform: scale(var(--fa-layers-scale, 0.25));\n  -webkit-transform-origin: top right;\n          transform-origin: top right;\n}\n\n.fa-layers-top-left {\n  left: var(--fa-left, 0);\n  right: auto;\n  top: var(--fa-top, 0);\n  -webkit-transform: scale(var(--fa-layers-scale, 0.25));\n          transform: scale(var(--fa-layers-scale, 0.25));\n  -webkit-transform-origin: top left;\n          transform-origin: top left;\n}\n\n.fa-1x {\n  font-size: 1em;\n}\n\n.fa-2x {\n  font-size: 2em;\n}\n\n.fa-3x {\n  font-size: 3em;\n}\n\n.fa-4x {\n  font-size: 4em;\n}\n\n.fa-5x {\n  font-size: 5em;\n}\n\n.fa-6x {\n  font-size: 6em;\n}\n\n.fa-7x {\n  font-size: 7em;\n}\n\n.fa-8x {\n  font-size: 8em;\n}\n\n.fa-9x {\n  font-size: 9em;\n}\n\n.fa-10x {\n  font-size: 10em;\n}\n\n.fa-2xs {\n  font-size: 0.625em;\n  line-height: 0.1em;\n  vertical-align: 0.225em;\n}\n\n.fa-xs {\n  font-size: 0.75em;\n  line-height: 0.0833333337em;\n  vertical-align: 0.125em;\n}\n\n.fa-sm {\n  font-size: 0.875em;\n  line-height: 0.0714285718em;\n  vertical-align: 0.0535714295em;\n}\n\n.fa-lg {\n  font-size: 1.25em;\n  line-height: 0.05em;\n  vertical-align: -0.075em;\n}\n\n.fa-xl {\n  font-size: 1.5em;\n  line-height: 0.0416666682em;\n  vertical-align: -0.125em;\n}\n\n.fa-2xl {\n  font-size: 2em;\n  line-height: 0.03125em;\n  vertical-align: -0.1875em;\n}\n\n.fa-fw {\n  text-align: center;\n  width: 1.25em;\n}\n\n.fa-ul {\n  list-style-type: none;\n  margin-left: var(--fa-li-margin, 2.5em);\n  padding-left: 0;\n}\n.fa-ul > li {\n  position: relative;\n}\n\n.fa-li {\n  left: calc(var(--fa-li-width, 2em) * -1);\n  position: absolute;\n  text-align: center;\n  width: var(--fa-li-width, 2em);\n  line-height: inherit;\n}\n\n.fa-border {\n  border-color: var(--fa-border-color, #eee);\n  border-radius: var(--fa-border-radius, 0.1em);\n  border-style: var(--fa-border-style, solid);\n  border-width: var(--fa-border-width, 0.08em);\n  padding: var(--fa-border-padding, 0.2em 0.25em 0.15em);\n}\n\n.fa-pull-left {\n  float: left;\n  margin-right: var(--fa-pull-margin, 0.3em);\n}\n\n.fa-pull-right {\n  float: right;\n  margin-left: var(--fa-pull-margin, 0.3em);\n}\n\n.fa-beat {\n  -webkit-animation-name: fa-beat;\n          animation-name: fa-beat;\n  -webkit-animation-delay: var(--fa-animation-delay, 0s);\n          animation-delay: var(--fa-animation-delay, 0s);\n  -webkit-animation-direction: var(--fa-animation-direction, normal);\n          animation-direction: var(--fa-animation-direction, normal);\n  -webkit-animation-duration: var(--fa-animation-duration, 1s);\n          animation-duration: var(--fa-animation-duration, 1s);\n  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n          animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n  -webkit-animation-timing-function: var(--fa-animation-timing, ease-in-out);\n          animation-timing-function: var(--fa-animation-timing, ease-in-out);\n}\n\n.fa-bounce {\n  -webkit-animation-name: fa-bounce;\n          animation-name: fa-bounce;\n  -webkit-animation-delay: var(--fa-animation-delay, 0s);\n          animation-delay: var(--fa-animation-delay, 0s);\n  -webkit-animation-direction: var(--fa-animation-direction, normal);\n          animation-direction: var(--fa-animation-direction, normal);\n  -webkit-animation-duration: var(--fa-animation-duration, 1s);\n          animation-duration: var(--fa-animation-duration, 1s);\n  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n          animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n  -webkit-animation-timing-function: var(--fa-animation-timing, cubic-bezier(0.28, 0.84, 0.42, 1));\n          animation-timing-function: var(--fa-animation-timing, cubic-bezier(0.28, 0.84, 0.42, 1));\n}\n\n.fa-fade {\n  -webkit-animation-name: fa-fade;\n          animation-name: fa-fade;\n  -webkit-animation-delay: var(--fa-animation-delay, 0s);\n          animation-delay: var(--fa-animation-delay, 0s);\n  -webkit-animation-direction: var(--fa-animation-direction, normal);\n          animation-direction: var(--fa-animation-direction, normal);\n  -webkit-animation-duration: var(--fa-animation-duration, 1s);\n          animation-duration: var(--fa-animation-duration, 1s);\n  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n          animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n  -webkit-animation-timing-function: var(--fa-animation-timing, cubic-bezier(0.4, 0, 0.6, 1));\n          animation-timing-function: var(--fa-animation-timing, cubic-bezier(0.4, 0, 0.6, 1));\n}\n\n.fa-beat-fade {\n  -webkit-animation-name: fa-beat-fade;\n          animation-name: fa-beat-fade;\n  -webkit-animation-delay: var(--fa-animation-delay, 0s);\n          animation-delay: var(--fa-animation-delay, 0s);\n  -webkit-animation-direction: var(--fa-animation-direction, normal);\n          animation-direction: var(--fa-animation-direction, normal);\n  -webkit-animation-duration: var(--fa-animation-duration, 1s);\n          animation-duration: var(--fa-animation-duration, 1s);\n  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n          animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n  -webkit-animation-timing-function: var(--fa-animation-timing, cubic-bezier(0.4, 0, 0.6, 1));\n          animation-timing-function: var(--fa-animation-timing, cubic-bezier(0.4, 0, 0.6, 1));\n}\n\n.fa-flip {\n  -webkit-animation-name: fa-flip;\n          animation-name: fa-flip;\n  -webkit-animation-delay: var(--fa-animation-delay, 0s);\n          animation-delay: var(--fa-animation-delay, 0s);\n  -webkit-animation-direction: var(--fa-animation-direction, normal);\n          animation-direction: var(--fa-animation-direction, normal);\n  -webkit-animation-duration: var(--fa-animation-duration, 1s);\n          animation-duration: var(--fa-animation-duration, 1s);\n  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n          animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n  -webkit-animation-timing-function: var(--fa-animation-timing, ease-in-out);\n          animation-timing-function: var(--fa-animation-timing, ease-in-out);\n}\n\n.fa-shake {\n  -webkit-animation-name: fa-shake;\n          animation-name: fa-shake;\n  -webkit-animation-delay: var(--fa-animation-delay, 0s);\n          animation-delay: var(--fa-animation-delay, 0s);\n  -webkit-animation-direction: var(--fa-animation-direction, normal);\n          animation-direction: var(--fa-animation-direction, normal);\n  -webkit-animation-duration: var(--fa-animation-duration, 1s);\n          animation-duration: var(--fa-animation-duration, 1s);\n  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n          animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n  -webkit-animation-timing-function: var(--fa-animation-timing, linear);\n          animation-timing-function: var(--fa-animation-timing, linear);\n}\n\n.fa-spin {\n  -webkit-animation-name: fa-spin;\n          animation-name: fa-spin;\n  -webkit-animation-delay: var(--fa-animation-delay, 0s);\n          animation-delay: var(--fa-animation-delay, 0s);\n  -webkit-animation-direction: var(--fa-animation-direction, normal);\n          animation-direction: var(--fa-animation-direction, normal);\n  -webkit-animation-duration: var(--fa-animation-duration, 2s);\n          animation-duration: var(--fa-animation-duration, 2s);\n  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n          animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n  -webkit-animation-timing-function: var(--fa-animation-timing, linear);\n          animation-timing-function: var(--fa-animation-timing, linear);\n}\n\n.fa-spin-reverse {\n  --fa-animation-direction: reverse;\n}\n\n.fa-pulse,\n.fa-spin-pulse {\n  -webkit-animation-name: fa-spin;\n          animation-name: fa-spin;\n  -webkit-animation-direction: var(--fa-animation-direction, normal);\n          animation-direction: var(--fa-animation-direction, normal);\n  -webkit-animation-duration: var(--fa-animation-duration, 1s);\n          animation-duration: var(--fa-animation-duration, 1s);\n  -webkit-animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n          animation-iteration-count: var(--fa-animation-iteration-count, infinite);\n  -webkit-animation-timing-function: var(--fa-animation-timing, steps(8));\n          animation-timing-function: var(--fa-animation-timing, steps(8));\n}\n\n@media (prefers-reduced-motion: reduce) {\n  .fa-beat,\n.fa-bounce,\n.fa-fade,\n.fa-beat-fade,\n.fa-flip,\n.fa-pulse,\n.fa-shake,\n.fa-spin,\n.fa-spin-pulse {\n    -webkit-animation-delay: -1ms;\n            animation-delay: -1ms;\n    -webkit-animation-duration: 1ms;\n            animation-duration: 1ms;\n    -webkit-animation-iteration-count: 1;\n            animation-iteration-count: 1;\n    -webkit-transition-delay: 0s;\n            transition-delay: 0s;\n    -webkit-transition-duration: 0s;\n            transition-duration: 0s;\n  }\n}\n@-webkit-keyframes fa-beat {\n  0%, 90% {\n    -webkit-transform: scale(1);\n            transform: scale(1);\n  }\n  45% {\n    -webkit-transform: scale(var(--fa-beat-scale, 1.25));\n            transform: scale(var(--fa-beat-scale, 1.25));\n  }\n}\n@keyframes fa-beat {\n  0%, 90% {\n    -webkit-transform: scale(1);\n            transform: scale(1);\n  }\n  45% {\n    -webkit-transform: scale(var(--fa-beat-scale, 1.25));\n            transform: scale(var(--fa-beat-scale, 1.25));\n  }\n}\n@-webkit-keyframes fa-bounce {\n  0% {\n    -webkit-transform: scale(1, 1) translateY(0);\n            transform: scale(1, 1) translateY(0);\n  }\n  10% {\n    -webkit-transform: scale(var(--fa-bounce-start-scale-x, 1.1), var(--fa-bounce-start-scale-y, 0.9)) translateY(0);\n            transform: scale(var(--fa-bounce-start-scale-x, 1.1), var(--fa-bounce-start-scale-y, 0.9)) translateY(0);\n  }\n  30% {\n    -webkit-transform: scale(var(--fa-bounce-jump-scale-x, 0.9), var(--fa-bounce-jump-scale-y, 1.1)) translateY(var(--fa-bounce-height, -0.5em));\n            transform: scale(var(--fa-bounce-jump-scale-x, 0.9), var(--fa-bounce-jump-scale-y, 1.1)) translateY(var(--fa-bounce-height, -0.5em));\n  }\n  50% {\n    -webkit-transform: scale(var(--fa-bounce-land-scale-x, 1.05), var(--fa-bounce-land-scale-y, 0.95)) translateY(0);\n            transform: scale(var(--fa-bounce-land-scale-x, 1.05), var(--fa-bounce-land-scale-y, 0.95)) translateY(0);\n  }\n  57% {\n    -webkit-transform: scale(1, 1) translateY(var(--fa-bounce-rebound, -0.125em));\n            transform: scale(1, 1) translateY(var(--fa-bounce-rebound, -0.125em));\n  }\n  64% {\n    -webkit-transform: scale(1, 1) translateY(0);\n            transform: scale(1, 1) translateY(0);\n  }\n  100% {\n    -webkit-transform: scale(1, 1) translateY(0);\n            transform: scale(1, 1) translateY(0);\n  }\n}\n@keyframes fa-bounce {\n  0% {\n    -webkit-transform: scale(1, 1) translateY(0);\n            transform: scale(1, 1) translateY(0);\n  }\n  10% {\n    -webkit-transform: scale(var(--fa-bounce-start-scale-x, 1.1), var(--fa-bounce-start-scale-y, 0.9)) translateY(0);\n            transform: scale(var(--fa-bounce-start-scale-x, 1.1), var(--fa-bounce-start-scale-y, 0.9)) translateY(0);\n  }\n  30% {\n    -webkit-transform: scale(var(--fa-bounce-jump-scale-x, 0.9), var(--fa-bounce-jump-scale-y, 1.1)) translateY(var(--fa-bounce-height, -0.5em));\n            transform: scale(var(--fa-bounce-jump-scale-x, 0.9), var(--fa-bounce-jump-scale-y, 1.1)) translateY(var(--fa-bounce-height, -0.5em));\n  }\n  50% {\n    -webkit-transform: scale(var(--fa-bounce-land-scale-x, 1.05), var(--fa-bounce-land-scale-y, 0.95)) translateY(0);\n            transform: scale(var(--fa-bounce-land-scale-x, 1.05), var(--fa-bounce-land-scale-y, 0.95)) translateY(0);\n  }\n  57% {\n    -webkit-transform: scale(1, 1) translateY(var(--fa-bounce-rebound, -0.125em));\n            transform: scale(1, 1) translateY(var(--fa-bounce-rebound, -0.125em));\n  }\n  64% {\n    -webkit-transform: scale(1, 1) translateY(0);\n            transform: scale(1, 1) translateY(0);\n  }\n  100% {\n    -webkit-transform: scale(1, 1) translateY(0);\n            transform: scale(1, 1) translateY(0);\n  }\n}\n@-webkit-keyframes fa-fade {\n  50% {\n    opacity: var(--fa-fade-opacity, 0.4);\n  }\n}\n@keyframes fa-fade {\n  50% {\n    opacity: var(--fa-fade-opacity, 0.4);\n  }\n}\n@-webkit-keyframes fa-beat-fade {\n  0%, 100% {\n    opacity: var(--fa-beat-fade-opacity, 0.4);\n    -webkit-transform: scale(1);\n            transform: scale(1);\n  }\n  50% {\n    opacity: 1;\n    -webkit-transform: scale(var(--fa-beat-fade-scale, 1.125));\n            transform: scale(var(--fa-beat-fade-scale, 1.125));\n  }\n}\n@keyframes fa-beat-fade {\n  0%, 100% {\n    opacity: var(--fa-beat-fade-opacity, 0.4);\n    -webkit-transform: scale(1);\n            transform: scale(1);\n  }\n  50% {\n    opacity: 1;\n    -webkit-transform: scale(var(--fa-beat-fade-scale, 1.125));\n            transform: scale(var(--fa-beat-fade-scale, 1.125));\n  }\n}\n@-webkit-keyframes fa-flip {\n  50% {\n    -webkit-transform: rotate3d(var(--fa-flip-x, 0), var(--fa-flip-y, 1), var(--fa-flip-z, 0), var(--fa-flip-angle, -180deg));\n            transform: rotate3d(var(--fa-flip-x, 0), var(--fa-flip-y, 1), var(--fa-flip-z, 0), var(--fa-flip-angle, -180deg));\n  }\n}\n@keyframes fa-flip {\n  50% {\n    -webkit-transform: rotate3d(var(--fa-flip-x, 0), var(--fa-flip-y, 1), var(--fa-flip-z, 0), var(--fa-flip-angle, -180deg));\n            transform: rotate3d(var(--fa-flip-x, 0), var(--fa-flip-y, 1), var(--fa-flip-z, 0), var(--fa-flip-angle, -180deg));\n  }\n}\n@-webkit-keyframes fa-shake {\n  0% {\n    -webkit-transform: rotate(-15deg);\n            transform: rotate(-15deg);\n  }\n  4% {\n    -webkit-transform: rotate(15deg);\n            transform: rotate(15deg);\n  }\n  8%, 24% {\n    -webkit-transform: rotate(-18deg);\n            transform: rotate(-18deg);\n  }\n  12%, 28% {\n    -webkit-transform: rotate(18deg);\n            transform: rotate(18deg);\n  }\n  16% {\n    -webkit-transform: rotate(-22deg);\n            transform: rotate(-22deg);\n  }\n  20% {\n    -webkit-transform: rotate(22deg);\n            transform: rotate(22deg);\n  }\n  32% {\n    -webkit-transform: rotate(-12deg);\n            transform: rotate(-12deg);\n  }\n  36% {\n    -webkit-transform: rotate(12deg);\n            transform: rotate(12deg);\n  }\n  40%, 100% {\n    -webkit-transform: rotate(0deg);\n            transform: rotate(0deg);\n  }\n}\n@keyframes fa-shake {\n  0% {\n    -webkit-transform: rotate(-15deg);\n            transform: rotate(-15deg);\n  }\n  4% {\n    -webkit-transform: rotate(15deg);\n            transform: rotate(15deg);\n  }\n  8%, 24% {\n    -webkit-transform: rotate(-18deg);\n            transform: rotate(-18deg);\n  }\n  12%, 28% {\n    -webkit-transform: rotate(18deg);\n            transform: rotate(18deg);\n  }\n  16% {\n    -webkit-transform: rotate(-22deg);\n            transform: rotate(-22deg);\n  }\n  20% {\n    -webkit-transform: rotate(22deg);\n            transform: rotate(22deg);\n  }\n  32% {\n    -webkit-transform: rotate(-12deg);\n            transform: rotate(-12deg);\n  }\n  36% {\n    -webkit-transform: rotate(12deg);\n            transform: rotate(12deg);\n  }\n  40%, 100% {\n    -webkit-transform: rotate(0deg);\n            transform: rotate(0deg);\n  }\n}\n@-webkit-keyframes fa-spin {\n  0% {\n    -webkit-transform: rotate(0deg);\n            transform: rotate(0deg);\n  }\n  100% {\n    -webkit-transform: rotate(360deg);\n            transform: rotate(360deg);\n  }\n}\n@keyframes fa-spin {\n  0% {\n    -webkit-transform: rotate(0deg);\n            transform: rotate(0deg);\n  }\n  100% {\n    -webkit-transform: rotate(360deg);\n            transform: rotate(360deg);\n  }\n}\n.fa-rotate-90 {\n  -webkit-transform: rotate(90deg);\n          transform: rotate(90deg);\n}\n\n.fa-rotate-180 {\n  -webkit-transform: rotate(180deg);\n          transform: rotate(180deg);\n}\n\n.fa-rotate-270 {\n  -webkit-transform: rotate(270deg);\n          transform: rotate(270deg);\n}\n\n.fa-flip-horizontal {\n  -webkit-transform: scale(-1, 1);\n          transform: scale(-1, 1);\n}\n\n.fa-flip-vertical {\n  -webkit-transform: scale(1, -1);\n          transform: scale(1, -1);\n}\n\n.fa-flip-both,\n.fa-flip-horizontal.fa-flip-vertical {\n  -webkit-transform: scale(-1, -1);\n          transform: scale(-1, -1);\n}\n\n.fa-rotate-by {\n  -webkit-transform: rotate(var(--fa-rotate-angle, none));\n          transform: rotate(var(--fa-rotate-angle, none));\n}\n\n.fa-stack {\n  display: inline-block;\n  vertical-align: middle;\n  height: 2em;\n  position: relative;\n  width: 2.5em;\n}\n\n.fa-stack-1x,\n.fa-stack-2x {\n  bottom: 0;\n  left: 0;\n  margin: auto;\n  position: absolute;\n  right: 0;\n  top: 0;\n  z-index: var(--fa-stack-z-index, auto);\n}\n\n.svg-inline--fa.fa-stack-1x {\n  height: 1em;\n  width: 1.25em;\n}\n.svg-inline--fa.fa-stack-2x {\n  height: 2em;\n  width: 2.5em;\n}\n\n.fa-inverse {\n  color: var(--fa-inverse, #fff);\n}\n\n.sr-only,\n.fa-sr-only {\n  position: absolute;\n  width: 1px;\n  height: 1px;\n  padding: 0;\n  margin: -1px;\n  overflow: hidden;\n  clip: rect(0, 0, 0, 0);\n  white-space: nowrap;\n  border-width: 0;\n}\n\n.sr-only-focusable:not(:focus),\n.fa-sr-only-focusable:not(:focus) {\n  position: absolute;\n  width: 1px;\n  height: 1px;\n  padding: 0;\n  margin: -1px;\n  overflow: hidden;\n  clip: rect(0, 0, 0, 0);\n  white-space: nowrap;\n  border-width: 0;\n}\n\n.svg-inline--fa .fa-primary {\n  fill: var(--fa-primary-color, currentColor);\n  opacity: var(--fa-primary-opacity, 1);\n}\n\n.svg-inline--fa .fa-secondary {\n  fill: var(--fa-secondary-color, currentColor);\n  opacity: var(--fa-secondary-opacity, 0.4);\n}\n\n.svg-inline--fa.fa-swap-opacity .fa-primary {\n  opacity: var(--fa-secondary-opacity, 0.4);\n}\n\n.svg-inline--fa.fa-swap-opacity .fa-secondary {\n  opacity: var(--fa-primary-opacity, 1);\n}\n\n.svg-inline--fa mask .fa-primary,\n.svg-inline--fa mask .fa-secondary {\n  fill: black;\n}\n\n.fad.fa-inverse,\n.fa-duotone.fa-inverse {\n  color: var(--fa-inverse, #fff);\n}';
function css() {
  var dcp = DEFAULT_CSS_PREFIX;
  var drc = DEFAULT_REPLACEMENT_CLASS;
  var fp = config.cssPrefix;
  var rc = config.replacementClass;
  var s = baseStyles;
  if (fp !== dcp || rc !== drc) {
    var dPatt = new RegExp("\\.".concat(dcp, "\\-"), "g");
    var customPropPatt = new RegExp("\\--".concat(dcp, "\\-"), "g");
    var rPatt = new RegExp("\\.".concat(drc), "g");
    s = s.replace(dPatt, ".".concat(fp, "-")).replace(customPropPatt, "--".concat(fp, "-")).replace(rPatt, ".".concat(rc));
  }
  return s;
}
var _cssInserted = false;
function ensureCss() {
  if (config.autoAddCss && !_cssInserted) {
    insertCss(css());
    _cssInserted = true;
  }
}
var InjectCSS = {
  mixout: function mixout() {
    return {
      dom: {
        css,
        insertCss: ensureCss
      }
    };
  },
  hooks: function hooks() {
    return {
      beforeDOMElementCreation: function beforeDOMElementCreation() {
        ensureCss();
      },
      beforeI2svg: function beforeI2svg() {
        ensureCss();
      }
    };
  }
};
var w = WINDOW || {};
if (!w[NAMESPACE_IDENTIFIER])
  w[NAMESPACE_IDENTIFIER] = {};
if (!w[NAMESPACE_IDENTIFIER].styles)
  w[NAMESPACE_IDENTIFIER].styles = {};
if (!w[NAMESPACE_IDENTIFIER].hooks)
  w[NAMESPACE_IDENTIFIER].hooks = {};
if (!w[NAMESPACE_IDENTIFIER].shims)
  w[NAMESPACE_IDENTIFIER].shims = [];
var namespace = w[NAMESPACE_IDENTIFIER];
var functions = [];
var listener = function listener2() {
  DOCUMENT.removeEventListener("DOMContentLoaded", listener2);
  loaded = 1;
  functions.map(function(fn) {
    return fn();
  });
};
var loaded = false;
if (IS_DOM) {
  loaded = (DOCUMENT.documentElement.doScroll ? /^loaded|^c/ : /^loaded|^i|^c/).test(DOCUMENT.readyState);
  if (!loaded)
    DOCUMENT.addEventListener("DOMContentLoaded", listener);
}
function domready(fn) {
  if (!IS_DOM)
    return;
  loaded ? setTimeout(fn, 0) : functions.push(fn);
}
function toHtml(abstractNodes) {
  var tag = abstractNodes.tag, _abstractNodes$attrib = abstractNodes.attributes, attributes = _abstractNodes$attrib === void 0 ? {} : _abstractNodes$attrib, _abstractNodes$childr = abstractNodes.children, children = _abstractNodes$childr === void 0 ? [] : _abstractNodes$childr;
  if (typeof abstractNodes === "string") {
    return htmlEscape(abstractNodes);
  } else {
    return "<".concat(tag, " ").concat(joinAttributes(attributes), ">").concat(children.map(toHtml).join(""), "</").concat(tag, ">");
  }
}
function iconFromMapping(mapping, prefix, iconName) {
  if (mapping && mapping[prefix] && mapping[prefix][iconName]) {
    return {
      prefix,
      iconName,
      icon: mapping[prefix][iconName]
    };
  }
}
var bindInternal4 = function bindInternal42(func, thisContext) {
  return function(a, b, c, d2) {
    return func.call(thisContext, a, b, c, d2);
  };
};
var reduce = function fastReduceObject(subject, fn, initialValue, thisContext) {
  var keys3 = Object.keys(subject), length = keys3.length, iterator = thisContext !== void 0 ? bindInternal4(fn, thisContext) : fn, i, key, result;
  if (initialValue === void 0) {
    i = 1;
    result = subject[keys3[0]];
  } else {
    i = 0;
    result = initialValue;
  }
  for (; i < length; i++) {
    key = keys3[i];
    result = iterator(result, subject[key], key, subject);
  }
  return result;
};
function ucs2decode(string) {
  var output = [];
  var counter2 = 0;
  var length = string.length;
  while (counter2 < length) {
    var value = string.charCodeAt(counter2++);
    if (value >= 55296 && value <= 56319 && counter2 < length) {
      var extra = string.charCodeAt(counter2++);
      if ((extra & 64512) == 56320) {
        output.push(((value & 1023) << 10) + (extra & 1023) + 65536);
      } else {
        output.push(value);
        counter2--;
      }
    } else {
      output.push(value);
    }
  }
  return output;
}
function toHex(unicode) {
  var decoded = ucs2decode(unicode);
  return decoded.length === 1 ? decoded[0].toString(16) : null;
}
function codePointAt(string, index) {
  var size = string.length;
  var first = string.charCodeAt(index);
  var second;
  if (first >= 55296 && first <= 56319 && size > index + 1) {
    second = string.charCodeAt(index + 1);
    if (second >= 56320 && second <= 57343) {
      return (first - 55296) * 1024 + second - 56320 + 65536;
    }
  }
  return first;
}
function normalizeIcons(icons) {
  return Object.keys(icons).reduce(function(acc, iconName) {
    var icon3 = icons[iconName];
    var expanded = !!icon3.icon;
    if (expanded) {
      acc[icon3.iconName] = icon3.icon;
    } else {
      acc[iconName] = icon3;
    }
    return acc;
  }, {});
}
function defineIcons(prefix, icons) {
  var params = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
  var _params$skipHooks = params.skipHooks, skipHooks = _params$skipHooks === void 0 ? false : _params$skipHooks;
  var normalized = normalizeIcons(icons);
  if (typeof namespace.hooks.addPack === "function" && !skipHooks) {
    namespace.hooks.addPack(prefix, normalizeIcons(icons));
  } else {
    namespace.styles[prefix] = _objectSpread2$1(_objectSpread2$1({}, namespace.styles[prefix] || {}), normalized);
  }
  if (prefix === "fas") {
    defineIcons("fa", icons);
  }
}
var _LONG_STYLE, _PREFIXES, _PREFIXES_FOR_FAMILY;
var styles = namespace.styles, shims = namespace.shims;
var LONG_STYLE = (_LONG_STYLE = {}, _defineProperty$x(_LONG_STYLE, FAMILY_CLASSIC, Object.values(PREFIX_TO_LONG_STYLE[FAMILY_CLASSIC])), _defineProperty$x(_LONG_STYLE, FAMILY_SHARP, Object.values(PREFIX_TO_LONG_STYLE[FAMILY_SHARP])), _LONG_STYLE);
var _defaultUsablePrefix = null;
var _byUnicode = {};
var _byLigature = {};
var _byOldName = {};
var _byOldUnicode = {};
var _byAlias = {};
var PREFIXES = (_PREFIXES = {}, _defineProperty$x(_PREFIXES, FAMILY_CLASSIC, Object.keys(PREFIX_TO_STYLE[FAMILY_CLASSIC])), _defineProperty$x(_PREFIXES, FAMILY_SHARP, Object.keys(PREFIX_TO_STYLE[FAMILY_SHARP])), _PREFIXES);
function isReserved(name2) {
  return ~RESERVED_CLASSES.indexOf(name2);
}
function getIconName(cssPrefix, cls) {
  var parts = cls.split("-");
  var prefix = parts[0];
  var iconName = parts.slice(1).join("-");
  if (prefix === cssPrefix && iconName !== "" && !isReserved(iconName)) {
    return iconName;
  } else {
    return null;
  }
}
var build = function build2() {
  var lookup2 = function lookup3(reducer) {
    return reduce(styles, function(o, style, prefix) {
      o[prefix] = reduce(style, reducer, {});
      return o;
    }, {});
  };
  _byUnicode = lookup2(function(acc, icon3, iconName) {
    if (icon3[3]) {
      acc[icon3[3]] = iconName;
    }
    if (icon3[2]) {
      var aliases = icon3[2].filter(function(a) {
        return typeof a === "number";
      });
      aliases.forEach(function(alias) {
        acc[alias.toString(16)] = iconName;
      });
    }
    return acc;
  });
  _byLigature = lookup2(function(acc, icon3, iconName) {
    acc[iconName] = iconName;
    if (icon3[2]) {
      var aliases = icon3[2].filter(function(a) {
        return typeof a === "string";
      });
      aliases.forEach(function(alias) {
        acc[alias] = iconName;
      });
    }
    return acc;
  });
  _byAlias = lookup2(function(acc, icon3, iconName) {
    var aliases = icon3[2];
    acc[iconName] = iconName;
    aliases.forEach(function(alias) {
      acc[alias] = iconName;
    });
    return acc;
  });
  var hasRegular = "far" in styles || config.autoFetchSvg;
  var shimLookups = reduce(shims, function(acc, shim2) {
    var maybeNameMaybeUnicode = shim2[0];
    var prefix = shim2[1];
    var iconName = shim2[2];
    if (prefix === "far" && !hasRegular) {
      prefix = "fas";
    }
    if (typeof maybeNameMaybeUnicode === "string") {
      acc.names[maybeNameMaybeUnicode] = {
        prefix,
        iconName
      };
    }
    if (typeof maybeNameMaybeUnicode === "number") {
      acc.unicodes[maybeNameMaybeUnicode.toString(16)] = {
        prefix,
        iconName
      };
    }
    return acc;
  }, {
    names: {},
    unicodes: {}
  });
  _byOldName = shimLookups.names;
  _byOldUnicode = shimLookups.unicodes;
  _defaultUsablePrefix = getCanonicalPrefix(config.styleDefault, {
    family: config.familyDefault
  });
};
onChange(function(c) {
  _defaultUsablePrefix = getCanonicalPrefix(c.styleDefault, {
    family: config.familyDefault
  });
});
build();
function byUnicode(prefix, unicode) {
  return (_byUnicode[prefix] || {})[unicode];
}
function byLigature(prefix, ligature) {
  return (_byLigature[prefix] || {})[ligature];
}
function byAlias(prefix, alias) {
  return (_byAlias[prefix] || {})[alias];
}
function byOldName(name2) {
  return _byOldName[name2] || {
    prefix: null,
    iconName: null
  };
}
function byOldUnicode(unicode) {
  var oldUnicode = _byOldUnicode[unicode];
  var newUnicode = byUnicode("fas", unicode);
  return oldUnicode || (newUnicode ? {
    prefix: "fas",
    iconName: newUnicode
  } : null) || {
    prefix: null,
    iconName: null
  };
}
function getDefaultUsablePrefix() {
  return _defaultUsablePrefix;
}
var emptyCanonicalIcon = function emptyCanonicalIcon2() {
  return {
    prefix: null,
    iconName: null,
    rest: []
  };
};
function getCanonicalPrefix(styleOrPrefix) {
  var params = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var _params$family = params.family, family = _params$family === void 0 ? FAMILY_CLASSIC : _params$family;
  var style = PREFIX_TO_STYLE[family][styleOrPrefix];
  var prefix = STYLE_TO_PREFIX[family][styleOrPrefix] || STYLE_TO_PREFIX[family][style];
  var defined = styleOrPrefix in namespace.styles ? styleOrPrefix : null;
  return prefix || defined || null;
}
var PREFIXES_FOR_FAMILY = (_PREFIXES_FOR_FAMILY = {}, _defineProperty$x(_PREFIXES_FOR_FAMILY, FAMILY_CLASSIC, Object.keys(PREFIX_TO_LONG_STYLE[FAMILY_CLASSIC])), _defineProperty$x(_PREFIXES_FOR_FAMILY, FAMILY_SHARP, Object.keys(PREFIX_TO_LONG_STYLE[FAMILY_SHARP])), _PREFIXES_FOR_FAMILY);
function getCanonicalIcon(values) {
  var _famProps;
  var params = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var _params$skipLookups = params.skipLookups, skipLookups = _params$skipLookups === void 0 ? false : _params$skipLookups;
  var famProps = (_famProps = {}, _defineProperty$x(_famProps, FAMILY_CLASSIC, "".concat(config.cssPrefix, "-").concat(FAMILY_CLASSIC)), _defineProperty$x(_famProps, FAMILY_SHARP, "".concat(config.cssPrefix, "-").concat(FAMILY_SHARP)), _famProps);
  var givenPrefix = null;
  var family = FAMILY_CLASSIC;
  if (values.includes(famProps[FAMILY_CLASSIC]) || values.some(function(v) {
    return PREFIXES_FOR_FAMILY[FAMILY_CLASSIC].includes(v);
  })) {
    family = FAMILY_CLASSIC;
  }
  if (values.includes(famProps[FAMILY_SHARP]) || values.some(function(v) {
    return PREFIXES_FOR_FAMILY[FAMILY_SHARP].includes(v);
  })) {
    family = FAMILY_SHARP;
  }
  var canonical = values.reduce(function(acc, cls) {
    var iconName = getIconName(config.cssPrefix, cls);
    if (styles[cls]) {
      cls = LONG_STYLE[family].includes(cls) ? LONG_STYLE_TO_PREFIX[family][cls] : cls;
      givenPrefix = cls;
      acc.prefix = cls;
    } else if (PREFIXES[family].indexOf(cls) > -1) {
      givenPrefix = cls;
      acc.prefix = getCanonicalPrefix(cls, {
        family
      });
    } else if (iconName) {
      acc.iconName = iconName;
    } else if (cls !== config.replacementClass && cls !== famProps[FAMILY_CLASSIC] && cls !== famProps[FAMILY_SHARP]) {
      acc.rest.push(cls);
    }
    if (!skipLookups && acc.prefix && acc.iconName) {
      var shim2 = givenPrefix === "fa" ? byOldName(acc.iconName) : {};
      var aliasIconName = byAlias(acc.prefix, acc.iconName);
      if (shim2.prefix) {
        givenPrefix = null;
      }
      acc.iconName = shim2.iconName || aliasIconName || acc.iconName;
      acc.prefix = shim2.prefix || acc.prefix;
      if (acc.prefix === "far" && !styles["far"] && styles["fas"] && !config.autoFetchSvg) {
        acc.prefix = "fas";
      }
    }
    return acc;
  }, emptyCanonicalIcon());
  if (values.includes("fa-brands") || values.includes("fab")) {
    canonical.prefix = "fab";
  }
  if (values.includes("fa-duotone") || values.includes("fad")) {
    canonical.prefix = "fad";
  }
  if (!canonical.prefix && family === FAMILY_SHARP && (styles["fass"] || config.autoFetchSvg)) {
    canonical.prefix = "fass";
    canonical.iconName = byAlias(canonical.prefix, canonical.iconName) || canonical.iconName;
  }
  if (canonical.prefix === "fa" || givenPrefix === "fa") {
    canonical.prefix = getDefaultUsablePrefix() || "fas";
  }
  return canonical;
}
var Library = /* @__PURE__ */ function() {
  function Library2() {
    _classCallCheck(this, Library2);
    this.definitions = {};
  }
  _createClass(Library2, [{
    key: "add",
    value: function add() {
      var _this = this;
      for (var _len = arguments.length, definitions = new Array(_len), _key = 0; _key < _len; _key++) {
        definitions[_key] = arguments[_key];
      }
      var additions = definitions.reduce(this._pullDefinitions, {});
      Object.keys(additions).forEach(function(key) {
        _this.definitions[key] = _objectSpread2$1(_objectSpread2$1({}, _this.definitions[key] || {}), additions[key]);
        defineIcons(key, additions[key]);
        var longPrefix = PREFIX_TO_LONG_STYLE[FAMILY_CLASSIC][key];
        if (longPrefix)
          defineIcons(longPrefix, additions[key]);
        build();
      });
    }
  }, {
    key: "reset",
    value: function reset2() {
      this.definitions = {};
    }
  }, {
    key: "_pullDefinitions",
    value: function _pullDefinitions(additions, definition) {
      var normalized = definition.prefix && definition.iconName && definition.icon ? {
        0: definition
      } : definition;
      Object.keys(normalized).map(function(key) {
        var _normalized$key = normalized[key], prefix = _normalized$key.prefix, iconName = _normalized$key.iconName, icon3 = _normalized$key.icon;
        var aliases = icon3[2];
        if (!additions[prefix])
          additions[prefix] = {};
        if (aliases.length > 0) {
          aliases.forEach(function(alias) {
            if (typeof alias === "string") {
              additions[prefix][alias] = icon3;
            }
          });
        }
        additions[prefix][iconName] = icon3;
      });
      return additions;
    }
  }]);
  return Library2;
}();
var _plugins = [];
var _hooks = {};
var providers = {};
var defaultProviderKeys = Object.keys(providers);
function registerPlugins(nextPlugins, _ref2) {
  var obj = _ref2.mixoutsTo;
  _plugins = nextPlugins;
  _hooks = {};
  Object.keys(providers).forEach(function(k) {
    if (defaultProviderKeys.indexOf(k) === -1) {
      delete providers[k];
    }
  });
  _plugins.forEach(function(plugin) {
    var mixout8 = plugin.mixout ? plugin.mixout() : {};
    Object.keys(mixout8).forEach(function(tk) {
      if (typeof mixout8[tk] === "function") {
        obj[tk] = mixout8[tk];
      }
      if (_typeof$1(mixout8[tk]) === "object") {
        Object.keys(mixout8[tk]).forEach(function(sk) {
          if (!obj[tk]) {
            obj[tk] = {};
          }
          obj[tk][sk] = mixout8[tk][sk];
        });
      }
    });
    if (plugin.hooks) {
      var hooks8 = plugin.hooks();
      Object.keys(hooks8).forEach(function(hook) {
        if (!_hooks[hook]) {
          _hooks[hook] = [];
        }
        _hooks[hook].push(hooks8[hook]);
      });
    }
    if (plugin.provides) {
      plugin.provides(providers);
    }
  });
  return obj;
}
function chainHooks(hook, accumulator) {
  for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    args[_key - 2] = arguments[_key];
  }
  var hookFns = _hooks[hook] || [];
  hookFns.forEach(function(hookFn) {
    accumulator = hookFn.apply(null, [accumulator].concat(args));
  });
  return accumulator;
}
function callHooks(hook) {
  for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    args[_key2 - 1] = arguments[_key2];
  }
  var hookFns = _hooks[hook] || [];
  hookFns.forEach(function(hookFn) {
    hookFn.apply(null, args);
  });
  return void 0;
}
function callProvided() {
  var hook = arguments[0];
  var args = Array.prototype.slice.call(arguments, 1);
  return providers[hook] ? providers[hook].apply(null, args) : void 0;
}
function findIconDefinition(iconLookup) {
  if (iconLookup.prefix === "fa") {
    iconLookup.prefix = "fas";
  }
  var iconName = iconLookup.iconName;
  var prefix = iconLookup.prefix || getDefaultUsablePrefix();
  if (!iconName)
    return;
  iconName = byAlias(prefix, iconName) || iconName;
  return iconFromMapping(library.definitions, prefix, iconName) || iconFromMapping(namespace.styles, prefix, iconName);
}
var library = new Library();
var noAuto = function noAuto2() {
  config.autoReplaceSvg = false;
  config.observeMutations = false;
  callHooks("noAuto");
};
var dom = {
  i2svg: function i2svg() {
    var params = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    if (IS_DOM) {
      callHooks("beforeI2svg", params);
      callProvided("pseudoElements2svg", params);
      return callProvided("i2svg", params);
    } else {
      return Promise.reject("Operation requires a DOM of some kind.");
    }
  },
  watch: function watch() {
    var params = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    var autoReplaceSvgRoot = params.autoReplaceSvgRoot;
    if (config.autoReplaceSvg === false) {
      config.autoReplaceSvg = true;
    }
    config.observeMutations = true;
    domready(function() {
      autoReplace({
        autoReplaceSvgRoot
      });
      callHooks("watch", params);
    });
  }
};
var parse = {
  icon: function icon(_icon) {
    if (_icon === null) {
      return null;
    }
    if (_typeof$1(_icon) === "object" && _icon.prefix && _icon.iconName) {
      return {
        prefix: _icon.prefix,
        iconName: byAlias(_icon.prefix, _icon.iconName) || _icon.iconName
      };
    }
    if (Array.isArray(_icon) && _icon.length === 2) {
      var iconName = _icon[1].indexOf("fa-") === 0 ? _icon[1].slice(3) : _icon[1];
      var prefix = getCanonicalPrefix(_icon[0]);
      return {
        prefix,
        iconName: byAlias(prefix, iconName) || iconName
      };
    }
    if (typeof _icon === "string" && (_icon.indexOf("".concat(config.cssPrefix, "-")) > -1 || _icon.match(ICON_SELECTION_SYNTAX_PATTERN))) {
      var canonicalIcon = getCanonicalIcon(_icon.split(" "), {
        skipLookups: true
      });
      return {
        prefix: canonicalIcon.prefix || getDefaultUsablePrefix(),
        iconName: byAlias(canonicalIcon.prefix, canonicalIcon.iconName) || canonicalIcon.iconName
      };
    }
    if (typeof _icon === "string") {
      var _prefix = getDefaultUsablePrefix();
      return {
        prefix: _prefix,
        iconName: byAlias(_prefix, _icon) || _icon
      };
    }
  }
};
var api = {
  noAuto,
  config,
  dom,
  parse,
  library,
  findIconDefinition,
  toHtml
};
var autoReplace = function autoReplace2() {
  var params = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
  var _params$autoReplaceSv = params.autoReplaceSvgRoot, autoReplaceSvgRoot = _params$autoReplaceSv === void 0 ? DOCUMENT : _params$autoReplaceSv;
  if ((Object.keys(namespace.styles).length > 0 || config.autoFetchSvg) && IS_DOM && config.autoReplaceSvg)
    api.dom.i2svg({
      node: autoReplaceSvgRoot
    });
};
function domVariants(val, abstractCreator) {
  Object.defineProperty(val, "abstract", {
    get: abstractCreator
  });
  Object.defineProperty(val, "html", {
    get: function get3() {
      return val.abstract.map(function(a) {
        return toHtml(a);
      });
    }
  });
  Object.defineProperty(val, "node", {
    get: function get3() {
      if (!IS_DOM)
        return;
      var container = DOCUMENT.createElement("div");
      container.innerHTML = val.html;
      return container.children;
    }
  });
  return val;
}
function asIcon(_ref2) {
  var children = _ref2.children, main = _ref2.main, mask = _ref2.mask, attributes = _ref2.attributes, styles2 = _ref2.styles, transform = _ref2.transform;
  if (transformIsMeaningful(transform) && main.found && !mask.found) {
    var width = main.width, height = main.height;
    var offset2 = {
      x: width / height / 2,
      y: 0.5
    };
    attributes["style"] = joinStyles(_objectSpread2$1(_objectSpread2$1({}, styles2), {}, {
      "transform-origin": "".concat(offset2.x + transform.x / 16, "em ").concat(offset2.y + transform.y / 16, "em")
    }));
  }
  return [{
    tag: "svg",
    attributes,
    children
  }];
}
function asSymbol(_ref2) {
  var prefix = _ref2.prefix, iconName = _ref2.iconName, children = _ref2.children, attributes = _ref2.attributes, symbol = _ref2.symbol;
  var id = symbol === true ? "".concat(prefix, "-").concat(config.cssPrefix, "-").concat(iconName) : symbol;
  return [{
    tag: "svg",
    attributes: {
      style: "display: none;"
    },
    children: [{
      tag: "symbol",
      attributes: _objectSpread2$1(_objectSpread2$1({}, attributes), {}, {
        id
      }),
      children
    }]
  }];
}
function makeInlineSvgAbstract(params) {
  var _params$icons = params.icons, main = _params$icons.main, mask = _params$icons.mask, prefix = params.prefix, iconName = params.iconName, transform = params.transform, symbol = params.symbol, title = params.title, maskId = params.maskId, titleId = params.titleId, extra = params.extra, _params$watchable = params.watchable, watchable = _params$watchable === void 0 ? false : _params$watchable;
  var _ref2 = mask.found ? mask : main, width = _ref2.width, height = _ref2.height;
  var isUploadedIcon = prefix === "fak";
  var attrClass = [config.replacementClass, iconName ? "".concat(config.cssPrefix, "-").concat(iconName) : ""].filter(function(c) {
    return extra.classes.indexOf(c) === -1;
  }).filter(function(c) {
    return c !== "" || !!c;
  }).concat(extra.classes).join(" ");
  var content = {
    children: [],
    attributes: _objectSpread2$1(_objectSpread2$1({}, extra.attributes), {}, {
      "data-prefix": prefix,
      "data-icon": iconName,
      "class": attrClass,
      "role": extra.attributes.role || "img",
      "xmlns": "http://www.w3.org/2000/svg",
      "viewBox": "0 0 ".concat(width, " ").concat(height)
    })
  };
  var uploadedIconWidthStyle = isUploadedIcon && !~extra.classes.indexOf("fa-fw") ? {
    width: "".concat(width / height * 16 * 0.0625, "em")
  } : {};
  if (watchable) {
    content.attributes[DATA_FA_I2SVG] = "";
  }
  if (title) {
    content.children.push({
      tag: "title",
      attributes: {
        id: content.attributes["aria-labelledby"] || "title-".concat(titleId || nextUniqueId())
      },
      children: [title]
    });
    delete content.attributes.title;
  }
  var args = _objectSpread2$1(_objectSpread2$1({}, content), {}, {
    prefix,
    iconName,
    main,
    mask,
    maskId,
    transform,
    symbol,
    styles: _objectSpread2$1(_objectSpread2$1({}, uploadedIconWidthStyle), extra.styles)
  });
  var _ref22 = mask.found && main.found ? callProvided("generateAbstractMask", args) || {
    children: [],
    attributes: {}
  } : callProvided("generateAbstractIcon", args) || {
    children: [],
    attributes: {}
  }, children = _ref22.children, attributes = _ref22.attributes;
  args.children = children;
  args.attributes = attributes;
  if (symbol) {
    return asSymbol(args);
  } else {
    return asIcon(args);
  }
}
function makeLayersTextAbstract(params) {
  var content = params.content, width = params.width, height = params.height, transform = params.transform, title = params.title, extra = params.extra, _params$watchable2 = params.watchable, watchable = _params$watchable2 === void 0 ? false : _params$watchable2;
  var attributes = _objectSpread2$1(_objectSpread2$1(_objectSpread2$1({}, extra.attributes), title ? {
    "title": title
  } : {}), {}, {
    "class": extra.classes.join(" ")
  });
  if (watchable) {
    attributes[DATA_FA_I2SVG] = "";
  }
  var styles2 = _objectSpread2$1({}, extra.styles);
  if (transformIsMeaningful(transform)) {
    styles2["transform"] = transformForCss({
      transform,
      startCentered: true,
      width,
      height
    });
    styles2["-webkit-transform"] = styles2["transform"];
  }
  var styleString = joinStyles(styles2);
  if (styleString.length > 0) {
    attributes["style"] = styleString;
  }
  var val = [];
  val.push({
    tag: "span",
    attributes,
    children: [content]
  });
  if (title) {
    val.push({
      tag: "span",
      attributes: {
        class: "sr-only"
      },
      children: [title]
    });
  }
  return val;
}
function makeLayersCounterAbstract(params) {
  var content = params.content, title = params.title, extra = params.extra;
  var attributes = _objectSpread2$1(_objectSpread2$1(_objectSpread2$1({}, extra.attributes), title ? {
    "title": title
  } : {}), {}, {
    "class": extra.classes.join(" ")
  });
  var styleString = joinStyles(extra.styles);
  if (styleString.length > 0) {
    attributes["style"] = styleString;
  }
  var val = [];
  val.push({
    tag: "span",
    attributes,
    children: [content]
  });
  if (title) {
    val.push({
      tag: "span",
      attributes: {
        class: "sr-only"
      },
      children: [title]
    });
  }
  return val;
}
var styles$1 = namespace.styles;
function asFoundIcon(icon3) {
  var width = icon3[0];
  var height = icon3[1];
  var _icon$slice = icon3.slice(4), _icon$slice2 = _slicedToArray(_icon$slice, 1), vectorData = _icon$slice2[0];
  var element = null;
  if (Array.isArray(vectorData)) {
    element = {
      tag: "g",
      attributes: {
        class: "".concat(config.cssPrefix, "-").concat(DUOTONE_CLASSES.GROUP)
      },
      children: [{
        tag: "path",
        attributes: {
          class: "".concat(config.cssPrefix, "-").concat(DUOTONE_CLASSES.SECONDARY),
          fill: "currentColor",
          d: vectorData[0]
        }
      }, {
        tag: "path",
        attributes: {
          class: "".concat(config.cssPrefix, "-").concat(DUOTONE_CLASSES.PRIMARY),
          fill: "currentColor",
          d: vectorData[1]
        }
      }]
    };
  } else {
    element = {
      tag: "path",
      attributes: {
        fill: "currentColor",
        d: vectorData
      }
    };
  }
  return {
    found: true,
    width,
    height,
    icon: element
  };
}
var missingIconResolutionMixin = {
  found: false,
  width: 512,
  height: 512
};
function maybeNotifyMissing(iconName, prefix) {
  if (!PRODUCTION$1 && !config.showMissingIcons && iconName) {
    console.error('Icon with name "'.concat(iconName, '" and prefix "').concat(prefix, '" is missing.'));
  }
}
function findIcon(iconName, prefix) {
  var givenPrefix = prefix;
  if (prefix === "fa" && config.styleDefault !== null) {
    prefix = getDefaultUsablePrefix();
  }
  return new Promise(function(resolve, reject) {
    ({
      found: false,
      width: 512,
      height: 512,
      icon: callProvided("missingIconAbstract") || {}
    });
    if (givenPrefix === "fa") {
      var shim2 = byOldName(iconName) || {};
      iconName = shim2.iconName || iconName;
      prefix = shim2.prefix || prefix;
    }
    if (iconName && prefix && styles$1[prefix] && styles$1[prefix][iconName]) {
      var icon3 = styles$1[prefix][iconName];
      return resolve(asFoundIcon(icon3));
    }
    maybeNotifyMissing(iconName, prefix);
    resolve(_objectSpread2$1(_objectSpread2$1({}, missingIconResolutionMixin), {}, {
      icon: config.showMissingIcons && iconName ? callProvided("missingIconAbstract") || {} : {}
    }));
  });
}
var noop$1 = function noop3() {
};
var p$1 = config.measurePerformance && PERFORMANCE && PERFORMANCE.mark && PERFORMANCE.measure ? PERFORMANCE : {
  mark: noop$1,
  measure: noop$1
};
var preamble = 'FA "6.4.0"';
var begin = function begin2(name2) {
  p$1.mark("".concat(preamble, " ").concat(name2, " begins"));
  return function() {
    return end(name2);
  };
};
var end = function end2(name2) {
  p$1.mark("".concat(preamble, " ").concat(name2, " ends"));
  p$1.measure("".concat(preamble, " ").concat(name2), "".concat(preamble, " ").concat(name2, " begins"), "".concat(preamble, " ").concat(name2, " ends"));
};
var perf = {
  begin,
  end
};
var noop$2 = function noop4() {
};
function isWatched(node) {
  var i2svg2 = node.getAttribute ? node.getAttribute(DATA_FA_I2SVG) : null;
  return typeof i2svg2 === "string";
}
function hasPrefixAndIcon(node) {
  var prefix = node.getAttribute ? node.getAttribute(DATA_PREFIX) : null;
  var icon3 = node.getAttribute ? node.getAttribute(DATA_ICON) : null;
  return prefix && icon3;
}
function hasBeenReplaced(node) {
  return node && node.classList && node.classList.contains && node.classList.contains(config.replacementClass);
}
function getMutator() {
  if (config.autoReplaceSvg === true) {
    return mutators.replace;
  }
  var mutator = mutators[config.autoReplaceSvg];
  return mutator || mutators.replace;
}
function createElementNS(tag) {
  return DOCUMENT.createElementNS("http://www.w3.org/2000/svg", tag);
}
function createElement(tag) {
  return DOCUMENT.createElement(tag);
}
function convertSVG(abstractObj) {
  var params = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var _params$ceFn = params.ceFn, ceFn = _params$ceFn === void 0 ? abstractObj.tag === "svg" ? createElementNS : createElement : _params$ceFn;
  if (typeof abstractObj === "string") {
    return DOCUMENT.createTextNode(abstractObj);
  }
  var tag = ceFn(abstractObj.tag);
  Object.keys(abstractObj.attributes || []).forEach(function(key) {
    tag.setAttribute(key, abstractObj.attributes[key]);
  });
  var children = abstractObj.children || [];
  children.forEach(function(child) {
    tag.appendChild(convertSVG(child, {
      ceFn
    }));
  });
  return tag;
}
function nodeAsComment(node) {
  var comment = " ".concat(node.outerHTML, " ");
  comment = "".concat(comment, "Font Awesome fontawesome.com ");
  return comment;
}
var mutators = {
  replace: function replace(mutation) {
    var node = mutation[0];
    if (node.parentNode) {
      mutation[1].forEach(function(_abstract) {
        node.parentNode.insertBefore(convertSVG(_abstract), node);
      });
      if (node.getAttribute(DATA_FA_I2SVG) === null && config.keepOriginalSource) {
        var comment = DOCUMENT.createComment(nodeAsComment(node));
        node.parentNode.replaceChild(comment, node);
      } else {
        node.remove();
      }
    }
  },
  nest: function nest(mutation) {
    var node = mutation[0];
    var _abstract2 = mutation[1];
    if (~classArray(node).indexOf(config.replacementClass)) {
      return mutators.replace(mutation);
    }
    var forSvg = new RegExp("".concat(config.cssPrefix, "-.*"));
    delete _abstract2[0].attributes.id;
    if (_abstract2[0].attributes.class) {
      var splitClasses = _abstract2[0].attributes.class.split(" ").reduce(function(acc, cls) {
        if (cls === config.replacementClass || cls.match(forSvg)) {
          acc.toSvg.push(cls);
        } else {
          acc.toNode.push(cls);
        }
        return acc;
      }, {
        toNode: [],
        toSvg: []
      });
      _abstract2[0].attributes.class = splitClasses.toSvg.join(" ");
      if (splitClasses.toNode.length === 0) {
        node.removeAttribute("class");
      } else {
        node.setAttribute("class", splitClasses.toNode.join(" "));
      }
    }
    var newInnerHTML = _abstract2.map(function(a) {
      return toHtml(a);
    }).join("\n");
    node.setAttribute(DATA_FA_I2SVG, "");
    node.innerHTML = newInnerHTML;
  }
};
function performOperationSync(op) {
  op();
}
function perform(mutations, callback) {
  var callbackFunction = typeof callback === "function" ? callback : noop$2;
  if (mutations.length === 0) {
    callbackFunction();
  } else {
    var frame = performOperationSync;
    if (config.mutateApproach === MUTATION_APPROACH_ASYNC) {
      frame = WINDOW.requestAnimationFrame || performOperationSync;
    }
    frame(function() {
      var mutator = getMutator();
      var mark = perf.begin("mutate");
      mutations.map(mutator);
      mark();
      callbackFunction();
    });
  }
}
var disabled = false;
function disableObservation() {
  disabled = true;
}
function enableObservation() {
  disabled = false;
}
var mo = null;
function observe(options) {
  if (!MUTATION_OBSERVER) {
    return;
  }
  if (!config.observeMutations) {
    return;
  }
  var _options$treeCallback = options.treeCallback, treeCallback = _options$treeCallback === void 0 ? noop$2 : _options$treeCallback, _options$nodeCallback = options.nodeCallback, nodeCallback = _options$nodeCallback === void 0 ? noop$2 : _options$nodeCallback, _options$pseudoElemen = options.pseudoElementsCallback, pseudoElementsCallback = _options$pseudoElemen === void 0 ? noop$2 : _options$pseudoElemen, _options$observeMutat = options.observeMutationsRoot, observeMutationsRoot = _options$observeMutat === void 0 ? DOCUMENT : _options$observeMutat;
  mo = new MUTATION_OBSERVER(function(objects) {
    if (disabled)
      return;
    var defaultPrefix = getDefaultUsablePrefix();
    toArray(objects).forEach(function(mutationRecord) {
      if (mutationRecord.type === "childList" && mutationRecord.addedNodes.length > 0 && !isWatched(mutationRecord.addedNodes[0])) {
        if (config.searchPseudoElements) {
          pseudoElementsCallback(mutationRecord.target);
        }
        treeCallback(mutationRecord.target);
      }
      if (mutationRecord.type === "attributes" && mutationRecord.target.parentNode && config.searchPseudoElements) {
        pseudoElementsCallback(mutationRecord.target.parentNode);
      }
      if (mutationRecord.type === "attributes" && isWatched(mutationRecord.target) && ~ATTRIBUTES_WATCHED_FOR_MUTATION.indexOf(mutationRecord.attributeName)) {
        if (mutationRecord.attributeName === "class" && hasPrefixAndIcon(mutationRecord.target)) {
          var _getCanonicalIcon = getCanonicalIcon(classArray(mutationRecord.target)), prefix = _getCanonicalIcon.prefix, iconName = _getCanonicalIcon.iconName;
          mutationRecord.target.setAttribute(DATA_PREFIX, prefix || defaultPrefix);
          if (iconName)
            mutationRecord.target.setAttribute(DATA_ICON, iconName);
        } else if (hasBeenReplaced(mutationRecord.target)) {
          nodeCallback(mutationRecord.target);
        }
      }
    });
  });
  if (!IS_DOM)
    return;
  mo.observe(observeMutationsRoot, {
    childList: true,
    attributes: true,
    characterData: true,
    subtree: true
  });
}
function disconnect() {
  if (!mo)
    return;
  mo.disconnect();
}
function styleParser(node) {
  var style = node.getAttribute("style");
  var val = [];
  if (style) {
    val = style.split(";").reduce(function(acc, style2) {
      var styles2 = style2.split(":");
      var prop = styles2[0];
      var value = styles2.slice(1);
      if (prop && value.length > 0) {
        acc[prop] = value.join(":").trim();
      }
      return acc;
    }, {});
  }
  return val;
}
function classParser(node) {
  var existingPrefix = node.getAttribute("data-prefix");
  var existingIconName = node.getAttribute("data-icon");
  var innerText = node.innerText !== void 0 ? node.innerText.trim() : "";
  var val = getCanonicalIcon(classArray(node));
  if (!val.prefix) {
    val.prefix = getDefaultUsablePrefix();
  }
  if (existingPrefix && existingIconName) {
    val.prefix = existingPrefix;
    val.iconName = existingIconName;
  }
  if (val.iconName && val.prefix) {
    return val;
  }
  if (val.prefix && innerText.length > 0) {
    val.iconName = byLigature(val.prefix, node.innerText) || byUnicode(val.prefix, toHex(node.innerText));
  }
  if (!val.iconName && config.autoFetchSvg && node.firstChild && node.firstChild.nodeType === Node.TEXT_NODE) {
    val.iconName = node.firstChild.data;
  }
  return val;
}
function attributesParser(node) {
  var extraAttributes = toArray(node.attributes).reduce(function(acc, attr) {
    if (acc.name !== "class" && acc.name !== "style") {
      acc[attr.name] = attr.value;
    }
    return acc;
  }, {});
  var title = node.getAttribute("title");
  var titleId = node.getAttribute("data-fa-title-id");
  if (config.autoA11y) {
    if (title) {
      extraAttributes["aria-labelledby"] = "".concat(config.replacementClass, "-title-").concat(titleId || nextUniqueId());
    } else {
      extraAttributes["aria-hidden"] = "true";
      extraAttributes["focusable"] = "false";
    }
  }
  return extraAttributes;
}
function blankMeta() {
  return {
    iconName: null,
    title: null,
    titleId: null,
    prefix: null,
    transform: meaninglessTransform,
    symbol: false,
    mask: {
      iconName: null,
      prefix: null,
      rest: []
    },
    maskId: null,
    extra: {
      classes: [],
      styles: {},
      attributes: {}
    }
  };
}
function parseMeta(node) {
  var parser = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {
    styleParser: true
  };
  var _classParser = classParser(node), iconName = _classParser.iconName, prefix = _classParser.prefix, extraClasses = _classParser.rest;
  var extraAttributes = attributesParser(node);
  var pluginMeta = chainHooks("parseNodeAttributes", {}, node);
  var extraStyles = parser.styleParser ? styleParser(node) : [];
  return _objectSpread2$1({
    iconName,
    title: node.getAttribute("title"),
    titleId: node.getAttribute("data-fa-title-id"),
    prefix,
    transform: meaninglessTransform,
    mask: {
      iconName: null,
      prefix: null,
      rest: []
    },
    maskId: null,
    symbol: false,
    extra: {
      classes: extraClasses,
      styles: extraStyles,
      attributes: extraAttributes
    }
  }, pluginMeta);
}
var styles$2 = namespace.styles;
function generateMutation(node) {
  var nodeMeta = config.autoReplaceSvg === "nest" ? parseMeta(node, {
    styleParser: false
  }) : parseMeta(node);
  if (~nodeMeta.extra.classes.indexOf(LAYERS_TEXT_CLASSNAME)) {
    return callProvided("generateLayersText", node, nodeMeta);
  } else {
    return callProvided("generateSvgReplacementMutation", node, nodeMeta);
  }
}
var knownPrefixes = /* @__PURE__ */ new Set();
FAMILIES.map(function(family) {
  knownPrefixes.add("fa-".concat(family));
});
Object.keys(PREFIX_TO_STYLE[FAMILY_CLASSIC]).map(knownPrefixes.add.bind(knownPrefixes));
Object.keys(PREFIX_TO_STYLE[FAMILY_SHARP]).map(knownPrefixes.add.bind(knownPrefixes));
knownPrefixes = _toConsumableArray$1(knownPrefixes);
function onTree(root2) {
  var callback = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
  if (!IS_DOM)
    return Promise.resolve();
  var htmlClassList = DOCUMENT.documentElement.classList;
  var hclAdd = function hclAdd2(suffix) {
    return htmlClassList.add("".concat(HTML_CLASS_I2SVG_BASE_CLASS, "-").concat(suffix));
  };
  var hclRemove = function hclRemove2(suffix) {
    return htmlClassList.remove("".concat(HTML_CLASS_I2SVG_BASE_CLASS, "-").concat(suffix));
  };
  var prefixes2 = config.autoFetchSvg ? knownPrefixes : FAMILIES.map(function(f2) {
    return "fa-".concat(f2);
  }).concat(Object.keys(styles$2));
  if (!prefixes2.includes("fa")) {
    prefixes2.push("fa");
  }
  var prefixesDomQuery = [".".concat(LAYERS_TEXT_CLASSNAME, ":not([").concat(DATA_FA_I2SVG, "])")].concat(prefixes2.map(function(p2) {
    return ".".concat(p2, ":not([").concat(DATA_FA_I2SVG, "])");
  })).join(", ");
  if (prefixesDomQuery.length === 0) {
    return Promise.resolve();
  }
  var candidates = [];
  try {
    candidates = toArray(root2.querySelectorAll(prefixesDomQuery));
  } catch (e) {
  }
  if (candidates.length > 0) {
    hclAdd("pending");
    hclRemove("complete");
  } else {
    return Promise.resolve();
  }
  var mark = perf.begin("onTree");
  var mutations = candidates.reduce(function(acc, node) {
    try {
      var mutation = generateMutation(node);
      if (mutation) {
        acc.push(mutation);
      }
    } catch (e) {
      if (!PRODUCTION$1) {
        if (e.name === "MissingIcon") {
          console.error(e);
        }
      }
    }
    return acc;
  }, []);
  return new Promise(function(resolve, reject) {
    Promise.all(mutations).then(function(resolvedMutations) {
      perform(resolvedMutations, function() {
        hclAdd("active");
        hclAdd("complete");
        hclRemove("pending");
        if (typeof callback === "function")
          callback();
        mark();
        resolve();
      });
    }).catch(function(e) {
      mark();
      reject(e);
    });
  });
}
function onNode(node) {
  var callback = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
  generateMutation(node).then(function(mutation) {
    if (mutation) {
      perform([mutation], callback);
    }
  });
}
function resolveIcons(next) {
  return function(maybeIconDefinition) {
    var params = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    var iconDefinition = (maybeIconDefinition || {}).icon ? maybeIconDefinition : findIconDefinition(maybeIconDefinition || {});
    var mask = params.mask;
    if (mask) {
      mask = (mask || {}).icon ? mask : findIconDefinition(mask || {});
    }
    return next(iconDefinition, _objectSpread2$1(_objectSpread2$1({}, params), {}, {
      mask
    }));
  };
}
var render = function render2(iconDefinition) {
  var params = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var _params$transform = params.transform, transform = _params$transform === void 0 ? meaninglessTransform : _params$transform, _params$symbol = params.symbol, symbol = _params$symbol === void 0 ? false : _params$symbol, _params$mask = params.mask, mask = _params$mask === void 0 ? null : _params$mask, _params$maskId = params.maskId, maskId = _params$maskId === void 0 ? null : _params$maskId, _params$title = params.title, title = _params$title === void 0 ? null : _params$title, _params$titleId = params.titleId, titleId = _params$titleId === void 0 ? null : _params$titleId, _params$classes = params.classes, classes = _params$classes === void 0 ? [] : _params$classes, _params$attributes = params.attributes, attributes = _params$attributes === void 0 ? {} : _params$attributes, _params$styles = params.styles, styles2 = _params$styles === void 0 ? {} : _params$styles;
  if (!iconDefinition)
    return;
  var prefix = iconDefinition.prefix, iconName = iconDefinition.iconName, icon3 = iconDefinition.icon;
  return domVariants(_objectSpread2$1({
    type: "icon"
  }, iconDefinition), function() {
    callHooks("beforeDOMElementCreation", {
      iconDefinition,
      params
    });
    if (config.autoA11y) {
      if (title) {
        attributes["aria-labelledby"] = "".concat(config.replacementClass, "-title-").concat(titleId || nextUniqueId());
      } else {
        attributes["aria-hidden"] = "true";
        attributes["focusable"] = "false";
      }
    }
    return makeInlineSvgAbstract({
      icons: {
        main: asFoundIcon(icon3),
        mask: mask ? asFoundIcon(mask.icon) : {
          found: false,
          width: null,
          height: null,
          icon: {}
        }
      },
      prefix,
      iconName,
      transform: _objectSpread2$1(_objectSpread2$1({}, meaninglessTransform), transform),
      symbol,
      title,
      maskId,
      titleId,
      extra: {
        attributes,
        styles: styles2,
        classes
      }
    });
  });
};
var ReplaceElements = {
  mixout: function mixout2() {
    return {
      icon: resolveIcons(render)
    };
  },
  hooks: function hooks2() {
    return {
      mutationObserverCallbacks: function mutationObserverCallbacks(accumulator) {
        accumulator.treeCallback = onTree;
        accumulator.nodeCallback = onNode;
        return accumulator;
      }
    };
  },
  provides: function provides(providers$$1) {
    providers$$1.i2svg = function(params) {
      var _params$node = params.node, node = _params$node === void 0 ? DOCUMENT : _params$node, _params$callback = params.callback, callback = _params$callback === void 0 ? function() {
      } : _params$callback;
      return onTree(node, callback);
    };
    providers$$1.generateSvgReplacementMutation = function(node, nodeMeta) {
      var iconName = nodeMeta.iconName, title = nodeMeta.title, titleId = nodeMeta.titleId, prefix = nodeMeta.prefix, transform = nodeMeta.transform, symbol = nodeMeta.symbol, mask = nodeMeta.mask, maskId = nodeMeta.maskId, extra = nodeMeta.extra;
      return new Promise(function(resolve, reject) {
        Promise.all([findIcon(iconName, prefix), mask.iconName ? findIcon(mask.iconName, mask.prefix) : Promise.resolve({
          found: false,
          width: 512,
          height: 512,
          icon: {}
        })]).then(function(_ref2) {
          var _ref22 = _slicedToArray(_ref2, 2), main = _ref22[0], mask2 = _ref22[1];
          resolve([node, makeInlineSvgAbstract({
            icons: {
              main,
              mask: mask2
            },
            prefix,
            iconName,
            transform,
            symbol,
            maskId,
            title,
            titleId,
            extra,
            watchable: true
          })]);
        }).catch(reject);
      });
    };
    providers$$1.generateAbstractIcon = function(_ref3) {
      var children = _ref3.children, attributes = _ref3.attributes, main = _ref3.main, transform = _ref3.transform, styles2 = _ref3.styles;
      var styleString = joinStyles(styles2);
      if (styleString.length > 0) {
        attributes["style"] = styleString;
      }
      var nextChild;
      if (transformIsMeaningful(transform)) {
        nextChild = callProvided("generateAbstractTransformGrouping", {
          main,
          transform,
          containerWidth: main.width,
          iconWidth: main.width
        });
      }
      children.push(nextChild || main.icon);
      return {
        children,
        attributes
      };
    };
  }
};
var Layers = {
  mixout: function mixout3() {
    return {
      layer: function layer(assembler) {
        var params = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        var _params$classes = params.classes, classes = _params$classes === void 0 ? [] : _params$classes;
        return domVariants({
          type: "layer"
        }, function() {
          callHooks("beforeDOMElementCreation", {
            assembler,
            params
          });
          var children = [];
          assembler(function(args) {
            Array.isArray(args) ? args.map(function(a) {
              children = children.concat(a.abstract);
            }) : children = children.concat(args.abstract);
          });
          return [{
            tag: "span",
            attributes: {
              class: ["".concat(config.cssPrefix, "-layers")].concat(_toConsumableArray$1(classes)).join(" ")
            },
            children
          }];
        });
      }
    };
  }
};
var LayersCounter = {
  mixout: function mixout4() {
    return {
      counter: function counter2(content) {
        var params = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        var _params$title = params.title, title = _params$title === void 0 ? null : _params$title, _params$classes = params.classes, classes = _params$classes === void 0 ? [] : _params$classes, _params$attributes = params.attributes, attributes = _params$attributes === void 0 ? {} : _params$attributes, _params$styles = params.styles, styles2 = _params$styles === void 0 ? {} : _params$styles;
        return domVariants({
          type: "counter",
          content
        }, function() {
          callHooks("beforeDOMElementCreation", {
            content,
            params
          });
          return makeLayersCounterAbstract({
            content: content.toString(),
            title,
            extra: {
              attributes,
              styles: styles2,
              classes: ["".concat(config.cssPrefix, "-layers-counter")].concat(_toConsumableArray$1(classes))
            }
          });
        });
      }
    };
  }
};
var LayersText = {
  mixout: function mixout5() {
    return {
      text: function text(content) {
        var params = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        var _params$transform = params.transform, transform = _params$transform === void 0 ? meaninglessTransform : _params$transform, _params$title = params.title, title = _params$title === void 0 ? null : _params$title, _params$classes = params.classes, classes = _params$classes === void 0 ? [] : _params$classes, _params$attributes = params.attributes, attributes = _params$attributes === void 0 ? {} : _params$attributes, _params$styles = params.styles, styles2 = _params$styles === void 0 ? {} : _params$styles;
        return domVariants({
          type: "text",
          content
        }, function() {
          callHooks("beforeDOMElementCreation", {
            content,
            params
          });
          return makeLayersTextAbstract({
            content,
            transform: _objectSpread2$1(_objectSpread2$1({}, meaninglessTransform), transform),
            title,
            extra: {
              attributes,
              styles: styles2,
              classes: ["".concat(config.cssPrefix, "-layers-text")].concat(_toConsumableArray$1(classes))
            }
          });
        });
      }
    };
  },
  provides: function provides2(providers$$1) {
    providers$$1.generateLayersText = function(node, nodeMeta) {
      var title = nodeMeta.title, transform = nodeMeta.transform, extra = nodeMeta.extra;
      var width = null;
      var height = null;
      if (IS_IE) {
        var computedFontSize = parseInt(getComputedStyle(node).fontSize, 10);
        var boundingClientRect = node.getBoundingClientRect();
        width = boundingClientRect.width / computedFontSize;
        height = boundingClientRect.height / computedFontSize;
      }
      if (config.autoA11y && !title) {
        extra.attributes["aria-hidden"] = "true";
      }
      return Promise.resolve([node, makeLayersTextAbstract({
        content: node.innerHTML,
        width,
        height,
        transform,
        title,
        extra,
        watchable: true
      })]);
    };
  }
};
var CLEAN_CONTENT_PATTERN = new RegExp('"', "ug");
var SECONDARY_UNICODE_RANGE = [1105920, 1112319];
function hexValueFromContent(content) {
  var cleaned = content.replace(CLEAN_CONTENT_PATTERN, "");
  var codePoint = codePointAt(cleaned, 0);
  var isPrependTen = codePoint >= SECONDARY_UNICODE_RANGE[0] && codePoint <= SECONDARY_UNICODE_RANGE[1];
  var isDoubled = cleaned.length === 2 ? cleaned[0] === cleaned[1] : false;
  return {
    value: isDoubled ? toHex(cleaned[0]) : toHex(cleaned),
    isSecondary: isPrependTen || isDoubled
  };
}
function replaceForPosition(node, position) {
  var pendingAttribute = "".concat(DATA_FA_PSEUDO_ELEMENT_PENDING).concat(position.replace(":", "-"));
  return new Promise(function(resolve, reject) {
    if (node.getAttribute(pendingAttribute) !== null) {
      return resolve();
    }
    var children = toArray(node.children);
    var alreadyProcessedPseudoElement = children.filter(function(c) {
      return c.getAttribute(DATA_FA_PSEUDO_ELEMENT) === position;
    })[0];
    var styles2 = WINDOW.getComputedStyle(node, position);
    var fontFamily = styles2.getPropertyValue("font-family").match(FONT_FAMILY_PATTERN);
    var fontWeight = styles2.getPropertyValue("font-weight");
    var content = styles2.getPropertyValue("content");
    if (alreadyProcessedPseudoElement && !fontFamily) {
      node.removeChild(alreadyProcessedPseudoElement);
      return resolve();
    } else if (fontFamily && content !== "none" && content !== "") {
      var _content = styles2.getPropertyValue("content");
      var family = ~["Sharp"].indexOf(fontFamily[2]) ? FAMILY_SHARP : FAMILY_CLASSIC;
      var prefix = ~["Solid", "Regular", "Light", "Thin", "Duotone", "Brands", "Kit"].indexOf(fontFamily[2]) ? STYLE_TO_PREFIX[family][fontFamily[2].toLowerCase()] : FONT_WEIGHT_TO_PREFIX[family][fontWeight];
      var _hexValueFromContent = hexValueFromContent(_content), hexValue = _hexValueFromContent.value, isSecondary = _hexValueFromContent.isSecondary;
      var isV4 = fontFamily[0].startsWith("FontAwesome");
      var iconName = byUnicode(prefix, hexValue);
      var iconIdentifier = iconName;
      if (isV4) {
        var iconName4 = byOldUnicode(hexValue);
        if (iconName4.iconName && iconName4.prefix) {
          iconName = iconName4.iconName;
          prefix = iconName4.prefix;
        }
      }
      if (iconName && !isSecondary && (!alreadyProcessedPseudoElement || alreadyProcessedPseudoElement.getAttribute(DATA_PREFIX) !== prefix || alreadyProcessedPseudoElement.getAttribute(DATA_ICON) !== iconIdentifier)) {
        node.setAttribute(pendingAttribute, iconIdentifier);
        if (alreadyProcessedPseudoElement) {
          node.removeChild(alreadyProcessedPseudoElement);
        }
        var meta = blankMeta();
        var extra = meta.extra;
        extra.attributes[DATA_FA_PSEUDO_ELEMENT] = position;
        findIcon(iconName, prefix).then(function(main) {
          var _abstract = makeInlineSvgAbstract(_objectSpread2$1(_objectSpread2$1({}, meta), {}, {
            icons: {
              main,
              mask: emptyCanonicalIcon()
            },
            prefix,
            iconName: iconIdentifier,
            extra,
            watchable: true
          }));
          var element = DOCUMENT.createElement("svg");
          if (position === "::before") {
            node.insertBefore(element, node.firstChild);
          } else {
            node.appendChild(element);
          }
          element.outerHTML = _abstract.map(function(a) {
            return toHtml(a);
          }).join("\n");
          node.removeAttribute(pendingAttribute);
          resolve();
        }).catch(reject);
      } else {
        resolve();
      }
    } else {
      resolve();
    }
  });
}
function replace2(node) {
  return Promise.all([replaceForPosition(node, "::before"), replaceForPosition(node, "::after")]);
}
function processable(node) {
  return node.parentNode !== document.head && !~TAGNAMES_TO_SKIP_FOR_PSEUDOELEMENTS.indexOf(node.tagName.toUpperCase()) && !node.getAttribute(DATA_FA_PSEUDO_ELEMENT) && (!node.parentNode || node.parentNode.tagName !== "svg");
}
function searchPseudoElements(root2) {
  if (!IS_DOM)
    return;
  return new Promise(function(resolve, reject) {
    var operations = toArray(root2.querySelectorAll("*")).filter(processable).map(replace2);
    var end3 = perf.begin("searchPseudoElements");
    disableObservation();
    Promise.all(operations).then(function() {
      end3();
      enableObservation();
      resolve();
    }).catch(function() {
      end3();
      enableObservation();
      reject();
    });
  });
}
var PseudoElements = {
  hooks: function hooks3() {
    return {
      mutationObserverCallbacks: function mutationObserverCallbacks(accumulator) {
        accumulator.pseudoElementsCallback = searchPseudoElements;
        return accumulator;
      }
    };
  },
  provides: function provides3(providers$$1) {
    providers$$1.pseudoElements2svg = function(params) {
      var _params$node = params.node, node = _params$node === void 0 ? DOCUMENT : _params$node;
      if (config.searchPseudoElements) {
        searchPseudoElements(node);
      }
    };
  }
};
var _unwatched = false;
var MutationObserver$1 = {
  mixout: function mixout6() {
    return {
      dom: {
        unwatch: function unwatch() {
          disableObservation();
          _unwatched = true;
        }
      }
    };
  },
  hooks: function hooks4() {
    return {
      bootstrap: function bootstrap() {
        observe(chainHooks("mutationObserverCallbacks", {}));
      },
      noAuto: function noAuto3() {
        disconnect();
      },
      watch: function watch2(params) {
        var observeMutationsRoot = params.observeMutationsRoot;
        if (_unwatched) {
          enableObservation();
        } else {
          observe(chainHooks("mutationObserverCallbacks", {
            observeMutationsRoot
          }));
        }
      }
    };
  }
};
var parseTransformString = function parseTransformString2(transformString) {
  var transform = {
    size: 16,
    x: 0,
    y: 0,
    flipX: false,
    flipY: false,
    rotate: 0
  };
  return transformString.toLowerCase().split(" ").reduce(function(acc, n2) {
    var parts = n2.toLowerCase().split("-");
    var first = parts[0];
    var rest = parts.slice(1).join("-");
    if (first && rest === "h") {
      acc.flipX = true;
      return acc;
    }
    if (first && rest === "v") {
      acc.flipY = true;
      return acc;
    }
    rest = parseFloat(rest);
    if (isNaN(rest)) {
      return acc;
    }
    switch (first) {
      case "grow":
        acc.size = acc.size + rest;
        break;
      case "shrink":
        acc.size = acc.size - rest;
        break;
      case "left":
        acc.x = acc.x - rest;
        break;
      case "right":
        acc.x = acc.x + rest;
        break;
      case "up":
        acc.y = acc.y - rest;
        break;
      case "down":
        acc.y = acc.y + rest;
        break;
      case "rotate":
        acc.rotate = acc.rotate + rest;
        break;
    }
    return acc;
  }, transform);
};
var PowerTransforms = {
  mixout: function mixout7() {
    return {
      parse: {
        transform: function transform(transformString) {
          return parseTransformString(transformString);
        }
      }
    };
  },
  hooks: function hooks5() {
    return {
      parseNodeAttributes: function parseNodeAttributes(accumulator, node) {
        var transformString = node.getAttribute("data-fa-transform");
        if (transformString) {
          accumulator.transform = parseTransformString(transformString);
        }
        return accumulator;
      }
    };
  },
  provides: function provides4(providers2) {
    providers2.generateAbstractTransformGrouping = function(_ref2) {
      var main = _ref2.main, transform = _ref2.transform, containerWidth = _ref2.containerWidth, iconWidth = _ref2.iconWidth;
      var outer = {
        transform: "translate(".concat(containerWidth / 2, " 256)")
      };
      var innerTranslate = "translate(".concat(transform.x * 32, ", ").concat(transform.y * 32, ") ");
      var innerScale = "scale(".concat(transform.size / 16 * (transform.flipX ? -1 : 1), ", ").concat(transform.size / 16 * (transform.flipY ? -1 : 1), ") ");
      var innerRotate = "rotate(".concat(transform.rotate, " 0 0)");
      var inner2 = {
        transform: "".concat(innerTranslate, " ").concat(innerScale, " ").concat(innerRotate)
      };
      var path = {
        transform: "translate(".concat(iconWidth / 2 * -1, " -256)")
      };
      var operations = {
        outer,
        inner: inner2,
        path
      };
      return {
        tag: "g",
        attributes: _objectSpread2$1({}, operations.outer),
        children: [{
          tag: "g",
          attributes: _objectSpread2$1({}, operations.inner),
          children: [{
            tag: main.icon.tag,
            children: main.icon.children,
            attributes: _objectSpread2$1(_objectSpread2$1({}, main.icon.attributes), operations.path)
          }]
        }]
      };
    };
  }
};
var ALL_SPACE = {
  x: 0,
  y: 0,
  width: "100%",
  height: "100%"
};
function fillBlack(_abstract) {
  var force = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
  if (_abstract.attributes && (_abstract.attributes.fill || force)) {
    _abstract.attributes.fill = "black";
  }
  return _abstract;
}
function deGroup(_abstract2) {
  if (_abstract2.tag === "g") {
    return _abstract2.children;
  } else {
    return [_abstract2];
  }
}
var Masks = {
  hooks: function hooks6() {
    return {
      parseNodeAttributes: function parseNodeAttributes(accumulator, node) {
        var maskData = node.getAttribute("data-fa-mask");
        var mask = !maskData ? emptyCanonicalIcon() : getCanonicalIcon(maskData.split(" ").map(function(i) {
          return i.trim();
        }));
        if (!mask.prefix) {
          mask.prefix = getDefaultUsablePrefix();
        }
        accumulator.mask = mask;
        accumulator.maskId = node.getAttribute("data-fa-mask-id");
        return accumulator;
      }
    };
  },
  provides: function provides5(providers2) {
    providers2.generateAbstractMask = function(_ref2) {
      var children = _ref2.children, attributes = _ref2.attributes, main = _ref2.main, mask = _ref2.mask, explicitMaskId = _ref2.maskId, transform = _ref2.transform;
      var mainWidth = main.width, mainPath = main.icon;
      var maskWidth = mask.width, maskPath = mask.icon;
      var trans = transformForSvg({
        transform,
        containerWidth: maskWidth,
        iconWidth: mainWidth
      });
      var maskRect = {
        tag: "rect",
        attributes: _objectSpread2$1(_objectSpread2$1({}, ALL_SPACE), {}, {
          fill: "white"
        })
      };
      var maskInnerGroupChildrenMixin = mainPath.children ? {
        children: mainPath.children.map(fillBlack)
      } : {};
      var maskInnerGroup = {
        tag: "g",
        attributes: _objectSpread2$1({}, trans.inner),
        children: [fillBlack(_objectSpread2$1({
          tag: mainPath.tag,
          attributes: _objectSpread2$1(_objectSpread2$1({}, mainPath.attributes), trans.path)
        }, maskInnerGroupChildrenMixin))]
      };
      var maskOuterGroup = {
        tag: "g",
        attributes: _objectSpread2$1({}, trans.outer),
        children: [maskInnerGroup]
      };
      var maskId = "mask-".concat(explicitMaskId || nextUniqueId());
      var clipId = "clip-".concat(explicitMaskId || nextUniqueId());
      var maskTag = {
        tag: "mask",
        attributes: _objectSpread2$1(_objectSpread2$1({}, ALL_SPACE), {}, {
          id: maskId,
          maskUnits: "userSpaceOnUse",
          maskContentUnits: "userSpaceOnUse"
        }),
        children: [maskRect, maskOuterGroup]
      };
      var defs = {
        tag: "defs",
        children: [{
          tag: "clipPath",
          attributes: {
            id: clipId
          },
          children: deGroup(maskPath)
        }, maskTag]
      };
      children.push(defs, {
        tag: "rect",
        attributes: _objectSpread2$1({
          fill: "currentColor",
          "clip-path": "url(#".concat(clipId, ")"),
          mask: "url(#".concat(maskId, ")")
        }, ALL_SPACE)
      });
      return {
        children,
        attributes
      };
    };
  }
};
var MissingIconIndicator = {
  provides: function provides6(providers2) {
    var reduceMotion = false;
    if (WINDOW.matchMedia) {
      reduceMotion = WINDOW.matchMedia("(prefers-reduced-motion: reduce)").matches;
    }
    providers2.missingIconAbstract = function() {
      var gChildren = [];
      var FILL = {
        fill: "currentColor"
      };
      var ANIMATION_BASE = {
        attributeType: "XML",
        repeatCount: "indefinite",
        dur: "2s"
      };
      gChildren.push({
        tag: "path",
        attributes: _objectSpread2$1(_objectSpread2$1({}, FILL), {}, {
          d: "M156.5,447.7l-12.6,29.5c-18.7-9.5-35.9-21.2-51.5-34.9l22.7-22.7C127.6,430.5,141.5,440,156.5,447.7z M40.6,272H8.5 c1.4,21.2,5.4,41.7,11.7,61.1L50,321.2C45.1,305.5,41.8,289,40.6,272z M40.6,240c1.4-18.8,5.2-37,11.1-54.1l-29.5-12.6 C14.7,194.3,10,216.7,8.5,240H40.6z M64.3,156.5c7.8-14.9,17.2-28.8,28.1-41.5L69.7,92.3c-13.7,15.6-25.5,32.8-34.9,51.5 L64.3,156.5z M397,419.6c-13.9,12-29.4,22.3-46.1,30.4l11.9,29.8c20.7-9.9,39.8-22.6,56.9-37.6L397,419.6z M115,92.4 c13.9-12,29.4-22.3,46.1-30.4l-11.9-29.8c-20.7,9.9-39.8,22.6-56.8,37.6L115,92.4z M447.7,355.5c-7.8,14.9-17.2,28.8-28.1,41.5 l22.7,22.7c13.7-15.6,25.5-32.9,34.9-51.5L447.7,355.5z M471.4,272c-1.4,18.8-5.2,37-11.1,54.1l29.5,12.6 c7.5-21.1,12.2-43.5,13.6-66.8H471.4z M321.2,462c-15.7,5-32.2,8.2-49.2,9.4v32.1c21.2-1.4,41.7-5.4,61.1-11.7L321.2,462z M240,471.4c-18.8-1.4-37-5.2-54.1-11.1l-12.6,29.5c21.1,7.5,43.5,12.2,66.8,13.6V471.4z M462,190.8c5,15.7,8.2,32.2,9.4,49.2h32.1 c-1.4-21.2-5.4-41.7-11.7-61.1L462,190.8z M92.4,397c-12-13.9-22.3-29.4-30.4-46.1l-29.8,11.9c9.9,20.7,22.6,39.8,37.6,56.9 L92.4,397z M272,40.6c18.8,1.4,36.9,5.2,54.1,11.1l12.6-29.5C317.7,14.7,295.3,10,272,8.5V40.6z M190.8,50 c15.7-5,32.2-8.2,49.2-9.4V8.5c-21.2,1.4-41.7,5.4-61.1,11.7L190.8,50z M442.3,92.3L419.6,115c12,13.9,22.3,29.4,30.5,46.1 l29.8-11.9C470,128.5,457.3,109.4,442.3,92.3z M397,92.4l22.7-22.7c-15.6-13.7-32.8-25.5-51.5-34.9l-12.6,29.5 C370.4,72.1,384.4,81.5,397,92.4z"
        })
      });
      var OPACITY_ANIMATE = _objectSpread2$1(_objectSpread2$1({}, ANIMATION_BASE), {}, {
        attributeName: "opacity"
      });
      var dot = {
        tag: "circle",
        attributes: _objectSpread2$1(_objectSpread2$1({}, FILL), {}, {
          cx: "256",
          cy: "364",
          r: "28"
        }),
        children: []
      };
      if (!reduceMotion) {
        dot.children.push({
          tag: "animate",
          attributes: _objectSpread2$1(_objectSpread2$1({}, ANIMATION_BASE), {}, {
            attributeName: "r",
            values: "28;14;28;28;14;28;"
          })
        }, {
          tag: "animate",
          attributes: _objectSpread2$1(_objectSpread2$1({}, OPACITY_ANIMATE), {}, {
            values: "1;0;1;1;0;1;"
          })
        });
      }
      gChildren.push(dot);
      gChildren.push({
        tag: "path",
        attributes: _objectSpread2$1(_objectSpread2$1({}, FILL), {}, {
          opacity: "1",
          d: "M263.7,312h-16c-6.6,0-12-5.4-12-12c0-71,77.4-63.9,77.4-107.8c0-20-17.8-40.2-57.4-40.2c-29.1,0-44.3,9.6-59.2,28.7 c-3.9,5-11.1,6-16.2,2.4l-13.1-9.2c-5.6-3.9-6.9-11.8-2.6-17.2c21.2-27.2,46.4-44.7,91.2-44.7c52.3,0,97.4,29.8,97.4,80.2 c0,67.6-77.4,63.5-77.4,107.8C275.7,306.6,270.3,312,263.7,312z"
        }),
        children: reduceMotion ? [] : [{
          tag: "animate",
          attributes: _objectSpread2$1(_objectSpread2$1({}, OPACITY_ANIMATE), {}, {
            values: "1;0;0;0;0;1;"
          })
        }]
      });
      if (!reduceMotion) {
        gChildren.push({
          tag: "path",
          attributes: _objectSpread2$1(_objectSpread2$1({}, FILL), {}, {
            opacity: "0",
            d: "M232.5,134.5l7,168c0.3,6.4,5.6,11.5,12,11.5h9c6.4,0,11.7-5.1,12-11.5l7-168c0.3-6.8-5.2-12.5-12-12.5h-23 C237.7,122,232.2,127.7,232.5,134.5z"
          }),
          children: [{
            tag: "animate",
            attributes: _objectSpread2$1(_objectSpread2$1({}, OPACITY_ANIMATE), {}, {
              values: "0;0;1;1;0;0;"
            })
          }]
        });
      }
      return {
        tag: "g",
        attributes: {
          "class": "missing"
        },
        children: gChildren
      };
    };
  }
};
var SvgSymbols = {
  hooks: function hooks7() {
    return {
      parseNodeAttributes: function parseNodeAttributes(accumulator, node) {
        var symbolData = node.getAttribute("data-fa-symbol");
        var symbol = symbolData === null ? false : symbolData === "" ? true : symbolData;
        accumulator["symbol"] = symbol;
        return accumulator;
      }
    };
  }
};
var plugins = [InjectCSS, ReplaceElements, Layers, LayersCounter, LayersText, PseudoElements, MutationObserver$1, PowerTransforms, Masks, MissingIconIndicator, SvgSymbols];
registerPlugins(plugins, {
  mixoutsTo: api
});
api.noAuto;
api.config;
api.library;
api.dom;
var parse$1 = api.parse;
api.findIconDefinition;
api.toHtml;
var icon2 = api.icon;
api.layer;
api.text;
api.counter;
function ownKeys$a(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$a(Object(source), true).forEach(function(key) {
      _defineProperty$w(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$a(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _typeof(obj) {
  "@babel/helpers - typeof";
  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj2) {
    return typeof obj2;
  } : function(obj2) {
    return obj2 && "function" == typeof Symbol && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof(obj);
}
function _defineProperty$w(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null)
    return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0)
      continue;
    target[key] = source[key];
  }
  return target;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null)
    return {};
  var target = _objectWithoutPropertiesLoose(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0)
        continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key))
        continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr))
    return _arrayLikeToArray(arr);
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null)
    return Array.from(iter);
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n2 = Object.prototype.toString.call(o).slice(8, -1);
  if (n2 === "Object" && o.constructor)
    n2 = o.constructor.name;
  if (n2 === "Map" || n2 === "Set")
    return Array.from(o);
  if (n2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function classList(props) {
  var _classes;
  var beat = props.beat, fade = props.fade, beatFade = props.beatFade, bounce = props.bounce, shake = props.shake, flash = props.flash, spin = props.spin, spinPulse = props.spinPulse, spinReverse = props.spinReverse, pulse = props.pulse, fixedWidth = props.fixedWidth, inverse = props.inverse, border = props.border, listItem = props.listItem, flip2 = props.flip, size = props.size, rotation = props.rotation, pull = props.pull;
  var classes = (_classes = {
    "fa-beat": beat,
    "fa-fade": fade,
    "fa-beat-fade": beatFade,
    "fa-bounce": bounce,
    "fa-shake": shake,
    "fa-flash": flash,
    "fa-spin": spin,
    "fa-spin-reverse": spinReverse,
    "fa-spin-pulse": spinPulse,
    "fa-pulse": pulse,
    "fa-fw": fixedWidth,
    "fa-inverse": inverse,
    "fa-border": border,
    "fa-li": listItem,
    "fa-flip": flip2 === true,
    "fa-flip-horizontal": flip2 === "horizontal" || flip2 === "both",
    "fa-flip-vertical": flip2 === "vertical" || flip2 === "both"
  }, _defineProperty$w(_classes, "fa-".concat(size), typeof size !== "undefined" && size !== null), _defineProperty$w(_classes, "fa-rotate-".concat(rotation), typeof rotation !== "undefined" && rotation !== null && rotation !== 0), _defineProperty$w(_classes, "fa-pull-".concat(pull), typeof pull !== "undefined" && pull !== null), _defineProperty$w(_classes, "fa-swap-opacity", props.swapOpacity), _classes);
  return Object.keys(classes).map(function(key) {
    return classes[key] ? key : null;
  }).filter(function(key) {
    return key;
  });
}
function _isNumerical(obj) {
  obj = obj - 0;
  return obj === obj;
}
function camelize(string) {
  if (_isNumerical(string)) {
    return string;
  }
  string = string.replace(/[\-_\s]+(.)?/g, function(match, chr) {
    return chr ? chr.toUpperCase() : "";
  });
  return string.substr(0, 1).toLowerCase() + string.substr(1);
}
var _excluded = ["style"];
function capitalize(val) {
  return val.charAt(0).toUpperCase() + val.slice(1);
}
function styleToObject(style) {
  return style.split(";").map(function(s) {
    return s.trim();
  }).filter(function(s) {
    return s;
  }).reduce(function(acc, pair) {
    var i = pair.indexOf(":");
    var prop = camelize(pair.slice(0, i));
    var value = pair.slice(i + 1).trim();
    prop.startsWith("webkit") ? acc[capitalize(prop)] = value : acc[prop] = value;
    return acc;
  }, {});
}
function convert(createElement2, element) {
  var extraProps = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
  if (typeof element === "string") {
    return element;
  }
  var children = (element.children || []).map(function(child) {
    return convert(createElement2, child);
  });
  var mixins = Object.keys(element.attributes || {}).reduce(function(acc, key) {
    var val = element.attributes[key];
    switch (key) {
      case "class":
        acc.attrs["className"] = val;
        delete element.attributes["class"];
        break;
      case "style":
        acc.attrs["style"] = styleToObject(val);
        break;
      default:
        if (key.indexOf("aria-") === 0 || key.indexOf("data-") === 0) {
          acc.attrs[key.toLowerCase()] = val;
        } else {
          acc.attrs[camelize(key)] = val;
        }
    }
    return acc;
  }, {
    attrs: {}
  });
  var _extraProps$style = extraProps.style, existingStyle = _extraProps$style === void 0 ? {} : _extraProps$style, remaining = _objectWithoutProperties(extraProps, _excluded);
  mixins.attrs["style"] = _objectSpread2(_objectSpread2({}, mixins.attrs["style"]), existingStyle);
  return createElement2.apply(void 0, [element.tag, _objectSpread2(_objectSpread2({}, mixins.attrs), remaining)].concat(_toConsumableArray(children)));
}
var PRODUCTION = false;
try {
  PRODUCTION = true;
} catch (e) {
}
function log$c() {
  if (!PRODUCTION && console && typeof console.error === "function") {
    var _console;
    (_console = console).error.apply(_console, arguments);
  }
}
function normalizeIconArgs(icon3) {
  if (icon3 && _typeof(icon3) === "object" && icon3.prefix && icon3.iconName && icon3.icon) {
    return icon3;
  }
  if (parse$1.icon) {
    return parse$1.icon(icon3);
  }
  if (icon3 === null) {
    return null;
  }
  if (icon3 && _typeof(icon3) === "object" && icon3.prefix && icon3.iconName) {
    return icon3;
  }
  if (Array.isArray(icon3) && icon3.length === 2) {
    return {
      prefix: icon3[0],
      iconName: icon3[1]
    };
  }
  if (typeof icon3 === "string") {
    return {
      prefix: "fas",
      iconName: icon3
    };
  }
}
function objectWithKey(key, value) {
  return Array.isArray(value) && value.length > 0 || !Array.isArray(value) && value ? _defineProperty$w({}, key, value) : {};
}
var FontAwesomeIcon = /* @__PURE__ */ React.forwardRef(function(props, ref) {
  var iconArgs = props.icon, maskArgs = props.mask, symbol = props.symbol, className = props.className, title = props.title, titleId = props.titleId, maskId = props.maskId;
  var iconLookup = normalizeIconArgs(iconArgs);
  var classes = objectWithKey("classes", [].concat(_toConsumableArray(classList(props)), _toConsumableArray(className.split(" "))));
  var transform = objectWithKey("transform", typeof props.transform === "string" ? parse$1.transform(props.transform) : props.transform);
  var mask = objectWithKey("mask", normalizeIconArgs(maskArgs));
  var renderedIcon = icon2(iconLookup, _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, classes), transform), mask), {}, {
    symbol,
    title,
    titleId,
    maskId
  }));
  if (!renderedIcon) {
    log$c("Could not find icon", iconLookup);
    return null;
  }
  var abstract = renderedIcon.abstract;
  var extraProps = {
    ref
  };
  Object.keys(props).forEach(function(key) {
    if (!FontAwesomeIcon.defaultProps.hasOwnProperty(key)) {
      extraProps[key] = props[key];
    }
  });
  return convertCurry(abstract[0], extraProps);
});
FontAwesomeIcon.displayName = "FontAwesomeIcon";
FontAwesomeIcon.propTypes = {
  beat: propTypesExports.bool,
  border: propTypesExports.bool,
  beatFade: propTypesExports.bool,
  bounce: propTypesExports.bool,
  className: propTypesExports.string,
  fade: propTypesExports.bool,
  flash: propTypesExports.bool,
  mask: propTypesExports.oneOfType([propTypesExports.object, propTypesExports.array, propTypesExports.string]),
  maskId: propTypesExports.string,
  fixedWidth: propTypesExports.bool,
  inverse: propTypesExports.bool,
  flip: propTypesExports.oneOf([true, false, "horizontal", "vertical", "both"]),
  icon: propTypesExports.oneOfType([propTypesExports.object, propTypesExports.array, propTypesExports.string]),
  listItem: propTypesExports.bool,
  pull: propTypesExports.oneOf(["right", "left"]),
  pulse: propTypesExports.bool,
  rotation: propTypesExports.oneOf([0, 90, 180, 270]),
  shake: propTypesExports.bool,
  size: propTypesExports.oneOf(["2xs", "xs", "sm", "lg", "xl", "2xl", "1x", "2x", "3x", "4x", "5x", "6x", "7x", "8x", "9x", "10x"]),
  spin: propTypesExports.bool,
  spinPulse: propTypesExports.bool,
  spinReverse: propTypesExports.bool,
  symbol: propTypesExports.oneOfType([propTypesExports.bool, propTypesExports.string]),
  title: propTypesExports.string,
  titleId: propTypesExports.string,
  transform: propTypesExports.oneOfType([propTypesExports.string, propTypesExports.object]),
  swapOpacity: propTypesExports.bool
};
FontAwesomeIcon.defaultProps = {
  border: false,
  className: "",
  mask: null,
  maskId: null,
  fixedWidth: false,
  inverse: false,
  flip: false,
  icon: null,
  listItem: false,
  pull: null,
  pulse: false,
  rotation: null,
  size: null,
  spin: false,
  spinPulse: false,
  spinReverse: false,
  beat: false,
  fade: false,
  beatFade: false,
  bounce: false,
  shake: false,
  symbol: false,
  title: "",
  titleId: null,
  transform: null,
  swapOpacity: false
};
var convertCurry = convert.bind(null, React.createElement);
var vsCircleLargeOutline = {
  prefix: "vs",
  iconName: "circle-large-outline",
  icon: [512, 512, [], "f000", "M306.816 70.88A185.856 185.856 0 0 0 256 64c-17.728 0 -34.624 2.336 -50.816 6.88l-0.192 0.064c-16.448 4.512 -31.68 10.944 -45.824 19.232A196.992 196.992 0 0 0 90.24 159.36l-0.064 0.128A190.944 190.944 0 0 0 70.72 205.12 191.552 191.552 0 0 0 64 256c0 17.76 2.24 34.72 6.72 50.912a193.6 193.6 0 0 0 49.536 84.832c11.84 11.68 24.768 21.664 38.912 30.08a195.2 195.2 0 0 0 45.92 19.488A192.64 192.64 0 0 0 256 448c17.76 0 34.72 -2.24 50.912 -6.72 16.48 -4.64 31.68 -11.136 45.632 -19.424l0.128 -0.064a197.12 197.12 0 0 0 69.152 -68.96 187.2 187.2 0 0 0 19.2 -45.824l0.096 -0.192A185.824 185.824 0 0 0 448 256c0 -17.728 -2.304 -34.624 -6.88 -50.816l-0.064 -0.192a184.704 184.704 0 0 0 -19.2 -45.536l-0.064 -0.128a188.8 188.8 0 0 0 -30.144 -38.72l-0.256 -0.256a188.864 188.864 0 0 0 -38.72 -30.144l-0.128 -0.064a184.704 184.704 0 0 0 -45.536 -19.2l-0.192 -0.064zm142.56 298.24a229.024 229.024 0 0 1 -80.512 80.256 222.912 222.912 0 0 1 -53.376 22.72A223.488 223.488 0 0 1 256 480a223.488 223.488 0 0 1 -59.52 -7.872 227.136 227.136 0 0 1 -53.568 -22.752 233.6 233.6 0 0 1 -45.28 -35.008 233.44 233.44 0 0 1 -35.008 -45.28 227.136 227.136 0 0 1 -22.72 -53.6A223.52 223.52 0 0 1 32 256c0 -20.576 2.624 -40.384 7.872 -59.52a222.976 222.976 0 0 1 22.752 -53.344 228.992 228.992 0 0 1 80.288 -80.512 220.64 220.64 0 0 1 53.6 -22.528A217.856 217.856 0 0 1 256 32a217.6 217.6 0 0 1 59.52 8.096 220.768 220.768 0 0 1 98.656 57.76 220.896 220.896 0 0 1 57.728 98.656C477.312 215.616 480 235.424 480 256s-2.688 40.384 -8.096 59.52a220.8 220.8 0 0 1 -22.528 53.568z"]
};
var vsCopy = {
  prefix: "vs",
  iconName: "copy",
  icon: [512, 512, [], "f000", "m128 128 32 -32h173.248L448 210.752V448l-32 32H160l-32 -32V128zm288 96 -96 -96H160v320h256V224zM96 32 64 64v320l32 32V64h205.248l-32 -32H96z"]
};
var vsLoading = {
  prefix: "vs",
  iconName: "loading",
  icon: [512, 512, [], "f000", "M445.344 224A192.064 192.064 0 0 0 66.656 224H34.272a224.064 224.064 0 0 1 443.456 0h-32.384z"]
};
var vsPassFilled = {
  prefix: "vs",
  iconName: "pass-filled",
  icon: [512, 512, [], "f000", "M256 480A224 224 0 1 0 256 32a224 224 0 0 0 0 448zm-32.64 -132.16h-22.72L128 275.2l22.72 -22.72 61.44 61.44 134.4 -134.72 22.72 22.72 -145.92 145.92z"]
};
var vsWarning = {
  prefix: "vs",
  iconName: "warning",
  icon: [512, 512, [], "f000", "M241.92 32h28.16l209.28 392.32 -14.08 23.68H46.08L32 424.32 241.92 32zM256 72.96 72.96 416H438.4L256 72.96zM276 384v-32h-40v32h40zm-40 -64V192h40v128h-40z"]
};
var safeIsNaN = Number.isNaN || function ponyfill(value) {
  return typeof value === "number" && value !== value;
};
function isEqual(first, second) {
  if (first === second) {
    return true;
  }
  if (safeIsNaN(first) && safeIsNaN(second)) {
    return true;
  }
  return false;
}
function areInputsEqual(newInputs, lastInputs) {
  if (newInputs.length !== lastInputs.length) {
    return false;
  }
  for (var i = 0; i < newInputs.length; i++) {
    if (!isEqual(newInputs[i], lastInputs[i])) {
      return false;
    }
  }
  return true;
}
function memoizeOne(resultFn, isEqual2) {
  if (isEqual2 === void 0) {
    isEqual2 = areInputsEqual;
  }
  var lastThis;
  var lastArgs = [];
  var lastResult;
  var calledOnce = false;
  function memoized() {
    var newArgs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
      newArgs[_i] = arguments[_i];
    }
    if (calledOnce && lastThis === this && isEqual2(newArgs, lastArgs)) {
      return lastResult;
    }
    lastResult = resultFn.apply(this, newArgs);
    calledOnce = true;
    lastThis = this;
    lastArgs = newArgs;
    return lastResult;
  }
  return memoized;
}
const PanelErrorBoundary$1 = "";
Log$7.module("PanelErrorBoundary");
var Container$1 = propTypesExports.shape({
  on: propTypesExports.func,
  off: propTypesExports.func,
  isHidden: propTypesExports.bool,
  tab: propTypesExports.shape({
    header: propTypesExports.shape({
      tabs: propTypesExports.arrayOf(propTypesExports.shape({
        contentItem: propTypesExports.shape({})
      }))
    })
  }),
  title: propTypesExports.string,
  setTitle: propTypesExports.func,
  close: propTypesExports.func
});
var EventHub$1 = propTypesExports.shape({
  on: propTypesExports.func,
  off: propTypesExports.func,
  emit: propTypesExports.func
});
var Layout$1 = propTypesExports.shape({
  registerComponent: propTypesExports.func,
  root: propTypesExports.shape({
    addChild: propTypesExports.func
  }),
  on: propTypesExports.func,
  off: propTypesExports.func,
  eventHub: EventHub$1
});
var GLPropTypes$1 = Object.freeze({
  Container: Container$1,
  EventHub: EventHub$1,
  Layout: Layout$1
});
var useListener = (eventEmitter, eventName, callback) => React.useEffect(function initEventEmitter() {
  eventEmitter.on(eventName, callback);
  return () => {
    eventEmitter.off(eventName, callback);
  };
}, [eventEmitter, eventName, callback]);
function ownKeys$9(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread$9(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$9(Object(source), true).forEach(function(key) {
      _defineProperty$v(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$9(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$v(obj, key, value) {
  key = _toPropertyKey$v(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$v(arg) {
  var key = _toPrimitive$v(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$v(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
function replaceByIdReducer$1(type) {
  var initialState = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var checkIfChanged = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true;
  return function() {
    var state = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : initialState;
    var action = arguments.length > 1 ? arguments[1] : void 0;
    switch (action.type) {
      case type: {
        var {
          id,
          payload
        } = action;
        if (checkIfChanged && deepEqual({
          payload
        }, {
          payload: state[id]
        })) {
          return state;
        }
        return _objectSpread$9(_objectSpread$9({}, state), {}, {
          [id]: payload
        });
      }
      default:
        return state;
    }
  };
}
function ownKeys$8(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread$8(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$8(Object(source), true).forEach(function(key) {
      _defineProperty$u(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$8(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$u(obj, key, value) {
  key = _toPropertyKey$u(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$u(arg) {
  var key = _toPrimitive$u(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$u(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
let ReducerRegistry$1 = class ReducerRegistry {
  constructor() {
    _defineProperty$u(this, "reducers", {});
    _defineProperty$u(this, "listener", null);
  }
  register(name2, reducer) {
    var _this$listener;
    this.reducers = _objectSpread$8(_objectSpread$8({}, this.reducers), {}, {
      [name2]: reducer
    });
    (_this$listener = this.listener) === null || _this$listener === void 0 ? void 0 : _this$listener.call(this, this.reducers);
  }
  setListener(listener3) {
    this.listener = listener3;
  }
};
var reducerRegistry$2 = new ReducerRegistry$1();
const reducerRegistry$3 = reducerRegistry$2;
var SET_DASHBOARD_DATA$1 = "SET_DASHBOARD_DATA";
const dashboardData$1 = replaceByIdReducer$1(SET_DASHBOARD_DATA$1, {}, false);
const reducers$1 = {
  dashboardData: dashboardData$1
};
Object.entries(reducers$1).map((_ref2) => {
  var [name2, reducer] = _ref2;
  return reducerRegistry$3.register(name2, reducer);
});
Log$7.module("DashboardLayout");
({
  id: propTypesExports.string.isRequired,
  children: propTypesExports.node,
  data: propTypesExports.shape({}),
  emptyDashboard: propTypesExports.node,
  layout: GLPropTypes$1.Layout.isRequired,
  layoutConfig: propTypesExports.arrayOf(propTypesExports.shape({})),
  onLayoutChange: propTypesExports.func,
  onLayoutInitialized: propTypesExports.func
});
const Dashboard$1 = "";
var jsxRuntimeExports = {};
var jsxRuntime = {
  get exports() {
    return jsxRuntimeExports;
  },
  set exports(v) {
    jsxRuntimeExports = v;
  }
};
var reactJsxRuntime_production_min = {};
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty$2 = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;
function toObject(val) {
  if (val === null || val === void 0) {
    throw new TypeError("Object.assign cannot be called with null or undefined");
  }
  return Object(val);
}
function shouldUseNative() {
  try {
    if (!Object.assign) {
      return false;
    }
    var test1 = new String("abc");
    test1[5] = "de";
    if (Object.getOwnPropertyNames(test1)[0] === "5") {
      return false;
    }
    var test2 = {};
    for (var i = 0; i < 10; i++) {
      test2["_" + String.fromCharCode(i)] = i;
    }
    var order2 = Object.getOwnPropertyNames(test2).map(function(n2) {
      return test2[n2];
    });
    if (order2.join("") !== "0123456789") {
      return false;
    }
    var test3 = {};
    "abcdefghijklmnopqrst".split("").forEach(function(letter) {
      test3[letter] = letter;
    });
    if (Object.keys(Object.assign({}, test3)).join("") !== "abcdefghijklmnopqrst") {
      return false;
    }
    return true;
  } catch (err) {
    return false;
  }
}
shouldUseNative() ? Object.assign : function(target, source) {
  var from;
  var to = toObject(target);
  var symbols;
  for (var s = 1; s < arguments.length; s++) {
    from = Object(arguments[s]);
    for (var key in from) {
      if (hasOwnProperty$2.call(from, key)) {
        to[key] = from[key];
      }
    }
    if (getOwnPropertySymbols) {
      symbols = getOwnPropertySymbols(from);
      for (var i = 0; i < symbols.length; i++) {
        if (propIsEnumerable.call(from, symbols[i])) {
          to[symbols[i]] = from[symbols[i]];
        }
      }
    }
  }
  return to;
};
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var f = React, g = 60103;
reactJsxRuntime_production_min.Fragment = 60107;
if ("function" === typeof Symbol && Symbol.for) {
  var h = Symbol.for;
  g = h("react.element");
  reactJsxRuntime_production_min.Fragment = h("react.fragment");
}
var m = f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, n = Object.prototype.hasOwnProperty, p = { key: true, ref: true, __self: true, __source: true };
function q(c, a, k) {
  var b, d2 = {}, e = null, l = null;
  void 0 !== k && (e = "" + k);
  void 0 !== a.key && (e = "" + a.key);
  void 0 !== a.ref && (l = a.ref);
  for (b in a)
    n.call(a, b) && !p.hasOwnProperty(b) && (d2[b] = a[b]);
  if (c && c.defaultProps)
    for (b in a = c.defaultProps, a)
      void 0 === d2[b] && (d2[b] = a[b]);
  return { $$typeof: g, type: c, key: e, ref: l, props: d2, _owner: m.current };
}
reactJsxRuntime_production_min.jsx = q;
reactJsxRuntime_production_min.jsxs = q;
(function(module2) {
  {
    module2.exports = reactJsxRuntime_production_min;
  }
})(jsxRuntime);
function _defineProperty$t(obj, key, value) {
  key = _toPropertyKey$t(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$t(arg) {
  var key = _toPrimitive$t(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$t(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class CanceledPromiseError2 extends Error {
  constructor() {
    super(...arguments);
    _defineProperty$t(this, "isCanceled", true);
  }
}
const CanceledPromiseError$1 = CanceledPromiseError2;
function _defineProperty$s(obj, key, value) {
  key = _toPropertyKey$s(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$s(arg) {
  var key = _toPrimitive$s(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$s(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class TimeoutError2 extends Error {
  constructor() {
    super(...arguments);
    _defineProperty$s(this, "isTimeout", true);
  }
}
const TimeoutError$1 = TimeoutError2;
class PromiseUtils2 {
  /**
   * Creates a promise that can be canceled by calling the `cancel` function
   * Pass an optional `cleanupFunc` to perform actions on the resolved item after promise is cancelled.
   * @param promise The item to resolve
   * @param cleanup Function to cleanup the resolved item after cancelation. Called after both this promise is cancelled and the wrapped item was resolved (order does not matter).
   */
  static makeCancelable(promise, cleanup) {
    var hasCanceled = false;
    var resolved;
    var rejectFn;
    var wrappedPromise = new Promise((resolve, reject) => {
      rejectFn = reject;
      Promise.resolve(promise).then((val) => {
        if (hasCanceled) {
          if (cleanup) {
            cleanup(val);
          }
        } else {
          resolved = val;
          resolve(val);
        }
      }).catch((error) => reject(error));
    });
    wrappedPromise.cancel = () => {
      hasCanceled = true;
      rejectFn(new CanceledPromiseError$1());
      if (resolved != null && cleanup) {
        cleanup(resolved);
      }
    };
    return wrappedPromise;
  }
  static isCanceled(error) {
    return error instanceof CanceledPromiseError$1;
  }
  static isTimedOut(error) {
    return error instanceof TimeoutError$1;
  }
  /**
   * Wrap a callback call in a Promise + setTimeout.
   * @param timeoutMs
   * @param callback
   */
  static withTimeout(timeoutMs, callback) {
    return new Promise((resolve, reject) => {
      setTimeout(() => {
        try {
          resolve(callback());
        } catch (err) {
          reject(err);
        }
      }, timeoutMs);
    });
  }
}
class TextUtils {
  /**
   * Joins a list of strings with a comma, keeping the oxford comma and adding "and" as appropriate.
   * Eg.
   * One
   * One and Two
   * One, Two, and Three
   * @param items The items to join in a list
   * @param conjunction Conjunction to use between the last two items
   */
  static join(items) {
    var conjunction = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "and";
    if (items == null || items.length === 0) {
      return "";
    }
    if (items.length === 1) {
      return items[0];
    }
    if (items.length === 2) {
      return "".concat(items[0], " ").concat(conjunction, " ").concat(items[1]);
    }
    var itemText = items.slice(0, items.length - 1).join(", ");
    var lastItem = items[items.length - 1];
    return "".concat(itemText, ", ").concat(conjunction, " ").concat(lastItem);
  }
  /**
   * Converts text to lower case, handling null if necessary and returning an empty string
   * @param text The text to convert to lower case
   * @param isNullAllowed True if a null string should return an empty string from this function. If false an error is thrown if null is passed in.
   */
  static toLower(text) {
    var isNullAllowed = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
    if (text == null) {
      if (isNullAllowed) {
        return "";
      }
      throw new Error("Null string passed in to TextUtils.toLower");
    }
    return text.toLowerCase();
  }
  /**
   *
   * @param a The string to sort
   * @param b Second string to sort
   * @param isAscending Whether to sort ascending or descending
   */
  static sort(a, b) {
    var isAscending = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true;
    if (a < b) {
      return isAscending ? -1 : 1;
    }
    if (a > b) {
      return isAscending ? 1 : -1;
    }
    return 0;
  }
}
const TextUtils$1 = TextUtils;
var {
  dh: dh$2
} = globalThis;
const shim$2 = dh$2;
var ERROR$2 = 0;
var WARN$2 = 1;
var INFO$2 = 2;
var DEBUG$2 = 3;
var DEBUG2$2 = 4;
function _defineProperty$r(obj, key, value) {
  key = _toPropertyKey$r(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$r(arg) {
  var key = _toPrimitive$r(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$r(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var silent$2 = () => void 0;
let Logger$4 = class Logger2 {
  constructor(name2, level) {
    _defineProperty$r(this, "name", void 0);
    _defineProperty$r(this, "prefix", void 0);
    _defineProperty$r(this, "level", void 0);
    _defineProperty$r(this, "error", void 0);
    _defineProperty$r(this, "warn", void 0);
    _defineProperty$r(this, "log", void 0);
    _defineProperty$r(this, "info", void 0);
    _defineProperty$r(this, "debug", void 0);
    _defineProperty$r(this, "debug2", void 0);
    this.name = name2;
    this.prefix = name2 != null ? "[".concat(name2, "]") : "";
    this.error = silent$2;
    this.warn = silent$2;
    this.log = silent$2;
    this.info = silent$2;
    this.debug = silent$2;
    this.debug2 = silent$2;
    this.level = level;
    this.setLogLevel(level);
  }
  setLogLevel(level) {
    if (!Number.isFinite(level)) {
      console.warn("Expected a number for log level. Received: ".concat(level, ". Ignoring"));
      return;
    }
    this.level = level;
    this.error = level >= ERROR$2 ? console.error.bind(console, this.prefix) : silent$2;
    this.warn = level >= WARN$2 ? console.warn.bind(console, this.prefix) : silent$2;
    this.log = level >= INFO$2 ? console.log.bind(console, this.prefix) : silent$2;
    this.info = this.log;
    this.debug = level >= DEBUG$2 ? console.debug.bind(console, this.prefix) : silent$2;
    this.debug2 = level >= DEBUG2$2 ? console.debug.bind(console, this.prefix) : silent$2;
  }
};
const Logger$5 = Logger$4;
function _defineProperty$q(obj, key, value) {
  key = _toPropertyKey$q(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$q(arg) {
  var key = _toPrimitive$q(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$q(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
let DefaultLogger$4 = class DefaultLogger2 extends Logger$5 {
  constructor() {
    var level = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : INFO$2;
    super(null, level);
    _defineProperty$q(this, "modules", void 0);
    this.modules = {};
  }
  module(name2) {
    if (this.modules[name2] == null) {
      this.modules[name2] = new Logger$5(name2, this.level);
    }
    return this.modules[name2];
  }
  setLogLevel(level) {
    super.setLogLevel(level);
    if (this.modules == null) {
      return;
    }
    var keys3 = Object.keys(this.modules);
    for (var i = 0; i < keys3.length; i += 1) {
      this.modules[keys3[i]].setLogLevel(level);
    }
  }
};
const DefaultLogger$5 = DefaultLogger$4;
var Log$4 = new DefaultLogger$5();
const Log$5 = Log$4;
function _defineProperty$p(obj, key, value) {
  key = _toPropertyKey$p(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$p(arg) {
  var key = _toPrimitive$p(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$p(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class DateUtils {
  /**
   *
   * @param timeZone The time zone to parse this time in. E.g. America/New_York
   * @param year The year for the date
   * @param month The month, starting at 0
   * @param day The day, starting at 1
   * @param hour The hours
   * @param minute The minutes
   * @param second The seconds
   * @param ns The nanoseconds
   */
  static makeDateWrapper(timeZone, year) {
    var month = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
    var day = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 1;
    var hour = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 0;
    var minute = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : 0;
    var second = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : 0;
    var ns = arguments.length > 7 && arguments[7] !== void 0 ? arguments[7] : 0;
    if (!timeZone) {
      throw new Error("No timezone provided");
    }
    var yearString = "".concat(year).padStart(4, "0");
    var monthString = "".concat(month + 1).padStart(2, "0");
    var dayString = "".concat(day).padStart(2, "0");
    var hourString = "".concat(hour).padStart(2, "0");
    var minuteString = "".concat(minute).padStart(2, "0");
    var secondString = "".concat(second).padStart(2, "0");
    var nanoString = "".concat(ns).padStart(9, "0");
    var dateString = "".concat(yearString, "-").concat(monthString, "-").concat(dayString, " ").concat(hourString, ":").concat(minuteString, ":").concat(secondString, ".").concat(nanoString);
    return shim$2.i18n.DateTimeFormat.parse(DateUtils.FULL_DATE_FORMAT, dateString, shim$2.i18n.TimeZone.getTimeZone(timeZone));
  }
  /**
   * Takes the string the user entered and returns the next nanos value
   * @param nanoString The nano string to get the next one of
   * @returns The value of the next nanos
   */
  static getNextNanos(nanoString) {
    var sigNanos = parseInt(nanoString, 10);
    var zeros = "0".repeat(9 - nanoString.length);
    var nextNanoString = "".concat(sigNanos + 1).concat(zeros);
    return parseInt(nextNanoString, 10);
  }
  /**
   * @param components The string components that were parsed from the original string
   * @param values The values that were parsed from the components
   * @param timeZone The time zone to parse the date in. E.g. America/New_York
   * @returns Returns the DateWrapper for the next date, or null if a full date was passed in
   */
  static getNextDate(components, values, timeZone) {
    var {
      year,
      month,
      date,
      hours,
      minutes,
      seconds,
      nanos
    } = values;
    if (components.nanos != null) {
      if (components.nanos.length === 9) {
        return null;
      }
      nanos = DateUtils.getNextNanos(components.nanos);
      if (nanos > 999999999) {
        seconds += 1;
        nanos = 0;
      }
    } else if (components.seconds != null) {
      seconds += 1;
    } else if (components.minutes != null) {
      minutes += 1;
    } else if (components.hours != null) {
      hours += 1;
    } else if (components.date != null) {
      date += 1;
    } else if (components.month != null) {
      month += 1;
    } else {
      year += 1;
    }
    var jsDate = new Date(year, month, date, hours, minutes, seconds);
    return DateUtils.makeDateWrapper(timeZone, jsDate.getFullYear(), jsDate.getMonth(), jsDate.getDate(), jsDate.getHours(), jsDate.getMinutes(), jsDate.getSeconds(), nanos);
  }
  /**
   * Get the JS month value for the provided string.
   * Matches digits or a month name (eg. '1', '01', 'jan', 'january' should all work)
   * @param monthString The string to parse to a JS month value
   * @returns number The JS month value, which starts at 0 for january, or NaN if nothing could be parsed
   */
  static parseMonth(monthString) {
    var month = parseInt(monthString, 10);
    if (!Number.isNaN(month)) {
      if (month >= 1 && month <= 12) {
        return month - 1;
      }
      return NaN;
    }
    var cleanMonthString = monthString.trim().toLowerCase();
    if (cleanMonthString.length >= 3) {
      for (var i = 0; i < DateUtils.months.length; i += 1) {
        if (DateUtils.months[i].startsWith(cleanMonthString)) {
          return i;
        }
      }
    }
    return NaN;
  }
  /**
   * Parse a date object out of the provided string segments.
   * Also using `parseMonth` to get month names like Aug/August rather than
   * simply doing `parseInt`.
   * @param yearString The year part of the string
   * @param monthString The month part of the string
   * @param dayString The day part of the string
   * @param hourString The hour part of the string
   * @param minuteString The minute part of the string
   * @param secondString The second part of the string
   * @param nanoString The milli part of the string
   */
  static parseDateValues(yearString, monthString, dayString, hourString, minuteString, secondString, nanoString) {
    var year = parseInt(yearString, 10);
    var month = monthString != null ? this.parseMonth(monthString) : 0;
    var date = dayString != null ? parseInt(dayString, 10) : 1;
    var hours = hourString != null ? parseInt(hourString, 10) : 0;
    var minutes = minuteString != null ? parseInt(minuteString, 10) : 0;
    var seconds = secondString != null ? parseInt(secondString, 10) : 0;
    var nanos = nanoString != null ? parseInt(nanoString.padEnd(9, "0"), 10) : 0;
    if (Number.isNaN(year) || Number.isNaN(month) || Number.isNaN(date) || Number.isNaN(hours) || Number.isNaN(minutes) || Number.isNaN(seconds) || Number.isNaN(nanos)) {
      return null;
    }
    return {
      year,
      month,
      date,
      hours,
      minutes,
      seconds,
      nanos
    };
  }
  /**
   * Parse out a date time string into it's string components.
   * Anything that is not captured in the string will be undefined.
   *
   * @param dateTimeString The date time string to parse
   * @returns Containing the date time components
   */
  static parseDateTimeString(dateTimeString) {
    var regex2 = /\s*(\d{4})([-./]([\da-z]+))?([-./](\d{1,2}))?([tT\s](\d{2})([:](\d{2}))?([:](\d{2}))?([.](\d{1,9}))?)?(.*)/;
    var result = regex2.exec(dateTimeString);
    if (result == null) {
      throw new Error("Unexpected date string: ".concat(dateTimeString));
    }
    var [, year, , month, , date, , hours, , minutes, , seconds, , nanos, overflow] = result;
    if (overflow != null && overflow.length > 0) {
      throw new Error("Unexpected characters after date string '".concat(dateTimeString, "': ").concat(overflow));
    }
    return {
      year,
      month,
      date,
      hours,
      minutes,
      seconds,
      nanos
    };
  }
  /**
   * Parses the date range provided from a string of text.
   * @param text The string to parse the date from. Can be a keyword like "today", or in the format "2018-08-04"
   * @param timeZone The time zone to parse this range in. E.g. America/New_York
   * @returns A tuple with the start and end value/null for that date range, or both null
   */
  static parseDateRange(text, timeZone) {
    var cleanText = text.trim().toLowerCase();
    if (cleanText.length === 0) {
      throw new Error("Cannot parse date range from empty string");
    }
    if (cleanText === "null") {
      return [null, null];
    }
    if (cleanText === "today") {
      var now = new Date(Date.now());
      var _startDate = DateUtils.makeDateWrapper(timeZone, now.getFullYear(), now.getMonth(), now.getDate());
      var _endDate = DateUtils.makeDateWrapper(timeZone, now.getFullYear(), now.getMonth(), now.getDate() + 1);
      return [_startDate, _endDate];
    }
    if (cleanText === "yesterday") {
      var _now = new Date(Date.now());
      var _startDate2 = DateUtils.makeDateWrapper(timeZone, _now.getFullYear(), _now.getMonth(), _now.getDate() - 1);
      var _endDate2 = DateUtils.makeDateWrapper(timeZone, _now.getFullYear(), _now.getMonth(), _now.getDate());
      return [_startDate2, _endDate2];
    }
    if (cleanText === "now") {
      var _now2 = new Date(Date.now());
      var date = shim$2.DateWrapper.ofJsDate(_now2);
      return [date, null];
    }
    var components = DateUtils.parseDateTimeString(cleanText);
    if (components.year == null && components.month == null && components.date == null) {
      throw new Error("Unable to extract year, month, or day ".concat(cleanText));
    }
    var values = DateUtils.parseDateValues(components.year, components.month, components.date, components.hours, components.minutes, components.seconds, components.nanos);
    if (values == null) {
      throw new Error("Unable to extract date values from ".concat(components));
    }
    var startDate = DateUtils.makeDateWrapper(timeZone, values.year, values.month, values.date, values.hours, values.minutes, values.seconds, values.nanos);
    var endDate = DateUtils.getNextDate(components, values, timeZone);
    return [startDate, endDate];
  }
  /**
   * Gets the Js Date object from the provided DateWrapper.
   * In unit test, DateWrapper is just a number provided in millis, so handles that case.
   * @param dateWrapper The DateWrapper object, or time in millis
   */
  static getJsDate(dateWrapper) {
    if (typeof dateWrapper === "number") {
      return new Date(dateWrapper);
    }
    return dateWrapper.asDate();
  }
}
_defineProperty$p(DateUtils, "FULL_DATE_FORMAT", "yyyy-MM-dd HH:mm:ss.SSSSSSSSS");
_defineProperty$p(DateUtils, "months", ["january", "february", "march", "april", "may", "june", "july", "august", "september", "october", "november", "december"]);
const DateUtils$1 = DateUtils;
function _defineProperty$o(obj, key, value) {
  key = _toPropertyKey$o(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$o(arg) {
  var key = _toPrimitive$o(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$o(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class Operator {
}
_defineProperty$o(Operator, "not", "not");
_defineProperty$o(Operator, "and", "and");
_defineProperty$o(Operator, "or", "or");
function _defineProperty$n(obj, key, value) {
  key = _toPropertyKey$n(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$n(arg) {
  var key = _toPrimitive$n(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$n(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class Type {
}
_defineProperty$n(Type, "eq", "eq");
_defineProperty$n(Type, "eqIgnoreCase", "eqIgnoreCase");
_defineProperty$n(Type, "notEq", "notEq");
_defineProperty$n(Type, "notEqIgnoreCase", "notEqIgnoreCase");
_defineProperty$n(Type, "greaterThan", "greaterThan");
_defineProperty$n(Type, "greaterThanOrEqualTo", "greaterThanOrEqualTo");
_defineProperty$n(Type, "lessThan", "lessThan");
_defineProperty$n(Type, "lessThanOrEqualTo", "lessThanOrEqualTo");
_defineProperty$n(Type, "in", "in");
_defineProperty$n(Type, "inIgnoreCase", "inIgnoreCase");
_defineProperty$n(Type, "notIn", "notIn");
_defineProperty$n(Type, "notInIgnoreCase", "notInIgnoreCase");
_defineProperty$n(Type, "isTrue", "isTrue");
_defineProperty$n(Type, "isFalse", "isFalse");
_defineProperty$n(Type, "isNull", "isNull");
_defineProperty$n(Type, "invoke", "invoke");
_defineProperty$n(Type, "contains", "contains");
_defineProperty$n(Type, "notContains", "notContains");
_defineProperty$n(Type, "startsWith", "startsWith");
_defineProperty$n(Type, "endsWith", "endsWith");
_defineProperty$n(Type, "containsAny", "containsAny");
function _defineProperty$m(obj, key, value) {
  key = _toPropertyKey$m(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$m(arg) {
  var key = _toPrimitive$m(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$m(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var log$b = Log$5.module("TableUtils");
class TableUtils {
  // Regex looking for a negative or positive integer or decimal number
  static getSortIndex(sort, columnName) {
    for (var i = 0; i < sort.length; i += 1) {
      var _s$column;
      var s = sort[i];
      if (((_s$column = s.column) === null || _s$column === void 0 ? void 0 : _s$column.name) === columnName) {
        return i;
      }
    }
    return null;
  }
  /**
   * @param tableSort The sorts from the table to get the sort from
   * @param columnName The name of the column to get the sort for
   * @returns The sort for the column, or null if it's not sorted
   */
  static getSortForColumn(tableSort, columnName) {
    var sortIndex = TableUtils.getSortIndex(tableSort, columnName);
    if (sortIndex != null) {
      return tableSort[sortIndex];
    }
    return null;
  }
  static getFilterText(filter) {
    if (filter) {
      return filter.toString();
    }
    return null;
  }
  /** Return the valid filter types for the column */
  static getFilterTypes(columnType) {
    if (TableUtils.isBooleanType(columnType)) {
      return [Type.isTrue, Type.isFalse, Type.isNull];
    }
    if (TableUtils.isCharType(columnType) || TableUtils.isNumberType(columnType) || TableUtils.isDateType(columnType)) {
      return [Type.eq, Type.notEq, Type.greaterThan, Type.greaterThanOrEqualTo, Type.lessThan, Type.lessThanOrEqualTo];
    }
    if (TableUtils.isTextType(columnType)) {
      return [Type.eq, Type.eqIgnoreCase, Type.notEq, Type.notEqIgnoreCase, Type.contains, Type.notContains, Type.startsWith, Type.endsWith];
    }
    return [];
  }
  static getNextSort(columns, sorts, columnIndex) {
    if (columnIndex < 0 || columnIndex >= columns.length) {
      return null;
    }
    var sort = TableUtils.getSortForColumn(sorts, columns[columnIndex].name);
    if (sort === null) {
      return columns[columnIndex].sort().asc();
    }
    if (sort.direction === TableUtils.sortDirection.ascending) {
      return sort.desc();
    }
    return null;
  }
  static makeColumnSort(columns, columnIndex, direction, isAbs) {
    if (columnIndex < 0 || columnIndex >= columns.length) {
      return null;
    }
    if (direction === TableUtils.sortDirection.none) {
      return null;
    }
    var sort = columns[columnIndex].sort();
    switch (direction) {
      case TableUtils.sortDirection.ascending:
        sort = sort.asc();
        break;
      case TableUtils.sortDirection.descending:
        sort = sort.desc();
        break;
    }
    if (isAbs) {
      sort = sort.abs();
    }
    return sort;
  }
  /**
   * Toggles the sort for the specified column
   * @param sorts The current sorts from IrisGrid.state
   * @param columns The columns to apply the sort to
   * @param columnIndex The column index to apply the sort to
   * @param addToExisting Add this sort to the existing sort
   */
  static toggleSortForColumn(sorts, columns, columnIndex) {
    var addToExisting = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
    if (columnIndex < 0 || columnIndex >= columns.length) {
      return [];
    }
    var newSort = TableUtils.getNextSort(columns, sorts, columnIndex);
    return TableUtils.setSortForColumn(sorts, columns[columnIndex].name, newSort, addToExisting);
  }
  static sortColumn(sorts, columns, modelColumn, direction, isAbs, addToExisting) {
    if (modelColumn < 0 || modelColumn >= columns.length) {
      return [];
    }
    var newSort = TableUtils.makeColumnSort(columns, modelColumn, direction, isAbs);
    return TableUtils.setSortForColumn(sorts, columns[modelColumn].name, newSort, addToExisting);
  }
  /**
   * Sets the sort for the given column *and* removes any reverses
   * @param tableSort The current sorts from IrisGrid.state
   * @param columnName The column name to apply the sort to
   * @param sort The sort object to add
   * @param addToExisting Add this sort to the existing sort
   * @returns Returns the modified array of sorts - removing reverses
   */
  static setSortForColumn(tableSort, columnName, sort) {
    var addToExisting = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
    var sortIndex = TableUtils.getSortIndex(tableSort, columnName);
    var sorts = [];
    if (addToExisting) {
      sorts = sorts.concat(tableSort.filter((_ref2) => {
        var {
          direction
        } = _ref2;
        return direction !== TableUtils.sortDirection.reverse;
      }));
      if (sortIndex !== null) {
        sorts.splice(sortIndex, 1);
      }
    }
    if (sort !== null) {
      sorts.push(sort);
    }
    return sorts;
  }
  static getNormalizedType(columnType) {
    switch (columnType) {
      case "boolean":
      case "java.lang.Boolean":
      case TableUtils.dataType.BOOLEAN:
        return TableUtils.dataType.BOOLEAN;
      case "char":
      case "java.lang.Character":
      case TableUtils.dataType.CHAR:
        return TableUtils.dataType.CHAR;
      case "java.lang.String":
      case TableUtils.dataType.STRING:
        return TableUtils.dataType.STRING;
      case "io.deephaven.db.tables.utils.DBDateTime":
      case "io.deephaven.time.DateTime":
      case "com.illumon.iris.db.tables.utils.DBDateTime":
      case "java.time.Instant":
      case "java.time.ZonedDateTime":
      case TableUtils.dataType.DATETIME:
        return TableUtils.dataType.DATETIME;
      case "double":
      case "java.lang.Double":
      case "float":
      case "java.lang.Float":
      case "java.math.BigDecimal":
      case TableUtils.dataType.DECIMAL:
        return TableUtils.dataType.DECIMAL;
      case "int":
      case "java.lang.Integer":
      case "long":
      case "java.lang.Long":
      case "short":
      case "java.lang.Short":
      case "byte":
      case "java.lang.Byte":
      case "java.math.BigInteger":
      case TableUtils.dataType.INT:
        return TableUtils.dataType.INT;
      default:
        return TableUtils.dataType.UNKNOWN;
    }
  }
  static isLongType(columnType) {
    switch (columnType) {
      case "long":
      case "java.lang.Long":
        return true;
      default:
        return false;
    }
  }
  static isDateType(columnType) {
    switch (columnType) {
      case "io.deephaven.db.tables.utils.DBDateTime":
      case "io.deephaven.time.DateTime":
      case "java.time.Instant":
      case "java.time.ZonedDateTime":
      case "com.illumon.iris.db.tables.utils.DBDateTime":
        return true;
      default:
        return false;
    }
  }
  static isNumberType(columnType) {
    return TableUtils.isIntegerType(columnType) || TableUtils.isDecimalType(columnType);
  }
  static isIntegerType(columnType) {
    switch (columnType) {
      case "int":
      case "java.lang.Integer":
      case "java.math.BigInteger":
      case "long":
      case "java.lang.Long":
      case "short":
      case "java.lang.Short":
      case "byte":
      case "java.lang.Byte":
        return true;
      default:
        return false;
    }
  }
  static isDecimalType(columnType) {
    switch (columnType) {
      case "double":
      case "java.lang.Double":
      case "java.math.BigDecimal":
      case "float":
      case "java.lang.Float":
        return true;
      default:
        return false;
    }
  }
  static isBigDecimalType(columnType) {
    switch (columnType) {
      case "java.math.BigDecimal":
        return true;
      default:
        return false;
    }
  }
  static isBigIntegerType(columnType) {
    switch (columnType) {
      case "java.math.BigInteger":
        return true;
      default:
        return false;
    }
  }
  static isBooleanType(columnType) {
    switch (columnType) {
      case "boolean":
      case "java.lang.Boolean":
        return true;
      default:
        return false;
    }
  }
  static isCharType(columnType) {
    switch (columnType) {
      case "char":
      case "java.lang.Character":
        return true;
      default:
        return false;
    }
  }
  static isStringType(columnType) {
    switch (columnType) {
      case "java.lang.String":
        return true;
      default:
        return false;
    }
  }
  static isTextType(columnType) {
    return this.isStringType(columnType) || this.isCharType(columnType);
  }
  /**
   * Get base column type
   * @param columnType Column type
   * @returns Element type for array columns, original type for non-array columns
   */
  static getBaseType(columnType) {
    return columnType.split("[]")[0];
  }
  /**
   * Check if the column types are compatible
   * @param type1 Column type to check
   * @param type2 Column type to check
   * @returns True, if types are compatible
   */
  static isCompatibleType(type1, type2) {
    return TableUtils.getNormalizedType(type1) === TableUtils.getNormalizedType(type2);
  }
  /**
   * Create filter with the provided column and text. Handles multiple filters joined with && or ||
   * @param column The column to set the filter on
   * @param text The text string to create the filter from
   * @param timeZone The time zone to make this value in if it is a date type. E.g. America/New_York
   * @returns Returns the created filter, null if text could not be parsed
   */
  static makeQuickFilter(column, text, timeZone) {
    var orComponents = text.split("||");
    var orFilter = null;
    for (var i = 0; i < orComponents.length; i += 1) {
      var orComponent = orComponents[i];
      var andComponents = orComponent.split("&&");
      var andFilter = null;
      for (var j = 0; j < andComponents.length; j += 1) {
        var andComponent = andComponents[j].trim();
        if (andComponent.length > 0) {
          var filter = TableUtils.makeQuickFilterFromComponent(column, andComponent, timeZone);
          if (filter) {
            if (andFilter) {
              andFilter = andFilter.and(filter);
            } else {
              andFilter = filter;
            }
          } else {
            throw new Error("Unable to parse quick filter from text ".concat(text));
          }
        }
      }
      if (orFilter && andFilter) {
        orFilter = orFilter.or(andFilter);
      } else {
        orFilter = andFilter;
      }
    }
    return orFilter;
  }
  /**
   * Create filter with the provided column and text of one component (no multiple conditions)
   * @param column The column to set the filter on
   * @param text The text string to create the filter from
   * @param timeZone The time zone to make this filter in if it is a date type. E.g. America/New_York
   * @returns Returns the created filter, null if text could not be parsed
   */
  static makeQuickFilterFromComponent(column, text, timeZone) {
    var {
      type
    } = column;
    if (TableUtils.isNumberType(type)) {
      return this.makeQuickNumberFilter(column, text);
    }
    if (TableUtils.isBooleanType(type)) {
      return this.makeQuickBooleanFilter(column, text);
    }
    if (timeZone != null && TableUtils.isDateType(type)) {
      return this.makeQuickDateFilter(column, text, timeZone);
    }
    if (TableUtils.isCharType(type)) {
      return this.makeQuickCharFilter(column, text);
    }
    return this.makeQuickTextFilter(column, text);
  }
  static makeQuickNumberFilter(column, text) {
    var columnFilter = column.filter();
    var filter = null;
    var regex2 = /\s*(>=|<=|=>|=<|>|<|!=|=|!)?(\s*-\s*)?(\s*\d*(?:,\d{3})*(?:\.\d*)?\s*)?(null|nan|infinity|inf|\u221E)?(.*)/i;
    var result = regex2.exec(text);
    var operation = null;
    var negativeSign = null;
    var value = null;
    var abnormalValue = null;
    var overflow = null;
    if (result !== null && result.length > 3) {
      [, operation, negativeSign, value, abnormalValue, overflow] = result;
    }
    if (overflow != null && overflow.trim().length > 0) {
      return null;
    }
    if (operation == null) {
      operation = "=";
    }
    if (abnormalValue != null) {
      if (!(operation === "=" || operation === "!" || operation === "!=")) {
        return null;
      }
      abnormalValue = abnormalValue.trim().toLowerCase();
      switch (abnormalValue) {
        case "null":
          filter = columnFilter.isNull();
          break;
        case "nan":
          filter = shim$2.FilterCondition.invoke("isNaN", columnFilter);
          break;
        case "infinity":
        case "inf":
        case "∞":
          if (negativeSign != null) {
            filter = shim$2.FilterCondition.invoke("isInf", columnFilter).and(columnFilter.lessThan(shim$2.FilterValue.ofNumber(0)));
          } else {
            filter = shim$2.FilterCondition.invoke("isInf", columnFilter).and(columnFilter.greaterThan(shim$2.FilterValue.ofNumber(0)));
          }
          break;
      }
      if (filter !== null && (operation === "!" || operation === "!=")) {
        filter = filter.not();
      }
      return filter;
    }
    if (value == null) {
      return null;
    }
    value = TableUtils.removeCommas(value);
    if (TableUtils.isLongType(column.type)) {
      try {
        value = shim$2.FilterValue.ofNumber(shim$2.LongWrapper.ofString("".concat(negativeSign != null ? "-" : "").concat(value)));
      } catch (error) {
        log$b.warn("Unable to create long filter", error);
        return null;
      }
    } else {
      value = parseFloat(value);
      if (value == null || Number.isNaN(value)) {
        return null;
      }
      value = shim$2.FilterValue.ofNumber(negativeSign != null ? 0 - value : value);
    }
    filter = column.filter();
    return TableUtils.makeRangeFilterWithOperation(filter, operation, value);
  }
  static makeQuickTextFilter(column, text) {
    var cleanText = "".concat(text).trim();
    var regex2 = /^(!~|!=|~|=|!)?(.*)/;
    var result = regex2.exec(cleanText);
    var operation = null;
    var value = null;
    if (result !== null && result.length > 2) {
      [, operation, value] = result;
      if (value != null) {
        value = value.trim();
      }
    }
    if (value == null || value.length === 0) {
      return null;
    }
    if (operation == null) {
      operation = "=";
    }
    var filter = column.filter();
    if (value.toLowerCase() === "null") {
      switch (operation) {
        case "=":
          return filter.isNull();
        case "!=":
        case "!":
          return filter.isNull().not();
      }
    }
    var prefix = null;
    var suffix = null;
    if (value.startsWith("*")) {
      prefix = "*";
      value = value.substring(1);
    } else if (value.endsWith("*") && !value.endsWith("\\*")) {
      suffix = "*";
      value = value.substring(0, value.length - 1);
    }
    value = value.replace("\\", "");
    switch (operation) {
      case "~": {
        return filter.isNull().not().and(filter.invoke("matches", shim$2.FilterValue.ofString("(?s)(?i).*\\Q".concat(value, "\\E.*"))));
      }
      case "!~":
        return filter.isNull().or(filter.invoke("matches", shim$2.FilterValue.ofString("(?s)(?i).*\\Q".concat(value, "\\E.*"))).not());
      case "!=":
        if (prefix === "*") {
          return filter.isNull().or(filter.invoke("matches", shim$2.FilterValue.ofString("(?s)(?i).*\\Q".concat(value, "\\E$"))).not());
        }
        if (suffix === "*") {
          return filter.isNull().or(filter.invoke("matches", shim$2.FilterValue.ofString("(?s)(?i)^\\Q".concat(value, "\\E.*"))).not());
        }
        return filter.notEqIgnoreCase(shim$2.FilterValue.ofString(value.toLowerCase()));
      case "=":
        if (prefix === "*") {
          return filter.isNull().not().and(filter.invoke("matches", shim$2.FilterValue.ofString("(?s)(?i).*\\Q".concat(value, "\\E$"))));
        }
        if (suffix === "*") {
          return filter.isNull().not().and(filter.invoke("matches", shim$2.FilterValue.ofString("(?s)(?i)^\\Q".concat(value, "\\E.*"))));
        }
        return filter.eqIgnoreCase(shim$2.FilterValue.ofString(value.toLowerCase()));
    }
    return null;
  }
  static makeQuickBooleanFilter(column, text) {
    var regex2 = /^(!=|=|!)?(.*)/;
    var result = regex2.exec("".concat(text).trim());
    if (result === null) {
      return null;
    }
    var [, operation, value] = result;
    var notEqual = operation === "!" || operation === "!=";
    var cleanValue = value.trim().toLowerCase();
    var filter = column.filter();
    try {
      var boolValue = TableUtils.makeBooleanValue(cleanValue);
      if (boolValue != null && boolValue) {
        filter = filter.isTrue();
      } else if (boolValue === null) {
        filter = filter.isNull();
      } else {
        filter = filter.isFalse();
      }
      return notEqual ? filter.not() : filter;
    } catch (e) {
      return null;
    }
  }
  /**
   * Builds a date filter parsed from the text string which may or may not include an operator.
   * @param column The column to build the filter from, with or without a leading operator.
   * @param text The date string text to parse.
   * @param timeZone The time zone to make this filter in if it is a date type. E.g. America/New_York
   */
  static makeQuickDateFilter(column, text, timeZone) {
    var cleanText = text.trim();
    var regex2 = /\s*(>=|<=|=>|=<|>|<|!=|!|=)?(.*)/;
    var result = regex2.exec(cleanText);
    if (result == null || result.length <= 2) {
      throw new Error("Unable to parse date filter: ".concat(text));
    }
    var operation = null;
    var dateText = null;
    [, operation, dateText] = result;
    var filterOperation = Type.eq;
    switch (operation) {
      case "<":
        filterOperation = Type.lessThan;
        break;
      case "<=":
      case "=<":
        filterOperation = Type.lessThanOrEqualTo;
        break;
      case ">":
        filterOperation = Type.greaterThan;
        break;
      case ">=":
      case "=>":
        filterOperation = Type.greaterThanOrEqualTo;
        break;
      case "!=":
      case "!":
        filterOperation = Type.notEq;
        break;
      case "=":
      case "==":
      default:
        filterOperation = Type.eq;
        break;
    }
    return TableUtils.makeQuickDateFilterWithOperation(column, dateText, filterOperation, timeZone);
  }
  /**
   * Builds a date filter parsed from the text string with the provided filter.
   * @param column The column to build the filter from.
   * @param text The date string text to parse, without an operator.
   * @param operation The filter operation to use.
   * @param timeZone The time zone to make this filter with. E.g. America/New_York
   */
  static makeQuickDateFilterWithOperation(column, text, operation, timeZone) {
    var [startDate, endDate] = DateUtils$1.parseDateRange(text, timeZone);
    var startValue = startDate != null ? shim$2.FilterValue.ofNumber(startDate) : null;
    var endValue = endDate != null ? shim$2.FilterValue.ofNumber(endDate) : null;
    var filter = column.filter();
    if (startValue == null) {
      return operation === Type.notEq ? filter.isNull().not() : filter.isNull();
    }
    switch (operation) {
      case Type.eq: {
        if (endValue != null) {
          var startFilter = filter.greaterThanOrEqualTo(startValue);
          var endFilter = filter.lessThan(endValue);
          return startFilter.and(endFilter);
        }
        return filter.eq(startValue);
      }
      case Type.lessThan: {
        return filter.lessThan(startValue);
      }
      case Type.lessThanOrEqualTo: {
        if (endValue != null) {
          return filter.lessThan(endValue);
        }
        return filter.lessThanOrEqualTo(startValue);
      }
      case Type.greaterThan: {
        if (endValue != null) {
          return filter.greaterThanOrEqualTo(endValue);
        }
        return filter.greaterThan(startValue);
      }
      case Type.greaterThanOrEqualTo:
        return filter.greaterThanOrEqualTo(startValue);
      case Type.notEq: {
        if (endValue != null) {
          var _startFilter = filter.lessThan(startValue);
          var _endFilter = filter.greaterThanOrEqualTo(endValue);
          return _startFilter.or(_endFilter);
        }
        return filter.notEq(startValue);
      }
      default:
        throw new Error("Invalid operator: ".concat(operation));
    }
  }
  /**
   * Adds quotes to a value if they're not already added
   * @param value Value to add quotes around
   */
  static quoteValue(value) {
    if (value.length >= 2 && (value.charAt(0) === '"' && value.charAt(value.length - 1) === '"' || value.charAt(0) === "'" && value.charAt(value.length - 1) === "'")) {
      return value;
    }
    return '"'.concat(value, '"');
  }
  static isRangeOperation(operation) {
    switch (operation) {
      case "<":
      case "<=":
      case "=<":
      case ">":
      case ">=":
      case "=>":
        return true;
      default:
        return false;
    }
  }
  static makeQuickCharFilter(column, text) {
    var cleanText = "".concat(text).trim();
    var regex2 = /^(>=|<=|=>|=<|>|<|!=|=|!)?(null|"."|'.'|.)?(.*)/;
    var result = regex2.exec(cleanText);
    var operation = null;
    var value = null;
    var overflow = null;
    if (result !== null && result.length > 3) {
      [, operation, value, overflow] = result;
    }
    if (overflow != null && overflow.trim().length > 0) {
      return null;
    }
    if (value == null || value.length === 0) {
      return null;
    }
    if (operation == null) {
      operation = "=";
    }
    var filter = column.filter();
    if (value.toLowerCase() === "null") {
      switch (operation) {
        case "=":
          return filter.isNull();
        case "!=":
        case "!":
          return filter.isNull().not();
        default:
          return null;
      }
    }
    var filterValue = shim$2.FilterValue.ofString(TableUtils.isRangeOperation(operation) ? TableUtils.quoteValue(value) : value);
    return TableUtils.makeRangeFilterWithOperation(filter, operation, filterValue);
  }
  /**
   * @param filter The column filter to apply the range operation to
   * @param operation The range operation to run
   * @param value The value to use for the operation
   * @returns The condition with the specified operation
   */
  static makeRangeFilterWithOperation(filter, operation, value) {
    switch (operation) {
      case "=":
        return filter.eq(value);
      case "<":
        return filter.lessThan(value);
      case "<=":
      case "=<":
        return filter.lessThanOrEqualTo(value);
      case ">":
        return filter.greaterThan(value);
      case ">=":
      case "=>":
        return filter.greaterThanOrEqualTo(value);
      case "!=":
      case "!":
        return filter.notEq(value);
      default:
        return null;
    }
  }
  /**
   * Wraps a table promise in a cancelable promise that will close the table if the promise is cancelled.
   * Use in a component that loads a table, and call cancel when unmounting.
   * @param table The table promise to wrap
   */
  static makeCancelableTablePromise(table) {
    return PromiseUtils2.makeCancelable(table, (resolved) => {
      resolved.close();
    });
  }
  /**
   * Make a cancelable promise for a one-shot table event with a timeout.
   * @param table Table to listen for events on
   * @param eventName Event to listen for
   * @param timeout Event timeout in milliseconds, defaults to 0
   * @param matcher Optional function to determine if the promise can be resolved or stays pending
   * @returns Resolves with the event data
   */
  static makeCancelableTableEventPromise(table, eventName) {
    var timeout = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0;
    var matcher = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
    var eventCleanup;
    var timeoutId;
    var isPending = true;
    var wrappedPromise = new Promise((resolve, reject) => {
      timeoutId = setTimeout(() => {
        eventCleanup();
        isPending = false;
        reject(new TimeoutError$1('Event "'.concat(eventName, '" timed out.')));
      }, timeout);
      eventCleanup = table.addEventListener(eventName, (event) => {
        if (matcher != null && !matcher(event)) {
          log$b.debug2("Event triggered, but matcher returned false.");
          return;
        }
        log$b.debug2("Event triggered, resolving.");
        eventCleanup();
        clearTimeout(timeoutId);
        isPending = false;
        resolve(event);
      });
    });
    wrappedPromise.cancel = () => {
      if (isPending) {
        log$b.debug2("Pending promise cleanup.");
        eventCleanup();
        clearTimeout(timeoutId);
        isPending = false;
        return;
      }
      log$b.debug2("Ignoring non-pending promise cancel.");
    };
    return wrappedPromise;
  }
  static makeAdvancedFilter(column, options, timeZone) {
    var {
      filterItems,
      filterOperators,
      invertSelection,
      selectedValues
    } = options;
    var filter = null;
    for (var i = 0; i < filterItems.length; i += 1) {
      var filterItem = filterItems[i];
      var {
        selectedType,
        value
      } = filterItem;
      if (selectedType != null && selectedType.length > 0 && value != null && value.length > 0) {
        try {
          var newFilter = TableUtils.makeAdvancedValueFilter(column, selectedType, value, timeZone);
          if (newFilter != null) {
            if (i === 0) {
              filter = newFilter;
            } else if (filter !== null && i - 1 < filterOperators.length) {
              var filterOperator = filterOperators[i - 1];
              if (filterOperator === Operator.and) {
                filter = filter.and(newFilter);
              } else if (filterOperator === Operator.or) {
                filter = filter.or(newFilter);
              } else {
                log$b.error("Unexpected filter operator", filterOperator, newFilter);
                filter = null;
                break;
              }
            }
          } else {
            log$b.debug2("Empty filter ignored for", selectedType, value);
          }
        } catch (err) {
          log$b.error("Unable to create filter", err);
          filter = null;
          break;
        }
      }
    }
    var selectValueFilter = TableUtils.makeSelectValueFilter(column, selectedValues, invertSelection);
    if (selectValueFilter != null) {
      if (filter != null) {
        filter = filter.and(selectValueFilter);
      } else {
        filter = selectValueFilter;
      }
    }
    return filter;
  }
  static removeCommas(value) {
    return value.replace(/[\s|,]/g, "");
  }
  /**
   * @param columnType The column type to make the filter value from.
   * @param value The value to make the filter value from.
   * @returns The FilterValue item for this column/value combination
   */
  static makeFilterValue(columnType, value) {
    var type = TableUtils.getBaseType(columnType);
    if (TableUtils.isTextType(type)) {
      return shim$2.FilterValue.ofString(value);
    }
    if (TableUtils.isLongType(type)) {
      return shim$2.FilterValue.ofNumber(shim$2.LongWrapper.ofString(TableUtils.removeCommas(value)));
    }
    return shim$2.FilterValue.ofNumber(TableUtils.removeCommas(value));
  }
  /**
   * Takes a value and converts it to an `dh.FilterValue`
   *
   * @param columnType The column type to make the filter value from.
   * @param value The value to actually set
   * @returns The FilterValue item for this column/value combination
   */
  static makeFilterRawValue(columnType, rawValue) {
    if (TableUtils.isTextType(columnType)) {
      return shim$2.FilterValue.ofString(rawValue);
    }
    if (TableUtils.isBooleanType(columnType)) {
      return shim$2.FilterValue.ofBoolean(rawValue);
    }
    return shim$2.FilterValue.ofNumber(rawValue);
  }
  /**
   * Converts a string value to a value appropriate for the column
   * @param columnType The column type to make the value for
   * @param text The string value to make a type for
   * @param timeZone The time zone to make this value in if it is a date type. E.g. America/New_York
   */
  static makeValue(columnType, text, timeZone) {
    if (text === "null") {
      return null;
    }
    if (TableUtils.isTextType(columnType)) {
      return text;
    }
    if (TableUtils.isLongType(columnType)) {
      return shim$2.LongWrapper.ofString(TableUtils.removeCommas(text));
    }
    if (TableUtils.isBooleanType(columnType)) {
      return TableUtils.makeBooleanValue(text, true);
    }
    if (TableUtils.isDateType(columnType)) {
      var [date] = DateUtils$1.parseDateRange(text, timeZone);
      return date;
    }
    if (TableUtils.isNumberType(columnType)) {
      return TableUtils.makeNumberValue(text);
    }
    log$b.error("Unexpected column type", columnType);
    return null;
  }
  static makeBooleanValue(text) {
    var allowEmpty = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
    if (text === "" && allowEmpty) {
      return null;
    }
    switch (text === null || text === void 0 ? void 0 : text.toLowerCase()) {
      case "null":
        return null;
      case "0":
      case "f":
      case "fa":
      case "fal":
      case "fals":
      case "false":
      case "n":
      case "no":
        return false;
      case "1":
      case "t":
      case "tr":
      case "tru":
      case "true":
      case "y":
      case "ye":
      case "yes":
        return true;
      default:
        throw new Error("Invalid boolean '".concat(text, "'"));
    }
  }
  static makeNumberValue(text) {
    if (text === "null" || text === "") {
      return null;
    }
    var cleanText = text.toLowerCase().trim();
    if (cleanText === "∞" || cleanText === "infinity" || cleanText === "inf") {
      return Number.POSITIVE_INFINITY;
    }
    if (cleanText === "-∞" || cleanText === "-infinity" || cleanText === "-inf") {
      return Number.NEGATIVE_INFINITY;
    }
    var numberText = TableUtils.removeCommas(cleanText);
    if (TableUtils.NUMBER_REGEX.test(numberText)) {
      return parseFloat(numberText);
    }
    throw new Error("Invalid number '".concat(text, "'"));
  }
  static getFilterOperatorString(operation) {
    switch (operation) {
      case Type.eq:
        return "=";
      case Type.notEq:
        return "!=";
      case Type.greaterThan:
        return ">";
      case Type.greaterThanOrEqualTo:
        return ">=";
      case Type.lessThan:
        return "<";
      case Type.lessThanOrEqualTo:
        return "<=";
      case Type.contains:
        return "~";
      case Type.notContains:
        return "!~";
      default:
        throw new Error("Unexpected filter type ".concat(operation));
    }
  }
  static makeAdvancedValueFilter(column, operation, value, timeZone) {
    if (TableUtils.isDateType(column.type)) {
      return TableUtils.makeQuickDateFilterWithOperation(column, value, operation, timeZone);
    }
    if (TableUtils.isNumberType(column.type) || TableUtils.isCharType(column.type)) {
      return TableUtils.makeQuickFilter(column, "".concat(TableUtils.getFilterOperatorString(operation)).concat(value));
    }
    var filterValue = TableUtils.makeFilterValue(column.type, value);
    var filter = column.filter();
    switch (operation) {
      case Type.eq:
        return filter.eq(filterValue);
      case Type.eqIgnoreCase:
        return filter.eqIgnoreCase(filterValue);
      case Type.notEq:
        return filter.notEq(filterValue);
      case Type.notEqIgnoreCase:
        return filter.notEqIgnoreCase(filterValue);
      case Type.greaterThan:
        return filter.greaterThan(filterValue);
      case Type.greaterThanOrEqualTo:
        return filter.greaterThanOrEqualTo(filterValue);
      case Type.lessThan:
        return filter.lessThan(filterValue);
      case Type.lessThanOrEqualTo:
        return filter.lessThanOrEqualTo(filterValue);
      case Type.isTrue:
        return filter.isTrue();
      case Type.isFalse:
        return filter.isFalse();
      case Type.isNull:
        return filter.isNull();
      case Type.contains:
        return filter.isNull().not().and(filter.invoke("matches", shim$2.FilterValue.ofString("(?s)(?i).*\\Q".concat(value, "\\E.*"))));
      case Type.notContains:
        return filter.isNull().or(filter.invoke("matches", shim$2.FilterValue.ofString("(?s)(?i).*\\Q".concat(value, "\\E.*"))).not());
      case Type.startsWith:
        return filter.isNull().not().and(filter.invoke("matches", shim$2.FilterValue.ofString("(?s)(?i)^\\Q".concat(value, "\\E.*"))));
      case Type.endsWith:
        return filter.isNull().not().and(filter.invoke("matches", shim$2.FilterValue.ofString("(?s)(?i).*\\Q".concat(value, "\\E$"))));
      case Type.in:
      case Type.inIgnoreCase:
      case Type.notIn:
      case Type.notInIgnoreCase:
      case Type.invoke:
      default:
        throw new Error("Unexpected filter operation: ".concat(operation));
    }
  }
  /**
   * Create a filter using the selected items
   * Has a flag for invertSelection as we start from a "Select All" state and a user just deselects items.
   * Since there may be millions of distinct items, it's easier to build an inverse filter.
   * @param column The column to set the filter on
   * @param selectedValues The values that are selected
   * @param invertSelection Invert the selection (eg. All items are selected, then you deselect items)
   * @returns Returns a `in` or `notIn` FilterCondition as necessary, or null if no filtering should be applied (everything selected)
   */
  static makeSelectValueFilter(column, selectedValues, invertSelection) {
    if (selectedValues.length === 0) {
      if (invertSelection) {
        return null;
      }
      var value = null;
      if (TableUtils.isTextType(column.type)) {
        value = shim$2.FilterValue.ofString("a");
      } else if (TableUtils.isBooleanType(column.type)) {
        value = shim$2.FilterValue.ofBoolean(true);
      } else if (TableUtils.isDateType(column.type)) {
        value = shim$2.FilterValue.ofNumber(shim$2.DateWrapper.ofJsDate(new Date()));
      } else {
        value = shim$2.FilterValue.ofNumber(0);
      }
      var eqFilter = column.filter().eq(value);
      var notEqFilter = column.filter().notEq(value);
      return eqFilter.and(notEqFilter);
    }
    var values = [];
    var isNullSelected = false;
    for (var i = 0; i < selectedValues.length; i += 1) {
      var _value = selectedValues[i];
      if (_value == null) {
        isNullSelected = true;
      } else if (TableUtils.isTextType(column.type)) {
        values.push(shim$2.FilterValue.ofString(typeof _value === "number" ? String.fromCharCode(_value) : _value));
      } else if (TableUtils.isBooleanType(column.type)) {
        values.push(shim$2.FilterValue.ofBoolean(Boolean(_value)));
      } else {
        values.push(shim$2.FilterValue.ofNumber(_value));
      }
    }
    if (isNullSelected) {
      if (values.length > 0) {
        if (invertSelection) {
          return column.filter().isNull().not().and(column.filter().notIn(values));
        }
        return column.filter().isNull().or(column.filter().in(values));
      }
      if (invertSelection) {
        return column.filter().isNull().not();
      }
      return column.filter().isNull();
    }
    if (invertSelection) {
      return column.filter().notIn(values);
    }
    return column.filter().in(values);
  }
  static isTreeTable(table) {
    return table != null && table.expand !== void 0 && table.collapse !== void 0;
  }
  /**
   * Copies the provided array, sorts by column name case insensitive, and returns the sorted array.
   * @param columns The columns to sort
   * @param isAscending Whether to sort ascending
   */
  static sortColumns(columns) {
    var isAscending = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
    return [...columns].sort((a, b) => {
      var aName = a.name.toUpperCase();
      var bName = b.name.toUpperCase();
      return TextUtils$1.sort(aName, bName, isAscending);
    });
  }
}
_defineProperty$m(TableUtils, "dataType", {
  BOOLEAN: "boolean",
  CHAR: "char",
  DATETIME: "datetime",
  DECIMAL: "decimal",
  INT: "int",
  STRING: "string",
  UNKNOWN: "unknown"
});
_defineProperty$m(TableUtils, "sortDirection", {
  ascending: "ASC",
  descending: "DESC",
  reverse: "REVERSE",
  none: null
});
_defineProperty$m(TableUtils, "REVERSE_TYPE", Object.freeze({
  NONE: "none",
  PRE_SORT: "pre-sort",
  POST_SORT: "post-sort"
}));
_defineProperty$m(TableUtils, "NUMBER_REGEX", /^-?\d+(\.\d+)?$/);
var ERROR$1 = 0;
var WARN$1 = 1;
var INFO$1 = 2;
var DEBUG$1 = 3;
var DEBUG2$1 = 4;
function _defineProperty$l(obj, key, value) {
  key = _toPropertyKey$l(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$l(arg) {
  var key = _toPrimitive$l(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$l(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var silent$1 = () => void 0;
let Logger$2 = class Logger3 {
  constructor(name2, level) {
    _defineProperty$l(this, "name", void 0);
    _defineProperty$l(this, "prefix", void 0);
    _defineProperty$l(this, "level", void 0);
    _defineProperty$l(this, "error", void 0);
    _defineProperty$l(this, "warn", void 0);
    _defineProperty$l(this, "log", void 0);
    _defineProperty$l(this, "info", void 0);
    _defineProperty$l(this, "debug", void 0);
    _defineProperty$l(this, "debug2", void 0);
    this.name = name2;
    this.prefix = name2 != null ? "[".concat(name2, "]") : "";
    this.error = silent$1;
    this.warn = silent$1;
    this.log = silent$1;
    this.info = silent$1;
    this.debug = silent$1;
    this.debug2 = silent$1;
    this.level = level;
    this.setLogLevel(level);
  }
  setLogLevel(level) {
    if (!Number.isFinite(level)) {
      console.warn("Expected a number for log level. Received: ".concat(level, ". Ignoring"));
      return;
    }
    this.level = level;
    this.error = level >= ERROR$1 ? console.error.bind(console, this.prefix) : silent$1;
    this.warn = level >= WARN$1 ? console.warn.bind(console, this.prefix) : silent$1;
    this.log = level >= INFO$1 ? console.log.bind(console, this.prefix) : silent$1;
    this.info = this.log;
    this.debug = level >= DEBUG$1 ? console.debug.bind(console, this.prefix) : silent$1;
    this.debug2 = level >= DEBUG2$1 ? console.debug.bind(console, this.prefix) : silent$1;
  }
};
const Logger$3 = Logger$2;
function _defineProperty$k(obj, key, value) {
  key = _toPropertyKey$k(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$k(arg) {
  var key = _toPrimitive$k(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$k(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
let DefaultLogger$2 = class DefaultLogger3 extends Logger$3 {
  constructor() {
    var level = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : INFO$1;
    super(null, level);
    _defineProperty$k(this, "modules", void 0);
    this.modules = {};
  }
  module(name2) {
    if (this.modules[name2] == null) {
      this.modules[name2] = new Logger$3(name2, this.level);
    }
    return this.modules[name2];
  }
  setLogLevel(level) {
    super.setLogLevel(level);
    if (this.modules == null) {
      return;
    }
    var keys3 = Object.keys(this.modules);
    for (var i = 0; i < keys3.length; i += 1) {
      this.modules[keys3[i]].setLogLevel(level);
    }
  }
};
const DefaultLogger$3 = DefaultLogger$2;
var Log$2 = new DefaultLogger$3();
const Log$3 = Log$2;
var factory = {};
(function(exports2) {
  function _typeof2(obj) {
    "@babel/helpers - typeof";
    return _typeof2 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj2) {
      return typeof obj2;
    } : function(obj2) {
      return obj2 && "function" == typeof Symbol && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
    }, _typeof2(obj);
  }
  Object.defineProperty(exports2, "__esModule", {
    value: true
  });
  exports2["default"] = plotComponentFactory;
  var _react = _interopRequireWildcard(React);
  var _propTypes = _interopRequireDefault(propTypesExports);
  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }
  function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function")
      return null;
    var cacheBabelInterop = /* @__PURE__ */ new WeakMap();
    var cacheNodeInterop = /* @__PURE__ */ new WeakMap();
    return (_getRequireWildcardCache = function _getRequireWildcardCache2(nodeInterop2) {
      return nodeInterop2 ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
  }
  function _interopRequireWildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
      return obj;
    }
    if (obj === null || _typeof2(obj) !== "object" && typeof obj !== "function") {
      return { "default": obj };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
      if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
        if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }
    newObj["default"] = obj;
    if (cache) {
      cache.set(obj, newObj);
    }
    return newObj;
  }
  function _classCallCheck2(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
  function _defineProperties2(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor)
        descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }
  function _createClass2(Constructor, protoProps, staticProps) {
    if (protoProps)
      _defineProperties2(Constructor.prototype, protoProps);
    if (staticProps)
      _defineProperties2(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", { writable: false });
    return Constructor;
  }
  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });
    Object.defineProperty(subClass, "prototype", { writable: false });
    if (superClass)
      _setPrototypeOf2(subClass, superClass);
  }
  function _setPrototypeOf2(o, p2) {
    _setPrototypeOf2 = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf3(o2, p3) {
      o2.__proto__ = p3;
      return o2;
    };
    return _setPrototypeOf2(o, p2);
  }
  function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();
    return function _createSuperInternal() {
      var Super = _getPrototypeOf(Derived), result;
      if (hasNativeReflectConstruct) {
        var NewTarget = _getPrototypeOf(this).constructor;
        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }
      return _possibleConstructorReturn(this, result);
    };
  }
  function _possibleConstructorReturn(self2, call) {
    if (call && (_typeof2(call) === "object" || typeof call === "function")) {
      return call;
    } else if (call !== void 0) {
      throw new TypeError("Derived constructors may only return object or undefined");
    }
    return _assertThisInitialized(self2);
  }
  function _assertThisInitialized(self2) {
    if (self2 === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self2;
  }
  function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct)
      return false;
    if (Reflect.construct.sham)
      return false;
    if (typeof Proxy === "function")
      return true;
    try {
      Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
      }));
      return true;
    } catch (e) {
      return false;
    }
  }
  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf2(o2) {
      return o2.__proto__ || Object.getPrototypeOf(o2);
    };
    return _getPrototypeOf(o);
  }
  var eventNames = ["AfterExport", "AfterPlot", "Animated", "AnimatingFrame", "AnimationInterrupted", "AutoSize", "BeforeExport", "BeforeHover", "ButtonClicked", "Click", "ClickAnnotation", "Deselect", "DoubleClick", "Framework", "Hover", "LegendClick", "LegendDoubleClick", "Relayout", "Relayouting", "Restyle", "Redraw", "Selected", "Selecting", "SliderChange", "SliderEnd", "SliderStart", "SunburstClick", "Transitioning", "TransitionInterrupted", "Unhover", "WebGlContextLost"];
  var updateEvents = ["plotly_restyle", "plotly_redraw", "plotly_relayout", "plotly_relayouting", "plotly_doubleclick", "plotly_animated", "plotly_sunburstclick"];
  var isBrowser2 = typeof window !== "undefined";
  function plotComponentFactory(Plotly2) {
    var PlotlyComponent = /* @__PURE__ */ function(_Component) {
      _inherits(PlotlyComponent2, _Component);
      var _super = _createSuper(PlotlyComponent2);
      function PlotlyComponent2(props) {
        var _this;
        _classCallCheck2(this, PlotlyComponent2);
        _this = _super.call(this, props);
        _this.p = Promise.resolve();
        _this.resizeHandler = null;
        _this.handlers = {};
        _this.syncWindowResize = _this.syncWindowResize.bind(_assertThisInitialized(_this));
        _this.syncEventHandlers = _this.syncEventHandlers.bind(_assertThisInitialized(_this));
        _this.attachUpdateEvents = _this.attachUpdateEvents.bind(_assertThisInitialized(_this));
        _this.getRef = _this.getRef.bind(_assertThisInitialized(_this));
        _this.handleUpdate = _this.handleUpdate.bind(_assertThisInitialized(_this));
        _this.figureCallback = _this.figureCallback.bind(_assertThisInitialized(_this));
        _this.updatePlotly = _this.updatePlotly.bind(_assertThisInitialized(_this));
        return _this;
      }
      _createClass2(PlotlyComponent2, [{
        key: "updatePlotly",
        value: function updatePlotly(shouldInvokeResizeHandler, figureCallbackFunction, shouldAttachUpdateEvents) {
          var _this2 = this;
          this.p = this.p.then(function() {
            if (_this2.unmounting) {
              return;
            }
            if (!_this2.el) {
              throw new Error("Missing element reference");
            }
            return Plotly2.react(_this2.el, {
              data: _this2.props.data,
              layout: _this2.props.layout,
              config: _this2.props.config,
              frames: _this2.props.frames
            });
          }).then(function() {
            if (_this2.unmounting) {
              return;
            }
            _this2.syncWindowResize(shouldInvokeResizeHandler);
            _this2.syncEventHandlers();
            _this2.figureCallback(figureCallbackFunction);
            if (shouldAttachUpdateEvents) {
              _this2.attachUpdateEvents();
            }
          })["catch"](function(err) {
            if (_this2.props.onError) {
              _this2.props.onError(err);
            }
          });
        }
      }, {
        key: "componentDidMount",
        value: function componentDidMount() {
          this.unmounting = false;
          this.updatePlotly(true, this.props.onInitialized, true);
        }
      }, {
        key: "componentDidUpdate",
        value: function componentDidUpdate(prevProps) {
          this.unmounting = false;
          var numPrevFrames = prevProps.frames && prevProps.frames.length ? prevProps.frames.length : 0;
          var numNextFrames = this.props.frames && this.props.frames.length ? this.props.frames.length : 0;
          var figureChanged = !(prevProps.layout === this.props.layout && prevProps.data === this.props.data && prevProps.config === this.props.config && numNextFrames === numPrevFrames);
          var revisionDefined = prevProps.revision !== void 0;
          var revisionChanged = prevProps.revision !== this.props.revision;
          if (!figureChanged && (!revisionDefined || revisionDefined && !revisionChanged)) {
            return;
          }
          this.updatePlotly(false, this.props.onUpdate, false);
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.unmounting = true;
          this.figureCallback(this.props.onPurge);
          if (this.resizeHandler && isBrowser2) {
            window.removeEventListener("resize", this.resizeHandler);
            this.resizeHandler = null;
          }
          this.removeUpdateEvents();
          Plotly2.purge(this.el);
        }
      }, {
        key: "attachUpdateEvents",
        value: function attachUpdateEvents() {
          var _this3 = this;
          if (!this.el || !this.el.removeListener) {
            return;
          }
          updateEvents.forEach(function(updateEvent) {
            _this3.el.on(updateEvent, _this3.handleUpdate);
          });
        }
      }, {
        key: "removeUpdateEvents",
        value: function removeUpdateEvents() {
          var _this4 = this;
          if (!this.el || !this.el.removeListener) {
            return;
          }
          updateEvents.forEach(function(updateEvent) {
            _this4.el.removeListener(updateEvent, _this4.handleUpdate);
          });
        }
      }, {
        key: "handleUpdate",
        value: function handleUpdate() {
          this.figureCallback(this.props.onUpdate);
        }
      }, {
        key: "figureCallback",
        value: function figureCallback(callback) {
          if (typeof callback === "function") {
            var _this$el = this.el, data = _this$el.data, layout = _this$el.layout;
            var frames = this.el._transitionData ? this.el._transitionData._frames : null;
            var figure = {
              data,
              layout,
              frames
            };
            callback(figure, this.el);
          }
        }
      }, {
        key: "syncWindowResize",
        value: function syncWindowResize(invoke) {
          var _this5 = this;
          if (!isBrowser2) {
            return;
          }
          if (this.props.useResizeHandler && !this.resizeHandler) {
            this.resizeHandler = function() {
              return Plotly2.Plots.resize(_this5.el);
            };
            window.addEventListener("resize", this.resizeHandler);
            if (invoke) {
              this.resizeHandler();
            }
          } else if (!this.props.useResizeHandler && this.resizeHandler) {
            window.removeEventListener("resize", this.resizeHandler);
            this.resizeHandler = null;
          }
        }
      }, {
        key: "getRef",
        value: function getRef(el) {
          this.el = el;
          if (this.props.debug && isBrowser2) {
            window.gd = this.el;
          }
        }
        // Attach and remove event handlers as they're added or removed from props:
      }, {
        key: "syncEventHandlers",
        value: function syncEventHandlers() {
          var _this6 = this;
          eventNames.forEach(function(eventName) {
            var prop = _this6.props["on" + eventName];
            var handler = _this6.handlers[eventName];
            var hasHandler = Boolean(handler);
            if (prop && !hasHandler) {
              _this6.addEventHandler(eventName, prop);
            } else if (!prop && hasHandler) {
              _this6.removeEventHandler(eventName);
            } else if (prop && hasHandler && prop !== handler) {
              _this6.removeEventHandler(eventName);
              _this6.addEventHandler(eventName, prop);
            }
          });
        }
      }, {
        key: "addEventHandler",
        value: function addEventHandler(eventName, prop) {
          this.handlers[eventName] = prop;
          this.el.on(this.getPlotlyEventName(eventName), this.handlers[eventName]);
        }
      }, {
        key: "removeEventHandler",
        value: function removeEventHandler(eventName) {
          this.el.removeListener(this.getPlotlyEventName(eventName), this.handlers[eventName]);
          delete this.handlers[eventName];
        }
      }, {
        key: "getPlotlyEventName",
        value: function getPlotlyEventName(eventName) {
          return "plotly_" + eventName.toLowerCase();
        }
      }, {
        key: "render",
        value: function render3() {
          return /* @__PURE__ */ _react["default"].createElement("div", {
            id: this.props.divId,
            style: this.props.style,
            ref: this.getRef,
            className: this.props.className
          });
        }
      }]);
      return PlotlyComponent2;
    }(_react.Component);
    PlotlyComponent.propTypes = {
      data: _propTypes["default"].arrayOf(_propTypes["default"].object),
      config: _propTypes["default"].object,
      layout: _propTypes["default"].object,
      frames: _propTypes["default"].arrayOf(_propTypes["default"].object),
      revision: _propTypes["default"].number,
      onInitialized: _propTypes["default"].func,
      onPurge: _propTypes["default"].func,
      onError: _propTypes["default"].func,
      onUpdate: _propTypes["default"].func,
      debug: _propTypes["default"].bool,
      style: _propTypes["default"].object,
      className: _propTypes["default"].string,
      useResizeHandler: _propTypes["default"].bool,
      divId: _propTypes["default"].string
    };
    eventNames.forEach(function(eventName) {
      PlotlyComponent.propTypes["on" + eventName] = _propTypes["default"].func;
    });
    PlotlyComponent.defaultProps = {
      debug: false,
      useResizeHandler: false,
      data: [],
      style: {
        position: "relative",
        display: "inline-block"
      }
    };
    return PlotlyComponent;
  }
})(factory);
const createPlotlyComponent = /* @__PURE__ */ getDefaultExportFromCjs(factory);
function _defineProperty$j(obj, key, value) {
  key = _toPropertyKey$j(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$j(arg) {
  var key = _toPrimitive$j(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$j(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class ChartModel {
  constructor() {
    _defineProperty$j(this, "listeners", void 0);
    _defineProperty$j(this, "formatter", void 0);
    _defineProperty$j(this, "rect", void 0);
    _defineProperty$j(this, "isDownsamplingDisabled", void 0);
    _defineProperty$j(this, "title", void 0);
    this.listeners = [];
    this.isDownsamplingDisabled = false;
  }
  getData() {
    return [];
  }
  getDefaultTitle() {
    return "";
  }
  getLayout() {
    return {};
  }
  getFilterColumnMap() {
    return /* @__PURE__ */ new Map();
  }
  isFilterRequired() {
    return false;
  }
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  setFilter(filter) {
  }
  /**
   * Close this model, clean up any underlying subscriptions
   */
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  close() {
  }
  /**
   * Set the formatter to use when charting the data.
   * @param formatter The formatter to use to format the charting data
   */
  setFormatter(formatter) {
    this.formatter = formatter;
  }
  /**
   * Disable downsampling
   * @param isDownsamplingDisabled True if downsampling should be disabled
   */
  setDownsamplingDisabled(isDownsamplingDisabled) {
    this.isDownsamplingDisabled = isDownsamplingDisabled;
  }
  /**
   * Set the dimensions of the plot. May be needed to evaluate some of the percents
   * @param rect The bounding rectangle of the plot
   */
  setDimensions(rect) {
    this.rect = rect;
  }
  setTitle(title) {
    this.title = title;
  }
  /**
   * Subscribe to this ChartModel and start listening for all events.
   * @param callback Callback when an event occurs
   */
  subscribe(callback) {
    this.listeners.push(callback);
  }
  unsubscribe(callback) {
    this.listeners = this.listeners.filter((listener3) => listener3 !== callback);
  }
  fireEvent(event) {
    for (var i = 0; i < this.listeners.length; i += 1) {
      this.listeners[i](event);
    }
  }
  fireUpdate(data) {
    this.fireEvent(new CustomEvent(ChartModel.EVENT_UPDATED, {
      detail: data
    }));
  }
  fireDisconnect() {
    this.fireEvent(new CustomEvent(ChartModel.EVENT_DISCONNECT));
  }
  fireReconnect() {
    this.fireEvent(new CustomEvent(ChartModel.EVENT_RECONNECT));
  }
  fireDownsampleStart(detail) {
    this.fireEvent(new CustomEvent(ChartModel.EVENT_DOWNSAMPLESTARTED, {
      detail
    }));
  }
  fireDownsampleFinish(detail) {
    this.fireEvent(new CustomEvent(ChartModel.EVENT_DOWNSAMPLEFINISHED, {
      detail
    }));
  }
  fireDownsampleFail(detail) {
    this.fireEvent(new CustomEvent(ChartModel.EVENT_DOWNSAMPLEFAILED, {
      detail
    }));
  }
  fireDownsampleNeeded(detail) {
    this.fireEvent(new CustomEvent(ChartModel.EVENT_DOWNSAMPLENEEDED, {
      detail
    }));
  }
  fireLoadFinished() {
    this.fireEvent(new CustomEvent(ChartModel.EVENT_LOADFINISHED));
  }
}
_defineProperty$j(ChartModel, "EVENT_UPDATED", "ChartModel.EVENT_UPDATED");
_defineProperty$j(ChartModel, "EVENT_DISCONNECT", "ChartModel.EVENT_DISCONNECT");
_defineProperty$j(ChartModel, "EVENT_RECONNECT", "ChartModel.EVENT_RECONNECT");
_defineProperty$j(ChartModel, "EVENT_DOWNSAMPLESTARTED", "ChartModel.EVENT_DOWNSAMPLESTARTED");
_defineProperty$j(ChartModel, "EVENT_DOWNSAMPLEFINISHED", "ChartModel.EVENT_DOWNSAMPLEFINISHED");
_defineProperty$j(ChartModel, "EVENT_DOWNSAMPLEFAILED", "ChartModel.EVENT_DOWNSAMPLEFAILED");
_defineProperty$j(ChartModel, "EVENT_DOWNSAMPLENEEDED", "ChartModel.EVENT_DOWNSAMPLENEEDED");
_defineProperty$j(ChartModel, "EVENT_LOADFINISHED", "ChartModel.EVENT_LOADFINISHED");
const ChartModel$1 = ChartModel;
var {
  dh: dh$1
} = globalThis;
const shim$1 = dh$1;
var FUNC_ERROR_TEXT = "Expected a function";
var HASH_UNDEFINED = "__lodash_hash_undefined__";
var INFINITY = 1 / 0, MAX_SAFE_INTEGER = 9007199254740991;
var funcTag = "[object Function]", genTag = "[object GeneratorFunction]", symbolTag = "[object Symbol]";
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, reLeadingDot = /^\./, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
var reEscapeChar = /\\(\\)?/g;
var reIsHostCtor = /^\[object .+?Constructor\]$/;
var reIsUint = /^(?:0|[1-9]\d*)$/;
var freeGlobal = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal || freeSelf || Function("return this")();
function getValue(object, key) {
  return object == null ? void 0 : object[key];
}
function isHostObject(value) {
  var result = false;
  if (value != null && typeof value.toString != "function") {
    try {
      result = !!(value + "");
    } catch (e) {
    }
  }
  return result;
}
var arrayProto = Array.prototype, funcProto = Function.prototype, objectProto = Object.prototype;
var coreJsData = root["__core-js_shared__"];
var maskSrcKey = function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
  return uid ? "Symbol(src)_1." + uid : "";
}();
var funcToString = funcProto.toString;
var hasOwnProperty$1 = objectProto.hasOwnProperty;
var objectToString = objectProto.toString;
var reIsNative = RegExp(
  "^" + funcToString.call(hasOwnProperty$1).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
);
var Symbol$1 = root.Symbol, splice = arrayProto.splice;
var Map$1 = getNative(root, "Map"), nativeCreate = getNative(Object, "create");
var symbolProto = Symbol$1 ? Symbol$1.prototype : void 0, symbolToString = symbolProto ? symbolProto.toString : void 0;
function Hash(entries) {
  var index = -1, length = entries ? entries.length : 0;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
function hashClear() {
  this.__data__ = nativeCreate ? nativeCreate(null) : {};
}
function hashDelete(key) {
  return this.has(key) && delete this.__data__[key];
}
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate) {
    var result = data[key];
    return result === HASH_UNDEFINED ? void 0 : result;
  }
  return hasOwnProperty$1.call(data, key) ? data[key] : void 0;
}
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate ? data[key] !== void 0 : hasOwnProperty$1.call(data, key);
}
function hashSet(key, value) {
  var data = this.__data__;
  data[key] = nativeCreate && value === void 0 ? HASH_UNDEFINED : value;
  return this;
}
Hash.prototype.clear = hashClear;
Hash.prototype["delete"] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;
function ListCache(entries) {
  var index = -1, length = entries ? entries.length : 0;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
function listCacheClear() {
  this.__data__ = [];
}
function listCacheDelete(key) {
  var data = this.__data__, index = assocIndexOf(data, key);
  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  return true;
}
function listCacheGet(key) {
  var data = this.__data__, index = assocIndexOf(data, key);
  return index < 0 ? void 0 : data[index][1];
}
function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}
function listCacheSet(key, value) {
  var data = this.__data__, index = assocIndexOf(data, key);
  if (index < 0) {
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}
ListCache.prototype.clear = listCacheClear;
ListCache.prototype["delete"] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;
function MapCache(entries) {
  var index = -1, length = entries ? entries.length : 0;
  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
function mapCacheClear() {
  this.__data__ = {
    "hash": new Hash(),
    "map": new (Map$1 || ListCache)(),
    "string": new Hash()
  };
}
function mapCacheDelete(key) {
  return getMapData(this, key)["delete"](key);
}
function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}
function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}
function mapCacheSet(key, value) {
  getMapData(this, key).set(key, value);
  return this;
}
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype["delete"] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;
function assignValue(object, key, value) {
  var objValue = object[key];
  if (!(hasOwnProperty$1.call(object, key) && eq(objValue, value)) || value === void 0 && !(key in object)) {
    object[key] = value;
  }
}
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}
function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction(value) || isHostObject(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}
function baseSet(object, path, value, customizer) {
  if (!isObject(object)) {
    return object;
  }
  path = isKey(path, object) ? [path] : castPath(path);
  var index = -1, length = path.length, lastIndex = length - 1, nested = object;
  while (nested != null && ++index < length) {
    var key = toKey(path[index]), newValue = value;
    if (index != lastIndex) {
      var objValue = nested[key];
      newValue = customizer ? customizer(objValue, key, nested) : void 0;
      if (newValue === void 0) {
        newValue = isObject(objValue) ? objValue : isIndex(path[index + 1]) ? [] : {};
      }
    }
    assignValue(nested, key, newValue);
    nested = nested[key];
  }
  return object;
}
function baseToString(value) {
  if (typeof value == "string") {
    return value;
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : "";
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY ? "-0" : result;
}
function castPath(value) {
  return isArray(value) ? value : stringToPath2(value);
}
function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
}
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : void 0;
}
function isIndex(value, length) {
  length = length == null ? MAX_SAFE_INTEGER : length;
  return !!length && (typeof value == "number" || reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
}
function isKey(value, object) {
  if (isArray(value)) {
    return false;
  }
  var type = typeof value;
  if (type == "number" || type == "symbol" || type == "boolean" || value == null || isSymbol(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object(object);
}
function isKeyable(value) {
  var type = typeof value;
  return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
}
function isMasked(func) {
  return !!maskSrcKey && maskSrcKey in func;
}
var stringToPath2 = memoize(function(string) {
  string = toString(string);
  var result = [];
  if (reLeadingDot.test(string)) {
    result.push("");
  }
  string.replace(rePropName, function(match, number, quote2, string2) {
    result.push(quote2 ? string2.replace(reEscapeChar, "$1") : number || match);
  });
  return result;
});
function toKey(value) {
  if (typeof value == "string" || isSymbol(value)) {
    return value;
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY ? "-0" : result;
}
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {
    }
    try {
      return func + "";
    } catch (e) {
    }
  }
  return "";
}
function memoize(func, resolver) {
  if (typeof func != "function" || resolver && typeof resolver != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result);
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache)();
  return memoized;
}
memoize.Cache = MapCache;
function eq(value, other) {
  return value === other || value !== value && other !== other;
}
var isArray = Array.isArray;
function isFunction(value) {
  var tag = isObject(value) ? objectToString.call(value) : "";
  return tag == funcTag || tag == genTag;
}
function isObject(value) {
  var type = typeof value;
  return !!value && (type == "object" || type == "function");
}
function isObjectLike(value) {
  return !!value && typeof value == "object";
}
function isSymbol(value) {
  return typeof value == "symbol" || isObjectLike(value) && objectToString.call(value) == symbolTag;
}
function toString(value) {
  return value == null ? "" : baseToString(value);
}
function set2(object, path, value) {
  return object == null ? object : baseSet(object, path, value);
}
var lodash_set = set2;
function assertNotNull$1(value) {
  if (value == null)
    throw new Error("Value is null or undefined");
}
const colorway = "#76d9e4 #9edc6f #fcd65b #aa9af4 #f37e3f #f95d84 #f0f0ee";
const gridcolor = "#403e41";
const linecolor = "#5b5a5c";
const zerolinecolor = "#c0bfbf";
const activecolor = "#4878ea";
const rangebgcolor = "rgba(91, 90, 92, 0.7)";
const ChartTheme$1 = {
  "paper-bgcolor": "#2d2a2e",
  "plot-bgcolor": "#322f33",
  "title-color": "#f0f0ee",
  colorway,
  gridcolor,
  linecolor,
  zerolinecolor,
  activecolor,
  rangebgcolor,
  "area-color": "#76d9e4",
  "trend-color": "#d5f0c1",
  "line-color": "#9edc6f",
  "error-band-line-color": "white",
  "error-band-fill-color": "rgba(213, 240, 193, 0.1)",
  "ohlc-increasing": "#9edc6f",
  "ohlc-decreasing": "#f95d84"
};
const ChartTheme = Object.freeze({
  paper_bgcolor: ChartTheme$1["paper-bgcolor"],
  plot_bgcolor: ChartTheme$1["plot-bgcolor"],
  title_color: ChartTheme$1["title-color"],
  colorway: ChartTheme$1.colorway,
  gridcolor: ChartTheme$1.gridcolor,
  linecolor: ChartTheme$1.linecolor,
  zerolinecolor: ChartTheme$1.zerolinecolor,
  activecolor: ChartTheme$1.activecolor,
  rangebgcolor: ChartTheme$1.rangebgcolor,
  area_color: ChartTheme$1["area-color"],
  trend_color: ChartTheme$1["trend-color"],
  line_color: ChartTheme$1["line-color"],
  error_band_line_color: ChartTheme$1["error-band-line-color"],
  error_band_fill_color: ChartTheme$1["error-band-fill-color"],
  ohlc_increasing: ChartTheme$1["ohlc-increasing"],
  ohlc_decreasing: ChartTheme$1["ohlc-decreasing"]
});
function ownKeys$7(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread$7(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$7(Object(source), true).forEach(function(key) {
      _defineProperty$i(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$7(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$i(obj, key, value) {
  key = _toPropertyKey$i(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$i(arg) {
  var key = _toPrimitive$i(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$i(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var log$a = Log$3.module("ChartUtils");
var DAYS = Object.freeze(shim$1.calendar.DayOfWeek.values());
var BUSINESS_COLUMN_TYPE = "io.deephaven.time.DateTime";
var MILLIS_PER_HOUR = 36e5;
var NANOS_PER_MILLI = 1e6;
function isDateWrapper(value) {
  return value.asDate !== void 0;
}
function isLongWrapper(value) {
  return value.asNumber !== void 0;
}
function isDateTimeColumnFormatter(value) {
  return value.dhTimeZone !== void 0;
}
function isRangedPlotlyAxis(value) {
  return value != null && value.range != null && (value.autorange === false || value.autorange === void 0);
}
class ChartUtils {
  /**
   * Converts the Iris plot style into a plotly chart type
   * @param plotStyle The plotStyle to use, see dh.plot.SeriesPlotStyle
   * @param isBusinessTime If the plot is using business time for an axis
   */
  static getPlotlyChartType(plotStyle, isBusinessTime) {
    switch (plotStyle) {
      case shim$1.plot.SeriesPlotStyle.SCATTER:
        return !isBusinessTime ? "scattergl" : "scatter";
      case shim$1.plot.SeriesPlotStyle.LINE:
        return "scatter";
      case shim$1.plot.SeriesPlotStyle.BAR:
      case shim$1.plot.SeriesPlotStyle.STACKED_BAR:
        return "bar";
      case shim$1.plot.SeriesPlotStyle.PIE:
        return "pie";
      case shim$1.plot.SeriesPlotStyle.TREEMAP:
        return "treemap";
      case shim$1.plot.SeriesPlotStyle.HISTOGRAM:
        return "histogram";
      case shim$1.plot.SeriesPlotStyle.OHLC:
        return "ohlc";
      default:
        return void 0;
    }
  }
  /**
   * Converts the Iris plot style into a plotly chart mode
   * @param plotStyle The plotStyle to use, see dh.plot.SeriesPlotStyle.*
   * @param areLinesVisible Whether lines are visible or not
   * @param areShapesVisible Whether shapes are visible or not
   */
  static getPlotlyChartMode(plotStyle, areLinesVisible, areShapesVisible) {
    var modes = /* @__PURE__ */ new Set();
    switch (plotStyle) {
      case shim$1.plot.SeriesPlotStyle.SCATTER:
        if (areLinesVisible !== null && areLinesVisible !== void 0 ? areLinesVisible : false) {
          modes.add(ChartUtils.MODE_LINES);
        }
        if (areShapesVisible !== null && areShapesVisible !== void 0 ? areShapesVisible : true) {
          modes.add(ChartUtils.MODE_MARKERS);
        }
        break;
      case shim$1.plot.SeriesPlotStyle.LINE:
        if (areLinesVisible !== null && areLinesVisible !== void 0 ? areLinesVisible : true) {
          modes.add(ChartUtils.MODE_LINES);
        }
        if (areShapesVisible !== null && areShapesVisible !== void 0 ? areShapesVisible : false) {
          modes.add(ChartUtils.MODE_MARKERS);
        }
        break;
    }
    return modes.size > 0 ? [...modes].join("+") : void 0;
  }
  /**
   * Get the property to set on the series data for plotly
   * @param plotStyle The plot style of the series
   * @param sourceType The source type for the series
   */
  static getPlotlyProperty(plotStyle, sourceType) {
    switch (plotStyle) {
      case shim$1.plot.SeriesPlotStyle.PIE:
        switch (sourceType) {
          case shim$1.plot.SourceType.X:
            return "labels";
          case shim$1.plot.SourceType.Y:
            return "values";
        }
        break;
      case shim$1.plot.SeriesPlotStyle.OHLC:
        switch (sourceType) {
          case shim$1.plot.SourceType.TIME:
            return "x";
        }
        break;
      case shim$1.plot.SeriesPlotStyle.TREEMAP:
        switch (sourceType) {
          case shim$1.plot.SourceType.X:
            return "ids";
          case shim$1.plot.SourceType.Y:
            return "values";
          case shim$1.plot.SourceType.LABEL:
            return "labels";
          case shim$1.plot.SourceType.PARENT:
            return "parents";
          case shim$1.plot.SourceType.COLOR:
            return "marker.colors";
        }
        break;
    }
    switch (sourceType) {
      case shim$1.plot.SourceType.X:
        return "x";
      case shim$1.plot.SourceType.Y:
        return "y";
      case shim$1.plot.SourceType.Z:
        return "z";
      case shim$1.plot.SourceType.X_LOW:
        return "xLow";
      case shim$1.plot.SourceType.X_HIGH:
        return "xHigh";
      case shim$1.plot.SourceType.Y_LOW:
        return "yLow";
      case shim$1.plot.SourceType.Y_HIGH:
        return "yHigh";
      case shim$1.plot.SourceType.TIME:
        return "time";
      case shim$1.plot.SourceType.OPEN:
        return "open";
      case shim$1.plot.SourceType.HIGH:
        return "high";
      case shim$1.plot.SourceType.LOW:
        return "low";
      case shim$1.plot.SourceType.CLOSE:
        return "close";
      case shim$1.plot.SourceType.SHAPE:
        return "shape";
      case shim$1.plot.SourceType.SIZE:
        return "size";
      case shim$1.plot.SourceType.LABEL:
        return "label";
      case shim$1.plot.SourceType.COLOR:
        return "color";
      case shim$1.plot.SourceType.PARENT:
        return "parent";
      case shim$1.plot.SourceType.HOVER_TEXT:
        return "hovertext";
      case shim$1.plot.SourceType.TEXT:
        return "text";
      default:
        throw new Error("Unrecognized source type: ".concat(sourceType));
    }
  }
  static getPlotlySeriesOrientation(series) {
    var _sources$, _sources$$axis;
    var {
      sources
    } = series;
    if (sources.length === 2 && ((_sources$ = sources[0]) === null || _sources$ === void 0 ? void 0 : (_sources$$axis = _sources$.axis) === null || _sources$$axis === void 0 ? void 0 : _sources$$axis.type) === shim$1.plot.AxisType.Y) {
      return ChartUtils.ORIENTATION.HORIZONTAL;
    }
    return ChartUtils.ORIENTATION.VERTICAL;
  }
  /**
   * Generate the plotly error bar data from the passed in data.
   * Iris passes in the values as absolute, plotly needs them as relative.
   * @param x The main data array
   * @param xLow The absolute low values
   * @param xHigh
   *
   * @returns The error_x object required by plotly, or null if none is required
   */
  static getPlotlyErrorBars(x, xLow, xHigh) {
    var array = xHigh.map((value, i) => value - x[i]);
    var arrayminus = xLow.map((value, i) => x[i] - value);
    return {
      type: "data",
      symmetric: false,
      array,
      arrayminus
    };
  }
  static getPlotlyDateFormat(formatter, columnType, formatPattern) {
    var tickformat = formatPattern == null ? void 0 : formatPattern.replace("%", "%%").replace(/S{9}/g, "%9f").replace(/S{8}/g, "%8f").replace(/S{7}/g, "%7f").replace(/S{6}/g, "%6f").replace(/S{5}/g, "%5f").replace(/S{4}/g, "%4f").replace(/S{3}/g, "%3f").replace(/S{2}/g, "%2f").replace(/S{1}/g, "%1f").replace(/y{4}/g, "%Y").replace(/y{2}/g, "%y").replace(/M{4}/g, "%B").replace(/M{3}/g, "%b").replace(/M{2}/g, "%m").replace(/M{1}/g, "%-m").replace(/E{4,}/g, "%A").replace(/E{1,}/g, "%a").replace(/d{2}/g, "%d").replace(/([^%]|^)d{1}/g, "$1%-d").replace(/H{2}/g, "%H").replace(/h{2}/g, "%I").replace(/h{1}/g, "%-I").replace(/m{2}/g, "%M").replace(/s{2}/g, "%S").replace("'T'", "T").replace(" z", "");
    var ticksuffix;
    var dataFormatter = formatter === null || formatter === void 0 ? void 0 : formatter.getColumnTypeFormatter(columnType);
    if (dataFormatter != null && isDateTimeColumnFormatter(dataFormatter) && dataFormatter.dhTimeZone != null && dataFormatter.showTimeZone) {
      ticksuffix = shim$1.i18n.DateTimeFormat.format(" z", new Date(), dataFormatter.dhTimeZone);
    }
    return {
      tickformat,
      ticksuffix,
      automargin: true
    };
  }
  static convertNumberPrefix(prefix) {
    return prefix.replace(/\u00A4\u00A4/g, "USD").replace(/\u00A4/g, "$");
  }
  static getPlotlyNumberFormat(formatter, columnType, formatPattern) {
    if (!formatPattern) {
      return null;
    }
    var subpatterns = formatPattern.split(";");
    var matchArray = subpatterns[0].match(/^([^#,0.]*)([#,]*)([0,]*)(\.?)(0*)(#*)(E?0*)(%?)(.*)/);
    assertNotNull$1(matchArray);
    var [, prefix, placeholderDigits, zeroDigits, , decimalDigits, optionalDecimalDigits, numberType, percentSign, suffix] = matchArray;
    var paddingLength = zeroDigits.replace(",", "").length;
    var isCommaSeparated = placeholderDigits.indexOf(",") >= 0 || zeroDigits.indexOf(",") >= 0;
    var comma = isCommaSeparated ? "," : "";
    var plotlyNumberType = numberType != null && numberType !== "" ? "e" : "f";
    var type = percentSign !== "" ? percentSign : plotlyNumberType;
    var decimalLength = decimalDigits.length + optionalDecimalDigits.length;
    var trimOption = "";
    var tickformat = "0".concat(paddingLength).concat(comma, ".").concat(decimalLength).concat(trimOption).concat(type);
    var tickprefix = ChartUtils.convertNumberPrefix(prefix);
    var ticksuffix = ChartUtils.convertNumberPrefix(suffix);
    return {
      tickformat,
      tickprefix,
      ticksuffix,
      automargin: true
    };
  }
  /**
   * Gets the plotly axis formatting information from the source passed in
   * @param source The Source to get the formatter information from
   * @param formatter The current formatter for formatting data
   */
  static getPlotlyAxisFormat(source) {
    var formatter = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
    var {
      axis,
      columnType
    } = source;
    var {
      formatPattern
    } = axis;
    var axisFormat = null;
    if (TableUtils.isDateType(columnType)) {
      axisFormat = ChartUtils.getPlotlyDateFormat(formatter, columnType, formatPattern);
      axisFormat = ChartUtils.addTickSpacing(axisFormat, axis, true);
    } else if (TableUtils.isNumberType(columnType)) {
      axisFormat = ChartUtils.getPlotlyNumberFormat(formatter, columnType, formatPattern);
      axisFormat = ChartUtils.addTickSpacing(axisFormat, axis, false);
    }
    if (axis.formatType === shim$1.plot.AxisFormatType.CATEGORY) {
      if (axisFormat) {
        axisFormat.type = "category";
      } else {
        axisFormat = {
          type: "category",
          tickformat: void 0,
          ticksuffix: void 0
        };
      }
    }
    return axisFormat;
  }
  /**
   * Adds tick spacing for an axis that has gapBetweenMajorTicks defined.
   *
   * @param axisFormat the current axis format, may be null
   * @param axis the current axis
   * @param isDateType indicates if the columns is a date type
   */
  static addTickSpacing(axisFormat, axis, isDateType) {
    var {
      gapBetweenMajorTicks
    } = axis;
    if (gapBetweenMajorTicks > 0) {
      var updatedFormat = axisFormat || {};
      var tickSpacing = gapBetweenMajorTicks;
      if (isDateType) {
        tickSpacing = gapBetweenMajorTicks / NANOS_PER_MILLI;
      }
      if (axis.log) {
        tickSpacing = Math.log(tickSpacing);
      }
      updatedFormat.tickmode = "linear";
      updatedFormat.dtick = tickSpacing;
      return updatedFormat;
    }
    return axisFormat;
  }
  /**
   * Retrieve the data source for a given axis in a chart
   * @param chart The chart to get the source for
   * @param axis The axis to find the source for
   * @returns The first source matching this axis
   */
  static getSourceForAxis(chart, axis) {
    for (var i = 0; i < chart.series.length; i += 1) {
      var series = chart.series[i];
      for (var j = 0; j < series.sources.length; j += 1) {
        var source = series.sources[j];
        if (source.axis === axis) {
          return source;
        }
      }
    }
    return null;
  }
  /**
   * Get visibility setting for the series object
   * @param  name The series name to get the visibility for
   * @param  settings Chart settings
   * @returns True for visible series and 'legendonly' for hidden
   */
  static getSeriesVisibility(name2, settings) {
    if (settings != null && settings.hiddenSeries != null && settings.hiddenSeries.includes(name2)) {
      return "legendonly";
    }
    return true;
  }
  /**
   * Get hidden labels array from chart settings
   * @param settings Chart settings
   * @returns Array of hidden series names
   */
  static getHiddenLabels(settings) {
    if (settings !== null && settings !== void 0 && settings.hiddenSeries) {
      return [...settings.hiddenSeries];
    }
    return [];
  }
  /**
   * Create a default series data object. Apply styling to the object afterward.
   * @returns A simple series data object with no styling
   */
  static makeSeriesData(type, mode, name2, showLegend) {
    var orientation = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : ChartUtils.ORIENTATION.VERTICAL;
    return {
      type,
      mode,
      name: name2,
      orientation,
      showlegend: showLegend !== null && showLegend !== void 0 ? showLegend : void 0
    };
  }
  /**
   * Create a data series (trace) for use with plotly
   * @param series The series to create the series data with
   * @param axisTypeMap The map of axes grouped by type
   * @param seriesVisibility Visibility setting for the series
   * @param theme The theme properties for the plot. See ChartTheme.js for an example
   * @returns The series data (trace) object for use with plotly.
   */
  static makeSeriesDataFromSeries(series, axisTypeMap, seriesVisibility) {
    var showLegend = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
    var theme = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : ChartTheme;
    var {
      name: name2,
      isLinesVisible,
      isShapesVisible,
      plotStyle,
      lineColor,
      shapeColor,
      sources,
      shape,
      shapeSize
    } = series;
    var isBusinessTime = sources.some((source) => {
      var _source$axis;
      return (_source$axis = source.axis) === null || _source$axis === void 0 ? void 0 : _source$axis.businessCalendar;
    });
    var type = ChartUtils.getChartType(plotStyle, isBusinessTime);
    var mode = ChartUtils.getPlotlyChartMode(plotStyle, isLinesVisible !== null && isLinesVisible !== void 0 ? isLinesVisible : void 0, isShapesVisible !== null && isShapesVisible !== void 0 ? isShapesVisible : void 0);
    var orientation = ChartUtils.getPlotlySeriesOrientation(series);
    var seriesData = ChartUtils.makeSeriesData(type, mode, name2, showLegend, orientation);
    ChartUtils.addSourcesToSeriesData(seriesData, plotStyle, sources, axisTypeMap);
    ChartUtils.addStylingToSeriesData(seriesData, plotStyle, theme, lineColor, shapeColor, shape, shapeSize, seriesVisibility);
    return seriesData;
  }
  static addSourcesToSeriesData(seriesDataParam, plotStyle, sources, axisTypeMap) {
    var seriesData = seriesDataParam;
    for (var k = 0; k < sources.length; k += 1) {
      var source = sources[k];
      var {
        axis: _axis,
        type: sourceType
      } = source;
      var dataAttributeName = ChartUtils.getPlotlyProperty(plotStyle, sourceType);
      lodash_set(seriesData, dataAttributeName, []);
      var axisProperty = _axis != null ? ChartUtils.getAxisPropertyName(_axis.type) : null;
      if (axisProperty != null) {
        var axes = axisTypeMap.get(_axis.type);
        if (axes) {
          var axisIndex = axes.indexOf(_axis);
          var axisIndexString = axisIndex > 0 ? "".concat(axisIndex + 1) : "";
          seriesData["".concat(axisProperty, "axis")] = "".concat(axisProperty).concat(axisIndexString);
        }
      }
    }
  }
  static addStylingToSeriesData(seriesDataParam, plotStyle) {
    var theme = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : ChartTheme;
    var lineColor = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
    var shapeColor = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : null;
    var shape = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : null;
    var shapeSize = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : null;
    var seriesVisibility = arguments.length > 7 && arguments[7] !== void 0 ? arguments[7] : null;
    var seriesData = seriesDataParam;
    seriesData.marker = {
      line: {}
    };
    seriesData.line = {
      width: 1
      // default line width for lines, should eventually be able to override
    };
    if (plotStyle === shim$1.plot.SeriesPlotStyle.AREA) {
      seriesData.fill = "tozeroy";
    } else if (plotStyle === shim$1.plot.SeriesPlotStyle.STACKED_AREA) {
      seriesData.stackgroup = "stack";
    } else if (plotStyle === shim$1.plot.SeriesPlotStyle.STEP) {
      seriesData.line.shape = "hv";
    } else if (plotStyle === shim$1.plot.SeriesPlotStyle.HISTOGRAM) {
      seriesData.width = [];
      if (seriesData.marker.line !== void 0) {
        Object.assign(seriesData.marker.line, {
          color: theme.paper_bgcolor,
          width: 1
        });
      }
    } else if (plotStyle === shim$1.plot.SeriesPlotStyle.OHLC) {
      seriesData.increasing = {
        line: {
          color: theme.ohlc_increasing
        }
      };
      seriesData.decreasing = {
        line: {
          color: theme.ohlc_decreasing
        }
      };
    } else if (plotStyle === shim$1.plot.SeriesPlotStyle.PIE) {
      seriesData.textinfo = "label+percent";
      seriesData.outsidetextfont = {
        color: theme.title_color
      };
    } else if (plotStyle === shim$1.plot.SeriesPlotStyle.TREEMAP) {
      seriesData.hoverinfo = "text";
      seriesData.textinfo = "label+text";
      seriesData.tiling = {
        packing: "squarify",
        pad: 0
      };
      seriesData.textposition = "middle center";
      seriesData.outsidetextfont = {
        color: theme.title_color
      };
    }
    if (lineColor != null) {
      if (plotStyle === shim$1.plot.SeriesPlotStyle.BAR) {
        seriesData.marker.color = lineColor;
      } else {
        seriesData.line.color = lineColor;
      }
    }
    if (shapeColor != null) {
      seriesData.marker.color = shapeColor;
    }
    if (shape != null && shape.length > 0) {
      try {
        seriesData.marker.symbol = ChartUtils.getMarkerSymbol(shape);
      } catch (e) {
        log$a.warn("Unable to handle shape", shape, ":", e);
      }
    }
    if (shapeSize != null) {
      seriesData.marker.size = shapeSize * ChartUtils.DEFAULT_MARKER_SIZE;
    }
    if (seriesVisibility != null && plotStyle !== shim$1.plot.SeriesPlotStyle.PIE) {
      seriesData.visible = seriesVisibility;
    }
  }
  /**
   * Get the Plotly marker symbol for the provided Deephaven shape
   * Deephaven shapes: https://deephaven.io/enterprise/docs/plotting/visual-formatting/#point-formatting
   * Plotly shapes: https://plotly.com/javascript/reference/scattergl/#scattergl-marker-symbol
   * Table of plotly shapes: https://plotly.com/python/marker-style/#custom-marker-symbols
   * @param deephavenShape Deephaven shape to get the marker symbol for
   */
  static getMarkerSymbol(deephavenShape) {
    switch (deephavenShape) {
      case "SQUARE":
        return "square";
      case "CIRCLE":
        return "circle";
      case "DIAMOND":
        return "diamond";
      case "UP_TRIANGLE":
        return "triangle-up";
      case "DOWN_TRIANGLE":
        return "triangle-down";
      case "RIGHT_TRIANGLE":
        return "triangle-right";
      case "LEFT_TRIANGLE":
        return "triangle-left";
      case "ELLIPSE":
      case "HORIZONTAL_RECTANGLE":
      case "VERTICAL_RECTANGLE":
      default:
        throw new Error("Unrecognized shape ".concat(deephavenShape));
    }
  }
  /**
   * Retrieve the axis formats from the provided figure.
   * Currently defaults to just the x/y axes.
   * @param figure The figure to get the axis formats for
   * @param formatter The formatter to use when getting the axis format
   * @returns A map of axis layout property names to axis formats
   */
  static getAxisFormats(figure, formatter) {
    var axisFormats = /* @__PURE__ */ new Map();
    var nullFormat = {
      tickformat: null,
      ticksuffix: null
    };
    var allAxes = ChartUtils.getAllAxes(figure);
    var axisTypeMap = ChartUtils.groupArray(allAxes, "type");
    var {
      charts
    } = figure;
    for (var i = 0; i < charts.length; i += 1) {
      var _chart = charts[i];
      for (var j = 0; j < _chart.series.length; j += 1) {
        var series = _chart.series[j];
        var {
          sources
        } = series;
        var axisSources = sources.filter((source) => source.axis);
        var _loop = function _loop2() {
          var source = axisSources[k];
          var {
            axis
          } = source;
          var {
            type: axisType
          } = axis;
          var typeAxes = axisTypeMap.get(axisType);
          assertNotNull$1(typeAxes);
          var axisIndex = typeAxes.indexOf(axis);
          var axisProperty = ChartUtils.getAxisPropertyName(axisType);
          if (axisProperty != null) {
            var axisLayoutProperty = ChartUtils.getAxisLayoutProperty(axisProperty, axisIndex);
            if (axisFormats.has(axisLayoutProperty)) {
              log$a.debug("".concat(axisLayoutProperty, " already added."));
            } else {
              log$a.debug("Adding ".concat(axisLayoutProperty, " to axisFormats."));
              var axisFormat = ChartUtils.getPlotlyAxisFormat(source, formatter);
              if (axisFormat === null) {
                axisFormats.set(axisLayoutProperty, nullFormat);
              } else {
                axisFormats.set(axisLayoutProperty, axisFormat);
                var {
                  businessCalendar
                } = axis;
                if (businessCalendar != null) {
                  var rangebreaks = [];
                  var {
                    businessPeriods,
                    businessDays,
                    holidays,
                    timeZone: calendarTimeZone
                  } = businessCalendar;
                  var typeFormatter = formatter === null || formatter === void 0 ? void 0 : formatter.getColumnTypeFormatter(BUSINESS_COLUMN_TYPE);
                  var formatterTimeZone;
                  if (isDateTimeColumnFormatter(typeFormatter)) {
                    formatterTimeZone = typeFormatter.dhTimeZone;
                  }
                  var timeZoneDiff = formatterTimeZone ? (calendarTimeZone.standardOffset - formatterTimeZone.standardOffset) / 60 : 0;
                  if (holidays.length > 0) {
                    rangebreaks.push(...ChartUtils.createRangeBreakValuesFromHolidays(holidays, calendarTimeZone, formatterTimeZone));
                  }
                  businessPeriods.forEach((period) => rangebreaks.push({
                    pattern: "hour",
                    bounds: [ChartUtils.periodToDecimal(period.close) + timeZoneDiff, ChartUtils.periodToDecimal(period.open) + timeZoneDiff]
                  }));
                  if (businessDays.length < DAYS.length) {
                    ChartUtils.createBoundsFromDays(businessDays).forEach((weekendBounds) => rangebreaks.push({
                      pattern: "day of week",
                      bounds: weekendBounds
                    }));
                  }
                  axisFormat.rangebreaks = rangebreaks;
                }
                if (axisFormats.size === _chart.axes.length) {
                  return {
                    v: axisFormats
                  };
                }
              }
            }
          }
        };
        for (var k = 0; k < axisSources.length; k += 1) {
          var _ret = _loop();
          if (typeof _ret === "object")
            return _ret.v;
        }
      }
    }
    return axisFormats;
  }
  static getChartType(plotStyle, isBusinessTime) {
    switch (plotStyle) {
      case shim$1.plot.SeriesPlotStyle.HISTOGRAM:
        return "bar";
      default:
        return ChartUtils.getPlotlyChartType(plotStyle, isBusinessTime);
    }
  }
  /**
   * Return the plotly axis property name
   * @param axisType The axis type to get the property name for
   */
  static getAxisPropertyName(axisType) {
    switch (axisType) {
      case shim$1.plot.AxisType.X:
        return "x";
      case shim$1.plot.AxisType.Y:
        return "y";
      default:
        return null;
    }
  }
  /**
   * Returns the plotly "side" value for the provided axis position
   * @param axisPosition The Iris AxisPosition of the axis
   */
  static getAxisSide(axisPosition) {
    switch (axisPosition) {
      case shim$1.plot.AxisPosition.BOTTOM:
        return "bottom";
      case shim$1.plot.AxisPosition.TOP:
        return "top";
      case shim$1.plot.AxisPosition.LEFT:
        return "left";
      case shim$1.plot.AxisPosition.RIGHT:
        return "right";
      default:
        return void 0;
    }
  }
  /**
   * Get all axes for a given `Figure`. Iterates through all charts axes and concatenates them.
   * @param figure Figure to get all axes for
   */
  static getAllAxes(figure) {
    return figure.charts.reduce((axes, chart) => [...axes, ...chart.axes], []);
  }
  /**
   * Retrieve the chart that contains the passed in series from the figure
   * @param figure The figure to retrieve the chart from
   * @param series The series to get the chart for
   */
  static getChartForSeries(figure, series) {
    var {
      charts
    } = figure;
    for (var i = 0; i < charts.length; i += 1) {
      var _chart2 = charts[i];
      for (var j = 0; j < _chart2.series.length; j += 1) {
        if (series === _chart2.series[j]) {
          return _chart2;
        }
      }
    }
    return null;
  }
  /**
   * Get an object mapping axis to their ranges
   * @param layout The plotly layout object to get the ranges from
   * @returns An object mapping the axis name to it's range
   */
  static getLayoutRanges(layout) {
    var ranges = {};
    var keys3 = Object.keys(layout).filter((key2) => key2.indexOf("axis") >= 0);
    for (var i = 0; i < keys3.length; i += 1) {
      var key = keys3[i];
      var value = layout[key];
      if (isRangedPlotlyAxis(value)) {
        ranges[key] = [...value.range];
      }
    }
    return ranges;
  }
  /**
   * Update the layout with all the axes information for the provided figure
   * @param figure Figure to update the axes for
   * @param layoutParam Layout object to update in place
   * @param chartAxisRangeParser Function to retrieve the axis range parser
   * @param plotWidth Width of the plot in pixels
   * @param plotHeight Height of the plot in pixels
   * @param theme Theme used for displaying the plot
   */
  static updateFigureAxes(layoutParam, figure, chartAxisRangeParser) {
    var plotWidth = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0;
    var plotHeight = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 0;
    var theme = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : ChartTheme;
    var layout = layoutParam;
    var figureAxes = ChartUtils.getAllAxes(figure);
    for (var i = 0; i < figure.charts.length; i += 1) {
      var _chart3 = figure.charts[i];
      var axisRangeParser = chartAxisRangeParser === null || chartAxisRangeParser === void 0 ? void 0 : chartAxisRangeParser(_chart3);
      var bounds = ChartUtils.getChartBounds(figure, _chart3, plotWidth, plotHeight);
      ChartUtils.updateLayoutAxes(layout, _chart3.axes, figureAxes, plotWidth, plotHeight, bounds, axisRangeParser, theme);
    }
    ChartUtils.removeStaleAxes(layout, figureAxes);
  }
  static getChartBounds(figure, chart, plotWidth, plotHeight) {
    var _axisPositionMap$get;
    var {
      cols,
      rows
    } = figure;
    var {
      column,
      colspan,
      row,
      rowspan
    } = chart;
    var endColumn = column + colspan;
    var endRow = row + rowspan;
    var columnSize = 1 / cols;
    var rowSize = 1 / rows;
    var xMarginSize = ChartUtils.AXIS_SIZE_PX / plotWidth;
    var yMarginSize = ChartUtils.AXIS_SIZE_PX / plotHeight;
    var bounds = {
      // Need to invert the row positioning so the first one defined shows up on top instead of the bottom, since coordinates start in bottom left
      bottom: (rows - endRow) * rowSize + (endRow < rows ? yMarginSize / 2 : 0),
      top: (rows - row) * rowSize - (row > 0 ? yMarginSize / 2 : 0),
      left: column * columnSize + (column > 0 ? xMarginSize / 2 : 0),
      right: endColumn * columnSize - (endColumn < cols ? xMarginSize / 2 : 0)
    };
    var axisPositionMap = ChartUtils.groupArray(chart.axes, "position");
    var rightAxes = (_axisPositionMap$get = axisPositionMap.get(shim$1.plot.AxisPosition.RIGHT)) !== null && _axisPositionMap$get !== void 0 ? _axisPositionMap$get : [];
    if (rightAxes.length > 0) {
      if (plotWidth > 0) {
        bounds.right -= (bounds.right - bounds.left) * Math.max(0, Math.min(ChartUtils.LEGEND_WIDTH_PX / plotWidth, ChartUtils.MAX_LEGEND_SIZE));
      } else {
        bounds.right -= (bounds.right - bounds.left) * ChartUtils.DEFAULT_AXIS_SIZE;
      }
    }
    return bounds;
  }
  /**
   * Updates the axes positions and sizes in the layout object provided.
   * If the axis did not exist in the layout previously, it is created and added.
   * Any axis that no longer exists in axes is removed.
   * With Downsampling enabled, will also update the range on the axis itself as appropriate
   * @param layoutParam The layout object to update
   * @param chartAxes The chart axes to update the layout with
   * @param figureAxes All figure axes to update the layout with
   * @param plotWidth The width of the plot to calculate the axis sizes for
   * @param plotHeight The height of the plot to calculate the axis sizes for
   * @param bounds The bounds for this set of axes
   * @param axisRangeParser A function to retrieve the range parser for a given axis
   */
  static updateLayoutAxes(layoutParam, chartAxes, figureAxes) {
    var plotWidth = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : 0;
    var plotHeight = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : 0;
    var bounds = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : {
      left: 0,
      top: 0,
      right: 1,
      bottom: 1
    };
    var axisRangeParser = arguments.length > 6 ? arguments[6] : void 0;
    var theme = arguments.length > 7 && arguments[7] !== void 0 ? arguments[7] : ChartTheme;
    var xAxisSize = plotWidth > 0 ? Math.max(ChartUtils.MIN_AXIS_SIZE, Math.min(ChartUtils.AXIS_SIZE_PX / plotHeight, ChartUtils.MAX_AXIS_SIZE)) : ChartUtils.DEFAULT_AXIS_SIZE;
    var yAxisSize = plotHeight > 0 ? Math.max(ChartUtils.MIN_AXIS_SIZE, Math.min(ChartUtils.AXIS_SIZE_PX / plotWidth, ChartUtils.MAX_AXIS_SIZE)) : ChartUtils.DEFAULT_AXIS_SIZE;
    var layout = layoutParam;
    var axisPositionMap = ChartUtils.groupArray(chartAxes, "position");
    var axisTypeMap = ChartUtils.groupArray(chartAxes, "type");
    var axisTypes = [...axisTypeMap.keys()];
    var figureAxisTypeMap = ChartUtils.groupArray(figureAxes, "type");
    for (var j = 0; j < axisTypes.length; j += 1) {
      var axisType = axisTypes[j];
      var axisProperty = ChartUtils.getAxisPropertyName(axisType);
      if (axisProperty != null) {
        var typeAxes = axisTypeMap.get(axisType);
        var figureTypeAxes = figureAxisTypeMap.get(axisType);
        var isYAxis = axisType === shim$1.plot.AxisType.Y;
        var plotSize = isYAxis ? plotHeight : plotWidth;
        assertNotNull$1(typeAxes);
        assertNotNull$1(figureTypeAxes);
        for (var chartAxisIndex = 0; chartAxisIndex < typeAxes.length; chartAxisIndex += 1) {
          var _axis2 = typeAxes[chartAxisIndex];
          var figureAxisIndex = figureTypeAxes.indexOf(_axis2);
          var axisLayoutProperty = ChartUtils.getAxisLayoutProperty(axisProperty, figureAxisIndex);
          if (layout[axisLayoutProperty] == null) {
            layout[axisLayoutProperty] = ChartUtils.makeLayoutAxis(axisType, theme);
          }
          var layoutAxis = layout[axisLayoutProperty];
          if (layoutAxis != null) {
            ChartUtils.updateLayoutAxis(layoutAxis, _axis2, chartAxisIndex, axisPositionMap, xAxisSize, yAxisSize, bounds);
            var {
              range: _range,
              autorange
            } = layoutAxis;
            if (axisRangeParser != null && _range !== void 0 && (autorange === void 0 || autorange === false)) {
              var rangeParser = axisRangeParser(_axis2);
              var [rangeStart, rangeEnd] = rangeParser(_range);
              log$a.debug("Setting downsample range", plotSize, rangeStart, rangeEnd);
              _axis2.range(plotSize, rangeStart, rangeEnd);
            } else {
              _axis2.range(plotSize);
            }
          }
        }
      }
    }
  }
  /**
   * Remove any axes from the layout param that no longer belong to any series
   * @param layoutParam Layout object to remove stale axes from
   * @param axes All axes in the figure
   */
  static removeStaleAxes(layoutParam, axes) {
    var layout = layoutParam;
    var figureAxisTypeMap = ChartUtils.groupArray(axes, "type");
    var figureAxisTypes = [...figureAxisTypeMap.keys()];
    for (var i = 0; i < figureAxisTypes.length; i += 1) {
      var axisType = figureAxisTypes[i];
      var typeAxes = figureAxisTypeMap.get(axisType);
      assertNotNull$1(typeAxes);
      var axisIndex = typeAxes.length;
      var axisProperty = ChartUtils.getAxisPropertyName(axisType);
      if (axisProperty != null) {
        var axisLayoutProperty = ChartUtils.getAxisLayoutProperty(axisProperty, axisIndex);
        while (layout[axisLayoutProperty] != null) {
          delete layout[axisLayoutProperty];
          axisIndex += 1;
          axisLayoutProperty = ChartUtils.getAxisLayoutProperty(axisProperty, axisIndex);
        }
      }
    }
  }
  static getAxisLayoutProperty(axisProperty, axisIndex) {
    var axisIndexString = axisIndex > 0 ? "".concat(axisIndex + 1) : "";
    return "".concat(axisProperty !== null && axisProperty !== void 0 ? axisProperty : "", "axis").concat(axisIndexString);
  }
  /**
   * Updates the layout axis object in place
   * @param layoutAxisParam The plotly layout axis param
   * @param axis The Iris Axis to update the plotly layout with
   * @param axisIndex The type index for this axis
   * @param axisPositionMap All the axes mapped by position
   * @param axisSize The size of each axis in percent
   * @param bounds The bounds of the axes domains
   */
  static updateLayoutAxis(layoutAxisParam, axis, axisIndex, axisPositionMap, xAxisSize, yAxisSize, bounds) {
    var _axis$label;
    var isYAxis = axis.type === shim$1.plot.AxisType.Y;
    var axisSize = isYAxis ? yAxisSize : xAxisSize;
    var layoutAxis = layoutAxisParam;
    var label = (_axis$label = axis.label) !== null && _axis$label !== void 0 ? _axis$label : "";
    if (layoutAxis.title !== void 0 && typeof layoutAxis.title !== "string") {
      layoutAxis.title.text = label;
    } else {
      layoutAxis.title = {
        text: label
      };
    }
    if (axis.log) {
      layoutAxis.type = "log";
    }
    layoutAxis.side = ChartUtils.getAxisSide(axis.position);
    if (axisIndex > 0) {
      var _ChartUtils$getAxisPr, _axisPositionMap$get2;
      layoutAxis.overlaying = (_ChartUtils$getAxisPr = ChartUtils.getAxisPropertyName(axis.type)) !== null && _ChartUtils$getAxisPr !== void 0 ? _ChartUtils$getAxisPr : void 0;
      var positionAxes = (_axisPositionMap$get2 = axisPositionMap.get(axis.position)) !== null && _axisPositionMap$get2 !== void 0 ? _axisPositionMap$get2 : [];
      var sideIndex = positionAxes.indexOf(axis);
      if (sideIndex > 0) {
        layoutAxis.anchor = "free";
        if (axis.position === shim$1.plot.AxisPosition.RIGHT) {
          layoutAxis.position = bounds.right + (sideIndex - positionAxes.length + 1) * axisSize;
        } else if (axis.position === shim$1.plot.AxisPosition.TOP) {
          layoutAxis.position = bounds.top + (sideIndex - positionAxes.length + 1) * axisSize;
        } else if (axis.position === shim$1.plot.AxisPosition.BOTTOM) {
          layoutAxis.position = bounds.bottom + (positionAxes.length - sideIndex + 1) * axisSize;
        } else if (axis.position === shim$1.plot.AxisPosition.LEFT) {
          layoutAxis.position = bounds.left + (positionAxes.length - sideIndex + 1) * axisSize;
        }
      }
    } else if (axis.type === shim$1.plot.AxisType.X) {
      var leftAxes = axisPositionMap.get(shim$1.plot.AxisPosition.LEFT) || [];
      var rightAxes = axisPositionMap.get(shim$1.plot.AxisPosition.RIGHT) || [];
      var left = Math.max(bounds.left, bounds.left + (leftAxes.length - 1) * yAxisSize);
      var right = Math.min(bounds.right - (rightAxes.length - 1) * yAxisSize, bounds.right);
      layoutAxis.domain = [left, right];
    } else if (axis.type === shim$1.plot.AxisType.Y) {
      var bottomAxes = axisPositionMap.get(shim$1.plot.AxisPosition.BOTTOM) || [];
      var topAxes = axisPositionMap.get(shim$1.plot.AxisPosition.TOP) || [];
      var bottom = Math.max(bounds.bottom, bounds.bottom + (bottomAxes.length - 1) * xAxisSize);
      var top = Math.min(bounds.top - (topAxes.length - 1) * xAxisSize, bounds.top);
      layoutAxis.domain = [bottom, top];
    }
  }
  /**
   * Converts an open or close period to a declimal. e.g '09:30" to 9.5
   *
   * @param period the open or close value of the period
   */
  static periodToDecimal(period) {
    var values = period.split(":");
    return Number(values[0]) + Number(values[1]) / 60;
  }
  /**
   * Creates range break bounds for plotly from business days.
   * For example a standard business week of ['MONDAY','TUESDAY','WEDNESDAY','THURSDAY','FRIDAY']
   * will result in [[6,1]] meaning close on Saturday and open on Monday.
   * If you remove Wednesday from the array, then you get two closures [[6, 1], [3, 4]]
   *
   * @param businessDays the days to display on the x-axis
   */
  static createBoundsFromDays(businessDays) {
    var businessDaysInt = businessDays.map((day) => DAYS.indexOf(day));
    var nonBusinessDaysInt = DAYS.filter((day) => !businessDays.includes(day)).map((day) => DAYS.indexOf(day));
    var reopenDays = /* @__PURE__ */ new Set();
    nonBusinessDaysInt.forEach((closed) => {
      for (var i = closed + 1; i < closed + DAYS.length; i += 1) {
        var adjustedDay = i % DAYS.length;
        if (businessDaysInt.includes(adjustedDay)) {
          reopenDays.add(adjustedDay);
          break;
        }
      }
    });
    var boundsArray = [];
    reopenDays.forEach((open) => {
      for (var i = open - 1; i > open - DAYS.length; i -= 1) {
        var adjustedDay = i < 0 ? i + DAYS.length : i;
        if (businessDaysInt.includes(adjustedDay)) {
          var closedDay = (adjustedDay + 1) % 7;
          boundsArray.push([closedDay, open]);
          break;
        }
      }
    });
    return boundsArray;
  }
  /**
   * Creates an array of range breaks for all holidays.
   *
   * @param holidays an array of holidays
   * @param calendarTimeZone the time zone for the business calendar
   * @param formatterTimeZone the time zone for the formatter
   */
  static createRangeBreakValuesFromHolidays(holidays, calendarTimeZone, formatterTimeZone) {
    var fullHolidays = [];
    var partialHolidays = [];
    holidays.forEach((holiday) => {
      if (holiday.businessPeriods.length > 0) {
        partialHolidays.push(...ChartUtils.createPartialHoliday(holiday, calendarTimeZone, formatterTimeZone));
      } else {
        fullHolidays.push(ChartUtils.createFullHoliday(holiday, calendarTimeZone, formatterTimeZone));
      }
    });
    return [{
      values: fullHolidays
    }, ...partialHolidays];
  }
  /**
   * Creates the range break value for a full holiday. A full holiday is day that has no business periods.
   *
   * @param holiday the full holiday
   * @param calendarTimeZone the time zone for the business calendar
   * @param formatterTimeZone the time zone for the formatter
   */
  static createFullHoliday(holiday, calendarTimeZone, formatterTimeZone) {
    return ChartUtils.adjustDateForTimeZone("".concat(holiday.date.toString(), " 00:00:00.000000"), calendarTimeZone, formatterTimeZone);
  }
  /**
   * Creates the range break for a partial holiday. A partial holiday is holiday with business periods
   * that are different than the default business periods.
   *
   * @param holiday the partial holiday
   * @param calendarTimeZone the time zone for the business calendar
   * @param formatterTimeZone the time zone for the formatter
   */
  static createPartialHoliday(holiday, calendarTimeZone, formatterTimeZone) {
    var dateString = holiday.date.toString();
    var closedPeriods = ["00:00"];
    holiday.businessPeriods.forEach((period) => {
      closedPeriods.push(period.open);
      closedPeriods.push(period.close);
    });
    closedPeriods.push("24:00");
    var rangeBreaks = [];
    for (var i = 0; i < closedPeriods.length; i += 2) {
      var startClose = closedPeriods[i];
      var endClose = closedPeriods[i + 1];
      if (startClose !== endClose) {
        var values = [ChartUtils.adjustDateForTimeZone("".concat(dateString, " ").concat(startClose, ":00.000000"), calendarTimeZone, formatterTimeZone)];
        var dvalue = MILLIS_PER_HOUR * (ChartUtils.periodToDecimal(endClose) - ChartUtils.periodToDecimal(startClose));
        rangeBreaks.push({
          values,
          dvalue
        });
      }
    }
    return rangeBreaks;
  }
  /**
   * Adjusts a date string from the calendar time zone to the formatter time zone.
   *
   * @param dateString the date string
   * @param calendarTimeZone the time zone for the business calendar
   * @param formatterTimeZone the time zone for the formatter
   */
  static adjustDateForTimeZone(dateString, calendarTimeZone, formatterTimeZone) {
    if (formatterTimeZone && formatterTimeZone.standardOffset !== calendarTimeZone.standardOffset) {
      return ChartUtils.unwrapValue(ChartUtils.wrapValue(dateString, BUSINESS_COLUMN_TYPE, calendarTimeZone), formatterTimeZone);
    }
    return dateString;
  }
  /**
   * Groups an array and returns a map
   * @param array The object to group
   * @param property The property name to group by
   * @returns A map containing the items grouped by their values for the property
   */
  static groupArray(array, property) {
    return array.reduce((result, item) => {
      var _result$get;
      var key = item[property];
      var group = (_result$get = result.get(key)) !== null && _result$get !== void 0 ? _result$get : [];
      group.push(item);
      result.set(key, group);
      return result;
    }, /* @__PURE__ */ new Map());
  }
  /**
   * Unwraps a value provided from API to a value plotly can understand
   * Eg. Unwraps DateWrapper, LongWrapper objects.
   */
  static unwrapValue(value, timeZone) {
    if (value != null) {
      if (isDateWrapper(value)) {
        return shim$1.i18n.DateTimeFormat.format(ChartUtils.DATE_FORMAT, value, timeZone);
      }
      if (isLongWrapper(value)) {
        return value.asNumber();
      }
    }
    return value;
  }
  /**
   *
   * @param value The value to wrap up
   * @param columnType The type of column this value is from
   * @param timeZone The time zone if applicable
   */
  static wrapValue(value, columnType) {
    var timeZone = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
    if (TableUtils.isDateType(columnType) && typeof value === "string") {
      var text = value;
      var format2 = ChartUtils.DATE_FORMAT.substr(0, value.length);
      var date = shim$1.i18n.DateTimeFormat.parse(format2, text);
      if (!timeZone) {
        return date;
      }
      var tzFormat = "".concat(format2, " Z");
      var estimatedOffset = shim$1.i18n.DateTimeFormat.format("Z", date, timeZone);
      var estimatedDate = shim$1.i18n.DateTimeFormat.parse(tzFormat, "".concat(text, " ").concat(estimatedOffset));
      var offset2 = shim$1.i18n.DateTimeFormat.format("Z", estimatedDate, timeZone);
      return shim$1.i18n.DateTimeFormat.parse(tzFormat, "".concat(text, " ").concat(offset2));
    }
    return value;
  }
  static makeLayoutAxis(type) {
    var theme = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : ChartTheme;
    var axis = {
      automargin: true,
      gridcolor: theme.gridcolor,
      linecolor: theme.linecolor,
      rangeslider: {
        visible: false
      },
      showline: true,
      ticklen: 5,
      // act as padding, can't find a tick padding
      tickcolor: theme.paper_bgcolor,
      // hide ticks as padding
      tickfont: {
        color: theme.zerolinecolor
      },
      title: {
        font: {
          color: theme.title_color
        }
      }
    };
    if (type === shim$1.plot.AxisType.X) {
      Object.assign(axis, {
        showgrid: true
      });
    } else if (type === shim$1.plot.AxisType.Y) {
      Object.assign(axis, {
        zerolinecolor: theme.zerolinecolor,
        zerolinewidth: 2
      });
    }
    return axis;
  }
  /**
   * Parses the colorway property of a theme and returns an array of colors
   * Theme could have a single string with space separated colors or an array of strings representing the colorway
   * @param theme The theme to get colorway from
   * @returns Colorway array for the theme
   */
  static getColorwayFromTheme() {
    var theme = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : ChartTheme;
    var colorway2 = [];
    if (theme.colorway) {
      if (Array.isArray(theme.colorway)) {
        colorway2 = theme.colorway;
      } else if (typeof theme.colorway === "string") {
        colorway2 = theme.colorway.split(" ");
      } else {
        log$a.warn("Unable to handle colorway property: ".concat(theme.colorway));
      }
    }
    return colorway2;
  }
  static makeDefaultLayout() {
    var theme = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : ChartTheme;
    var layout = _objectSpread$7(_objectSpread$7({}, theme), {}, {
      autosize: true,
      colorway: ChartUtils.getColorwayFromTheme(theme),
      font: {
        family: "'Fira Sans', sans-serif"
      },
      title: {
        font: {
          color: theme.title_color
        },
        yanchor: "top",
        pad: _objectSpread$7({}, ChartUtils.DEFAULT_TITLE_PADDING),
        y: 1
      },
      legend: {
        font: {
          color: theme.title_color
        }
      },
      margin: _objectSpread$7({}, ChartUtils.DEFAULT_MARGIN),
      xaxis: ChartUtils.makeLayoutAxis(shim$1.plot.AxisType.X, theme),
      yaxis: ChartUtils.makeLayoutAxis(shim$1.plot.AxisType.Y, theme)
    });
    layout.datarevision = 0;
    return layout;
  }
  /**
   * Hydrate settings from a JSONable object
   * @param settings Dehydrated settings
   */
  static hydrateSettings(settings) {
    return _objectSpread$7(_objectSpread$7({}, settings), {}, {
      type: settings.type != null ? shim$1.plot.SeriesPlotStyle[settings.type] : void 0
    });
  }
  static titleFromSettings(settings) {
    var {
      series,
      xAxis,
      title = "".concat((series !== null && series !== void 0 ? series : []).join(", "), " by ").concat(xAxis)
    } = settings;
    return title;
  }
  /**
   * Creates the Figure settings from the Chart Builder settings
   * This should be deprecated at some point, and have Chart Builder create the figure settings directly.
   * This logic will still need to exist to translate existing charts, but could be part of a migration script
   * to translate the data.
   * Change when we decide to add more functionality to the Chart Builder.
   * @param settings The chart builder settings
   * @param settings.title The title for this figure
   * @param settings.xAxis The name of the column to use for the x-axis
   * @param settings.series The name of the columns to use for the series of this figure
   * @param settings.type The plot style for this figure
   */
  static makeFigureSettings(settings, table) {
    var {
      series,
      xAxis: settingsAxis,
      type
    } = settings;
    var title = ChartUtils.titleFromSettings(settings);
    var xAxis = {
      formatType: "".concat(shim$1.plot.AxisFormatType.NUMBER),
      type: "".concat(shim$1.plot.AxisType.X),
      position: "".concat(shim$1.plot.AxisPosition.BOTTOM)
    };
    var yAxis = {
      formatType: "".concat(shim$1.plot.AxisFormatType.NUMBER),
      type: "".concat(shim$1.plot.AxisType.Y),
      position: "".concat(shim$1.plot.AxisPosition.LEFT)
    };
    return {
      charts: [{
        chartType: "".concat(shim$1.plot.ChartType.XY),
        axes: [xAxis, yAxis],
        series: (series !== null && series !== void 0 ? series : []).map((name2) => ({
          plotStyle: "".concat(type),
          name: name2,
          dataSources: [{
            type: "".concat(shim$1.plot.SourceType.X),
            columnName: settingsAxis !== null && settingsAxis !== void 0 ? settingsAxis : "",
            axis: xAxis,
            table
          }, {
            type: "".concat(shim$1.plot.SourceType.Y),
            columnName: name2,
            axis: yAxis,
            table
          }]
        }))
      }],
      title
    };
  }
}
_defineProperty$i(ChartUtils, "DEFAULT_AXIS_SIZE", 0.15);
_defineProperty$i(ChartUtils, "MIN_AXIS_SIZE", 0.025);
_defineProperty$i(ChartUtils, "MAX_AXIS_SIZE", 0.2);
_defineProperty$i(ChartUtils, "AXIS_SIZE_PX", 75);
_defineProperty$i(ChartUtils, "LEGEND_WIDTH_PX", 50);
_defineProperty$i(ChartUtils, "MAX_LEGEND_SIZE", 0.25);
_defineProperty$i(ChartUtils, "ORIENTATION", Object.freeze({
  HORIZONTAL: "h",
  VERTICAL: "v"
}));
_defineProperty$i(ChartUtils, "DATE_FORMAT", "yyyy-MM-dd HH:mm:ss.SSSSSS");
_defineProperty$i(ChartUtils, "DEFAULT_MARGIN", Object.freeze({
  l: 60,
  r: 50,
  t: 30,
  b: 60,
  pad: 0
}));
_defineProperty$i(ChartUtils, "DEFAULT_TITLE_PADDING", Object.freeze({
  t: 8
}));
_defineProperty$i(ChartUtils, "SUBTITLE_LINE_HEIGHT", 25);
_defineProperty$i(ChartUtils, "DEFAULT_MARKER_SIZE", 6);
_defineProperty$i(ChartUtils, "MODE_MARKERS", "markers");
_defineProperty$i(ChartUtils, "MODE_LINES", "lines");
const ChartUtils$1 = ChartUtils;
var {
  dh
} = globalThis;
const shim = dh;
const log$9 = Log$7.module("@deephaven/js-plugin-plotly-express.ChartModel");
function isPlotData(data) {
  return (
    // BoxPlot extends PlotData
    // The rest do not extend PlotData
    !isViolinPlotData(data) && !isOhlcPlotData(data) && !isCandlestickPlotData(data) && !isPiePlotData(data)
  );
}
function isViolinPlotData(data) {
  return data.type === "violin";
}
function isOhlcPlotData(data) {
  return data.type === "ohlc";
}
function isCandlestickPlotData(data) {
  return data.type === "candlestick";
}
function isPiePlotData(data) {
  return data.type === "pie";
}
class PlotlyExpressChartModel extends ChartModel$1 {
  constructor(tableColumnReplacementMap, data, plotlyLayout, isDefaultTemplate = true, theme = ChartTheme) {
    var _a, _b;
    super();
    __publicField(this, "tableSubscriptionMap");
    __publicField(this, "tableSubscriptionCleanups", []);
    __publicField(this, "tableColumnReplacementMap");
    __publicField(this, "chartDataMap");
    __publicField(this, "theme");
    __publicField(this, "data");
    __publicField(this, "layout");
    __publicField(this, "plotlyLayout");
    this.handleFigureUpdated = this.handleFigureUpdated.bind(this);
    this.tableColumnReplacementMap = new Map(tableColumnReplacementMap);
    this.chartDataMap = /* @__PURE__ */ new Map();
    this.tableSubscriptionMap = /* @__PURE__ */ new Map();
    this.theme = theme;
    this.data = data;
    const template = { layout: ChartUtils$1.makeDefaultLayout(theme) };
    if (!isDefaultTemplate) {
      template.layout.colorway = ((_b = (_a = plotlyLayout.template) == null ? void 0 : _a.layout) == null ? void 0 : _b.colorway) ?? template.layout.colorway;
    }
    this.plotlyLayout = plotlyLayout;
    this.layout = {
      ...plotlyLayout,
      template
    };
    this.applyColorwayToData();
    this.setTitle(this.getDefaultTitle());
  }
  /* @ts-ignore */
  getData() {
    return this.data;
  }
  getLayout() {
    return this.layout;
  }
  /**
   * Applies the model template colorway to the data unless the data color is not its default value
   * Data color is not default if the user set the color specifically or the plot type sets it
   */
  applyColorwayToData() {
    var _a, _b, _c, _d, _e, _f;
    const colorway2 = ((_c = (_b = (_a = this.layout) == null ? void 0 : _a.template) == null ? void 0 : _b.layout) == null ? void 0 : _c.colorway) ?? [];
    const plotlyColorway = ((_f = (_e = (_d = this.plotlyLayout) == null ? void 0 : _d.template) == null ? void 0 : _e.layout) == null ? void 0 : _f.colorway) ?? [];
    if (colorway2.length === 0) {
      return;
    }
    for (let i = 0; i < this.data.length; i += 1) {
      const d2 = this.data[i];
      const color = colorway2[i % colorway2.length];
      const plotlyColor = plotlyColorway[i % plotlyColorway.length] ?? "";
      if (isPlotData(d2)) {
        const { marker, line } = d2;
        if ((marker == null ? void 0 : marker.color) === plotlyColor && color != null) {
          marker.color = color;
        }
        if ((line == null ? void 0 : line.color) === plotlyColor && color != null) {
          line.color = color;
        }
      }
    }
  }
  subscribe(callback) {
    super.subscribe(callback);
    this.tableColumnReplacementMap.forEach(
      (_, table) => this.chartDataMap.set(table, new shim.plot.ChartData(table))
    );
    this.tableColumnReplacementMap.forEach((columnReplacements, table) => {
      const columnNames = new Set(columnReplacements.keys());
      const columns = table.columns.filter(({ name: name2 }) => columnNames.has(name2));
      this.tableSubscriptionMap.set(table, table.subscribe(columns));
    });
    this.startListening();
  }
  unsubscribe(callback) {
    super.unsubscribe(callback);
    this.stopListening();
    this.tableSubscriptionMap.forEach((sub) => sub.close());
    this.chartDataMap.clear();
  }
  handleFigureUpdated(event, chartData, columnReplacements) {
    if (chartData == null || columnReplacements == null) {
      log$9.warn(
        "Unknown chartData or columnReplacements for this event. Skipping update"
      );
      return;
    }
    const { detail: figureUpdateEvent } = event;
    chartData.update(figureUpdateEvent);
    columnReplacements.forEach((destinations, column) => {
      const columnData = chartData.getColumn(
        column,
        (val) => ChartUtils$1.unwrapValue(val),
        figureUpdateEvent
      );
      destinations.forEach((destination) => {
        const parts = destination.split("/").filter((part) => part !== "" && part !== "plotly");
        let selector = this;
        for (let i = 0; i < parts.length; i += 1) {
          if (i !== parts.length - 1) {
            selector = selector[parts[i]];
          } else {
            selector[parts[i]] = columnData;
          }
        }
      });
    });
    const { data } = this;
    this.fireUpdate(data);
  }
  startListening() {
    this.tableSubscriptionMap.forEach((sub, table) => {
      this.tableSubscriptionCleanups.push(
        sub.addEventListener(
          shim.Table.EVENT_UPDATED,
          (e) => this.handleFigureUpdated(
            e,
            this.chartDataMap.get(table),
            this.tableColumnReplacementMap.get(table)
          )
        )
      );
    });
  }
  stopListening() {
    this.tableSubscriptionCleanups.forEach((cleanup) => cleanup());
  }
  getPlotWidth() {
    var _a, _b;
    if (!this.rect || !this.rect.width) {
      return 0;
    }
    return Math.max(
      this.rect.width - (((_a = this.layout.margin) == null ? void 0 : _a.l) ?? 0) - (((_b = this.layout.margin) == null ? void 0 : _b.r) ?? 0),
      0
    );
  }
  getPlotHeight() {
    var _a, _b;
    if (!this.rect || !this.rect.height) {
      return 0;
    }
    return Math.max(
      this.rect.height - (((_a = this.layout.margin) == null ? void 0 : _a.t) ?? 0) - (((_b = this.layout.margin) == null ? void 0 : _b.b) ?? 0),
      0
    );
  }
}
function isStack(item) {
  return item.isStack;
}
function isComponent(item) {
  return item.isComponent;
}
function isRoot(item) {
  return item.isRoot;
}
const GoldenLayout$1 = "";
var ERROR = 0;
var WARN = 1;
var INFO = 2;
var DEBUG = 3;
var DEBUG2 = 4;
function _defineProperty$h(obj, key, value) {
  key = _toPropertyKey$h(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$h(arg) {
  var key = _toPrimitive$h(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$h(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var silent = () => void 0;
class Logger4 {
  constructor(name2, level) {
    _defineProperty$h(this, "name", void 0);
    _defineProperty$h(this, "prefix", void 0);
    _defineProperty$h(this, "level", void 0);
    _defineProperty$h(this, "error", void 0);
    _defineProperty$h(this, "warn", void 0);
    _defineProperty$h(this, "log", void 0);
    _defineProperty$h(this, "info", void 0);
    _defineProperty$h(this, "debug", void 0);
    _defineProperty$h(this, "debug2", void 0);
    this.name = name2;
    this.prefix = name2 != null ? "[".concat(name2, "]") : "";
    this.error = silent;
    this.warn = silent;
    this.log = silent;
    this.info = silent;
    this.debug = silent;
    this.debug2 = silent;
    this.level = level;
    this.setLogLevel(level);
  }
  setLogLevel(level) {
    if (!Number.isFinite(level)) {
      console.warn("Expected a number for log level. Received: ".concat(level, ". Ignoring"));
      return;
    }
    this.level = level;
    this.error = level >= ERROR ? console.error.bind(console, this.prefix) : silent;
    this.warn = level >= WARN ? console.warn.bind(console, this.prefix) : silent;
    this.log = level >= INFO ? console.log.bind(console, this.prefix) : silent;
    this.info = this.log;
    this.debug = level >= DEBUG ? console.debug.bind(console, this.prefix) : silent;
    this.debug2 = level >= DEBUG2 ? console.debug.bind(console, this.prefix) : silent;
  }
}
const Logger$1 = Logger4;
function _defineProperty$g(obj, key, value) {
  key = _toPropertyKey$g(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$g(arg) {
  var key = _toPrimitive$g(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$g(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class DefaultLogger4 extends Logger$1 {
  constructor() {
    var level = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : INFO;
    super(null, level);
    _defineProperty$g(this, "modules", void 0);
    this.modules = {};
  }
  module(name2) {
    if (this.modules[name2] == null) {
      this.modules[name2] = new Logger$1(name2, this.level);
    }
    return this.modules[name2];
  }
  setLogLevel(level) {
    super.setLogLevel(level);
    if (this.modules == null) {
      return;
    }
    var keys3 = Object.keys(this.modules);
    for (var i = 0; i < keys3.length; i += 1) {
      this.modules[keys3[i]].setLogLevel(level);
    }
  }
}
const DefaultLogger$1 = DefaultLogger4;
var Log = new DefaultLogger$1();
const Log$1 = Log;
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info2 = gen[key](arg);
    var value = info2.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info2.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function() {
    var self2 = this, args = arguments;
    return new Promise(function(resolve, reject) {
      var gen = fn.apply(self2, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(void 0);
    });
  };
}
function copyToClipboard(_x) {
  return _copyToClipboard.apply(this, arguments);
}
function _copyToClipboard() {
  _copyToClipboard = _asyncToGenerator(function* (text) {
    var {
      clipboard
    } = navigator;
    if (clipboard !== void 0) {
      try {
        return navigator.clipboard.writeText(text);
      } catch (_unused) {
        return copyToClipboardExecCommand(text);
      }
    }
    copyToClipboardExecCommand(text);
  });
  return _copyToClipboard.apply(this, arguments);
}
function copyToClipboardExecCommand(text) {
  var oldFocus = document.activeElement;
  var textArea = document.createElement("textarea");
  textArea.value = text;
  document.body.appendChild(textArea);
  textArea.focus();
  textArea.select();
  var result = document.execCommand("copy");
  document.body.removeChild(textArea);
  if (oldFocus instanceof HTMLElement) {
    oldFocus.focus();
  }
  if (!result)
    throw new Error("Unable to execute copy command");
}
function assertNotNull(value) {
  if (value == null)
    throw new Error("Value is null or undefined");
}
const lm_root = "_lm_root_1qf9a_3";
const lm_row = "_lm_row_1qf9a_7";
const lm_item = "_lm_item_1qf9a_7";
const lm_content = "_lm_content_1qf9a_11";
const lm_dragging = "_lm_dragging_1qf9a_17";
const lm_maximised = "_lm_maximised_1qf9a_23";
const lm_maximise_placeholder = "_lm_maximise_placeholder_1qf9a_30";
const lm_splitter = "_lm_splitter_1qf9a_34";
const lm_vertical = "_lm_vertical_1qf9a_41";
const lm_drag_handle = "_lm_drag_handle_1qf9a_41";
const lm_horizontal = "_lm_horizontal_1qf9a_46";
const lm_header = "_lm_header_1qf9a_56";
const lm_dropdown_open = "_lm_dropdown_open_1qf9a_63";
const lm_controls = "_lm_controls_1qf9a_69";
const lm_tabs = "_lm_tabs_1qf9a_89";
const lm_tab = "_lm_tab_1qf9a_89";
const lm_title = "_lm_title_1qf9a_104";
const lm_close_tab = "_lm_close_tab_1qf9a_111";
const lm_stack = "_lm_stack_1qf9a_120";
const lm_left = "_lm_left_1qf9a_120";
const lm_right = "_lm_right_1qf9a_121";
const lm_dragProxy = "_lm_dragProxy_1qf9a_125";
const lm_items = "_lm_items_1qf9a_148";
const lm_tabdropdown_list = "_lm_tabdropdown_list_1qf9a_165";
const lm_bottom = "_lm_bottom_1qf9a_192";
const lm_drop_tab_placeholder = "_lm_drop_tab_placeholder_1qf9a_207";
const lm_tabdropdown = "_lm_tabdropdown_1qf9a_165";
const lm_dropTargetIndicator = "_lm_dropTargetIndicator_1qf9a_258";
const lm_inner = "_lm_inner_1qf9a_264";
const lm_transition_indicator = "_lm_transition_indicator_1qf9a_272";
const lm_popin = "_lm_popin_1qf9a_282";
const lm_bg = "_lm_bg_1qf9a_297";
const lm_icon = "_lm_icon_1qf9a_300";
const lm_goldenlayout = "_lm_goldenlayout_1qf9a_304";
const lm_selectable = "_lm_selectable_1qf9a_340";
const lm_active = "_lm_active_1qf9a_370";
const lm_selected = "_lm_selected_1qf9a_388";
const lm_keyboard_active = "_lm_keyboard_active_1qf9a_397";
const lm_popout = "_lm_popout_1qf9a_416";
const lm_maximise = "_lm_maximise_1qf9a_23";
const lm_close = "_lm_close_1qf9a_111";
const lm_tabnextbutton = "_lm_tabnextbutton_1qf9a_425";
const lm_tabpreviousbutton = "_lm_tabpreviousbutton_1qf9a_428";
const lm_title_before = "_lm_title_before_1qf9a_544";
const lm_focusin = "_lm_focusin_1qf9a_568";
const lm_window_blur = "_lm_window_blur_1qf9a_573";
const lm_tabdropdown_search = "_lm_tabdropdown_search_1qf9a_631";
const march = "_march_1qf9a_1";
const app = "_app_1qf9a_712";
const plotly = "_plotly_1qf9a_721";
const GoldenLayout = {
  "tab-height": "28px",
  "drag-border-width": "5px",
  lm_root,
  lm_row,
  lm_item,
  lm_content,
  lm_dragging,
  lm_maximised,
  lm_maximise_placeholder,
  lm_splitter,
  lm_vertical,
  lm_drag_handle,
  lm_horizontal,
  lm_header,
  lm_dropdown_open,
  lm_controls,
  lm_tabs,
  lm_tab,
  lm_title,
  lm_close_tab,
  lm_stack,
  lm_left,
  lm_right,
  lm_dragProxy,
  lm_items,
  lm_tabdropdown_list,
  lm_bottom,
  lm_drop_tab_placeholder,
  lm_tabdropdown,
  lm_dropTargetIndicator,
  lm_inner,
  lm_transition_indicator,
  lm_popin,
  lm_bg,
  lm_icon,
  lm_goldenlayout,
  lm_selectable,
  lm_active,
  lm_selected,
  lm_keyboard_active,
  lm_popout,
  lm_maximise,
  lm_close,
  lm_tabnextbutton,
  lm_tabpreviousbutton,
  lm_title_before,
  "editor-unsaved-indicator": "_editor-unsaved-indicator_1qf9a_548",
  "is-unsaved": "_is-unsaved_1qf9a_556",
  lm_focusin,
  lm_window_blur,
  lm_tabdropdown_search,
  march,
  app,
  "js-plotly-plot": "_js-plotly-plot_1qf9a_721",
  plotly
};
const GoldenLayoutThemeExport = Object.freeze({
  tabHeight: parseInt(GoldenLayout["tab-height"], 10),
  dragBorderWidth: parseInt(GoldenLayout["drag-border-width"], 10)
});
function ownKeys$6(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread$6(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$6(Object(source), true).forEach(function(key) {
      _defineProperty$f(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$6(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$f(obj, key, value) {
  key = _toPropertyKey$f(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$f(arg) {
  var key = _toPrimitive$f(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$f(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var log$8 = Log$1.module("LayoutUtils");
function isComponentConfig(config2) {
  return config2.componentName !== void 0;
}
function isReactComponentConfig(config2) {
  var reactConfig = config2;
  return (isComponentConfig(config2) && config2.componentName === "lm-react-component" || config2.type === "react-component") && reactConfig.component !== void 0;
}
function isHTMLElement(element) {
  return element.focus !== void 0;
}
function isStackItemConfig(config2) {
  return config2.type === "stack";
}
class LayoutUtils2 {
  static activateTab(root2, config2) {
    var stack = LayoutUtils2.getStackForRoot(root2, config2, false);
    if (!stack) {
      log$8.error("Could not find stack for config", config2);
      return;
    }
    var contentItem = LayoutUtils2.getContentItemInStack(stack, config2);
    if (contentItem) {
      stack.setActiveContentItem(contentItem);
    }
  }
  /**
   * Is the tab with the given config active
   * @param root A GoldenLayout content item with the tab
   * @param config Tab config to match
   * @returns True if the tab is active
   */
  static isActiveTab(root2, config2) {
    var stack = LayoutUtils2.getStackForRoot(root2, config2, false);
    if (!stack) {
      log$8.error("Could not find stack for config", config2);
      return false;
    }
    var contentItem = LayoutUtils2.getContentItemInStack(stack, config2);
    var activeItem = stack.getActiveContentItem();
    return activeItem === contentItem;
  }
  /**
   * Adds a stack to the root layout specified. Adds to the first row/column with only one item
   * @param parent A GoldenLayout content item to add the stack to
   * @returns The newly created stack.
   */
  static addStack(parent) {
    var columnPreferred = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
    var type = columnPreferred ? "column" : "row";
    if (isRoot(parent)) {
      if (parent.contentItems == null || parent.contentItems.length === 0) {
        parent.addChild({
          type
        });
      }
      var child = parent.contentItems[0];
      var _isCorrectType = columnPreferred ? child.isColumn : child.isRow;
      if (!_isCorrectType) {
        parent.removeChild(child, true);
        parent.addChild({
          type
        });
        var maintainFocusElement = document.activeElement;
        parent.contentItems[0].addChild(child);
        if (maintainFocusElement && maintainFocusElement.focus != null) {
          maintainFocusElement.focus();
        }
      }
      return this.addStack(parent.contentItems[0], columnPreferred);
    }
    if (parent.contentItems.length < 2) {
      parent.addChild({
        type: "stack"
      });
      return parent.contentItems[parent.contentItems.length - 1];
    }
    var newParent = parent.contentItems[parent.contentItems.length - 1];
    var isCorrectType = !columnPreferred ? newParent.isColumn : newParent.isRow;
    if (!isCorrectType) {
      parent.addChild({
        type: !columnPreferred ? "column" : "row"
      });
      parent.removeChild(newParent, true);
      parent.contentItems[parent.contentItems.length - 1].addChild(newParent);
      newParent = parent.contentItems[parent.contentItems.length - 1];
    }
    return this.addStack(newParent, !columnPreferred);
  }
  /**
   * Gets the first stack which contains a contentItem with the given config values
   * @param item Golden layout content item to search for the stack
   * @param config The item properties to match
   */
  static getStackForConfig(item) {
    var config2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    var allowEmptyStack = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
    if (allowEmptyStack && isStack(item) && item.contentItems.length === 0) {
      return item;
    }
    if (item.contentItems == null) {
      return null;
    }
    for (var i = 0; i < item.contentItems.length; i += 1) {
      var contentItem = item.contentItems[i];
      if (contentItem.isComponent && contentItem.config != null) {
        if (lodash_ismatchExports(contentItem.config, config2)) {
          return item;
        }
      }
      var stack = this.getStackForConfig(contentItem, config2, allowEmptyStack);
      if (stack) {
        return stack;
      }
    }
    return null;
  }
  /**
   * Gets a stack matching the specified config
   * @param root The root GoldenLayout element
   * @param config The item config type to match, eg. { component: 'IrisGridPanel', title: 'Table Name' }
   * @param createIfNecessary Whether to create the stack if it does not exist.
   * @param matchComponentType If the config doesn't match exactly, just find another one of the same component type
   * @param allowEmptyStack If no configs match, search for an empty stack that can be used
   */
  static getStackForRoot(root2, config2) {
    var createIfNecessary = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true;
    var matchComponentType = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
    var allowEmptyStack = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : true;
    var stack = this.getStackForConfig(root2, config2);
    if (!stack && matchComponentType) {
      stack = this.getStackForConfig(root2, {
        component: config2.component
      }, allowEmptyStack);
    }
    if (!stack && createIfNecessary) {
      stack = this.addStack(root2);
    }
    return stack;
  }
  /**
   * Gets a stack matching one of the specified types, creates new stack if necessary
   * @param root The GoldenLayout root to find or create the stack in
   * @param types The array of component types to match
   * @param createIfNecessary Whether to create the stack if it does not exist
   * @param matchComponentType If the config doesn't match exactly, just find another one of the same component type
   * @param allowEmptyStack If no configs match, search for an empty stack that can be used
   */
  static getStackForComponentTypes(root2, types) {
    var createIfNecessary = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true;
    var matchComponentType = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
    var allowEmptyStack = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : true;
    for (var i = 0; i < types.length; i += 1) {
      var component = types[i];
      var isLastType = i === types.length - 1;
      var stack = LayoutUtils2.getStackForRoot(root2, {
        component
      }, createIfNecessary && isLastType, matchComponentType, allowEmptyStack);
      if (stack) {
        return stack;
      }
    }
    return null;
  }
  /**
   * Gets first content item with the specified config in stack.
   * @param stack The stack to search for the item
   * @param config The item config type to match, eg. { component: 'IrisGridPanel', title: 'Table Name' }
   * @returns Returns the found content item, null if not found.
   */
  static getContentItemInStack(stack, config2) {
    if (!stack) {
      return null;
    }
    for (var i = 0; i < stack.contentItems.length; i += 1) {
      var contentItem = stack.contentItems[i];
      if (contentItem.isComponent && contentItem.config != null) {
        if (lodash_ismatchExports(contentItem.config, config2)) {
          return contentItem;
        }
      }
    }
    return null;
  }
  /**
   * Removes dynamic props from components in the given config so this config could be serialized
   * @param config Config objec
   * @returns Dehydrated config
   */
  static dehydrateLayoutConfig(config2, dehydrateComponent) {
    if (config2 == null || !config2.length) {
      return [];
    }
    var dehydratedConfig = [];
    for (var i = 0; i < config2.length; i += 1) {
      var itemConfig = config2[i];
      var {
        component,
        content
      } = itemConfig;
      if (component) {
        var dehydratedComponent = dehydrateComponent(component, itemConfig);
        if (dehydratedComponent != null) {
          dehydratedConfig.push(dehydratedComponent);
        } else {
          log$8.debug2('dehydrateLayoutConfig: skipping unmapped component "'.concat(component, '"'));
        }
      } else if (content) {
        var layoutItemConfig = _objectSpread$6(_objectSpread$6({}, itemConfig), {}, {
          content: LayoutUtils2.dehydrateLayoutConfig(content, dehydrateComponent)
        });
        dehydratedConfig.push(layoutItemConfig);
      } else {
        dehydratedConfig.push(itemConfig);
      }
    }
    return dehydratedConfig;
  }
  static getTabPoint(glContainer) {
    var {
      tab
    } = glContainer;
    if (tab == null) {
      throw new Error("Cannot get tab for panel container ".concat(glContainer));
    }
    var tabRect = tab.element[0].getBoundingClientRect();
    return [tabRect.left + tabRect.width * 0.5, tabRect.bottom - 8];
  }
  /**
   * Drop minor changes in Layout Configuration for deep comparison
   * @param config Layout Configuration
   *
   * minor changes:
   * 1. sorts in grid
   * 2. quick filters in grid
   * 3. active item
   *
   * item id is also removed
   */
  static dropLayoutMinorChange(config2) {
    for (var i = 0; i < config2.length; i += 1) {
      var itemConfig = config2[i];
      var {
        content
      } = itemConfig;
      if (content !== void 0) {
        if (isStackItemConfig(itemConfig)) {
          delete itemConfig.activeItemIndex;
        }
        LayoutUtils2.dropLayoutMinorChange(content);
      } else if (isReactComponentConfig(itemConfig) && itemConfig.component === "IrisGridPanel") {
        if (itemConfig.props.panelState != null) {
          delete itemConfig.id;
          itemConfig.props.panelState.irisGridState.sorts = [];
          itemConfig.props.panelState.irisGridState.quickFilters = [];
        }
      }
    }
  }
  /**
   * Compare two layouts to see if they are equivalent
   * @param layout1 A Golden Layout config object
   * @param layout2 Another Golden layout config object
   * @param major When true, will ignore "minor" property differences (eg. sorts)
   */
  static isEqual(layout1, layout2) {
    var major = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
    if (major) {
      var layout1Clone = LayoutUtils2.cloneLayout(layout1);
      var layout2Clone = LayoutUtils2.cloneLayout(layout2);
      LayoutUtils2.dropLayoutMinorChange(layout1Clone);
      LayoutUtils2.dropLayoutMinorChange(layout2Clone);
      return deepEqual(layout1Clone, layout2Clone);
    }
    return deepEqual(layout1, layout2);
  }
  static cloneLayout(layout) {
    return JSON.parse(JSON.stringify(layout));
  }
  /**
   * Adds dynamic props to components in the given config so this config could be used to initialize a layout
   * @param config Dehydrated config object
   * @param hydrateComponent Function to hydrate the component
   * @returns Hydrated config
   */
  static hydrateLayoutConfig(config2, hydrateComponent) {
    if (config2 == null || !config2.length) {
      return [];
    }
    var hydratedConfig = [];
    for (var i = 0; i < config2.length; i += 1) {
      var itemConfig = config2[i];
      if (isReactComponentConfig(itemConfig)) {
        var _itemConfig$id;
        var {
          component,
          props = {}
        } = itemConfig;
        hydratedConfig.push(_objectSpread$6(_objectSpread$6({}, itemConfig), {}, {
          id: (_itemConfig$id = itemConfig === null || itemConfig === void 0 ? void 0 : itemConfig.id) !== null && _itemConfig$id !== void 0 ? _itemConfig$id : shortid(),
          props: hydrateComponent(component, props)
        }));
      } else if (itemConfig.content !== void 0) {
        var contentConfig = LayoutUtils2.hydrateLayoutConfig(itemConfig.content, hydrateComponent);
        if (isStackItemConfig(itemConfig) && itemConfig.activeItemIndex != null && itemConfig.activeItemIndex >= contentConfig.length) {
          log$8.warn("Fixing bad activeItemIndex!", itemConfig.activeItemIndex, itemConfig);
          itemConfig.activeItemIndex = 0;
        }
        hydratedConfig.push(_objectSpread$6(_objectSpread$6({}, itemConfig), {}, {
          content: contentConfig
        }));
      } else {
        hydratedConfig.push(itemConfig);
      }
    }
    return hydratedConfig;
  }
  /**
   * Opens a component. It will try and open the component in an existing stack of the same component.
   * If `replaceExisting` is true and there is a component found with the same `config.id`, it will replace that component with this one.
   * If `allowStack` is true and there is a component of the same type found, it will open in that stack (potentially covering up a panel).
   * @param root The GoldenLayout root to open the component in
   * @param config The component config definition to open
   * @param replaceExisting Whether it should replace the existing one matching component type and id, or open a new one
   * @param replaceConfig The component config to replace
   * @param createNewStack True to force opening in a new stack, false to try and open in a stack with the same type of component.
   * @param focusElement The element to focus on
   * @param dragEvent Whether component is being created with a drag, mouse event is initial position for drag proxy
   */
  static openComponent() {
    var {
      root: root2,
      config: configParam,
      replaceExisting = true,
      replaceConfig = void 0,
      createNewStack = false,
      focusElement = void 0,
      dragEvent = void 0
    } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    var maintainFocusElement = document.activeElement;
    var config2 = _objectSpread$6({}, configParam);
    if (config2.id == null) {
      config2.id = shortid.generate();
    }
    if (dragEvent) {
      root2 === null || root2 === void 0 ? void 0 : root2.layoutManager.createDragSourceFromEvent(config2, dragEvent);
      return;
    }
    var searchConfig = replaceConfig || {
      id: config2.id,
      component: config2.component
    };
    assertNotNull(root2);
    var stack = createNewStack ? LayoutUtils2.addStack(root2) : LayoutUtils2.getStackForRoot(root2, searchConfig);
    assertNotNull(stack);
    var oldContentItem = LayoutUtils2.getContentItemInStack(stack, searchConfig);
    if (focusElement != null) {
      var onComponentCreated = (event) => {
        log$8.debug("Component created, focusing element", focusElement);
        stack.off("componentCreated", onComponentCreated);
        var {
          element
        } = event.origin;
        requestAnimationFrame(() => {
          LayoutUtils2.focusElement(element[0], focusElement);
        });
      };
      stack.on("componentCreated", onComponentCreated);
    }
    if (replaceExisting && oldContentItem) {
      var index = stack.contentItems.indexOf(oldContentItem);
      stack.addChild(config2, index + 1);
      stack.removeChild(oldContentItem);
      stack.setActiveContentItem(stack.contentItems[index]);
    } else {
      stack.addChild(config2);
    }
    if (focusElement == null && maintainFocusElement && isHTMLElement(maintainFocusElement)) {
      maintainFocusElement.focus();
    }
  }
  /**
   * Opens a component in an given stack.
   * If `replaceExisting` is true and there is a component found with the same `config.id`, it will replace that component with this one
   * @param stack The GoldenLayout stack to open the component in
   * @param config The component config definition to open
   * @param replaceExisting Whether it should replace the existing one matching component type and id, or open a new one
   */
  static openComponentInStack(stack, config2) {
    var replaceExisting = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true;
    var maintainFocusElement = document.activeElement;
    var searchConfig = {
      id: config2.id
    };
    var oldContentItem = LayoutUtils2.getContentItemInStack(stack, searchConfig);
    if (replaceExisting && oldContentItem && stack) {
      var index = stack === null || stack === void 0 ? void 0 : stack.contentItems.indexOf(oldContentItem);
      stack.addChild(config2, index + 1);
      stack.removeChild(oldContentItem);
      stack.setActiveContentItem(stack.contentItems[index]);
    } else {
      stack === null || stack === void 0 ? void 0 : stack.addChild(config2);
    }
    if (maintainFocusElement && isHTMLElement(maintainFocusElement)) {
      maintainFocusElement.focus();
    }
  }
  /**
   * Close the specified component and remove it from the stack it's currently in
   * @param root The GoldenLayout root to search and close the component in
   * @param config The GoldenLayout component config definition to close, eg. { component: 'IrisGridPanel', id: 'table-t' }
   */
  static closeComponent(root2, config2, closeOptions) {
    var stack = LayoutUtils2.getStackForRoot(root2, config2, false, false, false);
    if (!stack) {
      log$8.warn("Cannot find stack for component, ignoring close", config2);
      return;
    }
    var oldContentItem = LayoutUtils2.getContentItemInStack(stack, config2);
    var maintainFocusElement = document.activeElement;
    if (oldContentItem) {
      if (isComponent(oldContentItem)) {
        oldContentItem.container.close(closeOptions);
      } else {
        stack.removeChild(oldContentItem);
      }
    }
    if (maintainFocusElement && document.contains(maintainFocusElement) && isHTMLElement(maintainFocusElement)) {
      maintainFocusElement.focus();
    }
  }
  static renameComponent(root2, config2, newTitle) {
    var stack = LayoutUtils2.getStackForRoot(root2, config2, false);
    if (!stack) {
      log$8.error("Could not find stack for config", config2);
      return;
    }
    var contentItem = LayoutUtils2.getContentItemInStack(stack, config2);
    if (contentItem) {
      contentItem.setTitle(newTitle);
    }
  }
  /**
   * Create a component clone based on the given config
   * @param root The GoldenLayout root to clone the component in
   * @param config The config to clone
   * @returns Clone config
   */
  static cloneComponent(root2, config2) {
    var stack = LayoutUtils2.getStackForRoot(root2, config2, false);
    if (!stack) {
      log$8.error("Could not find stack for config", config2);
      return null;
    }
    var {
      props = {}
    } = config2;
    var panelState = LayoutUtils2.getPanelComponentState(config2);
    var cloneConfig = {
      type: "react-component",
      component: config2.component,
      props: _objectSpread$6(_objectSpread$6({}, props), {}, {
        panelState
      }),
      title: "".concat(config2.title, " Copy"),
      id: shortid.generate()
    };
    LayoutUtils2.openComponentInStack(stack, cloneConfig);
    return cloneConfig;
  }
  /**
   * Get panel component state for the given config
   * @param config Panel config
   * @returns Panel state
   */
  static getPanelComponentState(config2) {
    if (isComponentConfig(config2)) {
      var _config$componentStat;
      return (_config$componentStat = config2.componentState) === null || _config$componentStat === void 0 ? void 0 : _config$componentStat.panelState;
    }
    if (isReactComponentConfig(config2)) {
      var _config$props;
      return (_config$props = config2.props) === null || _config$props === void 0 ? void 0 : _config$props.panelState;
    }
    return null;
  }
  static makeDefaultLayout() {
    return {
      dimensions: {
        headerHeight: GoldenLayoutThemeExport.tabHeight,
        borderWidth: GoldenLayoutThemeExport.dragBorderWidth,
        borderGrabWidth: 10
      },
      settings: {
        showPopoutIcon: false,
        showCloseIcon: false,
        constrainDragToContainer: false
      }
    };
  }
  /**
   * Gets a containers root node
   * @param container The Golden Layout container to get the root for
   */
  static getRootFromContainer(container) {
    return container.layoutManager.root;
  }
  /**
   * Gets the config for the panel component given a glContainer
   * @param container The Golden Layout container to get the config for
   */
  static getComponentConfigFromContainer(container) {
    if (container) {
      if (container.tab != null && container.tab.contentItem != null) {
        return container.tab.contentItem.config;
      }
      return container._config;
    }
    return null;
  }
  static getTitleFromContainer(container) {
    if (container != null && container.tab != null && container.tab.contentItem != null) {
      return container.tab.contentItem.config.title;
    }
    return null;
  }
  static getTitleFromTab(tab) {
    if (tab != null && tab.contentItem != null) {
      return tab.contentItem.config.title;
    }
    return null;
  }
  /**
   * Retrieve the panel ID for the provided golden layout container
   * @param glContainer The container to get the panel ID for
   * @returns Panel ID
   */
  static getIdFromContainer(glContainer) {
    var config2 = LayoutUtils2.getComponentConfigFromContainer(glContainer);
    if (config2) {
      return config2.id;
    }
    return null;
  }
  /**
   * Retrieve the ID of the panel provided
   * @param panel The panel to get the ID for
   * @returns Panel ID
   */
  static getIdFromPanel(panel) {
    var {
      glContainer
    } = panel.props;
    return LayoutUtils2.getIdFromContainer(glContainer);
  }
  /**
   * Get component name from the panel instance
   * @param panel Panel to get component name for
   * @returns Component name or null if unable to retrieve name
   */
  static getComponentNameFromPanel(panel) {
    var {
      glContainer
    } = panel.props;
    var config2 = LayoutUtils2.getComponentConfigFromContainer(glContainer);
    if (config2 && isReactComponentConfig(config2)) {
      var _config$component;
      return (_config$component = config2.component) !== null && _config$component !== void 0 ? _config$component : null;
    }
    return null;
  }
  /**
   * Get component name for wrapped and un-wrapped components
   * @param component Component to get name for
   * @returns Component name
   * @throws If displayName for the component is not defined
   */
  static getComponentName(component) {
    var _component$WrappedCom, _component$WrappedCom2;
    var name2 = (_component$WrappedCom = (_component$WrappedCom2 = component.WrappedComponent) === null || _component$WrappedCom2 === void 0 ? void 0 : _component$WrappedCom2.displayName) !== null && _component$WrappedCom !== void 0 ? _component$WrappedCom : component.displayName;
    if (name2 == null) {
      throw new Error("Component displayName not defined ".concat(component));
    }
    return name2;
  }
  /**
   * Put focus on the first "input" element (input, button, select, textarea) within an element
   * If element is null or input element not found, does nothing
   * @param element The element to put focus in.
   * @param selector The first element matching this selector will be focused.
   * @returns The element that was focused, null if not focused
   */
  static focusElement(element) {
    var selector = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : LayoutUtils2.DEFAULT_FOCUS_SELECTOR;
    if (element == null) {
      return null;
    }
    var focusElement = element.querySelector(selector);
    if (focusElement == null) {
      return null;
    }
    if (isHTMLElement(focusElement)) {
      focusElement.focus();
    }
    return focusElement;
  }
  /**
   * Get a promise that initializes when layout is initialized
   * @param layout The layout to await initialization on
   * @returns Promise that resolves when layout is initialized
   */
  static onInitialized(layout) {
    return new Promise((resolve) => {
      if (layout.isInitialised) {
        resolve();
        return;
      }
      var onInit = () => {
        layout.off("initialised", onInit);
        resolve();
      };
      layout.on("initialised", onInit);
    });
  }
}
_defineProperty$f(LayoutUtils2, "DEFAULT_FOCUS_SELECTOR", "input, select, textarea, button");
const PanelPlaceholder$1 = "";
var PanelPlaceholder = /* @__PURE__ */ React.forwardRef((props, ref) => {
  var component = LayoutUtils2.getComponentNameFromPanel({
    props
  });
  return /* @__PURE__ */ React.createElement("div", {
    ref,
    className: "panel-placeholder"
  }, 'Component "', component, '" is not registered.');
});
PanelPlaceholder.displayName = "PanelPlaceholder";
var TIMEOUT_DELAY = 3500;
var log$7 = Log$1.module("useCopyToClipboard");
function useCopyToClipboard() {
  var [copied, setCopied] = React.useState(false);
  var copiedTimeout = React.useRef(null);
  var copy = React.useCallback((value) => {
    copyToClipboard(value).then(() => {
      setCopied(true);
    }).catch((e) => log$7.error("Unable to copy ".concat(value), "\n", e));
  }, []);
  React.useEffect(() => {
    if (copiedTimeout.current)
      clearTimeout(copiedTimeout.current);
    if (copied) {
      copiedTimeout.current = setTimeout(() => {
        setCopied(false);
      }, TIMEOUT_DELAY);
    }
    return () => {
      if (copiedTimeout.current)
        clearTimeout(copiedTimeout.current);
    };
  }, [copied]);
  return [copied, copy];
}
const PanelEvent = Object.freeze({
  // Panel has received focus
  FOCUS: "PanelEvent.FOCUS",
  // Panel has been mounted
  MOUNT: "PanelEvent.MOUNT",
  // Panel has been unmounted
  UNMOUNT: "PanelEvent.UNMOUNT",
  // The title of the panel has changed
  TITLE_CHANGED: "PanelEvent.TITLE_CHANGED",
  // Panel was re-opened from a dehydrated state
  REOPEN: "PanelEvent.REOPEN",
  // Panel was deleted
  DELETE: "PanelEvent.DELETE",
  // Panel was cloned/copied
  CLONED: "PanelEvent.CLONED",
  // Panel was closed
  CLOSED: "PanelEvent.CLOSED",
  // Event to open a new panel
  // Plugins will need to register to open based on this event.
  // Multiple plugins could open panels for the same event if desired.
  OPEN: "PanelEvent.OPEN",
  // Event to close a panel that's currently open
  CLOSE: "PanelEvent.CLOSE",
  // Panel is being dragged
  DRAGGING: "PanelEvent.DRAGGING",
  // Panel is dropped
  DROPPED: "PanelEvent.DROPPED"
});
function isWrappedComponent(type) {
  return (type === null || type === void 0 ? void 0 : type.WrappedComponent) !== void 0;
}
function ownKeys$5(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread$5(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$5(Object(source), true).forEach(function(key) {
      _defineProperty$e(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$5(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$e(obj, key, value) {
  key = _toPropertyKey$e(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$e(arg) {
  var key = _toPrimitive$e(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$e(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var log$6 = Log$1.module("PanelManager");
class PanelManager2 {
  /**
   * @param layout The GoldenLayout object to attach to
   * @param hydrateComponent Function to hydrate a panel from a dehydrated state
   * @param dehydrateComponent Function to dehydrate a panel
   * @param openedMap Map of opened panels
   * @param closed Array of closed panels in a dehydrated state
   * @param onPanelsUpdated Triggered when the panels are updated
   */
  constructor(layout) {
    var hydrateComponent = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : (name2, props) => props;
    var dehydrateComponent = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : (name2, config2) => config2;
    var openedMap = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : /* @__PURE__ */ new Map();
    var closed = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : [];
    var onPanelsUpdated = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : () => void 0;
    _defineProperty$e(this, "layout", void 0);
    _defineProperty$e(this, "hydrateComponent", void 0);
    _defineProperty$e(this, "dehydrateComponent", void 0);
    _defineProperty$e(this, "onPanelsUpdated", void 0);
    _defineProperty$e(this, "closed", void 0);
    _defineProperty$e(this, "openedMap", void 0);
    this.handleFocus = this.handleFocus.bind(this);
    this.handleMount = this.handleMount.bind(this);
    this.handleUnmount = this.handleUnmount.bind(this);
    this.handleReopen = this.handleReopen.bind(this);
    this.handleDeleted = this.handleDeleted.bind(this);
    this.handleClosed = this.handleClosed.bind(this);
    this.handleControlClose = this.handleControlClose.bind(this);
    this.layout = layout;
    this.hydrateComponent = hydrateComponent;
    this.dehydrateComponent = dehydrateComponent;
    this.onPanelsUpdated = onPanelsUpdated;
    this.openedMap = new Map(openedMap);
    this.closed = [...closed];
    this.startListening();
  }
  startListening() {
    var {
      eventHub
    } = this.layout;
    eventHub.on(PanelEvent.FOCUS, this.handleFocus);
    eventHub.on(PanelEvent.MOUNT, this.handleMount);
    eventHub.on(PanelEvent.UNMOUNT, this.handleUnmount);
    eventHub.on(PanelEvent.REOPEN, this.handleReopen);
    eventHub.on(PanelEvent.DELETE, this.handleDeleted);
    eventHub.on(PanelEvent.CLOSED, this.handleClosed);
    eventHub.on(PanelEvent.CLOSE, this.handleControlClose);
  }
  stopListening() {
    var {
      eventHub
    } = this.layout;
    eventHub.off(PanelEvent.FOCUS, this.handleFocus);
    eventHub.off(PanelEvent.MOUNT, this.handleMount);
    eventHub.off(PanelEvent.UNMOUNT, this.handleUnmount);
    eventHub.off(PanelEvent.REOPEN, this.handleReopen);
    eventHub.off(PanelEvent.DELETE, this.handleDeleted);
    eventHub.off(PanelEvent.CLOSED, this.handleClosed);
    eventHub.off(PanelEvent.CLOSE, this.handleControlClose);
  }
  getClosedPanelConfigsOfType(typeString) {
    return this.closed.filter((panel) => panel.component === typeString);
  }
  getOpenedPanels() {
    return Array.from(this.openedMap.values());
  }
  getOpenedPanelConfigs() {
    return this.getOpenedPanels().map((panel) => {
      var {
        glContainer
      } = panel.props;
      return LayoutUtils2.getComponentConfigFromContainer(glContainer);
    });
  }
  getOpenedPanelConfigsOfType(typeString) {
    return this.getOpenedPanelConfigs().filter((config2) => config2 != null && isReactComponentConfig(config2) && config2.component === typeString);
  }
  getOpenedPanelById(panelId) {
    return this.openedMap.get(panelId);
  }
  getContainerByPanelId(panelId) {
    var _ref2;
    var stack = LayoutUtils2.getStackForConfig(this.layout.root, {
      id: panelId
    });
    return (_ref2 = stack && LayoutUtils2.getContentItemInStack(stack, {
      id: panelId
    })) !== null && _ref2 !== void 0 ? _ref2 : null;
  }
  getLastUsedPanel(matcher) {
    var opened = this.getOpenedPanels();
    for (var i = opened.length - 1; i >= 0; i -= 1) {
      var _panel = opened[i];
      if (matcher == null || matcher(_panel)) {
        return _panel;
      }
    }
    return void 0;
  }
  getLastUsedPanelOfType(type) {
    return this.getLastUsedPanelOfTypes([type]);
  }
  getLastUsedPanelOfTypes(types) {
    return this.getLastUsedPanel((panel) => types.some((type) => isWrappedComponent(type) && panel instanceof type.WrappedComponent || !isWrappedComponent(type) && panel instanceof type));
  }
  updatePanel(panel) {
    var panelId = LayoutUtils2.getIdFromPanel(panel);
    if (panelId == null) {
      log$6.error("updatePanel Panel did not have an ID", panel);
      return;
    }
    log$6.debug2("Updating panel ID ".concat(panelId, " in open panels map"));
    this.openedMap.delete(panelId);
    this.openedMap.set(panelId, panel);
  }
  removePanel(panel) {
    var panelId = LayoutUtils2.getIdFromPanel(panel);
    if (panelId == null) {
      log$6.error("removePanel Panel did not have an ID", panel);
      return;
    }
    if (!this.openedMap.has(panelId)) {
      log$6.error("Missing panel ID ".concat(panelId, " in open panels map"));
      return;
    }
    if (this.openedMap.get(panelId) !== panel) {
      log$6.debug("Panel argument doesn't match the open panels map entry for ".concat(panelId, ", removePanel ignored"));
      return;
    }
    log$6.debug2("Removing panel ID ".concat(panelId, " from open panels map"));
    this.openedMap.delete(panelId);
  }
  removeClosedPanelConfig(panelConfig) {
    var index = this.closed.findIndex((closedConfig) => closedConfig === panelConfig || closedConfig.id != null && panelConfig.id != null && closedConfig.id === panelConfig.id);
    if (index >= 0) {
      this.closed.splice(index, 1);
    }
  }
  handleFocus(panel) {
    log$6.debug2("Focus: ", panel);
    this.updatePanel(panel);
  }
  handleMount(panel) {
    log$6.debug2("Mount: ", panel);
    this.updatePanel(panel);
    this.sendUpdate();
  }
  handleUnmount(panel) {
    log$6.debug2("Unmount: ", panel);
    this.removePanel(panel);
    this.sendUpdate();
  }
  /**
   *
   * @param panelConfig The config to hydrate and load
   * @param replaceConfig The config to place
   */
  handleReopen(panelConfig, replaceConfig) {
    log$6.debug2("Reopen:", panelConfig, replaceConfig);
    this.removeClosedPanelConfig(panelConfig);
    var {
      component
    } = panelConfig;
    var {
      props
    } = panelConfig;
    props = this.hydrateComponent(component, props);
    var config2 = _objectSpread$5(_objectSpread$5({}, panelConfig), {}, {
      props
    });
    var {
      root: root2
    } = this.layout;
    LayoutUtils2.openComponent({
      root: root2,
      config: config2,
      replaceConfig
    });
  }
  handleDeleted(panelConfig) {
    log$6.debug2("Deleted:", panelConfig);
    this.removeClosedPanelConfig(panelConfig);
    this.sendUpdate();
  }
  handleClosed(panelId, glContainer) {
    log$6.debug2("Closed: ", panelId);
    this.addClosedPanel(glContainer);
    this.sendUpdate();
  }
  handleControlClose(id) {
    var config2 = {
      id
    };
    var {
      root: root2
    } = this.layout;
    LayoutUtils2.closeComponent(root2, config2);
  }
  addClosedPanel(glContainer) {
    var config2 = LayoutUtils2.getComponentConfigFromContainer(glContainer);
    if (config2 && isReactComponentConfig(config2)) {
      var dehydratedConfig = this.dehydrateComponent(config2.component, config2);
      if (dehydratedConfig != null) {
        this.closed.push(dehydratedConfig);
      }
    }
  }
  sendUpdate() {
    var {
      closed,
      openedMap
    } = this;
    this.onPanelsUpdated({
      closed: [...closed],
      openedMap: new Map(openedMap)
    });
  }
}
_defineProperty$e(PanelManager2, "MAX_CLOSED_PANEL_COUNT", 100);
const black = "#1a171a";
const white = "#f0f0ee";
const yellow = "#fcd65b";
const green = "#9edc6f";
const blue = "#76d9e4";
const purple = "#aa9af4";
const orange = "#f37e3f";
const red = "#f95d84";
const primary = "#4878ea";
const secondary = "#5b5a5c";
const success = "#9edc6f";
const info = "#fcd65b";
const warning = "#f37e3f";
const danger = "#f95d84";
const light = "#fcfcfa";
const mid = "#929192";
const dark = "#373438";
const background = "#1a171a";
const foreground = "#f0f0ee";
const transition = "0.15s";
const ThemeExport$1 = {
  "gray-100": "#fcfcfa",
  "gray-200": "#f0f0ee",
  "gray-300": "#c0bfbf",
  "gray-400": "#929192",
  "gray-500": "#5b5a5c",
  "gray-600": "#555356",
  "gray-700": "#403e41",
  "gray-800": "#373438",
  "gray-850": "#322f33",
  "gray-900": "#211f22",
  black,
  white,
  yellow,
  green,
  blue,
  purple,
  orange,
  red,
  primary,
  "primary-hover": "#235de6",
  "primary-dark": "#343e5d",
  secondary,
  success,
  info,
  warning,
  danger,
  light,
  mid,
  dark,
  "text-muted": "#929192",
  "content-bg": "#2d2a2e",
  background,
  foreground,
  transition
};
function ownKeys$4(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread$4(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$4(Object(source), true).forEach(function(key) {
      _defineProperty$d(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$4(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$d(obj, key, value) {
  key = _toPropertyKey$d(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$d(arg) {
  var key = _toPrimitive$d(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$d(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var transitions = {
  transitionMs: 150,
  transitionMidMs: 200,
  transitionLongMs: 300,
  transitionSlowMs: 1e3
};
const ThemeExport = Object.freeze(_objectSpread$4(_objectSpread$4({}, transitions), ThemeExport$1));
const Popper$2 = "";
function ownKeys$3(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread$3(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$3(Object(source), true).forEach(function(key) {
      _defineProperty$c(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$3(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$c(obj, key, value) {
  key = _toPropertyKey$c(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$c(arg) {
  var key = _toPrimitive$c(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$c(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class Popper extends React.Component {
  constructor(props) {
    super(props);
    _defineProperty$c(this, "element", void 0);
    _defineProperty$c(this, "container", void 0);
    _defineProperty$c(this, "rAF", void 0);
    this.handleEnter = this.handleEnter.bind(this);
    this.handleExit = this.handleExit.bind(this);
    this.handleBlur = this.handleBlur.bind(this);
    this.element = document.createElement("div");
    this.element.className = "popper-container";
    this.container = /* @__PURE__ */ React.createRef();
    this.rAF = 0;
    var {
      isShown
    } = this.props;
    this.state = {
      show: isShown,
      popper: null
    };
  }
  componentDidUpdate(prevProps) {
    var {
      isShown
    } = this.props;
    if (prevProps.isShown !== isShown) {
      if (isShown) {
        cancelAnimationFrame(this.rAF);
        this.rAF = window.requestAnimationFrame(() => {
          this.show();
        });
      } else {
        this.hide();
      }
    }
  }
  componentWillUnmount() {
    this.destroyPopper(false);
  }
  /** Goes through an element and it's parents until the first visible element is found */
  getVisibleElement(element) {
    if (element == null || element.clientHeight > 0 || element.clientWidth > 0) {
      return element;
    }
    return this.getVisibleElement(element.parentElement);
  }
  initPopper() {
    var {
      popper
    } = this.state;
    var {
      closeOnBlur,
      referenceObject
    } = this.props;
    if (popper) {
      return;
    }
    if (this.container.current === null) {
      return;
    }
    var {
      options
    } = this.props;
    options = _objectSpread$3({
      placement: "auto",
      modifiers: {
        preventOverflow: {
          boundariesElement: "viewport"
        }
      }
    }, options);
    document.body.appendChild(this.element);
    var parent = this.getVisibleElement(this.container.current);
    if (parent == null) {
      parent = this.container.current;
    }
    popper = new PopperJs(referenceObject || parent, this.element, options);
    popper.scheduleUpdate();
    cancelAnimationFrame(this.rAF);
    this.rAF = window.requestAnimationFrame(() => {
      if (closeOnBlur && !this.element.contains(document.activeElement)) {
        var elem = this.element.firstElementChild;
        if (elem instanceof HTMLElement) {
          elem.focus();
        }
      }
    });
    this.setState({
      popper
    });
  }
  destroyPopper() {
    var updateState = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true;
    cancelAnimationFrame(this.rAF);
    var {
      popper
    } = this.state;
    if (!popper) {
      return;
    }
    popper.destroy();
    if (document.body.contains(this.element)) {
      document.body.removeChild(this.element);
    }
    if (updateState) {
      this.setState({
        popper: null
      });
    }
  }
  show() {
    this.initPopper();
    this.setState({
      show: true
    });
  }
  hide() {
    this.setState({
      show: false
    });
  }
  scheduleUpdate() {
    var {
      popper
    } = this.state;
    if (popper)
      popper.scheduleUpdate();
  }
  handleBlur(e) {
    if (!(e.relatedTarget instanceof HTMLElement)) {
      return;
    }
    if (!this.element.contains(e.relatedTarget)) {
      this.hide();
    }
  }
  handleEnter() {
    var {
      onEntered
    } = this.props;
    onEntered();
  }
  handleExit() {
    var {
      onExited
    } = this.props;
    var {
      show
    } = this.state;
    if (!show) {
      this.destroyPopper();
    }
    onExited();
  }
  renderContent() {
    var {
      className,
      children,
      timeout,
      interactive,
      closeOnBlur
    } = this.props;
    var {
      show
    } = this.state;
    return /* @__PURE__ */ React.createElement(CSSTransition$1, {
      in: show,
      timeout,
      classNames: "popper-transition",
      onEntered: this.handleEnter,
      onExited: this.handleExit
    }, /* @__PURE__ */ React.createElement("div", {
      onClick: (e) => {
        e.stopPropagation();
      },
      onKeyDown: (e) => {
        if (e.key === "Escape")
          this.hide();
      },
      className: classnamesExports("popper", {
        interactive
      }, className),
      onBlur: closeOnBlur ? this.handleBlur : void 0,
      tabIndex: closeOnBlur ? -1 : void 0,
      role: "presentation"
    }, /* @__PURE__ */ React.createElement("div", {
      className: "popper-content"
    }, children, /* @__PURE__ */ React.createElement("div", {
      className: "popper-arrow",
      "x-arrow": ""
    }))));
  }
  render() {
    var {
      popper
    } = this.state;
    var {
      "data-testid": dataTestId
    } = this.props;
    return /* @__PURE__ */ React.createElement("div", {
      className: "popper-parent-container",
      ref: this.container,
      style: {
        display: "none"
      },
      "data-testid": dataTestId
    }, popper && /* @__PURE__ */ ReactDOM.createPortal(this.renderContent(), this.element));
  }
}
_defineProperty$c(Popper, "propTypes", {
  children: propTypesExports.node.isRequired,
  options: propTypesExports.shape({}),
  className: propTypesExports.string,
  timeout: propTypesExports.number,
  onEntered: propTypesExports.func,
  onExited: propTypesExports.func,
  isShown: propTypesExports.bool,
  closeOnBlur: propTypesExports.bool,
  interactive: propTypesExports.bool,
  referenceObject: propTypesExports.shape({}),
  "data-testid": propTypesExports.string
});
_defineProperty$c(Popper, "defaultProps", {
  options: {},
  className: "",
  timeout: ThemeExport.transitionMs,
  onEntered() {
  },
  onExited() {
  },
  isShown: false,
  interactive: false,
  closeOnBlur: false,
  referenceObject: null,
  "data-testid": void 0
});
const Popper$1 = Popper;
function ownKeys$2(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread$2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$2(Object(source), true).forEach(function(key) {
      _defineProperty$b(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$2(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$b(obj, key, value) {
  key = _toPropertyKey$b(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$b(arg) {
  var key = _toPrimitive$b(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$b(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var log$5 = Log$1.module("Tooltip");
class Tooltip extends React.Component {
  static handleHidden() {
    Tooltip.shownTooltipCount -= 1;
    if (Tooltip.shownTooltipCount === 0) {
      Tooltip.lastHiddenTime = Date.now();
    }
  }
  static handleShown() {
    Tooltip.shownTooltipCount += 1;
  }
  constructor(props) {
    super(props);
    _defineProperty$b(this, "container", void 0);
    _defineProperty$b(this, "popper", void 0);
    _defineProperty$b(this, "parent", void 0);
    _defineProperty$b(this, "timer", void 0);
    this.handleMouseMove = this.handleMouseMove.bind(this);
    this.handleMouseLeave = this.handleMouseLeave.bind(this);
    this.handleWindowMouseMove = this.handleWindowMouseMove.bind(this);
    this.handleWheel = this.handleWheel.bind(this);
    this.handleTimeout = this.handleTimeout.bind(this);
    this.handleExited = this.handleExited.bind(this);
    this.stopShowingTooltip = this.stopShowingTooltip.bind(this);
    this.container = /* @__PURE__ */ React.createRef();
    this.popper = /* @__PURE__ */ React.createRef();
    this.parent = null;
    this.timer = null;
    this.state = {
      isShown: false
    };
  }
  componentDidMount() {
    this.startListening();
    var {
      timeout
    } = this.props;
    if (timeout === 0) {
      this.show();
    }
  }
  componentDidUpdate(prevProps, prevState) {
    var {
      isShown: oldIsShown
    } = prevState;
    var {
      isShown
    } = this.state;
    if (isShown !== oldIsShown) {
      if (isShown) {
        Tooltip.handleShown();
      } else {
        Tooltip.handleHidden();
      }
    }
  }
  componentWillUnmount() {
    this.stopListening();
    this.stopListeningWindow();
    this.stopTimer();
    var {
      isShown
    } = this.state;
    if (isShown) {
      Tooltip.handleHidden();
    }
  }
  startListening() {
    if (!this.container.current || !this.container.current.parentElement) {
      log$5.error("Tooltip doesn't have a container or a parent set!");
      return;
    }
    this.parent = this.container.current.parentElement;
    this.parent.addEventListener("mousemove", this.handleMouseMove);
    this.parent.addEventListener("mouseleave", this.handleMouseLeave);
    this.parent.addEventListener("mousedown", this.stopShowingTooltip);
  }
  stopListening() {
    if (!this.parent) {
      return;
    }
    this.parent.removeEventListener("mousemove", this.handleMouseMove);
    this.parent.removeEventListener("mouseleave", this.handleMouseLeave);
    this.parent.removeEventListener("mousedown", this.stopShowingTooltip);
  }
  startListeningWindow() {
    window.addEventListener("mousemove", this.handleWindowMouseMove, true);
    window.addEventListener("contextmenu", this.stopShowingTooltip, true);
    window.addEventListener("wheel", this.handleWheel);
  }
  stopListeningWindow() {
    window.removeEventListener("mousemove", this.handleWindowMouseMove, true);
    window.removeEventListener("contextmenu", this.stopShowingTooltip, true);
    window.removeEventListener("wheel", this.handleWheel);
  }
  handleMouseMove() {
    this.startTimer();
  }
  handleWheel() {
    var {
      isShown
    } = this.state;
    if (this.popper.current && this.parent && isShown) {
      if (!this.popper.current.element.matches(":hover") && !this.parent.matches(":hover")) {
        this.stopTimer();
        this.hide();
      }
    }
  }
  handleMouseLeave() {
    var {
      isShown
    } = this.state;
    this.stopTimer();
    var {
      interactive
    } = this.props;
    if (!interactive && isShown) {
      this.hide();
    }
  }
  handleTimeout() {
    this.show();
  }
  handleWindowMouseMove(event) {
    var mouseX = event.clientX;
    var mouseY = event.clientY;
    var {
      isShown
    } = this.state;
    if (!this.popper.current || !this.parent) {
      return;
    }
    var popperRect = this.popper.current.element.getBoundingClientRect();
    var parentRect = this.parent.getBoundingClientRect();
    if (mouseX >= popperRect.left && mouseX <= popperRect.left + popperRect.width && mouseY >= popperRect.top && mouseY <= popperRect.top + popperRect.height) {
      this.handleMouseMove();
    } else if (mouseX >= parentRect.left && mouseX <= parentRect.left + parentRect.width && mouseY >= parentRect.top && mouseY <= parentRect.top + parentRect.height) {
      this.handleMouseMove();
    } else if (isShown) {
      this.stopTimer();
      this.hide();
    }
  }
  startTimer() {
    this.stopTimer();
    var {
      timeout,
      reshowTimeout
    } = this.props;
    var timerTimeout = timeout;
    if (Tooltip.shownTooltipCount > 0 || Date.now() - Tooltip.lastHiddenTime < Tooltip.triggerReshowThreshold) {
      timerTimeout = reshowTimeout;
    }
    this.timer = window.setTimeout(this.handleTimeout, timerTimeout);
  }
  stopTimer() {
    if (this.timer != null) {
      clearTimeout(this.timer);
      this.timer = null;
    }
  }
  show() {
    var {
      isShown
    } = this.state;
    this.stopTimer();
    if (!isShown) {
      var _this$popper$current;
      (_this$popper$current = this.popper.current) === null || _this$popper$current === void 0 ? void 0 : _this$popper$current.show();
      this.setState({
        isShown: true
      });
      var {
        interactive
      } = this.props;
      if (interactive) {
        this.startListeningWindow();
      }
    }
  }
  hide() {
    var _this$popper$current2;
    (_this$popper$current2 = this.popper.current) === null || _this$popper$current2 === void 0 ? void 0 : _this$popper$current2.hide();
    this.stopListeningWindow();
  }
  update() {
    var _this$popper$current3;
    (_this$popper$current3 = this.popper.current) === null || _this$popper$current3 === void 0 ? void 0 : _this$popper$current3.scheduleUpdate();
  }
  handleExited() {
    this.setState({
      isShown: false
    });
    var {
      onExited
    } = this.props;
    onExited();
  }
  stopShowingTooltip() {
    var {
      isShown
    } = this.state;
    this.stopTimer();
    if (isShown) {
      this.hide();
    }
  }
  render() {
    var {
      interactive,
      children,
      referenceObject,
      popperClassName,
      "data-testid": dataTestId,
      onEntered
    } = this.props;
    var {
      isShown
    } = this.state;
    var {
      options
    } = this.props;
    options = _objectSpread$2({
      placement: "bottom"
    }, options);
    return /* @__PURE__ */ React.createElement("div", {
      ref: this.container,
      style: {
        display: "none"
      },
      "data-testid": dataTestId
    }, /* @__PURE__ */ React.createElement(Popper$1, {
      className: classnamesExports(popperClassName),
      options,
      ref: this.popper,
      onEntered,
      onExited: this.handleExited,
      interactive,
      referenceObject
    }, /* @__PURE__ */ React.createElement("div", {
      className: "tooltip-content"
    }, " ", isShown && children)));
  }
}
_defineProperty$b(Tooltip, "defaultTimeout", 500);
_defineProperty$b(Tooltip, "defaultReshowTimeout", 100);
_defineProperty$b(Tooltip, "triggerReshowThreshold", 300);
_defineProperty$b(Tooltip, "shownTooltipCount", 0);
_defineProperty$b(Tooltip, "lastHiddenTime", Date.now());
_defineProperty$b(Tooltip, "defaultProps", {
  interactive: false,
  options: {},
  popperClassName: "",
  reshowTimeout: Tooltip.defaultReshowTimeout,
  timeout: Tooltip.defaultTimeout,
  onEntered: () => void 0,
  onExited: () => void 0,
  "data-testid": void 0
});
const Tooltip$1 = Tooltip;
var BUTTON_KINDS = ["primary", "secondary", "tertiary", "success", "danger", "inline", "ghost"];
var VARIANT_KINDS = ["group-end"];
function getClassName(kind, iconOnly) {
  switch (kind) {
    case "primary":
      return "btn-primary";
    case "secondary":
      return "btn-outline-primary";
    case "tertiary":
      return "btn-secondary";
    case "success":
      return "btn-success";
    case "danger":
      return "btn-danger";
    case "inline":
      return "btn-inline";
    case "ghost":
      return classnamesExports("btn-link", {
        "btn-link-icon": iconOnly,
        "btn-link-icon-only": iconOnly
      });
  }
}
function getVariantClasses(kind) {
  switch (kind) {
    case "group-end":
      return classnamesExports("pl-2", "pr-3");
  }
}
var Button = /* @__PURE__ */ React.forwardRef((props, ref) => {
  var {
    kind,
    variant,
    type,
    tooltip,
    icon: icon3,
    disabled: disabled2 = false,
    active,
    onClick,
    onContextMenu,
    onMouseDown,
    onMouseUp,
    onMouseEnter,
    onMouseLeave,
    onKeyDown,
    className,
    style,
    children,
    tabIndex,
    "data-testid": dataTestId,
    "aria-label": ariaLabel
  } = props;
  var iconOnly = Boolean(icon3 && children == null);
  var btnClassName = getClassName(kind, iconOnly);
  var variantClassName;
  if (variant) {
    variantClassName = getVariantClasses(variant);
  }
  var iconElem;
  if (icon3) {
    iconElem = /* @__PURE__ */ React.isValidElement(icon3) ? icon3 : /* @__PURE__ */ React.createElement(FontAwesomeIcon, {
      icon: icon3
    });
  }
  var tooltipElem;
  if (tooltip !== void 0) {
    tooltipElem = typeof tooltip === "string" ? /* @__PURE__ */ React.createElement(Tooltip$1, null, tooltip) : tooltip;
  }
  var ariaLabelString = ariaLabel;
  if (ariaLabel === void 0 && iconOnly && tooltip != null && typeof tooltip === "string") {
    ariaLabelString = tooltip;
  }
  var button = /* @__PURE__ */ React.createElement("button", {
    "data-testid": dataTestId,
    ref,
    type,
    className: classnamesExports("btn", btnClassName, variantClassName, {
      active
    }, className),
    onClick,
    onContextMenu,
    onMouseUp,
    onMouseDown,
    onMouseEnter,
    onMouseLeave,
    onKeyDown,
    style,
    disabled: disabled2,
    tabIndex,
    "aria-label": ariaLabelString
  }, icon3 && iconElem, children, tooltip != null && !disabled2 && tooltipElem);
  return disabled2 ? /* @__PURE__ */ React.createElement("span", {
    className: "btn-disabled-wrapper"
  }, button, tooltip !== void 0 && tooltipElem) : button;
});
Button.displayName = "Button";
Button.propTypes = {
  kind: propTypesExports.oneOf(BUTTON_KINDS).isRequired,
  variant: propTypesExports.oneOf(VARIANT_KINDS),
  type: propTypesExports.oneOf(["submit", "reset", "button"]),
  tooltip(props) {
    var {
      tooltip,
      icon: icon3,
      children
    } = props;
    if (tooltip === void 0 && icon3 != null && children == null) {
      return new Error("Tooltip is required for icon only buttons");
    }
    return null;
  },
  icon(props) {
    var {
      children,
      icon: icon3
    } = props;
    if (icon3 == null && children == null) {
      return new Error("Icon is required if no children are provided");
    }
    if (children == null && !/* @__PURE__ */ React.isValidElement(icon3) && (icon3 == null || icon3.iconName === "" || icon3.iconName == null)) {
      return new Error("Icon must be react element or fontawesome IconDefinition");
    }
    return null;
  },
  disabled: propTypesExports.bool,
  active: propTypesExports.bool,
  onClick(props) {
    var {
      onClick,
      type
    } = props;
    if (type === "button" && typeof onClick !== "function") {
      return new Error("type button requires an onClick function");
    }
    if (onClick !== void 0 && typeof onClick !== "function") {
      return new Error("onClick must be a function");
    }
    return null;
  },
  onContextMenu: propTypesExports.func,
  onMouseUp: propTypesExports.func,
  onMouseDown: propTypesExports.func,
  onMouseEnter: propTypesExports.func,
  onMouseLeave: propTypesExports.func,
  onKeyDown: propTypesExports.func,
  tabIndex: propTypesExports.number,
  children: propTypesExports.node,
  className: propTypesExports.string,
  style: propTypesExports.object,
  "data-testid": propTypesExports.string
};
Button.defaultProps = {
  type: "button",
  onClick: void 0,
  onContextMenu: void 0,
  onMouseUp: void 0,
  onMouseDown: void 0,
  onMouseEnter: void 0,
  onMouseLeave: void 0,
  onKeyDown: void 0,
  variant: void 0,
  tooltip: void 0,
  icon: void 0,
  disabled: false,
  active: void 0,
  tabIndex: void 0,
  children: void 0,
  className: void 0,
  style: {},
  "data-testid": void 0
};
const Button$1 = Button;
function _defineProperty$a(obj, key, value) {
  key = _toPropertyKey$a(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$a(arg) {
  var key = _toPrimitive$a(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$a(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
function isPromise(value) {
  return value.then !== void 0;
}
class ContextActionUtils {
  static disableAllActions() {
    ContextActionUtils.actionsDisabled = true;
  }
  static enableAllActions() {
    ContextActionUtils.actionsDisabled = false;
  }
  static isContextActionEvent(e) {
    return Array.isArray(e.contextActions);
  }
  /**
   * Compare two action items. Useful in Array.sort
   * @param a First context action to compare
   * @param b Second context action to compare
   */
  static compareActions(a, b) {
    if (a.group !== b.group) {
      var _a$group, _b$group;
      return ((_a$group = a.group) !== null && _a$group !== void 0 ? _a$group : 0) > ((_b$group = b.group) !== null && _b$group !== void 0 ? _b$group : 0) ? 1 : -1;
    }
    if (a.order !== b.order) {
      var _a$order, _b$order;
      return ((_a$order = a.order) !== null && _a$order !== void 0 ? _a$order : 0) > ((_b$order = b.order) !== null && _b$order !== void 0 ? _b$order : 0) ? 1 : -1;
    }
    if (a.title !== b.title) {
      var _a$title, _b$title;
      return ((_a$title = a.title) !== null && _a$title !== void 0 ? _a$title : "") > ((_b$title = b.title) !== null && _b$title !== void 0 ? _b$title : "") ? 1 : -1;
    }
    if (a !== b) {
      return a > b ? 1 : -1;
    }
    return 0;
  }
  /**
   *
   * @param actions The array of actions to sort
   */
  static sortActions(actions) {
    if (actions == null || !Array.isArray(actions)) {
      return [];
    }
    var sortedActions = actions.slice();
    sortedActions.sort(ContextActionUtils.compareActions);
    return sortedActions;
  }
  static isMacPlatform() {
    var {
      platform
    } = window.navigator;
    return platform.startsWith("Mac");
  }
  /**
   * Retrieve the preferred modifier key based on the current platform
   */
  static getModifierKey() {
    if (ContextActionUtils.isMacPlatform()) {
      return "metaKey";
    }
    return "ctrlKey";
  }
  /**
   * Returns true if the modifier key for the current platform is down for the event (Ctrl for windows/linux, Command (meta) for mac)
   * @param event The event to get the meta key status from
   */
  static isModifierKeyDown(event) {
    var modifierKey = ContextActionUtils.getModifierKey();
    return event[modifierKey];
  }
  /**
   * Returns the menu items for the provided context actions, or empty array if none found.
   * @param actionsParam The actions to get menu items for
   * @param includePromises Whether or not to include promises in the returned menu items
   */
  static getMenuItems(actionsParam) {
    var includePromises = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true;
    var menuItems = [];
    var actions = actionsParam;
    if (!Array.isArray(actions)) {
      actions = [actions];
    }
    for (var i = 0; i < actions.length; i += 1) {
      var _action = actions[i];
      var newMenuItems = void 0;
      if (typeof _action === "function") {
        newMenuItems = _action();
      } else {
        newMenuItems = _action;
      }
      if (newMenuItems != null) {
        if (newMenuItems instanceof Promise) {
          if (includePromises) {
            menuItems.push(newMenuItems);
          }
        } else if (Array.isArray(newMenuItems)) {
          menuItems = menuItems.concat(newMenuItems);
        } else {
          menuItems.push(newMenuItems);
        }
      }
    }
    menuItems = menuItems.filter((action) => action.title !== void 0 || action.then != null || action.menuElement);
    return menuItems;
  }
  /**
   * Returns the index of the next menu item in a list that doesn't have a disabled=true prop
   * @param startIndex the starting position for the iteration
   * @param delta the direction of travel, -1 or 1
   * @param menuItems an array of menuItems
   */
  static getNextMenuItem(startIndex, delta, menuItems) {
    var firstIndex = startIndex;
    if (firstIndex < 0 && delta < 0) {
      firstIndex = menuItems.length;
    }
    for (var i = 1; i < menuItems.length + 1; i += 1) {
      var menuIndex = (firstIndex + delta * i + menuItems.length) % menuItems.length;
      var item = menuItems[menuIndex];
      if (!(item instanceof Promise) && item.disabled !== true) {
        return menuIndex;
      }
    }
    return startIndex;
  }
}
_defineProperty$a(ContextActionUtils, "actionsDisabled", false);
const ContextActionUtils$1 = ContextActionUtils;
var log$4 = Log$1.module("GlobalContextAction");
class GlobalContextAction extends React.Component {
  constructor(props) {
    super(props);
    this.handleContextMenu = this.handleContextMenu.bind(this);
    this.handleKeyDown = this.handleKeyDown.bind(this);
  }
  componentDidMount() {
    document.body.addEventListener("contextmenu", this.handleContextMenu);
    document.body.addEventListener("keydown", this.handleKeyDown);
  }
  componentWillUnmount() {
    document.body.removeEventListener("contextmenu", this.handleContextMenu);
    document.body.removeEventListener("keydown", this.handleKeyDown);
  }
  handleContextMenu(evt) {
    var e = evt;
    if (e.contextActions == null) {
      e.contextActions = [];
    }
    var {
      action
    } = this.props;
    if (action.title == null && !action.menuElement) {
      return;
    }
    if (e.contextActions == null) {
      e.contextActions = [];
    }
    e.contextActions.push(action);
    log$4.debug("Received context menu event at global action! Menu items are now: ", e.contextActions);
  }
  handleKeyDown(e) {
    var {
      action
    } = this.props;
    if (!ContextActionUtils$1.actionsDisabled && action.shortcut !== void 0 && action.shortcut.matchesEvent(e)) {
      var _action$action;
      log$4.debug("Global hotkey matched!", e);
      (_action$action = action.action) === null || _action$action === void 0 ? void 0 : _action$action.call(action, e);
      e.preventDefault();
      e.stopPropagation();
    }
  }
  render() {
    return null;
  }
}
const GlobalContextAction$1 = GlobalContextAction;
class GlobalContextActions extends React.Component {
  render() {
    var {
      actions,
      "data-testid": dataTestId
    } = this.props;
    var actionElements = [];
    for (var i = 0; i < actions.length; i += 1) {
      var action = actions[i];
      var {
        shortcut
      } = action;
      if (action.title != null || action.menuElement || shortcut) {
        var actionElement = /* @__PURE__ */ React.createElement(GlobalContextAction$1, {
          key: "".concat(action.title, ".").concat(shortcut === null || shortcut === void 0 ? void 0 : shortcut.id),
          action,
          "data-testid": dataTestId
        });
        actionElements.push(actionElement);
      }
    }
    return actionElements;
  }
}
const GlobalContextActions$1 = GlobalContextActions;
const ContextActions$2 = "";
function _defineProperty$9(obj, key, value) {
  key = _toPropertyKey$9(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$9(arg) {
  var key = _toPrimitive$9(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$9(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var log$3 = Log$1.module("ContextActions");
class ContextActions extends React.Component {
  /**
   * Group you can assign to context menu actions to group them together.
   * Lower group IDs appear at the top of the list.
   * Groups are separated by a separator item.
   * Items within groups are ordered by their order property, then by their title.
   */
  static triggerMenu(element, clientX, clientY, actions) {
    if (actions.length === 0) {
      return;
    }
    var mouseEvent = new MouseEvent("contextmenu", {
      clientX,
      clientY,
      bubbles: true,
      cancelable: true
    });
    mouseEvent.contextActions = actions;
    element.dispatchEvent(mouseEvent);
  }
  constructor(props) {
    super(props);
    _defineProperty$9(this, "container", void 0);
    this.handleContextMenu = this.handleContextMenu.bind(this);
    this.handleKeyDown = this.handleKeyDown.bind(this);
    this.container = /* @__PURE__ */ React.createRef();
    this.state = {
      globalActions: [],
      keyboardActions: []
    };
  }
  static getDerivedStateFromProps(props) {
    if (props.actions == null || !Array.isArray(props.actions)) {
      return {
        globalActions: [],
        keyboardActions: []
      };
    }
    var globalActions = props.actions.filter((action) => !isPromise(action) && typeof action !== "function" && action.isGlobal);
    var keyboardActions = props.actions.filter((action) => !isPromise(action) && typeof action !== "function" && (action.isGlobal === void 0 || !action.isGlobal) && action.shortcut != null);
    return {
      globalActions,
      keyboardActions
    };
  }
  componentDidMount() {
    var _this$container$curre;
    if ((_this$container$curre = this.container.current) !== null && _this$container$curre !== void 0 && _this$container$curre.parentElement) {
      this.container.current.parentElement.addEventListener("contextmenu", this.handleContextMenu);
      this.container.current.parentElement.addEventListener("keydown", this.handleKeyDown);
    }
  }
  componentWillUnmount() {
    var _this$container$curre2;
    if ((_this$container$curre2 = this.container.current) !== null && _this$container$curre2 !== void 0 && _this$container$curre2.parentElement) {
      this.container.current.parentElement.removeEventListener("contextmenu", this.handleContextMenu);
      this.container.current.parentElement.removeEventListener("keydown", this.handleKeyDown);
    }
  }
  handleContextMenu(e) {
    var {
      ignoreClassNames = []
    } = this.props;
    if (ignoreClassNames.length > 0) {
      var el = e.target;
      var _loop = function _loop2() {
        var {
          classList: classList2
        } = el;
        var ignoredClassName = ignoreClassNames.find((className) => classList2.contains(className));
        if (ignoredClassName !== void 0) {
          log$3.debug2('Contextmenu event ignored based on the target className "'.concat(ignoredClassName, '"'));
          return {
            v: void 0
          };
        }
        el = el.parentElement;
      };
      while (el != null) {
        var _ret = _loop();
        if (typeof _ret === "object")
          return _ret.v;
      }
    }
    if (!ContextActionUtils$1.isContextActionEvent(e)) {
      e.contextActions = [];
    }
    if (!ContextActionUtils$1.isContextActionEvent(e)) {
      return;
    }
    var {
      actions
    } = this.props;
    if (actions != null) {
      var contextActions = actions;
      if (Array.isArray(contextActions)) {
        contextActions = contextActions.filter((action) => isPromise(action) || typeof action === "function" || action.isGlobal === void 0 || !action.isGlobal);
      }
      e.contextActions = e.contextActions.concat(contextActions);
    }
    log$3.debug("Received context menu event! Menu items are now: ", e.contextActions);
  }
  handleKeyDown(e) {
    var {
      keyboardActions
    } = this.state;
    for (var i = 0; i < keyboardActions.length; i += 1) {
      var keyboardAction = keyboardActions[i];
      if (!ContextActionUtils$1.actionsDisabled && keyboardAction.shortcut != null && keyboardAction.shortcut.matchesEvent(e)) {
        var _keyboardAction$actio;
        log$3.debug("Context hotkey matched!", e);
        (_keyboardAction$actio = keyboardAction.action) === null || _keyboardAction$actio === void 0 ? void 0 : _keyboardAction$actio.call(keyboardAction, e);
        e.stopPropagation();
        e.preventDefault();
        log$3.debug2("Matched hotkey returned false, key event not consumed");
      }
    }
  }
  render() {
    var {
      "data-testid": dataTestId
    } = this.props;
    var {
      globalActions
    } = this.state;
    return /* @__PURE__ */ React.createElement("div", {
      className: "context-actions-listener",
      ref: this.container,
      "data-testid": dataTestId
    }, /* @__PURE__ */ React.createElement(GlobalContextActions$1, {
      actions: globalActions
    }));
  }
}
_defineProperty$9(ContextActions, "groups", {
  default: null,
  high: 100,
  medium: 5e3,
  low: 1e4,
  global: 1e5,
  edit: 100
});
const ContextActions$1 = ContextActions;
const LoadingSpinner$1 = "";
function LoadingSpinner(_ref2) {
  var {
    className = "",
    "data-testid": dataTestId
  } = _ref2;
  return /* @__PURE__ */ React.createElement("div", {
    className: classnamesExports("loading-spinner fa-layers", className),
    "data-testid": dataTestId
  }, /* @__PURE__ */ React.createElement(FontAwesomeIcon, {
    icon: vsCircleLargeOutline,
    className: "text-white-50"
  }), /* @__PURE__ */ React.createElement(FontAwesomeIcon, {
    icon: vsLoading,
    className: "text-primary",
    spin: true
  }));
}
function CopyButton(_ref2) {
  var {
    copy,
    kind = "ghost",
    tooltip = "Copy",
    className,
    "data-testid": dataTestId,
    children
  } = _ref2;
  var [copied, copyToClipboard2] = useCopyToClipboard();
  return /* @__PURE__ */ React.createElement(Button$1, {
    kind,
    className,
    "data-testid": dataTestId,
    icon: copied ? vsPassFilled : vsCopy,
    tooltip: copied ? "Copied" : tooltip,
    onClick: () => {
      copyToClipboard2(typeof copy === "function" ? copy() : copy);
    }
  }, children);
}
const LoadingOverlay$1 = "";
function LoadingOverlay(_ref2) {
  var {
    isLoaded = false,
    isLoading = true,
    errorMessage = null,
    "data-testid": dataTestId
  } = _ref2;
  return /* @__PURE__ */ React.createElement(CSSTransition$1, {
    in: Boolean(errorMessage) || !isLoaded || isLoading,
    timeout: ThemeExport.transitionMs,
    classNames: isLoaded ? "fade" : "",
    mountOnEnter: true,
    unmountOnExit: true
  }, /* @__PURE__ */ React.createElement("div", {
    className: "fill-parent-absolute",
    "data-testid": dataTestId
  }, /* @__PURE__ */ React.createElement("div", {
    className: classnamesExports("iris-panel-message-overlay", "fill-parent-absolute", {
      "iris-panel-scrim-background": isLoaded
    })
  }, /* @__PURE__ */ React.createElement("div", {
    className: "message-content"
  }, /* @__PURE__ */ React.createElement("div", {
    className: "message-icon"
  }, isLoading && /* @__PURE__ */ React.createElement(LoadingSpinner, null), !isLoading && errorMessage != null && /* @__PURE__ */ React.createElement(FontAwesomeIcon, {
    icon: vsWarning
  })), /* @__PURE__ */ React.createElement("div", {
    className: "message-text"
  }, errorMessage)))));
}
const PanelErrorBoundary = "";
Log$1.module("PanelErrorBoundary");
var Container = propTypesExports.shape({
  on: propTypesExports.func,
  off: propTypesExports.func,
  isHidden: propTypesExports.bool,
  tab: propTypesExports.shape({
    header: propTypesExports.shape({
      tabs: propTypesExports.arrayOf(propTypesExports.shape({
        contentItem: propTypesExports.shape({})
      }))
    })
  }),
  title: propTypesExports.string,
  setTitle: propTypesExports.func,
  close: propTypesExports.func
});
var EventHub = propTypesExports.shape({
  on: propTypesExports.func,
  off: propTypesExports.func,
  emit: propTypesExports.func
});
var Layout = propTypesExports.shape({
  registerComponent: propTypesExports.func,
  root: propTypesExports.shape({
    addChild: propTypesExports.func
  }),
  on: propTypesExports.func,
  off: propTypesExports.func,
  eventHub: EventHub
});
var GLPropTypes = Object.freeze({
  Container,
  EventHub,
  Layout
});
function ownKeys$1(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread$1(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys$1(Object(source), true).forEach(function(key) {
      _defineProperty$8(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys$1(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$8(obj, key, value) {
  key = _toPropertyKey$8(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$8(arg) {
  var key = _toPrimitive$8(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$8(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
function replaceByIdReducer(type) {
  var initialState = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
  var checkIfChanged = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true;
  return function() {
    var state = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : initialState;
    var action = arguments.length > 1 ? arguments[1] : void 0;
    switch (action.type) {
      case type: {
        var {
          id,
          payload
        } = action;
        if (checkIfChanged && deepEqual({
          payload
        }, {
          payload: state[id]
        })) {
          return state;
        }
        return _objectSpread$1(_objectSpread$1({}, state), {}, {
          [id]: payload
        });
      }
      default:
        return state;
    }
  };
}
function ownKeys(object, enumerableOnly) {
  var keys3 = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys3.push.apply(keys3, symbols);
  }
  return keys3;
}
function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), true).forEach(function(key) {
      _defineProperty$7(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _defineProperty$7(obj, key, value) {
  key = _toPropertyKey$7(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$7(arg) {
  var key = _toPrimitive$7(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$7(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class ReducerRegistry2 {
  constructor() {
    _defineProperty$7(this, "reducers", {});
    _defineProperty$7(this, "listener", null);
  }
  register(name2, reducer) {
    var _this$listener;
    this.reducers = _objectSpread(_objectSpread({}, this.reducers), {}, {
      [name2]: reducer
    });
    (_this$listener = this.listener) === null || _this$listener === void 0 ? void 0 : _this$listener.call(this, this.reducers);
  }
  setListener(listener3) {
    this.listener = listener3;
  }
}
var reducerRegistry = new ReducerRegistry2();
const reducerRegistry$1 = reducerRegistry;
var SET_DASHBOARD_DATA = "SET_DASHBOARD_DATA";
const dashboardData = replaceByIdReducer(SET_DASHBOARD_DATA, {}, false);
const reducers = {
  dashboardData
};
Object.entries(reducers).map((_ref2) => {
  var [name2, reducer] = _ref2;
  return reducerRegistry$1.register(name2, reducer);
});
Log$1.module("DashboardLayout");
({
  id: propTypesExports.string.isRequired,
  children: propTypesExports.node,
  data: propTypesExports.shape({}),
  emptyDashboard: propTypesExports.node,
  layout: GLPropTypes.Layout.isRequired,
  layoutConfig: propTypesExports.arrayOf(propTypesExports.shape({})),
  onLayoutChange: propTypesExports.func,
  onLayoutInitialized: propTypesExports.func
});
const Dashboard = "";
function _defineProperty$6(obj, key, value) {
  key = _toPropertyKey$6(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$6(arg) {
  var key = _toPrimitive$6(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$6(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class ConsoleEvent {
}
_defineProperty$6(ConsoleEvent, "SESSION_OPENED", "ConsoleEvent.SESSION_OPENED");
_defineProperty$6(ConsoleEvent, "SESSION_CLOSED", "ConsoleEvent.SESSION_CLOSED");
_defineProperty$6(ConsoleEvent, "FOCUS_HISTORY", "ConsoleEvent.FOCUS_HISTORY");
_defineProperty$6(ConsoleEvent, "SEND_COMMAND", "ConsoleEvent.SEND_COMMAND");
_defineProperty$6(ConsoleEvent, "SETTINGS_CHANGED", "ConsoleEvent.SETTINGS_CHANGED");
const ConsoleEvent$1 = ConsoleEvent;
function _defineProperty$5(obj, key, value) {
  key = _toPropertyKey$5(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$5(arg) {
  var key = _toPrimitive$5(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$5(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class InputFilterEvent {
}
_defineProperty$5(InputFilterEvent, "TABLE_CHANGED", "InputFilterEvent.TABLE_CHANGED");
_defineProperty$5(InputFilterEvent, "COLUMNS_CHANGED", "InputFilterEvent.COLUMNS_CHANGED");
_defineProperty$5(InputFilterEvent, "FILTERS_CHANGED", "InputFilterEvent.FILTERS_CHANGED");
_defineProperty$5(InputFilterEvent, "CLEAR_ALL_FILTERS", "InputFilterEvent.CLEAR_ALL_FILTERS");
_defineProperty$5(InputFilterEvent, "COLUMN_SELECTED", "InputFilterEvent.COLUMN_SELECTED");
_defineProperty$5(InputFilterEvent, "OPEN_DROPDOWN", "InputFilterEvent.OPEN_DROPDOWN");
_defineProperty$5(InputFilterEvent, "OPEN_INPUT", "InputFilterEvent.OPEN_INPUT");
_defineProperty$5(InputFilterEvent, "OPEN_FILTER_SET_MANAGER", "InputFilterEvent.OPEN_FILTER_SET_MANAGER");
const InputFilterEvent$1 = InputFilterEvent;
function _defineProperty$4(obj, key, value) {
  key = _toPropertyKey$4(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$4(arg) {
  var key = _toPrimitive$4(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$4(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class TabEvent {
}
_defineProperty$4(TabEvent, "focus", "TabEvent.focus");
_defineProperty$4(TabEvent, "blur", "TabEvent.blur");
_defineProperty$4(TabEvent, "openPQObject", "TabEvent.openPQObject");
_defineProperty$4(TabEvent, "openControl", "TabEvent.openControl");
_defineProperty$4(TabEvent, "reload", "TabEvent.reload");
_defineProperty$4(TabEvent, "clearAllFilters", "TabEvent.clearAllFilters");
const TabEvent$1 = TabEvent;
function _defineProperty$3(obj, key, value) {
  key = _toPropertyKey$3(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$3(arg) {
  var key = _toPrimitive$3(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$3(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class PanelContextMenu extends React.PureComponent {
  constructor(props) {
    super(props);
    this.handleCloseTab = this.handleCloseTab.bind(this);
    this.handleCloseTabsRight = this.handleCloseTabsRight.bind(this);
    this.handleCloseTabsAll = this.handleCloseTabsAll.bind(this);
  }
  getAllTabs() {
    var _glContainer$tab$head, _glContainer$tab, _glContainer$tab$head2;
    var {
      glContainer
    } = this.props;
    return [...(_glContainer$tab$head = glContainer === null || glContainer === void 0 ? void 0 : (_glContainer$tab = glContainer.tab) === null || _glContainer$tab === void 0 ? void 0 : (_glContainer$tab$head2 = _glContainer$tab.header) === null || _glContainer$tab$head2 === void 0 ? void 0 : _glContainer$tab$head2.tabs) !== null && _glContainer$tab$head !== void 0 ? _glContainer$tab$head : []];
  }
  handleCloseTab() {
    var {
      glContainer
    } = this.props;
    glContainer.close();
  }
  handleCloseTabsAll() {
    var tabs = this.getAllTabs();
    tabs.forEach((tab) => {
      var _container;
      return (_container = (tab === null || tab === void 0 ? void 0 : tab.contentItem).container) === null || _container === void 0 ? void 0 : _container.close();
    });
  }
  handleCloseTabsRight() {
    var {
      glContainer
    } = this.props;
    var tabs = this.getAllTabs();
    for (var i = tabs.length - 1; i > 0; i -= 1) {
      var _tabs$i$contentItem, _tabs$i$contentItem$c, _glContainer$tab2, _glContainer$tab2$con, _glContainer$tab2$con2, _container2, _tabs$i;
      if (((_tabs$i$contentItem = tabs[i].contentItem) === null || _tabs$i$contentItem === void 0 ? void 0 : (_tabs$i$contentItem$c = _tabs$i$contentItem.config) === null || _tabs$i$contentItem$c === void 0 ? void 0 : _tabs$i$contentItem$c.id) === ((_glContainer$tab2 = glContainer.tab) === null || _glContainer$tab2 === void 0 ? void 0 : (_glContainer$tab2$con = _glContainer$tab2.contentItem) === null || _glContainer$tab2$con === void 0 ? void 0 : (_glContainer$tab2$con2 = _glContainer$tab2$con.config) === null || _glContainer$tab2$con2 === void 0 ? void 0 : _glContainer$tab2$con2.id)) {
        break;
      }
      (_container2 = ((_tabs$i = tabs[i]) === null || _tabs$i === void 0 ? void 0 : _tabs$i.contentItem).container) === null || _container2 === void 0 ? void 0 : _container2.close();
    }
  }
  canCloseTabsRight() {
    var {
      glContainer
    } = this.props;
    var tabs = this.getAllTabs();
    var disabled2 = true;
    for (var i = tabs.length - 1; i > 0; i -= 1) {
      var _tabs$i$contentItem2, _tabs$i$contentItem2$, _glContainer$tab3, _glContainer$tab3$con, _glContainer$tab3$con2, _tabs$i2, _tabs$i2$contentItem, _tabs$i2$contentItem$;
      if (((_tabs$i$contentItem2 = tabs[i].contentItem) === null || _tabs$i$contentItem2 === void 0 ? void 0 : (_tabs$i$contentItem2$ = _tabs$i$contentItem2.config) === null || _tabs$i$contentItem2$ === void 0 ? void 0 : _tabs$i$contentItem2$.id) === ((_glContainer$tab3 = glContainer.tab) === null || _glContainer$tab3 === void 0 ? void 0 : (_glContainer$tab3$con = _glContainer$tab3.contentItem) === null || _glContainer$tab3$con === void 0 ? void 0 : (_glContainer$tab3$con2 = _glContainer$tab3$con.config) === null || _glContainer$tab3$con2 === void 0 ? void 0 : _glContainer$tab3$con2.id)) {
        break;
      }
      var closable = Boolean((_tabs$i2 = tabs[i]) === null || _tabs$i2 === void 0 ? void 0 : (_tabs$i2$contentItem = _tabs$i2.contentItem) === null || _tabs$i2$contentItem === void 0 ? void 0 : (_tabs$i2$contentItem$ = _tabs$i2$contentItem.config) === null || _tabs$i2$contentItem$ === void 0 ? void 0 : _tabs$i2$contentItem$.isClosable);
      if (closable) {
        disabled2 = false;
        break;
      }
    }
    return disabled2;
  }
  canCloseAny() {
    var tabs = this.getAllTabs();
    var disabled2 = true;
    for (var i = tabs.length - 1; i > 0; i -= 1) {
      var _tabs$i3, _tabs$i3$contentItem, _tabs$i3$contentItem$;
      var closable = Boolean((_tabs$i3 = tabs[i]) === null || _tabs$i3 === void 0 ? void 0 : (_tabs$i3$contentItem = _tabs$i3.contentItem) === null || _tabs$i3$contentItem === void 0 ? void 0 : (_tabs$i3$contentItem$ = _tabs$i3$contentItem.config) === null || _tabs$i3$contentItem$ === void 0 ? void 0 : _tabs$i3$contentItem$.isClosable);
      if (closable) {
        disabled2 = false;
        break;
      }
    }
    return disabled2;
  }
  render() {
    var _glContainer$tab4, _glContainer$tab4$con, _glContainer$tab4$con2;
    var {
      additionalActions,
      glContainer
    } = this.props;
    var contextActions = [...additionalActions];
    var closable = (_glContainer$tab4 = glContainer.tab) === null || _glContainer$tab4 === void 0 ? void 0 : (_glContainer$tab4$con = _glContainer$tab4.contentItem) === null || _glContainer$tab4$con === void 0 ? void 0 : (_glContainer$tab4$con2 = _glContainer$tab4$con.config) === null || _glContainer$tab4$con2 === void 0 ? void 0 : _glContainer$tab4$con2.isClosable;
    contextActions.push({
      title: "Close",
      order: 10,
      group: ContextActions$1.groups.low,
      action: this.handleCloseTab,
      disabled: closable === void 0 || !closable
    });
    contextActions.push(() => ({
      title: "Close Tabs to Right",
      order: 20,
      group: ContextActions$1.groups.low,
      action: this.handleCloseTabsRight,
      disabled: this.canCloseTabsRight()
    }));
    contextActions.push(() => ({
      title: "Close All",
      order: 30,
      group: ContextActions$1.groups.low,
      action: this.handleCloseTabsAll,
      disabled: this.canCloseAny()
    }));
    return /* @__PURE__ */ React.createElement(ContextActions$1, {
      actions: contextActions
    });
  }
}
_defineProperty$3(PanelContextMenu, "defaultProps", {
  additionalActions: []
});
const PanelContextMenu$1 = PanelContextMenu;
function _defineProperty$2(obj, key, value) {
  key = _toPropertyKey$2(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$2(arg) {
  var key = _toPrimitive$2(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$2(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class RenameDialog extends React.PureComponent {
  constructor(props) {
    super(props);
    _defineProperty$2(this, "renameInputRef", void 0);
    this.handleRenameDialogOpened = this.handleRenameDialogOpened.bind(this);
    this.handleRenameInputChange = this.handleRenameInputChange.bind(this);
    this.handleRenameCancel = this.handleRenameCancel.bind(this);
    this.handleRenameSubmit = this.handleRenameSubmit.bind(this);
    this.renameInputRef = /* @__PURE__ */ React.createRef();
    var {
      value
    } = props;
    this.state = {
      value,
      valueWasValidated: false
    };
  }
  componentDidUpdate(prevProps) {
    var {
      isShown: prevIsShown
    } = prevProps;
    var {
      isShown
    } = this.props;
    if (isShown && !prevIsShown) {
      this.resetState();
    }
  }
  resetState() {
    var {
      value
    } = this.props;
    this.setState({
      value,
      valueWasValidated: false
    });
  }
  handleRenameDialogOpened() {
    var _this$renameInputRef, _this$renameInputRef$;
    (_this$renameInputRef = this.renameInputRef) === null || _this$renameInputRef === void 0 ? void 0 : (_this$renameInputRef$ = _this$renameInputRef.current) === null || _this$renameInputRef$ === void 0 ? void 0 : _this$renameInputRef$.focus();
  }
  handleRenameInputChange(event) {
    this.setState({
      value: event.target.value
    });
  }
  handleRenameCancel() {
    var {
      onCancel
    } = this.props;
    onCancel();
  }
  handleRenameSubmit(event) {
    event.stopPropagation();
    event.preventDefault();
    var {
      value
    } = this.state;
    var newTitle = value === null || value === void 0 ? void 0 : value.trim();
    if (newTitle !== void 0 && newTitle !== "") {
      var {
        onSubmit
      } = this.props;
      onSubmit(newTitle);
    } else {
      this.setState({
        value: newTitle,
        valueWasValidated: true
      });
    }
  }
  renderRenameDialog() {
    var {
      isShared,
      isOwner,
      itemType
    } = this.props;
    var {
      value,
      valueWasValidated
    } = this.state;
    return /* @__PURE__ */ React.createElement("form", {
      className: classnamesExports("p-3", {
        "was-validated": valueWasValidated
      }),
      onSubmit: this.handleRenameSubmit,
      noValidate: true,
      role: "presentation",
      onMouseDown: (event) => {
        event.stopPropagation();
      },
      onMouseUp: (event) => {
        event.stopPropagation();
      }
    }, /* @__PURE__ */ React.createElement("div", {
      className: "form-group"
    }, /* @__PURE__ */ React.createElement("label", {
      htmlFor: "rename-dialog-".concat(itemType, "-input")
    }, "Rename ", itemType), /* @__PURE__ */ React.createElement("input", {
      type: "text",
      className: "form-control",
      id: "rename-dialog-".concat(itemType, "-input"),
      value: value !== null && value !== void 0 ? value : void 0,
      ref: this.renameInputRef,
      onChange: this.handleRenameInputChange,
      required: true
    }), /* @__PURE__ */ React.createElement("div", {
      className: "invalid-feedback"
    }, itemType, " name cannot be empty"), (isShared || !isOwner) && /* @__PURE__ */ React.createElement("div", {
      className: "pt-2"
    }, "Renaming this ", itemType, " will rename for all users.")), /* @__PURE__ */ React.createElement("div", {
      className: "text-right"
    }, /* @__PURE__ */ React.createElement(Button$1, {
      kind: "secondary",
      className: "mr-2",
      onClick: this.handleRenameCancel
    }, "Cancel"), /* @__PURE__ */ React.createElement(Button$1, {
      kind: "primary",
      type: "submit"
    }, "Rename")));
  }
  render() {
    var {
      isShown,
      onCancel
    } = this.props;
    return /* @__PURE__ */ React.createElement(Popper$1, {
      isShown,
      onEntered: this.handleRenameDialogOpened,
      onExited: onCancel,
      options: {
        placement: "bottom"
      },
      interactive: true,
      closeOnBlur: true
    }, this.renderRenameDialog());
  }
}
_defineProperty$2(RenameDialog, "defaultProps", {
  isShared: false,
  isOwner: true,
  itemType: "Item",
  value: ""
});
function _defineProperty$1(obj, key, value) {
  key = _toPropertyKey$1(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey$1(arg) {
  var key = _toPrimitive$1(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive$1(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
var log$2 = Log$1.module("Panel");
class Panel extends React.PureComponent {
  constructor(props) {
    super(props);
    _defineProperty$1(this, "getAdditionActions", memoizeOne((actions, isClonable, isRenamable) => {
      var additionalActions = [];
      if (isClonable) {
        additionalActions.push(this.getCloneAction());
      }
      if (isRenamable) {
        additionalActions.push(this.getRenameAction());
      }
      return [...additionalActions, ...actions];
    }));
    this.handleClearAllFilters = this.handleClearAllFilters.bind(this);
    this.handleCopyPanel = this.handleCopyPanel.bind(this);
    this.handleFocus = this.handleFocus.bind(this);
    this.handleBlur = this.handleBlur.bind(this);
    this.handleHide = this.handleHide.bind(this);
    this.handleResize = this.handleResize.bind(this);
    this.handleSessionClosed = this.handleSessionClosed.bind(this);
    this.handleSessionOpened = this.handleSessionOpened.bind(this);
    this.handleBeforeShow = this.handleBeforeShow.bind(this);
    this.handleShow = this.handleShow.bind(this);
    this.handleTabBlur = this.handleTabBlur.bind(this);
    this.handleTabFocus = this.handleTabFocus.bind(this);
    this.handleRenameCancel = this.handleRenameCancel.bind(this);
    this.handleRenameSubmit = this.handleRenameSubmit.bind(this);
    this.handleShowRenameDialog = this.handleShowRenameDialog.bind(this);
    this.handleTabClicked = this.handleTabClicked.bind(this);
    this.handleTab = this.handleTab.bind(this);
    var {
      glContainer
    } = this.props;
    this.state = {
      title: LayoutUtils2.getTitleFromContainer(glContainer),
      showRenameDialog: false
    };
  }
  componentDidMount() {
    var {
      componentPanel,
      glContainer,
      glEventHub
    } = this.props;
    glContainer.on("resize", this.handleResize);
    glContainer.on("show", this.handleBeforeShow);
    glContainer.on("shown", this.handleShow);
    glContainer.on("hide", this.handleHide);
    glContainer.on("tab", this.handleTab);
    glContainer.on("tabClicked", this.handleTabClicked);
    glEventHub.on(ConsoleEvent$1.SESSION_CLOSED, this.handleSessionClosed);
    glEventHub.on(ConsoleEvent$1.SESSION_OPENED, this.handleSessionOpened);
    glEventHub.on(TabEvent$1.focus, this.handleTabFocus);
    glEventHub.on(TabEvent$1.blur, this.handleTabBlur);
    glEventHub.on(InputFilterEvent$1.CLEAR_ALL_FILTERS, this.handleClearAllFilters);
    glEventHub.emit(PanelEvent.MOUNT, componentPanel);
  }
  componentWillUnmount() {
    var {
      componentPanel,
      glContainer,
      glEventHub
    } = this.props;
    glContainer.off("resize", this.handleResize);
    glContainer.off("show", this.handleBeforeShow);
    glContainer.off("shown", this.handleShow);
    glContainer.off("hide", this.handleHide);
    glContainer.off("tab", this.handleTab);
    glContainer.off("tabClicked", this.handleTabClicked);
    glEventHub.off(ConsoleEvent$1.SESSION_CLOSED, this.handleSessionClosed);
    glEventHub.off(ConsoleEvent$1.SESSION_OPENED, this.handleSessionOpened);
    glEventHub.off(TabEvent$1.focus, this.handleTabFocus);
    glEventHub.off(TabEvent$1.blur, this.handleTabBlur);
    glEventHub.off(InputFilterEvent$1.CLEAR_ALL_FILTERS, this.handleClearAllFilters);
    glEventHub.emit(PanelEvent.UNMOUNT, componentPanel);
  }
  handleTab(tab) {
    if (tab != null) {
      this.setState({
        title: LayoutUtils2.getTitleFromTab(tab)
      });
    }
    this.forceUpdate();
    var {
      onTab
    } = this.props;
    onTab(tab);
  }
  handleTabClicked(e) {
    var {
      onTabClicked
    } = this.props;
    onTabClicked(e);
  }
  handleClearAllFilters() {
    var {
      onClearAllFilters
    } = this.props;
    onClearAllFilters(...arguments);
  }
  handleFocus(event) {
    var {
      componentPanel,
      glEventHub
    } = this.props;
    glEventHub.emit(PanelEvent.FOCUS, componentPanel);
    var {
      onFocus
    } = this.props;
    onFocus(event);
  }
  handleBlur(event) {
    var {
      onBlur
    } = this.props;
    onBlur(event);
  }
  handleHide() {
    var {
      onHide
    } = this.props;
    onHide(...arguments);
  }
  handleResize() {
    var {
      onResize
    } = this.props;
    onResize(...arguments);
  }
  handleSessionClosed(session) {
    var {
      onSessionClose
    } = this.props;
    onSessionClose(session);
  }
  handleSessionOpened(session, params) {
    var {
      onSessionOpen
    } = this.props;
    onSessionOpen(session, params);
  }
  handleBeforeShow() {
    var {
      onBeforeShow
    } = this.props;
    onBeforeShow(...arguments);
  }
  handleShow() {
    var {
      onShow
    } = this.props;
    onShow(...arguments);
  }
  handleTabBlur() {
    var {
      onTabBlur
    } = this.props;
    onTabBlur(...arguments);
  }
  handleTabFocus() {
    var {
      onTabFocus
    } = this.props;
    onTabFocus(...arguments);
  }
  handleRenameCancel() {
    this.setState({
      showRenameDialog: false
    });
  }
  handleShowRenameDialog() {
    this.setState({
      showRenameDialog: true
    });
  }
  handleRenameSubmit(newTitle) {
    var {
      glContainer
    } = this.props;
    this.setState({
      showRenameDialog: false,
      title: newTitle
    });
    var root2 = LayoutUtils2.getRootFromContainer(glContainer);
    var config2 = LayoutUtils2.getComponentConfigFromContainer(glContainer);
    assertNotNull(config2);
    LayoutUtils2.renameComponent(root2, config2, newTitle);
  }
  handleCopyPanel() {
    var {
      glContainer,
      glEventHub
    } = this.props;
    var root2 = LayoutUtils2.getRootFromContainer(glContainer);
    var config2 = LayoutUtils2.getComponentConfigFromContainer(glContainer);
    if (config2 == null) {
      log$2.error("Could not get component config from container", glContainer);
      return;
    }
    var cloneConfig = LayoutUtils2.cloneComponent(root2, config2);
    if (cloneConfig !== null) {
      glEventHub.emit(PanelEvent.CLONED, this, cloneConfig);
    }
  }
  getCloneAction() {
    return {
      title: "Copy Panel",
      order: 10,
      group: ContextActions$1.groups.high,
      action: this.handleCopyPanel
    };
  }
  getRenameAction() {
    return {
      title: "Rename",
      order: 10,
      group: ContextActions$1.groups.medium,
      action: this.handleShowRenameDialog
    };
  }
  render() {
    var {
      children,
      className,
      renderTabTooltip,
      glContainer,
      additionalActions,
      errorMessage,
      isLoaded,
      isLoading,
      isClonable,
      isRenamable
    } = this.props;
    var {
      tab: glTab
    } = glContainer;
    var {
      showRenameDialog,
      title
    } = this.state;
    return /* @__PURE__ */ React.createElement("div", {
      className: classnamesExports("h-100 w-100 iris-panel", className),
      onFocusCapture: this.handleFocus,
      onBlurCapture: this.handleBlur
    }, children, /* @__PURE__ */ React.createElement(LoadingOverlay, {
      errorMessage,
      isLoaded,
      isLoading
    }), glTab != null && /* @__PURE__ */ ReactDOM.createPortal(
      /* @__PURE__ */ React.createElement(React.Fragment, null, /* @__PURE__ */ React.createElement(PanelContextMenu$1, {
        glContainer,
        additionalActions: this.getAdditionActions(additionalActions, isClonable, isRenamable)
      }), isRenamable && /* @__PURE__ */ React.createElement(RenameDialog, {
        isShown: showRenameDialog,
        value: title,
        itemType: "Panel",
        onCancel: this.handleRenameCancel,
        onSubmit: this.handleRenameSubmit
      }), renderTabTooltip != null && /* @__PURE__ */ React.createElement(Tooltip$1, {
        interactive: true,
        options: {
          placement: "bottom"
        },
        popperClassName: "panel-tab-popper"
      }, renderTabTooltip())),
      glTab.element[0]
      // tab.element is jquery element, we want a dom element
    ));
  }
}
_defineProperty$1(Panel, "defaultProps", {
  className: "",
  onTab: () => void 0,
  onTabClicked: () => void 0,
  onClearAllFilters: () => void 0,
  onFocus: () => void 0,
  onBlur: () => void 0,
  onHide: () => void 0,
  onResize: () => void 0,
  onSessionClose: () => void 0,
  onSessionOpen: () => void 0,
  onBeforeShow: () => void 0,
  onShow: () => void 0,
  onTabBlur: () => void 0,
  onTabFocus: () => void 0,
  renderTabTooltip: null,
  additionalActions: [],
  errorMessage: null,
  isLoading: false,
  isLoaded: true,
  isClonable: false,
  isRenamable: false
});
const Panel$1 = Panel;
const WidgetPanelTooltip$1 = "";
function WidgetPanelTooltip(props) {
  var {
    widgetType,
    widgetName,
    glContainer,
    description,
    children
  } = props;
  var panelTitle = LayoutUtils2.getTitleFromContainer(glContainer);
  return /* @__PURE__ */ React.createElement("div", {
    className: "tab-tooltip-container"
  }, /* @__PURE__ */ React.createElement("div", {
    className: "row flex-nowrap align-items-start"
  }, /* @__PURE__ */ React.createElement("span", {
    className: "tab-tooltip-title"
  }, /* @__PURE__ */ React.createElement("b", null, widgetType, " Name ")), /* @__PURE__ */ React.createElement("span", {
    className: "tab-tooltip-name"
  }, widgetName), /* @__PURE__ */ React.createElement(CopyButton, {
    className: "tab-tooltip-copy",
    tooltip: "Copy name",
    copy: widgetName
  })), widgetName !== panelTitle && /* @__PURE__ */ React.createElement("div", {
    className: "row"
  }, /* @__PURE__ */ React.createElement("span", {
    className: "tab-tooltip-title"
  }, /* @__PURE__ */ React.createElement("b", null, "Display Name")), /* @__PURE__ */ React.createElement("span", {
    className: "tab-tooltip-name"
  }, panelTitle)), description && /* @__PURE__ */ React.createElement("div", {
    className: "row"
  }, /* @__PURE__ */ React.createElement("span", {
    className: "tab-tooltip-description"
  }, description)), children);
}
WidgetPanelTooltip.propTypes = {
  glContainer: GLPropTypes.Container.isRequired,
  widgetType: propTypesExports.string,
  widgetName: propTypesExports.string,
  description: propTypesExports.string,
  children: propTypesExports.node
};
WidgetPanelTooltip.defaultProps = {
  widgetType: "",
  widgetName: "",
  description: null,
  children: null
};
const WidgetPanel$2 = "";
function _defineProperty(obj, key, value) {
  key = _toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, { value, enumerable: true, configurable: true, writable: true });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _toPropertyKey(arg) {
  var key = _toPrimitive(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}
function _toPrimitive(input, hint) {
  if (typeof input !== "object" || input === null)
    return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== void 0) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object")
      return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
class WidgetPanel extends React.PureComponent {
  constructor(props) {
    super(props);
    _defineProperty(this, "getCachedRenderTabTooltip", memoizeOne((showTabTooltip, glContainer, widgetType, widgetName, description) => showTabTooltip ? () => /* @__PURE__ */ React.createElement(WidgetPanelTooltip, {
      glContainer,
      widgetType,
      widgetName,
      description
    }) : null));
    this.handleSessionClosed = this.handleSessionClosed.bind(this);
    this.handleSessionOpened = this.handleSessionOpened.bind(this);
    this.handleCopyName = this.handleCopyName.bind(this);
    this.state = {
      isClientDisconnected: false,
      isPanelDisconnected: false,
      isWidgetDisconnected: false,
      isWaitingForReconnect: false,
      isPanelInactive: false
    };
  }
  handleCopyName() {
    var {
      widgetName
    } = this.props;
    copyToClipboard(widgetName);
  }
  getErrorMessage() {
    var {
      errorMessage
    } = this.props;
    var {
      isClientDisconnected,
      isPanelDisconnected,
      isWidgetDisconnected,
      isWaitingForReconnect
    } = this.state;
    if (errorMessage) {
      return "".concat(errorMessage);
    }
    if (isClientDisconnected && isPanelDisconnected && isWaitingForReconnect) {
      return "Disconnected from server.\nCheck your internet connection.";
    }
    if (isClientDisconnected && isPanelDisconnected) {
      return "Disconnected from server.";
    }
    if (isPanelDisconnected) {
      var {
        widgetName,
        widgetType
      } = this.props;
      return 'Variable "'.concat(widgetName, '" not set.\n').concat(widgetType, " does not exist yet.");
    }
    if (isWidgetDisconnected) {
      var {
        widgetName: _widgetName
      } = this.props;
      return "".concat(_widgetName, " is unavailable.");
    }
    return void 0;
  }
  handleSessionClosed() {
    var {
      onSessionClose
    } = this.props;
    this.setState({
      isPanelDisconnected: true,
      isWaitingForReconnect: false
    });
    onSessionClose(...arguments);
  }
  handleSessionOpened() {
    var {
      onSessionOpen
    } = this.props;
    onSessionOpen(...arguments);
  }
  render() {
    var {
      children,
      className,
      componentPanel,
      isLoaded,
      isLoading,
      glContainer,
      glEventHub,
      isDisconnected,
      isClonable,
      isRenamable,
      showTabTooltip,
      renderTabTooltip,
      widgetType,
      widgetName,
      description,
      onClearAllFilters,
      onHide,
      onFocus,
      onBlur,
      onResize,
      onShow,
      onTabBlur,
      onTabFocus,
      onTabClicked
    } = this.props;
    var {
      isPanelDisconnected,
      isWidgetDisconnected,
      isPanelInactive
    } = this.state;
    var errorMessage = this.getErrorMessage();
    var doRenderTabTooltip = renderTabTooltip !== null && renderTabTooltip !== void 0 ? renderTabTooltip : this.getCachedRenderTabTooltip(showTabTooltip, glContainer, widgetType, widgetName, description);
    var additionalActions = [{
      title: "Copy ".concat(widgetType, " Name"),
      group: ContextActions$1.groups.medium,
      order: 20,
      action: this.handleCopyName
    }];
    return /* @__PURE__ */ React.createElement(Panel$1, {
      className: classnamesExports(className, {
        disconnected: isPanelDisconnected || isWidgetDisconnected || isDisconnected,
        inactive: isPanelInactive
      }),
      componentPanel,
      glContainer,
      glEventHub,
      onClearAllFilters,
      onHide,
      onFocus,
      onBlur,
      onResize,
      onShow,
      onSessionClose: this.handleSessionClosed,
      onSessionOpen: this.handleSessionOpened,
      onTabBlur,
      onTabFocus,
      onTabClicked,
      renderTabTooltip: doRenderTabTooltip,
      errorMessage,
      isLoaded,
      isLoading,
      isClonable,
      isRenamable,
      additionalActions
    }, children, isPanelInactive && /* @__PURE__ */ React.createElement("div", {
      className: "fill-parent-absolute"
    }));
  }
}
_defineProperty(WidgetPanel, "defaultProps", {
  className: "",
  errorMessage: null,
  isClonable: true,
  isDisconnected: false,
  isLoading: false,
  isLoaded: true,
  isRenamable: true,
  showTabTooltip: true,
  widgetName: "Widget",
  widgetType: "Widget",
  renderTabTooltip: null,
  description: "",
  onFocus: () => void 0,
  onBlur: () => void 0,
  onHide: () => void 0,
  onClearAllFilters: () => void 0,
  onResize: () => void 0,
  onSessionClose: () => void 0,
  onSessionOpen: () => void 0,
  onShow: () => void 0,
  onTabBlur: () => void 0,
  onTabFocus: () => void 0,
  onTabClicked: () => void 0
});
const WidgetPanel$1 = WidgetPanel;
var plotly_minExports = {};
var plotly_min = {
  get exports() {
    return plotly_minExports;
  },
  set exports(v) {
    plotly_minExports = v;
  }
};
(function(module2, exports2) {
  /*! For license information please see plotly.min.js.LICENSE.txt */
  !function(t, e) {
    module2.exports = e();
  }(self, function() {
    return function() {
      var t = { 98847: function(t2, e2, r2) {
        var n2 = r2(71828), i = { "X,X div": 'direction:ltr;font-family:"Open Sans",verdana,arial,sans-serif;margin:0;padding:0;', "X input,X button": 'font-family:"Open Sans",verdana,arial,sans-serif;', "X input:focus,X button:focus": "outline:none;", "X a": "text-decoration:none;", "X a:hover": "text-decoration:none;", "X .crisp": "shape-rendering:crispEdges;", "X .user-select-none": "-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;-o-user-select:none;user-select:none;", "X svg": "overflow:hidden;", "X svg a": "fill:#447adb;", "X svg a:hover": "fill:#3c6dc5;", "X .main-svg": "position:absolute;top:0;left:0;pointer-events:none;", "X .main-svg .draglayer": "pointer-events:all;", "X .cursor-default": "cursor:default;", "X .cursor-pointer": "cursor:pointer;", "X .cursor-crosshair": "cursor:crosshair;", "X .cursor-move": "cursor:move;", "X .cursor-col-resize": "cursor:col-resize;", "X .cursor-row-resize": "cursor:row-resize;", "X .cursor-ns-resize": "cursor:ns-resize;", "X .cursor-ew-resize": "cursor:ew-resize;", "X .cursor-sw-resize": "cursor:sw-resize;", "X .cursor-s-resize": "cursor:s-resize;", "X .cursor-se-resize": "cursor:se-resize;", "X .cursor-w-resize": "cursor:w-resize;", "X .cursor-e-resize": "cursor:e-resize;", "X .cursor-nw-resize": "cursor:nw-resize;", "X .cursor-n-resize": "cursor:n-resize;", "X .cursor-ne-resize": "cursor:ne-resize;", "X .cursor-grab": "cursor:-webkit-grab;cursor:grab;", "X .modebar": "position:absolute;top:2px;right:2px;", "X .ease-bg": "-webkit-transition:background-color .3s ease 0s;-moz-transition:background-color .3s ease 0s;-ms-transition:background-color .3s ease 0s;-o-transition:background-color .3s ease 0s;transition:background-color .3s ease 0s;", "X .modebar--hover>:not(.watermark)": "opacity:0;-webkit-transition:opacity .3s ease 0s;-moz-transition:opacity .3s ease 0s;-ms-transition:opacity .3s ease 0s;-o-transition:opacity .3s ease 0s;transition:opacity .3s ease 0s;", "X:hover .modebar--hover .modebar-group": "opacity:1;", "X .modebar-group": "float:left;display:inline-block;box-sizing:border-box;padding-left:8px;position:relative;vertical-align:middle;white-space:nowrap;", "X .modebar-btn": "position:relative;font-size:16px;padding:3px 4px;height:22px;cursor:pointer;line-height:normal;box-sizing:border-box;", "X .modebar-btn svg": "position:relative;top:2px;", "X .modebar.vertical": "display:flex;flex-direction:column;flex-wrap:wrap;align-content:flex-end;max-height:100%;", "X .modebar.vertical svg": "top:-1px;", "X .modebar.vertical .modebar-group": "display:block;float:none;padding-left:0px;padding-bottom:8px;", "X .modebar.vertical .modebar-group .modebar-btn": "display:block;text-align:center;", "X [data-title]:before,X [data-title]:after": "position:absolute;-webkit-transform:translate3d(0, 0, 0);-moz-transform:translate3d(0, 0, 0);-ms-transform:translate3d(0, 0, 0);-o-transform:translate3d(0, 0, 0);transform:translate3d(0, 0, 0);display:none;opacity:0;z-index:1001;pointer-events:none;top:110%;right:50%;", "X [data-title]:hover:before,X [data-title]:hover:after": "display:block;opacity:1;", "X [data-title]:before": 'content:"";position:absolute;background:rgba(0,0,0,0);border:6px solid rgba(0,0,0,0);z-index:1002;margin-top:-12px;border-bottom-color:#69738a;margin-right:-6px;', "X [data-title]:after": "content:attr(data-title);background:#69738a;color:#fff;padding:8px 10px;font-size:12px;line-height:12px;white-space:nowrap;margin-right:-18px;border-radius:2px;", "X .vertical [data-title]:before,X .vertical [data-title]:after": "top:0%;right:200%;", "X .vertical [data-title]:before": "border:6px solid rgba(0,0,0,0);border-left-color:#69738a;margin-top:8px;margin-right:-30px;", Y: 'font-family:"Open Sans",verdana,arial,sans-serif;position:fixed;top:50px;right:20px;z-index:10000;font-size:10pt;max-width:180px;', "Y p": "margin:0;", "Y .notifier-note": "min-width:180px;max-width:250px;border:1px solid #fff;z-index:3000;margin:0;background-color:#8c97af;background-color:rgba(140,151,175,.9);color:#fff;padding:10px;overflow-wrap:break-word;word-wrap:break-word;-ms-hyphens:auto;-webkit-hyphens:auto;hyphens:auto;", "Y .notifier-close": "color:#fff;opacity:.8;float:right;padding:0 5px;background:none;border:none;font-size:20px;font-weight:bold;line-height:20px;", "Y .notifier-close:hover": "color:#444;text-decoration:none;cursor:pointer;" };
        for (var a in i) {
          var o = a.replace(/^,/, " ,").replace(/X/g, ".js-plotly-plot .plotly").replace(/Y/g, ".plotly-notifier");
          n2.addStyleRule(o, i[a]);
        }
      }, 98222: function(t2, e2, r2) {
        t2.exports = r2(82887);
      }, 27206: function(t2, e2, r2) {
        t2.exports = r2(60822);
      }, 59893: function(t2, e2, r2) {
        t2.exports = r2(23381);
      }, 5224: function(t2, e2, r2) {
        t2.exports = r2(83832);
      }, 59509: function(t2, e2, r2) {
        t2.exports = r2(72201);
      }, 75557: function(t2, e2, r2) {
        t2.exports = r2(91815);
      }, 40338: function(t2, e2, r2) {
        t2.exports = r2(21462);
      }, 35080: function(t2, e2, r2) {
        t2.exports = r2(51319);
      }, 61396: function(t2, e2, r2) {
        t2.exports = r2(57516);
      }, 40549: function(t2, e2, r2) {
        t2.exports = r2(98128);
      }, 49866: function(t2, e2, r2) {
        t2.exports = r2(99442);
      }, 36089: function(t2, e2, r2) {
        t2.exports = r2(93740);
      }, 19548: function(t2, e2, r2) {
        t2.exports = r2(8729);
      }, 35831: function(t2, e2, r2) {
        t2.exports = r2(93814);
      }, 61039: function(t2, e2, r2) {
        t2.exports = r2(14382);
      }, 97040: function(t2, e2, r2) {
        t2.exports = r2(51759);
      }, 77986: function(t2, e2, r2) {
        t2.exports = r2(10421);
      }, 24296: function(t2, e2, r2) {
        t2.exports = r2(43102);
      }, 58872: function(t2, e2, r2) {
        t2.exports = r2(92165);
      }, 29626: function(t2, e2, r2) {
        t2.exports = r2(3325);
      }, 65591: function(t2, e2, r2) {
        t2.exports = r2(36071);
      }, 69738: function(t2, e2, r2) {
        t2.exports = r2(43905);
      }, 92650: function(t2, e2, r2) {
        t2.exports = r2(35902);
      }, 35630: function(t2, e2, r2) {
        t2.exports = r2(69816);
      }, 73434: function(t2, e2, r2) {
        t2.exports = r2(94507);
      }, 27909: function(t2, e2, r2) {
        var n2 = r2(19548);
        n2.register([r2(27206), r2(5224), r2(58872), r2(65591), r2(69738), r2(92650), r2(49866), r2(25743), r2(6197), r2(97040), r2(85461), r2(73434), r2(54201), r2(81299), r2(47645), r2(35630), r2(77986), r2(83043), r2(93005), r2(96881), r2(4534), r2(50581), r2(40549), r2(77900), r2(47582), r2(35080), r2(21641), r2(17280), r2(5861), r2(29626), r2(10021), r2(65317), r2(96268), r2(61396), r2(35831), r2(16122), r2(46163), r2(40344), r2(40338), r2(48131), r2(36089), r2(55334), r2(75557), r2(19440), r2(99488), r2(59893), r2(97393), r2(98222), r2(61039), r2(24296), r2(66398), r2(59509)]), t2.exports = n2;
      }, 46163: function(t2, e2, r2) {
        t2.exports = r2(15154);
      }, 96881: function(t2, e2, r2) {
        t2.exports = r2(64943);
      }, 50581: function(t2, e2, r2) {
        t2.exports = r2(21164);
      }, 55334: function(t2, e2, r2) {
        t2.exports = r2(54186);
      }, 65317: function(t2, e2, r2) {
        t2.exports = r2(94873);
      }, 10021: function(t2, e2, r2) {
        t2.exports = r2(67618);
      }, 54201: function(t2, e2, r2) {
        t2.exports = r2(58810);
      }, 5861: function(t2, e2, r2) {
        t2.exports = r2(20593);
      }, 16122: function(t2, e2, r2) {
        t2.exports = r2(29396);
      }, 83043: function(t2, e2, r2) {
        t2.exports = r2(13551);
      }, 48131: function(t2, e2, r2) {
        t2.exports = r2(46858);
      }, 47582: function(t2, e2, r2) {
        t2.exports = r2(17988);
      }, 21641: function(t2, e2, r2) {
        t2.exports = r2(68868);
      }, 96268: function(t2, e2, r2) {
        t2.exports = r2(20467);
      }, 19440: function(t2, e2, r2) {
        t2.exports = r2(91271);
      }, 99488: function(t2, e2, r2) {
        t2.exports = r2(21461);
      }, 97393: function(t2, e2, r2) {
        t2.exports = r2(85956);
      }, 25743: function(t2, e2, r2) {
        t2.exports = r2(52979);
      }, 66398: function(t2, e2, r2) {
        t2.exports = r2(32275);
      }, 17280: function(t2, e2, r2) {
        t2.exports = r2(6419);
      }, 77900: function(t2, e2, r2) {
        t2.exports = r2(61510);
      }, 81299: function(t2, e2, r2) {
        t2.exports = r2(87619);
      }, 93005: function(t2, e2, r2) {
        t2.exports = r2(93601);
      }, 40344: function(t2, e2, r2) {
        t2.exports = r2(96595);
      }, 47645: function(t2, e2, r2) {
        t2.exports = r2(70954);
      }, 6197: function(t2, e2, r2) {
        t2.exports = r2(47462);
      }, 4534: function(t2, e2, r2) {
        t2.exports = r2(17659);
      }, 85461: function(t2, e2, r2) {
        t2.exports = r2(19990);
      }, 82884: function(t2) {
        t2.exports = [{ path: "", backoff: 0 }, { path: "M-2.4,-3V3L0.6,0Z", backoff: 0.6 }, { path: "M-3.7,-2.5V2.5L1.3,0Z", backoff: 1.3 }, { path: "M-4.45,-3L-1.65,-0.2V0.2L-4.45,3L1.55,0Z", backoff: 1.55 }, { path: "M-2.2,-2.2L-0.2,-0.2V0.2L-2.2,2.2L-1.4,3L1.6,0L-1.4,-3Z", backoff: 1.6 }, { path: "M-4.4,-2.1L-0.6,-0.2V0.2L-4.4,2.1L-4,3L2,0L-4,-3Z", backoff: 2 }, { path: "M2,0A2,2 0 1,1 0,-2A2,2 0 0,1 2,0Z", backoff: 0, noRotate: true }, { path: "M2,2V-2H-2V2Z", backoff: 0, noRotate: true }];
      }, 50215: function(t2, e2, r2) {
        var n2 = r2(82884), i = r2(41940), a = r2(85555), o = r2(44467).templatedArray;
        r2(24695), t2.exports = o("annotation", { visible: { valType: "boolean", dflt: true, editType: "calc+arraydraw" }, text: { valType: "string", editType: "calc+arraydraw" }, textangle: { valType: "angle", dflt: 0, editType: "calc+arraydraw" }, font: i({ editType: "calc+arraydraw", colorEditType: "arraydraw" }), width: { valType: "number", min: 1, dflt: null, editType: "calc+arraydraw" }, height: { valType: "number", min: 1, dflt: null, editType: "calc+arraydraw" }, opacity: { valType: "number", min: 0, max: 1, dflt: 1, editType: "arraydraw" }, align: { valType: "enumerated", values: ["left", "center", "right"], dflt: "center", editType: "arraydraw" }, valign: { valType: "enumerated", values: ["top", "middle", "bottom"], dflt: "middle", editType: "arraydraw" }, bgcolor: { valType: "color", dflt: "rgba(0,0,0,0)", editType: "arraydraw" }, bordercolor: { valType: "color", dflt: "rgba(0,0,0,0)", editType: "arraydraw" }, borderpad: { valType: "number", min: 0, dflt: 1, editType: "calc+arraydraw" }, borderwidth: { valType: "number", min: 0, dflt: 1, editType: "calc+arraydraw" }, showarrow: { valType: "boolean", dflt: true, editType: "calc+arraydraw" }, arrowcolor: { valType: "color", editType: "arraydraw" }, arrowhead: { valType: "integer", min: 0, max: n2.length, dflt: 1, editType: "arraydraw" }, startarrowhead: { valType: "integer", min: 0, max: n2.length, dflt: 1, editType: "arraydraw" }, arrowside: { valType: "flaglist", flags: ["end", "start"], extras: ["none"], dflt: "end", editType: "arraydraw" }, arrowsize: { valType: "number", min: 0.3, dflt: 1, editType: "calc+arraydraw" }, startarrowsize: { valType: "number", min: 0.3, dflt: 1, editType: "calc+arraydraw" }, arrowwidth: { valType: "number", min: 0.1, editType: "calc+arraydraw" }, standoff: { valType: "number", min: 0, dflt: 0, editType: "calc+arraydraw" }, startstandoff: { valType: "number", min: 0, dflt: 0, editType: "calc+arraydraw" }, ax: { valType: "any", editType: "calc+arraydraw" }, ay: { valType: "any", editType: "calc+arraydraw" }, axref: { valType: "enumerated", dflt: "pixel", values: ["pixel", a.idRegex.x.toString()], editType: "calc" }, ayref: { valType: "enumerated", dflt: "pixel", values: ["pixel", a.idRegex.y.toString()], editType: "calc" }, xref: { valType: "enumerated", values: ["paper", a.idRegex.x.toString()], editType: "calc" }, x: { valType: "any", editType: "calc+arraydraw" }, xanchor: { valType: "enumerated", values: ["auto", "left", "center", "right"], dflt: "auto", editType: "calc+arraydraw" }, xshift: { valType: "number", dflt: 0, editType: "calc+arraydraw" }, yref: { valType: "enumerated", values: ["paper", a.idRegex.y.toString()], editType: "calc" }, y: { valType: "any", editType: "calc+arraydraw" }, yanchor: { valType: "enumerated", values: ["auto", "top", "middle", "bottom"], dflt: "auto", editType: "calc+arraydraw" }, yshift: { valType: "number", dflt: 0, editType: "calc+arraydraw" }, clicktoshow: { valType: "enumerated", values: [false, "onoff", "onout"], dflt: false, editType: "arraydraw" }, xclick: { valType: "any", editType: "arraydraw" }, yclick: { valType: "any", editType: "arraydraw" }, hovertext: { valType: "string", editType: "arraydraw" }, hoverlabel: { bgcolor: { valType: "color", editType: "arraydraw" }, bordercolor: { valType: "color", editType: "arraydraw" }, font: i({ editType: "arraydraw" }), editType: "arraydraw" }, captureevents: { valType: "boolean", editType: "arraydraw" }, editType: "calc", _deprecated: { ref: { valType: "string", editType: "calc" } } });
      }, 3749: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298), a = r2(92605).draw;
        function o(t3) {
          var e3 = t3._fullLayout;
          n2.filterVisible(e3.annotations).forEach(function(e4) {
            var r3 = i.getFromId(t3, e4.xref), n3 = i.getFromId(t3, e4.yref), a2 = i.getRefType(e4.xref), o2 = i.getRefType(e4.yref);
            e4._extremes = {}, "range" === a2 && s(e4, r3), "range" === o2 && s(e4, n3);
          });
        }
        function s(t3, e3) {
          var r3, n3 = e3._id, a2 = n3.charAt(0), o2 = t3[a2], s2 = t3["a" + a2], l = t3[a2 + "ref"], u = t3["a" + a2 + "ref"], c = t3["_" + a2 + "padplus"], f2 = t3["_" + a2 + "padminus"], h = { x: 1, y: -1 }[a2] * t3[a2 + "shift"], p2 = 3 * t3.arrowsize * t3.arrowwidth || 0, d2 = p2 + h, v = p2 - h, g2 = 3 * t3.startarrowsize * t3.arrowwidth || 0, y = g2 + h, m2 = g2 - h;
          if (u === l) {
            var x = i.findExtremes(e3, [e3.r2c(o2)], { ppadplus: d2, ppadminus: v }), b = i.findExtremes(e3, [e3.r2c(s2)], { ppadplus: Math.max(c, y), ppadminus: Math.max(f2, m2) });
            r3 = { min: [x.min[0], b.min[0]], max: [x.max[0], b.max[0]] };
          } else
            y = s2 ? y + s2 : y, m2 = s2 ? m2 - s2 : m2, r3 = i.findExtremes(e3, [e3.r2c(o2)], { ppadplus: Math.max(c, d2, y), ppadminus: Math.max(f2, v, m2) });
          t3._extremes[n3] = r3;
        }
        t2.exports = function(t3) {
          var e3 = t3._fullLayout;
          if (n2.filterVisible(e3.annotations).length && t3._fullData.length)
            return n2.syncOrAsync([a, o], t3);
        };
      }, 44317: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(73972), a = r2(44467).arrayEditor;
        function o(t3, e3) {
          var r3, n3, i2, a2, o2, l, u, c = t3._fullLayout.annotations, f2 = [], h = [], p2 = [], d2 = (e3 || []).length;
          for (r3 = 0; r3 < c.length; r3++)
            if (a2 = (i2 = c[r3]).clicktoshow) {
              for (n3 = 0; n3 < d2; n3++)
                if (l = (o2 = e3[n3]).xaxis, u = o2.yaxis, l._id === i2.xref && u._id === i2.yref && l.d2r(o2.x) === s(i2._xclick, l) && u.d2r(o2.y) === s(i2._yclick, u)) {
                  (i2.visible ? "onout" === a2 ? h : p2 : f2).push(r3);
                  break;
                }
              n3 === d2 && i2.visible && "onout" === a2 && h.push(r3);
            }
          return { on: f2, off: h, explicitOff: p2 };
        }
        function s(t3, e3) {
          return "log" === e3.type ? e3.l2r(t3) : e3.d2r(t3);
        }
        t2.exports = { hasClickToShow: function(t3, e3) {
          var r3 = o(t3, e3);
          return r3.on.length > 0 || r3.explicitOff.length > 0;
        }, onClick: function(t3, e3) {
          var r3, s2, l = o(t3, e3), u = l.on, c = l.off.concat(l.explicitOff), f2 = {}, h = t3._fullLayout.annotations;
          if (u.length || c.length) {
            for (r3 = 0; r3 < u.length; r3++)
              (s2 = a(t3.layout, "annotations", h[u[r3]])).modifyItem("visible", true), n2.extendFlat(f2, s2.getUpdateObj());
            for (r3 = 0; r3 < c.length; r3++)
              (s2 = a(t3.layout, "annotations", h[c[r3]])).modifyItem("visible", false), n2.extendFlat(f2, s2.getUpdateObj());
            return i.call("update", t3, {}, f2);
          }
        } };
      }, 25625: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901);
        t2.exports = function(t3, e3, r3, a) {
          a("opacity");
          var o = a("bgcolor"), s = a("bordercolor"), l = i.opacity(s);
          a("borderpad");
          var u = a("borderwidth"), c = a("showarrow");
          if (a("text", c ? " " : r3._dfltTitle.annotation), a("textangle"), n2.coerceFont(a, "font", r3.font), a("width"), a("align"), a("height") && a("valign"), c) {
            var f2, h, p2 = a("arrowside");
            -1 !== p2.indexOf("end") && (f2 = a("arrowhead"), h = a("arrowsize")), -1 !== p2.indexOf("start") && (a("startarrowhead", f2), a("startarrowsize", h)), a("arrowcolor", l ? e3.bordercolor : i.defaultLine), a("arrowwidth", 2 * (l && u || 1)), a("standoff"), a("startstandoff");
          }
          var d2 = a("hovertext"), v = r3.hoverlabel || {};
          if (d2) {
            var g2 = a("hoverlabel.bgcolor", v.bgcolor || (i.opacity(o) ? i.rgb(o) : i.defaultLine)), y = a("hoverlabel.bordercolor", v.bordercolor || i.contrast(g2));
            n2.coerceFont(a, "hoverlabel.font", { family: v.font.family, size: v.font.size, color: v.font.color || y });
          }
          a("captureevents", !!d2);
        };
      }, 94128: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(58163);
        t2.exports = function(t3, e3, r3, a) {
          e3 = e3 || {};
          var o = "log" === r3 && "linear" === e3.type, s = "linear" === r3 && "log" === e3.type;
          if (o || s)
            for (var l, u, c = t3._fullLayout.annotations, f2 = e3._id.charAt(0), h = 0; h < c.length; h++)
              l = c[h], u = "annotations[" + h + "].", l[f2 + "ref"] === e3._id && p2(f2), l["a" + f2 + "ref"] === e3._id && p2("a" + f2);
          function p2(t4) {
            var r4 = l[t4], s2 = null;
            s2 = o ? i(r4, e3.range) : Math.pow(10, r4), n2(s2) || (s2 = null), a(u + t4, s2);
          }
        };
      }, 84046: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298), a = r2(85501), o = r2(25625), s = r2(50215);
        function l(t3, e3, r3) {
          function a2(r4, i2) {
            return n2.coerce(t3, e3, s, r4, i2);
          }
          var l2 = a2("visible"), u = a2("clicktoshow");
          if (l2 || u) {
            o(t3, e3, r3, a2);
            for (var c = e3.showarrow, f2 = ["x", "y"], h = [-10, -30], p2 = { _fullLayout: r3 }, d2 = 0; d2 < 2; d2++) {
              var v = f2[d2], g2 = i.coerceRef(t3, e3, p2, v, "", "paper");
              if ("paper" !== g2 && i.getFromId(p2, g2)._annIndices.push(e3._index), i.coercePosition(e3, p2, a2, g2, v, 0.5), c) {
                var y = "a" + v, m2 = i.coerceRef(t3, e3, p2, y, "pixel", ["pixel", "paper"]);
                "pixel" !== m2 && m2 !== g2 && (m2 = e3[y] = "pixel");
                var x = "pixel" === m2 ? h[d2] : 0.4;
                i.coercePosition(e3, p2, a2, m2, y, x);
              }
              a2(v + "anchor"), a2(v + "shift");
            }
            if (n2.noneOrAll(t3, e3, ["x", "y"]), c && n2.noneOrAll(t3, e3, ["ax", "ay"]), u) {
              var b = a2("xclick"), _ = a2("yclick");
              e3._xclick = void 0 === b ? e3.x : i.cleanPosition(b, p2, e3.xref), e3._yclick = void 0 === _ ? e3.y : i.cleanPosition(_, p2, e3.yref);
            }
          }
        }
        t2.exports = function(t3, e3) {
          a(t3, e3, { name: "annotations", handleItemDefaults: l });
        };
      }, 92605: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(73972), a = r2(74875), o = r2(71828), s = o.strTranslate, l = r2(89298), u = r2(7901), c = r2(91424), f2 = r2(30211), h = r2(63893), p2 = r2(6964), d2 = r2(28569), v = r2(44467).arrayEditor, g2 = r2(13011);
        function y(t3, e3) {
          var r3 = t3._fullLayout.annotations[e3] || {}, n3 = l.getFromId(t3, r3.xref), i2 = l.getFromId(t3, r3.yref);
          n3 && n3.setScale(), i2 && i2.setScale(), x(t3, r3, e3, false, n3, i2);
        }
        function m2(t3, e3, r3, n3, i2) {
          var a2 = i2[r3], o2 = i2[r3 + "ref"], s2 = -1 !== r3.indexOf("y"), u2 = "domain" === l.getRefType(o2), c2 = s2 ? n3.h : n3.w;
          return t3 ? u2 ? a2 + (s2 ? -e3 : e3) / t3._length : t3.p2r(t3.r2p(a2) + e3) : a2 + (s2 ? -e3 : e3) / c2;
        }
        function x(t3, e3, r3, a2, y2, x2) {
          var b, _, w2 = t3._fullLayout, T = t3._fullLayout._size, k = t3._context.edits;
          a2 ? (b = "annotation-" + a2, _ = a2 + ".annotations") : (b = "annotation", _ = "annotations");
          var A = v(t3.layout, _, e3), M = A.modifyBase, S = A.modifyItem, E = A.getUpdateObj;
          w2._infolayer.selectAll("." + b + '[data-index="' + r3 + '"]').remove();
          var L = "clip" + w2._uid + "_ann" + r3;
          if (e3._input && false !== e3.visible) {
            var C = { x: {}, y: {} }, P = +e3.textangle || 0, O = w2._infolayer.append("g").classed(b, true).attr("data-index", String(r3)).style("opacity", e3.opacity), I = O.append("g").classed("annotation-text-g", true), D = k[e3.showarrow ? "annotationTail" : "annotationPosition"], z = e3.captureevents || k.annotationText || D, R = I.append("g").style("pointer-events", z ? "all" : null).call(p2, "pointer").on("click", function() {
              t3._dragging = false, t3.emit("plotly_clickannotation", Z(n2.event));
            });
            e3.hovertext && R.on("mouseover", function() {
              var r4 = e3.hoverlabel, n3 = r4.font, i2 = this.getBoundingClientRect(), a3 = t3.getBoundingClientRect();
              f2.loneHover({ x0: i2.left - a3.left, x1: i2.right - a3.left, y: (i2.top + i2.bottom) / 2 - a3.top, text: e3.hovertext, color: r4.bgcolor, borderColor: r4.bordercolor, fontFamily: n3.family, fontSize: n3.size, fontColor: n3.color }, { container: w2._hoverlayer.node(), outerContainer: w2._paper.node(), gd: t3 });
            }).on("mouseout", function() {
              f2.loneUnhover(w2._hoverlayer.node());
            });
            var F = e3.borderwidth, B = e3.borderpad, N = F + B, j = R.append("rect").attr("class", "bg").style("stroke-width", F + "px").call(u.stroke, e3.bordercolor).call(u.fill, e3.bgcolor), U = e3.width || e3.height, V = w2._topclips.selectAll("#" + L).data(U ? [0] : []);
            V.enter().append("clipPath").classed("annclip", true).attr("id", L).append("rect"), V.exit().remove();
            var H = e3.font, q2 = w2._meta ? o.templateString(e3.text, w2._meta) : e3.text, G = R.append("text").classed("annotation-text", true).text(q2);
            k.annotationText ? G.call(h.makeEditable, { delegate: R, gd: t3 }).call(Y).on("edit", function(r4) {
              e3.text = r4, this.call(Y), S("text", r4), y2 && y2.autorange && M(y2._name + ".autorange", true), x2 && x2.autorange && M(x2._name + ".autorange", true), i.call("_guiRelayout", t3, E());
            }) : G.call(Y);
          } else
            n2.selectAll("#" + L).remove();
          function Z(t4) {
            var n3 = { index: r3, annotation: e3._input, fullAnnotation: e3, event: t4 };
            return a2 && (n3.subplotId = a2), n3;
          }
          function Y(r4) {
            return r4.call(c.font, H).attr({ "text-anchor": { left: "start", right: "end" }[e3.align] || "middle" }), h.convertToTspans(r4, t3, W), r4;
          }
          function W() {
            var r4 = G.selectAll("a");
            1 === r4.size() && r4.text() === G.text() && R.insert("a", ":first-child").attr({ "xlink:xlink:href": r4.attr("xlink:href"), "xlink:xlink:show": r4.attr("xlink:show") }).style({ cursor: "pointer" }).node().appendChild(j.node());
            var n3 = R.select(".annotation-text-math-group"), f3 = !n3.empty(), v2 = c.bBox((f3 ? n3 : G).node()), b2 = v2.width, _2 = v2.height, A2 = e3.width || b2, z2 = e3.height || _2, B2 = Math.round(A2 + 2 * N), H2 = Math.round(z2 + 2 * N);
            function q3(t4, e4) {
              return "auto" === e4 && (e4 = t4 < 1 / 3 ? "left" : t4 > 2 / 3 ? "right" : "center"), { center: 0, middle: 0, left: 0.5, bottom: -0.5, right: -0.5, top: 0.5 }[e4];
            }
            for (var Y2 = false, W2 = ["x", "y"], X = 0; X < W2.length; X++) {
              var J, K, $, Q, tt, et = W2[X], rt = e3[et + "ref"] || et, nt = e3["a" + et + "ref"], it = { x: y2, y: x2 }[et], at = (P + ("x" === et ? 0 : -90)) * Math.PI / 180, ot = B2 * Math.cos(at), st = H2 * Math.sin(at), lt = Math.abs(ot) + Math.abs(st), ut = e3[et + "anchor"], ct = e3[et + "shift"] * ("x" === et ? 1 : -1), ft = C[et], ht = l.getRefType(rt);
              if (it && "domain" !== ht) {
                var pt = it.r2fraction(e3[et]);
                (pt < 0 || pt > 1) && (nt === rt ? ((pt = it.r2fraction(e3["a" + et])) < 0 || pt > 1) && (Y2 = true) : Y2 = true), J = it._offset + it.r2p(e3[et]), Q = 0.5;
              } else {
                var dt = "domain" === ht;
                "x" === et ? ($ = e3[et], J = dt ? it._offset + it._length * $ : J = T.l + T.w * $) : ($ = 1 - e3[et], J = dt ? it._offset + it._length * $ : J = T.t + T.h * $), Q = e3.showarrow ? 0.5 : $;
              }
              if (e3.showarrow) {
                ft.head = J;
                var vt = e3["a" + et];
                if (tt = ot * q3(0.5, e3.xanchor) - st * q3(0.5, e3.yanchor), nt === rt) {
                  var gt = l.getRefType(nt);
                  "domain" === gt ? ("y" === et && (vt = 1 - vt), ft.tail = it._offset + it._length * vt) : "paper" === gt ? "y" === et ? (vt = 1 - vt, ft.tail = T.t + T.h * vt) : ft.tail = T.l + T.w * vt : ft.tail = it._offset + it.r2p(vt), K = tt;
                } else
                  ft.tail = J + vt, K = tt + vt;
                ft.text = ft.tail + tt;
                var yt = w2["x" === et ? "width" : "height"];
                if ("paper" === rt && (ft.head = o.constrain(ft.head, 1, yt - 1)), "pixel" === nt) {
                  var mt = -Math.max(ft.tail - 3, ft.text), xt = Math.min(ft.tail + 3, ft.text) - yt;
                  mt > 0 ? (ft.tail += mt, ft.text += mt) : xt > 0 && (ft.tail -= xt, ft.text -= xt);
                }
                ft.tail += ct, ft.head += ct;
              } else
                K = tt = lt * q3(Q, ut), ft.text = J + tt;
              ft.text += ct, tt += ct, K += ct, e3["_" + et + "padplus"] = lt / 2 + K, e3["_" + et + "padminus"] = lt / 2 - K, e3["_" + et + "size"] = lt, e3["_" + et + "shift"] = tt;
            }
            if (Y2)
              R.remove();
            else {
              var bt = 0, _t = 0;
              if ("left" !== e3.align && (bt = (A2 - b2) * ("center" === e3.align ? 0.5 : 1)), "top" !== e3.valign && (_t = (z2 - _2) * ("middle" === e3.valign ? 0.5 : 1)), f3)
                n3.select("svg").attr({ x: N + bt - 1, y: N + _t }).call(c.setClipUrl, U ? L : null, t3);
              else {
                var wt = N + _t - v2.top, Tt = N + bt - v2.left;
                G.call(h.positionText, Tt, wt).call(c.setClipUrl, U ? L : null, t3);
              }
              V.select("rect").call(c.setRect, N, N, A2, z2), j.call(c.setRect, F / 2, F / 2, B2 - F, H2 - F), R.call(c.setTranslate, Math.round(C.x.text - B2 / 2), Math.round(C.y.text - H2 / 2)), I.attr({ transform: "rotate(" + P + "," + C.x.text + "," + C.y.text + ")" });
              var kt, At = function(r5, n4) {
                O.selectAll(".annotation-arrow-g").remove();
                var l2 = C.x.head, f4 = C.y.head, h2 = C.x.tail + r5, p3 = C.y.tail + n4, v3 = C.x.text + r5, b3 = C.y.text + n4, _3 = o.rotationXYMatrix(P, v3, b3), w3 = o.apply2DTransform(_3), A3 = o.apply2DTransform2(_3), L2 = +j.attr("width"), D2 = +j.attr("height"), z3 = v3 - 0.5 * L2, F2 = z3 + L2, B3 = b3 - 0.5 * D2, N2 = B3 + D2, U2 = [[z3, B3, z3, N2], [z3, N2, F2, N2], [F2, N2, F2, B3], [F2, B3, z3, B3]].map(A3);
                if (!U2.reduce(function(t4, e4) {
                  return t4 ^ !!o.segmentsIntersect(l2, f4, l2 + 1e6, f4 + 1e6, e4[0], e4[1], e4[2], e4[3]);
                }, false)) {
                  U2.forEach(function(t4) {
                    var e4 = o.segmentsIntersect(h2, p3, l2, f4, t4[0], t4[1], t4[2], t4[3]);
                    e4 && (h2 = e4.x, p3 = e4.y);
                  });
                  var V2 = e3.arrowwidth, H3 = e3.arrowcolor, q4 = e3.arrowside, G2 = O.append("g").style({ opacity: u.opacity(H3) }).classed("annotation-arrow-g", true), Z2 = G2.append("path").attr("d", "M" + h2 + "," + p3 + "L" + l2 + "," + f4).style("stroke-width", V2 + "px").call(u.stroke, u.rgb(H3));
                  if (g2(Z2, q4, e3), k.annotationPosition && Z2.node().parentNode && !a2) {
                    var Y3 = l2, W3 = f4;
                    if (e3.standoff) {
                      var X2 = Math.sqrt(Math.pow(l2 - h2, 2) + Math.pow(f4 - p3, 2));
                      Y3 += e3.standoff * (h2 - l2) / X2, W3 += e3.standoff * (p3 - f4) / X2;
                    }
                    var J2, K2, $2 = G2.append("path").classed("annotation-arrow", true).classed("anndrag", true).classed("cursor-move", true).attr({ d: "M3,3H-3V-3H3ZM0,0L" + (h2 - Y3) + "," + (p3 - W3), transform: s(Y3, W3) }).style("stroke-width", V2 + 6 + "px").call(u.stroke, "rgba(0,0,0,0)").call(u.fill, "rgba(0,0,0,0)");
                    d2.init({ element: $2.node(), gd: t3, prepFn: function() {
                      var t4 = c.getTranslate(R);
                      J2 = t4.x, K2 = t4.y, y2 && y2.autorange && M(y2._name + ".autorange", true), x2 && x2.autorange && M(x2._name + ".autorange", true);
                    }, moveFn: function(t4, r6) {
                      var n5 = w3(J2, K2), i2 = n5[0] + t4, a3 = n5[1] + r6;
                      R.call(c.setTranslate, i2, a3), S("x", m2(y2, t4, "x", T, e3)), S("y", m2(x2, r6, "y", T, e3)), e3.axref === e3.xref && S("ax", m2(y2, t4, "ax", T, e3)), e3.ayref === e3.yref && S("ay", m2(x2, r6, "ay", T, e3)), G2.attr("transform", s(t4, r6)), I.attr({ transform: "rotate(" + P + "," + i2 + "," + a3 + ")" });
                    }, doneFn: function() {
                      i.call("_guiRelayout", t3, E());
                      var e4 = document.querySelector(".js-notes-box-panel");
                      e4 && e4.redraw(e4.selectedObj);
                    } });
                  }
                }
              };
              e3.showarrow && At(0, 0), D && d2.init({ element: R.node(), gd: t3, prepFn: function() {
                kt = I.attr("transform");
              }, moveFn: function(t4, r5) {
                var n4 = "pointer";
                if (e3.showarrow)
                  e3.axref === e3.xref ? S("ax", m2(y2, t4, "ax", T, e3)) : S("ax", e3.ax + t4), e3.ayref === e3.yref ? S("ay", m2(x2, r5, "ay", T.w, e3)) : S("ay", e3.ay + r5), At(t4, r5);
                else {
                  if (a2)
                    return;
                  var i2, o2;
                  if (y2)
                    i2 = m2(y2, t4, "x", T, e3);
                  else {
                    var l2 = e3._xsize / T.w, u2 = e3.x + (e3._xshift - e3.xshift) / T.w - l2 / 2;
                    i2 = d2.align(u2 + t4 / T.w, l2, 0, 1, e3.xanchor);
                  }
                  if (x2)
                    o2 = m2(x2, r5, "y", T, e3);
                  else {
                    var c2 = e3._ysize / T.h, f4 = e3.y - (e3._yshift + e3.yshift) / T.h - c2 / 2;
                    o2 = d2.align(f4 - r5 / T.h, c2, 0, 1, e3.yanchor);
                  }
                  S("x", i2), S("y", o2), y2 && x2 || (n4 = d2.getCursor(y2 ? 0.5 : i2, x2 ? 0.5 : o2, e3.xanchor, e3.yanchor));
                }
                I.attr({ transform: s(t4, r5) + kt }), p2(R, n4);
              }, clickFn: function(r5, n4) {
                e3.captureevents && t3.emit("plotly_clickannotation", Z(n4));
              }, doneFn: function() {
                p2(R), i.call("_guiRelayout", t3, E());
                var e4 = document.querySelector(".js-notes-box-panel");
                e4 && e4.redraw(e4.selectedObj);
              } });
            }
          }
        }
        t2.exports = { draw: function(t3) {
          var e3 = t3._fullLayout;
          e3._infolayer.selectAll(".annotation").remove();
          for (var r3 = 0; r3 < e3.annotations.length; r3++)
            e3.annotations[r3].visible && y(t3, r3);
          return a.previousPromises(t3);
        }, drawOne: y, drawRaw: x };
      }, 13011: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(7901), a = r2(82884), o = r2(71828), s = o.strScale, l = o.strRotate, u = o.strTranslate;
        t2.exports = function(t3, e3, r3) {
          var o2, c, f2, h, p2 = t3.node(), d2 = a[r3.arrowhead || 0], v = a[r3.startarrowhead || 0], g2 = (r3.arrowwidth || 1) * (r3.arrowsize || 1), y = (r3.arrowwidth || 1) * (r3.startarrowsize || 1), m2 = e3.indexOf("start") >= 0, x = e3.indexOf("end") >= 0, b = d2.backoff * g2 + r3.standoff, _ = v.backoff * y + r3.startstandoff;
          if ("line" === p2.nodeName) {
            o2 = { x: +t3.attr("x1"), y: +t3.attr("y1") }, c = { x: +t3.attr("x2"), y: +t3.attr("y2") };
            var w2 = o2.x - c.x, T = o2.y - c.y;
            if (h = (f2 = Math.atan2(T, w2)) + Math.PI, b && _ && b + _ > Math.sqrt(w2 * w2 + T * T))
              return void D();
            if (b) {
              if (b * b > w2 * w2 + T * T)
                return void D();
              var k = b * Math.cos(f2), A = b * Math.sin(f2);
              c.x += k, c.y += A, t3.attr({ x2: c.x, y2: c.y });
            }
            if (_) {
              if (_ * _ > w2 * w2 + T * T)
                return void D();
              var M = _ * Math.cos(f2), S = _ * Math.sin(f2);
              o2.x -= M, o2.y -= S, t3.attr({ x1: o2.x, y1: o2.y });
            }
          } else if ("path" === p2.nodeName) {
            var E = p2.getTotalLength(), L = "";
            if (E < b + _)
              return void D();
            var C = p2.getPointAtLength(0), P = p2.getPointAtLength(0.1);
            f2 = Math.atan2(C.y - P.y, C.x - P.x), o2 = p2.getPointAtLength(Math.min(_, E)), L = "0px," + _ + "px,";
            var O = p2.getPointAtLength(E), I = p2.getPointAtLength(E - 0.1);
            h = Math.atan2(O.y - I.y, O.x - I.x), c = p2.getPointAtLength(Math.max(0, E - b)), L += E - (L ? _ + b : b) + "px," + E + "px", t3.style("stroke-dasharray", L);
          }
          function D() {
            t3.style("stroke-dasharray", "0px,100px");
          }
          function z(e4, a2, o3, c2) {
            e4.path && (e4.noRotate && (o3 = 0), n2.select(p2.parentNode).append("path").attr({ class: t3.attr("class"), d: e4.path, transform: u(a2.x, a2.y) + l(180 * o3 / Math.PI) + s(c2) }).style({ fill: i.rgb(r3.arrowcolor), "stroke-width": 0 }));
          }
          m2 && z(v, o2, f2, y), x && z(d2, c, h, g2);
        };
      }, 32745: function(t2, e2, r2) {
        var n2 = r2(92605), i = r2(44317);
        t2.exports = { moduleType: "component", name: "annotations", layoutAttributes: r2(50215), supplyLayoutDefaults: r2(84046), includeBasePlot: r2(76325)("annotations"), calcAutorange: r2(3749), draw: n2.draw, drawOne: n2.drawOne, drawRaw: n2.drawRaw, hasClickToShow: i.hasClickToShow, onClick: i.onClick, convertCoords: r2(94128) };
      }, 26997: function(t2, e2, r2) {
        var n2 = r2(50215), i = r2(30962).overrideAll, a = r2(44467).templatedArray;
        t2.exports = i(a("annotation", { visible: n2.visible, x: { valType: "any" }, y: { valType: "any" }, z: { valType: "any" }, ax: { valType: "number" }, ay: { valType: "number" }, xanchor: n2.xanchor, xshift: n2.xshift, yanchor: n2.yanchor, yshift: n2.yshift, text: n2.text, textangle: n2.textangle, font: n2.font, width: n2.width, height: n2.height, opacity: n2.opacity, align: n2.align, valign: n2.valign, bgcolor: n2.bgcolor, bordercolor: n2.bordercolor, borderpad: n2.borderpad, borderwidth: n2.borderwidth, showarrow: n2.showarrow, arrowcolor: n2.arrowcolor, arrowhead: n2.arrowhead, startarrowhead: n2.startarrowhead, arrowside: n2.arrowside, arrowsize: n2.arrowsize, startarrowsize: n2.startarrowsize, arrowwidth: n2.arrowwidth, standoff: n2.standoff, startstandoff: n2.startstandoff, hovertext: n2.hovertext, hoverlabel: n2.hoverlabel, captureevents: n2.captureevents }), "calc", "from-root");
      }, 5485: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298);
        function a(t3, e3) {
          var r3 = e3.fullSceneLayout.domain, a2 = e3.fullLayout._size, o = { pdata: null, type: "linear", autorange: false, range: [-1 / 0, 1 / 0] };
          t3._xa = {}, n2.extendFlat(t3._xa, o), i.setConvert(t3._xa), t3._xa._offset = a2.l + r3.x[0] * a2.w, t3._xa.l2p = function() {
            return 0.5 * (1 + t3._pdata[0] / t3._pdata[3]) * a2.w * (r3.x[1] - r3.x[0]);
          }, t3._ya = {}, n2.extendFlat(t3._ya, o), i.setConvert(t3._ya), t3._ya._offset = a2.t + (1 - r3.y[1]) * a2.h, t3._ya.l2p = function() {
            return 0.5 * (1 - t3._pdata[1] / t3._pdata[3]) * a2.h * (r3.y[1] - r3.y[0]);
          };
        }
        t2.exports = function(t3) {
          for (var e3 = t3.fullSceneLayout.annotations, r3 = 0; r3 < e3.length; r3++)
            a(e3[r3], t3);
          t3.fullLayout._infolayer.selectAll(".annotation-" + t3.id).remove();
        };
      }, 20226: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298), a = r2(85501), o = r2(25625), s = r2(26997);
        function l(t3, e3, r3, a2) {
          function l2(r4, i2) {
            return n2.coerce(t3, e3, s, r4, i2);
          }
          function u(t4) {
            var n3 = t4 + "axis", a3 = { _fullLayout: {} };
            return a3._fullLayout[n3] = r3[n3], i.coercePosition(e3, a3, l2, t4, t4, 0.5);
          }
          l2("visible") && (o(t3, e3, a2.fullLayout, l2), u("x"), u("y"), u("z"), n2.noneOrAll(t3, e3, ["x", "y", "z"]), e3.xref = "x", e3.yref = "y", e3.zref = "z", l2("xanchor"), l2("yanchor"), l2("xshift"), l2("yshift"), e3.showarrow && (e3.axref = "pixel", e3.ayref = "pixel", l2("ax", -10), l2("ay", -30), n2.noneOrAll(t3, e3, ["ax", "ay"])));
        }
        t2.exports = function(t3, e3, r3) {
          a(t3, e3, { name: "annotations", handleItemDefaults: l, fullLayout: r3.fullLayout });
        };
      }, 82188: function(t2, e2, r2) {
        var n2 = r2(92605).drawRaw, i = r2(63538), a = ["x", "y", "z"];
        t2.exports = function(t3) {
          for (var e3 = t3.fullSceneLayout, r3 = t3.dataScale, o = e3.annotations, s = 0; s < o.length; s++) {
            for (var l = o[s], u = false, c = 0; c < 3; c++) {
              var f2 = a[c], h = l[f2], p2 = e3[f2 + "axis"].r2fraction(h);
              if (p2 < 0 || p2 > 1) {
                u = true;
                break;
              }
            }
            u ? t3.fullLayout._infolayer.select(".annotation-" + t3.id + '[data-index="' + s + '"]').remove() : (l._pdata = i(t3.glplot.cameraParams, [e3.xaxis.r2l(l.x) * r3[0], e3.yaxis.r2l(l.y) * r3[1], e3.zaxis.r2l(l.z) * r3[2]]), n2(t3.graphDiv, l, s, t3.id, l._xa, l._ya));
          }
        };
      }, 2468: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828);
        t2.exports = { moduleType: "component", name: "annotations3d", schema: { subplots: { scene: { annotations: r2(26997) } } }, layoutAttributes: r2(26997), handleDefaults: r2(20226), includeBasePlot: function(t3, e3) {
          var r3 = n2.subplotsRegistry.gl3d;
          if (r3)
            for (var a = r3.attrRegex, o = Object.keys(t3), s = 0; s < o.length; s++) {
              var l = o[s];
              a.test(l) && (t3[l].annotations || []).length && (i.pushUnique(e3._basePlotModules, r3), i.pushUnique(e3._subplots.gl3d, l));
            }
        }, convert: r2(5485), draw: r2(82188) };
      }, 7561: function(t2, e2, r2) {
        t2.exports = r2(63489), r2(94338), r2(3961), r2(38751), r2(86825), r2(37715), r2(99384), r2(43805), r2(88874), r2(83290), r2(29108), r2(55422), r2(94320), r2(31320), r2(51367), r2(21457);
      }, 72201: function(t2, e2, r2) {
        var n2 = r2(7561), i = r2(71828), a = r2(50606), o = a.EPOCHJD, s = a.ONEDAY, l = { valType: "enumerated", values: i.sortObjectKeys(n2.calendars), editType: "calc", dflt: "gregorian" }, u = function(t3, e3, r3, n3) {
          var a2 = {};
          return a2[r3] = l, i.coerce(t3, e3, a2, r3, n3);
        }, c = "##", f2 = { d: { 0: "dd", "-": "d" }, e: { 0: "d", "-": "d" }, a: { 0: "D", "-": "D" }, A: { 0: "DD", "-": "DD" }, j: { 0: "oo", "-": "o" }, W: { 0: "ww", "-": "w" }, m: { 0: "mm", "-": "m" }, b: { 0: "M", "-": "M" }, B: { 0: "MM", "-": "MM" }, y: { 0: "yy", "-": "yy" }, Y: { 0: "yyyy", "-": "yyyy" }, U: c, w: c, c: { 0: "D M d %X yyyy", "-": "D M d %X yyyy" }, x: { 0: "mm/dd/yyyy", "-": "mm/dd/yyyy" } }, h = {};
        function p2(t3) {
          var e3 = h[t3];
          return e3 || (h[t3] = n2.instance(t3));
        }
        function d2(t3) {
          return i.extendFlat({}, l, { description: t3 });
        }
        function v(t3) {
          return "Sets the calendar system to use with `" + t3 + "` date data.";
        }
        var g2 = { xcalendar: d2(v("x")) }, y = i.extendFlat({}, g2, { ycalendar: d2(v("y")) }), m2 = i.extendFlat({}, y, { zcalendar: d2(v("z")) }), x = d2(["Sets the calendar system to use for `range` and `tick0`", "if this is a date axis. This does not set the calendar for", "interpreting data on this axis, that's specified in the trace", "or via the global `layout.calendar`"].join(" "));
        t2.exports = { moduleType: "component", name: "calendars", schema: { traces: { scatter: y, bar: y, box: y, heatmap: y, contour: y, histogram: y, histogram2d: y, histogram2dcontour: y, scatter3d: m2, surface: m2, mesh3d: m2, scattergl: y, ohlc: g2, candlestick: g2 }, layout: { calendar: d2(["Sets the default calendar system to use for interpreting and", "displaying dates throughout the plot."].join(" ")) }, subplots: { xaxis: { calendar: x }, yaxis: { calendar: x }, scene: { xaxis: { calendar: x }, yaxis: { calendar: x }, zaxis: { calendar: x } }, polar: { radialaxis: { calendar: x } } }, transforms: { filter: { valuecalendar: d2(["WARNING: All transforms are deprecated and may be removed from the API in next major version.", "Sets the calendar system to use for `value`, if it is a date."].join(" ")), targetcalendar: d2(["WARNING: All transforms are deprecated and may be removed from the API in next major version.", "Sets the calendar system to use for `target`, if it is an", "array of dates. If `target` is a string (eg *x*) we use the", "corresponding trace attribute (eg `xcalendar`) if it exists,", "even if `targetcalendar` is provided."].join(" ")) } } }, layoutAttributes: l, handleDefaults: u, handleTraceDefaults: function(t3, e3, r3, n3) {
          for (var i2 = 0; i2 < r3.length; i2++)
            u(t3, e3, r3[i2] + "calendar", n3.calendar);
        }, CANONICAL_SUNDAY: { chinese: "2000-01-02", coptic: "2000-01-03", discworld: "2000-01-03", ethiopian: "2000-01-05", hebrew: "5000-01-01", islamic: "1000-01-02", julian: "2000-01-03", mayan: "5000-01-01", nanakshahi: "1000-01-05", nepali: "2000-01-05", persian: "1000-01-01", jalali: "1000-01-01", taiwan: "1000-01-04", thai: "2000-01-04", ummalqura: "1400-01-06" }, CANONICAL_TICK: { chinese: "2000-01-01", coptic: "2000-01-01", discworld: "2000-01-01", ethiopian: "2000-01-01", hebrew: "5000-01-01", islamic: "1000-01-01", julian: "2000-01-01", mayan: "5000-01-01", nanakshahi: "1000-01-01", nepali: "2000-01-01", persian: "1000-01-01", jalali: "1000-01-01", taiwan: "1000-01-01", thai: "2000-01-01", ummalqura: "1400-01-01" }, DFLTRANGE: { chinese: ["2000-01-01", "2001-01-01"], coptic: ["1700-01-01", "1701-01-01"], discworld: ["1800-01-01", "1801-01-01"], ethiopian: ["2000-01-01", "2001-01-01"], hebrew: ["5700-01-01", "5701-01-01"], islamic: ["1400-01-01", "1401-01-01"], julian: ["2000-01-01", "2001-01-01"], mayan: ["5200-01-01", "5201-01-01"], nanakshahi: ["0500-01-01", "0501-01-01"], nepali: ["2000-01-01", "2001-01-01"], persian: ["1400-01-01", "1401-01-01"], jalali: ["1400-01-01", "1401-01-01"], taiwan: ["0100-01-01", "0101-01-01"], thai: ["2500-01-01", "2501-01-01"], ummalqura: ["1400-01-01", "1401-01-01"] }, getCal: p2, worldCalFmt: function(t3, e3, r3) {
          for (var n3, i2, a2, l2, u2, h2 = Math.floor((e3 + 0.05) / s) + o, d3 = p2(r3).fromJD(h2), v2 = 0; -1 !== (v2 = t3.indexOf("%", v2)); )
            "0" === (n3 = t3.charAt(v2 + 1)) || "-" === n3 || "_" === n3 ? (a2 = 3, i2 = t3.charAt(v2 + 2), "_" === n3 && (n3 = "-")) : (i2 = n3, n3 = "0", a2 = 2), (l2 = f2[i2]) ? (u2 = l2 === c ? c : d3.formatDate(l2[n3]), t3 = t3.substr(0, v2) + u2 + t3.substr(v2 + a2), v2 += u2.length) : v2 += a2;
          return t3;
        } };
      }, 22399: function(t2, e2) {
        e2.defaults = ["#1f77b4", "#ff7f0e", "#2ca02c", "#d62728", "#9467bd", "#8c564b", "#e377c2", "#7f7f7f", "#bcbd22", "#17becf"], e2.defaultLine = "#444", e2.lightLine = "#eee", e2.background = "#fff", e2.borderLine = "#BEC8D9", e2.lightFraction = 1e3 / 11;
      }, 7901: function(t2, e2, r2) {
        var n2 = r2(84267), i = r2(92770), a = r2(73627).isTypedArray, o = t2.exports = {}, s = r2(22399);
        o.defaults = s.defaults;
        var l = o.defaultLine = s.defaultLine;
        o.lightLine = s.lightLine;
        var u = o.background = s.background;
        function c(t3) {
          if (i(t3) || "string" != typeof t3)
            return t3;
          var e3 = t3.trim();
          if ("rgb" !== e3.substr(0, 3))
            return t3;
          var r3 = e3.match(/^rgba?\s*\(([^()]*)\)$/);
          if (!r3)
            return t3;
          var n3 = r3[1].trim().split(/\s*[\s,]\s*/), a2 = "a" === e3.charAt(3) && 4 === n3.length;
          if (!a2 && 3 !== n3.length)
            return t3;
          for (var o2 = 0; o2 < n3.length; o2++) {
            if (!n3[o2].length)
              return t3;
            if (n3[o2] = Number(n3[o2]), !(n3[o2] >= 0))
              return t3;
            if (3 === o2)
              n3[o2] > 1 && (n3[o2] = 1);
            else if (n3[o2] >= 1)
              return t3;
          }
          var s2 = Math.round(255 * n3[0]) + ", " + Math.round(255 * n3[1]) + ", " + Math.round(255 * n3[2]);
          return a2 ? "rgba(" + s2 + ", " + n3[3] + ")" : "rgb(" + s2 + ")";
        }
        o.tinyRGB = function(t3) {
          var e3 = t3.toRgb();
          return "rgb(" + Math.round(e3.r) + ", " + Math.round(e3.g) + ", " + Math.round(e3.b) + ")";
        }, o.rgb = function(t3) {
          return o.tinyRGB(n2(t3));
        }, o.opacity = function(t3) {
          return t3 ? n2(t3).getAlpha() : 0;
        }, o.addOpacity = function(t3, e3) {
          var r3 = n2(t3).toRgb();
          return "rgba(" + Math.round(r3.r) + ", " + Math.round(r3.g) + ", " + Math.round(r3.b) + ", " + e3 + ")";
        }, o.combine = function(t3, e3) {
          var r3 = n2(t3).toRgb();
          if (1 === r3.a)
            return n2(t3).toRgbString();
          var i2 = n2(e3 || u).toRgb(), a2 = 1 === i2.a ? i2 : { r: 255 * (1 - i2.a) + i2.r * i2.a, g: 255 * (1 - i2.a) + i2.g * i2.a, b: 255 * (1 - i2.a) + i2.b * i2.a }, o2 = { r: a2.r * (1 - r3.a) + r3.r * r3.a, g: a2.g * (1 - r3.a) + r3.g * r3.a, b: a2.b * (1 - r3.a) + r3.b * r3.a };
          return n2(o2).toRgbString();
        }, o.contrast = function(t3, e3, r3) {
          var i2 = n2(t3);
          return 1 !== i2.getAlpha() && (i2 = n2(o.combine(t3, u))), (i2.isDark() ? e3 ? i2.lighten(e3) : u : r3 ? i2.darken(r3) : l).toString();
        }, o.stroke = function(t3, e3) {
          var r3 = n2(e3);
          t3.style({ stroke: o.tinyRGB(r3), "stroke-opacity": r3.getAlpha() });
        }, o.fill = function(t3, e3) {
          var r3 = n2(e3);
          t3.style({ fill: o.tinyRGB(r3), "fill-opacity": r3.getAlpha() });
        }, o.clean = function(t3) {
          if (t3 && "object" == typeof t3) {
            var e3, r3, n3, i2, s2 = Object.keys(t3);
            for (e3 = 0; e3 < s2.length; e3++)
              if (i2 = t3[n3 = s2[e3]], "color" === n3.substr(n3.length - 5))
                if (Array.isArray(i2))
                  for (r3 = 0; r3 < i2.length; r3++)
                    i2[r3] = c(i2[r3]);
                else
                  t3[n3] = c(i2);
              else if ("colorscale" === n3.substr(n3.length - 10) && Array.isArray(i2))
                for (r3 = 0; r3 < i2.length; r3++)
                  Array.isArray(i2[r3]) && (i2[r3][1] = c(i2[r3][1]));
              else if (Array.isArray(i2)) {
                var l2 = i2[0];
                if (!Array.isArray(l2) && l2 && "object" == typeof l2)
                  for (r3 = 0; r3 < i2.length; r3++)
                    o.clean(i2[r3]);
              } else
                i2 && "object" == typeof i2 && !a(i2) && o.clean(i2);
          }
        };
      }, 63583: function(t2, e2, r2) {
        var n2 = r2(13838), i = r2(41940), a = r2(1426).extendFlat, o = r2(30962).overrideAll;
        t2.exports = o({ orientation: { valType: "enumerated", values: ["h", "v"], dflt: "v" }, thicknessmode: { valType: "enumerated", values: ["fraction", "pixels"], dflt: "pixels" }, thickness: { valType: "number", min: 0, dflt: 30 }, lenmode: { valType: "enumerated", values: ["fraction", "pixels"], dflt: "fraction" }, len: { valType: "number", min: 0, dflt: 1 }, x: { valType: "number", min: -2, max: 3 }, xanchor: { valType: "enumerated", values: ["left", "center", "right"] }, xpad: { valType: "number", min: 0, dflt: 10 }, y: { valType: "number", min: -2, max: 3 }, yanchor: { valType: "enumerated", values: ["top", "middle", "bottom"] }, ypad: { valType: "number", min: 0, dflt: 10 }, outlinecolor: n2.linecolor, outlinewidth: n2.linewidth, bordercolor: n2.linecolor, borderwidth: { valType: "number", min: 0, dflt: 0 }, bgcolor: { valType: "color", dflt: "rgba(0,0,0,0)" }, tickmode: n2.minor.tickmode, nticks: n2.nticks, tick0: n2.tick0, dtick: n2.dtick, tickvals: n2.tickvals, ticktext: n2.ticktext, ticks: a({}, n2.ticks, { dflt: "" }), ticklabeloverflow: a({}, n2.ticklabeloverflow, {}), ticklabelposition: { valType: "enumerated", values: ["outside", "inside", "outside top", "inside top", "outside left", "inside left", "outside right", "inside right", "outside bottom", "inside bottom"], dflt: "outside" }, ticklen: n2.ticklen, tickwidth: n2.tickwidth, tickcolor: n2.tickcolor, ticklabelstep: n2.ticklabelstep, showticklabels: n2.showticklabels, labelalias: n2.labelalias, tickfont: i({}), tickangle: n2.tickangle, tickformat: n2.tickformat, tickformatstops: n2.tickformatstops, tickprefix: n2.tickprefix, showtickprefix: n2.showtickprefix, ticksuffix: n2.ticksuffix, showticksuffix: n2.showticksuffix, separatethousands: n2.separatethousands, exponentformat: n2.exponentformat, minexponent: n2.minexponent, showexponent: n2.showexponent, title: { text: { valType: "string" }, font: i({}), side: { valType: "enumerated", values: ["right", "top", "bottom"] } }, _deprecated: { title: { valType: "string" }, titlefont: i({}), titleside: { valType: "enumerated", values: ["right", "top", "bottom"], dflt: "top" } } }, "colorbars", "from-root");
      }, 30939: function(t2) {
        t2.exports = { cn: { colorbar: "colorbar", cbbg: "cbbg", cbfill: "cbfill", cbfills: "cbfills", cbline: "cbline", cblines: "cblines", cbaxis: "cbaxis", cbtitleunshift: "cbtitleunshift", cbtitle: "cbtitle", cboutline: "cboutline", crisp: "crisp", jsPlaceholder: "js-placeholder" } };
      }, 62499: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(44467), a = r2(26218), o = r2(38701), s = r2(96115), l = r2(89426), u = r2(63583);
        t2.exports = function(t3, e3, r3) {
          var c = i.newContainer(e3, "colorbar"), f2 = t3.colorbar || {};
          function h(t4, e4) {
            return n2.coerce(f2, c, u, t4, e4);
          }
          var p2 = r3.margin || { t: 0, b: 0, l: 0, r: 0 }, d2 = r3.width - p2.l - p2.r, v = r3.height - p2.t - p2.b, g2 = "v" === h("orientation"), y = h("thicknessmode");
          h("thickness", "fraction" === y ? 30 / (g2 ? d2 : v) : 30);
          var m2 = h("lenmode");
          h("len", "fraction" === m2 ? 1 : g2 ? v : d2), h("x", g2 ? 1.02 : 0.5), h("xanchor", g2 ? "left" : "center"), h("xpad"), h("y", g2 ? 0.5 : 1.02), h("yanchor", g2 ? "middle" : "bottom"), h("ypad"), n2.noneOrAll(f2, c, ["x", "y"]), h("outlinecolor"), h("outlinewidth"), h("bordercolor"), h("borderwidth"), h("bgcolor");
          var x = n2.coerce(f2, c, { ticklabelposition: { valType: "enumerated", dflt: "outside", values: g2 ? ["outside", "inside", "outside top", "inside top", "outside bottom", "inside bottom"] : ["outside", "inside", "outside left", "inside left", "outside right", "inside right"] } }, "ticklabelposition");
          h("ticklabeloverflow", -1 !== x.indexOf("inside") ? "hide past domain" : "hide past div"), a(f2, c, h, "linear");
          var b = r3.font, _ = { outerTicks: false, font: b };
          -1 !== x.indexOf("inside") && (_.bgColor = "black"), l(f2, c, h, "linear", _), s(f2, c, h, "linear", _), o(f2, c, h, "linear", _), h("title.text", r3._dfltTitle.colorbar);
          var w2 = c.tickfont, T = n2.extendFlat({}, w2, { color: b.color, size: n2.bigFont(w2.size) });
          n2.coerceFont(h, "title.font", T), h("title.side", g2 ? "top" : "right");
        };
      }, 98981: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(84267), a = r2(74875), o = r2(73972), s = r2(89298), l = r2(28569), u = r2(71828), c = u.strTranslate, f2 = r2(1426).extendFlat, h = r2(6964), p2 = r2(91424), d2 = r2(7901), v = r2(92998), g2 = r2(63893), y = r2(52075).flipScale, m2 = r2(71453), x = r2(52830), b = r2(13838), _ = r2(18783), w2 = _.LINE_SPACING, T = _.FROM_TL, k = _.FROM_BR, A = r2(30939).cn;
        t2.exports = { draw: function(t3) {
          var e3 = t3._fullLayout._infolayer.selectAll("g." + A.colorbar).data(function(t4) {
            var e4, r3, n3, i2, a2 = t4._fullLayout, o2 = t4.calcdata, s2 = [];
            function l2(t5) {
              return f2(t5, { _fillcolor: null, _line: { color: null, width: null, dash: null }, _levels: { start: null, end: null, size: null }, _filllevels: null, _fillgradient: null, _zrange: null });
            }
            function u2() {
              "function" == typeof i2.calc ? i2.calc(t4, n3, e4) : (e4._fillgradient = r3.reversescale ? y(r3.colorscale) : r3.colorscale, e4._zrange = [r3[i2.min], r3[i2.max]]);
            }
            for (var c2 = 0; c2 < o2.length; c2++) {
              var h2 = o2[c2], p3 = (n3 = h2[0].trace)._module.colorbar;
              if (true === n3.visible && p3)
                for (var d3 = Array.isArray(p3), v2 = d3 ? p3 : [p3], g3 = 0; g3 < v2.length; g3++) {
                  var m3 = (i2 = v2[g3]).container;
                  (r3 = m3 ? n3[m3] : n3) && r3.showscale && ((e4 = l2(r3.colorbar))._id = "cb" + n3.uid + (d3 && m3 ? "-" + m3 : ""), e4._traceIndex = n3.index, e4._propPrefix = (m3 ? m3 + "." : "") + "colorbar.", e4._meta = n3._meta, u2(), s2.push(e4));
                }
            }
            for (var x2 in a2._colorAxes)
              if ((r3 = a2[x2]).showscale) {
                var b2 = a2._colorAxes[x2];
                (e4 = l2(r3.colorbar))._id = "cb" + x2, e4._propPrefix = x2 + ".colorbar.", e4._meta = a2._meta, i2 = { min: "cmin", max: "cmax" }, "heatmap" !== b2[0] && (n3 = b2[1], i2.calc = n3._module.colorbar.calc), u2(), s2.push(e4);
              }
            return s2;
          }(t3), function(t4) {
            return t4._id;
          });
          e3.enter().append("g").attr("class", function(t4) {
            return t4._id;
          }).classed(A.colorbar, true), e3.each(function(e4) {
            var r3 = n2.select(this);
            u.ensureSingle(r3, "rect", A.cbbg), u.ensureSingle(r3, "g", A.cbfills), u.ensureSingle(r3, "g", A.cblines), u.ensureSingle(r3, "g", A.cbaxis, function(t4) {
              t4.classed(A.crisp, true);
            }), u.ensureSingle(r3, "g", A.cbtitleunshift, function(t4) {
              t4.append("g").classed(A.cbtitle, true);
            }), u.ensureSingle(r3, "rect", A.cboutline);
            var y2 = function(t4, e5, r4) {
              var o2 = "v" === e5.orientation, l2 = e5.len, h2 = e5.lenmode, y3 = e5.thickness, _2 = e5.thicknessmode, M = e5.outlinewidth, S = e5.borderwidth, E = e5.bgcolor, L = e5.xanchor, C = e5.yanchor, P = e5.xpad, O = e5.ypad, I = e5.x, D = o2 ? e5.y : 1 - e5.y, z = r4._fullLayout, R = z._size, F = e5._fillcolor, B = e5._line, N = e5.title, j = N.side, U = e5._zrange || n2.extent(("function" == typeof F ? F : B.color).domain()), V = "function" == typeof B.color ? B.color : function() {
                return B.color;
              }, H = "function" == typeof F ? F : function() {
                return F;
              }, q2 = e5._levels, G = function(t5, e6, r5) {
                var n3, i2, a2 = e6._levels, o3 = [], s2 = [], l3 = a2.end + a2.size / 100, u2 = a2.size, c2 = 1.001 * r5[0] - 1e-3 * r5[1], f3 = 1.001 * r5[1] - 1e-3 * r5[0];
                for (i2 = 0; i2 < 1e5 && (n3 = a2.start + i2 * u2, !(u2 > 0 ? n3 >= l3 : n3 <= l3)); i2++)
                  n3 > c2 && n3 < f3 && o3.push(n3);
                if (e6._fillgradient)
                  s2 = [0];
                else if ("function" == typeof e6._fillcolor) {
                  var h3 = e6._filllevels;
                  if (h3)
                    for (l3 = h3.end + h3.size / 100, u2 = h3.size, i2 = 0; i2 < 1e5 && (n3 = h3.start + i2 * u2, !(u2 > 0 ? n3 >= l3 : n3 <= l3)); i2++)
                      n3 > r5[0] && n3 < r5[1] && s2.push(n3);
                  else
                    (s2 = o3.map(function(t6) {
                      return t6 - a2.size / 2;
                    })).push(s2[s2.length - 1] + a2.size);
                } else
                  e6._fillcolor && "string" == typeof e6._fillcolor && (s2 = [0]);
                return a2.size < 0 && (o3.reverse(), s2.reverse()), { line: o3, fill: s2 };
              }(0, e5, U), Z = G.fill, Y = G.line, W = Math.round(y3 * ("fraction" === _2 ? o2 ? R.w : R.h : 1)), X = W / (o2 ? R.w : R.h), J = Math.round(l2 * ("fraction" === h2 ? o2 ? R.h : R.w : 1)), K = J / (o2 ? R.h : R.w), $ = Math.round(o2 ? I * R.w + P : D * R.h + O), Q = { center: 0.5, right: 1 }[L] || 0, tt = { top: 1, middle: 0.5 }[C] || 0, et = o2 ? I - Q * X : D - tt * X, rt = o2 ? D - tt * K : I - Q * K, nt = Math.round(o2 ? R.h * (1 - rt) : R.w * rt);
              e5._lenFrac = K, e5._thickFrac = X, e5._uFrac = et, e5._vFrac = rt;
              var it = e5._axis = function(t5, e6, r5) {
                var n3 = t5._fullLayout, i2 = "v" === e6.orientation, a2 = { type: "linear", range: r5, tickmode: e6.tickmode, nticks: e6.nticks, tick0: e6.tick0, dtick: e6.dtick, tickvals: e6.tickvals, ticktext: e6.ticktext, ticks: e6.ticks, ticklen: e6.ticklen, tickwidth: e6.tickwidth, tickcolor: e6.tickcolor, showticklabels: e6.showticklabels, labelalias: e6.labelalias, ticklabelposition: e6.ticklabelposition, ticklabeloverflow: e6.ticklabeloverflow, ticklabelstep: e6.ticklabelstep, tickfont: e6.tickfont, tickangle: e6.tickangle, tickformat: e6.tickformat, exponentformat: e6.exponentformat, minexponent: e6.minexponent, separatethousands: e6.separatethousands, showexponent: e6.showexponent, showtickprefix: e6.showtickprefix, tickprefix: e6.tickprefix, showticksuffix: e6.showticksuffix, ticksuffix: e6.ticksuffix, title: e6.title, showline: true, anchor: "free", side: i2 ? "right" : "bottom", position: 1 }, o3 = i2 ? "y" : "x", s2 = { type: "linear", _id: o3 + e6._id }, l3 = { letter: o3, font: n3.font, noHover: true, noTickson: true, noTicklabelmode: true, calendar: n3.calendar };
                function c2(t6, e7) {
                  return u.coerce(a2, s2, b, t6, e7);
                }
                return m2(a2, s2, c2, l3, n3), x(a2, s2, c2, l3), s2;
              }(r4, e5, U);
              it.position = X + (o2 ? I + P / R.w : D + O / R.h);
              var at = -1 !== ["top", "bottom"].indexOf(j);
              if (o2 && at && (it.title.side = j, it.titlex = I + P / R.w, it.titley = rt + ("top" === N.side ? K - O / R.h : O / R.h)), o2 || at || (it.title.side = j, it.titley = D + O / R.h, it.titlex = rt + P / R.w), B.color && "auto" === e5.tickmode) {
                it.tickmode = "linear", it.tick0 = q2.start;
                var ot = q2.size, st = u.constrain(J / 50, 4, 15) + 1, lt = (U[1] - U[0]) / ((e5.nticks || st) * ot);
                if (lt > 1) {
                  var ut = Math.pow(10, Math.floor(Math.log(lt) / Math.LN10));
                  ot *= ut * u.roundUp(lt / ut, [2, 5, 10]), (Math.abs(q2.start) / q2.size + 1e-6) % 1 < 2e-6 && (it.tick0 = 0);
                }
                it.dtick = ot;
              }
              it.domain = o2 ? [rt + O / R.h, rt + K - O / R.h] : [rt + P / R.w, rt + K - P / R.w], it.setScale(), t4.attr("transform", c(Math.round(R.l), Math.round(R.t)));
              var ct, ft = t4.select("." + A.cbtitleunshift).attr("transform", c(-Math.round(R.l), -Math.round(R.t))), ht = it.ticklabelposition, pt = it.title.font.size, dt = t4.select("." + A.cbaxis), vt = 0, gt = 0;
              function yt(n3, i2) {
                var a2 = { propContainer: it, propName: e5._propPrefix + "title", traceIndex: e5._traceIndex, _meta: e5._meta, placeholder: z._dfltTitle.colorbar, containerGroup: t4.select("." + A.cbtitle) }, o3 = "h" === n3.charAt(0) ? n3.substr(1) : "h" + n3;
                t4.selectAll("." + o3 + ",." + o3 + "-math-group").remove(), v.draw(r4, n3, f2(a2, i2 || {}));
              }
              return u.syncOrAsync([a.previousPromises, function() {
                var t5, e6;
                (o2 && at || !o2 && !at) && ("top" === j && (t5 = P + R.l + R.w * I, e6 = O + R.t + R.h * (1 - rt - K) + 3 + 0.75 * pt), "bottom" === j && (t5 = P + R.l + R.w * I, e6 = O + R.t + R.h * (1 - rt) - 3 - 0.25 * pt), "right" === j && (e6 = O + R.t + R.h * D + 3 + 0.75 * pt, t5 = P + R.l + R.w * rt), yt(it._id + "title", { attributes: { x: t5, y: e6, "text-anchor": o2 ? "start" : "middle" } }));
              }, function() {
                if (!o2 && !at || o2 && at) {
                  var a2, l3 = t4.select("." + A.cbtitle), f3 = l3.select("text"), h3 = [-M / 2, M / 2], d3 = l3.select(".h" + it._id + "title-math-group").node(), v2 = 15.6;
                  if (f3.node() && (v2 = parseInt(f3.node().style.fontSize, 10) * w2), d3 ? (a2 = p2.bBox(d3), gt = a2.width, (vt = a2.height) > v2 && (h3[1] -= (vt - v2) / 2)) : f3.node() && !f3.classed(A.jsPlaceholder) && (a2 = p2.bBox(f3.node()), gt = a2.width, vt = a2.height), o2) {
                    if (vt) {
                      if (vt += 5, "top" === j)
                        it.domain[1] -= vt / R.h, h3[1] *= -1;
                      else {
                        it.domain[0] += vt / R.h;
                        var y4 = g2.lineCount(f3);
                        h3[1] += (1 - y4) * v2;
                      }
                      l3.attr("transform", c(h3[0], h3[1])), it.setScale();
                    }
                  } else
                    gt && ("right" === j && (it.domain[0] += (gt + pt / 2) / R.w), l3.attr("transform", c(h3[0], h3[1])), it.setScale());
                }
                t4.selectAll("." + A.cbfills + ",." + A.cblines).attr("transform", o2 ? c(0, Math.round(R.h * (1 - it.domain[1]))) : c(Math.round(R.w * it.domain[0]), 0)), dt.attr("transform", o2 ? c(0, Math.round(-R.t)) : c(Math.round(-R.l), 0));
                var m3 = t4.select("." + A.cbfills).selectAll("rect." + A.cbfill).attr("style", "").data(Z);
                m3.enter().append("rect").classed(A.cbfill, true).style("stroke", "none"), m3.exit().remove();
                var x2 = U.map(it.c2p).map(Math.round).sort(function(t5, e6) {
                  return t5 - e6;
                });
                m3.each(function(t5, a3) {
                  var s2 = [0 === a3 ? U[0] : (Z[a3] + Z[a3 - 1]) / 2, a3 === Z.length - 1 ? U[1] : (Z[a3] + Z[a3 + 1]) / 2].map(it.c2p).map(Math.round);
                  o2 && (s2[1] = u.constrain(s2[1] + (s2[1] > s2[0]) ? 1 : -1, x2[0], x2[1]));
                  var l4 = n2.select(this).attr(o2 ? "x" : "y", $).attr(o2 ? "y" : "x", n2.min(s2)).attr(o2 ? "width" : "height", Math.max(W, 2)).attr(o2 ? "height" : "width", Math.max(n2.max(s2) - n2.min(s2), 2));
                  if (e5._fillgradient)
                    p2.gradient(l4, r4, e5._id, o2 ? "vertical" : "horizontalreversed", e5._fillgradient, "fill");
                  else {
                    var c2 = H(t5).replace("e-", "");
                    l4.attr("fill", i(c2).toHexString());
                  }
                });
                var b2 = t4.select("." + A.cblines).selectAll("path." + A.cbline).data(B.color && B.width ? Y : []);
                b2.enter().append("path").classed(A.cbline, true), b2.exit().remove(), b2.each(function(t5) {
                  var e6 = $, r5 = Math.round(it.c2p(t5)) + B.width / 2 % 1;
                  n2.select(this).attr("d", "M" + (o2 ? e6 + "," + r5 : r5 + "," + e6) + (o2 ? "h" : "v") + W).call(p2.lineGroupStyle, B.width, V(t5), B.dash);
                }), dt.selectAll("g." + it._id + "tick,path").remove();
                var _3 = $ + W + (M || 0) / 2 - ("outside" === e5.ticks ? 1 : 0), T2 = s.calcTicks(it), k2 = s.getTickSigns(it)[2];
                return s.drawTicks(r4, it, { vals: "inside" === it.ticks ? s.clipEnds(it, T2) : T2, layer: dt, path: s.makeTickPath(it, _3, k2), transFn: s.makeTransTickFn(it) }), s.drawLabels(r4, it, { vals: T2, layer: dt, transFn: s.makeTransTickLabelFn(it), labelFns: s.makeLabelFns(it, _3) });
              }, function() {
                if (o2 && !at || !o2 && at) {
                  var t5, i2, a2 = it.position || 0, s2 = it._offset + it._length / 2;
                  if ("right" === j)
                    i2 = s2, t5 = R.l + R.w * a2 + 10 + pt * (it.showticklabels ? 1 : 0.5);
                  else if (t5 = s2, "bottom" === j && (i2 = R.t + R.h * a2 + 10 + (-1 === ht.indexOf("inside") ? it.tickfont.size : 0) + ("intside" !== it.ticks && e5.ticklen || 0)), "top" === j) {
                    var l3 = N.text.split("<br>").length;
                    i2 = R.t + R.h * a2 + 10 - W - w2 * pt * l3;
                  }
                  yt((o2 ? "h" : "v") + it._id + "title", { avoid: { selection: n2.select(r4).selectAll("g." + it._id + "tick"), side: j, offsetTop: o2 ? 0 : R.t, offsetLeft: o2 ? R.l : 0, maxShift: o2 ? z.width : z.height }, attributes: { x: t5, y: i2, "text-anchor": "middle" }, transform: { rotate: o2 ? -90 : 0, offset: 0 } });
                }
              }, a.previousPromises, function() {
                var n3, s2 = W + M / 2;
                -1 === ht.indexOf("inside") && (n3 = p2.bBox(dt.node()), s2 += o2 ? n3.width : n3.height), ct = ft.select("text");
                var u2 = 0, f3 = o2 && "top" === j, v2 = !o2 && "right" === j, g3 = 0;
                if (ct.node() && !ct.classed(A.jsPlaceholder)) {
                  var m3, x2 = ft.select(".h" + it._id + "title-math-group").node();
                  x2 && (o2 && at || !o2 && !at) ? (u2 = (n3 = p2.bBox(x2)).width, m3 = n3.height) : (u2 = (n3 = p2.bBox(ft.node())).right - R.l - (o2 ? $ : nt), m3 = n3.bottom - R.t - (o2 ? nt : $), o2 || "top" !== j || (s2 += n3.height, g3 = n3.height)), v2 && (ct.attr("transform", c(u2 / 2 + pt / 2, 0)), u2 *= 2), s2 = Math.max(s2, o2 ? u2 : m3);
                }
                var b2 = 2 * (o2 ? P : O) + s2 + S + M / 2, w3 = 0;
                !o2 && N.text && "bottom" === C && D <= 0 && (b2 += w3 = b2 / 2, g3 += w3), z._hColorbarMoveTitle = w3, z._hColorbarMoveCBTitle = g3;
                var F2 = S + M;
                t4.select("." + A.cbbg).attr("x", (o2 ? $ : nt) - F2 / 2 - (o2 ? P : 0)).attr("y", (o2 ? nt : $) - (o2 ? J : O + g3 - w3)).attr(o2 ? "width" : "height", Math.max(b2 - w3, 2)).attr(o2 ? "height" : "width", Math.max(J + F2, 2)).call(d2.fill, E).call(d2.stroke, e5.bordercolor).style("stroke-width", S);
                var B2 = v2 ? Math.max(u2 - 10, 0) : 0;
                if (t4.selectAll("." + A.cboutline).attr("x", (o2 ? $ : nt + P) + B2).attr("y", (o2 ? nt + O - J : $) + (f3 ? vt : 0)).attr(o2 ? "width" : "height", Math.max(W, 2)).attr(o2 ? "height" : "width", Math.max(J - (o2 ? 2 * O + vt : 2 * P + B2), 2)).call(d2.stroke, e5.outlinecolor).style({ fill: "none", "stroke-width": M }), t4.attr("transform", c(R.l - (o2 ? Q * b2 : 0), R.t - (o2 ? 0 : (1 - tt) * b2 - g3))), !o2 && (S || i(E).getAlpha() && !i.equals(z.paper_bgcolor, E))) {
                  var U2 = dt.selectAll("text"), V2 = U2[0].length, H2 = t4.select("." + A.cbbg).node(), q3 = p2.bBox(H2), G2 = p2.getTranslate(t4);
                  U2.each(function(t5, e6) {
                    var r5 = V2 - 1;
                    if (0 === e6 || e6 === r5) {
                      var n4, i2 = p2.bBox(this), a2 = p2.getTranslate(this);
                      if (e6 === r5) {
                        var o3 = i2.right + a2.x;
                        (n4 = q3.right + G2.x + nt - S - 2 + I - o3) > 0 && (n4 = 0);
                      } else if (0 === e6) {
                        var s3 = i2.left + a2.x;
                        (n4 = q3.left + G2.x + nt + S + 2 - s3) < 0 && (n4 = 0);
                      }
                      n4 && (V2 < 3 ? this.setAttribute("transform", "translate(" + n4 + ",0) " + this.getAttribute("transform")) : this.setAttribute("visibility", "hidden"));
                    }
                  });
                }
                var Z2 = {}, Y2 = T[L], X2 = k[L], K2 = T[C], et2 = k[C], rt2 = b2 - W;
                o2 ? ("pixels" === h2 ? (Z2.y = D, Z2.t = J * K2, Z2.b = J * et2) : (Z2.t = Z2.b = 0, Z2.yt = D + l2 * K2, Z2.yb = D - l2 * et2), "pixels" === _2 ? (Z2.x = I, Z2.l = b2 * Y2, Z2.r = b2 * X2) : (Z2.l = rt2 * Y2, Z2.r = rt2 * X2, Z2.xl = I - y3 * Y2, Z2.xr = I + y3 * X2)) : ("pixels" === h2 ? (Z2.x = I, Z2.l = J * Y2, Z2.r = J * X2) : (Z2.l = Z2.r = 0, Z2.xl = I + l2 * Y2, Z2.xr = I - l2 * X2), "pixels" === _2 ? (Z2.y = 1 - D, Z2.t = b2 * K2, Z2.b = b2 * et2) : (Z2.t = rt2 * K2, Z2.b = rt2 * et2, Z2.yt = D - y3 * K2, Z2.yb = D + y3 * et2)), a.autoMargin(r4, e5._id, Z2);
              }], r4);
            }(r3, e4, t3);
            y2 && y2.then && (t3._promises || []).push(y2), t3._context.edits.colorbarPosition && function(t4, e5, r4) {
              var n3, i2, a2, s2 = "v" === e5.orientation, u2 = r4._fullLayout._size;
              l.init({ element: t4.node(), gd: r4, prepFn: function() {
                n3 = t4.attr("transform"), h(t4);
              }, moveFn: function(r5, o2) {
                t4.attr("transform", n3 + c(r5, o2)), i2 = l.align((s2 ? e5._uFrac : e5._vFrac) + r5 / u2.w, s2 ? e5._thickFrac : e5._lenFrac, 0, 1, e5.xanchor), a2 = l.align((s2 ? e5._vFrac : 1 - e5._uFrac) - o2 / u2.h, s2 ? e5._lenFrac : e5._thickFrac, 0, 1, e5.yanchor);
                var f3 = l.getCursor(i2, a2, e5.xanchor, e5.yanchor);
                h(t4, f3);
              }, doneFn: function() {
                if (h(t4), void 0 !== i2 && void 0 !== a2) {
                  var n4 = {};
                  n4[e5._propPrefix + "x"] = i2, n4[e5._propPrefix + "y"] = a2, void 0 !== e5._traceIndex ? o.call("_guiRestyle", r4, n4, e5._traceIndex) : o.call("_guiRelayout", r4, n4);
                }
              } });
            }(r3, e4, t3);
          }), e3.exit().each(function(e4) {
            a.autoMargin(t3, e4._id);
          }).remove(), e3.order();
        } };
      }, 76228: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = function(t3) {
          return n2.isPlainObject(t3.colorbar);
        };
      }, 12311: function(t2, e2, r2) {
        t2.exports = { moduleType: "component", name: "colorbar", attributes: r2(63583), supplyDefaults: r2(62499), draw: r2(98981).draw, hasColorbar: r2(76228) };
      }, 50693: function(t2, e2, r2) {
        var n2 = r2(63583), i = r2(30587).counter, a = r2(78607), o = r2(63282).scales;
        function s(t3) {
          return "`" + t3 + "`";
        }
        a(o), t2.exports = function(t3, e3) {
          t3 = t3 || "";
          var r3, a2 = (e3 = e3 || {}).cLetter || "c", l = ("onlyIfNumerical" in e3 ? e3.onlyIfNumerical : Boolean(t3), "noScale" in e3 ? e3.noScale : "marker.line" === t3), u = "showScaleDflt" in e3 ? e3.showScaleDflt : "z" === a2, c = "string" == typeof e3.colorscaleDflt ? o[e3.colorscaleDflt] : null, f2 = e3.editTypeOverride || "", h = t3 ? t3 + "." : "";
          "colorAttr" in e3 ? (r3 = e3.colorAttr, e3.colorAttr) : s(h + (r3 = { z: "z", c: "color" }[a2]));
          var p2 = a2 + "auto", d2 = a2 + "min", v = a2 + "max", g2 = a2 + "mid", y = {};
          y[d2] = y[v] = void 0;
          var m2 = {};
          m2[p2] = false;
          var x = {};
          return "color" === r3 && (x.color = { valType: "color", arrayOk: true, editType: f2 || "style" }, e3.anim && (x.color.anim = true)), x[p2] = { valType: "boolean", dflt: true, editType: "calc", impliedEdits: y }, x[d2] = { valType: "number", dflt: null, editType: f2 || "plot", impliedEdits: m2 }, x[v] = { valType: "number", dflt: null, editType: f2 || "plot", impliedEdits: m2 }, x[g2] = { valType: "number", dflt: null, editType: "calc", impliedEdits: y }, x.colorscale = { valType: "colorscale", editType: "calc", dflt: c, impliedEdits: { autocolorscale: false } }, x.autocolorscale = { valType: "boolean", dflt: false !== e3.autoColorDflt, editType: "calc", impliedEdits: { colorscale: void 0 } }, x.reversescale = { valType: "boolean", dflt: false, editType: "plot" }, l || (x.showscale = { valType: "boolean", dflt: u, editType: "calc" }, x.colorbar = n2), e3.noColorAxis || (x.coloraxis = { valType: "subplotid", regex: i("coloraxis"), dflt: null, editType: "calc" }), x;
        };
      }, 78803: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = r2(52075).extractOpts;
        t2.exports = function(t3, e3, r3) {
          var o, s = t3._fullLayout, l = r3.vals, u = r3.containerStr, c = u ? i.nestedProperty(e3, u).get() : e3, f2 = a(c), h = false !== f2.auto, p2 = f2.min, d2 = f2.max, v = f2.mid, g2 = function() {
            return i.aggNums(Math.min, null, l);
          }, y = function() {
            return i.aggNums(Math.max, null, l);
          };
          void 0 === p2 ? p2 = g2() : h && (p2 = c._colorAx && n2(p2) ? Math.min(p2, g2()) : g2()), void 0 === d2 ? d2 = y() : h && (d2 = c._colorAx && n2(d2) ? Math.max(d2, y()) : y()), h && void 0 !== v && (d2 - v > v - p2 ? p2 = v - (d2 - v) : d2 - v < v - p2 && (d2 = v + (v - p2))), p2 === d2 && (p2 -= 0.5, d2 += 0.5), f2._sync("min", p2), f2._sync("max", d2), f2.autocolorscale && (o = p2 * d2 < 0 ? s.colorscale.diverging : p2 >= 0 ? s.colorscale.sequential : s.colorscale.sequentialminus, f2._sync("colorscale", o));
        };
      }, 33046: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(52075).hasColorscale, a = r2(52075).extractOpts;
        t2.exports = function(t3, e3) {
          function r3(t4, e4) {
            var r4 = t4["_" + e4];
            void 0 !== r4 && (t4[e4] = r4);
          }
          function o(t4, i2) {
            var o2 = i2.container ? n2.nestedProperty(t4, i2.container).get() : t4;
            if (o2)
              if (o2.coloraxis)
                o2._colorAx = e3[o2.coloraxis];
              else {
                var s2 = a(o2), l2 = s2.auto;
                (l2 || void 0 === s2.min) && r3(o2, i2.min), (l2 || void 0 === s2.max) && r3(o2, i2.max), s2.autocolorscale && r3(o2, "colorscale");
              }
          }
          for (var s = 0; s < t3.length; s++) {
            var l = t3[s], u = l._module.colorbar;
            if (u)
              if (Array.isArray(u))
                for (var c = 0; c < u.length; c++)
                  o(l, u[c]);
              else
                o(l, u);
            i(l, "marker.line") && o(l, { container: "marker.line", min: "cmin", max: "cmax" });
          }
          for (var f2 in e3._colorAxes)
            o(e3[f2], { min: "cmin", max: "cmax" });
        };
      }, 1586: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = r2(76228), o = r2(62499), s = r2(63282).isValid, l = r2(73972).traceIs;
        function u(t3, e3) {
          var r3 = e3.slice(0, e3.length - 1);
          return e3 ? i.nestedProperty(t3, r3).get() || {} : t3;
        }
        t2.exports = function t3(e3, r3, c, f2, h) {
          var p2 = h.prefix, d2 = h.cLetter, v = "_module" in r3, g2 = u(e3, p2), y = u(r3, p2), m2 = u(r3._template || {}, p2) || {}, x = function() {
            return delete e3.coloraxis, delete r3.coloraxis, t3(e3, r3, c, f2, h);
          };
          if (v) {
            var b = c._colorAxes || {}, _ = f2(p2 + "coloraxis");
            if (_) {
              var w2 = l(r3, "contour") && i.nestedProperty(r3, "contours.coloring").get() || "heatmap", T = b[_];
              return void (T ? (T[2].push(x), T[0] !== w2 && (T[0] = false, i.warn(["Ignoring coloraxis:", _, "setting", "as it is linked to incompatible colorscales."].join(" ")))) : b[_] = [w2, r3, [x]]);
            }
          }
          var k = g2[d2 + "min"], A = g2[d2 + "max"], M = n2(k) && n2(A) && k < A;
          f2(p2 + d2 + "auto", !M) ? f2(p2 + d2 + "mid") : (f2(p2 + d2 + "min"), f2(p2 + d2 + "max"));
          var S, E, L = g2.colorscale, C = m2.colorscale;
          void 0 !== L && (S = !s(L)), void 0 !== C && (S = !s(C)), f2(p2 + "autocolorscale", S), f2(p2 + "colorscale"), f2(p2 + "reversescale"), "marker.line." !== p2 && (p2 && v && (E = a(g2)), f2(p2 + "showscale", E) && (p2 && m2 && (y._template = m2), o(g2, y, c)));
        };
      }, 52075: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(84267), a = r2(92770), o = r2(71828), s = r2(7901), l = r2(63282).isValid, u = ["showscale", "autocolorscale", "colorscale", "reversescale", "colorbar"], c = ["min", "max", "mid", "auto"];
        function f2(t3) {
          var e3, r3, n3, i2 = t3._colorAx, a2 = i2 || t3, o2 = {};
          for (r3 = 0; r3 < u.length; r3++)
            o2[n3 = u[r3]] = a2[n3];
          if (i2)
            for (e3 = "c", r3 = 0; r3 < c.length; r3++)
              o2[n3 = c[r3]] = a2["c" + n3];
          else {
            var s2;
            for (r3 = 0; r3 < c.length; r3++)
              ((s2 = "c" + (n3 = c[r3])) in a2 || (s2 = "z" + n3) in a2) && (o2[n3] = a2[s2]);
            e3 = s2.charAt(0);
          }
          return o2._sync = function(t4, r4) {
            var n4 = -1 !== c.indexOf(t4) ? e3 + t4 : t4;
            a2[n4] = a2["_" + n4] = r4;
          }, o2;
        }
        function h(t3) {
          for (var e3 = f2(t3), r3 = e3.min, n3 = e3.max, i2 = e3.reversescale ? p2(e3.colorscale) : e3.colorscale, a2 = i2.length, o2 = new Array(a2), s2 = new Array(a2), l2 = 0; l2 < a2; l2++) {
            var u2 = i2[l2];
            o2[l2] = r3 + u2[0] * (n3 - r3), s2[l2] = u2[1];
          }
          return { domain: o2, range: s2 };
        }
        function p2(t3) {
          for (var e3 = t3.length, r3 = new Array(e3), n3 = e3 - 1, i2 = 0; n3 >= 0; n3--, i2++) {
            var a2 = t3[n3];
            r3[i2] = [1 - a2[0], a2[1]];
          }
          return r3;
        }
        function d2(t3, e3) {
          e3 = e3 || {};
          for (var r3 = t3.domain, o2 = t3.range, l2 = o2.length, u2 = new Array(l2), c2 = 0; c2 < l2; c2++) {
            var f3 = i(o2[c2]).toRgb();
            u2[c2] = [f3.r, f3.g, f3.b, f3.a];
          }
          var h2, p3 = n2.scale.linear().domain(r3).range(u2).clamp(true), d3 = e3.noNumericCheck, g2 = e3.returnArray;
          return (h2 = d3 && g2 ? p3 : d3 ? function(t4) {
            return v(p3(t4));
          } : g2 ? function(t4) {
            return a(t4) ? p3(t4) : i(t4).isValid() ? t4 : s.defaultLine;
          } : function(t4) {
            return a(t4) ? v(p3(t4)) : i(t4).isValid() ? t4 : s.defaultLine;
          }).domain = p3.domain, h2.range = function() {
            return o2;
          }, h2;
        }
        function v(t3) {
          var e3 = { r: t3[0], g: t3[1], b: t3[2], a: t3[3] };
          return i(e3).toRgbString();
        }
        t2.exports = { hasColorscale: function(t3, e3, r3) {
          var n3 = e3 ? o.nestedProperty(t3, e3).get() || {} : t3, i2 = n3[r3 || "color"], s2 = false;
          if (o.isArrayOrTypedArray(i2)) {
            for (var u2 = 0; u2 < i2.length; u2++)
              if (a(i2[u2])) {
                s2 = true;
                break;
              }
          }
          return o.isPlainObject(n3) && (s2 || true === n3.showscale || a(n3.cmin) && a(n3.cmax) || l(n3.colorscale) || o.isPlainObject(n3.colorbar));
        }, extractOpts: f2, extractScale: h, flipScale: p2, makeColorScaleFunc: d2, makeColorScaleFuncFromTrace: function(t3, e3) {
          return d2(h(t3), e3);
        } };
      }, 21081: function(t2, e2, r2) {
        var n2 = r2(63282), i = r2(52075);
        t2.exports = { moduleType: "component", name: "colorscale", attributes: r2(50693), layoutAttributes: r2(72673), supplyLayoutDefaults: r2(30959), handleDefaults: r2(1586), crossTraceDefaults: r2(33046), calc: r2(78803), scales: n2.scales, defaultScale: n2.defaultScale, getScale: n2.get, isValidScale: n2.isValid, hasColorscale: i.hasColorscale, extractOpts: i.extractOpts, extractScale: i.extractScale, flipScale: i.flipScale, makeColorScaleFunc: i.makeColorScaleFunc, makeColorScaleFuncFromTrace: i.makeColorScaleFuncFromTrace };
      }, 72673: function(t2, e2, r2) {
        var n2 = r2(1426).extendFlat, i = r2(50693), a = r2(63282).scales;
        t2.exports = { editType: "calc", colorscale: { editType: "calc", sequential: { valType: "colorscale", dflt: a.Reds, editType: "calc" }, sequentialminus: { valType: "colorscale", dflt: a.Blues, editType: "calc" }, diverging: { valType: "colorscale", dflt: a.RdBu, editType: "calc" } }, coloraxis: n2({ _isSubplotObj: true, editType: "calc" }, i("", { colorAttr: "corresponding trace color array(s)", noColorAxis: true, showScaleDflt: true })) };
      }, 30959: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(44467), a = r2(72673), o = r2(1586);
        t2.exports = function(t3, e3) {
          function r3(r4, i2) {
            return n2.coerce(t3, e3, a, r4, i2);
          }
          r3("colorscale.sequential"), r3("colorscale.sequentialminus"), r3("colorscale.diverging");
          var s, l, u = e3._colorAxes;
          function c(t4, e4) {
            return n2.coerce(s, l, a.coloraxis, t4, e4);
          }
          for (var f2 in u) {
            var h = u[f2];
            if (h[0])
              s = t3[f2] || {}, (l = i.newContainer(e3, f2, "coloraxis"))._name = f2, o(s, l, e3, c, { prefix: "", cLetter: "c" });
            else {
              for (var p2 = 0; p2 < h[2].length; p2++)
                h[2][p2]();
              delete e3._colorAxes[f2];
            }
          }
        };
      }, 63282: function(t2, e2, r2) {
        var n2 = r2(84267), i = { Greys: [[0, "rgb(0,0,0)"], [1, "rgb(255,255,255)"]], YlGnBu: [[0, "rgb(8,29,88)"], [0.125, "rgb(37,52,148)"], [0.25, "rgb(34,94,168)"], [0.375, "rgb(29,145,192)"], [0.5, "rgb(65,182,196)"], [0.625, "rgb(127,205,187)"], [0.75, "rgb(199,233,180)"], [0.875, "rgb(237,248,217)"], [1, "rgb(255,255,217)"]], Greens: [[0, "rgb(0,68,27)"], [0.125, "rgb(0,109,44)"], [0.25, "rgb(35,139,69)"], [0.375, "rgb(65,171,93)"], [0.5, "rgb(116,196,118)"], [0.625, "rgb(161,217,155)"], [0.75, "rgb(199,233,192)"], [0.875, "rgb(229,245,224)"], [1, "rgb(247,252,245)"]], YlOrRd: [[0, "rgb(128,0,38)"], [0.125, "rgb(189,0,38)"], [0.25, "rgb(227,26,28)"], [0.375, "rgb(252,78,42)"], [0.5, "rgb(253,141,60)"], [0.625, "rgb(254,178,76)"], [0.75, "rgb(254,217,118)"], [0.875, "rgb(255,237,160)"], [1, "rgb(255,255,204)"]], Bluered: [[0, "rgb(0,0,255)"], [1, "rgb(255,0,0)"]], RdBu: [[0, "rgb(5,10,172)"], [0.35, "rgb(106,137,247)"], [0.5, "rgb(190,190,190)"], [0.6, "rgb(220,170,132)"], [0.7, "rgb(230,145,90)"], [1, "rgb(178,10,28)"]], Reds: [[0, "rgb(220,220,220)"], [0.2, "rgb(245,195,157)"], [0.4, "rgb(245,160,105)"], [1, "rgb(178,10,28)"]], Blues: [[0, "rgb(5,10,172)"], [0.35, "rgb(40,60,190)"], [0.5, "rgb(70,100,245)"], [0.6, "rgb(90,120,245)"], [0.7, "rgb(106,137,247)"], [1, "rgb(220,220,220)"]], Picnic: [[0, "rgb(0,0,255)"], [0.1, "rgb(51,153,255)"], [0.2, "rgb(102,204,255)"], [0.3, "rgb(153,204,255)"], [0.4, "rgb(204,204,255)"], [0.5, "rgb(255,255,255)"], [0.6, "rgb(255,204,255)"], [0.7, "rgb(255,153,255)"], [0.8, "rgb(255,102,204)"], [0.9, "rgb(255,102,102)"], [1, "rgb(255,0,0)"]], Rainbow: [[0, "rgb(150,0,90)"], [0.125, "rgb(0,0,200)"], [0.25, "rgb(0,25,255)"], [0.375, "rgb(0,152,255)"], [0.5, "rgb(44,255,150)"], [0.625, "rgb(151,255,0)"], [0.75, "rgb(255,234,0)"], [0.875, "rgb(255,111,0)"], [1, "rgb(255,0,0)"]], Portland: [[0, "rgb(12,51,131)"], [0.25, "rgb(10,136,186)"], [0.5, "rgb(242,211,56)"], [0.75, "rgb(242,143,56)"], [1, "rgb(217,30,30)"]], Jet: [[0, "rgb(0,0,131)"], [0.125, "rgb(0,60,170)"], [0.375, "rgb(5,255,255)"], [0.625, "rgb(255,255,0)"], [0.875, "rgb(250,0,0)"], [1, "rgb(128,0,0)"]], Hot: [[0, "rgb(0,0,0)"], [0.3, "rgb(230,0,0)"], [0.6, "rgb(255,210,0)"], [1, "rgb(255,255,255)"]], Blackbody: [[0, "rgb(0,0,0)"], [0.2, "rgb(230,0,0)"], [0.4, "rgb(230,210,0)"], [0.7, "rgb(255,255,255)"], [1, "rgb(160,200,255)"]], Earth: [[0, "rgb(0,0,130)"], [0.1, "rgb(0,180,180)"], [0.2, "rgb(40,210,40)"], [0.4, "rgb(230,230,50)"], [0.6, "rgb(120,70,20)"], [1, "rgb(255,255,255)"]], Electric: [[0, "rgb(0,0,0)"], [0.15, "rgb(30,0,100)"], [0.4, "rgb(120,0,100)"], [0.6, "rgb(160,90,0)"], [0.8, "rgb(230,200,0)"], [1, "rgb(255,250,220)"]], Viridis: [[0, "#440154"], [0.06274509803921569, "#48186a"], [0.12549019607843137, "#472d7b"], [0.18823529411764706, "#424086"], [0.25098039215686274, "#3b528b"], [0.3137254901960784, "#33638d"], [0.3764705882352941, "#2c728e"], [0.4392156862745098, "#26828e"], [0.5019607843137255, "#21918c"], [0.5647058823529412, "#1fa088"], [0.6274509803921569, "#28ae80"], [0.6901960784313725, "#3fbc73"], [0.7529411764705882, "#5ec962"], [0.8156862745098039, "#84d44b"], [0.8784313725490196, "#addc30"], [0.9411764705882353, "#d8e219"], [1, "#fde725"]], Cividis: [[0, "rgb(0,32,76)"], [0.058824, "rgb(0,42,102)"], [0.117647, "rgb(0,52,110)"], [0.176471, "rgb(39,63,108)"], [0.235294, "rgb(60,74,107)"], [0.294118, "rgb(76,85,107)"], [0.352941, "rgb(91,95,109)"], [0.411765, "rgb(104,106,112)"], [0.470588, "rgb(117,117,117)"], [0.529412, "rgb(131,129,120)"], [0.588235, "rgb(146,140,120)"], [0.647059, "rgb(161,152,118)"], [0.705882, "rgb(176,165,114)"], [0.764706, "rgb(192,177,109)"], [0.823529, "rgb(209,191,102)"], [0.882353, "rgb(225,204,92)"], [0.941176, "rgb(243,219,79)"], [1, "rgb(255,233,69)"]] }, a = i.RdBu;
        function o(t3) {
          var e3 = 0;
          if (!Array.isArray(t3) || t3.length < 2)
            return false;
          if (!t3[0] || !t3[t3.length - 1])
            return false;
          if (0 != +t3[0][0] || 1 != +t3[t3.length - 1][0])
            return false;
          for (var r3 = 0; r3 < t3.length; r3++) {
            var i2 = t3[r3];
            if (2 !== i2.length || +i2[0] < e3 || !n2(i2[1]).isValid())
              return false;
            e3 = +i2[0];
          }
          return true;
        }
        t2.exports = { scales: i, defaultScale: a, get: function(t3, e3) {
          if (e3 || (e3 = a), !t3)
            return e3;
          function r3() {
            try {
              t3 = i[t3] || JSON.parse(t3);
            } catch (r4) {
              t3 = e3;
            }
          }
          return "string" == typeof t3 && (r3(), "string" == typeof t3 && r3()), o(t3) ? t3 : e3;
        }, isValid: function(t3) {
          return void 0 !== i[t3] || o(t3);
        } };
      }, 92807: function(t2) {
        t2.exports = function(t3, e2, r2, n2, i) {
          var a = (t3 - r2) / (n2 - r2), o = a + e2 / (n2 - r2), s = (a + o) / 2;
          return "left" === i || "bottom" === i ? a : "center" === i || "middle" === i ? s : "right" === i || "top" === i ? o : a < 2 / 3 - s ? a : o > 4 / 3 - s ? o : s;
        };
      }, 70461: function(t2, e2, r2) {
        var n2 = r2(71828), i = [["sw-resize", "s-resize", "se-resize"], ["w-resize", "move", "e-resize"], ["nw-resize", "n-resize", "ne-resize"]];
        t2.exports = function(t3, e3, r3, a) {
          return t3 = "left" === r3 ? 0 : "center" === r3 ? 1 : "right" === r3 ? 2 : n2.constrain(Math.floor(3 * t3), 0, 2), e3 = "bottom" === a ? 0 : "middle" === a ? 1 : "top" === a ? 2 : n2.constrain(Math.floor(3 * e3), 0, 2), i[e3][t3];
        };
      }, 64505: function(t2, e2) {
        e2.selectMode = function(t3) {
          return "lasso" === t3 || "select" === t3;
        }, e2.drawMode = function(t3) {
          return "drawclosedpath" === t3 || "drawopenpath" === t3 || "drawline" === t3 || "drawrect" === t3 || "drawcircle" === t3;
        }, e2.openMode = function(t3) {
          return "drawline" === t3 || "drawopenpath" === t3;
        }, e2.rectMode = function(t3) {
          return "select" === t3 || "drawline" === t3 || "drawrect" === t3 || "drawcircle" === t3;
        }, e2.freeMode = function(t3) {
          return "lasso" === t3 || "drawclosedpath" === t3 || "drawopenpath" === t3;
        }, e2.selectingOrDrawing = function(t3) {
          return e2.freeMode(t3) || e2.rectMode(t3);
        };
      }, 28569: function(t2, e2, r2) {
        var n2 = r2(48956), i = r2(57035), a = r2(38520), o = r2(71828).removeElement, s = r2(85555), l = t2.exports = {};
        l.align = r2(92807), l.getCursor = r2(70461);
        var u = r2(26041);
        function c() {
          var t3 = document.createElement("div");
          t3.className = "dragcover";
          var e3 = t3.style;
          return e3.position = "fixed", e3.left = 0, e3.right = 0, e3.top = 0, e3.bottom = 0, e3.zIndex = 999999999, e3.background = "none", document.body.appendChild(t3), t3;
        }
        function f2(t3) {
          return n2(t3.changedTouches ? t3.changedTouches[0] : t3, document.body);
        }
        l.unhover = u.wrapped, l.unhoverRaw = u.raw, l.init = function(t3) {
          var e3, r3, n3, u2, h, p2, d2, v, g2 = t3.gd, y = 1, m2 = g2._context.doubleClickDelay, x = t3.element;
          g2._mouseDownTime || (g2._mouseDownTime = 0), x.style.pointerEvents = "all", x.onmousedown = _, a ? (x._ontouchstart && x.removeEventListener("touchstart", x._ontouchstart), x._ontouchstart = _, x.addEventListener("touchstart", _, { passive: false })) : x.ontouchstart = _;
          var b = t3.clampFn || function(t4, e4, r4) {
            return Math.abs(t4) < r4 && (t4 = 0), Math.abs(e4) < r4 && (e4 = 0), [t4, e4];
          };
          function _(a2) {
            g2._dragged = false, g2._dragging = true;
            var o2 = f2(a2);
            e3 = o2[0], r3 = o2[1], d2 = a2.target, p2 = a2, v = 2 === a2.buttons || a2.ctrlKey, void 0 === a2.clientX && void 0 === a2.clientY && (a2.clientX = e3, a2.clientY = r3), (n3 = new Date().getTime()) - g2._mouseDownTime < m2 ? y += 1 : (y = 1, g2._mouseDownTime = n3), t3.prepFn && t3.prepFn(a2, e3, r3), i && !v ? (h = c()).style.cursor = window.getComputedStyle(x).cursor : i || (h = document, u2 = window.getComputedStyle(document.documentElement).cursor, document.documentElement.style.cursor = window.getComputedStyle(x).cursor), document.addEventListener("mouseup", T), document.addEventListener("touchend", T), false !== t3.dragmode && (a2.preventDefault(), document.addEventListener("mousemove", w2), document.addEventListener("touchmove", w2, { passive: false }));
          }
          function w2(n4) {
            n4.preventDefault();
            var i2 = f2(n4), a2 = t3.minDrag || s.MINDRAG, o2 = b(i2[0] - e3, i2[1] - r3, a2), u3 = o2[0], c2 = o2[1];
            (u3 || c2) && (g2._dragged = true, l.unhover(g2, n4)), g2._dragged && t3.moveFn && !v && (g2._dragdata = { element: x, dx: u3, dy: c2 }, t3.moveFn(u3, c2));
          }
          function T(e4) {
            if (delete g2._dragdata, false !== t3.dragmode && (e4.preventDefault(), document.removeEventListener("mousemove", w2), document.removeEventListener("touchmove", w2)), document.removeEventListener("mouseup", T), document.removeEventListener("touchend", T), i ? o(h) : u2 && (h.documentElement.style.cursor = u2, u2 = null), g2._dragging) {
              if (g2._dragging = false, new Date().getTime() - g2._mouseDownTime > m2 && (y = Math.max(y - 1, 1)), g2._dragged)
                t3.doneFn && t3.doneFn();
              else if (t3.clickFn && t3.clickFn(y, p2), !v) {
                var r4;
                try {
                  r4 = new MouseEvent("click", e4);
                } catch (t4) {
                  var n4 = f2(e4);
                  (r4 = document.createEvent("MouseEvents")).initMouseEvent("click", e4.bubbles, e4.cancelable, e4.view, e4.detail, e4.screenX, e4.screenY, n4[0], n4[1], e4.ctrlKey, e4.altKey, e4.shiftKey, e4.metaKey, e4.button, e4.relatedTarget);
                }
                d2.dispatchEvent(r4);
              }
              g2._dragging = false, g2._dragged = false;
            } else
              g2._dragged = false;
          }
        }, l.coverSlip = c;
      }, 26041: function(t2, e2, r2) {
        var n2 = r2(11086), i = r2(79990), a = r2(24401).getGraphDiv, o = r2(26675), s = t2.exports = {};
        s.wrapped = function(t3, e3, r3) {
          (t3 = a(t3))._fullLayout && i.clear(t3._fullLayout._uid + o.HOVERID), s.raw(t3, e3, r3);
        }, s.raw = function(t3, e3) {
          var r3 = t3._fullLayout, i2 = t3._hoverdata;
          e3 || (e3 = {}), e3.target && !t3._dragged && false === n2.triggerHandler(t3, "plotly_beforehover", e3) || (r3._hoverlayer.selectAll("g").remove(), r3._hoverlayer.selectAll("line").remove(), r3._hoverlayer.selectAll("circle").remove(), t3._hoverdata = void 0, e3.target && i2 && t3.emit("plotly_unhover", { event: e3, points: i2 }));
        };
      }, 79952: function(t2, e2) {
        e2.P = { valType: "string", values: ["solid", "dot", "dash", "longdash", "dashdot", "longdashdot"], dflt: "solid", editType: "style" }, e2.u = { shape: { valType: "enumerated", values: ["", "/", "\\", "x", "-", "|", "+", "."], dflt: "", arrayOk: true, editType: "style" }, fillmode: { valType: "enumerated", values: ["replace", "overlay"], dflt: "replace", editType: "style" }, bgcolor: { valType: "color", arrayOk: true, editType: "style" }, fgcolor: { valType: "color", arrayOk: true, editType: "style" }, fgopacity: { valType: "number", editType: "style", min: 0, max: 1 }, size: { valType: "number", min: 0, dflt: 8, arrayOk: true, editType: "style" }, solidity: { valType: "number", min: 0, max: 1, dflt: 0.3, arrayOk: true, editType: "style" }, editType: "style" };
      }, 91424: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = i.numberFormat, o = r2(92770), s = r2(84267), l = r2(73972), u = r2(7901), c = r2(21081), f2 = i.strTranslate, h = r2(63893), p2 = r2(77922), d2 = r2(18783).LINE_SPACING, v = r2(37822).DESELECTDIM, g2 = r2(34098), y = r2(39984), m2 = r2(23469).appendArrayPointValue, x = t2.exports = {};
        function b(t3, e3, r3) {
          var n3 = e3.fillpattern, i2 = n3 && x.getPatternAttr(n3.shape, 0, "");
          if (i2) {
            var a2 = x.getPatternAttr(n3.bgcolor, 0, null), o2 = x.getPatternAttr(n3.fgcolor, 0, null), s2 = n3.fgopacity, l2 = x.getPatternAttr(n3.size, 0, 8), c2 = x.getPatternAttr(n3.solidity, 0, 0.3), f3 = e3.uid;
            x.pattern(t3, "point", r3, f3, i2, l2, c2, void 0, n3.fillmode, a2, o2, s2);
          } else
            e3.fillcolor && t3.call(u.fill, e3.fillcolor);
        }
        x.font = function(t3, e3, r3, n3) {
          i.isPlainObject(e3) && (n3 = e3.color, r3 = e3.size, e3 = e3.family), e3 && t3.style("font-family", e3), r3 + 1 && t3.style("font-size", r3 + "px"), n3 && t3.call(u.fill, n3);
        }, x.setPosition = function(t3, e3, r3) {
          t3.attr("x", e3).attr("y", r3);
        }, x.setSize = function(t3, e3, r3) {
          t3.attr("width", e3).attr("height", r3);
        }, x.setRect = function(t3, e3, r3, n3, i2) {
          t3.call(x.setPosition, e3, r3).call(x.setSize, n3, i2);
        }, x.translatePoint = function(t3, e3, r3, n3) {
          var i2 = r3.c2p(t3.x), a2 = n3.c2p(t3.y);
          return !!(o(i2) && o(a2) && e3.node()) && ("text" === e3.node().nodeName ? e3.attr("x", i2).attr("y", a2) : e3.attr("transform", f2(i2, a2)), true);
        }, x.translatePoints = function(t3, e3, r3) {
          t3.each(function(t4) {
            var i2 = n2.select(this);
            x.translatePoint(t4, i2, e3, r3);
          });
        }, x.hideOutsideRangePoint = function(t3, e3, r3, n3, i2, a2) {
          e3.attr("display", r3.isPtWithinRange(t3, i2) && n3.isPtWithinRange(t3, a2) ? null : "none");
        }, x.hideOutsideRangePoints = function(t3, e3) {
          if (e3._hasClipOnAxisFalse) {
            var r3 = e3.xaxis, i2 = e3.yaxis;
            t3.each(function(e4) {
              var a2 = e4[0].trace, o2 = a2.xcalendar, s2 = a2.ycalendar, u2 = l.traceIs(a2, "bar-like") ? ".bartext" : ".point,.textpoint";
              t3.selectAll(u2).each(function(t4) {
                x.hideOutsideRangePoint(t4, n2.select(this), r3, i2, o2, s2);
              });
            });
          }
        }, x.crispRound = function(t3, e3, r3) {
          return e3 && o(e3) ? t3._context.staticPlot ? e3 : e3 < 1 ? 1 : Math.round(e3) : r3 || 0;
        }, x.singleLineStyle = function(t3, e3, r3, n3, i2) {
          e3.style("fill", "none");
          var a2 = (((t3 || [])[0] || {}).trace || {}).line || {}, o2 = r3 || a2.width || 0, s2 = i2 || a2.dash || "";
          u.stroke(e3, n3 || a2.color), x.dashLine(e3, s2, o2);
        }, x.lineGroupStyle = function(t3, e3, r3, i2) {
          t3.style("fill", "none").each(function(t4) {
            var a2 = (((t4 || [])[0] || {}).trace || {}).line || {}, o2 = e3 || a2.width || 0, s2 = i2 || a2.dash || "";
            n2.select(this).call(u.stroke, r3 || a2.color).call(x.dashLine, s2, o2);
          });
        }, x.dashLine = function(t3, e3, r3) {
          r3 = +r3 || 0, e3 = x.dashStyle(e3, r3), t3.style({ "stroke-dasharray": e3, "stroke-width": r3 + "px" });
        }, x.dashStyle = function(t3, e3) {
          e3 = +e3 || 1;
          var r3 = Math.max(e3, 3);
          return "solid" === t3 ? t3 = "" : "dot" === t3 ? t3 = r3 + "px," + r3 + "px" : "dash" === t3 ? t3 = 3 * r3 + "px," + 3 * r3 + "px" : "longdash" === t3 ? t3 = 5 * r3 + "px," + 5 * r3 + "px" : "dashdot" === t3 ? t3 = 3 * r3 + "px," + r3 + "px," + r3 + "px," + r3 + "px" : "longdashdot" === t3 && (t3 = 5 * r3 + "px," + 2 * r3 + "px," + r3 + "px," + 2 * r3 + "px"), t3;
        }, x.singleFillStyle = function(t3, e3) {
          var r3 = n2.select(t3.node());
          b(t3, ((r3.data()[0] || [])[0] || {}).trace || {}, e3);
        }, x.fillGroupStyle = function(t3, e3) {
          t3.style("stroke-width", 0).each(function(t4) {
            var r3 = n2.select(this);
            t4[0].trace && b(r3, t4[0].trace, e3);
          });
        };
        var _ = r2(90998);
        x.symbolNames = [], x.symbolFuncs = [], x.symbolBackOffs = [], x.symbolNeedLines = {}, x.symbolNoDot = {}, x.symbolNoFill = {}, x.symbolList = [], Object.keys(_).forEach(function(t3) {
          var e3 = _[t3], r3 = e3.n;
          x.symbolList.push(r3, String(r3), t3, r3 + 100, String(r3 + 100), t3 + "-open"), x.symbolNames[r3] = t3, x.symbolFuncs[r3] = e3.f, x.symbolBackOffs[r3] = e3.backoff || 0, e3.needLine && (x.symbolNeedLines[r3] = true), e3.noDot ? x.symbolNoDot[r3] = true : x.symbolList.push(r3 + 200, String(r3 + 200), t3 + "-dot", r3 + 300, String(r3 + 300), t3 + "-open-dot"), e3.noFill && (x.symbolNoFill[r3] = true);
        });
        var w2 = x.symbolNames.length;
        function T(t3, e3, r3, n3) {
          var i2 = t3 % 100;
          return x.symbolFuncs[i2](e3, r3, n3) + (t3 >= 200 ? "M0,0.5L0.5,0L0,-0.5L-0.5,0Z" : "");
        }
        x.symbolNumber = function(t3) {
          if (o(t3))
            t3 = +t3;
          else if ("string" == typeof t3) {
            var e3 = 0;
            t3.indexOf("-open") > 0 && (e3 = 100, t3 = t3.replace("-open", "")), t3.indexOf("-dot") > 0 && (e3 += 200, t3 = t3.replace("-dot", "")), (t3 = x.symbolNames.indexOf(t3)) >= 0 && (t3 += e3);
          }
          return t3 % 100 >= w2 || t3 >= 400 ? 0 : Math.floor(Math.max(t3, 0));
        };
        var k = { x1: 1, x2: 0, y1: 0, y2: 0 }, A = { x1: 0, x2: 0, y1: 1, y2: 0 }, M = a("~f"), S = { radial: { node: "radialGradient" }, radialreversed: { node: "radialGradient", reversed: true }, horizontal: { node: "linearGradient", attrs: k }, horizontalreversed: { node: "linearGradient", attrs: k, reversed: true }, vertical: { node: "linearGradient", attrs: A }, verticalreversed: { node: "linearGradient", attrs: A, reversed: true } };
        x.gradient = function(t3, e3, r3, a2, o2, l2) {
          for (var c2 = o2.length, f3 = S[a2], h2 = new Array(c2), p3 = 0; p3 < c2; p3++)
            f3.reversed ? h2[c2 - 1 - p3] = [M(100 * (1 - o2[p3][0])), o2[p3][1]] : h2[p3] = [M(100 * o2[p3][0]), o2[p3][1]];
          var d3 = e3._fullLayout, v2 = "g" + d3._uid + "-" + r3, g3 = d3._defs.select(".gradients").selectAll("#" + v2).data([a2 + h2.join(";")], i.identity);
          g3.exit().remove(), g3.enter().append(f3.node).each(function() {
            var t4 = n2.select(this);
            f3.attrs && t4.attr(f3.attrs), t4.attr("id", v2);
            var e4 = t4.selectAll("stop").data(h2);
            e4.exit().remove(), e4.enter().append("stop"), e4.each(function(t5) {
              var e5 = s(t5[1]);
              n2.select(this).attr({ offset: t5[0] + "%", "stop-color": u.tinyRGB(e5), "stop-opacity": e5.getAlpha() });
            });
          }), t3.style(l2, V(v2, e3)).style(l2 + "-opacity", null), t3.classed("gradient_filled", true);
        }, x.pattern = function(t3, e3, r3, a2, o2, l2, c2, f3, h2, p3, d3, v2) {
          var g3 = "legend" === e3;
          f3 && ("overlay" === h2 ? (p3 = f3, d3 = u.contrast(p3)) : (p3 = void 0, d3 = f3));
          var y2, m3, x2, b2, _2, w3, T2, k2, A2, M2 = r3._fullLayout, S2 = "p" + M2._uid + "-" + a2, E2 = {}, L2 = s(d3), C2 = u.tinyRGB(L2), P2 = v2 * L2.getAlpha();
          switch (o2) {
            case "/":
              y2 = l2 * Math.sqrt(2), m3 = l2 * Math.sqrt(2), w3 = "path", E2 = { d: x2 = "M-" + y2 / 4 + "," + m3 / 4 + "l" + y2 / 2 + ",-" + m3 / 2 + "M0," + m3 + "L" + y2 + ",0M" + y2 / 4 * 3 + "," + m3 / 4 * 5 + "l" + y2 / 2 + ",-" + m3 / 2, opacity: P2, stroke: C2, "stroke-width": (b2 = c2 * l2) + "px" };
              break;
            case "\\":
              y2 = l2 * Math.sqrt(2), m3 = l2 * Math.sqrt(2), w3 = "path", E2 = { d: x2 = "M" + y2 / 4 * 3 + ",-" + m3 / 4 + "l" + y2 / 2 + "," + m3 / 2 + "M0,0L" + y2 + "," + m3 + "M-" + y2 / 4 + "," + m3 / 4 * 3 + "l" + y2 / 2 + "," + m3 / 2, opacity: P2, stroke: C2, "stroke-width": (b2 = c2 * l2) + "px" };
              break;
            case "x":
              y2 = l2 * Math.sqrt(2), m3 = l2 * Math.sqrt(2), x2 = "M-" + y2 / 4 + "," + m3 / 4 + "l" + y2 / 2 + ",-" + m3 / 2 + "M0," + m3 + "L" + y2 + ",0M" + y2 / 4 * 3 + "," + m3 / 4 * 5 + "l" + y2 / 2 + ",-" + m3 / 2 + "M" + y2 / 4 * 3 + ",-" + m3 / 4 + "l" + y2 / 2 + "," + m3 / 2 + "M0,0L" + y2 + "," + m3 + "M-" + y2 / 4 + "," + m3 / 4 * 3 + "l" + y2 / 2 + "," + m3 / 2, b2 = l2 - l2 * Math.sqrt(1 - c2), w3 = "path", E2 = { d: x2, opacity: P2, stroke: C2, "stroke-width": b2 + "px" };
              break;
            case "|":
              w3 = "path", w3 = "path", E2 = { d: x2 = "M" + (y2 = l2) / 2 + ",0L" + y2 / 2 + "," + (m3 = l2), opacity: P2, stroke: C2, "stroke-width": (b2 = c2 * l2) + "px" };
              break;
            case "-":
              w3 = "path", w3 = "path", E2 = { d: x2 = "M0," + (m3 = l2) / 2 + "L" + (y2 = l2) + "," + m3 / 2, opacity: P2, stroke: C2, "stroke-width": (b2 = c2 * l2) + "px" };
              break;
            case "+":
              w3 = "path", x2 = "M" + (y2 = l2) / 2 + ",0L" + y2 / 2 + "," + (m3 = l2) + "M0," + m3 / 2 + "L" + y2 + "," + m3 / 2, b2 = l2 - l2 * Math.sqrt(1 - c2), w3 = "path", E2 = { d: x2, opacity: P2, stroke: C2, "stroke-width": b2 + "px" };
              break;
            case ".":
              y2 = l2, m3 = l2, c2 < Math.PI / 4 ? _2 = Math.sqrt(c2 * l2 * l2 / Math.PI) : (T2 = c2, k2 = Math.PI / 4, _2 = (A2 = l2 / 2) + (l2 / Math.sqrt(2) - A2) * (T2 - k2) / (1 - k2)), w3 = "circle", E2 = { cx: y2 / 2, cy: m3 / 2, r: _2, opacity: P2, fill: C2 };
          }
          var O2 = [o2 || "noSh", p3 || "noBg", d3 || "noFg", l2, c2].join(";"), I2 = M2._defs.select(".patterns").selectAll("#" + S2).data([O2], i.identity);
          I2.exit().remove(), I2.enter().append("pattern").each(function() {
            var t4 = n2.select(this);
            if (t4.attr({ id: S2, width: y2 + "px", height: m3 + "px", patternUnits: "userSpaceOnUse", patternTransform: g3 ? "scale(0.8)" : "" }), p3) {
              var e4 = s(p3), r4 = u.tinyRGB(e4), i2 = e4.getAlpha(), a3 = t4.selectAll("rect").data([0]);
              a3.exit().remove(), a3.enter().append("rect").attr({ width: y2 + "px", height: m3 + "px", fill: r4, "fill-opacity": i2 });
            }
            var o3 = t4.selectAll(w3).data([0]);
            o3.exit().remove(), o3.enter().append(w3).attr(E2);
          }), t3.style("fill", V(S2, r3)).style("fill-opacity", null), t3.classed("pattern_filled", true);
        }, x.initGradients = function(t3) {
          var e3 = t3._fullLayout;
          i.ensureSingle(e3._defs, "g", "gradients").selectAll("linearGradient,radialGradient").remove(), n2.select(t3).selectAll(".gradient_filled").classed("gradient_filled", false);
        }, x.initPatterns = function(t3) {
          var e3 = t3._fullLayout;
          i.ensureSingle(e3._defs, "g", "patterns").selectAll("pattern").remove(), n2.select(t3).selectAll(".pattern_filled").classed("pattern_filled", false);
        }, x.getPatternAttr = function(t3, e3, r3) {
          return t3 && i.isArrayOrTypedArray(t3) ? e3 < t3.length ? t3[e3] : r3 : t3;
        }, x.pointStyle = function(t3, e3, r3) {
          if (t3.size()) {
            var i2 = x.makePointStyleFns(e3);
            t3.each(function(t4) {
              x.singlePointStyle(t4, n2.select(this), e3, i2, r3);
            });
          }
        }, x.singlePointStyle = function(t3, e3, r3, n3, a2) {
          var o2 = r3.marker, s2 = o2.line;
          if (e3.style("opacity", n3.selectedOpacityFn ? n3.selectedOpacityFn(t3) : void 0 === t3.mo ? o2.opacity : t3.mo), n3.ms2mrc) {
            var l2;
            l2 = "various" === t3.ms || "various" === o2.size ? 3 : n3.ms2mrc(t3.ms), t3.mrc = l2, n3.selectedSizeFn && (l2 = t3.mrc = n3.selectedSizeFn(t3));
            var c2 = x.symbolNumber(t3.mx || o2.symbol) || 0;
            t3.om = c2 % 200 >= 100;
            var f3 = rt(t3, r3), h2 = G(t3, r3);
            e3.attr("d", T(c2, l2, f3, h2));
          }
          var p3, d3, v2, g3 = false;
          if (t3.so)
            v2 = s2.outlierwidth, d3 = s2.outliercolor, p3 = o2.outliercolor;
          else {
            var y2 = (s2 || {}).width;
            v2 = (t3.mlw + 1 || y2 + 1 || (t3.trace ? (t3.trace.marker.line || {}).width : 0) + 1) - 1 || 0, d3 = "mlc" in t3 ? t3.mlcc = n3.lineScale(t3.mlc) : i.isArrayOrTypedArray(s2.color) ? u.defaultLine : s2.color, i.isArrayOrTypedArray(o2.color) && (p3 = u.defaultLine, g3 = true), p3 = "mc" in t3 ? t3.mcc = n3.markerScale(t3.mc) : o2.color || "rgba(0,0,0,0)", n3.selectedColorFn && (p3 = n3.selectedColorFn(t3));
          }
          if (t3.om)
            e3.call(u.stroke, p3).style({ "stroke-width": (v2 || 1) + "px", fill: "none" });
          else {
            e3.style("stroke-width", (t3.isBlank ? 0 : v2) + "px");
            var m3 = o2.gradient, b2 = t3.mgt;
            b2 ? g3 = true : b2 = m3 && m3.type, i.isArrayOrTypedArray(b2) && (b2 = b2[0], S[b2] || (b2 = 0));
            var _2 = o2.pattern, w3 = _2 && x.getPatternAttr(_2.shape, t3.i, "");
            if (b2 && "none" !== b2) {
              var k2 = t3.mgc;
              k2 ? g3 = true : k2 = m3.color;
              var A2 = r3.uid;
              g3 && (A2 += "-" + t3.i), x.gradient(e3, a2, A2, b2, [[0, k2], [1, p3]], "fill");
            } else if (w3) {
              var M2 = x.getPatternAttr(_2.bgcolor, t3.i, null), E2 = x.getPatternAttr(_2.fgcolor, t3.i, null), L2 = _2.fgopacity, C2 = x.getPatternAttr(_2.size, t3.i, 8), P2 = x.getPatternAttr(_2.solidity, t3.i, 0.3), O2 = t3.mcc || i.isArrayOrTypedArray(_2.shape) || i.isArrayOrTypedArray(_2.bgcolor) || i.isArrayOrTypedArray(_2.size) || i.isArrayOrTypedArray(_2.solidity), I2 = r3.uid;
              O2 && (I2 += "-" + t3.i), x.pattern(e3, "point", a2, I2, w3, C2, P2, t3.mcc, _2.fillmode, M2, E2, L2);
            } else
              u.fill(e3, p3);
            v2 && u.stroke(e3, d3);
          }
        }, x.makePointStyleFns = function(t3) {
          var e3 = {}, r3 = t3.marker;
          return e3.markerScale = x.tryColorscale(r3, ""), e3.lineScale = x.tryColorscale(r3, "line"), l.traceIs(t3, "symbols") && (e3.ms2mrc = g2.isBubble(t3) ? y(t3) : function() {
            return (r3.size || 6) / 2;
          }), t3.selectedpoints && i.extendFlat(e3, x.makeSelectedPointStyleFns(t3)), e3;
        }, x.makeSelectedPointStyleFns = function(t3) {
          var e3 = {}, r3 = t3.selected || {}, n3 = t3.unselected || {}, a2 = t3.marker || {}, o2 = r3.marker || {}, s2 = n3.marker || {}, u2 = a2.opacity, c2 = o2.opacity, f3 = s2.opacity, h2 = void 0 !== c2, p3 = void 0 !== f3;
          (i.isArrayOrTypedArray(u2) || h2 || p3) && (e3.selectedOpacityFn = function(t4) {
            var e4 = void 0 === t4.mo ? a2.opacity : t4.mo;
            return t4.selected ? h2 ? c2 : e4 : p3 ? f3 : v * e4;
          });
          var d3 = a2.color, g3 = o2.color, y2 = s2.color;
          (g3 || y2) && (e3.selectedColorFn = function(t4) {
            var e4 = t4.mcc || d3;
            return t4.selected ? g3 || e4 : y2 || e4;
          });
          var m3 = a2.size, x2 = o2.size, b2 = s2.size, _2 = void 0 !== x2, w3 = void 0 !== b2;
          return l.traceIs(t3, "symbols") && (_2 || w3) && (e3.selectedSizeFn = function(t4) {
            var e4 = t4.mrc || m3 / 2;
            return t4.selected ? _2 ? x2 / 2 : e4 : w3 ? b2 / 2 : e4;
          }), e3;
        }, x.makeSelectedTextStyleFns = function(t3) {
          var e3 = {}, r3 = t3.selected || {}, n3 = t3.unselected || {}, i2 = t3.textfont || {}, a2 = r3.textfont || {}, o2 = n3.textfont || {}, s2 = i2.color, l2 = a2.color, c2 = o2.color;
          return e3.selectedTextColorFn = function(t4) {
            var e4 = t4.tc || s2;
            return t4.selected ? l2 || e4 : c2 || (l2 ? e4 : u.addOpacity(e4, v));
          }, e3;
        }, x.selectedPointStyle = function(t3, e3) {
          if (t3.size() && e3.selectedpoints) {
            var r3 = x.makeSelectedPointStyleFns(e3), i2 = e3.marker || {}, a2 = [];
            r3.selectedOpacityFn && a2.push(function(t4, e4) {
              t4.style("opacity", r3.selectedOpacityFn(e4));
            }), r3.selectedColorFn && a2.push(function(t4, e4) {
              u.fill(t4, r3.selectedColorFn(e4));
            }), r3.selectedSizeFn && a2.push(function(t4, n3) {
              var a3 = n3.mx || i2.symbol || 0, o2 = r3.selectedSizeFn(n3);
              t4.attr("d", T(x.symbolNumber(a3), o2, rt(n3, e3), G(n3, e3))), n3.mrc2 = o2;
            }), a2.length && t3.each(function(t4) {
              for (var e4 = n2.select(this), r4 = 0; r4 < a2.length; r4++)
                a2[r4](e4, t4);
            });
          }
        }, x.tryColorscale = function(t3, e3) {
          var r3 = e3 ? i.nestedProperty(t3, e3).get() : t3;
          if (r3) {
            var n3 = r3.color;
            if ((r3.colorscale || r3._colorAx) && i.isArrayOrTypedArray(n3))
              return c.makeColorScaleFuncFromTrace(r3);
          }
          return i.identity;
        };
        var E, L, C = { start: 1, end: -1, middle: 0, bottom: 1, top: -1 };
        function P(t3, e3, r3, i2, a2) {
          var o2 = n2.select(t3.node().parentNode), s2 = -1 !== e3.indexOf("top") ? "top" : -1 !== e3.indexOf("bottom") ? "bottom" : "middle", l2 = -1 !== e3.indexOf("left") ? "end" : -1 !== e3.indexOf("right") ? "start" : "middle", u2 = i2 ? i2 / 0.8 + 1 : 0, c2 = (h.lineCount(t3) - 1) * d2 + 1, p3 = C[l2] * u2, v2 = 0.75 * r3 + C[s2] * u2 + (C[s2] - 1) * c2 * r3 / 2;
          t3.attr("text-anchor", l2), a2 || o2.attr("transform", f2(p3, v2));
        }
        function O(t3, e3) {
          var r3 = t3.ts || e3.textfont.size;
          return o(r3) && r3 > 0 ? r3 : 0;
        }
        function I(t3, e3, r3) {
          return r3 && (t3 = N(t3)), e3 ? z(t3[1]) : D(t3[0]);
        }
        function D(t3) {
          var e3 = n2.round(t3, 2);
          return E = e3, e3;
        }
        function z(t3) {
          var e3 = n2.round(t3, 2);
          return L = e3, e3;
        }
        function R(t3, e3, r3, n3) {
          var i2 = t3[0] - e3[0], a2 = t3[1] - e3[1], o2 = r3[0] - e3[0], s2 = r3[1] - e3[1], l2 = Math.pow(i2 * i2 + a2 * a2, 0.25), u2 = Math.pow(o2 * o2 + s2 * s2, 0.25), c2 = (u2 * u2 * i2 - l2 * l2 * o2) * n3, f3 = (u2 * u2 * a2 - l2 * l2 * s2) * n3, h2 = 3 * u2 * (l2 + u2), p3 = 3 * l2 * (l2 + u2);
          return [[D(e3[0] + (h2 && c2 / h2)), z(e3[1] + (h2 && f3 / h2))], [D(e3[0] - (p3 && c2 / p3)), z(e3[1] - (p3 && f3 / p3))]];
        }
        x.textPointStyle = function(t3, e3, r3) {
          if (t3.size()) {
            var a2;
            if (e3.selectedpoints) {
              var o2 = x.makeSelectedTextStyleFns(e3);
              a2 = o2.selectedTextColorFn;
            }
            var s2 = e3.texttemplate, l2 = r3._fullLayout;
            t3.each(function(t4) {
              var o3 = n2.select(this), u2 = s2 ? i.extractOption(t4, e3, "txt", "texttemplate") : i.extractOption(t4, e3, "tx", "text");
              if (u2 || 0 === u2) {
                if (s2) {
                  var c2 = e3._module.formatLabels, f3 = c2 ? c2(t4, e3, l2) : {}, p3 = {};
                  m2(p3, e3, t4.i);
                  var d3 = e3._meta || {};
                  u2 = i.texttemplateString(u2, f3, l2._d3locale, p3, t4, d3);
                }
                var v2 = t4.tp || e3.textposition, g3 = O(t4, e3), y2 = a2 ? a2(t4) : t4.tc || e3.textfont.color;
                o3.call(x.font, t4.tf || e3.textfont.family, g3, y2).text(u2).call(h.convertToTspans, r3).call(P, v2, g3, t4.mrc);
              } else
                o3.remove();
            });
          }
        }, x.selectedTextStyle = function(t3, e3) {
          if (t3.size() && e3.selectedpoints) {
            var r3 = x.makeSelectedTextStyleFns(e3);
            t3.each(function(t4) {
              var i2 = n2.select(this), a2 = r3.selectedTextColorFn(t4), o2 = t4.tp || e3.textposition, s2 = O(t4, e3);
              u.fill(i2, a2);
              var c2 = l.traceIs(e3, "bar-like");
              P(i2, o2, s2, t4.mrc2 || t4.mrc, c2);
            });
          }
        }, x.smoothopen = function(t3, e3) {
          if (t3.length < 3)
            return "M" + t3.join("L");
          var r3, n3 = "M" + t3[0], i2 = [];
          for (r3 = 1; r3 < t3.length - 1; r3++)
            i2.push(R(t3[r3 - 1], t3[r3], t3[r3 + 1], e3));
          for (n3 += "Q" + i2[0][0] + " " + t3[1], r3 = 2; r3 < t3.length - 1; r3++)
            n3 += "C" + i2[r3 - 2][1] + " " + i2[r3 - 1][0] + " " + t3[r3];
          return n3 + "Q" + i2[t3.length - 3][1] + " " + t3[t3.length - 1];
        }, x.smoothclosed = function(t3, e3) {
          if (t3.length < 3)
            return "M" + t3.join("L") + "Z";
          var r3, n3 = "M" + t3[0], i2 = t3.length - 1, a2 = [R(t3[i2], t3[0], t3[1], e3)];
          for (r3 = 1; r3 < i2; r3++)
            a2.push(R(t3[r3 - 1], t3[r3], t3[r3 + 1], e3));
          for (a2.push(R(t3[i2 - 1], t3[i2], t3[0], e3)), r3 = 1; r3 <= i2; r3++)
            n3 += "C" + a2[r3 - 1][1] + " " + a2[r3][0] + " " + t3[r3];
          return n3 + "C" + a2[i2][1] + " " + a2[0][0] + " " + t3[0] + "Z";
        };
        var F = { hv: function(t3, e3, r3) {
          return "H" + D(e3[0]) + "V" + I(e3, 1, r3);
        }, vh: function(t3, e3, r3) {
          return "V" + z(e3[1]) + "H" + I(e3, 0, r3);
        }, hvh: function(t3, e3, r3) {
          return "H" + D((t3[0] + e3[0]) / 2) + "V" + z(e3[1]) + "H" + I(e3, 0, r3);
        }, vhv: function(t3, e3, r3) {
          return "V" + z((t3[1] + e3[1]) / 2) + "H" + D(e3[0]) + "V" + I(e3, 1, r3);
        } }, B = function(t3, e3, r3) {
          return "L" + I(e3, 0, r3) + "," + I(e3, 1, r3);
        };
        function N(t3, e3) {
          var r3 = t3.backoff, n3 = t3.trace, a2 = t3.d, o2 = t3.i;
          if (r3 && n3 && n3.marker && n3.marker.angle % 360 == 0 && n3.line && "spline" !== n3.line.shape) {
            var s2 = i.isArrayOrTypedArray(r3), l2 = t3, u2 = e3 ? e3[0] : E || 0, c2 = e3 ? e3[1] : L || 0, f3 = l2[0], h2 = l2[1], p3 = f3 - u2, d3 = h2 - c2, v2 = Math.atan2(d3, p3), g3 = s2 ? r3[o2] : r3;
            if ("auto" === g3) {
              var y2 = l2.i;
              "scatter" === n3.type && y2--;
              var m3 = l2.marker, b2 = m3.symbol;
              i.isArrayOrTypedArray(b2) && (b2 = b2[y2]);
              var _2 = m3.size;
              i.isArrayOrTypedArray(_2) && (_2 = _2[y2]), g3 = m3 ? x.symbolBackOffs[x.symbolNumber(b2)] * _2 : 0, g3 += x.getMarkerStandoff(a2[y2], n3) || 0;
            }
            var w3 = f3 - g3 * Math.cos(v2), T2 = h2 - g3 * Math.sin(v2);
            (w3 <= f3 && w3 >= u2 || w3 >= f3 && w3 <= u2) && (T2 <= h2 && T2 >= c2 || T2 >= h2 && T2 <= c2) && (t3 = [w3, T2]);
          }
          return t3;
        }
        x.steps = function(t3) {
          var e3 = F[t3] || B;
          return function(t4) {
            for (var r3 = "M" + D(t4[0][0]) + "," + z(t4[0][1]), n3 = t4.length, i2 = 1; i2 < n3; i2++)
              r3 += e3(t4[i2 - 1], t4[i2], i2 === n3 - 1);
            return r3;
          };
        }, x.applyBackoff = N, x.makeTester = function() {
          var t3 = i.ensureSingleById(n2.select("body"), "svg", "js-plotly-tester", function(t4) {
            t4.attr(p2.svgAttrs).style({ position: "absolute", left: "-10000px", top: "-10000px", width: "9000px", height: "9000px", "z-index": "1" });
          }), e3 = i.ensureSingle(t3, "path", "js-reference-point", function(t4) {
            t4.attr("d", "M0,0H1V1H0Z").style({ "stroke-width": 0, fill: "black" });
          });
          x.tester = t3, x.testref = e3;
        }, x.savedBBoxes = {};
        var j = 0;
        function U(t3) {
          var e3 = t3.getAttribute("data-unformatted");
          if (null !== e3)
            return e3 + t3.getAttribute("data-math") + t3.getAttribute("text-anchor") + t3.getAttribute("style");
        }
        function V(t3, e3) {
          if (!t3)
            return null;
          var r3 = e3._context, n3 = r3._exportedPlot ? "" : r3._baseUrl || "";
          return n3 ? "url('" + n3 + "#" + t3 + "')" : "url(#" + t3 + ")";
        }
        x.bBox = function(t3, e3, r3) {
          var a2, o2, s2;
          if (r3 || (r3 = U(t3)), r3) {
            if (a2 = x.savedBBoxes[r3])
              return i.extendFlat({}, a2);
          } else if (1 === t3.childNodes.length) {
            var l2 = t3.childNodes[0];
            if (r3 = U(l2)) {
              var u2 = +l2.getAttribute("x") || 0, c2 = +l2.getAttribute("y") || 0, f3 = l2.getAttribute("transform");
              if (!f3) {
                var p3 = x.bBox(l2, false, r3);
                return u2 && (p3.left += u2, p3.right += u2), c2 && (p3.top += c2, p3.bottom += c2), p3;
              }
              if (r3 += "~" + u2 + "~" + c2 + "~" + f3, a2 = x.savedBBoxes[r3])
                return i.extendFlat({}, a2);
            }
          }
          e3 ? o2 = t3 : (s2 = x.tester.node(), o2 = t3.cloneNode(true), s2.appendChild(o2)), n2.select(o2).attr("transform", null).call(h.positionText, 0, 0);
          var d3 = o2.getBoundingClientRect(), v2 = x.testref.node().getBoundingClientRect();
          e3 || s2.removeChild(o2);
          var g3 = { height: d3.height, width: d3.width, left: d3.left - v2.left, top: d3.top - v2.top, right: d3.right - v2.left, bottom: d3.bottom - v2.top };
          return j >= 1e4 && (x.savedBBoxes = {}, j = 0), r3 && (x.savedBBoxes[r3] = g3), j++, i.extendFlat({}, g3);
        }, x.setClipUrl = function(t3, e3, r3) {
          t3.attr("clip-path", V(e3, r3));
        }, x.getTranslate = function(t3) {
          var e3 = (t3[t3.attr ? "attr" : "getAttribute"]("transform") || "").replace(/.*\btranslate\((-?\d*\.?\d*)[^-\d]*(-?\d*\.?\d*)[^\d].*/, function(t4, e4, r3) {
            return [e4, r3].join(" ");
          }).split(" ");
          return { x: +e3[0] || 0, y: +e3[1] || 0 };
        }, x.setTranslate = function(t3, e3, r3) {
          var n3 = t3.attr ? "attr" : "getAttribute", i2 = t3.attr ? "attr" : "setAttribute", a2 = t3[n3]("transform") || "";
          return e3 = e3 || 0, r3 = r3 || 0, a2 = a2.replace(/(\btranslate\(.*?\);?)/, "").trim(), a2 = (a2 += f2(e3, r3)).trim(), t3[i2]("transform", a2), a2;
        }, x.getScale = function(t3) {
          var e3 = (t3[t3.attr ? "attr" : "getAttribute"]("transform") || "").replace(/.*\bscale\((\d*\.?\d*)[^\d]*(\d*\.?\d*)[^\d].*/, function(t4, e4, r3) {
            return [e4, r3].join(" ");
          }).split(" ");
          return { x: +e3[0] || 1, y: +e3[1] || 1 };
        }, x.setScale = function(t3, e3, r3) {
          var n3 = t3.attr ? "attr" : "getAttribute", i2 = t3.attr ? "attr" : "setAttribute", a2 = t3[n3]("transform") || "";
          return e3 = e3 || 1, r3 = r3 || 1, a2 = a2.replace(/(\bscale\(.*?\);?)/, "").trim(), a2 = (a2 += "scale(" + e3 + "," + r3 + ")").trim(), t3[i2]("transform", a2), a2;
        };
        var H = /\s*sc.*/;
        x.setPointGroupScale = function(t3, e3, r3) {
          if (e3 = e3 || 1, r3 = r3 || 1, t3) {
            var n3 = 1 === e3 && 1 === r3 ? "" : "scale(" + e3 + "," + r3 + ")";
            t3.each(function() {
              var t4 = (this.getAttribute("transform") || "").replace(H, "");
              t4 = (t4 += n3).trim(), this.setAttribute("transform", t4);
            });
          }
        };
        var q2 = /translate\([^)]*\)\s*$/;
        function G(t3, e3) {
          var r3;
          return t3 && (r3 = t3.mf), void 0 === r3 && (r3 = e3.marker && e3.marker.standoff || 0), e3._geo || e3._xA ? r3 : -r3;
        }
        x.setTextPointsScale = function(t3, e3, r3) {
          t3 && t3.each(function() {
            var t4, i2 = n2.select(this), a2 = i2.select("text");
            if (a2.node()) {
              var o2 = parseFloat(a2.attr("x") || 0), s2 = parseFloat(a2.attr("y") || 0), l2 = (i2.attr("transform") || "").match(q2);
              t4 = 1 === e3 && 1 === r3 ? [] : [f2(o2, s2), "scale(" + e3 + "," + r3 + ")", f2(-o2, -s2)], l2 && t4.push(l2), i2.attr("transform", t4.join(""));
            }
          });
        }, x.getMarkerStandoff = G;
        var Z, Y, W, X, J, K, $ = Math.atan2, Q = Math.cos, tt = Math.sin;
        function et(t3, e3) {
          var r3 = e3[0], n3 = e3[1];
          return [r3 * Q(t3) - n3 * tt(t3), r3 * tt(t3) + n3 * Q(t3)];
        }
        function rt(t3, e3) {
          var r3, n3, i2 = t3.ma;
          void 0 === i2 && (i2 = e3.marker.angle || 0);
          var a2 = e3.marker.angleref;
          if ("previous" === a2 || "north" === a2) {
            if (e3._geo) {
              var s2 = e3._geo.project(t3.lonlat);
              r3 = s2[0], n3 = s2[1];
            } else {
              var l2 = e3._xA, u2 = e3._yA;
              if (!l2 || !u2)
                return 90;
              r3 = l2.c2p(t3.x), n3 = u2.c2p(t3.y);
            }
            if (e3._geo) {
              var c2, f3 = t3.lonlat[0], h2 = t3.lonlat[1], p3 = e3._geo.project([f3, h2 + 1e-5]), d3 = e3._geo.project([f3 + 1e-5, h2]), v2 = $(d3[1] - n3, d3[0] - r3), g3 = $(p3[1] - n3, p3[0] - r3);
              if ("north" === a2)
                c2 = i2 / 180 * Math.PI;
              else if ("previous" === a2) {
                var y2 = f3 / 180 * Math.PI, m3 = h2 / 180 * Math.PI, x2 = Z / 180 * Math.PI, b2 = Y / 180 * Math.PI, _2 = x2 - y2, w3 = Q(b2) * tt(_2), T2 = tt(b2) * Q(m3) - Q(b2) * tt(m3) * Q(_2);
                c2 = -$(w3, T2) - Math.PI, Z = f3, Y = h2;
              }
              var k2 = et(v2, [Q(c2), 0]), A2 = et(g3, [tt(c2), 0]);
              i2 = $(k2[1] + A2[1], k2[0] + A2[0]) / Math.PI * 180, "previous" !== a2 || K === e3.uid && t3.i === J + 1 || (i2 = null);
            }
            if ("previous" === a2 && !e3._geo)
              if (K === e3.uid && t3.i === J + 1 && o(r3) && o(n3)) {
                var M2 = r3 - W, S2 = n3 - X, E2 = e3.line && e3.line.shape || "", L2 = E2.slice(E2.length - 1);
                "h" === L2 && (S2 = 0), "v" === L2 && (M2 = 0), i2 += $(S2, M2) / Math.PI * 180 + 90;
              } else
                i2 = null;
          }
          return W = r3, X = n3, J = t3.i, K = e3.uid, i2;
        }
        x.getMarkerAngle = rt;
      }, 90998: function(t2, e2, r2) {
        var n2, i, a, o, s = r2(95616), l = r2(39898).round, u = "M0,0Z", c = Math.sqrt(2), f2 = Math.sqrt(3), h = Math.PI, p2 = Math.cos, d2 = Math.sin;
        function v(t3) {
          return null === t3;
        }
        function g2(t3, e3, r3) {
          if (!(t3 && t3 % 360 != 0 || e3))
            return r3;
          if (a === t3 && o === e3 && n2 === r3)
            return i;
          function l2(t4, r4) {
            var n3 = p2(t4), i2 = d2(t4), a2 = r4[0], o2 = r4[1] + (e3 || 0);
            return [a2 * n3 - o2 * i2, a2 * i2 + o2 * n3];
          }
          a = t3, o = e3, n2 = r3;
          for (var u2 = t3 / 180 * h, c2 = 0, f3 = 0, v2 = s(r3), g3 = "", y = 0; y < v2.length; y++) {
            var m2 = v2[y], x = m2[0], b = c2, _ = f3;
            if ("M" === x || "L" === x)
              c2 = +m2[1], f3 = +m2[2];
            else if ("m" === x || "l" === x)
              c2 += +m2[1], f3 += +m2[2];
            else if ("H" === x)
              c2 = +m2[1];
            else if ("h" === x)
              c2 += +m2[1];
            else if ("V" === x)
              f3 = +m2[1];
            else if ("v" === x)
              f3 += +m2[1];
            else if ("A" === x) {
              c2 = +m2[1], f3 = +m2[2];
              var w2 = l2(u2, [+m2[6], +m2[7]]);
              m2[6] = w2[0], m2[7] = w2[1], m2[3] = +m2[3] + t3;
            }
            "H" !== x && "V" !== x || (x = "L"), "h" !== x && "v" !== x || (x = "l"), "m" !== x && "l" !== x || (c2 -= b, f3 -= _);
            var T = l2(u2, [c2, f3]);
            "H" !== x && "V" !== x || (x = "L"), "M" !== x && "L" !== x && "m" !== x && "l" !== x || (m2[1] = T[0], m2[2] = T[1]), m2[0] = x, g3 += m2[0] + m2.slice(1).join(",");
          }
          return i = g3, g3;
        }
        t2.exports = { circle: { n: 0, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2), i2 = "M" + n3 + ",0A" + n3 + "," + n3 + " 0 1,1 0,-" + n3 + "A" + n3 + "," + n3 + " 0 0,1 " + n3 + ",0Z";
          return r3 ? g2(e3, r3, i2) : i2;
        } }, square: { n: 1, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M" + n3 + "," + n3 + "H-" + n3 + "V-" + n3 + "H" + n3 + "Z");
        } }, diamond: { n: 2, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.3 * t3, 2);
          return g2(e3, r3, "M" + n3 + ",0L0," + n3 + "L-" + n3 + ",0L0,-" + n3 + "Z");
        } }, cross: { n: 3, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(0.4 * t3, 2), i2 = l(1.2 * t3, 2);
          return g2(e3, r3, "M" + i2 + "," + n3 + "H" + n3 + "V" + i2 + "H-" + n3 + "V" + n3 + "H-" + i2 + "V-" + n3 + "H-" + n3 + "V-" + i2 + "H" + n3 + "V-" + n3 + "H" + i2 + "Z");
        } }, x: { n: 4, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(0.8 * t3 / c, 2), i2 = "l" + n3 + "," + n3, a2 = "l" + n3 + ",-" + n3, o2 = "l-" + n3 + ",-" + n3, s2 = "l-" + n3 + "," + n3;
          return g2(e3, r3, "M0," + n3 + i2 + a2 + o2 + a2 + o2 + s2 + o2 + s2 + i2 + s2 + i2 + "Z");
        } }, "triangle-up": { n: 5, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(2 * t3 / f2, 2);
          return g2(e3, r3, "M-" + n3 + "," + l(t3 / 2, 2) + "H" + n3 + "L0,-" + l(t3, 2) + "Z");
        } }, "triangle-down": { n: 6, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(2 * t3 / f2, 2);
          return g2(e3, r3, "M-" + n3 + ",-" + l(t3 / 2, 2) + "H" + n3 + "L0," + l(t3, 2) + "Z");
        } }, "triangle-left": { n: 7, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(2 * t3 / f2, 2);
          return g2(e3, r3, "M" + l(t3 / 2, 2) + ",-" + n3 + "V" + n3 + "L-" + l(t3, 2) + ",0Z");
        } }, "triangle-right": { n: 8, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(2 * t3 / f2, 2);
          return g2(e3, r3, "M-" + l(t3 / 2, 2) + ",-" + n3 + "V" + n3 + "L" + l(t3, 2) + ",0Z");
        } }, "triangle-ne": { n: 9, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(0.6 * t3, 2), i2 = l(1.2 * t3, 2);
          return g2(e3, r3, "M-" + i2 + ",-" + n3 + "H" + n3 + "V" + i2 + "Z");
        } }, "triangle-se": { n: 10, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(0.6 * t3, 2), i2 = l(1.2 * t3, 2);
          return g2(e3, r3, "M" + n3 + ",-" + i2 + "V" + n3 + "H-" + i2 + "Z");
        } }, "triangle-sw": { n: 11, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(0.6 * t3, 2), i2 = l(1.2 * t3, 2);
          return g2(e3, r3, "M" + i2 + "," + n3 + "H-" + n3 + "V-" + i2 + "Z");
        } }, "triangle-nw": { n: 12, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(0.6 * t3, 2), i2 = l(1.2 * t3, 2);
          return g2(e3, r3, "M-" + n3 + "," + i2 + "V-" + n3 + "H" + i2 + "Z");
        } }, pentagon: { n: 13, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(0.951 * t3, 2), i2 = l(0.588 * t3, 2), a2 = l(-t3, 2), o2 = l(-0.309 * t3, 2);
          return g2(e3, r3, "M" + n3 + "," + o2 + "L" + i2 + "," + l(0.809 * t3, 2) + "H-" + i2 + "L-" + n3 + "," + o2 + "L0," + a2 + "Z");
        } }, hexagon: { n: 14, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2), i2 = l(t3 / 2, 2), a2 = l(t3 * f2 / 2, 2);
          return g2(e3, r3, "M" + a2 + ",-" + i2 + "V" + i2 + "L0," + n3 + "L-" + a2 + "," + i2 + "V-" + i2 + "L0,-" + n3 + "Z");
        } }, hexagon2: { n: 15, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2), i2 = l(t3 / 2, 2), a2 = l(t3 * f2 / 2, 2);
          return g2(e3, r3, "M-" + i2 + "," + a2 + "H" + i2 + "L" + n3 + ",0L" + i2 + ",-" + a2 + "H-" + i2 + "L-" + n3 + ",0Z");
        } }, octagon: { n: 16, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(0.924 * t3, 2), i2 = l(0.383 * t3, 2);
          return g2(e3, r3, "M-" + i2 + ",-" + n3 + "H" + i2 + "L" + n3 + ",-" + i2 + "V" + i2 + "L" + i2 + "," + n3 + "H-" + i2 + "L-" + n3 + "," + i2 + "V-" + i2 + "Z");
        } }, star: { n: 17, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = 1.4 * t3, i2 = l(0.225 * n3, 2), a2 = l(0.951 * n3, 2), o2 = l(0.363 * n3, 2), s2 = l(0.588 * n3, 2), c2 = l(-n3, 2), f3 = l(-0.309 * n3, 2), h2 = l(0.118 * n3, 2), p3 = l(0.809 * n3, 2);
          return g2(e3, r3, "M" + i2 + "," + f3 + "H" + a2 + "L" + o2 + "," + h2 + "L" + s2 + "," + p3 + "L0," + l(0.382 * n3, 2) + "L-" + s2 + "," + p3 + "L-" + o2 + "," + h2 + "L-" + a2 + "," + f3 + "H-" + i2 + "L0," + c2 + "Z");
        } }, hexagram: { n: 18, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(0.66 * t3, 2), i2 = l(0.38 * t3, 2), a2 = l(0.76 * t3, 2);
          return g2(e3, r3, "M-" + a2 + ",0l-" + i2 + ",-" + n3 + "h" + a2 + "l" + i2 + ",-" + n3 + "l" + i2 + "," + n3 + "h" + a2 + "l-" + i2 + "," + n3 + "l" + i2 + "," + n3 + "h-" + a2 + "l-" + i2 + "," + n3 + "l-" + i2 + ",-" + n3 + "h-" + a2 + "Z");
        } }, "star-triangle-up": { n: 19, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3 * f2 * 0.8, 2), i2 = l(0.8 * t3, 2), a2 = l(1.6 * t3, 2), o2 = l(4 * t3, 2), s2 = "A " + o2 + "," + o2 + " 0 0 1 ";
          return g2(e3, r3, "M-" + n3 + "," + i2 + s2 + n3 + "," + i2 + s2 + "0,-" + a2 + s2 + "-" + n3 + "," + i2 + "Z");
        } }, "star-triangle-down": { n: 20, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3 * f2 * 0.8, 2), i2 = l(0.8 * t3, 2), a2 = l(1.6 * t3, 2), o2 = l(4 * t3, 2), s2 = "A " + o2 + "," + o2 + " 0 0 1 ";
          return g2(e3, r3, "M" + n3 + ",-" + i2 + s2 + "-" + n3 + ",-" + i2 + s2 + "0," + a2 + s2 + n3 + ",-" + i2 + "Z");
        } }, "star-square": { n: 21, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.1 * t3, 2), i2 = l(2 * t3, 2), a2 = "A " + i2 + "," + i2 + " 0 0 1 ";
          return g2(e3, r3, "M-" + n3 + ",-" + n3 + a2 + "-" + n3 + "," + n3 + a2 + n3 + "," + n3 + a2 + n3 + ",-" + n3 + a2 + "-" + n3 + ",-" + n3 + "Z");
        } }, "star-diamond": { n: 22, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.4 * t3, 2), i2 = l(1.9 * t3, 2), a2 = "A " + i2 + "," + i2 + " 0 0 1 ";
          return g2(e3, r3, "M-" + n3 + ",0" + a2 + "0," + n3 + a2 + n3 + ",0" + a2 + "0,-" + n3 + a2 + "-" + n3 + ",0Z");
        } }, "diamond-tall": { n: 23, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(0.7 * t3, 2), i2 = l(1.4 * t3, 2);
          return g2(e3, r3, "M0," + i2 + "L" + n3 + ",0L0,-" + i2 + "L-" + n3 + ",0Z");
        } }, "diamond-wide": { n: 24, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.4 * t3, 2), i2 = l(0.7 * t3, 2);
          return g2(e3, r3, "M0," + i2 + "L" + n3 + ",0L0,-" + i2 + "L-" + n3 + ",0Z");
        } }, hourglass: { n: 25, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M" + n3 + "," + n3 + "H-" + n3 + "L" + n3 + ",-" + n3 + "H-" + n3 + "Z");
        }, noDot: true }, bowtie: { n: 26, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M" + n3 + "," + n3 + "V-" + n3 + "L-" + n3 + "," + n3 + "V-" + n3 + "Z");
        }, noDot: true }, "circle-cross": { n: 27, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M0," + n3 + "V-" + n3 + "M" + n3 + ",0H-" + n3 + "M" + n3 + ",0A" + n3 + "," + n3 + " 0 1,1 0,-" + n3 + "A" + n3 + "," + n3 + " 0 0,1 " + n3 + ",0Z");
        }, needLine: true, noDot: true }, "circle-x": { n: 28, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2), i2 = l(t3 / c, 2);
          return g2(e3, r3, "M" + i2 + "," + i2 + "L-" + i2 + ",-" + i2 + "M" + i2 + ",-" + i2 + "L-" + i2 + "," + i2 + "M" + n3 + ",0A" + n3 + "," + n3 + " 0 1,1 0,-" + n3 + "A" + n3 + "," + n3 + " 0 0,1 " + n3 + ",0Z");
        }, needLine: true, noDot: true }, "square-cross": { n: 29, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M0," + n3 + "V-" + n3 + "M" + n3 + ",0H-" + n3 + "M" + n3 + "," + n3 + "H-" + n3 + "V-" + n3 + "H" + n3 + "Z");
        }, needLine: true, noDot: true }, "square-x": { n: 30, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M" + n3 + "," + n3 + "L-" + n3 + ",-" + n3 + "M" + n3 + ",-" + n3 + "L-" + n3 + "," + n3 + "M" + n3 + "," + n3 + "H-" + n3 + "V-" + n3 + "H" + n3 + "Z");
        }, needLine: true, noDot: true }, "diamond-cross": { n: 31, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.3 * t3, 2);
          return g2(e3, r3, "M" + n3 + ",0L0," + n3 + "L-" + n3 + ",0L0,-" + n3 + "ZM0,-" + n3 + "V" + n3 + "M-" + n3 + ",0H" + n3);
        }, needLine: true, noDot: true }, "diamond-x": { n: 32, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.3 * t3, 2), i2 = l(0.65 * t3, 2);
          return g2(e3, r3, "M" + n3 + ",0L0," + n3 + "L-" + n3 + ",0L0,-" + n3 + "ZM-" + i2 + ",-" + i2 + "L" + i2 + "," + i2 + "M-" + i2 + "," + i2 + "L" + i2 + ",-" + i2);
        }, needLine: true, noDot: true }, "cross-thin": { n: 33, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.4 * t3, 2);
          return g2(e3, r3, "M0," + n3 + "V-" + n3 + "M" + n3 + ",0H-" + n3);
        }, needLine: true, noDot: true, noFill: true }, "x-thin": { n: 34, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M" + n3 + "," + n3 + "L-" + n3 + ",-" + n3 + "M" + n3 + ",-" + n3 + "L-" + n3 + "," + n3);
        }, needLine: true, noDot: true, noFill: true }, asterisk: { n: 35, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.2 * t3, 2), i2 = l(0.85 * t3, 2);
          return g2(e3, r3, "M0," + n3 + "V-" + n3 + "M" + n3 + ",0H-" + n3 + "M" + i2 + "," + i2 + "L-" + i2 + ",-" + i2 + "M" + i2 + ",-" + i2 + "L-" + i2 + "," + i2);
        }, needLine: true, noDot: true, noFill: true }, hash: { n: 36, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3 / 2, 2), i2 = l(t3, 2);
          return g2(e3, r3, "M" + n3 + "," + i2 + "V-" + i2 + "M" + (n3 - i2) + ",-" + i2 + "V" + i2 + "M" + i2 + "," + n3 + "H-" + i2 + "M-" + i2 + "," + (n3 - i2) + "H" + i2);
        }, needLine: true, noFill: true }, "y-up": { n: 37, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.2 * t3, 2), i2 = l(1.6 * t3, 2), a2 = l(0.8 * t3, 2);
          return g2(e3, r3, "M-" + n3 + "," + a2 + "L0,0M" + n3 + "," + a2 + "L0,0M0,-" + i2 + "L0,0");
        }, needLine: true, noDot: true, noFill: true }, "y-down": { n: 38, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.2 * t3, 2), i2 = l(1.6 * t3, 2), a2 = l(0.8 * t3, 2);
          return g2(e3, r3, "M-" + n3 + ",-" + a2 + "L0,0M" + n3 + ",-" + a2 + "L0,0M0," + i2 + "L0,0");
        }, needLine: true, noDot: true, noFill: true }, "y-left": { n: 39, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.2 * t3, 2), i2 = l(1.6 * t3, 2), a2 = l(0.8 * t3, 2);
          return g2(e3, r3, "M" + a2 + "," + n3 + "L0,0M" + a2 + ",-" + n3 + "L0,0M-" + i2 + ",0L0,0");
        }, needLine: true, noDot: true, noFill: true }, "y-right": { n: 40, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.2 * t3, 2), i2 = l(1.6 * t3, 2), a2 = l(0.8 * t3, 2);
          return g2(e3, r3, "M-" + a2 + "," + n3 + "L0,0M-" + a2 + ",-" + n3 + "L0,0M" + i2 + ",0L0,0");
        }, needLine: true, noDot: true, noFill: true }, "line-ew": { n: 41, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.4 * t3, 2);
          return g2(e3, r3, "M" + n3 + ",0H-" + n3);
        }, needLine: true, noDot: true, noFill: true }, "line-ns": { n: 42, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(1.4 * t3, 2);
          return g2(e3, r3, "M0," + n3 + "V-" + n3);
        }, needLine: true, noDot: true, noFill: true }, "line-ne": { n: 43, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M" + n3 + ",-" + n3 + "L-" + n3 + "," + n3);
        }, needLine: true, noDot: true, noFill: true }, "line-nw": { n: 44, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M" + n3 + "," + n3 + "L-" + n3 + ",-" + n3);
        }, needLine: true, noDot: true, noFill: true }, "arrow-up": { n: 45, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M0,0L-" + n3 + "," + l(2 * t3, 2) + "H" + n3 + "Z");
        }, backoff: 1, noDot: true }, "arrow-down": { n: 46, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M0,0L-" + n3 + ",-" + l(2 * t3, 2) + "H" + n3 + "Z");
        }, noDot: true }, "arrow-left": { n: 47, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(2 * t3, 2), i2 = l(t3, 2);
          return g2(e3, r3, "M0,0L" + n3 + ",-" + i2 + "V" + i2 + "Z");
        }, noDot: true }, "arrow-right": { n: 48, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(2 * t3, 2), i2 = l(t3, 2);
          return g2(e3, r3, "M0,0L-" + n3 + ",-" + i2 + "V" + i2 + "Z");
        }, noDot: true }, "arrow-bar-up": { n: 49, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M-" + n3 + ",0H" + n3 + "M0,0L-" + n3 + "," + l(2 * t3, 2) + "H" + n3 + "Z");
        }, backoff: 1, needLine: true, noDot: true }, "arrow-bar-down": { n: 50, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(t3, 2);
          return g2(e3, r3, "M-" + n3 + ",0H" + n3 + "M0,0L-" + n3 + ",-" + l(2 * t3, 2) + "H" + n3 + "Z");
        }, needLine: true, noDot: true }, "arrow-bar-left": { n: 51, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(2 * t3, 2), i2 = l(t3, 2);
          return g2(e3, r3, "M0,-" + i2 + "V" + i2 + "M0,0L" + n3 + ",-" + i2 + "V" + i2 + "Z");
        }, needLine: true, noDot: true }, "arrow-bar-right": { n: 52, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = l(2 * t3, 2), i2 = l(t3, 2);
          return g2(e3, r3, "M0,-" + i2 + "V" + i2 + "M0,0L-" + n3 + ",-" + i2 + "V" + i2 + "Z");
        }, needLine: true, noDot: true }, arrow: { n: 53, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = h / 2.5, i2 = 2 * t3 * p2(n3), a2 = 2 * t3 * d2(n3);
          return g2(e3, r3, "M0,0L" + -i2 + "," + a2 + "L" + i2 + "," + a2 + "Z");
        }, backoff: 0.9, noDot: true }, "arrow-wide": { n: 54, f: function(t3, e3, r3) {
          if (v(e3))
            return u;
          var n3 = h / 4, i2 = 2 * t3 * p2(n3), a2 = 2 * t3 * d2(n3);
          return g2(e3, r3, "M0,0L" + -i2 + "," + a2 + "A " + 2 * t3 + "," + 2 * t3 + " 0 0 1 " + i2 + "," + a2 + "Z");
        }, backoff: 0.4, noDot: true } };
      }, 25673: function(t2) {
        t2.exports = { visible: { valType: "boolean", editType: "calc" }, type: { valType: "enumerated", values: ["percent", "constant", "sqrt", "data"], editType: "calc" }, symmetric: { valType: "boolean", editType: "calc" }, array: { valType: "data_array", editType: "calc" }, arrayminus: { valType: "data_array", editType: "calc" }, value: { valType: "number", min: 0, dflt: 10, editType: "calc" }, valueminus: { valType: "number", min: 0, dflt: 10, editType: "calc" }, traceref: { valType: "integer", min: 0, dflt: 0, editType: "style" }, tracerefminus: { valType: "integer", min: 0, dflt: 0, editType: "style" }, copy_ystyle: { valType: "boolean", editType: "plot" }, copy_zstyle: { valType: "boolean", editType: "style" }, color: { valType: "color", editType: "style" }, thickness: { valType: "number", min: 0, dflt: 2, editType: "style" }, width: { valType: "number", min: 0, editType: "plot" }, editType: "calc", _deprecated: { opacity: { valType: "number", editType: "style" } } };
      }, 84532: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(73972), a = r2(89298), o = r2(71828), s = r2(45827);
        function l(t3, e3, r3, i2) {
          var l2 = e3["error_" + i2] || {}, u = [];
          if (l2.visible && -1 !== ["linear", "log"].indexOf(r3.type)) {
            for (var c = s(l2), f2 = 0; f2 < t3.length; f2++) {
              var h = t3[f2], p2 = h.i;
              if (void 0 === p2)
                p2 = f2;
              else if (null === p2)
                continue;
              var d2 = h[i2];
              if (n2(r3.c2l(d2))) {
                var v = c(d2, p2);
                if (n2(v[0]) && n2(v[1])) {
                  var g2 = h[i2 + "s"] = d2 - v[0], y = h[i2 + "h"] = d2 + v[1];
                  u.push(g2, y);
                }
              }
            }
            var m2 = r3._id, x = e3._extremes[m2], b = a.findExtremes(r3, u, o.extendFlat({ tozero: x.opts.tozero }, { padded: true }));
            x.min = x.min.concat(b.min), x.max = x.max.concat(b.max);
          }
        }
        t2.exports = function(t3) {
          for (var e3 = t3.calcdata, r3 = 0; r3 < e3.length; r3++) {
            var n3 = e3[r3], o2 = n3[0].trace;
            if (true === o2.visible && i.traceIs(o2, "errorBarsOK")) {
              var s2 = a.getFromId(t3, o2.xaxis), u = a.getFromId(t3, o2.yaxis);
              l(n3, o2, s2, "x"), l(n3, o2, u, "y");
            }
          }
        };
      }, 45827: function(t2) {
        function e2(t3, e3) {
          return "percent" === t3 ? function(t4) {
            return Math.abs(t4 * e3 / 100);
          } : "constant" === t3 ? function() {
            return Math.abs(e3);
          } : "sqrt" === t3 ? function(t4) {
            return Math.sqrt(Math.abs(t4));
          } : void 0;
        }
        t2.exports = function(t3) {
          var r2 = t3.type, n2 = t3.symmetric;
          if ("data" === r2) {
            var i = t3.array || [];
            if (n2)
              return function(t4, e3) {
                var r3 = +i[e3];
                return [r3, r3];
              };
            var a = t3.arrayminus || [];
            return function(t4, e3) {
              var r3 = +i[e3], n3 = +a[e3];
              return isNaN(r3) && isNaN(n3) ? [NaN, NaN] : [n3 || 0, r3 || 0];
            };
          }
          var o = e2(r2, t3.value), s = e2(r2, t3.valueminus);
          return n2 || void 0 === t3.valueminus ? function(t4) {
            var e3 = o(t4);
            return [e3, e3];
          } : function(t4) {
            return [s(t4), o(t4)];
          };
        };
      }, 97587: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(73972), a = r2(71828), o = r2(44467), s = r2(25673);
        t2.exports = function(t3, e3, r3, l) {
          var u = "error_" + l.axis, c = o.newContainer(e3, u), f2 = t3[u] || {};
          function h(t4, e4) {
            return a.coerce(f2, c, s, t4, e4);
          }
          if (false !== h("visible", void 0 !== f2.array || void 0 !== f2.value || "sqrt" === f2.type)) {
            var p2 = h("type", "array" in f2 ? "data" : "percent"), d2 = true;
            "sqrt" !== p2 && (d2 = h("symmetric", !(("data" === p2 ? "arrayminus" : "valueminus") in f2))), "data" === p2 ? (h("array"), h("traceref"), d2 || (h("arrayminus"), h("tracerefminus"))) : "percent" !== p2 && "constant" !== p2 || (h("value"), d2 || h("valueminus"));
            var v = "copy_" + l.inherit + "style";
            l.inherit && (e3["error_" + l.inherit] || {}).visible && h(v, !(f2.color || n2(f2.thickness) || n2(f2.width))), l.inherit && c[v] || (h("color", r3), h("thickness"), h("width", i.traceIs(e3, "gl3d") ? 0 : 4));
          }
        };
      }, 37369: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(30962).overrideAll, a = r2(25673), o = { error_x: n2.extendFlat({}, a), error_y: n2.extendFlat({}, a) };
        delete o.error_x.copy_zstyle, delete o.error_y.copy_zstyle, delete o.error_y.copy_ystyle;
        var s = { error_x: n2.extendFlat({}, a), error_y: n2.extendFlat({}, a), error_z: n2.extendFlat({}, a) };
        delete s.error_x.copy_ystyle, delete s.error_y.copy_ystyle, delete s.error_z.copy_ystyle, delete s.error_z.copy_zstyle, t2.exports = { moduleType: "component", name: "errorbars", schema: { traces: { scatter: o, bar: o, histogram: o, scatter3d: i(s, "calc", "nested"), scattergl: i(o, "calc", "nested") } }, supplyDefaults: r2(97587), calc: r2(84532), makeComputeError: r2(45827), plot: r2(19398), style: r2(62662), hoverInfo: function(t3, e3, r3) {
          (e3.error_y || {}).visible && (r3.yerr = t3.yh - t3.y, e3.error_y.symmetric || (r3.yerrneg = t3.y - t3.ys)), (e3.error_x || {}).visible && (r3.xerr = t3.xh - t3.x, e3.error_x.symmetric || (r3.xerrneg = t3.x - t3.xs));
        } };
      }, 19398: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(92770), a = r2(91424), o = r2(34098);
        t2.exports = function(t3, e3, r3, s) {
          var l = r3.xaxis, u = r3.yaxis, c = s && s.duration > 0, f2 = t3._context.staticPlot;
          e3.each(function(e4) {
            var h, p2 = e4[0].trace, d2 = p2.error_x || {}, v = p2.error_y || {};
            p2.ids && (h = function(t4) {
              return t4.id;
            });
            var g2 = o.hasMarkers(p2) && p2.marker.maxdisplayed > 0;
            v.visible || d2.visible || (e4 = []);
            var y = n2.select(this).selectAll("g.errorbar").data(e4, h);
            if (y.exit().remove(), e4.length) {
              d2.visible || y.selectAll("path.xerror").remove(), v.visible || y.selectAll("path.yerror").remove(), y.style("opacity", 1);
              var m2 = y.enter().append("g").classed("errorbar", true);
              c && m2.style("opacity", 0).transition().duration(s.duration).style("opacity", 1), a.setClipUrl(y, r3.layerClipId, t3), y.each(function(t4) {
                var e5 = n2.select(this), r4 = function(t5, e6, r5) {
                  var n3 = { x: e6.c2p(t5.x), y: r5.c2p(t5.y) };
                  return void 0 !== t5.yh && (n3.yh = r5.c2p(t5.yh), n3.ys = r5.c2p(t5.ys), i(n3.ys) || (n3.noYS = true, n3.ys = r5.c2p(t5.ys, true))), void 0 !== t5.xh && (n3.xh = e6.c2p(t5.xh), n3.xs = e6.c2p(t5.xs), i(n3.xs) || (n3.noXS = true, n3.xs = e6.c2p(t5.xs, true))), n3;
                }(t4, l, u);
                if (!g2 || t4.vis) {
                  var a2, o2 = e5.select("path.yerror");
                  if (v.visible && i(r4.x) && i(r4.yh) && i(r4.ys)) {
                    var h2 = v.width;
                    a2 = "M" + (r4.x - h2) + "," + r4.yh + "h" + 2 * h2 + "m-" + h2 + ",0V" + r4.ys, r4.noYS || (a2 += "m-" + h2 + ",0h" + 2 * h2), o2.size() ? c && (o2 = o2.transition().duration(s.duration).ease(s.easing)) : o2 = e5.append("path").style("vector-effect", f2 ? "none" : "non-scaling-stroke").classed("yerror", true), o2.attr("d", a2);
                  } else
                    o2.remove();
                  var p3 = e5.select("path.xerror");
                  if (d2.visible && i(r4.y) && i(r4.xh) && i(r4.xs)) {
                    var y2 = (d2.copy_ystyle ? v : d2).width;
                    a2 = "M" + r4.xh + "," + (r4.y - y2) + "v" + 2 * y2 + "m0,-" + y2 + "H" + r4.xs, r4.noXS || (a2 += "m0,-" + y2 + "v" + 2 * y2), p3.size() ? c && (p3 = p3.transition().duration(s.duration).ease(s.easing)) : p3 = e5.append("path").style("vector-effect", f2 ? "none" : "non-scaling-stroke").classed("xerror", true), p3.attr("d", a2);
                  } else
                    p3.remove();
                }
              });
            }
          });
        };
      }, 62662: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(7901);
        t2.exports = function(t3) {
          t3.each(function(t4) {
            var e3 = t4[0].trace, r3 = e3.error_y || {}, a = e3.error_x || {}, o = n2.select(this);
            o.selectAll("path.yerror").style("stroke-width", r3.thickness + "px").call(i.stroke, r3.color), a.copy_ystyle && (a = r3), o.selectAll("path.xerror").style("stroke-width", a.thickness + "px").call(i.stroke, a.color);
          });
        };
      }, 77914: function(t2, e2, r2) {
        var n2 = r2(41940), i = r2(528).hoverlabel, a = r2(1426).extendFlat;
        t2.exports = { hoverlabel: { bgcolor: a({}, i.bgcolor, { arrayOk: true }), bordercolor: a({}, i.bordercolor, { arrayOk: true }), font: n2({ arrayOk: true, editType: "none" }), align: a({}, i.align, { arrayOk: true }), namelength: a({}, i.namelength, { arrayOk: true }), editType: "none" } };
      }, 30732: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(73972);
        function a(t3, e3, r3, i2) {
          i2 = i2 || n2.identity, Array.isArray(t3) && (e3[0][r3] = i2(t3));
        }
        t2.exports = function(t3) {
          var e3 = t3.calcdata, r3 = t3._fullLayout;
          function o(t4) {
            return function(e4) {
              return n2.coerceHoverinfo({ hoverinfo: e4 }, { _module: t4._module }, r3);
            };
          }
          for (var s = 0; s < e3.length; s++) {
            var l = e3[s], u = l[0].trace;
            if (!i.traceIs(u, "pie-like")) {
              var c = i.traceIs(u, "2dMap") ? a : n2.fillArray;
              c(u.hoverinfo, l, "hi", o(u)), u.hovertemplate && c(u.hovertemplate, l, "ht"), u.hoverlabel && (c(u.hoverlabel.bgcolor, l, "hbg"), c(u.hoverlabel.bordercolor, l, "hbc"), c(u.hoverlabel.font.size, l, "hts"), c(u.hoverlabel.font.color, l, "htc"), c(u.hoverlabel.font.family, l, "htf"), c(u.hoverlabel.namelength, l, "hnl"), c(u.hoverlabel.align, l, "hta"));
            }
          }
        };
      }, 75914: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(88335).hover;
        t2.exports = function(t3, e3, r3) {
          var a = n2.getComponentMethod("annotations", "onClick")(t3, t3._hoverdata);
          function o() {
            t3.emit("plotly_click", { points: t3._hoverdata, event: e3 });
          }
          void 0 !== r3 && i(t3, e3, r3, true), t3._hoverdata && e3 && e3.target && (a && a.then ? a.then(o) : o(), e3.stopImmediatePropagation && e3.stopImmediatePropagation());
        };
      }, 26675: function(t2) {
        t2.exports = { YANGLE: 60, HOVERARROWSIZE: 6, HOVERTEXTPAD: 3, HOVERFONTSIZE: 13, HOVERFONT: "Arial, sans-serif", HOVERMINTIME: 50, HOVERID: "-hover" };
      }, 54268: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(77914), a = r2(38048);
        t2.exports = function(t3, e3, r3, o) {
          var s = n2.extendFlat({}, o.hoverlabel);
          e3.hovertemplate && (s.namelength = -1), a(t3, e3, function(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }, s);
        };
      }, 23469: function(t2, e2, r2) {
        var n2 = r2(71828);
        e2.getSubplot = function(t3) {
          return t3.subplot || t3.xaxis + t3.yaxis || t3.geo;
        }, e2.isTraceInSubplots = function(t3, r3) {
          if ("splom" === t3.type) {
            for (var n3 = t3.xaxes || [], i2 = t3.yaxes || [], a2 = 0; a2 < n3.length; a2++)
              for (var o2 = 0; o2 < i2.length; o2++)
                if (-1 !== r3.indexOf(n3[a2] + i2[o2]))
                  return true;
            return false;
          }
          return -1 !== r3.indexOf(e2.getSubplot(t3));
        }, e2.flat = function(t3, e3) {
          for (var r3 = new Array(t3.length), n3 = 0; n3 < t3.length; n3++)
            r3[n3] = e3;
          return r3;
        }, e2.p2c = function(t3, e3) {
          for (var r3 = new Array(t3.length), n3 = 0; n3 < t3.length; n3++)
            r3[n3] = t3[n3].p2c(e3);
          return r3;
        }, e2.getDistanceFunction = function(t3, r3, n3, i2) {
          return "closest" === t3 ? i2 || e2.quadrature(r3, n3) : "x" === t3.charAt(0) ? r3 : n3;
        }, e2.getClosest = function(t3, e3, r3) {
          if (false !== r3.index)
            r3.index >= 0 && r3.index < t3.length ? r3.distance = 0 : r3.index = false;
          else
            for (var n3 = 0; n3 < t3.length; n3++) {
              var i2 = e3(t3[n3]);
              i2 <= r3.distance && (r3.index = n3, r3.distance = i2);
            }
          return r3;
        }, e2.inbox = function(t3, e3, r3) {
          return t3 * e3 < 0 || 0 === t3 ? r3 : 1 / 0;
        }, e2.quadrature = function(t3, e3) {
          return function(r3) {
            var n3 = t3(r3), i2 = e3(r3);
            return Math.sqrt(n3 * n3 + i2 * i2);
          };
        }, e2.makeEventData = function(t3, r3, n3) {
          var i2 = "index" in t3 ? t3.index : t3.pointNumber, a2 = { data: r3._input, fullData: r3, curveNumber: r3.index, pointNumber: i2 };
          if (r3._indexToPoints) {
            var o2 = r3._indexToPoints[i2];
            1 === o2.length ? a2.pointIndex = o2[0] : a2.pointIndices = o2;
          } else
            a2.pointIndex = i2;
          return r3._module.eventData ? a2 = r3._module.eventData(a2, t3, r3, n3, i2) : ("xVal" in t3 ? a2.x = t3.xVal : "x" in t3 && (a2.x = t3.x), "yVal" in t3 ? a2.y = t3.yVal : "y" in t3 && (a2.y = t3.y), t3.xa && (a2.xaxis = t3.xa), t3.ya && (a2.yaxis = t3.ya), void 0 !== t3.zLabelVal && (a2.z = t3.zLabelVal)), e2.appendArrayPointValue(a2, r3, i2), a2;
        }, e2.appendArrayPointValue = function(t3, e3, r3) {
          var i2 = e3._arrayAttrs;
          if (i2)
            for (var s2 = 0; s2 < i2.length; s2++) {
              var l2 = i2[s2], u = a(l2);
              if (void 0 === t3[u]) {
                var c = o(n2.nestedProperty(e3, l2).get(), r3);
                void 0 !== c && (t3[u] = c);
              }
            }
        }, e2.appendArrayMultiPointValues = function(t3, e3, r3) {
          var i2 = e3._arrayAttrs;
          if (i2)
            for (var s2 = 0; s2 < i2.length; s2++) {
              var l2 = i2[s2], u = a(l2);
              if (void 0 === t3[u]) {
                for (var c = n2.nestedProperty(e3, l2).get(), f2 = new Array(r3.length), h = 0; h < r3.length; h++)
                  f2[h] = o(c, r3[h]);
                t3[u] = f2;
              }
            }
        };
        var i = { ids: "id", locations: "location", labels: "label", values: "value", "marker.colors": "color", parents: "parent" };
        function a(t3) {
          return i[t3] || t3;
        }
        function o(t3, e3) {
          return Array.isArray(e3) ? Array.isArray(t3) && Array.isArray(t3[e3[0]]) ? t3[e3[0]][e3[1]] : void 0 : t3[e3];
        }
        var s = { x: true, y: true }, l = { "x unified": true, "y unified": true };
        e2.isUnifiedHover = function(t3) {
          return "string" == typeof t3 && !!l[t3];
        }, e2.isXYhover = function(t3) {
          return "string" == typeof t3 && !!s[t3];
        };
      }, 88335: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(92770), a = r2(84267), o = r2(71828), s = o.strTranslate, l = o.strRotate, u = r2(11086), c = r2(63893), f2 = r2(39918), h = r2(91424), p2 = r2(7901), d2 = r2(28569), v = r2(89298), g2 = r2(73972), y = r2(23469), m2 = r2(26675), x = r2(99017), b = r2(43969), _ = m2.YANGLE, w2 = Math.PI * _ / 180, T = 1 / Math.sin(w2), k = Math.cos(w2), A = Math.sin(w2), M = m2.HOVERARROWSIZE, S = m2.HOVERTEXTPAD, E = { box: true, ohlc: true, violin: true, candlestick: true }, L = { scatter: true, scattergl: true, splom: true };
        function C(t3) {
          return [t3.trace.index, t3.index, t3.x0, t3.y0, t3.name, t3.attr, t3.xa ? t3.xa._id : "", t3.ya ? t3.ya._id : ""].join(",");
        }
        e2.hover = function(t3, e3, r3, a2) {
          t3 = o.getGraphDiv(t3);
          var s2 = e3.target;
          o.throttle(t3._fullLayout._uid + m2.HOVERID, m2.HOVERMINTIME, function() {
            !function(t4, e4, r4, a3, s3) {
              r4 || (r4 = "xy");
              var l2 = Array.isArray(r4) ? r4 : [r4], c2 = t4._fullLayout, h2 = c2._plots || [], v2 = h2[r4], m3 = c2._has("cartesian");
              if (v2) {
                var x2 = v2.overlays.map(function(t5) {
                  return t5.id;
                });
                l2 = l2.concat(x2);
              }
              for (var b2 = l2.length, _2 = new Array(b2), w3 = new Array(b2), k2 = false, A2 = 0; A2 < b2; A2++) {
                var S2 = l2[A2];
                if (h2[S2])
                  k2 = true, _2[A2] = h2[S2].xaxis, w3[A2] = h2[S2].yaxis;
                else {
                  if (!c2[S2] || !c2[S2]._subplot)
                    return void o.warn("Unrecognized subplot: " + S2);
                  var P2 = c2[S2]._subplot;
                  _2[A2] = P2.xaxis, w3[A2] = P2.yaxis;
                }
              }
              var I2 = e4.hovermode || c2.hovermode;
              if (I2 && !k2 && (I2 = "closest"), -1 === ["x", "y", "closest", "x unified", "y unified"].indexOf(I2) || !t4.calcdata || t4.querySelector(".zoombox") || t4._dragging)
                return d2.unhoverRaw(t4, e4);
              var N2 = c2.hoverdistance;
              -1 === N2 && (N2 = 1 / 0);
              var H2 = c2.spikedistance;
              -1 === H2 && (H2 = 1 / 0);
              var q2, G, Z, Y, W, X, J, K, $, Q, tt, et, rt, nt = [], it = [], at = { hLinePoint: null, vLinePoint: null }, ot = false;
              if (Array.isArray(e4))
                for (I2 = "array", Z = 0; Z < e4.length; Z++)
                  (W = t4.calcdata[e4[Z].curveNumber || 0]) && (X = W[0].trace, "skip" !== W[0].trace.hoverinfo && (it.push(W), "h" === X.orientation && (ot = true)));
              else {
                for (Y = 0; Y < t4.calcdata.length; Y++)
                  W = t4.calcdata[Y], "skip" !== (X = W[0].trace).hoverinfo && y.isTraceInSubplots(X, l2) && (it.push(W), "h" === X.orientation && (ot = true));
                var st, lt;
                if (s3) {
                  if (false === u.triggerHandler(t4, "plotly_beforehover", e4))
                    return;
                  var ut = s3.getBoundingClientRect();
                  st = e4.clientX - ut.left, lt = e4.clientY - ut.top, c2._calcInverseTransform(t4);
                  var ct = o.apply3DTransform(c2._invTransform)(st, lt);
                  if (st = ct[0], lt = ct[1], st < 0 || st > _2[0]._length || lt < 0 || lt > w3[0]._length)
                    return d2.unhoverRaw(t4, e4);
                } else
                  st = "xpx" in e4 ? e4.xpx : _2[0]._length / 2, lt = "ypx" in e4 ? e4.ypx : w3[0]._length / 2;
                if (e4.pointerX = st + _2[0]._offset, e4.pointerY = lt + w3[0]._offset, q2 = "xval" in e4 ? y.flat(l2, e4.xval) : y.p2c(_2, st), G = "yval" in e4 ? y.flat(l2, e4.yval) : y.p2c(w3, lt), !i(q2[0]) || !i(G[0]))
                  return o.warn("Fx.hover failed", e4, t4), d2.unhoverRaw(t4, e4);
              }
              var ft = 1 / 0;
              function ht(t5, r5) {
                for (Y = 0; Y < it.length; Y++)
                  if ((W = it[Y]) && W[0] && W[0].trace && true === (X = W[0].trace).visible && 0 !== X._length && -1 === ["carpet", "contourcarpet"].indexOf(X._module.name)) {
                    if ("splom" === X.type ? J = l2[K = 0] : (J = y.getSubplot(X), K = l2.indexOf(J)), $ = I2, y.isUnifiedHover($) && ($ = $.charAt(0)), et = { cd: W, trace: X, xa: _2[K], ya: w3[K], maxHoverDistance: N2, maxSpikeDistance: H2, index: false, distance: Math.min(ft, N2), spikeDistance: 1 / 0, xSpike: void 0, ySpike: void 0, color: p2.defaultLine, name: X.name, x0: void 0, x1: void 0, y0: void 0, y1: void 0, xLabelVal: void 0, yLabelVal: void 0, zLabelVal: void 0, text: void 0 }, c2[J] && (et.subplot = c2[J]._subplot), c2._splomScenes && c2._splomScenes[X.uid] && (et.scene = c2._splomScenes[X.uid]), rt = nt.length, "array" === $) {
                      var n3 = e4[Y];
                      "pointNumber" in n3 ? (et.index = n3.pointNumber, $ = "closest") : ($ = "", "xval" in n3 && (Q = n3.xval, $ = "x"), "yval" in n3 && (tt = n3.yval, $ = $ ? "closest" : "y"));
                    } else
                      void 0 !== t5 && void 0 !== r5 ? (Q = t5, tt = r5) : (Q = q2[K], tt = G[K]);
                    if (0 !== N2)
                      if (X._module && X._module.hoverPoints) {
                        var a4 = X._module.hoverPoints(et, Q, tt, $, { finiteRange: true, hoverLayer: c2._hoverlayer });
                        if (a4)
                          for (var s4, u2 = 0; u2 < a4.length; u2++)
                            s4 = a4[u2], i(s4.x0) && i(s4.y0) && nt.push(R(s4, I2));
                      } else
                        o.log("Unrecognized trace type in hover:", X);
                    if ("closest" === I2 && nt.length > rt && (nt.splice(0, rt), ft = nt[0].distance), m3 && 0 !== H2 && 0 === nt.length) {
                      et.distance = H2, et.index = false;
                      var f3 = X._module.hoverPoints(et, Q, tt, "closest", { hoverLayer: c2._hoverlayer });
                      if (f3 && (f3 = f3.filter(function(t6) {
                        return t6.spikeDistance <= H2;
                      })), f3 && f3.length) {
                        var h3, d3 = f3.filter(function(t6) {
                          return t6.xa.showspikes && "hovered data" !== t6.xa.spikesnap;
                        });
                        if (d3.length) {
                          var v3 = d3[0];
                          i(v3.x0) && i(v3.y0) && (h3 = dt(v3), (!at.vLinePoint || at.vLinePoint.spikeDistance > h3.spikeDistance) && (at.vLinePoint = h3));
                        }
                        var g3 = f3.filter(function(t6) {
                          return t6.ya.showspikes && "hovered data" !== t6.ya.spikesnap;
                        });
                        if (g3.length) {
                          var x3 = g3[0];
                          i(x3.x0) && i(x3.y0) && (h3 = dt(x3), (!at.hLinePoint || at.hLinePoint.spikeDistance > h3.spikeDistance) && (at.hLinePoint = h3));
                        }
                      }
                    }
                  }
              }
              function pt(t5, e5, r5) {
                for (var n3, i2 = null, a4 = 1 / 0, o2 = 0; o2 < t5.length; o2++)
                  n3 = t5[o2].spikeDistance, r5 && 0 === o2 && (n3 = -1 / 0), n3 <= a4 && n3 <= e5 && (i2 = t5[o2], a4 = n3);
                return i2;
              }
              function dt(t5) {
                return t5 ? { xa: t5.xa, ya: t5.ya, x: void 0 !== t5.xSpike ? t5.xSpike : (t5.x0 + t5.x1) / 2, y: void 0 !== t5.ySpike ? t5.ySpike : (t5.y0 + t5.y1) / 2, distance: t5.distance, spikeDistance: t5.spikeDistance, curveNumber: t5.trace.index, color: t5.color, pointNumber: t5.index } : null;
              }
              ht();
              var vt = { fullLayout: c2, container: c2._hoverlayer, event: e4 }, gt = t4._spikepoints, yt = { vLinePoint: at.vLinePoint, hLinePoint: at.hLinePoint };
              t4._spikepoints = yt;
              var mt = function() {
                nt.sort(function(t5, e5) {
                  return t5.distance - e5.distance;
                }), nt = function(t5, e5) {
                  for (var r5 = e5.charAt(0), n3 = [], i2 = [], a4 = [], o2 = 0; o2 < t5.length; o2++) {
                    var s4 = t5[o2];
                    g2.traceIs(s4.trace, "bar-like") || g2.traceIs(s4.trace, "box-violin") ? a4.push(s4) : s4.trace[r5 + "period"] ? i2.push(s4) : n3.push(s4);
                  }
                  return n3.concat(i2).concat(a4);
                }(nt, I2);
              };
              mt();
              var xt = I2.charAt(0), bt = ("x" === xt || "y" === xt) && nt[0] && L[nt[0].trace.type];
              if (m3 && 0 !== H2 && 0 !== nt.length) {
                var _t = pt(nt.filter(function(t5) {
                  return t5.ya.showspikes;
                }), H2, bt);
                at.hLinePoint = dt(_t);
                var wt = pt(nt.filter(function(t5) {
                  return t5.xa.showspikes;
                }), H2, bt);
                at.vLinePoint = dt(wt);
              }
              if (0 === nt.length) {
                var Tt = d2.unhoverRaw(t4, e4);
                return !m3 || null === at.hLinePoint && null === at.vLinePoint || B(gt) && F(t4, at, vt), Tt;
              }
              if (m3 && B(gt) && F(t4, at, vt), y.isXYhover($) && 0 !== nt[0].length && "splom" !== nt[0].trace.type) {
                var kt = nt[0], At = (nt = E[kt.trace.type] ? nt.filter(function(t5) {
                  return t5.trace.index === kt.trace.index;
                }) : [kt]).length;
                ht(j("x", kt, c2), j("y", kt, c2));
                var Mt, St = [], Et = {}, Lt = 0, Ct = function(t5) {
                  var e5 = E[t5.trace.type] ? C(t5) : t5.trace.index;
                  if (Et[e5]) {
                    var r5 = Et[e5] - 1, n3 = St[r5];
                    r5 > 0 && Math.abs(t5.distance) < Math.abs(n3.distance) && (St[r5] = t5);
                  } else
                    Lt++, Et[e5] = Lt, St.push(t5);
                };
                for (Mt = 0; Mt < At; Mt++)
                  Ct(nt[Mt]);
                for (Mt = nt.length - 1; Mt > At - 1; Mt--)
                  Ct(nt[Mt]);
                nt = St, mt();
              }
              var Pt = t4._hoverdata, Ot = [], It = U(t4), Dt = V(t4);
              for (Z = 0; Z < nt.length; Z++) {
                var zt = nt[Z], Rt = y.makeEventData(zt, zt.trace, zt.cd);
                if (false !== zt.hovertemplate) {
                  var Ft = false;
                  zt.cd[zt.index] && zt.cd[zt.index].ht && (Ft = zt.cd[zt.index].ht), zt.hovertemplate = Ft || zt.trace.hovertemplate || false;
                }
                if (zt.xa && zt.ya) {
                  var Bt = zt.x0 + zt.xa._offset, Nt = zt.x1 + zt.xa._offset, jt = zt.y0 + zt.ya._offset, Ut = zt.y1 + zt.ya._offset, Vt = Math.min(Bt, Nt), Ht = Math.max(Bt, Nt), qt = Math.min(jt, Ut), Gt = Math.max(jt, Ut);
                  Rt.bbox = { x0: Vt + Dt, x1: Ht + Dt, y0: qt + It, y1: Gt + It };
                }
                zt.eventData = [Rt], Ot.push(Rt);
              }
              t4._hoverdata = Ot;
              var Zt = "y" === I2 && (it.length > 1 || nt.length > 1) || "closest" === I2 && ot && nt.length > 1, Yt = p2.combine(c2.plot_bgcolor || p2.background, c2.paper_bgcolor), Wt = O(nt, { gd: t4, hovermode: I2, rotateLabels: Zt, bgColor: Yt, container: c2._hoverlayer, outerContainer: c2._paper.node(), commonLabelOpts: c2.hoverlabel, hoverdistance: c2.hoverdistance }), Xt = Wt.hoverLabels;
              if (y.isUnifiedHover(I2) || (function(t5, e5, r5, n3) {
                var i2, a4, o2, s4, l3, u2, c3, f3 = e5 ? "xa" : "ya", h3 = e5 ? "ya" : "xa", p3 = 0, d3 = 1, v3 = t5.size(), g3 = new Array(v3), y2 = 0, m4 = n3.minX, x3 = n3.maxX, b3 = n3.minY, _3 = n3.maxY, w4 = function(t6) {
                  return t6 * r5._invScaleX;
                }, k3 = function(t6) {
                  return t6 * r5._invScaleY;
                };
                function A3(t6) {
                  var e6 = t6[0], r6 = t6[t6.length - 1];
                  if (a4 = e6.pmin - e6.pos - e6.dp + e6.size, o2 = r6.pos + r6.dp + r6.size - e6.pmax, a4 > 0.01) {
                    for (l3 = t6.length - 1; l3 >= 0; l3--)
                      t6[l3].dp += a4;
                    i2 = false;
                  }
                  if (!(o2 < 0.01)) {
                    if (a4 < -0.01) {
                      for (l3 = t6.length - 1; l3 >= 0; l3--)
                        t6[l3].dp -= o2;
                      i2 = false;
                    }
                    if (i2) {
                      var n4 = 0;
                      for (s4 = 0; s4 < t6.length; s4++)
                        (u2 = t6[s4]).pos + u2.dp + u2.size > e6.pmax && n4++;
                      for (s4 = t6.length - 1; s4 >= 0 && !(n4 <= 0); s4--)
                        (u2 = t6[s4]).pos > e6.pmax - 1 && (u2.del = true, n4--);
                      for (s4 = 0; s4 < t6.length && !(n4 <= 0); s4++)
                        if ((u2 = t6[s4]).pos < e6.pmin + 1)
                          for (u2.del = true, n4--, o2 = 2 * u2.size, l3 = t6.length - 1; l3 >= 0; l3--)
                            t6[l3].dp -= o2;
                      for (s4 = t6.length - 1; s4 >= 0 && !(n4 <= 0); s4--)
                        (u2 = t6[s4]).pos + u2.dp + u2.size > e6.pmax && (u2.del = true, n4--);
                    }
                  }
                }
                for (t5.each(function(t6) {
                  var n4 = t6[f3], i3 = t6[h3], a5 = "x" === n4._id.charAt(0), o3 = n4.range;
                  0 === y2 && o3 && o3[0] > o3[1] !== a5 && (d3 = -1);
                  var s5 = 0, l4 = a5 ? r5.width : r5.height;
                  if ("x" === r5.hovermode || "y" === r5.hovermode) {
                    var u3, c4, p4 = D(t6, e5), v4 = t6.anchor, A4 = "end" === v4 ? -1 : 1;
                    if ("middle" === v4)
                      c4 = (u3 = t6.crossPos + (a5 ? k3(p4.y - t6.by / 2) : w4(t6.bx / 2 + t6.tx2width / 2))) + (a5 ? k3(t6.by) : w4(t6.bx));
                    else if (a5)
                      c4 = (u3 = t6.crossPos + k3(M + p4.y) - k3(t6.by / 2 - M)) + k3(t6.by);
                    else {
                      var S4 = w4(A4 * M + p4.x), E3 = S4 + w4(A4 * t6.bx);
                      u3 = t6.crossPos + Math.min(S4, E3), c4 = t6.crossPos + Math.max(S4, E3);
                    }
                    a5 ? void 0 !== b3 && void 0 !== _3 && Math.min(c4, _3) - Math.max(u3, b3) > 1 && ("left" === i3.side ? (s5 = i3._mainLinePosition, l4 = r5.width) : l4 = i3._mainLinePosition) : void 0 !== m4 && void 0 !== x3 && Math.min(c4, x3) - Math.max(u3, m4) > 1 && ("top" === i3.side ? (s5 = i3._mainLinePosition, l4 = r5.height) : l4 = i3._mainLinePosition);
                  }
                  g3[y2++] = [{ datum: t6, traceIndex: t6.trace.index, dp: 0, pos: t6.pos, posref: t6.posref, size: t6.by * (a5 ? T : 1) / 2, pmin: s5, pmax: l4 }];
                }), g3.sort(function(t6, e6) {
                  return t6[0].posref - e6[0].posref || d3 * (e6[0].traceIndex - t6[0].traceIndex);
                }); !i2 && p3 <= v3; ) {
                  for (p3++, i2 = true, s4 = 0; s4 < g3.length - 1; ) {
                    var S3 = g3[s4], E2 = g3[s4 + 1], L2 = S3[S3.length - 1], C2 = E2[0];
                    if ((a4 = L2.pos + L2.dp + L2.size - C2.pos - C2.dp + C2.size) > 0.01 && L2.pmin === C2.pmin && L2.pmax === C2.pmax) {
                      for (l3 = E2.length - 1; l3 >= 0; l3--)
                        E2[l3].dp += a4;
                      for (S3.push.apply(S3, E2), g3.splice(s4 + 1, 1), c3 = 0, l3 = S3.length - 1; l3 >= 0; l3--)
                        c3 += S3[l3].dp;
                      for (o2 = c3 / S3.length, l3 = S3.length - 1; l3 >= 0; l3--)
                        S3[l3].dp -= o2;
                      i2 = false;
                    } else
                      s4++;
                  }
                  g3.forEach(A3);
                }
                for (s4 = g3.length - 1; s4 >= 0; s4--) {
                  var P3 = g3[s4];
                  for (l3 = P3.length - 1; l3 >= 0; l3--) {
                    var O2 = P3[l3], I3 = O2.datum;
                    I3.offset = O2.dp, I3.del = O2.del;
                  }
                }
              }(Xt, Zt, c2, Wt.commonLabelBoundingBox), z(Xt, Zt, c2._invScaleX, c2._invScaleY)), s3 && s3.tagName) {
                var Jt = g2.getComponentMethod("annotations", "hasClickToShow")(t4, Ot);
                f2(n2.select(s3), Jt ? "pointer" : "");
              }
              s3 && !a3 && function(t5, e5, r5) {
                if (!r5 || r5.length !== t5._hoverdata.length)
                  return true;
                for (var n3 = r5.length - 1; n3 >= 0; n3--) {
                  var i2 = r5[n3], a4 = t5._hoverdata[n3];
                  if (i2.curveNumber !== a4.curveNumber || String(i2.pointNumber) !== String(a4.pointNumber) || String(i2.pointNumbers) !== String(a4.pointNumbers))
                    return true;
                }
                return false;
              }(t4, 0, Pt) && (Pt && t4.emit("plotly_unhover", { event: e4, points: Pt }), t4.emit("plotly_hover", { event: e4, points: t4._hoverdata, xaxes: _2, yaxes: w3, xvals: q2, yvals: G }));
            }(t3, e3, r3, a2, s2);
          });
        }, e2.loneHover = function(t3, e3) {
          var r3 = true;
          Array.isArray(t3) || (r3 = false, t3 = [t3]);
          var i2 = e3.gd, a2 = U(i2), o2 = V(i2), s2 = O(t3.map(function(t4) {
            var r4 = t4._x0 || t4.x0 || t4.x || 0, n3 = t4._x1 || t4.x1 || t4.x || 0, s3 = t4._y0 || t4.y0 || t4.y || 0, l3 = t4._y1 || t4.y1 || t4.y || 0, u3 = t4.eventData;
            if (u3) {
              var c2 = Math.min(r4, n3), f3 = Math.max(r4, n3), h2 = Math.min(s3, l3), d3 = Math.max(s3, l3), v2 = t4.trace;
              if (g2.traceIs(v2, "gl3d")) {
                var y2 = i2._fullLayout[v2.scene]._scene.container, m3 = y2.offsetLeft, x2 = y2.offsetTop;
                c2 += m3, f3 += m3, h2 += x2, d3 += x2;
              }
              u3.bbox = { x0: c2 + o2, x1: f3 + o2, y0: h2 + a2, y1: d3 + a2 }, e3.inOut_bbox && e3.inOut_bbox.push(u3.bbox);
            } else
              u3 = false;
            return { color: t4.color || p2.defaultLine, x0: t4.x0 || t4.x || 0, x1: t4.x1 || t4.x || 0, y0: t4.y0 || t4.y || 0, y1: t4.y1 || t4.y || 0, xLabel: t4.xLabel, yLabel: t4.yLabel, zLabel: t4.zLabel, text: t4.text, name: t4.name, idealAlign: t4.idealAlign, borderColor: t4.borderColor, fontFamily: t4.fontFamily, fontSize: t4.fontSize, fontColor: t4.fontColor, nameLength: t4.nameLength, textAlign: t4.textAlign, trace: t4.trace || { index: 0, hoverinfo: "" }, xa: { _offset: 0 }, ya: { _offset: 0 }, index: 0, hovertemplate: t4.hovertemplate || false, hovertemplateLabels: t4.hovertemplateLabels || false, eventData: u3 };
          }), { gd: i2, hovermode: "closest", rotateLabels: false, bgColor: e3.bgColor || p2.background, container: n2.select(e3.container), outerContainer: e3.outerContainer || e3.container }).hoverLabels, l2 = 0, u2 = 0;
          return s2.sort(function(t4, e4) {
            return t4.y0 - e4.y0;
          }).each(function(t4, r4) {
            var n3 = t4.y0 - t4.by / 2;
            t4.offset = n3 - 5 < l2 ? l2 - n3 + 5 : 0, l2 = n3 + t4.by + t4.offset, r4 === e3.anchorIndex && (u2 = t4.offset);
          }).each(function(t4) {
            t4.offset -= u2;
          }), z(s2, false, i2._fullLayout._invScaleX, i2._fullLayout._invScaleY), r3 ? s2 : s2.node();
        };
        var P = /<extra>([\s\S]*)<\/extra>/;
        function O(t3, e3) {
          var r3 = e3.gd, i2 = r3._fullLayout, a2 = e3.hovermode, u2 = e3.rotateLabels, f3 = e3.bgColor, d3 = e3.container, v2 = e3.outerContainer, w3 = e3.commonLabelOpts || {};
          if (0 === t3.length)
            return [[]];
          var T2 = e3.fontFamily || m2.HOVERFONT, k2 = e3.fontSize || m2.HOVERFONTSIZE, A2 = t3[0], E2 = A2.xa, L2 = A2.ya, P2 = a2.charAt(0), O2 = P2 + "Label", D2 = A2[O2];
          if (void 0 === D2 && "multicategory" === E2.type)
            for (var z2 = 0; z2 < t3.length && void 0 === (D2 = t3[z2][O2]); z2++)
              ;
          var R2 = H(r3, v2), F2 = R2.top, B2 = R2.width, N2 = R2.height, j2 = void 0 !== D2 && A2.distance <= e3.hoverdistance && ("x" === a2 || "y" === a2);
          if (j2) {
            var U2, V2, q2 = true;
            for (U2 = 0; U2 < t3.length; U2++)
              if (q2 && void 0 === t3[U2].zLabel && (q2 = false), V2 = t3[U2].hoverinfo || t3[U2].trace.hoverinfo) {
                var G = Array.isArray(V2) ? V2 : V2.split("+");
                if (-1 === G.indexOf("all") && -1 === G.indexOf(a2)) {
                  j2 = false;
                  break;
                }
              }
            q2 && (j2 = false);
          }
          var Z = d3.selectAll("g.axistext").data(j2 ? [0] : []);
          Z.enter().append("g").classed("axistext", true), Z.exit().remove();
          var Y = { minX: 0, maxX: 0, minY: 0, maxY: 0 };
          if (Z.each(function() {
            var t4 = n2.select(this), e4 = o.ensureSingle(t4, "path", "", function(t5) {
              t5.style({ "stroke-width": "1px" });
            }), l2 = o.ensureSingle(t4, "text", "", function(t5) {
              t5.attr("data-notex", 1);
            }), u3 = w3.bgcolor || p2.defaultLine, f4 = w3.bordercolor || p2.contrast(u3), d4 = p2.contrast(u3), v3 = { family: w3.font.family || T2, size: w3.font.size || k2, color: w3.font.color || d4 };
            e4.style({ fill: u3, stroke: f4 }), l2.text(D2).call(h.font, v3).call(c.positionText, 0, 0).call(c.convertToTspans, r3), t4.attr("transform", "");
            var g3, y2, m3 = H(r3, l2.node());
            if ("x" === a2) {
              var x2 = "top" === E2.side ? "-" : "";
              l2.attr("text-anchor", "middle").call(c.positionText, 0, "top" === E2.side ? F2 - m3.bottom - M - S : F2 - m3.top + M + S), g3 = E2._offset + (A2.x0 + A2.x1) / 2, y2 = L2._offset + ("top" === E2.side ? 0 : L2._length);
              var b2 = m3.width / 2 + S;
              g3 < b2 ? (g3 = b2, e4.attr("d", "M-" + (b2 - M) + ",0L-" + (b2 - 2 * M) + "," + x2 + M + "H" + b2 + "v" + x2 + (2 * S + m3.height) + "H-" + b2 + "V" + x2 + M + "Z")) : g3 > i2.width - b2 ? (g3 = i2.width - b2, e4.attr("d", "M" + (b2 - M) + ",0L" + b2 + "," + x2 + M + "v" + x2 + (2 * S + m3.height) + "H-" + b2 + "V" + x2 + M + "H" + (b2 - 2 * M) + "Z")) : e4.attr("d", "M0,0L" + M + "," + x2 + M + "H" + b2 + "v" + x2 + (2 * S + m3.height) + "H-" + b2 + "V" + x2 + M + "H-" + M + "Z"), Y.minX = g3 - b2, Y.maxX = g3 + b2, "top" === E2.side ? (Y.minY = y2 - (2 * S + m3.height), Y.maxY = y2 - S) : (Y.minY = y2 + S, Y.maxY = y2 + (2 * S + m3.height));
            } else {
              var _2, C2, P3;
              "right" === L2.side ? (_2 = "start", C2 = 1, P3 = "", g3 = E2._offset + E2._length) : (_2 = "end", C2 = -1, P3 = "-", g3 = E2._offset), y2 = L2._offset + (A2.y0 + A2.y1) / 2, l2.attr("text-anchor", _2), e4.attr("d", "M0,0L" + P3 + M + "," + M + "V" + (S + m3.height / 2) + "h" + P3 + (2 * S + m3.width) + "V-" + (S + m3.height / 2) + "H" + P3 + M + "V-" + M + "Z"), Y.minY = y2 - (S + m3.height / 2), Y.maxY = y2 + (S + m3.height / 2), "right" === L2.side ? (Y.minX = g3 + M, Y.maxX = g3 + M + (2 * S + m3.width)) : (Y.minX = g3 - M - (2 * S + m3.width), Y.maxX = g3 - M);
              var O3, I2 = m3.height / 2, z3 = F2 - m3.top - I2, R3 = "clip" + i2._uid + "commonlabel" + L2._id;
              if (g3 < m3.width + 2 * S + M) {
                O3 = "M-" + (M + S) + "-" + I2 + "h-" + (m3.width - S) + "V" + I2 + "h" + (m3.width - S) + "Z";
                var B3 = m3.width - g3 + S;
                c.positionText(l2, B3, z3), "end" === _2 && l2.selectAll("tspan").each(function() {
                  var t5 = n2.select(this), e5 = h.tester.append("text").text(t5.text()).call(h.font, v3), i3 = H(r3, e5.node());
                  Math.round(i3.width) < Math.round(m3.width) && t5.attr("x", B3 - i3.width), e5.remove();
                });
              } else
                c.positionText(l2, C2 * (S + M), z3), O3 = null;
              var N3 = i2._topclips.selectAll("#" + R3).data(O3 ? [0] : []);
              N3.enter().append("clipPath").attr("id", R3).append("path"), N3.exit().remove(), N3.select("path").attr("d", O3), h.setClipUrl(l2, O3 ? R3 : null, r3);
            }
            t4.attr("transform", s(g3, y2));
          }), y.isUnifiedHover(a2)) {
            d3.selectAll("g.hovertext").remove();
            var W = t3.filter(function(t4) {
              return "none" !== t4.hoverinfo;
            });
            if (0 === W.length)
              return;
            var X = i2.hoverlabel, J = X.font, K = { showlegend: true, legend: { title: { text: D2, font: J }, font: J, bgcolor: X.bgcolor, bordercolor: X.bordercolor, borderwidth: 1, tracegroupgap: 7, traceorder: i2.legend ? i2.legend.traceorder : void 0, orientation: "v" } }, $ = { font: J };
            x(K, $, r3._fullData);
            var Q = $.legend;
            Q.entries = [];
            for (var tt = 0; tt < W.length; tt++) {
              var et = W[tt];
              if ("none" !== et.hoverinfo) {
                var rt = I(et, true, a2, i2, D2), nt = rt[0], it = rt[1];
                et.name = it, et.text = "" !== it ? it + " : " + nt : nt;
                var at = et.cd[et.index];
                at && (at.mc && (et.mc = at.mc), at.mcc && (et.mc = at.mcc), at.mlc && (et.mlc = at.mlc), at.mlcc && (et.mlc = at.mlcc), at.mlw && (et.mlw = at.mlw), at.mrc && (et.mrc = at.mrc), at.dir && (et.dir = at.dir)), et._distinct = true, Q.entries.push([et]);
              }
            }
            Q.entries.sort(function(t4, e4) {
              return t4[0].trace.index - e4[0].trace.index;
            }), Q.layer = d3, Q._inHover = true, Q._groupTitleFont = X.grouptitlefont, b(r3, Q);
            var ot, st, lt, ut, ct = d3.select("g.legend"), ft = H(r3, ct.node()), ht = ft.width + 2 * S, pt = ft.height + 2 * S, dt = W[0], vt = (dt.x0 + dt.x1) / 2, gt = (dt.y0 + dt.y1) / 2, yt = !(g2.traceIs(dt.trace, "bar-like") || g2.traceIs(dt.trace, "box-violin"));
            "y" === P2 ? yt ? (st = gt - S, ot = gt + S) : (st = Math.min.apply(null, W.map(function(t4) {
              return Math.min(t4.y0, t4.y1);
            })), ot = Math.max.apply(null, W.map(function(t4) {
              return Math.max(t4.y0, t4.y1);
            }))) : st = ot = o.mean(W.map(function(t4) {
              return (t4.y0 + t4.y1) / 2;
            })) - pt / 2, "x" === P2 ? yt ? (lt = vt + S, ut = vt - S) : (lt = Math.max.apply(null, W.map(function(t4) {
              return Math.max(t4.x0, t4.x1);
            })), ut = Math.min.apply(null, W.map(function(t4) {
              return Math.min(t4.x0, t4.x1);
            }))) : lt = ut = o.mean(W.map(function(t4) {
              return (t4.x0 + t4.x1) / 2;
            })) - ht / 2;
            var mt, xt, bt = E2._offset, _t = L2._offset;
            return ut += bt - ht, st += _t - pt, mt = (lt += bt) + ht < B2 && lt >= 0 ? lt : ut + ht < B2 && ut >= 0 ? ut : bt + ht < B2 ? bt : lt - vt < vt - ut + ht ? B2 - ht : 0, mt += S, xt = (ot += _t) + pt < N2 && ot >= 0 ? ot : st + pt < N2 && st >= 0 ? st : _t + pt < N2 ? _t : ot - gt < gt - st + pt ? N2 - pt : 0, xt += S, ct.attr("transform", s(mt - 1, xt - 1)), ct;
          }
          var wt = d3.selectAll("g.hovertext").data(t3, function(t4) {
            return C(t4);
          });
          return wt.enter().append("g").classed("hovertext", true).each(function() {
            var t4 = n2.select(this);
            t4.append("rect").call(p2.fill, p2.addOpacity(f3, 0.8)), t4.append("text").classed("name", true), t4.append("path").style("stroke-width", "1px"), t4.append("text").classed("nums", true).call(h.font, T2, k2);
          }), wt.exit().remove(), wt.each(function(t4) {
            var e4 = n2.select(this).attr("transform", ""), o2 = t4.color;
            Array.isArray(o2) && (o2 = o2[t4.eventData[0].pointNumber]);
            var d4 = t4.bgcolor || o2, v3 = p2.combine(p2.opacity(d4) ? d4 : p2.defaultLine, f3), g3 = p2.combine(p2.opacity(o2) ? o2 : p2.defaultLine, f3), y2 = t4.borderColor || p2.contrast(v3), m3 = I(t4, j2, a2, i2, D2, e4), x2 = m3[0], b2 = m3[1], w4 = e4.select("text.nums").call(h.font, t4.fontFamily || T2, t4.fontSize || k2, t4.fontColor || y2).text(x2).attr("data-notex", 1).call(c.positionText, 0, 0).call(c.convertToTspans, r3), A3 = e4.select("text.name"), E3 = 0, L3 = 0;
            if (b2 && b2 !== x2) {
              A3.call(h.font, t4.fontFamily || T2, t4.fontSize || k2, g3).text(b2).attr("data-notex", 1).call(c.positionText, 0, 0).call(c.convertToTspans, r3);
              var C2 = H(r3, A3.node());
              E3 = C2.width + 2 * S, L3 = C2.height + 2 * S;
            } else
              A3.remove(), e4.select("rect").remove();
            e4.select("path").style({ fill: v3, stroke: y2 });
            var P3 = t4.xa._offset + (t4.x0 + t4.x1) / 2, O3 = t4.ya._offset + (t4.y0 + t4.y1) / 2, z3 = Math.abs(t4.x1 - t4.x0), R3 = Math.abs(t4.y1 - t4.y0), U3 = H(r3, w4.node()), V3 = U3.width / i2._invScaleX, q3 = U3.height / i2._invScaleY;
            t4.ty0 = (F2 - U3.top) / i2._invScaleY, t4.bx = V3 + 2 * S, t4.by = Math.max(q3 + 2 * S, L3), t4.anchor = "start", t4.txwidth = V3, t4.tx2width = E3, t4.offset = 0;
            var G2, Z2, Y2 = (V3 + M + S + E3) * i2._invScaleX;
            if (u2)
              t4.pos = P3, G2 = O3 + R3 / 2 + Y2 <= N2, Z2 = O3 - R3 / 2 - Y2 >= 0, "top" !== t4.idealAlign && G2 || !Z2 ? G2 ? (O3 += R3 / 2, t4.anchor = "start") : t4.anchor = "middle" : (O3 -= R3 / 2, t4.anchor = "end"), t4.crossPos = O3;
            else {
              if (t4.pos = O3, G2 = P3 + z3 / 2 + Y2 <= B2, Z2 = P3 - z3 / 2 - Y2 >= 0, "left" !== t4.idealAlign && G2 || !Z2)
                if (G2)
                  P3 += z3 / 2, t4.anchor = "start";
                else {
                  t4.anchor = "middle";
                  var W2 = Y2 / 2, X2 = P3 + W2 - B2, J2 = P3 - W2;
                  X2 > 0 && (P3 -= X2), J2 < 0 && (P3 += -J2);
                }
              else
                P3 -= z3 / 2, t4.anchor = "end";
              t4.crossPos = P3;
            }
            w4.attr("text-anchor", t4.anchor), E3 && A3.attr("text-anchor", t4.anchor), e4.attr("transform", s(P3, O3) + (u2 ? l(_) : ""));
          }), { hoverLabels: wt, commonLabelBoundingBox: Y };
        }
        function I(t3, e3, r3, n3, i2, a2) {
          var s2 = "", l2 = "";
          void 0 !== t3.nameOverride && (t3.name = t3.nameOverride), t3.name && (t3.trace._meta && (t3.name = o.templateString(t3.name, t3.trace._meta)), s2 = N(t3.name, t3.nameLength));
          var u2 = r3.charAt(0), c2 = "x" === u2 ? "y" : "x";
          void 0 !== t3.zLabel ? (void 0 !== t3.xLabel && (l2 += "x: " + t3.xLabel + "<br>"), void 0 !== t3.yLabel && (l2 += "y: " + t3.yLabel + "<br>"), "choropleth" !== t3.trace.type && "choroplethmapbox" !== t3.trace.type && (l2 += (l2 ? "z: " : "") + t3.zLabel)) : e3 && t3[u2 + "Label"] === i2 ? l2 = t3[c2 + "Label"] || "" : void 0 === t3.xLabel ? void 0 !== t3.yLabel && "scattercarpet" !== t3.trace.type && (l2 = t3.yLabel) : l2 = void 0 === t3.yLabel ? t3.xLabel : "(" + t3.xLabel + ", " + t3.yLabel + ")", !t3.text && 0 !== t3.text || Array.isArray(t3.text) || (l2 += (l2 ? "<br>" : "") + t3.text), void 0 !== t3.extraText && (l2 += (l2 ? "<br>" : "") + t3.extraText), a2 && "" === l2 && !t3.hovertemplate && ("" === s2 && a2.remove(), l2 = s2);
          var f3 = t3.hovertemplate || false;
          if (f3) {
            var h2 = t3.hovertemplateLabels || t3;
            t3[u2 + "Label"] !== i2 && (h2[u2 + "other"] = h2[u2 + "Val"], h2[u2 + "otherLabel"] = h2[u2 + "Label"]), l2 = (l2 = o.hovertemplateString(f3, h2, n3._d3locale, t3.eventData[0] || {}, t3.trace._meta)).replace(P, function(e4, r4) {
              return s2 = N(r4, t3.nameLength), "";
            });
          }
          return [l2, s2];
        }
        function D(t3, e3) {
          var r3 = 0, n3 = t3.offset;
          return e3 && (n3 *= -A, r3 = t3.offset * k), { x: r3, y: n3 };
        }
        function z(t3, e3, r3, i2) {
          var a2 = function(t4) {
            return t4 * r3;
          }, o2 = function(t4) {
            return t4 * i2;
          };
          t3.each(function(t4) {
            var r4 = n2.select(this);
            if (t4.del)
              return r4.remove();
            var i3, s2, l2, u2, f3 = r4.select("text.nums"), p3 = t4.anchor, d3 = "end" === p3 ? -1 : 1, v2 = (u2 = (l2 = (s2 = { start: 1, end: -1, middle: 0 }[(i3 = t4).anchor]) * (M + S)) + s2 * (i3.txwidth + S), "middle" === i3.anchor && (l2 -= i3.tx2width / 2, u2 += i3.txwidth / 2 + S), { alignShift: s2, textShiftX: l2, text2ShiftX: u2 }), g3 = D(t4, e3), y2 = g3.x, m3 = g3.y, x2 = "middle" === p3;
            r4.select("path").attr("d", x2 ? "M-" + a2(t4.bx / 2 + t4.tx2width / 2) + "," + o2(m3 - t4.by / 2) + "h" + a2(t4.bx) + "v" + o2(t4.by) + "h-" + a2(t4.bx) + "Z" : "M0,0L" + a2(d3 * M + y2) + "," + o2(M + m3) + "v" + o2(t4.by / 2 - M) + "h" + a2(d3 * t4.bx) + "v-" + o2(t4.by) + "H" + a2(d3 * M + y2) + "V" + o2(m3 - M) + "Z");
            var b2 = y2 + v2.textShiftX, _2 = m3 + t4.ty0 - t4.by / 2 + S, w3 = t4.textAlign || "auto";
            "auto" !== w3 && ("left" === w3 && "start" !== p3 ? (f3.attr("text-anchor", "start"), b2 = x2 ? -t4.bx / 2 - t4.tx2width / 2 + S : -t4.bx - S) : "right" === w3 && "end" !== p3 && (f3.attr("text-anchor", "end"), b2 = x2 ? t4.bx / 2 - t4.tx2width / 2 - S : t4.bx + S)), f3.call(c.positionText, a2(b2), o2(_2)), t4.tx2width && (r4.select("text.name").call(c.positionText, a2(v2.text2ShiftX + v2.alignShift * S + y2), o2(m3 + t4.ty0 - t4.by / 2 + S)), r4.select("rect").call(h.setRect, a2(v2.text2ShiftX + (v2.alignShift - 1) * t4.tx2width / 2 + y2), o2(m3 - t4.by / 2 - 1), a2(t4.tx2width), o2(t4.by + 2)));
          });
        }
        function R(t3, e3) {
          var r3 = t3.index, n3 = t3.trace || {}, a2 = t3.cd[0], s2 = t3.cd[r3] || {};
          function l2(t4) {
            return t4 || i(t4) && 0 === t4;
          }
          var u2 = Array.isArray(r3) ? function(t4, e4) {
            var i2 = o.castOption(a2, r3, t4);
            return l2(i2) ? i2 : o.extractOption({}, n3, "", e4);
          } : function(t4, e4) {
            return o.extractOption(s2, n3, t4, e4);
          };
          function c2(e4, r4, n4) {
            var i2 = u2(r4, n4);
            l2(i2) && (t3[e4] = i2);
          }
          if (c2("hoverinfo", "hi", "hoverinfo"), c2("bgcolor", "hbg", "hoverlabel.bgcolor"), c2("borderColor", "hbc", "hoverlabel.bordercolor"), c2("fontFamily", "htf", "hoverlabel.font.family"), c2("fontSize", "hts", "hoverlabel.font.size"), c2("fontColor", "htc", "hoverlabel.font.color"), c2("nameLength", "hnl", "hoverlabel.namelength"), c2("textAlign", "hta", "hoverlabel.align"), t3.posref = "y" === e3 || "closest" === e3 && "h" === n3.orientation ? t3.xa._offset + (t3.x0 + t3.x1) / 2 : t3.ya._offset + (t3.y0 + t3.y1) / 2, t3.x0 = o.constrain(t3.x0, 0, t3.xa._length), t3.x1 = o.constrain(t3.x1, 0, t3.xa._length), t3.y0 = o.constrain(t3.y0, 0, t3.ya._length), t3.y1 = o.constrain(t3.y1, 0, t3.ya._length), void 0 !== t3.xLabelVal && (t3.xLabel = "xLabel" in t3 ? t3.xLabel : v.hoverLabelText(t3.xa, t3.xLabelVal, n3.xhoverformat), t3.xVal = t3.xa.c2d(t3.xLabelVal)), void 0 !== t3.yLabelVal && (t3.yLabel = "yLabel" in t3 ? t3.yLabel : v.hoverLabelText(t3.ya, t3.yLabelVal, n3.yhoverformat), t3.yVal = t3.ya.c2d(t3.yLabelVal)), void 0 !== t3.zLabelVal && void 0 === t3.zLabel && (t3.zLabel = String(t3.zLabelVal)), !(isNaN(t3.xerr) || "log" === t3.xa.type && t3.xerr <= 0)) {
            var f3 = v.tickText(t3.xa, t3.xa.c2l(t3.xerr), "hover").text;
            void 0 !== t3.xerrneg ? t3.xLabel += " +" + f3 + " / -" + v.tickText(t3.xa, t3.xa.c2l(t3.xerrneg), "hover").text : t3.xLabel += " ± " + f3, "x" === e3 && (t3.distance += 1);
          }
          if (!(isNaN(t3.yerr) || "log" === t3.ya.type && t3.yerr <= 0)) {
            var h2 = v.tickText(t3.ya, t3.ya.c2l(t3.yerr), "hover").text;
            void 0 !== t3.yerrneg ? t3.yLabel += " +" + h2 + " / -" + v.tickText(t3.ya, t3.ya.c2l(t3.yerrneg), "hover").text : t3.yLabel += " ± " + h2, "y" === e3 && (t3.distance += 1);
          }
          var p3 = t3.hoverinfo || t3.trace.hoverinfo;
          return p3 && "all" !== p3 && (-1 === (p3 = Array.isArray(p3) ? p3 : p3.split("+")).indexOf("x") && (t3.xLabel = void 0), -1 === p3.indexOf("y") && (t3.yLabel = void 0), -1 === p3.indexOf("z") && (t3.zLabel = void 0), -1 === p3.indexOf("text") && (t3.text = void 0), -1 === p3.indexOf("name") && (t3.name = void 0)), t3;
        }
        function F(t3, e3, r3) {
          var n3, i2, o2 = r3.container, s2 = r3.fullLayout, l2 = s2._size, u2 = r3.event, c2 = !!e3.hLinePoint, f3 = !!e3.vLinePoint;
          if (o2.selectAll(".spikeline").remove(), f3 || c2) {
            var d3 = p2.combine(s2.plot_bgcolor, s2.paper_bgcolor);
            if (c2) {
              var g3, y2, m3 = e3.hLinePoint;
              n3 = m3 && m3.xa, "cursor" === (i2 = m3 && m3.ya).spikesnap ? (g3 = u2.pointerX, y2 = u2.pointerY) : (g3 = n3._offset + m3.x, y2 = i2._offset + m3.y);
              var x2, b2, _2 = a.readability(m3.color, d3) < 1.5 ? p2.contrast(d3) : m3.color, w3 = i2.spikemode, T2 = i2.spikethickness, k2 = i2.spikecolor || _2, A2 = v.getPxPosition(t3, i2);
              if (-1 !== w3.indexOf("toaxis") || -1 !== w3.indexOf("across")) {
                if (-1 !== w3.indexOf("toaxis") && (x2 = A2, b2 = g3), -1 !== w3.indexOf("across")) {
                  var M2 = i2._counterDomainMin, S2 = i2._counterDomainMax;
                  "free" === i2.anchor && (M2 = Math.min(M2, i2.position), S2 = Math.max(S2, i2.position)), x2 = l2.l + M2 * l2.w, b2 = l2.l + S2 * l2.w;
                }
                o2.insert("line", ":first-child").attr({ x1: x2, x2: b2, y1: y2, y2, "stroke-width": T2, stroke: k2, "stroke-dasharray": h.dashStyle(i2.spikedash, T2) }).classed("spikeline", true).classed("crisp", true), o2.insert("line", ":first-child").attr({ x1: x2, x2: b2, y1: y2, y2, "stroke-width": T2 + 2, stroke: d3 }).classed("spikeline", true).classed("crisp", true);
              }
              -1 !== w3.indexOf("marker") && o2.insert("circle", ":first-child").attr({ cx: A2 + ("right" !== i2.side ? T2 : -T2), cy: y2, r: T2, fill: k2 }).classed("spikeline", true);
            }
            if (f3) {
              var E2, L2, C2 = e3.vLinePoint;
              n3 = C2 && C2.xa, i2 = C2 && C2.ya, "cursor" === n3.spikesnap ? (E2 = u2.pointerX, L2 = u2.pointerY) : (E2 = n3._offset + C2.x, L2 = i2._offset + C2.y);
              var P2, O2, I2 = a.readability(C2.color, d3) < 1.5 ? p2.contrast(d3) : C2.color, D2 = n3.spikemode, z2 = n3.spikethickness, R2 = n3.spikecolor || I2, F2 = v.getPxPosition(t3, n3);
              if (-1 !== D2.indexOf("toaxis") || -1 !== D2.indexOf("across")) {
                if (-1 !== D2.indexOf("toaxis") && (P2 = F2, O2 = L2), -1 !== D2.indexOf("across")) {
                  var B2 = n3._counterDomainMin, N2 = n3._counterDomainMax;
                  "free" === n3.anchor && (B2 = Math.min(B2, n3.position), N2 = Math.max(N2, n3.position)), P2 = l2.t + (1 - N2) * l2.h, O2 = l2.t + (1 - B2) * l2.h;
                }
                o2.insert("line", ":first-child").attr({ x1: E2, x2: E2, y1: P2, y2: O2, "stroke-width": z2, stroke: R2, "stroke-dasharray": h.dashStyle(n3.spikedash, z2) }).classed("spikeline", true).classed("crisp", true), o2.insert("line", ":first-child").attr({ x1: E2, x2: E2, y1: P2, y2: O2, "stroke-width": z2 + 2, stroke: d3 }).classed("spikeline", true).classed("crisp", true);
              }
              -1 !== D2.indexOf("marker") && o2.insert("circle", ":first-child").attr({ cx: E2, cy: F2 - ("top" !== n3.side ? z2 : -z2), r: z2, fill: R2 }).classed("spikeline", true);
            }
          }
        }
        function B(t3, e3) {
          return !e3 || e3.vLinePoint !== t3._spikepoints.vLinePoint || e3.hLinePoint !== t3._spikepoints.hLinePoint;
        }
        function N(t3, e3) {
          return c.plainText(t3 || "", { len: e3, allowedTags: ["br", "sub", "sup", "b", "i", "em"] });
        }
        function j(t3, e3, r3) {
          var n3 = e3[t3 + "a"], i2 = e3[t3 + "Val"], a2 = e3.cd[0];
          if ("category" === n3.type || "multicategory" === n3.type)
            i2 = n3._categoriesMap[i2];
          else if ("date" === n3.type) {
            var o2 = e3.trace[t3 + "periodalignment"];
            if (o2) {
              var s2 = e3.cd[e3.index], l2 = s2[t3 + "Start"];
              void 0 === l2 && (l2 = s2[t3]);
              var u2 = s2[t3 + "End"];
              void 0 === u2 && (u2 = s2[t3]);
              var c2 = u2 - l2;
              "end" === o2 ? i2 += c2 : "middle" === o2 && (i2 += c2 / 2);
            }
            i2 = n3.d2c(i2);
          }
          return a2 && a2.t && a2.t.posLetter === n3._id && ("group" !== r3.boxmode && "group" !== r3.violinmode || (i2 += a2.t.dPos)), i2;
        }
        function U(t3) {
          return t3.offsetTop + t3.clientTop;
        }
        function V(t3) {
          return t3.offsetLeft + t3.clientLeft;
        }
        function H(t3, e3) {
          var r3 = t3._fullLayout, n3 = e3.getBoundingClientRect(), i2 = n3.left, a2 = n3.top, s2 = i2 + n3.width, l2 = a2 + n3.height, u2 = o.apply3DTransform(r3._invTransform)(i2, a2), c2 = o.apply3DTransform(r3._invTransform)(s2, l2), f3 = u2[0], h2 = u2[1], p3 = c2[0], d3 = c2[1];
          return { x: f3, y: h2, width: p3 - f3, height: d3 - h2, top: Math.min(h2, d3), left: Math.min(f3, p3), right: Math.max(f3, p3), bottom: Math.max(h2, d3) };
        }
      }, 38048: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901), a = r2(23469).isUnifiedHover;
        t2.exports = function(t3, e3, r3, o) {
          o = o || {};
          var s = e3.legend;
          function l(t4) {
            o.font[t4] || (o.font[t4] = s ? e3.legend.font[t4] : e3.font[t4]);
          }
          e3 && a(e3.hovermode) && (o.font || (o.font = {}), l("size"), l("family"), l("color"), s ? (o.bgcolor || (o.bgcolor = i.combine(e3.legend.bgcolor, e3.paper_bgcolor)), o.bordercolor || (o.bordercolor = e3.legend.bordercolor)) : o.bgcolor || (o.bgcolor = e3.paper_bgcolor)), r3("hoverlabel.bgcolor", o.bgcolor), r3("hoverlabel.bordercolor", o.bordercolor), r3("hoverlabel.namelength", o.namelength), n2.coerceFont(r3, "hoverlabel.font", o.font), r3("hoverlabel.align", o.align);
        };
      }, 98212: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(528);
        t2.exports = function(t3, e3) {
          function r3(r4, a) {
            return void 0 !== e3[r4] ? e3[r4] : n2.coerce(t3, e3, i, r4, a);
          }
          return r3("clickmode"), r3("hovermode");
        };
      }, 30211: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(28569), o = r2(23469), s = r2(528), l = r2(88335);
        t2.exports = { moduleType: "component", name: "fx", constants: r2(26675), schema: { layout: s }, attributes: r2(77914), layoutAttributes: s, supplyLayoutGlobalDefaults: r2(22774), supplyDefaults: r2(54268), supplyLayoutDefaults: r2(34938), calc: r2(30732), getDistanceFunction: o.getDistanceFunction, getClosest: o.getClosest, inbox: o.inbox, quadrature: o.quadrature, appendArrayPointValue: o.appendArrayPointValue, castHoverOption: function(t3, e3, r3) {
          return i.castOption(t3, e3, "hoverlabel." + r3);
        }, castHoverinfo: function(t3, e3, r3) {
          return i.castOption(t3, r3, "hoverinfo", function(r4) {
            return i.coerceHoverinfo({ hoverinfo: r4 }, { _module: t3._module }, e3);
          });
        }, hover: l.hover, unhover: a.unhover, loneHover: l.loneHover, loneUnhover: function(t3) {
          var e3 = i.isD3Selection(t3) ? t3 : n2.select(t3);
          e3.selectAll("g.hovertext").remove(), e3.selectAll(".spikeline").remove();
        }, click: r2(75914) };
      }, 528: function(t2, e2, r2) {
        var n2 = r2(26675), i = r2(41940), a = i({ editType: "none" });
        a.family.dflt = n2.HOVERFONT, a.size.dflt = n2.HOVERFONTSIZE, t2.exports = { clickmode: { valType: "flaglist", flags: ["event", "select"], dflt: "event", editType: "plot", extras: ["none"] }, dragmode: { valType: "enumerated", values: ["zoom", "pan", "select", "lasso", "drawclosedpath", "drawopenpath", "drawline", "drawrect", "drawcircle", "orbit", "turntable", false], dflt: "zoom", editType: "modebar" }, hovermode: { valType: "enumerated", values: ["x", "y", "closest", false, "x unified", "y unified"], dflt: "closest", editType: "modebar" }, hoverdistance: { valType: "integer", min: -1, dflt: 20, editType: "none" }, spikedistance: { valType: "integer", min: -1, dflt: -1, editType: "none" }, hoverlabel: { bgcolor: { valType: "color", editType: "none" }, bordercolor: { valType: "color", editType: "none" }, font: a, grouptitlefont: i({ editType: "none" }), align: { valType: "enumerated", values: ["left", "right", "auto"], dflt: "auto", editType: "none" }, namelength: { valType: "integer", min: -1, dflt: 15, editType: "none" }, editType: "none" }, selectdirection: { valType: "enumerated", values: ["h", "v", "d", "any"], dflt: "any", editType: "none" } };
      }, 34938: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(528), a = r2(98212), o = r2(38048);
        t2.exports = function(t3, e3) {
          function r3(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          a(t3, e3) && (r3("hoverdistance"), r3("spikedistance")), "select" === r3("dragmode") && r3("selectdirection");
          var s = e3._has("mapbox"), l = e3._has("geo"), u = e3._basePlotModules.length;
          "zoom" === e3.dragmode && ((s || l) && 1 === u || s && l && 2 === u) && (e3.dragmode = "pan"), o(t3, e3, r3), n2.coerceFont(r3, "hoverlabel.grouptitlefont", e3.hoverlabel.font);
        };
      }, 22774: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(38048), a = r2(528);
        t2.exports = function(t3, e3) {
          i(t3, e3, function(r3, i2) {
            return n2.coerce(t3, e3, a, r3, i2);
          });
        };
      }, 83312: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(30587).counter, a = r2(27670).Y, o = r2(85555).idRegex, s = r2(44467), l = { rows: { valType: "integer", min: 1, editType: "plot" }, roworder: { valType: "enumerated", values: ["top to bottom", "bottom to top"], dflt: "top to bottom", editType: "plot" }, columns: { valType: "integer", min: 1, editType: "plot" }, subplots: { valType: "info_array", freeLength: true, dimensions: 2, items: { valType: "enumerated", values: [i("xy").toString(), ""], editType: "plot" }, editType: "plot" }, xaxes: { valType: "info_array", freeLength: true, items: { valType: "enumerated", values: [o.x.toString(), ""], editType: "plot" }, editType: "plot" }, yaxes: { valType: "info_array", freeLength: true, items: { valType: "enumerated", values: [o.y.toString(), ""], editType: "plot" }, editType: "plot" }, pattern: { valType: "enumerated", values: ["independent", "coupled"], dflt: "coupled", editType: "plot" }, xgap: { valType: "number", min: 0, max: 1, editType: "plot" }, ygap: { valType: "number", min: 0, max: 1, editType: "plot" }, domain: a({ name: "grid", editType: "plot", noGridCell: true }, {}), xside: { valType: "enumerated", values: ["bottom", "bottom plot", "top plot", "top"], dflt: "bottom plot", editType: "plot" }, yside: { valType: "enumerated", values: ["left", "left plot", "right plot", "right"], dflt: "left plot", editType: "plot" }, editType: "plot" };
        function u(t3, e3, r3) {
          var n3 = e3[r3 + "axes"], i2 = Object.keys((t3._splomAxes || {})[r3] || {});
          return Array.isArray(n3) ? n3 : i2.length ? i2 : void 0;
        }
        function c(t3, e3, r3, n3, i2, a2) {
          var o2 = e3(t3 + "gap", r3), s2 = e3("domain." + t3);
          e3(t3 + "side", n3);
          for (var l2 = new Array(i2), u2 = s2[0], c2 = (s2[1] - u2) / (i2 - o2), f3 = c2 * (1 - o2), h = 0; h < i2; h++) {
            var p2 = u2 + c2 * h;
            l2[a2 ? i2 - 1 - h : h] = [p2, p2 + f3];
          }
          return l2;
        }
        function f2(t3, e3, r3, n3, i2) {
          var a2, o2 = new Array(r3);
          function s2(t4, r4) {
            -1 !== e3.indexOf(r4) && void 0 === n3[r4] ? (o2[t4] = r4, n3[r4] = t4) : o2[t4] = "";
          }
          if (Array.isArray(t3))
            for (a2 = 0; a2 < r3; a2++)
              s2(a2, t3[a2]);
          else
            for (s2(0, i2), a2 = 1; a2 < r3; a2++)
              s2(a2, i2 + (a2 + 1));
          return o2;
        }
        t2.exports = { moduleType: "component", name: "grid", schema: { layout: { grid: l } }, layoutAttributes: l, sizeDefaults: function(t3, e3) {
          var r3 = t3.grid || {}, i2 = u(e3, r3, "x"), a2 = u(e3, r3, "y");
          if (t3.grid || i2 || a2) {
            var o2, f3, h = Array.isArray(r3.subplots) && Array.isArray(r3.subplots[0]), p2 = Array.isArray(i2), d2 = Array.isArray(a2), v = p2 && i2 !== r3.xaxes && d2 && a2 !== r3.yaxes;
            h ? (o2 = r3.subplots.length, f3 = r3.subplots[0].length) : (d2 && (o2 = a2.length), p2 && (f3 = i2.length));
            var g2 = s.newContainer(e3, "grid"), y = k("rows", o2), m2 = k("columns", f3);
            if (y * m2 > 1) {
              h || p2 || d2 || "independent" === k("pattern") && (h = true), g2._hasSubplotGrid = h;
              var x, b, _ = "top to bottom" === k("roworder"), w2 = h ? 0.2 : 0.1, T = h ? 0.3 : 0.1;
              v && e3._splomGridDflt && (x = e3._splomGridDflt.xside, b = e3._splomGridDflt.yside), g2._domains = { x: c("x", k, w2, x, m2), y: c("y", k, T, b, y, _) };
            } else
              delete e3.grid;
          }
          function k(t4, e4) {
            return n2.coerce(r3, g2, l, t4, e4);
          }
        }, contentDefaults: function(t3, e3) {
          var r3 = e3.grid;
          if (r3 && r3._domains) {
            var n3, i2, a2, o2, s2, l2, c2, h = t3.grid || {}, p2 = e3._subplots, d2 = r3._hasSubplotGrid, v = r3.rows, g2 = r3.columns, y = "independent" === r3.pattern, m2 = r3._axisMap = {};
            if (d2) {
              var x = h.subplots || [];
              l2 = r3.subplots = new Array(v);
              var b = 1;
              for (n3 = 0; n3 < v; n3++) {
                var _ = l2[n3] = new Array(g2), w2 = x[n3] || [];
                for (i2 = 0; i2 < g2; i2++)
                  if (y ? (s2 = 1 === b ? "xy" : "x" + b + "y" + b, b++) : s2 = w2[i2], _[i2] = "", -1 !== p2.cartesian.indexOf(s2)) {
                    if (c2 = s2.indexOf("y"), a2 = s2.slice(0, c2), o2 = s2.slice(c2), void 0 !== m2[a2] && m2[a2] !== i2 || void 0 !== m2[o2] && m2[o2] !== n3)
                      continue;
                    _[i2] = s2, m2[a2] = i2, m2[o2] = n3;
                  }
              }
            } else {
              var T = u(e3, h, "x"), k = u(e3, h, "y");
              r3.xaxes = f2(T, p2.xaxis, g2, m2, "x"), r3.yaxes = f2(k, p2.yaxis, v, m2, "y");
            }
            var A = r3._anchors = {}, M = "top to bottom" === r3.roworder;
            for (var S in m2) {
              var E, L, C, P = S.charAt(0), O = r3[P + "side"];
              if (O.length < 8)
                A[S] = "free";
              else if ("x" === P) {
                if ("t" === O.charAt(0) === M ? (E = 0, L = 1, C = v) : (E = v - 1, L = -1, C = -1), d2) {
                  var I = m2[S];
                  for (n3 = E; n3 !== C; n3 += L)
                    if ((s2 = l2[n3][I]) && (c2 = s2.indexOf("y"), s2.slice(0, c2) === S)) {
                      A[S] = s2.slice(c2);
                      break;
                    }
                } else
                  for (n3 = E; n3 !== C; n3 += L)
                    if (o2 = r3.yaxes[n3], -1 !== p2.cartesian.indexOf(S + o2)) {
                      A[S] = o2;
                      break;
                    }
              } else if ("l" === O.charAt(0) ? (E = 0, L = 1, C = g2) : (E = g2 - 1, L = -1, C = -1), d2) {
                var D = m2[S];
                for (n3 = E; n3 !== C; n3 += L)
                  if ((s2 = l2[D][n3]) && (c2 = s2.indexOf("y"), s2.slice(c2) === S)) {
                    A[S] = s2.slice(0, c2);
                    break;
                  }
              } else
                for (n3 = E; n3 !== C; n3 += L)
                  if (a2 = r3.xaxes[n3], -1 !== p2.cartesian.indexOf(a2 + S)) {
                    A[S] = a2;
                    break;
                  }
            }
          }
        } };
      }, 69819: function(t2, e2, r2) {
        var n2 = r2(85555), i = r2(44467).templatedArray;
        r2(24695), t2.exports = i("image", { visible: { valType: "boolean", dflt: true, editType: "arraydraw" }, source: { valType: "string", editType: "arraydraw" }, layer: { valType: "enumerated", values: ["below", "above"], dflt: "above", editType: "arraydraw" }, sizex: { valType: "number", dflt: 0, editType: "arraydraw" }, sizey: { valType: "number", dflt: 0, editType: "arraydraw" }, sizing: { valType: "enumerated", values: ["fill", "contain", "stretch"], dflt: "contain", editType: "arraydraw" }, opacity: { valType: "number", min: 0, max: 1, dflt: 1, editType: "arraydraw" }, x: { valType: "any", dflt: 0, editType: "arraydraw" }, y: { valType: "any", dflt: 0, editType: "arraydraw" }, xanchor: { valType: "enumerated", values: ["left", "center", "right"], dflt: "left", editType: "arraydraw" }, yanchor: { valType: "enumerated", values: ["top", "middle", "bottom"], dflt: "top", editType: "arraydraw" }, xref: { valType: "enumerated", values: ["paper", n2.idRegex.x.toString()], dflt: "paper", editType: "arraydraw" }, yref: { valType: "enumerated", values: ["paper", n2.idRegex.y.toString()], dflt: "paper", editType: "arraydraw" }, editType: "arraydraw" });
      }, 75378: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(58163);
        t2.exports = function(t3, e3, r3, a) {
          e3 = e3 || {};
          var o = "log" === r3 && "linear" === e3.type, s = "linear" === r3 && "log" === e3.type;
          if (o || s) {
            for (var l, u, c = t3._fullLayout.images, f2 = e3._id.charAt(0), h = 0; h < c.length; h++)
              if (u = "images[" + h + "].", (l = c[h])[f2 + "ref"] === e3._id) {
                var p2 = l[f2], d2 = l["size" + f2], v = null, g2 = null;
                if (o) {
                  v = i(p2, e3.range);
                  var y = d2 / Math.pow(10, v) / 2;
                  g2 = 2 * Math.log(y + Math.sqrt(1 + y * y)) / Math.LN10;
                } else
                  g2 = (v = Math.pow(10, p2)) * (Math.pow(10, d2 / 2) - Math.pow(10, -d2 / 2));
                n2(v) ? n2(g2) || (g2 = null) : (v = null, g2 = null), a(u + f2, v), a(u + "size" + f2, g2);
              }
          }
        };
      }, 81603: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298), a = r2(85501), o = r2(69819);
        function s(t3, e3, r3) {
          function a2(r4, i2) {
            return n2.coerce(t3, e3, o, r4, i2);
          }
          var s2 = a2("source");
          if (!a2("visible", !!s2))
            return e3;
          a2("layer"), a2("xanchor"), a2("yanchor"), a2("sizex"), a2("sizey"), a2("sizing"), a2("opacity");
          for (var l = { _fullLayout: r3 }, u = ["x", "y"], c = 0; c < 2; c++) {
            var f2 = u[c], h = i.coerceRef(t3, e3, l, f2, "paper", void 0);
            "paper" !== h && i.getFromId(l, h)._imgIndices.push(e3._index), i.coercePosition(e3, l, a2, h, f2, 0);
          }
          return e3;
        }
        t2.exports = function(t3, e3) {
          a(t3, e3, { name: "images", handleItemDefaults: s });
        };
      }, 80750: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(91424), a = r2(89298), o = r2(41675), s = r2(77922);
        t2.exports = function(t3) {
          var e3, r3, l = t3._fullLayout, u = [], c = {}, f2 = [];
          for (r3 = 0; r3 < l.images.length; r3++) {
            var h = l.images[r3];
            if (h.visible)
              if ("below" === h.layer && "paper" !== h.xref && "paper" !== h.yref) {
                e3 = o.ref2id(h.xref) + o.ref2id(h.yref);
                var p2 = l._plots[e3];
                if (!p2) {
                  f2.push(h);
                  continue;
                }
                p2.mainplot && (e3 = p2.mainplot.id), c[e3] || (c[e3] = []), c[e3].push(h);
              } else
                "above" === h.layer ? u.push(h) : f2.push(h);
          }
          var d2 = { left: { sizing: "xMin", offset: 0 }, center: { sizing: "xMid", offset: -0.5 }, right: { sizing: "xMax", offset: -1 } }, v = { top: { sizing: "YMin", offset: 0 }, middle: { sizing: "YMid", offset: -0.5 }, bottom: { sizing: "YMax", offset: -1 } };
          function g2(e4) {
            var r4 = n2.select(this);
            if (this._imgSrc !== e4.source)
              if (r4.attr("xmlns", s.svg), e4.source && "data:" === e4.source.slice(0, 5))
                r4.attr("xlink:href", e4.source), this._imgSrc = e4.source;
              else {
                var i2 = new Promise(function(t4) {
                  var n3 = new Image();
                  function i3() {
                    r4.remove(), t4();
                  }
                  this.img = n3, n3.setAttribute("crossOrigin", "anonymous"), n3.onerror = i3, n3.onload = function() {
                    var e5 = document.createElement("canvas");
                    e5.width = this.width, e5.height = this.height, e5.getContext("2d", { willReadFrequently: true }).drawImage(this, 0, 0);
                    var n4 = e5.toDataURL("image/png");
                    r4.attr("xlink:href", n4), t4();
                  }, r4.on("error", i3), n3.src = e4.source, this._imgSrc = e4.source;
                }.bind(this));
                t3._promises.push(i2);
              }
          }
          function y(e4) {
            var r4, o2, s2 = n2.select(this), u2 = a.getFromId(t3, e4.xref), c2 = a.getFromId(t3, e4.yref), f3 = "domain" === a.getRefType(e4.xref), h2 = "domain" === a.getRefType(e4.yref), p3 = l._size;
            r4 = void 0 !== u2 ? "string" == typeof e4.xref && f3 ? u2._length * e4.sizex : Math.abs(u2.l2p(e4.sizex) - u2.l2p(0)) : e4.sizex * p3.w, o2 = void 0 !== c2 ? "string" == typeof e4.yref && h2 ? c2._length * e4.sizey : Math.abs(c2.l2p(e4.sizey) - c2.l2p(0)) : e4.sizey * p3.h;
            var g3, y2, m3 = r4 * d2[e4.xanchor].offset, x2 = o2 * v[e4.yanchor].offset, b2 = d2[e4.xanchor].sizing + v[e4.yanchor].sizing;
            switch (g3 = void 0 !== u2 ? "string" == typeof e4.xref && f3 ? u2._length * e4.x + u2._offset : u2.r2p(e4.x) + u2._offset : e4.x * p3.w + p3.l, g3 += m3, y2 = void 0 !== c2 ? "string" == typeof e4.yref && h2 ? c2._length * (1 - e4.y) + c2._offset : c2.r2p(e4.y) + c2._offset : p3.h - e4.y * p3.h + p3.t, y2 += x2, e4.sizing) {
              case "fill":
                b2 += " slice";
                break;
              case "stretch":
                b2 = "none";
            }
            s2.attr({ x: g3, y: y2, width: r4, height: o2, preserveAspectRatio: b2, opacity: e4.opacity });
            var _2 = (u2 && "domain" !== a.getRefType(e4.xref) ? u2._id : "") + (c2 && "domain" !== a.getRefType(e4.yref) ? c2._id : "");
            i.setClipUrl(s2, _2 ? "clip" + l._uid + _2 : null, t3);
          }
          var m2 = l._imageLowerLayer.selectAll("image").data(f2), x = l._imageUpperLayer.selectAll("image").data(u);
          m2.enter().append("image"), x.enter().append("image"), m2.exit().remove(), x.exit().remove(), m2.each(function(t4) {
            g2.bind(this)(t4), y.bind(this)(t4);
          }), x.each(function(t4) {
            g2.bind(this)(t4), y.bind(this)(t4);
          });
          var b = Object.keys(l._plots);
          for (r3 = 0; r3 < b.length; r3++) {
            e3 = b[r3];
            var _ = l._plots[e3];
            if (_.imagelayer) {
              var w2 = _.imagelayer.selectAll("image").data(c[e3] || []);
              w2.enter().append("image"), w2.exit().remove(), w2.each(function(t4) {
                g2.bind(this)(t4), y.bind(this)(t4);
              });
            }
          }
        };
      }, 68804: function(t2, e2, r2) {
        t2.exports = { moduleType: "component", name: "images", layoutAttributes: r2(69819), supplyLayoutDefaults: r2(81603), includeBasePlot: r2(76325)("images"), draw: r2(80750), convertCoords: r2(75378) };
      }, 33030: function(t2, e2, r2) {
        var n2 = r2(41940), i = r2(22399);
        t2.exports = { bgcolor: { valType: "color", editType: "legend" }, bordercolor: { valType: "color", dflt: i.defaultLine, editType: "legend" }, borderwidth: { valType: "number", min: 0, dflt: 0, editType: "legend" }, font: n2({ editType: "legend" }), grouptitlefont: n2({ editType: "legend" }), orientation: { valType: "enumerated", values: ["v", "h"], dflt: "v", editType: "legend" }, traceorder: { valType: "flaglist", flags: ["reversed", "grouped"], extras: ["normal"], editType: "legend" }, tracegroupgap: { valType: "number", min: 0, dflt: 10, editType: "legend" }, entrywidth: { valType: "number", min: 0, editType: "legend" }, entrywidthmode: { valType: "enumerated", values: ["fraction", "pixels"], dflt: "pixels", editType: "legend" }, itemsizing: { valType: "enumerated", values: ["trace", "constant"], dflt: "trace", editType: "legend" }, itemwidth: { valType: "number", min: 30, dflt: 30, editType: "legend" }, itemclick: { valType: "enumerated", values: ["toggle", "toggleothers", false], dflt: "toggle", editType: "legend" }, itemdoubleclick: { valType: "enumerated", values: ["toggle", "toggleothers", false], dflt: "toggleothers", editType: "legend" }, groupclick: { valType: "enumerated", values: ["toggleitem", "togglegroup"], dflt: "togglegroup", editType: "legend" }, x: { valType: "number", min: -2, max: 3, editType: "legend" }, xanchor: { valType: "enumerated", values: ["auto", "left", "center", "right"], dflt: "left", editType: "legend" }, y: { valType: "number", min: -2, max: 3, editType: "legend" }, yanchor: { valType: "enumerated", values: ["auto", "top", "middle", "bottom"], editType: "legend" }, uirevision: { valType: "any", editType: "none" }, valign: { valType: "enumerated", values: ["top", "middle", "bottom"], dflt: "middle", editType: "legend" }, title: { text: { valType: "string", dflt: "", editType: "legend" }, font: n2({ editType: "legend" }), side: { valType: "enumerated", values: ["top", "left", "top left"], editType: "legend" }, editType: "legend" }, editType: "legend" };
      }, 14928: function(t2) {
        t2.exports = { scrollBarWidth: 6, scrollBarMinHeight: 20, scrollBarColor: "#808BA4", scrollBarMargin: 4, scrollBarEnterAttrs: { rx: 20, ry: 3, width: 0, height: 0 }, titlePad: 2, itemGap: 5 };
      }, 99017: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828), a = r2(44467), o = r2(9012), s = r2(33030), l = r2(10820), u = r2(10130);
        t2.exports = function(t3, e3, r3) {
          var c, f2 = t3.legend || {}, h = a.newContainer(e3, "legend");
          function p2(t4, e4) {
            return i.coerce(f2, h, s, t4, e4);
          }
          for (var d2 = function(t4, e4) {
            var r4 = c._input, n3 = c;
            return i.coerce(r4, n3, o, t4, e4);
          }, v = e3.font || {}, g2 = i.coerceFont(p2, "grouptitlefont", i.extendFlat({}, v, { size: Math.round(1.1 * v.size) })), y = 0, m2 = false, x = "normal", b = 0; b < r3.length; b++)
            (c = r3[b]).visible && ((c.showlegend || c._dfltShowLegend && !(c._module && c._module.attributes && c._module.attributes.showlegend && false === c._module.attributes.showlegend.dflt)) && (y++, c.showlegend && (m2 = true, (n2.traceIs(c, "pie-like") || true === c._input.showlegend) && y++), i.coerceFont(d2, "legendgrouptitle.font", g2)), (n2.traceIs(c, "bar") && "stack" === e3.barmode || -1 !== ["tonextx", "tonexty"].indexOf(c.fill)) && (x = u.isGrouped({ traceorder: x }) ? "grouped+reversed" : "reversed"), void 0 !== c.legendgroup && "" !== c.legendgroup && (x = u.isReversed({ traceorder: x }) ? "reversed+grouped" : "grouped"));
          var _ = i.coerce(t3, e3, l, "showlegend", m2 && y > 1);
          if (false === _ && (e3.legend = void 0), (false !== _ || f2.uirevision) && (p2("uirevision", e3.uirevision), false !== _)) {
            p2("bgcolor", e3.paper_bgcolor), p2("bordercolor"), p2("borderwidth");
            var w2, T, k, A = i.coerceFont(p2, "font", e3.font), M = "h" === p2("orientation");
            if (M ? (w2 = 0, n2.getComponentMethod("rangeslider", "isVisible")(t3.xaxis) ? (T = 1.1, k = "bottom") : (T = -0.1, k = "top")) : (w2 = 1.02, T = 1, k = "auto"), p2("traceorder", x), u.isGrouped(e3.legend) && p2("tracegroupgap"), p2("entrywidth"), p2("entrywidthmode"), p2("itemsizing"), p2("itemwidth"), p2("itemclick"), p2("itemdoubleclick"), p2("groupclick"), p2("x", w2), p2("xanchor"), p2("y", T), p2("yanchor", k), p2("valign"), i.noneOrAll(f2, h, ["x", "y"]), p2("title.text")) {
              p2("title.side", M ? "left" : "top");
              var S = i.extendFlat({}, A, { size: i.bigFont(A.size) });
              i.coerceFont(p2, "title.font", S);
            }
          }
        };
      }, 43969: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(74875), o = r2(73972), s = r2(11086), l = r2(28569), u = r2(91424), c = r2(7901), f2 = r2(63893), h = r2(85167), p2 = r2(14928), d2 = r2(18783), v = d2.LINE_SPACING, g2 = d2.FROM_TL, y = d2.FROM_BR, m2 = r2(82424), x = r2(53630), b = r2(10130);
        function _(t3, e3, r3) {
          var n3 = t3[0], i2 = n3.width, a2 = e3.entrywidthmode, o2 = n3.trace.legendwidth || e3.entrywidth;
          return "fraction" === a2 ? e3._maxWidth * o2 : r3 + (o2 || i2);
        }
        function w2(t3, e3, r3, n3, i2) {
          var a2 = r3.data()[0][0].trace, l2 = { event: i2, node: r3.node(), curveNumber: a2.index, expandedIndex: a2._expandedIndex, data: t3.data, layout: t3.layout, frames: t3._transitionData._frames, config: t3._context, fullData: t3._fullData, fullLayout: t3._fullLayout };
          a2._group && (l2.group = a2._group), o.traceIs(a2, "pie-like") && (l2.label = r3.datum()[0].label), false !== s.triggerHandler(t3, "plotly_legendclick", l2) && (1 === n3 ? e3._clickTimeout = setTimeout(function() {
            t3._fullLayout && h(r3, t3, n3);
          }, t3._context.doubleClickDelay) : 2 === n3 && (e3._clickTimeout && clearTimeout(e3._clickTimeout), t3._legendMouseDownTime = 0, false !== s.triggerHandler(t3, "plotly_legenddoubleclick", l2) && h(r3, t3, n3)));
        }
        function T(t3, e3, r3) {
          var n3, a2, s2 = t3.data()[0][0], l2 = s2.trace, c2 = o.traceIs(l2, "pie-like"), h2 = !r3._inHover && e3._context.edits.legendText && !c2, d3 = r3._maxNameLength;
          s2.groupTitle ? (n3 = s2.groupTitle.text, a2 = s2.groupTitle.font) : (a2 = r3.font, r3.entries ? n3 = s2.text : (n3 = c2 ? s2.label : l2.name, l2._meta && (n3 = i.templateString(n3, l2._meta))));
          var v2 = i.ensureSingle(t3, "text", "legendtext");
          v2.attr("text-anchor", "start").call(u.font, a2).text(h2 ? k(n3, d3) : n3);
          var g3 = r3.itemwidth + 2 * p2.itemGap;
          f2.positionText(v2, g3, 0), h2 ? v2.call(f2.makeEditable, { gd: e3, text: n3 }).call(M, t3, e3, r3).on("edit", function(n4) {
            this.text(k(n4, d3)).call(M, t3, e3, r3);
            var a3 = s2.trace._fullInput || {}, u2 = {};
            if (o.hasTransform(a3, "groupby")) {
              var c3 = o.getTransformIndices(a3, "groupby"), f3 = c3[c3.length - 1], h3 = i.keyedContainer(a3, "transforms[" + f3 + "].styles", "target", "value.name");
              h3.set(s2.trace._group, n4), u2 = h3.constructUpdate();
            } else
              u2.name = n4;
            return o.call("_guiRestyle", e3, u2, l2.index);
          }) : M(v2, t3, e3, r3);
        }
        function k(t3, e3) {
          var r3 = Math.max(4, e3);
          if (t3 && t3.trim().length >= r3 / 2)
            return t3;
          for (var n3 = r3 - (t3 = t3 || "").length; n3 > 0; n3--)
            t3 += " ";
          return t3;
        }
        function A(t3, e3) {
          var r3, a2 = e3._context.doubleClickDelay, o2 = 1, s2 = i.ensureSingle(t3, "rect", "legendtoggle", function(t4) {
            e3._context.staticPlot || t4.style("cursor", "pointer").attr("pointer-events", "all"), t4.call(c.fill, "rgba(0,0,0,0)");
          });
          e3._context.staticPlot || (s2.on("mousedown", function() {
            (r3 = new Date().getTime()) - e3._legendMouseDownTime < a2 ? o2 += 1 : (o2 = 1, e3._legendMouseDownTime = r3);
          }), s2.on("mouseup", function() {
            if (!e3._dragged && !e3._editing) {
              var r4 = e3._fullLayout.legend;
              new Date().getTime() - e3._legendMouseDownTime > a2 && (o2 = Math.max(o2 - 1, 1)), w2(e3, r4, t3, o2, n2.event);
            }
          }));
        }
        function M(t3, e3, r3, n3, i2) {
          n3._inHover && t3.attr("data-notex", true), f2.convertToTspans(t3, r3, function() {
            !function(t4, e4, r4, n4) {
              var i3 = t4.data()[0][0];
              if (r4._inHover || !i3 || i3.trace.showlegend) {
                var a2 = t4.select("g[class*=math-group]"), o2 = a2.node();
                r4 || (r4 = e4._fullLayout.legend);
                var s2, l2, c2 = r4.borderwidth, h2 = (1 === n4 ? r4.title.font : i3.groupTitle ? i3.groupTitle.font : r4.font).size * v;
                if (o2) {
                  var d3 = u.bBox(o2);
                  s2 = d3.height, l2 = d3.width, 1 === n4 ? u.setTranslate(a2, c2, c2 + 0.75 * s2) : u.setTranslate(a2, 0, 0.25 * s2);
                } else {
                  var g3 = t4.select(1 === n4 ? ".legendtitletext" : ".legendtext"), y2 = f2.lineCount(g3), m3 = g3.node();
                  if (s2 = h2 * y2, l2 = m3 ? u.bBox(m3).width : 0, 1 === n4)
                    "left" === r4.title.side && (l2 += 2 * p2.itemGap), f2.positionText(g3, c2 + p2.titlePad, c2 + h2);
                  else {
                    var x2 = 2 * p2.itemGap + r4.itemwidth;
                    i3.groupTitle && (x2 = p2.itemGap, l2 -= r4.itemwidth), f2.positionText(g3, x2, -h2 * ((y2 - 1) / 2 - 0.3));
                  }
                }
                1 === n4 ? (r4._titleWidth = l2, r4._titleHeight = s2) : (i3.lineHeight = h2, i3.height = Math.max(s2, 16) + 3, i3.width = l2);
              } else
                t4.remove();
            }(e3, r3, n3, i2);
          });
        }
        function S(t3) {
          return i.isRightAnchor(t3) ? "right" : i.isCenterAnchor(t3) ? "center" : "left";
        }
        function E(t3) {
          return i.isBottomAnchor(t3) ? "bottom" : i.isMiddleAnchor(t3) ? "middle" : "top";
        }
        t2.exports = function(t3, e3) {
          return e3 || (e3 = t3._fullLayout.legend || {}), function(t4, e4) {
            var r3, s2, f3 = t4._fullLayout, h2 = "legend" + f3._uid, d3 = e4._inHover;
            if (d3 ? (r3 = e4.layer, h2 += "-hover") : r3 = f3._infolayer, r3) {
              if (t4._legendMouseDownTime || (t4._legendMouseDownTime = 0), d3) {
                if (!e4.entries)
                  return;
                s2 = m2(e4.entries, e4);
              } else {
                if (!t4.calcdata)
                  return;
                s2 = f3.showlegend && m2(t4.calcdata, e4);
              }
              var v2 = f3.hiddenlabels || [];
              if (!(d3 || f3.showlegend && s2.length))
                return r3.selectAll(".legend").remove(), f3._topdefs.select("#" + h2).remove(), a.autoMargin(t4, "legend");
              var k2 = i.ensureSingle(r3, "g", "legend", function(t5) {
                d3 || t5.attr("pointer-events", "all");
              }), L = i.ensureSingleById(f3._topdefs, "clipPath", h2, function(t5) {
                t5.append("rect");
              }), C = i.ensureSingle(k2, "rect", "bg", function(t5) {
                t5.attr("shape-rendering", "crispEdges");
              });
              C.call(c.stroke, e4.bordercolor).call(c.fill, e4.bgcolor).style("stroke-width", e4.borderwidth + "px");
              var P = i.ensureSingle(k2, "g", "scrollbox"), O = e4.title;
              if (e4._titleWidth = 0, e4._titleHeight = 0, O.text) {
                var I = i.ensureSingle(P, "text", "legendtitletext");
                I.attr("text-anchor", "start").call(u.font, O.font).text(O.text), M(I, P, t4, e4, 1);
              } else
                P.selectAll(".legendtitletext").remove();
              var D = i.ensureSingle(k2, "rect", "scrollbar", function(t5) {
                t5.attr(p2.scrollBarEnterAttrs).call(c.fill, p2.scrollBarColor);
              }), z = P.selectAll("g.groups").data(s2);
              z.enter().append("g").attr("class", "groups"), z.exit().remove();
              var R = z.selectAll("g.traces").data(i.identity);
              R.enter().append("g").attr("class", "traces"), R.exit().remove(), R.style("opacity", function(t5) {
                var e5 = t5[0].trace;
                return o.traceIs(e5, "pie-like") ? -1 !== v2.indexOf(t5[0].label) ? 0.5 : 1 : "legendonly" === e5.visible ? 0.5 : 1;
              }).each(function() {
                n2.select(this).call(T, t4, e4);
              }).call(x, t4, e4).each(function() {
                d3 || n2.select(this).call(A, t4);
              }), i.syncOrAsync([a.previousPromises, function() {
                return function(t5, e5, r4, i2) {
                  var a2 = t5._fullLayout;
                  i2 || (i2 = a2.legend);
                  var o2 = a2._size, s3 = b.isVertical(i2), l2 = b.isGrouped(i2), c2 = "fraction" === i2.entrywidthmode, f4 = i2.borderwidth, h3 = 2 * f4, d4 = p2.itemGap, v3 = i2.itemwidth + 2 * d4, g3 = 2 * (f4 + d4), y2 = E(i2), m3 = i2.y < 0 || 0 === i2.y && "top" === y2, x2 = i2.y > 1 || 1 === i2.y && "bottom" === y2, w3 = i2.tracegroupgap, T2 = {};
                  i2._maxHeight = Math.max(m3 || x2 ? a2.height / 2 : o2.h, 30);
                  var k3 = 0;
                  i2._width = 0, i2._height = 0;
                  var A2 = function(t6) {
                    var e6 = 0, r5 = 0, n3 = t6.title.side;
                    return n3 && (-1 !== n3.indexOf("left") && (e6 = t6._titleWidth), -1 !== n3.indexOf("top") && (r5 = t6._titleHeight)), [e6, r5];
                  }(i2);
                  if (s3)
                    r4.each(function(t6) {
                      var e6 = t6[0].height;
                      u.setTranslate(this, f4 + A2[0], f4 + A2[1] + i2._height + e6 / 2 + d4), i2._height += e6, i2._width = Math.max(i2._width, t6[0].width);
                    }), k3 = v3 + i2._width, i2._width += d4 + v3 + h3, i2._height += g3, l2 && (e5.each(function(t6, e6) {
                      u.setTranslate(this, 0, e6 * i2.tracegroupgap);
                    }), i2._height += (i2._lgroupsLength - 1) * i2.tracegroupgap);
                  else {
                    var M2 = S(i2), L2 = i2.x < 0 || 0 === i2.x && "right" === M2, C2 = i2.x > 1 || 1 === i2.x && "left" === M2, P2 = x2 || m3, O2 = a2.width / 2;
                    i2._maxWidth = Math.max(L2 ? P2 && "left" === M2 ? o2.l + o2.w : O2 : C2 ? P2 && "right" === M2 ? o2.r + o2.w : O2 : o2.w, 2 * v3);
                    var I2 = 0, D2 = 0;
                    r4.each(function(t6) {
                      var e6 = _(t6, i2, v3);
                      I2 = Math.max(I2, e6), D2 += e6;
                    }), k3 = null;
                    var z2 = 0;
                    if (l2) {
                      var R2 = 0, F = 0, B = 0;
                      e5.each(function() {
                        var t6 = 0, e6 = 0;
                        n2.select(this).selectAll("g.traces").each(function(r6) {
                          var n3 = _(r6, i2, v3), a3 = r6[0].height;
                          u.setTranslate(this, A2[0], A2[1] + f4 + d4 + a3 / 2 + e6), e6 += a3, t6 = Math.max(t6, n3), T2[r6[0].trace.legendgroup] = t6;
                        });
                        var r5 = t6 + d4;
                        F > 0 && r5 + f4 + F > i2._maxWidth ? (z2 = Math.max(z2, F), F = 0, B += R2 + w3, R2 = e6) : R2 = Math.max(R2, e6), u.setTranslate(this, F, B), F += r5;
                      }), i2._width = Math.max(z2, F) + f4, i2._height = B + R2 + g3;
                    } else {
                      var N = r4.size(), j = D2 + h3 + (N - 1) * d4 < i2._maxWidth, U = 0, V = 0, H = 0, q2 = 0;
                      r4.each(function(t6) {
                        var e6 = t6[0].height, r5 = _(t6, i2, v3), n3 = j ? r5 : I2;
                        c2 || (n3 += d4), n3 + f4 + V - d4 >= i2._maxWidth && (z2 = Math.max(z2, q2), V = 0, H += U, i2._height += U, U = 0), u.setTranslate(this, A2[0] + f4 + V, A2[1] + f4 + H + e6 / 2 + d4), q2 = V + r5 + d4, V += n3, U = Math.max(U, e6);
                      }), j ? (i2._width = V + h3, i2._height = U + g3) : (i2._width = Math.max(z2, q2) + h3, i2._height += U + g3);
                    }
                  }
                  i2._width = Math.ceil(Math.max(i2._width + A2[0], i2._titleWidth + 2 * (f4 + p2.titlePad))), i2._height = Math.ceil(Math.max(i2._height + A2[1], i2._titleHeight + 2 * (f4 + p2.itemGap))), i2._effHeight = Math.min(i2._height, i2._maxHeight);
                  var G = t5._context.edits, Z = G.legendText || G.legendPosition;
                  r4.each(function(t6) {
                    var e6 = n2.select(this).select(".legendtoggle"), r5 = t6[0].height, a3 = t6[0].trace.legendgroup, o3 = _(t6, i2, v3);
                    l2 && "" !== a3 && (o3 = T2[a3]);
                    var f5 = Z ? v3 : k3 || o3;
                    s3 || c2 || (f5 += d4 / 2), u.setRect(e6, 0, -r5 / 2, f5, r5);
                  });
                }(t4, z, R, e4);
              }, function() {
                var s3, c2, v3, m3, x2 = f3._size, b2 = e4.borderwidth;
                if (!d3) {
                  var _2 = function(t5) {
                    var e5 = t5._fullLayout.legend, r4 = S(e5), n3 = E(e5);
                    return a.autoMargin(t5, "legend", { x: e5.x, y: e5.y, l: e5._width * g2[r4], r: e5._width * y[r4], b: e5._effHeight * y[n3], t: e5._effHeight * g2[n3] });
                  }(t4);
                  if (_2)
                    return;
                  var T2 = x2.l + x2.w * e4.x - g2[S(e4)] * e4._width, A2 = x2.t + x2.h * (1 - e4.y) - g2[E(e4)] * e4._effHeight;
                  if (f3.margin.autoexpand) {
                    var M2 = T2, O2 = A2;
                    T2 = i.constrain(T2, 0, f3.width - e4._width), A2 = i.constrain(A2, 0, f3.height - e4._effHeight), T2 !== M2 && i.log("Constrain legend.x to make legend fit inside graph"), A2 !== O2 && i.log("Constrain legend.y to make legend fit inside graph");
                  }
                  u.setTranslate(k2, T2, A2);
                }
                if (D.on(".drag", null), k2.on("wheel", null), d3 || e4._height <= e4._maxHeight || t4._context.staticPlot) {
                  var I2 = e4._effHeight;
                  d3 && (I2 = e4._height), C.attr({ width: e4._width - b2, height: I2 - b2, x: b2 / 2, y: b2 / 2 }), u.setTranslate(P, 0, 0), L.select("rect").attr({ width: e4._width - 2 * b2, height: I2 - 2 * b2, x: b2, y: b2 }), u.setClipUrl(P, h2, t4), u.setRect(D, 0, 0, 0, 0), delete e4._scrollY;
                } else {
                  var z2, R2, F, B = Math.max(p2.scrollBarMinHeight, e4._effHeight * e4._effHeight / e4._height), N = e4._effHeight - B - 2 * p2.scrollBarMargin, j = e4._height - e4._effHeight, U = N / j, V = Math.min(e4._scrollY || 0, j);
                  C.attr({ width: e4._width - 2 * b2 + p2.scrollBarWidth + p2.scrollBarMargin, height: e4._effHeight - b2, x: b2 / 2, y: b2 / 2 }), L.select("rect").attr({ width: e4._width - 2 * b2 + p2.scrollBarWidth + p2.scrollBarMargin, height: e4._effHeight - 2 * b2, x: b2, y: b2 + V }), u.setClipUrl(P, h2, t4), G(V, B, U), k2.on("wheel", function() {
                    G(V = i.constrain(e4._scrollY + n2.event.deltaY / N * j, 0, j), B, U), 0 !== V && V !== j && n2.event.preventDefault();
                  });
                  var H = n2.behavior.drag().on("dragstart", function() {
                    var t5 = n2.event.sourceEvent;
                    z2 = "touchstart" === t5.type ? t5.changedTouches[0].clientY : t5.clientY, F = V;
                  }).on("drag", function() {
                    var t5 = n2.event.sourceEvent;
                    2 === t5.buttons || t5.ctrlKey || (R2 = "touchmove" === t5.type ? t5.changedTouches[0].clientY : t5.clientY, G(V = function(t6, e5, r4) {
                      var n3 = (r4 - e5) / U + t6;
                      return i.constrain(n3, 0, j);
                    }(F, z2, R2), B, U));
                  });
                  D.call(H);
                  var q2 = n2.behavior.drag().on("dragstart", function() {
                    var t5 = n2.event.sourceEvent;
                    "touchstart" === t5.type && (z2 = t5.changedTouches[0].clientY, F = V);
                  }).on("drag", function() {
                    var t5 = n2.event.sourceEvent;
                    "touchmove" === t5.type && (R2 = t5.changedTouches[0].clientY, G(V = function(t6, e5, r4) {
                      var n3 = (e5 - r4) / U + t6;
                      return i.constrain(n3, 0, j);
                    }(F, z2, R2), B, U));
                  });
                  P.call(q2);
                }
                function G(r4, n3, i2) {
                  e4._scrollY = t4._fullLayout.legend._scrollY = r4, u.setTranslate(P, 0, -r4), u.setRect(D, e4._width, p2.scrollBarMargin + r4 * i2, p2.scrollBarWidth, n3), L.select("rect").attr("y", b2 + r4);
                }
                t4._context.edits.legendPosition && (k2.classed("cursor-move", true), l.init({ element: k2.node(), gd: t4, prepFn: function() {
                  var t5 = u.getTranslate(k2);
                  v3 = t5.x, m3 = t5.y;
                }, moveFn: function(t5, r4) {
                  var n3 = v3 + t5, i2 = m3 + r4;
                  u.setTranslate(k2, n3, i2), s3 = l.align(n3, 0, x2.l, x2.l + x2.w, e4.xanchor), c2 = l.align(i2, 0, x2.t + x2.h, x2.t, e4.yanchor);
                }, doneFn: function() {
                  void 0 !== s3 && void 0 !== c2 && o.call("_guiRelayout", t4, { "legend.x": s3, "legend.y": c2 });
                }, clickFn: function(e5, n3) {
                  var i2 = r3.selectAll("g.traces").filter(function() {
                    var t5 = this.getBoundingClientRect();
                    return n3.clientX >= t5.left && n3.clientX <= t5.right && n3.clientY >= t5.top && n3.clientY <= t5.bottom;
                  });
                  i2.size() > 0 && w2(t4, k2, i2, e5, n3);
                } }));
              }], t4);
            }
          }(t3, e3);
        };
      }, 82424: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(10130);
        t2.exports = function(t3, e3) {
          var r3, a, o = e3._inHover, s = i.isGrouped(e3), l = i.isReversed(e3), u = {}, c = [], f2 = false, h = {}, p2 = 0, d2 = 0;
          function v(t4, r4) {
            if ("" !== t4 && i.isGrouped(e3))
              -1 === c.indexOf(t4) ? (c.push(t4), f2 = true, u[t4] = [r4]) : u[t4].push(r4);
            else {
              var n3 = "~~i" + p2;
              c.push(n3), u[n3] = [r4], p2++;
            }
          }
          for (r3 = 0; r3 < t3.length; r3++) {
            var g2 = t3[r3], y = g2[0], m2 = y.trace, x = m2.legendgroup;
            if (o || m2.visible && m2.showlegend)
              if (n2.traceIs(m2, "pie-like"))
                for (h[x] || (h[x] = {}), a = 0; a < g2.length; a++) {
                  var b = g2[a].label;
                  h[x][b] || (v(x, { label: b, color: g2[a].color, i: g2[a].i, trace: m2, pts: g2[a].pts }), h[x][b] = true, d2 = Math.max(d2, (b || "").length));
                }
              else
                v(x, y), d2 = Math.max(d2, (m2.name || "").length);
          }
          if (!c.length)
            return [];
          var _ = !f2 || !s, w2 = [];
          for (r3 = 0; r3 < c.length; r3++) {
            var T = u[c[r3]];
            _ ? w2.push(T[0]) : w2.push(T);
          }
          for (_ && (w2 = [w2]), r3 = 0; r3 < w2.length; r3++) {
            var k = 1 / 0;
            for (a = 0; a < w2[r3].length; a++) {
              var A = w2[r3][a].trace.legendrank;
              k > A && (k = A);
            }
            w2[r3][0]._groupMinRank = k, w2[r3][0]._preGroupSort = r3;
          }
          var M = function(t4, e4) {
            return t4.trace.legendrank - e4.trace.legendrank || t4._preSort - e4._preSort;
          };
          for (w2.forEach(function(t4, e4) {
            t4[0]._preGroupSort = e4;
          }), w2.sort(function(t4, e4) {
            return t4[0]._groupMinRank - e4[0]._groupMinRank || t4[0]._preGroupSort - e4[0]._preGroupSort;
          }), r3 = 0; r3 < w2.length; r3++) {
            w2[r3].forEach(function(t4, e4) {
              t4._preSort = e4;
            }), w2[r3].sort(M);
            var S = w2[r3][0].trace, E = null;
            for (a = 0; a < w2[r3].length; a++) {
              var L = w2[r3][a].trace.legendgrouptitle;
              if (L && L.text) {
                E = L, o && (L.font = e3._groupTitleFont);
                break;
              }
            }
            if (l && w2[r3].reverse(), E) {
              var C = false;
              for (a = 0; a < w2[r3].length; a++)
                if (n2.traceIs(w2[r3][a].trace, "pie-like")) {
                  C = true;
                  break;
                }
              w2[r3].unshift({ i: -1, groupTitle: E, noClick: C, trace: { showlegend: S.showlegend, legendgroup: S.legendgroup, visible: "toggleitem" === e3.groupclick || S.visible } });
            }
            for (a = 0; a < w2[r3].length; a++)
              w2[r3][a] = [w2[r3][a]];
          }
          return e3._lgroupsLength = w2.length, e3._maxNameLength = d2, w2;
        };
      }, 85167: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(73972), a = true;
        t2.exports = function(t3, e3, r3) {
          var o = e3._fullLayout;
          if (!e3._dragged && !e3._editing) {
            var s, l = o.legend.itemclick, u = o.legend.itemdoubleclick, c = o.legend.groupclick;
            if (1 === r3 && "toggle" === l && "toggleothers" === u && a && e3.data && e3._context.showTips ? (n2.notifier(n2._(e3, "Double-click on legend to isolate one trace"), "long"), a = false) : a = false, 1 === r3 ? s = l : 2 === r3 && (s = u), s) {
              var f2 = "togglegroup" === c, h = o.hiddenlabels ? o.hiddenlabels.slice() : [], p2 = t3.data()[0][0];
              if (!p2.groupTitle || !p2.noClick) {
                var d2, v, g2, y, m2, x = e3._fullData, b = p2.trace, _ = b.legendgroup, w2 = {}, T = [], k = [], A = [];
                if (i.traceIs(b, "pie-like")) {
                  var M = p2.label, S = h.indexOf(M);
                  "toggle" === s ? -1 === S ? h.push(M) : h.splice(S, 1) : "toggleothers" === s && (h = [], e3.calcdata[0].forEach(function(t4) {
                    M !== t4.label && h.push(t4.label);
                  }), e3._fullLayout.hiddenlabels && e3._fullLayout.hiddenlabels.length === h.length && -1 === S && (h = [])), i.call("_guiRelayout", e3, "hiddenlabels", h);
                } else {
                  var E, L = _ && _.length, C = [];
                  if (L)
                    for (d2 = 0; d2 < x.length; d2++)
                      (E = x[d2]).visible && E.legendgroup === _ && C.push(d2);
                  if ("toggle" === s) {
                    var P;
                    switch (b.visible) {
                      case true:
                        P = "legendonly";
                        break;
                      case false:
                        P = false;
                        break;
                      case "legendonly":
                        P = true;
                    }
                    if (L)
                      if (f2)
                        for (d2 = 0; d2 < x.length; d2++)
                          false !== x[d2].visible && x[d2].legendgroup === _ && j(x[d2], P);
                      else
                        j(b, P);
                    else
                      j(b, P);
                  } else if ("toggleothers" === s) {
                    var O, I, D, z, R = true;
                    for (d2 = 0; d2 < x.length; d2++)
                      if (O = x[d2] === b, D = true !== x[d2].showlegend, !(O || D || (I = L && x[d2].legendgroup === _) || true !== x[d2].visible || i.traceIs(x[d2], "notLegendIsolatable"))) {
                        R = false;
                        break;
                      }
                    for (d2 = 0; d2 < x.length; d2++)
                      if (false !== x[d2].visible && !i.traceIs(x[d2], "notLegendIsolatable"))
                        switch (b.visible) {
                          case "legendonly":
                            j(x[d2], true);
                            break;
                          case true:
                            z = !!R || "legendonly", O = x[d2] === b, D = true !== x[d2].showlegend && !x[d2].legendgroup, I = O || L && x[d2].legendgroup === _, j(x[d2], !(!I && !D) || z);
                        }
                  }
                  for (d2 = 0; d2 < k.length; d2++)
                    if (g2 = k[d2]) {
                      var F = g2.constructUpdate(), B = Object.keys(F);
                      for (v = 0; v < B.length; v++)
                        y = B[v], (w2[y] = w2[y] || [])[A[d2]] = F[y];
                    }
                  for (m2 = Object.keys(w2), d2 = 0; d2 < m2.length; d2++)
                    for (y = m2[d2], v = 0; v < T.length; v++)
                      w2[y].hasOwnProperty(v) || (w2[y][v] = void 0);
                  i.call("_guiRestyle", e3, w2, T);
                }
              }
            }
          }
          function N(t4, e4, r4) {
            var n3 = T.indexOf(t4), i2 = w2[e4];
            return i2 || (i2 = w2[e4] = []), -1 === T.indexOf(t4) && (T.push(t4), n3 = T.length - 1), i2[n3] = r4, n3;
          }
          function j(t4, e4) {
            if (!p2.groupTitle || f2) {
              var r4 = t4._fullInput;
              if (i.hasTransform(r4, "groupby")) {
                var a2 = k[r4.index];
                if (!a2) {
                  var o2 = i.getTransformIndices(r4, "groupby"), s2 = o2[o2.length - 1];
                  a2 = n2.keyedContainer(r4, "transforms[" + s2 + "].styles", "target", "value.visible"), k[r4.index] = a2;
                }
                var l2 = a2.get(t4._group);
                void 0 === l2 && (l2 = true), false !== l2 && a2.set(t4._group, e4), A[r4.index] = N(r4.index, "visible", false !== r4.visible);
              } else {
                var u2 = false !== r4.visible && e4;
                N(r4.index, "visible", u2);
              }
            }
          }
        };
      }, 10130: function(t2, e2) {
        e2.isGrouped = function(t3) {
          return -1 !== (t3.traceorder || "").indexOf("grouped");
        }, e2.isVertical = function(t3) {
          return "h" !== t3.orientation;
        }, e2.isReversed = function(t3) {
          return -1 !== (t3.traceorder || "").indexOf("reversed");
        };
      }, 2199: function(t2, e2, r2) {
        t2.exports = { moduleType: "component", name: "legend", layoutAttributes: r2(33030), supplyLayoutDefaults: r2(99017), draw: r2(43969), style: r2(53630) };
      }, 53630: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(73972), a = r2(71828), o = a.strTranslate, s = r2(91424), l = r2(7901), u = r2(52075).extractOpts, c = r2(34098), f2 = r2(63463), h = r2(53581).castOption, p2 = r2(14928);
        function d2(t3, e3) {
          return (e3 ? "radial" : "horizontal") + (t3 ? "" : "reversed");
        }
        function v(t3) {
          var e3 = t3[0].trace, r3 = e3.contours, n3 = c.hasLines(e3), i2 = c.hasMarkers(e3), a2 = e3.visible && e3.fill && "none" !== e3.fill, o2 = false, s2 = false;
          if (r3) {
            var l2 = r3.coloring;
            "lines" === l2 ? o2 = true : n3 = "none" === l2 || "heatmap" === l2 || r3.showlines, "constraint" === r3.type ? a2 = "=" !== r3._operation : "fill" !== l2 && "heatmap" !== l2 || (s2 = true);
          }
          return { showMarker: i2, showLine: n3, showFill: a2, showGradientLine: o2, showGradientFill: s2, anyLine: n3 || o2, anyFill: a2 || s2 };
        }
        function g2(t3, e3, r3) {
          return t3 && a.isArrayOrTypedArray(t3) ? e3 : t3 > r3 ? r3 : t3;
        }
        t2.exports = function(t3, e3, r3) {
          var y = e3._fullLayout;
          r3 || (r3 = y.legend);
          var m2 = "constant" === r3.itemsizing, x = r3.itemwidth, b = (x + 2 * p2.itemGap) / 2, _ = o(b, 0), w2 = function(t4, e4, r4, n3) {
            var i2;
            if (t4 + 1)
              i2 = t4;
            else {
              if (!(e4 && e4.width > 0))
                return 0;
              i2 = e4.width;
            }
            return m2 ? n3 : Math.min(i2, r4);
          };
          function T(t4, a2, o2) {
            var c2 = t4[0].trace, f3 = c2.marker || {}, h2 = f3.line || {}, p3 = o2 ? c2.visible && c2.type === o2 : i.traceIs(c2, "bar"), d3 = n2.select(a2).select("g.legendpoints").selectAll("path.legend" + o2).data(p3 ? [t4] : []);
            d3.enter().append("path").classed("legend" + o2, true).attr("d", "M6,6H-6V-6H6Z").attr("transform", _), d3.exit().remove(), d3.each(function(t5) {
              var i2 = n2.select(this), a3 = t5[0], o3 = w2(a3.mlw, f3.line, 5, 2);
              i2.style("stroke-width", o3 + "px");
              var p4 = a3.mcc;
              if (!r3._inHover && "mc" in a3) {
                var d4 = u(f3), v2 = d4.mid;
                void 0 === v2 && (v2 = (d4.max + d4.min) / 2), p4 = s.tryColorscale(f3, "")(v2);
              }
              var y2 = p4 || a3.mc || f3.color, m3 = f3.pattern, x2 = m3 && s.getPatternAttr(m3.shape, 0, "");
              if (x2) {
                var b2 = s.getPatternAttr(m3.bgcolor, 0, null), _2 = s.getPatternAttr(m3.fgcolor, 0, null), T2 = m3.fgopacity, k2 = g2(m3.size, 8, 10), A = g2(m3.solidity, 0.5, 1), M = "legend-" + c2.uid;
                i2.call(s.pattern, "legend", e3, M, x2, k2, A, p4, m3.fillmode, b2, _2, T2);
              } else
                i2.call(l.fill, y2);
              o3 && l.stroke(i2, a3.mlc || h2.color);
            });
          }
          function k(t4, e4, r4) {
            var o2 = t4[0], s2 = o2.trace, l2 = r4 ? s2.visible && s2.type === r4 : i.traceIs(s2, r4), u2 = n2.select(e4).select("g.legendpoints").selectAll("path.legend" + r4).data(l2 ? [t4] : []);
            if (u2.enter().append("path").classed("legend" + r4, true).attr("d", "M6,6H-6V-6H6Z").attr("transform", _), u2.exit().remove(), u2.size()) {
              var c2 = (s2.marker || {}).line, p3 = w2(h(c2.width, o2.pts), c2, 5, 2), d3 = a.minExtend(s2, { marker: { line: { width: p3 } } });
              d3.marker.line.color = c2.color;
              var v2 = a.minExtend(o2, { trace: d3 });
              f2(u2, v2, d3);
            }
          }
          t3.each(function(t4) {
            var e4 = n2.select(this), i2 = a.ensureSingle(e4, "g", "layers");
            i2.style("opacity", t4[0].trace.opacity);
            var s2 = r3.valign, l2 = t4[0].lineHeight, u2 = t4[0].height;
            if ("middle" !== s2 && l2 && u2) {
              var c2 = { top: 1, bottom: -1 }[s2] * (0.5 * (l2 - u2 + 3));
              i2.attr("transform", o(0, c2));
            } else
              i2.attr("transform", null);
            i2.selectAll("g.legendfill").data([t4]).enter().append("g").classed("legendfill", true), i2.selectAll("g.legendlines").data([t4]).enter().append("g").classed("legendlines", true);
            var f3 = i2.selectAll("g.legendsymbols").data([t4]);
            f3.enter().append("g").classed("legendsymbols", true), f3.selectAll("g.legendpoints").data([t4]).enter().append("g").classed("legendpoints", true);
          }).each(function(t4) {
            var r4, i2 = t4[0].trace, o2 = [];
            if (i2.visible)
              switch (i2.type) {
                case "histogram2d":
                case "heatmap":
                  o2 = [["M-15,-2V4H15V-2Z"]], r4 = true;
                  break;
                case "choropleth":
                case "choroplethmapbox":
                  o2 = [["M-6,-6V6H6V-6Z"]], r4 = true;
                  break;
                case "densitymapbox":
                  o2 = [["M-6,0 a6,6 0 1,0 12,0 a 6,6 0 1,0 -12,0"]], r4 = "radial";
                  break;
                case "cone":
                  o2 = [["M-6,2 A2,2 0 0,0 -6,6 V6L6,4Z"], ["M-6,-6 A2,2 0 0,0 -6,-2 L6,-4Z"], ["M-6,-2 A2,2 0 0,0 -6,2 L6,0Z"]], r4 = false;
                  break;
                case "streamtube":
                  o2 = [["M-6,2 A2,2 0 0,0 -6,6 H6 A2,2 0 0,1 6,2 Z"], ["M-6,-6 A2,2 0 0,0 -6,-2 H6 A2,2 0 0,1 6,-6 Z"], ["M-6,-2 A2,2 0 0,0 -6,2 H6 A2,2 0 0,1 6,-2 Z"]], r4 = false;
                  break;
                case "surface":
                  o2 = [["M-6,-6 A2,3 0 0,0 -6,0 H6 A2,3 0 0,1 6,-6 Z"], ["M-6,1 A2,3 0 0,1 -6,6 H6 A2,3 0 0,0 6,0 Z"]], r4 = true;
                  break;
                case "mesh3d":
                  o2 = [["M-6,6H0L-6,-6Z"], ["M6,6H0L6,-6Z"], ["M-6,-6H6L0,6Z"]], r4 = false;
                  break;
                case "volume":
                  o2 = [["M-6,6H0L-6,-6Z"], ["M6,6H0L6,-6Z"], ["M-6,-6H6L0,6Z"]], r4 = true;
                  break;
                case "isosurface":
                  o2 = [["M-6,6H0L-6,-6Z"], ["M6,6H0L6,-6Z"], ["M-6,-6 A12,24 0 0,0 6,-6 L0,6Z"]], r4 = false;
              }
            var c2 = n2.select(this).select("g.legendpoints").selectAll("path.legend3dandfriends").data(o2);
            c2.enter().append("path").classed("legend3dandfriends", true).attr("transform", _).style("stroke-miterlimit", 1), c2.exit().remove(), c2.each(function(t5, o3) {
              var c3, f3 = n2.select(this), h2 = u(i2), p3 = h2.colorscale, v2 = h2.reversescale;
              if (p3) {
                if (!r4) {
                  var g3 = p3.length;
                  c3 = 0 === o3 ? p3[v2 ? g3 - 1 : 0][1] : 1 === o3 ? p3[v2 ? 0 : g3 - 1][1] : p3[Math.floor((g3 - 1) / 2)][1];
                }
              } else {
                var y2 = i2.vertexcolor || i2.facecolor || i2.color;
                c3 = a.isArrayOrTypedArray(y2) ? y2[o3] || y2[0] : y2;
              }
              f3.attr("d", t5[0]), c3 ? f3.call(l.fill, c3) : f3.call(function(t6) {
                if (t6.size()) {
                  var n3 = "legendfill-" + i2.uid;
                  s.gradient(t6, e3, n3, d2(v2, "radial" === r4), p3, "fill");
                }
              });
            });
          }).each(function(t4) {
            var e4 = t4[0].trace, r4 = "waterfall" === e4.type;
            if (t4[0]._distinct && r4) {
              var i2 = t4[0].trace[t4[0].dir].marker;
              return t4[0].mc = i2.color, t4[0].mlw = i2.line.width, t4[0].mlc = i2.line.color, T(t4, this, "waterfall");
            }
            var a2 = [];
            e4.visible && r4 && (a2 = t4[0].hasTotals ? [["increasing", "M-6,-6V6H0Z"], ["totals", "M6,6H0L-6,-6H-0Z"], ["decreasing", "M6,6V-6H0Z"]] : [["increasing", "M-6,-6V6H6Z"], ["decreasing", "M6,6V-6H-6Z"]]);
            var o2 = n2.select(this).select("g.legendpoints").selectAll("path.legendwaterfall").data(a2);
            o2.enter().append("path").classed("legendwaterfall", true).attr("transform", _).style("stroke-miterlimit", 1), o2.exit().remove(), o2.each(function(t5) {
              var r5 = n2.select(this), i3 = e4[t5[0]].marker, a3 = w2(void 0, i3.line, 5, 2);
              r5.attr("d", t5[1]).style("stroke-width", a3 + "px").call(l.fill, i3.color), a3 && r5.call(l.stroke, i3.line.color);
            });
          }).each(function(t4) {
            T(t4, this, "funnel");
          }).each(function(t4) {
            T(t4, this);
          }).each(function(t4) {
            var r4 = t4[0].trace, o2 = n2.select(this).select("g.legendpoints").selectAll("path.legendbox").data(r4.visible && i.traceIs(r4, "box-violin") ? [t4] : []);
            o2.enter().append("path").classed("legendbox", true).attr("d", "M6,6H-6V-6H6Z").attr("transform", _), o2.exit().remove(), o2.each(function() {
              var t5 = n2.select(this);
              if ("all" !== r4.boxpoints && "all" !== r4.points || 0 !== l.opacity(r4.fillcolor) || 0 !== l.opacity((r4.line || {}).color)) {
                var i2 = w2(void 0, r4.line, 5, 2);
                t5.style("stroke-width", i2 + "px").call(l.fill, r4.fillcolor), i2 && l.stroke(t5, r4.line.color);
              } else {
                var u2 = a.minExtend(r4, { marker: { size: m2 ? 12 : a.constrain(r4.marker.size, 2, 16), sizeref: 1, sizemin: 1, sizemode: "diameter" } });
                o2.call(s.pointStyle, u2, e3);
              }
            });
          }).each(function(t4) {
            k(t4, this, "funnelarea");
          }).each(function(t4) {
            k(t4, this, "pie");
          }).each(function(t4) {
            var r4, i2, o2 = v(t4), l2 = o2.showFill, f3 = o2.showLine, h2 = o2.showGradientLine, p3 = o2.showGradientFill, g3 = o2.anyFill, y2 = o2.anyLine, m3 = t4[0], b2 = m3.trace, _2 = u(b2), T2 = _2.colorscale, k2 = _2.reversescale, A = c.hasMarkers(b2) || !g3 ? "M5,0" : y2 ? "M5,-2" : "M5,-3", M = n2.select(this), S = M.select(".legendfill").selectAll("path").data(l2 || p3 ? [t4] : []);
            if (S.enter().append("path").classed("js-fill", true), S.exit().remove(), S.attr("d", A + "h" + x + "v6h-" + x + "z").call(function(t5) {
              if (t5.size())
                if (l2)
                  s.fillGroupStyle(t5, e3);
                else {
                  var r5 = "legendfill-" + b2.uid;
                  s.gradient(t5, e3, r5, d2(k2), T2, "fill");
                }
            }), f3 || h2) {
              var E = w2(void 0, b2.line, 10, 5);
              i2 = a.minExtend(b2, { line: { width: E } }), r4 = [a.minExtend(m3, { trace: i2 })];
            }
            var L = M.select(".legendlines").selectAll("path").data(f3 || h2 ? [r4] : []);
            L.enter().append("path").classed("js-line", true), L.exit().remove(), L.attr("d", A + (h2 ? "l" + x + ",0.0001" : "h" + x)).call(f3 ? s.lineGroupStyle : function(t5) {
              if (t5.size()) {
                var r5 = "legendline-" + b2.uid;
                s.lineGroupStyle(t5), s.gradient(t5, e3, r5, d2(k2), T2, "stroke");
              }
            });
          }).each(function(t4) {
            var r4, i2, o2 = v(t4), l2 = o2.anyFill, u2 = o2.anyLine, f3 = o2.showLine, h2 = o2.showMarker, p3 = t4[0], d3 = p3.trace, g3 = !h2 && !u2 && !l2 && c.hasText(d3);
            function y2(t5, e4, r5, n3) {
              var i3 = a.nestedProperty(d3, t5).get(), o3 = a.isArrayOrTypedArray(i3) && e4 ? e4(i3) : i3;
              if (m2 && o3 && void 0 !== n3 && (o3 = n3), r5) {
                if (o3 < r5[0])
                  return r5[0];
                if (o3 > r5[1])
                  return r5[1];
              }
              return o3;
            }
            function x2(t5) {
              return p3._distinct && p3.index && t5[p3.index] ? t5[p3.index] : t5[0];
            }
            if (h2 || g3 || f3) {
              var b2 = {}, w3 = {};
              if (h2) {
                b2.mc = y2("marker.color", x2), b2.mx = y2("marker.symbol", x2), b2.mo = y2("marker.opacity", a.mean, [0.2, 1]), b2.mlc = y2("marker.line.color", x2), b2.mlw = y2("marker.line.width", a.mean, [0, 5], 2), w3.marker = { sizeref: 1, sizemin: 1, sizemode: "diameter" };
                var T2 = y2("marker.size", a.mean, [2, 16], 12);
                b2.ms = T2, w3.marker.size = T2;
              }
              f3 && (w3.line = { width: y2("line.width", x2, [0, 10], 5) }), g3 && (b2.tx = "Aa", b2.tp = y2("textposition", x2), b2.ts = 10, b2.tc = y2("textfont.color", x2), b2.tf = y2("textfont.family", x2)), r4 = [a.minExtend(p3, b2)], (i2 = a.minExtend(d3, w3)).selectedpoints = null, i2.texttemplate = null;
            }
            var k2 = n2.select(this).select("g.legendpoints"), A = k2.selectAll("path.scatterpts").data(h2 ? r4 : []);
            A.enter().insert("path", ":first-child").classed("scatterpts", true).attr("transform", _), A.exit().remove(), A.call(s.pointStyle, i2, e3), h2 && (r4[0].mrc = 3);
            var M = k2.selectAll("g.pointtext").data(g3 ? r4 : []);
            M.enter().append("g").classed("pointtext", true).append("text").attr("transform", _), M.exit().remove(), M.selectAll("text").call(s.textPointStyle, i2, e3);
          }).each(function(t4) {
            var e4 = t4[0].trace, r4 = n2.select(this).select("g.legendpoints").selectAll("path.legendcandle").data(e4.visible && "candlestick" === e4.type ? [t4, t4] : []);
            r4.enter().append("path").classed("legendcandle", true).attr("d", function(t5, e5) {
              return e5 ? "M-15,0H-8M-8,6V-6H8Z" : "M15,0H8M8,-6V6H-8Z";
            }).attr("transform", _).style("stroke-miterlimit", 1), r4.exit().remove(), r4.each(function(t5, r5) {
              var i2 = n2.select(this), a2 = e4[r5 ? "increasing" : "decreasing"], o2 = w2(void 0, a2.line, 5, 2);
              i2.style("stroke-width", o2 + "px").call(l.fill, a2.fillcolor), o2 && l.stroke(i2, a2.line.color);
            });
          }).each(function(t4) {
            var e4 = t4[0].trace, r4 = n2.select(this).select("g.legendpoints").selectAll("path.legendohlc").data(e4.visible && "ohlc" === e4.type ? [t4, t4] : []);
            r4.enter().append("path").classed("legendohlc", true).attr("d", function(t5, e5) {
              return e5 ? "M-15,0H0M-8,-6V0" : "M15,0H0M8,6V0";
            }).attr("transform", _).style("stroke-miterlimit", 1), r4.exit().remove(), r4.each(function(t5, r5) {
              var i2 = n2.select(this), a2 = e4[r5 ? "increasing" : "decreasing"], o2 = w2(void 0, a2.line, 5, 2);
              i2.style("fill", "none").call(s.dashLine, a2.line.dash, o2), o2 && l.stroke(i2, a2.line.color);
            });
          });
        };
      }, 42068: function(t2, e2, r2) {
        r2(93348), t2.exports = { editType: "modebar", orientation: { valType: "enumerated", values: ["v", "h"], dflt: "h", editType: "modebar" }, bgcolor: { valType: "color", editType: "modebar" }, color: { valType: "color", editType: "modebar" }, activecolor: { valType: "color", editType: "modebar" }, uirevision: { valType: "any", editType: "none" }, add: { valType: "string", arrayOk: true, dflt: "", editType: "modebar" }, remove: { valType: "string", arrayOk: true, dflt: "", editType: "modebar" } };
      }, 26023: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(74875), a = r2(41675), o = r2(24255), s = r2(34031).eraseActiveShape, l = r2(71828), u = l._, c = t2.exports = {};
        function f2(t3, e3) {
          var r3, i2, o2 = e3.currentTarget, s2 = o2.getAttribute("data-attr"), l2 = o2.getAttribute("data-val") || true, u2 = t3._fullLayout, c2 = {}, f3 = a.list(t3, null, true), h2 = u2._cartesianSpikesEnabled;
          if ("zoom" === s2) {
            var p3, d3 = "in" === l2 ? 0.5 : 2, v2 = (1 + d3) / 2, g3 = (1 - d3) / 2;
            for (i2 = 0; i2 < f3.length; i2++)
              if (!(r3 = f3[i2]).fixedrange)
                if (p3 = r3._name, "auto" === l2)
                  c2[p3 + ".autorange"] = true;
                else if ("reset" === l2) {
                  if (void 0 === r3._rangeInitial)
                    c2[p3 + ".autorange"] = true;
                  else {
                    var y2 = r3._rangeInitial.slice();
                    c2[p3 + ".range[0]"] = y2[0], c2[p3 + ".range[1]"] = y2[1];
                  }
                  void 0 !== r3._showSpikeInitial && (c2[p3 + ".showspikes"] = r3._showSpikeInitial, "on" !== h2 || r3._showSpikeInitial || (h2 = "off"));
                } else {
                  var m3 = [r3.r2l(r3.range[0]), r3.r2l(r3.range[1])], x2 = [v2 * m3[0] + g3 * m3[1], v2 * m3[1] + g3 * m3[0]];
                  c2[p3 + ".range[0]"] = r3.l2r(x2[0]), c2[p3 + ".range[1]"] = r3.l2r(x2[1]);
                }
          } else
            "hovermode" !== s2 || "x" !== l2 && "y" !== l2 || (l2 = u2._isHoriz ? "y" : "x", o2.setAttribute("data-val", l2)), c2[s2] = l2;
          u2._cartesianSpikesEnabled = h2, n2.call("_guiRelayout", t3, c2);
        }
        function h(t3, e3) {
          for (var r3 = e3.currentTarget, i2 = r3.getAttribute("data-attr"), a2 = r3.getAttribute("data-val") || true, o2 = t3._fullLayout._subplots.gl3d || [], s2 = {}, l2 = i2.split("."), u2 = 0; u2 < o2.length; u2++)
            s2[o2[u2] + "." + l2[1]] = a2;
          var c2 = "pan" === a2 ? a2 : "zoom";
          s2.dragmode = c2, n2.call("_guiRelayout", t3, s2);
        }
        function p2(t3, e3) {
          for (var r3 = e3.currentTarget.getAttribute("data-attr"), i2 = "resetLastSave" === r3, a2 = "resetDefault" === r3, o2 = t3._fullLayout, s2 = o2._subplots.gl3d || [], l2 = {}, u2 = 0; u2 < s2.length; u2++) {
            var c2, f3 = s2[u2], h2 = f3 + ".camera", p3 = f3 + ".aspectratio", d3 = f3 + ".aspectmode", v2 = o2[f3]._scene;
            i2 ? (l2[h2 + ".up"] = v2.viewInitial.up, l2[h2 + ".eye"] = v2.viewInitial.eye, l2[h2 + ".center"] = v2.viewInitial.center, c2 = true) : a2 && (l2[h2 + ".up"] = null, l2[h2 + ".eye"] = null, l2[h2 + ".center"] = null, c2 = true), c2 && (l2[p3 + ".x"] = v2.viewInitial.aspectratio.x, l2[p3 + ".y"] = v2.viewInitial.aspectratio.y, l2[p3 + ".z"] = v2.viewInitial.aspectratio.z, l2[d3] = v2.viewInitial.aspectmode);
          }
          n2.call("_guiRelayout", t3, l2);
        }
        function d2(t3, e3) {
          var r3 = e3.currentTarget, n3 = r3._previousVal, i2 = t3._fullLayout, a2 = i2._subplots.gl3d || [], o2 = ["xaxis", "yaxis", "zaxis"], s2 = {}, l2 = {};
          if (n3)
            l2 = n3, r3._previousVal = null;
          else {
            for (var u2 = 0; u2 < a2.length; u2++) {
              var c2 = a2[u2], f3 = i2[c2], h2 = c2 + ".hovermode";
              s2[h2] = f3.hovermode, l2[h2] = false;
              for (var p3 = 0; p3 < 3; p3++) {
                var d3 = o2[p3], v2 = c2 + "." + d3 + ".showspikes";
                l2[v2] = false, s2[v2] = f3[d3].showspikes;
              }
            }
            r3._previousVal = s2;
          }
          return l2;
        }
        function v(t3, e3) {
          for (var r3 = e3.currentTarget, i2 = r3.getAttribute("data-attr"), a2 = r3.getAttribute("data-val") || true, o2 = t3._fullLayout, s2 = o2._subplots.geo || [], l2 = 0; l2 < s2.length; l2++) {
            var u2 = s2[l2], c2 = o2[u2];
            if ("zoom" === i2) {
              var f3 = c2.projection.scale, h2 = "in" === a2 ? 2 * f3 : 0.5 * f3;
              n2.call("_guiRelayout", t3, u2 + ".projection.scale", h2);
            }
          }
          "reset" === i2 && x(t3, "geo");
        }
        function g2(t3) {
          var e3 = t3._fullLayout;
          return !e3.hovermode && (e3._has("cartesian") ? e3._isHoriz ? "y" : "x" : "closest");
        }
        function y(t3) {
          var e3 = g2(t3);
          n2.call("_guiRelayout", t3, "hovermode", e3);
        }
        function m2(t3, e3) {
          for (var r3 = e3.currentTarget.getAttribute("data-val"), i2 = t3._fullLayout, a2 = i2._subplots.mapbox || [], o2 = {}, s2 = 0; s2 < a2.length; s2++) {
            var l2 = a2[s2], u2 = i2[l2].zoom, c2 = "in" === r3 ? 1.05 * u2 : u2 / 1.05;
            o2[l2 + ".zoom"] = c2;
          }
          n2.call("_guiRelayout", t3, o2);
        }
        function x(t3, e3) {
          for (var r3 = t3._fullLayout, i2 = r3._subplots[e3] || [], a2 = {}, o2 = 0; o2 < i2.length; o2++)
            for (var s2 = i2[o2], l2 = r3[s2]._subplot.viewInitial, u2 = Object.keys(l2), c2 = 0; c2 < u2.length; c2++) {
              var f3 = u2[c2];
              a2[s2 + "." + f3] = l2[f3];
            }
          n2.call("_guiRelayout", t3, a2);
        }
        c.toImage = { name: "toImage", title: function(t3) {
          var e3 = (t3._context.toImageButtonOptions || {}).format || "png";
          return u(t3, "png" === e3 ? "Download plot as a png" : "Download plot");
        }, icon: o.camera, click: function(t3) {
          var e3 = t3._context.toImageButtonOptions, r3 = { format: e3.format || "png" };
          l.notifier(u(t3, "Taking snapshot - this may take a few seconds"), "long"), "svg" !== r3.format && l.isIE() && (l.notifier(u(t3, "IE only supports svg.  Changing format to svg."), "long"), r3.format = "svg"), ["filename", "width", "height", "scale"].forEach(function(t4) {
            t4 in e3 && (r3[t4] = e3[t4]);
          }), n2.call("downloadImage", t3, r3).then(function(e4) {
            l.notifier(u(t3, "Snapshot succeeded") + " - " + e4, "long");
          }).catch(function() {
            l.notifier(u(t3, "Sorry, there was a problem downloading your snapshot!"), "long");
          });
        } }, c.sendDataToCloud = { name: "sendDataToCloud", title: function(t3) {
          return u(t3, "Edit in Chart Studio");
        }, icon: o.disk, click: function(t3) {
          i.sendDataToCloud(t3);
        } }, c.editInChartStudio = { name: "editInChartStudio", title: function(t3) {
          return u(t3, "Edit in Chart Studio");
        }, icon: o.pencil, click: function(t3) {
          i.sendDataToCloud(t3);
        } }, c.zoom2d = { name: "zoom2d", _cat: "zoom", title: function(t3) {
          return u(t3, "Zoom");
        }, attr: "dragmode", val: "zoom", icon: o.zoombox, click: f2 }, c.pan2d = { name: "pan2d", _cat: "pan", title: function(t3) {
          return u(t3, "Pan");
        }, attr: "dragmode", val: "pan", icon: o.pan, click: f2 }, c.select2d = { name: "select2d", _cat: "select", title: function(t3) {
          return u(t3, "Box Select");
        }, attr: "dragmode", val: "select", icon: o.selectbox, click: f2 }, c.lasso2d = { name: "lasso2d", _cat: "lasso", title: function(t3) {
          return u(t3, "Lasso Select");
        }, attr: "dragmode", val: "lasso", icon: o.lasso, click: f2 }, c.drawclosedpath = { name: "drawclosedpath", title: function(t3) {
          return u(t3, "Draw closed freeform");
        }, attr: "dragmode", val: "drawclosedpath", icon: o.drawclosedpath, click: f2 }, c.drawopenpath = { name: "drawopenpath", title: function(t3) {
          return u(t3, "Draw open freeform");
        }, attr: "dragmode", val: "drawopenpath", icon: o.drawopenpath, click: f2 }, c.drawline = { name: "drawline", title: function(t3) {
          return u(t3, "Draw line");
        }, attr: "dragmode", val: "drawline", icon: o.drawline, click: f2 }, c.drawrect = { name: "drawrect", title: function(t3) {
          return u(t3, "Draw rectangle");
        }, attr: "dragmode", val: "drawrect", icon: o.drawrect, click: f2 }, c.drawcircle = { name: "drawcircle", title: function(t3) {
          return u(t3, "Draw circle");
        }, attr: "dragmode", val: "drawcircle", icon: o.drawcircle, click: f2 }, c.eraseshape = { name: "eraseshape", title: function(t3) {
          return u(t3, "Erase active shape");
        }, icon: o.eraseshape, click: s }, c.zoomIn2d = { name: "zoomIn2d", _cat: "zoomin", title: function(t3) {
          return u(t3, "Zoom in");
        }, attr: "zoom", val: "in", icon: o.zoom_plus, click: f2 }, c.zoomOut2d = { name: "zoomOut2d", _cat: "zoomout", title: function(t3) {
          return u(t3, "Zoom out");
        }, attr: "zoom", val: "out", icon: o.zoom_minus, click: f2 }, c.autoScale2d = { name: "autoScale2d", _cat: "autoscale", title: function(t3) {
          return u(t3, "Autoscale");
        }, attr: "zoom", val: "auto", icon: o.autoscale, click: f2 }, c.resetScale2d = { name: "resetScale2d", _cat: "resetscale", title: function(t3) {
          return u(t3, "Reset axes");
        }, attr: "zoom", val: "reset", icon: o.home, click: f2 }, c.hoverClosestCartesian = { name: "hoverClosestCartesian", _cat: "hoverclosest", title: function(t3) {
          return u(t3, "Show closest data on hover");
        }, attr: "hovermode", val: "closest", icon: o.tooltip_basic, gravity: "ne", click: f2 }, c.hoverCompareCartesian = { name: "hoverCompareCartesian", _cat: "hoverCompare", title: function(t3) {
          return u(t3, "Compare data on hover");
        }, attr: "hovermode", val: function(t3) {
          return t3._fullLayout._isHoriz ? "y" : "x";
        }, icon: o.tooltip_compare, gravity: "ne", click: f2 }, c.zoom3d = { name: "zoom3d", _cat: "zoom", title: function(t3) {
          return u(t3, "Zoom");
        }, attr: "scene.dragmode", val: "zoom", icon: o.zoombox, click: h }, c.pan3d = { name: "pan3d", _cat: "pan", title: function(t3) {
          return u(t3, "Pan");
        }, attr: "scene.dragmode", val: "pan", icon: o.pan, click: h }, c.orbitRotation = { name: "orbitRotation", title: function(t3) {
          return u(t3, "Orbital rotation");
        }, attr: "scene.dragmode", val: "orbit", icon: o["3d_rotate"], click: h }, c.tableRotation = { name: "tableRotation", title: function(t3) {
          return u(t3, "Turntable rotation");
        }, attr: "scene.dragmode", val: "turntable", icon: o["z-axis"], click: h }, c.resetCameraDefault3d = { name: "resetCameraDefault3d", _cat: "resetCameraDefault", title: function(t3) {
          return u(t3, "Reset camera to default");
        }, attr: "resetDefault", icon: o.home, click: p2 }, c.resetCameraLastSave3d = { name: "resetCameraLastSave3d", _cat: "resetCameraLastSave", title: function(t3) {
          return u(t3, "Reset camera to last save");
        }, attr: "resetLastSave", icon: o.movie, click: p2 }, c.hoverClosest3d = { name: "hoverClosest3d", _cat: "hoverclosest", title: function(t3) {
          return u(t3, "Toggle show closest data on hover");
        }, attr: "hovermode", val: null, toggle: true, icon: o.tooltip_basic, gravity: "ne", click: function(t3, e3) {
          var r3 = d2(t3, e3);
          n2.call("_guiRelayout", t3, r3);
        } }, c.zoomInGeo = { name: "zoomInGeo", _cat: "zoomin", title: function(t3) {
          return u(t3, "Zoom in");
        }, attr: "zoom", val: "in", icon: o.zoom_plus, click: v }, c.zoomOutGeo = { name: "zoomOutGeo", _cat: "zoomout", title: function(t3) {
          return u(t3, "Zoom out");
        }, attr: "zoom", val: "out", icon: o.zoom_minus, click: v }, c.resetGeo = { name: "resetGeo", _cat: "reset", title: function(t3) {
          return u(t3, "Reset");
        }, attr: "reset", val: null, icon: o.autoscale, click: v }, c.hoverClosestGeo = { name: "hoverClosestGeo", _cat: "hoverclosest", title: function(t3) {
          return u(t3, "Toggle show closest data on hover");
        }, attr: "hovermode", val: null, toggle: true, icon: o.tooltip_basic, gravity: "ne", click: y }, c.hoverClosestGl2d = { name: "hoverClosestGl2d", _cat: "hoverclosest", title: function(t3) {
          return u(t3, "Toggle show closest data on hover");
        }, attr: "hovermode", val: null, toggle: true, icon: o.tooltip_basic, gravity: "ne", click: y }, c.hoverClosestPie = { name: "hoverClosestPie", _cat: "hoverclosest", title: function(t3) {
          return u(t3, "Toggle show closest data on hover");
        }, attr: "hovermode", val: "closest", icon: o.tooltip_basic, gravity: "ne", click: y }, c.resetViewSankey = { name: "resetSankeyGroup", title: function(t3) {
          return u(t3, "Reset view");
        }, icon: o.home, click: function(t3) {
          for (var e3 = { "node.groups": [], "node.x": [], "node.y": [] }, r3 = 0; r3 < t3._fullData.length; r3++) {
            var i2 = t3._fullData[r3]._viewInitial;
            e3["node.groups"].push(i2.node.groups.slice()), e3["node.x"].push(i2.node.x.slice()), e3["node.y"].push(i2.node.y.slice());
          }
          n2.call("restyle", t3, e3);
        } }, c.toggleHover = { name: "toggleHover", title: function(t3) {
          return u(t3, "Toggle show closest data on hover");
        }, attr: "hovermode", val: null, toggle: true, icon: o.tooltip_basic, gravity: "ne", click: function(t3, e3) {
          var r3 = d2(t3, e3);
          r3.hovermode = g2(t3), n2.call("_guiRelayout", t3, r3);
        } }, c.resetViews = { name: "resetViews", title: function(t3) {
          return u(t3, "Reset views");
        }, icon: o.home, click: function(t3, e3) {
          var r3 = e3.currentTarget;
          r3.setAttribute("data-attr", "zoom"), r3.setAttribute("data-val", "reset"), f2(t3, e3), r3.setAttribute("data-attr", "resetLastSave"), p2(t3, e3), x(t3, "geo"), x(t3, "mapbox");
        } }, c.toggleSpikelines = { name: "toggleSpikelines", title: function(t3) {
          return u(t3, "Toggle Spike Lines");
        }, icon: o.spikeline, attr: "_cartesianSpikesEnabled", val: "on", click: function(t3) {
          var e3 = t3._fullLayout, r3 = e3._cartesianSpikesEnabled;
          e3._cartesianSpikesEnabled = "on" === r3 ? "off" : "on", n2.call("_guiRelayout", t3, function(t4) {
            for (var e4 = "on" === t4._fullLayout._cartesianSpikesEnabled, r4 = a.list(t4, null, true), n3 = {}, i2 = 0; i2 < r4.length; i2++) {
              var o2 = r4[i2];
              n3[o2._name + ".showspikes"] = !!e4 || o2._showSpikeInitial;
            }
            return n3;
          }(t3));
        } }, c.resetViewMapbox = { name: "resetViewMapbox", _cat: "resetView", title: function(t3) {
          return u(t3, "Reset view");
        }, attr: "reset", icon: o.home, click: function(t3) {
          x(t3, "mapbox");
        } }, c.zoomInMapbox = { name: "zoomInMapbox", _cat: "zoomin", title: function(t3) {
          return u(t3, "Zoom in");
        }, attr: "zoom", val: "in", icon: o.zoom_plus, click: m2 }, c.zoomOutMapbox = { name: "zoomOutMapbox", _cat: "zoomout", title: function(t3) {
          return u(t3, "Zoom out");
        }, attr: "zoom", val: "out", icon: o.zoom_minus, click: m2 };
      }, 93348: function(t2, e2, r2) {
        var n2 = r2(26023), i = Object.keys(n2), a = ["drawline", "drawopenpath", "drawclosedpath", "drawcircle", "drawrect", "eraseshape"], o = ["v1hovermode", "hoverclosest", "hovercompare", "togglehover", "togglespikelines"].concat(a), s = [];
        i.forEach(function(t3) {
          !function(t4) {
            if (-1 === o.indexOf(t4._cat || t4.name)) {
              var e3 = t4.name, r3 = (t4._cat || t4.name).toLowerCase();
              -1 === s.indexOf(e3) && s.push(e3), -1 === s.indexOf(r3) && s.push(r3);
            }
          }(n2[t3]);
        }), s.sort(), t2.exports = { DRAW_MODES: a, backButtons: o, foreButtons: s };
      }, 35750: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901), a = r2(44467), o = r2(42068);
        t2.exports = function(t3, e3) {
          var r3 = t3.modebar || {}, s = a.newContainer(e3, "modebar");
          function l(t4, e4) {
            return n2.coerce(r3, s, o, t4, e4);
          }
          l("orientation"), l("bgcolor", i.addOpacity(e3.paper_bgcolor, 0.5));
          var u = i.contrast(i.rgb(e3.modebar.bgcolor));
          l("color", i.addOpacity(u, 0.3)), l("activecolor", i.addOpacity(u, 0.7)), l("uirevision", e3.uirevision), l("add"), l("remove");
        };
      }, 64168: function(t2, e2, r2) {
        t2.exports = { moduleType: "component", name: "modebar", layoutAttributes: r2(42068), supplyLayoutDefaults: r2(35750), manage: r2(14192) };
      }, 14192: function(t2, e2, r2) {
        var n2 = r2(41675), i = r2(34098), a = r2(73972), o = r2(23469).isUnifiedHover, s = r2(37676), l = r2(26023), u = r2(93348).DRAW_MODES, c = r2(71828).extendDeep;
        t2.exports = function(t3) {
          var e3 = t3._fullLayout, r3 = t3._context, f2 = e3._modeBar;
          if (r3.displayModeBar || r3.watermark) {
            if (!Array.isArray(r3.modeBarButtonsToRemove))
              throw new Error(["*modeBarButtonsToRemove* configuration options", "must be an array."].join(" "));
            if (!Array.isArray(r3.modeBarButtonsToAdd))
              throw new Error(["*modeBarButtonsToAdd* configuration options", "must be an array."].join(" "));
            var h, p2 = r3.modeBarButtons;
            h = Array.isArray(p2) && p2.length ? function(t4) {
              for (var e4 = c([], t4), r4 = 0; r4 < e4.length; r4++)
                for (var n3 = e4[r4], i2 = 0; i2 < n3.length; i2++) {
                  var a2 = n3[i2];
                  if ("string" == typeof a2) {
                    if (void 0 === l[a2])
                      throw new Error(["*modeBarButtons* configuration options", "invalid button name"].join(" "));
                    e4[r4][i2] = l[a2];
                  }
                }
              return e4;
            }(p2) : !r3.displayModeBar && r3.watermark ? [] : function(t4) {
              var e4 = t4._fullLayout, r4 = t4._fullData, s2 = t4._context;
              function c2(t5, e5) {
                if ("string" == typeof e5) {
                  if (e5.toLowerCase() === t5.toLowerCase())
                    return true;
                } else {
                  var r5 = e5.name, n3 = e5._cat || e5.name;
                  if (r5 === t5 || n3 === t5.toLowerCase())
                    return true;
                }
                return false;
              }
              var f3 = e4.modebar.add;
              "string" == typeof f3 && (f3 = [f3]);
              var h2 = e4.modebar.remove;
              "string" == typeof h2 && (h2 = [h2]);
              var p3 = s2.modeBarButtonsToAdd.concat(f3.filter(function(t5) {
                for (var e5 = 0; e5 < s2.modeBarButtonsToRemove.length; e5++)
                  if (c2(t5, s2.modeBarButtonsToRemove[e5]))
                    return false;
                return true;
              })), d2 = s2.modeBarButtonsToRemove.concat(h2.filter(function(t5) {
                for (var e5 = 0; e5 < s2.modeBarButtonsToAdd.length; e5++)
                  if (c2(t5, s2.modeBarButtonsToAdd[e5]))
                    return false;
                return true;
              })), v = e4._has("cartesian"), g2 = e4._has("gl3d"), y = e4._has("geo"), m2 = e4._has("pie"), x = e4._has("funnelarea"), b = e4._has("gl2d"), _ = e4._has("ternary"), w2 = e4._has("mapbox"), T = e4._has("polar"), k = e4._has("smith"), A = e4._has("sankey"), M = function(t5) {
                for (var e5 = n2.list({ _fullLayout: t5 }, null, true), r5 = 0; r5 < e5.length; r5++)
                  if (!e5[r5].fixedrange)
                    return false;
                return true;
              }(e4), S = o(e4.hovermode), E = [];
              function L(t5) {
                if (t5.length) {
                  for (var e5 = [], r5 = 0; r5 < t5.length; r5++) {
                    for (var n3 = t5[r5], i2 = l[n3], a2 = i2.name.toLowerCase(), o2 = (i2._cat || i2.name).toLowerCase(), s3 = false, u2 = 0; u2 < d2.length; u2++) {
                      var c3 = d2[u2].toLowerCase();
                      if (c3 === a2 || c3 === o2) {
                        s3 = true;
                        break;
                      }
                    }
                    s3 || e5.push(l[n3]);
                  }
                  E.push(e5);
                }
              }
              var C = ["toImage"];
              s2.showEditInChartStudio ? C.push("editInChartStudio") : s2.showSendToCloud && C.push("sendDataToCloud"), L(C);
              var P = [], O = [], I = [], D = [];
              (v || b || m2 || x || _) + y + g2 + w2 + T + k > 1 ? (O = ["toggleHover"], I = ["resetViews"]) : y ? (P = ["zoomInGeo", "zoomOutGeo"], O = ["hoverClosestGeo"], I = ["resetGeo"]) : g2 ? (O = ["hoverClosest3d"], I = ["resetCameraDefault3d", "resetCameraLastSave3d"]) : w2 ? (P = ["zoomInMapbox", "zoomOutMapbox"], O = ["toggleHover"], I = ["resetViewMapbox"]) : b ? O = ["hoverClosestGl2d"] : m2 ? O = ["hoverClosestPie"] : A ? (O = ["hoverClosestCartesian", "hoverCompareCartesian"], I = ["resetViewSankey"]) : O = ["toggleHover"], v && (O = ["toggleSpikelines", "hoverClosestCartesian", "hoverCompareCartesian"]), (function(t5) {
                for (var e5 = 0; e5 < t5.length; e5++)
                  if (!a.traceIs(t5[e5], "noHover"))
                    return false;
                return true;
              }(r4) || S) && (O = []), !v && !b || M || (P = ["zoomIn2d", "zoomOut2d", "autoScale2d"], "resetViews" !== I[0] && (I = ["resetScale2d"])), g2 ? D = ["zoom3d", "pan3d", "orbitRotation", "tableRotation"] : (v || b) && !M || _ ? D = ["zoom2d", "pan2d"] : w2 || y ? D = ["pan2d"] : T && (D = ["zoom2d"]), function(t5) {
                for (var e5 = false, r5 = 0; r5 < t5.length && !e5; r5++) {
                  var n3 = t5[r5];
                  n3._module && n3._module.selectPoints && (a.traceIs(n3, "scatter-like") ? (i.hasMarkers(n3) || i.hasText(n3)) && (e5 = true) : a.traceIs(n3, "box-violin") && "all" !== n3.boxpoints && "all" !== n3.points || (e5 = true));
                }
                return e5;
              }(r4) && D.push("select2d", "lasso2d");
              var z = [], R = function(t5) {
                -1 === z.indexOf(t5) && -1 !== O.indexOf(t5) && z.push(t5);
              };
              if (Array.isArray(p3)) {
                for (var F = [], B = 0; B < p3.length; B++) {
                  var N = p3[B];
                  "string" == typeof N ? (N = N.toLowerCase(), -1 !== u.indexOf(N) ? (e4._has("mapbox") || e4._has("cartesian")) && D.push(N) : "togglespikelines" === N ? R("toggleSpikelines") : "togglehover" === N ? R("toggleHover") : "hovercompare" === N ? R("hoverCompareCartesian") : "hoverclosest" === N ? (R("hoverClosestCartesian"), R("hoverClosestGeo"), R("hoverClosest3d"), R("hoverClosestGl2d"), R("hoverClosestPie")) : "v1hovermode" === N && (R("toggleHover"), R("hoverClosestCartesian"), R("hoverCompareCartesian"), R("hoverClosestGeo"), R("hoverClosest3d"), R("hoverClosestGl2d"), R("hoverClosestPie"))) : F.push(N);
                }
                p3 = F;
              }
              return L(D), L(P.concat(I)), L(z), function(t5, e5) {
                if (e5.length)
                  if (Array.isArray(e5[0]))
                    for (var r5 = 0; r5 < e5.length; r5++)
                      t5.push(e5[r5]);
                  else
                    t5.push(e5);
                return t5;
              }(E, p3);
            }(t3), f2 ? f2.update(t3, h) : e3._modeBar = s(t3, h);
          } else
            f2 && (f2.destroy(), delete e3._modeBar);
        };
      }, 37676: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(92770), a = r2(71828), o = r2(24255), s = r2(11506).version, l = new DOMParser();
        function u(t3) {
          this.container = t3.container, this.element = document.createElement("div"), this.update(t3.graphInfo, t3.buttons), this.container.appendChild(this.element);
        }
        var c = u.prototype;
        c.update = function(t3, e3) {
          this.graphInfo = t3;
          var r3 = this.graphInfo._context, n3 = this.graphInfo._fullLayout, i2 = "modebar-" + n3._uid;
          this.element.setAttribute("id", i2), this._uid = i2, this.element.className = "modebar", "hover" === r3.displayModeBar && (this.element.className += " modebar--hover ease-bg"), "v" === n3.modebar.orientation && (this.element.className += " vertical", e3 = e3.reverse());
          var o2 = n3.modebar, s2 = "hover" === r3.displayModeBar ? ".js-plotly-plot .plotly:hover " : "";
          a.deleteRelatedStyleRule(i2), a.addRelatedStyleRule(i2, s2 + "#" + i2 + " .modebar-group", "background-color: " + o2.bgcolor), a.addRelatedStyleRule(i2, "#" + i2 + " .modebar-btn .icon path", "fill: " + o2.color), a.addRelatedStyleRule(i2, "#" + i2 + " .modebar-btn:hover .icon path", "fill: " + o2.activecolor), a.addRelatedStyleRule(i2, "#" + i2 + " .modebar-btn.active .icon path", "fill: " + o2.activecolor);
          var l2 = !this.hasButtons(e3), u2 = this.hasLogo !== r3.displaylogo, c2 = this.locale !== r3.locale;
          if (this.locale = r3.locale, (l2 || u2 || c2) && (this.removeAllButtons(), this.updateButtons(e3), r3.watermark || r3.displaylogo)) {
            var f2 = this.getLogo();
            r3.watermark && (f2.className = f2.className + " watermark"), "v" === n3.modebar.orientation ? this.element.insertBefore(f2, this.element.childNodes[0]) : this.element.appendChild(f2), this.hasLogo = true;
          }
          this.updateActiveButton();
        }, c.updateButtons = function(t3) {
          var e3 = this;
          this.buttons = t3, this.buttonElements = [], this.buttonsNames = [], this.buttons.forEach(function(t4) {
            var r3 = e3.createGroup();
            t4.forEach(function(t5) {
              var n3 = t5.name;
              if (!n3)
                throw new Error("must provide button 'name' in button config");
              if (-1 !== e3.buttonsNames.indexOf(n3))
                throw new Error("button name '" + n3 + "' is taken");
              e3.buttonsNames.push(n3);
              var i2 = e3.createButton(t5);
              e3.buttonElements.push(i2), r3.appendChild(i2);
            }), e3.element.appendChild(r3);
          });
        }, c.createGroup = function() {
          var t3 = document.createElement("div");
          return t3.className = "modebar-group", t3;
        }, c.createButton = function(t3) {
          var e3 = this, r3 = document.createElement("a");
          r3.setAttribute("rel", "tooltip"), r3.className = "modebar-btn";
          var i2 = t3.title;
          void 0 === i2 ? i2 = t3.name : "function" == typeof i2 && (i2 = i2(this.graphInfo)), (i2 || 0 === i2) && r3.setAttribute("data-title", i2), void 0 !== t3.attr && r3.setAttribute("data-attr", t3.attr);
          var a2 = t3.val;
          if (void 0 !== a2 && ("function" == typeof a2 && (a2 = a2(this.graphInfo)), r3.setAttribute("data-val", a2)), "function" != typeof t3.click)
            throw new Error("must provide button 'click' function in button config");
          r3.addEventListener("click", function(r4) {
            t3.click(e3.graphInfo, r4), e3.updateActiveButton(r4.currentTarget);
          }), r3.setAttribute("data-toggle", t3.toggle || false), t3.toggle && n2.select(r3).classed("active", true);
          var s2 = t3.icon;
          return "function" == typeof s2 ? r3.appendChild(s2()) : r3.appendChild(this.createIcon(s2 || o.question)), r3.setAttribute("data-gravity", t3.gravity || "n"), r3;
        }, c.createIcon = function(t3) {
          var e3, r3 = i(t3.height) ? Number(t3.height) : t3.ascent - t3.descent, n3 = "http://www.w3.org/2000/svg";
          if (t3.path) {
            (e3 = document.createElementNS(n3, "svg")).setAttribute("viewBox", [0, 0, t3.width, r3].join(" ")), e3.setAttribute("class", "icon");
            var a2 = document.createElementNS(n3, "path");
            a2.setAttribute("d", t3.path), t3.transform ? a2.setAttribute("transform", t3.transform) : void 0 !== t3.ascent && a2.setAttribute("transform", "matrix(1 0 0 -1 0 " + t3.ascent + ")"), e3.appendChild(a2);
          }
          return t3.svg && (e3 = l.parseFromString(t3.svg, "application/xml").childNodes[0]), e3.setAttribute("height", "1em"), e3.setAttribute("width", "1em"), e3;
        }, c.updateActiveButton = function(t3) {
          var e3 = this.graphInfo._fullLayout, r3 = void 0 !== t3 ? t3.getAttribute("data-attr") : null;
          this.buttonElements.forEach(function(t4) {
            var i2 = t4.getAttribute("data-val") || true, o2 = t4.getAttribute("data-attr"), s2 = "true" === t4.getAttribute("data-toggle"), l2 = n2.select(t4);
            if (s2)
              o2 === r3 && l2.classed("active", !l2.classed("active"));
            else {
              var u2 = null === o2 ? o2 : a.nestedProperty(e3, o2).get();
              l2.classed("active", u2 === i2);
            }
          });
        }, c.hasButtons = function(t3) {
          var e3 = this.buttons;
          if (!e3)
            return false;
          if (t3.length !== e3.length)
            return false;
          for (var r3 = 0; r3 < t3.length; ++r3) {
            if (t3[r3].length !== e3[r3].length)
              return false;
            for (var n3 = 0; n3 < t3[r3].length; n3++)
              if (t3[r3][n3].name !== e3[r3][n3].name)
                return false;
          }
          return true;
        }, c.getLogo = function() {
          var t3 = this.createGroup(), e3 = document.createElement("a");
          return e3.href = "https://plotly.com/", e3.target = "_blank", e3.setAttribute("data-title", a._(this.graphInfo, "Produced with Plotly.js") + " (v" + s + ")"), e3.className = "modebar-btn plotlyjsicon modebar-btn--logo", e3.appendChild(this.createIcon(o.newplotlylogo)), t3.appendChild(e3), t3;
        }, c.removeAllButtons = function() {
          for (; this.element.firstChild; )
            this.element.removeChild(this.element.firstChild);
          this.hasLogo = false;
        }, c.destroy = function() {
          a.removeElement(this.container.querySelector(".modebar")), a.deleteRelatedStyleRule(this._uid);
        }, t2.exports = function(t3, e3) {
          var r3 = t3._fullLayout, i2 = new u({ graphInfo: t3, container: r3._modebardiv.node(), buttons: e3 });
          return r3._privateplot && n2.select(i2.element).append("span").classed("badge-private float--left", true).text("PRIVATE"), i2;
        };
      }, 37113: function(t2, e2, r2) {
        var n2 = r2(41940), i = r2(22399), a = (0, r2(44467).templatedArray)("button", { visible: { valType: "boolean", dflt: true, editType: "plot" }, step: { valType: "enumerated", values: ["month", "year", "day", "hour", "minute", "second", "all"], dflt: "month", editType: "plot" }, stepmode: { valType: "enumerated", values: ["backward", "todate"], dflt: "backward", editType: "plot" }, count: { valType: "number", min: 0, dflt: 1, editType: "plot" }, label: { valType: "string", editType: "plot" }, editType: "plot" });
        t2.exports = { visible: { valType: "boolean", editType: "plot" }, buttons: a, x: { valType: "number", min: -2, max: 3, editType: "plot" }, xanchor: { valType: "enumerated", values: ["auto", "left", "center", "right"], dflt: "left", editType: "plot" }, y: { valType: "number", min: -2, max: 3, editType: "plot" }, yanchor: { valType: "enumerated", values: ["auto", "top", "middle", "bottom"], dflt: "bottom", editType: "plot" }, font: n2({ editType: "plot" }), bgcolor: { valType: "color", dflt: i.lightLine, editType: "plot" }, activecolor: { valType: "color", editType: "plot" }, bordercolor: { valType: "color", dflt: i.defaultLine, editType: "plot" }, borderwidth: { valType: "number", min: 0, dflt: 0, editType: "plot" }, editType: "plot" };
      }, 89573: function(t2) {
        t2.exports = { yPad: 0.02, minButtonWidth: 30, rx: 3, ry: 3, lightAmount: 25, darkAmount: 10 };
      }, 28674: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901), a = r2(44467), o = r2(85501), s = r2(37113), l = r2(89573);
        function u(t3, e3, r3, i2) {
          var a2 = i2.calendar;
          function o2(r4, i3) {
            return n2.coerce(t3, e3, s.buttons, r4, i3);
          }
          if (o2("visible")) {
            var l2 = o2("step");
            "all" !== l2 && (!a2 || "gregorian" === a2 || "month" !== l2 && "year" !== l2 ? o2("stepmode") : e3.stepmode = "backward", o2("count")), o2("label");
          }
        }
        t2.exports = function(t3, e3, r3, c, f2) {
          var h = t3.rangeselector || {}, p2 = a.newContainer(e3, "rangeselector");
          function d2(t4, e4) {
            return n2.coerce(h, p2, s, t4, e4);
          }
          if (d2("visible", o(h, p2, { name: "buttons", handleItemDefaults: u, calendar: f2 }).length > 0)) {
            var v = function(t4, e4, r4) {
              for (var n3 = r4.filter(function(r5) {
                return e4[r5].anchor === t4._id;
              }), i2 = 0, a2 = 0; a2 < n3.length; a2++) {
                var o2 = e4[n3[a2]].domain;
                o2 && (i2 = Math.max(o2[1], i2));
              }
              return [t4.domain[0], i2 + l.yPad];
            }(e3, r3, c);
            d2("x", v[0]), d2("y", v[1]), n2.noneOrAll(t3, e3, ["x", "y"]), d2("xanchor"), d2("yanchor"), n2.coerceFont(d2, "font", r3.font);
            var g2 = d2("bgcolor");
            d2("activecolor", i.contrast(g2, l.lightAmount, l.darkAmount)), d2("bordercolor"), d2("borderwidth");
          }
        };
      }, 21598: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(73972), a = r2(74875), o = r2(7901), s = r2(91424), l = r2(71828), u = l.strTranslate, c = r2(63893), f2 = r2(41675), h = r2(18783), p2 = h.LINE_SPACING, d2 = h.FROM_TL, v = h.FROM_BR, g2 = r2(89573), y = r2(70565);
        function m2(t3) {
          return t3._id;
        }
        function x(t3, e3, r3) {
          var n3 = l.ensureSingle(t3, "rect", "selector-rect", function(t4) {
            t4.attr("shape-rendering", "crispEdges");
          });
          n3.attr({ rx: g2.rx, ry: g2.ry }), n3.call(o.stroke, e3.bordercolor).call(o.fill, function(t4, e4) {
            return e4._isActive || e4._isHovered ? t4.activecolor : t4.bgcolor;
          }(e3, r3)).style("stroke-width", e3.borderwidth + "px");
        }
        function b(t3, e3, r3, n3) {
          var i2, a2;
          l.ensureSingle(t3, "text", "selector-text", function(t4) {
            t4.attr("text-anchor", "middle");
          }).call(s.font, e3.font).text((i2 = r3, a2 = n3._fullLayout._meta, i2.label ? a2 ? l.templateString(i2.label, a2) : i2.label : "all" === i2.step ? "all" : i2.count + i2.step.charAt(0))).call(function(t4) {
            c.convertToTspans(t4, n3);
          });
        }
        t2.exports = function(t3) {
          var e3 = t3._fullLayout._infolayer.selectAll(".rangeselector").data(function(t4) {
            for (var e4 = f2.list(t4, "x", true), r3 = [], n3 = 0; n3 < e4.length; n3++) {
              var i2 = e4[n3];
              i2.rangeselector && i2.rangeselector.visible && r3.push(i2);
            }
            return r3;
          }(t3), m2);
          e3.enter().append("g").classed("rangeselector", true), e3.exit().remove(), e3.style({ cursor: "pointer", "pointer-events": "all" }), e3.each(function(e4) {
            var r3 = n2.select(this), o2 = e4, f3 = o2.rangeselector, h2 = r3.selectAll("g.button").data(l.filterVisible(f3.buttons));
            h2.enter().append("g").classed("button", true), h2.exit().remove(), h2.each(function(e5) {
              var r4 = n2.select(this), a2 = y(o2, e5);
              e5._isActive = function(t4, e6, r5) {
                if ("all" === e6.step)
                  return true === t4.autorange;
                var n3 = Object.keys(r5);
                return t4.range[0] === r5[n3[0]] && t4.range[1] === r5[n3[1]];
              }(o2, e5, a2), r4.call(x, f3, e5), r4.call(b, f3, e5, t3), r4.on("click", function() {
                t3._dragged || i.call("_guiRelayout", t3, a2);
              }), r4.on("mouseover", function() {
                e5._isHovered = true, r4.call(x, f3, e5);
              }), r4.on("mouseout", function() {
                e5._isHovered = false, r4.call(x, f3, e5);
              });
            }), function(t4, e5, r4, i2, o3) {
              var f4 = 0, h3 = 0, y2 = r4.borderwidth;
              e5.each(function() {
                var t5 = n2.select(this).select(".selector-text"), e6 = r4.font.size * p2, i3 = Math.max(e6 * c.lineCount(t5), 16) + 3;
                h3 = Math.max(h3, i3);
              }), e5.each(function() {
                var t5 = n2.select(this), e6 = t5.select(".selector-rect"), i3 = t5.select(".selector-text"), a2 = i3.node() && s.bBox(i3.node()).width, o4 = r4.font.size * p2, l2 = c.lineCount(i3), d3 = Math.max(a2 + 10, g2.minButtonWidth);
                t5.attr("transform", u(y2 + f4, y2)), e6.attr({ x: 0, y: 0, width: d3, height: h3 }), c.positionText(i3, d3 / 2, h3 / 2 - (l2 - 1) * o4 / 2 + 3), f4 += d3 + 5;
              });
              var m3 = t4._fullLayout._size, x2 = m3.l + m3.w * r4.x, b2 = m3.t + m3.h * (1 - r4.y), _ = "left";
              l.isRightAnchor(r4) && (x2 -= f4, _ = "right"), l.isCenterAnchor(r4) && (x2 -= f4 / 2, _ = "center");
              var w2 = "top";
              l.isBottomAnchor(r4) && (b2 -= h3, w2 = "bottom"), l.isMiddleAnchor(r4) && (b2 -= h3 / 2, w2 = "middle"), f4 = Math.ceil(f4), h3 = Math.ceil(h3), x2 = Math.round(x2), b2 = Math.round(b2), a.autoMargin(t4, i2 + "-range-selector", { x: r4.x, y: r4.y, l: f4 * d2[_], r: f4 * v[_], b: h3 * v[w2], t: h3 * d2[w2] }), o3.attr("transform", u(x2, b2));
            }(t3, h2, f3, o2._name, r3);
          });
        };
      }, 70565: function(t2, e2, r2) {
        var n2 = r2(81041), i = r2(71828).titleCase;
        t2.exports = function(t3, e3) {
          var r3 = t3._name, a = {};
          if ("all" === e3.step)
            a[r3 + ".autorange"] = true;
          else {
            var o = function(t4, e4) {
              var r4, a2 = t4.range, o2 = new Date(t4.r2l(a2[1])), s = e4.step, l = n2["utc" + i(s)], u = e4.count;
              switch (e4.stepmode) {
                case "backward":
                  r4 = t4.l2r(+l.offset(o2, -u));
                  break;
                case "todate":
                  var c = l.offset(o2, -u);
                  r4 = t4.l2r(+l.ceil(c));
              }
              return [r4, a2[1]];
            }(t3, e3);
            a[r3 + ".range[0]"] = o[0], a[r3 + ".range[1]"] = o[1];
          }
          return a;
        };
      }, 97218: function(t2, e2, r2) {
        t2.exports = { moduleType: "component", name: "rangeselector", schema: { subplots: { xaxis: { rangeselector: r2(37113) } } }, layoutAttributes: r2(37113), handleDefaults: r2(28674), draw: r2(21598) };
      }, 75148: function(t2, e2, r2) {
        var n2 = r2(22399);
        t2.exports = { bgcolor: { valType: "color", dflt: n2.background, editType: "plot" }, bordercolor: { valType: "color", dflt: n2.defaultLine, editType: "plot" }, borderwidth: { valType: "integer", dflt: 0, min: 0, editType: "plot" }, autorange: { valType: "boolean", dflt: true, editType: "calc", impliedEdits: { "range[0]": void 0, "range[1]": void 0 } }, range: { valType: "info_array", items: [{ valType: "any", editType: "calc", impliedEdits: { "^autorange": false } }, { valType: "any", editType: "calc", impliedEdits: { "^autorange": false } }], editType: "calc", impliedEdits: { autorange: false } }, thickness: { valType: "number", dflt: 0.15, min: 0, max: 1, editType: "plot" }, visible: { valType: "boolean", dflt: true, editType: "calc" }, editType: "calc" };
      }, 88443: function(t2, e2, r2) {
        var n2 = r2(41675).list, i = r2(71739).getAutoRange, a = r2(73251);
        t2.exports = function(t3) {
          for (var e3 = n2(t3, "x", true), r3 = 0; r3 < e3.length; r3++) {
            var o = e3[r3], s = o[a.name];
            s && s.visible && s.autorange && (s._input.autorange = true, s._input.range = s.range = i(t3, o));
          }
        };
      }, 73251: function(t2) {
        t2.exports = { name: "rangeslider", containerClassName: "rangeslider-container", bgClassName: "rangeslider-bg", rangePlotClassName: "rangeslider-rangeplot", maskMinClassName: "rangeslider-mask-min", maskMaxClassName: "rangeslider-mask-max", slideBoxClassName: "rangeslider-slidebox", grabberMinClassName: "rangeslider-grabber-min", grabAreaMinClassName: "rangeslider-grabarea-min", handleMinClassName: "rangeslider-handle-min", grabberMaxClassName: "rangeslider-grabber-max", grabAreaMaxClassName: "rangeslider-grabarea-max", handleMaxClassName: "rangeslider-handle-max", maskMinOppAxisClassName: "rangeslider-mask-min-opp-axis", maskMaxOppAxisClassName: "rangeslider-mask-max-opp-axis", maskColor: "rgba(0,0,0,0.4)", maskOppAxisColor: "rgba(0,0,0,0.2)", slideBoxFill: "transparent", slideBoxCursor: "ew-resize", grabAreaFill: "transparent", grabAreaCursor: "col-resize", grabAreaWidth: 10, handleWidth: 4, handleRadius: 1, handleStrokeWidth: 1, extraPad: 15 };
      }, 26377: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(44467), a = r2(41675), o = r2(75148), s = r2(47850);
        t2.exports = function(t3, e3, r3) {
          var l = t3[r3], u = e3[r3];
          if (l.rangeslider || e3._requestRangeslider[u._id]) {
            n2.isPlainObject(l.rangeslider) || (l.rangeslider = {});
            var c, f2, h = l.rangeslider, p2 = i.newContainer(u, "rangeslider");
            if (_("visible")) {
              _("bgcolor", e3.plot_bgcolor), _("bordercolor"), _("borderwidth"), _("thickness"), _("autorange", !u.isValidRange(h.range)), _("range");
              var d2 = e3._subplots;
              if (d2)
                for (var v = d2.cartesian.filter(function(t4) {
                  return t4.substr(0, t4.indexOf("y")) === a.name2id(r3);
                }).map(function(t4) {
                  return t4.substr(t4.indexOf("y"), t4.length);
                }), g2 = n2.simpleMap(v, a.id2name), y = 0; y < g2.length; y++) {
                  var m2 = g2[y];
                  c = h[m2] || {}, f2 = i.newContainer(p2, m2, "yaxis");
                  var x, b = e3[m2];
                  c.range && b.isValidRange(c.range) && (x = "fixed"), "match" !== w2("rangemode", x) && w2("range", b.range.slice());
                }
              p2._input = h;
            }
          }
          function _(t4, e4) {
            return n2.coerce(h, p2, o, t4, e4);
          }
          function w2(t4, e4) {
            return n2.coerce(c, f2, s, t4, e4);
          }
        };
      }, 72413: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(73972), a = r2(74875), o = r2(71828), s = o.strTranslate, l = r2(91424), u = r2(7901), c = r2(92998), f2 = r2(93612), h = r2(41675), p2 = r2(28569), d2 = r2(6964), v = r2(73251);
        function g2(t3, e3, r3, n3) {
          var i2 = o.ensureSingle(t3, "rect", v.bgClassName, function(t4) {
            t4.attr({ x: 0, y: 0, "shape-rendering": "crispEdges" });
          }), a2 = n3.borderwidth % 2 == 0 ? n3.borderwidth : n3.borderwidth - 1, c2 = -n3._offsetShift, f3 = l.crispRound(e3, n3.borderwidth);
          i2.attr({ width: n3._width + a2, height: n3._height + a2, transform: s(c2, c2), "stroke-width": f3 }).call(u.stroke, n3.bordercolor).call(u.fill, n3.bgcolor);
        }
        function y(t3, e3, r3, n3) {
          var i2 = e3._fullLayout;
          o.ensureSingleById(i2._topdefs, "clipPath", n3._clipId, function(t4) {
            t4.append("rect").attr({ x: 0, y: 0 });
          }).select("rect").attr({ width: n3._width, height: n3._height });
        }
        function m2(t3, e3, r3, i2) {
          var s2, u2 = e3.calcdata, c2 = t3.selectAll("g." + v.rangePlotClassName).data(r3._subplotsWith, o.identity);
          c2.enter().append("g").attr("class", function(t4) {
            return v.rangePlotClassName + " " + t4;
          }).call(l.setClipUrl, i2._clipId, e3), c2.order(), c2.exit().remove(), c2.each(function(t4, o2) {
            var l2 = n2.select(this), c3 = 0 === o2, p3 = h.getFromId(e3, t4, "y"), d3 = p3._name, v2 = i2[d3], g3 = { data: [], layout: { xaxis: { type: r3.type, domain: [0, 1], range: i2.range.slice(), calendar: r3.calendar }, width: i2._width, height: i2._height, margin: { t: 0, b: 0, l: 0, r: 0 } }, _context: e3._context };
            r3.rangebreaks && (g3.layout.xaxis.rangebreaks = r3.rangebreaks), g3.layout[d3] = { type: p3.type, domain: [0, 1], range: "match" !== v2.rangemode ? v2.range.slice() : p3.range.slice(), calendar: p3.calendar }, p3.rangebreaks && (g3.layout[d3].rangebreaks = p3.rangebreaks), a.supplyDefaults(g3);
            var y2 = g3._fullLayout.xaxis, m3 = g3._fullLayout[d3];
            y2.clearCalc(), y2.setScale(), m3.clearCalc(), m3.setScale();
            var x2 = { id: t4, plotgroup: l2, xaxis: y2, yaxis: m3, isRangePlot: true };
            c3 ? s2 = x2 : (x2.mainplot = "xy", x2.mainplotinfo = s2), f2.rangePlot(e3, x2, function(t5, e4) {
              for (var r4 = [], n3 = 0; n3 < t5.length; n3++) {
                var i3 = t5[n3], a2 = i3[0].trace;
                a2.xaxis + a2.yaxis === e4 && r4.push(i3);
              }
              return r4;
            }(u2, t4));
          });
        }
        function x(t3, e3, r3, n3, i2) {
          o.ensureSingle(t3, "rect", v.maskMinClassName, function(t4) {
            t4.attr({ x: 0, y: 0, "shape-rendering": "crispEdges" });
          }).attr("height", n3._height).call(u.fill, v.maskColor), o.ensureSingle(t3, "rect", v.maskMaxClassName, function(t4) {
            t4.attr({ y: 0, "shape-rendering": "crispEdges" });
          }).attr("height", n3._height).call(u.fill, v.maskColor), "match" !== i2.rangemode && (o.ensureSingle(t3, "rect", v.maskMinOppAxisClassName, function(t4) {
            t4.attr({ y: 0, "shape-rendering": "crispEdges" });
          }).attr("width", n3._width).call(u.fill, v.maskOppAxisColor), o.ensureSingle(t3, "rect", v.maskMaxOppAxisClassName, function(t4) {
            t4.attr({ y: 0, "shape-rendering": "crispEdges" });
          }).attr("width", n3._width).style("border-top", v.maskOppBorder).call(u.fill, v.maskOppAxisColor));
        }
        function b(t3, e3, r3, n3) {
          e3._context.staticPlot || o.ensureSingle(t3, "rect", v.slideBoxClassName, function(t4) {
            t4.attr({ y: 0, cursor: v.slideBoxCursor, "shape-rendering": "crispEdges" });
          }).attr({ height: n3._height, fill: v.slideBoxFill });
        }
        function _(t3, e3, r3, n3) {
          var i2 = o.ensureSingle(t3, "g", v.grabberMinClassName), a2 = o.ensureSingle(t3, "g", v.grabberMaxClassName), s2 = { x: 0, width: v.handleWidth, rx: v.handleRadius, fill: u.background, stroke: u.defaultLine, "stroke-width": v.handleStrokeWidth, "shape-rendering": "crispEdges" }, l2 = { y: Math.round(n3._height / 4), height: Math.round(n3._height / 2) };
          o.ensureSingle(i2, "rect", v.handleMinClassName, function(t4) {
            t4.attr(s2);
          }).attr(l2), o.ensureSingle(a2, "rect", v.handleMaxClassName, function(t4) {
            t4.attr(s2);
          }).attr(l2);
          var c2 = { width: v.grabAreaWidth, x: 0, y: 0, fill: v.grabAreaFill, cursor: e3._context.staticPlot ? void 0 : v.grabAreaCursor };
          o.ensureSingle(i2, "rect", v.grabAreaMinClassName, function(t4) {
            t4.attr(c2);
          }).attr("height", n3._height), o.ensureSingle(a2, "rect", v.grabAreaMaxClassName, function(t4) {
            t4.attr(c2);
          }).attr("height", n3._height);
        }
        t2.exports = function(t3) {
          for (var e3 = t3._fullLayout, r3 = e3._rangeSliderData, a2 = 0; a2 < r3.length; a2++) {
            var l2 = r3[a2][v.name];
            l2._clipId = l2._id + "-" + e3._uid;
          }
          var u2 = e3._infolayer.selectAll("g." + v.containerClassName).data(r3, function(t4) {
            return t4._name;
          });
          u2.exit().each(function(t4) {
            var r4 = t4[v.name];
            e3._topdefs.select("#" + r4._clipId).remove();
          }).remove(), 0 !== r3.length && (u2.enter().append("g").classed(v.containerClassName, true).attr("pointer-events", "all"), u2.each(function(r4) {
            var a3 = n2.select(this), l3 = r4[v.name], u3 = e3[h.id2name(r4.anchor)], f3 = l3[h.id2name(r4.anchor)];
            if (l3.range) {
              var w2, T = o.simpleMap(l3.range, r4.r2l), k = o.simpleMap(r4.range, r4.r2l);
              w2 = k[0] < k[1] ? [Math.min(T[0], k[0]), Math.max(T[1], k[1])] : [Math.max(T[0], k[0]), Math.min(T[1], k[1])], l3.range = l3._input.range = o.simpleMap(w2, r4.l2r);
            }
            r4.cleanRange("rangeslider.range");
            var A = e3._size, M = r4.domain;
            l3._width = A.w * (M[1] - M[0]);
            var S = Math.round(A.l + A.w * M[0]), E = Math.round(A.t + A.h * (1 - r4._counterDomainMin) + ("bottom" === r4.side ? r4._depth : 0) + l3._offsetShift + v.extraPad);
            a3.attr("transform", s(S, E)), l3._rl = o.simpleMap(l3.range, r4.r2l);
            var L = l3._rl[0], C = l3._rl[1], P = C - L;
            if (l3.p2d = function(t4) {
              return t4 / l3._width * P + L;
            }, l3.d2p = function(t4) {
              return (t4 - L) / P * l3._width;
            }, r4.rangebreaks) {
              var O = r4.locateBreaks(L, C);
              if (O.length) {
                var I, D, z = 0;
                for (I = 0; I < O.length; I++)
                  z += (D = O[I]).max - D.min;
                var R = l3._width / (C - L - z), F = [-R * L];
                for (I = 0; I < O.length; I++)
                  D = O[I], F.push(F[F.length - 1] - R * (D.max - D.min));
                for (l3.d2p = function(t4) {
                  for (var e4 = F[0], r5 = 0; r5 < O.length; r5++) {
                    var n3 = O[r5];
                    if (t4 >= n3.max)
                      e4 = F[r5 + 1];
                    else if (t4 < n3.min)
                      break;
                  }
                  return e4 + R * t4;
                }, I = 0; I < O.length; I++)
                  (D = O[I]).pmin = l3.d2p(D.min), D.pmax = l3.d2p(D.max);
                l3.p2d = function(t4) {
                  for (var e4 = F[0], r5 = 0; r5 < O.length; r5++) {
                    var n3 = O[r5];
                    if (t4 >= n3.pmax)
                      e4 = F[r5 + 1];
                    else if (t4 < n3.pmin)
                      break;
                  }
                  return (t4 - e4) / R;
                };
              }
            }
            if ("match" !== f3.rangemode) {
              var B = u3.r2l(f3.range[0]), N = u3.r2l(f3.range[1]) - B;
              l3.d2pOppAxis = function(t4) {
                return (t4 - B) / N * l3._height;
              };
            }
            a3.call(g2, t3, r4, l3).call(y, t3, r4, l3).call(m2, t3, r4, l3).call(x, t3, r4, l3, f3).call(b, t3, r4, l3).call(_, t3, r4, l3), function(t4, e4, r5, a4) {
              if (!e4._context.staticPlot) {
                var s2 = t4.select("rect." + v.slideBoxClassName).node(), l4 = t4.select("rect." + v.grabAreaMinClassName).node(), u4 = t4.select("rect." + v.grabAreaMaxClassName).node();
                t4.on("mousedown", c2), t4.on("touchstart", c2);
              }
              function c2() {
                var c3 = n2.event, f4 = c3.target, h2 = c3.clientX || c3.touches[0].clientX, v2 = h2 - t4.node().getBoundingClientRect().left, g3 = a4.d2p(r5._rl[0]), y2 = a4.d2p(r5._rl[1]), m3 = p2.coverSlip();
                function x2(t5) {
                  var c4, p3, x3, b3 = +(t5.clientX || t5.touches[0].clientX) - h2;
                  switch (f4) {
                    case s2:
                      if (x3 = "ew-resize", g3 + b3 > r5._length || y2 + b3 < 0)
                        return;
                      c4 = g3 + b3, p3 = y2 + b3;
                      break;
                    case l4:
                      if (x3 = "col-resize", g3 + b3 > r5._length)
                        return;
                      c4 = g3 + b3, p3 = y2;
                      break;
                    case u4:
                      if (x3 = "col-resize", y2 + b3 < 0)
                        return;
                      c4 = g3, p3 = y2 + b3;
                      break;
                    default:
                      x3 = "ew-resize", c4 = v2, p3 = v2 + b3;
                  }
                  if (p3 < c4) {
                    var _2 = p3;
                    p3 = c4, c4 = _2;
                  }
                  a4._pixelMin = c4, a4._pixelMax = p3, d2(n2.select(m3), x3), function(t6, e5, r6, n3) {
                    function a5(t7) {
                      return r6.l2r(o.constrain(t7, n3._rl[0], n3._rl[1]));
                    }
                    var s3 = a5(n3.p2d(n3._pixelMin)), l5 = a5(n3.p2d(n3._pixelMax));
                    window.requestAnimationFrame(function() {
                      i.call("_guiRelayout", e5, r6._name + ".range", [s3, l5]);
                    });
                  }(0, e4, r5, a4);
                }
                function b2() {
                  m3.removeEventListener("mousemove", x2), m3.removeEventListener("mouseup", b2), this.removeEventListener("touchmove", x2), this.removeEventListener("touchend", b2), o.removeElement(m3);
                }
                this.addEventListener("touchmove", x2), this.addEventListener("touchend", b2), m3.addEventListener("mousemove", x2), m3.addEventListener("mouseup", b2);
              }
            }(a3, t3, r4, l3), function(t4, e4, r5, n3, i2, a4) {
              var l4 = v.handleWidth / 2;
              function u4(t5) {
                return o.constrain(t5, 0, n3._width);
              }
              function c2(t5) {
                return o.constrain(t5, 0, n3._height);
              }
              function f4(t5) {
                return o.constrain(t5, -l4, n3._width + l4);
              }
              var h2 = u4(n3.d2p(r5._rl[0])), p3 = u4(n3.d2p(r5._rl[1]));
              if (t4.select("rect." + v.slideBoxClassName).attr("x", h2).attr("width", p3 - h2), t4.select("rect." + v.maskMinClassName).attr("width", h2), t4.select("rect." + v.maskMaxClassName).attr("x", p3).attr("width", n3._width - p3), "match" !== a4.rangemode) {
                var d3 = n3._height - c2(n3.d2pOppAxis(i2._rl[1])), g3 = n3._height - c2(n3.d2pOppAxis(i2._rl[0]));
                t4.select("rect." + v.maskMinOppAxisClassName).attr("x", h2).attr("height", d3).attr("width", p3 - h2), t4.select("rect." + v.maskMaxOppAxisClassName).attr("x", h2).attr("y", g3).attr("height", n3._height - g3).attr("width", p3 - h2), t4.select("rect." + v.slideBoxClassName).attr("y", d3).attr("height", g3 - d3);
              }
              var y2 = 0.5, m3 = Math.round(f4(h2 - l4)) - y2, x2 = Math.round(f4(p3 - l4)) + y2;
              t4.select("g." + v.grabberMinClassName).attr("transform", s(m3, y2)), t4.select("g." + v.grabberMaxClassName).attr("transform", s(x2, y2));
            }(a3, 0, r4, l3, u3, f3), "bottom" === r4.side && c.draw(t3, r4._id + "title", { propContainer: r4, propName: r4._name + ".title", placeholder: e3._dfltTitle.x, attributes: { x: r4._offset + r4._length / 2, y: E + l3._height + l3._offsetShift + 10 + 1.5 * r4.title.font.size, "text-anchor": "middle" } });
          }));
        };
      }, 549: function(t2, e2, r2) {
        var n2 = r2(41675), i = r2(63893), a = r2(73251), o = r2(18783).LINE_SPACING, s = a.name;
        function l(t3) {
          var e3 = t3 && t3[s];
          return e3 && e3.visible;
        }
        e2.isVisible = l, e2.makeData = function(t3) {
          var e3 = n2.list({ _fullLayout: t3 }, "x", true), r3 = t3.margin, i2 = [];
          if (!t3._has("gl2d"))
            for (var a2 = 0; a2 < e3.length; a2++) {
              var o2 = e3[a2];
              if (l(o2)) {
                i2.push(o2);
                var u = o2[s];
                u._id = s + o2._id, u._height = (t3.height - r3.b - r3.t) * u.thickness, u._offsetShift = Math.floor(u.borderwidth / 2);
              }
            }
          t3._rangeSliderData = i2;
        }, e2.autoMarginOpts = function(t3, e3) {
          var r3 = t3._fullLayout, n3 = e3[s], l2 = e3._id.charAt(0), u = 0, c = 0;
          return "bottom" === e3.side && (u = e3._depth, e3.title.text !== r3._dfltTitle[l2] && (c = 1.5 * e3.title.font.size + 10 + n3._offsetShift, c += (e3.title.text.match(i.BR_TAG_ALL) || []).length * e3.title.font.size * o)), { x: 0, y: e3._counterDomainMin, l: 0, r: 0, t: 0, b: n3._height + u + Math.max(r3.margin.b, c), pad: a.extraPad + 2 * n3._offsetShift };
        };
      }, 13137: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(75148), a = r2(47850), o = r2(549);
        t2.exports = { moduleType: "component", name: "rangeslider", schema: { subplots: { xaxis: { rangeslider: n2.extendFlat({}, i, { yaxis: a }) } } }, layoutAttributes: r2(75148), handleDefaults: r2(26377), calcAutorange: r2(88443), draw: r2(72413), isVisible: o.isVisible, makeData: o.makeData, autoMarginOpts: o.autoMarginOpts };
      }, 47850: function(t2) {
        t2.exports = { _isSubplotObj: true, rangemode: { valType: "enumerated", values: ["auto", "fixed", "match"], dflt: "match", editType: "calc" }, range: { valType: "info_array", items: [{ valType: "any", editType: "plot" }, { valType: "any", editType: "plot" }], editType: "plot" }, editType: "calc" };
      }, 8389: function(t2, e2, r2) {
        var n2 = r2(50215), i = r2(82196).line, a = r2(79952).P, o = r2(1426).extendFlat, s = r2(30962).overrideAll, l = r2(44467).templatedArray;
        r2(24695), t2.exports = s(l("selection", { type: { valType: "enumerated", values: ["rect", "path"] }, xref: o({}, n2.xref, {}), yref: o({}, n2.yref, {}), x0: { valType: "any" }, x1: { valType: "any" }, y0: { valType: "any" }, y1: { valType: "any" }, path: { valType: "string", editType: "arraydraw" }, opacity: { valType: "number", min: 0, max: 1, dflt: 0.7, editType: "arraydraw" }, line: { color: i.color, width: o({}, i.width, { min: 1, dflt: 1 }), dash: o({}, a, { dflt: "dot" }) } }), "arraydraw", "from-root");
      }, 34122: function(t2) {
        t2.exports = { BENDPX: 1.5, MINSELECT: 12, SELECTDELAY: 100, SELECTID: "-select" };
      }, 59402: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298), a = r2(85501), o = r2(8389), s = r2(30477);
        function l(t3, e3, r3) {
          function a2(r4, i2) {
            return n2.coerce(t3, e3, o, r4, i2);
          }
          var l2 = a2("path"), u = "path" !== a2("type", l2 ? "path" : "rect");
          u && delete e3.path, a2("opacity"), a2("line.color"), a2("line.width"), a2("line.dash");
          for (var c = ["x", "y"], f2 = 0; f2 < 2; f2++) {
            var h, p2, d2, v = c[f2], g2 = { _fullLayout: r3 }, y = i.coerceRef(t3, e3, g2, v);
            if ((h = i.getFromId(g2, y))._selectionIndices.push(e3._index), d2 = s.rangeToShapePosition(h), p2 = s.shapePositionToRange(h), u) {
              var m2 = v + "0", x = v + "1", b = t3[m2], _ = t3[x];
              t3[m2] = p2(t3[m2], true), t3[x] = p2(t3[x], true), i.coercePosition(e3, g2, a2, y, m2), i.coercePosition(e3, g2, a2, y, x);
              var w2 = e3[m2], T = e3[x];
              void 0 !== w2 && void 0 !== T && (e3[m2] = d2(w2), e3[x] = d2(T), t3[m2] = b, t3[x] = _);
            }
          }
          u && n2.noneOrAll(t3, e3, ["x0", "x1", "y0", "y1"]);
        }
        t2.exports = function(t3, e3) {
          a(t3, e3, { name: "selections", handleItemDefaults: l });
          for (var r3 = e3.selections, n3 = 0; n3 < r3.length; n3++) {
            var i2 = r3[n3];
            i2 && void 0 === i2.path && (void 0 !== i2.x0 && void 0 !== i2.x1 && void 0 !== i2.y0 && void 0 !== i2.y1 || (e3.selections[n3] = null));
          }
        };
      }, 32485: function(t2, e2, r2) {
        var n2 = r2(60165).readPaths, i = r2(42359), a = r2(51873).clearOutlineControllers, o = r2(7901), s = r2(91424), l = r2(44467).arrayEditor, u = r2(30477), c = u.getPathString;
        function f2(t3) {
          var e3 = t3._fullLayout;
          for (var r3 in a(t3), e3._selectionLayer.selectAll("path").remove(), e3._plots) {
            var n3 = e3._plots[r3].selectionLayer;
            n3 && n3.selectAll("path").remove();
          }
          for (var i2 = 0; i2 < e3.selections.length; i2++)
            p2(t3, i2);
        }
        function h(t3) {
          return t3._context.editSelection;
        }
        function p2(t3, e3) {
          t3._fullLayout._paperdiv.selectAll('.selectionlayer [data-index="' + e3 + '"]').remove();
          var r3 = u.makeSelectionsOptionsAndPlotinfo(t3, e3), a2 = r3.options, p3 = r3.plotinfo;
          a2._input && function(r4) {
            var u2 = c(t3, a2), g2 = { "data-index": e3, "fill-rule": "evenodd", d: u2 }, y = a2.opacity, m2 = "rgba(0,0,0,0)", x = a2.line.color || o.contrast(t3._fullLayout.plot_bgcolor), b = a2.line.width, _ = a2.line.dash;
            b || (b = 5, _ = "solid");
            var w2 = h(t3) && t3._fullLayout._activeSelectionIndex === e3;
            w2 && (m2 = t3._fullLayout.activeselection.fillcolor, y = t3._fullLayout.activeselection.opacity);
            for (var T = [], k = 1; k >= 0; k--) {
              var A = r4.append("path").attr(g2).style("opacity", k ? 0.1 : y).call(o.stroke, x).call(o.fill, m2).call(s.dashLine, k ? "solid" : _, k ? 4 + b : b);
              if (d2(A, t3, a2), w2) {
                var M = l(t3.layout, "selections", a2);
                A.style({ cursor: "move" });
                var S = { element: A.node(), plotinfo: p3, gd: t3, editHelpers: M, isActiveSelection: true }, E = n2(u2, t3);
                i(E, A, S);
              } else
                A.style("pointer-events", k ? "all" : "none");
              T[k] = A;
            }
            var L = T[0];
            T[1].node().addEventListener("click", function() {
              return function(t4, e4) {
                if (h(t4)) {
                  var r5 = +e4.node().getAttribute("data-index");
                  if (r5 >= 0) {
                    if (r5 === t4._fullLayout._activeSelectionIndex)
                      return void v(t4);
                    t4._fullLayout._activeSelectionIndex = r5, t4._fullLayout._deactivateSelection = v, f2(t4);
                  }
                }
              }(t3, L);
            });
          }(t3._fullLayout._selectionLayer);
        }
        function d2(t3, e3, r3) {
          var n3 = r3.xref + r3.yref;
          s.setClipUrl(t3, "clip" + e3._fullLayout._uid + n3, e3);
        }
        function v(t3) {
          h(t3) && t3._fullLayout._activeSelectionIndex >= 0 && (a(t3), delete t3._fullLayout._activeSelectionIndex, f2(t3));
        }
        t2.exports = { draw: f2, drawOne: p2, activateLastSelection: function(t3) {
          if (h(t3)) {
            var e3 = t3._fullLayout.selections.length - 1;
            t3._fullLayout._activeSelectionIndex = e3, t3._fullLayout._deactivateSelection = v, f2(t3);
          }
        } };
      }, 53777: function(t2, e2, r2) {
        var n2 = r2(79952).P, i = r2(1426).extendFlat;
        t2.exports = { newselection: { mode: { valType: "enumerated", values: ["immediate", "gradual"], dflt: "immediate", editType: "none" }, line: { color: { valType: "color", editType: "none" }, width: { valType: "number", min: 1, dflt: 1, editType: "none" }, dash: i({}, n2, { dflt: "dot", editType: "none" }), editType: "none" }, editType: "none" }, activeselection: { fillcolor: { valType: "color", dflt: "rgba(0,0,0,0)", editType: "none" }, opacity: { valType: "number", min: 0, max: 1, dflt: 0.5, editType: "none" }, editType: "none" } };
      }, 90849: function(t2) {
        t2.exports = function(t3, e2, r2) {
          r2("newselection.mode"), r2("newselection.line.width") && (r2("newselection.line.color"), r2("newselection.line.dash")), r2("activeselection.fillcolor"), r2("activeselection.opacity");
        };
      }, 35855: function(t2, e2, r2) {
        var n2 = r2(64505).selectMode, i = r2(51873).clearOutline, a = r2(60165), o = a.readPaths, s = a.writePaths, l = a.fixDatesForPaths;
        t2.exports = function(t3, e3) {
          if (t3.length) {
            var r3 = t3[0][0];
            if (r3) {
              var a2 = r3.getAttribute("d"), u = e3.gd, c = u._fullLayout.newselection, f2 = e3.plotinfo, h = f2.xaxis, p2 = f2.yaxis, d2 = e3.isActiveSelection, v = e3.dragmode, g2 = (u.layout || {}).selections || [];
              if (!n2(v) && void 0 !== d2) {
                var y = u._fullLayout._activeSelectionIndex;
                if (y < g2.length)
                  switch (u._fullLayout.selections[y].type) {
                    case "rect":
                      v = "select";
                      break;
                    case "path":
                      v = "lasso";
                  }
              }
              var m2, x = o(a2, u, f2, d2), b = { xref: h._id, yref: p2._id, opacity: c.opacity, line: { color: c.line.color, width: c.line.width, dash: c.line.dash } };
              1 === x.length && (m2 = x[0]), m2 && 5 === m2.length && "select" === v ? (b.type = "rect", b.x0 = m2[0][1], b.y0 = m2[0][2], b.x1 = m2[2][1], b.y1 = m2[2][2]) : (b.type = "path", h && p2 && l(x, h, p2), b.path = s(x), m2 = null), i(u);
              for (var _ = e3.editHelpers, w2 = (_ || {}).modifyItem, T = [], k = 0; k < g2.length; k++) {
                var A = u._fullLayout.selections[k];
                if (A) {
                  if (T[k] = A._input, void 0 !== d2 && k === u._fullLayout._activeSelectionIndex) {
                    var M = b;
                    switch (A.type) {
                      case "rect":
                        w2("x0", M.x0), w2("x1", M.x1), w2("y0", M.y0), w2("y1", M.y1);
                        break;
                      case "path":
                        w2("path", M.path);
                    }
                  }
                } else
                  T[k] = A;
              }
              return void 0 === d2 ? (T.push(b), T) : _ ? _.getUpdateObj() : {};
            }
          }
        };
      }, 75549: function(t2, e2, r2) {
        var n2 = r2(71828).strTranslate;
        function i(t3, e3) {
          switch (t3.type) {
            case "log":
              return t3.p2d(e3);
            case "date":
              return t3.p2r(e3, 0, t3.calendar);
            default:
              return t3.p2r(e3);
          }
        }
        t2.exports = { p2r: i, r2p: function(t3, e3) {
          switch (t3.type) {
            case "log":
              return t3.d2p(e3);
            case "date":
              return t3.r2p(e3, 0, t3.calendar);
            default:
              return t3.r2p(e3);
          }
        }, axValue: function(t3) {
          var e3 = "y" === t3._id.charAt(0) ? 1 : 0;
          return function(r3) {
            return i(t3, r3[e3]);
          };
        }, getTransform: function(t3) {
          return n2(t3.xaxis._offset, t3.yaxis._offset);
        } };
      }, 47322: function(t2, e2, r2) {
        var n2 = r2(32485), i = r2(3937);
        t2.exports = { moduleType: "component", name: "selections", layoutAttributes: r2(8389), supplyLayoutDefaults: r2(59402), supplyDrawNewSelectionDefaults: r2(90849), includeBasePlot: r2(76325)("selections"), draw: n2.draw, drawOne: n2.drawOne, reselect: i.reselect, prepSelect: i.prepSelect, clearOutline: i.clearOutline, clearSelectionsCache: i.clearSelectionsCache, selectOnClick: i.selectOnClick };
      }, 3937: function(t2, e2, r2) {
        var n2 = r2(52142), i = r2(38258), a = r2(73972), o = r2(91424).dashStyle, s = r2(7901), l = r2(30211), u = r2(23469).makeEventData, c = r2(64505), f2 = c.freeMode, h = c.rectMode, p2 = c.drawMode, d2 = c.openMode, v = c.selectMode, g2 = r2(30477), y = r2(21459), m2 = r2(42359), x = r2(51873).clearOutline, b = r2(60165), _ = b.handleEllipse, w2 = b.readPaths, T = r2(90551), k = r2(35855), A = r2(32485).activateLastSelection, M = r2(71828), S = M.sorterAsc, E = r2(61082), L = r2(79990), C = r2(41675).getFromId, P = r2(33306), O = r2(61549).redrawReglTraces, I = r2(34122), D = I.MINSELECT, z = E.filter, R = E.tester, F = r2(75549), B = F.p2r, N = F.axValue, j = F.getTransform;
        function U(t3) {
          return void 0 !== t3.subplot;
        }
        function V(t3, e3, r3, n3, i2, a2, o2) {
          var s2, l2, u2, c2, f3, h2, p3, v2, g3, y2 = e3._hoverdata, x2 = e3._fullLayout.clickmode.indexOf("event") > -1, b2 = [];
          if (function(t4) {
            return t4 && Array.isArray(t4) && true !== t4[0].hoverOnBox;
          }(y2)) {
            Z(t3, e3, a2);
            var _2 = function(t4, e4) {
              var r4, n4, i3 = t4[0], a3 = -1, o3 = [];
              for (n4 = 0; n4 < e4.length; n4++)
                if (r4 = e4[n4], i3.fullData._expandedIndex === r4.cd[0].trace._expandedIndex) {
                  if (true === i3.hoverOnBox)
                    break;
                  void 0 !== i3.pointNumber ? a3 = i3.pointNumber : void 0 !== i3.binNumber && (a3 = i3.binNumber, o3 = i3.pointNumbers);
                  break;
                }
              return { pointNumber: a3, pointNumbers: o3, searchInfo: r4 };
            }(y2, s2 = X(e3, r3, n3, i2));
            if (_2.pointNumbers.length > 0 ? function(t4, e4) {
              var r4, n4, i3, a3 = [];
              for (i3 = 0; i3 < t4.length; i3++)
                (r4 = t4[i3]).cd[0].trace.selectedpoints && r4.cd[0].trace.selectedpoints.length > 0 && a3.push(r4);
              if (1 === a3.length && a3[0] === e4.searchInfo && (n4 = e4.searchInfo.cd[0].trace).selectedpoints.length === e4.pointNumbers.length) {
                for (i3 = 0; i3 < e4.pointNumbers.length; i3++)
                  if (n4.selectedpoints.indexOf(e4.pointNumbers[i3]) < 0)
                    return false;
                return true;
              }
              return false;
            }(s2, _2) : function(t4) {
              var e4, r4, n4 = 0;
              for (r4 = 0; r4 < t4.length; r4++)
                if ((e4 = t4[r4].cd[0].trace).selectedpoints) {
                  if (e4.selectedpoints.length > 1)
                    return false;
                  if ((n4 += e4.selectedpoints.length) > 1)
                    return false;
                }
              return 1 === n4;
            }(s2) && (h2 = K(_2))) {
              for (o2 && o2.remove(), g3 = 0; g3 < s2.length; g3++)
                (l2 = s2[g3])._module.selectPoints(l2, false);
              $(e3, s2), Y(a2), x2 && ht(e3);
            } else {
              for (p3 = t3.shiftKey && (void 0 !== h2 ? h2 : K(_2)), u2 = function(t4, e4, r4) {
                return { pointNumber: t4, searchInfo: e4, subtract: !!r4 };
              }(_2.pointNumber, _2.searchInfo, p3), c2 = G(a2.selectionDefs.concat([u2])), g3 = 0; g3 < s2.length; g3++)
                if (f3 = tt(s2[g3]._module.selectPoints(s2[g3], c2), s2[g3]), b2.length)
                  for (var w3 = 0; w3 < f3.length; w3++)
                    b2.push(f3[w3]);
                else
                  b2 = f3;
              if ($(e3, s2, v2 = { points: b2 }), u2 && a2 && a2.selectionDefs.push(u2), o2) {
                var T2 = a2.mergedPolygons, k2 = d2(a2.dragmode);
                m2(et(T2, k2), o2, a2);
              }
              x2 && ft(e3, v2);
            }
          }
        }
        function H(t3) {
          return "pointNumber" in t3 && "searchInfo" in t3;
        }
        function q2(t3) {
          return { xmin: 0, xmax: 0, ymin: 0, ymax: 0, pts: [], contains: function(e3, r3, n3, i2) {
            var a2 = t3.searchInfo.cd[0].trace._expandedIndex;
            return i2.cd[0].trace._expandedIndex === a2 && n3 === t3.pointNumber;
          }, isRect: false, degenerate: false, subtract: !!t3.subtract };
        }
        function G(t3) {
          if (t3.length) {
            for (var e3 = [], r3 = H(t3[0]) ? 0 : t3[0][0][0], n3 = r3, i2 = H(t3[0]) ? 0 : t3[0][0][1], a2 = i2, o2 = 0; o2 < t3.length; o2++)
              if (H(t3[o2]))
                e3.push(q2(t3[o2]));
              else {
                var s2 = R(t3[o2]);
                s2.subtract = !!t3[o2].subtract, e3.push(s2), r3 = Math.min(r3, s2.xmin), n3 = Math.max(n3, s2.xmax), i2 = Math.min(i2, s2.ymin), a2 = Math.max(a2, s2.ymax);
              }
            return { xmin: r3, xmax: n3, ymin: i2, ymax: a2, pts: [], contains: function(t4, r4, n4, i3) {
              for (var a3 = false, o3 = 0; o3 < e3.length; o3++)
                e3[o3].contains(t4, r4, n4, i3) && (a3 = !e3[o3].subtract);
              return a3;
            }, isRect: false, degenerate: false };
          }
        }
        function Z(t3, e3, r3) {
          var n3 = e3._fullLayout, i2 = r3.plotinfo, a2 = r3.dragmode, o2 = n3._lastSelectedSubplot && n3._lastSelectedSubplot === i2.id, s2 = (t3.shiftKey || t3.altKey) && !(p2(a2) && d2(a2));
          o2 && s2 && i2.selection && i2.selection.selectionDefs && !r3.selectionDefs ? (r3.selectionDefs = i2.selection.selectionDefs, r3.mergedPolygons = i2.selection.mergedPolygons) : s2 && i2.selection || Y(r3), o2 || (x(e3), n3._lastSelectedSubplot = i2.id);
        }
        function Y(t3, e3) {
          var r3 = t3.dragmode, n3 = t3.plotinfo, i2 = t3.gd;
          (function(t4) {
            return t4._fullLayout._activeShapeIndex >= 0;
          })(i2) && i2._fullLayout._deactivateShape(i2), function(t4) {
            return t4._fullLayout._activeSelectionIndex >= 0;
          }(i2) && i2._fullLayout._deactivateSelection(i2);
          var o2 = i2._fullLayout._zoomlayer, s2 = p2(r3), l2 = v(r3);
          if (s2 || l2) {
            var u2, c2, f3 = o2.selectAll(".select-outline-" + n3.id);
            f3 && i2._fullLayout._outlining && (s2 && (u2 = T(f3, t3)), u2 && a.call("_guiRelayout", i2, { shapes: u2 }), l2 && !U(t3) && (c2 = k(f3, t3)), c2 && (i2._fullLayout._noEmitSelectedAtStart = true, a.call("_guiRelayout", i2, { selections: c2 }).then(function() {
              e3 && A(i2);
            })), i2._fullLayout._outlining = false);
          }
          n3.selection = {}, n3.selection.selectionDefs = t3.selectionDefs = [], n3.selection.mergedPolygons = t3.mergedPolygons = [];
        }
        function W(t3) {
          return t3._id;
        }
        function X(t3, e3, r3, n3) {
          if (!t3.calcdata)
            return [];
          var i2, a2, o2, s2 = [], l2 = e3.map(W), u2 = r3.map(W);
          for (o2 = 0; o2 < t3.calcdata.length; o2++)
            if (true === (a2 = (i2 = t3.calcdata[o2])[0].trace).visible && a2._module && a2._module.selectPoints)
              if (!U({ subplot: n3 }) || a2.subplot !== n3 && a2.geo !== n3)
                if ("splom" === a2.type) {
                  if (a2._xaxes[l2[0]] && a2._yaxes[u2[0]]) {
                    var c2 = J(a2._module, i2, e3[0], r3[0]);
                    c2.scene = t3._fullLayout._splomScenes[a2.uid], s2.push(c2);
                  }
                } else if ("sankey" === a2.type) {
                  var f3 = J(a2._module, i2, e3[0], r3[0]);
                  s2.push(f3);
                } else {
                  if (-1 === l2.indexOf(a2.xaxis))
                    continue;
                  if (-1 === u2.indexOf(a2.yaxis))
                    continue;
                  s2.push(J(a2._module, i2, C(t3, a2.xaxis), C(t3, a2.yaxis)));
                }
              else
                s2.push(J(a2._module, i2, e3[0], r3[0]));
          return s2;
        }
        function J(t3, e3, r3, n3) {
          return { _module: t3, cd: e3, xaxis: r3, yaxis: n3 };
        }
        function K(t3) {
          var e3 = t3.searchInfo.cd[0].trace, r3 = t3.pointNumber, n3 = t3.pointNumbers, i2 = n3.length > 0 ? n3[0] : r3;
          return !!e3.selectedpoints && e3.selectedpoints.indexOf(i2) > -1;
        }
        function $(t3, e3, r3) {
          var n3, i2;
          for (n3 = 0; n3 < e3.length; n3++) {
            var o2 = e3[n3].cd[0].trace._fullInput, s2 = t3._fullLayout._tracePreGUI[o2.uid] || {};
            void 0 === s2.selectedpoints && (s2.selectedpoints = o2._input.selectedpoints || null);
          }
          if (r3) {
            var l2 = r3.points || [];
            for (n3 = 0; n3 < e3.length; n3++)
              (i2 = e3[n3].cd[0].trace)._input.selectedpoints = i2._fullInput.selectedpoints = [], i2._fullInput !== i2 && (i2.selectedpoints = []);
            for (var u2 = 0; u2 < l2.length; u2++) {
              var c2 = l2[u2], f3 = c2.data, h2 = c2.fullData, p3 = c2.pointIndex, d3 = c2.pointIndices;
              d3 ? ([].push.apply(f3.selectedpoints, d3), i2._fullInput !== i2 && [].push.apply(h2.selectedpoints, d3)) : (f3.selectedpoints.push(p3), i2._fullInput !== i2 && h2.selectedpoints.push(p3));
            }
          } else
            for (n3 = 0; n3 < e3.length; n3++)
              delete (i2 = e3[n3].cd[0].trace).selectedpoints, delete i2._input.selectedpoints, i2._fullInput !== i2 && delete i2._fullInput.selectedpoints;
          !function(t4, e4) {
            for (var r4 = false, n4 = 0; n4 < e4.length; n4++) {
              var i3 = e4[n4], o3 = i3.cd;
              a.traceIs(o3[0].trace, "regl") && (r4 = true);
              var s3 = i3._module, l3 = s3.styleOnSelect || s3.style;
              l3 && (l3(t4, o3, o3[0].node3), o3[0].nodeRangePlot3 && l3(t4, o3, o3[0].nodeRangePlot3));
            }
            r4 && (P(t4), O(t4));
          }(t3, e3);
        }
        function Q(t3, e3, r3) {
          for (var i2 = (r3 ? n2.difference : n2.union)({ regions: t3 }, { regions: [e3] }).regions.reverse(), a2 = 0; a2 < i2.length; a2++) {
            var o2 = i2[a2];
            o2.subtract = st(o2, i2.slice(0, a2));
          }
          return i2;
        }
        function tt(t3, e3) {
          if (Array.isArray(t3))
            for (var r3 = e3.cd, n3 = e3.cd[0].trace, i2 = 0; i2 < t3.length; i2++)
              t3[i2] = u(t3[i2], n3, r3);
          return t3;
        }
        function et(t3, e3) {
          for (var r3 = [], n3 = 0; n3 < t3.length; n3++) {
            r3[n3] = [];
            for (var i2 = 0; i2 < t3[n3].length; i2++) {
              r3[n3][i2] = [], r3[n3][i2][0] = i2 ? "L" : "M";
              for (var a2 = 0; a2 < t3[n3][i2].length; a2++)
                r3[n3][i2].push(t3[n3][i2][a2]);
            }
            e3 || r3[n3].push(["Z", r3[n3][0][1], r3[n3][0][2]]);
          }
          return r3;
        }
        function rt(t3, e3) {
          for (var r3, n3, i2 = [], a2 = [], o2 = 0; o2 < e3.length; o2++) {
            var s2 = e3[o2];
            n3 = s2._module.selectPoints(s2, t3), a2.push(n3), r3 = tt(n3, s2), i2 = i2.concat(r3);
          }
          return i2;
        }
        function nt(t3, e3, r3, n3, i2) {
          var a2, o2, s2, l2 = !!n3;
          i2 && (a2 = i2.plotinfo, o2 = i2.xaxes[0]._id, s2 = i2.yaxes[0]._id);
          var u2 = [], c2 = [], f3 = ot(t3), h2 = t3._fullLayout;
          if (a2) {
            var d3 = h2._zoomlayer, g3 = h2.dragmode, y2 = p2(g3), m3 = v(g3);
            if (y2 || m3) {
              var x2 = C(t3, o2, "x"), b2 = C(t3, s2, "y");
              if (x2 && b2) {
                var _2 = d3.selectAll(".select-outline-" + a2.id);
                if (_2 && t3._fullLayout._outlining && _2.length) {
                  for (var T2 = _2[0][0].getAttribute("d"), k2 = w2(T2, t3, a2), A2 = [], M2 = 0; M2 < k2.length; M2++) {
                    for (var S2 = k2[M2], E2 = [], L2 = 0; L2 < S2.length; L2++)
                      E2.push([lt(x2, S2[L2][1]), lt(b2, S2[L2][2])]);
                    E2.xref = o2, E2.yref = s2, E2.subtract = st(E2, A2), A2.push(E2);
                  }
                  f3 = f3.concat(A2);
                }
              }
            }
          }
          var P2 = o2 && s2 ? [o2 + s2] : h2._subplots.cartesian;
          !function(t4) {
            var e4 = t4.calcdata;
            if (e4)
              for (var r4 = 0; r4 < e4.length; r4++) {
                var n4 = e4[r4][0].trace, i3 = t4._fullLayout._splomScenes;
                if (i3) {
                  var a3 = i3[n4.uid];
                  a3 && (a3.selectBatch = []);
                }
              }
          }(t3);
          for (var O2 = {}, I2 = 0; I2 < P2.length; I2++) {
            var D2 = P2[I2], z2 = D2.indexOf("y"), R2 = D2.slice(0, z2), F2 = D2.slice(z2), B2 = o2 && s2 ? r3 : void 0;
            if (B2 = at(f3, R2, F2, B2)) {
              var N2 = n3;
              if (!l2) {
                var j2 = C(t3, R2, "x"), U2 = C(t3, F2, "y");
                N2 = X(t3, [j2], [U2], D2);
                for (var V2 = 0; V2 < N2.length; V2++) {
                  var H2 = N2[V2], q3 = H2.cd[0], G2 = q3.trace;
                  if ("scattergl" === H2._module.name && !q3.t.xpx) {
                    var Z2 = G2.x, Y2 = G2.y, W2 = G2._length;
                    q3.t.xpx = [], q3.t.ypx = [];
                    for (var J2 = 0; J2 < W2; J2++)
                      q3.t.xpx[J2] = j2.c2p(Z2[J2]), q3.t.ypx[J2] = U2.c2p(Y2[J2]);
                  }
                  "splom" === H2._module.name && (O2[G2.uid] || (O2[G2.uid] = true));
                }
              }
              var K2 = rt(B2, N2);
              u2 = u2.concat(K2), c2 = c2.concat(N2);
            }
          }
          var Q2 = { points: u2 };
          $(t3, c2, Q2);
          var tt2 = h2.clickmode.indexOf("event") > -1 && e3;
          if (!a2 && e3) {
            var et2 = ot(t3, true);
            if (et2.length) {
              var nt2 = et2[0].xref, pt = et2[0].yref;
              if (nt2 && pt) {
                var dt = ut(et2);
                ct([C(t3, nt2, "x"), C(t3, pt, "y")])(Q2, dt);
              }
            }
            t3._fullLayout._noEmitSelectedAtStart ? t3._fullLayout._noEmitSelectedAtStart = false : tt2 && ft(t3, Q2), h2._reselect = false;
          }
          if (!a2 && h2._deselect) {
            var vt = h2._deselect;
            (function(t4, e4, r4) {
              for (var n4 = 0; n4 < r4.length; n4++) {
                var i3 = r4[n4];
                if (i3.xaxis && i3.xaxis._id === t4 && i3.yaxis && i3.yaxis._id === e4)
                  return true;
              }
              return false;
            })(o2 = vt.xref, s2 = vt.yref, c2) || it(t3, o2, s2, n3), tt2 && (Q2.points.length ? ft(t3, Q2) : ht(t3)), h2._deselect = false;
          }
          return { eventData: Q2, selectionTesters: r3 };
        }
        function it(t3, e3, r3, n3) {
          n3 = X(t3, [C(t3, e3, "x")], [C(t3, r3, "y")], e3 + r3);
          for (var i2 = 0; i2 < n3.length; i2++) {
            var a2 = n3[i2];
            a2._module.selectPoints(a2, false);
          }
          $(t3, n3);
        }
        function at(t3, e3, r3, n3) {
          for (var i2, a2 = 0; a2 < t3.length; a2++) {
            var o2 = t3[a2];
            e3 === o2.xref && r3 === o2.yref && (i2 ? n3 = G(i2 = Q(i2, o2, !!o2.subtract)) : (i2 = [o2], n3 = R(o2)));
          }
          return n3;
        }
        function ot(t3, e3) {
          for (var r3 = [], n3 = t3._fullLayout, i2 = n3.selections, a2 = i2.length, o2 = 0; o2 < a2; o2++)
            if (!e3 || o2 === n3._activeSelectionIndex) {
              var s2 = i2[o2];
              if (s2) {
                var l2, u2, c2, f3, h2, p3 = s2.xref, d3 = s2.yref, v2 = C(t3, p3, "x"), m3 = C(t3, d3, "y");
                if ("rect" === s2.type) {
                  h2 = [];
                  var x2 = lt(v2, s2.x0), b2 = lt(v2, s2.x1), _2 = lt(m3, s2.y0), w3 = lt(m3, s2.y1);
                  h2 = [[x2, _2], [x2, w3], [b2, w3], [b2, _2]], l2 = Math.min(x2, b2), u2 = Math.max(x2, b2), c2 = Math.min(_2, w3), f3 = Math.max(_2, w3), h2.xmin = l2, h2.xmax = u2, h2.ymin = c2, h2.ymax = f3, h2.xref = p3, h2.yref = d3, h2.subtract = false, h2.isRect = true, r3.push(h2);
                } else if ("path" === s2.type)
                  for (var T2 = s2.path.split("Z"), k2 = [], A2 = 0; A2 < T2.length; A2++) {
                    var M2 = T2[A2];
                    if (M2) {
                      M2 += "Z";
                      var S2 = g2.extractPathCoords(M2, y.paramIsX, "raw"), E2 = g2.extractPathCoords(M2, y.paramIsY, "raw");
                      l2 = 1 / 0, u2 = -1 / 0, c2 = 1 / 0, f3 = -1 / 0, h2 = [];
                      for (var L2 = 0; L2 < S2.length; L2++) {
                        var P2 = lt(v2, S2[L2]), O2 = lt(m3, E2[L2]);
                        h2.push([P2, O2]), l2 = Math.min(P2, l2), u2 = Math.max(P2, u2), c2 = Math.min(O2, c2), f3 = Math.max(O2, f3);
                      }
                      h2.xmin = l2, h2.xmax = u2, h2.ymin = c2, h2.ymax = f3, h2.xref = p3, h2.yref = d3, h2.subtract = st(h2, k2), k2.push(h2), r3.push(h2);
                    }
                  }
              }
            }
          return r3;
        }
        function st(t3, e3) {
          for (var r3 = false, n3 = 0; n3 < e3.length; n3++)
            for (var a2 = e3[n3], o2 = 0; o2 < t3.length; o2++)
              if (i(t3[o2], a2)) {
                r3 = !r3;
                break;
              }
          return r3;
        }
        function lt(t3, e3) {
          return "date" === t3.type && (e3 = e3.replace("_", " ")), "log" === t3.type ? t3.c2p(e3) : t3.r2p(e3, null, t3.calendar);
        }
        function ut(t3) {
          for (var e3 = t3.length, r3 = [], n3 = 0; n3 < e3; n3++) {
            var i2 = t3[n3];
            r3 = (r3 = r3.concat(i2)).concat([i2[0]]);
          }
          return (a2 = r3).isRect = 5 === a2.length && a2[0][0] === a2[4][0] && a2[0][1] === a2[4][1] && a2[0][0] === a2[1][0] && a2[2][0] === a2[3][0] && a2[0][1] === a2[3][1] && a2[1][1] === a2[2][1] || a2[0][1] === a2[1][1] && a2[2][1] === a2[3][1] && a2[0][0] === a2[3][0] && a2[1][0] === a2[2][0], a2.isRect && (a2.xmin = Math.min(a2[0][0], a2[2][0]), a2.xmax = Math.max(a2[0][0], a2[2][0]), a2.ymin = Math.min(a2[0][1], a2[2][1]), a2.ymax = Math.max(a2[0][1], a2[2][1])), a2;
          var a2;
        }
        function ct(t3) {
          return function(e3, r3) {
            for (var n3, i2, a2 = 0; a2 < t3.length; a2++) {
              var o2 = t3[a2], s2 = o2._id, l2 = s2.charAt(0);
              if (r3.isRect) {
                n3 || (n3 = {});
                var u2 = r3[l2 + "min"], c2 = r3[l2 + "max"];
                void 0 !== u2 && void 0 !== c2 && (n3[s2] = [B(o2, u2), B(o2, c2)].sort(S));
              } else
                i2 || (i2 = {}), i2[s2] = r3.map(N(o2));
            }
            n3 && (e3.range = n3), i2 && (e3.lassoPoints = i2);
          };
        }
        function ft(t3, e3) {
          e3 && (e3.selections = (t3.layout || {}).selections || []), t3.emit("plotly_selected", e3);
        }
        function ht(t3) {
          t3.emit("plotly_deselect", null);
        }
        t2.exports = { reselect: nt, prepSelect: function(t3, e3, r3, n3, i2) {
          var u2 = !U(n3), c2 = f2(i2), g3 = h(i2), y2 = d2(i2), x2 = p2(i2), b2 = v(i2), w3 = "drawcircle" === i2, T2 = "drawline" === i2 || w3, k2 = n3.gd, A2 = k2._fullLayout, S2 = b2 && "immediate" === A2.newselection.mode && u2, E2 = A2._zoomlayer, C2 = n3.element.getBoundingClientRect(), P2 = n3.plotinfo, O2 = j(P2), F2 = e3 - C2.left, B2 = r3 - C2.top;
          A2._calcInverseTransform(k2);
          var N2 = M.apply3DTransform(A2._invTransform)(F2, B2);
          F2 = N2[0], B2 = N2[1];
          var H2, q3, W2, J2, K2, tt2, at2, ot2 = A2._invScaleX, st2 = A2._invScaleY, lt2 = F2, pt = B2, dt = "M" + F2 + "," + B2, vt = n3.xaxes[0], gt = n3.yaxes[0], yt = vt._length, mt = gt._length, xt = t3.altKey && !(p2(i2) && y2);
          Z(t3, k2, n3), c2 && (H2 = z([[F2, B2]], I.BENDPX));
          var bt = E2.selectAll("path.select-outline-" + P2.id).data([1]), _t = x2 ? A2.newshape : A2.newselection, wt = x2 && !y2 ? _t.fillcolor : "rgba(0,0,0,0)", Tt = _t.line.color || (u2 ? s.contrast(k2._fullLayout.plot_bgcolor) : "#7f7f7f");
          bt.enter().append("path").attr("class", "select-outline select-outline-" + P2.id).style({ opacity: x2 ? _t.opacity / 2 : 1, "stroke-dasharray": o(_t.line.dash, _t.line.width), "stroke-width": _t.line.width + "px", "shape-rendering": "crispEdges" }).call(s.stroke, Tt).call(s.fill, wt).attr("fill-rule", "evenodd").classed("cursor-move", !!x2).attr("transform", O2).attr("d", dt + "Z");
          var kt = E2.append("path").attr("class", "zoombox-corners").style({ fill: s.background, stroke: s.defaultLine, "stroke-width": 1 }).attr("transform", O2).attr("d", "M0,0Z"), At = A2._uid + I.SELECTID, Mt = [], St = X(k2, n3.xaxes, n3.yaxes, n3.subplot);
          S2 && !t3.shiftKey && (n3._clearSubplotSelections = function() {
            if (u2) {
              var t4 = vt._id, e4 = gt._id;
              it(k2, t4, e4, St);
              for (var r4 = (k2.layout || {}).selections || [], n4 = [], i3 = false, o2 = 0; o2 < r4.length; o2++) {
                var s2 = A2.selections[o2];
                s2.xref !== t4 || s2.yref !== e4 ? n4.push(r4[o2]) : i3 = true;
              }
              i3 && (k2._fullLayout._noEmitSelectedAtStart = true, a.call("_guiRelayout", k2, { selections: n4 }));
            }
          });
          var Et = function(t4) {
            return t4.plotinfo.fillRangeItems || ct(t4.xaxes.concat(t4.yaxes));
          }(n3);
          n3.moveFn = function(t4, e4) {
            n3._clearSubplotSelections && (n3._clearSubplotSelections(), n3._clearSubplotSelections = void 0), lt2 = Math.max(0, Math.min(yt, ot2 * t4 + F2)), pt = Math.max(0, Math.min(mt, st2 * e4 + B2));
            var r4 = Math.abs(lt2 - F2), i3 = Math.abs(pt - B2);
            if (g3) {
              var a2, o2, s2;
              if (b2) {
                var l2 = A2.selectdirection;
                switch (a2 = "any" === l2 ? i3 < Math.min(0.6 * r4, D) ? "h" : r4 < Math.min(0.6 * i3, D) ? "v" : "d" : l2) {
                  case "h":
                    o2 = w3 ? mt / 2 : 0, s2 = mt;
                    break;
                  case "v":
                    o2 = w3 ? yt / 2 : 0, s2 = yt;
                }
              }
              if (x2)
                switch (A2.newshape.drawdirection) {
                  case "vertical":
                    a2 = "h", o2 = w3 ? mt / 2 : 0, s2 = mt;
                    break;
                  case "horizontal":
                    a2 = "v", o2 = w3 ? yt / 2 : 0, s2 = yt;
                    break;
                  case "ortho":
                    r4 < i3 ? (a2 = "h", o2 = B2, s2 = pt) : (a2 = "v", o2 = F2, s2 = lt2);
                    break;
                  default:
                    a2 = "d";
                }
              "h" === a2 ? ((J2 = T2 ? _(w3, [lt2, o2], [lt2, s2]) : [[F2, o2], [F2, s2], [lt2, s2], [lt2, o2]]).xmin = T2 ? lt2 : Math.min(F2, lt2), J2.xmax = T2 ? lt2 : Math.max(F2, lt2), J2.ymin = Math.min(o2, s2), J2.ymax = Math.max(o2, s2), kt.attr("d", "M" + J2.xmin + "," + (B2 - D) + "h-4v" + 2 * D + "h4ZM" + (J2.xmax - 1) + "," + (B2 - D) + "h4v" + 2 * D + "h-4Z")) : "v" === a2 ? ((J2 = T2 ? _(w3, [o2, pt], [s2, pt]) : [[o2, B2], [o2, pt], [s2, pt], [s2, B2]]).xmin = Math.min(o2, s2), J2.xmax = Math.max(o2, s2), J2.ymin = T2 ? pt : Math.min(B2, pt), J2.ymax = T2 ? pt : Math.max(B2, pt), kt.attr("d", "M" + (F2 - D) + "," + J2.ymin + "v-4h" + 2 * D + "v4ZM" + (F2 - D) + "," + (J2.ymax - 1) + "v4h" + 2 * D + "v-4Z")) : "d" === a2 && ((J2 = T2 ? _(w3, [F2, B2], [lt2, pt]) : [[F2, B2], [F2, pt], [lt2, pt], [lt2, B2]]).xmin = Math.min(F2, lt2), J2.xmax = Math.max(F2, lt2), J2.ymin = Math.min(B2, pt), J2.ymax = Math.max(B2, pt), kt.attr("d", "M0,0Z"));
            } else
              c2 && (H2.addPt([lt2, pt]), J2 = H2.filtered);
            if (n3.selectionDefs && n3.selectionDefs.length ? (W2 = Q(n3.mergedPolygons, J2, xt), J2.subtract = xt, q3 = G(n3.selectionDefs.concat([J2]))) : (W2 = [J2], q3 = R(J2)), m2(et(W2, y2), bt, n3), b2) {
              var u3, f3 = nt(k2, false), h2 = f3.eventData ? f3.eventData.points.slice() : [];
              f3 = nt(k2, false, q3, St, n3), q3 = f3.selectionTesters, at2 = f3.eventData, u3 = H2 ? H2.filtered : ut(W2), L.throttle(At, I.SELECTDELAY, function() {
                for (var t5 = (Mt = rt(q3, St)).slice(), e5 = 0; e5 < h2.length; e5++) {
                  for (var r5 = h2[e5], n4 = false, i4 = 0; i4 < t5.length; i4++)
                    if (t5[i4].curveNumber === r5.curveNumber && t5[i4].pointNumber === r5.pointNumber) {
                      n4 = true;
                      break;
                    }
                  n4 || t5.push(r5);
                }
                t5.length && (at2 || (at2 = {}), at2.points = t5), Et(at2, u3), function(t6, e6) {
                  t6.emit("plotly_selecting", e6);
                }(k2, at2);
              });
            }
          }, n3.clickFn = function(t4, e4) {
            if (kt.remove(), k2._fullLayout._activeShapeIndex >= 0)
              k2._fullLayout._deactivateShape(k2);
            else if (!x2) {
              var r4 = A2.clickmode;
              L.done(At).then(function() {
                if (L.clear(At), 2 === t4) {
                  for (bt.remove(), K2 = 0; K2 < St.length; K2++)
                    (tt2 = St[K2])._module.selectPoints(tt2, false);
                  if ($(k2, St), Y(n3), ht(k2), St.length) {
                    var i3 = St[0].xaxis, o2 = St[0].yaxis;
                    if (i3 && o2) {
                      for (var s2 = [], u3 = k2._fullLayout.selections, c3 = 0; c3 < u3.length; c3++) {
                        var f3 = u3[c3];
                        f3 && (f3.xref === i3._id && f3.yref === o2._id || s2.push(f3));
                      }
                      s2.length < u3.length && (k2._fullLayout._noEmitSelectedAtStart = true, a.call("_guiRelayout", k2, { selections: s2 }));
                    }
                  }
                } else
                  r4.indexOf("select") > -1 && V(e4, k2, n3.xaxes, n3.yaxes, n3.subplot, n3, bt), "event" === r4 && ft(k2, void 0);
                l.click(k2, e4);
              }).catch(M.error);
            }
          }, n3.doneFn = function() {
            kt.remove(), L.done(At).then(function() {
              L.clear(At), !S2 && J2 && n3.selectionDefs && (J2.subtract = xt, n3.selectionDefs.push(J2), n3.mergedPolygons.length = 0, [].push.apply(n3.mergedPolygons, W2)), (S2 || x2) && Y(n3, S2), n3.doneFnCompleted && n3.doneFnCompleted(Mt), b2 && ft(k2, at2);
            }).catch(M.error);
          };
        }, clearOutline: x, clearSelectionsCache: Y, selectOnClick: V };
      }, 89827: function(t2, e2, r2) {
        var n2 = r2(50215), i = r2(41940), a = r2(82196).line, o = r2(79952).P, s = r2(1426).extendFlat, l = r2(44467).templatedArray;
        r2(24695), t2.exports = l("shape", { visible: { valType: "boolean", dflt: true, editType: "calc+arraydraw" }, type: { valType: "enumerated", values: ["circle", "rect", "path", "line"], editType: "calc+arraydraw" }, layer: { valType: "enumerated", values: ["below", "above"], dflt: "above", editType: "arraydraw" }, xref: s({}, n2.xref, {}), xsizemode: { valType: "enumerated", values: ["scaled", "pixel"], dflt: "scaled", editType: "calc+arraydraw" }, xanchor: { valType: "any", editType: "calc+arraydraw" }, x0: { valType: "any", editType: "calc+arraydraw" }, x1: { valType: "any", editType: "calc+arraydraw" }, yref: s({}, n2.yref, {}), ysizemode: { valType: "enumerated", values: ["scaled", "pixel"], dflt: "scaled", editType: "calc+arraydraw" }, yanchor: { valType: "any", editType: "calc+arraydraw" }, y0: { valType: "any", editType: "calc+arraydraw" }, y1: { valType: "any", editType: "calc+arraydraw" }, path: { valType: "string", editType: "calc+arraydraw" }, opacity: { valType: "number", min: 0, max: 1, dflt: 1, editType: "arraydraw" }, line: { color: s({}, a.color, { editType: "arraydraw" }), width: s({}, a.width, { editType: "calc+arraydraw" }), dash: s({}, o, { editType: "arraydraw" }), editType: "calc+arraydraw" }, fillcolor: { valType: "color", dflt: "rgba(0,0,0,0)", editType: "arraydraw" }, fillrule: { valType: "enumerated", values: ["evenodd", "nonzero"], dflt: "evenodd", editType: "arraydraw" }, editable: { valType: "boolean", dflt: false, editType: "calc+arraydraw" }, label: { text: { valType: "string", dflt: "", editType: "arraydraw" }, font: i({ editType: "calc+arraydraw", colorEditType: "arraydraw" }), textposition: { valType: "enumerated", values: ["top left", "top center", "top right", "middle left", "middle center", "middle right", "bottom left", "bottom center", "bottom right", "start", "middle", "end"], editType: "arraydraw" }, textangle: { valType: "angle", dflt: "auto", editType: "calc+arraydraw" }, xanchor: { valType: "enumerated", values: ["auto", "left", "center", "right"], dflt: "auto", editType: "calc+arraydraw" }, yanchor: { valType: "enumerated", values: ["top", "middle", "bottom"], editType: "calc+arraydraw" }, padding: { valType: "number", dflt: 3, min: 0, editType: "arraydraw" }, editType: "arraydraw" }, editType: "arraydraw" });
      }, 5627: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298), a = r2(21459), o = r2(30477);
        function s(t3) {
          return u(t3.line.width, t3.xsizemode, t3.x0, t3.x1, t3.path, false);
        }
        function l(t3) {
          return u(t3.line.width, t3.ysizemode, t3.y0, t3.y1, t3.path, true);
        }
        function u(t3, e3, r3, i2, s2, l2) {
          var u2 = t3 / 2, c2 = l2;
          if ("pixel" === e3) {
            var f2 = s2 ? o.extractPathCoords(s2, l2 ? a.paramIsY : a.paramIsX) : [r3, i2], h = n2.aggNums(Math.max, null, f2), p2 = n2.aggNums(Math.min, null, f2), d2 = p2 < 0 ? Math.abs(p2) + u2 : u2, v = h > 0 ? h + u2 : u2;
            return { ppad: u2, ppadplus: c2 ? d2 : v, ppadminus: c2 ? v : d2 };
          }
          return { ppad: u2 };
        }
        function c(t3, e3, r3, n3, i2) {
          var s2 = "category" === t3.type || "multicategory" === t3.type ? t3.r2c : t3.d2c;
          if (void 0 !== e3)
            return [s2(e3), s2(r3)];
          if (n3) {
            var l2, u2, c2, f2, h = 1 / 0, p2 = -1 / 0, d2 = n3.match(a.segmentRE);
            for ("date" === t3.type && (s2 = o.decodeDate(s2)), l2 = 0; l2 < d2.length; l2++)
              void 0 !== (u2 = i2[d2[l2].charAt(0)].drawn) && (!(c2 = d2[l2].substr(1).match(a.paramRE)) || c2.length < u2 || ((f2 = s2(c2[u2])) < h && (h = f2), f2 > p2 && (p2 = f2)));
            return p2 >= h ? [h, p2] : void 0;
          }
        }
        t2.exports = function(t3) {
          var e3 = t3._fullLayout, r3 = n2.filterVisible(e3.shapes);
          if (r3.length && t3._fullData.length)
            for (var o2 = 0; o2 < r3.length; o2++) {
              var u2, f2, h = r3[o2];
              h._extremes = {};
              var p2 = i.getRefType(h.xref), d2 = i.getRefType(h.yref);
              if ("paper" !== h.xref && "domain" !== p2) {
                var v = "pixel" === h.xsizemode ? h.xanchor : h.x0, g2 = "pixel" === h.xsizemode ? h.xanchor : h.x1;
                (f2 = c(u2 = i.getFromId(t3, h.xref), v, g2, h.path, a.paramIsX)) && (h._extremes[u2._id] = i.findExtremes(u2, f2, s(h)));
              }
              if ("paper" !== h.yref && "domain" !== d2) {
                var y = "pixel" === h.ysizemode ? h.yanchor : h.y0, m2 = "pixel" === h.ysizemode ? h.yanchor : h.y1;
                (f2 = c(u2 = i.getFromId(t3, h.yref), y, m2, h.path, a.paramIsY)) && (h._extremes[u2._id] = i.findExtremes(u2, f2, l(h)));
              }
            }
        };
      }, 21459: function(t2) {
        t2.exports = { segmentRE: /[MLHVQCTSZ][^MLHVQCTSZ]*/g, paramRE: /[^\s,]+/g, paramIsX: { M: { 0: true, drawn: 0 }, L: { 0: true, drawn: 0 }, H: { 0: true, drawn: 0 }, V: {}, Q: { 0: true, 2: true, drawn: 2 }, C: { 0: true, 2: true, 4: true, drawn: 4 }, T: { 0: true, drawn: 0 }, S: { 0: true, 2: true, drawn: 2 }, Z: {} }, paramIsY: { M: { 1: true, drawn: 1 }, L: { 1: true, drawn: 1 }, H: {}, V: { 0: true, drawn: 0 }, Q: { 1: true, 3: true, drawn: 3 }, C: { 1: true, 3: true, 5: true, drawn: 5 }, T: { 1: true, drawn: 1 }, S: { 1: true, 3: true, drawn: 5 }, Z: {} }, numParams: { M: 2, L: 2, H: 1, V: 1, Q: 4, C: 6, T: 2, S: 4, Z: 0 } };
      }, 84726: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298), a = r2(85501), o = r2(89827), s = r2(30477);
        function l(t3, e3, r3) {
          function a2(r4, i2) {
            return n2.coerce(t3, e3, o, r4, i2);
          }
          if (a2("visible")) {
            var l2 = a2("path"), u = a2("type", l2 ? "path" : "rect"), c = "path" !== u;
            c && delete e3.path, a2("editable"), a2("layer"), a2("opacity"), a2("fillcolor"), a2("fillrule"), a2("line.width") && (a2("line.color"), a2("line.dash"));
            for (var f2 = a2("xsizemode"), h = a2("ysizemode"), p2 = ["x", "y"], d2 = 0; d2 < 2; d2++) {
              var v, g2, y, m2 = p2[d2], x = m2 + "anchor", b = "x" === m2 ? f2 : h, _ = { _fullLayout: r3 }, w2 = i.coerceRef(t3, e3, _, m2, void 0, "paper");
              if ("range" === i.getRefType(w2) ? ((v = i.getFromId(_, w2))._shapeIndices.push(e3._index), y = s.rangeToShapePosition(v), g2 = s.shapePositionToRange(v)) : g2 = y = n2.identity, c) {
                var T = m2 + "0", k = m2 + "1", A = t3[T], M = t3[k];
                t3[T] = g2(t3[T], true), t3[k] = g2(t3[k], true), "pixel" === b ? (a2(T, 0), a2(k, 10)) : (i.coercePosition(e3, _, a2, w2, T, 0.25), i.coercePosition(e3, _, a2, w2, k, 0.75)), e3[T] = y(e3[T]), e3[k] = y(e3[k]), t3[T] = A, t3[k] = M;
              }
              if ("pixel" === b) {
                var S = t3[x];
                t3[x] = g2(t3[x], true), i.coercePosition(e3, _, a2, w2, x, 0.25), e3[x] = y(e3[x]), t3[x] = S;
              }
            }
            c && n2.noneOrAll(t3, e3, ["x0", "x1", "y0", "y1"]);
            var E = "line" === u;
            if (a2("label.text")) {
              a2("label.textangle");
              var L = a2("label.textposition", E ? "middle" : "middle center");
              a2("label.xanchor"), a2("label.yanchor", function(t4, e4) {
                return t4 ? "bottom" : -1 !== e4.indexOf("top") ? "top" : -1 !== e4.indexOf("bottom") ? "bottom" : "middle";
              }(E, L)), a2("label.padding"), n2.coerceFont(a2, "label.font", r3.font);
            }
          }
        }
        t2.exports = function(t3, e3) {
          a(t3, e3, { name: "shapes", handleItemDefaults: l });
        };
      }, 42359: function(t2, e2, r2) {
        var n2 = r2(71828).strTranslate, i = r2(28569), a = r2(64505), o = a.drawMode, s = a.selectMode, l = r2(73972), u = r2(7901), c = r2(89995), f2 = c.i000, h = c.i090, p2 = c.i180, d2 = c.i270, v = r2(51873).clearOutlineControllers, g2 = r2(60165), y = g2.pointsOnRectangle, m2 = g2.pointsOnEllipse, x = g2.writePaths, b = r2(90551), _ = r2(35855);
        function w2(t3, e3) {
          var r3, n3, i2, a2 = t3[e3][1], o2 = t3[e3][2], s2 = t3.length;
          return n3 = t3[r3 = (e3 + 1) % s2][1], i2 = t3[r3][2], n3 === a2 && i2 === o2 && (n3 = t3[r3 = (e3 + 2) % s2][1], i2 = t3[r3][2]), [r3, n3, i2];
        }
        t2.exports = function t3(e3, r3, a2, c2) {
          c2 || (c2 = 0);
          var g3 = a2.gd;
          function T() {
            t3(e3, r3, a2, c2++), (m2(e3[0]) || a2.hasText) && k({ redrawing: true });
          }
          function k(t4) {
            var e4 = {};
            void 0 !== a2.isActiveShape && (a2.isActiveShape = false, e4 = b(r3, a2)), void 0 !== a2.isActiveSelection && (a2.isActiveSelection = false, e4 = _(r3, a2), g3._fullLayout._reselect = true), Object.keys(e4).length && l.call((t4 || {}).redrawing ? "relayout" : "_guiRelayout", g3, e4);
          }
          var A, M, S, E, L, C = g3._fullLayout._zoomlayer, P = a2.dragmode, O = o(P), I = s(P);
          function D(t4) {
            S = +t4.srcElement.getAttribute("data-i"), E = +t4.srcElement.getAttribute("data-j"), A[S][E].moveFn = z;
          }
          function z(t4, r4) {
            if (e3.length) {
              var n3 = L[S][E][1], i2 = L[S][E][2], o2 = e3[S], s2 = o2.length;
              if (y(o2)) {
                var l2 = t4, u2 = r4;
                a2.isActiveSelection && (w2(o2, E)[1] === o2[E][1] ? u2 = 0 : l2 = 0);
                for (var c3 = 0; c3 < s2; c3++)
                  if (c3 !== E) {
                    var f3 = o2[c3];
                    f3[1] === o2[E][1] && (f3[1] = n3 + l2), f3[2] === o2[E][2] && (f3[2] = i2 + u2);
                  }
                if (o2[E][1] = n3 + l2, o2[E][2] = i2 + u2, !y(o2))
                  for (var h2 = 0; h2 < s2; h2++)
                    for (var p3 = 0; p3 < o2[h2].length; p3++)
                      o2[h2][p3] = L[S][h2][p3];
              } else
                o2[E][1] = n3 + t4, o2[E][2] = i2 + r4;
              T();
            }
          }
          function R() {
            k();
          }
          function F(t4, r4) {
            if (2 === t4) {
              S = +r4.srcElement.getAttribute("data-i"), E = +r4.srcElement.getAttribute("data-j");
              var n3 = e3[S];
              y(n3) || m2(n3) || function() {
                if (e3.length && e3[S] && e3[S].length) {
                  for (var t5 = [], r5 = 0; r5 < e3[S].length; r5++)
                    r5 !== E && t5.push(e3[S][r5]);
                  t5.length > 1 && (2 !== t5.length || "Z" !== t5[1][0]) && (0 === E && (t5[0][0] = "M"), e3[S] = t5, T(), k());
                }
              }();
            }
          }
          function B(t4, r4) {
            !function(t5, r5) {
              if (e3.length)
                for (var n3 = 0; n3 < e3.length; n3++)
                  for (var i2 = 0; i2 < e3[n3].length; i2++)
                    for (var a3 = 0; a3 + 2 < e3[n3][i2].length; a3 += 2)
                      e3[n3][i2][a3 + 1] = L[n3][i2][a3 + 1] + t5, e3[n3][i2][a3 + 2] = L[n3][i2][a3 + 2] + r5;
            }(t4, r4), T();
          }
          function N(t4) {
            (S = +t4.srcElement.getAttribute("data-i")) || (S = 0), M[S].moveFn = B;
          }
          function j() {
            k();
          }
          function U(t4) {
            2 === t4 && function(t5) {
              if (s(t5._fullLayout.dragmode)) {
                v(t5);
                var e4 = t5._fullLayout._activeSelectionIndex, r4 = (t5.layout || {}).selections || [];
                if (e4 < r4.length) {
                  for (var n3 = [], i2 = 0; i2 < r4.length; i2++)
                    i2 !== e4 && n3.push(r4[i2]);
                  delete t5._fullLayout._activeSelectionIndex;
                  var a3 = t5._fullLayout.selections[e4];
                  t5._fullLayout._deselect = { xref: a3.xref, yref: a3.yref }, l.call("_guiRelayout", t5, { selections: n3 });
                }
              }
            }(g3);
          }
          (O || I) && (g3._fullLayout._outlining = true), v(g3), r3.attr("d", x(e3)), c2 || !a2.isActiveShape && !a2.isActiveSelection || (L = function(t4, e4) {
            for (var r4 = 0; r4 < e4.length; r4++) {
              var n3 = e4[r4];
              t4[r4] = [];
              for (var i2 = 0; i2 < n3.length; i2++) {
                t4[r4][i2] = [];
                for (var a3 = 0; a3 < n3[i2].length; a3++)
                  t4[r4][i2][a3] = n3[i2][a3];
              }
            }
            return t4;
          }([], e3), function(t4) {
            A = [];
            for (var r4 = 0; r4 < e3.length; r4++) {
              var o2 = e3[r4], s2 = y(o2), l2 = !s2 && m2(o2);
              A[r4] = [];
              for (var c3 = o2.length, v2 = 0; v2 < c3; v2++)
                if ("Z" !== o2[v2][0] && (!l2 || v2 === f2 || v2 === h || v2 === p2 || v2 === d2)) {
                  var x2, b2 = s2 && a2.isActiveSelection;
                  b2 && (x2 = w2(o2, v2));
                  var _2 = o2[v2][1], T2 = o2[v2][2], k2 = t4.append(b2 ? "rect" : "circle").attr("data-i", r4).attr("data-j", v2).style({ fill: u.background, stroke: u.defaultLine, "stroke-width": 1, "shape-rendering": "crispEdges" });
                  if (b2) {
                    var M2 = x2[1] - _2, S2 = x2[2] - T2, E2 = S2 ? 5 : Math.max(Math.min(25, Math.abs(M2) - 5), 5), L2 = M2 ? 5 : Math.max(Math.min(25, Math.abs(S2) - 5), 5);
                    k2.classed(S2 ? "cursor-ew-resize" : "cursor-ns-resize", true).attr("width", E2).attr("height", L2).attr("x", _2 - E2 / 2).attr("y", T2 - L2 / 2).attr("transform", n2(M2 / 2, S2 / 2));
                  } else
                    k2.classed("cursor-grab", true).attr("r", 5).attr("cx", _2).attr("cy", T2);
                  A[r4][v2] = { element: k2.node(), gd: g3, prepFn: D, doneFn: R, clickFn: F }, i.init(A[r4][v2]);
                }
            }
          }(C.append("g").attr("class", "outline-controllers")), function() {
            if (M = [], e3.length) {
              M[0] = { element: r3[0][0], gd: g3, prepFn: N, doneFn: j, clickFn: U }, i.init(M[0]);
            }
          }());
        };
      }, 34031: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(73972), a = r2(71828), o = r2(89298), s = r2(60165).readPaths, l = r2(42359), u = r2(51873).clearOutlineControllers, c = r2(7901), f2 = r2(91424), h = r2(44467).arrayEditor, p2 = r2(28569), d2 = r2(6964), v = r2(63893), g2 = r2(21459), y = r2(30477), m2 = y.getPathString, x = r2(18783).FROM_TL;
        function b(t3) {
          var e3 = t3._fullLayout;
          for (var r3 in e3._shapeUpperLayer.selectAll("path").remove(), e3._shapeLowerLayer.selectAll("path").remove(), e3._shapeUpperLayer.selectAll("text").remove(), e3._shapeLowerLayer.selectAll("text").remove(), e3._plots) {
            var n3 = e3._plots[r3].shapelayer;
            n3 && (n3.selectAll("path").remove(), n3.selectAll("text").remove());
          }
          for (var i2 = 0; i2 < e3.shapes.length; i2++)
            e3.shapes[i2].visible && T(t3, i2);
        }
        function _(t3) {
          return !!t3._fullLayout._outlining;
        }
        function w2(t3) {
          return !t3._context.edits.shapePosition;
        }
        function T(t3, e3) {
          t3._fullLayout._paperdiv.selectAll('.shapelayer [data-index="' + e3 + '"]').remove();
          var r3 = y.makeShapesOptionsAndPlotinfo(t3, e3), u2 = r3.options, v2 = r3.plotinfo;
          function x2(r4) {
            var x3 = m2(t3, u2), T2 = { "data-index": e3, "fill-rule": u2.fillrule, d: x3 }, E = u2.opacity, L = u2.fillcolor, C = u2.line.width ? u2.line.color : "rgba(0,0,0,0)", P = u2.line.width, O = u2.line.dash;
            P || true !== u2.editable || (P = 5, O = "solid");
            var I = "Z" !== x3[x3.length - 1], D = w2(t3) && u2.editable && t3._fullLayout._activeShapeIndex === e3;
            D && (L = I ? "rgba(0,0,0,0)" : t3._fullLayout.activeshape.fillcolor, E = t3._fullLayout.activeshape.opacity);
            var z, R = r4.append("g").classed("shape-group", true).attr({ "data-index": e3 }), F = R.append("path").attr(T2).style("opacity", E).call(c.stroke, C).call(c.fill, L).call(f2.dashLine, O, P);
            if (k(R, t3, u2), A(t3, e3, u2, R), (D || t3._context.edits.shapePosition) && (z = h(t3.layout, "shapes", u2)), D) {
              F.style({ cursor: "move" });
              var B = { element: F.node(), plotinfo: v2, gd: t3, editHelpers: z, hasText: u2.label.text, isActiveShape: true }, N = s(x3, t3);
              l(N, F, B);
            } else
              t3._context.edits.shapePosition ? function(t4, e4, r5, s2, l2, u3) {
                var c2, h2, v3, x4, b2, w3, T3, S2, E2, L2, C2, P2, O2, I2, D2, z2, R2 = "pixel" === r5.xsizemode, F2 = "pixel" === r5.ysizemode, B2 = "line" === r5.type, N2 = "path" === r5.type, j = u3.modifyItem, U = n2.select(e4.node().parentNode), V = o.getFromId(t4, r5.xref), H = o.getRefType(r5.xref), q2 = o.getFromId(t4, r5.yref), G = o.getRefType(r5.yref), Z = y.getDataToPixel(t4, V, false, H), Y = y.getDataToPixel(t4, q2, true, G), W = y.getPixelToData(t4, V, false, H), X = y.getPixelToData(t4, q2, true, G), J = B2 ? function() {
                  var t5 = 10, n3 = Math.max(r5.line.width, t5), i2 = l2.append("g").attr("data-index", s2).attr("drag-helper", true);
                  i2.append("path").attr("d", e4.attr("d")).style({ cursor: "move", "stroke-width": n3, "stroke-opacity": "0" });
                  var a2 = { "fill-opacity": "0" }, o2 = Math.max(n3 / 2, t5);
                  return i2.append("circle").attr({ "data-line-point": "start-point", cx: R2 ? Z(r5.xanchor) + r5.x0 : Z(r5.x0), cy: F2 ? Y(r5.yanchor) - r5.y0 : Y(r5.y0), r: o2 }).style(a2).classed("cursor-grab", true), i2.append("circle").attr({ "data-line-point": "end-point", cx: R2 ? Z(r5.xanchor) + r5.x1 : Z(r5.x1), cy: F2 ? Y(r5.yanchor) - r5.y1 : Y(r5.y1), r: o2 }).style(a2).classed("cursor-grab", true), i2;
                }() : e4, K = { element: J.node(), gd: t4, prepFn: function(n3) {
                  _(t4) || (R2 && (b2 = Z(r5.xanchor)), F2 && (w3 = Y(r5.yanchor)), "path" === r5.type ? D2 = r5.path : (c2 = R2 ? r5.x0 : Z(r5.x0), h2 = F2 ? r5.y0 : Y(r5.y0), v3 = R2 ? r5.x1 : Z(r5.x1), x4 = F2 ? r5.y1 : Y(r5.y1)), c2 < v3 ? (E2 = c2, O2 = "x0", L2 = v3, I2 = "x1") : (E2 = v3, O2 = "x1", L2 = c2, I2 = "x0"), !F2 && h2 < x4 || F2 && h2 > x4 ? (T3 = h2, C2 = "y0", S2 = x4, P2 = "y1") : (T3 = x4, C2 = "y1", S2 = h2, P2 = "y0"), $(n3), et(l2, r5), function(t5, e5, r6) {
                    var n4 = e5.xref, i2 = e5.yref, a2 = o.getFromId(r6, n4), s3 = o.getFromId(r6, i2), l3 = "";
                    "paper" === n4 || a2.autorange || (l3 += n4), "paper" === i2 || s3.autorange || (l3 += i2), f2.setClipUrl(t5, l3 ? "clip" + r6._fullLayout._uid + l3 : null, r6);
                  }(e4, r5, t4), K.moveFn = "move" === z2 ? Q : tt, K.altKey = n3.altKey);
                }, doneFn: function() {
                  _(t4) || (d2(e4), rt(l2), k(e4, t4, r5), i.call("_guiRelayout", t4, u3.getUpdateObj()));
                }, clickFn: function() {
                  _(t4) || rt(l2);
                } };
                function $(r6) {
                  if (_(t4))
                    z2 = null;
                  else if (B2)
                    z2 = "path" === r6.target.tagName ? "move" : "start-point" === r6.target.attributes["data-line-point"].value ? "resize-over-start-point" : "resize-over-end-point";
                  else {
                    var n3 = K.element.getBoundingClientRect(), i2 = n3.right - n3.left, a2 = n3.bottom - n3.top, o2 = r6.clientX - n3.left, s3 = r6.clientY - n3.top, l3 = !N2 && i2 > 10 && a2 > 10 && !r6.shiftKey ? p2.getCursor(o2 / i2, 1 - s3 / a2) : "move";
                    d2(e4, l3), z2 = l3.split("-")[0];
                  }
                }
                function Q(n3, i2) {
                  if ("path" === r5.type) {
                    var a2 = function(t5) {
                      return t5;
                    }, o2 = a2, u4 = a2;
                    R2 ? j("xanchor", r5.xanchor = W(b2 + n3)) : (o2 = function(t5) {
                      return W(Z(t5) + n3);
                    }, V && "date" === V.type && (o2 = y.encodeDate(o2))), F2 ? j("yanchor", r5.yanchor = X(w3 + i2)) : (u4 = function(t5) {
                      return X(Y(t5) + i2);
                    }, q2 && "date" === q2.type && (u4 = y.encodeDate(u4))), j("path", r5.path = M(D2, o2, u4));
                  } else
                    R2 ? j("xanchor", r5.xanchor = W(b2 + n3)) : (j("x0", r5.x0 = W(c2 + n3)), j("x1", r5.x1 = W(v3 + n3))), F2 ? j("yanchor", r5.yanchor = X(w3 + i2)) : (j("y0", r5.y0 = X(h2 + i2)), j("y1", r5.y1 = X(x4 + i2)));
                  e4.attr("d", m2(t4, r5)), et(l2, r5), A(t4, s2, r5, U);
                }
                function tt(n3, i2) {
                  if (N2) {
                    var a2 = function(t5) {
                      return t5;
                    }, o2 = a2, u4 = a2;
                    R2 ? j("xanchor", r5.xanchor = W(b2 + n3)) : (o2 = function(t5) {
                      return W(Z(t5) + n3);
                    }, V && "date" === V.type && (o2 = y.encodeDate(o2))), F2 ? j("yanchor", r5.yanchor = X(w3 + i2)) : (u4 = function(t5) {
                      return X(Y(t5) + i2);
                    }, q2 && "date" === q2.type && (u4 = y.encodeDate(u4))), j("path", r5.path = M(D2, o2, u4));
                  } else if (B2) {
                    if ("resize-over-start-point" === z2) {
                      var f3 = c2 + n3, p3 = F2 ? h2 - i2 : h2 + i2;
                      j("x0", r5.x0 = R2 ? f3 : W(f3)), j("y0", r5.y0 = F2 ? p3 : X(p3));
                    } else if ("resize-over-end-point" === z2) {
                      var d3 = v3 + n3, g3 = F2 ? x4 - i2 : x4 + i2;
                      j("x1", r5.x1 = R2 ? d3 : W(d3)), j("y1", r5.y1 = F2 ? g3 : X(g3));
                    }
                  } else {
                    var _2 = function(t5) {
                      return -1 !== z2.indexOf(t5);
                    }, k2 = _2("n"), H2 = _2("s"), G2 = _2("w"), J2 = _2("e"), K2 = k2 ? T3 + i2 : T3, $2 = H2 ? S2 + i2 : S2, Q2 = G2 ? E2 + n3 : E2, tt2 = J2 ? L2 + n3 : L2;
                    F2 && (k2 && (K2 = T3 - i2), H2 && ($2 = S2 - i2)), (!F2 && $2 - K2 > 10 || F2 && K2 - $2 > 10) && (j(C2, r5[C2] = F2 ? K2 : X(K2)), j(P2, r5[P2] = F2 ? $2 : X($2))), tt2 - Q2 > 10 && (j(O2, r5[O2] = R2 ? Q2 : W(Q2)), j(I2, r5[I2] = R2 ? tt2 : W(tt2)));
                  }
                  e4.attr("d", m2(t4, r5)), et(l2, r5), A(t4, s2, r5, U);
                }
                function et(t5, e5) {
                  (R2 || F2) && function() {
                    var r6 = "path" !== e5.type, n3 = t5.selectAll(".visual-cue").data([0]);
                    n3.enter().append("path").attr({ fill: "#fff", "fill-rule": "evenodd", stroke: "#000", "stroke-width": 1 }).classed("visual-cue", true);
                    var i2 = Z(R2 ? e5.xanchor : a.midRange(r6 ? [e5.x0, e5.x1] : y.extractPathCoords(e5.path, g2.paramIsX))), o2 = Y(F2 ? e5.yanchor : a.midRange(r6 ? [e5.y0, e5.y1] : y.extractPathCoords(e5.path, g2.paramIsY)));
                    if (i2 = y.roundPositionForSharpStrokeRendering(i2, 1), o2 = y.roundPositionForSharpStrokeRendering(o2, 1), R2 && F2) {
                      var s3 = "M" + (i2 - 1 - 1) + "," + (o2 - 1 - 1) + "h-8v2h8 v8h2v-8 h8v-2h-8 v-8h-2 Z";
                      n3.attr("d", s3);
                    } else if (R2) {
                      var l3 = "M" + (i2 - 1 - 1) + "," + (o2 - 9 - 1) + "v18 h2 v-18 Z";
                      n3.attr("d", l3);
                    } else {
                      var u4 = "M" + (i2 - 9 - 1) + "," + (o2 - 1 - 1) + "h18 v2 h-18 Z";
                      n3.attr("d", u4);
                    }
                  }();
                }
                function rt(t5) {
                  t5.selectAll(".visual-cue").remove();
                }
                p2.init(K), J.node().onmousemove = $;
              }(t3, F, u2, e3, r4, z) : true === u2.editable && F.style("pointer-events", I || c.opacity(L) * E <= 0.5 ? "stroke" : "all");
            F.node().addEventListener("click", function() {
              return function(t4, e4) {
                if (w2(t4)) {
                  var r5 = +e4.node().getAttribute("data-index");
                  if (r5 >= 0) {
                    if (r5 === t4._fullLayout._activeShapeIndex)
                      return void S(t4);
                    t4._fullLayout._activeShapeIndex = r5, t4._fullLayout._deactivateShape = S, b(t4);
                  }
                }
              }(t3, F);
            });
          }
          u2._input && false !== u2.visible && ("below" !== u2.layer ? x2(t3._fullLayout._shapeUpperLayer) : "paper" === u2.xref || "paper" === u2.yref ? x2(t3._fullLayout._shapeLowerLayer) : v2._hadPlotinfo ? x2((v2.mainplotinfo || v2).shapelayer) : x2(t3._fullLayout._shapeLowerLayer));
        }
        function k(t3, e3, r3) {
          var n3 = (r3.xref + r3.yref).replace(/paper/g, "").replace(/[xyz][1-9]* *domain/g, "");
          f2.setClipUrl(t3, n3 ? "clip" + e3._fullLayout._uid + n3 : null, e3);
        }
        function A(t3, e3, r3, n3) {
          if (n3.selectAll(".shape-label").remove(), r3.label.text) {
            var i2, a2, l2, u2, c2 = { "data-index": e3 }, h2 = r3.label.text, p3 = r3.label.font, d3 = n3.append("g").attr(c2).classed("shape-label", true).append("text").attr({ "data-notex": 1 }).classed("shape-label-text", true).text(h2);
            if (r3.path) {
              var g3 = m2(t3, r3), b2 = s(g3, t3);
              i2 = 1 / 0, l2 = 1 / 0, a2 = -1 / 0, u2 = -1 / 0;
              for (var _2 = 0; _2 < b2.length; _2++)
                for (var w3 = 0; w3 < b2[_2].length; w3++)
                  for (var T2 = b2[_2][w3], k2 = 1; k2 < T2.length; k2 += 2) {
                    var A2 = T2[k2], M2 = T2[k2 + 1];
                    i2 = Math.min(i2, A2), a2 = Math.max(a2, A2), l2 = Math.min(l2, M2), u2 = Math.max(u2, M2);
                  }
            } else {
              var S2 = o.getFromId(t3, r3.xref), E = o.getRefType(r3.xref), L = o.getFromId(t3, r3.yref), C = o.getRefType(r3.yref), P = y.getDataToPixel(t3, S2, false, E), O = y.getDataToPixel(t3, L, true, C);
              i2 = P(r3.x0), a2 = P(r3.x1), l2 = O(r3.y0), u2 = O(r3.y1);
            }
            var I = r3.label.textangle;
            "auto" === I && (I = "line" === r3.type ? function(t4, e4, r4, n4) {
              var i3, a3;
              return a3 = Math.abs(r4 - t4), i3 = r4 >= t4 ? e4 - n4 : n4 - e4, -180 / Math.PI * Math.atan2(i3, a3);
            }(i2, l2, a2, u2) : 0), d3.call(function(e4) {
              return e4.call(f2.font, p3).attr({}), v.convertToTspans(e4, t3), e4;
            });
            var D = function(t4, e4, r4, n4, i3, a3, o2) {
              var s2, l3, u3, c3, f3 = i3.label.textposition, h3 = i3.label.textangle, p4 = i3.label.padding, d4 = i3.type, v2 = Math.PI / 180 * a3, g4 = Math.sin(v2), y2 = Math.cos(v2), m3 = i3.label.xanchor, b3 = i3.label.yanchor;
              if ("line" === d4) {
                "start" === f3 ? (s2 = t4, l3 = e4) : "end" === f3 ? (s2 = r4, l3 = n4) : (s2 = (t4 + r4) / 2, l3 = (e4 + n4) / 2), "auto" === m3 && (m3 = "start" === f3 ? "auto" === h3 ? r4 > t4 ? "left" : r4 < t4 ? "right" : "center" : r4 > t4 ? "right" : r4 < t4 ? "left" : "center" : "end" === f3 ? "auto" === h3 ? r4 > t4 ? "right" : r4 < t4 ? "left" : "center" : r4 > t4 ? "left" : r4 < t4 ? "right" : "center" : "center");
                var _3 = { bottom: -1, middle: 0, top: 1 };
                if ("auto" === h3) {
                  var w4 = _3[b3];
                  u3 = -p4 * g4 * w4, c3 = p4 * y2 * w4;
                } else
                  u3 = p4 * { left: 1, center: 0, right: -1 }[m3], c3 = p4 * _3[b3];
                s2 += u3, l3 += c3;
              } else
                u3 = p4 + 3, -1 !== f3.indexOf("right") ? (s2 = Math.max(t4, r4) - u3, "auto" === m3 && (m3 = "right")) : -1 !== f3.indexOf("left") ? (s2 = Math.min(t4, r4) + u3, "auto" === m3 && (m3 = "left")) : (s2 = (t4 + r4) / 2, "auto" === m3 && (m3 = "center")), l3 = -1 !== f3.indexOf("top") ? Math.min(e4, n4) : -1 !== f3.indexOf("bottom") ? Math.max(e4, n4) : (e4 + n4) / 2, c3 = p4, "bottom" === b3 ? l3 -= c3 : "top" === b3 && (l3 += c3);
              var T3 = x[b3], k3 = i3.label.font.size, A3 = o2.height;
              return { textx: s2 + (A3 * T3 - k3) * g4, texty: l3 + -(A3 * T3 - k3) * y2, xanchor: m3 };
            }(i2, l2, a2, u2, r3, I, f2.bBox(d3.node())), z = D.textx, R = D.texty, F = D.xanchor;
            d3.attr({ "text-anchor": { left: "start", center: "middle", right: "end" }[F], y: R, x: z, transform: "rotate(" + I + "," + z + "," + R + ")" }).call(v.positionText, z, R);
          }
        }
        function M(t3, e3, r3) {
          return t3.replace(g2.segmentRE, function(t4) {
            var n3 = 0, i2 = t4.charAt(0), a2 = g2.paramIsX[i2], o2 = g2.paramIsY[i2], s2 = g2.numParams[i2];
            return i2 + t4.substr(1).replace(g2.paramRE, function(t5) {
              return n3 >= s2 || (a2[n3] ? t5 = e3(t5) : o2[n3] && (t5 = r3(t5)), n3++), t5;
            });
          });
        }
        function S(t3) {
          w2(t3) && t3._fullLayout._activeShapeIndex >= 0 && (u(t3), delete t3._fullLayout._activeShapeIndex, b(t3));
        }
        t2.exports = { draw: b, drawOne: T, eraseActiveShape: function(t3) {
          if (w2(t3)) {
            u(t3);
            var e3 = t3._fullLayout._activeShapeIndex, r3 = (t3.layout || {}).shapes || [];
            if (e3 < r3.length) {
              for (var n3 = [], a2 = 0; a2 < r3.length; a2++)
                a2 !== e3 && n3.push(r3[a2]);
              delete t3._fullLayout._activeShapeIndex, i.call("_guiRelayout", t3, { shapes: n3 });
            }
          }
        } };
      }, 29241: function(t2, e2, r2) {
        var n2 = r2(41940), i = r2(79952).P, a = r2(1426).extendFlat;
        t2.exports = { newshape: { line: { color: { valType: "color", editType: "none" }, width: { valType: "number", min: 0, dflt: 4, editType: "none" }, dash: a({}, i, { dflt: "solid", editType: "none" }), editType: "none" }, fillcolor: { valType: "color", dflt: "rgba(0,0,0,0)", editType: "none" }, fillrule: { valType: "enumerated", values: ["evenodd", "nonzero"], dflt: "evenodd", editType: "none" }, opacity: { valType: "number", min: 0, max: 1, dflt: 1, editType: "none" }, layer: { valType: "enumerated", values: ["below", "above"], dflt: "above", editType: "none" }, drawdirection: { valType: "enumerated", values: ["ortho", "horizontal", "vertical", "diagonal"], dflt: "diagonal", editType: "none" }, label: { text: { valType: "string", dflt: "", editType: "none" }, font: n2({ editType: "none" }), textposition: { valType: "enumerated", values: ["top left", "top center", "top right", "middle left", "middle center", "middle right", "bottom left", "bottom center", "bottom right", "start", "middle", "end"], editType: "none" }, textangle: { valType: "angle", dflt: "auto", editType: "none" }, xanchor: { valType: "enumerated", values: ["auto", "left", "center", "right"], dflt: "auto", editType: "none" }, yanchor: { valType: "enumerated", values: ["top", "middle", "bottom"], editType: "none" }, padding: { valType: "number", dflt: 3, min: 0, editType: "none" }, editType: "none" }, editType: "none" }, activeshape: { fillcolor: { valType: "color", dflt: "rgb(255,0,255)", editType: "none" }, opacity: { valType: "number", min: 0, max: 1, dflt: 0.5, editType: "none" }, editType: "none" } };
      }, 89995: function(t2) {
        t2.exports = { CIRCLE_SIDES: 32, i000: 0, i090: 8, i180: 16, i270: 24, cos45: Math.cos(Math.PI / 4), sin45: Math.sin(Math.PI / 4), SQRT2: Math.sqrt(2) };
      }, 45547: function(t2, e2, r2) {
        var n2 = r2(7901), i = r2(71828);
        t2.exports = function(t3, e3, r3) {
          if (r3("newshape.drawdirection"), r3("newshape.layer"), r3("newshape.fillcolor"), r3("newshape.fillrule"), r3("newshape.opacity"), r3("newshape.line.width")) {
            var a = (t3 || {}).plot_bgcolor || "#FFF";
            r3("newshape.line.color", n2.contrast(a)), r3("newshape.line.dash");
          }
          var o = "drawline" === t3.dragmode;
          if (r3("newshape.label.text")) {
            r3("newshape.label.textangle");
            var s = r3("newshape.label.textposition", o ? "middle" : "middle center");
            r3("newshape.label.xanchor"), r3("newshape.label.yanchor", function(t4, e4) {
              return t4 ? "bottom" : -1 !== e4.indexOf("top") ? "top" : -1 !== e4.indexOf("bottom") ? "bottom" : "middle";
            }(o, s)), r3("newshape.label.padding"), i.coerceFont(r3, "newshape.label.font", e3.font);
          }
          r3("activeshape.fillcolor"), r3("activeshape.opacity");
        };
      }, 60165: function(t2, e2, r2) {
        var n2 = r2(95616), i = r2(89995), a = i.CIRCLE_SIDES, o = i.SQRT2, s = r2(75549), l = s.p2r, u = s.r2p, c = [0, 3, 4, 5, 6, 1, 2], f2 = [0, 3, 4, 1, 2];
        function h(t3, e3) {
          return Math.abs(t3 - e3) <= 1e-6;
        }
        function p2(t3, e3) {
          var r3 = e3[1] - t3[1], n3 = e3[2] - t3[2];
          return Math.sqrt(r3 * r3 + n3 * n3);
        }
        e2.writePaths = function(t3) {
          var e3 = t3.length;
          if (!e3)
            return "M0,0Z";
          for (var r3 = "", n3 = 0; n3 < e3; n3++)
            for (var i2 = t3[n3].length, a2 = 0; a2 < i2; a2++) {
              var o2 = t3[n3][a2][0];
              if ("Z" === o2)
                r3 += "Z";
              else
                for (var s2 = t3[n3][a2].length, l2 = 0; l2 < s2; l2++) {
                  var u2 = l2;
                  "Q" === o2 || "S" === o2 ? u2 = f2[l2] : "C" === o2 && (u2 = c[l2]), r3 += t3[n3][a2][u2], l2 > 0 && l2 < s2 - 1 && (r3 += ",");
                }
            }
          return r3;
        }, e2.readPaths = function(t3, e3, r3, i2) {
          var o2, s2, c2, f3 = n2(t3), h2 = [], p3 = -1, d2 = 0, v = 0, g2 = function() {
            s2 = d2, c2 = v;
          };
          g2();
          for (var y = 0; y < f3.length; y++) {
            var m2, x, b, _, w2 = [], T = f3[y][0], k = T;
            switch (T) {
              case "M":
                h2[++p3] = [], d2 = +f3[y][1], v = +f3[y][2], w2.push([k, d2, v]), g2();
                break;
              case "Q":
              case "S":
                m2 = +f3[y][1], b = +f3[y][2], d2 = +f3[y][3], v = +f3[y][4], w2.push([k, d2, v, m2, b]);
                break;
              case "C":
                m2 = +f3[y][1], b = +f3[y][2], x = +f3[y][3], _ = +f3[y][4], d2 = +f3[y][5], v = +f3[y][6], w2.push([k, d2, v, m2, b, x, _]);
                break;
              case "T":
              case "L":
                d2 = +f3[y][1], v = +f3[y][2], w2.push([k, d2, v]);
                break;
              case "H":
                k = "L", d2 = +f3[y][1], w2.push([k, d2, v]);
                break;
              case "V":
                k = "L", v = +f3[y][1], w2.push([k, d2, v]);
                break;
              case "A":
                k = "L";
                var A = +f3[y][1], M = +f3[y][2];
                +f3[y][4] || (A = -A, M = -M);
                var S = d2 - A, E = v;
                for (o2 = 1; o2 <= a / 2; o2++) {
                  var L = 2 * Math.PI * o2 / a;
                  w2.push([k, S + A * Math.cos(L), E + M * Math.sin(L)]);
                }
                break;
              case "Z":
                d2 === s2 && v === c2 || (d2 = s2, v = c2, w2.push([k, d2, v]));
            }
            for (var C = (r3 || {}).domain, P = e3._fullLayout._size, O = r3 && "pixel" === r3.xsizemode, I = r3 && "pixel" === r3.ysizemode, D = false === i2, z = 0; z < w2.length; z++) {
              for (o2 = 0; o2 + 2 < 7; o2 += 2) {
                var R = w2[z][o2 + 1], F = w2[z][o2 + 2];
                void 0 !== R && void 0 !== F && (d2 = R, v = F, r3 && (r3.xaxis && r3.xaxis.p2r ? (D && (R -= r3.xaxis._offset), R = O ? u(r3.xaxis, r3.xanchor) + R : l(r3.xaxis, R)) : (D && (R -= P.l), C ? R = C.x[0] + R / P.w : R /= P.w), r3.yaxis && r3.yaxis.p2r ? (D && (F -= r3.yaxis._offset), F = I ? u(r3.yaxis, r3.yanchor) - F : l(r3.yaxis, F)) : (D && (F -= P.t), F = C ? C.y[1] - F / P.h : 1 - F / P.h)), w2[z][o2 + 1] = R, w2[z][o2 + 2] = F);
              }
              h2[p3].push(w2[z].slice());
            }
          }
          return h2;
        }, e2.pointsOnRectangle = function(t3) {
          if (5 !== t3.length)
            return false;
          for (var e3 = 1; e3 < 3; e3++) {
            if (!h(t3[0][e3] - t3[1][e3], t3[3][e3] - t3[2][e3]))
              return false;
            if (!h(t3[0][e3] - t3[3][e3], t3[1][e3] - t3[2][e3]))
              return false;
          }
          return !(!h(t3[0][1], t3[1][1]) && !h(t3[0][1], t3[3][1]) || !(p2(t3[0], t3[1]) * p2(t3[0], t3[3])));
        }, e2.pointsOnEllipse = function(t3) {
          var e3 = t3.length;
          if (e3 !== a + 1)
            return false;
          e3 = a;
          for (var r3 = 0; r3 < e3; r3++) {
            var n3 = (2 * e3 - r3) % e3, i2 = (e3 / 2 + n3) % e3, o2 = (e3 / 2 + r3) % e3;
            if (!h(p2(t3[r3], t3[o2]), p2(t3[n3], t3[i2])))
              return false;
          }
          return true;
        }, e2.handleEllipse = function(t3, r3, n3) {
          if (!t3)
            return [r3, n3];
          var i2 = e2.ellipseOver({ x0: r3[0], y0: r3[1], x1: n3[0], y1: n3[1] }), s2 = (i2.x1 + i2.x0) / 2, l2 = (i2.y1 + i2.y0) / 2, u2 = (i2.x1 - i2.x0) / 2, c2 = (i2.y1 - i2.y0) / 2;
          u2 || (u2 = c2 /= o), c2 || (c2 = u2 /= o);
          for (var f3 = [], h2 = 0; h2 < a; h2++) {
            var p3 = 2 * h2 * Math.PI / a;
            f3.push([s2 + u2 * Math.cos(p3), l2 + c2 * Math.sin(p3)]);
          }
          return f3;
        }, e2.ellipseOver = function(t3) {
          var e3 = t3.x0, r3 = t3.y0, n3 = t3.x1, i2 = t3.y1, a2 = n3 - e3, s2 = i2 - r3, l2 = ((e3 -= a2) + n3) / 2, u2 = ((r3 -= s2) + i2) / 2;
          return { x0: l2 - (a2 *= o), y0: u2 - (s2 *= o), x1: l2 + a2, y1: u2 + s2 };
        }, e2.fixDatesForPaths = function(t3, e3, r3) {
          var n3 = "date" === e3.type, i2 = "date" === r3.type;
          if (!n3 && !i2)
            return t3;
          for (var a2 = 0; a2 < t3.length; a2++)
            for (var o2 = 0; o2 < t3[a2].length; o2++)
              for (var s2 = 0; s2 + 2 < t3[a2][o2].length; s2 += 2)
                n3 && (t3[a2][o2][s2 + 1] = t3[a2][o2][s2 + 1].replace(" ", "_")), i2 && (t3[a2][o2][s2 + 2] = t3[a2][o2][s2 + 2].replace(" ", "_"));
          return t3;
        };
      }, 90551: function(t2, e2, r2) {
        var n2 = r2(64505), i = n2.drawMode, a = n2.openMode, o = r2(89995), s = o.i000, l = o.i090, u = o.i180, c = o.i270, f2 = o.cos45, h = o.sin45, p2 = r2(75549), d2 = p2.p2r, v = p2.r2p, g2 = r2(51873).clearOutline, y = r2(60165), m2 = y.readPaths, x = y.writePaths, b = y.ellipseOver, _ = y.fixDatesForPaths;
        t2.exports = function(t3, e3) {
          if (t3.length) {
            var r3 = t3[0][0];
            if (r3) {
              var n3 = r3.getAttribute("d"), o2 = e3.gd, p3 = o2._fullLayout.newshape, y2 = e3.plotinfo, w2 = y2.xaxis, T = y2.yaxis, k = !!y2.domain || !y2.xaxis, A = !!y2.domain || !y2.yaxis, M = e3.isActiveShape, S = e3.dragmode, E = (o2.layout || {}).shapes || [];
              if (!i(S) && void 0 !== M) {
                var L = o2._fullLayout._activeShapeIndex;
                if (L < E.length)
                  switch (o2._fullLayout.shapes[L].type) {
                    case "rect":
                      S = "drawrect";
                      break;
                    case "circle":
                      S = "drawcircle";
                      break;
                    case "line":
                      S = "drawline";
                      break;
                    case "path":
                      var C = E[L].path || "";
                      S = "Z" === C[C.length - 1] ? "drawclosedpath" : "drawopenpath";
                  }
              }
              var P, O = a(S), I = m2(n3, o2, y2, M), D = { editable: true, label: p3.label, xref: k ? "paper" : w2._id, yref: A ? "paper" : T._id, layer: p3.layer, opacity: p3.opacity, line: { color: p3.line.color, width: p3.line.width, dash: p3.line.dash } };
              if (O || (D.fillcolor = p3.fillcolor, D.fillrule = p3.fillrule), 1 === I.length && (P = I[0]), P && 5 === P.length && "drawrect" === S)
                D.type = "rect", D.x0 = P[0][1], D.y0 = P[0][2], D.x1 = P[2][1], D.y1 = P[2][2];
              else if (P && "drawline" === S)
                D.type = "line", D.x0 = P[0][1], D.y0 = P[0][2], D.x1 = P[1][1], D.y1 = P[1][2];
              else if (P && "drawcircle" === S) {
                D.type = "circle";
                var z = P[s][1], R = P[l][1], F = P[u][1], B = P[c][1], N = P[s][2], j = P[l][2], U = P[u][2], V = P[c][2], H = y2.xaxis && ("date" === y2.xaxis.type || "log" === y2.xaxis.type), q2 = y2.yaxis && ("date" === y2.yaxis.type || "log" === y2.yaxis.type);
                H && (z = v(y2.xaxis, z), R = v(y2.xaxis, R), F = v(y2.xaxis, F), B = v(y2.xaxis, B)), q2 && (N = v(y2.yaxis, N), j = v(y2.yaxis, j), U = v(y2.yaxis, U), V = v(y2.yaxis, V));
                var G = (R + B) / 2, Z = (N + U) / 2, Y = b({ x0: G, y0: Z, x1: G + (B - R + F - z) / 2 * f2, y1: Z + (V - j + U - N) / 2 * h });
                H && (Y.x0 = d2(y2.xaxis, Y.x0), Y.x1 = d2(y2.xaxis, Y.x1)), q2 && (Y.y0 = d2(y2.yaxis, Y.y0), Y.y1 = d2(y2.yaxis, Y.y1)), D.x0 = Y.x0, D.y0 = Y.y0, D.x1 = Y.x1, D.y1 = Y.y1;
              } else
                D.type = "path", w2 && T && _(I, w2, T), D.path = x(I), P = null;
              g2(o2);
              for (var W = e3.editHelpers, X = (W || {}).modifyItem, J = [], K = 0; K < E.length; K++) {
                var $ = o2._fullLayout.shapes[K];
                if (J[K] = $._input, void 0 !== M && K === o2._fullLayout._activeShapeIndex) {
                  var Q = D;
                  switch ($.type) {
                    case "line":
                    case "rect":
                    case "circle":
                      X("x0", Q.x0), X("x1", Q.x1), X("y0", Q.y0), X("y1", Q.y1);
                      break;
                    case "path":
                      X("path", Q.path);
                  }
                }
              }
              return void 0 === M ? (J.push(D), J) : W ? W.getUpdateObj() : {};
            }
          }
        };
      }, 51873: function(t2) {
        t2.exports = { clearOutlineControllers: function(t3) {
          var e2 = t3._fullLayout._zoomlayer;
          e2 && e2.selectAll(".outline-controllers").remove();
        }, clearOutline: function(t3) {
          var e2 = t3._fullLayout._zoomlayer;
          e2 && e2.selectAll(".select-outline").remove(), t3._fullLayout._outlining = false;
        } };
      }, 30477: function(t2, e2, r2) {
        var n2 = r2(21459), i = r2(71828), a = r2(89298);
        e2.rangeToShapePosition = function(t3) {
          return "log" === t3.type ? t3.r2d : function(t4) {
            return t4;
          };
        }, e2.shapePositionToRange = function(t3) {
          return "log" === t3.type ? t3.d2r : function(t4) {
            return t4;
          };
        }, e2.decodeDate = function(t3) {
          return function(e3) {
            return e3.replace && (e3 = e3.replace("_", " ")), t3(e3);
          };
        }, e2.encodeDate = function(t3) {
          return function(e3) {
            return t3(e3).replace(" ", "_");
          };
        }, e2.extractPathCoords = function(t3, e3, r3) {
          var a2 = [];
          return t3.match(n2.segmentRE).forEach(function(t4) {
            var o = e3[t4.charAt(0)].drawn;
            if (void 0 !== o) {
              var s = t4.substr(1).match(n2.paramRE);
              if (s && !(s.length < o)) {
                var l = s[o], u = r3 ? l : i.cleanNumber(l);
                a2.push(u);
              }
            }
          }), a2;
        }, e2.getDataToPixel = function(t3, r3, n3, i2) {
          var a2, o = t3._fullLayout._size;
          if (r3)
            if ("domain" === i2)
              a2 = function(t4) {
                return r3._length * (n3 ? 1 - t4 : t4) + r3._offset;
              };
            else {
              var s = e2.shapePositionToRange(r3);
              a2 = function(t4) {
                return r3._offset + r3.r2p(s(t4, true));
              }, "date" === r3.type && (a2 = e2.decodeDate(a2));
            }
          else
            a2 = n3 ? function(t4) {
              return o.t + o.h * (1 - t4);
            } : function(t4) {
              return o.l + o.w * t4;
            };
          return a2;
        }, e2.getPixelToData = function(t3, r3, n3, i2) {
          var a2, o = t3._fullLayout._size;
          if (r3)
            if ("domain" === i2)
              a2 = function(t4) {
                var e3 = (t4 - r3._offset) / r3._length;
                return n3 ? 1 - e3 : e3;
              };
            else {
              var s = e2.rangeToShapePosition(r3);
              a2 = function(t4) {
                return s(r3.p2r(t4 - r3._offset));
              };
            }
          else
            a2 = n3 ? function(t4) {
              return 1 - (t4 - o.t) / o.h;
            } : function(t4) {
              return (t4 - o.l) / o.w;
            };
          return a2;
        }, e2.roundPositionForSharpStrokeRendering = function(t3, e3) {
          var r3 = 1 === Math.round(e3 % 2), n3 = Math.round(t3);
          return r3 ? n3 + 0.5 : n3;
        }, e2.makeShapesOptionsAndPlotinfo = function(t3, e3) {
          var r3 = t3._fullLayout.shapes[e3] || {}, n3 = t3._fullLayout._plots[r3.xref + r3.yref];
          return n3 ? n3._hadPlotinfo = true : (n3 = {}, r3.xref && "paper" !== r3.xref && (n3.xaxis = t3._fullLayout[r3.xref + "axis"]), r3.yref && "paper" !== r3.yref && (n3.yaxis = t3._fullLayout[r3.yref + "axis"])), n3.xsizemode = r3.xsizemode, n3.ysizemode = r3.ysizemode, n3.xanchor = r3.xanchor, n3.yanchor = r3.yanchor, { options: r3, plotinfo: n3 };
        }, e2.makeSelectionsOptionsAndPlotinfo = function(t3, e3) {
          var r3 = t3._fullLayout.selections[e3] || {}, n3 = t3._fullLayout._plots[r3.xref + r3.yref];
          return n3 ? n3._hadPlotinfo = true : (n3 = {}, r3.xref && (n3.xaxis = t3._fullLayout[r3.xref + "axis"]), r3.yref && (n3.yaxis = t3._fullLayout[r3.yref + "axis"])), { options: r3, plotinfo: n3 };
        }, e2.getPathString = function(t3, r3) {
          var o, s, l, u, c, f2, h, p2, d2 = r3.type, v = a.getRefType(r3.xref), g2 = a.getRefType(r3.yref), y = a.getFromId(t3, r3.xref), m2 = a.getFromId(t3, r3.yref), x = t3._fullLayout._size;
          if (y ? "domain" === v ? s = function(t4) {
            return y._offset + y._length * t4;
          } : (o = e2.shapePositionToRange(y), s = function(t4) {
            return y._offset + y.r2p(o(t4, true));
          }) : s = function(t4) {
            return x.l + x.w * t4;
          }, m2 ? "domain" === g2 ? u = function(t4) {
            return m2._offset + m2._length * (1 - t4);
          } : (l = e2.shapePositionToRange(m2), u = function(t4) {
            return m2._offset + m2.r2p(l(t4, true));
          }) : u = function(t4) {
            return x.t + x.h * (1 - t4);
          }, "path" === d2)
            return y && "date" === y.type && (s = e2.decodeDate(s)), m2 && "date" === m2.type && (u = e2.decodeDate(u)), function(t4, e3, r4) {
              var a2 = t4.path, o2 = t4.xsizemode, s2 = t4.ysizemode, l2 = t4.xanchor, u2 = t4.yanchor;
              return a2.replace(n2.segmentRE, function(t5) {
                var a3 = 0, c2 = t5.charAt(0), f3 = n2.paramIsX[c2], h2 = n2.paramIsY[c2], p3 = n2.numParams[c2], d3 = t5.substr(1).replace(n2.paramRE, function(t6) {
                  return f3[a3] ? t6 = "pixel" === o2 ? e3(l2) + Number(t6) : e3(t6) : h2[a3] && (t6 = "pixel" === s2 ? r4(u2) - Number(t6) : r4(t6)), ++a3 > p3 && (t6 = "X"), t6;
                });
                return a3 > p3 && (d3 = d3.replace(/[\s,]*X.*/, ""), i.log("Ignoring extra params in segment " + t5)), c2 + d3;
              });
            }(r3, s, u);
          if ("pixel" === r3.xsizemode) {
            var b = s(r3.xanchor);
            c = b + r3.x0, f2 = b + r3.x1;
          } else
            c = s(r3.x0), f2 = s(r3.x1);
          if ("pixel" === r3.ysizemode) {
            var _ = u(r3.yanchor);
            h = _ - r3.y0, p2 = _ - r3.y1;
          } else
            h = u(r3.y0), p2 = u(r3.y1);
          if ("line" === d2)
            return "M" + c + "," + h + "L" + f2 + "," + p2;
          if ("rect" === d2)
            return "M" + c + "," + h + "H" + f2 + "V" + p2 + "H" + c + "Z";
          var w2 = (c + f2) / 2, T = (h + p2) / 2, k = Math.abs(w2 - c), A = Math.abs(T - h), M = "A" + k + "," + A, S = w2 + k + "," + T;
          return "M" + S + M + " 0 1,1 " + w2 + "," + (T - A) + M + " 0 0,1 " + S + "Z";
        };
      }, 89853: function(t2, e2, r2) {
        var n2 = r2(34031);
        t2.exports = { moduleType: "component", name: "shapes", layoutAttributes: r2(89827), supplyLayoutDefaults: r2(84726), supplyDrawNewShapeDefaults: r2(45547), includeBasePlot: r2(76325)("shapes"), calcAutorange: r2(5627), draw: n2.draw, drawOne: n2.drawOne };
      }, 75067: function(t2, e2, r2) {
        var n2 = r2(41940), i = r2(35025), a = r2(1426).extendDeepAll, o = r2(30962).overrideAll, s = r2(85594), l = r2(44467).templatedArray, u = r2(98292), c = l("step", { visible: { valType: "boolean", dflt: true }, method: { valType: "enumerated", values: ["restyle", "relayout", "animate", "update", "skip"], dflt: "restyle" }, args: { valType: "info_array", freeLength: true, items: [{ valType: "any" }, { valType: "any" }, { valType: "any" }] }, label: { valType: "string" }, value: { valType: "string" }, execute: { valType: "boolean", dflt: true } });
        t2.exports = o(l("slider", { visible: { valType: "boolean", dflt: true }, active: { valType: "number", min: 0, dflt: 0 }, steps: c, lenmode: { valType: "enumerated", values: ["fraction", "pixels"], dflt: "fraction" }, len: { valType: "number", min: 0, dflt: 1 }, x: { valType: "number", min: -2, max: 3, dflt: 0 }, pad: a(i({ editType: "arraydraw" }), {}, { t: { dflt: 20 } }), xanchor: { valType: "enumerated", values: ["auto", "left", "center", "right"], dflt: "left" }, y: { valType: "number", min: -2, max: 3, dflt: 0 }, yanchor: { valType: "enumerated", values: ["auto", "top", "middle", "bottom"], dflt: "top" }, transition: { duration: { valType: "number", min: 0, dflt: 150 }, easing: { valType: "enumerated", values: s.transition.easing.values, dflt: "cubic-in-out" } }, currentvalue: { visible: { valType: "boolean", dflt: true }, xanchor: { valType: "enumerated", values: ["left", "center", "right"], dflt: "left" }, offset: { valType: "number", dflt: 10 }, prefix: { valType: "string" }, suffix: { valType: "string" }, font: n2({}) }, font: n2({}), activebgcolor: { valType: "color", dflt: u.gripBgActiveColor }, bgcolor: { valType: "color", dflt: u.railBgColor }, bordercolor: { valType: "color", dflt: u.railBorderColor }, borderwidth: { valType: "number", min: 0, dflt: u.railBorderWidth }, ticklen: { valType: "number", min: 0, dflt: u.tickLength }, tickcolor: { valType: "color", dflt: u.tickColor }, tickwidth: { valType: "number", min: 0, dflt: 1 }, minorticklen: { valType: "number", min: 0, dflt: u.minorTickLength } }), "arraydraw", "from-root");
      }, 98292: function(t2) {
        t2.exports = { name: "sliders", containerClassName: "slider-container", groupClassName: "slider-group", inputAreaClass: "slider-input-area", railRectClass: "slider-rail-rect", railTouchRectClass: "slider-rail-touch-rect", gripRectClass: "slider-grip-rect", tickRectClass: "slider-tick-rect", inputProxyClass: "slider-input-proxy", labelsClass: "slider-labels", labelGroupClass: "slider-label-group", labelClass: "slider-label", currentValueClass: "slider-current-value", railHeight: 5, menuIndexAttrName: "slider-active-index", autoMarginIdRoot: "slider-", minWidth: 30, minHeight: 30, textPadX: 40, arrowOffsetX: 4, railRadius: 2, railWidth: 5, railBorder: 4, railBorderWidth: 1, railBorderColor: "#bec8d9", railBgColor: "#f8fafc", railInset: 8, stepInset: 10, gripRadius: 10, gripWidth: 20, gripHeight: 20, gripBorder: 20, gripBorderWidth: 1, gripBorderColor: "#bec8d9", gripBgColor: "#f6f8fa", gripBgActiveColor: "#dbdde0", labelPadding: 8, labelOffset: 0, tickWidth: 1, tickColor: "#333", tickOffset: 25, tickLength: 7, minorTickOffset: 25, minorTickColor: "#333", minorTickLength: 4, currentValuePadding: 8, currentValueInset: 0 };
      }, 12343: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(85501), a = r2(75067), o = r2(98292).name, s = a.steps;
        function l(t3, e3, r3) {
          function o2(r4, i2) {
            return n2.coerce(t3, e3, a, r4, i2);
          }
          for (var s2 = i(t3, e3, { name: "steps", handleItemDefaults: u }), l2 = 0, c = 0; c < s2.length; c++)
            s2[c].visible && l2++;
          if (l2 < 2 ? e3.visible = false : o2("visible")) {
            e3._stepCount = l2;
            var f2 = e3._visibleSteps = n2.filterVisible(s2);
            (s2[o2("active")] || {}).visible || (e3.active = f2[0]._index), o2("x"), o2("y"), n2.noneOrAll(t3, e3, ["x", "y"]), o2("xanchor"), o2("yanchor"), o2("len"), o2("lenmode"), o2("pad.t"), o2("pad.r"), o2("pad.b"), o2("pad.l"), n2.coerceFont(o2, "font", r3.font), o2("currentvalue.visible") && (o2("currentvalue.xanchor"), o2("currentvalue.prefix"), o2("currentvalue.suffix"), o2("currentvalue.offset"), n2.coerceFont(o2, "currentvalue.font", e3.font)), o2("transition.duration"), o2("transition.easing"), o2("bgcolor"), o2("activebgcolor"), o2("bordercolor"), o2("borderwidth"), o2("ticklen"), o2("tickwidth"), o2("tickcolor"), o2("minorticklen");
          }
        }
        function u(t3, e3) {
          function r3(r4, i3) {
            return n2.coerce(t3, e3, s, r4, i3);
          }
          if ("skip" === t3.method || Array.isArray(t3.args) ? r3("visible") : e3.visible = false) {
            r3("method"), r3("args");
            var i2 = r3("label", "step-" + e3._index);
            r3("value", i2), r3("execute");
          }
        }
        t2.exports = function(t3, e3) {
          i(t3, e3, { name: o, handleItemDefaults: l });
        };
      }, 44504: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(74875), a = r2(7901), o = r2(91424), s = r2(71828), l = s.strTranslate, u = r2(63893), c = r2(44467).arrayEditor, f2 = r2(98292), h = r2(18783), p2 = h.LINE_SPACING, d2 = h.FROM_TL, v = h.FROM_BR;
        function g2(t3) {
          return f2.autoMarginIdRoot + t3._index;
        }
        function y(t3) {
          return t3._index;
        }
        function m2(t3, e3) {
          var r3 = o.tester.selectAll("g." + f2.labelGroupClass).data(e3._visibleSteps);
          r3.enter().append("g").classed(f2.labelGroupClass, true);
          var a2 = 0, l2 = 0;
          r3.each(function(t4) {
            var r4 = _(n2.select(this), { step: t4 }, e3).node();
            if (r4) {
              var i2 = o.bBox(r4);
              l2 = Math.max(l2, i2.height), a2 = Math.max(a2, i2.width);
            }
          }), r3.remove();
          var c2 = e3._dims = {};
          c2.inputAreaWidth = Math.max(f2.railWidth, f2.gripHeight);
          var h2 = t3._fullLayout._size;
          c2.lx = h2.l + h2.w * e3.x, c2.ly = h2.t + h2.h * (1 - e3.y), "fraction" === e3.lenmode ? c2.outerLength = Math.round(h2.w * e3.len) : c2.outerLength = e3.len, c2.inputAreaStart = 0, c2.inputAreaLength = Math.round(c2.outerLength - e3.pad.l - e3.pad.r);
          var p3 = (c2.inputAreaLength - 2 * f2.stepInset) / (e3._stepCount - 1), y2 = a2 + f2.labelPadding;
          if (c2.labelStride = Math.max(1, Math.ceil(y2 / p3)), c2.labelHeight = l2, c2.currentValueMaxWidth = 0, c2.currentValueHeight = 0, c2.currentValueTotalHeight = 0, c2.currentValueMaxLines = 1, e3.currentvalue.visible) {
            var m3 = o.tester.append("g");
            r3.each(function(t4) {
              var r4 = x(m3, e3, t4.label), n3 = r4.node() && o.bBox(r4.node()) || { width: 0, height: 0 }, i2 = u.lineCount(r4);
              c2.currentValueMaxWidth = Math.max(c2.currentValueMaxWidth, Math.ceil(n3.width)), c2.currentValueHeight = Math.max(c2.currentValueHeight, Math.ceil(n3.height)), c2.currentValueMaxLines = Math.max(c2.currentValueMaxLines, i2);
            }), c2.currentValueTotalHeight = c2.currentValueHeight + e3.currentvalue.offset, m3.remove();
          }
          c2.height = c2.currentValueTotalHeight + f2.tickOffset + e3.ticklen + f2.labelOffset + c2.labelHeight + e3.pad.t + e3.pad.b;
          var b2 = "left";
          s.isRightAnchor(e3) && (c2.lx -= c2.outerLength, b2 = "right"), s.isCenterAnchor(e3) && (c2.lx -= c2.outerLength / 2, b2 = "center");
          var w3 = "top";
          s.isBottomAnchor(e3) && (c2.ly -= c2.height, w3 = "bottom"), s.isMiddleAnchor(e3) && (c2.ly -= c2.height / 2, w3 = "middle"), c2.outerLength = Math.ceil(c2.outerLength), c2.height = Math.ceil(c2.height), c2.lx = Math.round(c2.lx), c2.ly = Math.round(c2.ly);
          var T2 = { y: e3.y, b: c2.height * v[w3], t: c2.height * d2[w3] };
          "fraction" === e3.lenmode ? (T2.l = 0, T2.xl = e3.x - e3.len * d2[b2], T2.r = 0, T2.xr = e3.x + e3.len * v[b2]) : (T2.x = e3.x, T2.l = c2.outerLength * d2[b2], T2.r = c2.outerLength * v[b2]), i.autoMargin(t3, g2(e3), T2);
        }
        function x(t3, e3, r3) {
          if (e3.currentvalue.visible) {
            var n3, i2, a2 = e3._dims;
            switch (e3.currentvalue.xanchor) {
              case "right":
                n3 = a2.inputAreaLength - f2.currentValueInset - a2.currentValueMaxWidth, i2 = "left";
                break;
              case "center":
                n3 = 0.5 * a2.inputAreaLength, i2 = "middle";
                break;
              default:
                n3 = f2.currentValueInset, i2 = "left";
            }
            var l2 = s.ensureSingle(t3, "text", f2.labelClass, function(t4) {
              t4.attr({ "text-anchor": i2, "data-notex": 1 });
            }), c2 = e3.currentvalue.prefix ? e3.currentvalue.prefix : "";
            if ("string" == typeof r3)
              c2 += r3;
            else {
              var h2 = e3.steps[e3.active].label, d3 = e3._gd._fullLayout._meta;
              d3 && (h2 = s.templateString(h2, d3)), c2 += h2;
            }
            e3.currentvalue.suffix && (c2 += e3.currentvalue.suffix), l2.call(o.font, e3.currentvalue.font).text(c2).call(u.convertToTspans, e3._gd);
            var v2 = u.lineCount(l2), g3 = (a2.currentValueMaxLines + 1 - v2) * e3.currentvalue.font.size * p2;
            return u.positionText(l2, n3, g3), l2;
          }
        }
        function b(t3, e3, r3) {
          s.ensureSingle(t3, "rect", f2.gripRectClass, function(n3) {
            n3.call(A, e3, t3, r3).style("pointer-events", "all");
          }).attr({ width: f2.gripWidth, height: f2.gripHeight, rx: f2.gripRadius, ry: f2.gripRadius }).call(a.stroke, r3.bordercolor).call(a.fill, r3.bgcolor).style("stroke-width", r3.borderwidth + "px");
        }
        function _(t3, e3, r3) {
          var n3 = s.ensureSingle(t3, "text", f2.labelClass, function(t4) {
            t4.attr({ "text-anchor": "middle", "data-notex": 1 });
          }), i2 = e3.step.label, a2 = r3._gd._fullLayout._meta;
          return a2 && (i2 = s.templateString(i2, a2)), n3.call(o.font, r3.font).text(i2).call(u.convertToTspans, r3._gd), n3;
        }
        function w2(t3, e3) {
          var r3 = s.ensureSingle(t3, "g", f2.labelsClass), i2 = e3._dims, a2 = r3.selectAll("g." + f2.labelGroupClass).data(i2.labelSteps);
          a2.enter().append("g").classed(f2.labelGroupClass, true), a2.exit().remove(), a2.each(function(t4) {
            var r4 = n2.select(this);
            r4.call(_, t4, e3), o.setTranslate(r4, E(e3, t4.fraction), f2.tickOffset + e3.ticklen + e3.font.size * p2 + f2.labelOffset + i2.currentValueTotalHeight);
          });
        }
        function T(t3, e3, r3, n3, i2) {
          var a2 = Math.round(n3 * (r3._stepCount - 1)), o2 = r3._visibleSteps[a2]._index;
          o2 !== r3.active && k(t3, e3, r3, o2, true, i2);
        }
        function k(t3, e3, r3, n3, a2, o2) {
          var s2 = r3.active;
          r3.active = n3, c(t3.layout, f2.name, r3).applyUpdate("active", n3);
          var l2 = r3.steps[r3.active];
          e3.call(S, r3, o2), e3.call(x, r3), t3.emit("plotly_sliderchange", { slider: r3, step: r3.steps[r3.active], interaction: a2, previousActive: s2 }), l2 && l2.method && a2 && (e3._nextMethod ? (e3._nextMethod.step = l2, e3._nextMethod.doCallback = a2, e3._nextMethod.doTransition = o2) : (e3._nextMethod = { step: l2, doCallback: a2, doTransition: o2 }, e3._nextMethodRaf = window.requestAnimationFrame(function() {
            var r4 = e3._nextMethod.step;
            r4.method && (r4.execute && i.executeAPICommand(t3, r4.method, r4.args), e3._nextMethod = null, e3._nextMethodRaf = null);
          })));
        }
        function A(t3, e3, r3) {
          if (!e3._context.staticPlot) {
            var i2 = r3.node(), o2 = n2.select(e3);
            t3.on("mousedown", l2), t3.on("touchstart", l2);
          }
          function s2() {
            return r3.data()[0];
          }
          function l2() {
            var t4 = s2();
            e3.emit("plotly_sliderstart", { slider: t4 });
            var l3 = r3.select("." + f2.gripRectClass);
            n2.event.stopPropagation(), n2.event.preventDefault(), l3.call(a.fill, t4.activebgcolor);
            var u2 = L(t4, n2.mouse(i2)[0]);
            function c2() {
              var t5 = s2(), a2 = L(t5, n2.mouse(i2)[0]);
              T(e3, r3, t5, a2, false);
            }
            function h2() {
              var t5 = s2();
              t5._dragging = false, l3.call(a.fill, t5.bgcolor), o2.on("mouseup", null), o2.on("mousemove", null), o2.on("touchend", null), o2.on("touchmove", null), e3.emit("plotly_sliderend", { slider: t5, step: t5.steps[t5.active] });
            }
            T(e3, r3, t4, u2, true), t4._dragging = true, o2.on("mousemove", c2), o2.on("touchmove", c2), o2.on("mouseup", h2), o2.on("touchend", h2);
          }
        }
        function M(t3, e3) {
          var r3 = t3.selectAll("rect." + f2.tickRectClass).data(e3._visibleSteps), i2 = e3._dims;
          r3.enter().append("rect").classed(f2.tickRectClass, true), r3.exit().remove(), r3.attr({ width: e3.tickwidth + "px", "shape-rendering": "crispEdges" }), r3.each(function(t4, r4) {
            var s2 = r4 % i2.labelStride == 0, l2 = n2.select(this);
            l2.attr({ height: s2 ? e3.ticklen : e3.minorticklen }).call(a.fill, e3.tickcolor), o.setTranslate(l2, E(e3, r4 / (e3._stepCount - 1)) - 0.5 * e3.tickwidth, (s2 ? f2.tickOffset : f2.minorTickOffset) + i2.currentValueTotalHeight);
          });
        }
        function S(t3, e3, r3) {
          for (var n3 = t3.select("rect." + f2.gripRectClass), i2 = 0, a2 = 0; a2 < e3._stepCount; a2++)
            if (e3._visibleSteps[a2]._index === e3.active) {
              i2 = a2;
              break;
            }
          var o2 = E(e3, i2 / (e3._stepCount - 1));
          if (!e3._invokingCommand) {
            var s2 = n3;
            r3 && e3.transition.duration > 0 && (s2 = s2.transition().duration(e3.transition.duration).ease(e3.transition.easing)), s2.attr("transform", l(o2 - 0.5 * f2.gripWidth, e3._dims.currentValueTotalHeight));
          }
        }
        function E(t3, e3) {
          var r3 = t3._dims;
          return r3.inputAreaStart + f2.stepInset + (r3.inputAreaLength - 2 * f2.stepInset) * Math.min(1, Math.max(0, e3));
        }
        function L(t3, e3) {
          var r3 = t3._dims;
          return Math.min(1, Math.max(0, (e3 - f2.stepInset - r3.inputAreaStart) / (r3.inputAreaLength - 2 * f2.stepInset - 2 * r3.inputAreaStart)));
        }
        function C(t3, e3, r3) {
          var n3 = r3._dims, i2 = s.ensureSingle(t3, "rect", f2.railTouchRectClass, function(n4) {
            n4.call(A, e3, t3, r3).style("pointer-events", "all");
          });
          i2.attr({ width: n3.inputAreaLength, height: Math.max(n3.inputAreaWidth, f2.tickOffset + r3.ticklen + n3.labelHeight) }).call(a.fill, r3.bgcolor).attr("opacity", 0), o.setTranslate(i2, 0, n3.currentValueTotalHeight);
        }
        function P(t3, e3) {
          var r3 = e3._dims, n3 = r3.inputAreaLength - 2 * f2.railInset, i2 = s.ensureSingle(t3, "rect", f2.railRectClass);
          i2.attr({ width: n3, height: f2.railWidth, rx: f2.railRadius, ry: f2.railRadius, "shape-rendering": "crispEdges" }).call(a.stroke, e3.bordercolor).call(a.fill, e3.bgcolor).style("stroke-width", e3.borderwidth + "px"), o.setTranslate(i2, f2.railInset, 0.5 * (r3.inputAreaWidth - f2.railWidth) + r3.currentValueTotalHeight);
        }
        t2.exports = function(t3) {
          var e3 = t3._context.staticPlot, r3 = t3._fullLayout, a2 = function(t4, e4) {
            for (var r4 = t4[f2.name], n3 = [], i2 = 0; i2 < r4.length; i2++) {
              var a3 = r4[i2];
              a3.visible && (a3._gd = e4, n3.push(a3));
            }
            return n3;
          }(r3, t3), s2 = r3._infolayer.selectAll("g." + f2.containerClassName).data(a2.length > 0 ? [0] : []);
          function l2(e4) {
            e4._commandObserver && (e4._commandObserver.remove(), delete e4._commandObserver), i.autoMargin(t3, g2(e4));
          }
          if (s2.enter().append("g").classed(f2.containerClassName, true).style("cursor", e3 ? null : "ew-resize"), s2.exit().each(function() {
            n2.select(this).selectAll("g." + f2.groupClassName).each(l2);
          }).remove(), 0 !== a2.length) {
            var u2 = s2.selectAll("g." + f2.groupClassName).data(a2, y);
            u2.enter().append("g").classed(f2.groupClassName, true), u2.exit().each(l2).remove();
            for (var c2 = 0; c2 < a2.length; c2++) {
              var h2 = a2[c2];
              m2(t3, h2);
            }
            u2.each(function(e4) {
              var r4 = n2.select(this);
              !function(t4) {
                var e5 = t4._dims;
                e5.labelSteps = [];
                for (var r5 = t4._stepCount, n3 = 0; n3 < r5; n3 += e5.labelStride)
                  e5.labelSteps.push({ fraction: n3 / (r5 - 1), step: t4._visibleSteps[n3] });
              }(e4), i.manageCommandObserver(t3, e4, e4._visibleSteps, function(e5) {
                var n3 = r4.data()[0];
                n3.active !== e5.index && (n3._dragging || k(t3, r4, n3, e5.index, false, true));
              }), function(t4, e5, r5) {
                (r5.steps[r5.active] || {}).visible || (r5.active = r5._visibleSteps[0]._index), e5.call(x, r5).call(P, r5).call(w2, r5).call(M, r5).call(C, t4, r5).call(b, t4, r5);
                var n3 = r5._dims;
                o.setTranslate(e5, n3.lx + r5.pad.l, n3.ly + r5.pad.t), e5.call(S, r5, false), e5.call(x, r5);
              }(t3, n2.select(this), e4);
            });
          }
        };
      }, 23243: function(t2, e2, r2) {
        var n2 = r2(98292);
        t2.exports = { moduleType: "component", name: n2.name, layoutAttributes: r2(75067), supplyLayoutDefaults: r2(12343), draw: r2(44504) };
      }, 92998: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(92770), a = r2(74875), o = r2(73972), s = r2(71828), l = s.strTranslate, u = r2(91424), c = r2(7901), f2 = r2(63893), h = r2(37822), p2 = r2(18783).OPPOSITE_SIDE, d2 = / [XY][0-9]* /;
        t2.exports = { draw: function(t3, e3, r3) {
          var v, g2 = r3.propContainer, y = r3.propName, m2 = r3.placeholder, x = r3.traceIndex, b = r3.avoid || {}, _ = r3.attributes, w2 = r3.transform, T = r3.containerGroup, k = t3._fullLayout, A = 1, M = false, S = g2.title, E = (S && S.text ? S.text : "").trim(), L = S && S.font ? S.font : {}, C = L.family, P = L.size, O = L.color;
          "title.text" === y ? v = "titleText" : -1 !== y.indexOf("axis") ? v = "axisTitleText" : y.indexOf(true) && (v = "colorbarTitleText");
          var I = t3._context.edits[v];
          "" === E ? A = 0 : E.replace(d2, " % ") === m2.replace(d2, " % ") && (A = 0.2, M = true, I || (E = "")), r3._meta ? E = s.templateString(E, r3._meta) : k._meta && (E = s.templateString(E, k._meta));
          var D, z = E || I;
          T || (T = s.ensureSingle(k._infolayer, "g", "g-" + e3), D = k._hColorbarMoveTitle);
          var R = T.selectAll("text").data(z ? [0] : []);
          if (R.enter().append("text"), R.text(E).attr("class", e3), R.exit().remove(), !z)
            return T;
          function F(t4) {
            s.syncOrAsync([B, N], t4);
          }
          function B(e4) {
            var r4;
            return !w2 && D && (w2 = {}), w2 ? (r4 = "", w2.rotate && (r4 += "rotate(" + [w2.rotate, _.x, _.y] + ")"), (w2.offset || D) && (r4 += l(0, (w2.offset || 0) - (D || 0)))) : r4 = null, e4.attr("transform", r4), e4.style({ "font-family": C, "font-size": n2.round(P, 2) + "px", fill: c.rgb(O), opacity: A * c.opacity(O), "font-weight": a.fontWeight }).attr(_).call(f2.convertToTspans, t3), a.previousPromises(t3);
          }
          function N(e4) {
            var r4 = n2.select(e4.node().parentNode);
            if (b && b.selection && b.side && E) {
              r4.attr("transform", null);
              var a2 = p2[b.side], o2 = "left" === b.side || "top" === b.side ? -1 : 1, c2 = i(b.pad) ? b.pad : 2, f3 = u.bBox(r4.node()), h2 = { t: 0, b: 0, l: 0, r: 0 }, d3 = t3._fullLayout._reservedMargin;
              for (var v2 in d3)
                for (var y2 in d3[v2]) {
                  var m3 = d3[v2][y2];
                  h2[y2] = Math.max(h2[y2], m3);
                }
              var x2 = { left: h2.l, top: h2.t, right: k.width - h2.r, bottom: k.height - h2.b }, _2 = b.maxShift || o2 * (x2[b.side] - f3[b.side]), w3 = 0;
              if (_2 < 0)
                w3 = _2;
              else {
                var T2 = b.offsetLeft || 0, A2 = b.offsetTop || 0;
                f3.left -= T2, f3.right -= T2, f3.top -= A2, f3.bottom -= A2, b.selection.each(function() {
                  var t4 = u.bBox(this);
                  s.bBoxIntersect(f3, t4, c2) && (w3 = Math.max(w3, o2 * (t4[b.side] - f3[a2]) + c2));
                }), w3 = Math.min(_2, w3), g2._titleScoot = Math.abs(w3);
              }
              if (w3 > 0 || _2 < 0) {
                var M2 = { left: [-w3, 0], right: [w3, 0], top: [0, -w3], bottom: [0, w3] }[b.side];
                r4.attr("transform", l(M2[0], M2[1]));
              }
            }
          }
          return R.call(F), I && (E ? R.on(".opacity", null) : (A = 0, M = true, R.text(m2).on("mouseover.opacity", function() {
            n2.select(this).transition().duration(h.SHOW_PLACEHOLDER).style("opacity", 1);
          }).on("mouseout.opacity", function() {
            n2.select(this).transition().duration(h.HIDE_PLACEHOLDER).style("opacity", 0);
          })), R.call(f2.makeEditable, { gd: t3 }).on("edit", function(e4) {
            void 0 !== x ? o.call("_guiRestyle", t3, y, e4, x) : o.call("_guiRelayout", t3, y, e4);
          }).on("cancel", function() {
            this.text(this.attr("data-unformatted")).call(F);
          }).on("input", function(t4) {
            this.text(t4 || " ").call(f2.positionText, _.x, _.y);
          })), R.classed("js-placeholder", M), T;
        } };
      }, 7163: function(t2, e2, r2) {
        var n2 = r2(41940), i = r2(22399), a = r2(1426).extendFlat, o = r2(30962).overrideAll, s = r2(35025), l = r2(44467).templatedArray, u = l("button", { visible: { valType: "boolean" }, method: { valType: "enumerated", values: ["restyle", "relayout", "animate", "update", "skip"], dflt: "restyle" }, args: { valType: "info_array", freeLength: true, items: [{ valType: "any" }, { valType: "any" }, { valType: "any" }] }, args2: { valType: "info_array", freeLength: true, items: [{ valType: "any" }, { valType: "any" }, { valType: "any" }] }, label: { valType: "string", dflt: "" }, execute: { valType: "boolean", dflt: true } });
        t2.exports = o(l("updatemenu", { _arrayAttrRegexps: [/^updatemenus\[(0|[1-9][0-9]+)\]\.buttons/], visible: { valType: "boolean" }, type: { valType: "enumerated", values: ["dropdown", "buttons"], dflt: "dropdown" }, direction: { valType: "enumerated", values: ["left", "right", "up", "down"], dflt: "down" }, active: { valType: "integer", min: -1, dflt: 0 }, showactive: { valType: "boolean", dflt: true }, buttons: u, x: { valType: "number", min: -2, max: 3, dflt: -0.05 }, xanchor: { valType: "enumerated", values: ["auto", "left", "center", "right"], dflt: "right" }, y: { valType: "number", min: -2, max: 3, dflt: 1 }, yanchor: { valType: "enumerated", values: ["auto", "top", "middle", "bottom"], dflt: "top" }, pad: a(s({ editType: "arraydraw" }), {}), font: n2({}), bgcolor: { valType: "color" }, bordercolor: { valType: "color", dflt: i.borderLine }, borderwidth: { valType: "number", min: 0, dflt: 1, editType: "arraydraw" } }), "arraydraw", "from-root");
      }, 75909: function(t2) {
        t2.exports = { name: "updatemenus", containerClassName: "updatemenu-container", headerGroupClassName: "updatemenu-header-group", headerClassName: "updatemenu-header", headerArrowClassName: "updatemenu-header-arrow", dropdownButtonGroupClassName: "updatemenu-dropdown-button-group", dropdownButtonClassName: "updatemenu-dropdown-button", buttonClassName: "updatemenu-button", itemRectClassName: "updatemenu-item-rect", itemTextClassName: "updatemenu-item-text", menuIndexAttrName: "updatemenu-active-index", autoMarginIdRoot: "updatemenu-", blankHeaderOpts: { label: "  " }, minWidth: 30, minHeight: 30, textPadX: 24, arrowPadX: 16, rx: 2, ry: 2, textOffsetX: 12, textOffsetY: 3, arrowOffsetX: 4, gapButtonHeader: 5, gapButton: 2, activeColor: "#F4FAFF", hoverColor: "#F4FAFF", arrowSymbol: { left: "◄", right: "►", up: "▲", down: "▼" } };
      }, 64897: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(85501), a = r2(7163), o = r2(75909).name, s = a.buttons;
        function l(t3, e3, r3) {
          function o2(r4, i2) {
            return n2.coerce(t3, e3, a, r4, i2);
          }
          o2("visible", i(t3, e3, { name: "buttons", handleItemDefaults: u }).length > 0) && (o2("active"), o2("direction"), o2("type"), o2("showactive"), o2("x"), o2("y"), n2.noneOrAll(t3, e3, ["x", "y"]), o2("xanchor"), o2("yanchor"), o2("pad.t"), o2("pad.r"), o2("pad.b"), o2("pad.l"), n2.coerceFont(o2, "font", r3.font), o2("bgcolor", r3.paper_bgcolor), o2("bordercolor"), o2("borderwidth"));
        }
        function u(t3, e3) {
          function r3(r4, i2) {
            return n2.coerce(t3, e3, s, r4, i2);
          }
          r3("visible", "skip" === t3.method || Array.isArray(t3.args)) && (r3("method"), r3("args"), r3("args2"), r3("label"), r3("execute"));
        }
        t2.exports = function(t3, e3) {
          i(t3, e3, { name: o, handleItemDefaults: l });
        };
      }, 13689: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(74875), a = r2(7901), o = r2(91424), s = r2(71828), l = r2(63893), u = r2(44467).arrayEditor, c = r2(18783).LINE_SPACING, f2 = r2(75909), h = r2(25849);
        function p2(t3) {
          return t3._index;
        }
        function d2(t3, e3) {
          return +t3.attr(f2.menuIndexAttrName) === e3._index;
        }
        function v(t3, e3, r3, n3, i2, a2, o2, s2) {
          e3.active = o2, u(t3.layout, f2.name, e3).applyUpdate("active", o2), "buttons" === e3.type ? y(t3, n3, null, null, e3) : "dropdown" === e3.type && (i2.attr(f2.menuIndexAttrName, "-1"), g2(t3, n3, i2, a2, e3), s2 || y(t3, n3, i2, a2, e3));
        }
        function g2(t3, e3, r3, n3, i2) {
          var a2 = s.ensureSingle(e3, "g", f2.headerClassName, function(t4) {
            t4.style("pointer-events", "all");
          }), l2 = i2._dims, u2 = i2.active, c2 = i2.buttons[u2] || f2.blankHeaderOpts, h2 = { y: i2.pad.t, yPad: 0, x: i2.pad.l, xPad: 0, index: 0 }, p3 = { width: l2.headerWidth, height: l2.headerHeight };
          a2.call(m2, i2, c2, t3).call(M, i2, h2, p3), s.ensureSingle(e3, "text", f2.headerArrowClassName, function(t4) {
            t4.attr("text-anchor", "end").call(o.font, i2.font).text(f2.arrowSymbol[i2.direction]);
          }).attr({ x: l2.headerWidth - f2.arrowOffsetX + i2.pad.l, y: l2.headerHeight / 2 + f2.textOffsetY + i2.pad.t }), a2.on("click", function() {
            r3.call(S, String(d2(r3, i2) ? -1 : i2._index)), y(t3, e3, r3, n3, i2);
          }), a2.on("mouseover", function() {
            a2.call(w2);
          }), a2.on("mouseout", function() {
            a2.call(T, i2);
          }), o.setTranslate(e3, l2.lx, l2.ly);
        }
        function y(t3, e3, r3, a2, o2) {
          r3 || (r3 = e3).attr("pointer-events", "all");
          var l2 = function(t4) {
            return -1 == +t4.attr(f2.menuIndexAttrName);
          }(r3) && "buttons" !== o2.type ? [] : o2.buttons, u2 = "dropdown" === o2.type ? f2.dropdownButtonClassName : f2.buttonClassName, c2 = r3.selectAll("g." + u2).data(s.filterVisible(l2)), h2 = c2.enter().append("g").classed(u2, true), p3 = c2.exit();
          "dropdown" === o2.type ? (h2.attr("opacity", "0").transition().attr("opacity", "1"), p3.transition().attr("opacity", "0").remove()) : p3.remove();
          var d3 = 0, g3 = 0, y2 = o2._dims, x2 = -1 !== ["up", "down"].indexOf(o2.direction);
          "dropdown" === o2.type && (x2 ? g3 = y2.headerHeight + f2.gapButtonHeader : d3 = y2.headerWidth + f2.gapButtonHeader), "dropdown" === o2.type && "up" === o2.direction && (g3 = -f2.gapButtonHeader + f2.gapButton - y2.openHeight), "dropdown" === o2.type && "left" === o2.direction && (d3 = -f2.gapButtonHeader + f2.gapButton - y2.openWidth);
          var b2 = { x: y2.lx + d3 + o2.pad.l, y: y2.ly + g3 + o2.pad.t, yPad: f2.gapButton, xPad: f2.gapButton, index: 0 }, k2 = { l: b2.x + o2.borderwidth, t: b2.y + o2.borderwidth };
          c2.each(function(s2, l3) {
            var u3 = n2.select(this);
            u3.call(m2, o2, s2, t3).call(M, o2, b2), u3.on("click", function() {
              n2.event.defaultPrevented || (s2.execute && (s2.args2 && o2.active === l3 ? (v(t3, o2, 0, e3, r3, a2, -1), i.executeAPICommand(t3, s2.method, s2.args2)) : (v(t3, o2, 0, e3, r3, a2, l3), i.executeAPICommand(t3, s2.method, s2.args))), t3.emit("plotly_buttonclicked", { menu: o2, button: s2, active: o2.active }));
            }), u3.on("mouseover", function() {
              u3.call(w2);
            }), u3.on("mouseout", function() {
              u3.call(T, o2), c2.call(_, o2);
            });
          }), c2.call(_, o2), x2 ? (k2.w = Math.max(y2.openWidth, y2.headerWidth), k2.h = b2.y - k2.t) : (k2.w = b2.x - k2.l, k2.h = Math.max(y2.openHeight, y2.headerHeight)), k2.direction = o2.direction, a2 && (c2.size() ? function(t4, e4, r4, n3, i2, a3) {
            var o3, s2, l3, u3 = i2.direction, c3 = "up" === u3 || "down" === u3, h3 = i2._dims, p4 = i2.active;
            if (c3)
              for (s2 = 0, l3 = 0; l3 < p4; l3++)
                s2 += h3.heights[l3] + f2.gapButton;
            else
              for (o3 = 0, l3 = 0; l3 < p4; l3++)
                o3 += h3.widths[l3] + f2.gapButton;
            n3.enable(a3, o3, s2), n3.hbar && n3.hbar.attr("opacity", "0").transition().attr("opacity", "1"), n3.vbar && n3.vbar.attr("opacity", "0").transition().attr("opacity", "1");
          }(0, 0, 0, a2, o2, k2) : function(t4) {
            var e4 = !!t4.hbar, r4 = !!t4.vbar;
            e4 && t4.hbar.transition().attr("opacity", "0").each("end", function() {
              e4 = false, r4 || t4.disable();
            }), r4 && t4.vbar.transition().attr("opacity", "0").each("end", function() {
              r4 = false, e4 || t4.disable();
            });
          }(a2));
        }
        function m2(t3, e3, r3, n3) {
          t3.call(x, e3).call(b, e3, r3, n3);
        }
        function x(t3, e3) {
          s.ensureSingle(t3, "rect", f2.itemRectClassName, function(t4) {
            t4.attr({ rx: f2.rx, ry: f2.ry, "shape-rendering": "crispEdges" });
          }).call(a.stroke, e3.bordercolor).call(a.fill, e3.bgcolor).style("stroke-width", e3.borderwidth + "px");
        }
        function b(t3, e3, r3, n3) {
          var i2 = s.ensureSingle(t3, "text", f2.itemTextClassName, function(t4) {
            t4.attr({ "text-anchor": "start", "data-notex": 1 });
          }), a2 = r3.label, u2 = n3._fullLayout._meta;
          u2 && (a2 = s.templateString(a2, u2)), i2.call(o.font, e3.font).text(a2).call(l.convertToTspans, n3);
        }
        function _(t3, e3) {
          var r3 = e3.active;
          t3.each(function(t4, i2) {
            var o2 = n2.select(this);
            i2 === r3 && e3.showactive && o2.select("rect." + f2.itemRectClassName).call(a.fill, f2.activeColor);
          });
        }
        function w2(t3) {
          t3.select("rect." + f2.itemRectClassName).call(a.fill, f2.hoverColor);
        }
        function T(t3, e3) {
          t3.select("rect." + f2.itemRectClassName).call(a.fill, e3.bgcolor);
        }
        function k(t3, e3) {
          var r3 = e3._dims = { width1: 0, height1: 0, heights: [], widths: [], totalWidth: 0, totalHeight: 0, openWidth: 0, openHeight: 0, lx: 0, ly: 0 }, a2 = o.tester.selectAll("g." + f2.dropdownButtonClassName).data(s.filterVisible(e3.buttons));
          a2.enter().append("g").classed(f2.dropdownButtonClassName, true);
          var u2 = -1 !== ["up", "down"].indexOf(e3.direction);
          a2.each(function(i2, a3) {
            var s2 = n2.select(this);
            s2.call(m2, e3, i2, t3);
            var h3 = s2.select("." + f2.itemTextClassName), p4 = h3.node() && o.bBox(h3.node()).width, d4 = Math.max(p4 + f2.textPadX, f2.minWidth), v3 = e3.font.size * c, g4 = l.lineCount(h3), y2 = Math.max(v3 * g4, f2.minHeight) + f2.textOffsetY;
            y2 = Math.ceil(y2), d4 = Math.ceil(d4), r3.widths[a3] = d4, r3.heights[a3] = y2, r3.height1 = Math.max(r3.height1, y2), r3.width1 = Math.max(r3.width1, d4), u2 ? (r3.totalWidth = Math.max(r3.totalWidth, d4), r3.openWidth = r3.totalWidth, r3.totalHeight += y2 + f2.gapButton, r3.openHeight += y2 + f2.gapButton) : (r3.totalWidth += d4 + f2.gapButton, r3.openWidth += d4 + f2.gapButton, r3.totalHeight = Math.max(r3.totalHeight, y2), r3.openHeight = r3.totalHeight);
          }), u2 ? r3.totalHeight -= f2.gapButton : r3.totalWidth -= f2.gapButton, r3.headerWidth = r3.width1 + f2.arrowPadX, r3.headerHeight = r3.height1, "dropdown" === e3.type && (u2 ? (r3.width1 += f2.arrowPadX, r3.totalHeight = r3.height1) : r3.totalWidth = r3.width1, r3.totalWidth += f2.arrowPadX), a2.remove();
          var h2 = r3.totalWidth + e3.pad.l + e3.pad.r, p3 = r3.totalHeight + e3.pad.t + e3.pad.b, d3 = t3._fullLayout._size;
          r3.lx = d3.l + d3.w * e3.x, r3.ly = d3.t + d3.h * (1 - e3.y);
          var v2 = "left";
          s.isRightAnchor(e3) && (r3.lx -= h2, v2 = "right"), s.isCenterAnchor(e3) && (r3.lx -= h2 / 2, v2 = "center");
          var g3 = "top";
          s.isBottomAnchor(e3) && (r3.ly -= p3, g3 = "bottom"), s.isMiddleAnchor(e3) && (r3.ly -= p3 / 2, g3 = "middle"), r3.totalWidth = Math.ceil(r3.totalWidth), r3.totalHeight = Math.ceil(r3.totalHeight), r3.lx = Math.round(r3.lx), r3.ly = Math.round(r3.ly), i.autoMargin(t3, A(e3), { x: e3.x, y: e3.y, l: h2 * ({ right: 1, center: 0.5 }[v2] || 0), r: h2 * ({ left: 1, center: 0.5 }[v2] || 0), b: p3 * ({ top: 1, middle: 0.5 }[g3] || 0), t: p3 * ({ bottom: 1, middle: 0.5 }[g3] || 0) });
        }
        function A(t3) {
          return f2.autoMarginIdRoot + t3._index;
        }
        function M(t3, e3, r3, n3) {
          n3 = n3 || {};
          var i2 = t3.select("." + f2.itemRectClassName), a2 = t3.select("." + f2.itemTextClassName), s2 = e3.borderwidth, u2 = r3.index, h2 = e3._dims;
          o.setTranslate(t3, s2 + r3.x, s2 + r3.y);
          var p3 = -1 !== ["up", "down"].indexOf(e3.direction), d3 = n3.height || (p3 ? h2.heights[u2] : h2.height1);
          i2.attr({ x: 0, y: 0, width: n3.width || (p3 ? h2.width1 : h2.widths[u2]), height: d3 });
          var v2 = e3.font.size * c, g3 = (l.lineCount(a2) - 1) * v2 / 2;
          l.positionText(a2, f2.textOffsetX, d3 / 2 - g3 + f2.textOffsetY), p3 ? r3.y += h2.heights[u2] + r3.yPad : r3.x += h2.widths[u2] + r3.xPad, r3.index++;
        }
        function S(t3, e3) {
          t3.attr(f2.menuIndexAttrName, e3 || "-1").selectAll("g." + f2.dropdownButtonClassName).remove();
        }
        t2.exports = function(t3) {
          var e3 = t3._fullLayout, r3 = s.filterVisible(e3[f2.name]);
          function a2(e4) {
            i.autoMargin(t3, A(e4));
          }
          var o2 = e3._menulayer.selectAll("g." + f2.containerClassName).data(r3.length > 0 ? [0] : []);
          if (o2.enter().append("g").classed(f2.containerClassName, true).style("cursor", "pointer"), o2.exit().each(function() {
            n2.select(this).selectAll("g." + f2.headerGroupClassName).each(a2);
          }).remove(), 0 !== r3.length) {
            var l2 = o2.selectAll("g." + f2.headerGroupClassName).data(r3, p2);
            l2.enter().append("g").classed(f2.headerGroupClassName, true);
            for (var u2 = s.ensureSingle(o2, "g", f2.dropdownButtonGroupClassName, function(t4) {
              t4.style("pointer-events", "all");
            }), c2 = 0; c2 < r3.length; c2++) {
              var m3 = r3[c2];
              k(t3, m3);
            }
            var x2 = "updatemenus" + e3._uid, b2 = new h(t3, u2, x2);
            l2.enter().size() && (u2.node().parentNode.appendChild(u2.node()), u2.call(S)), l2.exit().each(function(t4) {
              u2.call(S), a2(t4);
            }).remove(), l2.each(function(e4) {
              var r4 = n2.select(this), a3 = "dropdown" === e4.type ? u2 : null;
              i.manageCommandObserver(t3, e4, e4.buttons, function(n3) {
                v(t3, e4, e4.buttons[n3.index], r4, a3, b2, n3.index, true);
              }), "dropdown" === e4.type ? (g2(t3, r4, u2, b2, e4), d2(u2, e4) && y(t3, r4, u2, b2, e4)) : y(t3, r4, null, null, e4);
            });
          }
        };
      }, 20763: function(t2, e2, r2) {
        var n2 = r2(75909);
        t2.exports = { moduleType: "component", name: n2.name, layoutAttributes: r2(7163), supplyLayoutDefaults: r2(64897), draw: r2(13689) };
      }, 25849: function(t2, e2, r2) {
        t2.exports = s;
        var n2 = r2(39898), i = r2(7901), a = r2(91424), o = r2(71828);
        function s(t3, e3, r3) {
          this.gd = t3, this.container = e3, this.id = r3, this.position = null, this.translateX = null, this.translateY = null, this.hbar = null, this.vbar = null, this.bg = this.container.selectAll("rect.scrollbox-bg").data([0]), this.bg.exit().on(".drag", null).on("wheel", null).remove(), this.bg.enter().append("rect").classed("scrollbox-bg", true).style("pointer-events", "all").attr({ opacity: 0, x: 0, y: 0, width: 0, height: 0 });
        }
        s.barWidth = 2, s.barLength = 20, s.barRadius = 2, s.barPad = 1, s.barColor = "#808BA4", s.prototype.enable = function(t3, e3, r3) {
          var o2 = this.gd._fullLayout, l = o2.width, u = o2.height;
          this.position = t3;
          var c, f2, h, p2, d2 = this.position.l, v = this.position.w, g2 = this.position.t, y = this.position.h, m2 = this.position.direction, x = "down" === m2, b = "left" === m2, _ = "up" === m2, w2 = v, T = y;
          x || b || "right" === m2 || _ || (this.position.direction = "down", x = true), x || _ ? (f2 = (c = d2) + w2, x ? (h = g2, T = (p2 = Math.min(h + T, u)) - h) : T = (p2 = g2 + T) - (h = Math.max(p2 - T, 0))) : (p2 = (h = g2) + T, b ? w2 = (f2 = d2 + w2) - (c = Math.max(f2 - w2, 0)) : (c = d2, w2 = (f2 = Math.min(c + w2, l)) - c)), this._box = { l: c, t: h, w: w2, h: T };
          var k = v > w2, A = s.barLength + 2 * s.barPad, M = s.barWidth + 2 * s.barPad, S = d2, E = g2 + y;
          E + M > u && (E = u - M);
          var L = this.container.selectAll("rect.scrollbar-horizontal").data(k ? [0] : []);
          L.exit().on(".drag", null).remove(), L.enter().append("rect").classed("scrollbar-horizontal", true).call(i.fill, s.barColor), k ? (this.hbar = L.attr({ rx: s.barRadius, ry: s.barRadius, x: S, y: E, width: A, height: M }), this._hbarXMin = S + A / 2, this._hbarTranslateMax = w2 - A) : (delete this.hbar, delete this._hbarXMin, delete this._hbarTranslateMax);
          var C = y > T, P = s.barWidth + 2 * s.barPad, O = s.barLength + 2 * s.barPad, I = d2 + v, D = g2;
          I + P > l && (I = l - P);
          var z = this.container.selectAll("rect.scrollbar-vertical").data(C ? [0] : []);
          z.exit().on(".drag", null).remove(), z.enter().append("rect").classed("scrollbar-vertical", true).call(i.fill, s.barColor), C ? (this.vbar = z.attr({ rx: s.barRadius, ry: s.barRadius, x: I, y: D, width: P, height: O }), this._vbarYMin = D + O / 2, this._vbarTranslateMax = T - O) : (delete this.vbar, delete this._vbarYMin, delete this._vbarTranslateMax);
          var R = this.id, F = c - 0.5, B = C ? f2 + P + 0.5 : f2 + 0.5, N = h - 0.5, j = k ? p2 + M + 0.5 : p2 + 0.5, U = o2._topdefs.selectAll("#" + R).data(k || C ? [0] : []);
          if (U.exit().remove(), U.enter().append("clipPath").attr("id", R).append("rect"), k || C ? (this._clipRect = U.select("rect").attr({ x: Math.floor(F), y: Math.floor(N), width: Math.ceil(B) - Math.floor(F), height: Math.ceil(j) - Math.floor(N) }), this.container.call(a.setClipUrl, R, this.gd), this.bg.attr({ x: d2, y: g2, width: v, height: y })) : (this.bg.attr({ width: 0, height: 0 }), this.container.on("wheel", null).on(".drag", null).call(a.setClipUrl, null), delete this._clipRect), k || C) {
            var V = n2.behavior.drag().on("dragstart", function() {
              n2.event.sourceEvent.preventDefault();
            }).on("drag", this._onBoxDrag.bind(this));
            this.container.on("wheel", null).on("wheel", this._onBoxWheel.bind(this)).on(".drag", null).call(V);
            var H = n2.behavior.drag().on("dragstart", function() {
              n2.event.sourceEvent.preventDefault(), n2.event.sourceEvent.stopPropagation();
            }).on("drag", this._onBarDrag.bind(this));
            k && this.hbar.on(".drag", null).call(H), C && this.vbar.on(".drag", null).call(H);
          }
          this.setTranslate(e3, r3);
        }, s.prototype.disable = function() {
          (this.hbar || this.vbar) && (this.bg.attr({ width: 0, height: 0 }), this.container.on("wheel", null).on(".drag", null).call(a.setClipUrl, null), delete this._clipRect), this.hbar && (this.hbar.on(".drag", null), this.hbar.remove(), delete this.hbar, delete this._hbarXMin, delete this._hbarTranslateMax), this.vbar && (this.vbar.on(".drag", null), this.vbar.remove(), delete this.vbar, delete this._vbarYMin, delete this._vbarTranslateMax);
        }, s.prototype._onBoxDrag = function() {
          var t3 = this.translateX, e3 = this.translateY;
          this.hbar && (t3 -= n2.event.dx), this.vbar && (e3 -= n2.event.dy), this.setTranslate(t3, e3);
        }, s.prototype._onBoxWheel = function() {
          var t3 = this.translateX, e3 = this.translateY;
          this.hbar && (t3 += n2.event.deltaY), this.vbar && (e3 += n2.event.deltaY), this.setTranslate(t3, e3);
        }, s.prototype._onBarDrag = function() {
          var t3 = this.translateX, e3 = this.translateY;
          if (this.hbar) {
            var r3 = t3 + this._hbarXMin, i2 = r3 + this._hbarTranslateMax;
            t3 = (o.constrain(n2.event.x, r3, i2) - r3) / (i2 - r3) * (this.position.w - this._box.w);
          }
          if (this.vbar) {
            var a2 = e3 + this._vbarYMin, s2 = a2 + this._vbarTranslateMax;
            e3 = (o.constrain(n2.event.y, a2, s2) - a2) / (s2 - a2) * (this.position.h - this._box.h);
          }
          this.setTranslate(t3, e3);
        }, s.prototype.setTranslate = function(t3, e3) {
          var r3 = this.position.w - this._box.w, n3 = this.position.h - this._box.h;
          if (t3 = o.constrain(t3 || 0, 0, r3), e3 = o.constrain(e3 || 0, 0, n3), this.translateX = t3, this.translateY = e3, this.container.call(a.setTranslate, this._box.l - this.position.l - t3, this._box.t - this.position.t - e3), this._clipRect && this._clipRect.attr({ x: Math.floor(this.position.l + t3 - 0.5), y: Math.floor(this.position.t + e3 - 0.5) }), this.hbar) {
            var i2 = t3 / r3;
            this.hbar.call(a.setTranslate, t3 + i2 * this._hbarTranslateMax, e3);
          }
          if (this.vbar) {
            var s2 = e3 / n3;
            this.vbar.call(a.setTranslate, t3, e3 + s2 * this._vbarTranslateMax);
          }
        };
      }, 18783: function(t2) {
        t2.exports = { FROM_BL: { left: 0, center: 0.5, right: 1, bottom: 0, middle: 0.5, top: 1 }, FROM_TL: { left: 0, center: 0.5, right: 1, bottom: 1, middle: 0.5, top: 0 }, FROM_BR: { left: 1, center: 0.5, right: 0, bottom: 0, middle: 0.5, top: 1 }, LINE_SPACING: 1.3, CAP_SHIFT: 0.7, MID_SHIFT: 0.35, OPPOSITE_SIDE: { left: "right", right: "left", top: "bottom", bottom: "top" } };
      }, 24695: function(t2) {
        t2.exports = { axisRefDescription: function(t3, e2, r2) {
          return ["If set to a", t3, "axis id (e.g. *" + t3 + "* or", "*" + t3 + "2*), the `" + t3 + "` position refers to a", t3, "coordinate. If set to *paper*, the `" + t3 + "`", "position refers to the distance from the", e2, "of the plotting", "area in normalized coordinates where *0* (*1*) corresponds to the", e2, "(" + r2 + "). If set to a", t3, "axis ID followed by", "*domain* (separated by a space), the position behaves like for", "*paper*, but refers to the distance in fractions of the domain", "length from the", e2, "of the domain of that axis: e.g.,", "*" + t3 + "2 domain* refers to the domain of the second", t3, " axis and a", t3, "position of 0.5 refers to the", "point between the", e2, "and the", r2, "of the domain of the", "second", t3, "axis."].join(" ");
        } };
      }, 22372: function(t2) {
        t2.exports = { INCREASING: { COLOR: "#3D9970", SYMBOL: "▲" }, DECREASING: { COLOR: "#FF4136", SYMBOL: "▼" } };
      }, 31562: function(t2) {
        t2.exports = { FORMAT_LINK: "https://github.com/d3/d3-format/tree/v1.4.5#d3-format", DATE_FORMAT_LINK: "https://github.com/d3/d3-time-format/tree/v2.2.3#locale_format" };
      }, 74808: function(t2) {
        t2.exports = { COMPARISON_OPS: ["=", "!=", "<", ">=", ">", "<="], COMPARISON_OPS2: ["=", "<", ">=", ">", "<="], INTERVAL_OPS: ["[]", "()", "[)", "(]", "][", ")(", "](", ")["], SET_OPS: ["{}", "}{"], CONSTRAINT_REDUCTION: { "=": "=", "<": "<", "<=": "<", ">": ">", ">=": ">", "[]": "[]", "()": "[]", "[)": "[]", "(]": "[]", "][": "][", ")(": "][", "](": "][", ")[": "][" } };
      }, 29659: function(t2) {
        t2.exports = { solid: [[], 0], dot: [[0.5, 1], 200], dash: [[0.5, 1], 50], longdash: [[0.5, 1], 10], dashdot: [[0.5, 0.625, 0.875, 1], 50], longdashdot: [[0.5, 0.7, 0.8, 1], 10] };
      }, 87381: function(t2) {
        t2.exports = { circle: "●", "circle-open": "○", square: "■", "square-open": "□", diamond: "◆", "diamond-open": "◇", cross: "+", x: "❌" };
      }, 37822: function(t2) {
        t2.exports = { SHOW_PLACEHOLDER: 100, HIDE_PLACEHOLDER: 1e3, DESELECTDIM: 0.2 };
      }, 50606: function(t2) {
        t2.exports = { BADNUM: void 0, FP_SAFE: 1e-4 * Number.MAX_VALUE, ONEMAXYEAR: 316224e5, ONEAVGYEAR: 315576e5, ONEMINYEAR: 31536e6, ONEMAXQUARTER: 79488e5, ONEAVGQUARTER: 78894e5, ONEMINQUARTER: 76896e5, ONEMAXMONTH: 26784e5, ONEAVGMONTH: 26298e5, ONEMINMONTH: 24192e5, ONEWEEK: 6048e5, ONEDAY: 864e5, ONEHOUR: 36e5, ONEMIN: 6e4, ONESEC: 1e3, EPOCHJD: 24405875e-1, ALMOST_EQUAL: 0.999999, LOG_CLIP: 10, MINUS_SIGN: "−" };
      }, 77922: function(t2, e2) {
        e2.xmlns = "http://www.w3.org/2000/xmlns/", e2.svg = "http://www.w3.org/2000/svg", e2.xlink = "http://www.w3.org/1999/xlink", e2.svgAttrs = { xmlns: e2.svg, "xmlns:xlink": e2.xlink };
      }, 8729: function(t2, e2, r2) {
        e2.version = r2(11506).version, r2(7417), r2(98847);
        for (var n2 = r2(73972), i = e2.register = n2.register, a = r2(10641), o = Object.keys(a), s = 0; s < o.length; s++) {
          var l = o[s];
          "_" !== l.charAt(0) && (e2[l] = a[l]), i({ moduleType: "apiMethod", name: l, fn: a[l] });
        }
        i(r2(67368)), i([r2(2199), r2(30211), r2(32745), r2(2468), r2(47322), r2(89853), r2(68804), r2(20763), r2(23243), r2(13137), r2(97218), r2(83312), r2(37369), r2(21081), r2(12311), r2(64168)]), i([r2(92177), r2(37815)]), window.PlotlyLocales && Array.isArray(window.PlotlyLocales) && (i(window.PlotlyLocales), delete window.PlotlyLocales), e2.Icons = r2(24255);
        var u = r2(30211), c = r2(74875);
        e2.Plots = { resize: c.resize, graphJson: c.graphJson, sendDataToCloud: c.sendDataToCloud }, e2.Fx = { hover: u.hover, unhover: u.unhover, loneHover: u.loneHover, loneUnhover: u.loneUnhover }, e2.Snapshot = r2(44511), e2.PlotSchema = r2(86281);
      }, 24255: function(t2) {
        t2.exports = { undo: { width: 857.1, height: 1e3, path: "m857 350q0-87-34-166t-91-137-137-92-166-34q-96 0-183 41t-147 114q-4 6-4 13t5 11l76 77q6 5 14 5 9-1 13-7 41-53 100-82t126-29q58 0 110 23t92 61 61 91 22 111-22 111-61 91-92 61-110 23q-55 0-105-20t-90-57l77-77q17-16 8-38-10-23-33-23h-250q-15 0-25 11t-11 25v250q0 24 22 33 22 10 39-8l72-72q60 57 137 88t159 31q87 0 166-34t137-92 91-137 34-166z", transform: "matrix(1 0 0 -1 0 850)" }, home: { width: 928.6, height: 1e3, path: "m786 296v-267q0-15-11-26t-25-10h-214v214h-143v-214h-214q-15 0-25 10t-11 26v267q0 1 0 2t0 2l321 264 321-264q1-1 1-4z m124 39l-34-41q-5-5-12-6h-2q-7 0-12 3l-386 322-386-322q-7-4-13-4-7 2-12 7l-35 41q-4 5-3 13t6 12l401 334q18 15 42 15t43-15l136-114v109q0 8 5 13t13 5h107q8 0 13-5t5-13v-227l122-102q5-5 6-12t-4-13z", transform: "matrix(1 0 0 -1 0 850)" }, "camera-retro": { width: 1e3, height: 1e3, path: "m518 386q0 8-5 13t-13 5q-37 0-63-27t-26-63q0-8 5-13t13-5 12 5 5 13q0 23 16 38t38 16q8 0 13 5t5 13z m125-73q0-59-42-101t-101-42-101 42-42 101 42 101 101 42 101-42 42-101z m-572-320h858v71h-858v-71z m643 320q0 89-62 152t-152 62-151-62-63-152 63-151 151-63 152 63 62 151z m-571 358h214v72h-214v-72z m-72-107h858v143h-462l-36-71h-360v-72z m929 143v-714q0-30-21-51t-50-21h-858q-29 0-50 21t-21 51v714q0 30 21 51t50 21h858q29 0 50-21t21-51z", transform: "matrix(1 0 0 -1 0 850)" }, zoombox: { width: 1e3, height: 1e3, path: "m1000-25l-250 251c40 63 63 138 63 218 0 224-182 406-407 406-224 0-406-182-406-406s183-406 407-406c80 0 155 22 218 62l250-250 125 125z m-812 250l0 438 437 0 0-438-437 0z m62 375l313 0 0-312-313 0 0 312z", transform: "matrix(1 0 0 -1 0 850)" }, pan: { width: 1e3, height: 1e3, path: "m1000 350l-187 188 0-125-250 0 0 250 125 0-188 187-187-187 125 0 0-250-250 0 0 125-188-188 186-187 0 125 252 0 0-250-125 0 187-188 188 188-125 0 0 250 250 0 0-126 187 188z", transform: "matrix(1 0 0 -1 0 850)" }, zoom_plus: { width: 875, height: 1e3, path: "m1 787l0-875 875 0 0 875-875 0z m687-500l-187 0 0-187-125 0 0 187-188 0 0 125 188 0 0 187 125 0 0-187 187 0 0-125z", transform: "matrix(1 0 0 -1 0 850)" }, zoom_minus: { width: 875, height: 1e3, path: "m0 788l0-876 875 0 0 876-875 0z m688-500l-500 0 0 125 500 0 0-125z", transform: "matrix(1 0 0 -1 0 850)" }, autoscale: { width: 1e3, height: 1e3, path: "m250 850l-187 0-63 0 0-62 0-188 63 0 0 188 187 0 0 62z m688 0l-188 0 0-62 188 0 0-188 62 0 0 188 0 62-62 0z m-875-938l0 188-63 0 0-188 0-62 63 0 187 0 0 62-187 0z m875 188l0-188-188 0 0-62 188 0 62 0 0 62 0 188-62 0z m-125 188l-1 0-93-94-156 156 156 156 92-93 2 0 0 250-250 0 0-2 93-92-156-156-156 156 94 92 0 2-250 0 0-250 0 0 93 93 157-156-157-156-93 94 0 0 0-250 250 0 0 0-94 93 156 157 156-157-93-93 0 0 250 0 0 250z", transform: "matrix(1 0 0 -1 0 850)" }, tooltip_basic: { width: 1500, height: 1e3, path: "m375 725l0 0-375-375 375-374 0-1 1125 0 0 750-1125 0z", transform: "matrix(1 0 0 -1 0 850)" }, tooltip_compare: { width: 1125, height: 1e3, path: "m187 786l0 2-187-188 188-187 0 0 937 0 0 373-938 0z m0-499l0 1-187-188 188-188 0 0 937 0 0 376-938-1z", transform: "matrix(1 0 0 -1 0 850)" }, plotlylogo: { width: 1542, height: 1e3, path: "m0-10h182v-140h-182v140z m228 146h183v-286h-183v286z m225 714h182v-1000h-182v1000z m225-285h182v-715h-182v715z m225 142h183v-857h-183v857z m231-428h182v-429h-182v429z m225-291h183v-138h-183v138z", transform: "matrix(1 0 0 -1 0 850)" }, "z-axis": { width: 1e3, height: 1e3, path: "m833 5l-17 108v41l-130-65 130-66c0 0 0 38 0 39 0-1 36-14 39-25 4-15-6-22-16-30-15-12-39-16-56-20-90-22-187-23-279-23-261 0-341 34-353 59 3 60 228 110 228 110-140-8-351-35-351-116 0-120 293-142 474-142 155 0 477 22 477 142 0 50-74 79-163 96z m-374 94c-58-5-99-21-99-40 0-24 65-43 144-43 79 0 143 19 143 43 0 19-42 34-98 40v216h87l-132 135-133-135h88v-216z m167 515h-136v1c16 16 31 34 46 52l84 109v54h-230v-71h124v-1c-16-17-28-32-44-51l-89-114v-51h245v72z", transform: "matrix(1 0 0 -1 0 850)" }, "3d_rotate": { width: 1e3, height: 1e3, path: "m922 660c-5 4-9 7-14 11-359 263-580-31-580-31l-102 28 58-400c0 1 1 1 2 2 118 108 351 249 351 249s-62 27-100 42c88 83 222 183 347 122 16-8 30-17 44-27-2 1-4 2-6 4z m36-329c0 0 64 229-88 296-62 27-124 14-175-11 157-78 225-208 249-266 8-19 11-31 11-31 2 5 6 15 11 32-5-13-8-20-8-20z m-775-239c70-31 117-50 198-32-121 80-199 346-199 346l-96-15-58-12c0 0 55-226 155-287z m603 133l-317-139c0 0 4-4 19-14 7-5 24-15 24-15s-177-147-389 4c235-287 536-112 536-112l31-22 100 299-4-1z m-298-153c6-4 14-9 24-15 0 0-17 10-24 15z", transform: "matrix(1 0 0 -1 0 850)" }, camera: { width: 1e3, height: 1e3, path: "m500 450c-83 0-150-67-150-150 0-83 67-150 150-150 83 0 150 67 150 150 0 83-67 150-150 150z m400 150h-120c-16 0-34 13-39 29l-31 93c-6 15-23 28-40 28h-340c-16 0-34-13-39-28l-31-94c-6-15-23-28-40-28h-120c-55 0-100-45-100-100v-450c0-55 45-100 100-100h800c55 0 100 45 100 100v450c0 55-45 100-100 100z m-400-550c-138 0-250 112-250 250 0 138 112 250 250 250 138 0 250-112 250-250 0-138-112-250-250-250z m365 380c-19 0-35 16-35 35 0 19 16 35 35 35 19 0 35-16 35-35 0-19-16-35-35-35z", transform: "matrix(1 0 0 -1 0 850)" }, movie: { width: 1e3, height: 1e3, path: "m938 413l-188-125c0 37-17 71-44 94 64 38 107 107 107 187 0 121-98 219-219 219-121 0-219-98-219-219 0-61 25-117 66-156h-115c30 33 49 76 49 125 0 103-84 187-187 187s-188-84-188-187c0-57 26-107 65-141-38-22-65-62-65-109v-250c0-70 56-126 125-126h500c69 0 125 56 125 126l188-126c34 0 62 28 62 63v375c0 35-28 63-62 63z m-750 0c-69 0-125 56-125 125s56 125 125 125 125-56 125-125-56-125-125-125z m406-1c-87 0-157 70-157 157 0 86 70 156 157 156s156-70 156-156-70-157-156-157z", transform: "matrix(1 0 0 -1 0 850)" }, question: { width: 857.1, height: 1e3, path: "m500 82v107q0 8-5 13t-13 5h-107q-8 0-13-5t-5-13v-107q0-8 5-13t13-5h107q8 0 13 5t5 13z m143 375q0 49-31 91t-77 65-95 23q-136 0-207-119-9-14 4-24l74-55q4-4 10-4 9 0 14 7 30 38 48 51 19 14 48 14 27 0 48-15t21-33q0-21-11-34t-38-25q-35-16-65-48t-29-70v-20q0-8 5-13t13-5h107q8 0 13 5t5 13q0 10 12 27t30 28q18 10 28 16t25 19 25 27 16 34 7 45z m214-107q0-117-57-215t-156-156-215-58-216 58-155 156-58 215 58 215 155 156 216 58 215-58 156-156 57-215z", transform: "matrix(1 0 0 -1 0 850)" }, disk: { width: 857.1, height: 1e3, path: "m214-7h429v214h-429v-214z m500 0h72v500q0 8-6 21t-11 20l-157 156q-5 6-19 12t-22 5v-232q0-22-15-38t-38-16h-322q-22 0-37 16t-16 38v232h-72v-714h72v232q0 22 16 38t37 16h465q22 0 38-16t15-38v-232z m-214 518v178q0 8-5 13t-13 5h-107q-7 0-13-5t-5-13v-178q0-8 5-13t13-5h107q7 0 13 5t5 13z m357-18v-518q0-22-15-38t-38-16h-750q-23 0-38 16t-16 38v750q0 22 16 38t38 16h517q23 0 50-12t42-26l156-157q16-15 27-42t11-49z", transform: "matrix(1 0 0 -1 0 850)" }, drawopenpath: { width: 70, height: 70, path: "M33.21,85.65a7.31,7.31,0,0,1-2.59-.48c-8.16-3.11-9.27-19.8-9.88-41.3-.1-3.58-.19-6.68-.35-9-.15-2.1-.67-3.48-1.43-3.79-2.13-.88-7.91,2.32-12,5.86L3,32.38c1.87-1.64,11.55-9.66,18.27-6.9,2.13.87,4.75,3.14,5.17,9,.17,2.43.26,5.59.36,9.25a224.17,224.17,0,0,0,1.5,23.4c1.54,10.76,4,12.22,4.48,12.4.84.32,2.79-.46,5.76-3.59L43,80.07C41.53,81.57,37.68,85.64,33.21,85.65ZM74.81,69a11.34,11.34,0,0,0,6.09-6.72L87.26,44.5,74.72,32,56.9,38.35c-2.37.86-5.57,3.42-6.61,6L38.65,72.14l8.42,8.43ZM55,46.27a7.91,7.91,0,0,1,3.64-3.17l14.8-5.3,8,8L76.11,60.6l-.06.19a6.37,6.37,0,0,1-3,3.43L48.25,74.59,44.62,71Zm16.57,7.82A6.9,6.9,0,1,0,64.64,61,6.91,6.91,0,0,0,71.54,54.09Zm-4.05,0a2.85,2.85,0,1,1-2.85-2.85A2.86,2.86,0,0,1,67.49,54.09Zm-4.13,5.22L60.5,56.45,44.26,72.7l2.86,2.86ZM97.83,35.67,84.14,22l-8.57,8.57L89.26,44.24Zm-13.69-8,8,8-2.85,2.85-8-8Z", transform: "matrix(1 0 0 1 -15 -15)" }, drawclosedpath: { width: 90, height: 90, path: "M88.41,21.12a26.56,26.56,0,0,0-36.18,0l-2.07,2-2.07-2a26.57,26.57,0,0,0-36.18,0,23.74,23.74,0,0,0,0,34.8L48,90.12a3.22,3.22,0,0,0,4.42,0l36-34.21a23.73,23.73,0,0,0,0-34.79ZM84,51.24,50.16,83.35,16.35,51.25a17.28,17.28,0,0,1,0-25.47,20,20,0,0,1,27.3,0l4.29,4.07a3.23,3.23,0,0,0,4.44,0l4.29-4.07a20,20,0,0,1,27.3,0,17.27,17.27,0,0,1,0,25.46ZM66.76,47.68h-33v6.91h33ZM53.35,35H46.44V68h6.91Z", transform: "matrix(1 0 0 1 -5 -5)" }, lasso: { width: 1031, height: 1e3, path: "m1018 538c-36 207-290 336-568 286-277-48-473-256-436-463 10-57 36-108 76-151-13-66 11-137 68-183 34-28 75-41 114-42l-55-70 0 0c-2-1-3-2-4-3-10-14-8-34 5-45 14-11 34-8 45 4 1 1 2 3 2 5l0 0 113 140c16 11 31 24 45 40 4 3 6 7 8 11 48-3 100 0 151 9 278 48 473 255 436 462z m-624-379c-80 14-149 48-197 96 42 42 109 47 156 9 33-26 47-66 41-105z m-187-74c-19 16-33 37-39 60 50-32 109-55 174-68-42-25-95-24-135 8z m360 75c-34-7-69-9-102-8 8 62-16 128-68 170-73 59-175 54-244-5-9 20-16 40-20 61-28 159 121 317 333 354s407-60 434-217c28-159-121-318-333-355z", transform: "matrix(1 0 0 -1 0 850)" }, selectbox: { width: 1e3, height: 1e3, path: "m0 850l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z m285 0l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z m-857-286l0-143 143 0 0 143-143 0z m857 0l0-143 143 0 0 143-143 0z m-857-285l0-143 143 0 0 143-143 0z m857 0l0-143 143 0 0 143-143 0z m-857-286l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z m285 0l0-143 143 0 0 143-143 0z m286 0l0-143 143 0 0 143-143 0z", transform: "matrix(1 0 0 -1 0 850)" }, drawline: { width: 70, height: 70, path: "M60.64,62.3a11.29,11.29,0,0,0,6.09-6.72l6.35-17.72L60.54,25.31l-17.82,6.4c-2.36.86-5.57,3.41-6.6,6L24.48,65.5l8.42,8.42ZM40.79,39.63a7.89,7.89,0,0,1,3.65-3.17l14.79-5.31,8,8L61.94,54l-.06.19a6.44,6.44,0,0,1-3,3.43L34.07,68l-3.62-3.63Zm16.57,7.81a6.9,6.9,0,1,0-6.89,6.9A6.9,6.9,0,0,0,57.36,47.44Zm-4,0a2.86,2.86,0,1,1-2.85-2.85A2.86,2.86,0,0,1,53.32,47.44Zm-4.13,5.22L46.33,49.8,30.08,66.05l2.86,2.86ZM83.65,29,70,15.34,61.4,23.9,75.09,37.59ZM70,21.06l8,8-2.84,2.85-8-8ZM87,80.49H10.67V87H87Z", transform: "matrix(1 0 0 1 -15 -15)" }, drawrect: { width: 80, height: 80, path: "M78,22V79H21V22H78m9-9H12V88H87V13ZM68,46.22H31V54H68ZM53,32H45.22V69H53Z", transform: "matrix(1 0 0 1 -10 -10)" }, drawcircle: { width: 80, height: 80, path: "M50,84.72C26.84,84.72,8,69.28,8,50.3S26.84,15.87,50,15.87,92,31.31,92,50.3,73.16,84.72,50,84.72Zm0-60.59c-18.6,0-33.74,11.74-33.74,26.17S31.4,76.46,50,76.46,83.74,64.72,83.74,50.3,68.6,24.13,50,24.13Zm17.15,22h-34v7.11h34Zm-13.8-13H46.24v34h7.11Z", transform: "matrix(1 0 0 1 -10 -10)" }, eraseshape: { width: 80, height: 80, path: "M82.77,78H31.85L6,49.57,31.85,21.14H82.77a8.72,8.72,0,0,1,8.65,8.77V69.24A8.72,8.72,0,0,1,82.77,78ZM35.46,69.84H82.77a.57.57,0,0,0,.49-.6V29.91a.57.57,0,0,0-.49-.61H35.46L17,49.57Zm32.68-34.7-24,24,5,5,24-24Zm-19,.53-5,5,24,24,5-5Z", transform: "matrix(1 0 0 1 -10 -10)" }, spikeline: { width: 1e3, height: 1e3, path: "M512 409c0-57-46-104-103-104-57 0-104 47-104 104 0 57 47 103 104 103 57 0 103-46 103-103z m-327-39l92 0 0 92-92 0z m-185 0l92 0 0 92-92 0z m370-186l92 0 0 93-92 0z m0-184l92 0 0 92-92 0z", transform: "matrix(1.5 0 0 -1.5 0 850)" }, pencil: { width: 1792, height: 1792, path: "M491 1536l91-91-235-235-91 91v107h128v128h107zm523-928q0-22-22-22-10 0-17 7l-542 542q-7 7-7 17 0 22 22 22 10 0 17-7l542-542q7-7 7-17zm-54-192l416 416-832 832h-416v-416zm683 96q0 53-37 90l-166 166-416-416 166-165q36-38 90-38 53 0 91 38l235 234q37 39 37 91z", transform: "matrix(1 0 0 1 0 1)" }, newplotlylogo: { name: "newplotlylogo", svg: ["<svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 132 132'>", "<defs>", " <style>", "  .cls-0{fill:#000;}", "  .cls-1{fill:#FFF;}", "  .cls-2{fill:#F26;}", "  .cls-3{fill:#D69;}", "  .cls-4{fill:#BAC;}", "  .cls-5{fill:#9EF;}", " </style>", "</defs>", " <title>plotly-logomark</title>", " <g id='symbol'>", "  <rect class='cls-0' x='0' y='0' width='132' height='132' rx='18' ry='18'/>", "  <circle class='cls-5' cx='102' cy='30' r='6'/>", "  <circle class='cls-4' cx='78' cy='30' r='6'/>", "  <circle class='cls-4' cx='78' cy='54' r='6'/>", "  <circle class='cls-3' cx='54' cy='30' r='6'/>", "  <circle class='cls-2' cx='30' cy='30' r='6'/>", "  <circle class='cls-2' cx='30' cy='54' r='6'/>", "  <path class='cls-1' d='M30,72a6,6,0,0,0-6,6v24a6,6,0,0,0,12,0V78A6,6,0,0,0,30,72Z'/>", "  <path class='cls-1' d='M78,72a6,6,0,0,0-6,6v24a6,6,0,0,0,12,0V78A6,6,0,0,0,78,72Z'/>", "  <path class='cls-1' d='M54,48a6,6,0,0,0-6,6v48a6,6,0,0,0,12,0V54A6,6,0,0,0,54,48Z'/>", "  <path class='cls-1' d='M102,48a6,6,0,0,0-6,6v48a6,6,0,0,0,12,0V54A6,6,0,0,0,102,48Z'/>", " </g>", "</svg>"].join("") } };
      }, 99863: function(t2, e2) {
        e2.isLeftAnchor = function(t3) {
          return "left" === t3.xanchor || "auto" === t3.xanchor && t3.x <= 1 / 3;
        }, e2.isCenterAnchor = function(t3) {
          return "center" === t3.xanchor || "auto" === t3.xanchor && t3.x > 1 / 3 && t3.x < 2 / 3;
        }, e2.isRightAnchor = function(t3) {
          return "right" === t3.xanchor || "auto" === t3.xanchor && t3.x >= 2 / 3;
        }, e2.isTopAnchor = function(t3) {
          return "top" === t3.yanchor || "auto" === t3.yanchor && t3.y >= 2 / 3;
        }, e2.isMiddleAnchor = function(t3) {
          return "middle" === t3.yanchor || "auto" === t3.yanchor && t3.y > 1 / 3 && t3.y < 2 / 3;
        }, e2.isBottomAnchor = function(t3) {
          return "bottom" === t3.yanchor || "auto" === t3.yanchor && t3.y <= 1 / 3;
        };
      }, 26348: function(t2, e2, r2) {
        var n2 = r2(64872), i = n2.mod, a = n2.modHalf, o = Math.PI, s = 2 * o;
        function l(t3) {
          return Math.abs(t3[1] - t3[0]) > s - 1e-14;
        }
        function u(t3, e3) {
          return a(e3 - t3, s);
        }
        function c(t3, e3) {
          if (l(e3))
            return true;
          var r3, n3;
          e3[0] < e3[1] ? (r3 = e3[0], n3 = e3[1]) : (r3 = e3[1], n3 = e3[0]), (r3 = i(r3, s)) > (n3 = i(n3, s)) && (n3 += s);
          var a2 = i(t3, s), o2 = a2 + s;
          return a2 >= r3 && a2 <= n3 || o2 >= r3 && o2 <= n3;
        }
        function f2(t3, e3, r3, n3, i2, a2, u2) {
          i2 = i2 || 0, a2 = a2 || 0;
          var c2, f3, h, p2, d2, v = l([r3, n3]);
          function g2(t4, e4) {
            return [t4 * Math.cos(e4) + i2, a2 - t4 * Math.sin(e4)];
          }
          v ? (c2 = 0, f3 = o, h = s) : r3 < n3 ? (c2 = r3, h = n3) : (c2 = n3, h = r3), t3 < e3 ? (p2 = t3, d2 = e3) : (p2 = e3, d2 = t3);
          var y, m2 = Math.abs(h - c2) <= o ? 0 : 1;
          function x(t4, e4, r4) {
            return "A" + [t4, t4] + " " + [0, m2, r4] + " " + g2(t4, e4);
          }
          return v ? y = null === p2 ? "M" + g2(d2, c2) + x(d2, f3, 0) + x(d2, h, 0) + "Z" : "M" + g2(p2, c2) + x(p2, f3, 0) + x(p2, h, 0) + "ZM" + g2(d2, c2) + x(d2, f3, 1) + x(d2, h, 1) + "Z" : null === p2 ? (y = "M" + g2(d2, c2) + x(d2, h, 0), u2 && (y += "L0,0Z")) : y = "M" + g2(p2, c2) + "L" + g2(d2, c2) + x(d2, h, 0) + "L" + g2(p2, h) + x(p2, c2, 1) + "Z", y;
        }
        t2.exports = { deg2rad: function(t3) {
          return t3 / 180 * o;
        }, rad2deg: function(t3) {
          return t3 / o * 180;
        }, angleDelta: u, angleDist: function(t3, e3) {
          return Math.abs(u(t3, e3));
        }, isFullCircle: l, isAngleInsideSector: c, isPtInsideSector: function(t3, e3, r3, n3) {
          return !!c(e3, n3) && (r3[0] < r3[1] ? (i2 = r3[0], a2 = r3[1]) : (i2 = r3[1], a2 = r3[0]), t3 >= i2 && t3 <= a2);
          var i2, a2;
        }, pathArc: function(t3, e3, r3, n3, i2) {
          return f2(null, t3, e3, r3, n3, i2, 0);
        }, pathSector: function(t3, e3, r3, n3, i2) {
          return f2(null, t3, e3, r3, n3, i2, 1);
        }, pathAnnulus: function(t3, e3, r3, n3, i2, a2) {
          return f2(t3, e3, r3, n3, i2, a2, 1);
        } };
      }, 73627: function(t2, e2) {
        var r2 = Array.isArray, n2 = ArrayBuffer, i = DataView;
        function a(t3) {
          return n2.isView(t3) && !(t3 instanceof i);
        }
        function o(t3) {
          return r2(t3) || a(t3);
        }
        function s(t3, e3, r3) {
          if (o(t3)) {
            if (o(t3[0])) {
              for (var n3 = r3, i2 = 0; i2 < t3.length; i2++)
                n3 = e3(n3, t3[i2].length);
              return n3;
            }
            return t3.length;
          }
          return 0;
        }
        e2.isTypedArray = a, e2.isArrayOrTypedArray = o, e2.isArray1D = function(t3) {
          return !o(t3[0]);
        }, e2.ensureArray = function(t3, e3) {
          return r2(t3) || (t3 = []), t3.length = e3, t3;
        }, e2.concat = function() {
          var t3, e3, n3, i2, a2, o2, s2, l, u = [], c = true, f2 = 0;
          for (n3 = 0; n3 < arguments.length; n3++)
            (o2 = (i2 = arguments[n3]).length) && (e3 ? u.push(i2) : (e3 = i2, a2 = o2), r2(i2) ? t3 = false : (c = false, f2 ? t3 !== i2.constructor && (t3 = false) : t3 = i2.constructor), f2 += o2);
          if (!f2)
            return [];
          if (!u.length)
            return e3;
          if (c)
            return e3.concat.apply(e3, u);
          if (t3) {
            for ((s2 = new t3(f2)).set(e3), n3 = 0; n3 < u.length; n3++)
              i2 = u[n3], s2.set(i2, a2), a2 += i2.length;
            return s2;
          }
          for (s2 = new Array(f2), l = 0; l < e3.length; l++)
            s2[l] = e3[l];
          for (n3 = 0; n3 < u.length; n3++) {
            for (i2 = u[n3], l = 0; l < i2.length; l++)
              s2[a2 + l] = i2[l];
            a2 += l;
          }
          return s2;
        }, e2.maxRowLength = function(t3) {
          return s(t3, Math.max, 0);
        }, e2.minRowLength = function(t3) {
          return s(t3, Math.min, 1 / 0);
        };
      }, 95218: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(50606).BADNUM, a = /^['"%,$#\s']+|[, ]|['"%,$#\s']+$/g;
        t2.exports = function(t3) {
          return "string" == typeof t3 && (t3 = t3.replace(a, "")), n2(t3) ? Number(t3) : i;
        };
      }, 33306: function(t2) {
        t2.exports = function(t3) {
          var e2 = t3._fullLayout;
          e2._glcanvas && e2._glcanvas.size() && e2._glcanvas.each(function(t4) {
            t4.regl && t4.regl.clear({ color: true, depth: true });
          });
        };
      }, 86367: function(t2) {
        t2.exports = function(t3) {
          t3._responsiveChartHandler && (window.removeEventListener("resize", t3._responsiveChartHandler), delete t3._responsiveChartHandler);
        };
      }, 96554: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(84267), a = r2(9012), o = r2(63282), s = r2(7901), l = r2(37822).DESELECTDIM, u = r2(65487), c = r2(30587).counter, f2 = r2(64872).modHalf, h = r2(73627).isArrayOrTypedArray;
        function p2(t3, r3) {
          var n3 = e2.valObjectMeta[r3.valType];
          if (r3.arrayOk && h(t3))
            return true;
          if (n3.validateFunction)
            return n3.validateFunction(t3, r3);
          var i2 = {}, a2 = i2, o2 = { set: function(t4) {
            a2 = t4;
          } };
          return n3.coerceFunction(t3, o2, i2, r3), a2 !== i2;
        }
        e2.valObjectMeta = { data_array: { coerceFunction: function(t3, e3, r3) {
          h(t3) ? e3.set(t3) : void 0 !== r3 && e3.set(r3);
        } }, enumerated: { coerceFunction: function(t3, e3, r3, n3) {
          n3.coerceNumber && (t3 = +t3), -1 === n3.values.indexOf(t3) ? e3.set(r3) : e3.set(t3);
        }, validateFunction: function(t3, e3) {
          e3.coerceNumber && (t3 = +t3);
          for (var r3 = e3.values, n3 = 0; n3 < r3.length; n3++) {
            var i2 = String(r3[n3]);
            if ("/" === i2.charAt(0) && "/" === i2.charAt(i2.length - 1)) {
              if (new RegExp(i2.substr(1, i2.length - 2)).test(t3))
                return true;
            } else if (t3 === r3[n3])
              return true;
          }
          return false;
        } }, boolean: { coerceFunction: function(t3, e3, r3) {
          true === t3 || false === t3 ? e3.set(t3) : e3.set(r3);
        } }, number: { coerceFunction: function(t3, e3, r3, i2) {
          !n2(t3) || void 0 !== i2.min && t3 < i2.min || void 0 !== i2.max && t3 > i2.max ? e3.set(r3) : e3.set(+t3);
        } }, integer: { coerceFunction: function(t3, e3, r3, i2) {
          t3 % 1 || !n2(t3) || void 0 !== i2.min && t3 < i2.min || void 0 !== i2.max && t3 > i2.max ? e3.set(r3) : e3.set(+t3);
        } }, string: { coerceFunction: function(t3, e3, r3, n3) {
          if ("string" != typeof t3) {
            var i2 = "number" == typeof t3;
            true !== n3.strict && i2 ? e3.set(String(t3)) : e3.set(r3);
          } else
            n3.noBlank && !t3 ? e3.set(r3) : e3.set(t3);
        } }, color: { coerceFunction: function(t3, e3, r3) {
          i(t3).isValid() ? e3.set(t3) : e3.set(r3);
        } }, colorlist: { coerceFunction: function(t3, e3, r3) {
          Array.isArray(t3) && t3.length && t3.every(function(t4) {
            return i(t4).isValid();
          }) ? e3.set(t3) : e3.set(r3);
        } }, colorscale: { coerceFunction: function(t3, e3, r3) {
          e3.set(o.get(t3, r3));
        } }, angle: { coerceFunction: function(t3, e3, r3) {
          "auto" === t3 ? e3.set("auto") : n2(t3) ? e3.set(f2(+t3, 360)) : e3.set(r3);
        } }, subplotid: { coerceFunction: function(t3, e3, r3, n3) {
          var i2 = n3.regex || c(r3);
          "string" == typeof t3 && i2.test(t3) ? e3.set(t3) : e3.set(r3);
        }, validateFunction: function(t3, e3) {
          var r3 = e3.dflt;
          return t3 === r3 || "string" == typeof t3 && !!c(r3).test(t3);
        } }, flaglist: { coerceFunction: function(t3, e3, r3, n3) {
          if (-1 === (n3.extras || []).indexOf(t3))
            if ("string" == typeof t3) {
              for (var i2 = t3.split("+"), a2 = 0; a2 < i2.length; ) {
                var o2 = i2[a2];
                -1 === n3.flags.indexOf(o2) || i2.indexOf(o2) < a2 ? i2.splice(a2, 1) : a2++;
              }
              i2.length ? e3.set(i2.join("+")) : e3.set(r3);
            } else
              e3.set(r3);
          else
            e3.set(t3);
        } }, any: { coerceFunction: function(t3, e3, r3) {
          void 0 === t3 ? e3.set(r3) : e3.set(t3);
        } }, info_array: { coerceFunction: function(t3, r3, n3, i2) {
          function a2(t4, r4, n4) {
            var i3, a3 = { set: function(t5) {
              i3 = t5;
            } };
            return void 0 === n4 && (n4 = r4.dflt), e2.valObjectMeta[r4.valType].coerceFunction(t4, a3, n4, r4), i3;
          }
          var o2 = 2 === i2.dimensions || "1-2" === i2.dimensions && Array.isArray(t3) && Array.isArray(t3[0]);
          if (Array.isArray(t3)) {
            var s2, l2, u2, c2, f3, h2, p3 = i2.items, d2 = [], v = Array.isArray(p3), g2 = v && o2 && Array.isArray(p3[0]), y = o2 && v && !g2, m2 = v && !y ? p3.length : t3.length;
            if (n3 = Array.isArray(n3) ? n3 : [], o2)
              for (s2 = 0; s2 < m2; s2++)
                for (d2[s2] = [], u2 = Array.isArray(t3[s2]) ? t3[s2] : [], f3 = y ? p3.length : v ? p3[s2].length : u2.length, l2 = 0; l2 < f3; l2++)
                  c2 = y ? p3[l2] : v ? p3[s2][l2] : p3, void 0 !== (h2 = a2(u2[l2], c2, (n3[s2] || [])[l2])) && (d2[s2][l2] = h2);
            else
              for (s2 = 0; s2 < m2; s2++)
                void 0 !== (h2 = a2(t3[s2], v ? p3[s2] : p3, n3[s2])) && (d2[s2] = h2);
            r3.set(d2);
          } else
            r3.set(n3);
        }, validateFunction: function(t3, e3) {
          if (!Array.isArray(t3))
            return false;
          var r3 = e3.items, n3 = Array.isArray(r3), i2 = 2 === e3.dimensions;
          if (!e3.freeLength && t3.length !== r3.length)
            return false;
          for (var a2 = 0; a2 < t3.length; a2++)
            if (i2) {
              if (!Array.isArray(t3[a2]) || !e3.freeLength && t3[a2].length !== r3[a2].length)
                return false;
              for (var o2 = 0; o2 < t3[a2].length; o2++)
                if (!p2(t3[a2][o2], n3 ? r3[a2][o2] : r3))
                  return false;
            } else if (!p2(t3[a2], n3 ? r3[a2] : r3))
              return false;
          return true;
        } } }, e2.coerce = function(t3, r3, n3, i2, a2) {
          var o2 = u(n3, i2).get(), s2 = u(t3, i2), l2 = u(r3, i2), c2 = s2.get(), f3 = r3._template;
          if (void 0 === c2 && f3 && (c2 = u(f3, i2).get(), f3 = 0), void 0 === a2 && (a2 = o2.dflt), o2.arrayOk && h(c2))
            return l2.set(c2), c2;
          var d2 = e2.valObjectMeta[o2.valType].coerceFunction;
          d2(c2, l2, a2, o2);
          var v = l2.get();
          return f3 && v === a2 && !p2(c2, o2) && (d2(c2 = u(f3, i2).get(), l2, a2, o2), v = l2.get()), v;
        }, e2.coerce2 = function(t3, r3, n3, i2, a2) {
          var o2 = u(t3, i2), s2 = e2.coerce(t3, r3, n3, i2, a2);
          return null != o2.get() && s2;
        }, e2.coerceFont = function(t3, e3, r3) {
          var n3 = {};
          return r3 = r3 || {}, n3.family = t3(e3 + ".family", r3.family), n3.size = t3(e3 + ".size", r3.size), n3.color = t3(e3 + ".color", r3.color), n3;
        }, e2.coercePattern = function(t3, e3, r3, n3) {
          if (t3(e3 + ".shape")) {
            t3(e3 + ".solidity"), t3(e3 + ".size");
            var i2 = "overlay" === t3(e3 + ".fillmode");
            if (!n3) {
              var a2 = t3(e3 + ".bgcolor", i2 ? r3 : void 0);
              t3(e3 + ".fgcolor", i2 ? s.contrast(a2) : r3);
            }
            t3(e3 + ".fgopacity", i2 ? 0.5 : 1);
          }
        }, e2.coerceHoverinfo = function(t3, r3, n3) {
          var i2, o2 = r3._module.attributes, s2 = o2.hoverinfo ? o2 : a, l2 = s2.hoverinfo;
          if (1 === n3._dataLength) {
            var u2 = "all" === l2.dflt ? l2.flags.slice() : l2.dflt.split("+");
            u2.splice(u2.indexOf("name"), 1), i2 = u2.join("+");
          }
          return e2.coerce(t3, r3, s2, "hoverinfo", i2);
        }, e2.coerceSelectionMarkerOpacity = function(t3, e3) {
          if (t3.marker) {
            var r3, n3, i2 = t3.marker.opacity;
            void 0 !== i2 && (h(i2) || t3.selected || t3.unselected || (r3 = i2, n3 = l * i2), e3("selected.marker.opacity", r3), e3("unselected.marker.opacity", n3));
          }
        }, e2.validate = p2;
      }, 41631: function(t2, e2, r2) {
        var n2, i, a = r2(84096).i$, o = r2(92770), s = r2(47769), l = r2(64872).mod, u = r2(50606), c = u.BADNUM, f2 = u.ONEDAY, h = u.ONEHOUR, p2 = u.ONEMIN, d2 = u.ONESEC, v = u.EPOCHJD, g2 = r2(73972), y = r2(84096).g0, m2 = /^\s*(-?\d\d\d\d|\d\d)(-(\d?\d)(-(\d?\d)([ Tt]([01]?\d|2[0-3])(:([0-5]\d)(:([0-5]\d(\.\d+)?))?(Z|z|[+\-]\d\d(:?\d\d)?)?)?)?)?)?\s*$/m, x = /^\s*(-?\d\d\d\d|\d\d)(-(\d?\di?)(-(\d?\d)([ Tt]([01]?\d|2[0-3])(:([0-5]\d)(:([0-5]\d(\.\d+)?))?(Z|z|[+\-]\d\d(:?\d\d)?)?)?)?)?)?\s*$/m, b = new Date().getFullYear() - 70;
        function _(t3) {
          return t3 && g2.componentsRegistry.calendars && "string" == typeof t3 && "gregorian" !== t3;
        }
        function w2(t3, e3) {
          return String(t3 + Math.pow(10, e3)).substr(1);
        }
        e2.dateTick0 = function(t3, r3) {
          var n3 = function(t4, e3) {
            return _(t4) ? e3 ? g2.getComponentMethod("calendars", "CANONICAL_SUNDAY")[t4] : g2.getComponentMethod("calendars", "CANONICAL_TICK")[t4] : e3 ? "2000-01-02" : "2000-01-01";
          }(t3, !!r3);
          if (r3 < 2)
            return n3;
          var i2 = e2.dateTime2ms(n3, t3);
          return i2 += f2 * (r3 - 1), e2.ms2DateTime(i2, 0, t3);
        }, e2.dfltRange = function(t3) {
          return _(t3) ? g2.getComponentMethod("calendars", "DFLTRANGE")[t3] : ["2000-01-01", "2001-01-01"];
        }, e2.isJSDate = function(t3) {
          return "object" == typeof t3 && null !== t3 && "function" == typeof t3.getTime;
        }, e2.dateTime2ms = function(t3, r3) {
          if (e2.isJSDate(t3)) {
            var a2 = t3.getTimezoneOffset() * p2, o2 = (t3.getUTCMinutes() - t3.getMinutes()) * p2 + (t3.getUTCSeconds() - t3.getSeconds()) * d2 + (t3.getUTCMilliseconds() - t3.getMilliseconds());
            if (o2) {
              var s2 = 3 * p2;
              a2 = a2 - s2 / 2 + l(o2 - a2 + s2 / 2, s2);
            }
            return (t3 = Number(t3) - a2) >= n2 && t3 <= i ? t3 : c;
          }
          if ("string" != typeof t3 && "number" != typeof t3)
            return c;
          t3 = String(t3);
          var u2 = _(r3), y2 = t3.charAt(0);
          !u2 || "G" !== y2 && "g" !== y2 || (t3 = t3.substr(1), r3 = "");
          var w3 = u2 && "chinese" === r3.substr(0, 7), T2 = t3.match(w3 ? x : m2);
          if (!T2)
            return c;
          var k2 = T2[1], A2 = T2[3] || "1", M2 = Number(T2[5] || 1), S2 = Number(T2[7] || 0), E2 = Number(T2[9] || 0), L2 = Number(T2[11] || 0);
          if (u2) {
            if (2 === k2.length)
              return c;
            var C2;
            k2 = Number(k2);
            try {
              var P2 = g2.getComponentMethod("calendars", "getCal")(r3);
              if (w3) {
                var O2 = "i" === A2.charAt(A2.length - 1);
                A2 = parseInt(A2, 10), C2 = P2.newDate(k2, P2.toMonthIndex(k2, A2, O2), M2);
              } else
                C2 = P2.newDate(k2, Number(A2), M2);
            } catch (t4) {
              return c;
            }
            return C2 ? (C2.toJD() - v) * f2 + S2 * h + E2 * p2 + L2 * d2 : c;
          }
          k2 = 2 === k2.length ? (Number(k2) + 2e3 - b) % 100 + b : Number(k2), A2 -= 1;
          var I = new Date(Date.UTC(2e3, A2, M2, S2, E2));
          return I.setUTCFullYear(k2), I.getUTCMonth() !== A2 || I.getUTCDate() !== M2 ? c : I.getTime() + L2 * d2;
        }, n2 = e2.MIN_MS = e2.dateTime2ms("-9999"), i = e2.MAX_MS = e2.dateTime2ms("9999-12-31 23:59:59.9999"), e2.isDateTime = function(t3, r3) {
          return e2.dateTime2ms(t3, r3) !== c;
        };
        var T = 90 * f2, k = 3 * h, A = 5 * p2;
        function M(t3, e3, r3, n3, i2) {
          if ((e3 || r3 || n3 || i2) && (t3 += " " + w2(e3, 2) + ":" + w2(r3, 2), (n3 || i2) && (t3 += ":" + w2(n3, 2), i2))) {
            for (var a2 = 4; i2 % 10 == 0; )
              a2 -= 1, i2 /= 10;
            t3 += "." + w2(i2, a2);
          }
          return t3;
        }
        e2.ms2DateTime = function(t3, e3, r3) {
          if ("number" != typeof t3 || !(t3 >= n2 && t3 <= i))
            return c;
          e3 || (e3 = 0);
          var a2, o2, s2, u2, m3, x2, b2 = Math.floor(10 * l(t3 + 0.05, 1)), w3 = Math.round(t3 - b2 / 10);
          if (_(r3)) {
            var S2 = Math.floor(w3 / f2) + v, E2 = Math.floor(l(t3, f2));
            try {
              a2 = g2.getComponentMethod("calendars", "getCal")(r3).fromJD(S2).formatDate("yyyy-mm-dd");
            } catch (t4) {
              a2 = y("G%Y-%m-%d")(new Date(w3));
            }
            if ("-" === a2.charAt(0))
              for (; a2.length < 11; )
                a2 = "-0" + a2.substr(1);
            else
              for (; a2.length < 10; )
                a2 = "0" + a2;
            o2 = e3 < T ? Math.floor(E2 / h) : 0, s2 = e3 < T ? Math.floor(E2 % h / p2) : 0, u2 = e3 < k ? Math.floor(E2 % p2 / d2) : 0, m3 = e3 < A ? E2 % d2 * 10 + b2 : 0;
          } else
            x2 = new Date(w3), a2 = y("%Y-%m-%d")(x2), o2 = e3 < T ? x2.getUTCHours() : 0, s2 = e3 < T ? x2.getUTCMinutes() : 0, u2 = e3 < k ? x2.getUTCSeconds() : 0, m3 = e3 < A ? 10 * x2.getUTCMilliseconds() + b2 : 0;
          return M(a2, o2, s2, u2, m3);
        }, e2.ms2DateTimeLocal = function(t3) {
          if (!(t3 >= n2 + f2 && t3 <= i - f2))
            return c;
          var e3 = Math.floor(10 * l(t3 + 0.05, 1)), r3 = new Date(Math.round(t3 - e3 / 10));
          return M(a("%Y-%m-%d")(r3), r3.getHours(), r3.getMinutes(), r3.getSeconds(), 10 * r3.getUTCMilliseconds() + e3);
        }, e2.cleanDate = function(t3, r3, n3) {
          if (t3 === c)
            return r3;
          if (e2.isJSDate(t3) || "number" == typeof t3 && isFinite(t3)) {
            if (_(n3))
              return s.error("JS Dates and milliseconds are incompatible with world calendars", t3), r3;
            if (!(t3 = e2.ms2DateTimeLocal(+t3)) && void 0 !== r3)
              return r3;
          } else if (!e2.isDateTime(t3, n3))
            return s.error("unrecognized date", t3), r3;
          return t3;
        };
        var S = /%\d?f/g, E = /%h/g, L = { 1: "1", 2: "1", 3: "2", 4: "2" };
        function C(t3, e3, r3, n3) {
          t3 = t3.replace(S, function(t4) {
            var r4 = Math.min(+t4.charAt(1) || 6, 6);
            return (e3 / 1e3 % 1 + 2).toFixed(r4).substr(2).replace(/0+$/, "") || "0";
          });
          var i2 = new Date(Math.floor(e3 + 0.05));
          if (t3 = t3.replace(E, function() {
            return L[r3("%q")(i2)];
          }), _(n3))
            try {
              t3 = g2.getComponentMethod("calendars", "worldCalFmt")(t3, e3, n3);
            } catch (t4) {
              return "Invalid";
            }
          return r3(t3)(i2);
        }
        var P = [59, 59.9, 59.99, 59.999, 59.9999];
        e2.formatDate = function(t3, e3, r3, n3, i2, a2) {
          if (i2 = _(i2) && i2, !e3)
            if ("y" === r3)
              e3 = a2.year;
            else if ("m" === r3)
              e3 = a2.month;
            else {
              if ("d" !== r3)
                return function(t4, e4) {
                  var r4 = l(t4 + 0.05, f2), n4 = w2(Math.floor(r4 / h), 2) + ":" + w2(l(Math.floor(r4 / p2), 60), 2);
                  if ("M" !== e4) {
                    o(e4) || (e4 = 0);
                    var i3 = (100 + Math.min(l(t4 / d2, 60), P[e4])).toFixed(e4).substr(1);
                    e4 > 0 && (i3 = i3.replace(/0+$/, "").replace(/[\.]$/, "")), n4 += ":" + i3;
                  }
                  return n4;
                }(t3, r3) + "\n" + C(a2.dayMonthYear, t3, n3, i2);
              e3 = a2.dayMonth + "\n" + a2.year;
            }
          return C(e3, t3, n3, i2);
        };
        var O = 3 * f2;
        e2.incrementMonth = function(t3, e3, r3) {
          r3 = _(r3) && r3;
          var n3 = l(t3, f2);
          if (t3 = Math.round(t3 - n3), r3)
            try {
              var i2 = Math.round(t3 / f2) + v, a2 = g2.getComponentMethod("calendars", "getCal")(r3), o2 = a2.fromJD(i2);
              return e3 % 12 ? a2.add(o2, e3, "m") : a2.add(o2, e3 / 12, "y"), (o2.toJD() - v) * f2 + n3;
            } catch (e4) {
              s.error("invalid ms " + t3 + " in calendar " + r3);
            }
          var u2 = new Date(t3 + O);
          return u2.setUTCMonth(u2.getUTCMonth() + e3) + n3 - O;
        }, e2.findExactDates = function(t3, e3) {
          for (var r3, n3, i2 = 0, a2 = 0, s2 = 0, l2 = 0, u2 = _(e3) && g2.getComponentMethod("calendars", "getCal")(e3), c2 = 0; c2 < t3.length; c2++)
            if (n3 = t3[c2], o(n3)) {
              if (!(n3 % f2))
                if (u2)
                  try {
                    1 === (r3 = u2.fromJD(n3 / f2 + v)).day() ? 1 === r3.month() ? i2++ : a2++ : s2++;
                  } catch (t4) {
                  }
                else
                  1 === (r3 = new Date(n3)).getUTCDate() ? 0 === r3.getUTCMonth() ? i2++ : a2++ : s2++;
            } else
              l2++;
          s2 += a2 += i2;
          var h2 = t3.length - l2;
          return { exactYears: i2 / h2, exactMonths: a2 / h2, exactDays: s2 / h2 };
        };
      }, 24401: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(47769), a = r2(35657), o = r2(79576);
        function s(t3) {
          var e3 = t3 && t3.parentNode;
          e3 && e3.removeChild(t3);
        }
        function l(t3, e3, r3) {
          var n3 = "plotly.js-style-" + t3, a2 = document.getElementById(n3);
          a2 || ((a2 = document.createElement("style")).setAttribute("id", n3), a2.appendChild(document.createTextNode("")), document.head.appendChild(a2));
          var o2 = a2.sheet;
          o2.insertRule ? o2.insertRule(e3 + "{" + r3 + "}", 0) : o2.addRule ? o2.addRule(e3, r3, 0) : i.warn("addStyleRule failed");
        }
        function u(t3) {
          var e3 = window.getComputedStyle(t3, null), r3 = e3.getPropertyValue("-webkit-transform") || e3.getPropertyValue("-moz-transform") || e3.getPropertyValue("-ms-transform") || e3.getPropertyValue("-o-transform") || e3.getPropertyValue("transform");
          return "none" === r3 ? null : r3.replace("matrix", "").replace("3d", "").slice(1, -1).split(",").map(function(t4) {
            return +t4;
          });
        }
        function c(t3) {
          for (var e3 = []; f2(t3); )
            e3.push(t3), t3 = t3.parentNode;
          return e3;
        }
        function f2(t3) {
          return t3 && (t3 instanceof Element || t3 instanceof HTMLElement);
        }
        t2.exports = { getGraphDiv: function(t3) {
          var e3;
          if ("string" == typeof t3) {
            if (null === (e3 = document.getElementById(t3)))
              throw new Error("No DOM element with id '" + t3 + "' exists on the page.");
            return e3;
          }
          if (null == t3)
            throw new Error("DOM element provided is null or undefined");
          return t3;
        }, isPlotDiv: function(t3) {
          var e3 = n2.select(t3);
          return e3.node() instanceof HTMLElement && e3.size() && e3.classed("js-plotly-plot");
        }, removeElement: s, addStyleRule: function(t3, e3) {
          l("global", t3, e3);
        }, addRelatedStyleRule: l, deleteRelatedStyleRule: function(t3) {
          var e3 = "plotly.js-style-" + t3, r3 = document.getElementById(e3);
          r3 && s(r3);
        }, getFullTransformMatrix: function(t3) {
          var e3 = c(t3), r3 = [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1];
          return e3.forEach(function(t4) {
            var e4 = u(t4);
            if (e4) {
              var n3 = a.convertCssMatrix(e4);
              r3 = o.multiply(r3, r3, n3);
            }
          }), r3;
        }, getElementTransformMatrix: u, getElementAndAncestors: c, equalDomRects: function(t3, e3) {
          return t3 && e3 && t3.top === e3.top && t3.left === e3.left && t3.right === e3.right && t3.bottom === e3.bottom;
        } };
      }, 11086: function(t2, e2, r2) {
        var n2 = r2(15398).EventEmitter, i = { init: function(t3) {
          if (t3._ev instanceof n2)
            return t3;
          var e3 = new n2(), r3 = new n2();
          return t3._ev = e3, t3._internalEv = r3, t3.on = e3.on.bind(e3), t3.once = e3.once.bind(e3), t3.removeListener = e3.removeListener.bind(e3), t3.removeAllListeners = e3.removeAllListeners.bind(e3), t3._internalOn = r3.on.bind(r3), t3._internalOnce = r3.once.bind(r3), t3._removeInternalListener = r3.removeListener.bind(r3), t3._removeAllInternalListeners = r3.removeAllListeners.bind(r3), t3.emit = function(n3, i2) {
            "undefined" != typeof jQuery && jQuery(t3).trigger(n3, i2), e3.emit(n3, i2), r3.emit(n3, i2);
          }, t3;
        }, triggerHandler: function(t3, e3, r3) {
          var n3, i2;
          "undefined" != typeof jQuery && (n3 = jQuery(t3).triggerHandler(e3, r3));
          var a = t3._ev;
          if (!a)
            return n3;
          var o, s = a._events[e3];
          if (!s)
            return n3;
          function l(t4) {
            return t4.listener ? (a.removeListener(e3, t4.listener), t4.fired ? void 0 : (t4.fired = true, t4.listener.apply(a, [r3]))) : t4.apply(a, [r3]);
          }
          for (s = Array.isArray(s) ? s : [s], o = 0; o < s.length - 1; o++)
            l(s[o]);
          return i2 = l(s[o]), void 0 !== n3 ? n3 : i2;
        }, purge: function(t3) {
          return delete t3._ev, delete t3.on, delete t3.once, delete t3.removeListener, delete t3.removeAllListeners, delete t3.emit, delete t3._ev, delete t3._internalEv, delete t3._internalOn, delete t3._internalOnce, delete t3._removeInternalListener, delete t3._removeAllInternalListeners, t3;
        } };
        t2.exports = i;
      }, 1426: function(t2, e2, r2) {
        var n2 = r2(41965), i = Array.isArray;
        function a(t3, e3, r3, o) {
          var s, l, u, c, f2, h, p2, d2 = t3[0], v = t3.length;
          if (2 === v && i(d2) && i(t3[1]) && 0 === d2.length) {
            if (p2 = function(t4, e4) {
              var r4, n3;
              for (r4 = 0; r4 < t4.length; r4++) {
                if (null !== (n3 = t4[r4]) && "object" == typeof n3)
                  return false;
                void 0 !== n3 && (e4[r4] = n3);
              }
              return true;
            }(t3[1], d2), p2)
              return d2;
            d2.splice(0, d2.length);
          }
          for (var g2 = 1; g2 < v; g2++)
            for (l in s = t3[g2])
              u = d2[l], c = s[l], o && i(c) ? d2[l] = c : e3 && c && (n2(c) || (f2 = i(c))) ? (f2 ? (f2 = false, h = u && i(u) ? u : []) : h = u && n2(u) ? u : {}, d2[l] = a([h, c], e3, r3, o)) : (void 0 !== c || r3) && (d2[l] = c);
          return d2;
        }
        e2.extendFlat = function() {
          return a(arguments, false, false, false);
        }, e2.extendDeep = function() {
          return a(arguments, true, false, false);
        }, e2.extendDeepAll = function() {
          return a(arguments, true, true, false);
        }, e2.extendDeepNoArrays = function() {
          return a(arguments, true, false, true);
        };
      }, 75744: function(t2) {
        t2.exports = function(t3) {
          for (var e2 = {}, r2 = [], n2 = 0, i = 0; i < t3.length; i++) {
            var a = t3[i];
            1 !== e2[a] && (e2[a] = 1, r2[n2++] = a);
          }
          return r2;
        };
      }, 76756: function(t2) {
        function e2(t3) {
          return true === t3.visible;
        }
        function r2(t3) {
          var e3 = t3[0].trace;
          return true === e3.visible && 0 !== e3._length;
        }
        t2.exports = function(t3) {
          for (var n2, i = (n2 = t3, Array.isArray(n2) && Array.isArray(n2[0]) && n2[0][0] && n2[0][0].trace ? r2 : e2), a = [], o = 0; o < t3.length; o++) {
            var s = t3[o];
            i(s) && a.push(s);
          }
          return a;
        };
      }, 41327: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(24138), a = r2(30774), o = r2(29261), s = r2(85268), l = r2(23389), u = r2(47769), c = r2(41965), f2 = r2(65487), h = r2(61082), p2 = Object.keys(i), d2 = { "ISO-3": l, "USA-states": l, "country names": function(t3) {
          for (var e3 = 0; e3 < p2.length; e3++) {
            var r3 = p2[e3];
            if (new RegExp(i[r3]).test(t3.trim().toLowerCase()))
              return r3;
          }
          return u.log("Unrecognized country name: " + t3 + "."), false;
        } };
        function v(t3) {
          var e3 = t3.geojson, r3 = window.PlotlyGeoAssets || {}, n3 = "string" == typeof e3 ? r3[e3] : e3;
          return c(n3) ? n3 : (u.error("Oops ... something went wrong when fetching " + e3), false);
        }
        t2.exports = { locationToFeature: function(t3, e3, r3) {
          if (!e3 || "string" != typeof e3)
            return false;
          var n3, i2, a2, o2 = d2[t3](e3);
          if (o2) {
            if ("USA-states" === t3)
              for (n3 = [], a2 = 0; a2 < r3.length; a2++)
                (i2 = r3[a2]).properties && i2.properties.gu && "USA" === i2.properties.gu && n3.push(i2);
            else
              n3 = r3;
            for (a2 = 0; a2 < n3.length; a2++)
              if ((i2 = n3[a2]).id === o2)
                return i2;
            u.log(["Location with id", o2, "does not have a matching topojson feature at this resolution."].join(" "));
          }
          return false;
        }, feature2polygons: function(t3) {
          var e3, r3, n3, i2, a2 = t3.geometry, o2 = a2.coordinates, s2 = t3.id, l2 = [];
          function u2(t4) {
            for (var e4 = 0; e4 < t4.length - 1; e4++)
              if (t4[e4][0] > 0 && t4[e4 + 1][0] < 0)
                return e4;
            return null;
          }
          switch (e3 = "RUS" === s2 || "FJI" === s2 ? function(t4) {
            var e4;
            if (null === u2(t4))
              e4 = t4;
            else
              for (e4 = new Array(t4.length), i2 = 0; i2 < t4.length; i2++)
                e4[i2] = [t4[i2][0] < 0 ? t4[i2][0] + 360 : t4[i2][0], t4[i2][1]];
            l2.push(h.tester(e4));
          } : "ATA" === s2 ? function(t4) {
            var e4 = u2(t4);
            if (null === e4)
              return l2.push(h.tester(t4));
            var r4 = new Array(t4.length + 1), n4 = 0;
            for (i2 = 0; i2 < t4.length; i2++)
              i2 > e4 ? r4[n4++] = [t4[i2][0] + 360, t4[i2][1]] : i2 === e4 ? (r4[n4++] = t4[i2], r4[n4++] = [t4[i2][0], -90]) : r4[n4++] = t4[i2];
            var a3 = h.tester(r4);
            a3.pts.pop(), l2.push(a3);
          } : function(t4) {
            l2.push(h.tester(t4));
          }, a2.type) {
            case "MultiPolygon":
              for (r3 = 0; r3 < o2.length; r3++)
                for (n3 = 0; n3 < o2[r3].length; n3++)
                  e3(o2[r3][n3]);
              break;
            case "Polygon":
              for (r3 = 0; r3 < o2.length; r3++)
                e3(o2[r3]);
          }
          return l2;
        }, getTraceGeojson: v, extractTraceFeature: function(t3) {
          var e3 = t3[0].trace, r3 = v(e3);
          if (!r3)
            return false;
          var n3, i2 = {}, s2 = [];
          for (n3 = 0; n3 < e3._length; n3++) {
            var l2 = t3[n3];
            (l2.loc || 0 === l2.loc) && (i2[l2.loc] = l2);
          }
          function c2(t4) {
            var r4 = f2(t4, e3.featureidkey || "id").get(), n4 = i2[r4];
            if (n4) {
              var l3 = t4.geometry;
              if ("Polygon" === l3.type || "MultiPolygon" === l3.type) {
                var c3 = { type: "Feature", id: r4, geometry: l3, properties: {} };
                c3.properties.ct = function(t5) {
                  var e4, r5 = t5.geometry;
                  if ("MultiPolygon" === r5.type)
                    for (var n5 = r5.coordinates, i3 = 0, s3 = 0; s3 < n5.length; s3++) {
                      var l4 = { type: "Polygon", coordinates: n5[s3] }, u2 = a.default(l4);
                      u2 > i3 && (i3 = u2, e4 = l4);
                    }
                  else
                    e4 = r5;
                  return o.default(e4).geometry.coordinates;
                }(c3), n4.fIn = t4, n4.fOut = c3, s2.push(c3);
              } else
                u.log(["Location", n4.loc, "does not have a valid GeoJSON geometry.", "Traces with locationmode *geojson-id* only support", "*Polygon* and *MultiPolygon* geometries."].join(" "));
            }
            delete i2[r4];
          }
          switch (r3.type) {
            case "FeatureCollection":
              var h2 = r3.features;
              for (n3 = 0; n3 < h2.length; n3++)
                c2(h2[n3]);
              break;
            case "Feature":
              c2(r3);
              break;
            default:
              return u.warn(["Invalid GeoJSON type", (r3.type || "none") + ".", "Traces with locationmode *geojson-id* only support", "*FeatureCollection* and *Feature* types."].join(" ")), false;
          }
          for (var p3 in i2)
            u.log(["Location *" + p3 + "*", "does not have a matching feature with id-key", "*" + e3.featureidkey + "*."].join(" "));
          return s2;
        }, fetchTraceGeoData: function(t3) {
          var e3 = window.PlotlyGeoAssets || {}, r3 = [];
          function i2(t4) {
            return new Promise(function(r4, i3) {
              n2.json(t4, function(n3, a3) {
                if (n3) {
                  delete e3[t4];
                  var o3 = 404 === n3.status ? 'GeoJSON at URL "' + t4 + '" does not exist.' : "Unexpected error while fetching from " + t4;
                  return i3(new Error(o3));
                }
                return e3[t4] = a3, r4(a3);
              });
            });
          }
          function a2(t4) {
            return new Promise(function(r4, n3) {
              var i3 = 0, a3 = setInterval(function() {
                return e3[t4] && "pending" !== e3[t4] ? (clearInterval(a3), r4(e3[t4])) : i3 > 100 ? (clearInterval(a3), n3("Unexpected error while fetching from " + t4)) : void i3++;
              }, 50);
            });
          }
          for (var o2 = 0; o2 < t3.length; o2++) {
            var s2 = t3[o2][0].trace.geojson;
            "string" == typeof s2 && (e3[s2] ? "pending" === e3[s2] && r3.push(a2(s2)) : (e3[s2] = "pending", r3.push(i2(s2))));
          }
          return r3;
        }, computeBbox: function(t3) {
          return s.default(t3);
        } };
      }, 18214: function(t2, e2, r2) {
        var n2 = r2(50606).BADNUM;
        e2.calcTraceToLineCoords = function(t3) {
          for (var e3 = t3[0].trace.connectgaps, r3 = [], i = [], a = 0; a < t3.length; a++) {
            var o = t3[a].lonlat;
            o[0] !== n2 ? i.push(o) : !e3 && i.length > 0 && (r3.push(i), i = []);
          }
          return i.length > 0 && r3.push(i), r3;
        }, e2.makeLine = function(t3) {
          return 1 === t3.length ? { type: "LineString", coordinates: t3[0] } : { type: "MultiLineString", coordinates: t3 };
        }, e2.makePolygon = function(t3) {
          if (1 === t3.length)
            return { type: "Polygon", coordinates: t3 };
          for (var e3 = new Array(t3.length), r3 = 0; r3 < t3.length; r3++)
            e3[r3] = [t3[r3]];
          return { type: "MultiPolygon", coordinates: e3 };
        }, e2.makeBlank = function() {
          return { type: "Point", coordinates: [] };
        };
      }, 87642: function(t2, e2, r2) {
        var n2, i, a, o = r2(64872).mod;
        function s(t3, e3, r3, n3, i2, a2, o2, s2) {
          var l2 = r3 - t3, u = i2 - t3, c = o2 - i2, f2 = n3 - e3, h = a2 - e3, p2 = s2 - a2, d2 = l2 * p2 - c * f2;
          if (0 === d2)
            return null;
          var v = (u * p2 - c * h) / d2, g2 = (u * f2 - l2 * h) / d2;
          return g2 < 0 || g2 > 1 || v < 0 || v > 1 ? null : { x: t3 + l2 * v, y: e3 + f2 * v };
        }
        function l(t3, e3, r3, n3, i2) {
          var a2 = n3 * t3 + i2 * e3;
          if (a2 < 0)
            return n3 * n3 + i2 * i2;
          if (a2 > r3) {
            var o2 = n3 - t3, s2 = i2 - e3;
            return o2 * o2 + s2 * s2;
          }
          var l2 = n3 * e3 - i2 * t3;
          return l2 * l2 / r3;
        }
        e2.segmentsIntersect = s, e2.segmentDistance = function(t3, e3, r3, n3, i2, a2, o2, u) {
          if (s(t3, e3, r3, n3, i2, a2, o2, u))
            return 0;
          var c = r3 - t3, f2 = n3 - e3, h = o2 - i2, p2 = u - a2, d2 = c * c + f2 * f2, v = h * h + p2 * p2, g2 = Math.min(l(c, f2, d2, i2 - t3, a2 - e3), l(c, f2, d2, o2 - t3, u - e3), l(h, p2, v, t3 - i2, e3 - a2), l(h, p2, v, r3 - i2, n3 - a2));
          return Math.sqrt(g2);
        }, e2.getTextLocation = function(t3, e3, r3, s2) {
          if (t3 === i && s2 === a || (n2 = {}, i = t3, a = s2), n2[r3])
            return n2[r3];
          var l2 = t3.getPointAtLength(o(r3 - s2 / 2, e3)), u = t3.getPointAtLength(o(r3 + s2 / 2, e3)), c = Math.atan((u.y - l2.y) / (u.x - l2.x)), f2 = t3.getPointAtLength(o(r3, e3)), h = { x: (4 * f2.x + l2.x + u.x) / 6, y: (4 * f2.y + l2.y + u.y) / 6, theta: c };
          return n2[r3] = h, h;
        }, e2.clearLocationCache = function() {
          i = null;
        }, e2.getVisibleSegment = function(t3, e3, r3) {
          var n3, i2, a2 = e3.left, o2 = e3.right, s2 = e3.top, l2 = e3.bottom, u = 0, c = t3.getTotalLength(), f2 = c;
          function h(e4) {
            var r4 = t3.getPointAtLength(e4);
            0 === e4 ? n3 = r4 : e4 === c && (i2 = r4);
            var u2 = r4.x < a2 ? a2 - r4.x : r4.x > o2 ? r4.x - o2 : 0, f3 = r4.y < s2 ? s2 - r4.y : r4.y > l2 ? r4.y - l2 : 0;
            return Math.sqrt(u2 * u2 + f3 * f3);
          }
          for (var p2 = h(u); p2; ) {
            if ((u += p2 + r3) > f2)
              return;
            p2 = h(u);
          }
          for (p2 = h(f2); p2; ) {
            if (u > (f2 -= p2 + r3))
              return;
            p2 = h(f2);
          }
          return { min: u, max: f2, len: f2 - u, total: c, isClosed: 0 === u && f2 === c && Math.abs(n3.x - i2.x) < 0.1 && Math.abs(n3.y - i2.y) < 0.1 };
        }, e2.findPointOnPath = function(t3, e3, r3, n3) {
          for (var i2, a2, o2, s2 = (n3 = n3 || {}).pathLength || t3.getTotalLength(), l2 = n3.tolerance || 1e-3, u = n3.iterationLimit || 30, c = t3.getPointAtLength(0)[r3] > t3.getPointAtLength(s2)[r3] ? -1 : 1, f2 = 0, h = 0, p2 = s2; f2 < u; ) {
            if (i2 = (h + p2) / 2, o2 = (a2 = t3.getPointAtLength(i2))[r3] - e3, Math.abs(o2) < l2)
              return a2;
            c * o2 > 0 ? p2 = i2 : h = i2, f2++;
          }
          return a2;
        };
      }, 81697: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(84267), a = r2(25075), o = r2(21081), s = r2(22399).defaultLine, l = r2(73627).isArrayOrTypedArray, u = a(s);
        function c(t3, e3) {
          var r3 = t3;
          return r3[3] *= e3, r3;
        }
        function f2(t3) {
          if (n2(t3))
            return u;
          var e3 = a(t3);
          return e3.length ? e3 : u;
        }
        function h(t3) {
          return n2(t3) ? t3 : 1;
        }
        t2.exports = { formatColor: function(t3, e3, r3) {
          var n3, i2, s2, p2, d2, v = t3.color, g2 = l(v), y = l(e3), m2 = o.extractOpts(t3), x = [];
          if (n3 = void 0 !== m2.colorscale ? o.makeColorScaleFuncFromTrace(t3) : f2, i2 = g2 ? function(t4, e4) {
            return void 0 === t4[e4] ? u : a(n3(t4[e4]));
          } : f2, s2 = y ? function(t4, e4) {
            return void 0 === t4[e4] ? 1 : h(t4[e4]);
          } : h, g2 || y)
            for (var b = 0; b < r3; b++)
              p2 = i2(v, b), d2 = s2(e3, b), x[b] = c(p2, d2);
          else
            x = c(a(v), e3);
          return x;
        }, parseColorScale: function(t3) {
          var e3 = o.extractOpts(t3), r3 = e3.colorscale;
          return e3.reversescale && (r3 = o.flipScale(e3.colorscale)), r3.map(function(t4) {
            var e4 = t4[0], r4 = i(t4[1]).toRgb();
            return { index: e4, rgb: [r4.r, r4.g, r4.b, r4.a] };
          });
        } };
      }, 28984: function(t2, e2, r2) {
        var n2 = r2(23389);
        function i(t3) {
          return [t3];
        }
        t2.exports = { keyFun: function(t3) {
          return t3.key;
        }, repeat: i, descend: n2, wrap: i, unwrap: function(t3) {
          return t3[0];
        } };
      }, 23389: function(t2) {
        t2.exports = function(t3) {
          return t3;
        };
      }, 39240: function(t2) {
        t2.exports = function(t3, e2) {
          if (!e2)
            return t3;
          var r2 = 1 / Math.abs(e2), n2 = r2 > 1 ? (r2 * t3 + r2 * e2) / r2 : t3 + e2, i = String(n2).length;
          if (i > 16) {
            var a = String(e2).length;
            if (i >= String(t3).length + a) {
              var o = parseFloat(n2).toPrecision(12);
              -1 === o.indexOf("e+") && (n2 = +o);
            }
          }
          return n2;
        };
      }, 71828: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(84096).g0, a = r2(60721).WU, o = r2(92770), s = r2(50606), l = s.FP_SAFE, u = -l, c = s.BADNUM, f2 = t2.exports = {};
        f2.adjustFormat = function(t3) {
          return !t3 || /^\d[.]\df/.test(t3) || /[.]\d%/.test(t3) ? t3 : "0.f" === t3 ? "~f" : /^\d%/.test(t3) ? "~%" : /^\ds/.test(t3) ? "~s" : !/^[~,.0$]/.test(t3) && /[&fps]/.test(t3) ? "~" + t3 : t3;
        };
        var h = {};
        f2.warnBadFormat = function(t3) {
          var e3 = String(t3);
          h[e3] || (h[e3] = 1, f2.warn('encountered bad format: "' + e3 + '"'));
        }, f2.noFormat = function(t3) {
          return String(t3);
        }, f2.numberFormat = function(t3) {
          var e3;
          try {
            e3 = a(f2.adjustFormat(t3));
          } catch (e4) {
            return f2.warnBadFormat(t3), f2.noFormat;
          }
          return e3;
        }, f2.nestedProperty = r2(65487), f2.keyedContainer = r2(66636), f2.relativeAttr = r2(6962), f2.isPlainObject = r2(41965), f2.toLogRange = r2(58163), f2.relinkPrivateKeys = r2(51332);
        var p2 = r2(73627);
        f2.isTypedArray = p2.isTypedArray, f2.isArrayOrTypedArray = p2.isArrayOrTypedArray, f2.isArray1D = p2.isArray1D, f2.ensureArray = p2.ensureArray, f2.concat = p2.concat, f2.maxRowLength = p2.maxRowLength, f2.minRowLength = p2.minRowLength;
        var d2 = r2(64872);
        f2.mod = d2.mod, f2.modHalf = d2.modHalf;
        var v = r2(96554);
        f2.valObjectMeta = v.valObjectMeta, f2.coerce = v.coerce, f2.coerce2 = v.coerce2, f2.coerceFont = v.coerceFont, f2.coercePattern = v.coercePattern, f2.coerceHoverinfo = v.coerceHoverinfo, f2.coerceSelectionMarkerOpacity = v.coerceSelectionMarkerOpacity, f2.validate = v.validate;
        var g2 = r2(41631);
        f2.dateTime2ms = g2.dateTime2ms, f2.isDateTime = g2.isDateTime, f2.ms2DateTime = g2.ms2DateTime, f2.ms2DateTimeLocal = g2.ms2DateTimeLocal, f2.cleanDate = g2.cleanDate, f2.isJSDate = g2.isJSDate, f2.formatDate = g2.formatDate, f2.incrementMonth = g2.incrementMonth, f2.dateTick0 = g2.dateTick0, f2.dfltRange = g2.dfltRange, f2.findExactDates = g2.findExactDates, f2.MIN_MS = g2.MIN_MS, f2.MAX_MS = g2.MAX_MS;
        var y = r2(65888);
        f2.findBin = y.findBin, f2.sorterAsc = y.sorterAsc, f2.sorterDes = y.sorterDes, f2.distinctVals = y.distinctVals, f2.roundUp = y.roundUp, f2.sort = y.sort, f2.findIndexOfMin = y.findIndexOfMin, f2.sortObjectKeys = r2(78607);
        var m2 = r2(80038);
        f2.aggNums = m2.aggNums, f2.len = m2.len, f2.mean = m2.mean, f2.median = m2.median, f2.midRange = m2.midRange, f2.variance = m2.variance, f2.stdev = m2.stdev, f2.interp = m2.interp;
        var x = r2(35657);
        f2.init2dArray = x.init2dArray, f2.transposeRagged = x.transposeRagged, f2.dot = x.dot, f2.translationMatrix = x.translationMatrix, f2.rotationMatrix = x.rotationMatrix, f2.rotationXYMatrix = x.rotationXYMatrix, f2.apply3DTransform = x.apply3DTransform, f2.apply2DTransform = x.apply2DTransform, f2.apply2DTransform2 = x.apply2DTransform2, f2.convertCssMatrix = x.convertCssMatrix, f2.inverseTransformMatrix = x.inverseTransformMatrix;
        var b = r2(26348);
        f2.deg2rad = b.deg2rad, f2.rad2deg = b.rad2deg, f2.angleDelta = b.angleDelta, f2.angleDist = b.angleDist, f2.isFullCircle = b.isFullCircle, f2.isAngleInsideSector = b.isAngleInsideSector, f2.isPtInsideSector = b.isPtInsideSector, f2.pathArc = b.pathArc, f2.pathSector = b.pathSector, f2.pathAnnulus = b.pathAnnulus;
        var _ = r2(99863);
        f2.isLeftAnchor = _.isLeftAnchor, f2.isCenterAnchor = _.isCenterAnchor, f2.isRightAnchor = _.isRightAnchor, f2.isTopAnchor = _.isTopAnchor, f2.isMiddleAnchor = _.isMiddleAnchor, f2.isBottomAnchor = _.isBottomAnchor;
        var w2 = r2(87642);
        f2.segmentsIntersect = w2.segmentsIntersect, f2.segmentDistance = w2.segmentDistance, f2.getTextLocation = w2.getTextLocation, f2.clearLocationCache = w2.clearLocationCache, f2.getVisibleSegment = w2.getVisibleSegment, f2.findPointOnPath = w2.findPointOnPath;
        var T = r2(1426);
        f2.extendFlat = T.extendFlat, f2.extendDeep = T.extendDeep, f2.extendDeepAll = T.extendDeepAll, f2.extendDeepNoArrays = T.extendDeepNoArrays;
        var k = r2(47769);
        f2.log = k.log, f2.warn = k.warn, f2.error = k.error;
        var A = r2(30587);
        f2.counterRegex = A.counter;
        var M = r2(79990);
        f2.throttle = M.throttle, f2.throttleDone = M.done, f2.clearThrottle = M.clear;
        var S = r2(24401);
        function E(t3) {
          var e3 = {};
          for (var r3 in t3)
            for (var n3 = t3[r3], i2 = 0; i2 < n3.length; i2++)
              e3[n3[i2]] = +r3;
          return e3;
        }
        f2.getGraphDiv = S.getGraphDiv, f2.isPlotDiv = S.isPlotDiv, f2.removeElement = S.removeElement, f2.addStyleRule = S.addStyleRule, f2.addRelatedStyleRule = S.addRelatedStyleRule, f2.deleteRelatedStyleRule = S.deleteRelatedStyleRule, f2.getFullTransformMatrix = S.getFullTransformMatrix, f2.getElementTransformMatrix = S.getElementTransformMatrix, f2.getElementAndAncestors = S.getElementAndAncestors, f2.equalDomRects = S.equalDomRects, f2.clearResponsive = r2(86367), f2.preserveDrawingBuffer = r2(45142), f2.makeTraceGroups = r2(77310), f2._ = r2(15867), f2.notifier = r2(75046), f2.filterUnique = r2(75744), f2.filterVisible = r2(76756), f2.pushUnique = r2(75138), f2.increment = r2(39240), f2.cleanNumber = r2(95218), f2.ensureNumber = function(t3) {
          return o(t3) ? (t3 = Number(t3)) > l || t3 < u ? c : t3 : c;
        }, f2.isIndex = function(t3, e3) {
          return !(void 0 !== e3 && t3 >= e3) && o(t3) && t3 >= 0 && t3 % 1 == 0;
        }, f2.noop = r2(64213), f2.identity = r2(23389), f2.repeat = function(t3, e3) {
          for (var r3 = new Array(e3), n3 = 0; n3 < e3; n3++)
            r3[n3] = t3;
          return r3;
        }, f2.swapAttrs = function(t3, e3, r3, n3) {
          r3 || (r3 = "x"), n3 || (n3 = "y");
          for (var i2 = 0; i2 < e3.length; i2++) {
            var a2 = e3[i2], o2 = f2.nestedProperty(t3, a2.replace("?", r3)), s2 = f2.nestedProperty(t3, a2.replace("?", n3)), l2 = o2.get();
            o2.set(s2.get()), s2.set(l2);
          }
        }, f2.raiseToTop = function(t3) {
          t3.parentNode.appendChild(t3);
        }, f2.cancelTransition = function(t3) {
          return t3.transition().duration(0);
        }, f2.constrain = function(t3, e3, r3) {
          return e3 > r3 ? Math.max(r3, Math.min(e3, t3)) : Math.max(e3, Math.min(r3, t3));
        }, f2.bBoxIntersect = function(t3, e3, r3) {
          return r3 = r3 || 0, t3.left <= e3.right + r3 && e3.left <= t3.right + r3 && t3.top <= e3.bottom + r3 && e3.top <= t3.bottom + r3;
        }, f2.simpleMap = function(t3, e3, r3, n3, i2) {
          for (var a2 = t3.length, o2 = new Array(a2), s2 = 0; s2 < a2; s2++)
            o2[s2] = e3(t3[s2], r3, n3, i2);
          return o2;
        }, f2.randstr = function t3(e3, r3, n3, i2) {
          if (n3 || (n3 = 16), void 0 === r3 && (r3 = 24), r3 <= 0)
            return "0";
          var a2, o2, s2 = Math.log(Math.pow(2, r3)) / Math.log(n3), l2 = "";
          for (a2 = 2; s2 === 1 / 0; a2 *= 2)
            s2 = Math.log(Math.pow(2, r3 / a2)) / Math.log(n3) * a2;
          var u2 = s2 - Math.floor(s2);
          for (a2 = 0; a2 < Math.floor(s2); a2++)
            l2 = Math.floor(Math.random() * n3).toString(n3) + l2;
          u2 && (o2 = Math.pow(n3, u2), l2 = Math.floor(Math.random() * o2).toString(n3) + l2);
          var c2 = parseInt(l2, n3);
          return e3 && e3[l2] || c2 !== 1 / 0 && c2 >= Math.pow(2, r3) ? i2 > 10 ? (f2.warn("randstr failed uniqueness"), l2) : t3(e3, r3, n3, (i2 || 0) + 1) : l2;
        }, f2.OptionControl = function(t3, e3) {
          t3 || (t3 = {}), e3 || (e3 = "opt");
          var r3 = { optionList: [], _newoption: function(n3) {
            n3[e3] = t3, r3[n3.name] = n3, r3.optionList.push(n3);
          } };
          return r3["_" + e3] = t3, r3;
        }, f2.smooth = function(t3, e3) {
          if ((e3 = Math.round(e3) || 0) < 2)
            return t3;
          var r3, n3, i2, a2, o2 = t3.length, s2 = 2 * o2, l2 = 2 * e3 - 1, u2 = new Array(l2), c2 = new Array(o2);
          for (r3 = 0; r3 < l2; r3++)
            u2[r3] = (1 - Math.cos(Math.PI * (r3 + 1) / e3)) / (2 * e3);
          for (r3 = 0; r3 < o2; r3++) {
            for (a2 = 0, n3 = 0; n3 < l2; n3++)
              (i2 = r3 + n3 + 1 - e3) < -o2 ? i2 -= s2 * Math.round(i2 / s2) : i2 >= s2 && (i2 -= s2 * Math.floor(i2 / s2)), i2 < 0 ? i2 = -1 - i2 : i2 >= o2 && (i2 = s2 - 1 - i2), a2 += t3[i2] * u2[n3];
            c2[r3] = a2;
          }
          return c2;
        }, f2.syncOrAsync = function(t3, e3, r3) {
          var n3;
          function i2() {
            return f2.syncOrAsync(t3, e3, r3);
          }
          for (; t3.length; )
            if ((n3 = (0, t3.splice(0, 1)[0])(e3)) && n3.then)
              return n3.then(i2);
          return r3 && r3(e3);
        }, f2.stripTrailingSlash = function(t3) {
          return "/" === t3.substr(-1) ? t3.substr(0, t3.length - 1) : t3;
        }, f2.noneOrAll = function(t3, e3, r3) {
          if (t3) {
            var n3, i2 = false, a2 = true;
            for (n3 = 0; n3 < r3.length; n3++)
              null != t3[r3[n3]] ? i2 = true : a2 = false;
            if (i2 && !a2)
              for (n3 = 0; n3 < r3.length; n3++)
                t3[r3[n3]] = e3[r3[n3]];
          }
        }, f2.mergeArray = function(t3, e3, r3, n3) {
          var i2 = "function" == typeof n3;
          if (f2.isArrayOrTypedArray(t3))
            for (var a2 = Math.min(t3.length, e3.length), o2 = 0; o2 < a2; o2++) {
              var s2 = t3[o2];
              e3[o2][r3] = i2 ? n3(s2) : s2;
            }
        }, f2.mergeArrayCastPositive = function(t3, e3, r3) {
          return f2.mergeArray(t3, e3, r3, function(t4) {
            var e4 = +t4;
            return isFinite(e4) && e4 > 0 ? e4 : 0;
          });
        }, f2.fillArray = function(t3, e3, r3, n3) {
          if (n3 = n3 || f2.identity, f2.isArrayOrTypedArray(t3))
            for (var i2 = 0; i2 < e3.length; i2++)
              e3[i2][r3] = n3(t3[i2]);
        }, f2.castOption = function(t3, e3, r3, n3) {
          n3 = n3 || f2.identity;
          var i2 = f2.nestedProperty(t3, r3).get();
          return f2.isArrayOrTypedArray(i2) ? Array.isArray(e3) && f2.isArrayOrTypedArray(i2[e3[0]]) ? n3(i2[e3[0]][e3[1]]) : n3(i2[e3]) : i2;
        }, f2.extractOption = function(t3, e3, r3, n3) {
          if (r3 in t3)
            return t3[r3];
          var i2 = f2.nestedProperty(e3, n3).get();
          return Array.isArray(i2) ? void 0 : i2;
        }, f2.tagSelected = function(t3, e3, r3) {
          var n3, i2, a2 = e3.selectedpoints, o2 = e3._indexToPoints;
          o2 && (n3 = E(o2));
          for (var s2 = 0; s2 < a2.length; s2++) {
            var l2 = a2[s2];
            if (f2.isIndex(l2) || f2.isArrayOrTypedArray(l2) && f2.isIndex(l2[0]) && f2.isIndex(l2[1])) {
              var u2 = n3 ? n3[l2] : l2, c2 = r3 ? r3[u2] : u2;
              void 0 !== (i2 = c2) && i2 < t3.length && (t3[c2].selected = 1);
            }
          }
        }, f2.selIndices2selPoints = function(t3) {
          var e3 = t3.selectedpoints, r3 = t3._indexToPoints;
          if (r3) {
            for (var n3 = E(r3), i2 = [], a2 = 0; a2 < e3.length; a2++) {
              var o2 = e3[a2];
              if (f2.isIndex(o2)) {
                var s2 = n3[o2];
                f2.isIndex(s2) && i2.push(s2);
              }
            }
            return i2;
          }
          return e3;
        }, f2.getTargetArray = function(t3, e3) {
          var r3 = e3.target;
          if ("string" == typeof r3 && r3) {
            var n3 = f2.nestedProperty(t3, r3).get();
            return !!Array.isArray(n3) && n3;
          }
          return !!Array.isArray(r3) && r3;
        }, f2.minExtend = function(t3, e3) {
          var r3 = {};
          "object" != typeof e3 && (e3 = {});
          var n3, i2, a2, o2 = Object.keys(t3);
          for (n3 = 0; n3 < o2.length; n3++)
            a2 = t3[i2 = o2[n3]], "_" !== i2.charAt(0) && "function" != typeof a2 && ("module" === i2 ? r3[i2] = a2 : Array.isArray(a2) ? r3[i2] = "colorscale" === i2 ? a2.slice() : a2.slice(0, 3) : f2.isTypedArray(a2) ? r3[i2] = a2.subarray(0, 3) : r3[i2] = a2 && "object" == typeof a2 ? f2.minExtend(t3[i2], e3[i2]) : a2);
          for (o2 = Object.keys(e3), n3 = 0; n3 < o2.length; n3++)
            "object" == typeof (a2 = e3[i2 = o2[n3]]) && i2 in r3 && "object" == typeof r3[i2] || (r3[i2] = a2);
          return r3;
        }, f2.titleCase = function(t3) {
          return t3.charAt(0).toUpperCase() + t3.substr(1);
        }, f2.containsAny = function(t3, e3) {
          for (var r3 = 0; r3 < e3.length; r3++)
            if (-1 !== t3.indexOf(e3[r3]))
              return true;
          return false;
        }, f2.isIE = function() {
          return void 0 !== window.navigator.msSaveBlob;
        };
        var L = /Version\/[\d\.]+.*Safari/;
        f2.isSafari = function() {
          return L.test(window.navigator.userAgent);
        };
        var C = /iPad|iPhone|iPod/;
        f2.isIOS = function() {
          return C.test(window.navigator.userAgent);
        };
        var P = /Firefox\/(\d+)\.\d+/;
        f2.getFirefoxVersion = function() {
          var t3 = P.exec(window.navigator.userAgent);
          if (t3 && 2 === t3.length) {
            var e3 = parseInt(t3[1]);
            if (!isNaN(e3))
              return e3;
          }
          return null;
        }, f2.isD3Selection = function(t3) {
          return t3 instanceof n2.selection;
        }, f2.ensureSingle = function(t3, e3, r3, n3) {
          var i2 = t3.select(e3 + (r3 ? "." + r3 : ""));
          if (i2.size())
            return i2;
          var a2 = t3.append(e3);
          return r3 && a2.classed(r3, true), n3 && a2.call(n3), a2;
        }, f2.ensureSingleById = function(t3, e3, r3, n3) {
          var i2 = t3.select(e3 + "#" + r3);
          if (i2.size())
            return i2;
          var a2 = t3.append(e3).attr("id", r3);
          return n3 && a2.call(n3), a2;
        }, f2.objectFromPath = function(t3, e3) {
          for (var r3, n3 = t3.split("."), i2 = r3 = {}, a2 = 0; a2 < n3.length; a2++) {
            var o2 = n3[a2], s2 = null, l2 = n3[a2].match(/(.*)\[([0-9]+)\]/);
            l2 ? (o2 = l2[1], s2 = l2[2], r3 = r3[o2] = [], a2 === n3.length - 1 ? r3[s2] = e3 : r3[s2] = {}, r3 = r3[s2]) : (a2 === n3.length - 1 ? r3[o2] = e3 : r3[o2] = {}, r3 = r3[o2]);
          }
          return i2;
        };
        var O = /^([^\[\.]+)\.(.+)?/, I = /^([^\.]+)\[([0-9]+)\](\.)?(.+)?/;
        f2.expandObjectPaths = function(t3) {
          var e3, r3, n3, i2, a2, o2, s2;
          if ("object" == typeof t3 && !Array.isArray(t3))
            for (r3 in t3)
              t3.hasOwnProperty(r3) && ((e3 = r3.match(O)) ? (i2 = t3[r3], n3 = e3[1], delete t3[r3], t3[n3] = f2.extendDeepNoArrays(t3[n3] || {}, f2.objectFromPath(r3, f2.expandObjectPaths(i2))[n3])) : (e3 = r3.match(I)) ? (i2 = t3[r3], n3 = e3[1], a2 = parseInt(e3[2]), delete t3[r3], t3[n3] = t3[n3] || [], "." === e3[3] ? (s2 = e3[4], o2 = t3[n3][a2] = t3[n3][a2] || {}, f2.extendDeepNoArrays(o2, f2.objectFromPath(s2, f2.expandObjectPaths(i2)))) : t3[n3][a2] = f2.expandObjectPaths(i2)) : t3[r3] = f2.expandObjectPaths(t3[r3]));
          return t3;
        }, f2.numSeparate = function(t3, e3, r3) {
          if (r3 || (r3 = false), "string" != typeof e3 || 0 === e3.length)
            throw new Error("Separator string required for formatting!");
          "number" == typeof t3 && (t3 = String(t3));
          var n3 = /(\d+)(\d{3})/, i2 = e3.charAt(0), a2 = e3.charAt(1), o2 = t3.split("."), s2 = o2[0], l2 = o2.length > 1 ? i2 + o2[1] : "";
          if (a2 && (o2.length > 1 || s2.length > 4 || r3))
            for (; n3.test(s2); )
              s2 = s2.replace(n3, "$1" + a2 + "$2");
          return s2 + l2;
        }, f2.TEMPLATE_STRING_REGEX = /%{([^\s%{}:]*)([:|\|][^}]*)?}/g;
        var D = /^\w*$/;
        f2.templateString = function(t3, e3) {
          var r3 = {};
          return t3.replace(f2.TEMPLATE_STRING_REGEX, function(t4, n3) {
            var i2;
            return D.test(n3) ? i2 = e3[n3] : (r3[n3] = r3[n3] || f2.nestedProperty(e3, n3).get, i2 = r3[n3]()), f2.isValidTextValue(i2) ? i2 : "";
          });
        };
        var z = { max: 10, count: 0, name: "hovertemplate" };
        f2.hovertemplateString = function() {
          return B.apply(z, arguments);
        };
        var R = { max: 10, count: 0, name: "texttemplate" };
        f2.texttemplateString = function() {
          return B.apply(R, arguments);
        };
        var F = /^[:|\|]/;
        function B(t3, e3, r3) {
          var n3 = this, a2 = arguments;
          e3 || (e3 = {});
          var o2 = {};
          return t3.replace(f2.TEMPLATE_STRING_REGEX, function(t4, s2, l2) {
            var u2, c2, h2, p3 = "_xother" === s2 || "_yother" === s2, d3 = "_xother_" === s2 || "_yother_" === s2, v2 = "xother_" === s2 || "yother_" === s2, g3 = "xother" === s2 || "yother" === s2 || p3 || v2 || d3, y2 = s2;
            if ((p3 || d3) && (y2 = y2.substring(1)), (v2 || d3) && (y2 = y2.substring(0, y2.length - 1)), g3) {
              if (void 0 === (u2 = e3[y2]))
                return "";
            } else
              for (h2 = 3; h2 < a2.length; h2++)
                if (c2 = a2[h2]) {
                  if (c2.hasOwnProperty(y2)) {
                    u2 = c2[y2];
                    break;
                  }
                  if (D.test(y2) || (u2 = f2.nestedProperty(c2, y2).get(), (u2 = o2[y2] || f2.nestedProperty(c2, y2).get()) && (o2[y2] = u2)), void 0 !== u2)
                    break;
                }
            if (void 0 === u2 && n3)
              return n3.count < n3.max && (f2.warn("Variable '" + y2 + "' in " + n3.name + " could not be found!"), u2 = t4), n3.count === n3.max && f2.warn("Too many " + n3.name + " warnings - additional warnings will be suppressed"), n3.count++, t4;
            if (l2) {
              var m3;
              if (":" === l2[0] && (u2 = (m3 = r3 ? r3.numberFormat : f2.numberFormat)(l2.replace(F, ""))(u2)), "|" === l2[0]) {
                m3 = r3 ? r3.timeFormat : i;
                var x2 = f2.dateTime2ms(u2);
                u2 = f2.formatDate(x2, l2.replace(F, ""), false, m3);
              }
            } else {
              var b2 = y2 + "Label";
              e3.hasOwnProperty(b2) && (u2 = e3[b2]);
            }
            return g3 && (u2 = "(" + u2 + ")", (p3 || d3) && (u2 = " " + u2), (v2 || d3) && (u2 += " ")), u2;
          });
        }
        f2.subplotSort = function(t3, e3) {
          for (var r3 = Math.min(t3.length, e3.length) + 1, n3 = 0, i2 = 0, a2 = 0; a2 < r3; a2++) {
            var o2 = t3.charCodeAt(a2) || 0, s2 = e3.charCodeAt(a2) || 0, l2 = o2 >= 48 && o2 <= 57, u2 = s2 >= 48 && s2 <= 57;
            if (l2 && (n3 = 10 * n3 + o2 - 48), u2 && (i2 = 10 * i2 + s2 - 48), !l2 || !u2) {
              if (n3 !== i2)
                return n3 - i2;
              if (o2 !== s2)
                return o2 - s2;
            }
          }
          return i2 - n3;
        };
        var N = 2e9;
        f2.seedPseudoRandom = function() {
          N = 2e9;
        }, f2.pseudoRandom = function() {
          var t3 = N;
          return N = (69069 * N + 1) % 4294967296, Math.abs(N - t3) < 429496729 ? f2.pseudoRandom() : N / 4294967296;
        }, f2.fillText = function(t3, e3, r3) {
          var n3 = Array.isArray(r3) ? function(t4) {
            r3.push(t4);
          } : function(t4) {
            r3.text = t4;
          }, i2 = f2.extractOption(t3, e3, "htx", "hovertext");
          if (f2.isValidTextValue(i2))
            return n3(i2);
          var a2 = f2.extractOption(t3, e3, "tx", "text");
          return f2.isValidTextValue(a2) ? n3(a2) : void 0;
        }, f2.isValidTextValue = function(t3) {
          return t3 || 0 === t3;
        }, f2.formatPercent = function(t3, e3) {
          e3 = e3 || 0;
          for (var r3 = (Math.round(100 * t3 * Math.pow(10, e3)) * Math.pow(0.1, e3)).toFixed(e3) + "%", n3 = 0; n3 < e3; n3++)
            -1 !== r3.indexOf(".") && (r3 = (r3 = r3.replace("0%", "%")).replace(".%", "%"));
          return r3;
        }, f2.isHidden = function(t3) {
          var e3 = window.getComputedStyle(t3).display;
          return !e3 || "none" === e3;
        }, f2.strTranslate = function(t3, e3) {
          return t3 || e3 ? "translate(" + t3 + "," + e3 + ")" : "";
        }, f2.strRotate = function(t3) {
          return t3 ? "rotate(" + t3 + ")" : "";
        }, f2.strScale = function(t3) {
          return 1 !== t3 ? "scale(" + t3 + ")" : "";
        }, f2.getTextTransform = function(t3) {
          var e3 = t3.noCenter, r3 = t3.textX, n3 = t3.textY, i2 = t3.targetX, a2 = t3.targetY, o2 = t3.anchorX || 0, s2 = t3.anchorY || 0, l2 = t3.rotate, u2 = t3.scale;
          return u2 ? u2 > 1 && (u2 = 1) : u2 = 0, f2.strTranslate(i2 - u2 * (r3 + o2), a2 - u2 * (n3 + s2)) + f2.strScale(u2) + (l2 ? "rotate(" + l2 + (e3 ? "" : " " + r3 + " " + n3) + ")" : "");
        }, f2.setTransormAndDisplay = function(t3, e3) {
          t3.attr("transform", f2.getTextTransform(e3)), t3.style("display", e3.scale ? null : "none");
        }, f2.ensureUniformFontSize = function(t3, e3) {
          var r3 = f2.extendFlat({}, e3);
          return r3.size = Math.max(e3.size, t3._fullLayout.uniformtext.minsize || 0), r3;
        }, f2.join2 = function(t3, e3, r3) {
          var n3 = t3.length;
          return n3 > 1 ? t3.slice(0, -1).join(e3) + r3 + t3[n3 - 1] : t3.join(e3);
        }, f2.bigFont = function(t3) {
          return Math.round(1.2 * t3);
        };
        var j = f2.getFirefoxVersion(), U = null !== j && j < 86;
        f2.getPositionFromD3Event = function() {
          return U ? [n2.event.layerX, n2.event.layerY] : [n2.event.offsetX, n2.event.offsetY];
        };
      }, 41965: function(t2) {
        t2.exports = function(t3) {
          return window && window.process && window.process.versions ? "[object Object]" === Object.prototype.toString.call(t3) : "[object Object]" === Object.prototype.toString.call(t3) && Object.getPrototypeOf(t3).hasOwnProperty("hasOwnProperty");
        };
      }, 66636: function(t2, e2, r2) {
        var n2 = r2(65487), i = /^\w*$/;
        t2.exports = function(t3, e3, r3, a) {
          var o, s, l;
          r3 = r3 || "name", a = a || "value";
          var u = {};
          e3 && e3.length ? (l = n2(t3, e3), s = l.get()) : s = t3, e3 = e3 || "";
          var c = {};
          if (s)
            for (o = 0; o < s.length; o++)
              c[s[o][r3]] = o;
          var f2 = i.test(a), h = { set: function(t4, e4) {
            var i2 = null === e4 ? 4 : 0;
            if (!s) {
              if (!l || 4 === i2)
                return;
              s = [], l.set(s);
            }
            var o2 = c[t4];
            if (void 0 === o2) {
              if (4 === i2)
                return;
              i2 |= 3, o2 = s.length, c[t4] = o2;
            } else
              e4 !== (f2 ? s[o2][a] : n2(s[o2], a).get()) && (i2 |= 2);
            var p2 = s[o2] = s[o2] || {};
            return p2[r3] = t4, f2 ? p2[a] = e4 : n2(p2, a).set(e4), null !== e4 && (i2 &= -5), u[o2] = u[o2] | i2, h;
          }, get: function(t4) {
            if (s) {
              var e4 = c[t4];
              return void 0 === e4 ? void 0 : f2 ? s[e4][a] : n2(s[e4], a).get();
            }
          }, rename: function(t4, e4) {
            var n3 = c[t4];
            return void 0 === n3 || (u[n3] = 1 | u[n3], c[e4] = n3, delete c[t4], s[n3][r3] = e4), h;
          }, remove: function(t4) {
            var e4 = c[t4];
            if (void 0 === e4)
              return h;
            var i2 = s[e4];
            if (Object.keys(i2).length > 2)
              return u[e4] = 2 | u[e4], h.set(t4, null);
            if (f2) {
              for (o = e4; o < s.length; o++)
                u[o] = 3 | u[o];
              for (o = e4; o < s.length; o++)
                c[s[o][r3]]--;
              s.splice(e4, 1), delete c[t4];
            } else
              n2(i2, a).set(null), u[e4] = 6 | u[e4];
            return h;
          }, constructUpdate: function() {
            for (var t4, i2, o2 = {}, l2 = Object.keys(u), c2 = 0; c2 < l2.length; c2++)
              i2 = l2[c2], t4 = e3 + "[" + i2 + "]", s[i2] ? (1 & u[i2] && (o2[t4 + "." + r3] = s[i2][r3]), 2 & u[i2] && (o2[t4 + "." + a] = f2 ? 4 & u[i2] ? null : s[i2][a] : 4 & u[i2] ? null : n2(s[i2], a).get())) : o2[t4] = null;
            return o2;
          } };
          return h;
        };
      }, 15867: function(t2, e2, r2) {
        var n2 = r2(73972);
        t2.exports = function(t3, e3) {
          for (var r3 = t3._context.locale, i = 0; i < 2; i++) {
            for (var a = t3._context.locales, o = 0; o < 2; o++) {
              var s = (a[r3] || {}).dictionary;
              if (s) {
                var l = s[e3];
                if (l)
                  return l;
              }
              a = n2.localeRegistry;
            }
            var u = r3.split("-")[0];
            if (u === r3)
              break;
            r3 = u;
          }
          return e3;
        };
      }, 47769: function(t2, e2, r2) {
        var n2 = r2(72075).dfltConfig, i = r2(75046), a = t2.exports = {};
        a.log = function() {
          var t3;
          if (n2.logging > 1) {
            var e3 = ["LOG:"];
            for (t3 = 0; t3 < arguments.length; t3++)
              e3.push(arguments[t3]);
            console.trace.apply(console, e3);
          }
          if (n2.notifyOnLogging > 1) {
            var r3 = [];
            for (t3 = 0; t3 < arguments.length; t3++)
              r3.push(arguments[t3]);
            i(r3.join("<br>"), "long");
          }
        }, a.warn = function() {
          var t3;
          if (n2.logging > 0) {
            var e3 = ["WARN:"];
            for (t3 = 0; t3 < arguments.length; t3++)
              e3.push(arguments[t3]);
            console.trace.apply(console, e3);
          }
          if (n2.notifyOnLogging > 0) {
            var r3 = [];
            for (t3 = 0; t3 < arguments.length; t3++)
              r3.push(arguments[t3]);
            i(r3.join("<br>"), "stick");
          }
        }, a.error = function() {
          var t3;
          if (n2.logging > 0) {
            var e3 = ["ERROR:"];
            for (t3 = 0; t3 < arguments.length; t3++)
              e3.push(arguments[t3]);
            console.error.apply(console, e3);
          }
          if (n2.notifyOnLogging > 0) {
            var r3 = [];
            for (t3 = 0; t3 < arguments.length; t3++)
              r3.push(arguments[t3]);
            i(r3.join("<br>"), "stick");
          }
        };
      }, 77310: function(t2, e2, r2) {
        var n2 = r2(39898);
        t2.exports = function(t3, e3, r3) {
          var i = t3.selectAll("g." + r3.replace(/\s/g, ".")).data(e3, function(t4) {
            return t4[0].trace.uid;
          });
          i.exit().remove(), i.enter().append("g").attr("class", r3), i.order();
          var a = t3.classed("rangeplot") ? "nodeRangePlot3" : "node3";
          return i.each(function(t4) {
            t4[0][a] = n2.select(this);
          }), i;
        };
      }, 35657: function(t2, e2, r2) {
        var n2 = r2(79576);
        e2.init2dArray = function(t3, e3) {
          for (var r3 = new Array(t3), n3 = 0; n3 < t3; n3++)
            r3[n3] = new Array(e3);
          return r3;
        }, e2.transposeRagged = function(t3) {
          var e3, r3, n3 = 0, i = t3.length;
          for (e3 = 0; e3 < i; e3++)
            n3 = Math.max(n3, t3[e3].length);
          var a = new Array(n3);
          for (e3 = 0; e3 < n3; e3++)
            for (a[e3] = new Array(i), r3 = 0; r3 < i; r3++)
              a[e3][r3] = t3[r3][e3];
          return a;
        }, e2.dot = function(t3, r3) {
          if (!t3.length || !r3.length || t3.length !== r3.length)
            return null;
          var n3, i, a = t3.length;
          if (t3[0].length)
            for (n3 = new Array(a), i = 0; i < a; i++)
              n3[i] = e2.dot(t3[i], r3);
          else if (r3[0].length) {
            var o = e2.transposeRagged(r3);
            for (n3 = new Array(o.length), i = 0; i < o.length; i++)
              n3[i] = e2.dot(t3, o[i]);
          } else
            for (n3 = 0, i = 0; i < a; i++)
              n3 += t3[i] * r3[i];
          return n3;
        }, e2.translationMatrix = function(t3, e3) {
          return [[1, 0, t3], [0, 1, e3], [0, 0, 1]];
        }, e2.rotationMatrix = function(t3) {
          var e3 = t3 * Math.PI / 180;
          return [[Math.cos(e3), -Math.sin(e3), 0], [Math.sin(e3), Math.cos(e3), 0], [0, 0, 1]];
        }, e2.rotationXYMatrix = function(t3, r3, n3) {
          return e2.dot(e2.dot(e2.translationMatrix(r3, n3), e2.rotationMatrix(t3)), e2.translationMatrix(-r3, -n3));
        }, e2.apply3DTransform = function(t3) {
          return function() {
            var r3 = arguments, n3 = 1 === arguments.length ? r3[0] : [r3[0], r3[1], r3[2] || 0];
            return e2.dot(t3, [n3[0], n3[1], n3[2], 1]).slice(0, 3);
          };
        }, e2.apply2DTransform = function(t3) {
          return function() {
            var r3 = arguments;
            3 === r3.length && (r3 = r3[0]);
            var n3 = 1 === arguments.length ? r3[0] : [r3[0], r3[1]];
            return e2.dot(t3, [n3[0], n3[1], 1]).slice(0, 2);
          };
        }, e2.apply2DTransform2 = function(t3) {
          var r3 = e2.apply2DTransform(t3);
          return function(t4) {
            return r3(t4.slice(0, 2)).concat(r3(t4.slice(2, 4)));
          };
        }, e2.convertCssMatrix = function(t3) {
          if (t3) {
            var e3 = t3.length;
            if (16 === e3)
              return t3;
            if (6 === e3)
              return [t3[0], t3[1], 0, 0, t3[2], t3[3], 0, 0, 0, 0, 1, 0, t3[4], t3[5], 0, 1];
          }
          return [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1];
        }, e2.inverseTransformMatrix = function(t3) {
          var e3 = [];
          return n2.invert(e3, t3), [[e3[0], e3[1], e3[2], e3[3]], [e3[4], e3[5], e3[6], e3[7]], [e3[8], e3[9], e3[10], e3[11]], [e3[12], e3[13], e3[14], e3[15]]];
        };
      }, 64872: function(t2) {
        t2.exports = { mod: function(t3, e2) {
          var r2 = t3 % e2;
          return r2 < 0 ? r2 + e2 : r2;
        }, modHalf: function(t3, e2) {
          return Math.abs(t3) > e2 / 2 ? t3 - Math.round(t3 / e2) * e2 : t3;
        } };
      }, 65487: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(73627).isArrayOrTypedArray;
        function a(t3, e3) {
          return function() {
            var r3, n3, o2, s2, l2, u2 = t3;
            for (s2 = 0; s2 < e3.length - 1; s2++) {
              if (-1 === (r3 = e3[s2])) {
                for (n3 = true, o2 = [], l2 = 0; l2 < u2.length; l2++)
                  o2[l2] = a(u2[l2], e3.slice(s2 + 1))(), o2[l2] !== o2[0] && (n3 = false);
                return n3 ? o2[0] : o2;
              }
              if ("number" == typeof r3 && !i(u2))
                return;
              if ("object" != typeof (u2 = u2[r3]) || null === u2)
                return;
            }
            if ("object" == typeof u2 && null !== u2 && null !== (o2 = u2[e3[s2]]))
              return o2;
          };
        }
        t2.exports = function(t3, e3) {
          if (n2(e3))
            e3 = String(e3);
          else if ("string" != typeof e3 || "[-1]" === e3.substr(e3.length - 4))
            throw "bad property string";
          for (var r3, i2, o2, s2 = 0, u2 = e3.split("."); s2 < u2.length; ) {
            if (r3 = String(u2[s2]).match(/^([^\[\]]*)((\[\-?[0-9]*\])+)$/)) {
              if (r3[1])
                u2[s2] = r3[1];
              else {
                if (0 !== s2)
                  throw "bad property string";
                u2.splice(0, 1);
              }
              for (i2 = r3[2].substr(1, r3[2].length - 2).split("]["), o2 = 0; o2 < i2.length; o2++)
                s2++, u2.splice(s2, 0, Number(i2[o2]));
            }
            s2++;
          }
          return "object" != typeof t3 ? function(t4, e4, r4) {
            return { set: function() {
              throw "bad container";
            }, get: function() {
            }, astr: e4, parts: r4, obj: t4 };
          }(t3, e3, u2) : { set: l(t3, u2, e3), get: a(t3, u2), astr: e3, parts: u2, obj: t3 };
        };
        var o = /(^|\.)args\[/;
        function s(t3, e3) {
          return void 0 === t3 || null === t3 && !e3.match(o);
        }
        function l(t3, e3, r3) {
          return function(n3) {
            var a2, o2, l2 = t3, h = "", d2 = s(n3, r3);
            for (o2 = 0; o2 < e3.length - 1; o2++) {
              if ("number" == typeof (a2 = e3[o2]) && !i(l2))
                throw "array index but container is not an array";
              if (-1 === a2) {
                if (d2 = !c(l2, e3.slice(o2 + 1), n3, r3))
                  break;
                return;
              }
              if (!f2(l2, a2, e3[o2 + 1], d2))
                break;
              if ("object" != typeof (l2 = l2[a2]) || null === l2)
                throw "container is not an object";
              h = u(h, a2);
            }
            if (d2) {
              if (o2 === e3.length - 1 && (delete l2[e3[o2]], Array.isArray(l2) && +e3[o2] == l2.length - 1))
                for (; l2.length && void 0 === l2[l2.length - 1]; )
                  l2.pop();
            } else
              l2[e3[o2]] = n3;
          };
        }
        function u(t3, e3) {
          var r3 = e3;
          return n2(e3) ? r3 = "[" + e3 + "]" : t3 && (r3 = "." + e3), t3 + r3;
        }
        function c(t3, e3, r3, n3) {
          var a2, o2 = i(r3), u2 = true, c2 = r3, h = n3.replace("-1", 0), p2 = !o2 && s(r3, h), d2 = e3[0];
          for (a2 = 0; a2 < t3.length; a2++)
            h = n3.replace("-1", a2), o2 && (p2 = s(c2 = r3[a2 % r3.length], h)), p2 && (u2 = false), f2(t3, a2, d2, p2) && l(t3[a2], e3, n3.replace("-1", a2))(c2);
          return u2;
        }
        function f2(t3, e3, r3, n3) {
          if (void 0 === t3[e3]) {
            if (n3)
              return false;
            t3[e3] = "number" == typeof r3 ? [] : {};
          }
          return true;
        }
      }, 64213: function(t2) {
        t2.exports = function() {
        };
      }, 75046: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(92770), a = [];
        t2.exports = function(t3, e3) {
          if (-1 === a.indexOf(t3)) {
            a.push(t3);
            var r3 = 1e3;
            i(e3) ? r3 = e3 : "long" === e3 && (r3 = 3e3);
            var o = n2.select("body").selectAll(".plotly-notifier").data([0]);
            o.enter().append("div").classed("plotly-notifier", true), o.selectAll(".notifier-note").data(a).enter().append("div").classed("notifier-note", true).style("opacity", 0).each(function(t4) {
              var i2 = n2.select(this);
              i2.append("button").classed("notifier-close", true).html("&times;").on("click", function() {
                i2.transition().call(s);
              });
              for (var a2 = i2.append("p"), o2 = t4.split(/<br\s*\/?>/g), l = 0; l < o2.length; l++)
                l && a2.append("br"), a2.append("span").text(o2[l]);
              "stick" === e3 ? i2.transition().duration(350).style("opacity", 1) : i2.transition().duration(700).style("opacity", 1).transition().delay(r3).call(s);
            });
          }
          function s(t4) {
            t4.duration(700).style("opacity", 0).each("end", function(t5) {
              var e4 = a.indexOf(t5);
              -1 !== e4 && a.splice(e4, 1), n2.select(this).remove();
            });
          }
        };
      }, 39918: function(t2, e2, r2) {
        var n2 = r2(6964), i = "data-savedcursor";
        t2.exports = function(t3, e3) {
          var r3 = t3.attr(i);
          if (e3) {
            if (!r3) {
              for (var a = (t3.attr("class") || "").split(" "), o = 0; o < a.length; o++) {
                var s = a[o];
                0 === s.indexOf("cursor-") && t3.attr(i, s.substr(7)).classed(s, false);
              }
              t3.attr(i) || t3.attr(i, "!!");
            }
            n2(t3, e3);
          } else
            r3 && (t3.attr(i, null), "!!" === r3 ? n2(t3) : n2(t3, r3));
        };
      }, 61082: function(t2, e2, r2) {
        var n2 = r2(35657).dot, i = r2(50606).BADNUM, a = t2.exports = {};
        a.tester = function(t3) {
          var e3, r3 = t3.slice(), n3 = r3[0][0], a2 = n3, o = r3[0][1], s = o;
          for (r3[r3.length - 1][0] === r3[0][0] && r3[r3.length - 1][1] === r3[0][1] || r3.push(r3[0]), e3 = 1; e3 < r3.length; e3++)
            n3 = Math.min(n3, r3[e3][0]), a2 = Math.max(a2, r3[e3][0]), o = Math.min(o, r3[e3][1]), s = Math.max(s, r3[e3][1]);
          var l, u = false;
          5 === r3.length && (r3[0][0] === r3[1][0] ? r3[2][0] === r3[3][0] && r3[0][1] === r3[3][1] && r3[1][1] === r3[2][1] && (u = true, l = function(t4) {
            return t4[0] === r3[0][0];
          }) : r3[0][1] === r3[1][1] && r3[2][1] === r3[3][1] && r3[0][0] === r3[3][0] && r3[1][0] === r3[2][0] && (u = true, l = function(t4) {
            return t4[1] === r3[0][1];
          }));
          var c = true, f2 = r3[0];
          for (e3 = 1; e3 < r3.length; e3++)
            if (f2[0] !== r3[e3][0] || f2[1] !== r3[e3][1]) {
              c = false;
              break;
            }
          return { xmin: n3, xmax: a2, ymin: o, ymax: s, pts: r3, contains: u ? function(t4, e4) {
            var r4 = t4[0], u2 = t4[1];
            return !(r4 === i || r4 < n3 || r4 > a2 || u2 === i || u2 < o || u2 > s || e4 && l(t4));
          } : function(t4, e4) {
            var l2 = t4[0], u2 = t4[1];
            if (l2 === i || l2 < n3 || l2 > a2 || u2 === i || u2 < o || u2 > s)
              return false;
            var c2, f3, h, p2, d2, v = r3.length, g2 = r3[0][0], y = r3[0][1], m2 = 0;
            for (c2 = 1; c2 < v; c2++)
              if (f3 = g2, h = y, g2 = r3[c2][0], y = r3[c2][1], !(l2 < (p2 = Math.min(f3, g2)) || l2 > Math.max(f3, g2) || u2 > Math.max(h, y)))
                if (u2 < Math.min(h, y))
                  l2 !== p2 && m2++;
                else {
                  if (u2 === (d2 = g2 === f3 ? u2 : h + (l2 - f3) * (y - h) / (g2 - f3)))
                    return 1 !== c2 || !e4;
                  u2 <= d2 && l2 !== p2 && m2++;
                }
            return m2 % 2 == 1;
          }, isRect: u, degenerate: c };
        }, a.isSegmentBent = function(t3, e3, r3, i2) {
          var a2, o, s, l = t3[e3], u = [t3[r3][0] - l[0], t3[r3][1] - l[1]], c = n2(u, u), f2 = Math.sqrt(c), h = [-u[1] / f2, u[0] / f2];
          for (a2 = e3 + 1; a2 < r3; a2++)
            if (o = [t3[a2][0] - l[0], t3[a2][1] - l[1]], (s = n2(o, u)) < 0 || s > c || Math.abs(n2(o, h)) > i2)
              return true;
          return false;
        }, a.filter = function(t3, e3) {
          var r3 = [t3[0]], n3 = 0, i2 = 0;
          function o(o2) {
            t3.push(o2);
            var s = r3.length, l = n3;
            r3.splice(i2 + 1);
            for (var u = l + 1; u < t3.length; u++)
              (u === t3.length - 1 || a.isSegmentBent(t3, l, u + 1, e3)) && (r3.push(t3[u]), r3.length < s - 2 && (n3 = u, i2 = r3.length - 1), l = u);
          }
          return t3.length > 1 && o(t3.pop()), { addPt: o, raw: t3, filtered: r3 };
        };
      }, 79749: function(t2, e2, r2) {
        var n2 = r2(58617), i = r2(98580);
        t2.exports = function(t3, e3, a) {
          var o = t3._fullLayout, s = true;
          return o._glcanvas.each(function(n3) {
            if (n3.regl)
              n3.regl.preloadCachedCode(a);
            else if (!n3.pick || o._has("parcoords")) {
              try {
                n3.regl = i({ canvas: this, attributes: { antialias: !n3.pick, preserveDrawingBuffer: true }, pixelRatio: t3._context.plotGlPixelRatio || r2.g.devicePixelRatio, extensions: e3 || [], cachedCode: a || {} });
              } catch (t4) {
                s = false;
              }
              n3.regl || (s = false), s && this.addEventListener("webglcontextlost", function(e4) {
                t3 && t3.emit && t3.emit("plotly_webglcontextlost", { event: e4, layer: n3.key });
              }, false);
            }
          }), s || n2({ container: o._glcontainer.node() }), s;
        };
      }, 45142: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(35791);
        t2.exports = function(t3) {
          var e3;
          if ("string" != typeof (e3 = t3 && t3.hasOwnProperty("userAgent") ? t3.userAgent : function() {
            var t4;
            return "undefined" != typeof navigator && (t4 = navigator.userAgent), t4 && t4.headers && "string" == typeof t4.headers["user-agent"] && (t4 = t4.headers["user-agent"]), t4;
          }()))
            return true;
          var r3 = i({ ua: { headers: { "user-agent": e3 } }, tablet: true, featureDetect: false });
          if (!r3) {
            for (var a = e3.split(" "), o = 1; o < a.length; o++)
              if (-1 !== a[o].indexOf("Safari"))
                for (var s = o - 1; s > -1; s--) {
                  var l = a[s];
                  if ("Version/" === l.substr(0, 8)) {
                    var u = l.substr(8).split(".")[0];
                    if (n2(u) && (u = +u), u >= 13)
                      return true;
                  }
                }
          }
          return r3;
        };
      }, 75138: function(t2) {
        t2.exports = function(t3, e2) {
          if (e2 instanceof RegExp) {
            for (var r2 = e2.toString(), n2 = 0; n2 < t3.length; n2++)
              if (t3[n2] instanceof RegExp && t3[n2].toString() === r2)
                return t3;
            t3.push(e2);
          } else
            !e2 && 0 !== e2 || -1 !== t3.indexOf(e2) || t3.push(e2);
          return t3;
        };
      }, 10847: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(72075).dfltConfig, a = { add: function(t3, e3, r3, n3, a2) {
          var o, s;
          t3.undoQueue = t3.undoQueue || { index: 0, queue: [], sequence: false }, s = t3.undoQueue.index, t3.autoplay ? t3.undoQueue.inSequence || (t3.autoplay = false) : (!t3.undoQueue.sequence || t3.undoQueue.beginSequence ? (o = { undo: { calls: [], args: [] }, redo: { calls: [], args: [] } }, t3.undoQueue.queue.splice(s, t3.undoQueue.queue.length - s, o), t3.undoQueue.index += 1) : o = t3.undoQueue.queue[s - 1], t3.undoQueue.beginSequence = false, o && (o.undo.calls.unshift(e3), o.undo.args.unshift(r3), o.redo.calls.push(n3), o.redo.args.push(a2)), t3.undoQueue.queue.length > i.queueLength && (t3.undoQueue.queue.shift(), t3.undoQueue.index--));
        }, startSequence: function(t3) {
          t3.undoQueue = t3.undoQueue || { index: 0, queue: [], sequence: false }, t3.undoQueue.sequence = true, t3.undoQueue.beginSequence = true;
        }, stopSequence: function(t3) {
          t3.undoQueue = t3.undoQueue || { index: 0, queue: [], sequence: false }, t3.undoQueue.sequence = false, t3.undoQueue.beginSequence = false;
        }, undo: function(t3) {
          var e3, r3;
          if (!(void 0 === t3.undoQueue || isNaN(t3.undoQueue.index) || t3.undoQueue.index <= 0)) {
            for (t3.undoQueue.index--, e3 = t3.undoQueue.queue[t3.undoQueue.index], t3.undoQueue.inSequence = true, r3 = 0; r3 < e3.undo.calls.length; r3++)
              a.plotDo(t3, e3.undo.calls[r3], e3.undo.args[r3]);
            t3.undoQueue.inSequence = false, t3.autoplay = false;
          }
        }, redo: function(t3) {
          var e3, r3;
          if (!(void 0 === t3.undoQueue || isNaN(t3.undoQueue.index) || t3.undoQueue.index >= t3.undoQueue.queue.length)) {
            for (e3 = t3.undoQueue.queue[t3.undoQueue.index], t3.undoQueue.inSequence = true, r3 = 0; r3 < e3.redo.calls.length; r3++)
              a.plotDo(t3, e3.redo.calls[r3], e3.redo.args[r3]);
            t3.undoQueue.inSequence = false, t3.autoplay = false, t3.undoQueue.index++;
          }
        }, plotDo: function(t3, e3, r3) {
          t3.autoplay = true, r3 = function(t4, e4) {
            for (var r4, i2 = [], a2 = 0; a2 < e4.length; a2++)
              r4 = e4[a2], i2[a2] = r4 === t4 ? r4 : "object" == typeof r4 ? Array.isArray(r4) ? n2.extendDeep([], r4) : n2.extendDeepAll({}, r4) : r4;
            return i2;
          }(t3, r3), e3.apply(null, r3);
        } };
        t2.exports = a;
      }, 30587: function(t2, e2) {
        e2.counter = function(t3, e3, r2, n2) {
          var i = (e3 || "") + (r2 ? "" : "$"), a = false === n2 ? "" : "^";
          return "xy" === t3 ? new RegExp(a + "x([2-9]|[1-9][0-9]+)?y([2-9]|[1-9][0-9]+)?" + i) : new RegExp(a + t3 + "([2-9]|[1-9][0-9]+)?" + i);
        };
      }, 6962: function(t2) {
        var e2 = /^(.*)(\.[^\.\[\]]+|\[\d\])$/, r2 = /^[^\.\[\]]+$/;
        t2.exports = function(t3, n2) {
          for (; n2; ) {
            var i = t3.match(e2);
            if (i)
              t3 = i[1];
            else {
              if (!t3.match(r2))
                throw new Error("bad relativeAttr call:" + [t3, n2]);
              t3 = "";
            }
            if ("^" !== n2.charAt(0))
              break;
            n2 = n2.slice(1);
          }
          return t3 && "[" !== n2.charAt(0) ? t3 + "." + n2 : t3 + n2;
        };
      }, 51332: function(t2, e2, r2) {
        var n2 = r2(73627).isArrayOrTypedArray, i = r2(41965);
        t2.exports = function t3(e3, r3) {
          for (var a in r3) {
            var o = r3[a], s = e3[a];
            if (s !== o)
              if ("_" === a.charAt(0) || "function" == typeof o) {
                if (a in e3)
                  continue;
                e3[a] = o;
              } else if (n2(o) && n2(s) && i(o[0])) {
                if ("customdata" === a || "ids" === a)
                  continue;
                for (var l = Math.min(o.length, s.length), u = 0; u < l; u++)
                  s[u] !== o[u] && i(o[u]) && i(s[u]) && t3(s[u], o[u]);
              } else
                i(o) && i(s) && (t3(s, o), Object.keys(s).length || delete e3[a]);
          }
        };
      }, 65888: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(47769), a = r2(23389), o = r2(50606).BADNUM, s = 1e-9;
        function l(t3, e3) {
          return t3 < e3;
        }
        function u(t3, e3) {
          return t3 <= e3;
        }
        function c(t3, e3) {
          return t3 > e3;
        }
        function f2(t3, e3) {
          return t3 >= e3;
        }
        e2.findBin = function(t3, e3, r3) {
          if (n2(e3.start))
            return r3 ? Math.ceil((t3 - e3.start) / e3.size - s) - 1 : Math.floor((t3 - e3.start) / e3.size + s);
          var a2, o2, h = 0, p2 = e3.length, d2 = 0, v = p2 > 1 ? (e3[p2 - 1] - e3[0]) / (p2 - 1) : 1;
          for (o2 = v >= 0 ? r3 ? l : u : r3 ? f2 : c, t3 += v * s * (r3 ? -1 : 1) * (v >= 0 ? 1 : -1); h < p2 && d2++ < 100; )
            o2(e3[a2 = Math.floor((h + p2) / 2)], t3) ? h = a2 + 1 : p2 = a2;
          return d2 > 90 && i.log("Long binary search..."), h - 1;
        }, e2.sorterAsc = function(t3, e3) {
          return t3 - e3;
        }, e2.sorterDes = function(t3, e3) {
          return e3 - t3;
        }, e2.distinctVals = function(t3) {
          var r3, n3 = t3.slice();
          for (n3.sort(e2.sorterAsc), r3 = n3.length - 1; r3 > -1 && n3[r3] === o; r3--)
            ;
          for (var i2, a2 = n3[r3] - n3[0] || 1, s2 = a2 / (r3 || 1) / 1e4, l2 = [], u2 = 0; u2 <= r3; u2++) {
            var c2 = n3[u2], f3 = c2 - i2;
            void 0 === i2 ? (l2.push(c2), i2 = c2) : f3 > s2 && (a2 = Math.min(a2, f3), l2.push(c2), i2 = c2);
          }
          return { vals: l2, minDiff: a2 };
        }, e2.roundUp = function(t3, e3, r3) {
          for (var n3, i2 = 0, a2 = e3.length - 1, o2 = 0, s2 = r3 ? 0 : 1, l2 = r3 ? 1 : 0, u2 = r3 ? Math.ceil : Math.floor; i2 < a2 && o2++ < 100; )
            e3[n3 = u2((i2 + a2) / 2)] <= t3 ? i2 = n3 + s2 : a2 = n3 - l2;
          return e3[i2];
        }, e2.sort = function(t3, e3) {
          for (var r3 = 0, n3 = 0, i2 = 1; i2 < t3.length; i2++) {
            var a2 = e3(t3[i2], t3[i2 - 1]);
            if (a2 < 0 ? r3 = 1 : a2 > 0 && (n3 = 1), r3 && n3)
              return t3.sort(e3);
          }
          return n3 ? t3 : t3.reverse();
        }, e2.findIndexOfMin = function(t3, e3) {
          e3 = e3 || a;
          for (var r3, n3 = 1 / 0, i2 = 0; i2 < t3.length; i2++) {
            var o2 = e3(t3[i2]);
            o2 < n3 && (n3 = o2, r3 = i2);
          }
          return r3;
        };
      }, 6964: function(t2) {
        t2.exports = function(t3, e2) {
          (t3.attr("class") || "").split(" ").forEach(function(e3) {
            0 === e3.indexOf("cursor-") && t3.classed(e3, false);
          }), e2 && t3.classed("cursor-" + e2, true);
        };
      }, 58617: function(t2, e2, r2) {
        var n2 = r2(7901), i = function() {
        };
        t2.exports = function(t3) {
          for (var e3 in t3)
            "function" == typeof t3[e3] && (t3[e3] = i);
          t3.destroy = function() {
            t3.container.parentNode.removeChild(t3.container);
          };
          var r3 = document.createElement("div");
          r3.className = "no-webgl", r3.style.cursor = "pointer", r3.style.fontSize = "24px", r3.style.color = n2.defaults[0], r3.style.position = "absolute", r3.style.left = r3.style.top = "0px", r3.style.width = r3.style.height = "100%", r3.style["background-color"] = n2.lightLine, r3.style["z-index"] = 30;
          var a = document.createElement("p");
          return a.textContent = "WebGL is not supported by your browser - visit https://get.webgl.org for more info", a.style.position = "relative", a.style.top = "50%", a.style.left = "50%", a.style.height = "30%", a.style.width = "50%", a.style.margin = "-15% 0 0 -25%", r3.appendChild(a), t3.container.appendChild(r3), t3.container.style.background = "#FFFFFF", t3.container.onclick = function() {
            window.open("https://get.webgl.org");
          }, false;
        };
      }, 78607: function(t2) {
        t2.exports = function(t3) {
          return Object.keys(t3).sort();
        };
      }, 80038: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(73627).isArrayOrTypedArray;
        e2.aggNums = function(t3, r3, a, o) {
          var s, l;
          if ((!o || o > a.length) && (o = a.length), n2(r3) || (r3 = false), i(a[0])) {
            for (l = new Array(o), s = 0; s < o; s++)
              l[s] = e2.aggNums(t3, r3, a[s]);
            a = l;
          }
          for (s = 0; s < o; s++)
            n2(r3) ? n2(a[s]) && (r3 = t3(+r3, +a[s])) : r3 = a[s];
          return r3;
        }, e2.len = function(t3) {
          return e2.aggNums(function(t4) {
            return t4 + 1;
          }, 0, t3);
        }, e2.mean = function(t3, r3) {
          return r3 || (r3 = e2.len(t3)), e2.aggNums(function(t4, e3) {
            return t4 + e3;
          }, 0, t3) / r3;
        }, e2.midRange = function(t3) {
          if (void 0 !== t3 && 0 !== t3.length)
            return (e2.aggNums(Math.max, null, t3) + e2.aggNums(Math.min, null, t3)) / 2;
        }, e2.variance = function(t3, r3, i2) {
          return r3 || (r3 = e2.len(t3)), n2(i2) || (i2 = e2.mean(t3, r3)), e2.aggNums(function(t4, e3) {
            return t4 + Math.pow(e3 - i2, 2);
          }, 0, t3) / r3;
        }, e2.stdev = function(t3, r3, n3) {
          return Math.sqrt(e2.variance(t3, r3, n3));
        }, e2.median = function(t3) {
          var r3 = t3.slice().sort();
          return e2.interp(r3, 0.5);
        }, e2.interp = function(t3, e3) {
          if (!n2(e3))
            throw "n should be a finite number";
          if ((e3 = e3 * t3.length - 0.5) < 0)
            return t3[0];
          if (e3 > t3.length - 1)
            return t3[t3.length - 1];
          var r3 = e3 % 1;
          return r3 * t3[Math.ceil(e3)] + (1 - r3) * t3[Math.floor(e3)];
        };
      }, 78614: function(t2, e2, r2) {
        var n2 = r2(25075);
        t2.exports = function(t3) {
          return t3 ? n2(t3) : [0, 0, 0, 1];
        };
      }, 63893: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = i.strTranslate, o = r2(77922), s = r2(18783).LINE_SPACING, l = /([^$]*)([$]+[^$]*[$]+)([^$]*)/;
        e2.convertToTspans = function(t3, r3, g3) {
          var S2 = t3.text(), E2 = !t3.attr("data-notex") && r3 && r3._context.typesetMath && "undefined" != typeof MathJax && S2.match(l), P2 = n2.select(t3.node().parentNode);
          if (!P2.empty()) {
            var O2 = t3.attr("class") ? t3.attr("class").split(" ")[0] : "text";
            return O2 += "-math", P2.selectAll("svg." + O2).remove(), P2.selectAll("g." + O2 + "-group").remove(), t3.style("display", null).attr({ "data-unformatted": S2, "data-math": "N" }), E2 ? (r3 && r3._promises || []).push(new Promise(function(e3) {
              t3.style("display", "none");
              var r4 = parseInt(t3.node().style.fontSize, 10), o2 = { fontSize: r4 };
              !function(t4, e4, r5) {
                var a2, o3, s2, l2, h2 = parseInt((MathJax.version || "").split(".")[0]);
                if (2 === h2 || 3 === h2) {
                  var p3 = function() {
                    var r6 = "math-output-" + i.randstr({}, 64), a3 = (l2 = n2.select("body").append("div").attr({ id: r6 }).style({ visibility: "hidden", position: "absolute", "font-size": e4.fontSize + "px" }).text(t4.replace(u, "\\lt ").replace(c, "\\gt "))).node();
                    return 2 === h2 ? MathJax.Hub.Typeset(a3) : MathJax.typeset([a3]);
                  }, d3 = function() {
                    var e5 = l2.select(2 === h2 ? ".MathJax_SVG" : ".MathJax"), a3 = !e5.empty() && l2.select("svg").node();
                    if (a3) {
                      var o4, s3 = a3.getBoundingClientRect();
                      o4 = 2 === h2 ? n2.select("body").select("#MathJax_SVG_glyphs") : e5.select("defs"), r5(e5, o4, s3);
                    } else
                      i.log("There was an error in the tex syntax.", t4), r5();
                    l2.remove();
                  };
                  2 === h2 ? MathJax.Hub.Queue(function() {
                    return o3 = i.extendDeepAll({}, MathJax.Hub.config), s2 = MathJax.Hub.processSectionDelay, void 0 !== MathJax.Hub.processSectionDelay && (MathJax.Hub.processSectionDelay = 0), MathJax.Hub.Config({ messageStyle: "none", tex2jax: { inlineMath: f2 }, displayAlign: "left" });
                  }, function() {
                    if ("SVG" !== (a2 = MathJax.Hub.config.menuSettings.renderer))
                      return MathJax.Hub.setRenderer("SVG");
                  }, p3, d3, function() {
                    if ("SVG" !== a2)
                      return MathJax.Hub.setRenderer(a2);
                  }, function() {
                    return void 0 !== s2 && (MathJax.Hub.processSectionDelay = s2), MathJax.Hub.Config(o3);
                  }) : 3 === h2 && (o3 = i.extendDeepAll({}, MathJax.config), MathJax.config.tex || (MathJax.config.tex = {}), MathJax.config.tex.inlineMath = f2, "svg" !== (a2 = MathJax.config.startup.output) && (MathJax.config.startup.output = "svg"), MathJax.startup.defaultReady(), MathJax.startup.promise.then(function() {
                    p3(), d3(), "svg" !== a2 && (MathJax.config.startup.output = a2), MathJax.config = o3;
                  }));
                } else
                  i.warn("No MathJax version:", MathJax.version);
              }(E2[2], o2, function(n3, i2, o3) {
                P2.selectAll("svg." + O2).remove(), P2.selectAll("g." + O2 + "-group").remove();
                var s2 = n3 && n3.select("svg");
                if (!s2 || !s2.node())
                  return I(), void e3();
                var l2 = P2.append("g").classed(O2 + "-group", true).attr({ "pointer-events": "none", "data-unformatted": S2, "data-math": "Y" });
                l2.node().appendChild(s2.node()), i2 && i2.node() && s2.node().insertBefore(i2.node().cloneNode(true), s2.node().firstChild);
                var u2 = o3.width, c2 = o3.height;
                s2.attr({ class: O2, height: c2, preserveAspectRatio: "xMinYMin meet" }).style({ overflow: "visible", "pointer-events": "none" });
                var f3 = t3.node().style.fill || "black", h2 = s2.select("g");
                h2.attr({ fill: f3, stroke: f3 });
                var p3 = h2.node().getBoundingClientRect(), d3 = p3.width, v2 = p3.height;
                (d3 > u2 || v2 > c2) && (s2.style("overflow", "hidden"), d3 = (p3 = s2.node().getBoundingClientRect()).width, v2 = p3.height);
                var y2 = +t3.attr("x"), m3 = +t3.attr("y"), x2 = -(r4 || t3.node().getBoundingClientRect().height) / 4;
                if ("y" === O2[0])
                  l2.attr({ transform: "rotate(" + [-90, y2, m3] + ")" + a(-d3 / 2, x2 - v2 / 2) });
                else if ("l" === O2[0])
                  m3 = x2 - v2 / 2;
                else if ("a" === O2[0] && 0 !== O2.indexOf("atitle"))
                  y2 = 0, m3 = x2;
                else {
                  var b2 = t3.attr("text-anchor");
                  y2 -= d3 * ("middle" === b2 ? 0.5 : "end" === b2 ? 1 : 0), m3 = m3 + x2 - v2 / 2;
                }
                s2.attr({ x: y2, y: m3 }), g3 && g3.call(t3, l2), e3(l2);
              });
            })) : I(), t3;
          }
          function I() {
            P2.empty() || (O2 = t3.attr("class") + "-math", P2.select("svg." + O2).remove()), t3.text("").style("white-space", "pre");
            var r4 = function(t4, e3) {
              e3 = e3.replace(y, " ");
              var r5, a2 = false, l2 = [], u2 = -1;
              function c2() {
                u2++;
                var e4 = document.createElementNS(o.svg, "tspan");
                n2.select(e4).attr({ class: "line", dy: u2 * s + "em" }), t4.appendChild(e4), r5 = e4;
                var i2 = l2;
                if (l2 = [{ node: e4 }], i2.length > 1)
                  for (var a3 = 1; a3 < i2.length; a3++)
                    f3(i2[a3]);
              }
              function f3(t5) {
                var e4, i2 = t5.type, a3 = {};
                if ("a" === i2) {
                  e4 = "a";
                  var s2 = t5.target, u3 = t5.href, c3 = t5.popup;
                  u3 && (a3 = { "xlink:xlink:show": "_blank" === s2 || "_" !== s2.charAt(0) ? "new" : "replace", target: s2, "xlink:xlink:href": u3 }, c3 && (a3.onclick = 'window.open(this.href.baseVal,this.target.baseVal,"' + c3 + '");return false;'));
                } else
                  e4 = "tspan";
                t5.style && (a3.style = t5.style);
                var f4 = document.createElementNS(o.svg, e4);
                if ("sup" === i2 || "sub" === i2) {
                  g4(r5, v), r5.appendChild(f4);
                  var h2 = document.createElementNS(o.svg, "tspan");
                  g4(h2, v), n2.select(h2).attr("dy", d2[i2]), a3.dy = p2[i2], r5.appendChild(f4), r5.appendChild(h2);
                } else
                  r5.appendChild(f4);
                n2.select(f4).attr(a3), r5 = t5.node = f4, l2.push(t5);
              }
              function g4(t5, e4) {
                t5.appendChild(document.createTextNode(e4));
              }
              function S3(t5) {
                if (1 !== l2.length) {
                  var n3 = l2.pop();
                  t5 !== n3.type && i.log("Start tag <" + n3.type + "> doesnt match end tag <" + t5 + ">. Pretending it did match.", e3), r5 = l2[l2.length - 1].node;
                } else
                  i.log("Ignoring unexpected end tag </" + t5 + ">.", e3);
              }
              b.test(e3) ? c2() : (r5 = t4, l2 = [{ node: t4 }]);
              for (var E3 = e3.split(m2), P3 = 0; P3 < E3.length; P3++) {
                var O3 = E3[P3], I2 = O3.match(x), D = I2 && I2[2].toLowerCase(), z = h[D];
                if ("br" === D)
                  c2();
                else if (void 0 === z)
                  g4(r5, L(O3));
                else if (I2[1])
                  S3(D);
                else {
                  var R = I2[4], F = { type: D }, B = A(R, _);
                  if (B ? (B = B.replace(M, "$1 fill:"), z && (B += ";" + z)) : z && (B = z), B && (F.style = B), "a" === D) {
                    a2 = true;
                    var N = A(R, w2);
                    if (N) {
                      var j = C(N);
                      j && (F.href = j, F.target = A(R, T) || "_blank", F.popup = A(R, k));
                    }
                  }
                  f3(F);
                }
              }
              return a2;
            }(t3.node(), S2);
            r4 && t3.style("pointer-events", "all"), e2.positionText(t3), g3 && g3.call(t3);
          }
        };
        var u = /(<|&lt;|&#60;)/g, c = /(>|&gt;|&#62;)/g, f2 = [["$", "$"], ["\\(", "\\)"]], h = { sup: "font-size:70%", sub: "font-size:70%", b: "font-weight:bold", i: "font-style:italic", a: "cursor:pointer", span: "", em: "font-style:italic;font-weight:bold" }, p2 = { sub: "0.3em", sup: "-0.6em" }, d2 = { sub: "-0.21em", sup: "0.42em" }, v = "​", g2 = ["http:", "https:", "mailto:", "", void 0, ":"], y = e2.NEWLINES = /(\r\n?|\n)/g, m2 = /(<[^<>]*>)/, x = /<(\/?)([^ >]*)(\s+(.*))?>/i, b = /<br(\s+.*)?>/i;
        e2.BR_TAG_ALL = /<br(\s+.*)?>/gi;
        var _ = /(^|[\s"'])style\s*=\s*("([^"]*);?"|'([^']*);?')/i, w2 = /(^|[\s"'])href\s*=\s*("([^"]*)"|'([^']*)')/i, T = /(^|[\s"'])target\s*=\s*("([^"\s]*)"|'([^'\s]*)')/i, k = /(^|[\s"'])popup\s*=\s*("([\w=,]*)"|'([\w=,]*)')/i;
        function A(t3, e3) {
          if (!t3)
            return null;
          var r3 = t3.match(e3), n3 = r3 && (r3[3] || r3[4]);
          return n3 && L(n3);
        }
        var M = /(^|;)\s*color:/;
        e2.plainText = function(t3, e3) {
          for (var r3 = void 0 !== (e3 = e3 || {}).len && -1 !== e3.len ? e3.len : 1 / 0, n3 = void 0 !== e3.allowedTags ? e3.allowedTags : ["br"], i2 = "...".length, a2 = t3.split(m2), o2 = [], s2 = "", l2 = 0, u2 = 0; u2 < a2.length; u2++) {
            var c2 = a2[u2], f3 = c2.match(x), h2 = f3 && f3[2].toLowerCase();
            if (h2)
              -1 !== n3.indexOf(h2) && (o2.push(c2), s2 = h2);
            else {
              var p3 = c2.length;
              if (l2 + p3 < r3)
                o2.push(c2), l2 += p3;
              else if (l2 < r3) {
                var d3 = r3 - l2;
                s2 && ("br" !== s2 || d3 <= i2 || p3 <= i2) && o2.pop(), r3 > i2 ? o2.push(c2.substr(0, d3 - i2) + "...") : o2.push(c2.substr(0, d3));
                break;
              }
              s2 = "";
            }
          }
          return o2.join("");
        };
        var S = { mu: "μ", amp: "&", lt: "<", gt: ">", nbsp: " ", times: "×", plusmn: "±", deg: "°" }, E = /&(#\d+|#x[\da-fA-F]+|[a-z]+);/g;
        function L(t3) {
          return t3.replace(E, function(t4, e3) {
            return ("#" === e3.charAt(0) ? function(t5) {
              if (!(t5 > 1114111)) {
                var e4 = String.fromCodePoint;
                if (e4)
                  return e4(t5);
                var r3 = String.fromCharCode;
                return t5 <= 65535 ? r3(t5) : r3(55232 + (t5 >> 10), t5 % 1024 + 56320);
              }
            }("x" === e3.charAt(1) ? parseInt(e3.substr(2), 16) : parseInt(e3.substr(1), 10)) : S[e3]) || t4;
          });
        }
        function C(t3) {
          var e3 = encodeURI(decodeURI(t3)), r3 = document.createElement("a"), n3 = document.createElement("a");
          r3.href = t3, n3.href = e3;
          var i2 = r3.protocol, a2 = n3.protocol;
          return -1 !== g2.indexOf(i2) && -1 !== g2.indexOf(a2) ? e3 : "";
        }
        function P(t3, e3, r3) {
          var n3, a2, o2, s2 = r3.horizontalAlign, l2 = r3.verticalAlign || "top", u2 = t3.node().getBoundingClientRect(), c2 = e3.node().getBoundingClientRect();
          return a2 = "bottom" === l2 ? function() {
            return u2.bottom - n3.height;
          } : "middle" === l2 ? function() {
            return u2.top + (u2.height - n3.height) / 2;
          } : function() {
            return u2.top;
          }, o2 = "right" === s2 ? function() {
            return u2.right - n3.width;
          } : "center" === s2 ? function() {
            return u2.left + (u2.width - n3.width) / 2;
          } : function() {
            return u2.left;
          }, function() {
            n3 = this.node().getBoundingClientRect();
            var t4 = o2() - c2.left, e4 = a2() - c2.top, s3 = r3.gd || {};
            if (r3.gd) {
              s3._fullLayout._calcInverseTransform(s3);
              var l3 = i.apply3DTransform(s3._fullLayout._invTransform)(t4, e4);
              t4 = l3[0], e4 = l3[1];
            }
            return this.style({ top: e4 + "px", left: t4 + "px", "z-index": 1e3 }), this;
          };
        }
        e2.convertEntities = L, e2.sanitizeHTML = function(t3) {
          t3 = t3.replace(y, " ");
          for (var e3 = document.createElement("p"), r3 = e3, i2 = [], a2 = t3.split(m2), o2 = 0; o2 < a2.length; o2++) {
            var s2 = a2[o2], l2 = s2.match(x), u2 = l2 && l2[2].toLowerCase();
            if (u2 in h)
              if (l2[1])
                i2.length && (r3 = i2.pop());
              else {
                var c2 = l2[4], f3 = A(c2, _), p3 = f3 ? { style: f3 } : {};
                if ("a" === u2) {
                  var d3 = A(c2, w2);
                  if (d3) {
                    var v2 = C(d3);
                    if (v2) {
                      p3.href = v2;
                      var g3 = A(c2, T);
                      g3 && (p3.target = g3);
                    }
                  }
                }
                var b2 = document.createElement(u2);
                r3.appendChild(b2), n2.select(b2).attr(p3), r3 = b2, i2.push(b2);
              }
            else
              r3.appendChild(document.createTextNode(L(s2)));
          }
          return e3.innerHTML;
        }, e2.lineCount = function(t3) {
          return t3.selectAll("tspan.line").size() || 1;
        }, e2.positionText = function(t3, e3, r3) {
          return t3.each(function() {
            var t4 = n2.select(this);
            function i2(e4, r4) {
              return void 0 === r4 ? null === (r4 = t4.attr(e4)) && (t4.attr(e4, 0), r4 = 0) : t4.attr(e4, r4), r4;
            }
            var a2 = i2("x", e3), o2 = i2("y", r3);
            "text" === this.nodeName && t4.selectAll("tspan.line").attr({ x: a2, y: o2 });
          });
        };
        var O = "1px ";
        e2.makeTextShadow = function(t3) {
          return "1px 1px 1px " + t3 + ", -1px -" + O + O + t3 + ", 1px -" + O + O + t3 + ", -" + O + O + O + t3;
        }, e2.makeEditable = function(t3, e3) {
          var r3 = e3.gd, i2 = e3.delegate, a2 = n2.dispatch("edit", "input", "cancel"), o2 = i2 || t3;
          if (t3.style({ "pointer-events": i2 ? "none" : "all" }), 1 !== t3.size())
            throw new Error("boo");
          function s2() {
            var i3, s3, u2, c2, f3;
            i3 = n2.select(r3).select(".svg-container"), s3 = i3.append("div"), u2 = t3.node().style, c2 = parseFloat(u2.fontSize || 12), void 0 === (f3 = e3.text) && (f3 = t3.attr("data-unformatted")), s3.classed("plugin-editable editable", true).style({ position: "absolute", "font-family": u2.fontFamily || "Arial", "font-size": c2, color: e3.fill || u2.fill || "black", opacity: 1, "background-color": e3.background || "transparent", outline: "#ffffff33 1px solid", margin: [-c2 / 8 + 1, 0, 0, -1].join("px ") + "px", padding: "0", "box-sizing": "border-box" }).attr({ contenteditable: true }).text(f3).call(P(t3, i3, e3)).on("blur", function() {
              r3._editing = false, t3.text(this.textContent).style({ opacity: 1 });
              var e4, i4 = n2.select(this).attr("class");
              (e4 = i4 ? "." + i4.split(" ")[0] + "-math-group" : "[class*=-math-group]") && n2.select(t3.node().parentNode).select(e4).style({ opacity: 0 });
              var o3 = this.textContent;
              n2.select(this).transition().duration(0).remove(), n2.select(document).on("mouseup", null), a2.edit.call(t3, o3);
            }).on("focus", function() {
              var t4 = this;
              r3._editing = true, n2.select(document).on("mouseup", function() {
                if (n2.event.target === t4)
                  return false;
                document.activeElement === s3.node() && s3.node().blur();
              });
            }).on("keyup", function() {
              27 === n2.event.which ? (r3._editing = false, t3.style({ opacity: 1 }), n2.select(this).style({ opacity: 0 }).on("blur", function() {
                return false;
              }).transition().remove(), a2.cancel.call(t3, this.textContent)) : (a2.input.call(t3, this.textContent), n2.select(this).call(P(t3, i3, e3)));
            }).on("keydown", function() {
              13 === n2.event.which && this.blur();
            }).call(l2), t3.style({ opacity: 0 });
            var h2, p3 = o2.attr("class");
            (h2 = p3 ? "." + p3.split(" ")[0] + "-math-group" : "[class*=-math-group]") && n2.select(t3.node().parentNode).select(h2).style({ opacity: 0 });
          }
          function l2(t4) {
            var e4 = t4.node(), r4 = document.createRange();
            r4.selectNodeContents(e4);
            var n3 = window.getSelection();
            n3.removeAllRanges(), n3.addRange(r4), e4.focus();
          }
          return e3.immediate ? s2() : o2.on("click", s2), n2.rebind(t3, a2, "on");
        };
      }, 79990: function(t2, e2) {
        var r2 = {};
        function n2(t3) {
          t3 && null !== t3.timer && (clearTimeout(t3.timer), t3.timer = null);
        }
        e2.throttle = function(t3, e3, i) {
          var a = r2[t3], o = Date.now();
          if (!a) {
            for (var s in r2)
              r2[s].ts < o - 6e4 && delete r2[s];
            a = r2[t3] = { ts: 0, timer: null };
          }
          function l() {
            i(), a.ts = Date.now(), a.onDone && (a.onDone(), a.onDone = null);
          }
          n2(a), o > a.ts + e3 ? l() : a.timer = setTimeout(function() {
            l(), a.timer = null;
          }, e3);
        }, e2.done = function(t3) {
          var e3 = r2[t3];
          return e3 && e3.timer ? new Promise(function(t4) {
            var r3 = e3.onDone;
            e3.onDone = function() {
              r3 && r3(), t4(), e3.onDone = null;
            };
          }) : Promise.resolve();
        }, e2.clear = function(t3) {
          if (t3)
            n2(r2[t3]), delete r2[t3];
          else
            for (var i in r2)
              e2.clear(i);
        };
      }, 58163: function(t2, e2, r2) {
        var n2 = r2(92770);
        t2.exports = function(t3, e3) {
          if (t3 > 0)
            return Math.log(t3) / Math.LN10;
          var r3 = Math.log(Math.min(e3[0], e3[1])) / Math.LN10;
          return n2(r3) || (r3 = Math.log(Math.max(e3[0], e3[1])) / Math.LN10 - 6), r3;
        };
      }, 90973: function(t2, e2, r2) {
        var n2 = t2.exports = {}, i = r2(78776).locationmodeToLayer, a = r2(96892).zL;
        n2.getTopojsonName = function(t3) {
          return [t3.scope.replace(/ /g, "-"), "_", t3.resolution.toString(), "m"].join("");
        }, n2.getTopojsonPath = function(t3, e3) {
          return t3 + e3 + ".json";
        }, n2.getTopojsonFeatures = function(t3, e3) {
          var r3 = i[t3.locationmode], n3 = e3.objects[r3];
          return a(e3, n3).features;
        };
      }, 37815: function(t2) {
        t2.exports = { moduleType: "locale", name: "en-US", dictionary: { "Click to enter Colorscale title": "Click to enter Colorscale title" }, format: { date: "%m/%d/%Y" } };
      }, 92177: function(t2) {
        t2.exports = { moduleType: "locale", name: "en", dictionary: { "Click to enter Colorscale title": "Click to enter Colourscale title" }, format: { days: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], shortDays: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], months: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], shortMonths: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], periods: ["AM", "PM"], dateTime: "%a %b %e %X %Y", date: "%d/%m/%Y", time: "%H:%M:%S", decimal: ".", thousands: ",", grouping: [3], currency: ["$", ""], year: "%Y", month: "%b %Y", dayMonth: "%b %-d", dayMonthYear: "%b %-d, %Y" } };
      }, 14458: function(t2, e2, r2) {
        var n2 = r2(73972);
        t2.exports = function(t3) {
          for (var e3, r3, i = n2.layoutArrayContainers, a = n2.layoutArrayRegexes, o = t3.split("[")[0], s = 0; s < a.length; s++)
            if ((r3 = t3.match(a[s])) && 0 === r3.index) {
              e3 = r3[0];
              break;
            }
          if (e3 || (e3 = i[i.indexOf(o)]), !e3)
            return false;
          var l = t3.substr(e3.length);
          return l ? !!(r3 = l.match(/^\[(0|[1-9][0-9]*)\](\.(.+))?$/)) && { array: e3, index: Number(r3[1]), property: r3[3] || "" } : { array: e3, index: "", property: "" };
        };
      }, 30962: function(t2, e2, r2) {
        var n2 = r2(71828), i = n2.extendFlat, a = n2.isPlainObject, o = { valType: "flaglist", extras: ["none"], flags: ["calc", "clearAxisTypes", "plot", "style", "markerSize", "colorbars"] }, s = { valType: "flaglist", extras: ["none"], flags: ["calc", "plot", "legend", "ticks", "axrange", "layoutstyle", "modebar", "camera", "arraydraw", "colorbars"] }, l = o.flags.slice().concat(["fullReplot"]), u = s.flags.slice().concat("layoutReplot");
        function c(t3) {
          for (var e3 = {}, r3 = 0; r3 < t3.length; r3++)
            e3[t3[r3]] = false;
          return e3;
        }
        function f2(t3, e3, r3) {
          var n3 = i({}, t3);
          for (var o2 in n3) {
            var s2 = n3[o2];
            a(s2) && (n3[o2] = h(s2, e3, 0, o2));
          }
          return "from-root" === r3 && (n3.editType = e3), n3;
        }
        function h(t3, e3, r3, n3) {
          if (t3.valType) {
            var a2 = i({}, t3);
            if (a2.editType = e3, Array.isArray(t3.items)) {
              a2.items = new Array(t3.items.length);
              for (var o2 = 0; o2 < t3.items.length; o2++)
                a2.items[o2] = h(t3.items[o2], e3);
            }
            return a2;
          }
          return f2(t3, e3, "_" === n3.charAt(0) ? "nested" : "from-root");
        }
        t2.exports = { traces: o, layout: s, traceFlags: function() {
          return c(l);
        }, layoutFlags: function() {
          return c(u);
        }, update: function(t3, e3) {
          var r3 = e3.editType;
          if (r3 && "none" !== r3)
            for (var n3 = r3.split("+"), i2 = 0; i2 < n3.length; i2++)
              t3[n3[i2]] = true;
        }, overrideAll: f2 };
      }, 58377: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(27812), a = r2(73972), o = r2(71828), s = r2(74875), l = r2(41675), u = r2(7901), c = l.cleanId, f2 = l.getFromTrace, h = a.traceIs;
        function p2(t3, e3) {
          var r3 = t3[e3], n3 = e3.charAt(0);
          r3 && "paper" !== r3 && (t3[e3] = c(r3, n3, true));
        }
        function d2(t3) {
          function e3(e4, r3) {
            var n3 = t3[e4], i2 = t3.title && t3.title[r3];
            n3 && !i2 && (t3.title || (t3.title = {}), t3.title[r3] = t3[e4], delete t3[e4]);
          }
          t3 && ("string" != typeof t3.title && "number" != typeof t3.title || (t3.title = { text: t3.title }), e3("titlefont", "font"), e3("titleposition", "position"), e3("titleside", "side"), e3("titleoffset", "offset"));
        }
        function v(t3) {
          if (!o.isPlainObject(t3))
            return false;
          var e3 = t3.name;
          return delete t3.name, delete t3.showlegend, ("string" == typeof e3 || "number" == typeof e3) && String(e3);
        }
        function g2(t3, e3, r3, n3) {
          if (r3 && !n3)
            return t3;
          if (n3 && !r3)
            return e3;
          if (!t3.trim())
            return e3;
          if (!e3.trim())
            return t3;
          var i2, a2 = Math.min(t3.length, e3.length);
          for (i2 = 0; i2 < a2 && t3.charAt(i2) === e3.charAt(i2); i2++)
            ;
          return t3.substr(0, i2).trim();
        }
        function y(t3) {
          var e3 = "middle", r3 = "center";
          return "string" == typeof t3 && (-1 !== t3.indexOf("top") ? e3 = "top" : -1 !== t3.indexOf("bottom") && (e3 = "bottom"), -1 !== t3.indexOf("left") ? r3 = "left" : -1 !== t3.indexOf("right") && (r3 = "right")), e3 + " " + r3;
        }
        function m2(t3, e3) {
          return e3 in t3 && "object" == typeof t3[e3] && 0 === Object.keys(t3[e3]).length;
        }
        e2.clearPromiseQueue = function(t3) {
          Array.isArray(t3._promises) && t3._promises.length > 0 && o.log("Clearing previous rejected promises from queue."), t3._promises = [];
        }, e2.cleanLayout = function(t3) {
          var r3, n3;
          t3 || (t3 = {}), t3.xaxis1 && (t3.xaxis || (t3.xaxis = t3.xaxis1), delete t3.xaxis1), t3.yaxis1 && (t3.yaxis || (t3.yaxis = t3.yaxis1), delete t3.yaxis1), t3.scene1 && (t3.scene || (t3.scene = t3.scene1), delete t3.scene1);
          var a2 = (s.subplotsRegistry.cartesian || {}).attrRegex, l2 = (s.subplotsRegistry.polar || {}).attrRegex, f3 = (s.subplotsRegistry.ternary || {}).attrRegex, h2 = (s.subplotsRegistry.gl3d || {}).attrRegex, v2 = Object.keys(t3);
          for (r3 = 0; r3 < v2.length; r3++) {
            var g3 = v2[r3];
            if (a2 && a2.test(g3)) {
              var y2 = t3[g3];
              y2.anchor && "free" !== y2.anchor && (y2.anchor = c(y2.anchor)), y2.overlaying && (y2.overlaying = c(y2.overlaying)), y2.type || (y2.isdate ? y2.type = "date" : y2.islog ? y2.type = "log" : false === y2.isdate && false === y2.islog && (y2.type = "linear")), "withzero" !== y2.autorange && "tozero" !== y2.autorange || (y2.autorange = true, y2.rangemode = "tozero"), delete y2.islog, delete y2.isdate, delete y2.categories, m2(y2, "domain") && delete y2.domain, void 0 !== y2.autotick && (void 0 === y2.tickmode && (y2.tickmode = y2.autotick ? "auto" : "linear"), delete y2.autotick), d2(y2);
            } else if (l2 && l2.test(g3))
              d2(t3[g3].radialaxis);
            else if (f3 && f3.test(g3)) {
              var x2 = t3[g3];
              d2(x2.aaxis), d2(x2.baxis), d2(x2.caxis);
            } else if (h2 && h2.test(g3)) {
              var b2 = t3[g3], _2 = b2.cameraposition;
              if (Array.isArray(_2) && 4 === _2[0].length) {
                var w2 = _2[0], T = _2[1], k = _2[2], A = i([], w2), M = [];
                for (n3 = 0; n3 < 3; ++n3)
                  M[n3] = T[n3] + k * A[2 + 4 * n3];
                b2.camera = { eye: { x: M[0], y: M[1], z: M[2] }, center: { x: T[0], y: T[1], z: T[2] }, up: { x: 0, y: 0, z: 1 } }, delete b2.cameraposition;
              }
              d2(b2.xaxis), d2(b2.yaxis), d2(b2.zaxis);
            }
          }
          var S = Array.isArray(t3.annotations) ? t3.annotations.length : 0;
          for (r3 = 0; r3 < S; r3++) {
            var E = t3.annotations[r3];
            o.isPlainObject(E) && (E.ref && ("paper" === E.ref ? (E.xref = "paper", E.yref = "paper") : "data" === E.ref && (E.xref = "x", E.yref = "y"), delete E.ref), p2(E, "xref"), p2(E, "yref"));
          }
          var L = Array.isArray(t3.shapes) ? t3.shapes.length : 0;
          for (r3 = 0; r3 < L; r3++) {
            var C = t3.shapes[r3];
            o.isPlainObject(C) && (p2(C, "xref"), p2(C, "yref"));
          }
          var P = Array.isArray(t3.images) ? t3.images.length : 0;
          for (r3 = 0; r3 < P; r3++) {
            var O = t3.images[r3];
            o.isPlainObject(O) && (p2(O, "xref"), p2(O, "yref"));
          }
          var I = t3.legend;
          return I && (I.x > 3 ? (I.x = 1.02, I.xanchor = "left") : I.x < -2 && (I.x = -0.02, I.xanchor = "right"), I.y > 3 ? (I.y = 1.02, I.yanchor = "bottom") : I.y < -2 && (I.y = -0.02, I.yanchor = "top")), d2(t3), "rotate" === t3.dragmode && (t3.dragmode = "orbit"), u.clean(t3), t3.template && t3.template.layout && e2.cleanLayout(t3.template.layout), t3;
        }, e2.cleanData = function(t3) {
          for (var r3 = 0; r3 < t3.length; r3++) {
            var n3, i2 = t3[r3];
            if ("histogramy" === i2.type && "xbins" in i2 && !("ybins" in i2) && (i2.ybins = i2.xbins, delete i2.xbins), i2.error_y && "opacity" in i2.error_y) {
              var l2 = u.defaults, f3 = i2.error_y.color || (h(i2, "bar") ? u.defaultLine : l2[r3 % l2.length]);
              i2.error_y.color = u.addOpacity(u.rgb(f3), u.opacity(f3) * i2.error_y.opacity), delete i2.error_y.opacity;
            }
            if ("bardir" in i2 && ("h" !== i2.bardir || !h(i2, "bar") && "histogram" !== i2.type.substr(0, 9) || (i2.orientation = "h", e2.swapXYData(i2)), delete i2.bardir), "histogramy" === i2.type && e2.swapXYData(i2), "histogramx" !== i2.type && "histogramy" !== i2.type || (i2.type = "histogram"), "scl" in i2 && !("colorscale" in i2) && (i2.colorscale = i2.scl, delete i2.scl), "reversescl" in i2 && !("reversescale" in i2) && (i2.reversescale = i2.reversescl, delete i2.reversescl), i2.xaxis && (i2.xaxis = c(i2.xaxis, "x")), i2.yaxis && (i2.yaxis = c(i2.yaxis, "y")), h(i2, "gl3d") && i2.scene && (i2.scene = s.subplotsRegistry.gl3d.cleanId(i2.scene)), !h(i2, "pie-like") && !h(i2, "bar-like"))
              if (Array.isArray(i2.textposition))
                for (n3 = 0; n3 < i2.textposition.length; n3++)
                  i2.textposition[n3] = y(i2.textposition[n3]);
              else
                i2.textposition && (i2.textposition = y(i2.textposition));
            var p3 = a.getModule(i2);
            if (p3 && p3.colorbar) {
              var x2 = p3.colorbar.container, b2 = x2 ? i2[x2] : i2;
              b2 && b2.colorscale && ("YIGnBu" === b2.colorscale && (b2.colorscale = "YlGnBu"), "YIOrRd" === b2.colorscale && (b2.colorscale = "YlOrRd"));
            }
            if ("surface" === i2.type && o.isPlainObject(i2.contours)) {
              var _2 = ["x", "y", "z"];
              for (n3 = 0; n3 < _2.length; n3++) {
                var w2 = i2.contours[_2[n3]];
                o.isPlainObject(w2) && (w2.highlightColor && (w2.highlightcolor = w2.highlightColor, delete w2.highlightColor), w2.highlightWidth && (w2.highlightwidth = w2.highlightWidth, delete w2.highlightWidth));
              }
            }
            if ("candlestick" === i2.type || "ohlc" === i2.type) {
              var T = false !== (i2.increasing || {}).showlegend, k = false !== (i2.decreasing || {}).showlegend, A = v(i2.increasing), M = v(i2.decreasing);
              if (false !== A && false !== M) {
                var S = g2(A, M, T, k);
                S && (i2.name = S);
              } else
                !A && !M || i2.name || (i2.name = A || M);
            }
            if (Array.isArray(i2.transforms)) {
              var E = i2.transforms;
              for (n3 = 0; n3 < E.length; n3++) {
                var L = E[n3];
                if (o.isPlainObject(L))
                  switch (L.type) {
                    case "filter":
                      L.filtersrc && (L.target = L.filtersrc, delete L.filtersrc), L.calendar && (L.valuecalendar || (L.valuecalendar = L.calendar), delete L.calendar);
                      break;
                    case "groupby":
                      if (L.styles = L.styles || L.style, L.styles && !Array.isArray(L.styles)) {
                        var C = L.styles, P = Object.keys(C);
                        L.styles = [];
                        for (var O = 0; O < P.length; O++)
                          L.styles.push({ target: P[O], value: C[P[O]] });
                      }
                  }
              }
            }
            m2(i2, "line") && delete i2.line, "marker" in i2 && (m2(i2.marker, "line") && delete i2.marker.line, m2(i2, "marker") && delete i2.marker), u.clean(i2), i2.autobinx && (delete i2.autobinx, delete i2.xbins), i2.autobiny && (delete i2.autobiny, delete i2.ybins), d2(i2), i2.colorbar && d2(i2.colorbar), i2.marker && i2.marker.colorbar && d2(i2.marker.colorbar), i2.line && i2.line.colorbar && d2(i2.line.colorbar), i2.aaxis && d2(i2.aaxis), i2.baxis && d2(i2.baxis);
          }
        }, e2.swapXYData = function(t3) {
          var e3;
          if (o.swapAttrs(t3, ["?", "?0", "d?", "?bins", "nbins?", "autobin?", "?src", "error_?"]), Array.isArray(t3.z) && Array.isArray(t3.z[0]) && (t3.transpose ? delete t3.transpose : t3.transpose = true), t3.error_x && t3.error_y) {
            var r3 = t3.error_y, n3 = "copy_ystyle" in r3 ? r3.copy_ystyle : !(r3.color || r3.thickness || r3.width);
            o.swapAttrs(t3, ["error_?.copy_ystyle"]), n3 && o.swapAttrs(t3, ["error_?.color", "error_?.thickness", "error_?.width"]);
          }
          if ("string" == typeof t3.hoverinfo) {
            var i2 = t3.hoverinfo.split("+");
            for (e3 = 0; e3 < i2.length; e3++)
              "x" === i2[e3] ? i2[e3] = "y" : "y" === i2[e3] && (i2[e3] = "x");
            t3.hoverinfo = i2.join("+");
          }
        }, e2.coerceTraceIndices = function(t3, e3) {
          if (n2(e3))
            return [e3];
          if (!Array.isArray(e3) || !e3.length)
            return t3.data.map(function(t4, e4) {
              return e4;
            });
          if (Array.isArray(e3)) {
            for (var r3 = [], i2 = 0; i2 < e3.length; i2++)
              o.isIndex(e3[i2], t3.data.length) ? r3.push(e3[i2]) : o.warn("trace index (", e3[i2], ") is not a number or is out of bounds");
            return r3;
          }
          return e3;
        }, e2.manageArrayContainers = function(t3, e3, r3) {
          var i2 = t3.obj, a2 = t3.parts, s2 = a2.length, l2 = a2[s2 - 1], u2 = n2(l2);
          if (u2 && null === e3) {
            var c2 = a2.slice(0, s2 - 1).join(".");
            o.nestedProperty(i2, c2).get().splice(l2, 1);
          } else
            u2 && void 0 === t3.get() ? (void 0 === t3.get() && (r3[t3.astr] = null), t3.set(e3)) : t3.set(e3);
        };
        var x = /(\.[^\[\]\.]+|\[[^\[\]\.]+\])$/;
        function b(t3) {
          var e3 = t3.search(x);
          if (e3 > 0)
            return t3.substr(0, e3);
        }
        e2.hasParent = function(t3, e3) {
          for (var r3 = b(e3); r3; ) {
            if (r3 in t3)
              return true;
            r3 = b(r3);
          }
          return false;
        };
        var _ = ["x", "y", "z"];
        e2.clearAxisTypes = function(t3, e3, r3) {
          for (var n3 = 0; n3 < e3.length; n3++)
            for (var i2 = t3._fullData[n3], a2 = 0; a2 < 3; a2++) {
              var s2 = f2(t3, i2, _[a2]);
              if (s2 && "log" !== s2.type) {
                var l2 = s2._name, u2 = s2._id.substr(1);
                if ("scene" === u2.substr(0, 5)) {
                  if (void 0 !== r3[u2])
                    continue;
                  l2 = u2 + "." + l2;
                }
                var c2 = l2 + ".type";
                void 0 === r3[l2] && void 0 === r3[c2] && o.nestedProperty(t3.layout, c2).set(null);
              }
            }
        };
      }, 10641: function(t2, e2, r2) {
        var n2 = r2(72391);
        e2._doPlot = n2._doPlot, e2.newPlot = n2.newPlot, e2.restyle = n2.restyle, e2.relayout = n2.relayout, e2.redraw = n2.redraw, e2.update = n2.update, e2._guiRestyle = n2._guiRestyle, e2._guiRelayout = n2._guiRelayout, e2._guiUpdate = n2._guiUpdate, e2._storeDirectGUIEdit = n2._storeDirectGUIEdit, e2.react = n2.react, e2.extendTraces = n2.extendTraces, e2.prependTraces = n2.prependTraces, e2.addTraces = n2.addTraces, e2.deleteTraces = n2.deleteTraces, e2.moveTraces = n2.moveTraces, e2.purge = n2.purge, e2.addFrames = n2.addFrames, e2.deleteFrames = n2.deleteFrames, e2.animate = n2.animate, e2.setPlotConfig = n2.setPlotConfig, e2.toImage = r2(403), e2.validate = r2(84936), e2.downloadImage = r2(7239);
        var i = r2(96318);
        e2.makeTemplate = i.makeTemplate, e2.validateTemplate = i.validateTemplate;
      }, 6611: function(t2, e2, r2) {
        var n2 = r2(41965), i = r2(64213), a = r2(47769), o = r2(65888).sorterAsc, s = r2(73972);
        e2.containerArrayMatch = r2(14458);
        var l = e2.isAddVal = function(t3) {
          return "add" === t3 || n2(t3);
        }, u = e2.isRemoveVal = function(t3) {
          return null === t3 || "remove" === t3;
        };
        e2.applyContainerArrayChanges = function(t3, e3, r3, n3, c) {
          var f2 = e3.astr, h = s.getComponentMethod(f2, "supplyLayoutDefaults"), p2 = s.getComponentMethod(f2, "draw"), d2 = s.getComponentMethod(f2, "drawOne"), v = n3.replot || n3.recalc || h === i || p2 === i, g2 = t3.layout, y = t3._fullLayout;
          if (r3[""]) {
            Object.keys(r3).length > 1 && a.warn("Full array edits are incompatible with other edits", f2);
            var m2 = r3[""][""];
            if (u(m2))
              e3.set(null);
            else {
              if (!Array.isArray(m2))
                return a.warn("Unrecognized full array edit value", f2, m2), true;
              e3.set(m2);
            }
            return !v && (h(g2, y), p2(t3), true);
          }
          var x, b, _, w2, T, k, A, M, S = Object.keys(r3).map(Number).sort(o), E = e3.get(), L = E || [], C = c(y, f2).get(), P = [], O = -1, I = L.length;
          for (x = 0; x < S.length; x++)
            if (w2 = r3[_ = S[x]], T = Object.keys(w2), k = w2[""], A = l(k), _ < 0 || _ > L.length - (A ? 0 : 1))
              a.warn("index out of range", f2, _);
            else if (void 0 !== k)
              T.length > 1 && a.warn("Insertion & removal are incompatible with edits to the same index.", f2, _), u(k) ? P.push(_) : A ? ("add" === k && (k = {}), L.splice(_, 0, k), C && C.splice(_, 0, {})) : a.warn("Unrecognized full object edit value", f2, _, k), -1 === O && (O = _);
            else
              for (b = 0; b < T.length; b++)
                M = f2 + "[" + _ + "].", c(L[_], T[b], M).set(w2[T[b]]);
          for (x = P.length - 1; x >= 0; x--)
            L.splice(P[x], 1), C && C.splice(P[x], 1);
          if (L.length ? E || e3.set(L) : e3.set(null), v)
            return false;
          if (h(g2, y), d2 !== i) {
            var D;
            if (-1 === O)
              D = S;
            else {
              for (I = Math.max(L.length, I), D = [], x = 0; x < S.length && !((_ = S[x]) >= O); x++)
                D.push(_);
              for (x = O; x < I; x++)
                D.push(x);
            }
            for (x = 0; x < D.length; x++)
              d2(t3, D[x]);
          } else
            p2(t3);
          return true;
        };
      }, 72391: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(92770), a = r2(57035), o = r2(71828), s = o.nestedProperty, l = r2(11086), u = r2(10847), c = r2(73972), f2 = r2(86281), h = r2(74875), p2 = r2(89298), d2 = r2(91424), v = r2(7901), g2 = r2(4305).initInteractions, y = r2(77922), m2 = r2(47322).clearOutline, x = r2(72075).dfltConfig, b = r2(6611), _ = r2(58377), w2 = r2(61549), T = r2(30962), k = r2(85555).AX_NAME_PATTERN, A = 0;
        function M(t3) {
          var e3 = t3._fullLayout;
          e3._redrawFromAutoMarginCount ? e3._redrawFromAutoMarginCount-- : t3.emit("plotly_afterplot");
        }
        function S(t3, e3) {
          try {
            t3._fullLayout._paper.style("background", e3);
          } catch (t4) {
            o.error(t4);
          }
        }
        function E(t3, e3) {
          S(t3, v.combine(e3, "white"));
        }
        function L(t3, e3) {
          if (!t3._context) {
            t3._context = o.extendDeep({}, x);
            var r3 = n2.select("base");
            t3._context._baseUrl = r3.size() && r3.attr("href") ? window.location.href.split("#")[0] : "";
          }
          var i2, s2, l2, u2 = t3._context;
          if (e3) {
            for (s2 = Object.keys(e3), i2 = 0; i2 < s2.length; i2++)
              "editable" !== (l2 = s2[i2]) && "edits" !== l2 && l2 in u2 && ("setBackground" === l2 && "opaque" === e3[l2] ? u2[l2] = E : u2[l2] = e3[l2]);
            e3.plot3dPixelRatio && !u2.plotGlPixelRatio && (u2.plotGlPixelRatio = u2.plot3dPixelRatio);
            var c2 = e3.editable;
            if (void 0 !== c2)
              for (u2.editable = c2, s2 = Object.keys(u2.edits), i2 = 0; i2 < s2.length; i2++)
                u2.edits[s2[i2]] = c2;
            if (e3.edits)
              for (s2 = Object.keys(e3.edits), i2 = 0; i2 < s2.length; i2++)
                (l2 = s2[i2]) in u2.edits && (u2.edits[l2] = e3.edits[l2]);
            u2._exportedPlot = e3._exportedPlot;
          }
          u2.staticPlot && (u2.editable = false, u2.edits = {}, u2.autosizable = false, u2.scrollZoom = false, u2.doubleClick = false, u2.showTips = false, u2.showLink = false, u2.displayModeBar = false), "hover" !== u2.displayModeBar || a || (u2.displayModeBar = true), "transparent" !== u2.setBackground && "function" == typeof u2.setBackground || (u2.setBackground = S), u2._hasZeroHeight = u2._hasZeroHeight || 0 === t3.clientHeight, u2._hasZeroWidth = u2._hasZeroWidth || 0 === t3.clientWidth;
          var f3 = u2.scrollZoom, h2 = u2._scrollZoom = {};
          if (true === f3)
            h2.cartesian = 1, h2.gl3d = 1, h2.geo = 1, h2.mapbox = 1;
          else if ("string" == typeof f3) {
            var p3 = f3.split("+");
            for (i2 = 0; i2 < p3.length; i2++)
              h2[p3[i2]] = 1;
          } else
            false !== f3 && (h2.gl3d = 1, h2.geo = 1, h2.mapbox = 1);
        }
        function C(t3, e3) {
          var r3, n3, i2 = e3 + 1, a2 = [];
          for (r3 = 0; r3 < t3.length; r3++)
            (n3 = t3[r3]) < 0 ? a2.push(i2 + n3) : a2.push(n3);
          return a2;
        }
        function P(t3, e3, r3) {
          var n3, i2;
          for (n3 = 0; n3 < e3.length; n3++) {
            if ((i2 = e3[n3]) !== parseInt(i2, 10))
              throw new Error("all values in " + r3 + " must be integers");
            if (i2 >= t3.data.length || i2 < -t3.data.length)
              throw new Error(r3 + " must be valid indices for gd.data.");
            if (e3.indexOf(i2, n3 + 1) > -1 || i2 >= 0 && e3.indexOf(-t3.data.length + i2) > -1 || i2 < 0 && e3.indexOf(t3.data.length + i2) > -1)
              throw new Error("each index in " + r3 + " must be unique.");
          }
        }
        function O(t3, e3, r3) {
          if (!Array.isArray(t3.data))
            throw new Error("gd.data must be an array.");
          if (void 0 === e3)
            throw new Error("currentIndices is a required argument.");
          if (Array.isArray(e3) || (e3 = [e3]), P(t3, e3, "currentIndices"), void 0 === r3 || Array.isArray(r3) || (r3 = [r3]), void 0 !== r3 && P(t3, r3, "newIndices"), void 0 !== r3 && e3.length !== r3.length)
            throw new Error("current and new indices must be of equal length.");
        }
        function I(t3, e3, r3, n3, a2) {
          !function(t4, e4, r4, n4) {
            var i2 = o.isPlainObject(n4);
            if (!Array.isArray(t4.data))
              throw new Error("gd.data must be an array");
            if (!o.isPlainObject(e4))
              throw new Error("update must be a key:value object");
            if (void 0 === r4)
              throw new Error("indices must be an integer or array of integers");
            for (var a3 in P(t4, r4, "indices"), e4) {
              if (!Array.isArray(e4[a3]) || e4[a3].length !== r4.length)
                throw new Error("attribute " + a3 + " must be an array of length equal to indices array length");
              if (i2 && (!(a3 in n4) || !Array.isArray(n4[a3]) || n4[a3].length !== e4[a3].length))
                throw new Error("when maxPoints is set as a key:value object it must contain a 1:1 corrispondence with the keys and number of traces in the update object");
            }
          }(t3, e3, r3, n3);
          for (var l2 = function(t4, e4, r4, n4) {
            var a3, l3, u3, c3, f4, h3 = o.isPlainObject(n4), p4 = [];
            for (var d4 in Array.isArray(r4) || (r4 = [r4]), r4 = C(r4, t4.data.length - 1), e4)
              for (var v2 = 0; v2 < r4.length; v2++) {
                if (a3 = t4.data[r4[v2]], l3 = (u3 = s(a3, d4)).get(), c3 = e4[d4][v2], !o.isArrayOrTypedArray(c3))
                  throw new Error("attribute: " + d4 + " index: " + v2 + " must be an array");
                if (!o.isArrayOrTypedArray(l3))
                  throw new Error("cannot extend missing or non-array attribute: " + d4);
                if (l3.constructor !== c3.constructor)
                  throw new Error("cannot extend array with an array of a different type: " + d4);
                f4 = h3 ? n4[d4][v2] : n4, i(f4) || (f4 = -1), p4.push({ prop: u3, target: l3, insert: c3, maxp: Math.floor(f4) });
              }
            return p4;
          }(t3, e3, r3, n3), u2 = {}, c2 = {}, f3 = 0; f3 < l2.length; f3++) {
            var h2 = l2[f3].prop, p3 = l2[f3].maxp, d3 = a2(l2[f3].target, l2[f3].insert, p3);
            h2.set(d3[0]), Array.isArray(u2[h2.astr]) || (u2[h2.astr] = []), u2[h2.astr].push(d3[1]), Array.isArray(c2[h2.astr]) || (c2[h2.astr] = []), c2[h2.astr].push(l2[f3].target.length);
          }
          return { update: u2, maxPoints: c2 };
        }
        function D(t3, e3) {
          var r3 = new t3.constructor(t3.length + e3.length);
          return r3.set(t3), r3.set(e3, t3.length), r3;
        }
        function z(t3, r3, n3, i2) {
          t3 = o.getGraphDiv(t3), _.clearPromiseQueue(t3);
          var a2 = {};
          if ("string" == typeof r3)
            a2[r3] = n3;
          else {
            if (!o.isPlainObject(r3))
              return o.warn("Restyle fail.", r3, n3, i2), Promise.reject();
            a2 = o.extendFlat({}, r3), void 0 === i2 && (i2 = n3);
          }
          Object.keys(a2).length && (t3.changed = true);
          var s2 = _.coerceTraceIndices(t3, i2), l2 = N(t3, a2, s2), c2 = l2.flags;
          c2.calc && (t3.calcdata = void 0), c2.clearAxisTypes && _.clearAxisTypes(t3, s2, {});
          var f3 = [];
          c2.fullReplot ? f3.push(e2._doPlot) : (f3.push(h.previousPromises), h.supplyDefaults(t3), c2.markerSize && (h.doCalcdata(t3), H(f3)), c2.style && f3.push(w2.doTraceStyle), c2.colorbars && f3.push(w2.doColorBars), f3.push(M)), f3.push(h.rehover, h.redrag, h.reselect), u.add(t3, z, [t3, l2.undoit, l2.traces], z, [t3, l2.redoit, l2.traces]);
          var p3 = o.syncOrAsync(f3, t3);
          return p3 && p3.then || (p3 = Promise.resolve()), p3.then(function() {
            return t3.emit("plotly_restyle", l2.eventData), t3;
          });
        }
        function R(t3) {
          return void 0 === t3 ? null : t3;
        }
        function F(t3, e3) {
          return e3 ? function(e4, r3, n3) {
            var i2 = s(e4, r3), a2 = i2.set;
            return i2.set = function(e5) {
              B((n3 || "") + r3, i2.get(), e5, t3), a2(e5);
            }, i2;
          } : s;
        }
        function B(t3, e3, r3, n3) {
          if (Array.isArray(e3) || Array.isArray(r3))
            for (var i2 = Array.isArray(e3) ? e3 : [], a2 = Array.isArray(r3) ? r3 : [], s2 = Math.max(i2.length, a2.length), l2 = 0; l2 < s2; l2++)
              B(t3 + "[" + l2 + "]", i2[l2], a2[l2], n3);
          else if (o.isPlainObject(e3) || o.isPlainObject(r3)) {
            var u2 = o.isPlainObject(e3) ? e3 : {}, c2 = o.isPlainObject(r3) ? r3 : {}, f3 = o.extendFlat({}, u2, c2);
            for (var h2 in f3)
              B(t3 + "." + h2, u2[h2], c2[h2], n3);
          } else
            void 0 === n3[t3] && (n3[t3] = R(e3));
        }
        function N(t3, e3, r3) {
          var n3, i2 = t3._fullLayout, a2 = t3._fullData, l2 = t3.data, u2 = i2._guiEditing, d3 = F(i2._preGUI, u2), v2 = o.extendDeepAll({}, e3);
          j(e3);
          var g3, y2 = T.traceFlags(), m3 = {}, x2 = {};
          function b2() {
            return r3.map(function() {
            });
          }
          function w3(t4) {
            var e4 = p2.id2name(t4);
            -1 === g3.indexOf(e4) && g3.push(e4);
          }
          function k2(t4) {
            return "LAYOUT" + t4 + ".autorange";
          }
          function A2(t4) {
            return "LAYOUT" + t4 + ".range";
          }
          function M2(t4) {
            for (var e4 = t4; e4 < a2.length; e4++)
              if (a2[e4]._input === l2[t4])
                return a2[e4];
          }
          function S2(n4, a3, o2) {
            if (Array.isArray(n4))
              n4.forEach(function(t4) {
                S2(t4, a3, o2);
              });
            else if (!(n4 in e3) && !_.hasParent(e3, n4)) {
              var s2;
              if ("LAYOUT" === n4.substr(0, 6))
                s2 = d3(t3.layout, n4.replace("LAYOUT", ""));
              else {
                var c2 = r3[o2];
                s2 = F(i2._tracePreGUI[M2(c2)._fullInput.uid], u2)(l2[c2], n4);
              }
              n4 in x2 || (x2[n4] = b2()), void 0 === x2[n4][o2] && (x2[n4][o2] = R(s2.get())), void 0 !== a3 && s2.set(a3);
            }
          }
          function E2(t4) {
            return function(e4) {
              return a2[e4][t4];
            };
          }
          function L2(t4) {
            return function(e4, n4) {
              return false === e4 ? a2[r3[n4]][t4] : null;
            };
          }
          for (var C2 in e3) {
            if (_.hasParent(e3, C2))
              throw new Error("cannot set " + C2 + " and a parent attribute simultaneously");
            var P2, O2, I2, D2, z2, B2, N2 = e3[C2];
            if ("autobinx" !== C2 && "autobiny" !== C2 || (C2 = C2.charAt(C2.length - 1) + "bins", N2 = Array.isArray(N2) ? N2.map(L2(C2)) : false === N2 ? r3.map(E2(C2)) : null), m3[C2] = N2, "LAYOUT" !== C2.substr(0, 6)) {
              for (x2[C2] = b2(), n3 = 0; n3 < r3.length; n3++)
                if (P2 = l2[r3[n3]], O2 = M2(r3[n3]), D2 = (I2 = F(i2._tracePreGUI[O2._fullInput.uid], u2)(P2, C2)).get(), void 0 !== (z2 = Array.isArray(N2) ? N2[n3 % N2.length] : N2)) {
                  var U2 = I2.parts[I2.parts.length - 1], V2 = C2.substr(0, C2.length - U2.length - 1), H2 = V2 ? V2 + "." : "", q3 = V2 ? s(O2, V2).get() : O2;
                  if ((B2 = f2.getTraceValObject(O2, I2.parts)) && B2.impliedEdits && null !== z2)
                    for (var G2 in B2.impliedEdits)
                      S2(o.relativeAttr(C2, G2), B2.impliedEdits[G2], n3);
                  else if ("thicknessmode" !== U2 && "lenmode" !== U2 || D2 === z2 || "fraction" !== z2 && "pixels" !== z2 || !q3) {
                    if ("type" === C2 && ("pie" === z2 != ("pie" === D2) || "funnelarea" === z2 != ("funnelarea" === D2))) {
                      var Z2 = "x", Y2 = "y";
                      "bar" !== z2 && "bar" !== D2 || "h" !== P2.orientation || (Z2 = "y", Y2 = "x"), o.swapAttrs(P2, ["?", "?src"], "labels", Z2), o.swapAttrs(P2, ["d?", "?0"], "label", Z2), o.swapAttrs(P2, ["?", "?src"], "values", Y2), "pie" === D2 || "funnelarea" === D2 ? (s(P2, "marker.color").set(s(P2, "marker.colors").get()), i2._pielayer.selectAll("g.trace").remove()) : c.traceIs(P2, "cartesian") && s(P2, "marker.colors").set(s(P2, "marker.color").get());
                    }
                  } else {
                    var W2 = i2._size, X2 = q3.orient, J2 = "top" === X2 || "bottom" === X2;
                    if ("thicknessmode" === U2) {
                      var K2 = J2 ? W2.h : W2.w;
                      S2(H2 + "thickness", q3.thickness * ("fraction" === z2 ? 1 / K2 : K2), n3);
                    } else {
                      var $2 = J2 ? W2.w : W2.h;
                      S2(H2 + "len", q3.len * ("fraction" === z2 ? 1 / $2 : $2), n3);
                    }
                  }
                  if (x2[C2][n3] = R(D2), -1 !== ["swapxy", "swapxyaxes", "orientation", "orientationaxes"].indexOf(C2)) {
                    if ("orientation" === C2) {
                      I2.set(z2);
                      var Q2 = P2.x && !P2.y ? "h" : "v";
                      if ((I2.get() || Q2) === O2.orientation)
                        continue;
                    } else
                      "orientationaxes" === C2 && (P2.orientation = { v: "h", h: "v" }[O2.orientation]);
                    _.swapXYData(P2), y2.calc = y2.clearAxisTypes = true;
                  } else
                    -1 !== h.dataArrayContainers.indexOf(I2.parts[0]) ? (_.manageArrayContainers(I2, z2, x2), y2.calc = true) : (B2 ? B2.arrayOk && !c.traceIs(O2, "regl") && (o.isArrayOrTypedArray(z2) || o.isArrayOrTypedArray(D2)) ? y2.calc = true : T.update(y2, B2) : y2.calc = true, I2.set(z2));
                }
              if (-1 !== ["swapxyaxes", "orientationaxes"].indexOf(C2) && p2.swap(t3, r3), "orientationaxes" === C2) {
                var tt2 = s(t3.layout, "hovermode"), et2 = tt2.get();
                "x" === et2 ? tt2.set("y") : "y" === et2 ? tt2.set("x") : "x unified" === et2 ? tt2.set("y unified") : "y unified" === et2 && tt2.set("x unified");
              }
              if (-1 !== ["orientation", "type"].indexOf(C2)) {
                for (g3 = [], n3 = 0; n3 < r3.length; n3++) {
                  var rt2 = l2[r3[n3]];
                  c.traceIs(rt2, "cartesian") && (w3(rt2.xaxis || "x"), w3(rt2.yaxis || "y"));
                }
                S2(g3.map(k2), true, 0), S2(g3.map(A2), [0, 1], 0);
              }
            } else
              I2 = d3(t3.layout, C2.replace("LAYOUT", "")), x2[C2] = [R(I2.get())], I2.set(Array.isArray(N2) ? N2[0] : N2), y2.calc = true;
          }
          return (y2.calc || y2.plot) && (y2.fullReplot = true), { flags: y2, undoit: x2, redoit: m3, traces: r3, eventData: o.extendDeepNoArrays([], [v2, r3]) };
        }
        function j(t3) {
          var e3, r3, n3, i2 = o.counterRegex("axis", ".title", false, false), a2 = /colorbar\.title$/, s2 = Object.keys(t3);
          for (e3 = 0; e3 < s2.length; e3++)
            r3 = s2[e3], n3 = t3[r3], "title" !== r3 && !i2.test(r3) && !a2.test(r3) || "string" != typeof n3 && "number" != typeof n3 ? r3.indexOf("titlefont") > -1 && -1 === r3.indexOf("grouptitlefont") ? l2(r3, r3.replace("titlefont", "title.font")) : r3.indexOf("titleposition") > -1 ? l2(r3, r3.replace("titleposition", "title.position")) : r3.indexOf("titleside") > -1 ? l2(r3, r3.replace("titleside", "title.side")) : r3.indexOf("titleoffset") > -1 && l2(r3, r3.replace("titleoffset", "title.offset")) : l2(r3, r3.replace("title", "title.text"));
          function l2(e4, r4) {
            t3[r4] = t3[e4], delete t3[e4];
          }
        }
        function U(t3, e3, r3) {
          t3 = o.getGraphDiv(t3), _.clearPromiseQueue(t3);
          var n3 = {};
          if ("string" == typeof e3)
            n3[e3] = r3;
          else {
            if (!o.isPlainObject(e3))
              return o.warn("Relayout fail.", e3, r3), Promise.reject();
            n3 = o.extendFlat({}, e3);
          }
          Object.keys(n3).length && (t3.changed = true);
          var i2 = Y(t3, n3), a2 = i2.flags;
          a2.calc && (t3.calcdata = void 0);
          var s2 = [h.previousPromises];
          a2.layoutReplot ? s2.push(w2.layoutReplot) : Object.keys(n3).length && (V(t3, a2, i2) || h.supplyDefaults(t3), a2.legend && s2.push(w2.doLegend), a2.layoutstyle && s2.push(w2.layoutStyles), a2.axrange && H(s2, i2.rangesAltered), a2.ticks && s2.push(w2.doTicksRelayout), a2.modebar && s2.push(w2.doModeBar), a2.camera && s2.push(w2.doCamera), a2.colorbars && s2.push(w2.doColorBars), s2.push(M)), s2.push(h.rehover, h.redrag, h.reselect), u.add(t3, U, [t3, i2.undoit], U, [t3, i2.redoit]);
          var l2 = o.syncOrAsync(s2, t3);
          return l2 && l2.then || (l2 = Promise.resolve(t3)), l2.then(function() {
            return t3.emit("plotly_relayout", i2.eventData), t3;
          });
        }
        function V(t3, e3, r3) {
          var n3 = t3._fullLayout;
          if (!e3.axrange)
            return false;
          for (var i2 in e3)
            if ("axrange" !== i2 && e3[i2])
              return false;
          for (var a2 in r3.rangesAltered) {
            var o2 = p2.id2name(a2), s2 = t3.layout[o2], l2 = n3[o2];
            if (l2.autorange = s2.autorange, s2.range && (l2.range = s2.range.slice()), l2.cleanRange(), l2._matchGroup) {
              for (var u2 in l2._matchGroup)
                if (u2 !== a2) {
                  var c2 = n3[p2.id2name(u2)];
                  c2.autorange = l2.autorange, c2.range = l2.range.slice(), c2._input.range = l2.range.slice();
                }
            }
          }
          return true;
        }
        function H(t3, e3) {
          var r3 = e3 ? function(t4) {
            var r4 = [];
            for (var n3 in e3) {
              var i2 = p2.getFromId(t4, n3);
              if (r4.push(n3), -1 !== (i2.ticklabelposition || "").indexOf("inside") && i2._anchorAxis && r4.push(i2._anchorAxis._id), i2._matchGroup)
                for (var a2 in i2._matchGroup)
                  e3[a2] || r4.push(a2);
            }
            return p2.draw(t4, r4, { skipTitle: true });
          } : function(t4) {
            return p2.draw(t4, "redraw");
          };
          t3.push(m2, w2.doAutoRangeAndConstraints, r3, w2.drawData, w2.finalDraw);
        }
        var q2 = /^[xyz]axis[0-9]*\.range(\[[0|1]\])?$/, G = /^[xyz]axis[0-9]*\.autorange$/, Z = /^[xyz]axis[0-9]*\.domain(\[[0|1]\])?$/;
        function Y(t3, e3) {
          var r3, n3, i2, a2 = t3.layout, l2 = t3._fullLayout, u2 = l2._guiEditing, h2 = F(l2._preGUI, u2), d3 = Object.keys(e3), v2 = p2.list(t3), g3 = o.extendDeepAll({}, e3), y2 = {};
          for (j(e3), d3 = Object.keys(e3), n3 = 0; n3 < d3.length; n3++)
            if (0 === d3[n3].indexOf("allaxes")) {
              for (i2 = 0; i2 < v2.length; i2++) {
                var m3 = v2[i2]._id.substr(1), x2 = -1 !== m3.indexOf("scene") ? m3 + "." : "", w3 = d3[n3].replace("allaxes", x2 + v2[i2]._name);
                e3[w3] || (e3[w3] = e3[d3[n3]]);
              }
              delete e3[d3[n3]];
            }
          var A2 = T.layoutFlags(), M2 = {}, S2 = {};
          function E2(t4, r4) {
            if (Array.isArray(t4))
              t4.forEach(function(t5) {
                E2(t5, r4);
              });
            else if (!(t4 in e3) && !_.hasParent(e3, t4)) {
              var n4 = h2(a2, t4);
              t4 in S2 || (S2[t4] = R(n4.get())), void 0 !== r4 && n4.set(r4);
            }
          }
          var L2, C2 = {};
          function P2(t4) {
            var e4 = p2.name2id(t4.split(".")[0]);
            return C2[e4] = 1, e4;
          }
          for (var O2 in e3) {
            if (_.hasParent(e3, O2))
              throw new Error("cannot set " + O2 + " and a parent attribute simultaneously");
            for (var I2 = h2(a2, O2), D2 = e3[O2], z2 = I2.parts.length - 1; z2 > 0 && "string" != typeof I2.parts[z2]; )
              z2--;
            var B2 = I2.parts[z2], N2 = I2.parts[z2 - 1] + "." + B2, U2 = I2.parts.slice(0, z2).join("."), V2 = s(t3.layout, U2).get(), H2 = s(l2, U2).get(), Y2 = I2.get();
            if (void 0 !== D2) {
              M2[O2] = D2, S2[O2] = "reverse" === B2 ? D2 : R(Y2);
              var X2 = f2.getLayoutValObject(l2, I2.parts);
              if (X2 && X2.impliedEdits && null !== D2)
                for (var J2 in X2.impliedEdits)
                  E2(o.relativeAttr(O2, J2), X2.impliedEdits[J2]);
              if (-1 !== ["width", "height"].indexOf(O2))
                if (D2) {
                  E2("autosize", null);
                  var K2 = "height" === O2 ? "width" : "height";
                  E2(K2, l2[K2]);
                } else
                  l2[O2] = t3._initialAutoSize[O2];
              else if ("autosize" === O2)
                E2("width", D2 ? null : l2.width), E2("height", D2 ? null : l2.height);
              else if (N2.match(q2))
                P2(N2), s(l2, U2 + "._inputRange").set(null);
              else if (N2.match(G)) {
                P2(N2), s(l2, U2 + "._inputRange").set(null);
                var $2 = s(l2, U2).get();
                $2._inputDomain && ($2._input.domain = $2._inputDomain.slice());
              } else
                N2.match(Z) && s(l2, U2 + "._inputDomain").set(null);
              if ("type" === B2) {
                L2 = V2;
                var Q2 = "linear" === H2.type && "log" === D2, tt2 = "log" === H2.type && "linear" === D2;
                if (Q2 || tt2) {
                  if (L2 && L2.range)
                    if (H2.autorange)
                      Q2 && (L2.range = L2.range[1] > L2.range[0] ? [1, 2] : [2, 1]);
                    else {
                      var et2 = L2.range[0], rt2 = L2.range[1];
                      Q2 ? (et2 <= 0 && rt2 <= 0 && E2(U2 + ".autorange", true), et2 <= 0 ? et2 = rt2 / 1e6 : rt2 <= 0 && (rt2 = et2 / 1e6), E2(U2 + ".range[0]", Math.log(et2) / Math.LN10), E2(U2 + ".range[1]", Math.log(rt2) / Math.LN10)) : (E2(U2 + ".range[0]", Math.pow(10, et2)), E2(U2 + ".range[1]", Math.pow(10, rt2)));
                    }
                  else
                    E2(U2 + ".autorange", true);
                  Array.isArray(l2._subplots.polar) && l2._subplots.polar.length && l2[I2.parts[0]] && "radialaxis" === I2.parts[1] && delete l2[I2.parts[0]]._subplot.viewInitial["radialaxis.range"], c.getComponentMethod("annotations", "convertCoords")(t3, H2, D2, E2), c.getComponentMethod("images", "convertCoords")(t3, H2, D2, E2);
                } else
                  E2(U2 + ".autorange", true), E2(U2 + ".range", null);
                s(l2, U2 + "._inputRange").set(null);
              } else if (B2.match(k)) {
                var nt2 = s(l2, O2).get(), it2 = (D2 || {}).type;
                it2 && "-" !== it2 || (it2 = "linear"), c.getComponentMethod("annotations", "convertCoords")(t3, nt2, it2, E2), c.getComponentMethod("images", "convertCoords")(t3, nt2, it2, E2);
              }
              var at2 = b.containerArrayMatch(O2);
              if (at2) {
                r3 = at2.array, n3 = at2.index;
                var ot2 = at2.property, st = X2 || { editType: "calc" };
                "" !== n3 && "" === ot2 && (b.isAddVal(D2) ? S2[O2] = null : b.isRemoveVal(D2) ? S2[O2] = (s(a2, r3).get() || [])[n3] : o.warn("unrecognized full object value", e3)), T.update(A2, st), y2[r3] || (y2[r3] = {});
                var lt = y2[r3][n3];
                lt || (lt = y2[r3][n3] = {}), lt[ot2] = D2, delete e3[O2];
              } else
                "reverse" === B2 ? (V2.range ? V2.range.reverse() : (E2(U2 + ".autorange", true), V2.range = [1, 0]), H2.autorange ? A2.calc = true : A2.plot = true) : ("dragmode" === O2 && (false === D2 && false !== Y2 || false !== D2 && false === Y2) || l2._has("scatter-like") && l2._has("regl") && "dragmode" === O2 && ("lasso" === D2 || "select" === D2) && "lasso" !== Y2 && "select" !== Y2 || l2._has("gl2d") ? A2.plot = true : X2 ? T.update(A2, X2) : A2.calc = true, I2.set(D2));
            }
          }
          for (r3 in y2)
            b.applyContainerArrayChanges(t3, h2(a2, r3), y2[r3], A2, h2) || (A2.plot = true);
          for (var ut in C2) {
            var ct = (L2 = p2.getFromId(t3, ut)) && L2._constraintGroup;
            if (ct)
              for (var ft in A2.calc = true, ct)
                C2[ft] || (p2.getFromId(t3, ft)._constraintShrinkable = true);
          }
          return (W(t3) || e3.height || e3.width) && (A2.plot = true), (A2.plot || A2.calc) && (A2.layoutReplot = true), { flags: A2, rangesAltered: C2, undoit: S2, redoit: M2, eventData: g3 };
        }
        function W(t3) {
          var e3 = t3._fullLayout, r3 = e3.width, n3 = e3.height;
          return t3.layout.autosize && h.plotAutoSize(t3, t3.layout, e3), e3.width !== r3 || e3.height !== n3;
        }
        function X(t3, r3, n3, i2) {
          t3 = o.getGraphDiv(t3), _.clearPromiseQueue(t3), o.isPlainObject(r3) || (r3 = {}), o.isPlainObject(n3) || (n3 = {}), Object.keys(r3).length && (t3.changed = true), Object.keys(n3).length && (t3.changed = true);
          var a2 = _.coerceTraceIndices(t3, i2), s2 = N(t3, o.extendFlat({}, r3), a2), l2 = s2.flags, c2 = Y(t3, o.extendFlat({}, n3)), f3 = c2.flags;
          (l2.calc || f3.calc) && (t3.calcdata = void 0), l2.clearAxisTypes && _.clearAxisTypes(t3, a2, n3);
          var p3 = [];
          f3.layoutReplot ? p3.push(w2.layoutReplot) : l2.fullReplot ? p3.push(e2._doPlot) : (p3.push(h.previousPromises), V(t3, f3, c2) || h.supplyDefaults(t3), l2.style && p3.push(w2.doTraceStyle), (l2.colorbars || f3.colorbars) && p3.push(w2.doColorBars), f3.legend && p3.push(w2.doLegend), f3.layoutstyle && p3.push(w2.layoutStyles), f3.axrange && H(p3, c2.rangesAltered), f3.ticks && p3.push(w2.doTicksRelayout), f3.modebar && p3.push(w2.doModeBar), f3.camera && p3.push(w2.doCamera), p3.push(M)), p3.push(h.rehover, h.redrag, h.reselect), u.add(t3, X, [t3, s2.undoit, c2.undoit, s2.traces], X, [t3, s2.redoit, c2.redoit, s2.traces]);
          var d3 = o.syncOrAsync(p3, t3);
          return d3 && d3.then || (d3 = Promise.resolve(t3)), d3.then(function() {
            return t3.emit("plotly_update", { data: s2.eventData, layout: c2.eventData }), t3;
          });
        }
        function J(t3) {
          return function(e3) {
            e3._fullLayout._guiEditing = true;
            var r3 = t3.apply(null, arguments);
            return e3._fullLayout._guiEditing = false, r3;
          };
        }
        var K = [{ pattern: /^hiddenlabels/, attr: "legend.uirevision" }, { pattern: /^((x|y)axis\d*)\.((auto)?range|title\.text)/ }, { pattern: /axis\d*\.showspikes$/, attr: "modebar.uirevision" }, { pattern: /(hover|drag)mode$/, attr: "modebar.uirevision" }, { pattern: /^(scene\d*)\.camera/ }, { pattern: /^(geo\d*)\.(projection|center|fitbounds)/ }, { pattern: /^(ternary\d*\.[abc]axis)\.(min|title\.text)$/ }, { pattern: /^(polar\d*\.radialaxis)\.((auto)?range|angle|title\.text)/ }, { pattern: /^(polar\d*\.angularaxis)\.rotation/ }, { pattern: /^(mapbox\d*)\.(center|zoom|bearing|pitch)/ }, { pattern: /^legend\.(x|y)$/, attr: "editrevision" }, { pattern: /^(shapes|annotations)/, attr: "editrevision" }, { pattern: /^title\.text$/, attr: "editrevision" }], $ = [{ pattern: /^selectedpoints$/, attr: "selectionrevision" }, { pattern: /(^|value\.)visible$/, attr: "legend.uirevision" }, { pattern: /^dimensions\[\d+\]\.constraintrange/ }, { pattern: /^node\.(x|y|groups)/ }, { pattern: /^level$/ }, { pattern: /(^|value\.)name$/ }, { pattern: /colorbar\.title\.text$/ }, { pattern: /colorbar\.(x|y)$/, attr: "editrevision" }];
        function Q(t3, e3) {
          for (var r3 = 0; r3 < e3.length; r3++) {
            var n3 = e3[r3], i2 = t3.match(n3.pattern);
            if (i2) {
              var a2 = i2[1] || "";
              return { head: a2, tail: t3.substr(a2.length + 1), attr: n3.attr };
            }
          }
        }
        function tt(t3, e3) {
          var r3 = s(e3, t3).get();
          if (void 0 !== r3)
            return r3;
          var n3 = t3.split(".");
          for (n3.pop(); n3.length > 1; )
            if (n3.pop(), void 0 !== (r3 = s(e3, n3.join(".") + ".uirevision").get()))
              return r3;
          return e3.uirevision;
        }
        function et(t3, e3) {
          for (var r3 = 0; r3 < e3.length; r3++)
            if (e3[r3]._fullInput.uid === t3)
              return r3;
          return -1;
        }
        function rt(t3, e3, r3) {
          for (var n3 = 0; n3 < e3.length; n3++)
            if (e3[n3].uid === t3)
              return n3;
          return !e3[r3] || e3[r3].uid ? -1 : r3;
        }
        function nt(t3, e3) {
          var r3 = o.isPlainObject(t3), n3 = Array.isArray(t3);
          return r3 || n3 ? (r3 && o.isPlainObject(e3) || n3 && Array.isArray(e3)) && JSON.stringify(t3) === JSON.stringify(e3) : t3 === e3;
        }
        function it(t3, e3, r3, n3) {
          var i2, a2, l2, u2 = n3.getValObject, c2 = n3.flags, f3 = n3.immutable, h2 = n3.inArray, p3 = n3.arrayIndex;
          function d3() {
            var t4 = i2.editType;
            h2 && -1 !== t4.indexOf("arraydraw") ? o.pushUnique(c2.arrays[h2], p3) : (T.update(c2, i2), "none" !== t4 && c2.nChanges++, n3.transition && i2.anim && c2.nChangesAnim++, (q2.test(l2) || G.test(l2)) && (c2.rangesAltered[r3[0]] = 1), Z.test(l2) && s(e3, "_inputDomain").set(null), "datarevision" === a2 && (c2.newDataRevision = 1));
          }
          function v2(t4) {
            return "data_array" === t4.valType || t4.arrayOk;
          }
          for (a2 in t3) {
            if (c2.calc && !n3.transition)
              return;
            var g3 = t3[a2], y2 = e3[a2], m3 = r3.concat(a2);
            if (l2 = m3.join("."), "_" !== a2.charAt(0) && "function" != typeof g3 && g3 !== y2) {
              if (("tick0" === a2 || "dtick" === a2) && "geo" !== r3[0]) {
                var x2 = e3.tickmode;
                if ("auto" === x2 || "array" === x2 || !x2)
                  continue;
              }
              if (("range" !== a2 || !e3.autorange) && ("zmin" !== a2 && "zmax" !== a2 || "contourcarpet" !== e3.type) && (i2 = u2(m3)) && (!i2._compareAsJSON || JSON.stringify(g3) !== JSON.stringify(y2))) {
                var b2, _2 = i2.valType, w3 = v2(i2), k2 = Array.isArray(g3), A2 = Array.isArray(y2);
                if (k2 && A2) {
                  var M2 = "_input_" + a2, S2 = t3[M2], E2 = e3[M2];
                  if (Array.isArray(S2) && S2 === E2)
                    continue;
                }
                if (void 0 === y2)
                  w3 && k2 ? c2.calc = true : d3();
                else if (i2._isLinkedToArray) {
                  var L2 = [], C2 = false;
                  h2 || (c2.arrays[a2] = L2);
                  var P2 = Math.min(g3.length, y2.length), O2 = Math.max(g3.length, y2.length);
                  if (P2 !== O2) {
                    if ("arraydraw" !== i2.editType) {
                      d3();
                      continue;
                    }
                    C2 = true;
                  }
                  for (b2 = 0; b2 < P2; b2++)
                    it(g3[b2], y2[b2], m3.concat(b2), o.extendFlat({ inArray: a2, arrayIndex: b2 }, n3));
                  if (C2)
                    for (b2 = P2; b2 < O2; b2++)
                      L2.push(b2);
                } else
                  !_2 && o.isPlainObject(g3) ? it(g3, y2, m3, n3) : w3 ? k2 && A2 ? (f3 && (c2.calc = true), (f3 || n3.newDataRevision) && d3()) : k2 !== A2 ? c2.calc = true : d3() : k2 && A2 && g3.length === y2.length && String(g3) === String(y2) || d3();
              }
            }
          }
          for (a2 in e3)
            if (!(a2 in t3) && "_" !== a2.charAt(0) && "function" != typeof e3[a2]) {
              if (v2(i2 = u2(r3.concat(a2))) && Array.isArray(e3[a2]))
                return void (c2.calc = true);
              d3();
            }
        }
        function at(t3, e3) {
          var r3;
          for (r3 in t3)
            if ("_" !== r3.charAt(0)) {
              var n3 = t3[r3], i2 = e3[r3];
              if (n3 !== i2)
                if (o.isPlainObject(n3) && o.isPlainObject(i2)) {
                  if (at(n3, i2))
                    return true;
                } else {
                  if (!Array.isArray(n3) || !Array.isArray(i2))
                    return true;
                  if (n3.length !== i2.length)
                    return true;
                  for (var a2 = 0; a2 < n3.length; a2++)
                    if (n3[a2] !== i2[a2]) {
                      if (!o.isPlainObject(n3[a2]) || !o.isPlainObject(i2[a2]))
                        return true;
                      if (at(n3[a2], i2[a2]))
                        return true;
                    }
                }
            }
        }
        function ot(t3) {
          var e3 = t3._fullLayout, r3 = t3.getBoundingClientRect();
          if (!o.equalDomRects(r3, e3._lastBBox)) {
            var n3 = e3._invTransform = o.inverseTransformMatrix(o.getFullTransformMatrix(t3));
            e3._invScaleX = Math.sqrt(n3[0][0] * n3[0][0] + n3[0][1] * n3[0][1] + n3[0][2] * n3[0][2]), e3._invScaleY = Math.sqrt(n3[1][0] * n3[1][0] + n3[1][1] * n3[1][1] + n3[1][2] * n3[1][2]), e3._lastBBox = r3;
          }
        }
        e2.animate = function(t3, e3, r3) {
          if (t3 = o.getGraphDiv(t3), !o.isPlotDiv(t3))
            throw new Error("This element is not a Plotly plot: " + t3 + ". It's likely that you've failed to create a plot before animating it. For more details, see https://plotly.com/javascript/animations/");
          var n3 = t3._transitionData;
          n3._frameQueue || (n3._frameQueue = []);
          var i2 = (r3 = h.supplyAnimationDefaults(r3)).transition, a2 = r3.frame;
          function s2(t4) {
            return Array.isArray(i2) ? t4 >= i2.length ? i2[0] : i2[t4] : i2;
          }
          function l2(t4) {
            return Array.isArray(a2) ? t4 >= a2.length ? a2[0] : a2[t4] : a2;
          }
          function u2(t4, e4) {
            var r4 = 0;
            return function() {
              if (t4 && ++r4 === e4)
                return t4();
            };
          }
          return void 0 === n3._frameWaitingCnt && (n3._frameWaitingCnt = 0), new Promise(function(a3, c2) {
            function f3() {
              t3.emit("plotly_animating"), n3._lastFrameAt = -1 / 0, n3._timeToNext = 0, n3._runningTransitions = 0, n3._currentFrame = null;
              var e4 = function() {
                n3._animationRaf = window.requestAnimationFrame(e4), Date.now() - n3._lastFrameAt > n3._timeToNext && function() {
                  n3._currentFrame && n3._currentFrame.onComplete && n3._currentFrame.onComplete();
                  var e5 = n3._currentFrame = n3._frameQueue.shift();
                  if (e5) {
                    var r4 = e5.name ? e5.name.toString() : null;
                    t3._fullLayout._currentFrame = r4, n3._lastFrameAt = Date.now(), n3._timeToNext = e5.frameOpts.duration, h.transition(t3, e5.frame.data, e5.frame.layout, _.coerceTraceIndices(t3, e5.frame.traces), e5.frameOpts, e5.transitionOpts).then(function() {
                      e5.onComplete && e5.onComplete();
                    }), t3.emit("plotly_animatingframe", { name: r4, frame: e5.frame, animation: { frame: e5.frameOpts, transition: e5.transitionOpts } });
                  } else
                    t3.emit("plotly_animated"), window.cancelAnimationFrame(n3._animationRaf), n3._animationRaf = null;
                }();
              };
              e4();
            }
            var p3, d3, v2 = 0;
            function g3(t4) {
              return Array.isArray(i2) ? v2 >= i2.length ? t4.transitionOpts = i2[v2] : t4.transitionOpts = i2[0] : t4.transitionOpts = i2, v2++, t4;
            }
            var y2 = [], m3 = null == e3, x2 = Array.isArray(e3);
            if (m3 || x2 || !o.isPlainObject(e3)) {
              if (m3 || -1 !== ["string", "number"].indexOf(typeof e3))
                for (p3 = 0; p3 < n3._frames.length; p3++)
                  (d3 = n3._frames[p3]) && (m3 || String(d3.group) === String(e3)) && y2.push({ type: "byname", name: String(d3.name), data: g3({ name: d3.name }) });
              else if (x2)
                for (p3 = 0; p3 < e3.length; p3++) {
                  var b2 = e3[p3];
                  -1 !== ["number", "string"].indexOf(typeof b2) ? (b2 = String(b2), y2.push({ type: "byname", name: b2, data: g3({ name: b2 }) })) : o.isPlainObject(b2) && y2.push({ type: "object", data: g3(o.extendFlat({}, b2)) });
                }
            } else
              y2.push({ type: "object", data: g3(o.extendFlat({}, e3)) });
            for (p3 = 0; p3 < y2.length; p3++)
              if ("byname" === (d3 = y2[p3]).type && !n3._frameHash[d3.data.name])
                return o.warn('animate failure: frame not found: "' + d3.data.name + '"'), void c2();
            -1 !== ["next", "immediate"].indexOf(r3.mode) && function() {
              if (0 !== n3._frameQueue.length) {
                for (; n3._frameQueue.length; ) {
                  var e4 = n3._frameQueue.pop();
                  e4.onInterrupt && e4.onInterrupt();
                }
                t3.emit("plotly_animationinterrupted", []);
              }
            }(), "reverse" === r3.direction && y2.reverse();
            var w3 = t3._fullLayout._currentFrame;
            if (w3 && r3.fromcurrent) {
              var T2 = -1;
              for (p3 = 0; p3 < y2.length; p3++)
                if ("byname" === (d3 = y2[p3]).type && d3.name === w3) {
                  T2 = p3;
                  break;
                }
              if (T2 > 0 && T2 < y2.length - 1) {
                var k2 = [];
                for (p3 = 0; p3 < y2.length; p3++)
                  d3 = y2[p3], ("byname" !== y2[p3].type || p3 > T2) && k2.push(d3);
                y2 = k2;
              }
            }
            y2.length > 0 ? function(e4) {
              if (0 !== e4.length) {
                for (var i3 = 0; i3 < e4.length; i3++) {
                  var o2;
                  o2 = "byname" === e4[i3].type ? h.computeFrame(t3, e4[i3].name) : e4[i3].data;
                  var p4 = l2(i3), d4 = s2(i3);
                  d4.duration = Math.min(d4.duration, p4.duration);
                  var v3 = { frame: o2, name: e4[i3].name, frameOpts: p4, transitionOpts: d4 };
                  i3 === e4.length - 1 && (v3.onComplete = u2(a3, 2), v3.onInterrupt = c2), n3._frameQueue.push(v3);
                }
                "immediate" === r3.mode && (n3._lastFrameAt = -1 / 0), n3._animationRaf || f3();
              }
            }(y2) : (t3.emit("plotly_animated"), a3());
          });
        }, e2.addFrames = function(t3, e3, r3) {
          if (t3 = o.getGraphDiv(t3), null == e3)
            return Promise.resolve();
          if (!o.isPlotDiv(t3))
            throw new Error("This element is not a Plotly plot: " + t3 + ". It's likely that you've failed to create a plot before adding frames. For more details, see https://plotly.com/javascript/animations/");
          var n3, i2, a2, s2, l2 = t3._transitionData._frames, c2 = t3._transitionData._frameHash;
          if (!Array.isArray(e3))
            throw new Error("addFrames failure: frameList must be an Array of frame definitions" + e3);
          var f3 = l2.length + 2 * e3.length, p3 = [], d3 = {};
          for (n3 = e3.length - 1; n3 >= 0; n3--)
            if (o.isPlainObject(e3[n3])) {
              var v2 = e3[n3].name, g3 = (c2[v2] || d3[v2] || {}).name, y2 = e3[n3].name, m3 = c2[g3] || d3[g3];
              g3 && y2 && "number" == typeof y2 && m3 && A < 5 && (A++, o.warn('addFrames: overwriting frame "' + (c2[g3] || d3[g3]).name + '" with a frame whose name of type "number" also equates to "' + g3 + '". This is valid but may potentially lead to unexpected behavior since all plotly.js frame names are stored internally as strings.'), 5 === A && o.warn("addFrames: This API call has yielded too many of these warnings. For the rest of this call, further warnings about numeric frame names will be suppressed.")), d3[v2] = { name: v2 }, p3.push({ frame: h.supplyFrameDefaults(e3[n3]), index: r3 && void 0 !== r3[n3] && null !== r3[n3] ? r3[n3] : f3 + n3 });
            }
          p3.sort(function(t4, e4) {
            return t4.index > e4.index ? -1 : t4.index < e4.index ? 1 : 0;
          });
          var x2 = [], b2 = [], _2 = l2.length;
          for (n3 = p3.length - 1; n3 >= 0; n3--) {
            if ("number" == typeof (i2 = p3[n3].frame).name && o.warn("Warning: addFrames accepts frames with numeric names, but the numbers areimplicitly cast to strings"), !i2.name)
              for (; c2[i2.name = "frame " + t3._transitionData._counter++]; )
                ;
            if (c2[i2.name]) {
              for (a2 = 0; a2 < l2.length && (l2[a2] || {}).name !== i2.name; a2++)
                ;
              x2.push({ type: "replace", index: a2, value: i2 }), b2.unshift({ type: "replace", index: a2, value: l2[a2] });
            } else
              s2 = Math.max(0, Math.min(p3[n3].index, _2)), x2.push({ type: "insert", index: s2, value: i2 }), b2.unshift({ type: "delete", index: s2 }), _2++;
          }
          var w3 = h.modifyFrames, T2 = h.modifyFrames, k2 = [t3, b2], M2 = [t3, x2];
          return u && u.add(t3, w3, k2, T2, M2), h.modifyFrames(t3, x2);
        }, e2.deleteFrames = function(t3, e3) {
          if (t3 = o.getGraphDiv(t3), !o.isPlotDiv(t3))
            throw new Error("This element is not a Plotly plot: " + t3);
          var r3, n3, i2 = t3._transitionData._frames, a2 = [], s2 = [];
          if (!e3)
            for (e3 = [], r3 = 0; r3 < i2.length; r3++)
              e3.push(r3);
          for ((e3 = e3.slice()).sort(), r3 = e3.length - 1; r3 >= 0; r3--)
            n3 = e3[r3], a2.push({ type: "delete", index: n3 }), s2.unshift({ type: "insert", index: n3, value: i2[n3] });
          var l2 = h.modifyFrames, c2 = h.modifyFrames, f3 = [t3, s2], p3 = [t3, a2];
          return u && u.add(t3, l2, f3, c2, p3), h.modifyFrames(t3, a2);
        }, e2.addTraces = function t3(r3, n3, i2) {
          r3 = o.getGraphDiv(r3);
          var a2, s2, l2 = [], c2 = e2.deleteTraces, f3 = t3, h2 = [r3, l2], p3 = [r3, n3];
          for (function(t4, e3, r4) {
            var n4, i3;
            if (!Array.isArray(t4.data))
              throw new Error("gd.data must be an array.");
            if (void 0 === e3)
              throw new Error("traces must be defined.");
            for (Array.isArray(e3) || (e3 = [e3]), n4 = 0; n4 < e3.length; n4++)
              if ("object" != typeof (i3 = e3[n4]) || Array.isArray(i3) || null === i3)
                throw new Error("all values in traces array must be non-array objects");
            if (void 0 === r4 || Array.isArray(r4) || (r4 = [r4]), void 0 !== r4 && r4.length !== e3.length)
              throw new Error("if indices is specified, traces.length must equal indices.length");
          }(r3, n3, i2), Array.isArray(n3) || (n3 = [n3]), n3 = n3.map(function(t4) {
            return o.extendFlat({}, t4);
          }), _.cleanData(n3), a2 = 0; a2 < n3.length; a2++)
            r3.data.push(n3[a2]);
          for (a2 = 0; a2 < n3.length; a2++)
            l2.push(-n3.length + a2);
          if (void 0 === i2)
            return s2 = e2.redraw(r3), u.add(r3, c2, h2, f3, p3), s2;
          Array.isArray(i2) || (i2 = [i2]);
          try {
            O(r3, l2, i2);
          } catch (t4) {
            throw r3.data.splice(r3.data.length - n3.length, n3.length), t4;
          }
          return u.startSequence(r3), u.add(r3, c2, h2, f3, p3), s2 = e2.moveTraces(r3, l2, i2), u.stopSequence(r3), s2;
        }, e2.deleteTraces = function t3(r3, n3) {
          r3 = o.getGraphDiv(r3);
          var i2, a2, s2 = [], l2 = e2.addTraces, c2 = t3, f3 = [r3, s2, n3], h2 = [r3, n3];
          if (void 0 === n3)
            throw new Error("indices must be an integer or array of integers.");
          for (Array.isArray(n3) || (n3 = [n3]), P(r3, n3, "indices"), (n3 = C(n3, r3.data.length - 1)).sort(o.sorterDes), i2 = 0; i2 < n3.length; i2 += 1)
            a2 = r3.data.splice(n3[i2], 1)[0], s2.push(a2);
          var p3 = e2.redraw(r3);
          return u.add(r3, l2, f3, c2, h2), p3;
        }, e2.extendTraces = function t3(r3, n3, i2, a2) {
          function s2(t4, e3, r4) {
            var n4, i3;
            if (o.isTypedArray(t4))
              if (r4 < 0) {
                var a3 = new t4.constructor(0), s3 = D(t4, e3);
                r4 < 0 ? (n4 = s3, i3 = a3) : (n4 = a3, i3 = s3);
              } else if (n4 = new t4.constructor(r4), i3 = new t4.constructor(t4.length + e3.length - r4), r4 === e3.length)
                n4.set(e3), i3.set(t4);
              else if (r4 < e3.length) {
                var l3 = e3.length - r4;
                n4.set(e3.subarray(l3)), i3.set(t4), i3.set(e3.subarray(0, l3), t4.length);
              } else {
                var u2 = r4 - e3.length, c3 = t4.length - u2;
                n4.set(t4.subarray(c3)), n4.set(e3, u2), i3.set(t4.subarray(0, c3));
              }
            else
              n4 = t4.concat(e3), i3 = r4 >= 0 && r4 < n4.length ? n4.splice(0, n4.length - r4) : [];
            return [n4, i3];
          }
          var l2 = I(r3 = o.getGraphDiv(r3), n3, i2, a2, s2), c2 = e2.redraw(r3), f3 = [r3, l2.update, i2, l2.maxPoints];
          return u.add(r3, e2.prependTraces, f3, t3, arguments), c2;
        }, e2.moveTraces = function t3(r3, n3, i2) {
          var a2, s2 = [], l2 = [], c2 = t3, f3 = t3, h2 = [r3 = o.getGraphDiv(r3), i2, n3], p3 = [r3, n3, i2];
          if (O(r3, n3, i2), n3 = Array.isArray(n3) ? n3 : [n3], void 0 === i2)
            for (i2 = [], a2 = 0; a2 < n3.length; a2++)
              i2.push(-n3.length + a2);
          for (i2 = Array.isArray(i2) ? i2 : [i2], n3 = C(n3, r3.data.length - 1), i2 = C(i2, r3.data.length - 1), a2 = 0; a2 < r3.data.length; a2++)
            -1 === n3.indexOf(a2) && s2.push(r3.data[a2]);
          for (a2 = 0; a2 < n3.length; a2++)
            l2.push({ newIndex: i2[a2], trace: r3.data[n3[a2]] });
          for (l2.sort(function(t4, e3) {
            return t4.newIndex - e3.newIndex;
          }), a2 = 0; a2 < l2.length; a2 += 1)
            s2.splice(l2[a2].newIndex, 0, l2[a2].trace);
          r3.data = s2;
          var d3 = e2.redraw(r3);
          return u.add(r3, c2, h2, f3, p3), d3;
        }, e2.prependTraces = function t3(r3, n3, i2, a2) {
          function s2(t4, e3, r4) {
            var n4, i3;
            if (o.isTypedArray(t4))
              if (r4 <= 0) {
                var a3 = new t4.constructor(0), s3 = D(e3, t4);
                r4 < 0 ? (n4 = s3, i3 = a3) : (n4 = a3, i3 = s3);
              } else if (n4 = new t4.constructor(r4), i3 = new t4.constructor(t4.length + e3.length - r4), r4 === e3.length)
                n4.set(e3), i3.set(t4);
              else if (r4 < e3.length) {
                var l3 = e3.length - r4;
                n4.set(e3.subarray(0, l3)), i3.set(e3.subarray(l3)), i3.set(t4, l3);
              } else {
                var u2 = r4 - e3.length;
                n4.set(e3), n4.set(t4.subarray(0, u2), e3.length), i3.set(t4.subarray(u2));
              }
            else
              n4 = e3.concat(t4), i3 = r4 >= 0 && r4 < n4.length ? n4.splice(r4, n4.length) : [];
            return [n4, i3];
          }
          var l2 = I(r3 = o.getGraphDiv(r3), n3, i2, a2, s2), c2 = e2.redraw(r3), f3 = [r3, l2.update, i2, l2.maxPoints];
          return u.add(r3, e2.extendTraces, f3, t3, arguments), c2;
        }, e2.newPlot = function(t3, r3, n3, i2) {
          return t3 = o.getGraphDiv(t3), h.cleanPlot([], {}, t3._fullData || [], t3._fullLayout || {}), h.purge(t3), e2._doPlot(t3, r3, n3, i2);
        }, e2._doPlot = function(t3, r3, i2, a2) {
          var s2;
          if (t3 = o.getGraphDiv(t3), l.init(t3), o.isPlainObject(r3)) {
            var u2 = r3;
            r3 = u2.data, i2 = u2.layout, a2 = u2.config, s2 = u2.frames;
          }
          if (false === l.triggerHandler(t3, "plotly_beforeplot", [r3, i2, a2]))
            return Promise.reject();
          r3 || i2 || o.isPlotDiv(t3) || o.warn("Calling _doPlot as if redrawing but this container doesn't yet have a plot.", t3), L(t3, a2), i2 || (i2 = {}), n2.select(t3).classed("js-plotly-plot", true), d2.makeTester(), Array.isArray(t3._promises) || (t3._promises = []);
          var f3 = 0 === (t3.data || []).length && Array.isArray(r3);
          Array.isArray(r3) && (_.cleanData(r3), f3 ? t3.data = r3 : t3.data.push.apply(t3.data, r3), t3.empty = false), t3.layout && !f3 || (t3.layout = _.cleanLayout(i2)), h.supplyDefaults(t3);
          var v2 = t3._fullLayout, m3 = v2._has("cartesian");
          v2._replotting = true, (f3 || v2._shouldCreateBgLayer) && (function(t4) {
            var e3 = n2.select(t4), r4 = t4._fullLayout;
            if (r4._calcInverseTransform = ot, r4._calcInverseTransform(t4), r4._container = e3.selectAll(".plot-container").data([0]), r4._container.enter().insert("div", ":first-child").classed("plot-container", true).classed("plotly", true), r4._paperdiv = r4._container.selectAll(".svg-container").data([0]), r4._paperdiv.enter().append("div").classed("user-select-none", true).classed("svg-container", true).style("position", "relative"), r4._glcontainer = r4._paperdiv.selectAll(".gl-container").data([{}]), r4._glcontainer.enter().append("div").classed("gl-container", true), r4._paperdiv.selectAll(".main-svg").remove(), r4._paperdiv.select(".modebar-container").remove(), r4._paper = r4._paperdiv.insert("svg", ":first-child").classed("main-svg", true), r4._toppaper = r4._paperdiv.append("svg").classed("main-svg", true), r4._modebardiv = r4._paperdiv.append("div"), delete r4._modeBar, r4._hoverpaper = r4._paperdiv.append("svg").classed("main-svg", true), !r4._uid) {
              var i3 = {};
              n2.selectAll("defs").each(function() {
                this.id && (i3[this.id.split("-")[1]] = 1);
              }), r4._uid = o.randstr(i3);
            }
            r4._paperdiv.selectAll(".main-svg").attr(y.svgAttrs), r4._defs = r4._paper.append("defs").attr("id", "defs-" + r4._uid), r4._clips = r4._defs.append("g").classed("clips", true), r4._topdefs = r4._toppaper.append("defs").attr("id", "topdefs-" + r4._uid), r4._topclips = r4._topdefs.append("g").classed("clips", true), r4._bgLayer = r4._paper.append("g").classed("bglayer", true), r4._draggers = r4._paper.append("g").classed("draglayer", true);
            var a3 = r4._paper.append("g").classed("layer-below", true);
            r4._imageLowerLayer = a3.append("g").classed("imagelayer", true), r4._shapeLowerLayer = a3.append("g").classed("shapelayer", true), r4._cartesianlayer = r4._paper.append("g").classed("cartesianlayer", true), r4._polarlayer = r4._paper.append("g").classed("polarlayer", true), r4._smithlayer = r4._paper.append("g").classed("smithlayer", true), r4._ternarylayer = r4._paper.append("g").classed("ternarylayer", true), r4._geolayer = r4._paper.append("g").classed("geolayer", true), r4._funnelarealayer = r4._paper.append("g").classed("funnelarealayer", true), r4._pielayer = r4._paper.append("g").classed("pielayer", true), r4._iciclelayer = r4._paper.append("g").classed("iciclelayer", true), r4._treemaplayer = r4._paper.append("g").classed("treemaplayer", true), r4._sunburstlayer = r4._paper.append("g").classed("sunburstlayer", true), r4._indicatorlayer = r4._toppaper.append("g").classed("indicatorlayer", true), r4._glimages = r4._paper.append("g").classed("glimages", true);
            var s3 = r4._toppaper.append("g").classed("layer-above", true);
            r4._imageUpperLayer = s3.append("g").classed("imagelayer", true), r4._shapeUpperLayer = s3.append("g").classed("shapelayer", true), r4._selectionLayer = r4._toppaper.append("g").classed("selectionlayer", true), r4._infolayer = r4._toppaper.append("g").classed("infolayer", true), r4._menulayer = r4._toppaper.append("g").classed("menulayer", true), r4._zoomlayer = r4._toppaper.append("g").classed("zoomlayer", true), r4._hoverlayer = r4._hoverpaper.append("g").classed("hoverlayer", true), r4._modebardiv.classed("modebar-container", true).style("position", "absolute").style("top", "0px").style("right", "0px"), t4.emit("plotly_framework");
          }(t3), v2._shouldCreateBgLayer && delete v2._shouldCreateBgLayer), d2.initGradients(t3), d2.initPatterns(t3), f3 && p2.saveShowSpikeInitial(t3);
          var x2 = !t3.calcdata || t3.calcdata.length !== (t3._fullData || []).length;
          x2 && h.doCalcdata(t3);
          for (var b2 = 0; b2 < t3.calcdata.length; b2++)
            t3.calcdata[b2][0].trace = t3._fullData[b2];
          t3._context.responsive ? t3._responsiveChartHandler || (t3._responsiveChartHandler = function() {
            o.isHidden(t3) || h.resize(t3);
          }, window.addEventListener("resize", t3._responsiveChartHandler)) : o.clearResponsive(t3);
          var T2 = o.extendFlat({}, v2._size), k2 = 0;
          function A2() {
            if (h.clearAutoMarginIds(t3), w2.drawMarginPushers(t3), p2.allowAutoMargin(t3), t3._fullLayout.title.text && t3._fullLayout.title.automargin && h.allowAutoMargin(t3, "title.automargin"), v2._has("pie"))
              for (var e3 = t3._fullData, r4 = 0; r4 < e3.length; r4++) {
                var n3 = e3[r4];
                "pie" === n3.type && n3.automargin && h.allowAutoMargin(t3, "pie." + n3.uid + ".automargin");
              }
            return h.doAutoMargin(t3), h.previousPromises(t3);
          }
          function S2() {
            t3._transitioning || (w2.doAutoRangeAndConstraints(t3), f3 && p2.saveRangeInitial(t3), c.getComponentMethod("rangeslider", "calcAutorange")(t3));
          }
          var E2 = [h.previousPromises, function() {
            if (s2)
              return e2.addFrames(t3, s2);
          }, function e3() {
            for (var r4 = v2._basePlotModules, n3 = 0; n3 < r4.length; n3++)
              r4[n3].drawFramework && r4[n3].drawFramework(t3);
            !v2._glcanvas && v2._has("gl") && (v2._glcanvas = v2._glcontainer.selectAll(".gl-canvas").data([{ key: "contextLayer", context: true, pick: false }, { key: "focusLayer", context: false, pick: false }, { key: "pickLayer", context: false, pick: true }], function(t4) {
              return t4.key;
            }), v2._glcanvas.enter().append("canvas").attr("class", function(t4) {
              return "gl-canvas gl-canvas-" + t4.key.replace("Layer", "");
            }).style({ position: "absolute", top: 0, left: 0, overflow: "visible", "pointer-events": "none" }));
            var i3 = t3._context.plotGlPixelRatio;
            if (v2._glcanvas) {
              v2._glcanvas.attr("width", v2.width * i3).attr("height", v2.height * i3).style("width", v2.width + "px").style("height", v2.height + "px");
              var a3 = v2._glcanvas.data()[0].regl;
              if (a3 && (Math.floor(v2.width * i3) !== a3._gl.drawingBufferWidth || Math.floor(v2.height * i3) !== a3._gl.drawingBufferHeight)) {
                var s3 = "WebGL context buffer and canvas dimensions do not match due to browser/WebGL bug.";
                if (!k2)
                  return o.log(s3 + " Clearing graph and plotting again."), h.cleanPlot([], {}, t3._fullData, v2), h.supplyDefaults(t3), v2 = t3._fullLayout, h.doCalcdata(t3), k2++, e3();
                o.error(s3);
              }
            }
            return "h" === v2.modebar.orientation ? v2._modebardiv.style("height", null).style("width", "100%") : v2._modebardiv.style("width", null).style("height", v2.height + "px"), h.previousPromises(t3);
          }, A2, function() {
            if (h.didMarginChange(T2, v2._size))
              return o.syncOrAsync([A2, w2.layoutStyles], t3);
          }];
          m3 && E2.push(function() {
            if (x2)
              return o.syncOrAsync([c.getComponentMethod("shapes", "calcAutorange"), c.getComponentMethod("annotations", "calcAutorange"), S2], t3);
            S2();
          }), E2.push(w2.layoutStyles), m3 && E2.push(function() {
            return p2.draw(t3, f3 ? "" : "redraw");
          }, function(t4) {
            t4._fullLayout._insideTickLabelsAutorange && U(t4, t4._fullLayout._insideTickLabelsAutorange).then(function() {
              t4._fullLayout._insideTickLabelsAutorange = void 0;
            });
          }), E2.push(w2.drawData, w2.finalDraw, g2, h.addLinks, h.rehover, h.redrag, h.reselect, h.doAutoMargin, function(t4) {
            t4._fullLayout._insideTickLabelsAutorange && f3 && p2.saveRangeInitial(t4, true);
          }, h.previousPromises);
          var C2 = o.syncOrAsync(E2, t3);
          return C2 && C2.then || (C2 = Promise.resolve()), C2.then(function() {
            return M(t3), t3;
          });
        }, e2.purge = function(t3) {
          var e3 = (t3 = o.getGraphDiv(t3))._fullLayout || {}, r3 = t3._fullData || [];
          return h.cleanPlot([], {}, r3, e3), h.purge(t3), l.purge(t3), e3._container && e3._container.remove(), delete t3._context, t3;
        }, e2.react = function(t3, r3, n3, i2) {
          var a2, l2;
          t3 = o.getGraphDiv(t3), _.clearPromiseQueue(t3);
          var u2 = t3._fullData, p3 = t3._fullLayout;
          if (o.isPlotDiv(t3) && u2 && p3) {
            if (o.isPlainObject(r3)) {
              var d3 = r3;
              r3 = d3.data, n3 = d3.layout, i2 = d3.config, a2 = d3.frames;
            }
            var v2 = false;
            if (i2) {
              var g3 = o.extendDeep({}, t3._context);
              t3._context = void 0, L(t3, i2), v2 = at(g3, t3._context);
            }
            t3.data = r3 || [], _.cleanData(t3.data), t3.layout = n3 || {}, _.cleanLayout(t3.layout), function(t4, e3, r4, n4) {
              var i3, a3, l3, u3, c2, f3, h2, p4, d4, v3, g4 = n4._preGUI, y3 = [], m4 = {}, x3 = {};
              for (i3 in g4) {
                if (c2 = Q(i3, K)) {
                  if (d4 = c2.head, v3 = c2.tail, a3 = c2.attr || d4 + ".uirevision", (u3 = (l3 = s(n4, a3).get()) && tt(a3, e3)) && u3 === l3) {
                    if (null === (f3 = g4[i3]) && (f3 = void 0), nt(p4 = (h2 = s(e3, i3)).get(), f3)) {
                      void 0 === p4 && "autorange" === v3 && y3.push(d4), h2.set(R(s(n4, i3).get()));
                      continue;
                    }
                    if ("autorange" === v3 || "range[" === v3.substr(0, 6)) {
                      var b3 = g4[d4 + ".range[0]"], _2 = g4[d4 + ".range[1]"], w3 = g4[d4 + ".autorange"];
                      if (w3 || null === w3 && null === b3 && null === _2) {
                        if (!(d4 in m4)) {
                          var T2 = s(e3, d4).get();
                          m4[d4] = T2 && (T2.autorange || false !== T2.autorange && (!T2.range || 2 !== T2.range.length));
                        }
                        if (m4[d4]) {
                          h2.set(R(s(n4, i3).get()));
                          continue;
                        }
                      }
                    }
                  }
                } else
                  o.warn("unrecognized GUI edit: " + i3);
                delete g4[i3], c2 && "range[" === c2.tail.substr(0, 6) && (x3[c2.head] = 1);
              }
              for (var k3 = 0; k3 < y3.length; k3++) {
                var A3 = y3[k3];
                if (x3[A3]) {
                  var M2 = s(e3, A3).get();
                  M2 && delete M2.autorange;
                }
              }
              var S3 = n4._tracePreGUI;
              for (var E3 in S3) {
                var L2, C3 = S3[E3], P3 = null;
                for (i3 in C3) {
                  if (!P3) {
                    var O3 = et(E3, r4);
                    if (O3 < 0) {
                      delete S3[E3];
                      break;
                    }
                    var I3 = rt(E3, t4, (L2 = r4[O3]._fullInput).index);
                    if (I3 < 0) {
                      delete S3[E3];
                      break;
                    }
                    P3 = t4[I3];
                  }
                  if (c2 = Q(i3, $)) {
                    if (c2.attr ? u3 = (l3 = s(n4, c2.attr).get()) && tt(c2.attr, e3) : (l3 = L2.uirevision, void 0 === (u3 = P3.uirevision) && (u3 = e3.uirevision)), u3 && u3 === l3 && (null === (f3 = C3[i3]) && (f3 = void 0), nt(p4 = (h2 = s(P3, i3)).get(), f3))) {
                      h2.set(R(s(L2, i3).get()));
                      continue;
                    }
                  } else
                    o.warn("unrecognized GUI edit: " + i3 + " in trace uid " + E3);
                  delete C3[i3];
                }
              }
            }(t3.data, t3.layout, u2, p3), h.supplyDefaults(t3, { skipUpdateCalc: true });
            var y2 = t3._fullData, m3 = t3._fullLayout, x2 = void 0 === m3.datarevision, b2 = m3.transition, k2 = function(t4, e3, r4, n4, i3) {
              var a3 = T.layoutFlags();
              return a3.arrays = {}, a3.rangesAltered = {}, a3.nChanges = 0, a3.nChangesAnim = 0, it(e3, r4, [], { getValObject: function(t5) {
                return f2.getLayoutValObject(r4, t5);
              }, flags: a3, immutable: n4, transition: i3, gd: t4 }), (a3.plot || a3.calc) && (a3.layoutReplot = true), i3 && a3.nChanges && a3.nChangesAnim && (a3.anim = a3.nChanges === a3.nChangesAnim ? "all" : "some"), a3;
            }(t3, p3, m3, x2, b2), A2 = k2.newDataRevision, S2 = function(t4, e3, r4, n4, i3, a3) {
              var o2 = e3.length === r4.length;
              if (!i3 && !o2)
                return { fullReplot: true, calc: true };
              var s2, l3, u3 = T.traceFlags();
              u3.arrays = {}, u3.nChanges = 0, u3.nChangesAnim = 0;
              var c2 = { getValObject: function(t5) {
                var e4 = f2.getTraceValObject(l3, t5);
                return !l3._module.animatable && e4.anim && (e4.anim = false), e4;
              }, flags: u3, immutable: n4, transition: i3, newDataRevision: a3, gd: t4 }, p4 = {};
              for (s2 = 0; s2 < e3.length; s2++)
                if (r4[s2]) {
                  if (l3 = r4[s2]._fullInput, h.hasMakesDataTransform(l3) && (l3 = r4[s2]), p4[l3.uid])
                    continue;
                  p4[l3.uid] = 1, it(e3[s2]._fullInput, l3, [], c2);
                }
              return (u3.calc || u3.plot) && (u3.fullReplot = true), i3 && u3.nChanges && u3.nChangesAnim && (u3.anim = u3.nChanges === u3.nChangesAnim && o2 ? "all" : "some"), u3;
            }(t3, u2, y2, x2, b2, A2);
            if (W(t3) && (k2.layoutReplot = true), S2.calc || k2.calc) {
              t3.calcdata = void 0;
              for (var E2 = Object.getOwnPropertyNames(m3), C2 = 0; C2 < E2.length; C2++) {
                var P2 = E2[C2], O2 = P2.substring(0, 5);
                if ("xaxis" === O2 || "yaxis" === O2) {
                  var I2 = m3[P2]._emptyCategories;
                  I2 && I2();
                }
              }
            } else
              h.supplyDefaultsUpdateCalc(t3.calcdata, y2);
            var D2 = [];
            if (a2 && (t3._transitionData = {}, h.createTransitionData(t3), D2.push(function() {
              return e2.addFrames(t3, a2);
            })), m3.transition && !v2 && (S2.anim || k2.anim))
              k2.ticks && D2.push(w2.doTicksRelayout), h.doCalcdata(t3), w2.doAutoRangeAndConstraints(t3), D2.push(function() {
                return h.transitionFromReact(t3, S2, k2, p3);
              });
            else if (S2.fullReplot || k2.layoutReplot || v2)
              t3._fullLayout._skipDefaults = true, D2.push(e2._doPlot);
            else {
              for (var z2 in k2.arrays) {
                var F2 = k2.arrays[z2];
                if (F2.length) {
                  var B2 = c.getComponentMethod(z2, "drawOne");
                  if (B2 !== o.noop)
                    for (var N2 = 0; N2 < F2.length; N2++)
                      B2(t3, F2[N2]);
                  else {
                    var j2 = c.getComponentMethod(z2, "draw");
                    if (j2 === o.noop)
                      throw new Error("cannot draw components: " + z2);
                    j2(t3);
                  }
                }
              }
              D2.push(h.previousPromises), S2.style && D2.push(w2.doTraceStyle), (S2.colorbars || k2.colorbars) && D2.push(w2.doColorBars), k2.legend && D2.push(w2.doLegend), k2.layoutstyle && D2.push(w2.layoutStyles), k2.axrange && H(D2), k2.ticks && D2.push(w2.doTicksRelayout), k2.modebar && D2.push(w2.doModeBar), k2.camera && D2.push(w2.doCamera), D2.push(M);
            }
            D2.push(h.rehover, h.redrag, h.reselect), (l2 = o.syncOrAsync(D2, t3)) && l2.then || (l2 = Promise.resolve(t3));
          } else
            l2 = e2.newPlot(t3, r3, n3, i2);
          return l2.then(function() {
            return t3.emit("plotly_react", { data: r3, layout: n3 }), t3;
          });
        }, e2.redraw = function(t3) {
          if (t3 = o.getGraphDiv(t3), !o.isPlotDiv(t3))
            throw new Error("This element is not a Plotly plot: " + t3);
          return _.cleanData(t3.data), _.cleanLayout(t3.layout), t3.calcdata = void 0, e2._doPlot(t3).then(function() {
            return t3.emit("plotly_redraw"), t3;
          });
        }, e2.relayout = U, e2.restyle = z, e2.setPlotConfig = function(t3) {
          return o.extendFlat(x, t3);
        }, e2.update = X, e2._guiRelayout = J(U), e2._guiRestyle = J(z), e2._guiUpdate = J(X), e2._storeDirectGUIEdit = function(t3, e3, r3) {
          for (var n3 in r3)
            B(n3, s(t3, n3).get(), r3[n3], e3);
        };
      }, 72075: function(t2) {
        var e2 = { staticPlot: { valType: "boolean", dflt: false }, typesetMath: { valType: "boolean", dflt: true }, plotlyServerURL: { valType: "string", dflt: "" }, editable: { valType: "boolean", dflt: false }, edits: { annotationPosition: { valType: "boolean", dflt: false }, annotationTail: { valType: "boolean", dflt: false }, annotationText: { valType: "boolean", dflt: false }, axisTitleText: { valType: "boolean", dflt: false }, colorbarPosition: { valType: "boolean", dflt: false }, colorbarTitleText: { valType: "boolean", dflt: false }, legendPosition: { valType: "boolean", dflt: false }, legendText: { valType: "boolean", dflt: false }, shapePosition: { valType: "boolean", dflt: false }, titleText: { valType: "boolean", dflt: false } }, editSelection: { valType: "boolean", dflt: true }, autosizable: { valType: "boolean", dflt: false }, responsive: { valType: "boolean", dflt: false }, fillFrame: { valType: "boolean", dflt: false }, frameMargins: { valType: "number", dflt: 0, min: 0, max: 0.5 }, scrollZoom: { valType: "flaglist", flags: ["cartesian", "gl3d", "geo", "mapbox"], extras: [true, false], dflt: "gl3d+geo+mapbox" }, doubleClick: { valType: "enumerated", values: [false, "reset", "autosize", "reset+autosize"], dflt: "reset+autosize" }, doubleClickDelay: { valType: "number", dflt: 300, min: 0 }, showAxisDragHandles: { valType: "boolean", dflt: true }, showAxisRangeEntryBoxes: { valType: "boolean", dflt: true }, showTips: { valType: "boolean", dflt: true }, showLink: { valType: "boolean", dflt: false }, linkText: { valType: "string", dflt: "Edit chart", noBlank: true }, sendData: { valType: "boolean", dflt: true }, showSources: { valType: "any", dflt: false }, displayModeBar: { valType: "enumerated", values: ["hover", true, false], dflt: "hover" }, showSendToCloud: { valType: "boolean", dflt: false }, showEditInChartStudio: { valType: "boolean", dflt: false }, modeBarButtonsToRemove: { valType: "any", dflt: [] }, modeBarButtonsToAdd: { valType: "any", dflt: [] }, modeBarButtons: { valType: "any", dflt: false }, toImageButtonOptions: { valType: "any", dflt: {} }, displaylogo: { valType: "boolean", dflt: true }, watermark: { valType: "boolean", dflt: false }, plotGlPixelRatio: { valType: "number", dflt: 2, min: 1, max: 4 }, setBackground: { valType: "any", dflt: "transparent" }, topojsonURL: { valType: "string", noBlank: true, dflt: "https://cdn.plot.ly/" }, mapboxAccessToken: { valType: "string", dflt: null }, logging: { valType: "integer", min: 0, max: 2, dflt: 1 }, notifyOnLogging: { valType: "integer", min: 0, max: 2, dflt: 0 }, queueLength: { valType: "integer", min: 0, dflt: 0 }, globalTransforms: { valType: "any", dflt: [] }, locale: { valType: "string", dflt: "en-US" }, locales: { valType: "any", dflt: {} } }, r2 = {};
        !function t3(e3, r3) {
          for (var n2 in e3) {
            var i = e3[n2];
            i.valType ? r3[n2] = i.dflt : (r3[n2] || (r3[n2] = {}), t3(i, r3[n2]));
          }
        }(e2, r2), t2.exports = { configAttributes: e2, dfltConfig: r2 };
      }, 86281: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828), a = r2(9012), o = r2(10820), s = r2(31391), l = r2(85594), u = r2(72075).configAttributes, c = r2(30962), f2 = i.extendDeepAll, h = i.isPlainObject, p2 = i.isArrayOrTypedArray, d2 = i.nestedProperty, v = i.valObjectMeta, g2 = "_isSubplotObj", y = "_isLinkedToArray", m2 = "_deprecated", x = [g2, y, "_arrayAttrRegexps", m2];
        function b(t3, e3, r3) {
          if (!t3)
            return false;
          if (t3._isLinkedToArray) {
            if (_(e3[r3]))
              r3++;
            else if (r3 < e3.length)
              return false;
          }
          for (; r3 < e3.length; r3++) {
            var n3 = t3[e3[r3]];
            if (!h(n3))
              break;
            if (t3 = n3, r3 === e3.length - 1)
              break;
            if (t3._isLinkedToArray) {
              if (!_(e3[++r3]))
                return false;
            } else if ("info_array" === t3.valType) {
              var i2 = e3[++r3];
              if (!_(i2))
                return false;
              var a2 = t3.items;
              if (Array.isArray(a2)) {
                if (i2 >= a2.length)
                  return false;
                if (2 === t3.dimensions) {
                  if (r3++, e3.length === r3)
                    return t3;
                  var o2 = e3[r3];
                  if (!_(o2))
                    return false;
                  t3 = a2[i2][o2];
                } else
                  t3 = a2[i2];
              } else
                t3 = a2;
            }
          }
          return t3;
        }
        function _(t3) {
          return t3 === Math.round(t3) && t3 >= 0;
        }
        function w2() {
          var t3, e3, r3 = {};
          for (t3 in f2(r3, o), n2.subplotsRegistry)
            if ((e3 = n2.subplotsRegistry[t3]).layoutAttributes)
              if (Array.isArray(e3.attr))
                for (var i2 = 0; i2 < e3.attr.length; i2++)
                  k(r3, e3, e3.attr[i2]);
              else
                k(r3, e3, "subplot" === e3.attr ? e3.name : e3.attr);
          for (t3 in n2.componentsRegistry) {
            var a2 = (e3 = n2.componentsRegistry[t3]).schema;
            if (a2 && (a2.subplots || a2.layout)) {
              var s2 = a2.subplots;
              if (s2 && s2.xaxis && !s2.yaxis)
                for (var l2 in s2.xaxis)
                  delete r3.yaxis[l2];
              delete r3.xaxis.shift, delete r3.xaxis.autoshift;
            } else
              "colorscale" === e3.name ? f2(r3, e3.layoutAttributes) : e3.layoutAttributes && A(r3, e3.layoutAttributes, e3.name);
          }
          return { layoutAttributes: T(r3) };
        }
        function T(t3) {
          return function(t4) {
            e2.crawl(t4, function(t5, r3, n3) {
              e2.isValObject(t5) ? true !== t5.arrayOk && "data_array" !== t5.valType || (n3[r3 + "src"] = { valType: "string", editType: "none" }) : h(t5) && (t5.role = "object");
            });
          }(t3), function(t4) {
            e2.crawl(t4, function(t5, e3, r3) {
              if (t5) {
                var n3 = t5._isLinkedToArray;
                n3 && (delete t5._isLinkedToArray, r3[e3] = { items: {} }, r3[e3].items[n3] = t5, r3[e3].role = "object");
              }
            });
          }(t3), function(t4) {
            !function t5(e3) {
              for (var r3 in e3)
                if (h(e3[r3]))
                  t5(e3[r3]);
                else if (Array.isArray(e3[r3]))
                  for (var n3 = 0; n3 < e3[r3].length; n3++)
                    t5(e3[r3][n3]);
                else
                  e3[r3] instanceof RegExp && (e3[r3] = e3[r3].toString());
            }(t4);
          }(t3), t3;
        }
        function k(t3, e3, r3) {
          var n3 = d2(t3, r3), i2 = f2({}, e3.layoutAttributes);
          i2._isSubplotObj = true, n3.set(i2);
        }
        function A(t3, e3, r3) {
          var n3 = d2(t3, r3);
          n3.set(f2(n3.get() || {}, e3));
        }
        e2.IS_SUBPLOT_OBJ = g2, e2.IS_LINKED_TO_ARRAY = y, e2.DEPRECATED = m2, e2.UNDERSCORE_ATTRS = x, e2.get = function() {
          var t3 = {};
          n2.allTypes.forEach(function(r4) {
            t3[r4] = function(t4) {
              var r5, i3;
              i3 = (r5 = n2.modules[t4]._module).basePlotModule;
              var o2 = { type: null }, s2 = f2({}, a), l2 = f2({}, r5.attributes);
              e2.crawl(l2, function(t5, e3, r6, n3, i4) {
                d2(s2, i4).set(void 0), void 0 === t5 && d2(l2, i4).set(void 0);
              }), f2(o2, s2), n2.traceIs(t4, "noOpacity") && delete o2.opacity, n2.traceIs(t4, "showLegend") || (delete o2.showlegend, delete o2.legendgroup), n2.traceIs(t4, "noHover") && (delete o2.hoverinfo, delete o2.hoverlabel), r5.selectPoints || delete o2.selectedpoints, f2(o2, l2), i3.attributes && f2(o2, i3.attributes), o2.type = t4;
              var u2 = { meta: r5.meta || {}, categories: r5.categories || {}, animatable: Boolean(r5.animatable), type: t4, attributes: T(o2) };
              if (r5.layoutAttributes) {
                var c2 = {};
                f2(c2, r5.layoutAttributes), u2.layoutAttributes = T(c2);
              }
              return r5.animatable || e2.crawl(u2, function(t5) {
                e2.isValObject(t5) && "anim" in t5 && delete t5.anim;
              }), u2;
            }(r4);
          });
          var r3, i2 = {};
          return Object.keys(n2.transformsRegistry).forEach(function(t4) {
            i2[t4] = function(t5) {
              var e3 = n2.transformsRegistry[t5], r4 = f2({}, e3.attributes);
              return Object.keys(n2.componentsRegistry).forEach(function(e4) {
                var i3 = n2.componentsRegistry[e4];
                i3.schema && i3.schema.transforms && i3.schema.transforms[t5] && Object.keys(i3.schema.transforms[t5]).forEach(function(e5) {
                  A(r4, i3.schema.transforms[t5][e5], e5);
                });
              }), { attributes: T(r4) };
            }(t4);
          }), { defs: { valObjects: v, metaKeys: x.concat(["description", "role", "editType", "impliedEdits"]), editType: { traces: c.traces, layout: c.layout }, impliedEdits: {} }, traces: t3, layout: w2(), transforms: i2, frames: (r3 = { frames: f2({}, s) }, T(r3), r3.frames), animation: T(l), config: T(u) };
        }, e2.crawl = function(t3, r3, n3, i2) {
          var a2 = n3 || 0;
          i2 = i2 || "", Object.keys(t3).forEach(function(n4) {
            var o2 = t3[n4];
            if (-1 === x.indexOf(n4)) {
              var s2 = (i2 ? i2 + "." : "") + n4;
              r3(o2, n4, t3, a2, s2), e2.isValObject(o2) || h(o2) && "impliedEdits" !== n4 && e2.crawl(o2, r3, a2 + 1, s2);
            }
          });
        }, e2.isValObject = function(t3) {
          return t3 && void 0 !== t3.valType;
        }, e2.findArrayAttributes = function(t3) {
          var r3, n3, i2 = [], o2 = [], s2 = [];
          function l2(t4, e3, n4, i3) {
            o2 = o2.slice(0, i3).concat([e3]), s2 = s2.slice(0, i3).concat([t4 && t4._isLinkedToArray]), t4 && ("data_array" === t4.valType || true === t4.arrayOk) && ("colorbar" !== o2[i3 - 1] || "ticktext" !== e3 && "tickvals" !== e3) && u2(r3, 0, "");
          }
          function u2(t4, e3, r4) {
            var a2 = t4[o2[e3]], l3 = r4 + o2[e3];
            if (e3 === o2.length - 1)
              p2(a2) && i2.push(n3 + l3);
            else if (s2[e3]) {
              if (Array.isArray(a2))
                for (var c3 = 0; c3 < a2.length; c3++)
                  h(a2[c3]) && u2(a2[c3], e3 + 1, l3 + "[" + c3 + "].");
            } else
              h(a2) && u2(a2, e3 + 1, l3 + ".");
          }
          r3 = t3, n3 = "", e2.crawl(a, l2), t3._module && t3._module.attributes && e2.crawl(t3._module.attributes, l2);
          var c2 = t3.transforms;
          if (c2)
            for (var f3 = 0; f3 < c2.length; f3++) {
              var d3 = c2[f3], v2 = d3._module;
              v2 && (n3 = "transforms[" + f3 + "].", r3 = d3, e2.crawl(v2.attributes, l2));
            }
          return i2;
        }, e2.getTraceValObject = function(t3, e3) {
          var r3, i2, o2 = e3[0], s2 = 1;
          if ("transforms" === o2) {
            if (1 === e3.length)
              return a.transforms;
            var l2 = t3.transforms;
            if (!Array.isArray(l2) || !l2.length)
              return false;
            var u2 = e3[1];
            if (!_(u2) || u2 >= l2.length)
              return false;
            i2 = (r3 = (n2.transformsRegistry[l2[u2].type] || {}).attributes) && r3[e3[2]], s2 = 3;
          } else {
            var c2 = t3._module;
            if (c2 || (c2 = (n2.modules[t3.type || a.type.dflt] || {})._module), !c2)
              return false;
            if (!(i2 = (r3 = c2.attributes) && r3[o2])) {
              var f3 = c2.basePlotModule;
              f3 && f3.attributes && (i2 = f3.attributes[o2]);
            }
            i2 || (i2 = a[o2]);
          }
          return b(i2, e3, s2);
        }, e2.getLayoutValObject = function(t3, e3) {
          var r3 = function(t4, e4) {
            var r4, i2, a2, s2, l2 = t4._basePlotModules;
            if (l2) {
              var u2;
              for (r4 = 0; r4 < l2.length; r4++) {
                if ((a2 = l2[r4]).attrRegex && a2.attrRegex.test(e4)) {
                  if (a2.layoutAttrOverrides)
                    return a2.layoutAttrOverrides;
                  !u2 && a2.layoutAttributes && (u2 = a2.layoutAttributes);
                }
                var c2 = a2.baseLayoutAttrOverrides;
                if (c2 && e4 in c2)
                  return c2[e4];
              }
              if (u2)
                return u2;
            }
            var f3 = t4._modules;
            if (f3) {
              for (r4 = 0; r4 < f3.length; r4++)
                if ((s2 = f3[r4].layoutAttributes) && e4 in s2)
                  return s2[e4];
            }
            for (i2 in n2.componentsRegistry) {
              if ("colorscale" === (a2 = n2.componentsRegistry[i2]).name && 0 === e4.indexOf("coloraxis"))
                return a2.layoutAttributes[e4];
              if (!a2.schema && e4 === a2.name)
                return a2.layoutAttributes;
            }
            return e4 in o && o[e4];
          }(t3, e3[0]);
          return b(r3, e3, 1);
        };
      }, 44467: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(9012), a = { name: { valType: "string", editType: "none" } };
        function o(t3) {
          return t3 && "string" == typeof t3;
        }
        function s(t3) {
          var e3 = t3.length - 1;
          return "s" !== t3.charAt(e3) && n2.warn("bad argument to arrayDefaultKey: " + t3), t3.substr(0, t3.length - 1) + "defaults";
        }
        a.templateitemname = { valType: "string", editType: "calc" }, e2.templatedArray = function(t3, e3) {
          return e3._isLinkedToArray = t3, e3.name = a.name, e3.templateitemname = a.templateitemname, e3;
        }, e2.traceTemplater = function(t3) {
          var e3, r3, a2 = {};
          for (e3 in t3)
            r3 = t3[e3], Array.isArray(r3) && r3.length && (a2[e3] = 0);
          return { newTrace: function(o2) {
            var s2 = { type: e3 = n2.coerce(o2, {}, i, "type"), _template: null };
            if (e3 in a2) {
              r3 = t3[e3];
              var l = a2[e3] % r3.length;
              a2[e3]++, s2._template = r3[l];
            }
            return s2;
          } };
        }, e2.newContainer = function(t3, e3, r3) {
          var i2 = t3._template, a2 = i2 && (i2[e3] || r3 && i2[r3]);
          return n2.isPlainObject(a2) || (a2 = null), t3[e3] = { _template: a2 };
        }, e2.arrayTemplater = function(t3, e3, r3) {
          var n3 = t3._template, i2 = n3 && n3[s(e3)], a2 = n3 && n3[e3];
          Array.isArray(a2) && a2.length || (a2 = []);
          var l = {};
          return { newItem: function(t4) {
            var e4 = { name: t4.name, _input: t4 }, n4 = e4.templateitemname = t4.templateitemname;
            if (!o(n4))
              return e4._template = i2, e4;
            for (var s2 = 0; s2 < a2.length; s2++) {
              var u = a2[s2];
              if (u.name === n4)
                return l[n4] = 1, e4._template = u, e4;
            }
            return e4[r3] = t4[r3] || false, e4._template = false, e4;
          }, defaultItems: function() {
            for (var t4 = [], e4 = 0; e4 < a2.length; e4++) {
              var r4 = a2[e4], n4 = r4.name;
              if (o(n4) && !l[n4]) {
                var i3 = { _template: r4, name: n4, _input: { _templateitemname: n4 } };
                i3.templateitemname = r4.templateitemname, t4.push(i3), l[n4] = 1;
              }
            }
            return t4;
          } };
        }, e2.arrayDefaultKey = s, e2.arrayEditor = function(t3, e3, r3) {
          var i2 = (n2.nestedProperty(t3, e3).get() || []).length, a2 = r3._index, o2 = a2 >= i2 && (r3._input || {})._templateitemname;
          o2 && (a2 = i2);
          var s2, l = e3 + "[" + a2 + "]";
          function u() {
            s2 = {}, o2 && (s2[l] = {}, s2[l].templateitemname = o2);
          }
          function c(t4, e4) {
            o2 ? n2.nestedProperty(s2[l], t4).set(e4) : s2[l + "." + t4] = e4;
          }
          function f2() {
            var t4 = s2;
            return u(), t4;
          }
          return u(), { modifyBase: function(t4, e4) {
            s2[t4] = e4;
          }, modifyItem: c, getUpdateObj: f2, applyUpdate: function(e4, r4) {
            e4 && c(e4, r4);
            var i3 = f2();
            for (var a3 in i3)
              n2.nestedProperty(t3, a3).set(i3[a3]);
          } };
        };
      }, 61549: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(73972), a = r2(74875), o = r2(71828), s = r2(63893), l = r2(33306), u = r2(7901), c = r2(91424), f2 = r2(92998), h = r2(64168), p2 = r2(89298), d2 = r2(18783), v = r2(99082), g2 = v.enforce, y = v.clean, m2 = r2(71739).doAutoRange, x = "start";
        function b(t3, e3, r3) {
          for (var n3 = 0; n3 < r3.length; n3++) {
            var i2 = r3[n3][0], a2 = r3[n3][1];
            if (!(i2[0] >= t3[1] || i2[1] <= t3[0]) && a2[0] < e3[1] && a2[1] > e3[0])
              return true;
          }
          return false;
        }
        function _(t3) {
          var r3, i2, s2, l2, f3, v2, g3 = t3._fullLayout, y2 = g3._size, m3 = y2.p, x2 = p2.list(t3, "", true);
          if (g3._paperdiv.style({ width: t3._context.responsive && g3.autosize && !t3._context._hasZeroWidth && !t3.layout.width ? "100%" : g3.width + "px", height: t3._context.responsive && g3.autosize && !t3._context._hasZeroHeight && !t3.layout.height ? "100%" : g3.height + "px" }).selectAll(".main-svg").call(c.setSize, g3.width, g3.height), t3._context.setBackground(t3, g3.paper_bgcolor), e2.drawMainTitle(t3), h.manage(t3), !g3._has("cartesian"))
            return a.previousPromises(t3);
          function _2(t4, e3, r4) {
            var n3 = t4._lw / 2;
            return "x" === t4._id.charAt(0) ? e3 ? "top" === r4 ? e3._offset - m3 - n3 : e3._offset + e3._length + m3 + n3 : y2.t + y2.h * (1 - (t4.position || 0)) + n3 % 1 : e3 ? "right" === r4 ? e3._offset + e3._length + m3 + n3 : e3._offset - m3 - n3 : y2.l + y2.w * (t4.position || 0) + n3 % 1;
          }
          for (r3 = 0; r3 < x2.length; r3++) {
            var T2 = (l2 = x2[r3])._anchorAxis;
            l2._linepositions = {}, l2._lw = c.crispRound(t3, l2.linewidth, 1), l2._mainLinePosition = _2(l2, T2, l2.side), l2._mainMirrorPosition = l2.mirror && T2 ? _2(l2, T2, d2.OPPOSITE_SIDE[l2.side]) : null;
          }
          var A = [], M = [], S = [], E = 1 === u.opacity(g3.paper_bgcolor) && 1 === u.opacity(g3.plot_bgcolor) && g3.paper_bgcolor === g3.plot_bgcolor;
          for (i2 in g3._plots)
            if ((s2 = g3._plots[i2]).mainplot)
              s2.bg && s2.bg.remove(), s2.bg = void 0;
            else {
              var L = s2.xaxis.domain, C = s2.yaxis.domain, P = s2.plotgroup;
              if (b(L, C, S)) {
                var O = P.node(), I = s2.bg = o.ensureSingle(P, "rect", "bg");
                O.insertBefore(I.node(), O.childNodes[0]), M.push(i2);
              } else
                P.select("rect.bg").remove(), S.push([L, C]), E || (A.push(i2), M.push(i2));
            }
          var D, z, R, F, B, N, j, U, V, H, q2, G, Z, Y = g3._bgLayer.selectAll(".bg").data(A);
          for (Y.enter().append("rect").classed("bg", true), Y.exit().remove(), Y.each(function(t4) {
            g3._plots[t4].bg = n2.select(this);
          }), r3 = 0; r3 < M.length; r3++)
            s2 = g3._plots[M[r3]], f3 = s2.xaxis, v2 = s2.yaxis, s2.bg && void 0 !== f3._offset && void 0 !== v2._offset && s2.bg.call(c.setRect, f3._offset - m3, v2._offset - m3, f3._length + 2 * m3, v2._length + 2 * m3).call(u.fill, g3.plot_bgcolor).style("stroke-width", 0);
          if (!g3._hasOnlyLargeSploms)
            for (i2 in g3._plots) {
              s2 = g3._plots[i2], f3 = s2.xaxis, v2 = s2.yaxis;
              var W, X, J = s2.clipId = "clip" + g3._uid + i2 + "plot", K = o.ensureSingleById(g3._clips, "clipPath", J, function(t4) {
                t4.classed("plotclip", true).append("rect");
              });
              s2.clipRect = K.select("rect").attr({ width: f3._length, height: v2._length }), c.setTranslate(s2.plot, f3._offset, v2._offset), s2._hasClipOnAxisFalse ? (W = null, X = J) : (W = J, X = null), c.setClipUrl(s2.plot, W, t3), s2.layerClipId = X;
            }
          function $(t4) {
            return "M" + D + "," + t4 + "H" + z;
          }
          function Q(t4) {
            return "M" + f3._offset + "," + t4 + "h" + f3._length;
          }
          function tt(t4) {
            return "M" + t4 + "," + U + "V" + j;
          }
          function et(t4) {
            return void 0 !== v2._shift && (t4 += v2._shift), "M" + t4 + "," + v2._offset + "v" + v2._length;
          }
          function rt(t4, e3, r4) {
            if (!t4.showline || i2 !== t4._mainSubplot)
              return "";
            if (!t4._anchorAxis)
              return r4(t4._mainLinePosition);
            var n3 = e3(t4._mainLinePosition);
            return t4.mirror && (n3 += e3(t4._mainMirrorPosition)), n3;
          }
          for (i2 in g3._plots) {
            s2 = g3._plots[i2], f3 = s2.xaxis, v2 = s2.yaxis;
            var nt = "M0,0";
            w2(f3, i2) && (B = k(f3, "left", v2, x2), D = f3._offset - (B ? m3 + B : 0), N = k(f3, "right", v2, x2), z = f3._offset + f3._length + (N ? m3 + N : 0), R = _2(f3, v2, "bottom"), F = _2(f3, v2, "top"), !(Z = !f3._anchorAxis || i2 !== f3._mainSubplot) || "allticks" !== f3.mirror && "all" !== f3.mirror || (f3._linepositions[i2] = [R, F]), nt = rt(f3, $, Q), Z && f3.showline && ("all" === f3.mirror || "allticks" === f3.mirror) && (nt += $(R) + $(F)), s2.xlines.style("stroke-width", f3._lw + "px").call(u.stroke, f3.showline ? f3.linecolor : "rgba(0,0,0,0)")), s2.xlines.attr("d", nt);
            var it = "M0,0";
            w2(v2, i2) && (q2 = k(v2, "bottom", f3, x2), j = v2._offset + v2._length + (q2 ? m3 : 0), G = k(v2, "top", f3, x2), U = v2._offset - (G ? m3 : 0), V = _2(v2, f3, "left"), H = _2(v2, f3, "right"), !(Z = !v2._anchorAxis || i2 !== v2._mainSubplot) || "allticks" !== v2.mirror && "all" !== v2.mirror || (v2._linepositions[i2] = [V, H]), it = rt(v2, tt, et), Z && v2.showline && ("all" === v2.mirror || "allticks" === v2.mirror) && (it += tt(V) + tt(H)), s2.ylines.style("stroke-width", v2._lw + "px").call(u.stroke, v2.showline ? v2.linecolor : "rgba(0,0,0,0)")), s2.ylines.attr("d", it);
          }
          return p2.makeClipPaths(t3), a.previousPromises(t3);
        }
        function w2(t3, e3) {
          return (t3.ticks || t3.showline) && (e3 === t3._mainSubplot || "all" === t3.mirror || "allticks" === t3.mirror);
        }
        function T(t3, e3, r3) {
          if (!r3.showline || !r3._lw)
            return false;
          if ("all" === r3.mirror || "allticks" === r3.mirror)
            return true;
          var n3 = r3._anchorAxis;
          if (!n3)
            return false;
          var i2 = d2.FROM_BL[e3];
          return r3.side === e3 ? n3.domain[i2] === t3.domain[i2] : r3.mirror && n3.domain[1 - i2] === t3.domain[1 - i2];
        }
        function k(t3, e3, r3, n3) {
          if (T(t3, e3, r3))
            return r3._lw;
          for (var i2 = 0; i2 < n3.length; i2++) {
            var a2 = n3[i2];
            if (a2._mainAxis === r3._mainAxis && T(t3, e3, a2))
              return a2._lw;
          }
          return 0;
        }
        e2.layoutStyles = function(t3) {
          return o.syncOrAsync([a.doAutoMargin, _], t3);
        }, e2.drawMainTitle = function(t3) {
          var e3, r3 = t3._fullLayout.title, i2 = t3._fullLayout, l2 = function(t4) {
            var e4 = t4.title, r4 = "middle";
            return o.isRightAnchor(e4) ? r4 = "end" : o.isLeftAnchor(e4) && (r4 = x), r4;
          }(i2), u2 = function(t4) {
            var e4 = t4.title, r4 = "0em";
            return o.isTopAnchor(e4) ? r4 = d2.CAP_SHIFT + "em" : o.isMiddleAnchor(e4) && (r4 = d2.MID_SHIFT + "em"), r4;
          }(i2), h2 = function(t4, e4) {
            var r4 = t4.title, n3 = t4._size, i3 = 0;
            return "0em" !== e4 && e4 ? e4 === d2.CAP_SHIFT + "em" && (i3 = r4.pad.t) : i3 = -r4.pad.b, "auto" === r4.y ? n3.t / 2 : "paper" === r4.yref ? n3.t + n3.h - n3.h * r4.y + i3 : t4.height - t4.height * r4.y + i3;
          }(i2, u2), p3 = function(t4, e4) {
            var r4 = t4.title, n3 = t4._size, i3 = 0;
            return e4 === x ? i3 = r4.pad.l : "end" === e4 && (i3 = -r4.pad.r), "paper" === r4.xref ? n3.l + n3.w * r4.x + i3 : t4.width * r4.x + i3;
          }(i2, l2);
          if (f2.draw(t3, "gtitle", { propContainer: i2, propName: "title.text", placeholder: i2._dfltTitle.plot, attributes: { x: p3, y: h2, "text-anchor": l2, dy: u2 } }), r3.text && r3.automargin) {
            var v2 = n2.selectAll(".gtitle"), g3 = c.bBox(v2.node()).height, y2 = function(t4, e4, r4) {
              var n3 = e4.y, i3 = e4.yanchor, a2 = n3 > 0.5 ? "t" : "b", o2 = t4._fullLayout.margin[a2], s2 = 0;
              return "paper" === e4.yref ? s2 = r4 + e4.pad.t + e4.pad.b : "container" === e4.yref && (s2 = function(t5, e5, r5, n4, i4) {
                var a3 = 0;
                return "middle" === r5 && (a3 += i4 / 2), "t" === t5 ? ("top" === r5 && (a3 += i4), a3 += n4 - e5 * n4) : ("bottom" === r5 && (a3 += i4), a3 += e5 * n4), a3;
              }(a2, n3, i3, t4._fullLayout.height, r4) + e4.pad.t + e4.pad.b), s2 > o2 ? s2 : 0;
            }(t3, r3, g3);
            y2 > 0 && (function(t4, e4, r4, n3) {
              var i3 = "title.automargin", s2 = t4._fullLayout.title, l3 = s2.y > 0.5 ? "t" : "b", u3 = { x: s2.x, y: s2.y, t: 0, b: 0 }, c2 = {};
              "paper" === s2.yref && function(t5, e5, r5, n4, i4) {
                var a2 = "paper" === e5.yref ? t5._fullLayout._size.h : t5._fullLayout.height, s3 = o.isTopAnchor(e5) ? n4 : n4 - i4, l4 = "b" === r5 ? a2 - s3 : s3;
                return !(o.isTopAnchor(e5) && "t" === r5 || o.isBottomAnchor(e5) && "b" === r5) && l4 < i4;
              }(t4, s2, l3, e4, n3) ? u3[l3] = r4 : "container" === s2.yref && (c2[l3] = r4, t4._fullLayout._reservedMargin[i3] = c2), a.allowAutoMargin(t4, i3), a.autoMargin(t4, i3, u3);
            }(t3, h2, y2, g3), v2.attr({ x: p3, y: h2, "text-anchor": l2, dy: (e3 = r3.yanchor, "top" === e3 ? d2.CAP_SHIFT + 0.3 + "em" : "bottom" === e3 ? "-0.3em" : d2.MID_SHIFT + "em") }).call(s.positionText, p3, h2));
          }
        }, e2.doTraceStyle = function(t3) {
          var r3, n3 = t3.calcdata, o2 = [];
          for (r3 = 0; r3 < n3.length; r3++) {
            var s2 = n3[r3], u2 = s2[0] || {}, c2 = u2.trace || {}, f3 = c2._module || {}, h2 = f3.arraysToCalcdata;
            h2 && h2(s2, c2);
            var p3 = f3.editStyle;
            p3 && o2.push({ fn: p3, cd0: u2 });
          }
          if (o2.length) {
            for (r3 = 0; r3 < o2.length; r3++) {
              var d3 = o2[r3];
              d3.fn(t3, d3.cd0);
            }
            l(t3), e2.redrawReglTraces(t3);
          }
          return a.style(t3), i.getComponentMethod("legend", "draw")(t3), a.previousPromises(t3);
        }, e2.doColorBars = function(t3) {
          return i.getComponentMethod("colorbar", "draw")(t3), a.previousPromises(t3);
        }, e2.layoutReplot = function(t3) {
          var e3 = t3.layout;
          return t3.layout = void 0, i.call("_doPlot", t3, "", e3);
        }, e2.doLegend = function(t3) {
          return i.getComponentMethod("legend", "draw")(t3), a.previousPromises(t3);
        }, e2.doTicksRelayout = function(t3) {
          return p2.draw(t3, "redraw"), t3._fullLayout._hasOnlyLargeSploms && (i.subplotsRegistry.splom.updateGrid(t3), l(t3), e2.redrawReglTraces(t3)), e2.drawMainTitle(t3), a.previousPromises(t3);
        }, e2.doModeBar = function(t3) {
          var e3 = t3._fullLayout;
          h.manage(t3);
          for (var r3 = 0; r3 < e3._basePlotModules.length; r3++) {
            var n3 = e3._basePlotModules[r3].updateFx;
            n3 && n3(t3);
          }
          return a.previousPromises(t3);
        }, e2.doCamera = function(t3) {
          for (var e3 = t3._fullLayout, r3 = e3._subplots.gl3d, n3 = 0; n3 < r3.length; n3++) {
            var i2 = e3[r3[n3]];
            i2._scene.setViewport(i2);
          }
        }, e2.drawData = function(t3) {
          var r3 = t3._fullLayout;
          l(t3);
          for (var n3 = r3._basePlotModules, o2 = 0; o2 < n3.length; o2++)
            n3[o2].plot(t3);
          return e2.redrawReglTraces(t3), a.style(t3), i.getComponentMethod("selections", "draw")(t3), i.getComponentMethod("shapes", "draw")(t3), i.getComponentMethod("annotations", "draw")(t3), i.getComponentMethod("images", "draw")(t3), r3._replotting = false, a.previousPromises(t3);
        }, e2.redrawReglTraces = function(t3) {
          var e3 = t3._fullLayout;
          if (e3._has("regl")) {
            var r3, n3, i2 = t3._fullData, a2 = [], s2 = [];
            for (e3._hasOnlyLargeSploms && e3._splomGrid.draw(), r3 = 0; r3 < i2.length; r3++) {
              var l2 = i2[r3];
              true === l2.visible && 0 !== l2._length && ("splom" === l2.type ? e3._splomScenes[l2.uid].draw() : "scattergl" === l2.type ? o.pushUnique(a2, l2.xaxis + l2.yaxis) : "scatterpolargl" === l2.type && o.pushUnique(s2, l2.subplot));
            }
            for (r3 = 0; r3 < a2.length; r3++)
              (n3 = e3._plots[a2[r3]])._scene && n3._scene.draw();
            for (r3 = 0; r3 < s2.length; r3++)
              (n3 = e3[s2[r3]]._subplot)._scene && n3._scene.draw();
          }
        }, e2.doAutoRangeAndConstraints = function(t3) {
          for (var e3, r3 = p2.list(t3, "", true), n3 = {}, i2 = 0; i2 < r3.length; i2++)
            if (!n3[(e3 = r3[i2])._id]) {
              n3[e3._id] = 1, y(t3, e3), m2(t3, e3);
              var a2 = e3._matchGroup;
              if (a2)
                for (var o2 in a2) {
                  var s2 = p2.getFromId(t3, o2);
                  m2(t3, s2, e3.range), n3[o2] = 1;
                }
            }
          g2(t3);
        }, e2.finalDraw = function(t3) {
          i.getComponentMethod("rangeslider", "draw")(t3), i.getComponentMethod("rangeselector", "draw")(t3);
        }, e2.drawMarginPushers = function(t3) {
          i.getComponentMethod("legend", "draw")(t3), i.getComponentMethod("rangeselector", "draw")(t3), i.getComponentMethod("sliders", "draw")(t3), i.getComponentMethod("updatemenus", "draw")(t3), i.getComponentMethod("colorbar", "draw")(t3);
        };
      }, 96318: function(t2, e2, r2) {
        var n2 = r2(71828), i = n2.isPlainObject, a = r2(86281), o = r2(74875), s = r2(9012), l = r2(44467), u = r2(72075).dfltConfig;
        function c(t3, e3) {
          t3 = n2.extendDeep({}, t3);
          var r3, a2, o2 = Object.keys(t3).sort();
          function s2(e4, r4, n3) {
            if (i(r4) && i(e4))
              c(e4, r4);
            else if (Array.isArray(r4) && Array.isArray(e4)) {
              var o3 = l.arrayTemplater({ _template: t3 }, n3);
              for (a2 = 0; a2 < r4.length; a2++) {
                var s3 = r4[a2], u3 = o3.newItem(s3)._template;
                u3 && c(u3, s3);
              }
              var f3 = o3.defaultItems();
              for (a2 = 0; a2 < f3.length; a2++)
                r4.push(f3[a2]._template);
              for (a2 = 0; a2 < r4.length; a2++)
                delete r4[a2].templateitemname;
            }
          }
          for (r3 = 0; r3 < o2.length; r3++) {
            var u2 = o2[r3], h2 = t3[u2];
            if (u2 in e3 ? s2(h2, e3[u2], u2) : e3[u2] = h2, f2(u2) === u2)
              for (var p3 in e3) {
                var d3 = f2(p3);
                p3 === d3 || d3 !== u2 || p3 in t3 || s2(h2, e3[p3], u2);
              }
          }
        }
        function f2(t3) {
          return t3.replace(/[0-9]+$/, "");
        }
        function h(t3, e3, r3, a2, o2) {
          var s2 = o2 && r3(o2);
          for (var u2 in t3) {
            var c2 = t3[u2], p3 = v(t3, u2, a2), d3 = v(t3, u2, o2), g3 = r3(d3);
            if (!g3) {
              var y2 = f2(u2);
              y2 !== u2 && (g3 = r3(d3 = v(t3, y2, o2)));
            }
            if (!(s2 && s2 === g3 || !g3 || g3._noTemplating || "data_array" === g3.valType || g3.arrayOk && Array.isArray(c2)))
              if (!g3.valType && i(c2))
                h(c2, e3, r3, p3, d3);
              else if (g3._isLinkedToArray && Array.isArray(c2))
                for (var m2 = false, x = 0, b = {}, _ = 0; _ < c2.length; _++) {
                  var w2 = c2[_];
                  if (i(w2)) {
                    var T = w2.name;
                    if (T)
                      b[T] || (h(w2, e3, r3, v(c2, x, p3), v(c2, x, d3)), x++, b[T] = 1);
                    else if (!m2) {
                      var k = v(t3, l.arrayDefaultKey(u2), a2), A = v(c2, x, p3);
                      h(w2, e3, r3, A, v(c2, x, d3));
                      var M = n2.nestedProperty(e3, A);
                      n2.nestedProperty(e3, k).set(M.get()), M.set(null), m2 = true;
                    }
                  }
                }
              else
                n2.nestedProperty(e3, p3).set(c2);
          }
        }
        function p2(t3, e3) {
          return a.getLayoutValObject(t3, n2.nestedProperty({}, e3).parts);
        }
        function d2(t3, e3) {
          return a.getTraceValObject(t3, n2.nestedProperty({}, e3).parts);
        }
        function v(t3, e3, r3) {
          return r3 ? Array.isArray(t3) ? r3 + "[" + e3 + "]" : r3 + "." + e3 : e3;
        }
        function g2(t3) {
          for (var e3 = 0; e3 < t3.length; e3++)
            if (i(t3[e3]))
              return true;
        }
        function y(t3) {
          var e3;
          switch (t3.code) {
            case "data":
              e3 = "The template has no key data.";
              break;
            case "layout":
              e3 = "The template has no key layout.";
              break;
            case "missing":
              e3 = t3.path ? "There are no templates for item " + t3.path + " with name " + t3.templateitemname : "There are no templates for trace " + t3.index + ", of type " + t3.traceType + ".";
              break;
            case "unused":
              e3 = t3.path ? "The template item at " + t3.path + " was not used in constructing the plot." : t3.dataCount ? "Some of the templates of type " + t3.traceType + " were not used. The template has " + t3.templateCount + " traces, the data only has " + t3.dataCount + " of this type." : "The template has " + t3.templateCount + " traces of type " + t3.traceType + " but there are none in the data.";
              break;
            case "reused":
              e3 = "Some of the templates of type " + t3.traceType + " were used more than once. The template has " + t3.templateCount + " traces, the data has " + t3.dataCount + " of this type.";
          }
          return t3.msg = e3, t3;
        }
        e2.makeTemplate = function(t3) {
          t3 = n2.isPlainObject(t3) ? t3 : n2.getGraphDiv(t3), t3 = n2.extendDeep({ _context: u }, { data: t3.data, layout: t3.layout }), o.supplyDefaults(t3);
          var e3 = t3.data || [], r3 = t3.layout || {};
          r3._basePlotModules = t3._fullLayout._basePlotModules, r3._modules = t3._fullLayout._modules;
          var a2 = { data: {}, layout: {} };
          e3.forEach(function(t4) {
            var e4 = {};
            h(t4, e4, d2.bind(null, t4));
            var r4 = n2.coerce(t4, {}, s, "type"), i2 = a2.data[r4];
            i2 || (i2 = a2.data[r4] = []), i2.push(e4);
          }), h(r3, a2.layout, p2.bind(null, r3)), delete a2.layout.template;
          var l2 = r3.template;
          if (i(l2)) {
            var f3, v2, g3, y2, m2, x, b = l2.layout;
            i(b) && c(b, a2.layout);
            var _ = l2.data;
            if (i(_)) {
              for (v2 in a2.data)
                if (g3 = _[v2], Array.isArray(g3)) {
                  for (x = (m2 = a2.data[v2]).length, y2 = g3.length, f3 = 0; f3 < x; f3++)
                    c(g3[f3 % y2], m2[f3]);
                  for (f3 = x; f3 < y2; f3++)
                    m2.push(n2.extendDeep({}, g3[f3]));
                }
              for (v2 in _)
                v2 in a2.data || (a2.data[v2] = n2.extendDeep([], _[v2]));
            }
          }
          return a2;
        }, e2.validateTemplate = function(t3, e3) {
          var r3 = n2.extendDeep({}, { _context: u, data: t3.data, layout: t3.layout }), a2 = r3.layout || {};
          i(e3) || (e3 = a2.template || {});
          var s2 = e3.layout, l2 = e3.data, c2 = [];
          r3.layout = a2, r3.layout.template = e3, o.supplyDefaults(r3);
          var h2 = r3._fullLayout, p3 = r3._fullData, d3 = {};
          if (i(s2) ? (function t4(e4, r4) {
            for (var n3 in e4)
              if ("_" !== n3.charAt(0) && i(e4[n3])) {
                var a3, o2 = f2(n3), s3 = [];
                for (a3 = 0; a3 < r4.length; a3++)
                  s3.push(v(e4, n3, r4[a3])), o2 !== n3 && s3.push(v(e4, o2, r4[a3]));
                for (a3 = 0; a3 < s3.length; a3++)
                  d3[s3[a3]] = 1;
                t4(e4[n3], s3);
              }
          }(h2, ["layout"]), function t4(e4, r4) {
            for (var n3 in e4)
              if (-1 === n3.indexOf("defaults") && i(e4[n3])) {
                var a3 = v(e4, n3, r4);
                d3[a3] ? t4(e4[n3], a3) : c2.push({ code: "unused", path: a3 });
              }
          }(s2, "layout")) : c2.push({ code: "layout" }), i(l2)) {
            for (var m2, x = {}, b = 0; b < p3.length; b++) {
              var _ = p3[b];
              x[m2 = _.type] = (x[m2] || 0) + 1, _._fullInput._template || c2.push({ code: "missing", index: _._fullInput.index, traceType: m2 });
            }
            for (m2 in l2) {
              var w2 = l2[m2].length, T = x[m2] || 0;
              w2 > T ? c2.push({ code: "unused", traceType: m2, templateCount: w2, dataCount: T }) : T > w2 && c2.push({ code: "reused", traceType: m2, templateCount: w2, dataCount: T });
            }
          } else
            c2.push({ code: "data" });
          if (function t4(e4, r4) {
            for (var n3 in e4)
              if ("_" !== n3.charAt(0)) {
                var a3 = e4[n3], o2 = v(e4, n3, r4);
                i(a3) ? (Array.isArray(e4) && false === a3._template && a3.templateitemname && c2.push({ code: "missing", path: o2, templateitemname: a3.templateitemname }), t4(a3, o2)) : Array.isArray(a3) && g2(a3) && t4(a3, o2);
              }
          }({ data: p3, layout: h2 }, ""), c2.length)
            return c2.map(y);
        };
      }, 403: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(72391), a = r2(74875), o = r2(71828), s = r2(25095), l = r2(5900), u = r2(70942), c = r2(11506).version, f2 = { format: { valType: "enumerated", values: ["png", "jpeg", "webp", "svg", "full-json"], dflt: "png" }, width: { valType: "number", min: 1 }, height: { valType: "number", min: 1 }, scale: { valType: "number", min: 0, dflt: 1 }, setBackground: { valType: "any", dflt: false }, imageDataOnly: { valType: "boolean", dflt: false } };
        t2.exports = function(t3, e3) {
          var r3, h, p2, d2;
          function v(t4) {
            return !(t4 in e3) || o.validate(e3[t4], f2[t4]);
          }
          if (e3 = e3 || {}, o.isPlainObject(t3) ? (r3 = t3.data || [], h = t3.layout || {}, p2 = t3.config || {}, d2 = {}) : (t3 = o.getGraphDiv(t3), r3 = o.extendDeep([], t3.data), h = o.extendDeep({}, t3.layout), p2 = t3._context, d2 = t3._fullLayout || {}), !v("width") && null !== e3.width || !v("height") && null !== e3.height)
            throw new Error("Height and width should be pixel values.");
          if (!v("format"))
            throw new Error("Export format is not " + o.join2(f2.format.values, ", ", " or ") + ".");
          var g2 = {};
          function y(t4, r4) {
            return o.coerce(e3, g2, f2, t4, r4);
          }
          var m2 = y("format"), x = y("width"), b = y("height"), _ = y("scale"), w2 = y("setBackground"), T = y("imageDataOnly"), k = document.createElement("div");
          k.style.position = "absolute", k.style.left = "-5000px", document.body.appendChild(k);
          var A = o.extendFlat({}, h);
          x ? A.width = x : null === e3.width && n2(d2.width) && (A.width = d2.width), b ? A.height = b : null === e3.height && n2(d2.height) && (A.height = d2.height);
          var M = o.extendFlat({}, p2, { _exportedPlot: true, staticPlot: true, setBackground: w2 }), S = s.getRedrawFunc(k);
          function E() {
            return new Promise(function(t4) {
              setTimeout(t4, s.getDelay(k._fullLayout));
            });
          }
          function L() {
            return new Promise(function(t4, e4) {
              var r4 = l(k, m2, _), n3 = k._fullLayout.width, f3 = k._fullLayout.height;
              function h2() {
                i.purge(k), document.body.removeChild(k);
              }
              if ("full-json" === m2) {
                var p3 = a.graphJson(k, false, "keepdata", "object", true, true);
                return p3.version = c, p3 = JSON.stringify(p3), h2(), t4(T ? p3 : s.encodeJSON(p3));
              }
              if (h2(), "svg" === m2)
                return t4(T ? r4 : s.encodeSVG(r4));
              var d3 = document.createElement("canvas");
              d3.id = o.randstr(), u({ format: m2, width: n3, height: f3, scale: _, canvas: d3, svg: r4, promise: true }).then(t4).catch(e4);
            });
          }
          return new Promise(function(t4, e4) {
            i.newPlot(k, r3, A, M).then(S).then(E).then(L).then(function(e5) {
              t4(function(t5) {
                return T ? t5.replace(s.IMAGE_URL_PREFIX, "") : t5;
              }(e5));
            }).catch(function(t5) {
              e4(t5);
            });
          });
        };
      }, 84936: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(74875), a = r2(86281), o = r2(72075).dfltConfig, s = n2.isPlainObject, l = Array.isArray, u = n2.isArrayOrTypedArray;
        function c(t3, e3, r3, i2, a2, o2) {
          o2 = o2 || [];
          for (var f3 = Object.keys(t3), h2 = 0; h2 < f3.length; h2++) {
            var p3 = f3[h2];
            if ("transforms" !== p3) {
              var y2 = o2.slice();
              y2.push(p3);
              var m3 = t3[p3], x = e3[p3], b = g2(r3, p3), _ = (b || {}).valType, w2 = "info_array" === _, T = "colorscale" === _, k = (b || {}).items;
              if (v(r3, p3))
                if (s(m3) && s(x) && "any" !== _)
                  c(m3, x, b, i2, a2, y2);
                else if (w2 && l(m3)) {
                  m3.length > x.length && i2.push(d2("unused", a2, y2.concat(x.length)));
                  var A, M, S, E, L, C = x.length, P = Array.isArray(k);
                  if (P && (C = Math.min(C, k.length)), 2 === b.dimensions)
                    for (M = 0; M < C; M++)
                      if (l(m3[M])) {
                        m3[M].length > x[M].length && i2.push(d2("unused", a2, y2.concat(M, x[M].length)));
                        var O = x[M].length;
                        for (A = 0; A < (P ? Math.min(O, k[M].length) : O); A++)
                          S = P ? k[M][A] : k, E = m3[M][A], L = x[M][A], n2.validate(E, S) ? L !== E && L !== +E && i2.push(d2("dynamic", a2, y2.concat(M, A), E, L)) : i2.push(d2("value", a2, y2.concat(M, A), E));
                      } else
                        i2.push(d2("array", a2, y2.concat(M), m3[M]));
                  else
                    for (M = 0; M < C; M++)
                      S = P ? k[M] : k, E = m3[M], L = x[M], n2.validate(E, S) ? L !== E && L !== +E && i2.push(d2("dynamic", a2, y2.concat(M), E, L)) : i2.push(d2("value", a2, y2.concat(M), E));
                } else if (b.items && !w2 && l(m3)) {
                  var I, D, z = k[Object.keys(k)[0]], R = [];
                  for (I = 0; I < x.length; I++) {
                    var F = x[I]._index || I;
                    if ((D = y2.slice()).push(F), s(m3[F]) && s(x[I])) {
                      R.push(F);
                      var B = m3[F], N = x[I];
                      s(B) && false !== B.visible && false === N.visible ? i2.push(d2("invisible", a2, D)) : c(B, N, z, i2, a2, D);
                    }
                  }
                  for (I = 0; I < m3.length; I++)
                    (D = y2.slice()).push(I), s(m3[I]) ? -1 === R.indexOf(I) && i2.push(d2("unused", a2, D)) : i2.push(d2("object", a2, D, m3[I]));
                } else
                  !s(m3) && s(x) ? i2.push(d2("object", a2, y2, m3)) : u(m3) || !u(x) || w2 || T ? p3 in e3 ? n2.validate(m3, b) ? "enumerated" === b.valType && (b.coerceNumber && m3 !== +x || m3 !== x) && i2.push(d2("dynamic", a2, y2, m3, x)) : i2.push(d2("value", a2, y2, m3)) : i2.push(d2("unused", a2, y2, m3)) : i2.push(d2("array", a2, y2, m3));
              else
                i2.push(d2("schema", a2, y2));
            }
          }
          return i2;
        }
        function f2(t3, e3) {
          for (var r3 = t3.layout.layoutAttributes, i2 = 0; i2 < e3.length; i2++) {
            var a2 = e3[i2], o2 = t3.traces[a2.type], s2 = o2.layoutAttributes;
            s2 && (a2.subplot ? n2.extendFlat(r3[o2.attributes.subplot.dflt], s2) : n2.extendFlat(r3, s2));
          }
          return r3;
        }
        t2.exports = function(t3, e3) {
          void 0 === t3 && (t3 = []), void 0 === e3 && (e3 = {});
          var r3, u2, h2 = a.get(), p3 = [], v2 = { _context: n2.extendFlat({}, o) };
          l(t3) ? (v2.data = n2.extendDeep([], t3), r3 = t3) : (v2.data = [], r3 = [], p3.push(d2("array", "data"))), s(e3) ? (v2.layout = n2.extendDeep({}, e3), u2 = e3) : (v2.layout = {}, u2 = {}, arguments.length > 1 && p3.push(d2("object", "layout"))), i.supplyDefaults(v2);
          for (var g3 = v2._fullData, y2 = r3.length, m3 = 0; m3 < y2; m3++) {
            var x = r3[m3], b = ["data", m3];
            if (s(x)) {
              var _ = g3[m3], w2 = _.type, T = h2.traces[w2].attributes;
              T.type = { valType: "enumerated", values: [w2] }, false === _.visible && false !== x.visible && p3.push(d2("invisible", b)), c(x, _, T, p3, b);
              var k = x.transforms, A = _.transforms;
              if (k) {
                l(k) || p3.push(d2("array", b, ["transforms"])), b.push("transforms");
                for (var M = 0; M < k.length; M++) {
                  var S = ["transforms", M], E = k[M].type;
                  if (s(k[M])) {
                    var L = h2.transforms[E] ? h2.transforms[E].attributes : {};
                    L.type = { valType: "enumerated", values: Object.keys(h2.transforms) }, c(k[M], A[M], L, p3, b, S);
                  } else
                    p3.push(d2("object", b, S));
                }
              }
            } else
              p3.push(d2("object", b));
          }
          var C = v2._fullLayout, P = f2(h2, g3);
          return c(u2, C, P, p3, "layout"), 0 === p3.length ? void 0 : p3;
        };
        var h = { object: function(t3, e3) {
          return ("layout" === t3 && "" === e3 ? "The layout argument" : "data" === t3[0] && "" === e3 ? "Trace " + t3[1] + " in the data argument" : p2(t3) + "key " + e3) + " must be linked to an object container";
        }, array: function(t3, e3) {
          return ("data" === t3 ? "The data argument" : p2(t3) + "key " + e3) + " must be linked to an array container";
        }, schema: function(t3, e3) {
          return p2(t3) + "key " + e3 + " is not part of the schema";
        }, unused: function(t3, e3, r3) {
          var n3 = s(r3) ? "container" : "key";
          return p2(t3) + n3 + " " + e3 + " did not get coerced";
        }, dynamic: function(t3, e3, r3, n3) {
          return [p2(t3) + "key", e3, "(set to '" + r3 + "')", "got reset to", "'" + n3 + "'", "during defaults."].join(" ");
        }, invisible: function(t3, e3) {
          return (e3 ? p2(t3) + "item " + e3 : "Trace " + t3[1]) + " got defaulted to be not visible";
        }, value: function(t3, e3, r3) {
          return [p2(t3) + "key " + e3, "is set to an invalid value (" + r3 + ")"].join(" ");
        } };
        function p2(t3) {
          return l(t3) ? "In data trace " + t3[1] + ", " : "In " + t3 + ", ";
        }
        function d2(t3, e3, r3, i2, a2) {
          var o2, s2;
          r3 = r3 || "", l(e3) ? (o2 = e3[0], s2 = e3[1]) : (o2 = e3, s2 = null);
          var u2 = function(t4) {
            if (!l(t4))
              return String(t4);
            for (var e4 = "", r4 = 0; r4 < t4.length; r4++) {
              var n3 = t4[r4];
              "number" == typeof n3 ? e4 = e4.substr(0, e4.length - 1) + "[" + n3 + "]" : e4 += n3, r4 < t4.length - 1 && (e4 += ".");
            }
            return e4;
          }(r3), c2 = h[t3](e3, u2, i2, a2);
          return n2.log(c2), { code: t3, container: o2, trace: s2, path: r3, astr: u2, msg: c2 };
        }
        function v(t3, e3) {
          var r3 = m2(e3), n3 = r3.keyMinusId, i2 = r3.id;
          return !!(n3 in t3 && t3[n3]._isSubplotObj && i2) || e3 in t3;
        }
        function g2(t3, e3) {
          return e3 in t3 ? t3[e3] : t3[m2(e3).keyMinusId];
        }
        var y = n2.counterRegex("([a-z]+)");
        function m2(t3) {
          var e3 = t3.match(y);
          return { keyMinusId: e3 && e3[1], id: e3 && e3[2] };
        }
      }, 85594: function(t2) {
        t2.exports = { mode: { valType: "enumerated", dflt: "afterall", values: ["immediate", "next", "afterall"] }, direction: { valType: "enumerated", values: ["forward", "reverse"], dflt: "forward" }, fromcurrent: { valType: "boolean", dflt: false }, frame: { duration: { valType: "number", min: 0, dflt: 500 }, redraw: { valType: "boolean", dflt: true } }, transition: { duration: { valType: "number", min: 0, dflt: 500, editType: "none" }, easing: { valType: "enumerated", dflt: "cubic-in-out", values: ["linear", "quad", "cubic", "sin", "exp", "circle", "elastic", "back", "bounce", "linear-in", "quad-in", "cubic-in", "sin-in", "exp-in", "circle-in", "elastic-in", "back-in", "bounce-in", "linear-out", "quad-out", "cubic-out", "sin-out", "exp-out", "circle-out", "elastic-out", "back-out", "bounce-out", "linear-in-out", "quad-in-out", "cubic-in-out", "sin-in-out", "exp-in-out", "circle-in-out", "elastic-in-out", "back-in-out", "bounce-in-out"], editType: "none" }, ordering: { valType: "enumerated", values: ["layout first", "traces first"], dflt: "layout first", editType: "none" } } };
      }, 85501: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(44467);
        t2.exports = function(t3, e3, r3) {
          var a, o, s = r3.name, l = r3.inclusionAttr || "visible", u = e3[s], c = n2.isArrayOrTypedArray(t3[s]) ? t3[s] : [], f2 = e3[s] = [], h = i.arrayTemplater(e3, s, l);
          for (a = 0; a < c.length; a++) {
            var p2 = c[a];
            n2.isPlainObject(p2) ? o = h.newItem(p2) : (o = h.newItem({}))[l] = false, o._index = a, false !== o[l] && r3.handleItemDefaults(p2, o, e3, r3), f2.push(o);
          }
          var d2 = h.defaultItems();
          for (a = 0; a < d2.length; a++)
            (o = d2[a])._index = f2.length, r3.handleItemDefaults({}, o, e3, r3, {}), f2.push(o);
          if (n2.isArrayOrTypedArray(u)) {
            var v = Math.min(u.length, f2.length);
            for (a = 0; a < v; a++)
              n2.relinkPrivateKeys(f2[a], u[a]);
          }
          return f2;
        };
      }, 9012: function(t2, e2, r2) {
        var n2 = r2(41940), i = r2(77914);
        t2.exports = { type: { valType: "enumerated", values: [], dflt: "scatter", editType: "calc+clearAxisTypes", _noTemplating: true }, visible: { valType: "enumerated", values: [true, false, "legendonly"], dflt: true, editType: "calc" }, showlegend: { valType: "boolean", dflt: true, editType: "style" }, legendgroup: { valType: "string", dflt: "", editType: "style" }, legendgrouptitle: { text: { valType: "string", dflt: "", editType: "style" }, font: n2({ editType: "style" }), editType: "style" }, legendrank: { valType: "number", dflt: 1e3, editType: "style" }, legendwidth: { valType: "number", min: 0, editType: "style" }, opacity: { valType: "number", min: 0, max: 1, dflt: 1, editType: "style" }, name: { valType: "string", editType: "style" }, uid: { valType: "string", editType: "plot", anim: true }, ids: { valType: "data_array", editType: "calc", anim: true }, customdata: { valType: "data_array", editType: "calc" }, meta: { valType: "any", arrayOk: true, editType: "plot" }, selectedpoints: { valType: "any", editType: "calc" }, hoverinfo: { valType: "flaglist", flags: ["x", "y", "z", "text", "name"], extras: ["all", "none", "skip"], arrayOk: true, dflt: "all", editType: "none" }, hoverlabel: i.hoverlabel, stream: { token: { valType: "string", noBlank: true, strict: true, editType: "calc" }, maxpoints: { valType: "number", min: 0, max: 1e4, dflt: 500, editType: "calc" }, editType: "calc" }, transforms: { _isLinkedToArray: "transform", editType: "calc" }, uirevision: { valType: "any", editType: "none" } };
      }, 42973: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = i.dateTime2ms, o = i.incrementMonth, s = r2(50606).ONEAVGMONTH;
        t2.exports = function(t3, e3, r3, i2) {
          if ("date" !== e3.type)
            return { vals: i2 };
          var l = t3[r3 + "periodalignment"];
          if (!l)
            return { vals: i2 };
          var u, c = t3[r3 + "period"];
          if (n2(c)) {
            if ((c = +c) <= 0)
              return { vals: i2 };
          } else if ("string" == typeof c && "M" === c.charAt(0)) {
            var f2 = +c.substring(1);
            if (!(f2 > 0 && Math.round(f2) === f2))
              return { vals: i2 };
            u = f2;
          }
          for (var h = e3.calendar, p2 = "start" === l, d2 = "end" === l, v = t3[r3 + "period0"], g2 = a(v, h) || 0, y = [], m2 = [], x = [], b = i2.length, _ = 0; _ < b; _++) {
            var w2, T, k, A = i2[_];
            if (u) {
              for (w2 = Math.round((A - g2) / (u * s)), k = o(g2, u * w2, h); k > A; )
                k = o(k, -u, h);
              for (; k <= A; )
                k = o(k, u, h);
              T = o(k, -u, h);
            } else {
              for (k = g2 + (w2 = Math.round((A - g2) / c)) * c; k > A; )
                k -= c;
              for (; k <= A; )
                k += c;
              T = k - c;
            }
            y[_] = p2 ? T : d2 ? k : (T + k) / 2, m2[_] = T, x[_] = k;
          }
          return { vals: y, starts: m2, ends: x };
        };
      }, 89502: function(t2) {
        t2.exports = { xaxis: { valType: "subplotid", dflt: "x", editType: "calc+clearAxisTypes" }, yaxis: { valType: "subplotid", dflt: "y", editType: "calc+clearAxisTypes" } };
      }, 71739: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(92770), a = r2(71828), o = r2(50606).FP_SAFE, s = r2(73972), l = r2(91424), u = r2(41675), c = u.getFromId, f2 = u.isLinked;
        function h(t3, e3) {
          var r3, n3, i2 = [], o2 = t3._fullLayout, s2 = d2(o2, e3, 0), l2 = d2(o2, e3, 1), u2 = v(t3, e3), c2 = u2.min, f3 = u2.max;
          if (0 === c2.length || 0 === f3.length)
            return a.simpleMap(e3.range, e3.r2l);
          var h2 = c2[0].val, g3 = f3[0].val;
          for (r3 = 1; r3 < c2.length && h2 === g3; r3++)
            h2 = Math.min(h2, c2[r3].val);
          for (r3 = 1; r3 < f3.length && h2 === g3; r3++)
            g3 = Math.max(g3, f3[r3].val);
          var y2 = false;
          if (e3.range) {
            var m3 = a.simpleMap(e3.range, e3.r2l);
            y2 = m3[1] < m3[0];
          }
          "reversed" === e3.autorange && (y2 = true, e3.autorange = true);
          var x2, b2, _2, w2, T, k, A = e3.rangemode, M = "tozero" === A, S = "nonnegative" === A, E = e3._length, L = E / 10, C = 0;
          for (r3 = 0; r3 < c2.length; r3++)
            for (x2 = c2[r3], n3 = 0; n3 < f3.length; n3++)
              (k = (b2 = f3[n3]).val - x2.val - p2(e3, x2.val, b2.val)) > 0 && ((T = E - s2(x2) - l2(b2)) > L ? k / T > C && (_2 = x2, w2 = b2, C = k / T) : k / E > C && (_2 = { val: x2.val, nopad: 1 }, w2 = { val: b2.val, nopad: 1 }, C = k / E));
          if (h2 === g3) {
            var P = h2 - 1, O = h2 + 1;
            if (M)
              if (0 === h2)
                i2 = [0, 1];
              else {
                var I = (h2 > 0 ? f3 : c2).reduce(function(t4, e4) {
                  return Math.max(t4, l2(e4));
                }, 0), D = h2 / (1 - Math.min(0.5, I / E));
                i2 = h2 > 0 ? [0, D] : [D, 0];
              }
            else
              i2 = S ? [Math.max(0, P), Math.max(1, O)] : [P, O];
          } else
            M ? (_2.val >= 0 && (_2 = { val: 0, nopad: 1 }), w2.val <= 0 && (w2 = { val: 0, nopad: 1 })) : S && (_2.val - C * s2(_2) < 0 && (_2 = { val: 0, nopad: 1 }), w2.val <= 0 && (w2 = { val: 1, nopad: 1 })), C = (w2.val - _2.val - p2(e3, x2.val, b2.val)) / (E - s2(_2) - l2(w2)), i2 = [_2.val - C * s2(_2), w2.val + C * l2(w2)];
          return y2 && i2.reverse(), a.simpleMap(i2, e3.l2r || Number);
        }
        function p2(t3, e3, r3) {
          var n3 = 0;
          if (t3.rangebreaks)
            for (var i2 = t3.locateBreaks(e3, r3), a2 = 0; a2 < i2.length; a2++) {
              var o2 = i2[a2];
              n3 += o2.max - o2.min;
            }
          return n3;
        }
        function d2(t3, e3, r3) {
          var i2 = 0.05 * e3._length, o2 = e3._anchorAxis || {};
          if (-1 !== (e3.ticklabelposition || "").indexOf("inside") || -1 !== (o2.ticklabelposition || "").indexOf("inside")) {
            var s2 = "reversed" === e3.autorange;
            if (!s2) {
              var u2 = a.simpleMap(e3.range, e3.r2l);
              s2 = u2[1] < u2[0];
            }
            s2 && (r3 = !r3);
          }
          var c2 = 0;
          return f2(t3, e3._id) || (c2 = function(t4, e4, r4) {
            var i3 = 0, o3 = "x" === e4._id.charAt(0);
            for (var s3 in t4._plots) {
              var u3 = t4._plots[s3];
              if (e4._id === u3.xaxis._id || e4._id === u3.yaxis._id) {
                var c3 = (o3 ? u3.yaxis : u3.xaxis) || {};
                if (-1 !== (c3.ticklabelposition || "").indexOf("inside") && (!r4 && ("left" === c3.side || "bottom" === c3.side) || r4 && ("top" === c3.side || "right" === c3.side))) {
                  if (c3._vals) {
                    var f3 = a.deg2rad(c3._tickAngles[c3._id + "tick"] || 0), h2 = Math.abs(Math.cos(f3)), p3 = Math.abs(Math.sin(f3));
                    if (!c3._vals[0].bb) {
                      var d3 = c3._id + "tick";
                      c3._selections[d3].each(function(t5) {
                        var e5 = n2.select(this);
                        e5.select(".text-math-group").empty() && (t5.bb = l.bBox(e5.node()));
                      });
                    }
                    for (var v2 = 0; v2 < c3._vals.length; v2++) {
                      var g3 = c3._vals[v2].bb;
                      if (g3) {
                        var y2 = 6 + g3.width, m3 = 6 + g3.height;
                        i3 = Math.max(i3, o3 ? Math.max(y2 * h2, m3 * p3) : Math.max(m3 * h2, y2 * p3));
                      }
                    }
                  }
                  "inside" === c3.ticks && "inside" === c3.ticklabelposition && (i3 += c3.ticklen || 0);
                }
              }
            }
            return i3;
          }(t3, e3, r3)), i2 = Math.max(c2, i2), "domain" === e3.constrain && e3._inputDomain && (i2 *= (e3._inputDomain[1] - e3._inputDomain[0]) / (e3.domain[1] - e3.domain[0])), function(t4) {
            return t4.nopad ? 0 : t4.pad + (t4.extrapad ? i2 : c2);
          };
        }
        function v(t3, e3, r3) {
          var n3, i2, a2, o2 = e3._id, s2 = t3._fullData, l2 = t3._fullLayout, u2 = [], f3 = [];
          function h2(t4, e4) {
            for (n3 = 0; n3 < e4.length; n3++) {
              var r4 = t4[e4[n3]], s3 = (r4._extremes || {})[o2];
              if (true === r4.visible && s3) {
                for (i2 = 0; i2 < s3.min.length; i2++)
                  a2 = s3.min[i2], g2(u2, a2.val, a2.pad, { extrapad: a2.extrapad });
                for (i2 = 0; i2 < s3.max.length; i2++)
                  a2 = s3.max[i2], y(f3, a2.val, a2.pad, { extrapad: a2.extrapad });
              }
            }
          }
          if (h2(s2, e3._traceIndices), h2(l2.annotations || [], e3._annIndices || []), h2(l2.shapes || [], e3._shapeIndices || []), e3._matchGroup && !r3) {
            for (var p3 in e3._matchGroup)
              if (p3 !== e3._id) {
                var d3 = c(t3, p3), m3 = v(t3, d3, true), x2 = e3._length / d3._length;
                for (i2 = 0; i2 < m3.min.length; i2++)
                  a2 = m3.min[i2], g2(u2, a2.val, a2.pad * x2, { extrapad: a2.extrapad });
                for (i2 = 0; i2 < m3.max.length; i2++)
                  a2 = m3.max[i2], y(f3, a2.val, a2.pad * x2, { extrapad: a2.extrapad });
              }
          }
          return { min: u2, max: f3 };
        }
        function g2(t3, e3, r3, n3) {
          m2(t3, e3, r3, n3, b);
        }
        function y(t3, e3, r3, n3) {
          m2(t3, e3, r3, n3, _);
        }
        function m2(t3, e3, r3, n3, i2) {
          for (var a2 = n3.tozero, o2 = n3.extrapad, s2 = true, l2 = 0; l2 < t3.length && s2; l2++) {
            var u2 = t3[l2];
            if (i2(u2.val, e3) && u2.pad >= r3 && (u2.extrapad || !o2)) {
              s2 = false;
              break;
            }
            i2(e3, u2.val) && u2.pad <= r3 && (o2 || !u2.extrapad) && (t3.splice(l2, 1), l2--);
          }
          if (s2) {
            var c2 = a2 && 0 === e3;
            t3.push({ val: e3, pad: c2 ? 0 : r3, extrapad: !c2 && o2 });
          }
        }
        function x(t3) {
          return i(t3) && Math.abs(t3) < o;
        }
        function b(t3, e3) {
          return t3 <= e3;
        }
        function _(t3, e3) {
          return t3 >= e3;
        }
        t2.exports = { getAutoRange: h, makePadFn: d2, doAutoRange: function(t3, e3, r3) {
          if (e3.setScale(), e3.autorange) {
            e3.range = r3 ? r3.slice() : h(t3, e3), e3._r = e3.range.slice(), e3._rl = a.simpleMap(e3._r, e3.r2l);
            var n3 = e3._input, i2 = {};
            i2[e3._attr + ".range"] = e3.range, i2[e3._attr + ".autorange"] = e3.autorange, s.call("_storeDirectGUIEdit", t3.layout, t3._fullLayout._preGUI, i2), n3.range = e3.range.slice(), n3.autorange = e3.autorange;
          }
          var o2 = e3._anchorAxis;
          if (o2 && o2.rangeslider) {
            var l2 = o2.rangeslider[e3._name];
            l2 && "auto" === l2.rangemode && (l2.range = h(t3, e3)), o2._input.rangeslider[e3._name] = a.extendFlat({}, l2);
          }
        }, findExtremes: function(t3, e3, r3) {
          r3 || (r3 = {}), t3._m || t3.setScale();
          var n3, a2, s2, l2, u2, c2, f3, h2, p3, d3 = [], v2 = [], m3 = e3.length, b2 = r3.padded || false, _2 = r3.tozero && ("linear" === t3.type || "-" === t3.type), w2 = "log" === t3.type, T = false, k = r3.vpadLinearized || false;
          function A(t4) {
            if (Array.isArray(t4))
              return T = true, function(e5) {
                return Math.max(Number(t4[e5] || 0), 0);
              };
            var e4 = Math.max(Number(t4 || 0), 0);
            return function() {
              return e4;
            };
          }
          var M = A((t3._m > 0 ? r3.ppadplus : r3.ppadminus) || r3.ppad || 0), S = A((t3._m > 0 ? r3.ppadminus : r3.ppadplus) || r3.ppad || 0), E = A(r3.vpadplus || r3.vpad), L = A(r3.vpadminus || r3.vpad);
          if (!T) {
            if (h2 = 1 / 0, p3 = -1 / 0, w2)
              for (n3 = 0; n3 < m3; n3++)
                (a2 = e3[n3]) < h2 && a2 > 0 && (h2 = a2), a2 > p3 && a2 < o && (p3 = a2);
            else
              for (n3 = 0; n3 < m3; n3++)
                (a2 = e3[n3]) < h2 && a2 > -o && (h2 = a2), a2 > p3 && a2 < o && (p3 = a2);
            e3 = [h2, p3], m3 = 2;
          }
          var C = { tozero: _2, extrapad: b2 };
          function P(r4) {
            s2 = e3[r4], i(s2) && (c2 = M(r4), f3 = S(r4), k ? (l2 = t3.c2l(s2) - L(r4), u2 = t3.c2l(s2) + E(r4)) : (h2 = s2 - L(r4), p3 = s2 + E(r4), w2 && h2 < p3 / 10 && (h2 = p3 / 10), l2 = t3.c2l(h2), u2 = t3.c2l(p3)), _2 && (l2 = Math.min(0, l2), u2 = Math.max(0, u2)), x(l2) && g2(d3, l2, f3, C), x(u2) && y(v2, u2, c2, C));
          }
          var O = Math.min(6, m3);
          for (n3 = 0; n3 < O; n3++)
            P(n3);
          for (n3 = m3 - 1; n3 >= O; n3--)
            P(n3);
          return { min: d3, max: v2, opts: r3 };
        }, concatExtremes: v };
      }, 89298: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(92770), a = r2(74875), o = r2(73972), s = r2(71828), l = s.strTranslate, u = r2(63893), c = r2(92998), f2 = r2(7901), h = r2(91424), p2 = r2(13838), d2 = r2(66287), v = r2(50606), g2 = v.ONEMAXYEAR, y = v.ONEAVGYEAR, m2 = v.ONEMINYEAR, x = v.ONEMAXQUARTER, b = v.ONEAVGQUARTER, _ = v.ONEMINQUARTER, w2 = v.ONEMAXMONTH, T = v.ONEAVGMONTH, k = v.ONEMINMONTH, A = v.ONEWEEK, M = v.ONEDAY, S = M / 2, E = v.ONEHOUR, L = v.ONEMIN, C = v.ONESEC, P = v.MINUS_SIGN, O = v.BADNUM, I = { K: "zeroline" }, D = { K: "gridline", L: "path" }, z = { K: "minor-gridline", L: "path" }, R = { K: "tick", L: "path" }, F = { K: "tick", L: "text" }, B = { width: ["x", "r", "l", "xl", "xr"], height: ["y", "t", "b", "yt", "yb"], right: ["r", "xr"], left: ["l", "xl"], top: ["t", "yt"], bottom: ["b", "yb"] }, N = r2(18783), j = N.MID_SHIFT, U = N.CAP_SHIFT, V = N.LINE_SPACING, H = N.OPPOSITE_SIDE, q2 = t2.exports = {};
        q2.setConvert = r2(21994);
        var G = r2(4322), Z = r2(41675), Y = Z.idSort, W = Z.isLinked;
        q2.id2name = Z.id2name, q2.name2id = Z.name2id, q2.cleanId = Z.cleanId, q2.list = Z.list, q2.listIds = Z.listIds, q2.getFromId = Z.getFromId, q2.getFromTrace = Z.getFromTrace;
        var X = r2(71739);
        function J(t3) {
          var e3 = 1e-4 * (t3[1] - t3[0]);
          return [t3[0] - e3, t3[1] + e3];
        }
        q2.getAutoRange = X.getAutoRange, q2.findExtremes = X.findExtremes, q2.coerceRef = function(t3, e3, r3, n3, i2, a2) {
          var o2 = n3.charAt(n3.length - 1), l2 = r3._fullLayout._subplots[o2 + "axis"], u2 = n3 + "ref", c2 = {};
          return i2 || (i2 = l2[0] || ("string" == typeof a2 ? a2 : a2[0])), a2 || (a2 = i2), l2 = l2.concat(l2.map(function(t4) {
            return t4 + " domain";
          })), c2[u2] = { valType: "enumerated", values: l2.concat(a2 ? "string" == typeof a2 ? [a2] : a2 : []), dflt: i2 }, s.coerce(t3, e3, c2, u2);
        }, q2.getRefType = function(t3) {
          return void 0 === t3 ? t3 : "paper" === t3 ? "paper" : "pixel" === t3 ? "pixel" : /( domain)$/.test(t3) ? "domain" : "range";
        }, q2.coercePosition = function(t3, e3, r3, n3, i2, a2) {
          var o2, l2;
          if ("range" !== q2.getRefType(n3))
            o2 = s.ensureNumber, l2 = r3(i2, a2);
          else {
            var u2 = q2.getFromId(e3, n3);
            l2 = r3(i2, a2 = u2.fraction2r(a2)), o2 = u2.cleanPos;
          }
          t3[i2] = o2(l2);
        }, q2.cleanPosition = function(t3, e3, r3) {
          return ("paper" === r3 || "pixel" === r3 ? s.ensureNumber : q2.getFromId(e3, r3).cleanPos)(t3);
        }, q2.redrawComponents = function(t3, e3) {
          e3 = e3 || q2.listIds(t3);
          var r3 = t3._fullLayout;
          function n3(n4, i2, a2, s2) {
            for (var l2 = o.getComponentMethod(n4, i2), u2 = {}, c2 = 0; c2 < e3.length; c2++)
              for (var f3 = r3[q2.id2name(e3[c2])][a2], h2 = 0; h2 < f3.length; h2++) {
                var p3 = f3[h2];
                if (!u2[p3] && (l2(t3, p3), u2[p3] = 1, s2))
                  return;
              }
          }
          n3("annotations", "drawOne", "_annIndices"), n3("shapes", "drawOne", "_shapeIndices"), n3("images", "draw", "_imgIndices", true), n3("selections", "drawOne", "_selectionIndices");
        };
        var K = q2.getDataConversions = function(t3, e3, r3, n3) {
          var i2, a2 = "x" === r3 || "y" === r3 || "z" === r3 ? r3 : n3;
          if (Array.isArray(a2)) {
            if (i2 = { type: G(n3, void 0, { autotypenumbers: t3._fullLayout.autotypenumbers }), _categories: [] }, q2.setConvert(i2), "category" === i2.type)
              for (var o2 = 0; o2 < n3.length; o2++)
                i2.d2c(n3[o2]);
          } else
            i2 = q2.getFromTrace(t3, e3, a2);
          return i2 ? { d2c: i2.d2c, c2d: i2.c2d } : "ids" === a2 ? { d2c: Q, c2d: Q } : { d2c: $, c2d: $ };
        };
        function $(t3) {
          return +t3;
        }
        function Q(t3) {
          return String(t3);
        }
        function tt(t3, e3) {
          return Math.abs((t3 / e3 + 0.5) % 1 - 0.5) < 1e-3;
        }
        function et(t3, e3) {
          return Math.abs(t3 / e3 - 1) < 1e-3;
        }
        function rt(t3) {
          return +t3.substring(1);
        }
        function nt(t3, e3) {
          return t3.rangebreaks && (e3 = e3.filter(function(e4) {
            return t3.maskBreaks(e4.x) !== O;
          })), e3;
        }
        function it(t3) {
          var e3 = t3._mainAxis, r3 = [];
          if (e3._vals) {
            for (var n3 = 0; n3 < e3._vals.length; n3++)
              if (!e3._vals[n3].noTick) {
                var i2 = e3.l2p(e3._vals[n3].x), a2 = t3.p2l(i2), o2 = q2.tickText(t3, a2);
                e3._vals[n3].minor && (o2.minor = true, o2.text = ""), r3.push(o2);
              }
          }
          return nt(t3, r3);
        }
        function at(t3) {
          var e3 = J(s.simpleMap(t3.range, t3.r2l)), r3 = Math.min(e3[0], e3[1]), n3 = Math.max(e3[0], e3[1]), i2 = "category" === t3.type ? t3.d2l_noadd : t3.d2l;
          "log" === t3.type && "L" !== String(t3.dtick).charAt(0) && (t3.dtick = "L" + Math.pow(10, Math.floor(Math.min(t3.range[0], t3.range[1])) - 1));
          for (var a2 = [], o2 = 0; o2 <= 1; o2++)
            if (!o2 || t3.minor) {
              var l2 = o2 ? t3.minor.tickvals : t3.tickvals, u2 = o2 ? [] : t3.ticktext;
              if (l2) {
                Array.isArray(u2) || (u2 = []);
                for (var c2 = 0; c2 < l2.length; c2++) {
                  var f3 = i2(l2[c2]);
                  if (f3 > r3 && f3 < n3) {
                    var h2 = void 0 === u2[c2] ? q2.tickText(t3, f3) : vt(t3, f3, String(u2[c2]));
                    o2 && (h2.minor = true, h2.text = ""), a2.push(h2);
                  }
                }
              }
            }
          return nt(t3, a2);
        }
        q2.getDataToCoordFunc = function(t3, e3, r3, n3) {
          return K(t3, e3, r3, n3).d2c;
        }, q2.counterLetter = function(t3) {
          var e3 = t3.charAt(0);
          return "x" === e3 ? "y" : "y" === e3 ? "x" : void 0;
        }, q2.minDtick = function(t3, e3, r3, n3) {
          -1 === ["log", "category", "multicategory"].indexOf(t3.type) && n3 ? void 0 === t3._minDtick ? (t3._minDtick = e3, t3._forceTick0 = r3) : t3._minDtick && ((t3._minDtick / e3 + 1e-6) % 1 < 2e-6 && ((r3 - t3._forceTick0) / e3 % 1 + 1.000001) % 1 < 2e-6 ? (t3._minDtick = e3, t3._forceTick0 = r3) : ((e3 / t3._minDtick + 1e-6) % 1 > 2e-6 || ((r3 - t3._forceTick0) / t3._minDtick % 1 + 1.000001) % 1 > 2e-6) && (t3._minDtick = 0)) : t3._minDtick = 0;
        }, q2.saveRangeInitial = function(t3, e3) {
          for (var r3 = q2.list(t3, "", true), n3 = false, i2 = 0; i2 < r3.length; i2++) {
            var a2 = r3[i2], o2 = void 0 === a2._rangeInitial, s2 = o2 || !(a2.range[0] === a2._rangeInitial[0] && a2.range[1] === a2._rangeInitial[1]);
            (o2 && false === a2.autorange || e3 && s2) && (a2._rangeInitial = a2.range.slice(), n3 = true);
          }
          return n3;
        }, q2.saveShowSpikeInitial = function(t3, e3) {
          for (var r3 = q2.list(t3, "", true), n3 = false, i2 = "on", a2 = 0; a2 < r3.length; a2++) {
            var o2 = r3[a2], s2 = void 0 === o2._showSpikeInitial, l2 = s2 || !(o2.showspikes === o2._showspikes);
            (s2 || e3 && l2) && (o2._showSpikeInitial = o2.showspikes, n3 = true), "on" !== i2 || o2.showspikes || (i2 = "off");
          }
          return t3._fullLayout._cartesianSpikesEnabled = i2, n3;
        }, q2.autoBin = function(t3, e3, r3, n3, a2, o2) {
          var l2, u2 = s.aggNums(Math.min, null, t3), c2 = s.aggNums(Math.max, null, t3);
          if ("category" === e3.type || "multicategory" === e3.type)
            return { start: u2 - 0.5, end: c2 + 0.5, size: Math.max(1, Math.round(o2) || 1), _dataSpan: c2 - u2 };
          if (a2 || (a2 = e3.calendar), l2 = "log" === e3.type ? { type: "linear", range: [u2, c2] } : { type: e3.type, range: s.simpleMap([u2, c2], e3.c2r, 0, a2), calendar: a2 }, q2.setConvert(l2), o2 = o2 && d2.dtick(o2, l2.type))
            l2.dtick = o2, l2.tick0 = d2.tick0(void 0, l2.type, a2);
          else {
            var f3;
            if (r3)
              f3 = (c2 - u2) / r3;
            else {
              var h2 = s.distinctVals(t3), p3 = Math.pow(10, Math.floor(Math.log(h2.minDiff) / Math.LN10)), v2 = p3 * s.roundUp(h2.minDiff / p3, [0.9, 1.9, 4.9, 9.9], true);
              f3 = Math.max(v2, 2 * s.stdev(t3) / Math.pow(t3.length, n3 ? 0.25 : 0.4)), i(f3) || (f3 = 1);
            }
            q2.autoTicks(l2, f3);
          }
          var g3, y2 = l2.dtick, m3 = q2.tickIncrement(q2.tickFirst(l2), y2, "reverse", a2);
          if ("number" == typeof y2)
            m3 = function(t4, e4, r4, n4, a3) {
              var o3 = 0, s2 = 0, l3 = 0, u3 = 0;
              function c3(e5) {
                return (1 + 100 * (e5 - t4) / r4.dtick) % 100 < 2;
              }
              for (var f4 = 0; f4 < e4.length; f4++)
                e4[f4] % 1 == 0 ? l3++ : i(e4[f4]) || u3++, c3(e4[f4]) && o3++, c3(e4[f4] + r4.dtick / 2) && s2++;
              var h3 = e4.length - u3;
              if (l3 === h3 && "date" !== r4.type)
                r4.dtick < 1 ? t4 = n4 - 0.5 * r4.dtick : (t4 -= 0.5) + r4.dtick < n4 && (t4 += r4.dtick);
              else if (s2 < 0.1 * h3 && (o3 > 0.3 * h3 || c3(n4) || c3(a3))) {
                var p4 = r4.dtick / 2;
                t4 += t4 + p4 < n4 ? p4 : -p4;
              }
              return t4;
            }(m3, t3, l2, u2, c2), g3 = m3 + (1 + Math.floor((c2 - m3) / y2)) * y2;
          else
            for ("M" === l2.dtick.charAt(0) && (m3 = function(t4, e4, r4, n4, i2) {
              var a3 = s.findExactDates(e4, i2);
              if (a3.exactDays > 0.8) {
                var o3 = Number(r4.substr(1));
                a3.exactYears > 0.8 && o3 % 12 == 0 ? t4 = q2.tickIncrement(t4, "M6", "reverse") + 1.5 * M : a3.exactMonths > 0.8 ? t4 = q2.tickIncrement(t4, "M1", "reverse") + 15.5 * M : t4 -= S;
                var l3 = q2.tickIncrement(t4, r4);
                if (l3 <= n4)
                  return l3;
              }
              return t4;
            }(m3, t3, y2, u2, a2)), g3 = m3; g3 <= c2; )
              g3 = q2.tickIncrement(g3, y2, false, a2);
          return { start: e3.c2r(m3, 0, a2), end: e3.c2r(g3, 0, a2), size: y2, _dataSpan: c2 - u2 };
        }, q2.prepMinorTicks = function(t3, e3, r3) {
          if (!e3.minor.dtick) {
            delete t3.dtick;
            var n3, a2 = e3.dtick && i(e3._tmin);
            if (a2) {
              var o2 = q2.tickIncrement(e3._tmin, e3.dtick, true);
              n3 = [e3._tmin, 0.99 * o2 + 0.01 * e3._tmin];
            } else {
              var l2 = s.simpleMap(e3.range, e3.r2l);
              n3 = [l2[0], 0.8 * l2[0] + 0.2 * l2[1]];
            }
            if (t3.range = s.simpleMap(n3, e3.l2r), t3._isMinor = true, q2.prepTicks(t3, r3), a2) {
              var u2 = i(e3.dtick), c2 = i(t3.dtick), f3 = u2 ? e3.dtick : +e3.dtick.substring(1), h2 = c2 ? t3.dtick : +t3.dtick.substring(1);
              u2 && c2 ? tt(f3, h2) ? f3 === 2 * A && h2 === 2 * M && (t3.dtick = A) : f3 === 2 * A && h2 === 3 * M ? t3.dtick = A : f3 !== A || (e3._input.minor || {}).nticks ? et(f3 / h2, 2.5) ? t3.dtick = f3 / 2 : t3.dtick = f3 : t3.dtick = M : "M" === String(e3.dtick).charAt(0) ? c2 ? t3.dtick = "M1" : tt(f3, h2) ? f3 >= 12 && 2 === h2 && (t3.dtick = "M3") : t3.dtick = e3.dtick : "L" === String(t3.dtick).charAt(0) ? "L" === String(e3.dtick).charAt(0) ? tt(f3, h2) || (t3.dtick = et(f3 / h2, 2.5) ? e3.dtick / 2 : e3.dtick) : t3.dtick = "D1" : "D2" === t3.dtick && +e3.dtick > 1 && (t3.dtick = 1);
            }
            t3.range = e3.range;
          }
          void 0 === e3.minor._tick0Init && (t3.tick0 = e3.tick0);
        }, q2.prepTicks = function(t3, e3) {
          var r3 = s.simpleMap(t3.range, t3.r2l, void 0, void 0, e3);
          if ("auto" === t3.tickmode || !t3.dtick) {
            var n3, a2 = t3.nticks;
            a2 || ("category" === t3.type || "multicategory" === t3.type ? (n3 = t3.tickfont ? s.bigFont(t3.tickfont.size || 12) : 15, a2 = t3._length / n3) : (n3 = "y" === t3._id.charAt(0) ? 40 : 80, a2 = s.constrain(t3._length / n3, 4, 9) + 1), "radialaxis" === t3._name && (a2 *= 2)), t3.minor && "array" !== t3.minor.tickmode || "array" === t3.tickmode && (a2 *= 100), t3._roughDTick = Math.abs(r3[1] - r3[0]) / a2, q2.autoTicks(t3, t3._roughDTick), t3._minDtick > 0 && t3.dtick < 2 * t3._minDtick && (t3.dtick = t3._minDtick, t3.tick0 = t3.l2r(t3._forceTick0));
          }
          "period" === t3.ticklabelmode && function(t4) {
            var e4;
            function r4() {
              return !(i(t4.dtick) || "M" !== t4.dtick.charAt(0));
            }
            var n4 = r4(), a3 = q2.getTickFormat(t4);
            if (a3) {
              var o2 = t4._dtickInit !== t4.dtick;
              /%[fLQsSMX]/.test(a3) || (/%[HI]/.test(a3) ? (e4 = E, o2 && !n4 && t4.dtick < E && (t4.dtick = E)) : /%p/.test(a3) ? (e4 = S, o2 && !n4 && t4.dtick < S && (t4.dtick = S)) : /%[Aadejuwx]/.test(a3) ? (e4 = M, o2 && !n4 && t4.dtick < M && (t4.dtick = M)) : /%[UVW]/.test(a3) ? (e4 = A, o2 && !n4 && t4.dtick < A && (t4.dtick = A)) : /%[Bbm]/.test(a3) ? (e4 = T, o2 && (n4 ? rt(t4.dtick) < 1 : t4.dtick < k) && (t4.dtick = "M1")) : /%[q]/.test(a3) ? (e4 = b, o2 && (n4 ? rt(t4.dtick) < 3 : t4.dtick < _) && (t4.dtick = "M3")) : /%[Yy]/.test(a3) && (e4 = y, o2 && (n4 ? rt(t4.dtick) < 12 : t4.dtick < m2) && (t4.dtick = "M12")));
            }
            (n4 = r4()) && t4.tick0 === t4._dowTick0 && (t4.tick0 = t4._rawTick0), t4._definedDelta = e4;
          }(t3), t3.tick0 || (t3.tick0 = "date" === t3.type ? "2000-01-01" : 0), "date" === t3.type && t3.dtick < 0.1 && (t3.dtick = 0.1), dt(t3);
        }, q2.calcTicks = function(t3, e3) {
          for (var r3, n3, a2 = t3.type, o2 = t3.calendar, l2 = t3.ticklabelstep, u2 = "period" === t3.ticklabelmode, c2 = s.simpleMap(t3.range, t3.r2l, void 0, void 0, e3), f3 = c2[1] < c2[0], h2 = Math.min(c2[0], c2[1]), p3 = Math.max(c2[0], c2[1]), d3 = Math.max(1e3, t3._length || 0), v2 = [], L2 = [], C2 = [], P2 = [], I2 = t3.minor && (t3.minor.ticks || t3.minor.showgrid), D2 = 1; D2 >= (I2 ? 0 : 1); D2--) {
            var z2 = !D2;
            D2 ? (t3._dtickInit = t3.dtick, t3._tick0Init = t3.tick0) : (t3.minor._dtickInit = t3.minor.dtick, t3.minor._tick0Init = t3.minor.tick0);
            var R2 = D2 ? t3 : s.extendFlat({}, t3, t3.minor);
            if (z2 ? q2.prepMinorTicks(R2, t3, e3) : q2.prepTicks(R2, e3), "array" !== R2.tickmode)
              if ("sync" !== R2.tickmode) {
                var F2 = J(c2), B2 = F2[0], N2 = F2[1], j2 = i(R2.dtick), U2 = "log" === a2 && !(j2 || "L" === R2.dtick.charAt(0)), V2 = q2.tickFirst(R2, e3);
                if (D2) {
                  if (t3._tmin = V2, V2 < B2 !== f3)
                    break;
                  "category" !== a2 && "multicategory" !== a2 || (N2 = f3 ? Math.max(-0.5, N2) : Math.min(t3._categories.length - 0.5, N2));
                }
                var H2, G2, Z2 = null, Y2 = V2;
                D2 && (j2 ? G2 = t3.dtick : "date" === a2 ? "string" == typeof t3.dtick && "M" === t3.dtick.charAt(0) && (G2 = T * t3.dtick.substring(1)) : G2 = t3._roughDTick, H2 = Math.round((t3.r2l(Y2) - t3.r2l(t3.tick0)) / G2) - 1);
                var W2 = R2.dtick;
                for (R2.rangebreaks && R2._tick0Init !== R2.tick0 && (Y2 = Dt(Y2, t3), f3 || (Y2 = q2.tickIncrement(Y2, W2, !f3, o2))), D2 && u2 && (Y2 = q2.tickIncrement(Y2, W2, !f3, o2), H2--); f3 ? Y2 >= N2 : Y2 <= N2; Y2 = q2.tickIncrement(Y2, W2, f3, o2)) {
                  if (D2 && H2++, R2.rangebreaks && !f3) {
                    if (Y2 < B2)
                      continue;
                    if (R2.maskBreaks(Y2) === O && Dt(Y2, R2) >= p3)
                      break;
                  }
                  if (C2.length > d3 || Y2 === Z2)
                    break;
                  Z2 = Y2;
                  var X2 = { value: Y2 };
                  D2 ? (U2 && Y2 !== (0 | Y2) && (X2.simpleLabel = true), l2 > 1 && H2 % l2 && (X2.skipLabel = true), C2.push(X2)) : (X2.minor = true, P2.push(X2));
                }
              } else
                C2 = [], v2 = it(t3);
            else
              D2 ? (C2 = [], v2 = at(t3)) : (P2 = [], L2 = at(t3));
          }
          if (I2 && !("inside" === t3.minor.ticks && "outside" === t3.ticks || "outside" === t3.minor.ticks && "inside" === t3.ticks)) {
            for (var K2 = C2.map(function(t4) {
              return t4.value;
            }), $2 = [], Q2 = 0; Q2 < P2.length; Q2++) {
              var tt2 = P2[Q2], et2 = tt2.value;
              if (-1 === K2.indexOf(et2)) {
                for (var rt2 = false, nt2 = 0; !rt2 && nt2 < C2.length; nt2++)
                  1e7 + C2[nt2].value === 1e7 + et2 && (rt2 = true);
                rt2 || $2.push(tt2);
              }
            }
            P2 = $2;
          }
          if (u2 && function(t4, e4, r4) {
            for (var n4 = 0; n4 < t4.length; n4++) {
              var i2 = t4[n4].value, a3 = n4, o3 = n4 + 1;
              n4 < t4.length - 1 ? (a3 = n4, o3 = n4 + 1) : n4 > 0 ? (a3 = n4 - 1, o3 = n4) : (a3 = n4, o3 = n4);
              var s2, l3 = t4[a3].value, u3 = t4[o3].value, c3 = Math.abs(u3 - l3), f4 = r4 || c3, h3 = 0;
              f4 >= m2 ? h3 = c3 >= m2 && c3 <= g2 ? c3 : y : r4 === b && f4 >= _ ? h3 = c3 >= _ && c3 <= x ? c3 : b : f4 >= k ? h3 = c3 >= k && c3 <= w2 ? c3 : T : r4 === A && f4 >= A ? h3 = A : f4 >= M ? h3 = M : r4 === S && f4 >= S ? h3 = S : r4 === E && f4 >= E && (h3 = E), h3 >= c3 && (h3 = c3, s2 = true);
              var p4 = i2 + h3;
              if (e4.rangebreaks && h3 > 0) {
                for (var d4 = 0, v3 = 0; v3 < 84; v3++) {
                  var L3 = (v3 + 0.5) / 84;
                  e4.maskBreaks(i2 * (1 - L3) + L3 * p4) !== O && d4++;
                }
                (h3 *= d4 / 84) || (t4[n4].drop = true), s2 && c3 > A && (h3 = c3);
              }
              (h3 > 0 || 0 === n4) && (t4[n4].periodX = i2 + h3 / 2);
            }
          }(C2, t3, t3._definedDelta), t3.rangebreaks) {
            var ot2 = "y" === t3._id.charAt(0), st2 = 1;
            "auto" === t3.tickmode && (st2 = t3.tickfont ? t3.tickfont.size : 12);
            var lt2 = NaN;
            for (r3 = C2.length - 1; r3 > -1; r3--)
              if (C2[r3].drop)
                C2.splice(r3, 1);
              else {
                C2[r3].value = Dt(C2[r3].value, t3);
                var ut2 = t3.c2p(C2[r3].value);
                (ot2 ? lt2 > ut2 - st2 : lt2 < ut2 + st2) ? C2.splice(f3 ? r3 + 1 : r3, 1) : lt2 = ut2;
              }
          }
          It(t3) && 360 === Math.abs(c2[1] - c2[0]) && C2.pop(), t3._tmax = (C2[C2.length - 1] || {}).value, t3._prevDateHead = "", t3._inCalcTicks = true;
          var ct2, ft2, ht2 = function(e4) {
            e4.text = "", t3._prevDateHead = n3;
          };
          for (C2 = C2.concat(P2), r3 = 0; r3 < C2.length; r3++) {
            var pt2 = C2[r3].minor, dt2 = C2[r3].value;
            pt2 ? L2.push({ x: dt2, minor: true }) : (n3 = t3._prevDateHead, ct2 = q2.tickText(t3, dt2, false, C2[r3].simpleLabel), void 0 !== (ft2 = C2[r3].periodX) && (ct2.periodX = ft2, (ft2 > p3 || ft2 < h2) && (ft2 > p3 && (ct2.periodX = p3), ft2 < h2 && (ct2.periodX = h2), ht2(ct2))), C2[r3].skipLabel && ht2(ct2), v2.push(ct2));
          }
          return v2 = v2.concat(L2), t3._inCalcTicks = false, u2 && v2.length && (v2[0].noTick = true), v2;
        };
        var ot = [2, 5, 10], st = [1, 2, 3, 6, 12], lt = [1, 2, 5, 10, 15, 30], ut = [1, 2, 3, 7, 14], ct = [-0.046, 0, 0.301, 0.477, 0.602, 0.699, 0.778, 0.845, 0.903, 0.954, 1], ft = [-0.301, 0, 0.301, 0.699, 1], ht = [15, 30, 45, 90, 180];
        function pt(t3, e3, r3) {
          return e3 * s.roundUp(t3 / e3, r3);
        }
        function dt(t3) {
          var e3 = t3.dtick;
          if (t3._tickexponent = 0, i(e3) || "string" == typeof e3 || (e3 = 1), "category" !== t3.type && "multicategory" !== t3.type || (t3._tickround = null), "date" === t3.type) {
            var r3 = t3.r2l(t3.tick0), n3 = t3.l2r(r3).replace(/(^-|i)/g, ""), a2 = n3.length;
            if ("M" === String(e3).charAt(0))
              a2 > 10 || "01-01" !== n3.substr(5) ? t3._tickround = "d" : t3._tickround = +e3.substr(1) % 12 == 0 ? "y" : "m";
            else if (e3 >= M && a2 <= 10 || e3 >= 15 * M)
              t3._tickround = "d";
            else if (e3 >= L && a2 <= 16 || e3 >= E)
              t3._tickround = "M";
            else if (e3 >= C && a2 <= 19 || e3 >= L)
              t3._tickround = "S";
            else {
              var o2 = t3.l2r(r3 + e3).replace(/^-/, "").length;
              t3._tickround = Math.max(a2, o2) - 20, t3._tickround < 0 && (t3._tickround = 4);
            }
          } else if (i(e3) || "L" === e3.charAt(0)) {
            var s2 = t3.range.map(t3.r2d || Number);
            i(e3) || (e3 = Number(e3.substr(1))), t3._tickround = 2 - Math.floor(Math.log(e3) / Math.LN10 + 0.01);
            var l2 = Math.max(Math.abs(s2[0]), Math.abs(s2[1])), u2 = Math.floor(Math.log(l2) / Math.LN10 + 0.01), c2 = void 0 === t3.minexponent ? 3 : t3.minexponent;
            Math.abs(u2) > c2 && (yt(t3.exponentformat) && !mt(u2) ? t3._tickexponent = 3 * Math.round((u2 - 1) / 3) : t3._tickexponent = u2);
          } else
            t3._tickround = null;
        }
        function vt(t3, e3, r3) {
          var n3 = t3.tickfont || {};
          return { x: e3, dx: 0, dy: 0, text: r3 || "", fontSize: n3.size, font: n3.family, fontColor: n3.color };
        }
        q2.autoTicks = function(t3, e3, r3) {
          var n3;
          function a2(t4) {
            return Math.pow(t4, Math.floor(Math.log(e3) / Math.LN10));
          }
          if ("date" === t3.type) {
            t3.tick0 = s.dateTick0(t3.calendar, 0);
            var o2 = 2 * e3;
            if (o2 > y)
              e3 /= y, n3 = a2(10), t3.dtick = "M" + 12 * pt(e3, n3, ot);
            else if (o2 > T)
              e3 /= T, t3.dtick = "M" + pt(e3, 1, st);
            else if (o2 > M) {
              if (t3.dtick = pt(e3, M, t3._hasDayOfWeekBreaks ? [1, 2, 7, 14] : ut), !r3) {
                var l2 = q2.getTickFormat(t3), u2 = "period" === t3.ticklabelmode;
                u2 && (t3._rawTick0 = t3.tick0), /%[uVW]/.test(l2) ? t3.tick0 = s.dateTick0(t3.calendar, 2) : t3.tick0 = s.dateTick0(t3.calendar, 1), u2 && (t3._dowTick0 = t3.tick0);
              }
            } else
              o2 > E ? t3.dtick = pt(e3, E, st) : o2 > L ? t3.dtick = pt(e3, L, lt) : o2 > C ? t3.dtick = pt(e3, C, lt) : (n3 = a2(10), t3.dtick = pt(e3, n3, ot));
          } else if ("log" === t3.type) {
            t3.tick0 = 0;
            var c2 = s.simpleMap(t3.range, t3.r2l);
            if (t3._isMinor && (e3 *= 1.5), e3 > 0.7)
              t3.dtick = Math.ceil(e3);
            else if (Math.abs(c2[1] - c2[0]) < 1) {
              var f3 = 1.5 * Math.abs((c2[1] - c2[0]) / e3);
              e3 = Math.abs(Math.pow(10, c2[1]) - Math.pow(10, c2[0])) / f3, n3 = a2(10), t3.dtick = "L" + pt(e3, n3, ot);
            } else
              t3.dtick = e3 > 0.3 ? "D2" : "D1";
          } else
            "category" === t3.type || "multicategory" === t3.type ? (t3.tick0 = 0, t3.dtick = Math.ceil(Math.max(e3, 1))) : It(t3) ? (t3.tick0 = 0, n3 = 1, t3.dtick = pt(e3, n3, ht)) : (t3.tick0 = 0, n3 = a2(10), t3.dtick = pt(e3, n3, ot));
          if (0 === t3.dtick && (t3.dtick = 1), !i(t3.dtick) && "string" != typeof t3.dtick) {
            var h2 = t3.dtick;
            throw t3.dtick = 1, "ax.dtick error: " + String(h2);
          }
        }, q2.tickIncrement = function(t3, e3, r3, a2) {
          var o2 = r3 ? -1 : 1;
          if (i(e3))
            return s.increment(t3, o2 * e3);
          var l2 = e3.charAt(0), u2 = o2 * Number(e3.substr(1));
          if ("M" === l2)
            return s.incrementMonth(t3, u2, a2);
          if ("L" === l2)
            return Math.log(Math.pow(10, t3) + u2) / Math.LN10;
          if ("D" === l2) {
            var c2 = "D2" === e3 ? ft : ct, f3 = t3 + 0.01 * o2, h2 = s.roundUp(s.mod(f3, 1), c2, r3);
            return Math.floor(f3) + Math.log(n2.round(Math.pow(10, h2), 1)) / Math.LN10;
          }
          throw "unrecognized dtick " + String(e3);
        }, q2.tickFirst = function(t3, e3) {
          var r3 = t3.r2l || Number, a2 = s.simpleMap(t3.range, r3, void 0, void 0, e3), o2 = a2[1] < a2[0], l2 = o2 ? Math.floor : Math.ceil, u2 = J(a2)[0], c2 = t3.dtick, f3 = r3(t3.tick0);
          if (i(c2)) {
            var h2 = l2((u2 - f3) / c2) * c2 + f3;
            return "category" !== t3.type && "multicategory" !== t3.type || (h2 = s.constrain(h2, 0, t3._categories.length - 1)), h2;
          }
          var p3 = c2.charAt(0), d3 = Number(c2.substr(1));
          if ("M" === p3) {
            for (var v2, g3, y2, m3 = 0, x2 = f3; m3 < 10; ) {
              if (((v2 = q2.tickIncrement(x2, c2, o2, t3.calendar)) - u2) * (x2 - u2) <= 0)
                return o2 ? Math.min(x2, v2) : Math.max(x2, v2);
              g3 = (u2 - (x2 + v2) / 2) / (v2 - x2), y2 = p3 + (Math.abs(Math.round(g3)) || 1) * d3, x2 = q2.tickIncrement(x2, y2, g3 < 0 ? !o2 : o2, t3.calendar), m3++;
            }
            return s.error("tickFirst did not converge", t3), x2;
          }
          if ("L" === p3)
            return Math.log(l2((Math.pow(10, u2) - f3) / d3) * d3 + f3) / Math.LN10;
          if ("D" === p3) {
            var b2 = "D2" === c2 ? ft : ct, _2 = s.roundUp(s.mod(u2, 1), b2, o2);
            return Math.floor(u2) + Math.log(n2.round(Math.pow(10, _2), 1)) / Math.LN10;
          }
          throw "unrecognized dtick " + String(c2);
        }, q2.tickText = function(t3, e3, r3, n3) {
          var a2, o2 = vt(t3, e3), l2 = "array" === t3.tickmode, u2 = r3 || l2, c2 = t3.type, f3 = "category" === c2 ? t3.d2l_noadd : t3.d2l;
          if (l2 && Array.isArray(t3.ticktext)) {
            var h2 = s.simpleMap(t3.range, t3.r2l), p3 = (Math.abs(h2[1] - h2[0]) - (t3._lBreaks || 0)) / 1e4;
            for (a2 = 0; a2 < t3.ticktext.length && !(Math.abs(e3 - f3(t3.tickvals[a2])) < p3); a2++)
              ;
            if (a2 < t3.ticktext.length)
              return o2.text = String(t3.ticktext[a2]), o2;
          }
          function d3(n4) {
            if (void 0 === n4)
              return true;
            if (r3)
              return "none" === n4;
            var i2 = { first: t3._tmin, last: t3._tmax }[n4];
            return "all" !== n4 && e3 !== i2;
          }
          var v2 = r3 ? "never" : "none" !== t3.exponentformat && d3(t3.showexponent) ? "hide" : "";
          if ("date" === c2 ? function(t4, e4, r4, n4) {
            var a3 = t4._tickround, o3 = r4 && t4.hoverformat || q2.getTickFormat(t4);
            n4 && (a3 = i(a3) ? 4 : { y: "m", m: "d", d: "M", M: "S", S: 4 }[a3]);
            var l3, u3 = s.formatDate(e4.x, o3, a3, t4._dateFormat, t4.calendar, t4._extraFormat), c3 = u3.indexOf("\n");
            if (-1 !== c3 && (l3 = u3.substr(c3 + 1), u3 = u3.substr(0, c3)), n4 && ("00:00:00" === u3 || "00:00" === u3 ? (u3 = l3, l3 = "") : 8 === u3.length && (u3 = u3.replace(/:00$/, ""))), l3)
              if (r4)
                "d" === a3 ? u3 += ", " + l3 : u3 = l3 + (u3 ? ", " + u3 : "");
              else if (t4._inCalcTicks && t4._prevDateHead === l3) {
                var f4 = zt(t4), h3 = t4._trueSide || t4.side;
                (!f4 && "top" === h3 || f4 && "bottom" === h3) && (u3 += "<br> ");
              } else
                t4._prevDateHead = l3, u3 += "<br>" + l3;
            e4.text = u3;
          }(t3, o2, r3, u2) : "log" === c2 ? function(t4, e4, r4, n4, a3) {
            var o3 = t4.dtick, l3 = e4.x, u3 = t4.tickformat, c3 = "string" == typeof o3 && o3.charAt(0);
            if ("never" === a3 && (a3 = ""), n4 && "L" !== c3 && (o3 = "L3", c3 = "L"), u3 || "L" === c3)
              e4.text = xt(Math.pow(10, l3), t4, a3, n4);
            else if (i(o3) || "D" === c3 && s.mod(l3 + 0.01, 1) < 0.1) {
              var f4 = Math.round(l3), h3 = Math.abs(f4), p4 = t4.exponentformat;
              "power" === p4 || yt(p4) && mt(f4) ? (e4.text = 0 === f4 ? 1 : 1 === f4 ? "10" : "10<sup>" + (f4 > 1 ? "" : P) + h3 + "</sup>", e4.fontSize *= 1.25) : ("e" === p4 || "E" === p4) && h3 > 2 ? e4.text = "1" + p4 + (f4 > 0 ? "+" : P) + h3 : (e4.text = xt(Math.pow(10, l3), t4, "", "fakehover"), "D1" === o3 && "y" === t4._id.charAt(0) && (e4.dy -= e4.fontSize / 6));
            } else {
              if ("D" !== c3)
                throw "unrecognized dtick " + String(o3);
              e4.text = String(Math.round(Math.pow(10, s.mod(l3, 1)))), e4.fontSize *= 0.75;
            }
            if ("D1" === t4.dtick) {
              var d4 = String(e4.text).charAt(0);
              "0" !== d4 && "1" !== d4 || ("y" === t4._id.charAt(0) ? e4.dx -= e4.fontSize / 4 : (e4.dy += e4.fontSize / 2, e4.dx += (t4.range[1] > t4.range[0] ? 1 : -1) * e4.fontSize * (l3 < 0 ? 0.5 : 0.25)));
            }
          }(t3, o2, 0, u2, v2) : "category" === c2 ? function(t4, e4) {
            var r4 = t4._categories[Math.round(e4.x)];
            void 0 === r4 && (r4 = ""), e4.text = String(r4);
          }(t3, o2) : "multicategory" === c2 ? function(t4, e4, r4) {
            var n4 = Math.round(e4.x), i2 = t4._categories[n4] || [], a3 = void 0 === i2[1] ? "" : String(i2[1]), o3 = void 0 === i2[0] ? "" : String(i2[0]);
            r4 ? e4.text = o3 + " - " + a3 : (e4.text = a3, e4.text2 = o3);
          }(t3, o2, r3) : It(t3) ? function(t4, e4, r4, n4, i2) {
            if ("radians" !== t4.thetaunit || r4)
              e4.text = xt(e4.x, t4, i2, n4);
            else {
              var a3 = e4.x / 180;
              if (0 === a3)
                e4.text = "0";
              else {
                var o3 = function(t5) {
                  function e5(t6, e6) {
                    return Math.abs(t6 - e6) <= 1e-6;
                  }
                  var r5 = function(t6) {
                    for (var r6 = 1; !e5(Math.round(t6 * r6) / r6, t6); )
                      r6 *= 10;
                    return r6;
                  }(t5), n5 = t5 * r5, i3 = Math.abs(function t6(r6, n6) {
                    return e5(n6, 0) ? r6 : t6(n6, r6 % n6);
                  }(n5, r5));
                  return [Math.round(n5 / i3), Math.round(r5 / i3)];
                }(a3);
                if (o3[1] >= 100)
                  e4.text = xt(s.deg2rad(e4.x), t4, i2, n4);
                else {
                  var l3 = e4.x < 0;
                  1 === o3[1] ? 1 === o3[0] ? e4.text = "π" : e4.text = o3[0] + "π" : e4.text = ["<sup>", o3[0], "</sup>", "⁄", "<sub>", o3[1], "</sub>", "π"].join(""), l3 && (e4.text = P + e4.text);
                }
              }
            }
          }(t3, o2, r3, u2, v2) : function(t4, e4, r4, n4, i2) {
            "never" === i2 ? i2 = "" : "all" === t4.showexponent && Math.abs(e4.x / t4.dtick) < 1e-6 && (i2 = "hide"), e4.text = xt(e4.x, t4, i2, n4);
          }(t3, o2, 0, u2, v2), n3 || (t3.tickprefix && !d3(t3.showtickprefix) && (o2.text = t3.tickprefix + o2.text), t3.ticksuffix && !d3(t3.showticksuffix) && (o2.text += t3.ticksuffix)), t3.labelalias && t3.labelalias.hasOwnProperty(o2.text)) {
            var g3 = t3.labelalias[o2.text];
            "string" == typeof g3 && (o2.text = g3);
          }
          if ("boundaries" === t3.tickson || t3.showdividers) {
            var y2 = function(e4) {
              var r4 = t3.l2p(e4);
              return r4 >= 0 && r4 <= t3._length ? e4 : null;
            };
            o2.xbnd = [y2(o2.x - 0.5), y2(o2.x + t3.dtick - 0.5)];
          }
          return o2;
        }, q2.hoverLabelText = function(t3, e3, r3) {
          r3 && (t3 = s.extendFlat({}, t3, { hoverformat: r3 }));
          var n3 = Array.isArray(e3) ? e3[0] : e3, i2 = Array.isArray(e3) ? e3[1] : void 0;
          if (void 0 !== i2 && i2 !== n3)
            return q2.hoverLabelText(t3, n3, r3) + " - " + q2.hoverLabelText(t3, i2, r3);
          var a2 = "log" === t3.type && n3 <= 0, o2 = q2.tickText(t3, t3.c2l(a2 ? -n3 : n3), "hover").text;
          return a2 ? 0 === n3 ? "0" : P + o2 : o2;
        };
        var gt = ["f", "p", "n", "μ", "m", "", "k", "M", "G", "T"];
        function yt(t3) {
          return "SI" === t3 || "B" === t3;
        }
        function mt(t3) {
          return t3 > 14 || t3 < -15;
        }
        function xt(t3, e3, r3, n3) {
          var a2 = t3 < 0, o2 = e3._tickround, l2 = r3 || e3.exponentformat || "B", u2 = e3._tickexponent, c2 = q2.getTickFormat(e3), f3 = e3.separatethousands;
          if (n3) {
            var h2 = { exponentformat: l2, minexponent: e3.minexponent, dtick: "none" === e3.showexponent ? e3.dtick : i(t3) && Math.abs(t3) || 1, range: "none" === e3.showexponent ? e3.range.map(e3.r2d) : [0, t3 || 1] };
            dt(h2), o2 = (Number(h2._tickround) || 0) + 4, u2 = h2._tickexponent, e3.hoverformat && (c2 = e3.hoverformat);
          }
          if (c2)
            return e3._numFormat(c2)(t3).replace(/-/g, P);
          var p3, d3 = Math.pow(10, -o2) / 2;
          if ("none" === l2 && (u2 = 0), (t3 = Math.abs(t3)) < d3)
            t3 = "0", a2 = false;
          else {
            if (t3 += d3, u2 && (t3 *= Math.pow(10, -u2), o2 += u2), 0 === o2)
              t3 = String(Math.floor(t3));
            else if (o2 < 0) {
              t3 = (t3 = String(Math.round(t3))).substr(0, t3.length + o2);
              for (var v2 = o2; v2 < 0; v2++)
                t3 += "0";
            } else {
              var g3 = (t3 = String(t3)).indexOf(".") + 1;
              g3 && (t3 = t3.substr(0, g3 + o2).replace(/\.?0+$/, ""));
            }
            t3 = s.numSeparate(t3, e3._separators, f3);
          }
          return u2 && "hide" !== l2 && (yt(l2) && mt(u2) && (l2 = "power"), p3 = u2 < 0 ? P + -u2 : "power" !== l2 ? "+" + u2 : String(u2), "e" === l2 || "E" === l2 ? t3 += l2 + p3 : "power" === l2 ? t3 += "×10<sup>" + p3 + "</sup>" : "B" === l2 && 9 === u2 ? t3 += "B" : yt(l2) && (t3 += gt[u2 / 3 + 5])), a2 ? P + t3 : t3;
        }
        function bt(t3, e3) {
          if (t3) {
            var r3 = Object.keys(B).reduce(function(t4, r4) {
              return -1 !== e3.indexOf(r4) && B[r4].forEach(function(e4) {
                t4[e4] = 1;
              }), t4;
            }, {});
            Object.keys(t3).forEach(function(e4) {
              r3[e4] || (1 === e4.length ? t3[e4] = 0 : delete t3[e4]);
            });
          }
        }
        function _t(t3, e3) {
          for (var r3 = [], n3 = {}, i2 = 0; i2 < e3.length; i2++) {
            var a2 = e3[i2];
            n3[a2.text2] ? n3[a2.text2].push(a2.x) : n3[a2.text2] = [a2.x];
          }
          for (var o2 in n3)
            r3.push(vt(t3, s.interp(n3[o2], 0.5), o2));
          return r3;
        }
        function wt(t3) {
          return void 0 !== t3.periodX ? t3.periodX : t3.x;
        }
        function Tt(t3) {
          return [t3.text, t3.x, t3.axInfo, t3.font, t3.fontSize, t3.fontColor].join("_");
        }
        function kt(t3) {
          var e3 = t3.title.font.size, r3 = (t3.title.text.match(u.BR_TAG_ALL) || []).length;
          return t3.title.hasOwnProperty("standoff") ? r3 ? e3 * (U + r3 * V) : e3 * U : r3 ? e3 * (r3 + 1) * V : e3;
        }
        function At(t3, e3) {
          var r3 = t3.l2p(e3);
          return r3 > 1 && r3 < t3._length - 1;
        }
        function Mt(t3) {
          var e3 = n2.select(t3), r3 = e3.select(".text-math-group");
          return r3.empty() ? e3.select("text") : r3;
        }
        function St(t3) {
          return t3._id + ".automargin";
        }
        function Et(t3) {
          return St(t3) + ".mirror";
        }
        function Lt(t3) {
          return t3._id + ".rangeslider";
        }
        function Ct(t3, e3) {
          for (var r3 = 0; r3 < e3.length; r3++)
            -1 === t3.indexOf(e3[r3]) && t3.push(e3[r3]);
        }
        function Pt(t3, e3, r3) {
          var n3, i2, a2 = [], o2 = [], l2 = t3.layout;
          for (n3 = 0; n3 < e3.length; n3++)
            a2.push(q2.getFromId(t3, e3[n3]));
          for (n3 = 0; n3 < r3.length; n3++)
            o2.push(q2.getFromId(t3, r3[n3]));
          var u2 = Object.keys(p2), c2 = ["anchor", "domain", "overlaying", "position", "side", "tickangle", "editType"], f3 = ["linear", "log"];
          for (n3 = 0; n3 < u2.length; n3++) {
            var h2 = u2[n3], d3 = a2[0][h2], v2 = o2[0][h2], g3 = true, y2 = false, m3 = false;
            if ("_" !== h2.charAt(0) && "function" != typeof d3 && -1 === c2.indexOf(h2)) {
              for (i2 = 1; i2 < a2.length && g3; i2++) {
                var x2 = a2[i2][h2];
                "type" === h2 && -1 !== f3.indexOf(d3) && -1 !== f3.indexOf(x2) && d3 !== x2 ? y2 = true : x2 !== d3 && (g3 = false);
              }
              for (i2 = 1; i2 < o2.length && g3; i2++) {
                var b2 = o2[i2][h2];
                "type" === h2 && -1 !== f3.indexOf(v2) && -1 !== f3.indexOf(b2) && v2 !== b2 ? m3 = true : o2[i2][h2] !== v2 && (g3 = false);
              }
              g3 && (y2 && (l2[a2[0]._name].type = "linear"), m3 && (l2[o2[0]._name].type = "linear"), Ot(l2, h2, a2, o2, t3._fullLayout._dfltTitle));
            }
          }
          for (n3 = 0; n3 < t3._fullLayout.annotations.length; n3++) {
            var _2 = t3._fullLayout.annotations[n3];
            -1 !== e3.indexOf(_2.xref) && -1 !== r3.indexOf(_2.yref) && s.swapAttrs(l2.annotations[n3], ["?"]);
          }
        }
        function Ot(t3, e3, r3, n3, i2) {
          var a2, o2 = s.nestedProperty, l2 = o2(t3[r3[0]._name], e3).get(), u2 = o2(t3[n3[0]._name], e3).get();
          for ("title" === e3 && (l2 && l2.text === i2.x && (l2.text = i2.y), u2 && u2.text === i2.y && (u2.text = i2.x)), a2 = 0; a2 < r3.length; a2++)
            o2(t3, r3[a2]._name + "." + e3).set(u2);
          for (a2 = 0; a2 < n3.length; a2++)
            o2(t3, n3[a2]._name + "." + e3).set(l2);
        }
        function It(t3) {
          return "angularaxis" === t3._id;
        }
        function Dt(t3, e3) {
          for (var r3 = e3._rangebreaks.length, n3 = 0; n3 < r3; n3++) {
            var i2 = e3._rangebreaks[n3];
            if (t3 >= i2.min && t3 < i2.max)
              return i2.max;
          }
          return t3;
        }
        function zt(t3) {
          return -1 !== (t3.ticklabelposition || "").indexOf("inside");
        }
        function Rt(t3, e3) {
          zt(t3._anchorAxis || {}) && t3._hideCounterAxisInsideTickLabels && t3._hideCounterAxisInsideTickLabels(e3);
        }
        function Ft(t3, e3, r3, n3) {
          var i2, a2 = "free" === t3.anchor || void 0 !== t3.overlaying && false !== t3.overlaying ? t3.overlaying : t3._id;
          i2 = n3 ? "right" === t3.side ? e3 : -e3 : e3, a2 in r3 || (r3[a2] = {}), t3.side in r3[a2] || (r3[a2][t3.side] = 0), r3[a2][t3.side] += i2;
        }
        q2.getTickFormat = function(t3) {
          var e3, r3, n3, i2, a2, o2, s2, l2;
          function u2(t4) {
            return "string" != typeof t4 ? t4 : Number(t4.replace("M", "")) * T;
          }
          function c2(t4, e4) {
            var r4 = ["L", "D"];
            if (typeof t4 == typeof e4) {
              if ("number" == typeof t4)
                return t4 - e4;
              var n4 = r4.indexOf(t4.charAt(0)), i3 = r4.indexOf(e4.charAt(0));
              return n4 === i3 ? Number(t4.replace(/(L|D)/g, "")) - Number(e4.replace(/(L|D)/g, "")) : n4 - i3;
            }
            return "number" == typeof t4 ? 1 : -1;
          }
          function f3(t4, e4) {
            var r4 = null === e4[0], n4 = null === e4[1], i3 = c2(t4, e4[0]) >= 0, a3 = c2(t4, e4[1]) <= 0;
            return (r4 || i3) && (n4 || a3);
          }
          if (t3.tickformatstops && t3.tickformatstops.length > 0)
            switch (t3.type) {
              case "date":
              case "linear":
                for (e3 = 0; e3 < t3.tickformatstops.length; e3++)
                  if ((n3 = t3.tickformatstops[e3]).enabled && (i2 = t3.dtick, a2 = n3.dtickrange, o2 = void 0, s2 = void 0, l2 = void 0, o2 = u2 || function(t4) {
                    return t4;
                  }, s2 = a2[0], l2 = a2[1], (!s2 && "number" != typeof s2 || o2(s2) <= o2(i2)) && (!l2 && "number" != typeof l2 || o2(l2) >= o2(i2)))) {
                    r3 = n3;
                    break;
                  }
                break;
              case "log":
                for (e3 = 0; e3 < t3.tickformatstops.length; e3++)
                  if ((n3 = t3.tickformatstops[e3]).enabled && f3(t3.dtick, n3.dtickrange)) {
                    r3 = n3;
                    break;
                  }
            }
          return r3 ? r3.value : t3.tickformat;
        }, q2.getSubplots = function(t3, e3) {
          var r3 = t3._fullLayout._subplots, n3 = r3.cartesian.concat(r3.gl2d || []), i2 = e3 ? q2.findSubplotsWithAxis(n3, e3) : n3;
          return i2.sort(function(t4, e4) {
            var r4 = t4.substr(1).split("y"), n4 = e4.substr(1).split("y");
            return r4[0] === n4[0] ? +r4[1] - +n4[1] : +r4[0] - +n4[0];
          }), i2;
        }, q2.findSubplotsWithAxis = function(t3, e3) {
          for (var r3 = new RegExp("x" === e3._id.charAt(0) ? "^" + e3._id + "y" : e3._id + "$"), n3 = [], i2 = 0; i2 < t3.length; i2++) {
            var a2 = t3[i2];
            r3.test(a2) && n3.push(a2);
          }
          return n3;
        }, q2.makeClipPaths = function(t3) {
          var e3 = t3._fullLayout;
          if (!e3._hasOnlyLargeSploms) {
            var r3, i2, a2 = { _offset: 0, _length: e3.width, _id: "" }, o2 = { _offset: 0, _length: e3.height, _id: "" }, s2 = q2.list(t3, "x", true), l2 = q2.list(t3, "y", true), u2 = [];
            for (r3 = 0; r3 < s2.length; r3++)
              for (u2.push({ x: s2[r3], y: o2 }), i2 = 0; i2 < l2.length; i2++)
                0 === r3 && u2.push({ x: a2, y: l2[i2] }), u2.push({ x: s2[r3], y: l2[i2] });
            var c2 = e3._clips.selectAll(".axesclip").data(u2, function(t4) {
              return t4.x._id + t4.y._id;
            });
            c2.enter().append("clipPath").classed("axesclip", true).attr("id", function(t4) {
              return "clip" + e3._uid + t4.x._id + t4.y._id;
            }).append("rect"), c2.exit().remove(), c2.each(function(t4) {
              n2.select(this).select("rect").attr({ x: t4.x._offset || 0, y: t4.y._offset || 0, width: t4.x._length || 1, height: t4.y._length || 1 });
            });
          }
        }, q2.draw = function(t3, e3, r3) {
          var n3 = t3._fullLayout;
          "redraw" === e3 && n3._paper.selectAll("g.subplot").each(function(t4) {
            var e4 = t4[0], r4 = n3._plots[e4];
            if (r4) {
              var i3 = r4.xaxis, a3 = r4.yaxis;
              r4.xaxislayer.selectAll("." + i3._id + "tick").remove(), r4.yaxislayer.selectAll("." + a3._id + "tick").remove(), r4.xaxislayer.selectAll("." + i3._id + "tick2").remove(), r4.yaxislayer.selectAll("." + a3._id + "tick2").remove(), r4.xaxislayer.selectAll("." + i3._id + "divider").remove(), r4.yaxislayer.selectAll("." + a3._id + "divider").remove(), r4.minorGridlayer && r4.minorGridlayer.selectAll("path").remove(), r4.gridlayer && r4.gridlayer.selectAll("path").remove(), r4.zerolinelayer && r4.zerolinelayer.selectAll("path").remove(), n3._infolayer.select(".g-" + i3._id + "title").remove(), n3._infolayer.select(".g-" + a3._id + "title").remove();
            }
          });
          var i2 = e3 && "redraw" !== e3 ? e3 : q2.listIds(t3), a2 = q2.list(t3).filter(function(t4) {
            return t4.autoshift;
          }).map(function(t4) {
            return t4.overlaying;
          });
          i2.map(function(e4) {
            var r4 = q2.getFromId(t3, e4);
            if ("sync" === r4.tickmode && r4.overlaying) {
              var n4 = i2.findIndex(function(t4) {
                return t4 === r4.overlaying;
              });
              n4 >= 0 && i2.unshift(i2.splice(n4, 1).shift());
            }
          });
          var o2 = { false: { left: 0, right: 0 } };
          return s.syncOrAsync(i2.map(function(e4) {
            return function() {
              if (e4) {
                var n4 = q2.getFromId(t3, e4);
                r3 || (r3 = {}), r3.axShifts = o2, r3.overlayingShiftedAx = a2;
                var i3 = q2.drawOne(t3, n4, r3);
                return n4._shiftPusher && Ft(n4, n4._fullDepth || 0, o2, true), n4._r = n4.range.slice(), n4._rl = s.simpleMap(n4._r, n4.r2l), i3;
              }
            };
          }));
        }, q2.drawOne = function(t3, e3, r3) {
          var n3, i2, l2, u2 = (r3 = r3 || {}).axShifts || {}, p3 = r3.overlayingShiftedAx || [];
          e3.setScale();
          var d3 = t3._fullLayout, v2 = e3._id, g3 = v2.charAt(0), y2 = q2.counterLetter(v2), m3 = d3._plots[e3._mainSubplot];
          if (m3) {
            if (e3._shiftPusher = e3.autoshift || -1 !== p3.indexOf(e3._id) || -1 !== p3.indexOf(e3.overlaying), e3._shiftPusher & "free" === e3.anchor) {
              var x2 = e3.linewidth / 2 || 0;
              "inside" === e3.ticks && (x2 += e3.ticklen), Ft(e3, x2, u2, true), Ft(e3, e3.shift || 0, u2, false);
            }
            true === r3.skipTitle && void 0 !== e3._shift || (e3._shift = function(t4, e4) {
              return t4.autoshift ? e4[t4.overlaying][t4.side] : t4.shift || 0;
            }(e3, u2));
            var b2 = m3[g3 + "axislayer"], _2 = e3._mainLinePosition, w3 = _2 += e3._shift, T2 = e3._mainMirrorPosition, k2 = e3._vals = q2.calcTicks(e3), A2 = [e3.mirror, w3, T2].join("_");
            for (n3 = 0; n3 < k2.length; n3++)
              k2[n3].axInfo = A2;
            e3._selections = {}, e3._tickAngles && (e3._prevTickAngles = e3._tickAngles), e3._tickAngles = {}, e3._depth = null;
            var M2 = {};
            if (e3.visible) {
              var S2, E2, L2 = q2.makeTransTickFn(e3), C2 = q2.makeTransTickLabelFn(e3), P2 = "inside" === e3.ticks, O2 = "outside" === e3.ticks;
              if ("boundaries" === e3.tickson) {
                var I2 = function(t4, e4) {
                  var r4, n4 = [], i3 = function(t5, e5) {
                    var r5 = t5.xbnd[e5];
                    null !== r5 && n4.push(s.extendFlat({}, t5, { x: r5 }));
                  };
                  if (e4.length) {
                    for (r4 = 0; r4 < e4.length; r4++)
                      i3(e4[r4], 0);
                    i3(e4[r4 - 1], 1);
                  }
                  return n4;
                }(0, k2);
                E2 = q2.clipEnds(e3, I2), S2 = P2 ? E2 : I2;
              } else
                E2 = q2.clipEnds(e3, k2), S2 = P2 && "period" !== e3.ticklabelmode ? E2 : k2;
              var D2, z2 = e3._gridVals = E2, R2 = function(t4, e4) {
                var r4, n4, i3 = [], a2 = e4.length && e4[e4.length - 1].x < e4[0].x, o2 = function(t5, e5) {
                  var r5 = t5.xbnd[e5];
                  null !== r5 && i3.push(s.extendFlat({}, t5, { x: r5 }));
                };
                if (t4.showdividers && e4.length) {
                  for (r4 = 0; r4 < e4.length; r4++) {
                    var l3 = e4[r4];
                    l3.text2 !== n4 && o2(l3, a2 ? 1 : 0), n4 = l3.text2;
                  }
                  o2(e4[r4 - 1], a2 ? 0 : 1);
                }
                return i3;
              }(e3, k2);
              if (!d3._hasOnlyLargeSploms) {
                var F2 = e3._subplotsWith, B2 = {};
                for (n3 = 0; n3 < F2.length; n3++) {
                  i2 = F2[n3];
                  var N2 = (l2 = d3._plots[i2])[y2 + "axis"], j2 = N2._mainAxis._id;
                  if (!B2[j2]) {
                    B2[j2] = 1;
                    var U2 = "x" === g3 ? "M0," + N2._offset + "v" + N2._length : "M" + N2._offset + ",0h" + N2._length;
                    q2.drawGrid(t3, e3, { vals: z2, counterAxis: N2, layer: l2.gridlayer.select("." + v2), minorLayer: l2.minorGridlayer.select("." + v2), path: U2, transFn: L2 }), q2.drawZeroLine(t3, e3, { counterAxis: N2, layer: l2.zerolinelayer, path: U2, transFn: L2 });
                  }
                }
              }
              var G2 = q2.getTickSigns(e3), Z2 = q2.getTickSigns(e3, "minor");
              if (e3.ticks || e3.minor && e3.minor.ticks) {
                var Y2, W2, X2, J2, K2 = q2.makeTickPath(e3, w3, G2[2]), $2 = q2.makeTickPath(e3, w3, Z2[2], { minor: true });
                if (e3._anchorAxis && e3.mirror && true !== e3.mirror ? (Y2 = q2.makeTickPath(e3, T2, G2[3]), W2 = q2.makeTickPath(e3, T2, Z2[3], { minor: true }), X2 = K2 + Y2, J2 = $2 + W2) : (Y2 = "", W2 = "", X2 = K2, J2 = $2), e3.showdividers && O2 && "boundaries" === e3.tickson) {
                  var Q2 = {};
                  for (n3 = 0; n3 < R2.length; n3++)
                    Q2[R2[n3].x] = 1;
                  D2 = function(t4) {
                    return Q2[t4.x] ? Y2 : X2;
                  };
                } else
                  D2 = function(t4) {
                    return t4.minor ? J2 : X2;
                  };
              }
              if (q2.drawTicks(t3, e3, { vals: S2, layer: b2, path: D2, transFn: L2 }), "allticks" === e3.mirror) {
                var tt2 = Object.keys(e3._linepositions || {});
                for (n3 = 0; n3 < tt2.length; n3++) {
                  i2 = tt2[n3], l2 = d3._plots[i2];
                  var et2 = e3._linepositions[i2] || [], rt2 = et2[0], nt2 = et2[1], it2 = et2[2], at2 = q2.makeTickPath(e3, rt2, it2 ? G2[0] : Z2[0], { minor: it2 }) + q2.makeTickPath(e3, nt2, it2 ? G2[1] : Z2[1], { minor: it2 });
                  q2.drawTicks(t3, e3, { vals: S2, layer: l2[g3 + "axislayer"], path: at2, transFn: L2 });
                }
              }
              var ot2 = [];
              if (ot2.push(function() {
                return q2.drawLabels(t3, e3, { vals: k2, layer: b2, plotinfo: l2, transFn: C2, labelFns: q2.makeLabelFns(e3, w3) });
              }), "multicategory" === e3.type) {
                var st2 = { x: 2, y: 10 }[g3];
                ot2.push(function() {
                  var r4 = { x: "height", y: "width" }[g3], n4 = ut2()[r4] + st2 + (e3._tickAngles[v2 + "tick"] ? e3.tickfont.size * V : 0);
                  return q2.drawLabels(t3, e3, { vals: _t(e3, k2), layer: b2, cls: v2 + "tick2", repositionOnUpdate: true, secondary: true, transFn: L2, labelFns: q2.makeLabelFns(e3, w3 + n4 * G2[4]) });
                }), ot2.push(function() {
                  return e3._depth = G2[4] * (ut2("tick2")[e3.side] - w3), function(t4, e4, r4) {
                    var n4 = e4._id + "divider", i3 = r4.vals, a2 = r4.layer.selectAll("path." + n4).data(i3, Tt);
                    a2.exit().remove(), a2.enter().insert("path", ":first-child").classed(n4, 1).classed("crisp", 1).call(f2.stroke, e4.dividercolor).style("stroke-width", h.crispRound(t4, e4.dividerwidth, 1) + "px"), a2.attr("transform", r4.transFn).attr("d", r4.path);
                  }(t3, e3, { vals: R2, layer: b2, path: q2.makeTickPath(e3, w3, G2[4], { len: e3._depth }), transFn: L2 });
                });
              } else
                e3.title.hasOwnProperty("standoff") && ot2.push(function() {
                  e3._depth = G2[4] * (ut2()[e3.side] - w3);
                });
              var lt2 = o.getComponentMethod("rangeslider", "isVisible")(e3);
              return r3.skipTitle || lt2 && "bottom" === e3.side || ot2.push(function() {
                return function(t4, e4) {
                  var r4, n4 = t4._fullLayout, i3 = e4._id, a2 = i3.charAt(0), o2 = e4.title.font.size;
                  if (e4.title.hasOwnProperty("standoff"))
                    r4 = e4._depth + e4.title.standoff + kt(e4);
                  else {
                    var s2 = zt(e4);
                    if ("multicategory" === e4.type)
                      r4 = e4._depth;
                    else {
                      var l3 = 1.5 * o2;
                      s2 && (l3 = 0.5 * o2, "outside" === e4.ticks && (l3 += e4.ticklen)), r4 = 10 + l3 + (e4.linewidth ? e4.linewidth - 1 : 0);
                    }
                    s2 || (r4 += "x" === a2 ? "top" === e4.side ? o2 * (e4.showticklabels ? 1 : 0) : o2 * (e4.showticklabels ? 1.5 : 0.5) : "right" === e4.side ? o2 * (e4.showticklabels ? 1 : 0.5) : o2 * (e4.showticklabels ? 0.5 : 0));
                  }
                  var u3, f3, p4, d4, v3 = q2.getPxPosition(t4, e4);
                  if ("x" === a2 ? (f3 = e4._offset + e4._length / 2, p4 = "top" === e4.side ? v3 - r4 : v3 + r4) : (p4 = e4._offset + e4._length / 2, f3 = "right" === e4.side ? v3 + r4 : v3 - r4, u3 = { rotate: "-90", offset: 0 }), "multicategory" !== e4.type) {
                    var g4 = e4._selections[e4._id + "tick"];
                    if (d4 = { selection: g4, side: e4.side }, g4 && g4.node() && g4.node().parentNode) {
                      var y3 = h.getTranslate(g4.node().parentNode);
                      d4.offsetLeft = y3.x, d4.offsetTop = y3.y;
                    }
                    e4.title.hasOwnProperty("standoff") && (d4.pad = 0);
                  }
                  return e4._titleStandoff = r4, c.draw(t4, i3 + "title", { propContainer: e4, propName: e4._name + ".title.text", placeholder: n4._dfltTitle[a2], avoid: d4, transform: u3, attributes: { x: f3, y: p4, "text-anchor": "middle" } });
                }(t3, e3);
              }), ot2.push(function() {
                var r4, n4, i3, s2, l3 = e3.side.charAt(0), u3 = H[e3.side].charAt(0), c2 = q2.getPxPosition(t3, e3), f3 = O2 ? e3.ticklen : 0;
                (e3.automargin || lt2 || e3._shiftPusher) && ("multicategory" === e3.type ? r4 = ut2("tick2") : (r4 = ut2(), "x" === g3 && "b" === l3 && (e3._depth = Math.max(r4.width > 0 ? r4.bottom - c2 : 0, f3))));
                var h2 = 0, p4 = 0;
                if (e3._shiftPusher && (h2 = Math.max(f3, r4.height > 0 ? "l" === l3 ? c2 - r4.left : r4.right - c2 : 0), e3.title.text !== d3._dfltTitle[g3] && (p4 = (e3._titleStandoff || 0) + (e3._titleScoot || 0), "l" === l3 && (p4 += kt(e3))), e3._fullDepth = Math.max(h2, p4)), e3.automargin) {
                  n4 = { x: 0, y: 0, r: 0, l: 0, t: 0, b: 0 };
                  var v3 = [0, 1], m4 = "number" == typeof e3._shift ? e3._shift : 0;
                  if ("x" === g3) {
                    if ("b" === l3 ? n4[l3] = e3._depth : (n4[l3] = e3._depth = Math.max(r4.width > 0 ? c2 - r4.top : 0, f3), v3.reverse()), r4.width > 0) {
                      var x3 = r4.right - (e3._offset + e3._length);
                      x3 > 0 && (n4.xr = 1, n4.r = x3);
                      var b3 = e3._offset - r4.left;
                      b3 > 0 && (n4.xl = 0, n4.l = b3);
                    }
                  } else if ("l" === l3 ? (e3._depth = Math.max(r4.height > 0 ? c2 - r4.left : 0, f3), n4[l3] = e3._depth - m4) : (e3._depth = Math.max(r4.height > 0 ? r4.right - c2 : 0, f3), n4[l3] = e3._depth + m4, v3.reverse()), r4.height > 0) {
                    var _3 = r4.bottom - (e3._offset + e3._length);
                    _3 > 0 && (n4.yb = 0, n4.b = _3);
                    var w4 = e3._offset - r4.top;
                    w4 > 0 && (n4.yt = 1, n4.t = w4);
                  }
                  n4[y2] = "free" === e3.anchor ? e3.position : e3._anchorAxis.domain[v3[0]], e3.title.text !== d3._dfltTitle[g3] && (n4[l3] += kt(e3) + (e3.title.standoff || 0)), e3.mirror && "free" !== e3.anchor && ((i3 = { x: 0, y: 0, r: 0, l: 0, t: 0, b: 0 })[u3] = e3.linewidth, e3.mirror && true !== e3.mirror && (i3[u3] += f3), true === e3.mirror || "ticks" === e3.mirror ? i3[y2] = e3._anchorAxis.domain[v3[1]] : "all" !== e3.mirror && "allticks" !== e3.mirror || (i3[y2] = [e3._counterDomainMin, e3._counterDomainMax][v3[1]]));
                }
                lt2 && (s2 = o.getComponentMethod("rangeslider", "autoMarginOpts")(t3, e3)), "string" == typeof e3.automargin && (bt(n4, e3.automargin), bt(i3, e3.automargin)), a.autoMargin(t3, St(e3), n4), a.autoMargin(t3, Et(e3), i3), a.autoMargin(t3, Lt(e3), s2);
              }), s.syncOrAsync(ot2);
            }
          }
          function ut2(t4) {
            var r4 = v2 + (t4 || "tick");
            return M2[r4] || (M2[r4] = function(t5, e4) {
              var r5, n4, i3, a2;
              return t5._selections[e4].size() ? (r5 = 1 / 0, n4 = -1 / 0, i3 = 1 / 0, a2 = -1 / 0, t5._selections[e4].each(function() {
                var t6 = Mt(this), e5 = h.bBox(t6.node().parentNode);
                r5 = Math.min(r5, e5.top), n4 = Math.max(n4, e5.bottom), i3 = Math.min(i3, e5.left), a2 = Math.max(a2, e5.right);
              })) : (r5 = 0, n4 = 0, i3 = 0, a2 = 0), { top: r5, bottom: n4, left: i3, right: a2, height: n4 - r5, width: a2 - i3 };
            }(e3, r4)), M2[r4];
          }
        }, q2.getTickSigns = function(t3, e3) {
          var r3 = t3._id.charAt(0), n3 = { x: "top", y: "right" }[r3], i2 = t3.side === n3 ? 1 : -1, a2 = [-1, 1, i2, -i2];
          return "inside" !== (e3 ? (t3.minor || {}).ticks : t3.ticks) == ("x" === r3) && (a2 = a2.map(function(t4) {
            return -t4;
          })), t3.side && a2.push({ l: -1, t: -1, r: 1, b: 1 }[t3.side.charAt(0)]), a2;
        }, q2.makeTransTickFn = function(t3) {
          return "x" === t3._id.charAt(0) ? function(e3) {
            return l(t3._offset + t3.l2p(e3.x), 0);
          } : function(e3) {
            return l(0, t3._offset + t3.l2p(e3.x));
          };
        }, q2.makeTransTickLabelFn = function(t3) {
          var e3 = function(t4) {
            var e4 = t4.ticklabelposition || "", r4 = function(t5) {
              return -1 !== e4.indexOf(t5);
            }, n4 = r4("top"), i2 = r4("left"), a2 = r4("right"), o2 = r4("bottom"), s2 = r4("inside"), l2 = o2 || i2 || n4 || a2;
            if (!l2 && !s2)
              return [0, 0];
            var u2 = t4.side, c2 = l2 ? (t4.tickwidth || 0) / 2 : 0, f3 = 3, h2 = t4.tickfont ? t4.tickfont.size : 12;
            return (o2 || n4) && (c2 += h2 * U, f3 += (t4.linewidth || 0) / 2), (i2 || a2) && (c2 += (t4.linewidth || 0) / 2, f3 += 3), s2 && "top" === u2 && (f3 -= h2 * (1 - U)), (i2 || n4) && (c2 = -c2), "bottom" !== u2 && "right" !== u2 || (f3 = -f3), [l2 ? c2 : 0, s2 ? f3 : 0];
          }(t3), r3 = e3[0], n3 = e3[1];
          return "x" === t3._id.charAt(0) ? function(e4) {
            return l(r3 + t3._offset + t3.l2p(wt(e4)), n3);
          } : function(e4) {
            return l(n3, r3 + t3._offset + t3.l2p(wt(e4)));
          };
        }, q2.makeTickPath = function(t3, e3, r3, n3) {
          n3 || (n3 = {});
          var i2 = n3.minor;
          if (i2 && !t3.minor)
            return "";
          var a2 = void 0 !== n3.len ? n3.len : i2 ? t3.minor.ticklen : t3.ticklen, o2 = t3._id.charAt(0), s2 = (t3.linewidth || 1) / 2;
          return "x" === o2 ? "M0," + (e3 + s2 * r3) + "v" + a2 * r3 : "M" + (e3 + s2 * r3) + ",0h" + a2 * r3;
        }, q2.makeLabelFns = function(t3, e3, r3) {
          var n3 = t3.ticklabelposition || "", a2 = function(t4) {
            return -1 !== n3.indexOf(t4);
          }, o2 = a2("top"), l2 = a2("left"), u2 = a2("right"), c2 = a2("bottom") || l2 || o2 || u2, f3 = a2("inside"), h2 = "inside" === n3 && "inside" === t3.ticks || !f3 && "outside" === t3.ticks && "boundaries" !== t3.tickson, p3 = 0, d3 = 0, v2 = h2 ? t3.ticklen : 0;
          if (f3 ? v2 *= -1 : c2 && (v2 = 0), h2 && (p3 += v2, r3)) {
            var g3 = s.deg2rad(r3);
            p3 = v2 * Math.cos(g3) + 1, d3 = v2 * Math.sin(g3);
          }
          t3.showticklabels && (h2 || t3.showline) && (p3 += 0.2 * t3.tickfont.size);
          var y2, m3, x2, b2, _2, w3 = { labelStandoff: p3 += (t3.linewidth || 1) / 2 * (f3 ? -1 : 1), labelShift: d3 }, T2 = 0, k2 = t3.side, A2 = t3._id.charAt(0), M2 = t3.tickangle;
          if ("x" === A2)
            b2 = (_2 = !f3 && "bottom" === k2 || f3 && "top" === k2) ? 1 : -1, f3 && (b2 *= -1), y2 = d3 * b2, m3 = e3 + p3 * b2, x2 = _2 ? 1 : -0.2, 90 === Math.abs(M2) && (f3 ? x2 += j : x2 = -90 === M2 && "bottom" === k2 ? U : 90 === M2 && "top" === k2 ? j : 0.5, T2 = j / 2 * (M2 / 90)), w3.xFn = function(t4) {
              return t4.dx + y2 + T2 * t4.fontSize;
            }, w3.yFn = function(t4) {
              return t4.dy + m3 + t4.fontSize * x2;
            }, w3.anchorFn = function(t4, e4) {
              if (c2) {
                if (l2)
                  return "end";
                if (u2)
                  return "start";
              }
              return i(e4) && 0 !== e4 && 180 !== e4 ? e4 * b2 < 0 !== f3 ? "end" : "start" : "middle";
            }, w3.heightFn = function(e4, r4, n4) {
              return r4 < -60 || r4 > 60 ? -0.5 * n4 : "top" === t3.side !== f3 ? -n4 : 0;
            };
          else if ("y" === A2) {
            if (b2 = (_2 = !f3 && "left" === k2 || f3 && "right" === k2) ? 1 : -1, f3 && (b2 *= -1), y2 = p3, m3 = d3 * b2, x2 = 0, f3 || 90 !== Math.abs(M2) || (x2 = -90 === M2 && "left" === k2 || 90 === M2 && "right" === k2 ? U : 0.5), f3) {
              var S2 = i(M2) ? +M2 : 0;
              if (0 !== S2) {
                var E2 = s.deg2rad(S2);
                T2 = Math.abs(Math.sin(E2)) * U * b2, x2 = 0;
              }
            }
            w3.xFn = function(t4) {
              return t4.dx + e3 - (y2 + t4.fontSize * x2) * b2 + T2 * t4.fontSize;
            }, w3.yFn = function(t4) {
              return t4.dy + m3 + t4.fontSize * j;
            }, w3.anchorFn = function(t4, e4) {
              return i(e4) && 90 === Math.abs(e4) ? "middle" : _2 ? "end" : "start";
            }, w3.heightFn = function(e4, r4, n4) {
              return "right" === t3.side && (r4 *= -1), r4 < -30 ? -n4 : r4 < 30 ? -0.5 * n4 : 0;
            };
          }
          return w3;
        }, q2.drawTicks = function(t3, e3, r3) {
          r3 = r3 || {};
          var i2 = e3._id + "tick", a2 = [].concat(e3.minor && e3.minor.ticks ? r3.vals.filter(function(t4) {
            return t4.minor && !t4.noTick;
          }) : []).concat(e3.ticks ? r3.vals.filter(function(t4) {
            return !t4.minor && !t4.noTick;
          }) : []), o2 = r3.layer.selectAll("path." + i2).data(a2, Tt);
          o2.exit().remove(), o2.enter().append("path").classed(i2, 1).classed("ticks", 1).classed("crisp", false !== r3.crisp).each(function(t4) {
            return f2.stroke(n2.select(this), t4.minor ? e3.minor.tickcolor : e3.tickcolor);
          }).style("stroke-width", function(r4) {
            return h.crispRound(t3, r4.minor ? e3.minor.tickwidth : e3.tickwidth, 1) + "px";
          }).attr("d", r3.path).style("display", null), Rt(e3, [R]), o2.attr("transform", r3.transFn);
        }, q2.drawGrid = function(t3, e3, r3) {
          if (r3 = r3 || {}, "sync" !== e3.tickmode) {
            var i2 = e3._id + "grid", a2 = e3.minor && e3.minor.showgrid, o2 = a2 ? r3.vals.filter(function(t4) {
              return t4.minor;
            }) : [], s2 = e3.showgrid ? r3.vals.filter(function(t4) {
              return !t4.minor;
            }) : [], l2 = r3.counterAxis;
            if (l2 && q2.shouldShowZeroLine(t3, e3, l2))
              for (var u2 = "array" === e3.tickmode, c2 = 0; c2 < s2.length; c2++) {
                var p3 = s2[c2].x;
                if (u2 ? !p3 : Math.abs(p3) < e3.dtick / 100) {
                  if (s2 = s2.slice(0, c2).concat(s2.slice(c2 + 1)), !u2)
                    break;
                  c2--;
                }
              }
            e3._gw = h.crispRound(t3, e3.gridwidth, 1);
            for (var d3 = a2 ? h.crispRound(t3, e3.minor.gridwidth, 1) : 0, v2 = r3.layer, g3 = r3.minorLayer, y2 = 1; y2 >= 0; y2--) {
              var m3 = y2 ? v2 : g3;
              if (m3) {
                var x2 = m3.selectAll("path." + i2).data(y2 ? s2 : o2, Tt);
                x2.exit().remove(), x2.enter().append("path").classed(i2, 1).classed("crisp", false !== r3.crisp), x2.attr("transform", r3.transFn).attr("d", r3.path).each(function(t4) {
                  return f2.stroke(n2.select(this), t4.minor ? e3.minor.gridcolor : e3.gridcolor || "#ddd");
                }).style("stroke-dasharray", function(t4) {
                  return h.dashStyle(t4.minor ? e3.minor.griddash : e3.griddash, t4.minor ? e3.minor.gridwidth : e3.gridwidth);
                }).style("stroke-width", function(t4) {
                  return (t4.minor ? d3 : e3._gw) + "px";
                }).style("display", null), "function" == typeof r3.path && x2.attr("d", r3.path);
              }
            }
            Rt(e3, [D, z]);
          }
        }, q2.drawZeroLine = function(t3, e3, r3) {
          r3 = r3 || r3;
          var n3 = e3._id + "zl", i2 = q2.shouldShowZeroLine(t3, e3, r3.counterAxis), a2 = r3.layer.selectAll("path." + n3).data(i2 ? [{ x: 0, id: e3._id }] : []);
          a2.exit().remove(), a2.enter().append("path").classed(n3, 1).classed("zl", 1).classed("crisp", false !== r3.crisp).each(function() {
            r3.layer.selectAll("path").sort(function(t4, e4) {
              return Y(t4.id, e4.id);
            });
          }), a2.attr("transform", r3.transFn).attr("d", r3.path).call(f2.stroke, e3.zerolinecolor || f2.defaultLine).style("stroke-width", h.crispRound(t3, e3.zerolinewidth, e3._gw || 1) + "px").style("display", null), Rt(e3, [I]);
        }, q2.drawLabels = function(t3, e3, r3) {
          r3 = r3 || {};
          var a2 = t3._fullLayout, o2 = e3._id, c2 = o2.charAt(0), f3 = r3.cls || o2 + "tick", p3 = r3.vals.filter(function(t4) {
            return t4.text;
          }), d3 = r3.labelFns, v2 = r3.secondary ? 0 : e3.tickangle, g3 = (e3._prevTickAngles || {})[f3], y2 = r3.layer.selectAll("g." + f3).data(e3.showticklabels ? p3 : [], Tt), m3 = [];
          function x2(t4, a3) {
            t4.each(function(t5) {
              var o3 = n2.select(this), s2 = o3.select(".text-math-group"), c3 = d3.anchorFn(t5, a3), f4 = r3.transFn.call(o3.node(), t5) + (i(a3) && 0 != +a3 ? " rotate(" + a3 + "," + d3.xFn(t5) + "," + (d3.yFn(t5) - t5.fontSize / 2) + ")" : ""), p4 = u.lineCount(o3), v3 = V * t5.fontSize, g4 = d3.heightFn(t5, i(a3) ? +a3 : 0, (p4 - 1) * v3);
              if (g4 && (f4 += l(0, g4)), s2.empty()) {
                var y3 = o3.select("text");
                y3.attr({ transform: f4, "text-anchor": c3 }), y3.style("opacity", 1), e3._adjustTickLabelsOverflow && e3._adjustTickLabelsOverflow();
              } else {
                var m4 = h.bBox(s2.node()).width * { end: -0.5, start: 0.5 }[c3];
                s2.attr("transform", f4 + l(m4, 0));
              }
            });
          }
          y2.enter().append("g").classed(f3, 1).append("text").attr("text-anchor", "middle").each(function(e4) {
            var r4 = n2.select(this), i2 = t3._promises.length;
            r4.call(u.positionText, d3.xFn(e4), d3.yFn(e4)).call(h.font, e4.font, e4.fontSize, e4.fontColor).text(e4.text).call(u.convertToTspans, t3), t3._promises[i2] ? m3.push(t3._promises.pop().then(function() {
              x2(r4, v2);
            })) : x2(r4, v2);
          }), Rt(e3, [F]), y2.exit().remove(), r3.repositionOnUpdate && y2.each(function(t4) {
            n2.select(this).select("text").call(u.positionText, d3.xFn(t4), d3.yFn(t4));
          }), e3._adjustTickLabelsOverflow = function() {
            var r4 = e3.ticklabeloverflow;
            if (r4 && "allow" !== r4) {
              var i2 = -1 !== r4.indexOf("hide"), o3 = "x" === e3._id.charAt(0), l2 = 0, u2 = o3 ? t3._fullLayout.width : t3._fullLayout.height;
              if (-1 !== r4.indexOf("domain")) {
                var c3 = s.simpleMap(e3.range, e3.r2l);
                l2 = e3.l2p(c3[0]) + e3._offset, u2 = e3.l2p(c3[1]) + e3._offset;
              }
              var f4 = Math.min(l2, u2), p4 = Math.max(l2, u2), d4 = e3.side, v3 = 1 / 0, g4 = -1 / 0;
              for (var m4 in y2.each(function(t4) {
                var r5 = n2.select(this);
                if (r5.select(".text-math-group").empty()) {
                  var a3 = h.bBox(r5.node()), s2 = 0;
                  o3 ? (a3.right > p4 || a3.left < f4) && (s2 = 1) : (a3.bottom > p4 || a3.top + (e3.tickangle ? 0 : t4.fontSize / 4) < f4) && (s2 = 1);
                  var l3 = r5.select("text");
                  s2 ? i2 && l3.style("opacity", 0) : (l3.style("opacity", 1), v3 = "bottom" === d4 || "right" === d4 ? Math.min(v3, o3 ? a3.top : a3.left) : -1 / 0, g4 = "top" === d4 || "left" === d4 ? Math.max(g4, o3 ? a3.bottom : a3.right) : 1 / 0);
                }
              }), a2._plots) {
                var x3 = a2._plots[m4];
                if (e3._id === x3.xaxis._id || e3._id === x3.yaxis._id) {
                  var b3 = o3 ? x3.yaxis : x3.xaxis;
                  b3 && (b3["_visibleLabelMin_" + e3._id] = v3, b3["_visibleLabelMax_" + e3._id] = g4);
                }
              }
            }
          }, e3._hideCounterAxisInsideTickLabels = function(t4) {
            var r4 = "x" === e3._id.charAt(0), i2 = [];
            for (var o3 in a2._plots) {
              var s2 = a2._plots[o3];
              e3._id !== s2.xaxis._id && e3._id !== s2.yaxis._id || i2.push(r4 ? s2.yaxis : s2.xaxis);
            }
            i2.forEach(function(r5, i3) {
              r5 && zt(r5) && (t4 || [I, z, D, R, F]).forEach(function(t5) {
                var o4 = "tick" === t5.K && "text" === t5.L && "period" === e3.ticklabelmode, s3 = a2._plots[e3._mainSubplot];
                (t5.K === I.K ? s3.zerolinelayer.selectAll("." + e3._id + "zl") : t5.K === z.K ? s3.minorGridlayer.selectAll("." + e3._id) : t5.K === D.K ? s3.gridlayer.selectAll("." + e3._id) : s3[e3._id.charAt(0) + "axislayer"]).each(function() {
                  var a3 = n2.select(this);
                  t5.L && (a3 = a3.selectAll(t5.L)), a3.each(function(a4) {
                    var s4 = e3.l2p(o4 ? wt(a4) : a4.x) + e3._offset, l2 = n2.select(this);
                    s4 < e3["_visibleLabelMax_" + r5._id] && s4 > e3["_visibleLabelMin_" + r5._id] ? l2.style("display", "none") : "tick" !== t5.K || i3 || l2.style("display", null);
                  });
                });
              });
            });
          }, x2(y2, g3 + 1 ? g3 : v2);
          var b2 = null;
          e3._selections && (e3._selections[f3] = y2);
          var _2 = [function() {
            return m3.length && Promise.all(m3);
          }];
          e3.automargin && a2._redrawFromAutoMarginCount && 90 === g3 ? (b2 = 90, _2.push(function() {
            x2(y2, g3);
          })) : _2.push(function() {
            if (x2(y2, v2), p3.length && "x" === c2 && !i(v2) && ("log" !== e3.type || "D" !== String(e3.dtick).charAt(0))) {
              b2 = 0;
              var t4, n3 = 0, a3 = [];
              if (y2.each(function(t5) {
                n3 = Math.max(n3, t5.fontSize);
                var r4 = e3.l2p(t5.x), i2 = Mt(this), o4 = h.bBox(i2.node());
                a3.push({ top: 0, bottom: 10, height: 10, left: r4 - o4.width / 2, right: r4 + o4.width / 2 + 2, width: o4.width + 2 });
              }), "boundaries" !== e3.tickson && !e3.showdividers || r3.secondary) {
                var o3 = p3.length, l2 = Math.abs((p3[o3 - 1].x - p3[0].x) * e3._m) / (o3 - 1), u2 = e3.ticklabelposition || "", f4 = function(t5) {
                  return -1 !== u2.indexOf(t5);
                }, d4 = f4("top"), g4 = f4("left"), m4 = f4("right"), _3 = f4("bottom") || g4 || d4 || m4 ? (e3.tickwidth || 0) + 6 : 0, w4 = l2 < 2.5 * n3 || "multicategory" === e3.type || "realaxis" === e3._name;
                for (t4 = 0; t4 < a3.length - 1; t4++)
                  if (s.bBoxIntersect(a3[t4], a3[t4 + 1], _3)) {
                    b2 = w4 ? 90 : 30;
                    break;
                  }
              } else {
                var T3 = 2;
                for (e3.ticks && (T3 += e3.tickwidth / 2), t4 = 0; t4 < a3.length; t4++) {
                  var k2 = p3[t4].xbnd, A2 = a3[t4];
                  if (null !== k2[0] && A2.left - e3.l2p(k2[0]) < T3 || null !== k2[1] && e3.l2p(k2[1]) - A2.right < T3) {
                    b2 = 90;
                    break;
                  }
                }
              }
              b2 && x2(y2, b2);
            }
          }), e3._tickAngles && _2.push(function() {
            e3._tickAngles[f3] = null === b2 ? i(v2) ? v2 : 0 : b2;
          });
          var w3 = e3._anchorAxis;
          w3 && w3.autorange && zt(e3) && !W(a2, e3._id) && (a2._insideTickLabelsAutorange || (a2._insideTickLabelsAutorange = {}), a2._insideTickLabelsAutorange[w3._name + ".autorange"] = w3.autorange, _2.push(function() {
            y2.each(function(t4, r4) {
              var n3 = Mt(this);
              n3.select(".text-math-group").empty() && (e3._vals[r4].bb = h.bBox(n3.node()));
            });
          }));
          var T2 = s.syncOrAsync(_2);
          return T2 && T2.then && t3._promises.push(T2), T2;
        }, q2.getPxPosition = function(t3, e3) {
          var r3, n3 = t3._fullLayout._size, i2 = e3._id.charAt(0), a2 = e3.side;
          return "free" !== e3.anchor ? r3 = e3._anchorAxis : "x" === i2 ? r3 = { _offset: n3.t + (1 - (e3.position || 0)) * n3.h, _length: 0 } : "y" === i2 && (r3 = { _offset: n3.l + (e3.position || 0) * n3.w + e3._shift, _length: 0 }), "top" === a2 || "left" === a2 ? r3._offset : "bottom" === a2 || "right" === a2 ? r3._offset + r3._length : void 0;
        }, q2.shouldShowZeroLine = function(t3, e3, r3) {
          var n3 = s.simpleMap(e3.range, e3.r2l);
          return n3[0] * n3[1] <= 0 && e3.zeroline && ("linear" === e3.type || "-" === e3.type) && !(e3.rangebreaks && e3.maskBreaks(0) === O) && (At(e3, 0) || !function(t4, e4, r4, n4) {
            var i2 = r4._mainAxis;
            if (i2) {
              var a2 = t4._fullLayout, o2 = e4._id.charAt(0), s2 = q2.counterLetter(e4._id), l2 = e4._offset + (Math.abs(n4[0]) < Math.abs(n4[1]) == ("x" === o2) ? 0 : e4._length), u2 = a2._plots[r4._mainSubplot];
              if (!(u2.mainplotinfo || u2).overlays.length)
                return p3(r4);
              for (var c2 = q2.list(t4, s2), f3 = 0; f3 < c2.length; f3++) {
                var h2 = c2[f3];
                if (h2._mainAxis === i2 && p3(h2))
                  return true;
              }
            }
            function p3(t5) {
              if (!t5.showline || !t5.linewidth)
                return false;
              var r5 = Math.max((t5.linewidth + e4.zerolinewidth) / 2, 1);
              function n5(t6) {
                return "number" == typeof t6 && Math.abs(t6 - l2) < r5;
              }
              if (n5(t5._mainLinePosition) || n5(t5._mainMirrorPosition))
                return true;
              var i3 = t5._linepositions || {};
              for (var a3 in i3)
                if (n5(i3[a3][0]) || n5(i3[a3][1]))
                  return true;
            }
          }(t3, e3, r3, n3) || function(t4, e4) {
            for (var r4 = t4._fullData, n4 = e4._mainSubplot, i2 = e4._id.charAt(0), a2 = 0; a2 < r4.length; a2++) {
              var s2 = r4[a2];
              if (true === s2.visible && s2.xaxis + s2.yaxis === n4) {
                if (o.traceIs(s2, "bar-like") && s2.orientation === { x: "h", y: "v" }[i2])
                  return true;
                if (s2.fill && s2.fill.charAt(s2.fill.length - 1) === i2)
                  return true;
              }
            }
            return false;
          }(t3, e3));
        }, q2.clipEnds = function(t3, e3) {
          return e3.filter(function(e4) {
            return At(t3, e4.x);
          });
        }, q2.allowAutoMargin = function(t3) {
          for (var e3 = q2.list(t3, "", true), r3 = 0; r3 < e3.length; r3++) {
            var n3 = e3[r3];
            n3.automargin && (a.allowAutoMargin(t3, St(n3)), n3.mirror && a.allowAutoMargin(t3, Et(n3))), o.getComponentMethod("rangeslider", "isVisible")(n3) && a.allowAutoMargin(t3, Lt(n3));
          }
        }, q2.swap = function(t3, e3) {
          for (var r3 = function(t4, e4) {
            var r4, n4, i2 = [];
            for (r4 = 0; r4 < e4.length; r4++) {
              var a2 = [], o2 = t4._fullData[e4[r4]].xaxis, s2 = t4._fullData[e4[r4]].yaxis;
              if (o2 && s2) {
                for (n4 = 0; n4 < i2.length; n4++)
                  -1 === i2[n4].x.indexOf(o2) && -1 === i2[n4].y.indexOf(s2) || a2.push(n4);
                if (a2.length) {
                  var l2, u2 = i2[a2[0]];
                  if (a2.length > 1)
                    for (n4 = 1; n4 < a2.length; n4++)
                      l2 = i2[a2[n4]], Ct(u2.x, l2.x), Ct(u2.y, l2.y);
                  Ct(u2.x, [o2]), Ct(u2.y, [s2]);
                } else
                  i2.push({ x: [o2], y: [s2] });
              }
            }
            return i2;
          }(t3, e3), n3 = 0; n3 < r3.length; n3++)
            Pt(t3, r3[n3].x, r3[n3].y);
        };
      }, 4322: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = r2(50606).BADNUM, o = i.isArrayOrTypedArray, s = i.isDateTime, l = i.cleanNumber, u = Math.round;
        function c(t3, e3) {
          return e3 ? n2(t3) : "number" == typeof t3;
        }
        function f2(t3) {
          return Math.max(1, (t3 - 1) / 1e3);
        }
        t2.exports = function(t3, e3, r3) {
          var i2 = t3, h = r3.noMultiCategory;
          if (o(i2) && !i2.length)
            return "-";
          if (!h && function(t4) {
            return o(t4[0]) && o(t4[1]);
          }(i2))
            return "multicategory";
          if (h && Array.isArray(i2[0])) {
            for (var p2 = [], d2 = 0; d2 < i2.length; d2++)
              if (o(i2[d2]))
                for (var v = 0; v < i2[d2].length; v++)
                  p2.push(i2[d2][v]);
            i2 = p2;
          }
          if (function(t4, e4) {
            for (var r4 = t4.length, i3 = f2(r4), a2 = 0, o2 = 0, l2 = {}, c2 = 0; c2 < r4; c2 += i3) {
              var h2 = t4[u(c2)], p3 = String(h2);
              l2[p3] || (l2[p3] = 1, s(h2, e4) && a2++, n2(h2) && o2++);
            }
            return a2 > 2 * o2;
          }(i2, e3))
            return "date";
          var g2 = "strict" !== r3.autotypenumbers;
          return function(t4, e4) {
            for (var r4 = t4.length, n3 = f2(r4), i3 = 0, o2 = 0, s2 = {}, c2 = 0; c2 < r4; c2 += n3) {
              var h2 = t4[u(c2)], p3 = String(h2);
              if (!s2[p3]) {
                s2[p3] = 1;
                var d3 = typeof h2;
                "boolean" === d3 ? o2++ : (e4 ? l(h2) !== a : "number" === d3) ? i3++ : "string" === d3 && o2++;
              }
            }
            return o2 > 2 * i3;
          }(i2, g2) ? "category" : function(t4, e4) {
            for (var r4 = t4.length, n3 = 0; n3 < r4; n3++)
              if (c(t4[n3], e4))
                return true;
            return false;
          }(i2, g2) ? "linear" : "-";
        };
      }, 71453: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(73972), a = r2(71828), o = r2(44467), s = r2(85501), l = r2(13838), u = r2(26218), c = r2(38701), f2 = r2(96115), h = r2(89426), p2 = r2(15258), d2 = r2(92128), v = r2(21994), g2 = r2(85555).WEEKDAY_PATTERN, y = r2(85555).HOUR_PATTERN;
        function m2(t3, e3, r3) {
          function i2(r4, n3) {
            return a.coerce(t3, e3, l.rangebreaks, r4, n3);
          }
          if (i2("enabled")) {
            var o2 = i2("bounds");
            if (o2 && o2.length >= 2) {
              var s2, u2, c2 = "";
              if (2 === o2.length) {
                for (s2 = 0; s2 < 2; s2++)
                  if (u2 = b(o2[s2])) {
                    c2 = g2;
                    break;
                  }
              }
              var f3 = i2("pattern", c2);
              if (f3 === g2)
                for (s2 = 0; s2 < 2; s2++)
                  (u2 = b(o2[s2])) && (e3.bounds[s2] = o2[s2] = u2 - 1);
              if (f3)
                for (s2 = 0; s2 < 2; s2++)
                  switch (u2 = o2[s2], f3) {
                    case g2:
                      if (!n2(u2))
                        return void (e3.enabled = false);
                      if ((u2 = +u2) !== Math.floor(u2) || u2 < 0 || u2 >= 7)
                        return void (e3.enabled = false);
                      e3.bounds[s2] = o2[s2] = u2;
                      break;
                    case y:
                      if (!n2(u2))
                        return void (e3.enabled = false);
                      if ((u2 = +u2) < 0 || u2 > 24)
                        return void (e3.enabled = false);
                      e3.bounds[s2] = o2[s2] = u2;
                  }
              if (false === r3.autorange) {
                var h2 = r3.range;
                if (h2[0] < h2[1]) {
                  if (o2[0] < h2[0] && o2[1] > h2[1])
                    return void (e3.enabled = false);
                } else if (o2[0] > h2[0] && o2[1] < h2[1])
                  return void (e3.enabled = false);
              }
            } else {
              var p3 = i2("values");
              if (!p3 || !p3.length)
                return void (e3.enabled = false);
              i2("dvalue");
            }
          }
        }
        t2.exports = function(t3, e3, r3, n3, y2) {
          var x2, b2 = n3.letter, _ = n3.font || {}, w2 = n3.splomStash || {}, T = r3("visible", !n3.visibleDflt), k = e3._template || {}, A = e3.type || k.type || "-";
          "date" === A && (i.getComponentMethod("calendars", "handleDefaults")(t3, e3, "calendar", n3.calendar), n3.noTicklabelmode || (x2 = r3("ticklabelmode")));
          var M = "";
          n3.noTicklabelposition && "multicategory" !== A || (M = a.coerce(t3, e3, { ticklabelposition: { valType: "enumerated", dflt: "outside", values: "period" === x2 ? ["outside", "inside"] : "x" === b2 ? ["outside", "inside", "outside left", "inside left", "outside right", "inside right"] : ["outside", "inside", "outside top", "inside top", "outside bottom", "inside bottom"] } }, "ticklabelposition")), n3.noTicklabeloverflow || r3("ticklabeloverflow", -1 !== M.indexOf("inside") ? "hide past domain" : "category" === A || "multicategory" === A ? "allow" : "hide past div"), v(e3, y2);
          var S = !e3.isValidRange(t3.range);
          S && n3.reverseDflt && (S = "reversed"), !r3("autorange", S) || "linear" !== A && "-" !== A || r3("rangemode"), r3("range"), e3.cleanRange(), p2(t3, e3, r3, n3), "category" === A || n3.noHover || r3("hoverformat");
          var E = r3("color"), L = E !== l.color.dflt ? E : _.color, C = w2.label || y2._dfltTitle[b2];
          if (h(t3, e3, r3, A, n3), !T)
            return e3;
          r3("title.text", C), a.coerceFont(r3, "title.font", { family: _.family, size: a.bigFont(_.size), color: L }), u(t3, e3, r3, A);
          var P = n3.hasMinor;
          if (P && (o.newContainer(e3, "minor"), u(t3, e3, r3, A, { isMinor: true })), f2(t3, e3, r3, A, n3), c(t3, e3, r3, n3), P) {
            var O = n3.isMinor;
            n3.isMinor = true, c(t3, e3, r3, n3), n3.isMinor = O;
          }
          d2(t3, e3, r3, { dfltColor: E, bgColor: n3.bgColor, showGrid: n3.showGrid, hasMinor: P, attributes: l }), !P || e3.minor.ticks || e3.minor.showgrid || delete e3.minor, (e3.showline || e3.ticks) && r3("mirror");
          var I, D = "multicategory" === A;
          if (n3.noTickson || "category" !== A && !D || !e3.ticks && !e3.showgrid || (D && (I = "boundaries"), "boundaries" === r3("tickson", I) && delete e3.ticklabelposition), D && r3("showdividers") && (r3("dividercolor"), r3("dividerwidth")), "date" === A)
            if (s(t3, e3, { name: "rangebreaks", inclusionAttr: "enabled", handleItemDefaults: m2 }), e3.rangebreaks.length) {
              for (var z = 0; z < e3.rangebreaks.length; z++)
                if (e3.rangebreaks[z].pattern === g2) {
                  e3._hasDayOfWeekBreaks = true;
                  break;
                }
              if (v(e3, y2), y2._has("scattergl") || y2._has("splom"))
                for (var R = 0; R < n3.data.length; R++) {
                  var F = n3.data[R];
                  "scattergl" !== F.type && "splom" !== F.type || (F.visible = false, a.warn(F.type + " traces do not work on axes with rangebreaks. Setting trace " + F.index + " to `visible: false`."));
                }
            } else
              delete e3.rangebreaks;
          return e3;
        };
        var x = { sun: 1, mon: 2, tue: 3, wed: 4, thu: 5, fri: 6, sat: 7 };
        function b(t3) {
          if ("string" == typeof t3)
            return x[t3.substr(0, 3).toLowerCase()];
        }
      }, 12663: function(t2, e2, r2) {
        var n2 = r2(31562), i = n2.FORMAT_LINK, a = n2.DATE_FORMAT_LINK;
        function o(t3, e3) {
          return ["Sets the " + t3 + " formatting rule" + (e3 ? "for `" + e3 + "` " : ""), "using d3 formatting mini-languages", "which are very similar to those in Python. For numbers, see: " + i + "."].join(" ");
        }
        function s(t3, e3) {
          return o(t3, e3) + [" And for dates see: " + a + ".", "We add two items to d3's date formatter:", "*%h* for half of the year as a decimal number as well as", "*%{n}f* for fractional seconds", "with n digits. For example, *2016-10-13 09:15:23.456* with tickformat", "*%H~%M~%S.%2f* would display *09~15~23.46*"].join(" ");
        }
        t2.exports = { axisHoverFormat: function(t3, e3) {
          return { valType: "string", dflt: "", editType: "none", description: (e3 ? o : s)("hover text", t3) + ["By default the values are formatted using " + (e3 ? "generic number format" : "`" + t3 + "axis.hoverformat`") + "."].join(" ") };
        }, descriptionOnlyNumbers: o, descriptionWithDates: s };
      }, 41675: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(85555);
        function a(t3, e3) {
          if (e3 && e3.length) {
            for (var r3 = 0; r3 < e3.length; r3++)
              if (e3[r3][t3])
                return true;
          }
          return false;
        }
        e2.id2name = function(t3) {
          if ("string" == typeof t3 && t3.match(i.AX_ID_PATTERN)) {
            var e3 = t3.split(" ")[0].substr(1);
            return "1" === e3 && (e3 = ""), t3.charAt(0) + "axis" + e3;
          }
        }, e2.name2id = function(t3) {
          if (t3.match(i.AX_NAME_PATTERN)) {
            var e3 = t3.substr(5);
            return "1" === e3 && (e3 = ""), t3.charAt(0) + e3;
          }
        }, e2.cleanId = function(t3, e3, r3) {
          var n3 = /( domain)$/.test(t3);
          if ("string" == typeof t3 && t3.match(i.AX_ID_PATTERN) && (!e3 || t3.charAt(0) === e3) && (!n3 || r3)) {
            var a2 = t3.split(" ")[0].substr(1).replace(/^0+/, "");
            return "1" === a2 && (a2 = ""), t3.charAt(0) + a2 + (n3 && r3 ? " domain" : "");
          }
        }, e2.list = function(t3, r3, n3) {
          var i2 = t3._fullLayout;
          if (!i2)
            return [];
          var a2, o = e2.listIds(t3, r3), s = new Array(o.length);
          for (a2 = 0; a2 < o.length; a2++) {
            var l = o[a2];
            s[a2] = i2[l.charAt(0) + "axis" + l.substr(1)];
          }
          if (!n3) {
            var u = i2._subplots.gl3d || [];
            for (a2 = 0; a2 < u.length; a2++) {
              var c = i2[u[a2]];
              r3 ? s.push(c[r3 + "axis"]) : s.push(c.xaxis, c.yaxis, c.zaxis);
            }
          }
          return s;
        }, e2.listIds = function(t3, e3) {
          var r3 = t3._fullLayout;
          if (!r3)
            return [];
          var n3 = r3._subplots;
          return e3 ? n3[e3 + "axis"] : n3.xaxis.concat(n3.yaxis);
        }, e2.getFromId = function(t3, r3, n3) {
          var i2 = t3._fullLayout;
          return r3 = void 0 === r3 || "string" != typeof r3 ? r3 : r3.replace(" domain", ""), "x" === n3 ? r3 = r3.replace(/y[0-9]*/, "") : "y" === n3 && (r3 = r3.replace(/x[0-9]*/, "")), i2[e2.id2name(r3)];
        }, e2.getFromTrace = function(t3, r3, i2) {
          var a2 = t3._fullLayout, o = null;
          if (n2.traceIs(r3, "gl3d")) {
            var s = r3.scene;
            "scene" === s.substr(0, 5) && (o = a2[s][i2 + "axis"]);
          } else
            o = e2.getFromId(t3, r3[i2 + "axis"] || i2);
          return o;
        }, e2.idSort = function(t3, e3) {
          var r3 = t3.charAt(0), n3 = e3.charAt(0);
          return r3 !== n3 ? r3 > n3 ? 1 : -1 : +(t3.substr(1) || 1) - +(e3.substr(1) || 1);
        }, e2.ref2id = function(t3) {
          return !!/^[xyz]/.test(t3) && t3.split(" ")[0];
        }, e2.isLinked = function(t3, e3) {
          return a(e3, t3._axisMatchGroups) || a(e3, t3._axisConstraintGroups);
        };
      }, 15258: function(t2) {
        t2.exports = function(t3, e2, r2, n2) {
          if ("category" === e2.type) {
            var i, a = t3.categoryarray, o = Array.isArray(a) && a.length > 0;
            o && (i = "array");
            var s, l = r2("categoryorder", i);
            "array" === l && (s = r2("categoryarray")), o || "array" !== l || (l = e2.categoryorder = "trace"), "trace" === l ? e2._initialCategories = [] : "array" === l ? e2._initialCategories = s.slice() : (s = function(t4, e3) {
              var r3, n3, i2, a2 = e3.dataAttr || t4._id.charAt(0), o2 = {};
              if (e3.axData)
                r3 = e3.axData;
              else
                for (r3 = [], n3 = 0; n3 < e3.data.length; n3++) {
                  var s2 = e3.data[n3];
                  s2[a2 + "axis"] === t4._id && r3.push(s2);
                }
              for (n3 = 0; n3 < r3.length; n3++) {
                var l2 = r3[n3][a2];
                for (i2 = 0; i2 < l2.length; i2++) {
                  var u = l2[i2];
                  null != u && (o2[u] = 1);
                }
              }
              return Object.keys(o2);
            }(e2, n2).sort(), "category ascending" === l ? e2._initialCategories = s : "category descending" === l && (e2._initialCategories = s.reverse()));
          }
        };
      }, 66287: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = r2(50606), o = a.ONEDAY, s = a.ONEWEEK;
        e2.dtick = function(t3, e3) {
          var r3 = "log" === e3, i2 = "date" === e3, a2 = "category" === e3, s2 = i2 ? o : 1;
          if (!t3)
            return s2;
          if (n2(t3))
            return (t3 = Number(t3)) <= 0 ? s2 : a2 ? Math.max(1, Math.round(t3)) : i2 ? Math.max(0.1, t3) : t3;
          if ("string" != typeof t3 || !i2 && !r3)
            return s2;
          var l = t3.charAt(0), u = t3.substr(1);
          return (u = n2(u) ? Number(u) : 0) <= 0 || !(i2 && "M" === l && u === Math.round(u) || r3 && "L" === l || r3 && "D" === l && (1 === u || 2 === u)) ? s2 : t3;
        }, e2.tick0 = function(t3, e3, r3, a2) {
          return "date" === e3 ? i.cleanDate(t3, i.dateTick0(r3, a2 % s == 0 ? 1 : 0)) : "D1" !== a2 && "D2" !== a2 ? n2(t3) ? Number(t3) : 0 : void 0;
        };
      }, 85555: function(t2, e2, r2) {
        var n2 = r2(30587).counter;
        t2.exports = { idRegex: { x: n2("x", "( domain)?"), y: n2("y", "( domain)?") }, attrRegex: n2("[xy]axis"), xAxisMatch: n2("xaxis"), yAxisMatch: n2("yaxis"), AX_ID_PATTERN: /^[xyz][0-9]*( domain)?$/, AX_NAME_PATTERN: /^[xyz]axis[0-9]*$/, SUBPLOT_PATTERN: /^x([0-9]*)y([0-9]*)$/, HOUR_PATTERN: "hour", WEEKDAY_PATTERN: "day of week", MINDRAG: 8, MINZOOM: 20, DRAGGERSIZE: 20, REDRAWDELAY: 50, DFLTRANGEX: [-1, 6], DFLTRANGEY: [-1, 4], traceLayerClasses: ["imagelayer", "heatmaplayer", "contourcarpetlayer", "contourlayer", "funnellayer", "waterfalllayer", "barlayer", "carpetlayer", "violinlayer", "boxlayer", "ohlclayer", "scattercarpetlayer", "scatterlayer"], clipOnAxisFalseQuery: [".scatterlayer", ".barlayer", ".funnellayer", ".waterfalllayer"], layerValue2layerClass: { "above traces": "above", "below traces": "below" } };
      }, 99082: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(71739), a = r2(41675).id2name, o = r2(13838), s = r2(42449), l = r2(21994), u = r2(50606).ALMOST_EQUAL, c = r2(18783).FROM_BL;
        function f2(t3, e3, r3) {
          var i2 = r3.axIds, s2 = r3.layoutOut, l2 = r3.hasImage, u2 = s2._axisConstraintGroups, c2 = s2._axisMatchGroups, f3 = e3._id, v2 = f3.charAt(0), g3 = ((s2._splomAxes || {})[v2] || {})[f3] || {}, y2 = e3._id, m2 = "x" === y2.charAt(0);
          function x(r4, i3) {
            return n2.coerce(t3, e3, o, r4, i3);
          }
          e3._matchGroup = null, e3._constraintGroup = null, x("constrain", l2 ? "domain" : "range"), n2.coerce(t3, e3, { constraintoward: { valType: "enumerated", values: m2 ? ["left", "center", "right"] : ["bottom", "middle", "top"], dflt: m2 ? "center" : "middle" } }, "constraintoward");
          var b, _, w2 = e3.type, T = [];
          for (b = 0; b < i2.length; b++)
            (_ = i2[b]) !== y2 && s2[a(_)].type === w2 && T.push(_);
          var k = p2(u2, y2);
          if (k) {
            var A = [];
            for (b = 0; b < T.length; b++)
              k[_ = T[b]] || A.push(_);
            T = A;
          }
          var M, S, E = T.length;
          E && (t3.matches || g3.matches) && (M = n2.coerce(t3, e3, { matches: { valType: "enumerated", values: T, dflt: -1 !== T.indexOf(g3.matches) ? g3.matches : void 0 } }, "matches"));
          var L = l2 && !m2 ? e3.anchor : void 0;
          if (E && !M && (t3.scaleanchor || L) && (S = n2.coerce(t3, e3, { scaleanchor: { valType: "enumerated", values: T } }, "scaleanchor", L)), M) {
            e3._matchGroup = d2(c2, y2, M, 1);
            var C = s2[a(M)], P = h(s2, e3) / h(s2, C);
            m2 !== ("x" === M.charAt(0)) && (P = (m2 ? "x" : "y") + P), d2(u2, y2, M, P);
          } else
            t3.matches && -1 !== i2.indexOf(t3.matches) && n2.warn("ignored " + e3._name + '.matches: "' + t3.matches + '" to avoid an infinite loop');
          if (S) {
            var O = x("scaleratio");
            O || (O = e3.scaleratio = 1), d2(u2, y2, S, O);
          } else
            t3.scaleanchor && -1 !== i2.indexOf(t3.scaleanchor) && n2.warn("ignored " + e3._name + '.scaleanchor: "' + t3.scaleanchor + '" to avoid either an infinite loop and possibly inconsistent scaleratios, or because this axis declares a *matches* constraint.');
        }
        function h(t3, e3) {
          var r3 = e3.domain;
          return r3 || (r3 = t3[a(e3.overlaying)].domain), r3[1] - r3[0];
        }
        function p2(t3, e3) {
          for (var r3 = 0; r3 < t3.length; r3++)
            if (t3[r3][e3])
              return t3[r3];
          return null;
        }
        function d2(t3, e3, r3, n3) {
          var i2, a2, o2, s2, l2, u2 = p2(t3, e3);
          null === u2 ? ((u2 = {})[e3] = 1, l2 = t3.length, t3.push(u2)) : l2 = t3.indexOf(u2);
          var c2 = Object.keys(u2);
          for (i2 = 0; i2 < t3.length; i2++)
            if (o2 = t3[i2], i2 !== l2 && o2[r3]) {
              var f3 = o2[r3];
              for (a2 = 0; a2 < c2.length; a2++)
                o2[s2 = c2[a2]] = v(f3, v(n3, u2[s2]));
              return void t3.splice(l2, 1);
            }
          if (1 !== n3)
            for (a2 = 0; a2 < c2.length; a2++) {
              var h2 = c2[a2];
              u2[h2] = v(n3, u2[h2]);
            }
          u2[r3] = 1;
        }
        function v(t3, e3) {
          var r3, n3, i2 = "", a2 = "";
          "string" == typeof t3 && (r3 = (i2 = t3.match(/^[xy]*/)[0]).length, t3 = +t3.substr(r3)), "string" == typeof e3 && (n3 = (a2 = e3.match(/^[xy]*/)[0]).length, e3 = +e3.substr(n3));
          var o2 = t3 * e3;
          return r3 || n3 ? r3 && n3 && i2.charAt(0) !== a2.charAt(0) ? r3 === n3 ? o2 : (r3 > n3 ? i2.substr(n3) : a2.substr(r3)) + o2 : i2 + a2 + t3 * e3 : o2;
        }
        function g2(t3, e3) {
          for (var r3 = e3._size, n3 = r3.h / r3.w, i2 = {}, a2 = Object.keys(t3), o2 = 0; o2 < a2.length; o2++) {
            var s2 = a2[o2], l2 = t3[s2];
            if ("string" == typeof l2) {
              var u2 = l2.match(/^[xy]*/)[0], c2 = u2.length;
              l2 = +l2.substr(c2);
              for (var f3 = "y" === u2.charAt(0) ? n3 : 1 / n3, h2 = 0; h2 < c2; h2++)
                l2 *= f3;
            }
            i2[s2] = l2;
          }
          return i2;
        }
        function y(t3, e3) {
          var r3 = t3._inputDomain, n3 = c[t3.constraintoward], i2 = r3[0] + (r3[1] - r3[0]) * n3;
          t3.domain = t3._input.domain = [i2 + (r3[0] - i2) / e3, i2 + (r3[1] - i2) / e3], t3.setScale();
        }
        e2.handleDefaults = function(t3, e3, r3) {
          var i2, o2, s2, u2, c2, h2, p3, d3, v2 = r3.axIds, g3 = r3.axHasImage, y2 = e3._axisConstraintGroups = [], m2 = e3._axisMatchGroups = [];
          for (i2 = 0; i2 < v2.length; i2++)
            f2(c2 = t3[u2 = a(v2[i2])], h2 = e3[u2], { axIds: v2, layoutOut: e3, hasImage: g3[u2] });
          function x(t4, r4) {
            for (i2 = 0; i2 < t4.length; i2++)
              for (s2 in o2 = t4[i2])
                e3[a(s2)][r4] = o2;
          }
          for (x(m2, "_matchGroup"), i2 = 0; i2 < y2.length; i2++)
            for (s2 in o2 = y2[i2])
              if ((h2 = e3[a(s2)]).fixedrange) {
                for (var b in o2) {
                  var _ = a(b);
                  false === (t3[_] || {}).fixedrange && n2.warn("fixedrange was specified as false for axis " + _ + " but was overridden because another axis in its constraint group has fixedrange true"), e3[_].fixedrange = true;
                }
                break;
              }
          for (i2 = 0; i2 < y2.length; ) {
            for (s2 in o2 = y2[i2]) {
              (h2 = e3[a(s2)])._matchGroup && Object.keys(h2._matchGroup).length === Object.keys(o2).length && (y2.splice(i2, 1), i2--);
              break;
            }
            i2++;
          }
          x(y2, "_constraintGroup");
          var w2 = ["constrain", "range", "autorange", "rangemode", "rangebreaks", "categoryorder", "categoryarray"], T = false, k = false;
          function A() {
            d3 = h2[p3], "rangebreaks" === p3 && (k = h2._hasDayOfWeekBreaks);
          }
          for (i2 = 0; i2 < m2.length; i2++) {
            o2 = m2[i2];
            for (var M = 0; M < w2.length; M++) {
              var S;
              for (s2 in p3 = w2[M], d3 = null, o2)
                if (c2 = t3[u2 = a(s2)], h2 = e3[u2], p3 in h2) {
                  if (!h2.matches && (S = h2, p3 in c2)) {
                    A();
                    break;
                  }
                  null === d3 && p3 in c2 && A();
                }
              if ("range" === p3 && d3 && (T = true), "autorange" === p3 && null === d3 && T && (d3 = false), null === d3 && p3 in S && (d3 = S[p3]), null !== d3)
                for (s2 in o2)
                  (h2 = e3[a(s2)])[p3] = "range" === p3 ? d3.slice() : d3, "rangebreaks" === p3 && (h2._hasDayOfWeekBreaks = k, l(h2, e3));
            }
          }
        }, e2.enforce = function(t3) {
          var e3, r3, n3, o2, l2, c2, f3, h2, p3 = t3._fullLayout, d3 = p3._axisConstraintGroups || [];
          for (e3 = 0; e3 < d3.length; e3++) {
            n3 = g2(d3[e3], p3);
            var v2 = Object.keys(n3), m2 = 1 / 0, x = 0, b = 1 / 0, _ = {}, w2 = {}, T = false;
            for (r3 = 0; r3 < v2.length; r3++)
              w2[o2 = v2[r3]] = l2 = p3[a(o2)], l2._inputDomain ? l2.domain = l2._inputDomain.slice() : l2._inputDomain = l2.domain.slice(), l2._inputRange || (l2._inputRange = l2.range.slice()), l2.setScale(), _[o2] = c2 = Math.abs(l2._m) / n3[o2], m2 = Math.min(m2, c2), "domain" !== l2.constrain && l2._constraintShrinkable || (b = Math.min(b, c2)), delete l2._constraintShrinkable, x = Math.max(x, c2), "domain" === l2.constrain && (T = true);
            if (!(m2 > u * x) || T) {
              for (r3 = 0; r3 < v2.length; r3++)
                if (c2 = _[o2 = v2[r3]], f3 = (l2 = w2[o2]).constrain, c2 !== b || "domain" === f3)
                  if (h2 = c2 / b, "range" === f3)
                    s(l2, h2);
                  else {
                    var k = l2._inputDomain, A = (l2.domain[1] - l2.domain[0]) / (k[1] - k[0]), M = (l2.r2l(l2.range[1]) - l2.r2l(l2.range[0])) / (l2.r2l(l2._inputRange[1]) - l2.r2l(l2._inputRange[0]));
                    if ((h2 /= A) * M < 1) {
                      l2.domain = l2._input.domain = k.slice(), s(l2, h2);
                      continue;
                    }
                    if (M < 1 && (l2.range = l2._input.range = l2._inputRange.slice(), h2 *= M), l2.autorange) {
                      var S = l2.r2l(l2.range[0]), E = l2.r2l(l2.range[1]), L = (S + E) / 2, C = L, P = L, O = Math.abs(E - L), I = L - O * h2 * 1.0001, D = L + O * h2 * 1.0001, z = i.makePadFn(p3, l2, 0), R = i.makePadFn(p3, l2, 1);
                      y(l2, h2);
                      var F, B, N = Math.abs(l2._m), j = i.concatExtremes(t3, l2), U = j.min, V = j.max;
                      for (B = 0; B < U.length; B++)
                        (F = U[B].val - z(U[B]) / N) > I && F < C && (C = F);
                      for (B = 0; B < V.length; B++)
                        (F = V[B].val + R(V[B]) / N) < D && F > P && (P = F);
                      h2 /= (P - C) / (2 * O), C = l2.l2r(C), P = l2.l2r(P), l2.range = l2._input.range = S < E ? [C, P] : [P, C];
                    }
                    y(l2, h2);
                  }
            }
          }
        }, e2.getAxisGroup = function(t3, e3) {
          for (var r3 = t3._axisMatchGroups, n3 = 0; n3 < r3.length; n3++)
            if (r3[n3][e3])
              return "g" + n3;
          return e3;
        }, e2.clean = function(t3, e3) {
          if (e3._inputDomain) {
            for (var r3 = false, n3 = e3._id, i2 = t3._fullLayout._axisConstraintGroups, a2 = 0; a2 < i2.length; a2++)
              if (i2[a2][n3]) {
                r3 = true;
                break;
              }
            r3 && "domain" === e3.constrain || (e3._input.domain = e3.domain = e3._inputDomain, delete e3._inputDomain);
          }
        };
      }, 29323: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = i.numberFormat, o = r2(84267), s = r2(38520), l = r2(73972), u = i.strTranslate, c = r2(63893), f2 = r2(7901), h = r2(91424), p2 = r2(30211), d2 = r2(89298), v = r2(6964), g2 = r2(28569), y = r2(64505), m2 = y.selectingOrDrawing, x = y.freeMode, b = r2(18783).FROM_TL, _ = r2(33306), w2 = r2(61549).redrawReglTraces, T = r2(74875), k = r2(41675).getFromId, A = r2(47322).prepSelect, M = r2(47322).clearOutline, S = r2(47322).selectOnClick, E = r2(42449), L = r2(85555), C = L.MINDRAG, P = L.MINZOOM, O = true;
        function I(t3, e3, r3, n3) {
          var a2 = i.ensureSingle(t3.draglayer, e3, r3, function(e4) {
            e4.classed("drag", true).style({ fill: "transparent", "stroke-width": 0 }).attr("data-subplot", t3.id);
          });
          return a2.call(v, n3), a2.node();
        }
        function D(t3, e3, r3, i2, a2, o2, s2) {
          var l2 = I(t3, "rect", e3, r3);
          return n2.select(l2).call(h.setRect, i2, a2, o2, s2), l2;
        }
        function z(t3, e3) {
          for (var r3 = 0; r3 < t3.length; r3++)
            if (!t3[r3].fixedrange)
              return e3;
          return "";
        }
        function R(t3, e3, r3, n3, i2) {
          for (var a2 = 0; a2 < t3.length; a2++) {
            var o2 = t3[a2];
            if (!o2.fixedrange)
              if (o2.rangebreaks) {
                var s2 = "y" === o2._id.charAt(0), l2 = s2 ? 1 - e3 : e3, u2 = s2 ? 1 - r3 : r3;
                n3[o2._name + ".range[0]"] = o2.l2r(o2.p2l(l2 * o2._length)), n3[o2._name + ".range[1]"] = o2.l2r(o2.p2l(u2 * o2._length));
              } else {
                var c2 = o2._rl[0], f3 = o2._rl[1] - c2;
                n3[o2._name + ".range[0]"] = o2.l2r(c2 + f3 * e3), n3[o2._name + ".range[1]"] = o2.l2r(c2 + f3 * r3);
              }
          }
          if (i2 && i2.length) {
            var h2 = (e3 + (1 - r3)) / 2;
            R(i2, h2, 1 - h2, n3, []);
          }
        }
        function F(t3, e3) {
          for (var r3 = 0; r3 < t3.length; r3++) {
            var n3 = t3[r3];
            if (!n3.fixedrange)
              if (n3.rangebreaks) {
                var i2 = n3._length, a2 = (n3.p2l(0 + e3) - n3.p2l(0) + (n3.p2l(i2 + e3) - n3.p2l(i2))) / 2;
                n3.range = [n3.l2r(n3._rl[0] - a2), n3.l2r(n3._rl[1] - a2)];
              } else
                n3.range = [n3.l2r(n3._rl[0] - e3 / n3._m), n3.l2r(n3._rl[1] - e3 / n3._m)];
          }
        }
        function B(t3) {
          return 1 - (t3 >= 0 ? Math.min(t3, 0.9) : 1 / (1 / Math.max(t3, -0.3) + 3.222));
        }
        function N(t3, e3, r3, n3, i2) {
          return t3.append("path").attr("class", "zoombox").style({ fill: e3 > 0.2 ? "rgba(0,0,0,0)" : "rgba(255,255,255,0)", "stroke-width": 0 }).attr("transform", u(r3, n3)).attr("d", i2 + "Z");
        }
        function j(t3, e3, r3) {
          return t3.append("path").attr("class", "zoombox-corners").style({ fill: f2.background, stroke: f2.defaultLine, "stroke-width": 1, opacity: 0 }).attr("transform", u(e3, r3)).attr("d", "M0,0Z");
        }
        function U(t3, e3, r3, n3, i2, a2) {
          t3.attr("d", n3 + "M" + r3.l + "," + r3.t + "v" + r3.h + "h" + r3.w + "v-" + r3.h + "h-" + r3.w + "Z"), V(t3, e3, i2, a2);
        }
        function V(t3, e3, r3, n3) {
          r3 || (t3.transition().style("fill", n3 > 0.2 ? "rgba(0,0,0,0.4)" : "rgba(255,255,255,0.3)").duration(200), e3.transition().style("opacity", 1).duration(200));
        }
        function H(t3) {
          n2.select(t3).selectAll(".zoombox,.js-zoombox-backdrop,.js-zoombox-menu,.zoombox-corners").remove();
        }
        function q2(t3) {
          O && t3.data && t3._context.showTips && (i.notifier(i._(t3, "Double-click to zoom back out"), "long"), O = false);
        }
        function G(t3) {
          var e3 = Math.floor(Math.min(t3.b - t3.t, t3.r - t3.l, P) / 2);
          return "M" + (t3.l - 3.5) + "," + (t3.t - 0.5 + e3) + "h3v" + -e3 + "h" + e3 + "v-3h-" + (e3 + 3) + "ZM" + (t3.r + 3.5) + "," + (t3.t - 0.5 + e3) + "h-3v" + -e3 + "h" + -e3 + "v-3h" + (e3 + 3) + "ZM" + (t3.r + 3.5) + "," + (t3.b + 0.5 - e3) + "h-3v" + e3 + "h" + -e3 + "v3h" + (e3 + 3) + "ZM" + (t3.l - 3.5) + "," + (t3.b + 0.5 - e3) + "h3v" + e3 + "h" + e3 + "v3h-" + (e3 + 3) + "Z";
        }
        function Z(t3, e3, r3, n3, a2) {
          for (var o2, s2, l2, u2, c2 = false, f3 = {}, h2 = {}, p3 = (a2 || {}).xaHash, d3 = (a2 || {}).yaHash, v2 = 0; v2 < e3.length; v2++) {
            var g3 = e3[v2];
            for (o2 in r3)
              if (g3[o2]) {
                for (l2 in g3)
                  a2 && (p3[l2] || d3[l2]) || ("x" === l2.charAt(0) ? r3 : n3)[l2] || (f3[l2] = o2);
                for (s2 in n3)
                  a2 && (p3[s2] || d3[s2]) || !g3[s2] || (c2 = true);
              }
            for (s2 in n3)
              if (g3[s2])
                for (u2 in g3)
                  a2 && (p3[u2] || d3[u2]) || ("x" === u2.charAt(0) ? r3 : n3)[u2] || (h2[u2] = s2);
          }
          c2 && (i.extendFlat(f3, h2), h2 = {});
          var y2 = {}, m3 = [];
          for (l2 in f3) {
            var x2 = k(t3, l2);
            m3.push(x2), y2[x2._id] = x2;
          }
          var b2 = {}, _2 = [];
          for (u2 in h2) {
            var w3 = k(t3, u2);
            _2.push(w3), b2[w3._id] = w3;
          }
          return { xaHash: y2, yaHash: b2, xaxes: m3, yaxes: _2, xLinks: f3, yLinks: h2, isSubplotConstrained: c2 };
        }
        function Y(t3, e3) {
          if (s) {
            var r3 = void 0 !== t3.onwheel ? "wheel" : "mousewheel";
            t3._onwheel && t3.removeEventListener(r3, t3._onwheel), t3._onwheel = e3, t3.addEventListener(r3, e3, { passive: false });
          } else
            void 0 !== t3.onwheel ? t3.onwheel = e3 : void 0 !== t3.onmousewheel ? t3.onmousewheel = e3 : t3.isAddedWheelEvent || (t3.isAddedWheelEvent = true, t3.addEventListener("wheel", e3, { passive: false }));
        }
        function W(t3) {
          var e3 = [];
          for (var r3 in t3)
            e3.push(t3[r3]);
          return e3;
        }
        t2.exports = { makeDragBox: function(t3, e3, r3, s2, u2, f3, v2, y2) {
          var O2, I2, V2, X, J, K, $, Q, tt, et, rt, nt, it, at, ot, st, lt, ut, ct, ft, ht, pt, dt, vt = t3._fullLayout._zoomlayer, gt = v2 + y2 === "nsew", yt = 1 === (v2 + y2).length;
          function mt() {
            if (O2 = e3.xaxis, I2 = e3.yaxis, tt = O2._length, et = I2._length, $ = O2._offset, Q = I2._offset, (V2 = {})[O2._id] = O2, (X = {})[I2._id] = I2, v2 && y2)
              for (var r4 = e3.overlays, n3 = 0; n3 < r4.length; n3++) {
                var i2 = r4[n3].xaxis;
                V2[i2._id] = i2;
                var a2 = r4[n3].yaxis;
                X[a2._id] = a2;
              }
            J = W(V2), K = W(X), it = z(J, y2), at = z(K, v2), ot = !at && !it, nt = Z(t3, t3._fullLayout._axisMatchGroups, V2, X);
            var o2 = (rt = Z(t3, t3._fullLayout._axisConstraintGroups, V2, X, nt)).isSubplotConstrained || nt.isSubplotConstrained;
            st = y2 || o2, lt = v2 || o2;
            var s3 = t3._fullLayout;
            ut = s3._has("scattergl"), ct = s3._has("splom"), ft = s3._has("svg");
          }
          r3 += e3.yaxis._shift, mt();
          var xt = function(t4, e4, r4) {
            return t4 ? "nsew" === t4 ? r4 ? "" : "pan" === e4 ? "move" : "crosshair" : t4.toLowerCase() + "-resize" : "pointer";
          }(at + it, t3._fullLayout.dragmode, gt), bt = D(e3, v2 + y2 + "drag", xt, r3, s2, u2, f3);
          if (ot && !gt)
            return bt.onmousedown = null, bt.style.pointerEvents = "none", bt;
          var _t, wt, Tt, kt, At, Mt, St, Et, Lt, Ct, Pt = { element: bt, gd: t3, plotinfo: e3 };
          function Ot() {
            Pt.plotinfo.selection = false, M(t3);
          }
          function It(t4, r4) {
            var i2 = Pt.gd;
            if (i2._fullLayout._activeShapeIndex >= 0)
              i2._fullLayout._deactivateShape(i2);
            else {
              var o2 = i2._fullLayout.clickmode;
              if (H(i2), 2 !== t4 || yt || qt(), gt)
                o2.indexOf("select") > -1 && S(r4, i2, J, K, e3.id, Pt), o2.indexOf("event") > -1 && p2.click(i2, r4, e3.id);
              else if (1 === t4 && yt) {
                var s3 = v2 ? I2 : O2, u3 = "s" === v2 || "w" === y2 ? 0 : 1, f4 = s3._name + ".range[" + u3 + "]", h2 = function(t5, e4) {
                  var r5, n3 = t5.range[e4], i3 = Math.abs(n3 - t5.range[1 - e4]);
                  return "date" === t5.type ? n3 : "log" === t5.type ? (r5 = Math.ceil(Math.max(0, -Math.log(i3) / Math.LN10)) + 3, a("." + r5 + "g")(Math.pow(10, n3))) : (r5 = Math.floor(Math.log(Math.abs(n3)) / Math.LN10) - Math.floor(Math.log(i3) / Math.LN10) + 4, a("." + String(r5) + "g")(n3));
                }(s3, u3), d3 = "left", g3 = "middle";
                if (s3.fixedrange)
                  return;
                v2 ? (g3 = "n" === v2 ? "top" : "bottom", "right" === s3.side && (d3 = "right")) : "e" === y2 && (d3 = "right"), i2._context.showAxisRangeEntryBoxes && n2.select(bt).call(c.makeEditable, { gd: i2, immediate: true, background: i2._fullLayout.paper_bgcolor, text: String(h2), fill: s3.tickfont ? s3.tickfont.color : "#444", horizontalAlign: d3, verticalAlign: g3 }).on("edit", function(t5) {
                  var e4 = s3.d2r(t5);
                  void 0 !== e4 && l.call("_guiRelayout", i2, f4, e4);
                });
              }
            }
          }
          function Dt(e4, r4) {
            if (t3._transitioningWithDuration)
              return false;
            var n3 = Math.max(0, Math.min(tt, pt * e4 + _t)), i2 = Math.max(0, Math.min(et, dt * r4 + wt)), a2 = Math.abs(n3 - _t), o2 = Math.abs(i2 - wt);
            function s3() {
              St = "", Tt.r = Tt.l, Tt.t = Tt.b, Lt.attr("d", "M0,0Z");
            }
            if (Tt.l = Math.min(_t, n3), Tt.r = Math.max(_t, n3), Tt.t = Math.min(wt, i2), Tt.b = Math.max(wt, i2), rt.isSubplotConstrained)
              a2 > P || o2 > P ? (St = "xy", a2 / tt > o2 / et ? (o2 = a2 * et / tt, wt > i2 ? Tt.t = wt - o2 : Tt.b = wt + o2) : (a2 = o2 * tt / et, _t > n3 ? Tt.l = _t - a2 : Tt.r = _t + a2), Lt.attr("d", G(Tt))) : s3();
            else if (nt.isSubplotConstrained)
              if (a2 > P || o2 > P) {
                St = "xy";
                var l2 = Math.min(Tt.l / tt, (et - Tt.b) / et), u3 = Math.max(Tt.r / tt, (et - Tt.t) / et);
                Tt.l = l2 * tt, Tt.r = u3 * tt, Tt.b = (1 - l2) * et, Tt.t = (1 - u3) * et, Lt.attr("d", G(Tt));
              } else
                s3();
            else
              !at || o2 < Math.min(Math.max(0.6 * a2, C), P) ? a2 < C || !it ? s3() : (Tt.t = 0, Tt.b = et, St = "x", Lt.attr("d", function(t4, e5) {
                return "M" + (t4.l - 0.5) + "," + (e5 - P - 0.5) + "h-3v" + (2 * P + 1) + "h3ZM" + (t4.r + 0.5) + "," + (e5 - P - 0.5) + "h3v" + (2 * P + 1) + "h-3Z";
              }(Tt, wt))) : !it || a2 < Math.min(0.6 * o2, P) ? (Tt.l = 0, Tt.r = tt, St = "y", Lt.attr("d", function(t4, e5) {
                return "M" + (e5 - P - 0.5) + "," + (t4.t - 0.5) + "v-3h" + (2 * P + 1) + "v3ZM" + (e5 - P - 0.5) + "," + (t4.b + 0.5) + "v3h" + (2 * P + 1) + "v-3Z";
              }(Tt, _t))) : (St = "xy", Lt.attr("d", G(Tt)));
            Tt.w = Tt.r - Tt.l, Tt.h = Tt.b - Tt.t, St && (Ct = true), t3._dragged = Ct, U(Et, Lt, Tt, At, Mt, kt), zt(), t3.emit("plotly_relayouting", ht), Mt = true;
          }
          function zt() {
            ht = {}, "xy" !== St && "x" !== St || (R(J, Tt.l / tt, Tt.r / tt, ht, rt.xaxes), Vt("x", ht)), "xy" !== St && "y" !== St || (R(K, (et - Tt.b) / et, (et - Tt.t) / et, ht, rt.yaxes), Vt("y", ht));
          }
          function Rt() {
            zt(), H(t3), Gt(), q2(t3);
          }
          Pt.prepFn = function(e4, r4, n3) {
            var a2 = Pt.dragmode, s3 = t3._fullLayout.dragmode;
            s3 !== a2 && (Pt.dragmode = s3), mt(), pt = t3._fullLayout._invScaleX, dt = t3._fullLayout._invScaleY, ot || (gt ? e4.shiftKey ? "pan" === s3 ? s3 = "zoom" : m2(s3) || (s3 = "pan") : e4.ctrlKey && (s3 = "pan") : s3 = "pan"), x(s3) ? Pt.minDrag = 1 : Pt.minDrag = void 0, m2(s3) ? (Pt.xaxes = J, Pt.yaxes = K, A(e4, r4, n3, Pt, s3)) : (Pt.clickFn = It, m2(a2) && Ot(), ot || ("zoom" === s3 ? (Pt.moveFn = Dt, Pt.doneFn = Rt, Pt.minDrag = 1, function(e5, r5, n4) {
              var a3 = bt.getBoundingClientRect();
              _t = r5 - a3.left, wt = n4 - a3.top, t3._fullLayout._calcInverseTransform(t3);
              var s4 = i.apply3DTransform(t3._fullLayout._invTransform)(_t, wt);
              _t = s4[0], wt = s4[1], Tt = { l: _t, r: _t, w: 0, t: wt, b: wt, h: 0 }, kt = t3._hmpixcount ? t3._hmlumcount / t3._hmpixcount : o(t3._fullLayout.plot_bgcolor).getLuminance(), Mt = false, St = "xy", Ct = false, Et = N(vt, kt, $, Q, At = "M0,0H" + tt + "V" + et + "H0V0"), Lt = j(vt, $, Q);
            }(0, r4, n3)) : "pan" === s3 && (Pt.moveFn = Ut, Pt.doneFn = Gt))), t3._fullLayout._redrag = function() {
              var e5 = t3._dragdata;
              if (e5 && e5.element === bt) {
                var r5 = t3._fullLayout.dragmode;
                m2(r5) || (mt(), Zt([0, 0, tt, et]), Pt.moveFn(e5.dx, e5.dy));
              }
            };
          }, g2.init(Pt);
          var Ft = [0, 0, tt, et], Bt = null, Nt = L.REDRAWDELAY, jt = e3.mainplot ? t3._fullLayout._plots[e3.mainplot] : e3;
          function Ut(e4, r4) {
            if (e4 *= pt, r4 *= dt, !t3._transitioningWithDuration) {
              if (t3._fullLayout._replotting = true, "ew" === it || "ns" === at) {
                var n3 = it ? -e4 : 0, i2 = at ? -r4 : 0;
                if (nt.isSubplotConstrained) {
                  if (it && at) {
                    var a2 = (e4 / tt - r4 / et) / 2;
                    n3 = -(e4 = a2 * tt), i2 = -(r4 = -a2 * et);
                  }
                  at ? n3 = -i2 * tt / et : i2 = -n3 * et / tt;
                }
                return it && (F(J, e4), Vt("x")), at && (F(K, r4), Vt("y")), Zt([n3, i2, tt, et]), Ht(), void t3.emit("plotly_relayouting", ht);
              }
              var o2, s3, l2 = "w" === it == ("n" === at) ? 1 : -1;
              if (it && at && (rt.isSubplotConstrained || nt.isSubplotConstrained)) {
                var u3 = (e4 / tt + l2 * r4 / et) / 2;
                e4 = u3 * tt, r4 = l2 * u3 * et;
              }
              if ("w" === it ? e4 = p3(J, 0, e4) : "e" === it ? e4 = p3(J, 1, -e4) : it || (e4 = 0), "n" === at ? r4 = p3(K, 1, r4) : "s" === at ? r4 = p3(K, 0, -r4) : at || (r4 = 0), o2 = "w" === it ? e4 : 0, s3 = "n" === at ? r4 : 0, rt.isSubplotConstrained && !nt.isSubplotConstrained || nt.isSubplotConstrained && it && at && l2 > 0) {
                var c2;
                if (nt.isSubplotConstrained || !it && 1 === at.length) {
                  for (c2 = 0; c2 < J.length; c2++)
                    J[c2].range = J[c2]._r.slice(), E(J[c2], 1 - r4 / et);
                  o2 = (e4 = r4 * tt / et) / 2;
                }
                if (nt.isSubplotConstrained || !at && 1 === it.length) {
                  for (c2 = 0; c2 < K.length; c2++)
                    K[c2].range = K[c2]._r.slice(), E(K[c2], 1 - e4 / tt);
                  s3 = (r4 = e4 * et / tt) / 2;
                }
              }
              nt.isSubplotConstrained && at || Vt("x"), nt.isSubplotConstrained && it || Vt("y");
              var f4 = tt - e4, h2 = et - r4;
              !nt.isSubplotConstrained || it && at || (it ? (s3 = o2 ? 0 : e4 * et / tt, h2 = f4 * et / tt) : (o2 = s3 ? 0 : r4 * tt / et, f4 = h2 * tt / et)), Zt([o2, s3, f4, h2]), Ht(), t3.emit("plotly_relayouting", ht);
            }
            function p3(t4, e5, r5) {
              for (var n4, i3, a3 = 1 - e5, o3 = 0; o3 < t4.length; o3++) {
                var s4 = t4[o3];
                if (!s4.fixedrange) {
                  n4 = s4, i3 = s4._rl[a3] + (s4._rl[e5] - s4._rl[a3]) / B(r5 / s4._length);
                  var l3 = s4.l2r(i3);
                  false !== l3 && void 0 !== l3 && (s4.range[e5] = l3);
                }
              }
              return n4._length * (n4._rl[e5] - i3) / (n4._rl[e5] - n4._rl[a3]);
            }
          }
          function Vt(t4, e4) {
            for (var r4 = nt.isSubplotConstrained ? { x: K, y: J }[t4] : nt[t4 + "axes"], n3 = nt.isSubplotConstrained ? { x: J, y: K }[t4] : [], i2 = 0; i2 < r4.length; i2++) {
              var a2 = r4[i2], o2 = a2._id, s3 = nt.xLinks[o2] || nt.yLinks[o2], l2 = n3[0] || V2[s3] || X[s3];
              l2 && (e4 ? (e4[a2._name + ".range[0]"] = e4[l2._name + ".range[0]"], e4[a2._name + ".range[1]"] = e4[l2._name + ".range[1]"]) : a2.range = l2.range.slice());
            }
          }
          function Ht() {
            var r4, n3 = [];
            function i2(t4) {
              for (r4 = 0; r4 < t4.length; r4++)
                t4[r4].fixedrange || n3.push(t4[r4]._id);
            }
            function a2(t4, e4) {
              for (r4 = 0; r4 < t4.length; r4++) {
                var i3 = t4[r4], a3 = i3[e4];
                i3.fixedrange || "sync" !== a3.tickmode || n3.push(a3._id);
              }
            }
            for (st && (i2(J), i2(rt.xaxes), i2(nt.xaxes), a2(e3.overlays, "xaxis")), lt && (i2(K), i2(rt.yaxes), i2(nt.yaxes), a2(e3.overlays, "yaxis")), ht = {}, r4 = 0; r4 < n3.length; r4++) {
              var o2 = n3[r4], s3 = k(t3, o2);
              d2.drawOne(t3, s3, { skipTitle: true }), ht[s3._name + ".range[0]"] = s3.range[0], ht[s3._name + ".range[1]"] = s3.range[1];
            }
            d2.redrawComponents(t3, n3);
          }
          function qt() {
            if (!t3._transitioningWithDuration) {
              var e4 = t3._context.doubleClick, r4 = [];
              it && (r4 = r4.concat(J)), at && (r4 = r4.concat(K)), nt.xaxes && (r4 = r4.concat(nt.xaxes)), nt.yaxes && (r4 = r4.concat(nt.yaxes));
              var n3, i2, a2, o2 = {};
              if ("reset+autosize" === e4) {
                for (e4 = "autosize", i2 = 0; i2 < r4.length; i2++)
                  if ((n3 = r4[i2])._rangeInitial && (n3.range[0] !== n3._rangeInitial[0] || n3.range[1] !== n3._rangeInitial[1]) || !n3._rangeInitial && !n3.autorange) {
                    e4 = "reset";
                    break;
                  }
              }
              if ("autosize" === e4)
                for (i2 = 0; i2 < r4.length; i2++)
                  (n3 = r4[i2]).fixedrange || (o2[n3._name + ".autorange"] = true);
              else if ("reset" === e4)
                for ((it || rt.isSubplotConstrained) && (r4 = r4.concat(rt.xaxes)), at && !rt.isSubplotConstrained && (r4 = r4.concat(rt.yaxes)), rt.isSubplotConstrained && (it ? at || (r4 = r4.concat(K)) : r4 = r4.concat(J)), i2 = 0; i2 < r4.length; i2++)
                  (n3 = r4[i2]).fixedrange || (n3._rangeInitial ? (a2 = n3._rangeInitial, o2[n3._name + ".range[0]"] = a2[0], o2[n3._name + ".range[1]"] = a2[1]) : o2[n3._name + ".autorange"] = true);
              t3.emit("plotly_doubleclick", null), l.call("_guiRelayout", t3, o2);
            }
          }
          function Gt() {
            Zt([0, 0, tt, et]), i.syncOrAsync([T.previousPromises, function() {
              t3._fullLayout._replotting = false, l.call("_guiRelayout", t3, ht);
            }], t3);
          }
          function Zt(e4) {
            var r4, n3, a2, o2, s3 = t3._fullLayout, u3 = s3._plots, c2 = s3._subplots.cartesian;
            if (ct && l.subplotsRegistry.splom.drag(t3), ut) {
              for (r4 = 0; r4 < c2.length; r4++)
                if (a2 = (n3 = u3[c2[r4]]).xaxis, o2 = n3.yaxis, n3._scene) {
                  var f4 = i.simpleMap(a2.range, a2.r2l), p3 = i.simpleMap(o2.range, o2.r2l);
                  n3._scene.update({ range: [f4[0], p3[0], f4[1], p3[1]] });
                }
            }
            if ((ct || ut) && (_(t3), w2(t3)), ft) {
              var d3 = e4[2] / O2._length, g3 = e4[3] / I2._length;
              for (r4 = 0; r4 < c2.length; r4++) {
                a2 = (n3 = u3[c2[r4]]).xaxis, o2 = n3.yaxis;
                var m3, x2, b2, T2, k2 = (st || nt.isSubplotConstrained) && !a2.fixedrange && V2[a2._id], A2 = (lt || nt.isSubplotConstrained) && !o2.fixedrange && X[o2._id];
                if (k2 ? (m3 = d3, b2 = y2 || nt.isSubplotConstrained ? e4[0] : Xt(a2, m3)) : nt.xaHash[a2._id] ? (m3 = d3, b2 = e4[0] * a2._length / O2._length) : nt.yaHash[a2._id] ? (m3 = g3, b2 = "ns" === at ? -e4[1] * a2._length / I2._length : Xt(a2, m3, { n: "top", s: "bottom" }[at])) : b2 = Wt(a2, m3 = Yt(a2, d3, g3)), A2 ? (x2 = g3, T2 = v2 || nt.isSubplotConstrained ? e4[1] : Xt(o2, x2)) : nt.yaHash[o2._id] ? (x2 = g3, T2 = e4[1] * o2._length / I2._length) : nt.xaHash[o2._id] ? (x2 = d3, T2 = "ew" === it ? -e4[0] * o2._length / O2._length : Xt(o2, x2, { e: "right", w: "left" }[it])) : T2 = Wt(o2, x2 = Yt(o2, d3, g3)), m3 || x2) {
                  m3 || (m3 = 1), x2 || (x2 = 1);
                  var M2 = a2._offset - b2 / m3, S2 = o2._offset - T2 / x2;
                  n3.clipRect.call(h.setTranslate, b2, T2).call(h.setScale, m3, x2), n3.plot.call(h.setTranslate, M2, S2).call(h.setScale, 1 / m3, 1 / x2), m3 === n3.xScaleFactor && x2 === n3.yScaleFactor || (h.setPointGroupScale(n3.zoomScalePts, m3, x2), h.setTextPointsScale(n3.zoomScaleTxt, m3, x2)), h.hideOutsideRangePoints(n3.clipOnAxisFalseTraces, n3), n3.xScaleFactor = m3, n3.yScaleFactor = x2;
                }
              }
            }
          }
          function Yt(t4, e4, r4) {
            return t4.fixedrange ? 0 : st && rt.xaHash[t4._id] ? e4 : lt && (rt.isSubplotConstrained ? rt.xaHash : rt.yaHash)[t4._id] ? r4 : 0;
          }
          function Wt(t4, e4) {
            return e4 ? (t4.range = t4._r.slice(), E(t4, e4), Xt(t4, e4)) : 0;
          }
          function Xt(t4, e4, r4) {
            return t4._length * (1 - e4) * b[r4 || t4.constraintoward || "middle"];
          }
          return v2.length * y2.length != 1 && Y(bt, function(e4) {
            if (t3._context._scrollZoom.cartesian || t3._fullLayout._enablescrollzoom) {
              if (Ot(), t3._transitioningWithDuration)
                return e4.preventDefault(), void e4.stopPropagation();
              mt(), clearTimeout(Bt);
              var r4 = -e4.deltaY;
              if (isFinite(r4) || (r4 = e4.wheelDelta / 10), isFinite(r4)) {
                var n3, a2 = Math.exp(-Math.min(Math.max(r4, -20), 20) / 200), o2 = jt.draglayer.select(".nsewdrag").node().getBoundingClientRect(), s3 = (e4.clientX - o2.left) / o2.width, l2 = (o2.bottom - e4.clientY) / o2.height;
                if (st) {
                  for (y2 || (s3 = 0.5), n3 = 0; n3 < J.length; n3++)
                    u3(J[n3], s3, a2);
                  Vt("x"), Ft[2] *= a2, Ft[0] += Ft[2] * s3 * (1 / a2 - 1);
                }
                if (lt) {
                  for (v2 || (l2 = 0.5), n3 = 0; n3 < K.length; n3++)
                    u3(K[n3], l2, a2);
                  Vt("y"), Ft[3] *= a2, Ft[1] += Ft[3] * (1 - l2) * (1 / a2 - 1);
                }
                Zt(Ft), Ht(), t3.emit("plotly_relayouting", ht), Bt = setTimeout(function() {
                  t3._fullLayout && (Ft = [0, 0, tt, et], Gt());
                }, Nt), e4.preventDefault();
              } else
                i.log("Did not find wheel motion attributes: ", e4);
            }
            function u3(t4, e5, r5) {
              if (!t4.fixedrange) {
                var n4 = i.simpleMap(t4.range, t4.r2l), a3 = n4[0] + (n4[1] - n4[0]) * e5;
                t4.range = n4.map(function(e6) {
                  return t4.l2r(a3 + (e6 - a3) * r5);
                });
              }
            }
          }), bt;
        }, makeDragger: I, makeRectDragger: D, makeZoombox: N, makeCorners: j, updateZoombox: U, xyCorners: G, transitionZoombox: V, removeZoombox: H, showDoubleClickNotifier: q2, attachWheelEventHandler: Y };
      }, 4305: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(30211), a = r2(28569), o = r2(6964), s = r2(29323).makeDragBox, l = r2(85555).DRAGGERSIZE;
        e2.initInteractions = function(t3) {
          var r3 = t3._fullLayout;
          if (t3._context.staticPlot)
            n2.select(t3).selectAll(".drag").remove();
          else if (r3._has("cartesian") || r3._has("splom")) {
            Object.keys(r3._plots || {}).sort(function(t4, e3) {
              if ((r3._plots[t4].mainplot && true) === (r3._plots[e3].mainplot && true)) {
                var n3 = t4.split("y"), i2 = e3.split("y");
                return n3[0] === i2[0] ? Number(n3[1] || 1) - Number(i2[1] || 1) : Number(n3[0] || 1) - Number(i2[0] || 1);
              }
              return r3._plots[t4].mainplot ? 1 : -1;
            }).forEach(function(e3) {
              var n3 = r3._plots[e3], o3 = n3.xaxis, u = n3.yaxis;
              if (!n3.mainplot) {
                var c = s(t3, n3, o3._offset, u._offset, o3._length, u._length, "ns", "ew");
                c.onmousemove = function(r4) {
                  t3._fullLayout._rehover = function() {
                    t3._fullLayout._hoversubplot === e3 && t3._fullLayout._plots[e3] && i.hover(t3, r4, e3);
                  }, i.hover(t3, r4, e3), t3._fullLayout._lasthover = c, t3._fullLayout._hoversubplot = e3;
                }, c.onmouseout = function(e4) {
                  t3._dragging || (t3._fullLayout._hoversubplot = null, a.unhover(t3, e4));
                }, t3._context.showAxisDragHandles && (s(t3, n3, o3._offset - l, u._offset - l, l, l, "n", "w"), s(t3, n3, o3._offset + o3._length, u._offset - l, l, l, "n", "e"), s(t3, n3, o3._offset - l, u._offset + u._length, l, l, "s", "w"), s(t3, n3, o3._offset + o3._length, u._offset + u._length, l, l, "s", "e"));
              }
              if (t3._context.showAxisDragHandles) {
                if (e3 === o3._mainSubplot) {
                  var f2 = o3._mainLinePosition;
                  "top" === o3.side && (f2 -= l), s(t3, n3, o3._offset + 0.1 * o3._length, f2, 0.8 * o3._length, l, "", "ew"), s(t3, n3, o3._offset, f2, 0.1 * o3._length, l, "", "w"), s(t3, n3, o3._offset + 0.9 * o3._length, f2, 0.1 * o3._length, l, "", "e");
                }
                if (e3 === u._mainSubplot) {
                  var h = u._mainLinePosition;
                  "right" !== u.side && (h -= l), s(t3, n3, h, u._offset + 0.1 * u._length, l, 0.8 * u._length, "ns", ""), s(t3, n3, h, u._offset + 0.9 * u._length, l, 0.1 * u._length, "s", ""), s(t3, n3, h, u._offset, l, 0.1 * u._length, "n", "");
                }
              }
            });
            var o2 = r3._hoverlayer.node();
            o2.onmousemove = function(e3) {
              e3.target = t3._fullLayout._lasthover, i.hover(t3, e3, r3._hoversubplot);
            }, o2.onclick = function(e3) {
              e3.target = t3._fullLayout._lasthover, i.click(t3, e3);
            }, o2.onmousedown = function(e3) {
              t3._fullLayout._lasthover.onmousedown(e3);
            }, e2.updateFx(t3);
          }
        }, e2.updateFx = function(t3) {
          var e3 = t3._fullLayout, r3 = "pan" === e3.dragmode ? "move" : "crosshair";
          o(e3._draggers, r3);
        };
      }, 76325: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828), a = r2(41675);
        t2.exports = function(t3) {
          return function(e3, r3) {
            var o = e3[t3];
            if (Array.isArray(o))
              for (var s = n2.subplotsRegistry.cartesian, l = s.idRegex, u = r3._subplots, c = u.xaxis, f2 = u.yaxis, h = u.cartesian, p2 = r3._has("cartesian") || r3._has("gl2d"), d2 = 0; d2 < o.length; d2++) {
                var v = o[d2];
                if (i.isPlainObject(v)) {
                  var g2 = a.cleanId(v.xref, "x", false), y = a.cleanId(v.yref, "y", false), m2 = l.x.test(g2), x = l.y.test(y);
                  if (m2 || x) {
                    p2 || i.pushUnique(r3._basePlotModules, s);
                    var b = false;
                    m2 && -1 === c.indexOf(g2) && (c.push(g2), b = true), x && -1 === f2.indexOf(y) && (f2.push(y), b = true), b && m2 && x && h.push(g2 + y);
                  }
                }
              }
          };
        };
      }, 93612: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(73972), a = r2(71828), o = r2(74875), s = r2(91424), l = r2(27659).a0, u = r2(41675), c = r2(85555), f2 = r2(77922), h = a.ensureSingle;
        function p2(t3, e3, r3) {
          return a.ensureSingle(t3, e3, r3, function(t4) {
            t4.datum(r3);
          });
        }
        function d2(t3, e3, r3, a2, o2) {
          for (var u2, f3, h2, p3 = c.traceLayerClasses, d3 = t3._fullLayout, v2 = d3._modules, g3 = [], y2 = [], m2 = 0; m2 < v2.length; m2++) {
            var x = (u2 = v2[m2]).name, b = i.modules[x].categories;
            if (b.svg) {
              var _ = u2.layerName || x + "layer", w2 = u2.plot;
              h2 = (f3 = l(r3, w2))[0], r3 = f3[1], h2.length && g3.push({ i: p3.indexOf(_), className: _, plotMethod: w2, cdModule: h2 }), b.zoomScale && y2.push("." + _);
            }
          }
          g3.sort(function(t4, e4) {
            return t4.i - e4.i;
          });
          var T = e3.plot.selectAll("g.mlayer").data(g3, function(t4) {
            return t4.className;
          });
          if (T.enter().append("g").attr("class", function(t4) {
            return t4.className;
          }).classed("mlayer", true).classed("rangeplot", e3.isRangePlot), T.exit().remove(), T.order(), T.each(function(r4) {
            var i2 = n2.select(this), l2 = r4.className;
            r4.plotMethod(t3, e3, r4.cdModule, i2, a2, o2), -1 === c.clipOnAxisFalseQuery.indexOf("." + l2) && s.setClipUrl(i2, e3.layerClipId, t3);
          }), d3._has("scattergl") && (u2 = i.getModule("scattergl"), h2 = l(r3, u2)[0], u2.plot(t3, e3, h2)), !t3._context.staticPlot && (e3._hasClipOnAxisFalse && (e3.clipOnAxisFalseTraces = e3.plot.selectAll(c.clipOnAxisFalseQuery.join(",")).selectAll(".trace")), y2.length)) {
            var k = e3.plot.selectAll(y2.join(",")).selectAll(".trace");
            e3.zoomScalePts = k.selectAll("path.point"), e3.zoomScaleTxt = k.selectAll(".textpoint");
          }
        }
        function v(t3, e3) {
          var r3 = e3.plotgroup, n3 = e3.id, i2 = c.layerValue2layerClass[e3.xaxis.layer], a2 = c.layerValue2layerClass[e3.yaxis.layer], o2 = t3._fullLayout._hasOnlyLargeSploms;
          if (e3.mainplot) {
            var s2 = e3.mainplotinfo, l2 = s2.plotgroup, f3 = n3 + "-x", d3 = n3 + "-y";
            e3.minorGridlayer = s2.minorGridlayer, e3.gridlayer = s2.gridlayer, e3.zerolinelayer = s2.zerolinelayer, h(s2.overlinesBelow, "path", f3), h(s2.overlinesBelow, "path", d3), h(s2.overaxesBelow, "g", f3), h(s2.overaxesBelow, "g", d3), e3.plot = h(s2.overplot, "g", n3), h(s2.overlinesAbove, "path", f3), h(s2.overlinesAbove, "path", d3), h(s2.overaxesAbove, "g", f3), h(s2.overaxesAbove, "g", d3), e3.xlines = l2.select(".overlines-" + i2).select("." + f3), e3.ylines = l2.select(".overlines-" + a2).select("." + d3), e3.xaxislayer = l2.select(".overaxes-" + i2).select("." + f3), e3.yaxislayer = l2.select(".overaxes-" + a2).select("." + d3);
          } else if (o2)
            e3.xlines = h(r3, "path", "xlines-above"), e3.ylines = h(r3, "path", "ylines-above"), e3.xaxislayer = h(r3, "g", "xaxislayer-above"), e3.yaxislayer = h(r3, "g", "yaxislayer-above");
          else {
            var v2 = h(r3, "g", "layer-subplot");
            e3.shapelayer = h(v2, "g", "shapelayer"), e3.imagelayer = h(v2, "g", "imagelayer"), e3.minorGridlayer = h(r3, "g", "minor-gridlayer"), e3.gridlayer = h(r3, "g", "gridlayer"), e3.zerolinelayer = h(r3, "g", "zerolinelayer"), h(r3, "path", "xlines-below"), h(r3, "path", "ylines-below"), e3.overlinesBelow = h(r3, "g", "overlines-below"), h(r3, "g", "xaxislayer-below"), h(r3, "g", "yaxislayer-below"), e3.overaxesBelow = h(r3, "g", "overaxes-below"), e3.plot = h(r3, "g", "plot"), e3.overplot = h(r3, "g", "overplot"), e3.xlines = h(r3, "path", "xlines-above"), e3.ylines = h(r3, "path", "ylines-above"), e3.overlinesAbove = h(r3, "g", "overlines-above"), h(r3, "g", "xaxislayer-above"), h(r3, "g", "yaxislayer-above"), e3.overaxesAbove = h(r3, "g", "overaxes-above"), e3.xlines = r3.select(".xlines-" + i2), e3.ylines = r3.select(".ylines-" + a2), e3.xaxislayer = r3.select(".xaxislayer-" + i2), e3.yaxislayer = r3.select(".yaxislayer-" + a2);
          }
          o2 || (p2(e3.minorGridlayer, "g", e3.xaxis._id), p2(e3.minorGridlayer, "g", e3.yaxis._id), e3.minorGridlayer.selectAll("g").map(function(t4) {
            return t4[0];
          }).sort(u.idSort), p2(e3.gridlayer, "g", e3.xaxis._id), p2(e3.gridlayer, "g", e3.yaxis._id), e3.gridlayer.selectAll("g").map(function(t4) {
            return t4[0];
          }).sort(u.idSort)), e3.xlines.style("fill", "none").classed("crisp", true), e3.ylines.style("fill", "none").classed("crisp", true);
        }
        function g2(t3, e3) {
          if (t3) {
            var r3 = {};
            for (var i2 in t3.each(function(t4) {
              var i3 = t4[0];
              n2.select(this).remove(), y(i3, e3), r3[i3] = true;
            }), e3._plots)
              for (var a2 = e3._plots[i2].overlays || [], o2 = 0; o2 < a2.length; o2++) {
                var s2 = a2[o2];
                r3[s2.id] && s2.plot.selectAll(".trace").remove();
              }
          }
        }
        function y(t3, e3) {
          e3._draggers.selectAll("g." + t3).remove(), e3._defs.select("#clip" + e3._uid + t3 + "plot").remove();
        }
        e2.name = "cartesian", e2.attr = ["xaxis", "yaxis"], e2.idRoot = ["x", "y"], e2.idRegex = c.idRegex, e2.attrRegex = c.attrRegex, e2.attributes = r2(89502), e2.layoutAttributes = r2(13838), e2.supplyLayoutDefaults = r2(86763), e2.transitionAxes = r2(66847), e2.finalizeSubplots = function(t3, e3) {
          var r3, n3, i2, o2 = e3._subplots, s2 = o2.xaxis, l2 = o2.yaxis, f3 = o2.cartesian, h2 = f3.concat(o2.gl2d || []), p3 = {}, d3 = {};
          for (r3 = 0; r3 < h2.length; r3++) {
            var v2 = h2[r3].split("y");
            p3[v2[0]] = 1, d3["y" + v2[1]] = 1;
          }
          for (r3 = 0; r3 < s2.length; r3++)
            p3[n3 = s2[r3]] || (i2 = (t3[u.id2name(n3)] || {}).anchor, c.idRegex.y.test(i2) || (i2 = "y"), f3.push(n3 + i2), h2.push(n3 + i2), d3[i2] || (d3[i2] = 1, a.pushUnique(l2, i2)));
          for (r3 = 0; r3 < l2.length; r3++)
            d3[i2 = l2[r3]] || (n3 = (t3[u.id2name(i2)] || {}).anchor, c.idRegex.x.test(n3) || (n3 = "x"), f3.push(n3 + i2), h2.push(n3 + i2), p3[n3] || (p3[n3] = 1, a.pushUnique(s2, n3)));
          if (!h2.length) {
            for (var g3 in n3 = "", i2 = "", t3)
              c.attrRegex.test(g3) && ("x" === g3.charAt(0) ? (!n3 || +g3.substr(5) < +n3.substr(5)) && (n3 = g3) : (!i2 || +g3.substr(5) < +i2.substr(5)) && (i2 = g3));
            n3 = n3 ? u.name2id(n3) : "x", i2 = i2 ? u.name2id(i2) : "y", s2.push(n3), l2.push(i2), f3.push(n3 + i2);
          }
        }, e2.plot = function(t3, e3, r3, n3) {
          var i2, a2 = t3._fullLayout, o2 = a2._subplots.cartesian, s2 = t3.calcdata;
          if (!Array.isArray(e3))
            for (e3 = [], i2 = 0; i2 < s2.length; i2++)
              e3.push(i2);
          for (i2 = 0; i2 < o2.length; i2++) {
            for (var l2, u2 = o2[i2], c2 = a2._plots[u2], f3 = [], h2 = 0; h2 < s2.length; h2++) {
              var p3 = s2[h2], v2 = p3[0].trace;
              v2.xaxis + v2.yaxis === u2 && ((-1 !== e3.indexOf(v2.index) || v2.carpet) && (l2 && l2[0].trace.xaxis + l2[0].trace.yaxis === u2 && -1 !== ["tonextx", "tonexty", "tonext"].indexOf(v2.fill) && -1 === f3.indexOf(l2) && f3.push(l2), f3.push(p3)), l2 = p3);
            }
            d2(t3, c2, f3, r3, n3);
          }
        }, e2.clean = function(t3, e3, r3, n3) {
          var i2, a2, o2, s2 = n3._plots || {}, l2 = e3._plots || {}, c2 = n3._subplots || {};
          if (n3._hasOnlyLargeSploms && !e3._hasOnlyLargeSploms)
            for (o2 in s2)
              (i2 = s2[o2]).plotgroup && i2.plotgroup.remove();
          var f3 = n3._has && n3._has("gl"), h2 = e3._has && e3._has("gl");
          if (f3 && !h2)
            for (o2 in s2)
              (i2 = s2[o2])._scene && i2._scene.destroy();
          if (c2.xaxis && c2.yaxis) {
            var p3 = u.listIds({ _fullLayout: n3 });
            for (a2 = 0; a2 < p3.length; a2++) {
              var d3 = p3[a2];
              e3[u.id2name(d3)] || n3._infolayer.selectAll(".g-" + d3 + "title").remove();
            }
          }
          var v2 = n3._has && n3._has("cartesian"), m2 = e3._has && e3._has("cartesian");
          if (v2 && !m2)
            g2(n3._cartesianlayer.selectAll(".subplot"), n3), n3._defs.selectAll(".axesclip").remove(), delete n3._axisConstraintGroups, delete n3._axisMatchGroups;
          else if (c2.cartesian)
            for (a2 = 0; a2 < c2.cartesian.length; a2++) {
              var x = c2.cartesian[a2];
              if (!l2[x]) {
                var b = "." + x + ",." + x + "-x,." + x + "-y";
                n3._cartesianlayer.selectAll(b).remove(), y(x, n3);
              }
            }
        }, e2.drawFramework = function(t3) {
          var e3 = t3._fullLayout, r3 = function(t4) {
            var e4, r4, n3, i3, a2, o2, s2 = t4._fullLayout, l2 = s2._subplots.cartesian, u2 = l2.length, c2 = [], f3 = [];
            for (e4 = 0; e4 < u2; e4++) {
              n3 = l2[e4], a2 = (i3 = s2._plots[n3]).xaxis, o2 = i3.yaxis;
              var h2 = a2._mainAxis, p3 = o2._mainAxis, d3 = h2._id + p3._id, v2 = s2._plots[d3];
              i3.overlays = [], d3 !== n3 && v2 ? (i3.mainplot = d3, i3.mainplotinfo = v2, f3.push(n3)) : (i3.mainplot = void 0, i3.mainplotinfo = void 0, c2.push(n3));
            }
            for (e4 = 0; e4 < f3.length; e4++)
              n3 = f3[e4], (i3 = s2._plots[n3]).mainplotinfo.overlays.push(i3);
            var g3 = c2.concat(f3), y2 = new Array(u2);
            for (e4 = 0; e4 < u2; e4++) {
              n3 = g3[e4], a2 = (i3 = s2._plots[n3]).xaxis, o2 = i3.yaxis;
              var m2 = [n3, a2.layer, o2.layer, a2.overlaying || "", o2.overlaying || ""];
              for (r4 = 0; r4 < i3.overlays.length; r4++)
                m2.push(i3.overlays[r4].id);
              y2[e4] = m2;
            }
            return y2;
          }(t3), i2 = e3._cartesianlayer.selectAll(".subplot").data(r3, String);
          i2.enter().append("g").attr("class", function(t4) {
            return "subplot " + t4[0];
          }), i2.order(), i2.exit().call(g2, e3), i2.each(function(r4) {
            var i3 = r4[0], a2 = e3._plots[i3];
            a2.plotgroup = n2.select(this), v(t3, a2), a2.draglayer = h(e3._draggers, "g", i3);
          });
        }, e2.rangePlot = function(t3, e3, r3) {
          v(t3, e3), d2(t3, e3, r3), o.style(t3);
        }, e2.toSVG = function(t3) {
          var e3 = t3._fullLayout._glimages, r3 = n2.select(t3).selectAll(".svg-container");
          r3.filter(function(t4, e4) {
            return e4 === r3.size() - 1;
          }).selectAll(".gl-canvas-context, .gl-canvas-focus").each(function() {
            var t4 = this, r4 = t4.toDataURL("image/png");
            e3.append("svg:image").attr({ xmlns: f2.svg, "xlink:href": r4, preserveAspectRatio: "none", x: 0, y: 0, width: t4.style.width, height: t4.style.height });
          });
        }, e2.updateFx = r2(4305).updateFx;
      }, 13838: function(t2, e2, r2) {
        var n2 = r2(41940), i = r2(22399), a = r2(79952).P, o = r2(1426).extendFlat, s = r2(44467).templatedArray, l = r2(12663).descriptionWithDates, u = r2(50606).ONEDAY, c = r2(85555), f2 = c.HOUR_PATTERN, h = c.WEEKDAY_PATTERN, p2 = { valType: "enumerated", values: ["auto", "linear", "array"], editType: "ticks", impliedEdits: { tick0: void 0, dtick: void 0 } }, d2 = o({}, p2, { values: p2.values.slice().concat(["sync"]) });
        function v(t3) {
          return { valType: "integer", min: 0, dflt: t3 ? 5 : 0, editType: "ticks" };
        }
        var g2 = { valType: "any", editType: "ticks", impliedEdits: { tickmode: "linear" } }, y = { valType: "any", editType: "ticks", impliedEdits: { tickmode: "linear" } }, m2 = { valType: "data_array", editType: "ticks" }, x = { valType: "enumerated", values: ["outside", "inside", ""], editType: "ticks" };
        function b(t3) {
          var e3 = { valType: "number", min: 0, editType: "ticks" };
          return t3 || (e3.dflt = 5), e3;
        }
        function _(t3) {
          var e3 = { valType: "number", min: 0, editType: "ticks" };
          return t3 || (e3.dflt = 1), e3;
        }
        var w2 = { valType: "color", dflt: i.defaultLine, editType: "ticks" }, T = { valType: "color", dflt: i.lightLine, editType: "ticks" };
        function k(t3) {
          var e3 = { valType: "number", min: 0, editType: "ticks" };
          return t3 || (e3.dflt = 1), e3;
        }
        var A = o({}, a, { editType: "ticks" }), M = { valType: "boolean", editType: "ticks" };
        t2.exports = { visible: { valType: "boolean", editType: "plot" }, color: { valType: "color", dflt: i.defaultLine, editType: "ticks" }, title: { text: { valType: "string", editType: "ticks" }, font: n2({ editType: "ticks" }), standoff: { valType: "number", min: 0, editType: "ticks" }, editType: "ticks" }, type: { valType: "enumerated", values: ["-", "linear", "log", "date", "category", "multicategory"], dflt: "-", editType: "calc", _noTemplating: true }, autotypenumbers: { valType: "enumerated", values: ["convert types", "strict"], dflt: "convert types", editType: "calc" }, autorange: { valType: "enumerated", values: [true, false, "reversed"], dflt: true, editType: "axrange", impliedEdits: { "range[0]": void 0, "range[1]": void 0 } }, rangemode: { valType: "enumerated", values: ["normal", "tozero", "nonnegative"], dflt: "normal", editType: "plot" }, range: { valType: "info_array", items: [{ valType: "any", editType: "axrange", impliedEdits: { "^autorange": false }, anim: true }, { valType: "any", editType: "axrange", impliedEdits: { "^autorange": false }, anim: true }], editType: "axrange", impliedEdits: { autorange: false }, anim: true }, fixedrange: { valType: "boolean", dflt: false, editType: "calc" }, scaleanchor: { valType: "enumerated", values: [c.idRegex.x.toString(), c.idRegex.y.toString()], editType: "plot" }, scaleratio: { valType: "number", min: 0, dflt: 1, editType: "plot" }, constrain: { valType: "enumerated", values: ["range", "domain"], editType: "plot" }, constraintoward: { valType: "enumerated", values: ["left", "center", "right", "top", "middle", "bottom"], editType: "plot" }, matches: { valType: "enumerated", values: [c.idRegex.x.toString(), c.idRegex.y.toString()], editType: "calc" }, rangebreaks: s("rangebreak", { enabled: { valType: "boolean", dflt: true, editType: "calc" }, bounds: { valType: "info_array", items: [{ valType: "any", editType: "calc" }, { valType: "any", editType: "calc" }], editType: "calc" }, pattern: { valType: "enumerated", values: [h, f2, ""], editType: "calc" }, values: { valType: "info_array", freeLength: true, editType: "calc", items: { valType: "any", editType: "calc" } }, dvalue: { valType: "number", editType: "calc", min: 0, dflt: u }, editType: "calc" }), tickmode: d2, nticks: v(), tick0: g2, dtick: y, ticklabelstep: { valType: "integer", min: 1, dflt: 1, editType: "ticks" }, tickvals: m2, ticktext: { valType: "data_array", editType: "ticks" }, ticks: x, tickson: { valType: "enumerated", values: ["labels", "boundaries"], dflt: "labels", editType: "ticks" }, ticklabelmode: { valType: "enumerated", values: ["instant", "period"], dflt: "instant", editType: "ticks" }, ticklabelposition: { valType: "enumerated", values: ["outside", "inside", "outside top", "inside top", "outside left", "inside left", "outside right", "inside right", "outside bottom", "inside bottom"], dflt: "outside", editType: "calc" }, ticklabeloverflow: { valType: "enumerated", values: ["allow", "hide past div", "hide past domain"], editType: "calc" }, mirror: { valType: "enumerated", values: [true, "ticks", false, "all", "allticks"], dflt: false, editType: "ticks+layoutstyle" }, ticklen: b(), tickwidth: _(), tickcolor: w2, showticklabels: { valType: "boolean", dflt: true, editType: "ticks" }, labelalias: { valType: "any", dflt: false, editType: "ticks" }, automargin: { valType: "flaglist", flags: ["height", "width", "left", "right", "top", "bottom"], extras: [true, false], dflt: false, editType: "ticks" }, showspikes: { valType: "boolean", dflt: false, editType: "modebar" }, spikecolor: { valType: "color", dflt: null, editType: "none" }, spikethickness: { valType: "number", dflt: 3, editType: "none" }, spikedash: o({}, a, { dflt: "dash", editType: "none" }), spikemode: { valType: "flaglist", flags: ["toaxis", "across", "marker"], dflt: "toaxis", editType: "none" }, spikesnap: { valType: "enumerated", values: ["data", "cursor", "hovered data"], dflt: "hovered data", editType: "none" }, tickfont: n2({ editType: "ticks" }), tickangle: { valType: "angle", dflt: "auto", editType: "ticks" }, tickprefix: { valType: "string", dflt: "", editType: "ticks" }, showtickprefix: { valType: "enumerated", values: ["all", "first", "last", "none"], dflt: "all", editType: "ticks" }, ticksuffix: { valType: "string", dflt: "", editType: "ticks" }, showticksuffix: { valType: "enumerated", values: ["all", "first", "last", "none"], dflt: "all", editType: "ticks" }, showexponent: { valType: "enumerated", values: ["all", "first", "last", "none"], dflt: "all", editType: "ticks" }, exponentformat: { valType: "enumerated", values: ["none", "e", "E", "power", "SI", "B"], dflt: "B", editType: "ticks" }, minexponent: { valType: "number", dflt: 3, min: 0, editType: "ticks" }, separatethousands: { valType: "boolean", dflt: false, editType: "ticks" }, tickformat: { valType: "string", dflt: "", editType: "ticks", description: l("tick label") }, tickformatstops: s("tickformatstop", { enabled: { valType: "boolean", dflt: true, editType: "ticks" }, dtickrange: { valType: "info_array", items: [{ valType: "any", editType: "ticks" }, { valType: "any", editType: "ticks" }], editType: "ticks" }, value: { valType: "string", dflt: "", editType: "ticks" }, editType: "ticks" }), hoverformat: { valType: "string", dflt: "", editType: "none", description: l("hover text") }, showline: { valType: "boolean", dflt: false, editType: "ticks+layoutstyle" }, linecolor: { valType: "color", dflt: i.defaultLine, editType: "layoutstyle" }, linewidth: { valType: "number", min: 0, dflt: 1, editType: "ticks+layoutstyle" }, showgrid: M, gridcolor: T, gridwidth: k(), griddash: A, zeroline: { valType: "boolean", editType: "ticks" }, zerolinecolor: { valType: "color", dflt: i.defaultLine, editType: "ticks" }, zerolinewidth: { valType: "number", dflt: 1, editType: "ticks" }, showdividers: { valType: "boolean", dflt: true, editType: "ticks" }, dividercolor: { valType: "color", dflt: i.defaultLine, editType: "ticks" }, dividerwidth: { valType: "number", dflt: 1, editType: "ticks" }, anchor: { valType: "enumerated", values: ["free", c.idRegex.x.toString(), c.idRegex.y.toString()], editType: "plot" }, side: { valType: "enumerated", values: ["top", "bottom", "left", "right"], editType: "plot" }, overlaying: { valType: "enumerated", values: ["free", c.idRegex.x.toString(), c.idRegex.y.toString()], editType: "plot" }, minor: { tickmode: p2, nticks: v("minor"), tick0: g2, dtick: y, tickvals: m2, ticks: x, ticklen: b("minor"), tickwidth: _("minor"), tickcolor: w2, gridcolor: T, gridwidth: k("minor"), griddash: A, showgrid: M, editType: "ticks" }, layer: { valType: "enumerated", values: ["above traces", "below traces"], dflt: "above traces", editType: "plot" }, domain: { valType: "info_array", items: [{ valType: "number", min: 0, max: 1, editType: "plot" }, { valType: "number", min: 0, max: 1, editType: "plot" }], dflt: [0, 1], editType: "plot" }, position: { valType: "number", min: 0, max: 1, dflt: 0, editType: "plot" }, autoshift: { valType: "boolean", dflt: false, editType: "plot" }, shift: { valType: "number", editType: "plot" }, categoryorder: { valType: "enumerated", values: ["trace", "category ascending", "category descending", "array", "total ascending", "total descending", "min ascending", "min descending", "max ascending", "max descending", "sum ascending", "sum descending", "mean ascending", "mean descending", "median ascending", "median descending"], dflt: "trace", editType: "calc" }, categoryarray: { valType: "data_array", editType: "calc" }, uirevision: { valType: "any", editType: "none" }, editType: "calc", _deprecated: { autotick: { valType: "boolean", editType: "ticks" }, title: { valType: "string", editType: "ticks" }, titlefont: n2({ editType: "ticks" }) } };
      }, 86763: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901), a = r2(23469).isUnifiedHover, o = r2(98212), s = r2(44467), l = r2(10820), u = r2(13838), c = r2(951), f2 = r2(71453), h = r2(99082), p2 = r2(52830), d2 = r2(41675), v = d2.id2name, g2 = d2.name2id, y = r2(85555).AX_ID_PATTERN, m2 = r2(73972), x = m2.traceIs, b = m2.getComponentMethod;
        function _(t3, e3, r3) {
          Array.isArray(t3[e3]) ? t3[e3].push(r3) : t3[e3] = [r3];
        }
        t2.exports = function(t3, e3, r3) {
          var m3, w2, T = e3.autotypenumbers, k = {}, A = {}, M = {}, S = {}, E = {}, L = {}, C = {}, P = {}, O = {}, I = {};
          for (m3 = 0; m3 < r3.length; m3++) {
            var D = r3[m3];
            if (x(D, "cartesian") || x(D, "gl2d")) {
              var z, R;
              if (D.xaxis)
                z = v(D.xaxis), _(k, z, D);
              else if (D.xaxes)
                for (w2 = 0; w2 < D.xaxes.length; w2++)
                  _(k, v(D.xaxes[w2]), D);
              if (D.yaxis)
                R = v(D.yaxis), _(k, R, D);
              else if (D.yaxes)
                for (w2 = 0; w2 < D.yaxes.length; w2++)
                  _(k, v(D.yaxes[w2]), D);
              "funnel" === D.type ? "h" === D.orientation ? (z && (A[z] = true), R && (C[R] = true)) : R && (M[R] = true) : "image" === D.type ? (R && (P[R] = true), z && (P[z] = true)) : (R && (E[R] = true, L[R] = true), x(D, "carpet") && ("carpet" !== D.type || D._cheater) || z && (S[z] = true)), "carpet" === D.type && D._cheater && z && (A[z] = true), x(D, "2dMap") && (O[z] = true, O[R] = true), x(D, "oriented") && (I["h" === D.orientation ? R : z] = true);
            }
          }
          var F = e3._subplots, B = F.xaxis, N = F.yaxis, j = n2.simpleMap(B, v), U = n2.simpleMap(N, v), V = j.concat(U), H = i.background;
          B.length && N.length && (H = n2.coerce(t3, e3, l, "plot_bgcolor"));
          var q2, G, Z, Y, W, X = i.combine(H, e3.paper_bgcolor);
          function J() {
            var t4 = k[q2] || [];
            W._traceIndices = t4.map(function(t5) {
              return t5._expandedIndex;
            }), W._annIndices = [], W._shapeIndices = [], W._selectionIndices = [], W._imgIndices = [], W._subplotsWith = [], W._counterAxes = [], W._name = W._attr = q2, W._id = G;
          }
          function K(t4, e4) {
            return n2.coerce(Y, W, u, t4, e4);
          }
          function $(t4, e4) {
            return n2.coerce2(Y, W, u, t4, e4);
          }
          function Q(t4) {
            return "x" === t4 ? N : B;
          }
          function tt(e4, r4) {
            for (var n3 = "x" === e4 ? j : U, i2 = [], a2 = 0; a2 < n3.length; a2++) {
              var o2 = n3[a2];
              o2 === r4 || (t3[o2] || {}).overlaying || i2.push(g2(o2));
            }
            return i2;
          }
          var et = { x: Q("x"), y: Q("y") }, rt = et.x.concat(et.y), nt = {}, it = [];
          function at() {
            var t4 = Y.matches;
            y.test(t4) && -1 === rt.indexOf(t4) && (nt[t4] = Y.type, it = Object.keys(nt));
          }
          var ot = o(t3, e3), st = a(ot);
          for (m3 = 0; m3 < V.length; m3++) {
            q2 = V[m3], G = g2(q2), Z = q2.charAt(0), n2.isPlainObject(t3[q2]) || (t3[q2] = {}), Y = t3[q2], W = s.newContainer(e3, q2, Z + "axis"), J();
            var lt = "x" === Z && !S[q2] && A[q2] || "y" === Z && !E[q2] && M[q2], ut = "y" === Z && (!L[q2] && C[q2] || P[q2]), ct = { hasMinor: true, letter: Z, font: e3.font, outerTicks: O[q2], showGrid: !I[q2], data: k[q2] || [], bgColor: X, calendar: e3.calendar, automargin: true, visibleDflt: lt, reverseDflt: ut, autotypenumbersDflt: T, splomStash: ((e3._splomAxes || {})[Z] || {})[G] };
            K("uirevision", e3.uirevision), c(Y, W, K, ct), f2(Y, W, K, ct, e3);
            var ft = st && Z === ot.charAt(0), ht = $("spikecolor", st ? W.color : void 0), pt = $("spikethickness", st ? 1.5 : void 0), dt = $("spikedash", st ? "dot" : void 0), vt = $("spikemode", st ? "across" : void 0), gt = $("spikesnap");
            K("showspikes", !!(ft || ht || pt || dt || vt || gt)) || (delete W.spikecolor, delete W.spikethickness, delete W.spikedash, delete W.spikemode, delete W.spikesnap);
            var yt = v(Y.overlaying), mt = [0, 1];
            if (void 0 !== e3[yt]) {
              var xt = v(e3[yt].anchor);
              void 0 !== e3[xt] && (mt = e3[xt].domain);
            }
            p2(Y, W, K, { letter: Z, counterAxes: et[Z], overlayableAxes: tt(Z, q2), grid: e3.grid, overlayingDomain: mt }), K("title.standoff"), at(), W._input = Y;
          }
          for (m3 = 0; m3 < it.length; ) {
            G = it[m3++], Z = (q2 = v(G)).charAt(0), n2.isPlainObject(t3[q2]) || (t3[q2] = {}), Y = t3[q2], W = s.newContainer(e3, q2, Z + "axis"), J();
            var bt = { letter: Z, font: e3.font, outerTicks: O[q2], showGrid: !I[q2], data: [], bgColor: X, calendar: e3.calendar, automargin: true, visibleDflt: false, reverseDflt: false, autotypenumbersDflt: T, splomStash: ((e3._splomAxes || {})[Z] || {})[G] };
            K("uirevision", e3.uirevision), W.type = nt[G] || "linear", f2(Y, W, K, bt, e3), p2(Y, W, K, { letter: Z, counterAxes: et[Z], overlayableAxes: tt(Z, q2), grid: e3.grid }), K("fixedrange"), at(), W._input = Y;
          }
          var _t = b("rangeslider", "handleDefaults"), wt = b("rangeselector", "handleDefaults");
          for (m3 = 0; m3 < j.length; m3++)
            q2 = j[m3], Y = t3[q2], W = e3[q2], _t(t3, e3, q2), "date" === W.type && wt(Y, W, e3, U, W.calendar), K("fixedrange");
          for (m3 = 0; m3 < U.length; m3++) {
            q2 = U[m3], Y = t3[q2], W = e3[q2];
            var Tt = e3[v(W.anchor)];
            K("fixedrange", b("rangeslider", "isVisible")(Tt));
          }
          h.handleDefaults(t3, e3, { axIds: rt.concat(it).sort(d2.idSort), axHasImage: P });
        };
      }, 92128: function(t2, e2, r2) {
        var n2 = r2(84267).mix, i = r2(22399), a = r2(71828);
        t2.exports = function(t3, e3, r3, o) {
          var s = (o = o || {}).dfltColor;
          function l(r4, n3) {
            return a.coerce2(t3, e3, o.attributes, r4, n3);
          }
          var u = l("linecolor", s), c = l("linewidth");
          r3("showline", o.showLine || !!u || !!c) || (delete e3.linecolor, delete e3.linewidth);
          var f2 = l("gridcolor", n2(s, o.bgColor, o.blend || i.lightFraction).toRgbString()), h = l("gridwidth"), p2 = l("griddash");
          if (r3("showgrid", o.showGrid || !!f2 || !!h || !!p2) || (delete e3.gridcolor, delete e3.gridwidth, delete e3.griddash), o.hasMinor) {
            var d2 = l("minor.gridcolor", n2(e3.gridcolor, o.bgColor, 67).toRgbString()), v = l("minor.gridwidth", e3.gridwidth || 1), g2 = l("minor.griddash", e3.griddash || "solid");
            r3("minor.showgrid", !!d2 || !!v || !!g2) || (delete e3.minor.gridcolor, delete e3.minor.gridwidth, delete e3.minor.griddash);
          }
          if (!o.noZeroLine) {
            var y = l("zerolinecolor", s), m2 = l("zerolinewidth");
            r3("zeroline", o.showGrid || !!y || !!m2) || (delete e3.zerolinecolor, delete e3.zerolinewidth);
          }
        };
      }, 52830: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828);
        t2.exports = function(t3, e3, r3, a) {
          var o, s, l, u, c, f2, h = a.counterAxes || [], p2 = a.overlayableAxes || [], d2 = a.letter, v = a.grid, g2 = a.overlayingDomain;
          v && (s = v._domains[d2][v._axisMap[e3._id]], o = v._anchors[e3._id], s && (l = v[d2 + "side"].split(" ")[0], u = v.domain[d2]["right" === l || "top" === l ? 1 : 0])), s = s || [0, 1], o = o || (n2(t3.position) ? "free" : h[0] || "free"), l = l || ("x" === d2 ? "bottom" : "left"), u = u || 0, c = 0, f2 = false;
          var y = i.coerce(t3, e3, { anchor: { valType: "enumerated", values: ["free"].concat(h), dflt: o } }, "anchor"), m2 = i.coerce(t3, e3, { side: { valType: "enumerated", values: "x" === d2 ? ["bottom", "top"] : ["left", "right"], dflt: l } }, "side");
          "free" === y && ("y" === d2 && (r3("autoshift") && (u = "left" === m2 ? g2[0] : g2[1], f2 = !e3.automargin || e3.automargin, c = "left" === m2 ? -3 : 3), r3("shift", c)), r3("position", u)), r3("automargin", f2);
          var x = false;
          if (p2.length && (x = i.coerce(t3, e3, { overlaying: { valType: "enumerated", values: [false].concat(p2), dflt: false } }, "overlaying")), !x) {
            var b = r3("domain", s);
            b[0] > b[1] - 1 / 4096 && (e3.domain = s), i.noneOrAll(t3.domain, e3.domain, s), "sync" === e3.tickmode && (e3.tickmode = "auto");
          }
          return r3("layer"), e3;
        };
      }, 89426: function(t2, e2, r2) {
        var n2 = r2(59652);
        t2.exports = function(t3, e3, r3, i, a) {
          a || (a = {});
          var o = a.tickSuffixDflt, s = n2(t3);
          r3("tickprefix") && r3("showtickprefix", s), r3("ticksuffix", o) && r3("showticksuffix", s);
        };
      }, 42449: function(t2, e2, r2) {
        var n2 = r2(18783).FROM_BL;
        t2.exports = function(t3, e3, r3) {
          void 0 === r3 && (r3 = n2[t3.constraintoward || "center"]);
          var i = [t3.r2l(t3.range[0]), t3.r2l(t3.range[1])], a = i[0] + (i[1] - i[0]) * r3;
          t3.range = t3._input.range = [t3.l2r(a + (i[0] - a) * e3), t3.l2r(a + (i[1] - a) * e3)], t3.setScale();
        };
      }, 21994: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(84096).g0, a = r2(71828), o = a.numberFormat, s = r2(92770), l = a.cleanNumber, u = a.ms2DateTime, c = a.dateTime2ms, f2 = a.ensureNumber, h = a.isArrayOrTypedArray, p2 = r2(50606), d2 = p2.FP_SAFE, v = p2.BADNUM, g2 = p2.LOG_CLIP, y = p2.ONEWEEK, m2 = p2.ONEDAY, x = p2.ONEHOUR, b = p2.ONEMIN, _ = p2.ONESEC, w2 = r2(41675), T = r2(85555), k = T.HOUR_PATTERN, A = T.WEEKDAY_PATTERN;
        function M(t3) {
          return Math.pow(10, t3);
        }
        function S(t3) {
          return null != t3;
        }
        t2.exports = function(t3, e3) {
          e3 = e3 || {};
          var r3 = t3._id || "x", p3 = r3.charAt(0);
          function E(e4, r4) {
            if (e4 > 0)
              return Math.log(e4) / Math.LN10;
            if (e4 <= 0 && r4 && t3.range && 2 === t3.range.length) {
              var n3 = t3.range[0], i2 = t3.range[1];
              return 0.5 * (n3 + i2 - 2 * g2 * Math.abs(n3 - i2));
            }
            return v;
          }
          function L(e4, r4, n3, i2) {
            if ((i2 || {}).msUTC && s(e4))
              return +e4;
            var o2 = c(e4, n3 || t3.calendar);
            if (o2 === v) {
              if (!s(e4))
                return v;
              e4 = +e4;
              var l2 = Math.floor(10 * a.mod(e4 + 0.05, 1)), u2 = Math.round(e4 - l2 / 10);
              o2 = c(new Date(u2)) + l2 / 10;
            }
            return o2;
          }
          function C(e4, r4, n3) {
            return u(e4, r4, n3 || t3.calendar);
          }
          function P(e4) {
            return t3._categories[Math.round(e4)];
          }
          function O(e4) {
            if (S(e4)) {
              if (void 0 === t3._categoriesMap && (t3._categoriesMap = {}), void 0 !== t3._categoriesMap[e4])
                return t3._categoriesMap[e4];
              t3._categories.push("number" == typeof e4 ? String(e4) : e4);
              var r4 = t3._categories.length - 1;
              return t3._categoriesMap[e4] = r4, r4;
            }
            return v;
          }
          function I(e4) {
            if (t3._categoriesMap)
              return t3._categoriesMap[e4];
          }
          function D(t4) {
            var e4 = I(t4);
            return void 0 !== e4 ? e4 : s(t4) ? +t4 : void 0;
          }
          function z(t4) {
            return s(t4) ? +t4 : I(t4);
          }
          function R(t4, e4, r4) {
            return n2.round(r4 + e4 * t4, 2);
          }
          function F(t4, e4, r4) {
            return (t4 - r4) / e4;
          }
          var B = function(e4) {
            return s(e4) ? R(e4, t3._m, t3._b) : v;
          }, N = function(e4) {
            return F(e4, t3._m, t3._b);
          };
          if (t3.rangebreaks) {
            var j = "y" === p3;
            B = function(e4) {
              if (!s(e4))
                return v;
              var r4 = t3._rangebreaks.length;
              if (!r4)
                return R(e4, t3._m, t3._b);
              var n3 = j;
              t3.range[0] > t3.range[1] && (n3 = !n3);
              for (var i2 = n3 ? -1 : 1, a2 = i2 * e4, o2 = 0, l2 = 0; l2 < r4; l2++) {
                var u2 = i2 * t3._rangebreaks[l2].min, c2 = i2 * t3._rangebreaks[l2].max;
                if (a2 < u2)
                  break;
                if (!(a2 > c2)) {
                  o2 = a2 < (u2 + c2) / 2 ? l2 : l2 + 1;
                  break;
                }
                o2 = l2 + 1;
              }
              var f3 = t3._B[o2] || 0;
              return isFinite(f3) ? R(e4, t3._m2, f3) : 0;
            }, N = function(e4) {
              var r4 = t3._rangebreaks.length;
              if (!r4)
                return F(e4, t3._m, t3._b);
              for (var n3 = 0, i2 = 0; i2 < r4 && !(e4 < t3._rangebreaks[i2].pmin); i2++)
                e4 > t3._rangebreaks[i2].pmax && (n3 = i2 + 1);
              return F(e4, t3._m2, t3._B[n3]);
            };
          }
          t3.c2l = "log" === t3.type ? E : f2, t3.l2c = "log" === t3.type ? M : f2, t3.l2p = B, t3.p2l = N, t3.c2p = "log" === t3.type ? function(t4, e4) {
            return B(E(t4, e4));
          } : B, t3.p2c = "log" === t3.type ? function(t4) {
            return M(N(t4));
          } : N, -1 !== ["linear", "-"].indexOf(t3.type) ? (t3.d2r = t3.r2d = t3.d2c = t3.r2c = t3.d2l = t3.r2l = l, t3.c2d = t3.c2r = t3.l2d = t3.l2r = f2, t3.d2p = t3.r2p = function(e4) {
            return t3.l2p(l(e4));
          }, t3.p2d = t3.p2r = N, t3.cleanPos = f2) : "log" === t3.type ? (t3.d2r = t3.d2l = function(t4, e4) {
            return E(l(t4), e4);
          }, t3.r2d = t3.r2c = function(t4) {
            return M(l(t4));
          }, t3.d2c = t3.r2l = l, t3.c2d = t3.l2r = f2, t3.c2r = E, t3.l2d = M, t3.d2p = function(e4, r4) {
            return t3.l2p(t3.d2r(e4, r4));
          }, t3.p2d = function(t4) {
            return M(N(t4));
          }, t3.r2p = function(e4) {
            return t3.l2p(l(e4));
          }, t3.p2r = N, t3.cleanPos = f2) : "date" === t3.type ? (t3.d2r = t3.r2d = a.identity, t3.d2c = t3.r2c = t3.d2l = t3.r2l = L, t3.c2d = t3.c2r = t3.l2d = t3.l2r = C, t3.d2p = t3.r2p = function(e4, r4, n3) {
            return t3.l2p(L(e4, 0, n3));
          }, t3.p2d = t3.p2r = function(t4, e4, r4) {
            return C(N(t4), e4, r4);
          }, t3.cleanPos = function(e4) {
            return a.cleanDate(e4, v, t3.calendar);
          }) : "category" === t3.type ? (t3.d2c = t3.d2l = O, t3.r2d = t3.c2d = t3.l2d = P, t3.d2r = t3.d2l_noadd = D, t3.r2c = function(e4) {
            var r4 = z(e4);
            return void 0 !== r4 ? r4 : t3.fraction2r(0.5);
          }, t3.l2r = t3.c2r = f2, t3.r2l = z, t3.d2p = function(e4) {
            return t3.l2p(t3.r2c(e4));
          }, t3.p2d = function(t4) {
            return P(N(t4));
          }, t3.r2p = t3.d2p, t3.p2r = N, t3.cleanPos = function(t4) {
            return "string" == typeof t4 && "" !== t4 ? t4 : f2(t4);
          }) : "multicategory" === t3.type && (t3.r2d = t3.c2d = t3.l2d = P, t3.d2r = t3.d2l_noadd = D, t3.r2c = function(e4) {
            var r4 = D(e4);
            return void 0 !== r4 ? r4 : t3.fraction2r(0.5);
          }, t3.r2c_just_indices = I, t3.l2r = t3.c2r = f2, t3.r2l = D, t3.d2p = function(e4) {
            return t3.l2p(t3.r2c(e4));
          }, t3.p2d = function(t4) {
            return P(N(t4));
          }, t3.r2p = t3.d2p, t3.p2r = N, t3.cleanPos = function(t4) {
            return Array.isArray(t4) || "string" == typeof t4 && "" !== t4 ? t4 : f2(t4);
          }, t3.setupMultiCategory = function(n3) {
            var i2, o2, s2 = t3._traceIndices, l2 = t3._matchGroup;
            if (l2 && 0 === t3._categories.length) {
              for (var u2 in l2)
                if (u2 !== r3) {
                  var c2 = e3[w2.id2name(u2)];
                  s2 = s2.concat(c2._traceIndices);
                }
            }
            var f3 = [[0, {}], [0, {}]], d3 = [];
            for (i2 = 0; i2 < s2.length; i2++) {
              var v2 = n3[s2[i2]];
              if (p3 in v2) {
                var g3 = v2[p3], y2 = v2._length || a.minRowLength(g3);
                if (h(g3[0]) && h(g3[1]))
                  for (o2 = 0; o2 < y2; o2++) {
                    var m3 = g3[0][o2], x2 = g3[1][o2];
                    S(m3) && S(x2) && (d3.push([m3, x2]), m3 in f3[0][1] || (f3[0][1][m3] = f3[0][0]++), x2 in f3[1][1] || (f3[1][1][x2] = f3[1][0]++));
                  }
              }
            }
            for (d3.sort(function(t4, e4) {
              var r4 = f3[0][1], n4 = r4[t4[0]] - r4[e4[0]];
              if (n4)
                return n4;
              var i3 = f3[1][1];
              return i3[t4[1]] - i3[e4[1]];
            }), i2 = 0; i2 < d3.length; i2++)
              O(d3[i2]);
          }), t3.fraction2r = function(e4) {
            var r4 = t3.r2l(t3.range[0]), n3 = t3.r2l(t3.range[1]);
            return t3.l2r(r4 + e4 * (n3 - r4));
          }, t3.r2fraction = function(e4) {
            var r4 = t3.r2l(t3.range[0]), n3 = t3.r2l(t3.range[1]);
            return (t3.r2l(e4) - r4) / (n3 - r4);
          }, t3.cleanRange = function(e4, r4) {
            r4 || (r4 = {}), e4 || (e4 = "range");
            var n3, i2, o2 = a.nestedProperty(t3, e4).get();
            if (i2 = (i2 = "date" === t3.type ? a.dfltRange(t3.calendar) : "y" === p3 ? T.DFLTRANGEY : "realaxis" === t3._name ? [0, 1] : r4.dfltRange || T.DFLTRANGEX).slice(), "tozero" !== t3.rangemode && "nonnegative" !== t3.rangemode || (i2[0] = 0), o2 && 2 === o2.length)
              for ("date" !== t3.type || t3.autorange || (o2[0] = a.cleanDate(o2[0], v, t3.calendar), o2[1] = a.cleanDate(o2[1], v, t3.calendar)), n3 = 0; n3 < 2; n3++)
                if ("date" === t3.type) {
                  if (!a.isDateTime(o2[n3], t3.calendar)) {
                    t3[e4] = i2;
                    break;
                  }
                  if (t3.r2l(o2[0]) === t3.r2l(o2[1])) {
                    var l2 = a.constrain(t3.r2l(o2[0]), a.MIN_MS + 1e3, a.MAX_MS - 1e3);
                    o2[0] = t3.l2r(l2 - 1e3), o2[1] = t3.l2r(l2 + 1e3);
                    break;
                  }
                } else {
                  if (!s(o2[n3])) {
                    if (!s(o2[1 - n3])) {
                      t3[e4] = i2;
                      break;
                    }
                    o2[n3] = o2[1 - n3] * (n3 ? 10 : 0.1);
                  }
                  if (o2[n3] < -d2 ? o2[n3] = -d2 : o2[n3] > d2 && (o2[n3] = d2), o2[0] === o2[1]) {
                    var u2 = Math.max(1, Math.abs(1e-6 * o2[0]));
                    o2[0] -= u2, o2[1] += u2;
                  }
                }
            else
              a.nestedProperty(t3, e4).set(i2);
          }, t3.setScale = function(r4) {
            var n3 = e3._size;
            if (t3.overlaying) {
              var i2 = w2.getFromId({ _fullLayout: e3 }, t3.overlaying);
              t3.domain = i2.domain;
            }
            var a2 = r4 && t3._r ? "_r" : "range", o2 = t3.calendar;
            t3.cleanRange(a2);
            var s2, l2, u2 = t3.r2l(t3[a2][0], o2), c2 = t3.r2l(t3[a2][1], o2), f3 = "y" === p3;
            if (f3 ? (t3._offset = n3.t + (1 - t3.domain[1]) * n3.h, t3._length = n3.h * (t3.domain[1] - t3.domain[0]), t3._m = t3._length / (u2 - c2), t3._b = -t3._m * c2) : (t3._offset = n3.l + t3.domain[0] * n3.w, t3._length = n3.w * (t3.domain[1] - t3.domain[0]), t3._m = t3._length / (c2 - u2), t3._b = -t3._m * u2), t3._rangebreaks = [], t3._lBreaks = 0, t3._m2 = 0, t3._B = [], t3.rangebreaks && (t3._rangebreaks = t3.locateBreaks(Math.min(u2, c2), Math.max(u2, c2)), t3._rangebreaks.length)) {
              for (s2 = 0; s2 < t3._rangebreaks.length; s2++)
                l2 = t3._rangebreaks[s2], t3._lBreaks += Math.abs(l2.max - l2.min);
              var h2 = f3;
              u2 > c2 && (h2 = !h2), h2 && t3._rangebreaks.reverse();
              var d3 = h2 ? -1 : 1;
              for (t3._m2 = d3 * t3._length / (Math.abs(c2 - u2) - t3._lBreaks), t3._B.push(-t3._m2 * (f3 ? c2 : u2)), s2 = 0; s2 < t3._rangebreaks.length; s2++)
                l2 = t3._rangebreaks[s2], t3._B.push(t3._B[t3._B.length - 1] - d3 * t3._m2 * (l2.max - l2.min));
              for (s2 = 0; s2 < t3._rangebreaks.length; s2++)
                (l2 = t3._rangebreaks[s2]).pmin = B(l2.min), l2.pmax = B(l2.max);
            }
            if (!isFinite(t3._m) || !isFinite(t3._b) || t3._length < 0)
              throw e3._replotting = false, new Error("Something went wrong with axis scaling");
          }, t3.maskBreaks = function(e4) {
            var r4, n3, i2, o2, s2, u2 = t3.rangebreaks || [];
            u2._cachedPatterns || (u2._cachedPatterns = u2.map(function(e5) {
              return e5.enabled && e5.bounds ? a.simpleMap(e5.bounds, e5.pattern ? l : t3.d2c) : null;
            })), u2._cachedValues || (u2._cachedValues = u2.map(function(e5) {
              return e5.enabled && e5.values ? a.simpleMap(e5.values, t3.d2c).sort(a.sorterAsc) : null;
            }));
            for (var c2 = 0; c2 < u2.length; c2++) {
              var f3 = u2[c2];
              if (f3.enabled) {
                if (f3.bounds) {
                  var h2 = f3.pattern;
                  switch (n3 = (r4 = u2._cachedPatterns[c2])[0], i2 = r4[1], h2) {
                    case A:
                      o2 = (s2 = new Date(e4)).getUTCDay(), n3 > i2 && (i2 += 7, o2 < n3 && (o2 += 7));
                      break;
                    case k:
                      o2 = (s2 = new Date(e4)).getUTCHours() + (s2.getUTCMinutes() / 60 + s2.getUTCSeconds() / 3600 + s2.getUTCMilliseconds() / 36e5), n3 > i2 && (i2 += 24, o2 < n3 && (o2 += 24));
                      break;
                    case "":
                      o2 = e4;
                  }
                  if (o2 >= n3 && o2 < i2)
                    return v;
                } else
                  for (var p4 = u2._cachedValues[c2], d3 = 0; d3 < p4.length; d3++)
                    if (i2 = (n3 = p4[d3]) + f3.dvalue, e4 >= n3 && e4 < i2)
                      return v;
              }
            }
            return e4;
          }, t3.locateBreaks = function(e4, r4) {
            var n3, i2, o2, s2, u2 = [];
            if (!t3.rangebreaks)
              return u2;
            var c2 = t3.rangebreaks.slice().sort(function(t4, e5) {
              return t4.pattern === A && e5.pattern === k ? -1 : e5.pattern === A && t4.pattern === k ? 1 : 0;
            }), f3 = function(t4, n4) {
              if ((t4 = a.constrain(t4, e4, r4)) !== (n4 = a.constrain(n4, e4, r4))) {
                for (var i3 = true, o3 = 0; o3 < u2.length; o3++) {
                  var s3 = u2[o3];
                  t4 < s3.max && n4 >= s3.min && (t4 < s3.min && (s3.min = t4), n4 > s3.max && (s3.max = n4), i3 = false);
                }
                i3 && u2.push({ min: t4, max: n4 });
              }
            };
            for (n3 = 0; n3 < c2.length; n3++) {
              var h2 = c2[n3];
              if (h2.enabled)
                if (h2.bounds) {
                  var p4 = e4, d3 = r4;
                  h2.pattern && (p4 = Math.floor(p4)), o2 = (i2 = a.simpleMap(h2.bounds, h2.pattern ? l : t3.r2l))[0], s2 = i2[1];
                  var v2, g3, w3 = new Date(p4);
                  switch (h2.pattern) {
                    case A:
                      g3 = y, v2 = (s2 - o2 + (s2 < o2 ? 7 : 0)) * m2, p4 += o2 * m2 - (w3.getUTCDay() * m2 + w3.getUTCHours() * x + w3.getUTCMinutes() * b + w3.getUTCSeconds() * _ + w3.getUTCMilliseconds());
                      break;
                    case k:
                      g3 = m2, v2 = (s2 - o2 + (s2 < o2 ? 24 : 0)) * x, p4 += o2 * x - (w3.getUTCHours() * x + w3.getUTCMinutes() * b + w3.getUTCSeconds() * _ + w3.getUTCMilliseconds());
                      break;
                    default:
                      p4 = Math.min(i2[0], i2[1]), v2 = g3 = (d3 = Math.max(i2[0], i2[1])) - p4;
                  }
                  for (var T2 = p4; T2 < d3; T2 += g3)
                    f3(T2, T2 + v2);
                } else
                  for (var M2 = a.simpleMap(h2.values, t3.d2c), S2 = 0; S2 < M2.length; S2++)
                    f3(o2 = M2[S2], s2 = o2 + h2.dvalue);
            }
            return u2.sort(function(t4, e5) {
              return t4.min - e5.min;
            }), u2;
          }, t3.makeCalcdata = function(e4, r4, n3) {
            var i2, o2, s2, l2, u2 = t3.type, c2 = "date" === u2 && e4[r4 + "calendar"];
            if (r4 in e4) {
              if (i2 = e4[r4], l2 = e4._length || a.minRowLength(i2), a.isTypedArray(i2) && ("linear" === u2 || "log" === u2)) {
                if (l2 === i2.length)
                  return i2;
                if (i2.subarray)
                  return i2.subarray(0, l2);
              }
              if ("multicategory" === u2)
                return function(t4, e5) {
                  for (var r5 = new Array(e5), n4 = 0; n4 < e5; n4++) {
                    var i3 = (t4[0] || [])[n4], a2 = (t4[1] || [])[n4];
                    r5[n4] = I([i3, a2]);
                  }
                  return r5;
                }(i2, l2);
              for (o2 = new Array(l2), s2 = 0; s2 < l2; s2++)
                o2[s2] = t3.d2c(i2[s2], 0, c2, n3);
            } else {
              var f3 = r4 + "0" in e4 ? t3.d2c(e4[r4 + "0"], 0, c2) : 0, h2 = e4["d" + r4] ? Number(e4["d" + r4]) : 1;
              for (i2 = e4[{ x: "y", y: "x" }[r4]], l2 = e4._length || i2.length, o2 = new Array(l2), s2 = 0; s2 < l2; s2++)
                o2[s2] = f3 + s2 * h2;
            }
            if (t3.rangebreaks)
              for (s2 = 0; s2 < l2; s2++)
                o2[s2] = t3.maskBreaks(o2[s2]);
            return o2;
          }, t3.isValidRange = function(e4) {
            return Array.isArray(e4) && 2 === e4.length && s(t3.r2l(e4[0])) && s(t3.r2l(e4[1]));
          }, t3.isPtWithinRange = function(e4, r4) {
            var n3 = t3.c2l(e4[p3], null, r4), i2 = t3.r2l(t3.range[0]), a2 = t3.r2l(t3.range[1]);
            return i2 < a2 ? i2 <= n3 && n3 <= a2 : a2 <= n3 && n3 <= i2;
          }, t3._emptyCategories = function() {
            t3._categories = [], t3._categoriesMap = {};
          }, t3.clearCalc = function() {
            var r4 = t3._matchGroup;
            if (r4) {
              var n3 = null, i2 = null;
              for (var a2 in r4) {
                var o2 = e3[w2.id2name(a2)];
                if (o2._categories) {
                  n3 = o2._categories, i2 = o2._categoriesMap;
                  break;
                }
              }
              n3 && i2 ? (t3._categories = n3, t3._categoriesMap = i2) : t3._emptyCategories();
            } else
              t3._emptyCategories();
            if (t3._initialCategories)
              for (var s2 = 0; s2 < t3._initialCategories.length; s2++)
                O(t3._initialCategories[s2]);
          }, t3.sortByInitialCategories = function() {
            var n3 = [];
            if (t3._emptyCategories(), t3._initialCategories)
              for (var i2 = 0; i2 < t3._initialCategories.length; i2++)
                O(t3._initialCategories[i2]);
            n3 = n3.concat(t3._traceIndices);
            var a2 = t3._matchGroup;
            for (var o2 in a2)
              if (r3 !== o2) {
                var s2 = e3[w2.id2name(o2)];
                s2._categories = t3._categories, s2._categoriesMap = t3._categoriesMap, n3 = n3.concat(s2._traceIndices);
              }
            return n3;
          };
          var U = e3._d3locale;
          "date" === t3.type && (t3._dateFormat = U ? U.timeFormat : i, t3._extraFormat = e3._extraFormat), t3._separators = e3.separators, t3._numFormat = U ? U.numberFormat : o, delete t3._minDtick, delete t3._forceTick0;
        };
      }, 59652: function(t2) {
        t2.exports = function(t3) {
          var e2 = ["showexponent", "showtickprefix", "showticksuffix"].filter(function(e3) {
            return void 0 !== t3[e3];
          });
          if (e2.every(function(r2) {
            return t3[r2] === t3[e2[0]];
          }) || 1 === e2.length)
            return t3[e2[0]];
        };
      }, 96115: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901).contrast, a = r2(13838), o = r2(59652), s = r2(85501);
        function l(t3, e3) {
          function r3(r4, i2) {
            return n2.coerce(t3, e3, a.tickformatstops, r4, i2);
          }
          r3("enabled") && (r3("dtickrange"), r3("value"));
        }
        t2.exports = function(t3, e3, r3, u, c) {
          c || (c = {});
          var f2 = r3("labelalias");
          n2.isPlainObject(f2) || delete e3.labelalias;
          var h = o(t3);
          if (r3("showticklabels")) {
            var p2 = c.font || {}, d2 = e3.color, v = -1 !== (e3.ticklabelposition || "").indexOf("inside") ? i(c.bgColor) : d2 && d2 !== a.color.dflt ? d2 : p2.color;
            if (n2.coerceFont(r3, "tickfont", { family: p2.family, size: p2.size, color: v }), c.noTicklabelstep || "multicategory" === u || "log" === u || r3("ticklabelstep"), c.noAng || r3("tickangle"), "category" !== u) {
              var g2 = r3("tickformat");
              s(t3, e3, { name: "tickformatstops", inclusionAttr: "enabled", handleItemDefaults: l }), e3.tickformatstops.length || delete e3.tickformatstops, c.noExp || g2 || "date" === u || (r3("showexponent", h), r3("exponentformat"), r3("minexponent"), r3("separatethousands"));
            }
          }
        };
      }, 38701: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(13838);
        t2.exports = function(t3, e3, r3, a) {
          var o = a.isMinor, s = o ? t3.minor || {} : t3, l = o ? e3.minor : e3, u = o ? i.minor : i, c = o ? "minor." : "", f2 = n2.coerce2(s, l, u, "ticklen", o ? 0.6 * (e3.ticklen || 5) : void 0), h = n2.coerce2(s, l, u, "tickwidth", o ? e3.tickwidth || 1 : void 0), p2 = n2.coerce2(s, l, u, "tickcolor", (o ? e3.tickcolor : void 0) || l.color);
          r3(c + "ticks", !o && a.outerTicks || f2 || h || p2 ? "outside" : "") || (delete l.ticklen, delete l.tickwidth, delete l.tickcolor);
        };
      }, 26218: function(t2, e2, r2) {
        var n2 = r2(66287), i = r2(71828).isArrayOrTypedArray;
        t2.exports = function(t3, e3, r3, a, o) {
          o || (o = {});
          var s = o.isMinor, l = s ? t3.minor || {} : t3, u = s ? e3.minor : e3, c = s ? "minor." : "";
          function f2(t4) {
            var e4 = l[t4];
            return void 0 !== e4 ? e4 : (u._template || {})[t4];
          }
          var h = f2("tick0"), p2 = f2("dtick"), d2 = f2("tickvals"), v = r3(c + "tickmode", i(d2) ? "array" : p2 ? "linear" : "auto");
          if ("auto" === v || "sync" === v)
            r3(c + "nticks");
          else if ("linear" === v) {
            var g2 = u.dtick = n2.dtick(p2, a);
            u.tick0 = n2.tick0(h, a, e3.calendar, g2);
          } else
            "multicategory" !== a && (void 0 === r3(c + "tickvals") ? u.tickmode = "auto" : s || r3("ticktext"));
        };
      }, 66847: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(73972), a = r2(71828), o = r2(91424), s = r2(89298);
        t2.exports = function(t3, e3, r3, l) {
          var u = t3._fullLayout;
          if (0 !== e3.length) {
            var c, f2, h, p2;
            l && (c = l());
            var d2 = n2.ease(r3.easing);
            return t3._transitionData._interruptCallbacks.push(function() {
              return window.cancelAnimationFrame(p2), p2 = null, function() {
                for (var r4 = {}, n3 = 0; n3 < e3.length; n3++) {
                  var a2 = e3[n3], o2 = a2.plotinfo.xaxis, s2 = a2.plotinfo.yaxis;
                  a2.xr0 && (r4[o2._name + ".range"] = a2.xr0.slice()), a2.yr0 && (r4[s2._name + ".range"] = a2.yr0.slice());
                }
                return i.call("relayout", t3, r4).then(function() {
                  for (var t4 = 0; t4 < e3.length; t4++)
                    v(e3[t4].plotinfo);
                });
              }();
            }), f2 = Date.now(), p2 = window.requestAnimationFrame(function n3() {
              h = Date.now();
              for (var a2 = Math.min(1, (h - f2) / r3.duration), o2 = d2(a2), s2 = 0; s2 < e3.length; s2++)
                g2(e3[s2], o2);
              h - f2 > r3.duration ? (function() {
                for (var r4 = {}, n4 = 0; n4 < e3.length; n4++) {
                  var a3 = e3[n4], o3 = a3.plotinfo.xaxis, s3 = a3.plotinfo.yaxis;
                  a3.xr1 && (r4[o3._name + ".range"] = a3.xr1.slice()), a3.yr1 && (r4[s3._name + ".range"] = a3.yr1.slice());
                }
                c && c(), i.call("relayout", t3, r4).then(function() {
                  for (var t4 = 0; t4 < e3.length; t4++)
                    v(e3[t4].plotinfo);
                });
              }(), p2 = window.cancelAnimationFrame(n3)) : p2 = window.requestAnimationFrame(n3);
            }), Promise.resolve();
          }
          function v(t4) {
            var e4 = t4.xaxis, r4 = t4.yaxis;
            u._defs.select("#" + t4.clipId + "> rect").call(o.setTranslate, 0, 0).call(o.setScale, 1, 1), t4.plot.call(o.setTranslate, e4._offset, r4._offset).call(o.setScale, 1, 1);
            var n3 = t4.plot.selectAll(".scatterlayer .trace");
            n3.selectAll(".point").call(o.setPointGroupScale, 1, 1), n3.selectAll(".textpoint").call(o.setTextPointsScale, 1, 1), n3.call(o.hideOutsideRangePoints, t4);
          }
          function g2(e4, r4) {
            var n3 = e4.plotinfo, i2 = n3.xaxis, l2 = n3.yaxis, u2 = i2._length, c2 = l2._length, f3 = !!e4.xr1, h2 = !!e4.yr1, p3 = [];
            if (f3) {
              var d3 = a.simpleMap(e4.xr0, i2.r2l), v2 = a.simpleMap(e4.xr1, i2.r2l), g3 = d3[1] - d3[0], y = v2[1] - v2[0];
              p3[0] = (d3[0] * (1 - r4) + r4 * v2[0] - d3[0]) / (d3[1] - d3[0]) * u2, p3[2] = u2 * (1 - r4 + r4 * y / g3), i2.range[0] = i2.l2r(d3[0] * (1 - r4) + r4 * v2[0]), i2.range[1] = i2.l2r(d3[1] * (1 - r4) + r4 * v2[1]);
            } else
              p3[0] = 0, p3[2] = u2;
            if (h2) {
              var m2 = a.simpleMap(e4.yr0, l2.r2l), x = a.simpleMap(e4.yr1, l2.r2l), b = m2[1] - m2[0], _ = x[1] - x[0];
              p3[1] = (m2[1] * (1 - r4) + r4 * x[1] - m2[1]) / (m2[0] - m2[1]) * c2, p3[3] = c2 * (1 - r4 + r4 * _ / b), l2.range[0] = i2.l2r(m2[0] * (1 - r4) + r4 * x[0]), l2.range[1] = l2.l2r(m2[1] * (1 - r4) + r4 * x[1]);
            } else
              p3[1] = 0, p3[3] = c2;
            s.drawOne(t3, i2, { skipTitle: true }), s.drawOne(t3, l2, { skipTitle: true }), s.redrawComponents(t3, [i2._id, l2._id]);
            var w2 = f3 ? u2 / p3[2] : 1, T = h2 ? c2 / p3[3] : 1, k = f3 ? p3[0] : 0, A = h2 ? p3[1] : 0, M = f3 ? p3[0] / p3[2] * u2 : 0, S = h2 ? p3[1] / p3[3] * c2 : 0, E = i2._offset - M, L = l2._offset - S;
            n3.clipRect.call(o.setTranslate, k, A).call(o.setScale, 1 / w2, 1 / T), n3.plot.call(o.setTranslate, E, L).call(o.setScale, w2, T), o.setPointGroupScale(n3.zoomScalePts, 1 / w2, 1 / T), o.setTextPointsScale(n3.zoomScaleTxt, 1 / w2, 1 / T);
          }
          s.redrawComponents(t3);
        };
      }, 951: function(t2, e2, r2) {
        var n2 = r2(73972).traceIs, i = r2(4322);
        function a(t3) {
          return { v: "x", h: "y" }[t3.orientation || "v"];
        }
        function o(t3, e3) {
          var r3 = a(t3), i2 = n2(t3, "box-violin"), o2 = n2(t3._fullInput || {}, "candlestick");
          return i2 && !o2 && e3 === r3 && void 0 === t3[r3] && void 0 === t3[r3 + "0"];
        }
        t2.exports = function(t3, e3, r3, s) {
          r3("autotypenumbers", s.autotypenumbersDflt), "-" === r3("type", (s.splomStash || {}).type) && (function(t4, e4) {
            if ("-" === t4.type) {
              var r4, s2 = t4._id, l = s2.charAt(0);
              -1 !== s2.indexOf("scene") && (s2 = l);
              var u = function(t5, e5, r5) {
                for (var n3 = 0; n3 < t5.length; n3++) {
                  var i2 = t5[n3];
                  if ("splom" === i2.type && i2._length > 0 && (i2["_" + r5 + "axes"] || {})[e5])
                    return i2;
                  if ((i2[r5 + "axis"] || r5) === e5) {
                    if (o(i2, r5))
                      return i2;
                    if ((i2[r5] || []).length || i2[r5 + "0"])
                      return i2;
                  }
                }
              }(e4, s2, l);
              if (u)
                if ("histogram" !== u.type || l !== { v: "y", h: "x" }[u.orientation || "v"]) {
                  var c = l + "calendar", f2 = u[c], h = { noMultiCategory: !n2(u, "cartesian") || n2(u, "noMultiCategory") };
                  if ("box" === u.type && u._hasPreCompStats && l === { h: "x", v: "y" }[u.orientation || "v"] && (h.noMultiCategory = true), h.autotypenumbers = t4.autotypenumbers, o(u, l)) {
                    var p2 = a(u), d2 = [];
                    for (r4 = 0; r4 < e4.length; r4++) {
                      var v = e4[r4];
                      n2(v, "box-violin") && (v[l + "axis"] || l) === s2 && (void 0 !== v[p2] ? d2.push(v[p2][0]) : void 0 !== v.name ? d2.push(v.name) : d2.push("text"), v[c] !== f2 && (f2 = void 0));
                    }
                    t4.type = i(d2, f2, h);
                  } else if ("splom" === u.type) {
                    var g2 = u.dimensions[u._axesDim[s2]];
                    g2.visible && (t4.type = i(g2.values, f2, h));
                  } else
                    t4.type = i(u[l] || [u[l + "0"]], f2, h);
                } else
                  t4.type = "linear";
            }
          }(e3, s.data), "-" === e3.type ? e3.type = "linear" : t3.type = e3.type);
        };
      }, 31137: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828);
        function a(t3, e3, r3) {
          var n3, a2, o2, s2 = false;
          if ("data" === e3.type)
            n3 = t3._fullData[null !== e3.traces ? e3.traces[0] : 0];
          else {
            if ("layout" !== e3.type)
              return false;
            n3 = t3._fullLayout;
          }
          return a2 = i.nestedProperty(n3, e3.prop).get(), (o2 = r3[e3.type] = r3[e3.type] || {}).hasOwnProperty(e3.prop) && o2[e3.prop] !== a2 && (s2 = true), o2[e3.prop] = a2, { changed: s2, value: a2 };
        }
        function o(t3, e3) {
          var r3 = [], n3 = e3[0], a2 = {};
          if ("string" == typeof n3)
            a2[n3] = e3[1];
          else {
            if (!i.isPlainObject(n3))
              return r3;
            a2 = n3;
          }
          return l(a2, function(t4, e4, n4) {
            r3.push({ type: "layout", prop: t4, value: n4 });
          }, "", 0), r3;
        }
        function s(t3, e3) {
          var r3, n3, a2, o2, s2 = [];
          if (n3 = e3[0], a2 = e3[1], r3 = e3[2], o2 = {}, "string" == typeof n3)
            o2[n3] = a2;
          else {
            if (!i.isPlainObject(n3))
              return s2;
            o2 = n3, void 0 === r3 && (r3 = a2);
          }
          return void 0 === r3 && (r3 = null), l(o2, function(e4, n4, i2) {
            var a3, o3;
            if (Array.isArray(i2)) {
              o3 = i2.slice();
              var l2 = Math.min(o3.length, t3.data.length);
              r3 && (l2 = Math.min(l2, r3.length)), a3 = [];
              for (var u = 0; u < l2; u++)
                a3[u] = r3 ? r3[u] : u;
            } else
              o3 = i2, a3 = r3 ? r3.slice() : null;
            if (null === a3)
              Array.isArray(o3) && (o3 = o3[0]);
            else if (Array.isArray(a3)) {
              if (!Array.isArray(o3)) {
                var c = o3;
                o3 = [];
                for (var f2 = 0; f2 < a3.length; f2++)
                  o3[f2] = c;
              }
              o3.length = Math.min(a3.length, o3.length);
            }
            s2.push({ type: "data", prop: e4, traces: a3, value: o3 });
          }, "", 0), s2;
        }
        function l(t3, e3, r3, n3) {
          Object.keys(t3).forEach(function(a2) {
            var o2 = t3[a2];
            if ("_" !== a2[0]) {
              var s2 = r3 + (n3 > 0 ? "." : "") + a2;
              i.isPlainObject(o2) ? l(o2, e3, s2, n3 + 1) : e3(s2, a2, o2);
            }
          });
        }
        e2.manageCommandObserver = function(t3, r3, n3, o2) {
          var s2 = {}, l2 = true;
          r3 && r3._commandObserver && (s2 = r3._commandObserver), s2.cache || (s2.cache = {}), s2.lookupTable = {};
          var u = e2.hasSimpleAPICommandBindings(t3, n3, s2.lookupTable);
          if (r3 && r3._commandObserver) {
            if (u)
              return s2;
            if (r3._commandObserver.remove)
              return r3._commandObserver.remove(), r3._commandObserver = null, s2;
          }
          if (u) {
            a(t3, u, s2.cache), s2.check = function() {
              if (l2) {
                var e3 = a(t3, u, s2.cache);
                return e3.changed && o2 && void 0 !== s2.lookupTable[e3.value] && (s2.disable(), Promise.resolve(o2({ value: e3.value, type: u.type, prop: u.prop, traces: u.traces, index: s2.lookupTable[e3.value] })).then(s2.enable, s2.enable)), e3.changed;
              }
            };
            for (var c = ["plotly_relayout", "plotly_redraw", "plotly_restyle", "plotly_update", "plotly_animatingframe", "plotly_afterplot"], f2 = 0; f2 < c.length; f2++)
              t3._internalOn(c[f2], s2.check);
            s2.remove = function() {
              for (var e3 = 0; e3 < c.length; e3++)
                t3._removeInternalListener(c[e3], s2.check);
            };
          } else
            i.log("Unable to automatically bind plot updates to API command"), s2.lookupTable = {}, s2.remove = function() {
            };
          return s2.disable = function() {
            l2 = false;
          }, s2.enable = function() {
            l2 = true;
          }, r3 && (r3._commandObserver = s2), s2;
        }, e2.hasSimpleAPICommandBindings = function(t3, r3, n3) {
          var i2, a2, o2 = r3.length;
          for (i2 = 0; i2 < o2; i2++) {
            var s2, l2 = r3[i2], u = l2.method, c = l2.args;
            if (Array.isArray(c) || (c = []), !u)
              return false;
            var f2 = e2.computeAPICommandBindings(t3, u, c);
            if (1 !== f2.length)
              return false;
            if (a2) {
              if ((s2 = f2[0]).type !== a2.type)
                return false;
              if (s2.prop !== a2.prop)
                return false;
              if (Array.isArray(a2.traces)) {
                if (!Array.isArray(s2.traces))
                  return false;
                s2.traces.sort();
                for (var h = 0; h < a2.traces.length; h++)
                  if (a2.traces[h] !== s2.traces[h])
                    return false;
              } else if (s2.prop !== a2.prop)
                return false;
            } else
              a2 = f2[0], Array.isArray(a2.traces) && a2.traces.sort();
            var p2 = (s2 = f2[0]).value;
            if (Array.isArray(p2)) {
              if (1 !== p2.length)
                return false;
              p2 = p2[0];
            }
            n3 && (n3[p2] = i2);
          }
          return a2;
        }, e2.executeAPICommand = function(t3, e3, r3) {
          if ("skip" === e3)
            return Promise.resolve();
          var a2 = n2.apiMethodRegistry[e3], o2 = [t3];
          Array.isArray(r3) || (r3 = []);
          for (var s2 = 0; s2 < r3.length; s2++)
            o2.push(r3[s2]);
          return a2.apply(null, o2).catch(function(t4) {
            return i.warn("API call to Plotly." + e3 + " rejected.", t4), Promise.reject(t4);
          });
        }, e2.computeAPICommandBindings = function(t3, e3, r3) {
          var n3;
          switch (Array.isArray(r3) || (r3 = []), e3) {
            case "restyle":
              n3 = s(t3, r3);
              break;
            case "relayout":
              n3 = o(0, r3);
              break;
            case "update":
              n3 = s(t3, [r3[0], r3[2]]).concat(o(0, [r3[1]]));
              break;
            case "animate":
              n3 = function(t4, e4) {
                return Array.isArray(e4[0]) && 1 === e4[0].length && -1 !== ["string", "number"].indexOf(typeof e4[0][0]) ? [{ type: "layout", prop: "_currentFrame", value: e4[0][0].toString() }] : [];
              }(0, r3);
              break;
            default:
              n3 = [];
          }
          return n3;
        };
      }, 27670: function(t2, e2, r2) {
        var n2 = r2(1426).extendFlat;
        e2.Y = function(t3, e3) {
          e3 = e3 || {};
          var r3 = { valType: "info_array", editType: (t3 = t3 || {}).editType, items: [{ valType: "number", min: 0, max: 1, editType: t3.editType }, { valType: "number", min: 0, max: 1, editType: t3.editType }], dflt: [0, 1] }, i = (t3.name && t3.name, t3.trace, e3.description && e3.description, { x: n2({}, r3, {}), y: n2({}, r3, {}), editType: t3.editType });
          return t3.noGridCell || (i.row = { valType: "integer", min: 0, dflt: 0, editType: t3.editType }, i.column = { valType: "integer", min: 0, dflt: 0, editType: t3.editType }), i;
        }, e2.c = function(t3, e3, r3, n3) {
          var i = n3 && n3.x || [0, 1], a = n3 && n3.y || [0, 1], o = e3.grid;
          if (o) {
            var s = r3("domain.column");
            void 0 !== s && (s < o.columns ? i = o._domains.x[s] : delete t3.domain.column);
            var l = r3("domain.row");
            void 0 !== l && (l < o.rows ? a = o._domains.y[l] : delete t3.domain.row);
          }
          var u = r3("domain.x", i), c = r3("domain.y", a);
          u[0] < u[1] || (t3.domain.x = i.slice()), c[0] < c[1] || (t3.domain.y = a.slice());
        };
      }, 41940: function(t2) {
        t2.exports = function(t3) {
          var e2 = t3.editType, r2 = t3.colorEditType;
          void 0 === r2 && (r2 = e2);
          var n2 = { family: { valType: "string", noBlank: true, strict: true, editType: e2 }, size: { valType: "number", min: 1, editType: e2 }, color: { valType: "color", editType: r2 }, editType: e2 };
          return t3.autoSize && (n2.size.dflt = "auto"), t3.autoColor && (n2.color.dflt = "auto"), t3.arrayOk && (n2.family.arrayOk = true, n2.size.arrayOk = true, n2.color.arrayOk = true), n2;
        };
      }, 31391: function(t2) {
        t2.exports = { _isLinkedToArray: "frames_entry", group: { valType: "string" }, name: { valType: "string" }, traces: { valType: "any" }, baseframe: { valType: "string" }, data: { valType: "any" }, layout: { valType: "any" } };
      }, 78776: function(t2, e2) {
        e2.projNames = { airy: "airy", aitoff: "aitoff", "albers usa": "albersUsa", albers: "albers", august: "august", "azimuthal equal area": "azimuthalEqualArea", "azimuthal equidistant": "azimuthalEquidistant", baker: "baker", bertin1953: "bertin1953", boggs: "boggs", bonne: "bonne", bottomley: "bottomley", bromley: "bromley", collignon: "collignon", "conic conformal": "conicConformal", "conic equal area": "conicEqualArea", "conic equidistant": "conicEquidistant", craig: "craig", craster: "craster", "cylindrical equal area": "cylindricalEqualArea", "cylindrical stereographic": "cylindricalStereographic", eckert1: "eckert1", eckert2: "eckert2", eckert3: "eckert3", eckert4: "eckert4", eckert5: "eckert5", eckert6: "eckert6", eisenlohr: "eisenlohr", equirectangular: "equirectangular", fahey: "fahey", "foucaut sinusoidal": "foucautSinusoidal", foucaut: "foucaut", ginzburg4: "ginzburg4", ginzburg5: "ginzburg5", ginzburg6: "ginzburg6", ginzburg8: "ginzburg8", ginzburg9: "ginzburg9", gnomonic: "gnomonic", "gringorten quincuncial": "gringortenQuincuncial", gringorten: "gringorten", guyou: "guyou", hammer: "hammer", hill: "hill", homolosine: "homolosine", hufnagel: "hufnagel", hyperelliptical: "hyperelliptical", kavrayskiy7: "kavrayskiy7", lagrange: "lagrange", larrivee: "larrivee", laskowski: "laskowski", loximuthal: "loximuthal", mercator: "mercator", miller: "miller", mollweide: "mollweide", "mt flat polar parabolic": "mtFlatPolarParabolic", "mt flat polar quartic": "mtFlatPolarQuartic", "mt flat polar sinusoidal": "mtFlatPolarSinusoidal", "natural earth": "naturalEarth", "natural earth1": "naturalEarth1", "natural earth2": "naturalEarth2", "nell hammer": "nellHammer", nicolosi: "nicolosi", orthographic: "orthographic", patterson: "patterson", "peirce quincuncial": "peirceQuincuncial", polyconic: "polyconic", "rectangular polyconic": "rectangularPolyconic", robinson: "robinson", satellite: "satellite", "sinu mollweide": "sinuMollweide", sinusoidal: "sinusoidal", stereographic: "stereographic", times: "times", "transverse mercator": "transverseMercator", "van der grinten": "vanDerGrinten", "van der grinten2": "vanDerGrinten2", "van der grinten3": "vanDerGrinten3", "van der grinten4": "vanDerGrinten4", wagner4: "wagner4", wagner6: "wagner6", wiechel: "wiechel", "winkel tripel": "winkel3", winkel3: "winkel3" }, e2.axesNames = ["lonaxis", "lataxis"], e2.lonaxisSpan = { orthographic: 180, "azimuthal equal area": 360, "azimuthal equidistant": 360, "conic conformal": 180, gnomonic: 160, stereographic: 180, "transverse mercator": 180, "*": 360 }, e2.lataxisSpan = { "conic conformal": 150, stereographic: 179.5, "*": 180 }, e2.scopeDefaults = { world: { lonaxisRange: [-180, 180], lataxisRange: [-90, 90], projType: "equirectangular", projRotate: [0, 0, 0] }, usa: { lonaxisRange: [-180, -50], lataxisRange: [15, 80], projType: "albers usa" }, europe: { lonaxisRange: [-30, 60], lataxisRange: [30, 85], projType: "conic conformal", projRotate: [15, 0, 0], projParallels: [0, 60] }, asia: { lonaxisRange: [22, 160], lataxisRange: [-15, 55], projType: "mercator", projRotate: [0, 0, 0] }, africa: { lonaxisRange: [-30, 60], lataxisRange: [-40, 40], projType: "mercator", projRotate: [0, 0, 0] }, "north america": { lonaxisRange: [-180, -45], lataxisRange: [5, 85], projType: "conic conformal", projRotate: [-100, 0, 0], projParallels: [29.5, 45.5] }, "south america": { lonaxisRange: [-100, -30], lataxisRange: [-60, 15], projType: "mercator", projRotate: [0, 0, 0] } }, e2.clipPad = 1e-3, e2.precision = 0.1, e2.landColor = "#F0DC82", e2.waterColor = "#3399FF", e2.locationmodeToLayer = { "ISO-3": "countries", "USA-states": "subunits", "country names": "countries" }, e2.sphereSVG = { type: "Sphere" }, e2.fillLayers = { ocean: 1, land: 1, lakes: 1 }, e2.lineLayers = { subunits: 1, countries: 1, coastlines: 1, rivers: 1, frame: 1 }, e2.layers = ["bg", "ocean", "land", "lakes", "subunits", "countries", "coastlines", "rivers", "lataxis", "lonaxis", "frame", "backplot", "frontplot"], e2.layersForChoropleth = ["bg", "ocean", "land", "subunits", "countries", "coastlines", "lataxis", "lonaxis", "frame", "backplot", "rivers", "lakes", "frontplot"], e2.layerNameToAdjective = { ocean: "ocean", land: "land", lakes: "lake", subunits: "subunit", countries: "country", coastlines: "coastline", rivers: "river", frame: "frame" };
      }, 69082: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(27362), a = i.geoPath, o = i.geoDistance, s = r2(65704), l = r2(73972), u = r2(71828), c = u.strTranslate, f2 = r2(7901), h = r2(91424), p2 = r2(30211), d2 = r2(74875), v = r2(89298), g2 = r2(71739).getAutoRange, y = r2(28569), m2 = r2(47322).prepSelect, x = r2(47322).clearOutline, b = r2(47322).selectOnClick, _ = r2(74455), w2 = r2(78776), T = r2(41327), k = r2(90973), A = r2(96892).zL;
        function M(t3) {
          this.id = t3.id, this.graphDiv = t3.graphDiv, this.container = t3.container, this.topojsonURL = t3.topojsonURL, this.isStatic = t3.staticPlot, this.topojsonName = null, this.topojson = null, this.projection = null, this.scope = null, this.viewInitial = null, this.fitScale = null, this.bounds = null, this.midPt = null, this.hasChoropleth = false, this.traceHash = {}, this.layers = {}, this.basePaths = {}, this.dataPaths = {}, this.dataPoints = {}, this.clipDef = null, this.clipRect = null, this.bgRect = null, this.makeFramework();
        }
        var S = M.prototype;
        function E(t3, e3) {
          var r3 = w2.clipPad, n3 = t3[0] + r3, i2 = t3[1] - r3, a2 = e3[0] + r3, o2 = e3[1] - r3;
          n3 > 0 && i2 < 0 && (i2 += 360);
          var s2 = (i2 - n3) / 4;
          return { type: "Polygon", coordinates: [[[n3, a2], [n3, o2], [n3 + s2, o2], [n3 + 2 * s2, o2], [n3 + 3 * s2, o2], [i2, o2], [i2, a2], [i2 - s2, a2], [i2 - 2 * s2, a2], [i2 - 3 * s2, a2], [n3, a2]]] };
        }
        t2.exports = function(t3) {
          return new M(t3);
        }, S.plot = function(t3, e3, r3, n3) {
          var i2 = this;
          if (n3)
            return i2.update(t3, e3, true);
          i2._geoCalcData = t3, i2._fullLayout = e3;
          var a2 = e3[this.id], o2 = [], s2 = false;
          for (var l2 in w2.layerNameToAdjective)
            if ("frame" !== l2 && a2["show" + l2]) {
              s2 = true;
              break;
            }
          for (var u2 = false, c2 = 0; c2 < t3.length; c2++) {
            var f3 = t3[0][0].trace;
            f3._geo = i2, f3.locationmode && (s2 = true);
            var h2 = f3.marker;
            if (h2) {
              var p3 = h2.angle, d3 = h2.angleref;
              (p3 || "north" === d3 || "previous" === d3) && (u2 = true);
            }
          }
          if (this._hasMarkerAngles = u2, s2) {
            var v2 = k.getTopojsonName(a2);
            null !== i2.topojson && v2 === i2.topojsonName || (i2.topojsonName = v2, void 0 === PlotlyGeoAssets.topojson[i2.topojsonName] && o2.push(i2.fetchTopojson()));
          }
          o2 = o2.concat(T.fetchTraceGeoData(t3)), r3.push(new Promise(function(r4, n4) {
            Promise.all(o2).then(function() {
              i2.topojson = PlotlyGeoAssets.topojson[i2.topojsonName], i2.update(t3, e3), r4();
            }).catch(n4);
          }));
        }, S.fetchTopojson = function() {
          var t3 = this, e3 = k.getTopojsonPath(t3.topojsonURL, t3.topojsonName);
          return new Promise(function(r3, i2) {
            n2.json(e3, function(n3, a2) {
              if (n3)
                return 404 === n3.status ? i2(new Error(["plotly.js could not find topojson file at", e3 + ".", "Make sure the *topojsonURL* plot config option", "is set properly."].join(" "))) : i2(new Error(["unexpected error while fetching topojson file at", e3].join(" ")));
              PlotlyGeoAssets.topojson[t3.topojsonName] = a2, r3();
            });
          });
        }, S.update = function(t3, e3, r3) {
          var n3 = e3[this.id];
          this.hasChoropleth = false;
          for (var i2 = 0; i2 < t3.length; i2++) {
            var a2 = t3[i2], o2 = a2[0].trace;
            "choropleth" === o2.type && (this.hasChoropleth = true), true === o2.visible && o2._length > 0 && o2._module.calcGeoJSON(a2, e3);
          }
          if (!r3) {
            if (this.updateProjection(t3, e3))
              return;
            this.viewInitial && this.scope === n3.scope || this.saveViewInitial(n3);
          }
          this.scope = n3.scope, this.updateBaseLayers(e3, n3), this.updateDims(e3, n3), this.updateFx(e3, n3), d2.generalUpdatePerTraceModule(this.graphDiv, this, t3, n3);
          var s2 = this.layers.frontplot.select(".scatterlayer");
          this.dataPoints.point = s2.selectAll(".point"), this.dataPoints.text = s2.selectAll("text"), this.dataPaths.line = s2.selectAll(".js-line");
          var l2 = this.layers.backplot.select(".choroplethlayer");
          this.dataPaths.choropleth = l2.selectAll("path"), this._render();
        }, S.updateProjection = function(t3, e3) {
          var r3 = this.graphDiv, n3 = e3[this.id], l2 = e3._size, c2 = n3.domain, f3 = n3.projection, h2 = n3.lonaxis, p3 = n3.lataxis, d3 = h2._ax, v2 = p3._ax, y2 = this.projection = function(t4) {
            var e4 = t4.projection, r4 = e4.type, n4 = w2.projNames[r4];
            n4 = "geo" + u.titleCase(n4);
            for (var l3 = (i[n4] || s[n4])(), c3 = t4._isSatellite ? 180 * Math.acos(1 / e4.distance) / Math.PI : t4._isClipped ? w2.lonaxisSpan[r4] / 2 : null, f4 = ["center", "rotate", "parallels", "clipExtent"], h3 = function(t5) {
              return t5 ? l3 : [];
            }, p4 = 0; p4 < f4.length; p4++) {
              var d4 = f4[p4];
              "function" != typeof l3[d4] && (l3[d4] = h3);
            }
            return l3.isLonLatOverEdges = function(t5) {
              if (null === l3(t5))
                return true;
              if (c3) {
                var e5 = l3.rotate();
                return o(t5, [-e5[0], -e5[1]]) > c3 * Math.PI / 180;
              }
              return false;
            }, l3.getPath = function() {
              return a().projection(l3);
            }, l3.getBounds = function(t5) {
              return l3.getPath().bounds(t5);
            }, l3.precision(w2.precision), t4._isSatellite && l3.tilt(e4.tilt).distance(e4.distance), c3 && l3.clipAngle(c3 - w2.clipPad), l3;
          }(n3), m3 = [[l2.l + l2.w * c2.x[0], l2.t + l2.h * (1 - c2.y[1])], [l2.l + l2.w * c2.x[1], l2.t + l2.h * (1 - c2.y[0])]], x2 = n3.center || {}, b2 = f3.rotation || {}, _2 = h2.range || [], T2 = p3.range || [];
          if (n3.fitbounds) {
            d3._length = m3[1][0] - m3[0][0], v2._length = m3[1][1] - m3[0][1], d3.range = g2(r3, d3), v2.range = g2(r3, v2);
            var k2 = (d3.range[0] + d3.range[1]) / 2, A2 = (v2.range[0] + v2.range[1]) / 2;
            if (n3._isScoped)
              x2 = { lon: k2, lat: A2 };
            else if (n3._isClipped) {
              x2 = { lon: k2, lat: A2 }, b2 = { lon: k2, lat: A2, roll: b2.roll };
              var M2 = f3.type, S2 = w2.lonaxisSpan[M2] / 2 || 180, L = w2.lataxisSpan[M2] / 2 || 90;
              _2 = [k2 - S2, k2 + S2], T2 = [A2 - L, A2 + L];
            } else
              x2 = { lon: k2, lat: A2 }, b2 = { lon: k2, lat: b2.lat, roll: b2.roll };
          }
          y2.center([x2.lon - b2.lon, x2.lat - b2.lat]).rotate([-b2.lon, -b2.lat, b2.roll]).parallels(f3.parallels);
          var C = E(_2, T2);
          y2.fitExtent(m3, C);
          var P = this.bounds = y2.getBounds(C), O = this.fitScale = y2.scale(), I = y2.translate();
          if (n3.fitbounds) {
            var D = y2.getBounds(E(d3.range, v2.range)), z = Math.min((P[1][0] - P[0][0]) / (D[1][0] - D[0][0]), (P[1][1] - P[0][1]) / (D[1][1] - D[0][1]));
            isFinite(z) ? y2.scale(z * O) : u.warn("Something went wrong during" + this.id + "fitbounds computations.");
          } else
            y2.scale(f3.scale * O);
          var R = this.midPt = [(P[0][0] + P[1][0]) / 2, (P[0][1] + P[1][1]) / 2];
          if (y2.translate([I[0] + (R[0] - I[0]), I[1] + (R[1] - I[1])]).clipExtent(P), n3._isAlbersUsa) {
            var F = y2([x2.lon, x2.lat]), B = y2.translate();
            y2.translate([B[0] - (F[0] - B[0]), B[1] - (F[1] - B[1])]);
          }
        }, S.updateBaseLayers = function(t3, e3) {
          var r3 = this, i2 = r3.topojson, a2 = r3.layers, o2 = r3.basePaths;
          function s2(t4) {
            return "lonaxis" === t4 || "lataxis" === t4;
          }
          function l2(t4) {
            return Boolean(w2.lineLayers[t4]);
          }
          function u2(t4) {
            return Boolean(w2.fillLayers[t4]);
          }
          var c2 = (this.hasChoropleth ? w2.layersForChoropleth : w2.layers).filter(function(t4) {
            return l2(t4) || u2(t4) ? e3["show" + t4] : !s2(t4) || e3[t4].showgrid;
          }), p3 = r3.framework.selectAll(".layer").data(c2, String);
          p3.exit().each(function(t4) {
            delete a2[t4], delete o2[t4], n2.select(this).remove();
          }), p3.enter().append("g").attr("class", function(t4) {
            return "layer " + t4;
          }).each(function(t4) {
            var e4 = a2[t4] = n2.select(this);
            "bg" === t4 ? r3.bgRect = e4.append("rect").style("pointer-events", "all") : s2(t4) ? o2[t4] = e4.append("path").style("fill", "none") : "backplot" === t4 ? e4.append("g").classed("choroplethlayer", true) : "frontplot" === t4 ? e4.append("g").classed("scatterlayer", true) : l2(t4) ? o2[t4] = e4.append("path").style("fill", "none").style("stroke-miterlimit", 2) : u2(t4) && (o2[t4] = e4.append("path").style("stroke", "none"));
          }), p3.order(), p3.each(function(r4) {
            var n3 = o2[r4], a3 = w2.layerNameToAdjective[r4];
            "frame" === r4 ? n3.datum(w2.sphereSVG) : l2(r4) || u2(r4) ? n3.datum(A(i2, i2.objects[r4])) : s2(r4) && n3.datum(function(t4, e4, r5) {
              var n4, i3, a4, o3 = e4[t4], s3 = w2.scopeDefaults[e4.scope];
              "lonaxis" === t4 ? (n4 = s3.lonaxisRange, i3 = s3.lataxisRange, a4 = function(t5, e5) {
                return [t5, e5];
              }) : "lataxis" === t4 && (n4 = s3.lataxisRange, i3 = s3.lonaxisRange, a4 = function(t5, e5) {
                return [e5, t5];
              });
              var l3 = { type: "linear", range: [n4[0], n4[1] - 1e-6], tick0: o3.tick0, dtick: o3.dtick };
              v.setConvert(l3, r5);
              var u3 = v.calcTicks(l3);
              e4.isScoped || "lonaxis" !== t4 || u3.pop();
              for (var c3 = u3.length, f3 = new Array(c3), h2 = 0; h2 < c3; h2++)
                for (var p4 = u3[h2].x, d3 = f3[h2] = [], g3 = i3[0]; g3 < i3[1] + 2.5; g3 += 2.5)
                  d3.push(a4(p4, g3));
              return { type: "MultiLineString", coordinates: f3 };
            }(r4, e3, t3)).call(f2.stroke, e3[r4].gridcolor).call(h.dashLine, e3[r4].griddash, e3[r4].gridwidth), l2(r4) ? n3.call(f2.stroke, e3[a3 + "color"]).call(h.dashLine, "", e3[a3 + "width"]) : u2(r4) && n3.call(f2.fill, e3[a3 + "color"]);
          });
        }, S.updateDims = function(t3, e3) {
          var r3 = this.bounds, n3 = (e3.framewidth || 0) / 2, i2 = r3[0][0] - n3, a2 = r3[0][1] - n3, o2 = r3[1][0] - i2 + n3, s2 = r3[1][1] - a2 + n3;
          h.setRect(this.clipRect, i2, a2, o2, s2), this.bgRect.call(h.setRect, i2, a2, o2, s2).call(f2.fill, e3.bgcolor), this.xaxis._offset = i2, this.xaxis._length = o2, this.yaxis._offset = a2, this.yaxis._length = s2;
        }, S.updateFx = function(t3, e3) {
          var r3 = this, i2 = r3.graphDiv, a2 = r3.bgRect, o2 = t3.dragmode, s2 = t3.clickmode;
          if (!r3.isStatic) {
            var c2 = { element: r3.bgRect.node(), gd: i2, plotinfo: { id: r3.id, xaxis: r3.xaxis, yaxis: r3.yaxis, fillRangeItems: function(t4, e4) {
              e4.isRect ? (t4.range = {})[r3.id] = [f3([e4.xmin, e4.ymin]), f3([e4.xmax, e4.ymax])] : (t4.lassoPoints = {})[r3.id] = e4.map(f3);
            } }, xaxes: [r3.xaxis], yaxes: [r3.yaxis], subplot: r3.id, clickFn: function(t4) {
              2 === t4 && x(i2);
            } };
            "pan" === o2 ? (a2.node().onmousedown = null, a2.call(_(r3, e3)), a2.on("dblclick.zoom", function() {
              var t4 = r3.viewInitial, e4 = {};
              for (var n3 in t4)
                e4[r3.id + "." + n3] = t4[n3];
              l.call("_guiRelayout", i2, e4), i2.emit("plotly_doubleclick", null);
            }), i2._context._scrollZoom.geo || a2.on("wheel.zoom", null)) : "select" !== o2 && "lasso" !== o2 || (a2.on(".zoom", null), c2.prepFn = function(t4, e4, r4) {
              m2(t4, e4, r4, c2, o2);
            }, y.init(c2)), a2.on("mousemove", function() {
              var t4 = r3.projection.invert(u.getPositionFromD3Event());
              if (!t4)
                return y.unhover(i2, n2.event);
              r3.xaxis.p2c = function() {
                return t4[0];
              }, r3.yaxis.p2c = function() {
                return t4[1];
              }, p2.hover(i2, n2.event, r3.id);
            }), a2.on("mouseout", function() {
              i2._dragging || y.unhover(i2, n2.event);
            }), a2.on("click", function() {
              "select" !== o2 && "lasso" !== o2 && (s2.indexOf("select") > -1 && b(n2.event, i2, [r3.xaxis], [r3.yaxis], r3.id, c2), s2.indexOf("event") > -1 && p2.click(i2, n2.event));
            });
          }
          function f3(t4) {
            return r3.projection.invert([t4[0] + r3.xaxis._offset, t4[1] + r3.yaxis._offset]);
          }
        }, S.makeFramework = function() {
          var t3 = this, e3 = t3.graphDiv, r3 = e3._fullLayout, i2 = "clip" + r3._uid + t3.id;
          t3.clipDef = r3._clips.append("clipPath").attr("id", i2), t3.clipRect = t3.clipDef.append("rect"), t3.framework = n2.select(t3.container).append("g").attr("class", "geo " + t3.id).call(h.setClipUrl, i2, e3), t3.project = function(e4) {
            var r4 = t3.projection(e4);
            return r4 ? [r4[0] - t3.xaxis._offset, r4[1] - t3.yaxis._offset] : [null, null];
          }, t3.xaxis = { _id: "x", c2p: function(e4) {
            return t3.project(e4)[0];
          } }, t3.yaxis = { _id: "y", c2p: function(e4) {
            return t3.project(e4)[1];
          } }, t3.mockAxis = { type: "linear", showexponent: "all", exponentformat: "B" }, v.setConvert(t3.mockAxis, r3);
        }, S.saveViewInitial = function(t3) {
          var e3, r3 = t3.center || {}, n3 = t3.projection, i2 = n3.rotation || {};
          this.viewInitial = { fitbounds: t3.fitbounds, "projection.scale": n3.scale }, e3 = t3._isScoped ? { "center.lon": r3.lon, "center.lat": r3.lat } : t3._isClipped ? { "projection.rotation.lon": i2.lon, "projection.rotation.lat": i2.lat } : { "center.lon": r3.lon, "center.lat": r3.lat, "projection.rotation.lon": i2.lon }, u.extendFlat(this.viewInitial, e3);
        }, S.render = function(t3) {
          this._hasMarkerAngles && t3 ? this.plot(this._geoCalcData, this._fullLayout, [], true) : this._render();
        }, S._render = function() {
          var t3, e3 = this.projection, r3 = e3.getPath();
          function n3(t4) {
            var r4 = e3(t4.lonlat);
            return r4 ? c(r4[0], r4[1]) : null;
          }
          function i2(t4) {
            return e3.isLonLatOverEdges(t4.lonlat) ? "none" : null;
          }
          for (t3 in this.basePaths)
            this.basePaths[t3].attr("d", r3);
          for (t3 in this.dataPaths)
            this.dataPaths[t3].attr("d", function(t4) {
              return r3(t4.geojson);
            });
          for (t3 in this.dataPoints)
            this.dataPoints[t3].attr("display", i2).attr("transform", n3);
        };
      }, 44622: function(t2, e2, r2) {
        var n2 = r2(27659).AU, i = r2(71828).counterRegex, a = r2(69082), o = "geo", s = i(o), l = {};
        l.geo = { valType: "subplotid", dflt: o, editType: "calc" }, t2.exports = { attr: o, name: o, idRoot: o, idRegex: s, attrRegex: s, attributes: l, layoutAttributes: r2(77519), supplyLayoutDefaults: r2(82161), plot: function(t3) {
          for (var e3 = t3._fullLayout, r3 = t3.calcdata, i2 = e3._subplots.geo, s2 = 0; s2 < i2.length; s2++) {
            var l2 = i2[s2], u = n2(r3, o, l2), c = e3[l2]._subplot;
            c || (c = a({ id: l2, graphDiv: t3, container: e3._geolayer.node(), topojsonURL: t3._context.topojsonURL, staticPlot: t3._context.staticPlot }), e3[l2]._subplot = c), c.plot(u, e3, t3._promises);
          }
        }, updateFx: function(t3) {
          for (var e3 = t3._fullLayout, r3 = e3._subplots.geo, n3 = 0; n3 < r3.length; n3++) {
            var i2 = e3[r3[n3]];
            i2._subplot.updateFx(e3, i2);
          }
        }, clean: function(t3, e3, r3, n3) {
          for (var i2 = n3._subplots.geo || [], a2 = 0; a2 < i2.length; a2++) {
            var o2 = i2[a2], s2 = n3[o2]._subplot;
            !e3[o2] && s2 && (s2.framework.remove(), s2.clipDef.remove());
          }
        } };
      }, 77519: function(t2, e2, r2) {
        var n2 = r2(22399), i = r2(27670).Y, a = r2(79952).P, o = r2(78776), s = r2(30962).overrideAll, l = r2(78607), u = { range: { valType: "info_array", items: [{ valType: "number" }, { valType: "number" }] }, showgrid: { valType: "boolean", dflt: false }, tick0: { valType: "number", dflt: 0 }, dtick: { valType: "number" }, gridcolor: { valType: "color", dflt: n2.lightLine }, gridwidth: { valType: "number", min: 0, dflt: 1 }, griddash: a };
        (t2.exports = s({ domain: i({ name: "geo" }, {}), fitbounds: { valType: "enumerated", values: [false, "locations", "geojson"], dflt: false, editType: "plot" }, resolution: { valType: "enumerated", values: [110, 50], dflt: 110, coerceNumber: true }, scope: { valType: "enumerated", values: l(o.scopeDefaults), dflt: "world" }, projection: { type: { valType: "enumerated", values: l(o.projNames) }, rotation: { lon: { valType: "number" }, lat: { valType: "number" }, roll: { valType: "number" } }, tilt: { valType: "number", dflt: 0 }, distance: { valType: "number", min: 1.001, dflt: 2 }, parallels: { valType: "info_array", items: [{ valType: "number" }, { valType: "number" }] }, scale: { valType: "number", min: 0, dflt: 1 } }, center: { lon: { valType: "number" }, lat: { valType: "number" } }, visible: { valType: "boolean", dflt: true }, showcoastlines: { valType: "boolean" }, coastlinecolor: { valType: "color", dflt: n2.defaultLine }, coastlinewidth: { valType: "number", min: 0, dflt: 1 }, showland: { valType: "boolean", dflt: false }, landcolor: { valType: "color", dflt: o.landColor }, showocean: { valType: "boolean", dflt: false }, oceancolor: { valType: "color", dflt: o.waterColor }, showlakes: { valType: "boolean", dflt: false }, lakecolor: { valType: "color", dflt: o.waterColor }, showrivers: { valType: "boolean", dflt: false }, rivercolor: { valType: "color", dflt: o.waterColor }, riverwidth: { valType: "number", min: 0, dflt: 1 }, showcountries: { valType: "boolean" }, countrycolor: { valType: "color", dflt: n2.defaultLine }, countrywidth: { valType: "number", min: 0, dflt: 1 }, showsubunits: { valType: "boolean" }, subunitcolor: { valType: "color", dflt: n2.defaultLine }, subunitwidth: { valType: "number", min: 0, dflt: 1 }, showframe: { valType: "boolean" }, framecolor: { valType: "color", dflt: n2.defaultLine }, framewidth: { valType: "number", min: 0, dflt: 1 }, bgcolor: { valType: "color", dflt: n2.background }, lonaxis: u, lataxis: u }, "plot", "from-root")).uirevision = { valType: "any", editType: "none" };
      }, 82161: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(49119), a = r2(27659).NG, o = r2(78776), s = r2(77519), l = o.axesNames;
        function u(t3, e3, r3, i2) {
          var s2 = a(i2.fullData, "geo", i2.id).map(function(t4) {
            return t4._expandedIndex;
          }), u2 = r3("resolution"), c = r3("scope"), f2 = o.scopeDefaults[c], h = r3("projection.type", f2.projType), p2 = e3._isAlbersUsa = "albers usa" === h;
          p2 && (c = e3.scope = "usa");
          var d2 = e3._isScoped = "world" !== c, v = e3._isSatellite = "satellite" === h, g2 = e3._isConic = -1 !== h.indexOf("conic") || "albers" === h, y = e3._isClipped = !!o.lonaxisSpan[h];
          if (false === t3.visible) {
            var m2 = n2.extendDeep({}, e3._template);
            m2.showcoastlines = false, m2.showcountries = false, m2.showframe = false, m2.showlakes = false, m2.showland = false, m2.showocean = false, m2.showrivers = false, m2.showsubunits = false, m2.lonaxis && (m2.lonaxis.showgrid = false), m2.lataxis && (m2.lataxis.showgrid = false), e3._template = m2;
          }
          for (var x = r3("visible"), b = 0; b < l.length; b++) {
            var _, w2 = l[b], T = [30, 10][b];
            if (d2)
              _ = f2[w2 + "Range"];
            else {
              var k = o[w2 + "Span"], A = (k[h] || k["*"]) / 2, M = r3("projection.rotation." + w2.substr(0, 3), f2.projRotate[b]);
              _ = [M - A, M + A];
            }
            var S = r3(w2 + ".range", _);
            r3(w2 + ".tick0"), r3(w2 + ".dtick", T), r3(w2 + ".showgrid", !!x && void 0) && (r3(w2 + ".gridcolor"), r3(w2 + ".gridwidth"), r3(w2 + ".griddash")), e3[w2]._ax = { type: "linear", _id: w2.slice(0, 3), _traceIndices: s2, setScale: n2.identity, c2l: n2.identity, r2l: n2.identity, autorange: true, range: S.slice(), _m: 1, _input: {} };
          }
          var E = e3.lonaxis.range, L = e3.lataxis.range, C = E[0], P = E[1];
          C > 0 && P < 0 && (P += 360);
          var O, I, D, z = (C + P) / 2;
          if (!p2) {
            var R = d2 ? f2.projRotate : [z, 0, 0];
            O = r3("projection.rotation.lon", R[0]), r3("projection.rotation.lat", R[1]), r3("projection.rotation.roll", R[2]), r3("showcoastlines", !d2 && x) && (r3("coastlinecolor"), r3("coastlinewidth")), r3("showocean", !!x && void 0) && r3("oceancolor");
          }
          p2 ? (I = -96.6, D = 38.7) : (I = d2 ? z : O, D = (L[0] + L[1]) / 2), r3("center.lon", I), r3("center.lat", D), v && (r3("projection.tilt"), r3("projection.distance")), g2 && r3("projection.parallels", f2.projParallels || [0, 60]), r3("projection.scale"), r3("showland", !!x && void 0) && r3("landcolor"), r3("showlakes", !!x && void 0) && r3("lakecolor"), r3("showrivers", !!x && void 0) && (r3("rivercolor"), r3("riverwidth")), r3("showcountries", d2 && "usa" !== c && x) && (r3("countrycolor"), r3("countrywidth")), ("usa" === c || "north america" === c && 50 === u2) && (r3("showsubunits", x), r3("subunitcolor"), r3("subunitwidth")), d2 || r3("showframe", x) && (r3("framecolor"), r3("framewidth")), r3("bgcolor"), r3("fitbounds") && (delete e3.projection.scale, d2 ? (delete e3.center.lon, delete e3.center.lat) : y ? (delete e3.center.lon, delete e3.center.lat, delete e3.projection.rotation.lon, delete e3.projection.rotation.lat, delete e3.lonaxis.range, delete e3.lataxis.range) : (delete e3.center.lon, delete e3.center.lat, delete e3.projection.rotation.lon));
        }
        t2.exports = function(t3, e3, r3) {
          i(t3, e3, r3, { type: "geo", attributes: s, handleDefaults: u, fullData: r3, partition: "y" });
        };
      }, 74455: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(73972), o = Math.PI / 180, s = 180 / Math.PI, l = { cursor: "pointer" }, u = { cursor: "auto" };
        function c(t3, e3) {
          return n2.behavior.zoom().translate(e3.translate()).scale(e3.scale());
        }
        function f2(t3, e3, r3) {
          var n3 = t3.id, o2 = t3.graphDiv, s2 = o2.layout, l2 = s2[n3], u2 = o2._fullLayout, c2 = u2[n3], f3 = {}, h2 = {};
          function p3(t4, e4) {
            f3[n3 + "." + t4] = i.nestedProperty(l2, t4).get(), a.call("_storeDirectGUIEdit", s2, u2._preGUI, f3);
            var r4 = i.nestedProperty(c2, t4);
            r4.get() !== e4 && (r4.set(e4), i.nestedProperty(l2, t4).set(e4), h2[n3 + "." + t4] = e4);
          }
          r3(p3), p3("projection.scale", e3.scale() / t3.fitScale), p3("fitbounds", false), o2.emit("plotly_relayout", h2);
        }
        function h(t3, e3) {
          var r3 = c(0, e3);
          function i2(r4) {
            var n3 = e3.invert(t3.midPt);
            r4("center.lon", n3[0]), r4("center.lat", n3[1]);
          }
          return r3.on("zoomstart", function() {
            n2.select(this).style(l);
          }).on("zoom", function() {
            e3.scale(n2.event.scale).translate(n2.event.translate), t3.render(true);
            var r4 = e3.invert(t3.midPt);
            t3.graphDiv.emit("plotly_relayouting", { "geo.projection.scale": e3.scale() / t3.fitScale, "geo.center.lon": r4[0], "geo.center.lat": r4[1] });
          }).on("zoomend", function() {
            n2.select(this).style(u), f2(t3, e3, i2);
          }), r3;
        }
        function p2(t3, e3) {
          var r3, i2, a2, o2, s2, h2, p3, d3, v2, g3 = c(0, e3);
          function y2(t4) {
            return e3.invert(t4);
          }
          function m3(r4) {
            var n3 = e3.rotate(), i3 = e3.invert(t3.midPt);
            r4("projection.rotation.lon", -n3[0]), r4("center.lon", i3[0]), r4("center.lat", i3[1]);
          }
          return g3.on("zoomstart", function() {
            n2.select(this).style(l), r3 = n2.mouse(this), i2 = e3.rotate(), a2 = e3.translate(), o2 = i2, s2 = y2(r3);
          }).on("zoom", function() {
            if (h2 = n2.mouse(this), function(t4) {
              var r4 = y2(t4);
              if (!r4)
                return true;
              var n3 = e3(r4);
              return Math.abs(n3[0] - t4[0]) > 2 || Math.abs(n3[1] - t4[1]) > 2;
            }(r3))
              return g3.scale(e3.scale()), void g3.translate(e3.translate());
            e3.scale(n2.event.scale), e3.translate([a2[0], n2.event.translate[1]]), s2 ? y2(h2) && (d3 = y2(h2), p3 = [o2[0] + (d3[0] - s2[0]), i2[1], i2[2]], e3.rotate(p3), o2 = p3) : s2 = y2(r3 = h2), v2 = true, t3.render(true);
            var l2 = e3.rotate(), u2 = e3.invert(t3.midPt);
            t3.graphDiv.emit("plotly_relayouting", { "geo.projection.scale": e3.scale() / t3.fitScale, "geo.center.lon": u2[0], "geo.center.lat": u2[1], "geo.projection.rotation.lon": -l2[0] });
          }).on("zoomend", function() {
            n2.select(this).style(u), v2 && f2(t3, e3, m3);
          }), g3;
        }
        function d2(t3, e3) {
          var r3;
          ({ r: e3.rotate(), k: e3.scale() });
          var a2 = c(0, e3), o2 = function(t4) {
            for (var e4 = 0, r4 = arguments.length, i2 = []; ++e4 < r4; )
              i2.push(arguments[e4]);
            var a3 = n2.dispatch.apply(null, i2);
            return a3.of = function(e5, r5) {
              return function(i3) {
                var o3;
                try {
                  o3 = i3.sourceEvent = n2.event, i3.target = t4, n2.event = i3, a3[i3.type].apply(e5, r5);
                } finally {
                  n2.event = o3;
                }
              };
            }, a3;
          }(a2, "zoomstart", "zoom", "zoomend"), s2 = 0, h2 = a2.on;
          function p3(t4) {
            s2++ || t4({ type: "zoomstart" });
          }
          function d3(t4) {
            t4({ type: "zoom" });
          }
          function b2(t4) {
            --s2 || t4({ type: "zoomend" });
          }
          function _2(t4) {
            var r4 = e3.rotate();
            t4("projection.rotation.lon", -r4[0]), t4("projection.rotation.lat", -r4[1]);
          }
          return a2.on("zoomstart", function() {
            n2.select(this).style(l);
            var t4 = n2.mouse(this), s3 = e3.rotate(), u2 = s3, c2 = e3.translate(), f3 = g2(s3);
            r3 = v(e3, t4), h2.call(a2, "zoom", function() {
              var a3 = n2.mouse(this);
              if (e3.scale(n2.event.scale), r3) {
                if (v(e3, a3)) {
                  e3.rotate(s3).translate(c2);
                  var l2 = v(e3, a3), h3 = m2(r3, l2), p4 = T(y(f3, h3)), g3 = x(p4, r3, u2);
                  isFinite(g3[0]) && isFinite(g3[1]) && isFinite(g3[2]) || (g3 = u2), e3.rotate(g3), u2 = g3;
                }
              } else
                r3 = v(e3, t4 = a3);
              d3(o2.of(this, arguments));
            }), p3(o2.of(this, arguments));
          }).on("zoomend", function() {
            n2.select(this).style(u), h2.call(a2, "zoom", null), b2(o2.of(this, arguments)), f2(t3, e3, _2);
          }).on("zoom.redraw", function() {
            t3.render(true);
            var r4 = e3.rotate();
            t3.graphDiv.emit("plotly_relayouting", { "geo.projection.scale": e3.scale() / t3.fitScale, "geo.projection.rotation.lon": -r4[0], "geo.projection.rotation.lat": -r4[1] });
          }), n2.rebind(a2, o2, "on");
        }
        function v(t3, e3) {
          var r3 = t3.invert(e3);
          return r3 && isFinite(r3[0]) && isFinite(r3[1]) && function(t4) {
            var e4 = t4[0] * o, r4 = t4[1] * o, n3 = Math.cos(r4);
            return [n3 * Math.cos(e4), n3 * Math.sin(e4), Math.sin(r4)];
          }(r3);
        }
        function g2(t3) {
          var e3 = 0.5 * t3[0] * o, r3 = 0.5 * t3[1] * o, n3 = 0.5 * t3[2] * o, i2 = Math.sin(e3), a2 = Math.cos(e3), s2 = Math.sin(r3), l2 = Math.cos(r3), u2 = Math.sin(n3), c2 = Math.cos(n3);
          return [a2 * l2 * c2 + i2 * s2 * u2, i2 * l2 * c2 - a2 * s2 * u2, a2 * s2 * c2 + i2 * l2 * u2, a2 * l2 * u2 - i2 * s2 * c2];
        }
        function y(t3, e3) {
          var r3 = t3[0], n3 = t3[1], i2 = t3[2], a2 = t3[3], o2 = e3[0], s2 = e3[1], l2 = e3[2], u2 = e3[3];
          return [r3 * o2 - n3 * s2 - i2 * l2 - a2 * u2, r3 * s2 + n3 * o2 + i2 * u2 - a2 * l2, r3 * l2 - n3 * u2 + i2 * o2 + a2 * s2, r3 * u2 + n3 * l2 - i2 * s2 + a2 * o2];
        }
        function m2(t3, e3) {
          if (t3 && e3) {
            var r3 = function(t4, e4) {
              return [t4[1] * e4[2] - t4[2] * e4[1], t4[2] * e4[0] - t4[0] * e4[2], t4[0] * e4[1] - t4[1] * e4[0]];
            }(t3, e3), n3 = Math.sqrt(k(r3, r3)), i2 = 0.5 * Math.acos(Math.max(-1, Math.min(1, k(t3, e3)))), a2 = Math.sin(i2) / n3;
            return n3 && [Math.cos(i2), r3[2] * a2, -r3[1] * a2, r3[0] * a2];
          }
        }
        function x(t3, e3, r3) {
          var n3 = w2(e3, 2, t3[0]);
          n3 = w2(n3, 1, t3[1]), n3 = w2(n3, 0, t3[2] - r3[2]);
          var i2, a2, o2 = e3[0], l2 = e3[1], u2 = e3[2], c2 = n3[0], f3 = n3[1], h2 = n3[2], p3 = Math.atan2(l2, o2) * s, d3 = Math.sqrt(o2 * o2 + l2 * l2);
          Math.abs(f3) > d3 ? (a2 = (f3 > 0 ? 90 : -90) - p3, i2 = 0) : (a2 = Math.asin(f3 / d3) * s - p3, i2 = Math.sqrt(d3 * d3 - f3 * f3));
          var v2 = 180 - a2 - 2 * p3, g3 = (Math.atan2(h2, c2) - Math.atan2(u2, i2)) * s, y2 = (Math.atan2(h2, c2) - Math.atan2(u2, -i2)) * s;
          return b(r3[0], r3[1], a2, g3) <= b(r3[0], r3[1], v2, y2) ? [a2, g3, r3[2]] : [v2, y2, r3[2]];
        }
        function b(t3, e3, r3, n3) {
          var i2 = _(r3 - t3), a2 = _(n3 - e3);
          return Math.sqrt(i2 * i2 + a2 * a2);
        }
        function _(t3) {
          return (t3 % 360 + 540) % 360 - 180;
        }
        function w2(t3, e3, r3) {
          var n3 = r3 * o, i2 = t3.slice(), a2 = 0 === e3 ? 1 : 0, s2 = 2 === e3 ? 1 : 2, l2 = Math.cos(n3), u2 = Math.sin(n3);
          return i2[a2] = t3[a2] * l2 - t3[s2] * u2, i2[s2] = t3[s2] * l2 + t3[a2] * u2, i2;
        }
        function T(t3) {
          return [Math.atan2(2 * (t3[0] * t3[1] + t3[2] * t3[3]), 1 - 2 * (t3[1] * t3[1] + t3[2] * t3[2])) * s, Math.asin(Math.max(-1, Math.min(1, 2 * (t3[0] * t3[2] - t3[3] * t3[1])))) * s, Math.atan2(2 * (t3[0] * t3[3] + t3[1] * t3[2]), 1 - 2 * (t3[2] * t3[2] + t3[3] * t3[3])) * s];
        }
        function k(t3, e3) {
          for (var r3 = 0, n3 = 0, i2 = t3.length; n3 < i2; ++n3)
            r3 += t3[n3] * e3[n3];
          return r3;
        }
        t2.exports = function(t3, e3) {
          var r3 = t3.projection;
          return (e3._isScoped ? h : e3._isClipped ? d2 : p2)(t3, r3);
        };
      }, 27659: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(85555).SUBPLOT_PATTERN;
        e2.AU = function(t3, e3, r3) {
          var i2 = n2.subplotsRegistry[e3];
          if (!i2)
            return [];
          for (var a = i2.attr, o = [], s = 0; s < t3.length; s++) {
            var l = t3[s];
            l[0].trace[a] === r3 && o.push(l);
          }
          return o;
        }, e2.a0 = function(t3, e3) {
          var r3, i2 = [], a = [];
          if (!(r3 = "string" == typeof e3 ? n2.getModule(e3).plot : "function" == typeof e3 ? e3 : e3.plot))
            return [i2, t3];
          for (var o = 0; o < t3.length; o++) {
            var s = t3[o], l = s[0].trace;
            true === l.visible && 0 !== l._length && (l._module.plot === r3 ? i2.push(s) : a.push(s));
          }
          return [i2, a];
        }, e2.NG = function(t3, e3, r3) {
          if (!n2.subplotsRegistry[e3])
            return [];
          var a, o, s, l = n2.subplotsRegistry[e3].attr, u = [];
          if ("gl2d" === e3) {
            var c = r3.match(i);
            o = "x" + c[1], s = "y" + c[2];
          }
          for (var f2 = 0; f2 < t3.length; f2++)
            a = t3[f2], "gl2d" === e3 && n2.traceIs(a, "gl2d") ? a[l[0]] === o && a[l[1]] === s && u.push(a) : a[l] === r3 && u.push(a);
          return u;
        };
      }, 75071: function(t2, e2, r2) {
        var n2 = r2(16825), i = r2(1195), a = r2(48956), o = r2(85555), s = r2(38520);
        function l(t3, e3) {
          this.element = t3, this.plot = e3, this.mouseListener = null, this.wheelListener = null, this.lastInputTime = Date.now(), this.lastPos = [0, 0], this.boxEnabled = false, this.boxInited = false, this.boxStart = [0, 0], this.boxEnd = [0, 0], this.dragStart = [0, 0];
        }
        t2.exports = function(t3) {
          var e3 = t3.mouseContainer, r3 = t3.glplot, u = new l(e3, r3);
          function c() {
            t3.xaxis.autorange = false, t3.yaxis.autorange = false;
          }
          function f2(e4, n3, i2) {
            var a2, s2, l2 = t3.calcDataBox(), f3 = r3.viewBox, h = u.lastPos[0], p2 = u.lastPos[1], d2 = o.MINDRAG * r3.pixelRatio, v = o.MINZOOM * r3.pixelRatio;
            function g2(e5, r4, n4) {
              var i3 = Math.min(r4, n4), a3 = Math.max(r4, n4);
              i3 !== a3 ? (l2[e5] = i3, l2[e5 + 2] = a3, u.dataBox = l2, t3.setRanges(l2)) : (t3.selectBox.selectBox = [0, 0, 1, 1], t3.glplot.setDirty());
            }
            switch (n3 *= r3.pixelRatio, i2 *= r3.pixelRatio, i2 = f3[3] - f3[1] - i2, t3.fullLayout.dragmode) {
              case "zoom":
                if (e4) {
                  var y = n3 / (f3[2] - f3[0]) * (l2[2] - l2[0]) + l2[0], m2 = i2 / (f3[3] - f3[1]) * (l2[3] - l2[1]) + l2[1];
                  u.boxInited || (u.boxStart[0] = y, u.boxStart[1] = m2, u.dragStart[0] = n3, u.dragStart[1] = i2), u.boxEnd[0] = y, u.boxEnd[1] = m2, u.boxInited = true, u.boxEnabled || u.boxStart[0] === u.boxEnd[0] && u.boxStart[1] === u.boxEnd[1] || (u.boxEnabled = true);
                  var x = Math.abs(u.dragStart[0] - n3) < v, b = Math.abs(u.dragStart[1] - i2) < v;
                  if (!function() {
                    for (var e5 = t3.graphDiv._fullLayout._axisConstraintGroups, r4 = t3.xaxis._id, n4 = t3.yaxis._id, i3 = 0; i3 < e5.length; i3++)
                      if (-1 !== e5[i3][r4]) {
                        if (-1 !== e5[i3][n4])
                          return true;
                        break;
                      }
                    return false;
                  }() || x && b)
                    x && (u.boxEnd[0] = u.boxStart[0]), b && (u.boxEnd[1] = u.boxStart[1]);
                  else {
                    a2 = u.boxEnd[0] - u.boxStart[0], s2 = u.boxEnd[1] - u.boxStart[1];
                    var _ = (l2[3] - l2[1]) / (l2[2] - l2[0]);
                    Math.abs(a2 * _) > Math.abs(s2) ? (u.boxEnd[1] = u.boxStart[1] + Math.abs(a2) * _ * (s2 >= 0 ? 1 : -1), u.boxEnd[1] < l2[1] ? (u.boxEnd[1] = l2[1], u.boxEnd[0] = u.boxStart[0] + (l2[1] - u.boxStart[1]) / Math.abs(_)) : u.boxEnd[1] > l2[3] && (u.boxEnd[1] = l2[3], u.boxEnd[0] = u.boxStart[0] + (l2[3] - u.boxStart[1]) / Math.abs(_))) : (u.boxEnd[0] = u.boxStart[0] + Math.abs(s2) / _ * (a2 >= 0 ? 1 : -1), u.boxEnd[0] < l2[0] ? (u.boxEnd[0] = l2[0], u.boxEnd[1] = u.boxStart[1] + (l2[0] - u.boxStart[0]) * Math.abs(_)) : u.boxEnd[0] > l2[2] && (u.boxEnd[0] = l2[2], u.boxEnd[1] = u.boxStart[1] + (l2[2] - u.boxStart[0]) * Math.abs(_)));
                  }
                } else
                  u.boxEnabled ? (a2 = u.boxStart[0] !== u.boxEnd[0], s2 = u.boxStart[1] !== u.boxEnd[1], a2 || s2 ? (a2 && (g2(0, u.boxStart[0], u.boxEnd[0]), t3.xaxis.autorange = false), s2 && (g2(1, u.boxStart[1], u.boxEnd[1]), t3.yaxis.autorange = false), t3.relayoutCallback()) : t3.glplot.setDirty(), u.boxEnabled = false, u.boxInited = false) : u.boxInited && (u.boxInited = false);
                break;
              case "pan":
                u.boxEnabled = false, u.boxInited = false, e4 ? (u.panning || (u.dragStart[0] = n3, u.dragStart[1] = i2), Math.abs(u.dragStart[0] - n3) < d2 && (n3 = u.dragStart[0]), Math.abs(u.dragStart[1] - i2) < d2 && (i2 = u.dragStart[1]), a2 = (h - n3) * (l2[2] - l2[0]) / (r3.viewBox[2] - r3.viewBox[0]), s2 = (p2 - i2) * (l2[3] - l2[1]) / (r3.viewBox[3] - r3.viewBox[1]), l2[0] += a2, l2[2] += a2, l2[1] += s2, l2[3] += s2, t3.setRanges(l2), u.panning = true, u.lastInputTime = Date.now(), c(), t3.cameraChanged(), t3.handleAnnotations()) : u.panning && (u.panning = false, t3.relayoutCallback());
            }
            u.lastPos[0] = n3, u.lastPos[1] = i2;
          }
          return u.mouseListener = n2(e3, f2), e3.addEventListener("touchstart", function(t4) {
            var r4 = a(t4.changedTouches[0], e3);
            f2(0, r4[0], r4[1]), f2(1, r4[0], r4[1]), t4.preventDefault();
          }, !!s && { passive: false }), e3.addEventListener("touchmove", function(t4) {
            t4.preventDefault();
            var r4 = a(t4.changedTouches[0], e3);
            f2(1, r4[0], r4[1]), t4.preventDefault();
          }, !!s && { passive: false }), e3.addEventListener("touchend", function(t4) {
            f2(0, u.lastPos[0], u.lastPos[1]), t4.preventDefault();
          }, !!s && { passive: false }), u.wheelListener = i(e3, function(e4, n3) {
            if (!t3.scrollZoom)
              return false;
            var i2 = t3.calcDataBox(), a2 = r3.viewBox, o2 = u.lastPos[0], s2 = u.lastPos[1], l2 = Math.exp(5 * n3 / (a2[3] - a2[1])), f3 = o2 / (a2[2] - a2[0]) * (i2[2] - i2[0]) + i2[0], h = s2 / (a2[3] - a2[1]) * (i2[3] - i2[1]) + i2[1];
            return i2[0] = (i2[0] - f3) * l2 + f3, i2[2] = (i2[2] - f3) * l2 + f3, i2[1] = (i2[1] - h) * l2 + h, i2[3] = (i2[3] - h) * l2 + h, t3.setRanges(i2), u.lastInputTime = Date.now(), c(), t3.cameraChanged(), t3.handleAnnotations(), t3.relayoutCallback(), true;
          }, true), u;
        };
      }, 82961: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(78614);
        function a(t3) {
          this.scene = t3, this.gl = t3.gl, this.pixelRatio = t3.pixelRatio, this.screenBox = [0, 0, 1, 1], this.viewBox = [0, 0, 1, 1], this.dataBox = [-1, -1, 1, 1], this.borderLineEnable = [false, false, false, false], this.borderLineWidth = [1, 1, 1, 1], this.borderLineColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.ticks = [[], []], this.tickEnable = [true, true, false, false], this.tickPad = [15, 15, 15, 15], this.tickAngle = [0, 0, 0, 0], this.tickColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.tickMarkLength = [0, 0, 0, 0], this.tickMarkWidth = [0, 0, 0, 0], this.tickMarkColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.labels = ["x", "y"], this.labelEnable = [true, true, false, false], this.labelAngle = [0, Math.PI / 2, 0, 3 * Math.PI / 2], this.labelPad = [15, 15, 15, 15], this.labelSize = [12, 12], this.labelFont = ["sans-serif", "sans-serif"], this.labelColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.title = "", this.titleEnable = true, this.titleCenter = [0, 0, 0, 0], this.titleAngle = 0, this.titleColor = [0, 0, 0, 1], this.titleFont = "sans-serif", this.titleSize = 18, this.gridLineEnable = [true, true], this.gridLineColor = [[0, 0, 0, 0.5], [0, 0, 0, 0.5]], this.gridLineWidth = [1, 1], this.zeroLineEnable = [true, true], this.zeroLineWidth = [1, 1], this.zeroLineColor = [[0, 0, 0, 1], [0, 0, 0, 1]], this.borderColor = [0, 0, 0, 0], this.backgroundColor = [0, 0, 0, 0], this.static = this.scene.staticPlot;
        }
        var o = a.prototype, s = ["xaxis", "yaxis"];
        o.merge = function(t3) {
          var e3, r3, n3, a2, o2, l, u, c, f2, h, p2;
          for (this.titleEnable = false, this.backgroundColor = i(t3.plot_bgcolor), h = 0; h < 2; ++h) {
            var d2 = (e3 = s[h]).charAt(0);
            for (n3 = (r3 = t3[this.scene[e3]._name]).title.text === this.scene.fullLayout._dfltTitle[d2] ? "" : r3.title.text, p2 = 0; p2 <= 2; p2 += 2)
              this.labelEnable[h + p2] = false, this.labels[h + p2] = n3, this.labelColor[h + p2] = i(r3.title.font.color), this.labelFont[h + p2] = r3.title.font.family, this.labelSize[h + p2] = r3.title.font.size, this.labelPad[h + p2] = this.getLabelPad(e3, r3), this.tickEnable[h + p2] = false, this.tickColor[h + p2] = i((r3.tickfont || {}).color), this.tickAngle[h + p2] = "auto" === r3.tickangle ? 0 : Math.PI * -r3.tickangle / 180, this.tickPad[h + p2] = this.getTickPad(r3), this.tickMarkLength[h + p2] = 0, this.tickMarkWidth[h + p2] = r3.tickwidth || 0, this.tickMarkColor[h + p2] = i(r3.tickcolor), this.borderLineEnable[h + p2] = false, this.borderLineColor[h + p2] = i(r3.linecolor), this.borderLineWidth[h + p2] = r3.linewidth || 0;
            u = this.hasSharedAxis(r3), o2 = this.hasAxisInDfltPos(e3, r3) && !u, l = this.hasAxisInAltrPos(e3, r3) && !u, a2 = r3.mirror || false, c = u ? -1 !== String(a2).indexOf("all") : !!a2, f2 = u ? "allticks" === a2 : -1 !== String(a2).indexOf("ticks"), o2 ? this.labelEnable[h] = true : l && (this.labelEnable[h + 2] = true), o2 ? this.tickEnable[h] = r3.showticklabels : l && (this.tickEnable[h + 2] = r3.showticklabels), (o2 || c) && (this.borderLineEnable[h] = r3.showline), (l || c) && (this.borderLineEnable[h + 2] = r3.showline), (o2 || f2) && (this.tickMarkLength[h] = this.getTickMarkLength(r3)), (l || f2) && (this.tickMarkLength[h + 2] = this.getTickMarkLength(r3)), this.gridLineEnable[h] = r3.showgrid, this.gridLineColor[h] = i(r3.gridcolor), this.gridLineWidth[h] = r3.gridwidth, this.zeroLineEnable[h] = r3.zeroline, this.zeroLineColor[h] = i(r3.zerolinecolor), this.zeroLineWidth[h] = r3.zerolinewidth;
          }
        }, o.hasSharedAxis = function(t3) {
          var e3 = this.scene, r3 = e3.fullLayout._subplots.gl2d;
          return 0 !== n2.findSubplotsWithAxis(r3, t3).indexOf(e3.id);
        }, o.hasAxisInDfltPos = function(t3, e3) {
          var r3 = e3.side;
          return "xaxis" === t3 ? "bottom" === r3 : "yaxis" === t3 ? "left" === r3 : void 0;
        }, o.hasAxisInAltrPos = function(t3, e3) {
          var r3 = e3.side;
          return "xaxis" === t3 ? "top" === r3 : "yaxis" === t3 ? "right" === r3 : void 0;
        }, o.getLabelPad = function(t3, e3) {
          var r3 = 1.5, n3 = e3.title.font.size, i2 = e3.showticklabels;
          return "xaxis" === t3 ? "top" === e3.side ? n3 * (r3 + (i2 ? 1 : 0)) - 10 : n3 * (r3 + (i2 ? 0.5 : 0)) - 10 : "yaxis" === t3 ? "right" === e3.side ? 10 + n3 * (r3 + (i2 ? 1 : 0.5)) : 10 + n3 * (r3 + (i2 ? 0.5 : 0)) : void 0;
        }, o.getTickPad = function(t3) {
          return "outside" === t3.ticks ? 10 + t3.ticklen : 15;
        }, o.getTickMarkLength = function(t3) {
          if (!t3.ticks)
            return 0;
          var e3 = t3.ticklen;
          return "inside" === t3.ticks ? -e3 : e3;
        }, t2.exports = function(t3) {
          return new a(t3);
        };
      }, 4796: function(t2, e2, r2) {
        var n2 = r2(30962).overrideAll, i = r2(92918), a = r2(10820), o = r2(77922), s = r2(85555), l = r2(93612), u = r2(528), c = r2(27659).NG;
        e2.name = "gl2d", e2.attr = ["xaxis", "yaxis"], e2.idRoot = ["x", "y"], e2.idRegex = s.idRegex, e2.attrRegex = s.attrRegex, e2.attributes = r2(89502), e2.supplyLayoutDefaults = function(t3, e3, r3) {
          e3._has("cartesian") || l.supplyLayoutDefaults(t3, e3, r3);
        }, e2.layoutAttrOverrides = n2(l.layoutAttributes, "plot", "from-root"), e2.baseLayoutAttrOverrides = n2({ plot_bgcolor: a.plot_bgcolor, hoverlabel: u.hoverlabel }, "plot", "nested"), e2.plot = function(t3) {
          for (var e3 = t3._fullLayout, r3 = t3._fullData, n3 = e3._subplots.gl2d, a2 = 0; a2 < n3.length; a2++) {
            var o2 = n3[a2], s2 = e3._plots[o2], l2 = c(r3, "gl2d", o2), u2 = s2._scene2d;
            void 0 === u2 && (u2 = new i({ id: o2, graphDiv: t3, container: t3.querySelector(".gl-container"), staticPlot: t3._context.staticPlot, plotGlPixelRatio: t3._context.plotGlPixelRatio }, e3), s2._scene2d = u2), u2.plot(l2, t3.calcdata, e3, t3.layout);
          }
        }, e2.clean = function(t3, e3, r3, n3) {
          for (var i2 = n3._subplots.gl2d || [], a2 = 0; a2 < i2.length; a2++) {
            var o2 = i2[a2], s2 = n3._plots[o2];
            if (s2._scene2d) {
              var u2 = c(t3, "gl2d", o2);
              0 === u2.length && (s2._scene2d.destroy(), delete n3._plots[o2]);
            }
          }
          l.clean.apply(this, arguments);
        }, e2.drawFramework = function(t3) {
          t3._context.staticPlot || l.drawFramework(t3);
        }, e2.toSVG = function(t3) {
          for (var e3 = t3._fullLayout, r3 = e3._subplots.gl2d, n3 = 0; n3 < r3.length; n3++) {
            var i2 = e3._plots[r3[n3]]._scene2d, a2 = i2.toImage("png");
            e3._glimages.append("svg:image").attr({ xmlns: o.svg, "xlink:href": a2, x: 0, y: 0, width: "100%", height: "100%", preserveAspectRatio: "none" }), i2.destroy();
          }
        }, e2.updateFx = function(t3) {
          for (var e3 = t3._fullLayout, r3 = e3._subplots.gl2d, n3 = 0; n3 < r3.length; n3++)
            e3._plots[r3[n3]]._scene2d.updateFx(e3.dragmode);
        };
      }, 92918: function(t2, e2, r2) {
        var n2, i, a = r2(73972), o = r2(89298), s = r2(30211), l = r2(9330).gl_plot2d, u = r2(9330).gl_spikes2d, c = r2(9330).gl_select_box, f2 = r2(40372), h = r2(82961), p2 = r2(75071), d2 = r2(58617), v = r2(99082), g2 = v.enforce, y = v.clean, m2 = r2(71739).doAutoRange, x = r2(64505), b = x.drawMode, _ = x.selectMode, w2 = ["xaxis", "yaxis"], T = r2(85555).SUBPLOT_PATTERN;
        function k(t3, e3) {
          this.container = t3.container, this.graphDiv = t3.graphDiv, this.pixelRatio = t3.plotGlPixelRatio || window.devicePixelRatio, this.id = t3.id, this.staticPlot = !!t3.staticPlot, this.scrollZoom = this.graphDiv._context._scrollZoom.cartesian, this.fullData = null, this.updateRefs(e3), this.makeFramework(), this.stopped || (this.glplotOptions = h(this), this.glplotOptions.merge(e3), this.glplot = l(this.glplotOptions), this.camera = p2(this), this.traces = {}, this.spikes = u(this.glplot), this.selectBox = c(this.glplot, { innerFill: false, outerFill: true }), this.lastButtonState = 0, this.pickResult = null, this.isMouseOver = true, this.stopped = false, this.redraw = this.draw.bind(this), this.redraw());
        }
        t2.exports = k;
        var A = k.prototype;
        A.makeFramework = function() {
          if (this.staticPlot) {
            if (!(i || (n2 = document.createElement("canvas"), i = f2({ canvas: n2, preserveDrawingBuffer: false, premultipliedAlpha: true, antialias: true }))))
              throw new Error("Error creating static canvas/context for image server");
            this.canvas = n2, this.gl = i;
          } else {
            var t3 = this.container.querySelector(".gl-canvas-focus"), e3 = f2({ canvas: t3, preserveDrawingBuffer: true, premultipliedAlpha: true });
            if (!e3)
              return d2(this), void (this.stopped = true);
            this.canvas = t3, this.gl = e3;
          }
          var r3 = this.canvas;
          r3.style.width = "100%", r3.style.height = "100%", r3.style.position = "absolute", r3.style.top = "0px", r3.style.left = "0px", r3.style["pointer-events"] = "none", this.updateSize(r3);
          var a2 = this.svgContainer = document.createElementNS("http://www.w3.org/2000/svg", "svg");
          a2.style.position = "absolute", a2.style.top = a2.style.left = "0px", a2.style.width = a2.style.height = "100%", a2.style["z-index"] = 20, a2.style["pointer-events"] = "none";
          var o2 = this.mouseContainer = document.createElement("div");
          o2.style.position = "absolute", o2.style["pointer-events"] = "auto", this.pickCanvas = this.container.querySelector(".gl-canvas-pick");
          var s2 = this.container;
          s2.appendChild(a2), s2.appendChild(o2);
          var l2 = this;
          o2.addEventListener("mouseout", function() {
            l2.isMouseOver = false, l2.unhover();
          }), o2.addEventListener("mouseover", function() {
            l2.isMouseOver = true;
          });
        }, A.toImage = function(t3) {
          t3 || (t3 = "png"), this.stopped = true, this.staticPlot && this.container.appendChild(n2), this.updateSize(this.canvas);
          var e3 = this.glplot.gl, r3 = e3.drawingBufferWidth, i2 = e3.drawingBufferHeight;
          e3.clearColor(1, 1, 1, 0), e3.clear(e3.COLOR_BUFFER_BIT | e3.DEPTH_BUFFER_BIT), this.glplot.setDirty(), this.glplot.draw(), e3.bindFramebuffer(e3.FRAMEBUFFER, null);
          var a2 = new Uint8Array(r3 * i2 * 4);
          e3.readPixels(0, 0, r3, i2, e3.RGBA, e3.UNSIGNED_BYTE, a2);
          for (var o2 = 0, s2 = i2 - 1; o2 < s2; ++o2, --s2)
            for (var l2 = 0; l2 < r3; ++l2)
              for (var u2 = 0; u2 < 4; ++u2) {
                var c2 = a2[4 * (r3 * o2 + l2) + u2];
                a2[4 * (r3 * o2 + l2) + u2] = a2[4 * (r3 * s2 + l2) + u2], a2[4 * (r3 * s2 + l2) + u2] = c2;
              }
          var f3 = document.createElement("canvas");
          f3.width = r3, f3.height = i2;
          var h2, p3 = f3.getContext("2d", { willReadFrequently: true }), d3 = p3.createImageData(r3, i2);
          switch (d3.data.set(a2), p3.putImageData(d3, 0, 0), t3) {
            case "jpeg":
              h2 = f3.toDataURL("image/jpeg");
              break;
            case "webp":
              h2 = f3.toDataURL("image/webp");
              break;
            default:
              h2 = f3.toDataURL("image/png");
          }
          return this.staticPlot && this.container.removeChild(n2), h2;
        }, A.updateSize = function(t3) {
          t3 || (t3 = this.canvas);
          var e3 = this.pixelRatio, r3 = this.fullLayout, n3 = r3.width, i2 = r3.height, a2 = 0 | Math.ceil(e3 * n3), o2 = 0 | Math.ceil(e3 * i2);
          return t3.width === a2 && t3.height === o2 || (t3.width = a2, t3.height = o2), t3;
        }, A.computeTickMarks = function() {
          this.xaxis.setScale(), this.yaxis.setScale();
          for (var t3 = [o.calcTicks(this.xaxis), o.calcTicks(this.yaxis)], e3 = 0; e3 < 2; ++e3)
            for (var r3 = 0; r3 < t3[e3].length; ++r3)
              t3[e3][r3].text = t3[e3][r3].text + "";
          return t3;
        }, A.updateRefs = function(t3) {
          this.fullLayout = t3;
          var e3 = this.id.match(T), r3 = "xaxis" + e3[1], n3 = "yaxis" + e3[2];
          this.xaxis = this.fullLayout[r3], this.yaxis = this.fullLayout[n3];
        }, A.relayoutCallback = function() {
          var t3 = this.graphDiv, e3 = this.xaxis, r3 = this.yaxis, n3 = t3.layout, i2 = {}, o2 = i2[e3._name + ".range"] = e3.range.slice(), s2 = i2[r3._name + ".range"] = r3.range.slice();
          i2[e3._name + ".autorange"] = e3.autorange, i2[r3._name + ".autorange"] = r3.autorange, a.call("_storeDirectGUIEdit", t3.layout, t3._fullLayout._preGUI, i2);
          var l2 = n3[e3._name];
          l2.range = o2, l2.autorange = e3.autorange;
          var u2 = n3[r3._name];
          u2.range = s2, u2.autorange = r3.autorange, i2.lastInputTime = this.camera.lastInputTime, t3.emit("plotly_relayout", i2);
        }, A.cameraChanged = function() {
          var t3 = this.camera;
          this.glplot.setDataBox(this.calcDataBox());
          var e3 = this.computeTickMarks();
          (function(t4, e4) {
            for (var r3 = 0; r3 < 2; ++r3) {
              var n3 = t4[r3], i2 = e4[r3];
              if (n3.length !== i2.length)
                return true;
              for (var a2 = 0; a2 < n3.length; ++a2)
                if (n3[a2].x !== i2[a2].x)
                  return true;
            }
            return false;
          })(e3, this.glplotOptions.ticks) && (this.glplotOptions.ticks = e3, this.glplotOptions.dataBox = t3.dataBox, this.glplot.update(this.glplotOptions), this.handleAnnotations());
        }, A.handleAnnotations = function() {
          for (var t3 = this.graphDiv, e3 = this.fullLayout.annotations, r3 = 0; r3 < e3.length; r3++) {
            var n3 = e3[r3];
            n3.xref === this.xaxis._id && n3.yref === this.yaxis._id && a.getComponentMethod("annotations", "drawOne")(t3, r3);
          }
        }, A.destroy = function() {
          if (this.glplot) {
            var t3 = this.traces;
            t3 && Object.keys(t3).map(function(e3) {
              t3[e3].dispose(), delete t3[e3];
            }), this.glplot.dispose(), this.container.removeChild(this.svgContainer), this.container.removeChild(this.mouseContainer), this.fullData = null, this.glplot = null, this.stopped = true, this.camera.mouseListener.enabled = false, this.mouseContainer.removeEventListener("wheel", this.camera.wheelListener), this.camera = null;
          }
        }, A.plot = function(t3, e3, r3) {
          var n3 = this.glplot;
          this.updateRefs(r3), this.xaxis.clearCalc(), this.yaxis.clearCalc(), this.updateTraces(t3, e3), this.updateFx(r3.dragmode);
          var i2 = r3.width, a2 = r3.height;
          this.updateSize(this.canvas);
          var o2 = this.glplotOptions;
          o2.merge(r3), o2.screenBox = [0, 0, i2, a2];
          var s2 = { _fullLayout: { _axisConstraintGroups: r3._axisConstraintGroups, xaxis: this.xaxis, yaxis: this.yaxis, _size: r3._size } };
          y(s2, this.xaxis), y(s2, this.yaxis);
          var l2, u2, c2 = r3._size, f3 = this.xaxis.domain, h2 = this.yaxis.domain;
          for (o2.viewBox = [c2.l + f3[0] * c2.w, c2.b + h2[0] * c2.h, i2 - c2.r - (1 - f3[1]) * c2.w, a2 - c2.t - (1 - h2[1]) * c2.h], this.mouseContainer.style.width = c2.w * (f3[1] - f3[0]) + "px", this.mouseContainer.style.height = c2.h * (h2[1] - h2[0]) + "px", this.mouseContainer.height = c2.h * (h2[1] - h2[0]), this.mouseContainer.style.left = c2.l + f3[0] * c2.w + "px", this.mouseContainer.style.top = c2.t + (1 - h2[1]) * c2.h + "px", u2 = 0; u2 < 2; ++u2)
            (l2 = this[w2[u2]])._length = o2.viewBox[u2 + 2] - o2.viewBox[u2], m2(this.graphDiv, l2), l2.setScale();
          g2(s2), o2.ticks = this.computeTickMarks(), o2.dataBox = this.calcDataBox(), o2.merge(r3), n3.update(o2), this.glplot.draw();
        }, A.calcDataBox = function() {
          var t3 = this.xaxis, e3 = this.yaxis, r3 = t3.range, n3 = e3.range, i2 = t3.r2l, a2 = e3.r2l;
          return [i2(r3[0]), a2(n3[0]), i2(r3[1]), a2(n3[1])];
        }, A.setRanges = function(t3) {
          var e3 = this.xaxis, r3 = this.yaxis, n3 = e3.l2r, i2 = r3.l2r;
          e3.range = [n3(t3[0]), n3(t3[2])], r3.range = [i2(t3[1]), i2(t3[3])];
        }, A.updateTraces = function(t3, e3) {
          var r3, n3, i2, a2 = Object.keys(this.traces);
          this.fullData = t3;
          t:
            for (r3 = 0; r3 < a2.length; r3++) {
              var o2 = a2[r3], s2 = this.traces[o2];
              for (n3 = 0; n3 < t3.length; n3++)
                if ((i2 = t3[n3]).uid === o2 && i2.type === s2.type)
                  continue t;
              s2.dispose(), delete this.traces[o2];
            }
          for (r3 = 0; r3 < t3.length; r3++) {
            i2 = t3[r3];
            var l2 = e3[r3], u2 = this.traces[i2.uid];
            u2 ? u2.update(i2, l2) : (u2 = i2._module.plot(this, i2, l2), this.traces[i2.uid] = u2);
          }
          this.glplot.objects.sort(function(t4, e4) {
            return t4._trace.index - e4._trace.index;
          });
        }, A.updateFx = function(t3) {
          _(t3) || b(t3) ? (this.pickCanvas.style["pointer-events"] = "none", this.mouseContainer.style["pointer-events"] = "none") : (this.pickCanvas.style["pointer-events"] = "auto", this.mouseContainer.style["pointer-events"] = "auto"), this.mouseContainer.style.cursor = "pan" === t3 ? "move" : "zoom" === t3 ? "crosshair" : null;
        }, A.emitPointAction = function(t3, e3) {
          for (var r3, n3 = t3.trace.uid, i2 = t3.pointIndex, a2 = 0; a2 < this.fullData.length; a2++)
            this.fullData[a2].uid === n3 && (r3 = this.fullData[a2]);
          var o2 = { x: t3.traceCoord[0], y: t3.traceCoord[1], curveNumber: r3.index, pointNumber: i2, data: r3._input, fullData: this.fullData, xaxis: this.xaxis, yaxis: this.yaxis };
          s.appendArrayPointValue(o2, r3, i2), this.graphDiv.emit(e3, { points: [o2] });
        }, A.draw = function() {
          if (!this.stopped) {
            requestAnimationFrame(this.redraw);
            var t3 = this.glplot, e3 = this.camera, r3 = e3.mouseListener, n3 = 1 === this.lastButtonState && 0 === r3.buttons, i2 = this.fullLayout;
            this.lastButtonState = r3.buttons, this.cameraChanged();
            var a2, o2 = r3.x * t3.pixelRatio, l2 = this.canvas.height - t3.pixelRatio * r3.y;
            if (e3.boxEnabled && "zoom" === i2.dragmode) {
              this.selectBox.enabled = true;
              for (var u2 = this.selectBox.selectBox = [Math.min(e3.boxStart[0], e3.boxEnd[0]), Math.min(e3.boxStart[1], e3.boxEnd[1]), Math.max(e3.boxStart[0], e3.boxEnd[0]), Math.max(e3.boxStart[1], e3.boxEnd[1])], c2 = 0; c2 < 2; c2++)
                e3.boxStart[c2] === e3.boxEnd[c2] && (u2[c2] = t3.dataBox[c2], u2[c2 + 2] = t3.dataBox[c2 + 2]);
              t3.setDirty();
            } else if (!e3.panning && this.isMouseOver) {
              this.selectBox.enabled = false;
              var f3 = i2._size, h2 = this.xaxis.domain, p3 = this.yaxis.domain, d3 = (a2 = t3.pick(o2 / t3.pixelRatio + f3.l + h2[0] * f3.w, l2 / t3.pixelRatio - (f3.t + (1 - p3[1]) * f3.h))) && a2.object._trace.handlePick(a2);
              if (d3 && n3 && this.emitPointAction(d3, "plotly_click"), a2 && "skip" !== a2.object._trace.hoverinfo && i2.hovermode && d3 && (!this.lastPickResult || this.lastPickResult.traceUid !== d3.trace.uid || this.lastPickResult.dataCoord[0] !== d3.dataCoord[0] || this.lastPickResult.dataCoord[1] !== d3.dataCoord[1])) {
                var v2 = d3;
                this.lastPickResult = { traceUid: d3.trace ? d3.trace.uid : null, dataCoord: d3.dataCoord.slice() }, this.spikes.update({ center: a2.dataCoord }), v2.screenCoord = [((t3.viewBox[2] - t3.viewBox[0]) * (a2.dataCoord[0] - t3.dataBox[0]) / (t3.dataBox[2] - t3.dataBox[0]) + t3.viewBox[0]) / t3.pixelRatio, (this.canvas.height - (t3.viewBox[3] - t3.viewBox[1]) * (a2.dataCoord[1] - t3.dataBox[1]) / (t3.dataBox[3] - t3.dataBox[1]) - t3.viewBox[1]) / t3.pixelRatio], this.emitPointAction(d3, "plotly_hover");
                var g3 = this.fullData[v2.trace.index] || {}, y2 = v2.pointIndex, m3 = s.castHoverinfo(g3, i2, y2);
                if (m3 && "all" !== m3) {
                  var x2 = m3.split("+");
                  -1 === x2.indexOf("x") && (v2.traceCoord[0] = void 0), -1 === x2.indexOf("y") && (v2.traceCoord[1] = void 0), -1 === x2.indexOf("z") && (v2.traceCoord[2] = void 0), -1 === x2.indexOf("text") && (v2.textLabel = void 0), -1 === x2.indexOf("name") && (v2.name = void 0);
                }
                s.loneHover({ x: v2.screenCoord[0], y: v2.screenCoord[1], xLabel: this.hoverFormatter("xaxis", v2.traceCoord[0]), yLabel: this.hoverFormatter("yaxis", v2.traceCoord[1]), zLabel: v2.traceCoord[2], text: v2.textLabel, name: v2.name, color: s.castHoverOption(g3, y2, "bgcolor") || v2.color, borderColor: s.castHoverOption(g3, y2, "bordercolor"), fontFamily: s.castHoverOption(g3, y2, "font.family"), fontSize: s.castHoverOption(g3, y2, "font.size"), fontColor: s.castHoverOption(g3, y2, "font.color"), nameLength: s.castHoverOption(g3, y2, "namelength"), textAlign: s.castHoverOption(g3, y2, "align") }, { container: this.svgContainer, gd: this.graphDiv });
              }
            }
            a2 || this.unhover(), t3.draw();
          }
        }, A.unhover = function() {
          this.lastPickResult && (this.spikes.update({}), this.lastPickResult = null, this.graphDiv.emit("plotly_unhover"), s.loneUnhover(this.svgContainer));
        }, A.hoverFormatter = function(t3, e3) {
          if (void 0 !== e3) {
            var r3 = this[t3];
            return o.tickText(r3, r3.c2l(e3), "hover").text;
          }
        };
      }, 58547: function(t2, e2, r2) {
        var n2 = r2(30962).overrideAll, i = r2(528), a = r2(33539), o = r2(27659).NG, s = r2(71828), l = r2(77922), u = "gl3d", c = "scene";
        e2.name = u, e2.attr = c, e2.idRoot = c, e2.idRegex = e2.attrRegex = s.counterRegex("scene"), e2.attributes = r2(59084), e2.layoutAttributes = r2(65500), e2.baseLayoutAttrOverrides = n2({ hoverlabel: i.hoverlabel }, "plot", "nested"), e2.supplyLayoutDefaults = r2(24682), e2.plot = function(t3) {
          for (var e3 = t3._fullLayout, r3 = t3._fullData, n3 = e3._subplots.gl3d, i2 = 0; i2 < n3.length; i2++) {
            var s2 = n3[i2], l2 = o(r3, u, s2), c2 = e3[s2], f2 = c2.camera, h = c2._scene;
            h || (h = new a({ id: s2, graphDiv: t3, container: t3.querySelector(".gl-container"), staticPlot: t3._context.staticPlot, plotGlPixelRatio: t3._context.plotGlPixelRatio, camera: f2 }, e3), c2._scene = h), h.viewInitial || (h.viewInitial = { up: { x: f2.up.x, y: f2.up.y, z: f2.up.z }, eye: { x: f2.eye.x, y: f2.eye.y, z: f2.eye.z }, center: { x: f2.center.x, y: f2.center.y, z: f2.center.z } }), h.plot(l2, e3, t3.layout);
          }
        }, e2.clean = function(t3, e3, r3, n3) {
          for (var i2 = n3._subplots.gl3d || [], a2 = 0; a2 < i2.length; a2++) {
            var o2 = i2[a2];
            !e3[o2] && n3[o2]._scene && (n3[o2]._scene.destroy(), n3._infolayer && n3._infolayer.selectAll(".annotation-" + o2).remove());
          }
        }, e2.toSVG = function(t3) {
          for (var e3 = t3._fullLayout, r3 = e3._subplots.gl3d, n3 = e3._size, i2 = 0; i2 < r3.length; i2++) {
            var a2 = e3[r3[i2]], o2 = a2.domain, s2 = a2._scene, u2 = s2.toImage("png");
            e3._glimages.append("svg:image").attr({ xmlns: l.svg, "xlink:href": u2, x: n3.l + n3.w * o2.x[0], y: n3.t + n3.h * (1 - o2.y[1]), width: n3.w * (o2.x[1] - o2.x[0]), height: n3.h * (o2.y[1] - o2.y[0]), preserveAspectRatio: "none" }), s2.destroy();
          }
        }, e2.cleanId = function(t3) {
          if (t3.match(/^scene[0-9]*$/)) {
            var e3 = t3.substr(5);
            return "1" === e3 && (e3 = ""), c + e3;
          }
        }, e2.updateFx = function(t3) {
          for (var e3 = t3._fullLayout, r3 = e3._subplots.gl3d, n3 = 0; n3 < r3.length; n3++)
            e3[r3[n3]]._scene.updateFx(e3.dragmode, e3.hovermode);
        };
      }, 59084: function(t2) {
        t2.exports = { scene: { valType: "subplotid", dflt: "scene", editType: "calc+clearAxisTypes" } };
      }, 77894: function(t2, e2, r2) {
        var n2 = r2(7901), i = r2(13838), a = r2(1426).extendFlat, o = r2(30962).overrideAll;
        t2.exports = o({ visible: i.visible, showspikes: { valType: "boolean", dflt: true }, spikesides: { valType: "boolean", dflt: true }, spikethickness: { valType: "number", min: 0, dflt: 2 }, spikecolor: { valType: "color", dflt: n2.defaultLine }, showbackground: { valType: "boolean", dflt: false }, backgroundcolor: { valType: "color", dflt: "rgba(204, 204, 204, 0.5)" }, showaxeslabels: { valType: "boolean", dflt: true }, color: i.color, categoryorder: i.categoryorder, categoryarray: i.categoryarray, title: { text: i.title.text, font: i.title.font }, type: a({}, i.type, { values: ["-", "linear", "log", "date", "category"] }), autotypenumbers: i.autotypenumbers, autorange: i.autorange, rangemode: i.rangemode, range: a({}, i.range, { items: [{ valType: "any", editType: "plot", impliedEdits: { "^autorange": false } }, { valType: "any", editType: "plot", impliedEdits: { "^autorange": false } }], anim: false }), tickmode: i.minor.tickmode, nticks: i.nticks, tick0: i.tick0, dtick: i.dtick, tickvals: i.tickvals, ticktext: i.ticktext, ticks: i.ticks, mirror: i.mirror, ticklen: i.ticklen, tickwidth: i.tickwidth, tickcolor: i.tickcolor, showticklabels: i.showticklabels, labelalias: i.labelalias, tickfont: i.tickfont, tickangle: i.tickangle, tickprefix: i.tickprefix, showtickprefix: i.showtickprefix, ticksuffix: i.ticksuffix, showticksuffix: i.showticksuffix, showexponent: i.showexponent, exponentformat: i.exponentformat, minexponent: i.minexponent, separatethousands: i.separatethousands, tickformat: i.tickformat, tickformatstops: i.tickformatstops, hoverformat: i.hoverformat, showline: i.showline, linecolor: i.linecolor, linewidth: i.linewidth, showgrid: i.showgrid, gridcolor: a({}, i.gridcolor, { dflt: "rgb(204, 204, 204)" }), gridwidth: i.gridwidth, zeroline: i.zeroline, zerolinecolor: i.zerolinecolor, zerolinewidth: i.zerolinewidth, _deprecated: { title: i._deprecated.title, titlefont: i._deprecated.titlefont } }, "plot", "from-root");
      }, 3277: function(t2, e2, r2) {
        var n2 = r2(84267).mix, i = r2(71828), a = r2(44467), o = r2(77894), s = r2(951), l = r2(71453), u = ["xaxis", "yaxis", "zaxis"];
        t2.exports = function(t3, e3, r3) {
          var c, f2;
          function h(t4, e4) {
            return i.coerce(c, f2, o, t4, e4);
          }
          for (var p2 = 0; p2 < u.length; p2++) {
            var d2 = u[p2];
            c = t3[d2] || {}, (f2 = a.newContainer(e3, d2))._id = d2[0] + r3.scene, f2._name = d2, s(c, f2, h, r3), l(c, f2, h, { font: r3.font, letter: d2[0], data: r3.data, showGrid: true, noTickson: true, noTicklabelmode: true, noTicklabelstep: true, noTicklabelposition: true, noTicklabeloverflow: true, bgColor: r3.bgColor, calendar: r3.calendar }, r3.fullLayout), h("gridcolor", n2(f2.color, r3.bgColor, 72.72727272727273).toRgbString()), h("title.text", d2[0]), f2.setScale = i.noop, h("showspikes") && (h("spikesides"), h("spikethickness"), h("spikecolor", f2.color)), h("showaxeslabels"), h("showbackground") && h("backgroundcolor");
          }
        };
      }, 30422: function(t2, e2, r2) {
        var n2 = r2(78614), i = r2(71828), a = ["xaxis", "yaxis", "zaxis"];
        function o() {
          this.bounds = [[-10, -10, -10], [10, 10, 10]], this.ticks = [[], [], []], this.tickEnable = [true, true, true], this.tickFont = ["sans-serif", "sans-serif", "sans-serif"], this.tickSize = [12, 12, 12], this.tickAngle = [0, 0, 0], this.tickColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.tickPad = [18, 18, 18], this.labels = ["x", "y", "z"], this.labelEnable = [true, true, true], this.labelFont = ["Open Sans", "Open Sans", "Open Sans"], this.labelSize = [20, 20, 20], this.labelColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.labelPad = [30, 30, 30], this.lineEnable = [true, true, true], this.lineMirror = [false, false, false], this.lineWidth = [1, 1, 1], this.lineColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.lineTickEnable = [true, true, true], this.lineTickMirror = [false, false, false], this.lineTickLength = [10, 10, 10], this.lineTickWidth = [1, 1, 1], this.lineTickColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.gridEnable = [true, true, true], this.gridWidth = [1, 1, 1], this.gridColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.zeroEnable = [true, true, true], this.zeroLineColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.zeroLineWidth = [2, 2, 2], this.backgroundEnable = [true, true, true], this.backgroundColor = [[0.8, 0.8, 0.8, 0.5], [0.8, 0.8, 0.8, 0.5], [0.8, 0.8, 0.8, 0.5]], this._defaultTickPad = this.tickPad.slice(), this._defaultLabelPad = this.labelPad.slice(), this._defaultLineTickLength = this.lineTickLength.slice();
        }
        o.prototype.merge = function(t3, e3) {
          for (var r3 = this, o2 = 0; o2 < 3; ++o2) {
            var s = e3[a[o2]];
            s.visible ? (r3.labels[o2] = t3._meta ? i.templateString(s.title.text, t3._meta) : s.title.text, "font" in s.title && (s.title.font.color && (r3.labelColor[o2] = n2(s.title.font.color)), s.title.font.family && (r3.labelFont[o2] = s.title.font.family), s.title.font.size && (r3.labelSize[o2] = s.title.font.size)), "showline" in s && (r3.lineEnable[o2] = s.showline), "linecolor" in s && (r3.lineColor[o2] = n2(s.linecolor)), "linewidth" in s && (r3.lineWidth[o2] = s.linewidth), "showgrid" in s && (r3.gridEnable[o2] = s.showgrid), "gridcolor" in s && (r3.gridColor[o2] = n2(s.gridcolor)), "gridwidth" in s && (r3.gridWidth[o2] = s.gridwidth), "log" === s.type ? r3.zeroEnable[o2] = false : "zeroline" in s && (r3.zeroEnable[o2] = s.zeroline), "zerolinecolor" in s && (r3.zeroLineColor[o2] = n2(s.zerolinecolor)), "zerolinewidth" in s && (r3.zeroLineWidth[o2] = s.zerolinewidth), "ticks" in s && s.ticks ? r3.lineTickEnable[o2] = true : r3.lineTickEnable[o2] = false, "ticklen" in s && (r3.lineTickLength[o2] = r3._defaultLineTickLength[o2] = s.ticklen), "tickcolor" in s && (r3.lineTickColor[o2] = n2(s.tickcolor)), "tickwidth" in s && (r3.lineTickWidth[o2] = s.tickwidth), "tickangle" in s && (r3.tickAngle[o2] = "auto" === s.tickangle ? -3600 : Math.PI * -s.tickangle / 180), "showticklabels" in s && (r3.tickEnable[o2] = s.showticklabels), "tickfont" in s && (s.tickfont.color && (r3.tickColor[o2] = n2(s.tickfont.color)), s.tickfont.family && (r3.tickFont[o2] = s.tickfont.family), s.tickfont.size && (r3.tickSize[o2] = s.tickfont.size)), "mirror" in s ? -1 !== ["ticks", "all", "allticks"].indexOf(s.mirror) ? (r3.lineTickMirror[o2] = true, r3.lineMirror[o2] = true) : true === s.mirror ? (r3.lineTickMirror[o2] = false, r3.lineMirror[o2] = true) : (r3.lineTickMirror[o2] = false, r3.lineMirror[o2] = false) : r3.lineMirror[o2] = false, "showbackground" in s && false !== s.showbackground ? (r3.backgroundEnable[o2] = true, r3.backgroundColor[o2] = n2(s.backgroundcolor)) : r3.backgroundEnable[o2] = false) : (r3.tickEnable[o2] = false, r3.labelEnable[o2] = false, r3.lineEnable[o2] = false, r3.lineTickEnable[o2] = false, r3.gridEnable[o2] = false, r3.zeroEnable[o2] = false, r3.backgroundEnable[o2] = false);
          }
        }, t2.exports = function(t3, e3) {
          var r3 = new o();
          return r3.merge(t3, e3), r3;
        };
      }, 24682: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901), a = r2(73972), o = r2(49119), s = r2(3277), l = r2(65500), u = r2(27659).NG, c = "gl3d";
        function f2(t3, e3, r3, n3) {
          for (var o2 = r3("bgcolor"), l2 = i.combine(o2, n3.paper_bgcolor), f3 = ["up", "center", "eye"], h = 0; h < f3.length; h++)
            r3("camera." + f3[h] + ".x"), r3("camera." + f3[h] + ".y"), r3("camera." + f3[h] + ".z");
          r3("camera.projection.type");
          var p2 = !!r3("aspectratio.x") && !!r3("aspectratio.y") && !!r3("aspectratio.z"), d2 = r3("aspectmode", p2 ? "manual" : "auto");
          p2 || (t3.aspectratio = e3.aspectratio = { x: 1, y: 1, z: 1 }, "manual" === d2 && (e3.aspectmode = "auto"), t3.aspectmode = e3.aspectmode);
          var v = u(n3.fullData, c, n3.id);
          s(t3, e3, { font: n3.font, scene: n3.id, data: v, bgColor: l2, calendar: n3.calendar, autotypenumbersDflt: n3.autotypenumbersDflt, fullLayout: n3.fullLayout }), a.getComponentMethod("annotations3d", "handleDefaults")(t3, e3, n3);
          var g2 = n3.getDfltFromLayout("dragmode");
          if (false !== g2 && !g2)
            if (g2 = "orbit", t3.camera && t3.camera.up) {
              var y = t3.camera.up.x, m2 = t3.camera.up.y, x = t3.camera.up.z;
              0 !== x && (y && m2 && x ? x / Math.sqrt(y * y + m2 * m2 + x * x) > 0.999 && (g2 = "turntable") : g2 = "turntable");
            } else
              g2 = "turntable";
          r3("dragmode", g2), r3("hovermode", n3.getDfltFromLayout("hovermode"));
        }
        t2.exports = function(t3, e3, r3) {
          var i2 = e3._basePlotModules.length > 1;
          o(t3, e3, r3, { type: c, attributes: l, handleDefaults: f2, fullLayout: e3, font: e3.font, fullData: r3, getDfltFromLayout: function(e4) {
            if (!i2)
              return n2.validate(t3[e4], l[e4]) ? t3[e4] : void 0;
          }, autotypenumbersDflt: e3.autotypenumbers, paper_bgcolor: e3.paper_bgcolor, calendar: e3.calendar });
        };
      }, 65500: function(t2, e2, r2) {
        var n2 = r2(77894), i = r2(27670).Y, a = r2(1426).extendFlat, o = r2(71828).counterRegex;
        function s(t3, e3, r3) {
          return { x: { valType: "number", dflt: t3, editType: "camera" }, y: { valType: "number", dflt: e3, editType: "camera" }, z: { valType: "number", dflt: r3, editType: "camera" }, editType: "camera" };
        }
        t2.exports = { _arrayAttrRegexps: [o("scene", ".annotations", true)], bgcolor: { valType: "color", dflt: "rgba(0,0,0,0)", editType: "plot" }, camera: { up: a(s(0, 0, 1), {}), center: a(s(0, 0, 0), {}), eye: a(s(1.25, 1.25, 1.25), {}), projection: { type: { valType: "enumerated", values: ["perspective", "orthographic"], dflt: "perspective", editType: "calc" }, editType: "calc" }, editType: "camera" }, domain: i({ name: "scene", editType: "plot" }), aspectmode: { valType: "enumerated", values: ["auto", "cube", "data", "manual"], dflt: "auto", editType: "plot", impliedEdits: { "aspectratio.x": void 0, "aspectratio.y": void 0, "aspectratio.z": void 0 } }, aspectratio: { x: { valType: "number", min: 0, editType: "plot", impliedEdits: { "^aspectmode": "manual" } }, y: { valType: "number", min: 0, editType: "plot", impliedEdits: { "^aspectmode": "manual" } }, z: { valType: "number", min: 0, editType: "plot", impliedEdits: { "^aspectmode": "manual" } }, editType: "plot", impliedEdits: { aspectmode: "manual" } }, xaxis: n2, yaxis: n2, zaxis: n2, dragmode: { valType: "enumerated", values: ["orbit", "turntable", "zoom", "pan", false], editType: "plot" }, hovermode: { valType: "enumerated", values: ["closest", false], dflt: "closest", editType: "modebar" }, uirevision: { valType: "any", editType: "none" }, editType: "plot", _deprecated: { cameraposition: { valType: "info_array", editType: "camera" } } };
      }, 13133: function(t2, e2, r2) {
        var n2 = r2(78614), i = ["xaxis", "yaxis", "zaxis"];
        function a() {
          this.enabled = [true, true, true], this.colors = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.drawSides = [true, true, true], this.lineWidth = [1, 1, 1];
        }
        a.prototype.merge = function(t3) {
          for (var e3 = 0; e3 < 3; ++e3) {
            var r3 = t3[i[e3]];
            r3.visible ? (this.enabled[e3] = r3.showspikes, this.colors[e3] = n2(r3.spikecolor), this.drawSides[e3] = r3.spikesides, this.lineWidth[e3] = r3.spikethickness) : (this.enabled[e3] = false, this.drawSides[e3] = false);
          }
        }, t2.exports = function(t3) {
          var e3 = new a();
          return e3.merge(t3), e3;
        };
      }, 96085: function(t2, e2, r2) {
        t2.exports = function(t3) {
          for (var e3 = t3.axesOptions, r3 = t3.glplot.axesPixels, s = t3.fullSceneLayout, l = [[], [], []], u = 0; u < 3; ++u) {
            var c = s[a[u]];
            if (c._length = (r3[u].hi - r3[u].lo) * r3[u].pixelsPerDataUnit / t3.dataScale[u], Math.abs(c._length) === 1 / 0 || isNaN(c._length))
              l[u] = [];
            else {
              c._input_range = c.range.slice(), c.range[0] = r3[u].lo / t3.dataScale[u], c.range[1] = r3[u].hi / t3.dataScale[u], c._m = 1 / (t3.dataScale[u] * r3[u].pixelsPerDataUnit), c.range[0] === c.range[1] && (c.range[0] -= 1, c.range[1] += 1);
              var f2 = c.tickmode;
              if ("auto" === c.tickmode) {
                c.tickmode = "linear";
                var h = c.nticks || i.constrain(c._length / 40, 4, 9);
                n2.autoTicks(c, Math.abs(c.range[1] - c.range[0]) / h);
              }
              for (var p2 = n2.calcTicks(c, { msUTC: true }), d2 = 0; d2 < p2.length; ++d2)
                p2[d2].x = p2[d2].x * t3.dataScale[u], "date" === c.type && (p2[d2].text = p2[d2].text.replace(/\<br\>/g, " "));
              l[u] = p2, c.tickmode = f2;
            }
          }
          for (e3.ticks = l, u = 0; u < 3; ++u)
            for (o[u] = 0.5 * (t3.glplot.bounds[0][u] + t3.glplot.bounds[1][u]), d2 = 0; d2 < 2; ++d2)
              e3.bounds[d2][u] = t3.glplot.bounds[d2][u];
          t3.contourLevels = function(t4) {
            for (var e4 = new Array(3), r4 = 0; r4 < 3; ++r4) {
              for (var n3 = t4[r4], i2 = new Array(n3.length), a2 = 0; a2 < n3.length; ++a2)
                i2[a2] = n3[a2].x;
              e4[r4] = i2;
            }
            return e4;
          }(l);
        };
        var n2 = r2(89298), i = r2(71828), a = ["xaxis", "yaxis", "zaxis"], o = [0, 0, 0];
      }, 63538: function(t2) {
        function e2(t3, e3) {
          var r2, n2, i = [0, 0, 0, 0];
          for (r2 = 0; r2 < 4; ++r2)
            for (n2 = 0; n2 < 4; ++n2)
              i[n2] += t3[4 * r2 + n2] * e3[r2];
          return i;
        }
        t2.exports = function(t3, r2) {
          return e2(t3.projection, e2(t3.view, e2(t3.model, [r2[0], r2[1], r2[2], 1])));
        };
      }, 33539: function(t2, e2, r2) {
        var n2, i, a = r2(9330).gl_plot3d, o = a.createCamera, s = a.createScene, l = r2(40372), u = r2(38520), c = r2(73972), f2 = r2(71828), h = f2.preserveDrawingBuffer(), p2 = r2(89298), d2 = r2(30211), v = r2(78614), g2 = r2(58617), y = r2(63538), m2 = r2(30422), x = r2(13133), b = r2(96085);
        function _(t3, e3) {
          var r3 = document.createElement("div"), n3 = t3.container;
          this.graphDiv = t3.graphDiv;
          var i2 = document.createElementNS("http://www.w3.org/2000/svg", "svg");
          i2.style.position = "absolute", i2.style.top = i2.style.left = "0px", i2.style.width = i2.style.height = "100%", i2.style["z-index"] = 20, i2.style["pointer-events"] = "none", r3.appendChild(i2), this.svgContainer = i2, r3.id = t3.id, r3.style.position = "absolute", r3.style.top = r3.style.left = "0px", r3.style.width = r3.style.height = "100%", n3.appendChild(r3), this.fullLayout = e3, this.id = t3.id || "scene", this.fullSceneLayout = e3[this.id], this.plotArgs = [[], {}, {}], this.axesOptions = m2(e3, e3[this.id]), this.spikeOptions = x(e3[this.id]), this.container = r3, this.staticMode = !!t3.staticPlot, this.pixelRatio = this.pixelRatio || t3.plotGlPixelRatio || 2, this.dataScale = [1, 1, 1], this.contourLevels = [[], [], []], this.convertAnnotations = c.getComponentMethod("annotations3d", "convert"), this.drawAnnotations = c.getComponentMethod("annotations3d", "draw"), this.initializeGLPlot();
        }
        var w2 = _.prototype;
        w2.prepareOptions = function() {
          var t3 = this, e3 = { canvas: t3.canvas, gl: t3.gl, glOptions: { preserveDrawingBuffer: h, premultipliedAlpha: true, antialias: true }, container: t3.container, axes: t3.axesOptions, spikes: t3.spikeOptions, pickRadius: 10, snapToData: true, autoScale: true, autoBounds: false, cameraObject: t3.camera, pixelRatio: t3.pixelRatio };
          if (t3.staticMode) {
            if (!(i || (n2 = document.createElement("canvas"), i = l({ canvas: n2, preserveDrawingBuffer: true, premultipliedAlpha: true, antialias: true }))))
              throw new Error("error creating static canvas/context for image server");
            e3.gl = i, e3.canvas = n2;
          }
          return e3;
        };
        var T = true;
        w2.tryCreatePlot = function() {
          var t3 = this, e3 = t3.prepareOptions(), r3 = true;
          try {
            t3.glplot = s(e3);
          } catch (n3) {
            if (t3.staticMode || !T || h)
              r3 = false;
            else {
              f2.warn(["webgl setup failed possibly due to", "false preserveDrawingBuffer config.", "The mobile/tablet device may not be detected by is-mobile module.", "Enabling preserveDrawingBuffer in second attempt to create webgl scene..."].join(" "));
              try {
                h = e3.glOptions.preserveDrawingBuffer = true, t3.glplot = s(e3);
              } catch (t4) {
                h = e3.glOptions.preserveDrawingBuffer = false, r3 = false;
              }
            }
          }
          return T = false, r3;
        }, w2.initializeGLCamera = function() {
          var t3 = this, e3 = t3.fullSceneLayout.camera, r3 = "orthographic" === e3.projection.type;
          t3.camera = o(t3.container, { center: [e3.center.x, e3.center.y, e3.center.z], eye: [e3.eye.x, e3.eye.y, e3.eye.z], up: [e3.up.x, e3.up.y, e3.up.z], _ortho: r3, zoomMin: 0.01, zoomMax: 100, mode: "orbit" });
        }, w2.initializeGLPlot = function() {
          var t3 = this;
          if (t3.initializeGLCamera(), !t3.tryCreatePlot())
            return g2(t3);
          t3.traces = {}, t3.make4thDimension();
          var e3 = t3.graphDiv, r3 = e3.layout, n3 = function() {
            var e4 = {};
            return t3.isCameraChanged(r3) && (e4[t3.id + ".camera"] = t3.getCamera()), t3.isAspectChanged(r3) && (e4[t3.id + ".aspectratio"] = t3.glplot.getAspectratio(), "manual" !== r3[t3.id].aspectmode && (t3.fullSceneLayout.aspectmode = r3[t3.id].aspectmode = e4[t3.id + ".aspectmode"] = "manual")), e4;
          }, i2 = function(t4) {
            if (false !== t4.fullSceneLayout.dragmode) {
              var e4 = n3();
              t4.saveLayout(r3), t4.graphDiv.emit("plotly_relayout", e4);
            }
          };
          return t3.glplot.canvas && (t3.glplot.canvas.addEventListener("mouseup", function() {
            i2(t3);
          }), t3.glplot.canvas.addEventListener("wheel", function(r4) {
            if (e3._context._scrollZoom.gl3d) {
              if (t3.camera._ortho) {
                var n4 = r4.deltaX > r4.deltaY ? 1.1 : 1 / 1.1, a2 = t3.glplot.getAspectratio();
                t3.glplot.setAspectratio({ x: n4 * a2.x, y: n4 * a2.y, z: n4 * a2.z });
              }
              i2(t3);
            }
          }, !!u && { passive: false }), t3.glplot.canvas.addEventListener("mousemove", function() {
            if (false !== t3.fullSceneLayout.dragmode && 0 !== t3.camera.mouseListener.buttons) {
              var e4 = n3();
              t3.graphDiv.emit("plotly_relayouting", e4);
            }
          }), t3.staticMode || t3.glplot.canvas.addEventListener("webglcontextlost", function(r4) {
            e3 && e3.emit && e3.emit("plotly_webglcontextlost", { event: r4, layer: t3.id });
          }, false)), t3.glplot.oncontextloss = function() {
            t3.recoverContext();
          }, t3.glplot.onrender = function() {
            t3.render();
          }, true;
        }, w2.render = function() {
          var t3, e3 = this, r3 = e3.graphDiv, n3 = e3.svgContainer, i2 = e3.container.getBoundingClientRect();
          r3._fullLayout._calcInverseTransform(r3);
          var a2 = r3._fullLayout._invScaleX, o2 = r3._fullLayout._invScaleY, s2 = i2.width * a2, l2 = i2.height * o2;
          n3.setAttributeNS(null, "viewBox", "0 0 " + s2 + " " + l2), n3.setAttributeNS(null, "width", s2), n3.setAttributeNS(null, "height", l2), b(e3), e3.glplot.axes.update(e3.axesOptions);
          for (var u2 = Object.keys(e3.traces), c2 = null, h2 = e3.glplot.selection, v2 = 0; v2 < u2.length; ++v2)
            "skip" !== (t3 = e3.traces[u2[v2]]).data.hoverinfo && t3.handlePick(h2) && (c2 = t3), t3.setContourLevels && t3.setContourLevels();
          function g3(t4, r4, n4) {
            var i3 = e3.fullSceneLayout[t4 + "axis"];
            return "log" !== i3.type && (r4 = i3.d2l(r4)), p2.hoverLabelText(i3, r4, n4);
          }
          if (null !== c2) {
            var m3 = y(e3.glplot.cameraParams, h2.dataCoordinate);
            t3 = c2.data;
            var x2, _2 = r3._fullData[t3.index], w3 = h2.index, T2 = { xLabel: g3("x", h2.traceCoordinate[0], t3.xhoverformat), yLabel: g3("y", h2.traceCoordinate[1], t3.yhoverformat), zLabel: g3("z", h2.traceCoordinate[2], t3.zhoverformat) }, k2 = d2.castHoverinfo(_2, e3.fullLayout, w3), A2 = (k2 || "").split("+"), M = k2 && "all" === k2;
            _2.hovertemplate || M || (-1 === A2.indexOf("x") && (T2.xLabel = void 0), -1 === A2.indexOf("y") && (T2.yLabel = void 0), -1 === A2.indexOf("z") && (T2.zLabel = void 0), -1 === A2.indexOf("text") && (h2.textLabel = void 0), -1 === A2.indexOf("name") && (c2.name = void 0));
            var S = [];
            "cone" === t3.type || "streamtube" === t3.type ? (T2.uLabel = g3("x", h2.traceCoordinate[3], t3.uhoverformat), (M || -1 !== A2.indexOf("u")) && S.push("u: " + T2.uLabel), T2.vLabel = g3("y", h2.traceCoordinate[4], t3.vhoverformat), (M || -1 !== A2.indexOf("v")) && S.push("v: " + T2.vLabel), T2.wLabel = g3("z", h2.traceCoordinate[5], t3.whoverformat), (M || -1 !== A2.indexOf("w")) && S.push("w: " + T2.wLabel), T2.normLabel = h2.traceCoordinate[6].toPrecision(3), (M || -1 !== A2.indexOf("norm")) && S.push("norm: " + T2.normLabel), "streamtube" === t3.type && (T2.divergenceLabel = h2.traceCoordinate[7].toPrecision(3), (M || -1 !== A2.indexOf("divergence")) && S.push("divergence: " + T2.divergenceLabel)), h2.textLabel && S.push(h2.textLabel), x2 = S.join("<br>")) : "isosurface" === t3.type || "volume" === t3.type ? (T2.valueLabel = p2.hoverLabelText(e3._mockAxis, e3._mockAxis.d2l(h2.traceCoordinate[3]), t3.valuehoverformat), S.push("value: " + T2.valueLabel), h2.textLabel && S.push(h2.textLabel), x2 = S.join("<br>")) : x2 = h2.textLabel;
            var E = { x: h2.traceCoordinate[0], y: h2.traceCoordinate[1], z: h2.traceCoordinate[2], data: _2._input, fullData: _2, curveNumber: _2.index, pointNumber: w3 };
            d2.appendArrayPointValue(E, _2, w3), t3._module.eventData && (E = _2._module.eventData(E, h2, _2, {}, w3));
            var L = { points: [E] };
            if (e3.fullSceneLayout.hovermode) {
              var C = [];
              d2.loneHover({ trace: _2, x: (0.5 + 0.5 * m3[0] / m3[3]) * s2, y: (0.5 - 0.5 * m3[1] / m3[3]) * l2, xLabel: T2.xLabel, yLabel: T2.yLabel, zLabel: T2.zLabel, text: x2, name: c2.name, color: d2.castHoverOption(_2, w3, "bgcolor") || c2.color, borderColor: d2.castHoverOption(_2, w3, "bordercolor"), fontFamily: d2.castHoverOption(_2, w3, "font.family"), fontSize: d2.castHoverOption(_2, w3, "font.size"), fontColor: d2.castHoverOption(_2, w3, "font.color"), nameLength: d2.castHoverOption(_2, w3, "namelength"), textAlign: d2.castHoverOption(_2, w3, "align"), hovertemplate: f2.castOption(_2, w3, "hovertemplate"), hovertemplateLabels: f2.extendFlat({}, E, T2), eventData: [E] }, { container: n3, gd: r3, inOut_bbox: C }), E.bbox = C[0];
            }
            h2.buttons && h2.distance < 5 ? r3.emit("plotly_click", L) : r3.emit("plotly_hover", L), this.oldEventData = L;
          } else
            d2.loneUnhover(n3), this.oldEventData && r3.emit("plotly_unhover", this.oldEventData), this.oldEventData = void 0;
          e3.drawAnnotations(e3);
        }, w2.recoverContext = function() {
          var t3 = this;
          t3.glplot.dispose();
          var e3 = function() {
            t3.glplot.gl.isContextLost() ? requestAnimationFrame(e3) : t3.initializeGLPlot() ? t3.plot.apply(t3, t3.plotArgs) : f2.error("Catastrophic and unrecoverable WebGL error. Context lost.");
          };
          requestAnimationFrame(e3);
        };
        var k = ["xaxis", "yaxis", "zaxis"];
        function A(t3, e3, r3) {
          for (var n3 = t3.fullSceneLayout, i2 = 0; i2 < 3; i2++) {
            var a2 = k[i2], o2 = a2.charAt(0), s2 = n3[a2], l2 = e3[o2], u2 = e3[o2 + "calendar"], c2 = e3["_" + o2 + "length"];
            if (f2.isArrayOrTypedArray(l2))
              for (var h2, p3 = 0; p3 < (c2 || l2.length); p3++)
                if (f2.isArrayOrTypedArray(l2[p3]))
                  for (var d3 = 0; d3 < l2[p3].length; ++d3)
                    h2 = s2.d2l(l2[p3][d3], 0, u2), !isNaN(h2) && isFinite(h2) && (r3[0][i2] = Math.min(r3[0][i2], h2), r3[1][i2] = Math.max(r3[1][i2], h2));
                else
                  h2 = s2.d2l(l2[p3], 0, u2), !isNaN(h2) && isFinite(h2) && (r3[0][i2] = Math.min(r3[0][i2], h2), r3[1][i2] = Math.max(r3[1][i2], h2));
            else
              r3[0][i2] = Math.min(r3[0][i2], 0), r3[1][i2] = Math.max(r3[1][i2], c2 - 1);
          }
        }
        w2.plot = function(t3, e3, r3) {
          var n3 = this;
          if (n3.plotArgs = [t3, e3, r3], !n3.glplot.contextLost) {
            var i2, a2, o2, s2, l2, u2, c2 = e3[n3.id], f3 = r3[n3.id];
            n3.fullLayout = e3, n3.fullSceneLayout = c2, n3.axesOptions.merge(e3, c2), n3.spikeOptions.merge(c2), n3.setViewport(c2), n3.updateFx(c2.dragmode, c2.hovermode), n3.camera.enableWheel = n3.graphDiv._context._scrollZoom.gl3d, n3.glplot.setClearColor(v(c2.bgcolor)), n3.setConvert(l2), t3 ? Array.isArray(t3) || (t3 = [t3]) : t3 = [];
            var h2 = [[1 / 0, 1 / 0, 1 / 0], [-1 / 0, -1 / 0, -1 / 0]];
            for (o2 = 0; o2 < t3.length; ++o2)
              true === (i2 = t3[o2]).visible && 0 !== i2._length && A(this, i2, h2);
            !function(t4, e4) {
              for (var r4 = t4.fullSceneLayout, n4 = r4.annotations || [], i3 = 0; i3 < 3; i3++)
                for (var a3 = k[i3], o3 = a3.charAt(0), s3 = r4[a3], l3 = 0; l3 < n4.length; l3++) {
                  var u3 = n4[l3];
                  if (u3.visible) {
                    var c3 = s3.r2l(u3[o3]);
                    !isNaN(c3) && isFinite(c3) && (e4[0][i3] = Math.min(e4[0][i3], c3), e4[1][i3] = Math.max(e4[1][i3], c3));
                  }
                }
            }(this, h2);
            var p3 = [1, 1, 1];
            for (s2 = 0; s2 < 3; ++s2)
              h2[1][s2] === h2[0][s2] ? p3[s2] = 1 : p3[s2] = 1 / (h2[1][s2] - h2[0][s2]);
            for (n3.dataScale = p3, n3.convertAnnotations(this), o2 = 0; o2 < t3.length; ++o2)
              true === (i2 = t3[o2]).visible && 0 !== i2._length && ((a2 = n3.traces[i2.uid]) ? a2.data.type === i2.type ? a2.update(i2) : (a2.dispose(), a2 = i2._module.plot(this, i2), n3.traces[i2.uid] = a2) : (a2 = i2._module.plot(this, i2), n3.traces[i2.uid] = a2), a2.name = i2.name);
            var d3 = Object.keys(n3.traces);
            t:
              for (o2 = 0; o2 < d3.length; ++o2) {
                for (s2 = 0; s2 < t3.length; ++s2)
                  if (t3[s2].uid === d3[o2] && true === t3[s2].visible && 0 !== t3[s2]._length)
                    continue t;
                (a2 = n3.traces[d3[o2]]).dispose(), delete n3.traces[d3[o2]];
              }
            n3.glplot.objects.sort(function(t4, e4) {
              return t4._trace.data.index - e4._trace.data.index;
            });
            var g3, y2 = [[0, 0, 0], [0, 0, 0]], m3 = [], x2 = {};
            for (o2 = 0; o2 < 3; ++o2) {
              if ((u2 = (l2 = c2[k[o2]]).type) in x2 ? (x2[u2].acc *= p3[o2], x2[u2].count += 1) : x2[u2] = { acc: p3[o2], count: 1 }, l2.autorange) {
                y2[0][o2] = 1 / 0, y2[1][o2] = -1 / 0;
                var b2 = n3.glplot.objects, _2 = n3.fullSceneLayout.annotations || [], w3 = l2._name.charAt(0);
                for (s2 = 0; s2 < b2.length; s2++) {
                  var T2 = b2[s2], M = T2.bounds, S = T2._trace.data._pad || 0;
                  "ErrorBars" === T2.constructor.name && l2._lowerLogErrorBound ? y2[0][o2] = Math.min(y2[0][o2], l2._lowerLogErrorBound) : y2[0][o2] = Math.min(y2[0][o2], M[0][o2] / p3[o2] - S), y2[1][o2] = Math.max(y2[1][o2], M[1][o2] / p3[o2] + S);
                }
                for (s2 = 0; s2 < _2.length; s2++) {
                  var E = _2[s2];
                  if (E.visible) {
                    var L = l2.r2l(E[w3]);
                    y2[0][o2] = Math.min(y2[0][o2], L), y2[1][o2] = Math.max(y2[1][o2], L);
                  }
                }
                if ("rangemode" in l2 && "tozero" === l2.rangemode && (y2[0][o2] = Math.min(y2[0][o2], 0), y2[1][o2] = Math.max(y2[1][o2], 0)), y2[0][o2] > y2[1][o2])
                  y2[0][o2] = -1, y2[1][o2] = 1;
                else {
                  var C = y2[1][o2] - y2[0][o2];
                  y2[0][o2] -= C / 32, y2[1][o2] += C / 32;
                }
                if ("reversed" === l2.autorange) {
                  var P = y2[0][o2];
                  y2[0][o2] = y2[1][o2], y2[1][o2] = P;
                }
              } else {
                var O = l2.range;
                y2[0][o2] = l2.r2l(O[0]), y2[1][o2] = l2.r2l(O[1]);
              }
              y2[0][o2] === y2[1][o2] && (y2[0][o2] -= 1, y2[1][o2] += 1), m3[o2] = y2[1][o2] - y2[0][o2], n3.glplot.setBounds(o2, { min: y2[0][o2] * p3[o2], max: y2[1][o2] * p3[o2] });
            }
            var I = c2.aspectmode;
            if ("cube" === I)
              g3 = [1, 1, 1];
            else if ("manual" === I) {
              var D = c2.aspectratio;
              g3 = [D.x, D.y, D.z];
            } else {
              if ("auto" !== I && "data" !== I)
                throw new Error("scene.js aspectRatio was not one of the enumerated types");
              var z = [1, 1, 1];
              for (o2 = 0; o2 < 3; ++o2) {
                var R = x2[u2 = (l2 = c2[k[o2]]).type];
                z[o2] = Math.pow(R.acc, 1 / R.count) / p3[o2];
              }
              g3 = "data" === I || Math.max.apply(null, z) / Math.min.apply(null, z) <= 4 ? z : [1, 1, 1];
            }
            c2.aspectratio.x = f3.aspectratio.x = g3[0], c2.aspectratio.y = f3.aspectratio.y = g3[1], c2.aspectratio.z = f3.aspectratio.z = g3[2], n3.glplot.setAspectratio(c2.aspectratio), n3.viewInitial.aspectratio || (n3.viewInitial.aspectratio = { x: c2.aspectratio.x, y: c2.aspectratio.y, z: c2.aspectratio.z }), n3.viewInitial.aspectmode || (n3.viewInitial.aspectmode = c2.aspectmode);
            var F = c2.domain || null, B = e3._size || null;
            if (F && B) {
              var N = n3.container.style;
              N.position = "absolute", N.left = B.l + F.x[0] * B.w + "px", N.top = B.t + (1 - F.y[1]) * B.h + "px", N.width = B.w * (F.x[1] - F.x[0]) + "px", N.height = B.h * (F.y[1] - F.y[0]) + "px";
            }
            n3.glplot.redraw();
          }
        }, w2.destroy = function() {
          var t3 = this;
          t3.glplot && (t3.camera.mouseListener.enabled = false, t3.container.removeEventListener("wheel", t3.camera.wheelListener), t3.camera = null, t3.glplot.dispose(), t3.container.parentNode.removeChild(t3.container), t3.glplot = null);
        }, w2.getCamera = function() {
          var t3, e3 = this;
          return e3.camera.view.recalcMatrix(e3.camera.view.lastT()), { up: { x: (t3 = e3.camera).up[0], y: t3.up[1], z: t3.up[2] }, center: { x: t3.center[0], y: t3.center[1], z: t3.center[2] }, eye: { x: t3.eye[0], y: t3.eye[1], z: t3.eye[2] }, projection: { type: true === t3._ortho ? "orthographic" : "perspective" } };
        }, w2.setViewport = function(t3) {
          var e3, r3 = this, n3 = t3.camera;
          r3.camera.lookAt.apply(this, [[(e3 = n3).eye.x, e3.eye.y, e3.eye.z], [e3.center.x, e3.center.y, e3.center.z], [e3.up.x, e3.up.y, e3.up.z]]), r3.glplot.setAspectratio(t3.aspectratio), "orthographic" === n3.projection.type !== r3.camera._ortho && (r3.glplot.redraw(), r3.glplot.clearRGBA(), r3.glplot.dispose(), r3.initializeGLPlot());
        }, w2.isCameraChanged = function(t3) {
          var e3 = this.getCamera(), r3 = f2.nestedProperty(t3, this.id + ".camera").get();
          function n3(t4, e4, r4, n4) {
            var i3 = ["up", "center", "eye"], a3 = ["x", "y", "z"];
            return e4[i3[r4]] && t4[i3[r4]][a3[n4]] === e4[i3[r4]][a3[n4]];
          }
          var i2 = false;
          if (void 0 === r3)
            i2 = true;
          else {
            for (var a2 = 0; a2 < 3; a2++)
              for (var o2 = 0; o2 < 3; o2++)
                if (!n3(e3, r3, a2, o2)) {
                  i2 = true;
                  break;
                }
            (!r3.projection || e3.projection && e3.projection.type !== r3.projection.type) && (i2 = true);
          }
          return i2;
        }, w2.isAspectChanged = function(t3) {
          var e3 = this.glplot.getAspectratio(), r3 = f2.nestedProperty(t3, this.id + ".aspectratio").get();
          return void 0 === r3 || r3.x !== e3.x || r3.y !== e3.y || r3.z !== e3.z;
        }, w2.saveLayout = function(t3) {
          var e3, r3, n3, i2, a2, o2, s2 = this, l2 = s2.fullLayout, u2 = s2.isCameraChanged(t3), h2 = s2.isAspectChanged(t3), p3 = u2 || h2;
          if (p3) {
            var d3 = {};
            u2 && (e3 = s2.getCamera(), n3 = (r3 = f2.nestedProperty(t3, s2.id + ".camera")).get(), d3[s2.id + ".camera"] = n3), h2 && (i2 = s2.glplot.getAspectratio(), o2 = (a2 = f2.nestedProperty(t3, s2.id + ".aspectratio")).get(), d3[s2.id + ".aspectratio"] = o2), c.call("_storeDirectGUIEdit", t3, l2._preGUI, d3), u2 && (r3.set(e3), f2.nestedProperty(l2, s2.id + ".camera").set(e3)), h2 && (a2.set(i2), f2.nestedProperty(l2, s2.id + ".aspectratio").set(i2), s2.glplot.redraw());
          }
          return p3;
        }, w2.updateFx = function(t3, e3) {
          var r3 = this, n3 = r3.camera;
          if (n3)
            if ("orbit" === t3)
              n3.mode = "orbit", n3.keyBindingMode = "rotate";
            else if ("turntable" === t3) {
              n3.up = [0, 0, 1], n3.mode = "turntable", n3.keyBindingMode = "rotate";
              var i2 = r3.graphDiv, a2 = i2._fullLayout, o2 = r3.fullSceneLayout.camera, s2 = o2.up.x, l2 = o2.up.y, u2 = o2.up.z;
              if (u2 / Math.sqrt(s2 * s2 + l2 * l2 + u2 * u2) < 0.999) {
                var h2 = r3.id + ".camera.up", p3 = { x: 0, y: 0, z: 1 }, d3 = {};
                d3[h2] = p3;
                var v2 = i2.layout;
                c.call("_storeDirectGUIEdit", v2, a2._preGUI, d3), o2.up = p3, f2.nestedProperty(v2, h2).set(p3);
              }
            } else
              n3.keyBindingMode = t3;
          r3.fullSceneLayout.hovermode = e3;
        }, w2.toImage = function(t3) {
          var e3 = this;
          t3 || (t3 = "png"), e3.staticMode && e3.container.appendChild(n2), e3.glplot.redraw();
          var r3 = e3.glplot.gl, i2 = r3.drawingBufferWidth, a2 = r3.drawingBufferHeight;
          r3.bindFramebuffer(r3.FRAMEBUFFER, null);
          var o2 = new Uint8Array(i2 * a2 * 4);
          r3.readPixels(0, 0, i2, a2, r3.RGBA, r3.UNSIGNED_BYTE, o2), function(t4, e4, r4) {
            for (var n3 = 0, i3 = r4 - 1; n3 < i3; ++n3, --i3)
              for (var a3 = 0; a3 < e4; ++a3)
                for (var o3 = 0; o3 < 4; ++o3) {
                  var s3 = 4 * (e4 * n3 + a3) + o3, l3 = 4 * (e4 * i3 + a3) + o3, u3 = t4[s3];
                  t4[s3] = t4[l3], t4[l3] = u3;
                }
          }(o2, i2, a2), function(t4, e4, r4) {
            for (var n3 = 0; n3 < r4; ++n3)
              for (var i3 = 0; i3 < e4; ++i3) {
                var a3 = 4 * (e4 * n3 + i3), o3 = t4[a3 + 3];
                if (o3 > 0)
                  for (var s3 = 255 / o3, l3 = 0; l3 < 3; ++l3)
                    t4[a3 + l3] = Math.min(s3 * t4[a3 + l3], 255);
              }
          }(o2, i2, a2);
          var s2 = document.createElement("canvas");
          s2.width = i2, s2.height = a2;
          var l2, u2 = s2.getContext("2d", { willReadFrequently: true }), c2 = u2.createImageData(i2, a2);
          switch (c2.data.set(o2), u2.putImageData(c2, 0, 0), t3) {
            case "jpeg":
              l2 = s2.toDataURL("image/jpeg");
              break;
            case "webp":
              l2 = s2.toDataURL("image/webp");
              break;
            default:
              l2 = s2.toDataURL("image/png");
          }
          return e3.staticMode && e3.container.removeChild(n2), l2;
        }, w2.setConvert = function() {
          for (var t3 = 0; t3 < 3; t3++) {
            var e3 = this.fullSceneLayout[k[t3]];
            p2.setConvert(e3, this.fullLayout), e3.setScale = f2.noop;
          }
        }, w2.make4thDimension = function() {
          var t3 = this, e3 = t3.graphDiv._fullLayout;
          t3._mockAxis = { type: "linear", showexponent: "all", exponentformat: "B" }, p2.setConvert(t3._mockAxis, e3);
        }, t2.exports = _;
      }, 90060: function(t2) {
        t2.exports = function(t3, e2, r2, n2) {
          n2 = n2 || t3.length;
          for (var i = new Array(n2), a = 0; a < n2; a++)
            i[a] = [t3[a], e2[a], r2[a]];
          return i;
        };
      }, 10820: function(t2, e2, r2) {
        var n2 = r2(41940), i = r2(85594), a = r2(22399), o = r2(29241), s = r2(53777), l = r2(35025), u = r2(1426).extendFlat, c = n2({ editType: "calc" });
        c.family.dflt = '"Open Sans", verdana, arial, sans-serif', c.size.dflt = 12, c.color.dflt = a.defaultLine, t2.exports = { font: c, title: { text: { valType: "string", editType: "layoutstyle" }, font: n2({ editType: "layoutstyle" }), xref: { valType: "enumerated", dflt: "container", values: ["container", "paper"], editType: "layoutstyle" }, yref: { valType: "enumerated", dflt: "container", values: ["container", "paper"], editType: "layoutstyle" }, x: { valType: "number", min: 0, max: 1, dflt: 0.5, editType: "layoutstyle" }, y: { valType: "number", min: 0, max: 1, dflt: "auto", editType: "layoutstyle" }, xanchor: { valType: "enumerated", dflt: "auto", values: ["auto", "left", "center", "right"], editType: "layoutstyle" }, yanchor: { valType: "enumerated", dflt: "auto", values: ["auto", "top", "middle", "bottom"], editType: "layoutstyle" }, pad: u(l({ editType: "layoutstyle" }), {}), automargin: { valType: "boolean", dflt: false, editType: "plot" }, editType: "layoutstyle" }, uniformtext: { mode: { valType: "enumerated", values: [false, "hide", "show"], dflt: false, editType: "plot" }, minsize: { valType: "number", min: 0, dflt: 0, editType: "plot" }, editType: "plot" }, autosize: { valType: "boolean", dflt: false, editType: "none" }, width: { valType: "number", min: 10, dflt: 700, editType: "plot" }, height: { valType: "number", min: 10, dflt: 450, editType: "plot" }, minreducedwidth: { valType: "number", min: 2, dflt: 64, editType: "plot" }, minreducedheight: { valType: "number", min: 2, dflt: 64, editType: "plot" }, margin: { l: { valType: "number", min: 0, dflt: 80, editType: "plot" }, r: { valType: "number", min: 0, dflt: 80, editType: "plot" }, t: { valType: "number", min: 0, dflt: 100, editType: "plot" }, b: { valType: "number", min: 0, dflt: 80, editType: "plot" }, pad: { valType: "number", min: 0, dflt: 0, editType: "plot" }, autoexpand: { valType: "boolean", dflt: true, editType: "plot" }, editType: "plot" }, computed: { valType: "any", editType: "none" }, paper_bgcolor: { valType: "color", dflt: a.background, editType: "plot" }, plot_bgcolor: { valType: "color", dflt: a.background, editType: "layoutstyle" }, autotypenumbers: { valType: "enumerated", values: ["convert types", "strict"], dflt: "convert types", editType: "calc" }, separators: { valType: "string", editType: "plot" }, hidesources: { valType: "boolean", dflt: false, editType: "plot" }, showlegend: { valType: "boolean", editType: "legend" }, colorway: { valType: "colorlist", dflt: a.defaults, editType: "calc" }, datarevision: { valType: "any", editType: "calc" }, uirevision: { valType: "any", editType: "none" }, editrevision: { valType: "any", editType: "none" }, selectionrevision: { valType: "any", editType: "none" }, template: { valType: "any", editType: "calc" }, newshape: o.newshape, activeshape: o.activeshape, newselection: s.newselection, activeselection: s.activeselection, meta: { valType: "any", arrayOk: true, editType: "plot" }, transition: u({}, i.transition, { editType: "none" }), _deprecated: { title: { valType: "string", editType: "layoutstyle" }, titlefont: n2({ editType: "layoutstyle" }) } };
      }, 77734: function(t2, e2, r2) {
        var n2 = r2(78607), i = '© <a target="_blank" href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors', a = ['© <a target="_blank" href="https://carto.com/">Carto</a>', i].join(" "), o = ['Map tiles by <a target="_blank" href="https://stamen.com">Stamen Design</a>', 'under <a target="_blank" href="https://creativecommons.org/licenses/by/3.0">CC BY 3.0</a>', "|", 'Data by <a target="_blank" href="https://openstreetmap.org">OpenStreetMap</a> contributors', 'under <a target="_blank" href="https://www.openstreetmap.org/copyright">ODbL</a>'].join(" "), s = { "open-street-map": { id: "osm", version: 8, sources: { "plotly-osm-tiles": { type: "raster", attribution: i, tiles: ["https://a.tile.openstreetmap.org/{z}/{x}/{y}.png", "https://b.tile.openstreetmap.org/{z}/{x}/{y}.png"], tileSize: 256 } }, layers: [{ id: "plotly-osm-tiles", type: "raster", source: "plotly-osm-tiles", minzoom: 0, maxzoom: 22 }] }, "white-bg": { id: "white-bg", version: 8, sources: {}, layers: [{ id: "white-bg", type: "background", paint: { "background-color": "#FFFFFF" }, minzoom: 0, maxzoom: 22 }] }, "carto-positron": { id: "carto-positron", version: 8, sources: { "plotly-carto-positron": { type: "raster", attribution: a, tiles: ["https://cartodb-basemaps-c.global.ssl.fastly.net/light_all/{z}/{x}/{y}.png"], tileSize: 256 } }, layers: [{ id: "plotly-carto-positron", type: "raster", source: "plotly-carto-positron", minzoom: 0, maxzoom: 22 }] }, "carto-darkmatter": { id: "carto-darkmatter", version: 8, sources: { "plotly-carto-darkmatter": { type: "raster", attribution: a, tiles: ["https://cartodb-basemaps-c.global.ssl.fastly.net/dark_all/{z}/{x}/{y}.png"], tileSize: 256 } }, layers: [{ id: "plotly-carto-darkmatter", type: "raster", source: "plotly-carto-darkmatter", minzoom: 0, maxzoom: 22 }] }, "stamen-terrain": { id: "stamen-terrain", version: 8, sources: { "plotly-stamen-terrain": { type: "raster", attribution: o, tiles: ["https://stamen-tiles.a.ssl.fastly.net/terrain/{z}/{x}/{y}.png"], tileSize: 256 } }, layers: [{ id: "plotly-stamen-terrain", type: "raster", source: "plotly-stamen-terrain", minzoom: 0, maxzoom: 22 }] }, "stamen-toner": { id: "stamen-toner", version: 8, sources: { "plotly-stamen-toner": { type: "raster", attribution: o, tiles: ["https://stamen-tiles.a.ssl.fastly.net/toner/{z}/{x}/{y}.png"], tileSize: 256 } }, layers: [{ id: "plotly-stamen-toner", type: "raster", source: "plotly-stamen-toner", minzoom: 0, maxzoom: 22 }] }, "stamen-watercolor": { id: "stamen-watercolor", version: 8, sources: { "plotly-stamen-watercolor": { type: "raster", attribution: ['Map tiles by <a target="_blank" href="https://stamen.com">Stamen Design</a>', 'under <a target="_blank" href="https://creativecommons.org/licenses/by/3.0">CC BY 3.0</a>', "|", 'Data by <a target="_blank" href="https://openstreetmap.org">OpenStreetMap</a> contributors', 'under <a target="_blank" href="https://creativecommons.org/licenses/by-sa/3.0">CC BY SA</a>'].join(" "), tiles: ["https://stamen-tiles.a.ssl.fastly.net/watercolor/{z}/{x}/{y}.png"], tileSize: 256 } }, layers: [{ id: "plotly-stamen-watercolor", type: "raster", source: "plotly-stamen-watercolor", minzoom: 0, maxzoom: 22 }] } }, l = n2(s);
        t2.exports = { requiredVersion: "1.10.1", styleUrlPrefix: "mapbox://styles/mapbox/", styleUrlSuffix: "v9", styleValuesMapbox: ["basic", "streets", "outdoors", "light", "dark", "satellite", "satellite-streets"], styleValueDflt: "basic", stylesNonMapbox: s, styleValuesNonMapbox: l, traceLayerPrefix: "plotly-trace-layer-", layoutLayerPrefix: "plotly-layout-layer-", wrongVersionErrorMsg: ["Your custom plotly.js bundle is not using the correct mapbox-gl version", "Please install mapbox-gl@1.10.1."].join("\n"), noAccessTokenErrorMsg: ["Missing Mapbox access token.", "Mapbox trace type require a Mapbox access token to be registered.", "For example:", "  Plotly.newPlot(gd, data, layout, { mapboxAccessToken: 'my-access-token' });", "More info here: https://www.mapbox.com/help/define-access-token/"].join("\n"), missingStyleErrorMsg: ["No valid mapbox style found, please set `mapbox.style` to one of:", l.join(", "), "or register a Mapbox access token to use a Mapbox-served style."].join("\n"), multipleTokensErrorMsg: ["Set multiple mapbox access token across different mapbox subplot,", "using first token found as mapbox-gl does not allow multipleaccess tokens on the same page."].join("\n"), mapOnErrorMsg: "Mapbox error.", mapboxLogo: { path0: "m 10.5,1.24 c -5.11,0 -9.25,4.15 -9.25,9.25 0,5.1 4.15,9.25 9.25,9.25 5.1,0 9.25,-4.15 9.25,-9.25 0,-5.11 -4.14,-9.25 -9.25,-9.25 z m 4.39,11.53 c -1.93,1.93 -4.78,2.31 -6.7,2.31 -0.7,0 -1.41,-0.05 -2.1,-0.16 0,0 -1.02,-5.64 2.14,-8.81 0.83,-0.83 1.95,-1.28 3.13,-1.28 1.27,0 2.49,0.51 3.39,1.42 1.84,1.84 1.89,4.75 0.14,6.52 z", path1: "M 10.5,-0.01 C 4.7,-0.01 0,4.7 0,10.49 c 0,5.79 4.7,10.5 10.5,10.5 5.8,0 10.5,-4.7 10.5,-10.5 C 20.99,4.7 16.3,-0.01 10.5,-0.01 Z m 0,19.75 c -5.11,0 -9.25,-4.15 -9.25,-9.25 0,-5.1 4.14,-9.26 9.25,-9.26 5.11,0 9.25,4.15 9.25,9.25 0,5.13 -4.14,9.26 -9.25,9.26 z", path2: "M 14.74,6.25 C 12.9,4.41 9.98,4.35 8.23,6.1 5.07,9.27 6.09,14.91 6.09,14.91 c 0,0 5.64,1.02 8.81,-2.14 C 16.64,11 16.59,8.09 14.74,6.25 Z m -2.27,4.09 -0.91,1.87 -0.9,-1.87 -1.86,-0.91 1.86,-0.9 0.9,-1.87 0.91,1.87 1.86,0.9 z", polygon: "11.56,12.21 10.66,10.34 8.8,9.43 10.66,8.53 11.56,6.66 12.47,8.53 14.33,9.43 12.47,10.34" }, styleRules: { map: "overflow:hidden;position:relative;", "missing-css": "display:none;", canary: "background-color:salmon;", "ctrl-bottom-left": "position: absolute; pointer-events: none; z-index: 2; bottom: 0; left: 0;", "ctrl-bottom-right": "position: absolute; pointer-events: none; z-index: 2; right: 0; bottom: 0;", ctrl: "clear: both; pointer-events: auto; transform: translate(0, 0);", "ctrl-attrib.mapboxgl-compact .mapboxgl-ctrl-attrib-inner": "display: none;", "ctrl-attrib.mapboxgl-compact:hover .mapboxgl-ctrl-attrib-inner": "display: block; margin-top:2px", "ctrl-attrib.mapboxgl-compact:hover": "padding: 2px 24px 2px 4px; visibility: visible; margin-top: 6px;", "ctrl-attrib.mapboxgl-compact::after": `content: ""; cursor: pointer; position: absolute; background-image: url('data:image/svg+xml;charset=utf-8,%3Csvg viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg"%3E %3Cpath fill="%23333333" fill-rule="evenodd" d="M4,10a6,6 0 1,0 12,0a6,6 0 1,0 -12,0 M9,7a1,1 0 1,0 2,0a1,1 0 1,0 -2,0 M9,10a1,1 0 1,1 2,0l0,3a1,1 0 1,1 -2,0"/%3E %3C/svg%3E'); background-color: rgba(255, 255, 255, 0.5); width: 24px; height: 24px; box-sizing: border-box; border-radius: 12px;`, "ctrl-attrib.mapboxgl-compact": "min-height: 20px; padding: 0; margin: 10px; position: relative; background-color: #fff; border-radius: 3px 12px 12px 3px;", "ctrl-bottom-right > .mapboxgl-ctrl-attrib.mapboxgl-compact::after": "bottom: 0; right: 0", "ctrl-bottom-left > .mapboxgl-ctrl-attrib.mapboxgl-compact::after": "bottom: 0; left: 0", "ctrl-bottom-left .mapboxgl-ctrl": "margin: 0 0 10px 10px; float: left;", "ctrl-bottom-right .mapboxgl-ctrl": "margin: 0 10px 10px 0; float: right;", "ctrl-attrib": "color: rgba(0, 0, 0, 0.75); text-decoration: none; font-size: 12px", "ctrl-attrib a": "color: rgba(0, 0, 0, 0.75); text-decoration: none; font-size: 12px", "ctrl-attrib a:hover": "color: inherit; text-decoration: underline;", "ctrl-attrib .mapbox-improve-map": "font-weight: bold; margin-left: 2px;", "attrib-empty": "display: none;", "ctrl-logo": `display:block; width: 21px; height: 21px; background-image: url('data:image/svg+xml;charset=utf-8,%3C?xml version="1.0" encoding="utf-8"?%3E %3Csvg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 21 21" style="enable-background:new 0 0 21 21;" xml:space="preserve"%3E%3Cg transform="translate(0,0.01)"%3E%3Cpath d="m 10.5,1.24 c -5.11,0 -9.25,4.15 -9.25,9.25 0,5.1 4.15,9.25 9.25,9.25 5.1,0 9.25,-4.15 9.25,-9.25 0,-5.11 -4.14,-9.25 -9.25,-9.25 z m 4.39,11.53 c -1.93,1.93 -4.78,2.31 -6.7,2.31 -0.7,0 -1.41,-0.05 -2.1,-0.16 0,0 -1.02,-5.64 2.14,-8.81 0.83,-0.83 1.95,-1.28 3.13,-1.28 1.27,0 2.49,0.51 3.39,1.42 1.84,1.84 1.89,4.75 0.14,6.52 z" style="opacity:0.9;fill:%23ffffff;enable-background:new" class="st0"/%3E%3Cpath d="M 10.5,-0.01 C 4.7,-0.01 0,4.7 0,10.49 c 0,5.79 4.7,10.5 10.5,10.5 5.8,0 10.5,-4.7 10.5,-10.5 C 20.99,4.7 16.3,-0.01 10.5,-0.01 Z m 0,19.75 c -5.11,0 -9.25,-4.15 -9.25,-9.25 0,-5.1 4.14,-9.26 9.25,-9.26 5.11,0 9.25,4.15 9.25,9.25 0,5.13 -4.14,9.26 -9.25,9.26 z" style="opacity:0.35;enable-background:new" class="st1"/%3E%3Cpath d="M 14.74,6.25 C 12.9,4.41 9.98,4.35 8.23,6.1 5.07,9.27 6.09,14.91 6.09,14.91 c 0,0 5.64,1.02 8.81,-2.14 C 16.64,11 16.59,8.09 14.74,6.25 Z m -2.27,4.09 -0.91,1.87 -0.9,-1.87 -1.86,-0.91 1.86,-0.9 0.9,-1.87 0.91,1.87 1.86,0.9 z" style="opacity:0.35;enable-background:new" class="st1"/%3E%3Cpolygon points="11.56,12.21 10.66,10.34 8.8,9.43 10.66,8.53 11.56,6.66 12.47,8.53 14.33,9.43 12.47,10.34 " style="opacity:0.9;fill:%23ffffff;enable-background:new" class="st0"/%3E%3C/g%3E%3C/svg%3E')` } };
      }, 13056: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = function(t3, e3) {
          var r3 = t3.split(" "), i = r3[0], a = r3[1], o = n2.isArrayOrTypedArray(e3) ? n2.mean(e3) : e3, s = 0.5 + o / 100, l = 1.5 + o / 100, u = ["", ""], c = [0, 0];
          switch (i) {
            case "top":
              u[0] = "top", c[1] = -l;
              break;
            case "bottom":
              u[0] = "bottom", c[1] = l;
          }
          switch (a) {
            case "left":
              u[1] = "right", c[0] = -s;
              break;
            case "right":
              u[1] = "left", c[0] = s;
          }
          return { anchor: u[0] && u[1] ? u.join("-") : u[0] ? u[0] : u[1] ? u[1] : "center", offset: c };
        };
      }, 50101: function(t2, e2, r2) {
        var n2 = r2(44517), i = r2(71828), a = i.strTranslate, o = i.strScale, s = r2(27659).AU, l = r2(77922), u = r2(39898), c = r2(91424), f2 = r2(63893), h = r2(10481), p2 = "mapbox", d2 = e2.constants = r2(77734);
        function v(t3) {
          return "string" == typeof t3 && (-1 !== d2.styleValuesMapbox.indexOf(t3) || 0 === t3.indexOf("mapbox://"));
        }
        e2.name = p2, e2.attr = "subplot", e2.idRoot = p2, e2.idRegex = e2.attrRegex = i.counterRegex(p2), e2.attributes = { subplot: { valType: "subplotid", dflt: "mapbox", editType: "calc" } }, e2.layoutAttributes = r2(23585), e2.supplyLayoutDefaults = r2(77882), e2.plot = function(t3) {
          var e3 = t3._fullLayout, r3 = t3.calcdata, a2 = e3._subplots.mapbox;
          if (n2.version !== d2.requiredVersion)
            throw new Error(d2.wrongVersionErrorMsg);
          var o2 = function(t4, e4) {
            var r4 = t4._fullLayout;
            if ("" === t4._context.mapboxAccessToken)
              return "";
            for (var n3 = [], a3 = [], o3 = false, s2 = false, l3 = 0; l3 < e4.length; l3++) {
              var u3 = r4[e4[l3]], c3 = u3.accesstoken;
              v(u3.style) && (c3 ? i.pushUnique(n3, c3) : (v(u3._input.style) && (i.error("Uses Mapbox map style, but did not set an access token."), o3 = true), s2 = true)), c3 && i.pushUnique(a3, c3);
            }
            if (s2) {
              var f4 = o3 ? d2.noAccessTokenErrorMsg : d2.missingStyleErrorMsg;
              throw i.error(f4), new Error(f4);
            }
            return n3.length ? (n3.length > 1 && i.warn(d2.multipleTokensErrorMsg), n3[0]) : (a3.length && i.log(["Listed mapbox access token(s)", a3.join(","), "but did not use a Mapbox map style, ignoring token(s)."].join(" ")), "");
          }(t3, a2);
          n2.accessToken = o2;
          for (var l2 = 0; l2 < a2.length; l2++) {
            var u2 = a2[l2], c2 = s(r3, p2, u2), f3 = e3[u2], g2 = f3._subplot;
            g2 || (g2 = new h(t3, u2), e3[u2]._subplot = g2), g2.viewInitial || (g2.viewInitial = { center: i.extendFlat({}, f3.center), zoom: f3.zoom, bearing: f3.bearing, pitch: f3.pitch }), g2.plot(c2, e3, t3._promises);
          }
        }, e2.clean = function(t3, e3, r3, n3) {
          for (var i2 = n3._subplots.mapbox || [], a2 = 0; a2 < i2.length; a2++) {
            var o2 = i2[a2];
            !e3[o2] && n3[o2]._subplot && n3[o2]._subplot.destroy();
          }
        }, e2.toSVG = function(t3) {
          for (var e3 = t3._fullLayout, r3 = e3._subplots.mapbox, n3 = e3._size, i2 = 0; i2 < r3.length; i2++) {
            var s2 = e3[r3[i2]], h2 = s2.domain, p3 = s2._subplot.toImage("png");
            e3._glimages.append("svg:image").attr({ xmlns: l.svg, "xlink:href": p3, x: n3.l + n3.w * h2.x[0], y: n3.t + n3.h * (1 - h2.y[1]), width: n3.w * (h2.x[1] - h2.x[0]), height: n3.h * (h2.y[1] - h2.y[0]), preserveAspectRatio: "none" });
            var v2 = u.select(s2._subplot.div);
            if (null !== v2.select(".mapboxgl-ctrl-logo").node().offsetParent) {
              var g2 = e3._glimages.append("g");
              g2.attr("transform", a(n3.l + n3.w * h2.x[0] + 10, n3.t + n3.h * (1 - h2.y[0]) - 31)), g2.append("path").attr("d", d2.mapboxLogo.path0).style({ opacity: 0.9, fill: "#ffffff", "enable-background": "new" }), g2.append("path").attr("d", d2.mapboxLogo.path1).style("opacity", 0.35).style("enable-background", "new"), g2.append("path").attr("d", d2.mapboxLogo.path2).style("opacity", 0.35).style("enable-background", "new"), g2.append("polygon").attr("points", d2.mapboxLogo.polygon).style({ opacity: 0.9, fill: "#ffffff", "enable-background": "new" });
            }
            var y = v2.select(".mapboxgl-ctrl-attrib").text().replace("Improve this map", ""), m2 = e3._glimages.append("g"), x = m2.append("text");
            x.text(y).classed("static-attribution", true).attr({ "font-size": 12, "font-family": "Arial", color: "rgba(0, 0, 0, 0.75)", "text-anchor": "end", "data-unformatted": y });
            var b = c.bBox(x.node()), _ = n3.w * (h2.x[1] - h2.x[0]);
            if (b.width > _ / 2) {
              var w2 = y.split("|").join("<br>");
              x.text(w2).attr("data-unformatted", w2).call(f2.convertToTspans, t3), b = c.bBox(x.node());
            }
            x.attr("transform", a(-3, 8 - b.height)), m2.insert("rect", ".static-attribution").attr({ x: -b.width - 6, y: -b.height - 3, width: b.width + 6, height: b.height + 3, fill: "rgba(255, 255, 255, 0.75)" });
            var T = 1;
            b.width + 6 > _ && (T = _ / (b.width + 6));
            var k = [n3.l + n3.w * h2.x[1], n3.t + n3.h * (1 - h2.y[0])];
            m2.attr("transform", a(k[0], k[1]) + o(T));
          }
        }, e2.updateFx = function(t3) {
          for (var e3 = t3._fullLayout, r3 = e3._subplots.mapbox, n3 = 0; n3 < r3.length; n3++)
            e3[r3[n3]]._subplot.updateFx(e3);
        };
      }, 67911: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(63893).sanitizeHTML, a = r2(13056), o = r2(77734);
        function s(t3, e3) {
          this.subplot = t3, this.uid = t3.uid + "-" + e3, this.index = e3, this.idSource = "source-" + this.uid, this.idLayer = o.layoutLayerPrefix + this.uid, this.sourceType = null, this.source = null, this.layerType = null, this.below = null, this.visible = false;
        }
        var l = s.prototype;
        function u(t3) {
          if (!t3.visible)
            return false;
          var e3 = t3.source;
          if (Array.isArray(e3) && e3.length > 0) {
            for (var r3 = 0; r3 < e3.length; r3++)
              if ("string" != typeof e3[r3] || 0 === e3[r3].length)
                return false;
            return true;
          }
          return n2.isPlainObject(e3) || "string" == typeof e3 && e3.length > 0;
        }
        function c(t3) {
          var e3 = {}, r3 = {};
          switch (t3.type) {
            case "circle":
              n2.extendFlat(r3, { "circle-radius": t3.circle.radius, "circle-color": t3.color, "circle-opacity": t3.opacity });
              break;
            case "line":
              n2.extendFlat(r3, { "line-width": t3.line.width, "line-color": t3.color, "line-opacity": t3.opacity, "line-dasharray": t3.line.dash });
              break;
            case "fill":
              n2.extendFlat(r3, { "fill-color": t3.color, "fill-outline-color": t3.fill.outlinecolor, "fill-opacity": t3.opacity });
              break;
            case "symbol":
              var i2 = t3.symbol, o2 = a(i2.textposition, i2.iconsize);
              n2.extendFlat(e3, { "icon-image": i2.icon + "-15", "icon-size": i2.iconsize / 10, "text-field": i2.text, "text-size": i2.textfont.size, "text-anchor": o2.anchor, "text-offset": o2.offset, "symbol-placement": i2.placement }), n2.extendFlat(r3, { "icon-color": t3.color, "text-color": i2.textfont.color, "text-opacity": t3.opacity });
              break;
            case "raster":
              n2.extendFlat(r3, { "raster-fade-duration": 0, "raster-opacity": t3.opacity });
          }
          return { layout: e3, paint: r3 };
        }
        l.update = function(t3) {
          this.visible ? this.needsNewImage(t3) ? this.updateImage(t3) : this.needsNewSource(t3) ? (this.removeLayer(), this.updateSource(t3), this.updateLayer(t3)) : this.needsNewLayer(t3) ? this.updateLayer(t3) : this.updateStyle(t3) : (this.updateSource(t3), this.updateLayer(t3)), this.visible = u(t3);
        }, l.needsNewImage = function(t3) {
          return this.subplot.map.getSource(this.idSource) && "image" === this.sourceType && "image" === t3.sourcetype && (this.source !== t3.source || JSON.stringify(this.coordinates) !== JSON.stringify(t3.coordinates));
        }, l.needsNewSource = function(t3) {
          return this.sourceType !== t3.sourcetype || JSON.stringify(this.source) !== JSON.stringify(t3.source) || this.layerType !== t3.type;
        }, l.needsNewLayer = function(t3) {
          return this.layerType !== t3.type || this.below !== this.subplot.belowLookup["layout-" + this.index];
        }, l.lookupBelow = function() {
          return this.subplot.belowLookup["layout-" + this.index];
        }, l.updateImage = function(t3) {
          this.subplot.map.getSource(this.idSource).updateImage({ url: t3.source, coordinates: t3.coordinates });
          var e3 = this.findFollowingMapboxLayerId(this.lookupBelow());
          null !== e3 && this.subplot.map.moveLayer(this.idLayer, e3);
        }, l.updateSource = function(t3) {
          var e3 = this.subplot.map;
          if (e3.getSource(this.idSource) && e3.removeSource(this.idSource), this.sourceType = t3.sourcetype, this.source = t3.source, u(t3)) {
            var r3 = function(t4) {
              var e4, r4 = t4.sourcetype, n3 = t4.source, a2 = { type: r4 };
              return "geojson" === r4 ? e4 = "data" : "vector" === r4 ? e4 = "string" == typeof n3 ? "url" : "tiles" : "raster" === r4 ? (e4 = "tiles", a2.tileSize = 256) : "image" === r4 && (e4 = "url", a2.coordinates = t4.coordinates), a2[e4] = n3, t4.sourceattribution && (a2.attribution = i(t4.sourceattribution)), a2;
            }(t3);
            e3.addSource(this.idSource, r3);
          }
        }, l.findFollowingMapboxLayerId = function(t3) {
          if ("traces" === t3)
            for (var e3 = this.subplot.getMapLayers(), r3 = 0; r3 < e3.length; r3++) {
              var n3 = e3[r3].id;
              if ("string" == typeof n3 && 0 === n3.indexOf(o.traceLayerPrefix)) {
                t3 = n3;
                break;
              }
            }
          return t3;
        }, l.updateLayer = function(t3) {
          var e3 = this.subplot, r3 = c(t3), n3 = this.lookupBelow(), i2 = this.findFollowingMapboxLayerId(n3);
          this.removeLayer(), u(t3) && e3.addLayer({ id: this.idLayer, source: this.idSource, "source-layer": t3.sourcelayer || "", type: t3.type, minzoom: t3.minzoom, maxzoom: t3.maxzoom, layout: r3.layout, paint: r3.paint }, i2), this.layerType = t3.type, this.below = n3;
        }, l.updateStyle = function(t3) {
          if (u(t3)) {
            var e3 = c(t3);
            this.subplot.setOptions(this.idLayer, "setLayoutProperty", e3.layout), this.subplot.setOptions(this.idLayer, "setPaintProperty", e3.paint);
          }
        }, l.removeLayer = function() {
          var t3 = this.subplot.map;
          t3.getLayer(this.idLayer) && t3.removeLayer(this.idLayer);
        }, l.dispose = function() {
          var t3 = this.subplot.map;
          t3.getLayer(this.idLayer) && t3.removeLayer(this.idLayer), t3.getSource(this.idSource) && t3.removeSource(this.idSource);
        }, t2.exports = function(t3, e3, r3) {
          var n3 = new s(t3, e3);
          return n3.update(r3), n3;
        };
      }, 23585: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901).defaultLine, a = r2(27670).Y, o = r2(41940), s = r2(82196).textposition, l = r2(30962).overrideAll, u = r2(44467).templatedArray, c = r2(77734), f2 = o({});
        f2.family.dflt = "Open Sans Regular, Arial Unicode MS Regular", (t2.exports = l({ _arrayAttrRegexps: [n2.counterRegex("mapbox", ".layers", true)], domain: a({ name: "mapbox" }), accesstoken: { valType: "string", noBlank: true, strict: true }, style: { valType: "any", values: c.styleValuesMapbox.concat(c.styleValuesNonMapbox), dflt: c.styleValueDflt }, center: { lon: { valType: "number", dflt: 0 }, lat: { valType: "number", dflt: 0 } }, zoom: { valType: "number", dflt: 1 }, bearing: { valType: "number", dflt: 0 }, pitch: { valType: "number", dflt: 0 }, bounds: { west: { valType: "number" }, east: { valType: "number" }, south: { valType: "number" }, north: { valType: "number" } }, layers: u("layer", { visible: { valType: "boolean", dflt: true }, sourcetype: { valType: "enumerated", values: ["geojson", "vector", "raster", "image"], dflt: "geojson" }, source: { valType: "any" }, sourcelayer: { valType: "string", dflt: "" }, sourceattribution: { valType: "string" }, type: { valType: "enumerated", values: ["circle", "line", "fill", "symbol", "raster"], dflt: "circle" }, coordinates: { valType: "any" }, below: { valType: "string" }, color: { valType: "color", dflt: i }, opacity: { valType: "number", min: 0, max: 1, dflt: 1 }, minzoom: { valType: "number", min: 0, max: 24, dflt: 0 }, maxzoom: { valType: "number", min: 0, max: 24, dflt: 24 }, circle: { radius: { valType: "number", dflt: 15 } }, line: { width: { valType: "number", dflt: 2 }, dash: { valType: "data_array" } }, fill: { outlinecolor: { valType: "color", dflt: i } }, symbol: { icon: { valType: "string", dflt: "marker" }, iconsize: { valType: "number", dflt: 10 }, text: { valType: "string", dflt: "" }, placement: { valType: "enumerated", values: ["point", "line", "line-center"], dflt: "point" }, textfont: f2, textposition: n2.extendFlat({}, s, { arrayOk: false }) } }) }, "plot", "from-root")).uirevision = { valType: "any", editType: "none" };
      }, 77882: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(49119), a = r2(85501), o = r2(23585);
        function s(t3, e3, r3, n3) {
          r3("accesstoken", n3.accessToken), r3("style"), r3("center.lon"), r3("center.lat"), r3("zoom"), r3("bearing"), r3("pitch");
          var i2 = r3("bounds.west"), o2 = r3("bounds.east"), s2 = r3("bounds.south"), u = r3("bounds.north");
          void 0 !== i2 && void 0 !== o2 && void 0 !== s2 && void 0 !== u || delete e3.bounds, a(t3, e3, { name: "layers", handleItemDefaults: l }), e3._input = t3;
        }
        function l(t3, e3) {
          function r3(r4, i3) {
            return n2.coerce(t3, e3, o.layers, r4, i3);
          }
          if (r3("visible")) {
            var i2, a2 = r3("sourcetype"), s2 = "raster" === a2 || "image" === a2;
            r3("source"), r3("sourceattribution"), "vector" === a2 && r3("sourcelayer"), "image" === a2 && r3("coordinates"), s2 && (i2 = "raster");
            var l2 = r3("type", i2);
            s2 && "raster" !== l2 && (l2 = e3.type = "raster", n2.log("Source types *raster* and *image* must drawn *raster* layer type.")), r3("below"), r3("color"), r3("opacity"), r3("minzoom"), r3("maxzoom"), "circle" === l2 && r3("circle.radius"), "line" === l2 && (r3("line.width"), r3("line.dash")), "fill" === l2 && r3("fill.outlinecolor"), "symbol" === l2 && (r3("symbol.icon"), r3("symbol.iconsize"), r3("symbol.text"), n2.coerceFont(r3, "symbol.textfont"), r3("symbol.textposition"), r3("symbol.placement"));
          }
        }
        t2.exports = function(t3, e3, r3) {
          i(t3, e3, r3, { type: "mapbox", attributes: o, handleDefaults: s, partition: "y", accessToken: e3._mapboxAccessToken });
        };
      }, 10481: function(t2, e2, r2) {
        var n2 = r2(44517), i = r2(71828), a = r2(41327), o = r2(73972), s = r2(89298), l = r2(28569), u = r2(30211), c = r2(64505), f2 = c.drawMode, h = c.selectMode, p2 = r2(47322).prepSelect, d2 = r2(47322).clearOutline, v = r2(47322).clearSelectionsCache, g2 = r2(47322).selectOnClick, y = r2(77734), m2 = r2(67911);
        function x(t3, e3) {
          this.id = e3, this.gd = t3;
          var r3 = t3._fullLayout, n3 = t3._context;
          this.container = r3._glcontainer.node(), this.isStatic = n3.staticPlot, this.uid = r3._uid + "-" + this.id, this.div = null, this.xaxis = null, this.yaxis = null, this.createFramework(r3), this.map = null, this.accessToken = null, this.styleObj = null, this.traceHash = {}, this.layerList = [], this.belowLookup = {}, this.dragging = false, this.wheeling = false;
        }
        var b = x.prototype;
        b.plot = function(t3, e3, r3) {
          var n3, i2 = this, a2 = e3[i2.id];
          i2.map && a2.accesstoken !== i2.accessToken && (i2.map.remove(), i2.map = null, i2.styleObj = null, i2.traceHash = {}, i2.layerList = []), n3 = i2.map ? new Promise(function(r4, n4) {
            i2.updateMap(t3, e3, r4, n4);
          }) : new Promise(function(r4, n4) {
            i2.createMap(t3, e3, r4, n4);
          }), r3.push(n3);
        }, b.createMap = function(t3, e3, r3, i2) {
          var o2 = this, s2 = e3[o2.id], l2 = o2.styleObj = w2(s2.style);
          o2.accessToken = s2.accesstoken;
          var u2 = s2.bounds, c2 = u2 ? [[u2.west, u2.south], [u2.east, u2.north]] : null, f3 = o2.map = new n2.Map({ container: o2.div, style: l2.style, center: k(s2.center), zoom: s2.zoom, bearing: s2.bearing, pitch: s2.pitch, maxBounds: c2, interactive: !o2.isStatic, preserveDrawingBuffer: o2.isStatic, doubleClickZoom: false, boxZoom: false, attributionControl: false }).addControl(new n2.AttributionControl({ compact: true }));
          f3._canvas.style.left = "0px", f3._canvas.style.top = "0px", o2.rejectOnError(i2), o2.isStatic || o2.initFx(t3, e3);
          var h2 = [];
          h2.push(new Promise(function(t4) {
            f3.once("load", t4);
          })), h2 = h2.concat(a.fetchTraceGeoData(t3)), Promise.all(h2).then(function() {
            o2.fillBelowLookup(t3, e3), o2.updateData(t3), o2.updateLayout(e3), o2.resolveOnRender(r3);
          }).catch(i2);
        }, b.updateMap = function(t3, e3, r3, n3) {
          var i2 = this, o2 = i2.map, s2 = e3[this.id];
          i2.rejectOnError(n3);
          var l2 = [], u2 = w2(s2.style);
          JSON.stringify(i2.styleObj) !== JSON.stringify(u2) && (i2.styleObj = u2, o2.setStyle(u2.style), i2.traceHash = {}, l2.push(new Promise(function(t4) {
            o2.once("styledata", t4);
          }))), l2 = l2.concat(a.fetchTraceGeoData(t3)), Promise.all(l2).then(function() {
            i2.fillBelowLookup(t3, e3), i2.updateData(t3), i2.updateLayout(e3), i2.resolveOnRender(r3);
          }).catch(n3);
        }, b.fillBelowLookup = function(t3, e3) {
          var r3, n3, i2 = e3[this.id].layers, a2 = this.belowLookup = {}, o2 = false;
          for (r3 = 0; r3 < t3.length; r3++) {
            var s2 = t3[r3][0].trace, l2 = s2._module;
            "string" == typeof s2.below ? n3 = s2.below : l2.getBelow && (n3 = l2.getBelow(s2, this)), "" === n3 && (o2 = true), a2["trace-" + s2.uid] = n3 || "";
          }
          for (r3 = 0; r3 < i2.length; r3++) {
            var u2 = i2[r3];
            n3 = "string" == typeof u2.below ? u2.below : o2 ? "traces" : "", a2["layout-" + r3] = n3;
          }
          var c2, f3, h2 = {};
          for (c2 in a2)
            h2[n3 = a2[c2]] ? h2[n3].push(c2) : h2[n3] = [c2];
          for (n3 in h2) {
            var p3 = h2[n3];
            if (p3.length > 1)
              for (r3 = 0; r3 < p3.length; r3++)
                0 === (c2 = p3[r3]).indexOf("trace-") ? (f3 = c2.split("trace-")[1], this.traceHash[f3] && (this.traceHash[f3].below = null)) : 0 === c2.indexOf("layout-") && (f3 = c2.split("layout-")[1], this.layerList[f3] && (this.layerList[f3].below = null));
          }
        };
        var _ = { choroplethmapbox: 0, densitymapbox: 1, scattermapbox: 2 };
        function w2(t3) {
          var e3 = {};
          return i.isPlainObject(t3) ? (e3.id = t3.id, e3.style = t3) : "string" == typeof t3 ? (e3.id = t3, -1 !== y.styleValuesMapbox.indexOf(t3) ? e3.style = T(t3) : y.stylesNonMapbox[t3] ? e3.style = y.stylesNonMapbox[t3] : e3.style = t3) : (e3.id = y.styleValueDflt, e3.style = T(y.styleValueDflt)), e3.transition = { duration: 0, delay: 0 }, e3;
        }
        function T(t3) {
          return y.styleUrlPrefix + t3 + "-" + y.styleUrlSuffix;
        }
        function k(t3) {
          return [t3.lon, t3.lat];
        }
        b.updateData = function(t3) {
          var e3, r3, n3, i2, a2 = this.traceHash, o2 = t3.slice().sort(function(t4, e4) {
            return _[t4[0].trace.type] - _[e4[0].trace.type];
          });
          for (n3 = 0; n3 < o2.length; n3++) {
            var s2 = o2[n3], l2 = false;
            (e3 = a2[(r3 = s2[0].trace).uid]) && (e3.type === r3.type ? (e3.update(s2), l2 = true) : e3.dispose()), !l2 && r3._module && (a2[r3.uid] = r3._module.plot(this, s2));
          }
          var u2 = Object.keys(a2);
          t:
            for (n3 = 0; n3 < u2.length; n3++) {
              var c2 = u2[n3];
              for (i2 = 0; i2 < t3.length; i2++)
                if (c2 === (r3 = t3[i2][0].trace).uid)
                  continue t;
              (e3 = a2[c2]).dispose(), delete a2[c2];
            }
        }, b.updateLayout = function(t3) {
          var e3 = this.map, r3 = t3[this.id];
          this.dragging || this.wheeling || (e3.setCenter(k(r3.center)), e3.setZoom(r3.zoom), e3.setBearing(r3.bearing), e3.setPitch(r3.pitch)), this.updateLayers(t3), this.updateFramework(t3), this.updateFx(t3), this.map.resize(), this.gd._context._scrollZoom.mapbox ? e3.scrollZoom.enable() : e3.scrollZoom.disable();
        }, b.resolveOnRender = function(t3) {
          var e3 = this.map;
          e3.on("render", function r3() {
            e3.loaded() && (e3.off("render", r3), setTimeout(t3, 10));
          });
        }, b.rejectOnError = function(t3) {
          var e3 = this.map;
          function r3() {
            t3(new Error(y.mapOnErrorMsg));
          }
          e3.once("error", r3), e3.once("style.error", r3), e3.once("source.error", r3), e3.once("tile.error", r3), e3.once("layer.error", r3);
        }, b.createFramework = function(t3) {
          var e3 = this, r3 = e3.div = document.createElement("div");
          r3.id = e3.uid, r3.style.position = "absolute", e3.container.appendChild(r3), e3.xaxis = { _id: "x", c2p: function(t4) {
            return e3.project(t4).x;
          } }, e3.yaxis = { _id: "y", c2p: function(t4) {
            return e3.project(t4).y;
          } }, e3.updateFramework(t3), e3.mockAxis = { type: "linear", showexponent: "all", exponentformat: "B" }, s.setConvert(e3.mockAxis, t3);
        }, b.initFx = function(t3, e3) {
          var r3 = this, n3 = r3.gd, i2 = r3.map;
          function a2() {
            u.loneUnhover(e3._hoverlayer);
          }
          function s2() {
            var t4 = r3.getView();
            n3.emit("plotly_relayouting", r3.getViewEditsWithDerived(t4));
          }
          i2.on("moveend", function(t4) {
            if (r3.map) {
              var e4 = n3._fullLayout;
              if (t4.originalEvent || r3.wheeling) {
                var i3 = e4[r3.id];
                o.call("_storeDirectGUIEdit", n3.layout, e4._preGUI, r3.getViewEdits(i3));
                var a3 = r3.getView();
                i3._input.center = i3.center = a3.center, i3._input.zoom = i3.zoom = a3.zoom, i3._input.bearing = i3.bearing = a3.bearing, i3._input.pitch = i3.pitch = a3.pitch, n3.emit("plotly_relayout", r3.getViewEditsWithDerived(a3));
              }
              t4.originalEvent && "mouseup" === t4.originalEvent.type ? r3.dragging = false : r3.wheeling && (r3.wheeling = false), e4._rehover && e4._rehover();
            }
          }), i2.on("wheel", function() {
            r3.wheeling = true;
          }), i2.on("mousemove", function(t4) {
            var e4 = r3.div.getBoundingClientRect(), a3 = [t4.originalEvent.offsetX, t4.originalEvent.offsetY];
            t4.target.getBoundingClientRect = function() {
              return e4;
            }, r3.xaxis.p2c = function() {
              return i2.unproject(a3).lng;
            }, r3.yaxis.p2c = function() {
              return i2.unproject(a3).lat;
            }, n3._fullLayout._rehover = function() {
              n3._fullLayout._hoversubplot === r3.id && n3._fullLayout[r3.id] && u.hover(n3, t4, r3.id);
            }, u.hover(n3, t4, r3.id), n3._fullLayout._hoversubplot = r3.id;
          }), i2.on("dragstart", function() {
            r3.dragging = true, a2();
          }), i2.on("zoomstart", a2), i2.on("mouseout", function() {
            n3._fullLayout._hoversubplot = null;
          }), i2.on("drag", s2), i2.on("zoom", s2), i2.on("dblclick", function() {
            var t4 = n3._fullLayout[r3.id];
            o.call("_storeDirectGUIEdit", n3.layout, n3._fullLayout._preGUI, r3.getViewEdits(t4));
            var e4 = r3.viewInitial;
            i2.setCenter(k(e4.center)), i2.setZoom(e4.zoom), i2.setBearing(e4.bearing), i2.setPitch(e4.pitch);
            var a3 = r3.getView();
            t4._input.center = t4.center = a3.center, t4._input.zoom = t4.zoom = a3.zoom, t4._input.bearing = t4.bearing = a3.bearing, t4._input.pitch = t4.pitch = a3.pitch, n3.emit("plotly_doubleclick", null), n3.emit("plotly_relayout", r3.getViewEditsWithDerived(a3));
          }), r3.clearOutline = function() {
            v(r3.dragOptions), d2(r3.dragOptions.gd);
          }, r3.onClickInPanFn = function(t4) {
            return function(e4) {
              var i3 = n3._fullLayout.clickmode;
              i3.indexOf("select") > -1 && g2(e4.originalEvent, n3, [r3.xaxis], [r3.yaxis], r3.id, t4), i3.indexOf("event") > -1 && u.click(n3, e4.originalEvent);
            };
          };
        }, b.updateFx = function(t3) {
          var e3 = this, r3 = e3.map, n3 = e3.gd;
          if (!e3.isStatic) {
            var a2, o2 = t3.dragmode;
            a2 = function(t4, r4) {
              r4.isRect ? (t4.range = {})[e3.id] = [u2([r4.xmin, r4.ymin]), u2([r4.xmax, r4.ymax])] : (t4.lassoPoints = {})[e3.id] = r4.map(u2);
            };
            var s2 = e3.dragOptions;
            e3.dragOptions = i.extendDeep(s2 || {}, { dragmode: t3.dragmode, element: e3.div, gd: n3, plotinfo: { id: e3.id, domain: t3[e3.id].domain, xaxis: e3.xaxis, yaxis: e3.yaxis, fillRangeItems: a2 }, xaxes: [e3.xaxis], yaxes: [e3.yaxis], subplot: e3.id }), r3.off("click", e3.onClickInPanHandler), h(o2) || f2(o2) ? (r3.dragPan.disable(), r3.on("zoomstart", e3.clearOutline), e3.dragOptions.prepFn = function(t4, r4, n4) {
              p2(t4, r4, n4, e3.dragOptions, o2);
            }, l.init(e3.dragOptions)) : (r3.dragPan.enable(), r3.off("zoomstart", e3.clearOutline), e3.div.onmousedown = null, e3.div.ontouchstart = null, e3.div.removeEventListener("touchstart", e3.div._ontouchstart), e3.onClickInPanHandler = e3.onClickInPanFn(e3.dragOptions), r3.on("click", e3.onClickInPanHandler));
          }
          function u2(t4) {
            var r4 = e3.map.unproject(t4);
            return [r4.lng, r4.lat];
          }
        }, b.updateFramework = function(t3) {
          var e3 = t3[this.id].domain, r3 = t3._size, n3 = this.div.style;
          n3.width = r3.w * (e3.x[1] - e3.x[0]) + "px", n3.height = r3.h * (e3.y[1] - e3.y[0]) + "px", n3.left = r3.l + e3.x[0] * r3.w + "px", n3.top = r3.t + (1 - e3.y[1]) * r3.h + "px", this.xaxis._offset = r3.l + e3.x[0] * r3.w, this.xaxis._length = r3.w * (e3.x[1] - e3.x[0]), this.yaxis._offset = r3.t + (1 - e3.y[1]) * r3.h, this.yaxis._length = r3.h * (e3.y[1] - e3.y[0]);
        }, b.updateLayers = function(t3) {
          var e3, r3 = t3[this.id].layers, n3 = this.layerList;
          if (r3.length !== n3.length) {
            for (e3 = 0; e3 < n3.length; e3++)
              n3[e3].dispose();
            for (n3 = this.layerList = [], e3 = 0; e3 < r3.length; e3++)
              n3.push(m2(this, e3, r3[e3]));
          } else
            for (e3 = 0; e3 < r3.length; e3++)
              n3[e3].update(r3[e3]);
        }, b.destroy = function() {
          this.map && (this.map.remove(), this.map = null, this.container.removeChild(this.div));
        }, b.toImage = function() {
          return this.map.stop(), this.map.getCanvas().toDataURL();
        }, b.setOptions = function(t3, e3, r3) {
          for (var n3 in r3)
            this.map[e3](t3, n3, r3[n3]);
        }, b.getMapLayers = function() {
          return this.map.getStyle().layers;
        }, b.addLayer = function(t3, e3) {
          var r3 = this.map;
          if ("string" == typeof e3) {
            if ("" === e3)
              return void r3.addLayer(t3, e3);
            for (var n3 = this.getMapLayers(), a2 = 0; a2 < n3.length; a2++)
              if (e3 === n3[a2].id)
                return void r3.addLayer(t3, e3);
            i.warn(["Trying to add layer with *below* value", e3, "referencing a layer that does not exist", "or that does not yet exist."].join(" "));
          }
          r3.addLayer(t3);
        }, b.project = function(t3) {
          return this.map.project(new n2.LngLat(t3[0], t3[1]));
        }, b.getView = function() {
          var t3 = this.map, e3 = t3.getCenter(), r3 = { lon: e3.lng, lat: e3.lat }, n3 = t3.getCanvas(), i2 = parseInt(n3.style.width), a2 = parseInt(n3.style.height);
          return { center: r3, zoom: t3.getZoom(), bearing: t3.getBearing(), pitch: t3.getPitch(), _derived: { coordinates: [t3.unproject([0, 0]).toArray(), t3.unproject([i2, 0]).toArray(), t3.unproject([i2, a2]).toArray(), t3.unproject([0, a2]).toArray()] } };
        }, b.getViewEdits = function(t3) {
          for (var e3 = this.id, r3 = ["center", "zoom", "bearing", "pitch"], n3 = {}, i2 = 0; i2 < r3.length; i2++) {
            var a2 = r3[i2];
            n3[e3 + "." + a2] = t3[a2];
          }
          return n3;
        }, b.getViewEditsWithDerived = function(t3) {
          var e3 = this.id, r3 = this.getViewEdits(t3);
          return r3[e3 + "._derived"] = t3._derived, r3;
        }, t2.exports = x;
      }, 35025: function(t2) {
        t2.exports = function(t3) {
          var e2 = t3.editType;
          return { t: { valType: "number", dflt: 0, editType: e2 }, r: { valType: "number", dflt: 0, editType: e2 }, b: { valType: "number", dflt: 0, editType: e2 }, l: { valType: "number", dflt: 0, editType: e2 }, editType: e2 };
        };
      }, 74875: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(84096).Dq, a = r2(60721).FF, o = r2(92770), s = r2(73972), l = r2(86281), u = r2(44467), c = r2(71828), f2 = r2(7901), h = r2(50606).BADNUM, p2 = r2(41675), d2 = r2(51873).clearOutline, v = r2(21479), g2 = r2(85594), y = r2(31391), m2 = r2(27659).a0, x = c.relinkPrivateKeys, b = c._, _ = t2.exports = {};
        c.extendFlat(_, s), _.attributes = r2(9012), _.attributes.type.values = _.allTypes, _.fontAttrs = r2(41940), _.layoutAttributes = r2(10820), _.fontWeight = "normal";
        var w2 = _.transformsRegistry, T = r2(31137);
        _.executeAPICommand = T.executeAPICommand, _.computeAPICommandBindings = T.computeAPICommandBindings, _.manageCommandObserver = T.manageCommandObserver, _.hasSimpleAPICommandBindings = T.hasSimpleAPICommandBindings, _.redrawText = function(t3) {
          return t3 = c.getGraphDiv(t3), new Promise(function(e3) {
            setTimeout(function() {
              t3._fullLayout && (s.getComponentMethod("annotations", "draw")(t3), s.getComponentMethod("legend", "draw")(t3), s.getComponentMethod("colorbar", "draw")(t3), e3(_.previousPromises(t3)));
            }, 300);
          });
        }, _.resize = function(t3) {
          var e3;
          t3 = c.getGraphDiv(t3);
          var r3 = new Promise(function(r4, n3) {
            t3 && !c.isHidden(t3) || n3(new Error("Resize must be passed a displayed plot div element.")), t3._redrawTimer && clearTimeout(t3._redrawTimer), t3._resolveResize && (e3 = t3._resolveResize), t3._resolveResize = r4, t3._redrawTimer = setTimeout(function() {
              if (!t3.layout || t3.layout.width && t3.layout.height || c.isHidden(t3))
                r4(t3);
              else {
                delete t3.layout.width, delete t3.layout.height;
                var e4 = t3.changed;
                t3.autoplay = true, s.call("relayout", t3, { autosize: true }).then(function() {
                  t3.changed = e4, t3._resolveResize === r4 && (delete t3._resolveResize, r4(t3));
                });
              }
            }, 100);
          });
          return e3 && e3(r3), r3;
        }, _.previousPromises = function(t3) {
          if ((t3._promises || []).length)
            return Promise.all(t3._promises).then(function() {
              t3._promises = [];
            });
        }, _.addLinks = function(t3) {
          if (t3._context.showLink || t3._context.showSources) {
            var e3 = t3._fullLayout, r3 = c.ensureSingle(e3._paper, "text", "js-plot-link-container", function(t4) {
              t4.style({ "font-family": '"Open Sans", Arial, sans-serif', "font-size": "12px", fill: f2.defaultLine, "pointer-events": "all" }).each(function() {
                var t5 = n2.select(this);
                t5.append("tspan").classed("js-link-to-tool", true), t5.append("tspan").classed("js-link-spacer", true), t5.append("tspan").classed("js-sourcelinks", true);
              });
            }), i2 = r3.node(), a2 = { y: e3._paper.attr("height") - 9 };
            document.body.contains(i2) && i2.getComputedTextLength() >= e3.width - 20 ? (a2["text-anchor"] = "start", a2.x = 5) : (a2["text-anchor"] = "end", a2.x = e3._paper.attr("width") - 7), r3.attr(a2);
            var o2 = r3.select(".js-link-to-tool"), s2 = r3.select(".js-link-spacer"), l2 = r3.select(".js-sourcelinks");
            t3._context.showSources && t3._context.showSources(t3), t3._context.showLink && function(t4, e4) {
              e4.text("");
              var r4 = e4.append("a").attr({ "xlink:xlink:href": "#", class: "link--impt link--embedview", "font-weight": "bold" }).text(t4._context.linkText + " " + String.fromCharCode(187));
              if (t4._context.sendData)
                r4.on("click", function() {
                  _.sendDataToCloud(t4);
                });
              else {
                var n3 = window.location.pathname.split("/"), i3 = window.location.search;
                r4.attr({ "xlink:xlink:show": "new", "xlink:xlink:href": "/" + n3[2].split(".")[0] + "/" + n3[1] + i3 });
              }
            }(t3, o2), s2.text(o2.text() && l2.text() ? " - " : "");
          }
        }, _.sendDataToCloud = function(t3) {
          var e3 = (window.PLOTLYENV || {}).BASE_URL || t3._context.plotlyServerURL;
          if (e3) {
            t3.emit("plotly_beforeexport");
            var r3 = n2.select(t3).append("div").attr("id", "hiddenform").style("display", "none"), i2 = r3.append("form").attr({ action: e3 + "/external", method: "post", target: "_blank" });
            return i2.append("input").attr({ type: "text", name: "data" }).node().value = _.graphJson(t3, false, "keepdata"), i2.node().submit(), r3.remove(), t3.emit("plotly_afterexport"), false;
          }
        };
        var k = ["days", "shortDays", "months", "shortMonths", "periods", "dateTime", "date", "time", "decimal", "thousands", "grouping", "currency"], A = ["year", "month", "dayMonth", "dayMonthYear"];
        function M(t3, e3) {
          var r3 = t3._context.locale;
          r3 || (r3 = "en-US");
          var n3 = false, i2 = {};
          function a2(t4) {
            for (var r4 = true, a3 = 0; a3 < e3.length; a3++) {
              var o3 = e3[a3];
              i2[o3] || (t4[o3] ? i2[o3] = t4[o3] : r4 = false);
            }
            r4 && (n3 = true);
          }
          for (var o2 = 0; o2 < 2; o2++) {
            for (var l2 = t3._context.locales, u2 = 0; u2 < 2; u2++) {
              var c2 = (l2[r3] || {}).format;
              if (c2 && (a2(c2), n3))
                break;
              l2 = s.localeRegistry;
            }
            var f3 = r3.split("-")[0];
            if (n3 || f3 === r3)
              break;
            r3 = f3;
          }
          return n3 || a2(s.localeRegistry.en.format), i2;
        }
        function S(t3, e3) {
          var r3 = { _fullLayout: e3 }, n3 = "x" === t3._id.charAt(0), i2 = t3._mainAxis._anchorAxis, a2 = "", o2 = "", s2 = "";
          if (i2 && (s2 = i2._mainAxis._id, a2 = n3 ? t3._id + s2 : s2 + t3._id), !a2 || !e3._plots[a2]) {
            a2 = "";
            for (var l2 = t3._counterAxes, u2 = 0; u2 < l2.length; u2++) {
              var c2 = l2[u2], f3 = n3 ? t3._id + c2 : c2 + t3._id;
              o2 || (o2 = f3);
              var h2 = p2.getFromId(r3, c2);
              if (s2 && h2.overlaying === s2) {
                a2 = f3;
                break;
              }
            }
          }
          return a2 || o2;
        }
        function E(t3) {
          var e3 = t3.transforms;
          if (Array.isArray(e3) && e3.length)
            for (var r3 = 0; r3 < e3.length; r3++) {
              var n3 = e3[r3], i2 = n3._module || w2[n3.type];
              if (i2 && i2.makesData)
                return true;
            }
          return false;
        }
        function L(t3, e3, r3, n3) {
          for (var i2 = t3.transforms, a2 = [t3], o2 = 0; o2 < i2.length; o2++) {
            var s2 = i2[o2], l2 = w2[s2.type];
            l2 && l2.transform && (a2 = l2.transform(a2, { transform: s2, fullTrace: t3, fullData: e3, layout: r3, fullLayout: n3, transformIndex: o2 }));
          }
          return a2;
        }
        function C(t3) {
          return "string" == typeof t3 && "px" === t3.substr(t3.length - 2) && parseFloat(t3);
        }
        function P(t3) {
          var e3 = t3.margin;
          if (!t3._size) {
            var r3 = t3._size = { l: Math.round(e3.l), r: Math.round(e3.r), t: Math.round(e3.t), b: Math.round(e3.b), p: Math.round(e3.pad) };
            r3.w = Math.round(t3.width) - r3.l - r3.r, r3.h = Math.round(t3.height) - r3.t - r3.b;
          }
          t3._pushmargin || (t3._pushmargin = {}), t3._pushmarginIds || (t3._pushmarginIds = {}), t3._reservedMargin || (t3._reservedMargin = {});
        }
        _.supplyDefaults = function(t3, e3) {
          var r3 = e3 && e3.skipUpdateCalc, n3 = t3._fullLayout || {};
          if (n3._skipDefaults)
            delete n3._skipDefaults;
          else {
            var o2, l2 = t3._fullLayout = {}, u2 = t3.layout || {}, f3 = t3._fullData || [], h2 = t3._fullData = [], p3 = t3.data || [], v2 = t3.calcdata || [], g3 = t3._context || {};
            t3._transitionData || _.createTransitionData(t3), l2._dfltTitle = { plot: b(t3, "Click to enter Plot title"), x: b(t3, "Click to enter X axis title"), y: b(t3, "Click to enter Y axis title"), colorbar: b(t3, "Click to enter Colorscale title"), annotation: b(t3, "new text") }, l2._traceWord = b(t3, "trace");
            var y2 = M(t3, k);
            if (l2._mapboxAccessToken = g3.mapboxAccessToken, n3._initialAutoSizeIsDone) {
              var m3 = n3.width, w3 = n3.height;
              _.supplyLayoutGlobalDefaults(u2, l2, y2), u2.width || (l2.width = m3), u2.height || (l2.height = w3), _.sanitizeMargins(l2);
            } else {
              _.supplyLayoutGlobalDefaults(u2, l2, y2);
              var T2 = !u2.width || !u2.height, S2 = l2.autosize, E2 = g3.autosizable;
              T2 && (S2 || E2) ? _.plotAutoSize(t3, u2, l2) : T2 && _.sanitizeMargins(l2), !S2 && T2 && (u2.width = l2.width, u2.height = l2.height);
            }
            l2._d3locale = function(t4, e4) {
              return t4.decimal = e4.charAt(0), t4.thousands = e4.charAt(1), { numberFormat: function(e5) {
                try {
                  e5 = a(t4).format(c.adjustFormat(e5));
                } catch (t5) {
                  return c.warnBadFormat(e5), c.noFormat;
                }
                return e5;
              }, timeFormat: i(t4).utcFormat };
            }(y2, l2.separators), l2._extraFormat = M(t3, A), l2._initialAutoSizeIsDone = true, l2._dataLength = p3.length, l2._modules = [], l2._visibleModules = [], l2._basePlotModules = [];
            var L2 = l2._subplots = function() {
              var t4, e4, r4 = s.collectableSubplotTypes, n4 = {};
              if (!r4) {
                r4 = [];
                var i2 = s.subplotsRegistry;
                for (var a2 in i2) {
                  var o3 = i2[a2].attr;
                  if (o3 && (r4.push(a2), Array.isArray(o3)))
                    for (e4 = 0; e4 < o3.length; e4++)
                      c.pushUnique(r4, o3[e4]);
                }
              }
              for (t4 = 0; t4 < r4.length; t4++)
                n4[r4[t4]] = [];
              return n4;
            }(), C2 = l2._splomAxes = { x: {}, y: {} }, O2 = l2._splomSubplots = {};
            l2._splomGridDflt = {}, l2._scatterStackOpts = {}, l2._firstScatter = {}, l2._alignmentOpts = {}, l2._colorAxes = {}, l2._requestRangeslider = {}, l2._traceUids = function(t4, e4) {
              var r4, n4, i2 = e4.length, a2 = [];
              for (r4 = 0; r4 < t4.length; r4++) {
                var o3 = t4[r4]._fullInput;
                o3 !== n4 && a2.push(o3), n4 = o3;
              }
              var s2 = a2.length, l3 = new Array(i2), u3 = {};
              function f4(t5, e5) {
                l3[e5] = t5, u3[t5] = 1;
              }
              function h3(t5, e5) {
                if (t5 && "string" == typeof t5 && !u3[t5])
                  return f4(t5, e5), true;
              }
              for (r4 = 0; r4 < i2; r4++) {
                var p4 = e4[r4].uid;
                "number" == typeof p4 && (p4 = String(p4)), h3(p4, r4) || r4 < s2 && h3(a2[r4].uid, r4) || f4(c.randstr(u3), r4);
              }
              return l3;
            }(f3, p3), l2._globalTransforms = (t3._context || {}).globalTransforms, _.supplyDataDefaults(p3, h2, u2, l2);
            var I2 = Object.keys(C2.x), D2 = Object.keys(C2.y);
            if (I2.length > 1 && D2.length > 1) {
              for (s.getComponentMethod("grid", "sizeDefaults")(u2, l2), o2 = 0; o2 < I2.length; o2++)
                c.pushUnique(L2.xaxis, I2[o2]);
              for (o2 = 0; o2 < D2.length; o2++)
                c.pushUnique(L2.yaxis, D2[o2]);
              for (var z2 in O2)
                c.pushUnique(L2.cartesian, z2);
            }
            if (l2._has = _._hasPlotType.bind(l2), f3.length === h2.length)
              for (o2 = 0; o2 < h2.length; o2++)
                x(h2[o2], f3[o2]);
            _.supplyLayoutModuleDefaults(u2, l2, h2, t3._transitionData);
            var R2 = l2._visibleModules, F = [];
            for (o2 = 0; o2 < R2.length; o2++) {
              var B = R2[o2].crossTraceDefaults;
              B && c.pushUnique(F, B);
            }
            for (o2 = 0; o2 < F.length; o2++)
              F[o2](h2, l2);
            l2._hasOnlyLargeSploms = 1 === l2._basePlotModules.length && "splom" === l2._basePlotModules[0].name && I2.length > 15 && D2.length > 15 && 0 === l2.shapes.length && 0 === l2.images.length, _.linkSubplots(h2, l2, f3, n3), _.cleanPlot(h2, l2, f3, n3);
            var N = !(!n3._has || !n3._has("gl2d")), j = !(!l2._has || !l2._has("gl2d")), U = !(!n3._has || !n3._has("cartesian")) || N, V = !(!l2._has || !l2._has("cartesian")) || j;
            U && !V ? n3._bgLayer.remove() : V && !U && (l2._shouldCreateBgLayer = true), n3._zoomlayer && !t3._dragging && d2({ _fullLayout: n3 }), function(t4, e4) {
              var r4, n4 = [];
              e4.meta && (r4 = e4._meta = { meta: e4.meta, layout: { meta: e4.meta } });
              for (var i2 = 0; i2 < t4.length; i2++) {
                var a2 = t4[i2];
                a2.meta ? n4[a2.index] = a2._meta = { meta: a2.meta } : e4.meta && (a2._meta = { meta: e4.meta }), e4.meta && (a2._meta.layout = { meta: e4.meta });
              }
              n4.length && (r4 || (r4 = e4._meta = {}), r4.data = n4);
            }(h2, l2), x(l2, n3), s.getComponentMethod("colorscale", "crossTraceDefaults")(h2, l2), l2._preGUI || (l2._preGUI = {}), l2._tracePreGUI || (l2._tracePreGUI = {});
            var H, q2 = l2._tracePreGUI, G = {};
            for (H in q2)
              G[H] = "old";
            for (o2 = 0; o2 < h2.length; o2++)
              G[H = h2[o2]._fullInput.uid] || (q2[H] = {}), G[H] = "new";
            for (H in G)
              "old" === G[H] && delete q2[H];
            P(l2), s.getComponentMethod("rangeslider", "makeData")(l2), r3 || v2.length !== h2.length || _.supplyDefaultsUpdateCalc(v2, h2);
          }
        }, _.supplyDefaultsUpdateCalc = function(t3, e3) {
          for (var r3 = 0; r3 < e3.length; r3++) {
            var n3 = e3[r3], i2 = (t3[r3] || [])[0];
            if (i2 && i2.trace) {
              var a2 = i2.trace;
              if (a2._hasCalcTransform) {
                var o2, s2, l2, u2 = a2._arrayAttrs;
                for (o2 = 0; o2 < u2.length; o2++)
                  s2 = u2[o2], l2 = c.nestedProperty(a2, s2).get().slice(), c.nestedProperty(n3, s2).set(l2);
              }
              i2.trace = n3;
            }
          }
        }, _.createTransitionData = function(t3) {
          t3._transitionData || (t3._transitionData = {}), t3._transitionData._frames || (t3._transitionData._frames = []), t3._transitionData._frameHash || (t3._transitionData._frameHash = {}), t3._transitionData._counter || (t3._transitionData._counter = 0), t3._transitionData._interruptCallbacks || (t3._transitionData._interruptCallbacks = []);
        }, _._hasPlotType = function(t3) {
          var e3, r3 = this._basePlotModules || [];
          for (e3 = 0; e3 < r3.length; e3++)
            if (r3[e3].name === t3)
              return true;
          var n3 = this._modules || [];
          for (e3 = 0; e3 < n3.length; e3++) {
            var i2 = n3[e3].name;
            if (i2 === t3)
              return true;
            var a2 = s.modules[i2];
            if (a2 && a2.categories[t3])
              return true;
          }
          return false;
        }, _.cleanPlot = function(t3, e3, r3, n3) {
          var i2, a2, o2 = n3._basePlotModules || [];
          for (i2 = 0; i2 < o2.length; i2++) {
            var s2 = o2[i2];
            s2.clean && s2.clean(t3, e3, r3, n3);
          }
          var l2 = n3._has && n3._has("gl"), u2 = e3._has && e3._has("gl");
          l2 && !u2 && void 0 !== n3._glcontainer && (n3._glcontainer.selectAll(".gl-canvas").remove(), n3._glcontainer.selectAll(".no-webgl").remove(), n3._glcanvas = null);
          var c2 = !!n3._infolayer;
          t:
            for (i2 = 0; i2 < r3.length; i2++) {
              var f3 = r3[i2].uid;
              for (a2 = 0; a2 < t3.length; a2++)
                if (f3 === t3[a2].uid)
                  continue t;
              c2 && n3._infolayer.select(".cb" + f3).remove();
            }
        }, _.linkSubplots = function(t3, e3, r3, n3) {
          var i2, a2, o2 = n3._plots || {}, l2 = e3._plots = {}, u2 = e3._subplots, f3 = { _fullData: t3, _fullLayout: e3 }, h2 = u2.cartesian.concat(u2.gl2d || []);
          for (i2 = 0; i2 < h2.length; i2++) {
            var d3, v2 = h2[i2], g3 = o2[v2], y2 = p2.getFromId(f3, v2, "x"), m3 = p2.getFromId(f3, v2, "y");
            for (g3 ? d3 = l2[v2] = g3 : (d3 = l2[v2] = {}).id = v2, y2._counterAxes.push(m3._id), m3._counterAxes.push(y2._id), y2._subplotsWith.push(v2), m3._subplotsWith.push(v2), d3.xaxis = y2, d3.yaxis = m3, d3._hasClipOnAxisFalse = false, a2 = 0; a2 < t3.length; a2++) {
              var x2 = t3[a2];
              if (x2.xaxis === d3.xaxis._id && x2.yaxis === d3.yaxis._id && false === x2.cliponaxis) {
                d3._hasClipOnAxisFalse = true;
                break;
              }
            }
          }
          var b2, _2 = p2.list(f3, null, true);
          for (i2 = 0; i2 < _2.length; i2++) {
            var w3 = null;
            (b2 = _2[i2]).overlaying && (w3 = p2.getFromId(f3, b2.overlaying)) && w3.overlaying && (b2.overlaying = false, w3 = null), b2._mainAxis = w3 || b2, w3 && (b2.domain = w3.domain.slice()), b2._anchorAxis = "free" === b2.anchor ? null : p2.getFromId(f3, b2.anchor);
          }
          for (i2 = 0; i2 < _2.length; i2++)
            if ((b2 = _2[i2])._counterAxes.sort(p2.idSort), b2._subplotsWith.sort(c.subplotSort), b2._mainSubplot = S(b2, e3), b2._counterAxes.length && (b2.spikemode && -1 !== b2.spikemode.indexOf("across") || b2.automargin && b2.mirror && "free" !== b2.anchor || s.getComponentMethod("rangeslider", "isVisible")(b2))) {
              var T2 = 1, k2 = 0;
              for (a2 = 0; a2 < b2._counterAxes.length; a2++) {
                var A2 = p2.getFromId(f3, b2._counterAxes[a2]);
                T2 = Math.min(T2, A2.domain[0]), k2 = Math.max(k2, A2.domain[1]);
              }
              T2 < k2 && (b2._counterDomainMin = T2, b2._counterDomainMax = k2);
            }
        }, _.clearExpandedTraceDefaultColors = function(t3) {
          var e3, r3, n3;
          for (r3 = [], (e3 = t3._module._colorAttrs) || (t3._module._colorAttrs = e3 = [], l.crawl(t3._module.attributes, function(t4, n4, i2, a2) {
            r3[a2] = n4, r3.length = a2 + 1, "color" === t4.valType && void 0 === t4.dflt && e3.push(r3.join("."));
          })), n3 = 0; n3 < e3.length; n3++)
            c.nestedProperty(t3, "_input." + e3[n3]).get() || c.nestedProperty(t3, e3[n3]).set(null);
        }, _.supplyDataDefaults = function(t3, e3, r3, n3) {
          var i2, a2, o2, l2 = n3._modules, f3 = n3._visibleModules, h2 = n3._basePlotModules, p3 = 0, d3 = 0;
          function v2(t4) {
            e3.push(t4);
            var r4 = t4._module;
            r4 && (c.pushUnique(l2, r4), true === t4.visible && c.pushUnique(f3, r4), c.pushUnique(h2, t4._module.basePlotModule), p3++, false !== t4._input.visible && d3++);
          }
          n3._transformModules = [];
          var g3 = {}, y2 = [], m3 = (r3.template || {}).data || {}, b2 = u.traceTemplater(m3);
          for (i2 = 0; i2 < t3.length; i2++) {
            if (o2 = t3[i2], (a2 = b2.newTrace(o2)).uid = n3._traceUids[i2], _.supplyTraceDefaults(o2, a2, d3, n3, i2), a2.index = i2, a2._input = o2, a2._expandedIndex = p3, a2.transforms && a2.transforms.length)
              for (var w3 = false !== o2.visible && false === a2.visible, T2 = L(a2, e3, r3, n3), k2 = 0; k2 < T2.length; k2++) {
                var A2 = T2[k2], M2 = { _template: a2._template, type: a2.type, uid: a2.uid + k2 };
                w3 && false === A2.visible && delete A2.visible, _.supplyTraceDefaults(A2, M2, p3, n3, i2), x(M2, A2), M2.index = i2, M2._input = o2, M2._fullInput = a2, M2._expandedIndex = p3, M2._expandedInput = A2, v2(M2);
              }
            else
              a2._fullInput = a2, a2._expandedInput = a2, v2(a2);
            s.traceIs(a2, "carpetAxis") && (g3[a2.carpet] = a2), s.traceIs(a2, "carpetDependent") && y2.push(i2);
          }
          for (i2 = 0; i2 < y2.length; i2++)
            if ((a2 = e3[y2[i2]]).visible) {
              var S2 = g3[a2.carpet];
              a2._carpet = S2, S2 && S2.visible ? (a2.xaxis = S2.xaxis, a2.yaxis = S2.yaxis) : a2.visible = false;
            }
        }, _.supplyAnimationDefaults = function(t3) {
          var e3;
          t3 = t3 || {};
          var r3 = {};
          function n3(e4, n4) {
            return c.coerce(t3 || {}, r3, g2, e4, n4);
          }
          if (n3("mode"), n3("direction"), n3("fromcurrent"), Array.isArray(t3.frame))
            for (r3.frame = [], e3 = 0; e3 < t3.frame.length; e3++)
              r3.frame[e3] = _.supplyAnimationFrameDefaults(t3.frame[e3] || {});
          else
            r3.frame = _.supplyAnimationFrameDefaults(t3.frame || {});
          if (Array.isArray(t3.transition))
            for (r3.transition = [], e3 = 0; e3 < t3.transition.length; e3++)
              r3.transition[e3] = _.supplyAnimationTransitionDefaults(t3.transition[e3] || {});
          else
            r3.transition = _.supplyAnimationTransitionDefaults(t3.transition || {});
          return r3;
        }, _.supplyAnimationFrameDefaults = function(t3) {
          var e3 = {};
          function r3(r4, n3) {
            return c.coerce(t3 || {}, e3, g2.frame, r4, n3);
          }
          return r3("duration"), r3("redraw"), e3;
        }, _.supplyAnimationTransitionDefaults = function(t3) {
          var e3 = {};
          function r3(r4, n3) {
            return c.coerce(t3 || {}, e3, g2.transition, r4, n3);
          }
          return r3("duration"), r3("easing"), e3;
        }, _.supplyFrameDefaults = function(t3) {
          var e3 = {};
          function r3(r4, n3) {
            return c.coerce(t3, e3, y, r4, n3);
          }
          return r3("group"), r3("name"), r3("traces"), r3("baseframe"), r3("data"), r3("layout"), e3;
        }, _.supplyTraceDefaults = function(t3, e3, r3, n3, i2) {
          var a2, o2 = n3.colorway || f2.defaults, l2 = o2[r3 % o2.length];
          function u2(r4, n4) {
            return c.coerce(t3, e3, _.attributes, r4, n4);
          }
          var h2 = u2("visible");
          u2("type"), u2("name", n3._traceWord + " " + i2), u2("uirevision", n3.uirevision);
          var p3 = _.getModule(e3);
          if (e3._module = p3, p3) {
            var d3 = p3.basePlotModule, v2 = d3.attr, g3 = d3.attributes;
            if (v2 && g3) {
              var y2 = n3._subplots, m3 = "";
              if (h2 || "gl2d" !== d3.name) {
                if (Array.isArray(v2))
                  for (a2 = 0; a2 < v2.length; a2++) {
                    var x2 = v2[a2], b2 = c.coerce(t3, e3, g3, x2);
                    y2[x2] && c.pushUnique(y2[x2], b2), m3 += b2;
                  }
                else
                  m3 = c.coerce(t3, e3, g3, v2);
                y2[d3.name] && c.pushUnique(y2[d3.name], m3);
              }
            }
          }
          return h2 && (u2("customdata"), u2("ids"), u2("meta"), s.traceIs(e3, "showLegend") ? (c.coerce(t3, e3, p3.attributes.showlegend ? p3.attributes : _.attributes, "showlegend"), u2("legendwidth"), u2("legendgroup"), u2("legendgrouptitle.text"), u2("legendrank"), e3._dfltShowLegend = true) : e3._dfltShowLegend = false, p3 && p3.supplyDefaults(t3, e3, l2, n3), s.traceIs(e3, "noOpacity") || u2("opacity"), s.traceIs(e3, "notLegendIsolatable") && (e3.visible = !!e3.visible), s.traceIs(e3, "noHover") || (e3.hovertemplate || c.coerceHoverinfo(t3, e3, n3), "parcats" !== e3.type && s.getComponentMethod("fx", "supplyDefaults")(t3, e3, l2, n3)), p3 && p3.selectPoints && u2("selectedpoints"), _.supplyTransformDefaults(t3, e3, n3)), e3;
        }, _.hasMakesDataTransform = E, _.supplyTransformDefaults = function(t3, e3, r3) {
          if (e3._length || E(t3)) {
            var n3 = r3._globalTransforms || [], i2 = r3._transformModules || [];
            if (Array.isArray(t3.transforms) || 0 !== n3.length)
              for (var a2 = t3.transforms || [], o2 = n3.concat(a2), s2 = e3.transforms = [], l2 = 0; l2 < o2.length; l2++) {
                var u2, f3 = o2[l2], h2 = f3.type, p3 = w2[h2], d3 = !(f3._module && f3._module === p3), v2 = p3 && "function" == typeof p3.transform;
                p3 || c.warn("Unrecognized transform type " + h2 + "."), p3 && p3.supplyDefaults && (d3 || v2) ? ((u2 = p3.supplyDefaults(f3, e3, r3, t3)).type = h2, u2._module = p3, c.pushUnique(i2, p3)) : u2 = c.extendFlat({}, f3), s2.push(u2);
              }
          }
        }, _.supplyLayoutGlobalDefaults = function(t3, e3, r3) {
          function n3(r4, n4) {
            return c.coerce(t3, e3, _.layoutAttributes, r4, n4);
          }
          var i2 = t3.template;
          c.isPlainObject(i2) && (e3.template = i2, e3._template = i2.layout, e3._dataTemplate = i2.data), n3("autotypenumbers");
          var a2 = c.coerceFont(n3, "font"), o2 = a2.size;
          c.coerceFont(n3, "title.font", c.extendFlat({}, a2, { size: Math.round(1.4 * o2) })), n3("title.text", e3._dfltTitle.plot), n3("title.xref");
          var l2 = n3("title.yref");
          n3("title.pad.t"), n3("title.pad.r"), n3("title.pad.b"), n3("title.pad.l");
          var u2 = n3("title.automargin");
          n3("title.x"), n3("title.xanchor"), n3("title.y"), n3("title.yanchor"), u2 && ("paper" === l2 && (0 !== e3.title.y && (e3.title.y = 1), "auto" === e3.title.yanchor && (e3.title.yanchor = 0 === e3.title.y ? "top" : "bottom")), "container" === l2 && ("auto" === e3.title.y && (e3.title.y = 1), "auto" === e3.title.yanchor && (e3.title.yanchor = e3.title.y < 0.5 ? "bottom" : "top"))), n3("uniformtext.mode") && n3("uniformtext.minsize"), n3("autosize", !(t3.width && t3.height)), n3("width"), n3("height"), n3("minreducedwidth"), n3("minreducedheight"), n3("margin.l"), n3("margin.r"), n3("margin.t"), n3("margin.b"), n3("margin.pad"), n3("margin.autoexpand"), t3.width && t3.height && _.sanitizeMargins(e3), s.getComponentMethod("grid", "sizeDefaults")(t3, e3), n3("paper_bgcolor"), n3("separators", r3.decimal + r3.thousands), n3("hidesources"), n3("colorway"), n3("datarevision");
          var f3 = n3("uirevision");
          n3("editrevision", f3), n3("selectionrevision", f3), s.getComponentMethod("modebar", "supplyLayoutDefaults")(t3, e3), s.getComponentMethod("shapes", "supplyDrawNewShapeDefaults")(t3, e3, n3), s.getComponentMethod("selections", "supplyDrawNewSelectionDefaults")(t3, e3, n3), n3("meta"), c.isPlainObject(t3.transition) && (n3("transition.duration"), n3("transition.easing"), n3("transition.ordering")), s.getComponentMethod("calendars", "handleDefaults")(t3, e3, "calendar"), s.getComponentMethod("fx", "supplyLayoutGlobalDefaults")(t3, e3, n3), c.coerce(t3, e3, v, "scattermode");
        }, _.plotAutoSize = function(t3, e3, r3) {
          var n3, i2, a2 = t3._context || {}, s2 = a2.frameMargins, l2 = c.isPlotDiv(t3);
          if (l2 && t3.emit("plotly_autosize"), a2.fillFrame)
            n3 = window.innerWidth, i2 = window.innerHeight, document.body.style.overflow = "hidden";
          else {
            var u2 = l2 ? window.getComputedStyle(t3) : {};
            if (n3 = C(u2.width) || C(u2.maxWidth) || r3.width, i2 = C(u2.height) || C(u2.maxHeight) || r3.height, o(s2) && s2 > 0) {
              var f3 = 1 - 2 * s2;
              n3 = Math.round(f3 * n3), i2 = Math.round(f3 * i2);
            }
          }
          var h2 = _.layoutAttributes.width.min, p3 = _.layoutAttributes.height.min;
          n3 < h2 && (n3 = h2), i2 < p3 && (i2 = p3);
          var d3 = !e3.width && Math.abs(r3.width - n3) > 1, v2 = !e3.height && Math.abs(r3.height - i2) > 1;
          (v2 || d3) && (d3 && (r3.width = n3), v2 && (r3.height = i2)), t3._initialAutoSize || (t3._initialAutoSize = { width: n3, height: i2 }), _.sanitizeMargins(r3);
        }, _.supplyLayoutModuleDefaults = function(t3, e3, r3, n3) {
          var i2, a2, o2, l2 = s.componentsRegistry, u2 = e3._basePlotModules, f3 = s.subplotsRegistry.cartesian;
          for (i2 in l2)
            (o2 = l2[i2]).includeBasePlot && o2.includeBasePlot(t3, e3);
          for (var h2 in u2.length || u2.push(f3), e3._has("cartesian") && (s.getComponentMethod("grid", "contentDefaults")(t3, e3), f3.finalizeSubplots(t3, e3)), e3._subplots)
            e3._subplots[h2].sort(c.subplotSort);
          for (a2 = 0; a2 < u2.length; a2++)
            (o2 = u2[a2]).supplyLayoutDefaults && o2.supplyLayoutDefaults(t3, e3, r3);
          var p3 = e3._modules;
          for (a2 = 0; a2 < p3.length; a2++)
            (o2 = p3[a2]).supplyLayoutDefaults && o2.supplyLayoutDefaults(t3, e3, r3);
          var d3 = e3._transformModules;
          for (a2 = 0; a2 < d3.length; a2++)
            (o2 = d3[a2]).supplyLayoutDefaults && o2.supplyLayoutDefaults(t3, e3, r3, n3);
          for (i2 in l2)
            (o2 = l2[i2]).supplyLayoutDefaults && o2.supplyLayoutDefaults(t3, e3, r3);
        }, _.purge = function(t3) {
          var e3 = t3._fullLayout || {};
          void 0 !== e3._glcontainer && (e3._glcontainer.selectAll(".gl-canvas").remove(), e3._glcontainer.remove(), e3._glcanvas = null), e3._modeBar && e3._modeBar.destroy(), t3._transitionData && (t3._transitionData._interruptCallbacks && (t3._transitionData._interruptCallbacks.length = 0), t3._transitionData._animationRaf && window.cancelAnimationFrame(t3._transitionData._animationRaf)), c.clearThrottle(), c.clearResponsive(t3), delete t3.data, delete t3.layout, delete t3._fullData, delete t3._fullLayout, delete t3.calcdata, delete t3.empty, delete t3.fid, delete t3.undoqueue, delete t3.undonum, delete t3.autoplay, delete t3.changed, delete t3._promises, delete t3._redrawTimer, delete t3._hmlumcount, delete t3._hmpixcount, delete t3._transitionData, delete t3._transitioning, delete t3._initialAutoSize, delete t3._transitioningWithDuration, delete t3._dragging, delete t3._dragged, delete t3._dragdata, delete t3._hoverdata, delete t3._snapshotInProgress, delete t3._editing, delete t3._mouseDownTime, delete t3._legendMouseDownTime, t3.removeAllListeners && t3.removeAllListeners();
        }, _.style = function(t3) {
          var e3, r3 = t3._fullLayout._visibleModules, n3 = [];
          for (e3 = 0; e3 < r3.length; e3++) {
            var i2 = r3[e3];
            i2.style && c.pushUnique(n3, i2.style);
          }
          for (e3 = 0; e3 < n3.length; e3++)
            n3[e3](t3);
        }, _.sanitizeMargins = function(t3) {
          if (t3 && t3.margin) {
            var e3, r3 = t3.width, n3 = t3.height, i2 = t3.margin, a2 = r3 - (i2.l + i2.r), o2 = n3 - (i2.t + i2.b);
            a2 < 0 && (e3 = (r3 - 1) / (i2.l + i2.r), i2.l = Math.floor(e3 * i2.l), i2.r = Math.floor(e3 * i2.r)), o2 < 0 && (e3 = (n3 - 1) / (i2.t + i2.b), i2.t = Math.floor(e3 * i2.t), i2.b = Math.floor(e3 * i2.b));
          }
        }, _.clearAutoMarginIds = function(t3) {
          t3._fullLayout._pushmarginIds = {};
        }, _.allowAutoMargin = function(t3, e3) {
          t3._fullLayout._pushmarginIds[e3] = 1;
        }, _.autoMargin = function(t3, e3, r3) {
          var n3 = t3._fullLayout, i2 = n3.width, a2 = n3.height, o2 = n3.margin, s2 = n3.minreducedwidth, l2 = n3.minreducedheight, u2 = c.constrain(i2 - o2.l - o2.r, 2, s2), f3 = c.constrain(a2 - o2.t - o2.b, 2, l2), h2 = Math.max(0, i2 - u2), p3 = Math.max(0, a2 - f3), d3 = n3._pushmargin, v2 = n3._pushmarginIds;
          if (false !== o2.autoexpand) {
            if (r3) {
              var g3 = r3.pad;
              if (void 0 === g3 && (g3 = Math.min(12, o2.l, o2.r, o2.t, o2.b)), h2) {
                var y2 = (r3.l + r3.r) / h2;
                y2 > 1 && (r3.l /= y2, r3.r /= y2);
              }
              if (p3) {
                var m3 = (r3.t + r3.b) / p3;
                m3 > 1 && (r3.t /= m3, r3.b /= m3);
              }
              var x2 = void 0 !== r3.xl ? r3.xl : r3.x, b2 = void 0 !== r3.xr ? r3.xr : r3.x, w3 = void 0 !== r3.yt ? r3.yt : r3.y, T2 = void 0 !== r3.yb ? r3.yb : r3.y;
              d3[e3] = { l: { val: x2, size: r3.l + g3 }, r: { val: b2, size: r3.r + g3 }, b: { val: T2, size: r3.b + g3 }, t: { val: w3, size: r3.t + g3 } }, v2[e3] = 1;
            } else
              delete d3[e3], delete v2[e3];
            if (!n3._replotting)
              return _.doAutoMargin(t3);
          }
        }, _.doAutoMargin = function(t3) {
          var e3 = t3._fullLayout, r3 = e3.width, n3 = e3.height;
          e3._size || (e3._size = {}), P(e3);
          var i2 = e3._size, a2 = e3.margin, l2 = { t: 0, b: 0, l: 0, r: 0 }, u2 = c.extendFlat({}, i2), f3 = t3._fullLayout._reservedMargin;
          for (var h2 in f3)
            for (var d3 in f3[h2]) {
              var v2 = f3[h2][d3];
              l2[d3] = Math.max(l2[d3], v2);
            }
          var g3 = a2.l, y2 = a2.r, m3 = a2.t, x2 = a2.b, b2 = e3._pushmargin, w3 = e3._pushmarginIds, T2 = e3.minreducedwidth, k2 = e3.minreducedheight;
          if (false !== e3.margin.autoexpand) {
            for (var A2 in b2)
              w3[A2] || delete b2[A2];
            for (var M2 in b2.base = { l: { val: 0, size: g3 }, r: { val: 1, size: y2 }, t: { val: 1, size: m3 }, b: { val: 0, size: x2 } }, b2) {
              var S2 = b2[M2].l || {}, E2 = b2[M2].b || {}, L2 = S2.val, C2 = S2.size, O2 = E2.val, I2 = E2.size, D2 = r3 - l2.r - l2.l, z2 = n3 - l2.t - l2.b;
              for (var R2 in b2) {
                if (o(C2) && b2[R2].r) {
                  var F = b2[R2].r.val, B = b2[R2].r.size;
                  if (F > L2) {
                    var N = (C2 * F + (B - D2) * L2) / (F - L2), j = (B * (1 - L2) + (C2 - D2) * (1 - F)) / (F - L2);
                    N + j > g3 + y2 && (g3 = N, y2 = j);
                  }
                }
                if (o(I2) && b2[R2].t) {
                  var U = b2[R2].t.val, V = b2[R2].t.size;
                  if (U > O2) {
                    var H = (I2 * U + (V - z2) * O2) / (U - O2), q2 = (V * (1 - O2) + (I2 - z2) * (1 - U)) / (U - O2);
                    H + q2 > x2 + m3 && (x2 = H, m3 = q2);
                  }
                }
              }
            }
          }
          var G = c.constrain(r3 - a2.l - a2.r, 2, T2), Z = c.constrain(n3 - a2.t - a2.b, 2, k2), Y = Math.max(0, r3 - G), W = Math.max(0, n3 - Z);
          if (Y) {
            var X = (g3 + y2) / Y;
            X > 1 && (g3 /= X, y2 /= X);
          }
          if (W) {
            var J = (x2 + m3) / W;
            J > 1 && (x2 /= J, m3 /= J);
          }
          if (i2.l = Math.round(g3) + l2.l, i2.r = Math.round(y2) + l2.r, i2.t = Math.round(m3) + l2.t, i2.b = Math.round(x2) + l2.b, i2.p = Math.round(a2.pad), i2.w = Math.round(r3) - i2.l - i2.r, i2.h = Math.round(n3) - i2.t - i2.b, !e3._replotting && (_.didMarginChange(u2, i2) || function(t4) {
            if ("_redrawFromAutoMarginCount" in t4._fullLayout)
              return false;
            var e4 = p2.list(t4, "", true);
            for (var r4 in e4)
              if (e4[r4].autoshift || e4[r4].shift)
                return true;
            return false;
          }(t3))) {
            "_redrawFromAutoMarginCount" in e3 ? e3._redrawFromAutoMarginCount++ : e3._redrawFromAutoMarginCount = 1;
            var K = 3 * (1 + Object.keys(w3).length);
            if (e3._redrawFromAutoMarginCount < K)
              return s.call("_doPlot", t3);
            e3._size = u2, c.warn("Too many auto-margin redraws.");
          }
          !function(t4) {
            var e4 = p2.list(t4, "", true);
            ["_adjustTickLabelsOverflow", "_hideCounterAxisInsideTickLabels"].forEach(function(t5) {
              for (var r4 = 0; r4 < e4.length; r4++) {
                var n4 = e4[r4][t5];
                n4 && n4();
              }
            });
          }(t3);
        };
        var O = ["l", "r", "t", "b", "p", "w", "h"];
        function I(t3, e3, r3) {
          var n3 = false, i2 = [_.previousPromises, function() {
            if (t3._transitionData)
              return t3._transitioning = false, function(t4) {
                var e4 = Promise.resolve();
                if (!t4)
                  return e4;
                for (; t4.length; )
                  e4 = e4.then(t4.shift());
                return e4;
              }(t3._transitionData._interruptCallbacks);
          }, r3.prepareFn, _.rehover, _.reselect, function() {
            return t3.emit("plotly_transitioning", []), new Promise(function(i3) {
              t3._transitioning = true, e3.duration > 0 && (t3._transitioningWithDuration = true), t3._transitionData._interruptCallbacks.push(function() {
                n3 = true;
              }), r3.redraw && t3._transitionData._interruptCallbacks.push(function() {
                return s.call("redraw", t3);
              }), t3._transitionData._interruptCallbacks.push(function() {
                t3.emit("plotly_transitioninterrupted", []);
              });
              var a3 = 0, o2 = 0;
              function l2() {
                return a3++, function() {
                  var e4;
                  o2++, n3 || o2 !== a3 || (e4 = i3, t3._transitionData && (function(t4) {
                    if (t4)
                      for (; t4.length; )
                        t4.shift();
                  }(t3._transitionData._interruptCallbacks), Promise.resolve().then(function() {
                    if (r3.redraw)
                      return s.call("redraw", t3);
                  }).then(function() {
                    t3._transitioning = false, t3._transitioningWithDuration = false, t3.emit("plotly_transitioned", []);
                  }).then(e4)));
                };
              }
              r3.runFn(l2), setTimeout(l2());
            });
          }], a2 = c.syncOrAsync(i2, t3);
          return a2 && a2.then || (a2 = Promise.resolve()), a2.then(function() {
            return t3;
          });
        }
        _.didMarginChange = function(t3, e3) {
          for (var r3 = 0; r3 < O.length; r3++) {
            var n3 = O[r3], i2 = t3[n3], a2 = e3[n3];
            if (!o(i2) || Math.abs(a2 - i2) > 1)
              return true;
          }
          return false;
        }, _.graphJson = function(t3, e3, r3, n3, i2, a2) {
          (i2 && e3 && !t3._fullData || i2 && !e3 && !t3._fullLayout) && _.supplyDefaults(t3);
          var o2 = i2 ? t3._fullData : t3.data, s2 = i2 ? t3._fullLayout : t3.layout, l2 = (t3._transitionData || {})._frames;
          function u2(t4, e4) {
            if ("function" == typeof t4)
              return e4 ? "_function_" : null;
            if (c.isPlainObject(t4)) {
              var n4, i3 = {};
              return Object.keys(t4).sort().forEach(function(a3) {
                if (-1 === ["_", "["].indexOf(a3.charAt(0)))
                  if ("function" != typeof t4[a3]) {
                    if ("keepdata" === r3) {
                      if ("src" === a3.substr(a3.length - 3))
                        return;
                    } else if ("keepstream" === r3) {
                      if ("string" == typeof (n4 = t4[a3 + "src"]) && n4.indexOf(":") > 0 && !c.isPlainObject(t4.stream))
                        return;
                    } else if ("keepall" !== r3 && "string" == typeof (n4 = t4[a3 + "src"]) && n4.indexOf(":") > 0)
                      return;
                    i3[a3] = u2(t4[a3], e4);
                  } else
                    e4 && (i3[a3] = "_function");
              }), i3;
            }
            return Array.isArray(t4) ? t4.map(function(t5) {
              return u2(t5, e4);
            }) : c.isTypedArray(t4) ? c.simpleMap(t4, c.identity) : c.isJSDate(t4) ? c.ms2DateTimeLocal(+t4) : t4;
          }
          var f3 = { data: (o2 || []).map(function(t4) {
            var r4 = u2(t4);
            return e3 && delete r4.fit, r4;
          }) };
          if (!e3 && (f3.layout = u2(s2), i2)) {
            var h2 = s2._size;
            f3.layout.computed = { margin: { b: h2.b, l: h2.l, r: h2.r, t: h2.t } };
          }
          return l2 && (f3.frames = u2(l2)), a2 && (f3.config = u2(t3._context, true)), "object" === n3 ? f3 : JSON.stringify(f3);
        }, _.modifyFrames = function(t3, e3) {
          var r3, n3, i2, a2 = t3._transitionData._frames, o2 = t3._transitionData._frameHash;
          for (r3 = 0; r3 < e3.length; r3++)
            switch ((n3 = e3[r3]).type) {
              case "replace":
                i2 = n3.value;
                var s2 = (a2[n3.index] || {}).name, l2 = i2.name;
                a2[n3.index] = o2[l2] = i2, l2 !== s2 && (delete o2[s2], o2[l2] = i2);
                break;
              case "insert":
                o2[(i2 = n3.value).name] = i2, a2.splice(n3.index, 0, i2);
                break;
              case "delete":
                delete o2[(i2 = a2[n3.index]).name], a2.splice(n3.index, 1);
            }
          return Promise.resolve();
        }, _.computeFrame = function(t3, e3) {
          var r3, n3, i2, a2, o2 = t3._transitionData._frameHash;
          if (!e3)
            throw new Error("computeFrame must be given a string frame name");
          var s2 = o2[e3.toString()];
          if (!s2)
            return false;
          for (var l2 = [s2], u2 = [s2.name]; s2.baseframe && (s2 = o2[s2.baseframe.toString()]) && -1 === u2.indexOf(s2.name); )
            l2.push(s2), u2.push(s2.name);
          for (var c2 = {}; s2 = l2.pop(); )
            if (s2.layout && (c2.layout = _.extendLayout(c2.layout, s2.layout)), s2.data) {
              if (c2.data || (c2.data = []), !(n3 = s2.traces))
                for (n3 = [], r3 = 0; r3 < s2.data.length; r3++)
                  n3[r3] = r3;
              for (c2.traces || (c2.traces = []), r3 = 0; r3 < s2.data.length; r3++)
                null != (i2 = n3[r3]) && (-1 === (a2 = c2.traces.indexOf(i2)) && (a2 = c2.data.length, c2.traces[a2] = i2), c2.data[a2] = _.extendTrace(c2.data[a2], s2.data[r3]));
            }
          return c2;
        }, _.recomputeFrameHash = function(t3) {
          for (var e3 = t3._transitionData._frameHash = {}, r3 = t3._transitionData._frames, n3 = 0; n3 < r3.length; n3++) {
            var i2 = r3[n3];
            i2 && i2.name && (e3[i2.name] = i2);
          }
        }, _.extendObjectWithContainers = function(t3, e3, r3) {
          var n3, i2, a2, o2, s2, l2, u2, f3 = c.extendDeepNoArrays({}, e3 || {}), h2 = c.expandObjectPaths(f3), p3 = {};
          if (r3 && r3.length)
            for (a2 = 0; a2 < r3.length; a2++)
              void 0 === (i2 = (n3 = c.nestedProperty(h2, r3[a2])).get()) ? c.nestedProperty(p3, r3[a2]).set(null) : (n3.set(null), c.nestedProperty(p3, r3[a2]).set(i2));
          if (t3 = c.extendDeepNoArrays(t3 || {}, h2), r3 && r3.length) {
            for (a2 = 0; a2 < r3.length; a2++)
              if (l2 = c.nestedProperty(p3, r3[a2]).get()) {
                for (u2 = (s2 = c.nestedProperty(t3, r3[a2])).get(), Array.isArray(u2) || (u2 = [], s2.set(u2)), o2 = 0; o2 < l2.length; o2++) {
                  var d3 = l2[o2];
                  u2[o2] = null === d3 ? null : _.extendObjectWithContainers(u2[o2], d3);
                }
                s2.set(u2);
              }
          }
          return t3;
        }, _.dataArrayContainers = ["transforms", "dimensions"], _.layoutArrayContainers = s.layoutArrayContainers, _.extendTrace = function(t3, e3) {
          return _.extendObjectWithContainers(t3, e3, _.dataArrayContainers);
        }, _.extendLayout = function(t3, e3) {
          return _.extendObjectWithContainers(t3, e3, _.layoutArrayContainers);
        }, _.transition = function(t3, e3, r3, n3, i2, a2) {
          var o2 = { redraw: i2.redraw }, s2 = {}, l2 = [];
          return o2.prepareFn = function() {
            for (var i3 = Array.isArray(e3) ? e3.length : 0, a3 = n3.slice(0, i3), o3 = 0; o3 < a3.length; o3++) {
              var u2 = a3[o3], f3 = t3._fullData[u2]._module;
              if (f3) {
                if (f3.animatable) {
                  var h2 = f3.basePlotModule.name;
                  s2[h2] || (s2[h2] = []), s2[h2].push(u2);
                }
                t3.data[a3[o3]] = _.extendTrace(t3.data[a3[o3]], e3[o3]);
              }
            }
            var p3 = c.expandObjectPaths(c.extendDeepNoArrays({}, r3)), d3 = /^[xy]axis[0-9]*$/;
            for (var v2 in p3)
              d3.test(v2) && delete p3[v2].range;
            _.extendLayout(t3.layout, p3), delete t3.calcdata, _.supplyDefaults(t3), _.doCalcdata(t3);
            var g3 = c.expandObjectPaths(r3);
            if (g3) {
              var y2 = t3._fullLayout._plots;
              for (var m3 in y2) {
                var x2 = y2[m3], b2 = x2.xaxis, w3 = x2.yaxis, T2 = b2.range.slice(), k2 = w3.range.slice(), A2 = null, M2 = null, S2 = null, E2 = null;
                Array.isArray(g3[b2._name + ".range"]) ? A2 = g3[b2._name + ".range"].slice() : Array.isArray((g3[b2._name] || {}).range) && (A2 = g3[b2._name].range.slice()), Array.isArray(g3[w3._name + ".range"]) ? M2 = g3[w3._name + ".range"].slice() : Array.isArray((g3[w3._name] || {}).range) && (M2 = g3[w3._name].range.slice()), T2 && A2 && (b2.r2l(T2[0]) !== b2.r2l(A2[0]) || b2.r2l(T2[1]) !== b2.r2l(A2[1])) && (S2 = { xr0: T2, xr1: A2 }), k2 && M2 && (w3.r2l(k2[0]) !== w3.r2l(M2[0]) || w3.r2l(k2[1]) !== w3.r2l(M2[1])) && (E2 = { yr0: k2, yr1: M2 }), (S2 || E2) && l2.push(c.extendFlat({ plotinfo: x2 }, S2, E2));
              }
            }
            return Promise.resolve();
          }, o2.runFn = function(e4) {
            var n4, i3, o3 = t3._fullLayout._basePlotModules, u2 = l2.length;
            if (r3)
              for (i3 = 0; i3 < o3.length; i3++)
                o3[i3].transitionAxes && o3[i3].transitionAxes(t3, l2, a2, e4);
            for (var f3 in u2 ? ((n4 = c.extendFlat({}, a2)).duration = 0, delete s2.cartesian) : n4 = a2, s2) {
              var h2 = s2[f3];
              t3._fullData[h2[0]]._module.basePlotModule.plot(t3, h2, n4, e4);
            }
          }, I(t3, a2, o2);
        }, _.transitionFromReact = function(t3, e3, r3, n3) {
          var i2 = t3._fullLayout, a2 = i2.transition, o2 = {}, s2 = [];
          return o2.prepareFn = function() {
            var t4 = i2._plots;
            for (var a3 in o2.redraw = false, "some" === e3.anim && (o2.redraw = true), "some" === r3.anim && (o2.redraw = true), t4) {
              var l2 = t4[a3], u2 = l2.xaxis, f3 = l2.yaxis, h2 = n3[u2._name].range.slice(), p3 = n3[f3._name].range.slice(), d3 = u2.range.slice(), v2 = f3.range.slice();
              u2.setScale(), f3.setScale();
              var g3 = null, y2 = null;
              u2.r2l(h2[0]) === u2.r2l(d3[0]) && u2.r2l(h2[1]) === u2.r2l(d3[1]) || (g3 = { xr0: h2, xr1: d3 }), f3.r2l(p3[0]) === f3.r2l(v2[0]) && f3.r2l(p3[1]) === f3.r2l(v2[1]) || (y2 = { yr0: p3, yr1: v2 }), (g3 || y2) && s2.push(c.extendFlat({ plotinfo: l2 }, g3, y2));
            }
            return Promise.resolve();
          }, o2.runFn = function(r4) {
            for (var n4, i3, o3, l2 = t3._fullData, u2 = t3._fullLayout._basePlotModules, f3 = [], h2 = 0; h2 < l2.length; h2++)
              f3.push(h2);
            function p3() {
              if (t3._fullLayout)
                for (var e4 = 0; e4 < u2.length; e4++)
                  u2[e4].transitionAxes && u2[e4].transitionAxes(t3, s2, n4, r4);
            }
            function d3() {
              if (t3._fullLayout)
                for (var e4 = 0; e4 < u2.length; e4++)
                  u2[e4].plot(t3, o3, i3, r4);
            }
            s2.length && e3.anim ? "traces first" === a2.ordering ? (n4 = c.extendFlat({}, a2, { duration: 0 }), o3 = f3, i3 = a2, setTimeout(p3, a2.duration), d3()) : (n4 = a2, o3 = null, i3 = c.extendFlat({}, a2, { duration: 0 }), setTimeout(d3, n4.duration), p3()) : s2.length ? (n4 = a2, p3()) : e3.anim && (o3 = f3, i3 = a2, d3());
          }, I(t3, a2, o2);
        }, _.doCalcdata = function(t3, e3) {
          var r3, n3, i2, a2, o2 = p2.list(t3), u2 = t3._fullData, f3 = t3._fullLayout, d3 = new Array(u2.length), v2 = (t3.calcdata || []).slice();
          for (t3.calcdata = d3, f3._numBoxes = 0, f3._numViolins = 0, f3._violinScaleGroupStats = {}, t3._hmpixcount = 0, t3._hmlumcount = 0, f3._piecolormap = {}, f3._sunburstcolormap = {}, f3._treemapcolormap = {}, f3._iciclecolormap = {}, f3._funnelareacolormap = {}, i2 = 0; i2 < u2.length; i2++)
            Array.isArray(e3) && -1 === e3.indexOf(i2) && (d3[i2] = v2[i2]);
          for (i2 = 0; i2 < u2.length; i2++)
            (r3 = u2[i2])._arrayAttrs = l.findArrayAttributes(r3), r3._extremes = {};
          var g3 = f3._subplots.polar || [];
          for (i2 = 0; i2 < g3.length; i2++)
            o2.push(f3[g3[i2]].radialaxis, f3[g3[i2]].angularaxis);
          for (var y2 in f3._colorAxes) {
            var m3 = f3[y2];
            false !== m3.cauto && (delete m3.cmin, delete m3.cmax);
          }
          var x2 = false;
          function b2(e4) {
            if (r3 = u2[e4], n3 = r3._module, true === r3.visible && r3.transforms) {
              if (n3 && n3.calc) {
                var i3 = n3.calc(t3, r3);
                i3[0] && i3[0].t && i3[0].t._scene && delete i3[0].t._scene.dirty;
              }
              for (a2 = 0; a2 < r3.transforms.length; a2++) {
                var o3 = r3.transforms[a2];
                (n3 = w2[o3.type]) && n3.calcTransform && (r3._hasCalcTransform = true, x2 = true, n3.calcTransform(t3, r3, o3));
              }
            }
          }
          function _2(e4, i3) {
            if (r3 = u2[e4], !!(n3 = r3._module).isContainer === i3) {
              var o3 = [];
              if (true === r3.visible && 0 !== r3._length) {
                delete r3._indexToPoints;
                var s2 = r3.transforms || [];
                for (a2 = s2.length - 1; a2 >= 0; a2--)
                  if (s2[a2].enabled) {
                    r3._indexToPoints = s2[a2]._indexToPoints;
                    break;
                  }
                n3 && n3.calc && (o3 = n3.calc(t3, r3));
              }
              Array.isArray(o3) && o3[0] || (o3 = [{ x: h, y: h }]), o3[0].t || (o3[0].t = {}), o3[0].trace = r3, d3[e4] = o3;
            }
          }
          for (z(o2, u2, f3), i2 = 0; i2 < u2.length; i2++)
            _2(i2, true);
          for (i2 = 0; i2 < u2.length; i2++)
            b2(i2);
          for (x2 && z(o2, u2, f3), i2 = 0; i2 < u2.length; i2++)
            _2(i2, true);
          for (i2 = 0; i2 < u2.length; i2++)
            _2(i2, false);
          R(t3);
          var T2 = function(t4, e4) {
            var r4, n4, i3, a3, o3, l2 = [];
            function u3(t5, r5, n5) {
              var i4 = r5._id.charAt(0);
              if ("histogram2dcontour" === t5) {
                var a4 = r5._counterAxes[0], o4 = p2.getFromId(e4, a4), s2 = "x" === i4 || "x" === a4 && "category" === o4.type, l3 = "y" === i4 || "y" === a4 && "category" === o4.type;
                return function(t6, e5) {
                  return 0 === t6 || 0 === e5 || s2 && t6 === n5[e5].length - 1 || l3 && e5 === n5.length - 1 ? -1 : ("y" === i4 ? e5 : t6) - 1;
                };
              }
              return function(t6, e5) {
                return "y" === i4 ? e5 : t6;
              };
            }
            var f4 = { min: function(t5) {
              return c.aggNums(Math.min, null, t5);
            }, max: function(t5) {
              return c.aggNums(Math.max, null, t5);
            }, sum: function(t5) {
              return c.aggNums(function(t6, e5) {
                return t6 + e5;
              }, null, t5);
            }, total: function(t5) {
              return c.aggNums(function(t6, e5) {
                return t6 + e5;
              }, null, t5);
            }, mean: function(t5) {
              return c.mean(t5);
            }, median: function(t5) {
              return c.median(t5);
            } };
            for (r4 = 0; r4 < t4.length; r4++) {
              var h2 = t4[r4];
              if ("category" === h2.type) {
                var d4 = h2.categoryorder.match(D);
                if (d4) {
                  var v3 = d4[1], g4 = d4[2], y3 = h2._id.charAt(0), m4 = "x" === y3, x3 = [];
                  for (n4 = 0; n4 < h2._categories.length; n4++)
                    x3.push([h2._categories[n4], []]);
                  for (n4 = 0; n4 < h2._traceIndices.length; n4++) {
                    var b3 = h2._traceIndices[n4], _3 = e4._fullData[b3];
                    if (true === _3.visible) {
                      var w3 = _3.type;
                      s.traceIs(_3, "histogram") && (delete _3._xautoBinFinished, delete _3._yautoBinFinished);
                      var T3 = "splom" === w3, k2 = "scattergl" === w3, A2 = e4.calcdata[b3];
                      for (i3 = 0; i3 < A2.length; i3++) {
                        var M2, S2, E2 = A2[i3];
                        if (T3) {
                          var L2 = _3._axesDim[h2._id];
                          if (!m4) {
                            var C2 = _3._diag[L2][0];
                            C2 && (h2 = e4._fullLayout[p2.id2name(C2)]);
                          }
                          var P2 = E2.trace.dimensions[L2].values;
                          for (a3 = 0; a3 < P2.length; a3++)
                            for (M2 = h2._categoriesMap[P2[a3]], o3 = 0; o3 < E2.trace.dimensions.length; o3++)
                              if (o3 !== L2) {
                                var O2 = E2.trace.dimensions[o3];
                                x3[M2][1].push(O2.values[a3]);
                              }
                        } else if (k2) {
                          for (a3 = 0; a3 < E2.t.x.length; a3++)
                            m4 ? (M2 = E2.t.x[a3], S2 = E2.t.y[a3]) : (M2 = E2.t.y[a3], S2 = E2.t.x[a3]), x3[M2][1].push(S2);
                          E2.t && E2.t._scene && delete E2.t._scene.dirty;
                        } else if (E2.hasOwnProperty("z")) {
                          S2 = E2.z;
                          var I2 = u3(_3.type, h2, S2);
                          for (a3 = 0; a3 < S2.length; a3++)
                            for (o3 = 0; o3 < S2[a3].length; o3++)
                              (M2 = I2(o3, a3)) + 1 && x3[M2][1].push(S2[a3][o3]);
                        } else
                          for (void 0 === (M2 = E2.p) && (M2 = E2[y3]), void 0 === (S2 = E2.s) && (S2 = E2.v), void 0 === S2 && (S2 = m4 ? E2.y : E2.x), Array.isArray(S2) || (S2 = void 0 === S2 ? [] : [S2]), a3 = 0; a3 < S2.length; a3++)
                            x3[M2][1].push(S2[a3]);
                      }
                    }
                  }
                  h2._categoriesValue = x3;
                  var z2 = [];
                  for (n4 = 0; n4 < x3.length; n4++)
                    z2.push([x3[n4][0], f4[v3](x3[n4][1])]);
                  z2.sort(function(t5, e5) {
                    return t5[1] - e5[1];
                  }), h2._categoriesAggregatedValue = z2, h2._initialCategories = z2.map(function(t5) {
                    return t5[0];
                  }), "descending" === g4 && h2._initialCategories.reverse(), l2 = l2.concat(h2.sortByInitialCategories());
                }
              }
            }
            return l2;
          }(o2, t3);
          if (T2.length) {
            for (f3._numBoxes = 0, f3._numViolins = 0, i2 = 0; i2 < T2.length; i2++)
              _2(T2[i2], true);
            for (i2 = 0; i2 < T2.length; i2++)
              _2(T2[i2], false);
            R(t3);
          }
          s.getComponentMethod("fx", "calc")(t3), s.getComponentMethod("errorbars", "calc")(t3);
        };
        var D = /(total|sum|min|max|mean|median) (ascending|descending)/;
        function z(t3, e3, r3) {
          var n3 = {};
          function i2(t4) {
            t4.clearCalc(), "multicategory" === t4.type && t4.setupMultiCategory(e3), n3[t4._id] = 1;
          }
          c.simpleMap(t3, i2);
          for (var a2 = r3._axisMatchGroups || [], o2 = 0; o2 < a2.length; o2++)
            for (var s2 in a2[o2])
              n3[s2] || i2(r3[p2.id2name(s2)]);
        }
        function R(t3) {
          var e3, r3, n3, i2 = t3._fullLayout, a2 = i2._visibleModules, o2 = {};
          for (r3 = 0; r3 < a2.length; r3++) {
            var s2 = a2[r3], l2 = s2.crossTraceCalc;
            if (l2) {
              var u2 = s2.basePlotModule.name;
              o2[u2] ? c.pushUnique(o2[u2], l2) : o2[u2] = [l2];
            }
          }
          for (n3 in o2) {
            var f3 = o2[n3], h2 = i2._subplots[n3];
            if (Array.isArray(h2))
              for (e3 = 0; e3 < h2.length; e3++) {
                var p3 = h2[e3], d3 = "cartesian" === n3 ? i2._plots[p3] : i2[p3];
                for (r3 = 0; r3 < f3.length; r3++)
                  f3[r3](t3, d3, p3);
              }
            else
              for (r3 = 0; r3 < f3.length; r3++)
                f3[r3](t3);
          }
        }
        _.rehover = function(t3) {
          t3._fullLayout._rehover && t3._fullLayout._rehover();
        }, _.redrag = function(t3) {
          t3._fullLayout._redrag && t3._fullLayout._redrag();
        }, _.reselect = function(t3) {
          var e3 = t3._fullLayout, r3 = (t3.layout || {}).selections, n3 = e3._previousSelections;
          e3._previousSelections = r3;
          var i2 = e3._reselect || JSON.stringify(r3) !== JSON.stringify(n3);
          s.getComponentMethod("selections", "reselect")(t3, i2);
        }, _.generalUpdatePerTraceModule = function(t3, e3, r3, n3) {
          var i2, a2 = e3.traceHash, o2 = {};
          for (i2 = 0; i2 < r3.length; i2++) {
            var s2 = r3[i2], l2 = s2[0].trace;
            l2.visible && (o2[l2.type] = o2[l2.type] || [], o2[l2.type].push(s2));
          }
          for (var u2 in a2)
            if (!o2[u2]) {
              var f3 = a2[u2][0];
              f3[0].trace.visible = false, o2[u2] = [f3];
            }
          for (var h2 in o2) {
            var p3 = o2[h2];
            p3[0][0].trace._module.plot(t3, e3, c.filterVisible(p3), n3);
          }
          e3.traceHash = o2;
        }, _.plotBasePlot = function(t3, e3, r3, n3, i2) {
          var a2 = s.getModule(t3), o2 = m2(e3.calcdata, a2)[0];
          a2.plot(e3, o2, n3, i2);
        }, _.cleanBasePlot = function(t3, e3, r3, n3, i2) {
          var a2 = i2._has && i2._has(t3), o2 = r3._has && r3._has(t3);
          a2 && !o2 && i2["_" + t3 + "layer"].selectAll("g.trace").remove();
        };
      }, 9813: function(t2) {
        t2.exports = { attr: "subplot", name: "polar", axisNames: ["angularaxis", "radialaxis"], axisName2dataArray: { angularaxis: "theta", radialaxis: "r" }, layerNames: ["draglayer", "plotbg", "backplot", "angular-grid", "radial-grid", "frontplot", "angular-line", "radial-line", "angular-axis", "radial-axis"], radialDragBoxSize: 50, angularDragBoxSize: 30, cornerLen: 25, cornerHalfWidth: 2, MINDRAG: 8, MINZOOM: 20, OFFEDGE: 20 };
      }, 10869: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(61082).tester, a = n2.findIndexOfMin, o = n2.isAngleInsideSector, s = n2.angleDelta, l = n2.angleDist;
        function u(t3, e3, r3, n3) {
          var i2, a2, o2 = n3[0], s2 = n3[1], l2 = f2(Math.sin(e3) - Math.sin(t3)), u2 = f2(Math.cos(e3) - Math.cos(t3)), c2 = Math.tan(r3), h2 = f2(1 / c2), p2 = l2 / u2, d2 = s2 - p2 * o2;
          return h2 ? l2 && u2 ? a2 = c2 * (i2 = d2 / (c2 - p2)) : u2 ? (i2 = s2 * h2, a2 = s2) : (i2 = o2, a2 = o2 * c2) : l2 && u2 ? (i2 = 0, a2 = d2) : u2 ? (i2 = 0, a2 = s2) : i2 = a2 = NaN, [i2, a2];
        }
        function c(t3, e3, r3, i2) {
          return n2.isFullCircle([e3, r3]) ? function(t4, e4) {
            var r4, n3 = e4.length, i3 = new Array(n3 + 1);
            for (r4 = 0; r4 < n3; r4++) {
              var a2 = e4[r4];
              i3[r4] = [t4 * Math.cos(a2), t4 * Math.sin(a2)];
            }
            return i3[r4] = i3[0].slice(), i3;
          }(t3, i2) : function(t4, e4, r4, i3) {
            var s2, c2, f3 = i3.length, h2 = [];
            function p2(e5) {
              return [t4 * Math.cos(e5), t4 * Math.sin(e5)];
            }
            function d2(t5, e5, r5) {
              return u(t5, e5, r5, p2(t5));
            }
            function v(t5) {
              return n2.mod(t5, f3);
            }
            function g2(t5) {
              return o(t5, [e4, r4]);
            }
            var y = a(i3, function(t5) {
              return g2(t5) ? l(t5, e4) : 1 / 0;
            }), m2 = d2(i3[y], i3[v(y - 1)], e4);
            for (h2.push(m2), s2 = y, c2 = 0; c2 < f3; s2++, c2++) {
              var x = i3[v(s2)];
              if (!g2(x))
                break;
              h2.push(p2(x));
            }
            var b = a(i3, function(t5) {
              return g2(t5) ? l(t5, r4) : 1 / 0;
            }), _ = d2(i3[b], i3[v(b + 1)], r4);
            return h2.push(_), h2.push([0, 0]), h2.push(h2[0].slice()), h2;
          }(t3, e3, r3, i2);
        }
        function f2(t3) {
          return Math.abs(t3) > 1e-10 ? t3 : 0;
        }
        function h(t3, e3, r3) {
          e3 = e3 || 0, r3 = r3 || 0;
          for (var n3 = t3.length, i2 = new Array(n3), a2 = 0; a2 < n3; a2++) {
            var o2 = t3[a2];
            i2[a2] = [e3 + o2[0], r3 - o2[1]];
          }
          return i2;
        }
        t2.exports = { isPtInsidePolygon: function(t3, e3, r3, n3, a2) {
          if (!o(e3, n3))
            return false;
          var s2, l2;
          r3[0] < r3[1] ? (s2 = r3[0], l2 = r3[1]) : (s2 = r3[1], l2 = r3[0]);
          var u2 = i(c(s2, n3[0], n3[1], a2)), f3 = i(c(l2, n3[0], n3[1], a2)), h2 = [t3 * Math.cos(e3), t3 * Math.sin(e3)];
          return f3.contains(h2) && !u2.contains(h2);
        }, findPolygonOffset: function(t3, e3, r3, n3) {
          for (var i2 = 1 / 0, a2 = 1 / 0, o2 = c(t3, e3, r3, n3), s2 = 0; s2 < o2.length; s2++) {
            var l2 = o2[s2];
            i2 = Math.min(i2, l2[0]), a2 = Math.min(a2, -l2[1]);
          }
          return [i2, a2];
        }, findEnclosingVertexAngles: function(t3, e3) {
          var r3 = a(e3, function(e4) {
            var r4 = s(e4, t3);
            return r4 > 0 ? r4 : 1 / 0;
          }), i2 = n2.mod(r3 + 1, e3.length);
          return [e3[r3], e3[i2]];
        }, findIntersectionXY: u, findXYatLength: function(t3, e3, r3, n3) {
          var i2 = -e3 * r3, a2 = e3 * e3 + 1, o2 = 2 * (e3 * i2 - r3), s2 = i2 * i2 + r3 * r3 - t3 * t3, l2 = Math.sqrt(o2 * o2 - 4 * a2 * s2), u2 = (-o2 + l2) / (2 * a2), c2 = (-o2 - l2) / (2 * a2);
          return [[u2, e3 * u2 + i2 + n3], [c2, e3 * c2 + i2 + n3]];
        }, clampTiny: f2, pathPolygon: function(t3, e3, r3, n3, i2, a2) {
          return "M" + h(c(t3, e3, r3, n3), i2, a2).join("L");
        }, pathPolygonAnnulus: function(t3, e3, r3, n3, i2, a2, o2) {
          var s2, l2;
          t3 < e3 ? (s2 = t3, l2 = e3) : (s2 = e3, l2 = t3);
          var u2 = h(c(s2, r3, n3, i2), a2, o2);
          return "M" + h(c(l2, r3, n3, i2), a2, o2).reverse().join("L") + "M" + u2.join("L");
        } };
      }, 23580: function(t2, e2, r2) {
        var n2 = r2(27659).AU, i = r2(71828).counterRegex, a = r2(77997), o = r2(9813), s = o.attr, l = o.name, u = i(l), c = {};
        c[s] = { valType: "subplotid", dflt: l, editType: "calc" }, t2.exports = { attr: s, name: l, idRoot: l, idRegex: u, attrRegex: u, attributes: c, layoutAttributes: r2(73812), supplyLayoutDefaults: r2(68993), plot: function(t3) {
          for (var e3 = t3._fullLayout, r3 = t3.calcdata, i2 = e3._subplots[l], o2 = 0; o2 < i2.length; o2++) {
            var s2 = i2[o2], u2 = n2(r3, l, s2), c2 = e3[s2]._subplot;
            c2 || (c2 = a(t3, s2), e3[s2]._subplot = c2), c2.plot(u2, e3, t3._promises);
          }
        }, clean: function(t3, e3, r3, n3) {
          for (var i2 = n3._subplots[l] || [], a2 = n3._has && n3._has("gl"), o2 = e3._has && e3._has("gl"), s2 = a2 && !o2, u2 = 0; u2 < i2.length; u2++) {
            var c2 = i2[u2], f2 = n3[c2]._subplot;
            if (!e3[c2] && f2)
              for (var h in f2.framework.remove(), f2.layers["radial-axis-title"].remove(), f2.clipPaths)
                f2.clipPaths[h].remove();
            s2 && f2._scene && (f2._scene.destroy(), f2._scene = null);
          }
        }, toSVG: r2(93612).toSVG };
      }, 73812: function(t2, e2, r2) {
        var n2 = r2(22399), i = r2(13838), a = r2(27670).Y, o = r2(71828).extendFlat, s = r2(30962).overrideAll, l = s({ color: i.color, showline: o({}, i.showline, { dflt: true }), linecolor: i.linecolor, linewidth: i.linewidth, showgrid: o({}, i.showgrid, { dflt: true }), gridcolor: i.gridcolor, gridwidth: i.gridwidth, griddash: i.griddash }, "plot", "from-root"), u = s({ tickmode: i.minor.tickmode, nticks: i.nticks, tick0: i.tick0, dtick: i.dtick, tickvals: i.tickvals, ticktext: i.ticktext, ticks: i.ticks, ticklen: i.ticklen, tickwidth: i.tickwidth, tickcolor: i.tickcolor, ticklabelstep: i.ticklabelstep, showticklabels: i.showticklabels, labelalias: i.labelalias, showtickprefix: i.showtickprefix, tickprefix: i.tickprefix, showticksuffix: i.showticksuffix, ticksuffix: i.ticksuffix, showexponent: i.showexponent, exponentformat: i.exponentformat, minexponent: i.minexponent, separatethousands: i.separatethousands, tickfont: i.tickfont, tickangle: i.tickangle, tickformat: i.tickformat, tickformatstops: i.tickformatstops, layer: i.layer }, "plot", "from-root"), c = { visible: o({}, i.visible, { dflt: true }), type: o({}, i.type, { values: ["-", "linear", "log", "date", "category"] }), autotypenumbers: i.autotypenumbers, autorange: o({}, i.autorange, { editType: "plot" }), rangemode: { valType: "enumerated", values: ["tozero", "nonnegative", "normal"], dflt: "tozero", editType: "calc" }, range: o({}, i.range, { items: [{ valType: "any", editType: "plot", impliedEdits: { "^autorange": false } }, { valType: "any", editType: "plot", impliedEdits: { "^autorange": false } }], editType: "plot" }), categoryorder: i.categoryorder, categoryarray: i.categoryarray, angle: { valType: "angle", editType: "plot" }, side: { valType: "enumerated", values: ["clockwise", "counterclockwise"], dflt: "clockwise", editType: "plot" }, title: { text: o({}, i.title.text, { editType: "plot", dflt: "" }), font: o({}, i.title.font, { editType: "plot" }), editType: "plot" }, hoverformat: i.hoverformat, uirevision: { valType: "any", editType: "none" }, editType: "calc", _deprecated: { title: i._deprecated.title, titlefont: i._deprecated.titlefont } };
        o(c, l, u);
        var f2 = { visible: o({}, i.visible, { dflt: true }), type: { valType: "enumerated", values: ["-", "linear", "category"], dflt: "-", editType: "calc", _noTemplating: true }, autotypenumbers: i.autotypenumbers, categoryorder: i.categoryorder, categoryarray: i.categoryarray, thetaunit: { valType: "enumerated", values: ["radians", "degrees"], dflt: "degrees", editType: "calc" }, period: { valType: "number", editType: "calc", min: 0 }, direction: { valType: "enumerated", values: ["counterclockwise", "clockwise"], dflt: "counterclockwise", editType: "calc" }, rotation: { valType: "angle", editType: "calc" }, hoverformat: i.hoverformat, uirevision: { valType: "any", editType: "none" }, editType: "calc" };
        o(f2, l, u), t2.exports = { domain: a({ name: "polar", editType: "plot" }), sector: { valType: "info_array", items: [{ valType: "number", editType: "plot" }, { valType: "number", editType: "plot" }], dflt: [0, 360], editType: "plot" }, hole: { valType: "number", min: 0, max: 1, dflt: 0, editType: "plot" }, bgcolor: { valType: "color", editType: "plot", dflt: n2.background }, radialaxis: c, angularaxis: f2, gridshape: { valType: "enumerated", values: ["circular", "linear"], dflt: "circular", editType: "plot" }, uirevision: { valType: "any", editType: "none" }, editType: "calc" };
      }, 68993: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901), a = r2(44467), o = r2(49119), s = r2(27659).NG, l = r2(26218), u = r2(38701), c = r2(96115), f2 = r2(89426), h = r2(15258), p2 = r2(92128), d2 = r2(4322), v = r2(73812), g2 = r2(12101), y = r2(9813), m2 = y.axisNames;
        function x(t3, e3, r3, o2) {
          var d3 = r3("bgcolor");
          o2.bgColor = i.combine(d3, o2.paper_bgcolor);
          var x2 = r3("sector");
          r3("hole");
          var _, w2 = s(o2.fullData, y.name, o2.id), T = o2.layoutOut;
          function k(t4, e4) {
            return r3(_ + "." + t4, e4);
          }
          for (var A = 0; A < m2.length; A++) {
            _ = m2[A], n2.isPlainObject(t3[_]) || (t3[_] = {});
            var M = t3[_], S = a.newContainer(e3, _);
            S._id = S._name = _, S._attr = o2.id + "." + _, S._traceIndices = w2.map(function(t4) {
              return t4._expandedIndex;
            });
            var E = y.axisName2dataArray[_], L = b(M, S, k, w2, E, o2);
            h(M, S, k, { axData: w2, dataAttr: E });
            var C = k("visible");
            switch (g2(S, e3, T), k("uirevision", e3.uirevision), S._m = 1, _) {
              case "radialaxis":
                var P = k("autorange", !S.isValidRange(M.range));
                M.autorange = P, !P || "linear" !== L && "-" !== L || k("rangemode"), "reversed" === P && (S._m = -1), k("range"), S.cleanRange("range", { dfltRange: [0, 1] });
                break;
              case "angularaxis":
                if ("date" === L) {
                  n2.log("Polar plots do not support date angular axes yet.");
                  for (var O = 0; O < w2.length; O++)
                    w2[O].visible = false;
                  L = M.type = S.type = "linear";
                }
                k("linear" === L ? "thetaunit" : "period");
                var I = k("direction");
                k("rotation", { counterclockwise: 0, clockwise: 90 }[I]);
            }
            if (f2(M, S, k, S.type, { tickSuffixDflt: "degrees" === S.thetaunit ? "°" : void 0 }), C) {
              var D, z, R, F, B = o2.font || {};
              z = (D = k("color")) === M.color ? D : B.color, R = B.size, F = B.family, l(M, S, k, S.type), c(M, S, k, S.type, { font: { color: z, size: R, family: F } }), u(M, S, k, { outerTicks: true }), p2(M, S, k, { dfltColor: D, bgColor: o2.bgColor, blend: 60, showLine: true, showGrid: true, noZeroLine: true, attributes: v[_] }), k("layer"), "radialaxis" === _ && (k("side"), k("angle", x2[0]), k("title.text"), n2.coerceFont(k, "title.font", { color: z, size: n2.bigFont(R), family: F }));
            }
            "category" !== L && k("hoverformat"), S._input = M;
          }
          "category" === e3.angularaxis.type && r3("gridshape");
        }
        function b(t3, e3, r3, n3, i2, a2) {
          var o2 = r3("autotypenumbers", a2.autotypenumbersDflt);
          if ("-" === r3("type")) {
            for (var s2, l2 = 0; l2 < n3.length; l2++)
              if (n3[l2].visible) {
                s2 = n3[l2];
                break;
              }
            s2 && s2[i2] && (e3.type = d2(s2[i2], "gregorian", { noMultiCategory: true, autotypenumbers: o2 })), "-" === e3.type ? e3.type = "linear" : t3.type = e3.type;
          }
          return e3.type;
        }
        t2.exports = function(t3, e3, r3) {
          o(t3, e3, r3, { type: y.name, attributes: v, handleDefaults: x, font: e3.font, autotypenumbersDflt: e3.autotypenumbers, paper_bgcolor: e3.paper_bgcolor, fullData: r3, layoutOut: e3 });
        };
      }, 77997: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(84267), a = r2(73972), o = r2(71828), s = o.strRotate, l = o.strTranslate, u = r2(7901), c = r2(91424), f2 = r2(74875), h = r2(89298), p2 = r2(21994), d2 = r2(12101), v = r2(71739).doAutoRange, g2 = r2(29323), y = r2(28569), m2 = r2(30211), x = r2(92998), b = r2(47322).prepSelect, _ = r2(47322).selectOnClick, w2 = r2(47322).clearOutline, T = r2(6964), k = r2(33306), A = r2(61549).redrawReglTraces, M = r2(18783).MID_SHIFT, S = r2(9813), E = r2(10869), L = r2(23893), C = L.smith, P = L.reactanceArc, O = L.resistanceArc, I = L.smithTransform, D = o._, z = o.mod, R = o.deg2rad, F = o.rad2deg;
        function B(t3, e3, r3) {
          this.isSmith = r3 || false, this.id = e3, this.gd = t3, this._hasClipOnAxisFalse = null, this.vangles = null, this.radialAxisAngle = null, this.traceHash = {}, this.layers = {}, this.clipPaths = {}, this.clipIds = {}, this.viewInitial = {};
          var n3 = t3._fullLayout, i2 = "clip" + n3._uid + e3;
          this.clipIds.forTraces = i2 + "-for-traces", this.clipPaths.forTraces = n3._clips.append("clipPath").attr("id", this.clipIds.forTraces), this.clipPaths.forTraces.append("path"), this.framework = n3["_" + (r3 ? "smith" : "polar") + "layer"].append("g").attr("class", e3), this.getHole = function(t4) {
            return this.isSmith ? 0 : t4.hole;
          }, this.getSector = function(t4) {
            return this.isSmith ? [0, 360] : t4.sector;
          }, this.getRadial = function(t4) {
            return this.isSmith ? t4.realaxis : t4.radialaxis;
          }, this.getAngular = function(t4) {
            return this.isSmith ? t4.imaginaryaxis : t4.angularaxis;
          }, r3 || (this.radialTickLayout = null, this.angularTickLayout = null);
        }
        var N = B.prototype;
        function j(t3) {
          var e3 = t3.ticks + String(t3.ticklen) + String(t3.showticklabels);
          return "side" in t3 && (e3 += t3.side), e3;
        }
        function U(t3, e3) {
          return e3[o.findIndexOfMin(e3, function(e4) {
            return o.angleDist(t3, e4);
          })];
        }
        function V(t3, e3, r3) {
          return e3 ? (t3.attr("display", null), t3.attr(r3)) : t3 && t3.attr("display", "none"), t3;
        }
        t2.exports = function(t3, e3, r3) {
          return new B(t3, e3, r3);
        }, N.plot = function(t3, e3) {
          for (var r3 = this, n3 = e3[r3.id], i2 = false, a2 = 0; a2 < t3.length; a2++)
            if (false === t3[a2][0].trace.cliponaxis) {
              i2 = true;
              break;
            }
          r3._hasClipOnAxisFalse = i2, r3.updateLayers(e3, n3), r3.updateLayout(e3, n3), f2.generalUpdatePerTraceModule(r3.gd, r3, t3, n3), r3.updateFx(e3, n3), r3.isSmith && (delete n3.realaxis.range, delete n3.imaginaryaxis.range);
        }, N.updateLayers = function(t3, e3) {
          var r3 = this, i2 = r3.isSmith, a2 = r3.layers, o2 = r3.getRadial(e3), s2 = r3.getAngular(e3), l2 = S.layerNames, u2 = l2.indexOf("frontplot"), c2 = l2.slice(0, u2), f3 = "below traces" === s2.layer, h2 = "below traces" === o2.layer;
          f3 && c2.push("angular-line"), h2 && c2.push("radial-line"), f3 && c2.push("angular-axis"), h2 && c2.push("radial-axis"), c2.push("frontplot"), f3 || c2.push("angular-line"), h2 || c2.push("radial-line"), f3 || c2.push("angular-axis"), h2 || c2.push("radial-axis");
          var p3 = (i2 ? "smith" : "polar") + "sublayer", d3 = r3.framework.selectAll("." + p3).data(c2, String);
          d3.enter().append("g").attr("class", function(t4) {
            return p3 + " " + t4;
          }).each(function(t4) {
            var e4 = a2[t4] = n2.select(this);
            switch (t4) {
              case "frontplot":
                i2 || e4.append("g").classed("barlayer", true), e4.append("g").classed("scatterlayer", true);
                break;
              case "backplot":
                e4.append("g").classed("maplayer", true);
                break;
              case "plotbg":
                a2.bg = e4.append("path");
                break;
              case "radial-grid":
              case "angular-grid":
                e4.style("fill", "none");
                break;
              case "radial-line":
                e4.append("line").style("fill", "none");
                break;
              case "angular-line":
                e4.append("path").style("fill", "none");
            }
          }), d3.order();
        }, N.updateLayout = function(t3, e3) {
          var r3 = this, n3 = r3.layers, i2 = t3._size, a2 = r3.getRadial(e3), o2 = r3.getAngular(e3), s2 = e3.domain.x, f3 = e3.domain.y;
          r3.xOffset = i2.l + i2.w * s2[0], r3.yOffset = i2.t + i2.h * (1 - f3[1]);
          var h2 = r3.xLength = i2.w * (s2[1] - s2[0]), p3 = r3.yLength = i2.h * (f3[1] - f3[0]), d3 = r3.getSector(e3);
          r3.sectorInRad = d3.map(R);
          var v2, g3, y2, m3, x2, b2 = r3.sectorBBox = function(t4) {
            var e4, r4 = t4[0], n4 = t4[1] - r4, i3 = z(r4, 360), a3 = i3 + n4, o3 = Math.cos(R(i3)), s3 = Math.sin(R(i3)), l2 = Math.cos(R(a3)), u2 = Math.sin(R(a3));
            return e4 = i3 <= 90 && a3 >= 90 || i3 > 90 && a3 >= 450 ? 1 : s3 <= 0 && u2 <= 0 ? 0 : Math.max(s3, u2), [i3 <= 180 && a3 >= 180 || i3 > 180 && a3 >= 540 ? -1 : o3 >= 0 && l2 >= 0 ? 0 : Math.min(o3, l2), i3 <= 270 && a3 >= 270 || i3 > 270 && a3 >= 630 ? -1 : s3 >= 0 && u2 >= 0 ? 0 : Math.min(s3, u2), a3 >= 360 ? 1 : o3 <= 0 && l2 <= 0 ? 0 : Math.max(o3, l2), e4];
          }(d3), _2 = b2[2] - b2[0], w3 = b2[3] - b2[1], T2 = p3 / h2, k2 = Math.abs(w3 / _2);
          T2 > k2 ? (v2 = h2, x2 = (p3 - (g3 = h2 * k2)) / i2.h / 2, y2 = [s2[0], s2[1]], m3 = [f3[0] + x2, f3[1] - x2]) : (g3 = p3, x2 = (h2 - (v2 = p3 / k2)) / i2.w / 2, y2 = [s2[0] + x2, s2[1] - x2], m3 = [f3[0], f3[1]]), r3.xLength2 = v2, r3.yLength2 = g3, r3.xDomain2 = y2, r3.yDomain2 = m3;
          var A2, M2 = r3.xOffset2 = i2.l + i2.w * y2[0], S2 = r3.yOffset2 = i2.t + i2.h * (1 - m3[1]), E2 = r3.radius = v2 / _2, L2 = r3.innerRadius = r3.getHole(e3) * E2, C2 = r3.cx = M2 - E2 * b2[0], P2 = r3.cy = S2 + E2 * b2[3], O2 = r3.cxx = C2 - M2, I2 = r3.cyy = P2 - S2, D2 = a2.side;
          "counterclockwise" === D2 ? (A2 = D2, D2 = "top") : "clockwise" === D2 && (A2 = D2, D2 = "bottom"), r3.radialAxis = r3.mockAxis(t3, e3, a2, { _id: "x", side: D2, _trueSide: A2, domain: [L2 / i2.w, E2 / i2.w] }), r3.angularAxis = r3.mockAxis(t3, e3, o2, { side: "right", domain: [0, Math.PI], autorange: false }), r3.doAutoRange(t3, e3), r3.updateAngularAxis(t3, e3), r3.updateRadialAxis(t3, e3), r3.updateRadialAxisTitle(t3, e3), r3.xaxis = r3.mockCartesianAxis(t3, e3, { _id: "x", domain: y2 }), r3.yaxis = r3.mockCartesianAxis(t3, e3, { _id: "y", domain: m3 });
          var F2 = r3.pathSubplot();
          r3.clipPaths.forTraces.select("path").attr("d", F2).attr("transform", l(O2, I2)), n3.frontplot.attr("transform", l(M2, S2)).call(c.setClipUrl, r3._hasClipOnAxisFalse ? null : r3.clipIds.forTraces, r3.gd), n3.bg.attr("d", F2).attr("transform", l(C2, P2)).call(u.fill, e3.bgcolor);
        }, N.mockAxis = function(t3, e3, r3, n3) {
          var i2 = o.extendFlat({}, r3, n3);
          return d2(i2, e3, t3), i2;
        }, N.mockCartesianAxis = function(t3, e3, r3) {
          var n3 = this, i2 = n3.isSmith, a2 = r3._id, s2 = o.extendFlat({ type: "linear" }, r3);
          p2(s2, t3);
          var l2 = { x: [0, 2], y: [1, 3] };
          return s2.setRange = function() {
            var t4 = n3.sectorBBox, r4 = l2[a2], i3 = n3.radialAxis._rl, o2 = (i3[1] - i3[0]) / (1 - n3.getHole(e3));
            s2.range = [t4[r4[0]] * o2, t4[r4[1]] * o2];
          }, s2.isPtWithinRange = "x" !== a2 || i2 ? function() {
            return true;
          } : function(t4) {
            return n3.isPtInside(t4);
          }, s2.setRange(), s2.setScale(), s2;
        }, N.doAutoRange = function(t3, e3) {
          var r3 = this, n3 = r3.gd, i2 = r3.radialAxis, a2 = r3.getRadial(e3);
          v(n3, i2);
          var o2 = i2.range;
          a2.range = o2.slice(), a2._input.range = o2.slice(), i2._rl = [i2.r2l(o2[0], null, "gregorian"), i2.r2l(o2[1], null, "gregorian")];
        }, N.updateRadialAxis = function(t3, e3) {
          var r3 = this, n3 = r3.gd, i2 = r3.layers, a2 = r3.radius, c2 = r3.innerRadius, f3 = r3.cx, p3 = r3.cy, d3 = r3.getRadial(e3), v2 = z(r3.getSector(e3)[0], 360), g3 = r3.radialAxis, y2 = c2 < a2, m3 = r3.isSmith;
          m3 || (r3.fillViewInitialKey("radialaxis.angle", d3.angle), r3.fillViewInitialKey("radialaxis.range", g3.range.slice()), g3.setGeometry()), "auto" === g3.tickangle && v2 > 90 && v2 <= 270 && (g3.tickangle = 180);
          var x2 = m3 ? function(t4) {
            var e4 = I(r3, C([t4.x, 0]));
            return l(e4[0] - f3, e4[1] - p3);
          } : function(t4) {
            return l(g3.l2p(t4.x) + c2, 0);
          }, b2 = m3 ? function(t4) {
            return O(r3, t4.x, -1 / 0, 1 / 0);
          } : function(t4) {
            return r3.pathArc(g3.r2p(t4.x) + c2);
          }, _2 = j(d3);
          if (r3.radialTickLayout !== _2 && (i2["radial-axis"].selectAll(".xtick").remove(), r3.radialTickLayout = _2), y2) {
            g3.setScale();
            var w3 = 0, T2 = m3 ? (g3.tickvals || []).filter(function(t4) {
              return t4 >= 0;
            }).map(function(t4) {
              return h.tickText(g3, t4, true, false);
            }) : h.calcTicks(g3), k2 = m3 ? T2 : h.clipEnds(g3, T2), A2 = h.getTickSigns(g3)[2];
            m3 && (("top" === g3.ticks && "bottom" === g3.side || "bottom" === g3.ticks && "top" === g3.side) && (A2 = -A2), "top" === g3.ticks && "top" === g3.side && (w3 = -g3.ticklen), "bottom" === g3.ticks && "bottom" === g3.side && (w3 = g3.ticklen)), h.drawTicks(n3, g3, { vals: T2, layer: i2["radial-axis"], path: h.makeTickPath(g3, 0, A2), transFn: x2, crisp: false }), h.drawGrid(n3, g3, { vals: k2, layer: i2["radial-grid"], path: b2, transFn: o.noop, crisp: false }), h.drawLabels(n3, g3, { vals: T2, layer: i2["radial-axis"], transFn: x2, labelFns: h.makeLabelFns(g3, w3) });
          }
          var M2 = r3.radialAxisAngle = r3.vangles ? F(U(R(d3.angle), r3.vangles)) : d3.angle, S2 = l(f3, p3), E2 = S2 + s(-M2);
          V(i2["radial-axis"], y2 && (d3.showticklabels || d3.ticks), { transform: E2 }), V(i2["radial-grid"], y2 && d3.showgrid, { transform: m3 ? "" : S2 }), V(i2["radial-line"].select("line"), y2 && d3.showline, { x1: m3 ? -a2 : c2, y1: 0, x2: a2, y2: 0, transform: E2 }).attr("stroke-width", d3.linewidth).call(u.stroke, d3.linecolor);
        }, N.updateRadialAxisTitle = function(t3, e3, r3) {
          if (!this.isSmith) {
            var n3 = this, i2 = n3.gd, a2 = n3.radius, o2 = n3.cx, s2 = n3.cy, l2 = n3.getRadial(e3), u2 = n3.id + "title", f3 = 0;
            if (l2.title) {
              var h2 = c.bBox(n3.layers["radial-axis"].node()).height, p3 = l2.title.font.size, d3 = l2.side;
              f3 = "top" === d3 ? p3 : "counterclockwise" === d3 ? -(h2 + 0.4 * p3) : h2 + 0.8 * p3;
            }
            var v2 = void 0 !== r3 ? r3 : n3.radialAxisAngle, g3 = R(v2), y2 = Math.cos(g3), m3 = Math.sin(g3), b2 = o2 + a2 / 2 * y2 + f3 * m3, _2 = s2 - a2 / 2 * m3 + f3 * y2;
            n3.layers["radial-axis-title"] = x.draw(i2, u2, { propContainer: l2, propName: n3.id + ".radialaxis.title", placeholder: D(i2, "Click to enter radial axis title"), attributes: { x: b2, y: _2, "text-anchor": "middle" }, transform: { rotate: -v2 } });
          }
        }, N.updateAngularAxis = function(t3, e3) {
          var r3 = this, n3 = r3.gd, i2 = r3.layers, a2 = r3.radius, c2 = r3.innerRadius, f3 = r3.cx, p3 = r3.cy, d3 = r3.getAngular(e3), v2 = r3.angularAxis, g3 = r3.isSmith;
          g3 || (r3.fillViewInitialKey("angularaxis.rotation", d3.rotation), v2.setGeometry(), v2.setScale());
          var y2 = g3 ? function(t4) {
            var e4 = I(r3, C([0, t4.x]));
            return Math.atan2(e4[0] - f3, e4[1] - p3) - Math.PI / 2;
          } : function(t4) {
            return v2.t2g(t4.x);
          };
          "linear" === v2.type && "radians" === v2.thetaunit && (v2.tick0 = F(v2.tick0), v2.dtick = F(v2.dtick));
          var m3 = function(t4) {
            return l(f3 + a2 * Math.cos(t4), p3 - a2 * Math.sin(t4));
          }, x2 = g3 ? function(t4) {
            var e4 = I(r3, C([0, t4.x]));
            return l(e4[0], e4[1]);
          } : function(t4) {
            return m3(y2(t4));
          }, b2 = g3 ? function(t4) {
            var e4 = I(r3, C([0, t4.x])), n4 = Math.atan2(e4[0] - f3, e4[1] - p3) - Math.PI / 2;
            return l(e4[0], e4[1]) + s(-F(n4));
          } : function(t4) {
            var e4 = y2(t4);
            return m3(e4) + s(-F(e4));
          }, _2 = g3 ? function(t4) {
            return P(r3, t4.x, 0, 1 / 0);
          } : function(t4) {
            var e4 = y2(t4), r4 = Math.cos(e4), n4 = Math.sin(e4);
            return "M" + [f3 + c2 * r4, p3 - c2 * n4] + "L" + [f3 + a2 * r4, p3 - a2 * n4];
          }, w3 = h.makeLabelFns(v2, 0).labelStandoff, T2 = { xFn: function(t4) {
            var e4 = y2(t4);
            return Math.cos(e4) * w3;
          }, yFn: function(t4) {
            var e4 = y2(t4), r4 = Math.sin(e4) > 0 ? 0.2 : 1;
            return -Math.sin(e4) * (w3 + t4.fontSize * r4) + Math.abs(Math.cos(e4)) * (t4.fontSize * M);
          }, anchorFn: function(t4) {
            var e4 = y2(t4), r4 = Math.cos(e4);
            return Math.abs(r4) < 0.1 ? "middle" : r4 > 0 ? "start" : "end";
          }, heightFn: function(t4, e4, r4) {
            var n4 = y2(t4);
            return -0.5 * (1 + Math.sin(n4)) * r4;
          } }, k2 = j(d3);
          r3.angularTickLayout !== k2 && (i2["angular-axis"].selectAll("." + v2._id + "tick").remove(), r3.angularTickLayout = k2);
          var A2, S2 = g3 ? [1 / 0].concat(v2.tickvals || []).map(function(t4) {
            return h.tickText(v2, t4, true, false);
          }) : h.calcTicks(v2);
          if (g3 && (S2[0].text = "∞", S2[0].fontSize *= 1.75), "linear" === e3.gridshape ? (A2 = S2.map(y2), o.angleDelta(A2[0], A2[1]) < 0 && (A2 = A2.slice().reverse())) : A2 = null, r3.vangles = A2, "category" === v2.type && (S2 = S2.filter(function(t4) {
            return o.isAngleInsideSector(y2(t4), r3.sectorInRad);
          })), v2.visible) {
            var E2 = "inside" === v2.ticks ? -1 : 1, L2 = (v2.linewidth || 1) / 2;
            h.drawTicks(n3, v2, { vals: S2, layer: i2["angular-axis"], path: "M" + E2 * L2 + ",0h" + E2 * v2.ticklen, transFn: b2, crisp: false }), h.drawGrid(n3, v2, { vals: S2, layer: i2["angular-grid"], path: _2, transFn: o.noop, crisp: false }), h.drawLabels(n3, v2, { vals: S2, layer: i2["angular-axis"], repositionOnUpdate: true, transFn: x2, labelFns: T2 });
          }
          V(i2["angular-line"].select("path"), d3.showline, { d: r3.pathSubplot(), transform: l(f3, p3) }).attr("stroke-width", d3.linewidth).call(u.stroke, d3.linecolor);
        }, N.updateFx = function(t3, e3) {
          this.gd._context.staticPlot || (!this.isSmith && (this.updateAngularDrag(t3), this.updateRadialDrag(t3, e3, 0), this.updateRadialDrag(t3, e3, 1)), this.updateHoverAndMainDrag(t3));
        }, N.updateHoverAndMainDrag = function(t3) {
          var e3, r3, s2 = this, u2 = s2.isSmith, c2 = s2.gd, f3 = s2.layers, h2 = t3._zoomlayer, p3 = S.MINZOOM, d3 = S.OFFEDGE, v2 = s2.radius, x2 = s2.innerRadius, T2 = s2.cx, k2 = s2.cy, A2 = s2.cxx, M2 = s2.cyy, L2 = s2.sectorInRad, C2 = s2.vangles, P2 = s2.radialAxis, O2 = E.clampTiny, I2 = E.findXYatLength, D2 = E.findEnclosingVertexAngles, z2 = S.cornerHalfWidth, R2 = S.cornerLen / 2, F2 = g2.makeDragger(f3, "path", "maindrag", false === t3.dragmode ? "none" : "crosshair");
          n2.select(F2).attr("d", s2.pathSubplot()).attr("transform", l(T2, k2)), F2.onmousemove = function(t4) {
            m2.hover(c2, t4, s2.id), c2._fullLayout._lasthover = F2, c2._fullLayout._hoversubplot = s2.id;
          }, F2.onmouseout = function(t4) {
            c2._dragging || y.unhover(c2, t4);
          };
          var B2, N2, j2, U2, V2, H, q2, G, Z, Y = { element: F2, gd: c2, subplot: s2.id, plotinfo: { id: s2.id, xaxis: s2.xaxis, yaxis: s2.yaxis }, xaxes: [s2.xaxis], yaxes: [s2.yaxis] };
          function W(t4, e4) {
            return Math.sqrt(t4 * t4 + e4 * e4);
          }
          function X(t4, e4) {
            return W(t4 - A2, e4 - M2);
          }
          function J(t4, e4) {
            return Math.atan2(M2 - e4, t4 - A2);
          }
          function K(t4, e4) {
            return [t4 * Math.cos(e4), t4 * Math.sin(-e4)];
          }
          function $(t4, e4) {
            if (0 === t4)
              return s2.pathSector(2 * z2);
            var r4 = R2 / t4, n3 = e4 - r4, i2 = e4 + r4, a2 = Math.max(0, Math.min(t4, v2)), o2 = a2 - z2, l2 = a2 + z2;
            return "M" + K(o2, n3) + "A" + [o2, o2] + " 0,0,0 " + K(o2, i2) + "L" + K(l2, i2) + "A" + [l2, l2] + " 0,0,1 " + K(l2, n3) + "Z";
          }
          function Q(t4, e4, r4) {
            if (0 === t4)
              return s2.pathSector(2 * z2);
            var n3, i2, a2 = K(t4, e4), o2 = K(t4, r4), l2 = O2((a2[0] + o2[0]) / 2), u3 = O2((a2[1] + o2[1]) / 2);
            if (l2 && u3) {
              var c3 = u3 / l2, f4 = -1 / c3, h3 = I2(z2, c3, l2, u3);
              n3 = I2(R2, f4, h3[0][0], h3[0][1]), i2 = I2(R2, f4, h3[1][0], h3[1][1]);
            } else {
              var p4, d4;
              u3 ? (p4 = R2, d4 = z2) : (p4 = z2, d4 = R2), n3 = [[l2 - p4, u3 - d4], [l2 + p4, u3 - d4]], i2 = [[l2 - p4, u3 + d4], [l2 + p4, u3 + d4]];
            }
            return "M" + n3.join("L") + "L" + i2.reverse().join("L") + "Z";
          }
          function tt(t4, e4) {
            return e4 = Math.max(Math.min(e4, v2), x2), t4 < d3 ? t4 = 0 : v2 - t4 < d3 ? t4 = v2 : e4 < d3 ? e4 = 0 : v2 - e4 < d3 && (e4 = v2), Math.abs(e4 - t4) > p3 ? (t4 < e4 ? (j2 = t4, U2 = e4) : (j2 = e4, U2 = t4), true) : (j2 = null, U2 = null, false);
          }
          function et(t4, e4) {
            t4 = t4 || V2, e4 = e4 || "M0,0Z", G.attr("d", t4), Z.attr("d", e4), g2.transitionZoombox(G, Z, H, q2), H = true;
            var r4 = {};
            ot(r4), c2.emit("plotly_relayouting", r4);
          }
          function rt(t4, n3) {
            var i2, a2, o2 = B2 + (t4 *= e3), l2 = N2 + (n3 *= r3), u3 = X(B2, N2), c3 = Math.min(X(o2, l2), v2), f4 = J(B2, N2);
            tt(u3, c3) && (i2 = V2 + s2.pathSector(U2), j2 && (i2 += s2.pathSector(j2)), a2 = $(j2, f4) + $(U2, f4)), et(i2, a2);
          }
          function nt(t4, e4, r4, n3) {
            var i2 = E.findIntersectionXY(r4, n3, r4, [t4 - A2, M2 - e4]);
            return W(i2[0], i2[1]);
          }
          function it(t4, e4) {
            var r4, n3, i2 = B2 + t4, a2 = N2 + e4, o2 = J(B2, N2), l2 = J(i2, a2), u3 = D2(o2, C2), c3 = D2(l2, C2);
            tt(nt(B2, N2, u3[0], u3[1]), Math.min(nt(i2, a2, c3[0], c3[1]), v2)) && (r4 = V2 + s2.pathSector(U2), j2 && (r4 += s2.pathSector(j2)), n3 = [Q(j2, u3[0], u3[1]), Q(U2, u3[0], u3[1])].join(" ")), et(r4, n3);
          }
          function at() {
            if (g2.removeZoombox(c2), null !== j2 && null !== U2) {
              var t4 = {};
              ot(t4), g2.showDoubleClickNotifier(c2), a.call("_guiRelayout", c2, t4);
            }
          }
          function ot(t4) {
            var e4 = P2._rl, r4 = (e4[1] - e4[0]) / (1 - x2 / v2) / v2, n3 = [e4[0] + (j2 - x2) * r4, e4[0] + (U2 - x2) * r4];
            t4[s2.id + ".radialaxis.range"] = n3;
          }
          function st(t4, e4) {
            var r4 = c2._fullLayout.clickmode;
            if (g2.removeZoombox(c2), 2 === t4) {
              var n3 = {};
              for (var i2 in s2.viewInitial)
                n3[s2.id + "." + i2] = s2.viewInitial[i2];
              c2.emit("plotly_doubleclick", null), a.call("_guiRelayout", c2, n3);
            }
            r4.indexOf("select") > -1 && 1 === t4 && _(e4, c2, [s2.xaxis], [s2.yaxis], s2.id, Y), r4.indexOf("event") > -1 && m2.click(c2, e4, s2.id);
          }
          Y.prepFn = function(t4, n3, a2) {
            var l2 = c2._fullLayout.dragmode, f4 = F2.getBoundingClientRect();
            c2._fullLayout._calcInverseTransform(c2);
            var p4 = c2._fullLayout._invTransform;
            e3 = c2._fullLayout._invScaleX, r3 = c2._fullLayout._invScaleY;
            var d4 = o.apply3DTransform(p4)(n3 - f4.left, a2 - f4.top);
            if (B2 = d4[0], N2 = d4[1], C2) {
              var y2 = E.findPolygonOffset(v2, L2[0], L2[1], C2);
              B2 += A2 + y2[0], N2 += M2 + y2[1];
            }
            switch (l2) {
              case "zoom":
                Y.clickFn = st, u2 || (Y.moveFn = C2 ? it : rt, Y.doneFn = at, function() {
                  j2 = null, U2 = null, V2 = s2.pathSubplot(), H = false;
                  var t5 = c2._fullLayout[s2.id];
                  q2 = i(t5.bgcolor).getLuminance(), (G = g2.makeZoombox(h2, q2, T2, k2, V2)).attr("fill-rule", "evenodd"), Z = g2.makeCorners(h2, T2, k2), w2(c2);
                }());
                break;
              case "select":
              case "lasso":
                b(t4, n3, a2, Y, l2);
            }
          }, y.init(Y);
        }, N.updateRadialDrag = function(t3, e3, r3) {
          var i2 = this, u2 = i2.gd, c2 = i2.layers, f3 = i2.radius, h2 = i2.innerRadius, p3 = i2.cx, d3 = i2.cy, v2 = i2.radialAxis, m3 = S.radialDragBoxSize, x2 = m3 / 2;
          if (v2.visible) {
            var b2, _2, T2, M2 = R(i2.radialAxisAngle), E2 = v2._rl, L2 = E2[0], C2 = E2[1], P2 = E2[r3], O2 = 0.75 * (E2[1] - E2[0]) / (1 - i2.getHole(e3)) / f3;
            r3 ? (b2 = p3 + (f3 + x2) * Math.cos(M2), _2 = d3 - (f3 + x2) * Math.sin(M2), T2 = "radialdrag") : (b2 = p3 + (h2 - x2) * Math.cos(M2), _2 = d3 - (h2 - x2) * Math.sin(M2), T2 = "radialdrag-inner");
            var I2, D2, z2, B2 = g2.makeRectDragger(c2, T2, "crosshair", -x2, -x2, m3, m3), N2 = { element: B2, gd: u2 };
            false === t3.dragmode && (N2.dragmode = false), V(n2.select(B2), v2.visible && h2 < f3, { transform: l(b2, _2) }), N2.prepFn = function() {
              I2 = null, D2 = null, z2 = null, N2.moveFn = j2, N2.doneFn = H, w2(u2);
            }, N2.clampFn = function(t4, e4) {
              return Math.sqrt(t4 * t4 + e4 * e4) < S.MINDRAG && (t4 = 0, e4 = 0), [t4, e4];
            }, y.init(N2);
          }
          function j2(t4, e4) {
            if (I2)
              I2(t4, e4);
            else {
              var n3 = [t4, -e4], a2 = [Math.cos(M2), Math.sin(M2)], s2 = Math.abs(o.dot(n3, a2) / Math.sqrt(o.dot(n3, n3)));
              isNaN(s2) || (I2 = s2 < 0.5 ? q2 : G);
            }
            var l2 = {};
            !function(t5) {
              null !== D2 ? t5[i2.id + ".radialaxis.angle"] = D2 : null !== z2 && (t5[i2.id + ".radialaxis.range[" + r3 + "]"] = z2);
            }(l2), u2.emit("plotly_relayouting", l2);
          }
          function H() {
            null !== D2 ? a.call("_guiRelayout", u2, i2.id + ".radialaxis.angle", D2) : null !== z2 && a.call("_guiRelayout", u2, i2.id + ".radialaxis.range[" + r3 + "]", z2);
          }
          function q2(t4, e4) {
            if (0 !== r3) {
              var n3 = b2 + t4, a2 = _2 + e4;
              D2 = Math.atan2(d3 - a2, n3 - p3), i2.vangles && (D2 = U(D2, i2.vangles)), D2 = F(D2);
              var o2 = l(p3, d3) + s(-D2);
              c2["radial-axis"].attr("transform", o2), c2["radial-line"].select("line").attr("transform", o2);
              var u3 = i2.gd._fullLayout, f4 = u3[i2.id];
              i2.updateRadialAxisTitle(u3, f4, D2);
            }
          }
          function G(t4, e4) {
            var n3 = o.dot([t4, -e4], [Math.cos(M2), Math.sin(M2)]);
            if (z2 = P2 - O2 * n3, O2 > 0 == (r3 ? z2 > L2 : z2 < C2)) {
              var s2 = u2._fullLayout, l2 = s2[i2.id];
              v2.range[r3] = z2, v2._rl[r3] = z2, i2.updateRadialAxis(s2, l2), i2.xaxis.setRange(), i2.xaxis.setScale(), i2.yaxis.setRange(), i2.yaxis.setScale();
              var c3 = false;
              for (var f4 in i2.traceHash) {
                var h3 = i2.traceHash[f4], p4 = o.filterVisible(h3);
                h3[0][0].trace._module.plot(u2, i2, p4, l2), a.traceIs(f4, "gl") && p4.length && (c3 = true);
              }
              c3 && (k(u2), A(u2));
            } else
              z2 = null;
          }
        }, N.updateAngularDrag = function(t3) {
          var e3 = this, r3 = e3.gd, i2 = e3.layers, u2 = e3.radius, f3 = e3.angularAxis, h2 = e3.cx, p3 = e3.cy, d3 = e3.cxx, v2 = e3.cyy, m3 = S.angularDragBoxSize, x2 = g2.makeDragger(i2, "path", "angulardrag", false === t3.dragmode ? "none" : "move"), b2 = { element: x2, gd: r3 };
          function _2(t4, e4) {
            return Math.atan2(v2 + m3 - e4, t4 - d3 - m3);
          }
          false === t3.dragmode ? b2.dragmode = false : n2.select(x2).attr("d", e3.pathAnnulus(u2, u2 + m3)).attr("transform", l(h2, p3)).call(T, "move");
          var M2, E2, L2, C2, P2, O2, I2 = i2.frontplot.select(".scatterlayer").selectAll(".trace"), D2 = I2.selectAll(".point"), z2 = I2.selectAll(".textpoint");
          function R2(u3, g3) {
            var y2 = e3.gd._fullLayout, m4 = y2[e3.id], x3 = _2(M2 + u3 * t3._invScaleX, E2 + g3 * t3._invScaleY), b3 = F(x3 - O2);
            if (C2 = L2 + b3, i2.frontplot.attr("transform", l(e3.xOffset2, e3.yOffset2) + s([-b3, d3, v2])), e3.vangles) {
              P2 = e3.radialAxisAngle + b3;
              var w3 = l(h2, p3) + s(-b3), T2 = l(h2, p3) + s(-P2);
              i2.bg.attr("transform", w3), i2["radial-grid"].attr("transform", w3), i2["radial-axis"].attr("transform", T2), i2["radial-line"].select("line").attr("transform", T2), e3.updateRadialAxisTitle(y2, m4, P2);
            } else
              e3.clipPaths.forTraces.select("path").attr("transform", l(d3, v2) + s(b3));
            D2.each(function() {
              var t4 = n2.select(this), e4 = c.getTranslate(t4);
              t4.attr("transform", l(e4.x, e4.y) + s([b3]));
            }), z2.each(function() {
              var t4 = n2.select(this), e4 = t4.select("text"), r4 = c.getTranslate(t4);
              t4.attr("transform", s([b3, e4.attr("x"), e4.attr("y")]) + l(r4.x, r4.y));
            }), f3.rotation = o.modHalf(C2, 360), e3.updateAngularAxis(y2, m4), e3._hasClipOnAxisFalse && !o.isFullCircle(e3.sectorInRad) && I2.call(c.hideOutsideRangePoints, e3);
            var S2 = false;
            for (var R3 in e3.traceHash)
              if (a.traceIs(R3, "gl")) {
                var N3 = e3.traceHash[R3], j2 = o.filterVisible(N3);
                N3[0][0].trace._module.plot(r3, e3, j2, m4), j2.length && (S2 = true);
              }
            S2 && (k(r3), A(r3));
            var U2 = {};
            B2(U2), r3.emit("plotly_relayouting", U2);
          }
          function B2(t4) {
            t4[e3.id + ".angularaxis.rotation"] = C2, e3.vangles && (t4[e3.id + ".radialaxis.angle"] = P2);
          }
          function N2() {
            z2.select("text").attr("transform", null);
            var t4 = {};
            B2(t4), a.call("_guiRelayout", r3, t4);
          }
          b2.prepFn = function(n3, i3, a2) {
            var s2 = t3[e3.id];
            L2 = s2.angularaxis.rotation;
            var l2 = x2.getBoundingClientRect();
            M2 = i3 - l2.left, E2 = a2 - l2.top, r3._fullLayout._calcInverseTransform(r3);
            var u3 = o.apply3DTransform(t3._invTransform)(M2, E2);
            M2 = u3[0], E2 = u3[1], O2 = _2(M2, E2), b2.moveFn = R2, b2.doneFn = N2, w2(r3);
          }, e3.vangles && !o.isFullCircle(e3.sectorInRad) && (b2.prepFn = o.noop, T(n2.select(x2), null)), y.init(b2);
        }, N.isPtInside = function(t3) {
          if (this.isSmith)
            return true;
          var e3 = this.sectorInRad, r3 = this.vangles, n3 = this.angularAxis.c2g(t3.theta), i2 = this.radialAxis, a2 = i2.c2l(t3.r), s2 = i2._rl;
          return (r3 ? E.isPtInsidePolygon : o.isPtInsideSector)(a2, n3, s2, e3, r3);
        }, N.pathArc = function(t3) {
          var e3 = this.sectorInRad, r3 = this.vangles;
          return (r3 ? E.pathPolygon : o.pathArc)(t3, e3[0], e3[1], r3);
        }, N.pathSector = function(t3) {
          var e3 = this.sectorInRad, r3 = this.vangles;
          return (r3 ? E.pathPolygon : o.pathSector)(t3, e3[0], e3[1], r3);
        }, N.pathAnnulus = function(t3, e3) {
          var r3 = this.sectorInRad, n3 = this.vangles;
          return (n3 ? E.pathPolygonAnnulus : o.pathAnnulus)(t3, e3, r3[0], r3[1], n3);
        }, N.pathSubplot = function() {
          var t3 = this.innerRadius, e3 = this.radius;
          return t3 ? this.pathAnnulus(t3, e3) : this.pathSector(e3);
        }, N.fillViewInitialKey = function(t3, e3) {
          t3 in this.viewInitial || (this.viewInitial[t3] = e3);
        };
      }, 12101: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(21994), a = n2.deg2rad, o = n2.rad2deg;
        t2.exports = function(t3, e3, r3) {
          switch (i(t3, r3), t3._id) {
            case "x":
            case "radialaxis":
              !function(t4, e4) {
                var r4 = e4._subplot;
                t4.setGeometry = function() {
                  var e5 = t4._rl[0], n3 = t4._rl[1], i2 = r4.innerRadius, a2 = (r4.radius - i2) / (n3 - e5), o2 = i2 / a2, s = e5 > n3 ? function(t5) {
                    return t5 <= 0;
                  } : function(t5) {
                    return t5 >= 0;
                  };
                  t4.c2g = function(r5) {
                    var n4 = t4.c2l(r5) - e5;
                    return (s(n4) ? n4 : 0) + o2;
                  }, t4.g2c = function(r5) {
                    return t4.l2c(r5 + e5 - o2);
                  }, t4.g2p = function(t5) {
                    return t5 * a2;
                  }, t4.c2p = function(e6) {
                    return t4.g2p(t4.c2g(e6));
                  };
                };
              }(t3, e3);
              break;
            case "angularaxis":
              !function(t4, e4) {
                var r4 = t4.type;
                if ("linear" === r4) {
                  var i2 = t4.d2c, s = t4.c2d;
                  t4.d2c = function(t5, e5) {
                    return function(t6, e6) {
                      return "degrees" === e6 ? a(t6) : t6;
                    }(i2(t5), e5);
                  }, t4.c2d = function(t5, e5) {
                    return s(function(t6, e6) {
                      return "degrees" === e6 ? o(t6) : t6;
                    }(t5, e5));
                  };
                }
                t4.makeCalcdata = function(e5, i3) {
                  var a2, o2, s2 = e5[i3], l = e5._length, u = function(r5) {
                    return t4.d2c(r5, e5.thetaunit);
                  };
                  if (s2) {
                    if (n2.isTypedArray(s2) && "linear" === r4) {
                      if (l === s2.length)
                        return s2;
                      if (s2.subarray)
                        return s2.subarray(0, l);
                    }
                    for (a2 = new Array(l), o2 = 0; o2 < l; o2++)
                      a2[o2] = u(s2[o2]);
                  } else {
                    var c = i3 + "0", f2 = "d" + i3, h = c in e5 ? u(e5[c]) : 0, p2 = e5[f2] ? u(e5[f2]) : (t4.period || 2 * Math.PI) / l;
                    for (a2 = new Array(l), o2 = 0; o2 < l; o2++)
                      a2[o2] = h + o2 * p2;
                  }
                  return a2;
                }, t4.setGeometry = function() {
                  var i3, s2, l, u, c = e4.sector, f2 = c.map(a), h = { clockwise: -1, counterclockwise: 1 }[t4.direction], p2 = a(t4.rotation), d2 = function(t5) {
                    return h * t5 + p2;
                  }, v = function(t5) {
                    return (t5 - p2) / h;
                  };
                  switch (r4) {
                    case "linear":
                      s2 = i3 = n2.identity, u = a, l = o, t4.range = n2.isFullCircle(f2) ? [c[0], c[0] + 360] : f2.map(v).map(o);
                      break;
                    case "category":
                      var g2 = t4._categories.length, y = t4.period ? Math.max(t4.period, g2) : g2;
                      0 === y && (y = 1), s2 = u = function(t5) {
                        return 2 * t5 * Math.PI / y;
                      }, i3 = l = function(t5) {
                        return t5 * y / Math.PI / 2;
                      }, t4.range = [0, y];
                  }
                  t4.c2g = function(t5) {
                    return d2(s2(t5));
                  }, t4.g2c = function(t5) {
                    return i3(v(t5));
                  }, t4.t2g = function(t5) {
                    return d2(u(t5));
                  }, t4.g2t = function(t5) {
                    return l(v(t5));
                  };
                };
              }(t3, e3);
          }
        };
      }, 39779: function(t2) {
        t2.exports = { attr: "subplot", name: "smith", axisNames: ["realaxis", "imaginaryaxis"], axisName2dataArray: { imaginaryaxis: "imag", realaxis: "real" } };
      }, 23893: function(t2) {
        function e2(t3) {
          return t3 < 0 ? -1 : t3 > 0 ? 1 : 0;
        }
        function r2(t3) {
          var e3 = t3[0], r3 = t3[1];
          if (!isFinite(e3) || !isFinite(r3))
            return [1, 0];
          var n3 = (e3 + 1) * (e3 + 1) + r3 * r3;
          return [(e3 * e3 + r3 * r3 - 1) / n3, 2 * r3 / n3];
        }
        function n2(t3, e3) {
          var r3 = e3[0], n3 = e3[1];
          return [r3 * t3.radius + t3.cx, -n3 * t3.radius + t3.cy];
        }
        function i(t3, e3) {
          return e3 * t3.radius;
        }
        t2.exports = { smith: r2, reactanceArc: function(t3, e3, a, o) {
          var s = n2(t3, r2([a, e3])), l = s[0], u = s[1], c = n2(t3, r2([o, e3])), f2 = c[0], h = c[1];
          if (0 === e3)
            return ["M" + l + "," + u, "L" + f2 + "," + h].join(" ");
          var p2 = i(t3, 1 / Math.abs(e3));
          return ["M" + l + "," + u, "A" + p2 + "," + p2 + " 0 0," + (e3 < 0 ? 1 : 0) + " " + f2 + "," + h].join(" ");
        }, resistanceArc: function(t3, a, o, s) {
          var l = i(t3, 1 / (a + 1)), u = n2(t3, r2([a, o])), c = u[0], f2 = u[1], h = n2(t3, r2([a, s])), p2 = h[0], d2 = h[1];
          if (e2(o) !== e2(s)) {
            var v = n2(t3, r2([a, 0]));
            return ["M" + c + "," + f2, "A" + l + "," + l + " 0 0," + (0 < o ? 0 : 1) + " " + v[0] + "," + v[1], "A" + l + "," + l + " 0 0," + (s < 0 ? 0 : 1) + p2 + "," + d2].join(" ");
          }
          return ["M" + c + "," + f2, "A" + l + "," + l + " 0 0," + (s < o ? 0 : 1) + " " + p2 + "," + d2].join(" ");
        }, smithTransform: n2 };
      }, 7504: function(t2, e2, r2) {
        var n2 = r2(27659).AU, i = r2(71828).counterRegex, a = r2(77997), o = r2(39779), s = o.attr, l = o.name, u = i(l), c = {};
        c[s] = { valType: "subplotid", dflt: l, editType: "calc" }, t2.exports = { attr: s, name: l, idRoot: l, idRegex: u, attrRegex: u, attributes: c, layoutAttributes: r2(33419), supplyLayoutDefaults: r2(9558), plot: function(t3) {
          for (var e3 = t3._fullLayout, r3 = t3.calcdata, i2 = e3._subplots[l], o2 = 0; o2 < i2.length; o2++) {
            var s2 = i2[o2], u2 = n2(r3, l, s2), c2 = e3[s2]._subplot;
            c2 || (c2 = a(t3, s2, true), e3[s2]._subplot = c2), c2.plot(u2, e3, t3._promises);
          }
        }, clean: function(t3, e3, r3, n3) {
          for (var i2 = n3._subplots[l] || [], a2 = 0; a2 < i2.length; a2++) {
            var o2 = i2[a2], s2 = n3[o2]._subplot;
            if (!e3[o2] && s2)
              for (var u2 in s2.framework.remove(), s2.clipPaths)
                s2.clipPaths[u2].remove();
          }
        }, toSVG: r2(93612).toSVG };
      }, 33419: function(t2, e2, r2) {
        var n2 = r2(22399), i = r2(13838), a = r2(27670).Y, o = r2(71828).extendFlat, s = r2(30962).overrideAll, l = s({ color: i.color, showline: o({}, i.showline, { dflt: true }), linecolor: i.linecolor, linewidth: i.linewidth, showgrid: o({}, i.showgrid, { dflt: true }), gridcolor: i.gridcolor, gridwidth: i.gridwidth, griddash: i.griddash }, "plot", "from-root"), u = s({ ticklen: i.ticklen, tickwidth: o({}, i.tickwidth, { dflt: 2 }), tickcolor: i.tickcolor, showticklabels: i.showticklabels, labelalias: i.labelalias, showtickprefix: i.showtickprefix, tickprefix: i.tickprefix, showticksuffix: i.showticksuffix, ticksuffix: i.ticksuffix, tickfont: i.tickfont, tickformat: i.tickformat, hoverformat: i.hoverformat, layer: i.layer }, "plot", "from-root"), c = o({ visible: o({}, i.visible, { dflt: true }), tickvals: { dflt: [0.2, 0.5, 1, 2, 5], valType: "data_array", editType: "plot" }, tickangle: o({}, i.tickangle, { dflt: 90 }), ticks: { valType: "enumerated", values: ["top", "bottom", ""], editType: "ticks" }, side: { valType: "enumerated", values: ["top", "bottom"], dflt: "top", editType: "plot" }, editType: "calc" }, l, u), f2 = o({ visible: o({}, i.visible, { dflt: true }), tickvals: { valType: "data_array", editType: "plot" }, ticks: i.ticks, editType: "calc" }, l, u);
        t2.exports = { domain: a({ name: "smith", editType: "plot" }), bgcolor: { valType: "color", editType: "plot", dflt: n2.background }, realaxis: c, imaginaryaxis: f2, editType: "calc" };
      }, 9558: function(t2, e2, r2) {
        var n2, i, a, o = r2(71828), s = r2(7901), l = r2(44467), u = r2(49119), c = r2(27659).NG, f2 = r2(89426), h = r2(96115), p2 = r2(92128), d2 = r2(21994), v = r2(33419), g2 = r2(39779), y = g2.axisNames, m2 = (n2 = function(t3) {
          return t3.slice().reverse().map(function(t4) {
            return -t4;
          }).concat([0]).concat(t3);
        }, i = String, a = {}, function(t3) {
          var e3 = i ? i(t3) : t3;
          if (e3 in a)
            return a[e3];
          var r3 = n2(t3);
          return a[e3] = r3, r3;
        });
        function x(t3, e3, r3, n3) {
          var i2 = r3("bgcolor");
          n3.bgColor = s.combine(i2, n3.paper_bgcolor);
          var a2, u2 = c(n3.fullData, g2.name, n3.id), x2 = n3.layoutOut;
          function b(t4, e4) {
            return r3(a2 + "." + t4, e4);
          }
          for (var _ = 0; _ < y.length; _++) {
            a2 = y[_], o.isPlainObject(t3[a2]) || (t3[a2] = {});
            var w2 = t3[a2], T = l.newContainer(e3, a2);
            T._id = T._name = a2, T._attr = n3.id + "." + a2, T._traceIndices = u2.map(function(t4) {
              return t4._expandedIndex;
            });
            var k = b("visible");
            if (T.type = "linear", d2(T, x2), f2(w2, T, b, T.type), k) {
              var A, M, S, E, L = "realaxis" === a2;
              L && b("side"), L ? b("tickvals") : b("tickvals", m2(e3.realaxis.tickvals || v.realaxis.tickvals.dflt));
              var C = n3.font || {};
              k && (M = (A = b("color")) === w2.color ? A : C.color, S = C.size, E = C.family), h(w2, T, b, T.type, { noTicklabelstep: true, noAng: !L, noExp: true, font: { color: M, size: S, family: E } }), o.coerce2(t3, e3, v, a2 + ".ticklen"), o.coerce2(t3, e3, v, a2 + ".tickwidth"), o.coerce2(t3, e3, v, a2 + ".tickcolor", e3.color), b("ticks") || (delete e3[a2].ticklen, delete e3[a2].tickwidth, delete e3[a2].tickcolor), p2(w2, T, b, { dfltColor: A, bgColor: n3.bgColor, blend: 60, showLine: true, showGrid: true, noZeroLine: true, attributes: v[a2] }), b("layer");
            }
            b("hoverformat"), delete T.type, T._input = w2;
          }
        }
        t2.exports = function(t3, e3, r3) {
          u(t3, e3, r3, { noUirevision: true, type: g2.name, attributes: v, handleDefaults: x, font: e3.font, paper_bgcolor: e3.paper_bgcolor, fullData: r3, layoutOut: e3 });
        };
      }, 49119: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(44467), a = r2(27670).c;
        t2.exports = function(t3, e3, r3, o) {
          var s, l, u = o.type, c = o.attributes, f2 = o.handleDefaults, h = o.partition || "x", p2 = e3._subplots[u], d2 = p2.length, v = d2 && p2[0].replace(/\d+$/, "");
          function g2(t4, e4) {
            return n2.coerce(s, l, c, t4, e4);
          }
          for (var y = 0; y < d2; y++) {
            var m2 = p2[y];
            s = t3[m2] ? t3[m2] : t3[m2] = {}, l = i.newContainer(e3, m2, v), o.noUirevision || g2("uirevision", e3.uirevision);
            var x = {};
            x[h] = [y / d2, (y + 1) / d2], a(l, e3, g2, x), o.id = m2, f2(s, l, g2, o);
          }
        };
      }, 5386: function(t2, e2, r2) {
        var n2 = r2(31562);
        function i(t3) {
          var e3 = t3.description ? " " + t3.description : "", r3 = t3.keys || [];
          if (r3.length > 0) {
            for (var n3 = [], i2 = 0; i2 < r3.length; i2++)
              n3[i2] = "`" + r3[i2] + "`";
            e3 += "Finally, the template string has access to ", e3 = 1 === r3.length ? "variable " + n3[0] : "variables " + n3.slice(0, -1).join(", ") + " and " + n3.slice(-1) + ".";
          }
          return e3;
        }
        n2.FORMAT_LINK, n2.DATE_FORMAT_LINK, e2.f = function(t3, e3) {
          t3 = t3 || {}, i(e3 = e3 || {});
          var r3 = { valType: "string", dflt: "", editType: t3.editType || "none" };
          return false !== t3.arrayOk && (r3.arrayOk = true), r3;
        }, e2.s = function(t3, e3) {
          t3 = t3 || {}, i(e3 = e3 || {});
          var r3 = { valType: "string", dflt: "", editType: t3.editType || "calc" };
          return false !== t3.arrayOk && (r3.arrayOk = true), r3;
        };
      }, 61639: function(t2, e2, r2) {
        var n2 = r2(64380), i = r2(27659).AU, a = r2(71828).counterRegex, o = "ternary";
        e2.name = o;
        var s = e2.attr = "subplot";
        e2.idRoot = o, e2.idRegex = e2.attrRegex = a(o), (e2.attributes = {})[s] = { valType: "subplotid", dflt: "ternary", editType: "calc" }, e2.layoutAttributes = r2(81367), e2.supplyLayoutDefaults = r2(25369), e2.plot = function(t3) {
          for (var e3 = t3._fullLayout, r3 = t3.calcdata, a2 = e3._subplots.ternary, s2 = 0; s2 < a2.length; s2++) {
            var l = a2[s2], u = i(r3, o, l), c = e3[l]._subplot;
            c || (c = new n2({ id: l, graphDiv: t3, container: e3._ternarylayer.node() }, e3), e3[l]._subplot = c), c.plot(u, e3, t3._promises);
          }
        }, e2.clean = function(t3, e3, r3, n3) {
          for (var i2 = n3._subplots.ternary || [], a2 = 0; a2 < i2.length; a2++) {
            var o2 = i2[a2], s2 = n3[o2]._subplot;
            !e3[o2] && s2 && (s2.plotContainer.remove(), s2.clipDef.remove(), s2.clipDefRelative.remove(), s2.layers["a-title"].remove(), s2.layers["b-title"].remove(), s2.layers["c-title"].remove());
          }
        };
      }, 81367: function(t2, e2, r2) {
        var n2 = r2(22399), i = r2(27670).Y, a = r2(13838), o = r2(30962).overrideAll, s = r2(1426).extendFlat, l = { title: { text: a.title.text, font: a.title.font }, color: a.color, tickmode: a.minor.tickmode, nticks: s({}, a.nticks, { dflt: 6, min: 1 }), tick0: a.tick0, dtick: a.dtick, tickvals: a.tickvals, ticktext: a.ticktext, ticks: a.ticks, ticklen: a.ticklen, tickwidth: a.tickwidth, tickcolor: a.tickcolor, ticklabelstep: a.ticklabelstep, showticklabels: a.showticklabels, labelalias: a.labelalias, showtickprefix: a.showtickprefix, tickprefix: a.tickprefix, showticksuffix: a.showticksuffix, ticksuffix: a.ticksuffix, showexponent: a.showexponent, exponentformat: a.exponentformat, minexponent: a.minexponent, separatethousands: a.separatethousands, tickfont: a.tickfont, tickangle: a.tickangle, tickformat: a.tickformat, tickformatstops: a.tickformatstops, hoverformat: a.hoverformat, showline: s({}, a.showline, { dflt: true }), linecolor: a.linecolor, linewidth: a.linewidth, showgrid: s({}, a.showgrid, { dflt: true }), gridcolor: a.gridcolor, gridwidth: a.gridwidth, griddash: a.griddash, layer: a.layer, min: { valType: "number", dflt: 0, min: 0 }, _deprecated: { title: a._deprecated.title, titlefont: a._deprecated.titlefont } }, u = t2.exports = o({ domain: i({ name: "ternary" }), bgcolor: { valType: "color", dflt: n2.background }, sum: { valType: "number", dflt: 1, min: 0 }, aaxis: l, baxis: l, caxis: l }, "plot", "from-root");
        u.uirevision = { valType: "any", editType: "none" }, u.aaxis.uirevision = u.baxis.uirevision = u.caxis.uirevision = { valType: "any", editType: "none" };
      }, 25369: function(t2, e2, r2) {
        var n2 = r2(7901), i = r2(44467), a = r2(71828), o = r2(49119), s = r2(96115), l = r2(89426), u = r2(38701), c = r2(26218), f2 = r2(92128), h = r2(81367), p2 = ["aaxis", "baxis", "caxis"];
        function d2(t3, e3, r3, a2) {
          var o2, s2, l2, u2 = r3("bgcolor"), c2 = r3("sum");
          a2.bgColor = n2.combine(u2, a2.paper_bgcolor);
          for (var f3 = 0; f3 < p2.length; f3++)
            s2 = t3[o2 = p2[f3]] || {}, (l2 = i.newContainer(e3, o2))._name = o2, v(s2, l2, a2, e3);
          var h2 = e3.aaxis, d3 = e3.baxis, g2 = e3.caxis;
          h2.min + d3.min + g2.min >= c2 && (h2.min = 0, d3.min = 0, g2.min = 0, t3.aaxis && delete t3.aaxis.min, t3.baxis && delete t3.baxis.min, t3.caxis && delete t3.caxis.min);
        }
        function v(t3, e3, r3, n3) {
          var i2 = h[e3._name];
          function o2(r4, n4) {
            return a.coerce(t3, e3, i2, r4, n4);
          }
          o2("uirevision", n3.uirevision), e3.type = "linear";
          var p3 = o2("color"), d3 = p3 !== i2.color.dflt ? p3 : r3.font.color, v2 = e3._name.charAt(0).toUpperCase(), g2 = "Component " + v2, y = o2("title.text", g2);
          e3._hovertitle = y === g2 ? y : v2, a.coerceFont(o2, "title.font", { family: r3.font.family, size: a.bigFont(r3.font.size), color: d3 }), o2("min"), c(t3, e3, o2, "linear"), l(t3, e3, o2, "linear"), s(t3, e3, o2, "linear"), u(t3, e3, o2, { outerTicks: true }), o2("showticklabels") && (a.coerceFont(o2, "tickfont", { family: r3.font.family, size: r3.font.size, color: d3 }), o2("tickangle"), o2("tickformat")), f2(t3, e3, o2, { dfltColor: p3, bgColor: r3.bgColor, blend: 60, showLine: true, showGrid: true, noZeroLine: true, attributes: i2 }), o2("hoverformat"), o2("layer");
        }
        t2.exports = function(t3, e3, r3) {
          o(t3, e3, r3, { type: "ternary", attributes: h, handleDefaults: d2, font: e3.font, paper_bgcolor: e3.paper_bgcolor });
        };
      }, 64380: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(84267), a = r2(73972), o = r2(71828), s = o.strTranslate, l = o._, u = r2(7901), c = r2(91424), f2 = r2(21994), h = r2(1426).extendFlat, p2 = r2(74875), d2 = r2(89298), v = r2(28569), g2 = r2(30211), y = r2(64505), m2 = y.freeMode, x = y.rectMode, b = r2(92998), _ = r2(47322).prepSelect, w2 = r2(47322).selectOnClick, T = r2(47322).clearOutline, k = r2(47322).clearSelectionsCache, A = r2(85555);
        function M(t3, e3) {
          this.id = t3.id, this.graphDiv = t3.graphDiv, this.init(e3), this.makeFramework(e3), this.aTickLayout = null, this.bTickLayout = null, this.cTickLayout = null;
        }
        t2.exports = M;
        var S = M.prototype;
        S.init = function(t3) {
          this.container = t3._ternarylayer, this.defs = t3._defs, this.layoutId = t3._uid, this.traceHash = {}, this.layers = {};
        }, S.plot = function(t3, e3) {
          var r3 = this, n3 = e3[r3.id], i2 = e3._size;
          r3._hasClipOnAxisFalse = false;
          for (var a2 = 0; a2 < t3.length; a2++)
            if (false === t3[a2][0].trace.cliponaxis) {
              r3._hasClipOnAxisFalse = true;
              break;
            }
          r3.updateLayers(n3), r3.adjustLayout(n3, i2), p2.generalUpdatePerTraceModule(r3.graphDiv, r3, t3, n3), r3.layers.plotbg.select("path").call(u.fill, n3.bgcolor);
        }, S.makeFramework = function(t3) {
          var e3 = this, r3 = e3.graphDiv, n3 = t3[e3.id], i2 = e3.clipId = "clip" + e3.layoutId + e3.id, a2 = e3.clipIdRelative = "clip-relative" + e3.layoutId + e3.id;
          e3.clipDef = o.ensureSingleById(t3._clips, "clipPath", i2, function(t4) {
            t4.append("path").attr("d", "M0,0Z");
          }), e3.clipDefRelative = o.ensureSingleById(t3._clips, "clipPath", a2, function(t4) {
            t4.append("path").attr("d", "M0,0Z");
          }), e3.plotContainer = o.ensureSingle(e3.container, "g", e3.id), e3.updateLayers(n3), c.setClipUrl(e3.layers.backplot, i2, r3), c.setClipUrl(e3.layers.grids, i2, r3);
        }, S.updateLayers = function(t3) {
          var e3 = this.layers, r3 = ["draglayer", "plotbg", "backplot", "grids"];
          "below traces" === t3.aaxis.layer && r3.push("aaxis", "aline"), "below traces" === t3.baxis.layer && r3.push("baxis", "bline"), "below traces" === t3.caxis.layer && r3.push("caxis", "cline"), r3.push("frontplot"), "above traces" === t3.aaxis.layer && r3.push("aaxis", "aline"), "above traces" === t3.baxis.layer && r3.push("baxis", "bline"), "above traces" === t3.caxis.layer && r3.push("caxis", "cline");
          var i2 = this.plotContainer.selectAll("g.toplevel").data(r3, String), a2 = ["agrid", "bgrid", "cgrid"];
          i2.enter().append("g").attr("class", function(t4) {
            return "toplevel " + t4;
          }).each(function(t4) {
            var r4 = n2.select(this);
            e3[t4] = r4, "frontplot" === t4 ? r4.append("g").classed("scatterlayer", true) : "backplot" === t4 ? r4.append("g").classed("maplayer", true) : "plotbg" === t4 ? r4.append("path").attr("d", "M0,0Z") : "aline" === t4 || "bline" === t4 || "cline" === t4 ? r4.append("path") : "grids" === t4 && a2.forEach(function(t5) {
              e3[t5] = r4.append("g").classed("grid " + t5, true);
            });
          }), i2.order();
        };
        var E = Math.sqrt(4 / 3);
        S.adjustLayout = function(t3, e3) {
          var r3, n3, i2, a2, o2, l2, p3 = this, d3 = t3.domain, v2 = (d3.x[0] + d3.x[1]) / 2, g3 = (d3.y[0] + d3.y[1]) / 2, y2 = d3.x[1] - d3.x[0], m3 = d3.y[1] - d3.y[0], x2 = y2 * e3.w, b2 = m3 * e3.h, _2 = t3.sum, w3 = t3.aaxis.min, T2 = t3.baxis.min, k2 = t3.caxis.min;
          x2 > E * b2 ? i2 = (a2 = b2) * E : a2 = (i2 = x2) / E, o2 = y2 * i2 / x2, l2 = m3 * a2 / b2, r3 = e3.l + e3.w * v2 - i2 / 2, n3 = e3.t + e3.h * (1 - g3) - a2 / 2, p3.x0 = r3, p3.y0 = n3, p3.w = i2, p3.h = a2, p3.sum = _2, p3.xaxis = { type: "linear", range: [w3 + 2 * k2 - _2, _2 - w3 - 2 * T2], domain: [v2 - o2 / 2, v2 + o2 / 2], _id: "x" }, f2(p3.xaxis, p3.graphDiv._fullLayout), p3.xaxis.setScale(), p3.xaxis.isPtWithinRange = function(t4) {
            return t4.a >= p3.aaxis.range[0] && t4.a <= p3.aaxis.range[1] && t4.b >= p3.baxis.range[1] && t4.b <= p3.baxis.range[0] && t4.c >= p3.caxis.range[1] && t4.c <= p3.caxis.range[0];
          }, p3.yaxis = { type: "linear", range: [w3, _2 - T2 - k2], domain: [g3 - l2 / 2, g3 + l2 / 2], _id: "y" }, f2(p3.yaxis, p3.graphDiv._fullLayout), p3.yaxis.setScale(), p3.yaxis.isPtWithinRange = function() {
            return true;
          };
          var A2 = p3.yaxis.domain[0], M2 = p3.aaxis = h({}, t3.aaxis, { range: [w3, _2 - T2 - k2], side: "left", tickangle: (+t3.aaxis.tickangle || 0) - 30, domain: [A2, A2 + l2 * E], anchor: "free", position: 0, _id: "y", _length: i2 });
          f2(M2, p3.graphDiv._fullLayout), M2.setScale();
          var S2 = p3.baxis = h({}, t3.baxis, { range: [_2 - w3 - k2, T2], side: "bottom", domain: p3.xaxis.domain, anchor: "free", position: 0, _id: "x", _length: i2 });
          f2(S2, p3.graphDiv._fullLayout), S2.setScale();
          var L2 = p3.caxis = h({}, t3.caxis, { range: [_2 - w3 - T2, k2], side: "right", tickangle: (+t3.caxis.tickangle || 0) + 30, domain: [A2, A2 + l2 * E], anchor: "free", position: 0, _id: "y", _length: i2 });
          f2(L2, p3.graphDiv._fullLayout), L2.setScale();
          var C2 = "M" + r3 + "," + (n3 + a2) + "h" + i2 + "l-" + i2 / 2 + ",-" + a2 + "Z";
          p3.clipDef.select("path").attr("d", C2), p3.layers.plotbg.select("path").attr("d", C2);
          var P2 = "M0," + a2 + "h" + i2 + "l-" + i2 / 2 + ",-" + a2 + "Z";
          p3.clipDefRelative.select("path").attr("d", P2);
          var O2 = s(r3, n3);
          p3.plotContainer.selectAll(".scatterlayer,.maplayer").attr("transform", O2), p3.clipDefRelative.select("path").attr("transform", null);
          var I2 = s(r3 - S2._offset, n3 + a2);
          p3.layers.baxis.attr("transform", I2), p3.layers.bgrid.attr("transform", I2);
          var D2 = s(r3 + i2 / 2, n3) + "rotate(30)" + s(0, -M2._offset);
          p3.layers.aaxis.attr("transform", D2), p3.layers.agrid.attr("transform", D2);
          var z = s(r3 + i2 / 2, n3) + "rotate(-30)" + s(0, -L2._offset);
          p3.layers.caxis.attr("transform", z), p3.layers.cgrid.attr("transform", z), p3.drawAxes(true), p3.layers.aline.select("path").attr("d", M2.showline ? "M" + r3 + "," + (n3 + a2) + "l" + i2 / 2 + ",-" + a2 : "M0,0").call(u.stroke, M2.linecolor || "#000").style("stroke-width", (M2.linewidth || 0) + "px"), p3.layers.bline.select("path").attr("d", S2.showline ? "M" + r3 + "," + (n3 + a2) + "h" + i2 : "M0,0").call(u.stroke, S2.linecolor || "#000").style("stroke-width", (S2.linewidth || 0) + "px"), p3.layers.cline.select("path").attr("d", L2.showline ? "M" + (r3 + i2 / 2) + "," + n3 + "l" + i2 / 2 + "," + a2 : "M0,0").call(u.stroke, L2.linecolor || "#000").style("stroke-width", (L2.linewidth || 0) + "px"), p3.graphDiv._context.staticPlot || p3.initInteractions(), c.setClipUrl(p3.layers.frontplot, p3._hasClipOnAxisFalse ? null : p3.clipId, p3.graphDiv);
        }, S.drawAxes = function(t3) {
          var e3 = this, r3 = e3.graphDiv, n3 = e3.id.substr(7) + "title", i2 = e3.layers, a2 = e3.aaxis, o2 = e3.baxis, s2 = e3.caxis;
          if (e3.drawAx(a2), e3.drawAx(o2), e3.drawAx(s2), t3) {
            var u2 = Math.max(a2.showticklabels ? a2.tickfont.size / 2 : 0, (s2.showticklabels ? 0.75 * s2.tickfont.size : 0) + ("outside" === s2.ticks ? 0.87 * s2.ticklen : 0)), c2 = (o2.showticklabels ? o2.tickfont.size : 0) + ("outside" === o2.ticks ? o2.ticklen : 0) + 3;
            i2["a-title"] = b.draw(r3, "a" + n3, { propContainer: a2, propName: e3.id + ".aaxis.title", placeholder: l(r3, "Click to enter Component A title"), attributes: { x: e3.x0 + e3.w / 2, y: e3.y0 - a2.title.font.size / 3 - u2, "text-anchor": "middle" } }), i2["b-title"] = b.draw(r3, "b" + n3, { propContainer: o2, propName: e3.id + ".baxis.title", placeholder: l(r3, "Click to enter Component B title"), attributes: { x: e3.x0 - c2, y: e3.y0 + e3.h + 0.83 * o2.title.font.size + c2, "text-anchor": "middle" } }), i2["c-title"] = b.draw(r3, "c" + n3, { propContainer: s2, propName: e3.id + ".caxis.title", placeholder: l(r3, "Click to enter Component C title"), attributes: { x: e3.x0 + e3.w + c2, y: e3.y0 + e3.h + 0.83 * s2.title.font.size + c2, "text-anchor": "middle" } });
          }
        }, S.drawAx = function(t3) {
          var e3, r3 = this, n3 = r3.graphDiv, i2 = t3._name, a2 = i2.charAt(0), s2 = t3._id, l2 = r3.layers[i2], u2 = a2 + "tickLayout", c2 = (e3 = t3).ticks + String(e3.ticklen) + String(e3.showticklabels);
          r3[u2] !== c2 && (l2.selectAll("." + s2 + "tick").remove(), r3[u2] = c2), t3.setScale();
          var f3 = d2.calcTicks(t3), h2 = d2.clipEnds(t3, f3), p3 = d2.makeTransTickFn(t3), v2 = d2.getTickSigns(t3)[2], g3 = o.deg2rad(30), y2 = v2 * (t3.linewidth || 1) / 2, m3 = v2 * t3.ticklen, x2 = r3.w, b2 = r3.h, _2 = "b" === a2 ? "M0," + y2 + "l" + Math.sin(g3) * m3 + "," + Math.cos(g3) * m3 : "M" + y2 + ",0l" + Math.cos(g3) * m3 + "," + -Math.sin(g3) * m3, w3 = { a: "M0,0l" + b2 + ",-" + x2 / 2, b: "M0,0l-" + x2 / 2 + ",-" + b2, c: "M0,0l-" + b2 + "," + x2 / 2 }[a2];
          d2.drawTicks(n3, t3, { vals: "inside" === t3.ticks ? h2 : f3, layer: l2, path: _2, transFn: p3, crisp: false }), d2.drawGrid(n3, t3, { vals: h2, layer: r3.layers[a2 + "grid"], path: w3, transFn: p3, crisp: false }), d2.drawLabels(n3, t3, { vals: f3, layer: l2, transFn: p3, labelFns: d2.makeLabelFns(t3, 0, 30) });
        };
        var L = A.MINZOOM / 2 + 0.87, C = "m-0.87,.5h" + L + "v3h-" + (L + 5.2) + "l" + (L / 2 + 2.6) + ",-" + (0.87 * L + 4.5) + "l2.6,1.5l-" + L / 2 + "," + 0.87 * L + "Z", P = "m0.87,.5h-" + L + "v3h" + (L + 5.2) + "l-" + (L / 2 + 2.6) + ",-" + (0.87 * L + 4.5) + "l-2.6,1.5l" + L / 2 + "," + 0.87 * L + "Z", O = "m0,1l" + L / 2 + "," + 0.87 * L + "l2.6,-1.5l-" + (L / 2 + 2.6) + ",-" + (0.87 * L + 4.5) + "l-" + (L / 2 + 2.6) + "," + (0.87 * L + 4.5) + "l2.6,1.5l" + L / 2 + ",-" + 0.87 * L + "Z", I = true;
        function D(t3) {
          n2.select(t3).selectAll(".zoombox,.js-zoombox-backdrop,.js-zoombox-menu,.zoombox-corners").remove();
        }
        S.clearOutline = function() {
          k(this.dragOptions), T(this.dragOptions.gd);
        }, S.initInteractions = function() {
          var t3, e3, r3, n3, f3, h2, p3, d3, y2, b2, T2, k2, M2 = this, S2 = M2.layers.plotbg.select("path").node(), L2 = M2.graphDiv, z = L2._fullLayout._zoomlayer;
          function R(t4) {
            var e4 = {};
            return e4[M2.id + ".aaxis.min"] = t4.a, e4[M2.id + ".baxis.min"] = t4.b, e4[M2.id + ".caxis.min"] = t4.c, e4;
          }
          function F(t4, e4) {
            var r4 = L2._fullLayout.clickmode;
            D(L2), 2 === t4 && (L2.emit("plotly_doubleclick", null), a.call("_guiRelayout", L2, R({ a: 0, b: 0, c: 0 }))), r4.indexOf("select") > -1 && 1 === t4 && w2(e4, L2, [M2.xaxis], [M2.yaxis], M2.id, M2.dragOptions), r4.indexOf("event") > -1 && g2.click(L2, e4, M2.id);
          }
          function B(t4, e4) {
            return 1 - e4 / M2.h;
          }
          function N(t4, e4) {
            return 1 - (t4 + (M2.h - e4) / Math.sqrt(3)) / M2.w;
          }
          function j(t4, e4) {
            return (t4 - (M2.h - e4) / Math.sqrt(3)) / M2.w;
          }
          function U(i2, a2) {
            var o2 = r3 + i2 * t3, s2 = n3 + a2 * e3, l2 = Math.max(0, Math.min(1, B(0, n3), B(0, s2))), u2 = Math.max(0, Math.min(1, N(r3, n3), N(o2, s2))), c2 = Math.max(0, Math.min(1, j(r3, n3), j(o2, s2))), v2 = (l2 / 2 + c2) * M2.w, g3 = (1 - l2 / 2 - u2) * M2.w, m3 = (v2 + g3) / 2, x2 = g3 - v2, _2 = (1 - l2) * M2.h, w3 = _2 - x2 / E;
            x2 < A.MINZOOM ? (p3 = f3, T2.attr("d", y2), k2.attr("d", "M0,0Z")) : (p3 = { a: f3.a + l2 * h2, b: f3.b + u2 * h2, c: f3.c + c2 * h2 }, T2.attr("d", y2 + "M" + v2 + "," + _2 + "H" + g3 + "L" + m3 + "," + w3 + "L" + v2 + "," + _2 + "Z"), k2.attr("d", "M" + r3 + "," + n3 + "m0.5,0.5h5v-2h-5v-5h-2v5h-5v2h5v5h2ZM" + v2 + "," + _2 + C + "M" + g3 + "," + _2 + P + "M" + m3 + "," + w3 + O)), b2 || (T2.transition().style("fill", d3 > 0.2 ? "rgba(0,0,0,0.4)" : "rgba(255,255,255,0.3)").duration(200), k2.transition().style("opacity", 1).duration(200), b2 = true), L2.emit("plotly_relayouting", R(p3));
          }
          function V() {
            D(L2), p3 !== f3 && (a.call("_guiRelayout", L2, R(p3)), I && L2.data && L2._context.showTips && (o.notifier(l(L2, "Double-click to zoom back out"), "long"), I = false));
          }
          function H(t4, e4) {
            var r4 = t4 / M2.xaxis._m, n4 = e4 / M2.yaxis._m, i2 = [(p3 = { a: f3.a - n4, b: f3.b + (r4 + n4) / 2, c: f3.c - (r4 - n4) / 2 }).a, p3.b, p3.c].sort(o.sorterAsc), a2 = i2.indexOf(p3.a), l2 = i2.indexOf(p3.b), u2 = i2.indexOf(p3.c);
            i2[0] < 0 && (i2[1] + i2[0] / 2 < 0 ? (i2[2] += i2[0] + i2[1], i2[0] = i2[1] = 0) : (i2[2] += i2[0] / 2, i2[1] += i2[0] / 2, i2[0] = 0), p3 = { a: i2[a2], b: i2[l2], c: i2[u2] }, e4 = (f3.a - p3.a) * M2.yaxis._m, t4 = (f3.c - p3.c - f3.b + p3.b) * M2.xaxis._m);
            var h3 = s(M2.x0 + t4, M2.y0 + e4);
            M2.plotContainer.selectAll(".scatterlayer,.maplayer").attr("transform", h3);
            var d4 = s(-t4, -e4);
            M2.clipDefRelative.select("path").attr("transform", d4), M2.aaxis.range = [p3.a, M2.sum - p3.b - p3.c], M2.baxis.range = [M2.sum - p3.a - p3.c, p3.b], M2.caxis.range = [M2.sum - p3.a - p3.b, p3.c], M2.drawAxes(false), M2._hasClipOnAxisFalse && M2.plotContainer.select(".scatterlayer").selectAll(".trace").call(c.hideOutsideRangePoints, M2), L2.emit("plotly_relayouting", R(p3));
          }
          function q2() {
            a.call("_guiRelayout", L2, R(p3));
          }
          this.dragOptions = { element: S2, gd: L2, plotinfo: { id: M2.id, domain: L2._fullLayout[M2.id].domain, xaxis: M2.xaxis, yaxis: M2.yaxis }, subplot: M2.id, prepFn: function(a2, l2, c2) {
            M2.dragOptions.xaxes = [M2.xaxis], M2.dragOptions.yaxes = [M2.yaxis], t3 = L2._fullLayout._invScaleX, e3 = L2._fullLayout._invScaleY;
            var v2 = M2.dragOptions.dragmode = L2._fullLayout.dragmode;
            m2(v2) ? M2.dragOptions.minDrag = 1 : M2.dragOptions.minDrag = void 0, "zoom" === v2 ? (M2.dragOptions.moveFn = U, M2.dragOptions.clickFn = F, M2.dragOptions.doneFn = V, function(t4, e4, a3) {
              var l3 = S2.getBoundingClientRect();
              r3 = e4 - l3.left, n3 = a3 - l3.top, L2._fullLayout._calcInverseTransform(L2);
              var c3 = L2._fullLayout._invTransform, v3 = o.apply3DTransform(c3)(r3, n3);
              r3 = v3[0], n3 = v3[1], f3 = { a: M2.aaxis.range[0], b: M2.baxis.range[1], c: M2.caxis.range[1] }, p3 = f3, h2 = M2.aaxis.range[1] - f3.a, d3 = i(M2.graphDiv._fullLayout[M2.id].bgcolor).getLuminance(), y2 = "M0," + M2.h + "L" + M2.w / 2 + ", 0L" + M2.w + "," + M2.h + "Z", b2 = false, T2 = z.append("path").attr("class", "zoombox").attr("transform", s(M2.x0, M2.y0)).style({ fill: d3 > 0.2 ? "rgba(0,0,0,0)" : "rgba(255,255,255,0)", "stroke-width": 0 }).attr("d", y2), k2 = z.append("path").attr("class", "zoombox-corners").attr("transform", s(M2.x0, M2.y0)).style({ fill: u.background, stroke: u.defaultLine, "stroke-width": 1, opacity: 0 }).attr("d", "M0,0Z"), M2.clearOutline(L2);
            }(0, l2, c2)) : "pan" === v2 ? (M2.dragOptions.moveFn = H, M2.dragOptions.clickFn = F, M2.dragOptions.doneFn = q2, f3 = { a: M2.aaxis.range[0], b: M2.baxis.range[1], c: M2.caxis.range[1] }, p3 = f3, M2.clearOutline(L2)) : (x(v2) || m2(v2)) && _(a2, l2, c2, M2.dragOptions, v2);
          } }, S2.onmousemove = function(t4) {
            g2.hover(L2, t4, M2.id), L2._fullLayout._lasthover = S2, L2._fullLayout._hoversubplot = M2.id;
          }, S2.onmouseout = function(t4) {
            L2._dragging || v.unhover(L2, t4);
          }, v.init(this.dragOptions);
        };
      }, 73972: function(t2, e2, r2) {
        var n2 = r2(47769), i = r2(64213), a = r2(75138), o = r2(41965), s = r2(24401).addStyleRule, l = r2(1426), u = r2(9012), c = r2(10820), f2 = l.extendFlat, h = l.extendDeepAll;
        function p2(t3) {
          var r3 = t3.name, i2 = t3.categories, a2 = t3.meta;
          if (e2.modules[r3])
            n2.log("Type " + r3 + " already registered");
          else {
            e2.subplotsRegistry[t3.basePlotModule.name] || function(t4) {
              var r4 = t4.name;
              if (e2.subplotsRegistry[r4])
                n2.log("Plot type " + r4 + " already registered.");
              else
                for (var i3 in y(t4), e2.subplotsRegistry[r4] = t4, e2.componentsRegistry)
                  b(i3, t4.name);
            }(t3.basePlotModule);
            for (var o2 = {}, l2 = 0; l2 < i2.length; l2++)
              o2[i2[l2]] = true, e2.allCategories[i2[l2]] = true;
            for (var u2 in e2.modules[r3] = { _module: t3, categories: o2 }, a2 && Object.keys(a2).length && (e2.modules[r3].meta = a2), e2.allTypes.push(r3), e2.componentsRegistry)
              m2(u2, r3);
            t3.layoutAttributes && f2(e2.traceLayoutAttributes, t3.layoutAttributes);
            var c2 = t3.basePlotModule, h2 = c2.name;
            if ("mapbox" === h2) {
              var p3 = c2.constants.styleRules;
              for (var d3 in p3)
                s(".js-plotly-plot .plotly .mapboxgl-" + d3, p3[d3]);
            }
            "geo" !== h2 && "mapbox" !== h2 || void 0 !== window.PlotlyGeoAssets || (window.PlotlyGeoAssets = { topojson: {} });
          }
        }
        function d2(t3) {
          if ("string" != typeof t3.name)
            throw new Error("Component module *name* must be a string.");
          var r3 = t3.name;
          for (var n3 in e2.componentsRegistry[r3] = t3, t3.layoutAttributes && (t3.layoutAttributes._isLinkedToArray && a(e2.layoutArrayContainers, r3), y(t3)), e2.modules)
            m2(r3, n3);
          for (var i2 in e2.subplotsRegistry)
            b(r3, i2);
          for (var o2 in e2.transformsRegistry)
            x(r3, o2);
          t3.schema && t3.schema.layout && h(c, t3.schema.layout);
        }
        function v(t3) {
          if ("string" != typeof t3.name)
            throw new Error("Transform module *name* must be a string.");
          var r3 = "Transform module " + t3.name, i2 = "function" == typeof t3.transform, a2 = "function" == typeof t3.calcTransform;
          if (!i2 && !a2)
            throw new Error(r3 + " is missing a *transform* or *calcTransform* method.");
          for (var s2 in i2 && a2 && n2.log([r3 + " has both a *transform* and *calcTransform* methods.", "Please note that all *transform* methods are executed", "before all *calcTransform* methods."].join(" ")), o(t3.attributes) || n2.log(r3 + " registered without an *attributes* object."), "function" != typeof t3.supplyDefaults && n2.log(r3 + " registered without a *supplyDefaults* method."), e2.transformsRegistry[t3.name] = t3, e2.componentsRegistry)
            x(s2, t3.name);
        }
        function g2(t3) {
          var r3 = t3.name, n3 = r3.split("-")[0], i2 = t3.dictionary, a2 = t3.format, o2 = i2 && Object.keys(i2).length, s2 = a2 && Object.keys(a2).length, l2 = e2.localeRegistry, u2 = l2[r3];
          if (u2 || (l2[r3] = u2 = {}), n3 !== r3) {
            var c2 = l2[n3];
            c2 || (l2[n3] = c2 = {}), o2 && c2.dictionary === u2.dictionary && (c2.dictionary = i2), s2 && c2.format === u2.format && (c2.format = a2);
          }
          o2 && (u2.dictionary = i2), s2 && (u2.format = a2);
        }
        function y(t3) {
          if (t3.layoutAttributes) {
            var r3 = t3.layoutAttributes._arrayAttrRegexps;
            if (r3)
              for (var n3 = 0; n3 < r3.length; n3++)
                a(e2.layoutArrayRegexes, r3[n3]);
          }
        }
        function m2(t3, r3) {
          var n3 = e2.componentsRegistry[t3].schema;
          if (n3 && n3.traces) {
            var i2 = n3.traces[r3];
            i2 && h(e2.modules[r3]._module.attributes, i2);
          }
        }
        function x(t3, r3) {
          var n3 = e2.componentsRegistry[t3].schema;
          if (n3 && n3.transforms) {
            var i2 = n3.transforms[r3];
            i2 && h(e2.transformsRegistry[r3].attributes, i2);
          }
        }
        function b(t3, r3) {
          var n3 = e2.componentsRegistry[t3].schema;
          if (n3 && n3.subplots) {
            var i2 = e2.subplotsRegistry[r3], a2 = i2.layoutAttributes, o2 = "subplot" === i2.attr ? i2.name : i2.attr;
            Array.isArray(o2) && (o2 = o2[0]);
            var s2 = n3.subplots[o2];
            a2 && s2 && h(a2, s2);
          }
        }
        function _(t3) {
          return "object" == typeof t3 && (t3 = t3.type), t3;
        }
        e2.modules = {}, e2.allCategories = {}, e2.allTypes = [], e2.subplotsRegistry = {}, e2.transformsRegistry = {}, e2.componentsRegistry = {}, e2.layoutArrayContainers = [], e2.layoutArrayRegexes = [], e2.traceLayoutAttributes = {}, e2.localeRegistry = {}, e2.apiMethodRegistry = {}, e2.collectableSubplotTypes = null, e2.register = function(t3) {
          if (e2.collectableSubplotTypes = null, !t3)
            throw new Error("No argument passed to Plotly.register.");
          t3 && !Array.isArray(t3) && (t3 = [t3]);
          for (var r3 = 0; r3 < t3.length; r3++) {
            var n3 = t3[r3];
            if (!n3)
              throw new Error("Invalid module was attempted to be registered!");
            switch (n3.moduleType) {
              case "trace":
                p2(n3);
                break;
              case "transform":
                v(n3);
                break;
              case "component":
                d2(n3);
                break;
              case "locale":
                g2(n3);
                break;
              case "apiMethod":
                var i2 = n3.name;
                e2.apiMethodRegistry[i2] = n3.fn;
                break;
              default:
                throw new Error("Invalid module was attempted to be registered!");
            }
          }
        }, e2.getModule = function(t3) {
          var r3 = e2.modules[_(t3)];
          return !!r3 && r3._module;
        }, e2.traceIs = function(t3, r3) {
          if ("various" === (t3 = _(t3)))
            return false;
          var i2 = e2.modules[t3];
          return i2 || (t3 && n2.log("Unrecognized trace type " + t3 + "."), i2 = e2.modules[u.type.dflt]), !!i2.categories[r3];
        }, e2.getTransformIndices = function(t3, e3) {
          for (var r3 = [], n3 = t3.transforms || [], i2 = 0; i2 < n3.length; i2++)
            n3[i2].type === e3 && r3.push(i2);
          return r3;
        }, e2.hasTransform = function(t3, e3) {
          for (var r3 = t3.transforms || [], n3 = 0; n3 < r3.length; n3++)
            if (r3[n3].type === e3)
              return true;
          return false;
        }, e2.getComponentMethod = function(t3, r3) {
          var n3 = e2.componentsRegistry[t3];
          return n3 && n3[r3] || i;
        }, e2.call = function() {
          var t3 = arguments[0], r3 = [].slice.call(arguments, 1);
          return e2.apiMethodRegistry[t3].apply(null, r3);
        };
      }, 61914: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828), a = i.extendFlat, o = i.extendDeep;
        function s(t3) {
          var e3;
          switch (t3) {
            case "themes__thumb":
              e3 = { autosize: true, width: 150, height: 150, title: { text: "" }, showlegend: false, margin: { l: 5, r: 5, t: 5, b: 5, pad: 0 }, annotations: [] };
              break;
            case "thumbnail":
              e3 = { title: { text: "" }, hidesources: true, showlegend: false, borderwidth: 0, bordercolor: "", margin: { l: 1, r: 1, t: 1, b: 1, pad: 0 }, annotations: [] };
              break;
            default:
              e3 = {};
          }
          return e3;
        }
        t2.exports = function(t3, e3) {
          var r3, i2, l = t3.data, u = t3.layout, c = o([], l), f2 = o({}, u, s(e3.tileClass)), h = t3._context || {};
          if (e3.width && (f2.width = e3.width), e3.height && (f2.height = e3.height), "thumbnail" === e3.tileClass || "themes__thumb" === e3.tileClass) {
            f2.annotations = [];
            var p2 = Object.keys(f2);
            for (r3 = 0; r3 < p2.length; r3++)
              i2 = p2[r3], ["xaxis", "yaxis", "zaxis"].indexOf(i2.slice(0, 5)) > -1 && (f2[p2[r3]].title = { text: "" });
            for (r3 = 0; r3 < c.length; r3++) {
              var d2 = c[r3];
              d2.showscale = false, d2.marker && (d2.marker.showscale = false), n2.traceIs(d2, "pie-like") && (d2.textposition = "none");
            }
          }
          if (Array.isArray(e3.annotations))
            for (r3 = 0; r3 < e3.annotations.length; r3++)
              f2.annotations.push(e3.annotations[r3]);
          var v = Object.keys(f2).filter(function(t4) {
            return t4.match(/^scene\d*$/);
          });
          if (v.length) {
            var g2 = {};
            for ("thumbnail" === e3.tileClass && (g2 = { title: { text: "" }, showaxeslabels: false, showticklabels: false, linetickenable: false }), r3 = 0; r3 < v.length; r3++) {
              var y = f2[v[r3]];
              y.xaxis || (y.xaxis = {}), y.yaxis || (y.yaxis = {}), y.zaxis || (y.zaxis = {}), a(y.xaxis, g2), a(y.yaxis, g2), a(y.zaxis, g2), y._scene = null;
            }
          }
          var m2 = document.createElement("div");
          e3.tileClass && (m2.className = e3.tileClass);
          var x = { gd: m2, td: m2, layout: f2, data: c, config: { staticPlot: void 0 === e3.staticPlot || e3.staticPlot, plotGlPixelRatio: void 0 === e3.plotGlPixelRatio ? 2 : e3.plotGlPixelRatio, displaylogo: e3.displaylogo || false, showLink: e3.showLink || false, showTips: e3.showTips || false, mapboxAccessToken: h.mapboxAccessToken } };
          return "transparent" !== e3.setBackground && (x.config.setBackground = e3.setBackground || "opaque"), x.gd.defaultLayout = s(e3.tileClass), x;
        };
      }, 7239: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(403), a = r2(22435), o = r2(25095);
        t2.exports = function(t3, e3) {
          var r3;
          return n2.isPlainObject(t3) || (r3 = n2.getGraphDiv(t3)), (e3 = e3 || {}).format = e3.format || "png", e3.width = e3.width || null, e3.height = e3.height || null, e3.imageDataOnly = true, new Promise(function(s, l) {
            r3 && r3._snapshotInProgress && l(new Error("Snapshotting already in progress.")), n2.isIE() && "svg" !== e3.format && l(new Error(o.MSG_IE_BAD_FORMAT)), r3 && (r3._snapshotInProgress = true);
            var u = i(t3, e3), c = e3.filename || t3.fn || "newplot";
            c += "." + e3.format.replace("-", "."), u.then(function(t4) {
              return r3 && (r3._snapshotInProgress = false), a(t4, c, e3.format);
            }).then(function(t4) {
              s(t4);
            }).catch(function(t4) {
              r3 && (r3._snapshotInProgress = false), l(t4);
            });
          });
        };
      }, 22435: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(25095);
        t2.exports = function(t3, e3, r3) {
          var a = document.createElement("a"), o = "download" in a;
          return new Promise(function(s, l) {
            var u, c;
            if (n2.isIE())
              return u = i.createBlob(t3, "svg"), window.navigator.msSaveBlob(u, e3), u = null, s(e3);
            if (o)
              return u = i.createBlob(t3, r3), c = i.createObjectURL(u), a.href = c, a.download = e3, document.body.appendChild(a), a.click(), document.body.removeChild(a), i.revokeObjectURL(c), u = null, s(e3);
            if (n2.isSafari()) {
              var f2 = "svg" === r3 ? "," : ";base64,";
              return i.octetStream(f2 + encodeURIComponent(t3)), s(e3);
            }
            l(new Error("download error"));
          });
        };
      }, 25095: function(t2, e2, r2) {
        var n2 = r2(73972);
        e2.getDelay = function(t3) {
          return t3._has && (t3._has("gl3d") || t3._has("gl2d") || t3._has("mapbox")) ? 500 : 0;
        }, e2.getRedrawFunc = function(t3) {
          return function() {
            n2.getComponentMethod("colorbar", "draw")(t3);
          };
        }, e2.encodeSVG = function(t3) {
          return "data:image/svg+xml," + encodeURIComponent(t3);
        }, e2.encodeJSON = function(t3) {
          return "data:application/json," + encodeURIComponent(t3);
        };
        var i = window.URL || window.webkitURL;
        e2.createObjectURL = function(t3) {
          return i.createObjectURL(t3);
        }, e2.revokeObjectURL = function(t3) {
          return i.revokeObjectURL(t3);
        }, e2.createBlob = function(t3, e3) {
          if ("svg" === e3)
            return new window.Blob([t3], { type: "image/svg+xml;charset=utf-8" });
          if ("full-json" === e3)
            return new window.Blob([t3], { type: "application/json;charset=utf-8" });
          var r3 = function(t4) {
            for (var e4 = t4.length, r4 = new ArrayBuffer(e4), n3 = new Uint8Array(r4), i2 = 0; i2 < e4; i2++)
              n3[i2] = t4.charCodeAt(i2);
            return r4;
          }(window.atob(t3));
          return new window.Blob([r3], { type: "image/" + e3 });
        }, e2.octetStream = function(t3) {
          document.location.href = "data:application/octet-stream" + t3;
        }, e2.IMAGE_URL_PREFIX = /^data:image\/\w+;base64,/, e2.MSG_IE_BAD_FORMAT = "Sorry IE does not support downloading from canvas. Try {format:'svg'} instead.";
      }, 44511: function(t2, e2, r2) {
        var n2 = r2(25095), i = { getDelay: n2.getDelay, getRedrawFunc: n2.getRedrawFunc, clone: r2(61914), toSVG: r2(5900), svgToImg: r2(70942), toImage: r2(56395), downloadImage: r2(7239) };
        t2.exports = i;
      }, 70942: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(15398).EventEmitter, a = r2(25095);
        t2.exports = function(t3) {
          var e3 = t3.emitter || new i(), r3 = new Promise(function(i2, o) {
            var s = window.Image, l = t3.svg, u = t3.format || "png";
            if (n2.isIE() && "svg" !== u) {
              var c = new Error(a.MSG_IE_BAD_FORMAT);
              return o(c), t3.promise ? r3 : e3.emit("error", c);
            }
            var f2, h, p2 = t3.canvas, d2 = t3.scale || 1, v = t3.width || 300, g2 = t3.height || 150, y = d2 * v, m2 = d2 * g2, x = p2.getContext("2d", { willReadFrequently: true }), b = new s();
            "svg" === u || n2.isSafari() ? h = a.encodeSVG(l) : (f2 = a.createBlob(l, "svg"), h = a.createObjectURL(f2)), p2.width = y, p2.height = m2, b.onload = function() {
              var r4;
              switch (f2 = null, a.revokeObjectURL(h), "svg" !== u && x.drawImage(b, 0, 0, y, m2), u) {
                case "jpeg":
                  r4 = p2.toDataURL("image/jpeg");
                  break;
                case "png":
                  r4 = p2.toDataURL("image/png");
                  break;
                case "webp":
                  r4 = p2.toDataURL("image/webp");
                  break;
                case "svg":
                  r4 = h;
                  break;
                default:
                  var n3 = "Image format is not jpeg, png, svg or webp.";
                  if (o(new Error(n3)), !t3.promise)
                    return e3.emit("error", n3);
              }
              i2(r4), t3.promise || e3.emit("success", r4);
            }, b.onerror = function(r4) {
              if (f2 = null, a.revokeObjectURL(h), o(r4), !t3.promise)
                return e3.emit("error", r4);
            }, b.src = h;
          });
          return t3.promise ? r3 : e3;
        };
      }, 56395: function(t2, e2, r2) {
        var n2 = r2(15398).EventEmitter, i = r2(73972), a = r2(71828), o = r2(25095), s = r2(61914), l = r2(5900), u = r2(70942);
        t2.exports = function(t3, e3) {
          var r3 = new n2(), c = s(t3, { format: "png" }), f2 = c.gd;
          f2.style.position = "absolute", f2.style.left = "-5000px", document.body.appendChild(f2);
          var h = o.getRedrawFunc(f2);
          return i.call("_doPlot", f2, c.data, c.layout, c.config).then(h).then(function() {
            var t4 = o.getDelay(f2._fullLayout);
            setTimeout(function() {
              var t5 = l(f2), n3 = document.createElement("canvas");
              n3.id = a.randstr(), (r3 = u({ format: e3.format, width: f2._fullLayout.width, height: f2._fullLayout.height, canvas: n3, emitter: r3, svg: t5 })).clean = function() {
                f2 && document.body.removeChild(f2);
              };
            }, t4);
          }).catch(function(t4) {
            r3.emit("error", t4);
          }), r3;
        };
      }, 5900: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(91424), o = r2(7901), s = r2(77922), l = /"/g, u = "TOBESTRIPPED", c = new RegExp('("TOBESTRIPPED)|(TOBESTRIPPED")', "g");
        t2.exports = function(t3, e3, r3) {
          var f2, h = t3._fullLayout, p2 = h._paper, d2 = h._toppaper, v = h.width, g2 = h.height;
          p2.insert("rect", ":first-child").call(a.setRect, 0, 0, v, g2).call(o.fill, h.paper_bgcolor);
          var y = h._basePlotModules || [];
          for (f2 = 0; f2 < y.length; f2++) {
            var m2 = y[f2];
            m2.toSVG && m2.toSVG(t3);
          }
          if (d2) {
            var x = d2.node().childNodes, b = Array.prototype.slice.call(x);
            for (f2 = 0; f2 < b.length; f2++) {
              var _ = b[f2];
              _.childNodes.length && p2.node().appendChild(_);
            }
          }
          h._draggers && h._draggers.remove(), p2.node().style.background = "", p2.selectAll("text").attr({ "data-unformatted": null, "data-math": null }).each(function() {
            var t4 = n2.select(this);
            if ("hidden" !== this.style.visibility && "none" !== this.style.display) {
              t4.style({ visibility: null, display: null });
              var e4 = this.style.fontFamily;
              e4 && -1 !== e4.indexOf('"') && t4.style("font-family", e4.replace(l, u));
            } else
              t4.remove();
          }), p2.selectAll(".gradient_filled,.pattern_filled").each(function() {
            var t4 = n2.select(this), e4 = this.style.fill;
            e4 && -1 !== e4.indexOf("url(") && t4.style("fill", e4.replace(l, u));
            var r4 = this.style.stroke;
            r4 && -1 !== r4.indexOf("url(") && t4.style("stroke", r4.replace(l, u));
          }), "pdf" !== e3 && "eps" !== e3 || p2.selectAll("#MathJax_SVG_glyphs path").attr("stroke-width", 0), p2.node().setAttributeNS(s.xmlns, "xmlns", s.svg), p2.node().setAttributeNS(s.xmlns, "xmlns:xlink", s.xlink), "svg" === e3 && r3 && (p2.attr("width", r3 * v), p2.attr("height", r3 * g2), p2.attr("viewBox", "0 0 " + v + " " + g2));
          var w2 = new window.XMLSerializer().serializeToString(p2.node());
          return w2 = (w2 = (w2 = function(t4) {
            var e4 = n2.select("body").append("div").style({ display: "none" }).html(""), r4 = t4.replace(/(&[^;]*;)/gi, function(t5) {
              return "&lt;" === t5 ? "&#60;" : "&rt;" === t5 ? "&#62;" : -1 !== t5.indexOf("<") || -1 !== t5.indexOf(">") ? "" : e4.html(t5).text();
            });
            return e4.remove(), r4;
          }(w2)).replace(/&(?!\w+;|\#[0-9]+;| \#x[0-9A-F]+;)/g, "&amp;")).replace(c, "'"), i.isIE() && (w2 = (w2 = (w2 = w2.replace(/"/gi, "'")).replace(/(\('#)([^']*)('\))/gi, '("#$2")')).replace(/(\\')/gi, '"')), w2;
        };
      }, 75341: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = function(t3, e3) {
          for (var r3 = 0; r3 < t3.length; r3++)
            t3[r3].i = r3;
          n2.mergeArray(e3.text, t3, "tx"), n2.mergeArray(e3.hovertext, t3, "htx");
          var i = e3.marker;
          if (i) {
            n2.mergeArray(i.opacity, t3, "mo", true), n2.mergeArray(i.color, t3, "mc");
            var a = i.line;
            a && (n2.mergeArray(a.color, t3, "mlc"), n2.mergeArrayCastPositive(a.width, t3, "mlw"));
          }
        };
      }, 1486: function(t2, e2, r2) {
        var n2 = r2(82196), i = r2(12663).axisHoverFormat, a = r2(5386).f, o = r2(5386).s, s = r2(50693), l = r2(41940), u = r2(97313), c = r2(79952).u, f2 = r2(1426).extendFlat, h = l({ editType: "calc", arrayOk: true, colorEditType: "style" }), p2 = f2({}, n2.marker.line.width, { dflt: 0 }), d2 = f2({ width: p2, editType: "calc" }, s("marker.line")), v = f2({ line: d2, editType: "calc" }, s("marker"), { opacity: { valType: "number", arrayOk: true, dflt: 1, min: 0, max: 1, editType: "style" }, pattern: c });
        t2.exports = { x: n2.x, x0: n2.x0, dx: n2.dx, y: n2.y, y0: n2.y0, dy: n2.dy, xperiod: n2.xperiod, yperiod: n2.yperiod, xperiod0: n2.xperiod0, yperiod0: n2.yperiod0, xperiodalignment: n2.xperiodalignment, yperiodalignment: n2.yperiodalignment, xhoverformat: i("x"), yhoverformat: i("y"), text: n2.text, texttemplate: o({ editType: "plot" }, { keys: u.eventDataKeys }), hovertext: n2.hovertext, hovertemplate: a({}, { keys: u.eventDataKeys }), textposition: { valType: "enumerated", values: ["inside", "outside", "auto", "none"], dflt: "auto", arrayOk: true, editType: "calc" }, insidetextanchor: { valType: "enumerated", values: ["end", "middle", "start"], dflt: "end", editType: "plot" }, textangle: { valType: "angle", dflt: "auto", editType: "plot" }, textfont: f2({}, h, {}), insidetextfont: f2({}, h, {}), outsidetextfont: f2({}, h, {}), constraintext: { valType: "enumerated", values: ["inside", "outside", "both", "none"], dflt: "both", editType: "calc" }, cliponaxis: f2({}, n2.cliponaxis, {}), orientation: { valType: "enumerated", values: ["v", "h"], editType: "calc+clearAxisTypes" }, base: { valType: "any", dflt: null, arrayOk: true, editType: "calc" }, offset: { valType: "number", dflt: null, arrayOk: true, editType: "calc" }, width: { valType: "number", dflt: null, min: 0, arrayOk: true, editType: "calc" }, marker: v, offsetgroup: n2.offsetgroup, alignmentgroup: n2.alignmentgroup, selected: { marker: { opacity: n2.selected.marker.opacity, color: n2.selected.marker.color, editType: "style" }, textfont: n2.selected.textfont, editType: "style" }, unselected: { marker: { opacity: n2.unselected.marker.opacity, color: n2.unselected.marker.color, editType: "style" }, textfont: n2.unselected.textfont, editType: "style" }, _deprecated: { bardir: { valType: "enumerated", editType: "calc", values: ["v", "h"] } } };
      }, 92290: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(42973), a = r2(52075).hasColorscale, o = r2(78803), s = r2(75341), l = r2(66279);
        t2.exports = function(t3, e3) {
          var r3, u, c, f2, h, p2, d2 = n2.getFromId(t3, e3.xaxis || "x"), v = n2.getFromId(t3, e3.yaxis || "y"), g2 = { msUTC: !(!e3.base && 0 !== e3.base) };
          "h" === e3.orientation ? (r3 = d2.makeCalcdata(e3, "x", g2), c = v.makeCalcdata(e3, "y"), f2 = i(e3, v, "y", c), h = !!e3.yperiodalignment, p2 = "y") : (r3 = v.makeCalcdata(e3, "y", g2), c = d2.makeCalcdata(e3, "x"), f2 = i(e3, d2, "x", c), h = !!e3.xperiodalignment, p2 = "x"), u = f2.vals;
          for (var y = Math.min(u.length, r3.length), m2 = new Array(y), x = 0; x < y; x++)
            m2[x] = { p: u[x], s: r3[x] }, h && (m2[x].orig_p = c[x], m2[x][p2 + "End"] = f2.ends[x], m2[x][p2 + "Start"] = f2.starts[x]), e3.ids && (m2[x].id = String(e3.ids[x]));
          return a(e3, "marker") && o(t3, e3, { vals: e3.marker.color, containerStr: "marker", cLetter: "c" }), a(e3, "marker.line") && o(t3, e3, { vals: e3.marker.line.color, containerStr: "marker.line", cLetter: "c" }), s(m2, e3), l(m2, e3), m2;
        };
      }, 97313: function(t2) {
        t2.exports = { TEXTPAD: 3, eventDataKeys: ["value", "label"] };
      }, 11661: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828).isArrayOrTypedArray, a = r2(50606).BADNUM, o = r2(73972), s = r2(89298), l = r2(99082).getAxisGroup, u = r2(61546);
        function c(t3, e3, r3, o2, c2) {
          if (o2.length) {
            var b, _, w2, T;
            switch (function(t4, e4) {
              var r4, a2;
              for (r4 = 0; r4 < e4.length; r4++) {
                var o3, s2 = e4[r4], l2 = s2[0].trace, u2 = "funnel" === l2.type ? l2._base : l2.base, c3 = "h" === l2.orientation ? l2.xcalendar : l2.ycalendar, f3 = "category" === t4.type || "multicategory" === t4.type ? function() {
                  return null;
                } : t4.d2c;
                if (i(u2)) {
                  for (a2 = 0; a2 < Math.min(u2.length, s2.length); a2++)
                    o3 = f3(u2[a2], 0, c3), n2(o3) ? (s2[a2].b = +o3, s2[a2].hasB = 1) : s2[a2].b = 0;
                  for (; a2 < s2.length; a2++)
                    s2[a2].b = 0;
                } else {
                  o3 = f3(u2, 0, c3);
                  var h2 = n2(o3);
                  for (o3 = h2 ? o3 : 0, a2 = 0; a2 < s2.length; a2++)
                    s2[a2].b = o3, h2 && (s2[a2].hasB = 1);
                }
              }
            }(r3, o2), c2.mode) {
              case "overlay":
                f2(e3, r3, o2, c2);
                break;
              case "group":
                for (b = [], _ = [], w2 = 0; w2 < o2.length; w2++)
                  void 0 === (T = o2[w2])[0].trace.offset ? _.push(T) : b.push(T);
                _.length && function(t4, e4, r4, n3, i2) {
                  var o3 = new u(n3, { posAxis: e4, sepNegVal: false, overlapNoMerge: !i2.norm });
                  (function(t5, e5, r5, n4) {
                    for (var i3 = t5._fullLayout, a2 = r5.positions, o4 = r5.distinctPositions, s2 = r5.minDiff, u2 = r5.traces, c3 = u2.length, f3 = a2.length !== o4.length, h2 = s2 * (1 - n4.gap), g3 = l(i3, e5._id) + u2[0][0].trace.orientation, y2 = i3._alignmentOpts[g3] || {}, m3 = 0; m3 < c3; m3++) {
                      var x2, b2, _2 = u2[m3], w3 = _2[0].trace, T2 = y2[w3.alignmentgroup] || {}, k = Object.keys(T2.offsetGroups || {}).length, A = (x2 = k ? h2 / k : f3 ? h2 / c3 : h2) * (1 - (n4.groupgap || 0));
                      b2 = k ? ((2 * w3._offsetIndex + 1 - k) * x2 - A) / 2 : f3 ? ((2 * m3 + 1 - c3) * x2 - A) / 2 : -A / 2;
                      var M = _2[0].t;
                      M.barwidth = A, M.poffset = b2, M.bargroupwidth = h2, M.bardelta = s2;
                    }
                    r5.binWidth = u2[0][0].t.barwidth / 100, p2(r5), d2(e5, r5), v(e5, r5, f3);
                  })(t4, e4, o3, i2), function(t5, e5) {
                    for (var r5 = t5.traces, n4 = 0; n4 < r5.length; n4++) {
                      var i3 = r5[n4];
                      if (void 0 === i3[0].trace.base)
                        for (var o4 = new u([i3], { posAxis: e5, sepNegVal: true, overlapNoMerge: true }), s2 = 0; s2 < i3.length; s2++) {
                          var l2 = i3[s2];
                          if (l2.p !== a) {
                            var c3 = o4.put(l2.p, l2.b + l2.s);
                            c3 && (l2.b = c3);
                          }
                        }
                    }
                  }(o3, e4), i2.norm ? (y(o3), m2(r4, o3, i2)) : g2(r4, o3);
                }(t3, e3, r3, _, c2), b.length && f2(e3, r3, b, c2);
                break;
              case "stack":
              case "relative":
                for (b = [], _ = [], w2 = 0; w2 < o2.length; w2++)
                  void 0 === (T = o2[w2])[0].trace.base ? _.push(T) : b.push(T);
                _.length && function(t4, e4, r4, n3, i2) {
                  var o3 = new u(n3, { posAxis: e4, sepNegVal: "relative" === i2.mode, overlapNoMerge: !(i2.norm || "stack" === i2.mode || "relative" === i2.mode) });
                  h(e4, o3, i2), function(t5, e5, r5) {
                    var n4, i3, o4, l3, u2, c4, f4 = x(t5), h2 = e5.traces;
                    for (l3 = 0; l3 < h2.length; l3++)
                      if ("funnel" === (i3 = (n4 = h2[l3])[0].trace).type)
                        for (u2 = 0; u2 < n4.length; u2++)
                          (c4 = n4[u2]).s !== a && e5.put(c4.p, -0.5 * c4.s);
                    for (l3 = 0; l3 < h2.length; l3++) {
                      o4 = "funnel" === (i3 = (n4 = h2[l3])[0].trace).type;
                      var p4 = [];
                      for (u2 = 0; u2 < n4.length; u2++)
                        if ((c4 = n4[u2]).s !== a) {
                          var d3;
                          d3 = o4 ? c4.s : c4.s + c4.b;
                          var v2 = e5.put(c4.p, d3), g3 = v2 + d3;
                          c4.b = v2, c4[f4] = g3, r5.norm || (p4.push(g3), c4.hasB && p4.push(v2));
                        }
                      r5.norm || (i3._extremes[t5._id] = s.findExtremes(t5, p4, { tozero: true, padded: true }));
                    }
                  }(r4, o3, i2);
                  for (var l2 = 0; l2 < n3.length; l2++)
                    for (var c3 = n3[l2], f3 = 0; f3 < c3.length; f3++) {
                      var p3 = c3[f3];
                      p3.s !== a && p3.b + p3.s === o3.get(p3.p, p3.s) && (p3._outmost = true);
                    }
                  i2.norm && m2(r4, o3, i2);
                }(0, e3, r3, _, c2), b.length && f2(e3, r3, b, c2);
            }
            !function(t4, e4) {
              var r4, i2, a2, o3 = x(e4), s2 = {}, l2 = 1 / 0, u2 = -1 / 0;
              for (r4 = 0; r4 < t4.length; r4++)
                for (a2 = t4[r4], i2 = 0; i2 < a2.length; i2++) {
                  var c3 = a2[i2].p;
                  n2(c3) && (l2 = Math.min(l2, c3), u2 = Math.max(u2, c3));
                }
              var f3 = 1e4 / (u2 - l2), h2 = s2.round = function(t5) {
                return String(Math.round(f3 * (t5 - l2)));
              };
              for (r4 = 0; r4 < t4.length; r4++) {
                (a2 = t4[r4])[0].t.extents = s2;
                var p3 = a2[0].t.poffset, d3 = Array.isArray(p3);
                for (i2 = 0; i2 < a2.length; i2++) {
                  var v2 = a2[i2], g3 = v2[o3] - v2.w / 2;
                  if (n2(g3)) {
                    var y2 = v2[o3] + v2.w / 2, m3 = h2(v2.p);
                    s2[m3] ? s2[m3] = [Math.min(g3, s2[m3][0]), Math.max(y2, s2[m3][1])] : s2[m3] = [g3, y2];
                  }
                  v2.p0 = v2.p + (d3 ? p3[i2] : p3), v2.p1 = v2.p0 + v2.w, v2.s0 = v2.b, v2.s1 = v2.s0 + v2.s;
                }
              }
            }(o2, e3);
          }
        }
        function f2(t3, e3, r3, n3) {
          for (var i2 = 0; i2 < r3.length; i2++) {
            var a2 = r3[i2], o2 = new u([a2], { posAxis: t3, sepNegVal: false, overlapNoMerge: !n3.norm });
            h(t3, o2, n3), n3.norm ? (y(o2), m2(e3, o2, n3)) : g2(e3, o2);
          }
        }
        function h(t3, e3, r3) {
          for (var n3 = e3.minDiff, i2 = e3.traces, a2 = n3 * (1 - r3.gap), o2 = a2 * (1 - (r3.groupgap || 0)), s2 = -o2 / 2, l2 = 0; l2 < i2.length; l2++) {
            var u2 = i2[l2][0].t;
            u2.barwidth = o2, u2.poffset = s2, u2.bargroupwidth = a2, u2.bardelta = n3;
          }
          e3.binWidth = i2[0][0].t.barwidth / 100, p2(e3), d2(t3, e3), v(t3, e3);
        }
        function p2(t3) {
          var e3, r3, a2 = t3.traces;
          for (e3 = 0; e3 < a2.length; e3++) {
            var o2, s2 = a2[e3], l2 = s2[0], u2 = l2.trace, c2 = l2.t, f3 = u2._offset || u2.offset, h2 = c2.poffset;
            if (i(f3)) {
              for (o2 = Array.prototype.slice.call(f3, 0, s2.length), r3 = 0; r3 < o2.length; r3++)
                n2(o2[r3]) || (o2[r3] = h2);
              for (r3 = o2.length; r3 < s2.length; r3++)
                o2.push(h2);
              c2.poffset = o2;
            } else
              void 0 !== f3 && (c2.poffset = f3);
            var p3 = u2._width || u2.width, d3 = c2.barwidth;
            if (i(p3)) {
              var v2 = Array.prototype.slice.call(p3, 0, s2.length);
              for (r3 = 0; r3 < v2.length; r3++)
                n2(v2[r3]) || (v2[r3] = d3);
              for (r3 = v2.length; r3 < s2.length; r3++)
                v2.push(d3);
              if (c2.barwidth = v2, void 0 === f3) {
                for (o2 = [], r3 = 0; r3 < s2.length; r3++)
                  o2.push(h2 + (d3 - v2[r3]) / 2);
                c2.poffset = o2;
              }
            } else
              void 0 !== p3 && (c2.barwidth = p3, void 0 === f3 && (c2.poffset = h2 + (d3 - p3) / 2));
          }
        }
        function d2(t3, e3) {
          for (var r3 = e3.traces, n3 = x(t3), i2 = 0; i2 < r3.length; i2++)
            for (var a2 = r3[i2], o2 = a2[0].t, s2 = o2.poffset, l2 = Array.isArray(s2), u2 = o2.barwidth, c2 = Array.isArray(u2), f3 = 0; f3 < a2.length; f3++) {
              var h2 = a2[f3], p3 = h2.w = c2 ? u2[f3] : u2;
              void 0 === h2.p && (h2.p = h2[n3], h2["orig_" + n3] = h2[n3]);
              var d3 = (l2 ? s2[f3] : s2) + p3 / 2;
              h2[n3] = h2.p + d3;
            }
        }
        function v(t3, e3, r3) {
          var n3 = e3.traces, i2 = e3.minDiff / 2;
          s.minDtick(t3, e3.minDiff, e3.distinctPositions[0], r3);
          for (var a2 = 0; a2 < n3.length; a2++) {
            var o2, l2, u2, c2, f3 = n3[a2], h2 = f3[0], p3 = h2.trace, d3 = [];
            for (c2 = 0; c2 < f3.length; c2++)
              l2 = (o2 = f3[c2]).p - i2, u2 = o2.p + i2, d3.push(l2, u2);
            if (p3.width || p3.offset) {
              var v2 = h2.t, g3 = v2.poffset, y2 = v2.barwidth, m3 = Array.isArray(g3), x2 = Array.isArray(y2);
              for (c2 = 0; c2 < f3.length; c2++) {
                o2 = f3[c2];
                var b = m3 ? g3[c2] : g3, _ = x2 ? y2[c2] : y2;
                u2 = (l2 = o2.p + b) + _, d3.push(l2, u2);
              }
            }
            p3._extremes[t3._id] = s.findExtremes(t3, d3, { padded: false });
          }
        }
        function g2(t3, e3) {
          for (var r3 = e3.traces, n3 = x(t3), i2 = 0; i2 < r3.length; i2++) {
            for (var a2 = r3[i2], o2 = a2[0].trace, l2 = "scatter" === o2.type, u2 = "v" === o2.orientation, c2 = [], f3 = false, h2 = 0; h2 < a2.length; h2++) {
              var p3 = a2[h2], d3 = l2 ? 0 : p3.b, v2 = l2 ? u2 ? p3.y : p3.x : d3 + p3.s;
              p3[n3] = v2, c2.push(v2), p3.hasB && c2.push(d3), p3.hasB && p3.b || (f3 = true);
            }
            o2._extremes[t3._id] = s.findExtremes(t3, c2, { tozero: f3, padded: true });
          }
        }
        function y(t3) {
          for (var e3 = t3.traces, r3 = 0; r3 < e3.length; r3++)
            for (var n3 = e3[r3], i2 = 0; i2 < n3.length; i2++) {
              var o2 = n3[i2];
              o2.s !== a && t3.put(o2.p, o2.b + o2.s);
            }
        }
        function m2(t3, e3, r3) {
          var i2 = e3.traces, o2 = x(t3), l2 = "fraction" === r3.norm ? 1 : 100, u2 = l2 / 1e9, c2 = t3.l2c(t3.c2l(0)), f3 = "stack" === r3.mode ? l2 : c2;
          function h2(e4) {
            return n2(t3.c2l(e4)) && (e4 < c2 - u2 || e4 > f3 + u2 || !n2(c2));
          }
          for (var p3 = 0; p3 < i2.length; p3++) {
            for (var d3 = i2[p3], v2 = d3[0].trace, g3 = [], y2 = false, m3 = false, b = 0; b < d3.length; b++) {
              var _ = d3[b];
              if (_.s !== a) {
                var w2 = Math.abs(l2 / e3.get(_.p, _.s));
                _.b *= w2, _.s *= w2;
                var T = _.b, k = T + _.s;
                _[o2] = k, g3.push(k), m3 = m3 || h2(k), _.hasB && (g3.push(T), m3 = m3 || h2(T)), _.hasB && _.b || (y2 = true);
              }
            }
            v2._extremes[t3._id] = s.findExtremes(t3, g3, { tozero: y2, padded: m3 });
          }
        }
        function x(t3) {
          return t3._id.charAt(0);
        }
        t2.exports = { crossTraceCalc: function(t3, e3) {
          for (var r3 = e3.xaxis, n3 = e3.yaxis, i2 = t3._fullLayout, a2 = t3._fullData, s2 = t3.calcdata, l2 = [], u2 = [], f3 = 0; f3 < a2.length; f3++) {
            var h2 = a2[f3];
            if (true === h2.visible && o.traceIs(h2, "bar") && h2.xaxis === r3._id && h2.yaxis === n3._id && ("h" === h2.orientation ? l2.push(s2[f3]) : u2.push(s2[f3]), h2._computePh))
              for (var p3 = t3.calcdata[f3], d3 = 0; d3 < p3.length; d3++)
                "function" == typeof p3[d3].ph0 && (p3[d3].ph0 = p3[d3].ph0()), "function" == typeof p3[d3].ph1 && (p3[d3].ph1 = p3[d3].ph1());
          }
          var v2 = { xCat: "category" === r3.type || "multicategory" === r3.type, yCat: "category" === n3.type || "multicategory" === n3.type, mode: i2.barmode, norm: i2.barnorm, gap: i2.bargap, groupgap: i2.bargroupgap };
          c(t3, r3, n3, u2, v2), c(t3, n3, r3, l2, v2);
        }, setGroupPositions: c };
      }, 90769: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901), a = r2(73972), o = r2(67513), s = r2(73927), l = r2(98340), u = r2(26125), c = r2(1486), f2 = n2.coerceFont;
        function h(t3, e3, r3, i2, a2, o2) {
          var s2 = !(false === (o2 = o2 || {}).moduleHasSelected), l2 = !(false === o2.moduleHasUnselected), u2 = !(false === o2.moduleHasConstrain), c2 = !(false === o2.moduleHasCliponaxis), h2 = !(false === o2.moduleHasTextangle), p2 = !(false === o2.moduleHasInsideanchor), d2 = !!o2.hasPathbar, v = Array.isArray(a2) || "auto" === a2, g2 = v || "inside" === a2, y = v || "outside" === a2;
          if (g2 || y) {
            var m2 = f2(i2, "textfont", r3.font), x = n2.extendFlat({}, m2), b = !(t3.textfont && t3.textfont.color);
            if (b && delete x.color, f2(i2, "insidetextfont", x), d2) {
              var _ = n2.extendFlat({}, m2);
              b && delete _.color, f2(i2, "pathbar.textfont", _);
            }
            y && f2(i2, "outsidetextfont", m2), s2 && i2("selected.textfont.color"), l2 && i2("unselected.textfont.color"), u2 && i2("constraintext"), c2 && i2("cliponaxis"), h2 && i2("textangle"), i2("texttemplate");
          }
          g2 && p2 && i2("insidetextanchor");
        }
        t2.exports = { supplyDefaults: function(t3, e3, r3, u2) {
          function f3(r4, i2) {
            return n2.coerce(t3, e3, c, r4, i2);
          }
          if (o(t3, e3, u2, f3)) {
            s(t3, e3, u2, f3), f3("xhoverformat"), f3("yhoverformat"), f3("orientation", e3.x && !e3.y ? "h" : "v"), f3("base"), f3("offset"), f3("width"), f3("text"), f3("hovertext"), f3("hovertemplate");
            var p2 = f3("textposition");
            h(t3, 0, u2, f3, p2, { moduleHasSelected: true, moduleHasUnselected: true, moduleHasConstrain: true, moduleHasCliponaxis: true, moduleHasTextangle: true, moduleHasInsideanchor: true }), l(t3, e3, f3, r3, u2);
            var d2 = (e3.marker.line || {}).color, v = a.getComponentMethod("errorbars", "supplyDefaults");
            v(t3, e3, d2 || i.defaultLine, { axis: "y" }), v(t3, e3, d2 || i.defaultLine, { axis: "x", inherit: "y" }), n2.coerceSelectionMarkerOpacity(e3, f3);
          } else
            e3.visible = false;
        }, crossTraceDefaults: function(t3, e3) {
          var r3, i2;
          function a2(t4) {
            return n2.coerce(i2._input, i2, c, t4);
          }
          if ("group" === e3.barmode)
            for (var o2 = 0; o2 < t3.length; o2++)
              "bar" === (i2 = t3[o2]).type && (r3 = i2._input, u(r3, i2, e3, a2));
        }, handleText: h };
      }, 58065: function(t2) {
        t2.exports = function(t3, e2, r2) {
          return t3.x = "xVal" in e2 ? e2.xVal : e2.x, t3.y = "yVal" in e2 ? e2.yVal : e2.y, e2.xa && (t3.xaxis = e2.xa), e2.ya && (t3.yaxis = e2.ya), "h" === r2.orientation ? (t3.label = t3.y, t3.value = t3.x) : (t3.label = t3.x, t3.value = t3.y), t3;
        };
      }, 69383: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(84267), a = r2(71828).isArrayOrTypedArray;
        e2.coerceString = function(t3, e3, r3) {
          if ("string" == typeof e3) {
            if (e3 || !t3.noBlank)
              return e3;
          } else if (("number" == typeof e3 || true === e3) && !t3.strict)
            return String(e3);
          return void 0 !== r3 ? r3 : t3.dflt;
        }, e2.coerceNumber = function(t3, e3, r3) {
          if (n2(e3)) {
            e3 = +e3;
            var i2 = t3.min, a2 = t3.max;
            if (!(void 0 !== i2 && e3 < i2 || void 0 !== a2 && e3 > a2))
              return e3;
          }
          return void 0 !== r3 ? r3 : t3.dflt;
        }, e2.coerceColor = function(t3, e3, r3) {
          return i(e3).isValid() ? e3 : void 0 !== r3 ? r3 : t3.dflt;
        }, e2.coerceEnumerated = function(t3, e3, r3) {
          return t3.coerceNumber && (e3 = +e3), -1 !== t3.values.indexOf(e3) ? e3 : void 0 !== r3 ? r3 : t3.dflt;
        }, e2.getValue = function(t3, e3) {
          var r3;
          return Array.isArray(t3) ? e3 < t3.length && (r3 = t3[e3]) : r3 = t3, r3;
        }, e2.getLineWidth = function(t3, e3) {
          return 0 < e3.mlw ? e3.mlw : a(t3.marker.line.width) ? 0 : t3.marker.line.width;
        };
      }, 95423: function(t2, e2, r2) {
        var n2 = r2(30211), i = r2(73972), a = r2(7901), o = r2(71828).fillText, s = r2(69383).getLineWidth, l = r2(89298).hoverLabelText, u = r2(50606).BADNUM;
        function c(t3, e3, r3, i2, a2) {
          var s2, c2, f3, h, p2, d2, v, g2 = t3.cd, y = g2[0].trace, m2 = g2[0].t, x = "closest" === i2, b = "waterfall" === y.type, _ = t3.maxHoverDistance, w2 = t3.maxSpikeDistance;
          "h" === y.orientation ? (s2 = r3, c2 = e3, f3 = "y", h = "x", p2 = D, d2 = O) : (s2 = e3, c2 = r3, f3 = "x", h = "y", d2 = D, p2 = O);
          var T = y[f3 + "period"], k = x || T;
          function A(t4) {
            return S(t4, -1);
          }
          function M(t4) {
            return S(t4, 1);
          }
          function S(t4, e4) {
            var r4 = t4.w;
            return t4[f3] + e4 * r4 / 2;
          }
          function E(t4) {
            return t4[f3 + "End"] - t4[f3 + "Start"];
          }
          var L = x ? A : T ? function(t4) {
            return t4.p - E(t4) / 2;
          } : function(t4) {
            return Math.min(A(t4), t4.p - m2.bardelta / 2);
          }, C = x ? M : T ? function(t4) {
            return t4.p + E(t4) / 2;
          } : function(t4) {
            return Math.max(M(t4), t4.p + m2.bardelta / 2);
          };
          function P(t4, e4, r4) {
            return a2.finiteRange && (r4 = 0), n2.inbox(t4 - s2, e4 - s2, r4 + Math.min(1, Math.abs(e4 - t4) / v) - 1);
          }
          function O(t4) {
            return P(L(t4), C(t4), _);
          }
          function I(t4) {
            var e4 = t4[h];
            if (b) {
              var r4 = Math.abs(t4.rawS) || 0;
              c2 > 0 ? e4 += r4 : c2 < 0 && (e4 -= r4);
            }
            return e4;
          }
          function D(t4) {
            var e4 = c2, r4 = t4.b, i3 = I(t4);
            return n2.inbox(r4 - e4, i3 - e4, _ + (i3 - e4) / (i3 - r4) - 1);
          }
          var z = t3[f3 + "a"], R = t3[h + "a"];
          v = Math.abs(z.r2c(z.range[1]) - z.r2c(z.range[0]));
          var F = n2.getDistanceFunction(i2, p2, d2, function(t4) {
            return (p2(t4) + d2(t4)) / 2;
          });
          if (n2.getClosest(g2, F, t3), false !== t3.index && g2[t3.index].p !== u) {
            k || (L = function(t4) {
              return Math.min(A(t4), t4.p - m2.bargroupwidth / 2);
            }, C = function(t4) {
              return Math.max(M(t4), t4.p + m2.bargroupwidth / 2);
            });
            var B = g2[t3.index], N = y.base ? B.b + B.s : B.s;
            t3[h + "0"] = t3[h + "1"] = R.c2p(B[h], true), t3[h + "LabelVal"] = N;
            var j = m2.extents[m2.extents.round(B.p)];
            t3[f3 + "0"] = z.c2p(x ? L(B) : j[0], true), t3[f3 + "1"] = z.c2p(x ? C(B) : j[1], true);
            var U = void 0 !== B.orig_p;
            return t3[f3 + "LabelVal"] = U ? B.orig_p : B.p, t3.labelLabel = l(z, t3[f3 + "LabelVal"], y[f3 + "hoverformat"]), t3.valueLabel = l(R, t3[h + "LabelVal"], y[h + "hoverformat"]), t3.baseLabel = l(R, B.b, y[h + "hoverformat"]), t3.spikeDistance = (function(t4) {
              var e4 = c2, r4 = t4.b, i3 = I(t4);
              return n2.inbox(r4 - e4, i3 - e4, w2 + (i3 - e4) / (i3 - r4) - 1);
            }(B) + function(t4) {
              return P(A(t4), M(t4), w2);
            }(B)) / 2, t3[f3 + "Spike"] = z.c2p(B.p, true), o(B, y, t3), t3.hovertemplate = y.hovertemplate, t3;
          }
        }
        function f2(t3, e3) {
          var r3 = e3.mcc || t3.marker.color, n3 = e3.mlcc || t3.marker.line.color, i2 = s(t3, e3);
          return a.opacity(r3) ? r3 : a.opacity(n3) && i2 ? n3 : void 0;
        }
        t2.exports = { hoverPoints: function(t3, e3, r3, n3, a2) {
          var o2 = c(t3, e3, r3, n3, a2);
          if (o2) {
            var s2 = o2.cd, l2 = s2[0].trace, u2 = s2[o2.index];
            return o2.color = f2(l2, u2), i.getComponentMethod("errorbars", "hoverInfo")(u2, l2, o2), [o2];
          }
        }, hoverOnBars: c, getTraceColor: f2 };
      }, 60822: function(t2, e2, r2) {
        t2.exports = { attributes: r2(1486), layoutAttributes: r2(43641), supplyDefaults: r2(90769).supplyDefaults, crossTraceDefaults: r2(90769).crossTraceDefaults, supplyLayoutDefaults: r2(13957), calc: r2(92290), crossTraceCalc: r2(11661).crossTraceCalc, colorbar: r2(4898), arraysToCalcdata: r2(75341), plot: r2(17295).plot, style: r2(16688).style, styleOnSelect: r2(16688).styleOnSelect, hoverPoints: r2(95423).hoverPoints, eventData: r2(58065), selectPoints: r2(81974), moduleType: "trace", name: "bar", basePlotModule: r2(93612), categories: ["bar-like", "cartesian", "svg", "bar", "oriented", "errorBarsOK", "showLegend", "zoomScale"], animatable: true, meta: {} };
      }, 43641: function(t2) {
        t2.exports = { barmode: { valType: "enumerated", values: ["stack", "group", "overlay", "relative"], dflt: "group", editType: "calc" }, barnorm: { valType: "enumerated", values: ["", "fraction", "percent"], dflt: "", editType: "calc" }, bargap: { valType: "number", min: 0, max: 1, editType: "calc" }, bargroupgap: { valType: "number", min: 0, max: 1, dflt: 0, editType: "calc" } };
      }, 13957: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(89298), a = r2(71828), o = r2(43641);
        t2.exports = function(t3, e3, r3) {
          function s(r4, n3) {
            return a.coerce(t3, e3, o, r4, n3);
          }
          for (var l = false, u = false, c = false, f2 = {}, h = s("barmode"), p2 = 0; p2 < r3.length; p2++) {
            var d2 = r3[p2];
            if (n2.traceIs(d2, "bar") && d2.visible) {
              if (l = true, "group" === h) {
                var v = d2.xaxis + d2.yaxis;
                f2[v] && (c = true), f2[v] = true;
              }
              d2.visible && "histogram" === d2.type && "category" !== i.getFromId({ _fullLayout: e3 }, d2["v" === d2.orientation ? "xaxis" : "yaxis"]).type && (u = true);
            }
          }
          l ? ("overlay" !== h && s("barnorm"), s("bargap", u && !c ? 0 : 0.2), s("bargroupgap")) : delete e3.barmode;
        };
      }, 17295: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(92770), a = r2(71828), o = r2(63893), s = r2(7901), l = r2(91424), u = r2(73972), c = r2(89298).tickText, f2 = r2(72597), h = f2.recordMinTextSize, p2 = f2.clearMinTextSize, d2 = r2(16688), v = r2(69383), g2 = r2(97313), y = r2(1486), m2 = y.text, x = y.textposition, b = r2(23469).appendArrayPointValue, _ = g2.TEXTPAD;
        function w2(t3) {
          return t3.id;
        }
        function T(t3) {
          if (t3.ids)
            return w2;
        }
        function k(t3, e3) {
          return t3 < e3 ? 1 : -1;
        }
        function A(t3, e3, r3, n3) {
          var i2;
          return !e3.uniformtext.mode && M(r3) ? (n3 && (i2 = n3()), t3.transition().duration(r3.duration).ease(r3.easing).each("end", function() {
            i2 && i2();
          }).each("interrupt", function() {
            i2 && i2();
          })) : t3;
        }
        function M(t3) {
          return t3 && t3.duration > 0;
        }
        function S(t3) {
          return "auto" === t3 ? 0 : t3;
        }
        function E(t3, e3) {
          var r3 = Math.PI / 180 * e3, n3 = Math.abs(Math.sin(r3)), i2 = Math.abs(Math.cos(r3));
          return { x: t3.width * i2 + t3.height * n3, y: t3.width * n3 + t3.height * i2 };
        }
        function L(t3, e3, r3, n3, i2, a2) {
          var o2 = !!a2.isHorizontal, s2 = !!a2.constrained, l2 = a2.angle || 0, u2 = a2.anchor || "end", c2 = "end" === u2, f3 = "start" === u2, h2 = ((a2.leftToRight || 0) + 1) / 2, p3 = 1 - h2, d3 = i2.width, v2 = i2.height, g3 = Math.abs(e3 - t3), y2 = Math.abs(n3 - r3), m3 = g3 > 2 * _ && y2 > 2 * _ ? _ : 0;
          g3 -= 2 * m3, y2 -= 2 * m3;
          var x2 = S(l2);
          "auto" !== l2 || d3 <= g3 && v2 <= y2 || !(d3 > g3 || v2 > y2) || (d3 > y2 || v2 > g3) && d3 < v2 == g3 < y2 || (x2 += 90);
          var b2 = E(i2, x2), w3 = 1;
          s2 && (w3 = Math.min(1, g3 / b2.x, y2 / b2.y));
          var T2 = i2.left * p3 + i2.right * h2, A2 = (i2.top + i2.bottom) / 2, M2 = (t3 + _) * p3 + (e3 - _) * h2, L2 = (r3 + n3) / 2, C = 0, P = 0;
          if (f3 || c2) {
            var O = (o2 ? b2.x : b2.y) / 2, I = o2 ? k(t3, e3) : k(r3, n3);
            o2 ? f3 ? (M2 = t3 + I * m3, C = -I * O) : (M2 = e3 - I * m3, C = I * O) : f3 ? (L2 = r3 + I * m3, P = -I * O) : (L2 = n3 - I * m3, P = I * O);
          }
          return { textX: T2, textY: A2, targetX: M2, targetY: L2, anchorX: C, anchorY: P, scale: w3, rotate: x2 };
        }
        t2.exports = { plot: function(t3, e3, r3, f3, g3, y2) {
          var w3 = e3.xaxis, C = e3.yaxis, P = t3._fullLayout, O = t3._context.staticPlot;
          g3 || (g3 = { mode: P.barmode, norm: P.barmode, gap: P.bargap, groupgap: P.bargroupgap }, p2("bar", P));
          var I = a.makeTraceGroups(f3, r3, "trace bars").each(function(r4) {
            var u2 = n2.select(this), f4 = r4[0].trace, p3 = "waterfall" === f4.type, I2 = "funnel" === f4.type, D = "bar" === f4.type || I2, z = 0;
            p3 && f4.connector.visible && "between" === f4.connector.mode && (z = f4.connector.line.width / 2);
            var R = "h" === f4.orientation, F = M(g3), B = a.ensureSingle(u2, "g", "points"), N = T(f4), j = B.selectAll("g.point").data(a.identity, N);
            j.enter().append("g").classed("point", true), j.exit().remove(), j.each(function(u3, p4) {
              var T2, M2, I3 = n2.select(this), B2 = function(t4, e4, r5, n3) {
                var i2 = [], a2 = [], o2 = n3 ? e4 : r5, s2 = n3 ? r5 : e4;
                return i2[0] = o2.c2p(t4.s0, true), a2[0] = s2.c2p(t4.p0, true), i2[1] = o2.c2p(t4.s1, true), a2[1] = s2.c2p(t4.p1, true), n3 ? [i2, a2] : [a2, i2];
              }(u3, w3, C, R), N2 = B2[0][0], j2 = B2[0][1], U2 = B2[1][0], V = B2[1][1], H = 0 == (R ? j2 - N2 : V - U2);
              if (H && D && v.getLineWidth(f4, u3) && (H = false), H || (H = !(i(N2) && i(j2) && i(U2) && i(V))), u3.isBlank = H, H && (R ? j2 = N2 : V = U2), z && !H && (R ? (N2 -= k(N2, j2) * z, j2 += k(N2, j2) * z) : (U2 -= k(U2, V) * z, V += k(U2, V) * z)), "waterfall" === f4.type) {
                if (!H) {
                  var q2 = f4[u3.dir].marker;
                  T2 = q2.line.width, M2 = q2.color;
                }
              } else
                T2 = v.getLineWidth(f4, u3), M2 = u3.mc || f4.marker.color;
              function G(t4) {
                var e4 = n2.round(T2 / 2 % 1, 2);
                return 0 === g3.gap && 0 === g3.groupgap ? n2.round(Math.round(t4) - e4, 2) : t4;
              }
              if (!t3._context.staticPlot) {
                var Z = s.opacity(M2) < 1 || T2 > 0.01 ? G : function(t4, e4, r5) {
                  return r5 && t4 === e4 ? t4 : Math.abs(t4 - e4) >= 2 ? G(t4) : t4 > e4 ? Math.ceil(t4) : Math.floor(t4);
                };
                N2 = Z(N2, j2, R), j2 = Z(j2, N2, R), U2 = Z(U2, V, !R), V = Z(V, U2, !R);
              }
              var Y = A(a.ensureSingle(I3, "path"), P, g3, y2);
              if (Y.style("vector-effect", O ? "none" : "non-scaling-stroke").attr("d", isNaN((j2 - N2) * (V - U2)) || H && t3._context.staticPlot ? "M0,0Z" : "M" + N2 + "," + U2 + "V" + V + "H" + j2 + "V" + U2 + "Z").call(l.setClipUrl, e3.layerClipId, t3), !P.uniformtext.mode && F) {
                var W = l.makePointStyleFns(f4);
                l.singlePointStyle(u3, Y, f4, W, t3);
              }
              !function(t4, e4, r5, n3, i2, s2, u4, f5, p5, g4, y3) {
                var w4, T3 = e4.xaxis, M3 = e4.yaxis, C2 = t4._fullLayout;
                function P2(e5, r6, n4) {
                  return a.ensureSingle(e5, "text").text(r6).attr({ class: "bartext bartext-" + w4, "text-anchor": "middle", "data-notex": 1 }).call(l.font, n4).call(o.convertToTspans, t4);
                }
                var O2 = n3[0].trace, I4 = "h" === O2.orientation, D2 = function(t5, e5, r6, n4, i3) {
                  var o2, s3 = e5[0].trace;
                  return o2 = s3.texttemplate ? function(t6, e6, r7, n5, i4) {
                    var o3 = e6[0].trace, s4 = a.castOption(o3, r7, "texttemplate");
                    if (!s4)
                      return "";
                    var l2, u5, f6, h2, p6 = "histogram" === o3.type, d3 = "waterfall" === o3.type, v2 = "funnel" === o3.type, g5 = "h" === o3.orientation;
                    function y4(t7) {
                      return c(h2, h2.c2l(t7), true).text;
                    }
                    g5 ? (l2 = "y", u5 = i4, f6 = "x", h2 = n5) : (l2 = "x", u5 = n5, f6 = "y", h2 = i4);
                    var m3, x2 = e6[r7], _2 = {};
                    _2.label = x2.p, _2.labelLabel = _2[l2 + "Label"] = (m3 = x2.p, c(u5, u5.c2l(m3), true).text);
                    var w5 = a.castOption(o3, x2.i, "text");
                    (0 === w5 || w5) && (_2.text = w5), _2.value = x2.s, _2.valueLabel = _2[f6 + "Label"] = y4(x2.s);
                    var T4 = {};
                    b(T4, o3, x2.i), (p6 || void 0 === T4.x) && (T4.x = g5 ? _2.value : _2.label), (p6 || void 0 === T4.y) && (T4.y = g5 ? _2.label : _2.value), (p6 || void 0 === T4.xLabel) && (T4.xLabel = g5 ? _2.valueLabel : _2.labelLabel), (p6 || void 0 === T4.yLabel) && (T4.yLabel = g5 ? _2.labelLabel : _2.valueLabel), d3 && (_2.delta = +x2.rawS || x2.s, _2.deltaLabel = y4(_2.delta), _2.final = x2.v, _2.finalLabel = y4(_2.final), _2.initial = _2.final - _2.delta, _2.initialLabel = y4(_2.initial)), v2 && (_2.value = x2.s, _2.valueLabel = y4(_2.value), _2.percentInitial = x2.begR, _2.percentInitialLabel = a.formatPercent(x2.begR), _2.percentPrevious = x2.difR, _2.percentPreviousLabel = a.formatPercent(x2.difR), _2.percentTotal = x2.sumR, _2.percenTotalLabel = a.formatPercent(x2.sumR));
                    var k2 = a.castOption(o3, x2.i, "customdata");
                    return k2 && (_2.customdata = k2), a.texttemplateString(s4, _2, t6._d3locale, T4, _2, o3._meta || {});
                  }(t5, e5, r6, n4, i3) : s3.textinfo ? function(t6, e6, r7, n5) {
                    var i4 = t6[0].trace, o3 = "h" === i4.orientation, s4 = "waterfall" === i4.type, l2 = "funnel" === i4.type;
                    function u5(t7) {
                      return c(o3 ? r7 : n5, +t7, true).text;
                    }
                    var f6, h2, p6 = i4.textinfo, d3 = t6[e6], v2 = p6.split("+"), g5 = [], y4 = function(t7) {
                      return -1 !== v2.indexOf(t7);
                    };
                    if (y4("label") && g5.push((h2 = t6[e6].p, c(o3 ? n5 : r7, h2, true).text)), y4("text") && (0 === (f6 = a.castOption(i4, d3.i, "text")) || f6) && g5.push(f6), s4) {
                      var m3 = +d3.rawS || d3.s, x2 = d3.v, b2 = x2 - m3;
                      y4("initial") && g5.push(u5(b2)), y4("delta") && g5.push(u5(m3)), y4("final") && g5.push(u5(x2));
                    }
                    if (l2) {
                      y4("value") && g5.push(u5(d3.s));
                      var _2 = 0;
                      y4("percent initial") && _2++, y4("percent previous") && _2++, y4("percent total") && _2++;
                      var w5 = _2 > 1;
                      y4("percent initial") && (f6 = a.formatPercent(d3.begR), w5 && (f6 += " of initial"), g5.push(f6)), y4("percent previous") && (f6 = a.formatPercent(d3.difR), w5 && (f6 += " of previous"), g5.push(f6)), y4("percent total") && (f6 = a.formatPercent(d3.sumR), w5 && (f6 += " of total"), g5.push(f6));
                    }
                    return g5.join("<br>");
                  }(e5, r6, n4, i3) : v.getValue(s3.text, r6), v.coerceString(m2, o2);
                }(C2, n3, i2, T3, M3);
                w4 = function(t5, e5) {
                  var r6 = v.getValue(t5.textposition, e5);
                  return v.coerceEnumerated(x, r6);
                }(O2, i2);
                var z2 = "stack" === g4.mode || "relative" === g4.mode, R2 = n3[i2], F2 = !z2 || R2._outmost;
                if (D2 && "none" !== w4 && (!R2.isBlank && s2 !== u4 && f5 !== p5 || "auto" !== w4 && "inside" !== w4)) {
                  var B3 = C2.font, N3 = d2.getBarColor(n3[i2], O2), j3 = d2.getInsideTextFont(O2, i2, B3, N3), U3 = d2.getOutsideTextFont(O2, i2, B3), V2 = r5.datum();
                  I4 ? "log" === T3.type && V2.s0 <= 0 && (s2 = T3.range[0] < T3.range[1] ? 0 : T3._length) : "log" === M3.type && V2.s0 <= 0 && (f5 = M3.range[0] < M3.range[1] ? M3._length : 0);
                  var H2, q3, G2, Z2, Y2, W2 = Math.abs(u4 - s2) - 2 * _, X = Math.abs(p5 - f5) - 2 * _;
                  if ("outside" === w4 && (F2 || R2.hasB || (w4 = "inside")), "auto" === w4 && (F2 ? (w4 = "inside", H2 = P2(r5, D2, Y2 = a.ensureUniformFontSize(t4, j3)), G2 = (q3 = l.bBox(H2.node())).width, Z2 = q3.height, G2 > 0 && Z2 > 0 && (G2 <= W2 && Z2 <= X || G2 <= X && Z2 <= W2 || (I4 ? W2 >= G2 * (X / Z2) : X >= Z2 * (W2 / G2))) ? w4 = "inside" : (w4 = "outside", H2.remove(), H2 = null)) : w4 = "inside"), !H2) {
                    var J = (H2 = P2(r5, D2, Y2 = a.ensureUniformFontSize(t4, "outside" === w4 ? U3 : j3))).attr("transform");
                    if (H2.attr("transform", ""), G2 = (q3 = l.bBox(H2.node())).width, Z2 = q3.height, H2.attr("transform", J), G2 <= 0 || Z2 <= 0)
                      return void H2.remove();
                  }
                  var K, $ = O2.textangle;
                  K = "outside" === w4 ? function(t5, e5, r6, n4, i3, a2) {
                    var o2, s3 = !!a2.isHorizontal, l2 = !!a2.constrained, u5 = a2.angle || 0, c2 = i3.width, f6 = i3.height, h2 = Math.abs(e5 - t5), p6 = Math.abs(n4 - r6);
                    o2 = s3 ? p6 > 2 * _ ? _ : 0 : h2 > 2 * _ ? _ : 0;
                    var d3 = 1;
                    l2 && (d3 = s3 ? Math.min(1, p6 / f6) : Math.min(1, h2 / c2));
                    var v2 = S(u5), g5 = E(i3, v2), y4 = (s3 ? g5.x : g5.y) / 2, m3 = (i3.left + i3.right) / 2, x2 = (i3.top + i3.bottom) / 2, b2 = (t5 + e5) / 2, w5 = (r6 + n4) / 2, T4 = 0, A2 = 0, M4 = s3 ? k(e5, t5) : k(r6, n4);
                    return s3 ? (b2 = e5 - M4 * o2, T4 = M4 * y4) : (w5 = n4 + M4 * o2, A2 = -M4 * y4), { textX: m3, textY: x2, targetX: b2, targetY: w5, anchorX: T4, anchorY: A2, scale: d3, rotate: v2 };
                  }(s2, u4, f5, p5, q3, { isHorizontal: I4, constrained: "both" === O2.constraintext || "outside" === O2.constraintext, angle: $ }) : L(s2, u4, f5, p5, q3, { isHorizontal: I4, constrained: "both" === O2.constraintext || "inside" === O2.constraintext, angle: $, anchor: O2.insidetextanchor }), K.fontSize = Y2.size, h("histogram" === O2.type ? "bar" : O2.type, K, C2), R2.transform = K;
                  var Q = A(H2, C2, g4, y3);
                  a.setTransormAndDisplay(Q, K);
                } else
                  r5.select("text").remove();
              }(t3, e3, I3, r4, p4, N2, j2, U2, V, g3, y2), e3.layerClipId && l.hideOutsideRangePoint(u3, I3.select("text"), w3, C, f4.xcalendar, f4.ycalendar);
            });
            var U = false === f4.cliponaxis;
            l.setClipUrl(u2, U ? null : e3.layerClipId, t3);
          });
          u.getComponentMethod("errorbars", "plot")(t3, I, e3, g3);
        }, toMoveInsideBar: L };
      }, 81974: function(t2) {
        function e2(t3, e3, r2, n2, i) {
          var a = e3.c2p(n2 ? t3.s0 : t3.p0, true), o = e3.c2p(n2 ? t3.s1 : t3.p1, true), s = r2.c2p(n2 ? t3.p0 : t3.s0, true), l = r2.c2p(n2 ? t3.p1 : t3.s1, true);
          return i ? [(a + o) / 2, (s + l) / 2] : n2 ? [o, (s + l) / 2] : [(a + o) / 2, l];
        }
        t2.exports = function(t3, r2) {
          var n2, i = t3.cd, a = t3.xaxis, o = t3.yaxis, s = i[0].trace, l = "funnel" === s.type, u = "h" === s.orientation, c = [];
          if (false === r2)
            for (n2 = 0; n2 < i.length; n2++)
              i[n2].selected = 0;
          else
            for (n2 = 0; n2 < i.length; n2++) {
              var f2 = i[n2], h = "ct" in f2 ? f2.ct : e2(f2, a, o, u, l);
              r2.contains(h, false, n2, t3) ? (c.push({ pointNumber: n2, x: a.c2d(f2.x), y: o.c2d(f2.y) }), f2.selected = 1) : f2.selected = 0;
            }
          return c;
        };
      }, 61546: function(t2, e2, r2) {
        t2.exports = i;
        var n2 = r2(71828).distinctVals;
        function i(t3, e3) {
          this.traces = t3, this.sepNegVal = e3.sepNegVal, this.overlapNoMerge = e3.overlapNoMerge;
          for (var r3 = 1 / 0, i2 = e3.posAxis._id.charAt(0), a = [], o = 0; o < t3.length; o++) {
            for (var s = t3[o], l = 0; l < s.length; l++) {
              var u = s[l], c = u.p;
              void 0 === c && (c = u[i2]), void 0 !== c && a.push(c);
            }
            s[0] && s[0].width1 && (r3 = Math.min(s[0].width1, r3));
          }
          this.positions = a;
          var f2 = n2(a);
          this.distinctPositions = f2.vals, 1 === f2.vals.length && r3 !== 1 / 0 ? this.minDiff = r3 : this.minDiff = Math.min(f2.minDiff, r3);
          var h = (e3.posAxis || {}).type;
          "category" !== h && "multicategory" !== h || (this.minDiff = 1), this.binWidth = this.minDiff, this.bins = {};
        }
        i.prototype.put = function(t3, e3) {
          var r3 = this.getLabel(t3, e3), n3 = this.bins[r3] || 0;
          return this.bins[r3] = n3 + e3, n3;
        }, i.prototype.get = function(t3, e3) {
          var r3 = this.getLabel(t3, e3);
          return this.bins[r3] || 0;
        }, i.prototype.getLabel = function(t3, e3) {
          return (e3 < 0 && this.sepNegVal ? "v" : "^") + (this.overlapNoMerge ? t3 : Math.round(t3 / this.binWidth));
        };
      }, 16688: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(7901), a = r2(91424), o = r2(71828), s = r2(73972), l = r2(72597).resizeText, u = r2(1486), c = u.textfont, f2 = u.insidetextfont, h = u.outsidetextfont, p2 = r2(69383);
        function d2(t3, e3, r3) {
          a.pointStyle(t3.selectAll("path"), e3, r3), v(t3, e3, r3);
        }
        function v(t3, e3, r3) {
          t3.selectAll("text").each(function(t4) {
            var i2 = n2.select(this), s2 = o.ensureUniformFontSize(r3, g2(i2, t4, e3, r3));
            a.font(i2, s2);
          });
        }
        function g2(t3, e3, r3, n3) {
          var i2 = n3._fullLayout.font, a2 = r3.textfont;
          if (t3.classed("bartext-inside")) {
            var o2 = _(e3, r3);
            a2 = m2(r3, e3.i, i2, o2);
          } else
            t3.classed("bartext-outside") && (a2 = x(r3, e3.i, i2));
          return a2;
        }
        function y(t3, e3, r3) {
          return b(c, t3.textfont, e3, r3);
        }
        function m2(t3, e3, r3, n3) {
          var a2 = y(t3, e3, r3);
          return (void 0 === t3._input.textfont || void 0 === t3._input.textfont.color || Array.isArray(t3.textfont.color) && void 0 === t3.textfont.color[e3]) && (a2 = { color: i.contrast(n3), family: a2.family, size: a2.size }), b(f2, t3.insidetextfont, e3, a2);
        }
        function x(t3, e3, r3) {
          var n3 = y(t3, e3, r3);
          return b(h, t3.outsidetextfont, e3, n3);
        }
        function b(t3, e3, r3, n3) {
          e3 = e3 || {};
          var i2 = p2.getValue(e3.family, r3), a2 = p2.getValue(e3.size, r3), o2 = p2.getValue(e3.color, r3);
          return { family: p2.coerceString(t3.family, i2, n3.family), size: p2.coerceNumber(t3.size, a2, n3.size), color: p2.coerceColor(t3.color, o2, n3.color) };
        }
        function _(t3, e3) {
          return "waterfall" === e3.type ? e3[t3.dir].marker.color : t3.mcc || t3.mc || e3.marker.color;
        }
        t2.exports = { style: function(t3) {
          var e3 = n2.select(t3).selectAll("g.barlayer").selectAll("g.trace");
          l(t3, e3, "bar");
          var r3 = e3.size(), i2 = t3._fullLayout;
          e3.style("opacity", function(t4) {
            return t4[0].trace.opacity;
          }).each(function(t4) {
            ("stack" === i2.barmode && r3 > 1 || 0 === i2.bargap && 0 === i2.bargroupgap && !t4[0].trace.marker.line.width) && n2.select(this).attr("shape-rendering", "crispEdges");
          }), e3.selectAll("g.points").each(function(e4) {
            d2(n2.select(this), e4[0].trace, t3);
          }), s.getComponentMethod("errorbars", "style")(e3);
        }, styleTextPoints: v, styleOnSelect: function(t3, e3, r3) {
          var i2 = e3[0].trace;
          i2.selectedpoints ? function(t4, e4, r4) {
            a.selectedPointStyle(t4.selectAll("path"), e4), function(t5, e5, r5) {
              t5.each(function(t6) {
                var i3, s2 = n2.select(this);
                if (t6.selected) {
                  i3 = o.ensureUniformFontSize(r5, g2(s2, t6, e5, r5));
                  var l2 = e5.selected.textfont && e5.selected.textfont.color;
                  l2 && (i3.color = l2), a.font(s2, i3);
                } else
                  a.selectedTextStyle(s2, e5);
              });
            }(t4.selectAll("text"), e4, r4);
          }(r3, i2, t3) : (d2(r3, i2, t3), s.getComponentMethod("errorbars", "style")(r3));
        }, getInsideTextFont: m2, getOutsideTextFont: x, getBarColor: _, resizeText: l };
      }, 98340: function(t2, e2, r2) {
        var n2 = r2(7901), i = r2(52075).hasColorscale, a = r2(1586), o = r2(71828).coercePattern;
        t2.exports = function(t3, e3, r3, s, l) {
          var u = r3("marker.color", s), c = i(t3, "marker");
          c && a(t3, e3, l, r3, { prefix: "marker.", cLetter: "c" }), r3("marker.line.color", n2.defaultLine), i(t3, "marker.line") && a(t3, e3, l, r3, { prefix: "marker.line.", cLetter: "c" }), r3("marker.line.width"), r3("marker.opacity"), o(r3, "marker.pattern", u, c), r3("selected.marker.color"), r3("unselected.marker.color");
        };
      }, 72597: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828);
        function a(t3) {
          return "_" + t3 + "Text_minsize";
        }
        t2.exports = { recordMinTextSize: function(t3, e3, r3) {
          if (r3.uniformtext.mode) {
            var n3 = a(t3), i2 = r3.uniformtext.minsize, o = e3.scale * e3.fontSize;
            e3.hide = o < i2, r3[n3] = r3[n3] || 1 / 0, e3.hide || (r3[n3] = Math.min(r3[n3], Math.max(o, i2)));
          }
        }, clearMinTextSize: function(t3, e3) {
          e3[a(t3)] = void 0;
        }, resizeText: function(t3, e3, r3) {
          var a2 = t3._fullLayout, o = a2["_" + r3 + "Text_minsize"];
          if (o) {
            var s, l = "hide" === a2.uniformtext.mode;
            switch (r3) {
              case "funnelarea":
              case "pie":
              case "sunburst":
                s = "g.slice";
                break;
              case "treemap":
              case "icicle":
                s = "g.slice, g.pathbar";
                break;
              default:
                s = "g.points > g.point";
            }
            e3.selectAll(s).each(function(t4) {
              var e4 = t4.transform;
              if (e4) {
                e4.scale = l && e4.hide ? 0 : o / e4.fontSize;
                var r4 = n2.select(this).select("text");
                i.setTransormAndDisplay(r4, e4);
              }
            });
          }
        } };
      }, 55023: function(t2, e2, r2) {
        var n2 = r2(5386).f, i = r2(1426).extendFlat, a = r2(81245), o = r2(1486);
        t2.exports = { r: a.r, theta: a.theta, r0: a.r0, dr: a.dr, theta0: a.theta0, dtheta: a.dtheta, thetaunit: a.thetaunit, base: i({}, o.base, {}), offset: i({}, o.offset, {}), width: i({}, o.width, {}), text: i({}, o.text, {}), hovertext: i({}, o.hovertext, {}), marker: o.marker, hoverinfo: a.hoverinfo, hovertemplate: n2(), selected: o.selected, unselected: o.unselected };
      }, 74692: function(t2, e2, r2) {
        var n2 = r2(52075).hasColorscale, i = r2(78803), a = r2(75341), o = r2(11661).setGroupPositions, s = r2(66279), l = r2(73972).traceIs, u = r2(71828).extendFlat;
        t2.exports = { calc: function(t3, e3) {
          for (var r3 = t3._fullLayout, o2 = e3.subplot, l2 = r3[o2].radialaxis, u2 = r3[o2].angularaxis, c = l2.makeCalcdata(e3, "r"), f2 = u2.makeCalcdata(e3, "theta"), h = e3._length, p2 = new Array(h), d2 = c, v = f2, g2 = 0; g2 < h; g2++)
            p2[g2] = { p: v[g2], s: d2[g2] };
          function y(t4) {
            var r4 = e3[t4];
            void 0 !== r4 && (e3["_" + t4] = Array.isArray(r4) ? u2.makeCalcdata(e3, t4) : u2.d2c(r4, e3.thetaunit));
          }
          return "linear" === u2.type && (y("width"), y("offset")), n2(e3, "marker") && i(t3, e3, { vals: e3.marker.color, containerStr: "marker", cLetter: "c" }), n2(e3, "marker.line") && i(t3, e3, { vals: e3.marker.line.color, containerStr: "marker.line", cLetter: "c" }), a(p2, e3), s(p2, e3), p2;
        }, crossTraceCalc: function(t3, e3, r3) {
          for (var n3 = t3.calcdata, i2 = [], a2 = 0; a2 < n3.length; a2++) {
            var s2 = n3[a2], c = s2[0].trace;
            true === c.visible && l(c, "bar") && c.subplot === r3 && i2.push(s2);
          }
          var f2 = u({}, e3.radialaxis, { _id: "x" }), h = e3.angularaxis;
          o(t3, h, f2, i2, { mode: e3.barmode, norm: e3.barnorm, gap: e3.bargap, groupgap: e3.bargroupgap });
        } };
      }, 6135: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(22184).handleRThetaDefaults, a = r2(98340), o = r2(55023);
        t2.exports = function(t3, e3, r3, s) {
          function l(r4, i2) {
            return n2.coerce(t3, e3, o, r4, i2);
          }
          i(t3, e3, s, l) ? (l("thetaunit"), l("base"), l("offset"), l("width"), l("text"), l("hovertext"), l("hovertemplate"), a(t3, e3, l, r3, s), n2.coerceSelectionMarkerOpacity(e3, l)) : e3.visible = false;
        };
      }, 27379: function(t2, e2, r2) {
        var n2 = r2(30211), i = r2(71828), a = r2(95423).getTraceColor, o = i.fillText, s = r2(59150).makeHoverPointText, l = r2(10869).isPtInsidePolygon;
        t2.exports = function(t3, e3, r3) {
          var u = t3.cd, c = u[0].trace, f2 = t3.subplot, h = f2.radialAxis, p2 = f2.angularAxis, d2 = f2.vangles, v = d2 ? l : i.isPtInsideSector, g2 = t3.maxHoverDistance, y = p2._period || 2 * Math.PI, m2 = Math.abs(h.g2p(Math.sqrt(e3 * e3 + r3 * r3))), x = Math.atan2(r3, e3);
          if (h.range[0] > h.range[1] && (x += Math.PI), n2.getClosest(u, function(t4) {
            return v(m2, x, [t4.rp0, t4.rp1], [t4.thetag0, t4.thetag1], d2) ? g2 + Math.min(1, Math.abs(t4.thetag1 - t4.thetag0) / y) - 1 + (t4.rp1 - m2) / (t4.rp1 - t4.rp0) - 1 : 1 / 0;
          }, t3), false !== t3.index) {
            var b = u[t3.index];
            t3.x0 = t3.x1 = b.ct[0], t3.y0 = t3.y1 = b.ct[1];
            var _ = i.extendFlat({}, b, { r: b.s, theta: b.p });
            return o(b, c, t3), s(_, c, f2, t3), t3.hovertemplate = c.hovertemplate, t3.color = a(c, b), t3.xLabelVal = t3.yLabelVal = void 0, b.s < 0 && (t3.idealAlign = "left"), [t3];
          }
        };
      }, 23381: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "barpolar", basePlotModule: r2(23580), categories: ["polar", "bar", "showLegend"], attributes: r2(55023), layoutAttributes: r2(40151), supplyDefaults: r2(6135), supplyLayoutDefaults: r2(19860), calc: r2(74692).calc, crossTraceCalc: r2(74692).crossTraceCalc, plot: r2(60173), colorbar: r2(4898), formatLabels: r2(98608), style: r2(16688).style, styleOnSelect: r2(16688).styleOnSelect, hoverPoints: r2(27379), selectPoints: r2(81974), meta: {} };
      }, 40151: function(t2) {
        t2.exports = { barmode: { valType: "enumerated", values: ["stack", "overlay"], dflt: "stack", editType: "calc" }, bargap: { valType: "number", dflt: 0.1, min: 0, max: 1, editType: "calc" } };
      }, 19860: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(40151);
        t2.exports = function(t3, e3, r3) {
          var a, o = {};
          function s(r4, o2) {
            return n2.coerce(t3[a] || {}, e3[a], i, r4, o2);
          }
          for (var l = 0; l < r3.length; l++) {
            var u = r3[l];
            "barpolar" === u.type && true === u.visible && (o[a = u.subplot] || (s("barmode"), s("bargap"), o[a] = 1));
          }
        };
      }, 60173: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(92770), a = r2(71828), o = r2(91424), s = r2(10869);
        t2.exports = function(t3, e3, r3) {
          var l = t3._context.staticPlot, u = e3.xaxis, c = e3.yaxis, f2 = e3.radialAxis, h = e3.angularAxis, p2 = function(t4) {
            var e4 = t4.cxx, r4 = t4.cyy;
            return t4.vangles ? function(n3, i2, o2, l2) {
              var u2, c2;
              a.angleDelta(o2, l2) > 0 ? (u2 = o2, c2 = l2) : (u2 = l2, c2 = o2);
              var f3 = [s.findEnclosingVertexAngles(u2, t4.vangles)[0], (u2 + c2) / 2, s.findEnclosingVertexAngles(c2, t4.vangles)[1]];
              return s.pathPolygonAnnulus(n3, i2, u2, c2, f3, e4, r4);
            } : function(t5, n3, i2, o2) {
              return a.pathAnnulus(t5, n3, i2, o2, e4, r4);
            };
          }(e3), d2 = e3.layers.frontplot.select("g.barlayer");
          a.makeTraceGroups(d2, r3, "trace bars").each(function() {
            var r4 = n2.select(this), s2 = a.ensureSingle(r4, "g", "points").selectAll("g.point").data(a.identity);
            s2.enter().append("g").style("vector-effect", l ? "none" : "non-scaling-stroke").style("stroke-miterlimit", 2).classed("point", true), s2.exit().remove(), s2.each(function(t4) {
              var e4, r5 = n2.select(this), o2 = t4.rp0 = f2.c2p(t4.s0), s3 = t4.rp1 = f2.c2p(t4.s1), l2 = t4.thetag0 = h.c2g(t4.p0), d3 = t4.thetag1 = h.c2g(t4.p1);
              if (i(o2) && i(s3) && i(l2) && i(d3) && o2 !== s3 && l2 !== d3) {
                var v = f2.c2g(t4.s1), g2 = (l2 + d3) / 2;
                t4.ct = [u.c2p(v * Math.cos(g2)), c.c2p(v * Math.sin(g2))], e4 = p2(o2, s3, l2, d3);
              } else
                e4 = "M0,0Z";
              a.ensureSingle(r5, "path").attr("d", e4);
            }), o.setClipUrl(r4, e3._hasClipOnAxisFalse ? e3.clipIds.forTraces : null, t3);
          });
        };
      }, 53522: function(t2, e2, r2) {
        var n2 = r2(82196), i = r2(1486), a = r2(22399), o = r2(12663).axisHoverFormat, s = r2(5386).f, l = r2(1426).extendFlat, u = n2.marker, c = u.line;
        t2.exports = { y: { valType: "data_array", editType: "calc+clearAxisTypes" }, x: { valType: "data_array", editType: "calc+clearAxisTypes" }, x0: { valType: "any", editType: "calc+clearAxisTypes" }, y0: { valType: "any", editType: "calc+clearAxisTypes" }, dx: { valType: "number", editType: "calc" }, dy: { valType: "number", editType: "calc" }, xperiod: n2.xperiod, yperiod: n2.yperiod, xperiod0: n2.xperiod0, yperiod0: n2.yperiod0, xperiodalignment: n2.xperiodalignment, yperiodalignment: n2.yperiodalignment, xhoverformat: o("x"), yhoverformat: o("y"), name: { valType: "string", editType: "calc+clearAxisTypes" }, q1: { valType: "data_array", editType: "calc+clearAxisTypes" }, median: { valType: "data_array", editType: "calc+clearAxisTypes" }, q3: { valType: "data_array", editType: "calc+clearAxisTypes" }, lowerfence: { valType: "data_array", editType: "calc" }, upperfence: { valType: "data_array", editType: "calc" }, notched: { valType: "boolean", editType: "calc" }, notchwidth: { valType: "number", min: 0, max: 0.5, dflt: 0.25, editType: "calc" }, notchspan: { valType: "data_array", editType: "calc" }, boxpoints: { valType: "enumerated", values: ["all", "outliers", "suspectedoutliers", false], editType: "calc" }, jitter: { valType: "number", min: 0, max: 1, editType: "calc" }, pointpos: { valType: "number", min: -2, max: 2, editType: "calc" }, boxmean: { valType: "enumerated", values: [true, "sd", false], editType: "calc" }, mean: { valType: "data_array", editType: "calc" }, sd: { valType: "data_array", editType: "calc" }, orientation: { valType: "enumerated", values: ["v", "h"], editType: "calc+clearAxisTypes" }, quartilemethod: { valType: "enumerated", values: ["linear", "exclusive", "inclusive"], dflt: "linear", editType: "calc" }, width: { valType: "number", min: 0, dflt: 0, editType: "calc" }, marker: { outliercolor: { valType: "color", dflt: "rgba(0, 0, 0, 0)", editType: "style" }, symbol: l({}, u.symbol, { arrayOk: false, editType: "plot" }), opacity: l({}, u.opacity, { arrayOk: false, dflt: 1, editType: "style" }), angle: l({}, u.angle, { arrayOk: false, editType: "calc" }), size: l({}, u.size, { arrayOk: false, editType: "calc" }), color: l({}, u.color, { arrayOk: false, editType: "style" }), line: { color: l({}, c.color, { arrayOk: false, dflt: a.defaultLine, editType: "style" }), width: l({}, c.width, { arrayOk: false, dflt: 0, editType: "style" }), outliercolor: { valType: "color", editType: "style" }, outlierwidth: { valType: "number", min: 0, dflt: 1, editType: "style" }, editType: "style" }, editType: "plot" }, line: { color: { valType: "color", editType: "style" }, width: { valType: "number", min: 0, dflt: 2, editType: "style" }, editType: "plot" }, fillcolor: n2.fillcolor, whiskerwidth: { valType: "number", min: 0, max: 1, dflt: 0.5, editType: "calc" }, offsetgroup: i.offsetgroup, alignmentgroup: i.alignmentgroup, selected: { marker: n2.selected.marker, editType: "style" }, unselected: { marker: n2.unselected.marker, editType: "style" }, text: l({}, n2.text, {}), hovertext: l({}, n2.hovertext, {}), hovertemplate: s({}), hoveron: { valType: "flaglist", flags: ["boxes", "points"], dflt: "boxes+points", editType: "style" } };
      }, 48518: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(89298), a = r2(42973), o = r2(71828), s = r2(50606).BADNUM, l = o._;
        t2.exports = function(t3, e3) {
          var r3, u2, m2, x, b, _, w2, T = t3._fullLayout, k = i.getFromId(t3, e3.xaxis || "x"), A = i.getFromId(t3, e3.yaxis || "y"), M = [], S = "violin" === e3.type ? "_numViolins" : "_numBoxes";
          "h" === e3.orientation ? (m2 = k, x = "x", b = A, _ = "y", w2 = !!e3.yperiodalignment) : (m2 = A, x = "y", b = k, _ = "x", w2 = !!e3.xperiodalignment);
          var E, L, C, P, O, I, D = function(t4, e4, r4, i2) {
            var s2, l2 = e4 + "0" in t4;
            if (e4 in t4 || l2 && "d" + e4 in t4) {
              var u3 = r4.makeCalcdata(t4, e4);
              return [a(t4, r4, e4, u3).vals, u3];
            }
            s2 = l2 ? t4[e4 + "0"] : "name" in t4 && ("category" === r4.type || n2(t4.name) && -1 !== ["linear", "log"].indexOf(r4.type) || o.isDateTime(t4.name) && "date" === r4.type) ? t4.name : i2;
            for (var c2 = "multicategory" === r4.type ? r4.r2c_just_indices(s2) : r4.d2c(s2, 0, t4[e4 + "calendar"]), f3 = t4._length, h2 = new Array(f3), p3 = 0; p3 < f3; p3++)
              h2[p3] = c2;
            return [h2];
          }(e3, _, b, T[S]), z = D[0], R = D[1], F = o.distinctVals(z, b), B = F.vals, N = F.minDiff / 2, j = "all" === (e3.boxpoints || e3.points) ? o.identity : function(t4) {
            return t4.v < E.lf || t4.v > E.uf;
          };
          if (e3._hasPreCompStats) {
            var U = e3[x], V = function(t4) {
              return m2.d2c((e3[t4] || [])[r3]);
            }, H = 1 / 0, q2 = -1 / 0;
            for (r3 = 0; r3 < e3._length; r3++) {
              var G = z[r3];
              if (n2(G)) {
                if ((E = {}).pos = E[_] = G, w2 && R && (E.orig_p = R[r3]), E.q1 = V("q1"), E.med = V("median"), E.q3 = V("q3"), L = [], U && o.isArrayOrTypedArray(U[r3]))
                  for (u2 = 0; u2 < U[r3].length; u2++)
                    (I = m2.d2c(U[r3][u2])) !== s && (c(O = { v: I, i: [r3, u2] }, e3, [r3, u2]), L.push(O));
                if (E.pts = L.sort(f2), P = (C = E[x] = L.map(h)).length, E.med !== s && E.q1 !== s && E.q3 !== s && E.med >= E.q1 && E.q3 >= E.med) {
                  var Z = V("lowerfence");
                  E.lf = Z !== s && Z <= E.q1 ? Z : p2(E, C, P);
                  var Y = V("upperfence");
                  E.uf = Y !== s && Y >= E.q3 ? Y : d2(E, C, P);
                  var W = V("mean");
                  E.mean = W !== s ? W : P ? o.mean(C, P) : (E.q1 + E.q3) / 2;
                  var X = V("sd");
                  E.sd = W !== s && X >= 0 ? X : P ? o.stdev(C, P, E.mean) : E.q3 - E.q1, E.lo = v(E), E.uo = g2(E);
                  var J = V("notchspan");
                  J = J !== s && J > 0 ? J : y(E, P), E.ln = E.med - J, E.un = E.med + J;
                  var K = E.lf, $ = E.uf;
                  e3.boxpoints && C.length && (K = Math.min(K, C[0]), $ = Math.max($, C[P - 1])), e3.notched && (K = Math.min(K, E.ln), $ = Math.max($, E.un)), E.min = K, E.max = $;
                } else {
                  var Q;
                  o.warn(["Invalid input - make sure that q1 <= median <= q3", "q1 = " + E.q1, "median = " + E.med, "q3 = " + E.q3].join("\n")), Q = E.med !== s ? E.med : E.q1 !== s ? E.q3 !== s ? (E.q1 + E.q3) / 2 : E.q1 : E.q3 !== s ? E.q3 : 0, E.med = Q, E.q1 = E.q3 = Q, E.lf = E.uf = Q, E.mean = E.sd = Q, E.ln = E.un = Q, E.min = E.max = Q;
                }
                H = Math.min(H, E.min), q2 = Math.max(q2, E.max), E.pts2 = L.filter(j), M.push(E);
              }
            }
            e3._extremes[m2._id] = i.findExtremes(m2, [H, q2], { padded: true });
          } else {
            var tt = m2.makeCalcdata(e3, x), et = function(t4, e4) {
              for (var r4 = t4.length, n3 = new Array(r4 + 1), i2 = 0; i2 < r4; i2++)
                n3[i2] = t4[i2] - e4;
              return n3[r4] = t4[r4 - 1] + e4, n3;
            }(B, N), rt = B.length, nt = function(t4) {
              for (var e4 = new Array(t4), r4 = 0; r4 < t4; r4++)
                e4[r4] = [];
              return e4;
            }(rt);
            for (r3 = 0; r3 < e3._length; r3++)
              if (I = tt[r3], n2(I)) {
                var it = o.findBin(z[r3], et);
                it >= 0 && it < rt && (c(O = { v: I, i: r3 }, e3, r3), nt[it].push(O));
              }
            var at = 1 / 0, ot = -1 / 0, st = e3.quartilemethod, lt = "exclusive" === st, ut = "inclusive" === st;
            for (r3 = 0; r3 < rt; r3++)
              if (nt[r3].length > 0) {
                var ct, ft;
                (E = {}).pos = E[_] = B[r3], L = E.pts = nt[r3].sort(f2), P = (C = E[x] = L.map(h)).length, E.min = C[0], E.max = C[P - 1], E.mean = o.mean(C, P), E.sd = o.stdev(C, P, E.mean), E.med = o.interp(C, 0.5), P % 2 && (lt || ut) ? (lt ? (ct = C.slice(0, P / 2), ft = C.slice(P / 2 + 1)) : ut && (ct = C.slice(0, P / 2 + 1), ft = C.slice(P / 2)), E.q1 = o.interp(ct, 0.5), E.q3 = o.interp(ft, 0.5)) : (E.q1 = o.interp(C, 0.25), E.q3 = o.interp(C, 0.75)), E.lf = p2(E, C, P), E.uf = d2(E, C, P), E.lo = v(E), E.uo = g2(E);
                var ht = y(E, P);
                E.ln = E.med - ht, E.un = E.med + ht, at = Math.min(at, E.ln), ot = Math.max(ot, E.un), E.pts2 = L.filter(j), M.push(E);
              }
            e3._extremes[m2._id] = i.findExtremes(m2, e3.notched ? tt.concat([at, ot]) : tt, { padded: true });
          }
          return function(t4, e4) {
            if (o.isArrayOrTypedArray(e4.selectedpoints))
              for (var r4 = 0; r4 < t4.length; r4++) {
                for (var n3 = t4[r4].pts || [], i2 = {}, a2 = 0; a2 < n3.length; a2++)
                  i2[n3[a2].i] = a2;
                o.tagSelected(n3, e4, i2);
              }
          }(M, e3), M.length > 0 ? (M[0].t = { num: T[S], dPos: N, posLetter: _, valLetter: x, labels: { med: l(t3, "median:"), min: l(t3, "min:"), q1: l(t3, "q1:"), q3: l(t3, "q3:"), max: l(t3, "max:"), mean: "sd" === e3.boxmean ? l(t3, "mean ± σ:") : l(t3, "mean:"), lf: l(t3, "lower fence:"), uf: l(t3, "upper fence:") } }, T[S]++, M) : [{ t: { empty: true } }];
        };
        var u = { text: "tx", hovertext: "htx" };
        function c(t3, e3, r3) {
          for (var n3 in u)
            o.isArrayOrTypedArray(e3[n3]) && (Array.isArray(r3) ? o.isArrayOrTypedArray(e3[n3][r3[0]]) && (t3[u[n3]] = e3[n3][r3[0]][r3[1]]) : t3[u[n3]] = e3[n3][r3]);
        }
        function f2(t3, e3) {
          return t3.v - e3.v;
        }
        function h(t3) {
          return t3.v;
        }
        function p2(t3, e3, r3) {
          return 0 === r3 ? t3.q1 : Math.min(t3.q1, e3[Math.min(o.findBin(2.5 * t3.q1 - 1.5 * t3.q3, e3, true) + 1, r3 - 1)]);
        }
        function d2(t3, e3, r3) {
          return 0 === r3 ? t3.q3 : Math.max(t3.q3, e3[Math.max(o.findBin(2.5 * t3.q3 - 1.5 * t3.q1, e3), 0)]);
        }
        function v(t3) {
          return 4 * t3.q1 - 3 * t3.q3;
        }
        function g2(t3) {
          return 4 * t3.q3 - 3 * t3.q1;
        }
        function y(t3, e3) {
          return 0 === e3 ? 0 : 1.57 * (t3.q3 - t3.q1) / Math.sqrt(e3);
        }
      }, 37188: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(71828), a = r2(99082).getAxisGroup, o = ["v", "h"];
        function s(t3, e3, r3, o2) {
          var s2, l, u, c = e3.calcdata, f2 = e3._fullLayout, h = o2._id, p2 = h.charAt(0), d2 = [], v = 0;
          for (s2 = 0; s2 < r3.length; s2++)
            for (u = c[r3[s2]], l = 0; l < u.length; l++)
              d2.push(o2.c2l(u[l].pos, true)), v += (u[l].pts2 || []).length;
          if (d2.length) {
            var g2 = i.distinctVals(d2);
            "category" !== o2.type && "multicategory" !== o2.type || (g2.minDiff = 1);
            var y = g2.minDiff / 2;
            n2.minDtick(o2, g2.minDiff, g2.vals[0], true);
            var m2 = f2["violin" === t3 ? "_numViolins" : "_numBoxes"], x = "group" === f2[t3 + "mode"] && m2 > 1, b = 1 - f2[t3 + "gap"], _ = 1 - f2[t3 + "groupgap"];
            for (s2 = 0; s2 < r3.length; s2++) {
              var w2, T, k, A, M, S, E = (u = c[r3[s2]])[0].trace, L = u[0].t, C = E.width, P = E.side;
              if (C)
                w2 = T = A = C / 2, k = 0;
              else if (w2 = y, x) {
                var O = a(f2, o2._id) + E.orientation, I = (f2._alignmentOpts[O] || {})[E.alignmentgroup] || {}, D = Object.keys(I.offsetGroups || {}).length, z = D || m2;
                T = w2 * b * _ / z, k = 2 * w2 * (((D ? E._offsetIndex : L.num) + 0.5) / z - 0.5) * b, A = w2 * b / z;
              } else
                T = w2 * b * _, k = 0, A = w2;
              L.dPos = w2, L.bPos = k, L.bdPos = T, L.wHover = A;
              var R, F, B, N, j, U, V = k + T, H = Boolean(C);
              if ("positive" === P ? (M = w2 * (C ? 1 : 0.5), R = V, S = R = k) : "negative" === P ? (M = R = k, S = w2 * (C ? 1 : 0.5), F = V) : (M = S = w2, R = F = V), (E.boxpoints || E.points) && v > 0) {
                var q2 = E.pointpos, G = E.jitter, Z = E.marker.size / 2, Y = 0;
                q2 + G >= 0 && ((Y = V * (q2 + G)) > M ? (H = true, j = Z, B = Y) : Y > R && (j = Z, B = M)), Y <= M && (B = M);
                var W = 0;
                q2 - G <= 0 && ((W = -V * (q2 - G)) > S ? (H = true, U = Z, N = W) : W > F && (U = Z, N = S)), W <= S && (N = S);
              } else
                B = M, N = S;
              var X = new Array(u.length);
              for (l = 0; l < u.length; l++)
                X[l] = u[l].pos;
              E._extremes[h] = n2.findExtremes(o2, X, { padded: H, vpadminus: N, vpadplus: B, vpadLinearized: true, ppadminus: { x: U, y: j }[p2], ppadplus: { x: j, y: U }[p2] });
            }
          }
        }
        t2.exports = { crossTraceCalc: function(t3, e3) {
          for (var r3 = t3.calcdata, n3 = e3.xaxis, i2 = e3.yaxis, a2 = 0; a2 < o.length; a2++) {
            for (var l = o[a2], u = "h" === l ? i2 : n3, c = [], f2 = 0; f2 < r3.length; f2++) {
              var h = r3[f2], p2 = h[0].t, d2 = h[0].trace;
              true !== d2.visible || "box" !== d2.type && "candlestick" !== d2.type || p2.empty || (d2.orientation || "v") !== l || d2.xaxis !== n3._id || d2.yaxis !== i2._id || c.push(f2);
            }
            s("box", t3, c, u);
          }
        }, setPositionOffset: s };
      }, 36411: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(73972), a = r2(7901), o = r2(73927), s = r2(26125), l = r2(4322), u = r2(53522);
        function c(t3, e3, r3, a2) {
          function o2(t4) {
            var e4 = 0;
            return t4 && t4.length && (e4 += 1, n2.isArrayOrTypedArray(t4[0]) && t4[0].length && (e4 += 1)), e4;
          }
          function s2(e4) {
            return n2.validate(t3[e4], u[e4]);
          }
          var c2, f3 = r3("y"), h = r3("x");
          if ("box" === e3.type) {
            var p2 = r3("q1"), d2 = r3("median"), v = r3("q3");
            e3._hasPreCompStats = p2 && p2.length && d2 && d2.length && v && v.length, c2 = Math.min(n2.minRowLength(p2), n2.minRowLength(d2), n2.minRowLength(v));
          }
          var g2, y, m2 = o2(f3), x = o2(h), b = m2 && n2.minRowLength(f3), _ = x && n2.minRowLength(h), w2 = a2.calendar, T = { autotypenumbers: a2.autotypenumbers };
          if (e3._hasPreCompStats)
            switch (String(x) + String(m2)) {
              case "00":
                var k = s2("x0") || s2("dx");
                g2 = !s2("y0") && !s2("dy") || k ? "v" : "h", y = c2;
                break;
              case "10":
                g2 = "v", y = Math.min(c2, _);
                break;
              case "20":
                g2 = "h", y = Math.min(c2, h.length);
                break;
              case "01":
                g2 = "h", y = Math.min(c2, b);
                break;
              case "02":
                g2 = "v", y = Math.min(c2, f3.length);
                break;
              case "12":
                g2 = "v", y = Math.min(c2, _, f3.length);
                break;
              case "21":
                g2 = "h", y = Math.min(c2, h.length, b);
                break;
              case "11":
                y = 0;
                break;
              case "22":
                var A, M = false;
                for (A = 0; A < h.length; A++)
                  if ("category" === l(h[A], w2, T)) {
                    M = true;
                    break;
                  }
                if (M)
                  g2 = "v", y = Math.min(c2, _, f3.length);
                else {
                  for (A = 0; A < f3.length; A++)
                    if ("category" === l(f3[A], w2, T)) {
                      M = true;
                      break;
                    }
                  M ? (g2 = "h", y = Math.min(c2, h.length, b)) : (g2 = "v", y = Math.min(c2, _, f3.length));
                }
            }
          else
            m2 > 0 ? (g2 = "v", y = x > 0 ? Math.min(_, b) : Math.min(b)) : x > 0 ? (g2 = "h", y = Math.min(_)) : y = 0;
          if (y) {
            e3._length = y;
            var S = r3("orientation", g2);
            e3._hasPreCompStats ? "v" === S && 0 === x ? (r3("x0", 0), r3("dx", 1)) : "h" === S && 0 === m2 && (r3("y0", 0), r3("dy", 1)) : "v" === S && 0 === x ? r3("x0") : "h" === S && 0 === m2 && r3("y0"), i.getComponentMethod("calendars", "handleTraceDefaults")(t3, e3, ["x", "y"], a2);
          } else
            e3.visible = false;
        }
        function f2(t3, e3, r3, i2) {
          var a2 = i2.prefix, o2 = n2.coerce2(t3, e3, u, "marker.outliercolor"), s2 = r3("marker.line.outliercolor"), l2 = "outliers";
          e3._hasPreCompStats ? l2 = "all" : (o2 || s2) && (l2 = "suspectedoutliers");
          var c2 = r3(a2 + "points", l2);
          c2 ? (r3("jitter", "all" === c2 ? 0.3 : 0), r3("pointpos", "all" === c2 ? -1.5 : 0), r3("marker.symbol"), r3("marker.opacity"), r3("marker.size"), r3("marker.angle"), r3("marker.color", e3.line.color), r3("marker.line.color"), r3("marker.line.width"), "suspectedoutliers" === c2 && (r3("marker.line.outliercolor", e3.marker.color), r3("marker.line.outlierwidth")), r3("selected.marker.color"), r3("unselected.marker.color"), r3("selected.marker.size"), r3("unselected.marker.size"), r3("text"), r3("hovertext")) : delete e3.marker;
          var f3 = r3("hoveron");
          "all" !== f3 && -1 === f3.indexOf("points") || r3("hovertemplate"), n2.coerceSelectionMarkerOpacity(e3, r3);
        }
        t2.exports = { supplyDefaults: function(t3, e3, r3, i2) {
          function s2(r4, i3) {
            return n2.coerce(t3, e3, u, r4, i3);
          }
          if (c(t3, e3, s2, i2), false !== e3.visible) {
            o(t3, e3, i2, s2), s2("xhoverformat"), s2("yhoverformat");
            var l2 = e3._hasPreCompStats;
            l2 && (s2("lowerfence"), s2("upperfence")), s2("line.color", (t3.marker || {}).color || r3), s2("line.width"), s2("fillcolor", a.addOpacity(e3.line.color, 0.5));
            var h = false;
            if (l2) {
              var p2 = s2("mean"), d2 = s2("sd");
              p2 && p2.length && (h = true, d2 && d2.length && (h = "sd"));
            }
            s2("boxmean", h), s2("whiskerwidth"), s2("width"), s2("quartilemethod");
            var v = false;
            if (l2) {
              var g2 = s2("notchspan");
              g2 && g2.length && (v = true);
            } else
              n2.validate(t3.notchwidth, u.notchwidth) && (v = true);
            s2("notched", v) && s2("notchwidth"), f2(t3, e3, s2, { prefix: "box" });
          }
        }, crossTraceDefaults: function(t3, e3) {
          var r3, i2;
          function a2(t4) {
            return n2.coerce(i2._input, i2, u, t4);
          }
          for (var o2 = 0; o2 < t3.length; o2++) {
            var l2 = (i2 = t3[o2]).type;
            "box" !== l2 && "violin" !== l2 || (r3 = i2._input, "group" === e3[l2 + "mode"] && s(r3, i2, e3, a2));
          }
        }, handleSampleDefaults: c, handlePointsDefaults: f2 };
      }, 74907: function(t2) {
        t2.exports = function(t3, e2) {
          return e2.hoverOnBox && (t3.hoverOnBox = e2.hoverOnBox), "xVal" in e2 && (t3.x = e2.xVal), "yVal" in e2 && (t3.y = e2.yVal), e2.xa && (t3.xaxis = e2.xa), e2.ya && (t3.yaxis = e2.ya), t3;
        };
      }, 41868: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(71828), a = r2(30211), o = r2(7901), s = i.fillText;
        function l(t3, e3, r3, s2) {
          var l2, u2, c, f2, h, p2, d2, v, g2, y, m2, x, b, _, w2 = t3.cd, T = t3.xa, k = t3.ya, A = w2[0].trace, M = w2[0].t, S = "violin" === A.type, E = M.bdPos, L = M.wHover, C = function(t4) {
            return c.c2l(t4.pos) + M.bPos - c.c2l(p2);
          };
          S && "both" !== A.side ? ("positive" === A.side && (g2 = function(t4) {
            var e4 = C(t4);
            return a.inbox(e4, e4 + L, y);
          }, x = E, b = 0), "negative" === A.side && (g2 = function(t4) {
            var e4 = C(t4);
            return a.inbox(e4 - L, e4, y);
          }, x = 0, b = E)) : (g2 = function(t4) {
            var e4 = C(t4);
            return a.inbox(e4 - L, e4 + L, y);
          }, x = b = E), _ = S ? function(t4) {
            return a.inbox(t4.span[0] - h, t4.span[1] - h, y);
          } : function(t4) {
            return a.inbox(t4.min - h, t4.max - h, y);
          }, "h" === A.orientation ? (h = e3, p2 = r3, d2 = _, v = g2, l2 = "y", c = k, u2 = "x", f2 = T) : (h = r3, p2 = e3, d2 = g2, v = _, l2 = "x", c = T, u2 = "y", f2 = k);
          var P = Math.min(1, E / Math.abs(c.r2c(c.range[1]) - c.r2c(c.range[0])));
          function O(t4) {
            return (d2(t4) + v(t4)) / 2;
          }
          y = t3.maxHoverDistance - P, m2 = t3.maxSpikeDistance - P;
          var I = a.getDistanceFunction(s2, d2, v, O);
          if (a.getClosest(w2, I, t3), false === t3.index)
            return [];
          var D = w2[t3.index], z = A.line.color, R = (A.marker || {}).color;
          o.opacity(z) && A.line.width ? t3.color = z : o.opacity(R) && A.boxpoints ? t3.color = R : t3.color = A.fillcolor, t3[l2 + "0"] = c.c2p(D.pos + M.bPos - b, true), t3[l2 + "1"] = c.c2p(D.pos + M.bPos + x, true), t3[l2 + "LabelVal"] = void 0 !== D.orig_p ? D.orig_p : D.pos;
          var F = l2 + "Spike";
          t3.spikeDistance = O(D) * m2 / y, t3[F] = c.c2p(D.pos, true);
          var B = A.boxmean || (A.meanline || {}).visible, N = A.boxpoints || A.points, j = N && B ? ["max", "uf", "q3", "med", "mean", "q1", "lf", "min"] : N && !B ? ["max", "uf", "q3", "med", "q1", "lf", "min"] : !N && B ? ["max", "q3", "med", "mean", "q1", "min"] : ["max", "q3", "med", "q1", "min"], U = f2.range[1] < f2.range[0];
          A.orientation === (U ? "v" : "h") && j.reverse();
          for (var V = t3.spikeDistance, H = t3[F], q2 = [], G = 0; G < j.length; G++) {
            var Z = j[G];
            if (Z in D) {
              var Y = D[Z], W = f2.c2p(Y, true), X = i.extendFlat({}, t3);
              X.attr = Z, X[u2 + "0"] = X[u2 + "1"] = W, X[u2 + "LabelVal"] = Y, X[u2 + "Label"] = (M.labels ? M.labels[Z] + " " : "") + n2.hoverLabelText(f2, Y, A[u2 + "hoverformat"]), X.hoverOnBox = true, "mean" === Z && "sd" in D && "sd" === A.boxmean && (X[u2 + "err"] = D.sd), X.hovertemplate = false, q2.push(X);
            }
          }
          t3.name = "", t3.spikeDistance = void 0, t3[F] = void 0;
          for (var J = 0; J < q2.length; J++)
            "med" !== q2[J].attr ? (q2[J].name = "", q2[J].spikeDistance = void 0, q2[J][F] = void 0) : (q2[J].spikeDistance = V, q2[J][F] = H);
          return q2;
        }
        function u(t3, e3, r3) {
          for (var n3, o2, l2, u2 = t3.cd, c = t3.xa, f2 = t3.ya, h = u2[0].trace, p2 = c.c2p(e3), d2 = f2.c2p(r3), v = a.quadrature(function(t4) {
            var e4 = Math.max(3, t4.mrc || 0);
            return Math.max(Math.abs(c.c2p(t4.x) - p2) - e4, 1 - 3 / e4);
          }, function(t4) {
            var e4 = Math.max(3, t4.mrc || 0);
            return Math.max(Math.abs(f2.c2p(t4.y) - d2) - e4, 1 - 3 / e4);
          }), g2 = false, y = 0; y < u2.length; y++) {
            o2 = u2[y];
            for (var m2 = 0; m2 < (o2.pts || []).length; m2++) {
              var x = v(l2 = o2.pts[m2]);
              x <= t3.distance && (t3.distance = x, g2 = [y, m2]);
            }
          }
          if (!g2)
            return false;
          l2 = (o2 = u2[g2[0]]).pts[g2[1]];
          var b = c.c2p(l2.x, true), _ = f2.c2p(l2.y, true), w2 = l2.mrc || 1;
          n3 = i.extendFlat({}, t3, { index: l2.i, color: (h.marker || {}).color, name: h.name, x0: b - w2, x1: b + w2, y0: _ - w2, y1: _ + w2, spikeDistance: t3.distance, hovertemplate: h.hovertemplate });
          var T, k = o2.orig_p, A = void 0 !== k ? k : o2.pos;
          return "h" === h.orientation ? (T = f2, n3.xLabelVal = l2.x, n3.yLabelVal = A) : (T = c, n3.xLabelVal = A, n3.yLabelVal = l2.y), n3[T._id.charAt(0) + "Spike"] = T.c2p(o2.pos, true), s(l2, h, n3), n3;
        }
        t2.exports = { hoverPoints: function(t3, e3, r3, n3) {
          var i2, a2 = t3.cd[0].trace.hoveron, o2 = [];
          return -1 !== a2.indexOf("boxes") && (o2 = o2.concat(l(t3, e3, r3, n3))), -1 !== a2.indexOf("points") && (i2 = u(t3, e3, r3)), "closest" === n3 ? i2 ? [i2] : o2 : i2 ? (o2.push(i2), o2) : o2;
        }, hoverOnBoxes: l, hoverOnPoints: u };
      }, 83832: function(t2, e2, r2) {
        t2.exports = { attributes: r2(53522), layoutAttributes: r2(40094), supplyDefaults: r2(36411).supplyDefaults, crossTraceDefaults: r2(36411).crossTraceDefaults, supplyLayoutDefaults: r2(4199).supplyLayoutDefaults, calc: r2(48518), crossTraceCalc: r2(37188).crossTraceCalc, plot: r2(86047).plot, style: r2(58063).style, styleOnSelect: r2(58063).styleOnSelect, hoverPoints: r2(41868).hoverPoints, eventData: r2(74907), selectPoints: r2(24626), moduleType: "trace", name: "box", basePlotModule: r2(93612), categories: ["cartesian", "svg", "symbols", "oriented", "box-violin", "showLegend", "boxLayout", "zoomScale"], meta: {} };
      }, 40094: function(t2) {
        t2.exports = { boxmode: { valType: "enumerated", values: ["group", "overlay"], dflt: "overlay", editType: "calc" }, boxgap: { valType: "number", min: 0, max: 1, dflt: 0.3, editType: "calc" }, boxgroupgap: { valType: "number", min: 0, max: 1, dflt: 0.3, editType: "calc" } };
      }, 4199: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828), a = r2(40094);
        function o(t3, e3, r3, i2, a2) {
          for (var o2 = a2 + "Layout", s = false, l = 0; l < r3.length; l++) {
            var u = r3[l];
            if (n2.traceIs(u, o2)) {
              s = true;
              break;
            }
          }
          s && (i2(a2 + "mode"), i2(a2 + "gap"), i2(a2 + "groupgap"));
        }
        t2.exports = { supplyLayoutDefaults: function(t3, e3, r3) {
          o(0, 0, r3, function(r4, n3) {
            return i.coerce(t3, e3, a, r4, n3);
          }, "box");
        }, _supply: o };
      }, 86047: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(91424);
        function o(t3, e3, r3, a2, o2) {
          var s2, l2, u = "h" === r3.orientation, c = e3.val, f2 = e3.pos, h = !!f2.rangebreaks, p2 = a2.bPos, d2 = a2.wdPos || 0, v = a2.bPosPxOffset || 0, g2 = r3.whiskerwidth || 0, y = r3.notched || false, m2 = y ? 1 - 2 * r3.notchwidth : 1;
          Array.isArray(a2.bdPos) ? (s2 = a2.bdPos[0], l2 = a2.bdPos[1]) : (s2 = a2.bdPos, l2 = a2.bdPos);
          var x = t3.selectAll("path.box").data("violin" !== r3.type || r3.box.visible ? i.identity : []);
          x.enter().append("path").style("vector-effect", o2 ? "none" : "non-scaling-stroke").attr("class", "box"), x.exit().remove(), x.each(function(t4) {
            if (t4.empty)
              return "M0,0Z";
            var e4 = f2.c2l(t4.pos + p2, true), a3 = f2.l2p(e4 - s2) + v, o3 = f2.l2p(e4 + l2) + v, x2 = h ? (a3 + o3) / 2 : f2.l2p(e4) + v, b = r3.whiskerwidth, _ = h ? a3 * b + (1 - b) * x2 : f2.l2p(e4 - d2) + v, w2 = h ? o3 * b + (1 - b) * x2 : f2.l2p(e4 + d2) + v, T = f2.l2p(e4 - s2 * m2) + v, k = f2.l2p(e4 + l2 * m2) + v, A = c.c2p(t4.q1, true), M = c.c2p(t4.q3, true), S = i.constrain(c.c2p(t4.med, true), Math.min(A, M) + 1, Math.max(A, M) - 1), E = void 0 === t4.lf || false === r3.boxpoints, L = c.c2p(E ? t4.min : t4.lf, true), C = c.c2p(E ? t4.max : t4.uf, true), P = c.c2p(t4.ln, true), O = c.c2p(t4.un, true);
            u ? n2.select(this).attr("d", "M" + S + "," + T + "V" + k + "M" + A + "," + a3 + "V" + o3 + (y ? "H" + P + "L" + S + "," + k + "L" + O + "," + o3 : "") + "H" + M + "V" + a3 + (y ? "H" + O + "L" + S + "," + T + "L" + P + "," + a3 : "") + "ZM" + A + "," + x2 + "H" + L + "M" + M + "," + x2 + "H" + C + (0 === g2 ? "" : "M" + L + "," + _ + "V" + w2 + "M" + C + "," + _ + "V" + w2)) : n2.select(this).attr("d", "M" + T + "," + S + "H" + k + "M" + a3 + "," + A + "H" + o3 + (y ? "V" + P + "L" + k + "," + S + "L" + o3 + "," + O : "") + "V" + M + "H" + a3 + (y ? "V" + O + "L" + T + "," + S + "L" + a3 + "," + P : "") + "ZM" + x2 + "," + A + "V" + L + "M" + x2 + "," + M + "V" + C + (0 === g2 ? "" : "M" + _ + "," + L + "H" + w2 + "M" + _ + "," + C + "H" + w2));
          });
        }
        function s(t3, e3, r3, n3) {
          var o2 = e3.x, s2 = e3.y, l2 = n3.bdPos, u = n3.bPos, c = r3.boxpoints || r3.points;
          i.seedPseudoRandom();
          var f2 = t3.selectAll("g.points").data(c ? function(t4) {
            return t4.forEach(function(t5) {
              t5.t = n3, t5.trace = r3;
            }), t4;
          } : []);
          f2.enter().append("g").attr("class", "points"), f2.exit().remove();
          var h = f2.selectAll("path").data(function(t4) {
            var e4, n4, a2 = t4.pts2, o3 = Math.max((t4.max - t4.min) / 10, t4.q3 - t4.q1), s3 = 1e-9 * o3, f3 = 0.01 * o3, h2 = [], p2 = 0;
            if (r3.jitter) {
              if (0 === o3)
                for (p2 = 1, h2 = new Array(a2.length), e4 = 0; e4 < a2.length; e4++)
                  h2[e4] = 1;
              else
                for (e4 = 0; e4 < a2.length; e4++) {
                  var d2 = Math.max(0, e4 - 5), v = a2[d2].v, g2 = Math.min(a2.length - 1, e4 + 5), y = a2[g2].v;
                  "all" !== c && (a2[e4].v < t4.lf ? y = Math.min(y, t4.lf) : v = Math.max(v, t4.uf));
                  var m2 = Math.sqrt(f3 * (g2 - d2) / (y - v + s3)) || 0;
                  m2 = i.constrain(Math.abs(m2), 0, 1), h2.push(m2), p2 = Math.max(m2, p2);
                }
              n4 = 2 * r3.jitter / (p2 || 1);
            }
            for (e4 = 0; e4 < a2.length; e4++) {
              var x = a2[e4], b = x.v, _ = r3.jitter ? n4 * h2[e4] * (i.pseudoRandom() - 0.5) : 0, w2 = t4.pos + u + l2 * (r3.pointpos + _);
              "h" === r3.orientation ? (x.y = w2, x.x = b) : (x.x = w2, x.y = b), "suspectedoutliers" === c && b < t4.uo && b > t4.lo && (x.so = true);
            }
            return a2;
          });
          h.enter().append("path").classed("point", true), h.exit().remove(), h.call(a.translatePoints, o2, s2);
        }
        function l(t3, e3, r3, a2) {
          var o2, s2, l2 = e3.val, u = e3.pos, c = !!u.rangebreaks, f2 = a2.bPos, h = a2.bPosPxOffset || 0, p2 = r3.boxmean || (r3.meanline || {}).visible;
          Array.isArray(a2.bdPos) ? (o2 = a2.bdPos[0], s2 = a2.bdPos[1]) : (o2 = a2.bdPos, s2 = a2.bdPos);
          var d2 = t3.selectAll("path.mean").data("box" === r3.type && r3.boxmean || "violin" === r3.type && r3.box.visible && r3.meanline.visible ? i.identity : []);
          d2.enter().append("path").attr("class", "mean").style({ fill: "none", "vector-effect": "non-scaling-stroke" }), d2.exit().remove(), d2.each(function(t4) {
            var e4 = u.c2l(t4.pos + f2, true), i2 = u.l2p(e4 - o2) + h, a3 = u.l2p(e4 + s2) + h, d3 = c ? (i2 + a3) / 2 : u.l2p(e4) + h, v = l2.c2p(t4.mean, true), g2 = l2.c2p(t4.mean - t4.sd, true), y = l2.c2p(t4.mean + t4.sd, true);
            "h" === r3.orientation ? n2.select(this).attr("d", "M" + v + "," + i2 + "V" + a3 + ("sd" === p2 ? "m0,0L" + g2 + "," + d3 + "L" + v + "," + i2 + "L" + y + "," + d3 + "Z" : "")) : n2.select(this).attr("d", "M" + i2 + "," + v + "H" + a3 + ("sd" === p2 ? "m0,0L" + d3 + "," + g2 + "L" + i2 + "," + v + "L" + d3 + "," + y + "Z" : ""));
          });
        }
        t2.exports = { plot: function(t3, e3, r3, a2) {
          var u = t3._context.staticPlot, c = e3.xaxis, f2 = e3.yaxis;
          i.makeTraceGroups(a2, r3, "trace boxes").each(function(t4) {
            var e4, r4, i2 = n2.select(this), a3 = t4[0], h = a3.t, p2 = a3.trace;
            h.wdPos = h.bdPos * p2.whiskerwidth, true !== p2.visible || h.empty ? i2.remove() : ("h" === p2.orientation ? (e4 = f2, r4 = c) : (e4 = c, r4 = f2), o(i2, { pos: e4, val: r4 }, p2, h, u), s(i2, { x: c, y: f2 }, p2, h), l(i2, { pos: e4, val: r4 }, p2, h));
          });
        }, plotBoxAndWhiskers: o, plotPoints: s, plotBoxMean: l };
      }, 24626: function(t2) {
        t2.exports = function(t3, e2) {
          var r2, n2, i = t3.cd, a = t3.xaxis, o = t3.yaxis, s = [];
          if (false === e2)
            for (r2 = 0; r2 < i.length; r2++)
              for (n2 = 0; n2 < (i[r2].pts || []).length; n2++)
                i[r2].pts[n2].selected = 0;
          else
            for (r2 = 0; r2 < i.length; r2++)
              for (n2 = 0; n2 < (i[r2].pts || []).length; n2++) {
                var l = i[r2].pts[n2], u = a.c2p(l.x), c = o.c2p(l.y);
                e2.contains([u, c], null, l.i, t3) ? (s.push({ pointNumber: l.i, x: a.c2d(l.x), y: o.c2d(l.y) }), l.selected = 1) : l.selected = 0;
              }
          return s;
        };
      }, 58063: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(7901), a = r2(91424);
        t2.exports = { style: function(t3, e3, r3) {
          var o = r3 || n2.select(t3).selectAll("g.trace.boxes");
          o.style("opacity", function(t4) {
            return t4[0].trace.opacity;
          }), o.each(function(e4) {
            var r4 = n2.select(this), o2 = e4[0].trace, s = o2.line.width;
            function l(t4, e5, r5, n3) {
              t4.style("stroke-width", e5 + "px").call(i.stroke, r5).call(i.fill, n3);
            }
            var u = r4.selectAll("path.box");
            if ("candlestick" === o2.type)
              u.each(function(t4) {
                if (!t4.empty) {
                  var e5 = n2.select(this), r5 = o2[t4.dir];
                  l(e5, r5.line.width, r5.line.color, r5.fillcolor), e5.style("opacity", o2.selectedpoints && !t4.selected ? 0.3 : 1);
                }
              });
            else {
              l(u, s, o2.line.color, o2.fillcolor), r4.selectAll("path.mean").style({ "stroke-width": s, "stroke-dasharray": 2 * s + "px," + s + "px" }).call(i.stroke, o2.line.color);
              var c = r4.selectAll("path.point");
              a.pointStyle(c, o2, t3);
            }
          });
        }, styleOnSelect: function(t3, e3, r3) {
          var n3 = e3[0].trace, i2 = r3.selectAll("path.point");
          n3.selectedpoints ? a.selectedPointStyle(i2, n3) : a.pointStyle(i2, n3, t3);
        } };
      }, 75343: function(t2, e2, r2) {
        var n2 = r2(71828).extendFlat, i = r2(12663).axisHoverFormat, a = r2(2522), o = r2(53522);
        function s(t3) {
          return { line: { color: n2({}, o.line.color, { dflt: t3 }), width: o.line.width, editType: "style" }, fillcolor: o.fillcolor, editType: "style" };
        }
        t2.exports = { xperiod: a.xperiod, xperiod0: a.xperiod0, xperiodalignment: a.xperiodalignment, xhoverformat: i("x"), yhoverformat: i("y"), x: a.x, open: a.open, high: a.high, low: a.low, close: a.close, line: { width: n2({}, o.line.width, {}), editType: "style" }, increasing: s(a.increasing.line.color.dflt), decreasing: s(a.decreasing.line.color.dflt), text: a.text, hovertext: a.hovertext, whiskerwidth: n2({}, o.whiskerwidth, { dflt: 0 }), hoverlabel: a.hoverlabel };
      }, 41197: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298), a = r2(42973), o = r2(3485).calcCommon;
        function s(t3, e3, r3, n3) {
          return { min: r3, q1: Math.min(t3, n3), med: n3, q3: Math.max(t3, n3), max: e3 };
        }
        t2.exports = function(t3, e3) {
          var r3 = t3._fullLayout, l = i.getFromId(t3, e3.xaxis), u = i.getFromId(t3, e3.yaxis), c = l.makeCalcdata(e3, "x"), f2 = a(e3, l, "x", c).vals, h = o(t3, e3, c, f2, u, s);
          return h.length ? (n2.extendFlat(h[0].t, { num: r3._numBoxes, dPos: n2.distinctVals(f2).minDiff / 2, posLetter: "x", valLetter: "y" }), r3._numBoxes++, h) : [{ t: { empty: true } }];
        };
      }, 1026: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901), a = r2(14555), o = r2(73927), s = r2(75343);
        function l(t3, e3, r3, n3) {
          var a2 = r3(n3 + ".line.color");
          r3(n3 + ".line.width", e3.line.width), r3(n3 + ".fillcolor", i.addOpacity(a2, 0.5));
        }
        t2.exports = function(t3, e3, r3, i2) {
          function u(r4, i3) {
            return n2.coerce(t3, e3, s, r4, i3);
          }
          a(t3, e3, u, i2) ? (o(t3, e3, i2, u, { x: true }), u("xhoverformat"), u("yhoverformat"), u("line.width"), l(0, e3, u, "increasing"), l(0, e3, u, "decreasing"), u("text"), u("hovertext"), u("whiskerwidth"), i2._requestRangeslider[e3.xaxis] = true) : e3.visible = false;
        };
      }, 91815: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "candlestick", basePlotModule: r2(93612), categories: ["cartesian", "svg", "showLegend", "candlestick", "boxLayout"], meta: {}, attributes: r2(75343), layoutAttributes: r2(40094), supplyLayoutDefaults: r2(4199).supplyLayoutDefaults, crossTraceCalc: r2(37188).crossTraceCalc, supplyDefaults: r2(1026), calc: r2(41197), plot: r2(86047).plot, layerName: "boxlayer", style: r2(58063).style, hoverPoints: r2(66449).hoverPoints, selectPoints: r2(67324) };
      }, 13145: function(t2, e2, r2) {
        var n2 = r2(11500), i = r2(44467);
        t2.exports = function(t3, e3, r3, a, o) {
          a("a") || (a("da"), a("a0")), a("b") || (a("db"), a("b0")), function(t4, e4, r4, a2) {
            ["aaxis", "baxis"].forEach(function(o2) {
              var s = o2.charAt(0), l = t4[o2] || {}, u = i.newContainer(e4, o2), c = { noTicklabelstep: true, tickfont: "x", id: s + "axis", letter: s, font: e4.font, name: o2, data: t4[s], calendar: e4.calendar, dfltColor: a2, bgColor: r4.paper_bgcolor, autotypenumbersDflt: r4.autotypenumbers, fullLayout: r4 };
              n2(l, u, c), u._categories = u._categories || [], t4[o2] || "-" === l.type || (t4[o2] = { type: l.type });
            });
          }(t3, e3, r3, o);
        };
      }, 402: function(t2, e2, r2) {
        var n2 = r2(71828).isArrayOrTypedArray;
        function i(t3, e3) {
          if (!n2(t3) || e3 >= 10)
            return null;
          for (var r3 = 1 / 0, a = -1 / 0, o = t3.length, s = 0; s < o; s++) {
            var l = t3[s];
            if (n2(l)) {
              var u = i(l, e3 + 1);
              u && (r3 = Math.min(u[0], r3), a = Math.max(u[1], a));
            } else
              r3 = Math.min(l, r3), a = Math.max(l, a);
          }
          return [r3, a];
        }
        t2.exports = function(t3) {
          return i(t3, 0);
        };
      }, 99798: function(t2, e2, r2) {
        var n2 = r2(41940), i = r2(1928), a = r2(22399), o = n2({ editType: "calc" });
        o.family.dflt = '"Open Sans", verdana, arial, sans-serif', o.size.dflt = 12, o.color.dflt = a.defaultLine, t2.exports = { carpet: { valType: "string", editType: "calc" }, x: { valType: "data_array", editType: "calc+clearAxisTypes" }, y: { valType: "data_array", editType: "calc+clearAxisTypes" }, a: { valType: "data_array", editType: "calc" }, a0: { valType: "number", dflt: 0, editType: "calc" }, da: { valType: "number", dflt: 1, editType: "calc" }, b: { valType: "data_array", editType: "calc" }, b0: { valType: "number", dflt: 0, editType: "calc" }, db: { valType: "number", dflt: 1, editType: "calc" }, cheaterslope: { valType: "number", dflt: 1, editType: "calc" }, aaxis: i, baxis: i, font: o, color: { valType: "color", dflt: a.defaultLine, editType: "plot" }, transforms: void 0 };
      }, 4536: function(t2, e2, r2) {
        var n2 = r2(71828).isArrayOrTypedArray;
        t2.exports = function(t3, e3, r3, i) {
          var a, o, s, l, u, c, f2, h, p2, d2, v, g2, y, m2 = n2(r3) ? "a" : "b", x = ("a" === m2 ? t3.aaxis : t3.baxis).smoothing, b = "a" === m2 ? t3.a2i : t3.b2j, _ = "a" === m2 ? r3 : i, w2 = "a" === m2 ? i : r3, T = "a" === m2 ? e3.a.length : e3.b.length, k = "a" === m2 ? e3.b.length : e3.a.length, A = Math.floor("a" === m2 ? t3.b2j(w2) : t3.a2i(w2)), M = "a" === m2 ? function(e4) {
            return t3.evalxy([], e4, A);
          } : function(e4) {
            return t3.evalxy([], A, e4);
          };
          x && (s = Math.max(0, Math.min(k - 2, A)), l = A - s, o = "a" === m2 ? function(e4, r4) {
            return t3.dxydi([], e4, s, r4, l);
          } : function(e4, r4) {
            return t3.dxydj([], s, e4, l, r4);
          });
          var S = b(_[0]), E = b(_[1]), L = S < E ? 1 : -1, C = 1e-8 * (E - S), P = L > 0 ? Math.floor : Math.ceil, O = L > 0 ? Math.ceil : Math.floor, I = L > 0 ? Math.min : Math.max, D = L > 0 ? Math.max : Math.min, z = P(S + C), R = O(E - C), F = [[f2 = M(S)]];
          for (a = z; a * L < R * L; a += L)
            u = [], v = D(S, a), y = (g2 = I(E, a + L)) - v, c = Math.max(0, Math.min(T - 2, Math.floor(0.5 * (v + g2)))), h = M(g2), x && (p2 = o(c, v - c), d2 = o(c, g2 - c), u.push([f2[0] + p2[0] / 3 * y, f2[1] + p2[1] / 3 * y]), u.push([h[0] - d2[0] / 3 * y, h[1] - d2[1] / 3 * y])), u.push(h), F.push(u), f2 = h;
          return F;
        };
      }, 1928: function(t2, e2, r2) {
        var n2 = r2(41940), i = r2(22399), a = r2(13838), o = r2(12663).descriptionWithDates, s = r2(30962).overrideAll, l = r2(79952).P, u = r2(1426).extendFlat;
        t2.exports = { color: { valType: "color", editType: "calc" }, smoothing: { valType: "number", dflt: 1, min: 0, max: 1.3, editType: "calc" }, title: { text: { valType: "string", dflt: "", editType: "calc" }, font: n2({ editType: "calc" }), offset: { valType: "number", dflt: 10, editType: "calc" }, editType: "calc" }, type: { valType: "enumerated", values: ["-", "linear", "date", "category"], dflt: "-", editType: "calc" }, autotypenumbers: a.autotypenumbers, autorange: { valType: "enumerated", values: [true, false, "reversed"], dflt: true, editType: "calc" }, rangemode: { valType: "enumerated", values: ["normal", "tozero", "nonnegative"], dflt: "normal", editType: "calc" }, range: { valType: "info_array", editType: "calc", items: [{ valType: "any", editType: "calc" }, { valType: "any", editType: "calc" }] }, fixedrange: { valType: "boolean", dflt: false, editType: "calc" }, cheatertype: { valType: "enumerated", values: ["index", "value"], dflt: "value", editType: "calc" }, tickmode: { valType: "enumerated", values: ["linear", "array"], dflt: "array", editType: "calc" }, nticks: { valType: "integer", min: 0, dflt: 0, editType: "calc" }, tickvals: { valType: "data_array", editType: "calc" }, ticktext: { valType: "data_array", editType: "calc" }, showticklabels: { valType: "enumerated", values: ["start", "end", "both", "none"], dflt: "start", editType: "calc" }, labelalias: u({}, a.labelalias, { editType: "calc" }), tickfont: n2({ editType: "calc" }), tickangle: { valType: "angle", dflt: "auto", editType: "calc" }, tickprefix: { valType: "string", dflt: "", editType: "calc" }, showtickprefix: { valType: "enumerated", values: ["all", "first", "last", "none"], dflt: "all", editType: "calc" }, ticksuffix: { valType: "string", dflt: "", editType: "calc" }, showticksuffix: { valType: "enumerated", values: ["all", "first", "last", "none"], dflt: "all", editType: "calc" }, showexponent: { valType: "enumerated", values: ["all", "first", "last", "none"], dflt: "all", editType: "calc" }, exponentformat: { valType: "enumerated", values: ["none", "e", "E", "power", "SI", "B"], dflt: "B", editType: "calc" }, minexponent: { valType: "number", dflt: 3, min: 0, editType: "calc" }, separatethousands: { valType: "boolean", dflt: false, editType: "calc" }, tickformat: { valType: "string", dflt: "", editType: "calc", description: o("tick label") }, tickformatstops: s(a.tickformatstops, "calc", "from-root"), categoryorder: { valType: "enumerated", values: ["trace", "category ascending", "category descending", "array"], dflt: "trace", editType: "calc" }, categoryarray: { valType: "data_array", editType: "calc" }, labelpadding: { valType: "integer", dflt: 10, editType: "calc" }, labelprefix: { valType: "string", editType: "calc" }, labelsuffix: { valType: "string", dflt: "", editType: "calc" }, showline: { valType: "boolean", dflt: false, editType: "calc" }, linecolor: { valType: "color", dflt: i.defaultLine, editType: "calc" }, linewidth: { valType: "number", min: 0, dflt: 1, editType: "calc" }, gridcolor: { valType: "color", editType: "calc" }, gridwidth: { valType: "number", min: 0, dflt: 1, editType: "calc" }, griddash: u({}, l, { editType: "calc" }), showgrid: { valType: "boolean", dflt: true, editType: "calc" }, minorgridcount: { valType: "integer", min: 0, dflt: 0, editType: "calc" }, minorgridwidth: { valType: "number", min: 0, dflt: 1, editType: "calc" }, minorgriddash: u({}, l, { editType: "calc" }), minorgridcolor: { valType: "color", dflt: i.lightLine, editType: "calc" }, startline: { valType: "boolean", editType: "calc" }, startlinecolor: { valType: "color", editType: "calc" }, startlinewidth: { valType: "number", dflt: 1, editType: "calc" }, endline: { valType: "boolean", editType: "calc" }, endlinewidth: { valType: "number", dflt: 1, editType: "calc" }, endlinecolor: { valType: "color", editType: "calc" }, tick0: { valType: "number", min: 0, dflt: 0, editType: "calc" }, dtick: { valType: "number", min: 0, dflt: 1, editType: "calc" }, arraytick0: { valType: "integer", min: 0, dflt: 0, editType: "calc" }, arraydtick: { valType: "integer", min: 1, dflt: 1, editType: "calc" }, _deprecated: { title: { valType: "string", editType: "calc" }, titlefont: n2({ editType: "calc" }), titleoffset: { valType: "number", dflt: 10, editType: "calc" } }, editType: "calc" };
      }, 11500: function(t2, e2, r2) {
        var n2 = r2(99798), i = r2(7901).addOpacity, a = r2(73972), o = r2(71828), s = r2(26218), l = r2(96115), u = r2(89426), c = r2(15258), f2 = r2(21994), h = r2(4322);
        t2.exports = function(t3, e3, r3) {
          var p2 = r3.letter, d2 = r3.font || {}, v = n2[p2 + "axis"];
          function g2(r4, n3) {
            return o.coerce(t3, e3, v, r4, n3);
          }
          function y(r4, n3) {
            return o.coerce2(t3, e3, v, r4, n3);
          }
          r3.name && (e3._name = r3.name, e3._id = r3.name), g2("autotypenumbers", r3.autotypenumbersDflt);
          var m2 = g2("type");
          "-" === m2 && (r3.data && function(t4, e4) {
            if ("-" === t4.type) {
              var r4 = t4._id.charAt(0), n3 = t4[r4 + "calendar"];
              t4.type = h(e4, n3, { autotypenumbers: t4.autotypenumbers });
            }
          }(e3, r3.data), "-" === e3.type ? e3.type = "linear" : m2 = t3.type = e3.type), g2("smoothing"), g2("cheatertype"), g2("showticklabels"), g2("labelprefix", p2 + " = "), g2("labelsuffix"), g2("showtickprefix"), g2("showticksuffix"), g2("separatethousands"), g2("tickformat"), g2("exponentformat"), g2("minexponent"), g2("showexponent"), g2("categoryorder"), g2("tickmode"), g2("tickvals"), g2("ticktext"), g2("tick0"), g2("dtick"), "array" === e3.tickmode && (g2("arraytick0"), g2("arraydtick")), g2("labelpadding"), e3._hovertitle = p2, "date" === m2 && a.getComponentMethod("calendars", "handleDefaults")(t3, e3, "calendar", r3.calendar), f2(e3, r3.fullLayout), e3.c2p = o.identity;
          var x = g2("color", r3.dfltColor), b = x === t3.color ? x : d2.color;
          g2("title.text") && (o.coerceFont(g2, "title.font", { family: d2.family, size: o.bigFont(d2.size), color: b }), g2("title.offset")), g2("tickangle"), g2("autorange", !e3.isValidRange(t3.range)) && g2("rangemode"), g2("range"), e3.cleanRange(), g2("fixedrange"), s(t3, e3, g2, m2), u(t3, e3, g2, m2, r3), l(t3, e3, g2, m2, r3), c(t3, e3, g2, { data: r3.data, dataAttr: p2 });
          var _ = y("gridcolor", i(x, 0.3)), w2 = y("gridwidth"), T = y("griddash"), k = g2("showgrid");
          k || (delete e3.gridcolor, delete e3.gridwidth, delete e3.griddash);
          var A = y("startlinecolor", x), M = y("startlinewidth", w2);
          g2("startline", e3.showgrid || !!A || !!M) || (delete e3.startlinecolor, delete e3.startlinewidth);
          var S = y("endlinecolor", x), E = y("endlinewidth", w2);
          return g2("endline", e3.showgrid || !!S || !!E) || (delete e3.endlinecolor, delete e3.endlinewidth), k ? (g2("minorgridcount"), g2("minorgridwidth", w2), g2("minorgriddash", T), g2("minorgridcolor", i(_, 0.06)), e3.minorgridcount || (delete e3.minorgridwidth, delete e3.minorgriddash, delete e3.minorgridcolor)) : (delete e3.gridcolor, delete e3.gridwidth, delete e3.griddash), "none" === e3.showticklabels && (delete e3.tickfont, delete e3.tickangle, delete e3.showexponent, delete e3.exponentformat, delete e3.minexponent, delete e3.tickformat, delete e3.showticksuffix, delete e3.showtickprefix), e3.showticksuffix || delete e3.ticksuffix, e3.showtickprefix || delete e3.tickprefix, g2("tickmode"), e3;
        };
      }, 25281: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(71828).isArray1D, a = r2(53824), o = r2(402), s = r2(20347), l = r2(83311), u = r2(44807), c = r2(4742), f2 = r2(72505), h = r2(68296), p2 = r2(11435);
        t2.exports = function(t3, e3) {
          var r3 = n2.getFromId(t3, e3.xaxis), d2 = n2.getFromId(t3, e3.yaxis), v = e3.aaxis, g2 = e3.baxis, y = e3.x, m2 = e3.y, x = [];
          y && i(y) && x.push("x"), m2 && i(m2) && x.push("y"), x.length && h(e3, v, g2, "a", "b", x);
          var b = e3._a = e3._a || e3.a, _ = e3._b = e3._b || e3.b;
          y = e3._x || e3.x, m2 = e3._y || e3.y;
          var w2 = {};
          if (e3._cheater) {
            var T = "index" === v.cheatertype ? b.length : b, k = "index" === g2.cheatertype ? _.length : _;
            y = a(T, k, e3.cheaterslope);
          }
          e3._x = y = c(y), e3._y = m2 = c(m2), f2(y, b, _), f2(m2, b, _), p2(e3), e3.setScale();
          var A = o(y), M = o(m2), S = 0.5 * (A[1] - A[0]), E = 0.5 * (A[1] + A[0]), L = 0.5 * (M[1] - M[0]), C = 0.5 * (M[1] + M[0]), P = 1.3;
          return A = [E - S * P, E + S * P], M = [C - L * P, C + L * P], e3._extremes[r3._id] = n2.findExtremes(r3, A, { padded: true }), e3._extremes[d2._id] = n2.findExtremes(d2, M, { padded: true }), s(e3, "a", "b"), s(e3, "b", "a"), l(e3, v), l(e3, g2), w2.clipsegments = u(e3._xctrl, e3._yctrl, v, g2), w2.x = y, w2.y = m2, w2.a = b, w2.b = _, [w2];
        };
      }, 44807: function(t2) {
        t2.exports = function(t3, e2, r2, n2) {
          var i, a, o, s = [], l = !!r2.smoothing, u = !!n2.smoothing, c = t3[0].length - 1, f2 = t3.length - 1;
          for (i = 0, a = [], o = []; i <= c; i++)
            a[i] = t3[0][i], o[i] = e2[0][i];
          for (s.push({ x: a, y: o, bicubic: l }), i = 0, a = [], o = []; i <= f2; i++)
            a[i] = t3[i][c], o[i] = e2[i][c];
          for (s.push({ x: a, y: o, bicubic: u }), i = c, a = [], o = []; i >= 0; i--)
            a[c - i] = t3[f2][i], o[c - i] = e2[f2][i];
          for (s.push({ x: a, y: o, bicubic: l }), i = f2, a = [], o = []; i >= 0; i--)
            a[f2 - i] = t3[i][0], o[f2 - i] = e2[i][0];
          return s.push({ x: a, y: o, bicubic: u }), s;
        };
      }, 20347: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(1426).extendFlat;
        t2.exports = function(t3, e3, r3) {
          var a, o, s, l, u, c, f2, h, p2, d2, v, g2, y, m2, x = t3["_" + e3], b = t3[e3 + "axis"], _ = b._gridlines = [], w2 = b._minorgridlines = [], T = b._boundarylines = [], k = t3["_" + r3], A = t3[r3 + "axis"];
          "array" === b.tickmode && (b.tickvals = x.slice());
          var M = t3._xctrl, S = t3._yctrl, E = M[0].length, L = M.length, C = t3._a.length, P = t3._b.length;
          n2.prepTicks(b), "array" === b.tickmode && delete b.tickvals;
          var O = b.smoothing ? 3 : 1;
          function I(n3) {
            var i2, a2, o2, s2, l2, u2, c2, f3, p3, d3, v2, g3, y2 = [], m3 = [], x2 = {};
            if ("b" === e3)
              for (a2 = t3.b2j(n3), o2 = Math.floor(Math.max(0, Math.min(P - 2, a2))), s2 = a2 - o2, x2.length = P, x2.crossLength = C, x2.xy = function(e4) {
                return t3.evalxy([], e4, a2);
              }, x2.dxy = function(e4, r4) {
                return t3.dxydi([], e4, o2, r4, s2);
              }, i2 = 0; i2 < C; i2++)
                u2 = Math.min(C - 2, i2), c2 = i2 - u2, f3 = t3.evalxy([], i2, a2), A.smoothing && i2 > 0 && (p3 = t3.dxydi([], i2 - 1, o2, 0, s2), y2.push(l2[0] + p3[0] / 3), m3.push(l2[1] + p3[1] / 3), d3 = t3.dxydi([], i2 - 1, o2, 1, s2), y2.push(f3[0] - d3[0] / 3), m3.push(f3[1] - d3[1] / 3)), y2.push(f3[0]), m3.push(f3[1]), l2 = f3;
            else
              for (i2 = t3.a2i(n3), u2 = Math.floor(Math.max(0, Math.min(C - 2, i2))), c2 = i2 - u2, x2.length = C, x2.crossLength = P, x2.xy = function(e4) {
                return t3.evalxy([], i2, e4);
              }, x2.dxy = function(e4, r4) {
                return t3.dxydj([], u2, e4, c2, r4);
              }, a2 = 0; a2 < P; a2++)
                o2 = Math.min(P - 2, a2), s2 = a2 - o2, f3 = t3.evalxy([], i2, a2), A.smoothing && a2 > 0 && (v2 = t3.dxydj([], u2, a2 - 1, c2, 0), y2.push(l2[0] + v2[0] / 3), m3.push(l2[1] + v2[1] / 3), g3 = t3.dxydj([], u2, a2 - 1, c2, 1), y2.push(f3[0] - g3[0] / 3), m3.push(f3[1] - g3[1] / 3)), y2.push(f3[0]), m3.push(f3[1]), l2 = f3;
            return x2.axisLetter = e3, x2.axis = b, x2.crossAxis = A, x2.value = n3, x2.constvar = r3, x2.index = h, x2.x = y2, x2.y = m3, x2.smoothing = A.smoothing, x2;
          }
          function D(n3) {
            var i2, a2, o2, s2, l2, u2 = [], c2 = [], f3 = {};
            if (f3.length = x.length, f3.crossLength = k.length, "b" === e3)
              for (o2 = Math.max(0, Math.min(P - 2, n3)), l2 = Math.min(1, Math.max(0, n3 - o2)), f3.xy = function(e4) {
                return t3.evalxy([], e4, n3);
              }, f3.dxy = function(e4, r4) {
                return t3.dxydi([], e4, o2, r4, l2);
              }, i2 = 0; i2 < E; i2++)
                u2[i2] = M[n3 * O][i2], c2[i2] = S[n3 * O][i2];
            else
              for (a2 = Math.max(0, Math.min(C - 2, n3)), s2 = Math.min(1, Math.max(0, n3 - a2)), f3.xy = function(e4) {
                return t3.evalxy([], n3, e4);
              }, f3.dxy = function(e4, r4) {
                return t3.dxydj([], a2, e4, s2, r4);
              }, i2 = 0; i2 < L; i2++)
                u2[i2] = M[i2][n3 * O], c2[i2] = S[i2][n3 * O];
            return f3.axisLetter = e3, f3.axis = b, f3.crossAxis = A, f3.value = x[n3], f3.constvar = r3, f3.index = n3, f3.x = u2, f3.y = c2, f3.smoothing = A.smoothing, f3;
          }
          if ("array" === b.tickmode) {
            for (l = 5e-15, c = (u = [Math.floor((x.length - 1 - b.arraytick0) / b.arraydtick * (1 + l)), Math.ceil(-b.arraytick0 / b.arraydtick / (1 + l))].sort(function(t4, e4) {
              return t4 - e4;
            }))[0] - 1, f2 = u[1] + 1, h = c; h < f2; h++)
              (o = b.arraytick0 + b.arraydtick * h) < 0 || o > x.length - 1 || _.push(i(D(o), { color: b.gridcolor, width: b.gridwidth, dash: b.griddash }));
            for (h = c; h < f2; h++)
              if (s = b.arraytick0 + b.arraydtick * h, v = Math.min(s + b.arraydtick, x.length - 1), !(s < 0 || s > x.length - 1 || v < 0 || v > x.length - 1))
                for (g2 = x[s], y = x[v], a = 0; a < b.minorgridcount; a++)
                  (m2 = v - s) <= 0 || (d2 = g2 + (y - g2) * (a + 1) / (b.minorgridcount + 1) * (b.arraydtick / m2)) < x[0] || d2 > x[x.length - 1] || w2.push(i(I(d2), { color: b.minorgridcolor, width: b.minorgridwidth, dash: b.minorgriddash }));
            b.startline && T.push(i(D(0), { color: b.startlinecolor, width: b.startlinewidth })), b.endline && T.push(i(D(x.length - 1), { color: b.endlinecolor, width: b.endlinewidth }));
          } else {
            for (l = 5e-15, c = (u = [Math.floor((x[x.length - 1] - b.tick0) / b.dtick * (1 + l)), Math.ceil((x[0] - b.tick0) / b.dtick / (1 + l))].sort(function(t4, e4) {
              return t4 - e4;
            }))[0], f2 = u[1], h = c; h <= f2; h++)
              p2 = b.tick0 + b.dtick * h, _.push(i(I(p2), { color: b.gridcolor, width: b.gridwidth, dash: b.griddash }));
            for (h = c - 1; h < f2 + 1; h++)
              for (p2 = b.tick0 + b.dtick * h, a = 0; a < b.minorgridcount; a++)
                (d2 = p2 + b.dtick * (a + 1) / (b.minorgridcount + 1)) < x[0] || d2 > x[x.length - 1] || w2.push(i(I(d2), { color: b.minorgridcolor, width: b.minorgridwidth, dash: b.minorgriddash }));
            b.startline && T.push(i(I(x[0]), { color: b.startlinecolor, width: b.startlinewidth })), b.endline && T.push(i(I(x[x.length - 1]), { color: b.endlinecolor, width: b.endlinewidth }));
          }
        };
      }, 83311: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(1426).extendFlat;
        t2.exports = function(t3, e3) {
          var r3, a, o, s = e3._labels = [], l = e3._gridlines;
          for (r3 = 0; r3 < l.length; r3++)
            o = l[r3], -1 !== ["start", "both"].indexOf(e3.showticklabels) && (a = n2.tickText(e3, o.value), i(a, { prefix: void 0, suffix: void 0, endAnchor: true, xy: o.xy(0), dxy: o.dxy(0, 0), axis: o.axis, length: o.crossAxis.length, font: o.axis.tickfont, isFirst: 0 === r3, isLast: r3 === l.length - 1 }), s.push(a)), -1 !== ["end", "both"].indexOf(e3.showticklabels) && (a = n2.tickText(e3, o.value), i(a, { endAnchor: false, xy: o.xy(o.crossLength - 1), dxy: o.dxy(o.crossLength - 2, 1), axis: o.axis, length: o.crossAxis.length, font: o.axis.tickfont, isFirst: 0 === r3, isLast: r3 === l.length - 1 }), s.push(a));
        };
      }, 42048: function(t2) {
        t2.exports = function(t3, e2, r2, n2) {
          var i = t3[0] - e2[0], a = t3[1] - e2[1], o = r2[0] - e2[0], s = r2[1] - e2[1], l = Math.pow(i * i + a * a, 0.25), u = Math.pow(o * o + s * s, 0.25), c = (u * u * i - l * l * o) * n2, f2 = (u * u * a - l * l * s) * n2, h = u * (l + u) * 3, p2 = l * (l + u) * 3;
          return [[e2[0] + (h && c / h), e2[1] + (h && f2 / h)], [e2[0] - (p2 && c / p2), e2[1] - (p2 && f2 / p2)]];
        };
      }, 53824: function(t2, e2, r2) {
        var n2 = r2(71828).isArrayOrTypedArray;
        t2.exports = function(t3, e3, r3) {
          var i, a, o, s, l, u, c = [], f2 = n2(t3) ? t3.length : t3, h = n2(e3) ? e3.length : e3, p2 = n2(t3) ? t3 : null, d2 = n2(e3) ? e3 : null;
          p2 && (o = (p2.length - 1) / (p2[p2.length - 1] - p2[0]) / (f2 - 1)), d2 && (s = (d2.length - 1) / (d2[d2.length - 1] - d2[0]) / (h - 1));
          var v = 1 / 0, g2 = -1 / 0;
          for (a = 0; a < h; a++)
            for (c[a] = [], l = d2 ? (d2[a] - d2[0]) * s : a / (h - 1), i = 0; i < f2; i++)
              u = (p2 ? (p2[i] - p2[0]) * o : i / (f2 - 1)) - l * r3, v = Math.min(u, v), g2 = Math.max(u, g2), c[a][i] = u;
          var y = 1 / (g2 - v), m2 = -v * y;
          for (a = 0; a < h; a++)
            for (i = 0; i < f2; i++)
              c[a][i] = y * c[a][i] + m2;
          return c;
        };
      }, 45664: function(t2, e2, r2) {
        var n2 = r2(42048), i = r2(71828).ensureArray;
        function a(t3, e3, r3) {
          var n3 = -0.5 * r3[0] + 1.5 * e3[0], i2 = -0.5 * r3[1] + 1.5 * e3[1];
          return [(2 * n3 + t3[0]) / 3, (2 * i2 + t3[1]) / 3];
        }
        t2.exports = function(t3, e3, r3, o, s, l) {
          var u, c, f2, h, p2, d2, v, g2, y, m2, x = r3[0].length, b = r3.length, _ = s ? 3 * x - 2 : x, w2 = l ? 3 * b - 2 : b;
          for (t3 = i(t3, w2), e3 = i(e3, w2), f2 = 0; f2 < w2; f2++)
            t3[f2] = i(t3[f2], _), e3[f2] = i(e3[f2], _);
          for (c = 0, h = 0; c < b; c++, h += l ? 3 : 1)
            for (p2 = t3[h], d2 = e3[h], v = r3[c], g2 = o[c], u = 0, f2 = 0; u < x; u++, f2 += s ? 3 : 1)
              p2[f2] = v[u], d2[f2] = g2[u];
          if (s)
            for (c = 0, h = 0; c < b; c++, h += l ? 3 : 1) {
              for (u = 1, f2 = 3; u < x - 1; u++, f2 += 3)
                y = n2([r3[c][u - 1], o[c][u - 1]], [r3[c][u], o[c][u]], [r3[c][u + 1], o[c][u + 1]], s), t3[h][f2 - 1] = y[0][0], e3[h][f2 - 1] = y[0][1], t3[h][f2 + 1] = y[1][0], e3[h][f2 + 1] = y[1][1];
              m2 = a([t3[h][0], e3[h][0]], [t3[h][2], e3[h][2]], [t3[h][3], e3[h][3]]), t3[h][1] = m2[0], e3[h][1] = m2[1], m2 = a([t3[h][_ - 1], e3[h][_ - 1]], [t3[h][_ - 3], e3[h][_ - 3]], [t3[h][_ - 4], e3[h][_ - 4]]), t3[h][_ - 2] = m2[0], e3[h][_ - 2] = m2[1];
            }
          if (l)
            for (f2 = 0; f2 < _; f2++) {
              for (h = 3; h < w2 - 3; h += 3)
                y = n2([t3[h - 3][f2], e3[h - 3][f2]], [t3[h][f2], e3[h][f2]], [t3[h + 3][f2], e3[h + 3][f2]], l), t3[h - 1][f2] = y[0][0], e3[h - 1][f2] = y[0][1], t3[h + 1][f2] = y[1][0], e3[h + 1][f2] = y[1][1];
              m2 = a([t3[0][f2], e3[0][f2]], [t3[2][f2], e3[2][f2]], [t3[3][f2], e3[3][f2]]), t3[1][f2] = m2[0], e3[1][f2] = m2[1], m2 = a([t3[w2 - 1][f2], e3[w2 - 1][f2]], [t3[w2 - 3][f2], e3[w2 - 3][f2]], [t3[w2 - 4][f2], e3[w2 - 4][f2]]), t3[w2 - 2][f2] = m2[0], e3[w2 - 2][f2] = m2[1];
            }
          if (s && l)
            for (h = 1; h < w2; h += (h + 1) % 3 == 0 ? 2 : 1) {
              for (f2 = 3; f2 < _ - 3; f2 += 3)
                y = n2([t3[h][f2 - 3], e3[h][f2 - 3]], [t3[h][f2], e3[h][f2]], [t3[h][f2 + 3], e3[h][f2 + 3]], s), t3[h][f2 - 1] = 0.5 * (t3[h][f2 - 1] + y[0][0]), e3[h][f2 - 1] = 0.5 * (e3[h][f2 - 1] + y[0][1]), t3[h][f2 + 1] = 0.5 * (t3[h][f2 + 1] + y[1][0]), e3[h][f2 + 1] = 0.5 * (e3[h][f2 + 1] + y[1][1]);
              m2 = a([t3[h][0], e3[h][0]], [t3[h][2], e3[h][2]], [t3[h][3], e3[h][3]]), t3[h][1] = 0.5 * (t3[h][1] + m2[0]), e3[h][1] = 0.5 * (e3[h][1] + m2[1]), m2 = a([t3[h][_ - 1], e3[h][_ - 1]], [t3[h][_ - 3], e3[h][_ - 3]], [t3[h][_ - 4], e3[h][_ - 4]]), t3[h][_ - 2] = 0.5 * (t3[h][_ - 2] + m2[0]), e3[h][_ - 2] = 0.5 * (e3[h][_ - 2] + m2[1]);
            }
          return [t3, e3];
        };
      }, 35509: function(t2) {
        t2.exports = { RELATIVE_CULL_TOLERANCE: 1e-6 };
      }, 54495: function(t2) {
        t2.exports = function(t3, e2, r2) {
          return e2 && r2 ? function(e3, r3, n2, i, a) {
            var o, s, l, u, c, f2;
            e3 || (e3 = []), r3 *= 3, n2 *= 3;
            var h = i * i, p2 = 1 - i, d2 = p2 * p2, v = p2 * i * 2, g2 = -3 * d2, y = 3 * (d2 - v), m2 = 3 * (v - h), x = 3 * h, b = a * a, _ = b * a, w2 = 1 - a, T = w2 * w2, k = T * w2;
            for (f2 = 0; f2 < t3.length; f2++)
              o = g2 * (c = t3[f2])[n2][r3] + y * c[n2][r3 + 1] + m2 * c[n2][r3 + 2] + x * c[n2][r3 + 3], s = g2 * c[n2 + 1][r3] + y * c[n2 + 1][r3 + 1] + m2 * c[n2 + 1][r3 + 2] + x * c[n2 + 1][r3 + 3], l = g2 * c[n2 + 2][r3] + y * c[n2 + 2][r3 + 1] + m2 * c[n2 + 2][r3 + 2] + x * c[n2 + 2][r3 + 3], u = g2 * c[n2 + 3][r3] + y * c[n2 + 3][r3 + 1] + m2 * c[n2 + 3][r3 + 2] + x * c[n2 + 3][r3 + 3], e3[f2] = k * o + 3 * (T * a * s + w2 * b * l) + _ * u;
            return e3;
          } : e2 ? function(e3, r3, n2, i, a) {
            var o, s, l, u;
            e3 || (e3 = []), r3 *= 3;
            var c = i * i, f2 = 1 - i, h = f2 * f2, p2 = f2 * i * 2, d2 = -3 * h, v = 3 * (h - p2), g2 = 3 * (p2 - c), y = 3 * c, m2 = 1 - a;
            for (l = 0; l < t3.length; l++)
              o = d2 * (u = t3[l])[n2][r3] + v * u[n2][r3 + 1] + g2 * u[n2][r3 + 2] + y * u[n2][r3 + 3], s = d2 * u[n2 + 1][r3] + v * u[n2 + 1][r3 + 1] + g2 * u[n2 + 1][r3 + 2] + y * u[n2 + 1][r3 + 3], e3[l] = m2 * o + a * s;
            return e3;
          } : r2 ? function(e3, r3, n2, i, a) {
            var o, s, l, u, c, f2;
            e3 || (e3 = []), n2 *= 3;
            var h = a * a, p2 = h * a, d2 = 1 - a, v = d2 * d2, g2 = v * d2;
            for (c = 0; c < t3.length; c++)
              o = (f2 = t3[c])[n2][r3 + 1] - f2[n2][r3], s = f2[n2 + 1][r3 + 1] - f2[n2 + 1][r3], l = f2[n2 + 2][r3 + 1] - f2[n2 + 2][r3], u = f2[n2 + 3][r3 + 1] - f2[n2 + 3][r3], e3[c] = g2 * o + 3 * (v * a * s + d2 * h * l) + p2 * u;
            return e3;
          } : function(e3, r3, n2, i, a) {
            var o, s, l, u;
            e3 || (e3 = []);
            var c = 1 - a;
            for (l = 0; l < t3.length; l++)
              o = (u = t3[l])[n2][r3 + 1] - u[n2][r3], s = u[n2 + 1][r3 + 1] - u[n2 + 1][r3], e3[l] = c * o + a * s;
            return e3;
          };
        };
      }, 73057: function(t2) {
        t2.exports = function(t3, e2, r2) {
          return e2 && r2 ? function(e3, r3, n2, i, a) {
            var o, s, l, u, c, f2;
            e3 || (e3 = []), r3 *= 3, n2 *= 3;
            var h = i * i, p2 = h * i, d2 = 1 - i, v = d2 * d2, g2 = v * d2, y = a * a, m2 = 1 - a, x = m2 * m2, b = m2 * a * 2, _ = -3 * x, w2 = 3 * (x - b), T = 3 * (b - y), k = 3 * y;
            for (f2 = 0; f2 < t3.length; f2++)
              o = _ * (c = t3[f2])[n2][r3] + w2 * c[n2 + 1][r3] + T * c[n2 + 2][r3] + k * c[n2 + 3][r3], s = _ * c[n2][r3 + 1] + w2 * c[n2 + 1][r3 + 1] + T * c[n2 + 2][r3 + 1] + k * c[n2 + 3][r3 + 1], l = _ * c[n2][r3 + 2] + w2 * c[n2 + 1][r3 + 2] + T * c[n2 + 2][r3 + 2] + k * c[n2 + 3][r3 + 2], u = _ * c[n2][r3 + 3] + w2 * c[n2 + 1][r3 + 3] + T * c[n2 + 2][r3 + 3] + k * c[n2 + 3][r3 + 3], e3[f2] = g2 * o + 3 * (v * i * s + d2 * h * l) + p2 * u;
            return e3;
          } : e2 ? function(e3, r3, n2, i, a) {
            var o, s, l, u, c, f2;
            e3 || (e3 = []), r3 *= 3;
            var h = a * a, p2 = h * a, d2 = 1 - a, v = d2 * d2, g2 = v * d2;
            for (c = 0; c < t3.length; c++)
              o = (f2 = t3[c])[n2 + 1][r3] - f2[n2][r3], s = f2[n2 + 1][r3 + 1] - f2[n2][r3 + 1], l = f2[n2 + 1][r3 + 2] - f2[n2][r3 + 2], u = f2[n2 + 1][r3 + 3] - f2[n2][r3 + 3], e3[c] = g2 * o + 3 * (v * a * s + d2 * h * l) + p2 * u;
            return e3;
          } : r2 ? function(e3, r3, n2, i, a) {
            var o, s, l, u;
            e3 || (e3 = []), n2 *= 3;
            var c = 1 - i, f2 = a * a, h = 1 - a, p2 = h * h, d2 = h * a * 2, v = -3 * p2, g2 = 3 * (p2 - d2), y = 3 * (d2 - f2), m2 = 3 * f2;
            for (l = 0; l < t3.length; l++)
              o = v * (u = t3[l])[n2][r3] + g2 * u[n2 + 1][r3] + y * u[n2 + 2][r3] + m2 * u[n2 + 3][r3], s = v * u[n2][r3 + 1] + g2 * u[n2 + 1][r3 + 1] + y * u[n2 + 2][r3 + 1] + m2 * u[n2 + 3][r3 + 1], e3[l] = c * o + i * s;
            return e3;
          } : function(e3, r3, n2, i, a) {
            var o, s, l, u;
            e3 || (e3 = []);
            var c = 1 - i;
            for (l = 0; l < t3.length; l++)
              o = (u = t3[l])[n2 + 1][r3] - u[n2][r3], s = u[n2 + 1][r3 + 1] - u[n2][r3 + 1], e3[l] = c * o + i * s;
            return e3;
          };
        };
      }, 20349: function(t2) {
        t2.exports = function(t3, e2, r2, n2, i) {
          var a = e2 - 2, o = r2 - 2;
          return n2 && i ? function(e3, r3, n3) {
            var i2, s, l, u, c, f2;
            e3 || (e3 = []);
            var h = Math.max(0, Math.min(Math.floor(r3), a)), p2 = Math.max(0, Math.min(Math.floor(n3), o)), d2 = Math.max(0, Math.min(1, r3 - h)), v = Math.max(0, Math.min(1, n3 - p2));
            h *= 3, p2 *= 3;
            var g2 = d2 * d2, y = g2 * d2, m2 = 1 - d2, x = m2 * m2, b = x * m2, _ = v * v, w2 = _ * v, T = 1 - v, k = T * T, A = k * T;
            for (f2 = 0; f2 < t3.length; f2++)
              i2 = b * (c = t3[f2])[p2][h] + 3 * (x * d2 * c[p2][h + 1] + m2 * g2 * c[p2][h + 2]) + y * c[p2][h + 3], s = b * c[p2 + 1][h] + 3 * (x * d2 * c[p2 + 1][h + 1] + m2 * g2 * c[p2 + 1][h + 2]) + y * c[p2 + 1][h + 3], l = b * c[p2 + 2][h] + 3 * (x * d2 * c[p2 + 2][h + 1] + m2 * g2 * c[p2 + 2][h + 2]) + y * c[p2 + 2][h + 3], u = b * c[p2 + 3][h] + 3 * (x * d2 * c[p2 + 3][h + 1] + m2 * g2 * c[p2 + 3][h + 2]) + y * c[p2 + 3][h + 3], e3[f2] = A * i2 + 3 * (k * v * s + T * _ * l) + w2 * u;
            return e3;
          } : n2 ? function(e3, r3, n3) {
            e3 || (e3 = []);
            var i2, s, l, u, c, f2, h = Math.max(0, Math.min(Math.floor(r3), a)), p2 = Math.max(0, Math.min(Math.floor(n3), o)), d2 = Math.max(0, Math.min(1, r3 - h)), v = Math.max(0, Math.min(1, n3 - p2));
            h *= 3;
            var g2 = d2 * d2, y = g2 * d2, m2 = 1 - d2, x = m2 * m2, b = x * m2, _ = 1 - v;
            for (c = 0; c < t3.length; c++)
              i2 = _ * (f2 = t3[c])[p2][h] + v * f2[p2 + 1][h], s = _ * f2[p2][h + 1] + v * f2[p2 + 1][h + 1], l = _ * f2[p2][h + 2] + v * f2[p2 + 1][h + 1], u = _ * f2[p2][h + 3] + v * f2[p2 + 1][h + 1], e3[c] = b * i2 + 3 * (x * d2 * s + m2 * g2 * l) + y * u;
            return e3;
          } : i ? function(e3, r3, n3) {
            e3 || (e3 = []);
            var i2, s, l, u, c, f2, h = Math.max(0, Math.min(Math.floor(r3), a)), p2 = Math.max(0, Math.min(Math.floor(n3), o)), d2 = Math.max(0, Math.min(1, r3 - h)), v = Math.max(0, Math.min(1, n3 - p2));
            p2 *= 3;
            var g2 = v * v, y = g2 * v, m2 = 1 - v, x = m2 * m2, b = x * m2, _ = 1 - d2;
            for (c = 0; c < t3.length; c++)
              i2 = _ * (f2 = t3[c])[p2][h] + d2 * f2[p2][h + 1], s = _ * f2[p2 + 1][h] + d2 * f2[p2 + 1][h + 1], l = _ * f2[p2 + 2][h] + d2 * f2[p2 + 2][h + 1], u = _ * f2[p2 + 3][h] + d2 * f2[p2 + 3][h + 1], e3[c] = b * i2 + 3 * (x * v * s + m2 * g2 * l) + y * u;
            return e3;
          } : function(e3, r3, n3) {
            e3 || (e3 = []);
            var i2, s, l, u, c = Math.max(0, Math.min(Math.floor(r3), a)), f2 = Math.max(0, Math.min(Math.floor(n3), o)), h = Math.max(0, Math.min(1, r3 - c)), p2 = Math.max(0, Math.min(1, n3 - f2)), d2 = 1 - p2, v = 1 - h;
            for (l = 0; l < t3.length; l++)
              i2 = v * (u = t3[l])[f2][c] + h * u[f2][c + 1], s = v * u[f2 + 1][c] + h * u[f2 + 1][c + 1], e3[l] = d2 * i2 + p2 * s;
            return e3;
          };
        };
      }, 92087: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(19237), a = r2(13145), o = r2(99798), s = r2(22399);
        t2.exports = function(t3, e3, r3, l) {
          function u(r4, i2) {
            return n2.coerce(t3, e3, o, r4, i2);
          }
          e3._clipPathId = "clip" + e3.uid + "carpet";
          var c = u("color", s.defaultLine);
          n2.coerceFont(u, "font"), u("carpet"), a(t3, e3, l, u, c), e3.a && e3.b ? (e3.a.length < 3 && (e3.aaxis.smoothing = 0), e3.b.length < 3 && (e3.baxis.smoothing = 0), i(t3, e3, u) || (e3.visible = false), e3._cheater && u("cheaterslope")) : e3.visible = false;
        };
      }, 21462: function(t2, e2, r2) {
        t2.exports = { attributes: r2(99798), supplyDefaults: r2(92087), plot: r2(89740), calc: r2(25281), animatable: true, isContainer: true, moduleType: "trace", name: "carpet", basePlotModule: r2(93612), categories: ["cartesian", "svg", "carpet", "carpetAxis", "notLegendIsolatable", "noMultiCategory", "noHover", "noSortingByValue"], meta: {} };
      }, 22882: function(t2) {
        t2.exports = function(t3, e2) {
          for (var r2, n2 = t3._fullData.length, i = 0; i < n2; i++) {
            var a = t3._fullData[i];
            if (a.index !== e2.index && "carpet" === a.type && (r2 || (r2 = a), a.carpet === e2.carpet))
              return a;
          }
          return r2;
        };
      }, 67961: function(t2) {
        t2.exports = function(t3, e2, r2) {
          if (0 === t3.length)
            return "";
          var n2, i = [], a = r2 ? 3 : 1;
          for (n2 = 0; n2 < t3.length; n2 += a)
            i.push(t3[n2] + "," + e2[n2]), r2 && n2 < t3.length - a && (i.push("C"), i.push([t3[n2 + 1] + "," + e2[n2 + 1], t3[n2 + 2] + "," + e2[n2 + 2] + " "].join(" ")));
          return i.join(r2 ? "" : "L");
        };
      }, 27669: function(t2, e2, r2) {
        var n2 = r2(71828).isArrayOrTypedArray;
        t2.exports = function(t3, e3, r3) {
          var i;
          for (n2(t3) ? t3.length > e3.length && (t3 = t3.slice(0, e3.length)) : t3 = [], i = 0; i < e3.length; i++)
            t3[i] = r3(e3[i]);
          return t3;
        };
      }, 11651: function(t2) {
        t2.exports = function(t3, e2, r2, n2, i, a) {
          var o = i[0] * t3.dpdx(e2), s = i[1] * t3.dpdy(r2), l = 1, u = 1;
          if (a) {
            var c = Math.sqrt(i[0] * i[0] + i[1] * i[1]), f2 = Math.sqrt(a[0] * a[0] + a[1] * a[1]), h = (i[0] * a[0] + i[1] * a[1]) / c / f2;
            u = Math.max(0, h);
          }
          var p2 = 180 * Math.atan2(s, o) / Math.PI;
          return p2 < -90 ? (p2 += 180, l = -l) : p2 > 90 && (p2 -= 180, l = -l), { angle: p2, flip: l, p: t3.c2p(n2, e2, r2), offsetMultplier: u };
        };
      }, 89740: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(91424), a = r2(27669), o = r2(67961), s = r2(11651), l = r2(63893), u = r2(71828), c = u.strRotate, f2 = u.strTranslate, h = r2(18783);
        function p2(t3, e3, r3, s2, l2, u2, c2) {
          var f3 = "const-" + l2 + "-lines", h2 = r3.selectAll("." + f3).data(u2);
          h2.enter().append("path").classed(f3, true).style("vector-effect", c2 ? "none" : "non-scaling-stroke"), h2.each(function(r4) {
            var s3 = r4, l3 = s3.x, u3 = s3.y, c3 = a([], l3, t3.c2p), f4 = a([], u3, e3.c2p), h3 = "M" + o(c3, f4, s3.smoothing);
            n2.select(this).attr("d", h3).style("stroke-width", s3.width).style("stroke", s3.color).style("stroke-dasharray", i.dashStyle(s3.dash, s3.width)).style("fill", "none");
          }), h2.exit().remove();
        }
        function d2(t3, e3, r3, a2, o2, u2, h2, p3) {
          var d3 = u2.selectAll("text." + p3).data(h2);
          d3.enter().append("text").classed(p3, true);
          var v2 = 0, g3 = {};
          return d3.each(function(o3, u3) {
            var h3;
            if ("auto" === o3.axis.tickangle)
              h3 = s(a2, e3, r3, o3.xy, o3.dxy);
            else {
              var p4 = (o3.axis.tickangle + 180) * Math.PI / 180;
              h3 = s(a2, e3, r3, o3.xy, [Math.cos(p4), Math.sin(p4)]);
            }
            u3 || (g3 = { angle: h3.angle, flip: h3.flip });
            var d4 = (o3.endAnchor ? -1 : 1) * h3.flip, y2 = n2.select(this).attr({ "text-anchor": d4 > 0 ? "start" : "end", "data-notex": 1 }).call(i.font, o3.font).text(o3.text).call(l.convertToTspans, t3), m2 = i.bBox(this);
            y2.attr("transform", f2(h3.p[0], h3.p[1]) + c(h3.angle) + f2(o3.axis.labelpadding * d4, 0.3 * m2.height)), v2 = Math.max(v2, m2.width + o3.axis.labelpadding);
          }), d3.exit().remove(), g3.maxExtent = v2, g3;
        }
        t2.exports = function(t3, e3, r3, i2) {
          var l2 = t3._context.staticPlot, c2 = e3.xaxis, f3 = e3.yaxis, h2 = t3._fullLayout._clips;
          u.makeTraceGroups(i2, r3, "trace").each(function(e4) {
            var r4 = n2.select(this), i3 = e4[0], v2 = i3.trace, g3 = v2.aaxis, m2 = v2.baxis, x = u.ensureSingle(r4, "g", "minorlayer"), b = u.ensureSingle(r4, "g", "majorlayer"), _ = u.ensureSingle(r4, "g", "boundarylayer"), w2 = u.ensureSingle(r4, "g", "labellayer");
            r4.style("opacity", v2.opacity), p2(c2, f3, b, 0, "a", g3._gridlines, true), p2(c2, f3, b, 0, "b", m2._gridlines, true), p2(c2, f3, x, 0, "a", g3._minorgridlines, true), p2(c2, f3, x, 0, "b", m2._minorgridlines, true), p2(c2, f3, _, 0, "a-boundary", g3._boundarylines, l2), p2(c2, f3, _, 0, "b-boundary", m2._boundarylines, l2);
            var T = d2(t3, c2, f3, v2, 0, w2, g3._labels, "a-label"), k = d2(t3, c2, f3, v2, 0, w2, m2._labels, "b-label");
            !function(t4, e5, r5, n3, i4, a2, o2, l3) {
              var c3, f4, h3, p3, d3 = u.aggNums(Math.min, null, r5.a), v3 = u.aggNums(Math.max, null, r5.a), g4 = u.aggNums(Math.min, null, r5.b), m3 = u.aggNums(Math.max, null, r5.b);
              c3 = 0.5 * (d3 + v3), f4 = g4, h3 = r5.ab2xy(c3, f4, true), p3 = r5.dxyda_rough(c3, f4), void 0 === o2.angle && u.extendFlat(o2, s(r5, i4, a2, h3, r5.dxydb_rough(c3, f4))), y(t4, e5, r5, 0, h3, p3, r5.aaxis, i4, a2, o2, "a-title"), c3 = d3, f4 = 0.5 * (g4 + m3), h3 = r5.ab2xy(c3, f4, true), p3 = r5.dxydb_rough(c3, f4), void 0 === l3.angle && u.extendFlat(l3, s(r5, i4, a2, h3, r5.dxyda_rough(c3, f4))), y(t4, e5, r5, 0, h3, p3, r5.baxis, i4, a2, l3, "b-title");
            }(t3, w2, v2, 0, c2, f3, T, k), function(t4, e5, r5, n3, i4) {
              var s2, l3, c3, f4, h3 = r5.select("#" + t4._clipPathId);
              h3.size() || (h3 = r5.append("clipPath").classed("carpetclip", true));
              var p3 = u.ensureSingle(h3, "path", "carpetboundary"), d3 = e5.clipsegments, v3 = [];
              for (f4 = 0; f4 < d3.length; f4++)
                s2 = d3[f4], l3 = a([], s2.x, n3.c2p), c3 = a([], s2.y, i4.c2p), v3.push(o(l3, c3, s2.bicubic));
              var g4 = "M" + v3.join("L") + "Z";
              h3.attr("id", t4._clipPathId), p3.attr("d", g4);
            }(v2, i3, h2, c2, f3);
          });
        };
        var v = h.LINE_SPACING, g2 = (1 - h.MID_SHIFT) / v + 1;
        function y(t3, e3, r3, a2, o2, u2, h2, p3, d3, y2, m2) {
          var x = [];
          h2.title.text && x.push(h2.title.text);
          var b = e3.selectAll("text." + m2).data(x), _ = y2.maxExtent;
          b.enter().append("text").classed(m2, true), b.each(function() {
            var e4 = s(r3, p3, d3, o2, u2);
            -1 === ["start", "both"].indexOf(h2.showticklabels) && (_ = 0);
            var a3 = h2.title.font.size;
            _ += a3 + h2.title.offset;
            var m3 = (y2.angle + (y2.flip < 0 ? 180 : 0) - e4.angle + 450) % 360, x2 = m3 > 90 && m3 < 270, b2 = n2.select(this);
            b2.text(h2.title.text).call(l.convertToTspans, t3), x2 && (_ = (-l.lineCount(b2) + g2) * v * a3 - _), b2.attr("transform", f2(e4.p[0], e4.p[1]) + c(e4.angle) + f2(0, _)).attr("text-anchor", "middle").call(i.font, h2.title.font);
          }), b.exit().remove();
        }
      }, 11435: function(t2, e2, r2) {
        var n2 = r2(35509), i = r2(65888).findBin, a = r2(45664), o = r2(20349), s = r2(54495), l = r2(73057);
        t2.exports = function(t3) {
          var e3 = t3._a, r3 = t3._b, u = e3.length, c = r3.length, f2 = t3.aaxis, h = t3.baxis, p2 = e3[0], d2 = e3[u - 1], v = r3[0], g2 = r3[c - 1], y = e3[e3.length - 1] - e3[0], m2 = r3[r3.length - 1] - r3[0], x = y * n2.RELATIVE_CULL_TOLERANCE, b = m2 * n2.RELATIVE_CULL_TOLERANCE;
          p2 -= x, d2 += x, v -= b, g2 += b, t3.isVisible = function(t4, e4) {
            return t4 > p2 && t4 < d2 && e4 > v && e4 < g2;
          }, t3.isOccluded = function(t4, e4) {
            return t4 < p2 || t4 > d2 || e4 < v || e4 > g2;
          }, t3.setScale = function() {
            var e4 = t3._x, r4 = t3._y, n3 = a(t3._xctrl, t3._yctrl, e4, r4, f2.smoothing, h.smoothing);
            t3._xctrl = n3[0], t3._yctrl = n3[1], t3.evalxy = o([t3._xctrl, t3._yctrl], u, c, f2.smoothing, h.smoothing), t3.dxydi = s([t3._xctrl, t3._yctrl], f2.smoothing, h.smoothing), t3.dxydj = l([t3._xctrl, t3._yctrl], f2.smoothing, h.smoothing);
          }, t3.i2a = function(t4) {
            var r4 = Math.max(0, Math.floor(t4[0]), u - 2), n3 = t4[0] - r4;
            return (1 - n3) * e3[r4] + n3 * e3[r4 + 1];
          }, t3.j2b = function(t4) {
            var e4 = Math.max(0, Math.floor(t4[1]), u - 2), n3 = t4[1] - e4;
            return (1 - n3) * r3[e4] + n3 * r3[e4 + 1];
          }, t3.ij2ab = function(e4) {
            return [t3.i2a(e4[0]), t3.j2b(e4[1])];
          }, t3.a2i = function(t4) {
            var r4 = Math.max(0, Math.min(i(t4, e3), u - 2)), n3 = e3[r4], a2 = e3[r4 + 1];
            return Math.max(0, Math.min(u - 1, r4 + (t4 - n3) / (a2 - n3)));
          }, t3.b2j = function(t4) {
            var e4 = Math.max(0, Math.min(i(t4, r3), c - 2)), n3 = r3[e4], a2 = r3[e4 + 1];
            return Math.max(0, Math.min(c - 1, e4 + (t4 - n3) / (a2 - n3)));
          }, t3.ab2ij = function(e4) {
            return [t3.a2i(e4[0]), t3.b2j(e4[1])];
          }, t3.i2c = function(e4, r4) {
            return t3.evalxy([], e4, r4);
          }, t3.ab2xy = function(n3, i2, a2) {
            if (!a2 && (n3 < e3[0] || n3 > e3[u - 1] | i2 < r3[0] || i2 > r3[c - 1]))
              return [false, false];
            var o2 = t3.a2i(n3), s2 = t3.b2j(i2), l2 = t3.evalxy([], o2, s2);
            if (a2) {
              var f3, h2, p3, d3, v2 = 0, g3 = 0, y2 = [];
              n3 < e3[0] ? (f3 = 0, h2 = 0, v2 = (n3 - e3[0]) / (e3[1] - e3[0])) : n3 > e3[u - 1] ? (f3 = u - 2, h2 = 1, v2 = (n3 - e3[u - 1]) / (e3[u - 1] - e3[u - 2])) : h2 = o2 - (f3 = Math.max(0, Math.min(u - 2, Math.floor(o2)))), i2 < r3[0] ? (p3 = 0, d3 = 0, g3 = (i2 - r3[0]) / (r3[1] - r3[0])) : i2 > r3[c - 1] ? (p3 = c - 2, d3 = 1, g3 = (i2 - r3[c - 1]) / (r3[c - 1] - r3[c - 2])) : d3 = s2 - (p3 = Math.max(0, Math.min(c - 2, Math.floor(s2)))), v2 && (t3.dxydi(y2, f3, p3, h2, d3), l2[0] += y2[0] * v2, l2[1] += y2[1] * v2), g3 && (t3.dxydj(y2, f3, p3, h2, d3), l2[0] += y2[0] * g3, l2[1] += y2[1] * g3);
            }
            return l2;
          }, t3.c2p = function(t4, e4, r4) {
            return [e4.c2p(t4[0]), r4.c2p(t4[1])];
          }, t3.p2x = function(t4, e4, r4) {
            return [e4.p2c(t4[0]), r4.p2c(t4[1])];
          }, t3.dadi = function(t4) {
            var r4 = Math.max(0, Math.min(e3.length - 2, t4));
            return e3[r4 + 1] - e3[r4];
          }, t3.dbdj = function(t4) {
            var e4 = Math.max(0, Math.min(r3.length - 2, t4));
            return r3[e4 + 1] - r3[e4];
          }, t3.dxyda = function(e4, r4, n3, i2) {
            var a2 = t3.dxydi(null, e4, r4, n3, i2), o2 = t3.dadi(e4, n3);
            return [a2[0] / o2, a2[1] / o2];
          }, t3.dxydb = function(e4, r4, n3, i2) {
            var a2 = t3.dxydj(null, e4, r4, n3, i2), o2 = t3.dbdj(r4, i2);
            return [a2[0] / o2, a2[1] / o2];
          }, t3.dxyda_rough = function(e4, r4, n3) {
            var i2 = y * (n3 || 0.1), a2 = t3.ab2xy(e4 + i2, r4, true), o2 = t3.ab2xy(e4 - i2, r4, true);
            return [0.5 * (a2[0] - o2[0]) / i2, 0.5 * (a2[1] - o2[1]) / i2];
          }, t3.dxydb_rough = function(e4, r4, n3) {
            var i2 = m2 * (n3 || 0.1), a2 = t3.ab2xy(e4, r4 + i2, true), o2 = t3.ab2xy(e4, r4 - i2, true);
            return [0.5 * (a2[0] - o2[0]) / i2, 0.5 * (a2[1] - o2[1]) / i2];
          }, t3.dpdx = function(t4) {
            return t4._m;
          }, t3.dpdy = function(t4) {
            return t4._m;
          };
        };
      }, 72505: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = function(t3, e3, r3) {
          var i, a, o, s = [], l = [], u = t3[0].length, c = t3.length;
          function f2(e4, r4) {
            var n3, i2 = 0, a2 = 0;
            return e4 > 0 && void 0 !== (n3 = t3[r4][e4 - 1]) && (a2++, i2 += n3), e4 < u - 1 && void 0 !== (n3 = t3[r4][e4 + 1]) && (a2++, i2 += n3), r4 > 0 && void 0 !== (n3 = t3[r4 - 1][e4]) && (a2++, i2 += n3), r4 < c - 1 && void 0 !== (n3 = t3[r4 + 1][e4]) && (a2++, i2 += n3), i2 / Math.max(1, a2);
          }
          var h, p2, d2, v, g2, y, m2, x, b, _, w2, T = 0;
          for (i = 0; i < u; i++)
            for (a = 0; a < c; a++)
              void 0 === t3[a][i] && (s.push(i), l.push(a), t3[a][i] = f2(i, a)), T = Math.max(T, Math.abs(t3[a][i]));
          if (!s.length)
            return t3;
          var k = 0, A = 0, M = s.length;
          do {
            for (k = 0, o = 0; o < M; o++) {
              i = s[o], a = l[o];
              var S, E, L, C, P, O, I = 0, D = 0;
              0 === i ? (L = e3[P = Math.min(u - 1, 2)], C = e3[1], S = t3[a][P], D += (E = t3[a][1]) + (E - S) * (e3[0] - C) / (C - L), I++) : i === u - 1 && (L = e3[P = Math.max(0, u - 3)], C = e3[u - 2], S = t3[a][P], D += (E = t3[a][u - 2]) + (E - S) * (e3[u - 1] - C) / (C - L), I++), (0 === i || i === u - 1) && a > 0 && a < c - 1 && (h = r3[a + 1] - r3[a], D += ((p2 = r3[a] - r3[a - 1]) * t3[a + 1][i] + h * t3[a - 1][i]) / (p2 + h), I++), 0 === a ? (L = r3[O = Math.min(c - 1, 2)], C = r3[1], S = t3[O][i], D += (E = t3[1][i]) + (E - S) * (r3[0] - C) / (C - L), I++) : a === c - 1 && (L = r3[O = Math.max(0, c - 3)], C = r3[c - 2], S = t3[O][i], D += (E = t3[c - 2][i]) + (E - S) * (r3[c - 1] - C) / (C - L), I++), (0 === a || a === c - 1) && i > 0 && i < u - 1 && (h = e3[i + 1] - e3[i], D += ((p2 = e3[i] - e3[i - 1]) * t3[a][i + 1] + h * t3[a][i - 1]) / (p2 + h), I++), I ? D /= I : (d2 = e3[i + 1] - e3[i], v = e3[i] - e3[i - 1], x = (g2 = r3[a + 1] - r3[a]) * (y = r3[a] - r3[a - 1]) * (g2 + y), D = ((m2 = d2 * v * (d2 + v)) * (y * t3[a + 1][i] + g2 * t3[a - 1][i]) + x * (v * t3[a][i + 1] + d2 * t3[a][i - 1])) / (x * (v + d2) + m2 * (y + g2))), k += (_ = (b = D - t3[a][i]) / T) * _, w2 = I ? 0 : 0.85, t3[a][i] += b * (1 + w2);
            }
            k = Math.sqrt(k);
          } while (A++ < 100 && k > 1e-5);
          return n2.log("Smoother converged to", k, "after", A, "iterations"), t3;
        };
      }, 19237: function(t2, e2, r2) {
        var n2 = r2(71828).isArray1D;
        t2.exports = function(t3, e3, r3) {
          var i = r3("x"), a = i && i.length, o = r3("y"), s = o && o.length;
          if (!a && !s)
            return false;
          if (e3._cheater = !i, a && !n2(i) || s && !n2(o))
            e3._length = null;
          else {
            var l = a ? i.length : 1 / 0;
            s && (l = Math.min(l, o.length)), e3.a && e3.a.length && (l = Math.min(l, e3.a.length)), e3.b && e3.b.length && (l = Math.min(l, e3.b.length)), e3._length = l;
          }
          return true;
        };
      }, 69568: function(t2, e2, r2) {
        var n2 = r2(5386).f, i = r2(19316), a = r2(50693), o = r2(9012), s = r2(22399).defaultLine, l = r2(1426).extendFlat, u = i.marker.line;
        t2.exports = l({ locations: { valType: "data_array", editType: "calc" }, locationmode: i.locationmode, z: { valType: "data_array", editType: "calc" }, geojson: l({}, i.geojson, {}), featureidkey: i.featureidkey, text: l({}, i.text, {}), hovertext: l({}, i.hovertext, {}), marker: { line: { color: l({}, u.color, { dflt: s }), width: l({}, u.width, { dflt: 1 }), editType: "calc" }, opacity: { valType: "number", arrayOk: true, min: 0, max: 1, dflt: 1, editType: "style" }, editType: "calc" }, selected: { marker: { opacity: i.selected.marker.opacity, editType: "plot" }, editType: "plot" }, unselected: { marker: { opacity: i.unselected.marker.opacity, editType: "plot" }, editType: "plot" }, hoverinfo: l({}, o.hoverinfo, { editType: "calc", flags: ["location", "z", "text", "name"] }), hovertemplate: n2(), showlegend: l({}, o.showlegend, { dflt: false }) }, a("", { cLetter: "z", editTypeOverride: "calc" }));
      }, 38675: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(50606).BADNUM, a = r2(78803), o = r2(75225), s = r2(66279);
        function l(t3) {
          return t3 && "string" == typeof t3;
        }
        t2.exports = function(t3, e3) {
          var r3, u = e3._length, c = new Array(u);
          r3 = e3.geojson ? function(t4) {
            return l(t4) || n2(t4);
          } : l;
          for (var f2 = 0; f2 < u; f2++) {
            var h = c[f2] = {}, p2 = e3.locations[f2], d2 = e3.z[f2];
            r3(p2) && n2(d2) ? (h.loc = p2, h.z = d2) : (h.loc = null, h.z = i), h.index = f2;
          }
          return o(c, e3), a(t3, e3, { vals: e3.z, containerStr: "", cLetter: "z" }), s(c, e3), c;
        };
      }, 61869: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(1586), a = r2(69568);
        t2.exports = function(t3, e3, r3, o) {
          function s(r4, i2) {
            return n2.coerce(t3, e3, a, r4, i2);
          }
          var l = s("locations"), u = s("z");
          if (l && l.length && n2.isArrayOrTypedArray(u) && u.length) {
            e3._length = Math.min(l.length, u.length);
            var c, f2 = s("geojson");
            ("string" == typeof f2 && "" !== f2 || n2.isPlainObject(f2)) && (c = "geojson-id"), "geojson-id" === s("locationmode", c) && s("featureidkey"), s("text"), s("hovertext"), s("hovertemplate"), s("marker.line.width") && s("marker.line.color"), s("marker.opacity"), i(t3, e3, o, s, { prefix: "", cLetter: "z" }), n2.coerceSelectionMarkerOpacity(e3, s);
          } else
            e3.visible = false;
        };
      }, 92069: function(t2) {
        t2.exports = function(t3, e2, r2, n2, i) {
          t3.location = e2.location, t3.z = e2.z;
          var a = n2[i];
          return a.fIn && a.fIn.properties && (t3.properties = a.fIn.properties), t3.ct = a.ct, t3;
        };
      }, 42300: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(69568), a = r2(71828).fillText;
        t2.exports = function(t3, e3, r3) {
          var o, s, l, u, c = t3.cd, f2 = c[0].trace, h = t3.subplot, p2 = [e3, r3], d2 = [e3 + 360, r3];
          for (s = 0; s < c.length; s++)
            if (u = false, (o = c[s])._polygons) {
              for (l = 0; l < o._polygons.length; l++)
                o._polygons[l].contains(p2) && (u = !u), o._polygons[l].contains(d2) && (u = !u);
              if (u)
                break;
            }
          if (u && o)
            return t3.x0 = t3.x1 = t3.xa.c2p(o.ct), t3.y0 = t3.y1 = t3.ya.c2p(o.ct), t3.index = o.index, t3.location = o.loc, t3.z = o.z, t3.zLabel = n2.tickText(h.mockAxis, h.mockAxis.c2l(o.z), "hover").text, t3.hovertemplate = o.hovertemplate, function(t4, e4, r4) {
              if (!e4.hovertemplate) {
                var n3 = r4.hi || e4.hoverinfo, o2 = String(r4.loc), s2 = "all" === n3 ? i.hoverinfo.flags : n3.split("+"), l2 = -1 !== s2.indexOf("name"), u2 = -1 !== s2.indexOf("location"), c2 = -1 !== s2.indexOf("z"), f3 = -1 !== s2.indexOf("text"), h2 = [];
                !l2 && u2 ? t4.nameOverride = o2 : (l2 && (t4.nameOverride = e4.name), u2 && h2.push(o2)), c2 && h2.push(t4.zLabel), f3 && a(r4, e4, h2), t4.extraText = h2.join("<br>");
              }
            }(t3, f2, o), [t3];
        };
      }, 51319: function(t2, e2, r2) {
        t2.exports = { attributes: r2(69568), supplyDefaults: r2(61869), colorbar: r2(61243), calc: r2(38675), calcGeoJSON: r2(99841).calcGeoJSON, plot: r2(99841).plot, style: r2(99636).style, styleOnSelect: r2(99636).styleOnSelect, hoverPoints: r2(42300), eventData: r2(92069), selectPoints: r2(81253), moduleType: "trace", name: "choropleth", basePlotModule: r2(44622), categories: ["geo", "noOpacity", "showLegend"], meta: {} };
      }, 99841: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(41327), o = r2(90973).getTopojsonFeatures, s = r2(71739).findExtremes, l = r2(99636).style;
        t2.exports = { calcGeoJSON: function(t3, e3) {
          for (var r3 = t3[0].trace, n3 = e3[r3.geo], i2 = n3._subplot, l2 = r3.locationmode, u = r3._length, c = "geojson-id" === l2 ? a.extractTraceFeature(t3) : o(r3, i2.topojson), f2 = [], h = [], p2 = 0; p2 < u; p2++) {
            var d2 = t3[p2], v = "geojson-id" === l2 ? d2.fOut : a.locationToFeature(l2, d2.loc, c);
            if (v) {
              d2.geojson = v, d2.ct = v.properties.ct, d2._polygons = a.feature2polygons(v);
              var g2 = a.computeBbox(v);
              f2.push(g2[0], g2[2]), h.push(g2[1], g2[3]);
            } else
              d2.geojson = null;
          }
          if ("geojson" === n3.fitbounds && "geojson-id" === l2) {
            var y = a.computeBbox(a.getTraceGeojson(r3));
            f2 = [y[0], y[2]], h = [y[1], y[3]];
          }
          var m2 = { padded: true };
          r3._extremes.lon = s(n3.lonaxis._ax, f2, m2), r3._extremes.lat = s(n3.lataxis._ax, h, m2);
        }, plot: function(t3, e3, r3) {
          var a2 = e3.layers.backplot.select(".choroplethlayer");
          i.makeTraceGroups(a2, r3, "trace choropleth").each(function(e4) {
            var r4 = n2.select(this).selectAll("path.choroplethlocation").data(i.identity);
            r4.enter().append("path").classed("choroplethlocation", true), r4.exit().remove(), l(t3, e4);
          });
        } };
      }, 81253: function(t2) {
        t2.exports = function(t3, e2) {
          var r2, n2, i, a, o, s = t3.cd, l = t3.xaxis, u = t3.yaxis, c = [];
          if (false === e2)
            for (r2 = 0; r2 < s.length; r2++)
              s[r2].selected = 0;
          else
            for (r2 = 0; r2 < s.length; r2++)
              (i = (n2 = s[r2]).ct) && (a = l.c2p(i), o = u.c2p(i), e2.contains([a, o], null, r2, t3) ? (c.push({ pointNumber: r2, lon: i[0], lat: i[1] }), n2.selected = 1) : n2.selected = 0);
          return c;
        };
      }, 99636: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(7901), a = r2(91424), o = r2(21081);
        function s(t3, e3) {
          var r3 = e3[0].trace, s2 = e3[0].node3.selectAll(".choroplethlocation"), l = r3.marker || {}, u = l.line || {}, c = o.makeColorScaleFuncFromTrace(r3);
          s2.each(function(t4) {
            n2.select(this).attr("fill", c(t4.z)).call(i.stroke, t4.mlc || u.color).call(a.dashLine, "", t4.mlw || u.width || 0).style("opacity", l.opacity);
          }), a.selectedPointStyle(s2, r3);
        }
        t2.exports = { style: function(t3, e3) {
          e3 && s(0, e3);
        }, styleOnSelect: function(t3, e3) {
          var r3 = e3[0].node3, n3 = e3[0].trace;
          n3.selectedpoints ? a.selectedPointStyle(r3.selectAll(".choroplethlocation"), n3) : s(0, e3);
        } };
      }, 64496: function(t2, e2, r2) {
        var n2 = r2(69568), i = r2(50693), a = r2(5386).f, o = r2(9012), s = r2(1426).extendFlat;
        t2.exports = s({ locations: { valType: "data_array", editType: "calc" }, z: { valType: "data_array", editType: "calc" }, geojson: { valType: "any", editType: "calc" }, featureidkey: s({}, n2.featureidkey, {}), below: { valType: "string", editType: "plot" }, text: n2.text, hovertext: n2.hovertext, marker: { line: { color: s({}, n2.marker.line.color, { editType: "plot" }), width: s({}, n2.marker.line.width, { editType: "plot" }), editType: "calc" }, opacity: s({}, n2.marker.opacity, { editType: "plot" }), editType: "calc" }, selected: { marker: { opacity: s({}, n2.selected.marker.opacity, { editType: "plot" }), editType: "plot" }, editType: "plot" }, unselected: { marker: { opacity: s({}, n2.unselected.marker.opacity, { editType: "plot" }), editType: "plot" }, editType: "plot" }, hoverinfo: n2.hoverinfo, hovertemplate: a({}, { keys: ["properties"] }), showlegend: s({}, o.showlegend, { dflt: false }) }, i("", { cLetter: "z", editTypeOverride: "calc" }));
      }, 82004: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = r2(21081), o = r2(91424), s = r2(18214).makeBlank, l = r2(41327);
        function u(t3) {
          var e3, r3 = t3[0].trace, n3 = r3._opts;
          if (r3.selectedpoints) {
            for (var a2 = o.makeSelectedPointStyleFns(r3), s2 = 0; s2 < t3.length; s2++) {
              var l2 = t3[s2];
              l2.fOut && (l2.fOut.properties.mo2 = a2.selectedOpacityFn(l2));
            }
            e3 = { type: "identity", property: "mo2" };
          } else
            e3 = i.isArrayOrTypedArray(r3.marker.opacity) ? { type: "identity", property: "mo" } : r3.marker.opacity;
          return i.extendFlat(n3.fill.paint, { "fill-opacity": e3 }), i.extendFlat(n3.line.paint, { "line-opacity": e3 }), n3;
        }
        t2.exports = { convert: function(t3) {
          var e3 = t3[0].trace, r3 = true === e3.visible && 0 !== e3._length, o2 = { layout: { visibility: "none" }, paint: {} }, c = { layout: { visibility: "none" }, paint: {} }, f2 = e3._opts = { fill: o2, line: c, geojson: s() };
          if (!r3)
            return f2;
          var h = l.extractTraceFeature(t3);
          if (!h)
            return f2;
          var p2, d2, v, g2 = a.makeColorScaleFuncFromTrace(e3), y = e3.marker, m2 = y.line || {};
          i.isArrayOrTypedArray(y.opacity) && (p2 = function(t4) {
            var e4 = t4.mo;
            return n2(e4) ? +i.constrain(e4, 0, 1) : 0;
          }), i.isArrayOrTypedArray(m2.color) && (d2 = function(t4) {
            return t4.mlc;
          }), i.isArrayOrTypedArray(m2.width) && (v = function(t4) {
            return t4.mlw;
          });
          for (var x = 0; x < t3.length; x++) {
            var b = t3[x], _ = b.fOut;
            if (_) {
              var w2 = _.properties;
              w2.fc = g2(b.z), p2 && (w2.mo = p2(b)), d2 && (w2.mlc = d2(b)), v && (w2.mlw = v(b)), b.ct = w2.ct, b._polygons = l.feature2polygons(_);
            }
          }
          var T = p2 ? { type: "identity", property: "mo" } : y.opacity;
          return i.extendFlat(o2.paint, { "fill-color": { type: "identity", property: "fc" }, "fill-opacity": T }), i.extendFlat(c.paint, { "line-color": d2 ? { type: "identity", property: "mlc" } : m2.color, "line-width": v ? { type: "identity", property: "mlw" } : m2.width, "line-opacity": T }), o2.layout.visibility = "visible", c.layout.visibility = "visible", f2.geojson = { type: "FeatureCollection", features: h }, u(t3), f2;
        }, convertOnSelect: u };
      }, 22654: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(1586), a = r2(64496);
        t2.exports = function(t3, e3, r3, o) {
          function s(r4, i2) {
            return n2.coerce(t3, e3, a, r4, i2);
          }
          var l = s("locations"), u = s("z"), c = s("geojson");
          n2.isArrayOrTypedArray(l) && l.length && n2.isArrayOrTypedArray(u) && u.length && ("string" == typeof c && "" !== c || n2.isPlainObject(c)) ? (s("featureidkey"), e3._length = Math.min(l.length, u.length), s("below"), s("text"), s("hovertext"), s("hovertemplate"), s("marker.line.width") && s("marker.line.color"), s("marker.opacity"), i(t3, e3, o, s, { prefix: "", cLetter: "z" }), n2.coerceSelectionMarkerOpacity(e3, s)) : e3.visible = false;
        };
      }, 57516: function(t2, e2, r2) {
        t2.exports = { attributes: r2(64496), supplyDefaults: r2(22654), colorbar: r2(61243), calc: r2(38675), plot: r2(7852), hoverPoints: r2(42300), eventData: r2(92069), selectPoints: r2(81253), styleOnSelect: function(t3, e3) {
          e3 && e3[0].trace._glTrace.updateOnSelect(e3);
        }, getBelow: function(t3, e3) {
          for (var r3 = e3.getMapLayers(), n2 = r3.length - 2; n2 >= 0; n2--) {
            var i = r3[n2].id;
            if ("string" == typeof i && 0 === i.indexOf("water")) {
              for (var a = n2 + 1; a < r3.length; a++)
                if ("string" == typeof (i = r3[a].id) && -1 === i.indexOf("plotly-"))
                  return i;
            }
          }
        }, moduleType: "trace", name: "choroplethmapbox", basePlotModule: r2(50101), categories: ["mapbox", "gl", "noOpacity", "showLegend"], meta: { hr_name: "choropleth_mapbox" } };
      }, 7852: function(t2, e2, r2) {
        var n2 = r2(82004).convert, i = r2(82004).convertOnSelect, a = r2(77734).traceLayerPrefix;
        function o(t3, e3) {
          this.type = "choroplethmapbox", this.subplot = t3, this.uid = e3, this.sourceId = "source-" + e3, this.layerList = [["fill", a + e3 + "-fill"], ["line", a + e3 + "-line"]], this.below = null;
        }
        var s = o.prototype;
        s.update = function(t3) {
          this._update(n2(t3)), t3[0].trace._glTrace = this;
        }, s.updateOnSelect = function(t3) {
          this._update(i(t3));
        }, s._update = function(t3) {
          var e3 = this.subplot, r3 = this.layerList, n3 = e3.belowLookup["trace-" + this.uid];
          e3.map.getSource(this.sourceId).setData(t3.geojson), n3 !== this.below && (this._removeLayers(), this._addLayers(t3, n3), this.below = n3);
          for (var i2 = 0; i2 < r3.length; i2++) {
            var a2 = r3[i2], o2 = a2[0], s2 = a2[1], l = t3[o2];
            e3.setOptions(s2, "setLayoutProperty", l.layout), "visible" === l.layout.visibility && e3.setOptions(s2, "setPaintProperty", l.paint);
          }
        }, s._addLayers = function(t3, e3) {
          for (var r3 = this.subplot, n3 = this.layerList, i2 = this.sourceId, a2 = 0; a2 < n3.length; a2++) {
            var o2 = n3[a2], s2 = o2[0], l = t3[s2];
            r3.addLayer({ type: s2, id: o2[1], source: i2, layout: l.layout, paint: l.paint }, e3);
          }
        }, s._removeLayers = function() {
          for (var t3 = this.subplot.map, e3 = this.layerList, r3 = e3.length - 1; r3 >= 0; r3--)
            t3.removeLayer(e3[r3][1]);
        }, s.dispose = function() {
          var t3 = this.subplot.map;
          this._removeLayers(), t3.removeSource(this.sourceId);
        }, t2.exports = function(t3, e3) {
          var r3 = e3[0].trace, i2 = new o(t3, r3.uid), a2 = i2.sourceId, s2 = n2(e3), l = i2.below = t3.belowLookup["trace-" + r3.uid];
          return t3.map.addSource(a2, { type: "geojson", data: s2.geojson }), i2._addLayers(s2, l), e3[0].trace._glTrace = i2, i2;
        };
      }, 12674: function(t2, e2, r2) {
        var n2 = r2(50693), i = r2(12663).axisHoverFormat, a = r2(5386).f, o = r2(2418), s = r2(9012), l = r2(1426).extendFlat, u = { x: { valType: "data_array", editType: "calc+clearAxisTypes" }, y: { valType: "data_array", editType: "calc+clearAxisTypes" }, z: { valType: "data_array", editType: "calc+clearAxisTypes" }, u: { valType: "data_array", editType: "calc" }, v: { valType: "data_array", editType: "calc" }, w: { valType: "data_array", editType: "calc" }, sizemode: { valType: "enumerated", values: ["scaled", "absolute"], editType: "calc", dflt: "scaled" }, sizeref: { valType: "number", editType: "calc", min: 0 }, anchor: { valType: "enumerated", editType: "calc", values: ["tip", "tail", "cm", "center"], dflt: "cm" }, text: { valType: "string", dflt: "", arrayOk: true, editType: "calc" }, hovertext: { valType: "string", dflt: "", arrayOk: true, editType: "calc" }, hovertemplate: a({ editType: "calc" }, { keys: ["norm"] }), uhoverformat: i("u", 1), vhoverformat: i("v", 1), whoverformat: i("w", 1), xhoverformat: i("x"), yhoverformat: i("y"), zhoverformat: i("z"), showlegend: l({}, s.showlegend, { dflt: false }) };
        l(u, n2("", { colorAttr: "u/v/w norm", showScaleDflt: true, editTypeOverride: "calc" })), ["opacity", "lightposition", "lighting"].forEach(function(t3) {
          u[t3] = o[t3];
        }), u.hoverinfo = l({}, s.hoverinfo, { editType: "calc", flags: ["x", "y", "z", "u", "v", "w", "norm", "text", "name"], dflt: "x+y+z+norm+text+name" }), u.transforms = void 0, t2.exports = u;
      }, 31371: function(t2, e2, r2) {
        var n2 = r2(78803);
        t2.exports = function(t3, e3) {
          for (var r3 = e3.u, i = e3.v, a = e3.w, o = Math.min(e3.x.length, e3.y.length, e3.z.length, r3.length, i.length, a.length), s = -1 / 0, l = 1 / 0, u = 0; u < o; u++) {
            var c = r3[u], f2 = i[u], h = a[u], p2 = Math.sqrt(c * c + f2 * f2 + h * h);
            s = Math.max(s, p2), l = Math.min(l, p2);
          }
          e3._len = o, e3._normMax = s, n2(t3, e3, { vals: [l, s], containerStr: "", cLetter: "c" });
        };
      }, 5453: function(t2, e2, r2) {
        var n2 = r2(9330).gl_cone3d, i = r2(9330).gl_cone3d.createConeMesh, a = r2(71828).simpleMap, o = r2(81697).parseColorScale, s = r2(21081).extractOpts, l = r2(90060);
        function u(t3, e3) {
          this.scene = t3, this.uid = e3, this.mesh = null, this.data = null;
        }
        var c = u.prototype;
        c.handlePick = function(t3) {
          if (t3.object === this.mesh) {
            var e3 = t3.index = t3.data.index, r3 = this.data.x[e3], n3 = this.data.y[e3], i2 = this.data.z[e3], a2 = this.data.u[e3], o2 = this.data.v[e3], s2 = this.data.w[e3];
            t3.traceCoordinate = [r3, n3, i2, a2, o2, s2, Math.sqrt(a2 * a2 + o2 * o2 + s2 * s2)];
            var l2 = this.data.hovertext || this.data.text;
            return Array.isArray(l2) && void 0 !== l2[e3] ? t3.textLabel = l2[e3] : l2 && (t3.textLabel = l2), true;
          }
        };
        var f2 = { xaxis: 0, yaxis: 1, zaxis: 2 }, h = { tip: 1, tail: 0, cm: 0.25, center: 0.5 }, p2 = { tip: 1, tail: 1, cm: 0.75, center: 0.5 };
        function d2(t3, e3) {
          var r3 = t3.fullSceneLayout, i2 = t3.dataScale, u2 = {};
          function c2(t4, e4) {
            var n3 = r3[e4], o2 = i2[f2[e4]];
            return a(t4, function(t5) {
              return n3.d2l(t5) * o2;
            });
          }
          u2.vectors = l(c2(e3.u, "xaxis"), c2(e3.v, "yaxis"), c2(e3.w, "zaxis"), e3._len), u2.positions = l(c2(e3.x, "xaxis"), c2(e3.y, "yaxis"), c2(e3.z, "zaxis"), e3._len);
          var d3 = s(e3);
          u2.colormap = o(e3), u2.vertexIntensityBounds = [d3.min / e3._normMax, d3.max / e3._normMax], u2.coneOffset = h[e3.anchor], "scaled" === e3.sizemode ? u2.coneSize = e3.sizeref || 0.5 : u2.coneSize = e3.sizeref && e3._normMax ? e3.sizeref / e3._normMax : 0.5;
          var v = n2(u2), g2 = e3.lightposition;
          return v.lightPosition = [g2.x, g2.y, g2.z], v.ambient = e3.lighting.ambient, v.diffuse = e3.lighting.diffuse, v.specular = e3.lighting.specular, v.roughness = e3.lighting.roughness, v.fresnel = e3.lighting.fresnel, v.opacity = e3.opacity, e3._pad = p2[e3.anchor] * v.vectorScale * v.coneScale * e3._normMax, v;
        }
        c.update = function(t3) {
          this.data = t3;
          var e3 = d2(this.scene, t3);
          this.mesh.update(e3);
        }, c.dispose = function() {
          this.scene.glplot.remove(this.mesh), this.mesh.dispose();
        }, t2.exports = function(t3, e3) {
          var r3 = t3.glplot.gl, n3 = d2(t3, e3), a2 = i(r3, n3), o2 = new u(t3, e3.uid);
          return o2.mesh = a2, o2.data = e3, a2._trace = o2, t3.glplot.add(a2), o2;
        };
      }, 91750: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(1586), a = r2(12674);
        t2.exports = function(t3, e3, r3, o) {
          function s(r4, i2) {
            return n2.coerce(t3, e3, a, r4, i2);
          }
          var l = s("u"), u = s("v"), c = s("w"), f2 = s("x"), h = s("y"), p2 = s("z");
          l && l.length && u && u.length && c && c.length && f2 && f2.length && h && h.length && p2 && p2.length ? (s("sizeref"), s("sizemode"), s("anchor"), s("lighting.ambient"), s("lighting.diffuse"), s("lighting.specular"), s("lighting.roughness"), s("lighting.fresnel"), s("lightposition.x"), s("lightposition.y"), s("lightposition.z"), i(t3, e3, o, s, { prefix: "", cLetter: "c" }), s("text"), s("hovertext"), s("hovertemplate"), s("uhoverformat"), s("vhoverformat"), s("whoverformat"), s("xhoverformat"), s("yhoverformat"), s("zhoverformat"), e3._length = null) : e3.visible = false;
        };
      }, 98128: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "cone", basePlotModule: r2(58547), categories: ["gl3d", "showLegend"], attributes: r2(12674), supplyDefaults: r2(91750), colorbar: { min: "cmin", max: "cmax" }, calc: r2(31371), plot: r2(5453), eventData: function(t3, e3) {
          return t3.norm = e3.traceCoordinate[6], t3;
        }, meta: {} };
      }, 70600: function(t2, e2, r2) {
        var n2 = r2(21606), i = r2(82196), a = r2(12663), o = a.axisHoverFormat, s = a.descriptionOnlyNumbers, l = r2(50693), u = r2(79952).P, c = r2(41940), f2 = r2(1426).extendFlat, h = r2(74808), p2 = h.COMPARISON_OPS2, d2 = h.INTERVAL_OPS, v = i.line;
        t2.exports = f2({ z: n2.z, x: n2.x, x0: n2.x0, dx: n2.dx, y: n2.y, y0: n2.y0, dy: n2.dy, xperiod: n2.xperiod, yperiod: n2.yperiod, xperiod0: i.xperiod0, yperiod0: i.yperiod0, xperiodalignment: n2.xperiodalignment, yperiodalignment: n2.yperiodalignment, text: n2.text, hovertext: n2.hovertext, transpose: n2.transpose, xtype: n2.xtype, ytype: n2.ytype, xhoverformat: o("x"), yhoverformat: o("y"), zhoverformat: o("z", 1), hovertemplate: n2.hovertemplate, texttemplate: f2({}, n2.texttemplate, {}), textfont: f2({}, n2.textfont, {}), hoverongaps: n2.hoverongaps, connectgaps: f2({}, n2.connectgaps, {}), fillcolor: { valType: "color", editType: "calc" }, autocontour: { valType: "boolean", dflt: true, editType: "calc", impliedEdits: { "contours.start": void 0, "contours.end": void 0, "contours.size": void 0 } }, ncontours: { valType: "integer", dflt: 15, min: 1, editType: "calc" }, contours: { type: { valType: "enumerated", values: ["levels", "constraint"], dflt: "levels", editType: "calc" }, start: { valType: "number", dflt: null, editType: "plot", impliedEdits: { "^autocontour": false } }, end: { valType: "number", dflt: null, editType: "plot", impliedEdits: { "^autocontour": false } }, size: { valType: "number", dflt: null, min: 0, editType: "plot", impliedEdits: { "^autocontour": false } }, coloring: { valType: "enumerated", values: ["fill", "heatmap", "lines", "none"], dflt: "fill", editType: "calc" }, showlines: { valType: "boolean", dflt: true, editType: "plot" }, showlabels: { valType: "boolean", dflt: false, editType: "plot" }, labelfont: c({ editType: "plot", colorEditType: "style" }), labelformat: { valType: "string", dflt: "", editType: "plot", description: s("contour label") }, operation: { valType: "enumerated", values: [].concat(p2).concat(d2), dflt: "=", editType: "calc" }, value: { valType: "any", dflt: 0, editType: "calc" }, editType: "calc", impliedEdits: { autocontour: false } }, line: { color: f2({}, v.color, { editType: "style+colorbars" }), width: { valType: "number", min: 0, editType: "style+colorbars" }, dash: u, smoothing: f2({}, v.smoothing, {}), editType: "plot" } }, l("", { cLetter: "z", autoColorDflt: false, editTypeOverride: "calc" }));
      }, 27529: function(t2, e2, r2) {
        var n2 = r2(21081), i = r2(90757), a = r2(18670), o = r2(53572);
        t2.exports = function(t3, e3) {
          var r3 = i(t3, e3), s = r3[0].z;
          a(e3, s);
          var l, u = e3.contours, c = n2.extractOpts(e3);
          if ("heatmap" === u.coloring && c.auto && false === e3.autocontour) {
            var f2 = u.start, h = o(u), p2 = u.size || 1, d2 = Math.floor((h - f2) / p2) + 1;
            isFinite(p2) || (p2 = 1, d2 = 1);
            var v = f2 - p2 / 2;
            l = [v, v + d2 * p2];
          } else
            l = s;
          return n2.calc(t3, e3, { vals: l, cLetter: "z" }), r3;
        };
      }, 20083: function(t2) {
        t2.exports = function(t3, e2) {
          var r2, n2 = t3[0], i = n2.z;
          switch (e2.type) {
            case "levels":
              var a = Math.min(i[0][0], i[0][1]);
              for (r2 = 0; r2 < t3.length; r2++) {
                var o = t3[r2];
                o.prefixBoundary = !o.edgepaths.length && (a > o.level || o.starts.length && a === o.level);
              }
              break;
            case "constraint":
              if (n2.prefixBoundary = false, n2.edgepaths.length)
                return;
              var s = n2.x.length, l = n2.y.length, u = -1 / 0, c = 1 / 0;
              for (r2 = 0; r2 < l; r2++)
                c = Math.min(c, i[r2][0]), c = Math.min(c, i[r2][s - 1]), u = Math.max(u, i[r2][0]), u = Math.max(u, i[r2][s - 1]);
              for (r2 = 1; r2 < s - 1; r2++)
                c = Math.min(c, i[0][r2]), c = Math.min(c, i[l - 1][r2]), u = Math.max(u, i[0][r2]), u = Math.max(u, i[l - 1][r2]);
              var f2, h, p2 = e2.value;
              switch (e2._operation) {
                case ">":
                  p2 > u && (n2.prefixBoundary = true);
                  break;
                case "<":
                  (p2 < c || n2.starts.length && p2 === c) && (n2.prefixBoundary = true);
                  break;
                case "[]":
                  f2 = Math.min(p2[0], p2[1]), ((h = Math.max(p2[0], p2[1])) < c || f2 > u || n2.starts.length && h === c) && (n2.prefixBoundary = true);
                  break;
                case "][":
                  f2 = Math.min(p2[0], p2[1]), h = Math.max(p2[0], p2[1]), f2 < c && h > u && (n2.prefixBoundary = true);
              }
          }
        };
      }, 90654: function(t2, e2, r2) {
        var n2 = r2(21081), i = r2(86068), a = r2(53572);
        t2.exports = { min: "zmin", max: "zmax", calc: function(t3, e3, r3) {
          var o = e3.contours, s = e3.line, l = o.size || 1, u = o.coloring, c = i(e3, { isColorbar: true });
          if ("heatmap" === u) {
            var f2 = n2.extractOpts(e3);
            r3._fillgradient = f2.reversescale ? n2.flipScale(f2.colorscale) : f2.colorscale, r3._zrange = [f2.min, f2.max];
          } else
            "fill" === u && (r3._fillcolor = c);
          r3._line = { color: "lines" === u ? c : s.color, width: false !== o.showlines ? s.width : 0, dash: s.dash }, r3._levels = { start: o.start, end: a(o), size: l };
        } };
      }, 36914: function(t2) {
        t2.exports = { BOTTOMSTART: [1, 9, 13, 104, 713], TOPSTART: [4, 6, 7, 104, 713], LEFTSTART: [8, 12, 14, 208, 1114], RIGHTSTART: [2, 3, 11, 208, 1114], NEWDELTA: [null, [-1, 0], [0, -1], [-1, 0], [1, 0], null, [0, -1], [-1, 0], [0, 1], [0, 1], null, [0, 1], [1, 0], [1, 0], [0, -1]], CHOOSESADDLE: { 104: [4, 1], 208: [2, 8], 713: [7, 13], 1114: [11, 14] }, SADDLEREMAINDER: { 1: 4, 2: 8, 4: 1, 7: 13, 8: 2, 11: 14, 13: 7, 14: 11 }, LABELDISTANCE: 2, LABELINCREASE: 10, LABELMIN: 3, LABELMAX: 10, LABELOPTIMIZER: { EDGECOST: 1, ANGLECOST: 1, NEIGHBORCOST: 5, SAMELEVELFACTOR: 10, SAMELEVELDISTANCE: 5, MAXCOST: 100, INITIALSEARCHPOINTS: 10, ITERATIONS: 5 } };
      }, 83179: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(14523), a = r2(7901), o = a.addOpacity, s = a.opacity, l = r2(74808), u = l.CONSTRAINT_REDUCTION, c = l.COMPARISON_OPS2;
        t2.exports = function(t3, e3, r3, a2, l2, f2) {
          var h, p2, d2, v = e3.contours, g2 = r3("contours.operation");
          v._operation = u[g2], function(t4, e4) {
            var r4;
            -1 === c.indexOf(e4.operation) ? (t4("contours.value", [0, 1]), Array.isArray(e4.value) ? e4.value.length > 2 ? e4.value = e4.value.slice(2) : 0 === e4.length ? e4.value = [0, 1] : e4.length < 2 ? (r4 = parseFloat(e4.value[0]), e4.value = [r4, r4 + 1]) : e4.value = [parseFloat(e4.value[0]), parseFloat(e4.value[1])] : n2(e4.value) && (r4 = parseFloat(e4.value), e4.value = [r4, r4 + 1])) : (t4("contours.value", 0), n2(e4.value) || (Array.isArray(e4.value) ? e4.value = parseFloat(e4.value[0]) : e4.value = 0));
          }(r3, v), "=" === g2 ? h = v.showlines = true : (h = r3("contours.showlines"), d2 = r3("fillcolor", o((t3.line || {}).color || l2, 0.5))), h && (p2 = r3("line.color", d2 && s(d2) ? o(e3.fillcolor, 1) : l2), r3("line.width", 2), r3("line.dash")), r3("line.smoothing"), i(r3, a2, p2, f2);
        };
      }, 64237: function(t2, e2, r2) {
        var n2 = r2(74808), i = r2(92770);
        function a(t3, e3) {
          var r3, a2 = Array.isArray(e3);
          function o2(t4) {
            return i(t4) ? +t4 : null;
          }
          return -1 !== n2.COMPARISON_OPS2.indexOf(t3) ? r3 = o2(a2 ? e3[0] : e3) : -1 !== n2.INTERVAL_OPS.indexOf(t3) ? r3 = a2 ? [o2(e3[0]), o2(e3[1])] : [o2(e3), o2(e3)] : -1 !== n2.SET_OPS.indexOf(t3) && (r3 = a2 ? e3.map(o2) : [o2(e3)]), r3;
        }
        function o(t3) {
          return function(e3) {
            e3 = a(t3, e3);
            var r3 = Math.min(e3[0], e3[1]), n3 = Math.max(e3[0], e3[1]);
            return { start: r3, end: n3, size: n3 - r3 };
          };
        }
        function s(t3) {
          return function(e3) {
            return { start: e3 = a(t3, e3), end: 1 / 0, size: 1 / 0 };
          };
        }
        t2.exports = { "[]": o("[]"), "][": o("]["), ">": s(">"), "<": s("<"), "=": s("=") };
      }, 67217: function(t2) {
        t2.exports = function(t3, e2, r2, n2) {
          var i = n2("contours.start"), a = n2("contours.end"), o = false === i || false === a, s = r2("contours.size");
          !(o ? e2.autocontour = true : r2("autocontour", false)) && s || r2("ncontours");
        };
      }, 84857: function(t2, e2, r2) {
        var n2 = r2(71828);
        function i(t3) {
          return n2.extendFlat({}, t3, { edgepaths: n2.extendDeep([], t3.edgepaths), paths: n2.extendDeep([], t3.paths), starts: n2.extendDeep([], t3.starts) });
        }
        t2.exports = function(t3, e3) {
          var r3, a, o, s = function(t4) {
            return t4.reverse();
          }, l = function(t4) {
            return t4;
          };
          switch (e3) {
            case "=":
            case "<":
              return t3;
            case ">":
              for (1 !== t3.length && n2.warn("Contour data invalid for the specified inequality operation."), a = t3[0], r3 = 0; r3 < a.edgepaths.length; r3++)
                a.edgepaths[r3] = s(a.edgepaths[r3]);
              for (r3 = 0; r3 < a.paths.length; r3++)
                a.paths[r3] = s(a.paths[r3]);
              for (r3 = 0; r3 < a.starts.length; r3++)
                a.starts[r3] = s(a.starts[r3]);
              return t3;
            case "][":
              var u = s;
              s = l, l = u;
            case "[]":
              for (2 !== t3.length && n2.warn("Contour data invalid for the specified inequality range operation."), a = i(t3[0]), o = i(t3[1]), r3 = 0; r3 < a.edgepaths.length; r3++)
                a.edgepaths[r3] = s(a.edgepaths[r3]);
              for (r3 = 0; r3 < a.paths.length; r3++)
                a.paths[r3] = s(a.paths[r3]);
              for (r3 = 0; r3 < a.starts.length; r3++)
                a.starts[r3] = s(a.starts[r3]);
              for (; o.edgepaths.length; )
                a.edgepaths.push(l(o.edgepaths.shift()));
              for (; o.paths.length; )
                a.paths.push(l(o.paths.shift()));
              for (; o.starts.length; )
                a.starts.push(l(o.starts.shift()));
              return [a];
          }
        };
      }, 13031: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(67684), a = r2(73927), o = r2(83179), s = r2(67217), l = r2(8724), u = r2(58623), c = r2(70600);
        t2.exports = function(t3, e3, r3, f2) {
          function h(r4, i2) {
            return n2.coerce(t3, e3, c, r4, i2);
          }
          if (i(t3, e3, h, f2)) {
            a(t3, e3, f2, h), h("xhoverformat"), h("yhoverformat"), h("text"), h("hovertext"), h("hoverongaps"), h("hovertemplate");
            var p2 = "constraint" === h("contours.type");
            h("connectgaps", n2.isArray1D(e3.z)), p2 ? o(t3, e3, h, f2, r3) : (s(t3, e3, h, function(r4) {
              return n2.coerce2(t3, e3, c, r4);
            }), l(t3, e3, h, f2)), e3.contours && "heatmap" === e3.contours.coloring && u(h, f2);
          } else
            e3.visible = false;
        };
      }, 87558: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(64237), a = r2(53572);
        t2.exports = function(t3, e3, r3) {
          for (var o = "constraint" === t3.type ? i[t3._operation](t3.value) : t3, s = o.size, l = [], u = a(o), c = r3.trace._carpetTrace, f2 = c ? { xaxis: c.aaxis, yaxis: c.baxis, x: r3.a, y: r3.b } : { xaxis: e3.xaxis, yaxis: e3.yaxis, x: r3.x, y: r3.y }, h = o.start; h < u; h += s)
            if (l.push(n2.extendFlat({ level: h, crossings: {}, starts: [], edgepaths: [], paths: [], z: r3.z, smoothing: r3.trace.line.smoothing }, f2)), l.length > 1e3) {
              n2.warn("Too many contours, clipping at 1000", t3);
              break;
            }
          return l;
        };
      }, 53572: function(t2) {
        t2.exports = function(t3) {
          return t3.end + t3.size / 1e6;
        };
      }, 81696: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(36914);
        function a(t3, e3, r3, n3) {
          return Math.abs(t3[0] - e3[0]) < r3 && Math.abs(t3[1] - e3[1]) < n3;
        }
        function o(t3, e3, r3, o2, l) {
          var u, c = e3.join(","), f2 = t3.crossings[c], h = function(t4, e4, r4) {
            var n3 = 0, a2 = 0;
            return t4 > 20 && e4 ? 208 === t4 || 1114 === t4 ? n3 = 0 === r4[0] ? 1 : -1 : a2 = 0 === r4[1] ? 1 : -1 : -1 !== i.BOTTOMSTART.indexOf(t4) ? a2 = 1 : -1 !== i.LEFTSTART.indexOf(t4) ? n3 = 1 : -1 !== i.TOPSTART.indexOf(t4) ? a2 = -1 : n3 = -1, [n3, a2];
          }(f2, r3, e3), p2 = [s(t3, e3, [-h[0], -h[1]])], d2 = t3.z.length, v = t3.z[0].length, g2 = e3.slice(), y = h.slice();
          for (u = 0; u < 1e4; u++) {
            if (f2 > 20 ? (f2 = i.CHOOSESADDLE[f2][(h[0] || h[1]) < 0 ? 0 : 1], t3.crossings[c] = i.SADDLEREMAINDER[f2]) : delete t3.crossings[c], !(h = i.NEWDELTA[f2])) {
              n2.log("Found bad marching index:", f2, e3, t3.level);
              break;
            }
            p2.push(s(t3, e3, h)), e3[0] += h[0], e3[1] += h[1], c = e3.join(","), a(p2[p2.length - 1], p2[p2.length - 2], o2, l) && p2.pop();
            var m2 = h[0] && (e3[0] < 0 || e3[0] > v - 2) || h[1] && (e3[1] < 0 || e3[1] > d2 - 2);
            if (e3[0] === g2[0] && e3[1] === g2[1] && h[0] === y[0] && h[1] === y[1] || r3 && m2)
              break;
            f2 = t3.crossings[c];
          }
          1e4 === u && n2.log("Infinite loop in contour?");
          var x, b, _, w2, T, k, A, M, S, E, L, C, P, O, I, D = a(p2[0], p2[p2.length - 1], o2, l), z = 0, R = 0.2 * t3.smoothing, F = [], B = 0;
          for (u = 1; u < p2.length; u++)
            C = p2[u], P = p2[u - 1], O = C[2] - P[2], I = C[3] - P[3], z += A = Math.sqrt(O * O + I * I), F.push(A);
          var N = z / F.length * R;
          function j(t4) {
            return p2[t4 % p2.length];
          }
          for (u = p2.length - 2; u >= B; u--)
            if ((x = F[u]) < N) {
              for (_ = 0, b = u - 1; b >= B && x + F[b] < N; b--)
                x += F[b];
              if (D && u === p2.length - 2)
                for (_ = 0; _ < b && x + F[_] < N; _++)
                  x += F[_];
              T = u - b + _ + 1, k = Math.floor((u + b + _ + 2) / 2), w2 = D || u !== p2.length - 2 ? D || -1 !== b ? T % 2 ? j(k) : [(j(k)[0] + j(k + 1)[0]) / 2, (j(k)[1] + j(k + 1)[1]) / 2] : p2[0] : p2[p2.length - 1], p2.splice(b + 1, u - b + 1, w2), u = b + 1, _ && (B = _), D && (u === p2.length - 2 ? p2[_] = p2[p2.length - 1] : 0 === u && (p2[p2.length - 1] = p2[0]));
            }
          for (p2.splice(0, B), u = 0; u < p2.length; u++)
            p2[u].length = 2;
          if (!(p2.length < 2))
            if (D)
              p2.pop(), t3.paths.push(p2);
            else {
              r3 || n2.log("Unclosed interior contour?", t3.level, g2.join(","), p2.join("L"));
              var U = false;
              for (M = 0; M < t3.edgepaths.length; M++)
                if (E = t3.edgepaths[M], !U && a(E[0], p2[p2.length - 1], o2, l)) {
                  p2.pop(), U = true;
                  var V = false;
                  for (S = 0; S < t3.edgepaths.length; S++)
                    if (a((L = t3.edgepaths[S])[L.length - 1], p2[0], o2, l)) {
                      V = true, p2.shift(), t3.edgepaths.splice(M, 1), S === M ? t3.paths.push(p2.concat(L)) : (S > M && S--, t3.edgepaths[S] = L.concat(p2, E));
                      break;
                    }
                  V || (t3.edgepaths[M] = p2.concat(E));
                }
              for (M = 0; M < t3.edgepaths.length && !U; M++)
                a((E = t3.edgepaths[M])[E.length - 1], p2[0], o2, l) && (p2.shift(), t3.edgepaths[M] = E.concat(p2), U = true);
              U || t3.edgepaths.push(p2);
            }
        }
        function s(t3, e3, r3) {
          var n3 = e3[0] + Math.max(r3[0], 0), i2 = e3[1] + Math.max(r3[1], 0), a2 = t3.z[i2][n3], o2 = t3.xaxis, s2 = t3.yaxis;
          if (r3[1]) {
            var l = (t3.level - a2) / (t3.z[i2][n3 + 1] - a2), u = (1 !== l ? (1 - l) * o2.c2l(t3.x[n3]) : 0) + (0 !== l ? l * o2.c2l(t3.x[n3 + 1]) : 0);
            return [o2.c2p(o2.l2c(u), true), s2.c2p(t3.y[i2], true), n3 + l, i2];
          }
          var c = (t3.level - a2) / (t3.z[i2 + 1][n3] - a2), f2 = (1 !== c ? (1 - c) * s2.c2l(t3.y[i2]) : 0) + (0 !== c ? c * s2.c2l(t3.y[i2 + 1]) : 0);
          return [o2.c2p(t3.x[n3], true), s2.c2p(s2.l2c(f2), true), n3, i2 + c];
        }
        t2.exports = function(t3, e3, r3) {
          var i2, a2, s2, l;
          for (e3 = e3 || 0.01, r3 = r3 || 0.01, a2 = 0; a2 < t3.length; a2++) {
            for (s2 = t3[a2], l = 0; l < s2.starts.length; l++)
              o(s2, s2.starts[l], "edge", e3, r3);
            for (i2 = 0; Object.keys(s2.crossings).length && i2 < 1e4; )
              i2++, o(s2, Object.keys(s2.crossings)[0].split(",").map(Number), void 0, e3, r3);
            1e4 === i2 && n2.log("Infinite loop in contour?");
          }
        };
      }, 52421: function(t2, e2, r2) {
        var n2 = r2(7901), i = r2(46248);
        t2.exports = function(t3, e3, r3, a, o) {
          o || (o = {}), o.isContour = true;
          var s = i(t3, e3, r3, a, o);
          return s && s.forEach(function(t4) {
            var e4 = t4.trace;
            "constraint" === e4.contours.type && (e4.fillcolor && n2.opacity(e4.fillcolor) ? t4.color = n2.addOpacity(e4.fillcolor, 1) : e4.contours.showlines && n2.opacity(e4.line.color) && (t4.color = n2.addOpacity(e4.line.color, 1)));
          }), s;
        };
      }, 99442: function(t2, e2, r2) {
        t2.exports = { attributes: r2(70600), supplyDefaults: r2(13031), calc: r2(27529), plot: r2(29854).plot, style: r2(84426), colorbar: r2(90654), hoverPoints: r2(52421), moduleType: "trace", name: "contour", basePlotModule: r2(93612), categories: ["cartesian", "svg", "2dMap", "contour", "showLegend"], meta: {} };
      }, 14523: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = function(t3, e3, r3, i) {
          if (i || (i = {}), t3("contours.showlabels")) {
            var a = e3.font;
            n2.coerceFont(t3, "contours.labelfont", { family: a.family, size: a.size, color: r3 }), t3("contours.labelformat");
          }
          false !== i.hasHover && t3("zhoverformat");
        };
      }, 86068: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(21081), a = r2(53572);
        t2.exports = function(t3) {
          var e3 = t3.contours, r3 = e3.start, o = a(e3), s = e3.size || 1, l = Math.floor((o - r3) / s) + 1, u = "lines" === e3.coloring ? 0 : 1, c = i.extractOpts(t3);
          isFinite(s) || (s = 1, l = 1);
          var f2, h, p2 = c.reversescale ? i.flipScale(c.colorscale) : c.colorscale, d2 = p2.length, v = new Array(d2), g2 = new Array(d2);
          if ("heatmap" === e3.coloring) {
            var y = c.min, m2 = c.max;
            for (h = 0; h < d2; h++)
              f2 = p2[h], v[h] = f2[0] * (m2 - y) + y, g2[h] = f2[1];
            var x = n2.extent([y, m2, e3.start, e3.start + s * (l - 1)]), b = x[y < m2 ? 0 : 1], _ = x[y < m2 ? 1 : 0];
            b !== y && (v.splice(0, 0, b), g2.splice(0, 0, g2[0])), _ !== m2 && (v.push(_), g2.push(g2[g2.length - 1]));
          } else
            for (h = 0; h < d2; h++)
              f2 = p2[h], v[h] = (f2[0] * (l + u - 1) - u / 2) * s + r3, g2[h] = f2[1];
          return i.makeColorScaleFunc({ domain: v, range: g2 }, { noNumericCheck: true });
        };
      }, 87678: function(t2, e2, r2) {
        var n2 = r2(36914);
        function i(t3, e3) {
          var r3 = (e3[0][0] > t3 ? 0 : 1) + (e3[0][1] > t3 ? 0 : 2) + (e3[1][1] > t3 ? 0 : 4) + (e3[1][0] > t3 ? 0 : 8);
          return 5 === r3 || 10 === r3 ? t3 > (e3[0][0] + e3[0][1] + e3[1][0] + e3[1][1]) / 4 ? 5 === r3 ? 713 : 1114 : 5 === r3 ? 104 : 208 : 15 === r3 ? 0 : r3;
        }
        t2.exports = function(t3) {
          var e3, r3, a, o, s, l, u, c, f2, h = t3[0].z, p2 = h.length, d2 = h[0].length, v = 2 === p2 || 2 === d2;
          for (r3 = 0; r3 < p2 - 1; r3++)
            for (o = [], 0 === r3 && (o = o.concat(n2.BOTTOMSTART)), r3 === p2 - 2 && (o = o.concat(n2.TOPSTART)), e3 = 0; e3 < d2 - 1; e3++)
              for (a = o.slice(), 0 === e3 && (a = a.concat(n2.LEFTSTART)), e3 === d2 - 2 && (a = a.concat(n2.RIGHTSTART)), s = e3 + "," + r3, l = [[h[r3][e3], h[r3][e3 + 1]], [h[r3 + 1][e3], h[r3 + 1][e3 + 1]]], f2 = 0; f2 < t3.length; f2++)
                (u = i((c = t3[f2]).level, l)) && (c.crossings[s] = u, -1 !== a.indexOf(u) && (c.starts.push([e3, r3]), v && -1 !== a.indexOf(u, a.indexOf(u) + 1) && c.starts.push([e3, r3])));
        };
      }, 29854: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(91424), o = r2(21081), s = r2(63893), l = r2(89298), u = r2(21994), c = r2(50347), f2 = r2(87678), h = r2(81696), p2 = r2(87558), d2 = r2(84857), v = r2(20083), g2 = r2(36914), y = g2.LABELOPTIMIZER;
        function m2(t3, e3) {
          var r3, n3, o2, s2, l2, u2, c2, f3 = "", h2 = 0, p3 = t3.edgepaths.map(function(t4, e4) {
            return e4;
          }), d3 = true;
          function v2(t4) {
            return Math.abs(t4[1] - e3[2][1]) < 0.01;
          }
          function g3(t4) {
            return Math.abs(t4[0] - e3[0][0]) < 0.01;
          }
          function y2(t4) {
            return Math.abs(t4[0] - e3[2][0]) < 0.01;
          }
          for (; p3.length; ) {
            for (u2 = a.smoothopen(t3.edgepaths[h2], t3.smoothing), f3 += d3 ? u2 : u2.replace(/^M/, "L"), p3.splice(p3.indexOf(h2), 1), r3 = t3.edgepaths[h2][t3.edgepaths[h2].length - 1], s2 = -1, o2 = 0; o2 < 4; o2++) {
              if (!r3) {
                i.log("Missing end?", h2, t3);
                break;
              }
              for (c2 = r3, Math.abs(c2[1] - e3[0][1]) < 0.01 && !y2(r3) ? n3 = e3[1] : g3(r3) ? n3 = e3[0] : v2(r3) ? n3 = e3[3] : y2(r3) && (n3 = e3[2]), l2 = 0; l2 < t3.edgepaths.length; l2++) {
                var m3 = t3.edgepaths[l2][0];
                Math.abs(r3[0] - n3[0]) < 0.01 ? Math.abs(r3[0] - m3[0]) < 0.01 && (m3[1] - r3[1]) * (n3[1] - m3[1]) >= 0 && (n3 = m3, s2 = l2) : Math.abs(r3[1] - n3[1]) < 0.01 ? Math.abs(r3[1] - m3[1]) < 0.01 && (m3[0] - r3[0]) * (n3[0] - m3[0]) >= 0 && (n3 = m3, s2 = l2) : i.log("endpt to newendpt is not vert. or horz.", r3, n3, m3);
              }
              if (r3 = n3, s2 >= 0)
                break;
              f3 += "L" + n3;
            }
            if (s2 === t3.edgepaths.length) {
              i.log("unclosed perimeter path");
              break;
            }
            h2 = s2, (d3 = -1 === p3.indexOf(h2)) && (h2 = p3[0], f3 += "Z");
          }
          for (h2 = 0; h2 < t3.paths.length; h2++)
            f3 += a.smoothclosed(t3.paths[h2], t3.smoothing);
          return f3;
        }
        function x(t3, e3, r3, n3) {
          var a2 = e3.width / 2, o2 = e3.height / 2, s2 = t3.x, l2 = t3.y, u2 = t3.theta, c2 = Math.cos(u2) * a2, f3 = Math.sin(u2) * a2, h2 = (s2 > n3.center ? n3.right - s2 : s2 - n3.left) / (c2 + Math.abs(Math.sin(u2) * o2)), p3 = (l2 > n3.middle ? n3.bottom - l2 : l2 - n3.top) / (Math.abs(f3) + Math.cos(u2) * o2);
          if (h2 < 1 || p3 < 1)
            return 1 / 0;
          var d3 = y.EDGECOST * (1 / (h2 - 1) + 1 / (p3 - 1));
          d3 += y.ANGLECOST * u2 * u2;
          for (var v2 = s2 - c2, g3 = l2 - f3, m3 = s2 + c2, x2 = l2 + f3, b2 = 0; b2 < r3.length; b2++) {
            var _ = r3[b2], w2 = Math.cos(_.theta) * _.width / 2, T = Math.sin(_.theta) * _.width / 2, k = 2 * i.segmentDistance(v2, g3, m3, x2, _.x - w2, _.y - T, _.x + w2, _.y + T) / (e3.height + _.height), A = _.level === e3.level, M = A ? y.SAMELEVELDISTANCE : 1;
            if (k <= M)
              return 1 / 0;
            d3 += y.NEIGHBORCOST * (A ? y.SAMELEVELFACTOR : 1) / (k - M);
          }
          return d3;
        }
        function b(t3) {
          var e3, r3, n3 = t3.trace._emptypoints, i2 = [], a2 = t3.z.length, o2 = t3.z[0].length, s2 = [];
          for (e3 = 0; e3 < o2; e3++)
            s2.push(1);
          for (e3 = 0; e3 < a2; e3++)
            i2.push(s2.slice());
          for (e3 = 0; e3 < n3.length; e3++)
            i2[(r3 = n3[e3])[0]][r3[1]] = 0;
          return t3.zmask = i2, i2;
        }
        e2.plot = function(t3, r3, o2, s2) {
          var l2 = r3.xaxis, u2 = r3.yaxis;
          i.makeTraceGroups(s2, o2, "contour").each(function(o3) {
            var s3 = n2.select(this), y2 = o3[0], x2 = y2.trace, _ = y2.x, w2 = y2.y, T = x2.contours, k = p2(T, r3, y2), A = i.ensureSingle(s3, "g", "heatmapcoloring"), M = [];
            "heatmap" === T.coloring && (M = [o3]), c(t3, r3, M, A), f2(k), h(k);
            var S = l2.c2p(_[0], true), E = l2.c2p(_[_.length - 1], true), L = u2.c2p(w2[0], true), C = u2.c2p(w2[w2.length - 1], true), P = [[S, C], [E, C], [E, L], [S, L]], O = k;
            "constraint" === T.type && (O = d2(k, T._operation)), function(t4, e3, r4) {
              var n3 = i.ensureSingle(t4, "g", "contourbg").selectAll("path").data("fill" === r4.coloring ? [0] : []);
              n3.enter().append("path"), n3.exit().remove(), n3.attr("d", "M" + e3.join("L") + "Z").style("stroke", "none");
            }(s3, P, T), function(t4, e3, r4, a2) {
              var o4 = "fill" === a2.coloring || "constraint" === a2.type && "=" !== a2._operation, s4 = "M" + r4.join("L") + "Z";
              o4 && v(e3, a2);
              var l3 = i.ensureSingle(t4, "g", "contourfill").selectAll("path").data(o4 ? e3 : []);
              l3.enter().append("path"), l3.exit().remove(), l3.each(function(t5) {
                var e4 = (t5.prefixBoundary ? s4 : "") + m2(t5, r4);
                e4 ? n2.select(this).attr("d", e4).style("stroke", "none") : n2.select(this).remove();
              });
            }(s3, O, P, T), function(t4, r4, o4, s4, l3) {
              var u3 = o4._context.staticPlot, c2 = i.ensureSingle(t4, "g", "contourlines"), f3 = false !== l3.showlines, h2 = l3.showlabels, p3 = f3 && h2, d3 = e2.createLines(c2, f3 || h2, r4, u3), v2 = e2.createLineClip(c2, p3, o4, s4.trace.uid), y3 = t4.selectAll("g.contourlabels").data(h2 ? [0] : []);
              if (y3.exit().remove(), y3.enter().append("g").classed("contourlabels", true), h2) {
                var m3 = [], x3 = [];
                i.clearLocationCache();
                var b2 = e2.labelFormatter(o4, s4), _2 = a.tester.append("text").attr("data-notex", 1).call(a.font, l3.labelfont), w3 = r4[0].xaxis, T2 = r4[0].yaxis, k2 = w3._length, A2 = T2._length, M2 = w3.range, S2 = T2.range, E2 = i.aggNums(Math.min, null, s4.x), L2 = i.aggNums(Math.max, null, s4.x), C2 = i.aggNums(Math.min, null, s4.y), P2 = i.aggNums(Math.max, null, s4.y), O2 = Math.max(w3.c2p(E2, true), 0), I = Math.min(w3.c2p(L2, true), k2), D = Math.max(T2.c2p(P2, true), 0), z = Math.min(T2.c2p(C2, true), A2), R = {};
                M2[0] < M2[1] ? (R.left = O2, R.right = I) : (R.left = I, R.right = O2), S2[0] < S2[1] ? (R.top = D, R.bottom = z) : (R.top = z, R.bottom = D), R.middle = (R.top + R.bottom) / 2, R.center = (R.left + R.right) / 2, m3.push([[R.left, R.top], [R.right, R.top], [R.right, R.bottom], [R.left, R.bottom]]);
                var F = Math.sqrt(k2 * k2 + A2 * A2), B = g2.LABELDISTANCE * F / Math.max(1, r4.length / g2.LABELINCREASE);
                d3.each(function(t5) {
                  var r5 = e2.calcTextOpts(t5.level, b2, _2, o4);
                  n2.select(this).selectAll("path").each(function() {
                    var t6 = i.getVisibleSegment(this, R, r5.height / 2);
                    if (t6 && !(t6.len < (r5.width + r5.height) * g2.LABELMIN))
                      for (var n3 = Math.min(Math.ceil(t6.len / B), g2.LABELMAX), a2 = 0; a2 < n3; a2++) {
                        var o5 = e2.findBestTextLocation(this, t6, r5, x3, R);
                        if (!o5)
                          break;
                        e2.addLabelData(o5, r5, x3, m3);
                      }
                  });
                }), _2.remove(), e2.drawLabels(y3, x3, o4, v2, p3 ? m3 : null);
              }
              h2 && !f3 && d3.remove();
            }(s3, k, t3, y2, T), function(t4, e3, r4, n3, o4) {
              var s4 = n3.trace, l3 = r4._fullLayout._clips, u3 = "clip" + s4.uid, c2 = l3.selectAll("#" + u3).data(s4.connectgaps ? [] : [0]);
              if (c2.enter().append("clipPath").classed("contourclip", true).attr("id", u3), c2.exit().remove(), false === s4.connectgaps) {
                var p3 = { level: 0.9, crossings: {}, starts: [], edgepaths: [], paths: [], xaxis: e3.xaxis, yaxis: e3.yaxis, x: n3.x, y: n3.y, z: b(n3), smoothing: 0 };
                f2([p3]), h([p3]), v([p3], { type: "levels" }), i.ensureSingle(c2, "path", "").attr("d", (p3.prefixBoundary ? "M" + o4.join("L") + "Z" : "") + m2(p3, o4));
              } else
                u3 = null;
              a.setClipUrl(t4, u3, r4);
            }(s3, r3, t3, y2, P);
          });
        }, e2.createLines = function(t3, e3, r3, n3) {
          var i2 = r3[0].smoothing, o2 = t3.selectAll("g.contourlevel").data(e3 ? r3 : []);
          if (o2.exit().remove(), o2.enter().append("g").classed("contourlevel", true), e3) {
            var s2 = o2.selectAll("path.openline").data(function(t4) {
              return t4.pedgepaths || t4.edgepaths;
            });
            s2.exit().remove(), s2.enter().append("path").classed("openline", true), s2.attr("d", function(t4) {
              return a.smoothopen(t4, i2);
            }).style("stroke-miterlimit", 1).style("vector-effect", n3 ? "none" : "non-scaling-stroke");
            var l2 = o2.selectAll("path.closedline").data(function(t4) {
              return t4.ppaths || t4.paths;
            });
            l2.exit().remove(), l2.enter().append("path").classed("closedline", true), l2.attr("d", function(t4) {
              return a.smoothclosed(t4, i2);
            }).style("stroke-miterlimit", 1).style("vector-effect", n3 ? "none" : "non-scaling-stroke");
          }
          return o2;
        }, e2.createLineClip = function(t3, e3, r3, n3) {
          var i2 = e3 ? "clipline" + n3 : null, o2 = r3._fullLayout._clips.selectAll("#" + i2).data(e3 ? [0] : []);
          return o2.exit().remove(), o2.enter().append("clipPath").classed("contourlineclip", true).attr("id", i2), a.setClipUrl(t3, i2, r3), o2;
        }, e2.labelFormatter = function(t3, e3) {
          var r3 = t3._fullLayout, n3 = e3.trace, i2 = n3.contours, a2 = { type: "linear", _id: "ycontour", showexponent: "all", exponentformat: "B" };
          if (i2.labelformat)
            a2.tickformat = i2.labelformat, u(a2, r3);
          else {
            var s2 = o.extractOpts(n3);
            if (s2 && s2.colorbar && s2.colorbar._axis)
              a2 = s2.colorbar._axis;
            else {
              if ("constraint" === i2.type) {
                var c2 = i2.value;
                Array.isArray(c2) ? a2.range = [c2[0], c2[c2.length - 1]] : a2.range = [c2, c2];
              } else
                a2.range = [i2.start, i2.end], a2.nticks = (i2.end - i2.start) / i2.size;
              a2.range[0] === a2.range[1] && (a2.range[1] += a2.range[0] || 1), a2.nticks || (a2.nticks = 1e3), u(a2, r3), l.prepTicks(a2), a2._tmin = null, a2._tmax = null;
            }
          }
          return function(t4) {
            return l.tickText(a2, t4).text;
          };
        }, e2.calcTextOpts = function(t3, e3, r3, n3) {
          var i2 = e3(t3);
          r3.text(i2).call(s.convertToTspans, n3);
          var o2 = r3.node(), l2 = a.bBox(o2, true);
          return { text: i2, width: l2.width, height: l2.height, fontSize: +o2.style["font-size"].replace("px", ""), level: t3, dy: (l2.top + l2.bottom) / 2 };
        }, e2.findBestTextLocation = function(t3, e3, r3, n3, a2) {
          var o2, s2, l2, u2, c2, f3 = r3.width;
          e3.isClosed ? (s2 = e3.len / y.INITIALSEARCHPOINTS, o2 = e3.min + s2 / 2, l2 = e3.max) : (s2 = (e3.len - f3) / (y.INITIALSEARCHPOINTS + 1), o2 = e3.min + s2 + f3 / 2, l2 = e3.max - (s2 + f3) / 2);
          for (var h2 = 1 / 0, p3 = 0; p3 < y.ITERATIONS; p3++) {
            for (var d3 = o2; d3 < l2; d3 += s2) {
              var v2 = i.getTextLocation(t3, e3.total, d3, f3), g3 = x(v2, r3, n3, a2);
              g3 < h2 && (h2 = g3, c2 = v2, u2 = d3);
            }
            if (h2 > 2 * y.MAXCOST)
              break;
            p3 && (s2 /= 2), l2 = (o2 = u2 - s2 / 2) + 1.5 * s2;
          }
          if (h2 <= y.MAXCOST)
            return c2;
        }, e2.addLabelData = function(t3, e3, r3, n3) {
          var i2 = e3.fontSize, a2 = e3.width + i2 / 3, o2 = Math.max(0, e3.height - i2 / 3), s2 = t3.x, l2 = t3.y, u2 = t3.theta, c2 = Math.sin(u2), f3 = Math.cos(u2), h2 = function(t4, e4) {
            return [s2 + t4 * f3 - e4 * c2, l2 + t4 * c2 + e4 * f3];
          }, p3 = [h2(-a2 / 2, -o2 / 2), h2(-a2 / 2, o2 / 2), h2(a2 / 2, o2 / 2), h2(a2 / 2, -o2 / 2)];
          r3.push({ text: e3.text, x: s2, y: l2, dy: e3.dy, theta: u2, level: e3.level, width: a2, height: o2 }), n3.push(p3);
        }, e2.drawLabels = function(t3, e3, r3, a2, o2) {
          var l2 = t3.selectAll("text").data(e3, function(t4) {
            return t4.text + "," + t4.x + "," + t4.y + "," + t4.theta;
          });
          if (l2.exit().remove(), l2.enter().append("text").attr({ "data-notex": 1, "text-anchor": "middle" }).each(function(t4) {
            var e4 = t4.x + Math.sin(t4.theta) * t4.dy, i2 = t4.y - Math.cos(t4.theta) * t4.dy;
            n2.select(this).text(t4.text).attr({ x: e4, y: i2, transform: "rotate(" + 180 * t4.theta / Math.PI + " " + e4 + " " + i2 + ")" }).call(s.convertToTspans, r3);
          }), o2) {
            for (var u2 = "", c2 = 0; c2 < o2.length; c2++)
              u2 += "M" + o2[c2].join("L") + "Z";
            i.ensureSingle(a2, "path", "").attr("d", u2);
          }
        };
      }, 18670: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(71828);
        function a(t3, e3, r3) {
          var i2 = { type: "linear", range: [t3, e3] };
          return n2.autoTicks(i2, (e3 - t3) / (r3 || 15)), i2;
        }
        t2.exports = function(t3, e3) {
          var r3 = t3.contours;
          if (t3.autocontour) {
            var o = t3.zmin, s = t3.zmax;
            (t3.zauto || void 0 === o) && (o = i.aggNums(Math.min, null, e3)), (t3.zauto || void 0 === s) && (s = i.aggNums(Math.max, null, e3));
            var l = a(o, s, t3.ncontours);
            r3.size = l.dtick, r3.start = n2.tickFirst(l), l.range.reverse(), r3.end = n2.tickFirst(l), r3.start === o && (r3.start += r3.size), r3.end === s && (r3.end -= r3.size), r3.start > r3.end && (r3.start = r3.end = (r3.start + r3.end) / 2), t3._input.contours || (t3._input.contours = {}), i.extendFlat(t3._input.contours, { start: r3.start, end: r3.end, size: r3.size }), t3._input.autocontour = true;
          } else if ("constraint" !== r3.type) {
            var u, c = r3.start, f2 = r3.end, h = t3._input.contours;
            c > f2 && (r3.start = h.start = f2, f2 = r3.end = h.end = c, c = r3.start), r3.size > 0 || (u = c === f2 ? 1 : a(c, f2, t3.ncontours).dtick, h.size = r3.size = u);
          }
        };
      }, 84426: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(91424), a = r2(70035), o = r2(86068);
        t2.exports = function(t3) {
          var e3 = n2.select(t3).selectAll("g.contour");
          e3.style("opacity", function(t4) {
            return t4[0].trace.opacity;
          }), e3.each(function(t4) {
            var e4 = n2.select(this), r3 = t4[0].trace, a2 = r3.contours, s = r3.line, l = a2.size || 1, u = a2.start, c = "constraint" === a2.type, f2 = !c && "lines" === a2.coloring, h = !c && "fill" === a2.coloring, p2 = f2 || h ? o(r3) : null;
            e4.selectAll("g.contourlevel").each(function(t5) {
              n2.select(this).selectAll("path").call(i.lineGroupStyle, s.width, f2 ? p2(t5.level) : s.color, s.dash);
            });
            var d2 = a2.labelfont;
            if (e4.selectAll("g.contourlabels text").each(function(t5) {
              i.font(n2.select(this), { family: d2.family, size: d2.size, color: d2.color || (f2 ? p2(t5.level) : s.color) });
            }), c)
              e4.selectAll("g.contourfill path").style("fill", r3.fillcolor);
            else if (h) {
              var v;
              e4.selectAll("g.contourfill path").style("fill", function(t5) {
                return void 0 === v && (v = t5.level), p2(t5.level + 0.5 * l);
              }), void 0 === v && (v = u), e4.selectAll("g.contourbg path").style("fill", p2(v - 0.5 * l));
            }
          }), a(t3);
        };
      }, 8724: function(t2, e2, r2) {
        var n2 = r2(1586), i = r2(14523);
        t2.exports = function(t3, e3, r3, a, o) {
          var s, l = r3("contours.coloring"), u = "";
          "fill" === l && (s = r3("contours.showlines")), false !== s && ("lines" !== l && (u = r3("line.color", "#000")), r3("line.width", 0.5), r3("line.dash")), "none" !== l && (true !== t3.showlegend && (e3.showlegend = false), e3._dfltShowLegend = false, n2(t3, e3, a, r3, { prefix: "", cLetter: "z" })), r3("line.smoothing"), i(r3, a, u, o);
        };
      }, 88085: function(t2, e2, r2) {
        var n2 = r2(21606), i = r2(70600), a = r2(50693), o = r2(1426).extendFlat, s = i.contours;
        t2.exports = o({ carpet: { valType: "string", editType: "calc" }, z: n2.z, a: n2.x, a0: n2.x0, da: n2.dx, b: n2.y, b0: n2.y0, db: n2.dy, text: n2.text, hovertext: n2.hovertext, transpose: n2.transpose, atype: n2.xtype, btype: n2.ytype, fillcolor: i.fillcolor, autocontour: i.autocontour, ncontours: i.ncontours, contours: { type: s.type, start: s.start, end: s.end, size: s.size, coloring: { valType: "enumerated", values: ["fill", "lines", "none"], dflt: "fill", editType: "calc" }, showlines: s.showlines, showlabels: s.showlabels, labelfont: s.labelfont, labelformat: s.labelformat, operation: s.operation, value: s.value, editType: "calc", impliedEdits: { autocontour: false } }, line: { color: i.line.color, width: i.line.width, dash: i.line.dash, smoothing: i.line.smoothing, editType: "plot" }, transforms: void 0 }, a("", { cLetter: "z", autoColorDflt: false }));
      }, 59885: function(t2, e2, r2) {
        var n2 = r2(78803), i = r2(71828), a = r2(68296), o = r2(4742), s = r2(824), l = r2(43907), u = r2(70769), c = r2(75005), f2 = r2(22882), h = r2(18670);
        t2.exports = function(t3, e3) {
          var r3 = e3._carpetTrace = f2(t3, e3);
          if (r3 && r3.visible && "legendonly" !== r3.visible) {
            if (!e3.a || !e3.b) {
              var p2 = t3.data[r3.index], d2 = t3.data[e3.index];
              d2.a || (d2.a = p2.a), d2.b || (d2.b = p2.b), c(d2, e3, e3._defaultColor, t3._fullLayout);
            }
            var v = function(t4, e4) {
              var r4, c2, f3, h2, p3, d3, v2, g2 = e4._carpetTrace, y = g2.aaxis, m2 = g2.baxis;
              y._minDtick = 0, m2._minDtick = 0, i.isArray1D(e4.z) && a(e4, y, m2, "a", "b", ["z"]), r4 = e4._a = e4._a || e4.a, h2 = e4._b = e4._b || e4.b, r4 = r4 ? y.makeCalcdata(e4, "_a") : [], h2 = h2 ? m2.makeCalcdata(e4, "_b") : [], c2 = e4.a0 || 0, f3 = e4.da || 1, p3 = e4.b0 || 0, d3 = e4.db || 1, v2 = e4._z = o(e4._z || e4.z, e4.transpose), e4._emptypoints = l(v2), s(v2, e4._emptypoints);
              var x = i.maxRowLength(v2), b = "scaled" === e4.xtype ? "" : r4, _ = u(e4, b, c2, f3, x, y), w2 = "scaled" === e4.ytype ? "" : h2, T = { a: _, b: u(e4, w2, p3, d3, v2.length, m2), z: v2 };
              return "levels" === e4.contours.type && "none" !== e4.contours.coloring && n2(t4, e4, { vals: v2, containerStr: "", cLetter: "z" }), [T];
            }(t3, e3);
            return h(e3, e3._z), v;
          }
        };
      }, 75005: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(67684), a = r2(88085), o = r2(83179), s = r2(67217), l = r2(8724);
        t2.exports = function(t3, e3, r3, u) {
          function c(r4, i2) {
            return n2.coerce(t3, e3, a, r4, i2);
          }
          if (c("carpet"), t3.a && t3.b) {
            if (!i(t3, e3, c, u, "a", "b"))
              return void (e3.visible = false);
            c("text"), "constraint" === c("contours.type") ? o(t3, e3, c, u, r3, { hasHover: false }) : (s(t3, e3, c, function(r4) {
              return n2.coerce2(t3, e3, a, r4);
            }), l(t3, e3, c, u, { hasHover: false }));
          } else
            e3._defaultColor = r3, e3._length = null;
        };
      }, 93740: function(t2, e2, r2) {
        t2.exports = { attributes: r2(88085), supplyDefaults: r2(75005), colorbar: r2(90654), calc: r2(59885), plot: r2(51048), style: r2(84426), moduleType: "trace", name: "contourcarpet", basePlotModule: r2(93612), categories: ["cartesian", "svg", "carpet", "contour", "symbols", "showLegend", "hasLines", "carpetDependent", "noHover", "noSortingByValue"], meta: {} };
      }, 51048: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(27669), a = r2(67961), o = r2(91424), s = r2(71828), l = r2(87678), u = r2(81696), c = r2(29854), f2 = r2(36914), h = r2(84857), p2 = r2(87558), d2 = r2(20083), v = r2(22882), g2 = r2(4536);
        function y(t3, e3, r3) {
          var n3 = t3.getPointAtLength(e3), i2 = t3.getPointAtLength(r3), a2 = i2.x - n3.x, o2 = i2.y - n3.y, s2 = Math.sqrt(a2 * a2 + o2 * o2);
          return [a2 / s2, o2 / s2];
        }
        function m2(t3) {
          var e3 = Math.sqrt(t3[0] * t3[0] + t3[1] * t3[1]);
          return [t3[0] / e3, t3[1] / e3];
        }
        function x(t3, e3) {
          var r3 = Math.abs(t3[0] * e3[0] + t3[1] * e3[1]);
          return Math.sqrt(1 - r3 * r3) / r3;
        }
        t2.exports = function(t3, e3, r3, b) {
          var _ = e3.xaxis, w2 = e3.yaxis;
          s.makeTraceGroups(b, r3, "contour").each(function(r4) {
            var b2 = n2.select(this), T = r4[0], k = T.trace, A = k._carpetTrace = v(t3, k), M = t3.calcdata[A.index][0];
            if (A.visible && "legendonly" !== A.visible) {
              var S = T.a, E = T.b, L = k.contours, C = p2(L, e3, T), P = "constraint" === L.type, O = L._operation, I = P ? "=" === O ? "lines" : "fill" : L.coloring, D = [[S[0], E[E.length - 1]], [S[S.length - 1], E[E.length - 1]], [S[S.length - 1], E[0]], [S[0], E[0]]];
              l(C);
              var z = 1e-8 * (S[S.length - 1] - S[0]), R = 1e-8 * (E[E.length - 1] - E[0]);
              u(C, z, R);
              var F, B, N, j, U = C;
              "constraint" === L.type && (U = h(C, O)), function(t4, e4) {
                var r5, n3, i2, a2, o2, s2, l2, u2, c2;
                for (r5 = 0; r5 < t4.length; r5++) {
                  for (o2 = (a2 = t4[r5]).pedgepaths = [], s2 = a2.ppaths = [], n3 = 0; n3 < a2.edgepaths.length; n3++) {
                    for (c2 = a2.edgepaths[n3], l2 = [], i2 = 0; i2 < c2.length; i2++)
                      l2[i2] = e4(c2[i2]);
                    o2.push(l2);
                  }
                  for (n3 = 0; n3 < a2.paths.length; n3++) {
                    for (c2 = a2.paths[n3], u2 = [], i2 = 0; i2 < c2.length; i2++)
                      u2[i2] = e4(c2[i2]);
                    s2.push(u2);
                  }
                }
              }(C, q2);
              var V = [];
              for (j = M.clipsegments.length - 1; j >= 0; j--)
                F = M.clipsegments[j], B = i([], F.x, _.c2p), N = i([], F.y, w2.c2p), B.reverse(), N.reverse(), V.push(a(B, N, F.bicubic));
              var H = "M" + V.join("L") + "Z";
              !function(t4, e4, r5, n3, o2, l2) {
                var u2, c2, f3, h2, p3 = s.ensureSingle(t4, "g", "contourbg").selectAll("path").data("fill" !== l2 || o2 ? [] : [0]);
                p3.enter().append("path"), p3.exit().remove();
                var d3 = [];
                for (h2 = 0; h2 < e4.length; h2++)
                  u2 = e4[h2], c2 = i([], u2.x, r5.c2p), f3 = i([], u2.y, n3.c2p), d3.push(a(c2, f3, u2.bicubic));
                p3.attr("d", "M" + d3.join("L") + "Z").style("stroke", "none");
              }(b2, M.clipsegments, _, w2, P, I), function(t4, e4, r5, i2, a2, l2, u2, c2, f3, h2, p3) {
                var v2 = "fill" === h2;
                v2 && d2(a2, t4.contours);
                var y2 = s.ensureSingle(e4, "g", "contourfill").selectAll("path").data(v2 ? a2 : []);
                y2.enter().append("path"), y2.exit().remove(), y2.each(function(t5) {
                  var e5 = (t5.prefixBoundary ? p3 : "") + function(t6, e6, r6, n3, i3, a3, l3, u3) {
                    var c3, f4, h3, p4, d3, v3, y3, m3 = "", x2 = e6.edgepaths.map(function(t7, e7) {
                      return e7;
                    }), b3 = true, _2 = 1e-4 * Math.abs(r6[0][0] - r6[2][0]), w3 = 1e-4 * Math.abs(r6[0][1] - r6[2][1]);
                    function T2(t7) {
                      return Math.abs(t7[1] - r6[0][1]) < w3;
                    }
                    function k2(t7) {
                      return Math.abs(t7[1] - r6[2][1]) < w3;
                    }
                    function A2(t7) {
                      return Math.abs(t7[0] - r6[0][0]) < _2;
                    }
                    function M2(t7) {
                      return Math.abs(t7[0] - r6[2][0]) < _2;
                    }
                    function S2(t7, e7) {
                      var r7, n4, o2, s2, c4 = "";
                      for (T2(t7) && !M2(t7) || k2(t7) && !A2(t7) ? (s2 = i3.aaxis, o2 = g2(i3, a3, [t7[0], e7[0]], 0.5 * (t7[1] + e7[1]))) : (s2 = i3.baxis, o2 = g2(i3, a3, 0.5 * (t7[0] + e7[0]), [t7[1], e7[1]])), r7 = 1; r7 < o2.length; r7++)
                        for (c4 += s2.smoothing ? "C" : "L", n4 = 0; n4 < o2[r7].length; n4++) {
                          var f5 = o2[r7][n4];
                          c4 += [l3.c2p(f5[0]), u3.c2p(f5[1])] + " ";
                        }
                      return c4;
                    }
                    for (c3 = 0, f4 = null; x2.length; ) {
                      var E2 = e6.edgepaths[c3][0];
                      for (f4 && (m3 += S2(f4, E2)), y3 = o.smoothopen(e6.edgepaths[c3].map(n3), e6.smoothing), m3 += b3 ? y3 : y3.replace(/^M/, "L"), x2.splice(x2.indexOf(c3), 1), f4 = e6.edgepaths[c3][e6.edgepaths[c3].length - 1], d3 = -1, p4 = 0; p4 < 4; p4++) {
                        if (!f4) {
                          s.log("Missing end?", c3, e6);
                          break;
                        }
                        for (T2(f4) && !M2(f4) ? h3 = r6[1] : A2(f4) ? h3 = r6[0] : k2(f4) ? h3 = r6[3] : M2(f4) && (h3 = r6[2]), v3 = 0; v3 < e6.edgepaths.length; v3++) {
                          var L2 = e6.edgepaths[v3][0];
                          Math.abs(f4[0] - h3[0]) < _2 ? Math.abs(f4[0] - L2[0]) < _2 && (L2[1] - f4[1]) * (h3[1] - L2[1]) >= 0 && (h3 = L2, d3 = v3) : Math.abs(f4[1] - h3[1]) < w3 ? Math.abs(f4[1] - L2[1]) < w3 && (L2[0] - f4[0]) * (h3[0] - L2[0]) >= 0 && (h3 = L2, d3 = v3) : s.log("endpt to newendpt is not vert. or horz.", f4, h3, L2);
                        }
                        if (d3 >= 0)
                          break;
                        m3 += S2(f4, h3), f4 = h3;
                      }
                      if (d3 === e6.edgepaths.length) {
                        s.log("unclosed perimeter path");
                        break;
                      }
                      c3 = d3, (b3 = -1 === x2.indexOf(c3)) && (c3 = x2[0], m3 += S2(f4, h3) + "Z", f4 = null);
                    }
                    for (c3 = 0; c3 < e6.paths.length; c3++)
                      m3 += o.smoothclosed(e6.paths[c3].map(n3), e6.smoothing);
                    return m3;
                  }(0, t5, l2, u2, c2, f3, r5, i2);
                  e5 ? n2.select(this).attr("d", e5).style("stroke", "none") : n2.select(this).remove();
                });
              }(k, b2, _, w2, U, D, q2, A, M, I, H), function(t4, e4, r5, i2, a2, l2, u2) {
                var h2 = r5._context.staticPlot, p3 = s.ensureSingle(t4, "g", "contourlines"), d3 = false !== a2.showlines, v2 = a2.showlabels, g3 = d3 && v2, b3 = c.createLines(p3, d3 || v2, e4, h2), _2 = c.createLineClip(p3, g3, r5, i2.trace.uid), w3 = t4.selectAll("g.contourlabels").data(v2 ? [0] : []);
                if (w3.exit().remove(), w3.enter().append("g").classed("contourlabels", true), v2) {
                  var T2 = l2.xaxis, k2 = l2.yaxis, A2 = T2._length, M2 = k2._length, S2 = [[[0, 0], [A2, 0], [A2, M2], [0, M2]]], E2 = [];
                  s.clearLocationCache();
                  var L2 = c.labelFormatter(r5, i2), C2 = o.tester.append("text").attr("data-notex", 1).call(o.font, a2.labelfont), P2 = { left: 0, right: A2, center: A2 / 2, top: 0, bottom: M2, middle: M2 / 2 }, O2 = Math.sqrt(A2 * A2 + M2 * M2), I2 = f2.LABELDISTANCE * O2 / Math.max(1, e4.length / f2.LABELINCREASE);
                  b3.each(function(t5) {
                    var e5 = c.calcTextOpts(t5.level, L2, C2, r5);
                    n2.select(this).selectAll("path").each(function(r6) {
                      var n3 = this, i3 = s.getVisibleSegment(n3, P2, e5.height / 2);
                      if (i3 && (function(t6, e6, r7, n4, i4, a4) {
                        for (var o3, s2 = 0; s2 < r7.pedgepaths.length; s2++)
                          e6 === r7.pedgepaths[s2] && (o3 = r7.edgepaths[s2]);
                        if (o3) {
                          var l4 = i4.a[0], u3 = i4.a[i4.a.length - 1], c2 = i4.b[0], f3 = i4.b[i4.b.length - 1], h3 = y(t6, 0, 1), p4 = y(t6, n4.total, n4.total - 1), d4 = g4(o3[0], h3), v3 = n4.total - g4(o3[o3.length - 1], p4);
                          n4.min < d4 && (n4.min = d4), n4.max > v3 && (n4.max = v3), n4.len = n4.max - n4.min;
                        }
                        function g4(t7, e7) {
                          var r8, n5 = 0, o4 = 0.1;
                          return (Math.abs(t7[0] - l4) < o4 || Math.abs(t7[0] - u3) < o4) && (r8 = m2(i4.dxydb_rough(t7[0], t7[1], o4)), n5 = Math.max(n5, a4 * x(e7, r8) / 2)), (Math.abs(t7[1] - c2) < o4 || Math.abs(t7[1] - f3) < o4) && (r8 = m2(i4.dxyda_rough(t7[0], t7[1], o4)), n5 = Math.max(n5, a4 * x(e7, r8) / 2)), n5;
                        }
                      }(n3, r6, t5, i3, u2, e5.height), !(i3.len < (e5.width + e5.height) * f2.LABELMIN)))
                        for (var a3 = Math.min(Math.ceil(i3.len / I2), f2.LABELMAX), o2 = 0; o2 < a3; o2++) {
                          var l3 = c.findBestTextLocation(n3, i3, e5, E2, P2);
                          if (!l3)
                            break;
                          c.addLabelData(l3, e5, E2, S2);
                        }
                    });
                  }), C2.remove(), c.drawLabels(w3, E2, r5, _2, g3 ? S2 : null);
                }
                v2 && !d3 && b3.remove();
              }(b2, C, t3, T, L, e3, A), o.setClipUrl(b2, A._clipPathId, t3);
            }
            function q2(t4) {
              var e4 = A.ab2xy(t4[0], t4[1], true);
              return [_.c2p(e4[0]), w2.c2p(e4[1])];
            }
          });
        };
      }, 64096: function(t2, e2, r2) {
        var n2 = r2(50693), i = r2(5386).f, a = r2(9012), o = r2(99181), s = r2(1426).extendFlat;
        t2.exports = s({ lon: o.lon, lat: o.lat, z: { valType: "data_array", editType: "calc" }, radius: { valType: "number", editType: "plot", arrayOk: true, min: 1, dflt: 30 }, below: { valType: "string", editType: "plot" }, text: o.text, hovertext: o.hovertext, hoverinfo: s({}, a.hoverinfo, { flags: ["lon", "lat", "z", "text", "name"] }), hovertemplate: i(), showlegend: s({}, a.showlegend, { dflt: false }) }, n2("", { cLetter: "z", editTypeOverride: "calc" }));
      }, 85070: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828).isArrayOrTypedArray, a = r2(50606).BADNUM, o = r2(78803), s = r2(71828)._;
        t2.exports = function(t3, e3) {
          for (var r3 = e3._length, l = new Array(r3), u = e3.z, c = i(u) && u.length, f2 = 0; f2 < r3; f2++) {
            var h = l[f2] = {}, p2 = e3.lon[f2], d2 = e3.lat[f2];
            if (h.lonlat = n2(p2) && n2(d2) ? [+p2, +d2] : [a, a], c) {
              var v = u[f2];
              h.z = n2(v) ? v : a;
            }
          }
          return o(t3, e3, { vals: c ? u : [0, 1], containerStr: "", cLetter: "z" }), r3 && (l[0].t = { labels: { lat: s(t3, "lat:") + " ", lon: s(t3, "lon:") + " " } }), l;
        };
      }, 52414: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = r2(7901), o = r2(21081), s = r2(50606).BADNUM, l = r2(18214).makeBlank;
        t2.exports = function(t3) {
          var e3 = t3[0].trace, r3 = true === e3.visible && 0 !== e3._length, u = e3._opts = { heatmap: { layout: { visibility: "none" }, paint: {} }, geojson: l() };
          if (!r3)
            return u;
          var c, f2 = [], h = e3.z, p2 = e3.radius, d2 = i.isArrayOrTypedArray(h) && h.length, v = i.isArrayOrTypedArray(p2);
          for (c = 0; c < t3.length; c++) {
            var g2 = t3[c], y = g2.lonlat;
            if (y[0] !== s) {
              var m2 = {};
              if (d2) {
                var x = g2.z;
                m2.z = x !== s ? x : 0;
              }
              v && (m2.r = n2(p2[c]) && p2[c] > 0 ? +p2[c] : 0), f2.push({ type: "Feature", geometry: { type: "Point", coordinates: y }, properties: m2 });
            }
          }
          var b = o.extractOpts(e3), _ = b.reversescale ? o.flipScale(b.colorscale) : b.colorscale, w2 = _[0][1], T = ["interpolate", ["linear"], ["heatmap-density"], 0, a.opacity(w2) < 1 ? w2 : a.addOpacity(w2, 0)];
          for (c = 1; c < _.length; c++)
            T.push(_[c][0], _[c][1]);
          var k = ["interpolate", ["linear"], ["get", "z"], b.min, 0, b.max, 1];
          return i.extendFlat(u.heatmap.paint, { "heatmap-weight": d2 ? k : 1 / (b.max - b.min), "heatmap-color": T, "heatmap-radius": v ? { type: "identity", property: "r" } : e3.radius, "heatmap-opacity": e3.opacity }), u.geojson = { type: "FeatureCollection", features: f2 }, u.heatmap.layout.visibility = "visible", u;
        };
      }, 79429: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(1586), a = r2(64096);
        t2.exports = function(t3, e3, r3, o) {
          function s(r4, i2) {
            return n2.coerce(t3, e3, a, r4, i2);
          }
          var l = s("lon") || [], u = s("lat") || [], c = Math.min(l.length, u.length);
          c ? (e3._length = c, s("z"), s("radius"), s("below"), s("text"), s("hovertext"), s("hovertemplate"), i(t3, e3, o, s, { prefix: "", cLetter: "z" })) : e3.visible = false;
        };
      }, 62474: function(t2) {
        t2.exports = function(t3, e2) {
          return t3.lon = e2.lon, t3.lat = e2.lat, t3.z = e2.z, t3;
        };
      }, 84684: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(28178).hoverPoints, a = r2(28178).getExtraText;
        t2.exports = function(t3, e3, r3) {
          var o = i(t3, e3, r3);
          if (o) {
            var s = o[0], l = s.cd, u = l[0].trace, c = l[s.index];
            if (delete s.color, "z" in c) {
              var f2 = s.subplot.mockAxis;
              s.z = c.z, s.zLabel = n2.tickText(f2, f2.c2l(c.z), "hover").text;
            }
            return s.extraText = a(u, c, l[0].t.labels), [s];
          }
        };
      }, 93814: function(t2, e2, r2) {
        t2.exports = { attributes: r2(64096), supplyDefaults: r2(79429), colorbar: r2(61243), formatLabels: r2(15636), calc: r2(85070), plot: r2(7336), hoverPoints: r2(84684), eventData: r2(62474), getBelow: function(t3, e3) {
          for (var r3 = e3.getMapLayers(), n2 = 0; n2 < r3.length; n2++) {
            var i = r3[n2], a = i.id;
            if ("symbol" === i.type && "string" == typeof a && -1 === a.indexOf("plotly-"))
              return a;
          }
        }, moduleType: "trace", name: "densitymapbox", basePlotModule: r2(50101), categories: ["mapbox", "gl", "showLegend"], meta: { hr_name: "density_mapbox" } };
      }, 7336: function(t2, e2, r2) {
        var n2 = r2(52414), i = r2(77734).traceLayerPrefix;
        function a(t3, e3) {
          this.type = "densitymapbox", this.subplot = t3, this.uid = e3, this.sourceId = "source-" + e3, this.layerList = [["heatmap", i + e3 + "-heatmap"]], this.below = null;
        }
        var o = a.prototype;
        o.update = function(t3) {
          var e3 = this.subplot, r3 = this.layerList, i2 = n2(t3), a2 = e3.belowLookup["trace-" + this.uid];
          e3.map.getSource(this.sourceId).setData(i2.geojson), a2 !== this.below && (this._removeLayers(), this._addLayers(i2, a2), this.below = a2);
          for (var o2 = 0; o2 < r3.length; o2++) {
            var s = r3[o2], l = s[0], u = s[1], c = i2[l];
            e3.setOptions(u, "setLayoutProperty", c.layout), "visible" === c.layout.visibility && e3.setOptions(u, "setPaintProperty", c.paint);
          }
        }, o._addLayers = function(t3, e3) {
          for (var r3 = this.subplot, n3 = this.layerList, i2 = this.sourceId, a2 = 0; a2 < n3.length; a2++) {
            var o2 = n3[a2], s = o2[0], l = t3[s];
            r3.addLayer({ type: s, id: o2[1], source: i2, layout: l.layout, paint: l.paint }, e3);
          }
        }, o._removeLayers = function() {
          for (var t3 = this.subplot.map, e3 = this.layerList, r3 = e3.length - 1; r3 >= 0; r3--)
            t3.removeLayer(e3[r3][1]);
        }, o.dispose = function() {
          var t3 = this.subplot.map;
          this._removeLayers(), t3.removeSource(this.sourceId);
        }, t2.exports = function(t3, e3) {
          var r3 = e3[0].trace, i2 = new a(t3, r3.uid), o2 = i2.sourceId, s = n2(e3), l = i2.below = t3.belowLookup["trace-" + r3.uid];
          return t3.map.addSource(o2, { type: "geojson", data: s.geojson }), i2._addLayers(s, l), i2;
        };
      }, 49789: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = function(t3, e3) {
          for (var r3 = 0; r3 < t3.length; r3++)
            t3[r3].i = r3;
          n2.mergeArray(e3.text, t3, "tx"), n2.mergeArray(e3.hovertext, t3, "htx");
          var i = e3.marker;
          if (i) {
            n2.mergeArray(i.opacity, t3, "mo"), n2.mergeArray(i.color, t3, "mc");
            var a = i.line;
            a && (n2.mergeArray(a.color, t3, "mlc"), n2.mergeArrayCastPositive(a.width, t3, "mlw"));
          }
        };
      }, 1285: function(t2, e2, r2) {
        var n2, i = r2(1486), a = r2(82196).line, o = r2(9012), s = r2(12663).axisHoverFormat, l = r2(5386).f, u = r2(5386).s, c = r2(18517), f2 = r2(1426).extendFlat, h = r2(7901);
        t2.exports = { x: i.x, x0: i.x0, dx: i.dx, y: i.y, y0: i.y0, dy: i.dy, xperiod: i.xperiod, yperiod: i.yperiod, xperiod0: i.xperiod0, yperiod0: i.yperiod0, xperiodalignment: i.xperiodalignment, yperiodalignment: i.yperiodalignment, xhoverformat: s("x"), yhoverformat: s("y"), hovertext: i.hovertext, hovertemplate: l({}, { keys: c.eventDataKeys }), hoverinfo: f2({}, o.hoverinfo, { flags: ["name", "x", "y", "text", "percent initial", "percent previous", "percent total"] }), textinfo: { valType: "flaglist", flags: ["label", "text", "percent initial", "percent previous", "percent total", "value"], extras: ["none"], editType: "plot", arrayOk: false }, texttemplate: u({ editType: "plot" }, { keys: c.eventDataKeys.concat(["label", "value"]) }), text: i.text, textposition: i.textposition, insidetextanchor: f2({}, i.insidetextanchor, { dflt: "middle" }), textangle: f2({}, i.textangle, { dflt: 0 }), textfont: i.textfont, insidetextfont: i.insidetextfont, outsidetextfont: i.outsidetextfont, constraintext: i.constraintext, cliponaxis: i.cliponaxis, orientation: f2({}, i.orientation, {}), offset: f2({}, i.offset, { arrayOk: false }), width: f2({}, i.width, { arrayOk: false }), marker: (n2 = f2({}, i.marker), delete n2.pattern, n2), connector: { fillcolor: { valType: "color", editType: "style" }, line: { color: f2({}, a.color, { dflt: h.defaultLine }), width: f2({}, a.width, { dflt: 0, editType: "plot" }), dash: a.dash, editType: "style" }, visible: { valType: "boolean", dflt: true, editType: "plot" }, editType: "plot" }, offsetgroup: i.offsetgroup, alignmentgroup: i.alignmentgroup };
      }, 9532: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(42973), a = r2(49789), o = r2(66279), s = r2(50606).BADNUM;
        function l(t3) {
          return t3 === s ? 0 : t3;
        }
        t2.exports = function(t3, e3) {
          var r3, u, c, f2, h, p2, d2, v, g2 = n2.getFromId(t3, e3.xaxis || "x"), y = n2.getFromId(t3, e3.yaxis || "y");
          "h" === e3.orientation ? (r3 = g2.makeCalcdata(e3, "x"), c = y.makeCalcdata(e3, "y"), f2 = i(e3, y, "y", c), h = !!e3.yperiodalignment, p2 = "y") : (r3 = y.makeCalcdata(e3, "y"), c = g2.makeCalcdata(e3, "x"), f2 = i(e3, g2, "x", c), h = !!e3.xperiodalignment, p2 = "x"), u = f2.vals;
          var m2, x = Math.min(u.length, r3.length), b = new Array(x);
          for (e3._base = [], d2 = 0; d2 < x; d2++) {
            r3[d2] < 0 && (r3[d2] = s);
            var _ = false;
            r3[d2] !== s && d2 + 1 < x && r3[d2 + 1] !== s && (_ = true), v = b[d2] = { p: u[d2], s: r3[d2], cNext: _ }, e3._base[d2] = -0.5 * v.s, h && (b[d2].orig_p = c[d2], b[d2][p2 + "End"] = f2.ends[d2], b[d2][p2 + "Start"] = f2.starts[d2]), e3.ids && (v.id = String(e3.ids[d2])), 0 === d2 && (b[0].vTotal = 0), b[0].vTotal += l(v.s), v.begR = l(v.s) / l(b[0].s);
          }
          for (d2 = 0; d2 < x; d2++)
            (v = b[d2]).s !== s && (v.sumR = v.s / b[0].vTotal, v.difR = void 0 !== m2 ? v.s / m2 : 1, m2 = v.s);
          return a(b, e3), o(b, e3), b;
        };
      }, 18517: function(t2) {
        t2.exports = { eventDataKeys: ["percentInitial", "percentPrevious", "percentTotal"] };
      }, 8984: function(t2, e2, r2) {
        var n2 = r2(11661).setGroupPositions;
        t2.exports = function(t3, e3) {
          var r3, i, a = t3._fullLayout, o = t3._fullData, s = t3.calcdata, l = e3.xaxis, u = e3.yaxis, c = [], f2 = [], h = [];
          for (i = 0; i < o.length; i++) {
            var p2 = o[i], d2 = "h" === p2.orientation;
            true === p2.visible && p2.xaxis === l._id && p2.yaxis === u._id && "funnel" === p2.type && (r3 = s[i], d2 ? h.push(r3) : f2.push(r3), c.push(r3));
          }
          var v = { mode: a.funnelmode, norm: a.funnelnorm, gap: a.funnelgap, groupgap: a.funnelgroupgap };
          for (n2(t3, l, u, f2, v), n2(t3, u, l, h, v), i = 0; i < c.length; i++) {
            r3 = c[i];
            for (var g2 = 0; g2 < r3.length; g2++)
              g2 + 1 < r3.length && (r3[g2].nextP0 = r3[g2 + 1].p0, r3[g2].nextS0 = r3[g2 + 1].s0, r3[g2].nextP1 = r3[g2 + 1].p1, r3[g2].nextS1 = r3[g2 + 1].s1);
          }
        };
      }, 26199: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(26125), a = r2(90769).handleText, o = r2(67513), s = r2(73927), l = r2(1285), u = r2(7901);
        t2.exports = { supplyDefaults: function(t3, e3, r3, i2) {
          function c(r4, i3) {
            return n2.coerce(t3, e3, l, r4, i3);
          }
          if (o(t3, e3, i2, c)) {
            s(t3, e3, i2, c), c("xhoverformat"), c("yhoverformat"), c("orientation", e3.y && !e3.x ? "v" : "h"), c("offset"), c("width");
            var f2 = c("text");
            c("hovertext"), c("hovertemplate");
            var h = c("textposition");
            a(t3, e3, i2, c, h, { moduleHasSelected: false, moduleHasUnselected: false, moduleHasConstrain: true, moduleHasCliponaxis: true, moduleHasTextangle: true, moduleHasInsideanchor: true }), "none" === e3.textposition || e3.texttemplate || c("textinfo", Array.isArray(f2) ? "text+value" : "value");
            var p2 = c("marker.color", r3);
            c("marker.line.color", u.defaultLine), c("marker.line.width"), c("connector.visible") && (c("connector.fillcolor", function(t4) {
              var e4 = n2.isArrayOrTypedArray(t4) ? "#000" : t4;
              return u.addOpacity(e4, 0.5 * u.opacity(e4));
            }(p2)), c("connector.line.width") && (c("connector.line.color"), c("connector.line.dash")));
          } else
            e3.visible = false;
        }, crossTraceDefaults: function(t3, e3) {
          var r3, a2;
          function o2(t4) {
            return n2.coerce(a2._input, a2, l, t4);
          }
          if ("group" === e3.funnelmode)
            for (var s2 = 0; s2 < t3.length; s2++)
              r3 = (a2 = t3[s2])._input, i(r3, a2, e3, o2);
        } };
      }, 34598: function(t2) {
        t2.exports = function(t3, e2) {
          return t3.x = "xVal" in e2 ? e2.xVal : e2.x, t3.y = "yVal" in e2 ? e2.yVal : e2.y, "percentInitial" in e2 && (t3.percentInitial = e2.percentInitial), "percentPrevious" in e2 && (t3.percentPrevious = e2.percentPrevious), "percentTotal" in e2 && (t3.percentTotal = e2.percentTotal), e2.xa && (t3.xaxis = e2.xa), e2.ya && (t3.yaxis = e2.ya), t3;
        };
      }, 63341: function(t2, e2, r2) {
        var n2 = r2(7901).opacity, i = r2(95423).hoverOnBars, a = r2(71828).formatPercent;
        t2.exports = function(t3, e3, r3, o, s) {
          var l = i(t3, e3, r3, o, s);
          if (l) {
            var u = l.cd, c = u[0].trace, f2 = "h" === c.orientation, h = u[l.index];
            l[(f2 ? "x" : "y") + "LabelVal"] = h.s, l.percentInitial = h.begR, l.percentInitialLabel = a(h.begR, 1), l.percentPrevious = h.difR, l.percentPreviousLabel = a(h.difR, 1), l.percentTotal = h.sumR, l.percentTotalLabel = a(h.sumR, 1);
            var p2 = h.hi || c.hoverinfo, d2 = [];
            if (p2 && "none" !== p2 && "skip" !== p2) {
              var v = "all" === p2, g2 = p2.split("+"), y = function(t4) {
                return v || -1 !== g2.indexOf(t4);
              };
              y("percent initial") && d2.push(l.percentInitialLabel + " of initial"), y("percent previous") && d2.push(l.percentPreviousLabel + " of previous"), y("percent total") && d2.push(l.percentTotalLabel + " of total");
            }
            return l.extraText = d2.join("<br>"), l.color = function(t4, e4) {
              var r4 = t4.marker, i2 = e4.mc || r4.color, a2 = e4.mlc || r4.line.color, o2 = e4.mlw || r4.line.width;
              return n2(i2) ? i2 : n2(a2) && o2 ? a2 : void 0;
            }(c, h), [l];
          }
        };
      }, 51759: function(t2, e2, r2) {
        t2.exports = { attributes: r2(1285), layoutAttributes: r2(10440), supplyDefaults: r2(26199).supplyDefaults, crossTraceDefaults: r2(26199).crossTraceDefaults, supplyLayoutDefaults: r2(93138), calc: r2(9532), crossTraceCalc: r2(8984), plot: r2(80461), style: r2(68266).style, hoverPoints: r2(63341), eventData: r2(34598), selectPoints: r2(81974), moduleType: "trace", name: "funnel", basePlotModule: r2(93612), categories: ["bar-like", "cartesian", "svg", "oriented", "showLegend", "zoomScale"], meta: {} };
      }, 10440: function(t2) {
        t2.exports = { funnelmode: { valType: "enumerated", values: ["stack", "group", "overlay"], dflt: "stack", editType: "calc" }, funnelgap: { valType: "number", min: 0, max: 1, editType: "calc" }, funnelgroupgap: { valType: "number", min: 0, max: 1, dflt: 0, editType: "calc" } };
      }, 93138: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(10440);
        t2.exports = function(t3, e3, r3) {
          var a = false;
          function o(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          for (var s = 0; s < r3.length; s++) {
            var l = r3[s];
            if (l.visible && "funnel" === l.type) {
              a = true;
              break;
            }
          }
          a && (o("funnelmode"), o("funnelgap", 0.2), o("funnelgroupgap"));
        };
      }, 80461: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(91424), o = r2(50606).BADNUM, s = r2(17295), l = r2(72597).clearMinTextSize;
        function u(t3, e3, r3, n3) {
          var i2 = [], a2 = [], o2 = n3 ? e3 : r3, s2 = n3 ? r3 : e3;
          return i2[0] = o2.c2p(t3.s0, true), a2[0] = s2.c2p(t3.p0, true), i2[1] = o2.c2p(t3.s1, true), a2[1] = s2.c2p(t3.p1, true), i2[2] = o2.c2p(t3.nextS0, true), a2[2] = s2.c2p(t3.nextP0, true), i2[3] = o2.c2p(t3.nextS1, true), a2[3] = s2.c2p(t3.nextP1, true), n3 ? [i2, a2] : [a2, i2];
        }
        t2.exports = function(t3, e3, r3, c) {
          var f2 = t3._fullLayout;
          l("funnel", f2), function(t4, e4, r4, s2) {
            var l2 = e4.xaxis, c2 = e4.yaxis;
            i.makeTraceGroups(s2, r4, "trace bars").each(function(r5) {
              var s3 = n2.select(this), f3 = r5[0].trace, h = i.ensureSingle(s3, "g", "regions");
              if (f3.connector && f3.connector.visible) {
                var p2 = "h" === f3.orientation, d2 = h.selectAll("g.region").data(i.identity);
                d2.enter().append("g").classed("region", true), d2.exit().remove();
                var v = d2.size();
                d2.each(function(r6, s4) {
                  if (s4 === v - 1 || r6.cNext) {
                    var f4 = u(r6, l2, c2, p2), h2 = f4[0], d3 = f4[1], g2 = "";
                    h2[0] !== o && d3[0] !== o && h2[1] !== o && d3[1] !== o && h2[2] !== o && d3[2] !== o && h2[3] !== o && d3[3] !== o && (g2 += p2 ? "M" + h2[0] + "," + d3[1] + "L" + h2[2] + "," + d3[2] + "H" + h2[3] + "L" + h2[1] + "," + d3[1] + "Z" : "M" + h2[1] + "," + d3[1] + "L" + h2[2] + "," + d3[3] + "V" + d3[2] + "L" + h2[1] + "," + d3[0] + "Z"), "" === g2 && (g2 = "M0,0Z"), i.ensureSingle(n2.select(this), "path").attr("d", g2).call(a.setClipUrl, e4.layerClipId, t4);
                  }
                });
              } else
                h.remove();
            });
          }(t3, e3, r3, c), function(t4, e4, r4, o2) {
            var s2 = e4.xaxis, l2 = e4.yaxis;
            i.makeTraceGroups(o2, r4, "trace bars").each(function(r5) {
              var o3 = n2.select(this), c2 = r5[0].trace, f3 = i.ensureSingle(o3, "g", "lines");
              if (c2.connector && c2.connector.visible && c2.connector.line.width) {
                var h = "h" === c2.orientation, p2 = f3.selectAll("g.line").data(i.identity);
                p2.enter().append("g").classed("line", true), p2.exit().remove();
                var d2 = p2.size();
                p2.each(function(r6, o4) {
                  if (o4 === d2 - 1 || r6.cNext) {
                    var c3 = u(r6, s2, l2, h), f4 = c3[0], p3 = c3[1], v = "";
                    void 0 !== f4[3] && void 0 !== p3[3] && (h ? (v += "M" + f4[0] + "," + p3[1] + "L" + f4[2] + "," + p3[2], v += "M" + f4[1] + "," + p3[1] + "L" + f4[3] + "," + p3[2]) : (v += "M" + f4[1] + "," + p3[1] + "L" + f4[2] + "," + p3[3], v += "M" + f4[1] + "," + p3[0] + "L" + f4[2] + "," + p3[2])), "" === v && (v = "M0,0Z"), i.ensureSingle(n2.select(this), "path").attr("d", v).call(a.setClipUrl, e4.layerClipId, t4);
                  }
                });
              } else
                f3.remove();
            });
          }(t3, e3, r3, c), s.plot(t3, e3, r3, c, { mode: f2.funnelmode, norm: f2.funnelmode, gap: f2.funnelgap, groupgap: f2.funnelgroupgap });
        };
      }, 68266: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(91424), a = r2(7901), o = r2(37822).DESELECTDIM, s = r2(16688), l = r2(72597).resizeText, u = s.styleTextPoints;
        t2.exports = { style: function(t3, e3, r3) {
          var s2 = r3 || n2.select(t3).selectAll("g.funnellayer").selectAll("g.trace");
          l(t3, s2, "funnel"), s2.style("opacity", function(t4) {
            return t4[0].trace.opacity;
          }), s2.each(function(e4) {
            var r4 = n2.select(this), s3 = e4[0].trace;
            r4.selectAll(".point > path").each(function(t4) {
              if (!t4.isBlank) {
                var e5 = s3.marker;
                n2.select(this).call(a.fill, t4.mc || e5.color).call(a.stroke, t4.mlc || e5.line.color).call(i.dashLine, e5.line.dash, t4.mlw || e5.line.width).style("opacity", s3.selectedpoints && !t4.selected ? o : 1);
              }
            }), u(r4, s3, t3), r4.selectAll(".regions").each(function() {
              n2.select(this).selectAll("path").style("stroke-width", 0).call(a.fill, s3.connector.fillcolor);
            }), r4.selectAll(".lines").each(function() {
              var t4 = s3.connector.line;
              i.lineGroupStyle(n2.select(this).selectAll("path"), t4.width, t4.color, t4.dash);
            });
          });
        } };
      }, 86807: function(t2, e2, r2) {
        var n2 = r2(34e3), i = r2(9012), a = r2(27670).Y, o = r2(5386).f, s = r2(5386).s, l = r2(1426).extendFlat;
        t2.exports = { labels: n2.labels, label0: n2.label0, dlabel: n2.dlabel, values: n2.values, marker: { colors: n2.marker.colors, line: { color: l({}, n2.marker.line.color, { dflt: null }), width: l({}, n2.marker.line.width, { dflt: 1 }), editType: "calc" }, editType: "calc" }, text: n2.text, hovertext: n2.hovertext, scalegroup: l({}, n2.scalegroup, {}), textinfo: l({}, n2.textinfo, { flags: ["label", "text", "value", "percent"] }), texttemplate: s({ editType: "plot" }, { keys: ["label", "color", "value", "text", "percent"] }), hoverinfo: l({}, i.hoverinfo, { flags: ["label", "text", "value", "percent", "name"] }), hovertemplate: o({}, { keys: ["label", "color", "value", "text", "percent"] }), textposition: l({}, n2.textposition, { values: ["inside", "none"], dflt: "inside" }), textfont: n2.textfont, insidetextfont: n2.insidetextfont, title: { text: n2.title.text, font: n2.title.font, position: l({}, n2.title.position, { values: ["top left", "top center", "top right"], dflt: "top center" }), editType: "plot" }, domain: a({ name: "funnelarea", trace: true, editType: "calc" }), aspectratio: { valType: "number", min: 0, dflt: 1, editType: "plot" }, baseratio: { valType: "number", min: 0, max: 1, dflt: 0.333, editType: "plot" } };
      }, 6452: function(t2, e2, r2) {
        var n2 = r2(74875);
        e2.name = "funnelarea", e2.plot = function(t3, r3, i, a) {
          n2.plotBasePlot(e2.name, t3, r3, i, a);
        }, e2.clean = function(t3, r3, i, a) {
          n2.cleanBasePlot(e2.name, t3, r3, i, a);
        };
      }, 89574: function(t2, e2, r2) {
        var n2 = r2(32354);
        t2.exports = { calc: function(t3, e3) {
          return n2.calc(t3, e3);
        }, crossTraceCalc: function(t3) {
          n2.crossTraceCalc(t3, { type: "funnelarea" });
        } };
      }, 86282: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(86807), a = r2(27670).c, o = r2(90769).handleText, s = r2(37434).handleLabelsAndValues;
        t2.exports = function(t3, e3, r3, l) {
          function u(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          var c = u("labels"), f2 = u("values"), h = s(c, f2), p2 = h.len;
          if (e3._hasLabels = h.hasLabels, e3._hasValues = h.hasValues, !e3._hasLabels && e3._hasValues && (u("label0"), u("dlabel")), p2) {
            e3._length = p2, u("marker.line.width") && u("marker.line.color", l.paper_bgcolor), u("marker.colors"), u("scalegroup");
            var d2, v = u("text"), g2 = u("texttemplate");
            if (g2 || (d2 = u("textinfo", Array.isArray(v) ? "text+percent" : "percent")), u("hovertext"), u("hovertemplate"), g2 || d2 && "none" !== d2) {
              var y = u("textposition");
              o(t3, e3, l, u, y, { moduleHasSelected: false, moduleHasUnselected: false, moduleHasConstrain: false, moduleHasCliponaxis: false, moduleHasTextangle: false, moduleHasInsideanchor: false });
            }
            a(e3, l, u), u("title.text") && (u("title.position"), n2.coerceFont(u, "title.font", l.font)), u("aspectratio"), u("baseratio");
          } else
            e3.visible = false;
        };
      }, 10421: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "funnelarea", basePlotModule: r2(6452), categories: ["pie-like", "funnelarea", "showLegend"], attributes: r2(86807), layoutAttributes: r2(80097), supplyDefaults: r2(86282), supplyLayoutDefaults: r2(57402), calc: r2(89574).calc, crossTraceCalc: r2(89574).crossTraceCalc, plot: r2(79187), style: r2(71858), styleOne: r2(63463), meta: {} };
      }, 80097: function(t2, e2, r2) {
        var n2 = r2(92774).hiddenlabels;
        t2.exports = { hiddenlabels: n2, funnelareacolorway: { valType: "colorlist", editType: "calc" }, extendfunnelareacolors: { valType: "boolean", dflt: true, editType: "calc" } };
      }, 57402: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(80097);
        t2.exports = function(t3, e3) {
          function r3(r4, a) {
            return n2.coerce(t3, e3, i, r4, a);
          }
          r3("hiddenlabels"), r3("funnelareacolorway", e3.colorway), r3("extendfunnelareacolors");
        };
      }, 79187: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(91424), a = r2(71828), o = a.strScale, s = a.strTranslate, l = r2(63893), u = r2(17295).toMoveInsideBar, c = r2(72597), f2 = c.recordMinTextSize, h = c.clearMinTextSize, p2 = r2(53581), d2 = r2(14575), v = d2.attachFxHandlers, g2 = d2.determineInsideTextFont, y = d2.layoutAreas, m2 = d2.prerenderTitles, x = d2.positionTitleOutside, b = d2.formatSliceLabel;
        function _(t3, e3) {
          return "l" + (e3[0] - t3[0]) + "," + (e3[1] - t3[1]);
        }
        t2.exports = function(t3, e3) {
          var r3 = t3._context.staticPlot, c2 = t3._fullLayout;
          h("funnelarea", c2), m2(e3, t3), y(e3, c2._size), a.makeTraceGroups(c2._funnelarealayer, e3, "trace").each(function(e4) {
            var h2 = n2.select(this), d3 = e4[0], y2 = d3.trace;
            !function(t4) {
              if (t4.length) {
                var e5 = t4[0], r4 = e5.trace, n3 = r4.aspectratio, i2 = r4.baseratio;
                i2 > 0.999 && (i2 = 0.999);
                var a2, o2, s2, l2 = Math.pow(i2, 2), u2 = e5.vTotal, c3 = u2, f3 = u2 * l2 / (1 - l2) / u2, h3 = [];
                for (h3.push(E()), o2 = t4.length - 1; o2 > -1; o2--)
                  if (!(s2 = t4[o2]).hidden) {
                    var p3 = s2.v / c3;
                    f3 += p3, h3.push(E());
                  }
                var d4 = 1 / 0, v2 = -1 / 0;
                for (o2 = 0; o2 < h3.length; o2++)
                  a2 = h3[o2], d4 = Math.min(d4, a2[1]), v2 = Math.max(v2, a2[1]);
                for (o2 = 0; o2 < h3.length; o2++)
                  h3[o2][1] -= (v2 + d4) / 2;
                var g3 = h3[h3.length - 1][0], y3 = e5.r, m3 = (v2 - d4) / 2, x2 = y3 / g3, b2 = y3 / m3 * n3;
                for (e5.r = b2 * m3, o2 = 0; o2 < h3.length; o2++)
                  h3[o2][0] *= x2, h3[o2][1] *= b2;
                var _2, w2, T = [-(a2 = h3[0])[0], a2[1]], k = [a2[0], a2[1]], A = 0;
                for (o2 = t4.length - 1; o2 > -1; o2--)
                  if (!(s2 = t4[o2]).hidden) {
                    var M = h3[A += 1][0], S = h3[A][1];
                    s2.TL = [-M, S], s2.TR = [M, S], s2.BL = T, s2.BR = k, s2.pxmid = (_2 = s2.TR, w2 = s2.BR, [0.5 * (_2[0] + w2[0]), 0.5 * (_2[1] + w2[1])]), T = s2.TL, k = s2.TR;
                  }
              }
              function E() {
                var t5, e6 = { x: t5 = Math.sqrt(f3), y: -t5 };
                return [e6.x, e6.y];
              }
            }(e4), h2.each(function() {
              var h3 = n2.select(this).selectAll("g.slice").data(e4);
              h3.enter().append("g").classed("slice", true), h3.exit().remove(), h3.each(function(o2, s2) {
                if (o2.hidden)
                  n2.select(this).selectAll("path,g").remove();
                else {
                  o2.pointNumber = o2.i, o2.curveNumber = y2.index;
                  var h4 = d3.cx, m4 = d3.cy, x2 = n2.select(this), w2 = x2.selectAll("path.surface").data([o2]);
                  w2.enter().append("path").classed("surface", true).style({ "pointer-events": r3 ? "none" : "all" }), x2.call(v, t3, e4);
                  var T = "M" + (h4 + o2.TR[0]) + "," + (m4 + o2.TR[1]) + _(o2.TR, o2.BR) + _(o2.BR, o2.BL) + _(o2.BL, o2.TL) + "Z";
                  w2.attr("d", T), b(t3, o2, d3);
                  var k = p2.castOption(y2.textposition, o2.pts), A = x2.selectAll("g.slicetext").data(o2.text && "none" !== k ? [0] : []);
                  A.enter().append("g").classed("slicetext", true), A.exit().remove(), A.each(function() {
                    var r4 = a.ensureSingle(n2.select(this), "text", "", function(t4) {
                      t4.attr("data-notex", 1);
                    }), p3 = a.ensureUniformFontSize(t3, g2(y2, o2, c2.font));
                    r4.text(o2.text).attr({ class: "slicetext", transform: "", "text-anchor": "middle" }).call(i.font, p3).call(l.convertToTspans, t3);
                    var d4, v2, x3, b2 = i.bBox(r4.node()), _2 = Math.min(o2.BL[1], o2.BR[1]) + m4, w3 = Math.max(o2.TL[1], o2.TR[1]) + m4;
                    v2 = Math.max(o2.TL[0], o2.BL[0]) + h4, x3 = Math.min(o2.TR[0], o2.BR[0]) + h4, (d4 = u(v2, x3, _2, w3, b2, { isHorizontal: true, constrained: true, angle: 0, anchor: "middle" })).fontSize = p3.size, f2(y2.type, d4, c2), e4[s2].transform = d4, a.setTransormAndDisplay(r4, d4);
                  });
                }
              });
              var m3 = n2.select(this).selectAll("g.titletext").data(y2.title.text ? [0] : []);
              m3.enter().append("g").classed("titletext", true), m3.exit().remove(), m3.each(function() {
                var e5 = a.ensureSingle(n2.select(this), "text", "", function(t4) {
                  t4.attr("data-notex", 1);
                }), r4 = y2.title.text;
                y2._meta && (r4 = a.templateString(r4, y2._meta)), e5.text(r4).attr({ class: "titletext", transform: "", "text-anchor": "middle" }).call(i.font, y2.title.font).call(l.convertToTspans, t3);
                var u2 = x(d3, c2._size);
                e5.attr("transform", s(u2.x, u2.y) + o(Math.min(1, u2.scale)) + s(u2.tx, u2.ty));
              });
            });
          });
        };
      }, 71858: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(63463), a = r2(72597).resizeText;
        t2.exports = function(t3) {
          var e3 = t3._fullLayout._funnelarealayer.selectAll(".trace");
          a(t3, e3, "funnelarea"), e3.each(function(t4) {
            var e4 = t4[0].trace, r3 = n2.select(this);
            r3.style({ opacity: e4.opacity }), r3.selectAll("path.surface").each(function(t5) {
              n2.select(this).call(i, t5, e4);
            });
          });
        };
      }, 21606: function(t2, e2, r2) {
        var n2 = r2(82196), i = r2(9012), a = r2(41940), o = r2(12663).axisHoverFormat, s = r2(5386).f, l = r2(5386).s, u = r2(50693), c = r2(1426).extendFlat;
        t2.exports = c({ z: { valType: "data_array", editType: "calc" }, x: c({}, n2.x, { impliedEdits: { xtype: "array" } }), x0: c({}, n2.x0, { impliedEdits: { xtype: "scaled" } }), dx: c({}, n2.dx, { impliedEdits: { xtype: "scaled" } }), y: c({}, n2.y, { impliedEdits: { ytype: "array" } }), y0: c({}, n2.y0, { impliedEdits: { ytype: "scaled" } }), dy: c({}, n2.dy, { impliedEdits: { ytype: "scaled" } }), xperiod: c({}, n2.xperiod, { impliedEdits: { xtype: "scaled" } }), yperiod: c({}, n2.yperiod, { impliedEdits: { ytype: "scaled" } }), xperiod0: c({}, n2.xperiod0, { impliedEdits: { xtype: "scaled" } }), yperiod0: c({}, n2.yperiod0, { impliedEdits: { ytype: "scaled" } }), xperiodalignment: c({}, n2.xperiodalignment, { impliedEdits: { xtype: "scaled" } }), yperiodalignment: c({}, n2.yperiodalignment, { impliedEdits: { ytype: "scaled" } }), text: { valType: "data_array", editType: "calc" }, hovertext: { valType: "data_array", editType: "calc" }, transpose: { valType: "boolean", dflt: false, editType: "calc" }, xtype: { valType: "enumerated", values: ["array", "scaled"], editType: "calc+clearAxisTypes" }, ytype: { valType: "enumerated", values: ["array", "scaled"], editType: "calc+clearAxisTypes" }, zsmooth: { valType: "enumerated", values: ["fast", "best", false], dflt: false, editType: "calc" }, hoverongaps: { valType: "boolean", dflt: true, editType: "none" }, connectgaps: { valType: "boolean", editType: "calc" }, xgap: { valType: "number", dflt: 0, min: 0, editType: "plot" }, ygap: { valType: "number", dflt: 0, min: 0, editType: "plot" }, xhoverformat: o("x"), yhoverformat: o("y"), zhoverformat: o("z", 1), hovertemplate: s(), texttemplate: l({ arrayOk: false, editType: "plot" }, { keys: ["x", "y", "z", "text"] }), textfont: a({ editType: "plot", autoSize: true, autoColor: true, colorEditType: "style" }), showlegend: c({}, i.showlegend, { dflt: false }) }, { transforms: void 0 }, u("", { cLetter: "z", autoColorDflt: false }));
      }, 90757: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828), a = r2(89298), o = r2(42973), s = r2(17562), l = r2(78803), u = r2(68296), c = r2(4742), f2 = r2(824), h = r2(43907), p2 = r2(70769), d2 = r2(50606).BADNUM;
        function v(t3) {
          for (var e3 = [], r3 = t3.length, n3 = 0; n3 < r3; n3++) {
            var i2 = t3[n3];
            i2 !== d2 && e3.push(i2);
          }
          return e3;
        }
        t2.exports = function(t3, e3) {
          var r3, g2, y, m2, x, b, _, w2, T, k, A, M = a.getFromId(t3, e3.xaxis || "x"), S = a.getFromId(t3, e3.yaxis || "y"), E = n2.traceIs(e3, "contour"), L = n2.traceIs(e3, "histogram"), C = n2.traceIs(e3, "gl2d"), P = E ? "best" : e3.zsmooth;
          if (M._minDtick = 0, S._minDtick = 0, L)
            m2 = (A = s(t3, e3)).orig_x, r3 = A.x, g2 = A.x0, y = A.dx, w2 = A.orig_y, x = A.y, b = A.y0, _ = A.dy, T = A.z;
          else {
            var O = e3.z;
            i.isArray1D(O) ? (u(e3, M, S, "x", "y", ["z"]), r3 = e3._x, x = e3._y, O = e3._z) : (m2 = e3.x ? M.makeCalcdata(e3, "x") : [], w2 = e3.y ? S.makeCalcdata(e3, "y") : [], r3 = o(e3, M, "x", m2).vals, x = o(e3, S, "y", w2).vals, e3._x = r3, e3._y = x), g2 = e3.x0, y = e3.dx, b = e3.y0, _ = e3.dy, T = c(O, e3, M, S);
          }
          function I(t4) {
            P = e3._input.zsmooth = e3.zsmooth = false, i.warn('cannot use zsmooth: "fast": ' + t4);
          }
          if ((M.rangebreaks || S.rangebreaks) && (T = function(t4, e4, r4) {
            for (var n3 = [], i2 = -1, a2 = 0; a2 < r4.length; a2++)
              if (e4[a2] !== d2) {
                n3[++i2] = [];
                for (var o2 = 0; o2 < r4[a2].length; o2++)
                  t4[o2] !== d2 && n3[i2].push(r4[a2][o2]);
              }
            return n3;
          }(r3, x, T), L || (r3 = v(r3), x = v(x), e3._x = r3, e3._y = x)), L || !E && !e3.connectgaps || (e3._emptypoints = h(T), f2(T, e3._emptypoints)), "fast" === P) {
            if ("log" === M.type || "log" === S.type)
              I("log axis found");
            else if (!L) {
              if (r3.length) {
                var D = (r3[r3.length - 1] - r3[0]) / (r3.length - 1), z = Math.abs(D / 100);
                for (k = 0; k < r3.length - 1; k++)
                  if (Math.abs(r3[k + 1] - r3[k] - D) > z) {
                    I("x scale is not linear");
                    break;
                  }
              }
              if (x.length && "fast" === P) {
                var R = (x[x.length - 1] - x[0]) / (x.length - 1), F = Math.abs(R / 100);
                for (k = 0; k < x.length - 1; k++)
                  if (Math.abs(x[k + 1] - x[k] - R) > F) {
                    I("y scale is not linear");
                    break;
                  }
              }
            }
          }
          var B = i.maxRowLength(T), N = "scaled" === e3.xtype ? "" : r3, j = p2(e3, N, g2, y, B, M), U = "scaled" === e3.ytype ? "" : x, V = p2(e3, U, b, _, T.length, S);
          C || (e3._extremes[M._id] = a.findExtremes(M, j), e3._extremes[S._id] = a.findExtremes(S, V));
          var H = { x: j, y: V, z: T, text: e3._text || e3.text, hovertext: e3._hovertext || e3.hovertext };
          if (e3.xperiodalignment && m2 && (H.orig_x = m2), e3.yperiodalignment && w2 && (H.orig_y = w2), N && N.length === j.length - 1 && (H.xCenter = N), U && U.length === V.length - 1 && (H.yCenter = U), L && (H.xRanges = A.xRanges, H.yRanges = A.yRanges, H.pts = A.pts), E || l(t3, e3, { vals: T, cLetter: "z" }), E && e3.contours && "heatmap" === e3.contours.coloring) {
            var q2 = { type: "contour" === e3.type ? "heatmap" : "histogram2d", xcalendar: e3.xcalendar, ycalendar: e3.ycalendar };
            H.xfill = p2(q2, N, g2, y, B, M), H.yfill = p2(q2, U, b, _, T.length, S);
          }
          return [H];
        };
      }, 4742: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = r2(50606).BADNUM;
        t2.exports = function(t3, e3, r3, o) {
          var s, l, u, c, f2, h;
          function p2(t4) {
            if (n2(t4))
              return +t4;
          }
          if (e3 && e3.transpose) {
            for (s = 0, f2 = 0; f2 < t3.length; f2++)
              s = Math.max(s, t3[f2].length);
            if (0 === s)
              return false;
            u = function(t4) {
              return t4.length;
            }, c = function(t4, e4, r4) {
              return (t4[r4] || [])[e4];
            };
          } else
            s = t3.length, u = function(t4, e4) {
              return t4[e4].length;
            }, c = function(t4, e4, r4) {
              return (t4[e4] || [])[r4];
            };
          var d2 = function(t4, e4, r4) {
            return e4 === a || r4 === a ? a : c(t4, e4, r4);
          };
          function v(t4) {
            if (e3 && "carpet" !== e3.type && "contourcarpet" !== e3.type && t4 && "category" === t4.type && e3["_" + t4._id.charAt(0)].length) {
              var r4 = t4._id.charAt(0), n3 = {}, o2 = e3["_" + r4 + "CategoryMap"] || e3[r4];
              for (f2 = 0; f2 < o2.length; f2++)
                n3[o2[f2]] = f2;
              return function(e4) {
                var r5 = n3[t4._categories[e4]];
                return r5 + 1 ? r5 : a;
              };
            }
            return i.identity;
          }
          var g2 = v(r3), y = v(o);
          o && "category" === o.type && (s = o._categories.length);
          var m2 = new Array(s);
          for (f2 = 0; f2 < s; f2++)
            for (l = r3 && "category" === r3.type ? r3._categories.length : u(t3, f2), m2[f2] = new Array(l), h = 0; h < l; h++)
              m2[f2][h] = p2(d2(t3, y(f2), g2(h)));
          return m2;
        };
      }, 61243: function(t2) {
        t2.exports = { min: "zmin", max: "zmax" };
      }, 68296: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(50606).BADNUM, a = r2(42973);
        t2.exports = function(t3, e3, r3, o, s, l) {
          var u = t3._length, c = e3.makeCalcdata(t3, o), f2 = r3.makeCalcdata(t3, s);
          c = a(t3, e3, o, c).vals, f2 = a(t3, r3, s, f2).vals;
          var h, p2, d2, v, g2 = t3.text, y = void 0 !== g2 && n2.isArray1D(g2), m2 = t3.hovertext, x = void 0 !== m2 && n2.isArray1D(m2), b = n2.distinctVals(c), _ = b.vals, w2 = n2.distinctVals(f2), T = w2.vals, k = [], A = T.length, M = _.length;
          for (h = 0; h < l.length; h++)
            k[h] = n2.init2dArray(A, M);
          y && (d2 = n2.init2dArray(A, M)), x && (v = n2.init2dArray(A, M));
          var S = n2.init2dArray(A, M);
          for (h = 0; h < u; h++)
            if (c[h] !== i && f2[h] !== i) {
              var E = n2.findBin(c[h] + b.minDiff / 2, _), L = n2.findBin(f2[h] + w2.minDiff / 2, T);
              for (p2 = 0; p2 < l.length; p2++) {
                var C = t3[l[p2]];
                k[p2][L][E] = C[h], S[L][E] = h;
              }
              y && (d2[L][E] = g2[h]), x && (v[L][E] = m2[h]);
            }
          for (t3["_" + o] = _, t3["_" + s] = T, p2 = 0; p2 < l.length; p2++)
            t3["_" + l[p2]] = k[p2];
          y && (t3._text = d2), x && (t3._hovertext = v), e3 && "category" === e3.type && (t3["_" + o + "CategoryMap"] = _.map(function(t4) {
            return e3._categories[t4];
          })), r3 && "category" === r3.type && (t3["_" + s + "CategoryMap"] = T.map(function(t4) {
            return r3._categories[t4];
          })), t3._after2before = S;
        };
      }, 76382: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(67684), a = r2(58623), o = r2(73927), s = r2(49901), l = r2(1586), u = r2(21606);
        t2.exports = function(t3, e3, r3, c) {
          function f2(r4, i2) {
            return n2.coerce(t3, e3, u, r4, i2);
          }
          i(t3, e3, f2, c) ? (o(t3, e3, c, f2), f2("xhoverformat"), f2("yhoverformat"), f2("text"), f2("hovertext"), f2("hovertemplate"), a(f2, c), s(t3, e3, f2, c), f2("hoverongaps"), f2("connectgaps", n2.isArray1D(e3.z) && false !== e3.zsmooth), l(t3, e3, c, f2, { prefix: "", cLetter: "z" })) : e3.visible = false;
        };
      }, 43907: function(t2, e2, r2) {
        var n2 = r2(71828).maxRowLength;
        t2.exports = function(t3) {
          var e3, r3, i, a, o, s, l, u, c = [], f2 = {}, h = [], p2 = t3[0], d2 = [], v = [0, 0, 0], g2 = n2(t3);
          for (r3 = 0; r3 < t3.length; r3++)
            for (e3 = d2, d2 = p2, p2 = t3[r3 + 1] || [], i = 0; i < g2; i++)
              void 0 === d2[i] && ((s = (void 0 !== d2[i - 1] ? 1 : 0) + (void 0 !== d2[i + 1] ? 1 : 0) + (void 0 !== e3[i] ? 1 : 0) + (void 0 !== p2[i] ? 1 : 0)) ? (0 === r3 && s++, 0 === i && s++, r3 === t3.length - 1 && s++, i === d2.length - 1 && s++, s < 4 && (f2[[r3, i]] = [r3, i, s]), c.push([r3, i, s])) : h.push([r3, i]));
          for (; h.length; ) {
            for (l = {}, u = false, o = h.length - 1; o >= 0; o--)
              (s = ((f2[[(r3 = (a = h[o])[0]) - 1, i = a[1]]] || v)[2] + (f2[[r3 + 1, i]] || v)[2] + (f2[[r3, i - 1]] || v)[2] + (f2[[r3, i + 1]] || v)[2]) / 20) && (l[a] = [r3, i, s], h.splice(o, 1), u = true);
            if (!u)
              throw "findEmpties iterated with no new neighbors";
            for (a in l)
              f2[a] = l[a], c.push(l[a]);
          }
          return c.sort(function(t4, e4) {
            return e4[2] - t4[2];
          });
        };
      }, 46248: function(t2, e2, r2) {
        var n2 = r2(30211), i = r2(71828), a = r2(89298), o = r2(21081).extractOpts;
        t2.exports = function(t3, e3, r3, s, l) {
          l || (l = {});
          var u, c, f2, h, p2 = l.isContour, d2 = t3.cd[0], v = d2.trace, g2 = t3.xa, y = t3.ya, m2 = d2.x, x = d2.y, b = d2.z, _ = d2.xCenter, w2 = d2.yCenter, T = d2.zmask, k = v.zhoverformat, A = m2, M = x;
          if (false !== t3.index) {
            try {
              f2 = Math.round(t3.index[1]), h = Math.round(t3.index[0]);
            } catch (e4) {
              return void i.error("Error hovering on heatmap, pointNumber must be [row,col], found:", t3.index);
            }
            if (f2 < 0 || f2 >= b[0].length || h < 0 || h > b.length)
              return;
          } else {
            if (n2.inbox(e3 - m2[0], e3 - m2[m2.length - 1], 0) > 0 || n2.inbox(r3 - x[0], r3 - x[x.length - 1], 0) > 0)
              return;
            if (p2) {
              var S;
              for (A = [2 * m2[0] - m2[1]], S = 1; S < m2.length; S++)
                A.push((m2[S] + m2[S - 1]) / 2);
              for (A.push([2 * m2[m2.length - 1] - m2[m2.length - 2]]), M = [2 * x[0] - x[1]], S = 1; S < x.length; S++)
                M.push((x[S] + x[S - 1]) / 2);
              M.push([2 * x[x.length - 1] - x[x.length - 2]]);
            }
            f2 = Math.max(0, Math.min(A.length - 2, i.findBin(e3, A))), h = Math.max(0, Math.min(M.length - 2, i.findBin(r3, M)));
          }
          var E, L, C = g2.c2p(m2[f2]), P = g2.c2p(m2[f2 + 1]), O = y.c2p(x[h]), I = y.c2p(x[h + 1]);
          p2 ? (E = d2.orig_x || m2, L = d2.orig_y || x, P = C, u = E[f2], I = O, c = L[h]) : (E = d2.orig_x || _ || m2, L = d2.orig_y || w2 || x, u = _ ? E[f2] : (E[f2] + E[f2 + 1]) / 2, c = w2 ? L[h] : (L[h] + L[h + 1]) / 2, g2 && "category" === g2.type && (u = m2[f2]), y && "category" === y.type && (c = x[h]), v.zsmooth && (C = P = g2.c2p(u), O = I = y.c2p(c)));
          var D = b[h][f2];
          if (T && !T[h][f2] && (D = void 0), void 0 !== D || v.hoverongaps) {
            var z;
            Array.isArray(d2.hovertext) && Array.isArray(d2.hovertext[h]) ? z = d2.hovertext[h][f2] : Array.isArray(d2.text) && Array.isArray(d2.text[h]) && (z = d2.text[h][f2]);
            var R = o(v), F = { type: "linear", range: [R.min, R.max], hoverformat: k, _separators: g2._separators, _numFormat: g2._numFormat }, B = a.tickText(F, D, "hover").text;
            return [i.extendFlat(t3, { index: v._after2before ? v._after2before[h][f2] : [h, f2], distance: t3.maxHoverDistance, spikeDistance: t3.maxSpikeDistance, x0: C, x1: P, y0: O, y1: I, xLabelVal: u, yLabelVal: c, zLabelVal: D, zLabel: B, text: z })];
          }
        };
      }, 92165: function(t2, e2, r2) {
        t2.exports = { attributes: r2(21606), supplyDefaults: r2(76382), calc: r2(90757), plot: r2(50347), colorbar: r2(61243), style: r2(70035), hoverPoints: r2(46248), moduleType: "trace", name: "heatmap", basePlotModule: r2(93612), categories: ["cartesian", "svg", "2dMap", "showLegend"], meta: {} };
      }, 824: function(t2, e2, r2) {
        var n2 = r2(71828), i = [[-1, 0], [1, 0], [0, -1], [0, 1]];
        function a(t3) {
          return 0.5 - 0.25 * Math.min(1, 0.5 * t3);
        }
        function o(t3, e3, r3) {
          var n3, a2, o2, s, l, u, c, f2, h, p2, d2, v, g2, y = 0;
          for (s = 0; s < e3.length; s++) {
            for (a2 = (n3 = e3[s])[0], o2 = n3[1], d2 = t3[a2][o2], p2 = 0, h = 0, l = 0; l < 4; l++)
              (c = t3[a2 + (u = i[l])[0]]) && void 0 !== (f2 = c[o2 + u[1]]) && (0 === p2 ? v = g2 = f2 : (v = Math.min(v, f2), g2 = Math.max(g2, f2)), h++, p2 += f2);
            if (0 === h)
              throw "iterateInterp2d order is wrong: no defined neighbors";
            t3[a2][o2] = p2 / h, void 0 === d2 ? h < 4 && (y = 1) : (t3[a2][o2] = (1 + r3) * t3[a2][o2] - r3 * d2, g2 > v && (y = Math.max(y, Math.abs(t3[a2][o2] - d2) / (g2 - v))));
          }
          return y;
        }
        t2.exports = function(t3, e3) {
          var r3, i2 = 1;
          for (o(t3, e3), r3 = 0; r3 < e3.length && !(e3[r3][2] < 4); r3++)
            ;
          for (e3 = e3.slice(r3), r3 = 0; r3 < 100 && i2 > 0.01; r3++)
            i2 = o(t3, e3, a(i2));
          return i2 > 0.01 && n2.log("interp2d didn't converge quickly", i2), t3;
        };
      }, 58623: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = function(t3, e3) {
          t3("texttemplate");
          var r3 = n2.extendFlat({}, e3.font, { color: "auto", size: "auto" });
          n2.coerceFont(t3, "textfont", r3);
        };
      }, 70769: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828).isArrayOrTypedArray;
        t2.exports = function(t3, e3, r3, a, o, s) {
          var l, u, c, f2 = [], h = n2.traceIs(t3, "contour"), p2 = n2.traceIs(t3, "histogram"), d2 = n2.traceIs(t3, "gl2d");
          if (i(e3) && e3.length > 1 && !p2 && "category" !== s.type) {
            var v = e3.length;
            if (!(v <= o))
              return h ? e3.slice(0, o) : e3.slice(0, o + 1);
            if (h || d2)
              f2 = e3.slice(0, o);
            else if (1 === o)
              f2 = [e3[0] - 0.5, e3[0] + 0.5];
            else {
              for (f2 = [1.5 * e3[0] - 0.5 * e3[1]], c = 1; c < v; c++)
                f2.push(0.5 * (e3[c - 1] + e3[c]));
              f2.push(1.5 * e3[v - 1] - 0.5 * e3[v - 2]);
            }
            if (v < o) {
              var g2 = f2[f2.length - 1], y = g2 - f2[f2.length - 2];
              for (c = v; c < o; c++)
                g2 += y, f2.push(g2);
            }
          } else {
            var m2 = t3[s._id.charAt(0) + "calendar"];
            for (l = p2 ? s.r2c(r3, 0, m2) : i(e3) && 1 === e3.length ? e3[0] : void 0 === r3 ? 0 : ("log" === s.type ? s.d2c : s.r2c)(r3, 0, m2), u = a || 1, c = h || d2 ? 0 : -0.5; c < o; c++)
              f2.push(l + u * c);
          }
          return f2;
        };
      }, 50347: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(84267), a = r2(73972), o = r2(91424), s = r2(89298), l = r2(71828), u = r2(63893), c = r2(8225), f2 = r2(7901), h = r2(21081).extractOpts, p2 = r2(21081).makeColorScaleFuncFromTrace, d2 = r2(77922), v = r2(18783).LINE_SPACING, g2 = "heatmap-label";
        function y(t3) {
          return t3.selectAll("g." + g2);
        }
        function m2(t3) {
          y(t3).remove();
        }
        function x(t3, e3) {
          var r3 = e3.length - 2, n3 = l.constrain(l.findBin(t3, e3), 0, r3), i2 = e3[n3], a2 = e3[n3 + 1], o2 = l.constrain(n3 + (t3 - i2) / (a2 - i2) - 0.5, 0, r3), s2 = Math.round(o2), u2 = Math.abs(o2 - s2);
          return o2 && o2 !== r3 && u2 ? { bin0: s2, frac: u2, bin1: Math.round(s2 + u2 / (o2 - s2)) } : { bin0: s2, bin1: s2, frac: 0 };
        }
        function b(t3, e3) {
          var r3 = e3.length - 1, n3 = l.constrain(l.findBin(t3, e3), 0, r3), i2 = e3[n3], a2 = (t3 - i2) / (e3[n3 + 1] - i2) || 0;
          return a2 <= 0 ? { bin0: n3, bin1: n3, frac: 0 } : a2 < 0.5 ? { bin0: n3, bin1: n3 + 1, frac: a2 } : { bin0: n3 + 1, bin1: n3, frac: 1 - a2 };
        }
        function _(t3, e3, r3) {
          t3[e3] = r3[0], t3[e3 + 1] = r3[1], t3[e3 + 2] = r3[2], t3[e3 + 3] = Math.round(255 * r3[3]);
        }
        t2.exports = function(t3, e3, r3, w2) {
          var T = e3.xaxis, k = e3.yaxis;
          l.makeTraceGroups(w2, r3, "hm").each(function(e4) {
            var r4, w3, A, M, S, E, L, C, P = n2.select(this), O = e4[0], I = O.trace, D = I.xgap || 0, z = I.ygap || 0, R = O.z, F = O.x, B = O.y, N = O.xCenter, j = O.yCenter, U = a.traceIs(I, "contour"), V = U ? "best" : I.zsmooth, H = R.length, q2 = l.maxRowLength(R), G = false, Z = false;
            for (E = 0; void 0 === r4 && E < F.length - 1; )
              r4 = T.c2p(F[E]), E++;
            for (E = F.length - 1; void 0 === w3 && E > 0; )
              w3 = T.c2p(F[E]), E--;
            for (w3 < r4 && (A = w3, w3 = r4, r4 = A, G = true), E = 0; void 0 === M && E < B.length - 1; )
              M = k.c2p(B[E]), E++;
            for (E = B.length - 1; void 0 === S && E > 0; )
              S = k.c2p(B[E]), E--;
            if (S < M && (A = M, M = S, S = A, Z = true), U && (N = F, j = B, F = O.xfill, B = O.yfill), "fast" !== V) {
              var Y = "best" === V ? 0 : 0.5;
              r4 = Math.max(-Y * T._length, r4), w3 = Math.min((1 + Y) * T._length, w3), M = Math.max(-Y * k._length, M), S = Math.min((1 + Y) * k._length, S);
            }
            var W, X, J = Math.round(w3 - r4), K = Math.round(S - M);
            if (J <= 0 || K <= 0)
              return P.selectAll("image").data([]).exit().remove(), void m2(P);
            "fast" === V ? (W = q2, X = H) : (W = J, X = K);
            var $ = document.createElement("canvas");
            $.width = W, $.height = X;
            var Q, tt, et = $.getContext("2d"), rt = p2(I, { noNumericCheck: true, returnArray: true });
            "fast" === V ? (Q = G ? function(t4) {
              return q2 - 1 - t4;
            } : l.identity, tt = Z ? function(t4) {
              return H - 1 - t4;
            } : l.identity) : (Q = function(t4) {
              return l.constrain(Math.round(T.c2p(F[t4]) - r4), 0, J);
            }, tt = function(t4) {
              return l.constrain(Math.round(k.c2p(B[t4]) - M), 0, K);
            });
            var nt, it, at, ot, st = tt(0), lt = [st, st], ut = G ? 0 : 1, ct = Z ? 0 : 1, ft = 0, ht = 0, pt = 0, dt = 0;
            function vt(t4, e5) {
              if (void 0 !== t4) {
                var r5 = rt(t4);
                return r5[0] = Math.round(r5[0]), r5[1] = Math.round(r5[1]), r5[2] = Math.round(r5[2]), ft += e5, ht += r5[0] * e5, pt += r5[1] * e5, dt += r5[2] * e5, r5;
              }
              return [0, 0, 0, 0];
            }
            function gt(t4, e5, r5, n3) {
              var i2 = t4[r5.bin0];
              if (void 0 === i2)
                return vt(void 0, 1);
              var a2, o2 = t4[r5.bin1], s2 = e5[r5.bin0], l2 = e5[r5.bin1], u2 = o2 - i2 || 0, c2 = s2 - i2 || 0;
              return a2 = void 0 === o2 ? void 0 === l2 ? 0 : void 0 === s2 ? 2 * (l2 - i2) : 2 * (2 * l2 - s2 - i2) / 3 : void 0 === l2 ? void 0 === s2 ? 0 : 2 * (2 * i2 - o2 - s2) / 3 : void 0 === s2 ? 2 * (2 * l2 - o2 - i2) / 3 : l2 + i2 - o2 - s2, vt(i2 + r5.frac * u2 + n3.frac * (c2 + r5.frac * a2));
            }
            if (V) {
              var yt, mt = 0;
              try {
                yt = new Uint8Array(J * K * 4);
              } catch (t4) {
                yt = new Array(J * K * 4);
              }
              if ("best" === V) {
                var xt, bt, _t, wt = N || F, Tt = j || B, kt = new Array(wt.length), At = new Array(Tt.length), Mt = new Array(J), St = N ? b : x, Et = j ? b : x;
                for (E = 0; E < wt.length; E++)
                  kt[E] = Math.round(T.c2p(wt[E]) - r4);
                for (E = 0; E < Tt.length; E++)
                  At[E] = Math.round(k.c2p(Tt[E]) - M);
                for (E = 0; E < J; E++)
                  Mt[E] = St(E, kt);
                for (L = 0; L < K; L++)
                  for (bt = R[(xt = Et(L, At)).bin0], _t = R[xt.bin1], E = 0; E < J; E++, mt += 4)
                    _(yt, mt, ot = gt(bt, _t, Mt[E], xt));
              } else
                for (L = 0; L < H; L++)
                  for (at = R[L], lt = tt(L), E = 0; E < J; E++)
                    ot = vt(at[E], 1), _(yt, mt = 4 * (lt * J + Q(E)), ot);
              var Lt = et.createImageData(J, K);
              try {
                Lt.data.set(yt);
              } catch (t4) {
                var Ct = Lt.data, Pt = Ct.length;
                for (L = 0; L < Pt; L++)
                  Ct[L] = yt[L];
              }
              et.putImageData(Lt, 0, 0);
            } else {
              var Ot = Math.floor(D / 2), It = Math.floor(z / 2);
              for (L = 0; L < H; L++)
                if (at = R[L], lt.reverse(), lt[ct] = tt(L + 1), lt[0] !== lt[1] && void 0 !== lt[0] && void 0 !== lt[1])
                  for (nt = [it = Q(0), it], E = 0; E < q2; E++)
                    nt.reverse(), nt[ut] = Q(E + 1), nt[0] !== nt[1] && void 0 !== nt[0] && void 0 !== nt[1] && (ot = vt(at[E], (nt[1] - nt[0]) * (lt[1] - lt[0])), et.fillStyle = "rgba(" + ot.join(",") + ")", et.fillRect(nt[0] + Ot, lt[0] + It, nt[1] - nt[0] - D, lt[1] - lt[0] - z));
            }
            ht = Math.round(ht / ft), pt = Math.round(pt / ft), dt = Math.round(dt / ft);
            var Dt = i("rgb(" + ht + "," + pt + "," + dt + ")");
            t3._hmpixcount = (t3._hmpixcount || 0) + ft, t3._hmlumcount = (t3._hmlumcount || 0) + ft * Dt.getLuminance();
            var zt = P.selectAll("image").data(e4);
            zt.enter().append("svg:image").attr({ xmlns: d2.svg, preserveAspectRatio: "none" }), zt.attr({ height: K, width: J, x: r4, y: M, "xlink:href": $.toDataURL("image/png") }), m2(P);
            var Rt = I.texttemplate;
            if (Rt) {
              var Ft = h(I), Bt = { type: "linear", range: [Ft.min, Ft.max], _separators: T._separators, _numFormat: T._numFormat }, Nt = "histogram2dcontour" === I.type, jt = "contour" === I.type, Ut = jt ? H - 1 : H, Vt = jt ? 1 : 0, Ht = jt ? q2 - 1 : q2, qt = [];
              for (E = jt ? 1 : 0; E < Ut; E++) {
                var Gt;
                if (jt)
                  Gt = O.y[E];
                else if (Nt) {
                  if (0 === E || E === H - 1)
                    continue;
                  Gt = O.y[E];
                } else if (O.yCenter)
                  Gt = O.yCenter[E];
                else {
                  if (E + 1 === H && void 0 === O.y[E + 1])
                    continue;
                  Gt = (O.y[E] + O.y[E + 1]) / 2;
                }
                var Zt = Math.round(k.c2p(Gt));
                if (!(0 > Zt || Zt > k._length))
                  for (L = Vt; L < Ht; L++) {
                    var Yt;
                    if (jt)
                      Yt = O.x[L];
                    else if (Nt) {
                      if (0 === L || L === q2 - 1)
                        continue;
                      Yt = O.x[L];
                    } else if (O.xCenter)
                      Yt = O.xCenter[L];
                    else {
                      if (L + 1 === q2 && void 0 === O.x[L + 1])
                        continue;
                      Yt = (O.x[L] + O.x[L + 1]) / 2;
                    }
                    var Wt = Math.round(T.c2p(Yt));
                    if (!(0 > Wt || Wt > T._length)) {
                      var Xt = c({ x: Yt, y: Gt }, I, t3._fullLayout);
                      Xt.x = Yt, Xt.y = Gt;
                      var Jt = O.z[E][L];
                      void 0 === Jt ? (Xt.z = "", Xt.zLabel = "") : (Xt.z = Jt, Xt.zLabel = s.tickText(Bt, Jt, "hover").text);
                      var Kt = O.text && O.text[E] && O.text[E][L];
                      void 0 !== Kt && false !== Kt || (Kt = ""), Xt.text = Kt;
                      var $t = l.texttemplateString(Rt, Xt, t3._fullLayout._d3locale, Xt, I._meta || {});
                      if ($t) {
                        var Qt = $t.split("<br>"), te = Qt.length, ee = 0;
                        for (C = 0; C < te; C++)
                          ee = Math.max(ee, Qt[C].length);
                        qt.push({ l: te, c: ee, t: $t, x: Wt, y: Zt, z: Jt });
                      }
                    }
                  }
              }
              var re = I.textfont, ne = re.family, ie = re.size, ae = t3._fullLayout.font.size;
              if (!ie || "auto" === ie) {
                var oe = 1 / 0, se = 1 / 0, le = 0, ue = 0;
                for (C = 0; C < qt.length; C++) {
                  var ce = qt[C];
                  if (le = Math.max(le, ce.l), ue = Math.max(ue, ce.c), C < qt.length - 1) {
                    var fe = qt[C + 1], he = Math.abs(fe.x - ce.x), pe = Math.abs(fe.y - ce.y);
                    he && (oe = Math.min(oe, he)), pe && (se = Math.min(se, pe));
                  }
                }
                isFinite(oe) && isFinite(se) ? (oe -= D, se -= z, oe /= ue, se /= le, oe /= v / 2, se /= v, ie = Math.min(Math.floor(oe), Math.floor(se), ae)) : ie = ae;
              }
              if (ie <= 0 || !isFinite(ie))
                return;
              y(P).data(qt).enter().append("g").classed(g2, 1).append("text").attr("text-anchor", "middle").each(function(e5) {
                var r5 = n2.select(this), i2 = re.color;
                i2 && "auto" !== i2 || (i2 = f2.contrast("rgba(" + rt(e5.z).join() + ")")), r5.attr("data-notex", 1).call(u.positionText, function(t4) {
                  return t4.x;
                }(e5), function(t4) {
                  return t4.y - ie * (t4.l * v / 2 - 1);
                }(e5)).call(o.font, ne, ie, i2).text(e5.t).call(u.convertToTspans, t3);
              });
            }
          });
        };
      }, 70035: function(t2, e2, r2) {
        var n2 = r2(39898);
        t2.exports = function(t3) {
          n2.select(t3).selectAll(".hm image").style("opacity", function(t4) {
            return t4.trace.opacity;
          });
        };
      }, 49901: function(t2) {
        t2.exports = function(t3, e2, r2) {
          false === r2("zsmooth") && (r2("xgap"), r2("ygap")), r2("zhoverformat");
        };
      }, 67684: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = r2(73972);
        function o(t3, e3) {
          var r3 = e3(t3);
          return "scaled" === (r3 ? e3(t3 + "type", "array") : "scaled") && (e3(t3 + "0"), e3("d" + t3)), r3;
        }
        t2.exports = function(t3, e3, r3, s, l, u) {
          var c, f2, h = r3("z");
          if (l = l || "x", u = u || "y", void 0 === h || !h.length)
            return 0;
          if (i.isArray1D(t3.z)) {
            c = r3(l), f2 = r3(u);
            var p2 = i.minRowLength(c), d2 = i.minRowLength(f2);
            if (0 === p2 || 0 === d2)
              return 0;
            e3._length = Math.min(p2, d2, h.length);
          } else {
            if (c = o(l, r3), f2 = o(u, r3), !function(t4) {
              for (var e4, r4 = true, a2 = false, o2 = false, s2 = 0; s2 < t4.length; s2++) {
                if (e4 = t4[s2], !i.isArrayOrTypedArray(e4)) {
                  r4 = false;
                  break;
                }
                e4.length > 0 && (a2 = true);
                for (var l2 = 0; l2 < e4.length; l2++)
                  if (n2(e4[l2])) {
                    o2 = true;
                    break;
                  }
              }
              return r4 && a2 && o2;
            }(h))
              return 0;
            r3("transpose"), e3._length = null;
          }
          return "heatmapgl" === t3.type || a.getComponentMethod("calendars", "handleTraceDefaults")(t3, e3, [l, u], s), true;
        };
      }, 16063: function(t2, e2, r2) {
        for (var n2 = r2(21606), i = r2(50693), a = r2(1426).extendFlat, o = r2(30962).overrideAll, s = ["z", "x", "x0", "dx", "y", "y0", "dy", "text", "transpose", "xtype", "ytype"], l = {}, u = 0; u < s.length; u++) {
          var c = s[u];
          l[c] = n2[c];
        }
        l.zsmooth = { valType: "enumerated", values: ["fast", false], dflt: "fast", editType: "calc" }, a(l, i("", { cLetter: "z", autoColorDflt: false })), t2.exports = o(l, "calc", "nested");
      }, 59560: function(t2, e2, r2) {
        var n2 = r2(9330).gl_heatmap2d, i = r2(89298), a = r2(78614);
        function o(t3, e3) {
          this.scene = t3, this.uid = e3, this.type = "heatmapgl", this.name = "", this.hoverinfo = "all", this.xData = [], this.yData = [], this.zData = [], this.textLabels = [], this.idToIndex = [], this.bounds = [0, 0, 0, 0], this.options = { zsmooth: "fast", z: [], x: [], y: [], shape: [0, 0], colorLevels: [0], colorValues: [0, 0, 0, 1] }, this.heatmap = n2(t3.glplot, this.options), this.heatmap._trace = this;
        }
        var s = o.prototype;
        s.handlePick = function(t3) {
          var e3 = this.options, r3 = e3.shape, n3 = t3.pointId, i2 = n3 % r3[0], a2 = Math.floor(n3 / r3[0]), o2 = n3;
          return { trace: this, dataCoord: t3.dataCoord, traceCoord: [e3.x[i2], e3.y[a2], e3.z[o2]], textLabel: this.textLabels[n3], name: this.name, pointIndex: [a2, i2], hoverinfo: this.hoverinfo };
        }, s.update = function(t3, e3) {
          var r3 = e3[0];
          this.index = t3.index, this.name = t3.name, this.hoverinfo = t3.hoverinfo;
          var n3 = r3.z;
          this.options.z = [].concat.apply([], n3);
          var o2 = n3[0].length, s2 = n3.length;
          this.options.shape = [o2, s2], this.options.x = r3.x, this.options.y = r3.y, this.options.zsmooth = t3.zsmooth;
          var l = function(t4) {
            for (var e4 = t4.colorscale, r4 = t4.zmin, n4 = t4.zmax, i2 = e4.length, o3 = new Array(i2), s3 = new Array(4 * i2), l2 = 0; l2 < i2; l2++) {
              var u2 = e4[l2], c2 = a(u2[1]);
              o3[l2] = r4 + u2[0] * (n4 - r4);
              for (var f3 = 0; f3 < 4; f3++)
                s3[4 * l2 + f3] = c2[f3];
            }
            return { colorLevels: o3, colorValues: s3 };
          }(t3);
          this.options.colorLevels = l.colorLevels, this.options.colorValues = l.colorValues, this.textLabels = [].concat.apply([], t3.text), this.heatmap.update(this.options);
          var u, c, f2 = this.scene.xaxis, h = this.scene.yaxis;
          false === t3.zsmooth && (u = { ppad: r3.x[1] - r3.x[0] }, c = { ppad: r3.y[1] - r3.y[0] }), t3._extremes[f2._id] = i.findExtremes(f2, r3.x, u), t3._extremes[h._id] = i.findExtremes(h, r3.y, c);
        }, s.dispose = function() {
          this.heatmap.dispose();
        }, t2.exports = function(t3, e3, r3) {
          var n3 = new o(t3, e3.uid);
          return n3.update(e3, r3), n3;
        };
      }, 19600: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(67684), a = r2(1586), o = r2(16063);
        t2.exports = function(t3, e3, r3, s) {
          function l(r4, i2) {
            return n2.coerce(t3, e3, o, r4, i2);
          }
          i(t3, e3, l, s) ? (l("text"), l("zsmooth"), a(t3, e3, s, l, { prefix: "", cLetter: "z" })) : e3.visible = false;
        };
      }, 3325: function(t2, e2, r2) {
        t2.exports = { attributes: r2(16063), supplyDefaults: r2(19600), colorbar: r2(61243), calc: r2(90757), plot: r2(59560), moduleType: "trace", name: "heatmapgl", basePlotModule: r2(4796), categories: ["gl", "gl2d", "2dMap"], meta: {} };
      }, 7745: function(t2, e2, r2) {
        var n2 = r2(1486), i = r2(12663).axisHoverFormat, a = r2(5386).f, o = r2(5386).s, s = r2(41940), l = r2(17656), u = r2(72406), c = r2(1426).extendFlat;
        t2.exports = { x: { valType: "data_array", editType: "calc+clearAxisTypes" }, y: { valType: "data_array", editType: "calc+clearAxisTypes" }, xhoverformat: i("x"), yhoverformat: i("y"), text: c({}, n2.text, {}), hovertext: c({}, n2.hovertext, {}), orientation: n2.orientation, histfunc: { valType: "enumerated", values: ["count", "sum", "avg", "min", "max"], dflt: "count", editType: "calc" }, histnorm: { valType: "enumerated", values: ["", "percent", "probability", "density", "probability density"], dflt: "", editType: "calc" }, cumulative: { enabled: { valType: "boolean", dflt: false, editType: "calc" }, direction: { valType: "enumerated", values: ["increasing", "decreasing"], dflt: "increasing", editType: "calc" }, currentbin: { valType: "enumerated", values: ["include", "exclude", "half"], dflt: "include", editType: "calc" }, editType: "calc" }, nbinsx: { valType: "integer", min: 0, dflt: 0, editType: "calc" }, xbins: l("x", true), nbinsy: { valType: "integer", min: 0, dflt: 0, editType: "calc" }, ybins: l("y", true), autobinx: { valType: "boolean", dflt: null, editType: "calc" }, autobiny: { valType: "boolean", dflt: null, editType: "calc" }, bingroup: { valType: "string", dflt: "", editType: "calc" }, hovertemplate: a({}, { keys: u.eventDataKeys }), texttemplate: o({ arrayOk: false, editType: "plot" }, { keys: ["label", "value"] }), textposition: c({}, n2.textposition, { arrayOk: false }), textfont: s({ arrayOk: false, editType: "plot", colorEditType: "style" }), outsidetextfont: s({ arrayOk: false, editType: "plot", colorEditType: "style" }), insidetextfont: s({ arrayOk: false, editType: "plot", colorEditType: "style" }), insidetextanchor: n2.insidetextanchor, textangle: n2.textangle, cliponaxis: n2.cliponaxis, constraintext: n2.constraintext, marker: n2.marker, offsetgroup: n2.offsetgroup, alignmentgroup: n2.alignmentgroup, selected: n2.selected, unselected: n2.unselected, _deprecated: { bardir: n2._deprecated.bardir } };
      }, 42174: function(t2) {
        t2.exports = function(t3, e2) {
          for (var r2 = t3.length, n2 = 0, i = 0; i < r2; i++)
            e2[i] ? (t3[i] /= e2[i], n2 += t3[i]) : t3[i] = null;
          return n2;
        };
      }, 17656: function(t2) {
        t2.exports = function(t3, e2) {
          return { start: { valType: "any", editType: "calc" }, end: { valType: "any", editType: "calc" }, size: { valType: "any", editType: "calc" }, editType: "calc" };
        };
      }, 59575: function(t2, e2, r2) {
        var n2 = r2(92770);
        t2.exports = { count: function(t3, e3, r3) {
          return r3[t3]++, 1;
        }, sum: function(t3, e3, r3, i) {
          var a = i[e3];
          return n2(a) ? (a = Number(a), r3[t3] += a, a) : 0;
        }, avg: function(t3, e3, r3, i, a) {
          var o = i[e3];
          return n2(o) && (o = Number(o), r3[t3] += o, a[t3]++), 0;
        }, min: function(t3, e3, r3, i) {
          var a = i[e3];
          if (n2(a)) {
            if (a = Number(a), !n2(r3[t3]))
              return r3[t3] = a, a;
            if (r3[t3] > a) {
              var o = a - r3[t3];
              return r3[t3] = a, o;
            }
          }
          return 0;
        }, max: function(t3, e3, r3, i) {
          var a = i[e3];
          if (n2(a)) {
            if (a = Number(a), !n2(r3[t3]))
              return r3[t3] = a, a;
            if (r3[t3] < a) {
              var o = a - r3[t3];
              return r3[t3] = a, o;
            }
          }
          return 0;
        } };
      }, 40965: function(t2, e2, r2) {
        var n2 = r2(50606), i = n2.ONEAVGYEAR, a = n2.ONEAVGMONTH, o = n2.ONEDAY, s = n2.ONEHOUR, l = n2.ONEMIN, u = n2.ONESEC, c = r2(89298).tickIncrement;
        function f2(t3, e3, r3, n3) {
          if (t3 * e3 <= 0)
            return 1 / 0;
          for (var i2 = Math.abs(e3 - t3), a2 = "date" === r3.type, o2 = h(i2, a2), s2 = 0; s2 < 10; s2++) {
            var l2 = h(80 * o2, a2);
            if (o2 === l2)
              break;
            if (!p2(l2, t3, e3, a2, r3, n3))
              break;
            o2 = l2;
          }
          return o2;
        }
        function h(t3, e3) {
          return e3 && t3 > u ? t3 > o ? t3 > 1.1 * i ? i : t3 > 1.1 * a ? a : o : t3 > s ? s : t3 > l ? l : u : Math.pow(10, Math.floor(Math.log(t3) / Math.LN10));
        }
        function p2(t3, e3, r3, n3, a2, s2) {
          if (n3 && t3 > o) {
            var l2 = d2(e3, a2, s2), u2 = d2(r3, a2, s2), c2 = t3 === i ? 0 : 1;
            return l2[c2] !== u2[c2];
          }
          return Math.floor(r3 / t3) - Math.floor(e3 / t3) > 0.1;
        }
        function d2(t3, e3, r3) {
          var n3 = e3.c2d(t3, i, r3).split("-");
          return "" === n3[0] && (n3.unshift(), n3[0] = "-" + n3[0]), n3;
        }
        t2.exports = function(t3, e3, r3, n3, a2) {
          var s2, l2, u2 = -1.1 * e3, h2 = -0.1 * e3, p3 = t3 - h2, d3 = r3[0], v = r3[1], g2 = Math.min(f2(d3 + h2, d3 + p3, n3, a2), f2(v + h2, v + p3, n3, a2)), y = Math.min(f2(d3 + u2, d3 + h2, n3, a2), f2(v + u2, v + h2, n3, a2));
          if (g2 > y && y < Math.abs(v - d3) / 4e3 ? (s2 = g2, l2 = false) : (s2 = Math.min(g2, y), l2 = true), "date" === n3.type && s2 > o) {
            var m2 = s2 === i ? 1 : 6, x = s2 === i ? "M12" : "M1";
            return function(e4, r4) {
              var o2 = n3.c2d(e4, i, a2), s3 = o2.indexOf("-", m2);
              s3 > 0 && (o2 = o2.substr(0, s3));
              var u3 = n3.d2c(o2, 0, a2);
              if (u3 < e4) {
                var f3 = c(u3, x, false, a2);
                (u3 + f3) / 2 < e4 + t3 && (u3 = f3);
              }
              return r4 && l2 ? c(u3, x, true, a2) : u3;
            };
          }
          return function(e4, r4) {
            var n4 = s2 * Math.round(e4 / s2);
            return n4 + s2 / 10 < e4 && n4 + 0.9 * s2 < e4 + t3 && (n4 += s2), r4 && l2 && (n4 -= s2), n4;
          };
        };
      }, 72138: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = r2(73972), o = r2(89298), s = r2(75341), l = r2(59575), u = r2(36362), c = r2(42174), f2 = r2(40965);
        function h(t3, e3, r3, s2, l2) {
          var u2, c2, f3, p2, d2, v, g2, y = s2 + "bins", m2 = t3._fullLayout, x = e3["_" + s2 + "bingroup"], b = m2._histogramBinOpts[x], _ = "overlay" === m2.barmode, w2 = function(t4) {
            return r3.r2c(t4, 0, p2);
          }, T = function(t4) {
            return r3.c2r(t4, 0, p2);
          }, k = "date" === r3.type ? function(t4) {
            return t4 || 0 === t4 ? i.cleanDate(t4, null, p2) : null;
          } : function(t4) {
            return n2(t4) ? Number(t4) : null;
          };
          function A(t4, e4, r4) {
            e4[t4 + "Found"] ? (e4[t4] = k(e4[t4]), null === e4[t4] && (e4[t4] = r4[t4])) : (v[t4] = e4[t4] = r4[t4], i.nestedProperty(c2[0], y + "." + t4).set(r4[t4]));
          }
          if (e3["_" + s2 + "autoBinFinished"])
            delete e3["_" + s2 + "autoBinFinished"];
          else {
            c2 = b.traces;
            var M = [], S = true, E = false, L = false;
            for (u2 = 0; u2 < c2.length; u2++)
              if ((f3 = c2[u2]).visible) {
                var C = b.dirs[u2];
                d2 = f3["_" + C + "pos0"] = r3.makeCalcdata(f3, C), M = i.concat(M, d2), delete f3["_" + s2 + "autoBinFinished"], true === e3.visible && (S ? S = false : (delete f3._autoBin, f3["_" + s2 + "autoBinFinished"] = 1), a.traceIs(f3, "2dMap") && (E = true), "histogram2dcontour" === f3.type && (L = true));
              }
            p2 = c2[0][s2 + "calendar"];
            var P = o.autoBin(M, r3, b.nbins, E, p2, b.sizeFound && b.size), O = c2[0]._autoBin = {};
            if (v = O[b.dirs[0]] = {}, L && (b.size || (P.start = T(o.tickIncrement(w2(P.start), P.size, true, p2))), void 0 === b.end && (P.end = T(o.tickIncrement(w2(P.end), P.size, false, p2)))), _ && !a.traceIs(e3, "2dMap") && 0 === P._dataSpan && "category" !== r3.type && "multicategory" !== r3.type) {
              if (l2)
                return [P, d2, true];
              P = function(t4, e4, r4, n3, a2) {
                var o2, s3, l3, u3 = t4._fullLayout, c3 = function(t5, e5) {
                  for (var r5 = e5.xaxis, n4 = e5.yaxis, i2 = e5.orientation, a3 = [], o3 = t5._fullData, s4 = 0; s4 < o3.length; s4++) {
                    var l4 = o3[s4];
                    "histogram" === l4.type && true === l4.visible && l4.orientation === i2 && l4.xaxis === r5 && l4.yaxis === n4 && a3.push(l4);
                  }
                  return a3;
                }(t4, e4), f4 = false, p3 = 1 / 0, d3 = [e4];
                for (o2 = 0; o2 < c3.length; o2++)
                  if ((s3 = c3[o2]) === e4)
                    f4 = true;
                  else if (f4) {
                    var v2 = h(t4, s3, r4, n3, true), g3 = v2[0], y2 = v2[2];
                    s3["_" + n3 + "autoBinFinished"] = 1, s3["_" + n3 + "pos0"] = v2[1], y2 ? d3.push(s3) : p3 = Math.min(p3, g3.size);
                  } else
                    l3 = u3._histogramBinOpts[s3["_" + n3 + "bingroup"]], p3 = Math.min(p3, l3.size || s3[a2].size);
                var m3 = new Array(d3.length);
                for (o2 = 0; o2 < d3.length; o2++)
                  for (var x2 = d3[o2]["_" + n3 + "pos0"], b2 = 0; b2 < x2.length; b2++)
                    if (void 0 !== x2[b2]) {
                      m3[o2] = x2[b2];
                      break;
                    }
                for (isFinite(p3) || (p3 = i.distinctVals(m3).minDiff), o2 = 0; o2 < d3.length; o2++) {
                  var _2 = (s3 = d3[o2])[n3 + "calendar"], w3 = { start: r4.c2r(m3[o2] - p3 / 2, 0, _2), end: r4.c2r(m3[o2] + p3 / 2, 0, _2), size: p3 };
                  s3._input[a2] = s3[a2] = w3, (l3 = u3._histogramBinOpts[s3["_" + n3 + "bingroup"]]) && i.extendFlat(l3, w3);
                }
                return e4[a2];
              }(t3, e3, r3, s2, y);
            }
            (g2 = f3.cumulative || {}).enabled && "include" !== g2.currentbin && ("decreasing" === g2.direction ? P.start = T(o.tickIncrement(w2(P.start), P.size, true, p2)) : P.end = T(o.tickIncrement(w2(P.end), P.size, false, p2))), b.size = P.size, b.sizeFound || (v.size = P.size, i.nestedProperty(c2[0], y + ".size").set(P.size)), A("start", b, P), A("end", b, P);
          }
          d2 = e3["_" + s2 + "pos0"], delete e3["_" + s2 + "pos0"];
          var I = e3._input[y] || {}, D = i.extendFlat({}, b), z = b.start, R = r3.r2l(I.start), F = void 0 !== R;
          if ((b.startFound || F) && R !== r3.r2l(z)) {
            var B = F ? R : i.aggNums(Math.min, null, d2), N = { type: "category" === r3.type || "multicategory" === r3.type ? "linear" : r3.type, r2l: r3.r2l, dtick: b.size, tick0: z, calendar: p2, range: [B, o.tickIncrement(B, b.size, false, p2)].map(r3.l2r) }, j = o.tickFirst(N);
            j > r3.r2l(B) && (j = o.tickIncrement(j, b.size, true, p2)), D.start = r3.l2r(j), F || i.nestedProperty(e3, y + ".start").set(D.start);
          }
          var U = b.end, V = r3.r2l(I.end), H = void 0 !== V;
          if ((b.endFound || H) && V !== r3.r2l(U)) {
            var q2 = H ? V : i.aggNums(Math.max, null, d2);
            D.end = r3.l2r(q2), H || i.nestedProperty(e3, y + ".start").set(D.end);
          }
          var G = "autobin" + s2;
          return false === e3._input[G] && (e3._input[y] = i.extendFlat({}, e3[y] || {}), delete e3._input[G], delete e3[G]), [D, d2];
        }
        t2.exports = { calc: function(t3, e3) {
          var r3, a2, p2, d2, v = [], g2 = [], y = "h" === e3.orientation, m2 = o.getFromId(t3, y ? e3.yaxis : e3.xaxis), x = y ? "y" : "x", b = { x: "y", y: "x" }[x], _ = e3[x + "calendar"], w2 = e3.cumulative, T = h(t3, e3, m2, x), k = T[0], A = T[1], M = "string" == typeof k.size, S = [], E = M ? S : k, L = [], C = [], P = [], O = 0, I = e3.histnorm, D = e3.histfunc, z = -1 !== I.indexOf("density");
          w2.enabled && z && (I = I.replace(/ ?density$/, ""), z = false);
          var R, F = "max" === D || "min" === D ? null : 0, B = l.count, N = u[I], j = false, U = function(t4) {
            return m2.r2c(t4, 0, _);
          };
          for (i.isArrayOrTypedArray(e3[b]) && "count" !== D && (R = e3[b], j = "avg" === D, B = l[D]), r3 = U(k.start), p2 = U(k.end) + (r3 - o.tickIncrement(r3, k.size, false, _)) / 1e6; r3 < p2 && v.length < 1e6 && (a2 = o.tickIncrement(r3, k.size, false, _), v.push((r3 + a2) / 2), g2.push(F), P.push([]), S.push(r3), z && L.push(1 / (a2 - r3)), j && C.push(0), !(a2 <= r3)); )
            r3 = a2;
          S.push(r3), M || "date" !== m2.type || (E = { start: U(E.start), end: U(E.end), size: E.size }), t3._fullLayout._roundFnOpts || (t3._fullLayout._roundFnOpts = {});
          var V = e3["_" + x + "bingroup"], H = { leftGap: 1 / 0, rightGap: 1 / 0 };
          V && (t3._fullLayout._roundFnOpts[V] || (t3._fullLayout._roundFnOpts[V] = H), H = t3._fullLayout._roundFnOpts[V]);
          var q2, G = g2.length, Z = true, Y = H.leftGap, W = H.rightGap, X = {};
          for (r3 = 0; r3 < A.length; r3++) {
            var J = A[r3];
            (d2 = i.findBin(J, E)) >= 0 && d2 < G && (O += B(d2, r3, g2, R, C), Z && P[d2].length && J !== A[P[d2][0]] && (Z = false), P[d2].push(r3), X[r3] = d2, Y = Math.min(Y, J - S[d2]), W = Math.min(W, S[d2 + 1] - J));
          }
          H.leftGap = Y, H.rightGap = W, Z || (q2 = function(e4, r4) {
            return function() {
              var n3 = t3._fullLayout._roundFnOpts[V];
              return f2(n3.leftGap, n3.rightGap, S, m2, _)(e4, r4);
            };
          }), j && (O = c(g2, C)), N && N(g2, O, L), w2.enabled && function(t4, e4, r4) {
            var n3, i2, a3;
            function o2(e5) {
              a3 = t4[e5], t4[e5] /= 2;
            }
            function s2(e5) {
              i2 = t4[e5], t4[e5] = a3 + i2 / 2, a3 += i2;
            }
            if ("half" === r4)
              if ("increasing" === e4)
                for (o2(0), n3 = 1; n3 < t4.length; n3++)
                  s2(n3);
              else
                for (o2(t4.length - 1), n3 = t4.length - 2; n3 >= 0; n3--)
                  s2(n3);
            else if ("increasing" === e4) {
              for (n3 = 1; n3 < t4.length; n3++)
                t4[n3] += t4[n3 - 1];
              "exclude" === r4 && (t4.unshift(0), t4.pop());
            } else {
              for (n3 = t4.length - 2; n3 >= 0; n3--)
                t4[n3] += t4[n3 + 1];
              "exclude" === r4 && (t4.push(0), t4.shift());
            }
          }(g2, w2.direction, w2.currentbin);
          var K = Math.min(v.length, g2.length), $ = [], Q = 0, tt = K - 1;
          for (r3 = 0; r3 < K; r3++)
            if (g2[r3]) {
              Q = r3;
              break;
            }
          for (r3 = K - 1; r3 >= Q; r3--)
            if (g2[r3]) {
              tt = r3;
              break;
            }
          for (r3 = Q; r3 <= tt; r3++)
            if (n2(v[r3]) && n2(g2[r3])) {
              var et = { p: v[r3], s: g2[r3], b: 0 };
              w2.enabled || (et.pts = P[r3], Z ? et.ph0 = et.ph1 = P[r3].length ? A[P[r3][0]] : v[r3] : (e3._computePh = true, et.ph0 = q2(S[r3]), et.ph1 = q2(S[r3 + 1], true))), $.push(et);
            }
          return 1 === $.length && ($[0].width1 = o.tickIncrement($[0].p, k.size, false, _) - $[0].p), s($, e3), i.isArrayOrTypedArray(e3.selectedpoints) && i.tagSelected($, e3, X), $;
        }, calcAllAutoBins: h };
      }, 72406: function(t2) {
        t2.exports = { eventDataKeys: ["binNumber"] };
      }, 82222: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(41675), a = r2(73972).traceIs, o = r2(26125), s = n2.nestedProperty, l = r2(99082).getAxisGroup, u = [{ aStr: { x: "xbins.start", y: "ybins.start" }, name: "start" }, { aStr: { x: "xbins.end", y: "ybins.end" }, name: "end" }, { aStr: { x: "xbins.size", y: "ybins.size" }, name: "size" }, { aStr: { x: "nbinsx", y: "nbinsy" }, name: "nbins" }], c = ["x", "y"];
        t2.exports = function(t3, e3) {
          var r3, f2, h, p2, d2, v, g2, y = e3._histogramBinOpts = {}, m2 = [], x = {}, b = [];
          function _(t4, e4) {
            return n2.coerce(r3._input, r3, r3._module.attributes, t4, e4);
          }
          function w2(t4) {
            return "v" === t4.orientation ? "x" : "y";
          }
          function T(t4, r4, a2) {
            var o2 = t4.uid + "__" + a2;
            r4 || (r4 = o2);
            var s2 = function(t5, r5) {
              return i.getFromTrace({ _fullLayout: e3 }, t5, r5).type;
            }(t4, a2), l2 = t4[a2 + "calendar"] || "", u2 = y[r4], c2 = true;
            u2 && (s2 === u2.axType && l2 === u2.calendar ? (c2 = false, u2.traces.push(t4), u2.dirs.push(a2)) : (r4 = o2, s2 !== u2.axType && n2.warn(["Attempted to group the bins of trace", t4.index, "set on a", "type:" + s2, "axis", "with bins on", "type:" + u2.axType, "axis."].join(" ")), l2 !== u2.calendar && n2.warn(["Attempted to group the bins of trace", t4.index, "set with a", l2, "calendar", "with bins", u2.calendar ? "on a " + u2.calendar + " calendar" : "w/o a set calendar"].join(" ")))), c2 && (y[r4] = { traces: [t4], dirs: [a2], axType: s2, calendar: t4[a2 + "calendar"] || "" }), t4["_" + a2 + "bingroup"] = r4;
          }
          for (d2 = 0; d2 < t3.length; d2++)
            r3 = t3[d2], a(r3, "histogram") && (m2.push(r3), delete r3._xautoBinFinished, delete r3._yautoBinFinished, a(r3, "2dMap") || o(r3._input, r3, e3, _));
          var k = e3._alignmentOpts || {};
          for (d2 = 0; d2 < m2.length; d2++) {
            if (r3 = m2[d2], h = "", !a(r3, "2dMap")) {
              if (p2 = w2(r3), "group" === e3.barmode && r3.alignmentgroup) {
                var A = r3[p2 + "axis"], M = l(e3, A) + r3.orientation;
                (k[M] || {})[r3.alignmentgroup] && (h = M);
              }
              h || "overlay" === e3.barmode || (h = l(e3, r3.xaxis) + l(e3, r3.yaxis) + w2(r3));
            }
            h ? (x[h] || (x[h] = []), x[h].push(r3)) : b.push(r3);
          }
          for (h in x)
            if (1 !== (f2 = x[h]).length) {
              var S = false;
              for (f2.length && (r3 = f2[0], S = _("bingroup")), h = S || h, d2 = 0; d2 < f2.length; d2++) {
                var E = (r3 = f2[d2])._input.bingroup;
                E && E !== h && n2.warn(["Trace", r3.index, "must match", "within bingroup", h + ".", "Ignoring its bingroup:", E, "setting."].join(" ")), r3.bingroup = h, T(r3, h, w2(r3));
              }
            } else
              b.push(f2[0]);
          for (d2 = 0; d2 < b.length; d2++) {
            r3 = b[d2];
            var L = _("bingroup");
            if (a(r3, "2dMap"))
              for (g2 = 0; g2 < 2; g2++) {
                var C = _((p2 = c[g2]) + "bingroup", L ? L + "__" + p2 : null);
                T(r3, C, p2);
              }
            else
              T(r3, L, w2(r3));
          }
          for (h in y) {
            var P = y[h];
            for (f2 = P.traces, v = 0; v < u.length; v++) {
              var O, I, D = u[v], z = D.name;
              if ("nbins" !== z || !P.sizeFound) {
                for (d2 = 0; d2 < f2.length; d2++) {
                  if (r3 = f2[d2], p2 = P.dirs[d2], O = D.aStr[p2], void 0 !== s(r3._input, O).get()) {
                    P[z] = _(O), P[z + "Found"] = true;
                    break;
                  }
                  (I = (r3._autoBin || {})[p2] || {})[z] && s(r3, O).set(I[z]);
                }
                if ("start" === z || "end" === z)
                  for (; d2 < f2.length; d2++)
                    (r3 = f2[d2])["_" + p2 + "bingroup"] && _(O, (I = (r3._autoBin || {})[p2] || {})[z]);
                "nbins" !== z || P.sizeFound || P.nbinsFound || (r3 = f2[0], P[z] = _(O));
              }
            }
          }
        };
      }, 11385: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828), a = r2(7901), o = r2(90769).handleText, s = r2(98340), l = r2(7745);
        t2.exports = function(t3, e3, r3, u) {
          function c(r4, n3) {
            return i.coerce(t3, e3, l, r4, n3);
          }
          var f2 = c("x"), h = c("y");
          c("cumulative.enabled") && (c("cumulative.direction"), c("cumulative.currentbin")), c("text");
          var p2 = c("textposition");
          o(t3, e3, u, c, p2, { moduleHasSelected: true, moduleHasUnselected: true, moduleHasConstrain: true, moduleHasCliponaxis: true, moduleHasTextangle: true, moduleHasInsideanchor: true }), c("hovertext"), c("hovertemplate"), c("xhoverformat"), c("yhoverformat");
          var d2 = c("orientation", h && !f2 ? "h" : "v"), v = "v" === d2 ? "x" : "y", g2 = "v" === d2 ? "y" : "x", y = f2 && h ? Math.min(i.minRowLength(f2) && i.minRowLength(h)) : i.minRowLength(e3[v] || []);
          if (y) {
            e3._length = y, n2.getComponentMethod("calendars", "handleTraceDefaults")(t3, e3, ["x", "y"], u), e3[g2] && c("histfunc"), c("histnorm"), c("autobin" + v), s(t3, e3, c, r3, u), i.coerceSelectionMarkerOpacity(e3, c);
            var m2 = (e3.marker.line || {}).color, x = n2.getComponentMethod("errorbars", "supplyDefaults");
            x(t3, e3, m2 || a.defaultLine, { axis: "y" }), x(t3, e3, m2 || a.defaultLine, { axis: "x", inherit: "y" });
          } else
            e3.visible = false;
        };
      }, 84402: function(t2) {
        t2.exports = function(t3, e2, r2, n2, i) {
          if (t3.x = "xVal" in e2 ? e2.xVal : e2.x, t3.y = "yVal" in e2 ? e2.yVal : e2.y, "zLabelVal" in e2 && (t3.z = e2.zLabelVal), e2.xa && (t3.xaxis = e2.xa), e2.ya && (t3.yaxis = e2.ya), !(r2.cumulative || {}).enabled) {
            var a, o = Array.isArray(i) ? n2[0].pts[i[0]][i[1]] : n2[i].pts;
            if (t3.pointNumbers = o, t3.binNumber = t3.pointNumber, delete t3.pointNumber, delete t3.pointIndex, r2._indexToPoints) {
              a = [];
              for (var s = 0; s < o.length; s++)
                a = a.concat(r2._indexToPoints[o[s]]);
            } else
              a = o;
            t3.pointIndices = a;
          }
          return t3;
        };
      }, 76440: function(t2, e2, r2) {
        var n2 = r2(95423).hoverPoints, i = r2(89298).hoverLabelText;
        t2.exports = function(t3, e3, r3, a, o) {
          var s = n2(t3, e3, r3, a, o);
          if (s) {
            var l = (t3 = s[0]).cd[t3.index], u = t3.cd[0].trace;
            if (!u.cumulative.enabled) {
              var c = "h" === u.orientation ? "y" : "x";
              t3[c + "Label"] = i(t3[c + "a"], [l.ph0, l.ph1], u[c + "hoverformat"]);
            }
            return s;
          }
        };
      }, 36071: function(t2, e2, r2) {
        t2.exports = { attributes: r2(7745), layoutAttributes: r2(43641), supplyDefaults: r2(11385), crossTraceDefaults: r2(82222), supplyLayoutDefaults: r2(13957), calc: r2(72138).calc, crossTraceCalc: r2(11661).crossTraceCalc, plot: r2(17295).plot, layerName: "barlayer", style: r2(16688).style, styleOnSelect: r2(16688).styleOnSelect, colorbar: r2(4898), hoverPoints: r2(76440), selectPoints: r2(81974), eventData: r2(84402), moduleType: "trace", name: "histogram", basePlotModule: r2(93612), categories: ["bar-like", "cartesian", "svg", "bar", "histogram", "oriented", "errorBarsOK", "showLegend"], meta: {} };
      }, 36362: function(t2) {
        t2.exports = { percent: function(t3, e2) {
          for (var r2 = t3.length, n2 = 100 / e2, i = 0; i < r2; i++)
            t3[i] *= n2;
        }, probability: function(t3, e2) {
          for (var r2 = t3.length, n2 = 0; n2 < r2; n2++)
            t3[n2] /= e2;
        }, density: function(t3, e2, r2, n2) {
          var i = t3.length;
          n2 = n2 || 1;
          for (var a = 0; a < i; a++)
            t3[a] *= r2[a] * n2;
        }, "probability density": function(t3, e2, r2, n2) {
          var i = t3.length;
          n2 && (e2 /= n2);
          for (var a = 0; a < i; a++)
            t3[a] *= r2[a] / e2;
        } };
      }, 35361: function(t2, e2, r2) {
        var n2 = r2(7745), i = r2(17656), a = r2(21606), o = r2(9012), s = r2(12663).axisHoverFormat, l = r2(5386).f, u = r2(5386).s, c = r2(50693), f2 = r2(1426).extendFlat;
        t2.exports = f2({ x: n2.x, y: n2.y, z: { valType: "data_array", editType: "calc" }, marker: { color: { valType: "data_array", editType: "calc" }, editType: "calc" }, histnorm: n2.histnorm, histfunc: n2.histfunc, nbinsx: n2.nbinsx, xbins: i("x"), nbinsy: n2.nbinsy, ybins: i("y"), autobinx: n2.autobinx, autobiny: n2.autobiny, bingroup: f2({}, n2.bingroup, {}), xbingroup: f2({}, n2.bingroup, {}), ybingroup: f2({}, n2.bingroup, {}), xgap: a.xgap, ygap: a.ygap, zsmooth: a.zsmooth, xhoverformat: s("x"), yhoverformat: s("y"), zhoverformat: s("z", 1), hovertemplate: l({}, { keys: "z" }), texttemplate: u({ arrayOk: false, editType: "plot" }, { keys: "z" }), textfont: a.textfont, showlegend: f2({}, o.showlegend, { dflt: false }) }, c("", { cLetter: "z", autoColorDflt: false }));
      }, 17562: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298), a = r2(59575), o = r2(36362), s = r2(42174), l = r2(40965), u = r2(72138).calcAllAutoBins;
        function c(t3, e3, r3, n3) {
          var i2, a2 = new Array(t3);
          if (n3)
            for (i2 = 0; i2 < t3; i2++)
              a2[i2] = 1 / (e3[i2 + 1] - e3[i2]);
          else {
            var o2 = 1 / r3;
            for (i2 = 0; i2 < t3; i2++)
              a2[i2] = o2;
          }
          return a2;
        }
        function f2(t3, e3) {
          return { start: t3(e3.start), end: t3(e3.end), size: e3.size };
        }
        function h(t3, e3, r3, n3, i2, a2) {
          var o2, s2 = t3.length - 1, u2 = new Array(s2), c2 = l(r3, n3, t3, i2, a2);
          for (o2 = 0; o2 < s2; o2++) {
            var f3 = (e3 || [])[o2];
            u2[o2] = void 0 === f3 ? [c2(t3[o2]), c2(t3[o2 + 1], true)] : [f3, f3];
          }
          return u2;
        }
        t2.exports = function(t3, e3) {
          var r3, l2, p2, d2, v = i.getFromId(t3, e3.xaxis), g2 = i.getFromId(t3, e3.yaxis), y = e3.xcalendar, m2 = e3.ycalendar, x = function(t4) {
            return v.r2c(t4, 0, y);
          }, b = function(t4) {
            return g2.r2c(t4, 0, m2);
          }, _ = u(t3, e3, v, "x"), w2 = _[0], T = _[1], k = u(t3, e3, g2, "y"), A = k[0], M = k[1], S = e3._length;
          T.length > S && T.splice(S, T.length - S), M.length > S && M.splice(S, M.length - S);
          var E = [], L = [], C = [], P = "string" == typeof w2.size, O = "string" == typeof A.size, I = [], D = [], z = P ? I : w2, R = O ? D : A, F = 0, B = [], N = [], j = e3.histnorm, U = e3.histfunc, V = -1 !== j.indexOf("density"), H = "max" === U || "min" === U ? null : 0, q2 = a.count, G = o[j], Z = false, Y = [], W = [], X = "z" in e3 ? e3.z : "marker" in e3 && Array.isArray(e3.marker.color) ? e3.marker.color : "";
          X && "count" !== U && (Z = "avg" === U, q2 = a[U]);
          var J = w2.size, K = x(w2.start), $ = x(w2.end) + (K - i.tickIncrement(K, J, false, y)) / 1e6;
          for (r3 = K; r3 < $; r3 = i.tickIncrement(r3, J, false, y))
            L.push(H), I.push(r3), Z && C.push(0);
          I.push(r3);
          var Q, tt = L.length, et = (r3 - K) / tt, rt = (Q = K + et / 2, v.c2r(Q, 0, y)), nt = A.size, it = b(A.start), at = b(A.end) + (it - i.tickIncrement(it, nt, false, m2)) / 1e6;
          for (r3 = it; r3 < at; r3 = i.tickIncrement(r3, nt, false, m2)) {
            E.push(L.slice()), D.push(r3);
            var ot = new Array(tt);
            for (l2 = 0; l2 < tt; l2++)
              ot[l2] = [];
            N.push(ot), Z && B.push(C.slice());
          }
          D.push(r3);
          var st = E.length, lt = (r3 - it) / st, ut = function(t4) {
            return g2.c2r(t4, 0, m2);
          }(it + lt / 2);
          V && (Y = c(L.length, z, et, P), W = c(E.length, R, lt, O)), P || "date" !== v.type || (z = f2(x, z)), O || "date" !== g2.type || (R = f2(b, R));
          var ct = true, ft = true, ht = new Array(tt), pt = new Array(st), dt = 1 / 0, vt = 1 / 0, gt = 1 / 0, yt = 1 / 0;
          for (r3 = 0; r3 < S; r3++) {
            var mt = T[r3], xt = M[r3];
            p2 = n2.findBin(mt, z), d2 = n2.findBin(xt, R), p2 >= 0 && p2 < tt && d2 >= 0 && d2 < st && (F += q2(p2, r3, E[d2], X, B[d2]), N[d2][p2].push(r3), ct && (void 0 === ht[p2] ? ht[p2] = mt : ht[p2] !== mt && (ct = false)), ft && (void 0 === pt[d2] ? pt[d2] = xt : pt[d2] !== xt && (ft = false)), dt = Math.min(dt, mt - I[p2]), vt = Math.min(vt, I[p2 + 1] - mt), gt = Math.min(gt, xt - D[d2]), yt = Math.min(yt, D[d2 + 1] - xt));
          }
          if (Z)
            for (d2 = 0; d2 < st; d2++)
              F += s(E[d2], B[d2]);
          if (G)
            for (d2 = 0; d2 < st; d2++)
              G(E[d2], F, Y, W[d2]);
          return { x: T, xRanges: h(I, ct && ht, dt, vt, v, y), x0: rt, dx: et, y: M, yRanges: h(D, ft && pt, gt, yt, g2, m2), y0: ut, dy: lt, z: E, pts: N };
        };
      }, 93888: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(75238), a = r2(49901), o = r2(1586), s = r2(58623), l = r2(35361);
        t2.exports = function(t3, e3, r3, u) {
          function c(r4, i2) {
            return n2.coerce(t3, e3, l, r4, i2);
          }
          i(t3, e3, c, u), false !== e3.visible && (a(t3, e3, c, u), o(t3, e3, u, c, { prefix: "", cLetter: "z" }), c("hovertemplate"), s(c, u), c("xhoverformat"), c("yhoverformat"));
        };
      }, 76128: function(t2, e2, r2) {
        var n2 = r2(46248), i = r2(89298).hoverLabelText;
        t2.exports = function(t3, e3, r3, a, o) {
          var s = n2(t3, e3, r3, a, o);
          if (s) {
            var l = (t3 = s[0]).index, u = l[0], c = l[1], f2 = t3.cd[0], h = f2.trace, p2 = f2.xRanges[c], d2 = f2.yRanges[u];
            return t3.xLabel = i(t3.xa, [p2[0], p2[1]], h.xhoverformat), t3.yLabel = i(t3.ya, [d2[0], d2[1]], h.yhoverformat), s;
          }
        };
      }, 43905: function(t2, e2, r2) {
        t2.exports = { attributes: r2(35361), supplyDefaults: r2(93888), crossTraceDefaults: r2(82222), calc: r2(90757), plot: r2(50347), layerName: "heatmaplayer", colorbar: r2(61243), style: r2(70035), hoverPoints: r2(76128), eventData: r2(84402), moduleType: "trace", name: "histogram2d", basePlotModule: r2(93612), categories: ["cartesian", "svg", "2dMap", "histogram", "showLegend"], meta: {} };
      }, 75238: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828);
        t2.exports = function(t3, e3, r3, a) {
          var o = r3("x"), s = r3("y"), l = i.minRowLength(o), u = i.minRowLength(s);
          l && u ? (e3._length = Math.min(l, u), n2.getComponentMethod("calendars", "handleTraceDefaults")(t3, e3, ["x", "y"], a), (r3("z") || r3("marker.color")) && r3("histfunc"), r3("histnorm"), r3("autobinx"), r3("autobiny")) : e3.visible = false;
        };
      }, 99066: function(t2, e2, r2) {
        var n2 = r2(35361), i = r2(70600), a = r2(50693), o = r2(12663).axisHoverFormat, s = r2(1426).extendFlat;
        t2.exports = s({ x: n2.x, y: n2.y, z: n2.z, marker: n2.marker, histnorm: n2.histnorm, histfunc: n2.histfunc, nbinsx: n2.nbinsx, xbins: n2.xbins, nbinsy: n2.nbinsy, ybins: n2.ybins, autobinx: n2.autobinx, autobiny: n2.autobiny, bingroup: n2.bingroup, xbingroup: n2.xbingroup, ybingroup: n2.ybingroup, autocontour: i.autocontour, ncontours: i.ncontours, contours: i.contours, line: { color: i.line.color, width: s({}, i.line.width, { dflt: 0.5 }), dash: i.line.dash, smoothing: i.line.smoothing, editType: "plot" }, xhoverformat: o("x"), yhoverformat: o("y"), zhoverformat: o("z", 1), hovertemplate: n2.hovertemplate, texttemplate: i.texttemplate, textfont: i.textfont }, a("", { cLetter: "z", editTypeOverride: "calc" }));
      }, 62654: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(75238), a = r2(67217), o = r2(8724), s = r2(58623), l = r2(99066);
        t2.exports = function(t3, e3, r3, u) {
          function c(r4, i2) {
            return n2.coerce(t3, e3, l, r4, i2);
          }
          i(t3, e3, c, u), false !== e3.visible && (a(t3, e3, c, function(r4) {
            return n2.coerce2(t3, e3, l, r4);
          }), o(t3, e3, c, u), c("xhoverformat"), c("yhoverformat"), c("hovertemplate"), e3.contours && "heatmap" === e3.contours.coloring && s(c, u));
        };
      }, 35902: function(t2, e2, r2) {
        t2.exports = { attributes: r2(99066), supplyDefaults: r2(62654), crossTraceDefaults: r2(82222), calc: r2(27529), plot: r2(29854).plot, layerName: "contourlayer", style: r2(84426), colorbar: r2(90654), hoverPoints: r2(52421), moduleType: "trace", name: "histogram2dcontour", basePlotModule: r2(93612), categories: ["cartesian", "svg", "2dMap", "contour", "histogram", "showLegend"], meta: {} };
      }, 46291: function(t2, e2, r2) {
        var n2 = r2(5386).f, i = r2(5386).s, a = r2(50693), o = r2(27670).Y, s = r2(34e3), l = r2(57564), u = r2(45802), c = r2(43473), f2 = r2(1426).extendFlat;
        t2.exports = { labels: l.labels, parents: l.parents, values: l.values, branchvalues: l.branchvalues, count: l.count, level: l.level, maxdepth: l.maxdepth, tiling: { orientation: { valType: "enumerated", values: ["v", "h"], dflt: "h", editType: "plot" }, flip: u.tiling.flip, pad: { valType: "number", min: 0, dflt: 0, editType: "plot" }, editType: "calc" }, marker: f2({ colors: l.marker.colors, line: l.marker.line, editType: "calc" }, a("marker", { colorAttr: "colors", anim: false })), leaf: l.leaf, pathbar: u.pathbar, text: s.text, textinfo: l.textinfo, texttemplate: i({ editType: "plot" }, { keys: c.eventDataKeys.concat(["label", "value"]) }), hovertext: s.hovertext, hoverinfo: l.hoverinfo, hovertemplate: n2({}, { keys: c.eventDataKeys }), textfont: s.textfont, insidetextfont: s.insidetextfont, outsidetextfont: u.outsidetextfont, textposition: u.textposition, sort: s.sort, root: l.root, domain: o({ name: "icicle", trace: true, editType: "calc" }) };
      }, 96346: function(t2, e2, r2) {
        var n2 = r2(74875);
        e2.name = "icicle", e2.plot = function(t3, r3, i, a) {
          n2.plotBasePlot(e2.name, t3, r3, i, a);
        }, e2.clean = function(t3, r3, i, a) {
          n2.cleanBasePlot(e2.name, t3, r3, i, a);
        };
      }, 46584: function(t2, e2, r2) {
        var n2 = r2(52147);
        e2.y = function(t3, e3) {
          return n2.calc(t3, e3);
        }, e2.T = function(t3) {
          return n2._runCrossTraceCalc("icicle", t3);
        };
      }, 56524: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(46291), a = r2(7901), o = r2(27670).c, s = r2(90769).handleText, l = r2(97313).TEXTPAD, u = r2(21081), c = u.hasColorscale, f2 = u.handleDefaults;
        t2.exports = function(t3, e3, r3, u2) {
          function h(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          var p2 = h("labels"), d2 = h("parents");
          if (p2 && p2.length && d2 && d2.length) {
            var v = h("values");
            v && v.length ? h("branchvalues") : h("count"), h("level"), h("maxdepth"), h("tiling.orientation"), h("tiling.flip"), h("tiling.pad");
            var g2 = h("text");
            h("texttemplate"), e3.texttemplate || h("textinfo", Array.isArray(g2) ? "text+label" : "label"), h("hovertext"), h("hovertemplate");
            var y = h("pathbar.visible");
            s(t3, e3, u2, h, "auto", { hasPathbar: y, moduleHasSelected: false, moduleHasUnselected: false, moduleHasConstrain: false, moduleHasCliponaxis: false, moduleHasTextangle: false, moduleHasInsideanchor: false }), h("textposition"), h("marker.line.width") && h("marker.line.color", u2.paper_bgcolor), h("marker.colors");
            var m2 = e3._hasColorscale = c(t3, "marker", "colors") || (t3.marker || {}).coloraxis;
            m2 && f2(t3, e3, u2, h, { prefix: "marker.", cLetter: "c" }), h("leaf.opacity", m2 ? 1 : 0.7), e3._hovered = { marker: { line: { width: 2, color: a.contrast(u2.paper_bgcolor) } } }, y && (h("pathbar.thickness", e3.pathbar.textfont.size + 2 * l), h("pathbar.side"), h("pathbar.edgeshape")), h("sort"), h("root.color"), o(e3, u2, h), e3._length = null;
          } else
            e3.visible = false;
        };
      }, 90666: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(91424), o = r2(63893), s = r2(21538), l = r2(82454).styleOne, u = r2(43473), c = r2(2791), f2 = r2(83523), h = r2(24714).formatSliceLabel, p2 = false;
        t2.exports = function(t3, e3, r3, d2, v) {
          var g2 = v.width, y = v.height, m2 = v.viewX, x = v.viewY, b = v.pathSlice, _ = v.toMoveInsideSlice, w2 = v.strTransform, T = v.hasTransition, k = v.handleSlicesExit, A = v.makeUpdateSliceInterpolator, M = v.makeUpdateTextInterpolator, S = v.prevEntry, E = t3._context.staticPlot, L = t3._fullLayout, C = e3[0].trace, P = -1 !== C.textposition.indexOf("left"), O = -1 !== C.textposition.indexOf("right"), I = -1 !== C.textposition.indexOf("bottom"), D = s(r3, [g2, y], { flipX: C.tiling.flip.indexOf("x") > -1, flipY: C.tiling.flip.indexOf("y") > -1, orientation: C.tiling.orientation, pad: { inner: C.tiling.pad }, maxDepth: C._maxDepth }).descendants(), z = 1 / 0, R = -1 / 0;
          D.forEach(function(t4) {
            var e4 = t4.depth;
            e4 >= C._maxDepth ? (t4.x0 = t4.x1 = (t4.x0 + t4.x1) / 2, t4.y0 = t4.y1 = (t4.y0 + t4.y1) / 2) : (z = Math.min(z, e4), R = Math.max(R, e4));
          }), d2 = d2.data(D, c.getPtId), C._maxVisibleLayers = isFinite(R) ? R - z + 1 : 0, d2.enter().append("g").classed("slice", true), k(d2, p2, {}, [g2, y], b), d2.order();
          var F = null;
          if (T && S) {
            var B = c.getPtId(S);
            d2.each(function(t4) {
              null === F && c.getPtId(t4) === B && (F = { x0: t4.x0, x1: t4.x1, y0: t4.y0, y1: t4.y1 });
            });
          }
          var N = function() {
            return F || { x0: 0, x1: g2, y0: 0, y1: y };
          }, j = d2;
          return T && (j = j.transition().each("end", function() {
            var e4 = n2.select(this);
            c.setSliceCursor(e4, t3, { hideOnRoot: true, hideOnLeaves: false, isTransitioning: false });
          })), j.each(function(s2) {
            s2._x0 = m2(s2.x0), s2._x1 = m2(s2.x1), s2._y0 = x(s2.y0), s2._y1 = x(s2.y1), s2._hoverX = m2(s2.x1 - C.tiling.pad), s2._hoverY = x(I ? s2.y1 - C.tiling.pad / 2 : s2.y0 + C.tiling.pad / 2);
            var d3 = n2.select(this), v2 = i.ensureSingle(d3, "path", "surface", function(t4) {
              t4.style("pointer-events", E ? "none" : "all");
            });
            T ? v2.transition().attrTween("d", function(t4) {
              var e4 = A(t4, p2, N(), [g2, y], { orientation: C.tiling.orientation, flipX: C.tiling.flip.indexOf("x") > -1, flipY: C.tiling.flip.indexOf("y") > -1 });
              return function(t5) {
                return b(e4(t5));
              };
            }) : v2.attr("d", b), d3.call(f2, r3, t3, e3, { styleOne: l, eventDataKeys: u.eventDataKeys, transitionTime: u.CLICK_TRANSITION_TIME, transitionEasing: u.CLICK_TRANSITION_EASING }).call(c.setSliceCursor, t3, { isTransitioning: t3._transitioning }), v2.call(l, s2, C, { hovered: false }), s2.x0 === s2.x1 || s2.y0 === s2.y1 ? s2._text = "" : s2._text = h(s2, r3, C, e3, L) || "";
            var k2 = i.ensureSingle(d3, "g", "slicetext"), S2 = i.ensureSingle(k2, "text", "", function(t4) {
              t4.attr("data-notex", 1);
            }), D2 = i.ensureUniformFontSize(t3, c.determineTextFont(C, s2, L.font));
            S2.text(s2._text || " ").classed("slicetext", true).attr("text-anchor", O ? "end" : P ? "start" : "middle").call(a.font, D2).call(o.convertToTspans, t3), s2.textBB = a.bBox(S2.node()), s2.transform = _(s2, { fontSize: D2.size }), s2.transform.fontSize = D2.size, T ? S2.transition().attrTween("transform", function(t4) {
              var e4 = M(t4, p2, N(), [g2, y]);
              return function(t5) {
                return w2(e4(t5));
              };
            }) : S2.attr("transform", w2(s2));
          }), F;
        };
      }, 69816: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "icicle", basePlotModule: r2(96346), categories: [], animatable: true, attributes: r2(46291), layoutAttributes: r2(92894), supplyDefaults: r2(56524), supplyLayoutDefaults: r2(21070), calc: r2(46584).y, crossTraceCalc: r2(46584).T, plot: r2(85596), style: r2(82454).style, colorbar: r2(4898), meta: {} };
      }, 92894: function(t2) {
        t2.exports = { iciclecolorway: { valType: "colorlist", editType: "calc" }, extendiciclecolors: { valType: "boolean", dflt: true, editType: "calc" } };
      }, 21070: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(92894);
        t2.exports = function(t3, e3) {
          function r3(r4, a) {
            return n2.coerce(t3, e3, i, r4, a);
          }
          r3("iciclecolorway", e3.colorway), r3("extendiciclecolors");
        };
      }, 21538: function(t2, e2, r2) {
        var n2 = r2(674), i = r2(14102);
        t2.exports = function(t3, e3, r3) {
          var a = r3.flipX, o = r3.flipY, s = "h" === r3.orientation, l = r3.maxDepth, u = e3[0], c = e3[1];
          l && (u = (t3.height + 1) * e3[0] / Math.min(t3.height + 1, l), c = (t3.height + 1) * e3[1] / Math.min(t3.height + 1, l));
          var f2 = n2.partition().padding(r3.pad.inner).size(s ? [e3[1], u] : [e3[0], c])(t3);
          return (s || a || o) && i(f2, e3, { swapXY: s, flipX: a, flipY: o }), f2;
        };
      }, 85596: function(t2, e2, r2) {
        var n2 = r2(80694), i = r2(90666);
        t2.exports = function(t3, e3, r3, a) {
          return n2(t3, e3, r3, a, { type: "icicle", drawDescendants: i });
        };
      }, 82454: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(7901), a = r2(71828), o = r2(72597).resizeText;
        function s(t3, e3, r3) {
          var n3 = e3.data.data, o2 = !e3.children, s2 = n3.i, l = a.castOption(r3, s2, "marker.line.color") || i.defaultLine, u = a.castOption(r3, s2, "marker.line.width") || 0;
          t3.style("stroke-width", u).call(i.fill, n3.color).call(i.stroke, l).style("opacity", o2 ? r3.leaf.opacity : null);
        }
        t2.exports = { style: function(t3) {
          var e3 = t3._fullLayout._iciclelayer.selectAll(".trace");
          o(t3, e3, "icicle"), e3.each(function(t4) {
            var e4 = n2.select(this), r3 = t4[0].trace;
            e4.style("opacity", r3.opacity), e4.selectAll("path.surface").each(function(t5) {
              n2.select(this).call(s, t5, r3);
            });
          });
        }, styleOne: s };
      }, 17230: function(t2, e2, r2) {
        for (var n2 = r2(9012), i = r2(5386).f, a = r2(1426).extendFlat, o = r2(51877).colormodel, s = ["rgb", "rgba", "rgba256", "hsl", "hsla"], l = [], u = [], c = 0; c < s.length; c++) {
          var f2 = o[s[c]];
          l.push("For the `" + s[c] + "` colormodel, it is [" + (f2.zminDflt || f2.min).join(", ") + "]."), u.push("For the `" + s[c] + "` colormodel, it is [" + (f2.zmaxDflt || f2.max).join(", ") + "].");
        }
        t2.exports = a({ source: { valType: "string", editType: "calc" }, z: { valType: "data_array", editType: "calc" }, colormodel: { valType: "enumerated", values: s, editType: "calc" }, zsmooth: { valType: "enumerated", values: ["fast", false], dflt: false, editType: "plot" }, zmin: { valType: "info_array", items: [{ valType: "number", editType: "calc" }, { valType: "number", editType: "calc" }, { valType: "number", editType: "calc" }, { valType: "number", editType: "calc" }], editType: "calc" }, zmax: { valType: "info_array", items: [{ valType: "number", editType: "calc" }, { valType: "number", editType: "calc" }, { valType: "number", editType: "calc" }, { valType: "number", editType: "calc" }], editType: "calc" }, x0: { valType: "any", dflt: 0, editType: "calc+clearAxisTypes" }, y0: { valType: "any", dflt: 0, editType: "calc+clearAxisTypes" }, dx: { valType: "number", dflt: 1, editType: "calc" }, dy: { valType: "number", dflt: 1, editType: "calc" }, text: { valType: "data_array", editType: "plot" }, hovertext: { valType: "data_array", editType: "plot" }, hoverinfo: a({}, n2.hoverinfo, { flags: ["x", "y", "z", "color", "name", "text"], dflt: "x+y+z+text+name" }), hovertemplate: i({}, { keys: ["z", "color", "colormodel"] }), transforms: void 0 });
      }, 71113: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(51877), a = r2(92770), o = r2(89298), s = r2(71828).maxRowLength, l = r2(67395).A;
        function u(t3, e3, r3, i2) {
          return function(a2) {
            return n2.constrain((a2 - t3) * e3, r3, i2);
          };
        }
        function c(t3, e3) {
          return function(r3) {
            return n2.constrain(r3, t3, e3);
          };
        }
        t2.exports = function(t3, e3) {
          var r3, n3;
          if (e3._hasZ)
            r3 = e3.z.length, n3 = s(e3.z);
          else if (e3._hasSource) {
            var f2 = l(e3.source);
            r3 = f2.height, n3 = f2.width;
          }
          var h, p2 = o.getFromId(t3, e3.xaxis || "x"), d2 = o.getFromId(t3, e3.yaxis || "y"), v = p2.d2c(e3.x0) - e3.dx / 2, g2 = d2.d2c(e3.y0) - e3.dy / 2, y = [v, v + n3 * e3.dx], m2 = [g2, g2 + r3 * e3.dy];
          if (p2 && "log" === p2.type)
            for (h = 0; h < n3; h++)
              y.push(v + h * e3.dx);
          if (d2 && "log" === d2.type)
            for (h = 0; h < r3; h++)
              m2.push(g2 + h * e3.dy);
          return e3._extremes[p2._id] = o.findExtremes(p2, y), e3._extremes[d2._id] = o.findExtremes(d2, m2), e3._scaler = function(t4) {
            var e4 = i.colormodel[t4.colormodel], r4 = (e4.colormodel || t4.colormodel).length;
            t4._sArray = [];
            for (var n4 = 0; n4 < r4; n4++)
              e4.min[n4] !== t4.zmin[n4] || e4.max[n4] !== t4.zmax[n4] ? t4._sArray.push(u(t4.zmin[n4], (e4.max[n4] - e4.min[n4]) / (t4.zmax[n4] - t4.zmin[n4]), e4.min[n4], e4.max[n4])) : t4._sArray.push(c(e4.min[n4], e4.max[n4]));
            return function(e5) {
              for (var n5 = e5.slice(0, r4), i2 = 0; i2 < r4; i2++) {
                var o2 = n5[i2];
                if (!a(o2))
                  return false;
                n5[i2] = t4._sArray[i2](o2);
              }
              return n5;
            };
          }(e3), [{ x0: v, y0: g2, z: e3.z, w: n3, h: r3 }];
        };
      }, 51877: function(t2) {
        t2.exports = { colormodel: { rgb: { min: [0, 0, 0], max: [255, 255, 255], fmt: function(t3) {
          return t3.slice(0, 3);
        }, suffix: ["", "", ""] }, rgba: { min: [0, 0, 0, 0], max: [255, 255, 255, 1], fmt: function(t3) {
          return t3.slice(0, 4);
        }, suffix: ["", "", "", ""] }, rgba256: { colormodel: "rgba", zminDflt: [0, 0, 0, 0], zmaxDflt: [255, 255, 255, 255], min: [0, 0, 0, 0], max: [255, 255, 255, 1], fmt: function(t3) {
          return t3.slice(0, 4);
        }, suffix: ["", "", "", ""] }, hsl: { min: [0, 0, 0], max: [360, 100, 100], fmt: function(t3) {
          var e2 = t3.slice(0, 3);
          return e2[1] = e2[1] + "%", e2[2] = e2[2] + "%", e2;
        }, suffix: ["°", "%", "%"] }, hsla: { min: [0, 0, 0, 0], max: [360, 100, 100, 1], fmt: function(t3) {
          var e2 = t3.slice(0, 4);
          return e2[1] = e2[1] + "%", e2[2] = e2[2] + "%", e2;
        }, suffix: ["°", "%", "%", ""] } }, pixelatedStyle: ["image-rendering: optimizeSpeed", "image-rendering: -moz-crisp-edges", "image-rendering: -o-crisp-edges", "image-rendering: -webkit-optimize-contrast", "image-rendering: optimize-contrast", "image-rendering: crisp-edges", "image-rendering: pixelated", ""].join("; ") };
      }, 13245: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(17230), a = r2(51877), o = r2(25095).IMAGE_URL_PREFIX;
        t2.exports = function(t3, e3) {
          function r3(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          r3("source"), e3.source && !e3.source.match(o) && delete e3.source, e3._hasSource = !!e3.source;
          var s, l = r3("z");
          e3._hasZ = !(void 0 === l || !l.length || !l[0] || !l[0].length), e3._hasZ || e3._hasSource ? (r3("x0"), r3("y0"), r3("dx"), r3("dy"), e3._hasZ ? (r3("colormodel", "rgb"), r3("zmin", (s = a.colormodel[e3.colormodel]).zminDflt || s.min), r3("zmax", s.zmaxDflt || s.max)) : e3._hasSource && (e3.colormodel = "rgba256", s = a.colormodel[e3.colormodel], e3.zmin = s.zminDflt, e3.zmax = s.zmaxDflt), r3("zsmooth"), r3("text"), r3("hovertext"), r3("hovertemplate"), e3._length = null) : e3.visible = false;
        };
      }, 30835: function(t2) {
        t2.exports = function(t3, e2) {
          return "xVal" in e2 && (t3.x = e2.xVal), "yVal" in e2 && (t3.y = e2.yVal), e2.xa && (t3.xaxis = e2.xa), e2.ya && (t3.yaxis = e2.ya), t3.color = e2.color, t3.colormodel = e2.trace.colormodel, t3.z || (t3.z = e2.color), t3;
        };
      }, 67395: function(t2, e2, r2) {
        var n2 = r2(33575), i = r2(25095).IMAGE_URL_PREFIX, a = r2(12856).Buffer;
        e2.A = function(t3) {
          var e3 = t3.replace(i, ""), r3 = new a(e3, "base64");
          return n2(r3);
        };
      }, 28749: function(t2, e2, r2) {
        var n2 = r2(30211), i = r2(71828), a = r2(51877);
        t2.exports = function(t3, e3, r3) {
          var o = t3.cd[0], s = o.trace, l = t3.xa, u = t3.ya;
          if (!(n2.inbox(e3 - o.x0, e3 - (o.x0 + o.w * s.dx), 0) > 0 || n2.inbox(r3 - o.y0, r3 - (o.y0 + o.h * s.dy), 0) > 0)) {
            var c, f2 = Math.floor((e3 - o.x0) / s.dx), h = Math.floor(Math.abs(r3 - o.y0) / s.dy);
            if (s._hasZ ? c = o.z[h][f2] : s._hasSource && (c = s._canvas.el.getContext("2d", { willReadFrequently: true }).getImageData(f2, h, 1, 1).data), c) {
              var p2, d2 = o.hi || s.hoverinfo;
              if (d2) {
                var v = d2.split("+");
                -1 !== v.indexOf("all") && (v = ["color"]), -1 !== v.indexOf("color") && (p2 = true);
              }
              var g2, y = a.colormodel[s.colormodel], m2 = y.colormodel || s.colormodel, x = m2.length, b = s._scaler(c), _ = y.suffix, w2 = [];
              (s.hovertemplate || p2) && (w2.push("[" + [b[0] + _[0], b[1] + _[1], b[2] + _[2]].join(", ")), 4 === x && w2.push(", " + b[3] + _[3]), w2.push("]"), w2 = w2.join(""), t3.extraText = m2.toUpperCase() + ": " + w2), Array.isArray(s.hovertext) && Array.isArray(s.hovertext[h]) ? g2 = s.hovertext[h][f2] : Array.isArray(s.text) && Array.isArray(s.text[h]) && (g2 = s.text[h][f2]);
              var T = u.c2p(o.y0 + (h + 0.5) * s.dy), k = o.x0 + (f2 + 0.5) * s.dx, A = o.y0 + (h + 0.5) * s.dy, M = "[" + c.slice(0, s.colormodel.length).join(", ") + "]";
              return [i.extendFlat(t3, { index: [h, f2], x0: l.c2p(o.x0 + f2 * s.dx), x1: l.c2p(o.x0 + (f2 + 1) * s.dx), y0: T, y1: T, color: b, xVal: k, xLabelVal: k, yVal: A, yLabelVal: A, zLabelVal: M, text: g2, hovertemplateLabels: { zLabel: M, colorLabel: w2, "color[0]Label": b[0] + _[0], "color[1]Label": b[1] + _[1], "color[2]Label": b[2] + _[2], "color[3]Label": b[3] + _[3] } })];
            }
          }
        };
      }, 94507: function(t2, e2, r2) {
        t2.exports = { attributes: r2(17230), supplyDefaults: r2(13245), calc: r2(71113), plot: r2(60775), style: r2(12826), hoverPoints: r2(28749), eventData: r2(30835), moduleType: "trace", name: "image", basePlotModule: r2(93612), categories: ["cartesian", "svg", "2dMap", "noSortingByValue"], animatable: false, meta: {} };
      }, 60775: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = i.strTranslate, o = r2(77922), s = r2(51877), l = i.isIOS() || i.isSafari() || i.isIE();
        t2.exports = function(t3, e3, r3, u) {
          var c = e3.xaxis, f2 = e3.yaxis, h = !(l || t3._context._exportedPlot);
          i.makeTraceGroups(u, r3, "im").each(function(e4) {
            var r4 = n2.select(this), l2 = e4[0], u2 = l2.trace, p2 = ("fast" === u2.zsmooth || false === u2.zsmooth && h) && !u2._hasZ && u2._hasSource && "linear" === c.type && "linear" === f2.type;
            u2._realImage = p2;
            var d2, v, g2, y, m2, x, b = l2.z, _ = l2.x0, w2 = l2.y0, T = l2.w, k = l2.h, A = u2.dx, M = u2.dy;
            for (x = 0; void 0 === d2 && x < T; )
              d2 = c.c2p(_ + x * A), x++;
            for (x = T; void 0 === v && x > 0; )
              v = c.c2p(_ + x * A), x--;
            for (x = 0; void 0 === y && x < k; )
              y = f2.c2p(w2 + x * M), x++;
            for (x = k; void 0 === m2 && x > 0; )
              m2 = f2.c2p(w2 + x * M), x--;
            v < d2 && (g2 = v, v = d2, d2 = g2), m2 < y && (g2 = y, y = m2, m2 = g2), p2 || (d2 = Math.max(-0.5 * c._length, d2), v = Math.min(1.5 * c._length, v), y = Math.max(-0.5 * f2._length, y), m2 = Math.min(1.5 * f2._length, m2));
            var S = Math.round(v - d2), E = Math.round(m2 - y);
            if (S <= 0 || E <= 0)
              r4.selectAll("image").data([]).exit().remove();
            else {
              var L = r4.selectAll("image").data([e4]);
              L.enter().append("svg:image").attr({ xmlns: o.svg, preserveAspectRatio: "none" }), L.exit().remove();
              var C = false === u2.zsmooth ? s.pixelatedStyle : "";
              if (p2) {
                var P = i.simpleMap(c.range, c.r2l), O = i.simpleMap(f2.range, f2.r2l), I = P[1] < P[0], D = O[1] > O[0];
                if (I || D) {
                  var z = d2 + S / 2, R = y + E / 2;
                  C += "transform:" + a(z + "px", R + "px") + "scale(" + (I ? -1 : 1) + "," + (D ? -1 : 1) + ")" + a(-z + "px", -R + "px") + ";";
                }
              }
              L.attr("style", C);
              var F = new Promise(function(t4) {
                if (u2._hasZ)
                  t4();
                else if (u2._hasSource)
                  if (u2._canvas && u2._canvas.el.width === T && u2._canvas.el.height === k && u2._canvas.source === u2.source)
                    t4();
                  else {
                    var e5 = document.createElement("canvas");
                    e5.width = T, e5.height = k;
                    var r5 = e5.getContext("2d", { willReadFrequently: true });
                    u2._image = u2._image || new Image();
                    var n3 = u2._image;
                    n3.onload = function() {
                      r5.drawImage(n3, 0, 0), u2._canvas = { el: e5, source: u2.source }, t4();
                    }, n3.setAttribute("src", u2.source);
                  }
              }).then(function() {
                var t4, e5;
                if (u2._hasZ)
                  e5 = B(function(t5, e6) {
                    return b[e6][t5];
                  }), t4 = e5.toDataURL("image/png");
                else if (u2._hasSource)
                  if (p2)
                    t4 = u2.source;
                  else {
                    var r5 = u2._canvas.el.getContext("2d", { willReadFrequently: true }).getImageData(0, 0, T, k).data;
                    e5 = B(function(t5, e6) {
                      var n3 = 4 * (e6 * T + t5);
                      return [r5[n3], r5[n3 + 1], r5[n3 + 2], r5[n3 + 3]];
                    }), t4 = e5.toDataURL("image/png");
                  }
                L.attr({ "xlink:href": t4, height: E, width: S, x: d2, y });
              });
              t3._promises.push(F);
            }
            function B(t4) {
              var e5 = document.createElement("canvas");
              e5.width = S, e5.height = E;
              var r5, n3 = e5.getContext("2d", { willReadFrequently: true }), a2 = function(t5) {
                return i.constrain(Math.round(c.c2p(_ + t5 * A) - d2), 0, S);
              }, o2 = function(t5) {
                return i.constrain(Math.round(f2.c2p(w2 + t5 * M) - y), 0, E);
              }, h2 = s.colormodel[u2.colormodel], p3 = h2.colormodel || u2.colormodel, v2 = h2.fmt;
              for (x = 0; x < l2.w; x++) {
                var g3 = a2(x), m3 = a2(x + 1);
                if (m3 !== g3 && !isNaN(m3) && !isNaN(g3))
                  for (var b2 = 0; b2 < l2.h; b2++) {
                    var T2 = o2(b2), k2 = o2(b2 + 1);
                    k2 === T2 || isNaN(k2) || isNaN(T2) || !t4(x, b2) || (r5 = u2._scaler(t4(x, b2)), n3.fillStyle = r5 ? p3 + "(" + v2(r5).join(",") + ")" : "rgba(0,0,0,0)", n3.fillRect(g3, T2, m3 - g3, k2 - T2));
                  }
              }
              return e5;
            }
          });
        };
      }, 12826: function(t2, e2, r2) {
        var n2 = r2(39898);
        t2.exports = function(t3) {
          n2.select(t3).selectAll(".im image").style("opacity", function(t4) {
            return t4[0].trace.opacity;
          });
        };
      }, 54846: function(t2, e2, r2) {
        var n2 = r2(1426).extendFlat, i = r2(1426).extendDeep, a = r2(30962).overrideAll, o = r2(41940), s = r2(22399), l = r2(27670).Y, u = r2(13838), c = r2(44467).templatedArray, f2 = r2(22372), h = r2(12663).descriptionOnlyNumbers, p2 = o({ editType: "plot", colorEditType: "plot" }), d2 = { color: { valType: "color", editType: "plot" }, line: { color: { valType: "color", dflt: s.defaultLine, editType: "plot" }, width: { valType: "number", min: 0, dflt: 0, editType: "plot" }, editType: "calc" }, thickness: { valType: "number", min: 0, max: 1, dflt: 1, editType: "plot" }, editType: "calc" }, v = { valType: "info_array", items: [{ valType: "number", editType: "plot" }, { valType: "number", editType: "plot" }], editType: "plot" }, g2 = c("step", i({}, d2, { range: v }));
        t2.exports = { mode: { valType: "flaglist", editType: "calc", flags: ["number", "delta", "gauge"], dflt: "number" }, value: { valType: "number", editType: "calc", anim: true }, align: { valType: "enumerated", values: ["left", "center", "right"], editType: "plot" }, domain: l({ name: "indicator", trace: true, editType: "calc" }), title: { text: { valType: "string", editType: "plot" }, align: { valType: "enumerated", values: ["left", "center", "right"], editType: "plot" }, font: n2({}, p2, {}), editType: "plot" }, number: { valueformat: { valType: "string", dflt: "", editType: "plot", description: h("value") }, font: n2({}, p2, {}), prefix: { valType: "string", dflt: "", editType: "plot" }, suffix: { valType: "string", dflt: "", editType: "plot" }, editType: "plot" }, delta: { reference: { valType: "number", editType: "calc" }, position: { valType: "enumerated", values: ["top", "bottom", "left", "right"], dflt: "bottom", editType: "plot" }, relative: { valType: "boolean", editType: "plot", dflt: false }, valueformat: { valType: "string", editType: "plot", description: h("value") }, increasing: { symbol: { valType: "string", dflt: f2.INCREASING.SYMBOL, editType: "plot" }, color: { valType: "color", dflt: f2.INCREASING.COLOR, editType: "plot" }, editType: "plot" }, decreasing: { symbol: { valType: "string", dflt: f2.DECREASING.SYMBOL, editType: "plot" }, color: { valType: "color", dflt: f2.DECREASING.COLOR, editType: "plot" }, editType: "plot" }, font: n2({}, p2, {}), prefix: { valType: "string", dflt: "", editType: "plot" }, suffix: { valType: "string", dflt: "", editType: "plot" }, editType: "calc" }, gauge: { shape: { valType: "enumerated", editType: "plot", dflt: "angular", values: ["angular", "bullet"] }, bar: i({}, d2, { color: { dflt: "green" } }), bgcolor: { valType: "color", editType: "plot" }, bordercolor: { valType: "color", dflt: s.defaultLine, editType: "plot" }, borderwidth: { valType: "number", min: 0, dflt: 1, editType: "plot" }, axis: a({ range: v, visible: n2({}, u.visible, { dflt: true }), tickmode: u.minor.tickmode, nticks: u.nticks, tick0: u.tick0, dtick: u.dtick, tickvals: u.tickvals, ticktext: u.ticktext, ticks: n2({}, u.ticks, { dflt: "outside" }), ticklen: u.ticklen, tickwidth: u.tickwidth, tickcolor: u.tickcolor, ticklabelstep: u.ticklabelstep, showticklabels: u.showticklabels, labelalias: u.labelalias, tickfont: o({}), tickangle: u.tickangle, tickformat: u.tickformat, tickformatstops: u.tickformatstops, tickprefix: u.tickprefix, showtickprefix: u.showtickprefix, ticksuffix: u.ticksuffix, showticksuffix: u.showticksuffix, separatethousands: u.separatethousands, exponentformat: u.exponentformat, minexponent: u.minexponent, showexponent: u.showexponent, editType: "plot" }, "plot"), steps: g2, threshold: { line: { color: n2({}, d2.line.color, {}), width: n2({}, d2.line.width, { dflt: 1 }), editType: "plot" }, thickness: n2({}, d2.thickness, { dflt: 0.85 }), value: { valType: "number", editType: "calc", dflt: false }, editType: "plot" }, editType: "plot" } };
      }, 15970: function(t2, e2, r2) {
        var n2 = r2(74875);
        e2.name = "indicator", e2.plot = function(t3, r3, i, a) {
          n2.plotBasePlot(e2.name, t3, r3, i, a);
        }, e2.clean = function(t3, r3, i, a) {
          n2.cleanBasePlot(e2.name, t3, r3, i, a);
        };
      }, 24667: function(t2) {
        t2.exports = { calc: function(t3, e2) {
          var r2 = [], n2 = e2.value;
          "number" != typeof e2._lastValue && (e2._lastValue = e2.value);
          var i = e2._lastValue, a = i;
          return e2._hasDelta && "number" == typeof e2.delta.reference && (a = e2.delta.reference), r2[0] = { y: n2, lastY: i, delta: n2 - a, relativeDelta: (n2 - a) / a }, r2;
        } };
      }, 84577: function(t2) {
        t2.exports = { defaultNumberFontSize: 80, bulletNumberDomainSize: 0.25, bulletPadding: 0.025, innerRadius: 0.75, valueThickness: 0.5, titlePadding: 5, horizontalPadding: 10 };
      }, 94425: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(54846), a = r2(27670).c, o = r2(44467), s = r2(85501), l = r2(84577), u = r2(26218), c = r2(38701), f2 = r2(96115), h = r2(89426);
        function p2(t3, e3) {
          function r3(r4, a2) {
            return n2.coerce(t3, e3, i.gauge.steps, r4, a2);
          }
          r3("color"), r3("line.color"), r3("line.width"), r3("range"), r3("thickness");
        }
        t2.exports = { supplyDefaults: function(t3, e3, r3, d2) {
          function v(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          a(e3, d2, v), v("mode"), e3._hasNumber = -1 !== e3.mode.indexOf("number"), e3._hasDelta = -1 !== e3.mode.indexOf("delta"), e3._hasGauge = -1 !== e3.mode.indexOf("gauge");
          var g2 = v("value");
          e3._range = [0, "number" == typeof g2 ? 1.5 * g2 : 1];
          var y, m2, x, b, _, w2, T = new Array(2);
          function k(t4, e4) {
            return n2.coerce(x, b, i.gauge, t4, e4);
          }
          function A(t4, e4) {
            return n2.coerce(_, w2, i.gauge.axis, t4, e4);
          }
          if (e3._hasNumber && (v("number.valueformat"), v("number.font.color", d2.font.color), v("number.font.family", d2.font.family), v("number.font.size"), void 0 === e3.number.font.size && (e3.number.font.size = l.defaultNumberFontSize, T[0] = true), v("number.prefix"), v("number.suffix"), y = e3.number.font.size), e3._hasDelta && (v("delta.font.color", d2.font.color), v("delta.font.family", d2.font.family), v("delta.font.size"), void 0 === e3.delta.font.size && (e3.delta.font.size = (e3._hasNumber ? 0.5 : 1) * (y || l.defaultNumberFontSize), T[1] = true), v("delta.reference", e3.value), v("delta.relative"), v("delta.valueformat", e3.delta.relative ? "2%" : ""), v("delta.increasing.symbol"), v("delta.increasing.color"), v("delta.decreasing.symbol"), v("delta.decreasing.color"), v("delta.position"), v("delta.prefix"), v("delta.suffix"), m2 = e3.delta.font.size), e3._scaleNumbers = (!e3._hasNumber || T[0]) && (!e3._hasDelta || T[1]) || false, v("title.font.color", d2.font.color), v("title.font.family", d2.font.family), v("title.font.size", 0.25 * (y || m2 || l.defaultNumberFontSize)), v("title.text"), e3._hasGauge) {
            (x = t3.gauge) || (x = {}), b = o.newContainer(e3, "gauge"), k("shape"), (e3._isBullet = "bullet" === e3.gauge.shape) || v("title.align", "center"), (e3._isAngular = "angular" === e3.gauge.shape) || v("align", "center"), k("bgcolor", d2.paper_bgcolor), k("borderwidth"), k("bordercolor"), k("bar.color"), k("bar.line.color"), k("bar.line.width"), k("bar.thickness", l.valueThickness * ("bullet" === e3.gauge.shape ? 0.5 : 1)), s(x, b, { name: "steps", handleItemDefaults: p2 }), k("threshold.value"), k("threshold.thickness"), k("threshold.line.width"), k("threshold.line.color"), _ = {}, x && (_ = x.axis || {}), w2 = o.newContainer(b, "axis"), A("visible"), e3._range = A("range", e3._range);
            var M = { outerTicks: true };
            u(_, w2, A, "linear"), h(_, w2, A, "linear", M), f2(_, w2, A, "linear", M), c(_, w2, A, M);
          } else
            v("title.align", "center"), v("align", "center"), e3._isAngular = e3._isBullet = false;
          e3._length = null;
        } };
      }, 15154: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "indicator", basePlotModule: r2(15970), categories: ["svg", "noOpacity", "noHover"], animatable: true, attributes: r2(54846), supplyDefaults: r2(94425).supplyDefaults, calc: r2(24667).calc, plot: r2(75634), meta: {} };
      }, 75634: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(81684).sX, a = r2(81684).k4, o = r2(71828), s = o.strScale, l = o.strTranslate, u = o.rad2deg, c = r2(18783).MID_SHIFT, f2 = r2(91424), h = r2(84577), p2 = r2(63893), d2 = r2(89298), v = r2(71453), g2 = r2(52830), y = r2(13838), m2 = r2(7901), x = { left: "start", center: "middle", right: "end" }, b = { left: 0, center: 0.5, right: 1 }, _ = /[yzafpnµmkMGTPEZY]/;
        function w2(t3) {
          return t3 && t3.duration > 0;
        }
        function T(t3) {
          t3.each(function(t4) {
            m2.stroke(n2.select(this), t4.line.color);
          }).each(function(t4) {
            m2.fill(n2.select(this), t4.color);
          }).style("stroke-width", function(t4) {
            return t4.line.width;
          });
        }
        function k(t3, e3, r3) {
          var n3 = t3._fullLayout, i2 = o.extendFlat({ type: "linear", ticks: "outside", range: r3, showline: true }, e3), a2 = { type: "linear", _id: "x" + e3._id }, s2 = { letter: "x", font: n3.font, noHover: true, noTickson: true };
          function l2(t4, e4) {
            return o.coerce(i2, a2, y, t4, e4);
          }
          return v(i2, a2, l2, s2, n3), g2(i2, a2, l2, s2), a2;
        }
        function A(t3, e3, r3) {
          return [Math.min(e3 / t3.width, r3 / t3.height), t3, e3 + "x" + r3];
        }
        function M(t3, e3, r3, i2) {
          var a2 = document.createElementNS("http://www.w3.org/2000/svg", "text"), o2 = n2.select(a2);
          return o2.text(t3).attr("x", 0).attr("y", 0).attr("text-anchor", r3).attr("data-unformatted", t3).call(p2.convertToTspans, i2).call(f2.font, e3), f2.bBox(o2.node());
        }
        function S(t3, e3, r3, n3, i2, a2) {
          var s2 = "_cache" + e3;
          t3[s2] && t3[s2].key === i2 || (t3[s2] = { key: i2, value: r3 });
          var l2 = o.aggNums(a2, null, [t3[s2].value, n3], 2);
          return t3[s2].value = l2, l2;
        }
        t2.exports = function(t3, e3, r3, v2) {
          var g3, y2 = t3._fullLayout;
          w2(r3) && v2 && (g3 = v2()), o.makeTraceGroups(y2._indicatorlayer, e3, "trace").each(function(e4) {
            var v3, E, L, C, P, O = e4[0].trace, I = n2.select(this), D = O._hasGauge, z = O._isAngular, R = O._isBullet, F = O.domain, B = { w: y2._size.w * (F.x[1] - F.x[0]), h: y2._size.h * (F.y[1] - F.y[0]), l: y2._size.l + y2._size.w * F.x[0], r: y2._size.r + y2._size.w * (1 - F.x[1]), t: y2._size.t + y2._size.h * (1 - F.y[1]), b: y2._size.b + y2._size.h * F.y[0] }, N = B.l + B.w / 2, j = B.t + B.h / 2, U = Math.min(B.w / 2, B.h), V = h.innerRadius * U, H = O.align || "center";
            if (E = j, D) {
              if (z && (v3 = N, E = j + U / 2, L = function(t4) {
                return function(t5, e5) {
                  return [e5 / Math.sqrt(t5.width / 2 * (t5.width / 2) + t5.height * t5.height), t5, e5];
                }(t4, 0.9 * V);
              }), R) {
                var q2 = h.bulletPadding, G = 1 - h.bulletNumberDomainSize + q2;
                v3 = B.l + (G + (1 - G) * b[H]) * B.w, L = function(t4) {
                  return A(t4, (h.bulletNumberDomainSize - q2) * B.w, B.h);
                };
              }
            } else
              v3 = B.l + b[H] * B.w, L = function(t4) {
                return A(t4, B.w, B.h);
              };
            !function(t4, e5, r4, i2) {
              var u2, c2, h2, v4 = r4[0].trace, g4 = i2.numbersX, y3 = i2.numbersY, T2 = v4.align || "center", A2 = x[T2], E2 = i2.transitionOpts, L2 = i2.onComplete, C2 = o.ensureSingle(e5, "g", "numbers"), P2 = [];
              v4._hasNumber && P2.push("number"), v4._hasDelta && (P2.push("delta"), "left" === v4.delta.position && P2.reverse());
              var O2 = C2.selectAll("text").data(P2);
              function I2(e6, r5, n3, i3) {
                if (!e6.match("s") || n3 >= 0 == i3 >= 0 || r5(n3).slice(-1).match(_) || r5(i3).slice(-1).match(_))
                  return r5;
                var a2 = e6.slice().replace("s", "f").replace(/\d+/, function(t5) {
                  return parseInt(t5) - 1;
                }), o2 = k(t4, { tickformat: a2 });
                return function(t5) {
                  return Math.abs(t5) < 1 ? d2.tickText(o2, t5).text : r5(t5);
                };
              }
              O2.enter().append("text"), O2.attr("text-anchor", function() {
                return A2;
              }).attr("class", function(t5) {
                return t5;
              }).attr("x", null).attr("y", null).attr("dx", null).attr("dy", null), O2.exit().remove();
              var D2, z2 = v4.mode + v4.align;
              if (v4._hasDelta && (D2 = function() {
                var e6 = k(t4, { tickformat: v4.delta.valueformat }, v4._range);
                e6.setScale(), d2.prepTicks(e6);
                var i3 = function(t5) {
                  return d2.tickText(e6, t5).text;
                }, o2 = v4.delta.suffix, s2 = v4.delta.prefix, l2 = function(t5) {
                  return v4.delta.relative ? t5.relativeDelta : t5.delta;
                }, u3 = function(t5, e7) {
                  return 0 === t5 || "number" != typeof t5 || isNaN(t5) ? "-" : (t5 > 0 ? v4.delta.increasing.symbol : v4.delta.decreasing.symbol) + s2 + e7(t5) + o2;
                }, h3 = function(t5) {
                  return t5.delta >= 0 ? v4.delta.increasing.color : v4.delta.decreasing.color;
                };
                void 0 === v4._deltaLastValue && (v4._deltaLastValue = l2(r4[0]));
                var g5 = C2.select("text.delta");
                function y4() {
                  g5.text(u3(l2(r4[0]), i3)).call(m2.fill, h3(r4[0])).call(p2.convertToTspans, t4);
                }
                return g5.call(f2.font, v4.delta.font).call(m2.fill, h3({ delta: v4._deltaLastValue })), w2(E2) ? g5.transition().duration(E2.duration).ease(E2.easing).tween("text", function() {
                  var t5 = n2.select(this), e7 = l2(r4[0]), o3 = v4._deltaLastValue, s3 = I2(v4.delta.valueformat, i3, o3, e7), c3 = a(o3, e7);
                  return v4._deltaLastValue = e7, function(e8) {
                    t5.text(u3(c3(e8), s3)), t5.call(m2.fill, h3({ delta: c3(e8) }));
                  };
                }).each("end", function() {
                  y4(), L2 && L2();
                }).each("interrupt", function() {
                  y4(), L2 && L2();
                }) : y4(), c2 = M(u3(l2(r4[0]), i3), v4.delta.font, A2, t4), g5;
              }(), z2 += v4.delta.position + v4.delta.font.size + v4.delta.font.family + v4.delta.valueformat, z2 += v4.delta.increasing.symbol + v4.delta.decreasing.symbol, h2 = c2), v4._hasNumber && (function() {
                var e6 = k(t4, { tickformat: v4.number.valueformat }, v4._range);
                e6.setScale(), d2.prepTicks(e6);
                var i3 = function(t5) {
                  return d2.tickText(e6, t5).text;
                }, o2 = v4.number.suffix, s2 = v4.number.prefix, l2 = C2.select("text.number");
                function c3() {
                  var e7 = "number" == typeof r4[0].y ? s2 + i3(r4[0].y) + o2 : "-";
                  l2.text(e7).call(f2.font, v4.number.font).call(p2.convertToTspans, t4);
                }
                w2(E2) ? l2.transition().duration(E2.duration).ease(E2.easing).each("end", function() {
                  c3(), L2 && L2();
                }).each("interrupt", function() {
                  c3(), L2 && L2();
                }).attrTween("text", function() {
                  var t5 = n2.select(this), e7 = a(r4[0].lastY, r4[0].y);
                  v4._lastValue = r4[0].y;
                  var l3 = I2(v4.number.valueformat, i3, r4[0].lastY, r4[0].y);
                  return function(r5) {
                    t5.text(s2 + l3(e7(r5)) + o2);
                  };
                }) : c3(), u2 = M(s2 + i3(r4[0].y) + o2, v4.number.font, A2, t4);
              }(), z2 += v4.number.font.size + v4.number.font.family + v4.number.valueformat + v4.number.suffix + v4.number.prefix, h2 = u2), v4._hasDelta && v4._hasNumber) {
                var R2, F2, B2 = [(u2.left + u2.right) / 2, (u2.top + u2.bottom) / 2], N2 = [(c2.left + c2.right) / 2, (c2.top + c2.bottom) / 2], j2 = 0.75 * v4.delta.font.size;
                "left" === v4.delta.position && (R2 = S(v4, "deltaPos", 0, -1 * (u2.width * b[v4.align] + c2.width * (1 - b[v4.align]) + j2), z2, Math.min), F2 = B2[1] - N2[1], h2 = { width: u2.width + c2.width + j2, height: Math.max(u2.height, c2.height), left: c2.left + R2, right: u2.right, top: Math.min(u2.top, c2.top + F2), bottom: Math.max(u2.bottom, c2.bottom + F2) }), "right" === v4.delta.position && (R2 = S(v4, "deltaPos", 0, u2.width * (1 - b[v4.align]) + c2.width * b[v4.align] + j2, z2, Math.max), F2 = B2[1] - N2[1], h2 = { width: u2.width + c2.width + j2, height: Math.max(u2.height, c2.height), left: u2.left, right: c2.right + R2, top: Math.min(u2.top, c2.top + F2), bottom: Math.max(u2.bottom, c2.bottom + F2) }), "bottom" === v4.delta.position && (R2 = null, F2 = c2.height, h2 = { width: Math.max(u2.width, c2.width), height: u2.height + c2.height, left: Math.min(u2.left, c2.left), right: Math.max(u2.right, c2.right), top: u2.bottom - u2.height, bottom: u2.bottom + c2.height }), "top" === v4.delta.position && (R2 = null, F2 = u2.top, h2 = { width: Math.max(u2.width, c2.width), height: u2.height + c2.height, left: Math.min(u2.left, c2.left), right: Math.max(u2.right, c2.right), top: u2.bottom - u2.height - c2.height, bottom: u2.bottom }), D2.attr({ dx: R2, dy: F2 });
              }
              (v4._hasNumber || v4._hasDelta) && C2.attr("transform", function() {
                var t5 = i2.numbersScaler(h2);
                z2 += t5[2];
                var e6, r5 = S(v4, "numbersScale", 1, t5[0], z2, Math.min);
                v4._scaleNumbers || (r5 = 1), e6 = v4._isAngular ? y3 - r5 * h2.bottom : y3 - r5 * (h2.top + h2.bottom) / 2, v4._numbersTop = r5 * h2.top + e6;
                var n3 = h2[T2];
                "center" === T2 && (n3 = (h2.left + h2.right) / 2);
                var a2 = g4 - r5 * n3;
                return a2 = S(v4, "numbersTranslate", 0, a2, z2, Math.max), l(a2, e6) + s(r5);
              });
            }(t3, I, e4, { numbersX: v3, numbersY: E, numbersScaler: L, transitionOpts: r3, onComplete: g3 }), D && (C = { range: O.gauge.axis.range, color: O.gauge.bgcolor, line: { color: O.gauge.bordercolor, width: 0 }, thickness: 1 }, P = { range: O.gauge.axis.range, color: "rgba(0, 0, 0, 0)", line: { color: O.gauge.bordercolor, width: O.gauge.borderwidth }, thickness: 1 });
            var Z = I.selectAll("g.angular").data(z ? e4 : []);
            Z.exit().remove();
            var Y = I.selectAll("g.angularaxis").data(z ? e4 : []);
            Y.exit().remove(), z && function(t4, e5, r4, a2) {
              var o2, s2, f3, h2, p3 = r4[0].trace, v4 = a2.size, g4 = a2.radius, y3 = a2.innerRadius, m3 = a2.gaugeBg, x2 = a2.gaugeOutline, b2 = [v4.l + v4.w / 2, v4.t + v4.h / 2 + g4 / 2], _2 = a2.gauge, A2 = a2.layer, M2 = a2.transitionOpts, S2 = a2.onComplete, E2 = Math.PI / 2;
              function L2(t5) {
                var e6 = p3.gauge.axis.range[0], r5 = (t5 - e6) / (p3.gauge.axis.range[1] - e6) * Math.PI - E2;
                return r5 < -E2 ? -E2 : r5 > E2 ? E2 : r5;
              }
              function C2(t5) {
                return n2.svg.arc().innerRadius((y3 + g4) / 2 - t5 / 2 * (g4 - y3)).outerRadius((y3 + g4) / 2 + t5 / 2 * (g4 - y3)).startAngle(-E2);
              }
              function P2(t5) {
                t5.attr("d", function(t6) {
                  return C2(t6.thickness).startAngle(L2(t6.range[0])).endAngle(L2(t6.range[1]))();
                });
              }
              _2.enter().append("g").classed("angular", true), _2.attr("transform", l(b2[0], b2[1])), A2.enter().append("g").classed("angularaxis", true).classed("crisp", true), A2.selectAll("g.xangularaxistick,path,text").remove(), (o2 = k(t4, p3.gauge.axis)).type = "linear", o2.range = p3.gauge.axis.range, o2._id = "xangularaxis", o2.ticklabeloverflow = "allow", o2.setScale();
              var O2 = function(t5) {
                return (o2.range[0] - t5.x) / (o2.range[1] - o2.range[0]) * Math.PI + Math.PI;
              }, I2 = {}, D2 = d2.makeLabelFns(o2, 0).labelStandoff;
              I2.xFn = function(t5) {
                var e6 = O2(t5);
                return Math.cos(e6) * D2;
              }, I2.yFn = function(t5) {
                var e6 = O2(t5), r5 = Math.sin(e6) > 0 ? 0.2 : 1;
                return -Math.sin(e6) * (D2 + t5.fontSize * r5) + Math.abs(Math.cos(e6)) * (t5.fontSize * c);
              }, I2.anchorFn = function(t5) {
                var e6 = O2(t5), r5 = Math.cos(e6);
                return Math.abs(r5) < 0.1 ? "middle" : r5 > 0 ? "start" : "end";
              }, I2.heightFn = function(t5, e6, r5) {
                var n3 = O2(t5);
                return -0.5 * (1 + Math.sin(n3)) * r5;
              };
              var z2 = function(t5) {
                return l(b2[0] + g4 * Math.cos(t5), b2[1] - g4 * Math.sin(t5));
              };
              f3 = function(t5) {
                return z2(O2(t5));
              };
              if (s2 = d2.calcTicks(o2), h2 = d2.getTickSigns(o2)[2], o2.visible) {
                h2 = "inside" === o2.ticks ? -1 : 1;
                var R2 = (o2.linewidth || 1) / 2;
                d2.drawTicks(t4, o2, { vals: s2, layer: A2, path: "M" + h2 * R2 + ",0h" + h2 * o2.ticklen, transFn: function(t5) {
                  var e6 = O2(t5);
                  return z2(e6) + "rotate(" + -u(e6) + ")";
                } }), d2.drawLabels(t4, o2, { vals: s2, layer: A2, transFn: f3, labelFns: I2 });
              }
              var F2 = [m3].concat(p3.gauge.steps), B2 = _2.selectAll("g.bg-arc").data(F2);
              B2.enter().append("g").classed("bg-arc", true).append("path"), B2.select("path").call(P2).call(T), B2.exit().remove();
              var N2 = C2(p3.gauge.bar.thickness), j2 = _2.selectAll("g.value-arc").data([p3.gauge.bar]);
              j2.enter().append("g").classed("value-arc", true).append("path");
              var U2, V2, H2, q3 = j2.select("path");
              w2(M2) ? (q3.transition().duration(M2.duration).ease(M2.easing).each("end", function() {
                S2 && S2();
              }).each("interrupt", function() {
                S2 && S2();
              }).attrTween("d", (U2 = N2, V2 = L2(r4[0].lastY), H2 = L2(r4[0].y), function() {
                var t5 = i(V2, H2);
                return function(e6) {
                  return U2.endAngle(t5(e6))();
                };
              })), p3._lastValue = r4[0].y) : q3.attr("d", "number" == typeof r4[0].y ? N2.endAngle(L2(r4[0].y)) : "M0,0Z"), q3.call(T), j2.exit().remove(), F2 = [];
              var G2 = p3.gauge.threshold.value;
              (G2 || 0 === G2) && F2.push({ range: [G2, G2], color: p3.gauge.threshold.color, line: { color: p3.gauge.threshold.line.color, width: p3.gauge.threshold.line.width }, thickness: p3.gauge.threshold.thickness });
              var Z2 = _2.selectAll("g.threshold-arc").data(F2);
              Z2.enter().append("g").classed("threshold-arc", true).append("path"), Z2.select("path").call(P2).call(T), Z2.exit().remove();
              var Y2 = _2.selectAll("g.gauge-outline").data([x2]);
              Y2.enter().append("g").classed("gauge-outline", true).append("path"), Y2.select("path").call(P2).call(T), Y2.exit().remove();
            }(t3, 0, e4, { radius: U, innerRadius: V, gauge: Z, layer: Y, size: B, gaugeBg: C, gaugeOutline: P, transitionOpts: r3, onComplete: g3 });
            var W = I.selectAll("g.bullet").data(R ? e4 : []);
            W.exit().remove();
            var X = I.selectAll("g.bulletaxis").data(R ? e4 : []);
            X.exit().remove(), R && function(t4, e5, r4, n3) {
              var i2, a2, o2, s2, u2, c2 = r4[0].trace, f3 = n3.gauge, p3 = n3.layer, v4 = n3.gaugeBg, g4 = n3.gaugeOutline, y3 = n3.size, x2 = c2.domain, b2 = n3.transitionOpts, _2 = n3.onComplete;
              f3.enter().append("g").classed("bullet", true), f3.attr("transform", l(y3.l, y3.t)), p3.enter().append("g").classed("bulletaxis", true).classed("crisp", true), p3.selectAll("g.xbulletaxistick,path,text").remove();
              var A2 = y3.h, M2 = c2.gauge.bar.thickness * A2, S2 = x2.x[0], E2 = x2.x[0] + (x2.x[1] - x2.x[0]) * (c2._hasNumber || c2._hasDelta ? 1 - h.bulletNumberDomainSize : 1);
              function L2(t5) {
                t5.attr("width", function(t6) {
                  return Math.max(0, i2.c2p(t6.range[1]) - i2.c2p(t6.range[0]));
                }).attr("x", function(t6) {
                  return i2.c2p(t6.range[0]);
                }).attr("y", function(t6) {
                  return 0.5 * (1 - t6.thickness) * A2;
                }).attr("height", function(t6) {
                  return t6.thickness * A2;
                });
              }
              (i2 = k(t4, c2.gauge.axis))._id = "xbulletaxis", i2.domain = [S2, E2], i2.setScale(), a2 = d2.calcTicks(i2), o2 = d2.makeTransTickFn(i2), s2 = d2.getTickSigns(i2)[2], u2 = y3.t + y3.h, i2.visible && (d2.drawTicks(t4, i2, { vals: "inside" === i2.ticks ? d2.clipEnds(i2, a2) : a2, layer: p3, path: d2.makeTickPath(i2, u2, s2), transFn: o2 }), d2.drawLabels(t4, i2, { vals: a2, layer: p3, transFn: o2, labelFns: d2.makeLabelFns(i2, u2) }));
              var C2 = [v4].concat(c2.gauge.steps), P2 = f3.selectAll("g.bg-bullet").data(C2);
              P2.enter().append("g").classed("bg-bullet", true).append("rect"), P2.select("rect").call(L2).call(T), P2.exit().remove();
              var O2 = f3.selectAll("g.value-bullet").data([c2.gauge.bar]);
              O2.enter().append("g").classed("value-bullet", true).append("rect"), O2.select("rect").attr("height", M2).attr("y", (A2 - M2) / 2).call(T), w2(b2) ? O2.select("rect").transition().duration(b2.duration).ease(b2.easing).each("end", function() {
                _2 && _2();
              }).each("interrupt", function() {
                _2 && _2();
              }).attr("width", Math.max(0, i2.c2p(Math.min(c2.gauge.axis.range[1], r4[0].y)))) : O2.select("rect").attr("width", "number" == typeof r4[0].y ? Math.max(0, i2.c2p(Math.min(c2.gauge.axis.range[1], r4[0].y))) : 0), O2.exit().remove();
              var I2 = r4.filter(function() {
                return c2.gauge.threshold.value || 0 === c2.gauge.threshold.value;
              }), D2 = f3.selectAll("g.threshold-bullet").data(I2);
              D2.enter().append("g").classed("threshold-bullet", true).append("line"), D2.select("line").attr("x1", i2.c2p(c2.gauge.threshold.value)).attr("x2", i2.c2p(c2.gauge.threshold.value)).attr("y1", (1 - c2.gauge.threshold.thickness) / 2 * A2).attr("y2", (1 - (1 - c2.gauge.threshold.thickness) / 2) * A2).call(m2.stroke, c2.gauge.threshold.line.color).style("stroke-width", c2.gauge.threshold.line.width), D2.exit().remove();
              var z2 = f3.selectAll("g.gauge-outline").data([g4]);
              z2.enter().append("g").classed("gauge-outline", true).append("rect"), z2.select("rect").call(L2).call(T), z2.exit().remove();
            }(t3, 0, e4, { gauge: W, layer: X, size: B, gaugeBg: C, gaugeOutline: P, transitionOpts: r3, onComplete: g3 });
            var J = I.selectAll("text.title").data(e4);
            J.exit().remove(), J.enter().append("text").classed("title", true), J.attr("text-anchor", function() {
              return R ? x.right : x[O.title.align];
            }).text(O.title.text).call(f2.font, O.title.font).call(p2.convertToTspans, t3), J.attr("transform", function() {
              var t4, e5 = B.l + B.w * b[O.title.align], r4 = h.titlePadding, n3 = f2.bBox(J.node());
              return D ? (z && (t4 = O.gauge.axis.visible ? f2.bBox(Y.node()).top - r4 - n3.bottom : B.t + B.h / 2 - U / 2 - n3.bottom - r4), R && (t4 = E - (n3.top + n3.bottom) / 2, e5 = B.l - h.bulletPadding * B.w)) : t4 = O._numbersTop - r4 - n3.bottom, l(e5, t4);
            });
          });
        };
      }, 16249: function(t2, e2, r2) {
        var n2 = r2(50693), i = r2(12663).axisHoverFormat, a = r2(5386).f, o = r2(2418), s = r2(9012), l = r2(1426).extendFlat, u = r2(30962).overrideAll, c = t2.exports = u(l({ x: { valType: "data_array" }, y: { valType: "data_array" }, z: { valType: "data_array" }, value: { valType: "data_array" }, isomin: { valType: "number" }, isomax: { valType: "number" }, surface: { show: { valType: "boolean", dflt: true }, count: { valType: "integer", dflt: 2, min: 1 }, fill: { valType: "number", min: 0, max: 1, dflt: 1 }, pattern: { valType: "flaglist", flags: ["A", "B", "C", "D", "E"], extras: ["all", "odd", "even"], dflt: "all" } }, spaceframe: { show: { valType: "boolean", dflt: false }, fill: { valType: "number", min: 0, max: 1, dflt: 0.15 } }, slices: { x: { show: { valType: "boolean", dflt: false }, locations: { valType: "data_array", dflt: [] }, fill: { valType: "number", min: 0, max: 1, dflt: 1 } }, y: { show: { valType: "boolean", dflt: false }, locations: { valType: "data_array", dflt: [] }, fill: { valType: "number", min: 0, max: 1, dflt: 1 } }, z: { show: { valType: "boolean", dflt: false }, locations: { valType: "data_array", dflt: [] }, fill: { valType: "number", min: 0, max: 1, dflt: 1 } } }, caps: { x: { show: { valType: "boolean", dflt: true }, fill: { valType: "number", min: 0, max: 1, dflt: 1 } }, y: { show: { valType: "boolean", dflt: true }, fill: { valType: "number", min: 0, max: 1, dflt: 1 } }, z: { show: { valType: "boolean", dflt: true }, fill: { valType: "number", min: 0, max: 1, dflt: 1 } } }, text: { valType: "string", dflt: "", arrayOk: true }, hovertext: { valType: "string", dflt: "", arrayOk: true }, hovertemplate: a(), xhoverformat: i("x"), yhoverformat: i("y"), zhoverformat: i("z"), valuehoverformat: i("value", 1), showlegend: l({}, s.showlegend, { dflt: false }) }, n2("", { colorAttr: "`value`", showScaleDflt: true, editTypeOverride: "calc" }), { opacity: o.opacity, lightposition: o.lightposition, lighting: o.lighting, flatshading: o.flatshading, contour: o.contour, hoverinfo: l({}, s.hoverinfo) }), "calc", "nested");
        c.flatshading.dflt = true, c.lighting.facenormalsepsilon.dflt = 0, c.x.editType = c.y.editType = c.z.editType = c.value.editType = "calc+clearAxisTypes", c.transforms = void 0;
      }, 56959: function(t2, e2, r2) {
        var n2 = r2(78803), i = r2(88489).processGrid, a = r2(88489).filter;
        t2.exports = function(t3, e3) {
          e3._len = Math.min(e3.x.length, e3.y.length, e3.z.length, e3.value.length), e3._x = a(e3.x, e3._len), e3._y = a(e3.y, e3._len), e3._z = a(e3.z, e3._len), e3._value = a(e3.value, e3._len);
          var r3 = i(e3);
          e3._gridFill = r3.fill, e3._Xs = r3.Xs, e3._Ys = r3.Ys, e3._Zs = r3.Zs, e3._len = r3.len;
          for (var o = 1 / 0, s = -1 / 0, l = 0; l < e3._len; l++) {
            var u = e3._value[l];
            o = Math.min(o, u), s = Math.max(s, u);
          }
          e3._minValues = o, e3._maxValues = s, e3._vMin = void 0 === e3.isomin || null === e3.isomin ? o : e3.isomin, e3._vMax = void 0 === e3.isomax || null === e3.isomin ? s : e3.isomax, n2(t3, e3, { vals: [e3._vMin, e3._vMax], containerStr: "", cLetter: "c" });
        };
      }, 22674: function(t2, e2, r2) {
        var n2 = r2(9330).gl_mesh3d, i = r2(81697).parseColorScale, a = r2(78614), o = r2(21081).extractOpts, s = r2(90060), l = function(t3, e3) {
          for (var r3 = e3.length - 1; r3 > 0; r3--) {
            var n3 = Math.min(e3[r3], e3[r3 - 1]), i2 = Math.max(e3[r3], e3[r3 - 1]);
            if (i2 > n3 && n3 < t3 && t3 <= i2)
              return { id: r3, distRatio: (i2 - t3) / (i2 - n3) };
          }
          return { id: 0, distRatio: 0 };
        };
        function u(t3, e3, r3) {
          this.scene = t3, this.uid = r3, this.mesh = e3, this.name = "", this.data = null, this.showContour = false;
        }
        var c = u.prototype;
        c.handlePick = function(t3) {
          if (t3.object === this.mesh) {
            var e3 = t3.data.index, r3 = this.data._meshX[e3], n3 = this.data._meshY[e3], i2 = this.data._meshZ[e3], a2 = this.data._Ys.length, o2 = this.data._Zs.length, s2 = l(r3, this.data._Xs).id, u2 = l(n3, this.data._Ys).id, c2 = l(i2, this.data._Zs).id, f3 = t3.index = c2 + o2 * u2 + o2 * a2 * s2;
            t3.traceCoordinate = [this.data._meshX[f3], this.data._meshY[f3], this.data._meshZ[f3], this.data._value[f3]];
            var h2 = this.data.hovertext || this.data.text;
            return Array.isArray(h2) && void 0 !== h2[f3] ? t3.textLabel = h2[f3] : h2 && (t3.textLabel = h2), true;
          }
        }, c.update = function(t3) {
          var e3 = this.scene, r3 = e3.fullSceneLayout;
          function n3(t4, e4, r4, n4) {
            return e4.map(function(e5) {
              return t4.d2l(e5, 0, n4) * r4;
            });
          }
          this.data = h(t3);
          var l2 = { positions: s(n3(r3.xaxis, t3._meshX, e3.dataScale[0], t3.xcalendar), n3(r3.yaxis, t3._meshY, e3.dataScale[1], t3.ycalendar), n3(r3.zaxis, t3._meshZ, e3.dataScale[2], t3.zcalendar)), cells: s(t3._meshI, t3._meshJ, t3._meshK), lightPosition: [t3.lightposition.x, t3.lightposition.y, t3.lightposition.z], ambient: t3.lighting.ambient, diffuse: t3.lighting.diffuse, specular: t3.lighting.specular, roughness: t3.lighting.roughness, fresnel: t3.lighting.fresnel, vertexNormalsEpsilon: t3.lighting.vertexnormalsepsilon, faceNormalsEpsilon: t3.lighting.facenormalsepsilon, opacity: t3.opacity, contourEnable: t3.contour.show, contourColor: a(t3.contour.color).slice(0, 3), contourWidth: t3.contour.width, useFacetNormals: t3.flatshading }, u2 = o(t3);
          l2.vertexIntensity = t3._meshIntensity, l2.vertexIntensityBounds = [u2.min, u2.max], l2.colormap = i(t3), this.mesh.update(l2);
        }, c.dispose = function() {
          this.scene.glplot.remove(this.mesh), this.mesh.dispose();
        };
        var f2 = ["xyz", "xzy", "yxz", "yzx", "zxy", "zyx"];
        function h(t3) {
          t3._meshI = [], t3._meshJ = [], t3._meshK = [];
          var e3, r3, n3, i2, a2, o2, s2, u2 = t3.surface.show, c2 = t3.spaceframe.show, h2 = t3.surface.fill, p2 = t3.spaceframe.fill, d2 = false, v = false, g2 = 0, y = t3._Xs, m2 = t3._Ys, x = t3._Zs, b = y.length, _ = m2.length, w2 = x.length, T = f2.indexOf(t3._gridFill.replace(/-/g, "").replace(/\+/g, "")), k = function(t4, e4, r4) {
            switch (T) {
              case 5:
                return r4 + w2 * e4 + w2 * _ * t4;
              case 4:
                return r4 + w2 * t4 + w2 * b * e4;
              case 3:
                return e4 + _ * r4 + _ * w2 * t4;
              case 2:
                return e4 + _ * t4 + _ * b * r4;
              case 1:
                return t4 + b * r4 + b * w2 * e4;
              default:
                return t4 + b * e4 + b * _ * r4;
            }
          }, A = t3._minValues, M = t3._maxValues, S = t3._vMin, E = t3._vMax;
          function L(t4, e4, s3) {
            for (var l2 = o2.length, u3 = r3; u3 < l2; u3++)
              if (t4 === n3[u3] && e4 === i2[u3] && s3 === a2[u3])
                return u3;
            return -1;
          }
          function C() {
            r3 = e3;
          }
          function P() {
            n3 = [], i2 = [], a2 = [], o2 = [], e3 = 0, C();
          }
          function O(t4, r4, s3, l2) {
            return n3.push(t4), i2.push(r4), a2.push(s3), o2.push(l2), ++e3 - 1;
          }
          function I(t4, e4, r4) {
            for (var n4 = [], i3 = 0; i3 < t4.length; i3++)
              n4[i3] = t4[i3] * (1 - r4) + r4 * e4[i3];
            return n4;
          }
          function D(t4) {
            s2 = t4;
          }
          function z(t4, e4) {
            return "all" === t4 || null === t4 || t4.indexOf(e4) > -1;
          }
          function R(t4, e4) {
            return null === t4 ? e4 : t4;
          }
          function F(e4, r4, n4) {
            C();
            var i3, a3, o3, l2 = [r4], u3 = [n4];
            if (s2 >= 1)
              l2 = [r4], u3 = [n4];
            else if (s2 > 0) {
              var c3 = function(t4, e5) {
                var r5 = t4[0], n5 = t4[1], i4 = t4[2], a4 = function(t5, e6, r6) {
                  for (var n6 = [], i5 = 0; i5 < t5.length; i5++)
                    n6[i5] = (t5[i5] + e6[i5] + r6[i5]) / 3;
                  return n6;
                }(r5, n5, i4), o4 = Math.sqrt(1 - s2), l3 = I(a4, r5, o4), u4 = I(a4, n5, o4), c4 = I(a4, i4, o4), f4 = e5[0], h4 = e5[1], p4 = e5[2];
                return { xyzv: [[r5, n5, u4], [u4, l3, r5], [n5, i4, c4], [c4, u4, n5], [i4, r5, l3], [l3, c4, i4]], abc: [[f4, h4, -1], [-1, -1, f4], [h4, p4, -1], [-1, -1, h4], [p4, f4, -1], [-1, -1, p4]] };
              }(r4, n4);
              l2 = c3.xyzv, u3 = c3.abc;
            }
            for (var f3 = 0; f3 < l2.length; f3++) {
              r4 = l2[f3], n4 = u3[f3];
              for (var h3 = [], p3 = 0; p3 < 3; p3++) {
                var d3 = r4[p3][0], v2 = r4[p3][1], y2 = r4[p3][2], m3 = r4[p3][3], x2 = n4[p3] > -1 ? n4[p3] : L(d3, v2, y2);
                h3[p3] = x2 > -1 ? x2 : O(d3, v2, y2, R(e4, m3));
              }
              i3 = h3[0], a3 = h3[1], o3 = h3[2], t3._meshI.push(i3), t3._meshJ.push(a3), t3._meshK.push(o3), ++g2;
            }
          }
          function B(t4, e4, r4, n4) {
            var i3 = t4[3];
            i3 < r4 && (i3 = r4), i3 > n4 && (i3 = n4);
            for (var a3 = (t4[3] - i3) / (t4[3] - e4[3] + 1e-9), o3 = [], s3 = 0; s3 < 4; s3++)
              o3[s3] = (1 - a3) * t4[s3] + a3 * e4[s3];
            return o3;
          }
          function N(t4, e4, r4) {
            return t4 >= e4 && t4 <= r4;
          }
          function j(t4) {
            var e4 = 1e-3 * (E - S);
            return t4 >= S - e4 && t4 <= E + e4;
          }
          function U(e4) {
            for (var r4 = [], n4 = 0; n4 < 4; n4++) {
              var i3 = e4[n4];
              r4.push([t3._x[i3], t3._y[i3], t3._z[i3], t3._value[i3]]);
            }
            return r4;
          }
          function V(t4, e4, r4, n4, i3, a3) {
            a3 || (a3 = 1), r4 = [-1, -1, -1];
            var o3 = false, s3 = [N(e4[0][3], n4, i3), N(e4[1][3], n4, i3), N(e4[2][3], n4, i3)];
            if (!s3[0] && !s3[1] && !s3[2])
              return false;
            var l2 = function(t5, e5, r5) {
              return j(e5[0][3]) && j(e5[1][3]) && j(e5[2][3]) ? (F(t5, e5, r5), true) : a3 < 3 && V(t5, e5, r5, S, E, ++a3);
            };
            if (s3[0] && s3[1] && s3[2])
              return l2(t4, e4, r4) || o3;
            var u3 = false;
            return [[0, 1, 2], [2, 0, 1], [1, 2, 0]].forEach(function(a4) {
              if (s3[a4[0]] && s3[a4[1]] && !s3[a4[2]]) {
                var c3 = e4[a4[0]], f3 = e4[a4[1]], h3 = e4[a4[2]], p3 = B(h3, c3, n4, i3), d3 = B(h3, f3, n4, i3);
                o3 = l2(t4, [d3, p3, c3], [-1, -1, r4[a4[0]]]) || o3, o3 = l2(t4, [c3, f3, d3], [r4[a4[0]], r4[a4[1]], -1]) || o3, u3 = true;
              }
            }), u3 || [[0, 1, 2], [1, 2, 0], [2, 0, 1]].forEach(function(a4) {
              if (s3[a4[0]] && !s3[a4[1]] && !s3[a4[2]]) {
                var c3 = e4[a4[0]], f3 = e4[a4[1]], h3 = e4[a4[2]], p3 = B(f3, c3, n4, i3), d3 = B(h3, c3, n4, i3);
                o3 = l2(t4, [d3, p3, c3], [-1, -1, r4[a4[0]]]) || o3, u3 = true;
              }
            }), o3;
          }
          function H(t4, e4, r4, n4) {
            var i3 = false, a3 = U(e4), o3 = [N(a3[0][3], r4, n4), N(a3[1][3], r4, n4), N(a3[2][3], r4, n4), N(a3[3][3], r4, n4)];
            if (!(o3[0] || o3[1] || o3[2] || o3[3]))
              return i3;
            if (o3[0] && o3[1] && o3[2] && o3[3])
              return v && (i3 = function(t5, e5, r5) {
                var n5 = function(n6, i4, a4) {
                  F(t5, [e5[n6], e5[i4], e5[a4]], [r5[n6], r5[i4], r5[a4]]);
                };
                n5(0, 1, 2), n5(3, 0, 1), n5(2, 3, 0), n5(1, 2, 3);
              }(t4, a3, e4) || i3), i3;
            var s3 = false;
            return [[0, 1, 2, 3], [3, 0, 1, 2], [2, 3, 0, 1], [1, 2, 3, 0]].forEach(function(l2) {
              if (o3[l2[0]] && o3[l2[1]] && o3[l2[2]] && !o3[l2[3]]) {
                var u3 = a3[l2[0]], c3 = a3[l2[1]], f3 = a3[l2[2]], h3 = a3[l2[3]];
                if (v)
                  i3 = F(t4, [u3, c3, f3], [e4[l2[0]], e4[l2[1]], e4[l2[2]]]) || i3;
                else {
                  var p3 = B(h3, u3, r4, n4), d3 = B(h3, c3, r4, n4), g3 = B(h3, f3, r4, n4);
                  i3 = F(null, [p3, d3, g3], [-1, -1, -1]) || i3;
                }
                s3 = true;
              }
            }), s3 || ([[0, 1, 2, 3], [1, 2, 3, 0], [2, 3, 0, 1], [3, 0, 1, 2], [0, 2, 3, 1], [1, 3, 2, 0]].forEach(function(l2) {
              if (o3[l2[0]] && o3[l2[1]] && !o3[l2[2]] && !o3[l2[3]]) {
                var u3 = a3[l2[0]], c3 = a3[l2[1]], f3 = a3[l2[2]], h3 = a3[l2[3]], p3 = B(f3, u3, r4, n4), d3 = B(f3, c3, r4, n4), g3 = B(h3, c3, r4, n4), y2 = B(h3, u3, r4, n4);
                v ? (i3 = F(t4, [u3, y2, p3], [e4[l2[0]], -1, -1]) || i3, i3 = F(t4, [c3, d3, g3], [e4[l2[1]], -1, -1]) || i3) : i3 = function(t5, e5, r5) {
                  var n5 = function(t6, n6, i4) {
                    F(null, [e5[t6], e5[n6], e5[i4]], [r5[t6], r5[n6], r5[i4]]);
                  };
                  n5(0, 1, 2), n5(2, 3, 0);
                }(0, [p3, d3, g3, y2], [-1, -1, -1, -1]) || i3, s3 = true;
              }
            }), s3 || [[0, 1, 2, 3], [1, 2, 3, 0], [2, 3, 0, 1], [3, 0, 1, 2]].forEach(function(l2) {
              if (o3[l2[0]] && !o3[l2[1]] && !o3[l2[2]] && !o3[l2[3]]) {
                var u3 = a3[l2[0]], c3 = a3[l2[1]], f3 = a3[l2[2]], h3 = a3[l2[3]], p3 = B(c3, u3, r4, n4), d3 = B(f3, u3, r4, n4), g3 = B(h3, u3, r4, n4);
                v ? (i3 = F(t4, [u3, p3, d3], [e4[l2[0]], -1, -1]) || i3, i3 = F(t4, [u3, d3, g3], [e4[l2[0]], -1, -1]) || i3, i3 = F(t4, [u3, g3, p3], [e4[l2[0]], -1, -1]) || i3) : i3 = F(null, [p3, d3, g3], [-1, -1, -1]) || i3, s3 = true;
              }
            })), i3;
          }
          function q2(t4, e4, r4, n4, i3, a3, o3, s3, l2, u3, c3) {
            var f3 = false;
            return d2 && (z(t4, "A") && (f3 = H(null, [e4, r4, n4, a3], u3, c3) || f3), z(t4, "B") && (f3 = H(null, [r4, n4, i3, l2], u3, c3) || f3), z(t4, "C") && (f3 = H(null, [r4, a3, o3, l2], u3, c3) || f3), z(t4, "D") && (f3 = H(null, [n4, a3, s3, l2], u3, c3) || f3), z(t4, "E") && (f3 = H(null, [r4, n4, a3, l2], u3, c3) || f3)), v && (f3 = H(t4, [r4, n4, a3, l2], u3, c3) || f3), f3;
          }
          function G(t4, e4, r4, n4, i3, a3, o3, s3) {
            return [true === s3[0] || V(t4, U([e4, r4, n4]), [e4, r4, n4], a3, o3), true === s3[1] || V(t4, U([n4, i3, e4]), [n4, i3, e4], a3, o3)];
          }
          function Z(t4, e4, r4, n4, i3, a3, o3, s3, l2) {
            return s3 ? G(t4, e4, r4, i3, n4, a3, o3, l2) : G(t4, r4, i3, n4, e4, a3, o3, l2);
          }
          function Y(t4, e4, r4, n4, i3, a3, o3) {
            var s3, l2, u3, c3, f3 = false, h3 = function() {
              f3 = V(t4, [s3, l2, u3], [-1, -1, -1], i3, a3) || f3, f3 = V(t4, [u3, c3, s3], [-1, -1, -1], i3, a3) || f3;
            }, p3 = o3[0], d3 = o3[1], v2 = o3[2];
            return p3 && (s3 = I(U([k(e4, r4 - 0, n4 - 0)])[0], U([k(e4 - 1, r4 - 0, n4 - 0)])[0], p3), l2 = I(U([k(e4, r4 - 0, n4 - 1)])[0], U([k(e4 - 1, r4 - 0, n4 - 1)])[0], p3), u3 = I(U([k(e4, r4 - 1, n4 - 1)])[0], U([k(e4 - 1, r4 - 1, n4 - 1)])[0], p3), c3 = I(U([k(e4, r4 - 1, n4 - 0)])[0], U([k(e4 - 1, r4 - 1, n4 - 0)])[0], p3), h3()), d3 && (s3 = I(U([k(e4 - 0, r4, n4 - 0)])[0], U([k(e4 - 0, r4 - 1, n4 - 0)])[0], d3), l2 = I(U([k(e4 - 0, r4, n4 - 1)])[0], U([k(e4 - 0, r4 - 1, n4 - 1)])[0], d3), u3 = I(U([k(e4 - 1, r4, n4 - 1)])[0], U([k(e4 - 1, r4 - 1, n4 - 1)])[0], d3), c3 = I(U([k(e4 - 1, r4, n4 - 0)])[0], U([k(e4 - 1, r4 - 1, n4 - 0)])[0], d3), h3()), v2 && (s3 = I(U([k(e4 - 0, r4 - 0, n4)])[0], U([k(e4 - 0, r4 - 0, n4 - 1)])[0], v2), l2 = I(U([k(e4 - 0, r4 - 1, n4)])[0], U([k(e4 - 0, r4 - 1, n4 - 1)])[0], v2), u3 = I(U([k(e4 - 1, r4 - 1, n4)])[0], U([k(e4 - 1, r4 - 1, n4 - 1)])[0], v2), c3 = I(U([k(e4 - 1, r4 - 0, n4)])[0], U([k(e4 - 1, r4 - 0, n4 - 1)])[0], v2), h3()), f3;
          }
          function W(t4, e4, r4, n4, i3, a3, o3, s3, l2, u3, c3, f3) {
            var h3 = t4;
            return f3 ? (d2 && "even" === t4 && (h3 = null), q2(h3, e4, r4, n4, i3, a3, o3, s3, l2, u3, c3)) : (d2 && "odd" === t4 && (h3 = null), q2(h3, l2, s3, o3, a3, i3, n4, r4, e4, u3, c3));
          }
          function X(t4, e4, r4, n4, i3) {
            for (var a3 = [], o3 = 0, s3 = 0; s3 < e4.length; s3++)
              for (var l2 = e4[s3], u3 = 1; u3 < w2; u3++)
                for (var c3 = 1; c3 < _; c3++)
                  a3.push(Z(t4, k(l2, c3 - 1, u3 - 1), k(l2, c3 - 1, u3), k(l2, c3, u3 - 1), k(l2, c3, u3), r4, n4, (l2 + c3 + u3) % 2, i3 && i3[o3] ? i3[o3] : [])), o3++;
            return a3;
          }
          function J(t4, e4, r4, n4, i3) {
            for (var a3 = [], o3 = 0, s3 = 0; s3 < e4.length; s3++)
              for (var l2 = e4[s3], u3 = 1; u3 < b; u3++)
                for (var c3 = 1; c3 < w2; c3++)
                  a3.push(Z(t4, k(u3 - 1, l2, c3 - 1), k(u3, l2, c3 - 1), k(u3 - 1, l2, c3), k(u3, l2, c3), r4, n4, (u3 + l2 + c3) % 2, i3 && i3[o3] ? i3[o3] : [])), o3++;
            return a3;
          }
          function K(t4, e4, r4, n4, i3) {
            for (var a3 = [], o3 = 0, s3 = 0; s3 < e4.length; s3++)
              for (var l2 = e4[s3], u3 = 1; u3 < _; u3++)
                for (var c3 = 1; c3 < b; c3++)
                  a3.push(Z(t4, k(c3 - 1, u3 - 1, l2), k(c3 - 1, u3, l2), k(c3, u3 - 1, l2), k(c3, u3, l2), r4, n4, (c3 + u3 + l2) % 2, i3 && i3[o3] ? i3[o3] : [])), o3++;
            return a3;
          }
          function $(t4, e4, r4) {
            for (var n4 = 1; n4 < w2; n4++)
              for (var i3 = 1; i3 < _; i3++)
                for (var a3 = 1; a3 < b; a3++)
                  W(t4, k(a3 - 1, i3 - 1, n4 - 1), k(a3 - 1, i3 - 1, n4), k(a3 - 1, i3, n4 - 1), k(a3 - 1, i3, n4), k(a3, i3 - 1, n4 - 1), k(a3, i3 - 1, n4), k(a3, i3, n4 - 1), k(a3, i3, n4), e4, r4, (a3 + i3 + n4) % 2);
          }
          function Q(t4, e4, r4, n4, i3, a3) {
            for (var o3 = [], s3 = 0, l2 = 0; l2 < e4.length; l2++)
              for (var u3 = e4[l2], c3 = 1; c3 < w2; c3++)
                for (var f3 = 1; f3 < _; f3++)
                  o3.push(Y(t4, u3, f3, c3, r4, n4, i3[l2], a3 && a3[s3] && a3[s3])), s3++;
            return o3;
          }
          function tt(t4, e4, r4, n4, i3, a3) {
            for (var o3 = [], s3 = 0, l2 = 0; l2 < e4.length; l2++)
              for (var u3 = e4[l2], c3 = 1; c3 < b; c3++)
                for (var f3 = 1; f3 < w2; f3++)
                  o3.push(Y(t4, c3, u3, f3, r4, n4, i3[l2], a3 && a3[s3] && a3[s3])), s3++;
            return o3;
          }
          function et(t4, e4, r4, n4, i3, a3) {
            for (var o3 = [], s3 = 0, l2 = 0; l2 < e4.length; l2++)
              for (var u3 = e4[l2], c3 = 1; c3 < _; c3++)
                for (var f3 = 1; f3 < b; f3++)
                  o3.push(Y(t4, f3, c3, u3, r4, n4, i3[l2], a3 && a3[s3] && a3[s3])), s3++;
            return o3;
          }
          function rt(t4, e4) {
            for (var r4 = [], n4 = t4; n4 < e4; n4++)
              r4.push(n4);
            return r4;
          }
          return function() {
            P(), function() {
              for (var e5 = 0; e5 < b; e5++)
                for (var r5 = 0; r5 < _; r5++)
                  for (var n4 = 0; n4 < w2; n4++) {
                    var i3 = k(e5, r5, n4);
                    O(t3._x[i3], t3._y[i3], t3._z[i3], t3._value[i3]);
                  }
            }();
            var e4 = null;
            if (c2 && p2 && (D(p2), v = true, $(e4, S, E), v = false), u2 && h2) {
              D(h2);
              for (var r4 = t3.surface.pattern, s3 = t3.surface.count, f3 = 0; f3 < s3; f3++) {
                var T2 = 1 === s3 ? 0.5 : f3 / (s3 - 1), L2 = (1 - T2) * S + T2 * E, C2 = Math.abs(L2 - A) > Math.abs(L2 - M) ? [A, L2] : [L2, M];
                d2 = true, $(r4, C2[0], C2[1]), d2 = false;
              }
            }
            var I2 = [[Math.min(S, M), Math.max(S, M)], [Math.min(A, E), Math.max(A, E)]];
            ["x", "y", "z"].forEach(function(r5) {
              for (var n4 = [], i3 = 0; i3 < I2.length; i3++) {
                var a3 = 0, o3 = I2[i3][0], s4 = I2[i3][1], u3 = t3.slices[r5];
                if (u3.show && u3.fill) {
                  D(u3.fill);
                  var c3 = [], f4 = [], h3 = [];
                  if (u3.locations.length)
                    for (var p3 = 0; p3 < u3.locations.length; p3++) {
                      var d3 = l(u3.locations[p3], "x" === r5 ? y : "y" === r5 ? m2 : x);
                      0 === d3.distRatio ? c3.push(d3.id) : d3.id > 0 && (f4.push(d3.id), "x" === r5 ? h3.push([d3.distRatio, 0, 0]) : "y" === r5 ? h3.push([0, d3.distRatio, 0]) : h3.push([0, 0, d3.distRatio]));
                    }
                  else
                    c3 = rt(1, "x" === r5 ? b - 1 : "y" === r5 ? _ - 1 : w2 - 1);
                  f4.length > 0 && (n4[a3] = "x" === r5 ? Q(e4, f4, o3, s4, h3, n4[a3]) : "y" === r5 ? tt(e4, f4, o3, s4, h3, n4[a3]) : et(e4, f4, o3, s4, h3, n4[a3]), a3++), c3.length > 0 && (n4[a3] = "x" === r5 ? X(e4, c3, o3, s4, n4[a3]) : "y" === r5 ? J(e4, c3, o3, s4, n4[a3]) : K(e4, c3, o3, s4, n4[a3]), a3++);
                }
                var v2 = t3.caps[r5];
                v2.show && v2.fill && (D(v2.fill), n4[a3] = "x" === r5 ? X(e4, [0, b - 1], o3, s4, n4[a3]) : "y" === r5 ? J(e4, [0, _ - 1], o3, s4, n4[a3]) : K(e4, [0, w2 - 1], o3, s4, n4[a3]), a3++);
              }
            }), 0 === g2 && P(), t3._meshX = n3, t3._meshY = i2, t3._meshZ = a2, t3._meshIntensity = o2, t3._Xs = y, t3._Ys = m2, t3._Zs = x;
          }(), t3;
        }
        t2.exports = { findNearestOnAxis: l, generateIsoMeshes: h, createIsosurfaceTrace: function(t3, e3) {
          var r3 = t3.glplot.gl, i2 = n2({ gl: r3 }), a2 = new u(t3, i2, e3.uid);
          return i2._trace = a2, a2.update(e3), t3.glplot.add(i2), a2;
        } };
      }, 82738: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(73972), a = r2(16249), o = r2(1586);
        function s(t3, e3, r3, n3, a2) {
          var s2 = a2("isomin"), l = a2("isomax");
          null != l && null != s2 && s2 > l && (e3.isomin = null, e3.isomax = null);
          var u = a2("x"), c = a2("y"), f2 = a2("z"), h = a2("value");
          u && u.length && c && c.length && f2 && f2.length && h && h.length ? (i.getComponentMethod("calendars", "handleTraceDefaults")(t3, e3, ["x", "y", "z"], n3), a2("valuehoverformat"), ["x", "y", "z"].forEach(function(t4) {
            a2(t4 + "hoverformat");
            var e4 = "caps." + t4;
            a2(e4 + ".show") && a2(e4 + ".fill");
            var r4 = "slices." + t4;
            a2(r4 + ".show") && (a2(r4 + ".fill"), a2(r4 + ".locations"));
          }), a2("spaceframe.show") && a2("spaceframe.fill"), a2("surface.show") && (a2("surface.count"), a2("surface.fill"), a2("surface.pattern")), a2("contour.show") && (a2("contour.color"), a2("contour.width")), ["text", "hovertext", "hovertemplate", "lighting.ambient", "lighting.diffuse", "lighting.specular", "lighting.roughness", "lighting.fresnel", "lighting.vertexnormalsepsilon", "lighting.facenormalsepsilon", "lightposition.x", "lightposition.y", "lightposition.z", "flatshading", "opacity"].forEach(function(t4) {
            a2(t4);
          }), o(t3, e3, n3, a2, { prefix: "", cLetter: "c" }), e3._length = null) : e3.visible = false;
        }
        t2.exports = { supplyDefaults: function(t3, e3, r3, i2) {
          s(t3, e3, 0, i2, function(r4, i3) {
            return n2.coerce(t3, e3, a, r4, i3);
          });
        }, supplyIsoDefaults: s };
      }, 64943: function(t2, e2, r2) {
        t2.exports = { attributes: r2(16249), supplyDefaults: r2(82738).supplyDefaults, calc: r2(56959), colorbar: { min: "cmin", max: "cmax" }, plot: r2(22674).createIsosurfaceTrace, moduleType: "trace", name: "isosurface", basePlotModule: r2(58547), categories: ["gl3d", "showLegend"], meta: {} };
      }, 2418: function(t2, e2, r2) {
        var n2 = r2(50693), i = r2(12663).axisHoverFormat, a = r2(5386).f, o = r2(54532), s = r2(9012), l = r2(1426).extendFlat;
        t2.exports = l({ x: { valType: "data_array", editType: "calc+clearAxisTypes" }, y: { valType: "data_array", editType: "calc+clearAxisTypes" }, z: { valType: "data_array", editType: "calc+clearAxisTypes" }, i: { valType: "data_array", editType: "calc" }, j: { valType: "data_array", editType: "calc" }, k: { valType: "data_array", editType: "calc" }, text: { valType: "string", dflt: "", arrayOk: true, editType: "calc" }, hovertext: { valType: "string", dflt: "", arrayOk: true, editType: "calc" }, hovertemplate: a({ editType: "calc" }), xhoverformat: i("x"), yhoverformat: i("y"), zhoverformat: i("z"), delaunayaxis: { valType: "enumerated", values: ["x", "y", "z"], dflt: "z", editType: "calc" }, alphahull: { valType: "number", dflt: -1, editType: "calc" }, intensity: { valType: "data_array", editType: "calc" }, intensitymode: { valType: "enumerated", values: ["vertex", "cell"], dflt: "vertex", editType: "calc" }, color: { valType: "color", editType: "calc" }, vertexcolor: { valType: "data_array", editType: "calc" }, facecolor: { valType: "data_array", editType: "calc" }, transforms: void 0 }, n2("", { colorAttr: "`intensity`", showScaleDflt: true, editTypeOverride: "calc" }), { opacity: o.opacity, flatshading: { valType: "boolean", dflt: false, editType: "calc" }, contour: { show: l({}, o.contours.x.show, {}), color: o.contours.x.color, width: o.contours.x.width, editType: "calc" }, lightposition: { x: l({}, o.lightposition.x, { dflt: 1e5 }), y: l({}, o.lightposition.y, { dflt: 1e5 }), z: l({}, o.lightposition.z, { dflt: 0 }), editType: "calc" }, lighting: l({ vertexnormalsepsilon: { valType: "number", min: 0, max: 1, dflt: 1e-12, editType: "calc" }, facenormalsepsilon: { valType: "number", min: 0, max: 1, dflt: 1e-6, editType: "calc" }, editType: "calc" }, o.lighting), hoverinfo: l({}, s.hoverinfo, { editType: "calc" }), showlegend: l({}, s.showlegend, { dflt: false }) });
      }, 82932: function(t2, e2, r2) {
        var n2 = r2(78803);
        t2.exports = function(t3, e3) {
          e3.intensity && n2(t3, e3, { vals: e3.intensity, containerStr: "", cLetter: "c" });
        };
      }, 91134: function(t2, e2, r2) {
        var n2 = r2(9330).gl_mesh3d, i = r2(9330).delaunay_triangulate, a = r2(9330).alpha_shape, o = r2(9330).convex_hull, s = r2(81697).parseColorScale, l = r2(78614), u = r2(21081).extractOpts, c = r2(90060);
        function f2(t3, e3, r3) {
          this.scene = t3, this.uid = r3, this.mesh = e3, this.name = "", this.color = "#fff", this.data = null, this.showContour = false;
        }
        var h = f2.prototype;
        function p2(t3) {
          for (var e3 = [], r3 = t3.length, n3 = 0; n3 < r3; n3++)
            e3[n3] = l(t3[n3]);
          return e3;
        }
        function d2(t3, e3, r3, n3) {
          for (var i2 = [], a2 = e3.length, o2 = 0; o2 < a2; o2++)
            i2[o2] = t3.d2l(e3[o2], 0, n3) * r3;
          return i2;
        }
        function v(t3) {
          for (var e3 = [], r3 = t3.length, n3 = 0; n3 < r3; n3++)
            e3[n3] = Math.round(t3[n3]);
          return e3;
        }
        function g2(t3, e3) {
          for (var r3 = t3.length, n3 = 0; n3 < r3; n3++)
            if (t3[n3] <= -0.5 || t3[n3] >= e3 - 0.5)
              return false;
          return true;
        }
        h.handlePick = function(t3) {
          if (t3.object === this.mesh) {
            var e3 = t3.index = t3.data.index;
            t3.data._cellCenter ? t3.traceCoordinate = t3.data.dataCoordinate : t3.traceCoordinate = [this.data.x[e3], this.data.y[e3], this.data.z[e3]];
            var r3 = this.data.hovertext || this.data.text;
            return Array.isArray(r3) && void 0 !== r3[e3] ? t3.textLabel = r3[e3] : r3 && (t3.textLabel = r3), true;
          }
        }, h.update = function(t3) {
          var e3 = this.scene, r3 = e3.fullSceneLayout;
          this.data = t3;
          var n3, f3 = t3.x.length, h2 = c(d2(r3.xaxis, t3.x, e3.dataScale[0], t3.xcalendar), d2(r3.yaxis, t3.y, e3.dataScale[1], t3.ycalendar), d2(r3.zaxis, t3.z, e3.dataScale[2], t3.zcalendar));
          if (t3.i && t3.j && t3.k) {
            if (t3.i.length !== t3.j.length || t3.j.length !== t3.k.length || !g2(t3.i, f3) || !g2(t3.j, f3) || !g2(t3.k, f3))
              return;
            n3 = c(v(t3.i), v(t3.j), v(t3.k));
          } else
            n3 = 0 === t3.alphahull ? o(h2) : t3.alphahull > 0 ? a(t3.alphahull, h2) : function(t4, e4) {
              for (var r4 = ["x", "y", "z"].indexOf(t4), n4 = [], a2 = e4.length, o2 = 0; o2 < a2; o2++)
                n4[o2] = [e4[o2][(r4 + 1) % 3], e4[o2][(r4 + 2) % 3]];
              return i(n4);
            }(t3.delaunayaxis, h2);
          var y = { positions: h2, cells: n3, lightPosition: [t3.lightposition.x, t3.lightposition.y, t3.lightposition.z], ambient: t3.lighting.ambient, diffuse: t3.lighting.diffuse, specular: t3.lighting.specular, roughness: t3.lighting.roughness, fresnel: t3.lighting.fresnel, vertexNormalsEpsilon: t3.lighting.vertexnormalsepsilon, faceNormalsEpsilon: t3.lighting.facenormalsepsilon, opacity: t3.opacity, contourEnable: t3.contour.show, contourColor: l(t3.contour.color).slice(0, 3), contourWidth: t3.contour.width, useFacetNormals: t3.flatshading };
          if (t3.intensity) {
            var m2 = u(t3);
            this.color = "#fff";
            var x = t3.intensitymode;
            y[x + "Intensity"] = t3.intensity, y[x + "IntensityBounds"] = [m2.min, m2.max], y.colormap = s(t3);
          } else
            t3.vertexcolor ? (this.color = t3.vertexcolor[0], y.vertexColors = p2(t3.vertexcolor)) : t3.facecolor ? (this.color = t3.facecolor[0], y.cellColors = p2(t3.facecolor)) : (this.color = t3.color, y.meshColor = l(t3.color));
          this.mesh.update(y);
        }, h.dispose = function() {
          this.scene.glplot.remove(this.mesh), this.mesh.dispose();
        }, t2.exports = function(t3, e3) {
          var r3 = t3.glplot.gl, i2 = n2({ gl: r3 }), a2 = new f2(t3, i2, e3.uid);
          return i2._trace = a2, a2.update(e3), t3.glplot.add(i2), a2;
        };
      }, 58669: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828), a = r2(1586), o = r2(2418);
        t2.exports = function(t3, e3, r3, s) {
          function l(r4, n3) {
            return i.coerce(t3, e3, o, r4, n3);
          }
          function u(t4) {
            var e4 = t4.map(function(t5) {
              var e5 = l(t5);
              return e5 && i.isArrayOrTypedArray(e5) ? e5 : null;
            });
            return e4.every(function(t5) {
              return t5 && t5.length === e4[0].length;
            }) && e4;
          }
          u(["x", "y", "z"]) ? (u(["i", "j", "k"]), (!e3.i || e3.j && e3.k) && (!e3.j || e3.k && e3.i) && (!e3.k || e3.i && e3.j) ? (n2.getComponentMethod("calendars", "handleTraceDefaults")(t3, e3, ["x", "y", "z"], s), ["lighting.ambient", "lighting.diffuse", "lighting.specular", "lighting.roughness", "lighting.fresnel", "lighting.vertexnormalsepsilon", "lighting.facenormalsepsilon", "lightposition.x", "lightposition.y", "lightposition.z", "flatshading", "alphahull", "delaunayaxis", "opacity"].forEach(function(t4) {
            l(t4);
          }), l("contour.show") && (l("contour.color"), l("contour.width")), "intensity" in t3 ? (l("intensity"), l("intensitymode"), a(t3, e3, s, l, { prefix: "", cLetter: "c" })) : (e3.showscale = false, "facecolor" in t3 ? l("facecolor") : "vertexcolor" in t3 ? l("vertexcolor") : l("color", r3)), l("text"), l("hovertext"), l("hovertemplate"), l("xhoverformat"), l("yhoverformat"), l("zhoverformat"), e3._length = null) : e3.visible = false) : e3.visible = false;
        };
      }, 21164: function(t2, e2, r2) {
        t2.exports = { attributes: r2(2418), supplyDefaults: r2(58669), calc: r2(82932), colorbar: { min: "cmin", max: "cmax" }, plot: r2(91134), moduleType: "trace", name: "mesh3d", basePlotModule: r2(58547), categories: ["gl3d", "showLegend"], meta: {} };
      }, 2522: function(t2, e2, r2) {
        var n2 = r2(71828).extendFlat, i = r2(82196), a = r2(12663).axisHoverFormat, o = r2(79952).P, s = r2(77914), l = r2(22372), u = l.INCREASING.COLOR, c = l.DECREASING.COLOR, f2 = i.line;
        function h(t3) {
          return { line: { color: n2({}, f2.color, { dflt: t3 }), width: f2.width, dash: o, editType: "style" }, editType: "style" };
        }
        t2.exports = { xperiod: i.xperiod, xperiod0: i.xperiod0, xperiodalignment: i.xperiodalignment, xhoverformat: a("x"), yhoverformat: a("y"), x: { valType: "data_array", editType: "calc+clearAxisTypes" }, open: { valType: "data_array", editType: "calc" }, high: { valType: "data_array", editType: "calc" }, low: { valType: "data_array", editType: "calc" }, close: { valType: "data_array", editType: "calc" }, line: { width: n2({}, f2.width, {}), dash: n2({}, o, {}), editType: "style" }, increasing: h(u), decreasing: h(c), text: { valType: "string", dflt: "", arrayOk: true, editType: "calc" }, hovertext: { valType: "string", dflt: "", arrayOk: true, editType: "calc" }, tickwidth: { valType: "number", min: 0, max: 0.5, dflt: 0.3, editType: "calc" }, hoverlabel: n2({}, s.hoverlabel, { split: { valType: "boolean", dflt: false, editType: "style" } }) };
      }, 3485: function(t2, e2, r2) {
        var n2 = r2(71828), i = n2._, a = r2(89298), o = r2(42973), s = r2(50606).BADNUM;
        function l(t3, e3, r3, n3) {
          return { o: t3, h: e3, l: r3, c: n3 };
        }
        function u(t3, e3, r3, o2, l2, u2) {
          for (var c = l2.makeCalcdata(e3, "open"), f2 = l2.makeCalcdata(e3, "high"), h = l2.makeCalcdata(e3, "low"), p2 = l2.makeCalcdata(e3, "close"), d2 = Array.isArray(e3.text), v = Array.isArray(e3.hovertext), g2 = true, y = null, m2 = !!e3.xperiodalignment, x = [], b = 0; b < o2.length; b++) {
            var _ = o2[b], w2 = c[b], T = f2[b], k = h[b], A = p2[b];
            if (_ !== s && w2 !== s && T !== s && k !== s && A !== s) {
              A === w2 ? null !== y && A !== y && (g2 = A > y) : g2 = A > w2, y = A;
              var M = u2(w2, T, k, A);
              M.pos = _, M.yc = (w2 + A) / 2, M.i = b, M.dir = g2 ? "increasing" : "decreasing", M.x = M.pos, M.y = [k, T], m2 && (M.orig_p = r3[b]), d2 && (M.tx = e3.text[b]), v && (M.htx = e3.hovertext[b]), x.push(M);
            } else
              x.push({ pos: _, empty: true });
          }
          return e3._extremes[l2._id] = a.findExtremes(l2, n2.concat(h, f2), { padded: true }), x.length && (x[0].t = { labels: { open: i(t3, "open:") + " ", high: i(t3, "high:") + " ", low: i(t3, "low:") + " ", close: i(t3, "close:") + " " } }), x;
        }
        t2.exports = { calc: function(t3, e3) {
          var r3 = a.getFromId(t3, e3.xaxis), i2 = a.getFromId(t3, e3.yaxis), s2 = function(t4, e4, r4) {
            var i3 = r4._minDiff;
            if (!i3) {
              var a2, s3 = t4._fullData, l2 = [];
              for (i3 = 1 / 0, a2 = 0; a2 < s3.length; a2++) {
                var u2 = s3[a2];
                if ("ohlc" === u2.type && true === u2.visible && u2.xaxis === e4._id) {
                  l2.push(u2);
                  var c2 = e4.makeCalcdata(u2, "x");
                  u2._origX = c2;
                  var f3 = o(r4, e4, "x", c2).vals;
                  u2._xcalc = f3;
                  var h2 = n2.distinctVals(f3).minDiff;
                  h2 && isFinite(h2) && (i3 = Math.min(i3, h2));
                }
              }
              for (i3 === 1 / 0 && (i3 = 1), a2 = 0; a2 < l2.length; a2++)
                l2[a2]._minDiff = i3;
            }
            return i3 * r4.tickwidth;
          }(t3, r3, e3), c = e3._minDiff;
          e3._minDiff = null;
          var f2 = e3._origX;
          e3._origX = null;
          var h = e3._xcalc;
          e3._xcalc = null;
          var p2 = u(t3, e3, f2, h, i2, l);
          return e3._extremes[r3._id] = a.findExtremes(r3, h, { vpad: c / 2 }), p2.length ? (n2.extendFlat(p2[0].t, { wHover: c / 2, tickLen: s2 }), p2) : [{ t: { empty: true } }];
        }, calcCommon: u };
      }, 16169: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(14555), a = r2(73927), o = r2(2522);
        function s(t3, e3, r3, n3) {
          r3(n3 + ".line.color"), r3(n3 + ".line.width", e3.line.width), r3(n3 + ".line.dash", e3.line.dash);
        }
        t2.exports = function(t3, e3, r3, l) {
          function u(r4, i2) {
            return n2.coerce(t3, e3, o, r4, i2);
          }
          i(t3, e3, u, l) ? (a(t3, e3, l, u, { x: true }), u("xhoverformat"), u("yhoverformat"), u("line.width"), u("line.dash"), s(0, e3, u, "increasing"), s(0, e3, u, "decreasing"), u("text"), u("hovertext"), u("tickwidth"), l._requestRangeslider[e3.xaxis] = true) : e3.visible = false;
        };
      }, 66449: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(71828), a = r2(30211), o = r2(7901), s = r2(71828).fillText, l = r2(22372), u = { increasing: l.INCREASING.SYMBOL, decreasing: l.DECREASING.SYMBOL };
        function c(t3, e3, r3, n3) {
          var i2, s2, l2 = t3.cd, u2 = t3.xa, c2 = l2[0].trace, f3 = l2[0].t, h2 = c2.type, p2 = "ohlc" === h2 ? "l" : "min", d2 = "ohlc" === h2 ? "h" : "max", v = f3.bPos || 0, g2 = f3.bdPos || f3.tickLen, y = f3.wHover, m2 = Math.min(1, g2 / Math.abs(u2.r2c(u2.range[1]) - u2.r2c(u2.range[0])));
          function x(t4) {
            var r4 = function(t5) {
              return t5.pos + v - e3;
            }(t4);
            return a.inbox(r4 - y, r4 + y, i2);
          }
          function b(t4) {
            var e4 = t4[p2], n4 = t4[d2];
            return e4 === n4 || a.inbox(e4 - r3, n4 - r3, i2);
          }
          function _(t4) {
            return (x(t4) + b(t4)) / 2;
          }
          i2 = t3.maxHoverDistance - m2, s2 = t3.maxSpikeDistance - m2;
          var w2 = a.getDistanceFunction(n3, x, b, _);
          if (a.getClosest(l2, w2, t3), false === t3.index)
            return null;
          var T = l2[t3.index];
          if (T.empty)
            return null;
          var k = c2[T.dir], A = k.line.color;
          return o.opacity(A) && k.line.width ? t3.color = A : t3.color = k.fillcolor, t3.x0 = u2.c2p(T.pos + v - g2, true), t3.x1 = u2.c2p(T.pos + v + g2, true), t3.xLabelVal = void 0 !== T.orig_p ? T.orig_p : T.pos, t3.spikeDistance = _(T) * s2 / i2, t3.xSpike = u2.c2p(T.pos, true), t3;
        }
        function f2(t3, e3, r3, a2) {
          var o2 = t3.cd, s2 = t3.ya, l2 = o2[0].trace, u2 = o2[0].t, f3 = [], h2 = c(t3, e3, r3, a2);
          if (!h2)
            return [];
          var p2 = o2[h2.index].hi || l2.hoverinfo, d2 = p2.split("+");
          if ("all" !== p2 && -1 === d2.indexOf("y"))
            return [];
          for (var v = ["high", "open", "close", "low"], g2 = {}, y = 0; y < v.length; y++) {
            var m2, x = v[y], b = l2[x][h2.index], _ = s2.c2p(b, true);
            b in g2 ? (m2 = g2[b]).yLabel += "<br>" + u2.labels[x] + n2.hoverLabelText(s2, b, l2.yhoverformat) : ((m2 = i.extendFlat({}, h2)).y0 = m2.y1 = _, m2.yLabelVal = b, m2.yLabel = u2.labels[x] + n2.hoverLabelText(s2, b, l2.yhoverformat), m2.name = "", f3.push(m2), g2[b] = m2);
          }
          return f3;
        }
        function h(t3, e3, r3, i2) {
          var a2 = t3.cd, o2 = t3.ya, l2 = a2[0].trace, f3 = a2[0].t, h2 = c(t3, e3, r3, i2);
          if (!h2)
            return [];
          var p2 = a2[h2.index], d2 = h2.index = p2.i, v = p2.dir;
          function g2(t4) {
            return f3.labels[t4] + n2.hoverLabelText(o2, l2[t4][d2], l2.yhoverformat);
          }
          var y = p2.hi || l2.hoverinfo, m2 = y.split("+"), x = "all" === y, b = x || -1 !== m2.indexOf("y"), _ = x || -1 !== m2.indexOf("text"), w2 = b ? [g2("open"), g2("high"), g2("low"), g2("close") + "  " + u[v]] : [];
          return _ && s(p2, l2, w2), h2.extraText = w2.join("<br>"), h2.y0 = h2.y1 = o2.c2p(p2.yc, true), [h2];
        }
        t2.exports = { hoverPoints: function(t3, e3, r3, n3) {
          return t3.cd[0].trace.hoverlabel.split ? f2(t3, e3, r3, n3) : h(t3, e3, r3, n3);
        }, hoverSplit: f2, hoverOnPoints: h };
      }, 54186: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "ohlc", basePlotModule: r2(93612), categories: ["cartesian", "svg", "showLegend"], meta: {}, attributes: r2(2522), supplyDefaults: r2(16169), calc: r2(3485).calc, plot: r2(72314), style: r2(53101), hoverPoints: r2(66449).hoverPoints, selectPoints: r2(67324) };
      }, 14555: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828);
        t2.exports = function(t3, e3, r3, a) {
          var o = r3("x"), s = r3("open"), l = r3("high"), u = r3("low"), c = r3("close");
          if (r3("hoverlabel.split"), n2.getComponentMethod("calendars", "handleTraceDefaults")(t3, e3, ["x"], a), s && l && u && c) {
            var f2 = Math.min(s.length, l.length, u.length, c.length);
            return o && (f2 = Math.min(f2, i.minRowLength(o))), e3._length = f2, f2;
          }
        };
      }, 72314: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828);
        t2.exports = function(t3, e3, r3, a) {
          var o = e3.yaxis, s = e3.xaxis, l = !!s.rangebreaks;
          i.makeTraceGroups(a, r3, "trace ohlc").each(function(t4) {
            var e4 = n2.select(this), r4 = t4[0], a2 = r4.t;
            if (true !== r4.trace.visible || a2.empty)
              e4.remove();
            else {
              var u = a2.tickLen, c = e4.selectAll("path").data(i.identity);
              c.enter().append("path"), c.exit().remove(), c.attr("d", function(t5) {
                if (t5.empty)
                  return "M0,0Z";
                var e5 = s.c2p(t5.pos - u, true), r5 = s.c2p(t5.pos + u, true), n3 = l ? (e5 + r5) / 2 : s.c2p(t5.pos, true);
                return "M" + e5 + "," + o.c2p(t5.o, true) + "H" + n3 + "M" + n3 + "," + o.c2p(t5.h, true) + "V" + o.c2p(t5.l, true) + "M" + r5 + "," + o.c2p(t5.c, true) + "H" + n3;
              });
            }
          });
        };
      }, 67324: function(t2) {
        t2.exports = function(t3, e2) {
          var r2, n2 = t3.cd, i = t3.xaxis, a = t3.yaxis, o = [], s = n2[0].t.bPos || 0;
          if (false === e2)
            for (r2 = 0; r2 < n2.length; r2++)
              n2[r2].selected = 0;
          else
            for (r2 = 0; r2 < n2.length; r2++) {
              var l = n2[r2];
              e2.contains([i.c2p(l.pos + s), a.c2p(l.yc)], null, l.i, t3) ? (o.push({ pointNumber: l.i, x: i.c2d(l.pos), y: a.c2d(l.yc) }), l.selected = 1) : l.selected = 0;
            }
          return o;
        };
      }, 53101: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(91424), a = r2(7901);
        t2.exports = function(t3, e3, r3) {
          var o = r3 || n2.select(t3).selectAll("g.ohlclayer").selectAll("g.trace");
          o.style("opacity", function(t4) {
            return t4[0].trace.opacity;
          }), o.each(function(t4) {
            var e4 = t4[0].trace;
            n2.select(this).selectAll("path").each(function(t5) {
              if (!t5.empty) {
                var r4 = e4[t5.dir].line;
                n2.select(this).style("fill", "none").call(a.stroke, r4.color).call(i.dashLine, r4.dash, r4.width).style("opacity", e4.selectedpoints && !t5.selected ? 0.3 : 1);
              }
            });
          });
        };
      }, 99506: function(t2, e2, r2) {
        var n2 = r2(1426).extendFlat, i = r2(9012), a = r2(41940), o = r2(50693), s = r2(5386).f, l = r2(27670).Y, u = n2({ editType: "calc" }, o("line", { editTypeOverride: "calc" }), { shape: { valType: "enumerated", values: ["linear", "hspline"], dflt: "linear", editType: "plot" }, hovertemplate: s({ editType: "plot", arrayOk: false }, { keys: ["count", "probability"] }) });
        t2.exports = { domain: l({ name: "parcats", trace: true, editType: "calc" }), hoverinfo: n2({}, i.hoverinfo, { flags: ["count", "probability"], editType: "plot", arrayOk: false }), hoveron: { valType: "enumerated", values: ["category", "color", "dimension"], dflt: "category", editType: "plot" }, hovertemplate: s({ editType: "plot", arrayOk: false }, { keys: ["count", "probability", "category", "categorycount", "colorcount", "bandcolorcount"] }), arrangement: { valType: "enumerated", values: ["perpendicular", "freeform", "fixed"], dflt: "perpendicular", editType: "plot" }, bundlecolors: { valType: "boolean", dflt: true, editType: "plot" }, sortpaths: { valType: "enumerated", values: ["forward", "backward"], dflt: "forward", editType: "plot" }, labelfont: a({ editType: "calc" }), tickfont: a({ editType: "calc" }), dimensions: { _isLinkedToArray: "dimension", label: { valType: "string", editType: "calc" }, categoryorder: { valType: "enumerated", values: ["trace", "category ascending", "category descending", "array"], dflt: "trace", editType: "calc" }, categoryarray: { valType: "data_array", editType: "calc" }, ticktext: { valType: "data_array", editType: "calc" }, values: { valType: "data_array", dflt: [], editType: "calc" }, displayindex: { valType: "integer", editType: "calc" }, editType: "calc", visible: { valType: "boolean", dflt: true, editType: "calc" } }, line: u, counts: { valType: "number", min: 0, dflt: 1, arrayOk: true, editType: "calc" }, customdata: void 0, hoverlabel: void 0, ids: void 0, legendgroup: void 0, legendrank: void 0, opacity: void 0, selectedpoints: void 0, showlegend: void 0 };
      }, 27677: function(t2, e2, r2) {
        var n2 = r2(27659).a0, i = r2(45784), a = "parcats";
        e2.name = a, e2.plot = function(t3, e3, r3, o) {
          var s = n2(t3.calcdata, a);
          if (s.length) {
            var l = s[0];
            i(t3, l, r3, o);
          }
        }, e2.clean = function(t3, e3, r3, n3) {
          var i2 = n3._has && n3._has("parcats"), a2 = e3._has && e3._has("parcats");
          i2 && !a2 && n3._paperdiv.selectAll(".parcats").remove();
        };
      }, 28699: function(t2, e2, r2) {
        var n2 = r2(28984).wrap, i = r2(52075).hasColorscale, a = r2(78803), o = r2(75744), s = r2(91424), l = r2(71828), u = r2(92770);
        function c(t3, e3, r3) {
          t3.valueInds.push(e3), t3.count += r3;
        }
        function f2(t3, e3, r3) {
          return { categoryInds: t3, color: e3, rawColor: r3, valueInds: [], count: 0 };
        }
        function h(t3, e3, r3) {
          t3.valueInds.push(e3), t3.count += r3;
        }
        t2.exports = function(t3, e3) {
          var r3 = l.filterVisible(e3.dimensions);
          if (0 === r3.length)
            return [];
          var p2, d2, v, g2 = r3.map(function(t4) {
            var e4;
            if ("trace" === t4.categoryorder)
              e4 = null;
            else if ("array" === t4.categoryorder)
              e4 = t4.categoryarray;
            else {
              e4 = o(t4.values);
              for (var r4 = true, n3 = 0; n3 < e4.length; n3++)
                if (!u(e4[n3])) {
                  r4 = false;
                  break;
                }
              e4.sort(r4 ? l.sorterAsc : void 0), "category descending" === t4.categoryorder && (e4 = e4.reverse());
            }
            return function(t5, e5) {
              e5 = null == e5 ? [] : e5.map(function(t6) {
                return t6;
              });
              var r5 = {}, n4 = {}, i2 = [];
              e5.forEach(function(t6, e6) {
                r5[t6] = 0, n4[t6] = e6;
              });
              for (var a2 = 0; a2 < t5.length; a2++) {
                var o2, s2 = t5[a2];
                void 0 === r5[s2] ? (r5[s2] = 1, o2 = e5.push(s2) - 1, n4[s2] = o2) : (r5[s2]++, o2 = n4[s2]), i2.push(o2);
              }
              var l2 = e5.map(function(t6) {
                return r5[t6];
              });
              return { uniqueValues: e5, uniqueCounts: l2, inds: i2 };
            }(t4.values, e4);
          });
          p2 = l.isArrayOrTypedArray(e3.counts) ? e3.counts : [e3.counts], function(t4) {
            var e4, r4 = t4.map(function(t5) {
              return t5.displayindex;
            });
            if (function(t5) {
              for (var e5 = new Array(t5.length), r5 = 0; r5 < t5.length; r5++) {
                if (t5[r5] < 0 || t5[r5] >= t5.length)
                  return false;
                if (void 0 !== e5[t5[r5]])
                  return false;
                e5[t5[r5]] = true;
              }
              return true;
            }(r4))
              for (e4 = 0; e4 < t4.length; e4++)
                t4[e4]._displayindex = t4[e4].displayindex;
            else
              for (e4 = 0; e4 < t4.length; e4++)
                t4[e4]._displayindex = e4;
          }(r3), r3.forEach(function(t4, e4) {
            !function(t5, e5) {
              t5._categoryarray = e5.uniqueValues, null === t5.ticktext || void 0 === t5.ticktext ? t5._ticktext = [] : t5._ticktext = t5.ticktext.slice();
              for (var r4 = t5._ticktext.length; r4 < e5.uniqueValues.length; r4++)
                t5._ticktext.push(e5.uniqueValues[r4]);
            }(t4, g2[e4]);
          });
          var y, m2 = e3.line;
          m2 ? (i(e3, "line") && a(t3, e3, { vals: e3.line.color, containerStr: "line", cLetter: "c" }), y = s.tryColorscale(m2)) : y = l.identity;
          var x, b, _, w2, T, k = r3[0].values.length, A = {}, M = g2.map(function(t4) {
            return t4.inds;
          });
          for (v = 0, x = 0; x < k; x++) {
            var S = [];
            for (b = 0; b < M.length; b++)
              S.push(M[b][x]);
            d2 = p2[x % p2.length], v += d2;
            var E = (_ = x, w2 = void 0, T = void 0, l.isArrayOrTypedArray(m2.color) ? T = w2 = m2.color[_ % m2.color.length] : w2 = m2.color, { color: y(w2), rawColor: T }), L = S + "-" + E.rawColor;
            void 0 === A[L] && (A[L] = f2(S, E.color, E.rawColor)), h(A[L], x, d2);
          }
          var C, P = r3.map(function(t4, e4) {
            return function(t5, e5, r4, n3, i2) {
              return { dimensionInd: t5, containerInd: e5, displayInd: r4, dimensionLabel: n3, count: i2, categories: [], dragX: null };
            }(e4, t4._index, t4._displayindex, t4.label, v);
          });
          for (x = 0; x < k; x++)
            for (d2 = p2[x % p2.length], b = 0; b < P.length; b++) {
              var O = P[b].containerInd, I = g2[b].inds[x], D = P[b].categories;
              if (void 0 === D[I]) {
                var z = e3.dimensions[O]._categoryarray[I], R = e3.dimensions[O]._ticktext[I];
                D[I] = { dimensionInd: b, categoryInd: C = I, categoryValue: z, displayInd: C, categoryLabel: R, valueInds: [], count: 0, dragY: null };
              }
              c(D[I], x, d2);
            }
          return n2(function(t4, e4, r4) {
            var n3 = t4.map(function(t5) {
              return t5.categories.length;
            }).reduce(function(t5, e5) {
              return Math.max(t5, e5);
            });
            return { dimensions: t4, paths: e4, trace: void 0, maxCats: n3, count: r4 };
          }(P, A, v));
        };
      }, 14647: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(52075).hasColorscale, a = r2(1586), o = r2(27670).c, s = r2(85501), l = r2(99506), u = r2(94397);
        function c(t3, e3) {
          function r3(r4, i3) {
            return n2.coerce(t3, e3, l.dimensions, r4, i3);
          }
          var i2 = r3("values"), a2 = r3("visible");
          if (i2 && i2.length || (a2 = e3.visible = false), a2) {
            r3("label"), r3("displayindex", e3._index);
            var o2, s2 = t3.categoryarray, u2 = Array.isArray(s2) && s2.length > 0;
            u2 && (o2 = "array");
            var c2 = r3("categoryorder", o2);
            "array" === c2 ? (r3("categoryarray"), r3("ticktext")) : (delete t3.categoryarray, delete t3.ticktext), u2 || "array" !== c2 || (e3.categoryorder = "trace");
          }
        }
        t2.exports = function(t3, e3, r3, f2) {
          function h(r4, i2) {
            return n2.coerce(t3, e3, l, r4, i2);
          }
          var p2 = s(t3, e3, { name: "dimensions", handleItemDefaults: c }), d2 = function(t4, e4, r4, o2, s2) {
            s2("line.shape"), s2("line.hovertemplate");
            var l2 = s2("line.color", o2.colorway[0]);
            if (i(t4, "line") && n2.isArrayOrTypedArray(l2)) {
              if (l2.length)
                return s2("line.colorscale"), a(t4, e4, o2, s2, { prefix: "line.", cLetter: "c" }), l2.length;
              e4.line.color = r4;
            }
            return 1 / 0;
          }(t3, e3, r3, f2, h);
          o(e3, f2, h), Array.isArray(p2) && p2.length || (e3.visible = false), u(e3, p2, "values", d2), h("hoveron"), h("hovertemplate"), h("arrangement"), h("bundlecolors"), h("sortpaths"), h("counts");
          var v = { family: f2.font.family, size: Math.round(f2.font.size), color: f2.font.color };
          n2.coerceFont(h, "labelfont", v);
          var g2 = { family: f2.font.family, size: Math.round(f2.font.size / 1.2), color: f2.font.color };
          n2.coerceFont(h, "tickfont", g2);
        };
      }, 94873: function(t2, e2, r2) {
        t2.exports = { attributes: r2(99506), supplyDefaults: r2(14647), calc: r2(28699), plot: r2(45784), colorbar: { container: "line", min: "cmin", max: "cmax" }, moduleType: "trace", name: "parcats", basePlotModule: r2(27677), categories: ["noOpacity"], meta: {} };
      }, 45460: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(81684).k4, a = r2(72391), o = r2(30211), s = r2(71828), l = s.strTranslate, u = r2(91424), c = r2(84267), f2 = r2(63893);
        function h(t3, e3, r3, i2) {
          var a2 = e3._context.staticPlot, o2 = t3.map(F.bind(0, e3, r3)), c2 = i2.selectAll("g.parcatslayer").data([null]);
          c2.enter().append("g").attr("class", "parcatslayer").style("pointer-events", a2 ? "none" : "all");
          var h2 = c2.selectAll("g.trace.parcats").data(o2, p2), m3 = h2.enter().append("g").attr("class", "trace parcats");
          h2.attr("transform", function(t4) {
            return l(t4.x, t4.y);
          }), m3.append("g").attr("class", "paths");
          var x2 = h2.select("g.paths").selectAll("path.path").data(function(t4) {
            return t4.paths;
          }, p2);
          x2.attr("fill", function(t4) {
            return t4.model.color;
          });
          var w3 = x2.enter().append("path").attr("class", "path").attr("stroke-opacity", 0).attr("fill", function(t4) {
            return t4.model.color;
          }).attr("fill-opacity", 0);
          _(w3), x2.attr("d", function(t4) {
            return t4.svgD;
          }), w3.empty() || x2.sort(v), x2.exit().remove(), x2.on("mouseover", g2).on("mouseout", y).on("click", b), m3.append("g").attr("class", "dimensions");
          var A2 = h2.select("g.dimensions").selectAll("g.dimension").data(function(t4) {
            return t4.dimensions;
          }, p2);
          A2.enter().append("g").attr("class", "dimension"), A2.attr("transform", function(t4) {
            return l(t4.x, 0);
          }), A2.exit().remove();
          var M2 = A2.selectAll("g.category").data(function(t4) {
            return t4.categories;
          }, p2), S2 = M2.enter().append("g").attr("class", "category");
          M2.attr("transform", function(t4) {
            return l(0, t4.y);
          }), S2.append("rect").attr("class", "catrect").attr("pointer-events", "none"), M2.select("rect.catrect").attr("fill", "none").attr("width", function(t4) {
            return t4.width;
          }).attr("height", function(t4) {
            return t4.height;
          }), T(S2);
          var E2 = M2.selectAll("rect.bandrect").data(function(t4) {
            return t4.bands;
          }, p2);
          E2.each(function() {
            s.raiseToTop(this);
          }), E2.attr("fill", function(t4) {
            return t4.color;
          });
          var D2 = E2.enter().append("rect").attr("class", "bandrect").attr("stroke-opacity", 0).attr("fill", function(t4) {
            return t4.color;
          }).attr("fill-opacity", 0);
          E2.attr("fill", function(t4) {
            return t4.color;
          }).attr("width", function(t4) {
            return t4.width;
          }).attr("height", function(t4) {
            return t4.height;
          }).attr("y", function(t4) {
            return t4.y;
          }).attr("cursor", function(t4) {
            return "fixed" === t4.parcatsViewModel.arrangement ? "default" : "perpendicular" === t4.parcatsViewModel.arrangement ? "ns-resize" : "move";
          }), k(D2), E2.exit().remove(), S2.append("text").attr("class", "catlabel").attr("pointer-events", "none");
          var z2 = e3._fullLayout.paper_bgcolor;
          M2.select("text.catlabel").attr("text-anchor", function(t4) {
            return d2(t4) ? "start" : "end";
          }).attr("alignment-baseline", "middle").style("text-shadow", f2.makeTextShadow(z2)).style("fill", "rgb(0, 0, 0)").attr("x", function(t4) {
            return d2(t4) ? t4.width + 5 : -5;
          }).attr("y", function(t4) {
            return t4.height / 2;
          }).text(function(t4) {
            return t4.model.categoryLabel;
          }).each(function(t4) {
            u.font(n2.select(this), t4.parcatsViewModel.categorylabelfont), f2.convertToTspans(n2.select(this), e3);
          }), S2.append("text").attr("class", "dimlabel"), M2.select("text.dimlabel").attr("text-anchor", "middle").attr("alignment-baseline", "baseline").attr("cursor", function(t4) {
            return "fixed" === t4.parcatsViewModel.arrangement ? "default" : "ew-resize";
          }).attr("x", function(t4) {
            return t4.width / 2;
          }).attr("y", -5).text(function(t4, e4) {
            return 0 === e4 ? t4.parcatsViewModel.model.dimensions[t4.model.dimensionInd].dimensionLabel : null;
          }).each(function(t4) {
            u.font(n2.select(this), t4.parcatsViewModel.labelfont);
          }), M2.selectAll("rect.bandrect").on("mouseover", L).on("mouseout", C), M2.exit().remove(), A2.call(n2.behavior.drag().origin(function(t4) {
            return { x: t4.x, y: 0 };
          }).on("dragstart", P).on("drag", O).on("dragend", I)), h2.each(function(t4) {
            t4.traceSelection = n2.select(this), t4.pathSelection = n2.select(this).selectAll("g.paths").selectAll("path.path"), t4.dimensionSelection = n2.select(this).selectAll("g.dimensions").selectAll("g.dimension");
          }), h2.exit().remove();
        }
        function p2(t3) {
          return t3.key;
        }
        function d2(t3) {
          var e3 = t3.parcatsViewModel.dimensions.length, r3 = t3.parcatsViewModel.dimensions[e3 - 1].model.dimensionInd;
          return t3.model.dimensionInd === r3;
        }
        function v(t3, e3) {
          return t3.model.rawColor > e3.model.rawColor ? 1 : t3.model.rawColor < e3.model.rawColor ? -1 : 0;
        }
        function g2(t3) {
          if (!t3.parcatsViewModel.dragDimension && -1 === t3.parcatsViewModel.hoverinfoItems.indexOf("skip")) {
            s.raiseToTop(this), w2(n2.select(this));
            var e3 = m2(t3), r3 = x(t3);
            if (t3.parcatsViewModel.graphDiv.emit("plotly_hover", { points: e3, event: n2.event, constraints: r3 }), -1 === t3.parcatsViewModel.hoverinfoItems.indexOf("none")) {
              var i2, a2, l2, u2 = n2.mouse(this)[0], f3 = t3.parcatsViewModel.graphDiv, h2 = t3.parcatsViewModel.trace, p3 = f3._fullLayout, d3 = p3._paperdiv.node().getBoundingClientRect(), v2 = t3.parcatsViewModel.graphDiv.getBoundingClientRect();
              for (l2 = 0; l2 < t3.leftXs.length - 1; l2++)
                if (t3.leftXs[l2] + t3.dimWidths[l2] - 2 <= u2 && u2 <= t3.leftXs[l2 + 1] + 2) {
                  var g3 = t3.parcatsViewModel.dimensions[l2], y2 = t3.parcatsViewModel.dimensions[l2 + 1];
                  i2 = (g3.x + g3.width + y2.x) / 2, a2 = (t3.topYs[l2] + t3.topYs[l2 + 1] + t3.height) / 2;
                  break;
                }
              var b2 = t3.parcatsViewModel.x + i2, _2 = t3.parcatsViewModel.y + a2, T2 = c.mostReadable(t3.model.color, ["black", "white"]), k2 = t3.model.count, A2 = k2 / t3.parcatsViewModel.model.count, M2 = { countLabel: k2, probabilityLabel: A2.toFixed(3) }, S2 = [];
              -1 !== t3.parcatsViewModel.hoverinfoItems.indexOf("count") && S2.push(["Count:", M2.countLabel].join(" ")), -1 !== t3.parcatsViewModel.hoverinfoItems.indexOf("probability") && S2.push(["P:", M2.probabilityLabel].join(" "));
              var E2 = S2.join("<br>"), L2 = n2.mouse(f3)[0];
              o.loneHover({ trace: h2, x: b2 - d3.left + v2.left, y: _2 - d3.top + v2.top, text: E2, color: t3.model.color, borderColor: "black", fontFamily: 'Monaco, "Courier New", monospace', fontSize: 10, fontColor: T2, idealAlign: L2 < b2 ? "right" : "left", hovertemplate: (h2.line || {}).hovertemplate, hovertemplateLabels: M2, eventData: [{ data: h2._input, fullData: h2, count: k2, probability: A2 }] }, { container: p3._hoverlayer.node(), outerContainer: p3._paper.node(), gd: f3 });
            }
          }
        }
        function y(t3) {
          if (!t3.parcatsViewModel.dragDimension && (_(n2.select(this)), o.loneUnhover(t3.parcatsViewModel.graphDiv._fullLayout._hoverlayer.node()), t3.parcatsViewModel.pathSelection.sort(v), -1 === t3.parcatsViewModel.hoverinfoItems.indexOf("skip"))) {
            var e3 = m2(t3), r3 = x(t3);
            t3.parcatsViewModel.graphDiv.emit("plotly_unhover", { points: e3, event: n2.event, constraints: r3 });
          }
        }
        function m2(t3) {
          for (var e3 = [], r3 = D(t3.parcatsViewModel), n3 = 0; n3 < t3.model.valueInds.length; n3++) {
            var i2 = t3.model.valueInds[n3];
            e3.push({ curveNumber: r3, pointNumber: i2 });
          }
          return e3;
        }
        function x(t3) {
          for (var e3 = {}, r3 = t3.parcatsViewModel.model.dimensions, n3 = 0; n3 < r3.length; n3++) {
            var i2 = r3[n3], a2 = i2.categories[t3.model.categoryInds[n3]];
            e3[i2.containerInd] = a2.categoryValue;
          }
          return void 0 !== t3.model.rawColor && (e3.color = t3.model.rawColor), e3;
        }
        function b(t3) {
          if (-1 === t3.parcatsViewModel.hoverinfoItems.indexOf("skip")) {
            var e3 = m2(t3), r3 = x(t3);
            t3.parcatsViewModel.graphDiv.emit("plotly_click", { points: e3, event: n2.event, constraints: r3 });
          }
        }
        function _(t3) {
          t3.attr("fill", function(t4) {
            return t4.model.color;
          }).attr("fill-opacity", 0.6).attr("stroke", "lightgray").attr("stroke-width", 0.2).attr("stroke-opacity", 1);
        }
        function w2(t3) {
          t3.attr("fill-opacity", 0.8).attr("stroke", function(t4) {
            return c.mostReadable(t4.model.color, ["black", "white"]);
          }).attr("stroke-width", 0.3);
        }
        function T(t3) {
          t3.select("rect.catrect").attr("stroke", "black").attr("stroke-width", 1).attr("stroke-opacity", 1);
        }
        function k(t3) {
          t3.attr("stroke", "black").attr("stroke-width", 0.2).attr("stroke-opacity", 1).attr("fill-opacity", 1);
        }
        function A(t3) {
          var e3 = t3.parcatsViewModel.pathSelection, r3 = t3.categoryViewModel.model.dimensionInd, n3 = t3.categoryViewModel.model.categoryInd;
          return e3.filter(function(e4) {
            return e4.model.categoryInds[r3] === n3 && e4.model.color === t3.color;
          });
        }
        function M(t3, e3, r3) {
          var i2 = n2.select(t3).datum(), a2 = i2.categoryViewModel.model, o2 = i2.parcatsViewModel.graphDiv, s2 = n2.select(t3.parentNode).selectAll("rect.bandrect"), l2 = [];
          s2.each(function(t4) {
            A(t4).each(function(t5) {
              Array.prototype.push.apply(l2, m2(t5));
            });
          });
          var u2 = {};
          u2[a2.dimensionInd] = a2.categoryValue, o2.emit(e3, { points: l2, event: r3, constraints: u2 });
        }
        function S(t3, e3, r3) {
          var i2 = n2.select(t3).datum(), a2 = i2.categoryViewModel.model, o2 = i2.parcatsViewModel.graphDiv, s2 = A(i2), l2 = [];
          s2.each(function(t4) {
            Array.prototype.push.apply(l2, m2(t4));
          });
          var u2 = {};
          u2[a2.dimensionInd] = a2.categoryValue, void 0 !== i2.rawColor && (u2.color = i2.rawColor), o2.emit(e3, { points: l2, event: r3, constraints: u2 });
        }
        function E(t3, e3, r3) {
          t3._fullLayout._calcInverseTransform(t3);
          var i2, a2, o2 = t3._fullLayout._invScaleX, s2 = t3._fullLayout._invScaleY, l2 = n2.select(r3.parentNode).select("rect.catrect"), u2 = l2.node().getBoundingClientRect(), c2 = l2.datum(), f3 = c2.parcatsViewModel, h2 = f3.model.dimensions[c2.model.dimensionInd], p3 = f3.trace, d3 = u2.top + u2.height / 2;
          f3.dimensions.length > 1 && h2.displayInd === f3.dimensions.length - 1 ? (i2 = u2.left, a2 = "left") : (i2 = u2.left + u2.width, a2 = "right");
          var v2 = c2.model.count, g3 = c2.model.categoryLabel, y2 = v2 / c2.parcatsViewModel.model.count, m3 = { countLabel: v2, categoryLabel: g3, probabilityLabel: y2.toFixed(3) }, x2 = [];
          -1 !== c2.parcatsViewModel.hoverinfoItems.indexOf("count") && x2.push(["Count:", m3.countLabel].join(" ")), -1 !== c2.parcatsViewModel.hoverinfoItems.indexOf("probability") && x2.push(["P(" + m3.categoryLabel + "):", m3.probabilityLabel].join(" "));
          var b2 = x2.join("<br>");
          return { trace: p3, x: o2 * (i2 - e3.left), y: s2 * (d3 - e3.top), text: b2, color: "lightgray", borderColor: "black", fontFamily: 'Monaco, "Courier New", monospace', fontSize: 12, fontColor: "black", idealAlign: a2, hovertemplate: p3.hovertemplate, hovertemplateLabels: m3, eventData: [{ data: p3._input, fullData: p3, count: v2, category: g3, probability: y2 }] };
        }
        function L(t3) {
          if (!t3.parcatsViewModel.dragDimension && -1 === t3.parcatsViewModel.hoverinfoItems.indexOf("skip")) {
            if (n2.mouse(this)[1] < -1)
              return;
            var e3, r3 = t3.parcatsViewModel.graphDiv, i2 = r3._fullLayout, a2 = i2._paperdiv.node().getBoundingClientRect(), l2 = t3.parcatsViewModel.hoveron, u2 = this;
            "color" === l2 ? (function(t4) {
              var e4 = n2.select(t4).datum(), r4 = A(e4);
              w2(r4), r4.each(function() {
                s.raiseToTop(this);
              }), n2.select(t4.parentNode).selectAll("rect.bandrect").filter(function(t5) {
                return t5.color === e4.color;
              }).each(function() {
                s.raiseToTop(this), n2.select(this).attr("stroke", "black").attr("stroke-width", 1.5);
              });
            }(u2), S(u2, "plotly_hover", n2.event)) : (function(t4) {
              n2.select(t4.parentNode).selectAll("rect.bandrect").each(function(t5) {
                var e4 = A(t5);
                w2(e4), e4.each(function() {
                  s.raiseToTop(this);
                });
              }), n2.select(t4.parentNode).select("rect.catrect").attr("stroke", "black").attr("stroke-width", 2.5);
            }(u2), M(u2, "plotly_hover", n2.event)), -1 === t3.parcatsViewModel.hoverinfoItems.indexOf("none") && ("category" === l2 ? e3 = E(r3, a2, u2) : "color" === l2 ? e3 = function(t4, e4, r4) {
              t4._fullLayout._calcInverseTransform(t4);
              var i3, a3, o2 = t4._fullLayout._invScaleX, s2 = t4._fullLayout._invScaleY, l3 = r4.getBoundingClientRect(), u3 = n2.select(r4).datum(), f3 = u3.categoryViewModel, h2 = f3.parcatsViewModel, p3 = h2.model.dimensions[f3.model.dimensionInd], d3 = h2.trace, v2 = l3.y + l3.height / 2;
              h2.dimensions.length > 1 && p3.displayInd === h2.dimensions.length - 1 ? (i3 = l3.left, a3 = "left") : (i3 = l3.left + l3.width, a3 = "right");
              var g3 = f3.model.categoryLabel, y2 = u3.parcatsViewModel.model.count, m3 = 0;
              u3.categoryViewModel.bands.forEach(function(t5) {
                t5.color === u3.color && (m3 += t5.count);
              });
              var x2 = f3.model.count, b2 = 0;
              h2.pathSelection.each(function(t5) {
                t5.model.color === u3.color && (b2 += t5.model.count);
              });
              var _2 = m3 / y2, w3 = m3 / b2, T2 = m3 / x2, k2 = { countLabel: y2, categoryLabel: g3, probabilityLabel: _2.toFixed(3) }, A2 = [];
              -1 !== f3.parcatsViewModel.hoverinfoItems.indexOf("count") && A2.push(["Count:", k2.countLabel].join(" ")), -1 !== f3.parcatsViewModel.hoverinfoItems.indexOf("probability") && (A2.push("P(color ∩ " + g3 + "): " + k2.probabilityLabel), A2.push("P(" + g3 + " | color): " + w3.toFixed(3)), A2.push("P(color | " + g3 + "): " + T2.toFixed(3)));
              var M2 = A2.join("<br>"), S2 = c.mostReadable(u3.color, ["black", "white"]);
              return { trace: d3, x: o2 * (i3 - e4.left), y: s2 * (v2 - e4.top), text: M2, color: u3.color, borderColor: "black", fontFamily: 'Monaco, "Courier New", monospace', fontColor: S2, fontSize: 10, idealAlign: a3, hovertemplate: d3.hovertemplate, hovertemplateLabels: k2, eventData: [{ data: d3._input, fullData: d3, category: g3, count: y2, probability: _2, categorycount: x2, colorcount: b2, bandcolorcount: m3 }] };
            }(r3, a2, u2) : "dimension" === l2 && (e3 = function(t4, e4, r4) {
              var i3 = [];
              return n2.select(r4.parentNode.parentNode).selectAll("g.category").select("rect.catrect").each(function() {
                i3.push(E(t4, e4, this));
              }), i3;
            }(r3, a2, u2)), e3 && o.loneHover(e3, { container: i2._hoverlayer.node(), outerContainer: i2._paper.node(), gd: r3 }));
          }
        }
        function C(t3) {
          var e3 = t3.parcatsViewModel;
          e3.dragDimension || (_(e3.pathSelection), T(e3.dimensionSelection.selectAll("g.category")), k(e3.dimensionSelection.selectAll("g.category").selectAll("rect.bandrect")), o.loneUnhover(e3.graphDiv._fullLayout._hoverlayer.node()), e3.pathSelection.sort(v), -1 !== e3.hoverinfoItems.indexOf("skip")) || ("color" === t3.parcatsViewModel.hoveron ? S(this, "plotly_unhover", n2.event) : M(this, "plotly_unhover", n2.event));
        }
        function P(t3) {
          "fixed" !== t3.parcatsViewModel.arrangement && (t3.dragDimensionDisplayInd = t3.model.displayInd, t3.initialDragDimensionDisplayInds = t3.parcatsViewModel.model.dimensions.map(function(t4) {
            return t4.displayInd;
          }), t3.dragHasMoved = false, t3.dragCategoryDisplayInd = null, n2.select(this).selectAll("g.category").select("rect.catrect").each(function(e3) {
            var r3 = n2.mouse(this)[0], i2 = n2.mouse(this)[1];
            -2 <= r3 && r3 <= e3.width + 2 && -2 <= i2 && i2 <= e3.height + 2 && (t3.dragCategoryDisplayInd = e3.model.displayInd, t3.initialDragCategoryDisplayInds = t3.model.categories.map(function(t4) {
              return t4.displayInd;
            }), e3.model.dragY = e3.y, s.raiseToTop(this.parentNode), n2.select(this.parentNode).selectAll("rect.bandrect").each(function(e4) {
              e4.y < i2 && i2 <= e4.y + e4.height && (t3.potentialClickBand = this);
            }));
          }), t3.parcatsViewModel.dragDimension = t3, o.loneUnhover(t3.parcatsViewModel.graphDiv._fullLayout._hoverlayer.node()));
        }
        function O(t3) {
          if ("fixed" !== t3.parcatsViewModel.arrangement && (t3.dragHasMoved = true, null !== t3.dragDimensionDisplayInd)) {
            var e3 = t3.dragDimensionDisplayInd, r3 = e3 - 1, i2 = e3 + 1, a2 = t3.parcatsViewModel.dimensions[e3];
            if (null !== t3.dragCategoryDisplayInd) {
              var o2 = a2.categories[t3.dragCategoryDisplayInd];
              o2.model.dragY += n2.event.dy;
              var s2 = o2.model.dragY, l2 = o2.model.displayInd, u2 = a2.categories, c2 = u2[l2 - 1], f3 = u2[l2 + 1];
              void 0 !== c2 && s2 < c2.y + c2.height / 2 && (o2.model.displayInd = c2.model.displayInd, c2.model.displayInd = l2), void 0 !== f3 && s2 + o2.height > f3.y + f3.height / 2 && (o2.model.displayInd = f3.model.displayInd, f3.model.displayInd = l2), t3.dragCategoryDisplayInd = o2.model.displayInd;
            }
            if (null === t3.dragCategoryDisplayInd || "freeform" === t3.parcatsViewModel.arrangement) {
              a2.model.dragX = n2.event.x;
              var h2 = t3.parcatsViewModel.dimensions[r3], p3 = t3.parcatsViewModel.dimensions[i2];
              void 0 !== h2 && a2.model.dragX < h2.x + h2.width && (a2.model.displayInd = h2.model.displayInd, h2.model.displayInd = e3), void 0 !== p3 && a2.model.dragX + a2.width > p3.x && (a2.model.displayInd = p3.model.displayInd, p3.model.displayInd = t3.dragDimensionDisplayInd), t3.dragDimensionDisplayInd = a2.model.displayInd;
            }
            j(t3.parcatsViewModel), N(t3.parcatsViewModel), R(t3.parcatsViewModel), z(t3.parcatsViewModel);
          }
        }
        function I(t3) {
          if ("fixed" !== t3.parcatsViewModel.arrangement && null !== t3.dragDimensionDisplayInd) {
            n2.select(this).selectAll("text").attr("font-weight", "normal");
            var e3 = {}, r3 = D(t3.parcatsViewModel), i2 = t3.parcatsViewModel.model.dimensions.map(function(t4) {
              return t4.displayInd;
            }), o2 = t3.initialDragDimensionDisplayInds.some(function(t4, e4) {
              return t4 !== i2[e4];
            });
            o2 && i2.forEach(function(r4, n3) {
              var i3 = t3.parcatsViewModel.model.dimensions[n3].containerInd;
              e3["dimensions[" + i3 + "].displayindex"] = r4;
            });
            var s2 = false;
            if (null !== t3.dragCategoryDisplayInd) {
              var l2 = t3.model.categories.map(function(t4) {
                return t4.displayInd;
              });
              if (s2 = t3.initialDragCategoryDisplayInds.some(function(t4, e4) {
                return t4 !== l2[e4];
              })) {
                var u2 = t3.model.categories.slice().sort(function(t4, e4) {
                  return t4.displayInd - e4.displayInd;
                }), c2 = u2.map(function(t4) {
                  return t4.categoryValue;
                }), f3 = u2.map(function(t4) {
                  return t4.categoryLabel;
                });
                e3["dimensions[" + t3.model.containerInd + "].categoryarray"] = [c2], e3["dimensions[" + t3.model.containerInd + "].ticktext"] = [f3], e3["dimensions[" + t3.model.containerInd + "].categoryorder"] = "array";
              }
            }
            -1 === t3.parcatsViewModel.hoverinfoItems.indexOf("skip") && !t3.dragHasMoved && t3.potentialClickBand && ("color" === t3.parcatsViewModel.hoveron ? S(t3.potentialClickBand, "plotly_click", n2.event.sourceEvent) : M(t3.potentialClickBand, "plotly_click", n2.event.sourceEvent)), t3.model.dragX = null, null !== t3.dragCategoryDisplayInd && (t3.parcatsViewModel.dimensions[t3.dragDimensionDisplayInd].categories[t3.dragCategoryDisplayInd].model.dragY = null, t3.dragCategoryDisplayInd = null), t3.dragDimensionDisplayInd = null, t3.parcatsViewModel.dragDimension = null, t3.dragHasMoved = null, t3.potentialClickBand = null, j(t3.parcatsViewModel), N(t3.parcatsViewModel), n2.transition().duration(300).ease("cubic-in-out").each(function() {
              R(t3.parcatsViewModel, true), z(t3.parcatsViewModel, true);
            }).each("end", function() {
              (o2 || s2) && a.restyle(t3.parcatsViewModel.graphDiv, e3, [r3]);
            });
          }
        }
        function D(t3) {
          for (var e3, r3 = t3.graphDiv._fullData, n3 = 0; n3 < r3.length; n3++)
            if (t3.key === r3[n3].uid) {
              e3 = n3;
              break;
            }
          return e3;
        }
        function z(t3, e3) {
          var r3;
          void 0 === e3 && (e3 = false), t3.pathSelection.data(function(t4) {
            return t4.paths;
          }, p2), (r3 = t3.pathSelection, e3 ? r3.transition() : r3).attr("d", function(t4) {
            return t4.svgD;
          });
        }
        function R(t3, e3) {
          function r3(t4) {
            return e3 ? t4.transition() : t4;
          }
          void 0 === e3 && (e3 = false), t3.dimensionSelection.data(function(t4) {
            return t4.dimensions;
          }, p2);
          var i2 = t3.dimensionSelection.selectAll("g.category").data(function(t4) {
            return t4.categories;
          }, p2);
          r3(t3.dimensionSelection).attr("transform", function(t4) {
            return l(t4.x, 0);
          }), r3(i2).attr("transform", function(t4) {
            return l(0, t4.y);
          }), i2.select(".dimlabel").text(function(t4, e4) {
            return 0 === e4 ? t4.parcatsViewModel.model.dimensions[t4.model.dimensionInd].dimensionLabel : null;
          }), i2.select(".catlabel").attr("text-anchor", function(t4) {
            return d2(t4) ? "start" : "end";
          }).attr("x", function(t4) {
            return d2(t4) ? t4.width + 5 : -5;
          }).each(function(t4) {
            var e4, r4;
            d2(t4) ? (e4 = t4.width + 5, r4 = "start") : (e4 = -5, r4 = "end"), n2.select(this).selectAll("tspan").attr("x", e4).attr("text-anchor", r4);
          });
          var a2 = i2.selectAll("rect.bandrect").data(function(t4) {
            return t4.bands;
          }, p2), o2 = a2.enter().append("rect").attr("class", "bandrect").attr("cursor", "move").attr("stroke-opacity", 0).attr("fill", function(t4) {
            return t4.color;
          }).attr("fill-opacity", 0);
          a2.attr("fill", function(t4) {
            return t4.color;
          }).attr("width", function(t4) {
            return t4.width;
          }).attr("height", function(t4) {
            return t4.height;
          }).attr("y", function(t4) {
            return t4.y;
          }), k(o2), a2.each(function() {
            s.raiseToTop(this);
          }), a2.exit().remove();
        }
        function F(t3, e3, r3) {
          var n3, i2 = r3[0], a2 = e3.margin || { l: 80, r: 80, t: 100, b: 80 }, o2 = i2.trace, s2 = o2.domain, l2 = e3.width, u2 = e3.height, c2 = Math.floor(l2 * (s2.x[1] - s2.x[0])), f3 = Math.floor(u2 * (s2.y[1] - s2.y[0])), h2 = s2.x[0] * l2 + a2.l, p3 = e3.height - s2.y[1] * e3.height + a2.t, d3 = o2.line.shape;
          n3 = "all" === o2.hoverinfo ? ["count", "probability"] : (o2.hoverinfo || "").split("+");
          var v2 = { trace: o2, key: o2.uid, model: i2, x: h2, y: p3, width: c2, height: f3, hoveron: o2.hoveron, hoverinfoItems: n3, arrangement: o2.arrangement, bundlecolors: o2.bundlecolors, sortpaths: o2.sortpaths, labelfont: o2.labelfont, categorylabelfont: o2.tickfont, pathShape: d3, dragDimension: null, margin: a2, paths: [], dimensions: [], graphDiv: t3, traceSelection: null, pathSelection: null, dimensionSelection: null };
          return i2.dimensions && (j(v2), N(v2)), v2;
        }
        function B(t3, e3, r3, n3, a2) {
          var o2, s2, l2 = [], u2 = [];
          for (s2 = 0; s2 < r3.length - 1; s2++)
            o2 = i(r3[s2] + t3[s2], t3[s2 + 1]), l2.push(o2(a2)), u2.push(o2(1 - a2));
          var c2 = "M " + t3[0] + "," + e3[0];
          for (c2 += "l" + r3[0] + ",0 ", s2 = 1; s2 < r3.length; s2++)
            c2 += "C" + l2[s2 - 1] + "," + e3[s2 - 1] + " " + u2[s2 - 1] + "," + e3[s2] + " " + t3[s2] + "," + e3[s2], c2 += "l" + r3[s2] + ",0 ";
          for (c2 += "l0," + n3 + " ", c2 += "l -" + r3[r3.length - 1] + ",0 ", s2 = r3.length - 2; s2 >= 0; s2--)
            c2 += "C" + u2[s2] + "," + (e3[s2 + 1] + n3) + " " + l2[s2] + "," + (e3[s2] + n3) + " " + (t3[s2] + r3[s2]) + "," + (e3[s2] + n3), c2 += "l-" + r3[s2] + ",0 ";
          return c2 + "Z";
        }
        function N(t3) {
          var e3 = t3.dimensions, r3 = t3.model, n3 = e3.map(function(t4) {
            return t4.categories.map(function(t5) {
              return t5.y;
            });
          }), i2 = t3.model.dimensions.map(function(t4) {
            return t4.categories.map(function(t5) {
              return t5.displayInd;
            });
          }), a2 = t3.model.dimensions.map(function(t4) {
            return t4.displayInd;
          }), o2 = t3.dimensions.map(function(t4) {
            return t4.model.dimensionInd;
          }), s2 = e3.map(function(t4) {
            return t4.x;
          }), l2 = e3.map(function(t4) {
            return t4.width;
          }), u2 = [];
          for (var c2 in r3.paths)
            r3.paths.hasOwnProperty(c2) && u2.push(r3.paths[c2]);
          function f3(t4) {
            var e4 = t4.categoryInds.map(function(t5, e5) {
              return i2[e5][t5];
            });
            return o2.map(function(t5) {
              return e4[t5];
            });
          }
          u2.sort(function(e4, r4) {
            var n4 = f3(e4), i3 = f3(r4);
            return "backward" === t3.sortpaths && (n4.reverse(), i3.reverse()), n4.push(e4.valueInds[0]), i3.push(r4.valueInds[0]), t3.bundlecolors && (n4.unshift(e4.rawColor), i3.unshift(r4.rawColor)), n4 < i3 ? -1 : n4 > i3 ? 1 : 0;
          });
          for (var h2 = new Array(u2.length), p3 = e3[0].model.count, d3 = e3[0].categories.map(function(t4) {
            return t4.height;
          }).reduce(function(t4, e4) {
            return t4 + e4;
          }), v2 = 0; v2 < u2.length; v2++) {
            var g3, y2 = u2[v2];
            g3 = p3 > 0 ? d3 * (y2.count / p3) : 0;
            for (var m3, x2 = new Array(n3.length), b2 = 0; b2 < y2.categoryInds.length; b2++) {
              var _2 = y2.categoryInds[b2], w3 = i2[b2][_2], T2 = a2[b2];
              x2[T2] = n3[T2][w3], n3[T2][w3] += g3;
              var k2 = t3.dimensions[T2].categories[w3], A2 = k2.bands.length, M2 = k2.bands[A2 - 1];
              if (void 0 === M2 || y2.rawColor !== M2.rawColor) {
                var S2 = void 0 === M2 ? 0 : M2.y + M2.height;
                k2.bands.push({ key: S2, color: y2.color, rawColor: y2.rawColor, height: g3, width: k2.width, count: y2.count, y: S2, categoryViewModel: k2, parcatsViewModel: t3 });
              } else {
                var E2 = k2.bands[A2 - 1];
                E2.height += g3, E2.count += y2.count;
              }
            }
            m3 = "hspline" === t3.pathShape ? B(s2, x2, l2, g3, 0.5) : B(s2, x2, l2, g3, 0), h2[v2] = { key: y2.valueInds[0], model: y2, height: g3, leftXs: s2, topYs: x2, dimWidths: l2, svgD: m3, parcatsViewModel: t3 };
          }
          t3.paths = h2;
        }
        function j(t3) {
          var e3 = t3.model.dimensions.map(function(t4) {
            return { displayInd: t4.displayInd, dimensionInd: t4.dimensionInd };
          });
          e3.sort(function(t4, e4) {
            return t4.displayInd - e4.displayInd;
          });
          var r3 = [];
          for (var n3 in e3) {
            var i2 = e3[n3].dimensionInd, a2 = t3.model.dimensions[i2];
            r3.push(U(t3, a2));
          }
          t3.dimensions = r3;
        }
        function U(t3, e3) {
          var r3, n3 = t3.model.dimensions.length, i2 = e3.displayInd;
          r3 = 40 + (n3 > 1 ? (t3.width - 80 - 16) / (n3 - 1) : 0) * i2;
          var a2, o2, s2, l2, u2, c2 = [], f3 = t3.model.maxCats, h2 = e3.categories.length, p3 = e3.count, d3 = t3.height - 8 * (f3 - 1), v2 = 8 * (f3 - h2) / 2, g3 = e3.categories.map(function(t4) {
            return { displayInd: t4.displayInd, categoryInd: t4.categoryInd };
          });
          for (g3.sort(function(t4, e4) {
            return t4.displayInd - e4.displayInd;
          }), u2 = 0; u2 < h2; u2++)
            l2 = g3[u2].categoryInd, o2 = e3.categories[l2], a2 = p3 > 0 ? o2.count / p3 * d3 : 0, s2 = { key: o2.valueInds[0], model: o2, width: 16, height: a2, y: null !== o2.dragY ? o2.dragY : v2, bands: [], parcatsViewModel: t3 }, v2 = v2 + a2 + 8, c2.push(s2);
          return { key: e3.dimensionInd, x: null !== e3.dragX ? e3.dragX : r3, y: 0, width: 16, model: e3, categories: c2, parcatsViewModel: t3, dragCategoryDisplayInd: null, dragDimensionDisplayInd: null, initialDragDimensionDisplayInds: null, initialDragCategoryDisplayInds: null, dragHasMoved: null, potentialClickBand: null };
        }
        t2.exports = function(t3, e3, r3, n3) {
          h(r3, t3, n3, e3);
        };
      }, 45784: function(t2, e2, r2) {
        var n2 = r2(45460);
        t2.exports = function(t3, e3, r3, i) {
          var a = t3._fullLayout, o = a._paper, s = a._size;
          n2(t3, o, e3, { width: s.w, height: s.h, margin: { t: s.t, r: s.r, b: s.b, l: s.l } }, r3, i);
        };
      }, 73362: function(t2, e2, r2) {
        var n2 = r2(50693), i = r2(13838), a = r2(41940), o = r2(27670).Y, s = r2(1426).extendFlat, l = r2(44467).templatedArray;
        t2.exports = { domain: o({ name: "parcoords", trace: true, editType: "plot" }), labelangle: { valType: "angle", dflt: 0, editType: "plot" }, labelside: { valType: "enumerated", values: ["top", "bottom"], dflt: "top", editType: "plot" }, labelfont: a({ editType: "plot" }), tickfont: a({ editType: "plot" }), rangefont: a({ editType: "plot" }), dimensions: l("dimension", { label: { valType: "string", editType: "plot" }, tickvals: s({}, i.tickvals, { editType: "plot" }), ticktext: s({}, i.ticktext, { editType: "plot" }), tickformat: s({}, i.tickformat, { editType: "plot" }), visible: { valType: "boolean", dflt: true, editType: "plot" }, range: { valType: "info_array", items: [{ valType: "number", editType: "plot" }, { valType: "number", editType: "plot" }], editType: "plot" }, constraintrange: { valType: "info_array", freeLength: true, dimensions: "1-2", items: [{ valType: "any", editType: "plot" }, { valType: "any", editType: "plot" }], editType: "plot" }, multiselect: { valType: "boolean", dflt: true, editType: "plot" }, values: { valType: "data_array", editType: "calc" }, editType: "calc" }), line: s({ editType: "calc" }, n2("line", { colorscaleDflt: "Viridis", autoColorDflt: false, editTypeOverride: "calc" })), unselected: { line: { color: { valType: "color", dflt: "#7f7f7f", editType: "plot" }, opacity: { valType: "number", min: 0, max: 1, dflt: "auto", editType: "plot" }, editType: "plot" }, editType: "plot" } };
      }, 57920: function(t2, e2, r2) {
        var n2 = r2(25706), i = r2(39898), a = r2(28984).keyFun, o = r2(28984).repeat, s = r2(71828).sorterAsc, l = r2(71828).strTranslate, u = n2.bar.snapRatio;
        function c(t3, e3) {
          return t3 * (1 - u) + e3 * u;
        }
        var f2 = n2.bar.snapClose;
        function h(t3, e3) {
          return t3 * (1 - f2) + e3 * f2;
        }
        function p2(t3, e3, r3, n3) {
          if (function(t4, e4) {
            for (var r4 = 0; r4 < e4.length; r4++)
              if (t4 >= e4[r4][0] && t4 <= e4[r4][1])
                return true;
            return false;
          }(r3, n3))
            return r3;
          var i2 = t3 ? -1 : 1, a2 = 0, o2 = e3.length - 1;
          if (i2 < 0) {
            var s2 = a2;
            a2 = o2, o2 = s2;
          }
          for (var l2 = e3[a2], u2 = l2, f3 = a2; i2 * f3 < i2 * o2; f3 += i2) {
            var p3 = f3 + i2, d3 = e3[p3];
            if (i2 * r3 < i2 * h(l2, d3))
              return c(l2, u2);
            if (i2 * r3 < i2 * d3 || p3 === o2)
              return c(d3, l2);
            u2 = l2, l2 = d3;
          }
        }
        function d2(t3) {
          t3.attr("x", -n2.bar.captureWidth / 2).attr("width", n2.bar.captureWidth);
        }
        function v(t3) {
          t3.attr("visibility", "visible").style("visibility", "visible").attr("fill", "yellow").attr("opacity", 0);
        }
        function g2(t3) {
          if (!t3.brush.filterSpecified)
            return "0," + t3.height;
          for (var e3, r3, n3, i2 = y(t3.brush.filter.getConsolidated(), t3.height), a2 = [0], o2 = i2.length ? i2[0][0] : null, s2 = 0; s2 < i2.length; s2++)
            r3 = (e3 = i2[s2])[1] - e3[0], a2.push(o2), a2.push(r3), (n3 = s2 + 1) < i2.length && (o2 = i2[n3][0] - e3[1]);
          return a2.push(t3.height), a2;
        }
        function y(t3, e3) {
          return t3.map(function(t4) {
            return t4.map(function(t5) {
              return Math.max(0, t5 * e3);
            }).sort(s);
          });
        }
        function m2() {
          i.select(document.body).style("cursor", null);
        }
        function x(t3) {
          t3.attr("stroke-dasharray", g2);
        }
        function b(t3, e3) {
          var r3 = i.select(t3).selectAll(".highlight, .highlight-shadow");
          x(e3 ? r3.transition().duration(n2.bar.snapDuration).each("end", e3) : r3);
        }
        function _(t3, e3) {
          var r3, i2 = t3.brush, a2 = NaN, o2 = {};
          if (i2.filterSpecified) {
            var s2 = t3.height, l2 = i2.filter.getConsolidated(), u2 = y(l2, s2), c2 = NaN, f3 = NaN, h2 = NaN;
            for (r3 = 0; r3 <= u2.length; r3++) {
              var p3 = u2[r3];
              if (p3 && p3[0] <= e3 && e3 <= p3[1]) {
                c2 = r3;
                break;
              }
              if (f3 = r3 ? r3 - 1 : NaN, p3 && p3[0] > e3) {
                h2 = r3;
                break;
              }
            }
            if (a2 = c2, isNaN(a2) && (a2 = isNaN(f3) || isNaN(h2) ? isNaN(f3) ? h2 : f3 : e3 - u2[f3][1] < u2[h2][0] - e3 ? f3 : h2), !isNaN(a2)) {
              var d3 = u2[a2], v2 = function(t4, e4) {
                var r4 = n2.bar.handleHeight;
                if (!(e4 > t4[1] + r4 || e4 < t4[0] - r4))
                  return e4 >= 0.9 * t4[1] + 0.1 * t4[0] ? "n" : e4 <= 0.9 * t4[0] + 0.1 * t4[1] ? "s" : "ns";
              }(d3, e3);
              v2 && (o2.interval = l2[a2], o2.intervalPix = d3, o2.region = v2);
            }
          }
          if (t3.ordinal && !o2.region) {
            var g3 = t3.unitTickvals, m3 = t3.unitToPaddedPx.invert(e3);
            for (r3 = 0; r3 < g3.length; r3++) {
              var x2 = [0.25 * g3[Math.max(r3 - 1, 0)] + 0.75 * g3[r3], 0.25 * g3[Math.min(r3 + 1, g3.length - 1)] + 0.75 * g3[r3]];
              if (m3 >= x2[0] && m3 <= x2[1]) {
                o2.clickableOrdinalRange = x2;
                break;
              }
            }
          }
          return o2;
        }
        function w2(t3, e3) {
          i.event.sourceEvent.stopPropagation();
          var r3 = e3.height - i.mouse(t3)[1] - 2 * n2.verticalPadding, a2 = e3.brush.svgBrush;
          a2.wasDragged = true, a2._dragging = true, a2.grabbingBar ? a2.newExtent = [r3 - a2.grabPoint, r3 + a2.barLength - a2.grabPoint].map(e3.unitToPaddedPx.invert) : a2.newExtent = [a2.startExtent, e3.unitToPaddedPx.invert(r3)].sort(s), e3.brush.filterSpecified = true, a2.extent = a2.stayingIntervals.concat([a2.newExtent]), a2.brushCallback(e3), b(t3.parentNode);
        }
        function T(t3, e3) {
          var r3 = _(e3, e3.height - i.mouse(t3)[1] - 2 * n2.verticalPadding), a2 = "crosshair";
          r3.clickableOrdinalRange ? a2 = "pointer" : r3.region && (a2 = r3.region + "-resize"), i.select(document.body).style("cursor", a2);
        }
        function k(t3) {
          t3.on("mousemove", function(t4) {
            i.event.preventDefault(), t4.parent.inBrushDrag || T(this, t4);
          }).on("mouseleave", function(t4) {
            t4.parent.inBrushDrag || m2();
          }).call(i.behavior.drag().on("dragstart", function(t4) {
            !function(t5, e3) {
              i.event.sourceEvent.stopPropagation();
              var r3 = e3.height - i.mouse(t5)[1] - 2 * n2.verticalPadding, a2 = e3.unitToPaddedPx.invert(r3), o2 = e3.brush, s2 = _(e3, r3), l2 = s2.interval, u2 = o2.svgBrush;
              if (u2.wasDragged = false, u2.grabbingBar = "ns" === s2.region, u2.grabbingBar) {
                var c2 = l2.map(e3.unitToPaddedPx);
                u2.grabPoint = r3 - c2[0] - n2.verticalPadding, u2.barLength = c2[1] - c2[0];
              }
              u2.clickableOrdinalRange = s2.clickableOrdinalRange, u2.stayingIntervals = e3.multiselect && o2.filterSpecified ? o2.filter.getConsolidated() : [], l2 && (u2.stayingIntervals = u2.stayingIntervals.filter(function(t6) {
                return t6[0] !== l2[0] && t6[1] !== l2[1];
              })), u2.startExtent = s2.region ? l2["s" === s2.region ? 1 : 0] : a2, e3.parent.inBrushDrag = true, u2.brushStartCallback();
            }(this, t4);
          }).on("drag", function(t4) {
            w2(this, t4);
          }).on("dragend", function(t4) {
            !function(t5, e3) {
              var r3 = e3.brush, n3 = r3.filter, a2 = r3.svgBrush;
              a2._dragging || (T(t5, e3), w2(t5, e3), e3.brush.svgBrush.wasDragged = false), a2._dragging = false, i.event.sourceEvent.stopPropagation();
              var o2 = a2.grabbingBar;
              if (a2.grabbingBar = false, a2.grabLocation = void 0, e3.parent.inBrushDrag = false, m2(), !a2.wasDragged)
                return a2.wasDragged = void 0, a2.clickableOrdinalRange ? r3.filterSpecified && e3.multiselect ? a2.extent.push(a2.clickableOrdinalRange) : (a2.extent = [a2.clickableOrdinalRange], r3.filterSpecified = true) : o2 ? (a2.extent = a2.stayingIntervals, 0 === a2.extent.length && M(r3)) : M(r3), a2.brushCallback(e3), b(t5.parentNode), void a2.brushEndCallback(r3.filterSpecified ? n3.getConsolidated() : []);
              var s2 = function() {
                n3.set(n3.getConsolidated());
              };
              if (e3.ordinal) {
                var l2 = e3.unitTickvals;
                l2[l2.length - 1] < l2[0] && l2.reverse(), a2.newExtent = [p2(0, l2, a2.newExtent[0], a2.stayingIntervals), p2(1, l2, a2.newExtent[1], a2.stayingIntervals)];
                var u2 = a2.newExtent[1] > a2.newExtent[0];
                a2.extent = a2.stayingIntervals.concat(u2 ? [a2.newExtent] : []), a2.extent.length || M(r3), a2.brushCallback(e3), u2 ? b(t5.parentNode, s2) : (s2(), b(t5.parentNode));
              } else
                s2();
              a2.brushEndCallback(r3.filterSpecified ? n3.getConsolidated() : []);
            }(this, t4);
          }));
        }
        function A(t3, e3) {
          return t3[0] - e3[0];
        }
        function M(t3) {
          t3.filterSpecified = false, t3.svgBrush.extent = [[-1 / 0, 1 / 0]];
        }
        function S(t3) {
          for (var e3, r3 = t3.slice(), n3 = [], i2 = r3.shift(); i2; ) {
            for (e3 = i2.slice(); (i2 = r3.shift()) && i2[0] <= e3[1]; )
              e3[1] = Math.max(e3[1], i2[1]);
            n3.push(e3);
          }
          return 1 === n3.length && n3[0][0] > n3[0][1] && (n3 = []), n3;
        }
        t2.exports = { makeBrush: function(t3, e3, r3, n3, i2, a2) {
          var o2, l2 = function() {
            var t4, e4, r4 = [];
            return { set: function(n4) {
              1 === (r4 = n4.map(function(t5) {
                return t5.slice().sort(s);
              }).sort(A)).length && r4[0][0] === -1 / 0 && r4[0][1] === 1 / 0 && (r4 = [[0, -1]]), t4 = S(r4), e4 = r4.reduce(function(t5, e5) {
                return [Math.min(t5[0], e5[0]), Math.max(t5[1], e5[1])];
              }, [1 / 0, -1 / 0]);
            }, get: function() {
              return r4.slice();
            }, getConsolidated: function() {
              return t4;
            }, getBounds: function() {
              return e4;
            } };
          }();
          return l2.set(r3), { filter: l2, filterSpecified: e3, svgBrush: { extent: [], brushStartCallback: n3, brushCallback: (o2 = i2, function(t4) {
            var e4 = t4.brush, r4 = function(t5) {
              return t5.svgBrush.extent.map(function(t6) {
                return t6.slice();
              });
            }(e4), n4 = r4.slice();
            e4.filter.set(n4), o2();
          }), brushEndCallback: a2 } };
        }, ensureAxisBrush: function(t3, e3, r3) {
          var i2 = t3.selectAll("." + n2.cn.axisBrush).data(o, a);
          i2.enter().append("g").classed(n2.cn.axisBrush, true), function(t4, e4, r4) {
            var i3 = r4._context.staticPlot, a2 = t4.selectAll(".background").data(o);
            a2.enter().append("rect").classed("background", true).call(d2).call(v).style("pointer-events", i3 ? "none" : "auto").attr("transform", l(0, n2.verticalPadding)), a2.call(k).attr("height", function(t5) {
              return t5.height - n2.verticalPadding;
            });
            var s2 = t4.selectAll(".highlight-shadow").data(o);
            s2.enter().append("line").classed("highlight-shadow", true).attr("x", -n2.bar.width / 2).attr("stroke-width", n2.bar.width + n2.bar.strokeWidth).attr("stroke", e4).attr("opacity", n2.bar.strokeOpacity).attr("stroke-linecap", "butt"), s2.attr("y1", function(t5) {
              return t5.height;
            }).call(x);
            var u2 = t4.selectAll(".highlight").data(o);
            u2.enter().append("line").classed("highlight", true).attr("x", -n2.bar.width / 2).attr("stroke-width", n2.bar.width - n2.bar.strokeWidth).attr("stroke", n2.bar.fillColor).attr("opacity", n2.bar.fillOpacity).attr("stroke-linecap", "butt"), u2.attr("y1", function(t5) {
              return t5.height;
            }).call(x);
          }(i2, e3, r3);
        }, cleanRanges: function(t3, e3) {
          if (Array.isArray(t3[0]) ? (t3 = t3.map(function(t4) {
            return t4.sort(s);
          }), t3 = e3.multiselect ? S(t3.sort(A)) : [t3[0]]) : t3 = [t3.sort(s)], e3.tickvals) {
            var r3 = e3.tickvals.slice().sort(s);
            if (!(t3 = t3.map(function(t4) {
              var e4 = [p2(0, r3, t4[0], []), p2(1, r3, t4[1], [])];
              if (e4[1] > e4[0])
                return e4;
            }).filter(function(t4) {
              return t4;
            })).length)
              return;
          }
          return t3.length > 1 ? t3 : t3[0];
        } };
      }, 71791: function(t2, e2, r2) {
        t2.exports = { attributes: r2(73362), supplyDefaults: r2(3633), calc: r2(24639), colorbar: { container: "line", min: "cmin", max: "cmax" }, moduleType: "trace", name: "parcoords", basePlotModule: r2(49351), categories: ["gl", "regl", "noOpacity", "noHover"], meta: {} };
      }, 49351: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(27659).a0, a = r2(21341), o = r2(77922);
        e2.name = "parcoords", e2.plot = function(t3) {
          var e3 = i(t3.calcdata, "parcoords")[0];
          e3.length && a(t3, e3);
        }, e2.clean = function(t3, e3, r3, n3) {
          var i2 = n3._has && n3._has("parcoords"), a2 = e3._has && e3._has("parcoords");
          i2 && !a2 && (n3._paperdiv.selectAll(".parcoords").remove(), n3._glimages.selectAll("*").remove());
        }, e2.toSVG = function(t3) {
          var e3 = t3._fullLayout._glimages, r3 = n2.select(t3).selectAll(".svg-container");
          r3.filter(function(t4, e4) {
            return e4 === r3.size() - 1;
          }).selectAll(".gl-canvas-context, .gl-canvas-focus").each(function() {
            var t4 = this, r4 = t4.toDataURL("image/png");
            e3.append("svg:image").attr({ xmlns: o.svg, "xlink:href": r4, preserveAspectRatio: "none", x: 0, y: 0, width: t4.style.width, height: t4.style.height });
          }), window.setTimeout(function() {
            n2.selectAll("#filterBarPattern").attr("id", "filterBarPattern");
          }, 60);
        };
      }, 24639: function(t2, e2, r2) {
        var n2 = r2(71828).isArrayOrTypedArray, i = r2(21081), a = r2(28984).wrap;
        t2.exports = function(t3, e3) {
          var r3, o;
          return i.hasColorscale(e3, "line") && n2(e3.line.color) ? (r3 = e3.line.color, o = i.extractOpts(e3.line).colorscale, i.calc(t3, e3, { vals: r3, containerStr: "line", cLetter: "c" })) : (r3 = function(t4) {
            for (var e4 = new Array(t4), r4 = 0; r4 < t4; r4++)
              e4[r4] = 0.5;
            return e4;
          }(e3._length), o = [[0, e3.line.color], [1, e3.line.color]]), a({ lineColor: r3, cscale: o });
        };
      }, 25706: function(t2) {
        t2.exports = { maxDimensionCount: 60, overdrag: 45, verticalPadding: 2, tickDistance: 50, canvasPixelRatio: 1, blockLineCount: 5e3, layers: ["contextLineLayer", "focusLineLayer", "pickLineLayer"], axisTitleOffset: 28, axisExtentOffset: 10, bar: { width: 4, captureWidth: 10, fillColor: "magenta", fillOpacity: 1, snapDuration: 150, snapRatio: 0.25, snapClose: 0.01, strokeOpacity: 1, strokeWidth: 1, handleHeight: 8, handleOpacity: 1, handleOverlap: 0 }, cn: { axisExtentText: "axis-extent-text", parcoordsLineLayers: "parcoords-line-layers", parcoordsLineLayer: "parcoords-lines", parcoords: "parcoords", parcoordsControlView: "parcoords-control-view", yAxis: "y-axis", axisOverlays: "axis-overlays", axis: "axis", axisHeading: "axis-heading", axisTitle: "axis-title", axisExtent: "axis-extent", axisExtentTop: "axis-extent-top", axisExtentTopText: "axis-extent-top-text", axisExtentBottom: "axis-extent-bottom", axisExtentBottomText: "axis-extent-bottom-text", axisBrush: "axis-brush" }, id: { filterBarPattern: "filter-bar-pattern" } };
      }, 3633: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(52075).hasColorscale, a = r2(1586), o = r2(27670).c, s = r2(85501), l = r2(89298), u = r2(73362), c = r2(57920), f2 = r2(25706).maxDimensionCount, h = r2(94397);
        function p2(t3, e3, r3, i2) {
          function a2(r4, i3) {
            return n2.coerce(t3, e3, u.dimensions, r4, i3);
          }
          var o2 = a2("values"), s2 = a2("visible");
          if (o2 && o2.length || (s2 = e3.visible = false), s2) {
            a2("label"), a2("tickvals"), a2("ticktext"), a2("tickformat");
            var f3 = a2("range");
            e3._ax = { _id: "y", type: "linear", showexponent: "all", exponentformat: "B", range: f3 }, l.setConvert(e3._ax, i2.layout), a2("multiselect");
            var h2 = a2("constraintrange");
            h2 && (e3.constraintrange = c.cleanRanges(h2, e3));
          }
        }
        t2.exports = function(t3, e3, r3, l2) {
          function c2(r4, i2) {
            return n2.coerce(t3, e3, u, r4, i2);
          }
          var d2 = t3.dimensions;
          Array.isArray(d2) && d2.length > f2 && (n2.log("parcoords traces support up to " + f2 + " dimensions at the moment"), d2.splice(f2));
          var v = s(t3, e3, { name: "dimensions", layout: l2, handleItemDefaults: p2 }), g2 = function(t4, e4, r4, o2, s2) {
            var l3 = s2("line.color", r4);
            if (i(t4, "line") && n2.isArrayOrTypedArray(l3)) {
              if (l3.length)
                return s2("line.colorscale"), a(t4, e4, o2, s2, { prefix: "line.", cLetter: "c" }), l3.length;
              e4.line.color = r4;
            }
            return 1 / 0;
          }(t3, e3, r3, l2, c2);
          o(e3, l2, c2), Array.isArray(v) && v.length || (e3.visible = false), h(e3, v, "values", g2);
          var y = { family: l2.font.family, size: Math.round(l2.font.size / 1.2), color: l2.font.color };
          n2.coerceFont(c2, "labelfont", y), n2.coerceFont(c2, "tickfont", y), n2.coerceFont(c2, "rangefont", y), c2("labelangle"), c2("labelside"), c2("unselected.line.color"), c2("unselected.line.opacity");
        };
      }, 1602: function(t2, e2, r2) {
        var n2 = r2(71828).isTypedArray;
        e2.convertTypedArray = function(t3) {
          return n2(t3) ? Array.prototype.slice.call(t3) : t3;
        }, e2.isOrdinal = function(t3) {
          return !!t3.tickvals;
        }, e2.isVisible = function(t3) {
          return t3.visible || !("visible" in t3);
        };
      }, 67618: function(t2, e2, r2) {
        var n2 = r2(71791);
        n2.plot = r2(21341), t2.exports = n2;
      }, 83398: function(t2, e2, r2) {
        var n2 = r2(56068), i = n2(["precision highp float;\n#define GLSLIFY 1\n\nvarying vec4 fragColor;\n\nattribute vec4 p01_04, p05_08, p09_12, p13_16,\n               p17_20, p21_24, p25_28, p29_32,\n               p33_36, p37_40, p41_44, p45_48,\n               p49_52, p53_56, p57_60, colors;\n\nuniform mat4 dim0A, dim1A, dim0B, dim1B, dim0C, dim1C, dim0D, dim1D,\n             loA, hiA, loB, hiB, loC, hiC, loD, hiD;\n\nuniform vec2 resolution, viewBoxPos, viewBoxSize;\nuniform float maskHeight;\nuniform float drwLayer; // 0: context, 1: focus, 2: pick\nuniform vec4 contextColor;\nuniform sampler2D maskTexture, palette;\n\nbool isPick    = (drwLayer > 1.5);\nbool isContext = (drwLayer < 0.5);\n\nconst vec4 ZEROS = vec4(0.0, 0.0, 0.0, 0.0);\nconst vec4 UNITS = vec4(1.0, 1.0, 1.0, 1.0);\n\nfloat val(mat4 p, mat4 v) {\n    return dot(matrixCompMult(p, v) * UNITS, UNITS);\n}\n\nfloat axisY(float ratio, mat4 A, mat4 B, mat4 C, mat4 D) {\n    float y1 = val(A, dim0A) + val(B, dim0B) + val(C, dim0C) + val(D, dim0D);\n    float y2 = val(A, dim1A) + val(B, dim1B) + val(C, dim1C) + val(D, dim1D);\n    return y1 * (1.0 - ratio) + y2 * ratio;\n}\n\nint iMod(int a, int b) {\n    return a - b * (a / b);\n}\n\nbool fOutside(float p, float lo, float hi) {\n    return (lo < hi) && (lo > p || p > hi);\n}\n\nbool vOutside(vec4 p, vec4 lo, vec4 hi) {\n    return (\n        fOutside(p[0], lo[0], hi[0]) ||\n        fOutside(p[1], lo[1], hi[1]) ||\n        fOutside(p[2], lo[2], hi[2]) ||\n        fOutside(p[3], lo[3], hi[3])\n    );\n}\n\nbool mOutside(mat4 p, mat4 lo, mat4 hi) {\n    return (\n        vOutside(p[0], lo[0], hi[0]) ||\n        vOutside(p[1], lo[1], hi[1]) ||\n        vOutside(p[2], lo[2], hi[2]) ||\n        vOutside(p[3], lo[3], hi[3])\n    );\n}\n\nbool outsideBoundingBox(mat4 A, mat4 B, mat4 C, mat4 D) {\n    return mOutside(A, loA, hiA) ||\n           mOutside(B, loB, hiB) ||\n           mOutside(C, loC, hiC) ||\n           mOutside(D, loD, hiD);\n}\n\nbool outsideRasterMask(mat4 A, mat4 B, mat4 C, mat4 D) {\n    mat4 pnts[4];\n    pnts[0] = A;\n    pnts[1] = B;\n    pnts[2] = C;\n    pnts[3] = D;\n\n    for(int i = 0; i < 4; ++i) {\n        for(int j = 0; j < 4; ++j) {\n            for(int k = 0; k < 4; ++k) {\n                if(0 == iMod(\n                    int(255.0 * texture2D(maskTexture,\n                        vec2(\n                            (float(i * 2 + j / 2) + 0.5) / 8.0,\n                            (pnts[i][j][k] * (maskHeight - 1.0) + 1.0) / maskHeight\n                        ))[3]\n                    ) / int(pow(2.0, float(iMod(j * 4 + k, 8)))),\n                    2\n                )) return true;\n            }\n        }\n    }\n    return false;\n}\n\nvec4 position(bool isContext, float v, mat4 A, mat4 B, mat4 C, mat4 D) {\n    float x = 0.5 * sign(v) + 0.5;\n    float y = axisY(x, A, B, C, D);\n    float z = 1.0 - abs(v);\n\n    z += isContext ? 0.0 : 2.0 * float(\n        outsideBoundingBox(A, B, C, D) ||\n        outsideRasterMask(A, B, C, D)\n    );\n\n    return vec4(\n        2.0 * (vec2(x, y) * viewBoxSize + viewBoxPos) / resolution - 1.0,\n        z,\n        1.0\n    );\n}\n\nvoid main() {\n    mat4 A = mat4(p01_04, p05_08, p09_12, p13_16);\n    mat4 B = mat4(p17_20, p21_24, p25_28, p29_32);\n    mat4 C = mat4(p33_36, p37_40, p41_44, p45_48);\n    mat4 D = mat4(p49_52, p53_56, p57_60, ZEROS);\n\n    float v = colors[3];\n\n    gl_Position = position(isContext, v, A, B, C, D);\n\n    fragColor =\n        isContext ? vec4(contextColor) :\n        isPick ? vec4(colors.rgb, 1.0) : texture2D(palette, vec2(abs(v), 0.5));\n}\n"]), a = n2(["precision highp float;\n#define GLSLIFY 1\n\nvarying vec4 fragColor;\n\nvoid main() {\n    gl_FragColor = fragColor;\n}\n"]), o = r2(25706).maxDimensionCount, s = r2(71828), l = new Uint8Array(4), u = new Uint8Array(4), c = { shape: [256, 1], format: "rgba", type: "uint8", mag: "nearest", min: "nearest" };
        function f2(t3, e3, r3, n3, i2) {
          var a2 = t3._gl;
          a2.enable(a2.SCISSOR_TEST), a2.scissor(e3, r3, n3, i2), t3.clear({ color: [0, 0, 0, 0], depth: 1 });
        }
        function h(t3, e3, r3, n3, i2, a2) {
          var o2 = a2.key;
          r3.drawCompleted || (function(t4) {
            t4.read({ x: 0, y: 0, width: 1, height: 1, data: l });
          }(t3), r3.drawCompleted = true), function s2(l2) {
            var u2 = Math.min(n3, i2 - l2 * n3);
            0 === l2 && (window.cancelAnimationFrame(r3.currentRafs[o2]), delete r3.currentRafs[o2], f2(t3, a2.scissorX, a2.scissorY, a2.scissorWidth, a2.viewBoxSize[1])), r3.clearOnly || (a2.count = 2 * u2, a2.offset = 2 * l2 * n3, e3(a2), l2 * n3 + u2 < i2 && (r3.currentRafs[o2] = window.requestAnimationFrame(function() {
              s2(l2 + 1);
            })), r3.drawCompleted = false);
          }(0);
        }
        function p2(t3, e3) {
          for (var r3 = new Array(256), n3 = 0; n3 < 256; n3++)
            r3[n3] = t3(n3 / 255).concat(e3);
          return r3;
        }
        function d2(t3, e3) {
          return (t3 >>> 8 * e3) % 256 / 255;
        }
        function v(t3, e3, r3) {
          for (var n3 = new Array(8 * e3), i2 = 0, a2 = 0; a2 < e3; a2++)
            for (var o2 = 0; o2 < 2; o2++)
              for (var s2 = 0; s2 < 4; s2++) {
                var l2 = 4 * t3 + s2, u2 = r3[64 * a2 + l2];
                63 === l2 && 0 === o2 && (u2 *= -1), n3[i2++] = u2;
              }
          return n3;
        }
        function g2(t3) {
          var e3 = "0" + t3;
          return e3.substr(e3.length - 2);
        }
        function y(t3) {
          return t3 < o ? "p" + g2(t3 + 1) + "_" + g2(t3 + 4) : "colors";
        }
        function m2(t3, e3, r3, n3, i2, a2, o2, l2, u2, c2, f3, h2, p3, d3) {
          for (var v2 = [[], []], g3 = 0; g3 < 64; g3++)
            v2[0][g3] = g3 === i2 ? 1 : 0, v2[1][g3] = g3 === a2 ? 1 : 0;
          o2 *= d3, l2 *= d3, u2 *= d3, c2 *= d3;
          var y2 = t3.lines.canvasOverdrag * d3, m3 = t3.domain, x2 = t3.canvasWidth * d3, b = t3.canvasHeight * d3, _ = t3.pad.l * d3, w2 = t3.pad.b * d3, T = t3.layoutHeight * d3, k = t3.layoutWidth * d3, A = t3.deselectedLines.color, M = t3.deselectedLines.opacity;
          return s.extendFlat({ key: f3, resolution: [x2, b], viewBoxPos: [o2 + y2, l2], viewBoxSize: [u2, c2], i0: i2, i1: a2, dim0A: v2[0].slice(0, 16), dim0B: v2[0].slice(16, 32), dim0C: v2[0].slice(32, 48), dim0D: v2[0].slice(48, 64), dim1A: v2[1].slice(0, 16), dim1B: v2[1].slice(16, 32), dim1C: v2[1].slice(32, 48), dim1D: v2[1].slice(48, 64), drwLayer: h2, contextColor: [A[0] / 255, A[1] / 255, A[2] / 255, "auto" !== M ? A[3] * M : Math.max(1 / 255, Math.pow(1 / t3.lines.color.length, 1 / 3))], scissorX: (n3 === e3 ? 0 : o2 + y2) + (_ - y2) + k * m3.x[0], scissorWidth: (n3 === r3 ? x2 - o2 + y2 : u2 + 0.5) + (n3 === e3 ? o2 + y2 : 0), scissorY: l2 + w2 + T * m3.y[0], scissorHeight: c2, viewportX: _ - y2 + k * m3.x[0], viewportY: w2 + T * m3.y[0], viewportWidth: x2, viewportHeight: b }, p3);
        }
        function x(t3) {
          var e3 = 2047, r3 = Math.max(0, Math.floor(t3[0] * e3), 0), n3 = Math.min(e3, Math.ceil(t3[1] * e3), e3);
          return [Math.min(r3, n3), Math.max(r3, n3)];
        }
        t2.exports = function(t3, e3) {
          var r3, n3, l2, g3, b, _ = e3.context, w2 = e3.pick, T = e3.regl, k = T._gl, A = k.getParameter(k.ALIASED_LINE_WIDTH_RANGE), M = Math.max(A[0], Math.min(A[1], e3.viewModel.plotGlPixelRatio)), S = { currentRafs: {}, drawCompleted: true, clearOnly: false }, E = function(t4) {
            for (var e4 = {}, r4 = 0; r4 <= o; r4 += 4)
              e4[y(r4)] = t4.buffer({ usage: "dynamic", type: "float", data: new Uint8Array(0) });
            return e4;
          }(T), L = T.texture(c), C = [];
          O(e3);
          var P = T({ profile: false, blend: { enable: _, func: { srcRGB: "src alpha", dstRGB: "one minus src alpha", srcAlpha: 1, dstAlpha: 1 }, equation: { rgb: "add", alpha: "add" }, color: [0, 0, 0, 0] }, depth: { enable: !_, mask: true, func: "less", range: [0, 1] }, cull: { enable: true, face: "back" }, scissor: { enable: true, box: { x: T.prop("scissorX"), y: T.prop("scissorY"), width: T.prop("scissorWidth"), height: T.prop("scissorHeight") } }, viewport: { x: T.prop("viewportX"), y: T.prop("viewportY"), width: T.prop("viewportWidth"), height: T.prop("viewportHeight") }, dither: false, vert: i, frag: a, primitive: "lines", lineWidth: M, attributes: E, uniforms: { resolution: T.prop("resolution"), viewBoxPos: T.prop("viewBoxPos"), viewBoxSize: T.prop("viewBoxSize"), dim0A: T.prop("dim0A"), dim1A: T.prop("dim1A"), dim0B: T.prop("dim0B"), dim1B: T.prop("dim1B"), dim0C: T.prop("dim0C"), dim1C: T.prop("dim1C"), dim0D: T.prop("dim0D"), dim1D: T.prop("dim1D"), loA: T.prop("loA"), hiA: T.prop("hiA"), loB: T.prop("loB"), hiB: T.prop("hiB"), loC: T.prop("loC"), hiC: T.prop("hiC"), loD: T.prop("loD"), hiD: T.prop("hiD"), palette: L, contextColor: T.prop("contextColor"), maskTexture: T.prop("maskTexture"), drwLayer: T.prop("drwLayer"), maskHeight: T.prop("maskHeight") }, offset: T.prop("offset"), count: T.prop("count") });
          function O(t4) {
            r3 = t4.model, n3 = t4.viewModel, l2 = n3.dimensions.slice(), g3 = l2[0] ? l2[0].values.length : 0;
            var e4 = r3.lines, i2 = w2 ? e4.color.map(function(t5, r4) {
              return r4 / e4.color.length;
            }) : e4.color, a2 = function(t5, e5, r4) {
              for (var n4, i3 = new Array(t5 * (o + 4)), a3 = 0, s2 = 0; s2 < t5; s2++) {
                for (var l3 = 0; l3 < o; l3++)
                  i3[a3++] = l3 < e5.length ? e5[l3].paddedUnitValues[s2] : 0.5;
                i3[a3++] = d2(s2, 2), i3[a3++] = d2(s2, 1), i3[a3++] = d2(s2, 0), i3[a3++] = (n4 = r4[s2], Math.max(1e-6, Math.min(0.999999, n4)));
              }
              return i3;
            }(g3, l2, i2);
            !function(t5, e5, r4) {
              for (var n4 = 0; n4 <= o; n4 += 4)
                t5[y(n4)](v(n4 / 4, e5, r4));
            }(E, g3, a2), _ || w2 || (L = T.texture(s.extendFlat({ data: p2(r3.unitToColor, 255) }, c)));
          }
          return { render: function(t4, e4, n4) {
            var i2, a2, o2, s2 = t4.length, u2 = 1 / 0, c2 = -1 / 0;
            for (i2 = 0; i2 < s2; i2++)
              t4[i2].dim0.canvasX < u2 && (u2 = t4[i2].dim0.canvasX, a2 = i2), t4[i2].dim1.canvasX > c2 && (c2 = t4[i2].dim1.canvasX, o2 = i2);
            0 === s2 && f2(T, 0, 0, r3.canvasWidth, r3.canvasHeight);
            var p3 = function(t5) {
              var e5, r4, n5, i3 = [[], []];
              for (n5 = 0; n5 < 64; n5++) {
                var a3 = !t5 && n5 < l2.length ? l2[n5].brush.filter.getBounds() : [-1 / 0, 1 / 0];
                i3[0][n5] = a3[0], i3[1][n5] = a3[1];
              }
              var o3 = new Array(16384);
              for (e5 = 0; e5 < 16384; e5++)
                o3[e5] = 255;
              if (!t5)
                for (e5 = 0; e5 < l2.length; e5++) {
                  var s3 = e5 % 8, u3 = (e5 - s3) / 8, c3 = Math.pow(2, s3), f3 = l2[e5].brush.filter.get();
                  if (!(f3.length < 2)) {
                    var h2 = x(f3[0])[1];
                    for (r4 = 1; r4 < f3.length; r4++) {
                      var p4 = x(f3[r4]);
                      for (n5 = h2 + 1; n5 < p4[0]; n5++)
                        o3[8 * n5 + u3] &= ~c3;
                      h2 = Math.max(h2, p4[1]);
                    }
                  }
                }
              var d4 = { shape: [8, 2048], format: "alpha", type: "uint8", mag: "nearest", min: "nearest", data: o3 };
              return b ? b(d4) : b = T.texture(d4), { maskTexture: b, maskHeight: 2048, loA: i3[0].slice(0, 16), loB: i3[0].slice(16, 32), loC: i3[0].slice(32, 48), loD: i3[0].slice(48, 64), hiA: i3[1].slice(0, 16), hiB: i3[1].slice(16, 32), hiC: i3[1].slice(32, 48), hiD: i3[1].slice(48, 64) };
            }(_);
            for (i2 = 0; i2 < s2; i2++) {
              var d3 = t4[i2], v2 = d3.dim0.crossfilterDimensionIndex, y2 = d3.dim1.crossfilterDimensionIndex, k2 = d3.canvasX, A2 = d3.canvasY, M2 = k2 + d3.panelSizeX, E2 = d3.plotGlPixelRatio;
              if (e4 || !C[v2] || C[v2][0] !== k2 || C[v2][1] !== M2) {
                C[v2] = [k2, M2];
                var L2 = m2(r3, a2, o2, i2, v2, y2, k2, A2, d3.panelSizeX, d3.panelSizeY, d3.dim0.crossfilterDimensionIndex, _ ? 0 : w2 ? 2 : 1, p3, E2);
                S.clearOnly = n4;
                var O2 = e4 ? r3.lines.blockLineCount : g3;
                h(T, P, S, O2, g3, L2);
              }
            }
          }, readPixel: function(t4, e4) {
            return T.read({ x: t4, y: e4, width: 1, height: 1, data: u }), u;
          }, readPixels: function(t4, e4, r4, n4) {
            var i2 = new Uint8Array(4 * r4 * n4);
            return T.read({ x: t4, y: e4, width: r4, height: n4, data: i2 }), i2;
          }, destroy: function() {
            for (var e4 in t3.style["pointer-events"] = "none", L.destroy(), b && b.destroy(), E)
              E[e4].destroy();
          }, update: O };
        };
      }, 94397: function(t2) {
        t2.exports = function(t3, e2, r2, n2) {
          var i, a;
          for (n2 || (n2 = 1 / 0), i = 0; i < e2.length; i++)
            (a = e2[i]).visible && (n2 = Math.min(n2, a[r2].length));
          for (n2 === 1 / 0 && (n2 = 0), t3._length = n2, i = 0; i < e2.length; i++)
            (a = e2[i]).visible && (a._length = n2);
          return n2;
        };
      }, 17171: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = i.numberFormat, o = r2(36652), s = r2(89298), l = i.strRotate, u = i.strTranslate, c = r2(63893), f2 = r2(91424), h = r2(21081), p2 = r2(28984), d2 = p2.keyFun, v = p2.repeat, g2 = p2.unwrap, y = r2(1602), m2 = r2(25706), x = r2(57920), b = r2(83398);
        function _(t3, e3, r3) {
          return i.aggNums(t3, null, e3, r3);
        }
        function w2(t3, e3) {
          return k(_(Math.min, t3, e3), _(Math.max, t3, e3));
        }
        function T(t3) {
          var e3 = t3.range;
          return e3 ? k(e3[0], e3[1]) : w2(t3.values, t3._length);
        }
        function k(t3, e3) {
          return !isNaN(t3) && isFinite(t3) || (t3 = 0), !isNaN(e3) && isFinite(e3) || (e3 = 0), t3 === e3 && (0 === t3 ? (t3 -= 1, e3 += 1) : (t3 *= 0.9, e3 *= 1.1)), [t3, e3];
        }
        function A(t3, e3, r3, i2, o2) {
          var s2, l2, u2 = T(r3);
          return i2 ? n2.scale.ordinal().domain(i2.map((s2 = a(r3.tickformat), l2 = o2, l2 ? function(t4, e4) {
            var r4 = l2[e4];
            return null == r4 ? s2(t4) : r4;
          } : s2))).range(i2.map(function(r4) {
            var n3 = (r4 - u2[0]) / (u2[1] - u2[0]);
            return t3 - e3 + n3 * (2 * e3 - t3);
          })) : n2.scale.linear().domain(u2).range([t3 - e3, e3]);
        }
        function M(t3) {
          if (t3.tickvals) {
            var e3 = T(t3);
            return n2.scale.ordinal().domain(t3.tickvals).range(t3.tickvals.map(function(t4) {
              return (t4 - e3[0]) / (e3[1] - e3[0]);
            }));
          }
        }
        function S(t3) {
          var e3 = t3.map(function(t4) {
            return t4[0];
          }), r3 = t3.map(function(t4) {
            var e4 = o(t4[1]);
            return n2.rgb("rgb(" + e4[0] + "," + e4[1] + "," + e4[2] + ")");
          }), i2 = "rgb".split("").map(function(t4) {
            return n2.scale.linear().clamp(true).domain(e3).range(r3.map((i3 = t4, function(t5) {
              return t5[i3];
            })));
            var i3;
          });
          return function(t4) {
            return i2.map(function(e4) {
              return e4(t4);
            });
          };
        }
        function E(t3) {
          return t3.dimensions.some(function(t4) {
            return t4.brush.filterSpecified;
          });
        }
        function L(t3, e3, r3) {
          var a2 = g2(e3), s2 = a2.trace, l2 = y.convertTypedArray(a2.lineColor), u2 = s2.line, c2 = { color: o(s2.unselected.line.color), opacity: s2.unselected.line.opacity }, f3 = h.extractOpts(u2), p3 = f3.reversescale ? h.flipScale(a2.cscale) : a2.cscale, d3 = s2.domain, v2 = s2.dimensions, x2 = t3.width, b2 = s2.labelangle, _2 = s2.labelside, w3 = s2.labelfont, k2 = s2.tickfont, A2 = s2.rangefont, M2 = i.extendDeepNoArrays({}, u2, { color: l2.map(n2.scale.linear().domain(T({ values: l2, range: [f3.min, f3.max], _length: s2._length }))), blockLineCount: m2.blockLineCount, canvasOverdrag: m2.overdrag * m2.canvasPixelRatio }), E2 = Math.floor(x2 * (d3.x[1] - d3.x[0])), L2 = Math.floor(t3.height * (d3.y[1] - d3.y[0])), C2 = t3.margin || { l: 80, r: 80, t: 100, b: 80 }, P2 = E2, O2 = L2;
          return { key: r3, colCount: v2.filter(y.isVisible).length, dimensions: v2, tickDistance: m2.tickDistance, unitToColor: S(p3), lines: M2, deselectedLines: c2, labelAngle: b2, labelSide: _2, labelFont: w3, tickFont: k2, rangeFont: A2, layoutWidth: x2, layoutHeight: t3.height, domain: d3, translateX: d3.x[0] * x2, translateY: t3.height - d3.y[1] * t3.height, pad: C2, canvasWidth: P2 * m2.canvasPixelRatio + 2 * M2.canvasOverdrag, canvasHeight: O2 * m2.canvasPixelRatio, width: P2, height: O2, canvasPixelRatio: m2.canvasPixelRatio };
        }
        function C(t3, e3, r3) {
          var o2 = r3.width, s2 = r3.height, l2 = r3.dimensions, u2 = r3.canvasPixelRatio, c2 = function(t4) {
            return o2 * t4 / Math.max(1, r3.colCount - 1);
          }, f3 = m2.verticalPadding / s2, h2 = function(t4, e4) {
            return n2.scale.linear().range([e4, t4 - e4]);
          }(s2, m2.verticalPadding), p3 = { key: r3.key, xScale: c2, model: r3, inBrushDrag: false }, d3 = {};
          return p3.dimensions = l2.filter(y.isVisible).map(function(o3, l3) {
            var v2 = function(t4, e4) {
              return n2.scale.linear().domain(T(t4)).range([e4, 1 - e4]);
            }(o3, f3), g3 = d3[o3.label];
            d3[o3.label] = (g3 || 0) + 1;
            var b2 = o3.label + (g3 ? "__" + g3 : ""), _2 = o3.constraintrange, w3 = _2 && _2.length;
            w3 && !Array.isArray(_2[0]) && (_2 = [_2]);
            var k2 = w3 ? _2.map(function(t4) {
              return t4.map(v2);
            }) : [[-1 / 0, 1 / 0]], S2 = o3.values;
            S2.length > o3._length && (S2 = S2.slice(0, o3._length));
            var L2, C2 = o3.tickvals;
            function P2(t4, e4) {
              return { val: t4, text: L2[e4] };
            }
            function O2(t4, e4) {
              return t4.val - e4.val;
            }
            if (Array.isArray(C2) && C2.length) {
              L2 = o3.ticktext, Array.isArray(L2) && L2.length ? L2.length > C2.length ? L2 = L2.slice(0, C2.length) : C2.length > L2.length && (C2 = C2.slice(0, L2.length)) : L2 = C2.map(a(o3.tickformat));
              for (var I2 = 1; I2 < C2.length; I2++)
                if (C2[I2] < C2[I2 - 1]) {
                  for (var D2 = C2.map(P2).sort(O2), z2 = 0; z2 < C2.length; z2++)
                    C2[z2] = D2[z2].val, L2[z2] = D2[z2].text;
                  break;
                }
            } else
              C2 = void 0;
            return S2 = y.convertTypedArray(S2), { key: b2, label: o3.label, tickFormat: o3.tickformat, tickvals: C2, ticktext: L2, ordinal: y.isOrdinal(o3), multiselect: o3.multiselect, xIndex: l3, crossfilterDimensionIndex: l3, visibleIndex: o3._index, height: s2, values: S2, paddedUnitValues: S2.map(v2), unitTickvals: C2 && C2.map(v2), xScale: c2, x: c2(l3), canvasX: c2(l3) * u2, unitToPaddedPx: h2, domainScale: A(s2, m2.verticalPadding, o3, C2, L2), ordinalScale: M(o3), parent: p3, model: r3, brush: x.makeBrush(t3, w3, k2, function() {
              t3.linePickActive(false);
            }, function() {
              var e4 = p3;
              e4.focusLayer && e4.focusLayer.render(e4.panels, true);
              var r4 = E(e4);
              !t3.contextShown() && r4 ? (e4.contextLayer && e4.contextLayer.render(e4.panels, true), t3.contextShown(true)) : t3.contextShown() && !r4 && (e4.contextLayer && e4.contextLayer.render(e4.panels, true, true), t3.contextShown(false));
            }, function(r4) {
              if (p3.focusLayer.render(p3.panels, true), p3.pickLayer && p3.pickLayer.render(p3.panels, true), t3.linePickActive(true), e3 && e3.filterChanged) {
                var n3 = v2.invert, a2 = r4.map(function(t4) {
                  return t4.map(n3).sort(i.sorterAsc);
                }).sort(function(t4, e4) {
                  return t4[0] - e4[0];
                });
                e3.filterChanged(p3.key, o3._index, a2);
              }
            }) };
          }), p3;
        }
        function P(t3) {
          t3.classed(m2.cn.axisExtentText, true).attr("text-anchor", "middle").style("cursor", "default");
        }
        function O(t3, e3) {
          var r3 = "top" === e3 ? 1 : -1, n3 = t3 * Math.PI / 180;
          return { dir: r3, dx: Math.sin(n3), dy: Math.cos(n3), degrees: t3 };
        }
        function I(t3, e3, r3) {
          for (var n3 = e3.panels || (e3.panels = []), i2 = t3.data(), a2 = 0; a2 < i2.length - 1; a2++) {
            var o2 = n3[a2] || (n3[a2] = {}), s2 = i2[a2], l2 = i2[a2 + 1];
            o2.dim0 = s2, o2.dim1 = l2, o2.canvasX = s2.canvasX, o2.panelSizeX = l2.canvasX - s2.canvasX, o2.panelSizeY = e3.model.canvasHeight, o2.y = 0, o2.canvasY = 0, o2.plotGlPixelRatio = r3;
          }
        }
        function D(t3, e3) {
          return s.tickText(t3._ax, e3, false).text;
        }
        function z(t3, e3) {
          if (t3.ordinal)
            return "";
          var r3 = t3.domainScale.domain(), n3 = r3[e3 ? r3.length - 1 : 0];
          return D(t3.model.dimensions[t3.visibleIndex], n3);
        }
        t2.exports = function(t3, e3, r3, a2) {
          var o2 = t3._context.staticPlot, h2 = t3._fullLayout, p3 = h2._toppaper, _2 = h2._glcontainer, T2 = t3._context.plotGlPixelRatio, A2 = t3._fullLayout.paper_bgcolor;
          !function(t4) {
            for (var e4 = 0; e4 < t4.length; e4++)
              for (var r4 = 0; r4 < t4[e4].length; r4++)
                for (var n3 = t4[e4][r4].trace, i2 = n3.dimensions, a3 = 0; a3 < i2.length; a3++) {
                  var o3 = i2[a3].values, l2 = i2[a3]._ax;
                  l2 && (l2.range ? l2.range = k(l2.range[0], l2.range[1]) : l2.range = w2(o3, n3._length), l2.dtick || (l2.dtick = 0.01 * (Math.abs(l2.range[1] - l2.range[0]) || 1)), l2.tickformat = i2[a3].tickformat, s.calcTicks(l2), l2.cleanRange());
                }
          }(e3);
          var M2, S2, R = (M2 = true, S2 = false, { linePickActive: function(t4) {
            return arguments.length ? M2 = !!t4 : M2;
          }, contextShown: function(t4) {
            return arguments.length ? S2 = !!t4 : S2;
          } }), F = e3.filter(function(t4) {
            return g2(t4).trace.visible;
          }).map(L.bind(0, r3)).map(C.bind(0, R, a2));
          _2.each(function(t4, e4) {
            return i.extendFlat(t4, F[e4]);
          });
          var B = _2.selectAll(".gl-canvas").each(function(t4) {
            t4.viewModel = F[0], t4.viewModel.plotGlPixelRatio = T2, t4.viewModel.paperColor = A2, t4.model = t4.viewModel ? t4.viewModel.model : null;
          }), N = null;
          B.filter(function(t4) {
            return t4.pick;
          }).style("pointer-events", o2 ? "none" : "auto").on("mousemove", function(t4) {
            if (R.linePickActive() && t4.lineLayer && a2 && a2.hover) {
              var e4 = n2.event, r4 = this.width, i2 = this.height, o3 = n2.mouse(this), s2 = o3[0], l2 = o3[1];
              if (s2 < 0 || l2 < 0 || s2 >= r4 || l2 >= i2)
                return;
              var u2 = t4.lineLayer.readPixel(s2, i2 - 1 - l2), c2 = 0 !== u2[3], f3 = c2 ? u2[2] + 256 * (u2[1] + 256 * u2[0]) : null, h3 = { x: s2, y: l2, clientX: e4.clientX, clientY: e4.clientY, dataIndex: t4.model.key, curveNumber: f3 };
              f3 !== N && (c2 ? a2.hover(h3) : a2.unhover && a2.unhover(h3), N = f3);
            }
          }), B.style("opacity", function(t4) {
            return t4.pick ? 0 : 1;
          }), p3.style("background", "rgba(255, 255, 255, 0)");
          var j = p3.selectAll("." + m2.cn.parcoords).data(F, d2);
          j.exit().remove(), j.enter().append("g").classed(m2.cn.parcoords, true).style("shape-rendering", "crispEdges").style("pointer-events", "none"), j.attr("transform", function(t4) {
            return u(t4.model.translateX, t4.model.translateY);
          });
          var U = j.selectAll("." + m2.cn.parcoordsControlView).data(v, d2);
          U.enter().append("g").classed(m2.cn.parcoordsControlView, true), U.attr("transform", function(t4) {
            return u(t4.model.pad.l, t4.model.pad.t);
          });
          var V = U.selectAll("." + m2.cn.yAxis).data(function(t4) {
            return t4.dimensions;
          }, d2);
          V.enter().append("g").classed(m2.cn.yAxis, true), U.each(function(t4) {
            I(V, t4, T2);
          }), B.each(function(t4) {
            if (t4.viewModel) {
              !t4.lineLayer || a2 ? t4.lineLayer = b(this, t4) : t4.lineLayer.update(t4), (t4.key || 0 === t4.key) && (t4.viewModel[t4.key] = t4.lineLayer);
              var e4 = !t4.context || a2;
              t4.lineLayer.render(t4.viewModel.panels, e4);
            }
          }), V.attr("transform", function(t4) {
            return u(t4.xScale(t4.xIndex), 0);
          }), V.call(n2.behavior.drag().origin(function(t4) {
            return t4;
          }).on("drag", function(t4) {
            var e4 = t4.parent;
            R.linePickActive(false), t4.x = Math.max(-m2.overdrag, Math.min(t4.model.width + m2.overdrag, n2.event.x)), t4.canvasX = t4.x * t4.model.canvasPixelRatio, V.sort(function(t5, e5) {
              return t5.x - e5.x;
            }).each(function(e5, r4) {
              e5.xIndex = r4, e5.x = t4 === e5 ? e5.x : e5.xScale(e5.xIndex), e5.canvasX = e5.x * e5.model.canvasPixelRatio;
            }), I(V, e4, T2), V.filter(function(e5) {
              return 0 !== Math.abs(t4.xIndex - e5.xIndex);
            }).attr("transform", function(t5) {
              return u(t5.xScale(t5.xIndex), 0);
            }), n2.select(this).attr("transform", u(t4.x, 0)), V.each(function(r4, n3, i2) {
              i2 === t4.parent.key && (e4.dimensions[n3] = r4);
            }), e4.contextLayer && e4.contextLayer.render(e4.panels, false, !E(e4)), e4.focusLayer.render && e4.focusLayer.render(e4.panels);
          }).on("dragend", function(t4) {
            var e4 = t4.parent;
            t4.x = t4.xScale(t4.xIndex), t4.canvasX = t4.x * t4.model.canvasPixelRatio, I(V, e4, T2), n2.select(this).attr("transform", function(t5) {
              return u(t5.x, 0);
            }), e4.contextLayer && e4.contextLayer.render(e4.panels, false, !E(e4)), e4.focusLayer && e4.focusLayer.render(e4.panels), e4.pickLayer && e4.pickLayer.render(e4.panels, true), R.linePickActive(true), a2 && a2.axesMoved && a2.axesMoved(e4.key, e4.dimensions.map(function(t5) {
              return t5.crossfilterDimensionIndex;
            }));
          })), V.exit().remove();
          var H = V.selectAll("." + m2.cn.axisOverlays).data(v, d2);
          H.enter().append("g").classed(m2.cn.axisOverlays, true), H.selectAll("." + m2.cn.axis).remove();
          var q2 = H.selectAll("." + m2.cn.axis).data(v, d2);
          q2.enter().append("g").classed(m2.cn.axis, true), q2.each(function(t4) {
            var e4 = t4.model.height / t4.model.tickDistance, r4 = t4.domainScale, i2 = r4.domain();
            n2.select(this).call(n2.svg.axis().orient("left").tickSize(4).outerTickSize(2).ticks(e4, t4.tickFormat).tickValues(t4.ordinal ? i2 : null).tickFormat(function(e5) {
              return y.isOrdinal(t4) ? e5 : D(t4.model.dimensions[t4.visibleIndex], e5);
            }).scale(r4)), f2.font(q2.selectAll("text"), t4.model.tickFont);
          }), q2.selectAll(".domain, .tick>line").attr("fill", "none").attr("stroke", "black").attr("stroke-opacity", 0.25).attr("stroke-width", "1px"), q2.selectAll("text").style("text-shadow", c.makeTextShadow(A2)).style("cursor", "default");
          var G = H.selectAll("." + m2.cn.axisHeading).data(v, d2);
          G.enter().append("g").classed(m2.cn.axisHeading, true);
          var Z = G.selectAll("." + m2.cn.axisTitle).data(v, d2);
          Z.enter().append("text").classed(m2.cn.axisTitle, true).attr("text-anchor", "middle").style("cursor", "ew-resize").style("pointer-events", o2 ? "none" : "auto"), Z.text(function(t4) {
            return t4.label;
          }).each(function(e4) {
            var r4 = n2.select(this);
            f2.font(r4, e4.model.labelFont), c.convertToTspans(r4, t3);
          }).attr("transform", function(t4) {
            var e4 = O(t4.model.labelAngle, t4.model.labelSide), r4 = m2.axisTitleOffset;
            return (e4.dir > 0 ? "" : u(0, 2 * r4 + t4.model.height)) + l(e4.degrees) + u(-r4 * e4.dx, -r4 * e4.dy);
          }).attr("text-anchor", function(t4) {
            var e4 = O(t4.model.labelAngle, t4.model.labelSide);
            return 2 * Math.abs(e4.dx) > Math.abs(e4.dy) ? e4.dir * e4.dx < 0 ? "start" : "end" : "middle";
          });
          var Y = H.selectAll("." + m2.cn.axisExtent).data(v, d2);
          Y.enter().append("g").classed(m2.cn.axisExtent, true);
          var W = Y.selectAll("." + m2.cn.axisExtentTop).data(v, d2);
          W.enter().append("g").classed(m2.cn.axisExtentTop, true), W.attr("transform", u(0, -m2.axisExtentOffset));
          var X = W.selectAll("." + m2.cn.axisExtentTopText).data(v, d2);
          X.enter().append("text").classed(m2.cn.axisExtentTopText, true).call(P), X.text(function(t4) {
            return z(t4, true);
          }).each(function(t4) {
            f2.font(n2.select(this), t4.model.rangeFont);
          });
          var J = Y.selectAll("." + m2.cn.axisExtentBottom).data(v, d2);
          J.enter().append("g").classed(m2.cn.axisExtentBottom, true), J.attr("transform", function(t4) {
            return u(0, t4.model.height + m2.axisExtentOffset);
          });
          var K = J.selectAll("." + m2.cn.axisExtentBottomText).data(v, d2);
          K.enter().append("text").classed(m2.cn.axisExtentBottomText, true).attr("dy", "0.75em").call(P), K.text(function(t4) {
            return z(t4, false);
          }).each(function(t4) {
            f2.font(n2.select(this), t4.model.rangeFont);
          }), x.ensureAxisBrush(H, A2, t3);
        };
      }, 21341: function(t2, e2, r2) {
        var n2 = r2(17171), i = r2(79749), a = r2(1602).isVisible, o = {};
        function s(t3, e3, r3) {
          var n3 = e3.indexOf(r3), i2 = t3.indexOf(n3);
          return -1 === i2 && (i2 += e3.length), i2;
        }
        (t2.exports = function(t3, e3) {
          var r3 = t3._fullLayout;
          if (i(t3, [], o)) {
            var l = {}, u = {}, c = {}, f2 = {}, h = r3._size;
            e3.forEach(function(e4, r4) {
              var n3 = e4[0].trace;
              c[r4] = n3.index;
              var i2 = f2[r4] = n3._fullInput.index;
              l[r4] = t3.data[i2].dimensions, u[r4] = t3.data[i2].dimensions.slice();
            }), n2(t3, e3, { width: h.w, height: h.h, margin: { t: h.t, r: h.r, b: h.b, l: h.l } }, { filterChanged: function(e4, n3, i2) {
              var a2 = u[e4][n3], o2 = i2.map(function(t4) {
                return t4.slice();
              }), s2 = "dimensions[" + n3 + "].constraintrange", l2 = r3._tracePreGUI[t3._fullData[c[e4]]._fullInput.uid];
              if (void 0 === l2[s2]) {
                var h2 = a2.constraintrange;
                l2[s2] = h2 || null;
              }
              var p2 = t3._fullData[c[e4]].dimensions[n3];
              o2.length ? (1 === o2.length && (o2 = o2[0]), a2.constraintrange = o2, p2.constraintrange = o2.slice(), o2 = [o2]) : (delete a2.constraintrange, delete p2.constraintrange, o2 = null);
              var d2 = {};
              d2[s2] = o2, t3.emit("plotly_restyle", [d2, [f2[e4]]]);
            }, hover: function(e4) {
              t3.emit("plotly_hover", e4);
            }, unhover: function(e4) {
              t3.emit("plotly_unhover", e4);
            }, axesMoved: function(e4, r4) {
              var n3 = function(t4, e5) {
                return function(r5, n4) {
                  return s(t4, e5, r5) - s(t4, e5, n4);
                };
              }(r4, u[e4].filter(a));
              l[e4].sort(n3), u[e4].filter(function(t4) {
                return !a(t4);
              }).sort(function(t4) {
                return u[e4].indexOf(t4);
              }).forEach(function(t4) {
                l[e4].splice(l[e4].indexOf(t4), 1), l[e4].splice(u[e4].indexOf(t4), 0, t4);
              }), t3.emit("plotly_restyle", [{ dimensions: [l[e4]] }, [f2[e4]]]);
            } });
          }
        }).reglPrecompiled = o;
      }, 34e3: function(t2, e2, r2) {
        var n2 = r2(9012), i = r2(27670).Y, a = r2(41940), o = r2(22399), s = r2(5386).f, l = r2(5386).s, u = r2(1426).extendFlat, c = a({ editType: "plot", arrayOk: true, colorEditType: "plot" });
        t2.exports = { labels: { valType: "data_array", editType: "calc" }, label0: { valType: "number", dflt: 0, editType: "calc" }, dlabel: { valType: "number", dflt: 1, editType: "calc" }, values: { valType: "data_array", editType: "calc" }, marker: { colors: { valType: "data_array", editType: "calc" }, line: { color: { valType: "color", dflt: o.defaultLine, arrayOk: true, editType: "style" }, width: { valType: "number", min: 0, dflt: 0, arrayOk: true, editType: "style" }, editType: "calc" }, editType: "calc" }, text: { valType: "data_array", editType: "plot" }, hovertext: { valType: "string", dflt: "", arrayOk: true, editType: "style" }, scalegroup: { valType: "string", dflt: "", editType: "calc" }, textinfo: { valType: "flaglist", flags: ["label", "text", "value", "percent"], extras: ["none"], editType: "calc" }, hoverinfo: u({}, n2.hoverinfo, { flags: ["label", "text", "value", "percent", "name"] }), hovertemplate: s({}, { keys: ["label", "color", "value", "percent", "text"] }), texttemplate: l({ editType: "plot" }, { keys: ["label", "color", "value", "percent", "text"] }), textposition: { valType: "enumerated", values: ["inside", "outside", "auto", "none"], dflt: "auto", arrayOk: true, editType: "plot" }, textfont: u({}, c, {}), insidetextorientation: { valType: "enumerated", values: ["horizontal", "radial", "tangential", "auto"], dflt: "auto", editType: "plot" }, insidetextfont: u({}, c, {}), outsidetextfont: u({}, c, {}), automargin: { valType: "boolean", dflt: false, editType: "plot" }, title: { text: { valType: "string", dflt: "", editType: "plot" }, font: u({}, c, {}), position: { valType: "enumerated", values: ["top left", "top center", "top right", "middle center", "bottom left", "bottom center", "bottom right"], editType: "plot" }, editType: "plot" }, domain: i({ name: "pie", trace: true, editType: "calc" }), hole: { valType: "number", min: 0, max: 1, dflt: 0, editType: "calc" }, sort: { valType: "boolean", dflt: true, editType: "calc" }, direction: { valType: "enumerated", values: ["clockwise", "counterclockwise"], dflt: "counterclockwise", editType: "calc" }, rotation: { valType: "angle", dflt: 0, editType: "calc" }, pull: { valType: "number", min: 0, max: 1, dflt: 0, arrayOk: true, editType: "calc" }, _deprecated: { title: { valType: "string", dflt: "", editType: "calc" }, titlefont: u({}, c, {}), titleposition: { valType: "enumerated", values: ["top left", "top center", "top right", "middle center", "bottom left", "bottom center", "bottom right"], editType: "calc" } } };
      }, 13584: function(t2, e2, r2) {
        var n2 = r2(74875);
        e2.name = "pie", e2.plot = function(t3, r3, i, a) {
          n2.plotBasePlot(e2.name, t3, r3, i, a);
        }, e2.clean = function(t3, r3, i, a) {
          n2.cleanBasePlot(e2.name, t3, r3, i, a);
        };
      }, 32354: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(84267), a = r2(7901), o = {};
        function s(t3) {
          return function(e3, r3) {
            return !!e3 && !!(e3 = i(e3)).isValid() && (e3 = a.addOpacity(e3, e3.getAlpha()), t3[r3] || (t3[r3] = e3), e3);
          };
        }
        function l(t3, e3) {
          var r3, n3 = JSON.stringify(t3), a2 = e3[n3];
          if (!a2) {
            for (a2 = t3.slice(), r3 = 0; r3 < t3.length; r3++)
              a2.push(i(t3[r3]).lighten(20).toHexString());
            for (r3 = 0; r3 < t3.length; r3++)
              a2.push(i(t3[r3]).darken(20).toHexString());
            e3[n3] = a2;
          }
          return a2;
        }
        t2.exports = { calc: function(t3, e3) {
          var r3, i2, a2 = [], o2 = t3._fullLayout, l2 = o2.hiddenlabels || [], u = e3.labels, c = e3.marker.colors || [], f2 = e3.values, h = e3._length, p2 = e3._hasValues && h;
          if (e3.dlabel)
            for (u = new Array(h), r3 = 0; r3 < h; r3++)
              u[r3] = String(e3.label0 + r3 * e3.dlabel);
          var d2 = {}, v = s(o2["_" + e3.type + "colormap"]), g2 = 0, y = false;
          for (r3 = 0; r3 < h; r3++) {
            var m2, x, b;
            if (p2) {
              if (m2 = f2[r3], !n2(m2))
                continue;
              m2 = +m2;
            } else
              m2 = 1;
            void 0 !== (x = u[r3]) && "" !== x || (x = r3);
            var _ = d2[x = String(x)];
            void 0 === _ ? (d2[x] = a2.length, (b = -1 !== l2.indexOf(x)) || (g2 += m2), a2.push({ v: m2, label: x, color: v(c[r3], x), i: r3, pts: [r3], hidden: b })) : (y = true, (i2 = a2[_]).v += m2, i2.pts.push(r3), i2.hidden || (g2 += m2), false === i2.color && c[r3] && (i2.color = v(c[r3], x)));
          }
          return a2 = a2.filter(function(t4) {
            return t4.v >= 0;
          }), ("funnelarea" === e3.type ? y : e3.sort) && a2.sort(function(t4, e4) {
            return e4.v - t4.v;
          }), a2[0] && (a2[0].vTotal = g2), a2;
        }, crossTraceCalc: function(t3, e3) {
          var r3 = (e3 || {}).type;
          r3 || (r3 = "pie");
          var n3 = t3._fullLayout, i2 = t3.calcdata, a2 = n3[r3 + "colorway"], s2 = n3["_" + r3 + "colormap"];
          n3["extend" + r3 + "colors"] && (a2 = l(a2, o));
          for (var u = 0, c = 0; c < i2.length; c++) {
            var f2 = i2[c];
            if (f2[0].trace.type === r3)
              for (var h = 0; h < f2.length; h++) {
                var p2 = f2[h];
                false === p2.color && (s2[p2.label] ? p2.color = s2[p2.label] : (s2[p2.label] = p2.color = a2[u % a2.length], u++));
              }
          }
        }, makePullColorFn: s, generateExtendedColors: l };
      }, 37434: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = r2(34e3), o = r2(27670).c, s = r2(90769).handleText;
        function l(t3, e3) {
          var r3 = Array.isArray(t3), a2 = i.isArrayOrTypedArray(e3), o2 = Math.min(r3 ? t3.length : 1 / 0, a2 ? e3.length : 1 / 0);
          if (isFinite(o2) || (o2 = 0), o2 && a2) {
            for (var s2, l2 = 0; l2 < o2; l2++) {
              var u = e3[l2];
              if (n2(u) && u > 0) {
                s2 = true;
                break;
              }
            }
            s2 || (o2 = 0);
          }
          return { hasLabels: r3, hasValues: a2, len: o2 };
        }
        t2.exports = { handleLabelsAndValues: l, supplyDefaults: function(t3, e3, r3, n3) {
          function u(r4, n4) {
            return i.coerce(t3, e3, a, r4, n4);
          }
          var c = l(u("labels"), u("values")), f2 = c.len;
          if (e3._hasLabels = c.hasLabels, e3._hasValues = c.hasValues, !e3._hasLabels && e3._hasValues && (u("label0"), u("dlabel")), f2) {
            e3._length = f2, u("marker.line.width") && u("marker.line.color"), u("marker.colors"), u("scalegroup");
            var h, p2 = u("text"), d2 = u("texttemplate");
            if (d2 || (h = u("textinfo", Array.isArray(p2) ? "text+percent" : "percent")), u("hovertext"), u("hovertemplate"), d2 || h && "none" !== h) {
              var v = u("textposition");
              s(t3, e3, n3, u, v, { moduleHasSelected: false, moduleHasUnselected: false, moduleHasConstrain: false, moduleHasCliponaxis: false, moduleHasTextangle: false, moduleHasInsideanchor: false }), (Array.isArray(v) || "auto" === v || "outside" === v) && u("automargin"), ("inside" === v || "auto" === v || Array.isArray(v)) && u("insidetextorientation");
            }
            o(e3, n3, u);
            var g2 = u("hole");
            if (u("title.text")) {
              var y = u("title.position", g2 ? "middle center" : "top center");
              g2 || "middle center" !== y || (e3.title.position = "top center"), i.coerceFont(u, "title.font", n3.font);
            }
            u("sort"), u("direction"), u("rotation"), u("pull");
          } else
            e3.visible = false;
        } };
      }, 20007: function(t2, e2, r2) {
        var n2 = r2(23469).appendArrayMultiPointValues;
        t2.exports = function(t3, e3) {
          var r3 = { curveNumber: e3.index, pointNumbers: t3.pts, data: e3._input, fullData: e3, label: t3.label, color: t3.color, value: t3.v, percent: t3.percent, text: t3.text, bbox: t3.bbox, v: t3.v };
          return 1 === t3.pts.length && (r3.pointNumber = r3.i = t3.pts[0]), n2(r3, e3, t3.pts), "funnelarea" === e3.type && (delete r3.v, delete r3.i), r3;
        };
      }, 53581: function(t2, e2, r2) {
        var n2 = r2(71828);
        function i(t3) {
          return -1 !== t3.indexOf("e") ? t3.replace(/[.]?0+e/, "e") : -1 !== t3.indexOf(".") ? t3.replace(/[.]?0+$/, "") : t3;
        }
        e2.formatPiePercent = function(t3, e3) {
          var r3 = i((100 * t3).toPrecision(3));
          return n2.numSeparate(r3, e3) + "%";
        }, e2.formatPieValue = function(t3, e3) {
          var r3 = i(t3.toPrecision(10));
          return n2.numSeparate(r3, e3);
        }, e2.getFirstFilled = function(t3, e3) {
          if (Array.isArray(t3))
            for (var r3 = 0; r3 < e3.length; r3++) {
              var n3 = t3[e3[r3]];
              if (n3 || 0 === n3 || "" === n3)
                return n3;
            }
        }, e2.castOption = function(t3, r3) {
          return Array.isArray(t3) ? e2.getFirstFilled(t3, r3) : t3 || void 0;
        }, e2.getRotationAngle = function(t3) {
          return ("auto" === t3 ? 0 : t3) * Math.PI / 180;
        };
      }, 58810: function(t2, e2, r2) {
        t2.exports = { attributes: r2(34e3), supplyDefaults: r2(37434).supplyDefaults, supplyLayoutDefaults: r2(92097), layoutAttributes: r2(92774), calc: r2(32354).calc, crossTraceCalc: r2(32354).crossTraceCalc, plot: r2(14575).plot, style: r2(68357), styleOne: r2(63463), moduleType: "trace", name: "pie", basePlotModule: r2(13584), categories: ["pie-like", "pie", "showLegend"], meta: {} };
      }, 92774: function(t2) {
        t2.exports = { hiddenlabels: { valType: "data_array", editType: "calc" }, piecolorway: { valType: "colorlist", editType: "calc" }, extendpiecolors: { valType: "boolean", dflt: true, editType: "calc" } };
      }, 92097: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(92774);
        t2.exports = function(t3, e3) {
          function r3(r4, a) {
            return n2.coerce(t3, e3, i, r4, a);
          }
          r3("hiddenlabels"), r3("piecolorway", e3.colorway), r3("extendpiecolors");
        };
      }, 14575: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(74875), a = r2(30211), o = r2(7901), s = r2(91424), l = r2(71828), u = l.strScale, c = l.strTranslate, f2 = r2(63893), h = r2(72597), p2 = h.recordMinTextSize, d2 = h.clearMinTextSize, v = r2(97313).TEXTPAD, g2 = r2(53581), y = r2(20007), m2 = r2(71828).isValidTextValue;
        function x(t3, e3, r3) {
          var i2 = r3[0], o2 = i2.cx, s2 = i2.cy, u2 = i2.trace, c2 = "funnelarea" === u2.type;
          "_hasHoverLabel" in u2 || (u2._hasHoverLabel = false), "_hasHoverEvent" in u2 || (u2._hasHoverEvent = false), t3.on("mouseover", function(t4) {
            var r4 = e3._fullLayout, f3 = e3._fullData[u2.index];
            if (!e3._dragging && false !== r4.hovermode) {
              var h2 = f3.hoverinfo;
              if (Array.isArray(h2) && (h2 = a.castHoverinfo({ hoverinfo: [g2.castOption(h2, t4.pts)], _module: u2._module }, r4, 0)), "all" === h2 && (h2 = "label+text+value+percent+name"), f3.hovertemplate || "none" !== h2 && "skip" !== h2 && h2) {
                var p3 = t4.rInscribed || 0, d3 = o2 + t4.pxmid[0] * (1 - p3), v2 = s2 + t4.pxmid[1] * (1 - p3), m3 = r4.separators, x2 = [];
                if (h2 && -1 !== h2.indexOf("label") && x2.push(t4.label), t4.text = g2.castOption(f3.hovertext || f3.text, t4.pts), h2 && -1 !== h2.indexOf("text")) {
                  var b2 = t4.text;
                  l.isValidTextValue(b2) && x2.push(b2);
                }
                t4.value = t4.v, t4.valueLabel = g2.formatPieValue(t4.v, m3), h2 && -1 !== h2.indexOf("value") && x2.push(t4.valueLabel), t4.percent = t4.v / i2.vTotal, t4.percentLabel = g2.formatPiePercent(t4.percent, m3), h2 && -1 !== h2.indexOf("percent") && x2.push(t4.percentLabel);
                var _2 = f3.hoverlabel, w3 = _2.font, T2 = [];
                a.loneHover({ trace: u2, x0: d3 - p3 * i2.r, x1: d3 + p3 * i2.r, y: v2, _x0: c2 ? o2 + t4.TL[0] : d3 - p3 * i2.r, _x1: c2 ? o2 + t4.TR[0] : d3 + p3 * i2.r, _y0: c2 ? s2 + t4.TL[1] : v2 - p3 * i2.r, _y1: c2 ? s2 + t4.BL[1] : v2 + p3 * i2.r, text: x2.join("<br>"), name: f3.hovertemplate || -1 !== h2.indexOf("name") ? f3.name : void 0, idealAlign: t4.pxmid[0] < 0 ? "left" : "right", color: g2.castOption(_2.bgcolor, t4.pts) || t4.color, borderColor: g2.castOption(_2.bordercolor, t4.pts), fontFamily: g2.castOption(w3.family, t4.pts), fontSize: g2.castOption(w3.size, t4.pts), fontColor: g2.castOption(w3.color, t4.pts), nameLength: g2.castOption(_2.namelength, t4.pts), textAlign: g2.castOption(_2.align, t4.pts), hovertemplate: g2.castOption(f3.hovertemplate, t4.pts), hovertemplateLabels: t4, eventData: [y(t4, f3)] }, { container: r4._hoverlayer.node(), outerContainer: r4._paper.node(), gd: e3, inOut_bbox: T2 }), t4.bbox = T2[0], u2._hasHoverLabel = true;
              }
              u2._hasHoverEvent = true, e3.emit("plotly_hover", { points: [y(t4, f3)], event: n2.event });
            }
          }), t3.on("mouseout", function(t4) {
            var r4 = e3._fullLayout, i3 = e3._fullData[u2.index], o3 = n2.select(this).datum();
            u2._hasHoverEvent && (t4.originalEvent = n2.event, e3.emit("plotly_unhover", { points: [y(o3, i3)], event: n2.event }), u2._hasHoverEvent = false), u2._hasHoverLabel && (a.loneUnhover(r4._hoverlayer.node()), u2._hasHoverLabel = false);
          }), t3.on("click", function(t4) {
            var r4 = e3._fullLayout, i3 = e3._fullData[u2.index];
            e3._dragging || false === r4.hovermode || (e3._hoverdata = [y(t4, i3)], a.click(e3, n2.event));
          });
        }
        function b(t3, e3, r3) {
          var n3 = g2.castOption(t3.insidetextfont.color, e3.pts);
          !n3 && t3._input.textfont && (n3 = g2.castOption(t3._input.textfont.color, e3.pts));
          var i2 = g2.castOption(t3.insidetextfont.family, e3.pts) || g2.castOption(t3.textfont.family, e3.pts) || r3.family, a2 = g2.castOption(t3.insidetextfont.size, e3.pts) || g2.castOption(t3.textfont.size, e3.pts) || r3.size;
          return { color: n3 || o.contrast(e3.color), family: i2, size: a2 };
        }
        function _(t3, e3) {
          for (var r3, n3, i2 = 0; i2 < t3.length; i2++)
            if ((n3 = (r3 = t3[i2][0]).trace).title.text) {
              var a2 = n3.title.text;
              n3._meta && (a2 = l.templateString(a2, n3._meta));
              var o2 = s.tester.append("text").attr("data-notex", 1).text(a2).call(s.font, n3.title.font).call(f2.convertToTspans, e3), u2 = s.bBox(o2.node(), true);
              r3.titleBox = { width: u2.width, height: u2.height }, o2.remove();
            }
        }
        function w2(t3, e3, r3) {
          var n3 = r3.r || e3.rpx1, i2 = e3.rInscribed;
          if (e3.startangle === e3.stopangle)
            return { rCenter: 1 - i2, scale: 0, rotate: 0, textPosAngle: 0 };
          var a2, o2 = e3.ring, s2 = 1 === o2 && Math.abs(e3.startangle - e3.stopangle) === 2 * Math.PI, l2 = e3.halfangle, u2 = e3.midangle, c2 = r3.trace.insidetextorientation, f3 = "horizontal" === c2, h2 = "tangential" === c2, p3 = "radial" === c2, d3 = "auto" === c2, v2 = [];
          if (!d3) {
            var g3, y2 = function(r4, i3) {
              if (function(t4, e4) {
                var r5 = t4.startangle, n4 = t4.stopangle;
                return r5 > e4 && e4 > n4 || r5 < e4 && e4 < n4;
              }(e3, r4)) {
                var s3 = Math.abs(r4 - e3.startangle), l3 = Math.abs(r4 - e3.stopangle), u3 = s3 < l3 ? s3 : l3;
                (a2 = "tan" === i3 ? k(t3, n3, o2, u3, 0) : T(t3, n3, o2, u3, Math.PI / 2)).textPosAngle = r4, v2.push(a2);
              }
            };
            if (f3 || h2) {
              for (g3 = 4; g3 >= -4; g3 -= 2)
                y2(Math.PI * g3, "tan");
              for (g3 = 4; g3 >= -4; g3 -= 2)
                y2(Math.PI * (g3 + 1), "tan");
            }
            if (f3 || p3) {
              for (g3 = 4; g3 >= -4; g3 -= 2)
                y2(Math.PI * (g3 + 1.5), "rad");
              for (g3 = 4; g3 >= -4; g3 -= 2)
                y2(Math.PI * (g3 + 0.5), "rad");
            }
          }
          if (s2 || d3 || f3) {
            var m3 = Math.sqrt(t3.width * t3.width + t3.height * t3.height);
            if ((a2 = { scale: i2 * n3 * 2 / m3, rCenter: 1 - i2, rotate: 0 }).textPosAngle = (e3.startangle + e3.stopangle) / 2, a2.scale >= 1)
              return a2;
            v2.push(a2);
          }
          (d3 || p3) && ((a2 = T(t3, n3, o2, l2, u2)).textPosAngle = (e3.startangle + e3.stopangle) / 2, v2.push(a2)), (d3 || h2) && ((a2 = k(t3, n3, o2, l2, u2)).textPosAngle = (e3.startangle + e3.stopangle) / 2, v2.push(a2));
          for (var x2 = 0, b2 = 0, _2 = 0; _2 < v2.length; _2++) {
            var w3 = v2[_2].scale;
            if (b2 < w3 && (b2 = w3, x2 = _2), !d3 && b2 >= 1)
              break;
          }
          return v2[x2];
        }
        function T(t3, e3, r3, n3, i2) {
          e3 = Math.max(0, e3 - 2 * v);
          var a2 = t3.width / t3.height, o2 = S(a2, n3, e3, r3);
          return { scale: 2 * o2 / t3.height, rCenter: A(a2, o2 / e3), rotate: M(i2) };
        }
        function k(t3, e3, r3, n3, i2) {
          e3 = Math.max(0, e3 - 2 * v);
          var a2 = t3.height / t3.width, o2 = S(a2, n3, e3, r3);
          return { scale: 2 * o2 / t3.width, rCenter: A(a2, o2 / e3), rotate: M(i2 + Math.PI / 2) };
        }
        function A(t3, e3) {
          return Math.cos(e3) - t3 * e3;
        }
        function M(t3) {
          return (180 / Math.PI * t3 + 720) % 180 - 90;
        }
        function S(t3, e3, r3, n3) {
          var i2 = t3 + 1 / (2 * Math.tan(e3));
          return r3 * Math.min(1 / (Math.sqrt(i2 * i2 + 0.5) + i2), n3 / (Math.sqrt(t3 * t3 + n3 / 2) + t3));
        }
        function E(t3, e3) {
          return t3.v !== e3.vTotal || e3.trace.hole ? Math.min(1 / (1 + 1 / Math.sin(t3.halfangle)), t3.ring / 2) : 1;
        }
        function L(t3, e3) {
          var r3 = e3.pxmid[0], n3 = e3.pxmid[1], i2 = t3.width / 2, a2 = t3.height / 2;
          return r3 < 0 && (i2 *= -1), n3 < 0 && (a2 *= -1), { scale: 1, rCenter: 1, rotate: 0, x: i2 + Math.abs(a2) * (i2 > 0 ? 1 : -1) / 2, y: a2 / (1 + r3 * r3 / (n3 * n3)), outside: true };
        }
        function C(t3, e3) {
          var r3, n3, i2, a2 = t3.trace, o2 = { x: t3.cx, y: t3.cy }, s2 = { tx: 0, ty: 0 };
          s2.ty += a2.title.font.size, i2 = O(a2), -1 !== a2.title.position.indexOf("top") ? (o2.y -= (1 + i2) * t3.r, s2.ty -= t3.titleBox.height) : -1 !== a2.title.position.indexOf("bottom") && (o2.y += (1 + i2) * t3.r);
          var l2, u2 = t3.r / (void 0 === (l2 = t3.trace.aspectratio) ? 1 : l2), c2 = e3.w * (a2.domain.x[1] - a2.domain.x[0]) / 2;
          return -1 !== a2.title.position.indexOf("left") ? (c2 += u2, o2.x -= (1 + i2) * u2, s2.tx += t3.titleBox.width / 2) : -1 !== a2.title.position.indexOf("center") ? c2 *= 2 : -1 !== a2.title.position.indexOf("right") && (c2 += u2, o2.x += (1 + i2) * u2, s2.tx -= t3.titleBox.width / 2), r3 = c2 / t3.titleBox.width, n3 = P(t3, e3) / t3.titleBox.height, { x: o2.x, y: o2.y, scale: Math.min(r3, n3), tx: s2.tx, ty: s2.ty };
        }
        function P(t3, e3) {
          var r3 = t3.trace, n3 = e3.h * (r3.domain.y[1] - r3.domain.y[0]);
          return Math.min(t3.titleBox.height, n3 / 2);
        }
        function O(t3) {
          var e3, r3 = t3.pull;
          if (!r3)
            return 0;
          if (Array.isArray(r3))
            for (r3 = 0, e3 = 0; e3 < t3.pull.length; e3++)
              t3.pull[e3] > r3 && (r3 = t3.pull[e3]);
          return r3;
        }
        function I(t3, e3) {
          for (var r3 = [], n3 = 0; n3 < t3.length; n3++) {
            var i2 = t3[n3][0], a2 = i2.trace, o2 = a2.domain, s2 = e3.w * (o2.x[1] - o2.x[0]), l2 = e3.h * (o2.y[1] - o2.y[0]);
            a2.title.text && "middle center" !== a2.title.position && (l2 -= P(i2, e3));
            var u2 = s2 / 2, c2 = l2 / 2;
            "funnelarea" !== a2.type || a2.scalegroup || (c2 /= a2.aspectratio), i2.r = Math.min(u2, c2) / (1 + O(a2)), i2.cx = e3.l + e3.w * (a2.domain.x[1] + a2.domain.x[0]) / 2, i2.cy = e3.t + e3.h * (1 - a2.domain.y[0]) - l2 / 2, a2.title.text && -1 !== a2.title.position.indexOf("bottom") && (i2.cy -= P(i2, e3)), a2.scalegroup && -1 === r3.indexOf(a2.scalegroup) && r3.push(a2.scalegroup);
          }
          !function(t4, e4) {
            for (var r4, n4, i3, a3 = 0; a3 < e4.length; a3++) {
              var o3 = 1 / 0, s3 = e4[a3];
              for (n4 = 0; n4 < t4.length; n4++)
                if ((i3 = (r4 = t4[n4][0]).trace).scalegroup === s3) {
                  var l3;
                  if ("pie" === i3.type)
                    l3 = r4.r * r4.r;
                  else if ("funnelarea" === i3.type) {
                    var u3, c3;
                    i3.aspectratio > 1 ? c3 = (u3 = r4.r) / i3.aspectratio : u3 = (c3 = r4.r) * i3.aspectratio, l3 = (u3 *= (1 + i3.baseratio) / 2) * c3;
                  }
                  o3 = Math.min(o3, l3 / r4.vTotal);
                }
              for (n4 = 0; n4 < t4.length; n4++)
                if ((i3 = (r4 = t4[n4][0]).trace).scalegroup === s3) {
                  var f3 = o3 * r4.vTotal;
                  "funnelarea" === i3.type && (f3 /= (1 + i3.baseratio) / 2, f3 /= i3.aspectratio), r4.r = Math.sqrt(f3);
                }
            }
          }(t3, r3);
        }
        function D(t3, e3) {
          return [t3 * Math.sin(e3), -t3 * Math.cos(e3)];
        }
        function z(t3, e3, r3) {
          var n3 = t3._fullLayout, i2 = r3.trace, a2 = i2.texttemplate, o2 = i2.textinfo;
          if (!a2 && o2 && "none" !== o2) {
            var s2, u2 = o2.split("+"), c2 = function(t4) {
              return -1 !== u2.indexOf(t4);
            }, f3 = c2("label"), h2 = c2("text"), p3 = c2("value"), d3 = c2("percent"), v2 = n3.separators;
            if (s2 = f3 ? [e3.label] : [], h2) {
              var y2 = g2.getFirstFilled(i2.text, e3.pts);
              m2(y2) && s2.push(y2);
            }
            p3 && s2.push(g2.formatPieValue(e3.v, v2)), d3 && s2.push(g2.formatPiePercent(e3.v / r3.vTotal, v2)), e3.text = s2.join("<br>");
          }
          if (a2) {
            var x2 = l.castOption(i2, e3.i, "texttemplate");
            if (x2) {
              var b2 = function(t4) {
                return { label: t4.label, value: t4.v, valueLabel: g2.formatPieValue(t4.v, n3.separators), percent: t4.v / r3.vTotal, percentLabel: g2.formatPiePercent(t4.v / r3.vTotal, n3.separators), color: t4.color, text: t4.text, customdata: l.castOption(i2, t4.i, "customdata") };
              }(e3), _2 = g2.getFirstFilled(i2.text, e3.pts);
              (m2(_2) || "" === _2) && (b2.text = _2), e3.text = l.texttemplateString(x2, b2, t3._fullLayout._d3locale, b2, i2._meta || {});
            } else
              e3.text = "";
          }
        }
        function R(t3, e3) {
          var r3 = t3.rotate * Math.PI / 180, n3 = Math.cos(r3), i2 = Math.sin(r3), a2 = (e3.left + e3.right) / 2, o2 = (e3.top + e3.bottom) / 2;
          t3.textX = a2 * n3 - o2 * i2, t3.textY = a2 * i2 + o2 * n3, t3.noCenter = true;
        }
        t2.exports = { plot: function(t3, e3) {
          var r3 = t3._context.staticPlot, a2 = t3._fullLayout, h2 = a2._size;
          d2("pie", a2), _(e3, t3), I(e3, h2);
          var v2 = l.makeTraceGroups(a2._pielayer, e3, "trace").each(function(e4) {
            var d3 = n2.select(this), v3 = e4[0], y2 = v3.trace;
            !function(t4) {
              var e5, r4, n3, i2 = t4[0], a3 = i2.r, o2 = i2.trace, s2 = g2.getRotationAngle(o2.rotation), l2 = 2 * Math.PI / i2.vTotal, u2 = "px0", c2 = "px1";
              if ("counterclockwise" === o2.direction) {
                for (e5 = 0; e5 < t4.length && t4[e5].hidden; e5++)
                  ;
                if (e5 === t4.length)
                  return;
                s2 += l2 * t4[e5].v, l2 *= -1, u2 = "px1", c2 = "px0";
              }
              for (n3 = D(a3, s2), e5 = 0; e5 < t4.length; e5++)
                (r4 = t4[e5]).hidden || (r4[u2] = n3, r4.startangle = s2, s2 += l2 * r4.v / 2, r4.pxmid = D(a3, s2), r4.midangle = s2, n3 = D(a3, s2 += l2 * r4.v / 2), r4.stopangle = s2, r4[c2] = n3, r4.largeArc = r4.v > i2.vTotal / 2 ? 1 : 0, r4.halfangle = Math.PI * Math.min(r4.v / i2.vTotal, 0.5), r4.ring = 1 - o2.hole, r4.rInscribed = E(r4, i2));
            }(e4), d3.attr("stroke-linejoin", "round"), d3.each(function() {
              var m3 = n2.select(this).selectAll("g.slice").data(e4);
              m3.enter().append("g").classed("slice", true), m3.exit().remove();
              var _2 = [[[], []], [[], []]], T2 = false;
              m3.each(function(i2, o2) {
                if (i2.hidden)
                  n2.select(this).selectAll("path,g").remove();
                else {
                  i2.pointNumber = i2.i, i2.curveNumber = y2.index, _2[i2.pxmid[1] < 0 ? 0 : 1][i2.pxmid[0] < 0 ? 0 : 1].push(i2);
                  var u2 = v3.cx, c2 = v3.cy, h3 = n2.select(this), d4 = h3.selectAll("path.surface").data([i2]);
                  if (d4.enter().append("path").classed("surface", true).style({ "pointer-events": r3 ? "none" : "all" }), h3.call(x, t3, e4), y2.pull) {
                    var m4 = +g2.castOption(y2.pull, i2.pts) || 0;
                    m4 > 0 && (u2 += m4 * i2.pxmid[0], c2 += m4 * i2.pxmid[1]);
                  }
                  i2.cxFinal = u2, i2.cyFinal = c2;
                  var k3 = y2.hole;
                  if (i2.v === v3.vTotal) {
                    var A3 = "M" + (u2 + i2.px0[0]) + "," + (c2 + i2.px0[1]) + P3(i2.px0, i2.pxmid, true, 1) + P3(i2.pxmid, i2.px0, true, 1) + "Z";
                    k3 ? d4.attr("d", "M" + (u2 + k3 * i2.px0[0]) + "," + (c2 + k3 * i2.px0[1]) + P3(i2.px0, i2.pxmid, false, k3) + P3(i2.pxmid, i2.px0, false, k3) + "Z" + A3) : d4.attr("d", A3);
                  } else {
                    var M3 = P3(i2.px0, i2.px1, true, 1);
                    if (k3) {
                      var S3 = 1 - k3;
                      d4.attr("d", "M" + (u2 + k3 * i2.px1[0]) + "," + (c2 + k3 * i2.px1[1]) + P3(i2.px1, i2.px0, false, k3) + "l" + S3 * i2.px0[0] + "," + S3 * i2.px0[1] + M3 + "Z");
                    } else
                      d4.attr("d", "M" + u2 + "," + c2 + "l" + i2.px0[0] + "," + i2.px0[1] + M3 + "Z");
                  }
                  z(t3, i2, v3);
                  var E3 = g2.castOption(y2.textposition, i2.pts), C2 = h3.selectAll("g.slicetext").data(i2.text && "none" !== E3 ? [0] : []);
                  C2.enter().append("g").classed("slicetext", true), C2.exit().remove(), C2.each(function() {
                    var r4 = l.ensureSingle(n2.select(this), "text", "", function(t4) {
                      t4.attr("data-notex", 1);
                    }), h4 = l.ensureUniformFontSize(t3, "outside" === E3 ? function(t4, e5, r5) {
                      return { color: g2.castOption(t4.outsidetextfont.color, e5.pts) || g2.castOption(t4.textfont.color, e5.pts) || r5.color, family: g2.castOption(t4.outsidetextfont.family, e5.pts) || g2.castOption(t4.textfont.family, e5.pts) || r5.family, size: g2.castOption(t4.outsidetextfont.size, e5.pts) || g2.castOption(t4.textfont.size, e5.pts) || r5.size };
                    }(y2, i2, a2.font) : b(y2, i2, a2.font));
                    r4.text(i2.text).attr({ class: "slicetext", transform: "", "text-anchor": "middle" }).call(s.font, h4).call(f2.convertToTspans, t3);
                    var d5, m5 = s.bBox(r4.node());
                    if ("outside" === E3)
                      d5 = L(m5, i2);
                    else if (d5 = w2(m5, i2, v3), "auto" === E3 && d5.scale < 1) {
                      var x2 = l.ensureUniformFontSize(t3, y2.outsidetextfont);
                      r4.call(s.font, x2), d5 = L(m5 = s.bBox(r4.node()), i2);
                    }
                    var _3 = d5.textPosAngle, k4 = void 0 === _3 ? i2.pxmid : D(v3.r, _3);
                    if (d5.targetX = u2 + k4[0] * d5.rCenter + (d5.x || 0), d5.targetY = c2 + k4[1] * d5.rCenter + (d5.y || 0), R(d5, m5), d5.outside) {
                      var A4 = d5.targetY;
                      i2.yLabelMin = A4 - m5.height / 2, i2.yLabelMid = A4, i2.yLabelMax = A4 + m5.height / 2, i2.labelExtraX = 0, i2.labelExtraY = 0, T2 = true;
                    }
                    d5.fontSize = h4.size, p2(y2.type, d5, a2), e4[o2].transform = d5, l.setTransormAndDisplay(r4, d5);
                  });
                }
                function P3(t4, e5, r4, n3) {
                  var a3 = n3 * (e5[0] - t4[0]), o3 = n3 * (e5[1] - t4[1]);
                  return "a" + n3 * v3.r + "," + n3 * v3.r + " 0 " + i2.largeArc + (r4 ? " 1 " : " 0 ") + a3 + "," + o3;
                }
              });
              var k2 = n2.select(this).selectAll("g.titletext").data(y2.title.text ? [0] : []);
              if (k2.enter().append("g").classed("titletext", true), k2.exit().remove(), k2.each(function() {
                var e5, r4 = l.ensureSingle(n2.select(this), "text", "", function(t4) {
                  t4.attr("data-notex", 1);
                }), i2 = y2.title.text;
                y2._meta && (i2 = l.templateString(i2, y2._meta)), r4.text(i2).attr({ class: "titletext", transform: "", "text-anchor": "middle" }).call(s.font, y2.title.font).call(f2.convertToTspans, t3), e5 = "middle center" === y2.title.position ? function(t4) {
                  var e6 = Math.sqrt(t4.titleBox.width * t4.titleBox.width + t4.titleBox.height * t4.titleBox.height);
                  return { x: t4.cx, y: t4.cy, scale: t4.trace.hole * t4.r * 2 / e6, tx: 0, ty: -t4.titleBox.height / 2 + t4.trace.title.font.size };
                }(v3) : C(v3, h2), r4.attr("transform", c(e5.x, e5.y) + u(Math.min(1, e5.scale)) + c(e5.tx, e5.ty));
              }), T2 && function(t4, e5) {
                var r4, n3, i2, a3, o2, s2, l2, u2, c2, f3, h3, p3, d4;
                function v4(t5, e6) {
                  return t5.pxmid[1] - e6.pxmid[1];
                }
                function y3(t5, e6) {
                  return e6.pxmid[1] - t5.pxmid[1];
                }
                function m4(t5, r5) {
                  r5 || (r5 = {});
                  var i3, u3, c3, h4, p4 = r5.labelExtraY + (n3 ? r5.yLabelMax : r5.yLabelMin), d5 = n3 ? t5.yLabelMin : t5.yLabelMax, v5 = n3 ? t5.yLabelMax : t5.yLabelMin, y4 = t5.cyFinal + o2(t5.px0[1], t5.px1[1]), m5 = p4 - d5;
                  if (m5 * l2 > 0 && (t5.labelExtraY = m5), Array.isArray(e5.pull))
                    for (u3 = 0; u3 < f3.length; u3++)
                      (c3 = f3[u3]) === t5 || (g2.castOption(e5.pull, t5.pts) || 0) >= (g2.castOption(e5.pull, c3.pts) || 0) || ((t5.pxmid[1] - c3.pxmid[1]) * l2 > 0 ? (m5 = c3.cyFinal + o2(c3.px0[1], c3.px1[1]) - d5 - t5.labelExtraY) * l2 > 0 && (t5.labelExtraY += m5) : (v5 + t5.labelExtraY - y4) * l2 > 0 && (i3 = 3 * s2 * Math.abs(u3 - f3.indexOf(t5)), (h4 = c3.cxFinal + a3(c3.px0[0], c3.px1[0]) + i3 - (t5.cxFinal + t5.pxmid[0]) - t5.labelExtraX) * s2 > 0 && (t5.labelExtraX += h4)));
                }
                for (n3 = 0; n3 < 2; n3++)
                  for (i2 = n3 ? v4 : y3, o2 = n3 ? Math.max : Math.min, l2 = n3 ? 1 : -1, r4 = 0; r4 < 2; r4++) {
                    for (a3 = r4 ? Math.max : Math.min, s2 = r4 ? 1 : -1, (u2 = t4[n3][r4]).sort(i2), c2 = t4[1 - n3][r4], f3 = c2.concat(u2), p3 = [], h3 = 0; h3 < u2.length; h3++)
                      void 0 !== u2[h3].yLabelMid && p3.push(u2[h3]);
                    for (d4 = false, h3 = 0; n3 && h3 < c2.length; h3++)
                      if (void 0 !== c2[h3].yLabelMid) {
                        d4 = c2[h3];
                        break;
                      }
                    for (h3 = 0; h3 < p3.length; h3++) {
                      var x2 = h3 && p3[h3 - 1];
                      d4 && !h3 && (x2 = d4), m4(p3[h3], x2);
                    }
                  }
              }(_2, y2), function(t4, e5) {
                t4.each(function(t5) {
                  var r4 = n2.select(this);
                  if (t5.labelExtraX || t5.labelExtraY) {
                    var i2 = r4.select("g.slicetext text");
                    t5.transform.targetX += t5.labelExtraX, t5.transform.targetY += t5.labelExtraY, l.setTransormAndDisplay(i2, t5.transform);
                    var a3 = t5.cxFinal + t5.pxmid[0], s2 = "M" + a3 + "," + (t5.cyFinal + t5.pxmid[1]), u2 = (t5.yLabelMax - t5.yLabelMin) * (t5.pxmid[0] < 0 ? -1 : 1) / 4;
                    if (t5.labelExtraX) {
                      var c2 = t5.labelExtraX * t5.pxmid[1] / t5.pxmid[0], f3 = t5.yLabelMid + t5.labelExtraY - (t5.cyFinal + t5.pxmid[1]);
                      Math.abs(c2) > Math.abs(f3) ? s2 += "l" + f3 * t5.pxmid[0] / t5.pxmid[1] + "," + f3 + "H" + (a3 + t5.labelExtraX + u2) : s2 += "l" + t5.labelExtraX + "," + c2 + "v" + (f3 - c2) + "h" + u2;
                    } else
                      s2 += "V" + (t5.yLabelMid + t5.labelExtraY) + "h" + u2;
                    l.ensureSingle(r4, "path", "textline").call(o.stroke, e5.outsidetextfont.color).attr({ "stroke-width": Math.min(2, e5.outsidetextfont.size / 8), d: s2, fill: "none" });
                  } else
                    r4.select("path.textline").remove();
                });
              }(m3, y2), T2 && y2.automargin) {
                var A2 = s.bBox(d3.node()), M2 = y2.domain, S2 = h2.w * (M2.x[1] - M2.x[0]), E2 = h2.h * (M2.y[1] - M2.y[0]), P2 = (0.5 * S2 - v3.r) / h2.w, O2 = (0.5 * E2 - v3.r) / h2.h;
                i.autoMargin(t3, "pie." + y2.uid + ".automargin", { xl: M2.x[0] - P2, xr: M2.x[1] + P2, yb: M2.y[0] - O2, yt: M2.y[1] + O2, l: Math.max(v3.cx - v3.r - A2.left, 0), r: Math.max(A2.right - (v3.cx + v3.r), 0), b: Math.max(A2.bottom - (v3.cy + v3.r), 0), t: Math.max(v3.cy - v3.r - A2.top, 0), pad: 5 });
              }
            });
          });
          setTimeout(function() {
            v2.selectAll("tspan").each(function() {
              var t4 = n2.select(this);
              t4.attr("dy") && t4.attr("dy", t4.attr("dy"));
            });
          }, 0);
        }, formatSliceLabel: z, transformInsideText: w2, determineInsideTextFont: b, positionTitleOutside: C, prerenderTitles: _, layoutAreas: I, attachFxHandlers: x, computeTransform: R };
      }, 68357: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(63463), a = r2(72597).resizeText;
        t2.exports = function(t3) {
          var e3 = t3._fullLayout._pielayer.selectAll(".trace");
          a(t3, e3, "pie"), e3.each(function(t4) {
            var e4 = t4[0].trace, r3 = n2.select(this);
            r3.style({ opacity: e4.opacity }), r3.selectAll("path.surface").each(function(t5) {
              n2.select(this).call(i, t5, e4);
            });
          });
        };
      }, 63463: function(t2, e2, r2) {
        var n2 = r2(7901), i = r2(53581).castOption;
        t2.exports = function(t3, e3, r3) {
          var a = r3.marker.line, o = i(a.color, e3.pts) || n2.defaultLine, s = i(a.width, e3.pts) || 0;
          t3.style("stroke-width", s).call(n2.fill, e3.color).call(n2.stroke, o);
        };
      }, 10959: function(t2, e2, r2) {
        var n2 = r2(82196);
        t2.exports = { x: n2.x, y: n2.y, xy: { valType: "data_array", editType: "calc" }, indices: { valType: "data_array", editType: "calc" }, xbounds: { valType: "data_array", editType: "calc" }, ybounds: { valType: "data_array", editType: "calc" }, text: n2.text, marker: { color: { valType: "color", arrayOk: false, editType: "calc" }, opacity: { valType: "number", min: 0, max: 1, dflt: 1, arrayOk: false, editType: "calc" }, blend: { valType: "boolean", dflt: null, editType: "calc" }, sizemin: { valType: "number", min: 0.1, max: 2, dflt: 0.5, editType: "calc" }, sizemax: { valType: "number", min: 0.1, dflt: 20, editType: "calc" }, border: { color: { valType: "color", arrayOk: false, editType: "calc" }, arearatio: { valType: "number", min: 0, max: 1, dflt: 0, editType: "calc" }, editType: "calc" }, editType: "calc" }, transforms: void 0 };
      }, 42743: function(t2, e2, r2) {
        var n2 = r2(9330).gl_pointcloud2d, i = r2(78614), a = r2(71739).findExtremes, o = r2(34603);
        function s(t3, e3) {
          this.scene = t3, this.uid = e3, this.type = "pointcloud", this.pickXData = [], this.pickYData = [], this.xData = [], this.yData = [], this.textLabels = [], this.color = "rgb(0, 0, 0)", this.name = "", this.hoverinfo = "all", this.idToIndex = new Int32Array(0), this.bounds = [0, 0, 0, 0], this.pointcloudOptions = { positions: new Float32Array(0), idToIndex: this.idToIndex, sizemin: 0.5, sizemax: 12, color: [0, 0, 0, 1], areaRatio: 1, borderColor: [0, 0, 0, 1] }, this.pointcloud = n2(t3.glplot, this.pointcloudOptions), this.pointcloud._trace = this;
        }
        var l = s.prototype;
        l.handlePick = function(t3) {
          var e3 = this.idToIndex[t3.pointId];
          return { trace: this, dataCoord: t3.dataCoord, traceCoord: this.pickXYData ? [this.pickXYData[2 * e3], this.pickXYData[2 * e3 + 1]] : [this.pickXData[e3], this.pickYData[e3]], textLabel: Array.isArray(this.textLabels) ? this.textLabels[e3] : this.textLabels, color: this.color, name: this.name, pointIndex: e3, hoverinfo: this.hoverinfo };
        }, l.update = function(t3) {
          this.index = t3.index, this.textLabels = t3.text, this.name = t3.name, this.hoverinfo = t3.hoverinfo, this.bounds = [1 / 0, 1 / 0, -1 / 0, -1 / 0], this.updateFast(t3), this.color = o(t3, {});
        }, l.updateFast = function(t3) {
          var e3, r3, n3, o2, s2, l2, u = this.xData = this.pickXData = t3.x, c = this.yData = this.pickYData = t3.y, f2 = this.pickXYData = t3.xy, h = t3.xbounds && t3.ybounds, p2 = t3.indices, d2 = this.bounds;
          if (f2) {
            if (n3 = f2, e3 = f2.length >>> 1, h)
              d2[0] = t3.xbounds[0], d2[2] = t3.xbounds[1], d2[1] = t3.ybounds[0], d2[3] = t3.ybounds[1];
            else
              for (l2 = 0; l2 < e3; l2++)
                o2 = n3[2 * l2], s2 = n3[2 * l2 + 1], o2 < d2[0] && (d2[0] = o2), o2 > d2[2] && (d2[2] = o2), s2 < d2[1] && (d2[1] = s2), s2 > d2[3] && (d2[3] = s2);
            if (p2)
              r3 = p2;
            else
              for (r3 = new Int32Array(e3), l2 = 0; l2 < e3; l2++)
                r3[l2] = l2;
          } else
            for (e3 = u.length, n3 = new Float32Array(2 * e3), r3 = new Int32Array(e3), l2 = 0; l2 < e3; l2++)
              o2 = u[l2], s2 = c[l2], r3[l2] = l2, n3[2 * l2] = o2, n3[2 * l2 + 1] = s2, o2 < d2[0] && (d2[0] = o2), o2 > d2[2] && (d2[2] = o2), s2 < d2[1] && (d2[1] = s2), s2 > d2[3] && (d2[3] = s2);
          this.idToIndex = r3, this.pointcloudOptions.idToIndex = r3, this.pointcloudOptions.positions = n3;
          var v = i(t3.marker.color), g2 = i(t3.marker.border.color), y = t3.opacity * t3.marker.opacity;
          v[3] *= y, this.pointcloudOptions.color = v;
          var m2 = t3.marker.blend;
          null === m2 && (m2 = u.length < 100 || c.length < 100), this.pointcloudOptions.blend = m2, g2[3] *= y, this.pointcloudOptions.borderColor = g2;
          var x = t3.marker.sizemin, b = Math.max(t3.marker.sizemax, t3.marker.sizemin);
          this.pointcloudOptions.sizeMin = x, this.pointcloudOptions.sizeMax = b, this.pointcloudOptions.areaRatio = t3.marker.border.arearatio, this.pointcloud.update(this.pointcloudOptions);
          var _ = this.scene.xaxis, w2 = this.scene.yaxis, T = b / 2 || 0.5;
          t3._extremes[_._id] = a(_, [d2[0], d2[2]], { ppad: T }), t3._extremes[w2._id] = a(w2, [d2[1], d2[3]], { ppad: T });
        }, l.dispose = function() {
          this.pointcloud.dispose();
        }, t2.exports = function(t3, e3) {
          var r3 = new s(t3, e3.uid);
          return r3.update(e3), r3;
        };
      }, 33876: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(10959);
        t2.exports = function(t3, e3, r3) {
          function a(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          a("x"), a("y"), a("xbounds"), a("ybounds"), t3.xy && t3.xy instanceof Float32Array && (e3.xy = t3.xy), t3.indices && t3.indices instanceof Int32Array && (e3.indices = t3.indices), a("text"), a("marker.color", r3), a("marker.opacity"), a("marker.blend"), a("marker.sizemin"), a("marker.sizemax"), a("marker.border.color", r3), a("marker.border.arearatio"), e3._length = null;
        };
      }, 20593: function(t2, e2, r2) {
        t2.exports = { attributes: r2(10959), supplyDefaults: r2(33876), calc: r2(36563), plot: r2(42743), moduleType: "trace", name: "pointcloud", basePlotModule: r2(4796), categories: ["gl", "gl2d", "showLegend"], meta: {} };
      }, 39953: function(t2, e2, r2) {
        var n2 = r2(41940), i = r2(9012), a = r2(22399), o = r2(77914), s = r2(27670).Y, l = r2(5386).f, u = r2(50693), c = r2(44467).templatedArray, f2 = r2(12663).descriptionOnlyNumbers, h = r2(1426).extendFlat, p2 = r2(30962).overrideAll;
        (t2.exports = p2({ hoverinfo: h({}, i.hoverinfo, { flags: [], arrayOk: false }), hoverlabel: o.hoverlabel, domain: s({ name: "sankey", trace: true }), orientation: { valType: "enumerated", values: ["v", "h"], dflt: "h" }, valueformat: { valType: "string", dflt: ".3s", description: f2("value") }, valuesuffix: { valType: "string", dflt: "" }, arrangement: { valType: "enumerated", values: ["snap", "perpendicular", "freeform", "fixed"], dflt: "snap" }, textfont: n2({}), customdata: void 0, node: { label: { valType: "data_array", dflt: [] }, groups: { valType: "info_array", impliedEdits: { x: [], y: [] }, dimensions: 2, freeLength: true, dflt: [], items: { valType: "number", editType: "calc" } }, x: { valType: "data_array", dflt: [] }, y: { valType: "data_array", dflt: [] }, color: { valType: "color", arrayOk: true }, customdata: { valType: "data_array", editType: "calc" }, line: { color: { valType: "color", dflt: a.defaultLine, arrayOk: true }, width: { valType: "number", min: 0, dflt: 0.5, arrayOk: true } }, pad: { valType: "number", arrayOk: false, min: 0, dflt: 20 }, thickness: { valType: "number", arrayOk: false, min: 1, dflt: 20 }, hoverinfo: { valType: "enumerated", values: ["all", "none", "skip"], dflt: "all" }, hoverlabel: o.hoverlabel, hovertemplate: l({}, { keys: ["value", "label"] }) }, link: { arrowlen: { valType: "number", min: 0, dflt: 0 }, label: { valType: "data_array", dflt: [] }, color: { valType: "color", arrayOk: true }, customdata: { valType: "data_array", editType: "calc" }, line: { color: { valType: "color", dflt: a.defaultLine, arrayOk: true }, width: { valType: "number", min: 0, dflt: 0, arrayOk: true } }, source: { valType: "data_array", dflt: [] }, target: { valType: "data_array", dflt: [] }, value: { valType: "data_array", dflt: [] }, hoverinfo: { valType: "enumerated", values: ["all", "none", "skip"], dflt: "all" }, hoverlabel: o.hoverlabel, hovertemplate: l({}, { keys: ["value", "label"] }), colorscales: c("concentrationscales", { editType: "calc", label: { valType: "string", editType: "calc", dflt: "" }, cmax: { valType: "number", editType: "calc", dflt: 1 }, cmin: { valType: "number", editType: "calc", dflt: 0 }, colorscale: h(u().colorscale, { dflt: [[0, "white"], [1, "black"]] }) }) } }, "calc", "nested")).transforms = void 0;
      }, 75536: function(t2, e2, r2) {
        var n2 = r2(30962).overrideAll, i = r2(27659).a0, a = r2(60436), o = r2(528), s = r2(6964), l = r2(28569), u = r2(47322).prepSelect, c = r2(71828), f2 = r2(73972), h = "sankey";
        function p2(t3, e3) {
          var r3 = t3._fullData[e3], n3 = t3._fullLayout, i2 = n3.dragmode, a2 = "pan" === n3.dragmode ? "move" : "crosshair", o2 = r3._bgRect;
          if (o2 && "pan" !== i2 && "zoom" !== i2) {
            s(o2, a2);
            var h2 = { _id: "x", c2p: c.identity, _offset: r3._sankey.translateX, _length: r3._sankey.width }, p3 = { _id: "y", c2p: c.identity, _offset: r3._sankey.translateY, _length: r3._sankey.height }, d2 = { gd: t3, element: o2.node(), plotinfo: { id: e3, xaxis: h2, yaxis: p3, fillRangeItems: c.noop }, subplot: e3, xaxes: [h2], yaxes: [p3], doneFnCompleted: function(r4) {
              var n4, i3 = t3._fullData[e3], a3 = i3.node.groups.slice(), o3 = [];
              function s2(t4) {
                for (var e4 = i3._sankey.graph.nodes, r5 = 0; r5 < e4.length; r5++)
                  if (e4[r5].pointNumber === t4)
                    return e4[r5];
              }
              for (var l2 = 0; l2 < r4.length; l2++) {
                var u2 = s2(r4[l2].pointNumber);
                if (u2)
                  if (u2.group) {
                    for (var c2 = 0; c2 < u2.childrenNodes.length; c2++)
                      o3.push(u2.childrenNodes[c2].pointNumber);
                    a3[u2.pointNumber - i3.node._count] = false;
                  } else
                    o3.push(u2.pointNumber);
              }
              n4 = a3.filter(Boolean).concat([o3]), f2.call("_guiRestyle", t3, { "node.groups": [n4] }, e3);
            }, prepFn: function(t4, e4, r4) {
              u(t4, e4, r4, d2, i2);
            } };
            l.init(d2);
          }
        }
        e2.name = h, e2.baseLayoutAttrOverrides = n2({ hoverlabel: o.hoverlabel }, "plot", "nested"), e2.plot = function(t3) {
          var r3 = i(t3.calcdata, h)[0];
          a(t3, r3), e2.updateFx(t3);
        }, e2.clean = function(t3, e3, r3, n3) {
          var i2 = n3._has && n3._has(h), a2 = e3._has && e3._has(h);
          i2 && !a2 && (n3._paperdiv.selectAll(".sankey").remove(), n3._paperdiv.selectAll(".bgsankey").remove());
        }, e2.updateFx = function(t3) {
          for (var e3 = 0; e3 < t3._fullData.length; e3++)
            p2(t3, e3);
        };
      }, 92930: function(t2, e2, r2) {
        var n2 = r2(68664), i = r2(71828), a = r2(28984).wrap, o = i.isArrayOrTypedArray, s = i.isIndex, l = r2(21081);
        t2.exports = function(t3, e3) {
          var r3 = function(t4) {
            var e4, r4 = t4.node, a2 = t4.link, u = [], c = o(a2.color), f2 = o(a2.customdata), h = {}, p2 = {}, d2 = a2.colorscales.length;
            for (e4 = 0; e4 < d2; e4++) {
              var v = a2.colorscales[e4], g2 = l.extractScale(v, { cLetter: "c" }), y = l.makeColorScaleFunc(g2);
              p2[v.label] = y;
            }
            var m2 = 0;
            for (e4 = 0; e4 < a2.value.length; e4++)
              a2.source[e4] > m2 && (m2 = a2.source[e4]), a2.target[e4] > m2 && (m2 = a2.target[e4]);
            var x, b = m2 + 1;
            t4.node._count = b;
            var _ = t4.node.groups, w2 = {};
            for (e4 = 0; e4 < _.length; e4++) {
              var T = _[e4];
              for (x = 0; x < T.length; x++) {
                var k = T[x], A = b + e4;
                w2.hasOwnProperty(k) ? i.warn("Node " + k + " is already part of a group.") : w2[k] = A;
              }
            }
            var M = { source: [], target: [] };
            for (e4 = 0; e4 < a2.value.length; e4++) {
              var S = a2.value[e4], E = a2.source[e4], L = a2.target[e4];
              if (S > 0 && s(E, b) && s(L, b) && (!w2.hasOwnProperty(E) || !w2.hasOwnProperty(L) || w2[E] !== w2[L])) {
                w2.hasOwnProperty(L) && (L = w2[L]), w2.hasOwnProperty(E) && (E = w2[E]), L = +L, h[E = +E] = h[L] = true;
                var C = "";
                a2.label && a2.label[e4] && (C = a2.label[e4]);
                var P = null;
                C && p2.hasOwnProperty(C) && (P = p2[C]), u.push({ pointNumber: e4, label: C, color: c ? a2.color[e4] : a2.color, customdata: f2 ? a2.customdata[e4] : a2.customdata, concentrationscale: P, source: E, target: L, value: +S }), M.source.push(E), M.target.push(L);
              }
            }
            var O = b + _.length, I = o(r4.color), D = o(r4.customdata), z = [];
            for (e4 = 0; e4 < O; e4++)
              if (h[e4]) {
                var R = r4.label[e4];
                z.push({ group: e4 > b - 1, childrenNodes: [], pointNumber: e4, label: R, color: I ? r4.color[e4] : r4.color, customdata: D ? r4.customdata[e4] : r4.customdata });
              }
            var F = false;
            return function(t5, e5, r5) {
              for (var a3 = i.init2dArray(t5, 0), o2 = 0; o2 < Math.min(e5.length, r5.length); o2++)
                if (i.isIndex(e5[o2], t5) && i.isIndex(r5[o2], t5)) {
                  if (e5[o2] === r5[o2])
                    return true;
                  a3[e5[o2]].push(r5[o2]);
                }
              return n2(a3).components.some(function(t6) {
                return t6.length > 1;
              });
            }(O, M.source, M.target) && (F = true), { circular: F, links: u, nodes: z, groups: _, groupLookup: w2 };
          }(e3);
          return a({ circular: r3.circular, _nodes: r3.nodes, _links: r3.links, _groups: r3.groups, _groupLookup: r3.groupLookup });
        };
      }, 85247: function(t2) {
        t2.exports = { nodeTextOffsetHorizontal: 4, nodeTextOffsetVertical: 3, nodePadAcross: 10, sankeyIterations: 50, forceIterations: 5, forceTicksPerFrame: 10, duration: 500, ease: "linear", cn: { sankey: "sankey", sankeyLinks: "sankey-links", sankeyLink: "sankey-link", sankeyNodeSet: "sankey-node-set", sankeyNode: "sankey-node", nodeRect: "node-rect", nodeLabel: "node-label" } };
      }, 26857: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(39953), a = r2(7901), o = r2(84267), s = r2(27670).c, l = r2(38048), u = r2(44467), c = r2(85501);
        function f2(t3, e3) {
          function r3(r4, a2) {
            return n2.coerce(t3, e3, i.link.colorscales, r4, a2);
          }
          r3("label"), r3("cmin"), r3("cmax"), r3("colorscale");
        }
        t2.exports = function(t3, e3, r3, h) {
          function p2(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          var d2 = n2.extendDeep(h.hoverlabel, t3.hoverlabel), v = t3.node, g2 = u.newContainer(e3, "node");
          function y(t4, e4) {
            return n2.coerce(v, g2, i.node, t4, e4);
          }
          y("label"), y("groups"), y("x"), y("y"), y("pad"), y("thickness"), y("line.color"), y("line.width"), y("hoverinfo", t3.hoverinfo), l(v, g2, y, d2), y("hovertemplate");
          var m2 = h.colorway;
          y("color", g2.label.map(function(t4, e4) {
            return a.addOpacity(function(t5) {
              return m2[t5 % m2.length];
            }(e4), 0.8);
          })), y("customdata");
          var x = t3.link || {}, b = u.newContainer(e3, "link");
          function _(t4, e4) {
            return n2.coerce(x, b, i.link, t4, e4);
          }
          _("label"), _("arrowlen"), _("source"), _("target"), _("value"), _("line.color"), _("line.width"), _("hoverinfo", t3.hoverinfo), l(x, b, _, d2), _("hovertemplate");
          var w2, T = o(h.paper_bgcolor).getLuminance() < 0.333 ? "rgba(255, 255, 255, 0.6)" : "rgba(0, 0, 0, 0.2)";
          _("color", n2.repeat(T, b.value.length)), _("customdata"), c(x, b, { name: "colorscales", handleItemDefaults: f2 }), s(e3, h, p2), p2("orientation"), p2("valueformat"), p2("valuesuffix"), g2.x.length && g2.y.length && (w2 = "freeform"), p2("arrangement", w2), n2.coerceFont(p2, "textfont", n2.extendFlat({}, h.font)), e3._length = null;
        };
      }, 29396: function(t2, e2, r2) {
        t2.exports = { attributes: r2(39953), supplyDefaults: r2(26857), calc: r2(92930), plot: r2(60436), moduleType: "trace", name: "sankey", basePlotModule: r2(75536), selectPoints: r2(84564), categories: ["noOpacity"], meta: {} };
      }, 60436: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = i.numberFormat, o = r2(3393), s = r2(30211), l = r2(7901), u = r2(85247).cn, c = i._;
        function f2(t3) {
          return "" !== t3;
        }
        function h(t3, e3) {
          return t3.filter(function(t4) {
            return t4.key === e3.traceId;
          });
        }
        function p2(t3, e3) {
          n2.select(t3).select("path").style("fill-opacity", e3), n2.select(t3).select("rect").style("fill-opacity", e3);
        }
        function d2(t3) {
          n2.select(t3).select("text.name").style("fill", "black");
        }
        function v(t3) {
          return function(e3) {
            return -1 !== t3.node.sourceLinks.indexOf(e3.link) || -1 !== t3.node.targetLinks.indexOf(e3.link);
          };
        }
        function g2(t3) {
          return function(e3) {
            return -1 !== e3.node.sourceLinks.indexOf(t3.link) || -1 !== e3.node.targetLinks.indexOf(t3.link);
          };
        }
        function y(t3, e3, r3) {
          e3 && r3 && h(r3, e3).selectAll("." + u.sankeyLink).filter(v(e3)).call(x.bind(0, e3, r3, false));
        }
        function m2(t3, e3, r3) {
          e3 && r3 && h(r3, e3).selectAll("." + u.sankeyLink).filter(v(e3)).call(b.bind(0, e3, r3, false));
        }
        function x(t3, e3, r3, n3) {
          var i2 = n3.datum().link.label;
          n3.style("fill-opacity", function(t4) {
            if (!t4.link.concentrationscale)
              return 0.4;
          }), i2 && h(e3, t3).selectAll("." + u.sankeyLink).filter(function(t4) {
            return t4.link.label === i2;
          }).style("fill-opacity", function(t4) {
            if (!t4.link.concentrationscale)
              return 0.4;
          }), r3 && h(e3, t3).selectAll("." + u.sankeyNode).filter(g2(t3)).call(y);
        }
        function b(t3, e3, r3, n3) {
          var i2 = n3.datum().link.label;
          n3.style("fill-opacity", function(t4) {
            return t4.tinyColorAlpha;
          }), i2 && h(e3, t3).selectAll("." + u.sankeyLink).filter(function(t4) {
            return t4.link.label === i2;
          }).style("fill-opacity", function(t4) {
            return t4.tinyColorAlpha;
          }), r3 && h(e3, t3).selectAll(u.sankeyNode).filter(g2(t3)).call(m2);
        }
        function _(t3, e3) {
          var r3 = t3.hoverlabel || {}, n3 = i.nestedProperty(r3, e3).get();
          return !Array.isArray(n3) && n3;
        }
        t2.exports = function(t3, e3) {
          for (var r3 = t3._fullLayout, i2 = r3._paper, h2 = r3._size, v2 = 0; v2 < t3._fullData.length; v2++)
            if (t3._fullData[v2].visible && t3._fullData[v2].type === u.sankey && !t3._fullData[v2]._viewInitial) {
              var g3 = t3._fullData[v2].node;
              t3._fullData[v2]._viewInitial = { node: { groups: g3.groups.slice(), x: g3.x.slice(), y: g3.y.slice() } };
            }
          var w2 = c(t3, "source:") + " ", T = c(t3, "target:") + " ", k = c(t3, "concentration:") + " ", A = c(t3, "incoming flow count:") + " ", M = c(t3, "outgoing flow count:") + " ";
          o(t3, i2, e3, { width: h2.w, height: h2.h, margin: { t: h2.t, r: h2.r, b: h2.b, l: h2.l } }, { linkEvents: { hover: function(e4, r4, i3) {
            false !== t3._fullLayout.hovermode && (n2.select(e4).call(x.bind(0, r4, i3, true)), "skip" !== r4.link.trace.link.hoverinfo && (r4.link.fullData = r4.link.trace, t3.emit("plotly_hover", { event: n2.event, points: [r4.link] })));
          }, follow: function(e4, i3) {
            if (false !== t3._fullLayout.hovermode) {
              var o2 = i3.link.trace.link;
              if ("none" !== o2.hoverinfo && "skip" !== o2.hoverinfo) {
                for (var u2 = [], c2 = 0, h3 = 0; h3 < i3.flow.links.length; h3++) {
                  var v3 = i3.flow.links[h3];
                  if ("closest" !== t3._fullLayout.hovermode || i3.link.pointNumber === v3.pointNumber) {
                    i3.link.pointNumber === v3.pointNumber && (c2 = h3), v3.fullData = v3.trace, o2 = i3.link.trace.link;
                    var g4 = m3(v3), y2 = { valueLabel: a(i3.valueFormat)(v3.value) + i3.valueSuffix };
                    u2.push({ x: g4[0], y: g4[1], name: y2.valueLabel, text: [v3.label || "", w2 + v3.source.label, T + v3.target.label, v3.concentrationscale ? k + a("%0.2f")(v3.flow.labelConcentration) : ""].filter(f2).join("<br>"), color: _(o2, "bgcolor") || l.addOpacity(v3.color, 1), borderColor: _(o2, "bordercolor"), fontFamily: _(o2, "font.family"), fontSize: _(o2, "font.size"), fontColor: _(o2, "font.color"), nameLength: _(o2, "namelength"), textAlign: _(o2, "align"), idealAlign: n2.event.x < g4[0] ? "right" : "left", hovertemplate: o2.hovertemplate, hovertemplateLabels: y2, eventData: [v3] });
                  }
                }
                s.loneHover(u2, { container: r3._hoverlayer.node(), outerContainer: r3._paper.node(), gd: t3, anchorIndex: c2 }).each(function() {
                  i3.link.concentrationscale || p2(this, 0.65), d2(this);
                });
              }
            }
            function m3(t4) {
              var e5, r4;
              t4.circular ? (e5 = (t4.circularPathData.leftInnerExtent + t4.circularPathData.rightInnerExtent) / 2, r4 = t4.circularPathData.verticalFullExtent) : (e5 = (t4.source.x1 + t4.target.x0) / 2, r4 = (t4.y0 + t4.y1) / 2);
              var n3 = [e5, r4];
              return "v" === t4.trace.orientation && n3.reverse(), n3[0] += i3.parent.translateX, n3[1] += i3.parent.translateY, n3;
            }
          }, unhover: function(e4, i3, a2) {
            false !== t3._fullLayout.hovermode && (n2.select(e4).call(b.bind(0, i3, a2, true)), "skip" !== i3.link.trace.link.hoverinfo && (i3.link.fullData = i3.link.trace, t3.emit("plotly_unhover", { event: n2.event, points: [i3.link] })), s.loneUnhover(r3._hoverlayer.node()));
          }, select: function(e4, r4) {
            var i3 = r4.link;
            i3.originalEvent = n2.event, t3._hoverdata = [i3], s.click(t3, { target: true });
          } }, nodeEvents: { hover: function(e4, r4, i3) {
            false !== t3._fullLayout.hovermode && (n2.select(e4).call(y, r4, i3), "skip" !== r4.node.trace.node.hoverinfo && (r4.node.fullData = r4.node.trace, t3.emit("plotly_hover", { event: n2.event, points: [r4.node] })));
          }, follow: function(e4, i3) {
            if (false !== t3._fullLayout.hovermode) {
              var o2 = i3.node.trace.node;
              if ("none" !== o2.hoverinfo && "skip" !== o2.hoverinfo) {
                var l2 = n2.select(e4).select("." + u.nodeRect), c2 = t3._fullLayout._paperdiv.node().getBoundingClientRect(), h3 = l2.node().getBoundingClientRect(), v3 = h3.left - 2 - c2.left, g4 = h3.right + 2 - c2.left, y2 = h3.top + h3.height / 4 - c2.top, m3 = { valueLabel: a(i3.valueFormat)(i3.node.value) + i3.valueSuffix };
                i3.node.fullData = i3.node.trace, t3._fullLayout._calcInverseTransform(t3);
                var x2 = t3._fullLayout._invScaleX, b2 = t3._fullLayout._invScaleY, w3 = s.loneHover({ x0: x2 * v3, x1: x2 * g4, y: b2 * y2, name: a(i3.valueFormat)(i3.node.value) + i3.valueSuffix, text: [i3.node.label, A + i3.node.targetLinks.length, M + i3.node.sourceLinks.length].filter(f2).join("<br>"), color: _(o2, "bgcolor") || i3.tinyColorHue, borderColor: _(o2, "bordercolor"), fontFamily: _(o2, "font.family"), fontSize: _(o2, "font.size"), fontColor: _(o2, "font.color"), nameLength: _(o2, "namelength"), textAlign: _(o2, "align"), idealAlign: "left", hovertemplate: o2.hovertemplate, hovertemplateLabels: m3, eventData: [i3.node] }, { container: r3._hoverlayer.node(), outerContainer: r3._paper.node(), gd: t3 });
                p2(w3, 0.85), d2(w3);
              }
            }
          }, unhover: function(e4, i3, a2) {
            false !== t3._fullLayout.hovermode && (n2.select(e4).call(m2, i3, a2), "skip" !== i3.node.trace.node.hoverinfo && (i3.node.fullData = i3.node.trace, t3.emit("plotly_unhover", { event: n2.event, points: [i3.node] })), s.loneUnhover(r3._hoverlayer.node()));
          }, select: function(e4, r4, i3) {
            var a2 = r4.node;
            a2.originalEvent = n2.event, t3._hoverdata = [a2], n2.select(e4).call(m2, r4, i3), s.click(t3, { target: true });
          } } });
        };
      }, 3393: function(t2, e2, r2) {
        var n2 = r2(49887), i = r2(81684).k4, a = r2(39898), o = r2(30838), s = r2(86781), l = r2(85247), u = r2(84267), c = r2(7901), f2 = r2(91424), h = r2(71828), p2 = h.strTranslate, d2 = h.strRotate, v = r2(28984), g2 = v.keyFun, y = v.repeat, m2 = v.unwrap, x = r2(63893), b = r2(73972), _ = r2(18783), w2 = _.CAP_SHIFT, T = _.LINE_SPACING;
        function k(t3, e3, r3) {
          var n3, i2 = m2(e3), a2 = i2.trace, c2 = a2.domain, f3 = "h" === a2.orientation, p3 = a2.node.pad, d3 = a2.node.thickness, v2 = t3.width * (c2.x[1] - c2.x[0]), g3 = t3.height * (c2.y[1] - c2.y[0]), y2 = i2._nodes, x2 = i2._links, b2 = i2.circular;
          (n3 = b2 ? s.sankeyCircular().circularLinkGap(0) : o.sankey()).iterations(l.sankeyIterations).size(f3 ? [v2, g3] : [g3, v2]).nodeWidth(d3).nodePadding(p3).nodeId(function(t4) {
            return t4.pointNumber;
          }).nodes(y2).links(x2);
          var _2, w3, T2, k2 = n3();
          for (var A2 in n3.nodePadding() < p3 && h.warn("node.pad was reduced to ", n3.nodePadding(), " to fit within the figure."), i2._groupLookup) {
            var M2, S2 = parseInt(i2._groupLookup[A2]);
            for (_2 = 0; _2 < k2.nodes.length; _2++)
              if (k2.nodes[_2].pointNumber === S2) {
                M2 = k2.nodes[_2];
                break;
              }
            if (M2) {
              var E2 = { pointNumber: parseInt(A2), x0: M2.x0, x1: M2.x1, y0: M2.y0, y1: M2.y1, partOfGroup: true, sourceLinks: [], targetLinks: [] };
              k2.nodes.unshift(E2), M2.childrenNodes.unshift(E2);
            }
          }
          if (function() {
            for (_2 = 0; _2 < k2.nodes.length; _2++) {
              var t4, e4, r4 = k2.nodes[_2], n4 = {};
              for (w3 = 0; w3 < r4.targetLinks.length; w3++)
                t4 = (e4 = r4.targetLinks[w3]).source.pointNumber + ":" + e4.target.pointNumber, n4.hasOwnProperty(t4) || (n4[t4] = []), n4[t4].push(e4);
              var i3 = Object.keys(n4);
              for (w3 = 0; w3 < i3.length; w3++) {
                var a3 = n4[t4 = i3[w3]], o2 = 0, s2 = {};
                for (T2 = 0; T2 < a3.length; T2++)
                  s2[(e4 = a3[T2]).label] || (s2[e4.label] = 0), s2[e4.label] += e4.value, o2 += e4.value;
                for (T2 = 0; T2 < a3.length; T2++)
                  (e4 = a3[T2]).flow = { value: o2, labelConcentration: s2[e4.label] / o2, concentration: e4.value / o2, links: a3 }, e4.concentrationscale && (e4.color = u(e4.concentrationscale(e4.flow.labelConcentration)));
              }
              var l2 = 0;
              for (w3 = 0; w3 < r4.sourceLinks.length; w3++)
                l2 += r4.sourceLinks[w3].value;
              for (w3 = 0; w3 < r4.sourceLinks.length; w3++)
                (e4 = r4.sourceLinks[w3]).concentrationOut = e4.value / l2;
              var c3 = 0;
              for (w3 = 0; w3 < r4.targetLinks.length; w3++)
                c3 += r4.targetLinks[w3].value;
              for (w3 = 0; w3 < r4.targetLinks.length; w3++)
                (e4 = r4.targetLinks[w3]).concenrationIn = e4.value / c3;
            }
          }(), a2.node.x.length && a2.node.y.length) {
            for (_2 = 0; _2 < Math.min(a2.node.x.length, a2.node.y.length, k2.nodes.length); _2++)
              if (a2.node.x[_2] && a2.node.y[_2]) {
                var L2 = [a2.node.x[_2] * v2, a2.node.y[_2] * g3];
                k2.nodes[_2].x0 = L2[0] - d3 / 2, k2.nodes[_2].x1 = L2[0] + d3 / 2;
                var C2 = k2.nodes[_2].y1 - k2.nodes[_2].y0;
                k2.nodes[_2].y0 = L2[1] - C2 / 2, k2.nodes[_2].y1 = L2[1] + C2 / 2;
              }
            "snap" === a2.arrangement && function(t4) {
              var e4, r4, n4 = t4.map(function(t5, e5) {
                return { x0: t5.x0, index: e5 };
              }).sort(function(t5, e5) {
                return t5.x0 - e5.x0;
              }), i3 = [], a3 = -1, o2 = -1 / 0;
              for (_2 = 0; _2 < n4.length; _2++) {
                var s2 = t4[n4[_2].index];
                s2.x0 > o2 + d3 && (a3 += 1, e4 = s2.x0), o2 = s2.x0, i3[a3] || (i3[a3] = []), i3[a3].push(s2), r4 = e4 - s2.x0, s2.x0 += r4, s2.x1 += r4;
              }
              return i3;
            }(y2 = k2.nodes).forEach(function(t4) {
              var e4, r4, n4, i3 = 0, a3 = t4.length;
              for (t4.sort(function(t5, e5) {
                return t5.y0 - e5.y0;
              }), n4 = 0; n4 < a3; ++n4)
                (e4 = t4[n4]).y0 >= i3 || (r4 = i3 - e4.y0) > 1e-6 && (e4.y0 += r4, e4.y1 += r4), i3 = e4.y1 + p3;
            }), n3.update(k2);
          }
          return { circular: b2, key: r3, trace: a2, guid: h.randstr(), horizontal: f3, width: v2, height: g3, nodePad: a2.node.pad, nodeLineColor: a2.node.line.color, nodeLineWidth: a2.node.line.width, linkLineColor: a2.link.line.color, linkLineWidth: a2.link.line.width, linkArrowLength: a2.link.arrowlen, valueFormat: a2.valueformat, valueSuffix: a2.valuesuffix, textFont: a2.textfont, translateX: c2.x[0] * t3.width + t3.margin.l, translateY: t3.height - c2.y[1] * t3.height + t3.margin.t, dragParallel: f3 ? g3 : v2, dragPerpendicular: f3 ? v2 : g3, arrangement: a2.arrangement, sankey: n3, graph: k2, forceLayouts: {}, interactionState: { dragInProgress: false, hovered: false } };
        }
        function A(t3, e3, r3) {
          var n3 = u(e3.color), i2 = e3.source.label + "|" + e3.target.label + "__" + r3;
          return e3.trace = t3.trace, e3.curveNumber = t3.trace.index, { circular: t3.circular, key: i2, traceId: t3.key, pointNumber: e3.pointNumber, link: e3, tinyColorHue: c.tinyRGB(n3), tinyColorAlpha: n3.getAlpha(), linkPath: M, linkLineColor: t3.linkLineColor, linkLineWidth: t3.linkLineWidth, linkArrowLength: t3.linkArrowLength, valueFormat: t3.valueFormat, valueSuffix: t3.valueSuffix, sankey: t3.sankey, parent: t3, interactionState: t3.interactionState, flow: e3.flow };
        }
        function M() {
          return function(t3) {
            var e3 = t3.linkArrowLength;
            if (t3.link.circular)
              return function(t4, e4) {
                var r4 = t4.width / 2, n4 = t4.circularPathData;
                return "top" === t4.circularLinkType ? "M " + (n4.targetX - e4) + " " + (n4.targetY + r4) + " L" + (n4.rightInnerExtent - e4) + " " + (n4.targetY + r4) + "A" + (n4.rightLargeArcRadius + r4) + " " + (n4.rightSmallArcRadius + r4) + " 0 0 1 " + (n4.rightFullExtent - r4 - e4) + " " + (n4.targetY - n4.rightSmallArcRadius) + "L" + (n4.rightFullExtent - r4 - e4) + " " + n4.verticalRightInnerExtent + "A" + (n4.rightLargeArcRadius + r4) + " " + (n4.rightLargeArcRadius + r4) + " 0 0 1 " + (n4.rightInnerExtent - e4) + " " + (n4.verticalFullExtent - r4) + "L" + n4.leftInnerExtent + " " + (n4.verticalFullExtent - r4) + "A" + (n4.leftLargeArcRadius + r4) + " " + (n4.leftLargeArcRadius + r4) + " 0 0 1 " + (n4.leftFullExtent + r4) + " " + n4.verticalLeftInnerExtent + "L" + (n4.leftFullExtent + r4) + " " + (n4.sourceY - n4.leftSmallArcRadius) + "A" + (n4.leftLargeArcRadius + r4) + " " + (n4.leftSmallArcRadius + r4) + " 0 0 1 " + n4.leftInnerExtent + " " + (n4.sourceY + r4) + "L" + n4.sourceX + " " + (n4.sourceY + r4) + "L" + n4.sourceX + " " + (n4.sourceY - r4) + "L" + n4.leftInnerExtent + " " + (n4.sourceY - r4) + "A" + (n4.leftLargeArcRadius - r4) + " " + (n4.leftSmallArcRadius - r4) + " 0 0 0 " + (n4.leftFullExtent - r4) + " " + (n4.sourceY - n4.leftSmallArcRadius) + "L" + (n4.leftFullExtent - r4) + " " + n4.verticalLeftInnerExtent + "A" + (n4.leftLargeArcRadius - r4) + " " + (n4.leftLargeArcRadius - r4) + " 0 0 0 " + n4.leftInnerExtent + " " + (n4.verticalFullExtent + r4) + "L" + (n4.rightInnerExtent - e4) + " " + (n4.verticalFullExtent + r4) + "A" + (n4.rightLargeArcRadius - r4) + " " + (n4.rightLargeArcRadius - r4) + " 0 0 0 " + (n4.rightFullExtent + r4 - e4) + " " + n4.verticalRightInnerExtent + "L" + (n4.rightFullExtent + r4 - e4) + " " + (n4.targetY - n4.rightSmallArcRadius) + "A" + (n4.rightLargeArcRadius - r4) + " " + (n4.rightSmallArcRadius - r4) + " 0 0 0 " + (n4.rightInnerExtent - e4) + " " + (n4.targetY - r4) + "L" + (n4.targetX - e4) + " " + (n4.targetY - r4) + (e4 > 0 ? "L" + n4.targetX + " " + n4.targetY : "") + "Z" : "M " + (n4.targetX - e4) + " " + (n4.targetY - r4) + " L" + (n4.rightInnerExtent - e4) + " " + (n4.targetY - r4) + "A" + (n4.rightLargeArcRadius + r4) + " " + (n4.rightSmallArcRadius + r4) + " 0 0 0 " + (n4.rightFullExtent - r4 - e4) + " " + (n4.targetY + n4.rightSmallArcRadius) + "L" + (n4.rightFullExtent - r4 - e4) + " " + n4.verticalRightInnerExtent + "A" + (n4.rightLargeArcRadius + r4) + " " + (n4.rightLargeArcRadius + r4) + " 0 0 0 " + (n4.rightInnerExtent - e4) + " " + (n4.verticalFullExtent + r4) + "L" + n4.leftInnerExtent + " " + (n4.verticalFullExtent + r4) + "A" + (n4.leftLargeArcRadius + r4) + " " + (n4.leftLargeArcRadius + r4) + " 0 0 0 " + (n4.leftFullExtent + r4) + " " + n4.verticalLeftInnerExtent + "L" + (n4.leftFullExtent + r4) + " " + (n4.sourceY + n4.leftSmallArcRadius) + "A" + (n4.leftLargeArcRadius + r4) + " " + (n4.leftSmallArcRadius + r4) + " 0 0 0 " + n4.leftInnerExtent + " " + (n4.sourceY - r4) + "L" + n4.sourceX + " " + (n4.sourceY - r4) + "L" + n4.sourceX + " " + (n4.sourceY + r4) + "L" + n4.leftInnerExtent + " " + (n4.sourceY + r4) + "A" + (n4.leftLargeArcRadius - r4) + " " + (n4.leftSmallArcRadius - r4) + " 0 0 1 " + (n4.leftFullExtent - r4) + " " + (n4.sourceY + n4.leftSmallArcRadius) + "L" + (n4.leftFullExtent - r4) + " " + n4.verticalLeftInnerExtent + "A" + (n4.leftLargeArcRadius - r4) + " " + (n4.leftLargeArcRadius - r4) + " 0 0 1 " + n4.leftInnerExtent + " " + (n4.verticalFullExtent - r4) + "L" + (n4.rightInnerExtent - e4) + " " + (n4.verticalFullExtent - r4) + "A" + (n4.rightLargeArcRadius - r4) + " " + (n4.rightLargeArcRadius - r4) + " 0 0 1 " + (n4.rightFullExtent + r4 - e4) + " " + n4.verticalRightInnerExtent + "L" + (n4.rightFullExtent + r4 - e4) + " " + (n4.targetY + n4.rightSmallArcRadius) + "A" + (n4.rightLargeArcRadius - r4) + " " + (n4.rightSmallArcRadius - r4) + " 0 0 1 " + (n4.rightInnerExtent - e4) + " " + (n4.targetY + r4) + "L" + (n4.targetX - e4) + " " + (n4.targetY + r4) + (e4 > 0 ? "L" + n4.targetX + " " + n4.targetY : "") + "Z";
              }(t3.link, e3);
            var r3 = Math.abs((t3.link.target.x0 - t3.link.source.x1) / 2);
            e3 > r3 && (e3 = r3);
            var n3 = t3.link.source.x1, a2 = t3.link.target.x0 - e3, o2 = i(n3, a2), s2 = o2(0.5), l2 = o2(0.5), u2 = t3.link.y0 - t3.link.width / 2, c2 = t3.link.y0 + t3.link.width / 2, f3 = t3.link.y1 - t3.link.width / 2, h2 = t3.link.y1 + t3.link.width / 2, p3 = "M" + n3 + "," + u2, d3 = "C" + s2 + "," + u2 + " " + l2 + "," + f3 + " " + a2 + "," + f3, v2 = "C" + l2 + "," + h2 + " " + s2 + "," + c2 + " " + n3 + "," + c2, g3 = e3 > 0 ? "L" + (a2 + e3) + "," + (f3 + t3.link.width / 2) : "";
            return p3 + d3 + (g3 += "L" + a2 + "," + h2) + v2 + "Z";
          };
        }
        function S(t3, e3) {
          var r3 = u(e3.color), n3 = l.nodePadAcross, i2 = t3.nodePad / 2;
          e3.dx = e3.x1 - e3.x0, e3.dy = e3.y1 - e3.y0;
          var a2 = e3.dx, o2 = Math.max(0.5, e3.dy), s2 = "node_" + e3.pointNumber;
          return e3.group && (s2 = h.randstr()), e3.trace = t3.trace, e3.curveNumber = t3.trace.index, { index: e3.pointNumber, key: s2, partOfGroup: e3.partOfGroup || false, group: e3.group, traceId: t3.key, trace: t3.trace, node: e3, nodePad: t3.nodePad, nodeLineColor: t3.nodeLineColor, nodeLineWidth: t3.nodeLineWidth, textFont: t3.textFont, size: t3.horizontal ? t3.height : t3.width, visibleWidth: Math.ceil(a2), visibleHeight: o2, zoneX: -n3, zoneY: -i2, zoneWidth: a2 + 2 * n3, zoneHeight: o2 + 2 * i2, labelY: t3.horizontal ? e3.dy / 2 + 1 : e3.dx / 2 + 1, left: 1 === e3.originalLayer, sizeAcross: t3.width, forceLayouts: t3.forceLayouts, horizontal: t3.horizontal, darkBackground: r3.getBrightness() <= 128, tinyColorHue: c.tinyRGB(r3), tinyColorAlpha: r3.getAlpha(), valueFormat: t3.valueFormat, valueSuffix: t3.valueSuffix, sankey: t3.sankey, graph: t3.graph, arrangement: t3.arrangement, uniqueNodeLabelPathId: [t3.guid, t3.key, s2].join("_"), interactionState: t3.interactionState, figure: t3 };
        }
        function E(t3) {
          t3.attr("transform", function(t4) {
            return p2(t4.node.x0.toFixed(3), t4.node.y0.toFixed(3));
          });
        }
        function L(t3) {
          t3.call(E);
        }
        function C(t3, e3) {
          t3.call(L), e3.attr("d", M());
        }
        function P(t3) {
          t3.attr("width", function(t4) {
            return t4.node.x1 - t4.node.x0;
          }).attr("height", function(t4) {
            return t4.visibleHeight;
          });
        }
        function O(t3) {
          return t3.link.width > 1 || t3.linkLineWidth > 0;
        }
        function I(t3) {
          return p2(t3.translateX, t3.translateY) + (t3.horizontal ? "matrix(1 0 0 1 0 0)" : "matrix(0 1 1 0 0 0)");
        }
        function D(t3, e3, r3) {
          t3.on(".basic", null).on("mouseover.basic", function(t4) {
            t4.interactionState.dragInProgress || t4.partOfGroup || (r3.hover(this, t4, e3), t4.interactionState.hovered = [this, t4]);
          }).on("mousemove.basic", function(t4) {
            t4.interactionState.dragInProgress || t4.partOfGroup || (r3.follow(this, t4), t4.interactionState.hovered = [this, t4]);
          }).on("mouseout.basic", function(t4) {
            t4.interactionState.dragInProgress || t4.partOfGroup || (r3.unhover(this, t4, e3), t4.interactionState.hovered = false);
          }).on("click.basic", function(t4) {
            t4.interactionState.hovered && (r3.unhover(this, t4, e3), t4.interactionState.hovered = false), t4.interactionState.dragInProgress || t4.partOfGroup || r3.select(this, t4, e3);
          });
        }
        function z(t3, e3, r3, i2) {
          var o2 = a.behavior.drag().origin(function(t4) {
            return { x: t4.node.x0 + t4.visibleWidth / 2, y: t4.node.y0 + t4.visibleHeight / 2 };
          }).on("dragstart", function(a2) {
            if ("fixed" !== a2.arrangement && (h.ensureSingle(i2._fullLayout._infolayer, "g", "dragcover", function(t4) {
              i2._fullLayout._dragCover = t4;
            }), h.raiseToTop(this), a2.interactionState.dragInProgress = a2.node, F(a2.node), a2.interactionState.hovered && (r3.nodeEvents.unhover.apply(0, a2.interactionState.hovered), a2.interactionState.hovered = false), "snap" === a2.arrangement)) {
              var o3 = a2.traceId + "|" + a2.key;
              a2.forceLayouts[o3] ? a2.forceLayouts[o3].alpha(1) : function(t4, e4, r4, i3) {
                !function(t5) {
                  for (var e5 = 0; e5 < t5.length; e5++)
                    t5[e5].y = (t5[e5].y0 + t5[e5].y1) / 2, t5[e5].x = (t5[e5].x0 + t5[e5].x1) / 2;
                }(r4.graph.nodes);
                var a3 = r4.graph.nodes.filter(function(t5) {
                  return t5.originalX === r4.node.originalX;
                }).filter(function(t5) {
                  return !t5.partOfGroup;
                });
                r4.forceLayouts[e4] = n2.forceSimulation(a3).alphaDecay(0).force("collide", n2.forceCollide().radius(function(t5) {
                  return t5.dy / 2 + r4.nodePad / 2;
                }).strength(1).iterations(l.forceIterations)).force("constrain", function(t5, e5, r5, n3) {
                  return function() {
                    for (var t6 = 0, i4 = 0; i4 < r5.length; i4++) {
                      var a4 = r5[i4];
                      a4 === n3.interactionState.dragInProgress ? (a4.x = a4.lastDraggedX, a4.y = a4.lastDraggedY) : (a4.vx = (a4.originalX - a4.x) / l.forceTicksPerFrame, a4.y = Math.min(n3.size - a4.dy / 2, Math.max(a4.dy / 2, a4.y))), t6 = Math.max(t6, Math.abs(a4.vx), Math.abs(a4.vy));
                    }
                    !n3.interactionState.dragInProgress && t6 < 0.1 && n3.forceLayouts[e5].alpha() > 0 && n3.forceLayouts[e5].alpha(0);
                  };
                }(0, e4, a3, r4)).stop();
              }(0, o3, a2), function(t4, e4, r4, n3, i3) {
                window.requestAnimationFrame(function a3() {
                  var o4;
                  for (o4 = 0; o4 < l.forceTicksPerFrame; o4++)
                    r4.forceLayouts[n3].tick();
                  if (function(t5) {
                    for (var e5 = 0; e5 < t5.length; e5++)
                      t5[e5].y0 = t5[e5].y - t5[e5].dy / 2, t5[e5].y1 = t5[e5].y0 + t5[e5].dy, t5[e5].x0 = t5[e5].x - t5[e5].dx / 2, t5[e5].x1 = t5[e5].x0 + t5[e5].dx;
                  }(r4.graph.nodes), r4.sankey.update(r4.graph), C(t4.filter(B(r4)), e4), r4.forceLayouts[n3].alpha() > 0)
                    window.requestAnimationFrame(a3);
                  else {
                    var s2 = r4.node.originalX;
                    r4.node.x0 = s2 - r4.visibleWidth / 2, r4.node.x1 = s2 + r4.visibleWidth / 2, R(r4, i3);
                  }
                });
              }(t3, e3, a2, o3, i2);
            }
          }).on("drag", function(r4) {
            if ("fixed" !== r4.arrangement) {
              var n3 = a.event.x, i3 = a.event.y;
              "snap" === r4.arrangement ? (r4.node.x0 = n3 - r4.visibleWidth / 2, r4.node.x1 = n3 + r4.visibleWidth / 2, r4.node.y0 = i3 - r4.visibleHeight / 2, r4.node.y1 = i3 + r4.visibleHeight / 2) : ("freeform" === r4.arrangement && (r4.node.x0 = n3 - r4.visibleWidth / 2, r4.node.x1 = n3 + r4.visibleWidth / 2), i3 = Math.max(0, Math.min(r4.size - r4.visibleHeight / 2, i3)), r4.node.y0 = i3 - r4.visibleHeight / 2, r4.node.y1 = i3 + r4.visibleHeight / 2), F(r4.node), "snap" !== r4.arrangement && (r4.sankey.update(r4.graph), C(t3.filter(B(r4)), e3));
            }
          }).on("dragend", function(t4) {
            if ("fixed" !== t4.arrangement) {
              t4.interactionState.dragInProgress = false;
              for (var e4 = 0; e4 < t4.node.childrenNodes.length; e4++)
                t4.node.childrenNodes[e4].x = t4.node.x, t4.node.childrenNodes[e4].y = t4.node.y;
              "snap" !== t4.arrangement && R(t4, i2);
            }
          });
          t3.on(".drag", null).call(o2);
        }
        function R(t3, e3) {
          for (var r3 = [], n3 = [], i2 = 0; i2 < t3.graph.nodes.length; i2++) {
            var a2 = (t3.graph.nodes[i2].x0 + t3.graph.nodes[i2].x1) / 2, o2 = (t3.graph.nodes[i2].y0 + t3.graph.nodes[i2].y1) / 2;
            r3.push(a2 / t3.figure.width), n3.push(o2 / t3.figure.height);
          }
          b.call("_guiRestyle", e3, { "node.x": [r3], "node.y": [n3] }, t3.trace.index).then(function() {
            e3._fullLayout._dragCover && e3._fullLayout._dragCover.remove();
          });
        }
        function F(t3) {
          t3.lastDraggedX = t3.x0 + t3.dx / 2, t3.lastDraggedY = t3.y0 + t3.dy / 2;
        }
        function B(t3) {
          return function(e3) {
            return e3.node.originalX === t3.node.originalX;
          };
        }
        t2.exports = function(t3, e3, r3, n3, i2) {
          var o2 = t3._context.staticPlot, s2 = false;
          h.ensureSingle(t3._fullLayout._infolayer, "g", "first-render", function() {
            s2 = true;
          });
          var v2 = t3._fullLayout._dragCover, b2 = r3.filter(function(t4) {
            return m2(t4).trace.visible;
          }).map(k.bind(null, n3)), _2 = e3.selectAll("." + l.cn.sankey).data(b2, g2);
          _2.exit().remove(), _2.enter().append("g").classed(l.cn.sankey, true).style("box-sizing", "content-box").style("position", "absolute").style("left", 0).style("shape-rendering", "geometricPrecision").style("pointer-events", o2 ? "none" : "auto").attr("transform", I), _2.each(function(e4, r4) {
            t3._fullData[r4]._sankey = e4;
            var n4 = "bgsankey-" + e4.trace.uid + "-" + r4;
            h.ensureSingle(t3._fullLayout._draggers, "rect", n4), t3._fullData[r4]._bgRect = a.select("." + n4), t3._fullData[r4]._bgRect.style("pointer-events", o2 ? "none" : "all").attr("width", e4.width).attr("height", e4.height).attr("x", e4.translateX).attr("y", e4.translateY).classed("bgsankey", true).style({ fill: "transparent", "stroke-width": 0 });
          }), _2.transition().ease(l.ease).duration(l.duration).attr("transform", I);
          var L2 = _2.selectAll("." + l.cn.sankeyLinks).data(y, g2);
          L2.enter().append("g").classed(l.cn.sankeyLinks, true).style("fill", "none");
          var C2 = L2.selectAll("." + l.cn.sankeyLink).data(function(t4) {
            return t4.graph.links.filter(function(t5) {
              return t5.value;
            }).map(A.bind(null, t4));
          }, g2);
          C2.enter().append("path").classed(l.cn.sankeyLink, true).call(D, _2, i2.linkEvents), C2.style("stroke", function(t4) {
            return O(t4) ? c.tinyRGB(u(t4.linkLineColor)) : t4.tinyColorHue;
          }).style("stroke-opacity", function(t4) {
            return O(t4) ? c.opacity(t4.linkLineColor) : t4.tinyColorAlpha;
          }).style("fill", function(t4) {
            return t4.tinyColorHue;
          }).style("fill-opacity", function(t4) {
            return t4.tinyColorAlpha;
          }).style("stroke-width", function(t4) {
            return O(t4) ? t4.linkLineWidth : 1;
          }).attr("d", M()), C2.style("opacity", function() {
            return t3._context.staticPlot || s2 || v2 ? 1 : 0;
          }).transition().ease(l.ease).duration(l.duration).style("opacity", 1), C2.exit().transition().ease(l.ease).duration(l.duration).style("opacity", 0).remove();
          var R2 = _2.selectAll("." + l.cn.sankeyNodeSet).data(y, g2);
          R2.enter().append("g").classed(l.cn.sankeyNodeSet, true), R2.style("cursor", function(t4) {
            switch (t4.arrangement) {
              case "fixed":
                return "default";
              case "perpendicular":
                return "ns-resize";
              default:
                return "move";
            }
          });
          var F2 = R2.selectAll("." + l.cn.sankeyNode).data(function(t4) {
            var e4 = t4.graph.nodes;
            return function(t5) {
              var e5, r4 = [];
              for (e5 = 0; e5 < t5.length; e5++)
                t5[e5].originalX = (t5[e5].x0 + t5[e5].x1) / 2, t5[e5].originalY = (t5[e5].y0 + t5[e5].y1) / 2, -1 === r4.indexOf(t5[e5].originalX) && r4.push(t5[e5].originalX);
              for (r4.sort(function(t6, e6) {
                return t6 - e6;
              }), e5 = 0; e5 < t5.length; e5++)
                t5[e5].originalLayerIndex = r4.indexOf(t5[e5].originalX), t5[e5].originalLayer = t5[e5].originalLayerIndex / (r4.length - 1);
            }(e4), e4.map(S.bind(null, t4));
          }, g2);
          F2.enter().append("g").classed(l.cn.sankeyNode, true).call(E).style("opacity", function(e4) {
            return !t3._context.staticPlot && !s2 || e4.partOfGroup ? 0 : 1;
          }), F2.call(D, _2, i2.nodeEvents).call(z, C2, i2, t3), F2.transition().ease(l.ease).duration(l.duration).call(E).style("opacity", function(t4) {
            return t4.partOfGroup ? 0 : 1;
          }), F2.exit().transition().ease(l.ease).duration(l.duration).style("opacity", 0).remove();
          var B2 = F2.selectAll("." + l.cn.nodeRect).data(y);
          B2.enter().append("rect").classed(l.cn.nodeRect, true).call(P), B2.style("stroke-width", function(t4) {
            return t4.nodeLineWidth;
          }).style("stroke", function(t4) {
            return c.tinyRGB(u(t4.nodeLineColor));
          }).style("stroke-opacity", function(t4) {
            return c.opacity(t4.nodeLineColor);
          }).style("fill", function(t4) {
            return t4.tinyColorHue;
          }).style("fill-opacity", function(t4) {
            return t4.tinyColorAlpha;
          }), B2.transition().ease(l.ease).duration(l.duration).call(P);
          var N = F2.selectAll("." + l.cn.nodeLabel).data(y);
          N.enter().append("text").classed(l.cn.nodeLabel, true).style("cursor", "default"), N.attr("data-notex", 1).text(function(t4) {
            return t4.node.label;
          }).each(function(e4) {
            var r4 = a.select(this);
            f2.font(r4, e4.textFont), x.convertToTspans(r4, t3);
          }).style("text-shadow", x.makeTextShadow(t3._fullLayout.paper_bgcolor)).attr("text-anchor", function(t4) {
            return t4.horizontal && t4.left ? "end" : "start";
          }).attr("transform", function(t4) {
            var e4 = a.select(this), r4 = x.lineCount(e4), n4 = t4.textFont.size * ((r4 - 1) * T - w2), i3 = t4.nodeLineWidth / 2 + 3, o3 = ((t4.horizontal ? t4.visibleHeight : t4.visibleWidth) - n4) / 2;
            t4.horizontal && (t4.left ? i3 = -i3 : i3 += t4.visibleWidth);
            var s3 = t4.horizontal ? "" : "scale(-1,1)" + d2(90);
            return p2(t4.horizontal ? i3 : o3, t4.horizontal ? o3 : i3) + s3;
          }), N.transition().ease(l.ease).duration(l.duration);
        };
      }, 84564: function(t2) {
        t2.exports = function(t3, e2) {
          for (var r2 = [], n2 = t3.cd[0].trace, i = n2._sankey.graph.nodes, a = 0; a < i.length; a++) {
            var o = i[a];
            if (!o.partOfGroup) {
              var s = [(o.x0 + o.x1) / 2, (o.y0 + o.y1) / 2];
              "v" === n2.orientation && s.reverse(), e2 && e2.contains(s, false, a, t3) && r2.push({ pointNumber: o.pointNumber });
            }
          }
          return r2;
        };
      }, 75225: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = function(t3, e3) {
          for (var r3 = 0; r3 < t3.length; r3++)
            t3[r3].i = r3;
          n2.mergeArray(e3.text, t3, "tx"), n2.mergeArray(e3.texttemplate, t3, "txt"), n2.mergeArray(e3.hovertext, t3, "htx"), n2.mergeArray(e3.customdata, t3, "data"), n2.mergeArray(e3.textposition, t3, "tp"), e3.textfont && (n2.mergeArrayCastPositive(e3.textfont.size, t3, "ts"), n2.mergeArray(e3.textfont.color, t3, "tc"), n2.mergeArray(e3.textfont.family, t3, "tf"));
          var i = e3.marker;
          if (i) {
            n2.mergeArrayCastPositive(i.size, t3, "ms"), n2.mergeArrayCastPositive(i.opacity, t3, "mo"), n2.mergeArray(i.symbol, t3, "mx"), n2.mergeArray(i.angle, t3, "ma"), n2.mergeArray(i.standoff, t3, "mf"), n2.mergeArray(i.color, t3, "mc");
            var a = i.line;
            i.line && (n2.mergeArray(a.color, t3, "mlc"), n2.mergeArrayCastPositive(a.width, t3, "mlw"));
            var o = i.gradient;
            o && "none" !== o.type && (n2.mergeArray(o.type, t3, "mgt"), n2.mergeArray(o.color, t3, "mgc"));
          }
        };
      }, 82196: function(t2, e2, r2) {
        var n2 = r2(12663).axisHoverFormat, i = r2(5386).s, a = r2(5386).f, o = r2(50693), s = r2(41940), l = r2(79952).P, u = r2(79952).u, c = r2(91424), f2 = r2(47581), h = r2(1426).extendFlat;
        t2.exports = { x: { valType: "data_array", editType: "calc+clearAxisTypes", anim: true }, x0: { valType: "any", dflt: 0, editType: "calc+clearAxisTypes", anim: true }, dx: { valType: "number", dflt: 1, editType: "calc", anim: true }, y: { valType: "data_array", editType: "calc+clearAxisTypes", anim: true }, y0: { valType: "any", dflt: 0, editType: "calc+clearAxisTypes", anim: true }, dy: { valType: "number", dflt: 1, editType: "calc", anim: true }, xperiod: { valType: "any", dflt: 0, editType: "calc" }, yperiod: { valType: "any", dflt: 0, editType: "calc" }, xperiod0: { valType: "any", editType: "calc" }, yperiod0: { valType: "any", editType: "calc" }, xperiodalignment: { valType: "enumerated", values: ["start", "middle", "end"], dflt: "middle", editType: "calc" }, yperiodalignment: { valType: "enumerated", values: ["start", "middle", "end"], dflt: "middle", editType: "calc" }, xhoverformat: n2("x"), yhoverformat: n2("y"), offsetgroup: { valType: "string", dflt: "", editType: "calc" }, alignmentgroup: { valType: "string", dflt: "", editType: "calc" }, stackgroup: { valType: "string", dflt: "", editType: "calc" }, orientation: { valType: "enumerated", values: ["v", "h"], editType: "calc" }, groupnorm: { valType: "enumerated", values: ["", "fraction", "percent"], dflt: "", editType: "calc" }, stackgaps: { valType: "enumerated", values: ["infer zero", "interpolate"], dflt: "infer zero", editType: "calc" }, text: { valType: "string", dflt: "", arrayOk: true, editType: "calc" }, texttemplate: i({}, {}), hovertext: { valType: "string", dflt: "", arrayOk: true, editType: "style" }, mode: { valType: "flaglist", flags: ["lines", "markers", "text"], extras: ["none"], editType: "calc" }, hoveron: { valType: "flaglist", flags: ["points", "fills"], editType: "style" }, hovertemplate: a({}, { keys: f2.eventDataKeys }), line: { color: { valType: "color", editType: "style", anim: true }, width: { valType: "number", min: 0, dflt: 2, editType: "style", anim: true }, shape: { valType: "enumerated", values: ["linear", "spline", "hv", "vh", "hvh", "vhv"], dflt: "linear", editType: "plot" }, smoothing: { valType: "number", min: 0, max: 1.3, dflt: 1, editType: "plot" }, dash: h({}, l, { editType: "style" }), backoff: { valType: "number", min: 0, dflt: "auto", arrayOk: true, editType: "plot" }, simplify: { valType: "boolean", dflt: true, editType: "plot" }, editType: "plot" }, connectgaps: { valType: "boolean", dflt: false, editType: "calc" }, cliponaxis: { valType: "boolean", dflt: true, editType: "plot" }, fill: { valType: "enumerated", values: ["none", "tozeroy", "tozerox", "tonexty", "tonextx", "toself", "tonext"], editType: "calc" }, fillcolor: { valType: "color", editType: "style", anim: true }, fillpattern: u, marker: h({ symbol: { valType: "enumerated", values: c.symbolList, dflt: "circle", arrayOk: true, editType: "style" }, opacity: { valType: "number", min: 0, max: 1, arrayOk: true, editType: "style", anim: true }, angle: { valType: "angle", dflt: 0, arrayOk: true, editType: "plot", anim: false }, angleref: { valType: "enumerated", values: ["previous", "up"], dflt: "up", editType: "plot", anim: false }, standoff: { valType: "number", min: 0, dflt: 0, arrayOk: true, editType: "plot", anim: true }, size: { valType: "number", min: 0, dflt: 6, arrayOk: true, editType: "calc", anim: true }, maxdisplayed: { valType: "number", min: 0, dflt: 0, editType: "plot" }, sizeref: { valType: "number", dflt: 1, editType: "calc" }, sizemin: { valType: "number", min: 0, dflt: 0, editType: "calc" }, sizemode: { valType: "enumerated", values: ["diameter", "area"], dflt: "diameter", editType: "calc" }, line: h({ width: { valType: "number", min: 0, arrayOk: true, editType: "style", anim: true }, editType: "calc" }, o("marker.line", { anim: true })), gradient: { type: { valType: "enumerated", values: ["radial", "horizontal", "vertical", "none"], arrayOk: true, dflt: "none", editType: "calc" }, color: { valType: "color", arrayOk: true, editType: "calc" }, editType: "calc" }, editType: "calc" }, o("marker", { anim: true })), selected: { marker: { opacity: { valType: "number", min: 0, max: 1, editType: "style" }, color: { valType: "color", editType: "style" }, size: { valType: "number", min: 0, editType: "style" }, editType: "style" }, textfont: { color: { valType: "color", editType: "style" }, editType: "style" }, editType: "style" }, unselected: { marker: { opacity: { valType: "number", min: 0, max: 1, editType: "style" }, color: { valType: "color", editType: "style" }, size: { valType: "number", min: 0, editType: "style" }, editType: "style" }, textfont: { color: { valType: "color", editType: "style" }, editType: "style" }, editType: "style" }, textposition: { valType: "enumerated", values: ["top left", "top center", "top right", "middle left", "middle center", "middle right", "bottom left", "bottom center", "bottom right"], dflt: "middle center", arrayOk: true, editType: "calc" }, textfont: s({ editType: "calc", colorEditType: "style", arrayOk: true }) };
      }, 47761: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = r2(89298), o = r2(42973), s = r2(50606).BADNUM, l = r2(34098), u = r2(36922), c = r2(75225), f2 = r2(66279);
        function h(t3, e3, r3, n3, i2, o2, s2) {
          var u2 = e3._length, c2 = t3._fullLayout, f3 = r3._id, h2 = n3._id, p3 = c2._firstScatter[v(e3)] === e3.uid, d3 = (g2(e3, c2, r3, n3) || {}).orientation, y = e3.fill;
          r3._minDtick = 0, n3._minDtick = 0;
          var m2 = { padded: true }, x = { padded: true };
          s2 && (m2.ppad = x.ppad = s2);
          var b = u2 < 2 || i2[0] !== i2[u2 - 1] || o2[0] !== o2[u2 - 1];
          b && ("tozerox" === y || "tonextx" === y && (p3 || "h" === d3)) ? m2.tozero = true : (e3.error_y || {}).visible || "tonexty" !== y && "tozeroy" !== y && (l.hasMarkers(e3) || l.hasText(e3)) || (m2.padded = false, m2.ppad = 0), b && ("tozeroy" === y || "tonexty" === y && (p3 || "v" === d3)) ? x.tozero = true : "tonextx" !== y && "tozerox" !== y || (x.padded = false), f3 && (e3._extremes[f3] = a.findExtremes(r3, i2, m2)), h2 && (e3._extremes[h2] = a.findExtremes(n3, o2, x));
        }
        function p2(t3, e3) {
          if (l.hasMarkers(t3)) {
            var r3, n3 = t3.marker, o2 = 1.6 * (t3.marker.sizeref || 1);
            if (r3 = "area" === t3.marker.sizemode ? function(t4) {
              return Math.max(Math.sqrt((t4 || 0) / o2), 3);
            } : function(t4) {
              return Math.max((t4 || 0) / o2, 3);
            }, i.isArrayOrTypedArray(n3.size)) {
              var s2 = { type: "linear" };
              a.setConvert(s2);
              for (var u2 = s2.makeCalcdata(t3.marker, "size"), c2 = new Array(e3), f3 = 0; f3 < e3; f3++)
                c2[f3] = r3(u2[f3]);
              return c2;
            }
            return r3(n3.size);
          }
        }
        function d2(t3, e3) {
          var r3 = v(e3), n3 = t3._firstScatter;
          n3[r3] || (n3[r3] = e3.uid);
        }
        function v(t3) {
          var e3 = t3.stackgroup;
          return t3.xaxis + t3.yaxis + t3.type + (e3 ? "-" + e3 : "");
        }
        function g2(t3, e3, r3, n3) {
          var i2 = t3.stackgroup;
          if (i2) {
            var a2 = e3._scatterStackOpts[r3._id + n3._id][i2], o2 = "v" === a2.orientation ? n3 : r3;
            return "linear" === o2.type || "log" === o2.type ? a2 : void 0;
          }
        }
        t2.exports = { calc: function(t3, e3) {
          var r3, l2, v2, y, m2, x, b = t3._fullLayout, _ = e3._xA = a.getFromId(t3, e3.xaxis || "x", "x"), w2 = e3._yA = a.getFromId(t3, e3.yaxis || "y", "y"), T = _.makeCalcdata(e3, "x"), k = w2.makeCalcdata(e3, "y"), A = o(e3, _, "x", T), M = o(e3, w2, "y", k), S = A.vals, E = M.vals, L = e3._length, C = new Array(L), P = e3.ids, O = g2(e3, b, _, w2), I = false;
          d2(b, e3);
          var D, z = "x", R = "y";
          O ? (i.pushUnique(O.traceIndices, e3._expandedIndex), (r3 = "v" === O.orientation) ? (R = "s", D = "x") : (z = "s", D = "y"), m2 = "interpolate" === O.stackgaps) : h(t3, e3, _, w2, S, E, p2(e3, L));
          var F = !!e3.xperiodalignment, B = !!e3.yperiodalignment;
          for (l2 = 0; l2 < L; l2++) {
            var N = C[l2] = {}, j = n2(S[l2]), U = n2(E[l2]);
            j && U ? (N[z] = S[l2], N[R] = E[l2], F && (N.orig_x = T[l2], N.xEnd = A.ends[l2], N.xStart = A.starts[l2]), B && (N.orig_y = k[l2], N.yEnd = M.ends[l2], N.yStart = M.starts[l2])) : O && (r3 ? j : U) ? (N[D] = r3 ? S[l2] : E[l2], N.gap = true, m2 ? (N.s = s, I = true) : N.s = 0) : N[z] = N[R] = s, P && (N.id = String(P[l2]));
          }
          if (c(C, e3), u(t3, e3), f2(C, e3), O) {
            for (l2 = 0; l2 < C.length; )
              C[l2][D] === s ? C.splice(l2, 1) : l2++;
            if (i.sort(C, function(t4, e4) {
              return t4[D] - e4[D] || t4.i - e4.i;
            }), I) {
              for (l2 = 0; l2 < C.length - 1 && C[l2].gap; )
                l2++;
              for ((x = C[l2].s) || (x = C[l2].s = 0), v2 = 0; v2 < l2; v2++)
                C[v2].s = x;
              for (y = C.length - 1; y > l2 && C[y].gap; )
                y--;
              for (x = C[y].s, v2 = C.length - 1; v2 > y; v2--)
                C[v2].s = x;
              for (; l2 < y; )
                if (C[++l2].gap) {
                  for (v2 = l2 + 1; C[v2].gap; )
                    v2++;
                  for (var V = C[l2 - 1][D], H = C[l2 - 1].s, q2 = (C[v2].s - H) / (C[v2][D] - V); l2 < v2; )
                    C[l2].s = H + (C[l2][D] - V) * q2, l2++;
                }
            }
          }
          return C;
        }, calcMarkerSize: p2, calcAxisExpansion: h, setFirstScatter: d2, getStackOpts: g2 };
      }, 66279: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = function(t3, e3) {
          n2.isArrayOrTypedArray(e3.selectedpoints) && n2.tagSelected(t3, e3);
        };
      }, 36922: function(t2, e2, r2) {
        var n2 = r2(52075).hasColorscale, i = r2(78803), a = r2(34098);
        t2.exports = function(t3, e3) {
          a.hasLines(e3) && n2(e3, "line") && i(t3, e3, { vals: e3.line.color, containerStr: "line", cLetter: "c" }), a.hasMarkers(e3) && (n2(e3, "marker") && i(t3, e3, { vals: e3.marker.color, containerStr: "marker", cLetter: "c" }), n2(e3, "marker.line") && i(t3, e3, { vals: e3.marker.line.color, containerStr: "marker.line", cLetter: "c" }));
        };
      }, 47581: function(t2) {
        t2.exports = { PTS_LINESONLY: 20, minTolerance: 0.2, toleranceGrowth: 10, maxScreensAway: 20, eventDataKeys: [] };
      }, 72626: function(t2, e2, r2) {
        var n2 = r2(47761), i = r2(11661).setGroupPositions;
        function a(t3, e3, r3, n3, i2, a2, o) {
          i2[n3] = true;
          var s = { i: null, gap: true, s: 0 };
          if (s[o] = r3, t3.splice(e3, 0, s), e3 && r3 === t3[e3 - 1][o]) {
            var l = t3[e3 - 1];
            s.s = l.s, s.i = l.i, s.gap = l.gap;
          } else
            a2 && (s.s = function(t4, e4, r4, n4) {
              var i3 = t4[e4 - 1], a3 = t4[e4 + 1];
              return a3 ? i3 ? i3.s + (a3.s - i3.s) * (r4 - i3[n4]) / (a3[n4] - i3[n4]) : a3.s : i3.s;
            }(t3, e3, r3, o));
          e3 || (t3[0].t = t3[1].t, t3[0].trace = t3[1].trace, delete t3[1].t, delete t3[1].trace);
        }
        t2.exports = function(t3, e3) {
          "group" === t3._fullLayout.scattermode && function(t4, e4) {
            for (var r4 = e4.xaxis, n3 = e4.yaxis, a2 = t4._fullLayout, o2 = t4._fullData, s2 = t4.calcdata, l2 = [], u2 = [], c2 = 0; c2 < o2.length; c2++) {
              var f3 = o2[c2];
              true === f3.visible && "scatter" === f3.type && f3.xaxis === r4._id && f3.yaxis === n3._id && ("h" === f3.orientation ? l2.push(s2[c2]) : "v" === f3.orientation && u2.push(s2[c2]));
            }
            var h2 = { mode: a2.scattermode, gap: a2.scattergap };
            i(t4, r4, n3, u2, h2), i(t4, n3, r4, l2, h2);
          }(t3, e3);
          var r3 = e3.xaxis, o = e3.yaxis, s = r3._id + o._id, l = t3._fullLayout._scatterStackOpts[s];
          if (l) {
            var u, c, f2, h, p2, d2, v, g2, y, m2, x, b, _, w2, T, k = t3.calcdata;
            for (var A in l) {
              var M = (m2 = l[A]).traceIndices;
              if (M.length) {
                for (x = "interpolate" === m2.stackgaps, b = m2.groupnorm, "v" === m2.orientation ? (_ = "x", w2 = "y") : (_ = "y", w2 = "x"), T = new Array(M.length), u = 0; u < T.length; u++)
                  T[u] = false;
                d2 = k[M[0]];
                var S = new Array(d2.length);
                for (u = 0; u < d2.length; u++)
                  S[u] = d2[u][_];
                for (u = 1; u < M.length; u++) {
                  for (p2 = k[M[u]], c = f2 = 0; c < p2.length; c++) {
                    for (v = p2[c][_]; v > S[f2] && f2 < S.length; f2++)
                      a(p2, c, S[f2], u, T, x, _), c++;
                    if (v !== S[f2]) {
                      for (h = 0; h < u; h++)
                        a(k[M[h]], f2, v, h, T, x, _);
                      S.splice(f2, 0, v);
                    }
                    f2++;
                  }
                  for (; f2 < S.length; f2++)
                    a(p2, c, S[f2], u, T, x, _), c++;
                }
                var E = S.length;
                for (c = 0; c < d2.length; c++) {
                  for (g2 = d2[c][w2] = d2[c].s, u = 1; u < M.length; u++)
                    (p2 = k[M[u]])[0].trace._rawLength = p2[0].trace._length, p2[0].trace._length = E, g2 += p2[c].s, p2[c][w2] = g2;
                  if (b)
                    for (y = ("fraction" === b ? g2 : g2 / 100) || 1, u = 0; u < M.length; u++) {
                      var L = k[M[u]][c];
                      L[w2] /= y, L.sNorm = L.s / y;
                    }
                }
                for (u = 0; u < M.length; u++) {
                  var C = (p2 = k[M[u]])[0].trace, P = n2.calcMarkerSize(C, C._rawLength), O = Array.isArray(P);
                  if (P && T[u] || O) {
                    var I = P;
                    for (P = new Array(E), c = 0; c < E; c++)
                      P[c] = p2[c].gap ? 0 : O ? I[p2[c].i] : I;
                  }
                  var D = new Array(E), z = new Array(E);
                  for (c = 0; c < E; c++)
                    D[c] = p2[c].x, z[c] = p2[c].y;
                  n2.calcAxisExpansion(t3, C, r3, o, D, z, P), p2[0].t.orientation = m2.orientation;
                }
              }
            }
          }
        };
      }, 34936: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(26125), a = r2(82196);
        t2.exports = function(t3, e3) {
          var r3, o, s;
          function l(t4) {
            return n2.coerce(o._input, o, a, t4);
          }
          if ("group" === e3.scattermode)
            for (s = 0; s < t3.length; s++)
              "scatter" === (o = t3[s]).type && (r3 = o._input, i(r3, o, e3, l));
          for (s = 0; s < t3.length; s++) {
            var u = t3[s];
            if ("scatter" === u.type) {
              var c = u.fill;
              if ("none" !== c && "toself" !== c && (u.opacity = void 0, "tonexty" === c || "tonextx" === c))
                for (var f2 = s - 1; f2 >= 0; f2--) {
                  var h = t3[f2];
                  if ("scatter" === h.type && h.xaxis === u.xaxis && h.yaxis === u.yaxis) {
                    h.opacity = void 0;
                    break;
                  }
                }
            }
          }
        };
      }, 17438: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(73972), a = r2(82196), o = r2(47581), s = r2(34098), l = r2(67513), u = r2(73927), c = r2(565), f2 = r2(49508), h = r2(11058), p2 = r2(94039), d2 = r2(82410), v = r2(28908), g2 = r2(71828).coercePattern;
        t2.exports = function(t3, e3, r3, y) {
          function m2(r4, i2) {
            return n2.coerce(t3, e3, a, r4, i2);
          }
          var x = l(t3, e3, y, m2);
          if (x || (e3.visible = false), e3.visible) {
            u(t3, e3, y, m2), m2("xhoverformat"), m2("yhoverformat");
            var b = c(t3, e3, y, m2);
            "group" === y.scattermode && void 0 === e3.orientation && m2("orientation", "v");
            var _ = !b && x < o.PTS_LINESONLY ? "lines+markers" : "lines";
            m2("text"), m2("hovertext"), m2("mode", _), s.hasLines(e3) && (h(t3, e3, r3, y, m2, { backoff: true }), p2(t3, e3, m2), m2("connectgaps"), m2("line.simplify")), s.hasMarkers(e3) && f2(t3, e3, r3, y, m2, { gradient: true }), s.hasText(e3) && (m2("texttemplate"), d2(t3, e3, y, m2));
            var w2 = [];
            (s.hasMarkers(e3) || s.hasText(e3)) && (m2("cliponaxis"), m2("marker.maxdisplayed"), w2.push("points")), m2("fill", b ? b.fillDflt : "none"), "none" !== e3.fill && (v(t3, e3, r3, m2), s.hasLines(e3) || p2(t3, e3, m2), g2(m2, "fillpattern", e3.fillcolor, false));
            var T = (e3.line || {}).color, k = (e3.marker || {}).color;
            "tonext" !== e3.fill && "toself" !== e3.fill || w2.push("fills"), m2("hoveron", w2.join("+") || "points"), "fills" !== e3.hoveron && m2("hovertemplate");
            var A = i.getComponentMethod("errorbars", "supplyDefaults");
            A(t3, e3, T || k || r3, { axis: "y" }), A(t3, e3, T || k || r3, { axis: "x", inherit: "y" }), n2.coerceSelectionMarkerOpacity(e3, m2);
          }
        };
      }, 28908: function(t2, e2, r2) {
        var n2 = r2(7901), i = r2(71828).isArrayOrTypedArray;
        t2.exports = function(t3, e3, r3, a) {
          var o = false;
          if (e3.marker) {
            var s = e3.marker.color, l = (e3.marker.line || {}).color;
            s && !i(s) ? o = s : l && !i(l) && (o = l);
          }
          a("fillcolor", n2.addOpacity((e3.line || {}).color || o || r3, 0.5));
        };
      }, 8225: function(t2, e2, r2) {
        var n2 = r2(89298);
        t2.exports = function(t3, e3, r3) {
          var i = {}, a = { _fullLayout: r3 }, o = n2.getFromTrace(a, e3, "x"), s = n2.getFromTrace(a, e3, "y"), l = t3.orig_x;
          void 0 === l && (l = t3.x);
          var u = t3.orig_y;
          return void 0 === u && (u = t3.y), i.xLabel = n2.tickText(o, o.c2l(l), true).text, i.yLabel = n2.tickText(s, s.c2l(u), true).text, i;
        };
      }, 34603: function(t2, e2, r2) {
        var n2 = r2(7901), i = r2(34098);
        t2.exports = function(t3, e3) {
          var r3, a;
          if ("lines" === t3.mode)
            return (r3 = t3.line.color) && n2.opacity(r3) ? r3 : t3.fillcolor;
          if ("none" === t3.mode)
            return t3.fill ? t3.fillcolor : "";
          var o = e3.mcc || (t3.marker || {}).color, s = e3.mlcc || ((t3.marker || {}).line || {}).color;
          return (a = o && n2.opacity(o) ? o : s && n2.opacity(s) && (e3.mlw || ((t3.marker || {}).line || {}).width) ? s : "") ? n2.opacity(a) < 0.3 ? n2.addOpacity(a, 0.3) : a : (r3 = (t3.line || {}).color) && n2.opacity(r3) && i.hasLines(t3) && t3.line.width ? r3 : t3.fillcolor;
        };
      }, 26125: function(t2, e2, r2) {
        var n2 = r2(99082).getAxisGroup;
        t2.exports = function(t3, e3, r3, i) {
          var a = e3.orientation, o = e3[{ v: "x", h: "y" }[a] + "axis"], s = n2(r3, o) + a, l = r3._alignmentOpts || {}, u = i("alignmentgroup"), c = l[s];
          c || (c = l[s] = {});
          var f2 = c[u];
          f2 ? f2.traces.push(e3) : f2 = c[u] = { traces: [e3], alignmentIndex: Object.keys(c).length, offsetGroups: {} };
          var h = i("offsetgroup"), p2 = f2.offsetGroups, d2 = p2[h];
          h && (d2 || (d2 = p2[h] = { offsetIndex: Object.keys(p2).length }), e3._offsetIndex = d2.offsetIndex);
        };
      }, 33720: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(30211), a = r2(73972), o = r2(34603), s = r2(7901), l = n2.fillText;
        t2.exports = function(t3, e3, r3, u) {
          var c = t3.cd, f2 = c[0].trace, h = t3.xa, p2 = t3.ya, d2 = h.c2p(e3), v = p2.c2p(r3), g2 = [d2, v], y = f2.hoveron || "", m2 = -1 !== f2.mode.indexOf("markers") ? 3 : 0.5, x = !!f2.xperiodalignment, b = !!f2.yperiodalignment;
          if (-1 !== y.indexOf("points")) {
            var _ = function(t4) {
              var e4 = Math.max(m2, t4.mrc || 0), r4 = h.c2p(t4.x) - d2, n3 = p2.c2p(t4.y) - v;
              return Math.max(Math.sqrt(r4 * r4 + n3 * n3) - e4, 1 - m2 / e4);
            }, w2 = i.getDistanceFunction(u, function(t4) {
              if (x) {
                var e4 = h.c2p(t4.xStart), r4 = h.c2p(t4.xEnd);
                return d2 >= Math.min(e4, r4) && d2 <= Math.max(e4, r4) ? 0 : 1 / 0;
              }
              var n3 = Math.max(3, t4.mrc || 0), i2 = 1 - 1 / n3, a2 = Math.abs(h.c2p(t4.x) - d2);
              return a2 < n3 ? i2 * a2 / n3 : a2 - n3 + i2;
            }, function(t4) {
              if (b) {
                var e4 = p2.c2p(t4.yStart), r4 = p2.c2p(t4.yEnd);
                return v >= Math.min(e4, r4) && v <= Math.max(e4, r4) ? 0 : 1 / 0;
              }
              var n3 = Math.max(3, t4.mrc || 0), i2 = 1 - 1 / n3, a2 = Math.abs(p2.c2p(t4.y) - v);
              return a2 < n3 ? i2 * a2 / n3 : a2 - n3 + i2;
            }, _);
            if (i.getClosest(c, w2, t3), false !== t3.index) {
              var T = c[t3.index], k = h.c2p(T.x, true), A = p2.c2p(T.y, true), M = T.mrc || 1;
              t3.index = T.i;
              var S = c[0].t.orientation, E = S && (T.sNorm || T.s), L = "h" === S ? E : void 0 !== T.orig_x ? T.orig_x : T.x, C = "v" === S ? E : void 0 !== T.orig_y ? T.orig_y : T.y;
              return n2.extendFlat(t3, { color: o(f2, T), x0: k - M, x1: k + M, xLabelVal: L, y0: A - M, y1: A + M, yLabelVal: C, spikeDistance: _(T), hovertemplate: f2.hovertemplate }), l(T, f2, t3), a.getComponentMethod("errorbars", "hoverInfo")(T, f2, t3), [t3];
            }
          }
          if (-1 !== y.indexOf("fills") && f2._polygons) {
            var P, O, I, D, z, R, F, B, N, j = f2._polygons, U = [], V = false, H = 1 / 0, q2 = -1 / 0, G = 1 / 0, Z = -1 / 0;
            for (P = 0; P < j.length; P++)
              (I = j[P]).contains(g2) && (V = !V, U.push(I), G = Math.min(G, I.ymin), Z = Math.max(Z, I.ymax));
            if (V) {
              var Y = ((G = Math.max(G, 0)) + (Z = Math.min(Z, p2._length))) / 2;
              for (P = 0; P < U.length; P++)
                for (D = U[P].pts, O = 1; O < D.length; O++)
                  (B = D[O - 1][1]) > Y != (N = D[O][1]) >= Y && (R = D[O - 1][0], F = D[O][0], N - B && (z = R + (F - R) * (Y - B) / (N - B), H = Math.min(H, z), q2 = Math.max(q2, z)));
              H = Math.max(H, 0), q2 = Math.min(q2, h._length);
              var W = s.defaultLine;
              return s.opacity(f2.fillcolor) ? W = f2.fillcolor : s.opacity((f2.line || {}).color) && (W = f2.line.color), n2.extendFlat(t3, { distance: t3.maxHoverDistance, x0: H, x1: q2, y0: Y, y1: Y, color: W, hovertemplate: false }), delete t3.index, f2.text && !Array.isArray(f2.text) ? t3.text = String(f2.text) : t3.text = f2.name, [t3];
            }
          }
        };
      }, 67368: function(t2, e2, r2) {
        var n2 = r2(34098);
        t2.exports = { hasLines: n2.hasLines, hasMarkers: n2.hasMarkers, hasText: n2.hasText, isBubble: n2.isBubble, attributes: r2(82196), layoutAttributes: r2(21479), supplyDefaults: r2(17438), crossTraceDefaults: r2(34936), supplyLayoutDefaults: r2(79334), calc: r2(47761).calc, crossTraceCalc: r2(72626), arraysToCalcdata: r2(75225), plot: r2(32663), colorbar: r2(4898), formatLabels: r2(8225), style: r2(16296).style, styleOnSelect: r2(16296).styleOnSelect, hoverPoints: r2(33720), selectPoints: r2(98002), animatable: true, moduleType: "trace", name: "scatter", basePlotModule: r2(93612), categories: ["cartesian", "svg", "symbols", "errorBarsOK", "showLegend", "scatter-like", "zoomScale"], meta: {} };
      }, 21479: function(t2) {
        t2.exports = { scattermode: { valType: "enumerated", values: ["group", "overlay"], dflt: "overlay", editType: "calc" }, scattergap: { valType: "number", min: 0, max: 1, editType: "calc" } };
      }, 79334: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(21479);
        t2.exports = function(t3, e3) {
          var r3, a = "group" === e3.barmode;
          "group" === e3.scattermode && (r3 = a ? e3.bargap : 0.2, n2.coerce(t3, e3, i, "scattergap", r3));
        };
      }, 11058: function(t2, e2, r2) {
        var n2 = r2(71828).isArrayOrTypedArray, i = r2(52075).hasColorscale, a = r2(1586);
        t2.exports = function(t3, e3, r3, o, s, l) {
          l || (l = {});
          var u = (t3.marker || {}).color;
          s("line.color", r3), i(t3, "line") ? a(t3, e3, o, s, { prefix: "line.", cLetter: "c" }) : s("line.color", !n2(u) && u || r3), s("line.width"), l.noDash || s("line.dash"), l.backoff && s("line.backoff");
        };
      }, 34621: function(t2, e2, r2) {
        var n2 = r2(91424), i = r2(50606), a = i.BADNUM, o = i.LOG_CLIP, s = o + 0.5, l = o - 0.5, u = r2(71828), c = u.segmentsIntersect, f2 = u.constrain, h = r2(47581);
        t2.exports = function(t3, e3) {
          var r3, i2, o2, p2, d2, v, g2, y, m2, x, b, _, w2, T, k, A, M, S, E = e3.trace || {}, L = e3.xaxis, C = e3.yaxis, P = "log" === L.type, O = "log" === C.type, I = L._length, D = C._length, z = e3.backoff, R = E.marker, F = e3.connectGaps, B = e3.baseTolerance, N = e3.shape, j = "linear" === N, U = E.fill && "none" !== E.fill, V = [], H = h.minTolerance, q2 = t3.length, G = new Array(q2), Z = 0;
          function Y(r4) {
            var n3 = t3[r4];
            if (!n3)
              return false;
            var i3 = e3.linearized ? L.l2p(n3.x) : L.c2p(n3.x), o3 = e3.linearized ? C.l2p(n3.y) : C.c2p(n3.y);
            if (i3 === a) {
              if (P && (i3 = L.c2p(n3.x, true)), i3 === a)
                return false;
              O && o3 === a && (i3 *= Math.abs(L._m * D * (L._m > 0 ? s : l) / (C._m * I * (C._m > 0 ? s : l)))), i3 *= 1e3;
            }
            if (o3 === a) {
              if (O && (o3 = C.c2p(n3.y, true)), o3 === a)
                return false;
              o3 *= 1e3;
            }
            return [i3, o3];
          }
          function W(t4, e4, r4, n3) {
            var i3 = r4 - t4, a2 = n3 - e4, o3 = 0.5 - t4, s2 = 0.5 - e4, l2 = i3 * i3 + a2 * a2, u2 = i3 * o3 + a2 * s2;
            if (u2 > 0 && u2 < l2) {
              var c2 = o3 * a2 - s2 * i3;
              if (c2 * c2 < l2)
                return true;
            }
          }
          function X(t4, e4) {
            var r4 = t4[0] / I, n3 = t4[1] / D, i3 = Math.max(0, -r4, r4 - 1, -n3, n3 - 1);
            return i3 && void 0 !== M && W(r4, n3, M, S) && (i3 = 0), i3 && e4 && W(r4, n3, e4[0] / I, e4[1] / D) && (i3 = 0), (1 + h.toleranceGrowth * i3) * B;
          }
          function J(t4, e4) {
            var r4 = t4[0] - e4[0], n3 = t4[1] - e4[1];
            return Math.sqrt(r4 * r4 + n3 * n3);
          }
          var K, $, Q, tt, et, rt, nt, it = h.maxScreensAway, at = -I * it, ot = I * (1 + it), st = -D * it, lt = D * (1 + it), ut = [[at, st, ot, st], [ot, st, ot, lt], [ot, lt, at, lt], [at, lt, at, st]];
          function ct(t4) {
            if (t4[0] < at || t4[0] > ot || t4[1] < st || t4[1] > lt)
              return [f2(t4[0], at, ot), f2(t4[1], st, lt)];
          }
          function ft(t4, e4) {
            return t4[0] === e4[0] && (t4[0] === at || t4[0] === ot) || t4[1] === e4[1] && (t4[1] === st || t4[1] === lt) || void 0;
          }
          function ht(t4, e4, r4) {
            return function(n3, i3) {
              var a2 = ct(n3), o3 = ct(i3), s2 = [];
              if (a2 && o3 && ft(a2, o3))
                return s2;
              a2 && s2.push(a2), o3 && s2.push(o3);
              var l2 = 2 * u.constrain((n3[t4] + i3[t4]) / 2, e4, r4) - ((a2 || n3)[t4] + (o3 || i3)[t4]);
              return l2 && ((a2 && o3 ? l2 > 0 == a2[t4] > o3[t4] ? a2 : o3 : a2 || o3)[t4] += l2), s2;
            };
          }
          function pt(t4) {
            var e4 = t4[0], r4 = t4[1], n3 = e4 === G[Z - 1][0], i3 = r4 === G[Z - 1][1];
            if (!n3 || !i3)
              if (Z > 1) {
                var a2 = e4 === G[Z - 2][0], o3 = r4 === G[Z - 2][1];
                n3 && (e4 === at || e4 === ot) && a2 ? o3 ? Z-- : G[Z - 1] = t4 : i3 && (r4 === st || r4 === lt) && o3 ? a2 ? Z-- : G[Z - 1] = t4 : G[Z++] = t4;
              } else
                G[Z++] = t4;
          }
          function dt(t4) {
            G[Z - 1][0] !== t4[0] && G[Z - 1][1] !== t4[1] && pt([Q, tt]), pt(t4), et = null, Q = tt = 0;
          }
          "linear" === N || "spline" === N ? nt = function(t4, e4) {
            for (var r4 = [], n3 = 0, i3 = 0; i3 < 4; i3++) {
              var a2 = ut[i3], o3 = c(t4[0], t4[1], e4[0], e4[1], a2[0], a2[1], a2[2], a2[3]);
              o3 && (!n3 || Math.abs(o3.x - r4[0][0]) > 1 || Math.abs(o3.y - r4[0][1]) > 1) && (o3 = [o3.x, o3.y], n3 && J(o3, t4) < J(r4[0], t4) ? r4.unshift(o3) : r4.push(o3), n3++);
            }
            return r4;
          } : "hv" === N || "vh" === N ? nt = function(t4, e4) {
            var r4 = [], n3 = ct(t4), i3 = ct(e4);
            return n3 && i3 && ft(n3, i3) || (n3 && r4.push(n3), i3 && r4.push(i3)), r4;
          } : "hvh" === N ? nt = ht(0, at, ot) : "vhv" === N && (nt = ht(1, st, lt));
          var vt = u.isArrayOrTypedArray(R);
          function gt(e4) {
            if (e4 && z && (e4.i = r3, e4.d = t3, e4.trace = E, e4.marker = vt ? R[e4.i] : R, e4.backoff = z), M = e4[0] / I, S = e4[1] / D, K = e4[0] < at ? at : e4[0] > ot ? ot : 0, $ = e4[1] < st ? st : e4[1] > lt ? lt : 0, K || $) {
              if (Z)
                if (et) {
                  var n3 = nt(et, e4);
                  n3.length > 1 && (dt(n3[0]), G[Z++] = n3[1]);
                } else
                  rt = nt(G[Z - 1], e4)[0], G[Z++] = rt;
              else
                G[Z++] = [K || e4[0], $ || e4[1]];
              var i3 = G[Z - 1];
              K && $ && (i3[0] !== K || i3[1] !== $) ? (et && (Q !== K && tt !== $ ? pt(Q && tt ? (a2 = et, s2 = (o3 = e4)[0] - a2[0], l2 = (o3[1] - a2[1]) / s2, (a2[1] * o3[0] - o3[1] * a2[0]) / s2 > 0 ? [l2 > 0 ? at : ot, lt] : [l2 > 0 ? ot : at, st]) : [Q || K, tt || $]) : Q && tt && pt([Q, tt])), pt([K, $])) : Q - K && tt - $ && pt([K || Q, $ || tt]), et = e4, Q = K, tt = $;
            } else
              et && dt(nt(et, e4)[0]), G[Z++] = e4;
            var a2, o3, s2, l2;
          }
          for (r3 = 0; r3 < q2; r3++)
            if (i2 = Y(r3)) {
              for (Z = 0, et = null, gt(i2), r3++; r3 < q2; r3++) {
                if (!(p2 = Y(r3))) {
                  if (F)
                    continue;
                  break;
                }
                if (j && e3.simplify) {
                  var yt = Y(r3 + 1);
                  if (x = J(p2, i2), U && (0 === Z || Z === q2 - 1) || !(x < X(p2, yt) * H)) {
                    for (y = [(p2[0] - i2[0]) / x, (p2[1] - i2[1]) / x], d2 = i2, b = x, _ = T = k = 0, g2 = false, o2 = p2, r3++; r3 < t3.length; r3++) {
                      if (v = yt, yt = Y(r3 + 1), !v) {
                        if (F)
                          continue;
                        break;
                      }
                      if (A = (m2 = [v[0] - i2[0], v[1] - i2[1]])[0] * y[1] - m2[1] * y[0], T = Math.min(T, A), (k = Math.max(k, A)) - T > X(v, yt))
                        break;
                      o2 = v, (w2 = m2[0] * y[0] + m2[1] * y[1]) > b ? (b = w2, p2 = v, g2 = false) : w2 < _ && (_ = w2, d2 = v, g2 = true);
                    }
                    if (g2 ? (gt(p2), o2 !== d2 && gt(d2)) : (d2 !== i2 && gt(d2), o2 !== p2 && gt(p2)), gt(o2), r3 >= t3.length || !v)
                      break;
                    gt(v), i2 = v;
                  }
                } else
                  gt(p2);
              }
              et && pt([Q || et[0], tt || et[1]]), V.push(G.slice(0, Z));
            }
          var mt = N.slice(N.length - 1);
          if (z && "h" !== mt && "v" !== mt) {
            for (var xt = false, bt = -1, _t = [], wt = 0; wt < V.length; wt++)
              for (var Tt = 0; Tt < V[wt].length - 1; Tt++) {
                var kt = V[wt][Tt], At = V[wt][Tt + 1], Mt = n2.applyBackoff(At, kt);
                Mt[0] === At[0] && Mt[1] === At[1] || (xt = true), _t[bt + 1] || (_t[++bt] = [kt, [Mt[0], Mt[1]]]);
              }
            return xt ? _t : V;
          }
          return V;
        };
      }, 94039: function(t2) {
        t2.exports = function(t3, e2, r2) {
          "spline" === r2("line.shape") && r2("line.smoothing");
        };
      }, 68687: function(t2) {
        var e2 = { tonextx: 1, tonexty: 1, tonext: 1 };
        t2.exports = function(t3, r2, n2) {
          var i, a, o, s, l, u = {}, c = false, f2 = -1, h = 0, p2 = -1;
          for (a = 0; a < n2.length; a++)
            (o = (i = n2[a][0].trace).stackgroup || "") ? o in u ? l = u[o] : (l = u[o] = h, h++) : i.fill in e2 && p2 >= 0 ? l = p2 : (l = p2 = h, h++), l < f2 && (c = true), i._groupIndex = f2 = l;
          var d2 = n2.slice();
          c && d2.sort(function(t4, e3) {
            var r3 = t4[0].trace, n3 = e3[0].trace;
            return r3._groupIndex - n3._groupIndex || r3.index - n3.index;
          });
          var v = {};
          for (a = 0; a < d2.length; a++)
            o = (i = d2[a][0].trace).stackgroup || "", true === i.visible ? (i._nexttrace = null, i.fill in e2 && (s = v[o], i._prevtrace = s || null, s && (s._nexttrace = i)), i._ownfill = i.fill && ("tozero" === i.fill.substr(0, 6) || "toself" === i.fill || "to" === i.fill.substr(0, 2) && !i._prevtrace), v[o] = i) : i._prevtrace = i._nexttrace = i._ownfill = null;
          return d2;
        };
      }, 39984: function(t2, e2, r2) {
        var n2 = r2(92770);
        t2.exports = function(t3, e3) {
          e3 || (e3 = 2);
          var r3 = t3.marker, i = r3.sizeref || 1, a = r3.sizemin || 0, o = "area" === r3.sizemode ? function(t4) {
            return Math.sqrt(t4 / i);
          } : function(t4) {
            return t4 / i;
          };
          return function(t4) {
            var r4 = o(t4 / e3);
            return n2(r4) && r4 > 0 ? Math.max(r4, a) : 0;
          };
        };
      }, 4898: function(t2) {
        t2.exports = { container: "marker", min: "cmin", max: "cmax" };
      }, 49508: function(t2, e2, r2) {
        var n2 = r2(7901), i = r2(52075).hasColorscale, a = r2(1586), o = r2(34098);
        t2.exports = function(t3, e3, r3, s, l, u) {
          var c = o.isBubble(t3), f2 = (t3.line || {}).color;
          u = u || {}, f2 && (r3 = f2), l("marker.symbol"), l("marker.opacity", c ? 0.7 : 1), l("marker.size"), u.noAngle || (l("marker.angle"), u.noAngleRef || l("marker.angleref"), u.noStandOff || l("marker.standoff")), l("marker.color", r3), i(t3, "marker") && a(t3, e3, s, l, { prefix: "marker.", cLetter: "c" }), u.noSelect || (l("selected.marker.color"), l("unselected.marker.color"), l("selected.marker.size"), l("unselected.marker.size")), u.noLine || (l("marker.line.color", f2 && !Array.isArray(f2) && e3.marker.color !== f2 ? f2 : c ? n2.background : n2.defaultLine), i(t3, "marker.line") && a(t3, e3, s, l, { prefix: "marker.line.", cLetter: "c" }), l("marker.line.width", c ? 1 : 0)), c && (l("marker.sizeref"), l("marker.sizemin"), l("marker.sizemode")), u.gradient && "none" !== l("marker.gradient.type") && l("marker.gradient.color");
        };
      }, 73927: function(t2, e2, r2) {
        var n2 = r2(71828).dateTick0, i = r2(50606).ONEWEEK;
        function a(t3, e3) {
          return n2(e3, t3 % i == 0 ? 1 : 0);
        }
        t2.exports = function(t3, e3, r3, n3, i2) {
          if (i2 || (i2 = { x: true, y: true }), i2.x) {
            var o = n3("xperiod");
            o && (n3("xperiod0", a(o, e3.xcalendar)), n3("xperiodalignment"));
          }
          if (i2.y) {
            var s = n3("yperiod");
            s && (n3("yperiod0", a(s, e3.ycalendar)), n3("yperiodalignment"));
          }
        };
      }, 32663: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(73972), a = r2(71828), o = a.ensureSingle, s = a.identity, l = r2(91424), u = r2(34098), c = r2(34621), f2 = r2(68687), h = r2(61082).tester;
        function p2(t3, e3, r3, f3, p3, d2, v) {
          var g2, y = t3._context.staticPlot;
          !function(t4, e4, r4, i2, o2) {
            var s2 = r4.xaxis, l2 = r4.yaxis, c2 = n2.extent(a.simpleMap(s2.range, s2.r2c)), f4 = n2.extent(a.simpleMap(l2.range, l2.r2c)), h2 = i2[0].trace;
            if (u.hasMarkers(h2)) {
              var p4 = h2.marker.maxdisplayed;
              if (0 !== p4) {
                var d3 = i2.filter(function(t5) {
                  return t5.x >= c2[0] && t5.x <= c2[1] && t5.y >= f4[0] && t5.y <= f4[1];
                }), v2 = Math.ceil(d3.length / p4), g3 = 0;
                o2.forEach(function(t5, r5) {
                  var n3 = t5[0].trace;
                  u.hasMarkers(n3) && n3.marker.maxdisplayed > 0 && r5 < e4 && g3++;
                });
                var y2 = Math.round(g3 * v2 / 3 + Math.floor(g3 / 3) * v2 / 7.1);
                i2.forEach(function(t5) {
                  delete t5.vis;
                }), d3.forEach(function(t5, e5) {
                  0 === Math.round((e5 + y2) % v2) && (t5.vis = true);
                });
              }
            }
          }(0, e3, r3, f3, p3);
          var m2 = !!v && v.duration > 0;
          function x(t4) {
            return m2 ? t4.transition() : t4;
          }
          var b = r3.xaxis, _ = r3.yaxis, w2 = f3[0].trace, T = w2.line, k = n2.select(d2), A = o(k, "g", "errorbars"), M = o(k, "g", "lines"), S = o(k, "g", "points"), E = o(k, "g", "text");
          if (i.getComponentMethod("errorbars", "plot")(t3, A, r3, v), true === w2.visible) {
            var L, C;
            x(k).style("opacity", w2.opacity);
            var P = w2.fill.charAt(w2.fill.length - 1);
            "x" !== P && "y" !== P && (P = ""), f3[0][r3.isRangePlot ? "nodeRangePlot3" : "node3"] = k;
            var O, I, D = "", z = [], R = w2._prevtrace;
            R && (D = R._prevRevpath || "", C = R._nextFill, z = R._polygons);
            var F, B, N, j, U, V, H, q2 = "", G = "", Z = [], Y = a.noop;
            if (L = w2._ownFill, u.hasLines(w2) || "none" !== w2.fill) {
              for (C && C.datum(f3), -1 !== ["hv", "vh", "hvh", "vhv"].indexOf(T.shape) ? (F = l.steps(T.shape), B = l.steps(T.shape.split("").reverse().join(""))) : F = B = "spline" === T.shape ? function(t4) {
                var e4 = t4[t4.length - 1];
                return t4.length > 1 && t4[0][0] === e4[0] && t4[0][1] === e4[1] ? l.smoothclosed(t4.slice(1), T.smoothing) : l.smoothopen(t4, T.smoothing);
              } : function(t4) {
                return "M" + t4.join("L");
              }, N = function(t4) {
                return B(t4.reverse());
              }, Z = c(f3, { xaxis: b, yaxis: _, trace: w2, connectGaps: w2.connectgaps, baseTolerance: Math.max(T.width || 1, 3) / 4, shape: T.shape, backoff: T.backoff, simplify: T.simplify, fill: w2.fill }), H = w2._polygons = new Array(Z.length), g2 = 0; g2 < Z.length; g2++)
                w2._polygons[g2] = h(Z[g2]);
              Z.length && (j = Z[0][0], V = (U = Z[Z.length - 1])[U.length - 1]), Y = function(t4) {
                return function(e4) {
                  if (O = F(e4), I = N(e4), q2 ? P ? (q2 += "L" + O.substr(1), G = I + "L" + G.substr(1)) : (q2 += "Z" + O, G = I + "Z" + G) : (q2 = O, G = I), u.hasLines(w2)) {
                    var r4 = n2.select(this);
                    if (r4.datum(f3), t4)
                      x(r4.style("opacity", 0).attr("d", O).call(l.lineGroupStyle)).style("opacity", 1);
                    else {
                      var i2 = x(r4);
                      i2.attr("d", O), l.singleLineStyle(f3, i2);
                    }
                  }
                };
              };
            }
            var W = M.selectAll(".js-line").data(Z);
            x(W.exit()).style("opacity", 0).remove(), W.each(Y(false)), W.enter().append("path").classed("js-line", true).style("vector-effect", y ? "none" : "non-scaling-stroke").call(l.lineGroupStyle).each(Y(true)), l.setClipUrl(W, r3.layerClipId, t3), Z.length ? (L ? (L.datum(f3), j && V && (P ? ("y" === P ? j[1] = V[1] = _.c2p(0, true) : "x" === P && (j[0] = V[0] = b.c2p(0, true)), x(L).attr("d", "M" + V + "L" + j + "L" + q2.substr(1)).call(l.singleFillStyle, t3)) : x(L).attr("d", q2 + "Z").call(l.singleFillStyle, t3))) : C && ("tonext" === w2.fill.substr(0, 6) && q2 && D ? ("tonext" === w2.fill ? x(C).attr("d", q2 + "Z" + D + "Z").call(l.singleFillStyle, t3) : x(C).attr("d", q2 + "L" + D.substr(1) + "Z").call(l.singleFillStyle, t3), w2._polygons = w2._polygons.concat(z)) : (J(C), w2._polygons = null)), w2._prevRevpath = G, w2._prevPolygons = H) : (L ? J(L) : C && J(C), w2._polygons = w2._prevRevpath = w2._prevPolygons = null), S.datum(f3), E.datum(f3), function(e4, i2, a2) {
              var o2, c2 = a2[0].trace, f4 = u.hasMarkers(c2), h2 = u.hasText(c2), p4 = et(c2), d3 = rt, v2 = rt;
              if (f4 || h2) {
                var g3 = s, y2 = c2.stackgroup, w3 = y2 && "infer zero" === t3._fullLayout._scatterStackOpts[b._id + _._id][y2].stackgaps;
                c2.marker.maxdisplayed || c2._needsCull ? g3 = w3 ? $ : K : y2 && !w3 && (g3 = Q), f4 && (d3 = g3), h2 && (v2 = g3);
              }
              var T2, k2 = (o2 = e4.selectAll("path.point").data(d3, p4)).enter().append("path").classed("point", true);
              m2 && k2.call(l.pointStyle, c2, t3).call(l.translatePoints, b, _).style("opacity", 0).transition().style("opacity", 1), o2.order(), f4 && (T2 = l.makePointStyleFns(c2)), o2.each(function(e5) {
                var i3 = n2.select(this), a3 = x(i3);
                l.translatePoint(e5, a3, b, _) ? (l.singlePointStyle(e5, a3, c2, T2, t3), r3.layerClipId && l.hideOutsideRangePoint(e5, a3, b, _, c2.xcalendar, c2.ycalendar), c2.customdata && i3.classed("plotly-customdata", null !== e5.data && void 0 !== e5.data)) : a3.remove();
              }), m2 ? o2.exit().transition().style("opacity", 0).remove() : o2.exit().remove(), (o2 = i2.selectAll("g").data(v2, p4)).enter().append("g").classed("textpoint", true).append("text"), o2.order(), o2.each(function(t4) {
                var e5 = n2.select(this), i3 = x(e5.select("text"));
                l.translatePoint(t4, i3, b, _) ? r3.layerClipId && l.hideOutsideRangePoint(t4, e5, b, _, c2.xcalendar, c2.ycalendar) : e5.remove();
              }), o2.selectAll("text").call(l.textPointStyle, c2, t3).each(function(t4) {
                var e5 = b.c2p(t4.x), r4 = _.c2p(t4.y);
                n2.select(this).selectAll("tspan.line").each(function() {
                  x(n2.select(this)).attr({ x: e5, y: r4 });
                });
              }), o2.exit().remove();
            }(S, E, f3);
            var X = false === w2.cliponaxis ? null : r3.layerClipId;
            l.setClipUrl(S, X, t3), l.setClipUrl(E, X, t3);
          }
          function J(t4) {
            x(t4).attr("d", "M0,0Z");
          }
          function K(t4) {
            return t4.filter(function(t5) {
              return !t5.gap && t5.vis;
            });
          }
          function $(t4) {
            return t4.filter(function(t5) {
              return t5.vis;
            });
          }
          function Q(t4) {
            return t4.filter(function(t5) {
              return !t5.gap;
            });
          }
          function tt(t4) {
            return t4.id;
          }
          function et(t4) {
            if (t4.ids)
              return tt;
          }
          function rt() {
            return false;
          }
        }
        t2.exports = function(t3, e3, r3, i2, a2, u2) {
          var c2, h2, d2 = !a2, v = !!a2 && a2.duration > 0, g2 = f2(t3, e3, r3);
          (c2 = i2.selectAll("g.trace").data(g2, function(t4) {
            return t4[0].trace.uid;
          })).enter().append("g").attr("class", function(t4) {
            return "trace scatter trace" + t4[0].trace.uid;
          }).style("stroke-miterlimit", 2), c2.order(), function(t4, e4, r4) {
            e4.each(function(e5) {
              var i3 = o(n2.select(this), "g", "fills");
              l.setClipUrl(i3, r4.layerClipId, t4);
              var a3 = e5[0].trace, u3 = [];
              a3._ownfill && u3.push("_ownFill"), a3._nexttrace && u3.push("_nextFill");
              var c3 = i3.selectAll("g").data(u3, s);
              c3.enter().append("g"), c3.exit().each(function(t5) {
                a3[t5] = null;
              }).remove(), c3.order().each(function(t5) {
                a3[t5] = o(n2.select(this), "path", "js-fill");
              });
            });
          }(t3, c2, e3), v ? (u2 && (h2 = u2()), n2.transition().duration(a2.duration).ease(a2.easing).each("end", function() {
            h2 && h2();
          }).each("interrupt", function() {
            h2 && h2();
          }).each(function() {
            i2.selectAll("g.trace").each(function(r4, n3) {
              p2(t3, n3, e3, r4, g2, this, a2);
            });
          })) : c2.each(function(r4, n3) {
            p2(t3, n3, e3, r4, g2, this, a2);
          }), d2 && c2.exit().remove(), i2.selectAll("path:not([d])").remove();
        };
      }, 98002: function(t2, e2, r2) {
        var n2 = r2(34098);
        t2.exports = function(t3, e3) {
          var r3, i, a, o, s = t3.cd, l = t3.xaxis, u = t3.yaxis, c = [], f2 = s[0].trace;
          if (!n2.hasMarkers(f2) && !n2.hasText(f2))
            return [];
          if (false === e3)
            for (r3 = 0; r3 < s.length; r3++)
              s[r3].selected = 0;
          else
            for (r3 = 0; r3 < s.length; r3++)
              i = s[r3], a = l.c2p(i.x), o = u.c2p(i.y), null !== i.i && e3.contains([a, o], false, r3, t3) ? (c.push({ pointNumber: i.i, x: l.c2d(i.x), y: u.c2d(i.y) }), i.selected = 1) : i.selected = 0;
          return c;
        };
      }, 565: function(t2) {
        var e2 = ["orientation", "groupnorm", "stackgaps"];
        t2.exports = function(t3, r2, n2, i) {
          var a = n2._scatterStackOpts, o = i("stackgroup");
          if (o) {
            var s = r2.xaxis + r2.yaxis, l = a[s];
            l || (l = a[s] = {});
            var u = l[o], c = false;
            u ? u.traces.push(r2) : (u = l[o] = { traceIndices: [], traces: [r2] }, c = true);
            for (var f2 = { orientation: r2.x && !r2.y ? "h" : "v" }, h = 0; h < e2.length; h++) {
              var p2 = e2[h], d2 = p2 + "Found";
              if (!u[d2]) {
                var v = void 0 !== t3[p2], g2 = "orientation" === p2;
                if ((v || c) && (u[p2] = i(p2, f2[p2]), g2 && (u.fillDflt = "h" === u[p2] ? "tonextx" : "tonexty"), v && (u[d2] = true, !c && (delete u.traces[0][p2], g2))))
                  for (var y = 0; y < u.traces.length - 1; y++) {
                    var m2 = u.traces[y];
                    m2._input.fill !== m2.fill && (m2.fill = u.fillDflt);
                  }
              }
            }
            return u;
          }
        };
      }, 16296: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(91424), a = r2(73972);
        function o(t3, e3, r3) {
          i.pointStyle(t3.selectAll("path.point"), e3, r3);
        }
        function s(t3, e3, r3) {
          i.textPointStyle(t3.selectAll("text"), e3, r3);
        }
        t2.exports = { style: function(t3) {
          var e3 = n2.select(t3).selectAll("g.trace.scatter");
          e3.style("opacity", function(t4) {
            return t4[0].trace.opacity;
          }), e3.selectAll("g.points").each(function(e4) {
            o(n2.select(this), e4.trace || e4[0].trace, t3);
          }), e3.selectAll("g.text").each(function(e4) {
            s(n2.select(this), e4.trace || e4[0].trace, t3);
          }), e3.selectAll("g.trace path.js-line").call(i.lineGroupStyle), e3.selectAll("g.trace path.js-fill").call(i.fillGroupStyle, t3), a.getComponentMethod("errorbars", "style")(e3);
        }, stylePoints: o, styleText: s, styleOnSelect: function(t3, e3, r3) {
          var n3 = e3[0].trace;
          n3.selectedpoints ? (i.selectedPointStyle(r3.selectAll("path.point"), n3), i.selectedTextStyle(r3.selectAll("text"), n3)) : (o(r3, n3, t3), s(r3, n3, t3));
        } };
      }, 34098: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = { hasLines: function(t3) {
          return t3.visible && t3.mode && -1 !== t3.mode.indexOf("lines");
        }, hasMarkers: function(t3) {
          return t3.visible && (t3.mode && -1 !== t3.mode.indexOf("markers") || "splom" === t3.type);
        }, hasText: function(t3) {
          return t3.visible && t3.mode && -1 !== t3.mode.indexOf("text");
        }, isBubble: function(t3) {
          return n2.isPlainObject(t3.marker) && n2.isArrayOrTypedArray(t3.marker.size);
        } };
      }, 82410: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = function(t3, e3, r3, i, a) {
          a = a || {}, i("textposition"), n2.coerceFont(i, "textfont", r3.font), a.noSelect || (i("selected.textfont.color"), i("unselected.textfont.color"));
        };
      }, 67513: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(73972);
        t2.exports = function(t3, e3, r3, a) {
          var o, s = a("x"), l = a("y");
          if (i.getComponentMethod("calendars", "handleTraceDefaults")(t3, e3, ["x", "y"], r3), s) {
            var u = n2.minRowLength(s);
            l ? o = Math.min(u, n2.minRowLength(l)) : (o = u, a("y0"), a("dy"));
          } else {
            if (!l)
              return 0;
            o = n2.minRowLength(l), a("x0"), a("dx");
          }
          return e3._length = o, o;
        };
      }, 44542: function(t2, e2, r2) {
        var n2 = r2(82196), i = r2(50693), a = r2(12663).axisHoverFormat, o = r2(5386).f, s = r2(5386).s, l = r2(9012), u = r2(29659), c = r2(87381), f2 = r2(1426).extendFlat, h = r2(30962).overrideAll, p2 = r2(78607), d2 = n2.line, v = n2.marker, g2 = v.line, y = f2({ width: d2.width, dash: { valType: "enumerated", values: p2(u), dflt: "solid" } }, i("line")), m2 = t2.exports = h({ x: n2.x, y: n2.y, z: { valType: "data_array" }, text: f2({}, n2.text, {}), texttemplate: s({}, {}), hovertext: f2({}, n2.hovertext, {}), hovertemplate: o(), xhoverformat: a("x"), yhoverformat: a("y"), zhoverformat: a("z"), mode: f2({}, n2.mode, { dflt: "lines+markers" }), surfaceaxis: { valType: "enumerated", values: [-1, 0, 1, 2], dflt: -1 }, surfacecolor: { valType: "color" }, projection: { x: { show: { valType: "boolean", dflt: false }, opacity: { valType: "number", min: 0, max: 1, dflt: 1 }, scale: { valType: "number", min: 0, max: 10, dflt: 2 / 3 } }, y: { show: { valType: "boolean", dflt: false }, opacity: { valType: "number", min: 0, max: 1, dflt: 1 }, scale: { valType: "number", min: 0, max: 10, dflt: 2 / 3 } }, z: { show: { valType: "boolean", dflt: false }, opacity: { valType: "number", min: 0, max: 1, dflt: 1 }, scale: { valType: "number", min: 0, max: 10, dflt: 2 / 3 } } }, connectgaps: n2.connectgaps, line: y, marker: f2({ symbol: { valType: "enumerated", values: p2(c), dflt: "circle", arrayOk: true }, size: f2({}, v.size, { dflt: 8 }), sizeref: v.sizeref, sizemin: v.sizemin, sizemode: v.sizemode, opacity: f2({}, v.opacity, { arrayOk: false }), colorbar: v.colorbar, line: f2({ width: f2({}, g2.width, { arrayOk: false }) }, i("marker.line")) }, i("marker")), textposition: f2({}, n2.textposition, { dflt: "top center" }), textfont: { color: n2.textfont.color, size: n2.textfont.size, family: f2({}, n2.textfont.family, { arrayOk: false }) }, opacity: l.opacity, hoverinfo: f2({}, l.hoverinfo) }, "calc", "nested");
        m2.x.editType = m2.y.editType = m2.z.editType = "calc+clearAxisTypes";
      }, 36563: function(t2, e2, r2) {
        var n2 = r2(75225), i = r2(36922);
        t2.exports = function(t3, e3) {
          var r3 = [{ x: false, y: false, trace: e3, t: {} }];
          return n2(r3, e3), i(t3, e3), r3;
        };
      }, 67336: function(t2, e2, r2) {
        var n2 = r2(73972);
        function i(t3, e3, r3, i2) {
          if (!e3 || !e3.visible)
            return null;
          for (var a = n2.getComponentMethod("errorbars", "makeComputeError")(e3), o = new Array(t3.length), s = 0; s < t3.length; s++) {
            var l = a(+t3[s], s);
            if ("log" === i2.type) {
              var u = i2.c2l(t3[s]), c = t3[s] - l[0], f2 = t3[s] + l[1];
              if (o[s] = [(i2.c2l(c, true) - u) * r3, (i2.c2l(f2, true) - u) * r3], c > 0) {
                var h = i2.c2l(c);
                i2._lowerLogErrorBound || (i2._lowerLogErrorBound = h), i2._lowerErrorBound = Math.min(i2._lowerLogErrorBound, h);
              }
            } else
              o[s] = [-l[0] * r3, l[1] * r3];
          }
          return o;
        }
        t2.exports = function(t3, e3, r3) {
          var n3 = [i(t3.x, t3.error_x, e3[0], r3.xaxis), i(t3.y, t3.error_y, e3[1], r3.yaxis), i(t3.z, t3.error_z, e3[2], r3.zaxis)], a = function(t4) {
            for (var e4 = 0; e4 < t4.length; e4++)
              if (t4[e4])
                return t4[e4].length;
            return 0;
          }(n3);
          if (0 === a)
            return null;
          for (var o = new Array(a), s = 0; s < a; s++) {
            for (var l = [[0, 0, 0], [0, 0, 0]], u = 0; u < 3; u++)
              if (n3[u])
                for (var c = 0; c < 2; c++)
                  l[c][u] = n3[u][s][c];
            o[s] = l;
          }
          return o;
        };
      }, 58925: function(t2, e2, r2) {
        var n2 = r2(9330).gl_line3d, i = r2(9330).gl_scatter3d, a = r2(9330).gl_error3d, o = r2(9330).gl_mesh3d, s = r2(9330).delaunay_triangulate, l = r2(71828), u = r2(78614), c = r2(81697).formatColor, f2 = r2(39984), h = r2(29659), p2 = r2(87381), d2 = r2(89298), v = r2(23469).appendArrayPointValue, g2 = r2(67336);
        function y(t3, e3) {
          this.scene = t3, this.uid = e3, this.linePlot = null, this.scatterPlot = null, this.errorBars = null, this.textMarkers = null, this.delaunayMesh = null, this.color = null, this.mode = "", this.dataPoints = [], this.axesBounds = [[-1 / 0, -1 / 0, -1 / 0], [1 / 0, 1 / 0, 1 / 0]], this.textLabels = null, this.data = null;
        }
        var m2 = y.prototype;
        function x(t3) {
          return null == t3 ? 0 : t3.indexOf("left") > -1 ? -1 : t3.indexOf("right") > -1 ? 1 : 0;
        }
        function b(t3) {
          return null == t3 ? 0 : t3.indexOf("top") > -1 ? -1 : t3.indexOf("bottom") > -1 ? 1 : 0;
        }
        function _(t3, e3) {
          return e3(4 * t3);
        }
        function w2(t3) {
          return p2[t3];
        }
        function T(t3, e3, r3, n3, i2) {
          var a2 = null;
          if (l.isArrayOrTypedArray(t3)) {
            a2 = [];
            for (var o2 = 0; o2 < e3; o2++)
              void 0 === t3[o2] ? a2[o2] = n3 : a2[o2] = r3(t3[o2], i2);
          } else
            a2 = r3(t3, l.identity);
          return a2;
        }
        function k(t3) {
          if (l.isArrayOrTypedArray(t3)) {
            var e3 = t3[0];
            return l.isArrayOrTypedArray(e3) && (t3 = e3), "rgb(" + t3.slice(0, 3).map(function(t4) {
              return Math.round(255 * t4);
            }) + ")";
          }
          return null;
        }
        function A(t3) {
          return l.isArrayOrTypedArray(t3) ? 4 === t3.length && "number" == typeof t3[0] ? k(t3) : t3.map(k) : null;
        }
        m2.handlePick = function(t3) {
          if (t3.object && (t3.object === this.linePlot || t3.object === this.delaunayMesh || t3.object === this.textMarkers || t3.object === this.scatterPlot)) {
            var e3 = t3.index = t3.data.index;
            return t3.object.highlight && t3.object.highlight(null), this.scatterPlot && (t3.object = this.scatterPlot, this.scatterPlot.highlight(t3.data)), t3.textLabel = "", this.textLabels && (Array.isArray(this.textLabels) ? (this.textLabels[e3] || 0 === this.textLabels[e3]) && (t3.textLabel = this.textLabels[e3]) : t3.textLabel = this.textLabels), t3.traceCoordinate = [this.data.x[e3], this.data.y[e3], this.data.z[e3]], true;
          }
        }, m2.update = function(t3) {
          var e3, r3, p3, y2, m3 = this.scene.glplot.gl, k2 = h.solid;
          this.data = t3;
          var M = function(t4, e4) {
            var r4, n3, i2, a2, o2, s2, h2 = [], p4 = t4.fullSceneLayout, y3 = t4.dataScale, m4 = p4.xaxis, k3 = p4.yaxis, A2 = p4.zaxis, M2 = e4.marker, S2 = e4.line, E2 = e4.x || [], L = e4.y || [], C = e4.z || [], P = E2.length, O = e4.xcalendar, I = e4.ycalendar, D = e4.zcalendar;
            for (o2 = 0; o2 < P; o2++)
              r4 = m4.d2l(E2[o2], 0, O) * y3[0], n3 = k3.d2l(L[o2], 0, I) * y3[1], i2 = A2.d2l(C[o2], 0, D) * y3[2], h2[o2] = [r4, n3, i2];
            if (Array.isArray(e4.text))
              s2 = e4.text;
            else if (void 0 !== e4.text)
              for (s2 = new Array(P), o2 = 0; o2 < P; o2++)
                s2[o2] = e4.text;
            function z(t5, e5) {
              var r5 = p4[t5];
              return d2.tickText(r5, r5.d2l(e5), true).text;
            }
            var R = e4.texttemplate;
            if (R) {
              var F = t4.fullLayout._d3locale, B = Array.isArray(R), N = B ? Math.min(R.length, P) : P, j = B ? function(t5) {
                return R[t5];
              } : function() {
                return R;
              };
              for (s2 = new Array(N), o2 = 0; o2 < N; o2++) {
                var U = { x: E2[o2], y: L[o2], z: C[o2] }, V = { xLabel: z("xaxis", E2[o2]), yLabel: z("yaxis", L[o2]), zLabel: z("zaxis", C[o2]) }, H = {};
                v(H, e4, o2);
                var q2 = e4._meta || {};
                s2[o2] = l.texttemplateString(j(o2), V, F, H, U, q2);
              }
            }
            if (a2 = { position: h2, mode: e4.mode, text: s2 }, "line" in e4 && (a2.lineColor = c(S2, 1, P), a2.lineWidth = S2.width, a2.lineDashes = S2.dash), "marker" in e4) {
              var G = f2(e4);
              a2.scatterColor = c(M2, 1, P), a2.scatterSize = T(M2.size, P, _, 20, G), a2.scatterMarker = T(M2.symbol, P, w2, "●"), a2.scatterLineWidth = M2.line.width, a2.scatterLineColor = c(M2.line, 1, P), a2.scatterAngle = 0;
            }
            "textposition" in e4 && (a2.textOffset = function(t5) {
              var e5 = [0, 0];
              if (Array.isArray(t5))
                for (var r5 = 0; r5 < t5.length; r5++)
                  e5[r5] = [0, 0], t5[r5] && (e5[r5][0] = x(t5[r5]), e5[r5][1] = b(t5[r5]));
              else
                e5[0] = x(t5), e5[1] = b(t5);
              return e5;
            }(e4.textposition), a2.textColor = c(e4.textfont, 1, P), a2.textSize = T(e4.textfont.size, P, l.identity, 12), a2.textFont = e4.textfont.family, a2.textAngle = 0);
            var Z = ["x", "y", "z"];
            for (a2.project = [false, false, false], a2.projectScale = [1, 1, 1], a2.projectOpacity = [1, 1, 1], o2 = 0; o2 < 3; ++o2) {
              var Y = e4.projection[Z[o2]];
              (a2.project[o2] = Y.show) && (a2.projectOpacity[o2] = Y.opacity, a2.projectScale[o2] = Y.scale);
            }
            a2.errorBounds = g2(e4, y3, p4);
            var W = function(t5) {
              for (var e5 = [0, 0, 0], r5 = [[0, 0, 0], [0, 0, 0], [0, 0, 0]], n4 = [1, 1, 1], i3 = 0; i3 < 3; i3++) {
                var a3 = t5[i3];
                a3 && false !== a3.copy_zstyle && false !== t5[2].visible && (a3 = t5[2]), a3 && a3.visible && (e5[i3] = a3.width / 2, r5[i3] = u(a3.color), n4[i3] = a3.thickness);
              }
              return { capSize: e5, color: r5, lineWidth: n4 };
            }([e4.error_x, e4.error_y, e4.error_z]);
            return a2.errorColor = W.color, a2.errorLineWidth = W.lineWidth, a2.errorCapSize = W.capSize, a2.delaunayAxis = e4.surfaceaxis, a2.delaunayColor = u(e4.surfacecolor), a2;
          }(this.scene, t3);
          "mode" in M && (this.mode = M.mode), "lineDashes" in M && M.lineDashes in h && (k2 = h[M.lineDashes]), this.color = A(M.scatterColor) || A(M.lineColor), this.dataPoints = M.position, e3 = { gl: this.scene.glplot.gl, position: M.position, color: M.lineColor, lineWidth: M.lineWidth || 1, dashes: k2[0], dashScale: k2[1], opacity: t3.opacity, connectGaps: t3.connectgaps }, -1 !== this.mode.indexOf("lines") ? this.linePlot ? this.linePlot.update(e3) : (this.linePlot = n2(e3), this.linePlot._trace = this, this.scene.glplot.add(this.linePlot)) : this.linePlot && (this.scene.glplot.remove(this.linePlot), this.linePlot.dispose(), this.linePlot = null);
          var S = t3.opacity;
          if (t3.marker && t3.marker.opacity && (S *= t3.marker.opacity), r3 = { gl: this.scene.glplot.gl, position: M.position, color: M.scatterColor, size: M.scatterSize, glyph: M.scatterMarker, opacity: S, orthographic: true, lineWidth: M.scatterLineWidth, lineColor: M.scatterLineColor, project: M.project, projectScale: M.projectScale, projectOpacity: M.projectOpacity }, -1 !== this.mode.indexOf("markers") ? this.scatterPlot ? this.scatterPlot.update(r3) : (this.scatterPlot = i(r3), this.scatterPlot._trace = this, this.scatterPlot.highlightScale = 1, this.scene.glplot.add(this.scatterPlot)) : this.scatterPlot && (this.scene.glplot.remove(this.scatterPlot), this.scatterPlot.dispose(), this.scatterPlot = null), y2 = { gl: this.scene.glplot.gl, position: M.position, glyph: M.text, color: M.textColor, size: M.textSize, angle: M.textAngle, alignment: M.textOffset, font: M.textFont, orthographic: true, lineWidth: 0, project: false, opacity: t3.opacity }, this.textLabels = t3.hovertext || t3.text, -1 !== this.mode.indexOf("text") ? this.textMarkers ? this.textMarkers.update(y2) : (this.textMarkers = i(y2), this.textMarkers._trace = this, this.textMarkers.highlightScale = 1, this.scene.glplot.add(this.textMarkers)) : this.textMarkers && (this.scene.glplot.remove(this.textMarkers), this.textMarkers.dispose(), this.textMarkers = null), p3 = { gl: this.scene.glplot.gl, position: M.position, color: M.errorColor, error: M.errorBounds, lineWidth: M.errorLineWidth, capSize: M.errorCapSize, opacity: t3.opacity }, this.errorBars ? M.errorBounds ? this.errorBars.update(p3) : (this.scene.glplot.remove(this.errorBars), this.errorBars.dispose(), this.errorBars = null) : M.errorBounds && (this.errorBars = a(p3), this.errorBars._trace = this, this.scene.glplot.add(this.errorBars)), M.delaunayAxis >= 0) {
            var E = function(t4, e4, r4) {
              var n3, i2 = (r4 + 1) % 3, a2 = (r4 + 2) % 3, o2 = [], l2 = [];
              for (n3 = 0; n3 < t4.length; ++n3) {
                var u2 = t4[n3];
                !isNaN(u2[i2]) && isFinite(u2[i2]) && !isNaN(u2[a2]) && isFinite(u2[a2]) && (o2.push([u2[i2], u2[a2]]), l2.push(n3));
              }
              var c2 = s(o2);
              for (n3 = 0; n3 < c2.length; ++n3)
                for (var f3 = c2[n3], h2 = 0; h2 < f3.length; ++h2)
                  f3[h2] = l2[f3[h2]];
              return { positions: t4, cells: c2, meshColor: e4 };
            }(M.position, M.delaunayColor, M.delaunayAxis);
            E.opacity = t3.opacity, this.delaunayMesh ? this.delaunayMesh.update(E) : (E.gl = m3, this.delaunayMesh = o(E), this.delaunayMesh._trace = this, this.scene.glplot.add(this.delaunayMesh));
          } else
            this.delaunayMesh && (this.scene.glplot.remove(this.delaunayMesh), this.delaunayMesh.dispose(), this.delaunayMesh = null);
        }, m2.dispose = function() {
          this.linePlot && (this.scene.glplot.remove(this.linePlot), this.linePlot.dispose()), this.scatterPlot && (this.scene.glplot.remove(this.scatterPlot), this.scatterPlot.dispose()), this.errorBars && (this.scene.glplot.remove(this.errorBars), this.errorBars.dispose()), this.textMarkers && (this.scene.glplot.remove(this.textMarkers), this.textMarkers.dispose()), this.delaunayMesh && (this.scene.glplot.remove(this.delaunayMesh), this.delaunayMesh.dispose());
        }, t2.exports = function(t3, e3) {
          var r3 = new y(t3, e3.uid);
          return r3.update(e3), r3;
        };
      }, 21428: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828), a = r2(34098), o = r2(49508), s = r2(11058), l = r2(82410), u = r2(44542);
        t2.exports = function(t3, e3, r3, c) {
          function f2(r4, n3) {
            return i.coerce(t3, e3, u, r4, n3);
          }
          var h = function(t4, e4, r4, i2) {
            var a2 = 0, o2 = r4("x"), s2 = r4("y"), l2 = r4("z");
            return n2.getComponentMethod("calendars", "handleTraceDefaults")(t4, e4, ["x", "y", "z"], i2), o2 && s2 && l2 && (a2 = Math.min(o2.length, s2.length, l2.length), e4._length = e4._xlength = e4._ylength = e4._zlength = a2), a2;
          }(t3, e3, f2, c);
          if (h) {
            f2("text"), f2("hovertext"), f2("hovertemplate"), f2("xhoverformat"), f2("yhoverformat"), f2("zhoverformat"), f2("mode"), a.hasLines(e3) && (f2("connectgaps"), s(t3, e3, r3, c, f2)), a.hasMarkers(e3) && o(t3, e3, r3, c, f2, { noSelect: true, noAngle: true }), a.hasText(e3) && (f2("texttemplate"), l(t3, e3, c, f2, { noSelect: true }));
            var p2 = (e3.line || {}).color, d2 = (e3.marker || {}).color;
            f2("surfaceaxis") >= 0 && f2("surfacecolor", p2 || d2);
            for (var v = ["x", "y", "z"], g2 = 0; g2 < 3; ++g2) {
              var y = "projection." + v[g2];
              f2(y + ".show") && (f2(y + ".opacity"), f2(y + ".scale"));
            }
            var m2 = n2.getComponentMethod("errorbars", "supplyDefaults");
            m2(t3, e3, p2 || d2 || r3, { axis: "z" }), m2(t3, e3, p2 || d2 || r3, { axis: "y", inherit: "z" }), m2(t3, e3, p2 || d2 || r3, { axis: "x", inherit: "z" });
          } else
            e3.visible = false;
        };
      }, 13551: function(t2, e2, r2) {
        t2.exports = { plot: r2(58925), attributes: r2(44542), markerSymbols: r2(87381), supplyDefaults: r2(21428), colorbar: [{ container: "marker", min: "cmin", max: "cmax" }, { container: "line", min: "cmin", max: "cmax" }], calc: r2(36563), moduleType: "trace", name: "scatter3d", basePlotModule: r2(58547), categories: ["gl3d", "symbols", "showLegend", "scatter-like"], meta: {} };
      }, 97001: function(t2, e2, r2) {
        var n2 = r2(82196), i = r2(9012), a = r2(5386).f, o = r2(5386).s, s = r2(50693), l = r2(1426).extendFlat, u = n2.marker, c = n2.line, f2 = u.line;
        t2.exports = { carpet: { valType: "string", editType: "calc" }, a: { valType: "data_array", editType: "calc" }, b: { valType: "data_array", editType: "calc" }, mode: l({}, n2.mode, { dflt: "markers" }), text: l({}, n2.text, {}), texttemplate: o({ editType: "plot" }, { keys: ["a", "b", "text"] }), hovertext: l({}, n2.hovertext, {}), line: { color: c.color, width: c.width, dash: c.dash, backoff: c.backoff, shape: l({}, c.shape, { values: ["linear", "spline"] }), smoothing: c.smoothing, editType: "calc" }, connectgaps: n2.connectgaps, fill: l({}, n2.fill, { values: ["none", "toself", "tonext"], dflt: "none" }), fillcolor: n2.fillcolor, marker: l({ symbol: u.symbol, opacity: u.opacity, maxdisplayed: u.maxdisplayed, angle: u.angle, angleref: u.angleref, standoff: u.standoff, size: u.size, sizeref: u.sizeref, sizemin: u.sizemin, sizemode: u.sizemode, line: l({ width: f2.width, editType: "calc" }, s("marker.line")), gradient: u.gradient, editType: "calc" }, s("marker")), textfont: n2.textfont, textposition: n2.textposition, selected: n2.selected, unselected: n2.unselected, hoverinfo: l({}, i.hoverinfo, { flags: ["a", "b", "text", "name"] }), hoveron: n2.hoveron, hovertemplate: a() };
      }, 34618: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(36922), a = r2(75225), o = r2(66279), s = r2(47761).calcMarkerSize, l = r2(22882);
        t2.exports = function(t3, e3) {
          var r3 = e3._carpetTrace = l(t3, e3);
          if (r3 && r3.visible && "legendonly" !== r3.visible) {
            var u;
            e3.xaxis = r3.xaxis, e3.yaxis = r3.yaxis;
            var c, f2, h = e3._length, p2 = new Array(h), d2 = false;
            for (u = 0; u < h; u++)
              if (c = e3.a[u], f2 = e3.b[u], n2(c) && n2(f2)) {
                var v = r3.ab2xy(+c, +f2, true), g2 = r3.isVisible(+c, +f2);
                g2 || (d2 = true), p2[u] = { x: v[0], y: v[1], a: c, b: f2, vis: g2 };
              } else
                p2[u] = { x: false, y: false };
            return e3._needsCull = d2, p2[0].carpet = r3, p2[0].trace = e3, s(e3, h), i(t3, e3), a(p2, e3), o(p2, e3), p2;
          }
        };
      }, 98965: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(47581), a = r2(34098), o = r2(49508), s = r2(11058), l = r2(94039), u = r2(82410), c = r2(28908), f2 = r2(97001);
        t2.exports = function(t3, e3, r3, h) {
          function p2(r4, i2) {
            return n2.coerce(t3, e3, f2, r4, i2);
          }
          p2("carpet"), e3.xaxis = "x", e3.yaxis = "y";
          var d2 = p2("a"), v = p2("b"), g2 = Math.min(d2.length, v.length);
          if (g2) {
            e3._length = g2, p2("text"), p2("texttemplate"), p2("hovertext"), p2("mode", g2 < i.PTS_LINESONLY ? "lines+markers" : "lines"), a.hasLines(e3) && (s(t3, e3, r3, h, p2, { backoff: true }), l(t3, e3, p2), p2("connectgaps")), a.hasMarkers(e3) && o(t3, e3, r3, h, p2, { gradient: true }), a.hasText(e3) && u(t3, e3, h, p2);
            var y = [];
            (a.hasMarkers(e3) || a.hasText(e3)) && (p2("marker.maxdisplayed"), y.push("points")), p2("fill"), "none" !== e3.fill && (c(t3, e3, r3, p2), a.hasLines(e3) || l(t3, e3, p2)), "tonext" !== e3.fill && "toself" !== e3.fill || y.push("fills"), "fills" !== p2("hoveron", y.join("+") || "points") && p2("hovertemplate"), n2.coerceSelectionMarkerOpacity(e3, p2);
          } else
            e3.visible = false;
        };
      }, 16165: function(t2) {
        t2.exports = function(t3, e2, r2, n2, i) {
          var a = n2[i];
          return t3.a = a.a, t3.b = a.b, t3.y = a.y, t3;
        };
      }, 48953: function(t2) {
        t2.exports = function(t3, e2) {
          var r2 = {}, n2 = e2._carpet, i = n2.ab2ij([t3.a, t3.b]), a = Math.floor(i[0]), o = i[0] - a, s = Math.floor(i[1]), l = i[1] - s, u = n2.evalxy([], a, s, o, l);
          return r2.yLabel = u[1].toFixed(3), r2;
        };
      }, 22931: function(t2, e2, r2) {
        var n2 = r2(33720), i = r2(71828).fillText;
        t2.exports = function(t3, e3, r3, a) {
          var o = n2(t3, e3, r3, a);
          if (o && false !== o[0].index) {
            var s = o[0];
            if (void 0 === s.index) {
              var l = 1 - s.y0 / t3.ya._length, u = t3.xa._length, c = u * l / 2, f2 = u - c;
              return s.x0 = Math.max(Math.min(s.x0, f2), c), s.x1 = Math.max(Math.min(s.x1, f2), c), o;
            }
            var h = s.cd[s.index];
            s.a = h.a, s.b = h.b, s.xLabelVal = void 0, s.yLabelVal = void 0;
            var p2 = s.trace, d2 = p2._carpet, v = p2._module.formatLabels(h, p2);
            s.yLabel = v.yLabel, delete s.text;
            var g2 = [];
            if (!p2.hovertemplate) {
              var y = (h.hi || p2.hoverinfo).split("+");
              -1 !== y.indexOf("all") && (y = ["a", "b", "text"]), -1 !== y.indexOf("a") && m2(d2.aaxis, h.a), -1 !== y.indexOf("b") && m2(d2.baxis, h.b), g2.push("y: " + s.yLabel), -1 !== y.indexOf("text") && i(h, p2, g2), s.extraText = g2.join("<br>");
            }
            return o;
          }
          function m2(t4, e4) {
            var r4;
            r4 = t4.labelprefix && t4.labelprefix.length > 0 ? t4.labelprefix.replace(/ = $/, "") : t4._hovertitle, g2.push(r4 + ": " + e4.toFixed(3) + t4.labelsuffix);
          }
        };
      }, 46858: function(t2, e2, r2) {
        t2.exports = { attributes: r2(97001), supplyDefaults: r2(98965), colorbar: r2(4898), formatLabels: r2(48953), calc: r2(34618), plot: r2(1913), style: r2(16296).style, styleOnSelect: r2(16296).styleOnSelect, hoverPoints: r2(22931), selectPoints: r2(98002), eventData: r2(16165), moduleType: "trace", name: "scattercarpet", basePlotModule: r2(93612), categories: ["svg", "carpet", "symbols", "showLegend", "carpetDependent", "zoomScale"], meta: {} };
      }, 1913: function(t2, e2, r2) {
        var n2 = r2(32663), i = r2(89298), a = r2(91424);
        t2.exports = function(t3, e3, r3, o) {
          var s, l, u, c = r3[0][0].carpet, f2 = i.getFromId(t3, c.xaxis || "x"), h = i.getFromId(t3, c.yaxis || "y"), p2 = { xaxis: f2, yaxis: h, plot: e3.plot };
          for (s = 0; s < r3.length; s++)
            (l = r3[s][0].trace)._xA = f2, l._yA = h;
          for (n2(t3, p2, r3, o), s = 0; s < r3.length; s++)
            l = r3[s][0].trace, u = o.selectAll("g.trace" + l.uid + " .js-line"), a.setClipUrl(u, r3[s][0].carpet._clipPathId, t3);
        };
      }, 19316: function(t2, e2, r2) {
        var n2 = r2(5386).f, i = r2(5386).s, a = r2(82196), o = r2(9012), s = r2(50693), l = r2(79952).P, u = r2(1426).extendFlat, c = r2(30962).overrideAll, f2 = a.marker, h = a.line, p2 = f2.line;
        t2.exports = c({ lon: { valType: "data_array" }, lat: { valType: "data_array" }, locations: { valType: "data_array" }, locationmode: { valType: "enumerated", values: ["ISO-3", "USA-states", "country names", "geojson-id"], dflt: "ISO-3" }, geojson: { valType: "any", editType: "calc" }, featureidkey: { valType: "string", editType: "calc", dflt: "id" }, mode: u({}, a.mode, { dflt: "markers" }), text: u({}, a.text, {}), texttemplate: i({ editType: "plot" }, { keys: ["lat", "lon", "location", "text"] }), hovertext: u({}, a.hovertext, {}), textfont: a.textfont, textposition: a.textposition, line: { color: h.color, width: h.width, dash: l }, connectgaps: a.connectgaps, marker: u({ symbol: f2.symbol, opacity: f2.opacity, angle: f2.angle, angleref: u({}, f2.angleref, { values: ["previous", "up", "north"] }), standoff: f2.standoff, size: f2.size, sizeref: f2.sizeref, sizemin: f2.sizemin, sizemode: f2.sizemode, colorbar: f2.colorbar, line: u({ width: p2.width }, s("marker.line")), gradient: f2.gradient }, s("marker")), fill: { valType: "enumerated", values: ["none", "toself"], dflt: "none" }, fillcolor: a.fillcolor, selected: a.selected, unselected: a.unselected, hoverinfo: u({}, o.hoverinfo, { flags: ["lon", "lat", "location", "text", "name"] }), hovertemplate: n2() }, "calc", "nested");
      }, 84622: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(50606).BADNUM, a = r2(36922), o = r2(75225), s = r2(66279), l = r2(71828)._;
        function u(t3) {
          return t3 && "string" == typeof t3;
        }
        t2.exports = function(t3, e3) {
          var r3, c = Array.isArray(e3.locations), f2 = c ? e3.locations.length : e3._length, h = new Array(f2);
          r3 = e3.geojson ? function(t4) {
            return u(t4) || n2(t4);
          } : u;
          for (var p2 = 0; p2 < f2; p2++) {
            var d2 = h[p2] = {};
            if (c) {
              var v = e3.locations[p2];
              d2.loc = r3(v) ? v : null;
            } else {
              var g2 = e3.lon[p2], y = e3.lat[p2];
              n2(g2) && n2(y) ? d2.lonlat = [+g2, +y] : d2.lonlat = [i, i];
            }
          }
          return o(h, e3), a(t3, e3), s(h, e3), f2 && (h[0].t = { labels: { lat: l(t3, "lat:") + " ", lon: l(t3, "lon:") + " " } }), h;
        };
      }, 10659: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(34098), a = r2(49508), o = r2(11058), s = r2(82410), l = r2(28908), u = r2(19316);
        t2.exports = function(t3, e3, r3, c) {
          function f2(r4, i2) {
            return n2.coerce(t3, e3, u, r4, i2);
          }
          var h, p2 = f2("locations");
          if (p2 && p2.length) {
            var d2, v = f2("geojson");
            ("string" == typeof v && "" !== v || n2.isPlainObject(v)) && (d2 = "geojson-id"), "geojson-id" === f2("locationmode", d2) && f2("featureidkey"), h = p2.length;
          } else {
            var g2 = f2("lon") || [], y = f2("lat") || [];
            h = Math.min(g2.length, y.length);
          }
          h ? (e3._length = h, f2("text"), f2("hovertext"), f2("hovertemplate"), f2("mode"), i.hasLines(e3) && (o(t3, e3, r3, c, f2), f2("connectgaps")), i.hasMarkers(e3) && a(t3, e3, r3, c, f2, { gradient: true }), i.hasText(e3) && (f2("texttemplate"), s(t3, e3, c, f2)), f2("fill"), "none" !== e3.fill && l(t3, e3, r3, f2), n2.coerceSelectionMarkerOpacity(e3, f2)) : e3.visible = false;
        };
      }, 84084: function(t2) {
        t2.exports = function(t3, e2, r2, n2, i) {
          t3.lon = e2.lon, t3.lat = e2.lat, t3.location = e2.loc ? e2.loc : null;
          var a = n2[i];
          return a.fIn && a.fIn.properties && (t3.properties = a.fIn.properties), t3;
        };
      }, 82719: function(t2, e2, r2) {
        var n2 = r2(89298);
        t2.exports = function(t3, e3, r3) {
          var i = {}, a = r3[e3.geo]._subplot.mockAxis, o = t3.lonlat;
          return i.lonLabel = n2.tickText(a, a.c2l(o[0]), true).text, i.latLabel = n2.tickText(a, a.c2l(o[1]), true).text, i;
        };
      }, 14977: function(t2, e2, r2) {
        var n2 = r2(30211), i = r2(50606).BADNUM, a = r2(34603), o = r2(71828).fillText, s = r2(19316);
        t2.exports = function(t3, e3, r3) {
          var l = t3.cd, u = l[0].trace, c = t3.xa, f2 = t3.ya, h = t3.subplot, p2 = h.projection.isLonLatOverEdges, d2 = h.project;
          if (n2.getClosest(l, function(t4) {
            var n3 = t4.lonlat;
            if (n3[0] === i)
              return 1 / 0;
            if (p2(n3))
              return 1 / 0;
            var a2 = d2(n3), o2 = d2([e3, r3]), s2 = Math.abs(a2[0] - o2[0]), l2 = Math.abs(a2[1] - o2[1]), u2 = Math.max(3, t4.mrc || 0);
            return Math.max(Math.sqrt(s2 * s2 + l2 * l2) - u2, 1 - 3 / u2);
          }, t3), false !== t3.index) {
            var v = l[t3.index], g2 = v.lonlat, y = [c.c2p(g2), f2.c2p(g2)], m2 = v.mrc || 1;
            t3.x0 = y[0] - m2, t3.x1 = y[0] + m2, t3.y0 = y[1] - m2, t3.y1 = y[1] + m2, t3.loc = v.loc, t3.lon = g2[0], t3.lat = g2[1];
            var x = {};
            x[u.geo] = { _subplot: h };
            var b = u._module.formatLabels(v, u, x);
            return t3.lonLabel = b.lonLabel, t3.latLabel = b.latLabel, t3.color = a(u, v), t3.extraText = function(t4, e4, r4, n3) {
              if (!t4.hovertemplate) {
                var i2 = e4.hi || t4.hoverinfo, a2 = "all" === i2 ? s.hoverinfo.flags : i2.split("+"), l2 = -1 !== a2.indexOf("location") && Array.isArray(t4.locations), u2 = -1 !== a2.indexOf("lon"), c2 = -1 !== a2.indexOf("lat"), f3 = -1 !== a2.indexOf("text"), h2 = [];
                return l2 ? h2.push(e4.loc) : u2 && c2 ? h2.push("(" + p3(r4.latLabel) + ", " + p3(r4.lonLabel) + ")") : u2 ? h2.push(n3.lon + p3(r4.lonLabel)) : c2 && h2.push(n3.lat + p3(r4.latLabel)), f3 && o(e4, t4, h2), h2.join("<br>");
              }
              function p3(t5) {
                return t5 + "°";
              }
            }(u, v, t3, l[0].t.labels), t3.hovertemplate = u.hovertemplate, [t3];
          }
        };
      }, 17988: function(t2, e2, r2) {
        t2.exports = { attributes: r2(19316), supplyDefaults: r2(10659), colorbar: r2(4898), formatLabels: r2(82719), calc: r2(84622), calcGeoJSON: r2(89171).calcGeoJSON, plot: r2(89171).plot, style: r2(33095), styleOnSelect: r2(16296).styleOnSelect, hoverPoints: r2(14977), eventData: r2(84084), selectPoints: r2(20548), moduleType: "trace", name: "scattergeo", basePlotModule: r2(44622), categories: ["geo", "symbols", "showLegend", "scatter-like"], meta: {} };
      }, 89171: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(90973).getTopojsonFeatures, o = r2(18214), s = r2(41327), l = r2(71739).findExtremes, u = r2(50606).BADNUM, c = r2(47761).calcMarkerSize, f2 = r2(34098), h = r2(33095);
        t2.exports = { calcGeoJSON: function(t3, e3) {
          var r3, n3, i2 = t3[0].trace, o2 = e3[i2.geo], f3 = o2._subplot, h2 = i2._length;
          if (Array.isArray(i2.locations)) {
            var p2 = i2.locationmode, d2 = "geojson-id" === p2 ? s.extractTraceFeature(t3) : a(i2, f3.topojson);
            for (r3 = 0; r3 < h2; r3++) {
              n3 = t3[r3];
              var v = "geojson-id" === p2 ? n3.fOut : s.locationToFeature(p2, n3.loc, d2);
              n3.lonlat = v ? v.properties.ct : [u, u];
            }
          }
          var g2, y, m2 = { padded: true };
          if ("geojson" === o2.fitbounds && "geojson-id" === i2.locationmode) {
            var x = s.computeBbox(s.getTraceGeojson(i2));
            g2 = [x[0], x[2]], y = [x[1], x[3]];
          } else {
            for (g2 = new Array(h2), y = new Array(h2), r3 = 0; r3 < h2; r3++)
              n3 = t3[r3], g2[r3] = n3.lonlat[0], y[r3] = n3.lonlat[1];
            m2.ppad = c(i2, h2);
          }
          i2._extremes.lon = l(o2.lonaxis._ax, g2, m2), i2._extremes.lat = l(o2.lataxis._ax, y, m2);
        }, plot: function(t3, e3, r3) {
          var a2 = e3.layers.frontplot.select(".scatterlayer"), s2 = i.makeTraceGroups(a2, r3, "trace scattergeo");
          function l2(t4, e4) {
            t4.lonlat[0] === u && n2.select(e4).remove();
          }
          s2.selectAll("*").remove(), s2.each(function(e4) {
            var r4 = n2.select(this), a3 = e4[0].trace;
            if (f2.hasLines(a3) || "none" !== a3.fill) {
              var s3 = o.calcTraceToLineCoords(e4), u2 = "none" !== a3.fill ? o.makePolygon(s3) : o.makeLine(s3);
              r4.selectAll("path.js-line").data([{ geojson: u2, trace: a3 }]).enter().append("path").classed("js-line", true).style("stroke-miterlimit", 2);
            }
            f2.hasMarkers(a3) && r4.selectAll("path.point").data(i.identity).enter().append("path").classed("point", true).each(function(t4) {
              l2(t4, this);
            }), f2.hasText(a3) && r4.selectAll("g").data(i.identity).enter().append("g").append("text").each(function(t4) {
              l2(t4, this);
            }), h(t3, e4);
          });
        } };
      }, 20548: function(t2, e2, r2) {
        var n2 = r2(34098), i = r2(50606).BADNUM;
        t2.exports = function(t3, e3) {
          var r3, a, o, s, l, u = t3.cd, c = t3.xaxis, f2 = t3.yaxis, h = [], p2 = u[0].trace;
          if (!n2.hasMarkers(p2) && !n2.hasText(p2))
            return [];
          if (false === e3)
            for (l = 0; l < u.length; l++)
              u[l].selected = 0;
          else
            for (l = 0; l < u.length; l++)
              (a = (r3 = u[l]).lonlat)[0] !== i && (o = c.c2p(a), s = f2.c2p(a), e3.contains([o, s], null, l, t3) ? (h.push({ pointNumber: l, lon: a[0], lat: a[1] }), r3.selected = 1) : r3.selected = 0);
          return h;
        };
      }, 33095: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(91424), a = r2(7901), o = r2(16296), s = o.stylePoints, l = o.styleText;
        t2.exports = function(t3, e3) {
          e3 && function(t4, e4) {
            var r3 = e4[0].trace, o2 = e4[0].node3;
            o2.style("opacity", e4[0].trace.opacity), s(o2, r3, t4), l(o2, r3, t4), o2.selectAll("path.js-line").style("fill", "none").each(function(t5) {
              var e5 = n2.select(this), r4 = t5.trace, o3 = r4.line || {};
              e5.call(a.stroke, o3.color).call(i.dashLine, o3.dash || "", o3.width || 0), "none" !== r4.fill && e5.call(a.fill, r4.fillcolor);
            });
          }(t3, e3);
        };
      }, 42341: function(t2, e2, r2) {
        var n2 = r2(9012), i = r2(82196), a = r2(12663).axisHoverFormat, o = r2(50693), s = r2(78607), l = r2(1426).extendFlat, u = r2(30962).overrideAll, c = r2(78232).DASHES, f2 = i.line, h = i.marker, p2 = h.line, d2 = t2.exports = u({ x: i.x, x0: i.x0, dx: i.dx, y: i.y, y0: i.y0, dy: i.dy, xperiod: i.xperiod, yperiod: i.yperiod, xperiod0: i.xperiod0, yperiod0: i.yperiod0, xperiodalignment: i.xperiodalignment, yperiodalignment: i.yperiodalignment, xhoverformat: a("x"), yhoverformat: a("y"), text: i.text, hovertext: i.hovertext, textposition: i.textposition, textfont: i.textfont, mode: { valType: "flaglist", flags: ["lines", "markers", "text"], extras: ["none"] }, line: { color: f2.color, width: f2.width, shape: { valType: "enumerated", values: ["linear", "hv", "vh", "hvh", "vhv"], dflt: "linear", editType: "plot" }, dash: { valType: "enumerated", values: s(c), dflt: "solid" } }, marker: l({}, o("marker"), { symbol: h.symbol, angle: h.angle, size: h.size, sizeref: h.sizeref, sizemin: h.sizemin, sizemode: h.sizemode, opacity: h.opacity, colorbar: h.colorbar, line: l({}, o("marker.line"), { width: p2.width }) }), connectgaps: i.connectgaps, fill: l({}, i.fill, { dflt: "none" }), fillcolor: i.fillcolor, selected: { marker: i.selected.marker, textfont: i.selected.textfont }, unselected: { marker: i.unselected.marker, textfont: i.unselected.textfont }, opacity: n2.opacity }, "calc", "nested");
        d2.x.editType = d2.y.editType = d2.x0.editType = d2.y0.editType = "calc+clearAxisTypes", d2.hovertemplate = i.hovertemplate, d2.texttemplate = i.texttemplate;
      }, 72156: function(t2, e2, r2) {
        var n2 = r2(20794);
        t2.exports = { moduleType: "trace", name: "scattergl", basePlotModule: r2(93612), categories: ["gl", "regl", "cartesian", "symbols", "errorBarsOK", "showLegend", "scatter-like"], attributes: r2(42341), supplyDefaults: r2(47148), crossTraceDefaults: r2(34936), colorbar: r2(4898), formatLabels: r2(68101), calc: r2(45032), hoverPoints: n2.hoverPoints, selectPoints: r2(58147), meta: {} };
      }, 45032: function(t2, e2, r2) {
        var n2 = r2(88294), i = r2(71828), a = r2(41675), o = r2(71739).findExtremes, s = r2(42973), l = r2(47761), u = l.calcMarkerSize, c = l.calcAxisExpansion, f2 = l.setFirstScatter, h = r2(36922), p2 = r2(19635), d2 = r2(38967), v = r2(50606).BADNUM, g2 = r2(78232).TOO_MANY_POINTS;
        function y(t3, e3, r3) {
          var n3 = t3._extremes[e3._id], i2 = o(e3, r3._bnds, { padded: true });
          n3.min = n3.min.concat(i2.min), n3.max = n3.max.concat(i2.max);
        }
        t2.exports = function(t3, e3) {
          var r3, o2 = t3._fullLayout, l2 = e3._xA = a.getFromId(t3, e3.xaxis, "x"), m2 = e3._yA = a.getFromId(t3, e3.yaxis, "y"), x = o2._plots[e3.xaxis + e3.yaxis], b = e3._length, _ = b >= g2, w2 = 2 * b, T = {}, k = l2.makeCalcdata(e3, "x"), A = m2.makeCalcdata(e3, "y"), M = s(e3, l2, "x", k), S = s(e3, m2, "y", A), E = M.vals, L = S.vals;
          e3._x = E, e3._y = L, e3.xperiodalignment && (e3._origX = k, e3._xStarts = M.starts, e3._xEnds = M.ends), e3.yperiodalignment && (e3._origY = A, e3._yStarts = S.starts, e3._yEnds = S.ends);
          var C = new Array(w2), P = new Array(b);
          for (r3 = 0; r3 < b; r3++)
            C[2 * r3] = E[r3] === v ? NaN : E[r3], C[2 * r3 + 1] = L[r3] === v ? NaN : L[r3], P[r3] = r3;
          if ("log" === l2.type)
            for (r3 = 0; r3 < w2; r3 += 2)
              C[r3] = l2.c2l(C[r3]);
          if ("log" === m2.type)
            for (r3 = 1; r3 < w2; r3 += 2)
              C[r3] = m2.c2l(C[r3]);
          _ && "log" !== l2.type && "log" !== m2.type ? T.tree = n2(C) : T.ids = P, h(t3, e3);
          var O, I = function(t4, e4, r4, n3, a2, o3) {
            var s2 = p2.style(t4, r4);
            if (s2.marker && (s2.marker.positions = n3), s2.line && n3.length > 1 && i.extendFlat(s2.line, p2.linePositions(t4, r4, n3)), s2.errorX || s2.errorY) {
              var l3 = p2.errorBarPositions(t4, r4, n3, a2, o3);
              s2.errorX && i.extendFlat(s2.errorX, l3.x), s2.errorY && i.extendFlat(s2.errorY, l3.y);
            }
            return s2.text && (i.extendFlat(s2.text, { positions: n3 }, p2.textPosition(t4, r4, s2.text, s2.marker)), i.extendFlat(s2.textSel, { positions: n3 }, p2.textPosition(t4, r4, s2.text, s2.markerSel)), i.extendFlat(s2.textUnsel, { positions: n3 }, p2.textPosition(t4, r4, s2.text, s2.markerUnsel))), s2;
          }(t3, 0, e3, C, E, L), D = d2(t3, x);
          return f2(o2, e3), _ ? I.marker && (O = I.marker.sizeAvg || Math.max(I.marker.size, 3)) : O = u(e3, b), c(t3, e3, l2, m2, E, L, O), I.errorX && y(e3, l2, I.errorX), I.errorY && y(e3, m2, I.errorY), I.fill && !D.fill2d && (D.fill2d = true), I.marker && !D.scatter2d && (D.scatter2d = true), I.line && !D.line2d && (D.line2d = true), !I.errorX && !I.errorY || D.error2d || (D.error2d = true), I.text && !D.glText && (D.glText = true), I.marker && (I.marker.snap = b), D.lineOptions.push(I.line), D.errorXOptions.push(I.errorX), D.errorYOptions.push(I.errorY), D.fillOptions.push(I.fill), D.markerOptions.push(I.marker), D.markerSelectedOptions.push(I.markerSel), D.markerUnselectedOptions.push(I.markerUnsel), D.textOptions.push(I.text), D.textSelectedOptions.push(I.textSel), D.textUnselectedOptions.push(I.textUnsel), D.selectBatch.push([]), D.unselectBatch.push([]), T._scene = D, T.index = D.count, T.x = E, T.y = L, T.positions = C, D.count++, [{ x: false, y: false, t: T, trace: e3 }];
        };
      }, 78232: function(t2) {
        t2.exports = { TOO_MANY_POINTS: 1e5, SYMBOL_SDF_SIZE: 200, SYMBOL_SIZE: 20, SYMBOL_STROKE: 1, DOT_RE: /-dot/, OPEN_RE: /-open/, DASHES: { solid: [1], dot: [1, 1], dash: [4, 1], longdash: [8, 1], dashdot: [4, 1, 1, 1], longdashdot: [8, 1, 1, 1] } };
      }, 19635: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(82019), a = r2(25075), o = r2(73972), s = r2(71828), l = r2(91424), u = r2(41675), c = r2(81697).formatColor, f2 = r2(34098), h = r2(39984), p2 = r2(68645), d2 = r2(78232), v = r2(37822).DESELECTDIM, g2 = { start: 1, left: 1, end: -1, right: -1, middle: 0, center: 0, bottom: 1, top: -1 }, y = r2(23469).appendArrayPointValue;
        function m2(t3, e3) {
          var r3, i2 = t3._fullLayout, a2 = e3._length, o2 = e3.textfont, l2 = e3.textposition, u2 = Array.isArray(l2) ? l2 : [l2], c2 = o2.color, f3 = o2.size, h2 = o2.family, p3 = {}, d3 = t3._context.plotGlPixelRatio, v2 = e3.texttemplate;
          if (v2) {
            p3.text = [];
            var g3 = i2._d3locale, m3 = Array.isArray(v2), x2 = m3 ? Math.min(v2.length, a2) : a2, b2 = m3 ? function(t4) {
              return v2[t4];
            } : function() {
              return v2;
            };
            for (r3 = 0; r3 < x2; r3++) {
              var _2 = { i: r3 }, w3 = e3._module.formatLabels(_2, e3, i2), T2 = {};
              y(T2, e3, r3);
              var k2 = e3._meta || {};
              p3.text.push(s.texttemplateString(b2(r3), w3, g3, T2, _2, k2));
            }
          } else
            Array.isArray(e3.text) && e3.text.length < a2 ? p3.text = e3.text.slice() : p3.text = e3.text;
          if (Array.isArray(p3.text))
            for (r3 = p3.text.length; r3 < a2; r3++)
              p3.text[r3] = "";
          for (p3.opacity = e3.opacity, p3.font = {}, p3.align = [], p3.baseline = [], r3 = 0; r3 < u2.length; r3++) {
            var A2 = u2[r3].split(/\s+/);
            switch (A2[1]) {
              case "left":
                p3.align.push("right");
                break;
              case "right":
                p3.align.push("left");
                break;
              default:
                p3.align.push(A2[1]);
            }
            switch (A2[0]) {
              case "top":
                p3.baseline.push("bottom");
                break;
              case "bottom":
                p3.baseline.push("top");
                break;
              default:
                p3.baseline.push(A2[0]);
            }
          }
          if (Array.isArray(c2))
            for (p3.color = new Array(a2), r3 = 0; r3 < a2; r3++)
              p3.color[r3] = c2[r3];
          else
            p3.color = c2;
          if (s.isArrayOrTypedArray(f3) || Array.isArray(h2))
            for (p3.font = new Array(a2), r3 = 0; r3 < a2; r3++) {
              var M2 = p3.font[r3] = {};
              M2.size = (s.isTypedArray(f3) ? f3[r3] : Array.isArray(f3) ? n2(f3[r3]) ? f3[r3] : 0 : f3) * d3, M2.family = Array.isArray(h2) ? h2[r3] : h2;
            }
          else
            p3.font = { size: f3 * d3, family: h2 };
          return p3;
        }
        function x(t3, e3) {
          var r3, n3, i2 = e3._length, o2 = e3.marker, l2 = {}, u2 = s.isArrayOrTypedArray(o2.symbol), f3 = s.isArrayOrTypedArray(o2.angle), d3 = s.isArrayOrTypedArray(o2.color), v2 = s.isArrayOrTypedArray(o2.line.color), g3 = s.isArrayOrTypedArray(o2.opacity), y2 = s.isArrayOrTypedArray(o2.size), m3 = s.isArrayOrTypedArray(o2.line.width);
          if (u2 || (n3 = p2.isOpenSymbol(o2.symbol)), u2 || d3 || v2 || g3 || f3) {
            l2.symbols = new Array(i2), l2.angles = new Array(i2), l2.colors = new Array(i2), l2.borderColors = new Array(i2);
            var x2 = o2.symbol, b2 = o2.angle, _2 = c(o2, o2.opacity, i2), w3 = c(o2.line, o2.opacity, i2);
            if (!Array.isArray(w3[0])) {
              var T2 = w3;
              for (w3 = Array(i2), r3 = 0; r3 < i2; r3++)
                w3[r3] = T2;
            }
            if (!Array.isArray(_2[0])) {
              var k2 = _2;
              for (_2 = Array(i2), r3 = 0; r3 < i2; r3++)
                _2[r3] = k2;
            }
            if (!Array.isArray(x2)) {
              var A2 = x2;
              for (x2 = Array(i2), r3 = 0; r3 < i2; r3++)
                x2[r3] = A2;
            }
            if (!Array.isArray(b2)) {
              var M2 = b2;
              for (b2 = Array(i2), r3 = 0; r3 < i2; r3++)
                b2[r3] = M2;
            }
            for (l2.symbols = x2, l2.angles = b2, l2.colors = _2, l2.borderColors = w3, r3 = 0; r3 < i2; r3++)
              u2 && (n3 = p2.isOpenSymbol(o2.symbol[r3])), n3 && (w3[r3] = _2[r3].slice(), _2[r3] = _2[r3].slice(), _2[r3][3] = 0);
            for (l2.opacity = e3.opacity, l2.markers = new Array(i2), r3 = 0; r3 < i2; r3++)
              l2.markers[r3] = E({ mx: l2.symbols[r3], ma: l2.angles[r3] }, e3);
          } else
            n3 ? (l2.color = a(o2.color, "uint8"), l2.color[3] = 0, l2.borderColor = a(o2.color, "uint8")) : (l2.color = a(o2.color, "uint8"), l2.borderColor = a(o2.line.color, "uint8")), l2.opacity = e3.opacity * o2.opacity, l2.marker = E({ mx: o2.symbol, ma: o2.angle }, e3);
          var S2, L = h(e3, 1);
          if (y2 || m3) {
            var C, P = l2.sizes = new Array(i2), O = l2.borderSizes = new Array(i2), I = 0;
            if (y2) {
              for (r3 = 0; r3 < i2; r3++)
                P[r3] = L(o2.size[r3]), I += P[r3];
              C = I / i2;
            } else
              for (S2 = L(o2.size), r3 = 0; r3 < i2; r3++)
                P[r3] = S2;
            if (m3)
              for (r3 = 0; r3 < i2; r3++)
                O[r3] = o2.line.width[r3];
            else
              for (S2 = o2.line.width, r3 = 0; r3 < i2; r3++)
                O[r3] = S2;
            l2.sizeAvg = C;
          } else
            l2.size = L(o2 && o2.size || 10), l2.borderSizes = L(o2.line.width);
          return l2;
        }
        function b(t3, e3, r3) {
          var n3 = e3.marker, i2 = {};
          return r3 ? (r3.marker && r3.marker.symbol ? i2 = x(0, s.extendFlat({}, n3, r3.marker)) : r3.marker && (r3.marker.size && (i2.size = r3.marker.size), r3.marker.color && (i2.colors = r3.marker.color), void 0 !== r3.marker.opacity && (i2.opacity = r3.marker.opacity)), i2) : i2;
        }
        function _(t3, e3, r3) {
          var n3 = {};
          if (!r3)
            return n3;
          if (r3.textfont) {
            var i2 = { opacity: 1, text: e3.text, texttemplate: e3.texttemplate, textposition: e3.textposition, textfont: s.extendFlat({}, e3.textfont) };
            r3.textfont && s.extendFlat(i2.textfont, r3.textfont), n3 = m2(t3, i2);
          }
          return n3;
        }
        function w2(t3, e3, r3) {
          var n3 = { capSize: 2 * e3.width * r3, lineWidth: e3.thickness * r3, color: e3.color };
          return e3.copy_ystyle && (n3 = t3.error_y), n3;
        }
        var T = d2.SYMBOL_SDF_SIZE, k = d2.SYMBOL_SIZE, A = d2.SYMBOL_STROKE, M = {}, S = l.symbolFuncs[0](0.05 * k);
        function E(t3, e3) {
          var r3, n3, a2 = t3.mx;
          if ("circle" === a2)
            return null;
          var o2 = l.symbolNumber(a2), s2 = l.symbolFuncs[o2 % 100], u2 = !!l.symbolNoDot[o2 % 100], c2 = !!l.symbolNoFill[o2 % 100], f3 = p2.isDotSymbol(a2);
          if (t3.ma && (a2 += "_" + t3.ma), M[a2])
            return M[a2];
          var h2 = l.getMarkerAngle(t3, e3);
          return r3 = f3 && !u2 ? s2(1.1 * k, h2) + S : s2(k, h2), n3 = i(r3, { w: T, h: T, viewBox: [-k, -k, k, k], stroke: c2 ? A : -A }), M[a2] = n3, n3 || null;
        }
        t2.exports = { style: function(t3, e3) {
          var r3, n3 = { marker: void 0, markerSel: void 0, markerUnsel: void 0, line: void 0, fill: void 0, errorX: void 0, errorY: void 0, text: void 0, textSel: void 0, textUnsel: void 0 }, i2 = t3._context.plotGlPixelRatio;
          if (true !== e3.visible)
            return n3;
          if (f2.hasText(e3) && (n3.text = m2(t3, e3), n3.textSel = _(t3, e3, e3.selected), n3.textUnsel = _(t3, e3, e3.unselected)), f2.hasMarkers(e3) && (n3.marker = x(0, e3), n3.markerSel = b(0, e3, e3.selected), n3.markerUnsel = b(0, e3, e3.unselected), !e3.unselected && s.isArrayOrTypedArray(e3.marker.opacity))) {
            var a2 = e3.marker.opacity;
            for (n3.markerUnsel.opacity = new Array(a2.length), r3 = 0; r3 < a2.length; r3++)
              n3.markerUnsel.opacity[r3] = v * a2[r3];
          }
          if (f2.hasLines(e3)) {
            n3.line = { overlay: true, thickness: e3.line.width * i2, color: e3.line.color, opacity: e3.opacity };
            var o2 = (d2.DASHES[e3.line.dash] || [1]).slice();
            for (r3 = 0; r3 < o2.length; ++r3)
              o2[r3] *= e3.line.width * i2;
            n3.line.dashes = o2;
          }
          return e3.error_x && e3.error_x.visible && (n3.errorX = w2(e3, e3.error_x, i2)), e3.error_y && e3.error_y.visible && (n3.errorY = w2(e3, e3.error_y, i2)), e3.fill && "none" !== e3.fill && (n3.fill = { closed: true, fill: e3.fillcolor, thickness: 0 }), n3;
        }, markerStyle: x, markerSelection: b, linePositions: function(t3, e3, r3) {
          var n3, i2, a2 = r3.length, o2 = a2 / 2;
          if (f2.hasLines(e3) && o2)
            if ("hv" === e3.line.shape) {
              for (n3 = [], i2 = 0; i2 < o2 - 1; i2++)
                isNaN(r3[2 * i2]) || isNaN(r3[2 * i2 + 1]) ? n3.push(NaN, NaN, NaN, NaN) : (n3.push(r3[2 * i2], r3[2 * i2 + 1]), isNaN(r3[2 * i2 + 2]) || isNaN(r3[2 * i2 + 3]) ? n3.push(NaN, NaN) : n3.push(r3[2 * i2 + 2], r3[2 * i2 + 1]));
              n3.push(r3[a2 - 2], r3[a2 - 1]);
            } else if ("hvh" === e3.line.shape) {
              for (n3 = [], i2 = 0; i2 < o2 - 1; i2++)
                if (isNaN(r3[2 * i2]) || isNaN(r3[2 * i2 + 1]) || isNaN(r3[2 * i2 + 2]) || isNaN(r3[2 * i2 + 3]))
                  isNaN(r3[2 * i2]) || isNaN(r3[2 * i2 + 1]) ? n3.push(NaN, NaN) : n3.push(r3[2 * i2], r3[2 * i2 + 1]), n3.push(NaN, NaN);
                else {
                  var s2 = (r3[2 * i2] + r3[2 * i2 + 2]) / 2;
                  n3.push(r3[2 * i2], r3[2 * i2 + 1], s2, r3[2 * i2 + 1], s2, r3[2 * i2 + 3]);
                }
              n3.push(r3[a2 - 2], r3[a2 - 1]);
            } else if ("vhv" === e3.line.shape) {
              for (n3 = [], i2 = 0; i2 < o2 - 1; i2++)
                if (isNaN(r3[2 * i2]) || isNaN(r3[2 * i2 + 1]) || isNaN(r3[2 * i2 + 2]) || isNaN(r3[2 * i2 + 3]))
                  isNaN(r3[2 * i2]) || isNaN(r3[2 * i2 + 1]) ? n3.push(NaN, NaN) : n3.push(r3[2 * i2], r3[2 * i2 + 1]), n3.push(NaN, NaN);
                else {
                  var l2 = (r3[2 * i2 + 1] + r3[2 * i2 + 3]) / 2;
                  n3.push(r3[2 * i2], r3[2 * i2 + 1], r3[2 * i2], l2, r3[2 * i2 + 2], l2);
                }
              n3.push(r3[a2 - 2], r3[a2 - 1]);
            } else if ("vh" === e3.line.shape) {
              for (n3 = [], i2 = 0; i2 < o2 - 1; i2++)
                isNaN(r3[2 * i2]) || isNaN(r3[2 * i2 + 1]) ? n3.push(NaN, NaN, NaN, NaN) : (n3.push(r3[2 * i2], r3[2 * i2 + 1]), isNaN(r3[2 * i2 + 2]) || isNaN(r3[2 * i2 + 3]) ? n3.push(NaN, NaN) : n3.push(r3[2 * i2], r3[2 * i2 + 3]));
              n3.push(r3[a2 - 2], r3[a2 - 1]);
            } else
              n3 = r3;
          var u2 = false;
          for (i2 = 0; i2 < n3.length; i2++)
            if (isNaN(n3[i2])) {
              u2 = true;
              break;
            }
          var c2 = u2 || n3.length > d2.TOO_MANY_POINTS || f2.hasMarkers(e3) ? "rect" : "round";
          if (u2 && e3.connectgaps) {
            var h2 = n3[0], p3 = n3[1];
            for (i2 = 0; i2 < n3.length; i2 += 2)
              isNaN(n3[i2]) || isNaN(n3[i2 + 1]) ? (n3[i2] = h2, n3[i2 + 1] = p3) : (h2 = n3[i2], p3 = n3[i2 + 1]);
          }
          return { join: c2, positions: n3 };
        }, errorBarPositions: function(t3, e3, r3, i2, a2) {
          var s2 = o.getComponentMethod("errorbars", "makeComputeError"), l2 = u.getFromId(t3, e3.xaxis, "x"), c2 = u.getFromId(t3, e3.yaxis, "y"), f3 = r3.length / 2, h2 = {};
          function p3(t4, i3) {
            var a3 = i3._id.charAt(0), o2 = e3["error_" + a3];
            if (o2 && o2.visible && ("linear" === i3.type || "log" === i3.type)) {
              for (var l3 = s2(o2), u2 = { x: 0, y: 1 }[a3], c3 = { x: [0, 1, 2, 3], y: [2, 3, 0, 1] }[a3], p4 = new Float64Array(4 * f3), d3 = 1 / 0, v2 = -1 / 0, g3 = 0, y2 = 0; g3 < f3; g3++, y2 += 4) {
                var m3 = t4[g3];
                if (n2(m3)) {
                  var x2 = r3[2 * g3 + u2], b2 = l3(m3, g3), _2 = b2[0], w3 = b2[1];
                  if (n2(_2) && n2(w3)) {
                    var T2 = m3 - _2, k2 = m3 + w3;
                    p4[y2 + c3[0]] = x2 - i3.c2l(T2), p4[y2 + c3[1]] = i3.c2l(k2) - x2, p4[y2 + c3[2]] = 0, p4[y2 + c3[3]] = 0, d3 = Math.min(d3, m3 - _2), v2 = Math.max(v2, m3 + w3);
                  }
                }
              }
              h2[a3] = { positions: r3, errors: p4, _bnds: [d3, v2] };
            }
          }
          return p3(i2, l2), p3(a2, c2), h2;
        }, textPosition: function(t3, e3, r3, n3) {
          var i2, a2 = e3._length, o2 = {};
          if (f2.hasMarkers(e3)) {
            var s2 = r3.font, l2 = r3.align, u2 = r3.baseline;
            for (o2.offset = new Array(a2), i2 = 0; i2 < a2; i2++) {
              var c2 = n3.sizes ? n3.sizes[i2] : n3.size, h2 = Array.isArray(s2) ? s2[i2].size : s2.size, p3 = Array.isArray(l2) ? l2.length > 1 ? l2[i2] : l2[0] : l2, d3 = Array.isArray(u2) ? u2.length > 1 ? u2[i2] : u2[0] : u2, v2 = g2[p3], y2 = g2[d3], m3 = c2 ? c2 / 0.8 + 1 : 0, x2 = -y2 * m3 - 0.5 * y2;
              o2.offset[i2] = [v2 * m3 / h2, x2 / h2];
            }
          }
          return o2;
        } };
      }, 47148: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(73972), a = r2(68645), o = r2(42341), s = r2(47581), l = r2(34098), u = r2(67513), c = r2(73927), f2 = r2(49508), h = r2(11058), p2 = r2(28908), d2 = r2(82410);
        t2.exports = function(t3, e3, r3, v) {
          function g2(r4, i2) {
            return n2.coerce(t3, e3, o, r4, i2);
          }
          var y = !!t3.marker && a.isOpenSymbol(t3.marker.symbol), m2 = l.isBubble(t3), x = u(t3, e3, v, g2);
          if (x) {
            c(t3, e3, v, g2), g2("xhoverformat"), g2("yhoverformat");
            var b = x < s.PTS_LINESONLY ? "lines+markers" : "lines";
            g2("text"), g2("hovertext"), g2("hovertemplate"), g2("mode", b), l.hasLines(e3) && (g2("connectgaps"), h(t3, e3, r3, v, g2), g2("line.shape")), l.hasMarkers(e3) && (f2(t3, e3, r3, v, g2, { noAngleRef: true, noStandOff: true }), g2("marker.line.width", y || m2 ? 1 : 0)), l.hasText(e3) && (g2("texttemplate"), d2(t3, e3, v, g2));
            var _ = (e3.line || {}).color, w2 = (e3.marker || {}).color;
            g2("fill"), "none" !== e3.fill && p2(t3, e3, r3, g2);
            var T = i.getComponentMethod("errorbars", "supplyDefaults");
            T(t3, e3, _ || w2 || r3, { axis: "y" }), T(t3, e3, _ || w2 || r3, { axis: "x", inherit: "y" }), n2.coerceSelectionMarkerOpacity(e3, g2);
          } else
            e3.visible = false;
        };
      }, 5345: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901), a = r2(37822).DESELECTDIM;
        t2.exports = { styleTextSelection: function(t3) {
          var e3, r3, o = t3[0], s = o.trace, l = o.t, u = l._scene, c = l.index, f2 = u.selectBatch[c], h = u.unselectBatch[c], p2 = u.textOptions[c], d2 = u.textSelectedOptions[c] || {}, v = u.textUnselectedOptions[c] || {}, g2 = n2.extendFlat({}, p2);
          if (f2.length || h.length) {
            var y = d2.color, m2 = v.color, x = p2.color, b = Array.isArray(x);
            for (g2.color = new Array(s._length), e3 = 0; e3 < f2.length; e3++)
              r3 = f2[e3], g2.color[r3] = y || (b ? x[r3] : x);
            for (e3 = 0; e3 < h.length; e3++) {
              r3 = h[e3];
              var _ = b ? x[r3] : x;
              g2.color[r3] = m2 || (y ? _ : i.addOpacity(_, a));
            }
          }
          u.glText[c].update(g2);
        } };
      }, 68101: function(t2, e2, r2) {
        var n2 = r2(8225);
        t2.exports = function(t3, e3, r3) {
          var i = t3.i;
          return "x" in t3 || (t3.x = e3._x[i]), "y" in t3 || (t3.y = e3._y[i]), n2(t3, e3, r3);
        };
      }, 68645: function(t2, e2, r2) {
        var n2 = r2(78232);
        e2.isOpenSymbol = function(t3) {
          return "string" == typeof t3 ? n2.OPEN_RE.test(t3) : t3 % 200 > 100;
        }, e2.isDotSymbol = function(t3) {
          return "string" == typeof t3 ? n2.DOT_RE.test(t3) : t3 > 200;
        };
      }, 20794: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828), a = r2(34603);
        function o(t3, e3, r3, o2) {
          var s = t3.xa, l = t3.ya, u = t3.distance, c = t3.dxy, f2 = t3.index, h = { pointNumber: f2, x: e3[f2], y: r3[f2] };
          h.tx = Array.isArray(o2.text) ? o2.text[f2] : o2.text, h.htx = Array.isArray(o2.hovertext) ? o2.hovertext[f2] : o2.hovertext, h.data = Array.isArray(o2.customdata) ? o2.customdata[f2] : o2.customdata, h.tp = Array.isArray(o2.textposition) ? o2.textposition[f2] : o2.textposition;
          var p2 = o2.textfont;
          p2 && (h.ts = i.isArrayOrTypedArray(p2.size) ? p2.size[f2] : p2.size, h.tc = Array.isArray(p2.color) ? p2.color[f2] : p2.color, h.tf = Array.isArray(p2.family) ? p2.family[f2] : p2.family);
          var d2 = o2.marker;
          d2 && (h.ms = i.isArrayOrTypedArray(d2.size) ? d2.size[f2] : d2.size, h.mo = i.isArrayOrTypedArray(d2.opacity) ? d2.opacity[f2] : d2.opacity, h.mx = i.isArrayOrTypedArray(d2.symbol) ? d2.symbol[f2] : d2.symbol, h.ma = i.isArrayOrTypedArray(d2.angle) ? d2.angle[f2] : d2.angle, h.mc = i.isArrayOrTypedArray(d2.color) ? d2.color[f2] : d2.color);
          var v = d2 && d2.line;
          v && (h.mlc = Array.isArray(v.color) ? v.color[f2] : v.color, h.mlw = i.isArrayOrTypedArray(v.width) ? v.width[f2] : v.width);
          var g2 = d2 && d2.gradient;
          g2 && "none" !== g2.type && (h.mgt = Array.isArray(g2.type) ? g2.type[f2] : g2.type, h.mgc = Array.isArray(g2.color) ? g2.color[f2] : g2.color);
          var y = s.c2p(h.x, true), m2 = l.c2p(h.y, true), x = h.mrc || 1, b = o2.hoverlabel;
          b && (h.hbg = Array.isArray(b.bgcolor) ? b.bgcolor[f2] : b.bgcolor, h.hbc = Array.isArray(b.bordercolor) ? b.bordercolor[f2] : b.bordercolor, h.hts = i.isArrayOrTypedArray(b.font.size) ? b.font.size[f2] : b.font.size, h.htc = Array.isArray(b.font.color) ? b.font.color[f2] : b.font.color, h.htf = Array.isArray(b.font.family) ? b.font.family[f2] : b.font.family, h.hnl = i.isArrayOrTypedArray(b.namelength) ? b.namelength[f2] : b.namelength);
          var _ = o2.hoverinfo;
          _ && (h.hi = Array.isArray(_) ? _[f2] : _);
          var w2 = o2.hovertemplate;
          w2 && (h.ht = Array.isArray(w2) ? w2[f2] : w2);
          var T = {};
          T[t3.index] = h;
          var k = o2._origX, A = o2._origY, M = i.extendFlat({}, t3, { color: a(o2, h), x0: y - x, x1: y + x, xLabelVal: k ? k[f2] : h.x, y0: m2 - x, y1: m2 + x, yLabelVal: A ? A[f2] : h.y, cd: T, distance: u, spikeDistance: c, hovertemplate: h.ht });
          return h.htx ? M.text = h.htx : h.tx ? M.text = h.tx : o2.text && (M.text = o2.text), i.fillText(h, o2, M), n2.getComponentMethod("errorbars", "hoverInfo")(h, o2, M), M;
        }
        t2.exports = { hoverPoints: function(t3, e3, r3, n3) {
          var i2, a2, s, l, u, c, f2, h, p2, d2, v = t3.cd, g2 = v[0].t, y = v[0].trace, m2 = t3.xa, x = t3.ya, b = g2.x, _ = g2.y, w2 = m2.c2p(e3), T = x.c2p(r3), k = t3.distance;
          if (g2.tree) {
            var A = m2.p2c(w2 - k), M = m2.p2c(w2 + k), S = x.p2c(T - k), E = x.p2c(T + k);
            i2 = "x" === n3 ? g2.tree.range(Math.min(A, M), Math.min(x._rl[0], x._rl[1]), Math.max(A, M), Math.max(x._rl[0], x._rl[1])) : g2.tree.range(Math.min(A, M), Math.min(S, E), Math.max(A, M), Math.max(S, E));
          } else
            i2 = g2.ids;
          var L = k;
          if ("x" === n3) {
            var C = !!y.xperiodalignment, P = !!y.yperiodalignment;
            for (c = 0; c < i2.length; c++) {
              if (l = b[a2 = i2[c]], f2 = Math.abs(m2.c2p(l) - w2), C) {
                var O = m2.c2p(y._xStarts[a2]), I = m2.c2p(y._xEnds[a2]);
                f2 = w2 >= Math.min(O, I) && w2 <= Math.max(O, I) ? 0 : 1 / 0;
              }
              if (f2 < L) {
                if (L = f2, u = _[a2], h = x.c2p(u) - T, P) {
                  var D = x.c2p(y._yStarts[a2]), z = x.c2p(y._yEnds[a2]);
                  h = T >= Math.min(D, z) && T <= Math.max(D, z) ? 0 : 1 / 0;
                }
                d2 = Math.sqrt(f2 * f2 + h * h), s = i2[c];
              }
            }
          } else
            for (c = i2.length - 1; c > -1; c--)
              l = b[a2 = i2[c]], u = _[a2], f2 = m2.c2p(l) - w2, h = x.c2p(u) - T, (p2 = Math.sqrt(f2 * f2 + h * h)) < L && (L = d2 = p2, s = a2);
          return t3.index = s, t3.distance = L, t3.dxy = d2, void 0 === s ? [t3] : [o(t3, b, _, y)];
        }, calcHover: o };
      }, 68868: function(t2, e2, r2) {
        var n2 = r2(72156);
        n2.plot = r2(26787), t2.exports = n2;
      }, 26787: function(t2, e2, r2) {
        var n2 = r2(11870), i = r2(46075), a = r2(3593), o = r2(42505), s = r2(71828), l = r2(64505).selectMode, u = r2(79749), c = r2(34098), f2 = r2(68687), h = r2(5345).styleTextSelection, p2 = {};
        function d2(t3, e3, r3, n3) {
          var i2 = t3._size, a2 = t3.width * n3, o2 = t3.height * n3, s2 = i2.l * n3, l2 = i2.b * n3, u2 = i2.r * n3, c2 = i2.t * n3, f3 = i2.w * n3, h2 = i2.h * n3;
          return [s2 + e3.domain[0] * f3, l2 + r3.domain[0] * h2, a2 - u2 - (1 - e3.domain[1]) * f3, o2 - c2 - (1 - r3.domain[1]) * h2];
        }
        (t2.exports = function(t3, e3, r3) {
          if (r3.length) {
            var v, g2, y = t3._fullLayout, m2 = e3._scene, x = e3.xaxis, b = e3.yaxis;
            if (m2)
              if (u(t3, ["ANGLE_instanced_arrays", "OES_element_index_uint"], p2)) {
                var _ = m2.count, w2 = y._glcanvas.data()[0].regl;
                if (f2(t3, e3, r3), m2.dirty) {
                  if (true === m2.error2d && (m2.error2d = a(w2)), true === m2.line2d && (m2.line2d = i(w2)), true === m2.scatter2d && (m2.scatter2d = n2(w2)), true === m2.fill2d && (m2.fill2d = i(w2)), true === m2.glText)
                    for (m2.glText = new Array(_), v = 0; v < _; v++)
                      m2.glText[v] = new o(w2);
                  if (m2.glText) {
                    if (_ > m2.glText.length) {
                      var T = _ - m2.glText.length;
                      for (v = 0; v < T; v++)
                        m2.glText.push(new o(w2));
                    } else if (_ < m2.glText.length) {
                      var k = m2.glText.length - _;
                      m2.glText.splice(_, k).forEach(function(t4) {
                        t4.destroy();
                      });
                    }
                    for (v = 0; v < _; v++)
                      m2.glText[v].update(m2.textOptions[v]);
                  }
                  if (m2.line2d && (m2.line2d.update(m2.lineOptions), m2.lineOptions = m2.lineOptions.map(function(t4) {
                    if (t4 && t4.positions) {
                      for (var e4 = t4.positions, r4 = 0; r4 < e4.length && (isNaN(e4[r4]) || isNaN(e4[r4 + 1])); )
                        r4 += 2;
                      for (var n3 = e4.length - 2; n3 > r4 && (isNaN(e4[n3]) || isNaN(e4[n3 + 1])); )
                        n3 -= 2;
                      t4.positions = e4.slice(r4, n3 + 2);
                    }
                    return t4;
                  }), m2.line2d.update(m2.lineOptions)), m2.error2d) {
                    var A = (m2.errorXOptions || []).concat(m2.errorYOptions || []);
                    m2.error2d.update(A);
                  }
                  m2.scatter2d && m2.scatter2d.update(m2.markerOptions), m2.fillOrder = s.repeat(null, _), m2.fill2d && (m2.fillOptions = m2.fillOptions.map(function(t4, e4) {
                    var n3 = r3[e4];
                    if (t4 && n3 && n3[0] && n3[0].trace) {
                      var i2, a2, o2 = n3[0], s2 = o2.trace, l2 = o2.t, u2 = m2.lineOptions[e4], c2 = [];
                      s2._ownfill && c2.push(e4), s2._nexttrace && c2.push(e4 + 1), c2.length && (m2.fillOrder[e4] = c2);
                      var f3, h2, p3 = [], d3 = u2 && u2.positions || l2.positions;
                      if ("tozeroy" === s2.fill) {
                        for (f3 = 0; f3 < d3.length && isNaN(d3[f3 + 1]); )
                          f3 += 2;
                        for (h2 = d3.length - 2; h2 > f3 && isNaN(d3[h2 + 1]); )
                          h2 -= 2;
                        0 !== d3[f3 + 1] && (p3 = [d3[f3], 0]), p3 = p3.concat(d3.slice(f3, h2 + 2)), 0 !== d3[h2 + 1] && (p3 = p3.concat([d3[h2], 0]));
                      } else if ("tozerox" === s2.fill) {
                        for (f3 = 0; f3 < d3.length && isNaN(d3[f3]); )
                          f3 += 2;
                        for (h2 = d3.length - 2; h2 > f3 && isNaN(d3[h2]); )
                          h2 -= 2;
                        0 !== d3[f3] && (p3 = [0, d3[f3 + 1]]), p3 = p3.concat(d3.slice(f3, h2 + 2)), 0 !== d3[h2] && (p3 = p3.concat([0, d3[h2 + 1]]));
                      } else if ("toself" === s2.fill || "tonext" === s2.fill) {
                        for (p3 = [], i2 = 0, t4.splitNull = true, a2 = 0; a2 < d3.length; a2 += 2)
                          (isNaN(d3[a2]) || isNaN(d3[a2 + 1])) && ((p3 = p3.concat(d3.slice(i2, a2))).push(d3[i2], d3[i2 + 1]), p3.push(null, null), i2 = a2 + 2);
                        p3 = p3.concat(d3.slice(i2)), i2 && p3.push(d3[i2], d3[i2 + 1]);
                      } else {
                        var v2 = s2._nexttrace;
                        if (v2) {
                          var g3 = m2.lineOptions[e4 + 1];
                          if (g3) {
                            var y2 = g3.positions;
                            if ("tonexty" === s2.fill) {
                              for (p3 = d3.slice(), e4 = Math.floor(y2.length / 2); e4--; ) {
                                var x2 = y2[2 * e4], b2 = y2[2 * e4 + 1];
                                isNaN(x2) || isNaN(b2) || p3.push(x2, b2);
                              }
                              t4.fill = v2.fillcolor;
                            }
                          }
                        }
                      }
                      if (s2._prevtrace && "tonext" === s2._prevtrace.fill) {
                        var _2 = m2.lineOptions[e4 - 1].positions, w3 = p3.length / 2, T2 = [i2 = w3];
                        for (a2 = 0; a2 < _2.length; a2 += 2)
                          (isNaN(_2[a2]) || isNaN(_2[a2 + 1])) && (T2.push(a2 / 2 + w3 + 1), i2 = a2 + 2);
                        p3 = p3.concat(_2), t4.hole = T2;
                      }
                      return t4.fillmode = s2.fill, t4.opacity = s2.opacity, t4.positions = p3, t4;
                    }
                  }), m2.fill2d.update(m2.fillOptions));
                }
                var M = y.dragmode, S = l(M), E = y.clickmode.indexOf("select") > -1;
                for (v = 0; v < _; v++) {
                  var L = r3[v][0], C = L.trace, P = L.t, O = P.index, I = C._length, D = P.x, z = P.y;
                  if (C.selectedpoints || S || E) {
                    if (S || (S = true), C.selectedpoints) {
                      var R = m2.selectBatch[O] = s.selIndices2selPoints(C), F = {};
                      for (g2 = 0; g2 < R.length; g2++)
                        F[R[g2]] = 1;
                      var B = [];
                      for (g2 = 0; g2 < I; g2++)
                        F[g2] || B.push(g2);
                      m2.unselectBatch[O] = B;
                    }
                    var N = P.xpx = new Array(I), j = P.ypx = new Array(I);
                    for (g2 = 0; g2 < I; g2++)
                      N[g2] = x.c2p(D[g2]), j[g2] = b.c2p(z[g2]);
                  } else
                    P.xpx = P.ypx = null;
                }
                if (S) {
                  if (m2.select2d || (m2.select2d = n2(y._glcanvas.data()[1].regl)), m2.scatter2d) {
                    var U = new Array(_);
                    for (v = 0; v < _; v++)
                      U[v] = m2.selectBatch[v].length || m2.unselectBatch[v].length ? m2.markerUnselectedOptions[v] : {};
                    m2.scatter2d.update(U);
                  }
                  m2.select2d && (m2.select2d.update(m2.markerOptions), m2.select2d.update(m2.markerSelectedOptions)), m2.glText && r3.forEach(function(t4) {
                    var e4 = ((t4 || [])[0] || {}).trace || {};
                    c.hasText(e4) && h(t4);
                  });
                } else
                  m2.scatter2d && m2.scatter2d.update(m2.markerOptions);
                var V = { viewport: d2(y, x, b, t3._context.plotGlPixelRatio), range: [(x._rl || x.range)[0], (b._rl || b.range)[0], (x._rl || x.range)[1], (b._rl || b.range)[1]] }, H = s.repeat(V, m2.count);
                m2.fill2d && m2.fill2d.update(H), m2.line2d && m2.line2d.update(H), m2.error2d && m2.error2d.update(H.concat(H)), m2.scatter2d && m2.scatter2d.update(H), m2.select2d && m2.select2d.update(H), m2.glText && m2.glText.forEach(function(t4) {
                  t4.update(V);
                });
              } else
                m2.init();
          }
        }).reglPrecompiled = p2;
      }, 38967: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = function(t3, e3) {
          var r3 = e3._scene, i = { count: 0, dirty: true, lineOptions: [], fillOptions: [], markerOptions: [], markerSelectedOptions: [], markerUnselectedOptions: [], errorXOptions: [], errorYOptions: [], textOptions: [], textSelectedOptions: [], textUnselectedOptions: [], selectBatch: [], unselectBatch: [] }, a = { fill2d: false, scatter2d: false, error2d: false, line2d: false, glText: false, select2d: false };
          return e3._scene || ((r3 = e3._scene = {}).init = function() {
            n2.extendFlat(r3, a, i);
          }, r3.init(), r3.update = function(t4) {
            var e4 = n2.repeat(t4, r3.count);
            if (r3.fill2d && r3.fill2d.update(e4), r3.scatter2d && r3.scatter2d.update(e4), r3.line2d && r3.line2d.update(e4), r3.error2d && r3.error2d.update(e4.concat(e4)), r3.select2d && r3.select2d.update(e4), r3.glText)
              for (var i2 = 0; i2 < r3.count; i2++)
                r3.glText[i2].update(t4);
          }, r3.draw = function() {
            for (var t4 = r3.count, e4 = r3.fill2d, i2 = r3.error2d, a2 = r3.line2d, o = r3.scatter2d, s = r3.glText, l = r3.select2d, u = r3.selectBatch, c = r3.unselectBatch, f2 = 0; f2 < t4; f2++) {
              if (e4 && r3.fillOrder[f2] && e4.draw(r3.fillOrder[f2]), a2 && r3.lineOptions[f2] && a2.draw(f2), i2 && (r3.errorXOptions[f2] && i2.draw(f2), r3.errorYOptions[f2] && i2.draw(f2 + t4)), o && r3.markerOptions[f2])
                if (c[f2].length) {
                  var h = n2.repeat([], r3.count);
                  h[f2] = c[f2], o.draw(h);
                } else
                  u[f2].length || o.draw(f2);
              s[f2] && r3.textOptions[f2] && s[f2].render();
            }
            l && l.draw(u), r3.dirty = false;
          }, r3.destroy = function() {
            r3.fill2d && r3.fill2d.destroy && r3.fill2d.destroy(), r3.scatter2d && r3.scatter2d.destroy && r3.scatter2d.destroy(), r3.error2d && r3.error2d.destroy && r3.error2d.destroy(), r3.line2d && r3.line2d.destroy && r3.line2d.destroy(), r3.select2d && r3.select2d.destroy && r3.select2d.destroy(), r3.glText && r3.glText.forEach(function(t4) {
              t4.destroy && t4.destroy();
            }), r3.lineOptions = null, r3.fillOptions = null, r3.markerOptions = null, r3.markerSelectedOptions = null, r3.markerUnselectedOptions = null, r3.errorXOptions = null, r3.errorYOptions = null, r3.textOptions = null, r3.textSelectedOptions = null, r3.textUnselectedOptions = null, r3.selectBatch = null, r3.unselectBatch = null, e3._scene = null;
          }), r3.dirty || n2.extendFlat(r3, i), r3;
        };
      }, 58147: function(t2, e2, r2) {
        var n2 = r2(34098), i = r2(5345).styleTextSelection;
        t2.exports = function(t3, e3) {
          var r3 = t3.cd, a = t3.xaxis, o = t3.yaxis, s = [], l = r3[0].trace, u = r3[0].t, c = l._length, f2 = u.x, h = u.y, p2 = u._scene, d2 = u.index;
          if (!p2)
            return s;
          var v = n2.hasText(l), g2 = n2.hasMarkers(l), y = !g2 && !v;
          if (true !== l.visible || y)
            return s;
          var m2 = [], x = [];
          if (false !== e3 && !e3.degenerate)
            for (var b = 0; b < c; b++)
              e3.contains([u.xpx[b], u.ypx[b]], false, b, t3) ? (m2.push(b), s.push({ pointNumber: b, x: a.c2d(f2[b]), y: o.c2d(h[b]) })) : x.push(b);
          if (g2) {
            var _ = p2.scatter2d;
            if (m2.length || x.length) {
              if (!p2.selectBatch[d2].length && !p2.unselectBatch[d2].length) {
                var w2 = new Array(p2.count);
                w2[d2] = p2.markerUnselectedOptions[d2], _.update.apply(_, w2);
              }
            } else {
              var T = new Array(p2.count);
              T[d2] = p2.markerOptions[d2], _.update.apply(_, T);
            }
          }
          return p2.selectBatch[d2] = m2, p2.unselectBatch[d2] = x, v && i(r3), s;
        };
      }, 99181: function(t2, e2, r2) {
        var n2 = r2(5386).f, i = r2(5386).s, a = r2(19316), o = r2(82196), s = r2(23585), l = r2(9012), u = r2(50693), c = r2(1426).extendFlat, f2 = r2(30962).overrideAll, h = r2(23585), p2 = a.line, d2 = a.marker;
        t2.exports = f2({ lon: a.lon, lat: a.lat, cluster: { enabled: { valType: "boolean" }, maxzoom: c({}, h.layers.maxzoom, {}), step: { valType: "number", arrayOk: true, dflt: -1, min: -1 }, size: { valType: "number", arrayOk: true, dflt: 20, min: 0 }, color: { valType: "color", arrayOk: true }, opacity: c({}, d2.opacity, { dflt: 1 }) }, mode: c({}, o.mode, { dflt: "markers" }), text: c({}, o.text, {}), texttemplate: i({ editType: "plot" }, { keys: ["lat", "lon", "text"] }), hovertext: c({}, o.hovertext, {}), line: { color: p2.color, width: p2.width }, connectgaps: o.connectgaps, marker: c({ symbol: { valType: "string", dflt: "circle", arrayOk: true }, angle: { valType: "number", dflt: "auto", arrayOk: true }, allowoverlap: { valType: "boolean", dflt: false }, opacity: d2.opacity, size: d2.size, sizeref: d2.sizeref, sizemin: d2.sizemin, sizemode: d2.sizemode }, u("marker")), fill: a.fill, fillcolor: o.fillcolor, textfont: s.layers.symbol.textfont, textposition: s.layers.symbol.textposition, below: { valType: "string" }, selected: { marker: o.selected.marker }, unselected: { marker: o.unselected.marker }, hoverinfo: c({}, l.hoverinfo, { flags: ["lon", "lat", "text", "name"] }), hovertemplate: n2() }, "calc", "nested");
      }, 15790: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(71828), a = r2(50606).BADNUM, o = r2(18214), s = r2(21081), l = r2(91424), u = r2(39984), c = r2(34098), f2 = r2(13056), h = r2(23469).appendArrayPointValue, p2 = r2(63893).NEWLINES, d2 = r2(63893).BR_TAG_ALL;
        function v(t3) {
          return { type: t3, geojson: o.makeBlank(), layout: { visibility: "none" }, filter: null, paint: {} };
        }
        function g2(t3, e3) {
          return i.isArrayOrTypedArray(t3) ? e3 ? function(e4) {
            return n2(t3[e4]) ? +t3[e4] : 0;
          } : function(e4) {
            return t3[e4];
          } : t3 ? function() {
            return t3;
          } : y;
        }
        function y() {
          return "";
        }
        function m2(t3) {
          return t3[0] === a;
        }
        function x(t3, e3) {
          var r3;
          if (i.isArrayOrTypedArray(t3) && i.isArrayOrTypedArray(e3)) {
            r3 = ["step", ["get", "point_count"], t3[0]];
            for (var n3 = 1; n3 < t3.length; n3++)
              r3.push(e3[n3 - 1], t3[n3]);
          } else
            r3 = t3;
          return r3;
        }
        t2.exports = function(t3, e3) {
          var r3, a2 = e3[0].trace, b = true === a2.visible && 0 !== a2._length, _ = "none" !== a2.fill, w2 = c.hasLines(a2), T = c.hasMarkers(a2), k = c.hasText(a2), A = T && "circle" === a2.marker.symbol, M = T && "circle" !== a2.marker.symbol, S = a2.cluster && a2.cluster.enabled, E = v("fill"), L = v("line"), C = v("circle"), P = v("symbol"), O = { fill: E, line: L, circle: C, symbol: P };
          if (!b)
            return O;
          if ((_ || w2) && (r3 = o.calcTraceToLineCoords(e3)), _ && (E.geojson = o.makePolygon(r3), E.layout.visibility = "visible", i.extendFlat(E.paint, { "fill-color": a2.fillcolor })), w2 && (L.geojson = o.makeLine(r3), L.layout.visibility = "visible", i.extendFlat(L.paint, { "line-width": a2.line.width, "line-color": a2.line.color, "line-opacity": a2.opacity })), A) {
            var I = function(t4) {
              var e4, r4, a3, o2, c2 = t4[0].trace, f3 = c2.marker, h2 = c2.selectedpoints, p3 = i.isArrayOrTypedArray(f3.color), d3 = i.isArrayOrTypedArray(f3.size), v2 = i.isArrayOrTypedArray(f3.opacity);
              function g3(t5) {
                return c2.opacity * t5;
              }
              p3 && (r4 = s.hasColorscale(c2, "marker") ? s.makeColorScaleFuncFromTrace(f3) : i.identity), d3 && (a3 = u(c2)), v2 && (o2 = function(t5) {
                return g3(n2(t5) ? +i.constrain(t5, 0, 1) : 0);
              });
              var y2, x2, b2 = [];
              for (e4 = 0; e4 < t4.length; e4++) {
                var _2 = t4[e4], w3 = _2.lonlat;
                if (!m2(w3)) {
                  var T2 = {};
                  r4 && (T2.mcc = _2.mcc = r4(_2.mc)), a3 && (T2.mrc = _2.mrc = a3(_2.ms)), o2 && (T2.mo = o2(_2.mo)), h2 && (T2.selected = _2.selected || 0), b2.push({ type: "Feature", id: e4 + 1, geometry: { type: "Point", coordinates: w3 }, properties: T2 });
                }
              }
              if (h2)
                for (y2 = l.makeSelectedPointStyleFns(c2), e4 = 0; e4 < b2.length; e4++) {
                  var k2 = b2[e4].properties;
                  y2.selectedOpacityFn && (k2.mo = g3(y2.selectedOpacityFn(k2))), y2.selectedColorFn && (k2.mcc = y2.selectedColorFn(k2)), y2.selectedSizeFn && (k2.mrc = y2.selectedSizeFn(k2));
                }
              return { geojson: { type: "FeatureCollection", features: b2 }, mcc: p3 || y2 && y2.selectedColorFn ? { type: "identity", property: "mcc" } : f3.color, mrc: d3 || y2 && y2.selectedSizeFn ? { type: "identity", property: "mrc" } : (x2 = f3.size, x2 / 2), mo: v2 || y2 && y2.selectedOpacityFn ? { type: "identity", property: "mo" } : g3(f3.opacity) };
            }(e3);
            C.geojson = I.geojson, C.layout.visibility = "visible", S && (C.filter = ["!", ["has", "point_count"]], O.cluster = { type: "circle", filter: ["has", "point_count"], layout: { visibility: "visible" }, paint: { "circle-color": x(a2.cluster.color, a2.cluster.step), "circle-radius": x(a2.cluster.size, a2.cluster.step), "circle-opacity": x(a2.cluster.opacity, a2.cluster.step) } }, O.clusterCount = { type: "symbol", filter: ["has", "point_count"], paint: {}, layout: { "text-field": "{point_count_abbreviated}", "text-font": ["Open Sans Regular", "Arial Unicode MS Regular"], "text-size": 12 } }), i.extendFlat(C.paint, { "circle-color": I.mcc, "circle-radius": I.mrc, "circle-opacity": I.mo });
          }
          if (A && S && (C.filter = ["!", ["has", "point_count"]]), (M || k) && (P.geojson = function(t4, e4) {
            for (var r4 = e4._fullLayout, n3 = t4[0].trace, a3 = n3.marker || {}, o2 = a3.symbol, s2 = a3.angle, l2 = "circle" !== o2 ? g2(o2) : y, u2 = "auto" !== s2 ? g2(s2, true) : y, f3 = c.hasText(n3) ? g2(n3.text) : y, v2 = [], x2 = 0; x2 < t4.length; x2++) {
              var b2 = t4[x2];
              if (!m2(b2.lonlat)) {
                var _2, w3 = n3.texttemplate;
                if (w3) {
                  var T2 = Array.isArray(w3) ? w3[x2] || "" : w3, k2 = n3._module.formatLabels(b2, n3, r4), A2 = {};
                  h(A2, n3, b2.i);
                  var M2 = n3._meta || {};
                  _2 = i.texttemplateString(T2, k2, r4._d3locale, A2, b2, M2);
                } else
                  _2 = f3(x2);
                _2 && (_2 = _2.replace(p2, "").replace(d2, "\n")), v2.push({ type: "Feature", geometry: { type: "Point", coordinates: b2.lonlat }, properties: { symbol: l2(x2), angle: u2(x2), text: _2 } });
              }
            }
            return { type: "FeatureCollection", features: v2 };
          }(e3, t3), i.extendFlat(P.layout, { visibility: "visible", "icon-image": "{symbol}-15", "text-field": "{text}" }), M && (i.extendFlat(P.layout, { "icon-size": a2.marker.size / 10 }), "angle" in a2.marker && "auto" !== a2.marker.angle && i.extendFlat(P.layout, { "icon-rotate": { type: "identity", property: "angle" }, "icon-rotation-alignment": "map" }), P.layout["icon-allow-overlap"] = a2.marker.allowoverlap, i.extendFlat(P.paint, { "icon-opacity": a2.opacity * a2.marker.opacity, "icon-color": a2.marker.color })), k)) {
            var D = (a2.marker || {}).size, z = f2(a2.textposition, D);
            i.extendFlat(P.layout, { "text-size": a2.textfont.size, "text-anchor": z.anchor, "text-offset": z.offset }), i.extendFlat(P.paint, { "text-color": a2.textfont.color, "text-opacity": a2.opacity });
          }
          return O;
        };
      }, 76645: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(34098), a = r2(49508), o = r2(11058), s = r2(82410), l = r2(28908), u = r2(99181);
        t2.exports = function(t3, e3, r3, c) {
          function f2(r4, i2) {
            return n2.coerce(t3, e3, u, r4, i2);
          }
          function h(r4, i2) {
            return n2.coerce2(t3, e3, u, r4, i2);
          }
          var p2 = function(t4, e4, r4) {
            var n3 = r4("lon") || [], i2 = r4("lat") || [], a2 = Math.min(n3.length, i2.length);
            return e4._length = a2, a2;
          }(0, e3, f2);
          if (p2) {
            if (f2("text"), f2("texttemplate"), f2("hovertext"), f2("hovertemplate"), f2("mode"), f2("below"), i.hasLines(e3) && (o(t3, e3, r3, c, f2, { noDash: true }), f2("connectgaps")), i.hasMarkers(e3)) {
              a(t3, e3, r3, c, f2, { noLine: true, noAngle: true }), f2("marker.allowoverlap"), f2("marker.angle");
              var d2 = e3.marker;
              "circle" !== d2.symbol && (n2.isArrayOrTypedArray(d2.size) && (d2.size = d2.size[0]), n2.isArrayOrTypedArray(d2.color) && (d2.color = d2.color[0]));
            }
            var v = h("cluster.maxzoom"), g2 = h("cluster.step"), y = h("cluster.color", e3.marker && e3.marker.color || r3), m2 = h("cluster.size"), x = h("cluster.opacity");
            f2("cluster.enabled", false !== v || false !== g2 || false !== y || false !== m2 || false !== x), i.hasText(e3) && s(t3, e3, c, f2, { noSelect: true }), f2("fill"), "none" !== e3.fill && l(t3, e3, r3, f2), n2.coerceSelectionMarkerOpacity(e3, f2);
          } else
            e3.visible = false;
        };
      }, 53353: function(t2) {
        t2.exports = function(t3, e2) {
          return t3.lon = e2.lon, t3.lat = e2.lat, t3;
        };
      }, 15636: function(t2, e2, r2) {
        var n2 = r2(89298);
        t2.exports = function(t3, e3, r3) {
          var i = {}, a = r3[e3.subplot]._subplot.mockAxis, o = t3.lonlat;
          return i.lonLabel = n2.tickText(a, a.c2l(o[0]), true).text, i.latLabel = n2.tickText(a, a.c2l(o[1]), true).text, i;
        };
      }, 28178: function(t2, e2, r2) {
        var n2 = r2(30211), i = r2(71828), a = r2(34603), o = i.fillText, s = r2(50606).BADNUM, l = r2(77734).traceLayerPrefix;
        function u(t3, e3, r3) {
          if (!t3.hovertemplate) {
            var n3 = (e3.hi || t3.hoverinfo).split("+"), i2 = -1 !== n3.indexOf("all"), a2 = -1 !== n3.indexOf("lon"), s2 = -1 !== n3.indexOf("lat"), l2 = e3.lonlat, u2 = [];
            return i2 || a2 && s2 ? u2.push("(" + c(l2[1]) + ", " + c(l2[0]) + ")") : a2 ? u2.push(r3.lon + c(l2[0])) : s2 && u2.push(r3.lat + c(l2[1])), (i2 || -1 !== n3.indexOf("text")) && o(e3, t3, u2), u2.join("<br>");
          }
          function c(t4) {
            return t4 + "°";
          }
        }
        t2.exports = { hoverPoints: function(t3, e3, r3) {
          var o2 = t3.cd, c = o2[0].trace, f2 = t3.xa, h = t3.ya, p2 = t3.subplot, d2 = [], v = l + c.uid + "-circle", g2 = c.cluster && c.cluster.enabled;
          if (g2) {
            var y = p2.map.queryRenderedFeatures(null, { layers: [v] });
            d2 = y.map(function(t4) {
              return t4.id;
            });
          }
          var m2 = 360 * (e3 >= 0 ? Math.floor((e3 + 180) / 360) : Math.ceil((e3 - 180) / 360)), x = e3 - m2;
          if (n2.getClosest(o2, function(t4) {
            var e4 = t4.lonlat;
            if (e4[0] === s)
              return 1 / 0;
            if (g2 && -1 === d2.indexOf(t4.i + 1))
              return 1 / 0;
            var n3 = i.modHalf(e4[0], 360), a2 = e4[1], o3 = p2.project([n3, a2]), l2 = o3.x - f2.c2p([x, a2]), u2 = o3.y - h.c2p([n3, r3]), c2 = Math.max(3, t4.mrc || 0);
            return Math.max(Math.sqrt(l2 * l2 + u2 * u2) - c2, 1 - 3 / c2);
          }, t3), false !== t3.index) {
            var b = o2[t3.index], _ = b.lonlat, w2 = [i.modHalf(_[0], 360) + m2, _[1]], T = f2.c2p(w2), k = h.c2p(w2), A = b.mrc || 1;
            t3.x0 = T - A, t3.x1 = T + A, t3.y0 = k - A, t3.y1 = k + A;
            var M = {};
            M[c.subplot] = { _subplot: p2 };
            var S = c._module.formatLabels(b, c, M);
            return t3.lonLabel = S.lonLabel, t3.latLabel = S.latLabel, t3.color = a(c, b), t3.extraText = u(c, b, o2[0].t.labels), t3.hovertemplate = c.hovertemplate, [t3];
          }
        }, getExtraText: u };
      }, 20467: function(t2, e2, r2) {
        t2.exports = { attributes: r2(99181), supplyDefaults: r2(76645), colorbar: r2(4898), formatLabels: r2(15636), calc: r2(84622), plot: r2(86951), hoverPoints: r2(28178).hoverPoints, eventData: r2(53353), selectPoints: r2(86387), styleOnSelect: function(t3, e3) {
          e3 && e3[0].trace._glTrace.update(e3);
        }, moduleType: "trace", name: "scattermapbox", basePlotModule: r2(50101), categories: ["mapbox", "gl", "symbols", "showLegend", "scatter-like"], meta: {} };
      }, 86951: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(15790), a = r2(77734).traceLayerPrefix, o = { cluster: ["cluster", "clusterCount", "circle"], nonCluster: ["fill", "line", "circle", "symbol"] };
        function s(t3, e3, r3, n3) {
          this.type = "scattermapbox", this.subplot = t3, this.uid = e3, this.clusterEnabled = r3, this.isHidden = n3, this.sourceIds = { fill: "source-" + e3 + "-fill", line: "source-" + e3 + "-line", circle: "source-" + e3 + "-circle", symbol: "source-" + e3 + "-symbol", cluster: "source-" + e3 + "-circle", clusterCount: "source-" + e3 + "-circle" }, this.layerIds = { fill: a + e3 + "-fill", line: a + e3 + "-line", circle: a + e3 + "-circle", symbol: a + e3 + "-symbol", cluster: a + e3 + "-cluster", clusterCount: a + e3 + "-cluster-count" }, this.below = null;
        }
        var l = s.prototype;
        l.addSource = function(t3, e3, r3) {
          var i2 = { type: "geojson", data: e3.geojson };
          r3 && r3.enabled && n2.extendFlat(i2, { cluster: true, clusterMaxZoom: r3.maxzoom }), this.subplot.map.addSource(this.sourceIds[t3], i2);
        }, l.setSourceData = function(t3, e3) {
          this.subplot.map.getSource(this.sourceIds[t3]).setData(e3.geojson);
        }, l.addLayer = function(t3, e3, r3) {
          var n3 = { type: e3.type, id: this.layerIds[t3], source: this.sourceIds[t3], layout: e3.layout, paint: e3.paint };
          e3.filter && (n3.filter = e3.filter), this.subplot.addLayer(n3, r3);
        }, l.update = function(t3) {
          var e3 = t3[0].trace, r3 = this.subplot, n3 = r3.map, a2 = i(r3.gd, t3), s2 = r3.belowLookup["trace-" + this.uid], l2 = !(!e3.cluster || !e3.cluster.enabled), u = !!this.clusterEnabled, c = this;
          function f2(t4) {
            u ? function(t5) {
              for (var e4 = o.cluster, r4 = e4.length - 1; r4 >= 0; r4--) {
                var i2 = e4[r4];
                n3.removeLayer(c.layerIds[i2]);
              }
              t5 || n3.removeSource(c.sourceIds.circle);
            }(t4) : function(t5) {
              for (var e4 = o.nonCluster, r4 = e4.length - 1; r4 >= 0; r4--) {
                var i2 = e4[r4];
                n3.removeLayer(c.layerIds[i2]), t5 || n3.removeSource(c.sourceIds[i2]);
              }
            }(t4);
          }
          function h(t4) {
            l2 ? function(t5) {
              t5 || c.addSource("circle", a2.circle, e3.cluster);
              for (var r4 = o.cluster, n4 = 0; n4 < r4.length; n4++) {
                var i2 = r4[n4], l3 = a2[i2];
                c.addLayer(i2, l3, s2);
              }
            }(t4) : function(t5) {
              for (var e4 = o.nonCluster, r4 = 0; r4 < e4.length; r4++) {
                var n4 = e4[r4], i2 = a2[n4];
                t5 || c.addSource(n4, i2), c.addLayer(n4, i2, s2);
              }
            }(t4);
          }
          function p2() {
            for (var t4 = l2 ? o.cluster : o.nonCluster, e4 = 0; e4 < t4.length; e4++) {
              var n4 = t4[e4], i2 = a2[n4];
              i2 && (r3.setOptions(c.layerIds[n4], "setLayoutProperty", i2.layout), "visible" === i2.layout.visibility && ("cluster" !== n4 && c.setSourceData(n4, i2), r3.setOptions(c.layerIds[n4], "setPaintProperty", i2.paint)));
            }
          }
          var d2 = this.isHidden, v = true !== e3.visible;
          v ? d2 || f2() : d2 ? v || h() : u !== l2 ? (f2(), h()) : this.below !== s2 ? (f2(true), h(true), p2()) : p2(), this.clusterEnabled = l2, this.isHidden = v, this.below = s2, t3[0].trace._glTrace = this;
        }, l.dispose = function() {
          for (var t3 = this.subplot.map, e3 = this.clusterEnabled ? o.cluster : o.nonCluster, r3 = e3.length - 1; r3 >= 0; r3--) {
            var n3 = e3[r3];
            t3.removeLayer(this.layerIds[n3]), t3.removeSource(this.sourceIds[n3]);
          }
        }, t2.exports = function(t3, e3) {
          var r3, n3, a2, l2 = e3[0].trace, u = l2.cluster && l2.cluster.enabled, c = true !== l2.visible, f2 = new s(t3, l2.uid, u, c), h = i(t3.gd, e3), p2 = f2.below = t3.belowLookup["trace-" + l2.uid];
          if (u)
            for (f2.addSource("circle", h.circle, l2.cluster), r3 = 0; r3 < o.cluster.length; r3++)
              a2 = h[n3 = o.cluster[r3]], f2.addLayer(n3, a2, p2);
          else
            for (r3 = 0; r3 < o.nonCluster.length; r3++)
              a2 = h[n3 = o.nonCluster[r3]], f2.addSource(n3, a2, l2.cluster), f2.addLayer(n3, a2, p2);
          return e3[0].trace._glTrace = f2, f2;
        };
      }, 86387: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(34098), a = r2(50606).BADNUM;
        t2.exports = function(t3, e3) {
          var r3, o = t3.cd, s = t3.xaxis, l = t3.yaxis, u = [], c = o[0].trace;
          if (!i.hasMarkers(c))
            return [];
          if (false === e3)
            for (r3 = 0; r3 < o.length; r3++)
              o[r3].selected = 0;
          else
            for (r3 = 0; r3 < o.length; r3++) {
              var f2 = o[r3], h = f2.lonlat;
              if (h[0] !== a) {
                var p2 = [n2.modHalf(h[0], 360), h[1]], d2 = [s.c2p(p2), l.c2p(p2)];
                e3.contains(d2, null, r3, t3) ? (u.push({ pointNumber: r3, lon: h[0], lat: h[1] }), f2.selected = 1) : f2.selected = 0;
              }
            }
          return u;
        };
      }, 81245: function(t2, e2, r2) {
        var n2 = r2(5386).f, i = r2(5386).s, a = r2(1426).extendFlat, o = r2(82196), s = r2(9012), l = o.line;
        t2.exports = { mode: o.mode, r: { valType: "data_array", editType: "calc+clearAxisTypes" }, theta: { valType: "data_array", editType: "calc+clearAxisTypes" }, r0: { valType: "any", dflt: 0, editType: "calc+clearAxisTypes" }, dr: { valType: "number", dflt: 1, editType: "calc" }, theta0: { valType: "any", dflt: 0, editType: "calc+clearAxisTypes" }, dtheta: { valType: "number", editType: "calc" }, thetaunit: { valType: "enumerated", values: ["radians", "degrees", "gradians"], dflt: "degrees", editType: "calc+clearAxisTypes" }, text: o.text, texttemplate: i({ editType: "plot" }, { keys: ["r", "theta", "text"] }), hovertext: o.hovertext, line: { color: l.color, width: l.width, dash: l.dash, backoff: l.backoff, shape: a({}, l.shape, { values: ["linear", "spline"] }), smoothing: l.smoothing, editType: "calc" }, connectgaps: o.connectgaps, marker: o.marker, cliponaxis: a({}, o.cliponaxis, { dflt: false }), textposition: o.textposition, textfont: o.textfont, fill: a({}, o.fill, { values: ["none", "toself", "tonext"], dflt: "none" }), fillcolor: o.fillcolor, hoverinfo: a({}, s.hoverinfo, { flags: ["r", "theta", "text", "name"] }), hoveron: o.hoveron, hovertemplate: n2(), selected: o.selected, unselected: o.unselected };
      }, 26442: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(50606).BADNUM, a = r2(89298), o = r2(36922), s = r2(75225), l = r2(66279), u = r2(47761).calcMarkerSize;
        t2.exports = function(t3, e3) {
          for (var r3 = t3._fullLayout, c = e3.subplot, f2 = r3[c].radialaxis, h = r3[c].angularaxis, p2 = f2.makeCalcdata(e3, "r"), d2 = h.makeCalcdata(e3, "theta"), v = e3._length, g2 = new Array(v), y = 0; y < v; y++) {
            var m2 = p2[y], x = d2[y], b = g2[y] = {};
            n2(m2) && n2(x) ? (b.r = m2, b.theta = x) : b.r = i;
          }
          var _ = u(e3, v);
          return e3._extremes.x = a.findExtremes(f2, p2, { ppad: _ }), o(t3, e3), s(g2, e3), l(g2, e3), g2;
        };
      }, 22184: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(34098), a = r2(49508), o = r2(11058), s = r2(94039), l = r2(82410), u = r2(28908), c = r2(47581).PTS_LINESONLY, f2 = r2(81245);
        function h(t3, e3, r3, n3) {
          var i2, a2 = n3("r"), o2 = n3("theta");
          if (a2)
            o2 ? i2 = Math.min(a2.length, o2.length) : (i2 = a2.length, n3("theta0"), n3("dtheta"));
          else {
            if (!o2)
              return 0;
            i2 = e3.theta.length, n3("r0"), n3("dr");
          }
          return e3._length = i2, i2;
        }
        t2.exports = { handleRThetaDefaults: h, supplyDefaults: function(t3, e3, r3, p2) {
          function d2(r4, i2) {
            return n2.coerce(t3, e3, f2, r4, i2);
          }
          var v = h(0, e3, 0, d2);
          if (v) {
            d2("thetaunit"), d2("mode", v < c ? "lines+markers" : "lines"), d2("text"), d2("hovertext"), "fills" !== e3.hoveron && d2("hovertemplate"), i.hasLines(e3) && (o(t3, e3, r3, p2, d2, { backoff: true }), s(t3, e3, d2), d2("connectgaps")), i.hasMarkers(e3) && a(t3, e3, r3, p2, d2, { gradient: true }), i.hasText(e3) && (d2("texttemplate"), l(t3, e3, p2, d2));
            var g2 = [];
            (i.hasMarkers(e3) || i.hasText(e3)) && (d2("cliponaxis"), d2("marker.maxdisplayed"), g2.push("points")), d2("fill"), "none" !== e3.fill && (u(t3, e3, r3, d2), i.hasLines(e3) || s(t3, e3, d2)), "tonext" !== e3.fill && "toself" !== e3.fill || g2.push("fills"), d2("hoveron", g2.join("+") || "points"), n2.coerceSelectionMarkerOpacity(e3, d2);
          } else
            e3.visible = false;
        } };
      }, 98608: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298);
        t2.exports = function(t3, e3, r3) {
          var a, o, s = {}, l = r3[e3.subplot]._subplot;
          l ? (a = l.radialAxis, o = l.angularAxis) : (a = (l = r3[e3.subplot]).radialaxis, o = l.angularaxis);
          var u = a.c2l(t3.r);
          s.rLabel = i.tickText(a, u, true).text;
          var c = "degrees" === o.thetaunit ? n2.rad2deg(t3.theta) : t3.theta;
          return s.thetaLabel = i.tickText(o, c, true).text, s;
        };
      }, 59150: function(t2, e2, r2) {
        var n2 = r2(33720);
        function i(t3, e3, r3, n3) {
          var i2 = r3.radialAxis, a = r3.angularAxis;
          i2._hovertitle = "r", a._hovertitle = "θ";
          var o = {};
          o[e3.subplot] = { _subplot: r3 };
          var s = e3._module.formatLabels(t3, e3, o);
          n3.rLabel = s.rLabel, n3.thetaLabel = s.thetaLabel;
          var l = t3.hi || e3.hoverinfo, u = [];
          function c(t4, e4) {
            u.push(t4._hovertitle + ": " + e4);
          }
          if (!e3.hovertemplate) {
            var f2 = l.split("+");
            -1 !== f2.indexOf("all") && (f2 = ["r", "theta", "text"]), -1 !== f2.indexOf("r") && c(i2, n3.rLabel), -1 !== f2.indexOf("theta") && c(a, n3.thetaLabel), -1 !== f2.indexOf("text") && n3.text && (u.push(n3.text), delete n3.text), n3.extraText = u.join("<br>");
          }
        }
        t2.exports = { hoverPoints: function(t3, e3, r3, a) {
          var o = n2(t3, e3, r3, a);
          if (o && false !== o[0].index) {
            var s = o[0];
            if (void 0 === s.index)
              return o;
            var l = t3.subplot, u = s.cd[s.index], c = s.trace;
            if (l.isPtInside(u))
              return s.xLabelVal = void 0, s.yLabelVal = void 0, i(u, c, l, s), s.hovertemplate = c.hovertemplate, o;
          }
        }, makeHoverPointText: i };
      }, 91271: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "scatterpolar", basePlotModule: r2(23580), categories: ["polar", "symbols", "showLegend", "scatter-like"], attributes: r2(81245), supplyDefaults: r2(22184).supplyDefaults, colorbar: r2(4898), formatLabels: r2(98608), calc: r2(26442), plot: r2(45162), style: r2(16296).style, styleOnSelect: r2(16296).styleOnSelect, hoverPoints: r2(59150).hoverPoints, selectPoints: r2(98002), meta: {} };
      }, 45162: function(t2, e2, r2) {
        var n2 = r2(32663), i = r2(50606).BADNUM;
        t2.exports = function(t3, e3, r3) {
          for (var a = e3.layers.frontplot.select("g.scatterlayer"), o = e3.xaxis, s = e3.yaxis, l = { xaxis: o, yaxis: s, plot: e3.framework, layerClipId: e3._hasClipOnAxisFalse ? e3.clipIds.forTraces : null }, u = e3.radialAxis, c = e3.angularAxis, f2 = 0; f2 < r3.length; f2++)
            for (var h = r3[f2], p2 = 0; p2 < h.length; p2++) {
              0 === p2 && (h[0].trace._xA = o, h[0].trace._yA = s);
              var d2 = h[p2], v = d2.r;
              if (v === i)
                d2.x = d2.y = i;
              else {
                var g2 = u.c2g(v), y = c.c2g(d2.theta);
                d2.x = g2 * Math.cos(y), d2.y = g2 * Math.sin(y);
              }
            }
          n2(t3, l, r3, a);
        };
      }, 53286: function(t2, e2, r2) {
        var n2 = r2(81245), i = r2(42341), a = r2(5386).s;
        t2.exports = { mode: n2.mode, r: n2.r, theta: n2.theta, r0: n2.r0, dr: n2.dr, theta0: n2.theta0, dtheta: n2.dtheta, thetaunit: n2.thetaunit, text: n2.text, texttemplate: a({ editType: "plot" }, { keys: ["r", "theta", "text"] }), hovertext: n2.hovertext, hovertemplate: n2.hovertemplate, line: i.line, connectgaps: i.connectgaps, marker: i.marker, fill: i.fill, fillcolor: i.fillcolor, textposition: i.textposition, textfont: i.textfont, hoverinfo: n2.hoverinfo, selected: n2.selected, unselected: n2.unselected };
      }, 65746: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "scatterpolargl", basePlotModule: r2(23580), categories: ["gl", "regl", "polar", "symbols", "showLegend", "scatter-like"], attributes: r2(53286), supplyDefaults: r2(75485), colorbar: r2(4898), formatLabels: r2(46255), calc: r2(37499), hoverPoints: r2(29347).hoverPoints, selectPoints: r2(58147), meta: {} };
      }, 37499: function(t2, e2, r2) {
        var n2 = r2(36922), i = r2(47761).calcMarkerSize, a = r2(19635), o = r2(89298), s = r2(78232).TOO_MANY_POINTS;
        t2.exports = function(t3, e3) {
          var r3 = t3._fullLayout, l = e3.subplot, u = r3[l].radialaxis, c = r3[l].angularaxis, f2 = e3._r = u.makeCalcdata(e3, "r"), h = e3._theta = c.makeCalcdata(e3, "theta"), p2 = e3._length, d2 = {};
          p2 < f2.length && (f2 = f2.slice(0, p2)), p2 < h.length && (h = h.slice(0, p2)), d2.r = f2, d2.theta = h, n2(t3, e3);
          var v, g2 = d2.opts = a.style(t3, e3);
          return p2 < s ? v = i(e3, p2) : g2.marker && (v = 2 * (g2.marker.sizeAvg || Math.max(g2.marker.size, 3))), e3._extremes.x = o.findExtremes(u, f2, { ppad: v }), [{ x: false, y: false, t: d2, trace: e3 }];
        };
      }, 75485: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(34098), a = r2(22184).handleRThetaDefaults, o = r2(49508), s = r2(11058), l = r2(82410), u = r2(28908), c = r2(47581).PTS_LINESONLY, f2 = r2(53286);
        t2.exports = function(t3, e3, r3, h) {
          function p2(r4, i2) {
            return n2.coerce(t3, e3, f2, r4, i2);
          }
          var d2 = a(t3, e3, h, p2);
          d2 ? (p2("thetaunit"), p2("mode", d2 < c ? "lines+markers" : "lines"), p2("text"), p2("hovertext"), "fills" !== e3.hoveron && p2("hovertemplate"), i.hasLines(e3) && (s(t3, e3, r3, h, p2), p2("connectgaps")), i.hasMarkers(e3) && o(t3, e3, r3, h, p2, { noAngleRef: true, noStandOff: true }), i.hasText(e3) && (p2("texttemplate"), l(t3, e3, h, p2)), p2("fill"), "none" !== e3.fill && u(t3, e3, r3, p2), n2.coerceSelectionMarkerOpacity(e3, p2)) : e3.visible = false;
        };
      }, 46255: function(t2, e2, r2) {
        var n2 = r2(98608);
        t2.exports = function(t3, e3, r3) {
          var i = t3.i;
          return "r" in t3 || (t3.r = e3._r[i]), "theta" in t3 || (t3.theta = e3._theta[i]), n2(t3, e3, r3);
        };
      }, 29347: function(t2, e2, r2) {
        var n2 = r2(20794), i = r2(59150).makeHoverPointText;
        t2.exports = { hoverPoints: function(t3, e3, r3, a) {
          var o = t3.cd[0].t, s = o.r, l = o.theta, u = n2.hoverPoints(t3, e3, r3, a);
          if (u && false !== u[0].index) {
            var c = u[0];
            if (void 0 === c.index)
              return u;
            var f2 = t3.subplot, h = c.cd[c.index], p2 = c.trace;
            if (h.r = s[c.index], h.theta = l[c.index], f2.isPtInside(h))
              return c.xLabelVal = void 0, c.yLabelVal = void 0, i(h, p2, f2, c), u;
          }
        } };
      }, 21461: function(t2, e2, r2) {
        var n2 = r2(65746);
        n2.plot = r2(49741), t2.exports = n2;
      }, 49741: function(t2, e2, r2) {
        var n2 = r2(88294), i = r2(92770), a = r2(26787), o = r2(38967), s = r2(19635), l = r2(71828), u = r2(78232).TOO_MANY_POINTS;
        t2.exports = function(t3, e3, r3) {
          if (r3.length) {
            var c = e3.radialAxis, f2 = e3.angularAxis, h = o(t3, e3);
            return r3.forEach(function(r4) {
              if (r4 && r4[0] && r4[0].trace) {
                var a2, o2 = r4[0], p2 = o2.trace, d2 = o2.t, v = p2._length, g2 = d2.r, y = d2.theta, m2 = d2.opts, x = g2.slice(), b = y.slice();
                for (a2 = 0; a2 < g2.length; a2++)
                  e3.isPtInside({ r: g2[a2], theta: y[a2] }) || (x[a2] = NaN, b[a2] = NaN);
                var _ = new Array(2 * v), w2 = Array(v), T = Array(v);
                for (a2 = 0; a2 < v; a2++) {
                  var k, A, M = x[a2];
                  if (i(M)) {
                    var S = c.c2g(M), E = f2.c2g(b[a2], p2.thetaunit);
                    k = S * Math.cos(E), A = S * Math.sin(E);
                  } else
                    k = A = NaN;
                  w2[a2] = _[2 * a2] = k, T[a2] = _[2 * a2 + 1] = A;
                }
                d2.tree = n2(_), m2.marker && v >= u && (m2.marker.cluster = d2.tree), m2.marker && (m2.markerSel.positions = m2.markerUnsel.positions = m2.marker.positions = _), m2.line && _.length > 1 && l.extendFlat(m2.line, s.linePositions(t3, p2, _)), m2.text && (l.extendFlat(m2.text, { positions: _ }, s.textPosition(t3, p2, m2.text, m2.marker)), l.extendFlat(m2.textSel, { positions: _ }, s.textPosition(t3, p2, m2.text, m2.markerSel)), l.extendFlat(m2.textUnsel, { positions: _ }, s.textPosition(t3, p2, m2.text, m2.markerUnsel))), m2.fill && !h.fill2d && (h.fill2d = true), m2.marker && !h.scatter2d && (h.scatter2d = true), m2.line && !h.line2d && (h.line2d = true), m2.text && !h.glText && (h.glText = true), h.lineOptions.push(m2.line), h.fillOptions.push(m2.fill), h.markerOptions.push(m2.marker), h.markerSelectedOptions.push(m2.markerSel), h.markerUnselectedOptions.push(m2.markerUnsel), h.textOptions.push(m2.text), h.textSelectedOptions.push(m2.textSel), h.textUnselectedOptions.push(m2.textUnsel), h.selectBatch.push([]), h.unselectBatch.push([]), d2.x = w2, d2.y = T, d2.rawx = w2, d2.rawy = T, d2.r = g2, d2.theta = y, d2.positions = _, d2._scene = h, d2.index = h.count, h.count++;
              }
            }), a(t3, e3, r3);
          }
        }, t2.exports.reglPrecompiled = {};
      }, 48300: function(t2, e2, r2) {
        var n2 = r2(5386).f, i = r2(5386).s, a = r2(1426).extendFlat, o = r2(82196), s = r2(9012), l = o.line;
        t2.exports = { mode: o.mode, real: { valType: "data_array", editType: "calc+clearAxisTypes" }, imag: { valType: "data_array", editType: "calc+clearAxisTypes" }, text: o.text, texttemplate: i({ editType: "plot" }, { keys: ["real", "imag", "text"] }), hovertext: o.hovertext, line: { color: l.color, width: l.width, dash: l.dash, backoff: l.backoff, shape: a({}, l.shape, { values: ["linear", "spline"] }), smoothing: l.smoothing, editType: "calc" }, connectgaps: o.connectgaps, marker: o.marker, cliponaxis: a({}, o.cliponaxis, { dflt: false }), textposition: o.textposition, textfont: o.textfont, fill: a({}, o.fill, { values: ["none", "toself", "tonext"], dflt: "none" }), fillcolor: o.fillcolor, hoverinfo: a({}, s.hoverinfo, { flags: ["real", "imag", "text", "name"] }), hoveron: o.hoveron, hovertemplate: n2(), selected: o.selected, unselected: o.unselected };
      }, 30621: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(50606).BADNUM, a = r2(36922), o = r2(75225), s = r2(66279), l = r2(47761).calcMarkerSize;
        t2.exports = function(t3, e3) {
          for (var r3 = t3._fullLayout, u = e3.subplot, c = r3[u].realaxis, f2 = r3[u].imaginaryaxis, h = c.makeCalcdata(e3, "real"), p2 = f2.makeCalcdata(e3, "imag"), d2 = e3._length, v = new Array(d2), g2 = 0; g2 < d2; g2++) {
            var y = h[g2], m2 = p2[g2], x = v[g2] = {};
            n2(y) && n2(m2) ? (x.real = y, x.imag = m2) : x.real = i;
          }
          return l(e3, d2), a(t3, e3), o(v, e3), s(v, e3), v;
        };
      }, 65269: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(34098), a = r2(49508), o = r2(11058), s = r2(94039), l = r2(82410), u = r2(28908), c = r2(47581).PTS_LINESONLY, f2 = r2(48300);
        t2.exports = function(t3, e3, r3, h) {
          function p2(r4, i2) {
            return n2.coerce(t3, e3, f2, r4, i2);
          }
          var d2 = function(t4, e4, r4, n3) {
            var i2, a2 = n3("real"), o2 = n3("imag");
            return a2 && o2 && (i2 = Math.min(a2.length, o2.length)), e4._length = i2, i2;
          }(0, e3, 0, p2);
          if (d2) {
            p2("mode", d2 < c ? "lines+markers" : "lines"), p2("text"), p2("hovertext"), "fills" !== e3.hoveron && p2("hovertemplate"), i.hasLines(e3) && (o(t3, e3, r3, h, p2, { backoff: true }), s(t3, e3, p2), p2("connectgaps")), i.hasMarkers(e3) && a(t3, e3, r3, h, p2, { gradient: true }), i.hasText(e3) && (p2("texttemplate"), l(t3, e3, h, p2));
            var v = [];
            (i.hasMarkers(e3) || i.hasText(e3)) && (p2("cliponaxis"), p2("marker.maxdisplayed"), v.push("points")), p2("fill"), "none" !== e3.fill && (u(t3, e3, r3, p2), i.hasLines(e3) || s(t3, e3, p2)), "tonext" !== e3.fill && "toself" !== e3.fill || v.push("fills"), p2("hoveron", v.join("+") || "points"), n2.coerceSelectionMarkerOpacity(e3, p2);
          } else
            e3.visible = false;
        };
      }, 62047: function(t2, e2, r2) {
        var n2 = r2(89298);
        t2.exports = function(t3, e3, r3) {
          var i = {}, a = r3[e3.subplot]._subplot;
          return i.realLabel = n2.tickText(a.radialAxis, t3.real, true).text, i.imagLabel = n2.tickText(a.angularAxis, t3.imag, true).text, i;
        };
      }, 11350: function(t2, e2, r2) {
        var n2 = r2(33720);
        function i(t3, e3, r3, n3) {
          var i2 = r3.radialAxis, a = r3.angularAxis;
          i2._hovertitle = "real", a._hovertitle = "imag";
          var o = {};
          o[e3.subplot] = { _subplot: r3 };
          var s = e3._module.formatLabels(t3, e3, o);
          n3.realLabel = s.realLabel, n3.imagLabel = s.imagLabel;
          var l = t3.hi || e3.hoverinfo, u = [];
          function c(t4, e4) {
            u.push(t4._hovertitle + ": " + e4);
          }
          if (!e3.hovertemplate) {
            var f2 = l.split("+");
            -1 !== f2.indexOf("all") && (f2 = ["real", "imag", "text"]), -1 !== f2.indexOf("real") && c(i2, n3.realLabel), -1 !== f2.indexOf("imag") && c(a, n3.imagLabel), -1 !== f2.indexOf("text") && n3.text && (u.push(n3.text), delete n3.text), n3.extraText = u.join("<br>");
          }
        }
        t2.exports = { hoverPoints: function(t3, e3, r3, a) {
          var o = n2(t3, e3, r3, a);
          if (o && false !== o[0].index) {
            var s = o[0];
            if (void 0 === s.index)
              return o;
            var l = t3.subplot, u = s.cd[s.index], c = s.trace;
            if (l.isPtInside(u))
              return s.xLabelVal = void 0, s.yLabelVal = void 0, i(u, c, l, s), s.hovertemplate = c.hovertemplate, o;
          }
        }, makeHoverPointText: i };
      }, 85956: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "scattersmith", basePlotModule: r2(7504), categories: ["smith", "symbols", "showLegend", "scatter-like"], attributes: r2(48300), supplyDefaults: r2(65269), colorbar: r2(4898), formatLabels: r2(62047), calc: r2(30621), plot: r2(12480), style: r2(16296).style, styleOnSelect: r2(16296).styleOnSelect, hoverPoints: r2(11350).hoverPoints, selectPoints: r2(98002), meta: {} };
      }, 12480: function(t2, e2, r2) {
        var n2 = r2(32663), i = r2(50606).BADNUM, a = r2(23893).smith;
        t2.exports = function(t3, e3, r3) {
          for (var o = e3.layers.frontplot.select("g.scatterlayer"), s = e3.xaxis, l = e3.yaxis, u = { xaxis: s, yaxis: l, plot: e3.framework, layerClipId: e3._hasClipOnAxisFalse ? e3.clipIds.forTraces : null }, c = 0; c < r3.length; c++)
            for (var f2 = r3[c], h = 0; h < f2.length; h++) {
              0 === h && (f2[0].trace._xA = s, f2[0].trace._yA = l);
              var p2 = f2[h], d2 = p2.real;
              if (d2 === i)
                p2.x = p2.y = i;
              else {
                var v = a([d2, p2.imag]);
                p2.x = v[0], p2.y = v[1];
              }
            }
          n2(t3, u, r3, o);
        };
      }, 50413: function(t2, e2, r2) {
        var n2 = r2(5386).f, i = r2(5386).s, a = r2(82196), o = r2(9012), s = r2(50693), l = r2(79952).P, u = r2(1426).extendFlat, c = a.marker, f2 = a.line, h = c.line;
        t2.exports = { a: { valType: "data_array", editType: "calc" }, b: { valType: "data_array", editType: "calc" }, c: { valType: "data_array", editType: "calc" }, sum: { valType: "number", dflt: 0, min: 0, editType: "calc" }, mode: u({}, a.mode, { dflt: "markers" }), text: u({}, a.text, {}), texttemplate: i({ editType: "plot" }, { keys: ["a", "b", "c", "text"] }), hovertext: u({}, a.hovertext, {}), line: { color: f2.color, width: f2.width, dash: l, backoff: f2.backoff, shape: u({}, f2.shape, { values: ["linear", "spline"] }), smoothing: f2.smoothing, editType: "calc" }, connectgaps: a.connectgaps, cliponaxis: a.cliponaxis, fill: u({}, a.fill, { values: ["none", "toself", "tonext"], dflt: "none" }), fillcolor: a.fillcolor, marker: u({ symbol: c.symbol, opacity: c.opacity, angle: c.angle, angleref: c.angleref, standoff: c.standoff, maxdisplayed: c.maxdisplayed, size: c.size, sizeref: c.sizeref, sizemin: c.sizemin, sizemode: c.sizemode, line: u({ width: h.width, editType: "calc" }, s("marker.line")), gradient: c.gradient, editType: "calc" }, s("marker")), textfont: a.textfont, textposition: a.textposition, selected: a.selected, unselected: a.unselected, hoverinfo: u({}, o.hoverinfo, { flags: ["a", "b", "c", "text", "name"] }), hoveron: a.hoveron, hovertemplate: n2() };
      }, 54337: function(t2, e2, r2) {
        var n2 = r2(92770), i = r2(36922), a = r2(75225), o = r2(66279), s = r2(47761).calcMarkerSize, l = ["a", "b", "c"], u = { a: ["b", "c"], b: ["a", "c"], c: ["a", "b"] };
        t2.exports = function(t3, e3) {
          var r3, c, f2, h, p2, d2, v = t3._fullLayout[e3.subplot].sum, g2 = e3.sum || v, y = { a: e3.a, b: e3.b, c: e3.c };
          for (r3 = 0; r3 < l.length; r3++)
            if (!y[f2 = l[r3]]) {
              for (p2 = y[u[f2][0]], d2 = y[u[f2][1]], h = new Array(p2.length), c = 0; c < p2.length; c++)
                h[c] = g2 - p2[c] - d2[c];
              y[f2] = h;
            }
          var m2, x, b, _, w2, T, k = e3._length, A = new Array(k);
          for (r3 = 0; r3 < k; r3++)
            m2 = y.a[r3], x = y.b[r3], b = y.c[r3], n2(m2) && n2(x) && n2(b) ? (1 != (_ = v / ((m2 = +m2) + (x = +x) + (b = +b))) && (m2 *= _, x *= _, b *= _), T = m2, w2 = b - x, A[r3] = { x: w2, y: T, a: m2, b: x, c: b }) : A[r3] = { x: false, y: false };
          return s(e3, k), i(t3, e3), a(A, e3), o(A, e3), A;
        };
      }, 46008: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(47581), a = r2(34098), o = r2(49508), s = r2(11058), l = r2(94039), u = r2(82410), c = r2(28908), f2 = r2(50413);
        t2.exports = function(t3, e3, r3, h) {
          function p2(r4, i2) {
            return n2.coerce(t3, e3, f2, r4, i2);
          }
          var d2, v = p2("a"), g2 = p2("b"), y = p2("c");
          if (v ? (d2 = v.length, g2 ? (d2 = Math.min(d2, g2.length), y && (d2 = Math.min(d2, y.length))) : d2 = y ? Math.min(d2, y.length) : 0) : g2 && y && (d2 = Math.min(g2.length, y.length)), d2) {
            e3._length = d2, p2("sum"), p2("text"), p2("hovertext"), "fills" !== e3.hoveron && p2("hovertemplate"), p2("mode", d2 < i.PTS_LINESONLY ? "lines+markers" : "lines"), a.hasLines(e3) && (s(t3, e3, r3, h, p2, { backoff: true }), l(t3, e3, p2), p2("connectgaps")), a.hasMarkers(e3) && o(t3, e3, r3, h, p2, { gradient: true }), a.hasText(e3) && (p2("texttemplate"), u(t3, e3, h, p2));
            var m2 = [];
            (a.hasMarkers(e3) || a.hasText(e3)) && (p2("cliponaxis"), p2("marker.maxdisplayed"), m2.push("points")), p2("fill"), "none" !== e3.fill && (c(t3, e3, r3, p2), a.hasLines(e3) || l(t3, e3, p2)), "tonext" !== e3.fill && "toself" !== e3.fill || m2.push("fills"), p2("hoveron", m2.join("+") || "points"), n2.coerceSelectionMarkerOpacity(e3, p2);
          } else
            e3.visible = false;
        };
      }, 4524: function(t2) {
        t2.exports = function(t3, e2, r2, n2, i) {
          if (e2.xa && (t3.xaxis = e2.xa), e2.ya && (t3.yaxis = e2.ya), n2[i]) {
            var a = n2[i];
            t3.a = a.a, t3.b = a.b, t3.c = a.c;
          } else
            t3.a = e2.a, t3.b = e2.b, t3.c = e2.c;
          return t3;
        };
      }, 93645: function(t2, e2, r2) {
        var n2 = r2(89298);
        t2.exports = function(t3, e3, r3) {
          var i = {}, a = r3[e3.subplot]._subplot;
          return i.aLabel = n2.tickText(a.aaxis, t3.a, true).text, i.bLabel = n2.tickText(a.baxis, t3.b, true).text, i.cLabel = n2.tickText(a.caxis, t3.c, true).text, i;
        };
      }, 47250: function(t2, e2, r2) {
        var n2 = r2(33720);
        t2.exports = function(t3, e3, r3, i) {
          var a = n2(t3, e3, r3, i);
          if (a && false !== a[0].index) {
            var o = a[0];
            if (void 0 === o.index) {
              var s = 1 - o.y0 / t3.ya._length, l = t3.xa._length, u = l * s / 2, c = l - u;
              return o.x0 = Math.max(Math.min(o.x0, c), u), o.x1 = Math.max(Math.min(o.x1, c), u), a;
            }
            var f2 = o.cd[o.index], h = o.trace, p2 = o.subplot;
            o.a = f2.a, o.b = f2.b, o.c = f2.c, o.xLabelVal = void 0, o.yLabelVal = void 0;
            var d2 = {};
            d2[h.subplot] = { _subplot: p2 };
            var v = h._module.formatLabels(f2, h, d2);
            o.aLabel = v.aLabel, o.bLabel = v.bLabel, o.cLabel = v.cLabel;
            var g2 = f2.hi || h.hoverinfo, y = [];
            if (!h.hovertemplate) {
              var m2 = g2.split("+");
              -1 !== m2.indexOf("all") && (m2 = ["a", "b", "c"]), -1 !== m2.indexOf("a") && x(p2.aaxis, o.aLabel), -1 !== m2.indexOf("b") && x(p2.baxis, o.bLabel), -1 !== m2.indexOf("c") && x(p2.caxis, o.cLabel);
            }
            return o.extraText = y.join("<br>"), o.hovertemplate = h.hovertemplate, a;
          }
          function x(t4, e4) {
            y.push(t4._hovertitle + ": " + e4);
          }
        };
      }, 52979: function(t2, e2, r2) {
        t2.exports = { attributes: r2(50413), supplyDefaults: r2(46008), colorbar: r2(4898), formatLabels: r2(93645), calc: r2(54337), plot: r2(7507), style: r2(16296).style, styleOnSelect: r2(16296).styleOnSelect, hoverPoints: r2(47250), selectPoints: r2(98002), eventData: r2(4524), moduleType: "trace", name: "scatterternary", basePlotModule: r2(61639), categories: ["ternary", "symbols", "showLegend", "scatter-like"], meta: {} };
      }, 7507: function(t2, e2, r2) {
        var n2 = r2(32663);
        t2.exports = function(t3, e3, r3) {
          var i = e3.plotContainer;
          i.select(".scatterlayer").selectAll("*").remove();
          for (var a = e3.xaxis, o = e3.yaxis, s = { xaxis: a, yaxis: o, plot: i, layerClipId: e3._hasClipOnAxisFalse ? e3.clipIdRelative : null }, l = e3.layers.frontplot.select("g.scatterlayer"), u = 0; u < r3.length; u++) {
            var c = r3[u];
            c.length && (c[0].trace._xA = a, c[0].trace._yA = o);
          }
          n2(t3, s, r3, l);
        };
      }, 46880: function(t2, e2, r2) {
        var n2 = r2(82196), i = r2(50693), a = r2(12663).axisHoverFormat, o = r2(5386).f, s = r2(42341), l = r2(85555).idRegex, u = r2(44467).templatedArray, c = r2(1426).extendFlat, f2 = n2.marker, h = f2.line, p2 = c(i("marker.line", { editTypeOverride: "calc" }), { width: c({}, h.width, { editType: "calc" }), editType: "calc" }), d2 = c(i("marker"), { symbol: f2.symbol, angle: f2.angle, size: c({}, f2.size, { editType: "markerSize" }), sizeref: f2.sizeref, sizemin: f2.sizemin, sizemode: f2.sizemode, opacity: f2.opacity, colorbar: f2.colorbar, line: p2, editType: "calc" });
        function v(t3) {
          return { valType: "info_array", freeLength: true, editType: "calc", items: { valType: "subplotid", regex: l[t3], editType: "plot" } };
        }
        d2.color.editType = d2.cmin.editType = d2.cmax.editType = "style", t2.exports = { dimensions: u("dimension", { visible: { valType: "boolean", dflt: true, editType: "calc" }, label: { valType: "string", editType: "calc" }, values: { valType: "data_array", editType: "calc+clearAxisTypes" }, axis: { type: { valType: "enumerated", values: ["linear", "log", "date", "category"], editType: "calc+clearAxisTypes" }, matches: { valType: "boolean", dflt: false, editType: "calc" }, editType: "calc+clearAxisTypes" }, editType: "calc+clearAxisTypes" }), text: c({}, s.text, {}), hovertext: c({}, s.hovertext, {}), hovertemplate: o(), xhoverformat: a("x"), yhoverformat: a("y"), marker: d2, xaxes: v("x"), yaxes: v("y"), diagonal: { visible: { valType: "boolean", dflt: true, editType: "calc" }, editType: "calc" }, showupperhalf: { valType: "boolean", dflt: true, editType: "calc" }, showlowerhalf: { valType: "boolean", dflt: true, editType: "calc" }, selected: { marker: s.selected.marker, editType: "calc" }, unselected: { marker: s.unselected.marker, editType: "calc" }, opacity: s.opacity };
      }, 65017: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(83312);
        t2.exports = { moduleType: "trace", name: "splom", categories: ["gl", "regl", "cartesian", "symbols", "showLegend", "scatter-like"], attributes: r2(46880), supplyDefaults: r2(25784), colorbar: r2(4898), calc: r2(87625), plot: r2(79410), hoverPoints: r2(8567).hoverPoints, selectPoints: r2(8689), editStyle: r2(28801), meta: {} }, n2.register(i);
      }, 16947: function(t2, e2, r2) {
        var n2 = r2(46075), i = r2(73972), a = r2(79749), o = r2(27659).a0, s = r2(93612), l = r2(41675).getFromId, u = r2(89298).shouldShowZeroLine, c = "splom", f2 = {};
        function h(t3, e3, r3) {
          for (var n3 = r3.matrixOptions.data.length, i2 = e3._visibleDims, a2 = r3.viewOpts.ranges = new Array(n3), o2 = 0; o2 < i2.length; o2++) {
            var s2 = i2[o2], u2 = a2[o2] = new Array(4), c2 = l(t3, e3._diag[s2][0]);
            c2 && (u2[0] = c2.r2l(c2.range[0]), u2[2] = c2.r2l(c2.range[1]));
            var f3 = l(t3, e3._diag[s2][1]);
            f3 && (u2[1] = f3.r2l(f3.range[0]), u2[3] = f3.r2l(f3.range[1]));
          }
          r3.selectBatch.length || r3.unselectBatch.length ? r3.matrix.update({ ranges: a2 }, { ranges: a2 }) : r3.matrix.update({ ranges: a2 });
        }
        function p2(t3) {
          var e3 = t3._fullLayout, r3 = e3._glcanvas.data()[0].regl, i2 = e3._splomGrid;
          i2 || (i2 = e3._splomGrid = n2(r3)), i2.update(function(t4) {
            var e4, r4 = t4._context.plotGlPixelRatio, n3 = t4._fullLayout, i3 = n3._size, a2 = [0, 0, n3.width * r4, n3.height * r4], o2 = {};
            function s2(t5, e5, n4, i4, s3, l3) {
              n4 *= r4, i4 *= r4, s3 *= r4, l3 *= r4;
              var u2 = e5[t5 + "color"], c3 = e5[t5 + "width"], f4 = String(u2 + c3);
              f4 in o2 ? o2[f4].data.push(NaN, NaN, n4, i4, s3, l3) : o2[f4] = { data: [n4, i4, s3, l3], join: "rect", thickness: c3 * r4, color: u2, viewport: a2, range: a2, overlay: false };
            }
            for (e4 in n3._splomSubplots) {
              var l2, c2, f3 = n3._plots[e4], h2 = f3.xaxis, p3 = f3.yaxis, d2 = h2._gridVals, v = p3._gridVals, g2 = h2._offset, y = h2._length, m2 = p3._length, x = i3.b + p3.domain[0] * i3.h, b = -p3._m, _ = -b * p3.r2l(p3.range[0], p3.calendar);
              if (h2.showgrid)
                for (e4 = 0; e4 < d2.length; e4++)
                  l2 = g2 + h2.l2p(d2[e4].x), s2("grid", h2, l2, x, l2, x + m2);
              if (p3.showgrid)
                for (e4 = 0; e4 < v.length; e4++)
                  s2("grid", p3, g2, c2 = x + _ + b * v[e4].x, g2 + y, c2);
              u(t4, h2, p3) && (l2 = g2 + h2.l2p(0), s2("zeroline", h2, l2, x, l2, x + m2)), u(t4, p3, h2) && s2("zeroline", p3, g2, c2 = x + _ + 0, g2 + y, c2);
            }
            var w2 = [];
            for (e4 in o2)
              w2.push(o2[e4]);
            return w2;
          }(t3));
        }
        t2.exports = { name: c, attr: s.attr, attrRegex: s.attrRegex, layoutAttributes: s.layoutAttributes, supplyLayoutDefaults: s.supplyLayoutDefaults, drawFramework: s.drawFramework, plot: function(t3) {
          var e3 = t3._fullLayout, r3 = i.getModule(c), n3 = o(t3.calcdata, r3)[0];
          a(t3, ["ANGLE_instanced_arrays", "OES_element_index_uint"], f2) && (e3._hasOnlyLargeSploms && p2(t3), r3.plot(t3, {}, n3));
        }, drag: function(t3) {
          var e3 = t3.calcdata, r3 = t3._fullLayout;
          r3._hasOnlyLargeSploms && p2(t3);
          for (var n3 = 0; n3 < e3.length; n3++) {
            var i2 = e3[n3][0].trace, a2 = r3._splomScenes[i2.uid];
            "splom" === i2.type && a2 && a2.matrix && h(t3, i2, a2);
          }
        }, updateGrid: p2, clean: function(t3, e3, r3, n3) {
          var i2, a2 = {};
          if (n3._splomScenes) {
            for (i2 = 0; i2 < t3.length; i2++) {
              var o2 = t3[i2];
              "splom" === o2.type && (a2[o2.uid] = 1);
            }
            for (i2 = 0; i2 < r3.length; i2++) {
              var l2 = r3[i2];
              if (!a2[l2.uid]) {
                var u2 = n3._splomScenes[l2.uid];
                u2 && u2.destroy && u2.destroy(), n3._splomScenes[l2.uid] = null, delete n3._splomScenes[l2.uid];
              }
            }
          }
          0 === Object.keys(n3._splomScenes || {}).length && delete n3._splomScenes, n3._splomGrid && !e3._hasOnlyLargeSploms && n3._hasOnlyLargeSploms && (n3._splomGrid.destroy(), n3._splomGrid = null, delete n3._splomGrid), s.clean(t3, e3, r3, n3);
        }, updateFx: s.updateFx, toSVG: s.toSVG, reglPrecompiled: f2 };
      }, 87625: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(41675), a = r2(47761).calcMarkerSize, o = r2(47761).calcAxisExpansion, s = r2(36922), l = r2(19635).markerSelection, u = r2(19635).markerStyle, c = r2(10164), f2 = r2(50606).BADNUM, h = r2(78232).TOO_MANY_POINTS;
        t2.exports = function(t3, e3) {
          var r3, p2, d2, v, g2, y, m2 = e3.dimensions, x = e3._length, b = {}, _ = b.cdata = [], w2 = b.data = [], T = e3._visibleDims = [];
          function k(t4, r4) {
            for (var i2 = t4.makeCalcdata({ v: r4.values, vcalendar: e3.calendar }, "v"), a2 = 0; a2 < i2.length; a2++)
              i2[a2] = i2[a2] === f2 ? NaN : i2[a2];
            _.push(i2), w2.push("log" === t4.type ? n2.simpleMap(i2, t4.c2l) : i2);
          }
          for (r3 = 0; r3 < m2.length; r3++)
            if ((d2 = m2[r3]).visible) {
              if (v = i.getFromId(t3, e3._diag[r3][0]), g2 = i.getFromId(t3, e3._diag[r3][1]), v && g2 && v.type !== g2.type) {
                n2.log("Skipping splom dimension " + r3 + " with conflicting axis types");
                continue;
              }
              v ? (k(v, d2), g2 && "category" === g2.type && (g2._categories = v._categories.slice())) : k(g2, d2), T.push(r3);
            }
          for (s(t3, e3), n2.extendFlat(b, u(t3, e3)), y = _.length * x > h ? b.sizeAvg || Math.max(b.size, 3) : a(e3, x), p2 = 0; p2 < T.length; p2++)
            d2 = m2[r3 = T[p2]], v = i.getFromId(t3, e3._diag[r3][0]) || {}, g2 = i.getFromId(t3, e3._diag[r3][1]) || {}, o(t3, e3, v, g2, _[p2], _[p2], y);
          var A = c(t3, e3);
          return A.matrix || (A.matrix = true), A.matrixOptions = b, A.selectedOptions = l(t3, e3, e3.selected), A.unselectedOptions = l(t3, e3, e3.unselected), [{ x: false, y: false, t: {}, trace: e3 }];
        };
      }, 25784: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(85501), a = r2(46880), o = r2(34098), s = r2(49508), l = r2(94397), u = r2(68645).isOpenSymbol;
        function c(t3, e3) {
          function r3(r4, i3) {
            return n2.coerce(t3, e3, a.dimensions, r4, i3);
          }
          r3("label");
          var i2 = r3("values");
          i2 && i2.length ? r3("visible") : e3.visible = false, r3("axis.type"), r3("axis.matches");
        }
        t2.exports = function(t3, e3, r3, f2) {
          function h(r4, i2) {
            return n2.coerce(t3, e3, a, r4, i2);
          }
          var p2 = i(t3, e3, { name: "dimensions", handleItemDefaults: c }), d2 = h("diagonal.visible"), v = h("showupperhalf"), g2 = h("showlowerhalf");
          if (l(e3, p2, "values") && (d2 || v || g2)) {
            h("text"), h("hovertext"), h("hovertemplate"), h("xhoverformat"), h("yhoverformat"), s(t3, e3, r3, f2, h, { noAngleRef: true, noStandOff: true });
            var y = u(e3.marker.symbol), m2 = o.isBubble(e3);
            h("marker.line.width", y || m2 ? 1 : 0), function(t4, e4, r4, n3) {
              var i2, a2, o2 = e4.dimensions, s2 = o2.length, l2 = e4.showupperhalf, u2 = e4.showlowerhalf, c2 = e4.diagonal.visible, f3 = new Array(s2), h2 = new Array(s2);
              for (i2 = 0; i2 < s2; i2++) {
                var p3 = i2 ? i2 + 1 : "";
                f3[i2] = "x" + p3, h2[i2] = "y" + p3;
              }
              var d3 = n3("xaxes", f3), v2 = n3("yaxes", h2), g3 = e4._diag = new Array(s2);
              e4._xaxes = {}, e4._yaxes = {};
              var y2 = [], m3 = [];
              function x(t5, n4, i3, a3) {
                if (t5) {
                  var o3 = t5.charAt(0), s3 = r4._splomAxes[o3];
                  if (e4["_" + o3 + "axes"][t5] = 1, a3.push(t5), !(t5 in s3)) {
                    var l3 = s3[t5] = {};
                    i3 && (l3.label = i3.label || "", i3.visible && i3.axis && (i3.axis.type && (l3.type = i3.axis.type), i3.axis.matches && (l3.matches = n4)));
                  }
                }
              }
              var b = !c2 && !u2, _ = !c2 && !l2;
              for (e4._axesDim = {}, i2 = 0; i2 < s2; i2++) {
                var w2 = o2[i2], T = 0 === i2, k = i2 === s2 - 1, A = T && b || k && _ ? void 0 : d3[i2], M = T && _ || k && b ? void 0 : v2[i2];
                x(A, M, w2, y2), x(M, A, w2, m3), g3[i2] = [A, M], e4._axesDim[A] = i2, e4._axesDim[M] = i2;
              }
              for (i2 = 0; i2 < y2.length; i2++)
                for (a2 = 0; a2 < m3.length; a2++) {
                  var S = y2[i2] + m3[a2];
                  i2 > a2 && l2 || i2 < a2 && u2 ? r4._splomSubplots[S] = 1 : i2 !== a2 || !c2 && u2 && l2 || (r4._splomSubplots[S] = 1);
                }
              (!u2 || !c2 && l2 && u2) && (r4._splomGridDflt.xside = "bottom", r4._splomGridDflt.yside = "left");
            }(0, e3, f2, h), n2.coerceSelectionMarkerOpacity(e3, h);
          } else
            e3.visible = false;
        };
      }, 28801: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(36922), a = r2(19635).markerStyle;
        t2.exports = function(t3, e3) {
          var r3 = e3.trace, o = t3._fullLayout._splomScenes[r3.uid];
          if (o) {
            i(t3, r3), n2.extendFlat(o.matrixOptions, a(t3, r3));
            var s = n2.extendFlat({}, o.matrixOptions, o.viewOpts);
            o.matrix.update(s, null);
          }
        };
      }, 35948: function(t2, e2) {
        e2.getDimIndex = function(t3, e3) {
          for (var r2 = e3._id, n2 = { x: 0, y: 1 }[r2.charAt(0)], i = t3._visibleDims, a = 0; a < i.length; a++) {
            var o = i[a];
            if (t3._diag[o][n2] === r2)
              return a;
          }
          return false;
        };
      }, 8567: function(t2, e2, r2) {
        var n2 = r2(35948), i = r2(20794).calcHover;
        t2.exports = { hoverPoints: function(t3, e3, r3) {
          var a = t3.cd[0].trace, o = t3.scene.matrixOptions.cdata, s = t3.xa, l = t3.ya, u = s.c2p(e3), c = l.c2p(r3), f2 = t3.distance, h = n2.getDimIndex(a, s), p2 = n2.getDimIndex(a, l);
          if (false === h || false === p2)
            return [t3];
          for (var d2, v, g2 = o[h], y = o[p2], m2 = f2, x = 0; x < g2.length; x++) {
            var b = g2[x], _ = y[x], w2 = s.c2p(b) - u, T = l.c2p(_) - c, k = Math.sqrt(w2 * w2 + T * T);
            k < m2 && (m2 = v = k, d2 = x);
          }
          return t3.index = d2, t3.distance = m2, t3.dxy = v, void 0 === d2 ? [t3] : [i(t3, g2, y, a)];
        } };
      }, 6419: function(t2, e2, r2) {
        var n2 = r2(65017);
        n2.basePlotModule = r2(16947), t2.exports = n2;
      }, 79410: function(t2, e2, r2) {
        var n2 = r2(60487), i = r2(71828), a = r2(41675), o = r2(64505).selectMode;
        function s(t3, e3) {
          var r3, s2, l, u, c, f2 = t3._fullLayout, h = f2._size, p2 = e3.trace, d2 = e3.t, v = f2._splomScenes[p2.uid], g2 = v.matrixOptions, y = g2.cdata, m2 = f2._glcanvas.data()[0].regl, x = f2.dragmode;
          if (0 !== y.length) {
            g2.lower = p2.showupperhalf, g2.upper = p2.showlowerhalf, g2.diagonal = p2.diagonal.visible;
            var b = p2._visibleDims, _ = y.length, w2 = v.viewOpts = {};
            for (w2.ranges = new Array(_), w2.domains = new Array(_), c = 0; c < b.length; c++) {
              l = b[c];
              var T = w2.ranges[c] = new Array(4), k = w2.domains[c] = new Array(4);
              (r3 = a.getFromId(t3, p2._diag[l][0])) && (T[0] = r3._rl[0], T[2] = r3._rl[1], k[0] = r3.domain[0], k[2] = r3.domain[1]), (s2 = a.getFromId(t3, p2._diag[l][1])) && (T[1] = s2._rl[0], T[3] = s2._rl[1], k[1] = s2.domain[0], k[3] = s2.domain[1]);
            }
            var A = t3._context.plotGlPixelRatio, M = h.l * A, S = h.b * A, E = h.w * A, L = h.h * A;
            w2.viewport = [M, S, E + M, L + S], true === v.matrix && (v.matrix = n2(m2));
            var C = f2.clickmode.indexOf("select") > -1, P = true;
            if (o(x) || p2.selectedpoints || C) {
              var O = p2._length;
              if (p2.selectedpoints) {
                v.selectBatch = p2.selectedpoints;
                var I = p2.selectedpoints, D = {};
                for (l = 0; l < I.length; l++)
                  D[I[l]] = true;
                var z = [];
                for (l = 0; l < O; l++)
                  D[l] || z.push(l);
                v.unselectBatch = z;
              }
              var R = d2.xpx = new Array(_), F = d2.ypx = new Array(_);
              for (c = 0; c < b.length; c++) {
                if (l = b[c], r3 = a.getFromId(t3, p2._diag[l][0]))
                  for (R[c] = new Array(O), u = 0; u < O; u++)
                    R[c][u] = r3.c2p(y[c][u]);
                if (s2 = a.getFromId(t3, p2._diag[l][1]))
                  for (F[c] = new Array(O), u = 0; u < O; u++)
                    F[c][u] = s2.c2p(y[c][u]);
              }
              if (v.selectBatch.length || v.unselectBatch.length) {
                var B = i.extendFlat({}, g2, v.unselectedOptions, w2), N = i.extendFlat({}, g2, v.selectedOptions, w2);
                v.matrix.update(B, N), P = false;
              }
            } else
              d2.xpx = d2.ypx = null;
            if (P) {
              var j = i.extendFlat({}, g2, w2);
              v.matrix.update(j, null);
            }
          }
        }
        t2.exports = function(t3, e3, r3) {
          if (r3.length)
            for (var n3 = 0; n3 < r3.length; n3++)
              s(t3, r3[n3][0]);
        };
      }, 10164: function(t2, e2, r2) {
        var n2 = r2(71828);
        t2.exports = function(t3, e3) {
          var r3 = t3._fullLayout, i = e3.uid, a = r3._splomScenes;
          a || (a = r3._splomScenes = {});
          var o = { dirty: true, selectBatch: [], unselectBatch: [] }, s = a[e3.uid];
          return s || ((s = a[i] = n2.extendFlat({}, o, { matrix: false, selectBatch: [], unselectBatch: [] })).draw = function() {
            s.matrix && s.matrix.draw && (s.selectBatch.length || s.unselectBatch.length ? s.matrix.draw(s.unselectBatch, s.selectBatch) : s.matrix.draw()), s.dirty = false;
          }, s.destroy = function() {
            s.matrix && s.matrix.destroy && s.matrix.destroy(), s.matrixOptions = null, s.selectBatch = null, s.unselectBatch = null, s = null;
          }), s.dirty || n2.extendFlat(s, o), s;
        };
      }, 8689: function(t2, e2, r2) {
        var n2 = r2(71828), i = n2.pushUnique, a = r2(34098), o = r2(35948);
        t2.exports = function(t3, e3) {
          var r3 = t3.cd, s = r3[0].trace, l = r3[0].t, u = t3.scene, c = u.matrixOptions.cdata, f2 = t3.xaxis, h = t3.yaxis, p2 = [];
          if (!u)
            return p2;
          var d2 = !a.hasMarkers(s) && !a.hasText(s);
          if (true !== s.visible || d2)
            return p2;
          var v = o.getDimIndex(s, f2), g2 = o.getDimIndex(s, h);
          if (false === v || false === g2)
            return p2;
          var y = l.xpx[v], m2 = l.ypx[g2], x = c[v], b = c[g2], _ = (t3.scene.selectBatch || []).slice(), w2 = [];
          if (false !== e3 && !e3.degenerate)
            for (var T = 0; T < x.length; T++)
              e3.contains([y[T], m2[T]], null, T, t3) ? (p2.push({ pointNumber: T, x: x[T], y: b[T] }), i(_, T)) : -1 !== _.indexOf(T) ? i(_, T) : w2.push(T);
          var k = u.matrixOptions;
          return _.length || w2.length ? u.selectBatch.length || u.unselectBatch.length || u.matrix.update(u.unselectedOptions, n2.extendFlat({}, k, u.selectedOptions, u.viewOpts)) : u.matrix.update(k, null), u.selectBatch = _, u.unselectBatch = w2, p2;
        };
      }, 21850: function(t2, e2, r2) {
        var n2 = r2(50693), i = r2(12663).axisHoverFormat, a = r2(5386).f, o = r2(2418), s = r2(9012), l = r2(1426).extendFlat, u = { x: { valType: "data_array", editType: "calc+clearAxisTypes" }, y: { valType: "data_array", editType: "calc+clearAxisTypes" }, z: { valType: "data_array", editType: "calc+clearAxisTypes" }, u: { valType: "data_array", editType: "calc" }, v: { valType: "data_array", editType: "calc" }, w: { valType: "data_array", editType: "calc" }, starts: { x: { valType: "data_array", editType: "calc" }, y: { valType: "data_array", editType: "calc" }, z: { valType: "data_array", editType: "calc" }, editType: "calc" }, maxdisplayed: { valType: "integer", min: 0, dflt: 1e3, editType: "calc" }, sizeref: { valType: "number", editType: "calc", min: 0, dflt: 1 }, text: { valType: "string", dflt: "", editType: "calc" }, hovertext: { valType: "string", dflt: "", editType: "calc" }, hovertemplate: a({ editType: "calc" }, { keys: ["tubex", "tubey", "tubez", "tubeu", "tubev", "tubew", "norm", "divergence"] }), uhoverformat: i("u", 1), vhoverformat: i("v", 1), whoverformat: i("w", 1), xhoverformat: i("x"), yhoverformat: i("y"), zhoverformat: i("z"), showlegend: l({}, s.showlegend, { dflt: false }) };
        l(u, n2("", { colorAttr: "u/v/w norm", showScaleDflt: true, editTypeOverride: "calc" })), ["opacity", "lightposition", "lighting"].forEach(function(t3) {
          u[t3] = o[t3];
        }), u.hoverinfo = l({}, s.hoverinfo, { editType: "calc", flags: ["x", "y", "z", "u", "v", "w", "norm", "divergence", "text", "name"], dflt: "x+y+z+norm+text+name" }), u.transforms = void 0, t2.exports = u;
      }, 88489: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(78803);
        function a(t3) {
          var e3, r3, i2, a2, s2, l, u, c, f2, h, p2, d2, v = t3._x, g2 = t3._y, y = t3._z, m2 = t3._len, x = -1 / 0, b = 1 / 0, _ = -1 / 0, w2 = 1 / 0, T = -1 / 0, k = 1 / 0, A = "";
          for (m2 && (u = v[0], f2 = g2[0], p2 = y[0]), m2 > 1 && (c = v[m2 - 1], h = g2[m2 - 1], d2 = y[m2 - 1]), e3 = 0; e3 < m2; e3++)
            x = Math.max(x, v[e3]), b = Math.min(b, v[e3]), _ = Math.max(_, g2[e3]), w2 = Math.min(w2, g2[e3]), T = Math.max(T, y[e3]), k = Math.min(k, y[e3]), a2 || v[e3] === u || (a2 = true, A += "x"), s2 || g2[e3] === f2 || (s2 = true, A += "y"), l || y[e3] === p2 || (l = true, A += "z");
          a2 || (A += "x"), s2 || (A += "y"), l || (A += "z");
          var M = o(t3._x), S = o(t3._y), E = o(t3._z);
          A = (A = (A = A.replace("x", (u > c ? "-" : "+") + "x")).replace("y", (f2 > h ? "-" : "+") + "y")).replace("z", (p2 > d2 ? "-" : "+") + "z");
          var L = function() {
            m2 = 0, M = [], S = [], E = [];
          };
          (!m2 || m2 < M.length * S.length * E.length) && L();
          var C = function(t4) {
            return "x" === t4 ? v : "y" === t4 ? g2 : y;
          }, P = function(t4) {
            return "x" === t4 ? M : "y" === t4 ? S : E;
          }, O = function(t4) {
            return t4[m2 - 1] < t4[0] ? -1 : 1;
          }, I = C(A[1]), D = C(A[3]), z = C(A[5]), R = P(A[1]).length, F = P(A[3]).length, B = P(A[5]).length, N = false, j = function(t4, e4, r4) {
            return R * (F * t4 + e4) + r4;
          }, U = O(C(A[1])), V = O(C(A[3])), H = O(C(A[5]));
          for (e3 = 0; e3 < B - 1; e3++) {
            for (r3 = 0; r3 < F - 1; r3++) {
              for (i2 = 0; i2 < R - 1; i2++) {
                var q2 = j(e3, r3, i2), G = j(e3, r3, i2 + 1), Z = j(e3, r3 + 1, i2), Y = j(e3 + 1, r3, i2);
                if (I[q2] * U < I[G] * U && D[q2] * V < D[Z] * V && z[q2] * H < z[Y] * H || (N = true), N)
                  break;
              }
              if (N)
                break;
            }
            if (N)
              break;
          }
          return N && (n2.warn("Encountered arbitrary coordinates! Unable to input data grid."), L()), { xMin: b, yMin: w2, zMin: k, xMax: x, yMax: _, zMax: T, Xs: M, Ys: S, Zs: E, len: m2, fill: A };
        }
        function o(t3) {
          return n2.distinctVals(t3).vals;
        }
        function s(t3, e3) {
          if (void 0 === e3 && (e3 = t3.length), n2.isTypedArray(t3))
            return t3.subarray(0, e3);
          for (var r3 = [], i2 = 0; i2 < e3; i2++)
            r3[i2] = +t3[i2];
          return r3;
        }
        t2.exports = { calc: function(t3, e3) {
          e3._len = Math.min(e3.u.length, e3.v.length, e3.w.length, e3.x.length, e3.y.length, e3.z.length), e3._u = s(e3.u, e3._len), e3._v = s(e3.v, e3._len), e3._w = s(e3.w, e3._len), e3._x = s(e3.x, e3._len), e3._y = s(e3.y, e3._len), e3._z = s(e3.z, e3._len);
          var r3 = a(e3);
          e3._gridFill = r3.fill, e3._Xs = r3.Xs, e3._Ys = r3.Ys, e3._Zs = r3.Zs, e3._len = r3.len;
          var n3, o2, l, u = 0;
          e3.starts && (n3 = s(e3.starts.x || []), o2 = s(e3.starts.y || []), l = s(e3.starts.z || []), u = Math.min(n3.length, o2.length, l.length)), e3._startsX = n3 || [], e3._startsY = o2 || [], e3._startsZ = l || [];
          var c, f2 = 0, h = 1 / 0;
          for (c = 0; c < e3._len; c++) {
            var p2 = e3._u[c], d2 = e3._v[c], v = e3._w[c], g2 = Math.sqrt(p2 * p2 + d2 * d2 + v * v);
            f2 = Math.max(f2, g2), h = Math.min(h, g2);
          }
          for (i(t3, e3, { vals: [h, f2], containerStr: "", cLetter: "c" }), c = 0; c < u; c++) {
            var y = n3[c];
            r3.xMax = Math.max(r3.xMax, y), r3.xMin = Math.min(r3.xMin, y);
            var m2 = o2[c];
            r3.yMax = Math.max(r3.yMax, m2), r3.yMin = Math.min(r3.yMin, m2);
            var x = l[c];
            r3.zMax = Math.max(r3.zMax, x), r3.zMin = Math.min(r3.zMin, x);
          }
          e3._slen = u, e3._normMax = f2, e3._xbnds = [r3.xMin, r3.xMax], e3._ybnds = [r3.yMin, r3.yMax], e3._zbnds = [r3.zMin, r3.zMax];
        }, filter: s, processGrid: a };
      }, 90154: function(t2, e2, r2) {
        var n2 = r2(9330).gl_streamtube3d, i = n2.createTubeMesh, a = r2(71828), o = r2(81697).parseColorScale, s = r2(21081).extractOpts, l = r2(90060), u = { xaxis: 0, yaxis: 1, zaxis: 2 };
        function c(t3, e3) {
          this.scene = t3, this.uid = e3, this.mesh = null, this.data = null;
        }
        var f2 = c.prototype;
        function h(t3) {
          var e3 = t3.length;
          return e3 > 2 ? t3.slice(1, e3 - 1) : 2 === e3 ? [(t3[0] + t3[1]) / 2] : t3;
        }
        function p2(t3) {
          var e3 = t3.length;
          return 1 === e3 ? [0.5, 0.5] : [t3[1] - t3[0], t3[e3 - 1] - t3[e3 - 2]];
        }
        function d2(t3, e3) {
          var r3 = t3.fullSceneLayout, i2 = t3.dataScale, c2 = e3._len, f3 = {};
          function d3(t4, e4) {
            var n3 = r3[e4], o2 = i2[u[e4]];
            return a.simpleMap(t4, function(t5) {
              return n3.d2l(t5) * o2;
            });
          }
          if (f3.vectors = l(d3(e3._u, "xaxis"), d3(e3._v, "yaxis"), d3(e3._w, "zaxis"), c2), !c2)
            return { positions: [], cells: [] };
          var v = d3(e3._Xs, "xaxis"), g2 = d3(e3._Ys, "yaxis"), y = d3(e3._Zs, "zaxis");
          if (f3.meshgrid = [v, g2, y], f3.gridFill = e3._gridFill, e3._slen)
            f3.startingPositions = l(d3(e3._startsX, "xaxis"), d3(e3._startsY, "yaxis"), d3(e3._startsZ, "zaxis"));
          else {
            for (var m2 = g2[0], x = h(v), b = h(y), _ = new Array(x.length * b.length), w2 = 0, T = 0; T < x.length; T++)
              for (var k = 0; k < b.length; k++)
                _[w2++] = [x[T], m2, b[k]];
            f3.startingPositions = _;
          }
          f3.colormap = o(e3), f3.tubeSize = e3.sizeref, f3.maxLength = e3.maxdisplayed;
          var A = d3(e3._xbnds, "xaxis"), M = d3(e3._ybnds, "yaxis"), S = d3(e3._zbnds, "zaxis"), E = p2(v), L = p2(g2), C = p2(y), P = [[A[0] - E[0], M[0] - L[0], S[0] - C[0]], [A[1] + E[1], M[1] + L[1], S[1] + C[1]]], O = n2(f3, P), I = s(e3);
          O.vertexIntensityBounds = [I.min / e3._normMax, I.max / e3._normMax];
          var D = e3.lightposition;
          return O.lightPosition = [D.x, D.y, D.z], O.ambient = e3.lighting.ambient, O.diffuse = e3.lighting.diffuse, O.specular = e3.lighting.specular, O.roughness = e3.lighting.roughness, O.fresnel = e3.lighting.fresnel, O.opacity = e3.opacity, e3._pad = O.tubeScale * e3.sizeref * 2, O;
        }
        f2.handlePick = function(t3) {
          var e3 = this.scene.fullSceneLayout, r3 = this.scene.dataScale;
          function n3(t4, n4) {
            var i3 = e3[n4], a3 = r3[u[n4]];
            return i3.l2c(t4) / a3;
          }
          if (t3.object === this.mesh) {
            var i2 = t3.data.position, a2 = t3.data.velocity;
            return t3.traceCoordinate = [n3(i2[0], "xaxis"), n3(i2[1], "yaxis"), n3(i2[2], "zaxis"), n3(a2[0], "xaxis"), n3(a2[1], "yaxis"), n3(a2[2], "zaxis"), t3.data.intensity * this.data._normMax, t3.data.divergence], t3.textLabel = this.data.hovertext || this.data.text, true;
          }
        }, f2.update = function(t3) {
          this.data = t3;
          var e3 = d2(this.scene, t3);
          this.mesh.update(e3);
        }, f2.dispose = function() {
          this.scene.glplot.remove(this.mesh), this.mesh.dispose();
        }, t2.exports = function(t3, e3) {
          var r3 = t3.glplot.gl, n3 = d2(t3, e3), a2 = i(r3, n3), o2 = new c(t3, e3.uid);
          return o2.mesh = a2, o2.data = e3, a2._trace = o2, t3.glplot.add(a2), o2;
        };
      }, 22459: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(1586), a = r2(21850);
        t2.exports = function(t3, e3, r3, o) {
          function s(r4, i2) {
            return n2.coerce(t3, e3, a, r4, i2);
          }
          var l = s("u"), u = s("v"), c = s("w"), f2 = s("x"), h = s("y"), p2 = s("z");
          l && l.length && u && u.length && c && c.length && f2 && f2.length && h && h.length && p2 && p2.length ? (s("starts.x"), s("starts.y"), s("starts.z"), s("maxdisplayed"), s("sizeref"), s("lighting.ambient"), s("lighting.diffuse"), s("lighting.specular"), s("lighting.roughness"), s("lighting.fresnel"), s("lightposition.x"), s("lightposition.y"), s("lightposition.z"), i(t3, e3, o, s, { prefix: "", cLetter: "c" }), s("text"), s("hovertext"), s("hovertemplate"), s("uhoverformat"), s("vhoverformat"), s("whoverformat"), s("xhoverformat"), s("yhoverformat"), s("zhoverformat"), e3._length = null) : e3.visible = false;
        };
      }, 61510: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "streamtube", basePlotModule: r2(58547), categories: ["gl3d", "showLegend"], attributes: r2(21850), supplyDefaults: r2(22459), colorbar: { min: "cmin", max: "cmax" }, calc: r2(88489).calc, plot: r2(90154), eventData: function(t3, e3) {
          return t3.tubex = t3.x, t3.tubey = t3.y, t3.tubez = t3.z, t3.tubeu = e3.traceCoordinate[3], t3.tubev = e3.traceCoordinate[4], t3.tubew = e3.traceCoordinate[5], t3.norm = e3.traceCoordinate[6], t3.divergence = e3.traceCoordinate[7], delete t3.x, delete t3.y, delete t3.z, t3;
        }, meta: {} };
      }, 57564: function(t2, e2, r2) {
        var n2 = r2(9012), i = r2(5386).f, a = r2(5386).s, o = r2(50693), s = r2(27670).Y, l = r2(34e3), u = r2(7055), c = r2(1426).extendFlat;
        t2.exports = { labels: { valType: "data_array", editType: "calc" }, parents: { valType: "data_array", editType: "calc" }, values: { valType: "data_array", editType: "calc" }, branchvalues: { valType: "enumerated", values: ["remainder", "total"], dflt: "remainder", editType: "calc" }, count: { valType: "flaglist", flags: ["branches", "leaves"], dflt: "leaves", editType: "calc" }, level: { valType: "any", editType: "plot", anim: true }, maxdepth: { valType: "integer", editType: "plot", dflt: -1 }, marker: c({ colors: { valType: "data_array", editType: "calc" }, line: { color: c({}, l.marker.line.color, { dflt: null }), width: c({}, l.marker.line.width, { dflt: 1 }), editType: "calc" }, editType: "calc" }, o("marker", { colorAttr: "colors", anim: false })), leaf: { opacity: { valType: "number", editType: "style", min: 0, max: 1 }, editType: "plot" }, text: l.text, textinfo: { valType: "flaglist", flags: ["label", "text", "value", "current path", "percent root", "percent entry", "percent parent"], extras: ["none"], editType: "plot" }, texttemplate: a({ editType: "plot" }, { keys: u.eventDataKeys.concat(["label", "value"]) }), hovertext: l.hovertext, hoverinfo: c({}, n2.hoverinfo, { flags: ["label", "text", "value", "name", "current path", "percent root", "percent entry", "percent parent"], dflt: "label+text+value+name" }), hovertemplate: i({}, { keys: u.eventDataKeys }), textfont: l.textfont, insidetextorientation: l.insidetextorientation, insidetextfont: l.insidetextfont, outsidetextfont: c({}, l.outsidetextfont, {}), rotation: { valType: "angle", dflt: 0, editType: "plot" }, sort: l.sort, root: { color: { valType: "color", editType: "calc", dflt: "rgba(0,0,0,0)" }, editType: "calc" }, domain: s({ name: "sunburst", trace: true, editType: "calc" }) };
      }, 66888: function(t2, e2, r2) {
        var n2 = r2(74875);
        e2.name = "sunburst", e2.plot = function(t3, r3, i, a) {
          n2.plotBasePlot(e2.name, t3, r3, i, a);
        }, e2.clean = function(t3, r3, i, a) {
          n2.cleanBasePlot(e2.name, t3, r3, i, a);
        };
      }, 52147: function(t2, e2, r2) {
        var n2 = r2(674), i = r2(92770), a = r2(71828), o = r2(21081).makeColorScaleFuncFromTrace, s = r2(32354).makePullColorFn, l = r2(32354).generateExtendedColors, u = r2(21081).calc, c = r2(50606).ALMOST_EQUAL, f2 = {}, h = {}, p2 = {};
        function d2(t3, e3, r3) {
          var n3 = 0, i2 = t3.children;
          if (i2) {
            for (var a2 = i2.length, o2 = 0; o2 < a2; o2++)
              n3 += d2(i2[o2], e3, r3);
            r3.branches && n3++;
          } else
            r3.leaves && n3++;
          return t3.value = t3.data.data.value = n3, e3._values || (e3._values = []), e3._values[t3.data.data.i] = n3, n3;
        }
        e2.calc = function(t3, e3) {
          var r3, l2, f3, h2, p3, v, g2 = t3._fullLayout, y = e3.ids, m2 = a.isArrayOrTypedArray(y), x = e3.labels, b = e3.parents, _ = e3.values, w2 = a.isArrayOrTypedArray(_), T = [], k = {}, A = {}, M = function(t4) {
            return t4 || "number" == typeof t4;
          }, S = function(t4) {
            return !w2 || i(_[t4]) && _[t4] >= 0;
          };
          m2 ? (r3 = Math.min(y.length, b.length), l2 = function(t4) {
            return M(y[t4]) && S(t4);
          }, f3 = function(t4) {
            return String(y[t4]);
          }) : (r3 = Math.min(x.length, b.length), l2 = function(t4) {
            return M(x[t4]) && S(t4);
          }, f3 = function(t4) {
            return String(x[t4]);
          }), w2 && (r3 = Math.min(r3, _.length));
          for (var E = 0; E < r3; E++)
            if (l2(E)) {
              var L = f3(E), C = M(b[E]) ? String(b[E]) : "", P = { i: E, id: L, pid: C, label: M(x[E]) ? String(x[E]) : "" };
              w2 && (P.v = +_[E]), T.push(P), p3 = L, k[h2 = C] ? k[h2].push(p3) : k[h2] = [p3], A[p3] = 1;
            }
          if (k[""]) {
            if (k[""].length > 1) {
              for (var O = a.randstr(), I = 0; I < T.length; I++)
                "" === T[I].pid && (T[I].pid = O);
              T.unshift({ hasMultipleRoots: true, id: O, pid: "", label: "" });
            }
          } else {
            var D, z = [];
            for (D in k)
              A[D] || z.push(D);
            if (1 !== z.length)
              return a.warn(["Multiple implied roots, cannot build", e3.type, "hierarchy of", e3.name + ".", "These roots include:", z.join(", ")].join(" "));
            D = z[0], T.unshift({ hasImpliedRoot: true, id: D, pid: "", label: D });
          }
          try {
            v = n2.stratify().id(function(t4) {
              return t4.id;
            }).parentId(function(t4) {
              return t4.pid;
            })(T);
          } catch (t4) {
            return a.warn(["Failed to build", e3.type, "hierarchy of", e3.name + ".", "Error:", t4.message].join(" "));
          }
          var R = n2.hierarchy(v), F = false;
          if (w2)
            switch (e3.branchvalues) {
              case "remainder":
                R.sum(function(t4) {
                  return t4.data.v;
                });
                break;
              case "total":
                R.each(function(t4) {
                  var r4 = t4.data.data, n3 = r4.v;
                  if (t4.children) {
                    var i2 = t4.children.reduce(function(t5, e4) {
                      return t5 + e4.data.data.v;
                    }, 0);
                    if ((r4.hasImpliedRoot || r4.hasMultipleRoots) && (n3 = i2), n3 < i2 * c)
                      return F = true, a.warn(["Total value for node", t4.data.data.id, "of", e3.name, "is smaller than the sum of its children.", "\nparent value =", n3, "\nchildren sum =", i2].join(" "));
                  }
                  t4.value = n3;
                });
            }
          else
            d2(R, e3, { branches: -1 !== e3.count.indexOf("branches"), leaves: -1 !== e3.count.indexOf("leaves") });
          if (!F) {
            var B, N;
            e3.sort && R.sort(function(t4, e4) {
              return e4.value - t4.value;
            });
            var j = e3.marker.colors || [], U = !!j.length;
            return e3._hasColorscale ? (U || (j = w2 ? e3.values : e3._values), u(t3, e3, { vals: j, containerStr: "marker", cLetter: "c" }), N = o(e3.marker)) : B = s(g2["_" + e3.type + "colormap"]), R.each(function(t4) {
              var r4 = t4.data.data;
              r4.color = e3._hasColorscale ? N(j[r4.i]) : B(j[r4.i], r4.id);
            }), T[0].hierarchy = R, T;
          }
        }, e2._runCrossTraceCalc = function(t3, e3) {
          var r3 = e3._fullLayout, n3 = e3.calcdata, i2 = r3[t3 + "colorway"], a2 = r3["_" + t3 + "colormap"];
          r3["extend" + t3 + "colors"] && (i2 = l(i2, "icicle" === t3 ? p2 : "treemap" === t3 ? h : f2));
          var o2, s2 = 0;
          function u2(t4) {
            var e4 = t4.data.data, r4 = e4.id;
            false === e4.color && (a2[r4] ? e4.color = a2[r4] : t4.parent ? t4.parent.parent ? e4.color = t4.parent.data.data.color : (a2[r4] = e4.color = i2[s2 % i2.length], s2++) : e4.color = o2);
          }
          for (var c2 = 0; c2 < n3.length; c2++) {
            var d3 = n3[c2][0];
            d3.trace.type === t3 && d3.hierarchy && (o2 = d3.trace.root.color, d3.hierarchy.each(u2));
          }
        }, e2.crossTraceCalc = function(t3) {
          return e2._runCrossTraceCalc("sunburst", t3);
        };
      }, 7055: function(t2) {
        t2.exports = { CLICK_TRANSITION_TIME: 750, CLICK_TRANSITION_EASING: "linear", eventDataKeys: ["currentPath", "root", "entry", "percentRoot", "percentEntry", "percentParent"] };
      }, 17094: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(57564), a = r2(27670).c, o = r2(90769).handleText, s = r2(21081), l = s.hasColorscale, u = s.handleDefaults;
        t2.exports = function(t3, e3, r3, s2) {
          function c(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          var f2 = c("labels"), h = c("parents");
          if (f2 && f2.length && h && h.length) {
            var p2 = c("values");
            p2 && p2.length ? c("branchvalues") : c("count"), c("level"), c("maxdepth"), c("marker.line.width") && c("marker.line.color", s2.paper_bgcolor), c("marker.colors");
            var d2 = e3._hasColorscale = l(t3, "marker", "colors") || (t3.marker || {}).coloraxis;
            d2 && u(t3, e3, s2, c, { prefix: "marker.", cLetter: "c" }), c("leaf.opacity", d2 ? 1 : 0.7);
            var v = c("text");
            c("texttemplate"), e3.texttemplate || c("textinfo", Array.isArray(v) ? "text+label" : "label"), c("hovertext"), c("hovertemplate"), o(t3, e3, s2, c, "auto", { moduleHasSelected: false, moduleHasUnselected: false, moduleHasConstrain: false, moduleHasCliponaxis: false, moduleHasTextangle: false, moduleHasInsideanchor: false }), c("insidetextorientation"), c("sort"), c("rotation"), c("root.color"), a(e3, s2, c), e3._length = null;
          } else
            e3.visible = false;
        };
      }, 83523: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(73972), a = r2(23469).appendArrayPointValue, o = r2(30211), s = r2(71828), l = r2(11086), u = r2(2791), c = r2(53581).formatPieValue;
        function f2(t3, e3, r3) {
          for (var n3 = t3.data.data, i2 = { curveNumber: e3.index, pointNumber: n3.i, data: e3._input, fullData: e3 }, o2 = 0; o2 < r3.length; o2++) {
            var s2 = r3[o2];
            s2 in t3 && (i2[s2] = t3[s2]);
          }
          return "parentString" in t3 && !u.isHierarchyRoot(t3) && (i2.parent = t3.parentString), a(i2, e3, n3.i), i2;
        }
        t2.exports = function(t3, e3, r3, a2, h) {
          var p2 = a2[0], d2 = p2.trace, v = p2.hierarchy, g2 = "sunburst" === d2.type, y = "treemap" === d2.type || "icicle" === d2.type;
          "_hasHoverLabel" in d2 || (d2._hasHoverLabel = false), "_hasHoverEvent" in d2 || (d2._hasHoverEvent = false), t3.on("mouseover", function(i2) {
            var a3 = r3._fullLayout;
            if (!r3._dragging && false !== a3.hovermode) {
              var l2, m2 = r3._fullData[d2.index], x = i2.data.data, b = x.i, _ = u.isHierarchyRoot(i2), w2 = u.getParent(v, i2), T = u.getValue(i2), k = function(t4) {
                return s.castOption(m2, b, t4);
              }, A = k("hovertemplate"), M = o.castHoverinfo(m2, a3, b), S = a3.separators;
              if (A || M && "none" !== M && "skip" !== M) {
                var E, L;
                g2 && (E = p2.cx + i2.pxmid[0] * (1 - i2.rInscribed), L = p2.cy + i2.pxmid[1] * (1 - i2.rInscribed)), y && (E = i2._hoverX, L = i2._hoverY);
                var C, P = {}, O = [], I = [], D = function(t4) {
                  return -1 !== O.indexOf(t4);
                };
                M && (O = "all" === M ? m2._module.attributes.hoverinfo.flags : M.split("+")), P.label = x.label, D("label") && P.label && I.push(P.label), x.hasOwnProperty("v") && (P.value = x.v, P.valueLabel = c(P.value, S), D("value") && I.push(P.valueLabel)), P.currentPath = i2.currentPath = u.getPath(i2.data), D("current path") && !_ && I.push(P.currentPath);
                var z = [], R = function() {
                  -1 === z.indexOf(C) && (I.push(C), z.push(C));
                };
                P.percentParent = i2.percentParent = T / u.getValue(w2), P.parent = i2.parentString = u.getPtLabel(w2), D("percent parent") && (C = u.formatPercent(P.percentParent, S) + " of " + P.parent, R()), P.percentEntry = i2.percentEntry = T / u.getValue(e3), P.entry = i2.entry = u.getPtLabel(e3), !D("percent entry") || _ || i2.onPathbar || (C = u.formatPercent(P.percentEntry, S) + " of " + P.entry, R()), P.percentRoot = i2.percentRoot = T / u.getValue(v), P.root = i2.root = u.getPtLabel(v), D("percent root") && !_ && (C = u.formatPercent(P.percentRoot, S) + " of " + P.root, R()), P.text = k("hovertext") || k("text"), D("text") && (C = P.text, s.isValidTextValue(C) && I.push(C)), l2 = [f2(i2, m2, h.eventDataKeys)];
                var F = { trace: m2, y: L, _x0: i2._x0, _x1: i2._x1, _y0: i2._y0, _y1: i2._y1, text: I.join("<br>"), name: A || D("name") ? m2.name : void 0, color: k("hoverlabel.bgcolor") || x.color, borderColor: k("hoverlabel.bordercolor"), fontFamily: k("hoverlabel.font.family"), fontSize: k("hoverlabel.font.size"), fontColor: k("hoverlabel.font.color"), nameLength: k("hoverlabel.namelength"), textAlign: k("hoverlabel.align"), hovertemplate: A, hovertemplateLabels: P, eventData: l2 };
                g2 && (F.x0 = E - i2.rInscribed * i2.rpx1, F.x1 = E + i2.rInscribed * i2.rpx1, F.idealAlign = i2.pxmid[0] < 0 ? "left" : "right"), y && (F.x = E, F.idealAlign = E < 0 ? "left" : "right");
                var B = [];
                o.loneHover(F, { container: a3._hoverlayer.node(), outerContainer: a3._paper.node(), gd: r3, inOut_bbox: B }), l2[0].bbox = B[0], d2._hasHoverLabel = true;
              }
              if (y) {
                var N = t3.select("path.surface");
                h.styleOne(N, i2, m2, { hovered: true });
              }
              d2._hasHoverEvent = true, r3.emit("plotly_hover", { points: l2 || [f2(i2, m2, h.eventDataKeys)], event: n2.event });
            }
          }), t3.on("mouseout", function(e4) {
            var i2 = r3._fullLayout, a3 = r3._fullData[d2.index], s2 = n2.select(this).datum();
            if (d2._hasHoverEvent && (e4.originalEvent = n2.event, r3.emit("plotly_unhover", { points: [f2(s2, a3, h.eventDataKeys)], event: n2.event }), d2._hasHoverEvent = false), d2._hasHoverLabel && (o.loneUnhover(i2._hoverlayer.node()), d2._hasHoverLabel = false), y) {
              var l2 = t3.select("path.surface");
              h.styleOne(l2, s2, a3, { hovered: false });
            }
          }), t3.on("click", function(t4) {
            var e4 = r3._fullLayout, a3 = r3._fullData[d2.index], s2 = g2 && (u.isHierarchyRoot(t4) || u.isLeaf(t4)), c2 = u.getPtId(t4), p3 = u.isEntry(t4) ? u.findEntryWithChild(v, c2) : u.findEntryWithLevel(v, c2), y2 = u.getPtId(p3), m2 = { points: [f2(t4, a3, h.eventDataKeys)], event: n2.event };
            s2 || (m2.nextLevel = y2);
            var x = l.triggerHandler(r3, "plotly_" + d2.type + "click", m2);
            if (false !== x && e4.hovermode && (r3._hoverdata = [f2(t4, a3, h.eventDataKeys)], o.click(r3, n2.event)), !s2 && false !== x && !r3._dragging && !r3._transitioning) {
              i.call("_storeDirectGUIEdit", a3, e4._tracePreGUI[a3.uid], { level: a3.level });
              var b = { data: [{ level: y2 }], traces: [d2.index] }, _ = { frame: { redraw: false, duration: h.transitionTime }, transition: { duration: h.transitionTime, easing: h.transitionEasing }, mode: "immediate", fromcurrent: true };
              o.loneUnhover(e4._hoverlayer.node()), i.call("animate", r3, b, _);
            }
          });
        };
      }, 2791: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901), a = r2(6964), o = r2(53581);
        function s(t3) {
          return t3.data.data.pid;
        }
        e2.findEntryWithLevel = function(t3, r3) {
          var n3;
          return r3 && t3.eachAfter(function(t4) {
            if (e2.getPtId(t4) === r3)
              return n3 = t4.copy();
          }), n3 || t3;
        }, e2.findEntryWithChild = function(t3, r3) {
          var n3;
          return t3.eachAfter(function(t4) {
            for (var i2 = t4.children || [], a2 = 0; a2 < i2.length; a2++) {
              var o2 = i2[a2];
              if (e2.getPtId(o2) === r3)
                return n3 = t4.copy();
            }
          }), n3 || t3;
        }, e2.isEntry = function(t3) {
          return !t3.parent;
        }, e2.isLeaf = function(t3) {
          return !t3.children;
        }, e2.getPtId = function(t3) {
          return t3.data.data.id;
        }, e2.getPtLabel = function(t3) {
          return t3.data.data.label;
        }, e2.getValue = function(t3) {
          return t3.value;
        }, e2.isHierarchyRoot = function(t3) {
          return "" === s(t3);
        }, e2.setSliceCursor = function(t3, r3, n3) {
          var i2 = n3.isTransitioning;
          if (!i2) {
            var o2 = t3.datum();
            i2 = n3.hideOnRoot && e2.isHierarchyRoot(o2) || n3.hideOnLeaves && e2.isLeaf(o2);
          }
          a(t3, i2 ? null : "pointer");
        }, e2.getInsideTextFontKey = function(t3, e3, r3, i2, a2) {
          var o2 = (a2 || {}).onPathbar ? "pathbar.textfont" : "insidetextfont", s2 = r3.data.data.i;
          return n2.castOption(e3, s2, o2 + "." + t3) || n2.castOption(e3, s2, "textfont." + t3) || i2.size;
        }, e2.getOutsideTextFontKey = function(t3, e3, r3, i2) {
          var a2 = r3.data.data.i;
          return n2.castOption(e3, a2, "outsidetextfont." + t3) || n2.castOption(e3, a2, "textfont." + t3) || i2.size;
        }, e2.isOutsideText = function(t3, r3) {
          return !t3._hasColorscale && e2.isHierarchyRoot(r3);
        }, e2.determineTextFont = function(t3, r3, a2, o2) {
          return e2.isOutsideText(t3, r3) ? function(t4, r4, n3) {
            return { color: e2.getOutsideTextFontKey("color", t4, r4, n3), family: e2.getOutsideTextFontKey("family", t4, r4, n3), size: e2.getOutsideTextFontKey("size", t4, r4, n3) };
          }(t3, r3, a2) : function(t4, r4, a3, o3) {
            var s2 = (o3 || {}).onPathbar, l = r4.data.data, u = l.i, c = n2.castOption(t4, u, (s2 ? "pathbar.textfont" : "insidetextfont") + ".color");
            return !c && t4._input.textfont && (c = n2.castOption(t4._input, u, "textfont.color")), { color: c || i.contrast(l.color), family: e2.getInsideTextFontKey("family", t4, r4, a3, o3), size: e2.getInsideTextFontKey("size", t4, r4, a3, o3) };
          }(t3, r3, a2, o2);
        }, e2.hasTransition = function(t3) {
          return !!(t3 && t3.duration > 0);
        }, e2.getMaxDepth = function(t3) {
          return t3.maxdepth >= 0 ? t3.maxdepth : 1 / 0;
        }, e2.isHeader = function(t3, r3) {
          return !(e2.isLeaf(t3) || t3.depth === r3._maxDepth - 1);
        }, e2.getParent = function(t3, r3) {
          return e2.findEntryWithLevel(t3, s(r3));
        }, e2.listPath = function(t3, r3) {
          var n3 = t3.parent;
          if (!n3)
            return [];
          var i2 = r3 ? [n3.data[r3]] : [n3];
          return e2.listPath(n3, r3).concat(i2);
        }, e2.getPath = function(t3) {
          return e2.listPath(t3, "label").join("/") + "/";
        }, e2.formatValue = o.formatPieValue, e2.formatPercent = function(t3, e3) {
          var r3 = n2.formatPercent(t3, 0);
          return "0%" === r3 && (r3 = o.formatPiePercent(t3, e3)), r3;
        };
      }, 87619: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "sunburst", basePlotModule: r2(66888), categories: [], animatable: true, attributes: r2(57564), layoutAttributes: r2(2654), supplyDefaults: r2(17094), supplyLayoutDefaults: r2(57034), calc: r2(52147).calc, crossTraceCalc: r2(52147).crossTraceCalc, plot: r2(24714).plot, style: r2(29969).style, colorbar: r2(4898), meta: {} };
      }, 2654: function(t2) {
        t2.exports = { sunburstcolorway: { valType: "colorlist", editType: "calc" }, extendsunburstcolors: { valType: "boolean", dflt: true, editType: "calc" } };
      }, 57034: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(2654);
        t2.exports = function(t3, e3) {
          function r3(r4, a) {
            return n2.coerce(t3, e3, i, r4, a);
          }
          r3("sunburstcolorway", e3.colorway), r3("extendsunburstcolors");
        };
      }, 24714: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(674), a = r2(81684).sX, o = r2(91424), s = r2(71828), l = r2(63893), u = r2(72597), c = u.recordMinTextSize, f2 = u.clearMinTextSize, h = r2(14575), p2 = r2(53581).getRotationAngle, d2 = h.computeTransform, v = h.transformInsideText, g2 = r2(29969).styleOne, y = r2(16688).resizeText, m2 = r2(83523), x = r2(7055), b = r2(2791);
        function _(t3, r3, u2, f3) {
          var h2 = t3._context.staticPlot, y2 = t3._fullLayout, _2 = !y2.uniformtext.mode && b.hasTransition(f3), T = n2.select(u2).selectAll("g.slice"), k = r3[0], A = k.trace, M = k.hierarchy, S = b.findEntryWithLevel(M, A.level), E = b.getMaxDepth(A), L = y2._size, C = A.domain, P = L.w * (C.x[1] - C.x[0]), O = L.h * (C.y[1] - C.y[0]), I = 0.5 * Math.min(P, O), D = k.cx = L.l + L.w * (C.x[1] + C.x[0]) / 2, z = k.cy = L.t + L.h * (1 - C.y[0]) - O / 2;
          if (!S)
            return T.remove();
          var R = null, F = {};
          _2 && T.each(function(t4) {
            F[b.getPtId(t4)] = { rpx0: t4.rpx0, rpx1: t4.rpx1, x0: t4.x0, x1: t4.x1, transform: t4.transform }, !R && b.isEntry(t4) && (R = t4);
          });
          var B = function(t4) {
            return i.partition().size([2 * Math.PI, t4.height + 1])(t4);
          }(S).descendants(), N = S.height + 1, j = 0, U = E;
          k.hasMultipleRoots && b.isHierarchyRoot(S) && (B = B.slice(1), N -= 1, j = 1, U += 1), B = B.filter(function(t4) {
            return t4.y1 <= U;
          });
          var V = p2(A.rotation);
          V && B.forEach(function(t4) {
            t4.x0 += V, t4.x1 += V;
          });
          var H = Math.min(N, E), q2 = function(t4) {
            return (t4 - j) / H * I;
          }, G = function(t4, e3) {
            return [t4 * Math.cos(e3), -t4 * Math.sin(e3)];
          }, Z = function(t4) {
            return s.pathAnnulus(t4.rpx0, t4.rpx1, t4.x0, t4.x1, D, z);
          }, Y = function(t4) {
            return D + w2(t4)[0] * (t4.transform.rCenter || 0) + (t4.transform.x || 0);
          }, W = function(t4) {
            return z + w2(t4)[1] * (t4.transform.rCenter || 0) + (t4.transform.y || 0);
          };
          (T = T.data(B, b.getPtId)).enter().append("g").classed("slice", true), _2 ? T.exit().transition().each(function() {
            var t4 = n2.select(this);
            t4.select("path.surface").transition().attrTween("d", function(t5) {
              var e3 = function(t6) {
                var e4, r4 = b.getPtId(t6), n3 = F[r4], i2 = F[b.getPtId(S)];
                if (i2) {
                  var o2 = (t6.x1 > i2.x1 ? 2 * Math.PI : 0) + V;
                  e4 = t6.rpx1 < i2.rpx1 ? { x0: t6.x0, x1: t6.x1, rpx0: 0, rpx1: 0 } : { x0: o2, x1: o2, rpx0: t6.rpx0, rpx1: t6.rpx1 };
                } else {
                  var s2, l2 = b.getPtId(t6.parent);
                  T.each(function(t7) {
                    if (b.getPtId(t7) === l2)
                      return s2 = t7;
                  });
                  var u3, c2 = s2.children;
                  c2.forEach(function(t7, e5) {
                    if (b.getPtId(t7) === r4)
                      return u3 = e5;
                  });
                  var f4 = c2.length, h3 = a(s2.x0, s2.x1);
                  e4 = { rpx0: I, rpx1: I, x0: h3(u3 / f4), x1: h3((u3 + 1) / f4) };
                }
                return a(n3, e4);
              }(t5);
              return function(t6) {
                return Z(e3(t6));
              };
            }), t4.select("g.slicetext").attr("opacity", 0);
          }).remove() : T.exit().remove(), T.order();
          var X = null;
          if (_2 && R) {
            var J = b.getPtId(R);
            T.each(function(t4) {
              null === X && b.getPtId(t4) === J && (X = t4.x1);
            });
          }
          var K = T;
          function $(t4) {
            var e3 = t4.parent, r4 = F[b.getPtId(e3)], n3 = {};
            if (r4) {
              var i2 = e3.children, o2 = i2.indexOf(t4), s2 = i2.length, l2 = a(r4.x0, r4.x1);
              n3.x0 = l2(o2 / s2), n3.x1 = l2(o2 / s2);
            } else
              n3.x0 = n3.x1 = 0;
            return n3;
          }
          _2 && (K = K.transition().each("end", function() {
            var e3 = n2.select(this);
            b.setSliceCursor(e3, t3, { hideOnRoot: true, hideOnLeaves: true, isTransitioning: false });
          })), K.each(function(i2) {
            var u3 = n2.select(this), f4 = s.ensureSingle(u3, "path", "surface", function(t4) {
              t4.style("pointer-events", h2 ? "none" : "all");
            });
            i2.rpx0 = q2(i2.y0), i2.rpx1 = q2(i2.y1), i2.xmid = (i2.x0 + i2.x1) / 2, i2.pxmid = G(i2.rpx1, i2.xmid), i2.midangle = -(i2.xmid - Math.PI / 2), i2.startangle = -(i2.x0 - Math.PI / 2), i2.stopangle = -(i2.x1 - Math.PI / 2), i2.halfangle = 0.5 * Math.min(s.angleDelta(i2.x0, i2.x1) || Math.PI, Math.PI), i2.ring = 1 - i2.rpx0 / i2.rpx1, i2.rInscribed = function(t4) {
              return 0 === t4.rpx0 && s.isFullCircle([t4.x0, t4.x1]) ? 1 : Math.max(0, Math.min(1 / (1 + 1 / Math.sin(t4.halfangle)), t4.ring / 2));
            }(i2), _2 ? f4.transition().attrTween("d", function(t4) {
              var e3 = function(t5) {
                var e4, r4 = F[b.getPtId(t5)], n3 = { x0: t5.x0, x1: t5.x1, rpx0: t5.rpx0, rpx1: t5.rpx1 };
                if (r4)
                  e4 = r4;
                else if (R)
                  if (t5.parent)
                    if (X) {
                      var i3 = (t5.x1 > X ? 2 * Math.PI : 0) + V;
                      e4 = { x0: i3, x1: i3 };
                    } else
                      e4 = { rpx0: I, rpx1: I }, s.extendFlat(e4, $(t5));
                  else
                    e4 = { rpx0: 0, rpx1: 0 };
                else
                  e4 = { x0: V, x1: V };
                return a(e4, n3);
              }(t4);
              return function(t5) {
                return Z(e3(t5));
              };
            }) : f4.attr("d", Z), u3.call(m2, S, t3, r3, { eventDataKeys: x.eventDataKeys, transitionTime: x.CLICK_TRANSITION_TIME, transitionEasing: x.CLICK_TRANSITION_EASING }).call(b.setSliceCursor, t3, { hideOnRoot: true, hideOnLeaves: true, isTransitioning: t3._transitioning }), f4.call(g2, i2, A);
            var p3 = s.ensureSingle(u3, "g", "slicetext"), w3 = s.ensureSingle(p3, "text", "", function(t4) {
              t4.attr("data-notex", 1);
            }), T2 = s.ensureUniformFontSize(t3, b.determineTextFont(A, i2, y2.font));
            w3.text(e2.formatSliceLabel(i2, S, A, r3, y2)).classed("slicetext", true).attr("text-anchor", "middle").call(o.font, T2).call(l.convertToTspans, t3);
            var M2 = o.bBox(w3.node());
            i2.transform = v(M2, i2, k), i2.transform.targetX = Y(i2), i2.transform.targetY = W(i2);
            var E2 = function(t4, e3) {
              var r4 = t4.transform;
              return d2(r4, e3), r4.fontSize = T2.size, c(A.type, r4, y2), s.getTextTransform(r4);
            };
            _2 ? w3.transition().attrTween("transform", function(t4) {
              var e3 = function(t5) {
                var e4, r4 = F[b.getPtId(t5)], n3 = t5.transform;
                if (r4)
                  e4 = r4;
                else if (e4 = { rpx1: t5.rpx1, transform: { textPosAngle: n3.textPosAngle, scale: 0, rotate: n3.rotate, rCenter: n3.rCenter, x: n3.x, y: n3.y } }, R)
                  if (t5.parent)
                    if (X) {
                      var i3 = t5.x1 > X ? 2 * Math.PI : 0;
                      e4.x0 = e4.x1 = i3;
                    } else
                      s.extendFlat(e4, $(t5));
                  else
                    e4.x0 = e4.x1 = V;
                else
                  e4.x0 = e4.x1 = V;
                var o2 = a(e4.transform.textPosAngle, t5.transform.textPosAngle), l2 = a(e4.rpx1, t5.rpx1), u4 = a(e4.x0, t5.x0), f5 = a(e4.x1, t5.x1), h3 = a(e4.transform.scale, n3.scale), p4 = a(e4.transform.rotate, n3.rotate), d3 = 0 === n3.rCenter ? 3 : 0 === e4.transform.rCenter ? 1 / 3 : 1, v2 = a(e4.transform.rCenter, n3.rCenter);
                return function(t6) {
                  var e5 = l2(t6), r5 = u4(t6), i4 = f5(t6), a2 = function(t7) {
                    return v2(Math.pow(t7, d3));
                  }(t6), s2 = { pxmid: G(e5, (r5 + i4) / 2), rpx1: e5, transform: { textPosAngle: o2(t6), rCenter: a2, x: n3.x, y: n3.y } };
                  return c(A.type, n3, y2), { transform: { targetX: Y(s2), targetY: W(s2), scale: h3(t6), rotate: p4(t6), rCenter: a2 } };
                };
              }(t4);
              return function(t5) {
                return E2(e3(t5), M2);
              };
            }) : w3.attr("transform", E2(i2, M2));
          });
        }
        function w2(t3) {
          return e3 = t3.rpx1, r3 = t3.transform.textPosAngle, [e3 * Math.sin(r3), -e3 * Math.cos(r3)];
          var e3, r3;
        }
        e2.plot = function(t3, e3, r3, i2) {
          var a2, o2, s2 = t3._fullLayout, l2 = s2._sunburstlayer, u2 = !r3, c2 = !s2.uniformtext.mode && b.hasTransition(r3);
          f2("sunburst", s2), (a2 = l2.selectAll("g.trace.sunburst").data(e3, function(t4) {
            return t4[0].trace.uid;
          })).enter().append("g").classed("trace", true).classed("sunburst", true).attr("stroke-linejoin", "round"), a2.order(), c2 ? (i2 && (o2 = i2()), n2.transition().duration(r3.duration).ease(r3.easing).each("end", function() {
            o2 && o2();
          }).each("interrupt", function() {
            o2 && o2();
          }).each(function() {
            l2.selectAll("g.trace").each(function(e4) {
              _(t3, e4, this, r3);
            });
          })) : (a2.each(function(e4) {
            _(t3, e4, this, r3);
          }), s2.uniformtext.mode && y(t3, s2._sunburstlayer.selectAll(".trace"), "sunburst")), u2 && a2.exit().remove();
        }, e2.formatSliceLabel = function(t3, e3, r3, n3, i2) {
          var a2 = r3.texttemplate, o2 = r3.textinfo;
          if (!(a2 || o2 && "none" !== o2))
            return "";
          var l2 = i2.separators, u2 = n3[0], c2 = t3.data.data, f3 = u2.hierarchy, h2 = b.isHierarchyRoot(t3), p3 = b.getParent(f3, t3), d3 = b.getValue(t3);
          if (!a2) {
            var v2, g3 = o2.split("+"), y2 = function(t4) {
              return -1 !== g3.indexOf(t4);
            }, m3 = [];
            if (y2("label") && c2.label && m3.push(c2.label), c2.hasOwnProperty("v") && y2("value") && m3.push(b.formatValue(c2.v, l2)), !h2) {
              y2("current path") && m3.push(b.getPath(t3.data));
              var x2 = 0;
              y2("percent parent") && x2++, y2("percent entry") && x2++, y2("percent root") && x2++;
              var _2 = x2 > 1;
              if (x2) {
                var w3, T = function(t4) {
                  v2 = b.formatPercent(w3, l2), _2 && (v2 += " of " + t4), m3.push(v2);
                };
                y2("percent parent") && !h2 && (w3 = d3 / b.getValue(p3), T("parent")), y2("percent entry") && (w3 = d3 / b.getValue(e3), T("entry")), y2("percent root") && (w3 = d3 / b.getValue(f3), T("root"));
              }
            }
            return y2("text") && (v2 = s.castOption(r3, c2.i, "text"), s.isValidTextValue(v2) && m3.push(v2)), m3.join("<br>");
          }
          var k = s.castOption(r3, c2.i, "texttemplate");
          if (!k)
            return "";
          var A = {};
          c2.label && (A.label = c2.label), c2.hasOwnProperty("v") && (A.value = c2.v, A.valueLabel = b.formatValue(c2.v, l2)), A.currentPath = b.getPath(t3.data), h2 || (A.percentParent = d3 / b.getValue(p3), A.percentParentLabel = b.formatPercent(A.percentParent, l2), A.parent = b.getPtLabel(p3)), A.percentEntry = d3 / b.getValue(e3), A.percentEntryLabel = b.formatPercent(A.percentEntry, l2), A.entry = b.getPtLabel(e3), A.percentRoot = d3 / b.getValue(f3), A.percentRootLabel = b.formatPercent(A.percentRoot, l2), A.root = b.getPtLabel(f3), c2.hasOwnProperty("color") && (A.color = c2.color);
          var M = s.castOption(r3, c2.i, "text");
          return (s.isValidTextValue(M) || "" === M) && (A.text = M), A.customdata = s.castOption(r3, c2.i, "customdata"), s.texttemplateString(k, A, i2._d3locale, A, r3._meta || {});
        };
      }, 29969: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(7901), a = r2(71828), o = r2(72597).resizeText;
        function s(t3, e3, r3) {
          var n3 = e3.data.data, o2 = !e3.children, s2 = n3.i, l = a.castOption(r3, s2, "marker.line.color") || i.defaultLine, u = a.castOption(r3, s2, "marker.line.width") || 0;
          t3.style("stroke-width", u).call(i.fill, n3.color).call(i.stroke, l).style("opacity", o2 ? r3.leaf.opacity : null);
        }
        t2.exports = { style: function(t3) {
          var e3 = t3._fullLayout._sunburstlayer.selectAll(".trace");
          o(t3, e3, "sunburst"), e3.each(function(t4) {
            var e4 = n2.select(this), r3 = t4[0].trace;
            e4.style("opacity", r3.opacity), e4.selectAll("path.surface").each(function(t5) {
              n2.select(this).call(s, t5, r3);
            });
          });
        }, styleOne: s };
      }, 54532: function(t2, e2, r2) {
        var n2 = r2(7901), i = r2(50693), a = r2(12663).axisHoverFormat, o = r2(5386).f, s = r2(9012), l = r2(1426).extendFlat, u = r2(30962).overrideAll;
        function c(t3) {
          return { show: { valType: "boolean", dflt: false }, start: { valType: "number", dflt: null, editType: "plot" }, end: { valType: "number", dflt: null, editType: "plot" }, size: { valType: "number", dflt: null, min: 0, editType: "plot" }, project: { x: { valType: "boolean", dflt: false }, y: { valType: "boolean", dflt: false }, z: { valType: "boolean", dflt: false } }, color: { valType: "color", dflt: n2.defaultLine }, usecolormap: { valType: "boolean", dflt: false }, width: { valType: "number", min: 1, max: 16, dflt: 2 }, highlight: { valType: "boolean", dflt: true }, highlightcolor: { valType: "color", dflt: n2.defaultLine }, highlightwidth: { valType: "number", min: 1, max: 16, dflt: 2 } };
        }
        var f2 = t2.exports = u(l({ z: { valType: "data_array" }, x: { valType: "data_array" }, y: { valType: "data_array" }, text: { valType: "string", dflt: "", arrayOk: true }, hovertext: { valType: "string", dflt: "", arrayOk: true }, hovertemplate: o(), xhoverformat: a("x"), yhoverformat: a("y"), zhoverformat: a("z"), connectgaps: { valType: "boolean", dflt: false, editType: "calc" }, surfacecolor: { valType: "data_array" } }, i("", { colorAttr: "z or surfacecolor", showScaleDflt: true, autoColorDflt: false, editTypeOverride: "calc" }), { contours: { x: c(), y: c(), z: c() }, hidesurface: { valType: "boolean", dflt: false }, lightposition: { x: { valType: "number", min: -1e5, max: 1e5, dflt: 10 }, y: { valType: "number", min: -1e5, max: 1e5, dflt: 1e4 }, z: { valType: "number", min: -1e5, max: 1e5, dflt: 0 } }, lighting: { ambient: { valType: "number", min: 0, max: 1, dflt: 0.8 }, diffuse: { valType: "number", min: 0, max: 1, dflt: 0.8 }, specular: { valType: "number", min: 0, max: 2, dflt: 0.05 }, roughness: { valType: "number", min: 0, max: 1, dflt: 0.5 }, fresnel: { valType: "number", min: 0, max: 5, dflt: 0.2 } }, opacity: { valType: "number", min: 0, max: 1, dflt: 1 }, opacityscale: { valType: "any", editType: "calc" }, _deprecated: { zauto: l({}, i.zauto, {}), zmin: l({}, i.zmin, {}), zmax: l({}, i.zmax, {}) }, hoverinfo: l({}, s.hoverinfo), showlegend: l({}, s.showlegend, { dflt: false }) }), "calc", "nested");
        f2.x.editType = f2.y.editType = f2.z.editType = "calc+clearAxisTypes", f2.transforms = void 0;
      }, 18396: function(t2, e2, r2) {
        var n2 = r2(78803);
        t2.exports = function(t3, e3) {
          e3.surfacecolor ? n2(t3, e3, { vals: e3.surfacecolor, containerStr: "", cLetter: "c" }) : n2(t3, e3, { vals: e3.z, containerStr: "", cLetter: "c" });
        };
      }, 43768: function(t2, e2, r2) {
        var n2 = r2(9330).gl_surface3d, i = r2(9330).ndarray, a = r2(9330).ndarray_linear_interpolate.d2, o = r2(824), s = r2(43907), l = r2(71828).isArrayOrTypedArray, u = r2(81697).parseColorScale, c = r2(78614), f2 = r2(21081).extractOpts;
        function h(t3, e3, r3) {
          this.scene = t3, this.uid = r3, this.surface = e3, this.data = null, this.showContour = [false, false, false], this.contourStart = [null, null, null], this.contourEnd = [null, null, null], this.contourSize = [0, 0, 0], this.minValues = [1 / 0, 1 / 0, 1 / 0], this.maxValues = [-1 / 0, -1 / 0, -1 / 0], this.dataScaleX = 1, this.dataScaleY = 1, this.refineData = true, this.objectOffset = [0, 0, 0];
        }
        var p2 = h.prototype;
        p2.getXat = function(t3, e3, r3, n3) {
          var i2 = l(this.data.x) ? l(this.data.x[0]) ? this.data.x[e3][t3] : this.data.x[t3] : t3;
          return void 0 === r3 ? i2 : n3.d2l(i2, 0, r3);
        }, p2.getYat = function(t3, e3, r3, n3) {
          var i2 = l(this.data.y) ? l(this.data.y[0]) ? this.data.y[e3][t3] : this.data.y[e3] : e3;
          return void 0 === r3 ? i2 : n3.d2l(i2, 0, r3);
        }, p2.getZat = function(t3, e3, r3, n3) {
          var i2 = this.data.z[e3][t3];
          return null === i2 && this.data.connectgaps && this.data._interpolatedZ && (i2 = this.data._interpolatedZ[e3][t3]), void 0 === r3 ? i2 : n3.d2l(i2, 0, r3);
        }, p2.handlePick = function(t3) {
          if (t3.object === this.surface) {
            var e3 = (t3.data.index[0] - 1) / this.dataScaleX - 1, r3 = (t3.data.index[1] - 1) / this.dataScaleY - 1, n3 = Math.max(Math.min(Math.round(e3), this.data.z[0].length - 1), 0), i2 = Math.max(Math.min(Math.round(r3), this.data._ylength - 1), 0);
            t3.index = [n3, i2], t3.traceCoordinate = [this.getXat(n3, i2), this.getYat(n3, i2), this.getZat(n3, i2)], t3.dataCoordinate = [this.getXat(n3, i2, this.data.xcalendar, this.scene.fullSceneLayout.xaxis), this.getYat(n3, i2, this.data.ycalendar, this.scene.fullSceneLayout.yaxis), this.getZat(n3, i2, this.data.zcalendar, this.scene.fullSceneLayout.zaxis)];
            for (var a2 = 0; a2 < 3; a2++) {
              null != t3.dataCoordinate[a2] && (t3.dataCoordinate[a2] *= this.scene.dataScale[a2]);
            }
            var o2 = this.data.hovertext || this.data.text;
            return Array.isArray(o2) && o2[i2] && void 0 !== o2[i2][n3] ? t3.textLabel = o2[i2][n3] : t3.textLabel = o2 || "", t3.data.dataCoordinate = t3.dataCoordinate.slice(), this.surface.highlight(t3.data), this.scene.glplot.spikes.position = t3.dataCoordinate, true;
          }
        };
        var d2 = [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541, 547, 557, 563, 569, 571, 577, 587, 593, 599, 601, 607, 613, 617, 619, 631, 641, 643, 647, 653, 659, 661, 673, 677, 683, 691, 701, 709, 719, 727, 733, 739, 743, 751, 757, 761, 769, 773, 787, 797, 809, 811, 821, 823, 827, 829, 839, 853, 857, 859, 863, 877, 881, 883, 887, 907, 911, 919, 929, 937, 941, 947, 953, 967, 971, 977, 983, 991, 997, 1009, 1013, 1019, 1021, 1031, 1033, 1039, 1049, 1051, 1061, 1063, 1069, 1087, 1091, 1093, 1097, 1103, 1109, 1117, 1123, 1129, 1151, 1153, 1163, 1171, 1181, 1187, 1193, 1201, 1213, 1217, 1223, 1229, 1231, 1237, 1249, 1259, 1277, 1279, 1283, 1289, 1291, 1297, 1301, 1303, 1307, 1319, 1321, 1327, 1361, 1367, 1373, 1381, 1399, 1409, 1423, 1427, 1429, 1433, 1439, 1447, 1451, 1453, 1459, 1471, 1481, 1483, 1487, 1489, 1493, 1499, 1511, 1523, 1531, 1543, 1549, 1553, 1559, 1567, 1571, 1579, 1583, 1597, 1601, 1607, 1609, 1613, 1619, 1621, 1627, 1637, 1657, 1663, 1667, 1669, 1693, 1697, 1699, 1709, 1721, 1723, 1733, 1741, 1747, 1753, 1759, 1777, 1783, 1787, 1789, 1801, 1811, 1823, 1831, 1847, 1861, 1867, 1871, 1873, 1877, 1879, 1889, 1901, 1907, 1913, 1931, 1933, 1949, 1951, 1973, 1979, 1987, 1993, 1997, 1999, 2003, 2011, 2017, 2027, 2029, 2039, 2053, 2063, 2069, 2081, 2083, 2087, 2089, 2099, 2111, 2113, 2129, 2131, 2137, 2141, 2143, 2153, 2161, 2179, 2203, 2207, 2213, 2221, 2237, 2239, 2243, 2251, 2267, 2269, 2273, 2281, 2287, 2293, 2297, 2309, 2311, 2333, 2339, 2341, 2347, 2351, 2357, 2371, 2377, 2381, 2383, 2389, 2393, 2399, 2411, 2417, 2423, 2437, 2441, 2447, 2459, 2467, 2473, 2477, 2503, 2521, 2531, 2539, 2543, 2549, 2551, 2557, 2579, 2591, 2593, 2609, 2617, 2621, 2633, 2647, 2657, 2659, 2663, 2671, 2677, 2683, 2687, 2689, 2693, 2699, 2707, 2711, 2713, 2719, 2729, 2731, 2741, 2749, 2753, 2767, 2777, 2789, 2791, 2797, 2801, 2803, 2819, 2833, 2837, 2843, 2851, 2857, 2861, 2879, 2887, 2897, 2903, 2909, 2917, 2927, 2939, 2953, 2957, 2963, 2969, 2971, 2999];
        function v(t3, e3) {
          if (t3 < e3)
            return 0;
          for (var r3 = 0; 0 === Math.floor(t3 % e3); )
            t3 /= e3, r3++;
          return r3;
        }
        function g2(t3) {
          for (var e3 = [], r3 = 0; r3 < d2.length; r3++) {
            var n3 = d2[r3];
            e3.push(v(t3, n3));
          }
          return e3;
        }
        function y(t3) {
          for (var e3 = g2(t3), r3 = t3, n3 = 0; n3 < d2.length; n3++)
            if (e3[n3] > 0) {
              r3 = d2[n3];
              break;
            }
          return r3;
        }
        function m2(t3, e3) {
          if (!(t3 < 1 || e3 < 1)) {
            for (var r3 = g2(t3), n3 = g2(e3), i2 = 1, a2 = 0; a2 < d2.length; a2++)
              i2 *= Math.pow(d2[a2], Math.max(r3[a2], n3[a2]));
            return i2;
          }
        }
        p2.calcXnums = function(t3) {
          var e3, r3 = [];
          for (e3 = 1; e3 < t3; e3++) {
            var n3 = this.getXat(e3 - 1, 0), i2 = this.getXat(e3, 0);
            r3[e3 - 1] = i2 !== n3 && null != n3 && null != i2 ? Math.abs(i2 - n3) : 0;
          }
          var a2 = 0;
          for (e3 = 1; e3 < t3; e3++)
            a2 += r3[e3 - 1];
          for (e3 = 1; e3 < t3; e3++)
            0 === r3[e3 - 1] ? r3[e3 - 1] = 1 : r3[e3 - 1] = Math.round(a2 / r3[e3 - 1]);
          return r3;
        }, p2.calcYnums = function(t3) {
          var e3, r3 = [];
          for (e3 = 1; e3 < t3; e3++) {
            var n3 = this.getYat(0, e3 - 1), i2 = this.getYat(0, e3);
            r3[e3 - 1] = i2 !== n3 && null != n3 && null != i2 ? Math.abs(i2 - n3) : 0;
          }
          var a2 = 0;
          for (e3 = 1; e3 < t3; e3++)
            a2 += r3[e3 - 1];
          for (e3 = 1; e3 < t3; e3++)
            0 === r3[e3 - 1] ? r3[e3 - 1] = 1 : r3[e3 - 1] = Math.round(a2 / r3[e3 - 1]);
          return r3;
        };
        var x = [1, 2, 4, 6, 12, 24, 36, 48, 60, 120, 180, 240, 360, 720, 840, 1260], b = x[9], _ = x[13];
        function w2(t3, e3, r3) {
          var n3 = r3[8] + r3[2] * e3[0] + r3[5] * e3[1];
          return t3[0] = (r3[6] + r3[0] * e3[0] + r3[3] * e3[1]) / n3, t3[1] = (r3[7] + r3[1] * e3[0] + r3[4] * e3[1]) / n3, t3;
        }
        function T(t3, e3, r3) {
          return function(t4, e4, r4, n3) {
            for (var i2 = [0, 0], o2 = t4.shape[0], s2 = t4.shape[1], l2 = 0; l2 < o2; l2++)
              for (var u2 = 0; u2 < s2; u2++)
                r4(i2, [l2, u2], n3), t4.set(l2, u2, a(e4, i2[0], i2[1]));
          }(t3, e3, w2, r3), t3;
        }
        function k(t3, e3) {
          for (var r3 = false, n3 = 0; n3 < t3.length; n3++)
            if (e3 === t3[n3]) {
              r3 = true;
              break;
            }
          false === r3 && t3.push(e3);
        }
        p2.estimateScale = function(t3, e3) {
          for (var r3 = 1 + function(t4) {
            if (0 !== t4.length) {
              for (var e4 = 1, r4 = 0; r4 < t4.length; r4++)
                e4 = m2(e4, t4[r4]);
              return e4;
            }
          }(0 === e3 ? this.calcXnums(t3) : this.calcYnums(t3)); r3 < b; )
            r3 *= 2;
          for (; r3 > _; )
            r3--, r3 /= y(r3), ++r3 < b && (r3 = _);
          var n3 = Math.round(r3 / t3);
          return n3 > 1 ? n3 : 1;
        }, p2.refineCoords = function(t3) {
          for (var e3 = this.dataScaleX, r3 = this.dataScaleY, n3 = t3[0].shape[0], a2 = t3[0].shape[1], o2 = 0 | Math.floor(t3[0].shape[0] * e3 + 1), s2 = 0 | Math.floor(t3[0].shape[1] * r3 + 1), l2 = 1 + n3 + 1, u2 = 1 + a2 + 1, c2 = i(new Float32Array(l2 * u2), [l2, u2]), f3 = [1 / e3, 0, 0, 0, 1 / r3, 0, 0, 0, 1], h2 = 0; h2 < t3.length; ++h2) {
            this.surface.padField(c2, t3[h2]);
            var p3 = i(new Float32Array(o2 * s2), [o2, s2]);
            T(p3, c2, f3), t3[h2] = p3;
          }
        }, p2.setContourLevels = function() {
          var t3, e3, r3, n3 = [[], [], []], i2 = [false, false, false], a2 = false;
          for (t3 = 0; t3 < 3; ++t3)
            if (this.showContour[t3] && (a2 = true, this.contourSize[t3] > 0 && null !== this.contourStart[t3] && null !== this.contourEnd[t3] && this.contourEnd[t3] > this.contourStart[t3]))
              for (i2[t3] = true, e3 = this.contourStart[t3]; e3 < this.contourEnd[t3]; e3 += this.contourSize[t3])
                r3 = e3 * this.scene.dataScale[t3], k(n3[t3], r3);
          if (a2) {
            var o2 = [[], [], []];
            for (t3 = 0; t3 < 3; ++t3)
              this.showContour[t3] && (o2[t3] = i2[t3] ? n3[t3] : this.scene.contourLevels[t3]);
            this.surface.update({ levels: o2 });
          }
        }, p2.update = function(t3) {
          var e3, r3, n3, a2, l2 = this.scene, h2 = l2.fullSceneLayout, p3 = this.surface, d3 = u(t3), v2 = l2.dataScale, g3 = t3.z[0].length, y2 = t3._ylength, m3 = l2.contourLevels;
          this.data = t3;
          var x2 = [];
          for (e3 = 0; e3 < 3; e3++)
            for (x2[e3] = [], r3 = 0; r3 < g3; r3++)
              x2[e3][r3] = [];
          for (r3 = 0; r3 < g3; r3++)
            for (n3 = 0; n3 < y2; n3++)
              x2[0][r3][n3] = this.getXat(r3, n3, t3.xcalendar, h2.xaxis), x2[1][r3][n3] = this.getYat(r3, n3, t3.ycalendar, h2.yaxis), x2[2][r3][n3] = this.getZat(r3, n3, t3.zcalendar, h2.zaxis);
          if (t3.connectgaps)
            for (t3._emptypoints = s(x2[2]), o(x2[2], t3._emptypoints), t3._interpolatedZ = [], r3 = 0; r3 < g3; r3++)
              for (t3._interpolatedZ[r3] = [], n3 = 0; n3 < y2; n3++)
                t3._interpolatedZ[r3][n3] = x2[2][r3][n3];
          for (e3 = 0; e3 < 3; e3++)
            for (r3 = 0; r3 < g3; r3++)
              for (n3 = 0; n3 < y2; n3++)
                null == (a2 = x2[e3][r3][n3]) ? x2[e3][r3][n3] = NaN : a2 = x2[e3][r3][n3] *= v2[e3];
          for (e3 = 0; e3 < 3; e3++)
            for (r3 = 0; r3 < g3; r3++)
              for (n3 = 0; n3 < y2; n3++)
                null != (a2 = x2[e3][r3][n3]) && (this.minValues[e3] > a2 && (this.minValues[e3] = a2), this.maxValues[e3] < a2 && (this.maxValues[e3] = a2));
          for (e3 = 0; e3 < 3; e3++)
            this.objectOffset[e3] = 0.5 * (this.minValues[e3] + this.maxValues[e3]);
          for (e3 = 0; e3 < 3; e3++)
            for (r3 = 0; r3 < g3; r3++)
              for (n3 = 0; n3 < y2; n3++)
                null != (a2 = x2[e3][r3][n3]) && (x2[e3][r3][n3] -= this.objectOffset[e3]);
          var b2 = [i(new Float32Array(g3 * y2), [g3, y2]), i(new Float32Array(g3 * y2), [g3, y2]), i(new Float32Array(g3 * y2), [g3, y2])];
          for (e3 = 0; e3 < 3; e3++)
            for (r3 = 0; r3 < g3; r3++)
              for (n3 = 0; n3 < y2; n3++)
                b2[e3].set(r3, n3, x2[e3][r3][n3]);
          x2 = [];
          var w3 = { colormap: d3, levels: [[], [], []], showContour: [true, true, true], showSurface: !t3.hidesurface, contourProject: [[false, false, false], [false, false, false], [false, false, false]], contourWidth: [1, 1, 1], contourColor: [[1, 1, 1, 1], [1, 1, 1, 1], [1, 1, 1, 1]], contourTint: [1, 1, 1], dynamicColor: [[1, 1, 1, 1], [1, 1, 1, 1], [1, 1, 1, 1]], dynamicWidth: [1, 1, 1], dynamicTint: [1, 1, 1], opacityscale: t3.opacityscale, opacity: t3.opacity }, T2 = f2(t3);
          if (w3.intensityBounds = [T2.min, T2.max], t3.surfacecolor) {
            var k2 = i(new Float32Array(g3 * y2), [g3, y2]);
            for (r3 = 0; r3 < g3; r3++)
              for (n3 = 0; n3 < y2; n3++)
                k2.set(r3, n3, t3.surfacecolor[n3][r3]);
            b2.push(k2);
          } else
            w3.intensityBounds[0] *= v2[2], w3.intensityBounds[1] *= v2[2];
          (_ < b2[0].shape[0] || _ < b2[0].shape[1]) && (this.refineData = false), true === this.refineData && (this.dataScaleX = this.estimateScale(b2[0].shape[0], 0), this.dataScaleY = this.estimateScale(b2[0].shape[1], 1), 1 === this.dataScaleX && 1 === this.dataScaleY || this.refineCoords(b2)), t3.surfacecolor && (w3.intensity = b2.pop());
          var A = [true, true, true], M = ["x", "y", "z"];
          for (e3 = 0; e3 < 3; ++e3) {
            var S = t3.contours[M[e3]];
            A[e3] = S.highlight, w3.showContour[e3] = S.show || S.highlight, w3.showContour[e3] && (w3.contourProject[e3] = [S.project.x, S.project.y, S.project.z], S.show ? (this.showContour[e3] = true, w3.levels[e3] = m3[e3], p3.highlightColor[e3] = w3.contourColor[e3] = c(S.color), S.usecolormap ? p3.highlightTint[e3] = w3.contourTint[e3] = 0 : p3.highlightTint[e3] = w3.contourTint[e3] = 1, w3.contourWidth[e3] = S.width, this.contourStart[e3] = S.start, this.contourEnd[e3] = S.end, this.contourSize[e3] = S.size) : (this.showContour[e3] = false, this.contourStart[e3] = null, this.contourEnd[e3] = null, this.contourSize[e3] = 0), S.highlight && (w3.dynamicColor[e3] = c(S.highlightcolor), w3.dynamicWidth[e3] = S.highlightwidth));
          }
          (function(t4) {
            var e4 = t4[0].rgb, r4 = t4[t4.length - 1].rgb;
            return e4[0] === r4[0] && e4[1] === r4[1] && e4[2] === r4[2] && e4[3] === r4[3];
          })(d3) && (w3.vertexColor = true), w3.objectOffset = this.objectOffset, w3.coords = b2, p3.update(w3), p3.visible = t3.visible, p3.enableDynamic = A, p3.enableHighlight = A, p3.snapToData = true, "lighting" in t3 && (p3.ambientLight = t3.lighting.ambient, p3.diffuseLight = t3.lighting.diffuse, p3.specularLight = t3.lighting.specular, p3.roughness = t3.lighting.roughness, p3.fresnel = t3.lighting.fresnel), "lightposition" in t3 && (p3.lightPosition = [t3.lightposition.x, t3.lightposition.y, t3.lightposition.z]);
        }, p2.dispose = function() {
          this.scene.glplot.remove(this.surface), this.surface.dispose();
        }, t2.exports = function(t3, e3) {
          var r3 = t3.glplot.gl, i2 = n2({ gl: r3 }), a2 = new h(t3, i2, e3.uid);
          return i2._trace = a2, a2.update(e3), t3.glplot.add(i2), a2;
        };
      }, 91831: function(t2, e2, r2) {
        var n2 = r2(73972), i = r2(71828), a = r2(1586), o = r2(54532);
        function s(t3, e3, r3, n3) {
          var i2 = n3("opacityscale");
          "max" === i2 ? e3.opacityscale = [[0, 0.1], [1, 1]] : "min" === i2 ? e3.opacityscale = [[0, 1], [1, 0.1]] : "extremes" === i2 ? e3.opacityscale = function(t4, e4) {
            for (var r4 = [], n4 = 0; n4 < 32; n4++) {
              var i3 = n4 / 31, a2 = 0.1 + 0.9 * (1 - Math.pow(Math.sin(1 * i3 * Math.PI), 2));
              r4.push([i3, Math.max(0, Math.min(1, a2))]);
            }
            return r4;
          }() : function(t4) {
            var e4 = 0;
            if (!Array.isArray(t4) || t4.length < 2)
              return false;
            if (!t4[0] || !t4[t4.length - 1])
              return false;
            if (0 != +t4[0][0] || 1 != +t4[t4.length - 1][0])
              return false;
            for (var r4 = 0; r4 < t4.length; r4++) {
              var n4 = t4[r4];
              if (2 !== n4.length || +n4[0] < e4)
                return false;
              e4 = +n4[0];
            }
            return true;
          }(i2) || (e3.opacityscale = void 0);
        }
        function l(t3, e3, r3) {
          e3 in t3 && !(r3 in t3) && (t3[r3] = t3[e3]);
        }
        t2.exports = { supplyDefaults: function(t3, e3, r3, u) {
          var c, f2;
          function h(r4, n3) {
            return i.coerce(t3, e3, o, r4, n3);
          }
          var p2 = h("x"), d2 = h("y"), v = h("z");
          if (!v || !v.length || p2 && p2.length < 1 || d2 && d2.length < 1)
            e3.visible = false;
          else {
            e3._xlength = Array.isArray(p2) && i.isArrayOrTypedArray(p2[0]) ? v.length : v[0].length, e3._ylength = v.length, n2.getComponentMethod("calendars", "handleTraceDefaults")(t3, e3, ["x", "y", "z"], u), h("text"), h("hovertext"), h("hovertemplate"), h("xhoverformat"), h("yhoverformat"), h("zhoverformat"), ["lighting.ambient", "lighting.diffuse", "lighting.specular", "lighting.roughness", "lighting.fresnel", "lightposition.x", "lightposition.y", "lightposition.z", "hidesurface", "connectgaps", "opacity"].forEach(function(t4) {
              h(t4);
            });
            var g2 = h("surfacecolor"), y = ["x", "y", "z"];
            for (c = 0; c < 3; ++c) {
              var m2 = "contours." + y[c], x = h(m2 + ".show"), b = h(m2 + ".highlight");
              if (x || b)
                for (f2 = 0; f2 < 3; ++f2)
                  h(m2 + ".project." + y[f2]);
              x && (h(m2 + ".color"), h(m2 + ".width"), h(m2 + ".usecolormap")), b && (h(m2 + ".highlightcolor"), h(m2 + ".highlightwidth")), h(m2 + ".start"), h(m2 + ".end"), h(m2 + ".size");
            }
            g2 || (l(t3, "zmin", "cmin"), l(t3, "zmax", "cmax"), l(t3, "zauto", "cauto")), a(t3, e3, u, h, { prefix: "", cLetter: "c" }), s(0, e3, 0, h), e3._length = null;
          }
        }, opacityscaleDefaults: s };
      }, 93601: function(t2, e2, r2) {
        t2.exports = { attributes: r2(54532), supplyDefaults: r2(91831).supplyDefaults, colorbar: { min: "cmin", max: "cmax" }, calc: r2(18396), plot: r2(43768), moduleType: "trace", name: "surface", basePlotModule: r2(58547), categories: ["gl3d", "2dMap", "showLegend"], meta: {} };
      }, 44464: function(t2, e2, r2) {
        var n2 = r2(50215), i = r2(1426).extendFlat, a = r2(30962).overrideAll, o = r2(41940), s = r2(27670).Y, l = r2(12663).descriptionOnlyNumbers;
        (t2.exports = a({ domain: s({ name: "table", trace: true }), columnwidth: { valType: "number", arrayOk: true, dflt: null }, columnorder: { valType: "data_array" }, header: { values: { valType: "data_array", dflt: [] }, format: { valType: "data_array", dflt: [], description: l("cell value") }, prefix: { valType: "string", arrayOk: true, dflt: null }, suffix: { valType: "string", arrayOk: true, dflt: null }, height: { valType: "number", dflt: 28 }, align: i({}, n2.align, { arrayOk: true }), line: { width: { valType: "number", arrayOk: true, dflt: 1 }, color: { valType: "color", arrayOk: true, dflt: "grey" } }, fill: { color: { valType: "color", arrayOk: true, dflt: "white" } }, font: i({}, o({ arrayOk: true })) }, cells: { values: { valType: "data_array", dflt: [] }, format: { valType: "data_array", dflt: [], description: l("cell value") }, prefix: { valType: "string", arrayOk: true, dflt: null }, suffix: { valType: "string", arrayOk: true, dflt: null }, height: { valType: "number", dflt: 20 }, align: i({}, n2.align, { arrayOk: true }), line: { width: { valType: "number", arrayOk: true, dflt: 1 }, color: { valType: "color", arrayOk: true, dflt: "grey" } }, fill: { color: { valType: "color", arrayOk: true, dflt: "white" } }, font: i({}, o({ arrayOk: true })) } }, "calc", "from-root")).transforms = void 0;
      }, 99469: function(t2, e2, r2) {
        var n2 = r2(27659).a0, i = r2(36736), a = "table";
        e2.name = a, e2.plot = function(t3) {
          var e3 = n2(t3.calcdata, a)[0];
          e3.length && i(t3, e3);
        }, e2.clean = function(t3, e3, r3, n3) {
          var i2 = n3._has && n3._has(a), o = e3._has && e3._has(a);
          i2 && !o && n3._paperdiv.selectAll(".table").remove();
        };
      }, 76333: function(t2, e2, r2) {
        var n2 = r2(28984).wrap;
        t2.exports = function() {
          return n2({});
        };
      }, 49850: function(t2) {
        t2.exports = { cellPad: 8, columnExtentOffset: 10, columnTitleOffset: 28, emptyHeaderHeight: 16, latexCheck: /^\$.*\$$/, goldenRatio: 1.618, lineBreaker: "<br>", maxDimensionCount: 60, overdrag: 45, releaseTransitionDuration: 120, releaseTransitionEase: "cubic-out", scrollbarCaptureWidth: 18, scrollbarHideDelay: 1e3, scrollbarHideDuration: 1e3, scrollbarOffset: 5, scrollbarWidth: 8, transitionDuration: 100, transitionEase: "cubic-out", uplift: 5, wrapSpacer: " ", wrapSplitCharacter: " ", cn: { table: "table", tableControlView: "table-control-view", scrollBackground: "scroll-background", yColumn: "y-column", columnBlock: "column-block", scrollAreaClip: "scroll-area-clip", scrollAreaClipRect: "scroll-area-clip-rect", columnBoundary: "column-boundary", columnBoundaryClippath: "column-boundary-clippath", columnBoundaryRect: "column-boundary-rect", columnCells: "column-cells", columnCell: "column-cell", cellRect: "cell-rect", cellText: "cell-text", cellTextHolder: "cell-text-holder", scrollbarKit: "scrollbar-kit", scrollbar: "scrollbar", scrollbarSlider: "scrollbar-slider", scrollbarGlyph: "scrollbar-glyph", scrollbarCaptureZone: "scrollbar-capture-zone" } };
      }, 51018: function(t2, e2, r2) {
        var n2 = r2(49850), i = r2(1426).extendFlat, a = r2(92770);
        function o(t3) {
          if (Array.isArray(t3)) {
            for (var e3 = 0, r3 = 0; r3 < t3.length; r3++)
              e3 = Math.max(e3, o(t3[r3]));
            return e3;
          }
          return t3;
        }
        function s(t3, e3) {
          return t3 + e3;
        }
        function l(t3) {
          var e3, r3 = t3.slice(), n3 = 1 / 0, i2 = 0;
          for (e3 = 0; e3 < r3.length; e3++)
            Array.isArray(r3[e3]) || (r3[e3] = [r3[e3]]), n3 = Math.min(n3, r3[e3].length), i2 = Math.max(i2, r3[e3].length);
          if (n3 !== i2)
            for (e3 = 0; e3 < r3.length; e3++) {
              var a2 = i2 - r3[e3].length;
              a2 && (r3[e3] = r3[e3].concat(u(a2)));
            }
          return r3;
        }
        function u(t3) {
          for (var e3 = new Array(t3), r3 = 0; r3 < t3; r3++)
            e3[r3] = "";
          return e3;
        }
        function c(t3) {
          return t3.calcdata.columns.reduce(function(e3, r3) {
            return r3.xIndex < t3.xIndex ? e3 + r3.columnWidth : e3;
          }, 0);
        }
        function f2(t3, e3) {
          return Object.keys(t3).map(function(r3) {
            return i({}, t3[r3], { auxiliaryBlocks: e3 });
          });
        }
        function h(t3, e3) {
          for (var r3, n3 = {}, i2 = 0, a2 = 0, o2 = { firstRowIndex: null, lastRowIndex: null, rows: [] }, s2 = 0, l2 = 0, u2 = 0; u2 < t3.length; u2++)
            r3 = t3[u2], o2.rows.push({ rowIndex: u2, rowHeight: r3 }), ((a2 += r3) >= e3 || u2 === t3.length - 1) && (n3[i2] = o2, o2.key = l2++, o2.firstRowIndex = s2, o2.lastRowIndex = u2, o2 = { firstRowIndex: null, lastRowIndex: null, rows: [] }, i2 += a2, s2 = u2 + 1, a2 = 0);
          return n3;
        }
        t2.exports = function(t3, e3) {
          var r3 = l(e3.cells.values), p2 = function(t4) {
            return t4.slice(e3.header.values.length, t4.length);
          }, d2 = l(e3.header.values);
          d2.length && !d2[0].length && (d2[0] = [""], d2 = l(d2));
          var v = d2.concat(p2(r3).map(function() {
            return u((d2[0] || [""]).length);
          })), g2 = e3.domain, y = Math.floor(t3._fullLayout._size.w * (g2.x[1] - g2.x[0])), m2 = Math.floor(t3._fullLayout._size.h * (g2.y[1] - g2.y[0])), x = e3.header.values.length ? v[0].map(function() {
            return e3.header.height;
          }) : [n2.emptyHeaderHeight], b = r3.length ? r3[0].map(function() {
            return e3.cells.height;
          }) : [], _ = x.reduce(s, 0), w2 = h(b, m2 - _ + n2.uplift), T = f2(h(x, _), []), k = f2(w2, T), A = {}, M = e3._fullInput.columnorder.concat(p2(r3.map(function(t4, e4) {
            return e4;
          }))), S = v.map(function(t4, r4) {
            var n3 = Array.isArray(e3.columnwidth) ? e3.columnwidth[Math.min(r4, e3.columnwidth.length - 1)] : e3.columnwidth;
            return a(n3) ? Number(n3) : 1;
          }), E = S.reduce(s, 0);
          S = S.map(function(t4) {
            return t4 / E * y;
          });
          var L = Math.max(o(e3.header.line.width), o(e3.cells.line.width)), C = { key: e3.uid + t3._context.staticPlot, translateX: g2.x[0] * t3._fullLayout._size.w, translateY: t3._fullLayout._size.h * (1 - g2.y[1]), size: t3._fullLayout._size, width: y, maxLineWidth: L, height: m2, columnOrder: M, groupHeight: m2, rowBlocks: k, headerRowBlocks: T, scrollY: 0, cells: i({}, e3.cells, { values: r3 }), headerCells: i({}, e3.header, { values: v }), gdColumns: v.map(function(t4) {
            return t4[0];
          }), gdColumnsOriginalOrder: v.map(function(t4) {
            return t4[0];
          }), prevPages: [0, 0], scrollbarState: { scrollbarScrollInProgress: false }, columns: v.map(function(t4, e4) {
            var r4 = A[t4];
            return A[t4] = (r4 || 0) + 1, { key: t4 + "__" + A[t4], label: t4, specIndex: e4, xIndex: M[e4], xScale: c, x: void 0, calcdata: void 0, columnWidth: S[e4] };
          }) };
          return C.columns.forEach(function(t4) {
            t4.calcdata = C, t4.x = c(t4);
          }), C;
        };
      }, 56269: function(t2, e2, r2) {
        var n2 = r2(1426).extendFlat;
        e2.splitToPanels = function(t3) {
          var e3 = [0, 0], r3 = n2({}, t3, { key: "header", type: "header", page: 0, prevPages: e3, currentRepaint: [null, null], dragHandle: true, values: t3.calcdata.headerCells.values[t3.specIndex], rowBlocks: t3.calcdata.headerRowBlocks, calcdata: n2({}, t3.calcdata, { cells: t3.calcdata.headerCells }) });
          return [n2({}, t3, { key: "cells1", type: "cells", page: 0, prevPages: e3, currentRepaint: [null, null], dragHandle: false, values: t3.calcdata.cells.values[t3.specIndex], rowBlocks: t3.calcdata.rowBlocks }), n2({}, t3, { key: "cells2", type: "cells", page: 1, prevPages: e3, currentRepaint: [null, null], dragHandle: false, values: t3.calcdata.cells.values[t3.specIndex], rowBlocks: t3.calcdata.rowBlocks }), r3];
        }, e2.splitToCells = function(t3) {
          var e3 = function(t4) {
            var e4 = t4.rowBlocks[t4.page], r3 = e4 ? e4.rows[0].rowIndex : 0;
            return [r3, e4 ? r3 + e4.rows.length : 0];
          }(t3);
          return (t3.values || []).slice(e3[0], e3[1]).map(function(r3, n3) {
            return { keyWithinBlock: n3 + ("string" == typeof r3 && r3.match(/[<$&> ]/) ? "_keybuster_" + Math.random() : ""), key: e3[0] + n3, column: t3, calcdata: t3.calcdata, page: t3.page, rowBlocks: t3.rowBlocks, value: r3 };
          });
        };
      }, 39754: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(44464), a = r2(27670).c;
        t2.exports = function(t3, e3, r3, o) {
          function s(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          a(e3, o, s), s("columnwidth"), s("header.values"), s("header.format"), s("header.align"), s("header.prefix"), s("header.suffix"), s("header.height"), s("header.line.width"), s("header.line.color"), s("header.fill.color"), n2.coerceFont(s, "header.font", n2.extendFlat({}, o.font)), function(t4, e4) {
            for (var r4 = t4.columnorder || [], n3 = t4.header.values.length, i2 = r4.slice(0, n3), a2 = i2.slice().sort(function(t5, e5) {
              return t5 - e5;
            }), o2 = i2.map(function(t5) {
              return a2.indexOf(t5);
            }), s2 = o2.length; s2 < n3; s2++)
              o2.push(s2);
            e4("columnorder", o2);
          }(e3, s), s("cells.values"), s("cells.format"), s("cells.align"), s("cells.prefix"), s("cells.suffix"), s("cells.height"), s("cells.line.width"), s("cells.line.color"), s("cells.fill.color"), n2.coerceFont(s, "cells.font", n2.extendFlat({}, o.font)), e3._length = null;
        };
      }, 96595: function(t2, e2, r2) {
        t2.exports = { attributes: r2(44464), supplyDefaults: r2(39754), calc: r2(76333), plot: r2(36736), moduleType: "trace", name: "table", basePlotModule: r2(99469), categories: ["noOpacity"], meta: {} };
      }, 36736: function(t2, e2, r2) {
        var n2 = r2(49850), i = r2(39898), a = r2(71828).numberFormat, o = r2(28984), s = r2(91424), l = r2(63893), u = r2(71828).raiseToTop, c = r2(71828).strTranslate, f2 = r2(71828).cancelTransition, h = r2(51018), p2 = r2(56269), d2 = r2(7901);
        function v(t3) {
          return Math.ceil(t3.calcdata.maxLineWidth / 2);
        }
        function g2(t3, e3) {
          return "clip" + t3._fullLayout._uid + "_scrollAreaBottomClip_" + e3.key;
        }
        function y(t3, e3) {
          return "clip" + t3._fullLayout._uid + "_columnBoundaryClippath_" + e3.calcdata.key + "_" + e3.specIndex;
        }
        function m2(t3) {
          return [].concat.apply([], t3.map(function(t4) {
            return t4;
          })).map(function(t4) {
            return t4.__data__;
          });
        }
        function x(t3, e3, r3) {
          var a2 = t3.selectAll("." + n2.cn.scrollbarKit).data(o.repeat, o.keyFun);
          a2.enter().append("g").classed(n2.cn.scrollbarKit, true).style("shape-rendering", "geometricPrecision"), a2.each(function(t4) {
            var e4 = t4.scrollbarState;
            e4.totalHeight = function(t5) {
              var e5 = t5.rowBlocks;
              return z(e5, e5.length - 1) + (e5.length ? R(e5[e5.length - 1], 1 / 0) : 1);
            }(t4), e4.scrollableAreaHeight = t4.groupHeight - S(t4), e4.currentlyVisibleHeight = Math.min(e4.totalHeight, e4.scrollableAreaHeight), e4.ratio = e4.currentlyVisibleHeight / e4.totalHeight, e4.barLength = Math.max(e4.ratio * e4.currentlyVisibleHeight, n2.goldenRatio * n2.scrollbarWidth), e4.barWiggleRoom = e4.currentlyVisibleHeight - e4.barLength, e4.wiggleRoom = Math.max(0, e4.totalHeight - e4.scrollableAreaHeight), e4.topY = 0 === e4.barWiggleRoom ? 0 : t4.scrollY / e4.wiggleRoom * e4.barWiggleRoom, e4.bottomY = e4.topY + e4.barLength, e4.dragMultiplier = e4.wiggleRoom / e4.barWiggleRoom;
          }).attr("transform", function(t4) {
            var e4 = t4.width + n2.scrollbarWidth / 2 + n2.scrollbarOffset;
            return c(e4, S(t4));
          });
          var s2 = a2.selectAll("." + n2.cn.scrollbar).data(o.repeat, o.keyFun);
          s2.enter().append("g").classed(n2.cn.scrollbar, true);
          var l2 = s2.selectAll("." + n2.cn.scrollbarSlider).data(o.repeat, o.keyFun);
          l2.enter().append("g").classed(n2.cn.scrollbarSlider, true), l2.attr("transform", function(t4) {
            return c(0, t4.scrollbarState.topY || 0);
          });
          var u2 = l2.selectAll("." + n2.cn.scrollbarGlyph).data(o.repeat, o.keyFun);
          u2.enter().append("line").classed(n2.cn.scrollbarGlyph, true).attr("stroke", "black").attr("stroke-width", n2.scrollbarWidth).attr("stroke-linecap", "round").attr("y1", n2.scrollbarWidth / 2), u2.attr("y2", function(t4) {
            return t4.scrollbarState.barLength - n2.scrollbarWidth / 2;
          }).attr("stroke-opacity", function(t4) {
            return t4.columnDragInProgress || !t4.scrollbarState.barWiggleRoom || r3 ? 0 : 0.4;
          }), u2.transition().delay(0).duration(0), u2.transition().delay(n2.scrollbarHideDelay).duration(n2.scrollbarHideDuration).attr("stroke-opacity", 0);
          var f3 = s2.selectAll("." + n2.cn.scrollbarCaptureZone).data(o.repeat, o.keyFun);
          f3.enter().append("line").classed(n2.cn.scrollbarCaptureZone, true).attr("stroke", "white").attr("stroke-opacity", 0.01).attr("stroke-width", n2.scrollbarCaptureWidth).attr("stroke-linecap", "butt").attr("y1", 0).on("mousedown", function(r4) {
            var n3 = i.event.y, a3 = this.getBoundingClientRect(), o2 = r4.scrollbarState, s3 = n3 - a3.top, l3 = i.scale.linear().domain([0, o2.scrollableAreaHeight]).range([0, o2.totalHeight]).clamp(true);
            o2.topY <= s3 && s3 <= o2.bottomY || L(e3, t3, null, l3(s3 - o2.barLength / 2))(r4);
          }).call(i.behavior.drag().origin(function(t4) {
            return i.event.stopPropagation(), t4.scrollbarState.scrollbarScrollInProgress = true, t4;
          }).on("drag", L(e3, t3)).on("dragend", function() {
          })), f3.attr("y2", function(t4) {
            return t4.scrollbarState.scrollableAreaHeight;
          }), e3._context.staticPlot && (u2.remove(), f3.remove());
        }
        function b(t3, e3, r3, a2) {
          var l2 = function(t4) {
            var e4 = t4.selectAll("." + n2.cn.columnCells).data(o.repeat, o.keyFun);
            return e4.enter().append("g").classed(n2.cn.columnCells, true), e4.exit().remove(), e4;
          }(r3), u2 = function(t4) {
            var e4 = t4.selectAll("." + n2.cn.columnCell).data(p2.splitToCells, function(t5) {
              return t5.keyWithinBlock;
            });
            return e4.enter().append("g").classed(n2.cn.columnCell, true), e4.exit().remove(), e4;
          }(l2);
          !function(t4) {
            t4.each(function(t5, e4) {
              var r4 = t5.calcdata.cells.font, n3 = t5.column.specIndex, i2 = { size: T(r4.size, n3, e4), color: T(r4.color, n3, e4), family: T(r4.family, n3, e4) };
              t5.rowNumber = t5.key, t5.align = T(t5.calcdata.cells.align, n3, e4), t5.cellBorderWidth = T(t5.calcdata.cells.line.width, n3, e4), t5.font = i2;
            });
          }(u2);
          var c2 = function(t4) {
            var e4 = t4.selectAll("." + n2.cn.cellRect).data(o.repeat, function(t5) {
              return t5.keyWithinBlock;
            });
            return e4.enter().append("rect").classed(n2.cn.cellRect, true), e4;
          }(u2);
          !function(t4) {
            t4.attr("width", function(t5) {
              return t5.column.columnWidth;
            }).attr("stroke-width", function(t5) {
              return t5.cellBorderWidth;
            }).each(function(t5) {
              var e4 = i.select(this);
              d2.stroke(e4, T(t5.calcdata.cells.line.color, t5.column.specIndex, t5.rowNumber)), d2.fill(e4, T(t5.calcdata.cells.fill.color, t5.column.specIndex, t5.rowNumber));
            });
          }(c2);
          var f3 = function(t4) {
            var e4 = t4.selectAll("." + n2.cn.cellTextHolder).data(o.repeat, function(t5) {
              return t5.keyWithinBlock;
            });
            return e4.enter().append("g").classed(n2.cn.cellTextHolder, true).style("shape-rendering", "geometricPrecision"), e4;
          }(u2), h2 = function(t4) {
            var e4 = t4.selectAll("." + n2.cn.cellText).data(o.repeat, function(t5) {
              return t5.keyWithinBlock;
            });
            return e4.enter().append("text").classed(n2.cn.cellText, true).style("cursor", function() {
              return "auto";
            }).on("mousedown", function() {
              i.event.stopPropagation();
            }), e4;
          }(f3);
          !function(t4) {
            t4.each(function(t5) {
              s.font(i.select(this), t5.font);
            });
          }(h2), _(h2, e3, a2, t3), D(u2);
        }
        function _(t3, e3, r3, o2) {
          t3.text(function(t4) {
            var e4 = t4.column.specIndex, r4 = t4.rowNumber, i2 = t4.value, o3 = "string" == typeof i2, s2 = o3 && i2.match(/<br>/i), l2 = !o3 || s2;
            t4.mayHaveMarkup = o3 && i2.match(/[<&>]/);
            var u2, c2 = "string" == typeof (u2 = i2) && u2.match(n2.latexCheck);
            t4.latex = c2;
            var f3, h2, p3 = c2 ? "" : T(t4.calcdata.cells.prefix, e4, r4) || "", d3 = c2 ? "" : T(t4.calcdata.cells.suffix, e4, r4) || "", v2 = c2 ? null : T(t4.calcdata.cells.format, e4, r4) || null, g3 = p3 + (v2 ? a(v2)(t4.value) : t4.value) + d3;
            if (t4.wrappingNeeded = !t4.wrapped && !l2 && !c2 && (f3 = w2(g3)), t4.cellHeightMayIncrease = s2 || c2 || t4.mayHaveMarkup || (void 0 === f3 ? w2(g3) : f3), t4.needsConvertToTspans = t4.mayHaveMarkup || t4.wrappingNeeded || t4.latex, t4.wrappingNeeded) {
              var y2 = (" " === n2.wrapSplitCharacter ? g3.replace(/<a href=/gi, "<a_href=") : g3).split(n2.wrapSplitCharacter), m3 = " " === n2.wrapSplitCharacter ? y2.map(function(t5) {
                return t5.replace(/<a_href=/gi, "<a href=");
              }) : y2;
              t4.fragments = m3.map(function(t5) {
                return { text: t5, width: null };
              }), t4.fragments.push({ fragment: n2.wrapSpacer, width: null }), h2 = m3.join(n2.lineBreaker) + n2.lineBreaker + n2.wrapSpacer;
            } else
              delete t4.fragments, h2 = g3;
            return h2;
          }).attr("dy", function(t4) {
            return t4.needsConvertToTspans ? 0 : "0.75em";
          }).each(function(t4) {
            var a2 = this, s2 = i.select(a2), u2 = t4.wrappingNeeded ? P : O;
            t4.needsConvertToTspans ? l.convertToTspans(s2, o2, u2(r3, a2, e3, o2, t4)) : i.select(a2.parentNode).attr("transform", function(t5) {
              return c(I(t5), n2.cellPad);
            }).attr("text-anchor", function(t5) {
              return { left: "start", center: "middle", right: "end" }[t5.align];
            });
          });
        }
        function w2(t3) {
          return -1 !== t3.indexOf(n2.wrapSplitCharacter);
        }
        function T(t3, e3, r3) {
          if (Array.isArray(t3)) {
            var n3 = t3[Math.min(e3, t3.length - 1)];
            return Array.isArray(n3) ? n3[Math.min(r3, n3.length - 1)] : n3;
          }
          return t3;
        }
        function k(t3, e3, r3) {
          t3.transition().ease(n2.releaseTransitionEase).duration(n2.releaseTransitionDuration).attr("transform", c(e3.x, r3));
        }
        function A(t3) {
          return "cells" === t3.type;
        }
        function M(t3) {
          return "header" === t3.type;
        }
        function S(t3) {
          return (t3.rowBlocks.length ? t3.rowBlocks[0].auxiliaryBlocks : []).reduce(function(t4, e3) {
            return t4 + R(e3, 1 / 0);
          }, 0);
        }
        function E(t3, e3, r3) {
          var n3 = m2(e3)[0];
          if (void 0 !== n3) {
            var i2 = n3.rowBlocks, a2 = n3.calcdata, o2 = z(i2, i2.length), s2 = n3.calcdata.groupHeight - S(n3), l2 = a2.scrollY = Math.max(0, Math.min(o2 - s2, a2.scrollY)), u2 = function(t4, e4, r4) {
              for (var n4 = [], i3 = 0, a3 = 0; a3 < t4.length; a3++) {
                for (var o3 = t4[a3], s3 = o3.rows, l3 = 0, u3 = 0; u3 < s3.length; u3++)
                  l3 += s3[u3].rowHeight;
                o3.allRowsHeight = l3, e4 < i3 + l3 && e4 + r4 > i3 && n4.push(a3), i3 += l3;
              }
              return n4;
            }(i2, l2, s2);
            1 === u2.length && (u2[0] === i2.length - 1 ? u2.unshift(u2[0] - 1) : u2.push(u2[0] + 1)), u2[0] % 2 && u2.reverse(), e3.each(function(t4, e4) {
              t4.page = u2[e4], t4.scrollY = l2;
            }), e3.attr("transform", function(t4) {
              var e4 = z(t4.rowBlocks, t4.page) - t4.scrollY;
              return c(0, e4);
            }), t3 && (C(t3, r3, e3, u2, n3.prevPages, n3, 0), C(t3, r3, e3, u2, n3.prevPages, n3, 1), x(r3, t3));
          }
        }
        function L(t3, e3, r3, a2) {
          return function(o2) {
            var s2 = o2.calcdata ? o2.calcdata : o2, l2 = e3.filter(function(t4) {
              return s2.key === t4.key;
            }), u2 = r3 || s2.scrollbarState.dragMultiplier, c2 = s2.scrollY;
            s2.scrollY = void 0 === a2 ? s2.scrollY + u2 * i.event.dy : a2;
            var f3 = l2.selectAll("." + n2.cn.yColumn).selectAll("." + n2.cn.columnBlock).filter(A);
            return E(t3, f3, l2), s2.scrollY === c2;
          };
        }
        function C(t3, e3, r3, n3, i2, a2, o2) {
          n3[o2] !== i2[o2] && (clearTimeout(a2.currentRepaint[o2]), a2.currentRepaint[o2] = setTimeout(function() {
            var a3 = r3.filter(function(t4, e4) {
              return e4 === o2 && n3[e4] !== i2[e4];
            });
            b(t3, e3, a3, r3), i2[o2] = n3[o2];
          }));
        }
        function P(t3, e3, r3, a2) {
          return function() {
            var o2 = i.select(e3.parentNode);
            o2.each(function(t4) {
              var e4 = t4.fragments;
              o2.selectAll("tspan.line").each(function(t5, r5) {
                e4[r5].width = this.getComputedTextLength();
              });
              var r4, i2, a3 = e4[e4.length - 1].width, s2 = e4.slice(0, -1), l2 = [], u2 = 0, c2 = t4.column.columnWidth - 2 * n2.cellPad;
              for (t4.value = ""; s2.length; )
                u2 + (i2 = (r4 = s2.shift()).width + a3) > c2 && (t4.value += l2.join(n2.wrapSpacer) + n2.lineBreaker, l2 = [], u2 = 0), l2.push(r4.text), u2 += i2;
              u2 && (t4.value += l2.join(n2.wrapSpacer)), t4.wrapped = true;
            }), o2.selectAll("tspan.line").remove(), _(o2.select("." + n2.cn.cellText), r3, t3, a2), i.select(e3.parentNode.parentNode).call(D);
          };
        }
        function O(t3, e3, r3, a2, o2) {
          return function() {
            if (!o2.settledY) {
              var s2 = i.select(e3.parentNode), l2 = B(o2), u2 = o2.key - l2.firstRowIndex, f3 = l2.rows[u2].rowHeight, h2 = o2.cellHeightMayIncrease ? e3.parentNode.getBoundingClientRect().height + 2 * n2.cellPad : f3, p3 = Math.max(h2, f3);
              p3 - l2.rows[u2].rowHeight && (l2.rows[u2].rowHeight = p3, t3.selectAll("." + n2.cn.columnCell).call(D), E(null, t3.filter(A), 0), x(r3, a2, true)), s2.attr("transform", function() {
                var t4 = this, e4 = t4.parentNode.getBoundingClientRect(), r4 = i.select(t4.parentNode).select("." + n2.cn.cellRect).node().getBoundingClientRect(), a3 = t4.transform.baseVal.consolidate(), s3 = r4.top - e4.top + (a3 ? a3.matrix.f : n2.cellPad);
                return c(I(o2, i.select(t4.parentNode).select("." + n2.cn.cellTextHolder).node().getBoundingClientRect().width), s3);
              }), o2.settledY = true;
            }
          };
        }
        function I(t3, e3) {
          switch (t3.align) {
            case "left":
            default:
              return n2.cellPad;
            case "right":
              return t3.column.columnWidth - (e3 || 0) - n2.cellPad;
            case "center":
              return (t3.column.columnWidth - (e3 || 0)) / 2;
          }
        }
        function D(t3) {
          t3.attr("transform", function(t4) {
            var e3 = t4.rowBlocks[0].auxiliaryBlocks.reduce(function(t5, e4) {
              return t5 + R(e4, 1 / 0);
            }, 0), r3 = R(B(t4), t4.key);
            return c(0, r3 + e3);
          }).selectAll("." + n2.cn.cellRect).attr("height", function(t4) {
            return (e3 = B(t4), r3 = t4.key, e3.rows[r3 - e3.firstRowIndex]).rowHeight;
            var e3, r3;
          });
        }
        function z(t3, e3) {
          for (var r3 = 0, n3 = e3 - 1; n3 >= 0; n3--)
            r3 += F(t3[n3]);
          return r3;
        }
        function R(t3, e3) {
          for (var r3 = 0, n3 = 0; n3 < t3.rows.length && t3.rows[n3].rowIndex < e3; n3++)
            r3 += t3.rows[n3].rowHeight;
          return r3;
        }
        function F(t3) {
          var e3 = t3.allRowsHeight;
          if (void 0 !== e3)
            return e3;
          for (var r3 = 0, n3 = 0; n3 < t3.rows.length; n3++)
            r3 += t3.rows[n3].rowHeight;
          return t3.allRowsHeight = r3, r3;
        }
        function B(t3) {
          return t3.rowBlocks[t3.page];
        }
        t2.exports = function(t3, e3) {
          var r3 = !t3._context.staticPlot, a2 = t3._fullLayout._paper.selectAll("." + n2.cn.table).data(e3.map(function(e4) {
            var r4 = o.unwrap(e4).trace;
            return h(t3, r4);
          }), o.keyFun);
          a2.exit().remove(), a2.enter().append("g").classed(n2.cn.table, true).attr("overflow", "visible").style("box-sizing", "content-box").style("position", "absolute").style("left", 0).style("overflow", "visible").style("shape-rendering", "crispEdges").style("pointer-events", "all"), a2.attr("width", function(t4) {
            return t4.width + t4.size.l + t4.size.r;
          }).attr("height", function(t4) {
            return t4.height + t4.size.t + t4.size.b;
          }).attr("transform", function(t4) {
            return c(t4.translateX, t4.translateY);
          });
          var l2 = a2.selectAll("." + n2.cn.tableControlView).data(o.repeat, o.keyFun), d3 = l2.enter().append("g").classed(n2.cn.tableControlView, true).style("box-sizing", "content-box");
          if (r3) {
            var _2 = "onwheel" in document ? "wheel" : "mousewheel";
            d3.on("mousemove", function(e4) {
              l2.filter(function(t4) {
                return e4 === t4;
              }).call(x, t3);
            }).on(_2, function(e4) {
              if (!e4.scrollbarState.wheeling) {
                e4.scrollbarState.wheeling = true;
                var r4 = e4.scrollY + i.event.deltaY;
                L(t3, l2, null, r4)(e4) || (i.event.stopPropagation(), i.event.preventDefault()), e4.scrollbarState.wheeling = false;
              }
            }).call(x, t3, true);
          }
          l2.attr("transform", function(t4) {
            return c(t4.size.l, t4.size.t);
          });
          var w3 = l2.selectAll("." + n2.cn.scrollBackground).data(o.repeat, o.keyFun);
          w3.enter().append("rect").classed(n2.cn.scrollBackground, true).attr("fill", "none"), w3.attr("width", function(t4) {
            return t4.width;
          }).attr("height", function(t4) {
            return t4.height;
          }), l2.each(function(e4) {
            s.setClipUrl(i.select(this), g2(t3, e4), t3);
          });
          var T2 = l2.selectAll("." + n2.cn.yColumn).data(function(t4) {
            return t4.columns;
          }, o.keyFun);
          T2.enter().append("g").classed(n2.cn.yColumn, true), T2.exit().remove(), T2.attr("transform", function(t4) {
            return c(t4.x, 0);
          }), r3 && T2.call(i.behavior.drag().origin(function(e4) {
            return k(i.select(this), e4, -n2.uplift), u(this), e4.calcdata.columnDragInProgress = true, x(l2.filter(function(t4) {
              return e4.calcdata.key === t4.key;
            }), t3), e4;
          }).on("drag", function(t4) {
            var e4 = i.select(this), r4 = function(e5) {
              return (t4 === e5 ? i.event.x : e5.x) + e5.columnWidth / 2;
            };
            t4.x = Math.max(-n2.overdrag, Math.min(t4.calcdata.width + n2.overdrag - t4.columnWidth, i.event.x)), m2(T2).filter(function(e5) {
              return e5.calcdata.key === t4.calcdata.key;
            }).sort(function(t5, e5) {
              return r4(t5) - r4(e5);
            }).forEach(function(e5, r5) {
              e5.xIndex = r5, e5.x = t4 === e5 ? e5.x : e5.xScale(e5);
            }), T2.filter(function(e5) {
              return t4 !== e5;
            }).transition().ease(n2.transitionEase).duration(n2.transitionDuration).attr("transform", function(t5) {
              return c(t5.x, 0);
            }), e4.call(f2).attr("transform", c(t4.x, -n2.uplift));
          }).on("dragend", function(e4) {
            var r4 = i.select(this), n3 = e4.calcdata;
            e4.x = e4.xScale(e4), e4.calcdata.columnDragInProgress = false, k(r4, e4, 0), function(t4, e5, r5) {
              var n4 = e5.gdColumnsOriginalOrder;
              e5.gdColumns.sort(function(t5, e6) {
                return r5[n4.indexOf(t5)] - r5[n4.indexOf(e6)];
              }), e5.columnorder = r5, t4.emit("plotly_restyle");
            }(t3, n3, n3.columns.map(function(t4) {
              return t4.xIndex;
            }));
          })), T2.each(function(e4) {
            s.setClipUrl(i.select(this), y(t3, e4), t3);
          });
          var S2 = T2.selectAll("." + n2.cn.columnBlock).data(p2.splitToPanels, o.keyFun);
          S2.enter().append("g").classed(n2.cn.columnBlock, true).attr("id", function(t4) {
            return t4.key;
          }), S2.style("cursor", function(t4) {
            return t4.dragHandle ? "ew-resize" : t4.calcdata.scrollbarState.barWiggleRoom ? "ns-resize" : "default";
          });
          var C2 = S2.filter(M), P2 = S2.filter(A);
          r3 && P2.call(i.behavior.drag().origin(function(t4) {
            return i.event.stopPropagation(), t4;
          }).on("drag", L(t3, l2, -1)).on("dragend", function() {
          })), b(t3, l2, C2, S2), b(t3, l2, P2, S2);
          var O2 = l2.selectAll("." + n2.cn.scrollAreaClip).data(o.repeat, o.keyFun);
          O2.enter().append("clipPath").classed(n2.cn.scrollAreaClip, true).attr("id", function(e4) {
            return g2(t3, e4);
          });
          var I2 = O2.selectAll("." + n2.cn.scrollAreaClipRect).data(o.repeat, o.keyFun);
          I2.enter().append("rect").classed(n2.cn.scrollAreaClipRect, true).attr("x", -n2.overdrag).attr("y", -n2.uplift).attr("fill", "none"), I2.attr("width", function(t4) {
            return t4.width + 2 * n2.overdrag;
          }).attr("height", function(t4) {
            return t4.height + n2.uplift;
          }), T2.selectAll("." + n2.cn.columnBoundary).data(o.repeat, o.keyFun).enter().append("g").classed(n2.cn.columnBoundary, true);
          var D2 = T2.selectAll("." + n2.cn.columnBoundaryClippath).data(o.repeat, o.keyFun);
          D2.enter().append("clipPath").classed(n2.cn.columnBoundaryClippath, true), D2.attr("id", function(e4) {
            return y(t3, e4);
          });
          var z2 = D2.selectAll("." + n2.cn.columnBoundaryRect).data(o.repeat, o.keyFun);
          z2.enter().append("rect").classed(n2.cn.columnBoundaryRect, true).attr("fill", "none"), z2.attr("width", function(t4) {
            return t4.columnWidth + 2 * v(t4);
          }).attr("height", function(t4) {
            return t4.calcdata.height + 2 * v(t4) + n2.uplift;
          }).attr("x", function(t4) {
            return -v(t4);
          }).attr("y", function(t4) {
            return -v(t4);
          }), E(null, P2, l2);
        };
      }, 45802: function(t2, e2, r2) {
        var n2 = r2(5386).f, i = r2(5386).s, a = r2(50693), o = r2(27670).Y, s = r2(34e3), l = r2(57564), u = r2(43473), c = r2(1426).extendFlat;
        t2.exports = { labels: l.labels, parents: l.parents, values: l.values, branchvalues: l.branchvalues, count: l.count, level: l.level, maxdepth: l.maxdepth, tiling: { packing: { valType: "enumerated", values: ["squarify", "binary", "dice", "slice", "slice-dice", "dice-slice"], dflt: "squarify", editType: "plot" }, squarifyratio: { valType: "number", min: 1, dflt: 1, editType: "plot" }, flip: { valType: "flaglist", flags: ["x", "y"], dflt: "", editType: "plot" }, pad: { valType: "number", min: 0, dflt: 3, editType: "plot" }, editType: "calc" }, marker: c({ pad: { t: { valType: "number", min: 0, editType: "plot" }, l: { valType: "number", min: 0, editType: "plot" }, r: { valType: "number", min: 0, editType: "plot" }, b: { valType: "number", min: 0, editType: "plot" }, editType: "calc" }, colors: l.marker.colors, depthfade: { valType: "enumerated", values: [true, false, "reversed"], editType: "style" }, line: l.marker.line, cornerradius: { valType: "number", min: 0, dflt: 0, editType: "plot" }, editType: "calc" }, a("marker", { colorAttr: "colors", anim: false })), pathbar: { visible: { valType: "boolean", dflt: true, editType: "plot" }, side: { valType: "enumerated", values: ["top", "bottom"], dflt: "top", editType: "plot" }, edgeshape: { valType: "enumerated", values: [">", "<", "|", "/", "\\"], dflt: ">", editType: "plot" }, thickness: { valType: "number", min: 12, editType: "plot" }, textfont: c({}, s.textfont, {}), editType: "calc" }, text: s.text, textinfo: l.textinfo, texttemplate: i({ editType: "plot" }, { keys: u.eventDataKeys.concat(["label", "value"]) }), hovertext: s.hovertext, hoverinfo: l.hoverinfo, hovertemplate: n2({}, { keys: u.eventDataKeys }), textfont: s.textfont, insidetextfont: s.insidetextfont, outsidetextfont: c({}, s.outsidetextfont, {}), textposition: { valType: "enumerated", values: ["top left", "top center", "top right", "middle left", "middle center", "middle right", "bottom left", "bottom center", "bottom right"], dflt: "top left", editType: "plot" }, sort: s.sort, root: l.root, domain: o({ name: "treemap", trace: true, editType: "calc" }) };
      }, 78018: function(t2, e2, r2) {
        var n2 = r2(74875);
        e2.name = "treemap", e2.plot = function(t3, r3, i, a) {
          n2.plotBasePlot(e2.name, t3, r3, i, a);
        }, e2.clean = function(t3, r3, i, a) {
          n2.cleanBasePlot(e2.name, t3, r3, i, a);
        };
      }, 65039: function(t2, e2, r2) {
        var n2 = r2(52147);
        e2.y = function(t3, e3) {
          return n2.calc(t3, e3);
        }, e2.T = function(t3) {
          return n2._runCrossTraceCalc("treemap", t3);
        };
      }, 43473: function(t2) {
        t2.exports = { CLICK_TRANSITION_TIME: 750, CLICK_TRANSITION_EASING: "poly", eventDataKeys: ["currentPath", "root", "entry", "percentRoot", "percentEntry", "percentParent"], gapWithPathbar: 1 };
      }, 91174: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(45802), a = r2(7901), o = r2(27670).c, s = r2(90769).handleText, l = r2(97313).TEXTPAD, u = r2(21081), c = u.hasColorscale, f2 = u.handleDefaults;
        t2.exports = function(t3, e3, r3, u2) {
          function h(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          var p2 = h("labels"), d2 = h("parents");
          if (p2 && p2.length && d2 && d2.length) {
            var v = h("values");
            v && v.length ? h("branchvalues") : h("count"), h("level"), h("maxdepth"), "squarify" === h("tiling.packing") && h("tiling.squarifyratio"), h("tiling.flip"), h("tiling.pad");
            var g2 = h("text");
            h("texttemplate"), e3.texttemplate || h("textinfo", Array.isArray(g2) ? "text+label" : "label"), h("hovertext"), h("hovertemplate");
            var y = h("pathbar.visible");
            s(t3, e3, u2, h, "auto", { hasPathbar: y, moduleHasSelected: false, moduleHasUnselected: false, moduleHasConstrain: false, moduleHasCliponaxis: false, moduleHasTextangle: false, moduleHasInsideanchor: false }), h("textposition");
            var m2 = -1 !== e3.textposition.indexOf("bottom");
            h("marker.line.width") && h("marker.line.color", u2.paper_bgcolor);
            var x = h("marker.colors");
            (e3._hasColorscale = c(t3, "marker", "colors") || (t3.marker || {}).coloraxis) ? f2(t3, e3, u2, h, { prefix: "marker.", cLetter: "c" }) : h("marker.depthfade", !(x || []).length);
            var b = 2 * e3.textfont.size;
            h("marker.pad.t", m2 ? b / 4 : b), h("marker.pad.l", b / 4), h("marker.pad.r", b / 4), h("marker.pad.b", m2 ? b : b / 4), h("marker.cornerradius"), e3._hovered = { marker: { line: { width: 2, color: a.contrast(u2.paper_bgcolor) } } }, y && (h("pathbar.thickness", e3.pathbar.textfont.size + 2 * l), h("pathbar.side"), h("pathbar.edgeshape")), h("sort"), h("root.color"), o(e3, u2, h), e3._length = null;
          } else
            e3.visible = false;
        };
      }, 80694: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(2791), a = r2(72597).clearMinTextSize, o = r2(16688).resizeText, s = r2(46650);
        t2.exports = function(t3, e3, r3, l, u) {
          var c, f2, h = u.type, p2 = u.drawDescendants, d2 = t3._fullLayout, v = d2["_" + h + "layer"], g2 = !r3;
          a(h, d2), (c = v.selectAll("g.trace." + h).data(e3, function(t4) {
            return t4[0].trace.uid;
          })).enter().append("g").classed("trace", true).classed(h, true), c.order(), !d2.uniformtext.mode && i.hasTransition(r3) ? (l && (f2 = l()), n2.transition().duration(r3.duration).ease(r3.easing).each("end", function() {
            f2 && f2();
          }).each("interrupt", function() {
            f2 && f2();
          }).each(function() {
            v.selectAll("g.trace").each(function(e4) {
              s(t3, e4, this, r3, p2);
            });
          })) : (c.each(function(e4) {
            s(t3, e4, this, r3, p2);
          }), d2.uniformtext.mode && o(t3, v.selectAll(".trace"), h)), g2 && c.exit().remove();
        };
      }, 66209: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(91424), o = r2(63893), s = r2(37210), l = r2(96362).styleOne, u = r2(43473), c = r2(2791), f2 = r2(83523), h = true;
        t2.exports = function(t3, e3, r3, p2, d2) {
          var v = d2.barDifY, g2 = d2.width, y = d2.height, m2 = d2.viewX, x = d2.viewY, b = d2.pathSlice, _ = d2.toMoveInsideSlice, w2 = d2.strTransform, T = d2.hasTransition, k = d2.handleSlicesExit, A = d2.makeUpdateSliceInterpolator, M = d2.makeUpdateTextInterpolator, S = {}, E = t3._context.staticPlot, L = t3._fullLayout, C = e3[0], P = C.trace, O = C.hierarchy, I = g2 / P._entryDepth, D = c.listPath(r3.data, "id"), z = s(O.copy(), [g2, y], { packing: "dice", pad: { inner: 0, top: 0, left: 0, right: 0, bottom: 0 } }).descendants();
          (z = z.filter(function(t4) {
            var e4 = D.indexOf(t4.data.id);
            return -1 !== e4 && (t4.x0 = I * e4, t4.x1 = I * (e4 + 1), t4.y0 = v, t4.y1 = v + y, t4.onPathbar = true, true);
          })).reverse(), (p2 = p2.data(z, c.getPtId)).enter().append("g").classed("pathbar", true), k(p2, h, S, [g2, y], b), p2.order();
          var R = p2;
          T && (R = R.transition().each("end", function() {
            var e4 = n2.select(this);
            c.setSliceCursor(e4, t3, { hideOnRoot: false, hideOnLeaves: false, isTransitioning: false });
          })), R.each(function(s2) {
            s2._x0 = m2(s2.x0), s2._x1 = m2(s2.x1), s2._y0 = x(s2.y0), s2._y1 = x(s2.y1), s2._hoverX = m2(s2.x1 - Math.min(g2, y) / 2), s2._hoverY = x(s2.y1 - y / 2);
            var p3 = n2.select(this), d3 = i.ensureSingle(p3, "path", "surface", function(t4) {
              t4.style("pointer-events", E ? "none" : "all");
            });
            T ? d3.transition().attrTween("d", function(t4) {
              var e4 = A(t4, h, S, [g2, y]);
              return function(t5) {
                return b(e4(t5));
              };
            }) : d3.attr("d", b), p3.call(f2, r3, t3, e3, { styleOne: l, eventDataKeys: u.eventDataKeys, transitionTime: u.CLICK_TRANSITION_TIME, transitionEasing: u.CLICK_TRANSITION_EASING }).call(c.setSliceCursor, t3, { hideOnRoot: false, hideOnLeaves: false, isTransitioning: t3._transitioning }), d3.call(l, s2, P, { hovered: false }), s2._text = (c.getPtLabel(s2) || "").split("<br>").join(" ") || "";
            var v2 = i.ensureSingle(p3, "g", "slicetext"), k2 = i.ensureSingle(v2, "text", "", function(t4) {
              t4.attr("data-notex", 1);
            }), C2 = i.ensureUniformFontSize(t3, c.determineTextFont(P, s2, L.font, { onPathbar: true }));
            k2.text(s2._text || " ").classed("slicetext", true).attr("text-anchor", "start").call(a.font, C2).call(o.convertToTspans, t3), s2.textBB = a.bBox(k2.node()), s2.transform = _(s2, { fontSize: C2.size, onPathbar: true }), s2.transform.fontSize = C2.size, T ? k2.transition().attrTween("transform", function(t4) {
              var e4 = M(t4, h, S, [g2, y]);
              return function(t5) {
                return w2(e4(t5));
              };
            }) : k2.attr("transform", w2(s2));
          });
        };
      }, 52583: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(91424), o = r2(63893), s = r2(37210), l = r2(96362).styleOne, u = r2(43473), c = r2(2791), f2 = r2(83523), h = r2(24714).formatSliceLabel, p2 = false;
        t2.exports = function(t3, e3, r3, d2, v) {
          var g2 = v.width, y = v.height, m2 = v.viewX, x = v.viewY, b = v.pathSlice, _ = v.toMoveInsideSlice, w2 = v.strTransform, T = v.hasTransition, k = v.handleSlicesExit, A = v.makeUpdateSliceInterpolator, M = v.makeUpdateTextInterpolator, S = v.prevEntry, E = t3._context.staticPlot, L = t3._fullLayout, C = e3[0].trace, P = -1 !== C.textposition.indexOf("left"), O = -1 !== C.textposition.indexOf("right"), I = -1 !== C.textposition.indexOf("bottom"), D = !I && !C.marker.pad.t || I && !C.marker.pad.b, z = s(r3, [g2, y], { packing: C.tiling.packing, squarifyratio: C.tiling.squarifyratio, flipX: C.tiling.flip.indexOf("x") > -1, flipY: C.tiling.flip.indexOf("y") > -1, pad: { inner: C.tiling.pad, top: C.marker.pad.t, left: C.marker.pad.l, right: C.marker.pad.r, bottom: C.marker.pad.b } }).descendants(), R = 1 / 0, F = -1 / 0;
          z.forEach(function(t4) {
            var e4 = t4.depth;
            e4 >= C._maxDepth ? (t4.x0 = t4.x1 = (t4.x0 + t4.x1) / 2, t4.y0 = t4.y1 = (t4.y0 + t4.y1) / 2) : (R = Math.min(R, e4), F = Math.max(F, e4));
          }), d2 = d2.data(z, c.getPtId), C._maxVisibleLayers = isFinite(F) ? F - R + 1 : 0, d2.enter().append("g").classed("slice", true), k(d2, p2, {}, [g2, y], b), d2.order();
          var B = null;
          if (T && S) {
            var N = c.getPtId(S);
            d2.each(function(t4) {
              null === B && c.getPtId(t4) === N && (B = { x0: t4.x0, x1: t4.x1, y0: t4.y0, y1: t4.y1 });
            });
          }
          var j = function() {
            return B || { x0: 0, x1: g2, y0: 0, y1: y };
          }, U = d2;
          return T && (U = U.transition().each("end", function() {
            var e4 = n2.select(this);
            c.setSliceCursor(e4, t3, { hideOnRoot: true, hideOnLeaves: false, isTransitioning: false });
          })), U.each(function(s2) {
            var d3 = c.isHeader(s2, C);
            s2._x0 = m2(s2.x0), s2._x1 = m2(s2.x1), s2._y0 = x(s2.y0), s2._y1 = x(s2.y1), s2._hoverX = m2(s2.x1 - C.marker.pad.r), s2._hoverY = x(I ? s2.y1 - C.marker.pad.b / 2 : s2.y0 + C.marker.pad.t / 2);
            var v2 = n2.select(this), k2 = i.ensureSingle(v2, "path", "surface", function(t4) {
              t4.style("pointer-events", E ? "none" : "all");
            });
            T ? k2.transition().attrTween("d", function(t4) {
              var e4 = A(t4, p2, j(), [g2, y]);
              return function(t5) {
                return b(e4(t5));
              };
            }) : k2.attr("d", b), v2.call(f2, r3, t3, e3, { styleOne: l, eventDataKeys: u.eventDataKeys, transitionTime: u.CLICK_TRANSITION_TIME, transitionEasing: u.CLICK_TRANSITION_EASING }).call(c.setSliceCursor, t3, { isTransitioning: t3._transitioning }), k2.call(l, s2, C, { hovered: false }), s2.x0 === s2.x1 || s2.y0 === s2.y1 ? s2._text = "" : s2._text = d3 ? D ? "" : c.getPtLabel(s2) || "" : h(s2, r3, C, e3, L) || "";
            var S2 = i.ensureSingle(v2, "g", "slicetext"), z2 = i.ensureSingle(S2, "text", "", function(t4) {
              t4.attr("data-notex", 1);
            }), R2 = i.ensureUniformFontSize(t3, c.determineTextFont(C, s2, L.font));
            z2.text(s2._text || " ").classed("slicetext", true).attr("text-anchor", O ? "end" : P || d3 ? "start" : "middle").call(a.font, R2).call(o.convertToTspans, t3), s2.textBB = a.bBox(z2.node()), s2.transform = _(s2, { fontSize: R2.size, isHeader: d3 }), s2.transform.fontSize = R2.size, T ? z2.transition().attrTween("transform", function(t4) {
              var e4 = M(t4, p2, j(), [g2, y]);
              return function(t5) {
                return w2(e4(t5));
              };
            }) : z2.attr("transform", w2(s2));
          }), B;
        };
      }, 14102: function(t2) {
        t2.exports = function t3(e2, r2, n2) {
          var i;
          n2.swapXY && (i = e2.x0, e2.x0 = e2.y0, e2.y0 = i, i = e2.x1, e2.x1 = e2.y1, e2.y1 = i), n2.flipX && (i = e2.x0, e2.x0 = r2[0] - e2.x1, e2.x1 = r2[0] - i), n2.flipY && (i = e2.y0, e2.y0 = r2[1] - e2.y1, e2.y1 = r2[1] - i);
          var a = e2.children;
          if (a)
            for (var o = 0; o < a.length; o++)
              t3(a[o], r2, n2);
        };
      }, 70954: function(t2, e2, r2) {
        t2.exports = { moduleType: "trace", name: "treemap", basePlotModule: r2(78018), categories: [], animatable: true, attributes: r2(45802), layoutAttributes: r2(55479), supplyDefaults: r2(91174), supplyLayoutDefaults: r2(77182), calc: r2(65039).y, crossTraceCalc: r2(65039).T, plot: r2(5893), style: r2(96362).style, colorbar: r2(4898), meta: {} };
      }, 55479: function(t2) {
        t2.exports = { treemapcolorway: { valType: "colorlist", editType: "calc" }, extendtreemapcolors: { valType: "boolean", dflt: true, editType: "calc" } };
      }, 77182: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(55479);
        t2.exports = function(t3, e3) {
          function r3(r4, a) {
            return n2.coerce(t3, e3, i, r4, a);
          }
          r3("treemapcolorway", e3.colorway), r3("extendtreemapcolors");
        };
      }, 37210: function(t2, e2, r2) {
        var n2 = r2(674), i = r2(14102);
        t2.exports = function(t3, e3, r3) {
          var a, o = r3.flipX, s = r3.flipY, l = "dice-slice" === r3.packing, u = r3.pad[s ? "bottom" : "top"], c = r3.pad[o ? "right" : "left"], f2 = r3.pad[o ? "left" : "right"], h = r3.pad[s ? "top" : "bottom"];
          l && (a = c, c = u, u = a, a = f2, f2 = h, h = a);
          var p2 = n2.treemap().tile(function(t4, e4) {
            switch (t4) {
              case "squarify":
                return n2.treemapSquarify.ratio(e4);
              case "binary":
                return n2.treemapBinary;
              case "dice":
                return n2.treemapDice;
              case "slice":
                return n2.treemapSlice;
              default:
                return n2.treemapSliceDice;
            }
          }(r3.packing, r3.squarifyratio)).paddingInner(r3.pad.inner).paddingLeft(c).paddingRight(f2).paddingTop(u).paddingBottom(h).size(l ? [e3[1], e3[0]] : e3)(t3);
          return (l || o || s) && i(p2, e3, { swapXY: l, flipX: o, flipY: s }), p2;
        };
      }, 5893: function(t2, e2, r2) {
        var n2 = r2(80694), i = r2(52583);
        t2.exports = function(t3, e3, r3, a) {
          return n2(t3, e3, r3, a, { type: "treemap", drawDescendants: i });
        };
      }, 46650: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(81684).sX, a = r2(2791), o = r2(71828), s = r2(97313).TEXTPAD, l = r2(17295).toMoveInsideBar, u = r2(72597).recordMinTextSize, c = r2(43473), f2 = r2(66209);
        function h(t3) {
          return a.isHierarchyRoot(t3) ? "" : a.getPtId(t3);
        }
        t2.exports = function(t3, e3, r3, p2, d2) {
          var v = t3._fullLayout, g2 = e3[0], y = g2.trace, m2 = "icicle" === y.type, x = g2.hierarchy, b = a.findEntryWithLevel(x, y.level), _ = n2.select(r3), w2 = _.selectAll("g.pathbar"), T = _.selectAll("g.slice");
          if (!b)
            return w2.remove(), void T.remove();
          var k = a.isHierarchyRoot(b), A = !v.uniformtext.mode && a.hasTransition(p2), M = a.getMaxDepth(y), S = v._size, E = y.domain, L = S.w * (E.x[1] - E.x[0]), C = S.h * (E.y[1] - E.y[0]), P = L, O = y.pathbar.thickness, I = y.marker.line.width + c.gapWithPathbar, D = y.pathbar.visible ? y.pathbar.side.indexOf("bottom") > -1 ? C + I : -(O + I) : 0, z = { x0: P, x1: P, y0: D, y1: D + O }, R = function(t4, e4, r4) {
            var n3 = y.tiling.pad, i2 = function(t5) {
              return t5 - n3 <= e4.x0;
            }, a2 = function(t5) {
              return t5 + n3 >= e4.x1;
            }, o2 = function(t5) {
              return t5 - n3 <= e4.y0;
            }, s2 = function(t5) {
              return t5 + n3 >= e4.y1;
            };
            return t4.x0 === e4.x0 && t4.x1 === e4.x1 && t4.y0 === e4.y0 && t4.y1 === e4.y1 ? { x0: t4.x0, x1: t4.x1, y0: t4.y0, y1: t4.y1 } : { x0: i2(t4.x0 - n3) ? 0 : a2(t4.x0 - n3) ? r4[0] : t4.x0, x1: i2(t4.x1 + n3) ? 0 : a2(t4.x1 + n3) ? r4[0] : t4.x1, y0: o2(t4.y0 - n3) ? 0 : s2(t4.y0 - n3) ? r4[1] : t4.y0, y1: o2(t4.y1 + n3) ? 0 : s2(t4.y1 + n3) ? r4[1] : t4.y1 };
          }, F = null, B = {}, N = {}, j = null, U = function(t4, e4) {
            return e4 ? B[h(t4)] : N[h(t4)];
          };
          g2.hasMultipleRoots && k && M++, y._maxDepth = M, y._backgroundColor = v.paper_bgcolor, y._entryDepth = b.data.depth, y._atRootLevel = k;
          var V = -L / 2 + S.l + S.w * (E.x[1] + E.x[0]) / 2, H = -C / 2 + S.t + S.h * (1 - (E.y[1] + E.y[0]) / 2), q2 = function(t4) {
            return V + t4;
          }, G = function(t4) {
            return H + t4;
          }, Z = G(0), Y = q2(0), W = function(t4) {
            return Y + t4;
          }, X = function(t4) {
            return Z + t4;
          };
          function J(t4, e4) {
            return t4 + "," + e4;
          }
          var K = W(0), $ = function(t4) {
            t4.x = Math.max(K, t4.x);
          }, Q = y.pathbar.edgeshape, tt = y[m2 ? "tiling" : "marker"].pad, et = function(t4) {
            return -1 !== y.textposition.indexOf(t4);
          }, rt = et("top"), nt = et("left"), it = et("right"), at = et("bottom"), ot = function(t4, e4) {
            var r4 = t4.x0, n3 = t4.x1, i2 = t4.y0, a2 = t4.y1, o2 = t4.textBB, c2 = rt || e4.isHeader && !at ? "start" : at ? "end" : "middle", f3 = et("right"), h2 = et("left") || e4.onPathbar ? -1 : f3 ? 1 : 0;
            if (e4.isHeader) {
              if ((r4 += (m2 ? tt : tt.l) - s) >= (n3 -= (m2 ? tt : tt.r) - s)) {
                var p3 = (r4 + n3) / 2;
                r4 = p3, n3 = p3;
              }
              var d3;
              at ? i2 < (d3 = a2 - (m2 ? tt : tt.b)) && d3 < a2 && (i2 = d3) : i2 < (d3 = i2 + (m2 ? tt : tt.t)) && d3 < a2 && (a2 = d3);
            }
            var g3 = l(r4, n3, i2, a2, o2, { isHorizontal: false, constrained: true, angle: 0, anchor: c2, leftToRight: h2 });
            return g3.fontSize = e4.fontSize, g3.targetX = q2(g3.targetX), g3.targetY = G(g3.targetY), isNaN(g3.targetX) || isNaN(g3.targetY) ? {} : (r4 !== n3 && i2 !== a2 && u(y.type, g3, v), { scale: g3.scale, rotate: g3.rotate, textX: g3.textX, textY: g3.textY, anchorX: g3.anchorX, anchorY: g3.anchorY, targetX: g3.targetX, targetY: g3.targetY });
          }, st = function(t4, e4) {
            for (var r4, n3 = 0, i2 = t4; !r4 && n3 < M; )
              n3++, (i2 = i2.parent) ? r4 = U(i2, e4) : n3 = M;
            return r4 || {};
          }, lt = function(t4, e4, r4, n3, a2) {
            var s2, l2 = U(t4, e4);
            if (l2)
              s2 = l2;
            else if (e4)
              s2 = z;
            else if (F)
              if (t4.parent) {
                var u2 = j || r4;
                u2 && !e4 ? s2 = R(t4, u2, n3) : (s2 = {}, o.extendFlat(s2, st(t4, e4)));
              } else
                s2 = o.extendFlat({}, t4), m2 && ("h" === a2.orientation ? a2.flipX ? s2.x0 = t4.x1 : s2.x1 = 0 : a2.flipY ? s2.y0 = t4.y1 : s2.y1 = 0);
            else
              s2 = {};
            return i(s2, { x0: t4.x0, x1: t4.x1, y0: t4.y0, y1: t4.y1 });
          }, ut = function(t4, e4, r4, n3) {
            var s2 = U(t4, e4), l2 = {}, c2 = function(t5, e5, r5, n4) {
              if (e5)
                return B[h(x)] || z;
              var i2 = N[y.level] || r5;
              return function(t6) {
                return t6.data.depth - b.data.depth < M;
              }(t5) ? R(t5, i2, n4) : {};
            }(t4, e4, r4, n3);
            o.extendFlat(l2, { transform: ot({ x0: c2.x0, x1: c2.x1, y0: c2.y0, y1: c2.y1, textBB: t4.textBB, _text: t4._text }, { isHeader: a.isHeader(t4, y) }) }), s2 ? l2 = s2 : t4.parent && o.extendFlat(l2, st(t4, e4));
            var f3 = t4.transform;
            return t4.x0 !== t4.x1 && t4.y0 !== t4.y1 && u(y.type, f3, v), i(l2, { transform: { scale: f3.scale, rotate: f3.rotate, textX: f3.textX, textY: f3.textY, anchorX: f3.anchorX, anchorY: f3.anchorY, targetX: f3.targetX, targetY: f3.targetY } });
          }, ct = function(t4, e4, r4, a2, o2) {
            var s2 = a2[0], l2 = a2[1];
            A ? t4.exit().transition().each(function() {
              var t5 = n2.select(this);
              t5.select("path.surface").transition().attrTween("d", function(t6) {
                var r5 = function(t7, e5, r6, n3) {
                  var a3, o3 = U(t7, e5);
                  if (e5)
                    a3 = z;
                  else {
                    var s3 = U(b, e5);
                    a3 = s3 ? R(t7, s3, n3) : {};
                  }
                  return i(o3, a3);
                }(t6, e4, 0, [s2, l2]);
                return function(t7) {
                  return o2(r5(t7));
                };
              }), t5.select("g.slicetext").attr("opacity", 0);
            }).remove() : t4.exit().remove();
          }, ft = function(t4) {
            var e4 = t4.transform;
            return t4.x0 !== t4.x1 && t4.y0 !== t4.y1 && u(y.type, e4, v), o.getTextTransform({ textX: e4.textX, textY: e4.textY, anchorX: e4.anchorX, anchorY: e4.anchorY, targetX: e4.targetX, targetY: e4.targetY, scale: e4.scale, rotate: e4.rotate });
          };
          A && (w2.each(function(t4) {
            B[h(t4)] = { x0: t4.x0, x1: t4.x1, y0: t4.y0, y1: t4.y1 }, t4.transform && (B[h(t4)].transform = { textX: t4.transform.textX, textY: t4.transform.textY, anchorX: t4.transform.anchorX, anchorY: t4.transform.anchorY, targetX: t4.transform.targetX, targetY: t4.transform.targetY, scale: t4.transform.scale, rotate: t4.transform.rotate });
          }), T.each(function(t4) {
            N[h(t4)] = { x0: t4.x0, x1: t4.x1, y0: t4.y0, y1: t4.y1 }, t4.transform && (N[h(t4)].transform = { textX: t4.transform.textX, textY: t4.transform.textY, anchorX: t4.transform.anchorX, anchorY: t4.transform.anchorY, targetX: t4.transform.targetX, targetY: t4.transform.targetY, scale: t4.transform.scale, rotate: t4.transform.rotate }), !F && a.isEntry(t4) && (F = t4);
          })), j = d2(t3, e3, b, T, { width: L, height: C, viewX: q2, viewY: G, pathSlice: function(t4) {
            var e4 = q2(t4.x0), r4 = q2(t4.x1), n3 = G(t4.y0), i2 = G(t4.y1), a2 = r4 - e4, o2 = i2 - n3;
            if (!a2 || !o2)
              return "";
            var s2 = y.marker.cornerradius || 0, l2 = Math.min(s2, a2 / 2, o2 / 2);
            l2 && t4.data && t4.data.data && t4.data.data.label && (rt && (l2 = Math.min(l2, tt.t)), nt && (l2 = Math.min(l2, tt.l)), it && (l2 = Math.min(l2, tt.r)), at && (l2 = Math.min(l2, tt.b)));
            var u2 = function(t5, e5) {
              return l2 ? "a" + J(l2, l2) + " 0 0 1 " + J(t5, e5) : "";
            };
            return "M" + J(e4, n3 + l2) + u2(l2, -l2) + "L" + J(r4 - l2, n3) + u2(l2, l2) + "L" + J(r4, i2 - l2) + u2(-l2, l2) + "L" + J(e4 + l2, i2) + u2(-l2, -l2) + "Z";
          }, toMoveInsideSlice: ot, prevEntry: F, makeUpdateSliceInterpolator: lt, makeUpdateTextInterpolator: ut, handleSlicesExit: ct, hasTransition: A, strTransform: ft }), y.pathbar.visible ? f2(t3, e3, b, w2, { barDifY: D, width: P, height: O, viewX: W, viewY: X, pathSlice: function(t4) {
            var e4 = W(Math.max(Math.min(t4.x0, t4.x0), 0)), r4 = W(Math.min(Math.max(t4.x1, t4.x1), P)), n3 = X(t4.y0), i2 = X(t4.y1), a2 = O / 2, o2 = {}, s2 = {};
            o2.x = e4, s2.x = r4, o2.y = s2.y = (n3 + i2) / 2;
            var l2 = { x: e4, y: n3 }, u2 = { x: r4, y: n3 }, c2 = { x: r4, y: i2 }, f3 = { x: e4, y: i2 };
            return ">" === Q ? (l2.x -= a2, u2.x -= a2, c2.x -= a2, f3.x -= a2) : "/" === Q ? (c2.x -= a2, f3.x -= a2, o2.x -= a2 / 2, s2.x -= a2 / 2) : "\\" === Q ? (l2.x -= a2, u2.x -= a2, o2.x -= a2 / 2, s2.x -= a2 / 2) : "<" === Q && (o2.x -= a2, s2.x -= a2), $(l2), $(f3), $(o2), $(u2), $(c2), $(s2), "M" + J(l2.x, l2.y) + "L" + J(u2.x, u2.y) + "L" + J(s2.x, s2.y) + "L" + J(c2.x, c2.y) + "L" + J(f3.x, f3.y) + "L" + J(o2.x, o2.y) + "Z";
          }, toMoveInsideSlice: ot, makeUpdateSliceInterpolator: lt, makeUpdateTextInterpolator: ut, handleSlicesExit: ct, hasTransition: A, strTransform: ft }) : w2.remove();
        };
      }, 96362: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(7901), a = r2(71828), o = r2(2791), s = r2(72597).resizeText;
        function l(t3, e3, r3, n3) {
          var s2, l2, u = (n3 || {}).hovered, c = e3.data.data, f2 = c.i, h = c.color, p2 = o.isHierarchyRoot(e3), d2 = 1;
          if (u)
            s2 = r3._hovered.marker.line.color, l2 = r3._hovered.marker.line.width;
          else if (p2 && h === r3.root.color)
            d2 = 100, s2 = "rgba(0,0,0,0)", l2 = 0;
          else if (s2 = a.castOption(r3, f2, "marker.line.color") || i.defaultLine, l2 = a.castOption(r3, f2, "marker.line.width") || 0, !r3._hasColorscale && !e3.onPathbar) {
            var v = r3.marker.depthfade;
            if (v) {
              var g2, y = i.combine(i.addOpacity(r3._backgroundColor, 0.75), h);
              if (true === v) {
                var m2 = o.getMaxDepth(r3);
                g2 = isFinite(m2) ? o.isLeaf(e3) ? 0 : r3._maxVisibleLayers - (e3.data.depth - r3._entryDepth) : e3.data.height + 1;
              } else
                g2 = e3.data.depth - r3._entryDepth, r3._atRootLevel || g2++;
              if (g2 > 0)
                for (var x = 0; x < g2; x++) {
                  var b = 0.5 * x / g2;
                  h = i.combine(i.addOpacity(y, b), h);
                }
            }
          }
          t3.style("stroke-width", l2).call(i.fill, h).call(i.stroke, s2).style("opacity", d2);
        }
        t2.exports = { style: function(t3) {
          var e3 = t3._fullLayout._treemaplayer.selectAll(".trace");
          s(t3, e3, "treemap"), e3.each(function(t4) {
            var e4 = n2.select(this), r3 = t4[0].trace;
            e4.style("opacity", r3.opacity), e4.selectAll("path.surface").each(function(t5) {
              n2.select(this).call(l, t5, r3, { hovered: false });
            });
          });
        }, styleOne: l };
      }, 68875: function(t2, e2, r2) {
        var n2 = r2(53522), i = r2(1426).extendFlat, a = r2(12663).axisHoverFormat;
        t2.exports = { y: n2.y, x: n2.x, x0: n2.x0, y0: n2.y0, xhoverformat: a("x"), yhoverformat: a("y"), name: i({}, n2.name, {}), orientation: i({}, n2.orientation, {}), bandwidth: { valType: "number", min: 0, editType: "calc" }, scalegroup: { valType: "string", dflt: "", editType: "calc" }, scalemode: { valType: "enumerated", values: ["width", "count"], dflt: "width", editType: "calc" }, spanmode: { valType: "enumerated", values: ["soft", "hard", "manual"], dflt: "soft", editType: "calc" }, span: { valType: "info_array", items: [{ valType: "any", editType: "calc" }, { valType: "any", editType: "calc" }], editType: "calc" }, line: { color: { valType: "color", editType: "style" }, width: { valType: "number", min: 0, dflt: 2, editType: "style" }, editType: "plot" }, fillcolor: n2.fillcolor, points: i({}, n2.boxpoints, {}), jitter: i({}, n2.jitter, {}), pointpos: i({}, n2.pointpos, {}), width: i({}, n2.width, {}), marker: n2.marker, text: n2.text, hovertext: n2.hovertext, hovertemplate: n2.hovertemplate, quartilemethod: n2.quartilemethod, box: { visible: { valType: "boolean", dflt: false, editType: "plot" }, width: { valType: "number", min: 0, max: 1, dflt: 0.25, editType: "plot" }, fillcolor: { valType: "color", editType: "style" }, line: { color: { valType: "color", editType: "style" }, width: { valType: "number", min: 0, editType: "style" }, editType: "style" }, editType: "plot" }, meanline: { visible: { valType: "boolean", dflt: false, editType: "plot" }, color: { valType: "color", editType: "style" }, width: { valType: "number", min: 0, editType: "style" }, editType: "plot" }, side: { valType: "enumerated", values: ["both", "positive", "negative"], dflt: "both", editType: "calc" }, offsetgroup: n2.offsetgroup, alignmentgroup: n2.alignmentgroup, selected: n2.selected, unselected: n2.unselected, hoveron: { valType: "flaglist", flags: ["violins", "points", "kde"], dflt: "violins+points+kde", extras: ["all"], editType: "style" } };
      }, 38603: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298), a = r2(48518), o = r2(60168), s = r2(50606).BADNUM;
        function l(t3, e3, r3) {
          var i2 = e3.max - e3.min;
          if (!i2)
            return t3.bandwidth ? t3.bandwidth : 0;
          if (t3.bandwidth)
            return Math.max(t3.bandwidth, i2 / 1e4);
          var a2 = r3.length, o2 = n2.stdev(r3, a2 - 1, e3.mean);
          return Math.max(function(t4, e4, r4) {
            return 1.059 * Math.min(e4, r4 / 1.349) * Math.pow(t4, -0.2);
          }(a2, o2, e3.q3 - e3.q1), i2 / 100);
        }
        function u(t3, e3, r3, n3) {
          var a2, o2 = t3.spanmode, l2 = t3.span || [], u2 = [e3.min, e3.max], c = [e3.min - 2 * n3, e3.max + 2 * n3];
          function f2(n4) {
            var i2 = l2[n4], a3 = "multicategory" === r3.type ? r3.r2c(i2) : r3.d2c(i2, 0, t3[e3.valLetter + "calendar"]);
            return a3 === s ? c[n4] : a3;
          }
          var h = { type: "linear", range: a2 = "soft" === o2 ? c : "hard" === o2 ? u2 : [f2(0), f2(1)] };
          return i.setConvert(h), h.cleanRange(), a2;
        }
        t2.exports = function(t3, e3) {
          var r3 = a(t3, e3);
          if (r3[0].t.empty)
            return r3;
          for (var s2 = t3._fullLayout, c = i.getFromId(t3, e3["h" === e3.orientation ? "xaxis" : "yaxis"]), f2 = 1 / 0, h = -1 / 0, p2 = 0, d2 = 0, v = 0; v < r3.length; v++) {
            var g2 = r3[v], y = g2.pts.map(o.extractVal), m2 = g2.bandwidth = l(e3, g2, y), x = g2.span = u(e3, g2, c, m2);
            if (g2.min === g2.max && 0 === m2)
              x = g2.span = [g2.min, g2.max], g2.density = [{ v: 1, t: x[0] }], g2.bandwidth = m2, p2 = Math.max(p2, 1);
            else {
              var b = x[1] - x[0], _ = Math.ceil(b / (m2 / 3)), w2 = b / _;
              if (!isFinite(w2) || !isFinite(_))
                return n2.error("Something went wrong with computing the violin span"), r3[0].t.empty = true, r3;
              var T = o.makeKDE(g2, e3, y);
              g2.density = new Array(_);
              for (var k = 0, A = x[0]; A < x[1] + w2 / 2; k++, A += w2) {
                var M = T(A);
                g2.density[k] = { v: M, t: A }, p2 = Math.max(p2, M);
              }
            }
            d2 = Math.max(d2, y.length), f2 = Math.min(f2, x[0]), h = Math.max(h, x[1]);
          }
          var S = i.findExtremes(c, [f2, h], { padded: true });
          if (e3._extremes[c._id] = S, e3.width)
            r3[0].t.maxKDE = p2;
          else {
            var E = s2._violinScaleGroupStats, L = e3.scalegroup, C = E[L];
            C ? (C.maxKDE = Math.max(C.maxKDE, p2), C.maxCount = Math.max(C.maxCount, d2)) : E[L] = { maxKDE: p2, maxCount: d2 };
          }
          return r3[0].t.labels.kde = n2._(t3, "kde:"), r3;
        };
      }, 86403: function(t2, e2, r2) {
        var n2 = r2(37188).setPositionOffset, i = ["v", "h"];
        t2.exports = function(t3, e3) {
          for (var r3 = t3.calcdata, a = e3.xaxis, o = e3.yaxis, s = 0; s < i.length; s++) {
            for (var l = i[s], u = "h" === l ? o : a, c = [], f2 = 0; f2 < r3.length; f2++) {
              var h = r3[f2], p2 = h[0].t, d2 = h[0].trace;
              true !== d2.visible || "violin" !== d2.type || p2.empty || d2.orientation !== l || d2.xaxis !== a._id || d2.yaxis !== o._id || c.push(f2);
            }
            n2("violin", t3, c, u);
          }
        };
      }, 15899: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(7901), a = r2(36411), o = r2(68875);
        t2.exports = function(t3, e3, r3, s) {
          function l(r4, i2) {
            return n2.coerce(t3, e3, o, r4, i2);
          }
          function u(r4, i2) {
            return n2.coerce2(t3, e3, o, r4, i2);
          }
          if (a.handleSampleDefaults(t3, e3, l, s), false !== e3.visible) {
            l("bandwidth"), l("side"), l("width") || (l("scalegroup", e3.name), l("scalemode"));
            var c, f2 = l("span");
            Array.isArray(f2) && (c = "manual"), l("spanmode", c);
            var h = l("line.color", (t3.marker || {}).color || r3), p2 = l("line.width"), d2 = l("fillcolor", i.addOpacity(e3.line.color, 0.5));
            a.handlePointsDefaults(t3, e3, l, { prefix: "" });
            var v = u("box.width"), g2 = u("box.fillcolor", d2), y = u("box.line.color", h), m2 = u("box.line.width", p2);
            l("box.visible", Boolean(v || g2 || y || m2)) || (e3.box = { visible: false });
            var x = u("meanline.color", h), b = u("meanline.width", p2);
            l("meanline.visible", Boolean(x || b)) || (e3.meanline = { visible: false }), l("quartilemethod");
          }
        };
      }, 60168: function(t2, e2, r2) {
        var n2 = r2(71828), i = function(t3) {
          return 1 / Math.sqrt(2 * Math.PI) * Math.exp(-0.5 * t3 * t3);
        };
        e2.makeKDE = function(t3, e3, r3) {
          var n3 = r3.length, a = i, o = t3.bandwidth, s = 1 / (n3 * o);
          return function(t4) {
            for (var e4 = 0, i2 = 0; i2 < n3; i2++)
              e4 += a((t4 - r3[i2]) / o);
            return s * e4;
          };
        }, e2.getPositionOnKdePath = function(t3, e3, r3) {
          var i2, a;
          "h" === e3.orientation ? (i2 = "y", a = "x") : (i2 = "x", a = "y");
          var o = n2.findPointOnPath(t3.path, r3, a, { pathLength: t3.pathLength }), s = t3.posCenterPx, l = o[i2];
          return [l, "both" === e3.side ? 2 * s - l : s];
        }, e2.getKdeValue = function(t3, r3, n3) {
          var i2 = t3.pts.map(e2.extractVal);
          return e2.makeKDE(t3, r3, i2)(n3) / t3.posDensityScale;
        }, e2.extractVal = function(t3) {
          return t3.v;
        };
      }, 57634: function(t2, e2, r2) {
        var n2 = r2(7901), i = r2(71828), a = r2(89298), o = r2(41868), s = r2(60168);
        t2.exports = function(t3, e3, r3, l, u) {
          u || (u = {});
          var c, f2, h = u.hoverLayer, p2 = t3.cd, d2 = p2[0].trace, v = d2.hoveron, g2 = -1 !== v.indexOf("violins"), y = -1 !== v.indexOf("kde"), m2 = [];
          if (g2 || y) {
            var x = o.hoverOnBoxes(t3, e3, r3, l);
            if (y && x.length > 0) {
              var b, _, w2, T, k, A = t3.xa, M = t3.ya;
              "h" === d2.orientation ? (k = e3, b = "y", w2 = M, _ = "x", T = A) : (k = r3, b = "x", w2 = A, _ = "y", T = M);
              var S = p2[t3.index];
              if (k >= S.span[0] && k <= S.span[1]) {
                var E = i.extendFlat({}, t3), L = T.c2p(k, true), C = s.getKdeValue(S, d2, k), P = s.getPositionOnKdePath(S, d2, L), O = w2._offset, I = w2._length;
                E[b + "0"] = P[0], E[b + "1"] = P[1], E[_ + "0"] = E[_ + "1"] = L, E[_ + "Label"] = _ + ": " + a.hoverLabelText(T, k, d2[_ + "hoverformat"]) + ", " + p2[0].t.labels.kde + " " + C.toFixed(3);
                for (var D = 0, z = 0; z < x.length; z++)
                  if ("med" === x[z].attr) {
                    D = z;
                    break;
                  }
                E.spikeDistance = x[D].spikeDistance;
                var R = b + "Spike";
                E[R] = x[D][R], x[D].spikeDistance = void 0, x[D][R] = void 0, E.hovertemplate = false, m2.push(E), (f2 = {})[b + "1"] = i.constrain(O + P[0], O, O + I), f2[b + "2"] = i.constrain(O + P[1], O, O + I), f2[_ + "1"] = f2[_ + "2"] = T._offset + L;
              }
            }
            g2 && (m2 = m2.concat(x));
          }
          -1 !== v.indexOf("points") && (c = o.hoverOnPoints(t3, e3, r3));
          var F = h.selectAll(".violinline-" + d2.uid).data(f2 ? [0] : []);
          return F.enter().append("line").classed("violinline-" + d2.uid, true).attr("stroke-width", 1.5), F.exit().remove(), F.attr(f2).call(n2.stroke, t3.color), "closest" === l ? c ? [c] : m2 : c ? (m2.push(c), m2) : m2;
        };
      }, 47462: function(t2, e2, r2) {
        t2.exports = { attributes: r2(68875), layoutAttributes: r2(9228), supplyDefaults: r2(15899), crossTraceDefaults: r2(36411).crossTraceDefaults, supplyLayoutDefaults: r2(33598), calc: r2(38603), crossTraceCalc: r2(86403), plot: r2(28443), style: r2(31847), styleOnSelect: r2(16296).styleOnSelect, hoverPoints: r2(57634), selectPoints: r2(24626), moduleType: "trace", name: "violin", basePlotModule: r2(93612), categories: ["cartesian", "svg", "symbols", "oriented", "box-violin", "showLegend", "violinLayout", "zoomScale"], meta: {} };
      }, 9228: function(t2, e2, r2) {
        var n2 = r2(40094), i = r2(71828).extendFlat;
        t2.exports = { violinmode: i({}, n2.boxmode, {}), violingap: i({}, n2.boxgap, {}), violingroupgap: i({}, n2.boxgroupgap, {}) };
      }, 33598: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(9228), a = r2(4199);
        t2.exports = function(t3, e3, r3) {
          a._supply(t3, e3, r3, function(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }, "violin");
        };
      }, 28443: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(91424), o = r2(86047), s = r2(34621), l = r2(60168);
        t2.exports = function(t3, e3, r3, u) {
          var c = t3._context.staticPlot, f2 = t3._fullLayout, h = e3.xaxis, p2 = e3.yaxis;
          function d2(t4, e4) {
            var r4 = s(t4, { xaxis: h, yaxis: p2, trace: e4, connectGaps: true, baseTolerance: 0.75, shape: "spline", simplify: true, linearized: true });
            return a.smoothopen(r4[0], 1);
          }
          i.makeTraceGroups(u, r3, "trace violins").each(function(t4) {
            var r4 = n2.select(this), a2 = t4[0], s2 = a2.t, u2 = a2.trace;
            if (true !== u2.visible || s2.empty)
              r4.remove();
            else {
              var v = s2.bPos, g2 = s2.bdPos, y = e3[s2.valLetter + "axis"], m2 = e3[s2.posLetter + "axis"], x = "both" === u2.side, b = x || "positive" === u2.side, _ = x || "negative" === u2.side, w2 = r4.selectAll("path.violin").data(i.identity);
              w2.enter().append("path").style("vector-effect", c ? "none" : "non-scaling-stroke").attr("class", "violin"), w2.exit().remove(), w2.each(function(t5) {
                var e4, r5, i2, a3, o2, l2, c2, h2, p3 = n2.select(this), w3 = t5.density, T2 = w3.length, k2 = m2.c2l(t5.pos + v, true), A2 = m2.l2p(k2);
                if (u2.width)
                  e4 = s2.maxKDE / g2;
                else {
                  var M2 = f2._violinScaleGroupStats[u2.scalegroup];
                  e4 = "count" === u2.scalemode ? M2.maxKDE / g2 * (M2.maxCount / t5.pts.length) : M2.maxKDE / g2;
                }
                if (b) {
                  for (c2 = new Array(T2), o2 = 0; o2 < T2; o2++)
                    (h2 = c2[o2] = {})[s2.posLetter] = k2 + w3[o2].v / e4, h2[s2.valLetter] = y.c2l(w3[o2].t, true);
                  r5 = d2(c2, u2);
                }
                if (_) {
                  for (c2 = new Array(T2), l2 = 0, o2 = T2 - 1; l2 < T2; l2++, o2--)
                    (h2 = c2[l2] = {})[s2.posLetter] = k2 - w3[o2].v / e4, h2[s2.valLetter] = y.c2l(w3[o2].t, true);
                  i2 = d2(c2, u2);
                }
                if (x)
                  a3 = r5 + "L" + i2.substr(1) + "Z";
                else {
                  var S2 = [A2, y.c2p(w3[0].t)], E2 = [A2, y.c2p(w3[T2 - 1].t)];
                  "h" === u2.orientation && (S2.reverse(), E2.reverse()), a3 = b ? "M" + S2 + "L" + r5.substr(1) + "L" + E2 : "M" + E2 + "L" + i2.substr(1) + "L" + S2;
                }
                p3.attr("d", a3), t5.posCenterPx = A2, t5.posDensityScale = e4 * g2, t5.path = p3.node(), t5.pathLength = t5.path.getTotalLength() / (x ? 2 : 1);
              });
              var T, k, A, M = u2.box, S = M.width, E = (M.line || {}).width;
              x ? (T = g2 * S, k = 0) : b ? (T = [0, g2 * S / 2], k = E * { x: 1, y: -1 }[s2.posLetter]) : (T = [g2 * S / 2, 0], k = E * { x: -1, y: 1 }[s2.posLetter]), o.plotBoxAndWhiskers(r4, { pos: m2, val: y }, u2, { bPos: v, bdPos: T, bPosPxOffset: k }), o.plotBoxMean(r4, { pos: m2, val: y }, u2, { bPos: v, bdPos: T, bPosPxOffset: k }), !u2.box.visible && u2.meanline.visible && (A = i.identity);
              var L = r4.selectAll("path.meanline").data(A || []);
              L.enter().append("path").attr("class", "meanline").style("fill", "none").style("vector-effect", c ? "none" : "non-scaling-stroke"), L.exit().remove(), L.each(function(t5) {
                var e4 = y.c2p(t5.mean, true), r5 = l.getPositionOnKdePath(t5, u2, e4);
                n2.select(this).attr("d", "h" === u2.orientation ? "M" + e4 + "," + r5[0] + "V" + r5[1] : "M" + r5[0] + "," + e4 + "H" + r5[1]);
              }), o.plotPoints(r4, { x: h, y: p2 }, u2, s2);
            }
          });
        };
      }, 31847: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(7901), a = r2(16296).stylePoints;
        t2.exports = function(t3) {
          var e3 = n2.select(t3).selectAll("g.trace.violins");
          e3.style("opacity", function(t4) {
            return t4[0].trace.opacity;
          }), e3.each(function(e4) {
            var r3 = e4[0].trace, o = n2.select(this), s = r3.box || {}, l = s.line || {}, u = r3.meanline || {}, c = u.width;
            o.selectAll("path.violin").style("stroke-width", r3.line.width + "px").call(i.stroke, r3.line.color).call(i.fill, r3.fillcolor), o.selectAll("path.box").style("stroke-width", l.width + "px").call(i.stroke, l.color).call(i.fill, s.fillcolor);
            var f2 = { "stroke-width": c + "px", "stroke-dasharray": 2 * c + "px," + c + "px" };
            o.selectAll("path.mean").style(f2).call(i.stroke, u.color), o.selectAll("path.meanline").style(f2).call(i.stroke, u.color), a(o, r3, t3);
          });
        };
      }, 16336: function(t2, e2, r2) {
        var n2 = r2(50693), i = r2(16249), a = r2(54532), o = r2(9012), s = r2(1426).extendFlat, l = r2(30962).overrideAll, u = t2.exports = l(s({ x: i.x, y: i.y, z: i.z, value: i.value, isomin: i.isomin, isomax: i.isomax, surface: i.surface, spaceframe: { show: { valType: "boolean", dflt: false }, fill: { valType: "number", min: 0, max: 1, dflt: 1 } }, slices: i.slices, caps: i.caps, text: i.text, hovertext: i.hovertext, xhoverformat: i.xhoverformat, yhoverformat: i.yhoverformat, zhoverformat: i.zhoverformat, valuehoverformat: i.valuehoverformat, hovertemplate: i.hovertemplate }, n2("", { colorAttr: "`value`", showScaleDflt: true, editTypeOverride: "calc" }), { colorbar: i.colorbar, opacity: i.opacity, opacityscale: a.opacityscale, lightposition: i.lightposition, lighting: i.lighting, flatshading: i.flatshading, contour: i.contour, hoverinfo: s({}, o.hoverinfo), showlegend: s({}, o.showlegend, { dflt: false }) }), "calc", "nested");
        u.x.editType = u.y.editType = u.z.editType = u.value.editType = "calc+clearAxisTypes", u.transforms = void 0;
      }, 64809: function(t2, e2, r2) {
        var n2 = r2(9330).gl_mesh3d, i = r2(81697).parseColorScale, a = r2(78614), o = r2(21081).extractOpts, s = r2(90060), l = r2(22674).findNearestOnAxis, u = r2(22674).generateIsoMeshes;
        function c(t3, e3, r3) {
          this.scene = t3, this.uid = r3, this.mesh = e3, this.name = "", this.data = null, this.showContour = false;
        }
        var f2 = c.prototype;
        f2.handlePick = function(t3) {
          if (t3.object === this.mesh) {
            var e3 = t3.data.index, r3 = this.data._meshX[e3], n3 = this.data._meshY[e3], i2 = this.data._meshZ[e3], a2 = this.data._Ys.length, o2 = this.data._Zs.length, s2 = l(r3, this.data._Xs).id, u2 = l(n3, this.data._Ys).id, c2 = l(i2, this.data._Zs).id, f3 = t3.index = c2 + o2 * u2 + o2 * a2 * s2;
            t3.traceCoordinate = [this.data._meshX[f3], this.data._meshY[f3], this.data._meshZ[f3], this.data._value[f3]];
            var h = this.data.hovertext || this.data.text;
            return Array.isArray(h) && void 0 !== h[f3] ? t3.textLabel = h[f3] : h && (t3.textLabel = h), true;
          }
        }, f2.update = function(t3) {
          var e3 = this.scene, r3 = e3.fullSceneLayout;
          function n3(t4, e4, r4, n4) {
            return e4.map(function(e5) {
              return t4.d2l(e5, 0, n4) * r4;
            });
          }
          this.data = u(t3);
          var l2 = { positions: s(n3(r3.xaxis, t3._meshX, e3.dataScale[0], t3.xcalendar), n3(r3.yaxis, t3._meshY, e3.dataScale[1], t3.ycalendar), n3(r3.zaxis, t3._meshZ, e3.dataScale[2], t3.zcalendar)), cells: s(t3._meshI, t3._meshJ, t3._meshK), lightPosition: [t3.lightposition.x, t3.lightposition.y, t3.lightposition.z], ambient: t3.lighting.ambient, diffuse: t3.lighting.diffuse, specular: t3.lighting.specular, roughness: t3.lighting.roughness, fresnel: t3.lighting.fresnel, vertexNormalsEpsilon: t3.lighting.vertexnormalsepsilon, faceNormalsEpsilon: t3.lighting.facenormalsepsilon, opacity: t3.opacity, opacityscale: t3.opacityscale, contourEnable: t3.contour.show, contourColor: a(t3.contour.color).slice(0, 3), contourWidth: t3.contour.width, useFacetNormals: t3.flatshading }, c2 = o(t3);
          l2.vertexIntensity = t3._meshIntensity, l2.vertexIntensityBounds = [c2.min, c2.max], l2.colormap = i(t3), this.mesh.update(l2);
        }, f2.dispose = function() {
          this.scene.glplot.remove(this.mesh), this.mesh.dispose();
        }, t2.exports = function(t3, e3) {
          var r3 = t3.glplot.gl, i2 = n2({ gl: r3 }), a2 = new c(t3, i2, e3.uid);
          return i2._trace = a2, a2.update(e3), t3.glplot.add(i2), a2;
        };
      }, 47651: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(16336), a = r2(82738).supplyIsoDefaults, o = r2(91831).opacityscaleDefaults;
        t2.exports = function(t3, e3, r3, s) {
          function l(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          a(t3, e3, r3, s, l), o(t3, e3, s, l);
        };
      }, 17659: function(t2, e2, r2) {
        t2.exports = { attributes: r2(16336), supplyDefaults: r2(47651), calc: r2(56959), colorbar: { min: "cmin", max: "cmax" }, plot: r2(64809), moduleType: "trace", name: "volume", basePlotModule: r2(58547), categories: ["gl3d", "showLegend"], meta: {} };
      }, 43037: function(t2, e2, r2) {
        var n2 = r2(1486), i = r2(82196).line, a = r2(9012), o = r2(12663).axisHoverFormat, s = r2(5386).f, l = r2(5386).s, u = r2(48334), c = r2(1426).extendFlat, f2 = r2(7901);
        function h(t3) {
          return { marker: { color: c({}, n2.marker.color, { arrayOk: false, editType: "style" }), line: { color: c({}, n2.marker.line.color, { arrayOk: false, editType: "style" }), width: c({}, n2.marker.line.width, { arrayOk: false, editType: "style" }), editType: "style" }, editType: "style" }, editType: "style" };
        }
        t2.exports = { measure: { valType: "data_array", dflt: [], editType: "calc" }, base: { valType: "number", dflt: null, arrayOk: false, editType: "calc" }, x: n2.x, x0: n2.x0, dx: n2.dx, y: n2.y, y0: n2.y0, dy: n2.dy, xperiod: n2.xperiod, yperiod: n2.yperiod, xperiod0: n2.xperiod0, yperiod0: n2.yperiod0, xperiodalignment: n2.xperiodalignment, yperiodalignment: n2.yperiodalignment, xhoverformat: o("x"), yhoverformat: o("y"), hovertext: n2.hovertext, hovertemplate: s({}, { keys: u.eventDataKeys }), hoverinfo: c({}, a.hoverinfo, { flags: ["name", "x", "y", "text", "initial", "delta", "final"] }), textinfo: { valType: "flaglist", flags: ["label", "text", "initial", "delta", "final"], extras: ["none"], editType: "plot", arrayOk: false }, texttemplate: l({ editType: "plot" }, { keys: u.eventDataKeys.concat(["label"]) }), text: n2.text, textposition: n2.textposition, insidetextanchor: n2.insidetextanchor, textangle: n2.textangle, textfont: n2.textfont, insidetextfont: n2.insidetextfont, outsidetextfont: n2.outsidetextfont, constraintext: n2.constraintext, cliponaxis: n2.cliponaxis, orientation: n2.orientation, offset: n2.offset, width: n2.width, increasing: h(), decreasing: h(), totals: h(), connector: { line: { color: c({}, i.color, { dflt: f2.defaultLine }), width: c({}, i.width, { editType: "plot" }), dash: i.dash, editType: "plot" }, mode: { valType: "enumerated", values: ["spanning", "between"], dflt: "between", editType: "plot" }, visible: { valType: "boolean", dflt: true, editType: "plot" }, editType: "plot" }, offsetgroup: n2.offsetgroup, alignmentgroup: n2.alignmentgroup };
      }, 52752: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(42973), a = r2(71828).mergeArray, o = r2(66279), s = r2(50606).BADNUM;
        function l(t3) {
          return "a" === t3 || "absolute" === t3;
        }
        function u(t3) {
          return "t" === t3 || "total" === t3;
        }
        t2.exports = function(t3, e3) {
          var r3, c, f2, h, p2, d2, v = n2.getFromId(t3, e3.xaxis || "x"), g2 = n2.getFromId(t3, e3.yaxis || "y");
          "h" === e3.orientation ? (r3 = v.makeCalcdata(e3, "x"), f2 = g2.makeCalcdata(e3, "y"), h = i(e3, g2, "y", f2), p2 = !!e3.yperiodalignment, d2 = "y") : (r3 = g2.makeCalcdata(e3, "y"), f2 = v.makeCalcdata(e3, "x"), h = i(e3, v, "x", f2), p2 = !!e3.xperiodalignment, d2 = "x"), c = h.vals;
          for (var y, m2 = Math.min(c.length, r3.length), x = new Array(m2), b = 0, _ = false, w2 = 0; w2 < m2; w2++) {
            var T = r3[w2] || 0, k = false;
            (r3[w2] !== s || u(e3.measure[w2]) || l(e3.measure[w2])) && w2 + 1 < m2 && (r3[w2 + 1] !== s || u(e3.measure[w2 + 1]) || l(e3.measure[w2 + 1])) && (k = true);
            var A = x[w2] = { i: w2, p: c[w2], s: T, rawS: T, cNext: k };
            l(e3.measure[w2]) ? (b = A.s, A.isSum = true, A.dir = "totals", A.s = b) : u(e3.measure[w2]) ? (A.isSum = true, A.dir = "totals", A.s = b) : (A.isSum = false, A.dir = A.rawS < 0 ? "decreasing" : "increasing", y = A.s, A.s = b + y, b += y), "totals" === A.dir && (_ = true), p2 && (x[w2].orig_p = f2[w2], x[w2][d2 + "End"] = h.ends[w2], x[w2][d2 + "Start"] = h.starts[w2]), e3.ids && (A.id = String(e3.ids[w2])), A.v = (e3.base || 0) + b;
          }
          return x.length && (x[0].hasTotals = _), a(e3.text, x, "tx"), a(e3.hovertext, x, "htx"), o(x, e3), x;
        };
      }, 48334: function(t2) {
        t2.exports = { eventDataKeys: ["initial", "delta", "final"] };
      }, 70766: function(t2, e2, r2) {
        var n2 = r2(11661).setGroupPositions;
        t2.exports = function(t3, e3) {
          var r3, i, a = t3._fullLayout, o = t3._fullData, s = t3.calcdata, l = e3.xaxis, u = e3.yaxis, c = [], f2 = [], h = [];
          for (i = 0; i < o.length; i++) {
            var p2 = o[i];
            true === p2.visible && p2.xaxis === l._id && p2.yaxis === u._id && "waterfall" === p2.type && (r3 = s[i], "h" === p2.orientation ? h.push(r3) : f2.push(r3), c.push(r3));
          }
          var d2 = { mode: a.waterfallmode, norm: a.waterfallnorm, gap: a.waterfallgap, groupgap: a.waterfallgroupgap };
          for (n2(t3, l, u, f2, d2), n2(t3, u, l, h, d2), i = 0; i < c.length; i++) {
            r3 = c[i];
            for (var v = 0; v < r3.length; v++) {
              var g2 = r3[v];
              false === g2.isSum && (g2.s0 += 0 === v ? 0 : r3[v - 1].s), v + 1 < r3.length && (r3[v].nextP0 = r3[v + 1].p0, r3[v].nextS0 = r3[v + 1].s0);
            }
          }
        };
      }, 83266: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(26125), a = r2(90769).handleText, o = r2(67513), s = r2(73927), l = r2(43037), u = r2(7901), c = r2(22372), f2 = c.INCREASING.COLOR, h = c.DECREASING.COLOR;
        function p2(t3, e3, r3) {
          t3(e3 + ".marker.color", r3), t3(e3 + ".marker.line.color", u.defaultLine), t3(e3 + ".marker.line.width");
        }
        t2.exports = { supplyDefaults: function(t3, e3, r3, i2) {
          function u2(r4, i3) {
            return n2.coerce(t3, e3, l, r4, i3);
          }
          if (o(t3, e3, i2, u2)) {
            s(t3, e3, i2, u2), u2("xhoverformat"), u2("yhoverformat"), u2("measure"), u2("orientation", e3.x && !e3.y ? "h" : "v"), u2("base"), u2("offset"), u2("width"), u2("text"), u2("hovertext"), u2("hovertemplate");
            var c2 = u2("textposition");
            a(t3, e3, i2, u2, c2, { moduleHasSelected: false, moduleHasUnselected: false, moduleHasConstrain: true, moduleHasCliponaxis: true, moduleHasTextangle: true, moduleHasInsideanchor: true }), "none" !== e3.textposition && (u2("texttemplate"), e3.texttemplate || u2("textinfo")), p2(u2, "increasing", f2), p2(u2, "decreasing", h), p2(u2, "totals", "#4499FF"), u2("connector.visible") && (u2("connector.mode"), u2("connector.line.width") && (u2("connector.line.color"), u2("connector.line.dash")));
          } else
            e3.visible = false;
        }, crossTraceDefaults: function(t3, e3) {
          var r3, a2;
          function o2(t4) {
            return n2.coerce(a2._input, a2, l, t4);
          }
          if ("group" === e3.waterfallmode)
            for (var s2 = 0; s2 < t3.length; s2++)
              r3 = (a2 = t3[s2])._input, i(r3, a2, e3, o2);
        } };
      }, 58593: function(t2) {
        t2.exports = function(t3, e2) {
          return t3.x = "xVal" in e2 ? e2.xVal : e2.x, t3.y = "yVal" in e2 ? e2.yVal : e2.y, "initial" in e2 && (t3.initial = e2.initial), "delta" in e2 && (t3.delta = e2.delta), "final" in e2 && (t3.final = e2.final), e2.xa && (t3.xaxis = e2.xa), e2.ya && (t3.yaxis = e2.ya), t3;
        };
      }, 61326: function(t2, e2, r2) {
        var n2 = r2(89298).hoverLabelText, i = r2(7901).opacity, a = r2(95423).hoverOnBars, o = r2(22372), s = o.INCREASING.SYMBOL, l = o.DECREASING.SYMBOL;
        t2.exports = function(t3, e3, r3, o2, u) {
          var c = a(t3, e3, r3, o2, u);
          if (c) {
            var f2 = c.cd, h = f2[0].trace, p2 = "h" === h.orientation, d2 = p2 ? "x" : "y", v = p2 ? t3.xa : t3.ya, g2 = f2[c.index], y = g2.isSum ? g2.b + g2.s : g2.rawS;
            if (!g2.isSum) {
              c.initial = g2.b + g2.s - y, c.delta = y, c.final = c.initial + c.delta;
              var m2 = k(Math.abs(c.delta));
              c.deltaLabel = y < 0 ? "(" + m2 + ")" : m2, c.finalLabel = k(c.final), c.initialLabel = k(c.initial);
            }
            var x = g2.hi || h.hoverinfo, b = [];
            if (x && "none" !== x && "skip" !== x) {
              var _ = "all" === x, w2 = x.split("+"), T = function(t4) {
                return _ || -1 !== w2.indexOf(t4);
              };
              g2.isSum || (!T("final") || T(p2 ? "x" : "y") || b.push(c.finalLabel), T("delta") && (y < 0 ? b.push(c.deltaLabel + " " + l) : b.push(c.deltaLabel + " " + s)), T("initial") && b.push("Initial: " + c.initialLabel));
            }
            return b.length && (c.extraText = b.join("<br>")), c.color = function(t4, e4) {
              var r4 = t4[e4.dir].marker, n3 = r4.color, a2 = r4.line.color, o3 = r4.line.width;
              return i(n3) ? n3 : i(a2) && o3 ? a2 : void 0;
            }(h, g2), [c];
          }
          function k(t4) {
            return n2(v, t4, h[d2 + "hoverformat"]);
          }
        };
      }, 19990: function(t2, e2, r2) {
        t2.exports = { attributes: r2(43037), layoutAttributes: r2(13494), supplyDefaults: r2(83266).supplyDefaults, crossTraceDefaults: r2(83266).crossTraceDefaults, supplyLayoutDefaults: r2(5176), calc: r2(52752), crossTraceCalc: r2(70766), plot: r2(30436), style: r2(55750).style, hoverPoints: r2(61326), eventData: r2(58593), selectPoints: r2(81974), moduleType: "trace", name: "waterfall", basePlotModule: r2(93612), categories: ["bar-like", "cartesian", "svg", "oriented", "showLegend", "zoomScale"], meta: {} };
      }, 13494: function(t2) {
        t2.exports = { waterfallmode: { valType: "enumerated", values: ["group", "overlay"], dflt: "group", editType: "calc" }, waterfallgap: { valType: "number", min: 0, max: 1, editType: "calc" }, waterfallgroupgap: { valType: "number", min: 0, max: 1, dflt: 0, editType: "calc" } };
      }, 5176: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(13494);
        t2.exports = function(t3, e3, r3) {
          var a = false;
          function o(r4, a2) {
            return n2.coerce(t3, e3, i, r4, a2);
          }
          for (var s = 0; s < r3.length; s++) {
            var l = r3[s];
            if (l.visible && "waterfall" === l.type) {
              a = true;
              break;
            }
          }
          a && (o("waterfallmode"), o("waterfallgap", 0.2), o("waterfallgroupgap"));
        };
      }, 30436: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(71828), a = r2(91424), o = r2(50606).BADNUM, s = r2(17295), l = r2(72597).clearMinTextSize;
        t2.exports = function(t3, e3, r3, u) {
          var c = t3._fullLayout;
          l("waterfall", c), s.plot(t3, e3, r3, u, { mode: c.waterfallmode, norm: c.waterfallmode, gap: c.waterfallgap, groupgap: c.waterfallgroupgap }), function(t4, e4, r4, s2) {
            var l2 = e4.xaxis, u2 = e4.yaxis;
            i.makeTraceGroups(s2, r4, "trace bars").each(function(r5) {
              var s3 = n2.select(this), c2 = r5[0].trace, f2 = i.ensureSingle(s3, "g", "lines");
              if (c2.connector && c2.connector.visible) {
                var h = "h" === c2.orientation, p2 = c2.connector.mode, d2 = f2.selectAll("g.line").data(i.identity);
                d2.enter().append("g").classed("line", true), d2.exit().remove();
                var v = d2.size();
                d2.each(function(r6, s4) {
                  if (s4 === v - 1 || r6.cNext) {
                    var c3 = function(t5, e5, r7, n3) {
                      var i2 = [], a2 = [], o2 = n3 ? e5 : r7, s5 = n3 ? r7 : e5;
                      return i2[0] = o2.c2p(t5.s0, true), a2[0] = s5.c2p(t5.p0, true), i2[1] = o2.c2p(t5.s1, true), a2[1] = s5.c2p(t5.p1, true), i2[2] = o2.c2p(t5.nextS0, true), a2[2] = s5.c2p(t5.nextP0, true), n3 ? [i2, a2] : [a2, i2];
                    }(r6, l2, u2, h), f3 = c3[0], d3 = c3[1], g2 = "";
                    f3[0] !== o && d3[0] !== o && f3[1] !== o && d3[1] !== o && ("spanning" === p2 && !r6.isSum && s4 > 0 && (g2 += h ? "M" + f3[0] + "," + d3[1] + "V" + d3[0] : "M" + f3[1] + "," + d3[0] + "H" + f3[0]), "between" !== p2 && (r6.isSum || s4 < v - 1) && (g2 += h ? "M" + f3[1] + "," + d3[0] + "V" + d3[1] : "M" + f3[0] + "," + d3[1] + "H" + f3[1]), f3[2] !== o && d3[2] !== o && (g2 += h ? "M" + f3[1] + "," + d3[1] + "V" + d3[2] : "M" + f3[1] + "," + d3[1] + "H" + f3[2])), "" === g2 && (g2 = "M0,0Z"), i.ensureSingle(n2.select(this), "path").attr("d", g2).call(a.setClipUrl, e4.layerClipId, t4);
                  }
                });
              } else
                f2.remove();
            });
          }(t3, e3, r3, u);
        };
      }, 55750: function(t2, e2, r2) {
        var n2 = r2(39898), i = r2(91424), a = r2(7901), o = r2(37822).DESELECTDIM, s = r2(16688), l = r2(72597).resizeText, u = s.styleTextPoints;
        t2.exports = { style: function(t3, e3, r3) {
          var s2 = r3 || n2.select(t3).selectAll("g.waterfalllayer").selectAll("g.trace");
          l(t3, s2, "waterfall"), s2.style("opacity", function(t4) {
            return t4[0].trace.opacity;
          }), s2.each(function(e4) {
            var r4 = n2.select(this), s3 = e4[0].trace;
            r4.selectAll(".point > path").each(function(t4) {
              if (!t4.isBlank) {
                var e5 = s3[t4.dir].marker;
                n2.select(this).call(a.fill, e5.color).call(a.stroke, e5.line.color).call(i.dashLine, e5.line.dash, e5.line.width).style("opacity", s3.selectedpoints && !t4.selected ? o : 1);
              }
            }), u(r4, s3, t3), r4.selectAll(".lines").each(function() {
              var t4 = s3.connector.line;
              i.lineGroupStyle(n2.select(this).selectAll("path"), t4.width, t4.color, t4.dash);
            });
          });
        } };
      }, 82887: function(t2, e2, r2) {
        var n2 = r2(89298), i = r2(71828), a = r2(86281), o = r2(79344).p, s = r2(50606).BADNUM;
        e2.moduleType = "transform", e2.name = "aggregate";
        var l = e2.attributes = { enabled: { valType: "boolean", dflt: true, editType: "calc" }, groups: { valType: "string", strict: true, noBlank: true, arrayOk: true, dflt: "x", editType: "calc" }, aggregations: { _isLinkedToArray: "aggregation", target: { valType: "string", editType: "calc" }, func: { valType: "enumerated", values: ["count", "sum", "avg", "median", "mode", "rms", "stddev", "min", "max", "first", "last", "change", "range"], dflt: "first", editType: "calc" }, funcmode: { valType: "enumerated", values: ["sample", "population"], dflt: "sample", editType: "calc" }, enabled: { valType: "boolean", dflt: true, editType: "calc" }, editType: "calc" }, editType: "calc" }, u = l.aggregations;
        function c(t3, e3, r3, a2) {
          if (a2.enabled) {
            for (var o2 = a2.target, l2 = i.nestedProperty(e3, o2), u2 = l2.get(), c2 = function(t4, e4) {
              var r4 = t4.func, n3 = e4.d2c, a3 = e4.c2d;
              switch (r4) {
                case "count":
                  return f2;
                case "first":
                  return h;
                case "last":
                  return p2;
                case "sum":
                  return function(t5, e5) {
                    for (var r5 = 0, i2 = 0; i2 < e5.length; i2++) {
                      var o3 = n3(t5[e5[i2]]);
                      o3 !== s && (r5 += o3);
                    }
                    return a3(r5);
                  };
                case "avg":
                  return function(t5, e5) {
                    for (var r5 = 0, i2 = 0, o3 = 0; o3 < e5.length; o3++) {
                      var l3 = n3(t5[e5[o3]]);
                      l3 !== s && (r5 += l3, i2++);
                    }
                    return i2 ? a3(r5 / i2) : s;
                  };
                case "min":
                  return function(t5, e5) {
                    for (var r5 = 1 / 0, i2 = 0; i2 < e5.length; i2++) {
                      var o3 = n3(t5[e5[i2]]);
                      o3 !== s && (r5 = Math.min(r5, o3));
                    }
                    return r5 === 1 / 0 ? s : a3(r5);
                  };
                case "max":
                  return function(t5, e5) {
                    for (var r5 = -1 / 0, i2 = 0; i2 < e5.length; i2++) {
                      var o3 = n3(t5[e5[i2]]);
                      o3 !== s && (r5 = Math.max(r5, o3));
                    }
                    return r5 === -1 / 0 ? s : a3(r5);
                  };
                case "range":
                  return function(t5, e5) {
                    for (var r5 = 1 / 0, i2 = -1 / 0, o3 = 0; o3 < e5.length; o3++) {
                      var l3 = n3(t5[e5[o3]]);
                      l3 !== s && (r5 = Math.min(r5, l3), i2 = Math.max(i2, l3));
                    }
                    return i2 === -1 / 0 || r5 === 1 / 0 ? s : a3(i2 - r5);
                  };
                case "change":
                  return function(t5, e5) {
                    var r5 = n3(t5[e5[0]]), i2 = n3(t5[e5[e5.length - 1]]);
                    return r5 === s || i2 === s ? s : a3(i2 - r5);
                  };
                case "median":
                  return function(t5, e5) {
                    for (var r5 = [], o3 = 0; o3 < e5.length; o3++) {
                      var l3 = n3(t5[e5[o3]]);
                      l3 !== s && r5.push(l3);
                    }
                    if (!r5.length)
                      return s;
                    r5.sort(i.sorterAsc);
                    var u3 = (r5.length - 1) / 2;
                    return a3((r5[Math.floor(u3)] + r5[Math.ceil(u3)]) / 2);
                  };
                case "mode":
                  return function(t5, e5) {
                    for (var r5 = {}, i2 = 0, o3 = s, l3 = 0; l3 < e5.length; l3++) {
                      var u3 = n3(t5[e5[l3]]);
                      if (u3 !== s) {
                        var c3 = r5[u3] = (r5[u3] || 0) + 1;
                        c3 > i2 && (i2 = c3, o3 = u3);
                      }
                    }
                    return i2 ? a3(o3) : s;
                  };
                case "rms":
                  return function(t5, e5) {
                    for (var r5 = 0, i2 = 0, o3 = 0; o3 < e5.length; o3++) {
                      var l3 = n3(t5[e5[o3]]);
                      l3 !== s && (r5 += l3 * l3, i2++);
                    }
                    return i2 ? a3(Math.sqrt(r5 / i2)) : s;
                  };
                case "stddev":
                  return function(e5, r5) {
                    var i2, a4 = 0, o3 = 0, l3 = 1, u3 = s;
                    for (i2 = 0; i2 < r5.length && u3 === s; i2++)
                      u3 = n3(e5[r5[i2]]);
                    if (u3 === s)
                      return s;
                    for (; i2 < r5.length; i2++) {
                      var c3 = n3(e5[r5[i2]]);
                      if (c3 !== s) {
                        var f3 = c3 - u3;
                        a4 += f3, o3 += f3 * f3, l3++;
                      }
                    }
                    var h2 = "sample" === t4.funcmode ? l3 - 1 : l3;
                    return h2 ? Math.sqrt((o3 - a4 * a4 / l3) / h2) : 0;
                  };
              }
            }(a2, n2.getDataConversions(t3, e3, o2, u2)), d2 = new Array(r3.length), v = 0; v < r3.length; v++)
              d2[v] = c2(u2, r3[v]);
            l2.set(d2), "count" === a2.func && i.pushUnique(e3._arrayAttrs, o2);
          }
        }
        function f2(t3, e3) {
          return e3.length;
        }
        function h(t3, e3) {
          return t3[e3[0]];
        }
        function p2(t3, e3) {
          return t3[e3[e3.length - 1]];
        }
        e2.supplyDefaults = function(t3, e3) {
          var r3, n3 = {};
          function o2(e4, r4) {
            return i.coerce(t3, n3, l, e4, r4);
          }
          if (!o2("enabled"))
            return n3;
          var s2 = a.findArrayAttributes(e3), c2 = {};
          for (r3 = 0; r3 < s2.length; r3++)
            c2[s2[r3]] = 1;
          var f3 = o2("groups");
          if (!Array.isArray(f3)) {
            if (!c2[f3])
              return n3.enabled = false, n3;
            c2[f3] = 0;
          }
          var h2, p3 = t3.aggregations || [], d2 = n3.aggregations = new Array(p3.length);
          function v(t4, e4) {
            return i.coerce(p3[r3], h2, u, t4, e4);
          }
          for (r3 = 0; r3 < p3.length; r3++) {
            h2 = { _index: r3 };
            var g2 = v("target"), y = v("func");
            v("enabled") && g2 && (c2[g2] || "count" === y && void 0 === c2[g2]) ? ("stddev" === y && v("funcmode"), c2[g2] = 0, d2[r3] = h2) : d2[r3] = { enabled: false, _index: r3 };
          }
          for (r3 = 0; r3 < s2.length; r3++)
            c2[s2[r3]] && d2.push({ target: s2[r3], func: u.func.dflt, enabled: true, _index: -1 });
          return n3;
        }, e2.calcTransform = function(t3, e3, r3) {
          if (r3.enabled) {
            var n3 = r3.groups, a2 = i.getTargetArray(e3, { target: n3 });
            if (a2) {
              var s2, l2, u2, f3, h2 = {}, p3 = {}, d2 = [], v = o(e3.transforms, r3), g2 = a2.length;
              for (e3._length && (g2 = Math.min(g2, e3._length)), s2 = 0; s2 < g2; s2++)
                void 0 === (u2 = h2[l2 = a2[s2]]) ? (h2[l2] = d2.length, f3 = [s2], d2.push(f3), p3[h2[l2]] = v(s2)) : (d2[u2].push(s2), p3[h2[l2]] = (p3[h2[l2]] || []).concat(v(s2)));
              r3._indexToPoints = p3;
              var y = r3.aggregations;
              for (s2 = 0; s2 < y.length; s2++)
                c(t3, e3, d2, y[s2]);
              "string" == typeof n3 && c(t3, e3, d2, { target: n3, func: "first", enabled: true }), e3._length = d2.length;
            }
          }
        };
      }, 14382: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(73972), a = r2(89298), o = r2(79344).p, s = r2(74808), l = s.COMPARISON_OPS, u = s.INTERVAL_OPS, c = s.SET_OPS;
        e2.moduleType = "transform", e2.name = "filter", e2.attributes = { enabled: { valType: "boolean", dflt: true, editType: "calc" }, target: { valType: "string", strict: true, noBlank: true, arrayOk: true, dflt: "x", editType: "calc" }, operation: { valType: "enumerated", values: [].concat(l).concat(u).concat(c), dflt: "=", editType: "calc" }, value: { valType: "any", dflt: 0, editType: "calc" }, preservegaps: { valType: "boolean", dflt: false, editType: "calc" }, editType: "calc" }, e2.supplyDefaults = function(t3) {
          var r3 = {};
          function a2(i2, a3) {
            return n2.coerce(t3, r3, e2.attributes, i2, a3);
          }
          if (a2("enabled")) {
            var o2 = a2("target");
            if (n2.isArrayOrTypedArray(o2) && 0 === o2.length)
              return r3.enabled = false, r3;
            a2("preservegaps"), a2("operation"), a2("value");
            var s2 = i.getComponentMethod("calendars", "handleDefaults");
            s2(t3, r3, "valuecalendar", null), s2(t3, r3, "targetcalendar", null);
          }
          return r3;
        }, e2.calcTransform = function(t3, e3, r3) {
          if (r3.enabled) {
            var i2 = n2.getTargetArray(e3, r3);
            if (i2) {
              var s2 = r3.target, f2 = i2.length;
              e3._length && (f2 = Math.min(f2, e3._length));
              var h = r3.targetcalendar, p2 = e3._arrayAttrs, d2 = r3.preservegaps;
              if ("string" == typeof s2) {
                var v = n2.nestedProperty(e3, s2 + "calendar").get();
                v && (h = v);
              }
              var g2, y, m2 = function(t4, e4, r4) {
                var n3 = t4.operation, i3 = t4.value, a2 = Array.isArray(i3);
                function o2(t5) {
                  return -1 !== t5.indexOf(n3);
                }
                var s3, f3 = function(r5) {
                  return e4(r5, 0, t4.valuecalendar);
                }, h2 = function(t5) {
                  return e4(t5, 0, r4);
                };
                switch (o2(l) ? s3 = f3(a2 ? i3[0] : i3) : o2(u) ? s3 = a2 ? [f3(i3[0]), f3(i3[1])] : [f3(i3), f3(i3)] : o2(c) && (s3 = a2 ? i3.map(f3) : [f3(i3)]), n3) {
                  case "=":
                    return function(t5) {
                      return h2(t5) === s3;
                    };
                  case "!=":
                    return function(t5) {
                      return h2(t5) !== s3;
                    };
                  case "<":
                    return function(t5) {
                      return h2(t5) < s3;
                    };
                  case "<=":
                    return function(t5) {
                      return h2(t5) <= s3;
                    };
                  case ">":
                    return function(t5) {
                      return h2(t5) > s3;
                    };
                  case ">=":
                    return function(t5) {
                      return h2(t5) >= s3;
                    };
                  case "[]":
                    return function(t5) {
                      var e5 = h2(t5);
                      return e5 >= s3[0] && e5 <= s3[1];
                    };
                  case "()":
                    return function(t5) {
                      var e5 = h2(t5);
                      return e5 > s3[0] && e5 < s3[1];
                    };
                  case "[)":
                    return function(t5) {
                      var e5 = h2(t5);
                      return e5 >= s3[0] && e5 < s3[1];
                    };
                  case "(]":
                    return function(t5) {
                      var e5 = h2(t5);
                      return e5 > s3[0] && e5 <= s3[1];
                    };
                  case "][":
                    return function(t5) {
                      var e5 = h2(t5);
                      return e5 <= s3[0] || e5 >= s3[1];
                    };
                  case ")(":
                    return function(t5) {
                      var e5 = h2(t5);
                      return e5 < s3[0] || e5 > s3[1];
                    };
                  case "](":
                    return function(t5) {
                      var e5 = h2(t5);
                      return e5 <= s3[0] || e5 > s3[1];
                    };
                  case ")[":
                    return function(t5) {
                      var e5 = h2(t5);
                      return e5 < s3[0] || e5 >= s3[1];
                    };
                  case "{}":
                    return function(t5) {
                      return -1 !== s3.indexOf(h2(t5));
                    };
                  case "}{":
                    return function(t5) {
                      return -1 === s3.indexOf(h2(t5));
                    };
                }
              }(r3, a.getDataToCoordFunc(t3, e3, s2, i2), h), x = {}, b = {}, _ = 0;
              d2 ? (g2 = function(t4) {
                x[t4.astr] = n2.extendDeep([], t4.get()), t4.set(new Array(f2));
              }, y = function(t4, e4) {
                var r4 = x[t4.astr][e4];
                t4.get()[e4] = r4;
              }) : (g2 = function(t4) {
                x[t4.astr] = n2.extendDeep([], t4.get()), t4.set([]);
              }, y = function(t4, e4) {
                var r4 = x[t4.astr][e4];
                t4.get().push(r4);
              }), k(g2);
              for (var w2 = o(e3.transforms, r3), T = 0; T < f2; T++)
                m2(i2[T]) ? (k(y, T), b[_++] = w2(T)) : d2 && _++;
              r3._indexToPoints = b, e3._length = _;
            }
          }
          function k(t4, r4) {
            for (var i3 = 0; i3 < p2.length; i3++)
              t4(n2.nestedProperty(e3, p2[i3]), r4);
          }
        };
      }, 43102: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(86281), a = r2(74875), o = r2(79344).p;
        function s(t3, e3) {
          var r3, s2, l, u, c, f2, h, p2, d2, v, g2 = e3.transform, y = e3.transformIndex, m2 = t3.transforms[y].groups, x = o(t3.transforms, g2);
          if (!n2.isArrayOrTypedArray(m2) || 0 === m2.length)
            return [t3];
          var b = n2.filterUnique(m2), _ = new Array(b.length), w2 = m2.length, T = i.findArrayAttributes(t3), k = g2.styles || [], A = {};
          for (r3 = 0; r3 < k.length; r3++)
            A[k[r3].target] = k[r3].value;
          g2.styles && (v = n2.keyedContainer(g2, "styles", "target", "value.name"));
          var M = {}, S = {};
          for (r3 = 0; r3 < b.length; r3++) {
            M[f2 = b[r3]] = r3, S[f2] = 0, (h = _[r3] = n2.extendDeepNoArrays({}, t3))._group = f2, h.transforms[y]._indexToPoints = {};
            var E = null;
            for (v && (E = v.get(f2)), h.name = E || "" === E ? E : n2.templateString(g2.nameformat, { trace: t3.name, group: f2 }), p2 = h.transforms, h.transforms = [], s2 = 0; s2 < p2.length; s2++)
              h.transforms[s2] = n2.extendDeepNoArrays({}, p2[s2]);
            for (s2 = 0; s2 < T.length; s2++)
              n2.nestedProperty(h, T[s2]).set([]);
          }
          for (l = 0; l < T.length; l++) {
            for (u = T[l], s2 = 0, d2 = []; s2 < b.length; s2++)
              d2[s2] = n2.nestedProperty(_[s2], u).get();
            for (c = n2.nestedProperty(t3, u).get(), s2 = 0; s2 < w2; s2++)
              d2[M[m2[s2]]].push(c[s2]);
          }
          for (s2 = 0; s2 < w2; s2++)
            (h = _[M[m2[s2]]]).transforms[y]._indexToPoints[S[m2[s2]]] = x(s2), S[m2[s2]]++;
          for (r3 = 0; r3 < b.length; r3++)
            f2 = b[r3], h = _[r3], a.clearExpandedTraceDefaultColors(h), h = n2.extendDeepNoArrays(h, A[f2] || {});
          return _;
        }
        e2.moduleType = "transform", e2.name = "groupby", e2.attributes = { enabled: { valType: "boolean", dflt: true, editType: "calc" }, groups: { valType: "data_array", dflt: [], editType: "calc" }, nameformat: { valType: "string", editType: "calc" }, styles: { _isLinkedToArray: "style", target: { valType: "string", editType: "calc" }, value: { valType: "any", dflt: {}, editType: "calc", _compareAsJSON: true }, editType: "calc" }, editType: "calc" }, e2.supplyDefaults = function(t3, r3, i2) {
          var a2, o2 = {};
          function s2(r4, i3) {
            return n2.coerce(t3, o2, e2.attributes, r4, i3);
          }
          if (!s2("enabled"))
            return o2;
          s2("groups"), s2("nameformat", i2._dataLength > 1 ? "%{group} (%{trace})" : "%{group}");
          var l = t3.styles, u = o2.styles = [];
          if (l)
            for (a2 = 0; a2 < l.length; a2++) {
              var c = u[a2] = {};
              n2.coerce(l[a2], u[a2], e2.attributes.styles, "target");
              var f2 = n2.coerce(l[a2], u[a2], e2.attributes.styles, "value");
              n2.isPlainObject(f2) ? c.value = n2.extendDeep({}, f2) : f2 && delete c.value;
            }
          return o2;
        }, e2.transform = function(t3, e3) {
          var r3, n3, i2, a2 = [];
          for (n3 = 0; n3 < t3.length; n3++)
            for (r3 = s(t3[n3], e3), i2 = 0; i2 < r3.length; i2++)
              a2.push(r3[i2]);
          return a2;
        };
      }, 79344: function(t2, e2) {
        e2.p = function(t3, e3) {
          for (var r2, n2, i = 0; i < t3.length && (r2 = t3[i]) !== e3; i++)
            r2._indexToPoints && false !== r2.enabled && (n2 = r2._indexToPoints);
          var a = n2 ? function(t4) {
            return n2[t4];
          } : function(t4) {
            return [t4];
          };
          return a;
        };
      }, 32275: function(t2, e2, r2) {
        var n2 = r2(71828), i = r2(89298), a = r2(79344).p, o = r2(50606).BADNUM;
        e2.moduleType = "transform", e2.name = "sort", e2.attributes = { enabled: { valType: "boolean", dflt: true, editType: "calc" }, target: { valType: "string", strict: true, noBlank: true, arrayOk: true, dflt: "x", editType: "calc" }, order: { valType: "enumerated", values: ["ascending", "descending"], dflt: "ascending", editType: "calc" }, editType: "calc" }, e2.supplyDefaults = function(t3) {
          var r3 = {};
          function i2(i3, a2) {
            return n2.coerce(t3, r3, e2.attributes, i3, a2);
          }
          return i2("enabled") && (i2("target"), i2("order")), r3;
        }, e2.calcTransform = function(t3, e3, r3) {
          if (r3.enabled) {
            var s = n2.getTargetArray(e3, r3);
            if (s) {
              var l = r3.target, u = s.length;
              e3._length && (u = Math.min(u, e3._length));
              var c, f2, h = e3._arrayAttrs, p2 = function(t4, e4, r4, n3) {
                var i2, a2 = new Array(n3), s2 = new Array(n3);
                for (i2 = 0; i2 < n3; i2++)
                  a2[i2] = { v: e4[i2], i: i2 };
                for (a2.sort(function(t5, e5) {
                  switch (t5.order) {
                    case "ascending":
                      return function(t6, r5) {
                        var n4 = e5(t6.v), i3 = e5(r5.v);
                        return n4 === o ? 1 : i3 === o ? -1 : n4 - i3;
                      };
                    case "descending":
                      return function(t6, r5) {
                        var n4 = e5(t6.v), i3 = e5(r5.v);
                        return n4 === o ? 1 : i3 === o ? -1 : i3 - n4;
                      };
                  }
                }(t4, r4)), i2 = 0; i2 < n3; i2++)
                  s2[i2] = a2[i2].i;
                return s2;
              }(r3, s, i.getDataToCoordFunc(t3, e3, l, s), u), d2 = a(e3.transforms, r3), v = {};
              for (c = 0; c < h.length; c++) {
                var g2 = n2.nestedProperty(e3, h[c]), y = g2.get(), m2 = new Array(u);
                for (f2 = 0; f2 < u; f2++)
                  m2[f2] = y[p2[f2]];
                g2.set(m2);
              }
              for (f2 = 0; f2 < u; f2++)
                v[f2] = d2(p2[f2]);
              r3._indexToPoints = v, e3._length = u;
            }
          }
        };
      }, 11506: function(t2, e2) {
        e2.version = "2.20.0";
      }, 9330: function(t2, e2, r2) {
        var n2, i = r2(90386);
        n2 = function() {
          return function() {
            var t3 = { 7386: function(t4, e4, r4) {
              t4.exports = { alpha_shape: r4(2350), convex_hull: r4(5537), delaunay_triangulate: r4(4419), gl_cone3d: r4(1140), gl_error3d: r4(3110), gl_heatmap2d: r4(6386), gl_line3d: r4(6086), gl_mesh3d: r4(8116), gl_plot2d: r4(2117), gl_plot3d: r4(1059), gl_pointcloud2d: r4(8271), gl_scatter3d: r4(2182), gl_select_box: r4(6623), gl_spikes2d: r4(3050), gl_streamtube3d: r4(7307), gl_surface3d: r4(3754), ndarray: r4(5050), ndarray_linear_interpolate: r4(3581) };
            }, 2146: function(t4, e4, r4) {
              function n3(t5, e5) {
                if (!(t5 instanceof e5))
                  throw new TypeError("Cannot call a class as a function");
              }
              function i2(t5, e5) {
                for (var r5 = 0; r5 < e5.length; r5++) {
                  var n4 = e5[r5];
                  n4.enumerable = n4.enumerable || false, n4.configurable = true, "value" in n4 && (n4.writable = true), Object.defineProperty(t5, n4.key, n4);
                }
              }
              function a(t5, e5) {
                return a = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(t6, e6) {
                  return t6.__proto__ = e6, t6;
                }, a(t5, e5);
              }
              function o(t5, e5) {
                if (e5 && ("object" === u(e5) || "function" == typeof e5))
                  return e5;
                if (void 0 !== e5)
                  throw new TypeError("Derived constructors may only return object or undefined");
                return s(t5);
              }
              function s(t5) {
                if (void 0 === t5)
                  throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                return t5;
              }
              function l(t5) {
                return l = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function(t6) {
                  return t6.__proto__ || Object.getPrototypeOf(t6);
                }, l(t5);
              }
              function u(t5) {
                return u = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(t6) {
                  return typeof t6;
                } : function(t6) {
                  return t6 && "function" == typeof Symbol && t6.constructor === Symbol && t6 !== Symbol.prototype ? "symbol" : typeof t6;
                }, u(t5);
              }
              var c = r4(3910), f2 = r4(3187), h = "function" == typeof Symbol && "function" == typeof Symbol.for ? Symbol.for("nodejs.util.inspect.custom") : null;
              e4.lW = v, e4.h2 = 50;
              var p2 = 2147483647;
              function d2(t5) {
                if (t5 > p2)
                  throw new RangeError('The value "' + t5 + '" is invalid for option "size"');
                var e5 = new Uint8Array(t5);
                return Object.setPrototypeOf(e5, v.prototype), e5;
              }
              function v(t5, e5, r5) {
                if ("number" == typeof t5) {
                  if ("string" == typeof e5)
                    throw new TypeError('The "string" argument must be of type string. Received type number');
                  return m2(t5);
                }
                return g2(t5, e5, r5);
              }
              function g2(t5, e5, r5) {
                if ("string" == typeof t5)
                  return function(t6, e6) {
                    if ("string" == typeof e6 && "" !== e6 || (e6 = "utf8"), !v.isEncoding(e6))
                      throw new TypeError("Unknown encoding: " + e6);
                    var r6 = 0 | w2(t6, e6), n5 = d2(r6), i4 = n5.write(t6, e6);
                    return i4 !== r6 && (n5 = n5.slice(0, i4)), n5;
                  }(t5, e5);
                if (ArrayBuffer.isView(t5))
                  return function(t6) {
                    if (rt(t6, Uint8Array)) {
                      var e6 = new Uint8Array(t6);
                      return b(e6.buffer, e6.byteOffset, e6.byteLength);
                    }
                    return x(t6);
                  }(t5);
                if (null == t5)
                  throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type " + u(t5));
                if (rt(t5, ArrayBuffer) || t5 && rt(t5.buffer, ArrayBuffer))
                  return b(t5, e5, r5);
                if ("undefined" != typeof SharedArrayBuffer && (rt(t5, SharedArrayBuffer) || t5 && rt(t5.buffer, SharedArrayBuffer)))
                  return b(t5, e5, r5);
                if ("number" == typeof t5)
                  throw new TypeError('The "value" argument must not be of type number. Received type number');
                var n4 = t5.valueOf && t5.valueOf();
                if (null != n4 && n4 !== t5)
                  return v.from(n4, e5, r5);
                var i3 = function(t6) {
                  if (v.isBuffer(t6)) {
                    var e6 = 0 | _(t6.length), r6 = d2(e6);
                    return 0 === r6.length || t6.copy(r6, 0, 0, e6), r6;
                  }
                  return void 0 !== t6.length ? "number" != typeof t6.length || nt(t6.length) ? d2(0) : x(t6) : "Buffer" === t6.type && Array.isArray(t6.data) ? x(t6.data) : void 0;
                }(t5);
                if (i3)
                  return i3;
                if ("undefined" != typeof Symbol && null != Symbol.toPrimitive && "function" == typeof t5[Symbol.toPrimitive])
                  return v.from(t5[Symbol.toPrimitive]("string"), e5, r5);
                throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type " + u(t5));
              }
              function y(t5) {
                if ("number" != typeof t5)
                  throw new TypeError('"size" argument must be of type number');
                if (t5 < 0)
                  throw new RangeError('The value "' + t5 + '" is invalid for option "size"');
              }
              function m2(t5) {
                return y(t5), d2(t5 < 0 ? 0 : 0 | _(t5));
              }
              function x(t5) {
                for (var e5 = t5.length < 0 ? 0 : 0 | _(t5.length), r5 = d2(e5), n4 = 0; n4 < e5; n4 += 1)
                  r5[n4] = 255 & t5[n4];
                return r5;
              }
              function b(t5, e5, r5) {
                if (e5 < 0 || t5.byteLength < e5)
                  throw new RangeError('"offset" is outside of buffer bounds');
                if (t5.byteLength < e5 + (r5 || 0))
                  throw new RangeError('"length" is outside of buffer bounds');
                var n4;
                return n4 = void 0 === e5 && void 0 === r5 ? new Uint8Array(t5) : void 0 === r5 ? new Uint8Array(t5, e5) : new Uint8Array(t5, e5, r5), Object.setPrototypeOf(n4, v.prototype), n4;
              }
              function _(t5) {
                if (t5 >= p2)
                  throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x" + p2.toString(16) + " bytes");
                return 0 | t5;
              }
              function w2(t5, e5) {
                if (v.isBuffer(t5))
                  return t5.length;
                if (ArrayBuffer.isView(t5) || rt(t5, ArrayBuffer))
                  return t5.byteLength;
                if ("string" != typeof t5)
                  throw new TypeError('The "string" argument must be one of type string, Buffer, or ArrayBuffer. Received type ' + u(t5));
                var r5 = t5.length, n4 = arguments.length > 2 && true === arguments[2];
                if (!n4 && 0 === r5)
                  return 0;
                for (var i3 = false; ; )
                  switch (e5) {
                    case "ascii":
                    case "latin1":
                    case "binary":
                      return r5;
                    case "utf8":
                    case "utf-8":
                      return Q(t5).length;
                    case "ucs2":
                    case "ucs-2":
                    case "utf16le":
                    case "utf-16le":
                      return 2 * r5;
                    case "hex":
                      return r5 >>> 1;
                    case "base64":
                      return tt(t5).length;
                    default:
                      if (i3)
                        return n4 ? -1 : Q(t5).length;
                      e5 = ("" + e5).toLowerCase(), i3 = true;
                  }
              }
              function T(t5, e5, r5) {
                var n4 = false;
                if ((void 0 === e5 || e5 < 0) && (e5 = 0), e5 > this.length)
                  return "";
                if ((void 0 === r5 || r5 > this.length) && (r5 = this.length), r5 <= 0)
                  return "";
                if ((r5 >>>= 0) <= (e5 >>>= 0))
                  return "";
                for (t5 || (t5 = "utf8"); ; )
                  switch (t5) {
                    case "hex":
                      return F(this, e5, r5);
                    case "utf8":
                    case "utf-8":
                      return I(this, e5, r5);
                    case "ascii":
                      return z(this, e5, r5);
                    case "latin1":
                    case "binary":
                      return R(this, e5, r5);
                    case "base64":
                      return O(this, e5, r5);
                    case "ucs2":
                    case "ucs-2":
                    case "utf16le":
                    case "utf-16le":
                      return B(this, e5, r5);
                    default:
                      if (n4)
                        throw new TypeError("Unknown encoding: " + t5);
                      t5 = (t5 + "").toLowerCase(), n4 = true;
                  }
              }
              function k(t5, e5, r5) {
                var n4 = t5[e5];
                t5[e5] = t5[r5], t5[r5] = n4;
              }
              function A(t5, e5, r5, n4, i3) {
                if (0 === t5.length)
                  return -1;
                if ("string" == typeof r5 ? (n4 = r5, r5 = 0) : r5 > 2147483647 ? r5 = 2147483647 : r5 < -2147483648 && (r5 = -2147483648), nt(r5 = +r5) && (r5 = i3 ? 0 : t5.length - 1), r5 < 0 && (r5 = t5.length + r5), r5 >= t5.length) {
                  if (i3)
                    return -1;
                  r5 = t5.length - 1;
                } else if (r5 < 0) {
                  if (!i3)
                    return -1;
                  r5 = 0;
                }
                if ("string" == typeof e5 && (e5 = v.from(e5, n4)), v.isBuffer(e5))
                  return 0 === e5.length ? -1 : M(t5, e5, r5, n4, i3);
                if ("number" == typeof e5)
                  return e5 &= 255, "function" == typeof Uint8Array.prototype.indexOf ? i3 ? Uint8Array.prototype.indexOf.call(t5, e5, r5) : Uint8Array.prototype.lastIndexOf.call(t5, e5, r5) : M(t5, [e5], r5, n4, i3);
                throw new TypeError("val must be string, number or Buffer");
              }
              function M(t5, e5, r5, n4, i3) {
                var a2, o2 = 1, s2 = t5.length, l2 = e5.length;
                if (void 0 !== n4 && ("ucs2" === (n4 = String(n4).toLowerCase()) || "ucs-2" === n4 || "utf16le" === n4 || "utf-16le" === n4)) {
                  if (t5.length < 2 || e5.length < 2)
                    return -1;
                  o2 = 2, s2 /= 2, l2 /= 2, r5 /= 2;
                }
                function u2(t6, e6) {
                  return 1 === o2 ? t6[e6] : t6.readUInt16BE(e6 * o2);
                }
                if (i3) {
                  var c2 = -1;
                  for (a2 = r5; a2 < s2; a2++)
                    if (u2(t5, a2) === u2(e5, -1 === c2 ? 0 : a2 - c2)) {
                      if (-1 === c2 && (c2 = a2), a2 - c2 + 1 === l2)
                        return c2 * o2;
                    } else
                      -1 !== c2 && (a2 -= a2 - c2), c2 = -1;
                } else
                  for (r5 + l2 > s2 && (r5 = s2 - l2), a2 = r5; a2 >= 0; a2--) {
                    for (var f3 = true, h2 = 0; h2 < l2; h2++)
                      if (u2(t5, a2 + h2) !== u2(e5, h2)) {
                        f3 = false;
                        break;
                      }
                    if (f3)
                      return a2;
                  }
                return -1;
              }
              function S(t5, e5, r5, n4) {
                r5 = Number(r5) || 0;
                var i3 = t5.length - r5;
                n4 ? (n4 = Number(n4)) > i3 && (n4 = i3) : n4 = i3;
                var a2, o2 = e5.length;
                for (n4 > o2 / 2 && (n4 = o2 / 2), a2 = 0; a2 < n4; ++a2) {
                  var s2 = parseInt(e5.substr(2 * a2, 2), 16);
                  if (nt(s2))
                    return a2;
                  t5[r5 + a2] = s2;
                }
                return a2;
              }
              function E(t5, e5, r5, n4) {
                return et(Q(e5, t5.length - r5), t5, r5, n4);
              }
              function L(t5, e5, r5, n4) {
                return et(function(t6) {
                  for (var e6 = [], r6 = 0; r6 < t6.length; ++r6)
                    e6.push(255 & t6.charCodeAt(r6));
                  return e6;
                }(e5), t5, r5, n4);
              }
              function C(t5, e5, r5, n4) {
                return et(tt(e5), t5, r5, n4);
              }
              function P(t5, e5, r5, n4) {
                return et(function(t6, e6) {
                  for (var r6, n5, i3, a2 = [], o2 = 0; o2 < t6.length && !((e6 -= 2) < 0); ++o2)
                    n5 = (r6 = t6.charCodeAt(o2)) >> 8, i3 = r6 % 256, a2.push(i3), a2.push(n5);
                  return a2;
                }(e5, t5.length - r5), t5, r5, n4);
              }
              function O(t5, e5, r5) {
                return 0 === e5 && r5 === t5.length ? c.fromByteArray(t5) : c.fromByteArray(t5.slice(e5, r5));
              }
              function I(t5, e5, r5) {
                r5 = Math.min(t5.length, r5);
                for (var n4 = [], i3 = e5; i3 < r5; ) {
                  var a2 = t5[i3], o2 = null, s2 = a2 > 239 ? 4 : a2 > 223 ? 3 : a2 > 191 ? 2 : 1;
                  if (i3 + s2 <= r5) {
                    var l2 = void 0, u2 = void 0, c2 = void 0, f3 = void 0;
                    switch (s2) {
                      case 1:
                        a2 < 128 && (o2 = a2);
                        break;
                      case 2:
                        128 == (192 & (l2 = t5[i3 + 1])) && (f3 = (31 & a2) << 6 | 63 & l2) > 127 && (o2 = f3);
                        break;
                      case 3:
                        l2 = t5[i3 + 1], u2 = t5[i3 + 2], 128 == (192 & l2) && 128 == (192 & u2) && (f3 = (15 & a2) << 12 | (63 & l2) << 6 | 63 & u2) > 2047 && (f3 < 55296 || f3 > 57343) && (o2 = f3);
                        break;
                      case 4:
                        l2 = t5[i3 + 1], u2 = t5[i3 + 2], c2 = t5[i3 + 3], 128 == (192 & l2) && 128 == (192 & u2) && 128 == (192 & c2) && (f3 = (15 & a2) << 18 | (63 & l2) << 12 | (63 & u2) << 6 | 63 & c2) > 65535 && f3 < 1114112 && (o2 = f3);
                    }
                  }
                  null === o2 ? (o2 = 65533, s2 = 1) : o2 > 65535 && (o2 -= 65536, n4.push(o2 >>> 10 & 1023 | 55296), o2 = 56320 | 1023 & o2), n4.push(o2), i3 += s2;
                }
                return function(t6) {
                  var e6 = t6.length;
                  if (e6 <= D)
                    return String.fromCharCode.apply(String, t6);
                  for (var r6 = "", n5 = 0; n5 < e6; )
                    r6 += String.fromCharCode.apply(String, t6.slice(n5, n5 += D));
                  return r6;
                }(n4);
              }
              v.TYPED_ARRAY_SUPPORT = function() {
                try {
                  var t5 = new Uint8Array(1), e5 = { foo: function() {
                    return 42;
                  } };
                  return Object.setPrototypeOf(e5, Uint8Array.prototype), Object.setPrototypeOf(t5, e5), 42 === t5.foo();
                } catch (t6) {
                  return false;
                }
              }(), v.TYPED_ARRAY_SUPPORT || "undefined" == typeof console || "function" != typeof console.error || console.error("This browser lacks typed array (Uint8Array) support which is required by `buffer` v5.x. Use `buffer` v4.x if you require old browser support."), Object.defineProperty(v.prototype, "parent", { enumerable: true, get: function() {
                if (v.isBuffer(this))
                  return this.buffer;
              } }), Object.defineProperty(v.prototype, "offset", { enumerable: true, get: function() {
                if (v.isBuffer(this))
                  return this.byteOffset;
              } }), v.poolSize = 8192, v.from = function(t5, e5, r5) {
                return g2(t5, e5, r5);
              }, Object.setPrototypeOf(v.prototype, Uint8Array.prototype), Object.setPrototypeOf(v, Uint8Array), v.alloc = function(t5, e5, r5) {
                return function(t6, e6, r6) {
                  return y(t6), t6 <= 0 ? d2(t6) : void 0 !== e6 ? "string" == typeof r6 ? d2(t6).fill(e6, r6) : d2(t6).fill(e6) : d2(t6);
                }(t5, e5, r5);
              }, v.allocUnsafe = function(t5) {
                return m2(t5);
              }, v.allocUnsafeSlow = function(t5) {
                return m2(t5);
              }, v.isBuffer = function(t5) {
                return null != t5 && true === t5._isBuffer && t5 !== v.prototype;
              }, v.compare = function(t5, e5) {
                if (rt(t5, Uint8Array) && (t5 = v.from(t5, t5.offset, t5.byteLength)), rt(e5, Uint8Array) && (e5 = v.from(e5, e5.offset, e5.byteLength)), !v.isBuffer(t5) || !v.isBuffer(e5))
                  throw new TypeError('The "buf1", "buf2" arguments must be one of type Buffer or Uint8Array');
                if (t5 === e5)
                  return 0;
                for (var r5 = t5.length, n4 = e5.length, i3 = 0, a2 = Math.min(r5, n4); i3 < a2; ++i3)
                  if (t5[i3] !== e5[i3]) {
                    r5 = t5[i3], n4 = e5[i3];
                    break;
                  }
                return r5 < n4 ? -1 : n4 < r5 ? 1 : 0;
              }, v.isEncoding = function(t5) {
                switch (String(t5).toLowerCase()) {
                  case "hex":
                  case "utf8":
                  case "utf-8":
                  case "ascii":
                  case "latin1":
                  case "binary":
                  case "base64":
                  case "ucs2":
                  case "ucs-2":
                  case "utf16le":
                  case "utf-16le":
                    return true;
                  default:
                    return false;
                }
              }, v.concat = function(t5, e5) {
                if (!Array.isArray(t5))
                  throw new TypeError('"list" argument must be an Array of Buffers');
                if (0 === t5.length)
                  return v.alloc(0);
                var r5;
                if (void 0 === e5)
                  for (e5 = 0, r5 = 0; r5 < t5.length; ++r5)
                    e5 += t5[r5].length;
                var n4 = v.allocUnsafe(e5), i3 = 0;
                for (r5 = 0; r5 < t5.length; ++r5) {
                  var a2 = t5[r5];
                  if (rt(a2, Uint8Array))
                    i3 + a2.length > n4.length ? (v.isBuffer(a2) || (a2 = v.from(a2)), a2.copy(n4, i3)) : Uint8Array.prototype.set.call(n4, a2, i3);
                  else {
                    if (!v.isBuffer(a2))
                      throw new TypeError('"list" argument must be an Array of Buffers');
                    a2.copy(n4, i3);
                  }
                  i3 += a2.length;
                }
                return n4;
              }, v.byteLength = w2, v.prototype._isBuffer = true, v.prototype.swap16 = function() {
                var t5 = this.length;
                if (t5 % 2 != 0)
                  throw new RangeError("Buffer size must be a multiple of 16-bits");
                for (var e5 = 0; e5 < t5; e5 += 2)
                  k(this, e5, e5 + 1);
                return this;
              }, v.prototype.swap32 = function() {
                var t5 = this.length;
                if (t5 % 4 != 0)
                  throw new RangeError("Buffer size must be a multiple of 32-bits");
                for (var e5 = 0; e5 < t5; e5 += 4)
                  k(this, e5, e5 + 3), k(this, e5 + 1, e5 + 2);
                return this;
              }, v.prototype.swap64 = function() {
                var t5 = this.length;
                if (t5 % 8 != 0)
                  throw new RangeError("Buffer size must be a multiple of 64-bits");
                for (var e5 = 0; e5 < t5; e5 += 8)
                  k(this, e5, e5 + 7), k(this, e5 + 1, e5 + 6), k(this, e5 + 2, e5 + 5), k(this, e5 + 3, e5 + 4);
                return this;
              }, v.prototype.toString = function() {
                var t5 = this.length;
                return 0 === t5 ? "" : 0 === arguments.length ? I(this, 0, t5) : T.apply(this, arguments);
              }, v.prototype.toLocaleString = v.prototype.toString, v.prototype.equals = function(t5) {
                if (!v.isBuffer(t5))
                  throw new TypeError("Argument must be a Buffer");
                return this === t5 || 0 === v.compare(this, t5);
              }, v.prototype.inspect = function() {
                var t5 = "", r5 = e4.h2;
                return t5 = this.toString("hex", 0, r5).replace(/(.{2})/g, "$1 ").trim(), this.length > r5 && (t5 += " ... "), "<Buffer " + t5 + ">";
              }, h && (v.prototype[h] = v.prototype.inspect), v.prototype.compare = function(t5, e5, r5, n4, i3) {
                if (rt(t5, Uint8Array) && (t5 = v.from(t5, t5.offset, t5.byteLength)), !v.isBuffer(t5))
                  throw new TypeError('The "target" argument must be one of type Buffer or Uint8Array. Received type ' + u(t5));
                if (void 0 === e5 && (e5 = 0), void 0 === r5 && (r5 = t5 ? t5.length : 0), void 0 === n4 && (n4 = 0), void 0 === i3 && (i3 = this.length), e5 < 0 || r5 > t5.length || n4 < 0 || i3 > this.length)
                  throw new RangeError("out of range index");
                if (n4 >= i3 && e5 >= r5)
                  return 0;
                if (n4 >= i3)
                  return -1;
                if (e5 >= r5)
                  return 1;
                if (this === t5)
                  return 0;
                for (var a2 = (i3 >>>= 0) - (n4 >>>= 0), o2 = (r5 >>>= 0) - (e5 >>>= 0), s2 = Math.min(a2, o2), l2 = this.slice(n4, i3), c2 = t5.slice(e5, r5), f3 = 0; f3 < s2; ++f3)
                  if (l2[f3] !== c2[f3]) {
                    a2 = l2[f3], o2 = c2[f3];
                    break;
                  }
                return a2 < o2 ? -1 : o2 < a2 ? 1 : 0;
              }, v.prototype.includes = function(t5, e5, r5) {
                return -1 !== this.indexOf(t5, e5, r5);
              }, v.prototype.indexOf = function(t5, e5, r5) {
                return A(this, t5, e5, r5, true);
              }, v.prototype.lastIndexOf = function(t5, e5, r5) {
                return A(this, t5, e5, r5, false);
              }, v.prototype.write = function(t5, e5, r5, n4) {
                if (void 0 === e5)
                  n4 = "utf8", r5 = this.length, e5 = 0;
                else if (void 0 === r5 && "string" == typeof e5)
                  n4 = e5, r5 = this.length, e5 = 0;
                else {
                  if (!isFinite(e5))
                    throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");
                  e5 >>>= 0, isFinite(r5) ? (r5 >>>= 0, void 0 === n4 && (n4 = "utf8")) : (n4 = r5, r5 = void 0);
                }
                var i3 = this.length - e5;
                if ((void 0 === r5 || r5 > i3) && (r5 = i3), t5.length > 0 && (r5 < 0 || e5 < 0) || e5 > this.length)
                  throw new RangeError("Attempt to write outside buffer bounds");
                n4 || (n4 = "utf8");
                for (var a2 = false; ; )
                  switch (n4) {
                    case "hex":
                      return S(this, t5, e5, r5);
                    case "utf8":
                    case "utf-8":
                      return E(this, t5, e5, r5);
                    case "ascii":
                    case "latin1":
                    case "binary":
                      return L(this, t5, e5, r5);
                    case "base64":
                      return C(this, t5, e5, r5);
                    case "ucs2":
                    case "ucs-2":
                    case "utf16le":
                    case "utf-16le":
                      return P(this, t5, e5, r5);
                    default:
                      if (a2)
                        throw new TypeError("Unknown encoding: " + n4);
                      n4 = ("" + n4).toLowerCase(), a2 = true;
                  }
              }, v.prototype.toJSON = function() {
                return { type: "Buffer", data: Array.prototype.slice.call(this._arr || this, 0) };
              };
              var D = 4096;
              function z(t5, e5, r5) {
                var n4 = "";
                r5 = Math.min(t5.length, r5);
                for (var i3 = e5; i3 < r5; ++i3)
                  n4 += String.fromCharCode(127 & t5[i3]);
                return n4;
              }
              function R(t5, e5, r5) {
                var n4 = "";
                r5 = Math.min(t5.length, r5);
                for (var i3 = e5; i3 < r5; ++i3)
                  n4 += String.fromCharCode(t5[i3]);
                return n4;
              }
              function F(t5, e5, r5) {
                var n4 = t5.length;
                (!e5 || e5 < 0) && (e5 = 0), (!r5 || r5 < 0 || r5 > n4) && (r5 = n4);
                for (var i3 = "", a2 = e5; a2 < r5; ++a2)
                  i3 += it[t5[a2]];
                return i3;
              }
              function B(t5, e5, r5) {
                for (var n4 = t5.slice(e5, r5), i3 = "", a2 = 0; a2 < n4.length - 1; a2 += 2)
                  i3 += String.fromCharCode(n4[a2] + 256 * n4[a2 + 1]);
                return i3;
              }
              function N(t5, e5, r5) {
                if (t5 % 1 != 0 || t5 < 0)
                  throw new RangeError("offset is not uint");
                if (t5 + e5 > r5)
                  throw new RangeError("Trying to access beyond buffer length");
              }
              function j(t5, e5, r5, n4, i3, a2) {
                if (!v.isBuffer(t5))
                  throw new TypeError('"buffer" argument must be a Buffer instance');
                if (e5 > i3 || e5 < a2)
                  throw new RangeError('"value" argument is out of bounds');
                if (r5 + n4 > t5.length)
                  throw new RangeError("Index out of range");
              }
              function U(t5, e5, r5, n4, i3) {
                X(e5, n4, i3, t5, r5, 7);
                var a2 = Number(e5 & BigInt(4294967295));
                t5[r5++] = a2, a2 >>= 8, t5[r5++] = a2, a2 >>= 8, t5[r5++] = a2, a2 >>= 8, t5[r5++] = a2;
                var o2 = Number(e5 >> BigInt(32) & BigInt(4294967295));
                return t5[r5++] = o2, o2 >>= 8, t5[r5++] = o2, o2 >>= 8, t5[r5++] = o2, o2 >>= 8, t5[r5++] = o2, r5;
              }
              function V(t5, e5, r5, n4, i3) {
                X(e5, n4, i3, t5, r5, 7);
                var a2 = Number(e5 & BigInt(4294967295));
                t5[r5 + 7] = a2, a2 >>= 8, t5[r5 + 6] = a2, a2 >>= 8, t5[r5 + 5] = a2, a2 >>= 8, t5[r5 + 4] = a2;
                var o2 = Number(e5 >> BigInt(32) & BigInt(4294967295));
                return t5[r5 + 3] = o2, o2 >>= 8, t5[r5 + 2] = o2, o2 >>= 8, t5[r5 + 1] = o2, o2 >>= 8, t5[r5] = o2, r5 + 8;
              }
              function H(t5, e5, r5, n4, i3, a2) {
                if (r5 + n4 > t5.length)
                  throw new RangeError("Index out of range");
                if (r5 < 0)
                  throw new RangeError("Index out of range");
              }
              function q2(t5, e5, r5, n4, i3) {
                return e5 = +e5, r5 >>>= 0, i3 || H(t5, 0, r5, 4), f2.write(t5, e5, r5, n4, 23, 4), r5 + 4;
              }
              function G(t5, e5, r5, n4, i3) {
                return e5 = +e5, r5 >>>= 0, i3 || H(t5, 0, r5, 8), f2.write(t5, e5, r5, n4, 52, 8), r5 + 8;
              }
              v.prototype.slice = function(t5, e5) {
                var r5 = this.length;
                (t5 = ~~t5) < 0 ? (t5 += r5) < 0 && (t5 = 0) : t5 > r5 && (t5 = r5), (e5 = void 0 === e5 ? r5 : ~~e5) < 0 ? (e5 += r5) < 0 && (e5 = 0) : e5 > r5 && (e5 = r5), e5 < t5 && (e5 = t5);
                var n4 = this.subarray(t5, e5);
                return Object.setPrototypeOf(n4, v.prototype), n4;
              }, v.prototype.readUintLE = v.prototype.readUIntLE = function(t5, e5, r5) {
                t5 >>>= 0, e5 >>>= 0, r5 || N(t5, e5, this.length);
                for (var n4 = this[t5], i3 = 1, a2 = 0; ++a2 < e5 && (i3 *= 256); )
                  n4 += this[t5 + a2] * i3;
                return n4;
              }, v.prototype.readUintBE = v.prototype.readUIntBE = function(t5, e5, r5) {
                t5 >>>= 0, e5 >>>= 0, r5 || N(t5, e5, this.length);
                for (var n4 = this[t5 + --e5], i3 = 1; e5 > 0 && (i3 *= 256); )
                  n4 += this[t5 + --e5] * i3;
                return n4;
              }, v.prototype.readUint8 = v.prototype.readUInt8 = function(t5, e5) {
                return t5 >>>= 0, e5 || N(t5, 1, this.length), this[t5];
              }, v.prototype.readUint16LE = v.prototype.readUInt16LE = function(t5, e5) {
                return t5 >>>= 0, e5 || N(t5, 2, this.length), this[t5] | this[t5 + 1] << 8;
              }, v.prototype.readUint16BE = v.prototype.readUInt16BE = function(t5, e5) {
                return t5 >>>= 0, e5 || N(t5, 2, this.length), this[t5] << 8 | this[t5 + 1];
              }, v.prototype.readUint32LE = v.prototype.readUInt32LE = function(t5, e5) {
                return t5 >>>= 0, e5 || N(t5, 4, this.length), (this[t5] | this[t5 + 1] << 8 | this[t5 + 2] << 16) + 16777216 * this[t5 + 3];
              }, v.prototype.readUint32BE = v.prototype.readUInt32BE = function(t5, e5) {
                return t5 >>>= 0, e5 || N(t5, 4, this.length), 16777216 * this[t5] + (this[t5 + 1] << 16 | this[t5 + 2] << 8 | this[t5 + 3]);
              }, v.prototype.readBigUInt64LE = at(function(t5) {
                J(t5 >>>= 0, "offset");
                var e5 = this[t5], r5 = this[t5 + 7];
                void 0 !== e5 && void 0 !== r5 || K(t5, this.length - 8);
                var n4 = e5 + this[++t5] * Math.pow(2, 8) + this[++t5] * Math.pow(2, 16) + this[++t5] * Math.pow(2, 24), i3 = this[++t5] + this[++t5] * Math.pow(2, 8) + this[++t5] * Math.pow(2, 16) + r5 * Math.pow(2, 24);
                return BigInt(n4) + (BigInt(i3) << BigInt(32));
              }), v.prototype.readBigUInt64BE = at(function(t5) {
                J(t5 >>>= 0, "offset");
                var e5 = this[t5], r5 = this[t5 + 7];
                void 0 !== e5 && void 0 !== r5 || K(t5, this.length - 8);
                var n4 = e5 * Math.pow(2, 24) + this[++t5] * Math.pow(2, 16) + this[++t5] * Math.pow(2, 8) + this[++t5], i3 = this[++t5] * Math.pow(2, 24) + this[++t5] * Math.pow(2, 16) + this[++t5] * Math.pow(2, 8) + r5;
                return (BigInt(n4) << BigInt(32)) + BigInt(i3);
              }), v.prototype.readIntLE = function(t5, e5, r5) {
                t5 >>>= 0, e5 >>>= 0, r5 || N(t5, e5, this.length);
                for (var n4 = this[t5], i3 = 1, a2 = 0; ++a2 < e5 && (i3 *= 256); )
                  n4 += this[t5 + a2] * i3;
                return n4 >= (i3 *= 128) && (n4 -= Math.pow(2, 8 * e5)), n4;
              }, v.prototype.readIntBE = function(t5, e5, r5) {
                t5 >>>= 0, e5 >>>= 0, r5 || N(t5, e5, this.length);
                for (var n4 = e5, i3 = 1, a2 = this[t5 + --n4]; n4 > 0 && (i3 *= 256); )
                  a2 += this[t5 + --n4] * i3;
                return a2 >= (i3 *= 128) && (a2 -= Math.pow(2, 8 * e5)), a2;
              }, v.prototype.readInt8 = function(t5, e5) {
                return t5 >>>= 0, e5 || N(t5, 1, this.length), 128 & this[t5] ? -1 * (255 - this[t5] + 1) : this[t5];
              }, v.prototype.readInt16LE = function(t5, e5) {
                t5 >>>= 0, e5 || N(t5, 2, this.length);
                var r5 = this[t5] | this[t5 + 1] << 8;
                return 32768 & r5 ? 4294901760 | r5 : r5;
              }, v.prototype.readInt16BE = function(t5, e5) {
                t5 >>>= 0, e5 || N(t5, 2, this.length);
                var r5 = this[t5 + 1] | this[t5] << 8;
                return 32768 & r5 ? 4294901760 | r5 : r5;
              }, v.prototype.readInt32LE = function(t5, e5) {
                return t5 >>>= 0, e5 || N(t5, 4, this.length), this[t5] | this[t5 + 1] << 8 | this[t5 + 2] << 16 | this[t5 + 3] << 24;
              }, v.prototype.readInt32BE = function(t5, e5) {
                return t5 >>>= 0, e5 || N(t5, 4, this.length), this[t5] << 24 | this[t5 + 1] << 16 | this[t5 + 2] << 8 | this[t5 + 3];
              }, v.prototype.readBigInt64LE = at(function(t5) {
                J(t5 >>>= 0, "offset");
                var e5 = this[t5], r5 = this[t5 + 7];
                void 0 !== e5 && void 0 !== r5 || K(t5, this.length - 8);
                var n4 = this[t5 + 4] + this[t5 + 5] * Math.pow(2, 8) + this[t5 + 6] * Math.pow(2, 16) + (r5 << 24);
                return (BigInt(n4) << BigInt(32)) + BigInt(e5 + this[++t5] * Math.pow(2, 8) + this[++t5] * Math.pow(2, 16) + this[++t5] * Math.pow(2, 24));
              }), v.prototype.readBigInt64BE = at(function(t5) {
                J(t5 >>>= 0, "offset");
                var e5 = this[t5], r5 = this[t5 + 7];
                void 0 !== e5 && void 0 !== r5 || K(t5, this.length - 8);
                var n4 = (e5 << 24) + this[++t5] * Math.pow(2, 16) + this[++t5] * Math.pow(2, 8) + this[++t5];
                return (BigInt(n4) << BigInt(32)) + BigInt(this[++t5] * Math.pow(2, 24) + this[++t5] * Math.pow(2, 16) + this[++t5] * Math.pow(2, 8) + r5);
              }), v.prototype.readFloatLE = function(t5, e5) {
                return t5 >>>= 0, e5 || N(t5, 4, this.length), f2.read(this, t5, true, 23, 4);
              }, v.prototype.readFloatBE = function(t5, e5) {
                return t5 >>>= 0, e5 || N(t5, 4, this.length), f2.read(this, t5, false, 23, 4);
              }, v.prototype.readDoubleLE = function(t5, e5) {
                return t5 >>>= 0, e5 || N(t5, 8, this.length), f2.read(this, t5, true, 52, 8);
              }, v.prototype.readDoubleBE = function(t5, e5) {
                return t5 >>>= 0, e5 || N(t5, 8, this.length), f2.read(this, t5, false, 52, 8);
              }, v.prototype.writeUintLE = v.prototype.writeUIntLE = function(t5, e5, r5, n4) {
                t5 = +t5, e5 >>>= 0, r5 >>>= 0, n4 || j(this, t5, e5, r5, Math.pow(2, 8 * r5) - 1, 0);
                var i3 = 1, a2 = 0;
                for (this[e5] = 255 & t5; ++a2 < r5 && (i3 *= 256); )
                  this[e5 + a2] = t5 / i3 & 255;
                return e5 + r5;
              }, v.prototype.writeUintBE = v.prototype.writeUIntBE = function(t5, e5, r5, n4) {
                t5 = +t5, e5 >>>= 0, r5 >>>= 0, n4 || j(this, t5, e5, r5, Math.pow(2, 8 * r5) - 1, 0);
                var i3 = r5 - 1, a2 = 1;
                for (this[e5 + i3] = 255 & t5; --i3 >= 0 && (a2 *= 256); )
                  this[e5 + i3] = t5 / a2 & 255;
                return e5 + r5;
              }, v.prototype.writeUint8 = v.prototype.writeUInt8 = function(t5, e5, r5) {
                return t5 = +t5, e5 >>>= 0, r5 || j(this, t5, e5, 1, 255, 0), this[e5] = 255 & t5, e5 + 1;
              }, v.prototype.writeUint16LE = v.prototype.writeUInt16LE = function(t5, e5, r5) {
                return t5 = +t5, e5 >>>= 0, r5 || j(this, t5, e5, 2, 65535, 0), this[e5] = 255 & t5, this[e5 + 1] = t5 >>> 8, e5 + 2;
              }, v.prototype.writeUint16BE = v.prototype.writeUInt16BE = function(t5, e5, r5) {
                return t5 = +t5, e5 >>>= 0, r5 || j(this, t5, e5, 2, 65535, 0), this[e5] = t5 >>> 8, this[e5 + 1] = 255 & t5, e5 + 2;
              }, v.prototype.writeUint32LE = v.prototype.writeUInt32LE = function(t5, e5, r5) {
                return t5 = +t5, e5 >>>= 0, r5 || j(this, t5, e5, 4, 4294967295, 0), this[e5 + 3] = t5 >>> 24, this[e5 + 2] = t5 >>> 16, this[e5 + 1] = t5 >>> 8, this[e5] = 255 & t5, e5 + 4;
              }, v.prototype.writeUint32BE = v.prototype.writeUInt32BE = function(t5, e5, r5) {
                return t5 = +t5, e5 >>>= 0, r5 || j(this, t5, e5, 4, 4294967295, 0), this[e5] = t5 >>> 24, this[e5 + 1] = t5 >>> 16, this[e5 + 2] = t5 >>> 8, this[e5 + 3] = 255 & t5, e5 + 4;
              }, v.prototype.writeBigUInt64LE = at(function(t5) {
                var e5 = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0;
                return U(this, t5, e5, BigInt(0), BigInt("0xffffffffffffffff"));
              }), v.prototype.writeBigUInt64BE = at(function(t5) {
                var e5 = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0;
                return V(this, t5, e5, BigInt(0), BigInt("0xffffffffffffffff"));
              }), v.prototype.writeIntLE = function(t5, e5, r5, n4) {
                if (t5 = +t5, e5 >>>= 0, !n4) {
                  var i3 = Math.pow(2, 8 * r5 - 1);
                  j(this, t5, e5, r5, i3 - 1, -i3);
                }
                var a2 = 0, o2 = 1, s2 = 0;
                for (this[e5] = 255 & t5; ++a2 < r5 && (o2 *= 256); )
                  t5 < 0 && 0 === s2 && 0 !== this[e5 + a2 - 1] && (s2 = 1), this[e5 + a2] = (t5 / o2 >> 0) - s2 & 255;
                return e5 + r5;
              }, v.prototype.writeIntBE = function(t5, e5, r5, n4) {
                if (t5 = +t5, e5 >>>= 0, !n4) {
                  var i3 = Math.pow(2, 8 * r5 - 1);
                  j(this, t5, e5, r5, i3 - 1, -i3);
                }
                var a2 = r5 - 1, o2 = 1, s2 = 0;
                for (this[e5 + a2] = 255 & t5; --a2 >= 0 && (o2 *= 256); )
                  t5 < 0 && 0 === s2 && 0 !== this[e5 + a2 + 1] && (s2 = 1), this[e5 + a2] = (t5 / o2 >> 0) - s2 & 255;
                return e5 + r5;
              }, v.prototype.writeInt8 = function(t5, e5, r5) {
                return t5 = +t5, e5 >>>= 0, r5 || j(this, t5, e5, 1, 127, -128), t5 < 0 && (t5 = 255 + t5 + 1), this[e5] = 255 & t5, e5 + 1;
              }, v.prototype.writeInt16LE = function(t5, e5, r5) {
                return t5 = +t5, e5 >>>= 0, r5 || j(this, t5, e5, 2, 32767, -32768), this[e5] = 255 & t5, this[e5 + 1] = t5 >>> 8, e5 + 2;
              }, v.prototype.writeInt16BE = function(t5, e5, r5) {
                return t5 = +t5, e5 >>>= 0, r5 || j(this, t5, e5, 2, 32767, -32768), this[e5] = t5 >>> 8, this[e5 + 1] = 255 & t5, e5 + 2;
              }, v.prototype.writeInt32LE = function(t5, e5, r5) {
                return t5 = +t5, e5 >>>= 0, r5 || j(this, t5, e5, 4, 2147483647, -2147483648), this[e5] = 255 & t5, this[e5 + 1] = t5 >>> 8, this[e5 + 2] = t5 >>> 16, this[e5 + 3] = t5 >>> 24, e5 + 4;
              }, v.prototype.writeInt32BE = function(t5, e5, r5) {
                return t5 = +t5, e5 >>>= 0, r5 || j(this, t5, e5, 4, 2147483647, -2147483648), t5 < 0 && (t5 = 4294967295 + t5 + 1), this[e5] = t5 >>> 24, this[e5 + 1] = t5 >>> 16, this[e5 + 2] = t5 >>> 8, this[e5 + 3] = 255 & t5, e5 + 4;
              }, v.prototype.writeBigInt64LE = at(function(t5) {
                var e5 = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0;
                return U(this, t5, e5, -BigInt("0x8000000000000000"), BigInt("0x7fffffffffffffff"));
              }), v.prototype.writeBigInt64BE = at(function(t5) {
                var e5 = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0;
                return V(this, t5, e5, -BigInt("0x8000000000000000"), BigInt("0x7fffffffffffffff"));
              }), v.prototype.writeFloatLE = function(t5, e5, r5) {
                return q2(this, t5, e5, true, r5);
              }, v.prototype.writeFloatBE = function(t5, e5, r5) {
                return q2(this, t5, e5, false, r5);
              }, v.prototype.writeDoubleLE = function(t5, e5, r5) {
                return G(this, t5, e5, true, r5);
              }, v.prototype.writeDoubleBE = function(t5, e5, r5) {
                return G(this, t5, e5, false, r5);
              }, v.prototype.copy = function(t5, e5, r5, n4) {
                if (!v.isBuffer(t5))
                  throw new TypeError("argument should be a Buffer");
                if (r5 || (r5 = 0), n4 || 0 === n4 || (n4 = this.length), e5 >= t5.length && (e5 = t5.length), e5 || (e5 = 0), n4 > 0 && n4 < r5 && (n4 = r5), n4 === r5)
                  return 0;
                if (0 === t5.length || 0 === this.length)
                  return 0;
                if (e5 < 0)
                  throw new RangeError("targetStart out of bounds");
                if (r5 < 0 || r5 >= this.length)
                  throw new RangeError("Index out of range");
                if (n4 < 0)
                  throw new RangeError("sourceEnd out of bounds");
                n4 > this.length && (n4 = this.length), t5.length - e5 < n4 - r5 && (n4 = t5.length - e5 + r5);
                var i3 = n4 - r5;
                return this === t5 && "function" == typeof Uint8Array.prototype.copyWithin ? this.copyWithin(e5, r5, n4) : Uint8Array.prototype.set.call(t5, this.subarray(r5, n4), e5), i3;
              }, v.prototype.fill = function(t5, e5, r5, n4) {
                if ("string" == typeof t5) {
                  if ("string" == typeof e5 ? (n4 = e5, e5 = 0, r5 = this.length) : "string" == typeof r5 && (n4 = r5, r5 = this.length), void 0 !== n4 && "string" != typeof n4)
                    throw new TypeError("encoding must be a string");
                  if ("string" == typeof n4 && !v.isEncoding(n4))
                    throw new TypeError("Unknown encoding: " + n4);
                  if (1 === t5.length) {
                    var i3 = t5.charCodeAt(0);
                    ("utf8" === n4 && i3 < 128 || "latin1" === n4) && (t5 = i3);
                  }
                } else
                  "number" == typeof t5 ? t5 &= 255 : "boolean" == typeof t5 && (t5 = Number(t5));
                if (e5 < 0 || this.length < e5 || this.length < r5)
                  throw new RangeError("Out of range index");
                if (r5 <= e5)
                  return this;
                var a2;
                if (e5 >>>= 0, r5 = void 0 === r5 ? this.length : r5 >>> 0, t5 || (t5 = 0), "number" == typeof t5)
                  for (a2 = e5; a2 < r5; ++a2)
                    this[a2] = t5;
                else {
                  var o2 = v.isBuffer(t5) ? t5 : v.from(t5, n4), s2 = o2.length;
                  if (0 === s2)
                    throw new TypeError('The value "' + t5 + '" is invalid for argument "value"');
                  for (a2 = 0; a2 < r5 - e5; ++a2)
                    this[a2 + e5] = o2[a2 % s2];
                }
                return this;
              };
              var Z = {};
              function Y(t5, e5, r5) {
                Z[t5] = function(r6) {
                  !function(t6, e6) {
                    if ("function" != typeof e6 && null !== e6)
                      throw new TypeError("Super expression must either be null or a function");
                    t6.prototype = Object.create(e6 && e6.prototype, { constructor: { value: t6, writable: true, configurable: true } }), Object.defineProperty(t6, "prototype", { writable: false }), e6 && a(t6, e6);
                  }(d3, r6);
                  var u2, c2, f3, h2, p3 = (f3 = d3, h2 = function() {
                    if ("undefined" == typeof Reflect || !Reflect.construct)
                      return false;
                    if (Reflect.construct.sham)
                      return false;
                    if ("function" == typeof Proxy)
                      return true;
                    try {
                      return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
                      })), true;
                    } catch (t6) {
                      return false;
                    }
                  }(), function() {
                    var t6, e6 = l(f3);
                    if (h2) {
                      var r7 = l(this).constructor;
                      t6 = Reflect.construct(e6, arguments, r7);
                    } else
                      t6 = e6.apply(this, arguments);
                    return o(this, t6);
                  });
                  function d3() {
                    var r7;
                    return n3(this, d3), r7 = p3.call(this), Object.defineProperty(s(r7), "message", { value: e5.apply(s(r7), arguments), writable: true, configurable: true }), r7.name = "".concat(r7.name, " [").concat(t5, "]"), r7.stack, delete r7.name, r7;
                  }
                  return u2 = d3, (c2 = [{ key: "code", get: function() {
                    return t5;
                  }, set: function(t6) {
                    Object.defineProperty(this, "code", { configurable: true, enumerable: true, value: t6, writable: true });
                  } }, { key: "toString", value: function() {
                    return "".concat(this.name, " [").concat(t5, "]: ").concat(this.message);
                  } }]) && i2(u2.prototype, c2), Object.defineProperty(u2, "prototype", { writable: false }), d3;
                }(r5);
              }
              function W(t5) {
                for (var e5 = "", r5 = t5.length, n4 = "-" === t5[0] ? 1 : 0; r5 >= n4 + 4; r5 -= 3)
                  e5 = "_".concat(t5.slice(r5 - 3, r5)).concat(e5);
                return "".concat(t5.slice(0, r5)).concat(e5);
              }
              function X(t5, e5, r5, n4, i3, a2) {
                if (t5 > r5 || t5 < e5) {
                  var o2, s2 = "bigint" == typeof e5 ? "n" : "";
                  throw o2 = a2 > 3 ? 0 === e5 || e5 === BigInt(0) ? ">= 0".concat(s2, " and < 2").concat(s2, " ** ").concat(8 * (a2 + 1)).concat(s2) : ">= -(2".concat(s2, " ** ").concat(8 * (a2 + 1) - 1).concat(s2, ") and < 2 ** ") + "".concat(8 * (a2 + 1) - 1).concat(s2) : ">= ".concat(e5).concat(s2, " and <= ").concat(r5).concat(s2), new Z.ERR_OUT_OF_RANGE("value", o2, t5);
                }
                !function(t6, e6, r6) {
                  J(e6, "offset"), void 0 !== t6[e6] && void 0 !== t6[e6 + r6] || K(e6, t6.length - (r6 + 1));
                }(n4, i3, a2);
              }
              function J(t5, e5) {
                if ("number" != typeof t5)
                  throw new Z.ERR_INVALID_ARG_TYPE(e5, "number", t5);
              }
              function K(t5, e5, r5) {
                if (Math.floor(t5) !== t5)
                  throw J(t5, r5), new Z.ERR_OUT_OF_RANGE(r5 || "offset", "an integer", t5);
                if (e5 < 0)
                  throw new Z.ERR_BUFFER_OUT_OF_BOUNDS();
                throw new Z.ERR_OUT_OF_RANGE(r5 || "offset", ">= ".concat(r5 ? 1 : 0, " and <= ").concat(e5), t5);
              }
              Y("ERR_BUFFER_OUT_OF_BOUNDS", function(t5) {
                return t5 ? "".concat(t5, " is outside of buffer bounds") : "Attempt to access memory outside buffer bounds";
              }, RangeError), Y("ERR_INVALID_ARG_TYPE", function(t5, e5) {
                return 'The "'.concat(t5, '" argument must be of type number. Received type ').concat(u(e5));
              }, TypeError), Y("ERR_OUT_OF_RANGE", function(t5, e5, r5) {
                var n4 = 'The value of "'.concat(t5, '" is out of range.'), i3 = r5;
                return Number.isInteger(r5) && Math.abs(r5) > Math.pow(2, 32) ? i3 = W(String(r5)) : "bigint" == typeof r5 && (i3 = String(r5), (r5 > Math.pow(BigInt(2), BigInt(32)) || r5 < -Math.pow(BigInt(2), BigInt(32))) && (i3 = W(i3)), i3 += "n"), n4 + " It must be ".concat(e5, ". Received ").concat(i3);
              }, RangeError);
              var $ = /[^+/0-9A-Za-z-_]/g;
              function Q(t5, e5) {
                var r5;
                e5 = e5 || 1 / 0;
                for (var n4 = t5.length, i3 = null, a2 = [], o2 = 0; o2 < n4; ++o2) {
                  if ((r5 = t5.charCodeAt(o2)) > 55295 && r5 < 57344) {
                    if (!i3) {
                      if (r5 > 56319) {
                        (e5 -= 3) > -1 && a2.push(239, 191, 189);
                        continue;
                      }
                      if (o2 + 1 === n4) {
                        (e5 -= 3) > -1 && a2.push(239, 191, 189);
                        continue;
                      }
                      i3 = r5;
                      continue;
                    }
                    if (r5 < 56320) {
                      (e5 -= 3) > -1 && a2.push(239, 191, 189), i3 = r5;
                      continue;
                    }
                    r5 = 65536 + (i3 - 55296 << 10 | r5 - 56320);
                  } else
                    i3 && (e5 -= 3) > -1 && a2.push(239, 191, 189);
                  if (i3 = null, r5 < 128) {
                    if ((e5 -= 1) < 0)
                      break;
                    a2.push(r5);
                  } else if (r5 < 2048) {
                    if ((e5 -= 2) < 0)
                      break;
                    a2.push(r5 >> 6 | 192, 63 & r5 | 128);
                  } else if (r5 < 65536) {
                    if ((e5 -= 3) < 0)
                      break;
                    a2.push(r5 >> 12 | 224, r5 >> 6 & 63 | 128, 63 & r5 | 128);
                  } else {
                    if (!(r5 < 1114112))
                      throw new Error("Invalid code point");
                    if ((e5 -= 4) < 0)
                      break;
                    a2.push(r5 >> 18 | 240, r5 >> 12 & 63 | 128, r5 >> 6 & 63 | 128, 63 & r5 | 128);
                  }
                }
                return a2;
              }
              function tt(t5) {
                return c.toByteArray(function(t6) {
                  if ((t6 = (t6 = t6.split("=")[0]).trim().replace($, "")).length < 2)
                    return "";
                  for (; t6.length % 4 != 0; )
                    t6 += "=";
                  return t6;
                }(t5));
              }
              function et(t5, e5, r5, n4) {
                var i3;
                for (i3 = 0; i3 < n4 && !(i3 + r5 >= e5.length || i3 >= t5.length); ++i3)
                  e5[i3 + r5] = t5[i3];
                return i3;
              }
              function rt(t5, e5) {
                return t5 instanceof e5 || null != t5 && null != t5.constructor && null != t5.constructor.name && t5.constructor.name === e5.name;
              }
              function nt(t5) {
                return t5 != t5;
              }
              var it = function() {
                for (var t5 = "0123456789abcdef", e5 = new Array(256), r5 = 0; r5 < 16; ++r5)
                  for (var n4 = 16 * r5, i3 = 0; i3 < 16; ++i3)
                    e5[n4 + i3] = t5[r5] + t5[i3];
                return e5;
              }();
              function at(t5) {
                return "undefined" == typeof BigInt ? ot : t5;
              }
              function ot() {
                throw new Error("BigInt not supported");
              }
            }, 2321: function(t4) {
              t4.exports = i2, t4.exports.isMobile = i2, t4.exports.default = i2;
              var e4 = /(android|bb\d+|meego).+mobile|armv7l|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series[46]0|samsungbrowser.*mobile|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i, r4 = /CrOS/, n3 = /android|ipad|playbook|silk/i;
              function i2(t5) {
                t5 || (t5 = {});
                var i3 = t5.ua;
                if (i3 || "undefined" == typeof navigator || (i3 = navigator.userAgent), i3 && i3.headers && "string" == typeof i3.headers["user-agent"] && (i3 = i3.headers["user-agent"]), "string" != typeof i3)
                  return false;
                var a = e4.test(i3) && !r4.test(i3) || !!t5.tablet && n3.test(i3);
                return !a && t5.tablet && t5.featureDetect && navigator && navigator.maxTouchPoints > 1 && -1 !== i3.indexOf("Macintosh") && -1 !== i3.indexOf("Safari") && (a = true), a;
              }
            }, 3910: function(t4, e4) {
              e4.byteLength = function(t5) {
                var e5 = l(t5), r5 = e5[0], n4 = e5[1];
                return 3 * (r5 + n4) / 4 - n4;
              }, e4.toByteArray = function(t5) {
                var e5, r5, a2 = l(t5), o2 = a2[0], s2 = a2[1], u2 = new i2(function(t6, e6, r6) {
                  return 3 * (e6 + r6) / 4 - r6;
                }(0, o2, s2)), c = 0, f2 = s2 > 0 ? o2 - 4 : o2;
                for (r5 = 0; r5 < f2; r5 += 4)
                  e5 = n3[t5.charCodeAt(r5)] << 18 | n3[t5.charCodeAt(r5 + 1)] << 12 | n3[t5.charCodeAt(r5 + 2)] << 6 | n3[t5.charCodeAt(r5 + 3)], u2[c++] = e5 >> 16 & 255, u2[c++] = e5 >> 8 & 255, u2[c++] = 255 & e5;
                return 2 === s2 && (e5 = n3[t5.charCodeAt(r5)] << 2 | n3[t5.charCodeAt(r5 + 1)] >> 4, u2[c++] = 255 & e5), 1 === s2 && (e5 = n3[t5.charCodeAt(r5)] << 10 | n3[t5.charCodeAt(r5 + 1)] << 4 | n3[t5.charCodeAt(r5 + 2)] >> 2, u2[c++] = e5 >> 8 & 255, u2[c++] = 255 & e5), u2;
              }, e4.fromByteArray = function(t5) {
                for (var e5, n4 = t5.length, i3 = n4 % 3, a2 = [], o2 = 16383, s2 = 0, l2 = n4 - i3; s2 < l2; s2 += o2)
                  a2.push(u(t5, s2, s2 + o2 > l2 ? l2 : s2 + o2));
                return 1 === i3 ? (e5 = t5[n4 - 1], a2.push(r4[e5 >> 2] + r4[e5 << 4 & 63] + "==")) : 2 === i3 && (e5 = (t5[n4 - 2] << 8) + t5[n4 - 1], a2.push(r4[e5 >> 10] + r4[e5 >> 4 & 63] + r4[e5 << 2 & 63] + "=")), a2.join("");
              };
              for (var r4 = [], n3 = [], i2 = "undefined" != typeof Uint8Array ? Uint8Array : Array, a = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", o = 0, s = a.length; o < s; ++o)
                r4[o] = a[o], n3[a.charCodeAt(o)] = o;
              function l(t5) {
                var e5 = t5.length;
                if (e5 % 4 > 0)
                  throw new Error("Invalid string. Length must be a multiple of 4");
                var r5 = t5.indexOf("=");
                return -1 === r5 && (r5 = e5), [r5, r5 === e5 ? 0 : 4 - r5 % 4];
              }
              function u(t5, e5, n4) {
                for (var i3, a2, o2 = [], s2 = e5; s2 < n4; s2 += 3)
                  i3 = (t5[s2] << 16 & 16711680) + (t5[s2 + 1] << 8 & 65280) + (255 & t5[s2 + 2]), o2.push(r4[(a2 = i3) >> 18 & 63] + r4[a2 >> 12 & 63] + r4[a2 >> 6 & 63] + r4[63 & a2]);
                return o2.join("");
              }
              n3["-".charCodeAt(0)] = 62, n3["_".charCodeAt(0)] = 63;
            }, 3187: function(t4, e4) {
              e4.read = function(t5, e5, r4, n3, i2) {
                var a, o, s = 8 * i2 - n3 - 1, l = (1 << s) - 1, u = l >> 1, c = -7, f2 = r4 ? i2 - 1 : 0, h = r4 ? -1 : 1, p2 = t5[e5 + f2];
                for (f2 += h, a = p2 & (1 << -c) - 1, p2 >>= -c, c += s; c > 0; a = 256 * a + t5[e5 + f2], f2 += h, c -= 8)
                  ;
                for (o = a & (1 << -c) - 1, a >>= -c, c += n3; c > 0; o = 256 * o + t5[e5 + f2], f2 += h, c -= 8)
                  ;
                if (0 === a)
                  a = 1 - u;
                else {
                  if (a === l)
                    return o ? NaN : 1 / 0 * (p2 ? -1 : 1);
                  o += Math.pow(2, n3), a -= u;
                }
                return (p2 ? -1 : 1) * o * Math.pow(2, a - n3);
              }, e4.write = function(t5, e5, r4, n3, i2, a) {
                var o, s, l, u = 8 * a - i2 - 1, c = (1 << u) - 1, f2 = c >> 1, h = 23 === i2 ? Math.pow(2, -24) - Math.pow(2, -77) : 0, p2 = n3 ? 0 : a - 1, d2 = n3 ? 1 : -1, v = e5 < 0 || 0 === e5 && 1 / e5 < 0 ? 1 : 0;
                for (e5 = Math.abs(e5), isNaN(e5) || e5 === 1 / 0 ? (s = isNaN(e5) ? 1 : 0, o = c) : (o = Math.floor(Math.log(e5) / Math.LN2), e5 * (l = Math.pow(2, -o)) < 1 && (o--, l *= 2), (e5 += o + f2 >= 1 ? h / l : h * Math.pow(2, 1 - f2)) * l >= 2 && (o++, l /= 2), o + f2 >= c ? (s = 0, o = c) : o + f2 >= 1 ? (s = (e5 * l - 1) * Math.pow(2, i2), o += f2) : (s = e5 * Math.pow(2, f2 - 1) * Math.pow(2, i2), o = 0)); i2 >= 8; t5[r4 + p2] = 255 & s, p2 += d2, s /= 256, i2 -= 8)
                  ;
                for (o = o << i2 | s, u += i2; u > 0; t5[r4 + p2] = 255 & o, p2 += d2, o /= 256, u -= 8)
                  ;
                t5[r4 + p2 - d2] |= 128 * v;
              };
            }, 1152: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = (t5 = t5 || {}).eye || [0, 0, 1], r5 = t5.center || [0, 0, 0], s2 = t5.up || [0, 1, 0], l = t5.distanceLimits || [0, 1 / 0], u = t5.mode || "turntable", c = n3(), f2 = i2(), h = a();
                return c.setDistanceLimits(l[0], l[1]), c.lookAt(0, e5, r5, s2), f2.setDistanceLimits(l[0], l[1]), f2.lookAt(0, e5, r5, s2), h.setDistanceLimits(l[0], l[1]), h.lookAt(0, e5, r5, s2), new o({ turntable: c, orbit: f2, matrix: h }, u);
              };
              var n3 = r4(3440), i2 = r4(7774), a = r4(9298);
              function o(t5, e5) {
                this._controllerNames = Object.keys(t5), this._controllerList = this._controllerNames.map(function(e6) {
                  return t5[e6];
                }), this._mode = e5, this._active = t5[e5], this._active || (this._mode = "turntable", this._active = t5.turntable), this.modes = this._controllerNames, this.computedMatrix = this._active.computedMatrix, this.computedEye = this._active.computedEye, this.computedUp = this._active.computedUp, this.computedCenter = this._active.computedCenter, this.computedRadius = this._active.computedRadius;
              }
              var s = o.prototype;
              s.flush = function(t5) {
                for (var e5 = this._controllerList, r5 = 0; r5 < e5.length; ++r5)
                  e5[r5].flush(t5);
              }, s.idle = function(t5) {
                for (var e5 = this._controllerList, r5 = 0; r5 < e5.length; ++r5)
                  e5[r5].idle(t5);
              }, s.lookAt = function(t5, e5, r5, n4) {
                for (var i3 = this._controllerList, a2 = 0; a2 < i3.length; ++a2)
                  i3[a2].lookAt(t5, e5, r5, n4);
              }, s.rotate = function(t5, e5, r5, n4) {
                for (var i3 = this._controllerList, a2 = 0; a2 < i3.length; ++a2)
                  i3[a2].rotate(t5, e5, r5, n4);
              }, s.pan = function(t5, e5, r5, n4) {
                for (var i3 = this._controllerList, a2 = 0; a2 < i3.length; ++a2)
                  i3[a2].pan(t5, e5, r5, n4);
              }, s.translate = function(t5, e5, r5, n4) {
                for (var i3 = this._controllerList, a2 = 0; a2 < i3.length; ++a2)
                  i3[a2].translate(t5, e5, r5, n4);
              }, s.setMatrix = function(t5, e5) {
                for (var r5 = this._controllerList, n4 = 0; n4 < r5.length; ++n4)
                  r5[n4].setMatrix(t5, e5);
              }, s.setDistanceLimits = function(t5, e5) {
                for (var r5 = this._controllerList, n4 = 0; n4 < r5.length; ++n4)
                  r5[n4].setDistanceLimits(t5, e5);
              }, s.setDistance = function(t5, e5) {
                for (var r5 = this._controllerList, n4 = 0; n4 < r5.length; ++n4)
                  r5[n4].setDistance(t5, e5);
              }, s.recalcMatrix = function(t5) {
                this._active.recalcMatrix(t5);
              }, s.getDistance = function(t5) {
                return this._active.getDistance(t5);
              }, s.getDistanceLimits = function(t5) {
                return this._active.getDistanceLimits(t5);
              }, s.lastT = function() {
                return this._active.lastT();
              }, s.setMode = function(t5) {
                if (t5 !== this._mode) {
                  var e5 = this._controllerNames.indexOf(t5);
                  if (!(e5 < 0)) {
                    var r5 = this._active, n4 = this._controllerList[e5], i3 = Math.max(r5.lastT(), n4.lastT());
                    r5.recalcMatrix(i3), n4.setMatrix(i3, r5.computedMatrix), this._active = n4, this._mode = t5, this.computedMatrix = this._active.computedMatrix, this.computedEye = this._active.computedEye, this.computedUp = this._active.computedUp, this.computedCenter = this._active.computedCenter, this.computedRadius = this._active.computedRadius;
                  }
                }
              }, s.getMode = function() {
                return this._mode;
              };
            }, 8126: function(t4, e4, r4) {
              var n3 = "undefined" == typeof WeakMap ? r4(5346) : WeakMap, i2 = r4(5827), a = r4(2944), o = new n3();
              t4.exports = function(t5) {
                var e5 = o.get(t5), r5 = e5 && (e5._triangleBuffer.handle || e5._triangleBuffer.buffer);
                if (!r5 || !t5.isBuffer(r5)) {
                  var n4 = i2(t5, new Float32Array([-1, -1, -1, 4, 4, -1]));
                  (e5 = a(t5, [{ buffer: n4, type: t5.FLOAT, size: 2 }]))._triangleBuffer = n4, o.set(t5, e5);
                }
                e5.bind(), t5.drawArrays(t5.TRIANGLES, 0, 3), e5.unbind();
              };
            }, 8008: function(t4, e4, r4) {
              var n3 = r4(4930);
              t4.exports = function(t5, e5, r5) {
                e5 = "number" == typeof e5 ? e5 : 1, r5 = r5 || ": ";
                var i2 = t5.split(/\r?\n/), a = String(i2.length + e5 - 1).length;
                return i2.map(function(t6, i3) {
                  var o = i3 + e5, s = String(o).length;
                  return n3(o, a - s) + r5 + t6;
                }).join("\n");
              };
            }, 2153: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = t5.length;
                if (0 === e5)
                  return [];
                if (1 === e5)
                  return [0];
                for (var r5 = t5[0].length, n4 = [t5[0]], a = [0], o = 1; o < e5; ++o)
                  if (n4.push(t5[o]), i2(n4, r5)) {
                    if (a.push(o), a.length === r5 + 1)
                      return a;
                  } else
                    n4.pop();
                return a;
              };
              var n3 = r4(417);
              function i2(t5, e5) {
                for (var r5 = new Array(e5 + 1), i3 = 0; i3 < t5.length; ++i3)
                  r5[i3] = t5[i3];
                for (i3 = 0; i3 <= t5.length; ++i3) {
                  for (var a = t5.length; a <= e5; ++a) {
                    for (var o = new Array(e5), s = 0; s < e5; ++s)
                      o[s] = Math.pow(a + 1 - i3, s);
                    r5[a] = o;
                  }
                  if (n3.apply(void 0, r5))
                    return true;
                }
                return false;
              }
            }, 4653: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                return n3(e5).filter(function(r5) {
                  for (var n4 = new Array(r5.length), a = 0; a < r5.length; ++a)
                    n4[a] = e5[r5[a]];
                  return i2(n4) * t5 < 1;
                });
              };
              var n3 = r4(4419), i2 = r4(1778);
            }, 2350: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                return i2(n3(t5, e5));
              };
              var n3 = r4(4653), i2 = r4(8691);
            }, 7896: function(t4) {
              t4.exports = function(t5) {
                return atob(t5);
              };
            }, 957: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                for (var r5 = e5.length, a = new Array(r5 + 1), o = 0; o < r5; ++o) {
                  for (var s = new Array(r5 + 1), l = 0; l <= r5; ++l)
                    s[l] = t5[l][o];
                  a[o] = s;
                }
                for (a[r5] = new Array(r5 + 1), o = 0; o <= r5; ++o)
                  a[r5][o] = 1;
                var u = new Array(r5 + 1);
                for (o = 0; o < r5; ++o)
                  u[o] = e5[o];
                u[r5] = 1;
                var c = n3(a, u), f2 = i2(c[r5 + 1]);
                0 === f2 && (f2 = 1);
                var h = new Array(r5 + 1);
                for (o = 0; o <= r5; ++o)
                  h[o] = i2(c[o]) / f2;
                return h;
              };
              var n3 = r4(6606);
              function i2(t5) {
                for (var e5 = 0, r5 = 0; r5 < t5.length; ++r5)
                  e5 += t5[r5];
                return e5;
              }
            }, 1539: function(t4, e4, r4) {
              var n3 = r4(8524);
              t4.exports = function(t5, e5) {
                return n3(t5[0].mul(e5[1]).add(e5[0].mul(t5[1])), t5[1].mul(e5[1]));
              };
            }, 8846: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0].mul(e4[1]).cmp(e4[0].mul(t5[1]));
              };
            }, 9189: function(t4, e4, r4) {
              var n3 = r4(8524);
              t4.exports = function(t5, e5) {
                return n3(t5[0].mul(e5[1]), t5[1].mul(e5[0]));
              };
            }, 5125: function(t4, e4, r4) {
              var n3 = r4(234), i2 = r4(3218), a = r4(5514), o = r4(2813), s = r4(8524), l = r4(9189);
              t4.exports = function t5(e5, r5) {
                if (n3(e5))
                  return r5 ? l(e5, t5(r5)) : [e5[0].clone(), e5[1].clone()];
                var u, c, f2 = 0;
                if (i2(e5))
                  u = e5.clone();
                else if ("string" == typeof e5)
                  u = o(e5);
                else {
                  if (0 === e5)
                    return [a(0), a(1)];
                  if (e5 === Math.floor(e5))
                    u = a(e5);
                  else {
                    for (; e5 !== Math.floor(e5); )
                      e5 *= Math.pow(2, 256), f2 -= 256;
                    u = a(e5);
                  }
                }
                if (n3(r5))
                  u.mul(r5[1]), c = r5[0].clone();
                else if (i2(r5))
                  c = r5.clone();
                else if ("string" == typeof r5)
                  c = o(r5);
                else if (r5)
                  if (r5 === Math.floor(r5))
                    c = a(r5);
                  else {
                    for (; r5 !== Math.floor(r5); )
                      r5 *= Math.pow(2, 256), f2 += 256;
                    c = a(r5);
                  }
                else
                  c = a(1);
                return f2 > 0 ? u = u.ushln(f2) : f2 < 0 && (c = c.ushln(-f2)), s(u, c);
              };
            }, 234: function(t4, e4, r4) {
              var n3 = r4(3218);
              t4.exports = function(t5) {
                return Array.isArray(t5) && 2 === t5.length && n3(t5[0]) && n3(t5[1]);
              };
            }, 4275: function(t4, e4, r4) {
              var n3 = r4(1928);
              t4.exports = function(t5) {
                return t5.cmp(new n3(0));
              };
            }, 9958: function(t4, e4, r4) {
              var n3 = r4(4275);
              t4.exports = function(t5) {
                var e5 = t5.length, r5 = t5.words, i2 = 0;
                if (1 === e5)
                  i2 = r5[0];
                else if (2 === e5)
                  i2 = r5[0] + 67108864 * r5[1];
                else
                  for (var a = 0; a < e5; a++) {
                    i2 += r5[a] * Math.pow(67108864, a);
                  }
                return n3(t5) * i2;
              };
            }, 1112: function(t4, e4, r4) {
              var n3 = r4(8362), i2 = r4(2288).countTrailingZeros;
              t4.exports = function(t5) {
                var e5 = i2(n3.lo(t5));
                if (e5 < 32)
                  return e5;
                var r5 = i2(n3.hi(t5));
                return r5 > 20 ? 52 : r5 + 32;
              };
            }, 3218: function(t4, e4, r4) {
              r4(1928), t4.exports = function(t5) {
                return t5 && "object" == typeof t5 && Boolean(t5.words);
              };
            }, 5514: function(t4, e4, r4) {
              var n3 = r4(1928), i2 = r4(8362);
              t4.exports = function(t5) {
                var e5 = i2.exponent(t5);
                return e5 < 52 ? new n3(t5) : new n3(t5 * Math.pow(2, 52 - e5)).ushln(e5 - 52);
              };
            }, 8524: function(t4, e4, r4) {
              var n3 = r4(5514), i2 = r4(4275);
              t4.exports = function(t5, e5) {
                var r5 = i2(t5), a = i2(e5);
                if (0 === r5)
                  return [n3(0), n3(1)];
                if (0 === a)
                  return [n3(0), n3(0)];
                a < 0 && (t5 = t5.neg(), e5 = e5.neg());
                var o = t5.gcd(e5);
                return o.cmpn(1) ? [t5.div(o), e5.div(o)] : [t5, e5];
              };
            }, 2813: function(t4, e4, r4) {
              var n3 = r4(1928);
              t4.exports = function(t5) {
                return new n3(t5);
              };
            }, 3962: function(t4, e4, r4) {
              var n3 = r4(8524);
              t4.exports = function(t5, e5) {
                return n3(t5[0].mul(e5[0]), t5[1].mul(e5[1]));
              };
            }, 4951: function(t4, e4, r4) {
              var n3 = r4(4275);
              t4.exports = function(t5) {
                return n3(t5[0]) * n3(t5[1]);
              };
            }, 4354: function(t4, e4, r4) {
              var n3 = r4(8524);
              t4.exports = function(t5, e5) {
                return n3(t5[0].mul(e5[1]).sub(t5[1].mul(e5[0])), t5[1].mul(e5[1]));
              };
            }, 7999: function(t4, e4, r4) {
              var n3 = r4(9958), i2 = r4(1112);
              t4.exports = function(t5) {
                var e5 = t5[0], r5 = t5[1];
                if (0 === e5.cmpn(0))
                  return 0;
                var a = e5.abs().divmod(r5.abs()), o = a.div, s = n3(o), l = a.mod, u = e5.negative !== r5.negative ? -1 : 1;
                if (0 === l.cmpn(0))
                  return u * s;
                if (s) {
                  var c = i2(s) + 4, f2 = n3(l.ushln(c).divRound(r5));
                  return u * (s + f2 * Math.pow(2, -c));
                }
                var h = r5.bitLength() - l.bitLength() + 53;
                return f2 = n3(l.ushln(h).divRound(r5)), h < 1023 ? u * f2 * Math.pow(2, -h) : u * (f2 *= Math.pow(2, -1023)) * Math.pow(2, 1023 - h);
              };
            }, 5070: function(t4) {
              function e4(t5, e5, r5, n4, i3) {
                for (var a2 = i3 + 1; n4 <= i3; ) {
                  var o2 = n4 + i3 >>> 1, s = t5[o2];
                  (void 0 !== r5 ? r5(s, e5) : s - e5) >= 0 ? (a2 = o2, i3 = o2 - 1) : n4 = o2 + 1;
                }
                return a2;
              }
              function r4(t5, e5, r5, n4, i3) {
                for (var a2 = i3 + 1; n4 <= i3; ) {
                  var o2 = n4 + i3 >>> 1, s = t5[o2];
                  (void 0 !== r5 ? r5(s, e5) : s - e5) > 0 ? (a2 = o2, i3 = o2 - 1) : n4 = o2 + 1;
                }
                return a2;
              }
              function n3(t5, e5, r5, n4, i3) {
                for (var a2 = n4 - 1; n4 <= i3; ) {
                  var o2 = n4 + i3 >>> 1, s = t5[o2];
                  (void 0 !== r5 ? r5(s, e5) : s - e5) < 0 ? (a2 = o2, n4 = o2 + 1) : i3 = o2 - 1;
                }
                return a2;
              }
              function i2(t5, e5, r5, n4, i3) {
                for (var a2 = n4 - 1; n4 <= i3; ) {
                  var o2 = n4 + i3 >>> 1, s = t5[o2];
                  (void 0 !== r5 ? r5(s, e5) : s - e5) <= 0 ? (a2 = o2, n4 = o2 + 1) : i3 = o2 - 1;
                }
                return a2;
              }
              function a(t5, e5, r5, n4, i3) {
                for (; n4 <= i3; ) {
                  var a2 = n4 + i3 >>> 1, o2 = t5[a2], s = void 0 !== r5 ? r5(o2, e5) : o2 - e5;
                  if (0 === s)
                    return a2;
                  s <= 0 ? n4 = a2 + 1 : i3 = a2 - 1;
                }
                return -1;
              }
              function o(t5, e5, r5, n4, i3, a2) {
                return "function" == typeof r5 ? a2(t5, e5, r5, void 0 === n4 ? 0 : 0 | n4, void 0 === i3 ? t5.length - 1 : 0 | i3) : a2(t5, e5, void 0, void 0 === r5 ? 0 : 0 | r5, void 0 === n4 ? t5.length - 1 : 0 | n4);
              }
              t4.exports = { ge: function(t5, r5, n4, i3, a2) {
                return o(t5, r5, n4, i3, a2, e4);
              }, gt: function(t5, e5, n4, i3, a2) {
                return o(t5, e5, n4, i3, a2, r4);
              }, lt: function(t5, e5, r5, i3, a2) {
                return o(t5, e5, r5, i3, a2, n3);
              }, le: function(t5, e5, r5, n4, a2) {
                return o(t5, e5, r5, n4, a2, i2);
              }, eq: function(t5, e5, r5, n4, i3) {
                return o(t5, e5, r5, n4, i3, a);
              } };
            }, 2288: function(t4, e4) {
              function r4(t5) {
                var e5 = 32;
                return (t5 &= -t5) && e5--, 65535 & t5 && (e5 -= 16), 16711935 & t5 && (e5 -= 8), 252645135 & t5 && (e5 -= 4), 858993459 & t5 && (e5 -= 2), 1431655765 & t5 && (e5 -= 1), e5;
              }
              e4.INT_BITS = 32, e4.INT_MAX = 2147483647, e4.INT_MIN = -1 << 31, e4.sign = function(t5) {
                return (t5 > 0) - (t5 < 0);
              }, e4.abs = function(t5) {
                var e5 = t5 >> 31;
                return (t5 ^ e5) - e5;
              }, e4.min = function(t5, e5) {
                return e5 ^ (t5 ^ e5) & -(t5 < e5);
              }, e4.max = function(t5, e5) {
                return t5 ^ (t5 ^ e5) & -(t5 < e5);
              }, e4.isPow2 = function(t5) {
                return !(t5 & t5 - 1 || !t5);
              }, e4.log2 = function(t5) {
                var e5, r5;
                return e5 = (t5 > 65535) << 4, e5 |= r5 = ((t5 >>>= e5) > 255) << 3, e5 |= r5 = ((t5 >>>= r5) > 15) << 2, (e5 |= r5 = ((t5 >>>= r5) > 3) << 1) | (t5 >>>= r5) >> 1;
              }, e4.log10 = function(t5) {
                return t5 >= 1e9 ? 9 : t5 >= 1e8 ? 8 : t5 >= 1e7 ? 7 : t5 >= 1e6 ? 6 : t5 >= 1e5 ? 5 : t5 >= 1e4 ? 4 : t5 >= 1e3 ? 3 : t5 >= 100 ? 2 : t5 >= 10 ? 1 : 0;
              }, e4.popCount = function(t5) {
                return 16843009 * ((t5 = (858993459 & (t5 -= t5 >>> 1 & 1431655765)) + (t5 >>> 2 & 858993459)) + (t5 >>> 4) & 252645135) >>> 24;
              }, e4.countTrailingZeros = r4, e4.nextPow2 = function(t5) {
                return t5 += 0 === t5, --t5, t5 |= t5 >>> 1, t5 |= t5 >>> 2, t5 |= t5 >>> 4, 1 + ((t5 |= t5 >>> 8) | t5 >>> 16);
              }, e4.prevPow2 = function(t5) {
                return t5 |= t5 >>> 1, t5 |= t5 >>> 2, t5 |= t5 >>> 4, t5 |= t5 >>> 8, (t5 |= t5 >>> 16) - (t5 >>> 1);
              }, e4.parity = function(t5) {
                return t5 ^= t5 >>> 16, t5 ^= t5 >>> 8, t5 ^= t5 >>> 4, 27030 >>> (t5 &= 15) & 1;
              };
              var n3 = new Array(256);
              !function(t5) {
                for (var e5 = 0; e5 < 256; ++e5) {
                  var r5 = e5, n4 = e5, i2 = 7;
                  for (r5 >>>= 1; r5; r5 >>>= 1)
                    n4 <<= 1, n4 |= 1 & r5, --i2;
                  t5[e5] = n4 << i2 & 255;
                }
              }(n3), e4.reverse = function(t5) {
                return n3[255 & t5] << 24 | n3[t5 >>> 8 & 255] << 16 | n3[t5 >>> 16 & 255] << 8 | n3[t5 >>> 24 & 255];
              }, e4.interleave2 = function(t5, e5) {
                return (t5 = 1431655765 & ((t5 = 858993459 & ((t5 = 252645135 & ((t5 = 16711935 & ((t5 &= 65535) | t5 << 8)) | t5 << 4)) | t5 << 2)) | t5 << 1)) | (e5 = 1431655765 & ((e5 = 858993459 & ((e5 = 252645135 & ((e5 = 16711935 & ((e5 &= 65535) | e5 << 8)) | e5 << 4)) | e5 << 2)) | e5 << 1)) << 1;
              }, e4.deinterleave2 = function(t5, e5) {
                return (t5 = 65535 & ((t5 = 16711935 & ((t5 = 252645135 & ((t5 = 858993459 & ((t5 = t5 >>> e5 & 1431655765) | t5 >>> 1)) | t5 >>> 2)) | t5 >>> 4)) | t5 >>> 16)) << 16 >> 16;
              }, e4.interleave3 = function(t5, e5, r5) {
                return t5 = 1227133513 & ((t5 = 3272356035 & ((t5 = 251719695 & ((t5 = 4278190335 & ((t5 &= 1023) | t5 << 16)) | t5 << 8)) | t5 << 4)) | t5 << 2), (t5 |= (e5 = 1227133513 & ((e5 = 3272356035 & ((e5 = 251719695 & ((e5 = 4278190335 & ((e5 &= 1023) | e5 << 16)) | e5 << 8)) | e5 << 4)) | e5 << 2)) << 1) | (r5 = 1227133513 & ((r5 = 3272356035 & ((r5 = 251719695 & ((r5 = 4278190335 & ((r5 &= 1023) | r5 << 16)) | r5 << 8)) | r5 << 4)) | r5 << 2)) << 2;
              }, e4.deinterleave3 = function(t5, e5) {
                return (t5 = 1023 & ((t5 = 4278190335 & ((t5 = 251719695 & ((t5 = 3272356035 & ((t5 = t5 >>> e5 & 1227133513) | t5 >>> 2)) | t5 >>> 4)) | t5 >>> 8)) | t5 >>> 16)) << 22 >> 22;
              }, e4.nextCombination = function(t5) {
                var e5 = t5 | t5 - 1;
                return e5 + 1 | (~e5 & -~e5) - 1 >>> r4(t5) + 1;
              };
            }, 1928: function(t4, e4, r4) {
              !function(t5, e5) {
                function n3(t6, e6) {
                  if (!t6)
                    throw new Error(e6 || "Assertion failed");
                }
                function i2(t6, e6) {
                  t6.super_ = e6;
                  var r5 = function() {
                  };
                  r5.prototype = e6.prototype, t6.prototype = new r5(), t6.prototype.constructor = t6;
                }
                function a(t6, e6, r5) {
                  if (a.isBN(t6))
                    return t6;
                  this.negative = 0, this.words = null, this.length = 0, this.red = null, null !== t6 && ("le" !== e6 && "be" !== e6 || (r5 = e6, e6 = 10), this._init(t6 || 0, e6 || 10, r5 || "be"));
                }
                var o;
                "object" == typeof t5 ? t5.exports = a : e5.BN = a, a.BN = a, a.wordSize = 26;
                try {
                  o = "undefined" != typeof window && void 0 !== window.Buffer ? window.Buffer : r4(6601).Buffer;
                } catch (t6) {
                }
                function s(t6, e6) {
                  var r5 = t6.charCodeAt(e6);
                  return r5 >= 65 && r5 <= 70 ? r5 - 55 : r5 >= 97 && r5 <= 102 ? r5 - 87 : r5 - 48 & 15;
                }
                function l(t6, e6, r5) {
                  var n4 = s(t6, r5);
                  return r5 - 1 >= e6 && (n4 |= s(t6, r5 - 1) << 4), n4;
                }
                function u(t6, e6, r5, n4) {
                  for (var i3 = 0, a2 = Math.min(t6.length, r5), o2 = e6; o2 < a2; o2++) {
                    var s2 = t6.charCodeAt(o2) - 48;
                    i3 *= n4, i3 += s2 >= 49 ? s2 - 49 + 10 : s2 >= 17 ? s2 - 17 + 10 : s2;
                  }
                  return i3;
                }
                a.isBN = function(t6) {
                  return t6 instanceof a || null !== t6 && "object" == typeof t6 && t6.constructor.wordSize === a.wordSize && Array.isArray(t6.words);
                }, a.max = function(t6, e6) {
                  return t6.cmp(e6) > 0 ? t6 : e6;
                }, a.min = function(t6, e6) {
                  return t6.cmp(e6) < 0 ? t6 : e6;
                }, a.prototype._init = function(t6, e6, r5) {
                  if ("number" == typeof t6)
                    return this._initNumber(t6, e6, r5);
                  if ("object" == typeof t6)
                    return this._initArray(t6, e6, r5);
                  "hex" === e6 && (e6 = 16), n3(e6 === (0 | e6) && e6 >= 2 && e6 <= 36);
                  var i3 = 0;
                  "-" === (t6 = t6.toString().replace(/\s+/g, ""))[0] && (i3++, this.negative = 1), i3 < t6.length && (16 === e6 ? this._parseHex(t6, i3, r5) : (this._parseBase(t6, e6, i3), "le" === r5 && this._initArray(this.toArray(), e6, r5)));
                }, a.prototype._initNumber = function(t6, e6, r5) {
                  t6 < 0 && (this.negative = 1, t6 = -t6), t6 < 67108864 ? (this.words = [67108863 & t6], this.length = 1) : t6 < 4503599627370496 ? (this.words = [67108863 & t6, t6 / 67108864 & 67108863], this.length = 2) : (n3(t6 < 9007199254740992), this.words = [67108863 & t6, t6 / 67108864 & 67108863, 1], this.length = 3), "le" === r5 && this._initArray(this.toArray(), e6, r5);
                }, a.prototype._initArray = function(t6, e6, r5) {
                  if (n3("number" == typeof t6.length), t6.length <= 0)
                    return this.words = [0], this.length = 1, this;
                  this.length = Math.ceil(t6.length / 3), this.words = new Array(this.length);
                  for (var i3 = 0; i3 < this.length; i3++)
                    this.words[i3] = 0;
                  var a2, o2, s2 = 0;
                  if ("be" === r5)
                    for (i3 = t6.length - 1, a2 = 0; i3 >= 0; i3 -= 3)
                      o2 = t6[i3] | t6[i3 - 1] << 8 | t6[i3 - 2] << 16, this.words[a2] |= o2 << s2 & 67108863, this.words[a2 + 1] = o2 >>> 26 - s2 & 67108863, (s2 += 24) >= 26 && (s2 -= 26, a2++);
                  else if ("le" === r5)
                    for (i3 = 0, a2 = 0; i3 < t6.length; i3 += 3)
                      o2 = t6[i3] | t6[i3 + 1] << 8 | t6[i3 + 2] << 16, this.words[a2] |= o2 << s2 & 67108863, this.words[a2 + 1] = o2 >>> 26 - s2 & 67108863, (s2 += 24) >= 26 && (s2 -= 26, a2++);
                  return this.strip();
                }, a.prototype._parseHex = function(t6, e6, r5) {
                  this.length = Math.ceil((t6.length - e6) / 6), this.words = new Array(this.length);
                  for (var n4 = 0; n4 < this.length; n4++)
                    this.words[n4] = 0;
                  var i3, a2 = 0, o2 = 0;
                  if ("be" === r5)
                    for (n4 = t6.length - 1; n4 >= e6; n4 -= 2)
                      i3 = l(t6, e6, n4) << a2, this.words[o2] |= 67108863 & i3, a2 >= 18 ? (a2 -= 18, o2 += 1, this.words[o2] |= i3 >>> 26) : a2 += 8;
                  else
                    for (n4 = (t6.length - e6) % 2 == 0 ? e6 + 1 : e6; n4 < t6.length; n4 += 2)
                      i3 = l(t6, e6, n4) << a2, this.words[o2] |= 67108863 & i3, a2 >= 18 ? (a2 -= 18, o2 += 1, this.words[o2] |= i3 >>> 26) : a2 += 8;
                  this.strip();
                }, a.prototype._parseBase = function(t6, e6, r5) {
                  this.words = [0], this.length = 1;
                  for (var n4 = 0, i3 = 1; i3 <= 67108863; i3 *= e6)
                    n4++;
                  n4--, i3 = i3 / e6 | 0;
                  for (var a2 = t6.length - r5, o2 = a2 % n4, s2 = Math.min(a2, a2 - o2) + r5, l2 = 0, c2 = r5; c2 < s2; c2 += n4)
                    l2 = u(t6, c2, c2 + n4, e6), this.imuln(i3), this.words[0] + l2 < 67108864 ? this.words[0] += l2 : this._iaddn(l2);
                  if (0 !== o2) {
                    var f3 = 1;
                    for (l2 = u(t6, c2, t6.length, e6), c2 = 0; c2 < o2; c2++)
                      f3 *= e6;
                    this.imuln(f3), this.words[0] + l2 < 67108864 ? this.words[0] += l2 : this._iaddn(l2);
                  }
                  this.strip();
                }, a.prototype.copy = function(t6) {
                  t6.words = new Array(this.length);
                  for (var e6 = 0; e6 < this.length; e6++)
                    t6.words[e6] = this.words[e6];
                  t6.length = this.length, t6.negative = this.negative, t6.red = this.red;
                }, a.prototype.clone = function() {
                  var t6 = new a(null);
                  return this.copy(t6), t6;
                }, a.prototype._expand = function(t6) {
                  for (; this.length < t6; )
                    this.words[this.length++] = 0;
                  return this;
                }, a.prototype.strip = function() {
                  for (; this.length > 1 && 0 === this.words[this.length - 1]; )
                    this.length--;
                  return this._normSign();
                }, a.prototype._normSign = function() {
                  return 1 === this.length && 0 === this.words[0] && (this.negative = 0), this;
                }, a.prototype.inspect = function() {
                  return (this.red ? "<BN-R: " : "<BN: ") + this.toString(16) + ">";
                };
                var c = ["", "0", "00", "000", "0000", "00000", "000000", "0000000", "00000000", "000000000", "0000000000", "00000000000", "000000000000", "0000000000000", "00000000000000", "000000000000000", "0000000000000000", "00000000000000000", "000000000000000000", "0000000000000000000", "00000000000000000000", "000000000000000000000", "0000000000000000000000", "00000000000000000000000", "000000000000000000000000", "0000000000000000000000000"], f2 = [0, 0, 25, 16, 12, 11, 10, 9, 8, 8, 7, 7, 7, 7, 6, 6, 6, 6, 6, 6, 6, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5], h = [0, 0, 33554432, 43046721, 16777216, 48828125, 60466176, 40353607, 16777216, 43046721, 1e7, 19487171, 35831808, 62748517, 7529536, 11390625, 16777216, 24137569, 34012224, 47045881, 64e6, 4084101, 5153632, 6436343, 7962624, 9765625, 11881376, 14348907, 17210368, 20511149, 243e5, 28629151, 33554432, 39135393, 45435424, 52521875, 60466176];
                function p2(t6, e6, r5) {
                  r5.negative = e6.negative ^ t6.negative;
                  var n4 = t6.length + e6.length | 0;
                  r5.length = n4, n4 = n4 - 1 | 0;
                  var i3 = 0 | t6.words[0], a2 = 0 | e6.words[0], o2 = i3 * a2, s2 = 67108863 & o2, l2 = o2 / 67108864 | 0;
                  r5.words[0] = s2;
                  for (var u2 = 1; u2 < n4; u2++) {
                    for (var c2 = l2 >>> 26, f3 = 67108863 & l2, h2 = Math.min(u2, e6.length - 1), p3 = Math.max(0, u2 - t6.length + 1); p3 <= h2; p3++) {
                      var d3 = u2 - p3 | 0;
                      c2 += (o2 = (i3 = 0 | t6.words[d3]) * (a2 = 0 | e6.words[p3]) + f3) / 67108864 | 0, f3 = 67108863 & o2;
                    }
                    r5.words[u2] = 0 | f3, l2 = 0 | c2;
                  }
                  return 0 !== l2 ? r5.words[u2] = 0 | l2 : r5.length--, r5.strip();
                }
                a.prototype.toString = function(t6, e6) {
                  var r5;
                  if (e6 = 0 | e6 || 1, 16 === (t6 = t6 || 10) || "hex" === t6) {
                    r5 = "";
                    for (var i3 = 0, a2 = 0, o2 = 0; o2 < this.length; o2++) {
                      var s2 = this.words[o2], l2 = (16777215 & (s2 << i3 | a2)).toString(16);
                      r5 = 0 != (a2 = s2 >>> 24 - i3 & 16777215) || o2 !== this.length - 1 ? c[6 - l2.length] + l2 + r5 : l2 + r5, (i3 += 2) >= 26 && (i3 -= 26, o2--);
                    }
                    for (0 !== a2 && (r5 = a2.toString(16) + r5); r5.length % e6 != 0; )
                      r5 = "0" + r5;
                    return 0 !== this.negative && (r5 = "-" + r5), r5;
                  }
                  if (t6 === (0 | t6) && t6 >= 2 && t6 <= 36) {
                    var u2 = f2[t6], p3 = h[t6];
                    r5 = "";
                    var d3 = this.clone();
                    for (d3.negative = 0; !d3.isZero(); ) {
                      var v2 = d3.modn(p3).toString(t6);
                      r5 = (d3 = d3.idivn(p3)).isZero() ? v2 + r5 : c[u2 - v2.length] + v2 + r5;
                    }
                    for (this.isZero() && (r5 = "0" + r5); r5.length % e6 != 0; )
                      r5 = "0" + r5;
                    return 0 !== this.negative && (r5 = "-" + r5), r5;
                  }
                  n3(false, "Base should be between 2 and 36");
                }, a.prototype.toNumber = function() {
                  var t6 = this.words[0];
                  return 2 === this.length ? t6 += 67108864 * this.words[1] : 3 === this.length && 1 === this.words[2] ? t6 += 4503599627370496 + 67108864 * this.words[1] : this.length > 2 && n3(false, "Number can only safely store up to 53 bits"), 0 !== this.negative ? -t6 : t6;
                }, a.prototype.toJSON = function() {
                  return this.toString(16);
                }, a.prototype.toBuffer = function(t6, e6) {
                  return n3(void 0 !== o), this.toArrayLike(o, t6, e6);
                }, a.prototype.toArray = function(t6, e6) {
                  return this.toArrayLike(Array, t6, e6);
                }, a.prototype.toArrayLike = function(t6, e6, r5) {
                  var i3 = this.byteLength(), a2 = r5 || Math.max(1, i3);
                  n3(i3 <= a2, "byte array longer than desired length"), n3(a2 > 0, "Requested array length <= 0"), this.strip();
                  var o2, s2, l2 = "le" === e6, u2 = new t6(a2), c2 = this.clone();
                  if (l2) {
                    for (s2 = 0; !c2.isZero(); s2++)
                      o2 = c2.andln(255), c2.iushrn(8), u2[s2] = o2;
                    for (; s2 < a2; s2++)
                      u2[s2] = 0;
                  } else {
                    for (s2 = 0; s2 < a2 - i3; s2++)
                      u2[s2] = 0;
                    for (s2 = 0; !c2.isZero(); s2++)
                      o2 = c2.andln(255), c2.iushrn(8), u2[a2 - s2 - 1] = o2;
                  }
                  return u2;
                }, Math.clz32 ? a.prototype._countBits = function(t6) {
                  return 32 - Math.clz32(t6);
                } : a.prototype._countBits = function(t6) {
                  var e6 = t6, r5 = 0;
                  return e6 >= 4096 && (r5 += 13, e6 >>>= 13), e6 >= 64 && (r5 += 7, e6 >>>= 7), e6 >= 8 && (r5 += 4, e6 >>>= 4), e6 >= 2 && (r5 += 2, e6 >>>= 2), r5 + e6;
                }, a.prototype._zeroBits = function(t6) {
                  if (0 === t6)
                    return 26;
                  var e6 = t6, r5 = 0;
                  return 0 == (8191 & e6) && (r5 += 13, e6 >>>= 13), 0 == (127 & e6) && (r5 += 7, e6 >>>= 7), 0 == (15 & e6) && (r5 += 4, e6 >>>= 4), 0 == (3 & e6) && (r5 += 2, e6 >>>= 2), 0 == (1 & e6) && r5++, r5;
                }, a.prototype.bitLength = function() {
                  var t6 = this.words[this.length - 1], e6 = this._countBits(t6);
                  return 26 * (this.length - 1) + e6;
                }, a.prototype.zeroBits = function() {
                  if (this.isZero())
                    return 0;
                  for (var t6 = 0, e6 = 0; e6 < this.length; e6++) {
                    var r5 = this._zeroBits(this.words[e6]);
                    if (t6 += r5, 26 !== r5)
                      break;
                  }
                  return t6;
                }, a.prototype.byteLength = function() {
                  return Math.ceil(this.bitLength() / 8);
                }, a.prototype.toTwos = function(t6) {
                  return 0 !== this.negative ? this.abs().inotn(t6).iaddn(1) : this.clone();
                }, a.prototype.fromTwos = function(t6) {
                  return this.testn(t6 - 1) ? this.notn(t6).iaddn(1).ineg() : this.clone();
                }, a.prototype.isNeg = function() {
                  return 0 !== this.negative;
                }, a.prototype.neg = function() {
                  return this.clone().ineg();
                }, a.prototype.ineg = function() {
                  return this.isZero() || (this.negative ^= 1), this;
                }, a.prototype.iuor = function(t6) {
                  for (; this.length < t6.length; )
                    this.words[this.length++] = 0;
                  for (var e6 = 0; e6 < t6.length; e6++)
                    this.words[e6] = this.words[e6] | t6.words[e6];
                  return this.strip();
                }, a.prototype.ior = function(t6) {
                  return n3(0 == (this.negative | t6.negative)), this.iuor(t6);
                }, a.prototype.or = function(t6) {
                  return this.length > t6.length ? this.clone().ior(t6) : t6.clone().ior(this);
                }, a.prototype.uor = function(t6) {
                  return this.length > t6.length ? this.clone().iuor(t6) : t6.clone().iuor(this);
                }, a.prototype.iuand = function(t6) {
                  var e6;
                  e6 = this.length > t6.length ? t6 : this;
                  for (var r5 = 0; r5 < e6.length; r5++)
                    this.words[r5] = this.words[r5] & t6.words[r5];
                  return this.length = e6.length, this.strip();
                }, a.prototype.iand = function(t6) {
                  return n3(0 == (this.negative | t6.negative)), this.iuand(t6);
                }, a.prototype.and = function(t6) {
                  return this.length > t6.length ? this.clone().iand(t6) : t6.clone().iand(this);
                }, a.prototype.uand = function(t6) {
                  return this.length > t6.length ? this.clone().iuand(t6) : t6.clone().iuand(this);
                }, a.prototype.iuxor = function(t6) {
                  var e6, r5;
                  this.length > t6.length ? (e6 = this, r5 = t6) : (e6 = t6, r5 = this);
                  for (var n4 = 0; n4 < r5.length; n4++)
                    this.words[n4] = e6.words[n4] ^ r5.words[n4];
                  if (this !== e6)
                    for (; n4 < e6.length; n4++)
                      this.words[n4] = e6.words[n4];
                  return this.length = e6.length, this.strip();
                }, a.prototype.ixor = function(t6) {
                  return n3(0 == (this.negative | t6.negative)), this.iuxor(t6);
                }, a.prototype.xor = function(t6) {
                  return this.length > t6.length ? this.clone().ixor(t6) : t6.clone().ixor(this);
                }, a.prototype.uxor = function(t6) {
                  return this.length > t6.length ? this.clone().iuxor(t6) : t6.clone().iuxor(this);
                }, a.prototype.inotn = function(t6) {
                  n3("number" == typeof t6 && t6 >= 0);
                  var e6 = 0 | Math.ceil(t6 / 26), r5 = t6 % 26;
                  this._expand(e6), r5 > 0 && e6--;
                  for (var i3 = 0; i3 < e6; i3++)
                    this.words[i3] = 67108863 & ~this.words[i3];
                  return r5 > 0 && (this.words[i3] = ~this.words[i3] & 67108863 >> 26 - r5), this.strip();
                }, a.prototype.notn = function(t6) {
                  return this.clone().inotn(t6);
                }, a.prototype.setn = function(t6, e6) {
                  n3("number" == typeof t6 && t6 >= 0);
                  var r5 = t6 / 26 | 0, i3 = t6 % 26;
                  return this._expand(r5 + 1), this.words[r5] = e6 ? this.words[r5] | 1 << i3 : this.words[r5] & ~(1 << i3), this.strip();
                }, a.prototype.iadd = function(t6) {
                  var e6, r5, n4;
                  if (0 !== this.negative && 0 === t6.negative)
                    return this.negative = 0, e6 = this.isub(t6), this.negative ^= 1, this._normSign();
                  if (0 === this.negative && 0 !== t6.negative)
                    return t6.negative = 0, e6 = this.isub(t6), t6.negative = 1, e6._normSign();
                  this.length > t6.length ? (r5 = this, n4 = t6) : (r5 = t6, n4 = this);
                  for (var i3 = 0, a2 = 0; a2 < n4.length; a2++)
                    e6 = (0 | r5.words[a2]) + (0 | n4.words[a2]) + i3, this.words[a2] = 67108863 & e6, i3 = e6 >>> 26;
                  for (; 0 !== i3 && a2 < r5.length; a2++)
                    e6 = (0 | r5.words[a2]) + i3, this.words[a2] = 67108863 & e6, i3 = e6 >>> 26;
                  if (this.length = r5.length, 0 !== i3)
                    this.words[this.length] = i3, this.length++;
                  else if (r5 !== this)
                    for (; a2 < r5.length; a2++)
                      this.words[a2] = r5.words[a2];
                  return this;
                }, a.prototype.add = function(t6) {
                  var e6;
                  return 0 !== t6.negative && 0 === this.negative ? (t6.negative = 0, e6 = this.sub(t6), t6.negative ^= 1, e6) : 0 === t6.negative && 0 !== this.negative ? (this.negative = 0, e6 = t6.sub(this), this.negative = 1, e6) : this.length > t6.length ? this.clone().iadd(t6) : t6.clone().iadd(this);
                }, a.prototype.isub = function(t6) {
                  if (0 !== t6.negative) {
                    t6.negative = 0;
                    var e6 = this.iadd(t6);
                    return t6.negative = 1, e6._normSign();
                  }
                  if (0 !== this.negative)
                    return this.negative = 0, this.iadd(t6), this.negative = 1, this._normSign();
                  var r5, n4, i3 = this.cmp(t6);
                  if (0 === i3)
                    return this.negative = 0, this.length = 1, this.words[0] = 0, this;
                  i3 > 0 ? (r5 = this, n4 = t6) : (r5 = t6, n4 = this);
                  for (var a2 = 0, o2 = 0; o2 < n4.length; o2++)
                    a2 = (e6 = (0 | r5.words[o2]) - (0 | n4.words[o2]) + a2) >> 26, this.words[o2] = 67108863 & e6;
                  for (; 0 !== a2 && o2 < r5.length; o2++)
                    a2 = (e6 = (0 | r5.words[o2]) + a2) >> 26, this.words[o2] = 67108863 & e6;
                  if (0 === a2 && o2 < r5.length && r5 !== this)
                    for (; o2 < r5.length; o2++)
                      this.words[o2] = r5.words[o2];
                  return this.length = Math.max(this.length, o2), r5 !== this && (this.negative = 1), this.strip();
                }, a.prototype.sub = function(t6) {
                  return this.clone().isub(t6);
                };
                var d2 = function(t6, e6, r5) {
                  var n4, i3, a2, o2 = t6.words, s2 = e6.words, l2 = r5.words, u2 = 0, c2 = 0 | o2[0], f3 = 8191 & c2, h2 = c2 >>> 13, p3 = 0 | o2[1], d3 = 8191 & p3, v2 = p3 >>> 13, g3 = 0 | o2[2], y2 = 8191 & g3, m3 = g3 >>> 13, x2 = 0 | o2[3], b2 = 8191 & x2, _2 = x2 >>> 13, w3 = 0 | o2[4], T2 = 8191 & w3, k2 = w3 >>> 13, A = 0 | o2[5], M = 8191 & A, S = A >>> 13, E = 0 | o2[6], L = 8191 & E, C = E >>> 13, P = 0 | o2[7], O = 8191 & P, I = P >>> 13, D = 0 | o2[8], z = 8191 & D, R = D >>> 13, F = 0 | o2[9], B = 8191 & F, N = F >>> 13, j = 0 | s2[0], U = 8191 & j, V = j >>> 13, H = 0 | s2[1], q2 = 8191 & H, G = H >>> 13, Z = 0 | s2[2], Y = 8191 & Z, W = Z >>> 13, X = 0 | s2[3], J = 8191 & X, K = X >>> 13, $ = 0 | s2[4], Q = 8191 & $, tt = $ >>> 13, et = 0 | s2[5], rt = 8191 & et, nt = et >>> 13, it = 0 | s2[6], at = 8191 & it, ot = it >>> 13, st = 0 | s2[7], lt = 8191 & st, ut = st >>> 13, ct = 0 | s2[8], ft = 8191 & ct, ht = ct >>> 13, pt = 0 | s2[9], dt = 8191 & pt, vt = pt >>> 13;
                  r5.negative = t6.negative ^ e6.negative, r5.length = 19;
                  var gt = (u2 + (n4 = Math.imul(f3, U)) | 0) + ((8191 & (i3 = (i3 = Math.imul(f3, V)) + Math.imul(h2, U) | 0)) << 13) | 0;
                  u2 = ((a2 = Math.imul(h2, V)) + (i3 >>> 13) | 0) + (gt >>> 26) | 0, gt &= 67108863, n4 = Math.imul(d3, U), i3 = (i3 = Math.imul(d3, V)) + Math.imul(v2, U) | 0, a2 = Math.imul(v2, V);
                  var yt = (u2 + (n4 = n4 + Math.imul(f3, q2) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(f3, G) | 0) + Math.imul(h2, q2) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(h2, G) | 0) + (i3 >>> 13) | 0) + (yt >>> 26) | 0, yt &= 67108863, n4 = Math.imul(y2, U), i3 = (i3 = Math.imul(y2, V)) + Math.imul(m3, U) | 0, a2 = Math.imul(m3, V), n4 = n4 + Math.imul(d3, q2) | 0, i3 = (i3 = i3 + Math.imul(d3, G) | 0) + Math.imul(v2, q2) | 0, a2 = a2 + Math.imul(v2, G) | 0;
                  var mt = (u2 + (n4 = n4 + Math.imul(f3, Y) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(f3, W) | 0) + Math.imul(h2, Y) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(h2, W) | 0) + (i3 >>> 13) | 0) + (mt >>> 26) | 0, mt &= 67108863, n4 = Math.imul(b2, U), i3 = (i3 = Math.imul(b2, V)) + Math.imul(_2, U) | 0, a2 = Math.imul(_2, V), n4 = n4 + Math.imul(y2, q2) | 0, i3 = (i3 = i3 + Math.imul(y2, G) | 0) + Math.imul(m3, q2) | 0, a2 = a2 + Math.imul(m3, G) | 0, n4 = n4 + Math.imul(d3, Y) | 0, i3 = (i3 = i3 + Math.imul(d3, W) | 0) + Math.imul(v2, Y) | 0, a2 = a2 + Math.imul(v2, W) | 0;
                  var xt = (u2 + (n4 = n4 + Math.imul(f3, J) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(f3, K) | 0) + Math.imul(h2, J) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(h2, K) | 0) + (i3 >>> 13) | 0) + (xt >>> 26) | 0, xt &= 67108863, n4 = Math.imul(T2, U), i3 = (i3 = Math.imul(T2, V)) + Math.imul(k2, U) | 0, a2 = Math.imul(k2, V), n4 = n4 + Math.imul(b2, q2) | 0, i3 = (i3 = i3 + Math.imul(b2, G) | 0) + Math.imul(_2, q2) | 0, a2 = a2 + Math.imul(_2, G) | 0, n4 = n4 + Math.imul(y2, Y) | 0, i3 = (i3 = i3 + Math.imul(y2, W) | 0) + Math.imul(m3, Y) | 0, a2 = a2 + Math.imul(m3, W) | 0, n4 = n4 + Math.imul(d3, J) | 0, i3 = (i3 = i3 + Math.imul(d3, K) | 0) + Math.imul(v2, J) | 0, a2 = a2 + Math.imul(v2, K) | 0;
                  var bt = (u2 + (n4 = n4 + Math.imul(f3, Q) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(f3, tt) | 0) + Math.imul(h2, Q) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(h2, tt) | 0) + (i3 >>> 13) | 0) + (bt >>> 26) | 0, bt &= 67108863, n4 = Math.imul(M, U), i3 = (i3 = Math.imul(M, V)) + Math.imul(S, U) | 0, a2 = Math.imul(S, V), n4 = n4 + Math.imul(T2, q2) | 0, i3 = (i3 = i3 + Math.imul(T2, G) | 0) + Math.imul(k2, q2) | 0, a2 = a2 + Math.imul(k2, G) | 0, n4 = n4 + Math.imul(b2, Y) | 0, i3 = (i3 = i3 + Math.imul(b2, W) | 0) + Math.imul(_2, Y) | 0, a2 = a2 + Math.imul(_2, W) | 0, n4 = n4 + Math.imul(y2, J) | 0, i3 = (i3 = i3 + Math.imul(y2, K) | 0) + Math.imul(m3, J) | 0, a2 = a2 + Math.imul(m3, K) | 0, n4 = n4 + Math.imul(d3, Q) | 0, i3 = (i3 = i3 + Math.imul(d3, tt) | 0) + Math.imul(v2, Q) | 0, a2 = a2 + Math.imul(v2, tt) | 0;
                  var _t = (u2 + (n4 = n4 + Math.imul(f3, rt) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(f3, nt) | 0) + Math.imul(h2, rt) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(h2, nt) | 0) + (i3 >>> 13) | 0) + (_t >>> 26) | 0, _t &= 67108863, n4 = Math.imul(L, U), i3 = (i3 = Math.imul(L, V)) + Math.imul(C, U) | 0, a2 = Math.imul(C, V), n4 = n4 + Math.imul(M, q2) | 0, i3 = (i3 = i3 + Math.imul(M, G) | 0) + Math.imul(S, q2) | 0, a2 = a2 + Math.imul(S, G) | 0, n4 = n4 + Math.imul(T2, Y) | 0, i3 = (i3 = i3 + Math.imul(T2, W) | 0) + Math.imul(k2, Y) | 0, a2 = a2 + Math.imul(k2, W) | 0, n4 = n4 + Math.imul(b2, J) | 0, i3 = (i3 = i3 + Math.imul(b2, K) | 0) + Math.imul(_2, J) | 0, a2 = a2 + Math.imul(_2, K) | 0, n4 = n4 + Math.imul(y2, Q) | 0, i3 = (i3 = i3 + Math.imul(y2, tt) | 0) + Math.imul(m3, Q) | 0, a2 = a2 + Math.imul(m3, tt) | 0, n4 = n4 + Math.imul(d3, rt) | 0, i3 = (i3 = i3 + Math.imul(d3, nt) | 0) + Math.imul(v2, rt) | 0, a2 = a2 + Math.imul(v2, nt) | 0;
                  var wt = (u2 + (n4 = n4 + Math.imul(f3, at) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(f3, ot) | 0) + Math.imul(h2, at) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(h2, ot) | 0) + (i3 >>> 13) | 0) + (wt >>> 26) | 0, wt &= 67108863, n4 = Math.imul(O, U), i3 = (i3 = Math.imul(O, V)) + Math.imul(I, U) | 0, a2 = Math.imul(I, V), n4 = n4 + Math.imul(L, q2) | 0, i3 = (i3 = i3 + Math.imul(L, G) | 0) + Math.imul(C, q2) | 0, a2 = a2 + Math.imul(C, G) | 0, n4 = n4 + Math.imul(M, Y) | 0, i3 = (i3 = i3 + Math.imul(M, W) | 0) + Math.imul(S, Y) | 0, a2 = a2 + Math.imul(S, W) | 0, n4 = n4 + Math.imul(T2, J) | 0, i3 = (i3 = i3 + Math.imul(T2, K) | 0) + Math.imul(k2, J) | 0, a2 = a2 + Math.imul(k2, K) | 0, n4 = n4 + Math.imul(b2, Q) | 0, i3 = (i3 = i3 + Math.imul(b2, tt) | 0) + Math.imul(_2, Q) | 0, a2 = a2 + Math.imul(_2, tt) | 0, n4 = n4 + Math.imul(y2, rt) | 0, i3 = (i3 = i3 + Math.imul(y2, nt) | 0) + Math.imul(m3, rt) | 0, a2 = a2 + Math.imul(m3, nt) | 0, n4 = n4 + Math.imul(d3, at) | 0, i3 = (i3 = i3 + Math.imul(d3, ot) | 0) + Math.imul(v2, at) | 0, a2 = a2 + Math.imul(v2, ot) | 0;
                  var Tt = (u2 + (n4 = n4 + Math.imul(f3, lt) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(f3, ut) | 0) + Math.imul(h2, lt) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(h2, ut) | 0) + (i3 >>> 13) | 0) + (Tt >>> 26) | 0, Tt &= 67108863, n4 = Math.imul(z, U), i3 = (i3 = Math.imul(z, V)) + Math.imul(R, U) | 0, a2 = Math.imul(R, V), n4 = n4 + Math.imul(O, q2) | 0, i3 = (i3 = i3 + Math.imul(O, G) | 0) + Math.imul(I, q2) | 0, a2 = a2 + Math.imul(I, G) | 0, n4 = n4 + Math.imul(L, Y) | 0, i3 = (i3 = i3 + Math.imul(L, W) | 0) + Math.imul(C, Y) | 0, a2 = a2 + Math.imul(C, W) | 0, n4 = n4 + Math.imul(M, J) | 0, i3 = (i3 = i3 + Math.imul(M, K) | 0) + Math.imul(S, J) | 0, a2 = a2 + Math.imul(S, K) | 0, n4 = n4 + Math.imul(T2, Q) | 0, i3 = (i3 = i3 + Math.imul(T2, tt) | 0) + Math.imul(k2, Q) | 0, a2 = a2 + Math.imul(k2, tt) | 0, n4 = n4 + Math.imul(b2, rt) | 0, i3 = (i3 = i3 + Math.imul(b2, nt) | 0) + Math.imul(_2, rt) | 0, a2 = a2 + Math.imul(_2, nt) | 0, n4 = n4 + Math.imul(y2, at) | 0, i3 = (i3 = i3 + Math.imul(y2, ot) | 0) + Math.imul(m3, at) | 0, a2 = a2 + Math.imul(m3, ot) | 0, n4 = n4 + Math.imul(d3, lt) | 0, i3 = (i3 = i3 + Math.imul(d3, ut) | 0) + Math.imul(v2, lt) | 0, a2 = a2 + Math.imul(v2, ut) | 0;
                  var kt = (u2 + (n4 = n4 + Math.imul(f3, ft) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(f3, ht) | 0) + Math.imul(h2, ft) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(h2, ht) | 0) + (i3 >>> 13) | 0) + (kt >>> 26) | 0, kt &= 67108863, n4 = Math.imul(B, U), i3 = (i3 = Math.imul(B, V)) + Math.imul(N, U) | 0, a2 = Math.imul(N, V), n4 = n4 + Math.imul(z, q2) | 0, i3 = (i3 = i3 + Math.imul(z, G) | 0) + Math.imul(R, q2) | 0, a2 = a2 + Math.imul(R, G) | 0, n4 = n4 + Math.imul(O, Y) | 0, i3 = (i3 = i3 + Math.imul(O, W) | 0) + Math.imul(I, Y) | 0, a2 = a2 + Math.imul(I, W) | 0, n4 = n4 + Math.imul(L, J) | 0, i3 = (i3 = i3 + Math.imul(L, K) | 0) + Math.imul(C, J) | 0, a2 = a2 + Math.imul(C, K) | 0, n4 = n4 + Math.imul(M, Q) | 0, i3 = (i3 = i3 + Math.imul(M, tt) | 0) + Math.imul(S, Q) | 0, a2 = a2 + Math.imul(S, tt) | 0, n4 = n4 + Math.imul(T2, rt) | 0, i3 = (i3 = i3 + Math.imul(T2, nt) | 0) + Math.imul(k2, rt) | 0, a2 = a2 + Math.imul(k2, nt) | 0, n4 = n4 + Math.imul(b2, at) | 0, i3 = (i3 = i3 + Math.imul(b2, ot) | 0) + Math.imul(_2, at) | 0, a2 = a2 + Math.imul(_2, ot) | 0, n4 = n4 + Math.imul(y2, lt) | 0, i3 = (i3 = i3 + Math.imul(y2, ut) | 0) + Math.imul(m3, lt) | 0, a2 = a2 + Math.imul(m3, ut) | 0, n4 = n4 + Math.imul(d3, ft) | 0, i3 = (i3 = i3 + Math.imul(d3, ht) | 0) + Math.imul(v2, ft) | 0, a2 = a2 + Math.imul(v2, ht) | 0;
                  var At = (u2 + (n4 = n4 + Math.imul(f3, dt) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(f3, vt) | 0) + Math.imul(h2, dt) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(h2, vt) | 0) + (i3 >>> 13) | 0) + (At >>> 26) | 0, At &= 67108863, n4 = Math.imul(B, q2), i3 = (i3 = Math.imul(B, G)) + Math.imul(N, q2) | 0, a2 = Math.imul(N, G), n4 = n4 + Math.imul(z, Y) | 0, i3 = (i3 = i3 + Math.imul(z, W) | 0) + Math.imul(R, Y) | 0, a2 = a2 + Math.imul(R, W) | 0, n4 = n4 + Math.imul(O, J) | 0, i3 = (i3 = i3 + Math.imul(O, K) | 0) + Math.imul(I, J) | 0, a2 = a2 + Math.imul(I, K) | 0, n4 = n4 + Math.imul(L, Q) | 0, i3 = (i3 = i3 + Math.imul(L, tt) | 0) + Math.imul(C, Q) | 0, a2 = a2 + Math.imul(C, tt) | 0, n4 = n4 + Math.imul(M, rt) | 0, i3 = (i3 = i3 + Math.imul(M, nt) | 0) + Math.imul(S, rt) | 0, a2 = a2 + Math.imul(S, nt) | 0, n4 = n4 + Math.imul(T2, at) | 0, i3 = (i3 = i3 + Math.imul(T2, ot) | 0) + Math.imul(k2, at) | 0, a2 = a2 + Math.imul(k2, ot) | 0, n4 = n4 + Math.imul(b2, lt) | 0, i3 = (i3 = i3 + Math.imul(b2, ut) | 0) + Math.imul(_2, lt) | 0, a2 = a2 + Math.imul(_2, ut) | 0, n4 = n4 + Math.imul(y2, ft) | 0, i3 = (i3 = i3 + Math.imul(y2, ht) | 0) + Math.imul(m3, ft) | 0, a2 = a2 + Math.imul(m3, ht) | 0;
                  var Mt = (u2 + (n4 = n4 + Math.imul(d3, dt) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(d3, vt) | 0) + Math.imul(v2, dt) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(v2, vt) | 0) + (i3 >>> 13) | 0) + (Mt >>> 26) | 0, Mt &= 67108863, n4 = Math.imul(B, Y), i3 = (i3 = Math.imul(B, W)) + Math.imul(N, Y) | 0, a2 = Math.imul(N, W), n4 = n4 + Math.imul(z, J) | 0, i3 = (i3 = i3 + Math.imul(z, K) | 0) + Math.imul(R, J) | 0, a2 = a2 + Math.imul(R, K) | 0, n4 = n4 + Math.imul(O, Q) | 0, i3 = (i3 = i3 + Math.imul(O, tt) | 0) + Math.imul(I, Q) | 0, a2 = a2 + Math.imul(I, tt) | 0, n4 = n4 + Math.imul(L, rt) | 0, i3 = (i3 = i3 + Math.imul(L, nt) | 0) + Math.imul(C, rt) | 0, a2 = a2 + Math.imul(C, nt) | 0, n4 = n4 + Math.imul(M, at) | 0, i3 = (i3 = i3 + Math.imul(M, ot) | 0) + Math.imul(S, at) | 0, a2 = a2 + Math.imul(S, ot) | 0, n4 = n4 + Math.imul(T2, lt) | 0, i3 = (i3 = i3 + Math.imul(T2, ut) | 0) + Math.imul(k2, lt) | 0, a2 = a2 + Math.imul(k2, ut) | 0, n4 = n4 + Math.imul(b2, ft) | 0, i3 = (i3 = i3 + Math.imul(b2, ht) | 0) + Math.imul(_2, ft) | 0, a2 = a2 + Math.imul(_2, ht) | 0;
                  var St = (u2 + (n4 = n4 + Math.imul(y2, dt) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(y2, vt) | 0) + Math.imul(m3, dt) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(m3, vt) | 0) + (i3 >>> 13) | 0) + (St >>> 26) | 0, St &= 67108863, n4 = Math.imul(B, J), i3 = (i3 = Math.imul(B, K)) + Math.imul(N, J) | 0, a2 = Math.imul(N, K), n4 = n4 + Math.imul(z, Q) | 0, i3 = (i3 = i3 + Math.imul(z, tt) | 0) + Math.imul(R, Q) | 0, a2 = a2 + Math.imul(R, tt) | 0, n4 = n4 + Math.imul(O, rt) | 0, i3 = (i3 = i3 + Math.imul(O, nt) | 0) + Math.imul(I, rt) | 0, a2 = a2 + Math.imul(I, nt) | 0, n4 = n4 + Math.imul(L, at) | 0, i3 = (i3 = i3 + Math.imul(L, ot) | 0) + Math.imul(C, at) | 0, a2 = a2 + Math.imul(C, ot) | 0, n4 = n4 + Math.imul(M, lt) | 0, i3 = (i3 = i3 + Math.imul(M, ut) | 0) + Math.imul(S, lt) | 0, a2 = a2 + Math.imul(S, ut) | 0, n4 = n4 + Math.imul(T2, ft) | 0, i3 = (i3 = i3 + Math.imul(T2, ht) | 0) + Math.imul(k2, ft) | 0, a2 = a2 + Math.imul(k2, ht) | 0;
                  var Et = (u2 + (n4 = n4 + Math.imul(b2, dt) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(b2, vt) | 0) + Math.imul(_2, dt) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(_2, vt) | 0) + (i3 >>> 13) | 0) + (Et >>> 26) | 0, Et &= 67108863, n4 = Math.imul(B, Q), i3 = (i3 = Math.imul(B, tt)) + Math.imul(N, Q) | 0, a2 = Math.imul(N, tt), n4 = n4 + Math.imul(z, rt) | 0, i3 = (i3 = i3 + Math.imul(z, nt) | 0) + Math.imul(R, rt) | 0, a2 = a2 + Math.imul(R, nt) | 0, n4 = n4 + Math.imul(O, at) | 0, i3 = (i3 = i3 + Math.imul(O, ot) | 0) + Math.imul(I, at) | 0, a2 = a2 + Math.imul(I, ot) | 0, n4 = n4 + Math.imul(L, lt) | 0, i3 = (i3 = i3 + Math.imul(L, ut) | 0) + Math.imul(C, lt) | 0, a2 = a2 + Math.imul(C, ut) | 0, n4 = n4 + Math.imul(M, ft) | 0, i3 = (i3 = i3 + Math.imul(M, ht) | 0) + Math.imul(S, ft) | 0, a2 = a2 + Math.imul(S, ht) | 0;
                  var Lt = (u2 + (n4 = n4 + Math.imul(T2, dt) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(T2, vt) | 0) + Math.imul(k2, dt) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(k2, vt) | 0) + (i3 >>> 13) | 0) + (Lt >>> 26) | 0, Lt &= 67108863, n4 = Math.imul(B, rt), i3 = (i3 = Math.imul(B, nt)) + Math.imul(N, rt) | 0, a2 = Math.imul(N, nt), n4 = n4 + Math.imul(z, at) | 0, i3 = (i3 = i3 + Math.imul(z, ot) | 0) + Math.imul(R, at) | 0, a2 = a2 + Math.imul(R, ot) | 0, n4 = n4 + Math.imul(O, lt) | 0, i3 = (i3 = i3 + Math.imul(O, ut) | 0) + Math.imul(I, lt) | 0, a2 = a2 + Math.imul(I, ut) | 0, n4 = n4 + Math.imul(L, ft) | 0, i3 = (i3 = i3 + Math.imul(L, ht) | 0) + Math.imul(C, ft) | 0, a2 = a2 + Math.imul(C, ht) | 0;
                  var Ct = (u2 + (n4 = n4 + Math.imul(M, dt) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(M, vt) | 0) + Math.imul(S, dt) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(S, vt) | 0) + (i3 >>> 13) | 0) + (Ct >>> 26) | 0, Ct &= 67108863, n4 = Math.imul(B, at), i3 = (i3 = Math.imul(B, ot)) + Math.imul(N, at) | 0, a2 = Math.imul(N, ot), n4 = n4 + Math.imul(z, lt) | 0, i3 = (i3 = i3 + Math.imul(z, ut) | 0) + Math.imul(R, lt) | 0, a2 = a2 + Math.imul(R, ut) | 0, n4 = n4 + Math.imul(O, ft) | 0, i3 = (i3 = i3 + Math.imul(O, ht) | 0) + Math.imul(I, ft) | 0, a2 = a2 + Math.imul(I, ht) | 0;
                  var Pt = (u2 + (n4 = n4 + Math.imul(L, dt) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(L, vt) | 0) + Math.imul(C, dt) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(C, vt) | 0) + (i3 >>> 13) | 0) + (Pt >>> 26) | 0, Pt &= 67108863, n4 = Math.imul(B, lt), i3 = (i3 = Math.imul(B, ut)) + Math.imul(N, lt) | 0, a2 = Math.imul(N, ut), n4 = n4 + Math.imul(z, ft) | 0, i3 = (i3 = i3 + Math.imul(z, ht) | 0) + Math.imul(R, ft) | 0, a2 = a2 + Math.imul(R, ht) | 0;
                  var Ot = (u2 + (n4 = n4 + Math.imul(O, dt) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(O, vt) | 0) + Math.imul(I, dt) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(I, vt) | 0) + (i3 >>> 13) | 0) + (Ot >>> 26) | 0, Ot &= 67108863, n4 = Math.imul(B, ft), i3 = (i3 = Math.imul(B, ht)) + Math.imul(N, ft) | 0, a2 = Math.imul(N, ht);
                  var It = (u2 + (n4 = n4 + Math.imul(z, dt) | 0) | 0) + ((8191 & (i3 = (i3 = i3 + Math.imul(z, vt) | 0) + Math.imul(R, dt) | 0)) << 13) | 0;
                  u2 = ((a2 = a2 + Math.imul(R, vt) | 0) + (i3 >>> 13) | 0) + (It >>> 26) | 0, It &= 67108863;
                  var Dt = (u2 + (n4 = Math.imul(B, dt)) | 0) + ((8191 & (i3 = (i3 = Math.imul(B, vt)) + Math.imul(N, dt) | 0)) << 13) | 0;
                  return u2 = ((a2 = Math.imul(N, vt)) + (i3 >>> 13) | 0) + (Dt >>> 26) | 0, Dt &= 67108863, l2[0] = gt, l2[1] = yt, l2[2] = mt, l2[3] = xt, l2[4] = bt, l2[5] = _t, l2[6] = wt, l2[7] = Tt, l2[8] = kt, l2[9] = At, l2[10] = Mt, l2[11] = St, l2[12] = Et, l2[13] = Lt, l2[14] = Ct, l2[15] = Pt, l2[16] = Ot, l2[17] = It, l2[18] = Dt, 0 !== u2 && (l2[19] = u2, r5.length++), r5;
                };
                function v(t6, e6, r5) {
                  return new g2().mulp(t6, e6, r5);
                }
                function g2(t6, e6) {
                  this.x = t6, this.y = e6;
                }
                Math.imul || (d2 = p2), a.prototype.mulTo = function(t6, e6) {
                  var r5, n4 = this.length + t6.length;
                  return r5 = 10 === this.length && 10 === t6.length ? d2(this, t6, e6) : n4 < 63 ? p2(this, t6, e6) : n4 < 1024 ? function(t7, e7, r6) {
                    r6.negative = e7.negative ^ t7.negative, r6.length = t7.length + e7.length;
                    for (var n5 = 0, i3 = 0, a2 = 0; a2 < r6.length - 1; a2++) {
                      var o2 = i3;
                      i3 = 0;
                      for (var s2 = 67108863 & n5, l2 = Math.min(a2, e7.length - 1), u2 = Math.max(0, a2 - t7.length + 1); u2 <= l2; u2++) {
                        var c2 = a2 - u2, f3 = (0 | t7.words[c2]) * (0 | e7.words[u2]), h2 = 67108863 & f3;
                        s2 = 67108863 & (h2 = h2 + s2 | 0), i3 += (o2 = (o2 = o2 + (f3 / 67108864 | 0) | 0) + (h2 >>> 26) | 0) >>> 26, o2 &= 67108863;
                      }
                      r6.words[a2] = s2, n5 = o2, o2 = i3;
                    }
                    return 0 !== n5 ? r6.words[a2] = n5 : r6.length--, r6.strip();
                  }(this, t6, e6) : v(this, t6, e6), r5;
                }, g2.prototype.makeRBT = function(t6) {
                  for (var e6 = new Array(t6), r5 = a.prototype._countBits(t6) - 1, n4 = 0; n4 < t6; n4++)
                    e6[n4] = this.revBin(n4, r5, t6);
                  return e6;
                }, g2.prototype.revBin = function(t6, e6, r5) {
                  if (0 === t6 || t6 === r5 - 1)
                    return t6;
                  for (var n4 = 0, i3 = 0; i3 < e6; i3++)
                    n4 |= (1 & t6) << e6 - i3 - 1, t6 >>= 1;
                  return n4;
                }, g2.prototype.permute = function(t6, e6, r5, n4, i3, a2) {
                  for (var o2 = 0; o2 < a2; o2++)
                    n4[o2] = e6[t6[o2]], i3[o2] = r5[t6[o2]];
                }, g2.prototype.transform = function(t6, e6, r5, n4, i3, a2) {
                  this.permute(a2, t6, e6, r5, n4, i3);
                  for (var o2 = 1; o2 < i3; o2 <<= 1)
                    for (var s2 = o2 << 1, l2 = Math.cos(2 * Math.PI / s2), u2 = Math.sin(2 * Math.PI / s2), c2 = 0; c2 < i3; c2 += s2)
                      for (var f3 = l2, h2 = u2, p3 = 0; p3 < o2; p3++) {
                        var d3 = r5[c2 + p3], v2 = n4[c2 + p3], g3 = r5[c2 + p3 + o2], y2 = n4[c2 + p3 + o2], m3 = f3 * g3 - h2 * y2;
                        y2 = f3 * y2 + h2 * g3, g3 = m3, r5[c2 + p3] = d3 + g3, n4[c2 + p3] = v2 + y2, r5[c2 + p3 + o2] = d3 - g3, n4[c2 + p3 + o2] = v2 - y2, p3 !== s2 && (m3 = l2 * f3 - u2 * h2, h2 = l2 * h2 + u2 * f3, f3 = m3);
                      }
                }, g2.prototype.guessLen13b = function(t6, e6) {
                  var r5 = 1 | Math.max(e6, t6), n4 = 1 & r5, i3 = 0;
                  for (r5 = r5 / 2 | 0; r5; r5 >>>= 1)
                    i3++;
                  return 1 << i3 + 1 + n4;
                }, g2.prototype.conjugate = function(t6, e6, r5) {
                  if (!(r5 <= 1))
                    for (var n4 = 0; n4 < r5 / 2; n4++) {
                      var i3 = t6[n4];
                      t6[n4] = t6[r5 - n4 - 1], t6[r5 - n4 - 1] = i3, i3 = e6[n4], e6[n4] = -e6[r5 - n4 - 1], e6[r5 - n4 - 1] = -i3;
                    }
                }, g2.prototype.normalize13b = function(t6, e6) {
                  for (var r5 = 0, n4 = 0; n4 < e6 / 2; n4++) {
                    var i3 = 8192 * Math.round(t6[2 * n4 + 1] / e6) + Math.round(t6[2 * n4] / e6) + r5;
                    t6[n4] = 67108863 & i3, r5 = i3 < 67108864 ? 0 : i3 / 67108864 | 0;
                  }
                  return t6;
                }, g2.prototype.convert13b = function(t6, e6, r5, i3) {
                  for (var a2 = 0, o2 = 0; o2 < e6; o2++)
                    a2 += 0 | t6[o2], r5[2 * o2] = 8191 & a2, a2 >>>= 13, r5[2 * o2 + 1] = 8191 & a2, a2 >>>= 13;
                  for (o2 = 2 * e6; o2 < i3; ++o2)
                    r5[o2] = 0;
                  n3(0 === a2), n3(0 == (-8192 & a2));
                }, g2.prototype.stub = function(t6) {
                  for (var e6 = new Array(t6), r5 = 0; r5 < t6; r5++)
                    e6[r5] = 0;
                  return e6;
                }, g2.prototype.mulp = function(t6, e6, r5) {
                  var n4 = 2 * this.guessLen13b(t6.length, e6.length), i3 = this.makeRBT(n4), a2 = this.stub(n4), o2 = new Array(n4), s2 = new Array(n4), l2 = new Array(n4), u2 = new Array(n4), c2 = new Array(n4), f3 = new Array(n4), h2 = r5.words;
                  h2.length = n4, this.convert13b(t6.words, t6.length, o2, n4), this.convert13b(e6.words, e6.length, u2, n4), this.transform(o2, a2, s2, l2, n4, i3), this.transform(u2, a2, c2, f3, n4, i3);
                  for (var p3 = 0; p3 < n4; p3++) {
                    var d3 = s2[p3] * c2[p3] - l2[p3] * f3[p3];
                    l2[p3] = s2[p3] * f3[p3] + l2[p3] * c2[p3], s2[p3] = d3;
                  }
                  return this.conjugate(s2, l2, n4), this.transform(s2, l2, h2, a2, n4, i3), this.conjugate(h2, a2, n4), this.normalize13b(h2, n4), r5.negative = t6.negative ^ e6.negative, r5.length = t6.length + e6.length, r5.strip();
                }, a.prototype.mul = function(t6) {
                  var e6 = new a(null);
                  return e6.words = new Array(this.length + t6.length), this.mulTo(t6, e6);
                }, a.prototype.mulf = function(t6) {
                  var e6 = new a(null);
                  return e6.words = new Array(this.length + t6.length), v(this, t6, e6);
                }, a.prototype.imul = function(t6) {
                  return this.clone().mulTo(t6, this);
                }, a.prototype.imuln = function(t6) {
                  n3("number" == typeof t6), n3(t6 < 67108864);
                  for (var e6 = 0, r5 = 0; r5 < this.length; r5++) {
                    var i3 = (0 | this.words[r5]) * t6, a2 = (67108863 & i3) + (67108863 & e6);
                    e6 >>= 26, e6 += i3 / 67108864 | 0, e6 += a2 >>> 26, this.words[r5] = 67108863 & a2;
                  }
                  return 0 !== e6 && (this.words[r5] = e6, this.length++), this;
                }, a.prototype.muln = function(t6) {
                  return this.clone().imuln(t6);
                }, a.prototype.sqr = function() {
                  return this.mul(this);
                }, a.prototype.isqr = function() {
                  return this.imul(this.clone());
                }, a.prototype.pow = function(t6) {
                  var e6 = function(t7) {
                    for (var e7 = new Array(t7.bitLength()), r6 = 0; r6 < e7.length; r6++) {
                      var n5 = r6 / 26 | 0, i4 = r6 % 26;
                      e7[r6] = (t7.words[n5] & 1 << i4) >>> i4;
                    }
                    return e7;
                  }(t6);
                  if (0 === e6.length)
                    return new a(1);
                  for (var r5 = this, n4 = 0; n4 < e6.length && 0 === e6[n4]; n4++, r5 = r5.sqr())
                    ;
                  if (++n4 < e6.length)
                    for (var i3 = r5.sqr(); n4 < e6.length; n4++, i3 = i3.sqr())
                      0 !== e6[n4] && (r5 = r5.mul(i3));
                  return r5;
                }, a.prototype.iushln = function(t6) {
                  n3("number" == typeof t6 && t6 >= 0);
                  var e6, r5 = t6 % 26, i3 = (t6 - r5) / 26, a2 = 67108863 >>> 26 - r5 << 26 - r5;
                  if (0 !== r5) {
                    var o2 = 0;
                    for (e6 = 0; e6 < this.length; e6++) {
                      var s2 = this.words[e6] & a2, l2 = (0 | this.words[e6]) - s2 << r5;
                      this.words[e6] = l2 | o2, o2 = s2 >>> 26 - r5;
                    }
                    o2 && (this.words[e6] = o2, this.length++);
                  }
                  if (0 !== i3) {
                    for (e6 = this.length - 1; e6 >= 0; e6--)
                      this.words[e6 + i3] = this.words[e6];
                    for (e6 = 0; e6 < i3; e6++)
                      this.words[e6] = 0;
                    this.length += i3;
                  }
                  return this.strip();
                }, a.prototype.ishln = function(t6) {
                  return n3(0 === this.negative), this.iushln(t6);
                }, a.prototype.iushrn = function(t6, e6, r5) {
                  var i3;
                  n3("number" == typeof t6 && t6 >= 0), i3 = e6 ? (e6 - e6 % 26) / 26 : 0;
                  var a2 = t6 % 26, o2 = Math.min((t6 - a2) / 26, this.length), s2 = 67108863 ^ 67108863 >>> a2 << a2, l2 = r5;
                  if (i3 -= o2, i3 = Math.max(0, i3), l2) {
                    for (var u2 = 0; u2 < o2; u2++)
                      l2.words[u2] = this.words[u2];
                    l2.length = o2;
                  }
                  if (0 === o2)
                    ;
                  else if (this.length > o2)
                    for (this.length -= o2, u2 = 0; u2 < this.length; u2++)
                      this.words[u2] = this.words[u2 + o2];
                  else
                    this.words[0] = 0, this.length = 1;
                  var c2 = 0;
                  for (u2 = this.length - 1; u2 >= 0 && (0 !== c2 || u2 >= i3); u2--) {
                    var f3 = 0 | this.words[u2];
                    this.words[u2] = c2 << 26 - a2 | f3 >>> a2, c2 = f3 & s2;
                  }
                  return l2 && 0 !== c2 && (l2.words[l2.length++] = c2), 0 === this.length && (this.words[0] = 0, this.length = 1), this.strip();
                }, a.prototype.ishrn = function(t6, e6, r5) {
                  return n3(0 === this.negative), this.iushrn(t6, e6, r5);
                }, a.prototype.shln = function(t6) {
                  return this.clone().ishln(t6);
                }, a.prototype.ushln = function(t6) {
                  return this.clone().iushln(t6);
                }, a.prototype.shrn = function(t6) {
                  return this.clone().ishrn(t6);
                }, a.prototype.ushrn = function(t6) {
                  return this.clone().iushrn(t6);
                }, a.prototype.testn = function(t6) {
                  n3("number" == typeof t6 && t6 >= 0);
                  var e6 = t6 % 26, r5 = (t6 - e6) / 26, i3 = 1 << e6;
                  return !(this.length <= r5 || !(this.words[r5] & i3));
                }, a.prototype.imaskn = function(t6) {
                  n3("number" == typeof t6 && t6 >= 0);
                  var e6 = t6 % 26, r5 = (t6 - e6) / 26;
                  if (n3(0 === this.negative, "imaskn works only with positive numbers"), this.length <= r5)
                    return this;
                  if (0 !== e6 && r5++, this.length = Math.min(r5, this.length), 0 !== e6) {
                    var i3 = 67108863 ^ 67108863 >>> e6 << e6;
                    this.words[this.length - 1] &= i3;
                  }
                  return this.strip();
                }, a.prototype.maskn = function(t6) {
                  return this.clone().imaskn(t6);
                }, a.prototype.iaddn = function(t6) {
                  return n3("number" == typeof t6), n3(t6 < 67108864), t6 < 0 ? this.isubn(-t6) : 0 !== this.negative ? 1 === this.length && (0 | this.words[0]) < t6 ? (this.words[0] = t6 - (0 | this.words[0]), this.negative = 0, this) : (this.negative = 0, this.isubn(t6), this.negative = 1, this) : this._iaddn(t6);
                }, a.prototype._iaddn = function(t6) {
                  this.words[0] += t6;
                  for (var e6 = 0; e6 < this.length && this.words[e6] >= 67108864; e6++)
                    this.words[e6] -= 67108864, e6 === this.length - 1 ? this.words[e6 + 1] = 1 : this.words[e6 + 1]++;
                  return this.length = Math.max(this.length, e6 + 1), this;
                }, a.prototype.isubn = function(t6) {
                  if (n3("number" == typeof t6), n3(t6 < 67108864), t6 < 0)
                    return this.iaddn(-t6);
                  if (0 !== this.negative)
                    return this.negative = 0, this.iaddn(t6), this.negative = 1, this;
                  if (this.words[0] -= t6, 1 === this.length && this.words[0] < 0)
                    this.words[0] = -this.words[0], this.negative = 1;
                  else
                    for (var e6 = 0; e6 < this.length && this.words[e6] < 0; e6++)
                      this.words[e6] += 67108864, this.words[e6 + 1] -= 1;
                  return this.strip();
                }, a.prototype.addn = function(t6) {
                  return this.clone().iaddn(t6);
                }, a.prototype.subn = function(t6) {
                  return this.clone().isubn(t6);
                }, a.prototype.iabs = function() {
                  return this.negative = 0, this;
                }, a.prototype.abs = function() {
                  return this.clone().iabs();
                }, a.prototype._ishlnsubmul = function(t6, e6, r5) {
                  var i3, a2, o2 = t6.length + r5;
                  this._expand(o2);
                  var s2 = 0;
                  for (i3 = 0; i3 < t6.length; i3++) {
                    a2 = (0 | this.words[i3 + r5]) + s2;
                    var l2 = (0 | t6.words[i3]) * e6;
                    s2 = ((a2 -= 67108863 & l2) >> 26) - (l2 / 67108864 | 0), this.words[i3 + r5] = 67108863 & a2;
                  }
                  for (; i3 < this.length - r5; i3++)
                    s2 = (a2 = (0 | this.words[i3 + r5]) + s2) >> 26, this.words[i3 + r5] = 67108863 & a2;
                  if (0 === s2)
                    return this.strip();
                  for (n3(-1 === s2), s2 = 0, i3 = 0; i3 < this.length; i3++)
                    s2 = (a2 = -(0 | this.words[i3]) + s2) >> 26, this.words[i3] = 67108863 & a2;
                  return this.negative = 1, this.strip();
                }, a.prototype._wordDiv = function(t6, e6) {
                  var r5 = (this.length, t6.length), n4 = this.clone(), i3 = t6, o2 = 0 | i3.words[i3.length - 1];
                  0 != (r5 = 26 - this._countBits(o2)) && (i3 = i3.ushln(r5), n4.iushln(r5), o2 = 0 | i3.words[i3.length - 1]);
                  var s2, l2 = n4.length - i3.length;
                  if ("mod" !== e6) {
                    (s2 = new a(null)).length = l2 + 1, s2.words = new Array(s2.length);
                    for (var u2 = 0; u2 < s2.length; u2++)
                      s2.words[u2] = 0;
                  }
                  var c2 = n4.clone()._ishlnsubmul(i3, 1, l2);
                  0 === c2.negative && (n4 = c2, s2 && (s2.words[l2] = 1));
                  for (var f3 = l2 - 1; f3 >= 0; f3--) {
                    var h2 = 67108864 * (0 | n4.words[i3.length + f3]) + (0 | n4.words[i3.length + f3 - 1]);
                    for (h2 = Math.min(h2 / o2 | 0, 67108863), n4._ishlnsubmul(i3, h2, f3); 0 !== n4.negative; )
                      h2--, n4.negative = 0, n4._ishlnsubmul(i3, 1, f3), n4.isZero() || (n4.negative ^= 1);
                    s2 && (s2.words[f3] = h2);
                  }
                  return s2 && s2.strip(), n4.strip(), "div" !== e6 && 0 !== r5 && n4.iushrn(r5), { div: s2 || null, mod: n4 };
                }, a.prototype.divmod = function(t6, e6, r5) {
                  return n3(!t6.isZero()), this.isZero() ? { div: new a(0), mod: new a(0) } : 0 !== this.negative && 0 === t6.negative ? (s2 = this.neg().divmod(t6, e6), "mod" !== e6 && (i3 = s2.div.neg()), "div" !== e6 && (o2 = s2.mod.neg(), r5 && 0 !== o2.negative && o2.iadd(t6)), { div: i3, mod: o2 }) : 0 === this.negative && 0 !== t6.negative ? (s2 = this.divmod(t6.neg(), e6), "mod" !== e6 && (i3 = s2.div.neg()), { div: i3, mod: s2.mod }) : 0 != (this.negative & t6.negative) ? (s2 = this.neg().divmod(t6.neg(), e6), "div" !== e6 && (o2 = s2.mod.neg(), r5 && 0 !== o2.negative && o2.isub(t6)), { div: s2.div, mod: o2 }) : t6.length > this.length || this.cmp(t6) < 0 ? { div: new a(0), mod: this } : 1 === t6.length ? "div" === e6 ? { div: this.divn(t6.words[0]), mod: null } : "mod" === e6 ? { div: null, mod: new a(this.modn(t6.words[0])) } : { div: this.divn(t6.words[0]), mod: new a(this.modn(t6.words[0])) } : this._wordDiv(t6, e6);
                  var i3, o2, s2;
                }, a.prototype.div = function(t6) {
                  return this.divmod(t6, "div", false).div;
                }, a.prototype.mod = function(t6) {
                  return this.divmod(t6, "mod", false).mod;
                }, a.prototype.umod = function(t6) {
                  return this.divmod(t6, "mod", true).mod;
                }, a.prototype.divRound = function(t6) {
                  var e6 = this.divmod(t6);
                  if (e6.mod.isZero())
                    return e6.div;
                  var r5 = 0 !== e6.div.negative ? e6.mod.isub(t6) : e6.mod, n4 = t6.ushrn(1), i3 = t6.andln(1), a2 = r5.cmp(n4);
                  return a2 < 0 || 1 === i3 && 0 === a2 ? e6.div : 0 !== e6.div.negative ? e6.div.isubn(1) : e6.div.iaddn(1);
                }, a.prototype.modn = function(t6) {
                  n3(t6 <= 67108863);
                  for (var e6 = (1 << 26) % t6, r5 = 0, i3 = this.length - 1; i3 >= 0; i3--)
                    r5 = (e6 * r5 + (0 | this.words[i3])) % t6;
                  return r5;
                }, a.prototype.idivn = function(t6) {
                  n3(t6 <= 67108863);
                  for (var e6 = 0, r5 = this.length - 1; r5 >= 0; r5--) {
                    var i3 = (0 | this.words[r5]) + 67108864 * e6;
                    this.words[r5] = i3 / t6 | 0, e6 = i3 % t6;
                  }
                  return this.strip();
                }, a.prototype.divn = function(t6) {
                  return this.clone().idivn(t6);
                }, a.prototype.egcd = function(t6) {
                  n3(0 === t6.negative), n3(!t6.isZero());
                  var e6 = this, r5 = t6.clone();
                  e6 = 0 !== e6.negative ? e6.umod(t6) : e6.clone();
                  for (var i3 = new a(1), o2 = new a(0), s2 = new a(0), l2 = new a(1), u2 = 0; e6.isEven() && r5.isEven(); )
                    e6.iushrn(1), r5.iushrn(1), ++u2;
                  for (var c2 = r5.clone(), f3 = e6.clone(); !e6.isZero(); ) {
                    for (var h2 = 0, p3 = 1; 0 == (e6.words[0] & p3) && h2 < 26; ++h2, p3 <<= 1)
                      ;
                    if (h2 > 0)
                      for (e6.iushrn(h2); h2-- > 0; )
                        (i3.isOdd() || o2.isOdd()) && (i3.iadd(c2), o2.isub(f3)), i3.iushrn(1), o2.iushrn(1);
                    for (var d3 = 0, v2 = 1; 0 == (r5.words[0] & v2) && d3 < 26; ++d3, v2 <<= 1)
                      ;
                    if (d3 > 0)
                      for (r5.iushrn(d3); d3-- > 0; )
                        (s2.isOdd() || l2.isOdd()) && (s2.iadd(c2), l2.isub(f3)), s2.iushrn(1), l2.iushrn(1);
                    e6.cmp(r5) >= 0 ? (e6.isub(r5), i3.isub(s2), o2.isub(l2)) : (r5.isub(e6), s2.isub(i3), l2.isub(o2));
                  }
                  return { a: s2, b: l2, gcd: r5.iushln(u2) };
                }, a.prototype._invmp = function(t6) {
                  n3(0 === t6.negative), n3(!t6.isZero());
                  var e6 = this, r5 = t6.clone();
                  e6 = 0 !== e6.negative ? e6.umod(t6) : e6.clone();
                  for (var i3, o2 = new a(1), s2 = new a(0), l2 = r5.clone(); e6.cmpn(1) > 0 && r5.cmpn(1) > 0; ) {
                    for (var u2 = 0, c2 = 1; 0 == (e6.words[0] & c2) && u2 < 26; ++u2, c2 <<= 1)
                      ;
                    if (u2 > 0)
                      for (e6.iushrn(u2); u2-- > 0; )
                        o2.isOdd() && o2.iadd(l2), o2.iushrn(1);
                    for (var f3 = 0, h2 = 1; 0 == (r5.words[0] & h2) && f3 < 26; ++f3, h2 <<= 1)
                      ;
                    if (f3 > 0)
                      for (r5.iushrn(f3); f3-- > 0; )
                        s2.isOdd() && s2.iadd(l2), s2.iushrn(1);
                    e6.cmp(r5) >= 0 ? (e6.isub(r5), o2.isub(s2)) : (r5.isub(e6), s2.isub(o2));
                  }
                  return (i3 = 0 === e6.cmpn(1) ? o2 : s2).cmpn(0) < 0 && i3.iadd(t6), i3;
                }, a.prototype.gcd = function(t6) {
                  if (this.isZero())
                    return t6.abs();
                  if (t6.isZero())
                    return this.abs();
                  var e6 = this.clone(), r5 = t6.clone();
                  e6.negative = 0, r5.negative = 0;
                  for (var n4 = 0; e6.isEven() && r5.isEven(); n4++)
                    e6.iushrn(1), r5.iushrn(1);
                  for (; ; ) {
                    for (; e6.isEven(); )
                      e6.iushrn(1);
                    for (; r5.isEven(); )
                      r5.iushrn(1);
                    var i3 = e6.cmp(r5);
                    if (i3 < 0) {
                      var a2 = e6;
                      e6 = r5, r5 = a2;
                    } else if (0 === i3 || 0 === r5.cmpn(1))
                      break;
                    e6.isub(r5);
                  }
                  return r5.iushln(n4);
                }, a.prototype.invm = function(t6) {
                  return this.egcd(t6).a.umod(t6);
                }, a.prototype.isEven = function() {
                  return 0 == (1 & this.words[0]);
                }, a.prototype.isOdd = function() {
                  return 1 == (1 & this.words[0]);
                }, a.prototype.andln = function(t6) {
                  return this.words[0] & t6;
                }, a.prototype.bincn = function(t6) {
                  n3("number" == typeof t6);
                  var e6 = t6 % 26, r5 = (t6 - e6) / 26, i3 = 1 << e6;
                  if (this.length <= r5)
                    return this._expand(r5 + 1), this.words[r5] |= i3, this;
                  for (var a2 = i3, o2 = r5; 0 !== a2 && o2 < this.length; o2++) {
                    var s2 = 0 | this.words[o2];
                    a2 = (s2 += a2) >>> 26, s2 &= 67108863, this.words[o2] = s2;
                  }
                  return 0 !== a2 && (this.words[o2] = a2, this.length++), this;
                }, a.prototype.isZero = function() {
                  return 1 === this.length && 0 === this.words[0];
                }, a.prototype.cmpn = function(t6) {
                  var e6, r5 = t6 < 0;
                  if (0 !== this.negative && !r5)
                    return -1;
                  if (0 === this.negative && r5)
                    return 1;
                  if (this.strip(), this.length > 1)
                    e6 = 1;
                  else {
                    r5 && (t6 = -t6), n3(t6 <= 67108863, "Number is too big");
                    var i3 = 0 | this.words[0];
                    e6 = i3 === t6 ? 0 : i3 < t6 ? -1 : 1;
                  }
                  return 0 !== this.negative ? 0 | -e6 : e6;
                }, a.prototype.cmp = function(t6) {
                  if (0 !== this.negative && 0 === t6.negative)
                    return -1;
                  if (0 === this.negative && 0 !== t6.negative)
                    return 1;
                  var e6 = this.ucmp(t6);
                  return 0 !== this.negative ? 0 | -e6 : e6;
                }, a.prototype.ucmp = function(t6) {
                  if (this.length > t6.length)
                    return 1;
                  if (this.length < t6.length)
                    return -1;
                  for (var e6 = 0, r5 = this.length - 1; r5 >= 0; r5--) {
                    var n4 = 0 | this.words[r5], i3 = 0 | t6.words[r5];
                    if (n4 !== i3) {
                      n4 < i3 ? e6 = -1 : n4 > i3 && (e6 = 1);
                      break;
                    }
                  }
                  return e6;
                }, a.prototype.gtn = function(t6) {
                  return 1 === this.cmpn(t6);
                }, a.prototype.gt = function(t6) {
                  return 1 === this.cmp(t6);
                }, a.prototype.gten = function(t6) {
                  return this.cmpn(t6) >= 0;
                }, a.prototype.gte = function(t6) {
                  return this.cmp(t6) >= 0;
                }, a.prototype.ltn = function(t6) {
                  return -1 === this.cmpn(t6);
                }, a.prototype.lt = function(t6) {
                  return -1 === this.cmp(t6);
                }, a.prototype.lten = function(t6) {
                  return this.cmpn(t6) <= 0;
                }, a.prototype.lte = function(t6) {
                  return this.cmp(t6) <= 0;
                }, a.prototype.eqn = function(t6) {
                  return 0 === this.cmpn(t6);
                }, a.prototype.eq = function(t6) {
                  return 0 === this.cmp(t6);
                }, a.red = function(t6) {
                  return new T(t6);
                }, a.prototype.toRed = function(t6) {
                  return n3(!this.red, "Already a number in reduction context"), n3(0 === this.negative, "red works only with positives"), t6.convertTo(this)._forceRed(t6);
                }, a.prototype.fromRed = function() {
                  return n3(this.red, "fromRed works only with numbers in reduction context"), this.red.convertFrom(this);
                }, a.prototype._forceRed = function(t6) {
                  return this.red = t6, this;
                }, a.prototype.forceRed = function(t6) {
                  return n3(!this.red, "Already a number in reduction context"), this._forceRed(t6);
                }, a.prototype.redAdd = function(t6) {
                  return n3(this.red, "redAdd works only with red numbers"), this.red.add(this, t6);
                }, a.prototype.redIAdd = function(t6) {
                  return n3(this.red, "redIAdd works only with red numbers"), this.red.iadd(this, t6);
                }, a.prototype.redSub = function(t6) {
                  return n3(this.red, "redSub works only with red numbers"), this.red.sub(this, t6);
                }, a.prototype.redISub = function(t6) {
                  return n3(this.red, "redISub works only with red numbers"), this.red.isub(this, t6);
                }, a.prototype.redShl = function(t6) {
                  return n3(this.red, "redShl works only with red numbers"), this.red.shl(this, t6);
                }, a.prototype.redMul = function(t6) {
                  return n3(this.red, "redMul works only with red numbers"), this.red._verify2(this, t6), this.red.mul(this, t6);
                }, a.prototype.redIMul = function(t6) {
                  return n3(this.red, "redMul works only with red numbers"), this.red._verify2(this, t6), this.red.imul(this, t6);
                }, a.prototype.redSqr = function() {
                  return n3(this.red, "redSqr works only with red numbers"), this.red._verify1(this), this.red.sqr(this);
                }, a.prototype.redISqr = function() {
                  return n3(this.red, "redISqr works only with red numbers"), this.red._verify1(this), this.red.isqr(this);
                }, a.prototype.redSqrt = function() {
                  return n3(this.red, "redSqrt works only with red numbers"), this.red._verify1(this), this.red.sqrt(this);
                }, a.prototype.redInvm = function() {
                  return n3(this.red, "redInvm works only with red numbers"), this.red._verify1(this), this.red.invm(this);
                }, a.prototype.redNeg = function() {
                  return n3(this.red, "redNeg works only with red numbers"), this.red._verify1(this), this.red.neg(this);
                }, a.prototype.redPow = function(t6) {
                  return n3(this.red && !t6.red, "redPow(normalNum)"), this.red._verify1(this), this.red.pow(this, t6);
                };
                var y = { k256: null, p224: null, p192: null, p25519: null };
                function m2(t6, e6) {
                  this.name = t6, this.p = new a(e6, 16), this.n = this.p.bitLength(), this.k = new a(1).iushln(this.n).isub(this.p), this.tmp = this._tmp();
                }
                function x() {
                  m2.call(this, "k256", "ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff fffffffe fffffc2f");
                }
                function b() {
                  m2.call(this, "p224", "ffffffff ffffffff ffffffff ffffffff 00000000 00000000 00000001");
                }
                function _() {
                  m2.call(this, "p192", "ffffffff ffffffff ffffffff fffffffe ffffffff ffffffff");
                }
                function w2() {
                  m2.call(this, "25519", "7fffffffffffffff ffffffffffffffff ffffffffffffffff ffffffffffffffed");
                }
                function T(t6) {
                  if ("string" == typeof t6) {
                    var e6 = a._prime(t6);
                    this.m = e6.p, this.prime = e6;
                  } else
                    n3(t6.gtn(1), "modulus must be greater than 1"), this.m = t6, this.prime = null;
                }
                function k(t6) {
                  T.call(this, t6), this.shift = this.m.bitLength(), this.shift % 26 != 0 && (this.shift += 26 - this.shift % 26), this.r = new a(1).iushln(this.shift), this.r2 = this.imod(this.r.sqr()), this.rinv = this.r._invmp(this.m), this.minv = this.rinv.mul(this.r).isubn(1).div(this.m), this.minv = this.minv.umod(this.r), this.minv = this.r.sub(this.minv);
                }
                m2.prototype._tmp = function() {
                  var t6 = new a(null);
                  return t6.words = new Array(Math.ceil(this.n / 13)), t6;
                }, m2.prototype.ireduce = function(t6) {
                  var e6, r5 = t6;
                  do {
                    this.split(r5, this.tmp), e6 = (r5 = (r5 = this.imulK(r5)).iadd(this.tmp)).bitLength();
                  } while (e6 > this.n);
                  var n4 = e6 < this.n ? -1 : r5.ucmp(this.p);
                  return 0 === n4 ? (r5.words[0] = 0, r5.length = 1) : n4 > 0 ? r5.isub(this.p) : void 0 !== r5.strip ? r5.strip() : r5._strip(), r5;
                }, m2.prototype.split = function(t6, e6) {
                  t6.iushrn(this.n, 0, e6);
                }, m2.prototype.imulK = function(t6) {
                  return t6.imul(this.k);
                }, i2(x, m2), x.prototype.split = function(t6, e6) {
                  for (var r5 = 4194303, n4 = Math.min(t6.length, 9), i3 = 0; i3 < n4; i3++)
                    e6.words[i3] = t6.words[i3];
                  if (e6.length = n4, t6.length <= 9)
                    return t6.words[0] = 0, void (t6.length = 1);
                  var a2 = t6.words[9];
                  for (e6.words[e6.length++] = a2 & r5, i3 = 10; i3 < t6.length; i3++) {
                    var o2 = 0 | t6.words[i3];
                    t6.words[i3 - 10] = (o2 & r5) << 4 | a2 >>> 22, a2 = o2;
                  }
                  a2 >>>= 22, t6.words[i3 - 10] = a2, 0 === a2 && t6.length > 10 ? t6.length -= 10 : t6.length -= 9;
                }, x.prototype.imulK = function(t6) {
                  t6.words[t6.length] = 0, t6.words[t6.length + 1] = 0, t6.length += 2;
                  for (var e6 = 0, r5 = 0; r5 < t6.length; r5++) {
                    var n4 = 0 | t6.words[r5];
                    e6 += 977 * n4, t6.words[r5] = 67108863 & e6, e6 = 64 * n4 + (e6 / 67108864 | 0);
                  }
                  return 0 === t6.words[t6.length - 1] && (t6.length--, 0 === t6.words[t6.length - 1] && t6.length--), t6;
                }, i2(b, m2), i2(_, m2), i2(w2, m2), w2.prototype.imulK = function(t6) {
                  for (var e6 = 0, r5 = 0; r5 < t6.length; r5++) {
                    var n4 = 19 * (0 | t6.words[r5]) + e6, i3 = 67108863 & n4;
                    n4 >>>= 26, t6.words[r5] = i3, e6 = n4;
                  }
                  return 0 !== e6 && (t6.words[t6.length++] = e6), t6;
                }, a._prime = function(t6) {
                  if (y[t6])
                    return y[t6];
                  var e6;
                  if ("k256" === t6)
                    e6 = new x();
                  else if ("p224" === t6)
                    e6 = new b();
                  else if ("p192" === t6)
                    e6 = new _();
                  else {
                    if ("p25519" !== t6)
                      throw new Error("Unknown prime " + t6);
                    e6 = new w2();
                  }
                  return y[t6] = e6, e6;
                }, T.prototype._verify1 = function(t6) {
                  n3(0 === t6.negative, "red works only with positives"), n3(t6.red, "red works only with red numbers");
                }, T.prototype._verify2 = function(t6, e6) {
                  n3(0 == (t6.negative | e6.negative), "red works only with positives"), n3(t6.red && t6.red === e6.red, "red works only with red numbers");
                }, T.prototype.imod = function(t6) {
                  return this.prime ? this.prime.ireduce(t6)._forceRed(this) : t6.umod(this.m)._forceRed(this);
                }, T.prototype.neg = function(t6) {
                  return t6.isZero() ? t6.clone() : this.m.sub(t6)._forceRed(this);
                }, T.prototype.add = function(t6, e6) {
                  this._verify2(t6, e6);
                  var r5 = t6.add(e6);
                  return r5.cmp(this.m) >= 0 && r5.isub(this.m), r5._forceRed(this);
                }, T.prototype.iadd = function(t6, e6) {
                  this._verify2(t6, e6);
                  var r5 = t6.iadd(e6);
                  return r5.cmp(this.m) >= 0 && r5.isub(this.m), r5;
                }, T.prototype.sub = function(t6, e6) {
                  this._verify2(t6, e6);
                  var r5 = t6.sub(e6);
                  return r5.cmpn(0) < 0 && r5.iadd(this.m), r5._forceRed(this);
                }, T.prototype.isub = function(t6, e6) {
                  this._verify2(t6, e6);
                  var r5 = t6.isub(e6);
                  return r5.cmpn(0) < 0 && r5.iadd(this.m), r5;
                }, T.prototype.shl = function(t6, e6) {
                  return this._verify1(t6), this.imod(t6.ushln(e6));
                }, T.prototype.imul = function(t6, e6) {
                  return this._verify2(t6, e6), this.imod(t6.imul(e6));
                }, T.prototype.mul = function(t6, e6) {
                  return this._verify2(t6, e6), this.imod(t6.mul(e6));
                }, T.prototype.isqr = function(t6) {
                  return this.imul(t6, t6.clone());
                }, T.prototype.sqr = function(t6) {
                  return this.mul(t6, t6);
                }, T.prototype.sqrt = function(t6) {
                  if (t6.isZero())
                    return t6.clone();
                  var e6 = this.m.andln(3);
                  if (n3(e6 % 2 == 1), 3 === e6) {
                    var r5 = this.m.add(new a(1)).iushrn(2);
                    return this.pow(t6, r5);
                  }
                  for (var i3 = this.m.subn(1), o2 = 0; !i3.isZero() && 0 === i3.andln(1); )
                    o2++, i3.iushrn(1);
                  n3(!i3.isZero());
                  var s2 = new a(1).toRed(this), l2 = s2.redNeg(), u2 = this.m.subn(1).iushrn(1), c2 = this.m.bitLength();
                  for (c2 = new a(2 * c2 * c2).toRed(this); 0 !== this.pow(c2, u2).cmp(l2); )
                    c2.redIAdd(l2);
                  for (var f3 = this.pow(c2, i3), h2 = this.pow(t6, i3.addn(1).iushrn(1)), p3 = this.pow(t6, i3), d3 = o2; 0 !== p3.cmp(s2); ) {
                    for (var v2 = p3, g3 = 0; 0 !== v2.cmp(s2); g3++)
                      v2 = v2.redSqr();
                    n3(g3 < d3);
                    var y2 = this.pow(f3, new a(1).iushln(d3 - g3 - 1));
                    h2 = h2.redMul(y2), f3 = y2.redSqr(), p3 = p3.redMul(f3), d3 = g3;
                  }
                  return h2;
                }, T.prototype.invm = function(t6) {
                  var e6 = t6._invmp(this.m);
                  return 0 !== e6.negative ? (e6.negative = 0, this.imod(e6).redNeg()) : this.imod(e6);
                }, T.prototype.pow = function(t6, e6) {
                  if (e6.isZero())
                    return new a(1).toRed(this);
                  if (0 === e6.cmpn(1))
                    return t6.clone();
                  var r5 = new Array(16);
                  r5[0] = new a(1).toRed(this), r5[1] = t6;
                  for (var n4 = 2; n4 < r5.length; n4++)
                    r5[n4] = this.mul(r5[n4 - 1], t6);
                  var i3 = r5[0], o2 = 0, s2 = 0, l2 = e6.bitLength() % 26;
                  for (0 === l2 && (l2 = 26), n4 = e6.length - 1; n4 >= 0; n4--) {
                    for (var u2 = e6.words[n4], c2 = l2 - 1; c2 >= 0; c2--) {
                      var f3 = u2 >> c2 & 1;
                      i3 !== r5[0] && (i3 = this.sqr(i3)), 0 !== f3 || 0 !== o2 ? (o2 <<= 1, o2 |= f3, (4 == ++s2 || 0 === n4 && 0 === c2) && (i3 = this.mul(i3, r5[o2]), s2 = 0, o2 = 0)) : s2 = 0;
                    }
                    l2 = 26;
                  }
                  return i3;
                }, T.prototype.convertTo = function(t6) {
                  var e6 = t6.umod(this.m);
                  return e6 === t6 ? e6.clone() : e6;
                }, T.prototype.convertFrom = function(t6) {
                  var e6 = t6.clone();
                  return e6.red = null, e6;
                }, a.mont = function(t6) {
                  return new k(t6);
                }, i2(k, T), k.prototype.convertTo = function(t6) {
                  return this.imod(t6.ushln(this.shift));
                }, k.prototype.convertFrom = function(t6) {
                  var e6 = this.imod(t6.mul(this.rinv));
                  return e6.red = null, e6;
                }, k.prototype.imul = function(t6, e6) {
                  if (t6.isZero() || e6.isZero())
                    return t6.words[0] = 0, t6.length = 1, t6;
                  var r5 = t6.imul(e6), n4 = r5.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m), i3 = r5.isub(n4).iushrn(this.shift), a2 = i3;
                  return i3.cmp(this.m) >= 0 ? a2 = i3.isub(this.m) : i3.cmpn(0) < 0 && (a2 = i3.iadd(this.m)), a2._forceRed(this);
                }, k.prototype.mul = function(t6, e6) {
                  if (t6.isZero() || e6.isZero())
                    return new a(0)._forceRed(this);
                  var r5 = t6.mul(e6), n4 = r5.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m), i3 = r5.isub(n4).iushrn(this.shift), o2 = i3;
                  return i3.cmp(this.m) >= 0 ? o2 = i3.isub(this.m) : i3.cmpn(0) < 0 && (o2 = i3.iadd(this.m)), o2._forceRed(this);
                }, k.prototype.invm = function(t6) {
                  return this.imod(t6._invmp(this.m).mul(this.r2))._forceRed(this);
                };
              }(t4 = r4.nmd(t4), this);
            }, 2692: function(t4) {
              t4.exports = function(t5) {
                var e4, r4, n3, i2 = t5.length, a = 0;
                for (e4 = 0; e4 < i2; ++e4)
                  a += t5[e4].length;
                var o = new Array(a), s = 0;
                for (e4 = 0; e4 < i2; ++e4) {
                  var l = t5[e4], u = l.length;
                  for (r4 = 0; r4 < u; ++r4) {
                    var c = o[s++] = new Array(u - 1), f2 = 0;
                    for (n3 = 0; n3 < u; ++n3)
                      n3 !== r4 && (c[f2++] = l[n3]);
                    if (1 & r4) {
                      var h = c[1];
                      c[1] = c[0], c[0] = h;
                    }
                  }
                }
                return o;
              };
            }, 2569: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5) {
                switch (arguments.length) {
                  case 1:
                    return f2(t5);
                  case 2:
                    return "function" == typeof e5 ? u(t5, t5, e5, true) : h(t5, e5);
                  case 3:
                    return u(t5, e5, r5, false);
                  default:
                    throw new Error("box-intersect: Invalid arguments");
                }
              };
              var n3, i2 = r4(5306), a = r4(1390), o = r4(2337);
              function s(t5, e5) {
                for (var r5 = 0; r5 < t5; ++r5)
                  if (!(e5[r5] <= e5[r5 + t5]))
                    return true;
                return false;
              }
              function l(t5, e5, r5, n4) {
                for (var i3 = 0, a2 = 0, o2 = 0, l2 = t5.length; o2 < l2; ++o2) {
                  var u2 = t5[o2];
                  if (!s(e5, u2)) {
                    for (var c2 = 0; c2 < 2 * e5; ++c2)
                      r5[i3++] = u2[c2];
                    n4[a2++] = o2;
                  }
                }
                return a2;
              }
              function u(t5, e5, r5, n4) {
                var s2 = t5.length, u2 = e5.length;
                if (!(s2 <= 0 || u2 <= 0)) {
                  var c2 = t5[0].length >>> 1;
                  if (!(c2 <= 0)) {
                    var f3, h2 = i2.mallocDouble(2 * c2 * s2), p2 = i2.mallocInt32(s2);
                    if ((s2 = l(t5, c2, h2, p2)) > 0) {
                      if (1 === c2 && n4)
                        a.init(s2), f3 = a.sweepComplete(c2, r5, 0, s2, h2, p2, 0, s2, h2, p2);
                      else {
                        var d2 = i2.mallocDouble(2 * c2 * u2), v = i2.mallocInt32(u2);
                        (u2 = l(e5, c2, d2, v)) > 0 && (a.init(s2 + u2), f3 = 1 === c2 ? a.sweepBipartite(c2, r5, 0, s2, h2, p2, 0, u2, d2, v) : o(c2, r5, n4, s2, h2, p2, u2, d2, v), i2.free(d2), i2.free(v));
                      }
                      i2.free(h2), i2.free(p2);
                    }
                    return f3;
                  }
                }
              }
              function c(t5, e5) {
                n3.push([t5, e5]);
              }
              function f2(t5) {
                return n3 = [], u(t5, t5, c, true), n3;
              }
              function h(t5, e5) {
                return n3 = [], u(t5, e5, c, false), n3;
              }
            }, 7333: function(t4, e4) {
              function r4(t5) {
                return t5 ? function(t6, e5, r5, n3, i2, a, o, s, l, u, c) {
                  return i2 - n3 > l - s ? function(t7, e6, r6, n4, i3, a2, o2, s2, l2, u2, c2) {
                    for (var f2 = 2 * t7, h = n4, p2 = f2 * n4; h < i3; ++h, p2 += f2) {
                      var d2 = a2[e6 + p2], v = a2[e6 + p2 + t7], g2 = o2[h];
                      t:
                        for (var y = s2, m2 = f2 * s2; y < l2; ++y, m2 += f2) {
                          var x = u2[e6 + m2], b = u2[e6 + m2 + t7], _ = c2[y];
                          if (!(b < d2 || v < x)) {
                            for (var w2 = e6 + 1; w2 < t7; ++w2) {
                              var T = a2[w2 + p2], k = a2[w2 + t7 + p2], A = u2[w2 + m2], M = u2[w2 + t7 + m2];
                              if (k < A || M < T)
                                continue t;
                            }
                            var S = r6(g2, _);
                            if (void 0 !== S)
                              return S;
                          }
                        }
                    }
                  }(t6, e5, r5, n3, i2, a, o, s, l, u, c) : function(t7, e6, r6, n4, i3, a2, o2, s2, l2, u2, c2) {
                    for (var f2 = 2 * t7, h = s2, p2 = f2 * s2; h < l2; ++h, p2 += f2) {
                      var d2 = u2[e6 + p2], v = u2[e6 + p2 + t7], g2 = c2[h];
                      t:
                        for (var y = n4, m2 = f2 * n4; y < i3; ++y, m2 += f2) {
                          var x = a2[e6 + m2], b = a2[e6 + m2 + t7], _ = o2[y];
                          if (!(v < x || b < d2)) {
                            for (var w2 = e6 + 1; w2 < t7; ++w2) {
                              var T = a2[w2 + m2], k = a2[w2 + t7 + m2], A = u2[w2 + p2], M = u2[w2 + t7 + p2];
                              if (k < A || M < T)
                                continue t;
                            }
                            var S = r6(_, g2);
                            if (void 0 !== S)
                              return S;
                          }
                        }
                    }
                  }(t6, e5, r5, n3, i2, a, o, s, l, u, c);
                } : function(t6, e5, r5, n3, i2, a, o, s, l, u, c, f2) {
                  return a - i2 > u - l ? n3 ? function(t7, e6, r6, n4, i3, a2, o2, s2, l2, u2, c2) {
                    for (var f3 = 2 * t7, h = n4, p2 = f3 * n4; h < i3; ++h, p2 += f3) {
                      var d2 = a2[e6 + p2], v = a2[e6 + p2 + t7], g2 = o2[h];
                      t:
                        for (var y = s2, m2 = f3 * s2; y < l2; ++y, m2 += f3) {
                          var x = u2[e6 + m2], b = c2[y];
                          if (!(x <= d2 || v < x)) {
                            for (var _ = e6 + 1; _ < t7; ++_) {
                              var w2 = a2[_ + p2], T = a2[_ + t7 + p2], k = u2[_ + m2], A = u2[_ + t7 + m2];
                              if (T < k || A < w2)
                                continue t;
                            }
                            var M = r6(b, g2);
                            if (void 0 !== M)
                              return M;
                          }
                        }
                    }
                  }(t6, e5, r5, i2, a, o, s, l, u, c, f2) : function(t7, e6, r6, n4, i3, a2, o2, s2, l2, u2, c2) {
                    for (var f3 = 2 * t7, h = n4, p2 = f3 * n4; h < i3; ++h, p2 += f3) {
                      var d2 = a2[e6 + p2], v = a2[e6 + p2 + t7], g2 = o2[h];
                      t:
                        for (var y = s2, m2 = f3 * s2; y < l2; ++y, m2 += f3) {
                          var x = u2[e6 + m2], b = c2[y];
                          if (!(x < d2 || v < x)) {
                            for (var _ = e6 + 1; _ < t7; ++_) {
                              var w2 = a2[_ + p2], T = a2[_ + t7 + p2], k = u2[_ + m2], A = u2[_ + t7 + m2];
                              if (T < k || A < w2)
                                continue t;
                            }
                            var M = r6(g2, b);
                            if (void 0 !== M)
                              return M;
                          }
                        }
                    }
                  }(t6, e5, r5, i2, a, o, s, l, u, c, f2) : n3 ? function(t7, e6, r6, n4, i3, a2, o2, s2, l2, u2, c2) {
                    for (var f3 = 2 * t7, h = s2, p2 = f3 * s2; h < l2; ++h, p2 += f3) {
                      var d2 = u2[e6 + p2], v = c2[h];
                      t:
                        for (var g2 = n4, y = f3 * n4; g2 < i3; ++g2, y += f3) {
                          var m2 = a2[e6 + y], x = a2[e6 + y + t7], b = o2[g2];
                          if (!(d2 <= m2 || x < d2)) {
                            for (var _ = e6 + 1; _ < t7; ++_) {
                              var w2 = a2[_ + y], T = a2[_ + t7 + y], k = u2[_ + p2], A = u2[_ + t7 + p2];
                              if (T < k || A < w2)
                                continue t;
                            }
                            var M = r6(v, b);
                            if (void 0 !== M)
                              return M;
                          }
                        }
                    }
                  }(t6, e5, r5, i2, a, o, s, l, u, c, f2) : function(t7, e6, r6, n4, i3, a2, o2, s2, l2, u2, c2) {
                    for (var f3 = 2 * t7, h = s2, p2 = f3 * s2; h < l2; ++h, p2 += f3) {
                      var d2 = u2[e6 + p2], v = c2[h];
                      t:
                        for (var g2 = n4, y = f3 * n4; g2 < i3; ++g2, y += f3) {
                          var m2 = a2[e6 + y], x = a2[e6 + y + t7], b = o2[g2];
                          if (!(d2 < m2 || x < d2)) {
                            for (var _ = e6 + 1; _ < t7; ++_) {
                              var w2 = a2[_ + y], T = a2[_ + t7 + y], k = u2[_ + p2], A = u2[_ + t7 + p2];
                              if (T < k || A < w2)
                                continue t;
                            }
                            var M = r6(b, v);
                            if (void 0 !== M)
                              return M;
                          }
                        }
                    }
                  }(t6, e5, r5, i2, a, o, s, l, u, c, f2);
                };
              }
              e4.partial = r4(false), e4.full = r4(true);
            }, 2337: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5, a2, c2, w2, T, k, A) {
                !function(t6, e6) {
                  var r6 = 8 * i2.log2(e6 + 1) * (t6 + 1) | 0, a3 = i2.nextPow2(6 * r6);
                  y.length < a3 && (n3.free(y), y = n3.mallocInt32(a3));
                  var o2 = i2.nextPow2(2 * r6);
                  m2.length < o2 && (n3.free(m2), m2 = n3.mallocDouble(o2));
                }(t5, a2 + T);
                var M, S = 0, E = 2 * t5;
                for (x(S++, 0, 0, a2, 0, T, r5 ? 16 : 0, -1 / 0, 1 / 0), r5 || x(S++, 0, 0, T, 0, a2, 1, -1 / 0, 1 / 0); S > 0; ) {
                  var L = 6 * (S -= 1), C = y[L], P = y[L + 1], O = y[L + 2], I = y[L + 3], D = y[L + 4], z = y[L + 5], R = 2 * S, F = m2[R], B = m2[R + 1], N = 1 & z, j = !!(16 & z), U = c2, V = w2, H = k, q2 = A;
                  if (N && (U = k, V = A, H = c2, q2 = w2), !(2 & z && (O = p2(t5, C, P, O, U, V, B), P >= O) || 4 & z && (P = d2(t5, C, P, O, U, V, F)) >= O)) {
                    var G = O - P, Z = D - I;
                    if (j) {
                      if (t5 * G * (G + Z) < 4194304) {
                        if (void 0 !== (M = l.scanComplete(t5, C, e5, P, O, U, V, I, D, H, q2)))
                          return M;
                        continue;
                      }
                    } else {
                      if (t5 * Math.min(G, Z) < 128) {
                        if (void 0 !== (M = o(t5, C, e5, N, P, O, U, V, I, D, H, q2)))
                          return M;
                        continue;
                      }
                      if (t5 * G * Z < 4194304) {
                        if (void 0 !== (M = l.scanBipartite(t5, C, e5, N, P, O, U, V, I, D, H, q2)))
                          return M;
                        continue;
                      }
                    }
                    var Y = f2(t5, C, P, O, U, V, F, B);
                    if (P < Y)
                      if (t5 * (Y - P) < 128) {
                        if (void 0 !== (M = s(t5, C + 1, e5, P, Y, U, V, I, D, H, q2)))
                          return M;
                      } else if (C === t5 - 2) {
                        if (void 0 !== (M = N ? l.sweepBipartite(t5, e5, I, D, H, q2, P, Y, U, V) : l.sweepBipartite(t5, e5, P, Y, U, V, I, D, H, q2)))
                          return M;
                      } else
                        x(S++, C + 1, P, Y, I, D, N, -1 / 0, 1 / 0), x(S++, C + 1, I, D, P, Y, 1 ^ N, -1 / 0, 1 / 0);
                    if (Y < O) {
                      var W = u(t5, C, I, D, H, q2), X = H[E * W + C], J = h(t5, C, W, D, H, q2, X);
                      if (J < D && x(S++, C, Y, O, J, D, (4 | N) + (j ? 16 : 0), X, B), I < W && x(S++, C, Y, O, I, W, (2 | N) + (j ? 16 : 0), F, X), W + 1 === J) {
                        if (void 0 !== (M = j ? _(t5, C, e5, Y, O, U, V, W, H, q2[W]) : b(t5, C, e5, N, Y, O, U, V, W, H, q2[W])))
                          return M;
                      } else if (W < J) {
                        var K;
                        if (j) {
                          if (Y < (K = v(t5, C, Y, O, U, V, X))) {
                            var $ = h(t5, C, Y, K, U, V, X);
                            if (C === t5 - 2) {
                              if (Y < $ && void 0 !== (M = l.sweepComplete(t5, e5, Y, $, U, V, W, J, H, q2)))
                                return M;
                              if ($ < K && void 0 !== (M = l.sweepBipartite(t5, e5, $, K, U, V, W, J, H, q2)))
                                return M;
                            } else
                              Y < $ && x(S++, C + 1, Y, $, W, J, 16, -1 / 0, 1 / 0), $ < K && (x(S++, C + 1, $, K, W, J, 0, -1 / 0, 1 / 0), x(S++, C + 1, W, J, $, K, 1, -1 / 0, 1 / 0));
                          }
                        } else
                          Y < (K = N ? g2(t5, C, Y, O, U, V, X) : v(t5, C, Y, O, U, V, X)) && (C === t5 - 2 ? M = N ? l.sweepBipartite(t5, e5, W, J, H, q2, Y, K, U, V) : l.sweepBipartite(t5, e5, Y, K, U, V, W, J, H, q2) : (x(S++, C + 1, Y, K, W, J, N, -1 / 0, 1 / 0), x(S++, C + 1, W, J, Y, K, 1 ^ N, -1 / 0, 1 / 0)));
                      }
                    }
                  }
                }
              };
              var n3 = r4(5306), i2 = r4(2288), a = r4(7333), o = a.partial, s = a.full, l = r4(1390), u = r4(2464), c = r4(122), f2 = c("!(lo>=p0)&&!(p1>=hi)"), h = c("lo===p0"), p2 = c("lo<p0"), d2 = c("hi<=p0"), v = c("lo<=p0&&p0<=hi"), g2 = c("lo<p0&&p0<=hi"), y = n3.mallocInt32(1024), m2 = n3.mallocDouble(1024);
              function x(t5, e5, r5, n4, i3, a2, o2, s2, l2) {
                var u2 = 6 * t5;
                y[u2] = e5, y[u2 + 1] = r5, y[u2 + 2] = n4, y[u2 + 3] = i3, y[u2 + 4] = a2, y[u2 + 5] = o2;
                var c2 = 2 * t5;
                m2[c2] = s2, m2[c2 + 1] = l2;
              }
              function b(t5, e5, r5, n4, i3, a2, o2, s2, l2, u2, c2) {
                var f3 = 2 * t5, h2 = l2 * f3, p3 = u2[h2 + e5];
                t:
                  for (var d3 = i3, v2 = i3 * f3; d3 < a2; ++d3, v2 += f3) {
                    var g3 = o2[v2 + e5], y2 = o2[v2 + e5 + t5];
                    if (!(p3 < g3 || y2 < p3 || n4 && p3 === g3)) {
                      for (var m3, x2 = s2[d3], b2 = e5 + 1; b2 < t5; ++b2) {
                        g3 = o2[v2 + b2], y2 = o2[v2 + b2 + t5];
                        var _2 = u2[h2 + b2], w2 = u2[h2 + b2 + t5];
                        if (y2 < _2 || w2 < g3)
                          continue t;
                      }
                      if (void 0 !== (m3 = n4 ? r5(c2, x2) : r5(x2, c2)))
                        return m3;
                    }
                  }
              }
              function _(t5, e5, r5, n4, i3, a2, o2, s2, l2, u2) {
                var c2 = 2 * t5, f3 = s2 * c2, h2 = l2[f3 + e5];
                t:
                  for (var p3 = n4, d3 = n4 * c2; p3 < i3; ++p3, d3 += c2) {
                    var v2 = o2[p3];
                    if (v2 !== u2) {
                      var g3 = a2[d3 + e5], y2 = a2[d3 + e5 + t5];
                      if (!(h2 < g3 || y2 < h2)) {
                        for (var m3 = e5 + 1; m3 < t5; ++m3) {
                          g3 = a2[d3 + m3], y2 = a2[d3 + m3 + t5];
                          var x2 = l2[f3 + m3], b2 = l2[f3 + m3 + t5];
                          if (y2 < x2 || b2 < g3)
                            continue t;
                        }
                        var _2 = r5(v2, u2);
                        if (void 0 !== _2)
                          return _2;
                      }
                    }
                  }
              }
            }, 2464: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5, a, o, s) {
                if (a <= r5 + 1)
                  return r5;
                for (var l = r5, u = a, c = a + r5 >>> 1, f2 = 2 * t5, h = c, p2 = o[f2 * c + e5]; l < u; ) {
                  if (u - l < 8) {
                    i2(t5, e5, l, u, o, s), p2 = o[f2 * c + e5];
                    break;
                  }
                  var d2 = u - l, v = Math.random() * d2 + l | 0, g2 = o[f2 * v + e5], y = Math.random() * d2 + l | 0, m2 = o[f2 * y + e5], x = Math.random() * d2 + l | 0, b = o[f2 * x + e5];
                  g2 <= m2 ? b >= m2 ? (h = y, p2 = m2) : g2 >= b ? (h = v, p2 = g2) : (h = x, p2 = b) : m2 >= b ? (h = y, p2 = m2) : b >= g2 ? (h = v, p2 = g2) : (h = x, p2 = b);
                  for (var _ = f2 * (u - 1), w2 = f2 * h, T = 0; T < f2; ++T, ++_, ++w2) {
                    var k = o[_];
                    o[_] = o[w2], o[w2] = k;
                  }
                  var A = s[u - 1];
                  for (s[u - 1] = s[h], s[h] = A, _ = f2 * (u - 1), w2 = f2 * (h = n3(t5, e5, l, u - 1, o, s, p2)), T = 0; T < f2; ++T, ++_, ++w2)
                    k = o[_], o[_] = o[w2], o[w2] = k;
                  if (A = s[u - 1], s[u - 1] = s[h], s[h] = A, c < h) {
                    for (u = h - 1; l < u && o[f2 * (u - 1) + e5] === p2; )
                      u -= 1;
                    u += 1;
                  } else {
                    if (!(h < c))
                      break;
                    for (l = h + 1; l < u && o[f2 * l + e5] === p2; )
                      l += 1;
                  }
                }
                return n3(t5, e5, r5, c, o, s, o[f2 * c + e5]);
              };
              var n3 = r4(122)("lo<p0");
              function i2(t5, e5, r5, n4, i3, a) {
                for (var o = 2 * t5, s = o * (r5 + 1) + e5, l = r5 + 1; l < n4; ++l, s += o)
                  for (var u = i3[s], c = l, f2 = o * (l - 1); c > r5 && i3[f2 + e5] > u; --c, f2 -= o) {
                    for (var h = f2, p2 = f2 + o, d2 = 0; d2 < o; ++d2, ++h, ++p2) {
                      var v = i3[h];
                      i3[h] = i3[p2], i3[p2] = v;
                    }
                    var g2 = a[c];
                    a[c] = a[c - 1], a[c - 1] = g2;
                  }
              }
            }, 122: function(t4) {
              t4.exports = function(t5) {
                return e4[t5];
              };
              var e4 = { "lo===p0": function(t5, e5, r4, n3, i2, a, o) {
                for (var s = 2 * t5, l = s * r4, u = l, c = r4, f2 = e5, h = r4; n3 > h; ++h, l += s)
                  if (i2[l + f2] === o)
                    if (c === h)
                      c += 1, u += s;
                    else {
                      for (var p2 = 0; s > p2; ++p2) {
                        var d2 = i2[l + p2];
                        i2[l + p2] = i2[u], i2[u++] = d2;
                      }
                      var v = a[h];
                      a[h] = a[c], a[c++] = v;
                    }
                return c;
              }, "lo<p0": function(t5, e5, r4, n3, i2, a, o) {
                for (var s = 2 * t5, l = s * r4, u = l, c = r4, f2 = e5, h = r4; n3 > h; ++h, l += s)
                  if (i2[l + f2] < o)
                    if (c === h)
                      c += 1, u += s;
                    else {
                      for (var p2 = 0; s > p2; ++p2) {
                        var d2 = i2[l + p2];
                        i2[l + p2] = i2[u], i2[u++] = d2;
                      }
                      var v = a[h];
                      a[h] = a[c], a[c++] = v;
                    }
                return c;
              }, "lo<=p0": function(t5, e5, r4, n3, i2, a, o) {
                for (var s = 2 * t5, l = s * r4, u = l, c = r4, f2 = t5 + e5, h = r4; n3 > h; ++h, l += s)
                  if (i2[l + f2] <= o)
                    if (c === h)
                      c += 1, u += s;
                    else {
                      for (var p2 = 0; s > p2; ++p2) {
                        var d2 = i2[l + p2];
                        i2[l + p2] = i2[u], i2[u++] = d2;
                      }
                      var v = a[h];
                      a[h] = a[c], a[c++] = v;
                    }
                return c;
              }, "hi<=p0": function(t5, e5, r4, n3, i2, a, o) {
                for (var s = 2 * t5, l = s * r4, u = l, c = r4, f2 = t5 + e5, h = r4; n3 > h; ++h, l += s)
                  if (i2[l + f2] <= o)
                    if (c === h)
                      c += 1, u += s;
                    else {
                      for (var p2 = 0; s > p2; ++p2) {
                        var d2 = i2[l + p2];
                        i2[l + p2] = i2[u], i2[u++] = d2;
                      }
                      var v = a[h];
                      a[h] = a[c], a[c++] = v;
                    }
                return c;
              }, "lo<p0&&p0<=hi": function(t5, e5, r4, n3, i2, a, o) {
                for (var s = 2 * t5, l = s * r4, u = l, c = r4, f2 = e5, h = t5 + e5, p2 = r4; n3 > p2; ++p2, l += s) {
                  var d2 = i2[l + f2], v = i2[l + h];
                  if (d2 < o && o <= v)
                    if (c === p2)
                      c += 1, u += s;
                    else {
                      for (var g2 = 0; s > g2; ++g2) {
                        var y = i2[l + g2];
                        i2[l + g2] = i2[u], i2[u++] = y;
                      }
                      var m2 = a[p2];
                      a[p2] = a[c], a[c++] = m2;
                    }
                }
                return c;
              }, "lo<=p0&&p0<=hi": function(t5, e5, r4, n3, i2, a, o) {
                for (var s = 2 * t5, l = s * r4, u = l, c = r4, f2 = e5, h = t5 + e5, p2 = r4; n3 > p2; ++p2, l += s) {
                  var d2 = i2[l + f2], v = i2[l + h];
                  if (d2 <= o && o <= v)
                    if (c === p2)
                      c += 1, u += s;
                    else {
                      for (var g2 = 0; s > g2; ++g2) {
                        var y = i2[l + g2];
                        i2[l + g2] = i2[u], i2[u++] = y;
                      }
                      var m2 = a[p2];
                      a[p2] = a[c], a[c++] = m2;
                    }
                }
                return c;
              }, "!(lo>=p0)&&!(p1>=hi)": function(t5, e5, r4, n3, i2, a, o, s) {
                for (var l = 2 * t5, u = l * r4, c = u, f2 = r4, h = e5, p2 = t5 + e5, d2 = r4; n3 > d2; ++d2, u += l) {
                  var v = i2[u + h], g2 = i2[u + p2];
                  if (!(v >= o || s >= g2))
                    if (f2 === d2)
                      f2 += 1, c += l;
                    else {
                      for (var y = 0; l > y; ++y) {
                        var m2 = i2[u + y];
                        i2[u + y] = i2[c], i2[c++] = m2;
                      }
                      var x = a[d2];
                      a[d2] = a[f2], a[f2++] = x;
                    }
                }
                return f2;
              } };
            }, 309: function(t4) {
              function e4(t5, e5, r5) {
                for (var n4 = 2 * (t5 + 1), i3 = t5 + 1; i3 <= e5; ++i3) {
                  for (var a2 = r5[n4++], o2 = r5[n4++], s2 = i3, l2 = n4 - 2; s2-- > t5; ) {
                    var u = r5[l2 - 2], c = r5[l2 - 1];
                    if (u < a2)
                      break;
                    if (u === a2 && c < o2)
                      break;
                    r5[l2] = u, r5[l2 + 1] = c, l2 -= 2;
                  }
                  r5[l2] = a2, r5[l2 + 1] = o2;
                }
              }
              function r4(t5, e5, r5) {
                e5 *= 2;
                var n4 = r5[t5 *= 2], i3 = r5[t5 + 1];
                r5[t5] = r5[e5], r5[t5 + 1] = r5[e5 + 1], r5[e5] = n4, r5[e5 + 1] = i3;
              }
              function n3(t5, e5, r5) {
                e5 *= 2, r5[t5 *= 2] = r5[e5], r5[t5 + 1] = r5[e5 + 1];
              }
              function i2(t5, e5, r5, n4) {
                e5 *= 2, r5 *= 2;
                var i3 = n4[t5 *= 2], a2 = n4[t5 + 1];
                n4[t5] = n4[e5], n4[t5 + 1] = n4[e5 + 1], n4[e5] = n4[r5], n4[e5 + 1] = n4[r5 + 1], n4[r5] = i3, n4[r5 + 1] = a2;
              }
              function a(t5, e5, r5, n4, i3) {
                e5 *= 2, i3[t5 *= 2] = i3[e5], i3[e5] = r5, i3[t5 + 1] = i3[e5 + 1], i3[e5 + 1] = n4;
              }
              function o(t5, e5, r5) {
                e5 *= 2;
                var n4 = r5[t5 *= 2], i3 = r5[e5];
                return !(n4 < i3) && (n4 !== i3 || r5[t5 + 1] > r5[e5 + 1]);
              }
              function s(t5, e5, r5, n4) {
                var i3 = n4[t5 *= 2];
                return i3 < e5 || i3 === e5 && n4[t5 + 1] < r5;
              }
              function l(t5, u, c) {
                var f2 = (u - t5 + 1) / 6 | 0, h = t5 + f2, p2 = u - f2, d2 = t5 + u >> 1, v = d2 - f2, g2 = d2 + f2, y = h, m2 = v, x = d2, b = g2, _ = p2, w2 = t5 + 1, T = u - 1, k = 0;
                o(y, m2, c) && (k = y, y = m2, m2 = k), o(b, _, c) && (k = b, b = _, _ = k), o(y, x, c) && (k = y, y = x, x = k), o(m2, x, c) && (k = m2, m2 = x, x = k), o(y, b, c) && (k = y, y = b, b = k), o(x, b, c) && (k = x, x = b, b = k), o(m2, _, c) && (k = m2, m2 = _, _ = k), o(m2, x, c) && (k = m2, m2 = x, x = k), o(b, _, c) && (k = b, b = _, _ = k);
                for (var A = c[2 * m2], M = c[2 * m2 + 1], S = c[2 * b], E = c[2 * b + 1], L = 2 * y, C = 2 * x, P = 2 * _, O = 2 * h, I = 2 * d2, D = 2 * p2, z = 0; z < 2; ++z) {
                  var R = c[L + z], F = c[C + z], B = c[P + z];
                  c[O + z] = R, c[I + z] = F, c[D + z] = B;
                }
                n3(v, t5, c), n3(g2, u, c);
                for (var N = w2; N <= T; ++N)
                  if (s(N, A, M, c))
                    N !== w2 && r4(N, w2, c), ++w2;
                  else if (!s(N, S, E, c))
                    for (; ; ) {
                      if (s(T, S, E, c)) {
                        s(T, A, M, c) ? (i2(N, w2, T, c), ++w2, --T) : (r4(N, T, c), --T);
                        break;
                      }
                      if (--T < N)
                        break;
                    }
                a(t5, w2 - 1, A, M, c), a(u, T + 1, S, E, c), w2 - 2 - t5 <= 32 ? e4(t5, w2 - 2, c) : l(t5, w2 - 2, c), u - (T + 2) <= 32 ? e4(T + 2, u, c) : l(T + 2, u, c), T - w2 <= 32 ? e4(w2, T, c) : l(w2, T, c);
              }
              t4.exports = function(t5, r5) {
                r5 <= 128 ? e4(0, r5 - 1, t5) : l(0, r5 - 1, t5);
              };
            }, 1390: function(t4, e4, r4) {
              t4.exports = { init: function(t5) {
                var e5 = i2.nextPow2(t5);
                l.length < e5 && (n3.free(l), l = n3.mallocInt32(e5)), u.length < e5 && (n3.free(u), u = n3.mallocInt32(e5)), c.length < e5 && (n3.free(c), c = n3.mallocInt32(e5)), f2.length < e5 && (n3.free(f2), f2 = n3.mallocInt32(e5)), h.length < e5 && (n3.free(h), h = n3.mallocInt32(e5)), p2.length < e5 && (n3.free(p2), p2 = n3.mallocInt32(e5));
                var r5 = 8 * e5;
                d2.length < r5 && (n3.free(d2), d2 = n3.mallocDouble(r5));
              }, sweepBipartite: function(t5, e5, r5, n4, i3, s2, h2, p3, y, m2) {
                for (var x = 0, b = 2 * t5, _ = t5 - 1, w2 = b - 1, T = r5; T < n4; ++T) {
                  var k = s2[T], A = b * T;
                  d2[x++] = i3[A + _], d2[x++] = -(k + 1), d2[x++] = i3[A + w2], d2[x++] = k;
                }
                for (T = h2; T < p3; ++T) {
                  k = m2[T] + o;
                  var M = b * T;
                  d2[x++] = y[M + _], d2[x++] = -k, d2[x++] = y[M + w2], d2[x++] = k;
                }
                var S = x >>> 1;
                a(d2, S);
                var E = 0, L = 0;
                for (T = 0; T < S; ++T) {
                  var C = 0 | d2[2 * T + 1];
                  if (C >= o)
                    v(c, f2, L--, C = C - o | 0);
                  else if (C >= 0)
                    v(l, u, E--, C);
                  else if (C <= -268435456) {
                    C = -C - o | 0;
                    for (var P = 0; P < E; ++P)
                      if (void 0 !== (O = e5(l[P], C)))
                        return O;
                    g2(c, f2, L++, C);
                  } else {
                    for (C = -C - 1 | 0, P = 0; P < L; ++P) {
                      var O;
                      if (void 0 !== (O = e5(C, c[P])))
                        return O;
                    }
                    g2(l, u, E++, C);
                  }
                }
              }, sweepComplete: function(t5, e5, r5, n4, i3, o2, s2, y, m2, x) {
                for (var b = 0, _ = 2 * t5, w2 = t5 - 1, T = _ - 1, k = r5; k < n4; ++k) {
                  var A = o2[k] + 1 << 1, M = _ * k;
                  d2[b++] = i3[M + w2], d2[b++] = -A, d2[b++] = i3[M + T], d2[b++] = A;
                }
                for (k = s2; k < y; ++k) {
                  A = x[k] + 1 << 1;
                  var S = _ * k;
                  d2[b++] = m2[S + w2], d2[b++] = 1 | -A, d2[b++] = m2[S + T], d2[b++] = 1 | A;
                }
                var E = b >>> 1;
                a(d2, E);
                var L = 0, C = 0, P = 0;
                for (k = 0; k < E; ++k) {
                  var O = 0 | d2[2 * k + 1], I = 1 & O;
                  if (k < E - 1 && O >> 1 == d2[2 * k + 3] >> 1 && (I = 2, k += 1), O < 0) {
                    for (var D = -(O >> 1) - 1, z = 0; z < P; ++z)
                      if (void 0 !== (R = e5(h[z], D)))
                        return R;
                    if (0 !== I) {
                      for (z = 0; z < L; ++z)
                        if (void 0 !== (R = e5(l[z], D)))
                          return R;
                    }
                    if (1 !== I)
                      for (z = 0; z < C; ++z) {
                        var R;
                        if (void 0 !== (R = e5(c[z], D)))
                          return R;
                      }
                    0 === I ? g2(l, u, L++, D) : 1 === I ? g2(c, f2, C++, D) : 2 === I && g2(h, p2, P++, D);
                  } else
                    D = (O >> 1) - 1, 0 === I ? v(l, u, L--, D) : 1 === I ? v(c, f2, C--, D) : 2 === I && v(h, p2, P--, D);
                }
              }, scanBipartite: function(t5, e5, r5, n4, i3, s2, c2, f3, h2, p3, y, m2) {
                var x = 0, b = 2 * t5, _ = e5, w2 = e5 + t5, T = 1, k = 1;
                n4 ? k = o : T = o;
                for (var A = i3; A < s2; ++A) {
                  var M = A + T, S = b * A;
                  d2[x++] = c2[S + _], d2[x++] = -M, d2[x++] = c2[S + w2], d2[x++] = M;
                }
                for (A = h2; A < p3; ++A) {
                  M = A + k;
                  var E = b * A;
                  d2[x++] = y[E + _], d2[x++] = -M;
                }
                var L = x >>> 1;
                a(d2, L);
                var C = 0;
                for (A = 0; A < L; ++A) {
                  var P = 0 | d2[2 * A + 1];
                  if (P < 0) {
                    var O = false;
                    if ((M = -P) >= o ? (O = !n4, M -= o) : (O = !!n4, M -= 1), O)
                      g2(l, u, C++, M);
                    else {
                      var I = m2[M], D = b * M, z = y[D + e5 + 1], R = y[D + e5 + 1 + t5];
                      t:
                        for (var F = 0; F < C; ++F) {
                          var B = l[F], N = b * B;
                          if (!(R < c2[N + e5 + 1] || c2[N + e5 + 1 + t5] < z)) {
                            for (var j = e5 + 2; j < t5; ++j)
                              if (y[D + j + t5] < c2[N + j] || c2[N + j + t5] < y[D + j])
                                continue t;
                            var U, V = f3[B];
                            if (void 0 !== (U = n4 ? r5(I, V) : r5(V, I)))
                              return U;
                          }
                        }
                    }
                  } else
                    v(l, u, C--, P - T);
                }
              }, scanComplete: function(t5, e5, r5, n4, i3, s2, u2, c2, f3, h2, p3) {
                for (var v2 = 0, g3 = 2 * t5, y = e5, m2 = e5 + t5, x = n4; x < i3; ++x) {
                  var b = x + o, _ = g3 * x;
                  d2[v2++] = s2[_ + y], d2[v2++] = -b, d2[v2++] = s2[_ + m2], d2[v2++] = b;
                }
                for (x = c2; x < f3; ++x) {
                  b = x + 1;
                  var w2 = g3 * x;
                  d2[v2++] = h2[w2 + y], d2[v2++] = -b;
                }
                var T = v2 >>> 1;
                a(d2, T);
                var k = 0;
                for (x = 0; x < T; ++x) {
                  var A = 0 | d2[2 * x + 1];
                  if (A < 0)
                    if ((b = -A) >= o)
                      l[k++] = b - o;
                    else {
                      var M = p3[b -= 1], S = g3 * b, E = h2[S + e5 + 1], L = h2[S + e5 + 1 + t5];
                      t:
                        for (var C = 0; C < k; ++C) {
                          var P = l[C], O = u2[P];
                          if (O === M)
                            break;
                          var I = g3 * P;
                          if (!(L < s2[I + e5 + 1] || s2[I + e5 + 1 + t5] < E)) {
                            for (var D = e5 + 2; D < t5; ++D)
                              if (h2[S + D + t5] < s2[I + D] || s2[I + D + t5] < h2[S + D])
                                continue t;
                            var z = r5(O, M);
                            if (void 0 !== z)
                              return z;
                          }
                        }
                    }
                  else {
                    for (b = A - o, C = k - 1; C >= 0; --C)
                      if (l[C] === b) {
                        for (D = C + 1; D < k; ++D)
                          l[D - 1] = l[D];
                        break;
                      }
                    --k;
                  }
                }
              } };
              var n3 = r4(5306), i2 = r4(2288), a = r4(309), o = 1 << 28, s = 1024, l = n3.mallocInt32(s), u = n3.mallocInt32(s), c = n3.mallocInt32(s), f2 = n3.mallocInt32(s), h = n3.mallocInt32(s), p2 = n3.mallocInt32(s), d2 = n3.mallocDouble(8192);
              function v(t5, e5, r5, n4) {
                var i3 = e5[n4], a2 = t5[r5 - 1];
                t5[i3] = a2, e5[a2] = i3;
              }
              function g2(t5, e5, r5, n4) {
                t5[r5] = n4, e5[n4] = r5;
              }
            }, 7761: function(t4, e4, r4) {
              var n3 = r4(9971), i2 = r4(743), a = r4(2161), o = r4(7098);
              function s(t5) {
                return [Math.min(t5[0], t5[1]), Math.max(t5[0], t5[1])];
              }
              function l(t5, e5) {
                return t5[0] - e5[0] || t5[1] - e5[1];
              }
              function u(t5, e5, r5) {
                return e5 in t5 ? t5[e5] : r5;
              }
              t4.exports = function(t5, e5, r5) {
                Array.isArray(e5) ? (r5 = r5 || {}, e5 = e5 || []) : (r5 = e5 || {}, e5 = []);
                var c = !!u(r5, "delaunay", true), f2 = !!u(r5, "interior", true), h = !!u(r5, "exterior", true), p2 = !!u(r5, "infinity", false);
                if (!f2 && !h || 0 === t5.length)
                  return [];
                var d2 = n3(t5, e5);
                if (c || f2 !== h || p2) {
                  for (var v = i2(t5.length, function(t6) {
                    return t6.map(s).sort(l);
                  }(e5)), g2 = 0; g2 < d2.length; ++g2) {
                    var y = d2[g2];
                    v.addTriangle(y[0], y[1], y[2]);
                  }
                  return c && a(t5, v), h ? f2 ? p2 ? o(v, 0, p2) : v.cells() : o(v, 1, p2) : o(v, -1);
                }
                return d2;
              };
            }, 2161: function(t4, e4, r4) {
              var n3 = r4(2227)[4];
              function i2(t5, e5, r5, i3, a, o) {
                var s = e5.opposite(i3, a);
                if (!(s < 0)) {
                  if (a < i3) {
                    var l = i3;
                    i3 = a, a = l, l = o, o = s, s = l;
                  }
                  e5.isConstraint(i3, a) || n3(t5[i3], t5[a], t5[o], t5[s]) < 0 && r5.push(i3, a);
                }
              }
              r4(5070), t4.exports = function(t5, e5) {
                for (var r5 = [], a = t5.length, o = e5.stars, s = 0; s < a; ++s)
                  for (var l = o[s], u = 1; u < l.length; u += 2)
                    if (!((p2 = l[u]) < s || e5.isConstraint(s, p2))) {
                      for (var c = l[u - 1], f2 = -1, h = 1; h < l.length; h += 2)
                        if (l[h - 1] === p2) {
                          f2 = l[h];
                          break;
                        }
                      f2 < 0 || n3(t5[s], t5[p2], t5[c], t5[f2]) < 0 && r5.push(s, p2);
                    }
                for (; r5.length > 0; ) {
                  for (var p2 = r5.pop(), d2 = (c = -1, f2 = -1, l = o[s = r5.pop()], 1); d2 < l.length; d2 += 2) {
                    var v = l[d2 - 1], g2 = l[d2];
                    v === p2 ? f2 = g2 : g2 === p2 && (c = v);
                  }
                  c < 0 || f2 < 0 || n3(t5[s], t5[p2], t5[c], t5[f2]) >= 0 || (e5.flip(s, p2), i2(t5, e5, r5, c, s, f2), i2(t5, e5, r5, s, f2, c), i2(t5, e5, r5, f2, p2, c), i2(t5, e5, r5, p2, c, f2));
                }
              };
            }, 7098: function(t4, e4, r4) {
              var n3, i2 = r4(5070);
              function a(t5, e5, r5, n4, i3, a2, o2) {
                this.cells = t5, this.neighbor = e5, this.flags = n4, this.constraint = r5, this.active = i3, this.next = a2, this.boundary = o2;
              }
              function o(t5, e5) {
                return t5[0] - e5[0] || t5[1] - e5[1] || t5[2] - e5[2];
              }
              t4.exports = function(t5, e5, r5) {
                var n4 = function(t6, e6) {
                  for (var r6 = t6.cells(), n5 = r6.length, i4 = 0; i4 < n5; ++i4) {
                    var s2 = (y2 = r6[i4])[0], l2 = y2[1], u2 = y2[2];
                    l2 < u2 ? l2 < s2 && (y2[0] = l2, y2[1] = u2, y2[2] = s2) : u2 < s2 && (y2[0] = u2, y2[1] = s2, y2[2] = l2);
                  }
                  r6.sort(o);
                  var c2 = new Array(n5);
                  for (i4 = 0; i4 < c2.length; ++i4)
                    c2[i4] = 0;
                  var f3 = [], h2 = [], p3 = new Array(3 * n5), d3 = new Array(3 * n5), v2 = null;
                  e6 && (v2 = []);
                  var g3 = new a(r6, p3, d3, c2, f3, h2, v2);
                  for (i4 = 0; i4 < n5; ++i4)
                    for (var y2 = r6[i4], m2 = 0; m2 < 3; ++m2) {
                      s2 = y2[m2], l2 = y2[(m2 + 1) % 3];
                      var x = p3[3 * i4 + m2] = g3.locate(l2, s2, t6.opposite(l2, s2)), b = d3[3 * i4 + m2] = t6.isConstraint(s2, l2);
                      x < 0 && (b ? h2.push(i4) : (f3.push(i4), c2[i4] = 1), e6 && v2.push([l2, s2, -1]));
                    }
                  return g3;
                }(t5, r5);
                if (0 === e5)
                  return r5 ? n4.cells.concat(n4.boundary) : n4.cells;
                for (var i3 = 1, s = n4.active, l = n4.next, u = n4.flags, c = n4.cells, f2 = n4.constraint, h = n4.neighbor; s.length > 0 || l.length > 0; ) {
                  for (; s.length > 0; ) {
                    var p2 = s.pop();
                    if (u[p2] !== -i3) {
                      u[p2] = i3, c[p2];
                      for (var d2 = 0; d2 < 3; ++d2) {
                        var v = h[3 * p2 + d2];
                        v >= 0 && 0 === u[v] && (f2[3 * p2 + d2] ? l.push(v) : (s.push(v), u[v] = i3));
                      }
                    }
                  }
                  var g2 = l;
                  l = s, s = g2, l.length = 0, i3 = -i3;
                }
                var y = function(t6, e6, r6) {
                  for (var n5 = 0, i4 = 0; i4 < t6.length; ++i4)
                    e6[i4] === r6 && (t6[n5++] = t6[i4]);
                  return t6.length = n5, t6;
                }(c, u, e5);
                return r5 ? y.concat(n4.boundary) : y;
              }, a.prototype.locate = (n3 = [0, 0, 0], function(t5, e5, r5) {
                var a2 = t5, s = e5, l = r5;
                return e5 < r5 ? e5 < t5 && (a2 = e5, s = r5, l = t5) : r5 < t5 && (a2 = r5, s = t5, l = e5), a2 < 0 ? -1 : (n3[0] = a2, n3[1] = s, n3[2] = l, i2.eq(this.cells, n3, o));
              });
            }, 9971: function(t4, e4, r4) {
              var n3 = r4(5070), i2 = r4(417)[3];
              function a(t5, e5, r5, n4, i3) {
                this.a = t5, this.b = e5, this.idx = r5, this.lowerIds = n4, this.upperIds = i3;
              }
              function o(t5, e5, r5, n4) {
                this.a = t5, this.b = e5, this.type = r5, this.idx = n4;
              }
              function s(t5, e5) {
                var r5 = t5.a[0] - e5.a[0] || t5.a[1] - e5.a[1] || t5.type - e5.type;
                return r5 || (0 !== t5.type && (r5 = i2(t5.a, t5.b, e5.b)) ? r5 : t5.idx - e5.idx);
              }
              function l(t5, e5) {
                return i2(t5.a, t5.b, e5);
              }
              function u(t5, e5, r5, a2, o2) {
                for (var s2 = n3.lt(e5, a2, l), u2 = n3.gt(e5, a2, l), c2 = s2; c2 < u2; ++c2) {
                  for (var f3 = e5[c2], h2 = f3.lowerIds, p2 = h2.length; p2 > 1 && i2(r5[h2[p2 - 2]], r5[h2[p2 - 1]], a2) > 0; )
                    t5.push([h2[p2 - 1], h2[p2 - 2], o2]), p2 -= 1;
                  h2.length = p2, h2.push(o2);
                  var d2 = f3.upperIds;
                  for (p2 = d2.length; p2 > 1 && i2(r5[d2[p2 - 2]], r5[d2[p2 - 1]], a2) < 0; )
                    t5.push([d2[p2 - 2], d2[p2 - 1], o2]), p2 -= 1;
                  d2.length = p2, d2.push(o2);
                }
              }
              function c(t5, e5) {
                var r5;
                return (r5 = t5.a[0] < e5.a[0] ? i2(t5.a, t5.b, e5.a) : i2(e5.b, e5.a, t5.a)) ? r5 : (r5 = e5.b[0] < t5.b[0] ? i2(t5.a, t5.b, e5.b) : i2(e5.b, e5.a, t5.b)) || t5.idx - e5.idx;
              }
              function f2(t5, e5, r5) {
                var i3 = n3.le(t5, r5, c), o2 = t5[i3], s2 = o2.upperIds, l2 = s2[s2.length - 1];
                o2.upperIds = [l2], t5.splice(i3 + 1, 0, new a(r5.a, r5.b, r5.idx, [l2], s2));
              }
              function h(t5, e5, r5) {
                var i3 = r5.a;
                r5.a = r5.b, r5.b = i3;
                var a2 = n3.eq(t5, r5, c), o2 = t5[a2];
                t5[a2 - 1].upperIds = o2.upperIds, t5.splice(a2, 1);
              }
              t4.exports = function(t5, e5) {
                for (var r5 = t5.length, n4 = e5.length, i3 = [], l2 = 0; l2 < r5; ++l2)
                  i3.push(new o(t5[l2], null, 0, l2));
                for (l2 = 0; l2 < n4; ++l2) {
                  var c2 = e5[l2], p2 = t5[c2[0]], d2 = t5[c2[1]];
                  p2[0] < d2[0] ? i3.push(new o(p2, d2, 2, l2), new o(d2, p2, 1, l2)) : p2[0] > d2[0] && i3.push(new o(d2, p2, 2, l2), new o(p2, d2, 1, l2));
                }
                i3.sort(s);
                for (var v = i3[0].a[0] - (1 + Math.abs(i3[0].a[0])) * Math.pow(2, -52), g2 = [new a([v, 1], [v, 0], -1, [], [])], y = [], m2 = (l2 = 0, i3.length); l2 < m2; ++l2) {
                  var x = i3[l2], b = x.type;
                  0 === b ? u(y, g2, t5, x.a, x.idx) : 2 === b ? f2(g2, 0, x) : h(g2, 0, x);
                }
                return y;
              };
            }, 743: function(t4, e4, r4) {
              var n3 = r4(5070);
              function i2(t5, e5) {
                this.stars = t5, this.edges = e5;
              }
              t4.exports = function(t5, e5) {
                for (var r5 = new Array(t5), n4 = 0; n4 < t5; ++n4)
                  r5[n4] = [];
                return new i2(r5, e5);
              };
              var a = i2.prototype;
              function o(t5, e5, r5) {
                for (var n4 = 1, i3 = t5.length; n4 < i3; n4 += 2)
                  if (t5[n4 - 1] === e5 && t5[n4] === r5)
                    return t5[n4 - 1] = t5[i3 - 2], t5[n4] = t5[i3 - 1], void (t5.length = i3 - 2);
              }
              a.isConstraint = function() {
                var t5 = [0, 0];
                function e5(t6, e6) {
                  return t6[0] - e6[0] || t6[1] - e6[1];
                }
                return function(r5, i3) {
                  return t5[0] = Math.min(r5, i3), t5[1] = Math.max(r5, i3), n3.eq(this.edges, t5, e5) >= 0;
                };
              }(), a.removeTriangle = function(t5, e5, r5) {
                var n4 = this.stars;
                o(n4[t5], e5, r5), o(n4[e5], r5, t5), o(n4[r5], t5, e5);
              }, a.addTriangle = function(t5, e5, r5) {
                var n4 = this.stars;
                n4[t5].push(e5, r5), n4[e5].push(r5, t5), n4[r5].push(t5, e5);
              }, a.opposite = function(t5, e5) {
                for (var r5 = this.stars[e5], n4 = 1, i3 = r5.length; n4 < i3; n4 += 2)
                  if (r5[n4] === t5)
                    return r5[n4 - 1];
                return -1;
              }, a.flip = function(t5, e5) {
                var r5 = this.opposite(t5, e5), n4 = this.opposite(e5, t5);
                this.removeTriangle(t5, e5, r5), this.removeTriangle(e5, t5, n4), this.addTriangle(t5, n4, r5), this.addTriangle(e5, r5, n4);
              }, a.edges = function() {
                for (var t5 = this.stars, e5 = [], r5 = 0, n4 = t5.length; r5 < n4; ++r5)
                  for (var i3 = t5[r5], a2 = 0, o2 = i3.length; a2 < o2; a2 += 2)
                    e5.push([i3[a2], i3[a2 + 1]]);
                return e5;
              }, a.cells = function() {
                for (var t5 = this.stars, e5 = [], r5 = 0, n4 = t5.length; r5 < n4; ++r5)
                  for (var i3 = t5[r5], a2 = 0, o2 = i3.length; a2 < o2; a2 += 2) {
                    var s = i3[a2], l = i3[a2 + 1];
                    r5 < Math.min(s, l) && e5.push([r5, s, l]);
                  }
                return e5;
              };
            }, 9887: function(t4) {
              t4.exports = function(t5) {
                for (var e4 = 1, r4 = 1; r4 < t5.length; ++r4)
                  for (var n3 = 0; n3 < r4; ++n3)
                    if (t5[r4] < t5[n3])
                      e4 = -e4;
                    else if (t5[n3] === t5[r4])
                      return 0;
                return e4;
              };
            }, 9243: function(t4, e4, r4) {
              var n3 = r4(3094), i2 = r4(6606);
              function a(t5, e5) {
                for (var r5 = 0, n4 = t5.length, i3 = 0; i3 < n4; ++i3)
                  r5 += t5[i3] * e5[i3];
                return r5;
              }
              function o(t5) {
                var e5 = t5.length;
                if (0 === e5)
                  return [];
                t5[0].length;
                var r5 = n3([t5.length + 1, t5.length + 1], 1), o2 = n3([t5.length + 1], 1);
                r5[e5][e5] = 0;
                for (var s2 = 0; s2 < e5; ++s2) {
                  for (var l = 0; l <= s2; ++l)
                    r5[l][s2] = r5[s2][l] = 2 * a(t5[s2], t5[l]);
                  o2[s2] = a(t5[s2], t5[s2]);
                }
                var u = i2(r5, o2), c = 0, f2 = u[e5 + 1];
                for (s2 = 0; s2 < f2.length; ++s2)
                  c += f2[s2];
                var h = new Array(e5);
                for (s2 = 0; s2 < e5; ++s2) {
                  f2 = u[s2];
                  var p2 = 0;
                  for (l = 0; l < f2.length; ++l)
                    p2 += f2[l];
                  h[s2] = p2 / c;
                }
                return h;
              }
              function s(t5) {
                if (0 === t5.length)
                  return [];
                for (var e5 = t5[0].length, r5 = n3([e5]), i3 = o(t5), a2 = 0; a2 < t5.length; ++a2)
                  for (var s2 = 0; s2 < e5; ++s2)
                    r5[s2] += t5[a2][s2] * i3[a2];
                return r5;
              }
              s.barycenetric = o, t4.exports = s;
            }, 1778: function(t4, e4, r4) {
              t4.exports = function(t5) {
                for (var e5 = n3(t5), r5 = 0, i2 = 0; i2 < t5.length; ++i2)
                  for (var a = t5[i2], o = 0; o < e5.length; ++o)
                    r5 += Math.pow(a[o] - e5[o], 2);
                return Math.sqrt(r5 / t5.length);
              };
              var n3 = r4(9243);
            }, 197: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5) {
                var n4;
                if (r5) {
                  n4 = e5;
                  for (var i3 = new Array(e5.length), a2 = 0; a2 < e5.length; ++a2) {
                    var o2 = e5[a2];
                    i3[a2] = [o2[0], o2[1], r5[a2]];
                  }
                  e5 = i3;
                }
                for (var s2 = function(t6, e6, r6) {
                  var n5 = d2(t6, [], p2(t6));
                  return y(e6, n5, r6), !!n5;
                }(t5, e5, !!r5); m2(t5, e5, !!r5); )
                  s2 = true;
                if (r5 && s2)
                  for (n4.length = 0, r5.length = 0, a2 = 0; a2 < e5.length; ++a2)
                    o2 = e5[a2], n4.push([o2[0], o2[1]]), r5.push(o2[2]);
                return s2;
              };
              var n3 = r4(1731), i2 = r4(2569), a = r4(4434), o = r4(5125), s = r4(8846), l = r4(7999), u = r4(2826), c = r4(8551), f2 = r4(5528);
              function h(t5) {
                var e5 = l(t5);
                return [c(e5, -1 / 0), c(e5, 1 / 0)];
              }
              function p2(t5) {
                for (var e5 = new Array(t5.length), r5 = 0; r5 < t5.length; ++r5) {
                  var n4 = t5[r5];
                  e5[r5] = [c(n4[0], -1 / 0), c(n4[1], -1 / 0), c(n4[0], 1 / 0), c(n4[1], 1 / 0)];
                }
                return e5;
              }
              function d2(t5, e5, r5) {
                for (var a2 = e5.length, o2 = new n3(a2), s2 = [], l2 = 0; l2 < e5.length; ++l2) {
                  var u2 = e5[l2], f3 = h(u2[0]), p3 = h(u2[1]);
                  s2.push([c(f3[0], -1 / 0), c(p3[0], -1 / 0), c(f3[1], 1 / 0), c(p3[1], 1 / 0)]);
                }
                i2(s2, function(t6, e6) {
                  o2.link(t6, e6);
                });
                var d3 = true, v2 = new Array(a2);
                for (l2 = 0; l2 < a2; ++l2)
                  (y2 = o2.find(l2)) !== l2 && (d3 = false, t5[y2] = [Math.min(t5[l2][0], t5[y2][0]), Math.min(t5[l2][1], t5[y2][1])]);
                if (d3)
                  return null;
                var g3 = 0;
                for (l2 = 0; l2 < a2; ++l2) {
                  var y2;
                  (y2 = o2.find(l2)) === l2 ? (v2[l2] = g3, t5[g3++] = t5[l2]) : v2[l2] = -1;
                }
                for (t5.length = g3, l2 = 0; l2 < a2; ++l2)
                  v2[l2] < 0 && (v2[l2] = v2[o2.find(l2)]);
                return v2;
              }
              function v(t5, e5) {
                return t5[0] - e5[0] || t5[1] - e5[1];
              }
              function g2(t5, e5) {
                return t5[0] - e5[0] || t5[1] - e5[1] || (t5[2] < e5[2] ? -1 : t5[2] > e5[2] ? 1 : 0);
              }
              function y(t5, e5, r5) {
                if (0 !== t5.length) {
                  if (e5)
                    for (var n4 = 0; n4 < t5.length; ++n4) {
                      var i3 = e5[(o2 = t5[n4])[0]], a2 = e5[o2[1]];
                      o2[0] = Math.min(i3, a2), o2[1] = Math.max(i3, a2);
                    }
                  else
                    for (n4 = 0; n4 < t5.length; ++n4) {
                      var o2;
                      i3 = (o2 = t5[n4])[0], a2 = o2[1], o2[0] = Math.min(i3, a2), o2[1] = Math.max(i3, a2);
                    }
                  r5 ? t5.sort(g2) : t5.sort(v);
                  var s2 = 1;
                  for (n4 = 1; n4 < t5.length; ++n4) {
                    var l2 = t5[n4 - 1], u2 = t5[n4];
                    (u2[0] !== l2[0] || u2[1] !== l2[1] || r5 && u2[2] !== l2[2]) && (t5[s2++] = u2);
                  }
                  t5.length = s2;
                }
              }
              function m2(t5, e5, r5) {
                var n4 = function(t6, e6) {
                  for (var r6 = new Array(e6.length), n5 = 0; n5 < e6.length; ++n5) {
                    var i3 = e6[n5], a2 = t6[i3[0]], o2 = t6[i3[1]];
                    r6[n5] = [c(Math.min(a2[0], o2[0]), -1 / 0), c(Math.min(a2[1], o2[1]), -1 / 0), c(Math.max(a2[0], o2[0]), 1 / 0), c(Math.max(a2[1], o2[1]), 1 / 0)];
                  }
                  return r6;
                }(t5, e5), h2 = function(t6, e6, r6) {
                  var n5 = [];
                  return i2(r6, function(r7, i3) {
                    var o2 = e6[r7], s2 = e6[i3];
                    if (o2[0] !== s2[0] && o2[0] !== s2[1] && o2[1] !== s2[0] && o2[1] !== s2[1]) {
                      var l2 = t6[o2[0]], u2 = t6[o2[1]], c2 = t6[s2[0]], f3 = t6[s2[1]];
                      a(l2, u2, c2, f3) && n5.push([r7, i3]);
                    }
                  }), n5;
                }(t5, e5, n4), v2 = function(t6, e6, r6, n5) {
                  var o2 = [];
                  return i2(r6, n5, function(r7, n6) {
                    var i3 = e6[r7];
                    if (i3[0] !== n6 && i3[1] !== n6) {
                      var s2 = t6[n6], l2 = t6[i3[0]], u2 = t6[i3[1]];
                      a(l2, u2, s2, s2) && o2.push([r7, n6]);
                    }
                  }), o2;
                }(t5, e5, n4, p2(t5)), g3 = function(t6, e6, r6, n5, i3) {
                  var a2, c2, h3 = t6.map(function(t7) {
                    return [o(t7[0]), o(t7[1])];
                  });
                  for (a2 = 0; a2 < r6.length; ++a2) {
                    var p3 = r6[a2];
                    c2 = p3[0];
                    var d3 = p3[1], v3 = e6[c2], g4 = e6[d3], y2 = f2(u(t6[v3[0]]), u(t6[v3[1]]), u(t6[g4[0]]), u(t6[g4[1]]));
                    if (y2) {
                      var m4 = t6.length;
                      t6.push([l(y2[0]), l(y2[1])]), h3.push(y2), n5.push([c2, m4], [d3, m4]);
                    }
                  }
                  for (n5.sort(function(t7, e7) {
                    if (t7[0] !== e7[0])
                      return t7[0] - e7[0];
                    var r7 = h3[t7[1]], n6 = h3[e7[1]];
                    return s(r7[0], n6[0]) || s(r7[1], n6[1]);
                  }), a2 = n5.length - 1; a2 >= 0; --a2) {
                    var x = e6[c2 = (S = n5[a2])[0]], b = x[0], _ = x[1], w2 = t6[b], T = t6[_];
                    if ((w2[0] - T[0] || w2[1] - T[1]) < 0) {
                      var k = b;
                      b = _, _ = k;
                    }
                    x[0] = b;
                    var A, M = x[1] = S[1];
                    for (i3 && (A = x[2]); a2 > 0 && n5[a2 - 1][0] === c2; ) {
                      var S, E = (S = n5[--a2])[1];
                      i3 ? e6.push([M, E, A]) : e6.push([M, E]), M = E;
                    }
                    i3 ? e6.push([M, _, A]) : e6.push([M, _]);
                  }
                  return h3;
                }(t5, e5, h2, v2, r5), m3 = d2(t5, g3);
                return y(e5, m3, r5), !!m3 || h2.length > 0 || v2.length > 0;
              }
            }, 5528: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5, n4) {
                var a2 = s(e5, t5), f2 = s(n4, r5), h = c(a2, f2);
                if (0 === o(h))
                  return null;
                var p2 = c(f2, s(t5, r5)), d2 = i2(p2, h), v = u(a2, d2);
                return l(t5, v);
              };
              var n3 = r4(3962), i2 = r4(9189), a = r4(4354), o = r4(4951), s = r4(6695), l = r4(7584), u = r4(4469);
              function c(t5, e5) {
                return a(n3(t5[0], e5[1]), n3(t5[1], e5[0]));
              }
            }, 5692: function(t4) {
              t4.exports = { jet: [{ index: 0, rgb: [0, 0, 131] }, { index: 0.125, rgb: [0, 60, 170] }, { index: 0.375, rgb: [5, 255, 255] }, { index: 0.625, rgb: [255, 255, 0] }, { index: 0.875, rgb: [250, 0, 0] }, { index: 1, rgb: [128, 0, 0] }], hsv: [{ index: 0, rgb: [255, 0, 0] }, { index: 0.169, rgb: [253, 255, 2] }, { index: 0.173, rgb: [247, 255, 2] }, { index: 0.337, rgb: [0, 252, 4] }, { index: 0.341, rgb: [0, 252, 10] }, { index: 0.506, rgb: [1, 249, 255] }, { index: 0.671, rgb: [2, 0, 253] }, { index: 0.675, rgb: [8, 0, 253] }, { index: 0.839, rgb: [255, 0, 251] }, { index: 0.843, rgb: [255, 0, 245] }, { index: 1, rgb: [255, 0, 6] }], hot: [{ index: 0, rgb: [0, 0, 0] }, { index: 0.3, rgb: [230, 0, 0] }, { index: 0.6, rgb: [255, 210, 0] }, { index: 1, rgb: [255, 255, 255] }], spring: [{ index: 0, rgb: [255, 0, 255] }, { index: 1, rgb: [255, 255, 0] }], summer: [{ index: 0, rgb: [0, 128, 102] }, { index: 1, rgb: [255, 255, 102] }], autumn: [{ index: 0, rgb: [255, 0, 0] }, { index: 1, rgb: [255, 255, 0] }], winter: [{ index: 0, rgb: [0, 0, 255] }, { index: 1, rgb: [0, 255, 128] }], bone: [{ index: 0, rgb: [0, 0, 0] }, { index: 0.376, rgb: [84, 84, 116] }, { index: 0.753, rgb: [169, 200, 200] }, { index: 1, rgb: [255, 255, 255] }], copper: [{ index: 0, rgb: [0, 0, 0] }, { index: 0.804, rgb: [255, 160, 102] }, { index: 1, rgb: [255, 199, 127] }], greys: [{ index: 0, rgb: [0, 0, 0] }, { index: 1, rgb: [255, 255, 255] }], yignbu: [{ index: 0, rgb: [8, 29, 88] }, { index: 0.125, rgb: [37, 52, 148] }, { index: 0.25, rgb: [34, 94, 168] }, { index: 0.375, rgb: [29, 145, 192] }, { index: 0.5, rgb: [65, 182, 196] }, { index: 0.625, rgb: [127, 205, 187] }, { index: 0.75, rgb: [199, 233, 180] }, { index: 0.875, rgb: [237, 248, 217] }, { index: 1, rgb: [255, 255, 217] }], greens: [{ index: 0, rgb: [0, 68, 27] }, { index: 0.125, rgb: [0, 109, 44] }, { index: 0.25, rgb: [35, 139, 69] }, { index: 0.375, rgb: [65, 171, 93] }, { index: 0.5, rgb: [116, 196, 118] }, { index: 0.625, rgb: [161, 217, 155] }, { index: 0.75, rgb: [199, 233, 192] }, { index: 0.875, rgb: [229, 245, 224] }, { index: 1, rgb: [247, 252, 245] }], yiorrd: [{ index: 0, rgb: [128, 0, 38] }, { index: 0.125, rgb: [189, 0, 38] }, { index: 0.25, rgb: [227, 26, 28] }, { index: 0.375, rgb: [252, 78, 42] }, { index: 0.5, rgb: [253, 141, 60] }, { index: 0.625, rgb: [254, 178, 76] }, { index: 0.75, rgb: [254, 217, 118] }, { index: 0.875, rgb: [255, 237, 160] }, { index: 1, rgb: [255, 255, 204] }], bluered: [{ index: 0, rgb: [0, 0, 255] }, { index: 1, rgb: [255, 0, 0] }], rdbu: [{ index: 0, rgb: [5, 10, 172] }, { index: 0.35, rgb: [106, 137, 247] }, { index: 0.5, rgb: [190, 190, 190] }, { index: 0.6, rgb: [220, 170, 132] }, { index: 0.7, rgb: [230, 145, 90] }, { index: 1, rgb: [178, 10, 28] }], picnic: [{ index: 0, rgb: [0, 0, 255] }, { index: 0.1, rgb: [51, 153, 255] }, { index: 0.2, rgb: [102, 204, 255] }, { index: 0.3, rgb: [153, 204, 255] }, { index: 0.4, rgb: [204, 204, 255] }, { index: 0.5, rgb: [255, 255, 255] }, { index: 0.6, rgb: [255, 204, 255] }, { index: 0.7, rgb: [255, 153, 255] }, { index: 0.8, rgb: [255, 102, 204] }, { index: 0.9, rgb: [255, 102, 102] }, { index: 1, rgb: [255, 0, 0] }], rainbow: [{ index: 0, rgb: [150, 0, 90] }, { index: 0.125, rgb: [0, 0, 200] }, { index: 0.25, rgb: [0, 25, 255] }, { index: 0.375, rgb: [0, 152, 255] }, { index: 0.5, rgb: [44, 255, 150] }, { index: 0.625, rgb: [151, 255, 0] }, { index: 0.75, rgb: [255, 234, 0] }, { index: 0.875, rgb: [255, 111, 0] }, { index: 1, rgb: [255, 0, 0] }], portland: [{ index: 0, rgb: [12, 51, 131] }, { index: 0.25, rgb: [10, 136, 186] }, { index: 0.5, rgb: [242, 211, 56] }, { index: 0.75, rgb: [242, 143, 56] }, { index: 1, rgb: [217, 30, 30] }], blackbody: [{ index: 0, rgb: [0, 0, 0] }, { index: 0.2, rgb: [230, 0, 0] }, { index: 0.4, rgb: [230, 210, 0] }, { index: 0.7, rgb: [255, 255, 255] }, { index: 1, rgb: [160, 200, 255] }], earth: [{ index: 0, rgb: [0, 0, 130] }, { index: 0.1, rgb: [0, 180, 180] }, { index: 0.2, rgb: [40, 210, 40] }, { index: 0.4, rgb: [230, 230, 50] }, { index: 0.6, rgb: [120, 70, 20] }, { index: 1, rgb: [255, 255, 255] }], electric: [{ index: 0, rgb: [0, 0, 0] }, { index: 0.15, rgb: [30, 0, 100] }, { index: 0.4, rgb: [120, 0, 100] }, { index: 0.6, rgb: [160, 90, 0] }, { index: 0.8, rgb: [230, 200, 0] }, { index: 1, rgb: [255, 250, 220] }], alpha: [{ index: 0, rgb: [255, 255, 255, 0] }, { index: 1, rgb: [255, 255, 255, 1] }], viridis: [{ index: 0, rgb: [68, 1, 84] }, { index: 0.13, rgb: [71, 44, 122] }, { index: 0.25, rgb: [59, 81, 139] }, { index: 0.38, rgb: [44, 113, 142] }, { index: 0.5, rgb: [33, 144, 141] }, { index: 0.63, rgb: [39, 173, 129] }, { index: 0.75, rgb: [92, 200, 99] }, { index: 0.88, rgb: [170, 220, 50] }, { index: 1, rgb: [253, 231, 37] }], inferno: [{ index: 0, rgb: [0, 0, 4] }, { index: 0.13, rgb: [31, 12, 72] }, { index: 0.25, rgb: [85, 15, 109] }, { index: 0.38, rgb: [136, 34, 106] }, { index: 0.5, rgb: [186, 54, 85] }, { index: 0.63, rgb: [227, 89, 51] }, { index: 0.75, rgb: [249, 140, 10] }, { index: 0.88, rgb: [249, 201, 50] }, { index: 1, rgb: [252, 255, 164] }], magma: [{ index: 0, rgb: [0, 0, 4] }, { index: 0.13, rgb: [28, 16, 68] }, { index: 0.25, rgb: [79, 18, 123] }, { index: 0.38, rgb: [129, 37, 129] }, { index: 0.5, rgb: [181, 54, 122] }, { index: 0.63, rgb: [229, 80, 100] }, { index: 0.75, rgb: [251, 135, 97] }, { index: 0.88, rgb: [254, 194, 135] }, { index: 1, rgb: [252, 253, 191] }], plasma: [{ index: 0, rgb: [13, 8, 135] }, { index: 0.13, rgb: [75, 3, 161] }, { index: 0.25, rgb: [125, 3, 168] }, { index: 0.38, rgb: [168, 34, 150] }, { index: 0.5, rgb: [203, 70, 121] }, { index: 0.63, rgb: [229, 107, 93] }, { index: 0.75, rgb: [248, 148, 65] }, { index: 0.88, rgb: [253, 195, 40] }, { index: 1, rgb: [240, 249, 33] }], warm: [{ index: 0, rgb: [125, 0, 179] }, { index: 0.13, rgb: [172, 0, 187] }, { index: 0.25, rgb: [219, 0, 170] }, { index: 0.38, rgb: [255, 0, 130] }, { index: 0.5, rgb: [255, 63, 74] }, { index: 0.63, rgb: [255, 123, 0] }, { index: 0.75, rgb: [234, 176, 0] }, { index: 0.88, rgb: [190, 228, 0] }, { index: 1, rgb: [147, 255, 0] }], cool: [{ index: 0, rgb: [125, 0, 179] }, { index: 0.13, rgb: [116, 0, 218] }, { index: 0.25, rgb: [98, 74, 237] }, { index: 0.38, rgb: [68, 146, 231] }, { index: 0.5, rgb: [0, 204, 197] }, { index: 0.63, rgb: [0, 247, 146] }, { index: 0.75, rgb: [0, 255, 88] }, { index: 0.88, rgb: [40, 255, 8] }, { index: 1, rgb: [147, 255, 0] }], "rainbow-soft": [{ index: 0, rgb: [125, 0, 179] }, { index: 0.1, rgb: [199, 0, 180] }, { index: 0.2, rgb: [255, 0, 121] }, { index: 0.3, rgb: [255, 108, 0] }, { index: 0.4, rgb: [222, 194, 0] }, { index: 0.5, rgb: [150, 255, 0] }, { index: 0.6, rgb: [0, 255, 55] }, { index: 0.7, rgb: [0, 246, 150] }, { index: 0.8, rgb: [50, 167, 222] }, { index: 0.9, rgb: [103, 51, 235] }, { index: 1, rgb: [124, 0, 186] }], bathymetry: [{ index: 0, rgb: [40, 26, 44] }, { index: 0.13, rgb: [59, 49, 90] }, { index: 0.25, rgb: [64, 76, 139] }, { index: 0.38, rgb: [63, 110, 151] }, { index: 0.5, rgb: [72, 142, 158] }, { index: 0.63, rgb: [85, 174, 163] }, { index: 0.75, rgb: [120, 206, 163] }, { index: 0.88, rgb: [187, 230, 172] }, { index: 1, rgb: [253, 254, 204] }], cdom: [{ index: 0, rgb: [47, 15, 62] }, { index: 0.13, rgb: [87, 23, 86] }, { index: 0.25, rgb: [130, 28, 99] }, { index: 0.38, rgb: [171, 41, 96] }, { index: 0.5, rgb: [206, 67, 86] }, { index: 0.63, rgb: [230, 106, 84] }, { index: 0.75, rgb: [242, 149, 103] }, { index: 0.88, rgb: [249, 193, 135] }, { index: 1, rgb: [254, 237, 176] }], chlorophyll: [{ index: 0, rgb: [18, 36, 20] }, { index: 0.13, rgb: [25, 63, 41] }, { index: 0.25, rgb: [24, 91, 59] }, { index: 0.38, rgb: [13, 119, 72] }, { index: 0.5, rgb: [18, 148, 80] }, { index: 0.63, rgb: [80, 173, 89] }, { index: 0.75, rgb: [132, 196, 122] }, { index: 0.88, rgb: [175, 221, 162] }, { index: 1, rgb: [215, 249, 208] }], density: [{ index: 0, rgb: [54, 14, 36] }, { index: 0.13, rgb: [89, 23, 80] }, { index: 0.25, rgb: [110, 45, 132] }, { index: 0.38, rgb: [120, 77, 178] }, { index: 0.5, rgb: [120, 113, 213] }, { index: 0.63, rgb: [115, 151, 228] }, { index: 0.75, rgb: [134, 185, 227] }, { index: 0.88, rgb: [177, 214, 227] }, { index: 1, rgb: [230, 241, 241] }], "freesurface-blue": [{ index: 0, rgb: [30, 4, 110] }, { index: 0.13, rgb: [47, 14, 176] }, { index: 0.25, rgb: [41, 45, 236] }, { index: 0.38, rgb: [25, 99, 212] }, { index: 0.5, rgb: [68, 131, 200] }, { index: 0.63, rgb: [114, 156, 197] }, { index: 0.75, rgb: [157, 181, 203] }, { index: 0.88, rgb: [200, 208, 216] }, { index: 1, rgb: [241, 237, 236] }], "freesurface-red": [{ index: 0, rgb: [60, 9, 18] }, { index: 0.13, rgb: [100, 17, 27] }, { index: 0.25, rgb: [142, 20, 29] }, { index: 0.38, rgb: [177, 43, 27] }, { index: 0.5, rgb: [192, 87, 63] }, { index: 0.63, rgb: [205, 125, 105] }, { index: 0.75, rgb: [216, 162, 148] }, { index: 0.88, rgb: [227, 199, 193] }, { index: 1, rgb: [241, 237, 236] }], oxygen: [{ index: 0, rgb: [64, 5, 5] }, { index: 0.13, rgb: [106, 6, 15] }, { index: 0.25, rgb: [144, 26, 7] }, { index: 0.38, rgb: [168, 64, 3] }, { index: 0.5, rgb: [188, 100, 4] }, { index: 0.63, rgb: [206, 136, 11] }, { index: 0.75, rgb: [220, 174, 25] }, { index: 0.88, rgb: [231, 215, 44] }, { index: 1, rgb: [248, 254, 105] }], par: [{ index: 0, rgb: [51, 20, 24] }, { index: 0.13, rgb: [90, 32, 35] }, { index: 0.25, rgb: [129, 44, 34] }, { index: 0.38, rgb: [159, 68, 25] }, { index: 0.5, rgb: [182, 99, 19] }, { index: 0.63, rgb: [199, 134, 22] }, { index: 0.75, rgb: [212, 171, 35] }, { index: 0.88, rgb: [221, 210, 54] }, { index: 1, rgb: [225, 253, 75] }], phase: [{ index: 0, rgb: [145, 105, 18] }, { index: 0.13, rgb: [184, 71, 38] }, { index: 0.25, rgb: [186, 58, 115] }, { index: 0.38, rgb: [160, 71, 185] }, { index: 0.5, rgb: [110, 97, 218] }, { index: 0.63, rgb: [50, 123, 164] }, { index: 0.75, rgb: [31, 131, 110] }, { index: 0.88, rgb: [77, 129, 34] }, { index: 1, rgb: [145, 105, 18] }], salinity: [{ index: 0, rgb: [42, 24, 108] }, { index: 0.13, rgb: [33, 50, 162] }, { index: 0.25, rgb: [15, 90, 145] }, { index: 0.38, rgb: [40, 118, 137] }, { index: 0.5, rgb: [59, 146, 135] }, { index: 0.63, rgb: [79, 175, 126] }, { index: 0.75, rgb: [120, 203, 104] }, { index: 0.88, rgb: [193, 221, 100] }, { index: 1, rgb: [253, 239, 154] }], temperature: [{ index: 0, rgb: [4, 35, 51] }, { index: 0.13, rgb: [23, 51, 122] }, { index: 0.25, rgb: [85, 59, 157] }, { index: 0.38, rgb: [129, 79, 143] }, { index: 0.5, rgb: [175, 95, 130] }, { index: 0.63, rgb: [222, 112, 101] }, { index: 0.75, rgb: [249, 146, 66] }, { index: 0.88, rgb: [249, 196, 65] }, { index: 1, rgb: [232, 250, 91] }], turbidity: [{ index: 0, rgb: [34, 31, 27] }, { index: 0.13, rgb: [65, 50, 41] }, { index: 0.25, rgb: [98, 69, 52] }, { index: 0.38, rgb: [131, 89, 57] }, { index: 0.5, rgb: [161, 112, 59] }, { index: 0.63, rgb: [185, 140, 66] }, { index: 0.75, rgb: [202, 174, 88] }, { index: 0.88, rgb: [216, 209, 126] }, { index: 1, rgb: [233, 246, 171] }], "velocity-blue": [{ index: 0, rgb: [17, 32, 64] }, { index: 0.13, rgb: [35, 52, 116] }, { index: 0.25, rgb: [29, 81, 156] }, { index: 0.38, rgb: [31, 113, 162] }, { index: 0.5, rgb: [50, 144, 169] }, { index: 0.63, rgb: [87, 173, 176] }, { index: 0.75, rgb: [149, 196, 189] }, { index: 0.88, rgb: [203, 221, 211] }, { index: 1, rgb: [254, 251, 230] }], "velocity-green": [{ index: 0, rgb: [23, 35, 19] }, { index: 0.13, rgb: [24, 64, 38] }, { index: 0.25, rgb: [11, 95, 45] }, { index: 0.38, rgb: [39, 123, 35] }, { index: 0.5, rgb: [95, 146, 12] }, { index: 0.63, rgb: [152, 165, 18] }, { index: 0.75, rgb: [201, 186, 69] }, { index: 0.88, rgb: [233, 216, 137] }, { index: 1, rgb: [255, 253, 205] }], cubehelix: [{ index: 0, rgb: [0, 0, 0] }, { index: 0.07, rgb: [22, 5, 59] }, { index: 0.13, rgb: [60, 4, 105] }, { index: 0.2, rgb: [109, 1, 135] }, { index: 0.27, rgb: [161, 0, 147] }, { index: 0.33, rgb: [210, 2, 142] }, { index: 0.4, rgb: [251, 11, 123] }, { index: 0.47, rgb: [255, 29, 97] }, { index: 0.53, rgb: [255, 54, 69] }, { index: 0.6, rgb: [255, 85, 46] }, { index: 0.67, rgb: [255, 120, 34] }, { index: 0.73, rgb: [255, 157, 37] }, { index: 0.8, rgb: [241, 191, 57] }, { index: 0.87, rgb: [224, 220, 93] }, { index: 0.93, rgb: [218, 241, 142] }, { index: 1, rgb: [227, 253, 198] }] };
            }, 9156: function(t4, e4, r4) {
              var n3 = r4(5692), i2 = r4(3578);
              function a(t5) {
                return [t5[0] / 255, t5[1] / 255, t5[2] / 255, t5[3]];
              }
              function o(t5) {
                for (var e5, r5 = "#", n4 = 0; n4 < 3; ++n4)
                  r5 += ("00" + (e5 = (e5 = t5[n4]).toString(16))).substr(e5.length);
                return r5;
              }
              function s(t5) {
                return "rgba(" + t5.join(",") + ")";
              }
              t4.exports = function(t5) {
                var e5, r5, l, u, c, f2, h, p2, d2, v;
                if (t5 || (t5 = {}), p2 = (t5.nshades || 72) - 1, h = t5.format || "hex", (f2 = t5.colormap) || (f2 = "jet"), "string" == typeof f2) {
                  if (f2 = f2.toLowerCase(), !n3[f2])
                    throw Error(f2 + " not a supported colorscale");
                  c = n3[f2];
                } else {
                  if (!Array.isArray(f2))
                    throw Error("unsupported colormap option", f2);
                  c = f2.slice();
                }
                if (c.length > p2 + 1)
                  throw new Error(f2 + " map requires nshades to be at least size " + c.length);
                d2 = Array.isArray(t5.alpha) ? 2 !== t5.alpha.length ? [1, 1] : t5.alpha.slice() : "number" == typeof t5.alpha ? [t5.alpha, t5.alpha] : [1, 1], e5 = c.map(function(t6) {
                  return Math.round(t6.index * p2);
                }), d2[0] = Math.min(Math.max(d2[0], 0), 1), d2[1] = Math.min(Math.max(d2[1], 0), 1);
                var g2 = c.map(function(t6, e6) {
                  var r6 = c[e6].index, n4 = c[e6].rgb.slice();
                  return 4 === n4.length && n4[3] >= 0 && n4[3] <= 1 || (n4[3] = d2[0] + (d2[1] - d2[0]) * r6), n4;
                }), y = [];
                for (v = 0; v < e5.length - 1; ++v) {
                  u = e5[v + 1] - e5[v], r5 = g2[v], l = g2[v + 1];
                  for (var m2 = 0; m2 < u; m2++) {
                    var x = m2 / u;
                    y.push([Math.round(i2(r5[0], l[0], x)), Math.round(i2(r5[1], l[1], x)), Math.round(i2(r5[2], l[2], x)), i2(r5[3], l[3], x)]);
                  }
                }
                return y.push(c[c.length - 1].rgb.concat(d2[1])), "hex" === h ? y = y.map(o) : "rgbaString" === h ? y = y.map(s) : "float" === h && (y = y.map(a)), y;
              };
            }, 9398: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5, a2) {
                var o2 = n3(e5, r5, a2);
                if (0 === o2) {
                  var s2 = i2(n3(t5, e5, r5)), u = i2(n3(t5, e5, a2));
                  if (s2 === u) {
                    if (0 === s2) {
                      var c = l(t5, e5, r5);
                      return c === l(t5, e5, a2) ? 0 : c ? 1 : -1;
                    }
                    return 0;
                  }
                  return 0 === u ? s2 > 0 || l(t5, e5, a2) ? -1 : 1 : 0 === s2 ? u > 0 || l(t5, e5, r5) ? 1 : -1 : i2(u - s2);
                }
                var f2 = n3(t5, e5, r5);
                return f2 > 0 ? o2 > 0 && n3(t5, e5, a2) > 0 ? 1 : -1 : f2 < 0 ? o2 > 0 || n3(t5, e5, a2) > 0 ? 1 : -1 : n3(t5, e5, a2) > 0 || l(t5, e5, r5) ? 1 : -1;
              };
              var n3 = r4(417), i2 = r4(7538), a = r4(87), o = r4(2019), s = r4(9662);
              function l(t5, e5, r5) {
                var n4 = a(t5[0], -e5[0]), i3 = a(t5[1], -e5[1]), l2 = a(r5[0], -e5[0]), u = a(r5[1], -e5[1]), c = s(o(n4, l2), o(i3, u));
                return c[c.length - 1] >= 0;
              }
            }, 7538: function(t4) {
              t4.exports = function(t5) {
                return t5 < 0 ? -1 : t5 > 0 ? 1 : 0;
              };
            }, 9209: function(t4) {
              t4.exports = function(t5, n3) {
                var i2 = t5.length, a = t5.length - n3.length;
                if (a)
                  return a;
                switch (i2) {
                  case 0:
                    return 0;
                  case 1:
                    return t5[0] - n3[0];
                  case 2:
                    return t5[0] + t5[1] - n3[0] - n3[1] || e4(t5[0], t5[1]) - e4(n3[0], n3[1]);
                  case 3:
                    var o = t5[0] + t5[1], s = n3[0] + n3[1];
                    if (a = o + t5[2] - (s + n3[2]))
                      return a;
                    var l = e4(t5[0], t5[1]), u = e4(n3[0], n3[1]);
                    return e4(l, t5[2]) - e4(u, n3[2]) || e4(l + t5[2], o) - e4(u + n3[2], s);
                  case 4:
                    var c = t5[0], f2 = t5[1], h = t5[2], p2 = t5[3], d2 = n3[0], v = n3[1], g2 = n3[2], y = n3[3];
                    return c + f2 + h + p2 - (d2 + v + g2 + y) || e4(c, f2, h, p2) - e4(d2, v, g2, y, d2) || e4(c + f2, c + h, c + p2, f2 + h, f2 + p2, h + p2) - e4(d2 + v, d2 + g2, d2 + y, v + g2, v + y, g2 + y) || e4(c + f2 + h, c + f2 + p2, c + h + p2, f2 + h + p2) - e4(d2 + v + g2, d2 + v + y, d2 + g2 + y, v + g2 + y);
                  default:
                    for (var m2 = t5.slice().sort(r4), x = n3.slice().sort(r4), b = 0; b < i2; ++b)
                      if (a = m2[b] - x[b])
                        return a;
                    return 0;
                }
              };
              var e4 = Math.min;
              function r4(t5, e5) {
                return t5 - e5;
              }
            }, 1284: function(t4, e4, r4) {
              var n3 = r4(9209), i2 = r4(9887);
              t4.exports = function(t5, e5) {
                return n3(t5, e5) || i2(t5) - i2(e5);
              };
            }, 5537: function(t4, e4, r4) {
              var n3 = r4(8950), i2 = r4(8722), a = r4(3332);
              t4.exports = function(t5) {
                var e5 = t5.length;
                if (0 === e5)
                  return [];
                if (1 === e5)
                  return [[0]];
                var r5 = t5[0].length;
                return 0 === r5 ? [] : 1 === r5 ? n3(t5) : 2 === r5 ? i2(t5) : a(t5, r5);
              };
            }, 8950: function(t4) {
              t4.exports = function(t5) {
                for (var e4 = 0, r4 = 0, n3 = 1; n3 < t5.length; ++n3)
                  t5[n3][0] < t5[e4][0] && (e4 = n3), t5[n3][0] > t5[r4][0] && (r4 = n3);
                return e4 < r4 ? [[e4], [r4]] : e4 > r4 ? [[r4], [e4]] : [[e4]];
              };
            }, 8722: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = n3(t5), r5 = e5.length;
                if (r5 <= 2)
                  return [];
                for (var i2 = new Array(r5), a = e5[r5 - 1], o = 0; o < r5; ++o) {
                  var s = e5[o];
                  i2[o] = [a, s], a = s;
                }
                return i2;
              };
              var n3 = r4(3266);
            }, 3332: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                try {
                  return n3(t5, true);
                } catch (o) {
                  var r5 = i2(t5);
                  if (r5.length <= e5)
                    return [];
                  var a = function(t6, e6) {
                    for (var r6 = t6.length, n4 = new Array(r6), i3 = 0; i3 < e6.length; ++i3)
                      n4[i3] = t6[e6[i3]];
                    var a2 = e6.length;
                    for (i3 = 0; i3 < r6; ++i3)
                      e6.indexOf(i3) < 0 && (n4[a2++] = t6[i3]);
                    return n4;
                  }(t5, r5);
                  return function(t6, e6) {
                    for (var r6 = t6.length, n4 = e6.length, i3 = 0; i3 < r6; ++i3)
                      for (var a2 = t6[i3], o2 = 0; o2 < a2.length; ++o2) {
                        var s = a2[o2];
                        if (s < n4)
                          a2[o2] = e6[s];
                        else {
                          s -= n4;
                          for (var l = 0; l < n4; ++l)
                            s >= e6[l] && (s += 1);
                          a2[o2] = s;
                        }
                      }
                    return t6;
                  }(n3(a, true), r5);
                }
              };
              var n3 = r4(2183), i2 = r4(2153);
            }, 9680: function(t4) {
              t4.exports = function(t5, e4, r4, n3, i2, a) {
                var o = i2 - 1, s = i2 * i2, l = o * o, u = (1 + 2 * i2) * l, c = i2 * l, f2 = s * (3 - 2 * i2), h = s * o;
                if (t5.length) {
                  a || (a = new Array(t5.length));
                  for (var p2 = t5.length - 1; p2 >= 0; --p2)
                    a[p2] = u * t5[p2] + c * e4[p2] + f2 * r4[p2] + h * n3[p2];
                  return a;
                }
                return u * t5 + c * e4 + f2 * r4 + h * n3;
              }, t4.exports.derivative = function(t5, e4, r4, n3, i2, a) {
                var o = 6 * i2 * i2 - 6 * i2, s = 3 * i2 * i2 - 4 * i2 + 1, l = -6 * i2 * i2 + 6 * i2, u = 3 * i2 * i2 - 2 * i2;
                if (t5.length) {
                  a || (a = new Array(t5.length));
                  for (var c = t5.length - 1; c >= 0; --c)
                    a[c] = o * t5[c] + s * e4[c] + l * r4[c] + u * n3[c];
                  return a;
                }
                return o * t5 + s * e4 + l * r4[c] + u * n3;
              };
            }, 4419: function(t4, e4, r4) {
              var n3 = r4(2183), i2 = r4(1215);
              function a(t5, e5) {
                this.point = t5, this.index = e5;
              }
              function o(t5, e5) {
                for (var r5 = t5.point, n4 = e5.point, i3 = r5.length, a2 = 0; a2 < i3; ++a2) {
                  var o2 = n4[a2] - r5[a2];
                  if (o2)
                    return o2;
                }
                return 0;
              }
              t4.exports = function(t5, e5) {
                var r5 = t5.length;
                if (0 === r5)
                  return [];
                var s = t5[0].length;
                if (s < 1)
                  return [];
                if (1 === s)
                  return function(t6, e6, r6) {
                    if (1 === t6)
                      return r6 ? [[-1, 0]] : [];
                    var n4 = e6.map(function(t7, e7) {
                      return [t7[0], e7];
                    });
                    n4.sort(function(t7, e7) {
                      return t7[0] - e7[0];
                    });
                    for (var i3 = new Array(t6 - 1), a2 = 1; a2 < t6; ++a2) {
                      var o2 = n4[a2 - 1], s2 = n4[a2];
                      i3[a2 - 1] = [o2[1], s2[1]];
                    }
                    return r6 && i3.push([-1, i3[0][1]], [i3[t6 - 1][1], -1]), i3;
                  }(r5, t5, e5);
                for (var l = new Array(r5), u = 1, c = 0; c < r5; ++c) {
                  for (var f2 = t5[c], h = new Array(s + 1), p2 = 0, d2 = 0; d2 < s; ++d2) {
                    var v = f2[d2];
                    h[d2] = v, p2 += v * v;
                  }
                  h[s] = p2, l[c] = new a(h, c), u = Math.max(p2, u);
                }
                i2(l, o), r5 = l.length;
                var g2 = new Array(r5 + s + 1), y = new Array(r5 + s + 1), m2 = (s + 1) * (s + 1) * u, x = new Array(s + 1);
                for (c = 0; c <= s; ++c)
                  x[c] = 0;
                for (x[s] = m2, g2[0] = x.slice(), y[0] = -1, c = 0; c <= s; ++c)
                  (h = x.slice())[c] = 1, g2[c + 1] = h, y[c + 1] = -1;
                for (c = 0; c < r5; ++c) {
                  var b = l[c];
                  g2[c + s + 1] = b.point, y[c + s + 1] = b.index;
                }
                var _ = n3(g2, false);
                if (_ = e5 ? _.filter(function(t6) {
                  for (var e6 = 0, r6 = 0; r6 <= s; ++r6) {
                    var n4 = y[t6[r6]];
                    if (n4 < 0 && ++e6 >= 2)
                      return false;
                    t6[r6] = n4;
                  }
                  return true;
                }) : _.filter(function(t6) {
                  for (var e6 = 0; e6 <= s; ++e6) {
                    var r6 = y[t6[e6]];
                    if (r6 < 0)
                      return false;
                    t6[e6] = r6;
                  }
                  return true;
                }), 1 & s)
                  for (c = 0; c < _.length; ++c)
                    h = (b = _[c])[0], b[0] = b[1], b[1] = h;
                return _;
              };
            }, 8362: function(t4) {
              var e4 = false;
              if ("undefined" != typeof Float64Array) {
                var r4 = new Float64Array(1), n3 = new Uint32Array(r4.buffer);
                r4[0] = 1, e4 = true, 1072693248 === n3[1] ? (t4.exports = function(t5) {
                  return r4[0] = t5, [n3[0], n3[1]];
                }, t4.exports.pack = function(t5, e5) {
                  return n3[0] = t5, n3[1] = e5, r4[0];
                }, t4.exports.lo = function(t5) {
                  return r4[0] = t5, n3[0];
                }, t4.exports.hi = function(t5) {
                  return r4[0] = t5, n3[1];
                }) : 1072693248 === n3[0] ? (t4.exports = function(t5) {
                  return r4[0] = t5, [n3[1], n3[0]];
                }, t4.exports.pack = function(t5, e5) {
                  return n3[1] = t5, n3[0] = e5, r4[0];
                }, t4.exports.lo = function(t5) {
                  return r4[0] = t5, n3[1];
                }, t4.exports.hi = function(t5) {
                  return r4[0] = t5, n3[0];
                }) : e4 = false;
              }
              if (!e4) {
                var i2 = new Buffer(8);
                t4.exports = function(t5) {
                  return i2.writeDoubleLE(t5, 0, true), [i2.readUInt32LE(0, true), i2.readUInt32LE(4, true)];
                }, t4.exports.pack = function(t5, e5) {
                  return i2.writeUInt32LE(t5, 0, true), i2.writeUInt32LE(e5, 4, true), i2.readDoubleLE(0, true);
                }, t4.exports.lo = function(t5) {
                  return i2.writeDoubleLE(t5, 0, true), i2.readUInt32LE(0, true);
                }, t4.exports.hi = function(t5) {
                  return i2.writeDoubleLE(t5, 0, true), i2.readUInt32LE(4, true);
                };
              }
              t4.exports.sign = function(e5) {
                return t4.exports.hi(e5) >>> 31;
              }, t4.exports.exponent = function(e5) {
                return (t4.exports.hi(e5) << 1 >>> 21) - 1023;
              }, t4.exports.fraction = function(e5) {
                var r5 = t4.exports.lo(e5), n4 = t4.exports.hi(e5), i3 = 1048575 & n4;
                return 2146435072 & n4 && (i3 += 1 << 20), [r5, i3];
              }, t4.exports.denormalized = function(e5) {
                return !(2146435072 & t4.exports.hi(e5));
              };
            }, 3094: function(t4) {
              function e4(t5, r4, n3) {
                var i2 = 0 | t5[n3];
                if (i2 <= 0)
                  return [];
                var a, o = new Array(i2);
                if (n3 === t5.length - 1)
                  for (a = 0; a < i2; ++a)
                    o[a] = r4;
                else
                  for (a = 0; a < i2; ++a)
                    o[a] = e4(t5, r4, n3 + 1);
                return o;
              }
              t4.exports = function(t5, r4) {
                switch (void 0 === r4 && (r4 = 0), typeof t5) {
                  case "number":
                    if (t5 > 0)
                      return function(t6, e5) {
                        var r5, n3;
                        for (r5 = new Array(t6), n3 = 0; n3 < t6; ++n3)
                          r5[n3] = e5;
                        return r5;
                      }(0 | t5, r4);
                    break;
                  case "object":
                    if ("number" == typeof t5.length)
                      return e4(t5, r4, 0);
                }
                return [];
              };
            }, 8348: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                var r5 = t5.length;
                if ("number" != typeof e5) {
                  e5 = 0;
                  for (var i2 = 0; i2 < r5; ++i2) {
                    var a = t5[i2];
                    e5 = Math.max(e5, a[0], a[1]);
                  }
                  e5 = 1 + (0 | e5);
                }
                e5 |= 0;
                var o = new Array(e5);
                for (i2 = 0; i2 < e5; ++i2)
                  o[i2] = [];
                for (i2 = 0; i2 < r5; ++i2)
                  o[(a = t5[i2])[0]].push(a[1]), o[a[1]].push(a[0]);
                for (var s = 0; s < e5; ++s)
                  n3(o[s], function(t6, e6) {
                    return t6 - e6;
                  });
                return o;
              };
              var n3 = r4(1215);
            }, 5795: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = e4 || 0, i2 = r4 || 1;
                return [[t5[12] + t5[0], t5[13] + t5[1], t5[14] + t5[2], t5[15] + t5[3]], [t5[12] - t5[0], t5[13] - t5[1], t5[14] - t5[2], t5[15] - t5[3]], [t5[12] + t5[4], t5[13] + t5[5], t5[14] + t5[6], t5[15] + t5[7]], [t5[12] - t5[4], t5[13] - t5[5], t5[14] - t5[6], t5[15] - t5[7]], [n3 * t5[12] + t5[8], n3 * t5[13] + t5[9], n3 * t5[14] + t5[10], n3 * t5[15] + t5[11]], [i2 * t5[12] - t5[8], i2 * t5[13] - t5[9], i2 * t5[14] - t5[10], i2 * t5[15] - t5[11]]];
              };
            }, 8444: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5) {
                switch (arguments.length) {
                  case 0:
                    return new o([0], [0], 0);
                  case 1:
                    return "number" == typeof t5 ? new o(n4 = l(t5), n4, 0) : new o(t5, l(t5.length), 0);
                  case 2:
                    if ("number" == typeof e5) {
                      var n4 = l(t5.length);
                      return new o(t5, n4, +e5);
                    }
                    r5 = 0;
                  case 3:
                    if (t5.length !== e5.length)
                      throw new Error("state and velocity lengths must match");
                    return new o(t5, e5, r5);
                }
              };
              var n3 = r4(9680), i2 = r4(5070);
              function a(t5, e5, r5) {
                return Math.min(e5, Math.max(t5, r5));
              }
              function o(t5, e5, r5) {
                this.dimension = t5.length, this.bounds = [new Array(this.dimension), new Array(this.dimension)];
                for (var n4 = 0; n4 < this.dimension; ++n4)
                  this.bounds[0][n4] = -1 / 0, this.bounds[1][n4] = 1 / 0;
                this._state = t5.slice().reverse(), this._velocity = e5.slice().reverse(), this._time = [r5], this._scratch = [t5.slice(), t5.slice(), t5.slice(), t5.slice(), t5.slice()];
              }
              var s = o.prototype;
              function l(t5) {
                for (var e5 = new Array(t5), r5 = 0; r5 < t5; ++r5)
                  e5[r5] = 0;
                return e5;
              }
              s.flush = function(t5) {
                var e5 = i2.gt(this._time, t5) - 1;
                e5 <= 0 || (this._time.splice(0, e5), this._state.splice(0, e5 * this.dimension), this._velocity.splice(0, e5 * this.dimension));
              }, s.curve = function(t5) {
                var e5 = this._time, r5 = e5.length, o2 = i2.le(e5, t5), s2 = this._scratch[0], l2 = this._state, u = this._velocity, c = this.dimension, f2 = this.bounds;
                if (o2 < 0)
                  for (var h = c - 1, p2 = 0; p2 < c; ++p2, --h)
                    s2[p2] = l2[h];
                else if (o2 >= r5 - 1) {
                  h = l2.length - 1;
                  var d2 = t5 - e5[r5 - 1];
                  for (p2 = 0; p2 < c; ++p2, --h)
                    s2[p2] = l2[h] + d2 * u[h];
                } else {
                  h = c * (o2 + 1) - 1;
                  var v = e5[o2], g2 = e5[o2 + 1] - v || 1, y = this._scratch[1], m2 = this._scratch[2], x = this._scratch[3], b = this._scratch[4], _ = true;
                  for (p2 = 0; p2 < c; ++p2, --h)
                    y[p2] = l2[h], x[p2] = u[h] * g2, m2[p2] = l2[h + c], b[p2] = u[h + c] * g2, _ = _ && y[p2] === m2[p2] && x[p2] === b[p2] && 0 === x[p2];
                  if (_)
                    for (p2 = 0; p2 < c; ++p2)
                      s2[p2] = y[p2];
                  else
                    n3(y, x, m2, b, (t5 - v) / g2, s2);
                }
                var w2 = f2[0], T = f2[1];
                for (p2 = 0; p2 < c; ++p2)
                  s2[p2] = a(w2[p2], T[p2], s2[p2]);
                return s2;
              }, s.dcurve = function(t5) {
                var e5 = this._time, r5 = e5.length, a2 = i2.le(e5, t5), o2 = this._scratch[0], s2 = this._state, l2 = this._velocity, u = this.dimension;
                if (a2 >= r5 - 1)
                  for (var c = s2.length - 1, f2 = (e5[r5 - 1], 0); f2 < u; ++f2, --c)
                    o2[f2] = l2[c];
                else {
                  c = u * (a2 + 1) - 1;
                  var h = e5[a2], p2 = e5[a2 + 1] - h || 1, d2 = this._scratch[1], v = this._scratch[2], g2 = this._scratch[3], y = this._scratch[4], m2 = true;
                  for (f2 = 0; f2 < u; ++f2, --c)
                    d2[f2] = s2[c], g2[f2] = l2[c] * p2, v[f2] = s2[c + u], y[f2] = l2[c + u] * p2, m2 = m2 && d2[f2] === v[f2] && g2[f2] === y[f2] && 0 === g2[f2];
                  if (m2)
                    for (f2 = 0; f2 < u; ++f2)
                      o2[f2] = 0;
                  else
                    for (n3.derivative(d2, g2, v, y, (t5 - h) / p2, o2), f2 = 0; f2 < u; ++f2)
                      o2[f2] /= p2;
                }
                return o2;
              }, s.lastT = function() {
                var t5 = this._time;
                return t5[t5.length - 1];
              }, s.stable = function() {
                for (var t5 = this._velocity, e5 = t5.length, r5 = this.dimension - 1; r5 >= 0; --r5)
                  if (t5[--e5])
                    return false;
                return true;
              }, s.jump = function(t5) {
                var e5 = this.lastT(), r5 = this.dimension;
                if (!(t5 < e5 || arguments.length !== r5 + 1)) {
                  var n4 = this._state, i3 = this._velocity, o2 = n4.length - this.dimension, s2 = this.bounds, l2 = s2[0], u = s2[1];
                  this._time.push(e5, t5);
                  for (var c = 0; c < 2; ++c)
                    for (var f2 = 0; f2 < r5; ++f2)
                      n4.push(n4[o2++]), i3.push(0);
                  for (this._time.push(t5), f2 = r5; f2 > 0; --f2)
                    n4.push(a(l2[f2 - 1], u[f2 - 1], arguments[f2])), i3.push(0);
                }
              }, s.push = function(t5) {
                var e5 = this.lastT(), r5 = this.dimension;
                if (!(t5 < e5 || arguments.length !== r5 + 1)) {
                  var n4 = this._state, i3 = this._velocity, o2 = n4.length - this.dimension, s2 = t5 - e5, l2 = this.bounds, u = l2[0], c = l2[1], f2 = s2 > 1e-6 ? 1 / s2 : 0;
                  this._time.push(t5);
                  for (var h = r5; h > 0; --h) {
                    var p2 = a(u[h - 1], c[h - 1], arguments[h]);
                    n4.push(p2), i3.push((p2 - n4[o2++]) * f2);
                  }
                }
              }, s.set = function(t5) {
                var e5 = this.dimension;
                if (!(t5 < this.lastT() || arguments.length !== e5 + 1)) {
                  var r5 = this._state, n4 = this._velocity, i3 = this.bounds, o2 = i3[0], s2 = i3[1];
                  this._time.push(t5);
                  for (var l2 = e5; l2 > 0; --l2)
                    r5.push(a(o2[l2 - 1], s2[l2 - 1], arguments[l2])), n4.push(0);
                }
              }, s.move = function(t5) {
                var e5 = this.lastT(), r5 = this.dimension;
                if (!(t5 <= e5 || arguments.length !== r5 + 1)) {
                  var n4 = this._state, i3 = this._velocity, o2 = n4.length - this.dimension, s2 = this.bounds, l2 = s2[0], u = s2[1], c = t5 - e5, f2 = c > 1e-6 ? 1 / c : 0;
                  this._time.push(t5);
                  for (var h = r5; h > 0; --h) {
                    var p2 = arguments[h];
                    n4.push(a(l2[h - 1], u[h - 1], n4[o2++] + p2)), i3.push(p2 * f2);
                  }
                }
              }, s.idle = function(t5) {
                var e5 = this.lastT();
                if (!(t5 < e5)) {
                  var r5 = this.dimension, n4 = this._state, i3 = this._velocity, o2 = n4.length - r5, s2 = this.bounds, l2 = s2[0], u = s2[1], c = t5 - e5;
                  this._time.push(t5);
                  for (var f2 = r5 - 1; f2 >= 0; --f2)
                    n4.push(a(l2[f2], u[f2], n4[o2] + c * i3[o2])), i3.push(0), o2 += 1;
                }
              };
            }, 7080: function(t4) {
              function e4(t5, e5, r5, n4, i3, a2) {
                this._color = t5, this.key = e5, this.value = r5, this.left = n4, this.right = i3, this._count = a2;
              }
              function r4(t5) {
                return new e4(t5._color, t5.key, t5.value, t5.left, t5.right, t5._count);
              }
              function n3(t5, r5) {
                return new e4(t5, r5.key, r5.value, r5.left, r5.right, r5._count);
              }
              function i2(t5) {
                t5._count = 1 + (t5.left ? t5.left._count : 0) + (t5.right ? t5.right._count : 0);
              }
              function a(t5, e5) {
                this._compare = t5, this.root = e5;
              }
              t4.exports = function(t5) {
                return new a(t5 || p2, null);
              };
              var o = a.prototype;
              function s(t5, e5) {
                var r5;
                return e5.left && (r5 = s(t5, e5.left)) ? r5 : (r5 = t5(e5.key, e5.value)) || (e5.right ? s(t5, e5.right) : void 0);
              }
              function l(t5, e5, r5, n4) {
                if (e5(t5, n4.key) <= 0) {
                  var i3;
                  if (n4.left && (i3 = l(t5, e5, r5, n4.left)))
                    return i3;
                  if (i3 = r5(n4.key, n4.value))
                    return i3;
                }
                if (n4.right)
                  return l(t5, e5, r5, n4.right);
              }
              function u(t5, e5, r5, n4, i3) {
                var a2, o2 = r5(t5, i3.key), s2 = r5(e5, i3.key);
                if (o2 <= 0) {
                  if (i3.left && (a2 = u(t5, e5, r5, n4, i3.left)))
                    return a2;
                  if (s2 > 0 && (a2 = n4(i3.key, i3.value)))
                    return a2;
                }
                if (s2 > 0 && i3.right)
                  return u(t5, e5, r5, n4, i3.right);
              }
              function c(t5, e5) {
                this.tree = t5, this._stack = e5;
              }
              Object.defineProperty(o, "keys", { get: function() {
                var t5 = [];
                return this.forEach(function(e5, r5) {
                  t5.push(e5);
                }), t5;
              } }), Object.defineProperty(o, "values", { get: function() {
                var t5 = [];
                return this.forEach(function(e5, r5) {
                  t5.push(r5);
                }), t5;
              } }), Object.defineProperty(o, "length", { get: function() {
                return this.root ? this.root._count : 0;
              } }), o.insert = function(t5, r5) {
                for (var o2 = this._compare, s2 = this.root, l2 = [], u2 = []; s2; ) {
                  var c2 = o2(t5, s2.key);
                  l2.push(s2), u2.push(c2), s2 = c2 <= 0 ? s2.left : s2.right;
                }
                l2.push(new e4(0, t5, r5, null, null, 1));
                for (var f3 = l2.length - 2; f3 >= 0; --f3)
                  s2 = l2[f3], u2[f3] <= 0 ? l2[f3] = new e4(s2._color, s2.key, s2.value, l2[f3 + 1], s2.right, s2._count + 1) : l2[f3] = new e4(s2._color, s2.key, s2.value, s2.left, l2[f3 + 1], s2._count + 1);
                for (f3 = l2.length - 1; f3 > 1; --f3) {
                  var h2 = l2[f3 - 1];
                  if (s2 = l2[f3], 1 === h2._color || 1 === s2._color)
                    break;
                  var p3 = l2[f3 - 2];
                  if (p3.left === h2)
                    if (h2.left === s2) {
                      if (!(d2 = p3.right) || 0 !== d2._color) {
                        p3._color = 0, p3.left = h2.right, h2._color = 1, h2.right = p3, l2[f3 - 2] = h2, l2[f3 - 1] = s2, i2(p3), i2(h2), f3 >= 3 && ((v = l2[f3 - 3]).left === p3 ? v.left = h2 : v.right = h2);
                        break;
                      }
                      h2._color = 1, p3.right = n3(1, d2), p3._color = 0, f3 -= 1;
                    } else {
                      if (!(d2 = p3.right) || 0 !== d2._color) {
                        h2.right = s2.left, p3._color = 0, p3.left = s2.right, s2._color = 1, s2.left = h2, s2.right = p3, l2[f3 - 2] = s2, l2[f3 - 1] = h2, i2(p3), i2(h2), i2(s2), f3 >= 3 && ((v = l2[f3 - 3]).left === p3 ? v.left = s2 : v.right = s2);
                        break;
                      }
                      h2._color = 1, p3.right = n3(1, d2), p3._color = 0, f3 -= 1;
                    }
                  else if (h2.right === s2) {
                    if (!(d2 = p3.left) || 0 !== d2._color) {
                      p3._color = 0, p3.right = h2.left, h2._color = 1, h2.left = p3, l2[f3 - 2] = h2, l2[f3 - 1] = s2, i2(p3), i2(h2), f3 >= 3 && ((v = l2[f3 - 3]).right === p3 ? v.right = h2 : v.left = h2);
                      break;
                    }
                    h2._color = 1, p3.left = n3(1, d2), p3._color = 0, f3 -= 1;
                  } else {
                    var d2;
                    if (!(d2 = p3.left) || 0 !== d2._color) {
                      var v;
                      h2.left = s2.right, p3._color = 0, p3.right = s2.left, s2._color = 1, s2.right = h2, s2.left = p3, l2[f3 - 2] = s2, l2[f3 - 1] = h2, i2(p3), i2(h2), i2(s2), f3 >= 3 && ((v = l2[f3 - 3]).right === p3 ? v.right = s2 : v.left = s2);
                      break;
                    }
                    h2._color = 1, p3.left = n3(1, d2), p3._color = 0, f3 -= 1;
                  }
                }
                return l2[0]._color = 1, new a(o2, l2[0]);
              }, o.forEach = function(t5, e5, r5) {
                if (this.root)
                  switch (arguments.length) {
                    case 1:
                      return s(t5, this.root);
                    case 2:
                      return l(e5, this._compare, t5, this.root);
                    case 3:
                      if (this._compare(e5, r5) >= 0)
                        return;
                      return u(e5, r5, this._compare, t5, this.root);
                  }
              }, Object.defineProperty(o, "begin", { get: function() {
                for (var t5 = [], e5 = this.root; e5; )
                  t5.push(e5), e5 = e5.left;
                return new c(this, t5);
              } }), Object.defineProperty(o, "end", { get: function() {
                for (var t5 = [], e5 = this.root; e5; )
                  t5.push(e5), e5 = e5.right;
                return new c(this, t5);
              } }), o.at = function(t5) {
                if (t5 < 0)
                  return new c(this, []);
                for (var e5 = this.root, r5 = []; ; ) {
                  if (r5.push(e5), e5.left) {
                    if (t5 < e5.left._count) {
                      e5 = e5.left;
                      continue;
                    }
                    t5 -= e5.left._count;
                  }
                  if (!t5)
                    return new c(this, r5);
                  if (t5 -= 1, !e5.right)
                    break;
                  if (t5 >= e5.right._count)
                    break;
                  e5 = e5.right;
                }
                return new c(this, []);
              }, o.ge = function(t5) {
                for (var e5 = this._compare, r5 = this.root, n4 = [], i3 = 0; r5; ) {
                  var a2 = e5(t5, r5.key);
                  n4.push(r5), a2 <= 0 && (i3 = n4.length), r5 = a2 <= 0 ? r5.left : r5.right;
                }
                return n4.length = i3, new c(this, n4);
              }, o.gt = function(t5) {
                for (var e5 = this._compare, r5 = this.root, n4 = [], i3 = 0; r5; ) {
                  var a2 = e5(t5, r5.key);
                  n4.push(r5), a2 < 0 && (i3 = n4.length), r5 = a2 < 0 ? r5.left : r5.right;
                }
                return n4.length = i3, new c(this, n4);
              }, o.lt = function(t5) {
                for (var e5 = this._compare, r5 = this.root, n4 = [], i3 = 0; r5; ) {
                  var a2 = e5(t5, r5.key);
                  n4.push(r5), a2 > 0 && (i3 = n4.length), r5 = a2 <= 0 ? r5.left : r5.right;
                }
                return n4.length = i3, new c(this, n4);
              }, o.le = function(t5) {
                for (var e5 = this._compare, r5 = this.root, n4 = [], i3 = 0; r5; ) {
                  var a2 = e5(t5, r5.key);
                  n4.push(r5), a2 >= 0 && (i3 = n4.length), r5 = a2 < 0 ? r5.left : r5.right;
                }
                return n4.length = i3, new c(this, n4);
              }, o.find = function(t5) {
                for (var e5 = this._compare, r5 = this.root, n4 = []; r5; ) {
                  var i3 = e5(t5, r5.key);
                  if (n4.push(r5), 0 === i3)
                    return new c(this, n4);
                  r5 = i3 <= 0 ? r5.left : r5.right;
                }
                return new c(this, []);
              }, o.remove = function(t5) {
                var e5 = this.find(t5);
                return e5 ? e5.remove() : this;
              }, o.get = function(t5) {
                for (var e5 = this._compare, r5 = this.root; r5; ) {
                  var n4 = e5(t5, r5.key);
                  if (0 === n4)
                    return r5.value;
                  r5 = n4 <= 0 ? r5.left : r5.right;
                }
              };
              var f2 = c.prototype;
              function h(t5, e5) {
                t5.key = e5.key, t5.value = e5.value, t5.left = e5.left, t5.right = e5.right, t5._color = e5._color, t5._count = e5._count;
              }
              function p2(t5, e5) {
                return t5 < e5 ? -1 : t5 > e5 ? 1 : 0;
              }
              Object.defineProperty(f2, "valid", { get: function() {
                return this._stack.length > 0;
              } }), Object.defineProperty(f2, "node", { get: function() {
                return this._stack.length > 0 ? this._stack[this._stack.length - 1] : null;
              }, enumerable: true }), f2.clone = function() {
                return new c(this.tree, this._stack.slice());
              }, f2.remove = function() {
                var t5 = this._stack;
                if (0 === t5.length)
                  return this.tree;
                var o2 = new Array(t5.length), s2 = t5[t5.length - 1];
                o2[o2.length - 1] = new e4(s2._color, s2.key, s2.value, s2.left, s2.right, s2._count);
                for (var l2 = t5.length - 2; l2 >= 0; --l2)
                  (s2 = t5[l2]).left === t5[l2 + 1] ? o2[l2] = new e4(s2._color, s2.key, s2.value, o2[l2 + 1], s2.right, s2._count) : o2[l2] = new e4(s2._color, s2.key, s2.value, s2.left, o2[l2 + 1], s2._count);
                if ((s2 = o2[o2.length - 1]).left && s2.right) {
                  var u2 = o2.length;
                  for (s2 = s2.left; s2.right; )
                    o2.push(s2), s2 = s2.right;
                  var c2 = o2[u2 - 1];
                  for (o2.push(new e4(s2._color, c2.key, c2.value, s2.left, s2.right, s2._count)), o2[u2 - 1].key = s2.key, o2[u2 - 1].value = s2.value, l2 = o2.length - 2; l2 >= u2; --l2)
                    s2 = o2[l2], o2[l2] = new e4(s2._color, s2.key, s2.value, s2.left, o2[l2 + 1], s2._count);
                  o2[u2 - 1].left = o2[u2];
                }
                if (0 === (s2 = o2[o2.length - 1])._color) {
                  var f3 = o2[o2.length - 2];
                  for (f3.left === s2 ? f3.left = null : f3.right === s2 && (f3.right = null), o2.pop(), l2 = 0; l2 < o2.length; ++l2)
                    o2[l2]._count--;
                  return new a(this.tree._compare, o2[0]);
                }
                if (s2.left || s2.right) {
                  for (s2.left ? h(s2, s2.left) : s2.right && h(s2, s2.right), s2._color = 1, l2 = 0; l2 < o2.length - 1; ++l2)
                    o2[l2]._count--;
                  return new a(this.tree._compare, o2[0]);
                }
                if (1 === o2.length)
                  return new a(this.tree._compare, null);
                for (l2 = 0; l2 < o2.length; ++l2)
                  o2[l2]._count--;
                var p3 = o2[o2.length - 2];
                return function(t6) {
                  for (var e5, a2, o3, s3, l3 = t6.length - 1; l3 >= 0; --l3) {
                    if (e5 = t6[l3], 0 === l3)
                      return void (e5._color = 1);
                    if ((a2 = t6[l3 - 1]).left === e5) {
                      if ((o3 = a2.right).right && 0 === o3.right._color)
                        return s3 = (o3 = a2.right = r4(o3)).right = r4(o3.right), a2.right = o3.left, o3.left = a2, o3.right = s3, o3._color = a2._color, e5._color = 1, a2._color = 1, s3._color = 1, i2(a2), i2(o3), l3 > 1 && ((u3 = t6[l3 - 2]).left === a2 ? u3.left = o3 : u3.right = o3), void (t6[l3 - 1] = o3);
                      if (o3.left && 0 === o3.left._color)
                        return s3 = (o3 = a2.right = r4(o3)).left = r4(o3.left), a2.right = s3.left, o3.left = s3.right, s3.left = a2, s3.right = o3, s3._color = a2._color, a2._color = 1, o3._color = 1, e5._color = 1, i2(a2), i2(o3), i2(s3), l3 > 1 && ((u3 = t6[l3 - 2]).left === a2 ? u3.left = s3 : u3.right = s3), void (t6[l3 - 1] = s3);
                      if (1 === o3._color) {
                        if (0 === a2._color)
                          return a2._color = 1, void (a2.right = n3(0, o3));
                        a2.right = n3(0, o3);
                        continue;
                      }
                      o3 = r4(o3), a2.right = o3.left, o3.left = a2, o3._color = a2._color, a2._color = 0, i2(a2), i2(o3), l3 > 1 && ((u3 = t6[l3 - 2]).left === a2 ? u3.left = o3 : u3.right = o3), t6[l3 - 1] = o3, t6[l3] = a2, l3 + 1 < t6.length ? t6[l3 + 1] = e5 : t6.push(e5), l3 += 2;
                    } else {
                      if ((o3 = a2.left).left && 0 === o3.left._color)
                        return s3 = (o3 = a2.left = r4(o3)).left = r4(o3.left), a2.left = o3.right, o3.right = a2, o3.left = s3, o3._color = a2._color, e5._color = 1, a2._color = 1, s3._color = 1, i2(a2), i2(o3), l3 > 1 && ((u3 = t6[l3 - 2]).right === a2 ? u3.right = o3 : u3.left = o3), void (t6[l3 - 1] = o3);
                      if (o3.right && 0 === o3.right._color)
                        return s3 = (o3 = a2.left = r4(o3)).right = r4(o3.right), a2.left = s3.right, o3.right = s3.left, s3.right = a2, s3.left = o3, s3._color = a2._color, a2._color = 1, o3._color = 1, e5._color = 1, i2(a2), i2(o3), i2(s3), l3 > 1 && ((u3 = t6[l3 - 2]).right === a2 ? u3.right = s3 : u3.left = s3), void (t6[l3 - 1] = s3);
                      if (1 === o3._color) {
                        if (0 === a2._color)
                          return a2._color = 1, void (a2.left = n3(0, o3));
                        a2.left = n3(0, o3);
                        continue;
                      }
                      var u3;
                      o3 = r4(o3), a2.left = o3.right, o3.right = a2, o3._color = a2._color, a2._color = 0, i2(a2), i2(o3), l3 > 1 && ((u3 = t6[l3 - 2]).right === a2 ? u3.right = o3 : u3.left = o3), t6[l3 - 1] = o3, t6[l3] = a2, l3 + 1 < t6.length ? t6[l3 + 1] = e5 : t6.push(e5), l3 += 2;
                    }
                  }
                }(o2), p3.left === s2 ? p3.left = null : p3.right = null, new a(this.tree._compare, o2[0]);
              }, Object.defineProperty(f2, "key", { get: function() {
                if (this._stack.length > 0)
                  return this._stack[this._stack.length - 1].key;
              }, enumerable: true }), Object.defineProperty(f2, "value", { get: function() {
                if (this._stack.length > 0)
                  return this._stack[this._stack.length - 1].value;
              }, enumerable: true }), Object.defineProperty(f2, "index", { get: function() {
                var t5 = 0, e5 = this._stack;
                if (0 === e5.length) {
                  var r5 = this.tree.root;
                  return r5 ? r5._count : 0;
                }
                e5[e5.length - 1].left && (t5 = e5[e5.length - 1].left._count);
                for (var n4 = e5.length - 2; n4 >= 0; --n4)
                  e5[n4 + 1] === e5[n4].right && (++t5, e5[n4].left && (t5 += e5[n4].left._count));
                return t5;
              }, enumerable: true }), f2.next = function() {
                var t5 = this._stack;
                if (0 !== t5.length) {
                  var e5 = t5[t5.length - 1];
                  if (e5.right)
                    for (e5 = e5.right; e5; )
                      t5.push(e5), e5 = e5.left;
                  else
                    for (t5.pop(); t5.length > 0 && t5[t5.length - 1].right === e5; )
                      e5 = t5[t5.length - 1], t5.pop();
                }
              }, Object.defineProperty(f2, "hasNext", { get: function() {
                var t5 = this._stack;
                if (0 === t5.length)
                  return false;
                if (t5[t5.length - 1].right)
                  return true;
                for (var e5 = t5.length - 1; e5 > 0; --e5)
                  if (t5[e5 - 1].left === t5[e5])
                    return true;
                return false;
              } }), f2.update = function(t5) {
                var r5 = this._stack;
                if (0 === r5.length)
                  throw new Error("Can't update empty node!");
                var n4 = new Array(r5.length), i3 = r5[r5.length - 1];
                n4[n4.length - 1] = new e4(i3._color, i3.key, t5, i3.left, i3.right, i3._count);
                for (var o2 = r5.length - 2; o2 >= 0; --o2)
                  (i3 = r5[o2]).left === r5[o2 + 1] ? n4[o2] = new e4(i3._color, i3.key, i3.value, n4[o2 + 1], i3.right, i3._count) : n4[o2] = new e4(i3._color, i3.key, i3.value, i3.left, n4[o2 + 1], i3._count);
                return new a(this.tree._compare, n4[0]);
              }, f2.prev = function() {
                var t5 = this._stack;
                if (0 !== t5.length) {
                  var e5 = t5[t5.length - 1];
                  if (e5.left)
                    for (e5 = e5.left; e5; )
                      t5.push(e5), e5 = e5.right;
                  else
                    for (t5.pop(); t5.length > 0 && t5[t5.length - 1].left === e5; )
                      e5 = t5[t5.length - 1], t5.pop();
                }
              }, Object.defineProperty(f2, "hasPrev", { get: function() {
                var t5 = this._stack;
                if (0 === t5.length)
                  return false;
                if (t5[t5.length - 1].left)
                  return true;
                for (var e5 = t5.length - 1; e5 > 0; --e5)
                  if (t5[e5 - 1].right === t5[e5])
                    return true;
                return false;
              } });
            }, 7453: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                var r5 = new c(t5);
                return r5.update(e5), r5;
              };
              var n3 = r4(9557), i2 = r4(1681), a = r4(1011), o = r4(2864), s = r4(8468), l = new Float32Array([1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1]);
              function u(t5, e5) {
                return t5[0] = e5[0], t5[1] = e5[1], t5[2] = e5[2], t5;
              }
              function c(t5) {
                this.gl = t5, this.pixelRatio = 1, this.bounds = [[-10, -10, -10], [10, 10, 10]], this.ticks = [[], [], []], this.autoTicks = true, this.tickSpacing = [1, 1, 1], this.tickEnable = [true, true, true], this.tickFont = ["sans-serif", "sans-serif", "sans-serif"], this.tickSize = [12, 12, 12], this.tickAngle = [0, 0, 0], this.tickAlign = ["auto", "auto", "auto"], this.tickColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.tickPad = [10, 10, 10], this.lastCubeProps = { cubeEdges: [0, 0, 0], axis: [0, 0, 0] }, this.labels = ["x", "y", "z"], this.labelEnable = [true, true, true], this.labelFont = "sans-serif", this.labelSize = [20, 20, 20], this.labelAngle = [0, 0, 0], this.labelAlign = ["auto", "auto", "auto"], this.labelColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.labelPad = [10, 10, 10], this.lineEnable = [true, true, true], this.lineMirror = [false, false, false], this.lineWidth = [1, 1, 1], this.lineColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.lineTickEnable = [true, true, true], this.lineTickMirror = [false, false, false], this.lineTickLength = [0, 0, 0], this.lineTickWidth = [1, 1, 1], this.lineTickColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.gridEnable = [true, true, true], this.gridWidth = [1, 1, 1], this.gridColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.zeroEnable = [true, true, true], this.zeroLineColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.zeroLineWidth = [2, 2, 2], this.backgroundEnable = [false, false, false], this.backgroundColor = [[0.8, 0.8, 0.8, 0.5], [0.8, 0.8, 0.8, 0.5], [0.8, 0.8, 0.8, 0.5]], this._firstInit = true, this._text = null, this._lines = null, this._background = a(t5);
              }
              var f2 = c.prototype;
              function h() {
                this.primalOffset = [0, 0, 0], this.primalMinor = [0, 0, 0], this.mirrorOffset = [0, 0, 0], this.mirrorMinor = [0, 0, 0];
              }
              f2.update = function(t5) {
                function e5(e6, r6, n4) {
                  if (n4 in t5) {
                    var i3, a3 = t5[n4], o3 = this[n4];
                    (e6 ? Array.isArray(a3) && Array.isArray(a3[0]) : Array.isArray(a3)) ? this[n4] = i3 = [r6(a3[0]), r6(a3[1]), r6(a3[2])] : this[n4] = i3 = [r6(a3), r6(a3), r6(a3)];
                    for (var s2 = 0; s2 < 3; ++s2)
                      if (i3[s2] !== o3[s2])
                        return true;
                  }
                  return false;
                }
                t5 = t5 || {};
                var r5, a2 = e5.bind(this, false, Number), o2 = e5.bind(this, false, Boolean), l2 = e5.bind(this, false, String), u2 = e5.bind(this, true, function(t6) {
                  if (Array.isArray(t6)) {
                    if (3 === t6.length)
                      return [+t6[0], +t6[1], +t6[2], 1];
                    if (4 === t6.length)
                      return [+t6[0], +t6[1], +t6[2], +t6[3]];
                  }
                  return [0, 0, 0, 1];
                }), c2 = false, f3 = false;
                if ("bounds" in t5)
                  for (var h2 = t5.bounds, p3 = 0; p3 < 2; ++p3)
                    for (var d3 = 0; d3 < 3; ++d3)
                      h2[p3][d3] !== this.bounds[p3][d3] && (f3 = true), this.bounds[p3][d3] = h2[p3][d3];
                if ("ticks" in t5)
                  for (r5 = t5.ticks, c2 = true, this.autoTicks = false, p3 = 0; p3 < 3; ++p3)
                    this.tickSpacing[p3] = 0;
                else
                  a2("tickSpacing") && (this.autoTicks = true, f3 = true);
                if (this._firstInit && ("ticks" in t5 || "tickSpacing" in t5 || (this.autoTicks = true), f3 = true, c2 = true, this._firstInit = false), f3 && this.autoTicks && (r5 = s.create(this.bounds, this.tickSpacing), c2 = true), c2) {
                  for (p3 = 0; p3 < 3; ++p3)
                    r5[p3].sort(function(t6, e6) {
                      return t6.x - e6.x;
                    });
                  s.equal(r5, this.ticks) ? c2 = false : this.ticks = r5;
                }
                o2("tickEnable"), l2("tickFont") && (c2 = true), a2("tickSize"), a2("tickAngle"), a2("tickPad"), u2("tickColor");
                var v2 = l2("labels");
                l2("labelFont") && (v2 = true), o2("labelEnable"), a2("labelSize"), a2("labelPad"), u2("labelColor"), o2("lineEnable"), o2("lineMirror"), a2("lineWidth"), u2("lineColor"), o2("lineTickEnable"), o2("lineTickMirror"), a2("lineTickLength"), a2("lineTickWidth"), u2("lineTickColor"), o2("gridEnable"), a2("gridWidth"), u2("gridColor"), o2("zeroEnable"), u2("zeroLineColor"), a2("zeroLineWidth"), o2("backgroundEnable"), u2("backgroundColor"), this._text ? this._text && (v2 || c2) && this._text.update(this.bounds, this.labels, this.labelFont, this.ticks, this.tickFont) : this._text = n3(this.gl, this.bounds, this.labels, this.labelFont, this.ticks, this.tickFont), this._lines && c2 && (this._lines.dispose(), this._lines = null), this._lines || (this._lines = i2(this.gl, this.bounds, this.ticks));
              };
              var p2 = [new h(), new h(), new h()];
              function d2(t5, e5, r5, n4, i3) {
                for (var a2 = t5.primalOffset, o2 = t5.primalMinor, s2 = t5.mirrorOffset, l2 = t5.mirrorMinor, u2 = n4[e5], c2 = 0; c2 < 3; ++c2)
                  if (e5 !== c2) {
                    var f3 = a2, h2 = s2, p3 = o2, d3 = l2;
                    u2 & 1 << c2 && (f3 = s2, h2 = a2, p3 = l2, d3 = o2), f3[c2] = r5[0][c2], h2[c2] = r5[1][c2], i3[c2] > 0 ? (p3[c2] = -1, d3[c2] = 0) : (p3[c2] = 0, d3[c2] = 1);
                  }
              }
              var v = [0, 0, 0], g2 = { model: l, view: l, projection: l, _ortho: false };
              f2.isOpaque = function() {
                return true;
              }, f2.isTransparent = function() {
                return false;
              }, f2.drawTransparent = function(t5) {
              };
              var y = [0, 0, 0], m2 = [0, 0, 0], x = [0, 0, 0];
              f2.draw = function(t5) {
                t5 = t5 || g2;
                for (var e5 = this.gl, r5 = t5.model || l, n4 = t5.view || l, i3 = t5.projection || l, a2 = this.bounds, s2 = t5._ortho || false, c2 = o(r5, n4, i3, a2, s2), f3 = c2.cubeEdges, h2 = c2.axis, b = n4[12], _ = n4[13], w2 = n4[14], T = n4[15], k = (s2 ? 2 : 1) * this.pixelRatio * (i3[3] * b + i3[7] * _ + i3[11] * w2 + i3[15] * T) / e5.drawingBufferHeight, A = 0; A < 3; ++A)
                  this.lastCubeProps.cubeEdges[A] = f3[A], this.lastCubeProps.axis[A] = h2[A];
                var M = p2;
                for (A = 0; A < 3; ++A)
                  d2(p2[A], A, this.bounds, f3, h2);
                e5 = this.gl;
                var S, E, L, C = v;
                for (A = 0; A < 3; ++A)
                  this.backgroundEnable[A] ? C[A] = h2[A] : C[A] = 0;
                for (this._background.draw(r5, n4, i3, a2, C, this.backgroundColor), this._lines.bind(r5, n4, i3, this), A = 0; A < 3; ++A) {
                  var P = [0, 0, 0];
                  h2[A] > 0 ? P[A] = a2[1][A] : P[A] = a2[0][A];
                  for (var O = 0; O < 2; ++O) {
                    var I = (A + 1 + O) % 3, D = (A + 1 + (1 ^ O)) % 3;
                    this.gridEnable[I] && this._lines.drawGrid(I, D, this.bounds, P, this.gridColor[I], this.gridWidth[I] * this.pixelRatio);
                  }
                  for (O = 0; O < 2; ++O)
                    I = (A + 1 + O) % 3, D = (A + 1 + (1 ^ O)) % 3, this.zeroEnable[D] && Math.min(a2[0][D], a2[1][D]) <= 0 && Math.max(a2[0][D], a2[1][D]) >= 0 && this._lines.drawZero(I, D, this.bounds, P, this.zeroLineColor[D], this.zeroLineWidth[D] * this.pixelRatio);
                }
                for (A = 0; A < 3; ++A) {
                  this.lineEnable[A] && this._lines.drawAxisLine(A, this.bounds, M[A].primalOffset, this.lineColor[A], this.lineWidth[A] * this.pixelRatio), this.lineMirror[A] && this._lines.drawAxisLine(A, this.bounds, M[A].mirrorOffset, this.lineColor[A], this.lineWidth[A] * this.pixelRatio);
                  var z = u(y, M[A].primalMinor), R = u(m2, M[A].mirrorMinor), F = this.lineTickLength;
                  for (O = 0; O < 3; ++O) {
                    var B = k / r5[5 * O];
                    z[O] *= F[O] * B, R[O] *= F[O] * B;
                  }
                  this.lineTickEnable[A] && this._lines.drawAxisTicks(A, M[A].primalOffset, z, this.lineTickColor[A], this.lineTickWidth[A] * this.pixelRatio), this.lineTickMirror[A] && this._lines.drawAxisTicks(A, M[A].mirrorOffset, R, this.lineTickColor[A], this.lineTickWidth[A] * this.pixelRatio);
                }
                function N(t6) {
                  (L = [0, 0, 0])[t6] = 1;
                }
                function j(t6, e6, r6) {
                  var n5 = (t6 + 1) % 3, i4 = (t6 + 2) % 3, a3 = e6[n5], o2 = e6[i4], s3 = r6[n5], l2 = r6[i4];
                  a3 > 0 && l2 > 0 || a3 > 0 && l2 < 0 || a3 < 0 && l2 > 0 || a3 < 0 && l2 < 0 ? N(n5) : (o2 > 0 && s3 > 0 || o2 > 0 && s3 < 0 || o2 < 0 && s3 > 0 || o2 < 0 && s3 < 0) && N(i4);
                }
                for (this._lines.unbind(), this._text.bind(r5, n4, i3, this.pixelRatio), A = 0; A < 3; ++A) {
                  var U = M[A].primalMinor, V = M[A].mirrorMinor, H = u(x, M[A].primalOffset);
                  for (O = 0; O < 3; ++O)
                    this.lineTickEnable[A] && (H[O] += k * U[O] * Math.max(this.lineTickLength[O], 0) / r5[5 * O]);
                  var q2 = [0, 0, 0];
                  if (q2[A] = 1, this.tickEnable[A]) {
                    for (-3600 === this.tickAngle[A] ? (this.tickAngle[A] = 0, this.tickAlign[A] = "auto") : this.tickAlign[A] = -1, E = 1, "auto" === (S = [this.tickAlign[A], 0.5, E])[0] ? S[0] = 0 : S[0] = parseInt("" + S[0]), L = [0, 0, 0], j(A, U, V), O = 0; O < 3; ++O)
                      H[O] += k * U[O] * this.tickPad[O] / r5[5 * O];
                    this._text.drawTicks(A, this.tickSize[A], this.tickAngle[A], H, this.tickColor[A], q2, L, S);
                  }
                  if (this.labelEnable[A]) {
                    for (E = 0, L = [0, 0, 0], this.labels[A].length > 4 && (N(A), E = 1), "auto" === (S = [this.labelAlign[A], 0.5, E])[0] ? S[0] = 0 : S[0] = parseInt("" + S[0]), O = 0; O < 3; ++O)
                      H[O] += k * U[O] * this.labelPad[O] / r5[5 * O];
                    H[A] += 0.5 * (a2[0][A] + a2[1][A]), this._text.drawLabel(A, this.labelSize[A], this.labelAngle[A], H, this.labelColor[A], [0, 0, 0], L, S);
                  }
                }
                this._text.unbind();
              }, f2.dispose = function() {
                this._text.dispose(), this._lines.dispose(), this._background.dispose(), this._lines = null, this._text = null, this._background = null, this.gl = null;
              };
            }, 1011: function(t4, e4, r4) {
              t4.exports = function(t5) {
                for (var e5 = [], r5 = [], s2 = 0, l = 0; l < 3; ++l)
                  for (var u = (l + 1) % 3, c = (l + 2) % 3, f2 = [0, 0, 0], h = [0, 0, 0], p2 = -1; p2 <= 1; p2 += 2) {
                    r5.push(s2, s2 + 2, s2 + 1, s2 + 1, s2 + 2, s2 + 3), f2[l] = p2, h[l] = p2;
                    for (var d2 = -1; d2 <= 1; d2 += 2) {
                      f2[u] = d2;
                      for (var v = -1; v <= 1; v += 2)
                        f2[c] = v, e5.push(f2[0], f2[1], f2[2], h[0], h[1], h[2]), s2 += 1;
                    }
                    var g2 = u;
                    u = c, c = g2;
                  }
                var y = n3(t5, new Float32Array(e5)), m2 = n3(t5, new Uint16Array(r5), t5.ELEMENT_ARRAY_BUFFER), x = i2(t5, [{ buffer: y, type: t5.FLOAT, size: 3, offset: 0, stride: 24 }, { buffer: y, type: t5.FLOAT, size: 3, offset: 12, stride: 24 }], m2), b = a(t5);
                return b.attributes.position.location = 0, b.attributes.normal.location = 1, new o(t5, y, x, b);
              };
              var n3 = r4(5827), i2 = r4(2944), a = r4(1943).bg;
              function o(t5, e5, r5, n4) {
                this.gl = t5, this.buffer = e5, this.vao = r5, this.shader = n4;
              }
              var s = o.prototype;
              s.draw = function(t5, e5, r5, n4, i3, a2) {
                for (var o2 = false, s2 = 0; s2 < 3; ++s2)
                  o2 = o2 || i3[s2];
                if (o2) {
                  var l = this.gl;
                  l.enable(l.POLYGON_OFFSET_FILL), l.polygonOffset(1, 2), this.shader.bind(), this.shader.uniforms = { model: t5, view: e5, projection: r5, bounds: n4, enable: i3, colors: a2 }, this.vao.bind(), this.vao.draw(this.gl.TRIANGLES, 36), this.vao.unbind(), l.disable(l.POLYGON_OFFSET_FILL);
                }
              }, s.dispose = function() {
                this.vao.dispose(), this.buffer.dispose(), this.shader.dispose();
              };
            }, 2864: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5, a2, p3) {
                i2(s, e5, t5), i2(s, r5, s);
                for (var m2 = 0, x = 0; x < 2; ++x) {
                  c[2] = a2[x][2];
                  for (var b = 0; b < 2; ++b) {
                    c[1] = a2[b][1];
                    for (var _ = 0; _ < 2; ++_)
                      c[0] = a2[_][0], h(l[m2], c, s), m2 += 1;
                  }
                }
                var w2 = -1;
                for (x = 0; x < 8; ++x) {
                  for (var T = l[x][3], k = 0; k < 3; ++k)
                    u[x][k] = l[x][k] / T;
                  p3 && (u[x][2] *= -1), T < 0 && (w2 < 0 || u[x][2] < u[w2][2]) && (w2 = x);
                }
                if (w2 < 0) {
                  w2 = 0;
                  for (var A = 0; A < 3; ++A) {
                    for (var M = (A + 2) % 3, S = (A + 1) % 3, E = -1, L = -1, C = 0; C < 2; ++C) {
                      var P = (I = C << A) + (C << M) + (1 - C << S), O = I + (1 - C << M) + (C << S);
                      o(u[I], u[P], u[O], f2) < 0 || (C ? E = 1 : L = 1);
                    }
                    if (E < 0 || L < 0)
                      L > E && (w2 |= 1 << A);
                    else {
                      for (C = 0; C < 2; ++C) {
                        P = (I = C << A) + (C << M) + (1 - C << S), O = I + (1 - C << M) + (C << S);
                        var I, D = d2([l[I], l[P], l[O], l[I + (1 << M) + (1 << S)]]);
                        C ? E = D : L = D;
                      }
                      L > E && (w2 |= 1 << A);
                    }
                  }
                }
                var z = 7 ^ w2, R = -1;
                for (x = 0; x < 8; ++x)
                  x !== w2 && x !== z && (R < 0 || u[R][1] > u[x][1]) && (R = x);
                var F = -1;
                for (x = 0; x < 3; ++x)
                  (N = R ^ 1 << x) !== w2 && N !== z && (F < 0 && (F = N), (S = u[N])[0] < u[F][0] && (F = N));
                var B = -1;
                for (x = 0; x < 3; ++x) {
                  var N;
                  (N = R ^ 1 << x) !== w2 && N !== z && N !== F && (B < 0 && (B = N), (S = u[N])[0] > u[B][0] && (B = N));
                }
                var j = v;
                j[0] = j[1] = j[2] = 0, j[n3.log2(F ^ R)] = R & F, j[n3.log2(R ^ B)] = R & B;
                var U = 7 ^ B;
                U === w2 || U === z ? (U = 7 ^ F, j[n3.log2(B ^ U)] = U & B) : j[n3.log2(F ^ U)] = U & F;
                var V = g2, H = w2;
                for (A = 0; A < 3; ++A)
                  V[A] = H & 1 << A ? -1 : 1;
                return y;
              };
              var n3 = r4(2288), i2 = r4(104), a = r4(4670), o = r4(417), s = new Array(16), l = new Array(8), u = new Array(8), c = new Array(3), f2 = [0, 0, 0];
              function h(t5, e5, r5) {
                for (var n4 = 0; n4 < 4; ++n4) {
                  t5[n4] = r5[12 + n4];
                  for (var i3 = 0; i3 < 3; ++i3)
                    t5[n4] += e5[i3] * r5[4 * i3 + n4];
                }
              }
              !function() {
                for (var t5 = 0; t5 < 8; ++t5)
                  l[t5] = [1, 1, 1, 1], u[t5] = [1, 1, 1];
              }();
              var p2 = [[0, 0, 1, 0, 0], [0, 0, -1, 1, 0], [0, -1, 0, 1, 0], [0, 1, 0, 1, 0], [-1, 0, 0, 1, 0], [1, 0, 0, 1, 0]];
              function d2(t5) {
                for (var e5 = 0; e5 < p2.length; ++e5)
                  if ((t5 = a.positive(t5, p2[e5])).length < 3)
                    return 0;
                var r5 = t5[0], n4 = r5[0] / r5[3], i3 = r5[1] / r5[3], o2 = 0;
                for (e5 = 1; e5 + 1 < t5.length; ++e5) {
                  var s2 = t5[e5], l2 = t5[e5 + 1], u2 = s2[0] / s2[3] - n4, c2 = s2[1] / s2[3] - i3, f3 = l2[0] / l2[3] - n4, h2 = l2[1] / l2[3] - i3;
                  o2 += Math.abs(u2 * h2 - c2 * f3);
                }
                return o2;
              }
              var v = [1, 1, 1], g2 = [0, 0, 0], y = { cubeEdges: v, axis: g2 };
            }, 1681: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5) {
                var o2 = [], s2 = [0, 0, 0], l2 = [0, 0, 0], u2 = [0, 0, 0], c2 = [0, 0, 0];
                o2.push(0, 0, 1, 0, 1, 1, 0, 0, -1, 0, 0, -1, 0, 1, 1, 0, 1, -1);
                for (var f3 = 0; f3 < 3; ++f3) {
                  for (var h2 = o2.length / 3 | 0, d3 = 0; d3 < r5[f3].length; ++d3) {
                    var v = +r5[f3][d3].x;
                    o2.push(v, 0, 1, v, 1, 1, v, 0, -1, v, 0, -1, v, 1, 1, v, 1, -1);
                  }
                  var g2 = o2.length / 3 | 0;
                  s2[f3] = h2, l2[f3] = g2 - h2, h2 = o2.length / 3 | 0;
                  for (var y = 0; y < r5[f3].length; ++y)
                    v = +r5[f3][y].x, o2.push(v, 0, 1, v, 1, 1, v, 0, -1, v, 0, -1, v, 1, 1, v, 1, -1);
                  g2 = o2.length / 3 | 0, u2[f3] = h2, c2[f3] = g2 - h2;
                }
                var m2 = n3(t5, new Float32Array(o2)), x = i2(t5, [{ buffer: m2, type: t5.FLOAT, size: 3, stride: 0, offset: 0 }]), b = a(t5);
                return b.attributes.position.location = 0, new p2(t5, m2, x, b, l2, s2, c2, u2);
              };
              var n3 = r4(5827), i2 = r4(2944), a = r4(1943).j, o = [0, 0, 0], s = [0, 0, 0], l = [0, 0, 0], u = [0, 0, 0], c = [1, 1];
              function f2(t5) {
                return t5[0] = t5[1] = t5[2] = 0, t5;
              }
              function h(t5, e5) {
                return t5[0] = e5[0], t5[1] = e5[1], t5[2] = e5[2], t5;
              }
              function p2(t5, e5, r5, n4, i3, a2, o2, s2) {
                this.gl = t5, this.vertBuffer = e5, this.vao = r5, this.shader = n4, this.tickCount = i3, this.tickOffset = a2, this.gridCount = o2, this.gridOffset = s2;
              }
              var d2 = p2.prototype;
              d2.bind = function(t5, e5, r5) {
                this.shader.bind(), this.shader.uniforms.model = t5, this.shader.uniforms.view = e5, this.shader.uniforms.projection = r5, c[0] = this.gl.drawingBufferWidth, c[1] = this.gl.drawingBufferHeight, this.shader.uniforms.screenShape = c, this.vao.bind();
              }, d2.unbind = function() {
                this.vao.unbind();
              }, d2.drawAxisLine = function(t5, e5, r5, n4, i3) {
                var a2 = f2(s);
                this.shader.uniforms.majorAxis = s, a2[t5] = e5[1][t5] - e5[0][t5], this.shader.uniforms.minorAxis = a2;
                var o2, c2 = h(u, r5);
                c2[t5] += e5[0][t5], this.shader.uniforms.offset = c2, this.shader.uniforms.lineWidth = i3, this.shader.uniforms.color = n4, (o2 = f2(l))[(t5 + 2) % 3] = 1, this.shader.uniforms.screenAxis = o2, this.vao.draw(this.gl.TRIANGLES, 6), (o2 = f2(l))[(t5 + 1) % 3] = 1, this.shader.uniforms.screenAxis = o2, this.vao.draw(this.gl.TRIANGLES, 6);
              }, d2.drawAxisTicks = function(t5, e5, r5, n4, i3) {
                if (this.tickCount[t5]) {
                  var a2 = f2(o);
                  a2[t5] = 1, this.shader.uniforms.majorAxis = a2, this.shader.uniforms.offset = e5, this.shader.uniforms.minorAxis = r5, this.shader.uniforms.color = n4, this.shader.uniforms.lineWidth = i3;
                  var s2 = f2(l);
                  s2[t5] = 1, this.shader.uniforms.screenAxis = s2, this.vao.draw(this.gl.TRIANGLES, this.tickCount[t5], this.tickOffset[t5]);
                }
              }, d2.drawGrid = function(t5, e5, r5, n4, i3, a2) {
                if (this.gridCount[t5]) {
                  var c2 = f2(s);
                  c2[e5] = r5[1][e5] - r5[0][e5], this.shader.uniforms.minorAxis = c2;
                  var p3 = h(u, n4);
                  p3[e5] += r5[0][e5], this.shader.uniforms.offset = p3;
                  var d3 = f2(o);
                  d3[t5] = 1, this.shader.uniforms.majorAxis = d3;
                  var v = f2(l);
                  v[t5] = 1, this.shader.uniforms.screenAxis = v, this.shader.uniforms.lineWidth = a2, this.shader.uniforms.color = i3, this.vao.draw(this.gl.TRIANGLES, this.gridCount[t5], this.gridOffset[t5]);
                }
              }, d2.drawZero = function(t5, e5, r5, n4, i3, a2) {
                var o2 = f2(s);
                this.shader.uniforms.majorAxis = o2, o2[t5] = r5[1][t5] - r5[0][t5], this.shader.uniforms.minorAxis = o2;
                var c2 = h(u, n4);
                c2[t5] += r5[0][t5], this.shader.uniforms.offset = c2;
                var p3 = f2(l);
                p3[e5] = 1, this.shader.uniforms.screenAxis = p3, this.shader.uniforms.lineWidth = a2, this.shader.uniforms.color = i3, this.vao.draw(this.gl.TRIANGLES, 6);
              }, d2.dispose = function() {
                this.vao.dispose(), this.vertBuffer.dispose(), this.shader.dispose();
              };
            }, 1943: function(t4, e4, r4) {
              var n3 = r4(6832), i2 = r4(5158), a = n3(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec3 position;\n\nuniform mat4 model, view, projection;\nuniform vec3 offset, majorAxis, minorAxis, screenAxis;\nuniform float lineWidth;\nuniform vec2 screenShape;\n\nvec3 project(vec3 p) {\n  vec4 pp = projection * view * model * vec4(p, 1.0);\n  return pp.xyz / max(pp.w, 0.0001);\n}\n\nvoid main() {\n  vec3 major = position.x * majorAxis;\n  vec3 minor = position.y * minorAxis;\n\n  vec3 vPosition = major + minor + offset;\n  vec3 pPosition = project(vPosition);\n  vec3 offset = project(vPosition + screenAxis * position.z);\n\n  vec2 screen = normalize((offset - pPosition).xy * screenShape) / screenShape;\n\n  gl_Position = vec4(pPosition + vec3(0.5 * screen * lineWidth, 0), 1.0);\n}\n"]), o = n3(["precision highp float;\n#define GLSLIFY 1\n\nuniform vec4 color;\nvoid main() {\n  gl_FragColor = color;\n}"]);
              e4.j = function(t5) {
                return i2(t5, a, o, null, [{ name: "position", type: "vec3" }]);
              };
              var s = n3(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec3 position;\n\nuniform mat4 model, view, projection;\nuniform vec3 offset, axis, alignDir, alignOpt;\nuniform float scale, angle, pixelScale;\nuniform vec2 resolution;\n\nvec3 project(vec3 p) {\n  vec4 pp = projection * view * model * vec4(p, 1.0);\n  return pp.xyz / max(pp.w, 0.0001);\n}\n\nfloat computeViewAngle(vec3 a, vec3 b) {\n  vec3 A = project(a);\n  vec3 B = project(b);\n\n  return atan(\n    (B.y - A.y) * resolution.y,\n    (B.x - A.x) * resolution.x\n  );\n}\n\nconst float PI = 3.141592;\nconst float TWO_PI = 2.0 * PI;\nconst float HALF_PI = 0.5 * PI;\nconst float ONE_AND_HALF_PI = 1.5 * PI;\n\nint option = int(floor(alignOpt.x + 0.001));\nfloat hv_ratio =       alignOpt.y;\nbool enableAlign =    (alignOpt.z != 0.0);\n\nfloat mod_angle(float a) {\n  return mod(a, PI);\n}\n\nfloat positive_angle(float a) {\n  return mod_angle((a < 0.0) ?\n    a + TWO_PI :\n    a\n  );\n}\n\nfloat look_upwards(float a) {\n  float b = positive_angle(a);\n  return ((b > HALF_PI) && (b <= ONE_AND_HALF_PI)) ?\n    b - PI :\n    b;\n}\n\nfloat look_horizontal_or_vertical(float a, float ratio) {\n  // ratio controls the ratio between being horizontal to (vertical + horizontal)\n  // if ratio is set to 0.5 then it is 50%, 50%.\n  // when using a higher ratio e.g. 0.75 the result would\n  // likely be more horizontal than vertical.\n\n  float b = positive_angle(a);\n\n  return\n    (b < (      ratio) * HALF_PI) ? 0.0 :\n    (b < (2.0 - ratio) * HALF_PI) ? -HALF_PI :\n    (b < (2.0 + ratio) * HALF_PI) ? 0.0 :\n    (b < (4.0 - ratio) * HALF_PI) ? HALF_PI :\n                                    0.0;\n}\n\nfloat roundTo(float a, float b) {\n  return float(b * floor((a + 0.5 * b) / b));\n}\n\nfloat look_round_n_directions(float a, int n) {\n  float b = positive_angle(a);\n  float div = TWO_PI / float(n);\n  float c = roundTo(b, div);\n  return look_upwards(c);\n}\n\nfloat applyAlignOption(float rawAngle, float delta) {\n  return\n    (option >  2) ? look_round_n_directions(rawAngle + delta, option) :       // option 3-n: round to n directions\n    (option == 2) ? look_horizontal_or_vertical(rawAngle + delta, hv_ratio) : // horizontal or vertical\n    (option == 1) ? rawAngle + delta :       // use free angle, and flip to align with one direction of the axis\n    (option == 0) ? look_upwards(rawAngle) : // use free angle, and stay upwards\n    (option ==-1) ? 0.0 :                    // useful for backward compatibility, all texts remains horizontal\n                    rawAngle;                // otherwise return back raw input angle\n}\n\nbool isAxisTitle = (axis.x == 0.0) &&\n                   (axis.y == 0.0) &&\n                   (axis.z == 0.0);\n\nvoid main() {\n  //Compute world offset\n  float axisDistance = position.z;\n  vec3 dataPosition = axisDistance * axis + offset;\n\n  float beta = angle; // i.e. user defined attributes for each tick\n\n  float axisAngle;\n  float clipAngle;\n  float flip;\n\n  if (enableAlign) {\n    axisAngle = (isAxisTitle) ? HALF_PI :\n                      computeViewAngle(dataPosition, dataPosition + axis);\n    clipAngle = computeViewAngle(dataPosition, dataPosition + alignDir);\n\n    axisAngle += (sin(axisAngle) < 0.0) ? PI : 0.0;\n    clipAngle += (sin(clipAngle) < 0.0) ? PI : 0.0;\n\n    flip = (dot(vec2(cos(axisAngle), sin(axisAngle)),\n                vec2(sin(clipAngle),-cos(clipAngle))) > 0.0) ? 1.0 : 0.0;\n\n    beta += applyAlignOption(clipAngle, flip * PI);\n  }\n\n  //Compute plane offset\n  vec2 planeCoord = position.xy * pixelScale;\n\n  mat2 planeXform = scale * mat2(\n     cos(beta), sin(beta),\n    -sin(beta), cos(beta)\n  );\n\n  vec2 viewOffset = 2.0 * planeXform * planeCoord / resolution;\n\n  //Compute clip position\n  vec3 clipPosition = project(dataPosition);\n\n  //Apply text offset in clip coordinates\n  clipPosition += vec3(viewOffset, 0.0);\n\n  //Done\n  gl_Position = vec4(clipPosition, 1.0);\n}"]), l = n3(["precision highp float;\n#define GLSLIFY 1\n\nuniform vec4 color;\nvoid main() {\n  gl_FragColor = color;\n}"]);
              e4.f = function(t5) {
                return i2(t5, s, l, null, [{ name: "position", type: "vec3" }]);
              };
              var u = n3(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec3 position;\nattribute vec3 normal;\n\nuniform mat4 model, view, projection;\nuniform vec3 enable;\nuniform vec3 bounds[2];\n\nvarying vec3 colorChannel;\n\nvoid main() {\n\n  vec3 signAxis = sign(bounds[1] - bounds[0]);\n\n  vec3 realNormal = signAxis * normal;\n\n  if(dot(realNormal, enable) > 0.0) {\n    vec3 minRange = min(bounds[0], bounds[1]);\n    vec3 maxRange = max(bounds[0], bounds[1]);\n    vec3 nPosition = mix(minRange, maxRange, 0.5 * (position + 1.0));\n    gl_Position = projection * view * model * vec4(nPosition, 1.0);\n  } else {\n    gl_Position = vec4(0,0,0,0);\n  }\n\n  colorChannel = abs(realNormal);\n}"]), c = n3(["precision highp float;\n#define GLSLIFY 1\n\nuniform vec4 colors[3];\n\nvarying vec3 colorChannel;\n\nvoid main() {\n  gl_FragColor = colorChannel.x * colors[0] +\n                 colorChannel.y * colors[1] +\n                 colorChannel.z * colors[2];\n}"]);
              e4.bg = function(t5) {
                return i2(t5, u, c, null, [{ name: "position", type: "vec3" }, { name: "normal", type: "vec3" }]);
              };
            }, 9557: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5, i2, o2, l2) {
                var u2 = n3(t5), f3 = a(t5, [{ buffer: u2, size: 3 }]), h2 = s(t5);
                h2.attributes.position.location = 0;
                var p2 = new c(t5, h2, u2, f3);
                return p2.update(e5, r5, i2, o2, l2), p2;
              };
              var n3 = r4(5827), a = r4(2944), o = r4(875), s = r4(1943).f, l = window || i.global || {}, u = l.__TEXT_CACHE || {};
              function c(t5, e5, r5, n4) {
                this.gl = t5, this.shader = e5, this.buffer = r5, this.vao = n4, this.tickOffset = this.tickCount = this.labelOffset = this.labelCount = null;
              }
              l.__TEXT_CACHE = {};
              var f2 = c.prototype, h = [0, 0];
              f2.bind = function(t5, e5, r5, n4) {
                this.vao.bind(), this.shader.bind();
                var i2 = this.shader.uniforms;
                i2.model = t5, i2.view = e5, i2.projection = r5, i2.pixelScale = n4, h[0] = this.gl.drawingBufferWidth, h[1] = this.gl.drawingBufferHeight, this.shader.uniforms.resolution = h;
              }, f2.unbind = function() {
                this.vao.unbind();
              }, f2.update = function(t5, e5, r5, n4, i2) {
                var a2 = [];
                function s2(t6, e6, r6, n5, i3, s3) {
                  var l3 = u[r6];
                  l3 || (l3 = u[r6] = {});
                  var c3 = l3[e6];
                  c3 || (c3 = l3[e6] = function(t7, e7) {
                    try {
                      return o(t7, e7);
                    } catch (e8) {
                      return console.warn('error vectorizing text:"' + t7 + '" error:', e8), { cells: [], positions: [] };
                    }
                  }(e6, { triangles: true, font: r6, textAlign: "center", textBaseline: "middle", lineSpacing: i3, styletags: s3 }));
                  for (var f4 = (n5 || 12) / 12, h3 = c3.positions, p3 = c3.cells, d3 = 0, v2 = p3.length; d3 < v2; ++d3)
                    for (var g2 = p3[d3], y = 2; y >= 0; --y) {
                      var m2 = h3[g2[y]];
                      a2.push(f4 * m2[0], -f4 * m2[1], t6);
                    }
                }
                for (var l2 = [0, 0, 0], c2 = [0, 0, 0], f3 = [0, 0, 0], h2 = [0, 0, 0], p2 = { breaklines: true, bolds: true, italics: true, subscripts: true, superscripts: true }, d2 = 0; d2 < 3; ++d2) {
                  f3[d2] = a2.length / 3 | 0, s2(0.5 * (t5[0][d2] + t5[1][d2]), e5[d2], r5[d2], 12, 1.25, p2), h2[d2] = (a2.length / 3 | 0) - f3[d2], l2[d2] = a2.length / 3 | 0;
                  for (var v = 0; v < n4[d2].length; ++v)
                    n4[d2][v].text && s2(n4[d2][v].x, n4[d2][v].text, n4[d2][v].font || i2, n4[d2][v].fontSize || 12, 1.25, p2);
                  c2[d2] = (a2.length / 3 | 0) - l2[d2];
                }
                this.buffer.update(a2), this.tickOffset = l2, this.tickCount = c2, this.labelOffset = f3, this.labelCount = h2;
              }, f2.drawTicks = function(t5, e5, r5, n4, i2, a2, o2, s2) {
                this.tickCount[t5] && (this.shader.uniforms.axis = a2, this.shader.uniforms.color = i2, this.shader.uniforms.angle = r5, this.shader.uniforms.scale = e5, this.shader.uniforms.offset = n4, this.shader.uniforms.alignDir = o2, this.shader.uniforms.alignOpt = s2, this.vao.draw(this.gl.TRIANGLES, this.tickCount[t5], this.tickOffset[t5]));
              }, f2.drawLabel = function(t5, e5, r5, n4, i2, a2, o2, s2) {
                this.labelCount[t5] && (this.shader.uniforms.axis = a2, this.shader.uniforms.color = i2, this.shader.uniforms.angle = r5, this.shader.uniforms.scale = e5, this.shader.uniforms.offset = n4, this.shader.uniforms.alignDir = o2, this.shader.uniforms.alignOpt = s2, this.vao.draw(this.gl.TRIANGLES, this.labelCount[t5], this.labelOffset[t5]));
              }, f2.dispose = function() {
                this.shader.dispose(), this.vao.dispose(), this.buffer.dispose();
              };
            }, 8468: function(t4, e4) {
              function r4(t5, e5) {
                var r5 = t5 + "", n3 = r5.indexOf("."), i2 = 0;
                n3 >= 0 && (i2 = r5.length - n3 - 1);
                var a = Math.pow(10, i2), o = Math.round(t5 * e5 * a), s = o + "";
                if (s.indexOf("e") >= 0)
                  return s;
                var l = o / a, u = o % a;
                o < 0 ? (l = 0 | -Math.ceil(l), u = 0 | -u) : (l = 0 | Math.floor(l), u |= 0);
                var c = "" + l;
                if (o < 0 && (c = "-" + c), i2) {
                  for (var f2 = "" + u; f2.length < i2; )
                    f2 = "0" + f2;
                  return c + "." + f2;
                }
                return c;
              }
              e4.create = function(t5, e5) {
                for (var n3 = [], i2 = 0; i2 < 3; ++i2) {
                  for (var a = [], o = (t5[0][i2], t5[1][i2], 0); o * e5[i2] <= t5[1][i2]; ++o)
                    a.push({ x: o * e5[i2], text: r4(e5[i2], o) });
                  for (o = -1; o * e5[i2] >= t5[0][i2]; --o)
                    a.push({ x: o * e5[i2], text: r4(e5[i2], o) });
                  n3.push(a);
                }
                return n3;
              }, e4.equal = function(t5, e5) {
                for (var r5 = 0; r5 < 3; ++r5) {
                  if (t5[r5].length !== e5[r5].length)
                    return false;
                  for (var n3 = 0; n3 < t5[r5].length; ++n3) {
                    var i2 = t5[r5][n3], a = e5[r5][n3];
                    if (i2.x !== a.x || i2.text !== a.text || i2.font !== a.font || i2.fontColor !== a.fontColor || i2.fontSize !== a.fontSize || i2.dx !== a.dx || i2.dy !== a.dy)
                      return false;
                  }
                }
                return true;
              };
            }, 2771: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5, l2, f3) {
                var h2 = e5.model || u, p3 = e5.view || u, y = e5.projection || u, m2 = e5._ortho || false, x = t5.bounds, b = (f3 = f3 || a(h2, p3, y, x, m2)).axis;
                o(c, p3, h2), o(c, y, c);
                for (var _ = v, w2 = 0; w2 < 3; ++w2)
                  _[w2].lo = 1 / 0, _[w2].hi = -1 / 0, _[w2].pixelsPerDataUnit = 1 / 0;
                var T = n3(s(c, c));
                s(c, c);
                for (var k = 0; k < 3; ++k) {
                  var A = (k + 1) % 3, M = (k + 2) % 3, S = g2;
                  t:
                    for (w2 = 0; w2 < 2; ++w2) {
                      var E = [];
                      if (b[k] < 0 != !!w2) {
                        S[k] = x[w2][k];
                        for (var L = 0; L < 2; ++L) {
                          S[A] = x[L ^ w2][A];
                          for (var C = 0; C < 2; ++C)
                            S[M] = x[C ^ L ^ w2][M], E.push(S.slice());
                        }
                        var P = m2 ? 5 : 4;
                        for (L = P; L === P; ++L) {
                          if (0 === E.length)
                            continue t;
                          E = i2.positive(E, T[L]);
                        }
                        for (L = 0; L < E.length; ++L) {
                          M = E[L];
                          var O = d2(g2, c, M, r5, l2);
                          for (C = 0; C < 3; ++C)
                            _[C].lo = Math.min(_[C].lo, M[C]), _[C].hi = Math.max(_[C].hi, M[C]), C !== k && (_[C].pixelsPerDataUnit = Math.min(_[C].pixelsPerDataUnit, Math.abs(O[C])));
                        }
                      }
                    }
                }
                return _;
              };
              var n3 = r4(5795), i2 = r4(4670), a = r4(2864), o = r4(104), s = r4(2142), l = r4(6342), u = new Float32Array([1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1]), c = new Float32Array(16);
              function f2(t5, e5, r5) {
                this.lo = t5, this.hi = e5, this.pixelsPerDataUnit = r5;
              }
              var h = [0, 0, 0, 1], p2 = [0, 0, 0, 1];
              function d2(t5, e5, r5, n4, i3) {
                for (var a2 = 0; a2 < 3; ++a2) {
                  for (var o2 = h, s2 = p2, u2 = 0; u2 < 3; ++u2)
                    s2[u2] = o2[u2] = r5[u2];
                  s2[3] = o2[3] = 1, s2[a2] += 1, l(s2, s2, e5), s2[3] < 0 && (t5[a2] = 1 / 0), o2[a2] -= 1, l(o2, o2, e5), o2[3] < 0 && (t5[a2] = 1 / 0);
                  var c2 = (o2[0] / o2[3] - s2[0] / s2[3]) * n4, f3 = (o2[1] / o2[3] - s2[1] / s2[3]) * i3;
                  t5[a2] = 0.25 * Math.sqrt(c2 * c2 + f3 * f3);
                }
                return t5;
              }
              var v = [new f2(1 / 0, -1 / 0, 1 / 0), new f2(1 / 0, -1 / 0, 1 / 0), new f2(1 / 0, -1 / 0, 1 / 0)], g2 = [0, 0, 0];
            }, 5827: function(t4, e4, r4) {
              var n3 = r4(5306), i2 = r4(7498), a = r4(5050), o = ["uint8", "uint8_clamped", "uint16", "uint32", "int8", "int16", "int32", "float32"];
              function s(t5, e5, r5, n4, i3) {
                this.gl = t5, this.type = e5, this.handle = r5, this.length = n4, this.usage = i3;
              }
              var l = s.prototype;
              function u(t5, e5, r5, n4, i3, a2) {
                var o2 = i3.length * i3.BYTES_PER_ELEMENT;
                if (a2 < 0)
                  return t5.bufferData(e5, i3, n4), o2;
                if (o2 + a2 > r5)
                  throw new Error("gl-buffer: If resizing buffer, must not specify offset");
                return t5.bufferSubData(e5, a2, i3), r5;
              }
              function c(t5, e5) {
                for (var r5 = n3.malloc(t5.length, e5), i3 = t5.length, a2 = 0; a2 < i3; ++a2)
                  r5[a2] = t5[a2];
                return r5;
              }
              l.bind = function() {
                this.gl.bindBuffer(this.type, this.handle);
              }, l.unbind = function() {
                this.gl.bindBuffer(this.type, null);
              }, l.dispose = function() {
                this.gl.deleteBuffer(this.handle);
              }, l.update = function(t5, e5) {
                if ("number" != typeof e5 && (e5 = -1), this.bind(), "object" == typeof t5 && void 0 !== t5.shape) {
                  var r5 = t5.dtype;
                  if (o.indexOf(r5) < 0 && (r5 = "float32"), this.type === this.gl.ELEMENT_ARRAY_BUFFER && (r5 = gl.getExtension("OES_element_index_uint") && "uint16" !== r5 ? "uint32" : "uint16"), r5 === t5.dtype && function(t6, e6) {
                    for (var r6 = 1, n4 = e6.length - 1; n4 >= 0; --n4) {
                      if (e6[n4] !== r6)
                        return false;
                      r6 *= t6[n4];
                    }
                    return true;
                  }(t5.shape, t5.stride))
                    0 === t5.offset && t5.data.length === t5.shape[0] ? this.length = u(this.gl, this.type, this.length, this.usage, t5.data, e5) : this.length = u(this.gl, this.type, this.length, this.usage, t5.data.subarray(t5.offset, t5.shape[0]), e5);
                  else {
                    var s2 = n3.malloc(t5.size, r5), l2 = a(s2, t5.shape);
                    i2.assign(l2, t5), this.length = u(this.gl, this.type, this.length, this.usage, e5 < 0 ? s2 : s2.subarray(0, t5.size), e5), n3.free(s2);
                  }
                } else if (Array.isArray(t5)) {
                  var f2;
                  f2 = this.type === this.gl.ELEMENT_ARRAY_BUFFER ? c(t5, "uint16") : c(t5, "float32"), this.length = u(this.gl, this.type, this.length, this.usage, e5 < 0 ? f2 : f2.subarray(0, t5.length), e5), n3.free(f2);
                } else if ("object" == typeof t5 && "number" == typeof t5.length)
                  this.length = u(this.gl, this.type, this.length, this.usage, t5, e5);
                else {
                  if ("number" != typeof t5 && void 0 !== t5)
                    throw new Error("gl-buffer: Invalid data type");
                  if (e5 >= 0)
                    throw new Error("gl-buffer: Cannot specify offset when resizing buffer");
                  (t5 |= 0) <= 0 && (t5 = 1), this.gl.bufferData(this.type, 0 | t5, this.usage), this.length = t5;
                }
              }, t4.exports = function(t5, e5, r5, n4) {
                if (r5 = r5 || t5.ARRAY_BUFFER, n4 = n4 || t5.DYNAMIC_DRAW, r5 !== t5.ARRAY_BUFFER && r5 !== t5.ELEMENT_ARRAY_BUFFER)
                  throw new Error("gl-buffer: Invalid type for webgl buffer, must be either gl.ARRAY_BUFFER or gl.ELEMENT_ARRAY_BUFFER");
                if (n4 !== t5.DYNAMIC_DRAW && n4 !== t5.STATIC_DRAW && n4 !== t5.STREAM_DRAW)
                  throw new Error("gl-buffer: Invalid usage for buffer, must be either gl.DYNAMIC_DRAW, gl.STATIC_DRAW or gl.STREAM_DRAW");
                var i3 = t5.createBuffer(), a2 = new s(t5, r5, i3, 0, n4);
                return a2.update(e5), a2;
              };
            }, 1140: function(t4, e4, r4) {
              var n3 = r4(2858);
              t4.exports = function(t5, e5) {
                var r5 = t5.positions, i3 = t5.vectors, a = { positions: [], vertexIntensity: [], vertexIntensityBounds: t5.vertexIntensityBounds, vectors: [], cells: [], coneOffset: t5.coneOffset, colormap: t5.colormap };
                if (0 === t5.positions.length)
                  return e5 && (e5[0] = [0, 0, 0], e5[1] = [0, 0, 0]), a;
                for (var o = 0, s = 1 / 0, l = -1 / 0, u = 1 / 0, c = -1 / 0, f2 = 1 / 0, h = -1 / 0, p2 = null, d2 = null, v = [], g2 = 1 / 0, y = false, m2 = 0; m2 < r5.length; m2++) {
                  var x = r5[m2];
                  s = Math.min(x[0], s), l = Math.max(x[0], l), u = Math.min(x[1], u), c = Math.max(x[1], c), f2 = Math.min(x[2], f2), h = Math.max(x[2], h);
                  var b = i3[m2];
                  if (n3.length(b) > o && (o = n3.length(b)), m2) {
                    var _ = 2 * n3.distance(p2, x) / (n3.length(d2) + n3.length(b));
                    _ ? (g2 = Math.min(g2, _), y = false) : y = true;
                  }
                  y || (p2 = x, d2 = b), v.push(b);
                }
                var w2 = [s, u, f2], T = [l, c, h];
                e5 && (e5[0] = w2, e5[1] = T), 0 === o && (o = 1);
                var k = 1 / o;
                isFinite(g2) || (g2 = 1), a.vectorScale = g2;
                var A = t5.coneSize || 0.5;
                t5.absoluteConeSize && (A = t5.absoluteConeSize * k), a.coneScale = A, m2 = 0;
                for (var M = 0; m2 < r5.length; m2++)
                  for (var S = (x = r5[m2])[0], E = x[1], L = x[2], C = v[m2], P = n3.length(C) * k, O = 0; O < 8; O++) {
                    a.positions.push([S, E, L, M++]), a.positions.push([S, E, L, M++]), a.positions.push([S, E, L, M++]), a.positions.push([S, E, L, M++]), a.positions.push([S, E, L, M++]), a.positions.push([S, E, L, M++]), a.vectors.push(C), a.vectors.push(C), a.vectors.push(C), a.vectors.push(C), a.vectors.push(C), a.vectors.push(C), a.vertexIntensity.push(P, P, P), a.vertexIntensity.push(P, P, P);
                    var I = a.positions.length;
                    a.cells.push([I - 6, I - 5, I - 4], [I - 3, I - 2, I - 1]);
                  }
                return a;
              };
              var i2 = r4(7234);
              t4.exports.createMesh = r4(5028), t4.exports.createConeMesh = function(e5, r5) {
                return t4.exports.createMesh(e5, r5, { shaders: i2, traceType: "cone" });
              };
            }, 5028: function(t4, e4, r4) {
              var n3 = r4(5158), i2 = r4(5827), a = r4(2944), o = r4(8931), s = r4(104), l = r4(7437), u = r4(5050), c = r4(9156), f2 = [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1];
              function h(t5, e5, r5, n4, i3, a2, o2, s2, l2, u2, c2) {
                this.gl = t5, this.pixelRatio = 1, this.cells = [], this.positions = [], this.intensity = [], this.texture = e5, this.dirty = true, this.triShader = r5, this.pickShader = n4, this.trianglePositions = i3, this.triangleVectors = a2, this.triangleColors = s2, this.triangleUVs = l2, this.triangleIds = o2, this.triangleVAO = u2, this.triangleCount = 0, this.pickId = 1, this.bounds = [[1 / 0, 1 / 0, 1 / 0], [-1 / 0, -1 / 0, -1 / 0]], this.clipBounds = [[-1 / 0, -1 / 0, -1 / 0], [1 / 0, 1 / 0, 1 / 0]], this.lightPosition = [1e5, 1e5, 0], this.ambientLight = 0.8, this.diffuseLight = 0.8, this.specularLight = 2, this.roughness = 0.5, this.fresnel = 1.5, this.opacity = 1, this.traceType = c2, this.tubeScale = 1, this.coneScale = 2, this.vectorScale = 1, this.coneOffset = 0.25, this._model = f2, this._view = f2, this._projection = f2, this._resolution = [1, 1];
              }
              var p2 = h.prototype;
              function d2(t5, e5) {
                var r5 = n3(t5, e5.meshShader.vertex, e5.meshShader.fragment, null, e5.meshShader.attributes);
                return r5.attributes.position.location = 0, r5.attributes.color.location = 2, r5.attributes.uv.location = 3, r5.attributes.vector.location = 4, r5;
              }
              function v(t5, e5) {
                var r5 = n3(t5, e5.pickShader.vertex, e5.pickShader.fragment, null, e5.pickShader.attributes);
                return r5.attributes.position.location = 0, r5.attributes.id.location = 1, r5.attributes.vector.location = 4, r5;
              }
              p2.isOpaque = function() {
                return this.opacity >= 1;
              }, p2.isTransparent = function() {
                return this.opacity < 1;
              }, p2.pickSlots = 1, p2.setPickBase = function(t5) {
                this.pickId = t5;
              }, p2.update = function(t5) {
                t5 = t5 || {};
                var e5 = this.gl;
                this.dirty = true, "lightPosition" in t5 && (this.lightPosition = t5.lightPosition), "opacity" in t5 && (this.opacity = t5.opacity), "ambient" in t5 && (this.ambientLight = t5.ambient), "diffuse" in t5 && (this.diffuseLight = t5.diffuse), "specular" in t5 && (this.specularLight = t5.specular), "roughness" in t5 && (this.roughness = t5.roughness), "fresnel" in t5 && (this.fresnel = t5.fresnel), void 0 !== t5.tubeScale && (this.tubeScale = t5.tubeScale), void 0 !== t5.vectorScale && (this.vectorScale = t5.vectorScale), void 0 !== t5.coneScale && (this.coneScale = t5.coneScale), void 0 !== t5.coneOffset && (this.coneOffset = t5.coneOffset), t5.colormap && (this.texture.shape = [256, 256], this.texture.minFilter = e5.LINEAR_MIPMAP_LINEAR, this.texture.magFilter = e5.LINEAR, this.texture.setPixels(function(t6) {
                  for (var e6 = c({ colormap: t6, nshades: 256, format: "rgba" }), r6 = new Uint8Array(1024), n5 = 0; n5 < 256; ++n5) {
                    for (var i4 = e6[n5], a3 = 0; a3 < 3; ++a3)
                      r6[4 * n5 + a3] = i4[a3];
                    r6[4 * n5 + 3] = 255 * i4[3];
                  }
                  return u(r6, [256, 256, 4], [4, 0, 1]);
                }(t5.colormap)), this.texture.generateMipmap());
                var r5 = t5.cells, n4 = t5.positions, i3 = t5.vectors;
                if (n4 && r5 && i3) {
                  var a2 = [], o2 = [], s2 = [], l2 = [], f3 = [];
                  this.cells = r5, this.positions = n4, this.vectors = i3;
                  var h2 = t5.meshColor || [1, 1, 1, 1], p3 = t5.vertexIntensity, d3 = 1 / 0, v2 = -1 / 0;
                  if (p3)
                    if (t5.vertexIntensityBounds)
                      d3 = +t5.vertexIntensityBounds[0], v2 = +t5.vertexIntensityBounds[1];
                    else
                      for (var g2 = 0; g2 < p3.length; ++g2) {
                        var y = p3[g2];
                        d3 = Math.min(d3, y), v2 = Math.max(v2, y);
                      }
                  else
                    for (g2 = 0; g2 < n4.length; ++g2)
                      y = n4[g2][2], d3 = Math.min(d3, y), v2 = Math.max(v2, y);
                  for (this.intensity = p3 || function(t6) {
                    for (var e6 = t6.length, r6 = new Array(e6), n5 = 0; n5 < e6; ++n5)
                      r6[n5] = t6[n5][2];
                    return r6;
                  }(n4), this.bounds = [[1 / 0, 1 / 0, 1 / 0], [-1 / 0, -1 / 0, -1 / 0]], g2 = 0; g2 < n4.length; ++g2)
                    for (var m2 = n4[g2], x = 0; x < 3; ++x)
                      !isNaN(m2[x]) && isFinite(m2[x]) && (this.bounds[0][x] = Math.min(this.bounds[0][x], m2[x]), this.bounds[1][x] = Math.max(this.bounds[1][x], m2[x]));
                  var b = 0;
                  t:
                    for (g2 = 0; g2 < r5.length; ++g2) {
                      var _ = r5[g2];
                      if (3 === _.length) {
                        for (x = 0; x < 3; ++x) {
                          m2 = n4[T = _[x]];
                          for (var w2 = 0; w2 < 3; ++w2)
                            if (isNaN(m2[w2]) || !isFinite(m2[w2]))
                              continue t;
                        }
                        for (x = 0; x < 3; ++x) {
                          var T;
                          m2 = n4[T = _[2 - x]], a2.push(m2[0], m2[1], m2[2], m2[3]);
                          var k = i3[T];
                          o2.push(k[0], k[1], k[2], k[3] || 0);
                          var A, M = h2;
                          3 === M.length ? s2.push(M[0], M[1], M[2], 1) : s2.push(M[0], M[1], M[2], M[3]), A = p3 ? [(p3[T] - d3) / (v2 - d3), 0] : [(m2[2] - d3) / (v2 - d3), 0], l2.push(A[0], A[1]), f3.push(g2);
                        }
                        b += 1;
                      }
                    }
                  this.triangleCount = b, this.trianglePositions.update(a2), this.triangleVectors.update(o2), this.triangleColors.update(s2), this.triangleUVs.update(l2), this.triangleIds.update(new Uint32Array(f3));
                }
              }, p2.drawTransparent = p2.draw = function(t5) {
                t5 = t5 || {};
                for (var e5 = this.gl, r5 = t5.model || f2, n4 = t5.view || f2, i3 = t5.projection || f2, a2 = [[-1e6, -1e6, -1e6], [1e6, 1e6, 1e6]], o2 = 0; o2 < 3; ++o2)
                  a2[0][o2] = Math.max(a2[0][o2], this.clipBounds[0][o2]), a2[1][o2] = Math.min(a2[1][o2], this.clipBounds[1][o2]);
                var u2 = { model: r5, view: n4, projection: i3, inverseModel: f2.slice(), clipBounds: a2, kambient: this.ambientLight, kdiffuse: this.diffuseLight, kspecular: this.specularLight, roughness: this.roughness, fresnel: this.fresnel, eyePosition: [0, 0, 0], lightPosition: [0, 0, 0], opacity: this.opacity, tubeScale: this.tubeScale, vectorScale: this.vectorScale, coneScale: this.coneScale, coneOffset: this.coneOffset, texture: 0 };
                u2.inverseModel = l(u2.inverseModel, u2.model), e5.disable(e5.CULL_FACE), this.texture.bind(0);
                var c2 = new Array(16);
                for (s(c2, u2.view, u2.model), s(c2, u2.projection, c2), l(c2, c2), o2 = 0; o2 < 3; ++o2)
                  u2.eyePosition[o2] = c2[12 + o2] / c2[15];
                var h2 = c2[15];
                for (o2 = 0; o2 < 3; ++o2)
                  h2 += this.lightPosition[o2] * c2[4 * o2 + 3];
                for (o2 = 0; o2 < 3; ++o2) {
                  for (var p3 = c2[12 + o2], d3 = 0; d3 < 3; ++d3)
                    p3 += c2[4 * d3 + o2] * this.lightPosition[d3];
                  u2.lightPosition[o2] = p3 / h2;
                }
                if (this.triangleCount > 0) {
                  var v2 = this.triShader;
                  v2.bind(), v2.uniforms = u2, this.triangleVAO.bind(), e5.drawArrays(e5.TRIANGLES, 0, 3 * this.triangleCount), this.triangleVAO.unbind();
                }
              }, p2.drawPick = function(t5) {
                t5 = t5 || {};
                for (var e5 = this.gl, r5 = t5.model || f2, n4 = t5.view || f2, i3 = t5.projection || f2, a2 = [[-1e6, -1e6, -1e6], [1e6, 1e6, 1e6]], o2 = 0; o2 < 3; ++o2)
                  a2[0][o2] = Math.max(a2[0][o2], this.clipBounds[0][o2]), a2[1][o2] = Math.min(a2[1][o2], this.clipBounds[1][o2]);
                this._model = [].slice.call(r5), this._view = [].slice.call(n4), this._projection = [].slice.call(i3), this._resolution = [e5.drawingBufferWidth, e5.drawingBufferHeight];
                var s2 = { model: r5, view: n4, projection: i3, clipBounds: a2, tubeScale: this.tubeScale, vectorScale: this.vectorScale, coneScale: this.coneScale, coneOffset: this.coneOffset, pickId: this.pickId / 255 }, l2 = this.pickShader;
                l2.bind(), l2.uniforms = s2, this.triangleCount > 0 && (this.triangleVAO.bind(), e5.drawArrays(e5.TRIANGLES, 0, 3 * this.triangleCount), this.triangleVAO.unbind());
              }, p2.pick = function(t5) {
                if (!t5)
                  return null;
                if (t5.id !== this.pickId)
                  return null;
                var e5 = t5.value[0] + 256 * t5.value[1] + 65536 * t5.value[2], r5 = this.cells[e5], n4 = this.positions[r5[1]].slice(0, 3), i3 = { position: n4, dataCoordinate: n4, index: Math.floor(r5[1] / 48) };
                return "cone" === this.traceType ? i3.index = Math.floor(r5[1] / 48) : "streamtube" === this.traceType && (i3.intensity = this.intensity[r5[1]], i3.velocity = this.vectors[r5[1]].slice(0, 3), i3.divergence = this.vectors[r5[1]][3], i3.index = e5), i3;
              }, p2.dispose = function() {
                this.texture.dispose(), this.triShader.dispose(), this.pickShader.dispose(), this.triangleVAO.dispose(), this.trianglePositions.dispose(), this.triangleVectors.dispose(), this.triangleColors.dispose(), this.triangleUVs.dispose(), this.triangleIds.dispose();
              }, t4.exports = function(t5, e5, r5) {
                var n4 = r5.shaders;
                1 === arguments.length && (t5 = (e5 = t5).gl);
                var s2 = d2(t5, n4), l2 = v(t5, n4), c2 = o(t5, u(new Uint8Array([255, 255, 255, 255]), [1, 1, 4]));
                c2.generateMipmap(), c2.minFilter = t5.LINEAR_MIPMAP_LINEAR, c2.magFilter = t5.LINEAR;
                var f3 = i2(t5), p3 = i2(t5), g2 = i2(t5), y = i2(t5), m2 = i2(t5), x = a(t5, [{ buffer: f3, type: t5.FLOAT, size: 4 }, { buffer: m2, type: t5.UNSIGNED_BYTE, size: 4, normalized: true }, { buffer: g2, type: t5.FLOAT, size: 4 }, { buffer: y, type: t5.FLOAT, size: 2 }, { buffer: p3, type: t5.FLOAT, size: 4 }]), b = new h(t5, c2, s2, l2, f3, p3, m2, g2, y, x, r5.traceType || "cone");
                return b.update(e5), b;
              };
            }, 7234: function(t4, e4, r4) {
              var n3 = r4(6832), i2 = n3(["precision highp float;\n\nprecision highp float;\n#define GLSLIFY 1\n\nvec3 getOrthogonalVector(vec3 v) {\n  // Return up-vector for only-z vector.\n  // Return ax + by + cz = 0, a point that lies on the plane that has v as a normal and that isn't (0,0,0).\n  // From the above if-statement we have ||a|| > 0  U  ||b|| > 0.\n  // Assign z = 0, x = -b, y = a:\n  // a*-b + b*a + c*0 = -ba + ba + 0 = 0\n  if (v.x*v.x > v.z*v.z || v.y*v.y > v.z*v.z) {\n    return normalize(vec3(-v.y, v.x, 0.0));\n  } else {\n    return normalize(vec3(0.0, v.z, -v.y));\n  }\n}\n\n// Calculate the cone vertex and normal at the given index.\n//\n// The returned vertex is for a cone with its top at origin and height of 1.0,\n// pointing in the direction of the vector attribute.\n//\n// Each cone is made up of a top vertex, a center base vertex and base perimeter vertices.\n// These vertices are used to make up the triangles of the cone by the following:\n//   segment + 0 top vertex\n//   segment + 1 perimeter vertex a+1\n//   segment + 2 perimeter vertex a\n//   segment + 3 center base vertex\n//   segment + 4 perimeter vertex a\n//   segment + 5 perimeter vertex a+1\n// Where segment is the number of the radial segment * 6 and a is the angle at that radial segment.\n// To go from index to segment, floor(index / 6)\n// To go from segment to angle, 2*pi * (segment/segmentCount)\n// To go from index to segment index, index - (segment*6)\n//\nvec3 getConePosition(vec3 d, float rawIndex, float coneOffset, out vec3 normal) {\n\n  const float segmentCount = 8.0;\n\n  float index = rawIndex - floor(rawIndex /\n    (segmentCount * 6.0)) *\n    (segmentCount * 6.0);\n\n  float segment = floor(0.001 + index/6.0);\n  float segmentIndex = index - (segment*6.0);\n\n  normal = -normalize(d);\n\n  if (segmentIndex > 2.99 && segmentIndex < 3.01) {\n    return mix(vec3(0.0), -d, coneOffset);\n  }\n\n  float nextAngle = (\n    (segmentIndex > 0.99 &&  segmentIndex < 1.01) ||\n    (segmentIndex > 4.99 &&  segmentIndex < 5.01)\n  ) ? 1.0 : 0.0;\n  float angle = 2.0 * 3.14159 * ((segment + nextAngle) / segmentCount);\n\n  vec3 v1 = mix(d, vec3(0.0), coneOffset);\n  vec3 v2 = v1 - d;\n\n  vec3 u = getOrthogonalVector(d);\n  vec3 v = normalize(cross(u, d));\n\n  vec3 x = u * cos(angle) * length(d)*0.25;\n  vec3 y = v * sin(angle) * length(d)*0.25;\n  vec3 v3 = v2 + x + y;\n  if (segmentIndex < 3.0) {\n    vec3 tx = u * sin(angle);\n    vec3 ty = v * -cos(angle);\n    vec3 tangent = tx + ty;\n    normal = normalize(cross(v3 - v1, tangent));\n  }\n\n  if (segmentIndex == 0.0) {\n    return mix(d, vec3(0.0), coneOffset);\n  }\n  return v3;\n}\n\nattribute vec3 vector;\nattribute vec4 color, position;\nattribute vec2 uv;\n\nuniform float vectorScale, coneScale, coneOffset;\nuniform mat4 model, view, projection, inverseModel;\nuniform vec3 eyePosition, lightPosition;\n\nvarying vec3 f_normal, f_lightDirection, f_eyeDirection, f_data, f_position;\nvarying vec4 f_color;\nvarying vec2 f_uv;\n\nvoid main() {\n  // Scale the vector magnitude to stay constant with\n  // model & view changes.\n  vec3 normal;\n  vec3 XYZ = getConePosition(mat3(model) * ((vectorScale * coneScale) * vector), position.w, coneOffset, normal);\n  vec4 conePosition = model * vec4(position.xyz, 1.0) + vec4(XYZ, 0.0);\n\n  //Lighting geometry parameters\n  vec4 cameraCoordinate = view * conePosition;\n  cameraCoordinate.xyz /= cameraCoordinate.w;\n  f_lightDirection = lightPosition - cameraCoordinate.xyz;\n  f_eyeDirection   = eyePosition - cameraCoordinate.xyz;\n  f_normal = normalize((vec4(normal, 0.0) * inverseModel).xyz);\n\n  // vec4 m_position  = model * vec4(conePosition, 1.0);\n  vec4 t_position  = view * conePosition;\n  gl_Position      = projection * t_position;\n\n  f_color          = color;\n  f_data           = conePosition.xyz;\n  f_position       = position.xyz;\n  f_uv             = uv;\n}\n"]), a = n3(["#extension GL_OES_standard_derivatives : enable\n\nprecision highp float;\n#define GLSLIFY 1\n\nfloat beckmannDistribution(float x, float roughness) {\n  float NdotH = max(x, 0.0001);\n  float cos2Alpha = NdotH * NdotH;\n  float tan2Alpha = (cos2Alpha - 1.0) / cos2Alpha;\n  float roughness2 = roughness * roughness;\n  float denom = 3.141592653589793 * roughness2 * cos2Alpha * cos2Alpha;\n  return exp(tan2Alpha / roughness2) / denom;\n}\n\nfloat cookTorranceSpecular(\n  vec3 lightDirection,\n  vec3 viewDirection,\n  vec3 surfaceNormal,\n  float roughness,\n  float fresnel) {\n\n  float VdotN = max(dot(viewDirection, surfaceNormal), 0.0);\n  float LdotN = max(dot(lightDirection, surfaceNormal), 0.0);\n\n  //Half angle vector\n  vec3 H = normalize(lightDirection + viewDirection);\n\n  //Geometric term\n  float NdotH = max(dot(surfaceNormal, H), 0.0);\n  float VdotH = max(dot(viewDirection, H), 0.000001);\n  float LdotH = max(dot(lightDirection, H), 0.000001);\n  float G1 = (2.0 * NdotH * VdotN) / VdotH;\n  float G2 = (2.0 * NdotH * LdotN) / LdotH;\n  float G = min(1.0, min(G1, G2));\n  \n  //Distribution term\n  float D = beckmannDistribution(NdotH, roughness);\n\n  //Fresnel term\n  float F = pow(1.0 - VdotN, fresnel);\n\n  //Multiply terms and done\n  return  G * F * D / max(3.14159265 * VdotN, 0.000001);\n}\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec3 clipBounds[2];\nuniform float roughness, fresnel, kambient, kdiffuse, kspecular, opacity;\nuniform sampler2D texture;\n\nvarying vec3 f_normal, f_lightDirection, f_eyeDirection, f_data, f_position;\nvarying vec4 f_color;\nvarying vec2 f_uv;\n\nvoid main() {\n  if (outOfRange(clipBounds[0], clipBounds[1], f_position)) discard;\n  vec3 N = normalize(f_normal);\n  vec3 L = normalize(f_lightDirection);\n  vec3 V = normalize(f_eyeDirection);\n\n  if(gl_FrontFacing) {\n    N = -N;\n  }\n\n  float specular = min(1.0, max(0.0, cookTorranceSpecular(L, V, N, roughness, fresnel)));\n  float diffuse  = min(kambient + kdiffuse * max(dot(N, L), 0.0), 1.0);\n\n  vec4 surfaceColor = f_color * texture2D(texture, f_uv);\n  vec4 litColor = surfaceColor.a * vec4(diffuse * surfaceColor.rgb + kspecular * vec3(1,1,1) * specular,  1.0);\n\n  gl_FragColor = litColor * opacity;\n}\n"]), o = n3(["precision highp float;\n\nprecision highp float;\n#define GLSLIFY 1\n\nvec3 getOrthogonalVector(vec3 v) {\n  // Return up-vector for only-z vector.\n  // Return ax + by + cz = 0, a point that lies on the plane that has v as a normal and that isn't (0,0,0).\n  // From the above if-statement we have ||a|| > 0  U  ||b|| > 0.\n  // Assign z = 0, x = -b, y = a:\n  // a*-b + b*a + c*0 = -ba + ba + 0 = 0\n  if (v.x*v.x > v.z*v.z || v.y*v.y > v.z*v.z) {\n    return normalize(vec3(-v.y, v.x, 0.0));\n  } else {\n    return normalize(vec3(0.0, v.z, -v.y));\n  }\n}\n\n// Calculate the cone vertex and normal at the given index.\n//\n// The returned vertex is for a cone with its top at origin and height of 1.0,\n// pointing in the direction of the vector attribute.\n//\n// Each cone is made up of a top vertex, a center base vertex and base perimeter vertices.\n// These vertices are used to make up the triangles of the cone by the following:\n//   segment + 0 top vertex\n//   segment + 1 perimeter vertex a+1\n//   segment + 2 perimeter vertex a\n//   segment + 3 center base vertex\n//   segment + 4 perimeter vertex a\n//   segment + 5 perimeter vertex a+1\n// Where segment is the number of the radial segment * 6 and a is the angle at that radial segment.\n// To go from index to segment, floor(index / 6)\n// To go from segment to angle, 2*pi * (segment/segmentCount)\n// To go from index to segment index, index - (segment*6)\n//\nvec3 getConePosition(vec3 d, float rawIndex, float coneOffset, out vec3 normal) {\n\n  const float segmentCount = 8.0;\n\n  float index = rawIndex - floor(rawIndex /\n    (segmentCount * 6.0)) *\n    (segmentCount * 6.0);\n\n  float segment = floor(0.001 + index/6.0);\n  float segmentIndex = index - (segment*6.0);\n\n  normal = -normalize(d);\n\n  if (segmentIndex > 2.99 && segmentIndex < 3.01) {\n    return mix(vec3(0.0), -d, coneOffset);\n  }\n\n  float nextAngle = (\n    (segmentIndex > 0.99 &&  segmentIndex < 1.01) ||\n    (segmentIndex > 4.99 &&  segmentIndex < 5.01)\n  ) ? 1.0 : 0.0;\n  float angle = 2.0 * 3.14159 * ((segment + nextAngle) / segmentCount);\n\n  vec3 v1 = mix(d, vec3(0.0), coneOffset);\n  vec3 v2 = v1 - d;\n\n  vec3 u = getOrthogonalVector(d);\n  vec3 v = normalize(cross(u, d));\n\n  vec3 x = u * cos(angle) * length(d)*0.25;\n  vec3 y = v * sin(angle) * length(d)*0.25;\n  vec3 v3 = v2 + x + y;\n  if (segmentIndex < 3.0) {\n    vec3 tx = u * sin(angle);\n    vec3 ty = v * -cos(angle);\n    vec3 tangent = tx + ty;\n    normal = normalize(cross(v3 - v1, tangent));\n  }\n\n  if (segmentIndex == 0.0) {\n    return mix(d, vec3(0.0), coneOffset);\n  }\n  return v3;\n}\n\nattribute vec4 vector;\nattribute vec4 position;\nattribute vec4 id;\n\nuniform mat4 model, view, projection;\nuniform float vectorScale, coneScale, coneOffset;\n\nvarying vec3 f_position;\nvarying vec4 f_id;\n\nvoid main() {\n  vec3 normal;\n  vec3 XYZ = getConePosition(mat3(model) * ((vectorScale * coneScale) * vector.xyz), position.w, coneOffset, normal);\n  vec4 conePosition = model * vec4(position.xyz, 1.0) + vec4(XYZ, 0.0);\n  gl_Position = projection * view * conePosition;\n  f_id        = id;\n  f_position  = position.xyz;\n}\n"]), s = n3(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec3  clipBounds[2];\nuniform float pickId;\n\nvarying vec3 f_position;\nvarying vec4 f_id;\n\nvoid main() {\n  if (outOfRange(clipBounds[0], clipBounds[1], f_position)) discard;\n\n  gl_FragColor = vec4(pickId, f_id.xyz);\n}"]);
              e4.meshShader = { vertex: i2, fragment: a, attributes: [{ name: "position", type: "vec4" }, { name: "color", type: "vec4" }, { name: "uv", type: "vec2" }, { name: "vector", type: "vec3" }] }, e4.pickShader = { vertex: o, fragment: s, attributes: [{ name: "position", type: "vec4" }, { name: "id", type: "vec4" }, { name: "vector", type: "vec3" }] };
            }, 1950: function(t4) {
              t4.exports = { 0: "NONE", 1: "ONE", 2: "LINE_LOOP", 3: "LINE_STRIP", 4: "TRIANGLES", 5: "TRIANGLE_STRIP", 6: "TRIANGLE_FAN", 256: "DEPTH_BUFFER_BIT", 512: "NEVER", 513: "LESS", 514: "EQUAL", 515: "LEQUAL", 516: "GREATER", 517: "NOTEQUAL", 518: "GEQUAL", 519: "ALWAYS", 768: "SRC_COLOR", 769: "ONE_MINUS_SRC_COLOR", 770: "SRC_ALPHA", 771: "ONE_MINUS_SRC_ALPHA", 772: "DST_ALPHA", 773: "ONE_MINUS_DST_ALPHA", 774: "DST_COLOR", 775: "ONE_MINUS_DST_COLOR", 776: "SRC_ALPHA_SATURATE", 1024: "STENCIL_BUFFER_BIT", 1028: "FRONT", 1029: "BACK", 1032: "FRONT_AND_BACK", 1280: "INVALID_ENUM", 1281: "INVALID_VALUE", 1282: "INVALID_OPERATION", 1285: "OUT_OF_MEMORY", 1286: "INVALID_FRAMEBUFFER_OPERATION", 2304: "CW", 2305: "CCW", 2849: "LINE_WIDTH", 2884: "CULL_FACE", 2885: "CULL_FACE_MODE", 2886: "FRONT_FACE", 2928: "DEPTH_RANGE", 2929: "DEPTH_TEST", 2930: "DEPTH_WRITEMASK", 2931: "DEPTH_CLEAR_VALUE", 2932: "DEPTH_FUNC", 2960: "STENCIL_TEST", 2961: "STENCIL_CLEAR_VALUE", 2962: "STENCIL_FUNC", 2963: "STENCIL_VALUE_MASK", 2964: "STENCIL_FAIL", 2965: "STENCIL_PASS_DEPTH_FAIL", 2966: "STENCIL_PASS_DEPTH_PASS", 2967: "STENCIL_REF", 2968: "STENCIL_WRITEMASK", 2978: "VIEWPORT", 3024: "DITHER", 3042: "BLEND", 3088: "SCISSOR_BOX", 3089: "SCISSOR_TEST", 3106: "COLOR_CLEAR_VALUE", 3107: "COLOR_WRITEMASK", 3317: "UNPACK_ALIGNMENT", 3333: "PACK_ALIGNMENT", 3379: "MAX_TEXTURE_SIZE", 3386: "MAX_VIEWPORT_DIMS", 3408: "SUBPIXEL_BITS", 3410: "RED_BITS", 3411: "GREEN_BITS", 3412: "BLUE_BITS", 3413: "ALPHA_BITS", 3414: "DEPTH_BITS", 3415: "STENCIL_BITS", 3553: "TEXTURE_2D", 4352: "DONT_CARE", 4353: "FASTEST", 4354: "NICEST", 5120: "BYTE", 5121: "UNSIGNED_BYTE", 5122: "SHORT", 5123: "UNSIGNED_SHORT", 5124: "INT", 5125: "UNSIGNED_INT", 5126: "FLOAT", 5386: "INVERT", 5890: "TEXTURE", 6401: "STENCIL_INDEX", 6402: "DEPTH_COMPONENT", 6406: "ALPHA", 6407: "RGB", 6408: "RGBA", 6409: "LUMINANCE", 6410: "LUMINANCE_ALPHA", 7680: "KEEP", 7681: "REPLACE", 7682: "INCR", 7683: "DECR", 7936: "VENDOR", 7937: "RENDERER", 7938: "VERSION", 9728: "NEAREST", 9729: "LINEAR", 9984: "NEAREST_MIPMAP_NEAREST", 9985: "LINEAR_MIPMAP_NEAREST", 9986: "NEAREST_MIPMAP_LINEAR", 9987: "LINEAR_MIPMAP_LINEAR", 10240: "TEXTURE_MAG_FILTER", 10241: "TEXTURE_MIN_FILTER", 10242: "TEXTURE_WRAP_S", 10243: "TEXTURE_WRAP_T", 10497: "REPEAT", 10752: "POLYGON_OFFSET_UNITS", 16384: "COLOR_BUFFER_BIT", 32769: "CONSTANT_COLOR", 32770: "ONE_MINUS_CONSTANT_COLOR", 32771: "CONSTANT_ALPHA", 32772: "ONE_MINUS_CONSTANT_ALPHA", 32773: "BLEND_COLOR", 32774: "FUNC_ADD", 32777: "BLEND_EQUATION_RGB", 32778: "FUNC_SUBTRACT", 32779: "FUNC_REVERSE_SUBTRACT", 32819: "UNSIGNED_SHORT_4_4_4_4", 32820: "UNSIGNED_SHORT_5_5_5_1", 32823: "POLYGON_OFFSET_FILL", 32824: "POLYGON_OFFSET_FACTOR", 32854: "RGBA4", 32855: "RGB5_A1", 32873: "TEXTURE_BINDING_2D", 32926: "SAMPLE_ALPHA_TO_COVERAGE", 32928: "SAMPLE_COVERAGE", 32936: "SAMPLE_BUFFERS", 32937: "SAMPLES", 32938: "SAMPLE_COVERAGE_VALUE", 32939: "SAMPLE_COVERAGE_INVERT", 32968: "BLEND_DST_RGB", 32969: "BLEND_SRC_RGB", 32970: "BLEND_DST_ALPHA", 32971: "BLEND_SRC_ALPHA", 33071: "CLAMP_TO_EDGE", 33170: "GENERATE_MIPMAP_HINT", 33189: "DEPTH_COMPONENT16", 33306: "DEPTH_STENCIL_ATTACHMENT", 33635: "UNSIGNED_SHORT_5_6_5", 33648: "MIRRORED_REPEAT", 33901: "ALIASED_POINT_SIZE_RANGE", 33902: "ALIASED_LINE_WIDTH_RANGE", 33984: "TEXTURE0", 33985: "TEXTURE1", 33986: "TEXTURE2", 33987: "TEXTURE3", 33988: "TEXTURE4", 33989: "TEXTURE5", 33990: "TEXTURE6", 33991: "TEXTURE7", 33992: "TEXTURE8", 33993: "TEXTURE9", 33994: "TEXTURE10", 33995: "TEXTURE11", 33996: "TEXTURE12", 33997: "TEXTURE13", 33998: "TEXTURE14", 33999: "TEXTURE15", 34e3: "TEXTURE16", 34001: "TEXTURE17", 34002: "TEXTURE18", 34003: "TEXTURE19", 34004: "TEXTURE20", 34005: "TEXTURE21", 34006: "TEXTURE22", 34007: "TEXTURE23", 34008: "TEXTURE24", 34009: "TEXTURE25", 34010: "TEXTURE26", 34011: "TEXTURE27", 34012: "TEXTURE28", 34013: "TEXTURE29", 34014: "TEXTURE30", 34015: "TEXTURE31", 34016: "ACTIVE_TEXTURE", 34024: "MAX_RENDERBUFFER_SIZE", 34041: "DEPTH_STENCIL", 34055: "INCR_WRAP", 34056: "DECR_WRAP", 34067: "TEXTURE_CUBE_MAP", 34068: "TEXTURE_BINDING_CUBE_MAP", 34069: "TEXTURE_CUBE_MAP_POSITIVE_X", 34070: "TEXTURE_CUBE_MAP_NEGATIVE_X", 34071: "TEXTURE_CUBE_MAP_POSITIVE_Y", 34072: "TEXTURE_CUBE_MAP_NEGATIVE_Y", 34073: "TEXTURE_CUBE_MAP_POSITIVE_Z", 34074: "TEXTURE_CUBE_MAP_NEGATIVE_Z", 34076: "MAX_CUBE_MAP_TEXTURE_SIZE", 34338: "VERTEX_ATTRIB_ARRAY_ENABLED", 34339: "VERTEX_ATTRIB_ARRAY_SIZE", 34340: "VERTEX_ATTRIB_ARRAY_STRIDE", 34341: "VERTEX_ATTRIB_ARRAY_TYPE", 34342: "CURRENT_VERTEX_ATTRIB", 34373: "VERTEX_ATTRIB_ARRAY_POINTER", 34466: "NUM_COMPRESSED_TEXTURE_FORMATS", 34467: "COMPRESSED_TEXTURE_FORMATS", 34660: "BUFFER_SIZE", 34661: "BUFFER_USAGE", 34816: "STENCIL_BACK_FUNC", 34817: "STENCIL_BACK_FAIL", 34818: "STENCIL_BACK_PASS_DEPTH_FAIL", 34819: "STENCIL_BACK_PASS_DEPTH_PASS", 34877: "BLEND_EQUATION_ALPHA", 34921: "MAX_VERTEX_ATTRIBS", 34922: "VERTEX_ATTRIB_ARRAY_NORMALIZED", 34930: "MAX_TEXTURE_IMAGE_UNITS", 34962: "ARRAY_BUFFER", 34963: "ELEMENT_ARRAY_BUFFER", 34964: "ARRAY_BUFFER_BINDING", 34965: "ELEMENT_ARRAY_BUFFER_BINDING", 34975: "VERTEX_ATTRIB_ARRAY_BUFFER_BINDING", 35040: "STREAM_DRAW", 35044: "STATIC_DRAW", 35048: "DYNAMIC_DRAW", 35632: "FRAGMENT_SHADER", 35633: "VERTEX_SHADER", 35660: "MAX_VERTEX_TEXTURE_IMAGE_UNITS", 35661: "MAX_COMBINED_TEXTURE_IMAGE_UNITS", 35663: "SHADER_TYPE", 35664: "FLOAT_VEC2", 35665: "FLOAT_VEC3", 35666: "FLOAT_VEC4", 35667: "INT_VEC2", 35668: "INT_VEC3", 35669: "INT_VEC4", 35670: "BOOL", 35671: "BOOL_VEC2", 35672: "BOOL_VEC3", 35673: "BOOL_VEC4", 35674: "FLOAT_MAT2", 35675: "FLOAT_MAT3", 35676: "FLOAT_MAT4", 35678: "SAMPLER_2D", 35680: "SAMPLER_CUBE", 35712: "DELETE_STATUS", 35713: "COMPILE_STATUS", 35714: "LINK_STATUS", 35715: "VALIDATE_STATUS", 35716: "INFO_LOG_LENGTH", 35717: "ATTACHED_SHADERS", 35718: "ACTIVE_UNIFORMS", 35719: "ACTIVE_UNIFORM_MAX_LENGTH", 35720: "SHADER_SOURCE_LENGTH", 35721: "ACTIVE_ATTRIBUTES", 35722: "ACTIVE_ATTRIBUTE_MAX_LENGTH", 35724: "SHADING_LANGUAGE_VERSION", 35725: "CURRENT_PROGRAM", 36003: "STENCIL_BACK_REF", 36004: "STENCIL_BACK_VALUE_MASK", 36005: "STENCIL_BACK_WRITEMASK", 36006: "FRAMEBUFFER_BINDING", 36007: "RENDERBUFFER_BINDING", 36048: "FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE", 36049: "FRAMEBUFFER_ATTACHMENT_OBJECT_NAME", 36050: "FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL", 36051: "FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE", 36053: "FRAMEBUFFER_COMPLETE", 36054: "FRAMEBUFFER_INCOMPLETE_ATTACHMENT", 36055: "FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT", 36057: "FRAMEBUFFER_INCOMPLETE_DIMENSIONS", 36061: "FRAMEBUFFER_UNSUPPORTED", 36064: "COLOR_ATTACHMENT0", 36096: "DEPTH_ATTACHMENT", 36128: "STENCIL_ATTACHMENT", 36160: "FRAMEBUFFER", 36161: "RENDERBUFFER", 36162: "RENDERBUFFER_WIDTH", 36163: "RENDERBUFFER_HEIGHT", 36164: "RENDERBUFFER_INTERNAL_FORMAT", 36168: "STENCIL_INDEX8", 36176: "RENDERBUFFER_RED_SIZE", 36177: "RENDERBUFFER_GREEN_SIZE", 36178: "RENDERBUFFER_BLUE_SIZE", 36179: "RENDERBUFFER_ALPHA_SIZE", 36180: "RENDERBUFFER_DEPTH_SIZE", 36181: "RENDERBUFFER_STENCIL_SIZE", 36194: "RGB565", 36336: "LOW_FLOAT", 36337: "MEDIUM_FLOAT", 36338: "HIGH_FLOAT", 36339: "LOW_INT", 36340: "MEDIUM_INT", 36341: "HIGH_INT", 36346: "SHADER_COMPILER", 36347: "MAX_VERTEX_UNIFORM_VECTORS", 36348: "MAX_VARYING_VECTORS", 36349: "MAX_FRAGMENT_UNIFORM_VECTORS", 37440: "UNPACK_FLIP_Y_WEBGL", 37441: "UNPACK_PREMULTIPLY_ALPHA_WEBGL", 37442: "CONTEXT_LOST_WEBGL", 37443: "UNPACK_COLORSPACE_CONVERSION_WEBGL", 37444: "BROWSER_DEFAULT_WEBGL" };
            }, 6603: function(t4, e4, r4) {
              var n3 = r4(1950);
              t4.exports = function(t5) {
                return n3[t5];
              };
            }, 3110: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = t5.gl, r5 = n3(e5), o2 = i2(e5, [{ buffer: r5, type: e5.FLOAT, size: 3, offset: 0, stride: 40 }, { buffer: r5, type: e5.FLOAT, size: 4, offset: 12, stride: 40 }, { buffer: r5, type: e5.FLOAT, size: 3, offset: 28, stride: 40 }]), l2 = a(e5);
                l2.attributes.position.location = 0, l2.attributes.color.location = 1, l2.attributes.offset.location = 2;
                var u2 = new s(e5, r5, o2, l2);
                return u2.update(t5), u2;
              };
              var n3 = r4(5827), i2 = r4(2944), a = r4(7667), o = [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1];
              function s(t5, e5, r5, n4) {
                this.gl = t5, this.shader = n4, this.buffer = e5, this.vao = r5, this.pixelRatio = 1, this.bounds = [[1 / 0, 1 / 0, 1 / 0], [-1 / 0, -1 / 0, -1 / 0]], this.clipBounds = [[-1 / 0, -1 / 0, -1 / 0], [1 / 0, 1 / 0, 1 / 0]], this.lineWidth = [1, 1, 1], this.capSize = [10, 10, 10], this.lineCount = [0, 0, 0], this.lineOffset = [0, 0, 0], this.opacity = 1, this.hasAlpha = false;
              }
              var l = s.prototype;
              function u(t5, e5) {
                for (var r5 = 0; r5 < 3; ++r5)
                  t5[0][r5] = Math.min(t5[0][r5], e5[r5]), t5[1][r5] = Math.max(t5[1][r5], e5[r5]);
              }
              l.isOpaque = function() {
                return !this.hasAlpha;
              }, l.isTransparent = function() {
                return this.hasAlpha;
              }, l.drawTransparent = l.draw = function(t5) {
                var e5 = this.gl, r5 = this.shader.uniforms;
                this.shader.bind();
                var n4 = r5.view = t5.view || o, i3 = r5.projection = t5.projection || o;
                r5.model = t5.model || o, r5.clipBounds = this.clipBounds, r5.opacity = this.opacity;
                var a2 = n4[12], s2 = n4[13], l2 = n4[14], u2 = n4[15], c2 = (t5._ortho ? 2 : 1) * this.pixelRatio * (i3[3] * a2 + i3[7] * s2 + i3[11] * l2 + i3[15] * u2) / e5.drawingBufferHeight;
                this.vao.bind();
                for (var f3 = 0; f3 < 3; ++f3)
                  e5.lineWidth(this.lineWidth[f3] * this.pixelRatio), r5.capSize = this.capSize[f3] * c2, this.lineCount[f3] && e5.drawArrays(e5.LINES, this.lineOffset[f3], this.lineCount[f3]);
                this.vao.unbind();
              };
              var c = function() {
                for (var t5 = new Array(3), e5 = 0; e5 < 3; ++e5) {
                  for (var r5 = [], n4 = 1; n4 <= 2; ++n4)
                    for (var i3 = -1; i3 <= 1; i3 += 2) {
                      var a2 = [0, 0, 0];
                      a2[(n4 + e5) % 3] = i3, r5.push(a2);
                    }
                  t5[e5] = r5;
                }
                return t5;
              }();
              function f2(t5, e5, r5, n4) {
                for (var i3 = c[n4], a2 = 0; a2 < i3.length; ++a2) {
                  var o2 = i3[a2];
                  t5.push(e5[0], e5[1], e5[2], r5[0], r5[1], r5[2], r5[3], o2[0], o2[1], o2[2]);
                }
                return i3.length;
              }
              l.update = function(t5) {
                "lineWidth" in (t5 = t5 || {}) && (this.lineWidth = t5.lineWidth, Array.isArray(this.lineWidth) || (this.lineWidth = [this.lineWidth, this.lineWidth, this.lineWidth])), "capSize" in t5 && (this.capSize = t5.capSize, Array.isArray(this.capSize) || (this.capSize = [this.capSize, this.capSize, this.capSize])), this.hasAlpha = false, "opacity" in t5 && (this.opacity = +t5.opacity, this.opacity < 1 && (this.hasAlpha = true));
                var e5 = t5.color || [[0, 0, 0], [0, 0, 0], [0, 0, 0]], r5 = t5.position, n4 = t5.error;
                if (Array.isArray(e5[0]) || (e5 = [e5, e5, e5]), r5 && n4) {
                  var i3 = [], a2 = r5.length, o2 = 0;
                  this.bounds = [[1 / 0, 1 / 0, 1 / 0], [-1 / 0, -1 / 0, -1 / 0]], this.lineCount = [0, 0, 0];
                  for (var s2 = 0; s2 < 3; ++s2) {
                    this.lineOffset[s2] = o2;
                    t:
                      for (var l2 = 0; l2 < a2; ++l2) {
                        for (var c2 = r5[l2], h = 0; h < 3; ++h)
                          if (isNaN(c2[h]) || !isFinite(c2[h]))
                            continue t;
                        var p2, d2 = n4[l2], v = e5[s2];
                        Array.isArray(v[0]) && (v = e5[l2]), 3 === v.length ? v = [v[0], v[1], v[2], 1] : 4 === v.length && (v = [v[0], v[1], v[2], v[3]], !this.hasAlpha && v[3] < 1 && (this.hasAlpha = true)), isNaN(d2[0][s2]) || isNaN(d2[1][s2]) || (d2[0][s2] < 0 && ((p2 = c2.slice())[s2] += d2[0][s2], i3.push(c2[0], c2[1], c2[2], v[0], v[1], v[2], v[3], 0, 0, 0, p2[0], p2[1], p2[2], v[0], v[1], v[2], v[3], 0, 0, 0), u(this.bounds, p2), o2 += 2 + f2(i3, p2, v, s2)), d2[1][s2] > 0 && ((p2 = c2.slice())[s2] += d2[1][s2], i3.push(c2[0], c2[1], c2[2], v[0], v[1], v[2], v[3], 0, 0, 0, p2[0], p2[1], p2[2], v[0], v[1], v[2], v[3], 0, 0, 0), u(this.bounds, p2), o2 += 2 + f2(i3, p2, v, s2)));
                      }
                    this.lineCount[s2] = o2 - this.lineOffset[s2];
                  }
                  this.buffer.update(i3);
                }
              }, l.dispose = function() {
                this.shader.dispose(), this.buffer.dispose(), this.vao.dispose();
              };
            }, 7667: function(t4, e4, r4) {
              var n3 = r4(6832), i2 = r4(5158), a = n3(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec3 position, offset;\nattribute vec4 color;\nuniform mat4 model, view, projection;\nuniform float capSize;\nvarying vec4 fragColor;\nvarying vec3 fragPosition;\n\nvoid main() {\n  vec4 worldPosition  = model * vec4(position, 1.0);\n  worldPosition       = (worldPosition / worldPosition.w) + vec4(capSize * offset, 0.0);\n  gl_Position         = projection * view * worldPosition;\n  fragColor           = color;\n  fragPosition        = position;\n}"]), o = n3(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec3 clipBounds[2];\nuniform float opacity;\nvarying vec3 fragPosition;\nvarying vec4 fragColor;\n\nvoid main() {\n  if (\n    outOfRange(clipBounds[0], clipBounds[1], fragPosition) ||\n    fragColor.a * opacity == 0.\n  ) discard;\n\n  gl_FragColor = opacity * fragColor;\n}"]);
              t4.exports = function(t5) {
                return i2(t5, a, o, null, [{ name: "position", type: "vec3" }, { name: "color", type: "vec4" }, { name: "offset", type: "vec3" }]);
              };
            }, 4234: function(t4, e4, r4) {
              var n3 = r4(8931);
              t4.exports = function(t5, e5, r5, n4) {
                i2 || (i2 = t5.FRAMEBUFFER_UNSUPPORTED, a = t5.FRAMEBUFFER_INCOMPLETE_ATTACHMENT, o = t5.FRAMEBUFFER_INCOMPLETE_DIMENSIONS, s = t5.FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT);
                var u2 = t5.getExtension("WEBGL_draw_buffers");
                if (!l && u2 && function(t6, e6) {
                  var r6 = t6.getParameter(e6.MAX_COLOR_ATTACHMENTS_WEBGL);
                  l = new Array(r6 + 1);
                  for (var n5 = 0; n5 <= r6; ++n5) {
                    for (var i3 = new Array(r6), a2 = 0; a2 < n5; ++a2)
                      i3[a2] = t6.COLOR_ATTACHMENT0 + a2;
                    for (a2 = n5; a2 < r6; ++a2)
                      i3[a2] = t6.NONE;
                    l[n5] = i3;
                  }
                }(t5, u2), Array.isArray(e5) && (n4 = r5, r5 = 0 | e5[1], e5 = 0 | e5[0]), "number" != typeof e5)
                  throw new Error("gl-fbo: Missing shape parameter");
                var c2 = t5.getParameter(t5.MAX_RENDERBUFFER_SIZE);
                if (e5 < 0 || e5 > c2 || r5 < 0 || r5 > c2)
                  throw new Error("gl-fbo: Parameters are too large for FBO");
                var f3 = 1;
                if ("color" in (n4 = n4 || {})) {
                  if ((f3 = Math.max(0 | n4.color, 0)) < 0)
                    throw new Error("gl-fbo: Must specify a nonnegative number of colors");
                  if (f3 > 1) {
                    if (!u2)
                      throw new Error("gl-fbo: Multiple draw buffer extension not supported");
                    if (f3 > t5.getParameter(u2.MAX_COLOR_ATTACHMENTS_WEBGL))
                      throw new Error("gl-fbo: Context does not support " + f3 + " draw buffers");
                  }
                }
                var h2 = t5.UNSIGNED_BYTE, p3 = t5.getExtension("OES_texture_float");
                if (n4.float && f3 > 0) {
                  if (!p3)
                    throw new Error("gl-fbo: Context does not support floating point textures");
                  h2 = t5.FLOAT;
                } else
                  n4.preferFloat && f3 > 0 && p3 && (h2 = t5.FLOAT);
                var v2 = true;
                "depth" in n4 && (v2 = !!n4.depth);
                var g3 = false;
                return "stencil" in n4 && (g3 = !!n4.stencil), new d2(t5, e5, r5, h2, f3, v2, g3, u2);
              };
              var i2, a, o, s, l = null;
              function u(t5) {
                return [t5.getParameter(t5.FRAMEBUFFER_BINDING), t5.getParameter(t5.RENDERBUFFER_BINDING), t5.getParameter(t5.TEXTURE_BINDING_2D)];
              }
              function c(t5, e5) {
                t5.bindFramebuffer(t5.FRAMEBUFFER, e5[0]), t5.bindRenderbuffer(t5.RENDERBUFFER, e5[1]), t5.bindTexture(t5.TEXTURE_2D, e5[2]);
              }
              function f2(t5) {
                switch (t5) {
                  case i2:
                    throw new Error("gl-fbo: Framebuffer unsupported");
                  case a:
                    throw new Error("gl-fbo: Framebuffer incomplete attachment");
                  case o:
                    throw new Error("gl-fbo: Framebuffer incomplete dimensions");
                  case s:
                    throw new Error("gl-fbo: Framebuffer incomplete missing attachment");
                  default:
                    throw new Error("gl-fbo: Framebuffer failed for unspecified reason");
                }
              }
              function h(t5, e5, r5, i3, a2, o2) {
                if (!i3)
                  return null;
                var s2 = n3(t5, e5, r5, a2, i3);
                return s2.magFilter = t5.NEAREST, s2.minFilter = t5.NEAREST, s2.mipSamples = 1, s2.bind(), t5.framebufferTexture2D(t5.FRAMEBUFFER, o2, t5.TEXTURE_2D, s2.handle, 0), s2;
              }
              function p2(t5, e5, r5, n4, i3) {
                var a2 = t5.createRenderbuffer();
                return t5.bindRenderbuffer(t5.RENDERBUFFER, a2), t5.renderbufferStorage(t5.RENDERBUFFER, n4, e5, r5), t5.framebufferRenderbuffer(t5.FRAMEBUFFER, i3, t5.RENDERBUFFER, a2), a2;
              }
              function d2(t5, e5, r5, n4, i3, a2, o2, s2) {
                this.gl = t5, this._shape = [0 | e5, 0 | r5], this._destroyed = false, this._ext = s2, this.color = new Array(i3);
                for (var d3 = 0; d3 < i3; ++d3)
                  this.color[d3] = null;
                this._color_rb = null, this.depth = null, this._depth_rb = null, this._colorType = n4, this._useDepth = a2, this._useStencil = o2;
                var v2 = this, g3 = [0 | e5, 0 | r5];
                Object.defineProperties(g3, { 0: { get: function() {
                  return v2._shape[0];
                }, set: function(t6) {
                  return v2.width = t6;
                } }, 1: { get: function() {
                  return v2._shape[1];
                }, set: function(t6) {
                  return v2.height = t6;
                } } }), this._shapeVector = g3, function(t6) {
                  var e6 = u(t6.gl), r6 = t6.gl, n5 = t6.handle = r6.createFramebuffer(), i4 = t6._shape[0], a3 = t6._shape[1], o3 = t6.color.length, s3 = t6._ext, d4 = t6._useStencil, v3 = t6._useDepth, g4 = t6._colorType;
                  r6.bindFramebuffer(r6.FRAMEBUFFER, n5);
                  for (var y = 0; y < o3; ++y)
                    t6.color[y] = h(r6, i4, a3, g4, r6.RGBA, r6.COLOR_ATTACHMENT0 + y);
                  0 === o3 ? (t6._color_rb = p2(r6, i4, a3, r6.RGBA4, r6.COLOR_ATTACHMENT0), s3 && s3.drawBuffersWEBGL(l[0])) : o3 > 1 && s3.drawBuffersWEBGL(l[o3]);
                  var m2 = r6.getExtension("WEBGL_depth_texture");
                  m2 ? d4 ? t6.depth = h(r6, i4, a3, m2.UNSIGNED_INT_24_8_WEBGL, r6.DEPTH_STENCIL, r6.DEPTH_STENCIL_ATTACHMENT) : v3 && (t6.depth = h(r6, i4, a3, r6.UNSIGNED_SHORT, r6.DEPTH_COMPONENT, r6.DEPTH_ATTACHMENT)) : v3 && d4 ? t6._depth_rb = p2(r6, i4, a3, r6.DEPTH_STENCIL, r6.DEPTH_STENCIL_ATTACHMENT) : v3 ? t6._depth_rb = p2(r6, i4, a3, r6.DEPTH_COMPONENT16, r6.DEPTH_ATTACHMENT) : d4 && (t6._depth_rb = p2(r6, i4, a3, r6.STENCIL_INDEX, r6.STENCIL_ATTACHMENT));
                  var x = r6.checkFramebufferStatus(r6.FRAMEBUFFER);
                  if (x !== r6.FRAMEBUFFER_COMPLETE) {
                    for (t6._destroyed = true, r6.bindFramebuffer(r6.FRAMEBUFFER, null), r6.deleteFramebuffer(t6.handle), t6.handle = null, t6.depth && (t6.depth.dispose(), t6.depth = null), t6._depth_rb && (r6.deleteRenderbuffer(t6._depth_rb), t6._depth_rb = null), y = 0; y < t6.color.length; ++y)
                      t6.color[y].dispose(), t6.color[y] = null;
                    t6._color_rb && (r6.deleteRenderbuffer(t6._color_rb), t6._color_rb = null), c(r6, e6), f2(x);
                  }
                  c(r6, e6);
                }(this);
              }
              var v = d2.prototype;
              function g2(t5, e5, r5) {
                if (t5._destroyed)
                  throw new Error("gl-fbo: Can't resize destroyed FBO");
                if (t5._shape[0] !== e5 || t5._shape[1] !== r5) {
                  var n4 = t5.gl, i3 = n4.getParameter(n4.MAX_RENDERBUFFER_SIZE);
                  if (e5 < 0 || e5 > i3 || r5 < 0 || r5 > i3)
                    throw new Error("gl-fbo: Can't resize FBO, invalid dimensions");
                  t5._shape[0] = e5, t5._shape[1] = r5;
                  for (var a2 = u(n4), o2 = 0; o2 < t5.color.length; ++o2)
                    t5.color[o2].shape = t5._shape;
                  t5._color_rb && (n4.bindRenderbuffer(n4.RENDERBUFFER, t5._color_rb), n4.renderbufferStorage(n4.RENDERBUFFER, n4.RGBA4, t5._shape[0], t5._shape[1])), t5.depth && (t5.depth.shape = t5._shape), t5._depth_rb && (n4.bindRenderbuffer(n4.RENDERBUFFER, t5._depth_rb), t5._useDepth && t5._useStencil ? n4.renderbufferStorage(n4.RENDERBUFFER, n4.DEPTH_STENCIL, t5._shape[0], t5._shape[1]) : t5._useDepth ? n4.renderbufferStorage(n4.RENDERBUFFER, n4.DEPTH_COMPONENT16, t5._shape[0], t5._shape[1]) : t5._useStencil && n4.renderbufferStorage(n4.RENDERBUFFER, n4.STENCIL_INDEX, t5._shape[0], t5._shape[1])), n4.bindFramebuffer(n4.FRAMEBUFFER, t5.handle);
                  var s2 = n4.checkFramebufferStatus(n4.FRAMEBUFFER);
                  s2 !== n4.FRAMEBUFFER_COMPLETE && (t5.dispose(), c(n4, a2), f2(s2)), c(n4, a2);
                }
              }
              Object.defineProperties(v, { shape: { get: function() {
                return this._destroyed ? [0, 0] : this._shapeVector;
              }, set: function(t5) {
                if (Array.isArray(t5) || (t5 = [0 | t5, 0 | t5]), 2 !== t5.length)
                  throw new Error("gl-fbo: Shape vector must be length 2");
                var e5 = 0 | t5[0], r5 = 0 | t5[1];
                return g2(this, e5, r5), [e5, r5];
              }, enumerable: false }, width: { get: function() {
                return this._destroyed ? 0 : this._shape[0];
              }, set: function(t5) {
                return g2(this, t5 |= 0, this._shape[1]), t5;
              }, enumerable: false }, height: { get: function() {
                return this._destroyed ? 0 : this._shape[1];
              }, set: function(t5) {
                return t5 |= 0, g2(this, this._shape[0], t5), t5;
              }, enumerable: false } }), v.bind = function() {
                if (!this._destroyed) {
                  var t5 = this.gl;
                  t5.bindFramebuffer(t5.FRAMEBUFFER, this.handle), t5.viewport(0, 0, this._shape[0], this._shape[1]);
                }
              }, v.dispose = function() {
                if (!this._destroyed) {
                  this._destroyed = true;
                  var t5 = this.gl;
                  t5.deleteFramebuffer(this.handle), this.handle = null, this.depth && (this.depth.dispose(), this.depth = null), this._depth_rb && (t5.deleteRenderbuffer(this._depth_rb), this._depth_rb = null);
                  for (var e5 = 0; e5 < this.color.length; ++e5)
                    this.color[e5].dispose(), this.color[e5] = null;
                  this._color_rb && (t5.deleteRenderbuffer(this._color_rb), this._color_rb = null);
                }
              };
            }, 3530: function(t4, e4, r4) {
              var n3 = r4(8974).sprintf, i2 = r4(6603), a = r4(9365), o = r4(8008);
              t4.exports = function(t5, e5, r5) {
                var s = a(e5) || "of unknown name (see npm glsl-shader-name)", l = "unknown type";
                void 0 !== r5 && (l = r5 === i2.FRAGMENT_SHADER ? "fragment" : "vertex");
                for (var u = n3("Error compiling %s shader %s:\n", l, s), c = n3("%s%s", u, t5), f2 = t5.split("\n"), h = {}, p2 = 0; p2 < f2.length; p2++) {
                  var d2 = f2[p2];
                  if ("" !== d2 && "\0" !== d2) {
                    var v = parseInt(d2.split(":")[2]);
                    if (isNaN(v))
                      throw new Error(n3("Could not parse error: %s", d2));
                    h[v] = d2;
                  }
                }
                var g2 = o(e5).split("\n");
                for (p2 = 0; p2 < g2.length; p2++)
                  if (h[p2 + 3] || h[p2 + 2] || h[p2 + 1]) {
                    if (u += g2[p2] + "\n", h[p2 + 1]) {
                      var y = h[p2 + 1];
                      y = y.substr(y.split(":", 3).join(":").length + 1).trim(), u += n3("^^^ %s\n\n", y);
                    }
                  }
                return { long: u.trim(), short: c.trim() };
              };
            }, 6386: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                var r5 = t5.gl, n4 = new u(t5, o(r5, l.vertex, l.fragment), o(r5, l.pickVertex, l.pickFragment), s(r5), s(r5), s(r5), s(r5));
                return n4.update(e5), t5.addObject(n4), n4;
              };
              var n3 = r4(5070), i2 = r4(9560), a = r4(5306), o = r4(5158), s = r4(5827), l = r4(1292);
              function u(t5, e5, r5, n4, i3, a2, o2) {
                this.plot = t5, this.shader = e5, this.pickShader = r5, this.positionBuffer = n4, this.weightBuffer = i3, this.colorBuffer = a2, this.idBuffer = o2, this.xData = [], this.yData = [], this.shape = [0, 0], this.bounds = [1 / 0, 1 / 0, -1 / 0, -1 / 0], this.pickOffset = 0;
              }
              var c, f2 = u.prototype, h = [0, 0, 1, 0, 0, 1, 1, 0, 1, 1, 0, 1];
              f2.draw = (c = [1, 0, 0, 0, 1, 0, 0, 0, 1], function() {
                var t5 = this.plot, e5 = this.shader, r5 = this.bounds, n4 = this.numVertices;
                if (!(n4 <= 0)) {
                  var i3 = t5.gl, a2 = t5.dataBox, o2 = r5[2] - r5[0], s2 = r5[3] - r5[1], l2 = a2[2] - a2[0], u2 = a2[3] - a2[1];
                  c[0] = 2 * o2 / l2, c[4] = 2 * s2 / u2, c[6] = 2 * (r5[0] - a2[0]) / l2 - 1, c[7] = 2 * (r5[1] - a2[1]) / u2 - 1, e5.bind();
                  var f3 = e5.uniforms;
                  f3.viewTransform = c, f3.shape = this.shape;
                  var h2 = e5.attributes;
                  this.positionBuffer.bind(), h2.position.pointer(), this.weightBuffer.bind(), h2.weight.pointer(i3.UNSIGNED_BYTE, false), this.colorBuffer.bind(), h2.color.pointer(i3.UNSIGNED_BYTE, true), i3.drawArrays(i3.TRIANGLES, 0, n4);
                }
              }), f2.drawPick = function() {
                var t5 = [1, 0, 0, 0, 1, 0, 0, 0, 1], e5 = [0, 0, 0, 0];
                return function(r5) {
                  var n4 = this.plot, i3 = this.pickShader, a2 = this.bounds, o2 = this.numVertices;
                  if (!(o2 <= 0)) {
                    var s2 = n4.gl, l2 = n4.dataBox, u2 = a2[2] - a2[0], c2 = a2[3] - a2[1], f3 = l2[2] - l2[0], h2 = l2[3] - l2[1];
                    t5[0] = 2 * u2 / f3, t5[4] = 2 * c2 / h2, t5[6] = 2 * (a2[0] - l2[0]) / f3 - 1, t5[7] = 2 * (a2[1] - l2[1]) / h2 - 1;
                    for (var p2 = 0; p2 < 4; ++p2)
                      e5[p2] = r5 >> 8 * p2 & 255;
                    this.pickOffset = r5, i3.bind();
                    var d2 = i3.uniforms;
                    d2.viewTransform = t5, d2.pickOffset = e5, d2.shape = this.shape;
                    var v = i3.attributes;
                    return this.positionBuffer.bind(), v.position.pointer(), this.weightBuffer.bind(), v.weight.pointer(s2.UNSIGNED_BYTE, false), this.idBuffer.bind(), v.pickId.pointer(s2.UNSIGNED_BYTE, false), s2.drawArrays(s2.TRIANGLES, 0, o2), r5 + this.shape[0] * this.shape[1];
                  }
                };
              }(), f2.pick = function(t5, e5, r5) {
                var n4 = this.pickOffset, i3 = this.shape[0] * this.shape[1];
                if (r5 < n4 || r5 >= n4 + i3)
                  return null;
                var a2 = r5 - n4, o2 = this.xData, s2 = this.yData;
                return { object: this, pointId: a2, dataCoord: [o2[a2 % this.shape[0]], s2[a2 / this.shape[0] | 0]] };
              }, f2.update = function(t5) {
                var e5 = (t5 = t5 || {}).shape || [0, 0], r5 = t5.x || i2(e5[0]), o2 = t5.y || i2(e5[1]), s2 = t5.z || new Float32Array(e5[0] * e5[1]), l2 = false !== t5.zsmooth;
                this.xData = r5, this.yData = o2;
                var u2, c2, f3, p2, d2 = t5.colorLevels || [0], v = t5.colorValues || [0, 0, 0, 1], g2 = d2.length, y = this.bounds;
                l2 ? (u2 = y[0] = r5[0], c2 = y[1] = o2[0], f3 = y[2] = r5[r5.length - 1], p2 = y[3] = o2[o2.length - 1]) : (u2 = y[0] = r5[0] + (r5[1] - r5[0]) / 2, c2 = y[1] = o2[0] + (o2[1] - o2[0]) / 2, f3 = y[2] = r5[r5.length - 1] + (r5[r5.length - 1] - r5[r5.length - 2]) / 2, p2 = y[3] = o2[o2.length - 1] + (o2[o2.length - 1] - o2[o2.length - 2]) / 2);
                var m2 = 1 / (f3 - u2), x = 1 / (p2 - c2), b = e5[0], _ = e5[1];
                this.shape = [b, _];
                var w2 = (l2 ? (b - 1) * (_ - 1) : b * _) * (h.length >>> 1);
                this.numVertices = w2;
                for (var T = a.mallocUint8(4 * w2), k = a.mallocFloat32(2 * w2), A = a.mallocUint8(2 * w2), M = a.mallocUint32(w2), S = 0, E = l2 ? b - 1 : b, L = l2 ? _ - 1 : _, C = 0; C < L; ++C) {
                  var P, O;
                  l2 ? (P = x * (o2[C] - c2), O = x * (o2[C + 1] - c2)) : (P = C < _ - 1 ? x * (o2[C] - (o2[C + 1] - o2[C]) / 2 - c2) : x * (o2[C] - (o2[C] - o2[C - 1]) / 2 - c2), O = C < _ - 1 ? x * (o2[C] + (o2[C + 1] - o2[C]) / 2 - c2) : x * (o2[C] + (o2[C] - o2[C - 1]) / 2 - c2));
                  for (var I = 0; I < E; ++I) {
                    var D, z;
                    l2 ? (D = m2 * (r5[I] - u2), z = m2 * (r5[I + 1] - u2)) : (D = I < b - 1 ? m2 * (r5[I] - (r5[I + 1] - r5[I]) / 2 - u2) : m2 * (r5[I] - (r5[I] - r5[I - 1]) / 2 - u2), z = I < b - 1 ? m2 * (r5[I] + (r5[I + 1] - r5[I]) / 2 - u2) : m2 * (r5[I] + (r5[I] - r5[I - 1]) / 2 - u2));
                    for (var R = 0; R < h.length; R += 2) {
                      var F, B, N, j, U = h[R], V = h[R + 1], H = s2[l2 ? (C + V) * b + (I + U) : C * b + I], q2 = n3.le(d2, H);
                      if (q2 < 0)
                        F = v[0], B = v[1], N = v[2], j = v[3];
                      else if (q2 === g2 - 1)
                        F = v[4 * g2 - 4], B = v[4 * g2 - 3], N = v[4 * g2 - 2], j = v[4 * g2 - 1];
                      else {
                        var G = (H - d2[q2]) / (d2[q2 + 1] - d2[q2]), Z = 1 - G, Y = 4 * q2, W = 4 * (q2 + 1);
                        F = Z * v[Y] + G * v[W], B = Z * v[Y + 1] + G * v[W + 1], N = Z * v[Y + 2] + G * v[W + 2], j = Z * v[Y + 3] + G * v[W + 3];
                      }
                      T[4 * S] = 255 * F, T[4 * S + 1] = 255 * B, T[4 * S + 2] = 255 * N, T[4 * S + 3] = 255 * j, k[2 * S] = 0.5 * D + 0.5 * z, k[2 * S + 1] = 0.5 * P + 0.5 * O, A[2 * S] = U, A[2 * S + 1] = V, M[S] = C * b + I, S += 1;
                    }
                  }
                }
                this.positionBuffer.update(k), this.weightBuffer.update(A), this.colorBuffer.update(T), this.idBuffer.update(M), a.free(k), a.free(T), a.free(A), a.free(M);
              }, f2.dispose = function() {
                this.shader.dispose(), this.pickShader.dispose(), this.positionBuffer.dispose(), this.weightBuffer.dispose(), this.colorBuffer.dispose(), this.idBuffer.dispose(), this.plot.removeObject(this);
              };
            }, 1292: function(t4, e4, r4) {
              var n3 = r4(6832);
              t4.exports = { fragment: n3(["precision lowp float;\n#define GLSLIFY 1\nvarying vec4 fragColor;\nvoid main() {\n  gl_FragColor = vec4(fragColor.rgb * fragColor.a, fragColor.a);\n}\n"]), vertex: n3(["precision mediump float;\n#define GLSLIFY 1\n\nattribute vec2 position;\nattribute vec4 color;\nattribute vec2 weight;\n\nuniform vec2 shape;\nuniform mat3 viewTransform;\n\nvarying vec4 fragColor;\n\nvoid main() {\n  vec3 vPosition = viewTransform * vec3( position + (weight-.5)/(shape-1.) , 1.0);\n  fragColor = color;\n  gl_Position = vec4(vPosition.xy, 0, vPosition.z);\n}\n"]), pickFragment: n3(["precision mediump float;\n#define GLSLIFY 1\n\nvarying vec4 fragId;\nvarying vec2 vWeight;\n\nuniform vec2 shape;\nuniform vec4 pickOffset;\n\nvoid main() {\n  vec2 d = step(.5, vWeight);\n  vec4 id = fragId + pickOffset;\n  id.x += d.x + d.y*shape.x;\n\n  id.y += floor(id.x / 256.0);\n  id.x -= floor(id.x / 256.0) * 256.0;\n\n  id.z += floor(id.y / 256.0);\n  id.y -= floor(id.y / 256.0) * 256.0;\n\n  id.w += floor(id.z / 256.0);\n  id.z -= floor(id.z / 256.0) * 256.0;\n\n  gl_FragColor = id/255.;\n}\n"]), pickVertex: n3(["precision mediump float;\n#define GLSLIFY 1\n\nattribute vec2 position;\nattribute vec4 pickId;\nattribute vec2 weight;\n\nuniform vec2 shape;\nuniform mat3 viewTransform;\n\nvarying vec4 fragId;\nvarying vec2 vWeight;\n\nvoid main() {\n  vWeight = weight;\n\n  fragId = pickId;\n\n  vec3 vPosition = viewTransform * vec3( position + (weight-.5)/(shape-1.) , 1.0);\n  gl_Position = vec4(vPosition.xy, 0, vPosition.z);\n}\n"]) };
            }, 248: function(t4, e4, r4) {
              var n3 = r4(6832), i2 = r4(5158), a = n3(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec3 position, nextPosition;\nattribute float arcLength, lineWidth;\nattribute vec4 color;\n\nuniform vec2 screenShape;\nuniform float pixelRatio;\nuniform mat4 model, view, projection;\n\nvarying vec4 fragColor;\nvarying vec3 worldPosition;\nvarying float pixelArcLength;\n\nvec4 project(vec3 p) {\n  return projection * view * model * vec4(p, 1.0);\n}\n\nvoid main() {\n  vec4 startPoint = project(position);\n  vec4 endPoint   = project(nextPosition);\n\n  vec2 A = startPoint.xy / startPoint.w;\n  vec2 B =   endPoint.xy /   endPoint.w;\n\n  float clipAngle = atan(\n    (B.y - A.y) * screenShape.y,\n    (B.x - A.x) * screenShape.x\n  );\n\n  vec2 offset = 0.5 * pixelRatio * lineWidth * vec2(\n    sin(clipAngle),\n    -cos(clipAngle)\n  ) / screenShape;\n\n  gl_Position = vec4(startPoint.xy + startPoint.w * offset, startPoint.zw);\n\n  worldPosition = position;\n  pixelArcLength = arcLength;\n  fragColor = color;\n}\n"]), o = n3(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec3      clipBounds[2];\nuniform sampler2D dashTexture;\nuniform float     dashScale;\nuniform float     opacity;\n\nvarying vec3    worldPosition;\nvarying float   pixelArcLength;\nvarying vec4    fragColor;\n\nvoid main() {\n  if (\n    outOfRange(clipBounds[0], clipBounds[1], worldPosition) ||\n    fragColor.a * opacity == 0.\n  ) discard;\n\n  float dashWeight = texture2D(dashTexture, vec2(dashScale * pixelArcLength, 0)).r;\n  if(dashWeight < 0.5) {\n    discard;\n  }\n  gl_FragColor = fragColor * opacity;\n}\n"]), s = n3(["precision highp float;\n#define GLSLIFY 1\n\n#define FLOAT_MAX  1.70141184e38\n#define FLOAT_MIN  1.17549435e-38\n\n// https://github.com/mikolalysenko/glsl-read-float/blob/master/index.glsl\nvec4 packFloat(float v) {\n  float av = abs(v);\n\n  //Handle special cases\n  if(av < FLOAT_MIN) {\n    return vec4(0.0, 0.0, 0.0, 0.0);\n  } else if(v > FLOAT_MAX) {\n    return vec4(127.0, 128.0, 0.0, 0.0) / 255.0;\n  } else if(v < -FLOAT_MAX) {\n    return vec4(255.0, 128.0, 0.0, 0.0) / 255.0;\n  }\n\n  vec4 c = vec4(0,0,0,0);\n\n  //Compute exponent and mantissa\n  float e = floor(log2(av));\n  float m = av * pow(2.0, -e) - 1.0;\n\n  //Unpack mantissa\n  c[1] = floor(128.0 * m);\n  m -= c[1] / 128.0;\n  c[2] = floor(32768.0 * m);\n  m -= c[2] / 32768.0;\n  c[3] = floor(8388608.0 * m);\n\n  //Unpack exponent\n  float ebias = e + 127.0;\n  c[0] = floor(ebias / 2.0);\n  ebias -= c[0] * 2.0;\n  c[1] += floor(ebias) * 128.0;\n\n  //Unpack sign bit\n  c[0] += 128.0 * step(0.0, -v);\n\n  //Scale back to range\n  return c / 255.0;\n}\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform float pickId;\nuniform vec3 clipBounds[2];\n\nvarying vec3 worldPosition;\nvarying float pixelArcLength;\nvarying vec4 fragColor;\n\nvoid main() {\n  if (outOfRange(clipBounds[0], clipBounds[1], worldPosition)) discard;\n\n  gl_FragColor = vec4(pickId/255.0, packFloat(pixelArcLength).xyz);\n}"]), l = [{ name: "position", type: "vec3" }, { name: "nextPosition", type: "vec3" }, { name: "arcLength", type: "float" }, { name: "lineWidth", type: "float" }, { name: "color", type: "vec4" }];
              e4.createShader = function(t5) {
                return i2(t5, a, o, null, l);
              }, e4.createPickShader = function(t5) {
                return i2(t5, a, s, null, l);
              };
            }, 6086: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = t5.gl || t5.scene && t5.scene.gl, r5 = f2(e5);
                r5.attributes.position.location = 0, r5.attributes.nextPosition.location = 1, r5.attributes.arcLength.location = 2, r5.attributes.lineWidth.location = 3, r5.attributes.color.location = 4;
                var o2 = h(e5);
                o2.attributes.position.location = 0, o2.attributes.nextPosition.location = 1, o2.attributes.arcLength.location = 2, o2.attributes.lineWidth.location = 3, o2.attributes.color.location = 4;
                for (var s2 = n3(e5), l2 = i2(e5, [{ buffer: s2, size: 3, offset: 0, stride: 48 }, { buffer: s2, size: 3, offset: 12, stride: 48 }, { buffer: s2, size: 1, offset: 24, stride: 48 }, { buffer: s2, size: 1, offset: 28, stride: 48 }, { buffer: s2, size: 4, offset: 32, stride: 48 }]), c2 = u(new Array(1024), [256, 1, 4]), p3 = 0; p3 < 1024; ++p3)
                  c2.data[p3] = 255;
                var d3 = a(e5, c2);
                d3.wrap = e5.REPEAT;
                var v2 = new y(e5, r5, o2, s2, l2, d3);
                return v2.update(t5), v2;
              };
              var n3 = r4(5827), i2 = r4(2944), a = r4(8931), o = new Uint8Array(4), s = new Float32Array(o.buffer), l = r4(5070), u = r4(5050), c = r4(248), f2 = c.createShader, h = c.createPickShader, p2 = [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1];
              function d2(t5, e5) {
                for (var r5 = 0, n4 = 0; n4 < 3; ++n4) {
                  var i3 = t5[n4] - e5[n4];
                  r5 += i3 * i3;
                }
                return Math.sqrt(r5);
              }
              function v(t5) {
                for (var e5 = [[-1e6, -1e6, -1e6], [1e6, 1e6, 1e6]], r5 = 0; r5 < 3; ++r5)
                  e5[0][r5] = Math.max(t5[0][r5], e5[0][r5]), e5[1][r5] = Math.min(t5[1][r5], e5[1][r5]);
                return e5;
              }
              function g2(t5, e5, r5, n4) {
                this.arcLength = t5, this.position = e5, this.index = r5, this.dataCoordinate = n4;
              }
              function y(t5, e5, r5, n4, i3, a2) {
                this.gl = t5, this.shader = e5, this.pickShader = r5, this.buffer = n4, this.vao = i3, this.clipBounds = [[-1 / 0, -1 / 0, -1 / 0], [1 / 0, 1 / 0, 1 / 0]], this.points = [], this.arcLength = [], this.vertexCount = 0, this.bounds = [[0, 0, 0], [0, 0, 0]], this.pickId = 0, this.lineWidth = 1, this.texture = a2, this.dashScale = 1, this.opacity = 1, this.hasAlpha = false, this.dirty = true, this.pixelRatio = 1;
              }
              var m2 = y.prototype;
              m2.isTransparent = function() {
                return this.hasAlpha;
              }, m2.isOpaque = function() {
                return !this.hasAlpha;
              }, m2.pickSlots = 1, m2.setPickBase = function(t5) {
                this.pickId = t5;
              }, m2.drawTransparent = m2.draw = function(t5) {
                if (this.vertexCount) {
                  var e5 = this.gl, r5 = this.shader, n4 = this.vao;
                  r5.bind(), r5.uniforms = { model: t5.model || p2, view: t5.view || p2, projection: t5.projection || p2, clipBounds: v(this.clipBounds), dashTexture: this.texture.bind(), dashScale: this.dashScale / this.arcLength[this.arcLength.length - 1], opacity: this.opacity, screenShape: [e5.drawingBufferWidth, e5.drawingBufferHeight], pixelRatio: this.pixelRatio }, n4.bind(), n4.draw(e5.TRIANGLE_STRIP, this.vertexCount), n4.unbind();
                }
              }, m2.drawPick = function(t5) {
                if (this.vertexCount) {
                  var e5 = this.gl, r5 = this.pickShader, n4 = this.vao;
                  r5.bind(), r5.uniforms = { model: t5.model || p2, view: t5.view || p2, projection: t5.projection || p2, pickId: this.pickId, clipBounds: v(this.clipBounds), screenShape: [e5.drawingBufferWidth, e5.drawingBufferHeight], pixelRatio: this.pixelRatio }, n4.bind(), n4.draw(e5.TRIANGLE_STRIP, this.vertexCount), n4.unbind();
                }
              }, m2.update = function(t5) {
                var e5, r5;
                this.dirty = true;
                var n4 = !!t5.connectGaps;
                "dashScale" in t5 && (this.dashScale = t5.dashScale), this.hasAlpha = false, "opacity" in t5 && (this.opacity = +t5.opacity, this.opacity < 1 && (this.hasAlpha = true));
                var i3 = [], a2 = [], o2 = [], s2 = 0, c2 = 0, f3 = [[1 / 0, 1 / 0, 1 / 0], [-1 / 0, -1 / 0, -1 / 0]], h2 = t5.position || t5.positions;
                if (h2) {
                  var p3 = t5.color || t5.colors || [0, 0, 0, 1], v2 = t5.lineWidth || 1, g3 = false;
                  t:
                    for (e5 = 1; e5 < h2.length; ++e5) {
                      var y2, m3, x, b = h2[e5 - 1], _ = h2[e5];
                      for (a2.push(s2), o2.push(b.slice()), r5 = 0; r5 < 3; ++r5) {
                        if (isNaN(b[r5]) || isNaN(_[r5]) || !isFinite(b[r5]) || !isFinite(_[r5])) {
                          if (!n4 && i3.length > 0) {
                            for (var w2 = 0; w2 < 24; ++w2)
                              i3.push(i3[i3.length - 12]);
                            c2 += 2, g3 = true;
                          }
                          continue t;
                        }
                        f3[0][r5] = Math.min(f3[0][r5], b[r5], _[r5]), f3[1][r5] = Math.max(f3[1][r5], b[r5], _[r5]);
                      }
                      Array.isArray(p3[0]) ? (y2 = p3.length > e5 - 1 ? p3[e5 - 1] : p3.length > 0 ? p3[p3.length - 1] : [0, 0, 0, 1], m3 = p3.length > e5 ? p3[e5] : p3.length > 0 ? p3[p3.length - 1] : [0, 0, 0, 1]) : y2 = m3 = p3, 3 === y2.length && (y2 = [y2[0], y2[1], y2[2], 1]), 3 === m3.length && (m3 = [m3[0], m3[1], m3[2], 1]), !this.hasAlpha && y2[3] < 1 && (this.hasAlpha = true), x = Array.isArray(v2) ? v2.length > e5 - 1 ? v2[e5 - 1] : v2.length > 0 ? v2[v2.length - 1] : [0, 0, 0, 1] : v2;
                      var T = s2;
                      if (s2 += d2(b, _), g3) {
                        for (r5 = 0; r5 < 2; ++r5)
                          i3.push(b[0], b[1], b[2], _[0], _[1], _[2], T, x, y2[0], y2[1], y2[2], y2[3]);
                        c2 += 2, g3 = false;
                      }
                      i3.push(b[0], b[1], b[2], _[0], _[1], _[2], T, x, y2[0], y2[1], y2[2], y2[3], b[0], b[1], b[2], _[0], _[1], _[2], T, -x, y2[0], y2[1], y2[2], y2[3], _[0], _[1], _[2], b[0], b[1], b[2], s2, -x, m3[0], m3[1], m3[2], m3[3], _[0], _[1], _[2], b[0], b[1], b[2], s2, x, m3[0], m3[1], m3[2], m3[3]), c2 += 4;
                    }
                }
                if (this.buffer.update(i3), a2.push(s2), o2.push(h2[h2.length - 1].slice()), this.bounds = f3, this.vertexCount = c2, this.points = o2, this.arcLength = a2, "dashes" in t5) {
                  var k = t5.dashes.slice();
                  for (k.unshift(0), e5 = 1; e5 < k.length; ++e5)
                    k[e5] = k[e5 - 1] + k[e5];
                  var A = u(new Array(1024), [256, 1, 4]);
                  for (e5 = 0; e5 < 256; ++e5) {
                    for (r5 = 0; r5 < 4; ++r5)
                      A.set(e5, 0, r5, 0);
                    1 & l.le(k, k[k.length - 1] * e5 / 255) ? A.set(e5, 0, 0, 0) : A.set(e5, 0, 0, 255);
                  }
                  this.texture.setPixels(A);
                }
              }, m2.dispose = function() {
                this.shader.dispose(), this.vao.dispose(), this.buffer.dispose();
              }, m2.pick = function(t5) {
                if (!t5)
                  return null;
                if (t5.id !== this.pickId)
                  return null;
                var e5 = function(t6, e6, r6, n5) {
                  return o[0] = 0, o[1] = r6, o[2] = e6, o[3] = t6, s[0];
                }(t5.value[0], t5.value[1], t5.value[2]), r5 = l.le(this.arcLength, e5);
                if (r5 < 0)
                  return null;
                if (r5 === this.arcLength.length - 1)
                  return new g2(this.arcLength[this.arcLength.length - 1], this.points[this.points.length - 1].slice(), r5);
                for (var n4 = this.points[r5], i3 = this.points[Math.min(r5 + 1, this.points.length - 1)], a2 = (e5 - this.arcLength[r5]) / (this.arcLength[r5 + 1] - this.arcLength[r5]), u2 = 1 - a2, c2 = [0, 0, 0], f3 = 0; f3 < 3; ++f3)
                  c2[f3] = u2 * n4[f3] + a2 * i3[f3];
                var h2 = Math.min(a2 < 0.5 ? r5 : r5 + 1, this.points.length - 1);
                return new g2(e5, c2, h2, this.points[h2]);
              };
            }, 7332: function(t4) {
              t4.exports = function(t5) {
                var e4 = new Float32Array(16);
                return e4[0] = t5[0], e4[1] = t5[1], e4[2] = t5[2], e4[3] = t5[3], e4[4] = t5[4], e4[5] = t5[5], e4[6] = t5[6], e4[7] = t5[7], e4[8] = t5[8], e4[9] = t5[9], e4[10] = t5[10], e4[11] = t5[11], e4[12] = t5[12], e4[13] = t5[13], e4[14] = t5[14], e4[15] = t5[15], e4;
              };
            }, 9823: function(t4) {
              t4.exports = function() {
                var t5 = new Float32Array(16);
                return t5[0] = 1, t5[1] = 0, t5[2] = 0, t5[3] = 0, t5[4] = 0, t5[5] = 1, t5[6] = 0, t5[7] = 0, t5[8] = 0, t5[9] = 0, t5[10] = 1, t5[11] = 0, t5[12] = 0, t5[13] = 0, t5[14] = 0, t5[15] = 1, t5;
              };
            }, 7787: function(t4) {
              t4.exports = function(t5) {
                var e4 = t5[0], r4 = t5[1], n3 = t5[2], i2 = t5[3], a = t5[4], o = t5[5], s = t5[6], l = t5[7], u = t5[8], c = t5[9], f2 = t5[10], h = t5[11], p2 = t5[12], d2 = t5[13], v = t5[14], g2 = t5[15];
                return (e4 * o - r4 * a) * (f2 * g2 - h * v) - (e4 * s - n3 * a) * (c * g2 - h * d2) + (e4 * l - i2 * a) * (c * v - f2 * d2) + (r4 * s - n3 * o) * (u * g2 - h * p2) - (r4 * l - i2 * o) * (u * v - f2 * p2) + (n3 * l - i2 * s) * (u * d2 - c * p2);
              };
            }, 5950: function(t4) {
              t4.exports = function(t5, e4) {
                var r4 = e4[0], n3 = e4[1], i2 = e4[2], a = e4[3], o = r4 + r4, s = n3 + n3, l = i2 + i2, u = r4 * o, c = n3 * o, f2 = n3 * s, h = i2 * o, p2 = i2 * s, d2 = i2 * l, v = a * o, g2 = a * s, y = a * l;
                return t5[0] = 1 - f2 - d2, t5[1] = c + y, t5[2] = h - g2, t5[3] = 0, t5[4] = c - y, t5[5] = 1 - u - d2, t5[6] = p2 + v, t5[7] = 0, t5[8] = h + g2, t5[9] = p2 - v, t5[10] = 1 - u - f2, t5[11] = 0, t5[12] = 0, t5[13] = 0, t5[14] = 0, t5[15] = 1, t5;
              };
            }, 7280: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = e4[0], i2 = e4[1], a = e4[2], o = e4[3], s = n3 + n3, l = i2 + i2, u = a + a, c = n3 * s, f2 = n3 * l, h = n3 * u, p2 = i2 * l, d2 = i2 * u, v = a * u, g2 = o * s, y = o * l, m2 = o * u;
                return t5[0] = 1 - (p2 + v), t5[1] = f2 + m2, t5[2] = h - y, t5[3] = 0, t5[4] = f2 - m2, t5[5] = 1 - (c + v), t5[6] = d2 + g2, t5[7] = 0, t5[8] = h + y, t5[9] = d2 - g2, t5[10] = 1 - (c + p2), t5[11] = 0, t5[12] = r4[0], t5[13] = r4[1], t5[14] = r4[2], t5[15] = 1, t5;
              };
            }, 9947: function(t4) {
              t4.exports = function(t5) {
                return t5[0] = 1, t5[1] = 0, t5[2] = 0, t5[3] = 0, t5[4] = 0, t5[5] = 1, t5[6] = 0, t5[7] = 0, t5[8] = 0, t5[9] = 0, t5[10] = 1, t5[11] = 0, t5[12] = 0, t5[13] = 0, t5[14] = 0, t5[15] = 1, t5;
              };
            }, 7437: function(t4) {
              t4.exports = function(t5, e4) {
                var r4 = e4[0], n3 = e4[1], i2 = e4[2], a = e4[3], o = e4[4], s = e4[5], l = e4[6], u = e4[7], c = e4[8], f2 = e4[9], h = e4[10], p2 = e4[11], d2 = e4[12], v = e4[13], g2 = e4[14], y = e4[15], m2 = r4 * s - n3 * o, x = r4 * l - i2 * o, b = r4 * u - a * o, _ = n3 * l - i2 * s, w2 = n3 * u - a * s, T = i2 * u - a * l, k = c * v - f2 * d2, A = c * g2 - h * d2, M = c * y - p2 * d2, S = f2 * g2 - h * v, E = f2 * y - p2 * v, L = h * y - p2 * g2, C = m2 * L - x * E + b * S + _ * M - w2 * A + T * k;
                return C ? (C = 1 / C, t5[0] = (s * L - l * E + u * S) * C, t5[1] = (i2 * E - n3 * L - a * S) * C, t5[2] = (v * T - g2 * w2 + y * _) * C, t5[3] = (h * w2 - f2 * T - p2 * _) * C, t5[4] = (l * M - o * L - u * A) * C, t5[5] = (r4 * L - i2 * M + a * A) * C, t5[6] = (g2 * b - d2 * T - y * x) * C, t5[7] = (c * T - h * b + p2 * x) * C, t5[8] = (o * E - s * M + u * k) * C, t5[9] = (n3 * M - r4 * E - a * k) * C, t5[10] = (d2 * w2 - v * b + y * m2) * C, t5[11] = (f2 * b - c * w2 - p2 * m2) * C, t5[12] = (s * A - o * S - l * k) * C, t5[13] = (r4 * S - n3 * A + i2 * k) * C, t5[14] = (v * x - d2 * _ - g2 * m2) * C, t5[15] = (c * _ - f2 * x + h * m2) * C, t5) : null;
              };
            }, 3012: function(t4, e4, r4) {
              var n3 = r4(9947);
              t4.exports = function(t5, e5, r5, i2) {
                var a, o, s, l, u, c, f2, h, p2, d2, v = e5[0], g2 = e5[1], y = e5[2], m2 = i2[0], x = i2[1], b = i2[2], _ = r5[0], w2 = r5[1], T = r5[2];
                return Math.abs(v - _) < 1e-6 && Math.abs(g2 - w2) < 1e-6 && Math.abs(y - T) < 1e-6 ? n3(t5) : (f2 = v - _, h = g2 - w2, p2 = y - T, a = x * (p2 *= d2 = 1 / Math.sqrt(f2 * f2 + h * h + p2 * p2)) - b * (h *= d2), o = b * (f2 *= d2) - m2 * p2, s = m2 * h - x * f2, (d2 = Math.sqrt(a * a + o * o + s * s)) ? (a *= d2 = 1 / d2, o *= d2, s *= d2) : (a = 0, o = 0, s = 0), l = h * s - p2 * o, u = p2 * a - f2 * s, c = f2 * o - h * a, (d2 = Math.sqrt(l * l + u * u + c * c)) ? (l *= d2 = 1 / d2, u *= d2, c *= d2) : (l = 0, u = 0, c = 0), t5[0] = a, t5[1] = l, t5[2] = f2, t5[3] = 0, t5[4] = o, t5[5] = u, t5[6] = h, t5[7] = 0, t5[8] = s, t5[9] = c, t5[10] = p2, t5[11] = 0, t5[12] = -(a * v + o * g2 + s * y), t5[13] = -(l * v + u * g2 + c * y), t5[14] = -(f2 * v + h * g2 + p2 * y), t5[15] = 1, t5);
              };
            }, 104: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = e4[0], i2 = e4[1], a = e4[2], o = e4[3], s = e4[4], l = e4[5], u = e4[6], c = e4[7], f2 = e4[8], h = e4[9], p2 = e4[10], d2 = e4[11], v = e4[12], g2 = e4[13], y = e4[14], m2 = e4[15], x = r4[0], b = r4[1], _ = r4[2], w2 = r4[3];
                return t5[0] = x * n3 + b * s + _ * f2 + w2 * v, t5[1] = x * i2 + b * l + _ * h + w2 * g2, t5[2] = x * a + b * u + _ * p2 + w2 * y, t5[3] = x * o + b * c + _ * d2 + w2 * m2, x = r4[4], b = r4[5], _ = r4[6], w2 = r4[7], t5[4] = x * n3 + b * s + _ * f2 + w2 * v, t5[5] = x * i2 + b * l + _ * h + w2 * g2, t5[6] = x * a + b * u + _ * p2 + w2 * y, t5[7] = x * o + b * c + _ * d2 + w2 * m2, x = r4[8], b = r4[9], _ = r4[10], w2 = r4[11], t5[8] = x * n3 + b * s + _ * f2 + w2 * v, t5[9] = x * i2 + b * l + _ * h + w2 * g2, t5[10] = x * a + b * u + _ * p2 + w2 * y, t5[11] = x * o + b * c + _ * d2 + w2 * m2, x = r4[12], b = r4[13], _ = r4[14], w2 = r4[15], t5[12] = x * n3 + b * s + _ * f2 + w2 * v, t5[13] = x * i2 + b * l + _ * h + w2 * g2, t5[14] = x * a + b * u + _ * p2 + w2 * y, t5[15] = x * o + b * c + _ * d2 + w2 * m2, t5;
              };
            }, 5268: function(t4) {
              t4.exports = function(t5, e4, r4, n3, i2, a, o) {
                var s = 1 / (e4 - r4), l = 1 / (n3 - i2), u = 1 / (a - o);
                return t5[0] = -2 * s, t5[1] = 0, t5[2] = 0, t5[3] = 0, t5[4] = 0, t5[5] = -2 * l, t5[6] = 0, t5[7] = 0, t5[8] = 0, t5[9] = 0, t5[10] = 2 * u, t5[11] = 0, t5[12] = (e4 + r4) * s, t5[13] = (i2 + n3) * l, t5[14] = (o + a) * u, t5[15] = 1, t5;
              };
            }, 1120: function(t4) {
              t4.exports = function(t5, e4, r4, n3, i2) {
                var a = 1 / Math.tan(e4 / 2), o = 1 / (n3 - i2);
                return t5[0] = a / r4, t5[1] = 0, t5[2] = 0, t5[3] = 0, t5[4] = 0, t5[5] = a, t5[6] = 0, t5[7] = 0, t5[8] = 0, t5[9] = 0, t5[10] = (i2 + n3) * o, t5[11] = -1, t5[12] = 0, t5[13] = 0, t5[14] = 2 * i2 * n3 * o, t5[15] = 0, t5;
              };
            }, 4422: function(t4) {
              t4.exports = function(t5, e4, r4, n3) {
                var i2, a, o, s, l, u, c, f2, h, p2, d2, v, g2, y, m2, x, b, _, w2, T, k, A, M, S, E = n3[0], L = n3[1], C = n3[2], P = Math.sqrt(E * E + L * L + C * C);
                return Math.abs(P) < 1e-6 ? null : (E *= P = 1 / P, L *= P, C *= P, i2 = Math.sin(r4), o = 1 - (a = Math.cos(r4)), s = e4[0], l = e4[1], u = e4[2], c = e4[3], f2 = e4[4], h = e4[5], p2 = e4[6], d2 = e4[7], v = e4[8], g2 = e4[9], y = e4[10], m2 = e4[11], x = E * E * o + a, b = L * E * o + C * i2, _ = C * E * o - L * i2, w2 = E * L * o - C * i2, T = L * L * o + a, k = C * L * o + E * i2, A = E * C * o + L * i2, M = L * C * o - E * i2, S = C * C * o + a, t5[0] = s * x + f2 * b + v * _, t5[1] = l * x + h * b + g2 * _, t5[2] = u * x + p2 * b + y * _, t5[3] = c * x + d2 * b + m2 * _, t5[4] = s * w2 + f2 * T + v * k, t5[5] = l * w2 + h * T + g2 * k, t5[6] = u * w2 + p2 * T + y * k, t5[7] = c * w2 + d2 * T + m2 * k, t5[8] = s * A + f2 * M + v * S, t5[9] = l * A + h * M + g2 * S, t5[10] = u * A + p2 * M + y * S, t5[11] = c * A + d2 * M + m2 * S, e4 !== t5 && (t5[12] = e4[12], t5[13] = e4[13], t5[14] = e4[14], t5[15] = e4[15]), t5);
              };
            }, 6109: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = Math.sin(r4), i2 = Math.cos(r4), a = e4[4], o = e4[5], s = e4[6], l = e4[7], u = e4[8], c = e4[9], f2 = e4[10], h = e4[11];
                return e4 !== t5 && (t5[0] = e4[0], t5[1] = e4[1], t5[2] = e4[2], t5[3] = e4[3], t5[12] = e4[12], t5[13] = e4[13], t5[14] = e4[14], t5[15] = e4[15]), t5[4] = a * i2 + u * n3, t5[5] = o * i2 + c * n3, t5[6] = s * i2 + f2 * n3, t5[7] = l * i2 + h * n3, t5[8] = u * i2 - a * n3, t5[9] = c * i2 - o * n3, t5[10] = f2 * i2 - s * n3, t5[11] = h * i2 - l * n3, t5;
              };
            }, 7115: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = Math.sin(r4), i2 = Math.cos(r4), a = e4[0], o = e4[1], s = e4[2], l = e4[3], u = e4[8], c = e4[9], f2 = e4[10], h = e4[11];
                return e4 !== t5 && (t5[4] = e4[4], t5[5] = e4[5], t5[6] = e4[6], t5[7] = e4[7], t5[12] = e4[12], t5[13] = e4[13], t5[14] = e4[14], t5[15] = e4[15]), t5[0] = a * i2 - u * n3, t5[1] = o * i2 - c * n3, t5[2] = s * i2 - f2 * n3, t5[3] = l * i2 - h * n3, t5[8] = a * n3 + u * i2, t5[9] = o * n3 + c * i2, t5[10] = s * n3 + f2 * i2, t5[11] = l * n3 + h * i2, t5;
              };
            }, 5240: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = Math.sin(r4), i2 = Math.cos(r4), a = e4[0], o = e4[1], s = e4[2], l = e4[3], u = e4[4], c = e4[5], f2 = e4[6], h = e4[7];
                return e4 !== t5 && (t5[8] = e4[8], t5[9] = e4[9], t5[10] = e4[10], t5[11] = e4[11], t5[12] = e4[12], t5[13] = e4[13], t5[14] = e4[14], t5[15] = e4[15]), t5[0] = a * i2 + u * n3, t5[1] = o * i2 + c * n3, t5[2] = s * i2 + f2 * n3, t5[3] = l * i2 + h * n3, t5[4] = u * i2 - a * n3, t5[5] = c * i2 - o * n3, t5[6] = f2 * i2 - s * n3, t5[7] = h * i2 - l * n3, t5;
              };
            }, 3668: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = r4[0], i2 = r4[1], a = r4[2];
                return t5[0] = e4[0] * n3, t5[1] = e4[1] * n3, t5[2] = e4[2] * n3, t5[3] = e4[3] * n3, t5[4] = e4[4] * i2, t5[5] = e4[5] * i2, t5[6] = e4[6] * i2, t5[7] = e4[7] * i2, t5[8] = e4[8] * a, t5[9] = e4[9] * a, t5[10] = e4[10] * a, t5[11] = e4[11] * a, t5[12] = e4[12], t5[13] = e4[13], t5[14] = e4[14], t5[15] = e4[15], t5;
              };
            }, 998: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3, i2, a, o, s, l, u, c, f2, h, p2, d2, v = r4[0], g2 = r4[1], y = r4[2];
                return e4 === t5 ? (t5[12] = e4[0] * v + e4[4] * g2 + e4[8] * y + e4[12], t5[13] = e4[1] * v + e4[5] * g2 + e4[9] * y + e4[13], t5[14] = e4[2] * v + e4[6] * g2 + e4[10] * y + e4[14], t5[15] = e4[3] * v + e4[7] * g2 + e4[11] * y + e4[15]) : (n3 = e4[0], i2 = e4[1], a = e4[2], o = e4[3], s = e4[4], l = e4[5], u = e4[6], c = e4[7], f2 = e4[8], h = e4[9], p2 = e4[10], d2 = e4[11], t5[0] = n3, t5[1] = i2, t5[2] = a, t5[3] = o, t5[4] = s, t5[5] = l, t5[6] = u, t5[7] = c, t5[8] = f2, t5[9] = h, t5[10] = p2, t5[11] = d2, t5[12] = n3 * v + s * g2 + f2 * y + e4[12], t5[13] = i2 * v + l * g2 + h * y + e4[13], t5[14] = a * v + u * g2 + p2 * y + e4[14], t5[15] = o * v + c * g2 + d2 * y + e4[15]), t5;
              };
            }, 2142: function(t4) {
              t4.exports = function(t5, e4) {
                if (t5 === e4) {
                  var r4 = e4[1], n3 = e4[2], i2 = e4[3], a = e4[6], o = e4[7], s = e4[11];
                  t5[1] = e4[4], t5[2] = e4[8], t5[3] = e4[12], t5[4] = r4, t5[6] = e4[9], t5[7] = e4[13], t5[8] = n3, t5[9] = a, t5[11] = e4[14], t5[12] = i2, t5[13] = o, t5[14] = s;
                } else
                  t5[0] = e4[0], t5[1] = e4[4], t5[2] = e4[8], t5[3] = e4[12], t5[4] = e4[1], t5[5] = e4[5], t5[6] = e4[9], t5[7] = e4[13], t5[8] = e4[2], t5[9] = e4[6], t5[10] = e4[10], t5[11] = e4[14], t5[12] = e4[3], t5[13] = e4[7], t5[14] = e4[11], t5[15] = e4[15];
                return t5;
              };
            }, 4340: function(t4, e4, r4) {
              var n3 = r4(957), i2 = r4(7309);
              function a(t5, e5) {
                for (var r5 = [0, 0, 0, 0], n4 = 0; n4 < 4; ++n4)
                  for (var i3 = 0; i3 < 4; ++i3)
                    r5[i3] += t5[4 * n4 + i3] * e5[n4];
                return r5;
              }
              function o(t5, e5, r5, n4, i3) {
                for (var o2 = a(n4, a(r5, a(e5, [t5[0], t5[1], t5[2], 1]))), s2 = 0; s2 < 3; ++s2)
                  o2[s2] /= o2[3];
                return [0.5 * i3[0] * (1 + o2[0]), 0.5 * i3[1] * (1 - o2[1])];
              }
              function s(t5, e5) {
                for (var r5 = [0, 0, 0], n4 = 0; n4 < t5.length; ++n4)
                  for (var i3 = t5[n4], a2 = e5[n4], o2 = 0; o2 < 3; ++o2)
                    r5[o2] += a2 * i3[o2];
                return r5;
              }
              t4.exports = function(t5, e5, r5, a2, l, u) {
                if (1 === t5.length)
                  return [0, t5[0].slice()];
                for (var c = new Array(t5.length), f2 = 0; f2 < t5.length; ++f2)
                  c[f2] = o(t5[f2], r5, a2, l, u);
                var h = 0, p2 = 1 / 0;
                for (f2 = 0; f2 < c.length; ++f2) {
                  for (var d2 = 0, v = 0; v < 2; ++v)
                    d2 += Math.pow(c[f2][v] - e5[v], 2);
                  d2 < p2 && (p2 = d2, h = f2);
                }
                var g2 = function(t6, e6) {
                  if (2 === t6.length) {
                    for (var r6 = 0, a3 = 0, o2 = 0; o2 < 2; ++o2)
                      r6 += Math.pow(e6[o2] - t6[0][o2], 2), a3 += Math.pow(e6[o2] - t6[1][o2], 2);
                    return (r6 = Math.sqrt(r6)) + (a3 = Math.sqrt(a3)) < 1e-6 ? [1, 0] : [a3 / (r6 + a3), r6 / (a3 + r6)];
                  }
                  if (3 === t6.length) {
                    var s2 = [0, 0];
                    return i2(t6[0], t6[1], t6[2], e6, s2), n3(t6, s2);
                  }
                  return [];
                }(c, e5), y = 0;
                for (f2 = 0; f2 < 3; ++f2) {
                  if (g2[f2] < -1e-3 || g2[f2] > 1.0001)
                    return null;
                  y += g2[f2];
                }
                return Math.abs(y - 1) > 1e-3 ? null : [h, s(t5, g2), g2];
              };
            }, 2056: function(t4, e4, r4) {
              var n3 = r4(6832), i2 = n3(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec3 position, normal;\nattribute vec4 color;\nattribute vec2 uv;\n\nuniform mat4 model\n           , view\n           , projection\n           , inverseModel;\nuniform vec3 eyePosition\n           , lightPosition;\n\nvarying vec3 f_normal\n           , f_lightDirection\n           , f_eyeDirection\n           , f_data;\nvarying vec4 f_color;\nvarying vec2 f_uv;\n\nvec4 project(vec3 p) {\n  return projection * view * model * vec4(p, 1.0);\n}\n\nvoid main() {\n  gl_Position      = project(position);\n\n  //Lighting geometry parameters\n  vec4 cameraCoordinate = view * vec4(position , 1.0);\n  cameraCoordinate.xyz /= cameraCoordinate.w;\n  f_lightDirection = lightPosition - cameraCoordinate.xyz;\n  f_eyeDirection   = eyePosition - cameraCoordinate.xyz;\n  f_normal  = normalize((vec4(normal, 0.0) * inverseModel).xyz);\n\n  f_color          = color;\n  f_data           = position;\n  f_uv             = uv;\n}\n"]), a = n3(["#extension GL_OES_standard_derivatives : enable\n\nprecision highp float;\n#define GLSLIFY 1\n\nfloat beckmannDistribution(float x, float roughness) {\n  float NdotH = max(x, 0.0001);\n  float cos2Alpha = NdotH * NdotH;\n  float tan2Alpha = (cos2Alpha - 1.0) / cos2Alpha;\n  float roughness2 = roughness * roughness;\n  float denom = 3.141592653589793 * roughness2 * cos2Alpha * cos2Alpha;\n  return exp(tan2Alpha / roughness2) / denom;\n}\n\nfloat cookTorranceSpecular(\n  vec3 lightDirection,\n  vec3 viewDirection,\n  vec3 surfaceNormal,\n  float roughness,\n  float fresnel) {\n\n  float VdotN = max(dot(viewDirection, surfaceNormal), 0.0);\n  float LdotN = max(dot(lightDirection, surfaceNormal), 0.0);\n\n  //Half angle vector\n  vec3 H = normalize(lightDirection + viewDirection);\n\n  //Geometric term\n  float NdotH = max(dot(surfaceNormal, H), 0.0);\n  float VdotH = max(dot(viewDirection, H), 0.000001);\n  float LdotH = max(dot(lightDirection, H), 0.000001);\n  float G1 = (2.0 * NdotH * VdotN) / VdotH;\n  float G2 = (2.0 * NdotH * LdotN) / LdotH;\n  float G = min(1.0, min(G1, G2));\n  \n  //Distribution term\n  float D = beckmannDistribution(NdotH, roughness);\n\n  //Fresnel term\n  float F = pow(1.0 - VdotN, fresnel);\n\n  //Multiply terms and done\n  return  G * F * D / max(3.14159265 * VdotN, 0.000001);\n}\n\n//#pragma glslify: beckmann = require(glsl-specular-beckmann) // used in gl-surface3d\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec3 clipBounds[2];\nuniform float roughness\n            , fresnel\n            , kambient\n            , kdiffuse\n            , kspecular;\nuniform sampler2D texture;\n\nvarying vec3 f_normal\n           , f_lightDirection\n           , f_eyeDirection\n           , f_data;\nvarying vec4 f_color;\nvarying vec2 f_uv;\n\nvoid main() {\n  if (f_color.a == 0.0 ||\n    outOfRange(clipBounds[0], clipBounds[1], f_data)\n  ) discard;\n\n  vec3 N = normalize(f_normal);\n  vec3 L = normalize(f_lightDirection);\n  vec3 V = normalize(f_eyeDirection);\n\n  if(gl_FrontFacing) {\n    N = -N;\n  }\n\n  float specular = min(1.0, max(0.0, cookTorranceSpecular(L, V, N, roughness, fresnel)));\n  //float specular = max(0.0, beckmann(L, V, N, roughness)); // used in gl-surface3d\n\n  float diffuse  = min(kambient + kdiffuse * max(dot(N, L), 0.0), 1.0);\n\n  vec4 surfaceColor = vec4(f_color.rgb, 1.0) * texture2D(texture, f_uv);\n  vec4 litColor = surfaceColor.a * vec4(diffuse * surfaceColor.rgb + kspecular * vec3(1,1,1) * specular,  1.0);\n\n  gl_FragColor = litColor * f_color.a;\n}\n"]), o = n3(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec3 position;\nattribute vec4 color;\nattribute vec2 uv;\n\nuniform mat4 model, view, projection;\n\nvarying vec4 f_color;\nvarying vec3 f_data;\nvarying vec2 f_uv;\n\nvoid main() {\n  gl_Position = projection * view * model * vec4(position, 1.0);\n  f_color = color;\n  f_data  = position;\n  f_uv    = uv;\n}"]), s = n3(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec3 clipBounds[2];\nuniform sampler2D texture;\nuniform float opacity;\n\nvarying vec4 f_color;\nvarying vec3 f_data;\nvarying vec2 f_uv;\n\nvoid main() {\n  if (outOfRange(clipBounds[0], clipBounds[1], f_data)) discard;\n\n  gl_FragColor = f_color * texture2D(texture, f_uv) * opacity;\n}"]), l = n3(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nattribute vec3 position;\nattribute vec4 color;\nattribute vec2 uv;\nattribute float pointSize;\n\nuniform mat4 model, view, projection;\nuniform vec3 clipBounds[2];\n\nvarying vec4 f_color;\nvarying vec2 f_uv;\n\nvoid main() {\n  if (outOfRange(clipBounds[0], clipBounds[1], position)) {\n\n    gl_Position = vec4(0.0, 0.0 ,0.0 ,0.0);\n  } else {\n    gl_Position = projection * view * model * vec4(position, 1.0);\n  }\n  gl_PointSize = pointSize;\n  f_color = color;\n  f_uv = uv;\n}"]), u = n3(["precision highp float;\n#define GLSLIFY 1\n\nuniform sampler2D texture;\nuniform float opacity;\n\nvarying vec4 f_color;\nvarying vec2 f_uv;\n\nvoid main() {\n  vec2 pointR = gl_PointCoord.xy - vec2(0.5, 0.5);\n  if(dot(pointR, pointR) > 0.25) {\n    discard;\n  }\n  gl_FragColor = f_color * texture2D(texture, f_uv) * opacity;\n}"]), c = n3(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec3 position;\nattribute vec4 id;\n\nuniform mat4 model, view, projection;\n\nvarying vec3 f_position;\nvarying vec4 f_id;\n\nvoid main() {\n  gl_Position = projection * view * model * vec4(position, 1.0);\n  f_id        = id;\n  f_position  = position;\n}"]), f2 = n3(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec3  clipBounds[2];\nuniform float pickId;\n\nvarying vec3 f_position;\nvarying vec4 f_id;\n\nvoid main() {\n  if (outOfRange(clipBounds[0], clipBounds[1], f_position)) discard;\n\n  gl_FragColor = vec4(pickId, f_id.xyz);\n}"]), h = n3(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nattribute vec3  position;\nattribute float pointSize;\nattribute vec4  id;\n\nuniform mat4 model, view, projection;\nuniform vec3 clipBounds[2];\n\nvarying vec3 f_position;\nvarying vec4 f_id;\n\nvoid main() {\n  if (outOfRange(clipBounds[0], clipBounds[1], position)) {\n\n    gl_Position = vec4(0.0, 0.0, 0.0, 0.0);\n  } else {\n    gl_Position  = projection * view * model * vec4(position, 1.0);\n    gl_PointSize = pointSize;\n  }\n  f_id         = id;\n  f_position   = position;\n}"]), p2 = n3(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec3 position;\n\nuniform mat4 model, view, projection;\n\nvoid main() {\n  gl_Position = projection * view * model * vec4(position, 1.0);\n}"]), d2 = n3(["precision highp float;\n#define GLSLIFY 1\n\nuniform vec3 contourColor;\n\nvoid main() {\n  gl_FragColor = vec4(contourColor, 1.0);\n}\n"]);
              e4.meshShader = { vertex: i2, fragment: a, attributes: [{ name: "position", type: "vec3" }, { name: "normal", type: "vec3" }, { name: "color", type: "vec4" }, { name: "uv", type: "vec2" }] }, e4.wireShader = { vertex: o, fragment: s, attributes: [{ name: "position", type: "vec3" }, { name: "color", type: "vec4" }, { name: "uv", type: "vec2" }] }, e4.pointShader = { vertex: l, fragment: u, attributes: [{ name: "position", type: "vec3" }, { name: "color", type: "vec4" }, { name: "uv", type: "vec2" }, { name: "pointSize", type: "float" }] }, e4.pickShader = { vertex: c, fragment: f2, attributes: [{ name: "position", type: "vec3" }, { name: "id", type: "vec4" }] }, e4.pointPickShader = { vertex: h, fragment: f2, attributes: [{ name: "position", type: "vec3" }, { name: "pointSize", type: "float" }, { name: "id", type: "vec4" }] }, e4.contourShader = { vertex: p2, fragment: d2, attributes: [{ name: "position", type: "vec3" }] };
            }, 8116: function(t4, e4, r4) {
              var n3 = r4(5158), i2 = r4(5827), a = r4(2944), o = r4(8931), s = r4(115), l = r4(104), u = r4(7437), c = r4(5050), f2 = r4(9156), h = r4(7212), p2 = r4(5306), d2 = r4(2056), v = r4(4340), g2 = d2.meshShader, y = d2.wireShader, m2 = d2.pointShader, x = d2.pickShader, b = d2.pointPickShader, _ = d2.contourShader, w2 = [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1];
              function T(t5, e5, r5, n4, i3, a2, o2, s2, l2, u2, c2, f3, h2, p3, d3, v2, g3, y2, m3, x2, b2, _2, T2, k2, A2, M2, S2) {
                this.gl = t5, this.pixelRatio = 1, this.cells = [], this.positions = [], this.intensity = [], this.texture = e5, this.dirty = true, this.triShader = r5, this.lineShader = n4, this.pointShader = i3, this.pickShader = a2, this.pointPickShader = o2, this.contourShader = s2, this.trianglePositions = l2, this.triangleColors = c2, this.triangleNormals = h2, this.triangleUVs = f3, this.triangleIds = u2, this.triangleVAO = p3, this.triangleCount = 0, this.lineWidth = 1, this.edgePositions = d3, this.edgeColors = g3, this.edgeUVs = y2, this.edgeIds = v2, this.edgeVAO = m3, this.edgeCount = 0, this.pointPositions = x2, this.pointColors = _2, this.pointUVs = T2, this.pointSizes = k2, this.pointIds = b2, this.pointVAO = A2, this.pointCount = 0, this.contourLineWidth = 1, this.contourPositions = M2, this.contourVAO = S2, this.contourCount = 0, this.contourColor = [0, 0, 0], this.contourEnable = true, this.pickVertex = true, this.pickId = 1, this.bounds = [[1 / 0, 1 / 0, 1 / 0], [-1 / 0, -1 / 0, -1 / 0]], this.clipBounds = [[-1 / 0, -1 / 0, -1 / 0], [1 / 0, 1 / 0, 1 / 0]], this.lightPosition = [1e5, 1e5, 0], this.ambientLight = 0.8, this.diffuseLight = 0.8, this.specularLight = 2, this.roughness = 0.5, this.fresnel = 1.5, this.opacity = 1, this.hasAlpha = false, this.opacityscale = false, this._model = w2, this._view = w2, this._projection = w2, this._resolution = [1, 1];
              }
              var k = T.prototype;
              function A(t5, e5) {
                if (!e5)
                  return 1;
                if (!e5.length)
                  return 1;
                for (var r5 = 0; r5 < e5.length; ++r5) {
                  if (e5.length < 2)
                    return 1;
                  if (e5[r5][0] === t5)
                    return e5[r5][1];
                  if (e5[r5][0] > t5 && r5 > 0) {
                    var n4 = (e5[r5][0] - t5) / (e5[r5][0] - e5[r5 - 1][0]);
                    return e5[r5][1] * (1 - n4) + n4 * e5[r5 - 1][1];
                  }
                }
                return 1;
              }
              function M(t5) {
                var e5 = n3(t5, g2.vertex, g2.fragment);
                return e5.attributes.position.location = 0, e5.attributes.color.location = 2, e5.attributes.uv.location = 3, e5.attributes.normal.location = 4, e5;
              }
              function S(t5) {
                var e5 = n3(t5, y.vertex, y.fragment);
                return e5.attributes.position.location = 0, e5.attributes.color.location = 2, e5.attributes.uv.location = 3, e5;
              }
              function E(t5) {
                var e5 = n3(t5, m2.vertex, m2.fragment);
                return e5.attributes.position.location = 0, e5.attributes.color.location = 2, e5.attributes.uv.location = 3, e5.attributes.pointSize.location = 4, e5;
              }
              function L(t5) {
                var e5 = n3(t5, x.vertex, x.fragment);
                return e5.attributes.position.location = 0, e5.attributes.id.location = 1, e5;
              }
              function C(t5) {
                var e5 = n3(t5, b.vertex, b.fragment);
                return e5.attributes.position.location = 0, e5.attributes.id.location = 1, e5.attributes.pointSize.location = 4, e5;
              }
              function P(t5) {
                var e5 = n3(t5, _.vertex, _.fragment);
                return e5.attributes.position.location = 0, e5;
              }
              k.isOpaque = function() {
                return !this.hasAlpha;
              }, k.isTransparent = function() {
                return this.hasAlpha;
              }, k.pickSlots = 1, k.setPickBase = function(t5) {
                this.pickId = t5;
              }, k.highlight = function(t5) {
                if (t5 && this.contourEnable) {
                  for (var e5 = h(this.cells, this.intensity, t5.intensity), r5 = e5.cells, n4 = e5.vertexIds, i3 = e5.vertexWeights, a2 = r5.length, o2 = p2.mallocFloat32(6 * a2), s2 = 0, l2 = 0; l2 < a2; ++l2)
                    for (var u2 = r5[l2], c2 = 0; c2 < 2; ++c2) {
                      var f3 = u2[0];
                      2 === u2.length && (f3 = u2[c2]);
                      for (var d3 = n4[f3][0], v2 = n4[f3][1], g3 = i3[f3], y2 = 1 - g3, m3 = this.positions[d3], x2 = this.positions[v2], b2 = 0; b2 < 3; ++b2)
                        o2[s2++] = g3 * m3[b2] + y2 * x2[b2];
                    }
                  this.contourCount = s2 / 3 | 0, this.contourPositions.update(o2.subarray(0, s2)), p2.free(o2);
                } else
                  this.contourCount = 0;
              }, k.update = function(t5) {
                t5 = t5 || {};
                var e5 = this.gl;
                this.dirty = true, "contourEnable" in t5 && (this.contourEnable = t5.contourEnable), "contourColor" in t5 && (this.contourColor = t5.contourColor), "lineWidth" in t5 && (this.lineWidth = t5.lineWidth), "lightPosition" in t5 && (this.lightPosition = t5.lightPosition), this.hasAlpha = false, "opacity" in t5 && (this.opacity = t5.opacity, this.opacity < 1 && (this.hasAlpha = true)), "opacityscale" in t5 && (this.opacityscale = t5.opacityscale, this.hasAlpha = true), "ambient" in t5 && (this.ambientLight = t5.ambient), "diffuse" in t5 && (this.diffuseLight = t5.diffuse), "specular" in t5 && (this.specularLight = t5.specular), "roughness" in t5 && (this.roughness = t5.roughness), "fresnel" in t5 && (this.fresnel = t5.fresnel), t5.texture ? (this.texture.dispose(), this.texture = o(e5, t5.texture)) : t5.colormap && (this.texture.shape = [256, 256], this.texture.minFilter = e5.LINEAR_MIPMAP_LINEAR, this.texture.magFilter = e5.LINEAR, this.texture.setPixels(function(t6, e6) {
                  for (var r6 = f2({ colormap: t6, nshades: 256, format: "rgba" }), n5 = new Uint8Array(1024), i4 = 0; i4 < 256; ++i4) {
                    for (var a3 = r6[i4], o2 = 0; o2 < 3; ++o2)
                      n5[4 * i4 + o2] = a3[o2];
                    n5[4 * i4 + 3] = e6 ? 255 * A(i4 / 255, e6) : 255 * a3[3];
                  }
                  return c(n5, [256, 256, 4], [4, 0, 1]);
                }(t5.colormap, this.opacityscale)), this.texture.generateMipmap());
                var r5 = t5.cells, n4 = t5.positions;
                if (n4 && r5) {
                  var i3 = [], a2 = [], l2 = [], u2 = [], h2 = [], p3 = [], d3 = [], v2 = [], g3 = [], y2 = [], m3 = [], x2 = [], b2 = [], _2 = [];
                  this.cells = r5, this.positions = n4;
                  var w3 = t5.vertexNormals, T2 = t5.cellNormals, k2 = void 0 === t5.vertexNormalsEpsilon ? 1e-6 : t5.vertexNormalsEpsilon, M2 = void 0 === t5.faceNormalsEpsilon ? 1e-6 : t5.faceNormalsEpsilon;
                  t5.useFacetNormals && !T2 && (T2 = s.faceNormals(r5, n4, M2)), T2 || w3 || (w3 = s.vertexNormals(r5, n4, k2));
                  var S2 = t5.vertexColors, E2 = t5.cellColors, L2 = t5.meshColor || [1, 1, 1, 1], C2 = t5.vertexUVs, P2 = t5.vertexIntensity, O = t5.cellUVs, I = t5.cellIntensity, D = 1 / 0, z = -1 / 0;
                  if (!C2 && !O)
                    if (P2)
                      if (t5.vertexIntensityBounds)
                        D = +t5.vertexIntensityBounds[0], z = +t5.vertexIntensityBounds[1];
                      else
                        for (var R = 0; R < P2.length; ++R) {
                          var F = P2[R];
                          D = Math.min(D, F), z = Math.max(z, F);
                        }
                    else if (I)
                      if (t5.cellIntensityBounds)
                        D = +t5.cellIntensityBounds[0], z = +t5.cellIntensityBounds[1];
                      else
                        for (R = 0; R < I.length; ++R)
                          F = I[R], D = Math.min(D, F), z = Math.max(z, F);
                    else
                      for (R = 0; R < n4.length; ++R)
                        F = n4[R][2], D = Math.min(D, F), z = Math.max(z, F);
                  this.intensity = P2 || I || function(t6) {
                    for (var e6 = t6.length, r6 = new Array(e6), n5 = 0; n5 < e6; ++n5)
                      r6[n5] = t6[n5][2];
                    return r6;
                  }(n4), this.pickVertex = !(I || E2);
                  var B = t5.pointSizes, N = t5.pointSize || 1;
                  for (this.bounds = [[1 / 0, 1 / 0, 1 / 0], [-1 / 0, -1 / 0, -1 / 0]], R = 0; R < n4.length; ++R)
                    for (var j = n4[R], U = 0; U < 3; ++U)
                      !isNaN(j[U]) && isFinite(j[U]) && (this.bounds[0][U] = Math.min(this.bounds[0][U], j[U]), this.bounds[1][U] = Math.max(this.bounds[1][U], j[U]));
                  var V = 0, H = 0, q2 = 0;
                  t:
                    for (R = 0; R < r5.length; ++R) {
                      var G = r5[R];
                      switch (G.length) {
                        case 1:
                          for (j = n4[Y = G[0]], U = 0; U < 3; ++U)
                            if (isNaN(j[U]) || !isFinite(j[U]))
                              continue t;
                          y2.push(j[0], j[1], j[2]), W = S2 ? S2[Y] : E2 ? E2[R] : L2, this.opacityscale && P2 ? a2.push(W[0], W[1], W[2], this.opacity * A((P2[Y] - D) / (z - D), this.opacityscale)) : 3 === W.length ? m3.push(W[0], W[1], W[2], this.opacity) : (m3.push(W[0], W[1], W[2], W[3] * this.opacity), W[3] < 1 && (this.hasAlpha = true)), X = C2 ? C2[Y] : P2 ? [(P2[Y] - D) / (z - D), 0] : O ? O[R] : I ? [(I[R] - D) / (z - D), 0] : [(j[2] - D) / (z - D), 0], x2.push(X[0], X[1]), B ? b2.push(B[Y]) : b2.push(N), _2.push(R), q2 += 1;
                          break;
                        case 2:
                          for (U = 0; U < 2; ++U) {
                            j = n4[Y = G[U]];
                            for (var Z = 0; Z < 3; ++Z)
                              if (isNaN(j[Z]) || !isFinite(j[Z]))
                                continue t;
                          }
                          for (U = 0; U < 2; ++U)
                            j = n4[Y = G[U]], p3.push(j[0], j[1], j[2]), W = S2 ? S2[Y] : E2 ? E2[R] : L2, this.opacityscale && P2 ? a2.push(W[0], W[1], W[2], this.opacity * A((P2[Y] - D) / (z - D), this.opacityscale)) : 3 === W.length ? d3.push(W[0], W[1], W[2], this.opacity) : (d3.push(W[0], W[1], W[2], W[3] * this.opacity), W[3] < 1 && (this.hasAlpha = true)), X = C2 ? C2[Y] : P2 ? [(P2[Y] - D) / (z - D), 0] : O ? O[R] : I ? [(I[R] - D) / (z - D), 0] : [(j[2] - D) / (z - D), 0], v2.push(X[0], X[1]), g3.push(R);
                          H += 1;
                          break;
                        case 3:
                          for (U = 0; U < 3; ++U)
                            for (j = n4[Y = G[U]], Z = 0; Z < 3; ++Z)
                              if (isNaN(j[Z]) || !isFinite(j[Z]))
                                continue t;
                          for (U = 0; U < 3; ++U) {
                            var Y, W, X, J;
                            j = n4[Y = G[2 - U]], i3.push(j[0], j[1], j[2]), (W = S2 ? S2[Y] : E2 ? E2[R] : L2) ? this.opacityscale && P2 ? a2.push(W[0], W[1], W[2], this.opacity * A((P2[Y] - D) / (z - D), this.opacityscale)) : 3 === W.length ? a2.push(W[0], W[1], W[2], this.opacity) : (a2.push(W[0], W[1], W[2], W[3] * this.opacity), W[3] < 1 && (this.hasAlpha = true)) : a2.push(0.5, 0.5, 0.5, 1), X = C2 ? C2[Y] : P2 ? [(P2[Y] - D) / (z - D), 0] : O ? O[R] : I ? [(I[R] - D) / (z - D), 0] : [(j[2] - D) / (z - D), 0], u2.push(X[0], X[1]), J = w3 ? w3[Y] : T2[R], l2.push(J[0], J[1], J[2]), h2.push(R);
                          }
                          V += 1;
                      }
                    }
                  this.pointCount = q2, this.edgeCount = H, this.triangleCount = V, this.pointPositions.update(y2), this.pointColors.update(m3), this.pointUVs.update(x2), this.pointSizes.update(b2), this.pointIds.update(new Uint32Array(_2)), this.edgePositions.update(p3), this.edgeColors.update(d3), this.edgeUVs.update(v2), this.edgeIds.update(new Uint32Array(g3)), this.trianglePositions.update(i3), this.triangleColors.update(a2), this.triangleUVs.update(u2), this.triangleNormals.update(l2), this.triangleIds.update(new Uint32Array(h2));
                }
              }, k.drawTransparent = k.draw = function(t5) {
                t5 = t5 || {};
                for (var e5 = this.gl, r5 = t5.model || w2, n4 = t5.view || w2, i3 = t5.projection || w2, a2 = [[-1e6, -1e6, -1e6], [1e6, 1e6, 1e6]], o2 = 0; o2 < 3; ++o2)
                  a2[0][o2] = Math.max(a2[0][o2], this.clipBounds[0][o2]), a2[1][o2] = Math.min(a2[1][o2], this.clipBounds[1][o2]);
                var s2 = { model: r5, view: n4, projection: i3, inverseModel: w2.slice(), clipBounds: a2, kambient: this.ambientLight, kdiffuse: this.diffuseLight, kspecular: this.specularLight, roughness: this.roughness, fresnel: this.fresnel, eyePosition: [0, 0, 0], lightPosition: [0, 0, 0], contourColor: this.contourColor, texture: 0 };
                s2.inverseModel = u(s2.inverseModel, s2.model), e5.disable(e5.CULL_FACE), this.texture.bind(0);
                var c2 = new Array(16);
                for (l(c2, s2.view, s2.model), l(c2, s2.projection, c2), u(c2, c2), o2 = 0; o2 < 3; ++o2)
                  s2.eyePosition[o2] = c2[12 + o2] / c2[15];
                var f3, h2 = c2[15];
                for (o2 = 0; o2 < 3; ++o2)
                  h2 += this.lightPosition[o2] * c2[4 * o2 + 3];
                for (o2 = 0; o2 < 3; ++o2) {
                  for (var p3 = c2[12 + o2], d3 = 0; d3 < 3; ++d3)
                    p3 += c2[4 * d3 + o2] * this.lightPosition[d3];
                  s2.lightPosition[o2] = p3 / h2;
                }
                this.triangleCount > 0 && ((f3 = this.triShader).bind(), f3.uniforms = s2, this.triangleVAO.bind(), e5.drawArrays(e5.TRIANGLES, 0, 3 * this.triangleCount), this.triangleVAO.unbind()), this.edgeCount > 0 && this.lineWidth > 0 && ((f3 = this.lineShader).bind(), f3.uniforms = s2, this.edgeVAO.bind(), e5.lineWidth(this.lineWidth * this.pixelRatio), e5.drawArrays(e5.LINES, 0, 2 * this.edgeCount), this.edgeVAO.unbind()), this.pointCount > 0 && ((f3 = this.pointShader).bind(), f3.uniforms = s2, this.pointVAO.bind(), e5.drawArrays(e5.POINTS, 0, this.pointCount), this.pointVAO.unbind()), this.contourEnable && this.contourCount > 0 && this.contourLineWidth > 0 && ((f3 = this.contourShader).bind(), f3.uniforms = s2, this.contourVAO.bind(), e5.drawArrays(e5.LINES, 0, this.contourCount), this.contourVAO.unbind());
              }, k.drawPick = function(t5) {
                t5 = t5 || {};
                for (var e5 = this.gl, r5 = t5.model || w2, n4 = t5.view || w2, i3 = t5.projection || w2, a2 = [[-1e6, -1e6, -1e6], [1e6, 1e6, 1e6]], o2 = 0; o2 < 3; ++o2)
                  a2[0][o2] = Math.max(a2[0][o2], this.clipBounds[0][o2]), a2[1][o2] = Math.min(a2[1][o2], this.clipBounds[1][o2]);
                this._model = [].slice.call(r5), this._view = [].slice.call(n4), this._projection = [].slice.call(i3), this._resolution = [e5.drawingBufferWidth, e5.drawingBufferHeight];
                var s2, l2 = { model: r5, view: n4, projection: i3, clipBounds: a2, pickId: this.pickId / 255 };
                (s2 = this.pickShader).bind(), s2.uniforms = l2, this.triangleCount > 0 && (this.triangleVAO.bind(), e5.drawArrays(e5.TRIANGLES, 0, 3 * this.triangleCount), this.triangleVAO.unbind()), this.edgeCount > 0 && (this.edgeVAO.bind(), e5.lineWidth(this.lineWidth * this.pixelRatio), e5.drawArrays(e5.LINES, 0, 2 * this.edgeCount), this.edgeVAO.unbind()), this.pointCount > 0 && ((s2 = this.pointPickShader).bind(), s2.uniforms = l2, this.pointVAO.bind(), e5.drawArrays(e5.POINTS, 0, this.pointCount), this.pointVAO.unbind());
              }, k.pick = function(t5) {
                if (!t5)
                  return null;
                if (t5.id !== this.pickId)
                  return null;
                for (var e5 = t5.value[0] + 256 * t5.value[1] + 65536 * t5.value[2], r5 = this.cells[e5], n4 = this.positions, i3 = new Array(r5.length), a2 = 0; a2 < r5.length; ++a2)
                  i3[a2] = n4[r5[a2]];
                var o2 = t5.coord[0], s2 = t5.coord[1];
                if (!this.pickVertex) {
                  var l2 = this.positions[r5[0]], u2 = this.positions[r5[1]], c2 = this.positions[r5[2]], f3 = [(l2[0] + u2[0] + c2[0]) / 3, (l2[1] + u2[1] + c2[1]) / 3, (l2[2] + u2[2] + c2[2]) / 3];
                  return { _cellCenter: true, position: [o2, s2], index: e5, cell: r5, cellId: e5, intensity: this.intensity[e5], dataCoordinate: f3 };
                }
                var h2 = v(i3, [o2 * this.pixelRatio, this._resolution[1] - s2 * this.pixelRatio], this._model, this._view, this._projection, this._resolution);
                if (!h2)
                  return null;
                var p3 = h2[2], d3 = 0;
                for (a2 = 0; a2 < r5.length; ++a2)
                  d3 += p3[a2] * this.intensity[r5[a2]];
                return { position: h2[1], index: r5[h2[0]], cell: r5, cellId: e5, intensity: d3, dataCoordinate: this.positions[r5[h2[0]]] };
              }, k.dispose = function() {
                this.texture.dispose(), this.triShader.dispose(), this.lineShader.dispose(), this.pointShader.dispose(), this.pickShader.dispose(), this.pointPickShader.dispose(), this.triangleVAO.dispose(), this.trianglePositions.dispose(), this.triangleColors.dispose(), this.triangleUVs.dispose(), this.triangleNormals.dispose(), this.triangleIds.dispose(), this.edgeVAO.dispose(), this.edgePositions.dispose(), this.edgeColors.dispose(), this.edgeUVs.dispose(), this.edgeIds.dispose(), this.pointVAO.dispose(), this.pointPositions.dispose(), this.pointColors.dispose(), this.pointUVs.dispose(), this.pointSizes.dispose(), this.pointIds.dispose(), this.contourVAO.dispose(), this.contourPositions.dispose(), this.contourShader.dispose();
              }, t4.exports = function(t5, e5) {
                1 === arguments.length && (t5 = (e5 = t5).gl);
                var r5 = t5.getExtension("OES_standard_derivatives") || t5.getExtension("MOZ_OES_standard_derivatives") || t5.getExtension("WEBKIT_OES_standard_derivatives");
                if (!r5)
                  throw new Error("derivatives not supported");
                var n4 = M(t5), s2 = S(t5), l2 = E(t5), u2 = L(t5), f3 = C(t5), h2 = P(t5), p3 = o(t5, c(new Uint8Array([255, 255, 255, 255]), [1, 1, 4]));
                p3.generateMipmap(), p3.minFilter = t5.LINEAR_MIPMAP_LINEAR, p3.magFilter = t5.LINEAR;
                var d3 = i2(t5), v2 = i2(t5), g3 = i2(t5), y2 = i2(t5), m3 = i2(t5), x2 = a(t5, [{ buffer: d3, type: t5.FLOAT, size: 3 }, { buffer: m3, type: t5.UNSIGNED_BYTE, size: 4, normalized: true }, { buffer: v2, type: t5.FLOAT, size: 4 }, { buffer: g3, type: t5.FLOAT, size: 2 }, { buffer: y2, type: t5.FLOAT, size: 3 }]), b2 = i2(t5), _2 = i2(t5), w3 = i2(t5), k2 = i2(t5), A2 = a(t5, [{ buffer: b2, type: t5.FLOAT, size: 3 }, { buffer: k2, type: t5.UNSIGNED_BYTE, size: 4, normalized: true }, { buffer: _2, type: t5.FLOAT, size: 4 }, { buffer: w3, type: t5.FLOAT, size: 2 }]), O = i2(t5), I = i2(t5), D = i2(t5), z = i2(t5), R = i2(t5), F = a(t5, [{ buffer: O, type: t5.FLOAT, size: 3 }, { buffer: R, type: t5.UNSIGNED_BYTE, size: 4, normalized: true }, { buffer: I, type: t5.FLOAT, size: 4 }, { buffer: D, type: t5.FLOAT, size: 2 }, { buffer: z, type: t5.FLOAT, size: 1 }]), B = i2(t5), N = a(t5, [{ buffer: B, type: t5.FLOAT, size: 3 }]), j = new T(t5, p3, n4, s2, l2, u2, f3, h2, d3, m3, v2, g3, y2, x2, b2, k2, _2, w3, A2, O, R, I, D, z, F, B, N);
                return j.update(e5), j;
              };
            }, 4554: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = t5.gl;
                return new o(t5, n3(e5, [0, 0, 0, 1, 1, 0, 1, 1]), i2(e5, a.boxVert, a.lineFrag));
              };
              var n3 = r4(5827), i2 = r4(5158), a = r4(2709);
              function o(t5, e5, r5) {
                this.plot = t5, this.vbo = e5, this.shader = r5;
              }
              var s, l, u = o.prototype;
              u.bind = function() {
                var t5 = this.shader;
                this.vbo.bind(), this.shader.bind(), t5.attributes.coord.pointer(), t5.uniforms.screenBox = this.plot.screenBox;
              }, u.drawBox = (s = [0, 0], l = [0, 0], function(t5, e5, r5, n4, i3) {
                var a2 = this.plot, o2 = this.shader, u2 = a2.gl;
                s[0] = t5, s[1] = e5, l[0] = r5, l[1] = n4, o2.uniforms.lo = s, o2.uniforms.hi = l, o2.uniforms.color = i3, u2.drawArrays(u2.TRIANGLE_STRIP, 0, 4);
              }), u.dispose = function() {
                this.vbo.dispose(), this.shader.dispose();
              };
            }, 3016: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = t5.gl;
                return new s(t5, n3(e5), i2(e5, o.gridVert, o.gridFrag), i2(e5, o.tickVert, o.gridFrag));
              };
              var n3 = r4(5827), i2 = r4(5158), a = r4(5070), o = r4(2709);
              function s(t5, e5, r5, n4) {
                this.plot = t5, this.vbo = e5, this.shader = r5, this.tickShader = n4, this.ticks = [[], []];
              }
              function l(t5, e5) {
                return t5 - e5;
              }
              var u, c, f2, h, p2, d2 = s.prototype;
              d2.draw = (u = [0, 0], c = [0, 0], f2 = [0, 0], function() {
                for (var t5 = this.plot, e5 = this.vbo, r5 = this.shader, n4 = this.ticks, i3 = t5.gl, a2 = t5._tickBounds, o2 = t5.dataBox, s2 = t5.viewBox, l2 = t5.gridLineWidth, h2 = t5.gridLineColor, p3 = t5.gridLineEnable, d3 = t5.pixelRatio, v = 0; v < 2; ++v) {
                  var g2 = a2[v], y = a2[v + 2] - g2, m2 = 0.5 * (o2[v + 2] + o2[v]), x = o2[v + 2] - o2[v];
                  c[v] = 2 * y / x, u[v] = 2 * (g2 - m2) / x;
                }
                r5.bind(), e5.bind(), r5.attributes.dataCoord.pointer(), r5.uniforms.dataShift = u, r5.uniforms.dataScale = c;
                var b = 0;
                for (v = 0; v < 2; ++v) {
                  f2[0] = f2[1] = 0, f2[v] = 1, r5.uniforms.dataAxis = f2, r5.uniforms.lineWidth = l2[v] / (s2[v + 2] - s2[v]) * d3, r5.uniforms.color = h2[v];
                  var _ = 6 * n4[v].length;
                  p3[v] && _ && i3.drawArrays(i3.TRIANGLES, b, _), b += _;
                }
              }), d2.drawTickMarks = function() {
                var t5 = [0, 0], e5 = [0, 0], r5 = [1, 0], n4 = [0, 1], i3 = [0, 0], o2 = [0, 0];
                return function() {
                  for (var s2 = this.plot, u2 = this.vbo, c2 = this.tickShader, f3 = this.ticks, h2 = s2.gl, p3 = s2._tickBounds, d3 = s2.dataBox, v = s2.viewBox, g2 = s2.pixelRatio, y = s2.screenBox, m2 = y[2] - y[0], x = y[3] - y[1], b = v[2] - v[0], _ = v[3] - v[1], w2 = 0; w2 < 2; ++w2) {
                    var T = p3[w2], k = p3[w2 + 2] - T, A = 0.5 * (d3[w2 + 2] + d3[w2]), M = d3[w2 + 2] - d3[w2];
                    e5[w2] = 2 * k / M, t5[w2] = 2 * (T - A) / M;
                  }
                  e5[0] *= b / m2, t5[0] *= b / m2, e5[1] *= _ / x, t5[1] *= _ / x, c2.bind(), u2.bind(), c2.attributes.dataCoord.pointer();
                  var S = c2.uniforms;
                  S.dataShift = t5, S.dataScale = e5;
                  var E = s2.tickMarkLength, L = s2.tickMarkWidth, C = s2.tickMarkColor, P = 6 * f3[0].length, O = Math.min(a.ge(f3[0], (d3[0] - p3[0]) / (p3[2] - p3[0]), l), f3[0].length), I = Math.min(a.gt(f3[0], (d3[2] - p3[0]) / (p3[2] - p3[0]), l), f3[0].length), D = 0 + 6 * O, z = 6 * Math.max(0, I - O), R = Math.min(a.ge(f3[1], (d3[1] - p3[1]) / (p3[3] - p3[1]), l), f3[1].length), F = Math.min(a.gt(f3[1], (d3[3] - p3[1]) / (p3[3] - p3[1]), l), f3[1].length), B = P + 6 * R, N = 6 * Math.max(0, F - R);
                  i3[0] = 2 * (v[0] - E[1]) / m2 - 1, i3[1] = (v[3] + v[1]) / x - 1, o2[0] = E[1] * g2 / m2, o2[1] = L[1] * g2 / x, N && (S.color = C[1], S.tickScale = o2, S.dataAxis = n4, S.screenOffset = i3, h2.drawArrays(h2.TRIANGLES, B, N)), i3[0] = (v[2] + v[0]) / m2 - 1, i3[1] = 2 * (v[1] - E[0]) / x - 1, o2[0] = L[0] * g2 / m2, o2[1] = E[0] * g2 / x, z && (S.color = C[0], S.tickScale = o2, S.dataAxis = r5, S.screenOffset = i3, h2.drawArrays(h2.TRIANGLES, D, z)), i3[0] = 2 * (v[2] + E[3]) / m2 - 1, i3[1] = (v[3] + v[1]) / x - 1, o2[0] = E[3] * g2 / m2, o2[1] = L[3] * g2 / x, N && (S.color = C[3], S.tickScale = o2, S.dataAxis = n4, S.screenOffset = i3, h2.drawArrays(h2.TRIANGLES, B, N)), i3[0] = (v[2] + v[0]) / m2 - 1, i3[1] = 2 * (v[3] + E[2]) / x - 1, o2[0] = L[2] * g2 / m2, o2[1] = E[2] * g2 / x, z && (S.color = C[2], S.tickScale = o2, S.dataAxis = r5, S.screenOffset = i3, h2.drawArrays(h2.TRIANGLES, D, z));
                };
              }(), d2.update = (h = [1, 1, -1, -1, 1, -1], p2 = [1, -1, 1, 1, -1, -1], function(t5) {
                for (var e5 = t5.ticks, r5 = t5.bounds, n4 = new Float32Array(18 * (e5[0].length + e5[1].length)), i3 = (this.plot.zeroLineEnable, 0), a2 = [[], []], o2 = 0; o2 < 2; ++o2)
                  for (var s2 = a2[o2], l2 = e5[o2], u2 = r5[o2], c2 = r5[o2 + 2], f3 = 0; f3 < l2.length; ++f3) {
                    var d3 = (l2[f3].x - u2) / (c2 - u2);
                    s2.push(d3);
                    for (var v = 0; v < 6; ++v)
                      n4[i3++] = d3, n4[i3++] = h[v], n4[i3++] = p2[v];
                  }
                this.ticks = a2, this.vbo.update(n4);
              }), d2.dispose = function() {
                this.vbo.dispose(), this.shader.dispose(), this.tickShader.dispose();
              };
            }, 1154: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = t5.gl;
                return new o(t5, n3(e5, [-1, -1, -1, 1, 1, -1, 1, 1]), i2(e5, a.lineVert, a.lineFrag));
              };
              var n3 = r4(5827), i2 = r4(5158), a = r4(2709);
              function o(t5, e5, r5) {
                this.plot = t5, this.vbo = e5, this.shader = r5;
              }
              var s, l, u = o.prototype;
              u.bind = function() {
                var t5 = this.shader;
                this.vbo.bind(), this.shader.bind(), t5.attributes.coord.pointer(), t5.uniforms.screenBox = this.plot.screenBox;
              }, u.drawLine = (s = [0, 0], l = [0, 0], function(t5, e5, r5, n4, i3, a2) {
                var o2 = this.plot, u2 = this.shader, c = o2.gl;
                s[0] = t5, s[1] = e5, l[0] = r5, l[1] = n4, u2.uniforms.start = s, u2.uniforms.end = l, u2.uniforms.width = i3 * o2.pixelRatio, u2.uniforms.color = a2, c.drawArrays(c.TRIANGLE_STRIP, 0, 4);
              }), u.dispose = function() {
                this.vbo.dispose(), this.shader.dispose();
              };
            }, 2709: function(t4, e4, r4) {
              var n3 = r4(6832), i2 = n3(["precision lowp float;\n#define GLSLIFY 1\nuniform vec4 color;\nvoid main() {\n  gl_FragColor = vec4(color.xyz * color.w, color.w);\n}\n"]);
              t4.exports = { lineVert: n3(["precision mediump float;\n#define GLSLIFY 1\n\nattribute vec2 coord;\n\nuniform vec4 screenBox;\nuniform vec2 start, end;\nuniform float width;\n\nvec2 perp(vec2 v) {\n  return vec2(v.y, -v.x);\n}\n\nvec2 screen(vec2 v) {\n  return 2.0 * (v - screenBox.xy) / (screenBox.zw - screenBox.xy) - 1.0;\n}\n\nvoid main() {\n  vec2 delta = normalize(perp(start - end));\n  vec2 offset = mix(start, end, 0.5 * (coord.y+1.0));\n  gl_Position = vec4(screen(offset + 0.5 * width * delta * coord.x), 0, 1);\n}\n"]), lineFrag: i2, textVert: n3(["#define GLSLIFY 1\nattribute vec3 textCoordinate;\n\nuniform vec2 dataScale, dataShift, dataAxis, screenOffset, textScale;\nuniform float angle;\n\nvoid main() {\n  float dataOffset  = textCoordinate.z;\n  vec2 glyphOffset  = textCoordinate.xy;\n  mat2 glyphMatrix = mat2(cos(angle), sin(angle), -sin(angle), cos(angle));\n  vec2 screenCoordinate = dataAxis * (dataScale * dataOffset + dataShift) +\n    glyphMatrix * glyphOffset * textScale + screenOffset;\n  gl_Position = vec4(screenCoordinate, 0, 1);\n}\n"]), textFrag: i2, gridVert: n3(["precision mediump float;\n#define GLSLIFY 1\n\nattribute vec3 dataCoord;\n\nuniform vec2 dataAxis, dataShift, dataScale;\nuniform float lineWidth;\n\nvoid main() {\n  vec2 pos = dataAxis * (dataScale * dataCoord.x + dataShift);\n  pos += 10.0 * dataCoord.y * vec2(dataAxis.y, -dataAxis.x) + dataCoord.z * lineWidth;\n  gl_Position = vec4(pos, 0, 1);\n}\n"]), gridFrag: i2, boxVert: n3(["precision mediump float;\n#define GLSLIFY 1\n\nattribute vec2 coord;\n\nuniform vec4 screenBox;\nuniform vec2 lo, hi;\n\nvec2 screen(vec2 v) {\n  return 2.0 * (v - screenBox.xy) / (screenBox.zw - screenBox.xy) - 1.0;\n}\n\nvoid main() {\n  gl_Position = vec4(screen(mix(lo, hi, coord)), 0, 1);\n}\n"]), tickVert: n3(["precision mediump float;\n#define GLSLIFY 1\n\nattribute vec3 dataCoord;\n\nuniform vec2 dataAxis, dataShift, dataScale, screenOffset, tickScale;\n\nvoid main() {\n  vec2 pos = dataAxis * (dataScale * dataCoord.x + dataShift);\n  gl_Position = vec4(pos + tickScale*dataCoord.yz + screenOffset, 0, 1);\n}\n"]) };
            }, 5613: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = t5.gl;
                return new l(t5, n3(e5), i2(e5, s.textVert, s.textFrag));
              };
              var n3 = r4(5827), i2 = r4(5158), a = r4(6946), o = r4(5070), s = r4(2709);
              function l(t5, e5, r5) {
                this.plot = t5, this.vbo = e5, this.shader = r5, this.tickOffset = [[], []], this.tickX = [[], []], this.labelOffset = [0, 0], this.labelCount = [0, 0];
              }
              var u, c, f2, h, p2, d2, v = l.prototype;
              v.drawTicks = (u = [0, 0], c = [0, 0], f2 = [0, 0], function(t5) {
                var e5 = this.plot, r5 = this.shader, n4 = this.tickX[t5], i3 = this.tickOffset[t5], a2 = e5.gl, s2 = e5.viewBox, l2 = e5.dataBox, h2 = e5.screenBox, p3 = e5.pixelRatio, d3 = e5.tickEnable, v2 = e5.tickPad, g2 = e5.tickColor, y = e5.tickAngle, m2 = e5.labelEnable, x = e5.labelPad, b = e5.labelColor, _ = e5.labelAngle, w2 = this.labelOffset[t5], T = this.labelCount[t5], k = o.lt(n4, l2[t5]), A = o.le(n4, l2[t5 + 2]);
                u[0] = u[1] = 0, u[t5] = 1, c[t5] = (s2[2 + t5] + s2[t5]) / (h2[2 + t5] - h2[t5]) - 1;
                var M = 2 / h2[2 + (1 ^ t5)] - h2[1 ^ t5];
                c[1 ^ t5] = M * s2[1 ^ t5] - 1, d3[t5] && (c[1 ^ t5] -= M * p3 * v2[t5], k < A && i3[A] > i3[k] && (r5.uniforms.dataAxis = u, r5.uniforms.screenOffset = c, r5.uniforms.color = g2[t5], r5.uniforms.angle = y[t5], a2.drawArrays(a2.TRIANGLES, i3[k], i3[A] - i3[k]))), m2[t5] && T && (c[1 ^ t5] -= M * p3 * x[t5], r5.uniforms.dataAxis = f2, r5.uniforms.screenOffset = c, r5.uniforms.color = b[t5], r5.uniforms.angle = _[t5], a2.drawArrays(a2.TRIANGLES, w2, T)), c[1 ^ t5] = M * s2[2 + (1 ^ t5)] - 1, d3[t5 + 2] && (c[1 ^ t5] += M * p3 * v2[t5 + 2], k < A && i3[A] > i3[k] && (r5.uniforms.dataAxis = u, r5.uniforms.screenOffset = c, r5.uniforms.color = g2[t5 + 2], r5.uniforms.angle = y[t5 + 2], a2.drawArrays(a2.TRIANGLES, i3[k], i3[A] - i3[k]))), m2[t5 + 2] && T && (c[1 ^ t5] += M * p3 * x[t5 + 2], r5.uniforms.dataAxis = f2, r5.uniforms.screenOffset = c, r5.uniforms.color = b[t5 + 2], r5.uniforms.angle = _[t5 + 2], a2.drawArrays(a2.TRIANGLES, w2, T));
              }), v.drawTitle = function() {
                var t5 = [0, 0], e5 = [0, 0];
                return function() {
                  var r5 = this.plot, n4 = this.shader, i3 = r5.gl, a2 = r5.screenBox, o2 = r5.titleCenter, s2 = r5.titleAngle, l2 = r5.titleColor, u2 = r5.pixelRatio;
                  if (this.titleCount) {
                    for (var c2 = 0; c2 < 2; ++c2)
                      e5[c2] = 2 * (o2[c2] * u2 - a2[c2]) / (a2[2 + c2] - a2[c2]) - 1;
                    n4.bind(), n4.uniforms.dataAxis = t5, n4.uniforms.screenOffset = e5, n4.uniforms.angle = s2, n4.uniforms.color = l2, i3.drawArrays(i3.TRIANGLES, this.titleOffset, this.titleCount);
                  }
                };
              }(), v.bind = (h = [0, 0], p2 = [0, 0], d2 = [0, 0], function() {
                var t5 = this.plot, e5 = this.shader, r5 = t5._tickBounds, n4 = t5.dataBox, i3 = t5.screenBox, a2 = t5.viewBox;
                e5.bind();
                for (var o2 = 0; o2 < 2; ++o2) {
                  var s2 = r5[o2], l2 = r5[o2 + 2] - s2, u2 = 0.5 * (n4[o2 + 2] + n4[o2]), c2 = n4[o2 + 2] - n4[o2], f3 = a2[o2], v2 = a2[o2 + 2] - f3, g2 = i3[o2], y = i3[o2 + 2] - g2;
                  p2[o2] = 2 * l2 / c2 * v2 / y, h[o2] = 2 * (s2 - u2) / c2 * v2 / y;
                }
                d2[1] = 2 * t5.pixelRatio / (i3[3] - i3[1]), d2[0] = d2[1] * (i3[3] - i3[1]) / (i3[2] - i3[0]), e5.uniforms.dataScale = p2, e5.uniforms.dataShift = h, e5.uniforms.textScale = d2, this.vbo.bind(), e5.attributes.textCoordinate.pointer();
              }), v.update = function(t5) {
                var e5, r5, n4, i3, o2, s2 = [], l2 = t5.ticks, u2 = t5.bounds;
                for (o2 = 0; o2 < 2; ++o2) {
                  var c2 = [Math.floor(s2.length / 3)], f3 = [-1 / 0], h2 = l2[o2];
                  for (e5 = 0; e5 < h2.length; ++e5) {
                    var p3 = h2[e5], d3 = p3.x, v2 = p3.text, g2 = p3.font || "sans-serif";
                    i3 = p3.fontSize || 12;
                    for (var y = 1 / (u2[o2 + 2] - u2[o2]), m2 = u2[o2], x = v2.split("\n"), b = 0; b < x.length; b++)
                      for (n4 = a(g2, x[b]).data, r5 = 0; r5 < n4.length; r5 += 2)
                        s2.push(n4[r5] * i3, -n4[r5 + 1] * i3 - b * i3 * 1.2, (d3 - m2) * y);
                    c2.push(Math.floor(s2.length / 3)), f3.push(d3);
                  }
                  this.tickOffset[o2] = c2, this.tickX[o2] = f3;
                }
                for (o2 = 0; o2 < 2; ++o2) {
                  for (this.labelOffset[o2] = Math.floor(s2.length / 3), n4 = a(t5.labelFont[o2], t5.labels[o2], { textAlign: "center" }).data, i3 = t5.labelSize[o2], e5 = 0; e5 < n4.length; e5 += 2)
                    s2.push(n4[e5] * i3, -n4[e5 + 1] * i3, 0);
                  this.labelCount[o2] = Math.floor(s2.length / 3) - this.labelOffset[o2];
                }
                for (this.titleOffset = Math.floor(s2.length / 3), n4 = a(t5.titleFont, t5.title).data, i3 = t5.titleSize, e5 = 0; e5 < n4.length; e5 += 2)
                  s2.push(n4[e5] * i3, -n4[e5 + 1] * i3, 0);
                this.titleCount = Math.floor(s2.length / 3) - this.titleOffset, this.vbo.update(s2);
              }, v.dispose = function() {
                this.vbo.dispose(), this.shader.dispose();
              };
            }, 2117: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = t5.gl, r5 = new l(e5, n3(e5, [e5.drawingBufferWidth, e5.drawingBufferHeight]));
                return r5.grid = i2(r5), r5.text = a(r5), r5.line = o(r5), r5.box = s(r5), r5.update(t5), r5;
              };
              var n3 = r4(2611), i2 = r4(3016), a = r4(5613), o = r4(1154), s = r4(4554);
              function l(t5, e5) {
                this.gl = t5, this.pickBuffer = e5, this.screenBox = [0, 0, t5.drawingBufferWidth, t5.drawingBufferHeight], this.viewBox = [0, 0, 0, 0], this.dataBox = [-10, -10, 10, 10], this.gridLineEnable = [true, true], this.gridLineWidth = [1, 1], this.gridLineColor = [[0, 0, 0, 1], [0, 0, 0, 1]], this.pixelRatio = 1, this.tickMarkLength = [0, 0, 0, 0], this.tickMarkWidth = [0, 0, 0, 0], this.tickMarkColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.tickPad = [15, 15, 15, 15], this.tickAngle = [0, 0, 0, 0], this.tickEnable = [true, true, true, true], this.tickColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.labelPad = [15, 15, 15, 15], this.labelAngle = [0, Math.PI / 2, 0, 3 * Math.PI / 2], this.labelEnable = [true, true, true, true], this.labelColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.titleCenter = [0, 0], this.titleEnable = true, this.titleAngle = 0, this.titleColor = [0, 0, 0, 1], this.borderColor = [0, 0, 0, 0], this.backgroundColor = [0, 0, 0, 0], this.zeroLineEnable = [true, true], this.zeroLineWidth = [4, 4], this.zeroLineColor = [[0, 0, 0, 1], [0, 0, 0, 1]], this.borderLineEnable = [true, true, true, true], this.borderLineWidth = [2, 2, 2, 2], this.borderLineColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.grid = null, this.text = null, this.line = null, this.box = null, this.objects = [], this.overlays = [], this._tickBounds = [1 / 0, 1 / 0, -1 / 0, -1 / 0], this.static = false, this.dirty = false, this.pickDirty = false, this.pickDelay = 120, this.pickRadius = 10, this._pickTimeout = null, this._drawPick = this.drawPick.bind(this), this._depthCounter = 0;
              }
              var u = l.prototype;
              function c(t5) {
                for (var e5 = t5.slice(), r5 = 0; r5 < e5.length; ++r5)
                  e5[r5] = e5[r5].slice();
                return e5;
              }
              function f2(t5, e5) {
                return t5.x - e5.x;
              }
              u.setDirty = function() {
                this.dirty = this.pickDirty = true;
              }, u.setOverlayDirty = function() {
                this.dirty = true;
              }, u.nextDepthValue = function() {
                return this._depthCounter++ / 65536;
              }, u.draw = function() {
                var t5 = this.gl, e5 = this.screenBox, r5 = this.viewBox, n4 = this.dataBox, i3 = this.pixelRatio, a2 = this.grid, o2 = this.line, s2 = this.text, l2 = this.objects;
                if (this._depthCounter = 0, this.pickDirty && (this._pickTimeout && clearTimeout(this._pickTimeout), this.pickDirty = false, this._pickTimeout = setTimeout(this._drawPick, this.pickDelay)), this.dirty) {
                  if (this.dirty = false, t5.bindFramebuffer(t5.FRAMEBUFFER, null), t5.enable(t5.SCISSOR_TEST), t5.disable(t5.DEPTH_TEST), t5.depthFunc(t5.LESS), t5.depthMask(false), t5.enable(t5.BLEND), t5.blendEquation(t5.FUNC_ADD, t5.FUNC_ADD), t5.blendFunc(t5.ONE, t5.ONE_MINUS_SRC_ALPHA), this.borderColor) {
                    t5.scissor(e5[0], e5[1], e5[2] - e5[0], e5[3] - e5[1]);
                    var u2 = this.borderColor;
                    t5.clearColor(u2[0] * u2[3], u2[1] * u2[3], u2[2] * u2[3], u2[3]), t5.clear(t5.COLOR_BUFFER_BIT | t5.DEPTH_BUFFER_BIT);
                  }
                  t5.scissor(r5[0], r5[1], r5[2] - r5[0], r5[3] - r5[1]), t5.viewport(r5[0], r5[1], r5[2] - r5[0], r5[3] - r5[1]);
                  var c2 = this.backgroundColor;
                  t5.clearColor(c2[0] * c2[3], c2[1] * c2[3], c2[2] * c2[3], c2[3]), t5.clear(t5.COLOR_BUFFER_BIT), a2.draw();
                  var f3 = this.zeroLineEnable, h = this.zeroLineColor, p2 = this.zeroLineWidth;
                  if (f3[0] || f3[1]) {
                    o2.bind();
                    for (var d2 = 0; d2 < 2; ++d2)
                      if (f3[d2] && n4[d2] <= 0 && n4[d2 + 2] >= 0) {
                        var v = e5[d2] - n4[d2] * (e5[d2 + 2] - e5[d2]) / (n4[d2 + 2] - n4[d2]);
                        0 === d2 ? o2.drawLine(v, e5[1], v, e5[3], p2[d2], h[d2]) : o2.drawLine(e5[0], v, e5[2], v, p2[d2], h[d2]);
                      }
                  }
                  for (d2 = 0; d2 < l2.length; ++d2)
                    l2[d2].draw();
                  t5.viewport(e5[0], e5[1], e5[2] - e5[0], e5[3] - e5[1]), t5.scissor(e5[0], e5[1], e5[2] - e5[0], e5[3] - e5[1]), this.grid.drawTickMarks(), o2.bind();
                  var g2 = this.borderLineEnable, y = this.borderLineWidth, m2 = this.borderLineColor;
                  for (g2[1] && o2.drawLine(r5[0], r5[1] - 0.5 * y[1] * i3, r5[0], r5[3] + 0.5 * y[3] * i3, y[1], m2[1]), g2[0] && o2.drawLine(r5[0] - 0.5 * y[0] * i3, r5[1], r5[2] + 0.5 * y[2] * i3, r5[1], y[0], m2[0]), g2[3] && o2.drawLine(r5[2], r5[1] - 0.5 * y[1] * i3, r5[2], r5[3] + 0.5 * y[3] * i3, y[3], m2[3]), g2[2] && o2.drawLine(r5[0] - 0.5 * y[0] * i3, r5[3], r5[2] + 0.5 * y[2] * i3, r5[3], y[2], m2[2]), s2.bind(), d2 = 0; d2 < 2; ++d2)
                    s2.drawTicks(d2);
                  this.titleEnable && s2.drawTitle();
                  var x = this.overlays;
                  for (d2 = 0; d2 < x.length; ++d2)
                    x[d2].draw();
                  t5.disable(t5.SCISSOR_TEST), t5.disable(t5.BLEND), t5.depthMask(true);
                }
              }, u.drawPick = function() {
                if (!this.static) {
                  var t5 = this.pickBuffer;
                  this.gl, this._pickTimeout = null, t5.begin();
                  for (var e5 = 1, r5 = this.objects, n4 = 0; n4 < r5.length; ++n4)
                    e5 = r5[n4].drawPick(e5);
                  t5.end();
                }
              }, u.pick = function(t5, e5) {
                if (!this.static) {
                  var r5 = this.pixelRatio, n4 = this.pickPixelRatio, i3 = this.viewBox, a2 = 0 | Math.round((t5 - i3[0] / r5) * n4), o2 = 0 | Math.round((e5 - i3[1] / r5) * n4), s2 = this.pickBuffer.query(a2, o2, this.pickRadius);
                  if (!s2)
                    return null;
                  for (var l2 = s2.id + (s2.value[0] << 8) + (s2.value[1] << 16) + (s2.value[2] << 24), u2 = this.objects, c2 = 0; c2 < u2.length; ++c2) {
                    var f3 = u2[c2].pick(a2, o2, l2);
                    if (f3)
                      return f3;
                  }
                  return null;
                }
              }, u.setScreenBox = function(t5) {
                var e5 = this.screenBox, r5 = this.pixelRatio;
                e5[0] = 0 | Math.round(t5[0] * r5), e5[1] = 0 | Math.round(t5[1] * r5), e5[2] = 0 | Math.round(t5[2] * r5), e5[3] = 0 | Math.round(t5[3] * r5), this.setDirty();
              }, u.setDataBox = function(t5) {
                var e5 = this.dataBox;
                (e5[0] !== t5[0] || e5[1] !== t5[1] || e5[2] !== t5[2] || e5[3] !== t5[3]) && (e5[0] = t5[0], e5[1] = t5[1], e5[2] = t5[2], e5[3] = t5[3], this.setDirty());
              }, u.setViewBox = function(t5) {
                var e5 = this.pixelRatio, r5 = this.viewBox;
                r5[0] = 0 | Math.round(t5[0] * e5), r5[1] = 0 | Math.round(t5[1] * e5), r5[2] = 0 | Math.round(t5[2] * e5), r5[3] = 0 | Math.round(t5[3] * e5);
                var n4 = this.pickPixelRatio;
                this.pickBuffer.shape = [0 | Math.round((t5[2] - t5[0]) * n4), 0 | Math.round((t5[3] - t5[1]) * n4)], this.setDirty();
              }, u.update = function(t5) {
                t5 = t5 || {};
                var e5 = this.gl;
                this.pixelRatio = t5.pixelRatio || 1;
                var r5 = this.pixelRatio;
                this.pickPixelRatio = Math.max(r5, 1), this.setScreenBox(t5.screenBox || [0, 0, e5.drawingBufferWidth / r5, e5.drawingBufferHeight / r5]), this.screenBox, this.setViewBox(t5.viewBox || [0.125 * (this.screenBox[2] - this.screenBox[0]) / r5, 0.125 * (this.screenBox[3] - this.screenBox[1]) / r5, 0.875 * (this.screenBox[2] - this.screenBox[0]) / r5, 0.875 * (this.screenBox[3] - this.screenBox[1]) / r5]);
                var n4 = this.viewBox, i3 = (n4[2] - n4[0]) / (n4[3] - n4[1]);
                this.setDataBox(t5.dataBox || [-10, -10 / i3, 10, 10 / i3]), this.borderColor = false !== t5.borderColor && (t5.borderColor || [0, 0, 0, 0]).slice(), this.backgroundColor = (t5.backgroundColor || [0, 0, 0, 0]).slice(), this.gridLineEnable = (t5.gridLineEnable || [true, true]).slice(), this.gridLineWidth = (t5.gridLineWidth || [1, 1]).slice(), this.gridLineColor = c(t5.gridLineColor || [[0.5, 0.5, 0.5, 1], [0.5, 0.5, 0.5, 1]]), this.zeroLineEnable = (t5.zeroLineEnable || [true, true]).slice(), this.zeroLineWidth = (t5.zeroLineWidth || [4, 4]).slice(), this.zeroLineColor = c(t5.zeroLineColor || [[0, 0, 0, 1], [0, 0, 0, 1]]), this.tickMarkLength = (t5.tickMarkLength || [0, 0, 0, 0]).slice(), this.tickMarkWidth = (t5.tickMarkWidth || [0, 0, 0, 0]).slice(), this.tickMarkColor = c(t5.tickMarkColor || [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]]), this.titleCenter = (t5.titleCenter || [0.5 * (n4[0] + n4[2]) / r5, (n4[3] + 120) / r5]).slice(), this.titleEnable = !("titleEnable" in t5) || !!t5.titleEnable, this.titleAngle = t5.titleAngle || 0, this.titleColor = (t5.titleColor || [0, 0, 0, 1]).slice(), this.labelPad = (t5.labelPad || [15, 15, 15, 15]).slice(), this.labelAngle = (t5.labelAngle || [0, Math.PI / 2, 0, 3 * Math.PI / 2]).slice(), this.labelEnable = (t5.labelEnable || [true, true, true, true]).slice(), this.labelColor = c(t5.labelColor || [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]]), this.tickPad = (t5.tickPad || [15, 15, 15, 15]).slice(), this.tickAngle = (t5.tickAngle || [0, 0, 0, 0]).slice(), this.tickEnable = (t5.tickEnable || [true, true, true, true]).slice(), this.tickColor = c(t5.tickColor || [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]]), this.borderLineEnable = (t5.borderLineEnable || [true, true, true, true]).slice(), this.borderLineWidth = (t5.borderLineWidth || [2, 2, 2, 2]).slice(), this.borderLineColor = c(t5.borderLineColor || [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]]);
                var a2 = t5.ticks || [[], []], o2 = this._tickBounds;
                o2[0] = o2[1] = 1 / 0, o2[2] = o2[3] = -1 / 0;
                for (var s2 = 0; s2 < 2; ++s2) {
                  var l2 = a2[s2].slice(0);
                  0 !== l2.length && (l2.sort(f2), o2[s2] = Math.min(o2[s2], l2[0].x), o2[s2 + 2] = Math.max(o2[s2 + 2], l2[l2.length - 1].x));
                }
                this.grid.update({ bounds: o2, ticks: a2 }), this.text.update({ bounds: o2, ticks: a2, labels: t5.labels || ["x", "y"], labelSize: t5.labelSize || [12, 12], labelFont: t5.labelFont || ["sans-serif", "sans-serif"], title: t5.title || "", titleSize: t5.titleSize || 18, titleFont: t5.titleFont || "sans-serif" }), this.static = !!t5.static, this.setDirty();
              }, u.dispose = function() {
                this.box.dispose(), this.grid.dispose(), this.text.dispose(), this.line.dispose();
                for (var t5 = this.objects.length - 1; t5 >= 0; --t5)
                  this.objects[t5].dispose();
                for (this.objects.length = 0, t5 = this.overlays.length - 1; t5 >= 0; --t5)
                  this.overlays[t5].dispose();
                this.overlays.length = 0, this.gl = null;
              }, u.addObject = function(t5) {
                this.objects.indexOf(t5) < 0 && (this.objects.push(t5), this.setDirty());
              }, u.removeObject = function(t5) {
                for (var e5 = this.objects, r5 = 0; r5 < e5.length; ++r5)
                  if (e5[r5] === t5) {
                    e5.splice(r5, 1), this.setDirty();
                    break;
                  }
              }, u.addOverlay = function(t5) {
                this.overlays.indexOf(t5) < 0 && (this.overlays.push(t5), this.setOverlayDirty());
              }, u.removeOverlay = function(t5) {
                for (var e5 = this.overlays, r5 = 0; r5 < e5.length; ++r5)
                  if (e5[r5] === t5) {
                    e5.splice(r5, 1), this.setOverlayDirty();
                    break;
                  }
              };
            }, 4296: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                t5 = t5 || document.body;
                var r5 = [0.01, 1 / 0];
                "distanceLimits" in (e5 = e5 || {}) && (r5[0] = e5.distanceLimits[0], r5[1] = e5.distanceLimits[1]), "zoomMin" in e5 && (r5[0] = e5.zoomMin), "zoomMax" in e5 && (r5[1] = e5.zoomMax);
                var u = i2({ center: e5.center || [0, 0, 0], up: e5.up || [0, 1, 0], eye: e5.eye || [0, 0, 10], mode: e5.mode || "orbit", distanceLimits: r5 }), c = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], f2 = 0, h = t5.clientWidth, p2 = t5.clientHeight, d2 = { keyBindingMode: "rotate", enableWheel: true, view: u, element: t5, delay: e5.delay || 16, rotateSpeed: e5.rotateSpeed || 1, zoomSpeed: e5.zoomSpeed || 1, translateSpeed: e5.translateSpeed || 1, flipX: !!e5.flipX, flipY: !!e5.flipY, modes: u.modes, _ortho: e5._ortho || e5.projection && "orthographic" === e5.projection.type || false, tick: function() {
                  var e6 = n3(), r6 = this.delay, i3 = e6 - 2 * r6;
                  u.idle(e6 - r6), u.recalcMatrix(i3), u.flush(e6 - (100 + 2 * r6));
                  for (var a2 = true, o2 = u.computedMatrix, s2 = 0; s2 < 16; ++s2)
                    a2 = a2 && c[s2] === o2[s2], c[s2] = o2[s2];
                  var l2 = t5.clientWidth === h && t5.clientHeight === p2;
                  return h = t5.clientWidth, p2 = t5.clientHeight, a2 ? !l2 : (f2 = Math.exp(u.computedRadius[0]), true);
                }, lookAt: function(t6, e6, r6) {
                  u.lookAt(u.lastT(), t6, e6, r6);
                }, rotate: function(t6, e6, r6) {
                  u.rotate(u.lastT(), t6, e6, r6);
                }, pan: function(t6, e6, r6) {
                  u.pan(u.lastT(), t6, e6, r6);
                }, translate: function(t6, e6, r6) {
                  u.translate(u.lastT(), t6, e6, r6);
                } };
                return Object.defineProperties(d2, { matrix: { get: function() {
                  return u.computedMatrix;
                }, set: function(t6) {
                  return u.setMatrix(u.lastT(), t6), u.computedMatrix;
                }, enumerable: true }, mode: { get: function() {
                  return u.getMode();
                }, set: function(t6) {
                  var e6 = u.computedUp.slice(), r6 = u.computedEye.slice(), i3 = u.computedCenter.slice();
                  if (u.setMode(t6), "turntable" === t6) {
                    var a2 = n3();
                    u._active.lookAt(a2, r6, i3, e6), u._active.lookAt(a2 + 500, r6, i3, [0, 0, 1]), u._active.flush(a2);
                  }
                  return u.getMode();
                }, enumerable: true }, center: { get: function() {
                  return u.computedCenter;
                }, set: function(t6) {
                  return u.lookAt(u.lastT(), null, t6), u.computedCenter;
                }, enumerable: true }, eye: { get: function() {
                  return u.computedEye;
                }, set: function(t6) {
                  return u.lookAt(u.lastT(), t6), u.computedEye;
                }, enumerable: true }, up: { get: function() {
                  return u.computedUp;
                }, set: function(t6) {
                  return u.lookAt(u.lastT(), null, null, t6), u.computedUp;
                }, enumerable: true }, distance: { get: function() {
                  return f2;
                }, set: function(t6) {
                  return u.setDistance(u.lastT(), t6), t6;
                }, enumerable: true }, distanceLimits: { get: function() {
                  return u.getDistanceLimits(r5);
                }, set: function(t6) {
                  return u.setDistanceLimits(t6), t6;
                }, enumerable: true } }), t5.addEventListener("contextmenu", function(t6) {
                  return t6.preventDefault(), false;
                }), d2._lastX = -1, d2._lastY = -1, d2._lastMods = { shift: false, control: false, alt: false, meta: false }, d2.enableMouseListeners = function() {
                  function e6(e7, r6, i3, a2) {
                    var o2 = d2.keyBindingMode;
                    if (false !== o2) {
                      var s2 = "rotate" === o2, l2 = "pan" === o2, c2 = "zoom" === o2, h2 = !!a2.control, p3 = !!a2.alt, v = !!a2.shift, g2 = !!(1 & e7), y = !!(2 & e7), m2 = !!(4 & e7), x = 1 / t5.clientHeight, b = x * (r6 - d2._lastX), _ = x * (i3 - d2._lastY), w2 = d2.flipX ? 1 : -1, T = d2.flipY ? 1 : -1, k = Math.PI * d2.rotateSpeed, A = n3();
                      if (-1 !== d2._lastX && -1 !== d2._lastY && ((s2 && g2 && !h2 && !p3 && !v || g2 && !h2 && !p3 && v) && u.rotate(A, w2 * k * b, -T * k * _, 0), (l2 && g2 && !h2 && !p3 && !v || y || g2 && h2 && !p3 && !v) && u.pan(A, -d2.translateSpeed * b * f2, d2.translateSpeed * _ * f2, 0), c2 && g2 && !h2 && !p3 && !v || m2 || g2 && !h2 && p3 && !v)) {
                        var M = -d2.zoomSpeed * _ / window.innerHeight * (A - u.lastT()) * 100;
                        u.pan(A, 0, 0, f2 * (Math.exp(M) - 1));
                      }
                      return d2._lastX = r6, d2._lastY = i3, d2._lastMods = a2, true;
                    }
                  }
                  d2.mouseListener = a(t5, e6), t5.addEventListener("touchstart", function(r6) {
                    var n4 = s(r6.changedTouches[0], t5);
                    e6(0, n4[0], n4[1], d2._lastMods), e6(1, n4[0], n4[1], d2._lastMods);
                  }, !!l && { passive: true }), t5.addEventListener("touchmove", function(r6) {
                    var n4 = s(r6.changedTouches[0], t5);
                    e6(1, n4[0], n4[1], d2._lastMods), r6.preventDefault();
                  }, !!l && { passive: false }), t5.addEventListener("touchend", function(t6) {
                    e6(0, d2._lastX, d2._lastY, d2._lastMods);
                  }, !!l && { passive: true }), d2.wheelListener = o(t5, function(t6, e7) {
                    if (false !== d2.keyBindingMode && d2.enableWheel) {
                      var r6 = d2.flipX ? 1 : -1, i3 = d2.flipY ? 1 : -1, a2 = n3();
                      if (Math.abs(t6) > Math.abs(e7))
                        u.rotate(a2, 0, 0, -t6 * r6 * Math.PI * d2.rotateSpeed / window.innerWidth);
                      else if (!d2._ortho) {
                        var o2 = -d2.zoomSpeed * i3 * e7 / window.innerHeight * (a2 - u.lastT()) / 20;
                        u.pan(a2, 0, 0, f2 * (Math.exp(o2) - 1));
                      }
                    }
                  }, true);
                }, d2.enableMouseListeners(), d2;
              };
              var n3 = r4(8161), i2 = r4(1152), a = r4(6145), o = r4(6475), s = r4(2565), l = r4(5233);
            }, 8245: function(t4, e4, r4) {
              var n3 = r4(6832), i2 = r4(5158), a = n3(["precision mediump float;\n#define GLSLIFY 1\nattribute vec2 position;\nvarying vec2 uv;\nvoid main() {\n  uv = position;\n  gl_Position = vec4(position, 0, 1);\n}"]), o = n3(["precision mediump float;\n#define GLSLIFY 1\n\nuniform sampler2D accumBuffer;\nvarying vec2 uv;\n\nvoid main() {\n  vec4 accum = texture2D(accumBuffer, 0.5 * (uv + 1.0));\n  gl_FragColor = min(vec4(1,1,1,1), accum);\n}"]);
              t4.exports = function(t5) {
                return i2(t5, a, o, null, [{ name: "position", type: "vec2" }]);
              };
            }, 1059: function(t4, e4, r4) {
              var n3 = r4(4296), i2 = r4(7453), a = r4(2771), o = r4(6496), s = r4(2611), l = r4(4234), u = r4(8126), c = r4(6145), f2 = r4(1120), h = r4(5268), p2 = r4(8245), d2 = r4(2321)({ tablet: true, featureDetect: true });
              function v() {
                this.mouse = [-1, -1], this.screen = null, this.distance = 1 / 0, this.index = null, this.dataCoordinate = null, this.dataPosition = null, this.object = null, this.data = null;
              }
              function g2(t5) {
                var e5 = Math.round(Math.log(Math.abs(t5)) / Math.log(10));
                if (e5 < 0) {
                  var r5 = Math.round(Math.pow(10, -e5));
                  return Math.ceil(t5 * r5) / r5;
                }
                return e5 > 0 ? (r5 = Math.round(Math.pow(10, e5)), Math.ceil(t5 / r5) * r5) : Math.ceil(t5);
              }
              function y(t5) {
                return "boolean" != typeof t5 || t5;
              }
              t4.exports = { createScene: function(t5) {
                (t5 = t5 || {}).camera = t5.camera || {};
                var e5 = t5.canvas;
                e5 || (e5 = document.createElement("canvas"), t5.container ? t5.container.appendChild(e5) : document.body.appendChild(e5));
                var r5 = t5.gl;
                if (r5 || (t5.glOptions && (d2 = !!t5.glOptions.preserveDrawingBuffer), r5 = function(t6, e6) {
                  var r6 = null;
                  try {
                    (r6 = t6.getContext("webgl", e6)) || (r6 = t6.getContext("experimental-webgl", e6));
                  } catch (t7) {
                    return null;
                  }
                  return r6;
                }(e5, t5.glOptions || { premultipliedAlpha: true, antialias: true, preserveDrawingBuffer: d2 })), !r5)
                  throw new Error("webgl not supported");
                var m2 = t5.bounds || [[-10, -10, -10], [10, 10, 10]], x = new v(), b = l(r5, r5.drawingBufferWidth, r5.drawingBufferHeight, { preferFloat: !d2 }), _ = p2(r5), w2 = t5.cameraObject && true === t5.cameraObject._ortho || t5.camera.projection && "orthographic" === t5.camera.projection.type || false, T = { eye: t5.camera.eye || [2, 0, 0], center: t5.camera.center || [0, 0, 0], up: t5.camera.up || [0, 1, 0], zoomMin: t5.camera.zoomMax || 0.1, zoomMax: t5.camera.zoomMin || 100, mode: t5.camera.mode || "turntable", _ortho: w2 }, k = t5.axes || {}, A = i2(r5, k);
                A.enable = !k.disable;
                var M = t5.spikes || {}, S = o(r5, M), E = [], L = [], C = [], P = [], O = true, I = true, D = { view: null, projection: new Array(16), model: new Array(16), _ortho: false }, z = (I = true, [r5.drawingBufferWidth, r5.drawingBufferHeight]), R = t5.cameraObject || n3(e5, T), F = { gl: r5, contextLost: false, pixelRatio: t5.pixelRatio || 1, canvas: e5, selection: x, camera: R, axes: A, axesPixels: null, spikes: S, bounds: m2, objects: E, shape: z, aspect: t5.aspectRatio || [1, 1, 1], pickRadius: t5.pickRadius || 10, zNear: t5.zNear || 0.01, zFar: t5.zFar || 1e3, fovy: t5.fovy || Math.PI / 4, clearColor: t5.clearColor || [0, 0, 0, 0], autoResize: y(t5.autoResize), autoBounds: y(t5.autoBounds), autoScale: !!t5.autoScale, autoCenter: y(t5.autoCenter), clipToBounds: y(t5.clipToBounds), snapToData: !!t5.snapToData, onselect: t5.onselect || null, onrender: t5.onrender || null, onclick: t5.onclick || null, cameraParams: D, oncontextloss: null, mouseListener: null, _stopped: false, getAspectratio: function() {
                  return { x: this.aspect[0], y: this.aspect[1], z: this.aspect[2] };
                }, setAspectratio: function(t6) {
                  this.aspect[0] = t6.x, this.aspect[1] = t6.y, this.aspect[2] = t6.z, I = true;
                }, setBounds: function(t6, e6) {
                  this.bounds[0][t6] = e6.min, this.bounds[1][t6] = e6.max;
                }, setClearColor: function(t6) {
                  this.clearColor = t6;
                }, clearRGBA: function() {
                  this.gl.clearColor(this.clearColor[0], this.clearColor[1], this.clearColor[2], this.clearColor[3]), this.gl.clear(this.gl.COLOR_BUFFER_BIT | this.gl.DEPTH_BUFFER_BIT);
                } }, B = [r5.drawingBufferWidth / F.pixelRatio | 0, r5.drawingBufferHeight / F.pixelRatio | 0];
                function N() {
                  if (!F._stopped && F.autoResize) {
                    var t6 = e5.parentNode, r6 = 1, n4 = 1;
                    t6 && t6 !== document.body ? (r6 = t6.clientWidth, n4 = t6.clientHeight) : (r6 = window.innerWidth, n4 = window.innerHeight);
                    var i3 = 0 | Math.ceil(r6 * F.pixelRatio), a2 = 0 | Math.ceil(n4 * F.pixelRatio);
                    if (i3 !== e5.width || a2 !== e5.height) {
                      e5.width = i3, e5.height = a2;
                      var o2 = e5.style;
                      o2.position = o2.position || "absolute", o2.left = "0px", o2.top = "0px", o2.width = r6 + "px", o2.height = n4 + "px", O = true;
                    }
                  }
                }
                function j() {
                  for (var t6 = E.length, e6 = P.length, n4 = 0; n4 < e6; ++n4)
                    C[n4] = 0;
                  t:
                    for (n4 = 0; n4 < t6; ++n4) {
                      var i3 = E[n4], a2 = i3.pickSlots;
                      if (a2) {
                        for (var o2 = 0; o2 < e6; ++o2)
                          if (C[o2] + a2 < 255) {
                            L[n4] = o2, i3.setPickBase(C[o2] + 1), C[o2] += a2;
                            continue t;
                          }
                        var l2 = s(r5, z);
                        L[n4] = e6, P.push(l2), C.push(a2), i3.setPickBase(1), e6 += 1;
                      } else
                        L[n4] = -1;
                    }
                  for (; e6 > 0 && 0 === C[e6 - 1]; )
                    C.pop(), P.pop().dispose();
                }
                function U() {
                  if (F.contextLost)
                    return true;
                  r5.isContextLost() && (F.contextLost = true, F.mouseListener.enabled = false, F.selection.object = null, F.oncontextloss && F.oncontextloss());
                }
                F.autoResize && N(), window.addEventListener("resize", N), F.update = function(t6) {
                  F._stopped || (O = true, I = true);
                }, F.add = function(t6) {
                  F._stopped || (t6.axes = A, E.push(t6), L.push(-1), O = true, I = true, j());
                }, F.remove = function(t6) {
                  if (!F._stopped) {
                    var e6 = E.indexOf(t6);
                    e6 < 0 || (E.splice(e6, 1), L.pop(), O = true, I = true, j());
                  }
                }, F.dispose = function() {
                  if (!F._stopped && (F._stopped = true, window.removeEventListener("resize", N), e5.removeEventListener("webglcontextlost", U), F.mouseListener.enabled = false, !F.contextLost)) {
                    A.dispose(), S.dispose();
                    for (var t6 = 0; t6 < E.length; ++t6)
                      E[t6].dispose();
                    for (b.dispose(), t6 = 0; t6 < P.length; ++t6)
                      P[t6].dispose();
                    _.dispose(), r5 = null, A = null, S = null, E = [];
                  }
                }, F._mouseRotating = false, F._prevButtons = 0, F.enableMouseListeners = function() {
                  F.mouseListener = c(e5, function(t6, e6, r6) {
                    if (!F._stopped) {
                      var n4 = P.length, i3 = E.length, a2 = x.object;
                      x.distance = 1 / 0, x.mouse[0] = e6, x.mouse[1] = r6, x.object = null, x.screen = null, x.dataCoordinate = x.dataPosition = null;
                      var o2 = false;
                      if (t6 && F._prevButtons)
                        F._mouseRotating = true;
                      else {
                        F._mouseRotating && (I = true), F._mouseRotating = false;
                        for (var s2 = 0; s2 < n4; ++s2) {
                          var l2 = P[s2].query(e6, B[1] - r6 - 1, F.pickRadius);
                          if (l2) {
                            if (l2.distance > x.distance)
                              continue;
                            for (var u2 = 0; u2 < i3; ++u2) {
                              var c2 = E[u2];
                              if (L[u2] === s2) {
                                var f3 = c2.pick(l2);
                                f3 && (x.buttons = t6, x.screen = l2.coord, x.distance = l2.distance, x.object = c2, x.index = f3.distance, x.dataPosition = f3.position, x.dataCoordinate = f3.dataCoordinate, x.data = f3, o2 = true);
                              }
                            }
                          }
                        }
                      }
                      a2 && a2 !== x.object && (a2.highlight && a2.highlight(null), O = true), x.object && (x.object.highlight && x.object.highlight(x.data), O = true), (o2 = o2 || x.object !== a2) && F.onselect && F.onselect(x), 1 & t6 && !(1 & F._prevButtons) && F.onclick && F.onclick(x), F._prevButtons = t6;
                    }
                  });
                }, e5.addEventListener("webglcontextlost", U);
                var V = [[1 / 0, 1 / 0, 1 / 0], [-1 / 0, -1 / 0, -1 / 0]], H = [V[0].slice(), V[1].slice()];
                function q2() {
                  if (!U()) {
                    N();
                    var t6 = F.camera.tick();
                    D.view = F.camera.matrix, O = O || t6, I = I || t6, A.pixelRatio = F.pixelRatio, S.pixelRatio = F.pixelRatio;
                    var e6 = E.length, n4 = V[0], i3 = V[1];
                    n4[0] = n4[1] = n4[2] = 1 / 0, i3[0] = i3[1] = i3[2] = -1 / 0;
                    for (var o2 = 0; o2 < e6; ++o2) {
                      (C2 = E[o2]).pixelRatio = F.pixelRatio, C2.axes = F.axes, O = O || !!C2.dirty, I = I || !!C2.dirty;
                      var s2 = C2.bounds;
                      if (s2)
                        for (var l2 = s2[0], c2 = s2[1], p3 = 0; p3 < 3; ++p3)
                          n4[p3] = Math.min(n4[p3], l2[p3]), i3[p3] = Math.max(i3[p3], c2[p3]);
                    }
                    var d3 = F.bounds;
                    if (F.autoBounds)
                      for (p3 = 0; p3 < 3; ++p3) {
                        if (i3[p3] < n4[p3])
                          n4[p3] = -1, i3[p3] = 1;
                        else {
                          n4[p3] === i3[p3] && (n4[p3] -= 1, i3[p3] += 1);
                          var v2 = 0.05 * (i3[p3] - n4[p3]);
                          n4[p3] = n4[p3] - v2, i3[p3] = i3[p3] + v2;
                        }
                        d3[0][p3] = n4[p3], d3[1][p3] = i3[p3];
                      }
                    var y2 = false;
                    for (p3 = 0; p3 < 3; ++p3)
                      y2 = y2 || H[0][p3] !== d3[0][p3] || H[1][p3] !== d3[1][p3], H[0][p3] = d3[0][p3], H[1][p3] = d3[1][p3];
                    if (I = I || y2, O = O || y2) {
                      if (y2) {
                        var m3 = [0, 0, 0];
                        for (o2 = 0; o2 < 3; ++o2)
                          m3[o2] = g2((d3[1][o2] - d3[0][o2]) / 10);
                        A.autoTicks ? A.update({ bounds: d3, tickSpacing: m3 }) : A.update({ bounds: d3 });
                      }
                      var T2 = r5.drawingBufferWidth, k2 = r5.drawingBufferHeight;
                      for (z[0] = T2, z[1] = k2, B[0] = 0 | Math.max(T2 / F.pixelRatio, 1), B[1] = 0 | Math.max(k2 / F.pixelRatio, 1), function(t7, e7) {
                        var r6 = t7.bounds, n5 = t7.cameraParams, i4 = n5.projection, a2 = n5.model, o3 = t7.gl.drawingBufferWidth, s3 = t7.gl.drawingBufferHeight, l3 = t7.zNear, u2 = t7.zFar, c3 = t7.fovy, p4 = o3 / s3;
                        e7 ? (h(i4, -p4, p4, -1, 1, l3, u2), n5._ortho = true) : (f2(i4, c3, p4, l3, u2), n5._ortho = false);
                        for (var d4 = 0; d4 < 16; ++d4)
                          a2[d4] = 0;
                        a2[15] = 1;
                        var v3 = 0;
                        for (d4 = 0; d4 < 3; ++d4)
                          v3 = Math.max(v3, r6[1][d4] - r6[0][d4]);
                        for (d4 = 0; d4 < 3; ++d4)
                          t7.autoScale ? a2[5 * d4] = t7.aspect[d4] / (r6[1][d4] - r6[0][d4]) : a2[5 * d4] = 1 / v3, t7.autoCenter && (a2[12 + d4] = 0.5 * -a2[5 * d4] * (r6[0][d4] + r6[1][d4]));
                      }(F, w2), o2 = 0; o2 < e6; ++o2)
                        (C2 = E[o2]).axesBounds = d3, F.clipToBounds && (C2.clipBounds = d3);
                      x.object && (F.snapToData ? S.position = x.dataCoordinate : S.position = x.dataPosition, S.bounds = d3), I && (I = false, function() {
                        if (!U()) {
                          r5.colorMask(true, true, true, true), r5.depthMask(true), r5.disable(r5.BLEND), r5.enable(r5.DEPTH_TEST), r5.depthFunc(r5.LEQUAL);
                          for (var t7 = E.length, e7 = P.length, n5 = 0; n5 < e7; ++n5) {
                            var i4 = P[n5];
                            i4.shape = B, i4.begin();
                            for (var a2 = 0; a2 < t7; ++a2)
                              if (L[a2] === n5) {
                                var o3 = E[a2];
                                o3.drawPick && (o3.pixelRatio = 1, o3.drawPick(D));
                              }
                            i4.end();
                          }
                        }
                      }()), F.axesPixels = a(F.axes, D, T2, k2), F.onrender && F.onrender(), r5.bindFramebuffer(r5.FRAMEBUFFER, null), r5.viewport(0, 0, T2, k2), F.clearRGBA(), r5.depthMask(true), r5.colorMask(true, true, true, true), r5.enable(r5.DEPTH_TEST), r5.depthFunc(r5.LEQUAL), r5.disable(r5.BLEND), r5.disable(r5.CULL_FACE);
                      var M2 = false;
                      for (A.enable && (M2 = M2 || A.isTransparent(), A.draw(D)), S.axes = A, x.object && S.draw(D), r5.disable(r5.CULL_FACE), o2 = 0; o2 < e6; ++o2)
                        (C2 = E[o2]).axes = A, C2.pixelRatio = F.pixelRatio, C2.isOpaque && C2.isOpaque() && C2.draw(D), C2.isTransparent && C2.isTransparent() && (M2 = true);
                      if (M2) {
                        for (b.shape = z, b.bind(), r5.clear(r5.DEPTH_BUFFER_BIT), r5.colorMask(false, false, false, false), r5.depthMask(true), r5.depthFunc(r5.LESS), A.enable && A.isTransparent() && A.drawTransparent(D), o2 = 0; o2 < e6; ++o2)
                          (C2 = E[o2]).isOpaque && C2.isOpaque() && C2.draw(D);
                        for (r5.enable(r5.BLEND), r5.blendEquation(r5.FUNC_ADD), r5.blendFunc(r5.ONE, r5.ONE_MINUS_SRC_ALPHA), r5.colorMask(true, true, true, true), r5.depthMask(false), r5.clearColor(0, 0, 0, 0), r5.clear(r5.COLOR_BUFFER_BIT), A.isTransparent() && A.drawTransparent(D), o2 = 0; o2 < e6; ++o2) {
                          var C2;
                          (C2 = E[o2]).isTransparent && C2.isTransparent() && C2.drawTransparent(D);
                        }
                        r5.bindFramebuffer(r5.FRAMEBUFFER, null), r5.blendFunc(r5.ONE, r5.ONE_MINUS_SRC_ALPHA), r5.disable(r5.DEPTH_TEST), _.bind(), b.color[0].bind(0), _.uniforms.accumBuffer = 0, u(r5), r5.disable(r5.BLEND);
                      }
                      for (O = false, o2 = 0; o2 < e6; ++o2)
                        E[o2].dirty = false;
                    }
                  }
                }
                return F.enableMouseListeners(), function t6() {
                  F._stopped || F.contextLost || (q2(), requestAnimationFrame(t6));
                }(), F.redraw = function() {
                  F._stopped || (O = true, q2());
                }, F;
              }, createCamera: n3 };
            }, 8023: function(t4, e4, r4) {
              var n3 = r4(6832);
              e4.pointVertex = n3(["precision mediump float;\n#define GLSLIFY 1\n\nattribute vec2 position;\n\nuniform mat3 matrix;\nuniform float pointSize;\nuniform float pointCloud;\n\nhighp float rand(vec2 co) {\n  highp float a = 12.9898;\n  highp float b = 78.233;\n  highp float c = 43758.5453;\n  highp float d = dot(co.xy, vec2(a, b));\n  highp float e = mod(d, 3.14);\n  return fract(sin(e) * c);\n}\n\nvoid main() {\n  vec3 hgPosition = matrix * vec3(position, 1);\n  gl_Position  = vec4(hgPosition.xy, 0, hgPosition.z);\n    // if we don't jitter the point size a bit, overall point cloud\n    // saturation 'jumps' on zooming, which is disturbing and confusing\n  gl_PointSize = pointSize * ((19.5 + rand(position)) / 20.0);\n  if(pointCloud != 0.0) { // pointCloud is truthy\n    // get the same square surface as circle would be\n    gl_PointSize *= 0.886;\n  }\n}"]), e4.pointFragment = n3(["precision mediump float;\n#define GLSLIFY 1\n\nuniform vec4 color, borderColor;\nuniform float centerFraction;\nuniform float pointCloud;\n\nvoid main() {\n  float radius;\n  vec4 baseColor;\n  if(pointCloud != 0.0) { // pointCloud is truthy\n    if(centerFraction == 1.0) {\n      gl_FragColor = color;\n    } else {\n      gl_FragColor = mix(borderColor, color, centerFraction);\n    }\n  } else {\n    radius = length(2.0 * gl_PointCoord.xy - 1.0);\n    if(radius > 1.0) {\n      discard;\n    }\n    baseColor = mix(borderColor, color, step(radius, centerFraction));\n    gl_FragColor = vec4(baseColor.rgb * baseColor.a, baseColor.a);\n  }\n}\n"]), e4.pickVertex = n3(["precision mediump float;\n#define GLSLIFY 1\n\nattribute vec2 position;\nattribute vec4 pickId;\n\nuniform mat3 matrix;\nuniform float pointSize;\nuniform vec4 pickOffset;\n\nvarying vec4 fragId;\n\nvoid main() {\n  vec3 hgPosition = matrix * vec3(position, 1);\n  gl_Position  = vec4(hgPosition.xy, 0, hgPosition.z);\n  gl_PointSize = pointSize;\n\n  vec4 id = pickId + pickOffset;\n  id.y += floor(id.x / 256.0);\n  id.x -= floor(id.x / 256.0) * 256.0;\n\n  id.z += floor(id.y / 256.0);\n  id.y -= floor(id.y / 256.0) * 256.0;\n\n  id.w += floor(id.z / 256.0);\n  id.z -= floor(id.z / 256.0) * 256.0;\n\n  fragId = id;\n}\n"]), e4.pickFragment = n3(["precision mediump float;\n#define GLSLIFY 1\n\nvarying vec4 fragId;\n\nvoid main() {\n  float radius = length(2.0 * gl_PointCoord.xy - 1.0);\n  if(radius > 1.0) {\n    discard;\n  }\n  gl_FragColor = fragId / 255.0;\n}\n"]);
            }, 8271: function(t4, e4, r4) {
              var n3 = r4(5158), i2 = r4(5827), a = r4(5306), o = r4(8023);
              function s(t5, e5, r5, n4, i3) {
                this.plot = t5, this.offsetBuffer = e5, this.pickBuffer = r5, this.shader = n4, this.pickShader = i3, this.sizeMin = 0.5, this.sizeMinCap = 2, this.sizeMax = 20, this.areaRatio = 1, this.pointCount = 0, this.color = [1, 0, 0, 1], this.borderColor = [0, 0, 0, 1], this.blend = false, this.pickOffset = 0, this.points = null;
              }
              t4.exports = function(t5, e5) {
                var r5 = t5.gl, a2 = new s(t5, i2(r5), i2(r5), n3(r5, o.pointVertex, o.pointFragment), n3(r5, o.pickVertex, o.pickFragment));
                return a2.update(e5), t5.addObject(a2), a2;
              };
              var l, u, c = s.prototype;
              c.dispose = function() {
                this.shader.dispose(), this.pickShader.dispose(), this.offsetBuffer.dispose(), this.pickBuffer.dispose(), this.plot.removeObject(this);
              }, c.update = function(t5) {
                var e5;
                function r5(e6, r6) {
                  return e6 in t5 ? t5[e6] : r6;
                }
                t5 = t5 || {}, this.sizeMin = r5("sizeMin", 0.5), this.sizeMax = r5("sizeMax", 20), this.color = r5("color", [1, 0, 0, 1]).slice(), this.areaRatio = r5("areaRatio", 1), this.borderColor = r5("borderColor", [0, 0, 0, 1]).slice(), this.blend = r5("blend", false);
                var n4 = t5.positions.length >>> 1, i3 = t5.positions instanceof Float32Array, o2 = t5.idToIndex instanceof Int32Array && t5.idToIndex.length >= n4, s2 = t5.positions, l2 = i3 ? s2 : a.mallocFloat32(s2.length), u2 = o2 ? t5.idToIndex : a.mallocInt32(n4);
                if (i3 || l2.set(s2), !o2)
                  for (l2.set(s2), e5 = 0; e5 < n4; e5++)
                    u2[e5] = e5;
                this.points = s2, this.offsetBuffer.update(l2), this.pickBuffer.update(u2), i3 || a.free(l2), o2 || a.free(u2), this.pointCount = n4, this.pickOffset = 0;
              }, c.unifiedDraw = (l = [1, 0, 0, 0, 1, 0, 0, 0, 1], u = [0, 0, 0, 0], function(t5) {
                var e5 = void 0 !== t5, r5 = e5 ? this.pickShader : this.shader, n4 = this.plot.gl, i3 = this.plot.dataBox;
                if (0 === this.pointCount)
                  return t5;
                var a2 = i3[2] - i3[0], o2 = i3[3] - i3[1], s2 = function(t6, e6) {
                  var r6, n5 = 0, i4 = t6.length >>> 1;
                  for (r6 = 0; r6 < i4; r6++) {
                    var a3 = t6[2 * r6], o3 = t6[2 * r6 + 1];
                    a3 >= e6[0] && a3 <= e6[2] && o3 >= e6[1] && o3 <= e6[3] && n5++;
                  }
                  return n5;
                }(this.points, i3), c2 = this.plot.pickPixelRatio * Math.max(Math.min(this.sizeMinCap, this.sizeMin), Math.min(this.sizeMax, this.sizeMax / Math.pow(s2, 0.33333)));
                l[0] = 2 / a2, l[4] = 2 / o2, l[6] = -2 * i3[0] / a2 - 1, l[7] = -2 * i3[1] / o2 - 1, this.offsetBuffer.bind(), r5.bind(), r5.attributes.position.pointer(), r5.uniforms.matrix = l, r5.uniforms.color = this.color, r5.uniforms.borderColor = this.borderColor, r5.uniforms.pointCloud = c2 < 5, r5.uniforms.pointSize = c2, r5.uniforms.centerFraction = Math.min(1, Math.max(0, Math.sqrt(1 - this.areaRatio))), e5 && (u[0] = 255 & t5, u[1] = t5 >> 8 & 255, u[2] = t5 >> 16 & 255, u[3] = t5 >> 24 & 255, this.pickBuffer.bind(), r5.attributes.pickId.pointer(n4.UNSIGNED_BYTE), r5.uniforms.pickOffset = u, this.pickOffset = t5);
                var f2 = n4.getParameter(n4.BLEND), h = n4.getParameter(n4.DITHER);
                return f2 && !this.blend && n4.disable(n4.BLEND), h && n4.disable(n4.DITHER), n4.drawArrays(n4.POINTS, 0, this.pointCount), f2 && !this.blend && n4.enable(n4.BLEND), h && n4.enable(n4.DITHER), t5 + this.pointCount;
              }), c.draw = c.unifiedDraw, c.drawPick = c.unifiedDraw, c.pick = function(t5, e5, r5) {
                var n4 = this.pickOffset, i3 = this.pointCount;
                if (r5 < n4 || r5 >= n4 + i3)
                  return null;
                var a2 = r5 - n4, o2 = this.points;
                return { object: this, pointId: a2, dataCoord: [o2[2 * a2], o2[2 * a2 + 1]] };
              };
            }, 6093: function(t4) {
              t4.exports = function(t5, e4, r4, n3) {
                var i2, a, o, s, l, u = e4[0], c = e4[1], f2 = e4[2], h = e4[3], p2 = r4[0], d2 = r4[1], v = r4[2], g2 = r4[3];
                return (a = u * p2 + c * d2 + f2 * v + h * g2) < 0 && (a = -a, p2 = -p2, d2 = -d2, v = -v, g2 = -g2), 1 - a > 1e-6 ? (i2 = Math.acos(a), o = Math.sin(i2), s = Math.sin((1 - n3) * i2) / o, l = Math.sin(n3 * i2) / o) : (s = 1 - n3, l = n3), t5[0] = s * u + l * p2, t5[1] = s * c + l * d2, t5[2] = s * f2 + l * v, t5[3] = s * h + l * g2, t5;
              };
            }, 8240: function(t4) {
              t4.exports = function(t5) {
                return t5 || 0 === t5 ? t5.toString() : "";
              };
            }, 4123: function(t4, e4, r4) {
              var n3 = r4(875);
              t4.exports = function(t5, e5, r5) {
                var a = i2[e5];
                if (a || (a = i2[e5] = {}), t5 in a)
                  return a[t5];
                var o = { textAlign: "center", textBaseline: "middle", lineHeight: 1, font: e5, lineSpacing: 1.25, styletags: { breaklines: true, bolds: true, italics: true, subscripts: true, superscripts: true }, triangles: true }, s = n3(t5, o);
                o.triangles = false;
                var l, u, c = n3(t5, o);
                if (r5 && 1 !== r5) {
                  for (l = 0; l < s.positions.length; ++l)
                    for (u = 0; u < s.positions[l].length; ++u)
                      s.positions[l][u] /= r5;
                  for (l = 0; l < c.positions.length; ++l)
                    for (u = 0; u < c.positions[l].length; ++u)
                      c.positions[l][u] /= r5;
                }
                var f2 = [[1 / 0, 1 / 0], [-1 / 0, -1 / 0]], h = c.positions.length;
                for (l = 0; l < h; ++l) {
                  var p2 = c.positions[l];
                  for (u = 0; u < 2; ++u)
                    f2[0][u] = Math.min(f2[0][u], p2[u]), f2[1][u] = Math.max(f2[1][u], p2[u]);
                }
                return a[t5] = [s, c, f2];
              };
              var i2 = {};
            }, 9282: function(t4, e4, r4) {
              var n3 = r4(5158), i2 = r4(6832), a = i2(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nattribute vec3 position;\nattribute vec4 color;\nattribute vec2 glyph;\nattribute vec4 id;\n\nuniform vec4 highlightId;\nuniform float highlightScale;\nuniform mat4 model, view, projection;\nuniform vec3 clipBounds[2];\n\nvarying vec4 interpColor;\nvarying vec4 pickId;\nvarying vec3 dataCoordinate;\n\nvoid main() {\n  if (outOfRange(clipBounds[0], clipBounds[1], position)) {\n\n    gl_Position = vec4(0,0,0,0);\n  } else {\n    float scale = 1.0;\n    if(distance(highlightId, id) < 0.0001) {\n      scale = highlightScale;\n    }\n\n    vec4 worldPosition = model * vec4(position, 1);\n    vec4 viewPosition = view * worldPosition;\n    viewPosition = viewPosition / viewPosition.w;\n    vec4 clipPosition = projection * (viewPosition + scale * vec4(glyph.x, -glyph.y, 0, 0));\n\n    gl_Position = clipPosition;\n    interpColor = color;\n    pickId = id;\n    dataCoordinate = position;\n  }\n}"]), o = i2(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nattribute vec3 position;\nattribute vec4 color;\nattribute vec2 glyph;\nattribute vec4 id;\n\nuniform mat4 model, view, projection;\nuniform vec2 screenSize;\nuniform vec3 clipBounds[2];\nuniform float highlightScale, pixelRatio;\nuniform vec4 highlightId;\n\nvarying vec4 interpColor;\nvarying vec4 pickId;\nvarying vec3 dataCoordinate;\n\nvoid main() {\n  if (outOfRange(clipBounds[0], clipBounds[1], position)) {\n\n    gl_Position = vec4(0,0,0,0);\n  } else {\n    float scale = pixelRatio;\n    if(distance(highlightId.bgr, id.bgr) < 0.001) {\n      scale *= highlightScale;\n    }\n\n    vec4 worldPosition = model * vec4(position, 1.0);\n    vec4 viewPosition = view * worldPosition;\n    vec4 clipPosition = projection * viewPosition;\n    clipPosition /= clipPosition.w;\n\n    gl_Position = clipPosition + vec4(screenSize * scale * vec2(glyph.x, -glyph.y), 0.0, 0.0);\n    interpColor = color;\n    pickId = id;\n    dataCoordinate = position;\n  }\n}"]), s = i2(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nattribute vec3 position;\nattribute vec4 color;\nattribute vec2 glyph;\nattribute vec4 id;\n\nuniform float highlightScale;\nuniform vec4 highlightId;\nuniform vec3 axes[2];\nuniform mat4 model, view, projection;\nuniform vec2 screenSize;\nuniform vec3 clipBounds[2];\nuniform float scale, pixelRatio;\n\nvarying vec4 interpColor;\nvarying vec4 pickId;\nvarying vec3 dataCoordinate;\n\nvoid main() {\n  if (outOfRange(clipBounds[0], clipBounds[1], position)) {\n\n    gl_Position = vec4(0,0,0,0);\n  } else {\n    float lscale = pixelRatio * scale;\n    if(distance(highlightId, id) < 0.0001) {\n      lscale *= highlightScale;\n    }\n\n    vec4 clipCenter   = projection * view * model * vec4(position, 1);\n    vec3 dataPosition = position + 0.5*lscale*(axes[0] * glyph.x + axes[1] * glyph.y) * clipCenter.w * screenSize.y;\n    vec4 clipPosition = projection * view * model * vec4(dataPosition, 1);\n\n    gl_Position = clipPosition;\n    interpColor = color;\n    pickId = id;\n    dataCoordinate = dataPosition;\n  }\n}\n"]), l = i2(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec3 fragClipBounds[2];\nuniform float opacity;\n\nvarying vec4 interpColor;\nvarying vec3 dataCoordinate;\n\nvoid main() {\n  if (\n    outOfRange(fragClipBounds[0], fragClipBounds[1], dataCoordinate) ||\n    interpColor.a * opacity == 0.\n  ) discard;\n  gl_FragColor = interpColor * opacity;\n}\n"]), u = i2(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec3 fragClipBounds[2];\nuniform float pickGroup;\n\nvarying vec4 pickId;\nvarying vec3 dataCoordinate;\n\nvoid main() {\n  if (outOfRange(fragClipBounds[0], fragClipBounds[1], dataCoordinate)) discard;\n\n  gl_FragColor = vec4(pickGroup, pickId.bgr);\n}"]), c = [{ name: "position", type: "vec3" }, { name: "color", type: "vec4" }, { name: "glyph", type: "vec2" }, { name: "id", type: "vec4" }], f2 = { vertex: a, fragment: l, attributes: c }, h = { vertex: o, fragment: l, attributes: c }, p2 = { vertex: s, fragment: l, attributes: c }, d2 = { vertex: a, fragment: u, attributes: c }, v = { vertex: o, fragment: u, attributes: c }, g2 = { vertex: s, fragment: u, attributes: c };
              function y(t5, e5) {
                var r5 = n3(t5, e5), i3 = r5.attributes;
                return i3.position.location = 0, i3.color.location = 1, i3.glyph.location = 2, i3.id.location = 3, r5;
              }
              e4.createPerspective = function(t5) {
                return y(t5, f2);
              }, e4.createOrtho = function(t5) {
                return y(t5, h);
              }, e4.createProject = function(t5) {
                return y(t5, p2);
              }, e4.createPickPerspective = function(t5) {
                return y(t5, d2);
              }, e4.createPickOrtho = function(t5) {
                return y(t5, v);
              }, e4.createPickProject = function(t5) {
                return y(t5, g2);
              };
            }, 2182: function(t4, e4, r4) {
              var n3 = r4(3596), i2 = r4(5827), a = r4(2944), o = r4(5306), s = r4(104), l = r4(9282), u = r4(4123), c = r4(8240), f2 = [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1];
              function h(t5, e5) {
                var r5 = t5[0], n4 = t5[1], i3 = t5[2], a2 = t5[3];
                return t5[0] = e5[0] * r5 + e5[4] * n4 + e5[8] * i3 + e5[12] * a2, t5[1] = e5[1] * r5 + e5[5] * n4 + e5[9] * i3 + e5[13] * a2, t5[2] = e5[2] * r5 + e5[6] * n4 + e5[10] * i3 + e5[14] * a2, t5[3] = e5[3] * r5 + e5[7] * n4 + e5[11] * i3 + e5[15] * a2, t5;
              }
              function p2(t5, e5, r5, n4) {
                return h(n4, n4), h(n4, n4), h(n4, n4);
              }
              function d2(t5, e5) {
                this.index = t5, this.dataCoordinate = this.position = e5;
              }
              function v(t5) {
                return true === t5 || t5 > 1 ? 1 : t5;
              }
              function g2(t5, e5, r5, n4, i3, a2, o2, s2, l2, u2, c2, f3) {
                this.gl = t5, this.pixelRatio = 1, this.shader = e5, this.orthoShader = r5, this.projectShader = n4, this.pointBuffer = i3, this.colorBuffer = a2, this.glyphBuffer = o2, this.idBuffer = s2, this.vao = l2, this.vertexCount = 0, this.lineVertexCount = 0, this.opacity = 1, this.hasAlpha = false, this.lineWidth = 0, this.projectScale = [2 / 3, 2 / 3, 2 / 3], this.projectOpacity = [1, 1, 1], this.projectHasAlpha = false, this.pickId = 0, this.pickPerspectiveShader = u2, this.pickOrthoShader = c2, this.pickProjectShader = f3, this.points = [], this._selectResult = new d2(0, [0, 0, 0]), this.useOrtho = true, this.bounds = [[1 / 0, 1 / 0, 1 / 0], [-1 / 0, -1 / 0, -1 / 0]], this.axesProject = [true, true, true], this.axesBounds = [[-1 / 0, -1 / 0, -1 / 0], [1 / 0, 1 / 0, 1 / 0]], this.highlightId = [1, 1, 1, 1], this.highlightScale = 2, this.clipBounds = [[-1 / 0, -1 / 0, -1 / 0], [1 / 0, 1 / 0, 1 / 0]], this.dirty = true;
              }
              t4.exports = function(t5) {
                var e5 = t5.gl, r5 = l.createPerspective(e5), n4 = l.createOrtho(e5), o2 = l.createProject(e5), s2 = l.createPickPerspective(e5), u2 = l.createPickOrtho(e5), c2 = l.createPickProject(e5), f3 = i2(e5), h2 = i2(e5), p3 = i2(e5), d3 = i2(e5), v2 = new g2(e5, r5, n4, o2, f3, h2, p3, d3, a(e5, [{ buffer: f3, size: 3, type: e5.FLOAT }, { buffer: h2, size: 4, type: e5.FLOAT }, { buffer: p3, size: 2, type: e5.FLOAT }, { buffer: d3, size: 4, type: e5.UNSIGNED_BYTE, normalized: true }]), s2, u2, c2);
                return v2.update(t5), v2;
              };
              var y = g2.prototype;
              y.pickSlots = 1, y.setPickBase = function(t5) {
                this.pickId = t5;
              }, y.isTransparent = function() {
                if (this.hasAlpha)
                  return true;
                for (var t5 = 0; t5 < 3; ++t5)
                  if (this.axesProject[t5] && this.projectHasAlpha)
                    return true;
                return false;
              }, y.isOpaque = function() {
                if (!this.hasAlpha)
                  return true;
                for (var t5 = 0; t5 < 3; ++t5)
                  if (this.axesProject[t5] && !this.projectHasAlpha)
                    return true;
                return false;
              };
              var m2 = [0, 0], x = [0, 0, 0], b = [0, 0, 0], _ = [0, 0, 0, 1], w2 = [0, 0, 0, 1], T = f2.slice(), k = [0, 0, 0], A = [[0, 0, 0], [0, 0, 0]];
              function M(t5) {
                return t5[0] = t5[1] = t5[2] = 0, t5;
              }
              function S(t5, e5) {
                return t5[0] = e5[0], t5[1] = e5[1], t5[2] = e5[2], t5[3] = 1, t5;
              }
              function E(t5, e5, r5, n4) {
                return t5[0] = e5[0], t5[1] = e5[1], t5[2] = e5[2], t5[r5] = n4, t5;
              }
              var L = [[-1e8, -1e8, -1e8], [1e8, 1e8, 1e8]];
              function C(t5, e5, r5, n4, i3, a2, o2) {
                var l2 = r5.gl;
                if ((a2 === r5.projectHasAlpha || o2) && function(t6, e6, r6, n5) {
                  var i4, a3 = e6.axesProject, o3 = e6.gl, l3 = t6.uniforms, u3 = r6.model || f2, c2 = r6.view || f2, h2 = r6.projection || f2, d3 = e6.axesBounds, v2 = function(t7) {
                    for (var e7 = A, r7 = 0; r7 < 2; ++r7)
                      for (var n6 = 0; n6 < 3; ++n6)
                        e7[r7][n6] = Math.max(Math.min(t7[r7][n6], 1e8), -1e8);
                    return e7;
                  }(e6.clipBounds);
                  i4 = e6.axes && e6.axes.lastCubeProps ? e6.axes.lastCubeProps.axis : [1, 1, 1], m2[0] = 2 / o3.drawingBufferWidth, m2[1] = 2 / o3.drawingBufferHeight, t6.bind(), l3.view = c2, l3.projection = h2, l3.screenSize = m2, l3.highlightId = e6.highlightId, l3.highlightScale = e6.highlightScale, l3.clipBounds = v2, l3.pickGroup = e6.pickId / 255, l3.pixelRatio = n5;
                  for (var g3 = 0; g3 < 3; ++g3)
                    if (a3[g3]) {
                      l3.scale = e6.projectScale[g3], l3.opacity = e6.projectOpacity[g3];
                      for (var y2 = T, L2 = 0; L2 < 16; ++L2)
                        y2[L2] = 0;
                      for (L2 = 0; L2 < 4; ++L2)
                        y2[5 * L2] = 1;
                      y2[5 * g3] = 0, i4[g3] < 0 ? y2[12 + g3] = d3[0][g3] : y2[12 + g3] = d3[1][g3], s(y2, u3, y2), l3.model = y2;
                      var C2 = (g3 + 1) % 3, P2 = (g3 + 2) % 3, O = M(x), I = M(b);
                      O[C2] = 1, I[P2] = 1;
                      var D = p2(0, 0, 0, S(_, O)), z = p2(0, 0, 0, S(w2, I));
                      if (Math.abs(D[1]) > Math.abs(z[1])) {
                        var R = D;
                        D = z, z = R, R = O, O = I, I = R;
                        var F = C2;
                        C2 = P2, P2 = F;
                      }
                      D[0] < 0 && (O[C2] = -1), z[1] > 0 && (I[P2] = -1);
                      var B = 0, N = 0;
                      for (L2 = 0; L2 < 4; ++L2)
                        B += Math.pow(u3[4 * C2 + L2], 2), N += Math.pow(u3[4 * P2 + L2], 2);
                      O[C2] /= Math.sqrt(B), I[P2] /= Math.sqrt(N), l3.axes[0] = O, l3.axes[1] = I, l3.fragClipBounds[0] = E(k, v2[0], g3, -1e8), l3.fragClipBounds[1] = E(k, v2[1], g3, 1e8), e6.vao.bind(), e6.vao.draw(o3.TRIANGLES, e6.vertexCount), e6.lineWidth > 0 && (o3.lineWidth(e6.lineWidth * n5), e6.vao.draw(o3.LINES, e6.lineVertexCount, e6.vertexCount)), e6.vao.unbind();
                    }
                }(e5, r5, n4, i3), a2 === r5.hasAlpha || o2) {
                  t5.bind();
                  var u2 = t5.uniforms;
                  u2.model = n4.model || f2, u2.view = n4.view || f2, u2.projection = n4.projection || f2, m2[0] = 2 / l2.drawingBufferWidth, m2[1] = 2 / l2.drawingBufferHeight, u2.screenSize = m2, u2.highlightId = r5.highlightId, u2.highlightScale = r5.highlightScale, u2.fragClipBounds = L, u2.clipBounds = r5.axes.bounds, u2.opacity = r5.opacity, u2.pickGroup = r5.pickId / 255, u2.pixelRatio = i3, r5.vao.bind(), r5.vao.draw(l2.TRIANGLES, r5.vertexCount), r5.lineWidth > 0 && (l2.lineWidth(r5.lineWidth * i3), r5.vao.draw(l2.LINES, r5.lineVertexCount, r5.vertexCount)), r5.vao.unbind();
                }
              }
              function P(t5, e5, r5, i3) {
                var a2;
                a2 = Array.isArray(t5) ? e5 < t5.length ? t5[e5] : void 0 : t5, a2 = c(a2);
                var o2 = true;
                n3(a2) && (a2 = "▼", o2 = false);
                var s2 = u(a2, r5, i3);
                return { mesh: s2[0], lines: s2[1], bounds: s2[2], visible: o2 };
              }
              y.draw = function(t5) {
                C(this.useOrtho ? this.orthoShader : this.shader, this.projectShader, this, t5, this.pixelRatio, false, false);
              }, y.drawTransparent = function(t5) {
                C(this.useOrtho ? this.orthoShader : this.shader, this.projectShader, this, t5, this.pixelRatio, true, false);
              }, y.drawPick = function(t5) {
                C(this.useOrtho ? this.pickOrthoShader : this.pickPerspectiveShader, this.pickProjectShader, this, t5, 1, true, true);
              }, y.pick = function(t5) {
                if (!t5)
                  return null;
                if (t5.id !== this.pickId)
                  return null;
                var e5 = t5.value[2] + (t5.value[1] << 8) + (t5.value[0] << 16);
                if (e5 >= this.pointCount || e5 < 0)
                  return null;
                var r5 = this.points[e5], n4 = this._selectResult;
                n4.index = e5;
                for (var i3 = 0; i3 < 3; ++i3)
                  n4.position[i3] = n4.dataCoordinate[i3] = r5[i3];
                return n4;
              }, y.highlight = function(t5) {
                if (t5) {
                  var e5 = t5.index, r5 = 255 & e5, n4 = e5 >> 8 & 255, i3 = e5 >> 16 & 255;
                  this.highlightId = [r5 / 255, n4 / 255, i3 / 255, 0];
                } else
                  this.highlightId = [1, 1, 1, 1];
              }, y.update = function(t5) {
                if ("perspective" in (t5 = t5 || {}) && (this.useOrtho = !t5.perspective), "orthographic" in t5 && (this.useOrtho = !!t5.orthographic), "lineWidth" in t5 && (this.lineWidth = t5.lineWidth), "project" in t5)
                  if (Array.isArray(t5.project))
                    this.axesProject = t5.project;
                  else {
                    var e5 = !!t5.project;
                    this.axesProject = [e5, e5, e5];
                  }
                if ("projectScale" in t5)
                  if (Array.isArray(t5.projectScale))
                    this.projectScale = t5.projectScale.slice();
                  else {
                    var r5 = +t5.projectScale;
                    this.projectScale = [r5, r5, r5];
                  }
                if (this.projectHasAlpha = false, "projectOpacity" in t5) {
                  Array.isArray(t5.projectOpacity) ? this.projectOpacity = t5.projectOpacity.slice() : (r5 = +t5.projectOpacity, this.projectOpacity = [r5, r5, r5]);
                  for (var n4 = 0; n4 < 3; ++n4)
                    this.projectOpacity[n4] = v(this.projectOpacity[n4]), this.projectOpacity[n4] < 1 && (this.projectHasAlpha = true);
                }
                this.hasAlpha = false, "opacity" in t5 && (this.opacity = v(t5.opacity), this.opacity < 1 && (this.hasAlpha = true)), this.dirty = true;
                var i3, a2, s2 = t5.position, l2 = t5.font || "normal", u2 = t5.alignment || [0, 0];
                if (2 === u2.length)
                  i3 = u2[0], a2 = u2[1];
                else
                  for (i3 = [], a2 = [], n4 = 0; n4 < u2.length; ++n4)
                    i3[n4] = u2[n4][0], a2[n4] = u2[n4][1];
                var c2 = [1 / 0, 1 / 0, 1 / 0], f3 = [-1 / 0, -1 / 0, -1 / 0], h2 = t5.glyph, p3 = t5.color, d3 = t5.size, g3 = t5.angle, y2 = t5.lineColor, m3 = -1, x2 = 0, b2 = 0, _2 = 0;
                if (s2.length) {
                  _2 = s2.length;
                  t:
                    for (n4 = 0; n4 < _2; ++n4) {
                      for (var w3 = s2[n4], T2 = 0; T2 < 3; ++T2)
                        if (isNaN(w3[T2]) || !isFinite(w3[T2]))
                          continue t;
                      var k2 = (N = P(h2, n4, l2, this.pixelRatio)).mesh, A2 = N.lines, M2 = N.bounds;
                      x2 += 3 * k2.cells.length, b2 += 2 * A2.edges.length;
                    }
                }
                var S2 = x2 + b2, E2 = o.mallocFloat(3 * S2), L2 = o.mallocFloat(4 * S2), C2 = o.mallocFloat(2 * S2), O = o.mallocUint32(S2);
                if (S2 > 0) {
                  var I = 0, D = x2, z = [0, 0, 0, 1], R = [0, 0, 0, 1], F = Array.isArray(p3) && Array.isArray(p3[0]), B = Array.isArray(y2) && Array.isArray(y2[0]);
                  t:
                    for (n4 = 0; n4 < _2; ++n4) {
                      for (m3 += 1, w3 = s2[n4], T2 = 0; T2 < 3; ++T2) {
                        if (isNaN(w3[T2]) || !isFinite(w3[T2]))
                          continue t;
                        f3[T2] = Math.max(f3[T2], w3[T2]), c2[T2] = Math.min(c2[T2], w3[T2]);
                      }
                      k2 = (N = P(h2, n4, l2, this.pixelRatio)).mesh, A2 = N.lines, M2 = N.bounds;
                      var N, j = N.visible;
                      if (j)
                        if (Array.isArray(p3)) {
                          if (3 === (U = F ? n4 < p3.length ? p3[n4] : [0, 0, 0, 0] : p3).length) {
                            for (T2 = 0; T2 < 3; ++T2)
                              z[T2] = U[T2];
                            z[3] = 1;
                          } else if (4 === U.length) {
                            for (T2 = 0; T2 < 4; ++T2)
                              z[T2] = U[T2];
                            !this.hasAlpha && U[3] < 1 && (this.hasAlpha = true);
                          }
                        } else
                          z[0] = z[1] = z[2] = 0, z[3] = 1;
                      else
                        z = [1, 1, 1, 0];
                      if (j)
                        if (Array.isArray(y2)) {
                          var U;
                          if (3 === (U = B ? n4 < y2.length ? y2[n4] : [0, 0, 0, 0] : y2).length) {
                            for (T2 = 0; T2 < 3; ++T2)
                              R[T2] = U[T2];
                            R[T2] = 1;
                          } else if (4 === U.length) {
                            for (T2 = 0; T2 < 4; ++T2)
                              R[T2] = U[T2];
                            !this.hasAlpha && U[3] < 1 && (this.hasAlpha = true);
                          }
                        } else
                          R[0] = R[1] = R[2] = 0, R[3] = 1;
                      else
                        R = [1, 1, 1, 0];
                      var V = 0.5;
                      j ? Array.isArray(d3) ? V = n4 < d3.length ? +d3[n4] : 12 : d3 ? V = +d3 : this.useOrtho && (V = 12) : V = 0;
                      var H = 0;
                      Array.isArray(g3) ? H = n4 < g3.length ? +g3[n4] : 0 : g3 && (H = +g3);
                      var q2 = Math.cos(H), G = Math.sin(H);
                      for (w3 = s2[n4], T2 = 0; T2 < 3; ++T2)
                        f3[T2] = Math.max(f3[T2], w3[T2]), c2[T2] = Math.min(c2[T2], w3[T2]);
                      var Z = i3, Y = a2;
                      Z = 0, Array.isArray(i3) ? Z = n4 < i3.length ? i3[n4] : 0 : i3 && (Z = i3), Y = 0, Array.isArray(a2) ? Y = n4 < a2.length ? a2[n4] : 0 : a2 && (Y = a2);
                      var W = [Z *= Z > 0 ? 1 - M2[0][0] : Z < 0 ? 1 + M2[1][0] : 1, Y *= Y > 0 ? 1 - M2[0][1] : Y < 0 ? 1 + M2[1][1] : 1], X = k2.cells || [], J = k2.positions || [];
                      for (T2 = 0; T2 < X.length; ++T2)
                        for (var K = X[T2], $ = 0; $ < 3; ++$) {
                          for (var Q = 0; Q < 3; ++Q)
                            E2[3 * I + Q] = w3[Q];
                          for (Q = 0; Q < 4; ++Q)
                            L2[4 * I + Q] = z[Q];
                          O[I] = m3;
                          var tt = J[K[$]];
                          C2[2 * I] = V * (q2 * tt[0] - G * tt[1] + W[0]), C2[2 * I + 1] = V * (G * tt[0] + q2 * tt[1] + W[1]), I += 1;
                        }
                      for (X = A2.edges, J = A2.positions, T2 = 0; T2 < X.length; ++T2)
                        for (K = X[T2], $ = 0; $ < 2; ++$) {
                          for (Q = 0; Q < 3; ++Q)
                            E2[3 * D + Q] = w3[Q];
                          for (Q = 0; Q < 4; ++Q)
                            L2[4 * D + Q] = R[Q];
                          O[D] = m3, tt = J[K[$]], C2[2 * D] = V * (q2 * tt[0] - G * tt[1] + W[0]), C2[2 * D + 1] = V * (G * tt[0] + q2 * tt[1] + W[1]), D += 1;
                        }
                    }
                }
                this.bounds = [c2, f3], this.points = s2, this.pointCount = s2.length, this.vertexCount = x2, this.lineVertexCount = b2, this.pointBuffer.update(E2), this.colorBuffer.update(L2), this.glyphBuffer.update(C2), this.idBuffer.update(O), o.free(E2), o.free(L2), o.free(C2), o.free(O);
              }, y.dispose = function() {
                this.shader.dispose(), this.orthoShader.dispose(), this.pickPerspectiveShader.dispose(), this.pickOrthoShader.dispose(), this.vao.dispose(), this.pointBuffer.dispose(), this.colorBuffer.dispose(), this.glyphBuffer.dispose(), this.idBuffer.dispose();
              };
            }, 1884: function(t4, e4, r4) {
              var n3 = r4(6832);
              e4.boxVertex = n3(["precision mediump float;\n#define GLSLIFY 1\n\nattribute vec2 vertex;\n\nuniform vec2 cornerA, cornerB;\n\nvoid main() {\n  gl_Position = vec4(mix(cornerA, cornerB, vertex), 0, 1);\n}\n"]), e4.boxFragment = n3(["precision mediump float;\n#define GLSLIFY 1\n\nuniform vec4 color;\n\nvoid main() {\n  gl_FragColor = color;\n}\n"]);
            }, 6623: function(t4, e4, r4) {
              var n3 = r4(5158), i2 = r4(5827), a = r4(1884);
              function o(t5, e5, r5) {
                this.plot = t5, this.boxBuffer = e5, this.boxShader = r5, this.enabled = true, this.selectBox = [1 / 0, 1 / 0, -1 / 0, -1 / 0], this.borderColor = [0, 0, 0, 1], this.innerFill = false, this.innerColor = [0, 0, 0, 0.25], this.outerFill = true, this.outerColor = [0, 0, 0, 0.5], this.borderWidth = 10;
              }
              t4.exports = function(t5, e5) {
                var r5 = t5.gl, s2 = new o(t5, i2(r5, [0, 0, 0, 1, 1, 0, 1, 1]), n3(r5, a.boxVertex, a.boxFragment));
                return s2.update(e5), t5.addOverlay(s2), s2;
              };
              var s = o.prototype;
              s.draw = function() {
                if (this.enabled) {
                  var t5 = this.plot, e5 = this.selectBox, r5 = this.borderWidth, n4 = (this.innerFill, this.innerColor), i3 = (this.outerFill, this.outerColor), a2 = this.borderColor, o2 = t5.box, s2 = t5.screenBox, l = t5.dataBox, u = t5.viewBox, c = t5.pixelRatio, f2 = (e5[0] - l[0]) * (u[2] - u[0]) / (l[2] - l[0]) + u[0], h = (e5[1] - l[1]) * (u[3] - u[1]) / (l[3] - l[1]) + u[1], p2 = (e5[2] - l[0]) * (u[2] - u[0]) / (l[2] - l[0]) + u[0], d2 = (e5[3] - l[1]) * (u[3] - u[1]) / (l[3] - l[1]) + u[1];
                  if (f2 = Math.max(f2, u[0]), h = Math.max(h, u[1]), p2 = Math.min(p2, u[2]), d2 = Math.min(d2, u[3]), !(p2 < f2 || d2 < h)) {
                    o2.bind();
                    var v = s2[2] - s2[0], g2 = s2[3] - s2[1];
                    if (this.outerFill && (o2.drawBox(0, 0, v, h, i3), o2.drawBox(0, h, f2, d2, i3), o2.drawBox(0, d2, v, g2, i3), o2.drawBox(p2, h, v, d2, i3)), this.innerFill && o2.drawBox(f2, h, p2, d2, n4), r5 > 0) {
                      var y = r5 * c;
                      o2.drawBox(f2 - y, h - y, p2 + y, h + y, a2), o2.drawBox(f2 - y, d2 - y, p2 + y, d2 + y, a2), o2.drawBox(f2 - y, h - y, f2 + y, d2 + y, a2), o2.drawBox(p2 - y, h - y, p2 + y, d2 + y, a2);
                    }
                  }
                }
              }, s.update = function(t5) {
                t5 = t5 || {}, this.innerFill = !!t5.innerFill, this.outerFill = !!t5.outerFill, this.innerColor = (t5.innerColor || [0, 0, 0, 0.5]).slice(), this.outerColor = (t5.outerColor || [0, 0, 0, 0.5]).slice(), this.borderColor = (t5.borderColor || [0, 0, 0, 1]).slice(), this.borderWidth = t5.borderWidth || 0, this.selectBox = (t5.selectBox || this.selectBox).slice();
              }, s.dispose = function() {
                this.boxBuffer.dispose(), this.boxShader.dispose(), this.plot.removeOverlay(this);
              };
            }, 2611: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                var r5 = e5[0], a2 = e5[1];
                return new l(t5, n3(t5, r5, a2, {}), i2.mallocUint8(r5 * a2 * 4));
              };
              var n3 = r4(4234), i2 = r4(5306), a = r4(5050), o = r4(2288).nextPow2;
              function s(t5, e5, r5, n4, i3) {
                this.coord = [t5, e5], this.id = r5, this.value = n4, this.distance = i3;
              }
              function l(t5, e5, r5) {
                this.gl = t5, this.fbo = e5, this.buffer = r5, this._readTimeout = null;
                var n4 = this;
                this._readCallback = function() {
                  n4.gl && (e5.bind(), t5.readPixels(0, 0, e5.shape[0], e5.shape[1], t5.RGBA, t5.UNSIGNED_BYTE, n4.buffer), n4._readTimeout = null);
                };
              }
              var u = l.prototype;
              Object.defineProperty(u, "shape", { get: function() {
                return this.gl ? this.fbo.shape.slice() : [0, 0];
              }, set: function(t5) {
                if (this.gl) {
                  this.fbo.shape = t5;
                  var e5 = this.fbo.shape[0], r5 = this.fbo.shape[1];
                  if (r5 * e5 * 4 > this.buffer.length) {
                    i2.free(this.buffer);
                    for (var n4 = this.buffer = i2.mallocUint8(o(r5 * e5 * 4)), a2 = 0; a2 < r5 * e5 * 4; ++a2)
                      n4[a2] = 255;
                  }
                  return t5;
                }
              } }), u.begin = function() {
                var t5 = this.gl;
                this.shape, t5 && (this.fbo.bind(), t5.clearColor(1, 1, 1, 1), t5.clear(t5.COLOR_BUFFER_BIT | t5.DEPTH_BUFFER_BIT));
              }, u.end = function() {
                var t5 = this.gl;
                t5 && (t5.bindFramebuffer(t5.FRAMEBUFFER, null), this._readTimeout || clearTimeout(this._readTimeout), this._readTimeout = setTimeout(this._readCallback, 1));
              }, u.query = function(t5, e5, r5) {
                if (!this.gl)
                  return null;
                var n4 = this.fbo.shape.slice();
                t5 |= 0, e5 |= 0, "number" != typeof r5 && (r5 = 1);
                var i3 = 0 | Math.min(Math.max(t5 - r5, 0), n4[0]), o2 = 0 | Math.min(Math.max(t5 + r5, 0), n4[0]), l2 = 0 | Math.min(Math.max(e5 - r5, 0), n4[1]), u2 = 0 | Math.min(Math.max(e5 + r5, 0), n4[1]);
                if (o2 <= i3 || u2 <= l2)
                  return null;
                var c = [o2 - i3, u2 - l2], f2 = a(this.buffer, [c[0], c[1], 4], [4, 4 * n4[0], 1], 4 * (i3 + n4[0] * l2)), h = function(t6, e6, r6) {
                  for (var n5 = 1e8, i4 = -1, a2 = -1, o3 = t6.shape[0], s2 = t6.shape[1], l3 = 0; l3 < o3; l3++)
                    for (var u3 = 0; u3 < s2; u3++) {
                      var c2 = t6.get(l3, u3, 0), f3 = t6.get(l3, u3, 1), h2 = t6.get(l3, u3, 2), p3 = t6.get(l3, u3, 3);
                      if (c2 < 255 || f3 < 255 || h2 < 255 || p3 < 255) {
                        var d3 = e6 - l3, v = r6 - u3, g2 = d3 * d3 + v * v;
                        g2 < n5 && (n5 = g2, i4 = l3, a2 = u3);
                      }
                    }
                  return [i4, a2, n5];
                }(f2.hi(c[0], c[1], 1), r5, r5), p2 = h[0], d2 = h[1];
                return p2 < 0 || Math.pow(this.radius, 2) < h[2] ? null : new s(p2 + i3 | 0, d2 + l2 | 0, f2.get(p2, d2, 0), [f2.get(p2, d2, 1), f2.get(p2, d2, 2), f2.get(p2, d2, 3)], Math.sqrt(h[2]));
              }, u.dispose = function() {
                this.gl && (this.fbo.dispose(), i2.free(this.buffer), this.gl = null, this._readTimeout && clearTimeout(this._readTimeout));
              };
            }, 5158: function(t4, e4, r4) {
              var n3 = r4(9016), i2 = r4(4280), a = r4(3984), o = r4(1628), s = r4(2631), l = r4(9068);
              function u(t5) {
                this.gl = t5, this.gl.lastAttribCount = 0, this._vref = this._fref = this._relink = this.vertShader = this.fragShader = this.program = this.attributes = this.uniforms = this.types = null;
              }
              var c = u.prototype;
              function f2(t5, e5) {
                return t5.name < e5.name ? -1 : 1;
              }
              c.bind = function() {
                var t5;
                this.program || this._relink();
                var e5 = this.gl.getProgramParameter(this.program, this.gl.ACTIVE_ATTRIBUTES), r5 = this.gl.lastAttribCount;
                if (e5 > r5)
                  for (t5 = r5; t5 < e5; t5++)
                    this.gl.enableVertexAttribArray(t5);
                else if (r5 > e5)
                  for (t5 = e5; t5 < r5; t5++)
                    this.gl.disableVertexAttribArray(t5);
                this.gl.lastAttribCount = e5, this.gl.useProgram(this.program);
              }, c.dispose = function() {
                for (var t5 = this.gl.lastAttribCount, e5 = 0; e5 < t5; e5++)
                  this.gl.disableVertexAttribArray(e5);
                this.gl.lastAttribCount = 0, this._fref && this._fref.dispose(), this._vref && this._vref.dispose(), this.attributes = this.types = this.vertShader = this.fragShader = this.program = this._relink = this._fref = this._vref = null;
              }, c.update = function(t5, e5, r5, u2) {
                if (!e5 || 1 === arguments.length) {
                  var c2 = t5;
                  t5 = c2.vertex, e5 = c2.fragment, r5 = c2.uniforms, u2 = c2.attributes;
                }
                var h = this, p2 = h.gl, d2 = h._vref;
                h._vref = o.shader(p2, p2.VERTEX_SHADER, t5), d2 && d2.dispose(), h.vertShader = h._vref.shader;
                var v = this._fref;
                if (h._fref = o.shader(p2, p2.FRAGMENT_SHADER, e5), v && v.dispose(), h.fragShader = h._fref.shader, !r5 || !u2) {
                  var g2 = p2.createProgram();
                  if (p2.attachShader(g2, h.fragShader), p2.attachShader(g2, h.vertShader), p2.linkProgram(g2), !p2.getProgramParameter(g2, p2.LINK_STATUS)) {
                    var y = p2.getProgramInfoLog(g2);
                    throw new l(y, "Error linking program:" + y);
                  }
                  r5 = r5 || s.uniforms(p2, g2), u2 = u2 || s.attributes(p2, g2), p2.deleteProgram(g2);
                }
                (u2 = u2.slice()).sort(f2);
                var m2, x = [], b = [], _ = [];
                for (m2 = 0; m2 < u2.length; ++m2) {
                  var w2 = u2[m2];
                  if (w2.type.indexOf("mat") >= 0) {
                    for (var T = 0 | w2.type.charAt(w2.type.length - 1), k = new Array(T), A = 0; A < T; ++A)
                      k[A] = _.length, b.push(w2.name + "[" + A + "]"), "number" == typeof w2.location ? _.push(w2.location + A) : Array.isArray(w2.location) && w2.location.length === T && "number" == typeof w2.location[A] ? _.push(0 | w2.location[A]) : _.push(-1);
                    x.push({ name: w2.name, type: w2.type, locations: k });
                  } else
                    x.push({ name: w2.name, type: w2.type, locations: [_.length] }), b.push(w2.name), "number" == typeof w2.location ? _.push(0 | w2.location) : _.push(-1);
                }
                var M = 0;
                for (m2 = 0; m2 < _.length; ++m2)
                  if (_[m2] < 0) {
                    for (; _.indexOf(M) >= 0; )
                      M += 1;
                    _[m2] = M;
                  }
                var S = new Array(r5.length);
                function E() {
                  h.program = o.program(p2, h._vref, h._fref, b, _);
                  for (var t6 = 0; t6 < r5.length; ++t6)
                    S[t6] = p2.getUniformLocation(h.program, r5[t6].name);
                }
                E(), h._relink = E, h.types = { uniforms: a(r5), attributes: a(u2) }, h.attributes = i2(p2, h, x, _), Object.defineProperty(h, "uniforms", n3(p2, h, r5, S));
              }, t4.exports = function(t5, e5, r5, n4, i3) {
                var a2 = new u(t5);
                return a2.update(e5, r5, n4, i3), a2;
              };
            }, 9068: function(t4) {
              function e4(t5, e5, r4) {
                this.shortMessage = e5 || "", this.longMessage = r4 || "", this.rawError = t5 || "", this.message = "gl-shader: " + (e5 || t5 || "") + (r4 ? "\n" + r4 : ""), this.stack = new Error().stack;
              }
              e4.prototype = new Error(), e4.prototype.name = "GLError", e4.prototype.constructor = e4, t4.exports = e4;
            }, 4280: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5, i3) {
                for (var a2 = {}, o2 = 0, u = r5.length; o2 < u; ++o2) {
                  var c = r5[o2], f2 = c.name, h = c.type, p2 = c.locations;
                  switch (h) {
                    case "bool":
                    case "int":
                    case "float":
                      s(t5, e5, p2[0], i3, 1, a2, f2);
                      break;
                    default:
                      if (h.indexOf("vec") >= 0) {
                        if ((d2 = h.charCodeAt(h.length - 1) - 48) < 2 || d2 > 4)
                          throw new n3("", "Invalid data type for attribute " + f2 + ": " + h);
                        s(t5, e5, p2[0], i3, d2, a2, f2);
                      } else {
                        if (!(h.indexOf("mat") >= 0))
                          throw new n3("", "Unknown data type for attribute " + f2 + ": " + h);
                        var d2;
                        if ((d2 = h.charCodeAt(h.length - 1) - 48) < 2 || d2 > 4)
                          throw new n3("", "Invalid data type for attribute " + f2 + ": " + h);
                        l(t5, e5, p2, i3, d2, a2, f2);
                      }
                  }
                }
                return a2;
              };
              var n3 = r4(9068);
              function i2(t5, e5, r5, n4, i3, a2) {
                this._gl = t5, this._wrapper = e5, this._index = r5, this._locations = n4, this._dimension = i3, this._constFunc = a2;
              }
              var a = i2.prototype;
              a.pointer = function(t5, e5, r5, n4) {
                var i3 = this, a2 = i3._gl, o2 = i3._locations[i3._index];
                a2.vertexAttribPointer(o2, i3._dimension, t5 || a2.FLOAT, !!e5, r5 || 0, n4 || 0), a2.enableVertexAttribArray(o2);
              }, a.set = function(t5, e5, r5, n4) {
                return this._constFunc(this._locations[this._index], t5, e5, r5, n4);
              }, Object.defineProperty(a, "location", { get: function() {
                return this._locations[this._index];
              }, set: function(t5) {
                return t5 !== this._locations[this._index] && (this._locations[this._index] = 0 | t5, this._wrapper.program = null), 0 | t5;
              } });
              var o = [function(t5, e5, r5) {
                return void 0 === r5.length ? t5.vertexAttrib1f(e5, r5) : t5.vertexAttrib1fv(e5, r5);
              }, function(t5, e5, r5, n4) {
                return void 0 === r5.length ? t5.vertexAttrib2f(e5, r5, n4) : t5.vertexAttrib2fv(e5, r5);
              }, function(t5, e5, r5, n4, i3) {
                return void 0 === r5.length ? t5.vertexAttrib3f(e5, r5, n4, i3) : t5.vertexAttrib3fv(e5, r5);
              }, function(t5, e5, r5, n4, i3, a2) {
                return void 0 === r5.length ? t5.vertexAttrib4f(e5, r5, n4, i3, a2) : t5.vertexAttrib4fv(e5, r5);
              }];
              function s(t5, e5, r5, n4, a2, s2, l2) {
                var u = o[a2], c = new i2(t5, e5, r5, n4, a2, u);
                Object.defineProperty(s2, l2, { set: function(e6) {
                  return t5.disableVertexAttribArray(n4[r5]), u(t5, n4[r5], e6), e6;
                }, get: function() {
                  return c;
                }, enumerable: true });
              }
              function l(t5, e5, r5, n4, i3, a2, o2) {
                for (var l2 = new Array(i3), u = new Array(i3), c = 0; c < i3; ++c)
                  s(t5, e5, r5[c], n4, i3, l2, c), u[c] = l2[c];
                Object.defineProperty(l2, "location", { set: function(t6) {
                  if (Array.isArray(t6))
                    for (var e6 = 0; e6 < i3; ++e6)
                      u[e6].location = t6[e6];
                  else
                    for (e6 = 0; e6 < i3; ++e6)
                      u[e6].location = t6 + e6;
                  return t6;
                }, get: function() {
                  for (var t6 = new Array(i3), e6 = 0; e6 < i3; ++e6)
                    t6[e6] = n4[r5[e6]];
                  return t6;
                }, enumerable: true }), l2.pointer = function(e6, a3, o3, s2) {
                  e6 = e6 || t5.FLOAT, a3 = !!a3, o3 = o3 || i3 * i3, s2 = s2 || 0;
                  for (var l3 = 0; l3 < i3; ++l3) {
                    var u2 = n4[r5[l3]];
                    t5.vertexAttribPointer(u2, i3, e6, a3, o3, s2 + l3 * i3), t5.enableVertexAttribArray(u2);
                  }
                };
                var f2 = new Array(i3), h = t5["vertexAttrib" + i3 + "fv"];
                Object.defineProperty(a2, o2, { set: function(e6) {
                  for (var a3 = 0; a3 < i3; ++a3) {
                    var o3 = n4[r5[a3]];
                    if (t5.disableVertexAttribArray(o3), Array.isArray(e6[0]))
                      h.call(t5, o3, e6[a3]);
                    else {
                      for (var s2 = 0; s2 < i3; ++s2)
                        f2[s2] = e6[i3 * a3 + s2];
                      h.call(t5, o3, f2);
                    }
                  }
                  return e6;
                }, get: function() {
                  return l2;
                }, enumerable: true });
              }
            }, 9016: function(t4, e4, r4) {
              var n3 = r4(3984), i2 = r4(9068);
              function a(t5) {
                return function() {
                  return t5;
                };
              }
              function o(t5, e5) {
                for (var r5 = new Array(t5), n4 = 0; n4 < t5; ++n4)
                  r5[n4] = e5;
                return r5;
              }
              t4.exports = function(t5, e5, r5, s) {
                function l(e6) {
                  return function(n4) {
                    for (var a2 = u("", e6), o2 = 0; o2 < a2.length; ++o2) {
                      var l2 = a2[o2], c2 = l2[0], f3 = l2[1];
                      if (s[f3]) {
                        var h2 = n4;
                        if ("string" == typeof c2 && (0 === c2.indexOf(".") || 0 === c2.indexOf("["))) {
                          var p2 = c2;
                          if (0 === c2.indexOf(".") && (p2 = c2.slice(1)), p2.indexOf("]") === p2.length - 1) {
                            var d2 = p2.indexOf("["), v = p2.slice(0, d2), g2 = p2.slice(d2 + 1, p2.length - 1);
                            h2 = v ? n4[v][g2] : n4[g2];
                          } else
                            h2 = n4[p2];
                        }
                        var y, m2 = r5[f3].type;
                        switch (m2) {
                          case "bool":
                          case "int":
                          case "sampler2D":
                          case "samplerCube":
                            t5.uniform1i(s[f3], h2);
                            break;
                          case "float":
                            t5.uniform1f(s[f3], h2);
                            break;
                          default:
                            var x = m2.indexOf("vec");
                            if (!(0 <= x && x <= 1 && m2.length === 4 + x)) {
                              if (0 === m2.indexOf("mat") && 4 === m2.length) {
                                if ((y = m2.charCodeAt(m2.length - 1) - 48) < 2 || y > 4)
                                  throw new i2("", "Invalid uniform dimension type for matrix " + name + ": " + m2);
                                t5["uniformMatrix" + y + "fv"](s[f3], false, h2);
                                break;
                              }
                              throw new i2("", "Unknown uniform data type for " + name + ": " + m2);
                            }
                            if ((y = m2.charCodeAt(m2.length - 1) - 48) < 2 || y > 4)
                              throw new i2("", "Invalid data type");
                            switch (m2.charAt(0)) {
                              case "b":
                              case "i":
                                t5["uniform" + y + "iv"](s[f3], h2);
                                break;
                              case "v":
                                t5["uniform" + y + "fv"](s[f3], h2);
                                break;
                              default:
                                throw new i2("", "Unrecognized data type for vector " + name + ": " + m2);
                            }
                        }
                      }
                    }
                  };
                }
                function u(t6, e6) {
                  if ("object" != typeof e6)
                    return [[t6, e6]];
                  var r6 = [];
                  for (var n4 in e6) {
                    var i3 = e6[n4], a2 = t6;
                    parseInt(n4) + "" === n4 ? a2 += "[" + n4 + "]" : a2 += "." + n4, "object" == typeof i3 ? r6.push.apply(r6, u(a2, i3)) : r6.push([a2, i3]);
                  }
                  return r6;
                }
                function c(t6, e6, n4) {
                  if ("object" == typeof n4) {
                    var u2 = f2(n4);
                    Object.defineProperty(t6, e6, { get: a(u2), set: l(n4), enumerable: true, configurable: false });
                  } else
                    s[n4] ? Object.defineProperty(t6, e6, { get: (c2 = n4, function(t7, e7, r6) {
                      return t7.getUniform(e7.program, r6[c2]);
                    }), set: l(n4), enumerable: true, configurable: false }) : t6[e6] = function(t7) {
                      switch (t7) {
                        case "bool":
                          return false;
                        case "int":
                        case "sampler2D":
                        case "samplerCube":
                        case "float":
                          return 0;
                        default:
                          var e7 = t7.indexOf("vec");
                          if (0 <= e7 && e7 <= 1 && t7.length === 4 + e7) {
                            if ((r6 = t7.charCodeAt(t7.length - 1) - 48) < 2 || r6 > 4)
                              throw new i2("", "Invalid data type");
                            return "b" === t7.charAt(0) ? o(r6, false) : o(r6, 0);
                          }
                          if (0 === t7.indexOf("mat") && 4 === t7.length) {
                            var r6;
                            if ((r6 = t7.charCodeAt(t7.length - 1) - 48) < 2 || r6 > 4)
                              throw new i2("", "Invalid uniform dimension type for matrix " + name + ": " + t7);
                            return o(r6 * r6, 0);
                          }
                          throw new i2("", "Unknown uniform data type for " + name + ": " + t7);
                      }
                    }(r5[n4].type);
                  var c2;
                }
                function f2(t6) {
                  var e6;
                  if (Array.isArray(t6)) {
                    e6 = new Array(t6.length);
                    for (var r6 = 0; r6 < t6.length; ++r6)
                      c(e6, r6, t6[r6]);
                  } else
                    for (var n4 in e6 = {}, t6)
                      c(e6, n4, t6[n4]);
                  return e6;
                }
                var h = n3(r5, true);
                return { get: a(f2(h)), set: l(h), enumerable: true, configurable: true };
              };
            }, 3984: function(t4) {
              t4.exports = function(t5, e4) {
                for (var r4 = {}, n3 = 0; n3 < t5.length; ++n3)
                  for (var i2 = t5[n3].name.split("."), a = r4, o = 0; o < i2.length; ++o) {
                    var s = i2[o].split("[");
                    if (s.length > 1) {
                      s[0] in a || (a[s[0]] = []), a = a[s[0]];
                      for (var l = 1; l < s.length; ++l) {
                        var u = parseInt(s[l]);
                        l < s.length - 1 || o < i2.length - 1 ? (u in a || (l < s.length - 1 ? a[u] = [] : a[u] = {}), a = a[u]) : a[u] = e4 ? n3 : t5[n3].type;
                      }
                    } else
                      o < i2.length - 1 ? (s[0] in a || (a[s[0]] = {}), a = a[s[0]]) : a[s[0]] = e4 ? n3 : t5[n3].type;
                  }
                return r4;
              };
            }, 2631: function(t4, e4) {
              e4.uniforms = function(t5, e5) {
                for (var r5 = t5.getProgramParameter(e5, t5.ACTIVE_UNIFORMS), n4 = [], a = 0; a < r5; ++a) {
                  var o = t5.getActiveUniform(e5, a);
                  if (o) {
                    var s = i2(t5, o.type);
                    if (o.size > 1)
                      for (var l = 0; l < o.size; ++l)
                        n4.push({ name: o.name.replace("[0]", "[" + l + "]"), type: s });
                    else
                      n4.push({ name: o.name, type: s });
                  }
                }
                return n4;
              }, e4.attributes = function(t5, e5) {
                for (var r5 = t5.getProgramParameter(e5, t5.ACTIVE_ATTRIBUTES), n4 = [], a = 0; a < r5; ++a) {
                  var o = t5.getActiveAttrib(e5, a);
                  o && n4.push({ name: o.name, type: i2(t5, o.type) });
                }
                return n4;
              };
              var r4 = { FLOAT: "float", FLOAT_VEC2: "vec2", FLOAT_VEC3: "vec3", FLOAT_VEC4: "vec4", INT: "int", INT_VEC2: "ivec2", INT_VEC3: "ivec3", INT_VEC4: "ivec4", BOOL: "bool", BOOL_VEC2: "bvec2", BOOL_VEC3: "bvec3", BOOL_VEC4: "bvec4", FLOAT_MAT2: "mat2", FLOAT_MAT3: "mat3", FLOAT_MAT4: "mat4", SAMPLER_2D: "sampler2D", SAMPLER_CUBE: "samplerCube" }, n3 = null;
              function i2(t5, e5) {
                if (!n3) {
                  var i3 = Object.keys(r4);
                  n3 = {};
                  for (var a = 0; a < i3.length; ++a) {
                    var o = i3[a];
                    n3[t5[o]] = r4[o];
                  }
                }
                return n3[e5];
              }
            }, 1628: function(t4, e4, r4) {
              e4.shader = function(t5, e5, r5) {
                return c(t5).getShaderReference(e5, r5);
              }, e4.program = function(t5, e5, r5, n4, i3) {
                return c(t5).getProgram(e5, r5, n4, i3);
              };
              var n3 = r4(9068), i2 = r4(3530), a = new ("undefined" == typeof WeakMap ? r4(4037) : WeakMap)(), o = 0;
              function s(t5, e5, r5, n4, i3, a2, o2) {
                this.id = t5, this.src = e5, this.type = r5, this.shader = n4, this.count = a2, this.programs = [], this.cache = o2;
              }
              function l(t5) {
                this.gl = t5, this.shaders = [{}, {}], this.programs = {};
              }
              s.prototype.dispose = function() {
                if (0 == --this.count) {
                  for (var t5 = this.cache, e5 = t5.gl, r5 = this.programs, n4 = 0, i3 = r5.length; n4 < i3; ++n4) {
                    var a2 = t5.programs[r5[n4]];
                    a2 && (delete t5.programs[n4], e5.deleteProgram(a2));
                  }
                  e5.deleteShader(this.shader), delete t5.shaders[this.type === e5.FRAGMENT_SHADER | 0][this.src];
                }
              };
              var u = l.prototype;
              function c(t5) {
                var e5 = a.get(t5);
                return e5 || (e5 = new l(t5), a.set(t5, e5)), e5;
              }
              u.getShaderReference = function(t5, e5) {
                var r5 = this.gl, a2 = this.shaders[t5 === r5.FRAGMENT_SHADER | 0], l2 = a2[e5];
                if (l2 && r5.isShader(l2.shader))
                  l2.count += 1;
                else {
                  var u2 = function(t6, e6, r6) {
                    var a3 = t6.createShader(e6);
                    if (t6.shaderSource(a3, r6), t6.compileShader(a3), !t6.getShaderParameter(a3, t6.COMPILE_STATUS)) {
                      var o2 = t6.getShaderInfoLog(a3);
                      try {
                        var s2 = i2(o2, r6, e6);
                      } catch (t7) {
                        throw console.warn("Failed to format compiler error: " + t7), new n3(o2, "Error compiling shader:\n" + o2);
                      }
                      throw new n3(o2, s2.short, s2.long);
                    }
                    return a3;
                  }(r5, t5, e5);
                  l2 = a2[e5] = new s(o++, e5, t5, u2, [], 1, this);
                }
                return l2;
              }, u.getProgram = function(t5, e5, r5, i3) {
                var a2 = [t5.id, e5.id, r5.join(":"), i3.join(":")].join("@"), o2 = this.programs[a2];
                return o2 && this.gl.isProgram(o2) || (this.programs[a2] = o2 = function(t6, e6, r6, i4, a3) {
                  var o3 = t6.createProgram();
                  t6.attachShader(o3, e6), t6.attachShader(o3, r6);
                  for (var s2 = 0; s2 < i4.length; ++s2)
                    t6.bindAttribLocation(o3, a3[s2], i4[s2]);
                  if (t6.linkProgram(o3), !t6.getProgramParameter(o3, t6.LINK_STATUS)) {
                    var l2 = t6.getProgramInfoLog(o3);
                    throw new n3(l2, "Error linking program: " + l2);
                  }
                  return o3;
                }(this.gl, t5.shader, e5.shader, r5, i3), t5.programs.push(a2), e5.programs.push(a2)), o2;
              };
            }, 3050: function(t4) {
              function e4(t5) {
                this.plot = t5, this.enable = [true, true, false, false], this.width = [1, 1, 1, 1], this.color = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.center = [1 / 0, 1 / 0];
              }
              t4.exports = function(t5, r5) {
                var n3 = new e4(t5);
                return n3.update(r5), t5.addOverlay(n3), n3;
              };
              var r4 = e4.prototype;
              r4.update = function(t5) {
                t5 = t5 || {}, this.enable = (t5.enable || [true, true, false, false]).slice(), this.width = (t5.width || [1, 1, 1, 1]).slice(), this.color = (t5.color || [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]]).map(function(t6) {
                  return t6.slice();
                }), this.center = (t5.center || [1 / 0, 1 / 0]).slice(), this.plot.setOverlayDirty();
              }, r4.draw = function() {
                var t5 = this.enable, e5 = this.width, r5 = this.color, n3 = this.center, i2 = this.plot, a = i2.line, o = i2.dataBox, s = i2.viewBox;
                if (a.bind(), o[0] <= n3[0] && n3[0] <= o[2] && o[1] <= n3[1] && n3[1] <= o[3]) {
                  var l = s[0] + (n3[0] - o[0]) / (o[2] - o[0]) * (s[2] - s[0]), u = s[1] + (n3[1] - o[1]) / (o[3] - o[1]) * (s[3] - s[1]);
                  t5[0] && a.drawLine(l, u, s[0], u, e5[0], r5[0]), t5[1] && a.drawLine(l, u, l, s[1], e5[1], r5[1]), t5[2] && a.drawLine(l, u, s[2], u, e5[2], r5[2]), t5[3] && a.drawLine(l, u, l, s[3], e5[3], r5[3]);
                }
              }, r4.dispose = function() {
                this.plot.removeOverlay(this);
              };
            }, 3540: function(t4, e4, r4) {
              var n3 = r4(6832), i2 = r4(5158), a = n3(["precision mediump float;\n#define GLSLIFY 1\n\nattribute vec3 position, color;\nattribute float weight;\n\nuniform mat4 model, view, projection;\nuniform vec3 coordinates[3];\nuniform vec4 colors[3];\nuniform vec2 screenShape;\nuniform float lineWidth;\n\nvarying vec4 fragColor;\n\nvoid main() {\n  vec3 vertexPosition = mix(coordinates[0],\n    mix(coordinates[2], coordinates[1], 0.5 * (position + 1.0)), abs(position));\n\n  vec4 clipPos = projection * view * model * vec4(vertexPosition, 1.0);\n  vec2 clipOffset = (projection * view * model * vec4(color, 0.0)).xy;\n  vec2 delta = weight * clipOffset * screenShape;\n  vec2 lineOffset = normalize(vec2(delta.y, -delta.x)) / screenShape;\n\n  gl_Position   = vec4(clipPos.xy + clipPos.w * 0.5 * lineWidth * lineOffset, clipPos.z, clipPos.w);\n  fragColor     = color.x * colors[0] + color.y * colors[1] + color.z * colors[2];\n}\n"]), o = n3(["precision mediump float;\n#define GLSLIFY 1\n\nvarying vec4 fragColor;\n\nvoid main() {\n  gl_FragColor = fragColor;\n}"]);
              t4.exports = function(t5) {
                return i2(t5, a, o, null, [{ name: "position", type: "vec3" }, { name: "color", type: "vec3" }, { name: "weight", type: "float" }]);
              };
            }, 6496: function(t4, e4, r4) {
              var n3 = r4(5827), i2 = r4(2944), a = r4(3540);
              t4.exports = function(t5, e5) {
                var r5 = [];
                function o2(t6, e6, n4, i3, a2, o3) {
                  var s2 = [t6, e6, n4, 0, 0, 0, 1];
                  s2[i3 + 3] = 1, s2[i3] = a2, r5.push.apply(r5, s2), s2[6] = -1, r5.push.apply(r5, s2), s2[i3] = o3, r5.push.apply(r5, s2), r5.push.apply(r5, s2), s2[6] = 1, r5.push.apply(r5, s2), s2[i3] = a2, r5.push.apply(r5, s2);
                }
                o2(0, 0, 0, 0, 0, 1), o2(0, 0, 0, 1, 0, 1), o2(0, 0, 0, 2, 0, 1), o2(1, 0, 0, 1, -1, 1), o2(1, 0, 0, 2, -1, 1), o2(0, 1, 0, 0, -1, 1), o2(0, 1, 0, 2, -1, 1), o2(0, 0, 1, 0, -1, 1), o2(0, 0, 1, 1, -1, 1);
                var l2 = n3(t5, r5), u2 = i2(t5, [{ type: t5.FLOAT, buffer: l2, size: 3, offset: 0, stride: 28 }, { type: t5.FLOAT, buffer: l2, size: 3, offset: 12, stride: 28 }, { type: t5.FLOAT, buffer: l2, size: 1, offset: 24, stride: 28 }]), c2 = a(t5);
                c2.attributes.position.location = 0, c2.attributes.color.location = 1, c2.attributes.weight.location = 2;
                var f3 = new s(t5, l2, u2, c2);
                return f3.update(e5), f3;
              };
              var o = [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1];
              function s(t5, e5, r5, n4) {
                this.gl = t5, this.buffer = e5, this.vao = r5, this.shader = n4, this.pixelRatio = 1, this.bounds = [[-1e3, -1e3, -1e3], [1e3, 1e3, 1e3]], this.position = [0, 0, 0], this.lineWidth = [2, 2, 2], this.colors = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.enabled = [true, true, true], this.drawSides = [true, true, true], this.axes = null;
              }
              var l = s.prototype, u = [0, 0, 0], c = [0, 0, 0], f2 = [0, 0];
              l.isTransparent = function() {
                return false;
              }, l.drawTransparent = function(t5) {
              }, l.draw = function(t5) {
                var e5 = this.gl, r5 = this.vao, n4 = this.shader;
                r5.bind(), n4.bind();
                var i3, a2 = t5.model || o, s2 = t5.view || o, l2 = t5.projection || o;
                this.axes && (i3 = this.axes.lastCubeProps.axis);
                for (var h = u, p2 = c, d2 = 0; d2 < 3; ++d2)
                  i3 && i3[d2] < 0 ? (h[d2] = this.bounds[0][d2], p2[d2] = this.bounds[1][d2]) : (h[d2] = this.bounds[1][d2], p2[d2] = this.bounds[0][d2]);
                for (f2[0] = e5.drawingBufferWidth, f2[1] = e5.drawingBufferHeight, n4.uniforms.model = a2, n4.uniforms.view = s2, n4.uniforms.projection = l2, n4.uniforms.coordinates = [this.position, h, p2], n4.uniforms.colors = this.colors, n4.uniforms.screenShape = f2, d2 = 0; d2 < 3; ++d2)
                  n4.uniforms.lineWidth = this.lineWidth[d2] * this.pixelRatio, this.enabled[d2] && (r5.draw(e5.TRIANGLES, 6, 6 * d2), this.drawSides[d2] && r5.draw(e5.TRIANGLES, 12, 18 + 12 * d2));
                r5.unbind();
              }, l.update = function(t5) {
                t5 && ("bounds" in t5 && (this.bounds = t5.bounds), "position" in t5 && (this.position = t5.position), "lineWidth" in t5 && (this.lineWidth = t5.lineWidth), "colors" in t5 && (this.colors = t5.colors), "enabled" in t5 && (this.enabled = t5.enabled), "drawSides" in t5 && (this.drawSides = t5.drawSides));
              }, l.dispose = function() {
                this.vao.dispose(), this.buffer.dispose(), this.shader.dispose();
              };
            }, 9578: function(t4, e4, r4) {
              var n3 = r4(6832), i2 = n3(["precision highp float;\n\nprecision highp float;\n#define GLSLIFY 1\n\nvec3 getOrthogonalVector(vec3 v) {\n  // Return up-vector for only-z vector.\n  // Return ax + by + cz = 0, a point that lies on the plane that has v as a normal and that isn't (0,0,0).\n  // From the above if-statement we have ||a|| > 0  U  ||b|| > 0.\n  // Assign z = 0, x = -b, y = a:\n  // a*-b + b*a + c*0 = -ba + ba + 0 = 0\n  if (v.x*v.x > v.z*v.z || v.y*v.y > v.z*v.z) {\n    return normalize(vec3(-v.y, v.x, 0.0));\n  } else {\n    return normalize(vec3(0.0, v.z, -v.y));\n  }\n}\n\n// Calculate the tube vertex and normal at the given index.\n//\n// The returned vertex is for a tube ring with its center at origin, radius of length(d), pointing in the direction of d.\n//\n// Each tube segment is made up of a ring of vertices.\n// These vertices are used to make up the triangles of the tube by connecting them together in the vertex array.\n// The indexes of tube segments run from 0 to 8.\n//\nvec3 getTubePosition(vec3 d, float index, out vec3 normal) {\n  float segmentCount = 8.0;\n\n  float angle = 2.0 * 3.14159 * (index / segmentCount);\n\n  vec3 u = getOrthogonalVector(d);\n  vec3 v = normalize(cross(u, d));\n\n  vec3 x = u * cos(angle) * length(d);\n  vec3 y = v * sin(angle) * length(d);\n  vec3 v3 = x + y;\n\n  normal = normalize(v3);\n\n  return v3;\n}\n\nattribute vec4 vector;\nattribute vec4 color, position;\nattribute vec2 uv;\n\nuniform float vectorScale, tubeScale;\nuniform mat4 model, view, projection, inverseModel;\nuniform vec3 eyePosition, lightPosition;\n\nvarying vec3 f_normal, f_lightDirection, f_eyeDirection, f_data, f_position;\nvarying vec4 f_color;\nvarying vec2 f_uv;\n\nvoid main() {\n  // Scale the vector magnitude to stay constant with\n  // model & view changes.\n  vec3 normal;\n  vec3 XYZ = getTubePosition(mat3(model) * (tubeScale * vector.w * normalize(vector.xyz)), position.w, normal);\n  vec4 tubePosition = model * vec4(position.xyz, 1.0) + vec4(XYZ, 0.0);\n\n  //Lighting geometry parameters\n  vec4 cameraCoordinate = view * tubePosition;\n  cameraCoordinate.xyz /= cameraCoordinate.w;\n  f_lightDirection = lightPosition - cameraCoordinate.xyz;\n  f_eyeDirection   = eyePosition - cameraCoordinate.xyz;\n  f_normal = normalize((vec4(normal, 0.0) * inverseModel).xyz);\n\n  // vec4 m_position  = model * vec4(tubePosition, 1.0);\n  vec4 t_position  = view * tubePosition;\n  gl_Position      = projection * t_position;\n\n  f_color          = color;\n  f_data           = tubePosition.xyz;\n  f_position       = position.xyz;\n  f_uv             = uv;\n}\n"]), a = n3(["#extension GL_OES_standard_derivatives : enable\n\nprecision highp float;\n#define GLSLIFY 1\n\nfloat beckmannDistribution(float x, float roughness) {\n  float NdotH = max(x, 0.0001);\n  float cos2Alpha = NdotH * NdotH;\n  float tan2Alpha = (cos2Alpha - 1.0) / cos2Alpha;\n  float roughness2 = roughness * roughness;\n  float denom = 3.141592653589793 * roughness2 * cos2Alpha * cos2Alpha;\n  return exp(tan2Alpha / roughness2) / denom;\n}\n\nfloat cookTorranceSpecular(\n  vec3 lightDirection,\n  vec3 viewDirection,\n  vec3 surfaceNormal,\n  float roughness,\n  float fresnel) {\n\n  float VdotN = max(dot(viewDirection, surfaceNormal), 0.0);\n  float LdotN = max(dot(lightDirection, surfaceNormal), 0.0);\n\n  //Half angle vector\n  vec3 H = normalize(lightDirection + viewDirection);\n\n  //Geometric term\n  float NdotH = max(dot(surfaceNormal, H), 0.0);\n  float VdotH = max(dot(viewDirection, H), 0.000001);\n  float LdotH = max(dot(lightDirection, H), 0.000001);\n  float G1 = (2.0 * NdotH * VdotN) / VdotH;\n  float G2 = (2.0 * NdotH * LdotN) / LdotH;\n  float G = min(1.0, min(G1, G2));\n  \n  //Distribution term\n  float D = beckmannDistribution(NdotH, roughness);\n\n  //Fresnel term\n  float F = pow(1.0 - VdotN, fresnel);\n\n  //Multiply terms and done\n  return  G * F * D / max(3.14159265 * VdotN, 0.000001);\n}\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec3 clipBounds[2];\nuniform float roughness, fresnel, kambient, kdiffuse, kspecular, opacity;\nuniform sampler2D texture;\n\nvarying vec3 f_normal, f_lightDirection, f_eyeDirection, f_data, f_position;\nvarying vec4 f_color;\nvarying vec2 f_uv;\n\nvoid main() {\n  if (outOfRange(clipBounds[0], clipBounds[1], f_position)) discard;\n  vec3 N = normalize(f_normal);\n  vec3 L = normalize(f_lightDirection);\n  vec3 V = normalize(f_eyeDirection);\n\n  if(gl_FrontFacing) {\n    N = -N;\n  }\n\n  float specular = min(1.0, max(0.0, cookTorranceSpecular(L, V, N, roughness, fresnel)));\n  float diffuse  = min(kambient + kdiffuse * max(dot(N, L), 0.0), 1.0);\n\n  vec4 surfaceColor = f_color * texture2D(texture, f_uv);\n  vec4 litColor = surfaceColor.a * vec4(diffuse * surfaceColor.rgb + kspecular * vec3(1,1,1) * specular,  1.0);\n\n  gl_FragColor = litColor * opacity;\n}\n"]), o = n3(["precision highp float;\n\nprecision highp float;\n#define GLSLIFY 1\n\nvec3 getOrthogonalVector(vec3 v) {\n  // Return up-vector for only-z vector.\n  // Return ax + by + cz = 0, a point that lies on the plane that has v as a normal and that isn't (0,0,0).\n  // From the above if-statement we have ||a|| > 0  U  ||b|| > 0.\n  // Assign z = 0, x = -b, y = a:\n  // a*-b + b*a + c*0 = -ba + ba + 0 = 0\n  if (v.x*v.x > v.z*v.z || v.y*v.y > v.z*v.z) {\n    return normalize(vec3(-v.y, v.x, 0.0));\n  } else {\n    return normalize(vec3(0.0, v.z, -v.y));\n  }\n}\n\n// Calculate the tube vertex and normal at the given index.\n//\n// The returned vertex is for a tube ring with its center at origin, radius of length(d), pointing in the direction of d.\n//\n// Each tube segment is made up of a ring of vertices.\n// These vertices are used to make up the triangles of the tube by connecting them together in the vertex array.\n// The indexes of tube segments run from 0 to 8.\n//\nvec3 getTubePosition(vec3 d, float index, out vec3 normal) {\n  float segmentCount = 8.0;\n\n  float angle = 2.0 * 3.14159 * (index / segmentCount);\n\n  vec3 u = getOrthogonalVector(d);\n  vec3 v = normalize(cross(u, d));\n\n  vec3 x = u * cos(angle) * length(d);\n  vec3 y = v * sin(angle) * length(d);\n  vec3 v3 = x + y;\n\n  normal = normalize(v3);\n\n  return v3;\n}\n\nattribute vec4 vector;\nattribute vec4 position;\nattribute vec4 id;\n\nuniform mat4 model, view, projection;\nuniform float tubeScale;\n\nvarying vec3 f_position;\nvarying vec4 f_id;\n\nvoid main() {\n  vec3 normal;\n  vec3 XYZ = getTubePosition(mat3(model) * (tubeScale * vector.w * normalize(vector.xyz)), position.w, normal);\n  vec4 tubePosition = model * vec4(position.xyz, 1.0) + vec4(XYZ, 0.0);\n\n  gl_Position = projection * view * tubePosition;\n  f_id        = id;\n  f_position  = position.xyz;\n}\n"]), s = n3(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec3  clipBounds[2];\nuniform float pickId;\n\nvarying vec3 f_position;\nvarying vec4 f_id;\n\nvoid main() {\n  if (outOfRange(clipBounds[0], clipBounds[1], f_position)) discard;\n\n  gl_FragColor = vec4(pickId, f_id.xyz);\n}"]);
              e4.meshShader = { vertex: i2, fragment: a, attributes: [{ name: "position", type: "vec4" }, { name: "color", type: "vec4" }, { name: "uv", type: "vec2" }, { name: "vector", type: "vec4" }] }, e4.pickShader = { vertex: o, fragment: s, attributes: [{ name: "position", type: "vec4" }, { name: "id", type: "vec4" }, { name: "vector", type: "vec4" }] };
            }, 7307: function(t4, e4, r4) {
              var n3 = r4(2858), i2 = r4(4020), a = ["xyz", "xzy", "yxz", "yzx", "zxy", "zyx"], o = function(t5, e5) {
                var r5, n4 = t5.length;
                for (r5 = 0; r5 < n4; r5++) {
                  var i3 = t5[r5];
                  if (i3 === e5)
                    return r5;
                  if (i3 > e5)
                    return r5 - 1;
                }
                return r5;
              }, s = function(t5, e5, r5) {
                return t5 < e5 ? e5 : t5 > r5 ? r5 : t5;
              }, l = function(t5) {
                var e5 = 1 / 0;
                t5.sort(function(t6, e6) {
                  return t6 - e6;
                });
                for (var r5 = t5.length, n4 = 1; n4 < r5; n4++) {
                  var i3 = Math.abs(t5[n4] - t5[n4 - 1]);
                  i3 < e5 && (e5 = i3);
                }
                return e5;
              };
              t4.exports = function(t5, e5) {
                var r5 = t5.startingPositions, u2 = t5.maxLength || 1e3, c2 = t5.tubeSize || 1, f2 = t5.absoluteTubeSize, h = t5.gridFill || "+x+y+z", p2 = {};
                -1 !== h.indexOf("-x") && (p2.reversedX = true), -1 !== h.indexOf("-y") && (p2.reversedY = true), -1 !== h.indexOf("-z") && (p2.reversedZ = true), p2.filled = a.indexOf(h.replace(/-/g, "").replace(/\+/g, ""));
                var d2 = t5.getVelocity || function(e6) {
                  return function(t6, e7, r6) {
                    var i3 = e7.vectors, a2 = e7.meshgrid, l2 = t6[0], u3 = t6[1], c3 = t6[2], f3 = a2[0].length, h2 = a2[1].length, p3 = a2[2].length, d3 = o(a2[0], l2), v2 = o(a2[1], u3), g3 = o(a2[2], c3), y2 = d3 + 1, m3 = v2 + 1, x2 = g3 + 1;
                    if (d3 = s(d3, 0, f3 - 1), y2 = s(y2, 0, f3 - 1), v2 = s(v2, 0, h2 - 1), m3 = s(m3, 0, h2 - 1), g3 = s(g3, 0, p3 - 1), x2 = s(x2, 0, p3 - 1), d3 < 0 || v2 < 0 || g3 < 0 || y2 > f3 - 1 || m3 > h2 - 1 || x2 > p3 - 1)
                      return n3.create();
                    var b2, _2, w3, T2, k2, A2, M2 = a2[0][d3], S2 = a2[0][y2], E2 = a2[1][v2], L2 = a2[1][m3], C2 = a2[2][g3], P2 = (l2 - M2) / (S2 - M2), O2 = (u3 - E2) / (L2 - E2), I2 = (c3 - C2) / (a2[2][x2] - C2);
                    switch (isFinite(P2) || (P2 = 0.5), isFinite(O2) || (O2 = 0.5), isFinite(I2) || (I2 = 0.5), r6.reversedX && (d3 = f3 - 1 - d3, y2 = f3 - 1 - y2), r6.reversedY && (v2 = h2 - 1 - v2, m3 = h2 - 1 - m3), r6.reversedZ && (g3 = p3 - 1 - g3, x2 = p3 - 1 - x2), r6.filled) {
                      case 5:
                        k2 = g3, A2 = x2, w3 = v2 * p3, T2 = m3 * p3, b2 = d3 * p3 * h2, _2 = y2 * p3 * h2;
                        break;
                      case 4:
                        k2 = g3, A2 = x2, b2 = d3 * p3, _2 = y2 * p3, w3 = v2 * p3 * f3, T2 = m3 * p3 * f3;
                        break;
                      case 3:
                        w3 = v2, T2 = m3, k2 = g3 * h2, A2 = x2 * h2, b2 = d3 * h2 * p3, _2 = y2 * h2 * p3;
                        break;
                      case 2:
                        w3 = v2, T2 = m3, b2 = d3 * h2, _2 = y2 * h2, k2 = g3 * h2 * f3, A2 = x2 * h2 * f3;
                        break;
                      case 1:
                        b2 = d3, _2 = y2, k2 = g3 * f3, A2 = x2 * f3, w3 = v2 * f3 * p3, T2 = m3 * f3 * p3;
                        break;
                      default:
                        b2 = d3, _2 = y2, w3 = v2 * f3, T2 = m3 * f3, k2 = g3 * f3 * h2, A2 = x2 * f3 * h2;
                    }
                    var D2 = i3[b2 + w3 + k2], z2 = i3[b2 + w3 + A2], R2 = i3[b2 + T2 + k2], F2 = i3[b2 + T2 + A2], B2 = i3[_2 + w3 + k2], N2 = i3[_2 + w3 + A2], j2 = i3[_2 + T2 + k2], U2 = i3[_2 + T2 + A2], V = n3.create(), H = n3.create(), q2 = n3.create(), G = n3.create();
                    n3.lerp(V, D2, B2, P2), n3.lerp(H, z2, N2, P2), n3.lerp(q2, R2, j2, P2), n3.lerp(G, F2, U2, P2);
                    var Z = n3.create(), Y = n3.create();
                    n3.lerp(Z, V, q2, O2), n3.lerp(Y, H, G, O2);
                    var W = n3.create();
                    return n3.lerp(W, Z, Y, I2), W;
                  }(e6, t5, p2);
                }, v = t5.getDivergence || function(t6, e6) {
                  var r6 = n3.create(), i3 = 1e-4;
                  n3.add(r6, t6, [i3, 0, 0]);
                  var a2 = d2(r6);
                  n3.subtract(a2, a2, e6), n3.scale(a2, a2, 1 / i3), n3.add(r6, t6, [0, i3, 0]);
                  var o2 = d2(r6);
                  n3.subtract(o2, o2, e6), n3.scale(o2, o2, 1 / i3), n3.add(r6, t6, [0, 0, i3]);
                  var s2 = d2(r6);
                  return n3.subtract(s2, s2, e6), n3.scale(s2, s2, 1 / i3), n3.add(r6, a2, o2), n3.add(r6, r6, s2), r6;
                }, g2 = [], y = e5[0][0], m2 = e5[0][1], x = e5[0][2], b = e5[1][0], _ = e5[1][1], w2 = e5[1][2], T = function(t6) {
                  var e6 = t6[0], r6 = t6[1], n4 = t6[2];
                  return !(e6 < y || e6 > b || r6 < m2 || r6 > _ || n4 < x || n4 > w2);
                }, k = 10 * n3.distance(e5[0], e5[1]) / u2, A = k * k, M = 1, S = 0, E = r5.length;
                E > 1 && (M = function(t6) {
                  for (var e6 = [], r6 = [], n4 = [], i3 = {}, a2 = {}, o2 = {}, s2 = t6.length, u3 = 0; u3 < s2; u3++) {
                    var c3 = t6[u3], f3 = c3[0], h2 = c3[1], p3 = c3[2];
                    i3[f3] || (e6.push(f3), i3[f3] = true), a2[h2] || (r6.push(h2), a2[h2] = true), o2[p3] || (n4.push(p3), o2[p3] = true);
                  }
                  var d3 = l(e6), v2 = l(r6), g3 = l(n4), y2 = Math.min(d3, v2, g3);
                  return isFinite(y2) ? y2 : 1;
                }(r5));
                for (var L = 0; L < E; L++) {
                  var C = n3.create();
                  n3.copy(C, r5[L]);
                  var P = [C], O = [], I = d2(C), D = C;
                  O.push(I);
                  var z = [], R = v(C, I), F = n3.length(R);
                  isFinite(F) && F > S && (S = F), z.push(F), g2.push({ points: P, velocities: O, divergences: z });
                  for (var B = 0; B < 100 * u2 && P.length < u2 && T(C); ) {
                    B++;
                    var N = n3.clone(I), j = n3.squaredLength(N);
                    if (0 === j)
                      break;
                    j > A && n3.scale(N, N, k / Math.sqrt(j)), n3.add(N, N, C), I = d2(N), n3.squaredDistance(D, N) - A > -1e-4 * A && (P.push(N), D = N, O.push(I), R = v(N, I), F = n3.length(R), isFinite(F) && F > S && (S = F), z.push(F)), C = N;
                  }
                }
                var U = function(t6, e6, r6, a2) {
                  for (var o2 = 0, s2 = 0; s2 < t6.length; s2++)
                    for (var l2 = t6[s2].velocities, u3 = 0; u3 < l2.length; u3++)
                      o2 = Math.max(o2, n3.length(l2[u3]));
                  var c3 = t6.map(function(t7) {
                    return function(t8, e7, r7, a3) {
                      for (var o3 = t8.points, s3 = t8.velocities, l3 = t8.divergences, u4 = [], c4 = [], f4 = [], h3 = [], p4 = [], d4 = [], v3 = 0, g4 = 0, y3 = i2.create(), m4 = i2.create(), x3 = 0; x3 < o3.length; x3++) {
                        var b2 = o3[x3], _2 = s3[x3], w3 = l3[x3];
                        0 === e7 && (w3 = 0.05 * r7), g4 = n3.length(_2) / a3, y3 = i2.create(), n3.copy(y3, _2), y3[3] = w3;
                        for (var T2 = 0; T2 < 8; T2++)
                          p4[T2] = [b2[0], b2[1], b2[2], T2];
                        if (h3.length > 0)
                          for (T2 = 0; T2 < 8; T2++) {
                            var k2 = (T2 + 1) % 8;
                            u4.push(h3[T2], p4[T2], p4[k2], p4[k2], h3[k2], h3[T2]), f4.push(m4, y3, y3, y3, m4, m4), d4.push(v3, g4, g4, g4, v3, v3);
                            var A2 = u4.length;
                            c4.push([A2 - 6, A2 - 5, A2 - 4], [A2 - 3, A2 - 2, A2 - 1]);
                          }
                        var M2 = h3;
                        h3 = p4, p4 = M2;
                        var S2 = m4;
                        m4 = y3, y3 = S2;
                        var E2 = v3;
                        v3 = g4, g4 = E2;
                      }
                      return { positions: u4, cells: c4, vectors: f4, vertexIntensity: d4 };
                    }(t7, r6, a2, o2);
                  }), f3 = [], h2 = [], p3 = [], d3 = [];
                  for (s2 = 0; s2 < c3.length; s2++) {
                    var v2 = c3[s2], g3 = f3.length;
                    for (f3 = f3.concat(v2.positions), p3 = p3.concat(v2.vectors), d3 = d3.concat(v2.vertexIntensity), u3 = 0; u3 < v2.cells.length; u3++) {
                      var y2 = v2.cells[u3], m3 = [];
                      h2.push(m3);
                      for (var x2 = 0; x2 < y2.length; x2++)
                        m3.push(y2[x2] + g3);
                    }
                  }
                  return { positions: f3, cells: h2, vectors: p3, vertexIntensity: d3, colormap: e6 };
                }(g2, t5.colormap, S, M);
                return f2 ? U.tubeScale = f2 : (0 === S && (S = 1), U.tubeScale = 0.5 * c2 * M / S), U;
              };
              var u = r4(9578), c = r4(1140).createMesh;
              t4.exports.createTubeMesh = function(t5, e5) {
                return c(t5, e5, { shaders: u, traceType: "streamtube" });
              };
            }, 9054: function(t4, e4, r4) {
              var n3 = r4(5158), i2 = r4(6832), a = i2(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec4 uv;\nattribute vec3 f;\nattribute vec3 normal;\n\nuniform vec3 objectOffset;\nuniform mat4 model, view, projection, inverseModel;\nuniform vec3 lightPosition, eyePosition;\nuniform sampler2D colormap;\n\nvarying float value, kill;\nvarying vec3 worldCoordinate;\nvarying vec2 planeCoordinate;\nvarying vec3 lightDirection, eyeDirection, surfaceNormal;\nvarying vec4 vColor;\n\nvoid main() {\n  vec3 localCoordinate = vec3(uv.zw, f.x);\n  worldCoordinate = objectOffset + localCoordinate;\n  vec4 worldPosition = model * vec4(worldCoordinate, 1.0);\n  vec4 clipPosition = projection * view * worldPosition;\n  gl_Position = clipPosition;\n  kill = f.y;\n  value = f.z;\n  planeCoordinate = uv.xy;\n\n  vColor = texture2D(colormap, vec2(value, value));\n\n  //Lighting geometry parameters\n  vec4 cameraCoordinate = view * worldPosition;\n  cameraCoordinate.xyz /= cameraCoordinate.w;\n  lightDirection = lightPosition - cameraCoordinate.xyz;\n  eyeDirection   = eyePosition - cameraCoordinate.xyz;\n  surfaceNormal  = normalize((vec4(normal,0) * inverseModel).xyz);\n}\n"]), o = i2(["precision highp float;\n#define GLSLIFY 1\n\nfloat beckmannDistribution(float x, float roughness) {\n  float NdotH = max(x, 0.0001);\n  float cos2Alpha = NdotH * NdotH;\n  float tan2Alpha = (cos2Alpha - 1.0) / cos2Alpha;\n  float roughness2 = roughness * roughness;\n  float denom = 3.141592653589793 * roughness2 * cos2Alpha * cos2Alpha;\n  return exp(tan2Alpha / roughness2) / denom;\n}\n\nfloat beckmannSpecular(\n  vec3 lightDirection,\n  vec3 viewDirection,\n  vec3 surfaceNormal,\n  float roughness) {\n  return beckmannDistribution(dot(surfaceNormal, normalize(lightDirection + viewDirection)), roughness);\n}\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec3 lowerBound, upperBound;\nuniform float contourTint;\nuniform vec4 contourColor;\nuniform sampler2D colormap;\nuniform vec3 clipBounds[2];\nuniform float roughness, fresnel, kambient, kdiffuse, kspecular, opacity;\nuniform float vertexColor;\n\nvarying float value, kill;\nvarying vec3 worldCoordinate;\nvarying vec3 lightDirection, eyeDirection, surfaceNormal;\nvarying vec4 vColor;\n\nvoid main() {\n  if (\n    kill > 0.0 ||\n    vColor.a == 0.0 ||\n    outOfRange(clipBounds[0], clipBounds[1], worldCoordinate)\n  ) discard;\n\n  vec3 N = normalize(surfaceNormal);\n  vec3 V = normalize(eyeDirection);\n  vec3 L = normalize(lightDirection);\n\n  if(gl_FrontFacing) {\n    N = -N;\n  }\n\n  float specular = max(beckmannSpecular(L, V, N, roughness), 0.);\n  float diffuse  = min(kambient + kdiffuse * max(dot(N, L), 0.0), 1.0);\n\n  //decide how to interpolate color — in vertex or in fragment\n  vec4 surfaceColor =\n    step(vertexColor, .5) * texture2D(colormap, vec2(value, value)) +\n    step(.5, vertexColor) * vColor;\n\n  vec4 litColor = surfaceColor.a * vec4(diffuse * surfaceColor.rgb + kspecular * vec3(1,1,1) * specular,  1.0);\n\n  gl_FragColor = mix(litColor, contourColor, contourTint) * opacity;\n}\n"]), s = i2(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec4 uv;\nattribute float f;\n\nuniform vec3 objectOffset;\nuniform mat3 permutation;\nuniform mat4 model, view, projection;\nuniform float height, zOffset;\nuniform sampler2D colormap;\n\nvarying float value, kill;\nvarying vec3 worldCoordinate;\nvarying vec2 planeCoordinate;\nvarying vec3 lightDirection, eyeDirection, surfaceNormal;\nvarying vec4 vColor;\n\nvoid main() {\n  vec3 dataCoordinate = permutation * vec3(uv.xy, height);\n  worldCoordinate = objectOffset + dataCoordinate;\n  vec4 worldPosition = model * vec4(worldCoordinate, 1.0);\n\n  vec4 clipPosition = projection * view * worldPosition;\n  clipPosition.z += zOffset;\n\n  gl_Position = clipPosition;\n  value = f + objectOffset.z;\n  kill = -1.0;\n  planeCoordinate = uv.zw;\n\n  vColor = texture2D(colormap, vec2(value, value));\n\n  //Don't do lighting for contours\n  surfaceNormal   = vec3(1,0,0);\n  eyeDirection    = vec3(0,1,0);\n  lightDirection  = vec3(0,0,1);\n}\n"]), l = i2(["precision highp float;\n#define GLSLIFY 1\n\nbool outOfRange(float a, float b, float p) {\n  return ((p > max(a, b)) || \n          (p < min(a, b)));\n}\n\nbool outOfRange(vec2 a, vec2 b, vec2 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y));\n}\n\nbool outOfRange(vec3 a, vec3 b, vec3 p) {\n  return (outOfRange(a.x, b.x, p.x) ||\n          outOfRange(a.y, b.y, p.y) ||\n          outOfRange(a.z, b.z, p.z));\n}\n\nbool outOfRange(vec4 a, vec4 b, vec4 p) {\n  return outOfRange(a.xyz, b.xyz, p.xyz);\n}\n\nuniform vec2 shape;\nuniform vec3 clipBounds[2];\nuniform float pickId;\n\nvarying float value, kill;\nvarying vec3 worldCoordinate;\nvarying vec2 planeCoordinate;\nvarying vec3 surfaceNormal;\n\nvec2 splitFloat(float v) {\n  float vh = 255.0 * v;\n  float upper = floor(vh);\n  float lower = fract(vh);\n  return vec2(upper / 255.0, floor(lower * 16.0) / 16.0);\n}\n\nvoid main() {\n  if ((kill > 0.0) ||\n      (outOfRange(clipBounds[0], clipBounds[1], worldCoordinate))) discard;\n\n  vec2 ux = splitFloat(planeCoordinate.x / shape.x);\n  vec2 uy = splitFloat(planeCoordinate.y / shape.y);\n  gl_FragColor = vec4(pickId, ux.x, uy.x, ux.y + (uy.y/16.0));\n}\n"]);
              e4.createShader = function(t5) {
                var e5 = n3(t5, a, o, null, [{ name: "uv", type: "vec4" }, { name: "f", type: "vec3" }, { name: "normal", type: "vec3" }]);
                return e5.attributes.uv.location = 0, e5.attributes.f.location = 1, e5.attributes.normal.location = 2, e5;
              }, e4.createPickShader = function(t5) {
                var e5 = n3(t5, a, l, null, [{ name: "uv", type: "vec4" }, { name: "f", type: "vec3" }, { name: "normal", type: "vec3" }]);
                return e5.attributes.uv.location = 0, e5.attributes.f.location = 1, e5.attributes.normal.location = 2, e5;
              }, e4.createContourShader = function(t5) {
                var e5 = n3(t5, s, o, null, [{ name: "uv", type: "vec4" }, { name: "f", type: "float" }]);
                return e5.attributes.uv.location = 0, e5.attributes.f.location = 1, e5;
              }, e4.createPickContourShader = function(t5) {
                var e5 = n3(t5, s, l, null, [{ name: "uv", type: "vec4" }, { name: "f", type: "float" }]);
                return e5.attributes.uv.location = 0, e5.attributes.f.location = 1, e5;
              };
            }, 3754: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = t5.gl, r5 = m2(e5), n4 = b(e5), s2 = x(e5), l2 = _(e5), u2 = i2(e5), c2 = a(e5, [{ buffer: u2, size: 4, stride: 40, offset: 0 }, { buffer: u2, size: 3, stride: 40, offset: 16 }, { buffer: u2, size: 3, stride: 40, offset: 28 }]), f3 = i2(e5), h2 = a(e5, [{ buffer: f3, size: 4, stride: 20, offset: 0 }, { buffer: f3, size: 1, stride: 20, offset: 16 }]), p3 = i2(e5), d3 = a(e5, [{ buffer: p3, size: 2, type: e5.FLOAT }]), v2 = o(e5, 1, 256, e5.RGBA, e5.UNSIGNED_BYTE);
                v2.minFilter = e5.LINEAR, v2.magFilter = e5.LINEAR;
                var g3 = new M(e5, [0, 0], [[0, 0, 0], [0, 0, 0]], r5, n4, u2, c2, v2, s2, l2, f3, h2, p3, d3, [0, 0, 0]), y2 = { levels: [[], [], []] };
                for (var w3 in t5)
                  y2[w3] = t5[w3];
                return y2.colormap = y2.colormap || "jet", g3.update(y2), g3;
              };
              var n3 = r4(2288), i2 = r4(5827), a = r4(2944), o = r4(8931), s = r4(5306), l = r4(9156), u = r4(7498), c = r4(7382), f2 = r4(5050), h = r4(4162), p2 = r4(104), d2 = r4(7437), v = r4(5070), g2 = r4(9144), y = r4(9054), m2 = y.createShader, x = y.createContourShader, b = y.createPickShader, _ = y.createPickContourShader, w2 = [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1], T = [[0, 0], [0, 1], [1, 0], [1, 1], [1, 0], [0, 1]], k = [[0, 0, 0, 0, 0, 0, 0, 0, 0], [0, 0, 0, 0, 0, 0, 0, 0, 0], [0, 0, 0, 0, 0, 0, 0, 0, 0]];
              function A(t5, e5, r5, n4, i3) {
                this.position = t5, this.index = e5, this.uv = r5, this.level = n4, this.dataCoordinate = i3;
              }
              function M(t5, e5, r5, n4, i3, a2, o2, l2, u2, c2, h2, p3, d3, v2, g3) {
                this.gl = t5, this.shape = e5, this.bounds = r5, this.objectOffset = g3, this.intensityBounds = [], this._shader = n4, this._pickShader = i3, this._coordinateBuffer = a2, this._vao = o2, this._colorMap = l2, this._contourShader = u2, this._contourPickShader = c2, this._contourBuffer = h2, this._contourVAO = p3, this._contourOffsets = [[], [], []], this._contourCounts = [[], [], []], this._vertexCount = 0, this._pickResult = new A([0, 0, 0], [0, 0], [0, 0], [0, 0, 0], [0, 0, 0]), this._dynamicBuffer = d3, this._dynamicVAO = v2, this._dynamicOffsets = [0, 0, 0], this._dynamicCounts = [0, 0, 0], this.contourWidth = [1, 1, 1], this.contourLevels = [[1], [1], [1]], this.contourTint = [0, 0, 0], this.contourColor = [[0.5, 0.5, 0.5, 1], [0.5, 0.5, 0.5, 1], [0.5, 0.5, 0.5, 1]], this.showContour = true, this.showSurface = true, this.enableHighlight = [true, true, true], this.highlightColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.highlightTint = [1, 1, 1], this.highlightLevel = [-1, -1, -1], this.enableDynamic = [true, true, true], this.dynamicLevel = [NaN, NaN, NaN], this.dynamicColor = [[0, 0, 0, 1], [0, 0, 0, 1], [0, 0, 0, 1]], this.dynamicTint = [1, 1, 1], this.dynamicWidth = [1, 1, 1], this.axesBounds = [[1 / 0, 1 / 0, 1 / 0], [-1 / 0, -1 / 0, -1 / 0]], this.surfaceProject = [false, false, false], this.contourProject = [[false, false, false], [false, false, false], [false, false, false]], this.colorBounds = [false, false], this._field = [f2(s.mallocFloat(1024), [0, 0]), f2(s.mallocFloat(1024), [0, 0]), f2(s.mallocFloat(1024), [0, 0])], this.pickId = 1, this.clipBounds = [[-1 / 0, -1 / 0, -1 / 0], [1 / 0, 1 / 0, 1 / 0]], this.snapToData = false, this.pixelRatio = 1, this.opacity = 1, this.lightPosition = [10, 1e4, 0], this.ambientLight = 0.8, this.diffuseLight = 0.8, this.specularLight = 2, this.roughness = 0.5, this.fresnel = 1.5, this.vertexColor = 0, this.dirty = true;
              }
              !function() {
                for (var t5 = 0; t5 < 3; ++t5) {
                  var e5 = k[t5], r5 = (t5 + 2) % 3;
                  e5[(t5 + 1) % 3 + 0] = 1, e5[r5 + 3] = 1, e5[t5 + 6] = 1;
                }
              }();
              var S = M.prototype;
              S.genColormap = function(t5, e5) {
                var r5 = false, n4 = c([l({ colormap: t5, nshades: 256, format: "rgba" }).map(function(t6, n5) {
                  var i3 = e5 ? function(t7, e6) {
                    if (!e6)
                      return 1;
                    if (!e6.length)
                      return 1;
                    for (var r6 = 0; r6 < e6.length; ++r6) {
                      if (e6.length < 2)
                        return 1;
                      if (e6[r6][0] === t7)
                        return e6[r6][1];
                      if (e6[r6][0] > t7 && r6 > 0) {
                        var n6 = (e6[r6][0] - t7) / (e6[r6][0] - e6[r6 - 1][0]);
                        return e6[r6][1] * (1 - n6) + n6 * e6[r6 - 1][1];
                      }
                    }
                    return 1;
                  }(n5 / 255, e5) : t6[3];
                  return i3 < 1 && (r5 = true), [t6[0], t6[1], t6[2], 255 * i3];
                })]);
                return u.divseq(n4, 255), this.hasAlphaScale = r5, n4;
              }, S.isTransparent = function() {
                return this.opacity < 1 || this.hasAlphaScale;
              }, S.isOpaque = function() {
                return !this.isTransparent();
              }, S.pickSlots = 1, S.setPickBase = function(t5) {
                this.pickId = t5;
              };
              var E = [0, 0, 0], L = { showSurface: false, showContour: false, projections: [w2.slice(), w2.slice(), w2.slice()], clipBounds: [[[0, 0, 0], [0, 0, 0]], [[0, 0, 0], [0, 0, 0]], [[0, 0, 0], [0, 0, 0]]] };
              function C(t5, e5) {
                var r5, n4, i3, a2 = e5.axes && e5.axes.lastCubeProps.axis || E, o2 = e5.showSurface, s2 = e5.showContour;
                for (r5 = 0; r5 < 3; ++r5)
                  for (o2 = o2 || e5.surfaceProject[r5], n4 = 0; n4 < 3; ++n4)
                    s2 = s2 || e5.contourProject[r5][n4];
                for (r5 = 0; r5 < 3; ++r5) {
                  var l2 = L.projections[r5];
                  for (n4 = 0; n4 < 16; ++n4)
                    l2[n4] = 0;
                  for (n4 = 0; n4 < 4; ++n4)
                    l2[5 * n4] = 1;
                  l2[5 * r5] = 0, l2[12 + r5] = e5.axesBounds[+(a2[r5] > 0)][r5], p2(l2, t5.model, l2);
                  var u2 = L.clipBounds[r5];
                  for (i3 = 0; i3 < 2; ++i3)
                    for (n4 = 0; n4 < 3; ++n4)
                      u2[i3][n4] = t5.clipBounds[i3][n4];
                  u2[0][r5] = -1e8, u2[1][r5] = 1e8;
                }
                return L.showSurface = o2, L.showContour = s2, L;
              }
              var P = { model: w2, view: w2, projection: w2, inverseModel: w2.slice(), lowerBound: [0, 0, 0], upperBound: [0, 0, 0], colorMap: 0, clipBounds: [[0, 0, 0], [0, 0, 0]], height: 0, contourTint: 0, contourColor: [0, 0, 0, 1], permutation: [1, 0, 0, 0, 1, 0, 0, 0, 1], zOffset: -1e-4, objectOffset: [0, 0, 0], kambient: 1, kdiffuse: 1, kspecular: 1, lightPosition: [1e3, 1e3, 1e3], eyePosition: [0, 0, 0], roughness: 1, fresnel: 1, opacity: 1, vertexColor: 0 }, O = w2.slice(), I = [1, 0, 0, 0, 1, 0, 0, 0, 1];
              function D(t5, e5) {
                t5 = t5 || {};
                var r5 = this.gl;
                r5.disable(r5.CULL_FACE), this._colorMap.bind(0);
                var n4 = P;
                n4.model = t5.model || w2, n4.view = t5.view || w2, n4.projection = t5.projection || w2, n4.lowerBound = [this.bounds[0][0], this.bounds[0][1], this.colorBounds[0] || this.bounds[0][2]], n4.upperBound = [this.bounds[1][0], this.bounds[1][1], this.colorBounds[1] || this.bounds[1][2]], n4.objectOffset = this.objectOffset, n4.contourColor = this.contourColor[0], n4.inverseModel = d2(n4.inverseModel, n4.model);
                for (var i3 = 0; i3 < 2; ++i3)
                  for (var a2 = n4.clipBounds[i3], o2 = 0; o2 < 3; ++o2)
                    a2[o2] = Math.min(Math.max(this.clipBounds[i3][o2], -1e8), 1e8);
                n4.kambient = this.ambientLight, n4.kdiffuse = this.diffuseLight, n4.kspecular = this.specularLight, n4.roughness = this.roughness, n4.fresnel = this.fresnel, n4.opacity = this.opacity, n4.height = 0, n4.permutation = I, n4.vertexColor = this.vertexColor;
                var s2 = O;
                for (p2(s2, n4.view, n4.model), p2(s2, n4.projection, s2), d2(s2, s2), i3 = 0; i3 < 3; ++i3)
                  n4.eyePosition[i3] = s2[12 + i3] / s2[15];
                var l2 = s2[15];
                for (i3 = 0; i3 < 3; ++i3)
                  l2 += this.lightPosition[i3] * s2[4 * i3 + 3];
                for (i3 = 0; i3 < 3; ++i3) {
                  var u2 = s2[12 + i3];
                  for (o2 = 0; o2 < 3; ++o2)
                    u2 += s2[4 * o2 + i3] * this.lightPosition[o2];
                  n4.lightPosition[i3] = u2 / l2;
                }
                var c2 = C(n4, this);
                if (c2.showSurface) {
                  for (this._shader.bind(), this._shader.uniforms = n4, this._vao.bind(), this.showSurface && this._vertexCount && this._vao.draw(r5.TRIANGLES, this._vertexCount), i3 = 0; i3 < 3; ++i3)
                    this.surfaceProject[i3] && this.vertexCount && (this._shader.uniforms.model = c2.projections[i3], this._shader.uniforms.clipBounds = c2.clipBounds[i3], this._vao.draw(r5.TRIANGLES, this._vertexCount));
                  this._vao.unbind();
                }
                if (c2.showContour) {
                  var f3 = this._contourShader;
                  n4.kambient = 1, n4.kdiffuse = 0, n4.kspecular = 0, n4.opacity = 1, f3.bind(), f3.uniforms = n4;
                  var h2 = this._contourVAO;
                  for (h2.bind(), i3 = 0; i3 < 3; ++i3)
                    for (f3.uniforms.permutation = k[i3], r5.lineWidth(this.contourWidth[i3] * this.pixelRatio), o2 = 0; o2 < this.contourLevels[i3].length; ++o2)
                      o2 === this.highlightLevel[i3] ? (f3.uniforms.contourColor = this.highlightColor[i3], f3.uniforms.contourTint = this.highlightTint[i3]) : 0 !== o2 && o2 - 1 !== this.highlightLevel[i3] || (f3.uniforms.contourColor = this.contourColor[i3], f3.uniforms.contourTint = this.contourTint[i3]), this._contourCounts[i3][o2] && (f3.uniforms.height = this.contourLevels[i3][o2], h2.draw(r5.LINES, this._contourCounts[i3][o2], this._contourOffsets[i3][o2]));
                  for (i3 = 0; i3 < 3; ++i3)
                    for (f3.uniforms.model = c2.projections[i3], f3.uniforms.clipBounds = c2.clipBounds[i3], o2 = 0; o2 < 3; ++o2)
                      if (this.contourProject[i3][o2]) {
                        f3.uniforms.permutation = k[o2], r5.lineWidth(this.contourWidth[o2] * this.pixelRatio);
                        for (var v2 = 0; v2 < this.contourLevels[o2].length; ++v2)
                          v2 === this.highlightLevel[o2] ? (f3.uniforms.contourColor = this.highlightColor[o2], f3.uniforms.contourTint = this.highlightTint[o2]) : 0 !== v2 && v2 - 1 !== this.highlightLevel[o2] || (f3.uniforms.contourColor = this.contourColor[o2], f3.uniforms.contourTint = this.contourTint[o2]), this._contourCounts[o2][v2] && (f3.uniforms.height = this.contourLevels[o2][v2], h2.draw(r5.LINES, this._contourCounts[o2][v2], this._contourOffsets[o2][v2]));
                      }
                  for (h2.unbind(), (h2 = this._dynamicVAO).bind(), i3 = 0; i3 < 3; ++i3)
                    if (0 !== this._dynamicCounts[i3])
                      for (f3.uniforms.model = n4.model, f3.uniforms.clipBounds = n4.clipBounds, f3.uniforms.permutation = k[i3], r5.lineWidth(this.dynamicWidth[i3] * this.pixelRatio), f3.uniforms.contourColor = this.dynamicColor[i3], f3.uniforms.contourTint = this.dynamicTint[i3], f3.uniforms.height = this.dynamicLevel[i3], h2.draw(r5.LINES, this._dynamicCounts[i3], this._dynamicOffsets[i3]), o2 = 0; o2 < 3; ++o2)
                        this.contourProject[o2][i3] && (f3.uniforms.model = c2.projections[o2], f3.uniforms.clipBounds = c2.clipBounds[o2], h2.draw(r5.LINES, this._dynamicCounts[i3], this._dynamicOffsets[i3]));
                  h2.unbind();
                }
              }
              S.draw = function(t5) {
                return D.call(this, t5, false);
              }, S.drawTransparent = function(t5) {
                return D.call(this, t5, true);
              };
              var z = { model: w2, view: w2, projection: w2, inverseModel: w2, clipBounds: [[0, 0, 0], [0, 0, 0]], height: 0, shape: [0, 0], pickId: 0, lowerBound: [0, 0, 0], upperBound: [0, 0, 0], zOffset: 0, objectOffset: [0, 0, 0], permutation: [1, 0, 0, 0, 1, 0, 0, 0, 1], lightPosition: [0, 0, 0], eyePosition: [0, 0, 0] };
              function R(t5, e5) {
                return Array.isArray(t5) ? [e5(t5[0]), e5(t5[1]), e5(t5[2])] : [e5(t5), e5(t5), e5(t5)];
              }
              function F(t5) {
                return Array.isArray(t5) ? 3 === t5.length ? [t5[0], t5[1], t5[2], 1] : [t5[0], t5[1], t5[2], t5[3]] : [0, 0, 0, 1];
              }
              function B(t5) {
                if (Array.isArray(t5)) {
                  if (Array.isArray(t5))
                    return [F(t5[0]), F(t5[1]), F(t5[2])];
                  var e5 = F(t5);
                  return [e5.slice(), e5.slice(), e5.slice()];
                }
              }
              S.drawPick = function(t5) {
                t5 = t5 || {};
                var e5 = this.gl;
                e5.disable(e5.CULL_FACE);
                var r5 = z;
                r5.model = t5.model || w2, r5.view = t5.view || w2, r5.projection = t5.projection || w2, r5.shape = this._field[2].shape, r5.pickId = this.pickId / 255, r5.lowerBound = this.bounds[0], r5.upperBound = this.bounds[1], r5.objectOffset = this.objectOffset, r5.permutation = I;
                for (var n4 = 0; n4 < 2; ++n4)
                  for (var i3 = r5.clipBounds[n4], a2 = 0; a2 < 3; ++a2)
                    i3[a2] = Math.min(Math.max(this.clipBounds[n4][a2], -1e8), 1e8);
                var o2 = C(r5, this);
                if (o2.showSurface) {
                  for (this._pickShader.bind(), this._pickShader.uniforms = r5, this._vao.bind(), this._vao.draw(e5.TRIANGLES, this._vertexCount), n4 = 0; n4 < 3; ++n4)
                    this.surfaceProject[n4] && (this._pickShader.uniforms.model = o2.projections[n4], this._pickShader.uniforms.clipBounds = o2.clipBounds[n4], this._vao.draw(e5.TRIANGLES, this._vertexCount));
                  this._vao.unbind();
                }
                if (o2.showContour) {
                  var s2 = this._contourPickShader;
                  s2.bind(), s2.uniforms = r5;
                  var l2 = this._contourVAO;
                  for (l2.bind(), a2 = 0; a2 < 3; ++a2)
                    for (e5.lineWidth(this.contourWidth[a2] * this.pixelRatio), s2.uniforms.permutation = k[a2], n4 = 0; n4 < this.contourLevels[a2].length; ++n4)
                      this._contourCounts[a2][n4] && (s2.uniforms.height = this.contourLevels[a2][n4], l2.draw(e5.LINES, this._contourCounts[a2][n4], this._contourOffsets[a2][n4]));
                  for (n4 = 0; n4 < 3; ++n4)
                    for (s2.uniforms.model = o2.projections[n4], s2.uniforms.clipBounds = o2.clipBounds[n4], a2 = 0; a2 < 3; ++a2)
                      if (this.contourProject[n4][a2]) {
                        s2.uniforms.permutation = k[a2], e5.lineWidth(this.contourWidth[a2] * this.pixelRatio);
                        for (var u2 = 0; u2 < this.contourLevels[a2].length; ++u2)
                          this._contourCounts[a2][u2] && (s2.uniforms.height = this.contourLevels[a2][u2], l2.draw(e5.LINES, this._contourCounts[a2][u2], this._contourOffsets[a2][u2]));
                      }
                  l2.unbind();
                }
              }, S.pick = function(t5) {
                if (!t5)
                  return null;
                if (t5.id !== this.pickId)
                  return null;
                var e5 = this._field[2].shape, r5 = this._pickResult, n4 = e5[0] * (t5.value[0] + (t5.value[2] >> 4) / 16) / 255, i3 = Math.floor(n4), a2 = n4 - i3, o2 = e5[1] * (t5.value[1] + (15 & t5.value[2]) / 16) / 255, s2 = Math.floor(o2), l2 = o2 - s2;
                i3 += 1, s2 += 1;
                var u2 = r5.position;
                u2[0] = u2[1] = u2[2] = 0;
                for (var c2 = 0; c2 < 2; ++c2)
                  for (var f3 = c2 ? a2 : 1 - a2, h2 = 0; h2 < 2; ++h2)
                    for (var p3 = i3 + c2, d3 = s2 + h2, g3 = f3 * (h2 ? l2 : 1 - l2), y2 = 0; y2 < 3; ++y2)
                      u2[y2] += this._field[y2].get(p3, d3) * g3;
                for (var m3 = this._pickResult.level, x2 = 0; x2 < 3; ++x2)
                  if (m3[x2] = v.le(this.contourLevels[x2], u2[x2]), m3[x2] < 0)
                    this.contourLevels[x2].length > 0 && (m3[x2] = 0);
                  else if (m3[x2] < this.contourLevels[x2].length - 1) {
                    var b2 = this.contourLevels[x2][m3[x2]], _2 = this.contourLevels[x2][m3[x2] + 1];
                    Math.abs(b2 - u2[x2]) > Math.abs(_2 - u2[x2]) && (m3[x2] += 1);
                  }
                for (r5.index[0] = a2 < 0.5 ? i3 : i3 + 1, r5.index[1] = l2 < 0.5 ? s2 : s2 + 1, r5.uv[0] = n4 / e5[0], r5.uv[1] = o2 / e5[1], y2 = 0; y2 < 3; ++y2)
                  r5.dataCoordinate[y2] = this._field[y2].get(r5.index[0], r5.index[1]);
                return r5;
              }, S.padField = function(t5, e5) {
                var r5 = e5.shape.slice(), n4 = t5.shape.slice();
                u.assign(t5.lo(1, 1).hi(r5[0], r5[1]), e5), u.assign(t5.lo(1).hi(r5[0], 1), e5.hi(r5[0], 1)), u.assign(t5.lo(1, n4[1] - 1).hi(r5[0], 1), e5.lo(0, r5[1] - 1).hi(r5[0], 1)), u.assign(t5.lo(0, 1).hi(1, r5[1]), e5.hi(1)), u.assign(t5.lo(n4[0] - 1, 1).hi(1, r5[1]), e5.lo(r5[0] - 1)), t5.set(0, 0, e5.get(0, 0)), t5.set(0, n4[1] - 1, e5.get(0, r5[1] - 1)), t5.set(n4[0] - 1, 0, e5.get(r5[0] - 1, 0)), t5.set(n4[0] - 1, n4[1] - 1, e5.get(r5[0] - 1, r5[1] - 1));
              }, S.update = function(t5) {
                t5 = t5 || {}, this.objectOffset = t5.objectOffset || this.objectOffset, this.dirty = true, "contourWidth" in t5 && (this.contourWidth = R(t5.contourWidth, Number)), "showContour" in t5 && (this.showContour = R(t5.showContour, Boolean)), "showSurface" in t5 && (this.showSurface = !!t5.showSurface), "contourTint" in t5 && (this.contourTint = R(t5.contourTint, Boolean)), "contourColor" in t5 && (this.contourColor = B(t5.contourColor)), "contourProject" in t5 && (this.contourProject = R(t5.contourProject, function(t6) {
                  return R(t6, Boolean);
                })), "surfaceProject" in t5 && (this.surfaceProject = t5.surfaceProject), "dynamicColor" in t5 && (this.dynamicColor = B(t5.dynamicColor)), "dynamicTint" in t5 && (this.dynamicTint = R(t5.dynamicTint, Number)), "dynamicWidth" in t5 && (this.dynamicWidth = R(t5.dynamicWidth, Number)), "opacity" in t5 && (this.opacity = t5.opacity), "opacityscale" in t5 && (this.opacityscale = t5.opacityscale), "colorBounds" in t5 && (this.colorBounds = t5.colorBounds), "vertexColor" in t5 && (this.vertexColor = t5.vertexColor ? 1 : 0), "colormap" in t5 && this._colorMap.setPixels(this.genColormap(t5.colormap, this.opacityscale));
                var e5 = t5.field || t5.coords && t5.coords[2] || null, r5 = false;
                if (e5 || (e5 = this._field[2].shape[0] || this._field[2].shape[2] ? this._field[2].lo(1, 1).hi(this._field[2].shape[0] - 2, this._field[2].shape[1] - 2) : this._field[2].hi(0, 0)), "field" in t5 || "coords" in t5) {
                  var i3 = (e5.shape[0] + 2) * (e5.shape[1] + 2);
                  i3 > this._field[2].data.length && (s.freeFloat(this._field[2].data), this._field[2].data = s.mallocFloat(n3.nextPow2(i3))), this._field[2] = f2(this._field[2].data, [e5.shape[0] + 2, e5.shape[1] + 2]), this.padField(this._field[2], e5), this.shape = e5.shape.slice();
                  for (var a2 = this.shape, o2 = 0; o2 < 2; ++o2)
                    this._field[2].size > this._field[o2].data.length && (s.freeFloat(this._field[o2].data), this._field[o2].data = s.mallocFloat(this._field[2].size)), this._field[o2] = f2(this._field[o2].data, [a2[0] + 2, a2[1] + 2]);
                  if (t5.coords) {
                    var l2 = t5.coords;
                    if (!Array.isArray(l2) || 3 !== l2.length)
                      throw new Error("gl-surface: invalid coordinates for x/y");
                    for (o2 = 0; o2 < 2; ++o2) {
                      var u2 = l2[o2];
                      for (y2 = 0; y2 < 2; ++y2)
                        if (u2.shape[y2] !== a2[y2])
                          throw new Error("gl-surface: coords have incorrect shape");
                      this.padField(this._field[o2], u2);
                    }
                  } else if (t5.ticks) {
                    var c2 = t5.ticks;
                    if (!Array.isArray(c2) || 2 !== c2.length)
                      throw new Error("gl-surface: invalid ticks");
                    for (o2 = 0; o2 < 2; ++o2) {
                      var p3 = c2[o2];
                      if ((Array.isArray(p3) || p3.length) && (p3 = f2(p3)), p3.shape[0] !== a2[o2])
                        throw new Error("gl-surface: invalid tick length");
                      var d3 = f2(p3.data, a2);
                      d3.stride[o2] = p3.stride[0], d3.stride[1 ^ o2] = 0, this.padField(this._field[o2], d3);
                    }
                  } else {
                    for (o2 = 0; o2 < 2; ++o2) {
                      var v2 = [0, 0];
                      v2[o2] = 1, this._field[o2] = f2(this._field[o2].data, [a2[0] + 2, a2[1] + 2], v2, 0);
                    }
                    this._field[0].set(0, 0, 0);
                    for (var y2 = 0; y2 < a2[0]; ++y2)
                      this._field[0].set(y2 + 1, 0, y2);
                    for (this._field[0].set(a2[0] + 1, 0, a2[0] - 1), this._field[1].set(0, 0, 0), y2 = 0; y2 < a2[1]; ++y2)
                      this._field[1].set(0, y2 + 1, y2);
                    this._field[1].set(0, a2[1] + 1, a2[1] - 1);
                  }
                  var m3 = this._field, x2 = f2(s.mallocFloat(3 * m3[2].size * 2), [3, a2[0] + 2, a2[1] + 2, 2]);
                  for (o2 = 0; o2 < 3; ++o2)
                    g2(x2.pick(o2), m3[o2], "mirror");
                  var b2 = f2(s.mallocFloat(3 * m3[2].size), [a2[0] + 2, a2[1] + 2, 3]);
                  for (o2 = 0; o2 < a2[0] + 2; ++o2)
                    for (y2 = 0; y2 < a2[1] + 2; ++y2) {
                      var _2 = x2.get(0, o2, y2, 0), w3 = x2.get(0, o2, y2, 1), k2 = x2.get(1, o2, y2, 0), A2 = x2.get(1, o2, y2, 1), M2 = x2.get(2, o2, y2, 0), S2 = x2.get(2, o2, y2, 1), E2 = k2 * S2 - A2 * M2, L2 = M2 * w3 - S2 * _2, C2 = _2 * A2 - w3 * k2, P2 = Math.sqrt(E2 * E2 + L2 * L2 + C2 * C2);
                      P2 < 1e-8 ? (P2 = Math.max(Math.abs(E2), Math.abs(L2), Math.abs(C2))) < 1e-8 ? (C2 = 1, L2 = E2 = 0, P2 = 1) : P2 = 1 / P2 : P2 = 1 / Math.sqrt(P2), b2.set(o2, y2, 0, E2 * P2), b2.set(o2, y2, 1, L2 * P2), b2.set(o2, y2, 2, C2 * P2);
                    }
                  s.free(x2.data);
                  var O2 = [1 / 0, 1 / 0, 1 / 0], I2 = [-1 / 0, -1 / 0, -1 / 0], D2 = 1 / 0, z2 = -1 / 0, F2 = (a2[0] - 1) * (a2[1] - 1) * 6, N = s.mallocFloat(n3.nextPow2(10 * F2)), j = 0, U = 0;
                  for (o2 = 0; o2 < a2[0] - 1; ++o2)
                    t:
                      for (y2 = 0; y2 < a2[1] - 1; ++y2) {
                        for (var V = 0; V < 2; ++V)
                          for (var H = 0; H < 2; ++H)
                            for (var q2 = 0; q2 < 3; ++q2) {
                              var G = this._field[q2].get(1 + o2 + V, 1 + y2 + H);
                              if (isNaN(G) || !isFinite(G))
                                continue t;
                            }
                        for (q2 = 0; q2 < 6; ++q2) {
                          var Z = o2 + T[q2][0], Y = y2 + T[q2][1], W = this._field[0].get(Z + 1, Y + 1), X = this._field[1].get(Z + 1, Y + 1);
                          G = this._field[2].get(Z + 1, Y + 1), E2 = b2.get(Z + 1, Y + 1, 0), L2 = b2.get(Z + 1, Y + 1, 1), C2 = b2.get(Z + 1, Y + 1, 2), t5.intensity && (J = t5.intensity.get(Z, Y));
                          var J = t5.intensity ? t5.intensity.get(Z, Y) : G + this.objectOffset[2];
                          N[j++] = Z, N[j++] = Y, N[j++] = W, N[j++] = X, N[j++] = G, N[j++] = 0, N[j++] = J, N[j++] = E2, N[j++] = L2, N[j++] = C2, O2[0] = Math.min(O2[0], W + this.objectOffset[0]), O2[1] = Math.min(O2[1], X + this.objectOffset[1]), O2[2] = Math.min(O2[2], G + this.objectOffset[2]), D2 = Math.min(D2, J), I2[0] = Math.max(I2[0], W + this.objectOffset[0]), I2[1] = Math.max(I2[1], X + this.objectOffset[1]), I2[2] = Math.max(I2[2], G + this.objectOffset[2]), z2 = Math.max(z2, J), U += 1;
                        }
                      }
                  for (t5.intensityBounds && (D2 = +t5.intensityBounds[0], z2 = +t5.intensityBounds[1]), o2 = 6; o2 < j; o2 += 10)
                    N[o2] = (N[o2] - D2) / (z2 - D2);
                  this._vertexCount = U, this._coordinateBuffer.update(N.subarray(0, j)), s.freeFloat(N), s.free(b2.data), this.bounds = [O2, I2], this.intensity = t5.intensity || this._field[2], this.intensityBounds[0] === D2 && this.intensityBounds[1] === z2 || (r5 = true), this.intensityBounds = [D2, z2];
                }
                if ("levels" in t5) {
                  var K = t5.levels;
                  for (K = Array.isArray(K[0]) ? K.slice() : [[], [], K], o2 = 0; o2 < 3; ++o2)
                    K[o2] = K[o2].slice(), K[o2].sort(function(t6, e6) {
                      return t6 - e6;
                    });
                  for (o2 = 0; o2 < 3; ++o2)
                    for (y2 = 0; y2 < K[o2].length; ++y2)
                      K[o2][y2] -= this.objectOffset[o2];
                  t:
                    for (o2 = 0; o2 < 3; ++o2) {
                      if (K[o2].length !== this.contourLevels[o2].length) {
                        r5 = true;
                        break;
                      }
                      for (y2 = 0; y2 < K[o2].length; ++y2)
                        if (K[o2][y2] !== this.contourLevels[o2][y2]) {
                          r5 = true;
                          break t;
                        }
                    }
                  this.contourLevels = K;
                }
                if (r5) {
                  m3 = this._field, a2 = this.shape;
                  for (var $ = [], Q = 0; Q < 3; ++Q) {
                    var tt = this.contourLevels[Q], et = [], rt = [], nt = [0, 0, 0];
                    for (o2 = 0; o2 < tt.length; ++o2) {
                      var it = h(this._field[Q], tt[o2]);
                      et.push($.length / 5 | 0), U = 0;
                      t:
                        for (y2 = 0; y2 < it.cells.length; ++y2) {
                          var at = it.cells[y2];
                          for (q2 = 0; q2 < 2; ++q2) {
                            var ot = it.positions[at[q2]], st = ot[0], lt = 0 | Math.floor(st), ut = st - lt, ct = ot[1], ft = 0 | Math.floor(ct), ht = ct - ft, pt = false;
                            e:
                              for (var dt = 0; dt < 3; ++dt) {
                                nt[dt] = 0;
                                var vt = (Q + dt + 1) % 3;
                                for (V = 0; V < 2; ++V) {
                                  var gt = V ? ut : 1 - ut;
                                  for (Z = 0 | Math.min(Math.max(lt + V, 0), a2[0]), H = 0; H < 2; ++H) {
                                    var yt = H ? ht : 1 - ht;
                                    if (Y = 0 | Math.min(Math.max(ft + H, 0), a2[1]), G = dt < 2 ? this._field[vt].get(Z, Y) : (this.intensity.get(Z, Y) - this.intensityBounds[0]) / (this.intensityBounds[1] - this.intensityBounds[0]), !isFinite(G) || isNaN(G)) {
                                      pt = true;
                                      break e;
                                    }
                                    var mt = gt * yt;
                                    nt[dt] += mt * G;
                                  }
                                }
                              }
                            if (pt) {
                              if (q2 > 0) {
                                for (var xt = 0; xt < 5; ++xt)
                                  $.pop();
                                U -= 1;
                              }
                              continue t;
                            }
                            $.push(nt[0], nt[1], ot[0], ot[1], nt[2]), U += 1;
                          }
                        }
                      rt.push(U);
                    }
                    this._contourOffsets[Q] = et, this._contourCounts[Q] = rt;
                  }
                  var bt = s.mallocFloat($.length);
                  for (o2 = 0; o2 < $.length; ++o2)
                    bt[o2] = $[o2];
                  this._contourBuffer.update(bt), s.freeFloat(bt);
                }
              }, S.dispose = function() {
                this._shader.dispose(), this._vao.dispose(), this._coordinateBuffer.dispose(), this._colorMap.dispose(), this._contourBuffer.dispose(), this._contourVAO.dispose(), this._contourShader.dispose(), this._contourPickShader.dispose(), this._dynamicBuffer.dispose(), this._dynamicVAO.dispose();
                for (var t5 = 0; t5 < 3; ++t5)
                  s.freeFloat(this._field[t5].data);
              }, S.highlight = function(t5) {
                var e5, r5;
                if (!t5)
                  return this._dynamicCounts = [0, 0, 0], this.dyanamicLevel = [NaN, NaN, NaN], void (this.highlightLevel = [-1, -1, -1]);
                for (e5 = 0; e5 < 3; ++e5)
                  this.enableHighlight[e5] ? this.highlightLevel[e5] = t5.level[e5] : this.highlightLevel[e5] = -1;
                for (r5 = this.snapToData ? t5.dataCoordinate : t5.position, e5 = 0; e5 < 3; ++e5)
                  r5[e5] -= this.objectOffset[e5];
                if (this.enableDynamic[0] && r5[0] !== this.dynamicLevel[0] || this.enableDynamic[1] && r5[1] !== this.dynamicLevel[1] || this.enableDynamic[2] && r5[2] !== this.dynamicLevel[2]) {
                  for (var n4 = 0, i3 = this.shape, a2 = s.mallocFloat(12 * i3[0] * i3[1]), o2 = 0; o2 < 3; ++o2)
                    if (this.enableDynamic[o2]) {
                      this.dynamicLevel[o2] = r5[o2];
                      var l2 = (o2 + 1) % 3, u2 = (o2 + 2) % 3, c2 = this._field[o2], f3 = this._field[l2], p3 = this._field[u2], d3 = h(c2, r5[o2]), v2 = d3.cells, g3 = d3.positions;
                      for (this._dynamicOffsets[o2] = n4, e5 = 0; e5 < v2.length; ++e5)
                        for (var y2 = v2[e5], m3 = 0; m3 < 2; ++m3) {
                          var x2 = g3[y2[m3]], b2 = +x2[0], _2 = 0 | b2, w3 = 0 | Math.min(_2 + 1, i3[0]), T2 = b2 - _2, k2 = 1 - T2, A2 = +x2[1], M2 = 0 | A2, S2 = 0 | Math.min(M2 + 1, i3[1]), E2 = A2 - M2, L2 = 1 - E2, C2 = k2 * L2, P2 = k2 * E2, O2 = T2 * L2, I2 = T2 * E2, D2 = C2 * f3.get(_2, M2) + P2 * f3.get(_2, S2) + O2 * f3.get(w3, M2) + I2 * f3.get(w3, S2), z2 = C2 * p3.get(_2, M2) + P2 * p3.get(_2, S2) + O2 * p3.get(w3, M2) + I2 * p3.get(w3, S2);
                          if (isNaN(D2) || isNaN(z2)) {
                            m3 && (n4 -= 1);
                            break;
                          }
                          a2[2 * n4 + 0] = D2, a2[2 * n4 + 1] = z2, n4 += 1;
                        }
                      this._dynamicCounts[o2] = n4 - this._dynamicOffsets[o2];
                    } else
                      this.dynamicLevel[o2] = NaN, this._dynamicCounts[o2] = 0;
                  this._dynamicBuffer.update(a2.subarray(0, 2 * n4)), s.freeFloat(a2);
                }
              };
            }, 8931: function(t4, e4, r4) {
              var n3 = r4(5050), i2 = r4(7498), a = r4(5306);
              t4.exports = function(t5) {
                if (arguments.length <= 1)
                  throw new Error("gl-texture2d: Missing arguments for texture2d constructor");
                if (o || u(t5), "number" == typeof arguments[1])
                  return y(t5, arguments[1], arguments[2], arguments[3] || t5.RGBA, arguments[4] || t5.UNSIGNED_BYTE);
                if (Array.isArray(arguments[1]))
                  return y(t5, 0 | arguments[1][0], 0 | arguments[1][1], arguments[2] || t5.RGBA, arguments[3] || t5.UNSIGNED_BYTE);
                if ("object" == typeof arguments[1]) {
                  var e5 = arguments[1], r5 = c(e5) ? e5 : e5.raw;
                  if (r5)
                    return m2(t5, r5, 0 | e5.width, 0 | e5.height, arguments[2] || t5.RGBA, arguments[3] || t5.UNSIGNED_BYTE);
                  if (e5.shape && e5.data && e5.stride)
                    return x(t5, e5);
                }
                throw new Error("gl-texture2d: Invalid arguments for texture2d constructor");
              };
              var o = null, s = null, l = null;
              function u(t5) {
                o = [t5.LINEAR, t5.NEAREST_MIPMAP_LINEAR, t5.LINEAR_MIPMAP_NEAREST, t5.LINEAR_MIPMAP_NEAREST], s = [t5.NEAREST, t5.LINEAR, t5.NEAREST_MIPMAP_NEAREST, t5.NEAREST_MIPMAP_LINEAR, t5.LINEAR_MIPMAP_NEAREST, t5.LINEAR_MIPMAP_LINEAR], l = [t5.REPEAT, t5.CLAMP_TO_EDGE, t5.MIRRORED_REPEAT];
              }
              function c(t5) {
                return "undefined" != typeof HTMLCanvasElement && t5 instanceof HTMLCanvasElement || "undefined" != typeof HTMLImageElement && t5 instanceof HTMLImageElement || "undefined" != typeof HTMLVideoElement && t5 instanceof HTMLVideoElement || "undefined" != typeof ImageData && t5 instanceof ImageData;
              }
              var f2 = function(t5, e5) {
                i2.muls(t5, e5, 255);
              };
              function h(t5, e5, r5) {
                var n4 = t5.gl, i3 = n4.getParameter(n4.MAX_TEXTURE_SIZE);
                if (e5 < 0 || e5 > i3 || r5 < 0 || r5 > i3)
                  throw new Error("gl-texture2d: Invalid texture size");
                return t5._shape = [e5, r5], t5.bind(), n4.texImage2D(n4.TEXTURE_2D, 0, t5.format, e5, r5, 0, t5.format, t5.type, null), t5._mipLevels = [0], t5;
              }
              function p2(t5, e5, r5, n4, i3, a2) {
                this.gl = t5, this.handle = e5, this.format = i3, this.type = a2, this._shape = [r5, n4], this._mipLevels = [0], this._magFilter = t5.NEAREST, this._minFilter = t5.NEAREST, this._wrapS = t5.CLAMP_TO_EDGE, this._wrapT = t5.CLAMP_TO_EDGE, this._anisoSamples = 1;
                var o2 = this, s2 = [this._wrapS, this._wrapT];
                Object.defineProperties(s2, [{ get: function() {
                  return o2._wrapS;
                }, set: function(t6) {
                  return o2.wrapS = t6;
                } }, { get: function() {
                  return o2._wrapT;
                }, set: function(t6) {
                  return o2.wrapT = t6;
                } }]), this._wrapVector = s2;
                var l2 = [this._shape[0], this._shape[1]];
                Object.defineProperties(l2, [{ get: function() {
                  return o2._shape[0];
                }, set: function(t6) {
                  return o2.width = t6;
                } }, { get: function() {
                  return o2._shape[1];
                }, set: function(t6) {
                  return o2.height = t6;
                } }]), this._shapeVector = l2;
              }
              var d2 = p2.prototype;
              function v(t5, e5) {
                return 3 === t5.length ? 1 === e5[2] && e5[1] === t5[0] * t5[2] && e5[0] === t5[2] : 1 === e5[0] && e5[1] === t5[0];
              }
              function g2(t5) {
                var e5 = t5.createTexture();
                return t5.bindTexture(t5.TEXTURE_2D, e5), t5.texParameteri(t5.TEXTURE_2D, t5.TEXTURE_MIN_FILTER, t5.NEAREST), t5.texParameteri(t5.TEXTURE_2D, t5.TEXTURE_MAG_FILTER, t5.NEAREST), t5.texParameteri(t5.TEXTURE_2D, t5.TEXTURE_WRAP_S, t5.CLAMP_TO_EDGE), t5.texParameteri(t5.TEXTURE_2D, t5.TEXTURE_WRAP_T, t5.CLAMP_TO_EDGE), e5;
              }
              function y(t5, e5, r5, n4, i3) {
                var a2 = t5.getParameter(t5.MAX_TEXTURE_SIZE);
                if (e5 < 0 || e5 > a2 || r5 < 0 || r5 > a2)
                  throw new Error("gl-texture2d: Invalid texture shape");
                if (i3 === t5.FLOAT && !t5.getExtension("OES_texture_float"))
                  throw new Error("gl-texture2d: Floating point textures not supported on this platform");
                var o2 = g2(t5);
                return t5.texImage2D(t5.TEXTURE_2D, 0, n4, e5, r5, 0, n4, i3, null), new p2(t5, o2, e5, r5, n4, i3);
              }
              function m2(t5, e5, r5, n4, i3, a2) {
                var o2 = g2(t5);
                return t5.texImage2D(t5.TEXTURE_2D, 0, i3, i3, a2, e5), new p2(t5, o2, r5, n4, i3, a2);
              }
              function x(t5, e5) {
                var r5 = e5.dtype, o2 = e5.shape.slice(), s2 = t5.getParameter(t5.MAX_TEXTURE_SIZE);
                if (o2[0] < 0 || o2[0] > s2 || o2[1] < 0 || o2[1] > s2)
                  throw new Error("gl-texture2d: Invalid texture size");
                var l2 = v(o2, e5.stride.slice()), u2 = 0;
                "float32" === r5 ? u2 = t5.FLOAT : "float64" === r5 ? (u2 = t5.FLOAT, l2 = false, r5 = "float32") : "uint8" === r5 ? u2 = t5.UNSIGNED_BYTE : (u2 = t5.UNSIGNED_BYTE, l2 = false, r5 = "uint8");
                var c2, h2, d3 = 0;
                if (2 === o2.length)
                  d3 = t5.LUMINANCE, o2 = [o2[0], o2[1], 1], e5 = n3(e5.data, o2, [e5.stride[0], e5.stride[1], 1], e5.offset);
                else {
                  if (3 !== o2.length)
                    throw new Error("gl-texture2d: Invalid shape for texture");
                  if (1 === o2[2])
                    d3 = t5.ALPHA;
                  else if (2 === o2[2])
                    d3 = t5.LUMINANCE_ALPHA;
                  else if (3 === o2[2])
                    d3 = t5.RGB;
                  else {
                    if (4 !== o2[2])
                      throw new Error("gl-texture2d: Invalid shape for pixel coords");
                    d3 = t5.RGBA;
                  }
                }
                u2 !== t5.FLOAT || t5.getExtension("OES_texture_float") || (u2 = t5.UNSIGNED_BYTE, l2 = false);
                var y2 = e5.size;
                if (l2)
                  c2 = 0 === e5.offset && e5.data.length === y2 ? e5.data : e5.data.subarray(e5.offset, e5.offset + y2);
                else {
                  var m3 = [o2[2], o2[2] * o2[0], 1];
                  h2 = a.malloc(y2, r5);
                  var x2 = n3(h2, o2, m3, 0);
                  "float32" !== r5 && "float64" !== r5 || u2 !== t5.UNSIGNED_BYTE ? i2.assign(x2, e5) : f2(x2, e5), c2 = h2.subarray(0, y2);
                }
                var b = g2(t5);
                return t5.texImage2D(t5.TEXTURE_2D, 0, d3, o2[0], o2[1], 0, d3, u2, c2), l2 || a.free(h2), new p2(t5, b, o2[0], o2[1], d3, u2);
              }
              Object.defineProperties(d2, { minFilter: { get: function() {
                return this._minFilter;
              }, set: function(t5) {
                this.bind();
                var e5 = this.gl;
                if (this.type === e5.FLOAT && o.indexOf(t5) >= 0 && (e5.getExtension("OES_texture_float_linear") || (t5 = e5.NEAREST)), s.indexOf(t5) < 0)
                  throw new Error("gl-texture2d: Unknown filter mode " + t5);
                return e5.texParameteri(e5.TEXTURE_2D, e5.TEXTURE_MIN_FILTER, t5), this._minFilter = t5;
              } }, magFilter: { get: function() {
                return this._magFilter;
              }, set: function(t5) {
                this.bind();
                var e5 = this.gl;
                if (this.type === e5.FLOAT && o.indexOf(t5) >= 0 && (e5.getExtension("OES_texture_float_linear") || (t5 = e5.NEAREST)), s.indexOf(t5) < 0)
                  throw new Error("gl-texture2d: Unknown filter mode " + t5);
                return e5.texParameteri(e5.TEXTURE_2D, e5.TEXTURE_MAG_FILTER, t5), this._magFilter = t5;
              } }, mipSamples: { get: function() {
                return this._anisoSamples;
              }, set: function(t5) {
                var e5 = this._anisoSamples;
                if (this._anisoSamples = 0 | Math.max(t5, 1), e5 !== this._anisoSamples) {
                  var r5 = this.gl.getExtension("EXT_texture_filter_anisotropic");
                  r5 && this.gl.texParameterf(this.gl.TEXTURE_2D, r5.TEXTURE_MAX_ANISOTROPY_EXT, this._anisoSamples);
                }
                return this._anisoSamples;
              } }, wrapS: { get: function() {
                return this._wrapS;
              }, set: function(t5) {
                if (this.bind(), l.indexOf(t5) < 0)
                  throw new Error("gl-texture2d: Unknown wrap mode " + t5);
                return this.gl.texParameteri(this.gl.TEXTURE_2D, this.gl.TEXTURE_WRAP_S, t5), this._wrapS = t5;
              } }, wrapT: { get: function() {
                return this._wrapT;
              }, set: function(t5) {
                if (this.bind(), l.indexOf(t5) < 0)
                  throw new Error("gl-texture2d: Unknown wrap mode " + t5);
                return this.gl.texParameteri(this.gl.TEXTURE_2D, this.gl.TEXTURE_WRAP_T, t5), this._wrapT = t5;
              } }, wrap: { get: function() {
                return this._wrapVector;
              }, set: function(t5) {
                if (Array.isArray(t5) || (t5 = [t5, t5]), 2 !== t5.length)
                  throw new Error("gl-texture2d: Must specify wrap mode for rows and columns");
                for (var e5 = 0; e5 < 2; ++e5)
                  if (l.indexOf(t5[e5]) < 0)
                    throw new Error("gl-texture2d: Unknown wrap mode " + t5);
                this._wrapS = t5[0], this._wrapT = t5[1];
                var r5 = this.gl;
                return this.bind(), r5.texParameteri(r5.TEXTURE_2D, r5.TEXTURE_WRAP_S, this._wrapS), r5.texParameteri(r5.TEXTURE_2D, r5.TEXTURE_WRAP_T, this._wrapT), t5;
              } }, shape: { get: function() {
                return this._shapeVector;
              }, set: function(t5) {
                if (Array.isArray(t5)) {
                  if (2 !== t5.length)
                    throw new Error("gl-texture2d: Invalid texture shape");
                } else
                  t5 = [0 | t5, 0 | t5];
                return h(this, 0 | t5[0], 0 | t5[1]), [0 | t5[0], 0 | t5[1]];
              } }, width: { get: function() {
                return this._shape[0];
              }, set: function(t5) {
                return h(this, t5 |= 0, this._shape[1]), t5;
              } }, height: { get: function() {
                return this._shape[1];
              }, set: function(t5) {
                return t5 |= 0, h(this, this._shape[0], t5), t5;
              } } }), d2.bind = function(t5) {
                var e5 = this.gl;
                return void 0 !== t5 && e5.activeTexture(e5.TEXTURE0 + (0 | t5)), e5.bindTexture(e5.TEXTURE_2D, this.handle), void 0 !== t5 ? 0 | t5 : e5.getParameter(e5.ACTIVE_TEXTURE) - e5.TEXTURE0;
              }, d2.dispose = function() {
                this.gl.deleteTexture(this.handle);
              }, d2.generateMipmap = function() {
                this.bind(), this.gl.generateMipmap(this.gl.TEXTURE_2D);
                for (var t5 = Math.min(this._shape[0], this._shape[1]), e5 = 0; t5 > 0; ++e5, t5 >>>= 1)
                  this._mipLevels.indexOf(e5) < 0 && this._mipLevels.push(e5);
              }, d2.setPixels = function(t5, e5, r5, o2) {
                var s2 = this.gl;
                this.bind(), Array.isArray(e5) ? (o2 = r5, r5 = 0 | e5[1], e5 = 0 | e5[0]) : (e5 = e5 || 0, r5 = r5 || 0), o2 = o2 || 0;
                var l2 = c(t5) ? t5 : t5.raw;
                if (l2)
                  this._mipLevels.indexOf(o2) < 0 ? (s2.texImage2D(s2.TEXTURE_2D, 0, this.format, this.format, this.type, l2), this._mipLevels.push(o2)) : s2.texSubImage2D(s2.TEXTURE_2D, o2, e5, r5, this.format, this.type, l2);
                else {
                  if (!(t5.shape && t5.stride && t5.data))
                    throw new Error("gl-texture2d: Unsupported data type");
                  if (t5.shape.length < 2 || e5 + t5.shape[1] > this._shape[1] >>> o2 || r5 + t5.shape[0] > this._shape[0] >>> o2 || e5 < 0 || r5 < 0)
                    throw new Error("gl-texture2d: Texture dimensions are out of bounds");
                  !function(t6, e6, r6, o3, s3, l3, u2, c2) {
                    var h2 = c2.dtype, p3 = c2.shape.slice();
                    if (p3.length < 2 || p3.length > 3)
                      throw new Error("gl-texture2d: Invalid ndarray, must be 2d or 3d");
                    var d3 = 0, g3 = 0, y2 = v(p3, c2.stride.slice());
                    if ("float32" === h2 ? d3 = t6.FLOAT : "float64" === h2 ? (d3 = t6.FLOAT, y2 = false, h2 = "float32") : "uint8" === h2 ? d3 = t6.UNSIGNED_BYTE : (d3 = t6.UNSIGNED_BYTE, y2 = false, h2 = "uint8"), 2 === p3.length)
                      g3 = t6.LUMINANCE, p3 = [p3[0], p3[1], 1], c2 = n3(c2.data, p3, [c2.stride[0], c2.stride[1], 1], c2.offset);
                    else {
                      if (3 !== p3.length)
                        throw new Error("gl-texture2d: Invalid shape for texture");
                      if (1 === p3[2])
                        g3 = t6.ALPHA;
                      else if (2 === p3[2])
                        g3 = t6.LUMINANCE_ALPHA;
                      else if (3 === p3[2])
                        g3 = t6.RGB;
                      else {
                        if (4 !== p3[2])
                          throw new Error("gl-texture2d: Invalid shape for pixel coords");
                        g3 = t6.RGBA;
                      }
                      p3[2];
                    }
                    if (g3 !== t6.LUMINANCE && g3 !== t6.ALPHA || s3 !== t6.LUMINANCE && s3 !== t6.ALPHA || (g3 = s3), g3 !== s3)
                      throw new Error("gl-texture2d: Incompatible texture format for setPixels");
                    var m3 = c2.size, x2 = u2.indexOf(o3) < 0;
                    if (x2 && u2.push(o3), d3 === l3 && y2)
                      0 === c2.offset && c2.data.length === m3 ? x2 ? t6.texImage2D(t6.TEXTURE_2D, o3, s3, p3[0], p3[1], 0, s3, l3, c2.data) : t6.texSubImage2D(t6.TEXTURE_2D, o3, e6, r6, p3[0], p3[1], s3, l3, c2.data) : x2 ? t6.texImage2D(t6.TEXTURE_2D, o3, s3, p3[0], p3[1], 0, s3, l3, c2.data.subarray(c2.offset, c2.offset + m3)) : t6.texSubImage2D(t6.TEXTURE_2D, o3, e6, r6, p3[0], p3[1], s3, l3, c2.data.subarray(c2.offset, c2.offset + m3));
                    else {
                      var b;
                      b = l3 === t6.FLOAT ? a.mallocFloat32(m3) : a.mallocUint8(m3);
                      var _ = n3(b, p3, [p3[2], p3[2] * p3[0], 1]);
                      d3 === t6.FLOAT && l3 === t6.UNSIGNED_BYTE ? f2(_, c2) : i2.assign(_, c2), x2 ? t6.texImage2D(t6.TEXTURE_2D, o3, s3, p3[0], p3[1], 0, s3, l3, b.subarray(0, m3)) : t6.texSubImage2D(t6.TEXTURE_2D, o3, e6, r6, p3[0], p3[1], s3, l3, b.subarray(0, m3)), l3 === t6.FLOAT ? a.freeFloat32(b) : a.freeUint8(b);
                    }
                  }(s2, e5, r5, o2, this.format, this.type, this._mipLevels, t5);
                }
              };
            }, 3056: function(t4) {
              t4.exports = function(t5, e4, r4) {
                e4 ? e4.bind() : t5.bindBuffer(t5.ELEMENT_ARRAY_BUFFER, null);
                var n3 = 0 | t5.getParameter(t5.MAX_VERTEX_ATTRIBS);
                if (r4) {
                  if (r4.length > n3)
                    throw new Error("gl-vao: Too many vertex attributes");
                  for (var i2 = 0; i2 < r4.length; ++i2) {
                    var a = r4[i2];
                    if (a.buffer) {
                      var o = a.buffer, s = a.size || 4, l = a.type || t5.FLOAT, u = !!a.normalized, c = a.stride || 0, f2 = a.offset || 0;
                      o.bind(), t5.enableVertexAttribArray(i2), t5.vertexAttribPointer(i2, s, l, u, c, f2);
                    } else {
                      if ("number" == typeof a)
                        t5.vertexAttrib1f(i2, a);
                      else if (1 === a.length)
                        t5.vertexAttrib1f(i2, a[0]);
                      else if (2 === a.length)
                        t5.vertexAttrib2f(i2, a[0], a[1]);
                      else if (3 === a.length)
                        t5.vertexAttrib3f(i2, a[0], a[1], a[2]);
                      else {
                        if (4 !== a.length)
                          throw new Error("gl-vao: Invalid vertex attribute");
                        t5.vertexAttrib4f(i2, a[0], a[1], a[2], a[3]);
                      }
                      t5.disableVertexAttribArray(i2);
                    }
                  }
                  for (; i2 < n3; ++i2)
                    t5.disableVertexAttribArray(i2);
                } else
                  for (t5.bindBuffer(t5.ARRAY_BUFFER, null), i2 = 0; i2 < n3; ++i2)
                    t5.disableVertexAttribArray(i2);
              };
            }, 7220: function(t4, e4, r4) {
              var n3 = r4(3056);
              function i2(t5) {
                this.gl = t5, this._elements = null, this._attributes = null, this._elementsType = t5.UNSIGNED_SHORT;
              }
              i2.prototype.bind = function() {
                n3(this.gl, this._elements, this._attributes);
              }, i2.prototype.update = function(t5, e5, r5) {
                this._elements = e5, this._attributes = t5, this._elementsType = r5 || this.gl.UNSIGNED_SHORT;
              }, i2.prototype.dispose = function() {
              }, i2.prototype.unbind = function() {
              }, i2.prototype.draw = function(t5, e5, r5) {
                r5 = r5 || 0;
                var n4 = this.gl;
                this._elements ? n4.drawElements(t5, e5, this._elementsType, r5) : n4.drawArrays(t5, r5, e5);
              }, t4.exports = function(t5) {
                return new i2(t5);
              };
            }, 3778: function(t4, e4, r4) {
              var n3 = r4(3056);
              function i2(t5, e5, r5, n4, i3, a2) {
                this.location = t5, this.dimension = e5, this.a = r5, this.b = n4, this.c = i3, this.d = a2;
              }
              function a(t5, e5, r5) {
                this.gl = t5, this._ext = e5, this.handle = r5, this._attribs = [], this._useElements = false, this._elementsType = t5.UNSIGNED_SHORT;
              }
              i2.prototype.bind = function(t5) {
                switch (this.dimension) {
                  case 1:
                    t5.vertexAttrib1f(this.location, this.a);
                    break;
                  case 2:
                    t5.vertexAttrib2f(this.location, this.a, this.b);
                    break;
                  case 3:
                    t5.vertexAttrib3f(this.location, this.a, this.b, this.c);
                    break;
                  case 4:
                    t5.vertexAttrib4f(this.location, this.a, this.b, this.c, this.d);
                }
              }, a.prototype.bind = function() {
                this._ext.bindVertexArrayOES(this.handle);
                for (var t5 = 0; t5 < this._attribs.length; ++t5)
                  this._attribs[t5].bind(this.gl);
              }, a.prototype.unbind = function() {
                this._ext.bindVertexArrayOES(null);
              }, a.prototype.dispose = function() {
                this._ext.deleteVertexArrayOES(this.handle);
              }, a.prototype.update = function(t5, e5, r5) {
                if (this.bind(), n3(this.gl, e5, t5), this.unbind(), this._attribs.length = 0, t5)
                  for (var a2 = 0; a2 < t5.length; ++a2) {
                    var o = t5[a2];
                    "number" == typeof o ? this._attribs.push(new i2(a2, 1, o)) : Array.isArray(o) && this._attribs.push(new i2(a2, o.length, o[0], o[1], o[2], o[3]));
                  }
                this._useElements = !!e5, this._elementsType = r5 || this.gl.UNSIGNED_SHORT;
              }, a.prototype.draw = function(t5, e5, r5) {
                r5 = r5 || 0;
                var n4 = this.gl;
                this._useElements ? n4.drawElements(t5, e5, this._elementsType, r5) : n4.drawArrays(t5, r5, e5);
              }, t4.exports = function(t5, e5) {
                return new a(t5, e5, e5.createVertexArrayOES());
              };
            }, 2944: function(t4, e4, r4) {
              var n3 = r4(3778), i2 = r4(7220);
              function a(t5) {
                this.bindVertexArrayOES = t5.bindVertexArray.bind(t5), this.createVertexArrayOES = t5.createVertexArray.bind(t5), this.deleteVertexArrayOES = t5.deleteVertexArray.bind(t5);
              }
              t4.exports = function(t5, e5, r5, o) {
                var s, l = t5.createVertexArray ? new a(t5) : t5.getExtension("OES_vertex_array_object");
                return (s = l ? n3(t5, l) : i2(t5)).update(e5, r5, o), s;
              };
            }, 2598: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = e4[0] + r4[0], t5[1] = e4[1] + r4[1], t5[2] = e4[2] + r4[2], t5;
              };
            }, 5879: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                var r5 = n3(t5[0], t5[1], t5[2]), o = n3(e5[0], e5[1], e5[2]);
                i2(r5, r5), i2(o, o);
                var s = a(r5, o);
                return s > 1 ? 0 : Math.acos(s);
              };
              var n3 = r4(5415), i2 = r4(899), a = r4(9305);
            }, 8827: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0] = Math.ceil(e4[0]), t5[1] = Math.ceil(e4[1]), t5[2] = Math.ceil(e4[2]), t5;
              };
            }, 7622: function(t4) {
              t4.exports = function(t5) {
                var e4 = new Float32Array(3);
                return e4[0] = t5[0], e4[1] = t5[1], e4[2] = t5[2], e4;
              };
            }, 8782: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0] = e4[0], t5[1] = e4[1], t5[2] = e4[2], t5;
              };
            }, 8501: function(t4) {
              t4.exports = function() {
                var t5 = new Float32Array(3);
                return t5[0] = 0, t5[1] = 0, t5[2] = 0, t5;
              };
            }, 903: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = e4[0], i2 = e4[1], a = e4[2], o = r4[0], s = r4[1], l = r4[2];
                return t5[0] = i2 * l - a * s, t5[1] = a * o - n3 * l, t5[2] = n3 * s - i2 * o, t5;
              };
            }, 5981: function(t4, e4, r4) {
              t4.exports = r4(8288);
            }, 8288: function(t4) {
              t4.exports = function(t5, e4) {
                var r4 = e4[0] - t5[0], n3 = e4[1] - t5[1], i2 = e4[2] - t5[2];
                return Math.sqrt(r4 * r4 + n3 * n3 + i2 * i2);
              };
            }, 8629: function(t4, e4, r4) {
              t4.exports = r4(7979);
            }, 7979: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = e4[0] / r4[0], t5[1] = e4[1] / r4[1], t5[2] = e4[2] / r4[2], t5;
              };
            }, 9305: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0] * e4[0] + t5[1] * e4[1] + t5[2] * e4[2];
              };
            }, 154: function(t4) {
              t4.exports = 1e-6;
            }, 4932: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                var r5 = t5[0], i2 = t5[1], a = t5[2], o = e5[0], s = e5[1], l = e5[2];
                return Math.abs(r5 - o) <= n3 * Math.max(1, Math.abs(r5), Math.abs(o)) && Math.abs(i2 - s) <= n3 * Math.max(1, Math.abs(i2), Math.abs(s)) && Math.abs(a - l) <= n3 * Math.max(1, Math.abs(a), Math.abs(l));
              };
              var n3 = r4(154);
            }, 5777: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0] === e4[0] && t5[1] === e4[1] && t5[2] === e4[2];
              };
            }, 3306: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0] = Math.floor(e4[0]), t5[1] = Math.floor(e4[1]), t5[2] = Math.floor(e4[2]), t5;
              };
            }, 7447: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5, i2, a, o) {
                var s, l;
                for (e5 || (e5 = 3), r5 || (r5 = 0), l = i2 ? Math.min(i2 * e5 + r5, t5.length) : t5.length, s = r5; s < l; s += e5)
                  n3[0] = t5[s], n3[1] = t5[s + 1], n3[2] = t5[s + 2], a(n3, n3, o), t5[s] = n3[0], t5[s + 1] = n3[1], t5[s + 2] = n3[2];
                return t5;
              };
              var n3 = r4(8501)();
            }, 5415: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = new Float32Array(3);
                return n3[0] = t5, n3[1] = e4, n3[2] = r4, n3;
              };
            }, 2858: function(t4, e4, r4) {
              t4.exports = { EPSILON: r4(154), create: r4(8501), clone: r4(7622), angle: r4(5879), fromValues: r4(5415), copy: r4(8782), set: r4(831), equals: r4(4932), exactEquals: r4(5777), add: r4(2598), subtract: r4(911), sub: r4(8921), multiply: r4(105), mul: r4(5733), divide: r4(7979), div: r4(8629), min: r4(3605), max: r4(1716), floor: r4(3306), ceil: r4(8827), round: r4(1624), scale: r4(5685), scaleAndAdd: r4(6722), distance: r4(8288), dist: r4(5981), squaredDistance: r4(6403), sqrDist: r4(5294), length: r4(4693), len: r4(1468), squaredLength: r4(4337), sqrLen: r4(3303), negate: r4(435), inverse: r4(2073), normalize: r4(899), dot: r4(9305), cross: r4(903), lerp: r4(1868), random: r4(6660), transformMat4: r4(3255), transformMat3: r4(9908), transformQuat: r4(6568), rotateX: r4(392), rotateY: r4(3222), rotateZ: r4(3388), forEach: r4(7447) };
            }, 2073: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0] = 1 / e4[0], t5[1] = 1 / e4[1], t5[2] = 1 / e4[2], t5;
              };
            }, 1468: function(t4, e4, r4) {
              t4.exports = r4(4693);
            }, 4693: function(t4) {
              t4.exports = function(t5) {
                var e4 = t5[0], r4 = t5[1], n3 = t5[2];
                return Math.sqrt(e4 * e4 + r4 * r4 + n3 * n3);
              };
            }, 1868: function(t4) {
              t4.exports = function(t5, e4, r4, n3) {
                var i2 = e4[0], a = e4[1], o = e4[2];
                return t5[0] = i2 + n3 * (r4[0] - i2), t5[1] = a + n3 * (r4[1] - a), t5[2] = o + n3 * (r4[2] - o), t5;
              };
            }, 1716: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = Math.max(e4[0], r4[0]), t5[1] = Math.max(e4[1], r4[1]), t5[2] = Math.max(e4[2], r4[2]), t5;
              };
            }, 3605: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = Math.min(e4[0], r4[0]), t5[1] = Math.min(e4[1], r4[1]), t5[2] = Math.min(e4[2], r4[2]), t5;
              };
            }, 5733: function(t4, e4, r4) {
              t4.exports = r4(105);
            }, 105: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = e4[0] * r4[0], t5[1] = e4[1] * r4[1], t5[2] = e4[2] * r4[2], t5;
              };
            }, 435: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0] = -e4[0], t5[1] = -e4[1], t5[2] = -e4[2], t5;
              };
            }, 899: function(t4) {
              t4.exports = function(t5, e4) {
                var r4 = e4[0], n3 = e4[1], i2 = e4[2], a = r4 * r4 + n3 * n3 + i2 * i2;
                return a > 0 && (a = 1 / Math.sqrt(a), t5[0] = e4[0] * a, t5[1] = e4[1] * a, t5[2] = e4[2] * a), t5;
              };
            }, 6660: function(t4) {
              t4.exports = function(t5, e4) {
                e4 = e4 || 1;
                var r4 = 2 * Math.random() * Math.PI, n3 = 2 * Math.random() - 1, i2 = Math.sqrt(1 - n3 * n3) * e4;
                return t5[0] = Math.cos(r4) * i2, t5[1] = Math.sin(r4) * i2, t5[2] = n3 * e4, t5;
              };
            }, 392: function(t4) {
              t4.exports = function(t5, e4, r4, n3) {
                var i2 = r4[1], a = r4[2], o = e4[1] - i2, s = e4[2] - a, l = Math.sin(n3), u = Math.cos(n3);
                return t5[0] = e4[0], t5[1] = i2 + o * u - s * l, t5[2] = a + o * l + s * u, t5;
              };
            }, 3222: function(t4) {
              t4.exports = function(t5, e4, r4, n3) {
                var i2 = r4[0], a = r4[2], o = e4[0] - i2, s = e4[2] - a, l = Math.sin(n3), u = Math.cos(n3);
                return t5[0] = i2 + s * l + o * u, t5[1] = e4[1], t5[2] = a + s * u - o * l, t5;
              };
            }, 3388: function(t4) {
              t4.exports = function(t5, e4, r4, n3) {
                var i2 = r4[0], a = r4[1], o = e4[0] - i2, s = e4[1] - a, l = Math.sin(n3), u = Math.cos(n3);
                return t5[0] = i2 + o * u - s * l, t5[1] = a + o * l + s * u, t5[2] = e4[2], t5;
              };
            }, 1624: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0] = Math.round(e4[0]), t5[1] = Math.round(e4[1]), t5[2] = Math.round(e4[2]), t5;
              };
            }, 5685: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = e4[0] * r4, t5[1] = e4[1] * r4, t5[2] = e4[2] * r4, t5;
              };
            }, 6722: function(t4) {
              t4.exports = function(t5, e4, r4, n3) {
                return t5[0] = e4[0] + r4[0] * n3, t5[1] = e4[1] + r4[1] * n3, t5[2] = e4[2] + r4[2] * n3, t5;
              };
            }, 831: function(t4) {
              t4.exports = function(t5, e4, r4, n3) {
                return t5[0] = e4, t5[1] = r4, t5[2] = n3, t5;
              };
            }, 5294: function(t4, e4, r4) {
              t4.exports = r4(6403);
            }, 3303: function(t4, e4, r4) {
              t4.exports = r4(4337);
            }, 6403: function(t4) {
              t4.exports = function(t5, e4) {
                var r4 = e4[0] - t5[0], n3 = e4[1] - t5[1], i2 = e4[2] - t5[2];
                return r4 * r4 + n3 * n3 + i2 * i2;
              };
            }, 4337: function(t4) {
              t4.exports = function(t5) {
                var e4 = t5[0], r4 = t5[1], n3 = t5[2];
                return e4 * e4 + r4 * r4 + n3 * n3;
              };
            }, 8921: function(t4, e4, r4) {
              t4.exports = r4(911);
            }, 911: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = e4[0] - r4[0], t5[1] = e4[1] - r4[1], t5[2] = e4[2] - r4[2], t5;
              };
            }, 9908: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = e4[0], i2 = e4[1], a = e4[2];
                return t5[0] = n3 * r4[0] + i2 * r4[3] + a * r4[6], t5[1] = n3 * r4[1] + i2 * r4[4] + a * r4[7], t5[2] = n3 * r4[2] + i2 * r4[5] + a * r4[8], t5;
              };
            }, 3255: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = e4[0], i2 = e4[1], a = e4[2], o = r4[3] * n3 + r4[7] * i2 + r4[11] * a + r4[15];
                return o = o || 1, t5[0] = (r4[0] * n3 + r4[4] * i2 + r4[8] * a + r4[12]) / o, t5[1] = (r4[1] * n3 + r4[5] * i2 + r4[9] * a + r4[13]) / o, t5[2] = (r4[2] * n3 + r4[6] * i2 + r4[10] * a + r4[14]) / o, t5;
              };
            }, 6568: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = e4[0], i2 = e4[1], a = e4[2], o = r4[0], s = r4[1], l = r4[2], u = r4[3], c = u * n3 + s * a - l * i2, f2 = u * i2 + l * n3 - o * a, h = u * a + o * i2 - s * n3, p2 = -o * n3 - s * i2 - l * a;
                return t5[0] = c * u + p2 * -o + f2 * -l - h * -s, t5[1] = f2 * u + p2 * -s + h * -o - c * -l, t5[2] = h * u + p2 * -l + c * -s - f2 * -o, t5;
              };
            }, 3433: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = e4[0] + r4[0], t5[1] = e4[1] + r4[1], t5[2] = e4[2] + r4[2], t5[3] = e4[3] + r4[3], t5;
              };
            }, 1413: function(t4) {
              t4.exports = function(t5) {
                var e4 = new Float32Array(4);
                return e4[0] = t5[0], e4[1] = t5[1], e4[2] = t5[2], e4[3] = t5[3], e4;
              };
            }, 3470: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0] = e4[0], t5[1] = e4[1], t5[2] = e4[2], t5[3] = e4[3], t5;
              };
            }, 5313: function(t4) {
              t4.exports = function() {
                var t5 = new Float32Array(4);
                return t5[0] = 0, t5[1] = 0, t5[2] = 0, t5[3] = 0, t5;
              };
            }, 5446: function(t4) {
              t4.exports = function(t5, e4) {
                var r4 = e4[0] - t5[0], n3 = e4[1] - t5[1], i2 = e4[2] - t5[2], a = e4[3] - t5[3];
                return Math.sqrt(r4 * r4 + n3 * n3 + i2 * i2 + a * a);
              };
            }, 205: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = e4[0] / r4[0], t5[1] = e4[1] / r4[1], t5[2] = e4[2] / r4[2], t5[3] = e4[3] / r4[3], t5;
              };
            }, 4242: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0] * e4[0] + t5[1] * e4[1] + t5[2] * e4[2] + t5[3] * e4[3];
              };
            }, 5680: function(t4) {
              t4.exports = function(t5, e4, r4, n3) {
                var i2 = new Float32Array(4);
                return i2[0] = t5, i2[1] = e4, i2[2] = r4, i2[3] = n3, i2;
              };
            }, 4020: function(t4, e4, r4) {
              t4.exports = { create: r4(5313), clone: r4(1413), fromValues: r4(5680), copy: r4(3470), set: r4(6453), add: r4(3433), subtract: r4(2705), multiply: r4(746), divide: r4(205), min: r4(2170), max: r4(3030), scale: r4(5510), scaleAndAdd: r4(4224), distance: r4(5446), squaredDistance: r4(1542), length: r4(8177), squaredLength: r4(9037), negate: r4(6459), inverse: r4(8057), normalize: r4(381), dot: r4(4242), lerp: r4(8746), random: r4(3770), transformMat4: r4(6342), transformQuat: r4(5022) };
            }, 8057: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0] = 1 / e4[0], t5[1] = 1 / e4[1], t5[2] = 1 / e4[2], t5[3] = 1 / e4[3], t5;
              };
            }, 8177: function(t4) {
              t4.exports = function(t5) {
                var e4 = t5[0], r4 = t5[1], n3 = t5[2], i2 = t5[3];
                return Math.sqrt(e4 * e4 + r4 * r4 + n3 * n3 + i2 * i2);
              };
            }, 8746: function(t4) {
              t4.exports = function(t5, e4, r4, n3) {
                var i2 = e4[0], a = e4[1], o = e4[2], s = e4[3];
                return t5[0] = i2 + n3 * (r4[0] - i2), t5[1] = a + n3 * (r4[1] - a), t5[2] = o + n3 * (r4[2] - o), t5[3] = s + n3 * (r4[3] - s), t5;
              };
            }, 3030: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = Math.max(e4[0], r4[0]), t5[1] = Math.max(e4[1], r4[1]), t5[2] = Math.max(e4[2], r4[2]), t5[3] = Math.max(e4[3], r4[3]), t5;
              };
            }, 2170: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = Math.min(e4[0], r4[0]), t5[1] = Math.min(e4[1], r4[1]), t5[2] = Math.min(e4[2], r4[2]), t5[3] = Math.min(e4[3], r4[3]), t5;
              };
            }, 746: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = e4[0] * r4[0], t5[1] = e4[1] * r4[1], t5[2] = e4[2] * r4[2], t5[3] = e4[3] * r4[3], t5;
              };
            }, 6459: function(t4) {
              t4.exports = function(t5, e4) {
                return t5[0] = -e4[0], t5[1] = -e4[1], t5[2] = -e4[2], t5[3] = -e4[3], t5;
              };
            }, 381: function(t4) {
              t4.exports = function(t5, e4) {
                var r4 = e4[0], n3 = e4[1], i2 = e4[2], a = e4[3], o = r4 * r4 + n3 * n3 + i2 * i2 + a * a;
                return o > 0 && (o = 1 / Math.sqrt(o), t5[0] = r4 * o, t5[1] = n3 * o, t5[2] = i2 * o, t5[3] = a * o), t5;
              };
            }, 3770: function(t4, e4, r4) {
              var n3 = r4(381), i2 = r4(5510);
              t4.exports = function(t5, e5) {
                return e5 = e5 || 1, t5[0] = Math.random(), t5[1] = Math.random(), t5[2] = Math.random(), t5[3] = Math.random(), n3(t5, t5), i2(t5, t5, e5), t5;
              };
            }, 5510: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = e4[0] * r4, t5[1] = e4[1] * r4, t5[2] = e4[2] * r4, t5[3] = e4[3] * r4, t5;
              };
            }, 4224: function(t4) {
              t4.exports = function(t5, e4, r4, n3) {
                return t5[0] = e4[0] + r4[0] * n3, t5[1] = e4[1] + r4[1] * n3, t5[2] = e4[2] + r4[2] * n3, t5[3] = e4[3] + r4[3] * n3, t5;
              };
            }, 6453: function(t4) {
              t4.exports = function(t5, e4, r4, n3, i2) {
                return t5[0] = e4, t5[1] = r4, t5[2] = n3, t5[3] = i2, t5;
              };
            }, 1542: function(t4) {
              t4.exports = function(t5, e4) {
                var r4 = e4[0] - t5[0], n3 = e4[1] - t5[1], i2 = e4[2] - t5[2], a = e4[3] - t5[3];
                return r4 * r4 + n3 * n3 + i2 * i2 + a * a;
              };
            }, 9037: function(t4) {
              t4.exports = function(t5) {
                var e4 = t5[0], r4 = t5[1], n3 = t5[2], i2 = t5[3];
                return e4 * e4 + r4 * r4 + n3 * n3 + i2 * i2;
              };
            }, 2705: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5[0] = e4[0] - r4[0], t5[1] = e4[1] - r4[1], t5[2] = e4[2] - r4[2], t5[3] = e4[3] - r4[3], t5;
              };
            }, 6342: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = e4[0], i2 = e4[1], a = e4[2], o = e4[3];
                return t5[0] = r4[0] * n3 + r4[4] * i2 + r4[8] * a + r4[12] * o, t5[1] = r4[1] * n3 + r4[5] * i2 + r4[9] * a + r4[13] * o, t5[2] = r4[2] * n3 + r4[6] * i2 + r4[10] * a + r4[14] * o, t5[3] = r4[3] * n3 + r4[7] * i2 + r4[11] * a + r4[15] * o, t5;
              };
            }, 5022: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = e4[0], i2 = e4[1], a = e4[2], o = r4[0], s = r4[1], l = r4[2], u = r4[3], c = u * n3 + s * a - l * i2, f2 = u * i2 + l * n3 - o * a, h = u * a + o * i2 - s * n3, p2 = -o * n3 - s * i2 - l * a;
                return t5[0] = c * u + p2 * -o + f2 * -l - h * -s, t5[1] = f2 * u + p2 * -s + h * -o - c * -l, t5[2] = h * u + p2 * -l + c * -s - f2 * -o, t5[3] = e4[3], t5;
              };
            }, 9365: function(t4, e4, r4) {
              var n3 = r4(8096), i2 = r4(7896);
              t4.exports = function(t5) {
                for (var e5 = Array.isArray(t5) ? t5 : n3(t5), r5 = 0; r5 < e5.length; r5++) {
                  var a = e5[r5];
                  if ("preprocessor" === a.type) {
                    var o = a.data.match(/\#define\s+SHADER_NAME(_B64)?\s+(.+)$/);
                    if (o && o[2]) {
                      var s = o[1], l = o[2];
                      return (s ? i2(l) : l).trim();
                    }
                  }
                }
              };
            }, 3193: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5, r5, f2, h = 0, p2 = 0, d2 = l, v = [], g2 = [], y = 1, m2 = 0, x = 0, b = false, _ = false, w2 = "", T = a, k = n3;
                "300 es" === (t5 = t5 || {}).version && (T = s, k = o);
                var A = {}, M = {};
                for (h = 0; h < T.length; h++)
                  A[T[h]] = true;
                for (h = 0; h < k.length; h++)
                  M[k[h]] = true;
                return function(t6) {
                  return g2 = [], null !== t6 ? function(t7) {
                    var r6;
                    for (h = 0, t7.toString && (t7 = t7.toString()), w2 += t7.replace(/\r\n/g, "\n"), f2 = w2.length; e5 = w2[h], h < f2; ) {
                      switch (r6 = h, d2) {
                        case 0:
                          h = P();
                          break;
                        case 1:
                        case 2:
                          h = C();
                          break;
                        case 3:
                          h = O();
                          break;
                        case 4:
                          h = z();
                          break;
                        case 11:
                          h = D();
                          break;
                        case 5:
                          h = R();
                          break;
                        case u:
                          h = F();
                          break;
                        case 9:
                          h = L();
                          break;
                        case l:
                          h = E();
                      }
                      r6 !== h && ("\n" === w2[r6] ? (m2 = 0, ++y) : ++m2);
                    }
                    return p2 += h, w2 = w2.slice(h), g2;
                  }(t6) : (v.length && S(v.join("")), d2 = 10, S("(eof)"), g2);
                };
                function S(t6) {
                  t6.length && g2.push({ type: c[d2], data: t6, position: x, line: y, column: m2 });
                }
                function E() {
                  return v = v.length ? [] : v, "/" === r5 && "*" === e5 ? (x = p2 + h - 1, d2 = 0, r5 = e5, h + 1) : "/" === r5 && "/" === e5 ? (x = p2 + h - 1, d2 = 1, r5 = e5, h + 1) : "#" === e5 ? (d2 = 2, x = p2 + h, h) : /\s/.test(e5) ? (d2 = 9, x = p2 + h, h) : (b = /\d/.test(e5), _ = /[^\w_]/.test(e5), x = p2 + h, d2 = b ? 4 : _ ? 3 : u, h);
                }
                function L() {
                  return /[^\s]/g.test(e5) ? (S(v.join("")), d2 = l, h) : (v.push(e5), r5 = e5, h + 1);
                }
                function C() {
                  return "\r" !== e5 && "\n" !== e5 || "\\" === r5 ? (v.push(e5), r5 = e5, h + 1) : (S(v.join("")), d2 = l, h);
                }
                function P() {
                  return "/" === e5 && "*" === r5 ? (v.push(e5), S(v.join("")), d2 = l, h + 1) : (v.push(e5), r5 = e5, h + 1);
                }
                function O() {
                  if ("." === r5 && /\d/.test(e5))
                    return d2 = 5, h;
                  if ("/" === r5 && "*" === e5)
                    return d2 = 0, h;
                  if ("/" === r5 && "/" === e5)
                    return d2 = 1, h;
                  if ("." === e5 && v.length) {
                    for (; I(v); )
                      ;
                    return d2 = 5, h;
                  }
                  if (";" === e5 || ")" === e5 || "(" === e5) {
                    if (v.length)
                      for (; I(v); )
                        ;
                    return S(e5), d2 = l, h + 1;
                  }
                  var t6 = 2 === v.length && "=" !== e5;
                  if (/[\w_\d\s]/.test(e5) || t6) {
                    for (; I(v); )
                      ;
                    return d2 = l, h;
                  }
                  return v.push(e5), r5 = e5, h + 1;
                }
                function I(t6) {
                  for (var e6, r6, n4 = 0; ; ) {
                    if (e6 = i2.indexOf(t6.slice(0, t6.length + n4).join("")), r6 = i2[e6], -1 === e6) {
                      if (n4-- + t6.length > 0)
                        continue;
                      r6 = t6.slice(0, 1).join("");
                    }
                    return S(r6), x += r6.length, (v = v.slice(r6.length)).length;
                  }
                }
                function D() {
                  return /[^a-fA-F0-9]/.test(e5) ? (S(v.join("")), d2 = l, h) : (v.push(e5), r5 = e5, h + 1);
                }
                function z() {
                  return "." === e5 || /[eE]/.test(e5) ? (v.push(e5), d2 = 5, r5 = e5, h + 1) : "x" === e5 && 1 === v.length && "0" === v[0] ? (d2 = 11, v.push(e5), r5 = e5, h + 1) : /[^\d]/.test(e5) ? (S(v.join("")), d2 = l, h) : (v.push(e5), r5 = e5, h + 1);
                }
                function R() {
                  return "f" === e5 && (v.push(e5), r5 = e5, h += 1), /[eE]/.test(e5) ? (v.push(e5), r5 = e5, h + 1) : ("-" !== e5 && "+" !== e5 || !/[eE]/.test(r5)) && /[^\d]/.test(e5) ? (S(v.join("")), d2 = l, h) : (v.push(e5), r5 = e5, h + 1);
                }
                function F() {
                  if (/[^\d\w_]/.test(e5)) {
                    var t6 = v.join("");
                    return d2 = M[t6] ? 8 : A[t6] ? 7 : 6, S(v.join("")), d2 = l, h;
                  }
                  return v.push(e5), r5 = e5, h + 1;
                }
              };
              var n3 = r4(399), i2 = r4(9746), a = r4(9525), o = r4(9458), s = r4(3585), l = 999, u = 9999, c = ["block-comment", "line-comment", "preprocessor", "operator", "integer", "float", "ident", "builtin", "keyword", "whitespace", "eof", "integer"];
            }, 3585: function(t4, e4, r4) {
              var n3 = r4(9525);
              n3 = n3.slice().filter(function(t5) {
                return !/^(gl\_|texture)/.test(t5);
              }), t4.exports = n3.concat(["gl_VertexID", "gl_InstanceID", "gl_Position", "gl_PointSize", "gl_FragCoord", "gl_FrontFacing", "gl_FragDepth", "gl_PointCoord", "gl_MaxVertexAttribs", "gl_MaxVertexUniformVectors", "gl_MaxVertexOutputVectors", "gl_MaxFragmentInputVectors", "gl_MaxVertexTextureImageUnits", "gl_MaxCombinedTextureImageUnits", "gl_MaxTextureImageUnits", "gl_MaxFragmentUniformVectors", "gl_MaxDrawBuffers", "gl_MinProgramTexelOffset", "gl_MaxProgramTexelOffset", "gl_DepthRangeParameters", "gl_DepthRange", "trunc", "round", "roundEven", "isnan", "isinf", "floatBitsToInt", "floatBitsToUint", "intBitsToFloat", "uintBitsToFloat", "packSnorm2x16", "unpackSnorm2x16", "packUnorm2x16", "unpackUnorm2x16", "packHalf2x16", "unpackHalf2x16", "outerProduct", "transpose", "determinant", "inverse", "texture", "textureSize", "textureProj", "textureLod", "textureOffset", "texelFetch", "texelFetchOffset", "textureProjOffset", "textureLodOffset", "textureProjLod", "textureProjLodOffset", "textureGrad", "textureGradOffset", "textureProjGrad", "textureProjGradOffset"]);
            }, 9525: function(t4) {
              t4.exports = ["abs", "acos", "all", "any", "asin", "atan", "ceil", "clamp", "cos", "cross", "dFdx", "dFdy", "degrees", "distance", "dot", "equal", "exp", "exp2", "faceforward", "floor", "fract", "gl_BackColor", "gl_BackLightModelProduct", "gl_BackLightProduct", "gl_BackMaterial", "gl_BackSecondaryColor", "gl_ClipPlane", "gl_ClipVertex", "gl_Color", "gl_DepthRange", "gl_DepthRangeParameters", "gl_EyePlaneQ", "gl_EyePlaneR", "gl_EyePlaneS", "gl_EyePlaneT", "gl_Fog", "gl_FogCoord", "gl_FogFragCoord", "gl_FogParameters", "gl_FragColor", "gl_FragCoord", "gl_FragData", "gl_FragDepth", "gl_FragDepthEXT", "gl_FrontColor", "gl_FrontFacing", "gl_FrontLightModelProduct", "gl_FrontLightProduct", "gl_FrontMaterial", "gl_FrontSecondaryColor", "gl_LightModel", "gl_LightModelParameters", "gl_LightModelProducts", "gl_LightProducts", "gl_LightSource", "gl_LightSourceParameters", "gl_MaterialParameters", "gl_MaxClipPlanes", "gl_MaxCombinedTextureImageUnits", "gl_MaxDrawBuffers", "gl_MaxFragmentUniformComponents", "gl_MaxLights", "gl_MaxTextureCoords", "gl_MaxTextureImageUnits", "gl_MaxTextureUnits", "gl_MaxVaryingFloats", "gl_MaxVertexAttribs", "gl_MaxVertexTextureImageUnits", "gl_MaxVertexUniformComponents", "gl_ModelViewMatrix", "gl_ModelViewMatrixInverse", "gl_ModelViewMatrixInverseTranspose", "gl_ModelViewMatrixTranspose", "gl_ModelViewProjectionMatrix", "gl_ModelViewProjectionMatrixInverse", "gl_ModelViewProjectionMatrixInverseTranspose", "gl_ModelViewProjectionMatrixTranspose", "gl_MultiTexCoord0", "gl_MultiTexCoord1", "gl_MultiTexCoord2", "gl_MultiTexCoord3", "gl_MultiTexCoord4", "gl_MultiTexCoord5", "gl_MultiTexCoord6", "gl_MultiTexCoord7", "gl_Normal", "gl_NormalMatrix", "gl_NormalScale", "gl_ObjectPlaneQ", "gl_ObjectPlaneR", "gl_ObjectPlaneS", "gl_ObjectPlaneT", "gl_Point", "gl_PointCoord", "gl_PointParameters", "gl_PointSize", "gl_Position", "gl_ProjectionMatrix", "gl_ProjectionMatrixInverse", "gl_ProjectionMatrixInverseTranspose", "gl_ProjectionMatrixTranspose", "gl_SecondaryColor", "gl_TexCoord", "gl_TextureEnvColor", "gl_TextureMatrix", "gl_TextureMatrixInverse", "gl_TextureMatrixInverseTranspose", "gl_TextureMatrixTranspose", "gl_Vertex", "greaterThan", "greaterThanEqual", "inversesqrt", "length", "lessThan", "lessThanEqual", "log", "log2", "matrixCompMult", "max", "min", "mix", "mod", "normalize", "not", "notEqual", "pow", "radians", "reflect", "refract", "sign", "sin", "smoothstep", "sqrt", "step", "tan", "texture2D", "texture2DLod", "texture2DProj", "texture2DProjLod", "textureCube", "textureCubeLod", "texture2DLodEXT", "texture2DProjLodEXT", "textureCubeLodEXT", "texture2DGradEXT", "texture2DProjGradEXT", "textureCubeGradEXT"];
            }, 9458: function(t4, e4, r4) {
              var n3 = r4(399);
              t4.exports = n3.slice().concat(["layout", "centroid", "smooth", "case", "mat2x2", "mat2x3", "mat2x4", "mat3x2", "mat3x3", "mat3x4", "mat4x2", "mat4x3", "mat4x4", "uvec2", "uvec3", "uvec4", "samplerCubeShadow", "sampler2DArray", "sampler2DArrayShadow", "isampler2D", "isampler3D", "isamplerCube", "isampler2DArray", "usampler2D", "usampler3D", "usamplerCube", "usampler2DArray", "coherent", "restrict", "readonly", "writeonly", "resource", "atomic_uint", "noperspective", "patch", "sample", "subroutine", "common", "partition", "active", "filter", "image1D", "image2D", "image3D", "imageCube", "iimage1D", "iimage2D", "iimage3D", "iimageCube", "uimage1D", "uimage2D", "uimage3D", "uimageCube", "image1DArray", "image2DArray", "iimage1DArray", "iimage2DArray", "uimage1DArray", "uimage2DArray", "image1DShadow", "image2DShadow", "image1DArrayShadow", "image2DArrayShadow", "imageBuffer", "iimageBuffer", "uimageBuffer", "sampler1DArray", "sampler1DArrayShadow", "isampler1D", "isampler1DArray", "usampler1D", "usampler1DArray", "isampler2DRect", "usampler2DRect", "samplerBuffer", "isamplerBuffer", "usamplerBuffer", "sampler2DMS", "isampler2DMS", "usampler2DMS", "sampler2DMSArray", "isampler2DMSArray", "usampler2DMSArray"]);
            }, 399: function(t4) {
              t4.exports = ["precision", "highp", "mediump", "lowp", "attribute", "const", "uniform", "varying", "break", "continue", "do", "for", "while", "if", "else", "in", "out", "inout", "float", "int", "uint", "void", "bool", "true", "false", "discard", "return", "mat2", "mat3", "mat4", "vec2", "vec3", "vec4", "ivec2", "ivec3", "ivec4", "bvec2", "bvec3", "bvec4", "sampler1D", "sampler2D", "sampler3D", "samplerCube", "sampler1DShadow", "sampler2DShadow", "struct", "asm", "class", "union", "enum", "typedef", "template", "this", "packed", "goto", "switch", "default", "inline", "noinline", "volatile", "public", "static", "extern", "external", "interface", "long", "short", "double", "half", "fixed", "unsigned", "input", "output", "hvec2", "hvec3", "hvec4", "dvec2", "dvec3", "dvec4", "fvec2", "fvec3", "fvec4", "sampler2DRect", "sampler3DRect", "sampler2DRectShadow", "sizeof", "cast", "namespace", "using"];
            }, 9746: function(t4) {
              t4.exports = ["<<=", ">>=", "++", "--", "<<", ">>", "<=", ">=", "==", "!=", "&&", "||", "+=", "-=", "*=", "/=", "%=", "&=", "^^", "^=", "|=", "(", ")", "[", "]", ".", "!", "~", "*", "/", "%", "+", "-", "<", ">", "&", "^", "|", "?", ":", "=", ",", ";", "{", "}"];
            }, 8096: function(t4, e4, r4) {
              var n3 = r4(3193);
              t4.exports = function(t5, e5) {
                var r5 = n3(e5), i2 = [];
                return (i2 = i2.concat(r5(t5))).concat(r5(null));
              };
            }, 6832: function(t4) {
              t4.exports = function(t5) {
                "string" == typeof t5 && (t5 = [t5]);
                for (var e4 = [].slice.call(arguments, 1), r4 = [], n3 = 0; n3 < t5.length - 1; n3++)
                  r4.push(t5[n3], e4[n3] || "");
                return r4.push(t5[n3]), r4.join("");
              };
            }, 5233: function(t4, e4, r4) {
              var n3 = r4(4846);
              t4.exports = n3 && function() {
                var t5 = false;
                try {
                  var e5 = Object.defineProperty({}, "passive", { get: function() {
                    t5 = true;
                  } });
                  window.addEventListener("test", null, e5), window.removeEventListener("test", null, e5);
                } catch (e6) {
                  t5 = false;
                }
                return t5;
              }();
            }, 2183: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                var r5 = t5.length;
                if (0 === r5)
                  throw new Error("Must have at least d+1 points");
                var i3 = t5[0].length;
                if (r5 <= i3)
                  throw new Error("Must input at least d+1 points");
                var o2 = t5.slice(0, i3 + 1), s2 = n3.apply(void 0, o2);
                if (0 === s2)
                  throw new Error("Input not in general position");
                for (var l2 = new Array(i3 + 1), c2 = 0; c2 <= i3; ++c2)
                  l2[c2] = c2;
                s2 < 0 && (l2[0] = 1, l2[1] = 0);
                var f2 = new a(l2, new Array(i3 + 1), false), h = f2.adjacent, p2 = new Array(i3 + 2);
                for (c2 = 0; c2 <= i3; ++c2) {
                  for (var d2 = l2.slice(), v = 0; v <= i3; ++v)
                    v === c2 && (d2[v] = -1);
                  var g2 = d2[0];
                  d2[0] = d2[1], d2[1] = g2;
                  var y = new a(d2, new Array(i3 + 1), true);
                  h[c2] = y, p2[c2] = y;
                }
                for (p2[i3 + 1] = f2, c2 = 0; c2 <= i3; ++c2) {
                  d2 = h[c2].vertices;
                  var m2 = h[c2].adjacent;
                  for (v = 0; v <= i3; ++v) {
                    var x = d2[v];
                    if (x < 0)
                      m2[v] = f2;
                    else
                      for (var b = 0; b <= i3; ++b)
                        h[b].vertices.indexOf(x) < 0 && (m2[v] = h[b]);
                  }
                }
                var _ = new u(i3, o2, p2), w2 = !!e5;
                for (c2 = i3 + 1; c2 < r5; ++c2)
                  _.insert(t5[c2], w2);
                return _.boundary();
              };
              var n3 = r4(417), i2 = r4(8211).H;
              function a(t5, e5, r5) {
                this.vertices = t5, this.adjacent = e5, this.boundary = r5, this.lastVisited = -1;
              }
              function o(t5, e5, r5) {
                this.vertices = t5, this.cell = e5, this.index = r5;
              }
              function s(t5, e5) {
                return i2(t5.vertices, e5.vertices);
              }
              a.prototype.flip = function() {
                var t5 = this.vertices[0];
                this.vertices[0] = this.vertices[1], this.vertices[1] = t5;
                var e5 = this.adjacent[0];
                this.adjacent[0] = this.adjacent[1], this.adjacent[1] = e5;
              };
              var l = [];
              function u(t5, e5, r5) {
                this.dimension = t5, this.vertices = e5, this.simplices = r5, this.interior = r5.filter(function(t6) {
                  return !t6.boundary;
                }), this.tuple = new Array(t5 + 1);
                for (var i3 = 0; i3 <= t5; ++i3)
                  this.tuple[i3] = this.vertices[i3];
                var a2, o2 = l[t5];
                o2 || (o2 = l[t5] = ((a2 = n3[t5 + 1]) || (a2 = n3), function(t6) {
                  return function() {
                    var e6 = this.tuple;
                    return t6.apply(this, e6);
                  };
                }(a2))), this.orient = o2;
              }
              var c = u.prototype;
              c.handleBoundaryDegeneracy = function(t5, e5) {
                var r5 = this.dimension, n4 = this.vertices.length - 1, i3 = this.tuple, a2 = this.vertices, o2 = [t5];
                for (t5.lastVisited = -n4; o2.length > 0; )
                  for (var s2 = (t5 = o2.pop()).adjacent, l2 = 0; l2 <= r5; ++l2) {
                    var u2 = s2[l2];
                    if (u2.boundary && !(u2.lastVisited <= -n4)) {
                      for (var c2 = u2.vertices, f2 = 0; f2 <= r5; ++f2) {
                        var h = c2[f2];
                        i3[f2] = h < 0 ? e5 : a2[h];
                      }
                      var p2 = this.orient();
                      if (p2 > 0)
                        return u2;
                      u2.lastVisited = -n4, 0 === p2 && o2.push(u2);
                    }
                  }
                return null;
              }, c.walk = function(t5, e5) {
                var r5 = this.vertices.length - 1, n4 = this.dimension, i3 = this.vertices, a2 = this.tuple, o2 = e5 ? this.interior.length * Math.random() | 0 : this.interior.length - 1, s2 = this.interior[o2];
                t:
                  for (; !s2.boundary; ) {
                    for (var l2 = s2.vertices, u2 = s2.adjacent, c2 = 0; c2 <= n4; ++c2)
                      a2[c2] = i3[l2[c2]];
                    for (s2.lastVisited = r5, c2 = 0; c2 <= n4; ++c2) {
                      var f2 = u2[c2];
                      if (!(f2.lastVisited >= r5)) {
                        var h = a2[c2];
                        a2[c2] = t5;
                        var p2 = this.orient();
                        if (a2[c2] = h, p2 < 0) {
                          s2 = f2;
                          continue t;
                        }
                        f2.boundary ? f2.lastVisited = -r5 : f2.lastVisited = r5;
                      }
                    }
                    return;
                  }
                return s2;
              }, c.addPeaks = function(t5, e5) {
                var r5 = this.vertices.length - 1, n4 = this.dimension, i3 = this.vertices, l2 = this.tuple, u2 = this.interior, c2 = this.simplices, f2 = [e5];
                e5.lastVisited = r5, e5.vertices[e5.vertices.indexOf(-1)] = r5, e5.boundary = false, u2.push(e5);
                for (var h = []; f2.length > 0; ) {
                  var p2 = (e5 = f2.pop()).vertices, d2 = e5.adjacent, v = p2.indexOf(r5);
                  if (!(v < 0)) {
                    for (var g2 = 0; g2 <= n4; ++g2)
                      if (g2 !== v) {
                        var y = d2[g2];
                        if (y.boundary && !(y.lastVisited >= r5)) {
                          var m2 = y.vertices;
                          if (y.lastVisited !== -r5) {
                            for (var x = 0, b = 0; b <= n4; ++b)
                              m2[b] < 0 ? (x = b, l2[b] = t5) : l2[b] = i3[m2[b]];
                            if (this.orient() > 0) {
                              m2[x] = r5, y.boundary = false, u2.push(y), f2.push(y), y.lastVisited = r5;
                              continue;
                            }
                            y.lastVisited = -r5;
                          }
                          var _ = y.adjacent, w2 = p2.slice(), T = d2.slice(), k = new a(w2, T, true);
                          c2.push(k);
                          var A = _.indexOf(e5);
                          if (!(A < 0))
                            for (_[A] = k, T[v] = y, w2[g2] = -1, T[g2] = e5, d2[g2] = k, k.flip(), b = 0; b <= n4; ++b) {
                              var M = w2[b];
                              if (!(M < 0 || M === r5)) {
                                for (var S = new Array(n4 - 1), E = 0, L = 0; L <= n4; ++L) {
                                  var C = w2[L];
                                  C < 0 || L === b || (S[E++] = C);
                                }
                                h.push(new o(S, k, b));
                              }
                            }
                        }
                      }
                  }
                }
                for (h.sort(s), g2 = 0; g2 + 1 < h.length; g2 += 2) {
                  var P = h[g2], O = h[g2 + 1], I = P.index, D = O.index;
                  I < 0 || D < 0 || (P.cell.adjacent[P.index] = O.cell, O.cell.adjacent[O.index] = P.cell);
                }
              }, c.insert = function(t5, e5) {
                var r5 = this.vertices;
                r5.push(t5);
                var n4 = this.walk(t5, e5);
                if (n4) {
                  for (var i3 = this.dimension, a2 = this.tuple, o2 = 0; o2 <= i3; ++o2) {
                    var s2 = n4.vertices[o2];
                    a2[o2] = s2 < 0 ? t5 : r5[s2];
                  }
                  var l2 = this.orient(a2);
                  l2 < 0 || (0 !== l2 || (n4 = this.handleBoundaryDegeneracy(n4, t5))) && this.addPeaks(t5, n4);
                }
              }, c.boundary = function() {
                for (var t5 = this.dimension, e5 = [], r5 = this.simplices, n4 = r5.length, i3 = 0; i3 < n4; ++i3) {
                  var a2 = r5[i3];
                  if (a2.boundary) {
                    for (var o2 = new Array(t5), s2 = a2.vertices, l2 = 0, u2 = 0, c2 = 0; c2 <= t5; ++c2)
                      s2[c2] >= 0 ? o2[l2++] = s2[c2] : u2 = 1 & c2;
                    if (u2 === (1 & t5)) {
                      var f2 = o2[0];
                      o2[0] = o2[1], o2[1] = f2;
                    }
                    e5.push(o2);
                  }
                }
                return e5;
              };
            }, 9014: function(t4, e4, r4) {
              var n3 = r4(5070);
              function i2(t5, e5, r5, n4, i3) {
                this.mid = t5, this.left = e5, this.right = r5, this.leftPoints = n4, this.rightPoints = i3, this.count = (e5 ? e5.count : 0) + (r5 ? r5.count : 0) + n4.length;
              }
              t4.exports = function(t5) {
                return t5 && 0 !== t5.length ? new y(g2(t5)) : new y(null);
              };
              var a = i2.prototype;
              function o(t5, e5) {
                t5.mid = e5.mid, t5.left = e5.left, t5.right = e5.right, t5.leftPoints = e5.leftPoints, t5.rightPoints = e5.rightPoints, t5.count = e5.count;
              }
              function s(t5, e5) {
                var r5 = g2(e5);
                t5.mid = r5.mid, t5.left = r5.left, t5.right = r5.right, t5.leftPoints = r5.leftPoints, t5.rightPoints = r5.rightPoints, t5.count = r5.count;
              }
              function l(t5, e5) {
                var r5 = t5.intervals([]);
                r5.push(e5), s(t5, r5);
              }
              function u(t5, e5) {
                var r5 = t5.intervals([]), n4 = r5.indexOf(e5);
                return n4 < 0 ? 0 : (r5.splice(n4, 1), s(t5, r5), 1);
              }
              function c(t5, e5, r5) {
                for (var n4 = 0; n4 < t5.length && t5[n4][0] <= e5; ++n4) {
                  var i3 = r5(t5[n4]);
                  if (i3)
                    return i3;
                }
              }
              function f2(t5, e5, r5) {
                for (var n4 = t5.length - 1; n4 >= 0 && t5[n4][1] >= e5; --n4) {
                  var i3 = r5(t5[n4]);
                  if (i3)
                    return i3;
                }
              }
              function h(t5, e5) {
                for (var r5 = 0; r5 < t5.length; ++r5) {
                  var n4 = e5(t5[r5]);
                  if (n4)
                    return n4;
                }
              }
              function p2(t5, e5) {
                return t5 - e5;
              }
              function d2(t5, e5) {
                return t5[0] - e5[0] || t5[1] - e5[1];
              }
              function v(t5, e5) {
                return t5[1] - e5[1] || t5[0] - e5[0];
              }
              function g2(t5) {
                if (0 === t5.length)
                  return null;
                for (var e5 = [], r5 = 0; r5 < t5.length; ++r5)
                  e5.push(t5[r5][0], t5[r5][1]);
                e5.sort(p2);
                var n4 = e5[e5.length >> 1], a2 = [], o2 = [], s2 = [];
                for (r5 = 0; r5 < t5.length; ++r5) {
                  var l2 = t5[r5];
                  l2[1] < n4 ? a2.push(l2) : n4 < l2[0] ? o2.push(l2) : s2.push(l2);
                }
                var u2 = s2, c2 = s2.slice();
                return u2.sort(d2), c2.sort(v), new i2(n4, g2(a2), g2(o2), u2, c2);
              }
              function y(t5) {
                this.root = t5;
              }
              a.intervals = function(t5) {
                return t5.push.apply(t5, this.leftPoints), this.left && this.left.intervals(t5), this.right && this.right.intervals(t5), t5;
              }, a.insert = function(t5) {
                var e5 = this.count - this.leftPoints.length;
                if (this.count += 1, t5[1] < this.mid)
                  this.left ? 4 * (this.left.count + 1) > 3 * (e5 + 1) ? l(this, t5) : this.left.insert(t5) : this.left = g2([t5]);
                else if (t5[0] > this.mid)
                  this.right ? 4 * (this.right.count + 1) > 3 * (e5 + 1) ? l(this, t5) : this.right.insert(t5) : this.right = g2([t5]);
                else {
                  var r5 = n3.ge(this.leftPoints, t5, d2), i3 = n3.ge(this.rightPoints, t5, v);
                  this.leftPoints.splice(r5, 0, t5), this.rightPoints.splice(i3, 0, t5);
                }
              }, a.remove = function(t5) {
                var e5 = this.count - this.leftPoints;
                if (t5[1] < this.mid)
                  return this.left ? 4 * (this.right ? this.right.count : 0) > 3 * (e5 - 1) ? u(this, t5) : 2 === (s2 = this.left.remove(t5)) ? (this.left = null, this.count -= 1, 1) : (1 === s2 && (this.count -= 1), s2) : 0;
                if (t5[0] > this.mid)
                  return this.right ? 4 * (this.left ? this.left.count : 0) > 3 * (e5 - 1) ? u(this, t5) : 2 === (s2 = this.right.remove(t5)) ? (this.right = null, this.count -= 1, 1) : (1 === s2 && (this.count -= 1), s2) : 0;
                if (1 === this.count)
                  return this.leftPoints[0] === t5 ? 2 : 0;
                if (1 === this.leftPoints.length && this.leftPoints[0] === t5) {
                  if (this.left && this.right) {
                    for (var r5 = this, i3 = this.left; i3.right; )
                      r5 = i3, i3 = i3.right;
                    if (r5 === this)
                      i3.right = this.right;
                    else {
                      var a2 = this.left, s2 = this.right;
                      r5.count -= i3.count, r5.right = i3.left, i3.left = a2, i3.right = s2;
                    }
                    o(this, i3), this.count = (this.left ? this.left.count : 0) + (this.right ? this.right.count : 0) + this.leftPoints.length;
                  } else
                    this.left ? o(this, this.left) : o(this, this.right);
                  return 1;
                }
                for (a2 = n3.ge(this.leftPoints, t5, d2); a2 < this.leftPoints.length && this.leftPoints[a2][0] === t5[0]; ++a2)
                  if (this.leftPoints[a2] === t5) {
                    for (this.count -= 1, this.leftPoints.splice(a2, 1), s2 = n3.ge(this.rightPoints, t5, v); s2 < this.rightPoints.length && this.rightPoints[s2][1] === t5[1]; ++s2)
                      if (this.rightPoints[s2] === t5)
                        return this.rightPoints.splice(s2, 1), 1;
                  }
                return 0;
              }, a.queryPoint = function(t5, e5) {
                return t5 < this.mid ? this.left && (r5 = this.left.queryPoint(t5, e5)) ? r5 : c(this.leftPoints, t5, e5) : t5 > this.mid ? this.right && (r5 = this.right.queryPoint(t5, e5)) ? r5 : f2(this.rightPoints, t5, e5) : h(this.leftPoints, e5);
                var r5;
              }, a.queryInterval = function(t5, e5, r5) {
                var n4;
                return t5 < this.mid && this.left && (n4 = this.left.queryInterval(t5, e5, r5)) || e5 > this.mid && this.right && (n4 = this.right.queryInterval(t5, e5, r5)) ? n4 : e5 < this.mid ? c(this.leftPoints, e5, r5) : t5 > this.mid ? f2(this.rightPoints, t5, r5) : h(this.leftPoints, r5);
              };
              var m2 = y.prototype;
              m2.insert = function(t5) {
                this.root ? this.root.insert(t5) : this.root = new i2(t5[0], null, null, [t5], [t5]);
              }, m2.remove = function(t5) {
                if (this.root) {
                  var e5 = this.root.remove(t5);
                  return 2 === e5 && (this.root = null), 0 !== e5;
                }
                return false;
              }, m2.queryPoint = function(t5, e5) {
                if (this.root)
                  return this.root.queryPoint(t5, e5);
              }, m2.queryInterval = function(t5, e5, r5) {
                if (t5 <= e5 && this.root)
                  return this.root.queryInterval(t5, e5, r5);
              }, Object.defineProperty(m2, "count", { get: function() {
                return this.root ? this.root.count : 0;
              } }), Object.defineProperty(m2, "intervals", { get: function() {
                return this.root ? this.root.intervals([]) : [];
              } });
            }, 9560: function(t4) {
              t4.exports = function(t5) {
                for (var e4 = new Array(t5), r4 = 0; r4 < t5; ++r4)
                  e4[r4] = r4;
                return e4;
              };
            }, 4846: function(t4) {
              t4.exports = true;
            }, 4780: function(t4) {
              function e4(t5) {
                return !!t5.constructor && "function" == typeof t5.constructor.isBuffer && t5.constructor.isBuffer(t5);
              }
              t4.exports = function(t5) {
                return null != t5 && (e4(t5) || function(t6) {
                  return "function" == typeof t6.readFloatLE && "function" == typeof t6.slice && e4(t6.slice(0, 0));
                }(t5) || !!t5._isBuffer);
              };
            }, 3596: function(t4) {
              t4.exports = function(t5) {
                for (var e4, r4 = t5.length, n3 = 0; n3 < r4; n3++)
                  if (((e4 = t5.charCodeAt(n3)) < 9 || e4 > 13) && 32 !== e4 && 133 !== e4 && 160 !== e4 && 5760 !== e4 && 6158 !== e4 && (e4 < 8192 || e4 > 8205) && 8232 !== e4 && 8233 !== e4 && 8239 !== e4 && 8287 !== e4 && 8288 !== e4 && 12288 !== e4 && 65279 !== e4)
                    return false;
                return true;
              };
            }, 3578: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return t5 * (1 - r4) + e4 * r4;
              };
            }, 7191: function(t4, e4, r4) {
              var n3 = r4(4690), i2 = r4(9823), a = r4(7332), o = r4(7787), s = r4(7437), l = r4(2142), u = { length: r4(4693), normalize: r4(899), dot: r4(9305), cross: r4(903) }, c = i2(), f2 = i2(), h = [0, 0, 0, 0], p2 = [[0, 0, 0], [0, 0, 0], [0, 0, 0]], d2 = [0, 0, 0];
              function v(t5, e5, r5, n4, i3) {
                t5[0] = e5[0] * n4 + r5[0] * i3, t5[1] = e5[1] * n4 + r5[1] * i3, t5[2] = e5[2] * n4 + r5[2] * i3;
              }
              t4.exports = function(t5, e5, r5, i3, g2, y) {
                if (e5 || (e5 = [0, 0, 0]), r5 || (r5 = [0, 0, 0]), i3 || (i3 = [0, 0, 0]), g2 || (g2 = [0, 0, 0, 1]), y || (y = [0, 0, 0, 1]), !n3(c, t5))
                  return false;
                if (a(f2, c), f2[3] = 0, f2[7] = 0, f2[11] = 0, f2[15] = 1, Math.abs(o(f2) < 1e-8))
                  return false;
                var m2, x, b, _, w2, T, k, A = c[3], M = c[7], S = c[11], E = c[12], L = c[13], C = c[14], P = c[15];
                if (0 !== A || 0 !== M || 0 !== S) {
                  if (h[0] = A, h[1] = M, h[2] = S, h[3] = P, !s(f2, f2))
                    return false;
                  l(f2, f2), m2 = g2, b = f2, _ = (x = h)[0], w2 = x[1], T = x[2], k = x[3], m2[0] = b[0] * _ + b[4] * w2 + b[8] * T + b[12] * k, m2[1] = b[1] * _ + b[5] * w2 + b[9] * T + b[13] * k, m2[2] = b[2] * _ + b[6] * w2 + b[10] * T + b[14] * k, m2[3] = b[3] * _ + b[7] * w2 + b[11] * T + b[15] * k;
                } else
                  g2[0] = g2[1] = g2[2] = 0, g2[3] = 1;
                if (e5[0] = E, e5[1] = L, e5[2] = C, function(t6, e6) {
                  t6[0][0] = e6[0], t6[0][1] = e6[1], t6[0][2] = e6[2], t6[1][0] = e6[4], t6[1][1] = e6[5], t6[1][2] = e6[6], t6[2][0] = e6[8], t6[2][1] = e6[9], t6[2][2] = e6[10];
                }(p2, c), r5[0] = u.length(p2[0]), u.normalize(p2[0], p2[0]), i3[0] = u.dot(p2[0], p2[1]), v(p2[1], p2[1], p2[0], 1, -i3[0]), r5[1] = u.length(p2[1]), u.normalize(p2[1], p2[1]), i3[0] /= r5[1], i3[1] = u.dot(p2[0], p2[2]), v(p2[2], p2[2], p2[0], 1, -i3[1]), i3[2] = u.dot(p2[1], p2[2]), v(p2[2], p2[2], p2[1], 1, -i3[2]), r5[2] = u.length(p2[2]), u.normalize(p2[2], p2[2]), i3[1] /= r5[2], i3[2] /= r5[2], u.cross(d2, p2[1], p2[2]), u.dot(p2[0], d2) < 0)
                  for (var O = 0; O < 3; O++)
                    r5[O] *= -1, p2[O][0] *= -1, p2[O][1] *= -1, p2[O][2] *= -1;
                return y[0] = 0.5 * Math.sqrt(Math.max(1 + p2[0][0] - p2[1][1] - p2[2][2], 0)), y[1] = 0.5 * Math.sqrt(Math.max(1 - p2[0][0] + p2[1][1] - p2[2][2], 0)), y[2] = 0.5 * Math.sqrt(Math.max(1 - p2[0][0] - p2[1][1] + p2[2][2], 0)), y[3] = 0.5 * Math.sqrt(Math.max(1 + p2[0][0] + p2[1][1] + p2[2][2], 0)), p2[2][1] > p2[1][2] && (y[0] = -y[0]), p2[0][2] > p2[2][0] && (y[1] = -y[1]), p2[1][0] > p2[0][1] && (y[2] = -y[2]), true;
              };
            }, 4690: function(t4) {
              t4.exports = function(t5, e4) {
                var r4 = e4[15];
                if (0 === r4)
                  return false;
                for (var n3 = 1 / r4, i2 = 0; i2 < 16; i2++)
                  t5[i2] = e4[i2] * n3;
                return true;
              };
            }, 7649: function(t4, e4, r4) {
              var n3 = r4(1868), i2 = r4(1102), a = r4(7191), o = r4(7787), s = r4(1116), l = f2(), u = f2(), c = f2();
              function f2() {
                return { translate: h(), scale: h(1), skew: h(), perspective: [0, 0, 0, 1], quaternion: [0, 0, 0, 1] };
              }
              function h(t5) {
                return [t5 || 0, t5 || 0, t5 || 0];
              }
              t4.exports = function(t5, e5, r5, f3) {
                if (0 === o(e5) || 0 === o(r5))
                  return false;
                var h2 = a(e5, l.translate, l.scale, l.skew, l.perspective, l.quaternion), p2 = a(r5, u.translate, u.scale, u.skew, u.perspective, u.quaternion);
                return !(!h2 || !p2 || (n3(c.translate, l.translate, u.translate, f3), n3(c.skew, l.skew, u.skew, f3), n3(c.scale, l.scale, u.scale, f3), n3(c.perspective, l.perspective, u.perspective, f3), s(c.quaternion, l.quaternion, u.quaternion, f3), i2(t5, c.translate, c.scale, c.skew, c.perspective, c.quaternion), 0));
              };
            }, 1102: function(t4, e4, r4) {
              var n3 = { identity: r4(9947), translate: r4(998), multiply: r4(104), create: r4(9823), scale: r4(3668), fromRotationTranslation: r4(7280) }, i2 = (n3.create(), n3.create());
              t4.exports = function(t5, e5, r5, a, o, s) {
                return n3.identity(t5), n3.fromRotationTranslation(t5, s, e5), t5[3] = o[0], t5[7] = o[1], t5[11] = o[2], t5[15] = o[3], n3.identity(i2), 0 !== a[2] && (i2[9] = a[2], n3.multiply(t5, t5, i2)), 0 !== a[1] && (i2[9] = 0, i2[8] = a[1], n3.multiply(t5, t5, i2)), 0 !== a[0] && (i2[8] = 0, i2[4] = a[0], n3.multiply(t5, t5, i2)), n3.scale(t5, t5, r5), t5;
              };
            }, 9298: function(t4, e4, r4) {
              var n3 = r4(5070), i2 = r4(7649), a = r4(7437), o = r4(6109), s = r4(7115), l = r4(5240), u = r4(3012), c = r4(998), f2 = (r4(3668), r4(899)), h = [0, 0, 0];
              function p2(t5) {
                this._components = t5.slice(), this._time = [0], this.prevMatrix = t5.slice(), this.nextMatrix = t5.slice(), this.computedMatrix = t5.slice(), this.computedInverse = t5.slice(), this.computedEye = [0, 0, 0], this.computedUp = [0, 0, 0], this.computedCenter = [0, 0, 0], this.computedRadius = [0], this._limits = [-1 / 0, 1 / 0];
              }
              t4.exports = function(t5) {
                return new p2((t5 = t5 || {}).matrix || [1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1]);
              };
              var d2 = p2.prototype;
              d2.recalcMatrix = function(t5) {
                var e5 = this._time, r5 = n3.le(e5, t5), o2 = this.computedMatrix;
                if (!(r5 < 0)) {
                  var s2 = this._components;
                  if (r5 === e5.length - 1)
                    for (var l2 = 16 * r5, u2 = 0; u2 < 16; ++u2)
                      o2[u2] = s2[l2++];
                  else {
                    var c2 = e5[r5 + 1] - e5[r5], h2 = (l2 = 16 * r5, this.prevMatrix), p3 = true;
                    for (u2 = 0; u2 < 16; ++u2)
                      h2[u2] = s2[l2++];
                    var d3 = this.nextMatrix;
                    for (u2 = 0; u2 < 16; ++u2)
                      d3[u2] = s2[l2++], p3 = p3 && h2[u2] === d3[u2];
                    if (c2 < 1e-6 || p3)
                      for (u2 = 0; u2 < 16; ++u2)
                        o2[u2] = h2[u2];
                    else
                      i2(o2, h2, d3, (t5 - e5[r5]) / c2);
                  }
                  var v2 = this.computedUp;
                  v2[0] = o2[1], v2[1] = o2[5], v2[2] = o2[9], f2(v2, v2);
                  var g2 = this.computedInverse;
                  a(g2, o2);
                  var y = this.computedEye, m2 = g2[15];
                  y[0] = g2[12] / m2, y[1] = g2[13] / m2, y[2] = g2[14] / m2;
                  var x = this.computedCenter, b = Math.exp(this.computedRadius[0]);
                  for (u2 = 0; u2 < 3; ++u2)
                    x[u2] = y[u2] - o2[2 + 4 * u2] * b;
                }
              }, d2.idle = function(t5) {
                if (!(t5 < this.lastT())) {
                  for (var e5 = this._components, r5 = e5.length - 16, n4 = 0; n4 < 16; ++n4)
                    e5.push(e5[r5++]);
                  this._time.push(t5);
                }
              }, d2.flush = function(t5) {
                var e5 = n3.gt(this._time, t5) - 2;
                e5 < 0 || (this._time.splice(0, e5), this._components.splice(0, 16 * e5));
              }, d2.lastT = function() {
                return this._time[this._time.length - 1];
              }, d2.lookAt = function(t5, e5, r5, n4) {
                this.recalcMatrix(t5), e5 = e5 || this.computedEye, r5 = r5 || h, n4 = n4 || this.computedUp, this.setMatrix(t5, u(this.computedMatrix, e5, r5, n4));
                for (var i3 = 0, a2 = 0; a2 < 3; ++a2)
                  i3 += Math.pow(r5[a2] - e5[a2], 2);
                i3 = Math.log(Math.sqrt(i3)), this.computedRadius[0] = i3;
              }, d2.rotate = function(t5, e5, r5, n4) {
                this.recalcMatrix(t5);
                var i3 = this.computedInverse;
                e5 && s(i3, i3, e5), r5 && o(i3, i3, r5), n4 && l(i3, i3, n4), this.setMatrix(t5, a(this.computedMatrix, i3));
              };
              var v = [0, 0, 0];
              d2.pan = function(t5, e5, r5, n4) {
                v[0] = -(e5 || 0), v[1] = -(r5 || 0), v[2] = -(n4 || 0), this.recalcMatrix(t5);
                var i3 = this.computedInverse;
                c(i3, i3, v), this.setMatrix(t5, a(i3, i3));
              }, d2.translate = function(t5, e5, r5, n4) {
                v[0] = e5 || 0, v[1] = r5 || 0, v[2] = n4 || 0, this.recalcMatrix(t5);
                var i3 = this.computedMatrix;
                c(i3, i3, v), this.setMatrix(t5, i3);
              }, d2.setMatrix = function(t5, e5) {
                if (!(t5 < this.lastT())) {
                  this._time.push(t5);
                  for (var r5 = 0; r5 < 16; ++r5)
                    this._components.push(e5[r5]);
                }
              }, d2.setDistance = function(t5, e5) {
                this.computedRadius[0] = e5;
              }, d2.setDistanceLimits = function(t5, e5) {
                var r5 = this._limits;
                r5[0] = t5, r5[1] = e5;
              }, d2.getDistanceLimits = function(t5) {
                var e5 = this._limits;
                return t5 ? (t5[0] = e5[0], t5[1] = e5[1], t5) : e5;
              };
            }, 3266: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = t5.length;
                if (e5 < 3) {
                  for (var r5 = new Array(e5), i2 = 0; i2 < e5; ++i2)
                    r5[i2] = i2;
                  return 2 === e5 && t5[0][0] === t5[1][0] && t5[0][1] === t5[1][1] ? [0] : r5;
                }
                var a = new Array(e5);
                for (i2 = 0; i2 < e5; ++i2)
                  a[i2] = i2;
                a.sort(function(e6, r6) {
                  return t5[e6][0] - t5[r6][0] || t5[e6][1] - t5[r6][1];
                });
                var o = [a[0], a[1]], s = [a[0], a[1]];
                for (i2 = 2; i2 < e5; ++i2) {
                  for (var l = a[i2], u = t5[l], c = o.length; c > 1 && n3(t5[o[c - 2]], t5[o[c - 1]], u) <= 0; )
                    c -= 1, o.pop();
                  for (o.push(l), c = s.length; c > 1 && n3(t5[s[c - 2]], t5[s[c - 1]], u) >= 0; )
                    c -= 1, s.pop();
                  s.push(l);
                }
                r5 = new Array(s.length + o.length - 2);
                for (var f2 = 0, h = (i2 = 0, o.length); i2 < h; ++i2)
                  r5[f2++] = o[i2];
                for (var p2 = s.length - 2; p2 > 0; --p2)
                  r5[f2++] = s[p2];
                return r5;
              };
              var n3 = r4(417)[3];
            }, 6145: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                e5 || (e5 = t5, t5 = window);
                var r5 = 0, i2 = 0, a = 0, o = { shift: false, alt: false, control: false, meta: false }, s = false;
                function l(t6) {
                  var e6 = false;
                  return "altKey" in t6 && (e6 = e6 || t6.altKey !== o.alt, o.alt = !!t6.altKey), "shiftKey" in t6 && (e6 = e6 || t6.shiftKey !== o.shift, o.shift = !!t6.shiftKey), "ctrlKey" in t6 && (e6 = e6 || t6.ctrlKey !== o.control, o.control = !!t6.ctrlKey), "metaKey" in t6 && (e6 = e6 || t6.metaKey !== o.meta, o.meta = !!t6.metaKey), e6;
                }
                function u(t6, s2) {
                  var u2 = n3.x(s2), c2 = n3.y(s2);
                  "buttons" in s2 && (t6 = 0 | s2.buttons), (t6 !== r5 || u2 !== i2 || c2 !== a || l(s2)) && (r5 = 0 | t6, i2 = u2 || 0, a = c2 || 0, e5 && e5(r5, i2, a, o));
                }
                function c(t6) {
                  u(0, t6);
                }
                function f2() {
                  (r5 || i2 || a || o.shift || o.alt || o.meta || o.control) && (i2 = a = 0, r5 = 0, o.shift = o.alt = o.control = o.meta = false, e5 && e5(0, 0, 0, o));
                }
                function h(t6) {
                  l(t6) && e5 && e5(r5, i2, a, o);
                }
                function p2(t6) {
                  0 === n3.buttons(t6) ? u(0, t6) : u(r5, t6);
                }
                function d2(t6) {
                  u(r5 | n3.buttons(t6), t6);
                }
                function v(t6) {
                  u(r5 & ~n3.buttons(t6), t6);
                }
                function g2() {
                  s || (s = true, t5.addEventListener("mousemove", p2), t5.addEventListener("mousedown", d2), t5.addEventListener("mouseup", v), t5.addEventListener("mouseleave", c), t5.addEventListener("mouseenter", c), t5.addEventListener("mouseout", c), t5.addEventListener("mouseover", c), t5.addEventListener("blur", f2), t5.addEventListener("keyup", h), t5.addEventListener("keydown", h), t5.addEventListener("keypress", h), t5 !== window && (window.addEventListener("blur", f2), window.addEventListener("keyup", h), window.addEventListener("keydown", h), window.addEventListener("keypress", h)));
                }
                g2();
                var y = { element: t5 };
                return Object.defineProperties(y, { enabled: { get: function() {
                  return s;
                }, set: function(e6) {
                  e6 ? g2() : s && (s = false, t5.removeEventListener("mousemove", p2), t5.removeEventListener("mousedown", d2), t5.removeEventListener("mouseup", v), t5.removeEventListener("mouseleave", c), t5.removeEventListener("mouseenter", c), t5.removeEventListener("mouseout", c), t5.removeEventListener("mouseover", c), t5.removeEventListener("blur", f2), t5.removeEventListener("keyup", h), t5.removeEventListener("keydown", h), t5.removeEventListener("keypress", h), t5 !== window && (window.removeEventListener("blur", f2), window.removeEventListener("keyup", h), window.removeEventListener("keydown", h), window.removeEventListener("keypress", h)));
                }, enumerable: true }, buttons: { get: function() {
                  return r5;
                }, enumerable: true }, x: { get: function() {
                  return i2;
                }, enumerable: true }, y: { get: function() {
                  return a;
                }, enumerable: true }, mods: { get: function() {
                  return o;
                }, enumerable: true } }), y;
              };
              var n3 = r4(4110);
            }, 2565: function(t4) {
              var e4 = { left: 0, top: 0 };
              t4.exports = function(t5, r4, n3) {
                r4 = r4 || t5.currentTarget || t5.srcElement, Array.isArray(n3) || (n3 = [0, 0]);
                var i2, a = t5.clientX || 0, o = t5.clientY || 0, s = (i2 = r4) === window || i2 === document || i2 === document.body ? e4 : i2.getBoundingClientRect();
                return n3[0] = a - s.left, n3[1] = o - s.top, n3;
              };
            }, 4110: function(t4, e4) {
              function r4(t5) {
                return t5.target || t5.srcElement || window;
              }
              e4.buttons = function(t5) {
                if ("object" == typeof t5) {
                  if ("buttons" in t5)
                    return t5.buttons;
                  if ("which" in t5) {
                    if (2 === (e5 = t5.which))
                      return 4;
                    if (3 === e5)
                      return 2;
                    if (e5 > 0)
                      return 1 << e5 - 1;
                  } else if ("button" in t5) {
                    var e5;
                    if (1 === (e5 = t5.button))
                      return 4;
                    if (2 === e5)
                      return 2;
                    if (e5 >= 0)
                      return 1 << e5;
                  }
                }
                return 0;
              }, e4.element = r4, e4.x = function(t5) {
                if ("object" == typeof t5) {
                  if ("offsetX" in t5)
                    return t5.offsetX;
                  var e5 = r4(t5).getBoundingClientRect();
                  return t5.clientX - e5.left;
                }
                return 0;
              }, e4.y = function(t5) {
                if ("object" == typeof t5) {
                  if ("offsetY" in t5)
                    return t5.offsetY;
                  var e5 = r4(t5).getBoundingClientRect();
                  return t5.clientY - e5.top;
                }
                return 0;
              };
            }, 6475: function(t4, e4, r4) {
              var n3 = r4(14);
              t4.exports = function(t5, e5, r5) {
                "function" == typeof t5 && (r5 = !!e5, e5 = t5, t5 = window);
                var i2 = n3("ex", t5), a = function(t6) {
                  r5 && t6.preventDefault();
                  var n4 = t6.deltaX || 0, a2 = t6.deltaY || 0, o = t6.deltaZ || 0, s = 1;
                  switch (t6.deltaMode) {
                    case 1:
                      s = i2;
                      break;
                    case 2:
                      s = window.innerHeight;
                  }
                  if (a2 *= s, o *= s, (n4 *= s) || a2 || o)
                    return e5(n4, a2, o, t6);
                };
                return t5.addEventListener("wheel", a), a;
              };
            }, 9284: function(t4, e4, r4) {
              var n3 = r4(5306);
              t4.exports = function(t5) {
                function e5(t6) {
                  throw new Error("ndarray-extract-contour: " + t6);
                }
                "object" != typeof t5 && e5("Must specify arguments");
                var r5 = t5.order;
                Array.isArray(r5) || e5("Must specify order");
                var a = t5.arrayArguments || 1;
                a < 1 && e5("Must have at least one array argument"), (t5.scalarArguments || 0) < 0 && e5("Scalar arg count must be > 0"), "function" != typeof t5.vertex && e5("Must specify vertex creation function"), "function" != typeof t5.cell && e5("Must specify cell creation function"), "function" != typeof t5.phase && e5("Must specify phase function");
                for (var o = t5.getters || [], s = new Array(a), l = 0; l < a; ++l)
                  o.indexOf(l) >= 0 ? s[l] = true : s[l] = false;
                return function(t6, e6, r6, a2, o2, s2) {
                  var l2 = [s2, o2].join(",");
                  return (0, i2[l2])(t6, e6, r6, n3.mallocUint32, n3.freeUint32);
                }(t5.vertex, t5.cell, t5.phase, 0, r5, s);
              };
              var i2 = { "false,0,1": function(t5, e5, r5, n4, i3) {
                return function(a, o, s, l) {
                  var u, c = 0 | a.shape[0], f2 = 0 | a.shape[1], h = a.data, p2 = 0 | a.offset, d2 = 0 | a.stride[0], v = 0 | a.stride[1], g2 = p2, y = 0 | -d2, m2 = 0, x = 0 | -v, b = 0, _ = -d2 - v | 0, w2 = 0, T = 0 | d2, k = v - d2 * c | 0, A = 0, M = 0, S = 0, E = 2 * c | 0, L = n4(E), C = n4(E), P = 0, O = 0, I = -1, D = -1, z = 0, R = 0 | -c, F = 0 | c, B = 0, N = -c - 1 | 0, j = c - 1 | 0, U = 0, V = 0, H = 0;
                  for (A = 0; A < c; ++A)
                    L[P++] = r5(h[g2], o, s, l), g2 += T;
                  if (g2 += k, f2 > 0) {
                    if (M = 1, L[P++] = r5(h[g2], o, s, l), g2 += T, c > 0)
                      for (A = 1, u = h[g2], O = L[P] = r5(u, o, s, l), z = L[P + I], B = L[P + R], U = L[P + N], O === z && O === B && O === U || (m2 = h[g2 + y], b = h[g2 + x], w2 = h[g2 + _], t5(A, M, u, m2, b, w2, O, z, B, U, o, s, l), V = C[P] = S++), P += 1, g2 += T, A = 2; A < c; ++A)
                        u = h[g2], O = L[P] = r5(u, o, s, l), z = L[P + I], B = L[P + R], U = L[P + N], O === z && O === B && O === U || (m2 = h[g2 + y], b = h[g2 + x], w2 = h[g2 + _], t5(A, M, u, m2, b, w2, O, z, B, U, o, s, l), V = C[P] = S++, U !== z && e5(C[P + I], V, w2, m2, U, z, o, s, l)), P += 1, g2 += T;
                    for (g2 += k, P = 0, H = I, I = D, D = H, H = R, R = F, F = H, H = N, N = j, j = H, M = 2; M < f2; ++M) {
                      if (L[P++] = r5(h[g2], o, s, l), g2 += T, c > 0)
                        for (A = 1, u = h[g2], O = L[P] = r5(u, o, s, l), z = L[P + I], B = L[P + R], U = L[P + N], O === z && O === B && O === U || (m2 = h[g2 + y], b = h[g2 + x], w2 = h[g2 + _], t5(A, M, u, m2, b, w2, O, z, B, U, o, s, l), V = C[P] = S++, U !== B && e5(C[P + R], V, b, w2, B, U, o, s, l)), P += 1, g2 += T, A = 2; A < c; ++A)
                          u = h[g2], O = L[P] = r5(u, o, s, l), z = L[P + I], B = L[P + R], U = L[P + N], O === z && O === B && O === U || (m2 = h[g2 + y], b = h[g2 + x], w2 = h[g2 + _], t5(A, M, u, m2, b, w2, O, z, B, U, o, s, l), V = C[P] = S++, U !== B && e5(C[P + R], V, b, w2, B, U, o, s, l), U !== z && e5(C[P + I], V, w2, m2, U, z, o, s, l)), P += 1, g2 += T;
                      1 & M && (P = 0), H = I, I = D, D = H, H = R, R = F, F = H, H = N, N = j, j = H, g2 += k;
                    }
                  }
                  i3(C), i3(L);
                };
              }, "false,1,0": function(t5, e5, r5, n4, i3) {
                return function(a, o, s, l) {
                  var u, c = 0 | a.shape[0], f2 = 0 | a.shape[1], h = a.data, p2 = 0 | a.offset, d2 = 0 | a.stride[0], v = 0 | a.stride[1], g2 = p2, y = 0 | -d2, m2 = 0, x = 0 | -v, b = 0, _ = -d2 - v | 0, w2 = 0, T = 0 | v, k = d2 - v * f2 | 0, A = 0, M = 0, S = 0, E = 2 * f2 | 0, L = n4(E), C = n4(E), P = 0, O = 0, I = -1, D = -1, z = 0, R = 0 | -f2, F = 0 | f2, B = 0, N = -f2 - 1 | 0, j = f2 - 1 | 0, U = 0, V = 0, H = 0;
                  for (M = 0; M < f2; ++M)
                    L[P++] = r5(h[g2], o, s, l), g2 += T;
                  if (g2 += k, c > 0) {
                    if (A = 1, L[P++] = r5(h[g2], o, s, l), g2 += T, f2 > 0)
                      for (M = 1, u = h[g2], O = L[P] = r5(u, o, s, l), B = L[P + R], z = L[P + I], U = L[P + N], O === B && O === z && O === U || (m2 = h[g2 + y], b = h[g2 + x], w2 = h[g2 + _], t5(A, M, u, m2, b, w2, O, B, z, U, o, s, l), V = C[P] = S++), P += 1, g2 += T, M = 2; M < f2; ++M)
                        u = h[g2], O = L[P] = r5(u, o, s, l), B = L[P + R], z = L[P + I], U = L[P + N], O === B && O === z && O === U || (m2 = h[g2 + y], b = h[g2 + x], w2 = h[g2 + _], t5(A, M, u, m2, b, w2, O, B, z, U, o, s, l), V = C[P] = S++, U !== z && e5(C[P + I], V, b, w2, z, U, o, s, l)), P += 1, g2 += T;
                    for (g2 += k, P = 0, H = R, R = F, F = H, H = I, I = D, D = H, H = N, N = j, j = H, A = 2; A < c; ++A) {
                      if (L[P++] = r5(h[g2], o, s, l), g2 += T, f2 > 0)
                        for (M = 1, u = h[g2], O = L[P] = r5(u, o, s, l), B = L[P + R], z = L[P + I], U = L[P + N], O === B && O === z && O === U || (m2 = h[g2 + y], b = h[g2 + x], w2 = h[g2 + _], t5(A, M, u, m2, b, w2, O, B, z, U, o, s, l), V = C[P] = S++, U !== B && e5(C[P + R], V, w2, m2, U, B, o, s, l)), P += 1, g2 += T, M = 2; M < f2; ++M)
                          u = h[g2], O = L[P] = r5(u, o, s, l), B = L[P + R], z = L[P + I], U = L[P + N], O === B && O === z && O === U || (m2 = h[g2 + y], b = h[g2 + x], w2 = h[g2 + _], t5(A, M, u, m2, b, w2, O, B, z, U, o, s, l), V = C[P] = S++, U !== z && e5(C[P + I], V, b, w2, z, U, o, s, l), U !== B && e5(C[P + R], V, w2, m2, U, B, o, s, l)), P += 1, g2 += T;
                      1 & A && (P = 0), H = R, R = F, F = H, H = I, I = D, D = H, H = N, N = j, j = H, g2 += k;
                    }
                  }
                  i3(C), i3(L);
                };
              } };
            }, 9144: function(t4, e4, r4) {
              var n3 = r4(3094), i2 = { zero: function(t5, e5, r5, n4) {
                var i3 = t5[0];
                n4 |= 0;
                var a2 = 0, o2 = r5[0];
                for (a2 = 0; a2 < i3; ++a2)
                  e5[n4] = 0, n4 += o2;
              }, fdTemplate1: function(t5, e5, r5, n4, i3, a2, o2) {
                var s2 = t5[0], l2 = r5[0], u2 = -1 * l2, c2 = l2;
                n4 |= 0, o2 |= 0;
                var f3 = 0, h2 = l2, p3 = a2[0];
                for (f3 = 0; f3 < s2; ++f3)
                  i3[o2] = 0.5 * (e5[n4 + u2] - e5[n4 + c2]), n4 += h2, o2 += p3;
              }, fdTemplate2: function(t5, e5, r5, n4, i3, a2, o2, s2, l2, u2) {
                var c2 = t5[0], f3 = t5[1], h2 = r5[0], p3 = r5[1], d3 = a2[0], v = a2[1], g2 = l2[0], y = l2[1], m2 = -1 * h2, x = h2, b = -1 * p3, _ = p3;
                n4 |= 0, o2 |= 0, u2 |= 0;
                var w2 = 0, T = 0, k = p3, A = h2 - f3 * p3, M = v, S = d3 - f3 * v, E = y, L = g2 - f3 * y;
                for (T = 0; T < c2; ++T) {
                  for (w2 = 0; w2 < f3; ++w2)
                    i3[o2] = 0.5 * (e5[n4 + m2] - e5[n4 + x]), s2[u2] = 0.5 * (e5[n4 + b] - e5[n4 + _]), n4 += k, o2 += M, u2 += E;
                  n4 += A, o2 += S, u2 += L;
                }
              } }, a = { cdiff: function(t5) {
                var e5 = {};
                return function(r5, n4, i3) {
                  var a2 = r5.dtype, o2 = r5.order, s2 = n4.dtype, l2 = n4.order, u2 = i3.dtype, c2 = i3.order, f3 = [a2, o2.join(), s2, l2.join(), u2, c2.join()].join(), h2 = e5[f3];
                  return h2 || (e5[f3] = h2 = t5([a2, o2, s2, l2, u2, c2])), h2(r5.shape.slice(0), r5.data, r5.stride, 0 | r5.offset, n4.data, n4.stride, 0 | n4.offset, i3.data, i3.stride, 0 | i3.offset);
                };
              }, zero: function(t5) {
                var e5 = {};
                return function(r5) {
                  var n4 = r5.dtype, i3 = r5.order, a2 = [n4, i3.join()].join(), o2 = e5[a2];
                  return o2 || (e5[a2] = o2 = t5([n4, i3])), o2(r5.shape.slice(0), r5.data, r5.stride, 0 | r5.offset);
                };
              }, fdTemplate1: function(t5) {
                var e5 = {};
                return function(r5, n4) {
                  var i3 = r5.dtype, a2 = r5.order, o2 = n4.dtype, s2 = n4.order, l2 = [i3, a2.join(), o2, s2.join()].join(), u2 = e5[l2];
                  return u2 || (e5[l2] = u2 = t5([i3, a2, o2, s2])), u2(r5.shape.slice(0), r5.data, r5.stride, 0 | r5.offset, n4.data, n4.stride, 0 | n4.offset);
                };
              }, fdTemplate2: function(t5) {
                var e5 = {};
                return function(r5, n4, i3) {
                  var a2 = r5.dtype, o2 = r5.order, s2 = n4.dtype, l2 = n4.order, u2 = i3.dtype, c2 = i3.order, f3 = [a2, o2.join(), s2, l2.join(), u2, c2.join()].join(), h2 = e5[f3];
                  return h2 || (e5[f3] = h2 = t5([a2, o2, s2, l2, u2, c2])), h2(r5.shape.slice(0), r5.data, r5.stride, 0 | r5.offset, n4.data, n4.stride, 0 | n4.offset, i3.data, i3.stride, 0 | i3.offset);
                };
              } };
              function o(t5) {
                return (0, a[t5.funcName])(s.bind(void 0, t5));
              }
              function s(t5) {
                return i2[t5.funcName];
              }
              function l(t5) {
                return o({ funcName: t5.funcName });
              }
              var u = {}, c = {}, f2 = l({ funcName: "cdiff" }), h = l({ funcName: "zero" });
              function p2(t5) {
                return t5 in u ? u[t5] : u[t5] = l({ funcName: "fdTemplate" + t5 });
              }
              function d2(t5, e5, r5, n4) {
                return function(t6, i3) {
                  var a2 = i3.shape.slice();
                  return a2[0] > 2 && a2[1] > 2 && n4(i3.pick(-1, -1).lo(1, 1).hi(a2[0] - 2, a2[1] - 2), t6.pick(-1, -1, 0).lo(1, 1).hi(a2[0] - 2, a2[1] - 2), t6.pick(-1, -1, 1).lo(1, 1).hi(a2[0] - 2, a2[1] - 2)), a2[1] > 2 && (r5(i3.pick(0, -1).lo(1).hi(a2[1] - 2), t6.pick(0, -1, 1).lo(1).hi(a2[1] - 2)), e5(t6.pick(0, -1, 0).lo(1).hi(a2[1] - 2))), a2[1] > 2 && (r5(i3.pick(a2[0] - 1, -1).lo(1).hi(a2[1] - 2), t6.pick(a2[0] - 1, -1, 1).lo(1).hi(a2[1] - 2)), e5(t6.pick(a2[0] - 1, -1, 0).lo(1).hi(a2[1] - 2))), a2[0] > 2 && (r5(i3.pick(-1, 0).lo(1).hi(a2[0] - 2), t6.pick(-1, 0, 0).lo(1).hi(a2[0] - 2)), e5(t6.pick(-1, 0, 1).lo(1).hi(a2[0] - 2))), a2[0] > 2 && (r5(i3.pick(-1, a2[1] - 1).lo(1).hi(a2[0] - 2), t6.pick(-1, a2[1] - 1, 0).lo(1).hi(a2[0] - 2)), e5(t6.pick(-1, a2[1] - 1, 1).lo(1).hi(a2[0] - 2))), t6.set(0, 0, 0, 0), t6.set(0, 0, 1, 0), t6.set(a2[0] - 1, 0, 0, 0), t6.set(a2[0] - 1, 0, 1, 0), t6.set(0, a2[1] - 1, 0, 0), t6.set(0, a2[1] - 1, 1, 0), t6.set(a2[0] - 1, a2[1] - 1, 0, 0), t6.set(a2[0] - 1, a2[1] - 1, 1, 0), t6;
                };
              }
              t4.exports = function(t5, e5, r5) {
                return Array.isArray(r5) || (r5 = n3(e5.dimension, "string" == typeof r5 ? r5 : "clamp")), 0 === e5.size ? t5 : 0 === e5.dimension ? (t5.set(0), t5) : function(t6) {
                  var e6 = t6.join();
                  if (a2 = c[e6])
                    return a2;
                  for (var r6 = t6.length, n4 = [f2, h], i3 = 1; i3 <= r6; ++i3)
                    n4.push(p2(i3));
                  var a2 = d2.apply(void 0, n4);
                  return c[e6] = a2, a2;
                }(r5)(t5, e5);
              };
            }, 3581: function(t4) {
              function e4(t5, e5) {
                var r5 = Math.floor(e5), n4 = e5 - r5, i3 = 0 <= r5 && r5 < t5.shape[0], a = 0 <= r5 + 1 && r5 + 1 < t5.shape[0];
                return (1 - n4) * (i3 ? +t5.get(r5) : 0) + n4 * (a ? +t5.get(r5 + 1) : 0);
              }
              function r4(t5, e5, r5) {
                var n4 = Math.floor(e5), i3 = e5 - n4, a = 0 <= n4 && n4 < t5.shape[0], o = 0 <= n4 + 1 && n4 + 1 < t5.shape[0], s = Math.floor(r5), l = r5 - s, u = 0 <= s && s < t5.shape[1], c = 0 <= s + 1 && s + 1 < t5.shape[1], f2 = a && u ? t5.get(n4, s) : 0, h = a && c ? t5.get(n4, s + 1) : 0;
                return (1 - l) * ((1 - i3) * f2 + i3 * (o && u ? t5.get(n4 + 1, s) : 0)) + l * ((1 - i3) * h + i3 * (o && c ? t5.get(n4 + 1, s + 1) : 0));
              }
              function n3(t5, e5, r5, n4) {
                var i3 = Math.floor(e5), a = e5 - i3, o = 0 <= i3 && i3 < t5.shape[0], s = 0 <= i3 + 1 && i3 + 1 < t5.shape[0], l = Math.floor(r5), u = r5 - l, c = 0 <= l && l < t5.shape[1], f2 = 0 <= l + 1 && l + 1 < t5.shape[1], h = Math.floor(n4), p2 = n4 - h, d2 = 0 <= h && h < t5.shape[2], v = 0 <= h + 1 && h + 1 < t5.shape[2], g2 = o && c && d2 ? t5.get(i3, l, h) : 0, y = o && f2 && d2 ? t5.get(i3, l + 1, h) : 0, m2 = s && c && d2 ? t5.get(i3 + 1, l, h) : 0, x = s && f2 && d2 ? t5.get(i3 + 1, l + 1, h) : 0, b = o && c && v ? t5.get(i3, l, h + 1) : 0, _ = o && f2 && v ? t5.get(i3, l + 1, h + 1) : 0;
                return (1 - p2) * ((1 - u) * ((1 - a) * g2 + a * m2) + u * ((1 - a) * y + a * x)) + p2 * ((1 - u) * ((1 - a) * b + a * (s && c && v ? t5.get(i3 + 1, l, h + 1) : 0)) + u * ((1 - a) * _ + a * (s && f2 && v ? t5.get(i3 + 1, l + 1, h + 1) : 0)));
              }
              function i2(t5) {
                var e5, r5, n4 = 0 | t5.shape.length, i3 = new Array(n4), a = new Array(n4), o = new Array(n4), s = new Array(n4);
                for (e5 = 0; e5 < n4; ++e5)
                  r5 = +arguments[e5 + 1], i3[e5] = Math.floor(r5), a[e5] = r5 - i3[e5], o[e5] = 0 <= i3[e5] && i3[e5] < t5.shape[e5], s[e5] = 0 <= i3[e5] + 1 && i3[e5] + 1 < t5.shape[e5];
                var l, u, c, f2 = 0;
                t:
                  for (e5 = 0; e5 < 1 << n4; ++e5) {
                    for (u = 1, c = t5.offset, l = 0; l < n4; ++l)
                      if (e5 & 1 << l) {
                        if (!s[l])
                          continue t;
                        u *= a[l], c += t5.stride[l] * (i3[l] + 1);
                      } else {
                        if (!o[l])
                          continue t;
                        u *= 1 - a[l], c += t5.stride[l] * i3[l];
                      }
                    f2 += u * t5.data[c];
                  }
                return f2;
              }
              t4.exports = function(t5, a, o, s) {
                switch (t5.shape.length) {
                  case 0:
                    return 0;
                  case 1:
                    return e4(t5, a);
                  case 2:
                    return r4(t5, a, o);
                  case 3:
                    return n3(t5, a, o, s);
                  default:
                    return i2.apply(void 0, arguments);
                }
              }, t4.exports.d1 = e4, t4.exports.d2 = r4, t4.exports.d3 = n3;
            }, 7498: function(t4, e4) {
              var r4 = { "float64,2,1,0": function() {
                return function(t5, e5, r5, n4, i3) {
                  var a2 = t5[0], o2 = t5[1], s = t5[2], l = r5[0], u = r5[1], c = r5[2];
                  n4 |= 0;
                  var f2 = 0, h = 0, p2 = 0, d2 = c, v = u - s * c, g2 = l - o2 * u;
                  for (p2 = 0; p2 < a2; ++p2) {
                    for (h = 0; h < o2; ++h) {
                      for (f2 = 0; f2 < s; ++f2)
                        e5[n4] /= i3, n4 += d2;
                      n4 += v;
                    }
                    n4 += g2;
                  }
                };
              }, "uint8,2,0,1,float64,2,1,0": function() {
                return function(t5, e5, r5, n4, i3, a2, o2, s) {
                  for (var l = t5[0], u = t5[1], c = t5[2], f2 = r5[0], h = r5[1], p2 = r5[2], d2 = a2[0], v = a2[1], g2 = a2[2], y = n4 |= 0, m2 = o2 |= 0, x = 0 | t5[0]; x > 0; ) {
                    x < 64 ? (l = x, x = 0) : (l = 64, x -= 64);
                    for (var b = 0 | t5[1]; b > 0; ) {
                      b < 64 ? (u = b, b = 0) : (u = 64, b -= 64), n4 = y + x * f2 + b * h, o2 = m2 + x * d2 + b * v;
                      var _ = 0, w2 = 0, T = 0, k = p2, A = f2 - c * p2, M = h - l * f2, S = g2, E = d2 - c * g2, L = v - l * d2;
                      for (T = 0; T < u; ++T) {
                        for (w2 = 0; w2 < l; ++w2) {
                          for (_ = 0; _ < c; ++_)
                            e5[n4] = i3[o2] * s, n4 += k, o2 += S;
                          n4 += A, o2 += E;
                        }
                        n4 += M, o2 += L;
                      }
                    }
                  }
                };
              }, "float32,1,0,float32,1,0": function() {
                return function(t5, e5, r5, n4, i3, a2, o2) {
                  var s = t5[0], l = t5[1], u = r5[0], c = r5[1], f2 = a2[0], h = a2[1];
                  n4 |= 0, o2 |= 0;
                  var p2 = 0, d2 = 0, v = c, g2 = u - l * c, y = h, m2 = f2 - l * h;
                  for (d2 = 0; d2 < s; ++d2) {
                    for (p2 = 0; p2 < l; ++p2)
                      e5[n4] = i3[o2], n4 += v, o2 += y;
                    n4 += g2, o2 += m2;
                  }
                };
              }, "float32,1,0,float32,0,1": function() {
                return function(t5, e5, r5, n4, i3, a2, o2) {
                  for (var s = t5[0], l = t5[1], u = r5[0], c = r5[1], f2 = a2[0], h = a2[1], p2 = n4 |= 0, d2 = o2 |= 0, v = 0 | t5[1]; v > 0; ) {
                    v < 64 ? (l = v, v = 0) : (l = 64, v -= 64);
                    for (var g2 = 0 | t5[0]; g2 > 0; ) {
                      g2 < 64 ? (s = g2, g2 = 0) : (s = 64, g2 -= 64), n4 = p2 + v * c + g2 * u, o2 = d2 + v * h + g2 * f2;
                      var y = 0, m2 = 0, x = c, b = u - l * c, _ = h, w2 = f2 - l * h;
                      for (m2 = 0; m2 < s; ++m2) {
                        for (y = 0; y < l; ++y)
                          e5[n4] = i3[o2], n4 += x, o2 += _;
                        n4 += b, o2 += w2;
                      }
                    }
                  }
                };
              }, "uint8,2,0,1,uint8,1,2,0": function() {
                return function(t5, e5, r5, n4, i3, a2, o2) {
                  for (var s = t5[0], l = t5[1], u = t5[2], c = r5[0], f2 = r5[1], h = r5[2], p2 = a2[0], d2 = a2[1], v = a2[2], g2 = n4 |= 0, y = o2 |= 0, m2 = 0 | t5[2]; m2 > 0; ) {
                    m2 < 64 ? (u = m2, m2 = 0) : (u = 64, m2 -= 64);
                    for (var x = 0 | t5[0]; x > 0; ) {
                      x < 64 ? (s = x, x = 0) : (s = 64, x -= 64);
                      for (var b = 0 | t5[1]; b > 0; ) {
                        b < 64 ? (l = b, b = 0) : (l = 64, b -= 64), n4 = g2 + m2 * h + x * c + b * f2, o2 = y + m2 * v + x * p2 + b * d2;
                        var _ = 0, w2 = 0, T = 0, k = h, A = c - u * h, M = f2 - s * c, S = v, E = p2 - u * v, L = d2 - s * p2;
                        for (T = 0; T < l; ++T) {
                          for (w2 = 0; w2 < s; ++w2) {
                            for (_ = 0; _ < u; ++_)
                              e5[n4] = i3[o2], n4 += k, o2 += S;
                            n4 += A, o2 += E;
                          }
                          n4 += M, o2 += L;
                        }
                      }
                    }
                  }
                };
              }, "uint8,2,0,1,array,2,0,1": function() {
                return function(t5, e5, r5, n4, i3, a2, o2) {
                  var s = t5[0], l = t5[1], u = t5[2], c = r5[0], f2 = r5[1], h = r5[2], p2 = a2[0], d2 = a2[1], v = a2[2];
                  n4 |= 0, o2 |= 0;
                  var g2 = 0, y = 0, m2 = 0, x = h, b = c - u * h, _ = f2 - s * c, w2 = v, T = p2 - u * v, k = d2 - s * p2;
                  for (m2 = 0; m2 < l; ++m2) {
                    for (y = 0; y < s; ++y) {
                      for (g2 = 0; g2 < u; ++g2)
                        e5[n4] = i3[o2], n4 += x, o2 += w2;
                      n4 += b, o2 += T;
                    }
                    n4 += _, o2 += k;
                  }
                };
              } }, n3 = function(t5, e5) {
                var n4 = e5.join(",");
                return (0, r4[n4])();
              }, i2 = { mul: function(t5) {
                var e5 = {};
                return function(r5, n4, i3) {
                  var a2 = r5.dtype, o2 = r5.order, s = n4.dtype, l = n4.order, u = i3.dtype, c = i3.order, f2 = [a2, o2.join(), s, l.join(), u, c.join()].join(), h = e5[f2];
                  return h || (e5[f2] = h = t5([a2, o2, s, l, u, c])), h(r5.shape.slice(0), r5.data, r5.stride, 0 | r5.offset, n4.data, n4.stride, 0 | n4.offset, i3.data, i3.stride, 0 | i3.offset);
                };
              }, muls: function(t5) {
                var e5 = {};
                return function(r5, n4, i3) {
                  var a2 = r5.dtype, o2 = r5.order, s = n4.dtype, l = n4.order, u = [a2, o2.join(), s, l.join()].join(), c = e5[u];
                  return c || (e5[u] = c = t5([a2, o2, s, l])), c(r5.shape.slice(0), r5.data, r5.stride, 0 | r5.offset, n4.data, n4.stride, 0 | n4.offset, i3);
                };
              }, mulseq: function(t5) {
                var e5 = {};
                return function(r5, n4) {
                  var i3 = r5.dtype, a2 = r5.order, o2 = [i3, a2.join()].join(), s = e5[o2];
                  return s || (e5[o2] = s = t5([i3, a2])), s(r5.shape.slice(0), r5.data, r5.stride, 0 | r5.offset, n4);
                };
              }, div: function(t5) {
                var e5 = {};
                return function(r5, n4, i3) {
                  var a2 = r5.dtype, o2 = r5.order, s = n4.dtype, l = n4.order, u = i3.dtype, c = i3.order, f2 = [a2, o2.join(), s, l.join(), u, c.join()].join(), h = e5[f2];
                  return h || (e5[f2] = h = t5([a2, o2, s, l, u, c])), h(r5.shape.slice(0), r5.data, r5.stride, 0 | r5.offset, n4.data, n4.stride, 0 | n4.offset, i3.data, i3.stride, 0 | i3.offset);
                };
              }, divs: function(t5) {
                var e5 = {};
                return function(r5, n4, i3) {
                  var a2 = r5.dtype, o2 = r5.order, s = n4.dtype, l = n4.order, u = [a2, o2.join(), s, l.join()].join(), c = e5[u];
                  return c || (e5[u] = c = t5([a2, o2, s, l])), c(r5.shape.slice(0), r5.data, r5.stride, 0 | r5.offset, n4.data, n4.stride, 0 | n4.offset, i3);
                };
              }, divseq: function(t5) {
                var e5 = {};
                return function(r5, n4) {
                  var i3 = r5.dtype, a2 = r5.order, o2 = [i3, a2.join()].join(), s = e5[o2];
                  return s || (e5[o2] = s = t5([i3, a2])), s(r5.shape.slice(0), r5.data, r5.stride, 0 | r5.offset, n4);
                };
              }, assign: function(t5) {
                var e5 = {};
                return function(r5, n4) {
                  var i3 = r5.dtype, a2 = r5.order, o2 = n4.dtype, s = n4.order, l = [i3, a2.join(), o2, s.join()].join(), u = e5[l];
                  return u || (e5[l] = u = t5([i3, a2, o2, s])), u(r5.shape.slice(0), r5.data, r5.stride, 0 | r5.offset, n4.data, n4.stride, 0 | n4.offset);
                };
              } };
              function a(t5) {
                return e5 = { funcName: t5.funcName }, (0, i2[e5.funcName])(n3.bind(void 0, e5));
                var e5;
              }
              var o = { mul: "*", div: "/" };
              !function() {
                for (var t5 in o)
                  e4[t5] = a({ funcName: t5 }), e4[t5 + "s"] = a({ funcName: t5 + "s" }), e4[t5 + "seq"] = a({ funcName: t5 + "seq" });
              }(), e4.assign = a({ funcName: "assign" });
            }, 7382: function(t4, e4, r4) {
              var n3 = r4(5050), i2 = r4(9262);
              t4.exports = function(t5, e5) {
                for (var r5 = [], a = t5, o = 1; Array.isArray(a); )
                  r5.push(a.length), o *= a.length, a = a[0];
                return 0 === r5.length ? n3() : (e5 || (e5 = n3(new Float64Array(o), r5)), i2(e5, t5), e5);
              };
            }, 9262: function(t4) {
              t4.exports = function(t5) {
                var e4 = {};
                return function(r4, n3) {
                  var i2 = r4.dtype, a = r4.order, o = [i2, a.join()].join(), s = e4[o];
                  return s || (e4[o] = s = t5([i2, a])), s(r4.shape.slice(0), r4.data, r4.stride, 0 | r4.offset, n3);
                };
              }(function() {
                return function(t5, e4, r4, n3, i2) {
                  var a = t5[0], o = t5[1], s = t5[2], l = r4[0], u = r4[1], c = r4[2], f2 = [0, 0, 0];
                  n3 |= 0;
                  var h = 0, p2 = 0, d2 = 0, v = c, g2 = u - s * c, y = l - o * u;
                  for (d2 = 0; d2 < a; ++d2) {
                    for (p2 = 0; p2 < o; ++p2) {
                      for (h = 0; h < s; ++h) {
                        var m2, x = i2;
                        for (m2 = 0; m2 < f2.length - 1; ++m2)
                          x = x[f2[m2]];
                        e4[n3] = x[f2[f2.length - 1]], n3 += v, ++f2[2];
                      }
                      n3 += g2, f2[2] -= s, ++f2[1];
                    }
                    n3 += y, f2[1] -= o, ++f2[0];
                  }
                };
              }.bind(void 0, { funcName: "convert" }));
            }, 8139: function(t4, e4, r4) {
              var n3 = r4(5306);
              function i2(t5) {
                return "uint32" === t5 ? [n3.mallocUint32, n3.freeUint32] : null;
              }
              var a = { "uint32,1,0": function(t5, e5) {
                return function(r5, n4, i3, a2, o2, s2, l, u, c, f2, h) {
                  var p2, d2, v, g2, y, m2, x, b, _ = r5 * o2 + a2, w2 = t5(u);
                  for (p2 = r5 + 1; p2 <= n4; ++p2) {
                    for (d2 = p2, v = _ += o2, y = 0, m2 = _, g2 = 0; g2 < u; ++g2)
                      w2[y++] = i3[m2], m2 += c;
                    t:
                      for (; d2-- > r5; ) {
                        y = 0, m2 = v - o2;
                        e:
                          for (g2 = 0; g2 < u; ++g2) {
                            if ((x = i3[m2]) < (b = w2[y]))
                              break t;
                            if (x > b)
                              break e;
                            m2 += f2, y += h;
                          }
                        for (y = v, m2 = v - o2, g2 = 0; g2 < u; ++g2)
                          i3[y] = i3[m2], y += c, m2 += c;
                        v -= o2;
                      }
                    for (y = v, m2 = 0, g2 = 0; g2 < u; ++g2)
                      i3[y] = w2[m2++], y += c;
                  }
                  e5(w2);
                };
              } }, o = { "uint32,1,0": function(t5, e5, r5) {
                return function n4(i3, a2, o2, s2, l, u, c, f2, h, p2, d2) {
                  var v, g2, y, m2, x, b, _, w2, T, k, A, M, S, E, L, C, P, O, I, D, z, R, F, B, N, j = (a2 - i3 + 1) / 6 | 0, U = i3 + j, V = a2 - j, H = i3 + a2 >> 1, q2 = H - j, G = H + j, Z = U, Y = q2, W = H, X = G, J = V, K = i3 + 1, $ = a2 - 1, Q = true, tt = 0, et = 0, rt = 0, nt = f2, it = e5(nt), at = e5(nt);
                  A = l * Z, M = l * Y, N = s2;
                  t:
                    for (k = 0; k < f2; ++k) {
                      if (w2 = M + N, (rt = o2[_ = A + N] - o2[w2]) > 0) {
                        g2 = Z, Z = Y, Y = g2;
                        break t;
                      }
                      if (rt < 0)
                        break t;
                      N += p2;
                    }
                  A = l * X, M = l * J, N = s2;
                  t:
                    for (k = 0; k < f2; ++k) {
                      if (w2 = M + N, (rt = o2[_ = A + N] - o2[w2]) > 0) {
                        g2 = X, X = J, J = g2;
                        break t;
                      }
                      if (rt < 0)
                        break t;
                      N += p2;
                    }
                  A = l * Z, M = l * W, N = s2;
                  t:
                    for (k = 0; k < f2; ++k) {
                      if (w2 = M + N, (rt = o2[_ = A + N] - o2[w2]) > 0) {
                        g2 = Z, Z = W, W = g2;
                        break t;
                      }
                      if (rt < 0)
                        break t;
                      N += p2;
                    }
                  A = l * Y, M = l * W, N = s2;
                  t:
                    for (k = 0; k < f2; ++k) {
                      if (w2 = M + N, (rt = o2[_ = A + N] - o2[w2]) > 0) {
                        g2 = Y, Y = W, W = g2;
                        break t;
                      }
                      if (rt < 0)
                        break t;
                      N += p2;
                    }
                  A = l * Z, M = l * X, N = s2;
                  t:
                    for (k = 0; k < f2; ++k) {
                      if (w2 = M + N, (rt = o2[_ = A + N] - o2[w2]) > 0) {
                        g2 = Z, Z = X, X = g2;
                        break t;
                      }
                      if (rt < 0)
                        break t;
                      N += p2;
                    }
                  A = l * W, M = l * X, N = s2;
                  t:
                    for (k = 0; k < f2; ++k) {
                      if (w2 = M + N, (rt = o2[_ = A + N] - o2[w2]) > 0) {
                        g2 = W, W = X, X = g2;
                        break t;
                      }
                      if (rt < 0)
                        break t;
                      N += p2;
                    }
                  A = l * Y, M = l * J, N = s2;
                  t:
                    for (k = 0; k < f2; ++k) {
                      if (w2 = M + N, (rt = o2[_ = A + N] - o2[w2]) > 0) {
                        g2 = Y, Y = J, J = g2;
                        break t;
                      }
                      if (rt < 0)
                        break t;
                      N += p2;
                    }
                  A = l * Y, M = l * W, N = s2;
                  t:
                    for (k = 0; k < f2; ++k) {
                      if (w2 = M + N, (rt = o2[_ = A + N] - o2[w2]) > 0) {
                        g2 = Y, Y = W, W = g2;
                        break t;
                      }
                      if (rt < 0)
                        break t;
                      N += p2;
                    }
                  A = l * X, M = l * J, N = s2;
                  t:
                    for (k = 0; k < f2; ++k) {
                      if (w2 = M + N, (rt = o2[_ = A + N] - o2[w2]) > 0) {
                        g2 = X, X = J, J = g2;
                        break t;
                      }
                      if (rt < 0)
                        break t;
                      N += p2;
                    }
                  for (A = l * Z, M = l * Y, S = l * W, E = l * X, L = l * J, C = l * U, P = l * H, O = l * V, B = 0, N = s2, k = 0; k < f2; ++k)
                    _ = A + N, w2 = M + N, T = S + N, I = E + N, D = L + N, z = C + N, R = P + N, F = O + N, it[B] = o2[w2], at[B] = o2[I], Q = Q && it[B] === at[B], y = o2[_], m2 = o2[T], x = o2[D], o2[z] = y, o2[R] = m2, o2[F] = x, ++B, N += h;
                  for (A = l * q2, M = l * i3, N = s2, k = 0; k < f2; ++k)
                    w2 = M + N, o2[_ = A + N] = o2[w2], N += h;
                  for (A = l * G, M = l * a2, N = s2, k = 0; k < f2; ++k)
                    w2 = M + N, o2[_ = A + N] = o2[w2], N += h;
                  if (Q)
                    for (b = K; b <= $; ++b) {
                      for (_ = s2 + b * l, B = 0, k = 0; k < f2 && 0 == (rt = o2[_] - it[B]); ++k)
                        B += d2, _ += p2;
                      if (0 !== rt)
                        if (rt < 0) {
                          if (b !== K)
                            for (A = l * b, M = l * K, N = s2, k = 0; k < f2; ++k)
                              w2 = M + N, v = o2[_ = A + N], o2[_] = o2[w2], o2[w2] = v, N += h;
                          ++K;
                        } else
                          for (; ; ) {
                            for (_ = s2 + $ * l, B = 0, k = 0; k < f2 && 0 == (rt = o2[_] - it[B]); ++k)
                              B += d2, _ += p2;
                            if (!(rt > 0)) {
                              if (rt < 0) {
                                for (A = l * b, M = l * K, S = l * $, N = s2, k = 0; k < f2; ++k)
                                  w2 = M + N, T = S + N, v = o2[_ = A + N], o2[_] = o2[w2], o2[w2] = o2[T], o2[T] = v, N += h;
                                ++K, --$;
                                break;
                              }
                              for (A = l * b, M = l * $, N = s2, k = 0; k < f2; ++k)
                                w2 = M + N, v = o2[_ = A + N], o2[_] = o2[w2], o2[w2] = v, N += h;
                              --$;
                              break;
                            }
                            $--;
                          }
                    }
                  else
                    for (b = K; b <= $; ++b) {
                      for (_ = s2 + b * l, B = 0, k = 0; k < f2 && 0 == (tt = o2[_] - it[B]); ++k)
                        B += d2, _ += p2;
                      if (tt < 0) {
                        if (b !== K)
                          for (A = l * b, M = l * K, N = s2, k = 0; k < f2; ++k)
                            w2 = M + N, v = o2[_ = A + N], o2[_] = o2[w2], o2[w2] = v, N += h;
                        ++K;
                      } else {
                        for (_ = s2 + b * l, B = 0, k = 0; k < f2 && 0 == (et = o2[_] - at[B]); ++k)
                          B += d2, _ += p2;
                        if (et > 0)
                          for (; ; ) {
                            for (_ = s2 + $ * l, B = 0, k = 0; k < f2 && 0 == (rt = o2[_] - at[B]); ++k)
                              B += d2, _ += p2;
                            if (!(rt > 0)) {
                              for (_ = s2 + $ * l, B = 0, k = 0; k < f2 && 0 == (rt = o2[_] - it[B]); ++k)
                                B += d2, _ += p2;
                              if (rt < 0) {
                                for (A = l * b, M = l * K, S = l * $, N = s2, k = 0; k < f2; ++k)
                                  w2 = M + N, T = S + N, v = o2[_ = A + N], o2[_] = o2[w2], o2[w2] = o2[T], o2[T] = v, N += h;
                                ++K, --$;
                              } else {
                                for (A = l * b, M = l * $, N = s2, k = 0; k < f2; ++k)
                                  w2 = M + N, v = o2[_ = A + N], o2[_] = o2[w2], o2[w2] = v, N += h;
                                --$;
                              }
                              break;
                            }
                            if (--$ < b)
                              break;
                          }
                      }
                    }
                  for (A = l * i3, M = l * (K - 1), B = 0, N = s2, k = 0; k < f2; ++k)
                    w2 = M + N, o2[_ = A + N] = o2[w2], o2[w2] = it[B], ++B, N += h;
                  for (A = l * a2, M = l * ($ + 1), B = 0, N = s2, k = 0; k < f2; ++k)
                    w2 = M + N, o2[_ = A + N] = o2[w2], o2[w2] = at[B], ++B, N += h;
                  if (K - 2 - i3 <= 32 ? t5(i3, K - 2, o2, s2, l, u, c, f2, h, p2, d2) : n4(i3, K - 2, o2, s2, l, u, c, f2, h, p2, d2), a2 - ($ + 2) <= 32 ? t5($ + 2, a2, o2, s2, l, u, c, f2, h, p2, d2) : n4($ + 2, a2, o2, s2, l, u, c, f2, h, p2, d2), Q)
                    return r5(it), void r5(at);
                  if (K < U && $ > V) {
                    t:
                      for (; ; ) {
                        for (_ = s2 + K * l, B = 0, N = s2, k = 0; k < f2; ++k) {
                          if (o2[_] !== it[B])
                            break t;
                          ++B, _ += h;
                        }
                        ++K;
                      }
                    t:
                      for (; ; ) {
                        for (_ = s2 + $ * l, B = 0, N = s2, k = 0; k < f2; ++k) {
                          if (o2[_] !== at[B])
                            break t;
                          ++B, _ += h;
                        }
                        --$;
                      }
                    for (b = K; b <= $; ++b) {
                      for (_ = s2 + b * l, B = 0, k = 0; k < f2 && 0 == (tt = o2[_] - it[B]); ++k)
                        B += d2, _ += p2;
                      if (0 === tt) {
                        if (b !== K)
                          for (A = l * b, M = l * K, N = s2, k = 0; k < f2; ++k)
                            w2 = M + N, v = o2[_ = A + N], o2[_] = o2[w2], o2[w2] = v, N += h;
                        ++K;
                      } else {
                        for (_ = s2 + b * l, B = 0, k = 0; k < f2 && 0 == (et = o2[_] - at[B]); ++k)
                          B += d2, _ += p2;
                        if (0 === et)
                          for (; ; ) {
                            for (_ = s2 + $ * l, B = 0, k = 0; k < f2 && 0 == (rt = o2[_] - at[B]); ++k)
                              B += d2, _ += p2;
                            if (0 !== rt) {
                              for (_ = s2 + $ * l, B = 0, k = 0; k < f2 && 0 == (rt = o2[_] - it[B]); ++k)
                                B += d2, _ += p2;
                              if (rt < 0) {
                                for (A = l * b, M = l * K, S = l * $, N = s2, k = 0; k < f2; ++k)
                                  w2 = M + N, T = S + N, v = o2[_ = A + N], o2[_] = o2[w2], o2[w2] = o2[T], o2[T] = v, N += h;
                                ++K, --$;
                              } else {
                                for (A = l * b, M = l * $, N = s2, k = 0; k < f2; ++k)
                                  w2 = M + N, v = o2[_ = A + N], o2[_] = o2[w2], o2[w2] = v, N += h;
                                --$;
                              }
                              break;
                            }
                            if (--$ < b)
                              break;
                          }
                      }
                    }
                  }
                  r5(it), r5(at), $ - K <= 32 ? t5(K, $, o2, s2, l, u, c, f2, h, p2, d2) : n4(K, $, o2, s2, l, u, c, f2, h, p2, d2);
                };
              } }, s = { "uint32,1,0": function(t5, e5) {
                return function(r5) {
                  var n4 = r5.data, i3 = 0 | r5.offset, a2 = r5.shape, o2 = r5.stride, s2 = 0 | o2[0], l = 0 | a2[0], u = 0 | o2[1], c = 0 | a2[1], f2 = u, h = u;
                  l <= 32 ? t5(0, l - 1, n4, i3, s2, u, l, c, f2, h, 1) : e5(0, l - 1, n4, i3, s2, u, l, c, f2, h, 1);
                };
              } };
              t4.exports = function(t5, e5) {
                var r5 = [e5, t5].join(","), n4 = s[r5], l = function(t6, e6) {
                  var r6 = i2(e6), n5 = [e6, t6].join(","), o2 = a[n5];
                  return r6 ? o2(r6[0], r6[1]) : o2();
                }(t5, e5), u = function(t6, e6, r6) {
                  var n5 = i2(e6), a2 = [e6, t6].join(","), s2 = o[a2];
                  return t6.length > 1 && n5 ? s2(r6, n5[0], n5[1]) : s2(r6);
                }(t5, e5, l);
                return n4(l, u);
              };
            }, 8729: function(t4, e4, r4) {
              var n3 = r4(8139), i2 = {};
              t4.exports = function(t5) {
                var e5 = t5.order, r5 = t5.dtype, a = [e5, r5].join(":"), o = i2[a];
                return o || (i2[a] = o = n3(e5, r5)), o(t5), t5;
              };
            }, 5050: function(t4, e4, r4) {
              var n3 = r4(4780), i2 = "undefined" != typeof Float64Array;
              function a(t5, e5) {
                return t5[0] - e5[0];
              }
              function o() {
                var t5, e5 = this.stride, r5 = new Array(e5.length);
                for (t5 = 0; t5 < r5.length; ++t5)
                  r5[t5] = [Math.abs(e5[t5]), t5];
                r5.sort(a);
                var n4 = new Array(r5.length);
                for (t5 = 0; t5 < n4.length; ++t5)
                  n4[t5] = r5[t5][1];
                return n4;
              }
              var s = { T: function(t5) {
                function e5(t6) {
                  this.data = t6;
                }
                var r5 = e5.prototype;
                return r5.dtype = t5, r5.index = function() {
                  return -1;
                }, r5.size = 0, r5.dimension = -1, r5.shape = r5.stride = r5.order = [], r5.lo = r5.hi = r5.transpose = r5.step = function() {
                  return new e5(this.data);
                }, r5.get = r5.set = function() {
                }, r5.pick = function() {
                  return null;
                }, function(t6) {
                  return new e5(t6);
                };
              }, 0: function(t5, e5) {
                function r5(t6, e6) {
                  this.data = t6, this.offset = e6;
                }
                var n4 = r5.prototype;
                return n4.dtype = t5, n4.index = function() {
                  return this.offset;
                }, n4.dimension = 0, n4.size = 1, n4.shape = n4.stride = n4.order = [], n4.lo = n4.hi = n4.transpose = n4.step = function() {
                  return new r5(this.data, this.offset);
                }, n4.pick = function() {
                  return e5(this.data);
                }, n4.valueOf = n4.get = function() {
                  return "generic" === t5 ? this.data.get(this.offset) : this.data[this.offset];
                }, n4.set = function(e6) {
                  return "generic" === t5 ? this.data.set(this.offset, e6) : this.data[this.offset] = e6;
                }, function(t6, e6, n5, i3) {
                  return new r5(t6, i3);
                };
              }, 1: function(t5, e5, r5) {
                function n4(t6, e6, r6, n5) {
                  this.data = t6, this.shape = [e6], this.stride = [r6], this.offset = 0 | n5;
                }
                var i3 = n4.prototype;
                return i3.dtype = t5, i3.dimension = 1, Object.defineProperty(i3, "size", { get: function() {
                  return this.shape[0];
                } }), i3.order = [0], i3.set = function(e6, r6) {
                  return "generic" === t5 ? this.data.set(this.offset + this.stride[0] * e6, r6) : this.data[this.offset + this.stride[0] * e6] = r6;
                }, i3.get = function(e6) {
                  return "generic" === t5 ? this.data.get(this.offset + this.stride[0] * e6) : this.data[this.offset + this.stride[0] * e6];
                }, i3.index = function(t6) {
                  return this.offset + this.stride[0] * t6;
                }, i3.hi = function(t6) {
                  return new n4(this.data, "number" != typeof t6 || t6 < 0 ? this.shape[0] : 0 | t6, this.stride[0], this.offset);
                }, i3.lo = function(t6) {
                  var e6 = this.offset, r6 = 0, i4 = this.shape[0], a2 = this.stride[0];
                  return "number" == typeof t6 && t6 >= 0 && (e6 += a2 * (r6 = 0 | t6), i4 -= r6), new n4(this.data, i4, a2, e6);
                }, i3.step = function(t6) {
                  var e6 = this.shape[0], r6 = this.stride[0], i4 = this.offset, a2 = 0, o2 = Math.ceil;
                  return "number" == typeof t6 && ((a2 = 0 | t6) < 0 ? (i4 += r6 * (e6 - 1), e6 = o2(-e6 / a2)) : e6 = o2(e6 / a2), r6 *= a2), new n4(this.data, e6, r6, i4);
                }, i3.transpose = function(t6) {
                  t6 = void 0 === t6 ? 0 : 0 | t6;
                  var e6 = this.shape, r6 = this.stride;
                  return new n4(this.data, e6[t6], r6[t6], this.offset);
                }, i3.pick = function(t6) {
                  var r6 = [], n5 = [], i4 = this.offset;
                  return "number" == typeof t6 && t6 >= 0 ? i4 = i4 + this.stride[0] * t6 | 0 : (r6.push(this.shape[0]), n5.push(this.stride[0])), (0, e5[r6.length + 1])(this.data, r6, n5, i4);
                }, function(t6, e6, r6, i4) {
                  return new n4(t6, e6[0], r6[0], i4);
                };
              }, 2: function(t5, e5, r5) {
                function n4(t6, e6, r6, n5, i4, a2) {
                  this.data = t6, this.shape = [e6, r6], this.stride = [n5, i4], this.offset = 0 | a2;
                }
                var i3 = n4.prototype;
                return i3.dtype = t5, i3.dimension = 2, Object.defineProperty(i3, "size", { get: function() {
                  return this.shape[0] * this.shape[1];
                } }), Object.defineProperty(i3, "order", { get: function() {
                  return Math.abs(this.stride[0]) > Math.abs(this.stride[1]) ? [1, 0] : [0, 1];
                } }), i3.set = function(e6, r6, n5) {
                  return "generic" === t5 ? this.data.set(this.offset + this.stride[0] * e6 + this.stride[1] * r6, n5) : this.data[this.offset + this.stride[0] * e6 + this.stride[1] * r6] = n5;
                }, i3.get = function(e6, r6) {
                  return "generic" === t5 ? this.data.get(this.offset + this.stride[0] * e6 + this.stride[1] * r6) : this.data[this.offset + this.stride[0] * e6 + this.stride[1] * r6];
                }, i3.index = function(t6, e6) {
                  return this.offset + this.stride[0] * t6 + this.stride[1] * e6;
                }, i3.hi = function(t6, e6) {
                  return new n4(this.data, "number" != typeof t6 || t6 < 0 ? this.shape[0] : 0 | t6, "number" != typeof e6 || e6 < 0 ? this.shape[1] : 0 | e6, this.stride[0], this.stride[1], this.offset);
                }, i3.lo = function(t6, e6) {
                  var r6 = this.offset, i4 = 0, a2 = this.shape[0], o2 = this.shape[1], s2 = this.stride[0], l2 = this.stride[1];
                  return "number" == typeof t6 && t6 >= 0 && (r6 += s2 * (i4 = 0 | t6), a2 -= i4), "number" == typeof e6 && e6 >= 0 && (r6 += l2 * (i4 = 0 | e6), o2 -= i4), new n4(this.data, a2, o2, s2, l2, r6);
                }, i3.step = function(t6, e6) {
                  var r6 = this.shape[0], i4 = this.shape[1], a2 = this.stride[0], o2 = this.stride[1], s2 = this.offset, l2 = 0, u2 = Math.ceil;
                  return "number" == typeof t6 && ((l2 = 0 | t6) < 0 ? (s2 += a2 * (r6 - 1), r6 = u2(-r6 / l2)) : r6 = u2(r6 / l2), a2 *= l2), "number" == typeof e6 && ((l2 = 0 | e6) < 0 ? (s2 += o2 * (i4 - 1), i4 = u2(-i4 / l2)) : i4 = u2(i4 / l2), o2 *= l2), new n4(this.data, r6, i4, a2, o2, s2);
                }, i3.transpose = function(t6, e6) {
                  t6 = void 0 === t6 ? 0 : 0 | t6, e6 = void 0 === e6 ? 1 : 0 | e6;
                  var r6 = this.shape, i4 = this.stride;
                  return new n4(this.data, r6[t6], r6[e6], i4[t6], i4[e6], this.offset);
                }, i3.pick = function(t6, r6) {
                  var n5 = [], i4 = [], a2 = this.offset;
                  return "number" == typeof t6 && t6 >= 0 ? a2 = a2 + this.stride[0] * t6 | 0 : (n5.push(this.shape[0]), i4.push(this.stride[0])), "number" == typeof r6 && r6 >= 0 ? a2 = a2 + this.stride[1] * r6 | 0 : (n5.push(this.shape[1]), i4.push(this.stride[1])), (0, e5[n5.length + 1])(this.data, n5, i4, a2);
                }, function(t6, e6, r6, i4) {
                  return new n4(t6, e6[0], e6[1], r6[0], r6[1], i4);
                };
              }, 3: function(t5, e5, r5) {
                function n4(t6, e6, r6, n5, i4, a2, o2, s2) {
                  this.data = t6, this.shape = [e6, r6, n5], this.stride = [i4, a2, o2], this.offset = 0 | s2;
                }
                var i3 = n4.prototype;
                return i3.dtype = t5, i3.dimension = 3, Object.defineProperty(i3, "size", { get: function() {
                  return this.shape[0] * this.shape[1] * this.shape[2];
                } }), Object.defineProperty(i3, "order", { get: function() {
                  var t6 = Math.abs(this.stride[0]), e6 = Math.abs(this.stride[1]), r6 = Math.abs(this.stride[2]);
                  return t6 > e6 ? e6 > r6 ? [2, 1, 0] : t6 > r6 ? [1, 2, 0] : [1, 0, 2] : t6 > r6 ? [2, 0, 1] : r6 > e6 ? [0, 1, 2] : [0, 2, 1];
                } }), i3.set = function(e6, r6, n5, i4) {
                  return "generic" === t5 ? this.data.set(this.offset + this.stride[0] * e6 + this.stride[1] * r6 + this.stride[2] * n5, i4) : this.data[this.offset + this.stride[0] * e6 + this.stride[1] * r6 + this.stride[2] * n5] = i4;
                }, i3.get = function(e6, r6, n5) {
                  return "generic" === t5 ? this.data.get(this.offset + this.stride[0] * e6 + this.stride[1] * r6 + this.stride[2] * n5) : this.data[this.offset + this.stride[0] * e6 + this.stride[1] * r6 + this.stride[2] * n5];
                }, i3.index = function(t6, e6, r6) {
                  return this.offset + this.stride[0] * t6 + this.stride[1] * e6 + this.stride[2] * r6;
                }, i3.hi = function(t6, e6, r6) {
                  return new n4(this.data, "number" != typeof t6 || t6 < 0 ? this.shape[0] : 0 | t6, "number" != typeof e6 || e6 < 0 ? this.shape[1] : 0 | e6, "number" != typeof r6 || r6 < 0 ? this.shape[2] : 0 | r6, this.stride[0], this.stride[1], this.stride[2], this.offset);
                }, i3.lo = function(t6, e6, r6) {
                  var i4 = this.offset, a2 = 0, o2 = this.shape[0], s2 = this.shape[1], l2 = this.shape[2], u2 = this.stride[0], c = this.stride[1], f2 = this.stride[2];
                  return "number" == typeof t6 && t6 >= 0 && (i4 += u2 * (a2 = 0 | t6), o2 -= a2), "number" == typeof e6 && e6 >= 0 && (i4 += c * (a2 = 0 | e6), s2 -= a2), "number" == typeof r6 && r6 >= 0 && (i4 += f2 * (a2 = 0 | r6), l2 -= a2), new n4(this.data, o2, s2, l2, u2, c, f2, i4);
                }, i3.step = function(t6, e6, r6) {
                  var i4 = this.shape[0], a2 = this.shape[1], o2 = this.shape[2], s2 = this.stride[0], l2 = this.stride[1], u2 = this.stride[2], c = this.offset, f2 = 0, h = Math.ceil;
                  return "number" == typeof t6 && ((f2 = 0 | t6) < 0 ? (c += s2 * (i4 - 1), i4 = h(-i4 / f2)) : i4 = h(i4 / f2), s2 *= f2), "number" == typeof e6 && ((f2 = 0 | e6) < 0 ? (c += l2 * (a2 - 1), a2 = h(-a2 / f2)) : a2 = h(a2 / f2), l2 *= f2), "number" == typeof r6 && ((f2 = 0 | r6) < 0 ? (c += u2 * (o2 - 1), o2 = h(-o2 / f2)) : o2 = h(o2 / f2), u2 *= f2), new n4(this.data, i4, a2, o2, s2, l2, u2, c);
                }, i3.transpose = function(t6, e6, r6) {
                  t6 = void 0 === t6 ? 0 : 0 | t6, e6 = void 0 === e6 ? 1 : 0 | e6, r6 = void 0 === r6 ? 2 : 0 | r6;
                  var i4 = this.shape, a2 = this.stride;
                  return new n4(this.data, i4[t6], i4[e6], i4[r6], a2[t6], a2[e6], a2[r6], this.offset);
                }, i3.pick = function(t6, r6, n5) {
                  var i4 = [], a2 = [], o2 = this.offset;
                  return "number" == typeof t6 && t6 >= 0 ? o2 = o2 + this.stride[0] * t6 | 0 : (i4.push(this.shape[0]), a2.push(this.stride[0])), "number" == typeof r6 && r6 >= 0 ? o2 = o2 + this.stride[1] * r6 | 0 : (i4.push(this.shape[1]), a2.push(this.stride[1])), "number" == typeof n5 && n5 >= 0 ? o2 = o2 + this.stride[2] * n5 | 0 : (i4.push(this.shape[2]), a2.push(this.stride[2])), (0, e5[i4.length + 1])(this.data, i4, a2, o2);
                }, function(t6, e6, r6, i4) {
                  return new n4(t6, e6[0], e6[1], e6[2], r6[0], r6[1], r6[2], i4);
                };
              }, 4: function(t5, e5, r5) {
                function n4(t6, e6, r6, n5, i4, a2, o2, s2, l2, u2) {
                  this.data = t6, this.shape = [e6, r6, n5, i4], this.stride = [a2, o2, s2, l2], this.offset = 0 | u2;
                }
                var i3 = n4.prototype;
                return i3.dtype = t5, i3.dimension = 4, Object.defineProperty(i3, "size", { get: function() {
                  return this.shape[0] * this.shape[1] * this.shape[2] * this.shape[3];
                } }), Object.defineProperty(i3, "order", { get: r5 }), i3.set = function(e6, r6, n5, i4, a2) {
                  return "generic" === t5 ? this.data.set(this.offset + this.stride[0] * e6 + this.stride[1] * r6 + this.stride[2] * n5 + this.stride[3] * i4, a2) : this.data[this.offset + this.stride[0] * e6 + this.stride[1] * r6 + this.stride[2] * n5 + this.stride[3] * i4] = a2;
                }, i3.get = function(e6, r6, n5, i4) {
                  return "generic" === t5 ? this.data.get(this.offset + this.stride[0] * e6 + this.stride[1] * r6 + this.stride[2] * n5 + this.stride[3] * i4) : this.data[this.offset + this.stride[0] * e6 + this.stride[1] * r6 + this.stride[2] * n5 + this.stride[3] * i4];
                }, i3.index = function(t6, e6, r6, n5) {
                  return this.offset + this.stride[0] * t6 + this.stride[1] * e6 + this.stride[2] * r6 + this.stride[3] * n5;
                }, i3.hi = function(t6, e6, r6, i4) {
                  return new n4(this.data, "number" != typeof t6 || t6 < 0 ? this.shape[0] : 0 | t6, "number" != typeof e6 || e6 < 0 ? this.shape[1] : 0 | e6, "number" != typeof r6 || r6 < 0 ? this.shape[2] : 0 | r6, "number" != typeof i4 || i4 < 0 ? this.shape[3] : 0 | i4, this.stride[0], this.stride[1], this.stride[2], this.stride[3], this.offset);
                }, i3.lo = function(t6, e6, r6, i4) {
                  var a2 = this.offset, o2 = 0, s2 = this.shape[0], l2 = this.shape[1], u2 = this.shape[2], c = this.shape[3], f2 = this.stride[0], h = this.stride[1], p2 = this.stride[2], d2 = this.stride[3];
                  return "number" == typeof t6 && t6 >= 0 && (a2 += f2 * (o2 = 0 | t6), s2 -= o2), "number" == typeof e6 && e6 >= 0 && (a2 += h * (o2 = 0 | e6), l2 -= o2), "number" == typeof r6 && r6 >= 0 && (a2 += p2 * (o2 = 0 | r6), u2 -= o2), "number" == typeof i4 && i4 >= 0 && (a2 += d2 * (o2 = 0 | i4), c -= o2), new n4(this.data, s2, l2, u2, c, f2, h, p2, d2, a2);
                }, i3.step = function(t6, e6, r6, i4) {
                  var a2 = this.shape[0], o2 = this.shape[1], s2 = this.shape[2], l2 = this.shape[3], u2 = this.stride[0], c = this.stride[1], f2 = this.stride[2], h = this.stride[3], p2 = this.offset, d2 = 0, v = Math.ceil;
                  return "number" == typeof t6 && ((d2 = 0 | t6) < 0 ? (p2 += u2 * (a2 - 1), a2 = v(-a2 / d2)) : a2 = v(a2 / d2), u2 *= d2), "number" == typeof e6 && ((d2 = 0 | e6) < 0 ? (p2 += c * (o2 - 1), o2 = v(-o2 / d2)) : o2 = v(o2 / d2), c *= d2), "number" == typeof r6 && ((d2 = 0 | r6) < 0 ? (p2 += f2 * (s2 - 1), s2 = v(-s2 / d2)) : s2 = v(s2 / d2), f2 *= d2), "number" == typeof i4 && ((d2 = 0 | i4) < 0 ? (p2 += h * (l2 - 1), l2 = v(-l2 / d2)) : l2 = v(l2 / d2), h *= d2), new n4(this.data, a2, o2, s2, l2, u2, c, f2, h, p2);
                }, i3.transpose = function(t6, e6, r6, i4) {
                  t6 = void 0 === t6 ? 0 : 0 | t6, e6 = void 0 === e6 ? 1 : 0 | e6, r6 = void 0 === r6 ? 2 : 0 | r6, i4 = void 0 === i4 ? 3 : 0 | i4;
                  var a2 = this.shape, o2 = this.stride;
                  return new n4(this.data, a2[t6], a2[e6], a2[r6], a2[i4], o2[t6], o2[e6], o2[r6], o2[i4], this.offset);
                }, i3.pick = function(t6, r6, n5, i4) {
                  var a2 = [], o2 = [], s2 = this.offset;
                  return "number" == typeof t6 && t6 >= 0 ? s2 = s2 + this.stride[0] * t6 | 0 : (a2.push(this.shape[0]), o2.push(this.stride[0])), "number" == typeof r6 && r6 >= 0 ? s2 = s2 + this.stride[1] * r6 | 0 : (a2.push(this.shape[1]), o2.push(this.stride[1])), "number" == typeof n5 && n5 >= 0 ? s2 = s2 + this.stride[2] * n5 | 0 : (a2.push(this.shape[2]), o2.push(this.stride[2])), "number" == typeof i4 && i4 >= 0 ? s2 = s2 + this.stride[3] * i4 | 0 : (a2.push(this.shape[3]), o2.push(this.stride[3])), (0, e5[a2.length + 1])(this.data, a2, o2, s2);
                }, function(t6, e6, r6, i4) {
                  return new n4(t6, e6[0], e6[1], e6[2], e6[3], r6[0], r6[1], r6[2], r6[3], i4);
                };
              }, 5: function(t5, e5, r5) {
                function n4(t6, e6, r6, n5, i4, a2, o2, s2, l2, u2, c, f2) {
                  this.data = t6, this.shape = [e6, r6, n5, i4, a2], this.stride = [o2, s2, l2, u2, c], this.offset = 0 | f2;
                }
                var i3 = n4.prototype;
                return i3.dtype = t5, i3.dimension = 5, Object.defineProperty(i3, "size", { get: function() {
                  return this.shape[0] * this.shape[1] * this.shape[2] * this.shape[3] * this.shape[4];
                } }), Object.defineProperty(i3, "order", { get: r5 }), i3.set = function(e6, r6, n5, i4, a2, o2) {
                  return "generic" === t5 ? this.data.set(this.offset + this.stride[0] * e6 + this.stride[1] * r6 + this.stride[2] * n5 + this.stride[3] * i4 + this.stride[4] * a2, o2) : this.data[this.offset + this.stride[0] * e6 + this.stride[1] * r6 + this.stride[2] * n5 + this.stride[3] * i4 + this.stride[4] * a2] = o2;
                }, i3.get = function(e6, r6, n5, i4, a2) {
                  return "generic" === t5 ? this.data.get(this.offset + this.stride[0] * e6 + this.stride[1] * r6 + this.stride[2] * n5 + this.stride[3] * i4 + this.stride[4] * a2) : this.data[this.offset + this.stride[0] * e6 + this.stride[1] * r6 + this.stride[2] * n5 + this.stride[3] * i4 + this.stride[4] * a2];
                }, i3.index = function(t6, e6, r6, n5, i4) {
                  return this.offset + this.stride[0] * t6 + this.stride[1] * e6 + this.stride[2] * r6 + this.stride[3] * n5 + this.stride[4] * i4;
                }, i3.hi = function(t6, e6, r6, i4, a2) {
                  return new n4(this.data, "number" != typeof t6 || t6 < 0 ? this.shape[0] : 0 | t6, "number" != typeof e6 || e6 < 0 ? this.shape[1] : 0 | e6, "number" != typeof r6 || r6 < 0 ? this.shape[2] : 0 | r6, "number" != typeof i4 || i4 < 0 ? this.shape[3] : 0 | i4, "number" != typeof a2 || a2 < 0 ? this.shape[4] : 0 | a2, this.stride[0], this.stride[1], this.stride[2], this.stride[3], this.stride[4], this.offset);
                }, i3.lo = function(t6, e6, r6, i4, a2) {
                  var o2 = this.offset, s2 = 0, l2 = this.shape[0], u2 = this.shape[1], c = this.shape[2], f2 = this.shape[3], h = this.shape[4], p2 = this.stride[0], d2 = this.stride[1], v = this.stride[2], g2 = this.stride[3], y = this.stride[4];
                  return "number" == typeof t6 && t6 >= 0 && (o2 += p2 * (s2 = 0 | t6), l2 -= s2), "number" == typeof e6 && e6 >= 0 && (o2 += d2 * (s2 = 0 | e6), u2 -= s2), "number" == typeof r6 && r6 >= 0 && (o2 += v * (s2 = 0 | r6), c -= s2), "number" == typeof i4 && i4 >= 0 && (o2 += g2 * (s2 = 0 | i4), f2 -= s2), "number" == typeof a2 && a2 >= 0 && (o2 += y * (s2 = 0 | a2), h -= s2), new n4(this.data, l2, u2, c, f2, h, p2, d2, v, g2, y, o2);
                }, i3.step = function(t6, e6, r6, i4, a2) {
                  var o2 = this.shape[0], s2 = this.shape[1], l2 = this.shape[2], u2 = this.shape[3], c = this.shape[4], f2 = this.stride[0], h = this.stride[1], p2 = this.stride[2], d2 = this.stride[3], v = this.stride[4], g2 = this.offset, y = 0, m2 = Math.ceil;
                  return "number" == typeof t6 && ((y = 0 | t6) < 0 ? (g2 += f2 * (o2 - 1), o2 = m2(-o2 / y)) : o2 = m2(o2 / y), f2 *= y), "number" == typeof e6 && ((y = 0 | e6) < 0 ? (g2 += h * (s2 - 1), s2 = m2(-s2 / y)) : s2 = m2(s2 / y), h *= y), "number" == typeof r6 && ((y = 0 | r6) < 0 ? (g2 += p2 * (l2 - 1), l2 = m2(-l2 / y)) : l2 = m2(l2 / y), p2 *= y), "number" == typeof i4 && ((y = 0 | i4) < 0 ? (g2 += d2 * (u2 - 1), u2 = m2(-u2 / y)) : u2 = m2(u2 / y), d2 *= y), "number" == typeof a2 && ((y = 0 | a2) < 0 ? (g2 += v * (c - 1), c = m2(-c / y)) : c = m2(c / y), v *= y), new n4(this.data, o2, s2, l2, u2, c, f2, h, p2, d2, v, g2);
                }, i3.transpose = function(t6, e6, r6, i4, a2) {
                  t6 = void 0 === t6 ? 0 : 0 | t6, e6 = void 0 === e6 ? 1 : 0 | e6, r6 = void 0 === r6 ? 2 : 0 | r6, i4 = void 0 === i4 ? 3 : 0 | i4, a2 = void 0 === a2 ? 4 : 0 | a2;
                  var o2 = this.shape, s2 = this.stride;
                  return new n4(this.data, o2[t6], o2[e6], o2[r6], o2[i4], o2[a2], s2[t6], s2[e6], s2[r6], s2[i4], s2[a2], this.offset);
                }, i3.pick = function(t6, r6, n5, i4, a2) {
                  var o2 = [], s2 = [], l2 = this.offset;
                  return "number" == typeof t6 && t6 >= 0 ? l2 = l2 + this.stride[0] * t6 | 0 : (o2.push(this.shape[0]), s2.push(this.stride[0])), "number" == typeof r6 && r6 >= 0 ? l2 = l2 + this.stride[1] * r6 | 0 : (o2.push(this.shape[1]), s2.push(this.stride[1])), "number" == typeof n5 && n5 >= 0 ? l2 = l2 + this.stride[2] * n5 | 0 : (o2.push(this.shape[2]), s2.push(this.stride[2])), "number" == typeof i4 && i4 >= 0 ? l2 = l2 + this.stride[3] * i4 | 0 : (o2.push(this.shape[3]), s2.push(this.stride[3])), "number" == typeof a2 && a2 >= 0 ? l2 = l2 + this.stride[4] * a2 | 0 : (o2.push(this.shape[4]), s2.push(this.stride[4])), (0, e5[o2.length + 1])(this.data, o2, s2, l2);
                }, function(t6, e6, r6, i4) {
                  return new n4(t6, e6[0], e6[1], e6[2], e6[3], e6[4], r6[0], r6[1], r6[2], r6[3], r6[4], i4);
                };
              } };
              function l(t5, e5) {
                var r5 = -1 === e5 ? "T" : String(e5), n4 = s[r5];
                return -1 === e5 ? n4(t5) : 0 === e5 ? n4(t5, u[t5][0]) : n4(t5, u[t5], o);
              }
              var u = { generic: [], buffer: [], array: [], float32: [], float64: [], int8: [], int16: [], int32: [], uint8_clamped: [], uint8: [], uint16: [], uint32: [], bigint64: [], biguint64: [] };
              t4.exports = function(t5, e5, r5, a2) {
                if (void 0 === t5)
                  return (0, u.array[0])([]);
                "number" == typeof t5 && (t5 = [t5]), void 0 === e5 && (e5 = [t5.length]);
                var o2 = e5.length;
                if (void 0 === r5) {
                  r5 = new Array(o2);
                  for (var s2 = o2 - 1, c = 1; s2 >= 0; --s2)
                    r5[s2] = c, c *= e5[s2];
                }
                if (void 0 === a2)
                  for (a2 = 0, s2 = 0; s2 < o2; ++s2)
                    r5[s2] < 0 && (a2 -= (e5[s2] - 1) * r5[s2]);
                for (var f2 = function(t6) {
                  if (n3(t6))
                    return "buffer";
                  if (i2)
                    switch (Object.prototype.toString.call(t6)) {
                      case "[object Float64Array]":
                        return "float64";
                      case "[object Float32Array]":
                        return "float32";
                      case "[object Int8Array]":
                        return "int8";
                      case "[object Int16Array]":
                        return "int16";
                      case "[object Int32Array]":
                        return "int32";
                      case "[object Uint8ClampedArray]":
                        return "uint8_clamped";
                      case "[object Uint8Array]":
                        return "uint8";
                      case "[object Uint16Array]":
                        return "uint16";
                      case "[object Uint32Array]":
                        return "uint32";
                      case "[object BigInt64Array]":
                        return "bigint64";
                      case "[object BigUint64Array]":
                        return "biguint64";
                    }
                  return Array.isArray(t6) ? "array" : "generic";
                }(t5), h = u[f2]; h.length <= o2 + 1; )
                  h.push(l(f2, h.length - 1));
                return (0, h[o2 + 1])(t5, e5, r5, a2);
              };
            }, 8551: function(t4, e4, r4) {
              var n3 = r4(8362), i2 = Math.pow(2, -1074), a = -1 >>> 0;
              t4.exports = function(t5, e5) {
                if (isNaN(t5) || isNaN(e5))
                  return NaN;
                if (t5 === e5)
                  return t5;
                if (0 === t5)
                  return e5 < 0 ? -i2 : i2;
                var r5 = n3.hi(t5), o = n3.lo(t5);
                return e5 > t5 == t5 > 0 ? o === a ? (r5 += 1, o = 0) : o += 1 : 0 === o ? (o = a, r5 -= 1) : o -= 1, n3.pack(o, r5);
              };
            }, 115: function(t4, e4) {
              e4.vertexNormals = function(t5, e5, r4) {
                for (var n3 = e5.length, i2 = new Array(n3), a = void 0 === r4 ? 1e-6 : r4, o = 0; o < n3; ++o)
                  i2[o] = [0, 0, 0];
                for (o = 0; o < t5.length; ++o)
                  for (var s = t5[o], l = 0, u = s[s.length - 1], c = s[0], f2 = 0; f2 < s.length; ++f2) {
                    l = u, u = c, c = s[(f2 + 1) % s.length];
                    for (var h = e5[l], p2 = e5[u], d2 = e5[c], v = new Array(3), g2 = 0, y = new Array(3), m2 = 0, x = 0; x < 3; ++x)
                      v[x] = h[x] - p2[x], g2 += v[x] * v[x], y[x] = d2[x] - p2[x], m2 += y[x] * y[x];
                    if (g2 * m2 > a) {
                      var b = i2[u], _ = 1 / Math.sqrt(g2 * m2);
                      for (x = 0; x < 3; ++x) {
                        var w2 = (x + 1) % 3, T = (x + 2) % 3;
                        b[x] += _ * (y[w2] * v[T] - y[T] * v[w2]);
                      }
                    }
                  }
                for (o = 0; o < n3; ++o) {
                  b = i2[o];
                  var k = 0;
                  for (x = 0; x < 3; ++x)
                    k += b[x] * b[x];
                  if (k > a)
                    for (_ = 1 / Math.sqrt(k), x = 0; x < 3; ++x)
                      b[x] *= _;
                  else
                    for (x = 0; x < 3; ++x)
                      b[x] = 0;
                }
                return i2;
              }, e4.faceNormals = function(t5, e5, r4) {
                for (var n3 = t5.length, i2 = new Array(n3), a = void 0 === r4 ? 1e-6 : r4, o = 0; o < n3; ++o) {
                  for (var s = t5[o], l = new Array(3), u = 0; u < 3; ++u)
                    l[u] = e5[s[u]];
                  var c = new Array(3), f2 = new Array(3);
                  for (u = 0; u < 3; ++u)
                    c[u] = l[1][u] - l[0][u], f2[u] = l[2][u] - l[0][u];
                  var h = new Array(3), p2 = 0;
                  for (u = 0; u < 3; ++u) {
                    var d2 = (u + 1) % 3, v = (u + 2) % 3;
                    h[u] = c[d2] * f2[v] - c[v] * f2[d2], p2 += h[u] * h[u];
                  }
                  for (p2 = p2 > a ? 1 / Math.sqrt(p2) : 0, u = 0; u < 3; ++u)
                    h[u] *= p2;
                  i2[o] = h;
                }
                return i2;
              };
            }, 567: function(t4) {
              t4.exports = function(t5, e4, r4, n3, i2, a, o, s, l, u) {
                var c = e4 + a + u;
                if (f2 > 0) {
                  var f2 = Math.sqrt(c + 1);
                  t5[0] = 0.5 * (o - l) / f2, t5[1] = 0.5 * (s - n3) / f2, t5[2] = 0.5 * (r4 - a) / f2, t5[3] = 0.5 * f2;
                } else {
                  var h = Math.max(e4, a, u);
                  f2 = Math.sqrt(2 * h - c + 1), e4 >= h ? (t5[0] = 0.5 * f2, t5[1] = 0.5 * (i2 + r4) / f2, t5[2] = 0.5 * (s + n3) / f2, t5[3] = 0.5 * (o - l) / f2) : a >= h ? (t5[0] = 0.5 * (r4 + i2) / f2, t5[1] = 0.5 * f2, t5[2] = 0.5 * (l + o) / f2, t5[3] = 0.5 * (s - n3) / f2) : (t5[0] = 0.5 * (n3 + s) / f2, t5[1] = 0.5 * (o + l) / f2, t5[2] = 0.5 * f2, t5[3] = 0.5 * (r4 - i2) / f2);
                }
                return t5;
              };
            }, 7774: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = (t5 = t5 || {}).center || [0, 0, 0], r5 = t5.rotation || [0, 0, 0, 1], n4 = t5.radius || 1;
                e5 = [].slice.call(e5, 0, 3), c(r5 = [].slice.call(r5, 0, 4), r5);
                var i3 = new f2(r5, e5, Math.log(n4));
                return i3.setDistanceLimits(t5.zoomMin, t5.zoomMax), ("eye" in t5 || "up" in t5) && i3.lookAt(0, t5.eye, t5.center, t5.up), i3;
              };
              var n3 = r4(8444), i2 = r4(3012), a = r4(5950), o = r4(7437), s = r4(567);
              function l(t5, e5, r5) {
                return Math.sqrt(Math.pow(t5, 2) + Math.pow(e5, 2) + Math.pow(r5, 2));
              }
              function u(t5, e5, r5, n4) {
                return Math.sqrt(Math.pow(t5, 2) + Math.pow(e5, 2) + Math.pow(r5, 2) + Math.pow(n4, 2));
              }
              function c(t5, e5) {
                var r5 = e5[0], n4 = e5[1], i3 = e5[2], a2 = e5[3], o2 = u(r5, n4, i3, a2);
                o2 > 1e-6 ? (t5[0] = r5 / o2, t5[1] = n4 / o2, t5[2] = i3 / o2, t5[3] = a2 / o2) : (t5[0] = t5[1] = t5[2] = 0, t5[3] = 1);
              }
              function f2(t5, e5, r5) {
                this.radius = n3([r5]), this.center = n3(e5), this.rotation = n3(t5), this.computedRadius = this.radius.curve(0), this.computedCenter = this.center.curve(0), this.computedRotation = this.rotation.curve(0), this.computedUp = [0.1, 0, 0], this.computedEye = [0.1, 0, 0], this.computedMatrix = [0.1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], this.recalcMatrix(0);
              }
              var h = f2.prototype;
              h.lastT = function() {
                return Math.max(this.radius.lastT(), this.center.lastT(), this.rotation.lastT());
              }, h.recalcMatrix = function(t5) {
                this.radius.curve(t5), this.center.curve(t5), this.rotation.curve(t5);
                var e5 = this.computedRotation;
                c(e5, e5);
                var r5 = this.computedMatrix;
                a(r5, e5);
                var n4 = this.computedCenter, i3 = this.computedEye, o2 = this.computedUp, s2 = Math.exp(this.computedRadius[0]);
                i3[0] = n4[0] + s2 * r5[2], i3[1] = n4[1] + s2 * r5[6], i3[2] = n4[2] + s2 * r5[10], o2[0] = r5[1], o2[1] = r5[5], o2[2] = r5[9];
                for (var l2 = 0; l2 < 3; ++l2) {
                  for (var u2 = 0, f3 = 0; f3 < 3; ++f3)
                    u2 += r5[l2 + 4 * f3] * i3[f3];
                  r5[12 + l2] = -u2;
                }
              }, h.getMatrix = function(t5, e5) {
                this.recalcMatrix(t5);
                var r5 = this.computedMatrix;
                if (e5) {
                  for (var n4 = 0; n4 < 16; ++n4)
                    e5[n4] = r5[n4];
                  return e5;
                }
                return r5;
              }, h.idle = function(t5) {
                this.center.idle(t5), this.radius.idle(t5), this.rotation.idle(t5);
              }, h.flush = function(t5) {
                this.center.flush(t5), this.radius.flush(t5), this.rotation.flush(t5);
              }, h.pan = function(t5, e5, r5, n4) {
                e5 = e5 || 0, r5 = r5 || 0, n4 = n4 || 0, this.recalcMatrix(t5);
                var i3 = this.computedMatrix, a2 = i3[1], o2 = i3[5], s2 = i3[9], u2 = l(a2, o2, s2);
                a2 /= u2, o2 /= u2, s2 /= u2;
                var c2 = i3[0], f3 = i3[4], h2 = i3[8], p2 = c2 * a2 + f3 * o2 + h2 * s2, d2 = l(c2 -= a2 * p2, f3 -= o2 * p2, h2 -= s2 * p2);
                c2 /= d2, f3 /= d2, h2 /= d2;
                i3[2];
                i3[6];
                i3[10];
                var _ = c2 * e5 + a2 * r5, w2 = f3 * e5 + o2 * r5, T = h2 * e5 + s2 * r5;
                this.center.move(t5, _, w2, T);
                var k = Math.exp(this.computedRadius[0]);
                k = Math.max(1e-4, k + n4), this.radius.set(t5, Math.log(k));
              }, h.rotate = function(t5, e5, r5, n4) {
                this.recalcMatrix(t5), e5 = e5 || 0, r5 = r5 || 0;
                var i3 = this.computedMatrix, a2 = i3[0], o2 = i3[4], s2 = i3[8], c2 = i3[1], f3 = i3[5], h2 = i3[9], p2 = i3[2], d2 = i3[6], v = i3[10], g2 = e5 * a2 + r5 * c2, y = e5 * o2 + r5 * f3, m2 = e5 * s2 + r5 * h2, x = -(d2 * m2 - v * y), b = -(v * g2 - p2 * m2), _ = -(p2 * y - d2 * g2), w2 = Math.sqrt(Math.max(0, 1 - Math.pow(x, 2) - Math.pow(b, 2) - Math.pow(_, 2))), T = u(x, b, _, w2);
                T > 1e-6 ? (x /= T, b /= T, _ /= T, w2 /= T) : (x = b = _ = 0, w2 = 1);
                var k = this.computedRotation, A = k[0], M = k[1], S = k[2], E = k[3], L = A * w2 + E * x + M * _ - S * b, C = M * w2 + E * b + S * x - A * _, P = S * w2 + E * _ + A * b - M * x, O = E * w2 - A * x - M * b - S * _;
                if (n4) {
                  x = p2, b = d2, _ = v;
                  var I = Math.sin(n4) / l(x, b, _);
                  x *= I, b *= I, _ *= I, O = O * (w2 = Math.cos(e5)) - (L = L * w2 + O * x + C * _ - P * b) * x - (C = C * w2 + O * b + P * x - L * _) * b - (P = P * w2 + O * _ + L * b - C * x) * _;
                }
                var D = u(L, C, P, O);
                D > 1e-6 ? (L /= D, C /= D, P /= D, O /= D) : (L = C = P = 0, O = 1), this.rotation.set(t5, L, C, P, O);
              }, h.lookAt = function(t5, e5, r5, n4) {
                this.recalcMatrix(t5), r5 = r5 || this.computedCenter, e5 = e5 || this.computedEye, n4 = n4 || this.computedUp;
                var a2 = this.computedMatrix;
                i2(a2, e5, r5, n4);
                var o2 = this.computedRotation;
                s(o2, a2[0], a2[1], a2[2], a2[4], a2[5], a2[6], a2[8], a2[9], a2[10]), c(o2, o2), this.rotation.set(t5, o2[0], o2[1], o2[2], o2[3]);
                for (var l2 = 0, u2 = 0; u2 < 3; ++u2)
                  l2 += Math.pow(r5[u2] - e5[u2], 2);
                this.radius.set(t5, 0.5 * Math.log(Math.max(l2, 1e-6))), this.center.set(t5, r5[0], r5[1], r5[2]);
              }, h.translate = function(t5, e5, r5, n4) {
                this.center.move(t5, e5 || 0, r5 || 0, n4 || 0);
              }, h.setMatrix = function(t5, e5) {
                var r5 = this.computedRotation;
                s(r5, e5[0], e5[1], e5[2], e5[4], e5[5], e5[6], e5[8], e5[9], e5[10]), c(r5, r5), this.rotation.set(t5, r5[0], r5[1], r5[2], r5[3]);
                var n4 = this.computedMatrix;
                o(n4, e5);
                var i3 = n4[15];
                if (Math.abs(i3) > 1e-6) {
                  var a2 = n4[12] / i3, l2 = n4[13] / i3, u2 = n4[14] / i3;
                  this.recalcMatrix(t5);
                  var f3 = Math.exp(this.computedRadius[0]);
                  this.center.set(t5, a2 - n4[2] * f3, l2 - n4[6] * f3, u2 - n4[10] * f3), this.radius.idle(t5);
                } else
                  this.center.idle(t5), this.radius.idle(t5);
              }, h.setDistance = function(t5, e5) {
                e5 > 0 && this.radius.set(t5, Math.log(e5));
              }, h.setDistanceLimits = function(t5, e5) {
                t5 = t5 > 0 ? Math.log(t5) : -1 / 0, e5 = e5 > 0 ? Math.log(e5) : 1 / 0, e5 = Math.max(e5, t5), this.radius.bounds[0][0] = t5, this.radius.bounds[1][0] = e5;
              }, h.getDistanceLimits = function(t5) {
                var e5 = this.radius.bounds;
                return t5 ? (t5[0] = Math.exp(e5[0][0]), t5[1] = Math.exp(e5[1][0]), t5) : [Math.exp(e5[0][0]), Math.exp(e5[1][0])];
              }, h.toJSON = function() {
                return this.recalcMatrix(this.lastT()), { center: this.computedCenter.slice(), rotation: this.computedRotation.slice(), distance: Math.log(this.computedRadius[0]), zoomMin: this.radius.bounds[0][0], zoomMax: this.radius.bounds[1][0] };
              }, h.fromJSON = function(t5) {
                var e5 = this.lastT(), r5 = t5.center;
                r5 && this.center.set(e5, r5[0], r5[1], r5[2]);
                var n4 = t5.rotation;
                n4 && this.rotation.set(e5, n4[0], n4[1], n4[2], n4[3]);
                var i3 = t5.distance;
                i3 && i3 > 0 && this.radius.set(e5, Math.log(i3)), this.setDistanceLimits(t5.zoomMin, t5.zoomMax);
              };
            }, 4930: function(t4, e4, r4) {
              var n3 = r4(6184);
              t4.exports = function(t5, e5, r5) {
                return n3(r5 = void 0 !== r5 ? r5 + "" : " ", e5) + t5;
              };
            }, 4405: function(t4) {
              t4.exports = function(t5, e4) {
                e4 || (e4 = [0, ""]), t5 = String(t5);
                var r4 = parseFloat(t5, 10);
                return e4[0] = r4, e4[1] = t5.match(/[\d.\-\+]*\s*(.*)/)[1] || "", e4;
              };
            }, 4166: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                for (var r5 = 0 | e5.length, i2 = t5.length, a = [new Array(r5), new Array(r5)], o = 0; o < r5; ++o)
                  a[0][o] = [], a[1][o] = [];
                for (o = 0; o < i2; ++o) {
                  var s = t5[o];
                  a[0][s[0]].push(s), a[1][s[1]].push(s);
                }
                var l = [];
                for (o = 0; o < r5; ++o)
                  a[0][o].length + a[1][o].length === 0 && l.push([o]);
                function u(t6, e6) {
                  var r6 = a[e6][t6[e6]];
                  r6.splice(r6.indexOf(t6), 1);
                }
                function c(t6, r6, i3) {
                  for (var o2, s2, l2, c2 = 0; c2 < 2; ++c2)
                    if (a[c2][r6].length > 0) {
                      o2 = a[c2][r6][0], l2 = c2;
                      break;
                    }
                  s2 = o2[1 ^ l2];
                  for (var f3 = 0; f3 < 2; ++f3)
                    for (var h2 = a[f3][r6], p3 = 0; p3 < h2.length; ++p3) {
                      var d3 = h2[p3], v2 = d3[1 ^ f3];
                      n3(e5[t6], e5[r6], e5[s2], e5[v2]) > 0 && (o2 = d3, s2 = v2, l2 = f3);
                    }
                  return i3 || o2 && u(o2, l2), s2;
                }
                function f2(t6, r6) {
                  var i3 = a[r6][t6][0], o2 = [t6];
                  u(i3, r6);
                  for (var s2 = i3[1 ^ r6]; ; ) {
                    for (; s2 !== t6; )
                      o2.push(s2), s2 = c(o2[o2.length - 2], s2, false);
                    if (a[0][t6].length + a[1][t6].length === 0)
                      break;
                    var l2 = o2[o2.length - 1], f3 = t6, h2 = o2[1], p3 = c(l2, f3, true);
                    if (n3(e5[l2], e5[f3], e5[h2], e5[p3]) < 0)
                      break;
                    o2.push(t6), s2 = c(l2, f3);
                  }
                  return o2;
                }
                function h(t6, e6) {
                  return e6[1] === e6[e6.length - 1];
                }
                for (o = 0; o < r5; ++o)
                  for (var p2 = 0; p2 < 2; ++p2) {
                    for (var d2 = []; a[p2][o].length > 0; ) {
                      a[0][o].length;
                      var v = f2(o, p2);
                      h(0, v) ? d2.push.apply(d2, v) : (d2.length > 0 && l.push(d2), d2 = v);
                    }
                    d2.length > 0 && l.push(d2);
                  }
                return l;
              };
              var n3 = r4(9398);
            }, 3959: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                for (var r5 = n3(t5, e5.length), i2 = new Array(e5.length), a = new Array(e5.length), o = [], s = 0; s < e5.length; ++s) {
                  var l = r5[s].length;
                  a[s] = l, i2[s] = true, l <= 1 && o.push(s);
                }
                for (; o.length > 0; ) {
                  var u = o.pop();
                  i2[u] = false;
                  var c = r5[u];
                  for (s = 0; s < c.length; ++s) {
                    var f2 = c[s];
                    0 == --a[f2] && o.push(f2);
                  }
                }
                var h = new Array(e5.length), p2 = [];
                for (s = 0; s < e5.length; ++s)
                  i2[s] ? (u = p2.length, h[s] = u, p2.push(e5[s])) : h[s] = -1;
                var d2 = [];
                for (s = 0; s < t5.length; ++s) {
                  var v = t5[s];
                  i2[v[0]] && i2[v[1]] && d2.push([h[v[0]], h[v[1]]]);
                }
                return [d2, p2];
              };
              var n3 = r4(8348);
            }, 8040: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                var r5 = u(t5, e5);
                t5 = r5[0];
                for (var f2 = (e5 = r5[1]).length, h = (t5.length, n3(t5, e5.length)), p2 = 0; p2 < f2; ++p2)
                  if (h[p2].length % 2 == 1)
                    throw new Error("planar-graph-to-polyline: graph must be manifold");
                var d2 = i2(t5, e5), v = (d2 = d2.filter(function(t6) {
                  for (var r6 = t6.length, n4 = [0], i3 = 0; i3 < r6; ++i3) {
                    var a2 = e5[t6[i3]], l2 = e5[t6[(i3 + 1) % r6]], u2 = o(-a2[0], a2[1]), c2 = o(-a2[0], l2[1]), f3 = o(l2[0], a2[1]), h2 = o(l2[0], l2[1]);
                    n4 = s(n4, s(s(u2, c2), s(f3, h2)));
                  }
                  return n4[n4.length - 1] > 0;
                })).length, g2 = new Array(v), y = new Array(v);
                for (p2 = 0; p2 < v; ++p2) {
                  g2[p2] = p2;
                  var m2 = new Array(v), x = d2[p2].map(function(t6) {
                    return e5[t6];
                  }), b = a([x]), _ = 0;
                  t:
                    for (var w2 = 0; w2 < v; ++w2)
                      if (m2[w2] = 0, p2 !== w2) {
                        for (var T = (H = d2[w2]).length, k = 0; k < T; ++k) {
                          var A = b(e5[H[k]]);
                          if (0 !== A) {
                            A < 0 && (m2[w2] = 1, _ += 1);
                            continue t;
                          }
                        }
                        m2[w2] = 1, _ += 1;
                      }
                  y[p2] = [_, p2, m2];
                }
                for (y.sort(function(t6, e6) {
                  return e6[0] - t6[0];
                }), p2 = 0; p2 < v; ++p2) {
                  var M = (m2 = y[p2])[1], S = m2[2];
                  for (w2 = 0; w2 < v; ++w2)
                    S[w2] && (g2[w2] = M);
                }
                var E = function(t6) {
                  for (var e6 = new Array(t6), r6 = 0; r6 < t6; ++r6)
                    e6[r6] = [];
                  return e6;
                }(v);
                for (p2 = 0; p2 < v; ++p2)
                  E[p2].push(g2[p2]), E[g2[p2]].push(p2);
                var L = {}, C = c(f2, false);
                for (p2 = 0; p2 < v; ++p2)
                  for (T = (H = d2[p2]).length, w2 = 0; w2 < T; ++w2) {
                    var P = H[w2], O = H[(w2 + 1) % T], I = Math.min(P, O) + ":" + Math.max(P, O);
                    if (I in L) {
                      var D = L[I];
                      E[D].push(p2), E[p2].push(D), C[P] = C[O] = true;
                    } else
                      L[I] = p2;
                  }
                function z(t6) {
                  for (var e6 = t6.length, r6 = 0; r6 < e6; ++r6)
                    if (!C[t6[r6]])
                      return false;
                  return true;
                }
                var R = [], F = c(v, -1);
                for (p2 = 0; p2 < v; ++p2)
                  g2[p2] !== p2 || z(d2[p2]) ? F[p2] = -1 : (R.push(p2), F[p2] = 0);
                for (r5 = []; R.length > 0; ) {
                  var B = R.pop(), N = E[B];
                  l(N, function(t6, e6) {
                    return t6 - e6;
                  });
                  var j, U = N.length, V = F[B];
                  if (0 === V) {
                    var H = d2[B];
                    j = [H];
                  }
                  for (p2 = 0; p2 < U; ++p2) {
                    var q2 = N[p2];
                    F[q2] >= 0 || (F[q2] = 1 ^ V, R.push(q2), 0 === V && (z(H = d2[q2]) || (H.reverse(), j.push(H))));
                  }
                  0 === V && r5.push(j);
                }
                return r5;
              };
              var n3 = r4(8348), i2 = r4(4166), a = r4(211), o = r4(9660), s = r4(9662), l = r4(1215), u = r4(3959);
              function c(t5, e5) {
                for (var r5 = new Array(t5), n4 = 0; n4 < t5; ++n4)
                  r5[n4] = e5;
                return r5;
              }
            }, 211: function(t4, e4, r4) {
              t4.exports = function(t5) {
                for (var e5 = t5.length, r5 = [], a2 = [], s2 = 0; s2 < e5; ++s2)
                  for (var c = t5[s2], f2 = c.length, h = f2 - 1, p2 = 0; p2 < f2; h = p2++) {
                    var d2 = c[h], v = c[p2];
                    d2[0] === v[0] ? a2.push([d2, v]) : r5.push([d2, v]);
                  }
                if (0 === r5.length)
                  return 0 === a2.length ? u : (g2 = l(a2), function(t6) {
                    return g2(t6[0], t6[1]) ? 0 : 1;
                  });
                var g2, y = i2(r5), m2 = function(t6, e6) {
                  return function(r6) {
                    var i3 = o.le(e6, r6[0]);
                    if (i3 < 0)
                      return 1;
                    var a3 = t6[i3];
                    if (!a3) {
                      if (!(i3 > 0 && e6[i3] === r6[0]))
                        return 1;
                      a3 = t6[i3 - 1];
                    }
                    for (var s3 = 1; a3; ) {
                      var l2 = a3.key, u2 = n3(r6, l2[0], l2[1]);
                      if (l2[0][0] < l2[1][0])
                        if (u2 < 0)
                          a3 = a3.left;
                        else {
                          if (!(u2 > 0))
                            return 0;
                          s3 = -1, a3 = a3.right;
                        }
                      else if (u2 > 0)
                        a3 = a3.left;
                      else {
                        if (!(u2 < 0))
                          return 0;
                        s3 = 1, a3 = a3.right;
                      }
                    }
                    return s3;
                  };
                }(y.slabs, y.coordinates);
                return 0 === a2.length ? m2 : function(t6, e6) {
                  return function(r6) {
                    return t6(r6[0], r6[1]) ? 0 : e6(r6);
                  };
                }(l(a2), m2);
              };
              var n3 = r4(417)[3], i2 = r4(4385), a = r4(9014), o = r4(5070);
              function s() {
                return true;
              }
              function l(t5) {
                for (var e5 = {}, r5 = 0; r5 < t5.length; ++r5) {
                  var n4 = t5[r5], i3 = n4[0][0], o2 = n4[0][1], l2 = n4[1][1], u2 = [Math.min(o2, l2), Math.max(o2, l2)];
                  i3 in e5 ? e5[i3].push(u2) : e5[i3] = [u2];
                }
                var c = {}, f2 = Object.keys(e5);
                for (r5 = 0; r5 < f2.length; ++r5) {
                  var h = e5[f2[r5]];
                  c[f2[r5]] = a(h);
                }
                return function(t6) {
                  return function(e6, r6) {
                    var n5 = t6[e6];
                    return !!n5 && !!n5.queryPoint(r6, s);
                  };
                }(c);
              }
              function u(t5) {
                return 1;
              }
            }, 7309: function(t4) {
              var e4 = new Float64Array(4), r4 = new Float64Array(4), n3 = new Float64Array(4);
              t4.exports = function(t5, i2, a, o, s) {
                e4.length < o.length && (e4 = new Float64Array(o.length), r4 = new Float64Array(o.length), n3 = new Float64Array(o.length));
                for (var l = 0; l < o.length; ++l)
                  e4[l] = t5[l] - o[l], r4[l] = i2[l] - t5[l], n3[l] = a[l] - t5[l];
                var u = 0, c = 0, f2 = 0, h = 0, p2 = 0, d2 = 0;
                for (l = 0; l < o.length; ++l) {
                  var v = r4[l], g2 = n3[l], y = e4[l];
                  u += v * v, c += v * g2, f2 += g2 * g2, h += y * v, p2 += y * g2, d2 += y * y;
                }
                var m2, x, b, _, w2, T = Math.abs(u * f2 - c * c), k = c * p2 - f2 * h, A = c * h - u * p2;
                if (k + A <= T)
                  if (k < 0)
                    A < 0 && h < 0 ? (A = 0, -h >= u ? (k = 1, m2 = u + 2 * h + d2) : m2 = h * (k = -h / u) + d2) : (k = 0, p2 >= 0 ? (A = 0, m2 = d2) : -p2 >= f2 ? (A = 1, m2 = f2 + 2 * p2 + d2) : m2 = p2 * (A = -p2 / f2) + d2);
                  else if (A < 0)
                    A = 0, h >= 0 ? (k = 0, m2 = d2) : -h >= u ? (k = 1, m2 = u + 2 * h + d2) : m2 = h * (k = -h / u) + d2;
                  else {
                    var M = 1 / T;
                    m2 = (k *= M) * (u * k + c * (A *= M) + 2 * h) + A * (c * k + f2 * A + 2 * p2) + d2;
                  }
                else
                  k < 0 ? (b = f2 + p2) > (x = c + h) ? (_ = b - x) >= (w2 = u - 2 * c + f2) ? (k = 1, A = 0, m2 = u + 2 * h + d2) : m2 = (k = _ / w2) * (u * k + c * (A = 1 - k) + 2 * h) + A * (c * k + f2 * A + 2 * p2) + d2 : (k = 0, b <= 0 ? (A = 1, m2 = f2 + 2 * p2 + d2) : p2 >= 0 ? (A = 0, m2 = d2) : m2 = p2 * (A = -p2 / f2) + d2) : A < 0 ? (b = u + h) > (x = c + p2) ? (_ = b - x) >= (w2 = u - 2 * c + f2) ? (A = 1, k = 0, m2 = f2 + 2 * p2 + d2) : m2 = (k = 1 - (A = _ / w2)) * (u * k + c * A + 2 * h) + A * (c * k + f2 * A + 2 * p2) + d2 : (A = 0, b <= 0 ? (k = 1, m2 = u + 2 * h + d2) : h >= 0 ? (k = 0, m2 = d2) : m2 = h * (k = -h / u) + d2) : (_ = f2 + p2 - c - h) <= 0 ? (k = 0, A = 1, m2 = f2 + 2 * p2 + d2) : _ >= (w2 = u - 2 * c + f2) ? (k = 1, A = 0, m2 = u + 2 * h + d2) : m2 = (k = _ / w2) * (u * k + c * (A = 1 - k) + 2 * h) + A * (c * k + f2 * A + 2 * p2) + d2;
                var S = 1 - k - A;
                for (l = 0; l < o.length; ++l)
                  s[l] = S * t5[l] + k * i2[l] + A * a[l];
                return m2 < 0 ? 0 : m2;
              };
            }, 1116: function(t4, e4, r4) {
              t4.exports = r4(6093);
            }, 7584: function(t4, e4, r4) {
              var n3 = r4(1539);
              t4.exports = function(t5, e5) {
                for (var r5 = t5.length, i2 = new Array(r5), a = 0; a < r5; ++a)
                  i2[a] = n3(t5[a], e5[a]);
                return i2;
              };
            }, 2826: function(t4, e4, r4) {
              t4.exports = function(t5) {
                for (var e5 = new Array(t5.length), r5 = 0; r5 < t5.length; ++r5)
                  e5[r5] = n3(t5[r5]);
                return e5;
              };
              var n3 = r4(5125);
            }, 4469: function(t4, e4, r4) {
              var n3 = r4(5125), i2 = r4(3962);
              t4.exports = function(t5, e5) {
                for (var r5 = n3(e5), a = t5.length, o = new Array(a), s = 0; s < a; ++s)
                  o[s] = i2(t5[s], r5);
                return o;
              };
            }, 6695: function(t4, e4, r4) {
              var n3 = r4(4354);
              t4.exports = function(t5, e5) {
                for (var r5 = t5.length, i2 = new Array(r5), a = 0; a < r5; ++a)
                  i2[a] = n3(t5[a], e5[a]);
                return i2;
              };
            }, 7037: function(t4, e4, r4) {
              var n3 = r4(9209), i2 = r4(1284), a = r4(9887);
              t4.exports = function(t5) {
                t5.sort(i2);
                for (var e5 = t5.length, r5 = 0, o = 0; o < e5; ++o) {
                  var s = t5[o], l = a(s);
                  if (0 !== l) {
                    if (r5 > 0) {
                      var u = t5[r5 - 1];
                      if (0 === n3(s, u) && a(u) !== l) {
                        r5 -= 1;
                        continue;
                      }
                    }
                    t5[r5++] = s;
                  }
                }
                return t5.length = r5, t5;
              };
            }, 6184: function(t4) {
              var e4, r4 = "";
              t4.exports = function(t5, n3) {
                if ("string" != typeof t5)
                  throw new TypeError("expected a string");
                if (1 === n3)
                  return t5;
                if (2 === n3)
                  return t5 + t5;
                var i2 = t5.length * n3;
                if (e4 !== t5 || void 0 === e4)
                  e4 = t5, r4 = "";
                else if (r4.length >= i2)
                  return r4.substr(0, i2);
                for (; i2 > r4.length && n3 > 1; )
                  1 & n3 && (r4 += t5), n3 >>= 1, t5 += t5;
                return r4 = (r4 += t5).substr(0, i2);
              };
            }, 8161: function(t4, e4, r4) {
              t4.exports = r4.g.performance && r4.g.performance.now ? function() {
                return performance.now();
              } : Date.now || function() {
                return +new Date();
              };
            }, 402: function(t4) {
              t4.exports = function(t5) {
                for (var e4 = t5.length, r4 = t5[t5.length - 1], n3 = e4, i2 = e4 - 2; i2 >= 0; --i2) {
                  var a = r4, o = t5[i2];
                  (l = o - ((r4 = a + o) - a)) && (t5[--n3] = r4, r4 = l);
                }
                var s = 0;
                for (i2 = n3; i2 < e4; ++i2) {
                  var l;
                  (l = (o = r4) - ((r4 = (a = t5[i2]) + o) - a)) && (t5[s++] = l);
                }
                return t5[s++] = r4, t5.length = s, t5;
              };
            }, 8167: function(t4, e4, r4) {
              var n3 = r4(9660), i2 = r4(9662), a = r4(8289), o = r4(402);
              function s(t5, e5, r5, n4) {
                return function(e6) {
                  return n4(t5(r5(e6[0][0], e6[1][1]), r5(-e6[0][1], e6[1][0])));
                };
              }
              function l(t5, e5, r5, n4) {
                return function(i3) {
                  return n4(t5(e5(t5(r5(i3[1][1], i3[2][2]), r5(-i3[1][2], i3[2][1])), i3[0][0]), t5(e5(t5(r5(i3[1][0], i3[2][2]), r5(-i3[1][2], i3[2][0])), -i3[0][1]), e5(t5(r5(i3[1][0], i3[2][1]), r5(-i3[1][1], i3[2][0])), i3[0][2]))));
                };
              }
              function u(t5, e5, r5, n4) {
                return function(i3) {
                  return n4(t5(t5(e5(t5(e5(t5(r5(i3[2][2], i3[3][3]), r5(-i3[2][3], i3[3][2])), i3[1][1]), t5(e5(t5(r5(i3[2][1], i3[3][3]), r5(-i3[2][3], i3[3][1])), -i3[1][2]), e5(t5(r5(i3[2][1], i3[3][2]), r5(-i3[2][2], i3[3][1])), i3[1][3]))), i3[0][0]), e5(t5(e5(t5(r5(i3[2][2], i3[3][3]), r5(-i3[2][3], i3[3][2])), i3[1][0]), t5(e5(t5(r5(i3[2][0], i3[3][3]), r5(-i3[2][3], i3[3][0])), -i3[1][2]), e5(t5(r5(i3[2][0], i3[3][2]), r5(-i3[2][2], i3[3][0])), i3[1][3]))), -i3[0][1])), t5(e5(t5(e5(t5(r5(i3[2][1], i3[3][3]), r5(-i3[2][3], i3[3][1])), i3[1][0]), t5(e5(t5(r5(i3[2][0], i3[3][3]), r5(-i3[2][3], i3[3][0])), -i3[1][1]), e5(t5(r5(i3[2][0], i3[3][1]), r5(-i3[2][1], i3[3][0])), i3[1][3]))), i3[0][2]), e5(t5(e5(t5(r5(i3[2][1], i3[3][2]), r5(-i3[2][2], i3[3][1])), i3[1][0]), t5(e5(t5(r5(i3[2][0], i3[3][2]), r5(-i3[2][2], i3[3][0])), -i3[1][1]), e5(t5(r5(i3[2][0], i3[3][1]), r5(-i3[2][1], i3[3][0])), i3[1][2]))), -i3[0][3]))));
                };
              }
              function c(t5, e5, r5, n4) {
                return function(i3) {
                  return n4(t5(t5(e5(t5(t5(e5(t5(e5(t5(r5(i3[3][3], i3[4][4]), r5(-i3[3][4], i3[4][3])), i3[2][2]), t5(e5(t5(r5(i3[3][2], i3[4][4]), r5(-i3[3][4], i3[4][2])), -i3[2][3]), e5(t5(r5(i3[3][2], i3[4][3]), r5(-i3[3][3], i3[4][2])), i3[2][4]))), i3[1][1]), e5(t5(e5(t5(r5(i3[3][3], i3[4][4]), r5(-i3[3][4], i3[4][3])), i3[2][1]), t5(e5(t5(r5(i3[3][1], i3[4][4]), r5(-i3[3][4], i3[4][1])), -i3[2][3]), e5(t5(r5(i3[3][1], i3[4][3]), r5(-i3[3][3], i3[4][1])), i3[2][4]))), -i3[1][2])), t5(e5(t5(e5(t5(r5(i3[3][2], i3[4][4]), r5(-i3[3][4], i3[4][2])), i3[2][1]), t5(e5(t5(r5(i3[3][1], i3[4][4]), r5(-i3[3][4], i3[4][1])), -i3[2][2]), e5(t5(r5(i3[3][1], i3[4][2]), r5(-i3[3][2], i3[4][1])), i3[2][4]))), i3[1][3]), e5(t5(e5(t5(r5(i3[3][2], i3[4][3]), r5(-i3[3][3], i3[4][2])), i3[2][1]), t5(e5(t5(r5(i3[3][1], i3[4][3]), r5(-i3[3][3], i3[4][1])), -i3[2][2]), e5(t5(r5(i3[3][1], i3[4][2]), r5(-i3[3][2], i3[4][1])), i3[2][3]))), -i3[1][4]))), i3[0][0]), e5(t5(t5(e5(t5(e5(t5(r5(i3[3][3], i3[4][4]), r5(-i3[3][4], i3[4][3])), i3[2][2]), t5(e5(t5(r5(i3[3][2], i3[4][4]), r5(-i3[3][4], i3[4][2])), -i3[2][3]), e5(t5(r5(i3[3][2], i3[4][3]), r5(-i3[3][3], i3[4][2])), i3[2][4]))), i3[1][0]), e5(t5(e5(t5(r5(i3[3][3], i3[4][4]), r5(-i3[3][4], i3[4][3])), i3[2][0]), t5(e5(t5(r5(i3[3][0], i3[4][4]), r5(-i3[3][4], i3[4][0])), -i3[2][3]), e5(t5(r5(i3[3][0], i3[4][3]), r5(-i3[3][3], i3[4][0])), i3[2][4]))), -i3[1][2])), t5(e5(t5(e5(t5(r5(i3[3][2], i3[4][4]), r5(-i3[3][4], i3[4][2])), i3[2][0]), t5(e5(t5(r5(i3[3][0], i3[4][4]), r5(-i3[3][4], i3[4][0])), -i3[2][2]), e5(t5(r5(i3[3][0], i3[4][2]), r5(-i3[3][2], i3[4][0])), i3[2][4]))), i3[1][3]), e5(t5(e5(t5(r5(i3[3][2], i3[4][3]), r5(-i3[3][3], i3[4][2])), i3[2][0]), t5(e5(t5(r5(i3[3][0], i3[4][3]), r5(-i3[3][3], i3[4][0])), -i3[2][2]), e5(t5(r5(i3[3][0], i3[4][2]), r5(-i3[3][2], i3[4][0])), i3[2][3]))), -i3[1][4]))), -i3[0][1])), t5(e5(t5(t5(e5(t5(e5(t5(r5(i3[3][3], i3[4][4]), r5(-i3[3][4], i3[4][3])), i3[2][1]), t5(e5(t5(r5(i3[3][1], i3[4][4]), r5(-i3[3][4], i3[4][1])), -i3[2][3]), e5(t5(r5(i3[3][1], i3[4][3]), r5(-i3[3][3], i3[4][1])), i3[2][4]))), i3[1][0]), e5(t5(e5(t5(r5(i3[3][3], i3[4][4]), r5(-i3[3][4], i3[4][3])), i3[2][0]), t5(e5(t5(r5(i3[3][0], i3[4][4]), r5(-i3[3][4], i3[4][0])), -i3[2][3]), e5(t5(r5(i3[3][0], i3[4][3]), r5(-i3[3][3], i3[4][0])), i3[2][4]))), -i3[1][1])), t5(e5(t5(e5(t5(r5(i3[3][1], i3[4][4]), r5(-i3[3][4], i3[4][1])), i3[2][0]), t5(e5(t5(r5(i3[3][0], i3[4][4]), r5(-i3[3][4], i3[4][0])), -i3[2][1]), e5(t5(r5(i3[3][0], i3[4][1]), r5(-i3[3][1], i3[4][0])), i3[2][4]))), i3[1][3]), e5(t5(e5(t5(r5(i3[3][1], i3[4][3]), r5(-i3[3][3], i3[4][1])), i3[2][0]), t5(e5(t5(r5(i3[3][0], i3[4][3]), r5(-i3[3][3], i3[4][0])), -i3[2][1]), e5(t5(r5(i3[3][0], i3[4][1]), r5(-i3[3][1], i3[4][0])), i3[2][3]))), -i3[1][4]))), i3[0][2]), t5(e5(t5(t5(e5(t5(e5(t5(r5(i3[3][2], i3[4][4]), r5(-i3[3][4], i3[4][2])), i3[2][1]), t5(e5(t5(r5(i3[3][1], i3[4][4]), r5(-i3[3][4], i3[4][1])), -i3[2][2]), e5(t5(r5(i3[3][1], i3[4][2]), r5(-i3[3][2], i3[4][1])), i3[2][4]))), i3[1][0]), e5(t5(e5(t5(r5(i3[3][2], i3[4][4]), r5(-i3[3][4], i3[4][2])), i3[2][0]), t5(e5(t5(r5(i3[3][0], i3[4][4]), r5(-i3[3][4], i3[4][0])), -i3[2][2]), e5(t5(r5(i3[3][0], i3[4][2]), r5(-i3[3][2], i3[4][0])), i3[2][4]))), -i3[1][1])), t5(e5(t5(e5(t5(r5(i3[3][1], i3[4][4]), r5(-i3[3][4], i3[4][1])), i3[2][0]), t5(e5(t5(r5(i3[3][0], i3[4][4]), r5(-i3[3][4], i3[4][0])), -i3[2][1]), e5(t5(r5(i3[3][0], i3[4][1]), r5(-i3[3][1], i3[4][0])), i3[2][4]))), i3[1][2]), e5(t5(e5(t5(r5(i3[3][1], i3[4][2]), r5(-i3[3][2], i3[4][1])), i3[2][0]), t5(e5(t5(r5(i3[3][0], i3[4][2]), r5(-i3[3][2], i3[4][0])), -i3[2][1]), e5(t5(r5(i3[3][0], i3[4][1]), r5(-i3[3][1], i3[4][0])), i3[2][2]))), -i3[1][4]))), -i3[0][3]), e5(t5(t5(e5(t5(e5(t5(r5(i3[3][2], i3[4][3]), r5(-i3[3][3], i3[4][2])), i3[2][1]), t5(e5(t5(r5(i3[3][1], i3[4][3]), r5(-i3[3][3], i3[4][1])), -i3[2][2]), e5(t5(r5(i3[3][1], i3[4][2]), r5(-i3[3][2], i3[4][1])), i3[2][3]))), i3[1][0]), e5(t5(e5(t5(r5(i3[3][2], i3[4][3]), r5(-i3[3][3], i3[4][2])), i3[2][0]), t5(e5(t5(r5(i3[3][0], i3[4][3]), r5(-i3[3][3], i3[4][0])), -i3[2][2]), e5(t5(r5(i3[3][0], i3[4][2]), r5(-i3[3][2], i3[4][0])), i3[2][3]))), -i3[1][1])), t5(e5(t5(e5(t5(r5(i3[3][1], i3[4][3]), r5(-i3[3][3], i3[4][1])), i3[2][0]), t5(e5(t5(r5(i3[3][0], i3[4][3]), r5(-i3[3][3], i3[4][0])), -i3[2][1]), e5(t5(r5(i3[3][0], i3[4][1]), r5(-i3[3][1], i3[4][0])), i3[2][3]))), i3[1][2]), e5(t5(e5(t5(r5(i3[3][1], i3[4][2]), r5(-i3[3][2], i3[4][1])), i3[2][0]), t5(e5(t5(r5(i3[3][0], i3[4][2]), r5(-i3[3][2], i3[4][0])), -i3[2][1]), e5(t5(r5(i3[3][0], i3[4][1]), r5(-i3[3][1], i3[4][0])), i3[2][2]))), -i3[1][3]))), i3[0][4])))));
                };
              }
              function f2(t5) {
                return (2 === t5 ? s : 3 === t5 ? l : 4 === t5 ? u : 5 === t5 ? c : void 0)(i2, a, n3, o);
              }
              var h = [function() {
                return [0];
              }, function(t5) {
                return [t5[0][0]];
              }];
              function p2(t5, e5, r5, n4, i3, a2, o2, s2) {
                return function(l2) {
                  switch (l2.length) {
                    case 0:
                      return t5(l2);
                    case 1:
                      return e5(l2);
                    case 2:
                      return r5(l2);
                    case 3:
                      return n4(l2);
                    case 4:
                      return i3(l2);
                    case 5:
                      return a2(l2);
                  }
                  var u2 = o2[l2.length];
                  return u2 || (u2 = o2[l2.length] = s2(l2.length)), u2(l2);
                };
              }
              !function() {
                for (; h.length < 6; )
                  h.push(f2(h.length));
                t4.exports = p2.apply(void 0, h.concat([h, f2]));
                for (var e5 = 0; e5 < h.length; ++e5)
                  t4.exports[e5] = h[e5];
              }();
            }, 9130: function(t4, e4, r4) {
              var n3 = r4(9660), i2 = r4(9662);
              t4.exports = function(t5, e5) {
                for (var r5 = n3(t5[0], e5[0]), a = 1; a < t5.length; ++a)
                  r5 = i2(r5, n3(t5[a], e5[a]));
                return r5;
              };
            }, 2227: function(t4, e4, r4) {
              var n3 = r4(9660), i2 = r4(9662), a = r4(4078), o = r4(8289);
              function s(t5) {
                return (3 === t5 ? l : 4 === t5 ? u : 5 === t5 ? c : f2)(i2, a, n3, o);
              }
              function l(t5, e5, r5, n4) {
                return function(i3, a2, o2) {
                  var s2 = r5(i3[0], i3[0]), l2 = n4(s2, a2[0]), u2 = n4(s2, o2[0]), c2 = r5(a2[0], a2[0]), f3 = n4(c2, i3[0]), h2 = n4(c2, o2[0]), p3 = r5(o2[0], o2[0]), d3 = n4(p3, i3[0]), v = n4(p3, a2[0]), g2 = t5(e5(v, h2), e5(f3, l2)), y = e5(d3, u2), m2 = e5(g2, y);
                  return m2[m2.length - 1];
                };
              }
              function u(t5, e5, r5, n4) {
                return function(i3, a2, o2, s2) {
                  var l2 = t5(r5(i3[0], i3[0]), r5(i3[1], i3[1])), u2 = n4(l2, a2[0]), c2 = n4(l2, o2[0]), f3 = n4(l2, s2[0]), h2 = t5(r5(a2[0], a2[0]), r5(a2[1], a2[1])), p3 = n4(h2, i3[0]), d3 = n4(h2, o2[0]), v = n4(h2, s2[0]), g2 = t5(r5(o2[0], o2[0]), r5(o2[1], o2[1])), y = n4(g2, i3[0]), m2 = n4(g2, a2[0]), x = n4(g2, s2[0]), b = t5(r5(s2[0], s2[0]), r5(s2[1], s2[1])), _ = n4(b, i3[0]), w2 = n4(b, a2[0]), T = n4(b, o2[0]), k = t5(t5(n4(e5(T, x), a2[1]), t5(n4(e5(w2, v), -o2[1]), n4(e5(m2, d3), s2[1]))), t5(n4(e5(w2, v), i3[1]), t5(n4(e5(_, f3), -a2[1]), n4(e5(p3, u2), s2[1])))), A = t5(t5(n4(e5(T, x), i3[1]), t5(n4(e5(_, f3), -o2[1]), n4(e5(y, c2), s2[1]))), t5(n4(e5(m2, d3), i3[1]), t5(n4(e5(y, c2), -a2[1]), n4(e5(p3, u2), o2[1])))), M = e5(k, A);
                  return M[M.length - 1];
                };
              }
              function c(t5, e5, r5, n4) {
                return function(i3, a2, o2, s2, l2) {
                  var u2 = t5(r5(i3[0], i3[0]), t5(r5(i3[1], i3[1]), r5(i3[2], i3[2]))), c2 = n4(u2, a2[0]), f3 = n4(u2, o2[0]), h2 = n4(u2, s2[0]), p3 = n4(u2, l2[0]), d3 = t5(r5(a2[0], a2[0]), t5(r5(a2[1], a2[1]), r5(a2[2], a2[2]))), v = n4(d3, i3[0]), g2 = n4(d3, o2[0]), y = n4(d3, s2[0]), m2 = n4(d3, l2[0]), x = t5(r5(o2[0], o2[0]), t5(r5(o2[1], o2[1]), r5(o2[2], o2[2]))), b = n4(x, i3[0]), _ = n4(x, a2[0]), w2 = n4(x, s2[0]), T = n4(x, l2[0]), k = t5(r5(s2[0], s2[0]), t5(r5(s2[1], s2[1]), r5(s2[2], s2[2]))), A = n4(k, i3[0]), M = n4(k, a2[0]), S = n4(k, o2[0]), E = n4(k, l2[0]), L = t5(r5(l2[0], l2[0]), t5(r5(l2[1], l2[1]), r5(l2[2], l2[2]))), C = n4(L, i3[0]), P = n4(L, a2[0]), O = n4(L, o2[0]), I = n4(L, s2[0]), D = t5(t5(t5(n4(t5(n4(e5(I, E), o2[1]), t5(n4(e5(O, T), -s2[1]), n4(e5(S, w2), l2[1]))), a2[2]), t5(n4(t5(n4(e5(I, E), a2[1]), t5(n4(e5(P, m2), -s2[1]), n4(e5(M, y), l2[1]))), -o2[2]), n4(t5(n4(e5(O, T), a2[1]), t5(n4(e5(P, m2), -o2[1]), n4(e5(_, g2), l2[1]))), s2[2]))), t5(n4(t5(n4(e5(S, w2), a2[1]), t5(n4(e5(M, y), -o2[1]), n4(e5(_, g2), s2[1]))), -l2[2]), t5(n4(t5(n4(e5(I, E), a2[1]), t5(n4(e5(P, m2), -s2[1]), n4(e5(M, y), l2[1]))), i3[2]), n4(t5(n4(e5(I, E), i3[1]), t5(n4(e5(C, p3), -s2[1]), n4(e5(A, h2), l2[1]))), -a2[2])))), t5(t5(n4(t5(n4(e5(P, m2), i3[1]), t5(n4(e5(C, p3), -a2[1]), n4(e5(v, c2), l2[1]))), s2[2]), t5(n4(t5(n4(e5(M, y), i3[1]), t5(n4(e5(A, h2), -a2[1]), n4(e5(v, c2), s2[1]))), -l2[2]), n4(t5(n4(e5(S, w2), a2[1]), t5(n4(e5(M, y), -o2[1]), n4(e5(_, g2), s2[1]))), i3[2]))), t5(n4(t5(n4(e5(S, w2), i3[1]), t5(n4(e5(A, h2), -o2[1]), n4(e5(b, f3), s2[1]))), -a2[2]), t5(n4(t5(n4(e5(M, y), i3[1]), t5(n4(e5(A, h2), -a2[1]), n4(e5(v, c2), s2[1]))), o2[2]), n4(t5(n4(e5(_, g2), i3[1]), t5(n4(e5(b, f3), -a2[1]), n4(e5(v, c2), o2[1]))), -s2[2]))))), z = t5(t5(t5(n4(t5(n4(e5(I, E), o2[1]), t5(n4(e5(O, T), -s2[1]), n4(e5(S, w2), l2[1]))), i3[2]), n4(t5(n4(e5(I, E), i3[1]), t5(n4(e5(C, p3), -s2[1]), n4(e5(A, h2), l2[1]))), -o2[2])), t5(n4(t5(n4(e5(O, T), i3[1]), t5(n4(e5(C, p3), -o2[1]), n4(e5(b, f3), l2[1]))), s2[2]), n4(t5(n4(e5(S, w2), i3[1]), t5(n4(e5(A, h2), -o2[1]), n4(e5(b, f3), s2[1]))), -l2[2]))), t5(t5(n4(t5(n4(e5(O, T), a2[1]), t5(n4(e5(P, m2), -o2[1]), n4(e5(_, g2), l2[1]))), i3[2]), n4(t5(n4(e5(O, T), i3[1]), t5(n4(e5(C, p3), -o2[1]), n4(e5(b, f3), l2[1]))), -a2[2])), t5(n4(t5(n4(e5(P, m2), i3[1]), t5(n4(e5(C, p3), -a2[1]), n4(e5(v, c2), l2[1]))), o2[2]), n4(t5(n4(e5(_, g2), i3[1]), t5(n4(e5(b, f3), -a2[1]), n4(e5(v, c2), o2[1]))), -l2[2])))), R = e5(D, z);
                  return R[R.length - 1];
                };
              }
              function f2(t5, e5, r5, n4) {
                return function(i3, a2, o2, s2, l2, u2) {
                  var c2 = t5(t5(r5(i3[0], i3[0]), r5(i3[1], i3[1])), t5(r5(i3[2], i3[2]), r5(i3[3], i3[3]))), f3 = n4(c2, a2[0]), h2 = n4(c2, o2[0]), p3 = n4(c2, s2[0]), d3 = n4(c2, l2[0]), v = n4(c2, u2[0]), g2 = t5(t5(r5(a2[0], a2[0]), r5(a2[1], a2[1])), t5(r5(a2[2], a2[2]), r5(a2[3], a2[3]))), y = n4(g2, i3[0]), m2 = n4(g2, o2[0]), x = n4(g2, s2[0]), b = n4(g2, l2[0]), _ = n4(g2, u2[0]), w2 = t5(t5(r5(o2[0], o2[0]), r5(o2[1], o2[1])), t5(r5(o2[2], o2[2]), r5(o2[3], o2[3]))), T = n4(w2, i3[0]), k = n4(w2, a2[0]), A = n4(w2, s2[0]), M = n4(w2, l2[0]), S = n4(w2, u2[0]), E = t5(t5(r5(s2[0], s2[0]), r5(s2[1], s2[1])), t5(r5(s2[2], s2[2]), r5(s2[3], s2[3]))), L = n4(E, i3[0]), C = n4(E, a2[0]), P = n4(E, o2[0]), O = n4(E, l2[0]), I = n4(E, u2[0]), D = t5(t5(r5(l2[0], l2[0]), r5(l2[1], l2[1])), t5(r5(l2[2], l2[2]), r5(l2[3], l2[3]))), z = n4(D, i3[0]), R = n4(D, a2[0]), F = n4(D, o2[0]), B = n4(D, s2[0]), N = n4(D, u2[0]), j = t5(t5(r5(u2[0], u2[0]), r5(u2[1], u2[1])), t5(r5(u2[2], u2[2]), r5(u2[3], u2[3]))), U = n4(j, i3[0]), V = n4(j, a2[0]), H = n4(j, o2[0]), q2 = n4(j, s2[0]), G = n4(j, l2[0]), Z = t5(t5(t5(n4(t5(t5(n4(t5(n4(e5(G, N), s2[1]), t5(n4(e5(q2, I), -l2[1]), n4(e5(B, O), u2[1]))), o2[2]), n4(t5(n4(e5(G, N), o2[1]), t5(n4(e5(H, S), -l2[1]), n4(e5(F, M), u2[1]))), -s2[2])), t5(n4(t5(n4(e5(q2, I), o2[1]), t5(n4(e5(H, S), -s2[1]), n4(e5(P, A), u2[1]))), l2[2]), n4(t5(n4(e5(B, O), o2[1]), t5(n4(e5(F, M), -s2[1]), n4(e5(P, A), l2[1]))), -u2[2]))), a2[3]), t5(n4(t5(t5(n4(t5(n4(e5(G, N), s2[1]), t5(n4(e5(q2, I), -l2[1]), n4(e5(B, O), u2[1]))), a2[2]), n4(t5(n4(e5(G, N), a2[1]), t5(n4(e5(V, _), -l2[1]), n4(e5(R, b), u2[1]))), -s2[2])), t5(n4(t5(n4(e5(q2, I), a2[1]), t5(n4(e5(V, _), -s2[1]), n4(e5(C, x), u2[1]))), l2[2]), n4(t5(n4(e5(B, O), a2[1]), t5(n4(e5(R, b), -s2[1]), n4(e5(C, x), l2[1]))), -u2[2]))), -o2[3]), n4(t5(t5(n4(t5(n4(e5(G, N), o2[1]), t5(n4(e5(H, S), -l2[1]), n4(e5(F, M), u2[1]))), a2[2]), n4(t5(n4(e5(G, N), a2[1]), t5(n4(e5(V, _), -l2[1]), n4(e5(R, b), u2[1]))), -o2[2])), t5(n4(t5(n4(e5(H, S), a2[1]), t5(n4(e5(V, _), -o2[1]), n4(e5(k, m2), u2[1]))), l2[2]), n4(t5(n4(e5(F, M), a2[1]), t5(n4(e5(R, b), -o2[1]), n4(e5(k, m2), l2[1]))), -u2[2]))), s2[3]))), t5(t5(n4(t5(t5(n4(t5(n4(e5(q2, I), o2[1]), t5(n4(e5(H, S), -s2[1]), n4(e5(P, A), u2[1]))), a2[2]), n4(t5(n4(e5(q2, I), a2[1]), t5(n4(e5(V, _), -s2[1]), n4(e5(C, x), u2[1]))), -o2[2])), t5(n4(t5(n4(e5(H, S), a2[1]), t5(n4(e5(V, _), -o2[1]), n4(e5(k, m2), u2[1]))), s2[2]), n4(t5(n4(e5(P, A), a2[1]), t5(n4(e5(C, x), -o2[1]), n4(e5(k, m2), s2[1]))), -u2[2]))), -l2[3]), n4(t5(t5(n4(t5(n4(e5(B, O), o2[1]), t5(n4(e5(F, M), -s2[1]), n4(e5(P, A), l2[1]))), a2[2]), n4(t5(n4(e5(B, O), a2[1]), t5(n4(e5(R, b), -s2[1]), n4(e5(C, x), l2[1]))), -o2[2])), t5(n4(t5(n4(e5(F, M), a2[1]), t5(n4(e5(R, b), -o2[1]), n4(e5(k, m2), l2[1]))), s2[2]), n4(t5(n4(e5(P, A), a2[1]), t5(n4(e5(C, x), -o2[1]), n4(e5(k, m2), s2[1]))), -l2[2]))), u2[3])), t5(n4(t5(t5(n4(t5(n4(e5(G, N), s2[1]), t5(n4(e5(q2, I), -l2[1]), n4(e5(B, O), u2[1]))), a2[2]), n4(t5(n4(e5(G, N), a2[1]), t5(n4(e5(V, _), -l2[1]), n4(e5(R, b), u2[1]))), -s2[2])), t5(n4(t5(n4(e5(q2, I), a2[1]), t5(n4(e5(V, _), -s2[1]), n4(e5(C, x), u2[1]))), l2[2]), n4(t5(n4(e5(B, O), a2[1]), t5(n4(e5(R, b), -s2[1]), n4(e5(C, x), l2[1]))), -u2[2]))), i3[3]), n4(t5(t5(n4(t5(n4(e5(G, N), s2[1]), t5(n4(e5(q2, I), -l2[1]), n4(e5(B, O), u2[1]))), i3[2]), n4(t5(n4(e5(G, N), i3[1]), t5(n4(e5(U, v), -l2[1]), n4(e5(z, d3), u2[1]))), -s2[2])), t5(n4(t5(n4(e5(q2, I), i3[1]), t5(n4(e5(U, v), -s2[1]), n4(e5(L, p3), u2[1]))), l2[2]), n4(t5(n4(e5(B, O), i3[1]), t5(n4(e5(z, d3), -s2[1]), n4(e5(L, p3), l2[1]))), -u2[2]))), -a2[3])))), t5(t5(t5(n4(t5(t5(n4(t5(n4(e5(G, N), a2[1]), t5(n4(e5(V, _), -l2[1]), n4(e5(R, b), u2[1]))), i3[2]), n4(t5(n4(e5(G, N), i3[1]), t5(n4(e5(U, v), -l2[1]), n4(e5(z, d3), u2[1]))), -a2[2])), t5(n4(t5(n4(e5(V, _), i3[1]), t5(n4(e5(U, v), -a2[1]), n4(e5(y, f3), u2[1]))), l2[2]), n4(t5(n4(e5(R, b), i3[1]), t5(n4(e5(z, d3), -a2[1]), n4(e5(y, f3), l2[1]))), -u2[2]))), s2[3]), n4(t5(t5(n4(t5(n4(e5(q2, I), a2[1]), t5(n4(e5(V, _), -s2[1]), n4(e5(C, x), u2[1]))), i3[2]), n4(t5(n4(e5(q2, I), i3[1]), t5(n4(e5(U, v), -s2[1]), n4(e5(L, p3), u2[1]))), -a2[2])), t5(n4(t5(n4(e5(V, _), i3[1]), t5(n4(e5(U, v), -a2[1]), n4(e5(y, f3), u2[1]))), s2[2]), n4(t5(n4(e5(C, x), i3[1]), t5(n4(e5(L, p3), -a2[1]), n4(e5(y, f3), s2[1]))), -u2[2]))), -l2[3])), t5(n4(t5(t5(n4(t5(n4(e5(B, O), a2[1]), t5(n4(e5(R, b), -s2[1]), n4(e5(C, x), l2[1]))), i3[2]), n4(t5(n4(e5(B, O), i3[1]), t5(n4(e5(z, d3), -s2[1]), n4(e5(L, p3), l2[1]))), -a2[2])), t5(n4(t5(n4(e5(R, b), i3[1]), t5(n4(e5(z, d3), -a2[1]), n4(e5(y, f3), l2[1]))), s2[2]), n4(t5(n4(e5(C, x), i3[1]), t5(n4(e5(L, p3), -a2[1]), n4(e5(y, f3), s2[1]))), -l2[2]))), u2[3]), n4(t5(t5(n4(t5(n4(e5(q2, I), o2[1]), t5(n4(e5(H, S), -s2[1]), n4(e5(P, A), u2[1]))), a2[2]), n4(t5(n4(e5(q2, I), a2[1]), t5(n4(e5(V, _), -s2[1]), n4(e5(C, x), u2[1]))), -o2[2])), t5(n4(t5(n4(e5(H, S), a2[1]), t5(n4(e5(V, _), -o2[1]), n4(e5(k, m2), u2[1]))), s2[2]), n4(t5(n4(e5(P, A), a2[1]), t5(n4(e5(C, x), -o2[1]), n4(e5(k, m2), s2[1]))), -u2[2]))), i3[3]))), t5(t5(n4(t5(t5(n4(t5(n4(e5(q2, I), o2[1]), t5(n4(e5(H, S), -s2[1]), n4(e5(P, A), u2[1]))), i3[2]), n4(t5(n4(e5(q2, I), i3[1]), t5(n4(e5(U, v), -s2[1]), n4(e5(L, p3), u2[1]))), -o2[2])), t5(n4(t5(n4(e5(H, S), i3[1]), t5(n4(e5(U, v), -o2[1]), n4(e5(T, h2), u2[1]))), s2[2]), n4(t5(n4(e5(P, A), i3[1]), t5(n4(e5(L, p3), -o2[1]), n4(e5(T, h2), s2[1]))), -u2[2]))), -a2[3]), n4(t5(t5(n4(t5(n4(e5(q2, I), a2[1]), t5(n4(e5(V, _), -s2[1]), n4(e5(C, x), u2[1]))), i3[2]), n4(t5(n4(e5(q2, I), i3[1]), t5(n4(e5(U, v), -s2[1]), n4(e5(L, p3), u2[1]))), -a2[2])), t5(n4(t5(n4(e5(V, _), i3[1]), t5(n4(e5(U, v), -a2[1]), n4(e5(y, f3), u2[1]))), s2[2]), n4(t5(n4(e5(C, x), i3[1]), t5(n4(e5(L, p3), -a2[1]), n4(e5(y, f3), s2[1]))), -u2[2]))), o2[3])), t5(n4(t5(t5(n4(t5(n4(e5(H, S), a2[1]), t5(n4(e5(V, _), -o2[1]), n4(e5(k, m2), u2[1]))), i3[2]), n4(t5(n4(e5(H, S), i3[1]), t5(n4(e5(U, v), -o2[1]), n4(e5(T, h2), u2[1]))), -a2[2])), t5(n4(t5(n4(e5(V, _), i3[1]), t5(n4(e5(U, v), -a2[1]), n4(e5(y, f3), u2[1]))), o2[2]), n4(t5(n4(e5(k, m2), i3[1]), t5(n4(e5(T, h2), -a2[1]), n4(e5(y, f3), o2[1]))), -u2[2]))), -s2[3]), n4(t5(t5(n4(t5(n4(e5(P, A), a2[1]), t5(n4(e5(C, x), -o2[1]), n4(e5(k, m2), s2[1]))), i3[2]), n4(t5(n4(e5(P, A), i3[1]), t5(n4(e5(L, p3), -o2[1]), n4(e5(T, h2), s2[1]))), -a2[2])), t5(n4(t5(n4(e5(C, x), i3[1]), t5(n4(e5(L, p3), -a2[1]), n4(e5(y, f3), s2[1]))), o2[2]), n4(t5(n4(e5(k, m2), i3[1]), t5(n4(e5(T, h2), -a2[1]), n4(e5(y, f3), o2[1]))), -s2[2]))), u2[3]))))), Y = t5(t5(t5(n4(t5(t5(n4(t5(n4(e5(G, N), s2[1]), t5(n4(e5(q2, I), -l2[1]), n4(e5(B, O), u2[1]))), o2[2]), n4(t5(n4(e5(G, N), o2[1]), t5(n4(e5(H, S), -l2[1]), n4(e5(F, M), u2[1]))), -s2[2])), t5(n4(t5(n4(e5(q2, I), o2[1]), t5(n4(e5(H, S), -s2[1]), n4(e5(P, A), u2[1]))), l2[2]), n4(t5(n4(e5(B, O), o2[1]), t5(n4(e5(F, M), -s2[1]), n4(e5(P, A), l2[1]))), -u2[2]))), i3[3]), t5(n4(t5(t5(n4(t5(n4(e5(G, N), s2[1]), t5(n4(e5(q2, I), -l2[1]), n4(e5(B, O), u2[1]))), i3[2]), n4(t5(n4(e5(G, N), i3[1]), t5(n4(e5(U, v), -l2[1]), n4(e5(z, d3), u2[1]))), -s2[2])), t5(n4(t5(n4(e5(q2, I), i3[1]), t5(n4(e5(U, v), -s2[1]), n4(e5(L, p3), u2[1]))), l2[2]), n4(t5(n4(e5(B, O), i3[1]), t5(n4(e5(z, d3), -s2[1]), n4(e5(L, p3), l2[1]))), -u2[2]))), -o2[3]), n4(t5(t5(n4(t5(n4(e5(G, N), o2[1]), t5(n4(e5(H, S), -l2[1]), n4(e5(F, M), u2[1]))), i3[2]), n4(t5(n4(e5(G, N), i3[1]), t5(n4(e5(U, v), -l2[1]), n4(e5(z, d3), u2[1]))), -o2[2])), t5(n4(t5(n4(e5(H, S), i3[1]), t5(n4(e5(U, v), -o2[1]), n4(e5(T, h2), u2[1]))), l2[2]), n4(t5(n4(e5(F, M), i3[1]), t5(n4(e5(z, d3), -o2[1]), n4(e5(T, h2), l2[1]))), -u2[2]))), s2[3]))), t5(t5(n4(t5(t5(n4(t5(n4(e5(q2, I), o2[1]), t5(n4(e5(H, S), -s2[1]), n4(e5(P, A), u2[1]))), i3[2]), n4(t5(n4(e5(q2, I), i3[1]), t5(n4(e5(U, v), -s2[1]), n4(e5(L, p3), u2[1]))), -o2[2])), t5(n4(t5(n4(e5(H, S), i3[1]), t5(n4(e5(U, v), -o2[1]), n4(e5(T, h2), u2[1]))), s2[2]), n4(t5(n4(e5(P, A), i3[1]), t5(n4(e5(L, p3), -o2[1]), n4(e5(T, h2), s2[1]))), -u2[2]))), -l2[3]), n4(t5(t5(n4(t5(n4(e5(B, O), o2[1]), t5(n4(e5(F, M), -s2[1]), n4(e5(P, A), l2[1]))), i3[2]), n4(t5(n4(e5(B, O), i3[1]), t5(n4(e5(z, d3), -s2[1]), n4(e5(L, p3), l2[1]))), -o2[2])), t5(n4(t5(n4(e5(F, M), i3[1]), t5(n4(e5(z, d3), -o2[1]), n4(e5(T, h2), l2[1]))), s2[2]), n4(t5(n4(e5(P, A), i3[1]), t5(n4(e5(L, p3), -o2[1]), n4(e5(T, h2), s2[1]))), -l2[2]))), u2[3])), t5(n4(t5(t5(n4(t5(n4(e5(G, N), o2[1]), t5(n4(e5(H, S), -l2[1]), n4(e5(F, M), u2[1]))), a2[2]), n4(t5(n4(e5(G, N), a2[1]), t5(n4(e5(V, _), -l2[1]), n4(e5(R, b), u2[1]))), -o2[2])), t5(n4(t5(n4(e5(H, S), a2[1]), t5(n4(e5(V, _), -o2[1]), n4(e5(k, m2), u2[1]))), l2[2]), n4(t5(n4(e5(F, M), a2[1]), t5(n4(e5(R, b), -o2[1]), n4(e5(k, m2), l2[1]))), -u2[2]))), i3[3]), n4(t5(t5(n4(t5(n4(e5(G, N), o2[1]), t5(n4(e5(H, S), -l2[1]), n4(e5(F, M), u2[1]))), i3[2]), n4(t5(n4(e5(G, N), i3[1]), t5(n4(e5(U, v), -l2[1]), n4(e5(z, d3), u2[1]))), -o2[2])), t5(n4(t5(n4(e5(H, S), i3[1]), t5(n4(e5(U, v), -o2[1]), n4(e5(T, h2), u2[1]))), l2[2]), n4(t5(n4(e5(F, M), i3[1]), t5(n4(e5(z, d3), -o2[1]), n4(e5(T, h2), l2[1]))), -u2[2]))), -a2[3])))), t5(t5(t5(n4(t5(t5(n4(t5(n4(e5(G, N), a2[1]), t5(n4(e5(V, _), -l2[1]), n4(e5(R, b), u2[1]))), i3[2]), n4(t5(n4(e5(G, N), i3[1]), t5(n4(e5(U, v), -l2[1]), n4(e5(z, d3), u2[1]))), -a2[2])), t5(n4(t5(n4(e5(V, _), i3[1]), t5(n4(e5(U, v), -a2[1]), n4(e5(y, f3), u2[1]))), l2[2]), n4(t5(n4(e5(R, b), i3[1]), t5(n4(e5(z, d3), -a2[1]), n4(e5(y, f3), l2[1]))), -u2[2]))), o2[3]), n4(t5(t5(n4(t5(n4(e5(H, S), a2[1]), t5(n4(e5(V, _), -o2[1]), n4(e5(k, m2), u2[1]))), i3[2]), n4(t5(n4(e5(H, S), i3[1]), t5(n4(e5(U, v), -o2[1]), n4(e5(T, h2), u2[1]))), -a2[2])), t5(n4(t5(n4(e5(V, _), i3[1]), t5(n4(e5(U, v), -a2[1]), n4(e5(y, f3), u2[1]))), o2[2]), n4(t5(n4(e5(k, m2), i3[1]), t5(n4(e5(T, h2), -a2[1]), n4(e5(y, f3), o2[1]))), -u2[2]))), -l2[3])), t5(n4(t5(t5(n4(t5(n4(e5(F, M), a2[1]), t5(n4(e5(R, b), -o2[1]), n4(e5(k, m2), l2[1]))), i3[2]), n4(t5(n4(e5(F, M), i3[1]), t5(n4(e5(z, d3), -o2[1]), n4(e5(T, h2), l2[1]))), -a2[2])), t5(n4(t5(n4(e5(R, b), i3[1]), t5(n4(e5(z, d3), -a2[1]), n4(e5(y, f3), l2[1]))), o2[2]), n4(t5(n4(e5(k, m2), i3[1]), t5(n4(e5(T, h2), -a2[1]), n4(e5(y, f3), o2[1]))), -l2[2]))), u2[3]), n4(t5(t5(n4(t5(n4(e5(B, O), o2[1]), t5(n4(e5(F, M), -s2[1]), n4(e5(P, A), l2[1]))), a2[2]), n4(t5(n4(e5(B, O), a2[1]), t5(n4(e5(R, b), -s2[1]), n4(e5(C, x), l2[1]))), -o2[2])), t5(n4(t5(n4(e5(F, M), a2[1]), t5(n4(e5(R, b), -o2[1]), n4(e5(k, m2), l2[1]))), s2[2]), n4(t5(n4(e5(P, A), a2[1]), t5(n4(e5(C, x), -o2[1]), n4(e5(k, m2), s2[1]))), -l2[2]))), i3[3]))), t5(t5(n4(t5(t5(n4(t5(n4(e5(B, O), o2[1]), t5(n4(e5(F, M), -s2[1]), n4(e5(P, A), l2[1]))), i3[2]), n4(t5(n4(e5(B, O), i3[1]), t5(n4(e5(z, d3), -s2[1]), n4(e5(L, p3), l2[1]))), -o2[2])), t5(n4(t5(n4(e5(F, M), i3[1]), t5(n4(e5(z, d3), -o2[1]), n4(e5(T, h2), l2[1]))), s2[2]), n4(t5(n4(e5(P, A), i3[1]), t5(n4(e5(L, p3), -o2[1]), n4(e5(T, h2), s2[1]))), -l2[2]))), -a2[3]), n4(t5(t5(n4(t5(n4(e5(B, O), a2[1]), t5(n4(e5(R, b), -s2[1]), n4(e5(C, x), l2[1]))), i3[2]), n4(t5(n4(e5(B, O), i3[1]), t5(n4(e5(z, d3), -s2[1]), n4(e5(L, p3), l2[1]))), -a2[2])), t5(n4(t5(n4(e5(R, b), i3[1]), t5(n4(e5(z, d3), -a2[1]), n4(e5(y, f3), l2[1]))), s2[2]), n4(t5(n4(e5(C, x), i3[1]), t5(n4(e5(L, p3), -a2[1]), n4(e5(y, f3), s2[1]))), -l2[2]))), o2[3])), t5(n4(t5(t5(n4(t5(n4(e5(F, M), a2[1]), t5(n4(e5(R, b), -o2[1]), n4(e5(k, m2), l2[1]))), i3[2]), n4(t5(n4(e5(F, M), i3[1]), t5(n4(e5(z, d3), -o2[1]), n4(e5(T, h2), l2[1]))), -a2[2])), t5(n4(t5(n4(e5(R, b), i3[1]), t5(n4(e5(z, d3), -a2[1]), n4(e5(y, f3), l2[1]))), o2[2]), n4(t5(n4(e5(k, m2), i3[1]), t5(n4(e5(T, h2), -a2[1]), n4(e5(y, f3), o2[1]))), -l2[2]))), -s2[3]), n4(t5(t5(n4(t5(n4(e5(P, A), a2[1]), t5(n4(e5(C, x), -o2[1]), n4(e5(k, m2), s2[1]))), i3[2]), n4(t5(n4(e5(P, A), i3[1]), t5(n4(e5(L, p3), -o2[1]), n4(e5(T, h2), s2[1]))), -a2[2])), t5(n4(t5(n4(e5(C, x), i3[1]), t5(n4(e5(L, p3), -a2[1]), n4(e5(y, f3), s2[1]))), o2[2]), n4(t5(n4(e5(k, m2), i3[1]), t5(n4(e5(T, h2), -a2[1]), n4(e5(y, f3), o2[1]))), -s2[2]))), l2[3]))))), W = e5(Z, Y);
                  return W[W.length - 1];
                };
              }
              var h = [function() {
                return 0;
              }, function() {
                return 0;
              }, function() {
                return 0;
              }];
              function p2(t5) {
                var e5 = h[t5.length];
                return e5 || (e5 = h[t5.length] = s(t5.length)), e5.apply(void 0, t5);
              }
              function d2(t5, e5, r5, n4, i3, a2, o2, s2) {
                return function(e6, r6, l2, u2, c2, f3) {
                  switch (arguments.length) {
                    case 0:
                    case 1:
                      return 0;
                    case 2:
                      return n4(e6, r6);
                    case 3:
                      return i3(e6, r6, l2);
                    case 4:
                      return a2(e6, r6, l2, u2);
                    case 5:
                      return o2(e6, r6, l2, u2, c2);
                    case 6:
                      return s2(e6, r6, l2, u2, c2, f3);
                  }
                  for (var h2 = new Array(arguments.length), p3 = 0; p3 < arguments.length; ++p3)
                    h2[p3] = arguments[p3];
                  return t5(h2);
                };
              }
              !function() {
                for (; h.length <= 6; )
                  h.push(s(h.length));
                t4.exports = d2.apply(void 0, [p2].concat(h));
                for (var e5 = 0; e5 <= 6; ++e5)
                  t4.exports[e5] = h[e5];
              }();
            }, 6606: function(t4, e4, r4) {
              var n3 = r4(8167);
              function i2(t5) {
                return (2 === t5 ? a : 3 === t5 ? o : 4 === t5 ? s : 5 === t5 ? l : u)(t5 < 6 ? n3[t5] : n3);
              }
              function a(t5) {
                return function(e5, r5) {
                  return [t5([[+r5[0], +e5[0][1]], [+r5[1], +e5[1][1]]]), t5([[+e5[0][0], +r5[0]], [+e5[1][0], +r5[1]]]), t5(e5)];
                };
              }
              function o(t5) {
                return function(e5, r5) {
                  return [t5([[+r5[0], +e5[0][1], +e5[0][2]], [+r5[1], +e5[1][1], +e5[1][2]], [+r5[2], +e5[2][1], +e5[2][2]]]), t5([[+e5[0][0], +r5[0], +e5[0][2]], [+e5[1][0], +r5[1], +e5[1][2]], [+e5[2][0], +r5[2], +e5[2][2]]]), t5([[+e5[0][0], +e5[0][1], +r5[0]], [+e5[1][0], +e5[1][1], +r5[1]], [+e5[2][0], +e5[2][1], +r5[2]]]), t5(e5)];
                };
              }
              function s(t5) {
                return function(e5, r5) {
                  return [t5([[+r5[0], +e5[0][1], +e5[0][2], +e5[0][3]], [+r5[1], +e5[1][1], +e5[1][2], +e5[1][3]], [+r5[2], +e5[2][1], +e5[2][2], +e5[2][3]], [+r5[3], +e5[3][1], +e5[3][2], +e5[3][3]]]), t5([[+e5[0][0], +r5[0], +e5[0][2], +e5[0][3]], [+e5[1][0], +r5[1], +e5[1][2], +e5[1][3]], [+e5[2][0], +r5[2], +e5[2][2], +e5[2][3]], [+e5[3][0], +r5[3], +e5[3][2], +e5[3][3]]]), t5([[+e5[0][0], +e5[0][1], +r5[0], +e5[0][3]], [+e5[1][0], +e5[1][1], +r5[1], +e5[1][3]], [+e5[2][0], +e5[2][1], +r5[2], +e5[2][3]], [+e5[3][0], +e5[3][1], +r5[3], +e5[3][3]]]), t5([[+e5[0][0], +e5[0][1], +e5[0][2], +r5[0]], [+e5[1][0], +e5[1][1], +e5[1][2], +r5[1]], [+e5[2][0], +e5[2][1], +e5[2][2], +r5[2]], [+e5[3][0], +e5[3][1], +e5[3][2], +r5[3]]]), t5(e5)];
                };
              }
              function l(t5) {
                return function(e5, r5) {
                  return [t5([[+r5[0], +e5[0][1], +e5[0][2], +e5[0][3], +e5[0][4]], [+r5[1], +e5[1][1], +e5[1][2], +e5[1][3], +e5[1][4]], [+r5[2], +e5[2][1], +e5[2][2], +e5[2][3], +e5[2][4]], [+r5[3], +e5[3][1], +e5[3][2], +e5[3][3], +e5[3][4]], [+r5[4], +e5[4][1], +e5[4][2], +e5[4][3], +e5[4][4]]]), t5([[+e5[0][0], +r5[0], +e5[0][2], +e5[0][3], +e5[0][4]], [+e5[1][0], +r5[1], +e5[1][2], +e5[1][3], +e5[1][4]], [+e5[2][0], +r5[2], +e5[2][2], +e5[2][3], +e5[2][4]], [+e5[3][0], +r5[3], +e5[3][2], +e5[3][3], +e5[3][4]], [+e5[4][0], +r5[4], +e5[4][2], +e5[4][3], +e5[4][4]]]), t5([[+e5[0][0], +e5[0][1], +r5[0], +e5[0][3], +e5[0][4]], [+e5[1][0], +e5[1][1], +r5[1], +e5[1][3], +e5[1][4]], [+e5[2][0], +e5[2][1], +r5[2], +e5[2][3], +e5[2][4]], [+e5[3][0], +e5[3][1], +r5[3], +e5[3][3], +e5[3][4]], [+e5[4][0], +e5[4][1], +r5[4], +e5[4][3], +e5[4][4]]]), t5([[+e5[0][0], +e5[0][1], +e5[0][2], +r5[0], +e5[0][4]], [+e5[1][0], +e5[1][1], +e5[1][2], +r5[1], +e5[1][4]], [+e5[2][0], +e5[2][1], +e5[2][2], +r5[2], +e5[2][4]], [+e5[3][0], +e5[3][1], +e5[3][2], +r5[3], +e5[3][4]], [+e5[4][0], +e5[4][1], +e5[4][2], +r5[4], +e5[4][4]]]), t5([[+e5[0][0], +e5[0][1], +e5[0][2], +e5[0][3], +r5[0]], [+e5[1][0], +e5[1][1], +e5[1][2], +e5[1][3], +r5[1]], [+e5[2][0], +e5[2][1], +e5[2][2], +e5[2][3], +r5[2]], [+e5[3][0], +e5[3][1], +e5[3][2], +e5[3][3], +r5[3]], [+e5[4][0], +e5[4][1], +e5[4][2], +e5[4][3], +r5[4]]]), t5(e5)];
                };
              }
              function u(t5) {
                return function(e5, r5) {
                  return [t5([[+r5[0], +e5[0][1], +e5[0][2], +e5[0][3], +e5[0][4], +e5[0][5]], [+r5[1], +e5[1][1], +e5[1][2], +e5[1][3], +e5[1][4], +e5[1][5]], [+r5[2], +e5[2][1], +e5[2][2], +e5[2][3], +e5[2][4], +e5[2][5]], [+r5[3], +e5[3][1], +e5[3][2], +e5[3][3], +e5[3][4], +e5[3][5]], [+r5[4], +e5[4][1], +e5[4][2], +e5[4][3], +e5[4][4], +e5[4][5]], [+r5[5], +e5[5][1], +e5[5][2], +e5[5][3], +e5[5][4], +e5[5][5]]]), t5([[+e5[0][0], +r5[0], +e5[0][2], +e5[0][3], +e5[0][4], +e5[0][5]], [+e5[1][0], +r5[1], +e5[1][2], +e5[1][3], +e5[1][4], +e5[1][5]], [+e5[2][0], +r5[2], +e5[2][2], +e5[2][3], +e5[2][4], +e5[2][5]], [+e5[3][0], +r5[3], +e5[3][2], +e5[3][3], +e5[3][4], +e5[3][5]], [+e5[4][0], +r5[4], +e5[4][2], +e5[4][3], +e5[4][4], +e5[4][5]], [+e5[5][0], +r5[5], +e5[5][2], +e5[5][3], +e5[5][4], +e5[5][5]]]), t5([[+e5[0][0], +e5[0][1], +r5[0], +e5[0][3], +e5[0][4], +e5[0][5]], [+e5[1][0], +e5[1][1], +r5[1], +e5[1][3], +e5[1][4], +e5[1][5]], [+e5[2][0], +e5[2][1], +r5[2], +e5[2][3], +e5[2][4], +e5[2][5]], [+e5[3][0], +e5[3][1], +r5[3], +e5[3][3], +e5[3][4], +e5[3][5]], [+e5[4][0], +e5[4][1], +r5[4], +e5[4][3], +e5[4][4], +e5[4][5]], [+e5[5][0], +e5[5][1], +r5[5], +e5[5][3], +e5[5][4], +e5[5][5]]]), t5([[+e5[0][0], +e5[0][1], +e5[0][2], +r5[0], +e5[0][4], +e5[0][5]], [+e5[1][0], +e5[1][1], +e5[1][2], +r5[1], +e5[1][4], +e5[1][5]], [+e5[2][0], +e5[2][1], +e5[2][2], +r5[2], +e5[2][4], +e5[2][5]], [+e5[3][0], +e5[3][1], +e5[3][2], +r5[3], +e5[3][4], +e5[3][5]], [+e5[4][0], +e5[4][1], +e5[4][2], +r5[4], +e5[4][4], +e5[4][5]], [+e5[5][0], +e5[5][1], +e5[5][2], +r5[5], +e5[5][4], +e5[5][5]]]), t5([[+e5[0][0], +e5[0][1], +e5[0][2], +e5[0][3], +r5[0], +e5[0][5]], [+e5[1][0], +e5[1][1], +e5[1][2], +e5[1][3], +r5[1], +e5[1][5]], [+e5[2][0], +e5[2][1], +e5[2][2], +e5[2][3], +r5[2], +e5[2][5]], [+e5[3][0], +e5[3][1], +e5[3][2], +e5[3][3], +r5[3], +e5[3][5]], [+e5[4][0], +e5[4][1], +e5[4][2], +e5[4][3], +r5[4], +e5[4][5]], [+e5[5][0], +e5[5][1], +e5[5][2], +e5[5][3], +r5[5], +e5[5][5]]]), t5([[+e5[0][0], +e5[0][1], +e5[0][2], +e5[0][3], +e5[0][4], +r5[0]], [+e5[1][0], +e5[1][1], +e5[1][2], +e5[1][3], +e5[1][4], +r5[1]], [+e5[2][0], +e5[2][1], +e5[2][2], +e5[2][3], +e5[2][4], +r5[2]], [+e5[3][0], +e5[3][1], +e5[3][2], +e5[3][3], +e5[3][4], +r5[3]], [+e5[4][0], +e5[4][1], +e5[4][2], +e5[4][3], +e5[4][4], +r5[4]], [+e5[5][0], +e5[5][1], +e5[5][2], +e5[5][3], +e5[5][4], +r5[5]]]), t5(e5)];
                };
              }
              var c = [function() {
                return [[0]];
              }, function(t5, e5) {
                return [[e5[0]], [t5[0][0]]];
              }];
              function f2(t5, e5, r5, n4, i3, a2, o2, s2) {
                return function(l2, u2) {
                  switch (l2.length) {
                    case 0:
                      return t5(l2, u2);
                    case 1:
                      return e5(l2, u2);
                    case 2:
                      return r5(l2, u2);
                    case 3:
                      return n4(l2, u2);
                    case 4:
                      return i3(l2, u2);
                    case 5:
                      return a2(l2, u2);
                  }
                  var c2 = o2[l2.length];
                  return c2 || (c2 = o2[l2.length] = s2(l2.length)), c2(l2, u2);
                };
              }
              !function() {
                for (; c.length < 6; )
                  c.push(i2(c.length));
                t4.exports = f2.apply(void 0, c.concat([c, i2]));
                for (var e5 = 0; e5 < 6; ++e5)
                  t4.exports[e5] = c[e5];
              }();
            }, 417: function(t4, e4, r4) {
              var n3 = r4(9660), i2 = r4(9662), a = r4(8289), o = r4(4078);
              function s(t5, e5, r5, n4) {
                return function(r6, i3, a2) {
                  var o2 = t5(t5(e5(i3[1], a2[0]), e5(-a2[1], i3[0])), t5(e5(r6[1], i3[0]), e5(-i3[1], r6[0]))), s2 = t5(e5(r6[1], a2[0]), e5(-a2[1], r6[0])), l2 = n4(o2, s2);
                  return l2[l2.length - 1];
                };
              }
              function l(t5, e5, r5, n4) {
                return function(i3, a2, o2, s2) {
                  var l2 = t5(t5(r5(t5(e5(o2[1], s2[0]), e5(-s2[1], o2[0])), a2[2]), t5(r5(t5(e5(a2[1], s2[0]), e5(-s2[1], a2[0])), -o2[2]), r5(t5(e5(a2[1], o2[0]), e5(-o2[1], a2[0])), s2[2]))), t5(r5(t5(e5(a2[1], s2[0]), e5(-s2[1], a2[0])), i3[2]), t5(r5(t5(e5(i3[1], s2[0]), e5(-s2[1], i3[0])), -a2[2]), r5(t5(e5(i3[1], a2[0]), e5(-a2[1], i3[0])), s2[2])))), u2 = t5(t5(r5(t5(e5(o2[1], s2[0]), e5(-s2[1], o2[0])), i3[2]), t5(r5(t5(e5(i3[1], s2[0]), e5(-s2[1], i3[0])), -o2[2]), r5(t5(e5(i3[1], o2[0]), e5(-o2[1], i3[0])), s2[2]))), t5(r5(t5(e5(a2[1], o2[0]), e5(-o2[1], a2[0])), i3[2]), t5(r5(t5(e5(i3[1], o2[0]), e5(-o2[1], i3[0])), -a2[2]), r5(t5(e5(i3[1], a2[0]), e5(-a2[1], i3[0])), o2[2])))), c2 = n4(l2, u2);
                  return c2[c2.length - 1];
                };
              }
              function u(t5, e5, r5, n4) {
                return function(i3, a2, o2, s2, l2) {
                  var u2 = t5(t5(t5(r5(t5(r5(t5(e5(s2[1], l2[0]), e5(-l2[1], s2[0])), o2[2]), t5(r5(t5(e5(o2[1], l2[0]), e5(-l2[1], o2[0])), -s2[2]), r5(t5(e5(o2[1], s2[0]), e5(-s2[1], o2[0])), l2[2]))), a2[3]), t5(r5(t5(r5(t5(e5(s2[1], l2[0]), e5(-l2[1], s2[0])), a2[2]), t5(r5(t5(e5(a2[1], l2[0]), e5(-l2[1], a2[0])), -s2[2]), r5(t5(e5(a2[1], s2[0]), e5(-s2[1], a2[0])), l2[2]))), -o2[3]), r5(t5(r5(t5(e5(o2[1], l2[0]), e5(-l2[1], o2[0])), a2[2]), t5(r5(t5(e5(a2[1], l2[0]), e5(-l2[1], a2[0])), -o2[2]), r5(t5(e5(a2[1], o2[0]), e5(-o2[1], a2[0])), l2[2]))), s2[3]))), t5(r5(t5(r5(t5(e5(o2[1], s2[0]), e5(-s2[1], o2[0])), a2[2]), t5(r5(t5(e5(a2[1], s2[0]), e5(-s2[1], a2[0])), -o2[2]), r5(t5(e5(a2[1], o2[0]), e5(-o2[1], a2[0])), s2[2]))), -l2[3]), t5(r5(t5(r5(t5(e5(s2[1], l2[0]), e5(-l2[1], s2[0])), a2[2]), t5(r5(t5(e5(a2[1], l2[0]), e5(-l2[1], a2[0])), -s2[2]), r5(t5(e5(a2[1], s2[0]), e5(-s2[1], a2[0])), l2[2]))), i3[3]), r5(t5(r5(t5(e5(s2[1], l2[0]), e5(-l2[1], s2[0])), i3[2]), t5(r5(t5(e5(i3[1], l2[0]), e5(-l2[1], i3[0])), -s2[2]), r5(t5(e5(i3[1], s2[0]), e5(-s2[1], i3[0])), l2[2]))), -a2[3])))), t5(t5(r5(t5(r5(t5(e5(a2[1], l2[0]), e5(-l2[1], a2[0])), i3[2]), t5(r5(t5(e5(i3[1], l2[0]), e5(-l2[1], i3[0])), -a2[2]), r5(t5(e5(i3[1], a2[0]), e5(-a2[1], i3[0])), l2[2]))), s2[3]), t5(r5(t5(r5(t5(e5(a2[1], s2[0]), e5(-s2[1], a2[0])), i3[2]), t5(r5(t5(e5(i3[1], s2[0]), e5(-s2[1], i3[0])), -a2[2]), r5(t5(e5(i3[1], a2[0]), e5(-a2[1], i3[0])), s2[2]))), -l2[3]), r5(t5(r5(t5(e5(o2[1], s2[0]), e5(-s2[1], o2[0])), a2[2]), t5(r5(t5(e5(a2[1], s2[0]), e5(-s2[1], a2[0])), -o2[2]), r5(t5(e5(a2[1], o2[0]), e5(-o2[1], a2[0])), s2[2]))), i3[3]))), t5(r5(t5(r5(t5(e5(o2[1], s2[0]), e5(-s2[1], o2[0])), i3[2]), t5(r5(t5(e5(i3[1], s2[0]), e5(-s2[1], i3[0])), -o2[2]), r5(t5(e5(i3[1], o2[0]), e5(-o2[1], i3[0])), s2[2]))), -a2[3]), t5(r5(t5(r5(t5(e5(a2[1], s2[0]), e5(-s2[1], a2[0])), i3[2]), t5(r5(t5(e5(i3[1], s2[0]), e5(-s2[1], i3[0])), -a2[2]), r5(t5(e5(i3[1], a2[0]), e5(-a2[1], i3[0])), s2[2]))), o2[3]), r5(t5(r5(t5(e5(a2[1], o2[0]), e5(-o2[1], a2[0])), i3[2]), t5(r5(t5(e5(i3[1], o2[0]), e5(-o2[1], i3[0])), -a2[2]), r5(t5(e5(i3[1], a2[0]), e5(-a2[1], i3[0])), o2[2]))), -s2[3]))))), c2 = t5(t5(t5(r5(t5(r5(t5(e5(s2[1], l2[0]), e5(-l2[1], s2[0])), o2[2]), t5(r5(t5(e5(o2[1], l2[0]), e5(-l2[1], o2[0])), -s2[2]), r5(t5(e5(o2[1], s2[0]), e5(-s2[1], o2[0])), l2[2]))), i3[3]), r5(t5(r5(t5(e5(s2[1], l2[0]), e5(-l2[1], s2[0])), i3[2]), t5(r5(t5(e5(i3[1], l2[0]), e5(-l2[1], i3[0])), -s2[2]), r5(t5(e5(i3[1], s2[0]), e5(-s2[1], i3[0])), l2[2]))), -o2[3])), t5(r5(t5(r5(t5(e5(o2[1], l2[0]), e5(-l2[1], o2[0])), i3[2]), t5(r5(t5(e5(i3[1], l2[0]), e5(-l2[1], i3[0])), -o2[2]), r5(t5(e5(i3[1], o2[0]), e5(-o2[1], i3[0])), l2[2]))), s2[3]), r5(t5(r5(t5(e5(o2[1], s2[0]), e5(-s2[1], o2[0])), i3[2]), t5(r5(t5(e5(i3[1], s2[0]), e5(-s2[1], i3[0])), -o2[2]), r5(t5(e5(i3[1], o2[0]), e5(-o2[1], i3[0])), s2[2]))), -l2[3]))), t5(t5(r5(t5(r5(t5(e5(o2[1], l2[0]), e5(-l2[1], o2[0])), a2[2]), t5(r5(t5(e5(a2[1], l2[0]), e5(-l2[1], a2[0])), -o2[2]), r5(t5(e5(a2[1], o2[0]), e5(-o2[1], a2[0])), l2[2]))), i3[3]), r5(t5(r5(t5(e5(o2[1], l2[0]), e5(-l2[1], o2[0])), i3[2]), t5(r5(t5(e5(i3[1], l2[0]), e5(-l2[1], i3[0])), -o2[2]), r5(t5(e5(i3[1], o2[0]), e5(-o2[1], i3[0])), l2[2]))), -a2[3])), t5(r5(t5(r5(t5(e5(a2[1], l2[0]), e5(-l2[1], a2[0])), i3[2]), t5(r5(t5(e5(i3[1], l2[0]), e5(-l2[1], i3[0])), -a2[2]), r5(t5(e5(i3[1], a2[0]), e5(-a2[1], i3[0])), l2[2]))), o2[3]), r5(t5(r5(t5(e5(a2[1], o2[0]), e5(-o2[1], a2[0])), i3[2]), t5(r5(t5(e5(i3[1], o2[0]), e5(-o2[1], i3[0])), -a2[2]), r5(t5(e5(i3[1], a2[0]), e5(-a2[1], i3[0])), o2[2]))), -l2[3])))), f3 = n4(u2, c2);
                  return f3[f3.length - 1];
                };
              }
              function c(t5) {
                return (3 === t5 ? s : 4 === t5 ? l : u)(i2, n3, a, o);
              }
              var f2 = c(3), h = c(4), p2 = [function() {
                return 0;
              }, function() {
                return 0;
              }, function(t5, e5) {
                return e5[0] - t5[0];
              }, function(t5, e5, r5) {
                var n4, i3 = (t5[1] - r5[1]) * (e5[0] - r5[0]), a2 = (t5[0] - r5[0]) * (e5[1] - r5[1]), o2 = i3 - a2;
                if (i3 > 0) {
                  if (a2 <= 0)
                    return o2;
                  n4 = i3 + a2;
                } else {
                  if (!(i3 < 0))
                    return o2;
                  if (a2 >= 0)
                    return o2;
                  n4 = -(i3 + a2);
                }
                var s2 = 33306690738754716e-32 * n4;
                return o2 >= s2 || o2 <= -s2 ? o2 : f2(t5, e5, r5);
              }, function(t5, e5, r5, n4) {
                var i3 = t5[0] - n4[0], a2 = e5[0] - n4[0], o2 = r5[0] - n4[0], s2 = t5[1] - n4[1], l2 = e5[1] - n4[1], u2 = r5[1] - n4[1], c2 = t5[2] - n4[2], f3 = e5[2] - n4[2], p3 = r5[2] - n4[2], d3 = a2 * u2, v2 = o2 * l2, g2 = o2 * s2, y = i3 * u2, m2 = i3 * l2, x = a2 * s2, b = c2 * (d3 - v2) + f3 * (g2 - y) + p3 * (m2 - x), _ = 7771561172376103e-31 * ((Math.abs(d3) + Math.abs(v2)) * Math.abs(c2) + (Math.abs(g2) + Math.abs(y)) * Math.abs(f3) + (Math.abs(m2) + Math.abs(x)) * Math.abs(p3));
                return b > _ || -b > _ ? b : h(t5, e5, r5, n4);
              }];
              function d2(t5) {
                var e5 = p2[t5.length];
                return e5 || (e5 = p2[t5.length] = c(t5.length)), e5.apply(void 0, t5);
              }
              function v(t5, e5, r5, n4, i3, a2, o2) {
                return function(e6, r6, s2, l2, u2) {
                  switch (arguments.length) {
                    case 0:
                    case 1:
                      return 0;
                    case 2:
                      return n4(e6, r6);
                    case 3:
                      return i3(e6, r6, s2);
                    case 4:
                      return a2(e6, r6, s2, l2);
                    case 5:
                      return o2(e6, r6, s2, l2, u2);
                  }
                  for (var c2 = new Array(arguments.length), f3 = 0; f3 < arguments.length; ++f3)
                    c2[f3] = arguments[f3];
                  return t5(c2);
                };
              }
              !function() {
                for (; p2.length <= 5; )
                  p2.push(c(p2.length));
                t4.exports = v.apply(void 0, [d2].concat(p2));
                for (var e5 = 0; e5 <= 5; ++e5)
                  t4.exports[e5] = p2[e5];
              }();
            }, 2019: function(t4, e4, r4) {
              var n3 = r4(9662), i2 = r4(8289);
              t4.exports = function(t5, e5) {
                if (1 === t5.length)
                  return i2(e5, t5[0]);
                if (1 === e5.length)
                  return i2(t5, e5[0]);
                if (0 === t5.length || 0 === e5.length)
                  return [0];
                var r5 = [0];
                if (t5.length < e5.length)
                  for (var a = 0; a < t5.length; ++a)
                    r5 = n3(r5, i2(e5, t5[a]));
                else
                  for (a = 0; a < e5.length; ++a)
                    r5 = n3(r5, i2(t5, e5[a]));
                return r5;
              };
            }, 8289: function(t4, e4, r4) {
              var n3 = r4(9660), i2 = r4(87);
              t4.exports = function(t5, e5) {
                var r5 = t5.length;
                if (1 === r5) {
                  var a = n3(t5[0], e5);
                  return a[0] ? a : [a[1]];
                }
                var o = new Array(2 * r5), s = [0.1, 0.1], l = [0.1, 0.1], u = 0;
                n3(t5[0], e5, s), s[0] && (o[u++] = s[0]);
                for (var c = 1; c < r5; ++c) {
                  n3(t5[c], e5, l);
                  var f2 = s[1];
                  i2(f2, l[0], s), s[0] && (o[u++] = s[0]);
                  var h = l[1], p2 = s[1], d2 = h + p2, v = p2 - (d2 - h);
                  s[1] = d2, v && (o[u++] = v);
                }
                return s[1] && (o[u++] = s[1]), 0 === u && (o[u++] = 0), o.length = u, o;
              };
            }, 4434: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5, i2) {
                var a = n3(t5, r5, i2), o = n3(e5, r5, i2);
                if (a > 0 && o > 0 || a < 0 && o < 0)
                  return false;
                var s = n3(r5, t5, e5), l = n3(i2, t5, e5);
                return !(s > 0 && l > 0 || s < 0 && l < 0) && (0 !== a || 0 !== o || 0 !== s || 0 !== l || function(t6, e6, r6, n4) {
                  for (var i3 = 0; i3 < 2; ++i3) {
                    var a2 = t6[i3], o2 = e6[i3], s2 = Math.min(a2, o2), l2 = Math.max(a2, o2), u = r6[i3], c = n4[i3], f2 = Math.min(u, c);
                    if (Math.max(u, c) < s2 || l2 < f2)
                      return false;
                  }
                  return true;
                }(t5, e5, r5, i2));
              };
              var n3 = r4(417)[3];
            }, 4078: function(t4) {
              t4.exports = function(t5, e4) {
                var r4 = 0 | t5.length, n3 = 0 | e4.length;
                if (1 === r4 && 1 === n3)
                  return function(t6, e5) {
                    var r5 = t6 + e5, n4 = r5 - t6, i3 = t6 - (r5 - n4) + (e5 - n4);
                    return i3 ? [i3, r5] : [r5];
                  }(t5[0], -e4[0]);
                var i2, a, o = new Array(r4 + n3), s = 0, l = 0, u = 0, c = Math.abs, f2 = t5[l], h = c(f2), p2 = -e4[u], d2 = c(p2);
                h < d2 ? (a = f2, (l += 1) < r4 && (h = c(f2 = t5[l]))) : (a = p2, (u += 1) < n3 && (d2 = c(p2 = -e4[u]))), l < r4 && h < d2 || u >= n3 ? (i2 = f2, (l += 1) < r4 && (h = c(f2 = t5[l]))) : (i2 = p2, (u += 1) < n3 && (d2 = c(p2 = -e4[u])));
                for (var v, g2, y = i2 + a, m2 = y - i2, x = a - m2, b = x, _ = y; l < r4 && u < n3; )
                  h < d2 ? (i2 = f2, (l += 1) < r4 && (h = c(f2 = t5[l]))) : (i2 = p2, (u += 1) < n3 && (d2 = c(p2 = -e4[u]))), (x = (a = b) - (m2 = (y = i2 + a) - i2)) && (o[s++] = x), b = _ - ((v = _ + y) - (g2 = v - _)) + (y - g2), _ = v;
                for (; l < r4; )
                  (x = (a = b) - (m2 = (y = (i2 = f2) + a) - i2)) && (o[s++] = x), b = _ - ((v = _ + y) - (g2 = v - _)) + (y - g2), _ = v, (l += 1) < r4 && (f2 = t5[l]);
                for (; u < n3; )
                  (x = (a = b) - (m2 = (y = (i2 = p2) + a) - i2)) && (o[s++] = x), b = _ - ((v = _ + y) - (g2 = v - _)) + (y - g2), _ = v, (u += 1) < n3 && (p2 = -e4[u]);
                return b && (o[s++] = b), _ && (o[s++] = _), s || (o[s++] = 0), o.length = s, o;
              };
            }, 9662: function(t4) {
              t4.exports = function(t5, e4) {
                var r4 = 0 | t5.length, n3 = 0 | e4.length;
                if (1 === r4 && 1 === n3)
                  return function(t6, e5) {
                    var r5 = t6 + e5, n4 = r5 - t6, i3 = t6 - (r5 - n4) + (e5 - n4);
                    return i3 ? [i3, r5] : [r5];
                  }(t5[0], e4[0]);
                var i2, a, o = new Array(r4 + n3), s = 0, l = 0, u = 0, c = Math.abs, f2 = t5[l], h = c(f2), p2 = e4[u], d2 = c(p2);
                h < d2 ? (a = f2, (l += 1) < r4 && (h = c(f2 = t5[l]))) : (a = p2, (u += 1) < n3 && (d2 = c(p2 = e4[u]))), l < r4 && h < d2 || u >= n3 ? (i2 = f2, (l += 1) < r4 && (h = c(f2 = t5[l]))) : (i2 = p2, (u += 1) < n3 && (d2 = c(p2 = e4[u])));
                for (var v, g2, y = i2 + a, m2 = y - i2, x = a - m2, b = x, _ = y; l < r4 && u < n3; )
                  h < d2 ? (i2 = f2, (l += 1) < r4 && (h = c(f2 = t5[l]))) : (i2 = p2, (u += 1) < n3 && (d2 = c(p2 = e4[u]))), (x = (a = b) - (m2 = (y = i2 + a) - i2)) && (o[s++] = x), b = _ - ((v = _ + y) - (g2 = v - _)) + (y - g2), _ = v;
                for (; l < r4; )
                  (x = (a = b) - (m2 = (y = (i2 = f2) + a) - i2)) && (o[s++] = x), b = _ - ((v = _ + y) - (g2 = v - _)) + (y - g2), _ = v, (l += 1) < r4 && (f2 = t5[l]);
                for (; u < n3; )
                  (x = (a = b) - (m2 = (y = (i2 = p2) + a) - i2)) && (o[s++] = x), b = _ - ((v = _ + y) - (g2 = v - _)) + (y - g2), _ = v, (u += 1) < n3 && (p2 = e4[u]);
                return b && (o[s++] = b), _ && (o[s++] = _), s || (o[s++] = 0), o.length = s, o;
              };
            }, 8691: function(t4, e4, r4) {
              t4.exports = function(t5) {
                return i2(n3(t5));
              };
              var n3 = r4(2692), i2 = r4(7037);
            }, 7212: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5, s) {
                if (r5 = r5 || 0, void 0 === s && (s = function(t6) {
                  for (var e6 = t6.length, r6 = 0, n4 = 0; n4 < e6; ++n4)
                    r6 = 0 | Math.max(r6, t6[n4].length);
                  return r6 - 1;
                }(t5)), 0 === t5.length || s < 1)
                  return { cells: [], vertexIds: [], vertexWeights: [] };
                var l = function(t6, e6) {
                  for (var r6 = t6.length, n4 = i2.mallocUint8(r6), a2 = 0; a2 < r6; ++a2)
                    n4[a2] = t6[a2] < e6 | 0;
                  return n4;
                }(e5, +r5), u = function(t6, e6) {
                  for (var r6 = t6.length, o2 = e6 * (e6 + 1) / 2 * r6 | 0, s2 = i2.mallocUint32(2 * o2), l2 = 0, u2 = 0; u2 < r6; ++u2)
                    for (var c2 = t6[u2], f3 = (e6 = c2.length, 0); f3 < e6; ++f3)
                      for (var h2 = 0; h2 < f3; ++h2) {
                        var p3 = c2[h2], d3 = c2[f3];
                        s2[l2++] = 0 | Math.min(p3, d3), s2[l2++] = 0 | Math.max(p3, d3);
                      }
                  a(n3(s2, [l2 / 2 | 0, 2]));
                  var v = 2;
                  for (u2 = 2; u2 < l2; u2 += 2)
                    s2[u2 - 2] === s2[u2] && s2[u2 - 1] === s2[u2 + 1] || (s2[v++] = s2[u2], s2[v++] = s2[u2 + 1]);
                  return n3(s2, [v / 2 | 0, 2]);
                }(t5, s), c = function(t6, e6, r6, a2) {
                  for (var o2 = t6.data, s2 = t6.shape[0], l2 = i2.mallocDouble(s2), u2 = 0, c2 = 0; c2 < s2; ++c2) {
                    var f3 = o2[2 * c2], h2 = o2[2 * c2 + 1];
                    if (r6[f3] !== r6[h2]) {
                      var p3 = e6[f3], d3 = e6[h2];
                      o2[2 * u2] = f3, o2[2 * u2 + 1] = h2, l2[u2++] = (d3 - a2) / (d3 - p3);
                    }
                  }
                  return t6.shape[0] = u2, n3(l2, [u2]);
                }(u, e5, l, +r5), f2 = function(t6, e6) {
                  var r6 = i2.mallocInt32(2 * e6), n4 = t6.shape[0], a2 = t6.data;
                  r6[0] = 0;
                  for (var o2 = 0, s2 = 0; s2 < n4; ++s2) {
                    var l2 = a2[2 * s2];
                    if (l2 !== o2) {
                      for (r6[2 * o2 + 1] = s2; ++o2 < l2; )
                        r6[2 * o2] = s2, r6[2 * o2 + 1] = s2;
                      r6[2 * o2] = s2;
                    }
                  }
                  for (r6[2 * o2 + 1] = n4; ++o2 < e6; )
                    r6[2 * o2] = r6[2 * o2 + 1] = n4;
                  return r6;
                }(u, 0 | e5.length), h = o(s)(t5, u.data, f2, l), p2 = function(t6) {
                  for (var e6 = 0 | t6.shape[0], r6 = t6.data, n4 = new Array(e6), i3 = 0; i3 < e6; ++i3)
                    n4[i3] = [r6[2 * i3], r6[2 * i3 + 1]];
                  return n4;
                }(u), d2 = [].slice.call(c.data, 0, c.shape[0]);
                return i2.free(l), i2.free(u.data), i2.free(c.data), i2.free(f2), { cells: h, vertexIds: p2, vertexWeights: d2 };
              };
              var n3 = r4(5050), i2 = r4(5306), a = r4(8729), o = r4(1168);
            }, 1168: function(t4) {
              t4.exports = function(t5) {
                return e4[t5]();
              };
              var e4 = [function() {
                return function(t5, e5, r4, n3) {
                  for (var i2 = t5.length, a = 0; a < i2; ++a)
                    t5[a].length;
                  return [];
                };
              }, function() {
                function t5(t6, e5, r4, n3) {
                  for (var i2 = 0 | Math.min(r4, n3), a = 0 | Math.max(r4, n3), o = t6[2 * i2], s = t6[2 * i2 + 1]; o < s; ) {
                    var l = o + s >> 1, u = e5[2 * l + 1];
                    if (u === a)
                      return l;
                    a < u ? s = l : o = l + 1;
                  }
                  return o;
                }
                return function(e5, r4, n3, i2) {
                  for (var a = e5.length, o = [], s = 0; s < a; ++s) {
                    var l = e5[s];
                    if (2 === l.length) {
                      var u = (i2[l[0]] << 0) + (i2[l[1]] << 1);
                      if (0 === u || 3 === u)
                        continue;
                      switch (u) {
                        case 0:
                        case 3:
                          break;
                        case 1:
                          o.push([t5(n3, r4, l[0], l[1])]);
                          break;
                        case 2:
                          o.push([t5(n3, r4, l[1], l[0])]);
                      }
                    }
                  }
                  return o;
                };
              }, function() {
                function t5(t6, e5, r4, n3) {
                  for (var i2 = 0 | Math.min(r4, n3), a = 0 | Math.max(r4, n3), o = t6[2 * i2], s = t6[2 * i2 + 1]; o < s; ) {
                    var l = o + s >> 1, u = e5[2 * l + 1];
                    if (u === a)
                      return l;
                    a < u ? s = l : o = l + 1;
                  }
                  return o;
                }
                return function(e5, r4, n3, i2) {
                  for (var a = e5.length, o = [], s = 0; s < a; ++s) {
                    var l = e5[s], u = l.length;
                    if (3 === u) {
                      if (0 == (c = (i2[l[0]] << 0) + (i2[l[1]] << 1) + (i2[l[2]] << 2)) || 7 === c)
                        continue;
                      switch (c) {
                        case 0:
                        case 7:
                          break;
                        case 1:
                          o.push([t5(n3, r4, l[0], l[2]), t5(n3, r4, l[0], l[1])]);
                          break;
                        case 2:
                          o.push([t5(n3, r4, l[1], l[0]), t5(n3, r4, l[1], l[2])]);
                          break;
                        case 3:
                          o.push([t5(n3, r4, l[0], l[2]), t5(n3, r4, l[1], l[2])]);
                          break;
                        case 4:
                          o.push([t5(n3, r4, l[2], l[1]), t5(n3, r4, l[2], l[0])]);
                          break;
                        case 5:
                          o.push([t5(n3, r4, l[2], l[1]), t5(n3, r4, l[0], l[1])]);
                          break;
                        case 6:
                          o.push([t5(n3, r4, l[1], l[0]), t5(n3, r4, l[2], l[0])]);
                      }
                    } else if (2 === u) {
                      var c;
                      if (0 == (c = (i2[l[0]] << 0) + (i2[l[1]] << 1)) || 3 === c)
                        continue;
                      switch (c) {
                        case 0:
                        case 3:
                          break;
                        case 1:
                          o.push([t5(n3, r4, l[0], l[1])]);
                          break;
                        case 2:
                          o.push([t5(n3, r4, l[1], l[0])]);
                      }
                    }
                  }
                  return o;
                };
              }, function() {
                function t5(t6, e5, r4, n3) {
                  for (var i2 = 0 | Math.min(r4, n3), a = 0 | Math.max(r4, n3), o = t6[2 * i2], s = t6[2 * i2 + 1]; o < s; ) {
                    var l = o + s >> 1, u = e5[2 * l + 1];
                    if (u === a)
                      return l;
                    a < u ? s = l : o = l + 1;
                  }
                  return o;
                }
                return function(e5, r4, n3, i2) {
                  for (var a = e5.length, o = [], s = 0; s < a; ++s) {
                    var l = e5[s], u = l.length;
                    if (4 === u) {
                      if (0 == (c = (i2[l[0]] << 0) + (i2[l[1]] << 1) + (i2[l[2]] << 2) + (i2[l[3]] << 3)) || 15 === c)
                        continue;
                      switch (c) {
                        case 0:
                        case 15:
                          break;
                        case 1:
                          o.push([t5(n3, r4, l[0], l[1]), t5(n3, r4, l[0], l[2]), t5(n3, r4, l[0], l[3])]);
                          break;
                        case 2:
                          o.push([t5(n3, r4, l[1], l[2]), t5(n3, r4, l[1], l[0]), t5(n3, r4, l[1], l[3])]);
                          break;
                        case 3:
                          o.push([t5(n3, r4, l[1], l[2]), t5(n3, r4, l[0], l[2]), t5(n3, r4, l[0], l[3])], [t5(n3, r4, l[1], l[3]), t5(n3, r4, l[1], l[2]), t5(n3, r4, l[0], l[3])]);
                          break;
                        case 4:
                          o.push([t5(n3, r4, l[2], l[0]), t5(n3, r4, l[2], l[1]), t5(n3, r4, l[2], l[3])]);
                          break;
                        case 5:
                          o.push([t5(n3, r4, l[0], l[1]), t5(n3, r4, l[2], l[1]), t5(n3, r4, l[0], l[3])], [t5(n3, r4, l[2], l[1]), t5(n3, r4, l[2], l[3]), t5(n3, r4, l[0], l[3])]);
                          break;
                        case 6:
                          o.push([t5(n3, r4, l[2], l[0]), t5(n3, r4, l[1], l[0]), t5(n3, r4, l[1], l[3])], [t5(n3, r4, l[2], l[3]), t5(n3, r4, l[2], l[0]), t5(n3, r4, l[1], l[3])]);
                          break;
                        case 7:
                          o.push([t5(n3, r4, l[0], l[3]), t5(n3, r4, l[1], l[3]), t5(n3, r4, l[2], l[3])]);
                          break;
                        case 8:
                          o.push([t5(n3, r4, l[3], l[1]), t5(n3, r4, l[3], l[0]), t5(n3, r4, l[3], l[2])]);
                          break;
                        case 9:
                          o.push([t5(n3, r4, l[3], l[1]), t5(n3, r4, l[0], l[1]), t5(n3, r4, l[0], l[2])], [t5(n3, r4, l[3], l[2]), t5(n3, r4, l[3], l[1]), t5(n3, r4, l[0], l[2])]);
                          break;
                        case 10:
                          o.push([t5(n3, r4, l[1], l[0]), t5(n3, r4, l[3], l[0]), t5(n3, r4, l[1], l[2])], [t5(n3, r4, l[3], l[0]), t5(n3, r4, l[3], l[2]), t5(n3, r4, l[1], l[2])]);
                          break;
                        case 11:
                          o.push([t5(n3, r4, l[1], l[2]), t5(n3, r4, l[0], l[2]), t5(n3, r4, l[3], l[2])]);
                          break;
                        case 12:
                          o.push([t5(n3, r4, l[3], l[0]), t5(n3, r4, l[2], l[0]), t5(n3, r4, l[2], l[1])], [t5(n3, r4, l[3], l[1]), t5(n3, r4, l[3], l[0]), t5(n3, r4, l[2], l[1])]);
                          break;
                        case 13:
                          o.push([t5(n3, r4, l[0], l[1]), t5(n3, r4, l[2], l[1]), t5(n3, r4, l[3], l[1])]);
                          break;
                        case 14:
                          o.push([t5(n3, r4, l[2], l[0]), t5(n3, r4, l[1], l[0]), t5(n3, r4, l[3], l[0])]);
                      }
                    } else if (3 === u) {
                      if (0 == (c = (i2[l[0]] << 0) + (i2[l[1]] << 1) + (i2[l[2]] << 2)) || 7 === c)
                        continue;
                      switch (c) {
                        case 0:
                        case 7:
                          break;
                        case 1:
                          o.push([t5(n3, r4, l[0], l[2]), t5(n3, r4, l[0], l[1])]);
                          break;
                        case 2:
                          o.push([t5(n3, r4, l[1], l[0]), t5(n3, r4, l[1], l[2])]);
                          break;
                        case 3:
                          o.push([t5(n3, r4, l[0], l[2]), t5(n3, r4, l[1], l[2])]);
                          break;
                        case 4:
                          o.push([t5(n3, r4, l[2], l[1]), t5(n3, r4, l[2], l[0])]);
                          break;
                        case 5:
                          o.push([t5(n3, r4, l[2], l[1]), t5(n3, r4, l[0], l[1])]);
                          break;
                        case 6:
                          o.push([t5(n3, r4, l[1], l[0]), t5(n3, r4, l[2], l[0])]);
                      }
                    } else if (2 === u) {
                      var c;
                      if (0 == (c = (i2[l[0]] << 0) + (i2[l[1]] << 1)) || 3 === c)
                        continue;
                      switch (c) {
                        case 0:
                        case 3:
                          break;
                        case 1:
                          o.push([t5(n3, r4, l[0], l[1])]);
                          break;
                        case 2:
                          o.push([t5(n3, r4, l[1], l[0])]);
                      }
                    }
                  }
                  return o;
                };
              }];
            }, 8211: function(t4, e4, r4) {
              r4(2288), r4(1731), e4.H = function(t5, e5) {
                var r5 = t5.length, n3 = t5.length - e5.length, i2 = Math.min;
                if (n3)
                  return n3;
                switch (r5) {
                  case 0:
                    return 0;
                  case 1:
                    return t5[0] - e5[0];
                  case 2:
                    return (s = t5[0] + t5[1] - e5[0] - e5[1]) || i2(t5[0], t5[1]) - i2(e5[0], e5[1]);
                  case 3:
                    var a = t5[0] + t5[1], o = e5[0] + e5[1];
                    if (s = a + t5[2] - (o + e5[2]))
                      return s;
                    var s, l = i2(t5[0], t5[1]), u = i2(e5[0], e5[1]);
                    return (s = i2(l, t5[2]) - i2(u, e5[2])) || i2(l + t5[2], a) - i2(u + e5[2], o);
                  default:
                    var c = t5.slice(0);
                    c.sort();
                    var f2 = e5.slice(0);
                    f2.sort();
                    for (var h = 0; h < r5; ++h)
                      if (n3 = c[h] - f2[h])
                        return n3;
                    return 0;
                }
              };
            }, 9392: function(t4, e4) {
              function r4(t5) {
                var e5 = 32;
                return (t5 &= -t5) && e5--, 65535 & t5 && (e5 -= 16), 16711935 & t5 && (e5 -= 8), 252645135 & t5 && (e5 -= 4), 858993459 & t5 && (e5 -= 2), 1431655765 & t5 && (e5 -= 1), e5;
              }
              e4.INT_BITS = 32, e4.INT_MAX = 2147483647, e4.INT_MIN = -1 << 31, e4.sign = function(t5) {
                return (t5 > 0) - (t5 < 0);
              }, e4.abs = function(t5) {
                var e5 = t5 >> 31;
                return (t5 ^ e5) - e5;
              }, e4.min = function(t5, e5) {
                return e5 ^ (t5 ^ e5) & -(t5 < e5);
              }, e4.max = function(t5, e5) {
                return t5 ^ (t5 ^ e5) & -(t5 < e5);
              }, e4.isPow2 = function(t5) {
                return !(t5 & t5 - 1 || !t5);
              }, e4.log2 = function(t5) {
                var e5, r5;
                return e5 = (t5 > 65535) << 4, e5 |= r5 = ((t5 >>>= e5) > 255) << 3, e5 |= r5 = ((t5 >>>= r5) > 15) << 2, (e5 |= r5 = ((t5 >>>= r5) > 3) << 1) | (t5 >>>= r5) >> 1;
              }, e4.log10 = function(t5) {
                return t5 >= 1e9 ? 9 : t5 >= 1e8 ? 8 : t5 >= 1e7 ? 7 : t5 >= 1e6 ? 6 : t5 >= 1e5 ? 5 : t5 >= 1e4 ? 4 : t5 >= 1e3 ? 3 : t5 >= 100 ? 2 : t5 >= 10 ? 1 : 0;
              }, e4.popCount = function(t5) {
                return 16843009 * ((t5 = (858993459 & (t5 -= t5 >>> 1 & 1431655765)) + (t5 >>> 2 & 858993459)) + (t5 >>> 4) & 252645135) >>> 24;
              }, e4.countTrailingZeros = r4, e4.nextPow2 = function(t5) {
                return t5 += 0 === t5, --t5, t5 |= t5 >>> 1, t5 |= t5 >>> 2, t5 |= t5 >>> 4, 1 + ((t5 |= t5 >>> 8) | t5 >>> 16);
              }, e4.prevPow2 = function(t5) {
                return t5 |= t5 >>> 1, t5 |= t5 >>> 2, t5 |= t5 >>> 4, t5 |= t5 >>> 8, (t5 |= t5 >>> 16) - (t5 >>> 1);
              }, e4.parity = function(t5) {
                return t5 ^= t5 >>> 16, t5 ^= t5 >>> 8, t5 ^= t5 >>> 4, 27030 >>> (t5 &= 15) & 1;
              };
              var n3 = new Array(256);
              !function(t5) {
                for (var e5 = 0; e5 < 256; ++e5) {
                  var r5 = e5, n4 = e5, i2 = 7;
                  for (r5 >>>= 1; r5; r5 >>>= 1)
                    n4 <<= 1, n4 |= 1 & r5, --i2;
                  t5[e5] = n4 << i2 & 255;
                }
              }(n3), e4.reverse = function(t5) {
                return n3[255 & t5] << 24 | n3[t5 >>> 8 & 255] << 16 | n3[t5 >>> 16 & 255] << 8 | n3[t5 >>> 24 & 255];
              }, e4.interleave2 = function(t5, e5) {
                return (t5 = 1431655765 & ((t5 = 858993459 & ((t5 = 252645135 & ((t5 = 16711935 & ((t5 &= 65535) | t5 << 8)) | t5 << 4)) | t5 << 2)) | t5 << 1)) | (e5 = 1431655765 & ((e5 = 858993459 & ((e5 = 252645135 & ((e5 = 16711935 & ((e5 &= 65535) | e5 << 8)) | e5 << 4)) | e5 << 2)) | e5 << 1)) << 1;
              }, e4.deinterleave2 = function(t5, e5) {
                return (t5 = 65535 & ((t5 = 16711935 & ((t5 = 252645135 & ((t5 = 858993459 & ((t5 = t5 >>> e5 & 1431655765) | t5 >>> 1)) | t5 >>> 2)) | t5 >>> 4)) | t5 >>> 16)) << 16 >> 16;
              }, e4.interleave3 = function(t5, e5, r5) {
                return t5 = 1227133513 & ((t5 = 3272356035 & ((t5 = 251719695 & ((t5 = 4278190335 & ((t5 &= 1023) | t5 << 16)) | t5 << 8)) | t5 << 4)) | t5 << 2), (t5 |= (e5 = 1227133513 & ((e5 = 3272356035 & ((e5 = 251719695 & ((e5 = 4278190335 & ((e5 &= 1023) | e5 << 16)) | e5 << 8)) | e5 << 4)) | e5 << 2)) << 1) | (r5 = 1227133513 & ((r5 = 3272356035 & ((r5 = 251719695 & ((r5 = 4278190335 & ((r5 &= 1023) | r5 << 16)) | r5 << 8)) | r5 << 4)) | r5 << 2)) << 2;
              }, e4.deinterleave3 = function(t5, e5) {
                return (t5 = 1023 & ((t5 = 4278190335 & ((t5 = 251719695 & ((t5 = 3272356035 & ((t5 = t5 >>> e5 & 1227133513) | t5 >>> 2)) | t5 >>> 4)) | t5 >>> 8)) | t5 >>> 16)) << 22 >> 22;
              }, e4.nextCombination = function(t5) {
                var e5 = t5 | t5 - 1;
                return e5 + 1 | (~e5 & -~e5) - 1 >>> r4(t5) + 1;
              };
            }, 6656: function(t4, e4, r4) {
              var n3 = r4(9392), i2 = r4(9521);
              function a(t5, e5) {
                var r5 = t5.length, n4 = t5.length - e5.length, i3 = Math.min;
                if (n4)
                  return n4;
                switch (r5) {
                  case 0:
                    return 0;
                  case 1:
                    return t5[0] - e5[0];
                  case 2:
                    return (s2 = t5[0] + t5[1] - e5[0] - e5[1]) || i3(t5[0], t5[1]) - i3(e5[0], e5[1]);
                  case 3:
                    var a2 = t5[0] + t5[1], o2 = e5[0] + e5[1];
                    if (s2 = a2 + t5[2] - (o2 + e5[2]))
                      return s2;
                    var s2, l2 = i3(t5[0], t5[1]), u2 = i3(e5[0], e5[1]);
                    return (s2 = i3(l2, t5[2]) - i3(u2, e5[2])) || i3(l2 + t5[2], a2) - i3(u2 + e5[2], o2);
                  default:
                    var c2 = t5.slice(0);
                    c2.sort();
                    var f3 = e5.slice(0);
                    f3.sort();
                    for (var h = 0; h < r5; ++h)
                      if (n4 = c2[h] - f3[h])
                        return n4;
                    return 0;
                }
              }
              function o(t5, e5) {
                return a(t5[0], e5[0]);
              }
              function s(t5, e5) {
                if (e5) {
                  for (var r5 = t5.length, n4 = new Array(r5), i3 = 0; i3 < r5; ++i3)
                    n4[i3] = [t5[i3], e5[i3]];
                  for (n4.sort(o), i3 = 0; i3 < r5; ++i3)
                    t5[i3] = n4[i3][0], e5[i3] = n4[i3][1];
                  return t5;
                }
                return t5.sort(a), t5;
              }
              function l(t5) {
                if (0 === t5.length)
                  return [];
                for (var e5 = 1, r5 = t5.length, n4 = 1; n4 < r5; ++n4) {
                  var i3 = t5[n4];
                  if (a(i3, t5[n4 - 1])) {
                    if (n4 === e5) {
                      e5++;
                      continue;
                    }
                    t5[e5++] = i3;
                  }
                }
                return t5.length = e5, t5;
              }
              function u(t5, e5) {
                for (var r5 = 0, n4 = t5.length - 1, i3 = -1; r5 <= n4; ) {
                  var o2 = r5 + n4 >> 1, s2 = a(t5[o2], e5);
                  s2 <= 0 ? (0 === s2 && (i3 = o2), r5 = o2 + 1) : s2 > 0 && (n4 = o2 - 1);
                }
                return i3;
              }
              function c(t5, e5) {
                for (var r5 = new Array(t5.length), i3 = 0, o2 = r5.length; i3 < o2; ++i3)
                  r5[i3] = [];
                for (var s2 = [], l2 = (i3 = 0, e5.length); i3 < l2; ++i3)
                  for (var c2 = e5[i3], f3 = c2.length, h = 1, p2 = 1 << f3; h < p2; ++h) {
                    s2.length = n3.popCount(h);
                    for (var d2 = 0, v = 0; v < f3; ++v)
                      h & 1 << v && (s2[d2++] = c2[v]);
                    var g2 = u(t5, s2);
                    if (!(g2 < 0))
                      for (; r5[g2++].push(i3), !(g2 >= t5.length || 0 !== a(t5[g2], s2)); )
                        ;
                  }
                return r5;
              }
              function f2(t5, e5) {
                if (e5 < 0)
                  return [];
                for (var r5 = [], i3 = (1 << e5 + 1) - 1, a2 = 0; a2 < t5.length; ++a2)
                  for (var o2 = t5[a2], l2 = i3; l2 < 1 << o2.length; l2 = n3.nextCombination(l2)) {
                    for (var u2 = new Array(e5 + 1), c2 = 0, f3 = 0; f3 < o2.length; ++f3)
                      l2 & 1 << f3 && (u2[c2++] = o2[f3]);
                    r5.push(u2);
                  }
                return s(r5);
              }
              e4.dimension = function(t5) {
                for (var e5 = 0, r5 = Math.max, n4 = 0, i3 = t5.length; n4 < i3; ++n4)
                  e5 = r5(e5, t5[n4].length);
                return e5 - 1;
              }, e4.countVertices = function(t5) {
                for (var e5 = -1, r5 = Math.max, n4 = 0, i3 = t5.length; n4 < i3; ++n4)
                  for (var a2 = t5[n4], o2 = 0, s2 = a2.length; o2 < s2; ++o2)
                    e5 = r5(e5, a2[o2]);
                return e5 + 1;
              }, e4.cloneCells = function(t5) {
                for (var e5 = new Array(t5.length), r5 = 0, n4 = t5.length; r5 < n4; ++r5)
                  e5[r5] = t5[r5].slice(0);
                return e5;
              }, e4.compareCells = a, e4.normalize = s, e4.unique = l, e4.findCell = u, e4.incidence = c, e4.dual = function(t5, e5) {
                if (!e5)
                  return c(l(f2(t5, 0)), t5);
                for (var r5 = new Array(e5), n4 = 0; n4 < e5; ++n4)
                  r5[n4] = [];
                n4 = 0;
                for (var i3 = t5.length; n4 < i3; ++n4)
                  for (var a2 = t5[n4], o2 = 0, s2 = a2.length; o2 < s2; ++o2)
                    r5[a2[o2]].push(n4);
                return r5;
              }, e4.explode = function(t5) {
                for (var e5 = [], r5 = 0, n4 = t5.length; r5 < n4; ++r5)
                  for (var i3 = t5[r5], a2 = 0 | i3.length, o2 = 1, l2 = 1 << a2; o2 < l2; ++o2) {
                    for (var u2 = [], c2 = 0; c2 < a2; ++c2)
                      o2 >>> c2 & 1 && u2.push(i3[c2]);
                    e5.push(u2);
                  }
                return s(e5);
              }, e4.skeleton = f2, e4.boundary = function(t5) {
                for (var e5 = [], r5 = 0, n4 = t5.length; r5 < n4; ++r5)
                  for (var i3 = t5[r5], a2 = 0, o2 = i3.length; a2 < o2; ++a2) {
                    for (var l2 = new Array(i3.length - 1), u2 = 0, c2 = 0; u2 < o2; ++u2)
                      u2 !== a2 && (l2[c2++] = i3[u2]);
                    e5.push(l2);
                  }
                return s(e5);
              }, e4.connectedComponents = function(t5, e5) {
                return e5 ? function(t6, e6) {
                  for (var r5 = new i2(e6), n4 = 0; n4 < t6.length; ++n4)
                    for (var a2 = t6[n4], o2 = 0; o2 < a2.length; ++o2)
                      for (var s2 = o2 + 1; s2 < a2.length; ++s2)
                        r5.link(a2[o2], a2[s2]);
                  var l2 = [], u2 = r5.ranks;
                  for (n4 = 0; n4 < u2.length; ++n4)
                    u2[n4] = -1;
                  for (n4 = 0; n4 < t6.length; ++n4) {
                    var c2 = r5.find(t6[n4][0]);
                    u2[c2] < 0 ? (u2[c2] = l2.length, l2.push([t6[n4].slice(0)])) : l2[u2[c2]].push(t6[n4].slice(0));
                  }
                  return l2;
                }(t5, e5) : function(t6) {
                  for (var e6 = l(s(f2(t6, 0))), r5 = new i2(e6.length), n4 = 0; n4 < t6.length; ++n4)
                    for (var a2 = t6[n4], o2 = 0; o2 < a2.length; ++o2)
                      for (var c2 = u(e6, [a2[o2]]), h = o2 + 1; h < a2.length; ++h)
                        r5.link(c2, u(e6, [a2[h]]));
                  var p2 = [], d2 = r5.ranks;
                  for (n4 = 0; n4 < d2.length; ++n4)
                    d2[n4] = -1;
                  for (n4 = 0; n4 < t6.length; ++n4) {
                    var v = r5.find(u(e6, [t6[n4][0]]));
                    d2[v] < 0 ? (d2[v] = p2.length, p2.push([t6[n4].slice(0)])) : p2[d2[v]].push(t6[n4].slice(0));
                  }
                  return p2;
                }(t5);
              };
            }, 9521: function(t4) {
              function e4(t5) {
                this.roots = new Array(t5), this.ranks = new Array(t5);
                for (var e5 = 0; e5 < t5; ++e5)
                  this.roots[e5] = e5, this.ranks[e5] = 0;
              }
              t4.exports = e4, e4.prototype.length = function() {
                return this.roots.length;
              }, e4.prototype.makeSet = function() {
                var t5 = this.roots.length;
                return this.roots.push(t5), this.ranks.push(0), t5;
              }, e4.prototype.find = function(t5) {
                for (var e5 = this.roots; e5[t5] !== t5; ) {
                  var r4 = e5[t5];
                  e5[t5] = e5[r4], t5 = r4;
                }
                return t5;
              }, e4.prototype.link = function(t5, e5) {
                var r4 = this.find(t5), n3 = this.find(e5);
                if (r4 !== n3) {
                  var i2 = this.ranks, a = this.roots, o = i2[r4], s = i2[n3];
                  o < s ? a[r4] = n3 : s < o ? a[n3] = r4 : (a[n3] = r4, ++i2[r4]);
                }
              };
            }, 8243: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5) {
                for (var a = e5.length, o = t5.length, s = new Array(a), l = new Array(a), u = new Array(a), c = new Array(a), f2 = 0; f2 < a; ++f2)
                  s[f2] = l[f2] = -1, u[f2] = 1 / 0, c[f2] = false;
                for (f2 = 0; f2 < o; ++f2) {
                  var h = t5[f2];
                  if (2 !== h.length)
                    throw new Error("Input must be a graph");
                  var p2 = h[1], d2 = h[0];
                  -1 !== l[d2] ? l[d2] = -2 : l[d2] = p2, -1 !== s[p2] ? s[p2] = -2 : s[p2] = d2;
                }
                function v(t6) {
                  if (c[t6])
                    return 1 / 0;
                  var r6, i3, a2, o2 = s[t6], u2 = l[t6];
                  return o2 < 0 || u2 < 0 ? 1 / 0 : (r6 = e5[t6], i3 = e5[o2], a2 = e5[u2], Math.abs(n3(r6, i3, a2)) / Math.sqrt(Math.pow(i3[0] - a2[0], 2) + Math.pow(i3[1] - a2[1], 2)));
                }
                function g2(t6, e6) {
                  var r6 = k[t6], n4 = k[e6];
                  k[t6] = n4, k[e6] = r6, A[r6] = e6, A[n4] = t6;
                }
                function y(t6) {
                  return u[k[t6]];
                }
                function m2(t6) {
                  return 1 & t6 ? t6 - 1 >> 1 : (t6 >> 1) - 1;
                }
                function x(t6) {
                  for (var e6 = y(t6); ; ) {
                    var r6 = e6, n4 = 2 * t6 + 1, i3 = 2 * (t6 + 1), a2 = t6;
                    if (n4 < M) {
                      var o2 = y(n4);
                      o2 < r6 && (a2 = n4, r6 = o2);
                    }
                    if (i3 < M && y(i3) < r6 && (a2 = i3), a2 === t6)
                      return t6;
                    g2(t6, a2), t6 = a2;
                  }
                }
                function b(t6) {
                  for (var e6 = y(t6); t6 > 0; ) {
                    var r6 = m2(t6);
                    if (!(r6 >= 0 && e6 < y(r6)))
                      return t6;
                    g2(t6, r6), t6 = r6;
                  }
                }
                function _() {
                  if (M > 0) {
                    var t6 = k[0];
                    return g2(0, M - 1), M -= 1, x(0), t6;
                  }
                  return -1;
                }
                function w2(t6, e6) {
                  var r6 = k[t6];
                  return u[r6] === e6 ? t6 : (u[r6] = -1 / 0, b(t6), _(), u[r6] = e6, b((M += 1) - 1));
                }
                function T(t6) {
                  if (!c[t6]) {
                    c[t6] = true;
                    var e6 = s[t6], r6 = l[t6];
                    s[r6] >= 0 && (s[r6] = e6), l[e6] >= 0 && (l[e6] = r6), A[e6] >= 0 && w2(A[e6], v(e6)), A[r6] >= 0 && w2(A[r6], v(r6));
                  }
                }
                var k = [], A = new Array(a);
                for (f2 = 0; f2 < a; ++f2)
                  (u[f2] = v(f2)) < 1 / 0 ? (A[f2] = k.length, k.push(f2)) : A[f2] = -1;
                var M = k.length;
                for (f2 = M >> 1; f2 >= 0; --f2)
                  x(f2);
                for (; ; ) {
                  var S = _();
                  if (S < 0 || u[S] > r5)
                    break;
                  T(S);
                }
                var E = [];
                for (f2 = 0; f2 < a; ++f2)
                  c[f2] || (A[f2] = E.length, E.push(e5[f2].slice()));
                function L(t6, e6) {
                  if (t6[e6] < 0)
                    return e6;
                  var r6 = e6, n4 = e6;
                  do {
                    var i3 = t6[n4];
                    if (!c[n4] || i3 < 0 || i3 === n4)
                      break;
                    if (i3 = t6[n4 = i3], !c[n4] || i3 < 0 || i3 === n4)
                      break;
                    n4 = i3, r6 = t6[r6];
                  } while (r6 !== n4);
                  for (var a2 = e6; a2 !== n4; a2 = t6[a2])
                    t6[a2] = n4;
                  return n4;
                }
                E.length;
                var C = [];
                return t5.forEach(function(t6) {
                  var e6 = L(s, t6[0]), r6 = L(l, t6[1]);
                  if (e6 >= 0 && r6 >= 0 && e6 !== r6) {
                    var n4 = A[e6], i3 = A[r6];
                    n4 !== i3 && C.push([n4, i3]);
                  }
                }), i2.unique(i2.normalize(C)), { positions: E, edges: C };
              };
              var n3 = r4(417), i2 = r4(6656);
            }, 6638: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                var r5, a, o, s;
                if (e5[0][0] < e5[1][0])
                  r5 = e5[0], a = e5[1];
                else {
                  if (!(e5[0][0] > e5[1][0]))
                    return i2(e5, t5);
                  r5 = e5[1], a = e5[0];
                }
                if (t5[0][0] < t5[1][0])
                  o = t5[0], s = t5[1];
                else {
                  if (!(t5[0][0] > t5[1][0]))
                    return -i2(t5, e5);
                  o = t5[1], s = t5[0];
                }
                var l = n3(r5, a, s), u = n3(r5, a, o);
                if (l < 0) {
                  if (u <= 0)
                    return l;
                } else if (l > 0) {
                  if (u >= 0)
                    return l;
                } else if (u)
                  return u;
                if (l = n3(s, o, a), u = n3(s, o, r5), l < 0) {
                  if (u <= 0)
                    return l;
                } else if (l > 0) {
                  if (u >= 0)
                    return l;
                } else if (u)
                  return u;
                return a[0] - s[0];
              };
              var n3 = r4(417);
              function i2(t5, e5) {
                var r5, i3, a, o;
                if (e5[0][0] < e5[1][0])
                  r5 = e5[0], i3 = e5[1];
                else {
                  if (!(e5[0][0] > e5[1][0])) {
                    var s = Math.min(t5[0][1], t5[1][1]), l = Math.max(t5[0][1], t5[1][1]), u = Math.min(e5[0][1], e5[1][1]), c = Math.max(e5[0][1], e5[1][1]);
                    return l < u ? l - u : s > c ? s - c : l - c;
                  }
                  r5 = e5[1], i3 = e5[0];
                }
                t5[0][1] < t5[1][1] ? (a = t5[0], o = t5[1]) : (a = t5[1], o = t5[0]);
                var f2 = n3(i3, r5, a);
                return f2 || (f2 = n3(i3, r5, o)) || o - i3;
              }
            }, 4385: function(t4, e4, r4) {
              t4.exports = function(t5) {
                for (var e5 = t5.length, r5 = 2 * e5, n4 = new Array(r5), a2 = 0; a2 < e5; ++a2) {
                  var l2 = t5[a2], u2 = l2[0][0] < l2[1][0];
                  n4[2 * a2] = new f2(l2[0][0], l2, u2, a2), n4[2 * a2 + 1] = new f2(l2[1][0], l2, !u2, a2);
                }
                n4.sort(function(t6, e6) {
                  var r6 = t6.x - e6.x;
                  return r6 || (r6 = t6.create - e6.create) || Math.min(t6.segment[0][1], t6.segment[1][1]) - Math.min(e6.segment[0][1], e6.segment[1][1]);
                });
                var h = i2(o), p2 = [], d2 = [], v = [];
                for (a2 = 0; a2 < r5; ) {
                  for (var g2 = n4[a2].x, y = []; a2 < r5; ) {
                    var m2 = n4[a2];
                    if (m2.x !== g2)
                      break;
                    a2 += 1, m2.segment[0][0] === m2.x && m2.segment[1][0] === m2.x ? m2.create && (m2.segment[0][1] < m2.segment[1][1] ? (y.push(new c(m2.segment[0][1], m2.index, true, true)), y.push(new c(m2.segment[1][1], m2.index, false, false))) : (y.push(new c(m2.segment[1][1], m2.index, true, false)), y.push(new c(m2.segment[0][1], m2.index, false, true)))) : h = m2.create ? h.insert(m2.segment, m2.index) : h.remove(m2.segment);
                  }
                  p2.push(h.root), d2.push(g2), v.push(y);
                }
                return new s(p2, d2, v);
              };
              var n3 = r4(5070), i2 = r4(7080), a = r4(417), o = r4(6638);
              function s(t5, e5, r5) {
                this.slabs = t5, this.coordinates = e5, this.horizontal = r5;
              }
              function l(t5, e5) {
                return t5.y - e5;
              }
              function u(t5, e5) {
                for (var r5 = null; t5; ) {
                  var n4, i3, o2 = t5.key;
                  o2[0][0] < o2[1][0] ? (n4 = o2[0], i3 = o2[1]) : (n4 = o2[1], i3 = o2[0]);
                  var s2 = a(n4, i3, e5);
                  if (s2 < 0)
                    t5 = t5.left;
                  else if (s2 > 0)
                    if (e5[0] !== o2[1][0])
                      r5 = t5, t5 = t5.right;
                    else {
                      if (l2 = u(t5.right, e5))
                        return l2;
                      t5 = t5.left;
                    }
                  else {
                    if (e5[0] !== o2[1][0])
                      return t5;
                    var l2;
                    if (l2 = u(t5.right, e5))
                      return l2;
                    t5 = t5.left;
                  }
                }
                return r5;
              }
              function c(t5, e5, r5, n4) {
                this.y = t5, this.index = e5, this.start = r5, this.closed = n4;
              }
              function f2(t5, e5, r5, n4) {
                this.x = t5, this.segment = e5, this.create = r5, this.index = n4;
              }
              s.prototype.castUp = function(t5) {
                var e5 = n3.le(this.coordinates, t5[0]);
                if (e5 < 0)
                  return -1;
                this.slabs[e5];
                var r5 = u(this.slabs[e5], t5), i3 = -1;
                if (r5 && (i3 = r5.value), this.coordinates[e5] === t5[0]) {
                  var s2 = null;
                  if (r5 && (s2 = r5.key), e5 > 0) {
                    var c2 = u(this.slabs[e5 - 1], t5);
                    c2 && (s2 ? o(c2.key, s2) > 0 && (s2 = c2.key, i3 = c2.value) : (i3 = c2.value, s2 = c2.key));
                  }
                  var f3 = this.horizontal[e5];
                  if (f3.length > 0) {
                    var h = n3.ge(f3, t5[1], l);
                    if (h < f3.length) {
                      var p2 = f3[h];
                      if (t5[1] === p2.y) {
                        if (p2.closed)
                          return p2.index;
                        for (; h < f3.length - 1 && f3[h + 1].y === t5[1]; )
                          if ((p2 = f3[h += 1]).closed)
                            return p2.index;
                        if (p2.y === t5[1] && !p2.start) {
                          if ((h += 1) >= f3.length)
                            return i3;
                          p2 = f3[h];
                        }
                      }
                      if (p2.start)
                        if (s2) {
                          var d2 = a(s2[0], s2[1], [t5[0], p2.y]);
                          s2[0][0] > s2[1][0] && (d2 = -d2), d2 > 0 && (i3 = p2.index);
                        } else
                          i3 = p2.index;
                      else
                        p2.y !== t5[1] && (i3 = p2.index);
                    }
                  }
                }
                return i3;
              };
            }, 4670: function(t4, e4, r4) {
              var n3 = r4(9130), i2 = r4(9662);
              function a(t5, e5) {
                var r5 = i2(n3(t5, e5), [e5[e5.length - 1]]);
                return r5[r5.length - 1];
              }
              function o(t5, e5, r5, n4) {
                var i3 = -e5 / (n4 - e5);
                i3 < 0 ? i3 = 0 : i3 > 1 && (i3 = 1);
                for (var a2 = 1 - i3, o2 = t5.length, s = new Array(o2), l = 0; l < o2; ++l)
                  s[l] = i3 * t5[l] + a2 * r5[l];
                return s;
              }
              t4.exports = function(t5, e5) {
                for (var r5 = [], n4 = [], i3 = a(t5[t5.length - 1], e5), s = t5[t5.length - 1], l = t5[0], u = 0; u < t5.length; ++u, s = l) {
                  var c = a(l = t5[u], e5);
                  if (i3 < 0 && c > 0 || i3 > 0 && c < 0) {
                    var f2 = o(s, c, l, i3);
                    r5.push(f2), n4.push(f2.slice());
                  }
                  c < 0 ? n4.push(l.slice()) : c > 0 ? r5.push(l.slice()) : (r5.push(l.slice()), n4.push(l.slice())), i3 = c;
                }
                return { positive: r5, negative: n4 };
              }, t4.exports.positive = function(t5, e5) {
                for (var r5 = [], n4 = a(t5[t5.length - 1], e5), i3 = t5[t5.length - 1], s = t5[0], l = 0; l < t5.length; ++l, i3 = s) {
                  var u = a(s = t5[l], e5);
                  (n4 < 0 && u > 0 || n4 > 0 && u < 0) && r5.push(o(i3, u, s, n4)), u >= 0 && r5.push(s.slice()), n4 = u;
                }
                return r5;
              }, t4.exports.negative = function(t5, e5) {
                for (var r5 = [], n4 = a(t5[t5.length - 1], e5), i3 = t5[t5.length - 1], s = t5[0], l = 0; l < t5.length; ++l, i3 = s) {
                  var u = a(s = t5[l], e5);
                  (n4 < 0 && u > 0 || n4 > 0 && u < 0) && r5.push(o(i3, u, s, n4)), u <= 0 && r5.push(s.slice()), n4 = u;
                }
                return r5;
              };
            }, 8974: function(t4, e4, r4) {
              var n3;
              !function() {
                var i2 = { not_string: /[^s]/, not_bool: /[^t]/, not_type: /[^T]/, not_primitive: /[^v]/, number: /[diefg]/, numeric_arg: /[bcdiefguxX]/, json: /[j]/, not_json: /[^j]/, text: /^[^\x25]+/, modulo: /^\x25{2}/, placeholder: /^\x25(?:([1-9]\d*)\$|\(([^)]+)\))?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-gijostTuvxX])/, key: /^([a-z_][a-z_\d]*)/i, key_access: /^\.([a-z_][a-z_\d]*)/i, index_access: /^\[(\d+)\]/, sign: /^[+-]/ };
                function a(t5) {
                  return s(u(t5), arguments);
                }
                function o(t5, e5) {
                  return a.apply(null, [t5].concat(e5 || []));
                }
                function s(t5, e5) {
                  var r5, n4, o2, s2, l2, u2, c, f2, h, p2 = 1, d2 = t5.length, v = "";
                  for (n4 = 0; n4 < d2; n4++)
                    if ("string" == typeof t5[n4])
                      v += t5[n4];
                    else if ("object" == typeof t5[n4]) {
                      if ((s2 = t5[n4]).keys)
                        for (r5 = e5[p2], o2 = 0; o2 < s2.keys.length; o2++) {
                          if (null == r5)
                            throw new Error(a('[sprintf] Cannot access property "%s" of undefined value "%s"', s2.keys[o2], s2.keys[o2 - 1]));
                          r5 = r5[s2.keys[o2]];
                        }
                      else
                        r5 = s2.param_no ? e5[s2.param_no] : e5[p2++];
                      if (i2.not_type.test(s2.type) && i2.not_primitive.test(s2.type) && r5 instanceof Function && (r5 = r5()), i2.numeric_arg.test(s2.type) && "number" != typeof r5 && isNaN(r5))
                        throw new TypeError(a("[sprintf] expecting number but found %T", r5));
                      switch (i2.number.test(s2.type) && (f2 = r5 >= 0), s2.type) {
                        case "b":
                          r5 = parseInt(r5, 10).toString(2);
                          break;
                        case "c":
                          r5 = String.fromCharCode(parseInt(r5, 10));
                          break;
                        case "d":
                        case "i":
                          r5 = parseInt(r5, 10);
                          break;
                        case "j":
                          r5 = JSON.stringify(r5, null, s2.width ? parseInt(s2.width) : 0);
                          break;
                        case "e":
                          r5 = s2.precision ? parseFloat(r5).toExponential(s2.precision) : parseFloat(r5).toExponential();
                          break;
                        case "f":
                          r5 = s2.precision ? parseFloat(r5).toFixed(s2.precision) : parseFloat(r5);
                          break;
                        case "g":
                          r5 = s2.precision ? String(Number(r5.toPrecision(s2.precision))) : parseFloat(r5);
                          break;
                        case "o":
                          r5 = (parseInt(r5, 10) >>> 0).toString(8);
                          break;
                        case "s":
                          r5 = String(r5), r5 = s2.precision ? r5.substring(0, s2.precision) : r5;
                          break;
                        case "t":
                          r5 = String(!!r5), r5 = s2.precision ? r5.substring(0, s2.precision) : r5;
                          break;
                        case "T":
                          r5 = Object.prototype.toString.call(r5).slice(8, -1).toLowerCase(), r5 = s2.precision ? r5.substring(0, s2.precision) : r5;
                          break;
                        case "u":
                          r5 = parseInt(r5, 10) >>> 0;
                          break;
                        case "v":
                          r5 = r5.valueOf(), r5 = s2.precision ? r5.substring(0, s2.precision) : r5;
                          break;
                        case "x":
                          r5 = (parseInt(r5, 10) >>> 0).toString(16);
                          break;
                        case "X":
                          r5 = (parseInt(r5, 10) >>> 0).toString(16).toUpperCase();
                      }
                      i2.json.test(s2.type) ? v += r5 : (!i2.number.test(s2.type) || f2 && !s2.sign ? h = "" : (h = f2 ? "+" : "-", r5 = r5.toString().replace(i2.sign, "")), u2 = s2.pad_char ? "0" === s2.pad_char ? "0" : s2.pad_char.charAt(1) : " ", c = s2.width - (h + r5).length, l2 = s2.width && c > 0 ? u2.repeat(c) : "", v += s2.align ? h + r5 + l2 : "0" === u2 ? h + l2 + r5 : l2 + h + r5);
                    }
                  return v;
                }
                var l = /* @__PURE__ */ Object.create(null);
                function u(t5) {
                  if (l[t5])
                    return l[t5];
                  for (var e5, r5 = t5, n4 = [], a2 = 0; r5; ) {
                    if (null !== (e5 = i2.text.exec(r5)))
                      n4.push(e5[0]);
                    else if (null !== (e5 = i2.modulo.exec(r5)))
                      n4.push("%");
                    else {
                      if (null === (e5 = i2.placeholder.exec(r5)))
                        throw new SyntaxError("[sprintf] unexpected placeholder");
                      if (e5[2]) {
                        a2 |= 1;
                        var o2 = [], s2 = e5[2], u2 = [];
                        if (null === (u2 = i2.key.exec(s2)))
                          throw new SyntaxError("[sprintf] failed to parse named argument key");
                        for (o2.push(u2[1]); "" !== (s2 = s2.substring(u2[0].length)); )
                          if (null !== (u2 = i2.key_access.exec(s2)))
                            o2.push(u2[1]);
                          else {
                            if (null === (u2 = i2.index_access.exec(s2)))
                              throw new SyntaxError("[sprintf] failed to parse named argument key");
                            o2.push(u2[1]);
                          }
                        e5[2] = o2;
                      } else
                        a2 |= 2;
                      if (3 === a2)
                        throw new Error("[sprintf] mixing positional and named placeholders is not (yet) supported");
                      n4.push({ placeholder: e5[0], param_no: e5[1], keys: e5[2], sign: e5[3], pad_char: e5[4], align: e5[5], width: e5[6], precision: e5[7], type: e5[8] });
                    }
                    r5 = r5.substring(e5[0].length);
                  }
                  return l[t5] = n4;
                }
                e4.sprintf = a, e4.vsprintf = o, "undefined" != typeof window && (window.sprintf = a, window.vsprintf = o, void 0 === (n3 = function() {
                  return { sprintf: a, vsprintf: o };
                }.call(e4, r4, e4, t4)) || (t4.exports = n3));
              }();
            }, 4162: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                if (t5.dimension <= 0)
                  return { positions: [], cells: [] };
                if (1 === t5.dimension)
                  return function(t6, e6) {
                    for (var r6 = i2(t6, e6), n4 = r6.length, a2 = new Array(n4), o2 = new Array(n4), s2 = 0; s2 < n4; ++s2)
                      a2[s2] = [r6[s2]], o2[s2] = [s2];
                    return { positions: a2, cells: o2 };
                  }(t5, e5);
                var r5 = t5.order.join() + "-" + t5.dtype, s = o[r5];
                return e5 = +e5 || 0, s || (s = o[r5] = function(t6, e6) {
                  var r6 = t6.length + "d", i3 = a[r6];
                  if (i3)
                    return i3(n3, t6, e6);
                }(t5.order, t5.dtype)), s(t5, e5);
              };
              var n3 = r4(9284), i2 = r4(9584), a = { "2d": function(t5, e5, r5) {
                var n4 = t5({ order: e5, scalarArguments: 3, getters: "generic" === r5 ? [0] : void 0, phase: function(t6, e6, r6, n5) {
                  return t6 > n5 | 0;
                }, vertex: function(t6, e6, r6, n5, i3, a2, o2, s, l, u, c, f2, h) {
                  var p2 = (o2 << 0) + (s << 1) + (l << 2) + (u << 3) | 0;
                  if (0 !== p2 && 15 !== p2)
                    switch (p2) {
                      case 0:
                      case 15:
                        c.push([t6 - 0.5, e6 - 0.5]);
                        break;
                      case 1:
                        c.push([t6 - 0.25 - 0.25 * (n5 + r6 - 2 * h) / (r6 - n5), e6 - 0.25 - 0.25 * (i3 + r6 - 2 * h) / (r6 - i3)]);
                        break;
                      case 2:
                        c.push([t6 - 0.75 - 0.25 * (-n5 - r6 + 2 * h) / (n5 - r6), e6 - 0.25 - 0.25 * (a2 + n5 - 2 * h) / (n5 - a2)]);
                        break;
                      case 3:
                        c.push([t6 - 0.5, e6 - 0.5 - 0.5 * (i3 + r6 + a2 + n5 - 4 * h) / (r6 - i3 + n5 - a2)]);
                        break;
                      case 4:
                        c.push([t6 - 0.25 - 0.25 * (a2 + i3 - 2 * h) / (i3 - a2), e6 - 0.75 - 0.25 * (-i3 - r6 + 2 * h) / (i3 - r6)]);
                        break;
                      case 5:
                        c.push([t6 - 0.5 - 0.5 * (n5 + r6 + a2 + i3 - 4 * h) / (r6 - n5 + i3 - a2), e6 - 0.5]);
                        break;
                      case 6:
                        c.push([t6 - 0.5 - 0.25 * (-n5 - r6 + a2 + i3) / (n5 - r6 + i3 - a2), e6 - 0.5 - 0.25 * (-i3 - r6 + a2 + n5) / (i3 - r6 + n5 - a2)]);
                        break;
                      case 7:
                        c.push([t6 - 0.75 - 0.25 * (a2 + i3 - 2 * h) / (i3 - a2), e6 - 0.75 - 0.25 * (a2 + n5 - 2 * h) / (n5 - a2)]);
                        break;
                      case 8:
                        c.push([t6 - 0.75 - 0.25 * (-a2 - i3 + 2 * h) / (a2 - i3), e6 - 0.75 - 0.25 * (-a2 - n5 + 2 * h) / (a2 - n5)]);
                        break;
                      case 9:
                        c.push([t6 - 0.5 - 0.25 * (n5 + r6 + -a2 - i3) / (r6 - n5 + a2 - i3), e6 - 0.5 - 0.25 * (i3 + r6 + -a2 - n5) / (r6 - i3 + a2 - n5)]);
                        break;
                      case 10:
                        c.push([t6 - 0.5 - 0.5 * (-n5 - r6 - a2 - i3 + 4 * h) / (n5 - r6 + a2 - i3), e6 - 0.5]);
                        break;
                      case 11:
                        c.push([t6 - 0.25 - 0.25 * (-a2 - i3 + 2 * h) / (a2 - i3), e6 - 0.75 - 0.25 * (i3 + r6 - 2 * h) / (r6 - i3)]);
                        break;
                      case 12:
                        c.push([t6 - 0.5, e6 - 0.5 - 0.5 * (-i3 - r6 - a2 - n5 + 4 * h) / (i3 - r6 + a2 - n5)]);
                        break;
                      case 13:
                        c.push([t6 - 0.75 - 0.25 * (n5 + r6 - 2 * h) / (r6 - n5), e6 - 0.25 - 0.25 * (-a2 - n5 + 2 * h) / (a2 - n5)]);
                        break;
                      case 14:
                        c.push([t6 - 0.25 - 0.25 * (-n5 - r6 + 2 * h) / (n5 - r6), e6 - 0.25 - 0.25 * (-i3 - r6 + 2 * h) / (i3 - r6)]);
                    }
                }, cell: function(t6, e6, r6, n5, i3, a2, o2, s, l) {
                  i3 ? s.push([t6, e6]) : s.push([e6, t6]);
                } });
                return function(t6, e6) {
                  var r6 = [], i3 = [];
                  return n4(t6, r6, i3, e6), { positions: r6, cells: i3 };
                };
              } }, o = {};
            }, 6946: function(t4, e4, r4) {
              t4.exports = function t5(e5, r5, i2) {
                i2 = i2 || {};
                var a2 = o[e5];
                a2 || (a2 = o[e5] = { " ": { data: new Float32Array(0), shape: 0.2 } });
                var s = a2[r5];
                if (!s)
                  if (r5.length <= 1 || !/\d/.test(r5))
                    s = a2[r5] = function(t6) {
                      for (var e6 = t6.cells, r6 = t6.positions, n4 = new Float32Array(6 * e6.length), i3 = 0, a3 = 0, o2 = 0; o2 < e6.length; ++o2)
                        for (var s2 = e6[o2], l2 = 0; l2 < 3; ++l2) {
                          var u2 = r6[s2[l2]];
                          n4[i3++] = u2[0], n4[i3++] = u2[1] + 1.4, a3 = Math.max(u2[0], a3);
                        }
                      return { data: n4, shape: a3 };
                    }(n3(r5, { triangles: true, font: e5, textAlign: i2.textAlign || "left", textBaseline: "alphabetic", styletags: { breaklines: true, bolds: true, italics: true, subscripts: true, superscripts: true } }));
                  else {
                    for (var l = r5.split(/(\d|\s)/), u = new Array(l.length), c = 0, f2 = 0, h = 0; h < l.length; ++h)
                      u[h] = t5(e5, l[h]), c += u[h].data.length, f2 += u[h].shape, h > 0 && (f2 += 0.02);
                    var p2 = new Float32Array(c), d2 = 0, v = -0.5 * f2;
                    for (h = 0; h < u.length; ++h) {
                      for (var g2 = u[h].data, y = 0; y < g2.length; y += 2)
                        p2[d2++] = g2[y] + v, p2[d2++] = g2[y + 1];
                      v += u[h].shape + 0.02;
                    }
                    s = a2[r5] = { data: p2, shape: f2 };
                  }
                return s;
              };
              var n3 = r4(875), a = window || i.global || {}, o = a.__TEXT_CACHE || {};
              a.__TEXT_CACHE = {};
            }, 14: function(t4, e4, r4) {
              var n3 = r4(4405);
              function i2(t5, e5) {
                var r5 = n3(getComputedStyle(t5).getPropertyValue(e5));
                return r5[0] * a(r5[1], t5);
              }
              function a(t5, e5) {
                switch (e5 = e5 || document.body, t5 = (t5 || "px").trim().toLowerCase(), e5 !== window && e5 !== document || (e5 = document.body), t5) {
                  case "%":
                    return e5.clientHeight / 100;
                  case "ch":
                  case "ex":
                    return function(t6, e6) {
                      var r5 = document.createElement("div");
                      r5.style["font-size"] = "128" + t6, e6.appendChild(r5);
                      var n4 = i2(r5, "font-size") / 128;
                      return e6.removeChild(r5), n4;
                    }(t5, e5);
                  case "em":
                    return i2(e5, "font-size");
                  case "rem":
                    return i2(document.body, "font-size");
                  case "vw":
                    return window.innerWidth / 100;
                  case "vh":
                    return window.innerHeight / 100;
                  case "vmin":
                    return Math.min(window.innerWidth, window.innerHeight) / 100;
                  case "vmax":
                    return Math.max(window.innerWidth, window.innerHeight) / 100;
                  case "in":
                    return 96;
                  case "cm":
                    return 96 / 2.54;
                  case "mm":
                    return 96 / 25.4;
                  case "pt":
                    return 96 / 72;
                  case "pc":
                    return 16;
                }
                return 1;
              }
              t4.exports = a;
            }, 3440: function(t4, e4, r4) {
              t4.exports = function(t5) {
                var e5 = (t5 = t5 || {}).center || [0, 0, 0], r5 = t5.up || [0, 1, 0], n4 = t5.right || f2(r5), i3 = t5.radius || 1, a2 = t5.theta || 0, c2 = t5.phi || 0;
                if (e5 = [].slice.call(e5, 0, 3), r5 = [].slice.call(r5, 0, 3), s(r5, r5), n4 = [].slice.call(n4, 0, 3), s(n4, n4), "eye" in t5) {
                  var p3 = t5.eye, d3 = [p3[0] - e5[0], p3[1] - e5[1], p3[2] - e5[2]];
                  o(n4, d3, r5), u(n4[0], n4[1], n4[2]) < 1e-6 ? n4 = f2(r5) : s(n4, n4), i3 = u(d3[0], d3[1], d3[2]);
                  var v = l(r5, d3) / i3, g2 = l(n4, d3) / i3;
                  c2 = Math.acos(v), a2 = Math.acos(g2);
                }
                return i3 = Math.log(i3), new h(t5.zoomMin, t5.zoomMax, e5, r5, n4, i3, a2, c2);
              };
              var n3 = r4(8444), i2 = r4(7437), a = r4(4422), o = r4(903), s = r4(899), l = r4(9305);
              function u(t5, e5, r5) {
                return Math.sqrt(Math.pow(t5, 2) + Math.pow(e5, 2) + Math.pow(r5, 2));
              }
              function c(t5) {
                return Math.min(1, Math.max(-1, t5));
              }
              function f2(t5) {
                var e5 = Math.abs(t5[0]), r5 = Math.abs(t5[1]), n4 = Math.abs(t5[2]), i3 = [0, 0, 0];
                e5 > Math.max(r5, n4) ? i3[2] = 1 : r5 > Math.max(e5, n4) ? i3[0] = 1 : i3[1] = 1;
                for (var a2 = 0, o2 = 0, l2 = 0; l2 < 3; ++l2)
                  a2 += t5[l2] * t5[l2], o2 += i3[l2] * t5[l2];
                for (l2 = 0; l2 < 3; ++l2)
                  i3[l2] -= o2 / a2 * t5[l2];
                return s(i3, i3), i3;
              }
              function h(t5, e5, r5, i3, a2, o2, s2, l2) {
                this.center = n3(r5), this.up = n3(i3), this.right = n3(a2), this.radius = n3([o2]), this.angle = n3([s2, l2]), this.angle.bounds = [[-1 / 0, -Math.PI / 2], [1 / 0, Math.PI / 2]], this.setDistanceLimits(t5, e5), this.computedCenter = this.center.curve(0), this.computedUp = this.up.curve(0), this.computedRight = this.right.curve(0), this.computedRadius = this.radius.curve(0), this.computedAngle = this.angle.curve(0), this.computedToward = [0, 0, 0], this.computedEye = [0, 0, 0], this.computedMatrix = new Array(16);
                for (var u2 = 0; u2 < 16; ++u2)
                  this.computedMatrix[u2] = 0.5;
                this.recalcMatrix(0);
              }
              var p2 = h.prototype;
              p2.setDistanceLimits = function(t5, e5) {
                t5 = t5 > 0 ? Math.log(t5) : -1 / 0, e5 = e5 > 0 ? Math.log(e5) : 1 / 0, e5 = Math.max(e5, t5), this.radius.bounds[0][0] = t5, this.radius.bounds[1][0] = e5;
              }, p2.getDistanceLimits = function(t5) {
                var e5 = this.radius.bounds[0];
                return t5 ? (t5[0] = Math.exp(e5[0][0]), t5[1] = Math.exp(e5[1][0]), t5) : [Math.exp(e5[0][0]), Math.exp(e5[1][0])];
              }, p2.recalcMatrix = function(t5) {
                this.center.curve(t5), this.up.curve(t5), this.right.curve(t5), this.radius.curve(t5), this.angle.curve(t5);
                for (var e5 = this.computedUp, r5 = this.computedRight, n4 = 0, i3 = 0, a2 = 0; a2 < 3; ++a2)
                  i3 += e5[a2] * r5[a2], n4 += e5[a2] * e5[a2];
                var l2 = Math.sqrt(n4), c2 = 0;
                for (a2 = 0; a2 < 3; ++a2)
                  r5[a2] -= e5[a2] * i3 / n4, c2 += r5[a2] * r5[a2], e5[a2] /= l2;
                var f3 = Math.sqrt(c2);
                for (a2 = 0; a2 < 3; ++a2)
                  r5[a2] /= f3;
                var h2 = this.computedToward;
                o(h2, e5, r5), s(h2, h2);
                var p3 = Math.exp(this.computedRadius[0]), d3 = this.computedAngle[0], v = this.computedAngle[1], g2 = Math.cos(d3), y = Math.sin(d3), m2 = Math.cos(v), x = Math.sin(v), b = this.computedCenter, _ = g2 * m2, w2 = y * m2, T = x, k = -g2 * x, A = -y * x, M = m2, S = this.computedEye, E = this.computedMatrix;
                for (a2 = 0; a2 < 3; ++a2) {
                  var L = _ * r5[a2] + w2 * h2[a2] + T * e5[a2];
                  E[4 * a2 + 1] = k * r5[a2] + A * h2[a2] + M * e5[a2], E[4 * a2 + 2] = L, E[4 * a2 + 3] = 0;
                }
                var C = E[1], P = E[5], O = E[9], I = E[2], D = E[6], z = E[10], R = P * z - O * D, F = O * I - C * z, B = C * D - P * I, N = u(R, F, B);
                for (R /= N, F /= N, B /= N, E[0] = R, E[4] = F, E[8] = B, a2 = 0; a2 < 3; ++a2)
                  S[a2] = b[a2] + E[2 + 4 * a2] * p3;
                for (a2 = 0; a2 < 3; ++a2) {
                  c2 = 0;
                  for (var j = 0; j < 3; ++j)
                    c2 += E[a2 + 4 * j] * S[j];
                  E[12 + a2] = -c2;
                }
                E[15] = 1;
              }, p2.getMatrix = function(t5, e5) {
                this.recalcMatrix(t5);
                var r5 = this.computedMatrix;
                if (e5) {
                  for (var n4 = 0; n4 < 16; ++n4)
                    e5[n4] = r5[n4];
                  return e5;
                }
                return r5;
              };
              var d2 = [0, 0, 0];
              p2.rotate = function(t5, e5, r5, n4) {
                if (this.angle.move(t5, e5, r5), n4) {
                  this.recalcMatrix(t5);
                  var i3 = this.computedMatrix;
                  d2[0] = i3[2], d2[1] = i3[6], d2[2] = i3[10];
                  for (var o2 = this.computedUp, s2 = this.computedRight, l2 = this.computedToward, u2 = 0; u2 < 3; ++u2)
                    i3[4 * u2] = o2[u2], i3[4 * u2 + 1] = s2[u2], i3[4 * u2 + 2] = l2[u2];
                  for (a(i3, i3, n4, d2), u2 = 0; u2 < 3; ++u2)
                    o2[u2] = i3[4 * u2], s2[u2] = i3[4 * u2 + 1];
                  this.up.set(t5, o2[0], o2[1], o2[2]), this.right.set(t5, s2[0], s2[1], s2[2]);
                }
              }, p2.pan = function(t5, e5, r5, n4) {
                e5 = e5 || 0, r5 = r5 || 0, n4 = n4 || 0, this.recalcMatrix(t5);
                var i3 = this.computedMatrix, a2 = (Math.exp(this.computedRadius[0]), i3[1]), o2 = i3[5], s2 = i3[9], l2 = u(a2, o2, s2);
                a2 /= l2, o2 /= l2, s2 /= l2;
                var c2 = i3[0], f3 = i3[4], h2 = i3[8], p3 = c2 * a2 + f3 * o2 + h2 * s2, d3 = u(c2 -= a2 * p3, f3 -= o2 * p3, h2 -= s2 * p3), v = (c2 /= d3) * e5 + a2 * r5, g2 = (f3 /= d3) * e5 + o2 * r5, y = (h2 /= d3) * e5 + s2 * r5;
                this.center.move(t5, v, g2, y);
                var m2 = Math.exp(this.computedRadius[0]);
                m2 = Math.max(1e-4, m2 + n4), this.radius.set(t5, Math.log(m2));
              }, p2.translate = function(t5, e5, r5, n4) {
                this.center.move(t5, e5 || 0, r5 || 0, n4 || 0);
              }, p2.setMatrix = function(t5, e5, r5, n4) {
                var a2 = 1;
                "number" == typeof r5 && (a2 = 0 | r5), (a2 < 0 || a2 > 3) && (a2 = 1);
                var o2 = (a2 + 2) % 3;
                e5 || (this.recalcMatrix(t5), e5 = this.computedMatrix);
                var s2 = e5[a2], l2 = e5[a2 + 4], f3 = e5[a2 + 8];
                if (n4) {
                  var h2 = Math.abs(s2), p3 = Math.abs(l2), d3 = Math.abs(f3), v = Math.max(h2, p3, d3);
                  h2 === v ? (s2 = s2 < 0 ? -1 : 1, l2 = f3 = 0) : d3 === v ? (f3 = f3 < 0 ? -1 : 1, s2 = l2 = 0) : (l2 = l2 < 0 ? -1 : 1, s2 = f3 = 0);
                } else {
                  var g2 = u(s2, l2, f3);
                  s2 /= g2, l2 /= g2, f3 /= g2;
                }
                var y, m2, x = e5[o2], b = e5[o2 + 4], _ = e5[o2 + 8], w2 = x * s2 + b * l2 + _ * f3, T = u(x -= s2 * w2, b -= l2 * w2, _ -= f3 * w2), k = l2 * (_ /= T) - f3 * (b /= T), A = f3 * (x /= T) - s2 * _, M = s2 * b - l2 * x, S = u(k, A, M);
                if (k /= S, A /= S, M /= S, this.center.jump(t5, q2, G, Z), this.radius.idle(t5), this.up.jump(t5, s2, l2, f3), this.right.jump(t5, x, b, _), 2 === a2) {
                  var E = e5[1], L = e5[5], C = e5[9], P = E * x + L * b + C * _, O = E * k + L * A + C * M;
                  y = R < 0 ? -Math.PI / 2 : Math.PI / 2, m2 = Math.atan2(O, P);
                } else {
                  var I = e5[2], D = e5[6], z = e5[10], R = I * s2 + D * l2 + z * f3, F = I * x + D * b + z * _, B = I * k + D * A + z * M;
                  y = Math.asin(c(R)), m2 = Math.atan2(B, F);
                }
                this.angle.jump(t5, m2, y), this.recalcMatrix(t5);
                var N = e5[2], j = e5[6], U = e5[10], V = this.computedMatrix;
                i2(V, e5);
                var H = V[15], q2 = V[12] / H, G = V[13] / H, Z = V[14] / H, Y = Math.exp(this.computedRadius[0]);
                this.center.jump(t5, q2 - N * Y, G - j * Y, Z - U * Y);
              }, p2.lastT = function() {
                return Math.max(this.center.lastT(), this.up.lastT(), this.right.lastT(), this.radius.lastT(), this.angle.lastT());
              }, p2.idle = function(t5) {
                this.center.idle(t5), this.up.idle(t5), this.right.idle(t5), this.radius.idle(t5), this.angle.idle(t5);
              }, p2.flush = function(t5) {
                this.center.flush(t5), this.up.flush(t5), this.right.flush(t5), this.radius.flush(t5), this.angle.flush(t5);
              }, p2.setDistance = function(t5, e5) {
                e5 > 0 && this.radius.set(t5, Math.log(e5));
              }, p2.lookAt = function(t5, e5, r5, n4) {
                this.recalcMatrix(t5), e5 = e5 || this.computedEye, r5 = r5 || this.computedCenter;
                var i3 = (n4 = n4 || this.computedUp)[0], a2 = n4[1], o2 = n4[2], s2 = u(i3, a2, o2);
                if (!(s2 < 1e-6)) {
                  i3 /= s2, a2 /= s2, o2 /= s2;
                  var l2 = e5[0] - r5[0], f3 = e5[1] - r5[1], h2 = e5[2] - r5[2], p3 = u(l2, f3, h2);
                  if (!(p3 < 1e-6)) {
                    l2 /= p3, f3 /= p3, h2 /= p3;
                    var d3 = this.computedRight, v = d3[0], g2 = d3[1], y = d3[2], m2 = i3 * v + a2 * g2 + o2 * y, x = u(v -= m2 * i3, g2 -= m2 * a2, y -= m2 * o2);
                    if (!(x < 0.01 && (x = u(v = a2 * h2 - o2 * f3, g2 = o2 * l2 - i3 * h2, y = i3 * f3 - a2 * l2)) < 1e-6)) {
                      v /= x, g2 /= x, y /= x, this.up.set(t5, i3, a2, o2), this.right.set(t5, v, g2, y), this.center.set(t5, r5[0], r5[1], r5[2]), this.radius.set(t5, Math.log(p3));
                      var b = a2 * y - o2 * g2, _ = o2 * v - i3 * y, w2 = i3 * g2 - a2 * v, T = u(b, _, w2), k = i3 * l2 + a2 * f3 + o2 * h2, A = v * l2 + g2 * f3 + y * h2, M = (b /= T) * l2 + (_ /= T) * f3 + (w2 /= T) * h2, S = Math.asin(c(k)), E = Math.atan2(M, A), L = this.angle._state, C = L[L.length - 1], P = L[L.length - 2];
                      C %= 2 * Math.PI;
                      var O = Math.abs(C + 2 * Math.PI - E), I = Math.abs(C - E), D = Math.abs(C - 2 * Math.PI - E);
                      O < I && (C += 2 * Math.PI), D < I && (C -= 2 * Math.PI), this.angle.jump(this.angle.lastT(), C, P), this.angle.set(t5, E, S);
                    }
                  }
                }
              };
            }, 9660: function(t4) {
              t4.exports = function(t5, r4, n3) {
                var i2 = t5 * r4, a = e4 * t5, o = a - (a - t5), s = t5 - o, l = e4 * r4, u = l - (l - r4), c = r4 - u, f2 = s * c - (i2 - o * u - s * u - o * c);
                return n3 ? (n3[0] = f2, n3[1] = i2, n3) : [f2, i2];
              };
              var e4 = +(Math.pow(2, 27) + 1);
            }, 87: function(t4) {
              t4.exports = function(t5, e4, r4) {
                var n3 = t5 + e4, i2 = n3 - t5, a = e4 - i2, o = t5 - (n3 - i2);
                return r4 ? (r4[0] = o + a, r4[1] = n3, r4) : [o + a, n3];
              };
            }, 5306: function(t4, e4, r4) {
              var n3 = r4(2288), i2 = r4(3094), a = r4(2146).lW;
              r4.g.__TYPEDARRAY_POOL || (r4.g.__TYPEDARRAY_POOL = { UINT8: i2([32, 0]), UINT16: i2([32, 0]), UINT32: i2([32, 0]), BIGUINT64: i2([32, 0]), INT8: i2([32, 0]), INT16: i2([32, 0]), INT32: i2([32, 0]), BIGINT64: i2([32, 0]), FLOAT: i2([32, 0]), DOUBLE: i2([32, 0]), DATA: i2([32, 0]), UINT8C: i2([32, 0]), BUFFER: i2([32, 0]) });
              var o = "undefined" != typeof Uint8ClampedArray, s = "undefined" != typeof BigUint64Array, l = "undefined" != typeof BigInt64Array, u = r4.g.__TYPEDARRAY_POOL;
              u.UINT8C || (u.UINT8C = i2([32, 0])), u.BIGUINT64 || (u.BIGUINT64 = i2([32, 0])), u.BIGINT64 || (u.BIGINT64 = i2([32, 0])), u.BUFFER || (u.BUFFER = i2([32, 0]));
              var c = u.DATA, f2 = u.BUFFER;
              function h(t5) {
                if (t5) {
                  var e5 = t5.length || t5.byteLength, r5 = n3.log2(e5);
                  c[r5].push(t5);
                }
              }
              function p2(t5) {
                t5 = n3.nextPow2(t5);
                var e5 = n3.log2(t5), r5 = c[e5];
                return r5.length > 0 ? r5.pop() : new ArrayBuffer(t5);
              }
              function d2(t5) {
                return new Uint8Array(p2(t5), 0, t5);
              }
              function v(t5) {
                return new Uint16Array(p2(2 * t5), 0, t5);
              }
              function g2(t5) {
                return new Uint32Array(p2(4 * t5), 0, t5);
              }
              function y(t5) {
                return new Int8Array(p2(t5), 0, t5);
              }
              function m2(t5) {
                return new Int16Array(p2(2 * t5), 0, t5);
              }
              function x(t5) {
                return new Int32Array(p2(4 * t5), 0, t5);
              }
              function b(t5) {
                return new Float32Array(p2(4 * t5), 0, t5);
              }
              function _(t5) {
                return new Float64Array(p2(8 * t5), 0, t5);
              }
              function w2(t5) {
                return o ? new Uint8ClampedArray(p2(t5), 0, t5) : d2(t5);
              }
              function T(t5) {
                return s ? new BigUint64Array(p2(8 * t5), 0, t5) : null;
              }
              function k(t5) {
                return l ? new BigInt64Array(p2(8 * t5), 0, t5) : null;
              }
              function A(t5) {
                return new DataView(p2(t5), 0, t5);
              }
              function M(t5) {
                t5 = n3.nextPow2(t5);
                var e5 = n3.log2(t5), r5 = f2[e5];
                return r5.length > 0 ? r5.pop() : new a(t5);
              }
              e4.free = function(t5) {
                if (a.isBuffer(t5))
                  f2[n3.log2(t5.length)].push(t5);
                else {
                  if ("[object ArrayBuffer]" !== Object.prototype.toString.call(t5) && (t5 = t5.buffer), !t5)
                    return;
                  var e5 = t5.length || t5.byteLength, r5 = 0 | n3.log2(e5);
                  c[r5].push(t5);
                }
              }, e4.freeUint8 = e4.freeUint16 = e4.freeUint32 = e4.freeBigUint64 = e4.freeInt8 = e4.freeInt16 = e4.freeInt32 = e4.freeBigInt64 = e4.freeFloat32 = e4.freeFloat = e4.freeFloat64 = e4.freeDouble = e4.freeUint8Clamped = e4.freeDataView = function(t5) {
                h(t5.buffer);
              }, e4.freeArrayBuffer = h, e4.freeBuffer = function(t5) {
                f2[n3.log2(t5.length)].push(t5);
              }, e4.malloc = function(t5, e5) {
                if (void 0 === e5 || "arraybuffer" === e5)
                  return p2(t5);
                switch (e5) {
                  case "uint8":
                    return d2(t5);
                  case "uint16":
                    return v(t5);
                  case "uint32":
                    return g2(t5);
                  case "int8":
                    return y(t5);
                  case "int16":
                    return m2(t5);
                  case "int32":
                    return x(t5);
                  case "float":
                  case "float32":
                    return b(t5);
                  case "double":
                  case "float64":
                    return _(t5);
                  case "uint8_clamped":
                    return w2(t5);
                  case "bigint64":
                    return k(t5);
                  case "biguint64":
                    return T(t5);
                  case "buffer":
                    return M(t5);
                  case "data":
                  case "dataview":
                    return A(t5);
                  default:
                    return null;
                }
                return null;
              }, e4.mallocArrayBuffer = p2, e4.mallocUint8 = d2, e4.mallocUint16 = v, e4.mallocUint32 = g2, e4.mallocInt8 = y, e4.mallocInt16 = m2, e4.mallocInt32 = x, e4.mallocFloat32 = e4.mallocFloat = b, e4.mallocFloat64 = e4.mallocDouble = _, e4.mallocUint8Clamped = w2, e4.mallocBigUint64 = T, e4.mallocBigInt64 = k, e4.mallocDataView = A, e4.mallocBuffer = M, e4.clearCache = function() {
                for (var t5 = 0; t5 < 32; ++t5)
                  u.UINT8[t5].length = 0, u.UINT16[t5].length = 0, u.UINT32[t5].length = 0, u.INT8[t5].length = 0, u.INT16[t5].length = 0, u.INT32[t5].length = 0, u.FLOAT[t5].length = 0, u.DOUBLE[t5].length = 0, u.BIGUINT64[t5].length = 0, u.BIGINT64[t5].length = 0, u.UINT8C[t5].length = 0, c[t5].length = 0, f2[t5].length = 0;
              };
            }, 1731: function(t4) {
              function e4(t5) {
                this.roots = new Array(t5), this.ranks = new Array(t5);
                for (var e5 = 0; e5 < t5; ++e5)
                  this.roots[e5] = e5, this.ranks[e5] = 0;
              }
              t4.exports = e4;
              var r4 = e4.prototype;
              Object.defineProperty(r4, "length", { get: function() {
                return this.roots.length;
              } }), r4.makeSet = function() {
                var t5 = this.roots.length;
                return this.roots.push(t5), this.ranks.push(0), t5;
              }, r4.find = function(t5) {
                for (var e5 = t5, r5 = this.roots; r5[t5] !== t5; )
                  t5 = r5[t5];
                for (; r5[e5] !== t5; ) {
                  var n3 = r5[e5];
                  r5[e5] = t5, e5 = n3;
                }
                return t5;
              }, r4.link = function(t5, e5) {
                var r5 = this.find(t5), n3 = this.find(e5);
                if (r5 !== n3) {
                  var i2 = this.ranks, a = this.roots, o = i2[r5], s = i2[n3];
                  o < s ? a[r5] = n3 : s < o ? a[n3] = r5 : (a[n3] = r5, ++i2[r5]);
                }
              };
            }, 1215: function(t4) {
              t4.exports = function(t5, e4, r4) {
                return 0 === t5.length ? t5 : e4 ? (r4 || t5.sort(e4), function(t6, e5) {
                  for (var r5 = 1, n3 = t6.length, i2 = t6[0], a = t6[0], o = 1; o < n3; ++o)
                    if (a = i2, e5(i2 = t6[o], a)) {
                      if (o === r5) {
                        r5++;
                        continue;
                      }
                      t6[r5++] = i2;
                    }
                  return t6.length = r5, t6;
                }(t5, e4)) : (r4 || t5.sort(), function(t6) {
                  for (var e5 = 1, r5 = t6.length, n3 = t6[0], i2 = t6[0], a = 1; a < r5; ++a, i2 = n3)
                    if (i2 = n3, (n3 = t6[a]) !== i2) {
                      if (a === e5) {
                        e5++;
                        continue;
                      }
                      t6[e5++] = n3;
                    }
                  return t6.length = e5, t6;
                }(t5));
              };
            }, 875: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                return "object" == typeof e5 && null !== e5 || (e5 = {}), n3(t5, e5.canvas || i2, e5.context || a, e5);
              };
              var n3 = r4(712), i2 = null, a = null;
              "undefined" != typeof document && ((i2 = document.createElement("canvas")).width = 8192, i2.height = 1024, a = i2.getContext("2d"));
            }, 712: function(t4, e4, r4) {
              t4.exports = function(t5, e5, r5, n4) {
                var a2 = 64, o2 = 1.25, s2 = { breaklines: false, bolds: false, italics: false, subscripts: false, superscripts: false };
                return n4 && (n4.size && n4.size > 0 && (a2 = n4.size), n4.lineSpacing && n4.lineSpacing > 0 && (o2 = n4.lineSpacing), n4.styletags && n4.styletags.breaklines && (s2.breaklines = !!n4.styletags.breaklines), n4.styletags && n4.styletags.bolds && (s2.bolds = !!n4.styletags.bolds), n4.styletags && n4.styletags.italics && (s2.italics = !!n4.styletags.italics), n4.styletags && n4.styletags.subscripts && (s2.subscripts = !!n4.styletags.subscripts), n4.styletags && n4.styletags.superscripts && (s2.superscripts = !!n4.styletags.superscripts)), r5.font = [n4.fontStyle, n4.fontVariant, n4.fontWeight, a2 + "px", n4.font].filter(function(t6) {
                  return t6;
                }).join(" "), r5.textAlign = "start", r5.textBaseline = "alphabetic", r5.direction = "ltr", d2(function(t6, e6, r6, n5, a3, o3) {
                  r6 = r6.replace(/\n/g, ""), r6 = true === o3.breaklines ? r6.replace(/\<br\>/g, "\n") : r6.replace(/\<br\>/g, " ");
                  var s3 = "", l2 = [];
                  for (v = 0; v < r6.length; ++v)
                    l2[v] = s3;
                  true === o3.bolds && (l2 = f2("b", u, r6, l2)), true === o3.italics && (l2 = f2("i", c, r6, l2)), true === o3.superscripts && (l2 = f2("sup", "+1", r6, l2)), true === o3.subscripts && (l2 = f2("sub", "-1", r6, l2));
                  var h2 = [], p3 = "";
                  for (v = 0; v < r6.length; ++v)
                    null !== l2[v] && (p3 += r6[v], h2.push(l2[v]));
                  var d3, v, g2, y, m2, x = p3.split("\n"), b = x.length, _ = Math.round(a3 * n5), w2 = n5, T = 2 * n5, k = 0, A = b * _ + T;
                  t6.height < A && (t6.height = A), e6.fillStyle = "#000", e6.fillRect(0, 0, t6.width, t6.height), e6.fillStyle = "#fff";
                  var M = 0, S = "";
                  function E() {
                    if ("" !== S) {
                      var t7 = e6.measureText(S).width;
                      e6.fillText(S, w2 + g2, T + y), g2 += t7;
                    }
                  }
                  function L() {
                    return Math.round(m2) + "px ";
                  }
                  function C(t7, r7) {
                    var n6 = "" + e6.font;
                    if (true === o3.subscripts) {
                      var i3 = t7.indexOf("-"), a4 = r7.indexOf("-"), s4 = i3 > -1 ? parseInt(t7[1 + i3]) : 0, l3 = a4 > -1 ? parseInt(r7[1 + a4]) : 0;
                      s4 !== l3 && (n6 = n6.replace(L(), "?px "), m2 *= Math.pow(0.75, l3 - s4), n6 = n6.replace("?px ", L())), y += 0.25 * _ * (l3 - s4);
                    }
                    if (true === o3.superscripts) {
                      var f3 = t7.indexOf("+"), h3 = r7.indexOf("+"), p4 = f3 > -1 ? parseInt(t7[1 + f3]) : 0, d4 = h3 > -1 ? parseInt(r7[1 + h3]) : 0;
                      p4 !== d4 && (n6 = n6.replace(L(), "?px "), m2 *= Math.pow(0.75, d4 - p4), n6 = n6.replace("?px ", L())), y -= 0.25 * _ * (d4 - p4);
                    }
                    if (true === o3.bolds) {
                      var v2 = t7.indexOf(u) > -1, g3 = r7.indexOf(u) > -1;
                      !v2 && g3 && (n6 = x2 ? n6.replace("italic ", "italic bold ") : "bold " + n6), v2 && !g3 && (n6 = n6.replace("bold ", ""));
                    }
                    if (true === o3.italics) {
                      var x2 = t7.indexOf(c) > -1, b2 = r7.indexOf(c) > -1;
                      !x2 && b2 && (n6 = "italic " + n6), x2 && !b2 && (n6 = n6.replace("italic ", ""));
                    }
                    e6.font = n6;
                  }
                  for (d3 = 0; d3 < b; ++d3) {
                    var P = x[d3] + "\n";
                    for (g2 = 0, y = d3 * _, m2 = n5, S = "", v = 0; v < P.length; ++v) {
                      var O = v + M < h2.length ? h2[v + M] : h2[h2.length - 1];
                      s3 === O ? S += P[v] : (E(), S = P[v], void 0 !== O && (C(s3, O), s3 = O));
                    }
                    E(), M += P.length;
                    var I = 0 | Math.round(g2 + 2 * w2);
                    k < I && (k = I);
                  }
                  var D = k, z = T + _ * b;
                  return i2(e6.getImageData(0, 0, D, z).data, [z, D, 4]).pick(-1, -1, 0).transpose(1, 0);
                }(e5, r5, t5, a2, o2, s2), n4, a2);
              }, t4.exports.processPixels = d2;
              var n3 = r4(4162), i2 = r4(5050), a = r4(8243), o = r4(197), s = r4(7761), l = r4(8040), u = "b|", c = "i|";
              function f2(t5, e5, r5, n4) {
                for (var i3 = "<" + t5 + ">", a2 = "</" + t5 + ">", o2 = i3.length, s2 = a2.length, l2 = "+" === e5[0] || "-" === e5[0], u2 = 0, c2 = -s2; u2 > -1 && -1 !== (u2 = r5.indexOf(i3, u2)) && -1 !== (c2 = r5.indexOf(a2, u2 + o2)) && !(c2 <= u2); ) {
                  for (var f3 = u2; f3 < c2 + s2; ++f3)
                    if (f3 < u2 + o2 || f3 >= c2)
                      n4[f3] = null, r5 = r5.substr(0, f3) + " " + r5.substr(f3 + 1);
                    else if (null !== n4[f3]) {
                      var h2 = n4[f3].indexOf(e5[0]);
                      -1 === h2 ? n4[f3] += e5 : l2 && (n4[f3] = n4[f3].substr(0, h2 + 1) + (1 + parseInt(n4[f3][h2 + 1])) + n4[f3].substr(h2 + 2));
                    }
                  var p3 = u2 + o2, d3 = r5.substr(p3, c2 - p3).indexOf(i3);
                  u2 = -1 !== d3 ? d3 : c2 + s2;
                }
                return n4;
              }
              function h(t5, e5) {
                var r5 = n3(t5, 128);
                return e5 ? a(r5.cells, r5.positions, 0.25) : { edges: r5.cells, positions: r5.positions };
              }
              function p2(t5, e5, r5, n4) {
                var i3 = h(t5, n4), a2 = function(t6, e6, r6) {
                  for (var n5 = e6.textAlign || "start", i4 = e6.textBaseline || "alphabetic", a3 = [1 << 30, 1 << 30], o2 = [0, 0], s2 = t6.length, l2 = 0; l2 < s2; ++l2)
                    for (var u3 = t6[l2], c3 = 0; c3 < 2; ++c3)
                      a3[c3] = 0 | Math.min(a3[c3], u3[c3]), o2[c3] = 0 | Math.max(o2[c3], u3[c3]);
                  var f4 = 0;
                  switch (n5) {
                    case "center":
                      f4 = -0.5 * (a3[0] + o2[0]);
                      break;
                    case "right":
                    case "end":
                      f4 = -o2[0];
                      break;
                    case "left":
                    case "start":
                      f4 = -a3[0];
                      break;
                    default:
                      throw new Error("vectorize-text: Unrecognized textAlign: '" + n5 + "'");
                  }
                  var h2 = 0;
                  switch (i4) {
                    case "hanging":
                    case "top":
                      h2 = -a3[1];
                      break;
                    case "middle":
                      h2 = -0.5 * (a3[1] + o2[1]);
                      break;
                    case "alphabetic":
                    case "ideographic":
                      h2 = -3 * r6;
                      break;
                    case "bottom":
                      h2 = -o2[1];
                      break;
                    default:
                      throw new Error("vectorize-text: Unrecoginized textBaseline: '" + i4 + "'");
                  }
                  var p4 = 1 / r6;
                  return "lineHeight" in e6 ? p4 *= +e6.lineHeight : "width" in e6 ? p4 = e6.width / (o2[0] - a3[0]) : "height" in e6 && (p4 = e6.height / (o2[1] - a3[1])), t6.map(function(t7) {
                    return [p4 * (t7[0] + f4), p4 * (t7[1] + h2)];
                  });
                }(i3.positions, e5, r5), u2 = i3.edges, c2 = "ccw" === e5.orientation;
                if (o(a2, u2), e5.polygons || e5.polygon || e5.polyline) {
                  for (var f3 = l(u2, a2), p3 = new Array(f3.length), d3 = 0; d3 < f3.length; ++d3) {
                    for (var v = f3[d3], g2 = new Array(v.length), y = 0; y < v.length; ++y) {
                      for (var m2 = v[y], x = new Array(m2.length), b = 0; b < m2.length; ++b)
                        x[b] = a2[m2[b]].slice();
                      c2 && x.reverse(), g2[y] = x;
                    }
                    p3[d3] = g2;
                  }
                  return p3;
                }
                return e5.triangles || e5.triangulate || e5.triangle ? { cells: s(a2, u2, { delaunay: false, exterior: false, interior: true }), positions: a2 } : { edges: u2, positions: a2 };
              }
              function d2(t5, e5, r5) {
                try {
                  return p2(t5, e5, r5, true);
                } catch (t6) {
                }
                try {
                  return p2(t5, e5, r5, false);
                } catch (t6) {
                }
                return e5.polygons || e5.polyline || e5.polygon ? [] : e5.triangles || e5.triangulate || e5.triangle ? { cells: [], positions: [] } : { edges: [], positions: [] };
              }
            }, 5346: function(t4) {
              !function() {
                if ("undefined" == typeof ses || !ses.ok || ses.ok()) {
                  "undefined" != typeof ses && (ses.weakMapPermitHostObjects = g2);
                  var e4 = false;
                  if ("function" == typeof WeakMap) {
                    var r4 = WeakMap;
                    if ("undefined" != typeof navigator && /Firefox/.test(navigator.userAgent))
                      ;
                    else {
                      var n3 = new r4(), i2 = Object.freeze({});
                      if (n3.set(i2, 1), 1 === n3.get(i2))
                        return void (t4.exports = WeakMap);
                      e4 = true;
                    }
                  }
                  var a = Object.getOwnPropertyNames, o = Object.defineProperty, s = Object.isExtensible, l = "weakmap:", u = "weakmap:ident:" + Math.random() + "___";
                  if ("undefined" != typeof crypto && "function" == typeof crypto.getRandomValues && "function" == typeof ArrayBuffer && "function" == typeof Uint8Array) {
                    var c = new ArrayBuffer(25), f2 = new Uint8Array(c);
                    crypto.getRandomValues(f2), u = "weakmap:rand:" + Array.prototype.map.call(f2, function(t5) {
                      return (t5 % 36).toString(36);
                    }).join("") + "___";
                  }
                  if (o(Object, "getOwnPropertyNames", { value: function(t5) {
                    return a(t5).filter(y);
                  } }), "getPropertyNames" in Object) {
                    var h = Object.getPropertyNames;
                    o(Object, "getPropertyNames", { value: function(t5) {
                      return h(t5).filter(y);
                    } });
                  }
                  !function() {
                    var t5 = Object.freeze;
                    o(Object, "freeze", { value: function(e6) {
                      return m2(e6), t5(e6);
                    } });
                    var e5 = Object.seal;
                    o(Object, "seal", { value: function(t6) {
                      return m2(t6), e5(t6);
                    } });
                    var r5 = Object.preventExtensions;
                    o(Object, "preventExtensions", { value: function(t6) {
                      return m2(t6), r5(t6);
                    } });
                  }();
                  var p2 = false, d2 = 0, v = function() {
                    this instanceof v || b();
                    var t5 = [], e5 = [], r5 = d2++;
                    return Object.create(v.prototype, { get___: { value: x(function(n4, i3) {
                      var a2, o2 = m2(n4);
                      return o2 ? r5 in o2 ? o2[r5] : i3 : (a2 = t5.indexOf(n4)) >= 0 ? e5[a2] : i3;
                    }) }, has___: { value: x(function(e6) {
                      var n4 = m2(e6);
                      return n4 ? r5 in n4 : t5.indexOf(e6) >= 0;
                    }) }, set___: { value: x(function(n4, i3) {
                      var a2, o2 = m2(n4);
                      return o2 ? o2[r5] = i3 : (a2 = t5.indexOf(n4)) >= 0 ? e5[a2] = i3 : (a2 = t5.length, e5[a2] = i3, t5[a2] = n4), this;
                    }) }, delete___: { value: x(function(n4) {
                      var i3, a2, o2 = m2(n4);
                      return o2 ? r5 in o2 && delete o2[r5] : !((i3 = t5.indexOf(n4)) < 0 || (a2 = t5.length - 1, t5[i3] = void 0, e5[i3] = e5[a2], t5[i3] = t5[a2], t5.length = a2, e5.length = a2, 0));
                    }) } });
                  };
                  v.prototype = Object.create(Object.prototype, { get: { value: function(t5, e5) {
                    return this.get___(t5, e5);
                  }, writable: true, configurable: true }, has: { value: function(t5) {
                    return this.has___(t5);
                  }, writable: true, configurable: true }, set: { value: function(t5, e5) {
                    return this.set___(t5, e5);
                  }, writable: true, configurable: true }, delete: { value: function(t5) {
                    return this.delete___(t5);
                  }, writable: true, configurable: true } }), "function" == typeof r4 ? function() {
                    function n4() {
                      this instanceof v || b();
                      var t5, n5 = new r4(), i3 = void 0, a2 = false;
                      return t5 = e4 ? function(t6, e5) {
                        return n5.set(t6, e5), n5.has(t6) || (i3 || (i3 = new v()), i3.set(t6, e5)), this;
                      } : function(t6, e5) {
                        if (a2)
                          try {
                            n5.set(t6, e5);
                          } catch (r5) {
                            i3 || (i3 = new v()), i3.set___(t6, e5);
                          }
                        else
                          n5.set(t6, e5);
                        return this;
                      }, Object.create(v.prototype, { get___: { value: x(function(t6, e5) {
                        return i3 ? n5.has(t6) ? n5.get(t6) : i3.get___(t6, e5) : n5.get(t6, e5);
                      }) }, has___: { value: x(function(t6) {
                        return n5.has(t6) || !!i3 && i3.has___(t6);
                      }) }, set___: { value: x(t5) }, delete___: { value: x(function(t6) {
                        var e5 = !!n5.delete(t6);
                        return i3 && i3.delete___(t6) || e5;
                      }) }, permitHostObjects___: { value: x(function(t6) {
                        if (t6 !== g2)
                          throw new Error("bogus call to permitHostObjects___");
                        a2 = true;
                      }) } });
                    }
                    e4 && "undefined" != typeof Proxy && (Proxy = void 0), n4.prototype = v.prototype, t4.exports = n4, Object.defineProperty(WeakMap.prototype, "constructor", { value: WeakMap, enumerable: false, configurable: true, writable: true });
                  }() : ("undefined" != typeof Proxy && (Proxy = void 0), t4.exports = v);
                }
                function g2(t5) {
                  t5.permitHostObjects___ && t5.permitHostObjects___(g2);
                }
                function y(t5) {
                  return !(t5.substr(0, l.length) == l && "___" === t5.substr(t5.length - 3));
                }
                function m2(t5) {
                  if (t5 !== Object(t5))
                    throw new TypeError("Not an object: " + t5);
                  var e5 = t5[u];
                  if (e5 && e5.key === t5)
                    return e5;
                  if (s(t5)) {
                    e5 = { key: t5 };
                    try {
                      return o(t5, u, { value: e5, writable: false, enumerable: false, configurable: false }), e5;
                    } catch (t6) {
                      return;
                    }
                  }
                }
                function x(t5) {
                  return t5.prototype = null, Object.freeze(t5);
                }
                function b() {
                  p2 || "undefined" == typeof console || (p2 = true, console.warn("WeakMap should be invoked as new WeakMap(), not WeakMap(). This will be an error in the future."));
                }
              }();
            }, 9222: function(t4, e4, r4) {
              var n3 = r4(7178);
              t4.exports = function() {
                var t5 = {};
                return function(e5) {
                  if (("object" != typeof e5 || null === e5) && "function" != typeof e5)
                    throw new Error("Weakmap-shim: Key must be object");
                  var r5 = e5.valueOf(t5);
                  return r5 && r5.identity === t5 ? r5 : n3(e5, t5);
                };
              };
            }, 7178: function(t4) {
              t4.exports = function(t5, e4) {
                var r4 = { identity: e4 }, n3 = t5.valueOf;
                return Object.defineProperty(t5, "valueOf", { value: function(t6) {
                  return t6 !== e4 ? n3.apply(this, arguments) : r4;
                }, writable: true }), r4;
              };
            }, 4037: function(t4, e4, r4) {
              var n3 = r4(9222);
              t4.exports = function() {
                var t5 = n3();
                return { get: function(e5, r5) {
                  var n4 = t5(e5);
                  return n4.hasOwnProperty("value") ? n4.value : r5;
                }, set: function(e5, r5) {
                  return t5(e5).value = r5, this;
                }, has: function(e5) {
                  return "value" in t5(e5);
                }, delete: function(e5) {
                  return delete t5(e5).value;
                } };
              };
            }, 6183: function(t4) {
              t4.exports = function(t5) {
                var e4 = {};
                return function(r4, n3, i2) {
                  var a = r4.dtype, o = r4.order, s = [a, o.join()].join(), l = e4[s];
                  return l || (e4[s] = l = t5([a, o])), l(r4.shape.slice(0), r4.data, r4.stride, 0 | r4.offset, n3, i2);
                };
              }(function() {
                return function(t5, e4, r4, n3, i2, a) {
                  var o = t5[0], s = r4[0], l = [0], u = s;
                  n3 |= 0;
                  var c = 0, f2 = s;
                  for (c = 0; c < o; ++c) {
                    var h = e4[n3] - a, p2 = e4[n3 + u] - a;
                    h >= 0 != p2 >= 0 && i2.push(l[0] + 0.5 + 0.5 * (h + p2) / (h - p2)), n3 += f2, ++l[0];
                  }
                };
              }.bind(void 0, { funcName: "zeroCrossings" }));
            }, 9584: function(t4, e4, r4) {
              t4.exports = function(t5, e5) {
                var r5 = [];
                return e5 = +e5 || 0, n3(t5.hi(t5.shape[0] - 1), r5, e5), r5;
              };
              var n3 = r4(6183);
            }, 6601: function() {
            } }, e3 = {};
            function r3(n3) {
              var i2 = e3[n3];
              if (void 0 !== i2)
                return i2.exports;
              var a = e3[n3] = { id: n3, loaded: false, exports: {} };
              return t3[n3].call(a.exports, a, a.exports, r3), a.loaded = true, a.exports;
            }
            return r3.g = function() {
              if ("object" == typeof globalThis)
                return globalThis;
              try {
                return this || new Function("return this")();
              } catch (t4) {
                if ("object" == typeof window)
                  return window;
              }
            }(), r3.nmd = function(t4) {
              return t4.paths = [], t4.children || (t4.children = []), t4;
            }, r3(7386);
          }();
        }, t2.exports = n2();
      }, 12856: function(t2, e2, r2) {
        function n2(t3, e3) {
          if (!(t3 instanceof e3))
            throw new TypeError("Cannot call a class as a function");
        }
        function i(t3, e3) {
          for (var r3 = 0; r3 < e3.length; r3++) {
            var n3 = e3[r3];
            n3.enumerable = n3.enumerable || false, n3.configurable = true, "value" in n3 && (n3.writable = true), Object.defineProperty(t3, n3.key, n3);
          }
        }
        function a(t3, e3) {
          return a = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(t4, e4) {
            return t4.__proto__ = e4, t4;
          }, a(t3, e3);
        }
        function o(t3, e3) {
          if (e3 && ("object" === u(e3) || "function" == typeof e3))
            return e3;
          if (void 0 !== e3)
            throw new TypeError("Derived constructors may only return object or undefined");
          return s(t3);
        }
        function s(t3) {
          if (void 0 === t3)
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
          return t3;
        }
        function l(t3) {
          return l = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function(t4) {
            return t4.__proto__ || Object.getPrototypeOf(t4);
          }, l(t3);
        }
        function u(t3) {
          return u = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(t4) {
            return typeof t4;
          } : function(t4) {
            return t4 && "function" == typeof Symbol && t4.constructor === Symbol && t4 !== Symbol.prototype ? "symbol" : typeof t4;
          }, u(t3);
        }
        var c = r2(95341), f2 = r2(95280), h = "function" == typeof Symbol && "function" == typeof Symbol.for ? Symbol.for("nodejs.util.inspect.custom") : null;
        e2.Buffer = v, e2.SlowBuffer = function(t3) {
          return +t3 != t3 && (t3 = 0), v.alloc(+t3);
        }, e2.INSPECT_MAX_BYTES = 50;
        var p2 = 2147483647;
        function d2(t3) {
          if (t3 > p2)
            throw new RangeError('The value "' + t3 + '" is invalid for option "size"');
          var e3 = new Uint8Array(t3);
          return Object.setPrototypeOf(e3, v.prototype), e3;
        }
        function v(t3, e3, r3) {
          if ("number" == typeof t3) {
            if ("string" == typeof e3)
              throw new TypeError('The "string" argument must be of type string. Received type number');
            return m2(t3);
          }
          return g2(t3, e3, r3);
        }
        function g2(t3, e3, r3) {
          if ("string" == typeof t3)
            return function(t4, e4) {
              if ("string" == typeof e4 && "" !== e4 || (e4 = "utf8"), !v.isEncoding(e4))
                throw new TypeError("Unknown encoding: " + e4);
              var r4 = 0 | w2(t4, e4), n4 = d2(r4), i3 = n4.write(t4, e4);
              return i3 !== r4 && (n4 = n4.slice(0, i3)), n4;
            }(t3, e3);
          if (ArrayBuffer.isView(t3))
            return function(t4) {
              if (rt(t4, Uint8Array)) {
                var e4 = new Uint8Array(t4);
                return b(e4.buffer, e4.byteOffset, e4.byteLength);
              }
              return x(t4);
            }(t3);
          if (null == t3)
            throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type " + u(t3));
          if (rt(t3, ArrayBuffer) || t3 && rt(t3.buffer, ArrayBuffer))
            return b(t3, e3, r3);
          if ("undefined" != typeof SharedArrayBuffer && (rt(t3, SharedArrayBuffer) || t3 && rt(t3.buffer, SharedArrayBuffer)))
            return b(t3, e3, r3);
          if ("number" == typeof t3)
            throw new TypeError('The "value" argument must not be of type number. Received type number');
          var n3 = t3.valueOf && t3.valueOf();
          if (null != n3 && n3 !== t3)
            return v.from(n3, e3, r3);
          var i2 = function(t4) {
            if (v.isBuffer(t4)) {
              var e4 = 0 | _(t4.length), r4 = d2(e4);
              return 0 === r4.length || t4.copy(r4, 0, 0, e4), r4;
            }
            return void 0 !== t4.length ? "number" != typeof t4.length || nt(t4.length) ? d2(0) : x(t4) : "Buffer" === t4.type && Array.isArray(t4.data) ? x(t4.data) : void 0;
          }(t3);
          if (i2)
            return i2;
          if ("undefined" != typeof Symbol && null != Symbol.toPrimitive && "function" == typeof t3[Symbol.toPrimitive])
            return v.from(t3[Symbol.toPrimitive]("string"), e3, r3);
          throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type " + u(t3));
        }
        function y(t3) {
          if ("number" != typeof t3)
            throw new TypeError('"size" argument must be of type number');
          if (t3 < 0)
            throw new RangeError('The value "' + t3 + '" is invalid for option "size"');
        }
        function m2(t3) {
          return y(t3), d2(t3 < 0 ? 0 : 0 | _(t3));
        }
        function x(t3) {
          for (var e3 = t3.length < 0 ? 0 : 0 | _(t3.length), r3 = d2(e3), n3 = 0; n3 < e3; n3 += 1)
            r3[n3] = 255 & t3[n3];
          return r3;
        }
        function b(t3, e3, r3) {
          if (e3 < 0 || t3.byteLength < e3)
            throw new RangeError('"offset" is outside of buffer bounds');
          if (t3.byteLength < e3 + (r3 || 0))
            throw new RangeError('"length" is outside of buffer bounds');
          var n3;
          return n3 = void 0 === e3 && void 0 === r3 ? new Uint8Array(t3) : void 0 === r3 ? new Uint8Array(t3, e3) : new Uint8Array(t3, e3, r3), Object.setPrototypeOf(n3, v.prototype), n3;
        }
        function _(t3) {
          if (t3 >= p2)
            throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x" + p2.toString(16) + " bytes");
          return 0 | t3;
        }
        function w2(t3, e3) {
          if (v.isBuffer(t3))
            return t3.length;
          if (ArrayBuffer.isView(t3) || rt(t3, ArrayBuffer))
            return t3.byteLength;
          if ("string" != typeof t3)
            throw new TypeError('The "string" argument must be one of type string, Buffer, or ArrayBuffer. Received type ' + u(t3));
          var r3 = t3.length, n3 = arguments.length > 2 && true === arguments[2];
          if (!n3 && 0 === r3)
            return 0;
          for (var i2 = false; ; )
            switch (e3) {
              case "ascii":
              case "latin1":
              case "binary":
                return r3;
              case "utf8":
              case "utf-8":
                return Q(t3).length;
              case "ucs2":
              case "ucs-2":
              case "utf16le":
              case "utf-16le":
                return 2 * r3;
              case "hex":
                return r3 >>> 1;
              case "base64":
                return tt(t3).length;
              default:
                if (i2)
                  return n3 ? -1 : Q(t3).length;
                e3 = ("" + e3).toLowerCase(), i2 = true;
            }
        }
        function T(t3, e3, r3) {
          var n3 = false;
          if ((void 0 === e3 || e3 < 0) && (e3 = 0), e3 > this.length)
            return "";
          if ((void 0 === r3 || r3 > this.length) && (r3 = this.length), r3 <= 0)
            return "";
          if ((r3 >>>= 0) <= (e3 >>>= 0))
            return "";
          for (t3 || (t3 = "utf8"); ; )
            switch (t3) {
              case "hex":
                return F(this, e3, r3);
              case "utf8":
              case "utf-8":
                return I(this, e3, r3);
              case "ascii":
                return z(this, e3, r3);
              case "latin1":
              case "binary":
                return R(this, e3, r3);
              case "base64":
                return O(this, e3, r3);
              case "ucs2":
              case "ucs-2":
              case "utf16le":
              case "utf-16le":
                return B(this, e3, r3);
              default:
                if (n3)
                  throw new TypeError("Unknown encoding: " + t3);
                t3 = (t3 + "").toLowerCase(), n3 = true;
            }
        }
        function k(t3, e3, r3) {
          var n3 = t3[e3];
          t3[e3] = t3[r3], t3[r3] = n3;
        }
        function A(t3, e3, r3, n3, i2) {
          if (0 === t3.length)
            return -1;
          if ("string" == typeof r3 ? (n3 = r3, r3 = 0) : r3 > 2147483647 ? r3 = 2147483647 : r3 < -2147483648 && (r3 = -2147483648), nt(r3 = +r3) && (r3 = i2 ? 0 : t3.length - 1), r3 < 0 && (r3 = t3.length + r3), r3 >= t3.length) {
            if (i2)
              return -1;
            r3 = t3.length - 1;
          } else if (r3 < 0) {
            if (!i2)
              return -1;
            r3 = 0;
          }
          if ("string" == typeof e3 && (e3 = v.from(e3, n3)), v.isBuffer(e3))
            return 0 === e3.length ? -1 : M(t3, e3, r3, n3, i2);
          if ("number" == typeof e3)
            return e3 &= 255, "function" == typeof Uint8Array.prototype.indexOf ? i2 ? Uint8Array.prototype.indexOf.call(t3, e3, r3) : Uint8Array.prototype.lastIndexOf.call(t3, e3, r3) : M(t3, [e3], r3, n3, i2);
          throw new TypeError("val must be string, number or Buffer");
        }
        function M(t3, e3, r3, n3, i2) {
          var a2, o2 = 1, s2 = t3.length, l2 = e3.length;
          if (void 0 !== n3 && ("ucs2" === (n3 = String(n3).toLowerCase()) || "ucs-2" === n3 || "utf16le" === n3 || "utf-16le" === n3)) {
            if (t3.length < 2 || e3.length < 2)
              return -1;
            o2 = 2, s2 /= 2, l2 /= 2, r3 /= 2;
          }
          function u2(t4, e4) {
            return 1 === o2 ? t4[e4] : t4.readUInt16BE(e4 * o2);
          }
          if (i2) {
            var c2 = -1;
            for (a2 = r3; a2 < s2; a2++)
              if (u2(t3, a2) === u2(e3, -1 === c2 ? 0 : a2 - c2)) {
                if (-1 === c2 && (c2 = a2), a2 - c2 + 1 === l2)
                  return c2 * o2;
              } else
                -1 !== c2 && (a2 -= a2 - c2), c2 = -1;
          } else
            for (r3 + l2 > s2 && (r3 = s2 - l2), a2 = r3; a2 >= 0; a2--) {
              for (var f3 = true, h2 = 0; h2 < l2; h2++)
                if (u2(t3, a2 + h2) !== u2(e3, h2)) {
                  f3 = false;
                  break;
                }
              if (f3)
                return a2;
            }
          return -1;
        }
        function S(t3, e3, r3, n3) {
          r3 = Number(r3) || 0;
          var i2 = t3.length - r3;
          n3 ? (n3 = Number(n3)) > i2 && (n3 = i2) : n3 = i2;
          var a2, o2 = e3.length;
          for (n3 > o2 / 2 && (n3 = o2 / 2), a2 = 0; a2 < n3; ++a2) {
            var s2 = parseInt(e3.substr(2 * a2, 2), 16);
            if (nt(s2))
              return a2;
            t3[r3 + a2] = s2;
          }
          return a2;
        }
        function E(t3, e3, r3, n3) {
          return et(Q(e3, t3.length - r3), t3, r3, n3);
        }
        function L(t3, e3, r3, n3) {
          return et(function(t4) {
            for (var e4 = [], r4 = 0; r4 < t4.length; ++r4)
              e4.push(255 & t4.charCodeAt(r4));
            return e4;
          }(e3), t3, r3, n3);
        }
        function C(t3, e3, r3, n3) {
          return et(tt(e3), t3, r3, n3);
        }
        function P(t3, e3, r3, n3) {
          return et(function(t4, e4) {
            for (var r4, n4, i2, a2 = [], o2 = 0; o2 < t4.length && !((e4 -= 2) < 0); ++o2)
              n4 = (r4 = t4.charCodeAt(o2)) >> 8, i2 = r4 % 256, a2.push(i2), a2.push(n4);
            return a2;
          }(e3, t3.length - r3), t3, r3, n3);
        }
        function O(t3, e3, r3) {
          return 0 === e3 && r3 === t3.length ? c.fromByteArray(t3) : c.fromByteArray(t3.slice(e3, r3));
        }
        function I(t3, e3, r3) {
          r3 = Math.min(t3.length, r3);
          for (var n3 = [], i2 = e3; i2 < r3; ) {
            var a2 = t3[i2], o2 = null, s2 = a2 > 239 ? 4 : a2 > 223 ? 3 : a2 > 191 ? 2 : 1;
            if (i2 + s2 <= r3) {
              var l2 = void 0, u2 = void 0, c2 = void 0, f3 = void 0;
              switch (s2) {
                case 1:
                  a2 < 128 && (o2 = a2);
                  break;
                case 2:
                  128 == (192 & (l2 = t3[i2 + 1])) && (f3 = (31 & a2) << 6 | 63 & l2) > 127 && (o2 = f3);
                  break;
                case 3:
                  l2 = t3[i2 + 1], u2 = t3[i2 + 2], 128 == (192 & l2) && 128 == (192 & u2) && (f3 = (15 & a2) << 12 | (63 & l2) << 6 | 63 & u2) > 2047 && (f3 < 55296 || f3 > 57343) && (o2 = f3);
                  break;
                case 4:
                  l2 = t3[i2 + 1], u2 = t3[i2 + 2], c2 = t3[i2 + 3], 128 == (192 & l2) && 128 == (192 & u2) && 128 == (192 & c2) && (f3 = (15 & a2) << 18 | (63 & l2) << 12 | (63 & u2) << 6 | 63 & c2) > 65535 && f3 < 1114112 && (o2 = f3);
              }
            }
            null === o2 ? (o2 = 65533, s2 = 1) : o2 > 65535 && (o2 -= 65536, n3.push(o2 >>> 10 & 1023 | 55296), o2 = 56320 | 1023 & o2), n3.push(o2), i2 += s2;
          }
          return function(t4) {
            var e4 = t4.length;
            if (e4 <= D)
              return String.fromCharCode.apply(String, t4);
            for (var r4 = "", n4 = 0; n4 < e4; )
              r4 += String.fromCharCode.apply(String, t4.slice(n4, n4 += D));
            return r4;
          }(n3);
        }
        e2.kMaxLength = p2, v.TYPED_ARRAY_SUPPORT = function() {
          try {
            var t3 = new Uint8Array(1), e3 = { foo: function() {
              return 42;
            } };
            return Object.setPrototypeOf(e3, Uint8Array.prototype), Object.setPrototypeOf(t3, e3), 42 === t3.foo();
          } catch (t4) {
            return false;
          }
        }(), v.TYPED_ARRAY_SUPPORT || "undefined" == typeof console || "function" != typeof console.error || console.error("This browser lacks typed array (Uint8Array) support which is required by `buffer` v5.x. Use `buffer` v4.x if you require old browser support."), Object.defineProperty(v.prototype, "parent", { enumerable: true, get: function() {
          if (v.isBuffer(this))
            return this.buffer;
        } }), Object.defineProperty(v.prototype, "offset", { enumerable: true, get: function() {
          if (v.isBuffer(this))
            return this.byteOffset;
        } }), v.poolSize = 8192, v.from = function(t3, e3, r3) {
          return g2(t3, e3, r3);
        }, Object.setPrototypeOf(v.prototype, Uint8Array.prototype), Object.setPrototypeOf(v, Uint8Array), v.alloc = function(t3, e3, r3) {
          return function(t4, e4, r4) {
            return y(t4), t4 <= 0 ? d2(t4) : void 0 !== e4 ? "string" == typeof r4 ? d2(t4).fill(e4, r4) : d2(t4).fill(e4) : d2(t4);
          }(t3, e3, r3);
        }, v.allocUnsafe = function(t3) {
          return m2(t3);
        }, v.allocUnsafeSlow = function(t3) {
          return m2(t3);
        }, v.isBuffer = function(t3) {
          return null != t3 && true === t3._isBuffer && t3 !== v.prototype;
        }, v.compare = function(t3, e3) {
          if (rt(t3, Uint8Array) && (t3 = v.from(t3, t3.offset, t3.byteLength)), rt(e3, Uint8Array) && (e3 = v.from(e3, e3.offset, e3.byteLength)), !v.isBuffer(t3) || !v.isBuffer(e3))
            throw new TypeError('The "buf1", "buf2" arguments must be one of type Buffer or Uint8Array');
          if (t3 === e3)
            return 0;
          for (var r3 = t3.length, n3 = e3.length, i2 = 0, a2 = Math.min(r3, n3); i2 < a2; ++i2)
            if (t3[i2] !== e3[i2]) {
              r3 = t3[i2], n3 = e3[i2];
              break;
            }
          return r3 < n3 ? -1 : n3 < r3 ? 1 : 0;
        }, v.isEncoding = function(t3) {
          switch (String(t3).toLowerCase()) {
            case "hex":
            case "utf8":
            case "utf-8":
            case "ascii":
            case "latin1":
            case "binary":
            case "base64":
            case "ucs2":
            case "ucs-2":
            case "utf16le":
            case "utf-16le":
              return true;
            default:
              return false;
          }
        }, v.concat = function(t3, e3) {
          if (!Array.isArray(t3))
            throw new TypeError('"list" argument must be an Array of Buffers');
          if (0 === t3.length)
            return v.alloc(0);
          var r3;
          if (void 0 === e3)
            for (e3 = 0, r3 = 0; r3 < t3.length; ++r3)
              e3 += t3[r3].length;
          var n3 = v.allocUnsafe(e3), i2 = 0;
          for (r3 = 0; r3 < t3.length; ++r3) {
            var a2 = t3[r3];
            if (rt(a2, Uint8Array))
              i2 + a2.length > n3.length ? (v.isBuffer(a2) || (a2 = v.from(a2)), a2.copy(n3, i2)) : Uint8Array.prototype.set.call(n3, a2, i2);
            else {
              if (!v.isBuffer(a2))
                throw new TypeError('"list" argument must be an Array of Buffers');
              a2.copy(n3, i2);
            }
            i2 += a2.length;
          }
          return n3;
        }, v.byteLength = w2, v.prototype._isBuffer = true, v.prototype.swap16 = function() {
          var t3 = this.length;
          if (t3 % 2 != 0)
            throw new RangeError("Buffer size must be a multiple of 16-bits");
          for (var e3 = 0; e3 < t3; e3 += 2)
            k(this, e3, e3 + 1);
          return this;
        }, v.prototype.swap32 = function() {
          var t3 = this.length;
          if (t3 % 4 != 0)
            throw new RangeError("Buffer size must be a multiple of 32-bits");
          for (var e3 = 0; e3 < t3; e3 += 4)
            k(this, e3, e3 + 3), k(this, e3 + 1, e3 + 2);
          return this;
        }, v.prototype.swap64 = function() {
          var t3 = this.length;
          if (t3 % 8 != 0)
            throw new RangeError("Buffer size must be a multiple of 64-bits");
          for (var e3 = 0; e3 < t3; e3 += 8)
            k(this, e3, e3 + 7), k(this, e3 + 1, e3 + 6), k(this, e3 + 2, e3 + 5), k(this, e3 + 3, e3 + 4);
          return this;
        }, v.prototype.toString = function() {
          var t3 = this.length;
          return 0 === t3 ? "" : 0 === arguments.length ? I(this, 0, t3) : T.apply(this, arguments);
        }, v.prototype.toLocaleString = v.prototype.toString, v.prototype.equals = function(t3) {
          if (!v.isBuffer(t3))
            throw new TypeError("Argument must be a Buffer");
          return this === t3 || 0 === v.compare(this, t3);
        }, v.prototype.inspect = function() {
          var t3 = "", r3 = e2.INSPECT_MAX_BYTES;
          return t3 = this.toString("hex", 0, r3).replace(/(.{2})/g, "$1 ").trim(), this.length > r3 && (t3 += " ... "), "<Buffer " + t3 + ">";
        }, h && (v.prototype[h] = v.prototype.inspect), v.prototype.compare = function(t3, e3, r3, n3, i2) {
          if (rt(t3, Uint8Array) && (t3 = v.from(t3, t3.offset, t3.byteLength)), !v.isBuffer(t3))
            throw new TypeError('The "target" argument must be one of type Buffer or Uint8Array. Received type ' + u(t3));
          if (void 0 === e3 && (e3 = 0), void 0 === r3 && (r3 = t3 ? t3.length : 0), void 0 === n3 && (n3 = 0), void 0 === i2 && (i2 = this.length), e3 < 0 || r3 > t3.length || n3 < 0 || i2 > this.length)
            throw new RangeError("out of range index");
          if (n3 >= i2 && e3 >= r3)
            return 0;
          if (n3 >= i2)
            return -1;
          if (e3 >= r3)
            return 1;
          if (this === t3)
            return 0;
          for (var a2 = (i2 >>>= 0) - (n3 >>>= 0), o2 = (r3 >>>= 0) - (e3 >>>= 0), s2 = Math.min(a2, o2), l2 = this.slice(n3, i2), c2 = t3.slice(e3, r3), f3 = 0; f3 < s2; ++f3)
            if (l2[f3] !== c2[f3]) {
              a2 = l2[f3], o2 = c2[f3];
              break;
            }
          return a2 < o2 ? -1 : o2 < a2 ? 1 : 0;
        }, v.prototype.includes = function(t3, e3, r3) {
          return -1 !== this.indexOf(t3, e3, r3);
        }, v.prototype.indexOf = function(t3, e3, r3) {
          return A(this, t3, e3, r3, true);
        }, v.prototype.lastIndexOf = function(t3, e3, r3) {
          return A(this, t3, e3, r3, false);
        }, v.prototype.write = function(t3, e3, r3, n3) {
          if (void 0 === e3)
            n3 = "utf8", r3 = this.length, e3 = 0;
          else if (void 0 === r3 && "string" == typeof e3)
            n3 = e3, r3 = this.length, e3 = 0;
          else {
            if (!isFinite(e3))
              throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");
            e3 >>>= 0, isFinite(r3) ? (r3 >>>= 0, void 0 === n3 && (n3 = "utf8")) : (n3 = r3, r3 = void 0);
          }
          var i2 = this.length - e3;
          if ((void 0 === r3 || r3 > i2) && (r3 = i2), t3.length > 0 && (r3 < 0 || e3 < 0) || e3 > this.length)
            throw new RangeError("Attempt to write outside buffer bounds");
          n3 || (n3 = "utf8");
          for (var a2 = false; ; )
            switch (n3) {
              case "hex":
                return S(this, t3, e3, r3);
              case "utf8":
              case "utf-8":
                return E(this, t3, e3, r3);
              case "ascii":
              case "latin1":
              case "binary":
                return L(this, t3, e3, r3);
              case "base64":
                return C(this, t3, e3, r3);
              case "ucs2":
              case "ucs-2":
              case "utf16le":
              case "utf-16le":
                return P(this, t3, e3, r3);
              default:
                if (a2)
                  throw new TypeError("Unknown encoding: " + n3);
                n3 = ("" + n3).toLowerCase(), a2 = true;
            }
        }, v.prototype.toJSON = function() {
          return { type: "Buffer", data: Array.prototype.slice.call(this._arr || this, 0) };
        };
        var D = 4096;
        function z(t3, e3, r3) {
          var n3 = "";
          r3 = Math.min(t3.length, r3);
          for (var i2 = e3; i2 < r3; ++i2)
            n3 += String.fromCharCode(127 & t3[i2]);
          return n3;
        }
        function R(t3, e3, r3) {
          var n3 = "";
          r3 = Math.min(t3.length, r3);
          for (var i2 = e3; i2 < r3; ++i2)
            n3 += String.fromCharCode(t3[i2]);
          return n3;
        }
        function F(t3, e3, r3) {
          var n3 = t3.length;
          (!e3 || e3 < 0) && (e3 = 0), (!r3 || r3 < 0 || r3 > n3) && (r3 = n3);
          for (var i2 = "", a2 = e3; a2 < r3; ++a2)
            i2 += it[t3[a2]];
          return i2;
        }
        function B(t3, e3, r3) {
          for (var n3 = t3.slice(e3, r3), i2 = "", a2 = 0; a2 < n3.length - 1; a2 += 2)
            i2 += String.fromCharCode(n3[a2] + 256 * n3[a2 + 1]);
          return i2;
        }
        function N(t3, e3, r3) {
          if (t3 % 1 != 0 || t3 < 0)
            throw new RangeError("offset is not uint");
          if (t3 + e3 > r3)
            throw new RangeError("Trying to access beyond buffer length");
        }
        function j(t3, e3, r3, n3, i2, a2) {
          if (!v.isBuffer(t3))
            throw new TypeError('"buffer" argument must be a Buffer instance');
          if (e3 > i2 || e3 < a2)
            throw new RangeError('"value" argument is out of bounds');
          if (r3 + n3 > t3.length)
            throw new RangeError("Index out of range");
        }
        function U(t3, e3, r3, n3, i2) {
          X(e3, n3, i2, t3, r3, 7);
          var a2 = Number(e3 & BigInt(4294967295));
          t3[r3++] = a2, a2 >>= 8, t3[r3++] = a2, a2 >>= 8, t3[r3++] = a2, a2 >>= 8, t3[r3++] = a2;
          var o2 = Number(e3 >> BigInt(32) & BigInt(4294967295));
          return t3[r3++] = o2, o2 >>= 8, t3[r3++] = o2, o2 >>= 8, t3[r3++] = o2, o2 >>= 8, t3[r3++] = o2, r3;
        }
        function V(t3, e3, r3, n3, i2) {
          X(e3, n3, i2, t3, r3, 7);
          var a2 = Number(e3 & BigInt(4294967295));
          t3[r3 + 7] = a2, a2 >>= 8, t3[r3 + 6] = a2, a2 >>= 8, t3[r3 + 5] = a2, a2 >>= 8, t3[r3 + 4] = a2;
          var o2 = Number(e3 >> BigInt(32) & BigInt(4294967295));
          return t3[r3 + 3] = o2, o2 >>= 8, t3[r3 + 2] = o2, o2 >>= 8, t3[r3 + 1] = o2, o2 >>= 8, t3[r3] = o2, r3 + 8;
        }
        function H(t3, e3, r3, n3, i2, a2) {
          if (r3 + n3 > t3.length)
            throw new RangeError("Index out of range");
          if (r3 < 0)
            throw new RangeError("Index out of range");
        }
        function q2(t3, e3, r3, n3, i2) {
          return e3 = +e3, r3 >>>= 0, i2 || H(t3, 0, r3, 4), f2.write(t3, e3, r3, n3, 23, 4), r3 + 4;
        }
        function G(t3, e3, r3, n3, i2) {
          return e3 = +e3, r3 >>>= 0, i2 || H(t3, 0, r3, 8), f2.write(t3, e3, r3, n3, 52, 8), r3 + 8;
        }
        v.prototype.slice = function(t3, e3) {
          var r3 = this.length;
          (t3 = ~~t3) < 0 ? (t3 += r3) < 0 && (t3 = 0) : t3 > r3 && (t3 = r3), (e3 = void 0 === e3 ? r3 : ~~e3) < 0 ? (e3 += r3) < 0 && (e3 = 0) : e3 > r3 && (e3 = r3), e3 < t3 && (e3 = t3);
          var n3 = this.subarray(t3, e3);
          return Object.setPrototypeOf(n3, v.prototype), n3;
        }, v.prototype.readUintLE = v.prototype.readUIntLE = function(t3, e3, r3) {
          t3 >>>= 0, e3 >>>= 0, r3 || N(t3, e3, this.length);
          for (var n3 = this[t3], i2 = 1, a2 = 0; ++a2 < e3 && (i2 *= 256); )
            n3 += this[t3 + a2] * i2;
          return n3;
        }, v.prototype.readUintBE = v.prototype.readUIntBE = function(t3, e3, r3) {
          t3 >>>= 0, e3 >>>= 0, r3 || N(t3, e3, this.length);
          for (var n3 = this[t3 + --e3], i2 = 1; e3 > 0 && (i2 *= 256); )
            n3 += this[t3 + --e3] * i2;
          return n3;
        }, v.prototype.readUint8 = v.prototype.readUInt8 = function(t3, e3) {
          return t3 >>>= 0, e3 || N(t3, 1, this.length), this[t3];
        }, v.prototype.readUint16LE = v.prototype.readUInt16LE = function(t3, e3) {
          return t3 >>>= 0, e3 || N(t3, 2, this.length), this[t3] | this[t3 + 1] << 8;
        }, v.prototype.readUint16BE = v.prototype.readUInt16BE = function(t3, e3) {
          return t3 >>>= 0, e3 || N(t3, 2, this.length), this[t3] << 8 | this[t3 + 1];
        }, v.prototype.readUint32LE = v.prototype.readUInt32LE = function(t3, e3) {
          return t3 >>>= 0, e3 || N(t3, 4, this.length), (this[t3] | this[t3 + 1] << 8 | this[t3 + 2] << 16) + 16777216 * this[t3 + 3];
        }, v.prototype.readUint32BE = v.prototype.readUInt32BE = function(t3, e3) {
          return t3 >>>= 0, e3 || N(t3, 4, this.length), 16777216 * this[t3] + (this[t3 + 1] << 16 | this[t3 + 2] << 8 | this[t3 + 3]);
        }, v.prototype.readBigUInt64LE = at(function(t3) {
          J(t3 >>>= 0, "offset");
          var e3 = this[t3], r3 = this[t3 + 7];
          void 0 !== e3 && void 0 !== r3 || K(t3, this.length - 8);
          var n3 = e3 + this[++t3] * Math.pow(2, 8) + this[++t3] * Math.pow(2, 16) + this[++t3] * Math.pow(2, 24), i2 = this[++t3] + this[++t3] * Math.pow(2, 8) + this[++t3] * Math.pow(2, 16) + r3 * Math.pow(2, 24);
          return BigInt(n3) + (BigInt(i2) << BigInt(32));
        }), v.prototype.readBigUInt64BE = at(function(t3) {
          J(t3 >>>= 0, "offset");
          var e3 = this[t3], r3 = this[t3 + 7];
          void 0 !== e3 && void 0 !== r3 || K(t3, this.length - 8);
          var n3 = e3 * Math.pow(2, 24) + this[++t3] * Math.pow(2, 16) + this[++t3] * Math.pow(2, 8) + this[++t3], i2 = this[++t3] * Math.pow(2, 24) + this[++t3] * Math.pow(2, 16) + this[++t3] * Math.pow(2, 8) + r3;
          return (BigInt(n3) << BigInt(32)) + BigInt(i2);
        }), v.prototype.readIntLE = function(t3, e3, r3) {
          t3 >>>= 0, e3 >>>= 0, r3 || N(t3, e3, this.length);
          for (var n3 = this[t3], i2 = 1, a2 = 0; ++a2 < e3 && (i2 *= 256); )
            n3 += this[t3 + a2] * i2;
          return n3 >= (i2 *= 128) && (n3 -= Math.pow(2, 8 * e3)), n3;
        }, v.prototype.readIntBE = function(t3, e3, r3) {
          t3 >>>= 0, e3 >>>= 0, r3 || N(t3, e3, this.length);
          for (var n3 = e3, i2 = 1, a2 = this[t3 + --n3]; n3 > 0 && (i2 *= 256); )
            a2 += this[t3 + --n3] * i2;
          return a2 >= (i2 *= 128) && (a2 -= Math.pow(2, 8 * e3)), a2;
        }, v.prototype.readInt8 = function(t3, e3) {
          return t3 >>>= 0, e3 || N(t3, 1, this.length), 128 & this[t3] ? -1 * (255 - this[t3] + 1) : this[t3];
        }, v.prototype.readInt16LE = function(t3, e3) {
          t3 >>>= 0, e3 || N(t3, 2, this.length);
          var r3 = this[t3] | this[t3 + 1] << 8;
          return 32768 & r3 ? 4294901760 | r3 : r3;
        }, v.prototype.readInt16BE = function(t3, e3) {
          t3 >>>= 0, e3 || N(t3, 2, this.length);
          var r3 = this[t3 + 1] | this[t3] << 8;
          return 32768 & r3 ? 4294901760 | r3 : r3;
        }, v.prototype.readInt32LE = function(t3, e3) {
          return t3 >>>= 0, e3 || N(t3, 4, this.length), this[t3] | this[t3 + 1] << 8 | this[t3 + 2] << 16 | this[t3 + 3] << 24;
        }, v.prototype.readInt32BE = function(t3, e3) {
          return t3 >>>= 0, e3 || N(t3, 4, this.length), this[t3] << 24 | this[t3 + 1] << 16 | this[t3 + 2] << 8 | this[t3 + 3];
        }, v.prototype.readBigInt64LE = at(function(t3) {
          J(t3 >>>= 0, "offset");
          var e3 = this[t3], r3 = this[t3 + 7];
          void 0 !== e3 && void 0 !== r3 || K(t3, this.length - 8);
          var n3 = this[t3 + 4] + this[t3 + 5] * Math.pow(2, 8) + this[t3 + 6] * Math.pow(2, 16) + (r3 << 24);
          return (BigInt(n3) << BigInt(32)) + BigInt(e3 + this[++t3] * Math.pow(2, 8) + this[++t3] * Math.pow(2, 16) + this[++t3] * Math.pow(2, 24));
        }), v.prototype.readBigInt64BE = at(function(t3) {
          J(t3 >>>= 0, "offset");
          var e3 = this[t3], r3 = this[t3 + 7];
          void 0 !== e3 && void 0 !== r3 || K(t3, this.length - 8);
          var n3 = (e3 << 24) + this[++t3] * Math.pow(2, 16) + this[++t3] * Math.pow(2, 8) + this[++t3];
          return (BigInt(n3) << BigInt(32)) + BigInt(this[++t3] * Math.pow(2, 24) + this[++t3] * Math.pow(2, 16) + this[++t3] * Math.pow(2, 8) + r3);
        }), v.prototype.readFloatLE = function(t3, e3) {
          return t3 >>>= 0, e3 || N(t3, 4, this.length), f2.read(this, t3, true, 23, 4);
        }, v.prototype.readFloatBE = function(t3, e3) {
          return t3 >>>= 0, e3 || N(t3, 4, this.length), f2.read(this, t3, false, 23, 4);
        }, v.prototype.readDoubleLE = function(t3, e3) {
          return t3 >>>= 0, e3 || N(t3, 8, this.length), f2.read(this, t3, true, 52, 8);
        }, v.prototype.readDoubleBE = function(t3, e3) {
          return t3 >>>= 0, e3 || N(t3, 8, this.length), f2.read(this, t3, false, 52, 8);
        }, v.prototype.writeUintLE = v.prototype.writeUIntLE = function(t3, e3, r3, n3) {
          t3 = +t3, e3 >>>= 0, r3 >>>= 0, n3 || j(this, t3, e3, r3, Math.pow(2, 8 * r3) - 1, 0);
          var i2 = 1, a2 = 0;
          for (this[e3] = 255 & t3; ++a2 < r3 && (i2 *= 256); )
            this[e3 + a2] = t3 / i2 & 255;
          return e3 + r3;
        }, v.prototype.writeUintBE = v.prototype.writeUIntBE = function(t3, e3, r3, n3) {
          t3 = +t3, e3 >>>= 0, r3 >>>= 0, n3 || j(this, t3, e3, r3, Math.pow(2, 8 * r3) - 1, 0);
          var i2 = r3 - 1, a2 = 1;
          for (this[e3 + i2] = 255 & t3; --i2 >= 0 && (a2 *= 256); )
            this[e3 + i2] = t3 / a2 & 255;
          return e3 + r3;
        }, v.prototype.writeUint8 = v.prototype.writeUInt8 = function(t3, e3, r3) {
          return t3 = +t3, e3 >>>= 0, r3 || j(this, t3, e3, 1, 255, 0), this[e3] = 255 & t3, e3 + 1;
        }, v.prototype.writeUint16LE = v.prototype.writeUInt16LE = function(t3, e3, r3) {
          return t3 = +t3, e3 >>>= 0, r3 || j(this, t3, e3, 2, 65535, 0), this[e3] = 255 & t3, this[e3 + 1] = t3 >>> 8, e3 + 2;
        }, v.prototype.writeUint16BE = v.prototype.writeUInt16BE = function(t3, e3, r3) {
          return t3 = +t3, e3 >>>= 0, r3 || j(this, t3, e3, 2, 65535, 0), this[e3] = t3 >>> 8, this[e3 + 1] = 255 & t3, e3 + 2;
        }, v.prototype.writeUint32LE = v.prototype.writeUInt32LE = function(t3, e3, r3) {
          return t3 = +t3, e3 >>>= 0, r3 || j(this, t3, e3, 4, 4294967295, 0), this[e3 + 3] = t3 >>> 24, this[e3 + 2] = t3 >>> 16, this[e3 + 1] = t3 >>> 8, this[e3] = 255 & t3, e3 + 4;
        }, v.prototype.writeUint32BE = v.prototype.writeUInt32BE = function(t3, e3, r3) {
          return t3 = +t3, e3 >>>= 0, r3 || j(this, t3, e3, 4, 4294967295, 0), this[e3] = t3 >>> 24, this[e3 + 1] = t3 >>> 16, this[e3 + 2] = t3 >>> 8, this[e3 + 3] = 255 & t3, e3 + 4;
        }, v.prototype.writeBigUInt64LE = at(function(t3) {
          var e3 = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0;
          return U(this, t3, e3, BigInt(0), BigInt("0xffffffffffffffff"));
        }), v.prototype.writeBigUInt64BE = at(function(t3) {
          var e3 = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0;
          return V(this, t3, e3, BigInt(0), BigInt("0xffffffffffffffff"));
        }), v.prototype.writeIntLE = function(t3, e3, r3, n3) {
          if (t3 = +t3, e3 >>>= 0, !n3) {
            var i2 = Math.pow(2, 8 * r3 - 1);
            j(this, t3, e3, r3, i2 - 1, -i2);
          }
          var a2 = 0, o2 = 1, s2 = 0;
          for (this[e3] = 255 & t3; ++a2 < r3 && (o2 *= 256); )
            t3 < 0 && 0 === s2 && 0 !== this[e3 + a2 - 1] && (s2 = 1), this[e3 + a2] = (t3 / o2 >> 0) - s2 & 255;
          return e3 + r3;
        }, v.prototype.writeIntBE = function(t3, e3, r3, n3) {
          if (t3 = +t3, e3 >>>= 0, !n3) {
            var i2 = Math.pow(2, 8 * r3 - 1);
            j(this, t3, e3, r3, i2 - 1, -i2);
          }
          var a2 = r3 - 1, o2 = 1, s2 = 0;
          for (this[e3 + a2] = 255 & t3; --a2 >= 0 && (o2 *= 256); )
            t3 < 0 && 0 === s2 && 0 !== this[e3 + a2 + 1] && (s2 = 1), this[e3 + a2] = (t3 / o2 >> 0) - s2 & 255;
          return e3 + r3;
        }, v.prototype.writeInt8 = function(t3, e3, r3) {
          return t3 = +t3, e3 >>>= 0, r3 || j(this, t3, e3, 1, 127, -128), t3 < 0 && (t3 = 255 + t3 + 1), this[e3] = 255 & t3, e3 + 1;
        }, v.prototype.writeInt16LE = function(t3, e3, r3) {
          return t3 = +t3, e3 >>>= 0, r3 || j(this, t3, e3, 2, 32767, -32768), this[e3] = 255 & t3, this[e3 + 1] = t3 >>> 8, e3 + 2;
        }, v.prototype.writeInt16BE = function(t3, e3, r3) {
          return t3 = +t3, e3 >>>= 0, r3 || j(this, t3, e3, 2, 32767, -32768), this[e3] = t3 >>> 8, this[e3 + 1] = 255 & t3, e3 + 2;
        }, v.prototype.writeInt32LE = function(t3, e3, r3) {
          return t3 = +t3, e3 >>>= 0, r3 || j(this, t3, e3, 4, 2147483647, -2147483648), this[e3] = 255 & t3, this[e3 + 1] = t3 >>> 8, this[e3 + 2] = t3 >>> 16, this[e3 + 3] = t3 >>> 24, e3 + 4;
        }, v.prototype.writeInt32BE = function(t3, e3, r3) {
          return t3 = +t3, e3 >>>= 0, r3 || j(this, t3, e3, 4, 2147483647, -2147483648), t3 < 0 && (t3 = 4294967295 + t3 + 1), this[e3] = t3 >>> 24, this[e3 + 1] = t3 >>> 16, this[e3 + 2] = t3 >>> 8, this[e3 + 3] = 255 & t3, e3 + 4;
        }, v.prototype.writeBigInt64LE = at(function(t3) {
          var e3 = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0;
          return U(this, t3, e3, -BigInt("0x8000000000000000"), BigInt("0x7fffffffffffffff"));
        }), v.prototype.writeBigInt64BE = at(function(t3) {
          var e3 = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : 0;
          return V(this, t3, e3, -BigInt("0x8000000000000000"), BigInt("0x7fffffffffffffff"));
        }), v.prototype.writeFloatLE = function(t3, e3, r3) {
          return q2(this, t3, e3, true, r3);
        }, v.prototype.writeFloatBE = function(t3, e3, r3) {
          return q2(this, t3, e3, false, r3);
        }, v.prototype.writeDoubleLE = function(t3, e3, r3) {
          return G(this, t3, e3, true, r3);
        }, v.prototype.writeDoubleBE = function(t3, e3, r3) {
          return G(this, t3, e3, false, r3);
        }, v.prototype.copy = function(t3, e3, r3, n3) {
          if (!v.isBuffer(t3))
            throw new TypeError("argument should be a Buffer");
          if (r3 || (r3 = 0), n3 || 0 === n3 || (n3 = this.length), e3 >= t3.length && (e3 = t3.length), e3 || (e3 = 0), n3 > 0 && n3 < r3 && (n3 = r3), n3 === r3)
            return 0;
          if (0 === t3.length || 0 === this.length)
            return 0;
          if (e3 < 0)
            throw new RangeError("targetStart out of bounds");
          if (r3 < 0 || r3 >= this.length)
            throw new RangeError("Index out of range");
          if (n3 < 0)
            throw new RangeError("sourceEnd out of bounds");
          n3 > this.length && (n3 = this.length), t3.length - e3 < n3 - r3 && (n3 = t3.length - e3 + r3);
          var i2 = n3 - r3;
          return this === t3 && "function" == typeof Uint8Array.prototype.copyWithin ? this.copyWithin(e3, r3, n3) : Uint8Array.prototype.set.call(t3, this.subarray(r3, n3), e3), i2;
        }, v.prototype.fill = function(t3, e3, r3, n3) {
          if ("string" == typeof t3) {
            if ("string" == typeof e3 ? (n3 = e3, e3 = 0, r3 = this.length) : "string" == typeof r3 && (n3 = r3, r3 = this.length), void 0 !== n3 && "string" != typeof n3)
              throw new TypeError("encoding must be a string");
            if ("string" == typeof n3 && !v.isEncoding(n3))
              throw new TypeError("Unknown encoding: " + n3);
            if (1 === t3.length) {
              var i2 = t3.charCodeAt(0);
              ("utf8" === n3 && i2 < 128 || "latin1" === n3) && (t3 = i2);
            }
          } else
            "number" == typeof t3 ? t3 &= 255 : "boolean" == typeof t3 && (t3 = Number(t3));
          if (e3 < 0 || this.length < e3 || this.length < r3)
            throw new RangeError("Out of range index");
          if (r3 <= e3)
            return this;
          var a2;
          if (e3 >>>= 0, r3 = void 0 === r3 ? this.length : r3 >>> 0, t3 || (t3 = 0), "number" == typeof t3)
            for (a2 = e3; a2 < r3; ++a2)
              this[a2] = t3;
          else {
            var o2 = v.isBuffer(t3) ? t3 : v.from(t3, n3), s2 = o2.length;
            if (0 === s2)
              throw new TypeError('The value "' + t3 + '" is invalid for argument "value"');
            for (a2 = 0; a2 < r3 - e3; ++a2)
              this[a2 + e3] = o2[a2 % s2];
          }
          return this;
        };
        var Z = {};
        function Y(t3, e3, r3) {
          Z[t3] = function(r4) {
            !function(t4, e4) {
              if ("function" != typeof e4 && null !== e4)
                throw new TypeError("Super expression must either be null or a function");
              t4.prototype = Object.create(e4 && e4.prototype, { constructor: { value: t4, writable: true, configurable: true } }), Object.defineProperty(t4, "prototype", { writable: false }), e4 && a(t4, e4);
            }(d3, r4);
            var u2, c2, f3, h2, p3 = (f3 = d3, h2 = function() {
              if ("undefined" == typeof Reflect || !Reflect.construct)
                return false;
              if (Reflect.construct.sham)
                return false;
              if ("function" == typeof Proxy)
                return true;
              try {
                return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
                })), true;
              } catch (t4) {
                return false;
              }
            }(), function() {
              var t4, e4 = l(f3);
              if (h2) {
                var r5 = l(this).constructor;
                t4 = Reflect.construct(e4, arguments, r5);
              } else
                t4 = e4.apply(this, arguments);
              return o(this, t4);
            });
            function d3() {
              var r5;
              return n2(this, d3), r5 = p3.call(this), Object.defineProperty(s(r5), "message", { value: e3.apply(s(r5), arguments), writable: true, configurable: true }), r5.name = "".concat(r5.name, " [").concat(t3, "]"), r5.stack, delete r5.name, r5;
            }
            return u2 = d3, (c2 = [{ key: "code", get: function() {
              return t3;
            }, set: function(t4) {
              Object.defineProperty(this, "code", { configurable: true, enumerable: true, value: t4, writable: true });
            } }, { key: "toString", value: function() {
              return "".concat(this.name, " [").concat(t3, "]: ").concat(this.message);
            } }]) && i(u2.prototype, c2), Object.defineProperty(u2, "prototype", { writable: false }), d3;
          }(r3);
        }
        function W(t3) {
          for (var e3 = "", r3 = t3.length, n3 = "-" === t3[0] ? 1 : 0; r3 >= n3 + 4; r3 -= 3)
            e3 = "_".concat(t3.slice(r3 - 3, r3)).concat(e3);
          return "".concat(t3.slice(0, r3)).concat(e3);
        }
        function X(t3, e3, r3, n3, i2, a2) {
          if (t3 > r3 || t3 < e3) {
            var o2, s2 = "bigint" == typeof e3 ? "n" : "";
            throw o2 = a2 > 3 ? 0 === e3 || e3 === BigInt(0) ? ">= 0".concat(s2, " and < 2").concat(s2, " ** ").concat(8 * (a2 + 1)).concat(s2) : ">= -(2".concat(s2, " ** ").concat(8 * (a2 + 1) - 1).concat(s2, ") and < 2 ** ") + "".concat(8 * (a2 + 1) - 1).concat(s2) : ">= ".concat(e3).concat(s2, " and <= ").concat(r3).concat(s2), new Z.ERR_OUT_OF_RANGE("value", o2, t3);
          }
          !function(t4, e4, r4) {
            J(e4, "offset"), void 0 !== t4[e4] && void 0 !== t4[e4 + r4] || K(e4, t4.length - (r4 + 1));
          }(n3, i2, a2);
        }
        function J(t3, e3) {
          if ("number" != typeof t3)
            throw new Z.ERR_INVALID_ARG_TYPE(e3, "number", t3);
        }
        function K(t3, e3, r3) {
          if (Math.floor(t3) !== t3)
            throw J(t3, r3), new Z.ERR_OUT_OF_RANGE(r3 || "offset", "an integer", t3);
          if (e3 < 0)
            throw new Z.ERR_BUFFER_OUT_OF_BOUNDS();
          throw new Z.ERR_OUT_OF_RANGE(r3 || "offset", ">= ".concat(r3 ? 1 : 0, " and <= ").concat(e3), t3);
        }
        Y("ERR_BUFFER_OUT_OF_BOUNDS", function(t3) {
          return t3 ? "".concat(t3, " is outside of buffer bounds") : "Attempt to access memory outside buffer bounds";
        }, RangeError), Y("ERR_INVALID_ARG_TYPE", function(t3, e3) {
          return 'The "'.concat(t3, '" argument must be of type number. Received type ').concat(u(e3));
        }, TypeError), Y("ERR_OUT_OF_RANGE", function(t3, e3, r3) {
          var n3 = 'The value of "'.concat(t3, '" is out of range.'), i2 = r3;
          return Number.isInteger(r3) && Math.abs(r3) > Math.pow(2, 32) ? i2 = W(String(r3)) : "bigint" == typeof r3 && (i2 = String(r3), (r3 > Math.pow(BigInt(2), BigInt(32)) || r3 < -Math.pow(BigInt(2), BigInt(32))) && (i2 = W(i2)), i2 += "n"), n3 + " It must be ".concat(e3, ". Received ").concat(i2);
        }, RangeError);
        var $ = /[^+/0-9A-Za-z-_]/g;
        function Q(t3, e3) {
          var r3;
          e3 = e3 || 1 / 0;
          for (var n3 = t3.length, i2 = null, a2 = [], o2 = 0; o2 < n3; ++o2) {
            if ((r3 = t3.charCodeAt(o2)) > 55295 && r3 < 57344) {
              if (!i2) {
                if (r3 > 56319) {
                  (e3 -= 3) > -1 && a2.push(239, 191, 189);
                  continue;
                }
                if (o2 + 1 === n3) {
                  (e3 -= 3) > -1 && a2.push(239, 191, 189);
                  continue;
                }
                i2 = r3;
                continue;
              }
              if (r3 < 56320) {
                (e3 -= 3) > -1 && a2.push(239, 191, 189), i2 = r3;
                continue;
              }
              r3 = 65536 + (i2 - 55296 << 10 | r3 - 56320);
            } else
              i2 && (e3 -= 3) > -1 && a2.push(239, 191, 189);
            if (i2 = null, r3 < 128) {
              if ((e3 -= 1) < 0)
                break;
              a2.push(r3);
            } else if (r3 < 2048) {
              if ((e3 -= 2) < 0)
                break;
              a2.push(r3 >> 6 | 192, 63 & r3 | 128);
            } else if (r3 < 65536) {
              if ((e3 -= 3) < 0)
                break;
              a2.push(r3 >> 12 | 224, r3 >> 6 & 63 | 128, 63 & r3 | 128);
            } else {
              if (!(r3 < 1114112))
                throw new Error("Invalid code point");
              if ((e3 -= 4) < 0)
                break;
              a2.push(r3 >> 18 | 240, r3 >> 12 & 63 | 128, r3 >> 6 & 63 | 128, 63 & r3 | 128);
            }
          }
          return a2;
        }
        function tt(t3) {
          return c.toByteArray(function(t4) {
            if ((t4 = (t4 = t4.split("=")[0]).trim().replace($, "")).length < 2)
              return "";
            for (; t4.length % 4 != 0; )
              t4 += "=";
            return t4;
          }(t3));
        }
        function et(t3, e3, r3, n3) {
          var i2;
          for (i2 = 0; i2 < n3 && !(i2 + r3 >= e3.length || i2 >= t3.length); ++i2)
            e3[i2 + r3] = t3[i2];
          return i2;
        }
        function rt(t3, e3) {
          return t3 instanceof e3 || null != t3 && null != t3.constructor && null != t3.constructor.name && t3.constructor.name === e3.name;
        }
        function nt(t3) {
          return t3 != t3;
        }
        var it = function() {
          for (var t3 = "0123456789abcdef", e3 = new Array(256), r3 = 0; r3 < 16; ++r3)
            for (var n3 = 16 * r3, i2 = 0; i2 < 16; ++i2)
              e3[n3 + i2] = t3[r3] + t3[i2];
          return e3;
        }();
        function at(t3) {
          return "undefined" == typeof BigInt ? ot : t3;
        }
        function ot() {
          throw new Error("BigInt not supported");
        }
      }, 35791: function(t2) {
        t2.exports = i, t2.exports.isMobile = i, t2.exports.default = i;
        var e2 = /(android|bb\d+|meego).+mobile|armv7l|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series[46]0|samsungbrowser.*mobile|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i, r2 = /CrOS/, n2 = /android|ipad|playbook|silk/i;
        function i(t3) {
          t3 || (t3 = {});
          var i2 = t3.ua;
          if (i2 || "undefined" == typeof navigator || (i2 = navigator.userAgent), i2 && i2.headers && "string" == typeof i2.headers["user-agent"] && (i2 = i2.headers["user-agent"]), "string" != typeof i2)
            return false;
          var a = e2.test(i2) && !r2.test(i2) || !!t3.tablet && n2.test(i2);
          return !a && t3.tablet && t3.featureDetect && navigator && navigator.maxTouchPoints > 1 && -1 !== i2.indexOf("Macintosh") && -1 !== i2.indexOf("Safari") && (a = true), a;
        }
      }, 86781: function(t2, e2, r2) {
        r2.r(e2), r2.d(e2, { sankeyCenter: function() {
          return h;
        }, sankeyCircular: function() {
          return L;
        }, sankeyJustify: function() {
          return f2;
        }, sankeyLeft: function() {
          return u;
        }, sankeyRight: function() {
          return c;
        } });
        var n2 = r2(33064), i = r2(15140), a = r2(45879), o = r2(2502), s = r2.n(o);
        function l(t3) {
          return t3.target.depth;
        }
        function u(t3) {
          return t3.depth;
        }
        function c(t3, e3) {
          return e3 - 1 - t3.height;
        }
        function f2(t3, e3) {
          return t3.sourceLinks.length ? t3.depth : e3 - 1;
        }
        function h(t3) {
          return t3.targetLinks.length ? t3.depth : t3.sourceLinks.length ? (0, n2.VV)(t3.sourceLinks, l) - 1 : 0;
        }
        function p2(t3) {
          return function() {
            return t3;
          };
        }
        var d2 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(t3) {
          return typeof t3;
        } : function(t3) {
          return t3 && "function" == typeof Symbol && t3.constructor === Symbol && t3 !== Symbol.prototype ? "symbol" : typeof t3;
        };
        function v(t3, e3) {
          return y(t3.source, e3.source) || t3.index - e3.index;
        }
        function g2(t3, e3) {
          return y(t3.target, e3.target) || t3.index - e3.index;
        }
        function y(t3, e3) {
          return t3.partOfCycle === e3.partOfCycle ? t3.y0 - e3.y0 : "top" === t3.circularLinkType || "bottom" === e3.circularLinkType ? -1 : 1;
        }
        function m2(t3) {
          return t3.value;
        }
        function x(t3) {
          return (t3.y0 + t3.y1) / 2;
        }
        function b(t3) {
          return x(t3.source);
        }
        function _(t3) {
          return x(t3.target);
        }
        function w2(t3) {
          return t3.index;
        }
        function T(t3) {
          return t3.nodes;
        }
        function k(t3) {
          return t3.links;
        }
        function A(t3, e3) {
          var r3 = t3.get(e3);
          if (!r3)
            throw new Error("missing: " + e3);
          return r3;
        }
        function M(t3, e3) {
          return e3(t3);
        }
        var S = 25, E = 10;
        function L() {
          var t3, e3, r3 = 0, a2 = 0, o2 = 1, s2 = 1, l2 = 24, u2 = w2, c2 = f2, h2 = T, M2 = k, L2 = 32, O2 = 2, D2 = null;
          function z2() {
            var t4 = { nodes: h2.apply(null, arguments), links: M2.apply(null, arguments) };
            F2(t4), C(t4, 0, D2), B2(t4), N2(t4), P(t4, u2), j2(t4, L2, u2), U2(t4);
            for (var e4 = 4, r4 = 0; r4 < e4; r4++)
              W(t4, s2, u2), X(t4, 0, u2), Z(t4, a2, s2, u2), W(t4, s2, u2), X(t4, 0, u2);
            return Q(t4, a2, s2), R(t4, O2, s2, u2), t4;
          }
          function F2(t4) {
            t4.nodes.forEach(function(t5, e5) {
              t5.index = e5, t5.sourceLinks = [], t5.targetLinks = [];
            });
            var e4 = (0, i.UI)(t4.nodes, u2);
            return t4.links.forEach(function(t5, r4) {
              t5.index = r4;
              var n3 = t5.source, i2 = t5.target;
              "object" !== (void 0 === n3 ? "undefined" : d2(n3)) && (n3 = t5.source = A(e4, n3)), "object" !== (void 0 === i2 ? "undefined" : d2(i2)) && (i2 = t5.target = A(e4, i2)), n3.sourceLinks.push(t5), i2.targetLinks.push(t5);
            }), t4;
          }
          function B2(t4) {
            t4.nodes.forEach(function(t5) {
              t5.partOfCycle = false, t5.value = Math.max((0, n2.Sm)(t5.sourceLinks, m2), (0, n2.Sm)(t5.targetLinks, m2)), t5.sourceLinks.forEach(function(e4) {
                e4.circular && (t5.partOfCycle = true, t5.circularLinkType = e4.circularLinkType);
              }), t5.targetLinks.forEach(function(e4) {
                e4.circular && (t5.partOfCycle = true, t5.circularLinkType = e4.circularLinkType);
              });
            });
          }
          function N2(t4) {
            var e4, r4, n3;
            for (e4 = t4.nodes, r4 = [], n3 = 0; e4.length; ++n3, e4 = r4, r4 = [])
              e4.forEach(function(t5) {
                t5.depth = n3, t5.sourceLinks.forEach(function(t6) {
                  r4.indexOf(t6.target) < 0 && !t6.circular && r4.push(t6.target);
                });
              });
            for (e4 = t4.nodes, r4 = [], n3 = 0; e4.length; ++n3, e4 = r4, r4 = [])
              e4.forEach(function(t5) {
                t5.height = n3, t5.targetLinks.forEach(function(t6) {
                  r4.indexOf(t6.source) < 0 && !t6.circular && r4.push(t6.source);
                });
              });
            t4.nodes.forEach(function(t5) {
              t5.column = Math.floor(c2.call(null, t5, n3));
            });
          }
          function j2(u3, c3, f3) {
            var h3 = (0, i.b1)().key(function(t4) {
              return t4.column;
            }).sortKeys(n2.j2).entries(u3.nodes).map(function(t4) {
              return t4.values;
            });
            !function(i2) {
              if (e3) {
                var c4 = 1 / 0;
                h3.forEach(function(t4) {
                  var r4 = s2 * e3 / (t4.length + 1);
                  c4 = r4 < c4 ? r4 : c4;
                }), t3 = c4;
              }
              var f4 = (0, n2.VV)(h3, function(e4) {
                return (s2 - a2 - (e4.length - 1) * t3) / (0, n2.Sm)(e4, m2);
              });
              f4 *= 0.3, u3.links.forEach(function(t4) {
                t4.width = t4.value * f4;
              });
              var p4 = function(t4) {
                var e4 = 0, r4 = 0, i3 = 0, a3 = 0, o3 = (0, n2.Fp)(t4.nodes, function(t5) {
                  return t5.column;
                });
                return t4.links.forEach(function(t5) {
                  t5.circular && ("top" == t5.circularLinkType ? e4 += t5.width : r4 += t5.width, 0 == t5.target.column && (a3 += t5.width), t5.source.column == o3 && (i3 += t5.width));
                }), { top: e4 = e4 > 0 ? e4 + S + E : e4, bottom: r4 = r4 > 0 ? r4 + S + E : r4, left: a3 = a3 > 0 ? a3 + S + E : a3, right: i3 = i3 > 0 ? i3 + S + E : i3 };
              }(u3), d4 = function(t4, e4) {
                var i3 = (0, n2.Fp)(t4.nodes, function(t5) {
                  return t5.column;
                }), u4 = o2 - r3, c5 = s2 - a2, f5 = u4 / (u4 + e4.right + e4.left), h4 = c5 / (c5 + e4.top + e4.bottom);
                return r3 = r3 * f5 + e4.left, o2 = 0 == e4.right ? o2 : o2 * f5, a2 = a2 * h4 + e4.top, s2 *= h4, t4.nodes.forEach(function(t5) {
                  t5.x0 = r3 + t5.column * ((o2 - r3 - l2) / i3), t5.x1 = t5.x0 + l2;
                }), h4;
              }(u3, p4);
              f4 *= d4, u3.links.forEach(function(t4) {
                t4.width = t4.value * f4;
              }), h3.forEach(function(t4) {
                var e4 = t4.length;
                t4.forEach(function(t5, r4) {
                  t5.depth == h3.length - 1 && 1 == e4 || 0 == t5.depth && 1 == e4 ? (t5.y0 = s2 / 2 - t5.value * f4, t5.y1 = t5.y0 + t5.value * f4) : t5.partOfCycle ? 0 == I(t5, i2) ? (t5.y0 = s2 / 2 + r4, t5.y1 = t5.y0 + t5.value * f4) : "top" == t5.circularLinkType ? (t5.y0 = a2 + r4, t5.y1 = t5.y0 + t5.value * f4) : (t5.y0 = s2 - t5.value * f4 - r4, t5.y1 = t5.y0 + t5.value * f4) : 0 == p4.top || 0 == p4.bottom ? (t5.y0 = (s2 - a2) / e4 * r4, t5.y1 = t5.y0 + t5.value * f4) : (t5.y0 = (s2 - a2) / 2 - e4 / 2 + r4, t5.y1 = t5.y0 + t5.value * f4);
                });
              });
            }(f3), g3();
            for (var p3 = 1, d3 = c3; d3 > 0; --d3)
              v2(p3 *= 0.99, f3), g3();
            function v2(t4, e4) {
              var r4 = h3.length;
              h3.forEach(function(i2) {
                var a3 = i2.length, o3 = i2[0].depth;
                i2.forEach(function(i3) {
                  var l3;
                  if (i3.sourceLinks.length || i3.targetLinks.length)
                    if (i3.partOfCycle && I(i3, e4) > 0)
                      ;
                    else if (0 == o3 && 1 == a3)
                      l3 = i3.y1 - i3.y0, i3.y0 = s2 / 2 - l3 / 2, i3.y1 = s2 / 2 + l3 / 2;
                    else if (o3 == r4 - 1 && 1 == a3)
                      l3 = i3.y1 - i3.y0, i3.y0 = s2 / 2 - l3 / 2, i3.y1 = s2 / 2 + l3 / 2;
                    else {
                      var u4 = (0, n2.J6)(i3.sourceLinks, _), c4 = (0, n2.J6)(i3.targetLinks, b), f4 = ((u4 && c4 ? (u4 + c4) / 2 : u4 || c4) - x(i3)) * t4;
                      i3.y0 += f4, i3.y1 += f4;
                    }
                });
              });
            }
            function g3() {
              h3.forEach(function(e4) {
                var r4, n3, i2, o3 = a2, l3 = e4.length;
                for (e4.sort(y), i2 = 0; i2 < l3; ++i2)
                  (n3 = o3 - (r4 = e4[i2]).y0) > 0 && (r4.y0 += n3, r4.y1 += n3), o3 = r4.y1 + t3;
                if ((n3 = o3 - t3 - s2) > 0)
                  for (o3 = r4.y0 -= n3, r4.y1 -= n3, i2 = l3 - 2; i2 >= 0; --i2)
                    (n3 = (r4 = e4[i2]).y1 + t3 - o3) > 0 && (r4.y0 -= n3, r4.y1 -= n3), o3 = r4.y0;
              });
            }
          }
          function U2(t4) {
            t4.nodes.forEach(function(t5) {
              t5.sourceLinks.sort(g2), t5.targetLinks.sort(v);
            }), t4.nodes.forEach(function(t5) {
              var e4 = t5.y0, r4 = e4, n3 = t5.y1, i2 = n3;
              t5.sourceLinks.forEach(function(t6) {
                t6.circular ? (t6.y0 = n3 - t6.width / 2, n3 -= t6.width) : (t6.y0 = e4 + t6.width / 2, e4 += t6.width);
              }), t5.targetLinks.forEach(function(t6) {
                t6.circular ? (t6.y1 = i2 - t6.width / 2, i2 -= t6.width) : (t6.y1 = r4 + t6.width / 2, r4 += t6.width);
              });
            });
          }
          return z2.nodeId = function(t4) {
            return arguments.length ? (u2 = "function" == typeof t4 ? t4 : p2(t4), z2) : u2;
          }, z2.nodeAlign = function(t4) {
            return arguments.length ? (c2 = "function" == typeof t4 ? t4 : p2(t4), z2) : c2;
          }, z2.nodeWidth = function(t4) {
            return arguments.length ? (l2 = +t4, z2) : l2;
          }, z2.nodePadding = function(e4) {
            return arguments.length ? (t3 = +e4, z2) : t3;
          }, z2.nodes = function(t4) {
            return arguments.length ? (h2 = "function" == typeof t4 ? t4 : p2(t4), z2) : h2;
          }, z2.links = function(t4) {
            return arguments.length ? (M2 = "function" == typeof t4 ? t4 : p2(t4), z2) : M2;
          }, z2.size = function(t4) {
            return arguments.length ? (r3 = a2 = 0, o2 = +t4[0], s2 = +t4[1], z2) : [o2 - r3, s2 - a2];
          }, z2.extent = function(t4) {
            return arguments.length ? (r3 = +t4[0][0], o2 = +t4[1][0], a2 = +t4[0][1], s2 = +t4[1][1], z2) : [[r3, a2], [o2, s2]];
          }, z2.iterations = function(t4) {
            return arguments.length ? (L2 = +t4, z2) : L2;
          }, z2.circularLinkGap = function(t4) {
            return arguments.length ? (O2 = +t4, z2) : O2;
          }, z2.nodePaddingRatio = function(t4) {
            return arguments.length ? (e3 = +t4, z2) : e3;
          }, z2.sortNodes = function(t4) {
            return arguments.length ? (D2 = t4, z2) : D2;
          }, z2.update = function(t4) {
            return P(t4, u2), U2(t4), t4.links.forEach(function(t5) {
              t5.circular && (t5.circularLinkType = t5.y0 + t5.y1 < s2 ? "top" : "bottom", t5.source.circularLinkType = t5.circularLinkType, t5.target.circularLinkType = t5.circularLinkType);
            }), W(t4, s2, u2, false), X(t4, 0, u2), R(t4, O2, s2, u2), t4;
          }, z2;
        }
        function C(t3, e3, r3) {
          var n3 = 0;
          if (null === r3) {
            for (var i2 = [], a2 = 0; a2 < t3.links.length; a2++) {
              var o2 = t3.links[a2], l2 = o2.source.index, u2 = o2.target.index;
              i2[l2] || (i2[l2] = []), i2[u2] || (i2[u2] = []), -1 === i2[l2].indexOf(u2) && i2[l2].push(u2);
            }
            var c2 = s()(i2);
            c2.sort(function(t4, e4) {
              return t4.length - e4.length;
            });
            var f3 = {};
            for (a2 = 0; a2 < c2.length; a2++) {
              var h2 = c2[a2].slice(-2);
              f3[h2[0]] || (f3[h2[0]] = {}), f3[h2[0]][h2[1]] = true;
            }
            t3.links.forEach(function(t4) {
              var e4 = t4.target.index, r4 = t4.source.index;
              e4 === r4 || f3[r4] && f3[r4][e4] ? (t4.circular = true, t4.circularLinkID = n3, n3 += 1) : t4.circular = false;
            });
          } else
            t3.links.forEach(function(t4) {
              t4.source[r3] < t4.target[r3] ? t4.circular = false : (t4.circular = true, t4.circularLinkID = n3, n3 += 1);
            });
        }
        function P(t3, e3) {
          var r3 = 0, n3 = 0;
          t3.links.forEach(function(i2) {
            i2.circular && (i2.source.circularLinkType || i2.target.circularLinkType ? i2.circularLinkType = i2.source.circularLinkType ? i2.source.circularLinkType : i2.target.circularLinkType : i2.circularLinkType = r3 < n3 ? "top" : "bottom", "top" == i2.circularLinkType ? r3 += 1 : n3 += 1, t3.nodes.forEach(function(t4) {
              M(t4, e3) != M(i2.source, e3) && M(t4, e3) != M(i2.target, e3) || (t4.circularLinkType = i2.circularLinkType);
            }));
          }), t3.links.forEach(function(t4) {
            t4.circular && (t4.source.circularLinkType == t4.target.circularLinkType && (t4.circularLinkType = t4.source.circularLinkType), $(t4, e3) && (t4.circularLinkType = t4.source.circularLinkType));
          });
        }
        function O(t3) {
          var e3 = Math.abs(t3.y1 - t3.y0), r3 = Math.abs(t3.target.x0 - t3.source.x1);
          return Math.atan(r3 / e3);
        }
        function I(t3, e3) {
          var r3 = 0;
          t3.sourceLinks.forEach(function(t4) {
            r3 = t4.circular && !$(t4, e3) ? r3 + 1 : r3;
          });
          var n3 = 0;
          return t3.targetLinks.forEach(function(t4) {
            n3 = t4.circular && !$(t4, e3) ? n3 + 1 : n3;
          }), r3 + n3;
        }
        function D(t3) {
          var e3 = t3.source.sourceLinks, r3 = 0;
          e3.forEach(function(t4) {
            r3 = t4.circular ? r3 + 1 : r3;
          });
          var n3 = t3.target.targetLinks, i2 = 0;
          return n3.forEach(function(t4) {
            i2 = t4.circular ? i2 + 1 : i2;
          }), !(r3 > 1 || i2 > 1);
        }
        function z(t3, e3, r3) {
          return t3.sort(F), t3.forEach(function(n3, i2) {
            var a2, o2, s2 = 0;
            if ($(n3, r3) && D(n3))
              n3.circularPathData.verticalBuffer = s2 + n3.width / 2;
            else {
              for (var l2 = 0; l2 < i2; l2++)
                if (a2 = t3[i2], o2 = t3[l2], !(a2.source.column < o2.target.column || a2.target.column > o2.source.column)) {
                  var u2 = t3[l2].circularPathData.verticalBuffer + t3[l2].width / 2 + e3;
                  s2 = u2 > s2 ? u2 : s2;
                }
              n3.circularPathData.verticalBuffer = s2 + n3.width / 2;
            }
          }), t3;
        }
        function R(t3, e3, r3, i2) {
          var o2 = (0, n2.VV)(t3.links, function(t4) {
            return t4.source.y0;
          });
          t3.links.forEach(function(t4) {
            t4.circular && (t4.circularPathData = {});
          }), z(t3.links.filter(function(t4) {
            return "top" == t4.circularLinkType;
          }), e3, i2), z(t3.links.filter(function(t4) {
            return "bottom" == t4.circularLinkType;
          }), e3, i2), t3.links.forEach(function(n3) {
            if (n3.circular) {
              if (n3.circularPathData.arcRadius = n3.width + E, n3.circularPathData.leftNodeBuffer = 5, n3.circularPathData.rightNodeBuffer = 5, n3.circularPathData.sourceWidth = n3.source.x1 - n3.source.x0, n3.circularPathData.sourceX = n3.source.x0 + n3.circularPathData.sourceWidth, n3.circularPathData.targetX = n3.target.x0, n3.circularPathData.sourceY = n3.y0, n3.circularPathData.targetY = n3.y1, $(n3, i2) && D(n3))
                n3.circularPathData.leftSmallArcRadius = E + n3.width / 2, n3.circularPathData.leftLargeArcRadius = E + n3.width / 2, n3.circularPathData.rightSmallArcRadius = E + n3.width / 2, n3.circularPathData.rightLargeArcRadius = E + n3.width / 2, "bottom" == n3.circularLinkType ? (n3.circularPathData.verticalFullExtent = n3.source.y1 + S + n3.circularPathData.verticalBuffer, n3.circularPathData.verticalLeftInnerExtent = n3.circularPathData.verticalFullExtent - n3.circularPathData.leftLargeArcRadius, n3.circularPathData.verticalRightInnerExtent = n3.circularPathData.verticalFullExtent - n3.circularPathData.rightLargeArcRadius) : (n3.circularPathData.verticalFullExtent = n3.source.y0 - S - n3.circularPathData.verticalBuffer, n3.circularPathData.verticalLeftInnerExtent = n3.circularPathData.verticalFullExtent + n3.circularPathData.leftLargeArcRadius, n3.circularPathData.verticalRightInnerExtent = n3.circularPathData.verticalFullExtent + n3.circularPathData.rightLargeArcRadius);
              else {
                var s2 = n3.source.column, l2 = n3.circularLinkType, u2 = t3.links.filter(function(t4) {
                  return t4.source.column == s2 && t4.circularLinkType == l2;
                });
                "bottom" == n3.circularLinkType ? u2.sort(N) : u2.sort(B);
                var c2 = 0;
                u2.forEach(function(t4, r4) {
                  t4.circularLinkID == n3.circularLinkID && (n3.circularPathData.leftSmallArcRadius = E + n3.width / 2 + c2, n3.circularPathData.leftLargeArcRadius = E + n3.width / 2 + r4 * e3 + c2), c2 += t4.width;
                }), s2 = n3.target.column, u2 = t3.links.filter(function(t4) {
                  return t4.target.column == s2 && t4.circularLinkType == l2;
                }), "bottom" == n3.circularLinkType ? u2.sort(U) : u2.sort(j), c2 = 0, u2.forEach(function(t4, r4) {
                  t4.circularLinkID == n3.circularLinkID && (n3.circularPathData.rightSmallArcRadius = E + n3.width / 2 + c2, n3.circularPathData.rightLargeArcRadius = E + n3.width / 2 + r4 * e3 + c2), c2 += t4.width;
                }), "bottom" == n3.circularLinkType ? (n3.circularPathData.verticalFullExtent = Math.max(r3, n3.source.y1, n3.target.y1) + S + n3.circularPathData.verticalBuffer, n3.circularPathData.verticalLeftInnerExtent = n3.circularPathData.verticalFullExtent - n3.circularPathData.leftLargeArcRadius, n3.circularPathData.verticalRightInnerExtent = n3.circularPathData.verticalFullExtent - n3.circularPathData.rightLargeArcRadius) : (n3.circularPathData.verticalFullExtent = o2 - S - n3.circularPathData.verticalBuffer, n3.circularPathData.verticalLeftInnerExtent = n3.circularPathData.verticalFullExtent + n3.circularPathData.leftLargeArcRadius, n3.circularPathData.verticalRightInnerExtent = n3.circularPathData.verticalFullExtent + n3.circularPathData.rightLargeArcRadius);
              }
              n3.circularPathData.leftInnerExtent = n3.circularPathData.sourceX + n3.circularPathData.leftNodeBuffer, n3.circularPathData.rightInnerExtent = n3.circularPathData.targetX - n3.circularPathData.rightNodeBuffer, n3.circularPathData.leftFullExtent = n3.circularPathData.sourceX + n3.circularPathData.leftLargeArcRadius + n3.circularPathData.leftNodeBuffer, n3.circularPathData.rightFullExtent = n3.circularPathData.targetX - n3.circularPathData.rightLargeArcRadius - n3.circularPathData.rightNodeBuffer;
            }
            if (n3.circular)
              n3.path = function(t4) {
                return "top" == t4.circularLinkType ? "M" + t4.circularPathData.sourceX + " " + t4.circularPathData.sourceY + " L" + t4.circularPathData.leftInnerExtent + " " + t4.circularPathData.sourceY + " A" + t4.circularPathData.leftLargeArcRadius + " " + t4.circularPathData.leftSmallArcRadius + " 0 0 0 " + t4.circularPathData.leftFullExtent + " " + (t4.circularPathData.sourceY - t4.circularPathData.leftSmallArcRadius) + " L" + t4.circularPathData.leftFullExtent + " " + t4.circularPathData.verticalLeftInnerExtent + " A" + t4.circularPathData.leftLargeArcRadius + " " + t4.circularPathData.leftLargeArcRadius + " 0 0 0 " + t4.circularPathData.leftInnerExtent + " " + t4.circularPathData.verticalFullExtent + " L" + t4.circularPathData.rightInnerExtent + " " + t4.circularPathData.verticalFullExtent + " A" + t4.circularPathData.rightLargeArcRadius + " " + t4.circularPathData.rightLargeArcRadius + " 0 0 0 " + t4.circularPathData.rightFullExtent + " " + t4.circularPathData.verticalRightInnerExtent + " L" + t4.circularPathData.rightFullExtent + " " + (t4.circularPathData.targetY - t4.circularPathData.rightSmallArcRadius) + " A" + t4.circularPathData.rightLargeArcRadius + " " + t4.circularPathData.rightSmallArcRadius + " 0 0 0 " + t4.circularPathData.rightInnerExtent + " " + t4.circularPathData.targetY + " L" + t4.circularPathData.targetX + " " + t4.circularPathData.targetY : "M" + t4.circularPathData.sourceX + " " + t4.circularPathData.sourceY + " L" + t4.circularPathData.leftInnerExtent + " " + t4.circularPathData.sourceY + " A" + t4.circularPathData.leftLargeArcRadius + " " + t4.circularPathData.leftSmallArcRadius + " 0 0 1 " + t4.circularPathData.leftFullExtent + " " + (t4.circularPathData.sourceY + t4.circularPathData.leftSmallArcRadius) + " L" + t4.circularPathData.leftFullExtent + " " + t4.circularPathData.verticalLeftInnerExtent + " A" + t4.circularPathData.leftLargeArcRadius + " " + t4.circularPathData.leftLargeArcRadius + " 0 0 1 " + t4.circularPathData.leftInnerExtent + " " + t4.circularPathData.verticalFullExtent + " L" + t4.circularPathData.rightInnerExtent + " " + t4.circularPathData.verticalFullExtent + " A" + t4.circularPathData.rightLargeArcRadius + " " + t4.circularPathData.rightLargeArcRadius + " 0 0 1 " + t4.circularPathData.rightFullExtent + " " + t4.circularPathData.verticalRightInnerExtent + " L" + t4.circularPathData.rightFullExtent + " " + (t4.circularPathData.targetY + t4.circularPathData.rightSmallArcRadius) + " A" + t4.circularPathData.rightLargeArcRadius + " " + t4.circularPathData.rightSmallArcRadius + " 0 0 1 " + t4.circularPathData.rightInnerExtent + " " + t4.circularPathData.targetY + " L" + t4.circularPathData.targetX + " " + t4.circularPathData.targetY;
              }(n3);
            else {
              var f3 = (0, a.h5)().source(function(t4) {
                return [t4.source.x0 + (t4.source.x1 - t4.source.x0), t4.y0];
              }).target(function(t4) {
                return [t4.target.x0, t4.y1];
              });
              n3.path = f3(n3);
            }
          });
        }
        function F(t3, e3) {
          return V(t3) == V(e3) ? "bottom" == t3.circularLinkType ? N(t3, e3) : B(t3, e3) : V(e3) - V(t3);
        }
        function B(t3, e3) {
          return t3.y0 - e3.y0;
        }
        function N(t3, e3) {
          return e3.y0 - t3.y0;
        }
        function j(t3, e3) {
          return t3.y1 - e3.y1;
        }
        function U(t3, e3) {
          return e3.y1 - t3.y1;
        }
        function V(t3) {
          return t3.target.column - t3.source.column;
        }
        function H(t3) {
          return t3.target.x0 - t3.source.x1;
        }
        function q2(t3, e3) {
          var r3 = O(t3), n3 = H(e3) / Math.tan(r3);
          return "up" == K(t3) ? t3.y1 + n3 : t3.y1 - n3;
        }
        function G(t3, e3) {
          var r3 = O(t3), n3 = H(e3) / Math.tan(r3);
          return "up" == K(t3) ? t3.y1 - n3 : t3.y1 + n3;
        }
        function Z(t3, e3, r3, n3) {
          t3.links.forEach(function(i2) {
            if (!i2.circular && i2.target.column - i2.source.column > 1) {
              var a2 = i2.source.column + 1, o2 = i2.target.column - 1, s2 = 1, l2 = o2 - a2 + 1;
              for (s2 = 1; a2 <= o2; a2++, s2++)
                t3.nodes.forEach(function(o3) {
                  if (o3.column == a2) {
                    var u2, c2 = s2 / (l2 + 1), f3 = Math.pow(1 - c2, 3), h2 = 3 * c2 * Math.pow(1 - c2, 2), p3 = 3 * Math.pow(c2, 2) * (1 - c2), d3 = Math.pow(c2, 3), v2 = f3 * i2.y0 + h2 * i2.y0 + p3 * i2.y1 + d3 * i2.y1, g3 = v2 - i2.width / 2, y2 = v2 + i2.width / 2;
                    g3 > o3.y0 && g3 < o3.y1 ? (u2 = o3.y1 - g3 + 10, u2 = "bottom" == o3.circularLinkType ? u2 : -u2, o3 = Y(o3, u2, e3, r3), t3.nodes.forEach(function(t4) {
                      var i3, a3;
                      M(t4, n3) != M(o3, n3) && t4.column == o3.column && (a3 = t4, (i3 = o3).y0 > a3.y0 && i3.y0 < a3.y1 || i3.y1 > a3.y0 && i3.y1 < a3.y1 || i3.y0 < a3.y0 && i3.y1 > a3.y1) && Y(t4, u2, e3, r3);
                    })) : (y2 > o3.y0 && y2 < o3.y1 || g3 < o3.y0 && y2 > o3.y1) && (u2 = y2 - o3.y0 + 10, o3 = Y(o3, u2, e3, r3), t3.nodes.forEach(function(t4) {
                      M(t4, n3) != M(o3, n3) && t4.column == o3.column && t4.y0 < o3.y1 && t4.y1 > o3.y1 && Y(t4, u2, e3, r3);
                    }));
                  }
                });
            }
          });
        }
        function Y(t3, e3, r3, n3) {
          return t3.y0 + e3 >= r3 && t3.y1 + e3 <= n3 && (t3.y0 = t3.y0 + e3, t3.y1 = t3.y1 + e3, t3.targetLinks.forEach(function(t4) {
            t4.y1 = t4.y1 + e3;
          }), t3.sourceLinks.forEach(function(t4) {
            t4.y0 = t4.y0 + e3;
          })), t3;
        }
        function W(t3, e3, r3, n3) {
          t3.nodes.forEach(function(i2) {
            n3 && i2.y + (i2.y1 - i2.y0) > e3 && (i2.y = i2.y - (i2.y + (i2.y1 - i2.y0) - e3));
            var a2 = t3.links.filter(function(t4) {
              return M(t4.source, r3) == M(i2, r3);
            }), o2 = a2.length;
            o2 > 1 && a2.sort(function(t4, e4) {
              if (!t4.circular && !e4.circular) {
                if (t4.target.column == e4.target.column)
                  return t4.y1 - e4.y1;
                if (!J(t4, e4))
                  return t4.y1 - e4.y1;
                if (t4.target.column > e4.target.column) {
                  var r4 = G(e4, t4);
                  return t4.y1 - r4;
                }
                if (e4.target.column > t4.target.column)
                  return G(t4, e4) - e4.y1;
              }
              return t4.circular && !e4.circular ? "top" == t4.circularLinkType ? -1 : 1 : e4.circular && !t4.circular ? "top" == e4.circularLinkType ? 1 : -1 : t4.circular && e4.circular ? t4.circularLinkType === e4.circularLinkType && "top" == t4.circularLinkType ? t4.target.column === e4.target.column ? t4.target.y1 - e4.target.y1 : e4.target.column - t4.target.column : t4.circularLinkType === e4.circularLinkType && "bottom" == t4.circularLinkType ? t4.target.column === e4.target.column ? e4.target.y1 - t4.target.y1 : t4.target.column - e4.target.column : "top" == t4.circularLinkType ? -1 : 1 : void 0;
            });
            var s2 = i2.y0;
            a2.forEach(function(t4) {
              t4.y0 = s2 + t4.width / 2, s2 += t4.width;
            }), a2.forEach(function(t4, e4) {
              if ("bottom" == t4.circularLinkType) {
                for (var r4 = e4 + 1, n4 = 0; r4 < o2; r4++)
                  n4 += a2[r4].width;
                t4.y0 = i2.y1 - n4 - t4.width / 2;
              }
            });
          });
        }
        function X(t3, e3, r3) {
          t3.nodes.forEach(function(e4) {
            var n3 = t3.links.filter(function(t4) {
              return M(t4.target, r3) == M(e4, r3);
            }), i2 = n3.length;
            i2 > 1 && n3.sort(function(t4, e5) {
              if (!t4.circular && !e5.circular) {
                if (t4.source.column == e5.source.column)
                  return t4.y0 - e5.y0;
                if (!J(t4, e5))
                  return t4.y0 - e5.y0;
                if (e5.source.column < t4.source.column) {
                  var r4 = q2(e5, t4);
                  return t4.y0 - r4;
                }
                if (t4.source.column < e5.source.column)
                  return q2(t4, e5) - e5.y0;
              }
              return t4.circular && !e5.circular ? "top" == t4.circularLinkType ? -1 : 1 : e5.circular && !t4.circular ? "top" == e5.circularLinkType ? 1 : -1 : t4.circular && e5.circular ? t4.circularLinkType === e5.circularLinkType && "top" == t4.circularLinkType ? t4.source.column === e5.source.column ? t4.source.y1 - e5.source.y1 : t4.source.column - e5.source.column : t4.circularLinkType === e5.circularLinkType && "bottom" == t4.circularLinkType ? t4.source.column === e5.source.column ? t4.source.y1 - e5.source.y1 : e5.source.column - t4.source.column : "top" == t4.circularLinkType ? -1 : 1 : void 0;
            });
            var a2 = e4.y0;
            n3.forEach(function(t4) {
              t4.y1 = a2 + t4.width / 2, a2 += t4.width;
            }), n3.forEach(function(t4, r4) {
              if ("bottom" == t4.circularLinkType) {
                for (var a3 = r4 + 1, o2 = 0; a3 < i2; a3++)
                  o2 += n3[a3].width;
                t4.y1 = e4.y1 - o2 - t4.width / 2;
              }
            });
          });
        }
        function J(t3, e3) {
          return K(t3) == K(e3);
        }
        function K(t3) {
          return t3.y0 - t3.y1 > 0 ? "up" : "down";
        }
        function $(t3, e3) {
          return M(t3.source, e3) == M(t3.target, e3);
        }
        function Q(t3, e3, r3) {
          var i2 = t3.nodes, a2 = t3.links, o2 = false, s2 = false;
          if (a2.forEach(function(t4) {
            "top" == t4.circularLinkType ? o2 = true : "bottom" == t4.circularLinkType && (s2 = true);
          }), 0 == o2 || 0 == s2) {
            var l2 = (0, n2.VV)(i2, function(t4) {
              return t4.y0;
            }), u2 = (r3 - e3) / ((0, n2.Fp)(i2, function(t4) {
              return t4.y1;
            }) - l2);
            i2.forEach(function(t4) {
              var e4 = (t4.y1 - t4.y0) * u2;
              t4.y0 = (t4.y0 - l2) * u2, t4.y1 = t4.y0 + e4;
            }), a2.forEach(function(t4) {
              t4.y0 = (t4.y0 - l2) * u2, t4.y1 = (t4.y1 - l2) * u2, t4.width = t4.width * u2;
            });
          }
        }
      }, 30838: function(t2, e2, r2) {
        r2.r(e2), r2.d(e2, { sankey: function() {
          return w2;
        }, sankeyCenter: function() {
          return u;
        }, sankeyJustify: function() {
          return l;
        }, sankeyLeft: function() {
          return o;
        }, sankeyLinkHorizontal: function() {
          return M;
        }, sankeyRight: function() {
          return s;
        } });
        var n2 = r2(33064), i = r2(15140);
        function a(t3) {
          return t3.target.depth;
        }
        function o(t3) {
          return t3.depth;
        }
        function s(t3, e3) {
          return e3 - 1 - t3.height;
        }
        function l(t3, e3) {
          return t3.sourceLinks.length ? t3.depth : e3 - 1;
        }
        function u(t3) {
          return t3.targetLinks.length ? t3.depth : t3.sourceLinks.length ? (0, n2.VV)(t3.sourceLinks, a) - 1 : 0;
        }
        function c(t3) {
          return function() {
            return t3;
          };
        }
        function f2(t3, e3) {
          return p2(t3.source, e3.source) || t3.index - e3.index;
        }
        function h(t3, e3) {
          return p2(t3.target, e3.target) || t3.index - e3.index;
        }
        function p2(t3, e3) {
          return t3.y0 - e3.y0;
        }
        function d2(t3) {
          return t3.value;
        }
        function v(t3) {
          return (t3.y0 + t3.y1) / 2;
        }
        function g2(t3) {
          return v(t3.source) * t3.value;
        }
        function y(t3) {
          return v(t3.target) * t3.value;
        }
        function m2(t3) {
          return t3.index;
        }
        function x(t3) {
          return t3.nodes;
        }
        function b(t3) {
          return t3.links;
        }
        function _(t3, e3) {
          var r3 = t3.get(e3);
          if (!r3)
            throw new Error("missing: " + e3);
          return r3;
        }
        function w2() {
          var t3 = 0, e3 = 0, r3 = 1, a2 = 1, o2 = 24, s2 = 8, u2 = m2, w3 = l, T2 = x, k2 = b, A2 = 32;
          function M2() {
            var t4 = { nodes: T2.apply(null, arguments), links: k2.apply(null, arguments) };
            return S(t4), E(t4), L(t4), C(t4), P(t4), t4;
          }
          function S(t4) {
            t4.nodes.forEach(function(t5, e5) {
              t5.index = e5, t5.sourceLinks = [], t5.targetLinks = [];
            });
            var e4 = (0, i.UI)(t4.nodes, u2);
            t4.links.forEach(function(t5, r4) {
              t5.index = r4;
              var n3 = t5.source, i2 = t5.target;
              "object" != typeof n3 && (n3 = t5.source = _(e4, n3)), "object" != typeof i2 && (i2 = t5.target = _(e4, i2)), n3.sourceLinks.push(t5), i2.targetLinks.push(t5);
            });
          }
          function E(t4) {
            t4.nodes.forEach(function(t5) {
              t5.value = Math.max((0, n2.Sm)(t5.sourceLinks, d2), (0, n2.Sm)(t5.targetLinks, d2));
            });
          }
          function L(e4) {
            var n3, i2, a3;
            for (n3 = e4.nodes, i2 = [], a3 = 0; n3.length; ++a3, n3 = i2, i2 = [])
              n3.forEach(function(t4) {
                t4.depth = a3, t4.sourceLinks.forEach(function(t5) {
                  i2.indexOf(t5.target) < 0 && i2.push(t5.target);
                });
              });
            for (n3 = e4.nodes, i2 = [], a3 = 0; n3.length; ++a3, n3 = i2, i2 = [])
              n3.forEach(function(t4) {
                t4.height = a3, t4.targetLinks.forEach(function(t5) {
                  i2.indexOf(t5.source) < 0 && i2.push(t5.source);
                });
              });
            var s3 = (r3 - t3 - o2) / (a3 - 1);
            e4.nodes.forEach(function(e5) {
              e5.x1 = (e5.x0 = t3 + Math.max(0, Math.min(a3 - 1, Math.floor(w3.call(null, e5, a3)))) * s3) + o2;
            });
          }
          function C(t4) {
            var r4 = (0, i.b1)().key(function(t5) {
              return t5.x0;
            }).sortKeys(n2.j2).entries(t4.nodes).map(function(t5) {
              return t5.values;
            });
            !function() {
              var i2 = (0, n2.Fp)(r4, function(t5) {
                return t5.length;
              }), o4 = 0.6666666666666666 * (a2 - e3) / (i2 - 1);
              s2 > o4 && (s2 = o4);
              var l3 = (0, n2.VV)(r4, function(t5) {
                return (a2 - e3 - (t5.length - 1) * s2) / (0, n2.Sm)(t5, d2);
              });
              r4.forEach(function(t5) {
                t5.forEach(function(t6, e4) {
                  t6.y1 = (t6.y0 = e4) + t6.value * l3;
                });
              }), t4.links.forEach(function(t5) {
                t5.width = t5.value * l3;
              });
            }(), f3();
            for (var o3 = 1, l2 = A2; l2 > 0; --l2)
              c2(o3 *= 0.99), f3(), u3(o3), f3();
            function u3(t5) {
              r4.forEach(function(e4) {
                e4.forEach(function(e5) {
                  if (e5.targetLinks.length) {
                    var r5 = ((0, n2.Sm)(e5.targetLinks, g2) / (0, n2.Sm)(e5.targetLinks, d2) - v(e5)) * t5;
                    e5.y0 += r5, e5.y1 += r5;
                  }
                });
              });
            }
            function c2(t5) {
              r4.slice().reverse().forEach(function(e4) {
                e4.forEach(function(e5) {
                  if (e5.sourceLinks.length) {
                    var r5 = ((0, n2.Sm)(e5.sourceLinks, y) / (0, n2.Sm)(e5.sourceLinks, d2) - v(e5)) * t5;
                    e5.y0 += r5, e5.y1 += r5;
                  }
                });
              });
            }
            function f3() {
              r4.forEach(function(t5) {
                var r5, n3, i2, o4 = e3, l3 = t5.length;
                for (t5.sort(p2), i2 = 0; i2 < l3; ++i2)
                  (n3 = o4 - (r5 = t5[i2]).y0) > 0 && (r5.y0 += n3, r5.y1 += n3), o4 = r5.y1 + s2;
                if ((n3 = o4 - s2 - a2) > 0)
                  for (o4 = r5.y0 -= n3, r5.y1 -= n3, i2 = l3 - 2; i2 >= 0; --i2)
                    (n3 = (r5 = t5[i2]).y1 + s2 - o4) > 0 && (r5.y0 -= n3, r5.y1 -= n3), o4 = r5.y0;
              });
            }
          }
          function P(t4) {
            t4.nodes.forEach(function(t5) {
              t5.sourceLinks.sort(h), t5.targetLinks.sort(f2);
            }), t4.nodes.forEach(function(t5) {
              var e4 = t5.y0, r4 = e4;
              t5.sourceLinks.forEach(function(t6) {
                t6.y0 = e4 + t6.width / 2, e4 += t6.width;
              }), t5.targetLinks.forEach(function(t6) {
                t6.y1 = r4 + t6.width / 2, r4 += t6.width;
              });
            });
          }
          return M2.update = function(t4) {
            return P(t4), t4;
          }, M2.nodeId = function(t4) {
            return arguments.length ? (u2 = "function" == typeof t4 ? t4 : c(t4), M2) : u2;
          }, M2.nodeAlign = function(t4) {
            return arguments.length ? (w3 = "function" == typeof t4 ? t4 : c(t4), M2) : w3;
          }, M2.nodeWidth = function(t4) {
            return arguments.length ? (o2 = +t4, M2) : o2;
          }, M2.nodePadding = function(t4) {
            return arguments.length ? (s2 = +t4, M2) : s2;
          }, M2.nodes = function(t4) {
            return arguments.length ? (T2 = "function" == typeof t4 ? t4 : c(t4), M2) : T2;
          }, M2.links = function(t4) {
            return arguments.length ? (k2 = "function" == typeof t4 ? t4 : c(t4), M2) : k2;
          }, M2.size = function(n3) {
            return arguments.length ? (t3 = e3 = 0, r3 = +n3[0], a2 = +n3[1], M2) : [r3 - t3, a2 - e3];
          }, M2.extent = function(n3) {
            return arguments.length ? (t3 = +n3[0][0], r3 = +n3[1][0], e3 = +n3[0][1], a2 = +n3[1][1], M2) : [[t3, e3], [r3, a2]];
          }, M2.iterations = function(t4) {
            return arguments.length ? (A2 = +t4, M2) : A2;
          }, M2;
        }
        var T = r2(45879);
        function k(t3) {
          return [t3.source.x1, t3.y0];
        }
        function A(t3) {
          return [t3.target.x0, t3.y1];
        }
        function M() {
          return (0, T.h5)().source(k).target(A);
        }
      }, 39898: function(t2, e2, r2) {
        var n2, i;
        (function() {
          var a = { version: "3.8.0" }, o = [].slice, s = function(t3) {
            return o.call(t3);
          }, l = self.document;
          function u(t3) {
            return t3 && (t3.ownerDocument || t3.document || t3).documentElement;
          }
          function c(t3) {
            return t3 && (t3.ownerDocument && t3.ownerDocument.defaultView || t3.document && t3 || t3.defaultView);
          }
          if (l)
            try {
              s(l.documentElement.childNodes)[0].nodeType;
            } catch (t3) {
              s = function(t4) {
                for (var e3 = t4.length, r3 = new Array(e3); e3--; )
                  r3[e3] = t4[e3];
                return r3;
              };
            }
          if (Date.now || (Date.now = function() {
            return +new Date();
          }), l)
            try {
              l.createElement("DIV").style.setProperty("opacity", 0, "");
            } catch (t3) {
              var f2 = this.Element.prototype, h = f2.setAttribute, p2 = f2.setAttributeNS, d2 = this.CSSStyleDeclaration.prototype, v = d2.setProperty;
              f2.setAttribute = function(t4, e3) {
                h.call(this, t4, e3 + "");
              }, f2.setAttributeNS = function(t4, e3, r3) {
                p2.call(this, t4, e3, r3 + "");
              }, d2.setProperty = function(t4, e3, r3) {
                v.call(this, t4, e3 + "", r3);
              };
            }
          function g2(t3, e3) {
            return t3 < e3 ? -1 : t3 > e3 ? 1 : t3 >= e3 ? 0 : NaN;
          }
          function y(t3) {
            return null === t3 ? NaN : +t3;
          }
          function m2(t3) {
            return !isNaN(t3);
          }
          function x(t3) {
            return { left: function(e3, r3, n3, i2) {
              for (arguments.length < 3 && (n3 = 0), arguments.length < 4 && (i2 = e3.length); n3 < i2; ) {
                var a2 = n3 + i2 >>> 1;
                t3(e3[a2], r3) < 0 ? n3 = a2 + 1 : i2 = a2;
              }
              return n3;
            }, right: function(e3, r3, n3, i2) {
              for (arguments.length < 3 && (n3 = 0), arguments.length < 4 && (i2 = e3.length); n3 < i2; ) {
                var a2 = n3 + i2 >>> 1;
                t3(e3[a2], r3) > 0 ? i2 = a2 : n3 = a2 + 1;
              }
              return n3;
            } };
          }
          a.ascending = g2, a.descending = function(t3, e3) {
            return e3 < t3 ? -1 : e3 > t3 ? 1 : e3 >= t3 ? 0 : NaN;
          }, a.min = function(t3, e3) {
            var r3, n3, i2 = -1, a2 = t3.length;
            if (1 === arguments.length) {
              for (; ++i2 < a2; )
                if (null != (n3 = t3[i2]) && n3 >= n3) {
                  r3 = n3;
                  break;
                }
              for (; ++i2 < a2; )
                null != (n3 = t3[i2]) && r3 > n3 && (r3 = n3);
            } else {
              for (; ++i2 < a2; )
                if (null != (n3 = e3.call(t3, t3[i2], i2)) && n3 >= n3) {
                  r3 = n3;
                  break;
                }
              for (; ++i2 < a2; )
                null != (n3 = e3.call(t3, t3[i2], i2)) && r3 > n3 && (r3 = n3);
            }
            return r3;
          }, a.max = function(t3, e3) {
            var r3, n3, i2 = -1, a2 = t3.length;
            if (1 === arguments.length) {
              for (; ++i2 < a2; )
                if (null != (n3 = t3[i2]) && n3 >= n3) {
                  r3 = n3;
                  break;
                }
              for (; ++i2 < a2; )
                null != (n3 = t3[i2]) && n3 > r3 && (r3 = n3);
            } else {
              for (; ++i2 < a2; )
                if (null != (n3 = e3.call(t3, t3[i2], i2)) && n3 >= n3) {
                  r3 = n3;
                  break;
                }
              for (; ++i2 < a2; )
                null != (n3 = e3.call(t3, t3[i2], i2)) && n3 > r3 && (r3 = n3);
            }
            return r3;
          }, a.extent = function(t3, e3) {
            var r3, n3, i2, a2 = -1, o2 = t3.length;
            if (1 === arguments.length) {
              for (; ++a2 < o2; )
                if (null != (n3 = t3[a2]) && n3 >= n3) {
                  r3 = i2 = n3;
                  break;
                }
              for (; ++a2 < o2; )
                null != (n3 = t3[a2]) && (r3 > n3 && (r3 = n3), i2 < n3 && (i2 = n3));
            } else {
              for (; ++a2 < o2; )
                if (null != (n3 = e3.call(t3, t3[a2], a2)) && n3 >= n3) {
                  r3 = i2 = n3;
                  break;
                }
              for (; ++a2 < o2; )
                null != (n3 = e3.call(t3, t3[a2], a2)) && (r3 > n3 && (r3 = n3), i2 < n3 && (i2 = n3));
            }
            return [r3, i2];
          }, a.sum = function(t3, e3) {
            var r3, n3 = 0, i2 = t3.length, a2 = -1;
            if (1 === arguments.length)
              for (; ++a2 < i2; )
                m2(r3 = +t3[a2]) && (n3 += r3);
            else
              for (; ++a2 < i2; )
                m2(r3 = +e3.call(t3, t3[a2], a2)) && (n3 += r3);
            return n3;
          }, a.mean = function(t3, e3) {
            var r3, n3 = 0, i2 = t3.length, a2 = -1, o2 = i2;
            if (1 === arguments.length)
              for (; ++a2 < i2; )
                m2(r3 = y(t3[a2])) ? n3 += r3 : --o2;
            else
              for (; ++a2 < i2; )
                m2(r3 = y(e3.call(t3, t3[a2], a2))) ? n3 += r3 : --o2;
            if (o2)
              return n3 / o2;
          }, a.quantile = function(t3, e3) {
            var r3 = (t3.length - 1) * e3 + 1, n3 = Math.floor(r3), i2 = +t3[n3 - 1], a2 = r3 - n3;
            return a2 ? i2 + a2 * (t3[n3] - i2) : i2;
          }, a.median = function(t3, e3) {
            var r3, n3 = [], i2 = t3.length, o2 = -1;
            if (1 === arguments.length)
              for (; ++o2 < i2; )
                m2(r3 = y(t3[o2])) && n3.push(r3);
            else
              for (; ++o2 < i2; )
                m2(r3 = y(e3.call(t3, t3[o2], o2))) && n3.push(r3);
            if (n3.length)
              return a.quantile(n3.sort(g2), 0.5);
          }, a.variance = function(t3, e3) {
            var r3, n3, i2 = t3.length, a2 = 0, o2 = 0, s2 = -1, l2 = 0;
            if (1 === arguments.length)
              for (; ++s2 < i2; )
                m2(r3 = y(t3[s2])) && (o2 += (n3 = r3 - a2) * (r3 - (a2 += n3 / ++l2)));
            else
              for (; ++s2 < i2; )
                m2(r3 = y(e3.call(t3, t3[s2], s2))) && (o2 += (n3 = r3 - a2) * (r3 - (a2 += n3 / ++l2)));
            if (l2 > 1)
              return o2 / (l2 - 1);
          }, a.deviation = function() {
            var t3 = a.variance.apply(this, arguments);
            return t3 ? Math.sqrt(t3) : t3;
          };
          var b = x(g2);
          function _(t3) {
            return t3.length;
          }
          a.bisectLeft = b.left, a.bisect = a.bisectRight = b.right, a.bisector = function(t3) {
            return x(1 === t3.length ? function(e3, r3) {
              return g2(t3(e3), r3);
            } : t3);
          }, a.shuffle = function(t3, e3, r3) {
            (a2 = arguments.length) < 3 && (r3 = t3.length, a2 < 2 && (e3 = 0));
            for (var n3, i2, a2 = r3 - e3; a2; )
              i2 = Math.random() * a2-- | 0, n3 = t3[a2 + e3], t3[a2 + e3] = t3[i2 + e3], t3[i2 + e3] = n3;
            return t3;
          }, a.permute = function(t3, e3) {
            for (var r3 = e3.length, n3 = new Array(r3); r3--; )
              n3[r3] = t3[e3[r3]];
            return n3;
          }, a.pairs = function(t3) {
            for (var e3 = 0, r3 = t3.length - 1, n3 = t3[0], i2 = new Array(r3 < 0 ? 0 : r3); e3 < r3; )
              i2[e3] = [n3, n3 = t3[++e3]];
            return i2;
          }, a.transpose = function(t3) {
            if (!(i2 = t3.length))
              return [];
            for (var e3 = -1, r3 = a.min(t3, _), n3 = new Array(r3); ++e3 < r3; )
              for (var i2, o2 = -1, s2 = n3[e3] = new Array(i2); ++o2 < i2; )
                s2[o2] = t3[o2][e3];
            return n3;
          }, a.zip = function() {
            return a.transpose(arguments);
          }, a.keys = function(t3) {
            var e3 = [];
            for (var r3 in t3)
              e3.push(r3);
            return e3;
          }, a.values = function(t3) {
            var e3 = [];
            for (var r3 in t3)
              e3.push(t3[r3]);
            return e3;
          }, a.entries = function(t3) {
            var e3 = [];
            for (var r3 in t3)
              e3.push({ key: r3, value: t3[r3] });
            return e3;
          }, a.merge = function(t3) {
            for (var e3, r3, n3, i2 = t3.length, a2 = -1, o2 = 0; ++a2 < i2; )
              o2 += t3[a2].length;
            for (r3 = new Array(o2); --i2 >= 0; )
              for (e3 = (n3 = t3[i2]).length; --e3 >= 0; )
                r3[--o2] = n3[e3];
            return r3;
          };
          var w2 = Math.abs;
          function T(t3) {
            for (var e3 = 1; t3 * e3 % 1; )
              e3 *= 10;
            return e3;
          }
          function k(t3, e3) {
            for (var r3 in e3)
              Object.defineProperty(t3.prototype, r3, { value: e3[r3], enumerable: false });
          }
          function A() {
            this._ = /* @__PURE__ */ Object.create(null);
          }
          function M(t3) {
            return "__proto__" == (t3 += "") || "\0" === t3[0] ? "\0" + t3 : t3;
          }
          function S(t3) {
            return "\0" === (t3 += "")[0] ? t3.slice(1) : t3;
          }
          function E(t3) {
            return M(t3) in this._;
          }
          function L(t3) {
            return (t3 = M(t3)) in this._ && delete this._[t3];
          }
          function C() {
            var t3 = [];
            for (var e3 in this._)
              t3.push(S(e3));
            return t3;
          }
          function P() {
            var t3 = 0;
            for (var e3 in this._)
              ++t3;
            return t3;
          }
          function O() {
            for (var t3 in this._)
              return false;
            return true;
          }
          function I() {
            this._ = /* @__PURE__ */ Object.create(null);
          }
          function D(t3) {
            return t3;
          }
          function z(t3, e3, r3) {
            return function() {
              var n3 = r3.apply(e3, arguments);
              return n3 === e3 ? t3 : n3;
            };
          }
          function R(t3, e3) {
            if (e3 in t3)
              return e3;
            e3 = e3.charAt(0).toUpperCase() + e3.slice(1);
            for (var r3 = 0, n3 = F.length; r3 < n3; ++r3) {
              var i2 = F[r3] + e3;
              if (i2 in t3)
                return i2;
            }
          }
          a.range = function(t3, e3, r3) {
            if (arguments.length < 3 && (r3 = 1, arguments.length < 2 && (e3 = t3, t3 = 0)), (e3 - t3) / r3 == 1 / 0)
              throw new Error("infinite range");
            var n3, i2 = [], a2 = T(w2(r3)), o2 = -1;
            if (t3 *= a2, e3 *= a2, (r3 *= a2) < 0)
              for (; (n3 = t3 + r3 * ++o2) > e3; )
                i2.push(n3 / a2);
            else
              for (; (n3 = t3 + r3 * ++o2) < e3; )
                i2.push(n3 / a2);
            return i2;
          }, a.map = function(t3, e3) {
            var r3 = new A();
            if (t3 instanceof A)
              t3.forEach(function(t4, e4) {
                r3.set(t4, e4);
              });
            else if (Array.isArray(t3)) {
              var n3, i2 = -1, a2 = t3.length;
              if (1 === arguments.length)
                for (; ++i2 < a2; )
                  r3.set(i2, t3[i2]);
              else
                for (; ++i2 < a2; )
                  r3.set(e3.call(t3, n3 = t3[i2], i2), n3);
            } else
              for (var o2 in t3)
                r3.set(o2, t3[o2]);
            return r3;
          }, k(A, { has: E, get: function(t3) {
            return this._[M(t3)];
          }, set: function(t3, e3) {
            return this._[M(t3)] = e3;
          }, remove: L, keys: C, values: function() {
            var t3 = [];
            for (var e3 in this._)
              t3.push(this._[e3]);
            return t3;
          }, entries: function() {
            var t3 = [];
            for (var e3 in this._)
              t3.push({ key: S(e3), value: this._[e3] });
            return t3;
          }, size: P, empty: O, forEach: function(t3) {
            for (var e3 in this._)
              t3.call(this, S(e3), this._[e3]);
          } }), a.nest = function() {
            var t3, e3, r3 = {}, n3 = [], i2 = [];
            function o2(i3, a2, s3) {
              if (s3 >= n3.length)
                return e3 ? e3.call(r3, a2) : t3 ? a2.sort(t3) : a2;
              for (var l2, u2, c2, f3, h2 = -1, p3 = a2.length, d3 = n3[s3++], v2 = new A(); ++h2 < p3; )
                (f3 = v2.get(l2 = d3(u2 = a2[h2]))) ? f3.push(u2) : v2.set(l2, [u2]);
              return i3 ? (u2 = i3(), c2 = function(t4, e4) {
                u2.set(t4, o2(i3, e4, s3));
              }) : (u2 = {}, c2 = function(t4, e4) {
                u2[t4] = o2(i3, e4, s3);
              }), v2.forEach(c2), u2;
            }
            function s2(t4, e4) {
              if (e4 >= n3.length)
                return t4;
              var r4 = [], a2 = i2[e4++];
              return t4.forEach(function(t5, n4) {
                r4.push({ key: t5, values: s2(n4, e4) });
              }), a2 ? r4.sort(function(t5, e5) {
                return a2(t5.key, e5.key);
              }) : r4;
            }
            return r3.map = function(t4, e4) {
              return o2(e4, t4, 0);
            }, r3.entries = function(t4) {
              return s2(o2(a.map, t4, 0), 0);
            }, r3.key = function(t4) {
              return n3.push(t4), r3;
            }, r3.sortKeys = function(t4) {
              return i2[n3.length - 1] = t4, r3;
            }, r3.sortValues = function(e4) {
              return t3 = e4, r3;
            }, r3.rollup = function(t4) {
              return e3 = t4, r3;
            }, r3;
          }, a.set = function(t3) {
            var e3 = new I();
            if (t3)
              for (var r3 = 0, n3 = t3.length; r3 < n3; ++r3)
                e3.add(t3[r3]);
            return e3;
          }, k(I, { has: E, add: function(t3) {
            return this._[M(t3 += "")] = true, t3;
          }, remove: L, values: C, size: P, empty: O, forEach: function(t3) {
            for (var e3 in this._)
              t3.call(this, S(e3));
          } }), a.behavior = {}, a.rebind = function(t3, e3) {
            for (var r3, n3 = 1, i2 = arguments.length; ++n3 < i2; )
              t3[r3 = arguments[n3]] = z(t3, e3, e3[r3]);
            return t3;
          };
          var F = ["webkit", "ms", "moz", "Moz", "o", "O"];
          function B() {
          }
          function N() {
          }
          function j(t3) {
            var e3 = [], r3 = new A();
            function n3() {
              for (var r4, n4 = e3, i2 = -1, a2 = n4.length; ++i2 < a2; )
                (r4 = n4[i2].on) && r4.apply(this, arguments);
              return t3;
            }
            return n3.on = function(n4, i2) {
              var a2, o2 = r3.get(n4);
              return arguments.length < 2 ? o2 && o2.on : (o2 && (o2.on = null, e3 = e3.slice(0, a2 = e3.indexOf(o2)).concat(e3.slice(a2 + 1)), r3.remove(n4)), i2 && e3.push(r3.set(n4, { on: i2 })), t3);
            }, n3;
          }
          function U() {
            a.event.preventDefault();
          }
          function V() {
            for (var t3, e3 = a.event; t3 = e3.sourceEvent; )
              e3 = t3;
            return e3;
          }
          function H(t3) {
            for (var e3 = new N(), r3 = 0, n3 = arguments.length; ++r3 < n3; )
              e3[arguments[r3]] = j(e3);
            return e3.of = function(r4, n4) {
              return function(i2) {
                try {
                  var o2 = i2.sourceEvent = a.event;
                  i2.target = t3, a.event = i2, e3[i2.type].apply(r4, n4);
                } finally {
                  a.event = o2;
                }
              };
            }, e3;
          }
          a.dispatch = function() {
            for (var t3 = new N(), e3 = -1, r3 = arguments.length; ++e3 < r3; )
              t3[arguments[e3]] = j(t3);
            return t3;
          }, N.prototype.on = function(t3, e3) {
            var r3 = t3.indexOf("."), n3 = "";
            if (r3 >= 0 && (n3 = t3.slice(r3 + 1), t3 = t3.slice(0, r3)), t3)
              return arguments.length < 2 ? this[t3].on(n3) : this[t3].on(n3, e3);
            if (2 === arguments.length) {
              if (null == e3)
                for (t3 in this)
                  this.hasOwnProperty(t3) && this[t3].on(n3, null);
              return this;
            }
          }, a.event = null, a.requote = function(t3) {
            return t3.replace(q2, "\\$&");
          };
          var q2 = /[\\\^\$\*\+\?\|\[\]\(\)\.\{\}]/g, G = {}.__proto__ ? function(t3, e3) {
            t3.__proto__ = e3;
          } : function(t3, e3) {
            for (var r3 in e3)
              t3[r3] = e3[r3];
          };
          function Z(t3) {
            return G(t3, J), t3;
          }
          var Y = function(t3, e3) {
            return e3.querySelector(t3);
          }, W = function(t3, e3) {
            return e3.querySelectorAll(t3);
          }, X = function(t3, e3) {
            var r3 = t3.matches || t3[R(t3, "matchesSelector")];
            return X = function(t4, e4) {
              return r3.call(t4, e4);
            }, X(t3, e3);
          };
          "function" == typeof Sizzle && (Y = function(t3, e3) {
            return Sizzle(t3, e3)[0] || null;
          }, W = Sizzle, X = Sizzle.matchesSelector), a.selection = function() {
            return a.select(l.documentElement);
          };
          var J = a.selection.prototype = [];
          function K(t3) {
            return "function" == typeof t3 ? t3 : function() {
              return Y(t3, this);
            };
          }
          function $(t3) {
            return "function" == typeof t3 ? t3 : function() {
              return W(t3, this);
            };
          }
          J.select = function(t3) {
            var e3, r3, n3, i2, a2 = [];
            t3 = K(t3);
            for (var o2 = -1, s2 = this.length; ++o2 < s2; ) {
              a2.push(e3 = []), e3.parentNode = (n3 = this[o2]).parentNode;
              for (var l2 = -1, u2 = n3.length; ++l2 < u2; )
                (i2 = n3[l2]) ? (e3.push(r3 = t3.call(i2, i2.__data__, l2, o2)), r3 && "__data__" in i2 && (r3.__data__ = i2.__data__)) : e3.push(null);
            }
            return Z(a2);
          }, J.selectAll = function(t3) {
            var e3, r3, n3 = [];
            t3 = $(t3);
            for (var i2 = -1, a2 = this.length; ++i2 < a2; )
              for (var o2 = this[i2], l2 = -1, u2 = o2.length; ++l2 < u2; )
                (r3 = o2[l2]) && (n3.push(e3 = s(t3.call(r3, r3.__data__, l2, i2))), e3.parentNode = r3);
            return Z(n3);
          };
          var Q = "http://www.w3.org/1999/xhtml", tt = { svg: "http://www.w3.org/2000/svg", xhtml: Q, xlink: "http://www.w3.org/1999/xlink", xml: "http://www.w3.org/XML/1998/namespace", xmlns: "http://www.w3.org/2000/xmlns/" };
          function et(t3, e3) {
            return t3 = a.ns.qualify(t3), null == e3 ? t3.local ? function() {
              this.removeAttributeNS(t3.space, t3.local);
            } : function() {
              this.removeAttribute(t3);
            } : "function" == typeof e3 ? t3.local ? function() {
              var r3 = e3.apply(this, arguments);
              null == r3 ? this.removeAttributeNS(t3.space, t3.local) : this.setAttributeNS(t3.space, t3.local, r3);
            } : function() {
              var r3 = e3.apply(this, arguments);
              null == r3 ? this.removeAttribute(t3) : this.setAttribute(t3, r3);
            } : t3.local ? function() {
              this.setAttributeNS(t3.space, t3.local, e3);
            } : function() {
              this.setAttribute(t3, e3);
            };
          }
          function rt(t3) {
            return t3.trim().replace(/\s+/g, " ");
          }
          function nt(t3) {
            return new RegExp("(?:^|\\s+)" + a.requote(t3) + "(?:\\s+|$)", "g");
          }
          function it(t3) {
            return (t3 + "").trim().split(/^|\s+/);
          }
          function at(t3, e3) {
            var r3 = (t3 = it(t3).map(ot)).length;
            return "function" == typeof e3 ? function() {
              for (var n3 = -1, i2 = e3.apply(this, arguments); ++n3 < r3; )
                t3[n3](this, i2);
            } : function() {
              for (var n3 = -1; ++n3 < r3; )
                t3[n3](this, e3);
            };
          }
          function ot(t3) {
            var e3 = nt(t3);
            return function(r3, n3) {
              if (i2 = r3.classList)
                return n3 ? i2.add(t3) : i2.remove(t3);
              var i2 = r3.getAttribute("class") || "";
              n3 ? (e3.lastIndex = 0, e3.test(i2) || r3.setAttribute("class", rt(i2 + " " + t3))) : r3.setAttribute("class", rt(i2.replace(e3, " ")));
            };
          }
          function st(t3, e3, r3) {
            return null == e3 ? function() {
              this.style.removeProperty(t3);
            } : "function" == typeof e3 ? function() {
              var n3 = e3.apply(this, arguments);
              null == n3 ? this.style.removeProperty(t3) : this.style.setProperty(t3, n3, r3);
            } : function() {
              this.style.setProperty(t3, e3, r3);
            };
          }
          function lt(t3, e3) {
            return null == e3 ? function() {
              delete this[t3];
            } : "function" == typeof e3 ? function() {
              var r3 = e3.apply(this, arguments);
              null == r3 ? delete this[t3] : this[t3] = r3;
            } : function() {
              this[t3] = e3;
            };
          }
          function ut(t3) {
            return "function" == typeof t3 ? t3 : (t3 = a.ns.qualify(t3)).local ? function() {
              return this.ownerDocument.createElementNS(t3.space, t3.local);
            } : function() {
              var e3 = this.ownerDocument, r3 = this.namespaceURI;
              return r3 === Q && e3.documentElement.namespaceURI === Q ? e3.createElement(t3) : e3.createElementNS(r3, t3);
            };
          }
          function ct() {
            var t3 = this.parentNode;
            t3 && t3.removeChild(this);
          }
          function ft(t3) {
            return { __data__: t3 };
          }
          function ht(t3) {
            return function() {
              return X(this, t3);
            };
          }
          function pt(t3) {
            return arguments.length || (t3 = g2), function(e3, r3) {
              return e3 && r3 ? t3(e3.__data__, r3.__data__) : !e3 - !r3;
            };
          }
          function dt(t3, e3) {
            for (var r3 = 0, n3 = t3.length; r3 < n3; r3++)
              for (var i2, a2 = t3[r3], o2 = 0, s2 = a2.length; o2 < s2; o2++)
                (i2 = a2[o2]) && e3(i2, o2, r3);
            return t3;
          }
          function vt(t3) {
            return G(t3, gt), t3;
          }
          a.ns = { prefix: tt, qualify: function(t3) {
            var e3 = t3.indexOf(":"), r3 = t3;
            return e3 >= 0 && "xmlns" !== (r3 = t3.slice(0, e3)) && (t3 = t3.slice(e3 + 1)), tt.hasOwnProperty(r3) ? { space: tt[r3], local: t3 } : t3;
          } }, J.attr = function(t3, e3) {
            if (arguments.length < 2) {
              if ("string" == typeof t3) {
                var r3 = this.node();
                return (t3 = a.ns.qualify(t3)).local ? r3.getAttributeNS(t3.space, t3.local) : r3.getAttribute(t3);
              }
              for (e3 in t3)
                this.each(et(e3, t3[e3]));
              return this;
            }
            return this.each(et(t3, e3));
          }, J.classed = function(t3, e3) {
            if (arguments.length < 2) {
              if ("string" == typeof t3) {
                var r3 = this.node(), n3 = (t3 = it(t3)).length, i2 = -1;
                if (e3 = r3.classList) {
                  for (; ++i2 < n3; )
                    if (!e3.contains(t3[i2]))
                      return false;
                } else
                  for (e3 = r3.getAttribute("class"); ++i2 < n3; )
                    if (!nt(t3[i2]).test(e3))
                      return false;
                return true;
              }
              for (e3 in t3)
                this.each(at(e3, t3[e3]));
              return this;
            }
            return this.each(at(t3, e3));
          }, J.style = function(t3, e3, r3) {
            var n3 = arguments.length;
            if (n3 < 3) {
              if ("string" != typeof t3) {
                for (r3 in n3 < 2 && (e3 = ""), t3)
                  this.each(st(r3, t3[r3], e3));
                return this;
              }
              if (n3 < 2) {
                var i2 = this.node();
                return c(i2).getComputedStyle(i2, null).getPropertyValue(t3);
              }
              r3 = "";
            }
            return this.each(st(t3, e3, r3));
          }, J.property = function(t3, e3) {
            if (arguments.length < 2) {
              if ("string" == typeof t3)
                return this.node()[t3];
              for (e3 in t3)
                this.each(lt(e3, t3[e3]));
              return this;
            }
            return this.each(lt(t3, e3));
          }, J.text = function(t3) {
            return arguments.length ? this.each("function" == typeof t3 ? function() {
              var e3 = t3.apply(this, arguments);
              this.textContent = null == e3 ? "" : e3;
            } : null == t3 ? function() {
              this.textContent = "";
            } : function() {
              this.textContent = t3;
            }) : this.node().textContent;
          }, J.html = function(t3) {
            return arguments.length ? this.each("function" == typeof t3 ? function() {
              var e3 = t3.apply(this, arguments);
              this.innerHTML = null == e3 ? "" : e3;
            } : null == t3 ? function() {
              this.innerHTML = "";
            } : function() {
              this.innerHTML = t3;
            }) : this.node().innerHTML;
          }, J.append = function(t3) {
            return t3 = ut(t3), this.select(function() {
              return this.appendChild(t3.apply(this, arguments));
            });
          }, J.insert = function(t3, e3) {
            return t3 = ut(t3), e3 = K(e3), this.select(function() {
              return this.insertBefore(t3.apply(this, arguments), e3.apply(this, arguments) || null);
            });
          }, J.remove = function() {
            return this.each(ct);
          }, J.data = function(t3, e3) {
            var r3, n3, i2 = -1, a2 = this.length;
            if (!arguments.length) {
              for (t3 = new Array(a2 = (r3 = this[0]).length); ++i2 < a2; )
                (n3 = r3[i2]) && (t3[i2] = n3.__data__);
              return t3;
            }
            function o2(t4, r4) {
              var n4, i3, a3, o3 = t4.length, c2 = r4.length, f3 = Math.min(o3, c2), h2 = new Array(c2), p3 = new Array(c2), d3 = new Array(o3);
              if (e3) {
                var v2, g3 = new A(), y2 = new Array(o3);
                for (n4 = -1; ++n4 < o3; )
                  (i3 = t4[n4]) && (g3.has(v2 = e3.call(i3, i3.__data__, n4)) ? d3[n4] = i3 : g3.set(v2, i3), y2[n4] = v2);
                for (n4 = -1; ++n4 < c2; )
                  (i3 = g3.get(v2 = e3.call(r4, a3 = r4[n4], n4))) ? true !== i3 && (h2[n4] = i3, i3.__data__ = a3) : p3[n4] = ft(a3), g3.set(v2, true);
                for (n4 = -1; ++n4 < o3; )
                  n4 in y2 && true !== g3.get(y2[n4]) && (d3[n4] = t4[n4]);
              } else {
                for (n4 = -1; ++n4 < f3; )
                  i3 = t4[n4], a3 = r4[n4], i3 ? (i3.__data__ = a3, h2[n4] = i3) : p3[n4] = ft(a3);
                for (; n4 < c2; ++n4)
                  p3[n4] = ft(r4[n4]);
                for (; n4 < o3; ++n4)
                  d3[n4] = t4[n4];
              }
              p3.update = h2, p3.parentNode = h2.parentNode = d3.parentNode = t4.parentNode, s2.push(p3), l2.push(h2), u2.push(d3);
            }
            var s2 = vt([]), l2 = Z([]), u2 = Z([]);
            if ("function" == typeof t3)
              for (; ++i2 < a2; )
                o2(r3 = this[i2], t3.call(r3, r3.parentNode.__data__, i2));
            else
              for (; ++i2 < a2; )
                o2(r3 = this[i2], t3);
            return l2.enter = function() {
              return s2;
            }, l2.exit = function() {
              return u2;
            }, l2;
          }, J.datum = function(t3) {
            return arguments.length ? this.property("__data__", t3) : this.property("__data__");
          }, J.filter = function(t3) {
            var e3, r3, n3, i2 = [];
            "function" != typeof t3 && (t3 = ht(t3));
            for (var a2 = 0, o2 = this.length; a2 < o2; a2++) {
              i2.push(e3 = []), e3.parentNode = (r3 = this[a2]).parentNode;
              for (var s2 = 0, l2 = r3.length; s2 < l2; s2++)
                (n3 = r3[s2]) && t3.call(n3, n3.__data__, s2, a2) && e3.push(n3);
            }
            return Z(i2);
          }, J.order = function() {
            for (var t3 = -1, e3 = this.length; ++t3 < e3; )
              for (var r3, n3 = this[t3], i2 = n3.length - 1, a2 = n3[i2]; --i2 >= 0; )
                (r3 = n3[i2]) && (a2 && a2 !== r3.nextSibling && a2.parentNode.insertBefore(r3, a2), a2 = r3);
            return this;
          }, J.sort = function(t3) {
            t3 = pt.apply(this, arguments);
            for (var e3 = -1, r3 = this.length; ++e3 < r3; )
              this[e3].sort(t3);
            return this.order();
          }, J.each = function(t3) {
            return dt(this, function(e3, r3, n3) {
              t3.call(e3, e3.__data__, r3, n3);
            });
          }, J.call = function(t3) {
            var e3 = s(arguments);
            return t3.apply(e3[0] = this, e3), this;
          }, J.empty = function() {
            return !this.node();
          }, J.node = function() {
            for (var t3 = 0, e3 = this.length; t3 < e3; t3++)
              for (var r3 = this[t3], n3 = 0, i2 = r3.length; n3 < i2; n3++) {
                var a2 = r3[n3];
                if (a2)
                  return a2;
              }
            return null;
          }, J.size = function() {
            var t3 = 0;
            return dt(this, function() {
              ++t3;
            }), t3;
          };
          var gt = [];
          function yt(t3) {
            var e3, r3;
            return function(n3, i2, a2) {
              var o2, s2 = t3[a2].update, l2 = s2.length;
              for (a2 != r3 && (r3 = a2, e3 = 0), i2 >= e3 && (e3 = i2 + 1); !(o2 = s2[e3]) && ++e3 < l2; )
                ;
              return o2;
            };
          }
          function mt(t3, e3, r3) {
            var n3 = "__on" + t3, i2 = t3.indexOf("."), o2 = bt;
            i2 > 0 && (t3 = t3.slice(0, i2));
            var l2 = xt.get(t3);
            function u2() {
              var e4 = this[n3];
              e4 && (this.removeEventListener(t3, e4, e4.$), delete this[n3]);
            }
            return l2 && (t3 = l2, o2 = _t), i2 ? e3 ? function() {
              var i3 = o2(e3, s(arguments));
              u2.call(this), this.addEventListener(t3, this[n3] = i3, i3.$ = r3), i3._ = e3;
            } : u2 : e3 ? B : function() {
              var e4, r4 = new RegExp("^__on([^.]+)" + a.requote(t3) + "$");
              for (var n4 in this)
                if (e4 = n4.match(r4)) {
                  var i3 = this[n4];
                  this.removeEventListener(e4[1], i3, i3.$), delete this[n4];
                }
            };
          }
          a.selection.enter = vt, a.selection.enter.prototype = gt, gt.append = J.append, gt.empty = J.empty, gt.node = J.node, gt.call = J.call, gt.size = J.size, gt.select = function(t3) {
            for (var e3, r3, n3, i2, a2, o2 = [], s2 = -1, l2 = this.length; ++s2 < l2; ) {
              n3 = (i2 = this[s2]).update, o2.push(e3 = []), e3.parentNode = i2.parentNode;
              for (var u2 = -1, c2 = i2.length; ++u2 < c2; )
                (a2 = i2[u2]) ? (e3.push(n3[u2] = r3 = t3.call(i2.parentNode, a2.__data__, u2, s2)), r3.__data__ = a2.__data__) : e3.push(null);
            }
            return Z(o2);
          }, gt.insert = function(t3, e3) {
            return arguments.length < 2 && (e3 = yt(this)), J.insert.call(this, t3, e3);
          }, a.select = function(t3) {
            var e3;
            return "string" == typeof t3 ? (e3 = [Y(t3, l)]).parentNode = l.documentElement : (e3 = [t3]).parentNode = u(t3), Z([e3]);
          }, a.selectAll = function(t3) {
            var e3;
            return "string" == typeof t3 ? (e3 = s(W(t3, l))).parentNode = l.documentElement : (e3 = s(t3)).parentNode = null, Z([e3]);
          }, J.on = function(t3, e3, r3) {
            var n3 = arguments.length;
            if (n3 < 3) {
              if ("string" != typeof t3) {
                for (r3 in n3 < 2 && (e3 = false), t3)
                  this.each(mt(r3, t3[r3], e3));
                return this;
              }
              if (n3 < 2)
                return (n3 = this.node()["__on" + t3]) && n3._;
              r3 = false;
            }
            return this.each(mt(t3, e3, r3));
          };
          var xt = a.map({ mouseenter: "mouseover", mouseleave: "mouseout" });
          function bt(t3, e3) {
            return function(r3) {
              var n3 = a.event;
              a.event = r3, e3[0] = this.__data__;
              try {
                t3.apply(this, e3);
              } finally {
                a.event = n3;
              }
            };
          }
          function _t(t3, e3) {
            var r3 = bt(t3, e3);
            return function(t4) {
              var e4 = this, n3 = t4.relatedTarget;
              n3 && (n3 === e4 || 8 & n3.compareDocumentPosition(e4)) || r3.call(e4, t4);
            };
          }
          l && xt.forEach(function(t3) {
            "on" + t3 in l && xt.remove(t3);
          });
          var wt, Tt = 0;
          function kt(t3) {
            var e3 = ".dragsuppress-" + ++Tt, r3 = "click" + e3, n3 = a.select(c(t3)).on("touchmove" + e3, U).on("dragstart" + e3, U).on("selectstart" + e3, U);
            if (null == wt && (wt = !("onselectstart" in t3) && R(t3.style, "userSelect")), wt) {
              var i2 = u(t3).style, o2 = i2[wt];
              i2[wt] = "none";
            }
            return function(t4) {
              if (n3.on(e3, null), wt && (i2[wt] = o2), t4) {
                var a2 = function() {
                  n3.on(r3, null);
                };
                n3.on(r3, function() {
                  U(), a2();
                }, true), setTimeout(a2, 0);
              }
            };
          }
          a.mouse = function(t3) {
            return Mt(t3, V());
          };
          var At = this.navigator && /WebKit/.test(this.navigator.userAgent) ? -1 : 0;
          function Mt(t3, e3) {
            e3.changedTouches && (e3 = e3.changedTouches[0]);
            var r3 = t3.ownerSVGElement || t3;
            if (r3.createSVGPoint) {
              var n3 = r3.createSVGPoint();
              if (At < 0) {
                var i2 = c(t3);
                if (i2.scrollX || i2.scrollY) {
                  var o2 = (r3 = a.select("body").append("svg").style({ position: "absolute", top: 0, left: 0, margin: 0, padding: 0, border: "none" }, "important"))[0][0].getScreenCTM();
                  At = !(o2.f || o2.e), r3.remove();
                }
              }
              return At ? (n3.x = e3.pageX, n3.y = e3.pageY) : (n3.x = e3.clientX, n3.y = e3.clientY), [(n3 = n3.matrixTransform(t3.getScreenCTM().inverse())).x, n3.y];
            }
            var s2 = t3.getBoundingClientRect();
            return [e3.clientX - s2.left - t3.clientLeft, e3.clientY - s2.top - t3.clientTop];
          }
          function St() {
            return a.event.changedTouches[0].identifier;
          }
          a.touch = function(t3, e3, r3) {
            if (arguments.length < 3 && (r3 = e3, e3 = V().changedTouches), e3) {
              for (var n3, i2 = 0, a2 = e3.length; i2 < a2; ++i2)
                if ((n3 = e3[i2]).identifier === r3)
                  return Mt(t3, n3);
            }
          }, a.behavior.drag = function() {
            var t3 = H(i2, "drag", "dragstart", "dragend"), e3 = null, r3 = o2(B, a.mouse, c, "mousemove", "mouseup"), n3 = o2(St, a.touch, D, "touchmove", "touchend");
            function i2() {
              this.on("mousedown.drag", r3).on("touchstart.drag", n3);
            }
            function o2(r4, n4, i3, o3, s2) {
              return function() {
                var l2, u2 = this, c2 = a.event.target.correspondingElement || a.event.target, f3 = u2.parentNode, h2 = t3.of(u2, arguments), p3 = 0, d3 = r4(), v2 = ".drag" + (null == d3 ? "" : "-" + d3), g3 = a.select(i3(c2)).on(o3 + v2, x2).on(s2 + v2, b2), y2 = kt(c2), m3 = n4(f3, d3);
                function x2() {
                  var t4, e4, r5 = n4(f3, d3);
                  r5 && (t4 = r5[0] - m3[0], e4 = r5[1] - m3[1], p3 |= t4 | e4, m3 = r5, h2({ type: "drag", x: r5[0] + l2[0], y: r5[1] + l2[1], dx: t4, dy: e4 }));
                }
                function b2() {
                  n4(f3, d3) && (g3.on(o3 + v2, null).on(s2 + v2, null), y2(p3), h2({ type: "dragend" }));
                }
                l2 = e3 ? [(l2 = e3.apply(u2, arguments)).x - m3[0], l2.y - m3[1]] : [0, 0], h2({ type: "dragstart" });
              };
            }
            return i2.origin = function(t4) {
              return arguments.length ? (e3 = t4, i2) : e3;
            }, a.rebind(i2, t3, "on");
          }, a.touches = function(t3, e3) {
            return arguments.length < 2 && (e3 = V().touches), e3 ? s(e3).map(function(e4) {
              var r3 = Mt(t3, e4);
              return r3.identifier = e4.identifier, r3;
            }) : [];
          };
          var Et = 1e-6, Lt = Math.PI, Ct = 2 * Lt, Pt = Ct - Et, Ot = Lt / 2, It = Lt / 180, Dt = 180 / Lt;
          function zt(t3) {
            return t3 > 1 ? Ot : t3 < -1 ? -Ot : Math.asin(t3);
          }
          function Rt(t3) {
            return ((t3 = Math.exp(t3)) + 1 / t3) / 2;
          }
          var Ft = Math.SQRT2;
          a.interpolateZoom = function(t3, e3) {
            var r3, n3, i2 = t3[0], a2 = t3[1], o2 = t3[2], s2 = e3[0], l2 = e3[1], u2 = e3[2], c2 = s2 - i2, f3 = l2 - a2, h2 = c2 * c2 + f3 * f3;
            if (h2 < 1e-12)
              n3 = Math.log(u2 / o2) / Ft, r3 = function(t4) {
                return [i2 + t4 * c2, a2 + t4 * f3, o2 * Math.exp(Ft * t4 * n3)];
              };
            else {
              var p3 = Math.sqrt(h2), d3 = (u2 * u2 - o2 * o2 + 4 * h2) / (2 * o2 * 2 * p3), v2 = (u2 * u2 - o2 * o2 - 4 * h2) / (2 * u2 * 2 * p3), g3 = Math.log(Math.sqrt(d3 * d3 + 1) - d3), y2 = Math.log(Math.sqrt(v2 * v2 + 1) - v2);
              n3 = (y2 - g3) / Ft, r3 = function(t4) {
                var e4, r4 = t4 * n3, s3 = Rt(g3), l3 = o2 / (2 * p3) * (s3 * (e4 = Ft * r4 + g3, ((e4 = Math.exp(2 * e4)) - 1) / (e4 + 1)) - function(t5) {
                  return ((t5 = Math.exp(t5)) - 1 / t5) / 2;
                }(g3));
                return [i2 + l3 * c2, a2 + l3 * f3, o2 * s3 / Rt(Ft * r4 + g3)];
              };
            }
            return r3.duration = 1e3 * n3, r3;
          }, a.behavior.zoom = function() {
            var t3, e3, r3, n3, i2, o2, s2, u2, f3, h2 = { x: 0, y: 0, k: 1 }, p3 = [960, 500], d3 = jt, v2 = 250, g3 = 0, y2 = "mousedown.zoom", m3 = "mousemove.zoom", x2 = "mouseup.zoom", b2 = "touchstart.zoom", _2 = H(w3, "zoomstart", "zoom", "zoomend");
            function w3(t4) {
              t4.on(y2, P2).on(Nt + ".zoom", I2).on("dblclick.zoom", D2).on(b2, O2);
            }
            function T2(t4) {
              return [(t4[0] - h2.x) / h2.k, (t4[1] - h2.y) / h2.k];
            }
            function k2(t4) {
              h2.k = Math.max(d3[0], Math.min(d3[1], t4));
            }
            function A2(t4, e4) {
              e4 = function(t5) {
                return [t5[0] * h2.k + h2.x, t5[1] * h2.k + h2.y];
              }(e4), h2.x += t4[0] - e4[0], h2.y += t4[1] - e4[1];
            }
            function M2(t4, r4, n4, i3) {
              t4.__chart__ = { x: h2.x, y: h2.y, k: h2.k }, k2(Math.pow(2, i3)), A2(e3 = r4, n4), t4 = a.select(t4), v2 > 0 && (t4 = t4.transition().duration(v2)), t4.call(w3.event);
            }
            function S2() {
              s2 && s2.domain(o2.range().map(function(t4) {
                return (t4 - h2.x) / h2.k;
              }).map(o2.invert)), f3 && f3.domain(u2.range().map(function(t4) {
                return (t4 - h2.y) / h2.k;
              }).map(u2.invert));
            }
            function E2(t4) {
              g3++ || t4({ type: "zoomstart" });
            }
            function L2(t4) {
              S2(), t4({ type: "zoom", scale: h2.k, translate: [h2.x, h2.y] });
            }
            function C2(t4) {
              --g3 || (t4({ type: "zoomend" }), e3 = null);
            }
            function P2() {
              var t4 = this, e4 = _2.of(t4, arguments), r4 = 0, n4 = a.select(c(t4)).on(m3, s3).on(x2, l2), i3 = T2(a.mouse(t4)), o3 = kt(t4);
              function s3() {
                r4 = 1, A2(a.mouse(t4), i3), L2(e4);
              }
              function l2() {
                n4.on(m3, null).on(x2, null), o3(r4), C2(e4);
              }
              $i.call(t4), E2(e4);
            }
            function O2() {
              var t4, e4 = this, r4 = _2.of(e4, arguments), n4 = {}, o3 = 0, s3 = ".zoom-" + a.event.changedTouches[0].identifier, l2 = "touchmove" + s3, u3 = "touchend" + s3, c2 = [], f4 = a.select(e4), p4 = kt(e4);
              function d4() {
                var r5 = a.touches(e4);
                return t4 = h2.k, r5.forEach(function(t5) {
                  t5.identifier in n4 && (n4[t5.identifier] = T2(t5));
                }), r5;
              }
              function v3() {
                var t5 = a.event.target;
                a.select(t5).on(l2, g4).on(u3, m4), c2.push(t5);
                for (var r5 = a.event.changedTouches, s4 = 0, f5 = r5.length; s4 < f5; ++s4)
                  n4[r5[s4].identifier] = null;
                var p5 = d4(), v4 = Date.now();
                if (1 === p5.length) {
                  if (v4 - i2 < 500) {
                    var y3 = p5[0];
                    M2(e4, y3, n4[y3.identifier], Math.floor(Math.log(h2.k) / Math.LN2) + 1), U();
                  }
                  i2 = v4;
                } else if (p5.length > 1) {
                  y3 = p5[0];
                  var x3 = p5[1], b3 = y3[0] - x3[0], _3 = y3[1] - x3[1];
                  o3 = b3 * b3 + _3 * _3;
                }
              }
              function g4() {
                var s4, l3, u4, c3, f5 = a.touches(e4);
                $i.call(e4);
                for (var h3 = 0, p5 = f5.length; h3 < p5; ++h3, c3 = null)
                  if (u4 = f5[h3], c3 = n4[u4.identifier]) {
                    if (l3)
                      break;
                    s4 = u4, l3 = c3;
                  }
                if (c3) {
                  var d5 = (d5 = u4[0] - s4[0]) * d5 + (d5 = u4[1] - s4[1]) * d5, v4 = o3 && Math.sqrt(d5 / o3);
                  s4 = [(s4[0] + u4[0]) / 2, (s4[1] + u4[1]) / 2], l3 = [(l3[0] + c3[0]) / 2, (l3[1] + c3[1]) / 2], k2(v4 * t4);
                }
                i2 = null, A2(s4, l3), L2(r4);
              }
              function m4() {
                if (a.event.touches.length) {
                  for (var t5 = a.event.changedTouches, e5 = 0, i3 = t5.length; e5 < i3; ++e5)
                    delete n4[t5[e5].identifier];
                  for (var o4 in n4)
                    return void d4();
                }
                a.selectAll(c2).on(s3, null), f4.on(y2, P2).on(b2, O2), p4(), C2(r4);
              }
              v3(), E2(r4), f4.on(y2, null).on(b2, v3);
            }
            function I2() {
              var i3 = _2.of(this, arguments);
              n3 ? clearTimeout(n3) : ($i.call(this), t3 = T2(e3 = r3 || a.mouse(this)), E2(i3)), n3 = setTimeout(function() {
                n3 = null, C2(i3);
              }, 50), U(), k2(Math.pow(2, 2e-3 * Bt()) * h2.k), A2(e3, t3), L2(i3);
            }
            function D2() {
              var t4 = a.mouse(this), e4 = Math.log(h2.k) / Math.LN2;
              M2(this, t4, T2(t4), a.event.shiftKey ? Math.ceil(e4) - 1 : Math.floor(e4) + 1);
            }
            return Nt || (Nt = "onwheel" in l ? (Bt = function() {
              return -a.event.deltaY * (a.event.deltaMode ? 120 : 1);
            }, "wheel") : "onmousewheel" in l ? (Bt = function() {
              return a.event.wheelDelta;
            }, "mousewheel") : (Bt = function() {
              return -a.event.detail;
            }, "MozMousePixelScroll")), w3.event = function(t4) {
              t4.each(function() {
                var t5 = _2.of(this, arguments), r4 = h2;
                ea ? a.select(this).transition().each("start.zoom", function() {
                  h2 = this.__chart__ || { x: 0, y: 0, k: 1 }, E2(t5);
                }).tween("zoom:zoom", function() {
                  var n4 = p3[0], i3 = p3[1], o3 = e3 ? e3[0] : n4 / 2, s3 = e3 ? e3[1] : i3 / 2, l2 = a.interpolateZoom([(o3 - h2.x) / h2.k, (s3 - h2.y) / h2.k, n4 / h2.k], [(o3 - r4.x) / r4.k, (s3 - r4.y) / r4.k, n4 / r4.k]);
                  return function(e4) {
                    var r5 = l2(e4), i4 = n4 / r5[2];
                    this.__chart__ = h2 = { x: o3 - r5[0] * i4, y: s3 - r5[1] * i4, k: i4 }, L2(t5);
                  };
                }).each("interrupt.zoom", function() {
                  C2(t5);
                }).each("end.zoom", function() {
                  C2(t5);
                }) : (this.__chart__ = h2, E2(t5), L2(t5), C2(t5));
              });
            }, w3.translate = function(t4) {
              return arguments.length ? (h2 = { x: +t4[0], y: +t4[1], k: h2.k }, S2(), w3) : [h2.x, h2.y];
            }, w3.scale = function(t4) {
              return arguments.length ? (h2 = { x: h2.x, y: h2.y, k: null }, k2(+t4), S2(), w3) : h2.k;
            }, w3.scaleExtent = function(t4) {
              return arguments.length ? (d3 = null == t4 ? jt : [+t4[0], +t4[1]], w3) : d3;
            }, w3.center = function(t4) {
              return arguments.length ? (r3 = t4 && [+t4[0], +t4[1]], w3) : r3;
            }, w3.size = function(t4) {
              return arguments.length ? (p3 = t4 && [+t4[0], +t4[1]], w3) : p3;
            }, w3.duration = function(t4) {
              return arguments.length ? (v2 = +t4, w3) : v2;
            }, w3.x = function(t4) {
              return arguments.length ? (s2 = t4, o2 = t4.copy(), h2 = { x: 0, y: 0, k: 1 }, w3) : s2;
            }, w3.y = function(t4) {
              return arguments.length ? (f3 = t4, u2 = t4.copy(), h2 = { x: 0, y: 0, k: 1 }, w3) : f3;
            }, a.rebind(w3, _2, "on");
          };
          var Bt, Nt, jt = [0, 1 / 0];
          function Ut() {
          }
          function Vt(t3, e3, r3) {
            return this instanceof Vt ? (this.h = +t3, this.s = +e3, void (this.l = +r3)) : arguments.length < 2 ? t3 instanceof Vt ? new Vt(t3.h, t3.s, t3.l) : ue("" + t3, ce, Vt) : new Vt(t3, e3, r3);
          }
          a.color = Ut, Ut.prototype.toString = function() {
            return this.rgb() + "";
          }, a.hsl = Vt;
          var Ht = Vt.prototype = new Ut();
          function qt(t3, e3, r3) {
            var n3, i2;
            function a2(t4) {
              return Math.round(255 * function(t5) {
                return t5 > 360 ? t5 -= 360 : t5 < 0 && (t5 += 360), t5 < 60 ? n3 + (i2 - n3) * t5 / 60 : t5 < 180 ? i2 : t5 < 240 ? n3 + (i2 - n3) * (240 - t5) / 60 : n3;
              }(t4));
            }
            return t3 = isNaN(t3) ? 0 : (t3 %= 360) < 0 ? t3 + 360 : t3, e3 = isNaN(e3) || e3 < 0 ? 0 : e3 > 1 ? 1 : e3, n3 = 2 * (r3 = r3 < 0 ? 0 : r3 > 1 ? 1 : r3) - (i2 = r3 <= 0.5 ? r3 * (1 + e3) : r3 + e3 - r3 * e3), new ie(a2(t3 + 120), a2(t3), a2(t3 - 120));
          }
          function Gt(t3, e3, r3) {
            return this instanceof Gt ? (this.h = +t3, this.c = +e3, void (this.l = +r3)) : arguments.length < 2 ? t3 instanceof Gt ? new Gt(t3.h, t3.c, t3.l) : te(t3 instanceof Wt ? t3.l : (t3 = fe((t3 = a.rgb(t3)).r, t3.g, t3.b)).l, t3.a, t3.b) : new Gt(t3, e3, r3);
          }
          Ht.brighter = function(t3) {
            return t3 = Math.pow(0.7, arguments.length ? t3 : 1), new Vt(this.h, this.s, this.l / t3);
          }, Ht.darker = function(t3) {
            return t3 = Math.pow(0.7, arguments.length ? t3 : 1), new Vt(this.h, this.s, t3 * this.l);
          }, Ht.rgb = function() {
            return qt(this.h, this.s, this.l);
          }, a.hcl = Gt;
          var Zt = Gt.prototype = new Ut();
          function Yt(t3, e3, r3) {
            return isNaN(t3) && (t3 = 0), isNaN(e3) && (e3 = 0), new Wt(r3, Math.cos(t3 *= It) * e3, Math.sin(t3) * e3);
          }
          function Wt(t3, e3, r3) {
            return this instanceof Wt ? (this.l = +t3, this.a = +e3, void (this.b = +r3)) : arguments.length < 2 ? t3 instanceof Wt ? new Wt(t3.l, t3.a, t3.b) : t3 instanceof Gt ? Yt(t3.h, t3.c, t3.l) : fe((t3 = ie(t3)).r, t3.g, t3.b) : new Wt(t3, e3, r3);
          }
          Zt.brighter = function(t3) {
            return new Gt(this.h, this.c, Math.min(100, this.l + Xt * (arguments.length ? t3 : 1)));
          }, Zt.darker = function(t3) {
            return new Gt(this.h, this.c, Math.max(0, this.l - Xt * (arguments.length ? t3 : 1)));
          }, Zt.rgb = function() {
            return Yt(this.h, this.c, this.l).rgb();
          }, a.lab = Wt;
          var Xt = 18, Jt = 0.95047, Kt = 1.08883, $t = Wt.prototype = new Ut();
          function Qt(t3, e3, r3) {
            var n3 = (t3 + 16) / 116, i2 = n3 + e3 / 500, a2 = n3 - r3 / 200;
            return new ie(ne(3.2404542 * (i2 = ee(i2) * Jt) - 1.5371385 * (n3 = 1 * ee(n3)) - 0.4985314 * (a2 = ee(a2) * Kt)), ne(-0.969266 * i2 + 1.8760108 * n3 + 0.041556 * a2), ne(0.0556434 * i2 - 0.2040259 * n3 + 1.0572252 * a2));
          }
          function te(t3, e3, r3) {
            return t3 > 0 ? new Gt(Math.atan2(r3, e3) * Dt, Math.sqrt(e3 * e3 + r3 * r3), t3) : new Gt(NaN, NaN, t3);
          }
          function ee(t3) {
            return t3 > 0.206893034 ? t3 * t3 * t3 : (t3 - 4 / 29) / 7.787037;
          }
          function re(t3) {
            return t3 > 8856e-6 ? Math.pow(t3, 1 / 3) : 7.787037 * t3 + 4 / 29;
          }
          function ne(t3) {
            return Math.round(255 * (t3 <= 304e-5 ? 12.92 * t3 : 1.055 * Math.pow(t3, 1 / 2.4) - 0.055));
          }
          function ie(t3, e3, r3) {
            return this instanceof ie ? (this.r = ~~t3, this.g = ~~e3, void (this.b = ~~r3)) : arguments.length < 2 ? t3 instanceof ie ? new ie(t3.r, t3.g, t3.b) : ue("" + t3, ie, qt) : new ie(t3, e3, r3);
          }
          function ae(t3) {
            return new ie(t3 >> 16, t3 >> 8 & 255, 255 & t3);
          }
          function oe(t3) {
            return ae(t3) + "";
          }
          $t.brighter = function(t3) {
            return new Wt(Math.min(100, this.l + Xt * (arguments.length ? t3 : 1)), this.a, this.b);
          }, $t.darker = function(t3) {
            return new Wt(Math.max(0, this.l - Xt * (arguments.length ? t3 : 1)), this.a, this.b);
          }, $t.rgb = function() {
            return Qt(this.l, this.a, this.b);
          }, a.rgb = ie;
          var se = ie.prototype = new Ut();
          function le(t3) {
            return t3 < 16 ? "0" + Math.max(0, t3).toString(16) : Math.min(255, t3).toString(16);
          }
          function ue(t3, e3, r3) {
            var n3, i2, a2, o2 = 0, s2 = 0, l2 = 0;
            if (n3 = /([a-z]+)\((.*)\)/.exec(t3 = t3.toLowerCase()))
              switch (i2 = n3[2].split(","), n3[1]) {
                case "hsl":
                  return r3(parseFloat(i2[0]), parseFloat(i2[1]) / 100, parseFloat(i2[2]) / 100);
                case "rgb":
                  return e3(pe(i2[0]), pe(i2[1]), pe(i2[2]));
              }
            return (a2 = de.get(t3)) ? e3(a2.r, a2.g, a2.b) : (null == t3 || "#" !== t3.charAt(0) || isNaN(a2 = parseInt(t3.slice(1), 16)) || (4 === t3.length ? (o2 = (3840 & a2) >> 4, o2 |= o2 >> 4, s2 = 240 & a2, s2 |= s2 >> 4, l2 = 15 & a2, l2 |= l2 << 4) : 7 === t3.length && (o2 = (16711680 & a2) >> 16, s2 = (65280 & a2) >> 8, l2 = 255 & a2)), e3(o2, s2, l2));
          }
          function ce(t3, e3, r3) {
            var n3, i2, a2 = Math.min(t3 /= 255, e3 /= 255, r3 /= 255), o2 = Math.max(t3, e3, r3), s2 = o2 - a2, l2 = (o2 + a2) / 2;
            return s2 ? (i2 = l2 < 0.5 ? s2 / (o2 + a2) : s2 / (2 - o2 - a2), n3 = t3 == o2 ? (e3 - r3) / s2 + (e3 < r3 ? 6 : 0) : e3 == o2 ? (r3 - t3) / s2 + 2 : (t3 - e3) / s2 + 4, n3 *= 60) : (n3 = NaN, i2 = l2 > 0 && l2 < 1 ? 0 : n3), new Vt(n3, i2, l2);
          }
          function fe(t3, e3, r3) {
            var n3 = re((0.4124564 * (t3 = he(t3)) + 0.3575761 * (e3 = he(e3)) + 0.1804375 * (r3 = he(r3))) / Jt), i2 = re((0.2126729 * t3 + 0.7151522 * e3 + 0.072175 * r3) / 1);
            return Wt(116 * i2 - 16, 500 * (n3 - i2), 200 * (i2 - re((0.0193339 * t3 + 0.119192 * e3 + 0.9503041 * r3) / Kt)));
          }
          function he(t3) {
            return (t3 /= 255) <= 0.04045 ? t3 / 12.92 : Math.pow((t3 + 0.055) / 1.055, 2.4);
          }
          function pe(t3) {
            var e3 = parseFloat(t3);
            return "%" === t3.charAt(t3.length - 1) ? Math.round(2.55 * e3) : e3;
          }
          se.brighter = function(t3) {
            t3 = Math.pow(0.7, arguments.length ? t3 : 1);
            var e3 = this.r, r3 = this.g, n3 = this.b, i2 = 30;
            return e3 || r3 || n3 ? (e3 && e3 < i2 && (e3 = i2), r3 && r3 < i2 && (r3 = i2), n3 && n3 < i2 && (n3 = i2), new ie(Math.min(255, e3 / t3), Math.min(255, r3 / t3), Math.min(255, n3 / t3))) : new ie(i2, i2, i2);
          }, se.darker = function(t3) {
            return new ie((t3 = Math.pow(0.7, arguments.length ? t3 : 1)) * this.r, t3 * this.g, t3 * this.b);
          }, se.hsl = function() {
            return ce(this.r, this.g, this.b);
          }, se.toString = function() {
            return "#" + le(this.r) + le(this.g) + le(this.b);
          };
          var de = a.map({ aliceblue: 15792383, antiquewhite: 16444375, aqua: 65535, aquamarine: 8388564, azure: 15794175, beige: 16119260, bisque: 16770244, black: 0, blanchedalmond: 16772045, blue: 255, blueviolet: 9055202, brown: 10824234, burlywood: 14596231, cadetblue: 6266528, chartreuse: 8388352, chocolate: 13789470, coral: 16744272, cornflowerblue: 6591981, cornsilk: 16775388, crimson: 14423100, cyan: 65535, darkblue: 139, darkcyan: 35723, darkgoldenrod: 12092939, darkgray: 11119017, darkgreen: 25600, darkgrey: 11119017, darkkhaki: 12433259, darkmagenta: 9109643, darkolivegreen: 5597999, darkorange: 16747520, darkorchid: 10040012, darkred: 9109504, darksalmon: 15308410, darkseagreen: 9419919, darkslateblue: 4734347, darkslategray: 3100495, darkslategrey: 3100495, darkturquoise: 52945, darkviolet: 9699539, deeppink: 16716947, deepskyblue: 49151, dimgray: 6908265, dimgrey: 6908265, dodgerblue: 2003199, firebrick: 11674146, floralwhite: 16775920, forestgreen: 2263842, fuchsia: 16711935, gainsboro: 14474460, ghostwhite: 16316671, gold: 16766720, goldenrod: 14329120, gray: 8421504, green: 32768, greenyellow: 11403055, grey: 8421504, honeydew: 15794160, hotpink: 16738740, indianred: 13458524, indigo: 4915330, ivory: 16777200, khaki: 15787660, lavender: 15132410, lavenderblush: 16773365, lawngreen: 8190976, lemonchiffon: 16775885, lightblue: 11393254, lightcoral: 15761536, lightcyan: 14745599, lightgoldenrodyellow: 16448210, lightgray: 13882323, lightgreen: 9498256, lightgrey: 13882323, lightpink: 16758465, lightsalmon: 16752762, lightseagreen: 2142890, lightskyblue: 8900346, lightslategray: 7833753, lightslategrey: 7833753, lightsteelblue: 11584734, lightyellow: 16777184, lime: 65280, limegreen: 3329330, linen: 16445670, magenta: 16711935, maroon: 8388608, mediumaquamarine: 6737322, mediumblue: 205, mediumorchid: 12211667, mediumpurple: 9662683, mediumseagreen: 3978097, mediumslateblue: 8087790, mediumspringgreen: 64154, mediumturquoise: 4772300, mediumvioletred: 13047173, midnightblue: 1644912, mintcream: 16121850, mistyrose: 16770273, moccasin: 16770229, navajowhite: 16768685, navy: 128, oldlace: 16643558, olive: 8421376, olivedrab: 7048739, orange: 16753920, orangered: 16729344, orchid: 14315734, palegoldenrod: 15657130, palegreen: 10025880, paleturquoise: 11529966, palevioletred: 14381203, papayawhip: 16773077, peachpuff: 16767673, peru: 13468991, pink: 16761035, plum: 14524637, powderblue: 11591910, purple: 8388736, rebeccapurple: 6697881, red: 16711680, rosybrown: 12357519, royalblue: 4286945, saddlebrown: 9127187, salmon: 16416882, sandybrown: 16032864, seagreen: 3050327, seashell: 16774638, sienna: 10506797, silver: 12632256, skyblue: 8900331, slateblue: 6970061, slategray: 7372944, slategrey: 7372944, snow: 16775930, springgreen: 65407, steelblue: 4620980, tan: 13808780, teal: 32896, thistle: 14204888, tomato: 16737095, turquoise: 4251856, violet: 15631086, wheat: 16113331, white: 16777215, whitesmoke: 16119285, yellow: 16776960, yellowgreen: 10145074 });
          function ve(t3) {
            return "function" == typeof t3 ? t3 : function() {
              return t3;
            };
          }
          function ge(t3) {
            return function(e3, r3, n3) {
              return 2 === arguments.length && "function" == typeof r3 && (n3 = r3, r3 = null), ye(e3, r3, t3, n3);
            };
          }
          function ye(t3, e3, r3, n3) {
            var i2 = {}, o2 = a.dispatch("beforesend", "progress", "load", "error"), l2 = {}, u2 = new XMLHttpRequest(), c2 = null;
            function f3() {
              var t4, e4 = u2.status;
              if (!e4 && function(t5) {
                var e5 = t5.responseType;
                return e5 && "text" !== e5 ? t5.response : t5.responseText;
              }(u2) || e4 >= 200 && e4 < 300 || 304 === e4) {
                try {
                  t4 = r3.call(i2, u2);
                } catch (t5) {
                  return void o2.error.call(i2, t5);
                }
                o2.load.call(i2, t4);
              } else
                o2.error.call(i2, u2);
            }
            return self.XDomainRequest && !("withCredentials" in u2) && /^(http(s)?:)?\/\//.test(t3) && (u2 = new XDomainRequest()), "onload" in u2 ? u2.onload = u2.onerror = f3 : u2.onreadystatechange = function() {
              u2.readyState > 3 && f3();
            }, u2.onprogress = function(t4) {
              var e4 = a.event;
              a.event = t4;
              try {
                o2.progress.call(i2, u2);
              } finally {
                a.event = e4;
              }
            }, i2.header = function(t4, e4) {
              return t4 = (t4 + "").toLowerCase(), arguments.length < 2 ? l2[t4] : (null == e4 ? delete l2[t4] : l2[t4] = e4 + "", i2);
            }, i2.mimeType = function(t4) {
              return arguments.length ? (e3 = null == t4 ? null : t4 + "", i2) : e3;
            }, i2.responseType = function(t4) {
              return arguments.length ? (c2 = t4, i2) : c2;
            }, i2.response = function(t4) {
              return r3 = t4, i2;
            }, ["get", "post"].forEach(function(t4) {
              i2[t4] = function() {
                return i2.send.apply(i2, [t4].concat(s(arguments)));
              };
            }), i2.send = function(r4, n4, a2) {
              if (2 === arguments.length && "function" == typeof n4 && (a2 = n4, n4 = null), u2.open(r4, t3, true), null == e3 || "accept" in l2 || (l2.accept = e3 + ",*/*"), u2.setRequestHeader)
                for (var s2 in l2)
                  u2.setRequestHeader(s2, l2[s2]);
              return null != e3 && u2.overrideMimeType && u2.overrideMimeType(e3), null != c2 && (u2.responseType = c2), null != a2 && i2.on("error", a2).on("load", function(t4) {
                a2(null, t4);
              }), o2.beforesend.call(i2, u2), u2.send(null == n4 ? null : n4), i2;
            }, i2.abort = function() {
              return u2.abort(), i2;
            }, a.rebind(i2, o2, "on"), null == n3 ? i2 : i2.get(function(t4) {
              return 1 === t4.length ? function(e4, r4) {
                t4(null == e4 ? r4 : null);
              } : t4;
            }(n3));
          }
          de.forEach(function(t3, e3) {
            de.set(t3, ae(e3));
          }), a.functor = ve, a.xhr = ge(D), a.dsv = function(t3, e3) {
            var r3 = new RegExp('["' + t3 + "\n]"), n3 = t3.charCodeAt(0);
            function i2(t4, r4, n4) {
              arguments.length < 3 && (n4 = r4, r4 = null);
              var i3 = ye(t4, e3, null == r4 ? a2 : o2(r4), n4);
              return i3.row = function(t5) {
                return arguments.length ? i3.response(null == (r4 = t5) ? a2 : o2(t5)) : r4;
              }, i3;
            }
            function a2(t4) {
              return i2.parse(t4.responseText);
            }
            function o2(t4) {
              return function(e4) {
                return i2.parse(e4.responseText, t4);
              };
            }
            function s2(e4) {
              return e4.map(l2).join(t3);
            }
            function l2(t4) {
              return r3.test(t4) ? '"' + t4.replace(/\"/g, '""') + '"' : t4;
            }
            return i2.parse = function(t4, e4) {
              var r4;
              return i2.parseRows(t4, function(t5, n4) {
                if (r4)
                  return r4(t5, n4 - 1);
                var i3 = function(e5) {
                  for (var r5 = {}, n5 = t5.length, i4 = 0; i4 < n5; ++i4)
                    r5[t5[i4]] = e5[i4];
                  return r5;
                };
                r4 = e4 ? function(t6, r5) {
                  return e4(i3(t6), r5);
                } : i3;
              });
            }, i2.parseRows = function(t4, e4) {
              var r4, i3, a3 = {}, o3 = {}, s3 = [], l3 = t4.length, u2 = 0, c2 = 0;
              function f3() {
                if (u2 >= l3)
                  return o3;
                if (i3)
                  return i3 = false, a3;
                var e5 = u2;
                if (34 === t4.charCodeAt(e5)) {
                  for (var r5 = e5; r5++ < l3; )
                    if (34 === t4.charCodeAt(r5)) {
                      if (34 !== t4.charCodeAt(r5 + 1))
                        break;
                      ++r5;
                    }
                  return u2 = r5 + 2, 13 === (s4 = t4.charCodeAt(r5 + 1)) ? (i3 = true, 10 === t4.charCodeAt(r5 + 2) && ++u2) : 10 === s4 && (i3 = true), t4.slice(e5 + 1, r5).replace(/""/g, '"');
                }
                for (; u2 < l3; ) {
                  var s4, c3 = 1;
                  if (10 === (s4 = t4.charCodeAt(u2++)))
                    i3 = true;
                  else if (13 === s4)
                    i3 = true, 10 === t4.charCodeAt(u2) && (++u2, ++c3);
                  else if (s4 !== n3)
                    continue;
                  return t4.slice(e5, u2 - c3);
                }
                return t4.slice(e5);
              }
              for (; (r4 = f3()) !== o3; ) {
                for (var h2 = []; r4 !== a3 && r4 !== o3; )
                  h2.push(r4), r4 = f3();
                e4 && null == (h2 = e4(h2, c2++)) || s3.push(h2);
              }
              return s3;
            }, i2.format = function(e4) {
              if (Array.isArray(e4[0]))
                return i2.formatRows(e4);
              var r4 = new I(), n4 = [];
              return e4.forEach(function(t4) {
                for (var e5 in t4)
                  r4.has(e5) || n4.push(r4.add(e5));
              }), [n4.map(l2).join(t3)].concat(e4.map(function(e5) {
                return n4.map(function(t4) {
                  return l2(e5[t4]);
                }).join(t3);
              })).join("\n");
            }, i2.formatRows = function(t4) {
              return t4.map(s2).join("\n");
            }, i2;
          }, a.csv = a.dsv(",", "text/csv"), a.tsv = a.dsv("	", "text/tab-separated-values");
          var me, xe, be, _e, we = this[R(this, "requestAnimationFrame")] || function(t3) {
            setTimeout(t3, 17);
          };
          function Te(t3, e3, r3) {
            var n3 = arguments.length;
            n3 < 2 && (e3 = 0), n3 < 3 && (r3 = Date.now());
            var i2 = r3 + e3, a2 = { c: t3, t: i2, n: null };
            return xe ? xe.n = a2 : me = a2, xe = a2, be || (_e = clearTimeout(_e), be = 1, we(ke)), a2;
          }
          function ke() {
            var t3 = Ae(), e3 = Me() - t3;
            e3 > 24 ? (isFinite(e3) && (clearTimeout(_e), _e = setTimeout(ke, e3)), be = 0) : (be = 1, we(ke));
          }
          function Ae() {
            for (var t3 = Date.now(), e3 = me; e3; )
              t3 >= e3.t && e3.c(t3 - e3.t) && (e3.c = null), e3 = e3.n;
            return t3;
          }
          function Me() {
            for (var t3, e3 = me, r3 = 1 / 0; e3; )
              e3.c ? (e3.t < r3 && (r3 = e3.t), e3 = (t3 = e3).n) : e3 = t3 ? t3.n = e3.n : me = e3.n;
            return xe = t3, r3;
          }
          function Se(t3) {
            return t3[0];
          }
          function Ee(t3) {
            return t3[1];
          }
          function Le(t3) {
            for (var e3, r3, n3, i2 = t3.length, a2 = [0, 1], o2 = 2, s2 = 2; s2 < i2; s2++) {
              for (; o2 > 1 && (e3 = t3[a2[o2 - 2]], r3 = t3[a2[o2 - 1]], n3 = t3[s2], (r3[0] - e3[0]) * (n3[1] - e3[1]) - (r3[1] - e3[1]) * (n3[0] - e3[0]) <= 0); )
                --o2;
              a2[o2++] = s2;
            }
            return a2.slice(0, o2);
          }
          function Ce(t3, e3) {
            return t3[0] - e3[0] || t3[1] - e3[1];
          }
          a.timer = function() {
            Te.apply(this, arguments);
          }, a.timer.flush = function() {
            Ae(), Me();
          }, a.round = function(t3, e3) {
            return e3 ? Math.round(t3 * (e3 = Math.pow(10, e3))) / e3 : Math.round(t3);
          }, a.geom = {}, a.geom.hull = function(t3) {
            var e3 = Se, r3 = Ee;
            if (arguments.length)
              return n3(t3);
            function n3(t4) {
              if (t4.length < 3)
                return [];
              var n4, i2 = ve(e3), a2 = ve(r3), o2 = t4.length, s2 = [], l2 = [];
              for (n4 = 0; n4 < o2; n4++)
                s2.push([+i2.call(this, t4[n4], n4), +a2.call(this, t4[n4], n4), n4]);
              for (s2.sort(Ce), n4 = 0; n4 < o2; n4++)
                l2.push([s2[n4][0], -s2[n4][1]]);
              var u2 = Le(s2), c2 = Le(l2), f3 = c2[0] === u2[0], h2 = c2[c2.length - 1] === u2[u2.length - 1], p3 = [];
              for (n4 = u2.length - 1; n4 >= 0; --n4)
                p3.push(t4[s2[u2[n4]][2]]);
              for (n4 = +f3; n4 < c2.length - h2; ++n4)
                p3.push(t4[s2[c2[n4]][2]]);
              return p3;
            }
            return n3.x = function(t4) {
              return arguments.length ? (e3 = t4, n3) : e3;
            }, n3.y = function(t4) {
              return arguments.length ? (r3 = t4, n3) : r3;
            }, n3;
          }, a.geom.polygon = function(t3) {
            return G(t3, Pe), t3;
          };
          var Pe = a.geom.polygon.prototype = [];
          function Oe(t3, e3, r3) {
            return (r3[0] - e3[0]) * (t3[1] - e3[1]) < (r3[1] - e3[1]) * (t3[0] - e3[0]);
          }
          function Ie(t3, e3, r3, n3) {
            var i2 = t3[0], a2 = r3[0], o2 = e3[0] - i2, s2 = n3[0] - a2, l2 = t3[1], u2 = r3[1], c2 = e3[1] - l2, f3 = n3[1] - u2, h2 = (s2 * (l2 - u2) - f3 * (i2 - a2)) / (f3 * o2 - s2 * c2);
            return [i2 + h2 * o2, l2 + h2 * c2];
          }
          function De(t3) {
            var e3 = t3[0], r3 = t3[t3.length - 1];
            return !(e3[0] - r3[0] || e3[1] - r3[1]);
          }
          Pe.area = function() {
            for (var t3, e3 = -1, r3 = this.length, n3 = this[r3 - 1], i2 = 0; ++e3 < r3; )
              t3 = n3, n3 = this[e3], i2 += t3[1] * n3[0] - t3[0] * n3[1];
            return 0.5 * i2;
          }, Pe.centroid = function(t3) {
            var e3, r3, n3 = -1, i2 = this.length, a2 = 0, o2 = 0, s2 = this[i2 - 1];
            for (arguments.length || (t3 = -1 / (6 * this.area())); ++n3 < i2; )
              e3 = s2, s2 = this[n3], r3 = e3[0] * s2[1] - s2[0] * e3[1], a2 += (e3[0] + s2[0]) * r3, o2 += (e3[1] + s2[1]) * r3;
            return [a2 * t3, o2 * t3];
          }, Pe.clip = function(t3) {
            for (var e3, r3, n3, i2, a2, o2, s2 = De(t3), l2 = -1, u2 = this.length - De(this), c2 = this[u2 - 1]; ++l2 < u2; ) {
              for (e3 = t3.slice(), t3.length = 0, i2 = this[l2], a2 = e3[(n3 = e3.length - s2) - 1], r3 = -1; ++r3 < n3; )
                Oe(o2 = e3[r3], c2, i2) ? (Oe(a2, c2, i2) || t3.push(Ie(a2, o2, c2, i2)), t3.push(o2)) : Oe(a2, c2, i2) && t3.push(Ie(a2, o2, c2, i2)), a2 = o2;
              s2 && t3.push(t3[0]), c2 = i2;
            }
            return t3;
          };
          var ze, Re, Fe, Be, Ne, je = [], Ue = [];
          function Ve() {
            or(this), this.edge = this.site = this.circle = null;
          }
          function He(t3) {
            var e3 = je.pop() || new Ve();
            return e3.site = t3, e3;
          }
          function qe(t3) {
            Qe(t3), Fe.remove(t3), je.push(t3), or(t3);
          }
          function Ge(t3) {
            var e3 = t3.circle, r3 = e3.x, n3 = e3.cy, i2 = { x: r3, y: n3 }, a2 = t3.P, o2 = t3.N, s2 = [t3];
            qe(t3);
            for (var l2 = a2; l2.circle && w2(r3 - l2.circle.x) < Et && w2(n3 - l2.circle.cy) < Et; )
              a2 = l2.P, s2.unshift(l2), qe(l2), l2 = a2;
            s2.unshift(l2), Qe(l2);
            for (var u2 = o2; u2.circle && w2(r3 - u2.circle.x) < Et && w2(n3 - u2.circle.cy) < Et; )
              o2 = u2.N, s2.push(u2), qe(u2), u2 = o2;
            s2.push(u2), Qe(u2);
            var c2, f3 = s2.length;
            for (c2 = 1; c2 < f3; ++c2)
              u2 = s2[c2], l2 = s2[c2 - 1], nr(u2.edge, l2.site, u2.site, i2);
            l2 = s2[0], (u2 = s2[f3 - 1]).edge = rr(l2.site, u2.site, null, i2), $e(l2), $e(u2);
          }
          function Ze(t3) {
            for (var e3, r3, n3, i2, a2 = t3.x, o2 = t3.y, s2 = Fe._; s2; )
              if ((n3 = Ye(s2, o2) - a2) > Et)
                s2 = s2.L;
              else {
                if (!((i2 = a2 - We(s2, o2)) > Et)) {
                  n3 > -Et ? (e3 = s2.P, r3 = s2) : i2 > -Et ? (e3 = s2, r3 = s2.N) : e3 = r3 = s2;
                  break;
                }
                if (!s2.R) {
                  e3 = s2;
                  break;
                }
                s2 = s2.R;
              }
            var l2 = He(t3);
            if (Fe.insert(e3, l2), e3 || r3) {
              if (e3 === r3)
                return Qe(e3), r3 = He(e3.site), Fe.insert(l2, r3), l2.edge = r3.edge = rr(e3.site, l2.site), $e(e3), void $e(r3);
              if (r3) {
                Qe(e3), Qe(r3);
                var u2 = e3.site, c2 = u2.x, f3 = u2.y, h2 = t3.x - c2, p3 = t3.y - f3, d3 = r3.site, v2 = d3.x - c2, g3 = d3.y - f3, y2 = 2 * (h2 * g3 - p3 * v2), m3 = h2 * h2 + p3 * p3, x2 = v2 * v2 + g3 * g3, b2 = { x: (g3 * m3 - p3 * x2) / y2 + c2, y: (h2 * x2 - v2 * m3) / y2 + f3 };
                nr(r3.edge, u2, d3, b2), l2.edge = rr(u2, t3, null, b2), r3.edge = rr(t3, d3, null, b2), $e(e3), $e(r3);
              } else
                l2.edge = rr(e3.site, l2.site);
            }
          }
          function Ye(t3, e3) {
            var r3 = t3.site, n3 = r3.x, i2 = r3.y, a2 = i2 - e3;
            if (!a2)
              return n3;
            var o2 = t3.P;
            if (!o2)
              return -1 / 0;
            var s2 = (r3 = o2.site).x, l2 = r3.y, u2 = l2 - e3;
            if (!u2)
              return s2;
            var c2 = s2 - n3, f3 = 1 / a2 - 1 / u2, h2 = c2 / u2;
            return f3 ? (-h2 + Math.sqrt(h2 * h2 - 2 * f3 * (c2 * c2 / (-2 * u2) - l2 + u2 / 2 + i2 - a2 / 2))) / f3 + n3 : (n3 + s2) / 2;
          }
          function We(t3, e3) {
            var r3 = t3.N;
            if (r3)
              return Ye(r3, e3);
            var n3 = t3.site;
            return n3.y === e3 ? n3.x : 1 / 0;
          }
          function Xe(t3) {
            this.site = t3, this.edges = [];
          }
          function Je(t3, e3) {
            return e3.angle - t3.angle;
          }
          function Ke() {
            or(this), this.x = this.y = this.arc = this.site = this.cy = null;
          }
          function $e(t3) {
            var e3 = t3.P, r3 = t3.N;
            if (e3 && r3) {
              var n3 = e3.site, i2 = t3.site, a2 = r3.site;
              if (n3 !== a2) {
                var o2 = i2.x, s2 = i2.y, l2 = n3.x - o2, u2 = n3.y - s2, c2 = a2.x - o2, f3 = 2 * (l2 * (g3 = a2.y - s2) - u2 * c2);
                if (!(f3 >= -1e-12)) {
                  var h2 = l2 * l2 + u2 * u2, p3 = c2 * c2 + g3 * g3, d3 = (g3 * h2 - u2 * p3) / f3, v2 = (l2 * p3 - c2 * h2) / f3, g3 = v2 + s2, y2 = Ue.pop() || new Ke();
                  y2.arc = t3, y2.site = i2, y2.x = d3 + o2, y2.y = g3 + Math.sqrt(d3 * d3 + v2 * v2), y2.cy = g3, t3.circle = y2;
                  for (var m3 = null, x2 = Ne._; x2; )
                    if (y2.y < x2.y || y2.y === x2.y && y2.x <= x2.x) {
                      if (!x2.L) {
                        m3 = x2.P;
                        break;
                      }
                      x2 = x2.L;
                    } else {
                      if (!x2.R) {
                        m3 = x2;
                        break;
                      }
                      x2 = x2.R;
                    }
                  Ne.insert(m3, y2), m3 || (Be = y2);
                }
              }
            }
          }
          function Qe(t3) {
            var e3 = t3.circle;
            e3 && (e3.P || (Be = e3.N), Ne.remove(e3), Ue.push(e3), or(e3), t3.circle = null);
          }
          function tr(t3, e3) {
            var r3 = t3.b;
            if (r3)
              return true;
            var n3, i2, a2 = t3.a, o2 = e3[0][0], s2 = e3[1][0], l2 = e3[0][1], u2 = e3[1][1], c2 = t3.l, f3 = t3.r, h2 = c2.x, p3 = c2.y, d3 = f3.x, v2 = f3.y, g3 = (h2 + d3) / 2, y2 = (p3 + v2) / 2;
            if (v2 === p3) {
              if (g3 < o2 || g3 >= s2)
                return;
              if (h2 > d3) {
                if (a2) {
                  if (a2.y >= u2)
                    return;
                } else
                  a2 = { x: g3, y: l2 };
                r3 = { x: g3, y: u2 };
              } else {
                if (a2) {
                  if (a2.y < l2)
                    return;
                } else
                  a2 = { x: g3, y: u2 };
                r3 = { x: g3, y: l2 };
              }
            } else if (i2 = y2 - (n3 = (h2 - d3) / (v2 - p3)) * g3, n3 < -1 || n3 > 1)
              if (h2 > d3) {
                if (a2) {
                  if (a2.y >= u2)
                    return;
                } else
                  a2 = { x: (l2 - i2) / n3, y: l2 };
                r3 = { x: (u2 - i2) / n3, y: u2 };
              } else {
                if (a2) {
                  if (a2.y < l2)
                    return;
                } else
                  a2 = { x: (u2 - i2) / n3, y: u2 };
                r3 = { x: (l2 - i2) / n3, y: l2 };
              }
            else if (p3 < v2) {
              if (a2) {
                if (a2.x >= s2)
                  return;
              } else
                a2 = { x: o2, y: n3 * o2 + i2 };
              r3 = { x: s2, y: n3 * s2 + i2 };
            } else {
              if (a2) {
                if (a2.x < o2)
                  return;
              } else
                a2 = { x: s2, y: n3 * s2 + i2 };
              r3 = { x: o2, y: n3 * o2 + i2 };
            }
            return t3.a = a2, t3.b = r3, true;
          }
          function er(t3, e3) {
            this.l = t3, this.r = e3, this.a = this.b = null;
          }
          function rr(t3, e3, r3, n3) {
            var i2 = new er(t3, e3);
            return ze.push(i2), r3 && nr(i2, t3, e3, r3), n3 && nr(i2, e3, t3, n3), Re[t3.i].edges.push(new ir(i2, t3, e3)), Re[e3.i].edges.push(new ir(i2, e3, t3)), i2;
          }
          function nr(t3, e3, r3, n3) {
            t3.a || t3.b ? t3.l === r3 ? t3.b = n3 : t3.a = n3 : (t3.a = n3, t3.l = e3, t3.r = r3);
          }
          function ir(t3, e3, r3) {
            var n3 = t3.a, i2 = t3.b;
            this.edge = t3, this.site = e3, this.angle = r3 ? Math.atan2(r3.y - e3.y, r3.x - e3.x) : t3.l === e3 ? Math.atan2(i2.x - n3.x, n3.y - i2.y) : Math.atan2(n3.x - i2.x, i2.y - n3.y);
          }
          function ar() {
            this._ = null;
          }
          function or(t3) {
            t3.U = t3.C = t3.L = t3.R = t3.P = t3.N = null;
          }
          function sr(t3, e3) {
            var r3 = e3, n3 = e3.R, i2 = r3.U;
            i2 ? i2.L === r3 ? i2.L = n3 : i2.R = n3 : t3._ = n3, n3.U = i2, r3.U = n3, r3.R = n3.L, r3.R && (r3.R.U = r3), n3.L = r3;
          }
          function lr(t3, e3) {
            var r3 = e3, n3 = e3.L, i2 = r3.U;
            i2 ? i2.L === r3 ? i2.L = n3 : i2.R = n3 : t3._ = n3, n3.U = i2, r3.U = n3, r3.L = n3.R, r3.L && (r3.L.U = r3), n3.R = r3;
          }
          function ur(t3) {
            for (; t3.L; )
              t3 = t3.L;
            return t3;
          }
          function cr(t3, e3) {
            var r3, n3, i2, a2 = t3.sort(fr).pop();
            for (ze = [], Re = new Array(t3.length), Fe = new ar(), Ne = new ar(); ; )
              if (i2 = Be, a2 && (!i2 || a2.y < i2.y || a2.y === i2.y && a2.x < i2.x))
                a2.x === r3 && a2.y === n3 || (Re[a2.i] = new Xe(a2), Ze(a2), r3 = a2.x, n3 = a2.y), a2 = t3.pop();
              else {
                if (!i2)
                  break;
                Ge(i2.arc);
              }
            e3 && (function(t4) {
              for (var e4, r4, n4, i3, a3, o3 = ze, s2 = (r4 = t4[0][0], n4 = t4[0][1], i3 = t4[1][0], a3 = t4[1][1], function(t5) {
                var e5, o4 = t5.a, s3 = t5.b, l3 = o4.x, u2 = o4.y, c2 = 0, f3 = 1, h2 = s3.x - l3, p3 = s3.y - u2;
                if (e5 = r4 - l3, h2 || !(e5 > 0)) {
                  if (e5 /= h2, h2 < 0) {
                    if (e5 < c2)
                      return;
                    e5 < f3 && (f3 = e5);
                  } else if (h2 > 0) {
                    if (e5 > f3)
                      return;
                    e5 > c2 && (c2 = e5);
                  }
                  if (e5 = i3 - l3, h2 || !(e5 < 0)) {
                    if (e5 /= h2, h2 < 0) {
                      if (e5 > f3)
                        return;
                      e5 > c2 && (c2 = e5);
                    } else if (h2 > 0) {
                      if (e5 < c2)
                        return;
                      e5 < f3 && (f3 = e5);
                    }
                    if (e5 = n4 - u2, p3 || !(e5 > 0)) {
                      if (e5 /= p3, p3 < 0) {
                        if (e5 < c2)
                          return;
                        e5 < f3 && (f3 = e5);
                      } else if (p3 > 0) {
                        if (e5 > f3)
                          return;
                        e5 > c2 && (c2 = e5);
                      }
                      if (e5 = a3 - u2, p3 || !(e5 < 0)) {
                        if (e5 /= p3, p3 < 0) {
                          if (e5 > f3)
                            return;
                          e5 > c2 && (c2 = e5);
                        } else if (p3 > 0) {
                          if (e5 < c2)
                            return;
                          e5 < f3 && (f3 = e5);
                        }
                        return c2 > 0 && (t5.a = { x: l3 + c2 * h2, y: u2 + c2 * p3 }), f3 < 1 && (t5.b = { x: l3 + f3 * h2, y: u2 + f3 * p3 }), t5;
                      }
                    }
                  }
                }
              }), l2 = o3.length; l2--; )
                (!tr(e4 = o3[l2], t4) || !s2(e4) || w2(e4.a.x - e4.b.x) < Et && w2(e4.a.y - e4.b.y) < Et) && (e4.a = e4.b = null, o3.splice(l2, 1));
            }(e3), function(t4) {
              for (var e4, r4, n4, i3, a3, o3, s2, l2, u2, c2, f3 = t4[0][0], h2 = t4[1][0], p3 = t4[0][1], d3 = t4[1][1], v2 = Re, g3 = v2.length; g3--; )
                if ((a3 = v2[g3]) && a3.prepare())
                  for (l2 = (s2 = a3.edges).length, o3 = 0; o3 < l2; )
                    n4 = (c2 = s2[o3].end()).x, i3 = c2.y, e4 = (u2 = s2[++o3 % l2].start()).x, r4 = u2.y, (w2(n4 - e4) > Et || w2(i3 - r4) > Et) && (s2.splice(o3, 0, new ir((y2 = a3.site, m3 = c2, x2 = w2(n4 - f3) < Et && d3 - i3 > Et ? { x: f3, y: w2(e4 - f3) < Et ? r4 : d3 } : w2(i3 - d3) < Et && h2 - n4 > Et ? { x: w2(r4 - d3) < Et ? e4 : h2, y: d3 } : w2(n4 - h2) < Et && i3 - p3 > Et ? { x: h2, y: w2(e4 - h2) < Et ? r4 : p3 } : w2(i3 - p3) < Et && n4 - f3 > Et ? { x: w2(r4 - p3) < Et ? e4 : f3, y: p3 } : null, b2 = void 0, (b2 = new er(y2, null)).a = m3, b2.b = x2, ze.push(b2), b2), a3.site, null)), ++l2);
              var y2, m3, x2, b2;
            }(e3));
            var o2 = { cells: Re, edges: ze };
            return Fe = Ne = ze = Re = null, o2;
          }
          function fr(t3, e3) {
            return e3.y - t3.y || e3.x - t3.x;
          }
          Xe.prototype.prepare = function() {
            for (var t3, e3 = this.edges, r3 = e3.length; r3--; )
              (t3 = e3[r3].edge).b && t3.a || e3.splice(r3, 1);
            return e3.sort(Je), e3.length;
          }, ir.prototype = { start: function() {
            return this.edge.l === this.site ? this.edge.a : this.edge.b;
          }, end: function() {
            return this.edge.l === this.site ? this.edge.b : this.edge.a;
          } }, ar.prototype = { insert: function(t3, e3) {
            var r3, n3, i2;
            if (t3) {
              if (e3.P = t3, e3.N = t3.N, t3.N && (t3.N.P = e3), t3.N = e3, t3.R) {
                for (t3 = t3.R; t3.L; )
                  t3 = t3.L;
                t3.L = e3;
              } else
                t3.R = e3;
              r3 = t3;
            } else
              this._ ? (t3 = ur(this._), e3.P = null, e3.N = t3, t3.P = t3.L = e3, r3 = t3) : (e3.P = e3.N = null, this._ = e3, r3 = null);
            for (e3.L = e3.R = null, e3.U = r3, e3.C = true, t3 = e3; r3 && r3.C; )
              r3 === (n3 = r3.U).L ? (i2 = n3.R) && i2.C ? (r3.C = i2.C = false, n3.C = true, t3 = n3) : (t3 === r3.R && (sr(this, r3), r3 = (t3 = r3).U), r3.C = false, n3.C = true, lr(this, n3)) : (i2 = n3.L) && i2.C ? (r3.C = i2.C = false, n3.C = true, t3 = n3) : (t3 === r3.L && (lr(this, r3), r3 = (t3 = r3).U), r3.C = false, n3.C = true, sr(this, n3)), r3 = t3.U;
            this._.C = false;
          }, remove: function(t3) {
            t3.N && (t3.N.P = t3.P), t3.P && (t3.P.N = t3.N), t3.N = t3.P = null;
            var e3, r3, n3, i2 = t3.U, a2 = t3.L, o2 = t3.R;
            if (r3 = a2 ? o2 ? ur(o2) : a2 : o2, i2 ? i2.L === t3 ? i2.L = r3 : i2.R = r3 : this._ = r3, a2 && o2 ? (n3 = r3.C, r3.C = t3.C, r3.L = a2, a2.U = r3, r3 !== o2 ? (i2 = r3.U, r3.U = t3.U, t3 = r3.R, i2.L = t3, r3.R = o2, o2.U = r3) : (r3.U = i2, i2 = r3, t3 = r3.R)) : (n3 = t3.C, t3 = r3), t3 && (t3.U = i2), !n3)
              if (t3 && t3.C)
                t3.C = false;
              else {
                do {
                  if (t3 === this._)
                    break;
                  if (t3 === i2.L) {
                    if ((e3 = i2.R).C && (e3.C = false, i2.C = true, sr(this, i2), e3 = i2.R), e3.L && e3.L.C || e3.R && e3.R.C) {
                      e3.R && e3.R.C || (e3.L.C = false, e3.C = true, lr(this, e3), e3 = i2.R), e3.C = i2.C, i2.C = e3.R.C = false, sr(this, i2), t3 = this._;
                      break;
                    }
                  } else if ((e3 = i2.L).C && (e3.C = false, i2.C = true, lr(this, i2), e3 = i2.L), e3.L && e3.L.C || e3.R && e3.R.C) {
                    e3.L && e3.L.C || (e3.R.C = false, e3.C = true, sr(this, e3), e3 = i2.L), e3.C = i2.C, i2.C = e3.L.C = false, lr(this, i2), t3 = this._;
                    break;
                  }
                  e3.C = true, t3 = i2, i2 = i2.U;
                } while (!t3.C);
                t3 && (t3.C = false);
              }
          } }, a.geom.voronoi = function(t3) {
            var e3 = Se, r3 = Ee, n3 = e3, i2 = r3, a2 = hr;
            if (t3)
              return o2(t3);
            function o2(t4) {
              var e4 = new Array(t4.length), r4 = a2[0][0], n4 = a2[0][1], i3 = a2[1][0], o3 = a2[1][1];
              return cr(s2(t4), a2).cells.forEach(function(a3, s3) {
                var l2 = a3.edges, u2 = a3.site;
                (e4[s3] = l2.length ? l2.map(function(t5) {
                  var e5 = t5.start();
                  return [e5.x, e5.y];
                }) : u2.x >= r4 && u2.x <= i3 && u2.y >= n4 && u2.y <= o3 ? [[r4, o3], [i3, o3], [i3, n4], [r4, n4]] : []).point = t4[s3];
              }), e4;
            }
            function s2(t4) {
              return t4.map(function(t5, e4) {
                return { x: Math.round(n3(t5, e4) / Et) * Et, y: Math.round(i2(t5, e4) / Et) * Et, i: e4 };
              });
            }
            return o2.links = function(t4) {
              return cr(s2(t4)).edges.filter(function(t5) {
                return t5.l && t5.r;
              }).map(function(e4) {
                return { source: t4[e4.l.i], target: t4[e4.r.i] };
              });
            }, o2.triangles = function(t4) {
              var e4 = [];
              return cr(s2(t4)).cells.forEach(function(r4, n4) {
                for (var i3, a3, o3, s3, l2 = r4.site, u2 = r4.edges.sort(Je), c2 = -1, f3 = u2.length, h2 = u2[f3 - 1].edge, p3 = h2.l === l2 ? h2.r : h2.l; ++c2 < f3; )
                  i3 = p3, p3 = (h2 = u2[c2].edge).l === l2 ? h2.r : h2.l, n4 < i3.i && n4 < p3.i && (o3 = i3, s3 = p3, ((a3 = l2).x - s3.x) * (o3.y - a3.y) - (a3.x - o3.x) * (s3.y - a3.y) < 0) && e4.push([t4[n4], t4[i3.i], t4[p3.i]]);
              }), e4;
            }, o2.x = function(t4) {
              return arguments.length ? (n3 = ve(e3 = t4), o2) : e3;
            }, o2.y = function(t4) {
              return arguments.length ? (i2 = ve(r3 = t4), o2) : r3;
            }, o2.clipExtent = function(t4) {
              return arguments.length ? (a2 = null == t4 ? hr : t4, o2) : a2 === hr ? null : a2;
            }, o2.size = function(t4) {
              return arguments.length ? o2.clipExtent(t4 && [[0, 0], t4]) : a2 === hr ? null : a2 && a2[1];
            }, o2;
          };
          var hr = [[-1e6, -1e6], [1e6, 1e6]];
          function pr(t3) {
            return t3.x;
          }
          function dr(t3) {
            return t3.y;
          }
          function vr(t3, e3, r3, n3, i2, a2) {
            if (!t3(e3, r3, n3, i2, a2)) {
              var o2 = 0.5 * (r3 + i2), s2 = 0.5 * (n3 + a2), l2 = e3.nodes;
              l2[0] && vr(t3, l2[0], r3, n3, o2, s2), l2[1] && vr(t3, l2[1], o2, n3, i2, s2), l2[2] && vr(t3, l2[2], r3, s2, o2, a2), l2[3] && vr(t3, l2[3], o2, s2, i2, a2);
            }
          }
          function gr(t3, e3, r3, n3, i2, a2, o2) {
            var s2, l2 = 1 / 0;
            return function t4(u2, c2, f3, h2, p3) {
              if (!(c2 > a2 || f3 > o2 || h2 < n3 || p3 < i2)) {
                if (d3 = u2.point) {
                  var d3, v2 = e3 - u2.x, g3 = r3 - u2.y, y2 = v2 * v2 + g3 * g3;
                  if (y2 < l2) {
                    var m3 = Math.sqrt(l2 = y2);
                    n3 = e3 - m3, i2 = r3 - m3, a2 = e3 + m3, o2 = r3 + m3, s2 = d3;
                  }
                }
                for (var x2 = u2.nodes, b2 = 0.5 * (c2 + h2), _2 = 0.5 * (f3 + p3), w3 = (r3 >= _2) << 1 | e3 >= b2, T2 = w3 + 4; w3 < T2; ++w3)
                  if (u2 = x2[3 & w3])
                    switch (3 & w3) {
                      case 0:
                        t4(u2, c2, f3, b2, _2);
                        break;
                      case 1:
                        t4(u2, b2, f3, h2, _2);
                        break;
                      case 2:
                        t4(u2, c2, _2, b2, p3);
                        break;
                      case 3:
                        t4(u2, b2, _2, h2, p3);
                    }
              }
            }(t3, n3, i2, a2, o2), s2;
          }
          function yr(t3, e3) {
            t3 = a.rgb(t3), e3 = a.rgb(e3);
            var r3 = t3.r, n3 = t3.g, i2 = t3.b, o2 = e3.r - r3, s2 = e3.g - n3, l2 = e3.b - i2;
            return function(t4) {
              return "#" + le(Math.round(r3 + o2 * t4)) + le(Math.round(n3 + s2 * t4)) + le(Math.round(i2 + l2 * t4));
            };
          }
          function mr(t3, e3) {
            var r3, n3 = {}, i2 = {};
            for (r3 in t3)
              r3 in e3 ? n3[r3] = Tr(t3[r3], e3[r3]) : i2[r3] = t3[r3];
            for (r3 in e3)
              r3 in t3 || (i2[r3] = e3[r3]);
            return function(t4) {
              for (r3 in n3)
                i2[r3] = n3[r3](t4);
              return i2;
            };
          }
          function xr(t3, e3) {
            return t3 = +t3, e3 = +e3, function(r3) {
              return t3 * (1 - r3) + e3 * r3;
            };
          }
          function br(t3, e3) {
            var r3, n3, i2, a2 = _r.lastIndex = wr.lastIndex = 0, o2 = -1, s2 = [], l2 = [];
            for (t3 += "", e3 += ""; (r3 = _r.exec(t3)) && (n3 = wr.exec(e3)); )
              (i2 = n3.index) > a2 && (i2 = e3.slice(a2, i2), s2[o2] ? s2[o2] += i2 : s2[++o2] = i2), (r3 = r3[0]) === (n3 = n3[0]) ? s2[o2] ? s2[o2] += n3 : s2[++o2] = n3 : (s2[++o2] = null, l2.push({ i: o2, x: xr(r3, n3) })), a2 = wr.lastIndex;
            return a2 < e3.length && (i2 = e3.slice(a2), s2[o2] ? s2[o2] += i2 : s2[++o2] = i2), s2.length < 2 ? l2[0] ? (e3 = l2[0].x, function(t4) {
              return e3(t4) + "";
            }) : function() {
              return e3;
            } : (e3 = l2.length, function(t4) {
              for (var r4, n4 = 0; n4 < e3; ++n4)
                s2[(r4 = l2[n4]).i] = r4.x(t4);
              return s2.join("");
            });
          }
          a.geom.delaunay = function(t3) {
            return a.geom.voronoi().triangles(t3);
          }, a.geom.quadtree = function(t3, e3, r3, n3, i2) {
            var a2, o2 = Se, s2 = Ee;
            if (a2 = arguments.length)
              return o2 = pr, s2 = dr, 3 === a2 && (i2 = r3, n3 = e3, r3 = e3 = 0), l2(t3);
            function l2(t4) {
              var l3, u2, c2, f3, h2, p3, d3, v2, g3, y2 = ve(o2), m3 = ve(s2);
              if (null != e3)
                p3 = e3, d3 = r3, v2 = n3, g3 = i2;
              else if (v2 = g3 = -(p3 = d3 = 1 / 0), u2 = [], c2 = [], h2 = t4.length, a2)
                for (f3 = 0; f3 < h2; ++f3)
                  (l3 = t4[f3]).x < p3 && (p3 = l3.x), l3.y < d3 && (d3 = l3.y), l3.x > v2 && (v2 = l3.x), l3.y > g3 && (g3 = l3.y), u2.push(l3.x), c2.push(l3.y);
              else
                for (f3 = 0; f3 < h2; ++f3) {
                  var x2 = +y2(l3 = t4[f3], f3), b2 = +m3(l3, f3);
                  x2 < p3 && (p3 = x2), b2 < d3 && (d3 = b2), x2 > v2 && (v2 = x2), b2 > g3 && (g3 = b2), u2.push(x2), c2.push(b2);
                }
              var _2 = v2 - p3, T2 = g3 - d3;
              function k2(t5, e4, r4, n4, i3, a3, o3, s3) {
                if (!isNaN(r4) && !isNaN(n4))
                  if (t5.leaf) {
                    var l4 = t5.x, u3 = t5.y;
                    if (null != l4)
                      if (w2(l4 - r4) + w2(u3 - n4) < 0.01)
                        A2(t5, e4, r4, n4, i3, a3, o3, s3);
                      else {
                        var c3 = t5.point;
                        t5.x = t5.y = t5.point = null, A2(t5, c3, l4, u3, i3, a3, o3, s3), A2(t5, e4, r4, n4, i3, a3, o3, s3);
                      }
                    else
                      t5.x = r4, t5.y = n4, t5.point = e4;
                  } else
                    A2(t5, e4, r4, n4, i3, a3, o3, s3);
              }
              function A2(t5, e4, r4, n4, i3, a3, o3, s3) {
                var l4 = 0.5 * (i3 + o3), u3 = 0.5 * (a3 + s3), c3 = r4 >= l4, f4 = n4 >= u3, h3 = f4 << 1 | c3;
                t5.leaf = false, c3 ? i3 = l4 : o3 = l4, f4 ? a3 = u3 : s3 = u3, k2(t5 = t5.nodes[h3] || (t5.nodes[h3] = { leaf: true, nodes: [], point: null, x: null, y: null }), e4, r4, n4, i3, a3, o3, s3);
              }
              _2 > T2 ? g3 = d3 + _2 : v2 = p3 + T2;
              var M2 = { leaf: true, nodes: [], point: null, x: null, y: null, add: function(t5) {
                k2(M2, t5, +y2(t5, ++f3), +m3(t5, f3), p3, d3, v2, g3);
              }, visit: function(t5) {
                vr(t5, M2, p3, d3, v2, g3);
              }, find: function(t5) {
                return gr(M2, t5[0], t5[1], p3, d3, v2, g3);
              } };
              if (f3 = -1, null == e3) {
                for (; ++f3 < h2; )
                  k2(M2, t4[f3], u2[f3], c2[f3], p3, d3, v2, g3);
                --f3;
              } else
                t4.forEach(M2.add);
              return u2 = c2 = t4 = l3 = null, M2;
            }
            return l2.x = function(t4) {
              return arguments.length ? (o2 = t4, l2) : o2;
            }, l2.y = function(t4) {
              return arguments.length ? (s2 = t4, l2) : s2;
            }, l2.extent = function(t4) {
              return arguments.length ? (null == t4 ? e3 = r3 = n3 = i2 = null : (e3 = +t4[0][0], r3 = +t4[0][1], n3 = +t4[1][0], i2 = +t4[1][1]), l2) : null == e3 ? null : [[e3, r3], [n3, i2]];
            }, l2.size = function(t4) {
              return arguments.length ? (null == t4 ? e3 = r3 = n3 = i2 = null : (e3 = r3 = 0, n3 = +t4[0], i2 = +t4[1]), l2) : null == e3 ? null : [n3 - e3, i2 - r3];
            }, l2;
          }, a.interpolateRgb = yr, a.interpolateObject = mr, a.interpolateNumber = xr, a.interpolateString = br;
          var _r = /[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g, wr = new RegExp(_r.source, "g");
          function Tr(t3, e3) {
            for (var r3, n3 = a.interpolators.length; --n3 >= 0 && !(r3 = a.interpolators[n3](t3, e3)); )
              ;
            return r3;
          }
          function kr(t3, e3) {
            var r3, n3 = [], i2 = [], a2 = t3.length, o2 = e3.length, s2 = Math.min(t3.length, e3.length);
            for (r3 = 0; r3 < s2; ++r3)
              n3.push(Tr(t3[r3], e3[r3]));
            for (; r3 < a2; ++r3)
              i2[r3] = t3[r3];
            for (; r3 < o2; ++r3)
              i2[r3] = e3[r3];
            return function(t4) {
              for (r3 = 0; r3 < s2; ++r3)
                i2[r3] = n3[r3](t4);
              return i2;
            };
          }
          a.interpolate = Tr, a.interpolators = [function(t3, e3) {
            var r3 = typeof e3;
            return ("string" === r3 ? de.has(e3.toLowerCase()) || /^(#|rgb\(|hsl\()/i.test(e3) ? yr : br : e3 instanceof Ut ? yr : Array.isArray(e3) ? kr : "object" === r3 && isNaN(e3) ? mr : xr)(t3, e3);
          }], a.interpolateArray = kr;
          var Ar = function() {
            return D;
          }, Mr = a.map({ linear: Ar, poly: function(t3) {
            return function(e3) {
              return Math.pow(e3, t3);
            };
          }, quad: function() {
            return Pr;
          }, cubic: function() {
            return Or;
          }, sin: function() {
            return Dr;
          }, exp: function() {
            return zr;
          }, circle: function() {
            return Rr;
          }, elastic: function(t3, e3) {
            var r3;
            return arguments.length < 2 && (e3 = 0.45), arguments.length ? r3 = e3 / Ct * Math.asin(1 / t3) : (t3 = 1, r3 = e3 / 4), function(n3) {
              return 1 + t3 * Math.pow(2, -10 * n3) * Math.sin((n3 - r3) * Ct / e3);
            };
          }, back: function(t3) {
            return t3 || (t3 = 1.70158), function(e3) {
              return e3 * e3 * ((t3 + 1) * e3 - t3);
            };
          }, bounce: function() {
            return Fr;
          } }), Sr = a.map({ in: D, out: Lr, "in-out": Cr, "out-in": function(t3) {
            return Cr(Lr(t3));
          } });
          function Er(t3) {
            return function(e3) {
              return e3 <= 0 ? 0 : e3 >= 1 ? 1 : t3(e3);
            };
          }
          function Lr(t3) {
            return function(e3) {
              return 1 - t3(1 - e3);
            };
          }
          function Cr(t3) {
            return function(e3) {
              return 0.5 * (e3 < 0.5 ? t3(2 * e3) : 2 - t3(2 - 2 * e3));
            };
          }
          function Pr(t3) {
            return t3 * t3;
          }
          function Or(t3) {
            return t3 * t3 * t3;
          }
          function Ir(t3) {
            if (t3 <= 0)
              return 0;
            if (t3 >= 1)
              return 1;
            var e3 = t3 * t3, r3 = e3 * t3;
            return 4 * (t3 < 0.5 ? r3 : 3 * (t3 - e3) + r3 - 0.75);
          }
          function Dr(t3) {
            return 1 - Math.cos(t3 * Ot);
          }
          function zr(t3) {
            return Math.pow(2, 10 * (t3 - 1));
          }
          function Rr(t3) {
            return 1 - Math.sqrt(1 - t3 * t3);
          }
          function Fr(t3) {
            return t3 < 1 / 2.75 ? 7.5625 * t3 * t3 : t3 < 2 / 2.75 ? 7.5625 * (t3 -= 1.5 / 2.75) * t3 + 0.75 : t3 < 2.5 / 2.75 ? 7.5625 * (t3 -= 2.25 / 2.75) * t3 + 0.9375 : 7.5625 * (t3 -= 2.625 / 2.75) * t3 + 0.984375;
          }
          function Br(t3, e3) {
            return e3 -= t3, function(r3) {
              return Math.round(t3 + e3 * r3);
            };
          }
          function Nr(t3) {
            var e3, r3, n3, i2 = [t3.a, t3.b], a2 = [t3.c, t3.d], o2 = Ur(i2), s2 = jr(i2, a2), l2 = Ur(((e3 = a2)[0] += (n3 = -s2) * (r3 = i2)[0], e3[1] += n3 * r3[1], e3)) || 0;
            i2[0] * a2[1] < a2[0] * i2[1] && (i2[0] *= -1, i2[1] *= -1, o2 *= -1, s2 *= -1), this.rotate = (o2 ? Math.atan2(i2[1], i2[0]) : Math.atan2(-a2[0], a2[1])) * Dt, this.translate = [t3.e, t3.f], this.scale = [o2, l2], this.skew = l2 ? Math.atan2(s2, l2) * Dt : 0;
          }
          function jr(t3, e3) {
            return t3[0] * e3[0] + t3[1] * e3[1];
          }
          function Ur(t3) {
            var e3 = Math.sqrt(jr(t3, t3));
            return e3 && (t3[0] /= e3, t3[1] /= e3), e3;
          }
          a.ease = function(t3) {
            var e3 = t3.indexOf("-"), r3 = e3 >= 0 ? t3.slice(0, e3) : t3, n3 = e3 >= 0 ? t3.slice(e3 + 1) : "in";
            return r3 = Mr.get(r3) || Ar, Er((n3 = Sr.get(n3) || D)(r3.apply(null, o.call(arguments, 1))));
          }, a.interpolateHcl = function(t3, e3) {
            t3 = a.hcl(t3), e3 = a.hcl(e3);
            var r3 = t3.h, n3 = t3.c, i2 = t3.l, o2 = e3.h - r3, s2 = e3.c - n3, l2 = e3.l - i2;
            return isNaN(s2) && (s2 = 0, n3 = isNaN(n3) ? e3.c : n3), isNaN(o2) ? (o2 = 0, r3 = isNaN(r3) ? e3.h : r3) : o2 > 180 ? o2 -= 360 : o2 < -180 && (o2 += 360), function(t4) {
              return Yt(r3 + o2 * t4, n3 + s2 * t4, i2 + l2 * t4) + "";
            };
          }, a.interpolateHsl = function(t3, e3) {
            t3 = a.hsl(t3), e3 = a.hsl(e3);
            var r3 = t3.h, n3 = t3.s, i2 = t3.l, o2 = e3.h - r3, s2 = e3.s - n3, l2 = e3.l - i2;
            return isNaN(s2) && (s2 = 0, n3 = isNaN(n3) ? e3.s : n3), isNaN(o2) ? (o2 = 0, r3 = isNaN(r3) ? e3.h : r3) : o2 > 180 ? o2 -= 360 : o2 < -180 && (o2 += 360), function(t4) {
              return qt(r3 + o2 * t4, n3 + s2 * t4, i2 + l2 * t4) + "";
            };
          }, a.interpolateLab = function(t3, e3) {
            t3 = a.lab(t3), e3 = a.lab(e3);
            var r3 = t3.l, n3 = t3.a, i2 = t3.b, o2 = e3.l - r3, s2 = e3.a - n3, l2 = e3.b - i2;
            return function(t4) {
              return Qt(r3 + o2 * t4, n3 + s2 * t4, i2 + l2 * t4) + "";
            };
          }, a.interpolateRound = Br, a.transform = function(t3) {
            var e3 = l.createElementNS(a.ns.prefix.svg, "g");
            return (a.transform = function(t4) {
              if (null != t4) {
                e3.setAttribute("transform", t4);
                var r3 = e3.transform.baseVal.consolidate();
              }
              return new Nr(r3 ? r3.matrix : Vr);
            })(t3);
          }, Nr.prototype.toString = function() {
            return "translate(" + this.translate + ")rotate(" + this.rotate + ")skewX(" + this.skew + ")scale(" + this.scale + ")";
          };
          var Vr = { a: 1, b: 0, c: 0, d: 1, e: 0, f: 0 };
          function Hr(t3) {
            return t3.length ? t3.pop() + "," : "";
          }
          function qr(t3, e3) {
            var r3 = [], n3 = [];
            return t3 = a.transform(t3), e3 = a.transform(e3), function(t4, e4, r4, n4) {
              if (t4[0] !== e4[0] || t4[1] !== e4[1]) {
                var i2 = r4.push("translate(", null, ",", null, ")");
                n4.push({ i: i2 - 4, x: xr(t4[0], e4[0]) }, { i: i2 - 2, x: xr(t4[1], e4[1]) });
              } else
                (e4[0] || e4[1]) && r4.push("translate(" + e4 + ")");
            }(t3.translate, e3.translate, r3, n3), function(t4, e4, r4, n4) {
              t4 !== e4 ? (t4 - e4 > 180 ? e4 += 360 : e4 - t4 > 180 && (t4 += 360), n4.push({ i: r4.push(Hr(r4) + "rotate(", null, ")") - 2, x: xr(t4, e4) })) : e4 && r4.push(Hr(r4) + "rotate(" + e4 + ")");
            }(t3.rotate, e3.rotate, r3, n3), function(t4, e4, r4, n4) {
              t4 !== e4 ? n4.push({ i: r4.push(Hr(r4) + "skewX(", null, ")") - 2, x: xr(t4, e4) }) : e4 && r4.push(Hr(r4) + "skewX(" + e4 + ")");
            }(t3.skew, e3.skew, r3, n3), function(t4, e4, r4, n4) {
              if (t4[0] !== e4[0] || t4[1] !== e4[1]) {
                var i2 = r4.push(Hr(r4) + "scale(", null, ",", null, ")");
                n4.push({ i: i2 - 4, x: xr(t4[0], e4[0]) }, { i: i2 - 2, x: xr(t4[1], e4[1]) });
              } else
                1 === e4[0] && 1 === e4[1] || r4.push(Hr(r4) + "scale(" + e4 + ")");
            }(t3.scale, e3.scale, r3, n3), t3 = e3 = null, function(t4) {
              for (var e4, i2 = -1, a2 = n3.length; ++i2 < a2; )
                r3[(e4 = n3[i2]).i] = e4.x(t4);
              return r3.join("");
            };
          }
          function Gr(t3, e3) {
            return e3 = (e3 -= t3 = +t3) || 1 / e3, function(r3) {
              return (r3 - t3) / e3;
            };
          }
          function Zr(t3, e3) {
            return e3 = (e3 -= t3 = +t3) || 1 / e3, function(r3) {
              return Math.max(0, Math.min(1, (r3 - t3) / e3));
            };
          }
          function Yr(t3) {
            for (var e3 = t3.source, r3 = t3.target, n3 = function(t4, e4) {
              if (t4 === e4)
                return t4;
              for (var r4 = Wr(t4), n4 = Wr(e4), i3 = r4.pop(), a3 = n4.pop(), o2 = null; i3 === a3; )
                o2 = i3, i3 = r4.pop(), a3 = n4.pop();
              return o2;
            }(e3, r3), i2 = [e3]; e3 !== n3; )
              e3 = e3.parent, i2.push(e3);
            for (var a2 = i2.length; r3 !== n3; )
              i2.splice(a2, 0, r3), r3 = r3.parent;
            return i2;
          }
          function Wr(t3) {
            for (var e3 = [], r3 = t3.parent; null != r3; )
              e3.push(t3), t3 = r3, r3 = r3.parent;
            return e3.push(t3), e3;
          }
          function Xr(t3) {
            t3.fixed |= 2;
          }
          function Jr(t3) {
            t3.fixed &= -7;
          }
          function Kr(t3) {
            t3.fixed |= 4, t3.px = t3.x, t3.py = t3.y;
          }
          function $r(t3) {
            t3.fixed &= -5;
          }
          function Qr(t3, e3, r3) {
            var n3 = 0, i2 = 0;
            if (t3.charge = 0, !t3.leaf)
              for (var a2, o2 = t3.nodes, s2 = o2.length, l2 = -1; ++l2 < s2; )
                null != (a2 = o2[l2]) && (Qr(a2, e3, r3), t3.charge += a2.charge, n3 += a2.charge * a2.cx, i2 += a2.charge * a2.cy);
            if (t3.point) {
              t3.leaf || (t3.point.x += Math.random() - 0.5, t3.point.y += Math.random() - 0.5);
              var u2 = e3 * r3[t3.point.index];
              t3.charge += t3.pointCharge = u2, n3 += u2 * t3.point.x, i2 += u2 * t3.point.y;
            }
            t3.cx = n3 / t3.charge, t3.cy = i2 / t3.charge;
          }
          a.interpolateTransform = qr, a.layout = {}, a.layout.bundle = function() {
            return function(t3) {
              for (var e3 = [], r3 = -1, n3 = t3.length; ++r3 < n3; )
                e3.push(Yr(t3[r3]));
              return e3;
            };
          }, a.layout.chord = function() {
            var t3, e3, r3, n3, i2, o2, s2, l2 = {}, u2 = 0;
            function c2() {
              var l3, c3, h2, p3, d3, v2 = {}, g3 = [], y2 = a.range(n3), m3 = [];
              for (t3 = [], e3 = [], l3 = 0, p3 = -1; ++p3 < n3; ) {
                for (c3 = 0, d3 = -1; ++d3 < n3; )
                  c3 += r3[p3][d3];
                g3.push(c3), m3.push(a.range(n3)), l3 += c3;
              }
              for (i2 && y2.sort(function(t4, e4) {
                return i2(g3[t4], g3[e4]);
              }), o2 && m3.forEach(function(t4, e4) {
                t4.sort(function(t5, n4) {
                  return o2(r3[e4][t5], r3[e4][n4]);
                });
              }), l3 = (Ct - u2 * n3) / l3, c3 = 0, p3 = -1; ++p3 < n3; ) {
                for (h2 = c3, d3 = -1; ++d3 < n3; ) {
                  var x2 = y2[p3], b2 = m3[x2][d3], _2 = r3[x2][b2], w3 = c3, T2 = c3 += _2 * l3;
                  v2[x2 + "-" + b2] = { index: x2, subindex: b2, startAngle: w3, endAngle: T2, value: _2 };
                }
                e3[x2] = { index: x2, startAngle: h2, endAngle: c3, value: g3[x2] }, c3 += u2;
              }
              for (p3 = -1; ++p3 < n3; )
                for (d3 = p3 - 1; ++d3 < n3; ) {
                  var k2 = v2[p3 + "-" + d3], A2 = v2[d3 + "-" + p3];
                  (k2.value || A2.value) && t3.push(k2.value < A2.value ? { source: A2, target: k2 } : { source: k2, target: A2 });
                }
              s2 && f3();
            }
            function f3() {
              t3.sort(function(t4, e4) {
                return s2((t4.source.value + t4.target.value) / 2, (e4.source.value + e4.target.value) / 2);
              });
            }
            return l2.matrix = function(i3) {
              return arguments.length ? (n3 = (r3 = i3) && r3.length, t3 = e3 = null, l2) : r3;
            }, l2.padding = function(r4) {
              return arguments.length ? (u2 = r4, t3 = e3 = null, l2) : u2;
            }, l2.sortGroups = function(r4) {
              return arguments.length ? (i2 = r4, t3 = e3 = null, l2) : i2;
            }, l2.sortSubgroups = function(e4) {
              return arguments.length ? (o2 = e4, t3 = null, l2) : o2;
            }, l2.sortChords = function(e4) {
              return arguments.length ? (s2 = e4, t3 && f3(), l2) : s2;
            }, l2.chords = function() {
              return t3 || c2(), t3;
            }, l2.groups = function() {
              return e3 || c2(), e3;
            }, l2;
          }, a.layout.force = function() {
            var t3, e3, r3, n3, i2, o2, s2 = {}, l2 = a.dispatch("start", "tick", "end"), u2 = [1, 1], c2 = 0.9, f3 = tn, h2 = en, p3 = -30, d3 = rn, v2 = 0.1, g3 = 0.64, y2 = [], m3 = [];
            function x2(t4) {
              return function(e4, r4, n4, i3) {
                if (e4.point !== t4) {
                  var a2 = e4.cx - t4.x, o3 = e4.cy - t4.y, s3 = i3 - r4, l3 = a2 * a2 + o3 * o3;
                  if (s3 * s3 / g3 < l3) {
                    if (l3 < d3) {
                      var u3 = e4.charge / l3;
                      t4.px -= a2 * u3, t4.py -= o3 * u3;
                    }
                    return true;
                  }
                  e4.point && l3 && l3 < d3 && (u3 = e4.pointCharge / l3, t4.px -= a2 * u3, t4.py -= o3 * u3);
                }
                return !e4.charge;
              };
            }
            function b2(t4) {
              t4.px = a.event.x, t4.py = a.event.y, s2.resume();
            }
            return s2.tick = function() {
              if ((r3 *= 0.99) < 5e-3)
                return t3 = null, l2.end({ type: "end", alpha: r3 = 0 }), true;
              var e4, s3, f4, h3, d4, g4, b3, _2, w3, T2 = y2.length, k2 = m3.length;
              for (s3 = 0; s3 < k2; ++s3)
                h3 = (f4 = m3[s3]).source, (g4 = (_2 = (d4 = f4.target).x - h3.x) * _2 + (w3 = d4.y - h3.y) * w3) && (_2 *= g4 = r3 * i2[s3] * ((g4 = Math.sqrt(g4)) - n3[s3]) / g4, w3 *= g4, d4.x -= _2 * (b3 = h3.weight + d4.weight ? h3.weight / (h3.weight + d4.weight) : 0.5), d4.y -= w3 * b3, h3.x += _2 * (b3 = 1 - b3), h3.y += w3 * b3);
              if ((b3 = r3 * v2) && (_2 = u2[0] / 2, w3 = u2[1] / 2, s3 = -1, b3))
                for (; ++s3 < T2; )
                  (f4 = y2[s3]).x += (_2 - f4.x) * b3, f4.y += (w3 - f4.y) * b3;
              if (p3)
                for (Qr(e4 = a.geom.quadtree(y2), r3, o2), s3 = -1; ++s3 < T2; )
                  (f4 = y2[s3]).fixed || e4.visit(x2(f4));
              for (s3 = -1; ++s3 < T2; )
                (f4 = y2[s3]).fixed ? (f4.x = f4.px, f4.y = f4.py) : (f4.x -= (f4.px - (f4.px = f4.x)) * c2, f4.y -= (f4.py - (f4.py = f4.y)) * c2);
              l2.tick({ type: "tick", alpha: r3 });
            }, s2.nodes = function(t4) {
              return arguments.length ? (y2 = t4, s2) : y2;
            }, s2.links = function(t4) {
              return arguments.length ? (m3 = t4, s2) : m3;
            }, s2.size = function(t4) {
              return arguments.length ? (u2 = t4, s2) : u2;
            }, s2.linkDistance = function(t4) {
              return arguments.length ? (f3 = "function" == typeof t4 ? t4 : +t4, s2) : f3;
            }, s2.distance = s2.linkDistance, s2.linkStrength = function(t4) {
              return arguments.length ? (h2 = "function" == typeof t4 ? t4 : +t4, s2) : h2;
            }, s2.friction = function(t4) {
              return arguments.length ? (c2 = +t4, s2) : c2;
            }, s2.charge = function(t4) {
              return arguments.length ? (p3 = "function" == typeof t4 ? t4 : +t4, s2) : p3;
            }, s2.chargeDistance = function(t4) {
              return arguments.length ? (d3 = t4 * t4, s2) : Math.sqrt(d3);
            }, s2.gravity = function(t4) {
              return arguments.length ? (v2 = +t4, s2) : v2;
            }, s2.theta = function(t4) {
              return arguments.length ? (g3 = t4 * t4, s2) : Math.sqrt(g3);
            }, s2.alpha = function(e4) {
              return arguments.length ? (e4 = +e4, r3 ? e4 > 0 ? r3 = e4 : (t3.c = null, t3.t = NaN, t3 = null, l2.end({ type: "end", alpha: r3 = 0 })) : e4 > 0 && (l2.start({ type: "start", alpha: r3 = e4 }), t3 = Te(s2.tick)), s2) : r3;
            }, s2.start = function() {
              var t4, e4, r4, a2 = y2.length, l3 = m3.length, c3 = u2[0], d4 = u2[1];
              for (t4 = 0; t4 < a2; ++t4)
                (r4 = y2[t4]).index = t4, r4.weight = 0;
              for (t4 = 0; t4 < l3; ++t4)
                "number" == typeof (r4 = m3[t4]).source && (r4.source = y2[r4.source]), "number" == typeof r4.target && (r4.target = y2[r4.target]), ++r4.source.weight, ++r4.target.weight;
              for (t4 = 0; t4 < a2; ++t4)
                r4 = y2[t4], isNaN(r4.x) && (r4.x = v3("x", c3)), isNaN(r4.y) && (r4.y = v3("y", d4)), isNaN(r4.px) && (r4.px = r4.x), isNaN(r4.py) && (r4.py = r4.y);
              if (n3 = [], "function" == typeof f3)
                for (t4 = 0; t4 < l3; ++t4)
                  n3[t4] = +f3.call(this, m3[t4], t4);
              else
                for (t4 = 0; t4 < l3; ++t4)
                  n3[t4] = f3;
              if (i2 = [], "function" == typeof h2)
                for (t4 = 0; t4 < l3; ++t4)
                  i2[t4] = +h2.call(this, m3[t4], t4);
              else
                for (t4 = 0; t4 < l3; ++t4)
                  i2[t4] = h2;
              if (o2 = [], "function" == typeof p3)
                for (t4 = 0; t4 < a2; ++t4)
                  o2[t4] = +p3.call(this, y2[t4], t4);
              else
                for (t4 = 0; t4 < a2; ++t4)
                  o2[t4] = p3;
              function v3(r5, n4) {
                if (!e4) {
                  for (e4 = new Array(a2), u3 = 0; u3 < a2; ++u3)
                    e4[u3] = [];
                  for (u3 = 0; u3 < l3; ++u3) {
                    var i3 = m3[u3];
                    e4[i3.source.index].push(i3.target), e4[i3.target.index].push(i3.source);
                  }
                }
                for (var o3, s3 = e4[t4], u3 = -1, c4 = s3.length; ++u3 < c4; )
                  if (!isNaN(o3 = s3[u3][r5]))
                    return o3;
                return Math.random() * n4;
              }
              return s2.resume();
            }, s2.resume = function() {
              return s2.alpha(0.1);
            }, s2.stop = function() {
              return s2.alpha(0);
            }, s2.drag = function() {
              if (e3 || (e3 = a.behavior.drag().origin(D).on("dragstart.force", Xr).on("drag.force", b2).on("dragend.force", Jr)), !arguments.length)
                return e3;
              this.on("mouseover.force", Kr).on("mouseout.force", $r).call(e3);
            }, a.rebind(s2, l2, "on");
          };
          var tn = 20, en = 1, rn = 1 / 0;
          function nn(t3, e3) {
            return a.rebind(t3, e3, "sort", "children", "value"), t3.nodes = t3, t3.links = cn, t3;
          }
          function an(t3, e3) {
            for (var r3 = [t3]; null != (t3 = r3.pop()); )
              if (e3(t3), (i2 = t3.children) && (n3 = i2.length))
                for (var n3, i2; --n3 >= 0; )
                  r3.push(i2[n3]);
          }
          function on(t3, e3) {
            for (var r3 = [t3], n3 = []; null != (t3 = r3.pop()); )
              if (n3.push(t3), (a2 = t3.children) && (i2 = a2.length))
                for (var i2, a2, o2 = -1; ++o2 < i2; )
                  r3.push(a2[o2]);
            for (; null != (t3 = n3.pop()); )
              e3(t3);
          }
          function sn(t3) {
            return t3.children;
          }
          function ln(t3) {
            return t3.value;
          }
          function un(t3, e3) {
            return e3.value - t3.value;
          }
          function cn(t3) {
            return a.merge(t3.map(function(t4) {
              return (t4.children || []).map(function(e3) {
                return { source: t4, target: e3 };
              });
            }));
          }
          a.layout.hierarchy = function() {
            var t3 = un, e3 = sn, r3 = ln;
            function n3(i2) {
              var a2, o2 = [i2], s2 = [];
              for (i2.depth = 0; null != (a2 = o2.pop()); )
                if (s2.push(a2), (u2 = e3.call(n3, a2, a2.depth)) && (l2 = u2.length)) {
                  for (var l2, u2, c2; --l2 >= 0; )
                    o2.push(c2 = u2[l2]), c2.parent = a2, c2.depth = a2.depth + 1;
                  r3 && (a2.value = 0), a2.children = u2;
                } else
                  r3 && (a2.value = +r3.call(n3, a2, a2.depth) || 0), delete a2.children;
              return on(i2, function(e4) {
                var n4, i3;
                t3 && (n4 = e4.children) && n4.sort(t3), r3 && (i3 = e4.parent) && (i3.value += e4.value);
              }), s2;
            }
            return n3.sort = function(e4) {
              return arguments.length ? (t3 = e4, n3) : t3;
            }, n3.children = function(t4) {
              return arguments.length ? (e3 = t4, n3) : e3;
            }, n3.value = function(t4) {
              return arguments.length ? (r3 = t4, n3) : r3;
            }, n3.revalue = function(t4) {
              return r3 && (an(t4, function(t5) {
                t5.children && (t5.value = 0);
              }), on(t4, function(t5) {
                var e4;
                t5.children || (t5.value = +r3.call(n3, t5, t5.depth) || 0), (e4 = t5.parent) && (e4.value += t5.value);
              })), t4;
            }, n3;
          }, a.layout.partition = function() {
            var t3 = a.layout.hierarchy(), e3 = [1, 1];
            function r3(t4, e4, n4, i3) {
              var a2 = t4.children;
              if (t4.x = e4, t4.y = t4.depth * i3, t4.dx = n4, t4.dy = i3, a2 && (o2 = a2.length)) {
                var o2, s2, l2, u2 = -1;
                for (n4 = t4.value ? n4 / t4.value : 0; ++u2 < o2; )
                  r3(s2 = a2[u2], e4, l2 = s2.value * n4, i3), e4 += l2;
              }
            }
            function n3(t4) {
              var e4 = t4.children, r4 = 0;
              if (e4 && (i3 = e4.length))
                for (var i3, a2 = -1; ++a2 < i3; )
                  r4 = Math.max(r4, n3(e4[a2]));
              return 1 + r4;
            }
            function i2(i3, a2) {
              var o2 = t3.call(this, i3, a2);
              return r3(o2[0], 0, e3[0], e3[1] / n3(o2[0])), o2;
            }
            return i2.size = function(t4) {
              return arguments.length ? (e3 = t4, i2) : e3;
            }, nn(i2, t3);
          }, a.layout.pie = function() {
            var t3 = Number, e3 = fn, r3 = 0, n3 = Ct, i2 = 0;
            function o2(s2) {
              var l2, u2 = s2.length, c2 = s2.map(function(e4, r4) {
                return +t3.call(o2, e4, r4);
              }), f3 = +("function" == typeof r3 ? r3.apply(this, arguments) : r3), h2 = ("function" == typeof n3 ? n3.apply(this, arguments) : n3) - f3, p3 = Math.min(Math.abs(h2) / u2, +("function" == typeof i2 ? i2.apply(this, arguments) : i2)), d3 = p3 * (h2 < 0 ? -1 : 1), v2 = a.sum(c2), g3 = v2 ? (h2 - u2 * d3) / v2 : 0, y2 = a.range(u2), m3 = [];
              return null != e3 && y2.sort(e3 === fn ? function(t4, e4) {
                return c2[e4] - c2[t4];
              } : function(t4, r4) {
                return e3(s2[t4], s2[r4]);
              }), y2.forEach(function(t4) {
                m3[t4] = { data: s2[t4], value: l2 = c2[t4], startAngle: f3, endAngle: f3 += l2 * g3 + d3, padAngle: p3 };
              }), m3;
            }
            return o2.value = function(e4) {
              return arguments.length ? (t3 = e4, o2) : t3;
            }, o2.sort = function(t4) {
              return arguments.length ? (e3 = t4, o2) : e3;
            }, o2.startAngle = function(t4) {
              return arguments.length ? (r3 = t4, o2) : r3;
            }, o2.endAngle = function(t4) {
              return arguments.length ? (n3 = t4, o2) : n3;
            }, o2.padAngle = function(t4) {
              return arguments.length ? (i2 = t4, o2) : i2;
            }, o2;
          };
          var fn = {};
          function hn(t3) {
            return t3.x;
          }
          function pn(t3) {
            return t3.y;
          }
          function dn(t3, e3, r3) {
            t3.y0 = e3, t3.y = r3;
          }
          a.layout.stack = function() {
            var t3 = D, e3 = yn, r3 = mn, n3 = dn, i2 = hn, o2 = pn;
            function s2(l2, u2) {
              if (!(p3 = l2.length))
                return l2;
              var c2 = l2.map(function(e4, r4) {
                return t3.call(s2, e4, r4);
              }), f3 = c2.map(function(t4) {
                return t4.map(function(t5, e4) {
                  return [i2.call(s2, t5, e4), o2.call(s2, t5, e4)];
                });
              }), h2 = e3.call(s2, f3, u2);
              c2 = a.permute(c2, h2), f3 = a.permute(f3, h2);
              var p3, d3, v2, g3, y2 = r3.call(s2, f3, u2), m3 = c2[0].length;
              for (v2 = 0; v2 < m3; ++v2)
                for (n3.call(s2, c2[0][v2], g3 = y2[v2], f3[0][v2][1]), d3 = 1; d3 < p3; ++d3)
                  n3.call(s2, c2[d3][v2], g3 += f3[d3 - 1][v2][1], f3[d3][v2][1]);
              return l2;
            }
            return s2.values = function(e4) {
              return arguments.length ? (t3 = e4, s2) : t3;
            }, s2.order = function(t4) {
              return arguments.length ? (e3 = "function" == typeof t4 ? t4 : vn.get(t4) || yn, s2) : e3;
            }, s2.offset = function(t4) {
              return arguments.length ? (r3 = "function" == typeof t4 ? t4 : gn.get(t4) || mn, s2) : r3;
            }, s2.x = function(t4) {
              return arguments.length ? (i2 = t4, s2) : i2;
            }, s2.y = function(t4) {
              return arguments.length ? (o2 = t4, s2) : o2;
            }, s2.out = function(t4) {
              return arguments.length ? (n3 = t4, s2) : n3;
            }, s2;
          };
          var vn = a.map({ "inside-out": function(t3) {
            var e3, r3, n3 = t3.length, i2 = t3.map(xn), o2 = t3.map(bn), s2 = a.range(n3).sort(function(t4, e4) {
              return i2[t4] - i2[e4];
            }), l2 = 0, u2 = 0, c2 = [], f3 = [];
            for (e3 = 0; e3 < n3; ++e3)
              r3 = s2[e3], l2 < u2 ? (l2 += o2[r3], c2.push(r3)) : (u2 += o2[r3], f3.push(r3));
            return f3.reverse().concat(c2);
          }, reverse: function(t3) {
            return a.range(t3.length).reverse();
          }, default: yn }), gn = a.map({ silhouette: function(t3) {
            var e3, r3, n3, i2 = t3.length, a2 = t3[0].length, o2 = [], s2 = 0, l2 = [];
            for (r3 = 0; r3 < a2; ++r3) {
              for (e3 = 0, n3 = 0; e3 < i2; e3++)
                n3 += t3[e3][r3][1];
              n3 > s2 && (s2 = n3), o2.push(n3);
            }
            for (r3 = 0; r3 < a2; ++r3)
              l2[r3] = (s2 - o2[r3]) / 2;
            return l2;
          }, wiggle: function(t3) {
            var e3, r3, n3, i2, a2, o2, s2, l2, u2, c2 = t3.length, f3 = t3[0], h2 = f3.length, p3 = [];
            for (p3[0] = l2 = u2 = 0, r3 = 1; r3 < h2; ++r3) {
              for (e3 = 0, i2 = 0; e3 < c2; ++e3)
                i2 += t3[e3][r3][1];
              for (e3 = 0, a2 = 0, s2 = f3[r3][0] - f3[r3 - 1][0]; e3 < c2; ++e3) {
                for (n3 = 0, o2 = (t3[e3][r3][1] - t3[e3][r3 - 1][1]) / (2 * s2); n3 < e3; ++n3)
                  o2 += (t3[n3][r3][1] - t3[n3][r3 - 1][1]) / s2;
                a2 += o2 * t3[e3][r3][1];
              }
              p3[r3] = l2 -= i2 ? a2 / i2 * s2 : 0, l2 < u2 && (u2 = l2);
            }
            for (r3 = 0; r3 < h2; ++r3)
              p3[r3] -= u2;
            return p3;
          }, expand: function(t3) {
            var e3, r3, n3, i2 = t3.length, a2 = t3[0].length, o2 = 1 / i2, s2 = [];
            for (r3 = 0; r3 < a2; ++r3) {
              for (e3 = 0, n3 = 0; e3 < i2; e3++)
                n3 += t3[e3][r3][1];
              if (n3)
                for (e3 = 0; e3 < i2; e3++)
                  t3[e3][r3][1] /= n3;
              else
                for (e3 = 0; e3 < i2; e3++)
                  t3[e3][r3][1] = o2;
            }
            for (r3 = 0; r3 < a2; ++r3)
              s2[r3] = 0;
            return s2;
          }, zero: mn });
          function yn(t3) {
            return a.range(t3.length);
          }
          function mn(t3) {
            for (var e3 = -1, r3 = t3[0].length, n3 = []; ++e3 < r3; )
              n3[e3] = 0;
            return n3;
          }
          function xn(t3) {
            for (var e3, r3 = 1, n3 = 0, i2 = t3[0][1], a2 = t3.length; r3 < a2; ++r3)
              (e3 = t3[r3][1]) > i2 && (n3 = r3, i2 = e3);
            return n3;
          }
          function bn(t3) {
            return t3.reduce(_n, 0);
          }
          function _n(t3, e3) {
            return t3 + e3[1];
          }
          function wn(t3, e3) {
            return Tn(t3, Math.ceil(Math.log(e3.length) / Math.LN2 + 1));
          }
          function Tn(t3, e3) {
            for (var r3 = -1, n3 = +t3[0], i2 = (t3[1] - n3) / e3, a2 = []; ++r3 <= e3; )
              a2[r3] = i2 * r3 + n3;
            return a2;
          }
          function kn(t3) {
            return [a.min(t3), a.max(t3)];
          }
          function An(t3, e3) {
            return t3.value - e3.value;
          }
          function Mn(t3, e3) {
            var r3 = t3._pack_next;
            t3._pack_next = e3, e3._pack_prev = t3, e3._pack_next = r3, r3._pack_prev = e3;
          }
          function Sn(t3, e3) {
            t3._pack_next = e3, e3._pack_prev = t3;
          }
          function En(t3, e3) {
            var r3 = e3.x - t3.x, n3 = e3.y - t3.y, i2 = t3.r + e3.r;
            return 0.999 * i2 * i2 > r3 * r3 + n3 * n3;
          }
          function Ln(t3) {
            if ((e3 = t3.children) && (l2 = e3.length)) {
              var e3, r3, n3, i2, a2, o2, s2, l2, u2 = 1 / 0, c2 = -1 / 0, f3 = 1 / 0, h2 = -1 / 0;
              if (e3.forEach(Cn), (r3 = e3[0]).x = -r3.r, r3.y = 0, x2(r3), l2 > 1 && ((n3 = e3[1]).x = n3.r, n3.y = 0, x2(n3), l2 > 2))
                for (In(r3, n3, i2 = e3[2]), x2(i2), Mn(r3, i2), r3._pack_prev = i2, Mn(i2, n3), n3 = r3._pack_next, a2 = 3; a2 < l2; a2++) {
                  In(r3, n3, i2 = e3[a2]);
                  var p3 = 0, d3 = 1, v2 = 1;
                  for (o2 = n3._pack_next; o2 !== n3; o2 = o2._pack_next, d3++)
                    if (En(o2, i2)) {
                      p3 = 1;
                      break;
                    }
                  if (1 == p3)
                    for (s2 = r3._pack_prev; s2 !== o2._pack_prev && !En(s2, i2); s2 = s2._pack_prev, v2++)
                      ;
                  p3 ? (d3 < v2 || d3 == v2 && n3.r < r3.r ? Sn(r3, n3 = o2) : Sn(r3 = s2, n3), a2--) : (Mn(r3, i2), n3 = i2, x2(i2));
                }
              var g3 = (u2 + c2) / 2, y2 = (f3 + h2) / 2, m3 = 0;
              for (a2 = 0; a2 < l2; a2++)
                (i2 = e3[a2]).x -= g3, i2.y -= y2, m3 = Math.max(m3, i2.r + Math.sqrt(i2.x * i2.x + i2.y * i2.y));
              t3.r = m3, e3.forEach(Pn);
            }
            function x2(t4) {
              u2 = Math.min(t4.x - t4.r, u2), c2 = Math.max(t4.x + t4.r, c2), f3 = Math.min(t4.y - t4.r, f3), h2 = Math.max(t4.y + t4.r, h2);
            }
          }
          function Cn(t3) {
            t3._pack_next = t3._pack_prev = t3;
          }
          function Pn(t3) {
            delete t3._pack_next, delete t3._pack_prev;
          }
          function On(t3, e3, r3, n3) {
            var i2 = t3.children;
            if (t3.x = e3 += n3 * t3.x, t3.y = r3 += n3 * t3.y, t3.r *= n3, i2)
              for (var a2 = -1, o2 = i2.length; ++a2 < o2; )
                On(i2[a2], e3, r3, n3);
          }
          function In(t3, e3, r3) {
            var n3 = t3.r + r3.r, i2 = e3.x - t3.x, a2 = e3.y - t3.y;
            if (n3 && (i2 || a2)) {
              var o2 = e3.r + r3.r, s2 = i2 * i2 + a2 * a2, l2 = 0.5 + ((n3 *= n3) - (o2 *= o2)) / (2 * s2), u2 = Math.sqrt(Math.max(0, 2 * o2 * (n3 + s2) - (n3 -= s2) * n3 - o2 * o2)) / (2 * s2);
              r3.x = t3.x + l2 * i2 + u2 * a2, r3.y = t3.y + l2 * a2 - u2 * i2;
            } else
              r3.x = t3.x + n3, r3.y = t3.y;
          }
          function Dn(t3, e3) {
            return t3.parent == e3.parent ? 1 : 2;
          }
          function zn(t3) {
            var e3 = t3.children;
            return e3.length ? e3[0] : t3.t;
          }
          function Rn(t3) {
            var e3, r3 = t3.children;
            return (e3 = r3.length) ? r3[e3 - 1] : t3.t;
          }
          function Fn(t3, e3, r3) {
            var n3 = r3 / (e3.i - t3.i);
            e3.c -= n3, e3.s += r3, t3.c += n3, e3.z += r3, e3.m += r3;
          }
          function Bn(t3, e3, r3) {
            return t3.a.parent === e3.parent ? t3.a : r3;
          }
          function Nn(t3) {
            var e3 = t3.children;
            return e3 && e3.length ? Nn(e3[0]) : t3;
          }
          function jn(t3) {
            var e3, r3 = t3.children;
            return r3 && (e3 = r3.length) ? jn(r3[e3 - 1]) : t3;
          }
          function Un(t3) {
            return { x: t3.x, y: t3.y, dx: t3.dx, dy: t3.dy };
          }
          function Vn(t3, e3) {
            var r3 = t3.x + e3[3], n3 = t3.y + e3[0], i2 = t3.dx - e3[1] - e3[3], a2 = t3.dy - e3[0] - e3[2];
            return i2 < 0 && (r3 += i2 / 2, i2 = 0), a2 < 0 && (n3 += a2 / 2, a2 = 0), { x: r3, y: n3, dx: i2, dy: a2 };
          }
          function Hn(t3) {
            var e3 = t3[0], r3 = t3[t3.length - 1];
            return e3 < r3 ? [e3, r3] : [r3, e3];
          }
          function qn(t3) {
            return t3.rangeExtent ? t3.rangeExtent() : Hn(t3.range());
          }
          function Gn(t3, e3, r3, n3) {
            var i2 = r3(t3[0], t3[1]), a2 = n3(e3[0], e3[1]);
            return function(t4) {
              return a2(i2(t4));
            };
          }
          function Zn(t3, e3) {
            var r3, n3 = 0, i2 = t3.length - 1, a2 = t3[n3], o2 = t3[i2];
            return o2 < a2 && (r3 = n3, n3 = i2, i2 = r3, r3 = a2, a2 = o2, o2 = r3), t3[n3] = e3.floor(a2), t3[i2] = e3.ceil(o2), t3;
          }
          function Yn(t3) {
            return t3 ? { floor: function(e3) {
              return Math.floor(e3 / t3) * t3;
            }, ceil: function(e3) {
              return Math.ceil(e3 / t3) * t3;
            } } : Wn;
          }
          a.layout.histogram = function() {
            var t3 = true, e3 = Number, r3 = kn, n3 = wn;
            function i2(i3, o2) {
              for (var s2, l2, u2 = [], c2 = i3.map(e3, this), f3 = r3.call(this, c2, o2), h2 = n3.call(this, f3, c2, o2), p3 = (o2 = -1, c2.length), d3 = h2.length - 1, v2 = t3 ? 1 : 1 / p3; ++o2 < d3; )
                (s2 = u2[o2] = []).dx = h2[o2 + 1] - (s2.x = h2[o2]), s2.y = 0;
              if (d3 > 0)
                for (o2 = -1; ++o2 < p3; )
                  (l2 = c2[o2]) >= f3[0] && l2 <= f3[1] && ((s2 = u2[a.bisect(h2, l2, 1, d3) - 1]).y += v2, s2.push(i3[o2]));
              return u2;
            }
            return i2.value = function(t4) {
              return arguments.length ? (e3 = t4, i2) : e3;
            }, i2.range = function(t4) {
              return arguments.length ? (r3 = ve(t4), i2) : r3;
            }, i2.bins = function(t4) {
              return arguments.length ? (n3 = "number" == typeof t4 ? function(e4) {
                return Tn(e4, t4);
              } : ve(t4), i2) : n3;
            }, i2.frequency = function(e4) {
              return arguments.length ? (t3 = !!e4, i2) : t3;
            }, i2;
          }, a.layout.pack = function() {
            var t3, e3 = a.layout.hierarchy().sort(An), r3 = 0, n3 = [1, 1];
            function i2(i3, a2) {
              var o2 = e3.call(this, i3, a2), s2 = o2[0], l2 = n3[0], u2 = n3[1], c2 = null == t3 ? Math.sqrt : "function" == typeof t3 ? t3 : function() {
                return t3;
              };
              if (s2.x = s2.y = 0, on(s2, function(t4) {
                t4.r = +c2(t4.value);
              }), on(s2, Ln), r3) {
                var f3 = r3 * (t3 ? 1 : Math.max(2 * s2.r / l2, 2 * s2.r / u2)) / 2;
                on(s2, function(t4) {
                  t4.r += f3;
                }), on(s2, Ln), on(s2, function(t4) {
                  t4.r -= f3;
                });
              }
              return On(s2, l2 / 2, u2 / 2, t3 ? 1 : 1 / Math.max(2 * s2.r / l2, 2 * s2.r / u2)), o2;
            }
            return i2.size = function(t4) {
              return arguments.length ? (n3 = t4, i2) : n3;
            }, i2.radius = function(e4) {
              return arguments.length ? (t3 = null == e4 || "function" == typeof e4 ? e4 : +e4, i2) : t3;
            }, i2.padding = function(t4) {
              return arguments.length ? (r3 = +t4, i2) : r3;
            }, nn(i2, e3);
          }, a.layout.tree = function() {
            var t3 = a.layout.hierarchy().sort(null).value(null), e3 = Dn, r3 = [1, 1], n3 = null;
            function i2(i3, a2) {
              var u2 = t3.call(this, i3, a2), c2 = u2[0], f3 = function(t4) {
                for (var e4, r4 = { A: null, children: [t4] }, n4 = [r4]; null != (e4 = n4.pop()); )
                  for (var i4, a3 = e4.children, o3 = 0, s3 = a3.length; o3 < s3; ++o3)
                    n4.push((a3[o3] = i4 = { _: a3[o3], parent: e4, children: (i4 = a3[o3].children) && i4.slice() || [], A: null, a: null, z: 0, m: 0, c: 0, s: 0, t: null, i: o3 }).a = i4);
                return r4.children[0];
              }(c2);
              if (on(f3, o2), f3.parent.m = -f3.z, an(f3, s2), n3)
                an(c2, l2);
              else {
                var h2 = c2, p3 = c2, d3 = c2;
                an(c2, function(t4) {
                  t4.x < h2.x && (h2 = t4), t4.x > p3.x && (p3 = t4), t4.depth > d3.depth && (d3 = t4);
                });
                var v2 = e3(h2, p3) / 2 - h2.x, g3 = r3[0] / (p3.x + e3(p3, h2) / 2 + v2), y2 = r3[1] / (d3.depth || 1);
                an(c2, function(t4) {
                  t4.x = (t4.x + v2) * g3, t4.y = t4.depth * y2;
                });
              }
              return u2;
            }
            function o2(t4) {
              var r4 = t4.children, n4 = t4.parent.children, i3 = t4.i ? n4[t4.i - 1] : null;
              if (r4.length) {
                !function(t5) {
                  for (var e4, r5 = 0, n5 = 0, i4 = t5.children, a3 = i4.length; --a3 >= 0; )
                    (e4 = i4[a3]).z += r5, e4.m += r5, r5 += e4.s + (n5 += e4.c);
                }(t4);
                var a2 = (r4[0].z + r4[r4.length - 1].z) / 2;
                i3 ? (t4.z = i3.z + e3(t4._, i3._), t4.m = t4.z - a2) : t4.z = a2;
              } else
                i3 && (t4.z = i3.z + e3(t4._, i3._));
              t4.parent.A = function(t5, r5, n5) {
                if (r5) {
                  for (var i4, a3 = t5, o3 = t5, s3 = r5, l3 = a3.parent.children[0], u2 = a3.m, c2 = o3.m, f3 = s3.m, h2 = l3.m; s3 = Rn(s3), a3 = zn(a3), s3 && a3; )
                    l3 = zn(l3), (o3 = Rn(o3)).a = t5, (i4 = s3.z + f3 - a3.z - u2 + e3(s3._, a3._)) > 0 && (Fn(Bn(s3, t5, n5), t5, i4), u2 += i4, c2 += i4), f3 += s3.m, u2 += a3.m, h2 += l3.m, c2 += o3.m;
                  s3 && !Rn(o3) && (o3.t = s3, o3.m += f3 - c2), a3 && !zn(l3) && (l3.t = a3, l3.m += u2 - h2, n5 = t5);
                }
                return n5;
              }(t4, i3, t4.parent.A || n4[0]);
            }
            function s2(t4) {
              t4._.x = t4.z + t4.parent.m, t4.m += t4.parent.m;
            }
            function l2(t4) {
              t4.x *= r3[0], t4.y = t4.depth * r3[1];
            }
            return i2.separation = function(t4) {
              return arguments.length ? (e3 = t4, i2) : e3;
            }, i2.size = function(t4) {
              return arguments.length ? (n3 = null == (r3 = t4) ? l2 : null, i2) : n3 ? null : r3;
            }, i2.nodeSize = function(t4) {
              return arguments.length ? (n3 = null == (r3 = t4) ? null : l2, i2) : n3 ? r3 : null;
            }, nn(i2, t3);
          }, a.layout.cluster = function() {
            var t3 = a.layout.hierarchy().sort(null).value(null), e3 = Dn, r3 = [1, 1], n3 = false;
            function i2(i3, o2) {
              var s2, l2 = t3.call(this, i3, o2), u2 = l2[0], c2 = 0;
              on(u2, function(t4) {
                var r4 = t4.children;
                r4 && r4.length ? (t4.x = function(t5) {
                  return t5.reduce(function(t6, e4) {
                    return t6 + e4.x;
                  }, 0) / t5.length;
                }(r4), t4.y = function(t5) {
                  return 1 + a.max(t5, function(t6) {
                    return t6.y;
                  });
                }(r4)) : (t4.x = s2 ? c2 += e3(t4, s2) : 0, t4.y = 0, s2 = t4);
              });
              var f3 = Nn(u2), h2 = jn(u2), p3 = f3.x - e3(f3, h2) / 2, d3 = h2.x + e3(h2, f3) / 2;
              return on(u2, n3 ? function(t4) {
                t4.x = (t4.x - u2.x) * r3[0], t4.y = (u2.y - t4.y) * r3[1];
              } : function(t4) {
                t4.x = (t4.x - p3) / (d3 - p3) * r3[0], t4.y = (1 - (u2.y ? t4.y / u2.y : 1)) * r3[1];
              }), l2;
            }
            return i2.separation = function(t4) {
              return arguments.length ? (e3 = t4, i2) : e3;
            }, i2.size = function(t4) {
              return arguments.length ? (n3 = null == (r3 = t4), i2) : n3 ? null : r3;
            }, i2.nodeSize = function(t4) {
              return arguments.length ? (n3 = null != (r3 = t4), i2) : n3 ? r3 : null;
            }, nn(i2, t3);
          }, a.layout.treemap = function() {
            var t3, e3 = a.layout.hierarchy(), r3 = Math.round, n3 = [1, 1], i2 = null, o2 = Un, s2 = false, l2 = "squarify", u2 = 0.5 * (1 + Math.sqrt(5));
            function c2(t4, e4) {
              for (var r4, n4, i3 = -1, a2 = t4.length; ++i3 < a2; )
                n4 = (r4 = t4[i3]).value * (e4 < 0 ? 0 : e4), r4.area = isNaN(n4) || n4 <= 0 ? 0 : n4;
            }
            function f3(t4) {
              var e4 = t4.children;
              if (e4 && e4.length) {
                var r4, n4, i3, a2 = o2(t4), s3 = [], u3 = e4.slice(), h3 = 1 / 0, v3 = "slice" === l2 ? a2.dx : "dice" === l2 ? a2.dy : "slice-dice" === l2 ? 1 & t4.depth ? a2.dy : a2.dx : Math.min(a2.dx, a2.dy);
                for (c2(u3, a2.dx * a2.dy / t4.value), s3.area = 0; (i3 = u3.length) > 0; )
                  s3.push(r4 = u3[i3 - 1]), s3.area += r4.area, "squarify" !== l2 || (n4 = p3(s3, v3)) <= h3 ? (u3.pop(), h3 = n4) : (s3.area -= s3.pop().area, d3(s3, v3, a2, false), v3 = Math.min(a2.dx, a2.dy), s3.length = s3.area = 0, h3 = 1 / 0);
                s3.length && (d3(s3, v3, a2, true), s3.length = s3.area = 0), e4.forEach(f3);
              }
            }
            function h2(t4) {
              var e4 = t4.children;
              if (e4 && e4.length) {
                var r4, n4 = o2(t4), i3 = e4.slice(), a2 = [];
                for (c2(i3, n4.dx * n4.dy / t4.value), a2.area = 0; r4 = i3.pop(); )
                  a2.push(r4), a2.area += r4.area, null != r4.z && (d3(a2, r4.z ? n4.dx : n4.dy, n4, !i3.length), a2.length = a2.area = 0);
                e4.forEach(h2);
              }
            }
            function p3(t4, e4) {
              for (var r4, n4 = t4.area, i3 = 0, a2 = 1 / 0, o3 = -1, s3 = t4.length; ++o3 < s3; )
                (r4 = t4[o3].area) && (r4 < a2 && (a2 = r4), r4 > i3 && (i3 = r4));
              return e4 *= e4, (n4 *= n4) ? Math.max(e4 * i3 * u2 / n4, n4 / (e4 * a2 * u2)) : 1 / 0;
            }
            function d3(t4, e4, n4, i3) {
              var a2, o3 = -1, s3 = t4.length, l3 = n4.x, u3 = n4.y, c3 = e4 ? r3(t4.area / e4) : 0;
              if (e4 == n4.dx) {
                for ((i3 || c3 > n4.dy) && (c3 = n4.dy); ++o3 < s3; )
                  (a2 = t4[o3]).x = l3, a2.y = u3, a2.dy = c3, l3 += a2.dx = Math.min(n4.x + n4.dx - l3, c3 ? r3(a2.area / c3) : 0);
                a2.z = true, a2.dx += n4.x + n4.dx - l3, n4.y += c3, n4.dy -= c3;
              } else {
                for ((i3 || c3 > n4.dx) && (c3 = n4.dx); ++o3 < s3; )
                  (a2 = t4[o3]).x = l3, a2.y = u3, a2.dx = c3, u3 += a2.dy = Math.min(n4.y + n4.dy - u3, c3 ? r3(a2.area / c3) : 0);
                a2.z = false, a2.dy += n4.y + n4.dy - u3, n4.x += c3, n4.dx -= c3;
              }
            }
            function v2(r4) {
              var i3 = t3 || e3(r4), a2 = i3[0];
              return a2.x = a2.y = 0, a2.value ? (a2.dx = n3[0], a2.dy = n3[1]) : a2.dx = a2.dy = 0, t3 && e3.revalue(a2), c2([a2], a2.dx * a2.dy / a2.value), (t3 ? h2 : f3)(a2), s2 && (t3 = i3), i3;
            }
            return v2.size = function(t4) {
              return arguments.length ? (n3 = t4, v2) : n3;
            }, v2.padding = function(t4) {
              if (!arguments.length)
                return i2;
              function e4(e5) {
                var r5 = t4.call(v2, e5, e5.depth);
                return null == r5 ? Un(e5) : Vn(e5, "number" == typeof r5 ? [r5, r5, r5, r5] : r5);
              }
              function r4(e5) {
                return Vn(e5, t4);
              }
              var n4;
              return o2 = null == (i2 = t4) ? Un : "function" == (n4 = typeof t4) ? e4 : "number" === n4 ? (t4 = [t4, t4, t4, t4], r4) : r4, v2;
            }, v2.round = function(t4) {
              return arguments.length ? (r3 = t4 ? Math.round : Number, v2) : r3 != Number;
            }, v2.sticky = function(e4) {
              return arguments.length ? (s2 = e4, t3 = null, v2) : s2;
            }, v2.ratio = function(t4) {
              return arguments.length ? (u2 = t4, v2) : u2;
            }, v2.mode = function(t4) {
              return arguments.length ? (l2 = t4 + "", v2) : l2;
            }, nn(v2, e3);
          }, a.random = { normal: function(t3, e3) {
            var r3 = arguments.length;
            return r3 < 2 && (e3 = 1), r3 < 1 && (t3 = 0), function() {
              var r4, n3, i2;
              do {
                i2 = (r4 = 2 * Math.random() - 1) * r4 + (n3 = 2 * Math.random() - 1) * n3;
              } while (!i2 || i2 > 1);
              return t3 + e3 * r4 * Math.sqrt(-2 * Math.log(i2) / i2);
            };
          }, logNormal: function() {
            var t3 = a.random.normal.apply(a, arguments);
            return function() {
              return Math.exp(t3());
            };
          }, bates: function(t3) {
            var e3 = a.random.irwinHall(t3);
            return function() {
              return e3() / t3;
            };
          }, irwinHall: function(t3) {
            return function() {
              for (var e3 = 0, r3 = 0; r3 < t3; r3++)
                e3 += Math.random();
              return e3;
            };
          } }, a.scale = {};
          var Wn = { floor: D, ceil: D };
          function Xn(t3, e3, r3, n3) {
            var i2 = [], o2 = [], s2 = 0, l2 = Math.min(t3.length, e3.length) - 1;
            for (t3[l2] < t3[0] && (t3 = t3.slice().reverse(), e3 = e3.slice().reverse()); ++s2 <= l2; )
              i2.push(r3(t3[s2 - 1], t3[s2])), o2.push(n3(e3[s2 - 1], e3[s2]));
            return function(e4) {
              var r4 = a.bisect(t3, e4, 1, l2) - 1;
              return o2[r4](i2[r4](e4));
            };
          }
          function Jn(t3, e3, r3, n3) {
            var i2, a2;
            function o2() {
              var o3 = Math.min(t3.length, e3.length) > 2 ? Xn : Gn, l2 = n3 ? Zr : Gr;
              return i2 = o3(t3, e3, l2, r3), a2 = o3(e3, t3, l2, Tr), s2;
            }
            function s2(t4) {
              return i2(t4);
            }
            return s2.invert = function(t4) {
              return a2(t4);
            }, s2.domain = function(e4) {
              return arguments.length ? (t3 = e4.map(Number), o2()) : t3;
            }, s2.range = function(t4) {
              return arguments.length ? (e3 = t4, o2()) : e3;
            }, s2.rangeRound = function(t4) {
              return s2.range(t4).interpolate(Br);
            }, s2.clamp = function(t4) {
              return arguments.length ? (n3 = t4, o2()) : n3;
            }, s2.interpolate = function(t4) {
              return arguments.length ? (r3 = t4, o2()) : r3;
            }, s2.ticks = function(e4) {
              return ti(t3, e4);
            }, s2.tickFormat = function(e4, r4) {
              return d3_scale_linearTickFormat(t3, e4, r4);
            }, s2.nice = function(e4) {
              return $n(t3, e4), o2();
            }, s2.copy = function() {
              return Jn(t3, e3, r3, n3);
            }, o2();
          }
          function Kn(t3, e3) {
            return a.rebind(t3, e3, "range", "rangeRound", "interpolate", "clamp");
          }
          function $n(t3, e3) {
            return Zn(t3, Yn(Qn(t3, e3)[2])), Zn(t3, Yn(Qn(t3, e3)[2])), t3;
          }
          function Qn(t3, e3) {
            null == e3 && (e3 = 10);
            var r3 = Hn(t3), n3 = r3[1] - r3[0], i2 = Math.pow(10, Math.floor(Math.log(n3 / e3) / Math.LN10)), a2 = e3 / n3 * i2;
            return a2 <= 0.15 ? i2 *= 10 : a2 <= 0.35 ? i2 *= 5 : a2 <= 0.75 && (i2 *= 2), r3[0] = Math.ceil(r3[0] / i2) * i2, r3[1] = Math.floor(r3[1] / i2) * i2 + 0.5 * i2, r3[2] = i2, r3;
          }
          function ti(t3, e3) {
            return a.range.apply(a, Qn(t3, e3));
          }
          function ei(t3, e3, r3, n3) {
            function i2(t4) {
              return (r3 ? Math.log(t4 < 0 ? 0 : t4) : -Math.log(t4 > 0 ? 0 : -t4)) / Math.log(e3);
            }
            function a2(t4) {
              return r3 ? Math.pow(e3, t4) : -Math.pow(e3, -t4);
            }
            function o2(e4) {
              return t3(i2(e4));
            }
            return o2.invert = function(e4) {
              return a2(t3.invert(e4));
            }, o2.domain = function(e4) {
              return arguments.length ? (r3 = e4[0] >= 0, t3.domain((n3 = e4.map(Number)).map(i2)), o2) : n3;
            }, o2.base = function(r4) {
              return arguments.length ? (e3 = +r4, t3.domain(n3.map(i2)), o2) : e3;
            }, o2.nice = function() {
              var e4 = Zn(n3.map(i2), r3 ? Math : ri);
              return t3.domain(e4), n3 = e4.map(a2), o2;
            }, o2.ticks = function() {
              var t4 = Hn(n3), o3 = [], s2 = t4[0], l2 = t4[1], u2 = Math.floor(i2(s2)), c2 = Math.ceil(i2(l2)), f3 = e3 % 1 ? 2 : e3;
              if (isFinite(c2 - u2)) {
                if (r3) {
                  for (; u2 < c2; u2++)
                    for (var h2 = 1; h2 < f3; h2++)
                      o3.push(a2(u2) * h2);
                  o3.push(a2(u2));
                } else
                  for (o3.push(a2(u2)); u2++ < c2; )
                    for (h2 = f3 - 1; h2 > 0; h2--)
                      o3.push(a2(u2) * h2);
                for (u2 = 0; o3[u2] < s2; u2++)
                  ;
                for (c2 = o3.length; o3[c2 - 1] > l2; c2--)
                  ;
                o3 = o3.slice(u2, c2);
              }
              return o3;
            }, o2.copy = function() {
              return ei(t3.copy(), e3, r3, n3);
            }, Kn(o2, t3);
          }
          a.scale.linear = function() {
            return Jn([0, 1], [0, 1], Tr, false);
          }, a.scale.log = function() {
            return ei(a.scale.linear().domain([0, 1]), 10, true, [1, 10]);
          };
          var ri = { floor: function(t3) {
            return -Math.ceil(-t3);
          }, ceil: function(t3) {
            return -Math.floor(-t3);
          } };
          function ni(t3, e3, r3) {
            var n3 = ii(e3), i2 = ii(1 / e3);
            function a2(e4) {
              return t3(n3(e4));
            }
            return a2.invert = function(e4) {
              return i2(t3.invert(e4));
            }, a2.domain = function(e4) {
              return arguments.length ? (t3.domain((r3 = e4.map(Number)).map(n3)), a2) : r3;
            }, a2.ticks = function(t4) {
              return ti(r3, t4);
            }, a2.tickFormat = function(t4, e4) {
              return d3_scale_linearTickFormat(r3, t4, e4);
            }, a2.nice = function(t4) {
              return a2.domain($n(r3, t4));
            }, a2.exponent = function(o2) {
              return arguments.length ? (n3 = ii(e3 = o2), i2 = ii(1 / e3), t3.domain(r3.map(n3)), a2) : e3;
            }, a2.copy = function() {
              return ni(t3.copy(), e3, r3);
            }, Kn(a2, t3);
          }
          function ii(t3) {
            return function(e3) {
              return e3 < 0 ? -Math.pow(-e3, t3) : Math.pow(e3, t3);
            };
          }
          function ai(t3, e3) {
            var r3, n3, i2;
            function o2(i3) {
              return n3[((r3.get(i3) || ("range" === e3.t ? r3.set(i3, t3.push(i3)) : NaN)) - 1) % n3.length];
            }
            function s2(e4, r4) {
              return a.range(t3.length).map(function(t4) {
                return e4 + r4 * t4;
              });
            }
            return o2.domain = function(n4) {
              if (!arguments.length)
                return t3;
              t3 = [], r3 = new A();
              for (var i3, a2 = -1, s3 = n4.length; ++a2 < s3; )
                r3.has(i3 = n4[a2]) || r3.set(i3, t3.push(i3));
              return o2[e3.t].apply(o2, e3.a);
            }, o2.range = function(t4) {
              return arguments.length ? (n3 = t4, i2 = 0, e3 = { t: "range", a: arguments }, o2) : n3;
            }, o2.rangePoints = function(r4, a2) {
              arguments.length < 2 && (a2 = 0);
              var l2 = r4[0], u2 = r4[1], c2 = t3.length < 2 ? (l2 = (l2 + u2) / 2, 0) : (u2 - l2) / (t3.length - 1 + a2);
              return n3 = s2(l2 + c2 * a2 / 2, c2), i2 = 0, e3 = { t: "rangePoints", a: arguments }, o2;
            }, o2.rangeRoundPoints = function(r4, a2) {
              arguments.length < 2 && (a2 = 0);
              var l2 = r4[0], u2 = r4[1], c2 = t3.length < 2 ? (l2 = u2 = Math.round((l2 + u2) / 2), 0) : (u2 - l2) / (t3.length - 1 + a2) | 0;
              return n3 = s2(l2 + Math.round(c2 * a2 / 2 + (u2 - l2 - (t3.length - 1 + a2) * c2) / 2), c2), i2 = 0, e3 = { t: "rangeRoundPoints", a: arguments }, o2;
            }, o2.rangeBands = function(r4, a2, l2) {
              arguments.length < 2 && (a2 = 0), arguments.length < 3 && (l2 = a2);
              var u2 = r4[1] < r4[0], c2 = r4[u2 - 0], f3 = r4[1 - u2], h2 = (f3 - c2) / (t3.length - a2 + 2 * l2);
              return n3 = s2(c2 + h2 * l2, h2), u2 && n3.reverse(), i2 = h2 * (1 - a2), e3 = { t: "rangeBands", a: arguments }, o2;
            }, o2.rangeRoundBands = function(r4, a2, l2) {
              arguments.length < 2 && (a2 = 0), arguments.length < 3 && (l2 = a2);
              var u2 = r4[1] < r4[0], c2 = r4[u2 - 0], f3 = r4[1 - u2], h2 = Math.floor((f3 - c2) / (t3.length - a2 + 2 * l2));
              return n3 = s2(c2 + Math.round((f3 - c2 - (t3.length - a2) * h2) / 2), h2), u2 && n3.reverse(), i2 = Math.round(h2 * (1 - a2)), e3 = { t: "rangeRoundBands", a: arguments }, o2;
            }, o2.rangeBand = function() {
              return i2;
            }, o2.rangeExtent = function() {
              return Hn(e3.a[0]);
            }, o2.copy = function() {
              return ai(t3, e3);
            }, o2.domain(t3);
          }
          a.scale.pow = function() {
            return ni(a.scale.linear(), 1, [0, 1]);
          }, a.scale.sqrt = function() {
            return a.scale.pow().exponent(0.5);
          }, a.scale.ordinal = function() {
            return ai([], { t: "range", a: [[]] });
          }, a.scale.category10 = function() {
            return a.scale.ordinal().range(oi);
          }, a.scale.category20 = function() {
            return a.scale.ordinal().range(si);
          }, a.scale.category20b = function() {
            return a.scale.ordinal().range(li);
          }, a.scale.category20c = function() {
            return a.scale.ordinal().range(ui);
          };
          var oi = [2062260, 16744206, 2924588, 14034728, 9725885, 9197131, 14907330, 8355711, 12369186, 1556175].map(oe), si = [2062260, 11454440, 16744206, 16759672, 2924588, 10018698, 14034728, 16750742, 9725885, 12955861, 9197131, 12885140, 14907330, 16234194, 8355711, 13092807, 12369186, 14408589, 1556175, 10410725].map(oe), li = [3750777, 5395619, 7040719, 10264286, 6519097, 9216594, 11915115, 13556636, 9202993, 12426809, 15186514, 15190932, 8666169, 11356490, 14049643, 15177372, 8077683, 10834324, 13528509, 14589654].map(oe), ui = [3244733, 7057110, 10406625, 13032431, 15095053, 16616764, 16625259, 16634018, 3253076, 7652470, 10607003, 13101504, 7695281, 10394312, 12369372, 14342891, 6513507, 9868950, 12434877, 14277081].map(oe);
          function ci(t3, e3) {
            var r3;
            function n3() {
              var n4 = 0, o2 = e3.length;
              for (r3 = []; ++n4 < o2; )
                r3[n4 - 1] = a.quantile(t3, n4 / o2);
              return i2;
            }
            function i2(t4) {
              if (!isNaN(t4 = +t4))
                return e3[a.bisect(r3, t4)];
            }
            return i2.domain = function(e4) {
              return arguments.length ? (t3 = e4.map(y).filter(m2).sort(g2), n3()) : t3;
            }, i2.range = function(t4) {
              return arguments.length ? (e3 = t4, n3()) : e3;
            }, i2.quantiles = function() {
              return r3;
            }, i2.invertExtent = function(n4) {
              return (n4 = e3.indexOf(n4)) < 0 ? [NaN, NaN] : [n4 > 0 ? r3[n4 - 1] : t3[0], n4 < r3.length ? r3[n4] : t3[t3.length - 1]];
            }, i2.copy = function() {
              return ci(t3, e3);
            }, n3();
          }
          function fi(t3, e3, r3) {
            var n3, i2;
            function a2(e4) {
              return r3[Math.max(0, Math.min(i2, Math.floor(n3 * (e4 - t3))))];
            }
            function o2() {
              return n3 = r3.length / (e3 - t3), i2 = r3.length - 1, a2;
            }
            return a2.domain = function(r4) {
              return arguments.length ? (t3 = +r4[0], e3 = +r4[r4.length - 1], o2()) : [t3, e3];
            }, a2.range = function(t4) {
              return arguments.length ? (r3 = t4, o2()) : r3;
            }, a2.invertExtent = function(e4) {
              return [e4 = (e4 = r3.indexOf(e4)) < 0 ? NaN : e4 / n3 + t3, e4 + 1 / n3];
            }, a2.copy = function() {
              return fi(t3, e3, r3);
            }, o2();
          }
          function hi(t3, e3) {
            function r3(r4) {
              if (r4 <= r4)
                return e3[a.bisect(t3, r4)];
            }
            return r3.domain = function(e4) {
              return arguments.length ? (t3 = e4, r3) : t3;
            }, r3.range = function(t4) {
              return arguments.length ? (e3 = t4, r3) : e3;
            }, r3.invertExtent = function(r4) {
              return r4 = e3.indexOf(r4), [t3[r4 - 1], t3[r4]];
            }, r3.copy = function() {
              return hi(t3, e3);
            }, r3;
          }
          function pi(t3) {
            function e3(t4) {
              return +t4;
            }
            return e3.invert = e3, e3.domain = e3.range = function(r3) {
              return arguments.length ? (t3 = r3.map(e3), e3) : t3;
            }, e3.ticks = function(e4) {
              return ti(t3, e4);
            }, e3.tickFormat = function(e4, r3) {
              return d3_scale_linearTickFormat(t3, e4, r3);
            }, e3.copy = function() {
              return pi(t3);
            }, e3;
          }
          function di() {
            return 0;
          }
          a.scale.quantile = function() {
            return ci([], []);
          }, a.scale.quantize = function() {
            return fi(0, 1, [0, 1]);
          }, a.scale.threshold = function() {
            return hi([0.5], [0, 1]);
          }, a.scale.identity = function() {
            return pi([0, 1]);
          }, a.svg = {}, a.svg.arc = function() {
            var t3 = gi, e3 = yi, r3 = di, n3 = vi, i2 = mi, a2 = xi, o2 = bi;
            function s2() {
              var s3 = Math.max(0, +t3.apply(this, arguments)), u2 = Math.max(0, +e3.apply(this, arguments)), c2 = i2.apply(this, arguments) - Ot, f3 = a2.apply(this, arguments) - Ot, h2 = Math.abs(f3 - c2), p3 = c2 > f3 ? 0 : 1;
              if (u2 < s3 && (d3 = u2, u2 = s3, s3 = d3), h2 >= Pt)
                return l2(u2, p3) + (s3 ? l2(s3, 1 - p3) : "") + "Z";
              var d3, v2, g3, y2, m3, x2, b2, _2, w3, T2, k2, A2, M2 = 0, S2 = 0, E2 = [];
              if ((y2 = (+o2.apply(this, arguments) || 0) / 2) && (g3 = n3 === vi ? Math.sqrt(s3 * s3 + u2 * u2) : +n3.apply(this, arguments), p3 || (S2 *= -1), u2 && (S2 = zt(g3 / u2 * Math.sin(y2))), s3 && (M2 = zt(g3 / s3 * Math.sin(y2)))), u2) {
                m3 = u2 * Math.cos(c2 + S2), x2 = u2 * Math.sin(c2 + S2), b2 = u2 * Math.cos(f3 - S2), _2 = u2 * Math.sin(f3 - S2);
                var L2 = Math.abs(f3 - c2 - 2 * S2) <= Lt ? 0 : 1;
                if (S2 && _i(m3, x2, b2, _2) === p3 ^ L2) {
                  var C2 = (c2 + f3) / 2;
                  m3 = u2 * Math.cos(C2), x2 = u2 * Math.sin(C2), b2 = _2 = null;
                }
              } else
                m3 = x2 = 0;
              if (s3) {
                w3 = s3 * Math.cos(f3 - M2), T2 = s3 * Math.sin(f3 - M2), k2 = s3 * Math.cos(c2 + M2), A2 = s3 * Math.sin(c2 + M2);
                var P2 = Math.abs(c2 - f3 + 2 * M2) <= Lt ? 0 : 1;
                if (M2 && _i(w3, T2, k2, A2) === 1 - p3 ^ P2) {
                  var O2 = (c2 + f3) / 2;
                  w3 = s3 * Math.cos(O2), T2 = s3 * Math.sin(O2), k2 = A2 = null;
                }
              } else
                w3 = T2 = 0;
              if (h2 > Et && (d3 = Math.min(Math.abs(u2 - s3) / 2, +r3.apply(this, arguments))) > 1e-3) {
                v2 = s3 < u2 ^ p3 ? 0 : 1;
                var I2 = d3, D2 = d3;
                if (h2 < Lt) {
                  var z2 = null == k2 ? [w3, T2] : null == b2 ? [m3, x2] : Ie([m3, x2], [k2, A2], [b2, _2], [w3, T2]), R2 = m3 - z2[0], F2 = x2 - z2[1], B2 = b2 - z2[0], N2 = _2 - z2[1], j2 = 1 / Math.sin(Math.acos((R2 * B2 + F2 * N2) / (Math.sqrt(R2 * R2 + F2 * F2) * Math.sqrt(B2 * B2 + N2 * N2))) / 2), U2 = Math.sqrt(z2[0] * z2[0] + z2[1] * z2[1]);
                  D2 = Math.min(d3, (s3 - U2) / (j2 - 1)), I2 = Math.min(d3, (u2 - U2) / (j2 + 1));
                }
                if (null != b2) {
                  var V2 = wi(null == k2 ? [w3, T2] : [k2, A2], [m3, x2], u2, I2, p3), H2 = wi([b2, _2], [w3, T2], u2, I2, p3);
                  d3 === I2 ? E2.push("M", V2[0], "A", I2, ",", I2, " 0 0,", v2, " ", V2[1], "A", u2, ",", u2, " 0 ", 1 - p3 ^ _i(V2[1][0], V2[1][1], H2[1][0], H2[1][1]), ",", p3, " ", H2[1], "A", I2, ",", I2, " 0 0,", v2, " ", H2[0]) : E2.push("M", V2[0], "A", I2, ",", I2, " 0 1,", v2, " ", H2[0]);
                } else
                  E2.push("M", m3, ",", x2);
                if (null != k2) {
                  var q3 = wi([m3, x2], [k2, A2], s3, -D2, p3), G2 = wi([w3, T2], null == b2 ? [m3, x2] : [b2, _2], s3, -D2, p3);
                  d3 === D2 ? E2.push("L", G2[0], "A", D2, ",", D2, " 0 0,", v2, " ", G2[1], "A", s3, ",", s3, " 0 ", p3 ^ _i(G2[1][0], G2[1][1], q3[1][0], q3[1][1]), ",", 1 - p3, " ", q3[1], "A", D2, ",", D2, " 0 0,", v2, " ", q3[0]) : E2.push("L", G2[0], "A", D2, ",", D2, " 0 0,", v2, " ", q3[0]);
                } else
                  E2.push("L", w3, ",", T2);
              } else
                E2.push("M", m3, ",", x2), null != b2 && E2.push("A", u2, ",", u2, " 0 ", L2, ",", p3, " ", b2, ",", _2), E2.push("L", w3, ",", T2), null != k2 && E2.push("A", s3, ",", s3, " 0 ", P2, ",", 1 - p3, " ", k2, ",", A2);
              return E2.push("Z"), E2.join("");
            }
            function l2(t4, e4) {
              return "M0," + t4 + "A" + t4 + "," + t4 + " 0 1," + e4 + " 0," + -t4 + "A" + t4 + "," + t4 + " 0 1," + e4 + " 0," + t4;
            }
            return s2.innerRadius = function(e4) {
              return arguments.length ? (t3 = ve(e4), s2) : t3;
            }, s2.outerRadius = function(t4) {
              return arguments.length ? (e3 = ve(t4), s2) : e3;
            }, s2.cornerRadius = function(t4) {
              return arguments.length ? (r3 = ve(t4), s2) : r3;
            }, s2.padRadius = function(t4) {
              return arguments.length ? (n3 = t4 == vi ? vi : ve(t4), s2) : n3;
            }, s2.startAngle = function(t4) {
              return arguments.length ? (i2 = ve(t4), s2) : i2;
            }, s2.endAngle = function(t4) {
              return arguments.length ? (a2 = ve(t4), s2) : a2;
            }, s2.padAngle = function(t4) {
              return arguments.length ? (o2 = ve(t4), s2) : o2;
            }, s2.centroid = function() {
              var r4 = (+t3.apply(this, arguments) + +e3.apply(this, arguments)) / 2, n4 = (+i2.apply(this, arguments) + +a2.apply(this, arguments)) / 2 - Ot;
              return [Math.cos(n4) * r4, Math.sin(n4) * r4];
            }, s2;
          };
          var vi = "auto";
          function gi(t3) {
            return t3.innerRadius;
          }
          function yi(t3) {
            return t3.outerRadius;
          }
          function mi(t3) {
            return t3.startAngle;
          }
          function xi(t3) {
            return t3.endAngle;
          }
          function bi(t3) {
            return t3 && t3.padAngle;
          }
          function _i(t3, e3, r3, n3) {
            return (t3 - r3) * e3 - (e3 - n3) * t3 > 0 ? 0 : 1;
          }
          function wi(t3, e3, r3, n3, i2) {
            var a2 = t3[0] - e3[0], o2 = t3[1] - e3[1], s2 = (i2 ? n3 : -n3) / Math.sqrt(a2 * a2 + o2 * o2), l2 = s2 * o2, u2 = -s2 * a2, c2 = t3[0] + l2, f3 = t3[1] + u2, h2 = e3[0] + l2, p3 = e3[1] + u2, d3 = (c2 + h2) / 2, v2 = (f3 + p3) / 2, g3 = h2 - c2, y2 = p3 - f3, m3 = g3 * g3 + y2 * y2, x2 = r3 - n3, b2 = c2 * p3 - h2 * f3, _2 = (y2 < 0 ? -1 : 1) * Math.sqrt(Math.max(0, x2 * x2 * m3 - b2 * b2)), w3 = (b2 * y2 - g3 * _2) / m3, T2 = (-b2 * g3 - y2 * _2) / m3, k2 = (b2 * y2 + g3 * _2) / m3, A2 = (-b2 * g3 + y2 * _2) / m3, M2 = w3 - d3, S2 = T2 - v2, E2 = k2 - d3, L2 = A2 - v2;
            return M2 * M2 + S2 * S2 > E2 * E2 + L2 * L2 && (w3 = k2, T2 = A2), [[w3 - l2, T2 - u2], [w3 * r3 / x2, T2 * r3 / x2]];
          }
          function Ti() {
            return true;
          }
          function ki(t3) {
            var e3 = Se, r3 = Ee, n3 = Ti, i2 = Mi, a2 = i2.key, o2 = 0.7;
            function s2(a3) {
              var s3, l2 = [], u2 = [], c2 = -1, f3 = a3.length, h2 = ve(e3), p3 = ve(r3);
              function d3() {
                l2.push("M", i2(t3(u2), o2));
              }
              for (; ++c2 < f3; )
                n3.call(this, s3 = a3[c2], c2) ? u2.push([+h2.call(this, s3, c2), +p3.call(this, s3, c2)]) : u2.length && (d3(), u2 = []);
              return u2.length && d3(), l2.length ? l2.join("") : null;
            }
            return s2.x = function(t4) {
              return arguments.length ? (e3 = t4, s2) : e3;
            }, s2.y = function(t4) {
              return arguments.length ? (r3 = t4, s2) : r3;
            }, s2.defined = function(t4) {
              return arguments.length ? (n3 = t4, s2) : n3;
            }, s2.interpolate = function(t4) {
              return arguments.length ? (a2 = "function" == typeof t4 ? i2 = t4 : (i2 = Ai.get(t4) || Mi).key, s2) : a2;
            }, s2.tension = function(t4) {
              return arguments.length ? (o2 = t4, s2) : o2;
            }, s2;
          }
          a.svg.line = function() {
            return ki(D);
          };
          var Ai = a.map({ linear: Mi, "linear-closed": Si, step: function(t3) {
            for (var e3 = 0, r3 = t3.length, n3 = t3[0], i2 = [n3[0], ",", n3[1]]; ++e3 < r3; )
              i2.push("H", (n3[0] + (n3 = t3[e3])[0]) / 2, "V", n3[1]);
            return r3 > 1 && i2.push("H", n3[0]), i2.join("");
          }, "step-before": Ei, "step-after": Li, basis: Oi, "basis-open": function(t3) {
            if (t3.length < 4)
              return Mi(t3);
            for (var e3, r3 = [], n3 = -1, i2 = t3.length, a2 = [0], o2 = [0]; ++n3 < 3; )
              e3 = t3[n3], a2.push(e3[0]), o2.push(e3[1]);
            for (r3.push(Ii(Ri, a2) + "," + Ii(Ri, o2)), --n3; ++n3 < i2; )
              e3 = t3[n3], a2.shift(), a2.push(e3[0]), o2.shift(), o2.push(e3[1]), Fi(r3, a2, o2);
            return r3.join("");
          }, "basis-closed": function(t3) {
            for (var e3, r3, n3 = -1, i2 = t3.length, a2 = i2 + 4, o2 = [], s2 = []; ++n3 < 4; )
              r3 = t3[n3 % i2], o2.push(r3[0]), s2.push(r3[1]);
            for (e3 = [Ii(Ri, o2), ",", Ii(Ri, s2)], --n3; ++n3 < a2; )
              r3 = t3[n3 % i2], o2.shift(), o2.push(r3[0]), s2.shift(), s2.push(r3[1]), Fi(e3, o2, s2);
            return e3.join("");
          }, bundle: function(t3, e3) {
            var r3 = t3.length - 1;
            if (r3)
              for (var n3, i2, a2 = t3[0][0], o2 = t3[0][1], s2 = t3[r3][0] - a2, l2 = t3[r3][1] - o2, u2 = -1; ++u2 <= r3; )
                i2 = u2 / r3, (n3 = t3[u2])[0] = e3 * n3[0] + (1 - e3) * (a2 + i2 * s2), n3[1] = e3 * n3[1] + (1 - e3) * (o2 + i2 * l2);
            return Oi(t3);
          }, cardinal: function(t3, e3) {
            return t3.length < 3 ? Mi(t3) : t3[0] + Ci(t3, Pi(t3, e3));
          }, "cardinal-open": function(t3, e3) {
            return t3.length < 4 ? Mi(t3) : t3[1] + Ci(t3.slice(1, -1), Pi(t3, e3));
          }, "cardinal-closed": function(t3, e3) {
            return t3.length < 3 ? Si(t3) : t3[0] + Ci((t3.push(t3[0]), t3), Pi([t3[t3.length - 2]].concat(t3, [t3[1]]), e3));
          }, monotone: function(t3) {
            return t3.length < 3 ? Mi(t3) : t3[0] + Ci(t3, function(t4) {
              for (var e3, r3, n3, i2, a2 = [], o2 = function(t5) {
                for (var e4 = 0, r4 = t5.length - 1, n4 = [], i3 = t5[0], a3 = t5[1], o3 = n4[0] = Bi(i3, a3); ++e4 < r4; )
                  n4[e4] = (o3 + (o3 = Bi(i3 = a3, a3 = t5[e4 + 1]))) / 2;
                return n4[e4] = o3, n4;
              }(t4), s2 = -1, l2 = t4.length - 1; ++s2 < l2; )
                e3 = Bi(t4[s2], t4[s2 + 1]), w2(e3) < Et ? o2[s2] = o2[s2 + 1] = 0 : (i2 = (r3 = o2[s2] / e3) * r3 + (n3 = o2[s2 + 1] / e3) * n3) > 9 && (i2 = 3 * e3 / Math.sqrt(i2), o2[s2] = i2 * r3, o2[s2 + 1] = i2 * n3);
              for (s2 = -1; ++s2 <= l2; )
                i2 = (t4[Math.min(l2, s2 + 1)][0] - t4[Math.max(0, s2 - 1)][0]) / (6 * (1 + o2[s2] * o2[s2])), a2.push([i2 || 0, o2[s2] * i2 || 0]);
              return a2;
            }(t3));
          } });
          function Mi(t3) {
            return t3.length > 1 ? t3.join("L") : t3 + "Z";
          }
          function Si(t3) {
            return t3.join("L") + "Z";
          }
          function Ei(t3) {
            for (var e3 = 0, r3 = t3.length, n3 = t3[0], i2 = [n3[0], ",", n3[1]]; ++e3 < r3; )
              i2.push("V", (n3 = t3[e3])[1], "H", n3[0]);
            return i2.join("");
          }
          function Li(t3) {
            for (var e3 = 0, r3 = t3.length, n3 = t3[0], i2 = [n3[0], ",", n3[1]]; ++e3 < r3; )
              i2.push("H", (n3 = t3[e3])[0], "V", n3[1]);
            return i2.join("");
          }
          function Ci(t3, e3) {
            if (e3.length < 1 || t3.length != e3.length && t3.length != e3.length + 2)
              return Mi(t3);
            var r3 = t3.length != e3.length, n3 = "", i2 = t3[0], a2 = t3[1], o2 = e3[0], s2 = o2, l2 = 1;
            if (r3 && (n3 += "Q" + (a2[0] - 2 * o2[0] / 3) + "," + (a2[1] - 2 * o2[1] / 3) + "," + a2[0] + "," + a2[1], i2 = t3[1], l2 = 2), e3.length > 1) {
              s2 = e3[1], a2 = t3[l2], l2++, n3 += "C" + (i2[0] + o2[0]) + "," + (i2[1] + o2[1]) + "," + (a2[0] - s2[0]) + "," + (a2[1] - s2[1]) + "," + a2[0] + "," + a2[1];
              for (var u2 = 2; u2 < e3.length; u2++, l2++)
                a2 = t3[l2], s2 = e3[u2], n3 += "S" + (a2[0] - s2[0]) + "," + (a2[1] - s2[1]) + "," + a2[0] + "," + a2[1];
            }
            if (r3) {
              var c2 = t3[l2];
              n3 += "Q" + (a2[0] + 2 * s2[0] / 3) + "," + (a2[1] + 2 * s2[1] / 3) + "," + c2[0] + "," + c2[1];
            }
            return n3;
          }
          function Pi(t3, e3) {
            for (var r3, n3 = [], i2 = (1 - e3) / 2, a2 = t3[0], o2 = t3[1], s2 = 1, l2 = t3.length; ++s2 < l2; )
              r3 = a2, a2 = o2, o2 = t3[s2], n3.push([i2 * (o2[0] - r3[0]), i2 * (o2[1] - r3[1])]);
            return n3;
          }
          function Oi(t3) {
            if (t3.length < 3)
              return Mi(t3);
            var e3 = 1, r3 = t3.length, n3 = t3[0], i2 = n3[0], a2 = n3[1], o2 = [i2, i2, i2, (n3 = t3[1])[0]], s2 = [a2, a2, a2, n3[1]], l2 = [i2, ",", a2, "L", Ii(Ri, o2), ",", Ii(Ri, s2)];
            for (t3.push(t3[r3 - 1]); ++e3 <= r3; )
              n3 = t3[e3], o2.shift(), o2.push(n3[0]), s2.shift(), s2.push(n3[1]), Fi(l2, o2, s2);
            return t3.pop(), l2.push("L", n3), l2.join("");
          }
          function Ii(t3, e3) {
            return t3[0] * e3[0] + t3[1] * e3[1] + t3[2] * e3[2] + t3[3] * e3[3];
          }
          Ai.forEach(function(t3, e3) {
            e3.key = t3, e3.closed = /-closed$/.test(t3);
          });
          var Di = [0, 2 / 3, 1 / 3, 0], zi = [0, 1 / 3, 2 / 3, 0], Ri = [0, 1 / 6, 2 / 3, 1 / 6];
          function Fi(t3, e3, r3) {
            t3.push("C", Ii(Di, e3), ",", Ii(Di, r3), ",", Ii(zi, e3), ",", Ii(zi, r3), ",", Ii(Ri, e3), ",", Ii(Ri, r3));
          }
          function Bi(t3, e3) {
            return (e3[1] - t3[1]) / (e3[0] - t3[0]);
          }
          function Ni(t3) {
            for (var e3, r3, n3, i2 = -1, a2 = t3.length; ++i2 < a2; )
              r3 = (e3 = t3[i2])[0], n3 = e3[1] - Ot, e3[0] = r3 * Math.cos(n3), e3[1] = r3 * Math.sin(n3);
            return t3;
          }
          function ji(t3) {
            var e3 = Se, r3 = Se, n3 = 0, i2 = Ee, a2 = Ti, o2 = Mi, s2 = o2.key, l2 = o2, u2 = "L", c2 = 0.7;
            function f3(s3) {
              var f4, h2, p3, d3 = [], v2 = [], g3 = [], y2 = -1, m3 = s3.length, x2 = ve(e3), b2 = ve(n3), _2 = e3 === r3 ? function() {
                return h2;
              } : ve(r3), w3 = n3 === i2 ? function() {
                return p3;
              } : ve(i2);
              function T2() {
                d3.push("M", o2(t3(g3), c2), u2, l2(t3(v2.reverse()), c2), "Z");
              }
              for (; ++y2 < m3; )
                a2.call(this, f4 = s3[y2], y2) ? (v2.push([h2 = +x2.call(this, f4, y2), p3 = +b2.call(this, f4, y2)]), g3.push([+_2.call(this, f4, y2), +w3.call(this, f4, y2)])) : v2.length && (T2(), v2 = [], g3 = []);
              return v2.length && T2(), d3.length ? d3.join("") : null;
            }
            return f3.x = function(t4) {
              return arguments.length ? (e3 = r3 = t4, f3) : r3;
            }, f3.x0 = function(t4) {
              return arguments.length ? (e3 = t4, f3) : e3;
            }, f3.x1 = function(t4) {
              return arguments.length ? (r3 = t4, f3) : r3;
            }, f3.y = function(t4) {
              return arguments.length ? (n3 = i2 = t4, f3) : i2;
            }, f3.y0 = function(t4) {
              return arguments.length ? (n3 = t4, f3) : n3;
            }, f3.y1 = function(t4) {
              return arguments.length ? (i2 = t4, f3) : i2;
            }, f3.defined = function(t4) {
              return arguments.length ? (a2 = t4, f3) : a2;
            }, f3.interpolate = function(t4) {
              return arguments.length ? (s2 = "function" == typeof t4 ? o2 = t4 : (o2 = Ai.get(t4) || Mi).key, l2 = o2.reverse || o2, u2 = o2.closed ? "M" : "L", f3) : s2;
            }, f3.tension = function(t4) {
              return arguments.length ? (c2 = t4, f3) : c2;
            }, f3;
          }
          function Ui(t3) {
            return t3.source;
          }
          function Vi(t3) {
            return t3.target;
          }
          function Hi(t3) {
            return t3.radius;
          }
          function qi(t3) {
            return [t3.x, t3.y];
          }
          function Gi(t3) {
            return function() {
              var e3 = t3.apply(this, arguments), r3 = e3[0], n3 = e3[1] - Ot;
              return [r3 * Math.cos(n3), r3 * Math.sin(n3)];
            };
          }
          function Zi() {
            return 64;
          }
          function Yi() {
            return "circle";
          }
          function Wi(t3) {
            var e3 = Math.sqrt(t3 / Lt);
            return "M0," + e3 + "A" + e3 + "," + e3 + " 0 1,1 0," + -e3 + "A" + e3 + "," + e3 + " 0 1,1 0," + e3 + "Z";
          }
          a.svg.line.radial = function() {
            var t3 = ki(Ni);
            return t3.radius = t3.x, delete t3.x, t3.angle = t3.y, delete t3.y, t3;
          }, Ei.reverse = Li, Li.reverse = Ei, a.svg.area = function() {
            return ji(D);
          }, a.svg.area.radial = function() {
            var t3 = ji(Ni);
            return t3.radius = t3.x, delete t3.x, t3.innerRadius = t3.x0, delete t3.x0, t3.outerRadius = t3.x1, delete t3.x1, t3.angle = t3.y, delete t3.y, t3.startAngle = t3.y0, delete t3.y0, t3.endAngle = t3.y1, delete t3.y1, t3;
          }, a.svg.chord = function() {
            var t3 = Ui, e3 = Vi, r3 = Hi, n3 = mi, i2 = xi;
            function a2(r4, n4) {
              var i3, a3, u2 = o2(this, t3, r4, n4), c2 = o2(this, e3, r4, n4);
              return "M" + u2.p0 + s2(u2.r, u2.p1, u2.a1 - u2.a0) + (a3 = c2, ((i3 = u2).a0 == a3.a0 && i3.a1 == a3.a1 ? l2(u2.r, u2.p1, u2.r, u2.p0) : l2(u2.r, u2.p1, c2.r, c2.p0) + s2(c2.r, c2.p1, c2.a1 - c2.a0) + l2(c2.r, c2.p1, u2.r, u2.p0)) + "Z");
            }
            function o2(t4, e4, a3, o3) {
              var s3 = e4.call(t4, a3, o3), l3 = r3.call(t4, s3, o3), u2 = n3.call(t4, s3, o3) - Ot, c2 = i2.call(t4, s3, o3) - Ot;
              return { r: l3, a0: u2, a1: c2, p0: [l3 * Math.cos(u2), l3 * Math.sin(u2)], p1: [l3 * Math.cos(c2), l3 * Math.sin(c2)] };
            }
            function s2(t4, e4, r4) {
              return "A" + t4 + "," + t4 + " 0 " + +(r4 > Lt) + ",1 " + e4;
            }
            function l2(t4, e4, r4, n4) {
              return "Q 0,0 " + n4;
            }
            return a2.radius = function(t4) {
              return arguments.length ? (r3 = ve(t4), a2) : r3;
            }, a2.source = function(e4) {
              return arguments.length ? (t3 = ve(e4), a2) : t3;
            }, a2.target = function(t4) {
              return arguments.length ? (e3 = ve(t4), a2) : e3;
            }, a2.startAngle = function(t4) {
              return arguments.length ? (n3 = ve(t4), a2) : n3;
            }, a2.endAngle = function(t4) {
              return arguments.length ? (i2 = ve(t4), a2) : i2;
            }, a2;
          }, a.svg.diagonal = function() {
            var t3 = Ui, e3 = Vi, r3 = qi;
            function n3(n4, i2) {
              var a2 = t3.call(this, n4, i2), o2 = e3.call(this, n4, i2), s2 = (a2.y + o2.y) / 2, l2 = [a2, { x: a2.x, y: s2 }, { x: o2.x, y: s2 }, o2];
              return "M" + (l2 = l2.map(r3))[0] + "C" + l2[1] + " " + l2[2] + " " + l2[3];
            }
            return n3.source = function(e4) {
              return arguments.length ? (t3 = ve(e4), n3) : t3;
            }, n3.target = function(t4) {
              return arguments.length ? (e3 = ve(t4), n3) : e3;
            }, n3.projection = function(t4) {
              return arguments.length ? (r3 = t4, n3) : r3;
            }, n3;
          }, a.svg.diagonal.radial = function() {
            var t3 = a.svg.diagonal(), e3 = qi, r3 = t3.projection;
            return t3.projection = function(t4) {
              return arguments.length ? r3(Gi(e3 = t4)) : e3;
            }, t3;
          }, a.svg.symbol = function() {
            var t3 = Yi, e3 = Zi;
            function r3(r4, n3) {
              return (Xi.get(t3.call(this, r4, n3)) || Wi)(e3.call(this, r4, n3));
            }
            return r3.type = function(e4) {
              return arguments.length ? (t3 = ve(e4), r3) : t3;
            }, r3.size = function(t4) {
              return arguments.length ? (e3 = ve(t4), r3) : e3;
            }, r3;
          };
          var Xi = a.map({ circle: Wi, cross: function(t3) {
            var e3 = Math.sqrt(t3 / 5) / 2;
            return "M" + -3 * e3 + "," + -e3 + "H" + -e3 + "V" + -3 * e3 + "H" + e3 + "V" + -e3 + "H" + 3 * e3 + "V" + e3 + "H" + e3 + "V" + 3 * e3 + "H" + -e3 + "V" + e3 + "H" + -3 * e3 + "Z";
          }, diamond: function(t3) {
            var e3 = Math.sqrt(t3 / (2 * Ki)), r3 = e3 * Ki;
            return "M0," + -e3 + "L" + r3 + ",0 0," + e3 + " " + -r3 + ",0Z";
          }, square: function(t3) {
            var e3 = Math.sqrt(t3) / 2;
            return "M" + -e3 + "," + -e3 + "L" + e3 + "," + -e3 + " " + e3 + "," + e3 + " " + -e3 + "," + e3 + "Z";
          }, "triangle-down": function(t3) {
            var e3 = Math.sqrt(t3 / Ji), r3 = e3 * Ji / 2;
            return "M0," + r3 + "L" + e3 + "," + -r3 + " " + -e3 + "," + -r3 + "Z";
          }, "triangle-up": function(t3) {
            var e3 = Math.sqrt(t3 / Ji), r3 = e3 * Ji / 2;
            return "M0," + -r3 + "L" + e3 + "," + r3 + " " + -e3 + "," + r3 + "Z";
          } });
          a.svg.symbolTypes = Xi.keys();
          var Ji = Math.sqrt(3), Ki = Math.tan(30 * It);
          J.transition = function(t3) {
            for (var e3, r3, n3 = ea || ++ia, i2 = sa(t3), a2 = [], o2 = ra || { time: Date.now(), ease: Ir, delay: 0, duration: 250 }, s2 = -1, l2 = this.length; ++s2 < l2; ) {
              a2.push(e3 = []);
              for (var u2 = this[s2], c2 = -1, f3 = u2.length; ++c2 < f3; )
                (r3 = u2[c2]) && la(r3, c2, i2, n3, o2), e3.push(r3);
            }
            return ta(a2, i2, n3);
          }, J.interrupt = function(t3) {
            return this.each(null == t3 ? $i : Qi(sa(t3)));
          };
          var $i = Qi(sa());
          function Qi(t3) {
            return function() {
              var e3, r3, n3;
              (e3 = this[t3]) && (n3 = e3[r3 = e3.active]) && (n3.timer.c = null, n3.timer.t = NaN, --e3.count ? delete e3[r3] : delete this[t3], e3.active += 0.5, n3.event && n3.event.interrupt.call(this, this.__data__, n3.index));
            };
          }
          function ta(t3, e3, r3) {
            return G(t3, na), t3.namespace = e3, t3.id = r3, t3;
          }
          var ea, ra, na = [], ia = 0;
          function aa(t3, e3, r3, n3) {
            var i2 = t3.id, a2 = t3.namespace;
            return dt(t3, "function" == typeof r3 ? function(t4, o2, s2) {
              t4[a2][i2].tween.set(e3, n3(r3.call(t4, t4.__data__, o2, s2)));
            } : (r3 = n3(r3), function(t4) {
              t4[a2][i2].tween.set(e3, r3);
            }));
          }
          function oa(t3) {
            return null == t3 && (t3 = ""), function() {
              this.textContent = t3;
            };
          }
          function sa(t3) {
            return null == t3 ? "__transition__" : "__transition_" + t3 + "__";
          }
          function la(t3, e3, r3, n3, i2) {
            var a2, o2, s2, l2, u2, c2 = t3[r3] || (t3[r3] = { active: 0, count: 0 }), f3 = c2[n3];
            function h2(r4) {
              var i3 = c2.active, h3 = c2[i3];
              for (var d3 in h3 && (h3.timer.c = null, h3.timer.t = NaN, --c2.count, delete c2[i3], h3.event && h3.event.interrupt.call(t3, t3.__data__, h3.index)), c2)
                if (+d3 < n3) {
                  var v2 = c2[d3];
                  v2.timer.c = null, v2.timer.t = NaN, --c2.count, delete c2[d3];
                }
              o2.c = p3, Te(function() {
                return o2.c && p3(r4 || 1) && (o2.c = null, o2.t = NaN), 1;
              }, 0, a2), c2.active = n3, f3.event && f3.event.start.call(t3, t3.__data__, e3), u2 = [], f3.tween.forEach(function(r5, n4) {
                (n4 = n4.call(t3, t3.__data__, e3)) && u2.push(n4);
              }), l2 = f3.ease, s2 = f3.duration;
            }
            function p3(i3) {
              for (var a3 = i3 / s2, o3 = l2(a3), h3 = u2.length; h3 > 0; )
                u2[--h3].call(t3, o3);
              if (a3 >= 1)
                return f3.event && f3.event.end.call(t3, t3.__data__, e3), --c2.count ? delete c2[n3] : delete t3[r3], 1;
            }
            f3 || (a2 = i2.time, o2 = Te(function(t4) {
              var e4 = f3.delay;
              if (o2.t = e4 + a2, e4 <= t4)
                return h2(t4 - e4);
              o2.c = h2;
            }, 0, a2), f3 = c2[n3] = { tween: new A(), time: a2, timer: o2, delay: i2.delay, duration: i2.duration, ease: i2.ease, index: e3 }, i2 = null, ++c2.count);
          }
          na.call = J.call, na.empty = J.empty, na.node = J.node, na.size = J.size, a.transition = function(t3, e3) {
            return t3 && t3.transition ? ea ? t3.transition(e3) : t3 : a.selection().transition(t3);
          }, a.transition.prototype = na, na.select = function(t3) {
            var e3, r3, n3, i2 = this.id, a2 = this.namespace, o2 = [];
            t3 = K(t3);
            for (var s2 = -1, l2 = this.length; ++s2 < l2; ) {
              o2.push(e3 = []);
              for (var u2 = this[s2], c2 = -1, f3 = u2.length; ++c2 < f3; )
                (n3 = u2[c2]) && (r3 = t3.call(n3, n3.__data__, c2, s2)) ? ("__data__" in n3 && (r3.__data__ = n3.__data__), la(r3, c2, a2, i2, n3[a2][i2]), e3.push(r3)) : e3.push(null);
            }
            return ta(o2, a2, i2);
          }, na.selectAll = function(t3) {
            var e3, r3, n3, i2, a2, o2 = this.id, s2 = this.namespace, l2 = [];
            t3 = $(t3);
            for (var u2 = -1, c2 = this.length; ++u2 < c2; )
              for (var f3 = this[u2], h2 = -1, p3 = f3.length; ++h2 < p3; )
                if (n3 = f3[h2]) {
                  a2 = n3[s2][o2], r3 = t3.call(n3, n3.__data__, h2, u2), l2.push(e3 = []);
                  for (var d3 = -1, v2 = r3.length; ++d3 < v2; )
                    (i2 = r3[d3]) && la(i2, d3, s2, o2, a2), e3.push(i2);
                }
            return ta(l2, s2, o2);
          }, na.filter = function(t3) {
            var e3, r3, n3 = [];
            "function" != typeof t3 && (t3 = ht(t3));
            for (var i2 = 0, a2 = this.length; i2 < a2; i2++) {
              n3.push(e3 = []);
              for (var o2, s2 = 0, l2 = (o2 = this[i2]).length; s2 < l2; s2++)
                (r3 = o2[s2]) && t3.call(r3, r3.__data__, s2, i2) && e3.push(r3);
            }
            return ta(n3, this.namespace, this.id);
          }, na.tween = function(t3, e3) {
            var r3 = this.id, n3 = this.namespace;
            return arguments.length < 2 ? this.node()[n3][r3].tween.get(t3) : dt(this, null == e3 ? function(e4) {
              e4[n3][r3].tween.remove(t3);
            } : function(i2) {
              i2[n3][r3].tween.set(t3, e3);
            });
          }, na.attr = function(t3, e3) {
            if (arguments.length < 2) {
              for (e3 in t3)
                this.attr(e3, t3[e3]);
              return this;
            }
            var r3 = "transform" == t3 ? qr : Tr, n3 = a.ns.qualify(t3);
            function i2() {
              this.removeAttribute(n3);
            }
            function o2() {
              this.removeAttributeNS(n3.space, n3.local);
            }
            function s2(t4) {
              return null == t4 ? i2 : (t4 += "", function() {
                var e4, i3 = this.getAttribute(n3);
                return i3 !== t4 && (e4 = r3(i3, t4), function(t5) {
                  this.setAttribute(n3, e4(t5));
                });
              });
            }
            function l2(t4) {
              return null == t4 ? o2 : (t4 += "", function() {
                var e4, i3 = this.getAttributeNS(n3.space, n3.local);
                return i3 !== t4 && (e4 = r3(i3, t4), function(t5) {
                  this.setAttributeNS(n3.space, n3.local, e4(t5));
                });
              });
            }
            return aa(this, "attr." + t3, e3, n3.local ? l2 : s2);
          }, na.attrTween = function(t3, e3) {
            var r3 = a.ns.qualify(t3);
            return this.tween("attr." + t3, r3.local ? function(t4, n3) {
              var i2 = e3.call(this, t4, n3, this.getAttributeNS(r3.space, r3.local));
              return i2 && function(t5) {
                this.setAttributeNS(r3.space, r3.local, i2(t5));
              };
            } : function(t4, n3) {
              var i2 = e3.call(this, t4, n3, this.getAttribute(r3));
              return i2 && function(t5) {
                this.setAttribute(r3, i2(t5));
              };
            });
          }, na.style = function(t3, e3, r3) {
            var n3 = arguments.length;
            if (n3 < 3) {
              if ("string" != typeof t3) {
                for (r3 in n3 < 2 && (e3 = ""), t3)
                  this.style(r3, t3[r3], e3);
                return this;
              }
              r3 = "";
            }
            function i2() {
              this.style.removeProperty(t3);
            }
            function a2(e4) {
              return null == e4 ? i2 : (e4 += "", function() {
                var n4, i3 = c(this).getComputedStyle(this, null).getPropertyValue(t3);
                return i3 !== e4 && (n4 = Tr(i3, e4), function(e5) {
                  this.style.setProperty(t3, n4(e5), r3);
                });
              });
            }
            return aa(this, "style." + t3, e3, a2);
          }, na.styleTween = function(t3, e3, r3) {
            function n3(n4, i2) {
              var a2 = e3.call(this, n4, i2, c(this).getComputedStyle(this, null).getPropertyValue(t3));
              return a2 && function(e4) {
                this.style.setProperty(t3, a2(e4), r3);
              };
            }
            return arguments.length < 3 && (r3 = ""), this.tween("style." + t3, n3);
          }, na.text = function(t3) {
            return aa(this, "text", t3, oa);
          }, na.remove = function() {
            var t3 = this.namespace;
            return this.each("end.transition", function() {
              var e3;
              this[t3].count < 2 && (e3 = this.parentNode) && e3.removeChild(this);
            });
          }, na.ease = function(t3) {
            var e3 = this.id, r3 = this.namespace;
            return arguments.length < 1 ? this.node()[r3][e3].ease : ("function" != typeof t3 && (t3 = a.ease.apply(a, arguments)), dt(this, function(n3) {
              n3[r3][e3].ease = t3;
            }));
          }, na.delay = function(t3) {
            var e3 = this.id, r3 = this.namespace;
            return arguments.length < 1 ? this.node()[r3][e3].delay : dt(this, "function" == typeof t3 ? function(n3, i2, a2) {
              n3[r3][e3].delay = +t3.call(n3, n3.__data__, i2, a2);
            } : (t3 = +t3, function(n3) {
              n3[r3][e3].delay = t3;
            }));
          }, na.duration = function(t3) {
            var e3 = this.id, r3 = this.namespace;
            return arguments.length < 1 ? this.node()[r3][e3].duration : dt(this, "function" == typeof t3 ? function(n3, i2, a2) {
              n3[r3][e3].duration = Math.max(1, t3.call(n3, n3.__data__, i2, a2));
            } : (t3 = Math.max(1, t3), function(n3) {
              n3[r3][e3].duration = t3;
            }));
          }, na.each = function(t3, e3) {
            var r3 = this.id, n3 = this.namespace;
            if (arguments.length < 2) {
              var i2 = ra, o2 = ea;
              try {
                ea = r3, dt(this, function(e4, i3, a2) {
                  ra = e4[n3][r3], t3.call(e4, e4.__data__, i3, a2);
                });
              } finally {
                ra = i2, ea = o2;
              }
            } else
              dt(this, function(i3) {
                var o3 = i3[n3][r3];
                (o3.event || (o3.event = a.dispatch("start", "end", "interrupt"))).on(t3, e3);
              });
            return this;
          }, na.transition = function() {
            for (var t3, e3, r3, n3 = this.id, i2 = ++ia, a2 = this.namespace, o2 = [], s2 = 0, l2 = this.length; s2 < l2; s2++) {
              o2.push(t3 = []);
              for (var u2, c2 = 0, f3 = (u2 = this[s2]).length; c2 < f3; c2++)
                (e3 = u2[c2]) && la(e3, c2, a2, i2, { time: (r3 = e3[a2][n3]).time, ease: r3.ease, delay: r3.delay + r3.duration, duration: r3.duration }), t3.push(e3);
            }
            return ta(o2, a2, i2);
          }, a.svg.axis = function() {
            var t3, e3 = a.scale.linear(), r3 = ua, n3 = 6, i2 = 6, o2 = 3, l2 = [10], u2 = null;
            function c2(s2) {
              s2.each(function() {
                var s3, c3 = a.select(this), f3 = this.__chart__ || e3, h2 = this.__chart__ = e3.copy(), p3 = null == u2 ? h2.ticks ? h2.ticks.apply(h2, l2) : h2.domain() : u2, d3 = null == t3 ? h2.tickFormat ? h2.tickFormat.apply(h2, l2) : D : t3, v2 = c3.selectAll(".tick").data(p3, h2), g3 = v2.enter().insert("g", ".domain").attr("class", "tick").style("opacity", Et), y2 = a.transition(v2.exit()).style("opacity", Et).remove(), m3 = a.transition(v2.order()).style("opacity", 1), x2 = Math.max(n3, 0) + o2, b2 = qn(h2), _2 = c3.selectAll(".domain").data([0]), w3 = (_2.enter().append("path").attr("class", "domain"), a.transition(_2));
                g3.append("line"), g3.append("text");
                var T2, k2, A2, M2, S2 = g3.select("line"), E2 = m3.select("line"), L2 = v2.select("text").text(d3), C2 = g3.select("text"), P2 = m3.select("text"), O2 = "top" === r3 || "left" === r3 ? -1 : 1;
                if ("bottom" === r3 || "top" === r3 ? (s3 = fa, T2 = "x", A2 = "y", k2 = "x2", M2 = "y2", L2.attr("dy", O2 < 0 ? "0em" : ".71em").style("text-anchor", "middle"), w3.attr("d", "M" + b2[0] + "," + O2 * i2 + "V0H" + b2[1] + "V" + O2 * i2)) : (s3 = ha, T2 = "y", A2 = "x", k2 = "y2", M2 = "x2", L2.attr("dy", ".32em").style("text-anchor", O2 < 0 ? "end" : "start"), w3.attr("d", "M" + O2 * i2 + "," + b2[0] + "H0V" + b2[1] + "H" + O2 * i2)), S2.attr(M2, O2 * n3), C2.attr(A2, O2 * x2), E2.attr(k2, 0).attr(M2, O2 * n3), P2.attr(T2, 0).attr(A2, O2 * x2), h2.rangeBand) {
                  var I2 = h2, z2 = I2.rangeBand() / 2;
                  f3 = h2 = function(t4) {
                    return I2(t4) + z2;
                  };
                } else
                  f3.rangeBand ? f3 = h2 : y2.call(s3, h2, f3);
                g3.call(s3, f3, h2), m3.call(s3, h2, h2);
              });
            }
            return c2.scale = function(t4) {
              return arguments.length ? (e3 = t4, c2) : e3;
            }, c2.orient = function(t4) {
              return arguments.length ? (r3 = t4 in ca ? t4 + "" : ua, c2) : r3;
            }, c2.ticks = function() {
              return arguments.length ? (l2 = s(arguments), c2) : l2;
            }, c2.tickValues = function(t4) {
              return arguments.length ? (u2 = t4, c2) : u2;
            }, c2.tickFormat = function(e4) {
              return arguments.length ? (t3 = e4, c2) : t3;
            }, c2.tickSize = function(t4) {
              var e4 = arguments.length;
              return e4 ? (n3 = +t4, i2 = +arguments[e4 - 1], c2) : n3;
            }, c2.innerTickSize = function(t4) {
              return arguments.length ? (n3 = +t4, c2) : n3;
            }, c2.outerTickSize = function(t4) {
              return arguments.length ? (i2 = +t4, c2) : i2;
            }, c2.tickPadding = function(t4) {
              return arguments.length ? (o2 = +t4, c2) : o2;
            }, c2.tickSubdivide = function() {
              return arguments.length && c2;
            }, c2;
          };
          var ua = "bottom", ca = { top: 1, right: 1, bottom: 1, left: 1 };
          function fa(t3, e3, r3) {
            t3.attr("transform", function(t4) {
              var n3 = e3(t4);
              return "translate(" + (isFinite(n3) ? n3 : r3(t4)) + ",0)";
            });
          }
          function ha(t3, e3, r3) {
            t3.attr("transform", function(t4) {
              var n3 = e3(t4);
              return "translate(0," + (isFinite(n3) ? n3 : r3(t4)) + ")";
            });
          }
          a.svg.brush = function() {
            var t3, e3, r3 = H(h2, "brushstart", "brush", "brushend"), n3 = null, i2 = null, o2 = [0, 0], s2 = [0, 0], l2 = true, u2 = true, f3 = da[0];
            function h2(t4) {
              t4.each(function() {
                var t5 = a.select(this).style("pointer-events", "all").style("-webkit-tap-highlight-color", "rgba(0,0,0,0)").on("mousedown.brush", g3).on("touchstart.brush", g3), e4 = t5.selectAll(".background").data([0]);
                e4.enter().append("rect").attr("class", "background").style("visibility", "hidden").style("cursor", "crosshair"), t5.selectAll(".extent").data([0]).enter().append("rect").attr("class", "extent").style("cursor", "move");
                var r4 = t5.selectAll(".resize").data(f3, D);
                r4.exit().remove(), r4.enter().append("g").attr("class", function(t6) {
                  return "resize " + t6;
                }).style("cursor", function(t6) {
                  return pa[t6];
                }).append("rect").attr("x", function(t6) {
                  return /[ew]$/.test(t6) ? -3 : null;
                }).attr("y", function(t6) {
                  return /^[ns]/.test(t6) ? -3 : null;
                }).attr("width", 6).attr("height", 6).style("visibility", "hidden"), r4.style("display", h2.empty() ? "none" : null);
                var o3, s3 = a.transition(t5), l3 = a.transition(e4);
                n3 && (o3 = qn(n3), l3.attr("x", o3[0]).attr("width", o3[1] - o3[0]), d3(s3)), i2 && (o3 = qn(i2), l3.attr("y", o3[0]).attr("height", o3[1] - o3[0]), v2(s3)), p3(s3);
              });
            }
            function p3(t4) {
              t4.selectAll(".resize").attr("transform", function(t5) {
                return "translate(" + o2[+/e$/.test(t5)] + "," + s2[+/^s/.test(t5)] + ")";
              });
            }
            function d3(t4) {
              t4.select(".extent").attr("x", o2[0]), t4.selectAll(".extent,.n>rect,.s>rect").attr("width", o2[1] - o2[0]);
            }
            function v2(t4) {
              t4.select(".extent").attr("y", s2[0]), t4.selectAll(".extent,.e>rect,.w>rect").attr("height", s2[1] - s2[0]);
            }
            function g3() {
              var f4, g4, y2 = this, m3 = a.select(a.event.target), x2 = r3.of(y2, arguments), b2 = a.select(y2), _2 = m3.datum(), w3 = !/^(n|s)$/.test(_2) && n3, T2 = !/^(e|w)$/.test(_2) && i2, k2 = m3.classed("extent"), A2 = kt(y2), M2 = a.mouse(y2), S2 = a.select(c(y2)).on("keydown.brush", C2).on("keyup.brush", P2);
              if (a.event.changedTouches ? S2.on("touchmove.brush", O2).on("touchend.brush", D2) : S2.on("mousemove.brush", O2).on("mouseup.brush", D2), b2.interrupt().selectAll("*").interrupt(), k2)
                M2[0] = o2[0] - M2[0], M2[1] = s2[0] - M2[1];
              else if (_2) {
                var E2 = +/w$/.test(_2), L2 = +/^n/.test(_2);
                g4 = [o2[1 - E2] - M2[0], s2[1 - L2] - M2[1]], M2[0] = o2[E2], M2[1] = s2[L2];
              } else
                a.event.altKey && (f4 = M2.slice());
              function C2() {
                32 == a.event.keyCode && (k2 || (f4 = null, M2[0] -= o2[1], M2[1] -= s2[1], k2 = 2), U());
              }
              function P2() {
                32 == a.event.keyCode && 2 == k2 && (M2[0] += o2[1], M2[1] += s2[1], k2 = 0, U());
              }
              function O2() {
                var t4 = a.mouse(y2), e4 = false;
                g4 && (t4[0] += g4[0], t4[1] += g4[1]), k2 || (a.event.altKey ? (f4 || (f4 = [(o2[0] + o2[1]) / 2, (s2[0] + s2[1]) / 2]), M2[0] = o2[+(t4[0] < f4[0])], M2[1] = s2[+(t4[1] < f4[1])]) : f4 = null), w3 && I2(t4, n3, 0) && (d3(b2), e4 = true), T2 && I2(t4, i2, 1) && (v2(b2), e4 = true), e4 && (p3(b2), x2({ type: "brush", mode: k2 ? "move" : "resize" }));
              }
              function I2(r4, n4, i3) {
                var a2, c2, h3 = qn(n4), p4 = h3[0], d4 = h3[1], v3 = M2[i3], g5 = i3 ? s2 : o2, y3 = g5[1] - g5[0];
                if (k2 && (p4 -= v3, d4 -= y3 + v3), a2 = (i3 ? u2 : l2) ? Math.max(p4, Math.min(d4, r4[i3])) : r4[i3], k2 ? c2 = (a2 += v3) + y3 : (f4 && (v3 = Math.max(p4, Math.min(d4, 2 * f4[i3] - a2))), v3 < a2 ? (c2 = a2, a2 = v3) : c2 = v3), g5[0] != a2 || g5[1] != c2)
                  return i3 ? e3 = null : t3 = null, g5[0] = a2, g5[1] = c2, true;
              }
              function D2() {
                O2(), b2.style("pointer-events", "all").selectAll(".resize").style("display", h2.empty() ? "none" : null), a.select("body").style("cursor", null), S2.on("mousemove.brush", null).on("mouseup.brush", null).on("touchmove.brush", null).on("touchend.brush", null).on("keydown.brush", null).on("keyup.brush", null), A2(), x2({ type: "brushend" });
              }
              b2.style("pointer-events", "none").selectAll(".resize").style("display", null), a.select("body").style("cursor", m3.style("cursor")), x2({ type: "brushstart" }), O2();
            }
            return h2.event = function(n4) {
              n4.each(function() {
                var n5 = r3.of(this, arguments), i3 = { x: o2, y: s2, i: t3, j: e3 }, l3 = this.__chart__ || i3;
                this.__chart__ = i3, ea ? a.select(this).transition().each("start.brush", function() {
                  t3 = l3.i, e3 = l3.j, o2 = l3.x, s2 = l3.y, n5({ type: "brushstart" });
                }).tween("brush:brush", function() {
                  var r4 = kr(o2, i3.x), a2 = kr(s2, i3.y);
                  return t3 = e3 = null, function(t4) {
                    o2 = i3.x = r4(t4), s2 = i3.y = a2(t4), n5({ type: "brush", mode: "resize" });
                  };
                }).each("end.brush", function() {
                  t3 = i3.i, e3 = i3.j, n5({ type: "brush", mode: "resize" }), n5({ type: "brushend" });
                }) : (n5({ type: "brushstart" }), n5({ type: "brush", mode: "resize" }), n5({ type: "brushend" }));
              });
            }, h2.x = function(t4) {
              return arguments.length ? (f3 = da[!(n3 = t4) << 1 | !i2], h2) : n3;
            }, h2.y = function(t4) {
              return arguments.length ? (f3 = da[!n3 << 1 | !(i2 = t4)], h2) : i2;
            }, h2.clamp = function(t4) {
              return arguments.length ? (n3 && i2 ? (l2 = !!t4[0], u2 = !!t4[1]) : n3 ? l2 = !!t4 : i2 && (u2 = !!t4), h2) : n3 && i2 ? [l2, u2] : n3 ? l2 : i2 ? u2 : null;
            }, h2.extent = function(r4) {
              var a2, l3, u3, c2, f4;
              return arguments.length ? (n3 && (a2 = r4[0], l3 = r4[1], i2 && (a2 = a2[0], l3 = l3[0]), t3 = [a2, l3], n3.invert && (a2 = n3(a2), l3 = n3(l3)), l3 < a2 && (f4 = a2, a2 = l3, l3 = f4), a2 == o2[0] && l3 == o2[1] || (o2 = [a2, l3])), i2 && (u3 = r4[0], c2 = r4[1], n3 && (u3 = u3[1], c2 = c2[1]), e3 = [u3, c2], i2.invert && (u3 = i2(u3), c2 = i2(c2)), c2 < u3 && (f4 = u3, u3 = c2, c2 = f4), u3 == s2[0] && c2 == s2[1] || (s2 = [u3, c2])), h2) : (n3 && (t3 ? (a2 = t3[0], l3 = t3[1]) : (a2 = o2[0], l3 = o2[1], n3.invert && (a2 = n3.invert(a2), l3 = n3.invert(l3)), l3 < a2 && (f4 = a2, a2 = l3, l3 = f4))), i2 && (e3 ? (u3 = e3[0], c2 = e3[1]) : (u3 = s2[0], c2 = s2[1], i2.invert && (u3 = i2.invert(u3), c2 = i2.invert(c2)), c2 < u3 && (f4 = u3, u3 = c2, c2 = f4))), n3 && i2 ? [[a2, u3], [l3, c2]] : n3 ? [a2, l3] : i2 && [u3, c2]);
            }, h2.clear = function() {
              return h2.empty() || (o2 = [0, 0], s2 = [0, 0], t3 = e3 = null), h2;
            }, h2.empty = function() {
              return !!n3 && o2[0] == o2[1] || !!i2 && s2[0] == s2[1];
            }, a.rebind(h2, r3, "on");
          };
          var pa = { n: "ns-resize", e: "ew-resize", s: "ns-resize", w: "ew-resize", nw: "nwse-resize", ne: "nesw-resize", se: "nwse-resize", sw: "nesw-resize" }, da = [["n", "e", "s", "w", "nw", "ne", "se", "sw"], ["e", "w"], ["n", "s"], []];
          function va(t3) {
            return JSON.parse(t3.responseText);
          }
          function ga(t3) {
            var e3 = l.createRange();
            return e3.selectNode(l.body), e3.createContextualFragment(t3.responseText);
          }
          a.text = ge(function(t3) {
            return t3.responseText;
          }), a.json = function(t3, e3) {
            return ye(t3, "application/json", va, e3);
          }, a.html = function(t3, e3) {
            return ye(t3, "text/html", ga, e3);
          }, a.xml = ge(function(t3) {
            return t3.responseXML;
          }), void 0 === (i = "function" == typeof (n2 = a) ? n2.call(e2, r2, e2, t2) : n2) || (t2.exports = i);
        }).apply(self);
      }, 88294: function(t2, e2, r2) {
        t2.exports = r2(62849);
      }, 62849: function(t2, e2, r2) {
        var n2 = r2(91358), i = r2(53435), a = r2(18863), o = r2(21527), s = r2(71299), l = r2(46775), u = r2(30120), c = r2(64941), f2 = r2(90660), h = r2(27084);
        function p2(t3, e3) {
          for (var r3 = e3[0], n3 = e3[1], a2 = 1 / (e3[2] - r3), o2 = 1 / (e3[3] - n3), s2 = new Array(t3.length), l2 = 0, u2 = t3.length / 2; l2 < u2; l2++)
            s2[2 * l2] = i((t3[2 * l2] - r3) * a2, 0, 1), s2[2 * l2 + 1] = i((t3[2 * l2 + 1] - n3) * o2, 0, 1);
          return s2;
        }
        t2.exports = function(t3, e3) {
          e3 || (e3 = {}), t3 = u(t3, "float64"), e3 = s(e3, { bounds: "range bounds dataBox databox", maxDepth: "depth maxDepth maxdepth level maxLevel maxlevel levels", dtype: "type dtype format out dst output destination" });
          var r3 = l(e3.maxDepth, 255), i2 = l(e3.bounds, o(t3, 2));
          i2[0] === i2[2] && i2[2]++, i2[1] === i2[3] && i2[3]++;
          var d2, v = p2(t3, i2), g2 = t3.length >>> 1;
          e3.dtype || (e3.dtype = "array"), "string" == typeof e3.dtype ? d2 = new (f2(e3.dtype))(g2) : e3.dtype && (d2 = e3.dtype, Array.isArray(d2) && (d2.length = g2));
          for (var y = 0; y < g2; ++y)
            d2[y] = y;
          var m2 = [], x = [], b = [], _ = [];
          !function t4(e4, n3, i3, a2, o2, s2) {
            if (!a2.length)
              return null;
            var l2 = m2[o2] || (m2[o2] = []), u2 = b[o2] || (b[o2] = []), c2 = x[o2] || (x[o2] = []), f3 = l2.length;
            if (++o2 > r3 || s2 > 1073741824) {
              for (var h2 = 0; h2 < a2.length; h2++)
                l2.push(a2[h2]), u2.push(s2), c2.push(null, null, null, null);
              return f3;
            }
            if (l2.push(a2[0]), u2.push(s2), a2.length <= 1)
              return c2.push(null, null, null, null), f3;
            for (var p3 = 0.5 * i3, d3 = e4 + p3, g3 = n3 + p3, y2 = [], _2 = [], w3 = [], T2 = [], k2 = 1, A2 = a2.length; k2 < A2; k2++) {
              var M2 = a2[k2], S2 = v[2 * M2], E2 = v[2 * M2 + 1];
              S2 < d3 ? E2 < g3 ? y2.push(M2) : _2.push(M2) : E2 < g3 ? w3.push(M2) : T2.push(M2);
            }
            return s2 <<= 2, c2.push(t4(e4, n3, p3, y2, o2, s2), t4(e4, g3, p3, _2, o2, s2 + 1), t4(d3, n3, p3, w3, o2, s2 + 2), t4(d3, g3, p3, T2, o2, s2 + 3)), f3;
          }(0, 0, 1, d2, 0, 1);
          for (var w2 = 0, T = 0; T < m2.length; T++) {
            var k = m2[T];
            if (d2.set)
              d2.set(k, w2);
            else
              for (var A = 0, M = k.length; A < M; A++)
                d2[A + w2] = k[A];
            var S = w2 + m2[T].length;
            _[T] = [w2, S], w2 = S;
          }
          return d2.range = function() {
            for (var e4, r4 = [], n3 = arguments.length; n3--; )
              r4[n3] = arguments[n3];
            if (c(r4[r4.length - 1])) {
              var o2 = r4.pop();
              r4.length || null == o2.x && null == o2.l && null == o2.left || (r4 = [o2], e4 = {}), e4 = s(o2, { level: "level maxLevel", d: "d diam diameter r radius px pxSize pixel pixelSize maxD size minSize", lod: "lod details ranges offsets" });
            } else
              e4 = {};
            r4.length || (r4 = i2);
            var u2, f3 = a.apply(void 0, r4), d3 = [Math.min(f3.x, f3.x + f3.width), Math.min(f3.y, f3.y + f3.height), Math.max(f3.x, f3.x + f3.width), Math.max(f3.y, f3.y + f3.height)], v2 = d3[0], g3 = d3[1], y2 = d3[2], b2 = d3[3], _2 = p2([v2, g3, y2, b2], i2), w3 = _2[0], T2 = _2[1], k2 = _2[2], A2 = _2[3], M2 = l(e4.level, m2.length);
            null != e4.d && ("number" == typeof e4.d ? u2 = [e4.d, e4.d] : e4.d.length && (u2 = e4.d), M2 = Math.min(Math.max(Math.ceil(-h(Math.abs(u2[0]) / (i2[2] - i2[0]))), Math.ceil(-h(Math.abs(u2[1]) / (i2[3] - i2[1])))), M2));
            if (M2 = Math.min(M2, m2.length), e4.lod)
              return E(w3, T2, k2, A2, M2);
            var S2 = [];
            function L2(e5, r5, n4, i3, a2, o3) {
              if (null !== a2 && null !== o3 && !(w3 > e5 + n4 || T2 > r5 + n4 || k2 < e5 || A2 < r5 || i3 >= M2 || a2 === o3)) {
                var s2 = m2[i3];
                void 0 === o3 && (o3 = s2.length);
                for (var l2 = a2; l2 < o3; l2++) {
                  var u3 = s2[l2], c2 = t3[2 * u3], f4 = t3[2 * u3 + 1];
                  c2 >= v2 && c2 <= y2 && f4 >= g3 && f4 <= b2 && S2.push(u3);
                }
                var h2 = x[i3], p3 = h2[4 * a2 + 0], d4 = h2[4 * a2 + 1], _3 = h2[4 * a2 + 2], E2 = h2[4 * a2 + 3], P = C(h2, a2 + 1), O = 0.5 * n4, I = i3 + 1;
                L2(e5, r5, O, I, p3, d4 || _3 || E2 || P), L2(e5, r5 + O, O, I, d4, _3 || E2 || P), L2(e5 + O, r5, O, I, _3, E2 || P), L2(e5 + O, r5 + O, O, I, E2, P);
              }
            }
            function C(t4, e5) {
              for (var r5 = null, n4 = 0; null === r5; )
                if (r5 = t4[4 * e5 + n4], ++n4 > t4.length)
                  return null;
              return r5;
            }
            return L2(0, 0, 1, 0, 0, 1), S2;
          }, d2;
          function E(t4, e4, r4, i3, a2) {
            for (var o2 = [], s2 = 0; s2 < a2; s2++) {
              var l2 = b[s2], u2 = _[s2][0], c2 = L(t4, e4, s2), f3 = L(r4, i3, s2), h2 = n2.ge(l2, c2), p3 = n2.gt(l2, f3, h2, l2.length - 1);
              o2[s2] = [h2 + u2, p3 + u2];
            }
            return o2;
          }
          function L(t4, e4, r4) {
            for (var n3 = 1, i3 = 0.5, a2 = 0.5, o2 = 0.5, s2 = 0; s2 < r4; s2++)
              n3 <<= 2, n3 += t4 < i3 ? e4 < a2 ? 0 : 1 : e4 < a2 ? 2 : 3, o2 *= 0.5, i3 += t4 < i3 ? -o2 : o2, a2 += e4 < a2 ? -o2 : o2;
            return n3;
          }
        };
      }, 30774: function(t2, e2, r2) {
        Object.defineProperty(e2, "__esModule", { value: true });
        var n2 = r2(60302), i = 6378137;
        function a(t3) {
          var e3 = 0;
          if (t3 && t3.length > 0) {
            e3 += Math.abs(o(t3[0]));
            for (var r3 = 1; r3 < t3.length; r3++)
              e3 -= Math.abs(o(t3[r3]));
          }
          return e3;
        }
        function o(t3) {
          var e3, r3, n3, a2, o2, l, u = 0, c = t3.length;
          if (c > 2) {
            for (l = 0; l < c; l++)
              l === c - 2 ? (n3 = c - 2, a2 = c - 1, o2 = 0) : l === c - 1 ? (n3 = c - 1, a2 = 0, o2 = 1) : (n3 = l, a2 = l + 1, o2 = l + 2), e3 = t3[n3], r3 = t3[a2], u += (s(t3[o2][0]) - s(e3[0])) * Math.sin(s(r3[1]));
            u = u * i * i / 2;
          }
          return u;
        }
        function s(t3) {
          return t3 * Math.PI / 180;
        }
        e2.default = function(t3) {
          return n2.geomReduce(t3, function(t4, e3) {
            return t4 + function(t5) {
              var e4, r3 = 0;
              switch (t5.type) {
                case "Polygon":
                  return a(t5.coordinates);
                case "MultiPolygon":
                  for (e4 = 0; e4 < t5.coordinates.length; e4++)
                    r3 += a(t5.coordinates[e4]);
                  return r3;
                case "Point":
                case "MultiPoint":
                case "LineString":
                case "MultiLineString":
                  return 0;
              }
              return 0;
            }(e3);
          }, 0);
        };
      }, 23132: function(t2, e2) {
        function r2(t3, e3, r3) {
          void 0 === r3 && (r3 = {});
          var n3 = { type: "Feature" };
          return (0 === r3.id || r3.id) && (n3.id = r3.id), r3.bbox && (n3.bbox = r3.bbox), n3.properties = e3 || {}, n3.geometry = t3, n3;
        }
        function n2(t3, e3, n3) {
          if (void 0 === n3 && (n3 = {}), !t3)
            throw new Error("coordinates is required");
          if (!Array.isArray(t3))
            throw new Error("coordinates must be an Array");
          if (t3.length < 2)
            throw new Error("coordinates must be at least 2 numbers long");
          if (!p2(t3[0]) || !p2(t3[1]))
            throw new Error("coordinates must contain numbers");
          return r2({ type: "Point", coordinates: t3 }, e3, n3);
        }
        function i(t3, e3, n3) {
          void 0 === n3 && (n3 = {});
          for (var i2 = 0, a2 = t3; i2 < a2.length; i2++) {
            var o2 = a2[i2];
            if (o2.length < 4)
              throw new Error("Each LinearRing of a Polygon must have 4 or more Positions.");
            for (var s2 = 0; s2 < o2[o2.length - 1].length; s2++)
              if (o2[o2.length - 1][s2] !== o2[0][s2])
                throw new Error("First and last Position are not equivalent.");
          }
          return r2({ type: "Polygon", coordinates: t3 }, e3, n3);
        }
        function a(t3, e3, n3) {
          if (void 0 === n3 && (n3 = {}), t3.length < 2)
            throw new Error("coordinates must be an array of two or more positions");
          return r2({ type: "LineString", coordinates: t3 }, e3, n3);
        }
        function o(t3, e3) {
          void 0 === e3 && (e3 = {});
          var r3 = { type: "FeatureCollection" };
          return e3.id && (r3.id = e3.id), e3.bbox && (r3.bbox = e3.bbox), r3.features = t3, r3;
        }
        function s(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "MultiLineString", coordinates: t3 }, e3, n3);
        }
        function l(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "MultiPoint", coordinates: t3 }, e3, n3);
        }
        function u(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "MultiPolygon", coordinates: t3 }, e3, n3);
        }
        function c(t3, r3) {
          void 0 === r3 && (r3 = "kilometers");
          var n3 = e2.factors[r3];
          if (!n3)
            throw new Error(r3 + " units is invalid");
          return t3 * n3;
        }
        function f2(t3, r3) {
          void 0 === r3 && (r3 = "kilometers");
          var n3 = e2.factors[r3];
          if (!n3)
            throw new Error(r3 + " units is invalid");
          return t3 / n3;
        }
        function h(t3) {
          return t3 % (2 * Math.PI) * 180 / Math.PI;
        }
        function p2(t3) {
          return !isNaN(t3) && null !== t3 && !Array.isArray(t3);
        }
        Object.defineProperty(e2, "__esModule", { value: true }), e2.earthRadius = 63710088e-1, e2.factors = { centimeters: 100 * e2.earthRadius, centimetres: 100 * e2.earthRadius, degrees: e2.earthRadius / 111325, feet: 3.28084 * e2.earthRadius, inches: 39.37 * e2.earthRadius, kilometers: e2.earthRadius / 1e3, kilometres: e2.earthRadius / 1e3, meters: e2.earthRadius, metres: e2.earthRadius, miles: e2.earthRadius / 1609.344, millimeters: 1e3 * e2.earthRadius, millimetres: 1e3 * e2.earthRadius, nauticalmiles: e2.earthRadius / 1852, radians: 1, yards: 1.0936 * e2.earthRadius }, e2.unitsFactors = { centimeters: 100, centimetres: 100, degrees: 1 / 111325, feet: 3.28084, inches: 39.37, kilometers: 1e-3, kilometres: 1e-3, meters: 1, metres: 1, miles: 1 / 1609.344, millimeters: 1e3, millimetres: 1e3, nauticalmiles: 1 / 1852, radians: 1 / e2.earthRadius, yards: 1.0936133 }, e2.areaFactors = { acres: 247105e-9, centimeters: 1e4, centimetres: 1e4, feet: 10.763910417, hectares: 1e-4, inches: 1550.003100006, kilometers: 1e-6, kilometres: 1e-6, meters: 1, metres: 1, miles: 386e-9, millimeters: 1e6, millimetres: 1e6, yards: 1.195990046 }, e2.feature = r2, e2.geometry = function(t3, e3, r3) {
          switch (t3) {
            case "Point":
              return n2(e3).geometry;
            case "LineString":
              return a(e3).geometry;
            case "Polygon":
              return i(e3).geometry;
            case "MultiPoint":
              return l(e3).geometry;
            case "MultiLineString":
              return s(e3).geometry;
            case "MultiPolygon":
              return u(e3).geometry;
            default:
              throw new Error(t3 + " is invalid");
          }
        }, e2.point = n2, e2.points = function(t3, e3, r3) {
          return void 0 === r3 && (r3 = {}), o(t3.map(function(t4) {
            return n2(t4, e3);
          }), r3);
        }, e2.polygon = i, e2.polygons = function(t3, e3, r3) {
          return void 0 === r3 && (r3 = {}), o(t3.map(function(t4) {
            return i(t4, e3);
          }), r3);
        }, e2.lineString = a, e2.lineStrings = function(t3, e3, r3) {
          return void 0 === r3 && (r3 = {}), o(t3.map(function(t4) {
            return a(t4, e3);
          }), r3);
        }, e2.featureCollection = o, e2.multiLineString = s, e2.multiPoint = l, e2.multiPolygon = u, e2.geometryCollection = function(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "GeometryCollection", geometries: t3 }, e3, n3);
        }, e2.round = function(t3, e3) {
          if (void 0 === e3 && (e3 = 0), e3 && !(e3 >= 0))
            throw new Error("precision must be a positive number");
          var r3 = Math.pow(10, e3 || 0);
          return Math.round(t3 * r3) / r3;
        }, e2.radiansToLength = c, e2.lengthToRadians = f2, e2.lengthToDegrees = function(t3, e3) {
          return h(f2(t3, e3));
        }, e2.bearingToAzimuth = function(t3) {
          var e3 = t3 % 360;
          return e3 < 0 && (e3 += 360), e3;
        }, e2.radiansToDegrees = h, e2.degreesToRadians = function(t3) {
          return t3 % 360 * Math.PI / 180;
        }, e2.convertLength = function(t3, e3, r3) {
          if (void 0 === e3 && (e3 = "kilometers"), void 0 === r3 && (r3 = "kilometers"), !(t3 >= 0))
            throw new Error("length must be a positive number");
          return c(f2(t3, e3), r3);
        }, e2.convertArea = function(t3, r3, n3) {
          if (void 0 === r3 && (r3 = "meters"), void 0 === n3 && (n3 = "kilometers"), !(t3 >= 0))
            throw new Error("area must be a positive number");
          var i2 = e2.areaFactors[r3];
          if (!i2)
            throw new Error("invalid original units");
          var a2 = e2.areaFactors[n3];
          if (!a2)
            throw new Error("invalid final units");
          return t3 / i2 * a2;
        }, e2.isNumber = p2, e2.isObject = function(t3) {
          return !!t3 && t3.constructor === Object;
        }, e2.validateBBox = function(t3) {
          if (!t3)
            throw new Error("bbox is required");
          if (!Array.isArray(t3))
            throw new Error("bbox must be an Array");
          if (4 !== t3.length && 6 !== t3.length)
            throw new Error("bbox must be an Array of 4 or 6 numbers");
          t3.forEach(function(t4) {
            if (!p2(t4))
              throw new Error("bbox must only contain numbers");
          });
        }, e2.validateId = function(t3) {
          if (!t3)
            throw new Error("id is required");
          if (-1 === ["string", "number"].indexOf(typeof t3))
            throw new Error("id must be a number or a string");
        };
      }, 60302: function(t2, e2, r2) {
        Object.defineProperty(e2, "__esModule", { value: true });
        var n2 = r2(23132);
        function i(t3, e3, r3) {
          if (null !== t3)
            for (var n3, a2, o2, s2, l2, u2, c2, f2, h = 0, p2 = 0, d2 = t3.type, v = "FeatureCollection" === d2, g2 = "Feature" === d2, y = v ? t3.features.length : 1, m2 = 0; m2 < y; m2++) {
              l2 = (f2 = !!(c2 = v ? t3.features[m2].geometry : g2 ? t3.geometry : t3) && "GeometryCollection" === c2.type) ? c2.geometries.length : 1;
              for (var x = 0; x < l2; x++) {
                var b = 0, _ = 0;
                if (null !== (s2 = f2 ? c2.geometries[x] : c2)) {
                  u2 = s2.coordinates;
                  var w2 = s2.type;
                  switch (h = !r3 || "Polygon" !== w2 && "MultiPolygon" !== w2 ? 0 : 1, w2) {
                    case null:
                      break;
                    case "Point":
                      if (false === e3(u2, p2, m2, b, _))
                        return false;
                      p2++, b++;
                      break;
                    case "LineString":
                    case "MultiPoint":
                      for (n3 = 0; n3 < u2.length; n3++) {
                        if (false === e3(u2[n3], p2, m2, b, _))
                          return false;
                        p2++, "MultiPoint" === w2 && b++;
                      }
                      "LineString" === w2 && b++;
                      break;
                    case "Polygon":
                    case "MultiLineString":
                      for (n3 = 0; n3 < u2.length; n3++) {
                        for (a2 = 0; a2 < u2[n3].length - h; a2++) {
                          if (false === e3(u2[n3][a2], p2, m2, b, _))
                            return false;
                          p2++;
                        }
                        "MultiLineString" === w2 && b++, "Polygon" === w2 && _++;
                      }
                      "Polygon" === w2 && b++;
                      break;
                    case "MultiPolygon":
                      for (n3 = 0; n3 < u2.length; n3++) {
                        for (_ = 0, a2 = 0; a2 < u2[n3].length; a2++) {
                          for (o2 = 0; o2 < u2[n3][a2].length - h; o2++) {
                            if (false === e3(u2[n3][a2][o2], p2, m2, b, _))
                              return false;
                            p2++;
                          }
                          _++;
                        }
                        b++;
                      }
                      break;
                    case "GeometryCollection":
                      for (n3 = 0; n3 < s2.geometries.length; n3++)
                        if (false === i(s2.geometries[n3], e3, r3))
                          return false;
                      break;
                    default:
                      throw new Error("Unknown Geometry Type");
                  }
                }
              }
            }
        }
        function a(t3, e3) {
          var r3;
          switch (t3.type) {
            case "FeatureCollection":
              for (r3 = 0; r3 < t3.features.length && false !== e3(t3.features[r3].properties, r3); r3++)
                ;
              break;
            case "Feature":
              e3(t3.properties, 0);
          }
        }
        function o(t3, e3) {
          if ("Feature" === t3.type)
            e3(t3, 0);
          else if ("FeatureCollection" === t3.type)
            for (var r3 = 0; r3 < t3.features.length && false !== e3(t3.features[r3], r3); r3++)
              ;
        }
        function s(t3, e3) {
          var r3, n3, i2, a2, o2, s2, l2, u2, c2, f2, h = 0, p2 = "FeatureCollection" === t3.type, d2 = "Feature" === t3.type, v = p2 ? t3.features.length : 1;
          for (r3 = 0; r3 < v; r3++) {
            for (s2 = p2 ? t3.features[r3].geometry : d2 ? t3.geometry : t3, u2 = p2 ? t3.features[r3].properties : d2 ? t3.properties : {}, c2 = p2 ? t3.features[r3].bbox : d2 ? t3.bbox : void 0, f2 = p2 ? t3.features[r3].id : d2 ? t3.id : void 0, o2 = (l2 = !!s2 && "GeometryCollection" === s2.type) ? s2.geometries.length : 1, i2 = 0; i2 < o2; i2++)
              if (null !== (a2 = l2 ? s2.geometries[i2] : s2))
                switch (a2.type) {
                  case "Point":
                  case "LineString":
                  case "MultiPoint":
                  case "Polygon":
                  case "MultiLineString":
                  case "MultiPolygon":
                    if (false === e3(a2, h, u2, c2, f2))
                      return false;
                    break;
                  case "GeometryCollection":
                    for (n3 = 0; n3 < a2.geometries.length; n3++)
                      if (false === e3(a2.geometries[n3], h, u2, c2, f2))
                        return false;
                    break;
                  default:
                    throw new Error("Unknown Geometry Type");
                }
              else if (false === e3(null, h, u2, c2, f2))
                return false;
            h++;
          }
        }
        function l(t3, e3) {
          s(t3, function(t4, r3, i2, a2, o2) {
            var s2, l2 = null === t4 ? null : t4.type;
            switch (l2) {
              case null:
              case "Point":
              case "LineString":
              case "Polygon":
                return false !== e3(n2.feature(t4, i2, { bbox: a2, id: o2 }), r3, 0) && void 0;
            }
            switch (l2) {
              case "MultiPoint":
                s2 = "Point";
                break;
              case "MultiLineString":
                s2 = "LineString";
                break;
              case "MultiPolygon":
                s2 = "Polygon";
            }
            for (var u2 = 0; u2 < t4.coordinates.length; u2++) {
              var c2 = { type: s2, coordinates: t4.coordinates[u2] };
              if (false === e3(n2.feature(c2, i2), r3, u2))
                return false;
            }
          });
        }
        function u(t3, e3) {
          l(t3, function(t4, r3, a2) {
            var o2 = 0;
            if (t4.geometry) {
              var s2 = t4.geometry.type;
              if ("Point" !== s2 && "MultiPoint" !== s2) {
                var l2, u2 = 0, c2 = 0, f2 = 0;
                return false !== i(t4, function(i2, s3, h, p2, d2) {
                  if (void 0 === l2 || r3 > u2 || p2 > c2 || d2 > f2)
                    return l2 = i2, u2 = r3, c2 = p2, f2 = d2, void (o2 = 0);
                  var v = n2.lineString([l2, i2], t4.properties);
                  if (false === e3(v, r3, a2, d2, o2))
                    return false;
                  o2++, l2 = i2;
                }) && void 0;
              }
            }
          });
        }
        function c(t3, e3) {
          if (!t3)
            throw new Error("geojson is required");
          l(t3, function(t4, r3, i2) {
            if (null !== t4.geometry) {
              var a2 = t4.geometry.type, o2 = t4.geometry.coordinates;
              switch (a2) {
                case "LineString":
                  if (false === e3(t4, r3, i2, 0, 0))
                    return false;
                  break;
                case "Polygon":
                  for (var s2 = 0; s2 < o2.length; s2++)
                    if (false === e3(n2.lineString(o2[s2], t4.properties), r3, i2, s2))
                      return false;
              }
            }
          });
        }
        e2.coordEach = i, e2.coordReduce = function(t3, e3, r3, n3) {
          var a2 = r3;
          return i(t3, function(t4, n4, i2, o2, s2) {
            a2 = 0 === n4 && void 0 === r3 ? t4 : e3(a2, t4, n4, i2, o2, s2);
          }, n3), a2;
        }, e2.propEach = a, e2.propReduce = function(t3, e3, r3) {
          var n3 = r3;
          return a(t3, function(t4, i2) {
            n3 = 0 === i2 && void 0 === r3 ? t4 : e3(n3, t4, i2);
          }), n3;
        }, e2.featureEach = o, e2.featureReduce = function(t3, e3, r3) {
          var n3 = r3;
          return o(t3, function(t4, i2) {
            n3 = 0 === i2 && void 0 === r3 ? t4 : e3(n3, t4, i2);
          }), n3;
        }, e2.coordAll = function(t3) {
          var e3 = [];
          return i(t3, function(t4) {
            e3.push(t4);
          }), e3;
        }, e2.geomEach = s, e2.geomReduce = function(t3, e3, r3) {
          var n3 = r3;
          return s(t3, function(t4, i2, a2, o2, s2) {
            n3 = 0 === i2 && void 0 === r3 ? t4 : e3(n3, t4, i2, a2, o2, s2);
          }), n3;
        }, e2.flattenEach = l, e2.flattenReduce = function(t3, e3, r3) {
          var n3 = r3;
          return l(t3, function(t4, i2, a2) {
            n3 = 0 === i2 && 0 === a2 && void 0 === r3 ? t4 : e3(n3, t4, i2, a2);
          }), n3;
        }, e2.segmentEach = u, e2.segmentReduce = function(t3, e3, r3) {
          var n3 = r3, i2 = false;
          return u(t3, function(t4, a2, o2, s2, l2) {
            n3 = false === i2 && void 0 === r3 ? t4 : e3(n3, t4, a2, o2, s2, l2), i2 = true;
          }), n3;
        }, e2.lineEach = c, e2.lineReduce = function(t3, e3, r3) {
          var n3 = r3;
          return c(t3, function(t4, i2, a2, o2) {
            n3 = 0 === i2 && void 0 === r3 ? t4 : e3(n3, t4, i2, a2, o2);
          }), n3;
        }, e2.findSegment = function(t3, e3) {
          if (e3 = e3 || {}, !n2.isObject(e3))
            throw new Error("options is invalid");
          var r3, i2 = e3.featureIndex || 0, a2 = e3.multiFeatureIndex || 0, o2 = e3.geometryIndex || 0, s2 = e3.segmentIndex || 0, l2 = e3.properties;
          switch (t3.type) {
            case "FeatureCollection":
              i2 < 0 && (i2 = t3.features.length + i2), l2 = l2 || t3.features[i2].properties, r3 = t3.features[i2].geometry;
              break;
            case "Feature":
              l2 = l2 || t3.properties, r3 = t3.geometry;
              break;
            case "Point":
            case "MultiPoint":
              return null;
            case "LineString":
            case "Polygon":
            case "MultiLineString":
            case "MultiPolygon":
              r3 = t3;
              break;
            default:
              throw new Error("geojson is invalid");
          }
          if (null === r3)
            return null;
          var u2 = r3.coordinates;
          switch (r3.type) {
            case "Point":
            case "MultiPoint":
              return null;
            case "LineString":
              return s2 < 0 && (s2 = u2.length + s2 - 1), n2.lineString([u2[s2], u2[s2 + 1]], l2, e3);
            case "Polygon":
              return o2 < 0 && (o2 = u2.length + o2), s2 < 0 && (s2 = u2[o2].length + s2 - 1), n2.lineString([u2[o2][s2], u2[o2][s2 + 1]], l2, e3);
            case "MultiLineString":
              return a2 < 0 && (a2 = u2.length + a2), s2 < 0 && (s2 = u2[a2].length + s2 - 1), n2.lineString([u2[a2][s2], u2[a2][s2 + 1]], l2, e3);
            case "MultiPolygon":
              return a2 < 0 && (a2 = u2.length + a2), o2 < 0 && (o2 = u2[a2].length + o2), s2 < 0 && (s2 = u2[a2][o2].length - s2 - 1), n2.lineString([u2[a2][o2][s2], u2[a2][o2][s2 + 1]], l2, e3);
          }
          throw new Error("geojson is invalid");
        }, e2.findPoint = function(t3, e3) {
          if (e3 = e3 || {}, !n2.isObject(e3))
            throw new Error("options is invalid");
          var r3, i2 = e3.featureIndex || 0, a2 = e3.multiFeatureIndex || 0, o2 = e3.geometryIndex || 0, s2 = e3.coordIndex || 0, l2 = e3.properties;
          switch (t3.type) {
            case "FeatureCollection":
              i2 < 0 && (i2 = t3.features.length + i2), l2 = l2 || t3.features[i2].properties, r3 = t3.features[i2].geometry;
              break;
            case "Feature":
              l2 = l2 || t3.properties, r3 = t3.geometry;
              break;
            case "Point":
            case "MultiPoint":
              return null;
            case "LineString":
            case "Polygon":
            case "MultiLineString":
            case "MultiPolygon":
              r3 = t3;
              break;
            default:
              throw new Error("geojson is invalid");
          }
          if (null === r3)
            return null;
          var u2 = r3.coordinates;
          switch (r3.type) {
            case "Point":
              return n2.point(u2, l2, e3);
            case "MultiPoint":
              return a2 < 0 && (a2 = u2.length + a2), n2.point(u2[a2], l2, e3);
            case "LineString":
              return s2 < 0 && (s2 = u2.length + s2), n2.point(u2[s2], l2, e3);
            case "Polygon":
              return o2 < 0 && (o2 = u2.length + o2), s2 < 0 && (s2 = u2[o2].length + s2), n2.point(u2[o2][s2], l2, e3);
            case "MultiLineString":
              return a2 < 0 && (a2 = u2.length + a2), s2 < 0 && (s2 = u2[a2].length + s2), n2.point(u2[a2][s2], l2, e3);
            case "MultiPolygon":
              return a2 < 0 && (a2 = u2.length + a2), o2 < 0 && (o2 = u2[a2].length + o2), s2 < 0 && (s2 = u2[a2][o2].length - s2), n2.point(u2[a2][o2][s2], l2, e3);
          }
          throw new Error("geojson is invalid");
        };
      }, 85268: function(t2, e2, r2) {
        Object.defineProperty(e2, "__esModule", { value: true });
        var n2 = r2(27138);
        function i(t3) {
          var e3 = [1 / 0, 1 / 0, -1 / 0, -1 / 0];
          return n2.coordEach(t3, function(t4) {
            e3[0] > t4[0] && (e3[0] = t4[0]), e3[1] > t4[1] && (e3[1] = t4[1]), e3[2] < t4[0] && (e3[2] = t4[0]), e3[3] < t4[1] && (e3[3] = t4[1]);
          }), e3;
        }
        i.default = i, e2.default = i;
      }, 94228: function(t2, e2) {
        function r2(t3, e3, r3) {
          void 0 === r3 && (r3 = {});
          var n3 = { type: "Feature" };
          return (0 === r3.id || r3.id) && (n3.id = r3.id), r3.bbox && (n3.bbox = r3.bbox), n3.properties = e3 || {}, n3.geometry = t3, n3;
        }
        function n2(t3, e3, n3) {
          if (void 0 === n3 && (n3 = {}), !t3)
            throw new Error("coordinates is required");
          if (!Array.isArray(t3))
            throw new Error("coordinates must be an Array");
          if (t3.length < 2)
            throw new Error("coordinates must be at least 2 numbers long");
          if (!p2(t3[0]) || !p2(t3[1]))
            throw new Error("coordinates must contain numbers");
          return r2({ type: "Point", coordinates: t3 }, e3, n3);
        }
        function i(t3, e3, n3) {
          void 0 === n3 && (n3 = {});
          for (var i2 = 0, a2 = t3; i2 < a2.length; i2++) {
            var o2 = a2[i2];
            if (o2.length < 4)
              throw new Error("Each LinearRing of a Polygon must have 4 or more Positions.");
            for (var s2 = 0; s2 < o2[o2.length - 1].length; s2++)
              if (o2[o2.length - 1][s2] !== o2[0][s2])
                throw new Error("First and last Position are not equivalent.");
          }
          return r2({ type: "Polygon", coordinates: t3 }, e3, n3);
        }
        function a(t3, e3, n3) {
          if (void 0 === n3 && (n3 = {}), t3.length < 2)
            throw new Error("coordinates must be an array of two or more positions");
          return r2({ type: "LineString", coordinates: t3 }, e3, n3);
        }
        function o(t3, e3) {
          void 0 === e3 && (e3 = {});
          var r3 = { type: "FeatureCollection" };
          return e3.id && (r3.id = e3.id), e3.bbox && (r3.bbox = e3.bbox), r3.features = t3, r3;
        }
        function s(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "MultiLineString", coordinates: t3 }, e3, n3);
        }
        function l(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "MultiPoint", coordinates: t3 }, e3, n3);
        }
        function u(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "MultiPolygon", coordinates: t3 }, e3, n3);
        }
        function c(t3, r3) {
          void 0 === r3 && (r3 = "kilometers");
          var n3 = e2.factors[r3];
          if (!n3)
            throw new Error(r3 + " units is invalid");
          return t3 * n3;
        }
        function f2(t3, r3) {
          void 0 === r3 && (r3 = "kilometers");
          var n3 = e2.factors[r3];
          if (!n3)
            throw new Error(r3 + " units is invalid");
          return t3 / n3;
        }
        function h(t3) {
          return t3 % (2 * Math.PI) * 180 / Math.PI;
        }
        function p2(t3) {
          return !isNaN(t3) && null !== t3 && !Array.isArray(t3);
        }
        Object.defineProperty(e2, "__esModule", { value: true }), e2.earthRadius = 63710088e-1, e2.factors = { centimeters: 100 * e2.earthRadius, centimetres: 100 * e2.earthRadius, degrees: e2.earthRadius / 111325, feet: 3.28084 * e2.earthRadius, inches: 39.37 * e2.earthRadius, kilometers: e2.earthRadius / 1e3, kilometres: e2.earthRadius / 1e3, meters: e2.earthRadius, metres: e2.earthRadius, miles: e2.earthRadius / 1609.344, millimeters: 1e3 * e2.earthRadius, millimetres: 1e3 * e2.earthRadius, nauticalmiles: e2.earthRadius / 1852, radians: 1, yards: 1.0936 * e2.earthRadius }, e2.unitsFactors = { centimeters: 100, centimetres: 100, degrees: 1 / 111325, feet: 3.28084, inches: 39.37, kilometers: 1e-3, kilometres: 1e-3, meters: 1, metres: 1, miles: 1 / 1609.344, millimeters: 1e3, millimetres: 1e3, nauticalmiles: 1 / 1852, radians: 1 / e2.earthRadius, yards: 1.0936133 }, e2.areaFactors = { acres: 247105e-9, centimeters: 1e4, centimetres: 1e4, feet: 10.763910417, hectares: 1e-4, inches: 1550.003100006, kilometers: 1e-6, kilometres: 1e-6, meters: 1, metres: 1, miles: 386e-9, millimeters: 1e6, millimetres: 1e6, yards: 1.195990046 }, e2.feature = r2, e2.geometry = function(t3, e3, r3) {
          switch (t3) {
            case "Point":
              return n2(e3).geometry;
            case "LineString":
              return a(e3).geometry;
            case "Polygon":
              return i(e3).geometry;
            case "MultiPoint":
              return l(e3).geometry;
            case "MultiLineString":
              return s(e3).geometry;
            case "MultiPolygon":
              return u(e3).geometry;
            default:
              throw new Error(t3 + " is invalid");
          }
        }, e2.point = n2, e2.points = function(t3, e3, r3) {
          return void 0 === r3 && (r3 = {}), o(t3.map(function(t4) {
            return n2(t4, e3);
          }), r3);
        }, e2.polygon = i, e2.polygons = function(t3, e3, r3) {
          return void 0 === r3 && (r3 = {}), o(t3.map(function(t4) {
            return i(t4, e3);
          }), r3);
        }, e2.lineString = a, e2.lineStrings = function(t3, e3, r3) {
          return void 0 === r3 && (r3 = {}), o(t3.map(function(t4) {
            return a(t4, e3);
          }), r3);
        }, e2.featureCollection = o, e2.multiLineString = s, e2.multiPoint = l, e2.multiPolygon = u, e2.geometryCollection = function(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "GeometryCollection", geometries: t3 }, e3, n3);
        }, e2.round = function(t3, e3) {
          if (void 0 === e3 && (e3 = 0), e3 && !(e3 >= 0))
            throw new Error("precision must be a positive number");
          var r3 = Math.pow(10, e3 || 0);
          return Math.round(t3 * r3) / r3;
        }, e2.radiansToLength = c, e2.lengthToRadians = f2, e2.lengthToDegrees = function(t3, e3) {
          return h(f2(t3, e3));
        }, e2.bearingToAzimuth = function(t3) {
          var e3 = t3 % 360;
          return e3 < 0 && (e3 += 360), e3;
        }, e2.radiansToDegrees = h, e2.degreesToRadians = function(t3) {
          return t3 % 360 * Math.PI / 180;
        }, e2.convertLength = function(t3, e3, r3) {
          if (void 0 === e3 && (e3 = "kilometers"), void 0 === r3 && (r3 = "kilometers"), !(t3 >= 0))
            throw new Error("length must be a positive number");
          return c(f2(t3, e3), r3);
        }, e2.convertArea = function(t3, r3, n3) {
          if (void 0 === r3 && (r3 = "meters"), void 0 === n3 && (n3 = "kilometers"), !(t3 >= 0))
            throw new Error("area must be a positive number");
          var i2 = e2.areaFactors[r3];
          if (!i2)
            throw new Error("invalid original units");
          var a2 = e2.areaFactors[n3];
          if (!a2)
            throw new Error("invalid final units");
          return t3 / i2 * a2;
        }, e2.isNumber = p2, e2.isObject = function(t3) {
          return !!t3 && t3.constructor === Object;
        }, e2.validateBBox = function(t3) {
          if (!t3)
            throw new Error("bbox is required");
          if (!Array.isArray(t3))
            throw new Error("bbox must be an Array");
          if (4 !== t3.length && 6 !== t3.length)
            throw new Error("bbox must be an Array of 4 or 6 numbers");
          t3.forEach(function(t4) {
            if (!p2(t4))
              throw new Error("bbox must only contain numbers");
          });
        }, e2.validateId = function(t3) {
          if (!t3)
            throw new Error("id is required");
          if (-1 === ["string", "number"].indexOf(typeof t3))
            throw new Error("id must be a number or a string");
        };
      }, 27138: function(t2, e2, r2) {
        Object.defineProperty(e2, "__esModule", { value: true });
        var n2 = r2(94228);
        function i(t3, e3, r3) {
          if (null !== t3)
            for (var n3, a2, o2, s2, l2, u2, c2, f2, h = 0, p2 = 0, d2 = t3.type, v = "FeatureCollection" === d2, g2 = "Feature" === d2, y = v ? t3.features.length : 1, m2 = 0; m2 < y; m2++) {
              l2 = (f2 = !!(c2 = v ? t3.features[m2].geometry : g2 ? t3.geometry : t3) && "GeometryCollection" === c2.type) ? c2.geometries.length : 1;
              for (var x = 0; x < l2; x++) {
                var b = 0, _ = 0;
                if (null !== (s2 = f2 ? c2.geometries[x] : c2)) {
                  u2 = s2.coordinates;
                  var w2 = s2.type;
                  switch (h = !r3 || "Polygon" !== w2 && "MultiPolygon" !== w2 ? 0 : 1, w2) {
                    case null:
                      break;
                    case "Point":
                      if (false === e3(u2, p2, m2, b, _))
                        return false;
                      p2++, b++;
                      break;
                    case "LineString":
                    case "MultiPoint":
                      for (n3 = 0; n3 < u2.length; n3++) {
                        if (false === e3(u2[n3], p2, m2, b, _))
                          return false;
                        p2++, "MultiPoint" === w2 && b++;
                      }
                      "LineString" === w2 && b++;
                      break;
                    case "Polygon":
                    case "MultiLineString":
                      for (n3 = 0; n3 < u2.length; n3++) {
                        for (a2 = 0; a2 < u2[n3].length - h; a2++) {
                          if (false === e3(u2[n3][a2], p2, m2, b, _))
                            return false;
                          p2++;
                        }
                        "MultiLineString" === w2 && b++, "Polygon" === w2 && _++;
                      }
                      "Polygon" === w2 && b++;
                      break;
                    case "MultiPolygon":
                      for (n3 = 0; n3 < u2.length; n3++) {
                        for (_ = 0, a2 = 0; a2 < u2[n3].length; a2++) {
                          for (o2 = 0; o2 < u2[n3][a2].length - h; o2++) {
                            if (false === e3(u2[n3][a2][o2], p2, m2, b, _))
                              return false;
                            p2++;
                          }
                          _++;
                        }
                        b++;
                      }
                      break;
                    case "GeometryCollection":
                      for (n3 = 0; n3 < s2.geometries.length; n3++)
                        if (false === i(s2.geometries[n3], e3, r3))
                          return false;
                      break;
                    default:
                      throw new Error("Unknown Geometry Type");
                  }
                }
              }
            }
        }
        function a(t3, e3) {
          var r3;
          switch (t3.type) {
            case "FeatureCollection":
              for (r3 = 0; r3 < t3.features.length && false !== e3(t3.features[r3].properties, r3); r3++)
                ;
              break;
            case "Feature":
              e3(t3.properties, 0);
          }
        }
        function o(t3, e3) {
          if ("Feature" === t3.type)
            e3(t3, 0);
          else if ("FeatureCollection" === t3.type)
            for (var r3 = 0; r3 < t3.features.length && false !== e3(t3.features[r3], r3); r3++)
              ;
        }
        function s(t3, e3) {
          var r3, n3, i2, a2, o2, s2, l2, u2, c2, f2, h = 0, p2 = "FeatureCollection" === t3.type, d2 = "Feature" === t3.type, v = p2 ? t3.features.length : 1;
          for (r3 = 0; r3 < v; r3++) {
            for (s2 = p2 ? t3.features[r3].geometry : d2 ? t3.geometry : t3, u2 = p2 ? t3.features[r3].properties : d2 ? t3.properties : {}, c2 = p2 ? t3.features[r3].bbox : d2 ? t3.bbox : void 0, f2 = p2 ? t3.features[r3].id : d2 ? t3.id : void 0, o2 = (l2 = !!s2 && "GeometryCollection" === s2.type) ? s2.geometries.length : 1, i2 = 0; i2 < o2; i2++)
              if (null !== (a2 = l2 ? s2.geometries[i2] : s2))
                switch (a2.type) {
                  case "Point":
                  case "LineString":
                  case "MultiPoint":
                  case "Polygon":
                  case "MultiLineString":
                  case "MultiPolygon":
                    if (false === e3(a2, h, u2, c2, f2))
                      return false;
                    break;
                  case "GeometryCollection":
                    for (n3 = 0; n3 < a2.geometries.length; n3++)
                      if (false === e3(a2.geometries[n3], h, u2, c2, f2))
                        return false;
                    break;
                  default:
                    throw new Error("Unknown Geometry Type");
                }
              else if (false === e3(null, h, u2, c2, f2))
                return false;
            h++;
          }
        }
        function l(t3, e3) {
          s(t3, function(t4, r3, i2, a2, o2) {
            var s2, l2 = null === t4 ? null : t4.type;
            switch (l2) {
              case null:
              case "Point":
              case "LineString":
              case "Polygon":
                return false !== e3(n2.feature(t4, i2, { bbox: a2, id: o2 }), r3, 0) && void 0;
            }
            switch (l2) {
              case "MultiPoint":
                s2 = "Point";
                break;
              case "MultiLineString":
                s2 = "LineString";
                break;
              case "MultiPolygon":
                s2 = "Polygon";
            }
            for (var u2 = 0; u2 < t4.coordinates.length; u2++) {
              var c2 = { type: s2, coordinates: t4.coordinates[u2] };
              if (false === e3(n2.feature(c2, i2), r3, u2))
                return false;
            }
          });
        }
        function u(t3, e3) {
          l(t3, function(t4, r3, a2) {
            var o2 = 0;
            if (t4.geometry) {
              var s2 = t4.geometry.type;
              if ("Point" !== s2 && "MultiPoint" !== s2) {
                var l2, u2 = 0, c2 = 0, f2 = 0;
                return false !== i(t4, function(i2, s3, h, p2, d2) {
                  if (void 0 === l2 || r3 > u2 || p2 > c2 || d2 > f2)
                    return l2 = i2, u2 = r3, c2 = p2, f2 = d2, void (o2 = 0);
                  var v = n2.lineString([l2, i2], t4.properties);
                  if (false === e3(v, r3, a2, d2, o2))
                    return false;
                  o2++, l2 = i2;
                }) && void 0;
              }
            }
          });
        }
        function c(t3, e3) {
          if (!t3)
            throw new Error("geojson is required");
          l(t3, function(t4, r3, i2) {
            if (null !== t4.geometry) {
              var a2 = t4.geometry.type, o2 = t4.geometry.coordinates;
              switch (a2) {
                case "LineString":
                  if (false === e3(t4, r3, i2, 0, 0))
                    return false;
                  break;
                case "Polygon":
                  for (var s2 = 0; s2 < o2.length; s2++)
                    if (false === e3(n2.lineString(o2[s2], t4.properties), r3, i2, s2))
                      return false;
              }
            }
          });
        }
        e2.coordEach = i, e2.coordReduce = function(t3, e3, r3, n3) {
          var a2 = r3;
          return i(t3, function(t4, n4, i2, o2, s2) {
            a2 = 0 === n4 && void 0 === r3 ? t4 : e3(a2, t4, n4, i2, o2, s2);
          }, n3), a2;
        }, e2.propEach = a, e2.propReduce = function(t3, e3, r3) {
          var n3 = r3;
          return a(t3, function(t4, i2) {
            n3 = 0 === i2 && void 0 === r3 ? t4 : e3(n3, t4, i2);
          }), n3;
        }, e2.featureEach = o, e2.featureReduce = function(t3, e3, r3) {
          var n3 = r3;
          return o(t3, function(t4, i2) {
            n3 = 0 === i2 && void 0 === r3 ? t4 : e3(n3, t4, i2);
          }), n3;
        }, e2.coordAll = function(t3) {
          var e3 = [];
          return i(t3, function(t4) {
            e3.push(t4);
          }), e3;
        }, e2.geomEach = s, e2.geomReduce = function(t3, e3, r3) {
          var n3 = r3;
          return s(t3, function(t4, i2, a2, o2, s2) {
            n3 = 0 === i2 && void 0 === r3 ? t4 : e3(n3, t4, i2, a2, o2, s2);
          }), n3;
        }, e2.flattenEach = l, e2.flattenReduce = function(t3, e3, r3) {
          var n3 = r3;
          return l(t3, function(t4, i2, a2) {
            n3 = 0 === i2 && 0 === a2 && void 0 === r3 ? t4 : e3(n3, t4, i2, a2);
          }), n3;
        }, e2.segmentEach = u, e2.segmentReduce = function(t3, e3, r3) {
          var n3 = r3, i2 = false;
          return u(t3, function(t4, a2, o2, s2, l2) {
            n3 = false === i2 && void 0 === r3 ? t4 : e3(n3, t4, a2, o2, s2, l2), i2 = true;
          }), n3;
        }, e2.lineEach = c, e2.lineReduce = function(t3, e3, r3) {
          var n3 = r3;
          return c(t3, function(t4, i2, a2, o2) {
            n3 = 0 === i2 && void 0 === r3 ? t4 : e3(n3, t4, i2, a2, o2);
          }), n3;
        }, e2.findSegment = function(t3, e3) {
          if (e3 = e3 || {}, !n2.isObject(e3))
            throw new Error("options is invalid");
          var r3, i2 = e3.featureIndex || 0, a2 = e3.multiFeatureIndex || 0, o2 = e3.geometryIndex || 0, s2 = e3.segmentIndex || 0, l2 = e3.properties;
          switch (t3.type) {
            case "FeatureCollection":
              i2 < 0 && (i2 = t3.features.length + i2), l2 = l2 || t3.features[i2].properties, r3 = t3.features[i2].geometry;
              break;
            case "Feature":
              l2 = l2 || t3.properties, r3 = t3.geometry;
              break;
            case "Point":
            case "MultiPoint":
              return null;
            case "LineString":
            case "Polygon":
            case "MultiLineString":
            case "MultiPolygon":
              r3 = t3;
              break;
            default:
              throw new Error("geojson is invalid");
          }
          if (null === r3)
            return null;
          var u2 = r3.coordinates;
          switch (r3.type) {
            case "Point":
            case "MultiPoint":
              return null;
            case "LineString":
              return s2 < 0 && (s2 = u2.length + s2 - 1), n2.lineString([u2[s2], u2[s2 + 1]], l2, e3);
            case "Polygon":
              return o2 < 0 && (o2 = u2.length + o2), s2 < 0 && (s2 = u2[o2].length + s2 - 1), n2.lineString([u2[o2][s2], u2[o2][s2 + 1]], l2, e3);
            case "MultiLineString":
              return a2 < 0 && (a2 = u2.length + a2), s2 < 0 && (s2 = u2[a2].length + s2 - 1), n2.lineString([u2[a2][s2], u2[a2][s2 + 1]], l2, e3);
            case "MultiPolygon":
              return a2 < 0 && (a2 = u2.length + a2), o2 < 0 && (o2 = u2[a2].length + o2), s2 < 0 && (s2 = u2[a2][o2].length - s2 - 1), n2.lineString([u2[a2][o2][s2], u2[a2][o2][s2 + 1]], l2, e3);
          }
          throw new Error("geojson is invalid");
        }, e2.findPoint = function(t3, e3) {
          if (e3 = e3 || {}, !n2.isObject(e3))
            throw new Error("options is invalid");
          var r3, i2 = e3.featureIndex || 0, a2 = e3.multiFeatureIndex || 0, o2 = e3.geometryIndex || 0, s2 = e3.coordIndex || 0, l2 = e3.properties;
          switch (t3.type) {
            case "FeatureCollection":
              i2 < 0 && (i2 = t3.features.length + i2), l2 = l2 || t3.features[i2].properties, r3 = t3.features[i2].geometry;
              break;
            case "Feature":
              l2 = l2 || t3.properties, r3 = t3.geometry;
              break;
            case "Point":
            case "MultiPoint":
              return null;
            case "LineString":
            case "Polygon":
            case "MultiLineString":
            case "MultiPolygon":
              r3 = t3;
              break;
            default:
              throw new Error("geojson is invalid");
          }
          if (null === r3)
            return null;
          var u2 = r3.coordinates;
          switch (r3.type) {
            case "Point":
              return n2.point(u2, l2, e3);
            case "MultiPoint":
              return a2 < 0 && (a2 = u2.length + a2), n2.point(u2[a2], l2, e3);
            case "LineString":
              return s2 < 0 && (s2 = u2.length + s2), n2.point(u2[s2], l2, e3);
            case "Polygon":
              return o2 < 0 && (o2 = u2.length + o2), s2 < 0 && (s2 = u2[o2].length + s2), n2.point(u2[o2][s2], l2, e3);
            case "MultiLineString":
              return a2 < 0 && (a2 = u2.length + a2), s2 < 0 && (s2 = u2[a2].length + s2), n2.point(u2[a2][s2], l2, e3);
            case "MultiPolygon":
              return a2 < 0 && (a2 = u2.length + a2), o2 < 0 && (o2 = u2[a2].length + o2), s2 < 0 && (s2 = u2[a2][o2].length - s2), n2.point(u2[a2][o2][s2], l2, e3);
          }
          throw new Error("geojson is invalid");
        };
      }, 29261: function(t2, e2, r2) {
        Object.defineProperty(e2, "__esModule", { value: true });
        var n2 = r2(88553), i = r2(64182);
        e2.default = function(t3, e3) {
          void 0 === e3 && (e3 = {});
          var r3 = 0, a = 0, o = 0;
          return n2.coordEach(t3, function(t4) {
            r3 += t4[0], a += t4[1], o++;
          }), i.point([r3 / o, a / o], e3.properties);
        };
      }, 64182: function(t2, e2) {
        function r2(t3, e3, r3) {
          void 0 === r3 && (r3 = {});
          var n3 = { type: "Feature" };
          return (0 === r3.id || r3.id) && (n3.id = r3.id), r3.bbox && (n3.bbox = r3.bbox), n3.properties = e3 || {}, n3.geometry = t3, n3;
        }
        function n2(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "Point", coordinates: t3 }, e3, n3);
        }
        function i(t3, e3, n3) {
          void 0 === n3 && (n3 = {});
          for (var i2 = 0, a2 = t3; i2 < a2.length; i2++) {
            var o2 = a2[i2];
            if (o2.length < 4)
              throw new Error("Each LinearRing of a Polygon must have 4 or more Positions.");
            for (var s2 = 0; s2 < o2[o2.length - 1].length; s2++)
              if (o2[o2.length - 1][s2] !== o2[0][s2])
                throw new Error("First and last Position are not equivalent.");
          }
          return r2({ type: "Polygon", coordinates: t3 }, e3, n3);
        }
        function a(t3, e3, n3) {
          if (void 0 === n3 && (n3 = {}), t3.length < 2)
            throw new Error("coordinates must be an array of two or more positions");
          return r2({ type: "LineString", coordinates: t3 }, e3, n3);
        }
        function o(t3, e3) {
          void 0 === e3 && (e3 = {});
          var r3 = { type: "FeatureCollection" };
          return e3.id && (r3.id = e3.id), e3.bbox && (r3.bbox = e3.bbox), r3.features = t3, r3;
        }
        function s(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "MultiLineString", coordinates: t3 }, e3, n3);
        }
        function l(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "MultiPoint", coordinates: t3 }, e3, n3);
        }
        function u(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "MultiPolygon", coordinates: t3 }, e3, n3);
        }
        function c(t3, r3) {
          void 0 === r3 && (r3 = "kilometers");
          var n3 = e2.factors[r3];
          if (!n3)
            throw new Error(r3 + " units is invalid");
          return t3 * n3;
        }
        function f2(t3, r3) {
          void 0 === r3 && (r3 = "kilometers");
          var n3 = e2.factors[r3];
          if (!n3)
            throw new Error(r3 + " units is invalid");
          return t3 / n3;
        }
        function h(t3) {
          return t3 % (2 * Math.PI) * 180 / Math.PI;
        }
        function p2(t3) {
          return !isNaN(t3) && null !== t3 && !Array.isArray(t3) && !/^\s*$/.test(t3);
        }
        Object.defineProperty(e2, "__esModule", { value: true }), e2.earthRadius = 63710088e-1, e2.factors = { centimeters: 100 * e2.earthRadius, centimetres: 100 * e2.earthRadius, degrees: e2.earthRadius / 111325, feet: 3.28084 * e2.earthRadius, inches: 39.37 * e2.earthRadius, kilometers: e2.earthRadius / 1e3, kilometres: e2.earthRadius / 1e3, meters: e2.earthRadius, metres: e2.earthRadius, miles: e2.earthRadius / 1609.344, millimeters: 1e3 * e2.earthRadius, millimetres: 1e3 * e2.earthRadius, nauticalmiles: e2.earthRadius / 1852, radians: 1, yards: e2.earthRadius / 1.0936 }, e2.unitsFactors = { centimeters: 100, centimetres: 100, degrees: 1 / 111325, feet: 3.28084, inches: 39.37, kilometers: 1e-3, kilometres: 1e-3, meters: 1, metres: 1, miles: 1 / 1609.344, millimeters: 1e3, millimetres: 1e3, nauticalmiles: 1 / 1852, radians: 1 / e2.earthRadius, yards: 1 / 1.0936 }, e2.areaFactors = { acres: 247105e-9, centimeters: 1e4, centimetres: 1e4, feet: 10.763910417, inches: 1550.003100006, kilometers: 1e-6, kilometres: 1e-6, meters: 1, metres: 1, miles: 386e-9, millimeters: 1e6, millimetres: 1e6, yards: 1.195990046 }, e2.feature = r2, e2.geometry = function(t3, e3, r3) {
          switch (t3) {
            case "Point":
              return n2(e3).geometry;
            case "LineString":
              return a(e3).geometry;
            case "Polygon":
              return i(e3).geometry;
            case "MultiPoint":
              return l(e3).geometry;
            case "MultiLineString":
              return s(e3).geometry;
            case "MultiPolygon":
              return u(e3).geometry;
            default:
              throw new Error(t3 + " is invalid");
          }
        }, e2.point = n2, e2.points = function(t3, e3, r3) {
          return void 0 === r3 && (r3 = {}), o(t3.map(function(t4) {
            return n2(t4, e3);
          }), r3);
        }, e2.polygon = i, e2.polygons = function(t3, e3, r3) {
          return void 0 === r3 && (r3 = {}), o(t3.map(function(t4) {
            return i(t4, e3);
          }), r3);
        }, e2.lineString = a, e2.lineStrings = function(t3, e3, r3) {
          return void 0 === r3 && (r3 = {}), o(t3.map(function(t4) {
            return a(t4, e3);
          }), r3);
        }, e2.featureCollection = o, e2.multiLineString = s, e2.multiPoint = l, e2.multiPolygon = u, e2.geometryCollection = function(t3, e3, n3) {
          return void 0 === n3 && (n3 = {}), r2({ type: "GeometryCollection", geometries: t3 }, e3, n3);
        }, e2.round = function(t3, e3) {
          if (void 0 === e3 && (e3 = 0), e3 && !(e3 >= 0))
            throw new Error("precision must be a positive number");
          var r3 = Math.pow(10, e3 || 0);
          return Math.round(t3 * r3) / r3;
        }, e2.radiansToLength = c, e2.lengthToRadians = f2, e2.lengthToDegrees = function(t3, e3) {
          return h(f2(t3, e3));
        }, e2.bearingToAzimuth = function(t3) {
          var e3 = t3 % 360;
          return e3 < 0 && (e3 += 360), e3;
        }, e2.radiansToDegrees = h, e2.degreesToRadians = function(t3) {
          return t3 % 360 * Math.PI / 180;
        }, e2.convertLength = function(t3, e3, r3) {
          if (void 0 === e3 && (e3 = "kilometers"), void 0 === r3 && (r3 = "kilometers"), !(t3 >= 0))
            throw new Error("length must be a positive number");
          return c(f2(t3, e3), r3);
        }, e2.convertArea = function(t3, r3, n3) {
          if (void 0 === r3 && (r3 = "meters"), void 0 === n3 && (n3 = "kilometers"), !(t3 >= 0))
            throw new Error("area must be a positive number");
          var i2 = e2.areaFactors[r3];
          if (!i2)
            throw new Error("invalid original units");
          var a2 = e2.areaFactors[n3];
          if (!a2)
            throw new Error("invalid final units");
          return t3 / i2 * a2;
        }, e2.isNumber = p2, e2.isObject = function(t3) {
          return !!t3 && t3.constructor === Object;
        }, e2.validateBBox = function(t3) {
          if (!t3)
            throw new Error("bbox is required");
          if (!Array.isArray(t3))
            throw new Error("bbox must be an Array");
          if (4 !== t3.length && 6 !== t3.length)
            throw new Error("bbox must be an Array of 4 or 6 numbers");
          t3.forEach(function(t4) {
            if (!p2(t4))
              throw new Error("bbox must only contain numbers");
          });
        }, e2.validateId = function(t3) {
          if (!t3)
            throw new Error("id is required");
          if (-1 === ["string", "number"].indexOf(typeof t3))
            throw new Error("id must be a number or a string");
        }, e2.radians2degrees = function() {
          throw new Error("method has been renamed to `radiansToDegrees`");
        }, e2.degrees2radians = function() {
          throw new Error("method has been renamed to `degreesToRadians`");
        }, e2.distanceToDegrees = function() {
          throw new Error("method has been renamed to `lengthToDegrees`");
        }, e2.distanceToRadians = function() {
          throw new Error("method has been renamed to `lengthToRadians`");
        }, e2.radiansToDistance = function() {
          throw new Error("method has been renamed to `radiansToLength`");
        }, e2.bearingToAngle = function() {
          throw new Error("method has been renamed to `bearingToAzimuth`");
        }, e2.convertDistance = function() {
          throw new Error("method has been renamed to `convertLength`");
        };
      }, 88553: function(t2, e2, r2) {
        Object.defineProperty(e2, "__esModule", { value: true });
        var n2 = r2(64182);
        function i(t3, e3, r3) {
          if (null !== t3)
            for (var n3, a2, o2, s2, l2, u2, c2, f2, h = 0, p2 = 0, d2 = t3.type, v = "FeatureCollection" === d2, g2 = "Feature" === d2, y = v ? t3.features.length : 1, m2 = 0; m2 < y; m2++) {
              l2 = (f2 = !!(c2 = v ? t3.features[m2].geometry : g2 ? t3.geometry : t3) && "GeometryCollection" === c2.type) ? c2.geometries.length : 1;
              for (var x = 0; x < l2; x++) {
                var b = 0, _ = 0;
                if (null !== (s2 = f2 ? c2.geometries[x] : c2)) {
                  u2 = s2.coordinates;
                  var w2 = s2.type;
                  switch (h = !r3 || "Polygon" !== w2 && "MultiPolygon" !== w2 ? 0 : 1, w2) {
                    case null:
                      break;
                    case "Point":
                      if (false === e3(u2, p2, m2, b, _))
                        return false;
                      p2++, b++;
                      break;
                    case "LineString":
                    case "MultiPoint":
                      for (n3 = 0; n3 < u2.length; n3++) {
                        if (false === e3(u2[n3], p2, m2, b, _))
                          return false;
                        p2++, "MultiPoint" === w2 && b++;
                      }
                      "LineString" === w2 && b++;
                      break;
                    case "Polygon":
                    case "MultiLineString":
                      for (n3 = 0; n3 < u2.length; n3++) {
                        for (a2 = 0; a2 < u2[n3].length - h; a2++) {
                          if (false === e3(u2[n3][a2], p2, m2, b, _))
                            return false;
                          p2++;
                        }
                        "MultiLineString" === w2 && b++, "Polygon" === w2 && _++;
                      }
                      "Polygon" === w2 && b++;
                      break;
                    case "MultiPolygon":
                      for (n3 = 0; n3 < u2.length; n3++) {
                        for (_ = 0, a2 = 0; a2 < u2[n3].length; a2++) {
                          for (o2 = 0; o2 < u2[n3][a2].length - h; o2++) {
                            if (false === e3(u2[n3][a2][o2], p2, m2, b, _))
                              return false;
                            p2++;
                          }
                          _++;
                        }
                        b++;
                      }
                      break;
                    case "GeometryCollection":
                      for (n3 = 0; n3 < s2.geometries.length; n3++)
                        if (false === i(s2.geometries[n3], e3, r3))
                          return false;
                      break;
                    default:
                      throw new Error("Unknown Geometry Type");
                  }
                }
              }
            }
        }
        function a(t3, e3) {
          var r3;
          switch (t3.type) {
            case "FeatureCollection":
              for (r3 = 0; r3 < t3.features.length && false !== e3(t3.features[r3].properties, r3); r3++)
                ;
              break;
            case "Feature":
              e3(t3.properties, 0);
          }
        }
        function o(t3, e3) {
          if ("Feature" === t3.type)
            e3(t3, 0);
          else if ("FeatureCollection" === t3.type)
            for (var r3 = 0; r3 < t3.features.length && false !== e3(t3.features[r3], r3); r3++)
              ;
        }
        function s(t3, e3) {
          var r3, n3, i2, a2, o2, s2, l2, u2, c2, f2, h = 0, p2 = "FeatureCollection" === t3.type, d2 = "Feature" === t3.type, v = p2 ? t3.features.length : 1;
          for (r3 = 0; r3 < v; r3++) {
            for (s2 = p2 ? t3.features[r3].geometry : d2 ? t3.geometry : t3, u2 = p2 ? t3.features[r3].properties : d2 ? t3.properties : {}, c2 = p2 ? t3.features[r3].bbox : d2 ? t3.bbox : void 0, f2 = p2 ? t3.features[r3].id : d2 ? t3.id : void 0, o2 = (l2 = !!s2 && "GeometryCollection" === s2.type) ? s2.geometries.length : 1, i2 = 0; i2 < o2; i2++)
              if (null !== (a2 = l2 ? s2.geometries[i2] : s2))
                switch (a2.type) {
                  case "Point":
                  case "LineString":
                  case "MultiPoint":
                  case "Polygon":
                  case "MultiLineString":
                  case "MultiPolygon":
                    if (false === e3(a2, h, u2, c2, f2))
                      return false;
                    break;
                  case "GeometryCollection":
                    for (n3 = 0; n3 < a2.geometries.length; n3++)
                      if (false === e3(a2.geometries[n3], h, u2, c2, f2))
                        return false;
                    break;
                  default:
                    throw new Error("Unknown Geometry Type");
                }
              else if (false === e3(null, h, u2, c2, f2))
                return false;
            h++;
          }
        }
        function l(t3, e3) {
          s(t3, function(t4, r3, i2, a2, o2) {
            var s2, l2 = null === t4 ? null : t4.type;
            switch (l2) {
              case null:
              case "Point":
              case "LineString":
              case "Polygon":
                return false !== e3(n2.feature(t4, i2, { bbox: a2, id: o2 }), r3, 0) && void 0;
            }
            switch (l2) {
              case "MultiPoint":
                s2 = "Point";
                break;
              case "MultiLineString":
                s2 = "LineString";
                break;
              case "MultiPolygon":
                s2 = "Polygon";
            }
            for (var u2 = 0; u2 < t4.coordinates.length; u2++) {
              var c2 = { type: s2, coordinates: t4.coordinates[u2] };
              if (false === e3(n2.feature(c2, i2), r3, u2))
                return false;
            }
          });
        }
        function u(t3, e3) {
          l(t3, function(t4, r3, a2) {
            var o2 = 0;
            if (t4.geometry) {
              var s2 = t4.geometry.type;
              if ("Point" !== s2 && "MultiPoint" !== s2) {
                var l2, u2 = 0, c2 = 0, f2 = 0;
                return false !== i(t4, function(i2, s3, h, p2, d2) {
                  if (void 0 === l2 || r3 > u2 || p2 > c2 || d2 > f2)
                    return l2 = i2, u2 = r3, c2 = p2, f2 = d2, void (o2 = 0);
                  var v = n2.lineString([l2, i2], t4.properties);
                  if (false === e3(v, r3, a2, d2, o2))
                    return false;
                  o2++, l2 = i2;
                }) && void 0;
              }
            }
          });
        }
        function c(t3, e3) {
          if (!t3)
            throw new Error("geojson is required");
          l(t3, function(t4, r3, i2) {
            if (null !== t4.geometry) {
              var a2 = t4.geometry.type, o2 = t4.geometry.coordinates;
              switch (a2) {
                case "LineString":
                  if (false === e3(t4, r3, i2, 0, 0))
                    return false;
                  break;
                case "Polygon":
                  for (var s2 = 0; s2 < o2.length; s2++)
                    if (false === e3(n2.lineString(o2[s2], t4.properties), r3, i2, s2))
                      return false;
              }
            }
          });
        }
        e2.coordEach = i, e2.coordReduce = function(t3, e3, r3, n3) {
          var a2 = r3;
          return i(t3, function(t4, n4, i2, o2, s2) {
            a2 = 0 === n4 && void 0 === r3 ? t4 : e3(a2, t4, n4, i2, o2, s2);
          }, n3), a2;
        }, e2.propEach = a, e2.propReduce = function(t3, e3, r3) {
          var n3 = r3;
          return a(t3, function(t4, i2) {
            n3 = 0 === i2 && void 0 === r3 ? t4 : e3(n3, t4, i2);
          }), n3;
        }, e2.featureEach = o, e2.featureReduce = function(t3, e3, r3) {
          var n3 = r3;
          return o(t3, function(t4, i2) {
            n3 = 0 === i2 && void 0 === r3 ? t4 : e3(n3, t4, i2);
          }), n3;
        }, e2.coordAll = function(t3) {
          var e3 = [];
          return i(t3, function(t4) {
            e3.push(t4);
          }), e3;
        }, e2.geomEach = s, e2.geomReduce = function(t3, e3, r3) {
          var n3 = r3;
          return s(t3, function(t4, i2, a2, o2, s2) {
            n3 = 0 === i2 && void 0 === r3 ? t4 : e3(n3, t4, i2, a2, o2, s2);
          }), n3;
        }, e2.flattenEach = l, e2.flattenReduce = function(t3, e3, r3) {
          var n3 = r3;
          return l(t3, function(t4, i2, a2) {
            n3 = 0 === i2 && 0 === a2 && void 0 === r3 ? t4 : e3(n3, t4, i2, a2);
          }), n3;
        }, e2.segmentEach = u, e2.segmentReduce = function(t3, e3, r3) {
          var n3 = r3, i2 = false;
          return u(t3, function(t4, a2, o2, s2, l2) {
            n3 = false === i2 && void 0 === r3 ? t4 : e3(n3, t4, a2, o2, s2, l2), i2 = true;
          }), n3;
        }, e2.lineEach = c, e2.lineReduce = function(t3, e3, r3) {
          var n3 = r3;
          return c(t3, function(t4, i2, a2, o2) {
            n3 = 0 === i2 && void 0 === r3 ? t4 : e3(n3, t4, i2, a2, o2);
          }), n3;
        }, e2.findSegment = function(t3, e3) {
          if (e3 = e3 || {}, !n2.isObject(e3))
            throw new Error("options is invalid");
          var r3, i2 = e3.featureIndex || 0, a2 = e3.multiFeatureIndex || 0, o2 = e3.geometryIndex || 0, s2 = e3.segmentIndex || 0, l2 = e3.properties;
          switch (t3.type) {
            case "FeatureCollection":
              i2 < 0 && (i2 = t3.features.length + i2), l2 = l2 || t3.features[i2].properties, r3 = t3.features[i2].geometry;
              break;
            case "Feature":
              l2 = l2 || t3.properties, r3 = t3.geometry;
              break;
            case "Point":
            case "MultiPoint":
              return null;
            case "LineString":
            case "Polygon":
            case "MultiLineString":
            case "MultiPolygon":
              r3 = t3;
              break;
            default:
              throw new Error("geojson is invalid");
          }
          if (null === r3)
            return null;
          var u2 = r3.coordinates;
          switch (r3.type) {
            case "Point":
            case "MultiPoint":
              return null;
            case "LineString":
              return s2 < 0 && (s2 = u2.length + s2 - 1), n2.lineString([u2[s2], u2[s2 + 1]], l2, e3);
            case "Polygon":
              return o2 < 0 && (o2 = u2.length + o2), s2 < 0 && (s2 = u2[o2].length + s2 - 1), n2.lineString([u2[o2][s2], u2[o2][s2 + 1]], l2, e3);
            case "MultiLineString":
              return a2 < 0 && (a2 = u2.length + a2), s2 < 0 && (s2 = u2[a2].length + s2 - 1), n2.lineString([u2[a2][s2], u2[a2][s2 + 1]], l2, e3);
            case "MultiPolygon":
              return a2 < 0 && (a2 = u2.length + a2), o2 < 0 && (o2 = u2[a2].length + o2), s2 < 0 && (s2 = u2[a2][o2].length - s2 - 1), n2.lineString([u2[a2][o2][s2], u2[a2][o2][s2 + 1]], l2, e3);
          }
          throw new Error("geojson is invalid");
        }, e2.findPoint = function(t3, e3) {
          if (e3 = e3 || {}, !n2.isObject(e3))
            throw new Error("options is invalid");
          var r3, i2 = e3.featureIndex || 0, a2 = e3.multiFeatureIndex || 0, o2 = e3.geometryIndex || 0, s2 = e3.coordIndex || 0, l2 = e3.properties;
          switch (t3.type) {
            case "FeatureCollection":
              i2 < 0 && (i2 = t3.features.length + i2), l2 = l2 || t3.features[i2].properties, r3 = t3.features[i2].geometry;
              break;
            case "Feature":
              l2 = l2 || t3.properties, r3 = t3.geometry;
              break;
            case "Point":
            case "MultiPoint":
              return null;
            case "LineString":
            case "Polygon":
            case "MultiLineString":
            case "MultiPolygon":
              r3 = t3;
              break;
            default:
              throw new Error("geojson is invalid");
          }
          if (null === r3)
            return null;
          var u2 = r3.coordinates;
          switch (r3.type) {
            case "Point":
              return n2.point(u2, l2, e3);
            case "MultiPoint":
              return a2 < 0 && (a2 = u2.length + a2), n2.point(u2[a2], l2, e3);
            case "LineString":
              return s2 < 0 && (s2 = u2.length + s2), n2.point(u2[s2], l2, e3);
            case "Polygon":
              return o2 < 0 && (o2 = u2.length + o2), s2 < 0 && (s2 = u2[o2].length + s2), n2.point(u2[o2][s2], l2, e3);
            case "MultiLineString":
              return a2 < 0 && (a2 = u2.length + a2), s2 < 0 && (s2 = u2[a2].length + s2), n2.point(u2[a2][s2], l2, e3);
            case "MultiPolygon":
              return a2 < 0 && (a2 = u2.length + a2), o2 < 0 && (o2 = u2[a2].length + o2), s2 < 0 && (s2 = u2[a2][o2].length - s2), n2.point(u2[a2][o2][s2], l2, e3);
          }
          throw new Error("geojson is invalid");
        };
      }, 65185: function(t2) {
        t2.exports = function(t3) {
          var e2 = 0, r2 = 0, n2 = 0, i = 0;
          return t3.map(function(t4) {
            var a = (t4 = t4.slice())[0], o = a.toUpperCase();
            if (a != o)
              switch (t4[0] = o, a) {
                case "a":
                  t4[6] += n2, t4[7] += i;
                  break;
                case "v":
                  t4[1] += i;
                  break;
                case "h":
                  t4[1] += n2;
                  break;
                default:
                  for (var s = 1; s < t4.length; )
                    t4[s++] += n2, t4[s++] += i;
              }
            switch (o) {
              case "Z":
                n2 = e2, i = r2;
                break;
              case "H":
                n2 = t4[1];
                break;
              case "V":
                i = t4[1];
                break;
              case "M":
                n2 = e2 = t4[1], i = r2 = t4[2];
                break;
              default:
                n2 = t4[t4.length - 2], i = t4[t4.length - 1];
            }
            return t4;
          });
        };
      }, 21527: function(t2) {
        t2.exports = function(t3, e2) {
          if (!t3 || null == t3.length)
            throw Error("Argument should be an array");
          e2 = null == e2 ? 1 : Math.floor(e2);
          for (var r2 = Array(2 * e2), n2 = 0; n2 < e2; n2++) {
            for (var i = -1 / 0, a = 1 / 0, o = n2, s = t3.length; o < s; o += e2)
              t3[o] > i && (i = t3[o]), t3[o] < a && (a = t3[o]);
            r2[n2] = a, r2[e2 + n2] = i;
          }
          return r2;
        };
      }, 6851: function(t2) {
        t2.exports = function(t3, e2, r2) {
          if ("function" == typeof Array.prototype.findIndex)
            return t3.findIndex(e2, r2);
          if ("function" != typeof e2)
            throw new TypeError("predicate must be a function");
          var n2 = Object(t3), i = n2.length;
          if (0 === i)
            return -1;
          for (var a = 0; a < i; a++)
            if (e2.call(r2, n2[a], a, n2))
              return a;
          return -1;
        };
      }, 54: function(t2, e2, r2) {
        var n2 = r2(21527);
        t2.exports = function(t3, e3, r3) {
          if (!t3 || null == t3.length)
            throw Error("Argument should be an array");
          null == e3 && (e3 = 1), null == r3 && (r3 = n2(t3, e3));
          for (var i = 0; i < e3; i++) {
            var a = r3[e3 + i], o = r3[i], s = i, l = t3.length;
            if (a === 1 / 0 && o === -1 / 0)
              for (s = i; s < l; s += e3)
                t3[s] = t3[s] === a ? 1 : t3[s] === o ? 0 : 0.5;
            else if (a === 1 / 0)
              for (s = i; s < l; s += e3)
                t3[s] = t3[s] === a ? 1 : 0;
            else if (o === -1 / 0)
              for (s = i; s < l; s += e3)
                t3[s] = t3[s] === o ? 0 : 1;
            else {
              var u = a - o;
              for (s = i; s < l; s += e3)
                isNaN(t3[s]) || (t3[s] = 0 === u ? 0.5 : (t3[s] - o) / u);
            }
          }
          return t3;
        };
      }, 57471: function(t2) {
        t2.exports = function(t3, e2) {
          var r2 = "number" == typeof t3, n2 = "number" == typeof e2;
          r2 && !n2 ? (e2 = t3, t3 = 0) : r2 || n2 || (t3 = 0, e2 = 0);
          var i = (e2 |= 0) - (t3 |= 0);
          if (i < 0)
            throw new Error("array length must be positive");
          for (var a = new Array(i), o = 0, s = t3; o < i; o++, s++)
            a[o] = s;
          return a;
        };
      }, 32791: function(t2, e2, r2) {
        var n2 = r2(90386);
        function i(t3) {
          return i = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(t4) {
            return typeof t4;
          } : function(t4) {
            return t4 && "function" == typeof Symbol && t4.constructor === Symbol && t4 !== Symbol.prototype ? "symbol" : typeof t4;
          }, i(t3);
        }
        var a, o, s = r2(79616).codes, l = s.ERR_AMBIGUOUS_ARGUMENT, u = s.ERR_INVALID_ARG_TYPE, c = s.ERR_INVALID_ARG_VALUE, f2 = s.ERR_INVALID_RETURN_VALUE, h = s.ERR_MISSING_ARGS, p2 = r2(73894), d2 = r2(43827).inspect, v = r2(43827).types, g2 = v.isPromise, y = v.isRegExp, m2 = Object.assign ? Object.assign : r2(73523).assign, x = Object.is ? Object.is : r2(64003);
        function b() {
          var t3 = r2(74061);
          a = t3.isDeepEqual, o = t3.isDeepStrictEqual;
        }
        var _ = false, w2 = t2.exports = M, T = {};
        function k(t3) {
          if (t3.message instanceof Error)
            throw t3.message;
          throw new p2(t3);
        }
        function A(t3, e3, r3, n3) {
          if (!r3) {
            var i2 = false;
            if (0 === e3)
              i2 = true, n3 = "No value argument passed to `assert.ok()`";
            else if (n3 instanceof Error)
              throw n3;
            var a2 = new p2({ actual: r3, expected: true, message: n3, operator: "==", stackStartFn: t3 });
            throw a2.generatedMessage = i2, a2;
          }
        }
        function M() {
          for (var t3 = arguments.length, e3 = new Array(t3), r3 = 0; r3 < t3; r3++)
            e3[r3] = arguments[r3];
          A.apply(void 0, [M, e3.length].concat(e3));
        }
        w2.fail = function t3(e3, r3, i2, a2, o2) {
          var s2, l2 = arguments.length;
          if (0 === l2)
            s2 = "Failed";
          else if (1 === l2)
            i2 = e3, e3 = void 0;
          else {
            if (false === _) {
              _ = true;
              var u2 = n2.emitWarning ? n2.emitWarning : console.warn.bind(console);
              u2("assert.fail() with more than one argument is deprecated. Please use assert.strictEqual() instead or only pass a message.", "DeprecationWarning", "DEP0094");
            }
            2 === l2 && (a2 = "!=");
          }
          if (i2 instanceof Error)
            throw i2;
          var c2 = { actual: e3, expected: r3, operator: void 0 === a2 ? "fail" : a2, stackStartFn: o2 || t3 };
          void 0 !== i2 && (c2.message = i2);
          var f3 = new p2(c2);
          throw s2 && (f3.message = s2, f3.generatedMessage = true), f3;
        }, w2.AssertionError = p2, w2.ok = M, w2.equal = function t3(e3, r3, n3) {
          if (arguments.length < 2)
            throw new h("actual", "expected");
          e3 != r3 && k({ actual: e3, expected: r3, message: n3, operator: "==", stackStartFn: t3 });
        }, w2.notEqual = function t3(e3, r3, n3) {
          if (arguments.length < 2)
            throw new h("actual", "expected");
          e3 == r3 && k({ actual: e3, expected: r3, message: n3, operator: "!=", stackStartFn: t3 });
        }, w2.deepEqual = function t3(e3, r3, n3) {
          if (arguments.length < 2)
            throw new h("actual", "expected");
          void 0 === a && b(), a(e3, r3) || k({ actual: e3, expected: r3, message: n3, operator: "deepEqual", stackStartFn: t3 });
        }, w2.notDeepEqual = function t3(e3, r3, n3) {
          if (arguments.length < 2)
            throw new h("actual", "expected");
          void 0 === a && b(), a(e3, r3) && k({ actual: e3, expected: r3, message: n3, operator: "notDeepEqual", stackStartFn: t3 });
        }, w2.deepStrictEqual = function t3(e3, r3, n3) {
          if (arguments.length < 2)
            throw new h("actual", "expected");
          void 0 === a && b(), o(e3, r3) || k({ actual: e3, expected: r3, message: n3, operator: "deepStrictEqual", stackStartFn: t3 });
        }, w2.notDeepStrictEqual = function t3(e3, r3, n3) {
          if (arguments.length < 2)
            throw new h("actual", "expected");
          void 0 === a && b(), o(e3, r3) && k({ actual: e3, expected: r3, message: n3, operator: "notDeepStrictEqual", stackStartFn: t3 });
        }, w2.strictEqual = function t3(e3, r3, n3) {
          if (arguments.length < 2)
            throw new h("actual", "expected");
          x(e3, r3) || k({ actual: e3, expected: r3, message: n3, operator: "strictEqual", stackStartFn: t3 });
        }, w2.notStrictEqual = function t3(e3, r3, n3) {
          if (arguments.length < 2)
            throw new h("actual", "expected");
          x(e3, r3) && k({ actual: e3, expected: r3, message: n3, operator: "notStrictEqual", stackStartFn: t3 });
        };
        var S = function t3(e3, r3, n3) {
          var i2 = this;
          !function(t4, e4) {
            if (!(t4 instanceof e4))
              throw new TypeError("Cannot call a class as a function");
          }(this, t3), r3.forEach(function(t4) {
            t4 in e3 && (void 0 !== n3 && "string" == typeof n3[t4] && y(e3[t4]) && e3[t4].test(n3[t4]) ? i2[t4] = n3[t4] : i2[t4] = e3[t4]);
          });
        };
        function E(t3, e3, r3, n3, i2, a2) {
          if (!(r3 in t3) || !o(t3[r3], e3[r3])) {
            if (!n3) {
              var s2 = new S(t3, i2), l2 = new S(e3, i2, t3), u2 = new p2({ actual: s2, expected: l2, operator: "deepStrictEqual", stackStartFn: a2 });
              throw u2.actual = t3, u2.expected = e3, u2.operator = a2.name, u2;
            }
            k({ actual: t3, expected: e3, message: n3, operator: a2.name, stackStartFn: a2 });
          }
        }
        function L(t3, e3, r3, n3) {
          if ("function" != typeof e3) {
            if (y(e3))
              return e3.test(t3);
            if (2 === arguments.length)
              throw new u("expected", ["Function", "RegExp"], e3);
            if ("object" !== i(t3) || null === t3) {
              var o2 = new p2({ actual: t3, expected: e3, message: r3, operator: "deepStrictEqual", stackStartFn: n3 });
              throw o2.operator = n3.name, o2;
            }
            var s2 = Object.keys(e3);
            if (e3 instanceof Error)
              s2.push("name", "message");
            else if (0 === s2.length)
              throw new c("error", e3, "may not be an empty object");
            return void 0 === a && b(), s2.forEach(function(i2) {
              "string" == typeof t3[i2] && y(e3[i2]) && e3[i2].test(t3[i2]) || E(t3, e3, i2, r3, s2, n3);
            }), true;
          }
          return void 0 !== e3.prototype && t3 instanceof e3 || !Error.isPrototypeOf(e3) && true === e3.call({}, t3);
        }
        function C(t3) {
          if ("function" != typeof t3)
            throw new u("fn", "Function", t3);
          try {
            t3();
          } catch (t4) {
            return t4;
          }
          return T;
        }
        function P(t3) {
          return g2(t3) || null !== t3 && "object" === i(t3) && "function" == typeof t3.then && "function" == typeof t3.catch;
        }
        function O(t3) {
          return Promise.resolve().then(function() {
            var e3;
            if ("function" == typeof t3) {
              if (!P(e3 = t3()))
                throw new f2("instance of Promise", "promiseFn", e3);
            } else {
              if (!P(t3))
                throw new u("promiseFn", ["Function", "Promise"], t3);
              e3 = t3;
            }
            return Promise.resolve().then(function() {
              return e3;
            }).then(function() {
              return T;
            }).catch(function(t4) {
              return t4;
            });
          });
        }
        function I(t3, e3, r3, n3) {
          if ("string" == typeof r3) {
            if (4 === arguments.length)
              throw new u("error", ["Object", "Error", "Function", "RegExp"], r3);
            if ("object" === i(e3) && null !== e3) {
              if (e3.message === r3)
                throw new l("error/message", 'The error message "'.concat(e3.message, '" is identical to the message.'));
            } else if (e3 === r3)
              throw new l("error/message", 'The error "'.concat(e3, '" is identical to the message.'));
            n3 = r3, r3 = void 0;
          } else if (null != r3 && "object" !== i(r3) && "function" != typeof r3)
            throw new u("error", ["Object", "Error", "Function", "RegExp"], r3);
          if (e3 === T) {
            var a2 = "";
            r3 && r3.name && (a2 += " (".concat(r3.name, ")")), a2 += n3 ? ": ".concat(n3) : ".";
            var o2 = "rejects" === t3.name ? "rejection" : "exception";
            k({ actual: void 0, expected: r3, operator: t3.name, message: "Missing expected ".concat(o2).concat(a2), stackStartFn: t3 });
          }
          if (r3 && !L(e3, r3, n3, t3))
            throw e3;
        }
        function D(t3, e3, r3, n3) {
          if (e3 !== T) {
            if ("string" == typeof r3 && (n3 = r3, r3 = void 0), !r3 || L(e3, r3)) {
              var i2 = n3 ? ": ".concat(n3) : ".", a2 = "doesNotReject" === t3.name ? "rejection" : "exception";
              k({ actual: e3, expected: r3, operator: t3.name, message: "Got unwanted ".concat(a2).concat(i2, "\n") + 'Actual message: "'.concat(e3 && e3.message, '"'), stackStartFn: t3 });
            }
            throw e3;
          }
        }
        function z() {
          for (var t3 = arguments.length, e3 = new Array(t3), r3 = 0; r3 < t3; r3++)
            e3[r3] = arguments[r3];
          A.apply(void 0, [z, e3.length].concat(e3));
        }
        w2.throws = function t3(e3) {
          for (var r3 = arguments.length, n3 = new Array(r3 > 1 ? r3 - 1 : 0), i2 = 1; i2 < r3; i2++)
            n3[i2 - 1] = arguments[i2];
          I.apply(void 0, [t3, C(e3)].concat(n3));
        }, w2.rejects = function t3(e3) {
          for (var r3 = arguments.length, n3 = new Array(r3 > 1 ? r3 - 1 : 0), i2 = 1; i2 < r3; i2++)
            n3[i2 - 1] = arguments[i2];
          return O(e3).then(function(e4) {
            return I.apply(void 0, [t3, e4].concat(n3));
          });
        }, w2.doesNotThrow = function t3(e3) {
          for (var r3 = arguments.length, n3 = new Array(r3 > 1 ? r3 - 1 : 0), i2 = 1; i2 < r3; i2++)
            n3[i2 - 1] = arguments[i2];
          D.apply(void 0, [t3, C(e3)].concat(n3));
        }, w2.doesNotReject = function t3(e3) {
          for (var r3 = arguments.length, n3 = new Array(r3 > 1 ? r3 - 1 : 0), i2 = 1; i2 < r3; i2++)
            n3[i2 - 1] = arguments[i2];
          return O(e3).then(function(e4) {
            return D.apply(void 0, [t3, e4].concat(n3));
          });
        }, w2.ifError = function t3(e3) {
          if (null != e3) {
            var r3 = "ifError got unwanted exception: ";
            "object" === i(e3) && "string" == typeof e3.message ? 0 === e3.message.length && e3.constructor ? r3 += e3.constructor.name : r3 += e3.message : r3 += d2(e3);
            var n3 = new p2({ actual: e3, expected: null, operator: "ifError", message: r3, stackStartFn: t3 }), a2 = e3.stack;
            if ("string" == typeof a2) {
              var o2 = a2.split("\n");
              o2.shift();
              for (var s2 = n3.stack.split("\n"), l2 = 0; l2 < o2.length; l2++) {
                var u2 = s2.indexOf(o2[l2]);
                if (-1 !== u2) {
                  s2 = s2.slice(0, u2);
                  break;
                }
              }
              n3.stack = "".concat(s2.join("\n"), "\n").concat(o2.join("\n"));
            }
            throw n3;
          }
        }, w2.strict = m2(z, w2, { equal: w2.strictEqual, deepEqual: w2.deepStrictEqual, notEqual: w2.notStrictEqual, notDeepEqual: w2.notDeepStrictEqual }), w2.strict.strict = w2.strict;
      }, 73894: function(t2, e2, r2) {
        var n2 = r2(90386);
        function i(t3, e3, r3) {
          return e3 in t3 ? Object.defineProperty(t3, e3, { value: r3, enumerable: true, configurable: true, writable: true }) : t3[e3] = r3, t3;
        }
        function a(t3, e3) {
          for (var r3 = 0; r3 < e3.length; r3++) {
            var n3 = e3[r3];
            n3.enumerable = n3.enumerable || false, n3.configurable = true, "value" in n3 && (n3.writable = true), Object.defineProperty(t3, n3.key, n3);
          }
        }
        function o(t3, e3) {
          return !e3 || "object" !== p2(e3) && "function" != typeof e3 ? s(t3) : e3;
        }
        function s(t3) {
          if (void 0 === t3)
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
          return t3;
        }
        function l(t3) {
          var e3 = "function" == typeof Map ? /* @__PURE__ */ new Map() : void 0;
          return l = function(t4) {
            if (null === t4 || (r3 = t4, -1 === Function.toString.call(r3).indexOf("[native code]")))
              return t4;
            var r3;
            if ("function" != typeof t4)
              throw new TypeError("Super expression must either be null or a function");
            if (void 0 !== e3) {
              if (e3.has(t4))
                return e3.get(t4);
              e3.set(t4, n3);
            }
            function n3() {
              return c(t4, arguments, h(this).constructor);
            }
            return n3.prototype = Object.create(t4.prototype, { constructor: { value: n3, enumerable: false, writable: true, configurable: true } }), f2(n3, t4);
          }, l(t3);
        }
        function u() {
          if ("undefined" == typeof Reflect || !Reflect.construct)
            return false;
          if (Reflect.construct.sham)
            return false;
          if ("function" == typeof Proxy)
            return true;
          try {
            return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
            })), true;
          } catch (t3) {
            return false;
          }
        }
        function c(t3, e3, r3) {
          return c = u() ? Reflect.construct : function(t4, e4, r4) {
            var n3 = [null];
            n3.push.apply(n3, e4);
            var i2 = new (Function.bind.apply(t4, n3))();
            return r4 && f2(i2, r4.prototype), i2;
          }, c.apply(null, arguments);
        }
        function f2(t3, e3) {
          return f2 = Object.setPrototypeOf || function(t4, e4) {
            return t4.__proto__ = e4, t4;
          }, f2(t3, e3);
        }
        function h(t3) {
          return h = Object.setPrototypeOf ? Object.getPrototypeOf : function(t4) {
            return t4.__proto__ || Object.getPrototypeOf(t4);
          }, h(t3);
        }
        function p2(t3) {
          return p2 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(t4) {
            return typeof t4;
          } : function(t4) {
            return t4 && "function" == typeof Symbol && t4.constructor === Symbol && t4 !== Symbol.prototype ? "symbol" : typeof t4;
          }, p2(t3);
        }
        var d2 = r2(43827).inspect, v = r2(79616).codes.ERR_INVALID_ARG_TYPE;
        function g2(t3, e3, r3) {
          return (void 0 === r3 || r3 > t3.length) && (r3 = t3.length), t3.substring(r3 - e3.length, r3) === e3;
        }
        var y = "", m2 = "", x = "", b = "", _ = { deepStrictEqual: "Expected values to be strictly deep-equal:", strictEqual: "Expected values to be strictly equal:", strictEqualObject: 'Expected "actual" to be reference-equal to "expected":', deepEqual: "Expected values to be loosely deep-equal:", equal: "Expected values to be loosely equal:", notDeepStrictEqual: 'Expected "actual" not to be strictly deep-equal to:', notStrictEqual: 'Expected "actual" to be strictly unequal to:', notStrictEqualObject: 'Expected "actual" not to be reference-equal to "expected":', notDeepEqual: 'Expected "actual" not to be loosely deep-equal to:', notEqual: 'Expected "actual" to be loosely unequal to:', notIdentical: "Values identical but not reference-equal:" };
        function w2(t3) {
          var e3 = Object.keys(t3), r3 = Object.create(Object.getPrototypeOf(t3));
          return e3.forEach(function(e4) {
            r3[e4] = t3[e4];
          }), Object.defineProperty(r3, "message", { value: t3.message }), r3;
        }
        function T(t3) {
          return d2(t3, { compact: false, customInspect: false, depth: 1e3, maxArrayLength: 1 / 0, showHidden: false, breakLength: 1 / 0, showProxy: false, sorted: true, getters: true });
        }
        var k = function(t3) {
          function e3(t4) {
            var r4;
            if (function(t5, e4) {
              if (!(t5 instanceof e4))
                throw new TypeError("Cannot call a class as a function");
            }(this, e3), "object" !== p2(t4) || null === t4)
              throw new v("options", "Object", t4);
            var i2 = t4.message, a2 = t4.operator, l3 = t4.stackStartFn, u2 = t4.actual, c2 = t4.expected, f3 = Error.stackTraceLimit;
            if (Error.stackTraceLimit = 0, null != i2)
              r4 = o(this, h(e3).call(this, String(i2)));
            else if (n2.stderr && n2.stderr.isTTY && (n2.stderr && n2.stderr.getColorDepth && 1 !== n2.stderr.getColorDepth() ? (y = "\x1B[34m", m2 = "\x1B[32m", b = "\x1B[39m", x = "\x1B[31m") : (y = "", m2 = "", b = "", x = "")), "object" === p2(u2) && null !== u2 && "object" === p2(c2) && null !== c2 && "stack" in u2 && u2 instanceof Error && "stack" in c2 && c2 instanceof Error && (u2 = w2(u2), c2 = w2(c2)), "deepStrictEqual" === a2 || "strictEqual" === a2)
              r4 = o(this, h(e3).call(this, function(t5, e4, r5) {
                var i3 = "", a3 = "", o2 = 0, s2 = "", l4 = false, u3 = T(t5), c3 = u3.split("\n"), f4 = T(e4).split("\n"), h2 = 0, d4 = "";
                if ("strictEqual" === r5 && "object" === p2(t5) && "object" === p2(e4) && null !== t5 && null !== e4 && (r5 = "strictEqualObject"), 1 === c3.length && 1 === f4.length && c3[0] !== f4[0]) {
                  var v2 = c3[0].length + f4[0].length;
                  if (v2 <= 10) {
                    if (!("object" === p2(t5) && null !== t5 || "object" === p2(e4) && null !== e4 || 0 === t5 && 0 === e4))
                      return "".concat(_[r5], "\n\n") + "".concat(c3[0], " !== ").concat(f4[0], "\n");
                  } else if ("strictEqualObject" !== r5 && v2 < (n2.stderr && n2.stderr.isTTY ? n2.stderr.columns : 80)) {
                    for (; c3[0][h2] === f4[0][h2]; )
                      h2++;
                    h2 > 2 && (d4 = "\n  ".concat(function(t6, e5) {
                      if (e5 = Math.floor(e5), 0 == t6.length || 0 == e5)
                        return "";
                      var r6 = t6.length * e5;
                      for (e5 = Math.floor(Math.log(e5) / Math.log(2)); e5; )
                        t6 += t6, e5--;
                      return t6 + t6.substring(0, r6 - t6.length);
                    }(" ", h2), "^"), h2 = 0);
                  }
                }
                for (var w3 = c3[c3.length - 1], k3 = f4[f4.length - 1]; w3 === k3 && (h2++ < 2 ? s2 = "\n  ".concat(w3).concat(s2) : i3 = w3, c3.pop(), f4.pop(), 0 !== c3.length && 0 !== f4.length); )
                  w3 = c3[c3.length - 1], k3 = f4[f4.length - 1];
                var A2 = Math.max(c3.length, f4.length);
                if (0 === A2) {
                  var M2 = u3.split("\n");
                  if (M2.length > 30)
                    for (M2[26] = "".concat(y, "...").concat(b); M2.length > 27; )
                      M2.pop();
                  return "".concat(_.notIdentical, "\n\n").concat(M2.join("\n"), "\n");
                }
                h2 > 3 && (s2 = "\n".concat(y, "...").concat(b).concat(s2), l4 = true), "" !== i3 && (s2 = "\n  ".concat(i3).concat(s2), i3 = "");
                var S2 = 0, E = _[r5] + "\n".concat(m2, "+ actual").concat(b, " ").concat(x, "- expected").concat(b), L = " ".concat(y, "...").concat(b, " Lines skipped");
                for (h2 = 0; h2 < A2; h2++) {
                  var C = h2 - o2;
                  if (c3.length < h2 + 1)
                    C > 1 && h2 > 2 && (C > 4 ? (a3 += "\n".concat(y, "...").concat(b), l4 = true) : C > 3 && (a3 += "\n  ".concat(f4[h2 - 2]), S2++), a3 += "\n  ".concat(f4[h2 - 1]), S2++), o2 = h2, i3 += "\n".concat(x, "-").concat(b, " ").concat(f4[h2]), S2++;
                  else if (f4.length < h2 + 1)
                    C > 1 && h2 > 2 && (C > 4 ? (a3 += "\n".concat(y, "...").concat(b), l4 = true) : C > 3 && (a3 += "\n  ".concat(c3[h2 - 2]), S2++), a3 += "\n  ".concat(c3[h2 - 1]), S2++), o2 = h2, a3 += "\n".concat(m2, "+").concat(b, " ").concat(c3[h2]), S2++;
                  else {
                    var P = f4[h2], O = c3[h2], I = O !== P && (!g2(O, ",") || O.slice(0, -1) !== P);
                    I && g2(P, ",") && P.slice(0, -1) === O && (I = false, O += ","), I ? (C > 1 && h2 > 2 && (C > 4 ? (a3 += "\n".concat(y, "...").concat(b), l4 = true) : C > 3 && (a3 += "\n  ".concat(c3[h2 - 2]), S2++), a3 += "\n  ".concat(c3[h2 - 1]), S2++), o2 = h2, a3 += "\n".concat(m2, "+").concat(b, " ").concat(O), i3 += "\n".concat(x, "-").concat(b, " ").concat(P), S2 += 2) : (a3 += i3, i3 = "", 1 !== C && 0 !== h2 || (a3 += "\n  ".concat(O), S2++));
                  }
                  if (S2 > 20 && h2 < A2 - 2)
                    return "".concat(E).concat(L, "\n").concat(a3, "\n").concat(y, "...").concat(b).concat(i3, "\n") + "".concat(y, "...").concat(b);
                }
                return "".concat(E).concat(l4 ? L : "", "\n").concat(a3).concat(i3).concat(s2).concat(d4);
              }(u2, c2, a2)));
            else if ("notDeepStrictEqual" === a2 || "notStrictEqual" === a2) {
              var d3 = _[a2], k2 = T(u2).split("\n");
              if ("notStrictEqual" === a2 && "object" === p2(u2) && null !== u2 && (d3 = _.notStrictEqualObject), k2.length > 30)
                for (k2[26] = "".concat(y, "...").concat(b); k2.length > 27; )
                  k2.pop();
              r4 = 1 === k2.length ? o(this, h(e3).call(this, "".concat(d3, " ").concat(k2[0]))) : o(this, h(e3).call(this, "".concat(d3, "\n\n").concat(k2.join("\n"), "\n")));
            } else {
              var A = T(u2), M = "", S = _[a2];
              "notDeepEqual" === a2 || "notEqual" === a2 ? (A = "".concat(_[a2], "\n\n").concat(A)).length > 1024 && (A = "".concat(A.slice(0, 1021), "...")) : (M = "".concat(T(c2)), A.length > 512 && (A = "".concat(A.slice(0, 509), "...")), M.length > 512 && (M = "".concat(M.slice(0, 509), "...")), "deepEqual" === a2 || "equal" === a2 ? A = "".concat(S, "\n\n").concat(A, "\n\nshould equal\n\n") : M = " ".concat(a2, " ").concat(M)), r4 = o(this, h(e3).call(this, "".concat(A).concat(M)));
            }
            return Error.stackTraceLimit = f3, r4.generatedMessage = !i2, Object.defineProperty(s(r4), "name", { value: "AssertionError [ERR_ASSERTION]", enumerable: false, writable: true, configurable: true }), r4.code = "ERR_ASSERTION", r4.actual = u2, r4.expected = c2, r4.operator = a2, Error.captureStackTrace && Error.captureStackTrace(s(r4), l3), r4.stack, r4.name = "AssertionError", o(r4);
          }
          var r3, l2;
          return function(t4, e4) {
            if ("function" != typeof e4 && null !== e4)
              throw new TypeError("Super expression must either be null or a function");
            t4.prototype = Object.create(e4 && e4.prototype, { constructor: { value: t4, writable: true, configurable: true } }), e4 && f2(t4, e4);
          }(e3, t3), r3 = e3, l2 = [{ key: "toString", value: function() {
            return "".concat(this.name, " [").concat(this.code, "]: ").concat(this.message);
          } }, { key: d2.custom, value: function(t4, e4) {
            return d2(this, function(t5) {
              for (var e5 = 1; e5 < arguments.length; e5++) {
                var r4 = null != arguments[e5] ? arguments[e5] : {}, n3 = Object.keys(r4);
                "function" == typeof Object.getOwnPropertySymbols && (n3 = n3.concat(Object.getOwnPropertySymbols(r4).filter(function(t6) {
                  return Object.getOwnPropertyDescriptor(r4, t6).enumerable;
                }))), n3.forEach(function(e6) {
                  i(t5, e6, r4[e6]);
                });
              }
              return t5;
            }({}, e4, { customInspect: false, depth: 0 }));
          } }], l2 && a(r3.prototype, l2), e3;
        }(l(Error));
        t2.exports = k;
      }, 79616: function(t2, e2, r2) {
        function n2(t3) {
          return n2 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(t4) {
            return typeof t4;
          } : function(t4) {
            return t4 && "function" == typeof Symbol && t4.constructor === Symbol && t4 !== Symbol.prototype ? "symbol" : typeof t4;
          }, n2(t3);
        }
        function i(t3) {
          return i = Object.setPrototypeOf ? Object.getPrototypeOf : function(t4) {
            return t4.__proto__ || Object.getPrototypeOf(t4);
          }, i(t3);
        }
        function a(t3, e3) {
          return a = Object.setPrototypeOf || function(t4, e4) {
            return t4.__proto__ = e4, t4;
          }, a(t3, e3);
        }
        var o, s, l = {};
        function u(t3, e3, r3) {
          r3 || (r3 = Error);
          var o2 = function(r4) {
            function o3(r5, a2, s2) {
              var l2;
              return function(t4, e4) {
                if (!(t4 instanceof e4))
                  throw new TypeError("Cannot call a class as a function");
              }(this, o3), l2 = function(t4, e4) {
                return !e4 || "object" !== n2(e4) && "function" != typeof e4 ? function(t5) {
                  if (void 0 === t5)
                    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                  return t5;
                }(t4) : e4;
              }(this, i(o3).call(this, function(t4, r6, n3) {
                return "string" == typeof e3 ? e3 : e3(t4, r6, n3);
              }(r5, a2, s2))), l2.code = t3, l2;
            }
            return function(t4, e4) {
              if ("function" != typeof e4 && null !== e4)
                throw new TypeError("Super expression must either be null or a function");
              t4.prototype = Object.create(e4 && e4.prototype, { constructor: { value: t4, writable: true, configurable: true } }), e4 && a(t4, e4);
            }(o3, r4), o3;
          }(r3);
          l[t3] = o2;
        }
        function c(t3, e3) {
          if (Array.isArray(t3)) {
            var r3 = t3.length;
            return t3 = t3.map(function(t4) {
              return String(t4);
            }), r3 > 2 ? "one of ".concat(e3, " ").concat(t3.slice(0, r3 - 1).join(", "), ", or ") + t3[r3 - 1] : 2 === r3 ? "one of ".concat(e3, " ").concat(t3[0], " or ").concat(t3[1]) : "of ".concat(e3, " ").concat(t3[0]);
          }
          return "of ".concat(e3, " ").concat(String(t3));
        }
        u("ERR_AMBIGUOUS_ARGUMENT", 'The "%s" argument is ambiguous. %s', TypeError), u("ERR_INVALID_ARG_TYPE", function(t3, e3, i2) {
          var a2, s2, l2, u2, f2;
          if (void 0 === o && (o = r2(32791)), o("string" == typeof t3, "'name' must be a string"), "string" == typeof e3 && (s2 = "not ", e3.substr(0, s2.length) === s2) ? (a2 = "must not be", e3 = e3.replace(/^not /, "")) : a2 = "must be", function(t4, e4, r3) {
            return (void 0 === r3 || r3 > t4.length) && (r3 = t4.length), t4.substring(r3 - e4.length, r3) === e4;
          }(t3, " argument"))
            l2 = "The ".concat(t3, " ").concat(a2, " ").concat(c(e3, "type"));
          else {
            var h = ("number" != typeof f2 && (f2 = 0), f2 + ".".length > (u2 = t3).length || -1 === u2.indexOf(".", f2) ? "argument" : "property");
            l2 = 'The "'.concat(t3, '" ').concat(h, " ").concat(a2, " ").concat(c(e3, "type"));
          }
          return l2 + ". Received type ".concat(n2(i2));
        }, TypeError), u("ERR_INVALID_ARG_VALUE", function(t3, e3) {
          var n3 = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : "is invalid";
          void 0 === s && (s = r2(43827));
          var i2 = s.inspect(e3);
          return i2.length > 128 && (i2 = "".concat(i2.slice(0, 128), "...")), "The argument '".concat(t3, "' ").concat(n3, ". Received ").concat(i2);
        }, TypeError), u("ERR_INVALID_RETURN_VALUE", function(t3, e3, r3) {
          var i2;
          return i2 = r3 && r3.constructor && r3.constructor.name ? "instance of ".concat(r3.constructor.name) : "type ".concat(n2(r3)), "Expected ".concat(t3, ' to be returned from the "').concat(e3, '"') + " function but got ".concat(i2, ".");
        }, TypeError), u("ERR_MISSING_ARGS", function() {
          for (var t3 = arguments.length, e3 = new Array(t3), n3 = 0; n3 < t3; n3++)
            e3[n3] = arguments[n3];
          void 0 === o && (o = r2(32791)), o(e3.length > 0, "At least one arg needs to be specified");
          var i2 = "The ", a2 = e3.length;
          switch (e3 = e3.map(function(t4) {
            return '"'.concat(t4, '"');
          }), a2) {
            case 1:
              i2 += "".concat(e3[0], " argument");
              break;
            case 2:
              i2 += "".concat(e3[0], " and ").concat(e3[1], " arguments");
              break;
            default:
              i2 += e3.slice(0, a2 - 1).join(", "), i2 += ", and ".concat(e3[a2 - 1], " arguments");
          }
          return "".concat(i2, " must be specified");
        }, TypeError), t2.exports.codes = l;
      }, 74061: function(t2, e2, r2) {
        function n2(t3, e3) {
          return function(t4) {
            if (Array.isArray(t4))
              return t4;
          }(t3) || function(t4, e4) {
            var r3 = [], n3 = true, i2 = false, a2 = void 0;
            try {
              for (var o2, s2 = t4[Symbol.iterator](); !(n3 = (o2 = s2.next()).done) && (r3.push(o2.value), !e4 || r3.length !== e4); n3 = true)
                ;
            } catch (t5) {
              i2 = true, a2 = t5;
            } finally {
              try {
                n3 || null == s2.return || s2.return();
              } finally {
                if (i2)
                  throw a2;
              }
            }
            return r3;
          }(t3, e3) || function() {
            throw new TypeError("Invalid attempt to destructure non-iterable instance");
          }();
        }
        function i(t3) {
          return i = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(t4) {
            return typeof t4;
          } : function(t4) {
            return t4 && "function" == typeof Symbol && t4.constructor === Symbol && t4 !== Symbol.prototype ? "symbol" : typeof t4;
          }, i(t3);
        }
        var a = void 0 !== /a/g.flags, o = function(t3) {
          var e3 = [];
          return t3.forEach(function(t4) {
            return e3.push(t4);
          }), e3;
        }, s = function(t3) {
          var e3 = [];
          return t3.forEach(function(t4, r3) {
            return e3.push([r3, t4]);
          }), e3;
        }, l = Object.is ? Object.is : r2(64003), u = Object.getOwnPropertySymbols ? Object.getOwnPropertySymbols : function() {
          return [];
        }, c = Number.isNaN ? Number.isNaN : r2(15567);
        function f2(t3) {
          return t3.call.bind(t3);
        }
        var h = f2(Object.prototype.hasOwnProperty), p2 = f2(Object.prototype.propertyIsEnumerable), d2 = f2(Object.prototype.toString), v = r2(43827).types, g2 = v.isAnyArrayBuffer, y = v.isArrayBufferView, m2 = v.isDate, x = v.isMap, b = v.isRegExp, _ = v.isSet, w2 = v.isNativeError, T = v.isBoxedPrimitive, k = v.isNumberObject, A = v.isStringObject, M = v.isBooleanObject, S = v.isBigIntObject, E = v.isSymbolObject, L = v.isFloat32Array, C = v.isFloat64Array;
        function P(t3) {
          if (0 === t3.length || t3.length > 10)
            return true;
          for (var e3 = 0; e3 < t3.length; e3++) {
            var r3 = t3.charCodeAt(e3);
            if (r3 < 48 || r3 > 57)
              return true;
          }
          return 10 === t3.length && t3 >= Math.pow(2, 32);
        }
        function O(t3) {
          return Object.keys(t3).filter(P).concat(u(t3).filter(Object.prototype.propertyIsEnumerable.bind(t3)));
        }
        function I(t3, e3) {
          if (t3 === e3)
            return 0;
          for (var r3 = t3.length, n3 = e3.length, i2 = 0, a2 = Math.min(r3, n3); i2 < a2; ++i2)
            if (t3[i2] !== e3[i2]) {
              r3 = t3[i2], n3 = e3[i2];
              break;
            }
          return r3 < n3 ? -1 : n3 < r3 ? 1 : 0;
        }
        function D(t3, e3, r3, n3) {
          if (t3 === e3)
            return 0 !== t3 || !r3 || l(t3, e3);
          if (r3) {
            if ("object" !== i(t3))
              return "number" == typeof t3 && c(t3) && c(e3);
            if ("object" !== i(e3) || null === t3 || null === e3)
              return false;
            if (Object.getPrototypeOf(t3) !== Object.getPrototypeOf(e3))
              return false;
          } else {
            if (null === t3 || "object" !== i(t3))
              return (null === e3 || "object" !== i(e3)) && t3 == e3;
            if (null === e3 || "object" !== i(e3))
              return false;
          }
          var o2, s2, u2, f3, h2 = d2(t3);
          if (h2 !== d2(e3))
            return false;
          if (Array.isArray(t3)) {
            if (t3.length !== e3.length)
              return false;
            var p3 = O(t3), v2 = O(e3);
            return p3.length === v2.length && R(t3, e3, r3, n3, 1, p3);
          }
          if ("[object Object]" === h2 && (!x(t3) && x(e3) || !_(t3) && _(e3)))
            return false;
          if (m2(t3)) {
            if (!m2(e3) || Date.prototype.getTime.call(t3) !== Date.prototype.getTime.call(e3))
              return false;
          } else if (b(t3)) {
            if (!b(e3) || (u2 = t3, f3 = e3, !(a ? u2.source === f3.source && u2.flags === f3.flags : RegExp.prototype.toString.call(u2) === RegExp.prototype.toString.call(f3))))
              return false;
          } else if (w2(t3) || t3 instanceof Error) {
            if (t3.message !== e3.message || t3.name !== e3.name)
              return false;
          } else {
            if (y(t3)) {
              if (r3 || !L(t3) && !C(t3)) {
                if (!function(t4, e4) {
                  return t4.byteLength === e4.byteLength && 0 === I(new Uint8Array(t4.buffer, t4.byteOffset, t4.byteLength), new Uint8Array(e4.buffer, e4.byteOffset, e4.byteLength));
                }(t3, e3))
                  return false;
              } else if (!function(t4, e4) {
                if (t4.byteLength !== e4.byteLength)
                  return false;
                for (var r4 = 0; r4 < t4.byteLength; r4++)
                  if (t4[r4] !== e4[r4])
                    return false;
                return true;
              }(t3, e3))
                return false;
              var P2 = O(t3), D2 = O(e3);
              return P2.length === D2.length && R(t3, e3, r3, n3, 0, P2);
            }
            if (_(t3))
              return !(!_(e3) || t3.size !== e3.size) && R(t3, e3, r3, n3, 2);
            if (x(t3))
              return !(!x(e3) || t3.size !== e3.size) && R(t3, e3, r3, n3, 3);
            if (g2(t3)) {
              if (s2 = e3, (o2 = t3).byteLength !== s2.byteLength || 0 !== I(new Uint8Array(o2), new Uint8Array(s2)))
                return false;
            } else if (T(t3) && !function(t4, e4) {
              return k(t4) ? k(e4) && l(Number.prototype.valueOf.call(t4), Number.prototype.valueOf.call(e4)) : A(t4) ? A(e4) && String.prototype.valueOf.call(t4) === String.prototype.valueOf.call(e4) : M(t4) ? M(e4) && Boolean.prototype.valueOf.call(t4) === Boolean.prototype.valueOf.call(e4) : S(t4) ? S(e4) && BigInt.prototype.valueOf.call(t4) === BigInt.prototype.valueOf.call(e4) : E(e4) && Symbol.prototype.valueOf.call(t4) === Symbol.prototype.valueOf.call(e4);
            }(t3, e3))
              return false;
          }
          return R(t3, e3, r3, n3, 0);
        }
        function z(t3, e3) {
          return e3.filter(function(e4) {
            return p2(t3, e4);
          });
        }
        function R(t3, e3, r3, n3, i2, a2) {
          if (5 === arguments.length) {
            a2 = Object.keys(t3);
            var o2 = Object.keys(e3);
            if (a2.length !== o2.length)
              return false;
          }
          for (var s2 = 0; s2 < a2.length; s2++)
            if (!h(e3, a2[s2]))
              return false;
          if (r3 && 5 === arguments.length) {
            var l2 = u(t3);
            if (0 !== l2.length) {
              var c2 = 0;
              for (s2 = 0; s2 < l2.length; s2++) {
                var f3 = l2[s2];
                if (p2(t3, f3)) {
                  if (!p2(e3, f3))
                    return false;
                  a2.push(f3), c2++;
                } else if (p2(e3, f3))
                  return false;
              }
              var d3 = u(e3);
              if (l2.length !== d3.length && z(e3, d3).length !== c2)
                return false;
            } else {
              var v2 = u(e3);
              if (0 !== v2.length && 0 !== z(e3, v2).length)
                return false;
            }
          }
          if (0 === a2.length && (0 === i2 || 1 === i2 && 0 === t3.length || 0 === t3.size))
            return true;
          if (void 0 === n3)
            n3 = { val1: /* @__PURE__ */ new Map(), val2: /* @__PURE__ */ new Map(), position: 0 };
          else {
            var g3 = n3.val1.get(t3);
            if (void 0 !== g3) {
              var y2 = n3.val2.get(e3);
              if (void 0 !== y2)
                return g3 === y2;
            }
            n3.position++;
          }
          n3.val1.set(t3, n3.position), n3.val2.set(e3, n3.position);
          var m3 = V(t3, e3, r3, a2, n3, i2);
          return n3.val1.delete(t3), n3.val2.delete(e3), m3;
        }
        function F(t3, e3, r3, n3) {
          for (var i2 = o(t3), a2 = 0; a2 < i2.length; a2++) {
            var s2 = i2[a2];
            if (D(e3, s2, r3, n3))
              return t3.delete(s2), true;
          }
          return false;
        }
        function B(t3) {
          switch (i(t3)) {
            case "undefined":
              return null;
            case "object":
              return;
            case "symbol":
              return false;
            case "string":
              t3 = +t3;
            case "number":
              if (c(t3))
                return false;
          }
          return true;
        }
        function N(t3, e3, r3) {
          var n3 = B(r3);
          return null != n3 ? n3 : e3.has(n3) && !t3.has(n3);
        }
        function j(t3, e3, r3, n3, i2) {
          var a2 = B(r3);
          if (null != a2)
            return a2;
          var o2 = e3.get(a2);
          return !(void 0 === o2 && !e3.has(a2) || !D(n3, o2, false, i2)) && !t3.has(a2) && D(n3, o2, false, i2);
        }
        function U(t3, e3, r3, n3, i2, a2) {
          for (var s2 = o(t3), l2 = 0; l2 < s2.length; l2++) {
            var u2 = s2[l2];
            if (D(r3, u2, i2, a2) && D(n3, e3.get(u2), i2, a2))
              return t3.delete(u2), true;
          }
          return false;
        }
        function V(t3, e3, r3, a2, l2, u2) {
          var c2 = 0;
          if (2 === u2) {
            if (!function(t4, e4, r4, n3) {
              for (var a3 = null, s2 = o(t4), l3 = 0; l3 < s2.length; l3++) {
                var u3 = s2[l3];
                if ("object" === i(u3) && null !== u3)
                  null === a3 && (a3 = /* @__PURE__ */ new Set()), a3.add(u3);
                else if (!e4.has(u3)) {
                  if (r4)
                    return false;
                  if (!N(t4, e4, u3))
                    return false;
                  null === a3 && (a3 = /* @__PURE__ */ new Set()), a3.add(u3);
                }
              }
              if (null !== a3) {
                for (var c3 = o(e4), f4 = 0; f4 < c3.length; f4++) {
                  var h2 = c3[f4];
                  if ("object" === i(h2) && null !== h2) {
                    if (!F(a3, h2, r4, n3))
                      return false;
                  } else if (!r4 && !t4.has(h2) && !F(a3, h2, r4, n3))
                    return false;
                }
                return 0 === a3.size;
              }
              return true;
            }(t3, e3, r3, l2))
              return false;
          } else if (3 === u2) {
            if (!function(t4, e4, r4, a3) {
              for (var o2 = null, l3 = s(t4), u3 = 0; u3 < l3.length; u3++) {
                var c3 = n2(l3[u3], 2), f4 = c3[0], h2 = c3[1];
                if ("object" === i(f4) && null !== f4)
                  null === o2 && (o2 = /* @__PURE__ */ new Set()), o2.add(f4);
                else {
                  var p4 = e4.get(f4);
                  if (void 0 === p4 && !e4.has(f4) || !D(h2, p4, r4, a3)) {
                    if (r4)
                      return false;
                    if (!j(t4, e4, f4, h2, a3))
                      return false;
                    null === o2 && (o2 = /* @__PURE__ */ new Set()), o2.add(f4);
                  }
                }
              }
              if (null !== o2) {
                for (var d4 = s(e4), v2 = 0; v2 < d4.length; v2++) {
                  var g3 = n2(d4[v2], 2), y2 = (f4 = g3[0], g3[1]);
                  if ("object" === i(f4) && null !== f4) {
                    if (!U(o2, t4, f4, y2, r4, a3))
                      return false;
                  } else if (!(r4 || t4.has(f4) && D(t4.get(f4), y2, false, a3) || U(o2, t4, f4, y2, false, a3)))
                    return false;
                }
                return 0 === o2.size;
              }
              return true;
            }(t3, e3, r3, l2))
              return false;
          } else if (1 === u2)
            for (; c2 < t3.length; c2++) {
              if (!h(t3, c2)) {
                if (h(e3, c2))
                  return false;
                for (var f3 = Object.keys(t3); c2 < f3.length; c2++) {
                  var p3 = f3[c2];
                  if (!h(e3, p3) || !D(t3[p3], e3[p3], r3, l2))
                    return false;
                }
                return f3.length === Object.keys(e3).length;
              }
              if (!h(e3, c2) || !D(t3[c2], e3[c2], r3, l2))
                return false;
            }
          for (c2 = 0; c2 < a2.length; c2++) {
            var d3 = a2[c2];
            if (!D(t3[d3], e3[d3], r3, l2))
              return false;
          }
          return true;
        }
        t2.exports = { isDeepEqual: function(t3, e3) {
          return D(t3, e3, false);
        }, isDeepStrictEqual: function(t3, e3) {
          return D(t3, e3, true);
        } };
      }, 95341: function(t2, e2) {
        e2.byteLength = function(t3) {
          var e3 = l(t3), r3 = e3[0], n3 = e3[1];
          return 3 * (r3 + n3) / 4 - n3;
        }, e2.toByteArray = function(t3) {
          var e3, r3, a2 = l(t3), o2 = a2[0], s2 = a2[1], u2 = new i(function(t4, e4, r4) {
            return 3 * (e4 + r4) / 4 - r4;
          }(0, o2, s2)), c = 0, f2 = s2 > 0 ? o2 - 4 : o2;
          for (r3 = 0; r3 < f2; r3 += 4)
            e3 = n2[t3.charCodeAt(r3)] << 18 | n2[t3.charCodeAt(r3 + 1)] << 12 | n2[t3.charCodeAt(r3 + 2)] << 6 | n2[t3.charCodeAt(r3 + 3)], u2[c++] = e3 >> 16 & 255, u2[c++] = e3 >> 8 & 255, u2[c++] = 255 & e3;
          return 2 === s2 && (e3 = n2[t3.charCodeAt(r3)] << 2 | n2[t3.charCodeAt(r3 + 1)] >> 4, u2[c++] = 255 & e3), 1 === s2 && (e3 = n2[t3.charCodeAt(r3)] << 10 | n2[t3.charCodeAt(r3 + 1)] << 4 | n2[t3.charCodeAt(r3 + 2)] >> 2, u2[c++] = e3 >> 8 & 255, u2[c++] = 255 & e3), u2;
        }, e2.fromByteArray = function(t3) {
          for (var e3, n3 = t3.length, i2 = n3 % 3, a2 = [], o2 = 16383, s2 = 0, l2 = n3 - i2; s2 < l2; s2 += o2)
            a2.push(u(t3, s2, s2 + o2 > l2 ? l2 : s2 + o2));
          return 1 === i2 ? (e3 = t3[n3 - 1], a2.push(r2[e3 >> 2] + r2[e3 << 4 & 63] + "==")) : 2 === i2 && (e3 = (t3[n3 - 2] << 8) + t3[n3 - 1], a2.push(r2[e3 >> 10] + r2[e3 >> 4 & 63] + r2[e3 << 2 & 63] + "=")), a2.join("");
        };
        for (var r2 = [], n2 = [], i = "undefined" != typeof Uint8Array ? Uint8Array : Array, a = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", o = 0, s = a.length; o < s; ++o)
          r2[o] = a[o], n2[a.charCodeAt(o)] = o;
        function l(t3) {
          var e3 = t3.length;
          if (e3 % 4 > 0)
            throw new Error("Invalid string. Length must be a multiple of 4");
          var r3 = t3.indexOf("=");
          return -1 === r3 && (r3 = e3), [r3, r3 === e3 ? 0 : 4 - r3 % 4];
        }
        function u(t3, e3, n3) {
          for (var i2, a2, o2 = [], s2 = e3; s2 < n3; s2 += 3)
            i2 = (t3[s2] << 16 & 16711680) + (t3[s2 + 1] << 8 & 65280) + (255 & t3[s2 + 2]), o2.push(r2[(a2 = i2) >> 18 & 63] + r2[a2 >> 12 & 63] + r2[a2 >> 6 & 63] + r2[63 & a2]);
          return o2.join("");
        }
        n2["-".charCodeAt(0)] = 62, n2["_".charCodeAt(0)] = 63;
      }, 91358: function(t2) {
        function e2(t3, e3, r3, n3, i2) {
          for (var a2 = i2 + 1; n3 <= i2; ) {
            var o2 = n3 + i2 >>> 1, s = t3[o2];
            (void 0 !== r3 ? r3(s, e3) : s - e3) >= 0 ? (a2 = o2, i2 = o2 - 1) : n3 = o2 + 1;
          }
          return a2;
        }
        function r2(t3, e3, r3, n3, i2) {
          for (var a2 = i2 + 1; n3 <= i2; ) {
            var o2 = n3 + i2 >>> 1, s = t3[o2];
            (void 0 !== r3 ? r3(s, e3) : s - e3) > 0 ? (a2 = o2, i2 = o2 - 1) : n3 = o2 + 1;
          }
          return a2;
        }
        function n2(t3, e3, r3, n3, i2) {
          for (var a2 = n3 - 1; n3 <= i2; ) {
            var o2 = n3 + i2 >>> 1, s = t3[o2];
            (void 0 !== r3 ? r3(s, e3) : s - e3) < 0 ? (a2 = o2, n3 = o2 + 1) : i2 = o2 - 1;
          }
          return a2;
        }
        function i(t3, e3, r3, n3, i2) {
          for (var a2 = n3 - 1; n3 <= i2; ) {
            var o2 = n3 + i2 >>> 1, s = t3[o2];
            (void 0 !== r3 ? r3(s, e3) : s - e3) <= 0 ? (a2 = o2, n3 = o2 + 1) : i2 = o2 - 1;
          }
          return a2;
        }
        function a(t3, e3, r3, n3, i2) {
          for (; n3 <= i2; ) {
            var a2 = n3 + i2 >>> 1, o2 = t3[a2], s = void 0 !== r3 ? r3(o2, e3) : o2 - e3;
            if (0 === s)
              return a2;
            s <= 0 ? n3 = a2 + 1 : i2 = a2 - 1;
          }
          return -1;
        }
        function o(t3, e3, r3, n3, i2, a2) {
          return "function" == typeof r3 ? a2(t3, e3, r3, void 0 === n3 ? 0 : 0 | n3, void 0 === i2 ? t3.length - 1 : 0 | i2) : a2(t3, e3, void 0, void 0 === r3 ? 0 : 0 | r3, void 0 === n3 ? t3.length - 1 : 0 | n3);
        }
        t2.exports = { ge: function(t3, r3, n3, i2, a2) {
          return o(t3, r3, n3, i2, a2, e2);
        }, gt: function(t3, e3, n3, i2, a2) {
          return o(t3, e3, n3, i2, a2, r2);
        }, lt: function(t3, e3, r3, i2, a2) {
          return o(t3, e3, r3, i2, a2, n2);
        }, le: function(t3, e3, r3, n3, a2) {
          return o(t3, e3, r3, n3, a2, i);
        }, eq: function(t3, e3, r3, n3, i2) {
          return o(t3, e3, r3, n3, i2, a);
        } };
      }, 13547: function(t2, e2) {
        function r2(t3) {
          var e3 = 32;
          return (t3 &= -t3) && e3--, 65535 & t3 && (e3 -= 16), 16711935 & t3 && (e3 -= 8), 252645135 & t3 && (e3 -= 4), 858993459 & t3 && (e3 -= 2), 1431655765 & t3 && (e3 -= 1), e3;
        }
        e2.INT_BITS = 32, e2.INT_MAX = 2147483647, e2.INT_MIN = -1 << 31, e2.sign = function(t3) {
          return (t3 > 0) - (t3 < 0);
        }, e2.abs = function(t3) {
          var e3 = t3 >> 31;
          return (t3 ^ e3) - e3;
        }, e2.min = function(t3, e3) {
          return e3 ^ (t3 ^ e3) & -(t3 < e3);
        }, e2.max = function(t3, e3) {
          return t3 ^ (t3 ^ e3) & -(t3 < e3);
        }, e2.isPow2 = function(t3) {
          return !(t3 & t3 - 1 || !t3);
        }, e2.log2 = function(t3) {
          var e3, r3;
          return e3 = (t3 > 65535) << 4, e3 |= r3 = ((t3 >>>= e3) > 255) << 3, e3 |= r3 = ((t3 >>>= r3) > 15) << 2, (e3 |= r3 = ((t3 >>>= r3) > 3) << 1) | (t3 >>>= r3) >> 1;
        }, e2.log10 = function(t3) {
          return t3 >= 1e9 ? 9 : t3 >= 1e8 ? 8 : t3 >= 1e7 ? 7 : t3 >= 1e6 ? 6 : t3 >= 1e5 ? 5 : t3 >= 1e4 ? 4 : t3 >= 1e3 ? 3 : t3 >= 100 ? 2 : t3 >= 10 ? 1 : 0;
        }, e2.popCount = function(t3) {
          return 16843009 * ((t3 = (858993459 & (t3 -= t3 >>> 1 & 1431655765)) + (t3 >>> 2 & 858993459)) + (t3 >>> 4) & 252645135) >>> 24;
        }, e2.countTrailingZeros = r2, e2.nextPow2 = function(t3) {
          return t3 += 0 === t3, --t3, t3 |= t3 >>> 1, t3 |= t3 >>> 2, t3 |= t3 >>> 4, t3 |= t3 >>> 8, 1 + (t3 |= t3 >>> 16);
        }, e2.prevPow2 = function(t3) {
          return t3 |= t3 >>> 1, t3 |= t3 >>> 2, t3 |= t3 >>> 4, t3 |= t3 >>> 8, (t3 |= t3 >>> 16) - (t3 >>> 1);
        }, e2.parity = function(t3) {
          return t3 ^= t3 >>> 16, t3 ^= t3 >>> 8, t3 ^= t3 >>> 4, 27030 >>> (t3 &= 15) & 1;
        };
        var n2 = new Array(256);
        !function(t3) {
          for (var e3 = 0; e3 < 256; ++e3) {
            var r3 = e3, n3 = e3, i = 7;
            for (r3 >>>= 1; r3; r3 >>>= 1)
              n3 <<= 1, n3 |= 1 & r3, --i;
            t3[e3] = n3 << i & 255;
          }
        }(n2), e2.reverse = function(t3) {
          return n2[255 & t3] << 24 | n2[t3 >>> 8 & 255] << 16 | n2[t3 >>> 16 & 255] << 8 | n2[t3 >>> 24 & 255];
        }, e2.interleave2 = function(t3, e3) {
          return (t3 = 1431655765 & ((t3 = 858993459 & ((t3 = 252645135 & ((t3 = 16711935 & ((t3 &= 65535) | t3 << 8)) | t3 << 4)) | t3 << 2)) | t3 << 1)) | (e3 = 1431655765 & ((e3 = 858993459 & ((e3 = 252645135 & ((e3 = 16711935 & ((e3 &= 65535) | e3 << 8)) | e3 << 4)) | e3 << 2)) | e3 << 1)) << 1;
        }, e2.deinterleave2 = function(t3, e3) {
          return (t3 = 65535 & ((t3 = 16711935 & ((t3 = 252645135 & ((t3 = 858993459 & ((t3 = t3 >>> e3 & 1431655765) | t3 >>> 1)) | t3 >>> 2)) | t3 >>> 4)) | t3 >>> 16)) << 16 >> 16;
        }, e2.interleave3 = function(t3, e3, r3) {
          return t3 = 1227133513 & ((t3 = 3272356035 & ((t3 = 251719695 & ((t3 = 4278190335 & ((t3 &= 1023) | t3 << 16)) | t3 << 8)) | t3 << 4)) | t3 << 2), (t3 |= (e3 = 1227133513 & ((e3 = 3272356035 & ((e3 = 251719695 & ((e3 = 4278190335 & ((e3 &= 1023) | e3 << 16)) | e3 << 8)) | e3 << 4)) | e3 << 2)) << 1) | (r3 = 1227133513 & ((r3 = 3272356035 & ((r3 = 251719695 & ((r3 = 4278190335 & ((r3 &= 1023) | r3 << 16)) | r3 << 8)) | r3 << 4)) | r3 << 2)) << 2;
        }, e2.deinterleave3 = function(t3, e3) {
          return (t3 = 1023 & ((t3 = 4278190335 & ((t3 = 251719695 & ((t3 = 3272356035 & ((t3 = t3 >>> e3 & 1227133513) | t3 >>> 2)) | t3 >>> 4)) | t3 >>> 8)) | t3 >>> 16)) << 22 >> 22;
        }, e2.nextCombination = function(t3) {
          var e3 = t3 | t3 - 1;
          return e3 + 1 | (~e3 & -~e3) - 1 >>> r2(t3) + 1;
        };
      }, 44781: function(t2, e2, r2) {
        var n2 = r2(53435);
        t2.exports = function(t3, e3) {
          e3 || (e3 = {});
          var r3, o2, s, l, u, c, f2, h, p2, d2, v, g2 = null == e3.cutoff ? 0.25 : e3.cutoff, y = null == e3.radius ? 8 : e3.radius, m2 = e3.channel || 0;
          if (ArrayBuffer.isView(t3) || Array.isArray(t3)) {
            if (!e3.width || !e3.height)
              throw Error("For raw data width and height should be provided by options");
            r3 = e3.width, o2 = e3.height, l = t3, c = e3.stride ? e3.stride : Math.floor(t3.length / r3 / o2);
          } else
            window.HTMLCanvasElement && t3 instanceof window.HTMLCanvasElement ? (f2 = (h = t3).getContext("2d"), r3 = h.width, o2 = h.height, l = (p2 = f2.getImageData(0, 0, r3, o2)).data, c = 4) : window.CanvasRenderingContext2D && t3 instanceof window.CanvasRenderingContext2D ? (f2 = t3, r3 = (h = t3.canvas).width, o2 = h.height, l = (p2 = f2.getImageData(0, 0, r3, o2)).data, c = 4) : window.ImageData && t3 instanceof window.ImageData && (p2 = t3, r3 = t3.width, o2 = t3.height, l = p2.data, c = 4);
          if (s = Math.max(r3, o2), window.Uint8ClampedArray && l instanceof window.Uint8ClampedArray || window.Uint8Array && l instanceof window.Uint8Array)
            for (u = l, l = Array(r3 * o2), d2 = 0, v = u.length; d2 < v; d2++)
              l[d2] = u[d2 * c + m2] / 255;
          else if (1 !== c)
            throw Error("Raw data can have only 1 value per pixel");
          var x = Array(r3 * o2), b = Array(r3 * o2), _ = Array(s), w2 = Array(s), T = Array(s + 1), k = Array(s);
          for (d2 = 0, v = r3 * o2; d2 < v; d2++) {
            var A = l[d2];
            x[d2] = 1 === A ? 0 : 0 === A ? i : Math.pow(Math.max(0, 0.5 - A), 2), b[d2] = 1 === A ? i : 0 === A ? 0 : Math.pow(Math.max(0, A - 0.5), 2);
          }
          a(x, r3, o2, _, w2, k, T), a(b, r3, o2, _, w2, k, T);
          var M = window.Float32Array ? new Float32Array(r3 * o2) : new Array(r3 * o2);
          for (d2 = 0, v = r3 * o2; d2 < v; d2++)
            M[d2] = n2(1 - ((x[d2] - b[d2]) / y + g2), 0, 1);
          return M;
        };
        var i = 1e20;
        function a(t3, e3, r3, n3, i2, a2, s) {
          for (var l = 0; l < e3; l++) {
            for (var u = 0; u < r3; u++)
              n3[u] = t3[u * e3 + l];
            for (o(n3, i2, a2, s, r3), u = 0; u < r3; u++)
              t3[u * e3 + l] = i2[u];
          }
          for (u = 0; u < r3; u++) {
            for (l = 0; l < e3; l++)
              n3[l] = t3[u * e3 + l];
            for (o(n3, i2, a2, s, e3), l = 0; l < e3; l++)
              t3[u * e3 + l] = Math.sqrt(i2[l]);
          }
        }
        function o(t3, e3, r3, n3, a2) {
          r3[0] = 0, n3[0] = -i, n3[1] = +i;
          for (var o2 = 1, s = 0; o2 < a2; o2++) {
            for (var l = (t3[o2] + o2 * o2 - (t3[r3[s]] + r3[s] * r3[s])) / (2 * o2 - 2 * r3[s]); l <= n3[s]; )
              s--, l = (t3[o2] + o2 * o2 - (t3[r3[s]] + r3[s] * r3[s])) / (2 * o2 - 2 * r3[s]);
            r3[++s] = o2, n3[s] = l, n3[s + 1] = +i;
          }
          for (o2 = 0, s = 0; o2 < a2; o2++) {
            for (; n3[s + 1] < o2; )
              s++;
            e3[o2] = (o2 - r3[s]) * (o2 - r3[s]) + t3[r3[s]];
          }
        }
      }, 6614: function(t2, e2, r2) {
        var n2 = r2(68318), i = r2(68222), a = i(n2("String.prototype.indexOf"));
        t2.exports = function(t3, e3) {
          var r3 = n2(t3, !!e3);
          return "function" == typeof r3 && a(t3, ".prototype.") > -1 ? i(r3) : r3;
        };
      }, 68222: function(t2, e2, r2) {
        var n2 = r2(77575), i = r2(68318), a = i("%Function.prototype.apply%"), o = i("%Function.prototype.call%"), s = i("%Reflect.apply%", true) || n2.call(o, a), l = i("%Object.getOwnPropertyDescriptor%", true), u = i("%Object.defineProperty%", true), c = i("%Math.max%");
        if (u)
          try {
            u({}, "a", { value: 1 });
          } catch (t3) {
            u = null;
          }
        t2.exports = function(t3) {
          var e3 = s(n2, o, arguments);
          if (l && u) {
            var r3 = l(e3, "length");
            r3.configurable && u(e3, "length", { value: 1 + c(0, t3.length - (arguments.length - 1)) });
          }
          return e3;
        };
        var f2 = function() {
          return s(n2, a, arguments);
        };
        u ? u(t2.exports, "apply", { value: f2 }) : t2.exports.apply = f2;
      }, 53435: function(t2) {
        t2.exports = function(t3, e2, r2) {
          return e2 < r2 ? t3 < e2 ? e2 : t3 > r2 ? r2 : t3 : t3 < r2 ? r2 : t3 > e2 ? e2 : t3;
        };
      }, 6475: function(t2, e2, r2) {
        var n2 = r2(53435);
        function i(t3, e3) {
          null == e3 && (e3 = true);
          var r3 = t3[0], i2 = t3[1], a = t3[2], o = t3[3];
          return null == o && (o = e3 ? 1 : 255), e3 && (r3 *= 255, i2 *= 255, a *= 255, o *= 255), 16777216 * (r3 = 255 & n2(r3, 0, 255)) + ((i2 = 255 & n2(i2, 0, 255)) << 16) + ((a = 255 & n2(a, 0, 255)) << 8) + (255 & n2(o, 0, 255));
        }
        t2.exports = i, t2.exports.to = i, t2.exports.from = function(t3, e3) {
          var r3 = (t3 = +t3) >>> 24, n3 = (16711680 & t3) >>> 16, i2 = (65280 & t3) >>> 8, a = 255 & t3;
          return false === e3 ? [r3, n3, i2, a] : [r3 / 255, n3 / 255, i2 / 255, a / 255];
        };
      }, 76857: function(t2) {
        t2.exports = { aliceblue: [240, 248, 255], antiquewhite: [250, 235, 215], aqua: [0, 255, 255], aquamarine: [127, 255, 212], azure: [240, 255, 255], beige: [245, 245, 220], bisque: [255, 228, 196], black: [0, 0, 0], blanchedalmond: [255, 235, 205], blue: [0, 0, 255], blueviolet: [138, 43, 226], brown: [165, 42, 42], burlywood: [222, 184, 135], cadetblue: [95, 158, 160], chartreuse: [127, 255, 0], chocolate: [210, 105, 30], coral: [255, 127, 80], cornflowerblue: [100, 149, 237], cornsilk: [255, 248, 220], crimson: [220, 20, 60], cyan: [0, 255, 255], darkblue: [0, 0, 139], darkcyan: [0, 139, 139], darkgoldenrod: [184, 134, 11], darkgray: [169, 169, 169], darkgreen: [0, 100, 0], darkgrey: [169, 169, 169], darkkhaki: [189, 183, 107], darkmagenta: [139, 0, 139], darkolivegreen: [85, 107, 47], darkorange: [255, 140, 0], darkorchid: [153, 50, 204], darkred: [139, 0, 0], darksalmon: [233, 150, 122], darkseagreen: [143, 188, 143], darkslateblue: [72, 61, 139], darkslategray: [47, 79, 79], darkslategrey: [47, 79, 79], darkturquoise: [0, 206, 209], darkviolet: [148, 0, 211], deeppink: [255, 20, 147], deepskyblue: [0, 191, 255], dimgray: [105, 105, 105], dimgrey: [105, 105, 105], dodgerblue: [30, 144, 255], firebrick: [178, 34, 34], floralwhite: [255, 250, 240], forestgreen: [34, 139, 34], fuchsia: [255, 0, 255], gainsboro: [220, 220, 220], ghostwhite: [248, 248, 255], gold: [255, 215, 0], goldenrod: [218, 165, 32], gray: [128, 128, 128], green: [0, 128, 0], greenyellow: [173, 255, 47], grey: [128, 128, 128], honeydew: [240, 255, 240], hotpink: [255, 105, 180], indianred: [205, 92, 92], indigo: [75, 0, 130], ivory: [255, 255, 240], khaki: [240, 230, 140], lavender: [230, 230, 250], lavenderblush: [255, 240, 245], lawngreen: [124, 252, 0], lemonchiffon: [255, 250, 205], lightblue: [173, 216, 230], lightcoral: [240, 128, 128], lightcyan: [224, 255, 255], lightgoldenrodyellow: [250, 250, 210], lightgray: [211, 211, 211], lightgreen: [144, 238, 144], lightgrey: [211, 211, 211], lightpink: [255, 182, 193], lightsalmon: [255, 160, 122], lightseagreen: [32, 178, 170], lightskyblue: [135, 206, 250], lightslategray: [119, 136, 153], lightslategrey: [119, 136, 153], lightsteelblue: [176, 196, 222], lightyellow: [255, 255, 224], lime: [0, 255, 0], limegreen: [50, 205, 50], linen: [250, 240, 230], magenta: [255, 0, 255], maroon: [128, 0, 0], mediumaquamarine: [102, 205, 170], mediumblue: [0, 0, 205], mediumorchid: [186, 85, 211], mediumpurple: [147, 112, 219], mediumseagreen: [60, 179, 113], mediumslateblue: [123, 104, 238], mediumspringgreen: [0, 250, 154], mediumturquoise: [72, 209, 204], mediumvioletred: [199, 21, 133], midnightblue: [25, 25, 112], mintcream: [245, 255, 250], mistyrose: [255, 228, 225], moccasin: [255, 228, 181], navajowhite: [255, 222, 173], navy: [0, 0, 128], oldlace: [253, 245, 230], olive: [128, 128, 0], olivedrab: [107, 142, 35], orange: [255, 165, 0], orangered: [255, 69, 0], orchid: [218, 112, 214], palegoldenrod: [238, 232, 170], palegreen: [152, 251, 152], paleturquoise: [175, 238, 238], palevioletred: [219, 112, 147], papayawhip: [255, 239, 213], peachpuff: [255, 218, 185], peru: [205, 133, 63], pink: [255, 192, 203], plum: [221, 160, 221], powderblue: [176, 224, 230], purple: [128, 0, 128], rebeccapurple: [102, 51, 153], red: [255, 0, 0], rosybrown: [188, 143, 143], royalblue: [65, 105, 225], saddlebrown: [139, 69, 19], salmon: [250, 128, 114], sandybrown: [244, 164, 96], seagreen: [46, 139, 87], seashell: [255, 245, 238], sienna: [160, 82, 45], silver: [192, 192, 192], skyblue: [135, 206, 235], slateblue: [106, 90, 205], slategray: [112, 128, 144], slategrey: [112, 128, 144], snow: [255, 250, 250], springgreen: [0, 255, 127], steelblue: [70, 130, 180], tan: [210, 180, 140], teal: [0, 128, 128], thistle: [216, 191, 216], tomato: [255, 99, 71], turquoise: [64, 224, 208], violet: [238, 130, 238], wheat: [245, 222, 179], white: [255, 255, 255], whitesmoke: [245, 245, 245], yellow: [255, 255, 0], yellowgreen: [154, 205, 50] };
      }, 25075: function(t2, e2, r2) {
        var n2 = r2(36652), i = r2(53435), a = r2(90660);
        t2.exports = function(t3, e3) {
          "float" !== e3 && e3 || (e3 = "array"), "uint" === e3 && (e3 = "uint8"), "uint_clamped" === e3 && (e3 = "uint8_clamped");
          var r3 = new (a(e3))(4), o = "uint8" !== e3 && "uint8_clamped" !== e3;
          return t3.length && "string" != typeof t3 || ((t3 = n2(t3))[0] /= 255, t3[1] /= 255, t3[2] /= 255), function(t4) {
            return t4 instanceof Uint8Array || t4 instanceof Uint8ClampedArray || !!(Array.isArray(t4) && (t4[0] > 1 || 0 === t4[0]) && (t4[1] > 1 || 0 === t4[1]) && (t4[2] > 1 || 0 === t4[2]) && (!t4[3] || t4[3] > 1));
          }(t3) ? (r3[0] = t3[0], r3[1] = t3[1], r3[2] = t3[2], r3[3] = null != t3[3] ? t3[3] : 255, o && (r3[0] /= 255, r3[1] /= 255, r3[2] /= 255, r3[3] /= 255), r3) : (o ? (r3[0] = t3[0], r3[1] = t3[1], r3[2] = t3[2], r3[3] = null != t3[3] ? t3[3] : 1) : (r3[0] = i(Math.floor(255 * t3[0]), 0, 255), r3[1] = i(Math.floor(255 * t3[1]), 0, 255), r3[2] = i(Math.floor(255 * t3[2]), 0, 255), r3[3] = null == t3[3] ? 255 : i(Math.floor(255 * t3[3]), 0, 255)), r3);
        };
      }, 90736: function(t2, e2, r2) {
        var n2 = r2(76857), i = r2(10973), a = r2(46775);
        t2.exports = function(t3) {
          var e3, s, l = [], u = 1;
          if ("string" == typeof t3)
            if (n2[t3])
              l = n2[t3].slice(), s = "rgb";
            else if ("transparent" === t3)
              u = 0, s = "rgb", l = [0, 0, 0];
            else if (/^#[A-Fa-f0-9]+$/.test(t3)) {
              var c = (p2 = t3.slice(1)).length;
              u = 1, c <= 4 ? (l = [parseInt(p2[0] + p2[0], 16), parseInt(p2[1] + p2[1], 16), parseInt(p2[2] + p2[2], 16)], 4 === c && (u = parseInt(p2[3] + p2[3], 16) / 255)) : (l = [parseInt(p2[0] + p2[1], 16), parseInt(p2[2] + p2[3], 16), parseInt(p2[4] + p2[5], 16)], 8 === c && (u = parseInt(p2[6] + p2[7], 16) / 255)), l[0] || (l[0] = 0), l[1] || (l[1] = 0), l[2] || (l[2] = 0), s = "rgb";
            } else if (e3 = /^((?:rgb|hs[lvb]|hwb|cmyk?|xy[zy]|gray|lab|lchu?v?|[ly]uv|lms)a?)\s*\(([^\)]*)\)/.exec(t3)) {
              var f2 = e3[1], h = "rgb" === f2, p2 = f2.replace(/a$/, "");
              s = p2, c = "cmyk" === p2 ? 4 : "gray" === p2 ? 1 : 3, l = e3[2].trim().split(/\s*,\s*/).map(function(t4, e4) {
                if (/%$/.test(t4))
                  return e4 === c ? parseFloat(t4) / 100 : "rgb" === p2 ? 255 * parseFloat(t4) / 100 : parseFloat(t4);
                if ("h" === p2[e4]) {
                  if (/deg$/.test(t4))
                    return parseFloat(t4);
                  if (void 0 !== o[t4])
                    return o[t4];
                }
                return parseFloat(t4);
              }), f2 === p2 && l.push(1), u = h || void 0 === l[c] ? 1 : l[c], l = l.slice(0, c);
            } else
              t3.length > 10 && /[0-9](?:\s|\/)/.test(t3) && (l = t3.match(/([0-9]+)/g).map(function(t4) {
                return parseFloat(t4);
              }), s = t3.match(/([a-z])/gi).join("").toLowerCase());
          else if (isNaN(t3))
            if (i(t3)) {
              var d2 = a(t3.r, t3.red, t3.R, null);
              null !== d2 ? (s = "rgb", l = [d2, a(t3.g, t3.green, t3.G), a(t3.b, t3.blue, t3.B)]) : (s = "hsl", l = [a(t3.h, t3.hue, t3.H), a(t3.s, t3.saturation, t3.S), a(t3.l, t3.lightness, t3.L, t3.b, t3.brightness)]), u = a(t3.a, t3.alpha, t3.opacity, 1), null != t3.opacity && (u /= 100);
            } else
              (Array.isArray(t3) || r2.g.ArrayBuffer && ArrayBuffer.isView && ArrayBuffer.isView(t3)) && (l = [t3[0], t3[1], t3[2]], s = "rgb", u = 4 === t3.length ? t3[3] : 1);
          else
            s = "rgb", l = [t3 >>> 16, (65280 & t3) >>> 8, 255 & t3];
          return { space: s, values: l, alpha: u };
        };
        var o = { red: 0, orange: 60, yellow: 120, green: 180, blue: 240, purple: 300 };
      }, 36652: function(t2, e2, r2) {
        var n2 = r2(90736), i = r2(80009), a = r2(53435);
        t2.exports = function(t3) {
          var e3, r3 = n2(t3);
          return r3.space ? ((e3 = Array(3))[0] = a(r3.values[0], 0, 255), e3[1] = a(r3.values[1], 0, 255), e3[2] = a(r3.values[2], 0, 255), "h" === r3.space[0] && (e3 = i.rgb(e3)), e3.push(a(r3.alpha, 0, 1)), e3) : [];
        };
      }, 80009: function(t2, e2, r2) {
        var n2 = r2(6866);
        t2.exports = { name: "hsl", min: [0, 0, 0], max: [360, 100, 100], channel: ["hue", "saturation", "lightness"], alias: ["HSL"], rgb: function(t3) {
          var e3, r3, n3, i, a, o = t3[0] / 360, s = t3[1] / 100, l = t3[2] / 100;
          if (0 === s)
            return [a = 255 * l, a, a];
          e3 = 2 * l - (r3 = l < 0.5 ? l * (1 + s) : l + s - l * s), i = [0, 0, 0];
          for (var u = 0; u < 3; u++)
            (n3 = o + 1 / 3 * -(u - 1)) < 0 ? n3++ : n3 > 1 && n3--, a = 6 * n3 < 1 ? e3 + 6 * (r3 - e3) * n3 : 2 * n3 < 1 ? r3 : 3 * n3 < 2 ? e3 + (r3 - e3) * (2 / 3 - n3) * 6 : e3, i[u] = 255 * a;
          return i;
        } }, n2.hsl = function(t3) {
          var e3, r3, n3 = t3[0] / 255, i = t3[1] / 255, a = t3[2] / 255, o = Math.min(n3, i, a), s = Math.max(n3, i, a), l = s - o;
          return s === o ? e3 = 0 : n3 === s ? e3 = (i - a) / l : i === s ? e3 = 2 + (a - n3) / l : a === s && (e3 = 4 + (n3 - i) / l), (e3 = Math.min(60 * e3, 360)) < 0 && (e3 += 360), r3 = (o + s) / 2, [e3, 100 * (s === o ? 0 : r3 <= 0.5 ? l / (s + o) : l / (2 - s - o)), 100 * r3];
        };
      }, 6866: function(t2) {
        t2.exports = { name: "rgb", min: [0, 0, 0], max: [255, 255, 255], channel: ["red", "green", "blue"], alias: ["RGB"] };
      }, 24138: function(t2) {
        t2.exports = { AFG: "afghan", ALA: "\\b\\wland", ALB: "albania", DZA: "algeria", ASM: "^(?=.*americ).*samoa", AND: "andorra", AGO: "angola", AIA: "anguill?a", ATA: "antarctica", ATG: "antigua", ARG: "argentin", ARM: "armenia", ABW: "^(?!.*bonaire).*\\baruba", AUS: "australia", AUT: "^(?!.*hungary).*austria|\\baustri.*\\bemp", AZE: "azerbaijan", BHS: "bahamas", BHR: "bahrain", BGD: "bangladesh|^(?=.*east).*paki?stan", BRB: "barbados", BLR: "belarus|byelo", BEL: "^(?!.*luxem).*belgium", BLZ: "belize|^(?=.*british).*honduras", BEN: "benin|dahome", BMU: "bermuda", BTN: "bhutan", BOL: "bolivia", BES: "^(?=.*bonaire).*eustatius|^(?=.*carib).*netherlands|\\bbes.?islands", BIH: "herzegovina|bosnia", BWA: "botswana|bechuana", BVT: "bouvet", BRA: "brazil", IOT: "british.?indian.?ocean", BRN: "brunei", BGR: "bulgaria", BFA: "burkina|\\bfaso|upper.?volta", BDI: "burundi", CPV: "verde", KHM: "cambodia|kampuchea|khmer", CMR: "cameroon", CAN: "canada", CYM: "cayman", CAF: "\\bcentral.african.republic", TCD: "\\bchad", CHL: "\\bchile", CHN: "^(?!.*\\bmac)(?!.*\\bhong)(?!.*\\btai)(?!.*\\brep).*china|^(?=.*peo)(?=.*rep).*china", CXR: "christmas", CCK: "\\bcocos|keeling", COL: "colombia", COM: "comoro", COG: "^(?!.*\\bdem)(?!.*\\bd[\\.]?r)(?!.*kinshasa)(?!.*zaire)(?!.*belg)(?!.*l.opoldville)(?!.*free).*\\bcongo", COK: "\\bcook", CRI: "costa.?rica", CIV: "ivoire|ivory", HRV: "croatia", CUB: "\\bcuba", CUW: "^(?!.*bonaire).*\\bcura(c|ç)ao", CYP: "cyprus", CSK: "czechoslovakia", CZE: "^(?=.*rep).*czech|czechia|bohemia", COD: "\\bdem.*congo|congo.*\\bdem|congo.*\\bd[\\.]?r|\\bd[\\.]?r.*congo|belgian.?congo|congo.?free.?state|kinshasa|zaire|l.opoldville|drc|droc|rdc", DNK: "denmark", DJI: "djibouti", DMA: "dominica(?!n)", DOM: "dominican.rep", ECU: "ecuador", EGY: "egypt", SLV: "el.?salvador", GNQ: "guine.*eq|eq.*guine|^(?=.*span).*guinea", ERI: "eritrea", EST: "estonia", ETH: "ethiopia|abyssinia", FLK: "falkland|malvinas", FRO: "faroe|faeroe", FJI: "fiji", FIN: "finland", FRA: "^(?!.*\\bdep)(?!.*martinique).*france|french.?republic|\\bgaul", GUF: "^(?=.*french).*guiana", PYF: "french.?polynesia|tahiti", ATF: "french.?southern", GAB: "gabon", GMB: "gambia", GEO: "^(?!.*south).*georgia", DDR: "german.?democratic.?republic|democratic.?republic.*germany|east.germany", DEU: "^(?!.*east).*germany|^(?=.*\\bfed.*\\brep).*german", GHA: "ghana|gold.?coast", GIB: "gibraltar", GRC: "greece|hellenic|hellas", GRL: "greenland", GRD: "grenada", GLP: "guadeloupe", GUM: "\\bguam", GTM: "guatemala", GGY: "guernsey", GIN: "^(?!.*eq)(?!.*span)(?!.*bissau)(?!.*portu)(?!.*new).*guinea", GNB: "bissau|^(?=.*portu).*guinea", GUY: "guyana|british.?guiana", HTI: "haiti", HMD: "heard.*mcdonald", VAT: "holy.?see|vatican|papal.?st", HND: "^(?!.*brit).*honduras", HKG: "hong.?kong", HUN: "^(?!.*austr).*hungary", ISL: "iceland", IND: "india(?!.*ocea)", IDN: "indonesia", IRN: "\\biran|persia", IRQ: "\\biraq|mesopotamia", IRL: "(^ireland)|(^republic.*ireland)", IMN: "^(?=.*isle).*\\bman", ISR: "israel", ITA: "italy", JAM: "jamaica", JPN: "japan", JEY: "jersey", JOR: "jordan", KAZ: "kazak", KEN: "kenya|british.?east.?africa|east.?africa.?prot", KIR: "kiribati", PRK: "^(?=.*democrat|people|north|d.*p.*.r).*\\bkorea|dprk|korea.*(d.*p.*r)", KWT: "kuwait", KGZ: "kyrgyz|kirghiz", LAO: "\\blaos?\\b", LVA: "latvia", LBN: "lebanon", LSO: "lesotho|basuto", LBR: "liberia", LBY: "libya", LIE: "liechtenstein", LTU: "lithuania", LUX: "^(?!.*belg).*luxem", MAC: "maca(o|u)", MDG: "madagascar|malagasy", MWI: "malawi|nyasa", MYS: "malaysia", MDV: "maldive", MLI: "\\bmali\\b", MLT: "\\bmalta", MHL: "marshall", MTQ: "martinique", MRT: "mauritania", MUS: "mauritius", MYT: "\\bmayotte", MEX: "\\bmexic", FSM: "fed.*micronesia|micronesia.*fed", MCO: "monaco", MNG: "mongolia", MNE: "^(?!.*serbia).*montenegro", MSR: "montserrat", MAR: "morocco|\\bmaroc", MOZ: "mozambique", MMR: "myanmar|burma", NAM: "namibia", NRU: "nauru", NPL: "nepal", NLD: "^(?!.*\\bant)(?!.*\\bcarib).*netherlands", ANT: "^(?=.*\\bant).*(nether|dutch)", NCL: "new.?caledonia", NZL: "new.?zealand", NIC: "nicaragua", NER: "\\bniger(?!ia)", NGA: "nigeria", NIU: "niue", NFK: "norfolk", MNP: "mariana", NOR: "norway", OMN: "\\boman|trucial", PAK: "^(?!.*east).*paki?stan", PLW: "palau", PSE: "palestin|\\bgaza|west.?bank", PAN: "panama", PNG: "papua|new.?guinea", PRY: "paraguay", PER: "peru", PHL: "philippines", PCN: "pitcairn", POL: "poland", PRT: "portugal", PRI: "puerto.?rico", QAT: "qatar", KOR: "^(?!.*d.*p.*r)(?!.*democrat)(?!.*people)(?!.*north).*\\bkorea(?!.*d.*p.*r)", MDA: "moldov|b(a|e)ssarabia", REU: "r(e|é)union", ROU: "r(o|u|ou)mania", RUS: "\\brussia|soviet.?union|u\\.?s\\.?s\\.?r|socialist.?republics", RWA: "rwanda", BLM: "barth(e|é)lemy", SHN: "helena", KNA: "kitts|\\bnevis", LCA: "\\blucia", MAF: "^(?=.*collectivity).*martin|^(?=.*france).*martin(?!ique)|^(?=.*french).*martin(?!ique)", SPM: "miquelon", VCT: "vincent", WSM: "^(?!.*amer).*samoa", SMR: "san.?marino", STP: "\\bs(a|ã)o.?tom(e|é)", SAU: "\\bsa\\w*.?arabia", SEN: "senegal", SRB: "^(?!.*monte).*serbia", SYC: "seychell", SLE: "sierra", SGP: "singapore", SXM: "^(?!.*martin)(?!.*saba).*maarten", SVK: "^(?!.*cze).*slovak", SVN: "slovenia", SLB: "solomon", SOM: "somali", ZAF: "south.africa|s\\\\..?africa", SGS: "south.?georgia|sandwich", SSD: "\\bs\\w*.?sudan", ESP: "spain", LKA: "sri.?lanka|ceylon", SDN: "^(?!.*\\bs(?!u)).*sudan", SUR: "surinam|dutch.?guiana", SJM: "svalbard", SWZ: "swaziland", SWE: "sweden", CHE: "switz|swiss", SYR: "syria", TWN: "taiwan|taipei|formosa|^(?!.*peo)(?=.*rep).*china", TJK: "tajik", THA: "thailand|\\bsiam", MKD: "macedonia|fyrom", TLS: "^(?=.*leste).*timor|^(?=.*east).*timor", TGO: "togo", TKL: "tokelau", TON: "tonga", TTO: "trinidad|tobago", TUN: "tunisia", TUR: "turkey", TKM: "turkmen", TCA: "turks", TUV: "tuvalu", UGA: "uganda", UKR: "ukrain", ARE: "emirates|^u\\.?a\\.?e\\.?$|united.?arab.?em", GBR: "united.?kingdom|britain|^u\\.?k\\.?$", TZA: "tanzania", USA: "united.?states\\b(?!.*islands)|\\bu\\.?s\\.?a\\.?\\b|^\\s*u\\.?s\\.?\\b(?!.*islands)", UMI: "minor.?outlying.?is", URY: "uruguay", UZB: "uzbek", VUT: "vanuatu|new.?hebrides", VEN: "venezuela", VNM: "^(?!.*republic).*viet.?nam|^(?=.*socialist).*viet.?nam", VGB: "^(?=.*\\bu\\.?\\s?k).*virgin|^(?=.*brit).*virgin|^(?=.*kingdom).*virgin", VIR: "^(?=.*\\bu\\.?\\s?s).*virgin|^(?=.*states).*virgin", WLF: "futuna|wallis", ESH: "western.sahara", YEM: "^(?!.*arab)(?!.*north)(?!.*sana)(?!.*peo)(?!.*dem)(?!.*south)(?!.*aden)(?!.*\\bp\\.?d\\.?r).*yemen", YMD: "^(?=.*peo).*yemen|^(?!.*rep)(?=.*dem).*yemen|^(?=.*south).*yemen|^(?=.*aden).*yemen|^(?=.*\\bp\\.?d\\.?r).*yemen", YUG: "yugoslavia", ZMB: "zambia|northern.?rhodesia", EAZ: "zanzibar", ZWE: "zimbabwe|^(?!.*northern).*rhodesia" };
      }, 72791: function(t2, e2, r2) {
        t2.exports = { parse: r2(41004), stringify: r2(53313) };
      }, 63625: function(t2, e2, r2) {
        var n2 = r2(40402);
        t2.exports = { isSize: function(t3) {
          return /^[\d\.]/.test(t3) || -1 !== t3.indexOf("/") || -1 !== n2.indexOf(t3);
        } };
      }, 41004: function(t2, e2, r2) {
        var n2 = r2(90448), i = r2(38732), a = r2(41901), o = r2(15659), s = r2(96209), l = r2(83794), u = r2(99011), c = r2(63625).isSize;
        t2.exports = h;
        var f2 = h.cache = {};
        function h(t3) {
          if ("string" != typeof t3)
            throw new Error("Font argument must be a string.");
          if (f2[t3])
            return f2[t3];
          if ("" === t3)
            throw new Error("Cannot parse an empty string.");
          if (-1 !== a.indexOf(t3))
            return f2[t3] = { system: t3 };
          for (var e3, r3 = { style: "normal", variant: "normal", weight: "normal", stretch: "normal", lineHeight: "normal", size: "1rem", family: ["serif"] }, h2 = u(t3, /\s+/); e3 = h2.shift(); ) {
            if (-1 !== i.indexOf(e3))
              return ["style", "variant", "weight", "stretch"].forEach(function(t4) {
                r3[t4] = e3;
              }), f2[t3] = r3;
            if (-1 === s.indexOf(e3))
              if ("normal" !== e3 && "small-caps" !== e3)
                if (-1 === l.indexOf(e3)) {
                  if (-1 === o.indexOf(e3)) {
                    if (c(e3)) {
                      var d2 = u(e3, "/");
                      if (r3.size = d2[0], null != d2[1] ? r3.lineHeight = p2(d2[1]) : "/" === h2[0] && (h2.shift(), r3.lineHeight = p2(h2.shift())), !h2.length)
                        throw new Error("Missing required font-family.");
                      return r3.family = u(h2.join(" "), /\s*,\s*/).map(n2), f2[t3] = r3;
                    }
                    throw new Error("Unknown or unsupported font token: " + e3);
                  }
                  r3.weight = e3;
                } else
                  r3.stretch = e3;
              else
                r3.variant = e3;
            else
              r3.style = e3;
          }
          throw new Error("Missing required font-size.");
        }
        function p2(t3) {
          var e3 = parseFloat(t3);
          return e3.toString() === t3 ? e3 : t3;
        }
      }, 53313: function(t2, e2, r2) {
        var n2 = r2(71299), i = r2(63625).isSize, a = d2(r2(38732)), o = d2(r2(41901)), s = d2(r2(15659)), l = d2(r2(96209)), u = d2(r2(83794)), c = { normal: 1, "small-caps": 1 }, f2 = { serif: 1, "sans-serif": 1, monospace: 1, cursive: 1, fantasy: 1, "system-ui": 1 }, h = "serif";
        function p2(t3, e3) {
          if (t3 && !e3[t3] && !a[t3])
            throw Error("Unknown keyword `" + t3 + "`");
          return t3;
        }
        function d2(t3) {
          for (var e3 = {}, r3 = 0; r3 < t3.length; r3++)
            e3[t3[r3]] = 1;
          return e3;
        }
        t2.exports = function(t3) {
          if ((t3 = n2(t3, { style: "style fontstyle fontStyle font-style slope distinction", variant: "variant font-variant fontVariant fontvariant var capitalization", weight: "weight w font-weight fontWeight fontweight", stretch: "stretch font-stretch fontStretch fontstretch width", size: "size s font-size fontSize fontsize height em emSize", lineHeight: "lh line-height lineHeight lineheight leading", family: "font family fontFamily font-family fontfamily type typeface face", system: "system reserved default global" })).system)
            return t3.system && p2(t3.system, o), t3.system;
          if (p2(t3.style, l), p2(t3.variant, c), p2(t3.weight, s), p2(t3.stretch, u), null == t3.size && (t3.size = "1rem"), "number" == typeof t3.size && (t3.size += "px"), !i)
            throw Error("Bad size value `" + t3.size + "`");
          t3.family || (t3.family = h), Array.isArray(t3.family) && (t3.family.length || (t3.family = [h]), t3.family = t3.family.map(function(t4) {
            return f2[t4] ? t4 : '"' + t4 + '"';
          }).join(", "));
          var e3 = [];
          return e3.push(t3.style), t3.variant !== t3.style && e3.push(t3.variant), t3.weight !== t3.variant && t3.weight !== t3.style && e3.push(t3.weight), t3.stretch !== t3.weight && t3.stretch !== t3.variant && t3.stretch !== t3.style && e3.push(t3.stretch), e3.push(t3.size + (null == t3.lineHeight || "normal" === t3.lineHeight || t3.lineHeight + "" == "1" ? "" : "/" + t3.lineHeight)), e3.push(t3.family), e3.filter(Boolean).join(" ");
        };
      }, 55174: function(t2, e2, r2) {
        var n2, i = r2(24582), a = r2(10424), o = r2(82527), s = r2(19012), l = r2(21780), u = r2(16906), c = Function.prototype.bind, f2 = Object.defineProperty, h = Object.prototype.hasOwnProperty;
        n2 = function(t3, e3, r3) {
          var n3, i2 = a(e3) && o(e3.value);
          return delete (n3 = s(e3)).writable, delete n3.value, n3.get = function() {
            return !r3.overwriteDefinition && h.call(this, t3) ? i2 : (e3.value = c.call(i2, r3.resolveContext ? r3.resolveContext(this) : this), f2(this, t3, e3), this[t3]);
          }, n3;
        }, t2.exports = function(t3) {
          var e3 = l(arguments[1]);
          return i(e3.resolveContext) && o(e3.resolveContext), u(t3, function(t4, r3) {
            return n2(r3, t4, e3);
          });
        };
      }, 62072: function(t2, e2, r2) {
        var n2 = r2(24582), i = r2(84985), a = r2(95879), o = r2(21780), s = r2(66741), l = t2.exports = function(t3, e3) {
          var r3, i2, l2, u, c;
          return arguments.length < 2 || "string" != typeof t3 ? (u = e3, e3 = t3, t3 = null) : u = arguments[2], n2(t3) ? (r3 = s.call(t3, "c"), i2 = s.call(t3, "e"), l2 = s.call(t3, "w")) : (r3 = l2 = true, i2 = false), c = { value: e3, configurable: r3, enumerable: i2, writable: l2 }, u ? a(o(u), c) : c;
        };
        l.gs = function(t3, e3, r3) {
          var l2, u, c, f2;
          return "string" != typeof t3 ? (c = r3, r3 = e3, e3 = t3, t3 = null) : c = arguments[3], n2(e3) ? i(e3) ? n2(r3) ? i(r3) || (c = r3, r3 = void 0) : r3 = void 0 : (c = e3, e3 = r3 = void 0) : e3 = void 0, n2(t3) ? (l2 = s.call(t3, "c"), u = s.call(t3, "e")) : (l2 = true, u = false), f2 = { get: e3, set: r3, configurable: l2, enumerable: u }, c ? a(o(c), f2) : f2;
        };
      }, 33064: function(t2, e2, r2) {
        function n2(t3, e3) {
          return t3 < e3 ? -1 : t3 > e3 ? 1 : t3 >= e3 ? 0 : NaN;
        }
        r2.d(e2, { j2: function() {
          return n2;
        }, Fp: function() {
          return s;
        }, J6: function() {
          return u;
        }, TS: function() {
          return c;
        }, VV: function() {
          return f2;
        }, w6: function() {
          return h;
        }, Sm: function() {
          return p2;
        } }), 1 === (i = n2).length && (a = i, i = function(t3, e3) {
          return n2(a(t3), e3);
        });
        var i, a;
        function s(t3, e3) {
          var r3, n3, i2 = t3.length, a2 = -1;
          if (null == e3) {
            for (; ++a2 < i2; )
              if (null != (r3 = t3[a2]) && r3 >= r3)
                for (n3 = r3; ++a2 < i2; )
                  null != (r3 = t3[a2]) && r3 > n3 && (n3 = r3);
          } else
            for (; ++a2 < i2; )
              if (null != (r3 = e3(t3[a2], a2, t3)) && r3 >= r3)
                for (n3 = r3; ++a2 < i2; )
                  null != (r3 = e3(t3[a2], a2, t3)) && r3 > n3 && (n3 = r3);
          return n3;
        }
        function l(t3) {
          return null === t3 ? NaN : +t3;
        }
        function u(t3, e3) {
          var r3, n3 = t3.length, i2 = n3, a2 = -1, o = 0;
          if (null == e3)
            for (; ++a2 < n3; )
              isNaN(r3 = l(t3[a2])) ? --i2 : o += r3;
          else
            for (; ++a2 < n3; )
              isNaN(r3 = l(e3(t3[a2], a2, t3))) ? --i2 : o += r3;
          if (i2)
            return o / i2;
        }
        function c(t3) {
          for (var e3, r3, n3, i2 = t3.length, a2 = -1, o = 0; ++a2 < i2; )
            o += t3[a2].length;
          for (r3 = new Array(o); --i2 >= 0; )
            for (e3 = (n3 = t3[i2]).length; --e3 >= 0; )
              r3[--o] = n3[e3];
          return r3;
        }
        function f2(t3, e3) {
          var r3, n3, i2 = t3.length, a2 = -1;
          if (null == e3) {
            for (; ++a2 < i2; )
              if (null != (r3 = t3[a2]) && r3 >= r3)
                for (n3 = r3; ++a2 < i2; )
                  null != (r3 = t3[a2]) && n3 > r3 && (n3 = r3);
          } else
            for (; ++a2 < i2; )
              if (null != (r3 = e3(t3[a2], a2, t3)) && r3 >= r3)
                for (n3 = r3; ++a2 < i2; )
                  null != (r3 = e3(t3[a2], a2, t3)) && n3 > r3 && (n3 = r3);
          return n3;
        }
        function h(t3, e3, r3) {
          t3 = +t3, e3 = +e3, r3 = (i2 = arguments.length) < 2 ? (e3 = t3, t3 = 0, 1) : i2 < 3 ? 1 : +r3;
          for (var n3 = -1, i2 = 0 | Math.max(0, Math.ceil((e3 - t3) / r3)), a2 = new Array(i2); ++n3 < i2; )
            a2[n3] = t3 + n3 * r3;
          return a2;
        }
        function p2(t3, e3) {
          var r3, n3 = t3.length, i2 = -1, a2 = 0;
          if (null == e3)
            for (; ++i2 < n3; )
              (r3 = +t3[i2]) && (a2 += r3);
          else
            for (; ++i2 < n3; )
              (r3 = +e3(t3[i2], i2, t3)) && (a2 += r3);
          return a2;
        }
      }, 15140: function(t2, e2, r2) {
        r2.d(e2, { UI: function() {
          return o;
        }, b1: function() {
          return s;
        } });
        var n2 = "$";
        function i() {
        }
        function a(t3, e3) {
          var r3 = new i();
          if (t3 instanceof i)
            t3.each(function(t4, e4) {
              r3.set(e4, t4);
            });
          else if (Array.isArray(t3)) {
            var n3, a2 = -1, o2 = t3.length;
            if (null == e3)
              for (; ++a2 < o2; )
                r3.set(a2, t3[a2]);
            else
              for (; ++a2 < o2; )
                r3.set(e3(n3 = t3[a2], a2, t3), n3);
          } else if (t3)
            for (var s2 in t3)
              r3.set(s2, t3[s2]);
          return r3;
        }
        i.prototype = a.prototype = { constructor: i, has: function(t3) {
          return n2 + t3 in this;
        }, get: function(t3) {
          return this[n2 + t3];
        }, set: function(t3, e3) {
          return this[n2 + t3] = e3, this;
        }, remove: function(t3) {
          var e3 = n2 + t3;
          return e3 in this && delete this[e3];
        }, clear: function() {
          for (var t3 in this)
            t3[0] === n2 && delete this[t3];
        }, keys: function() {
          var t3 = [];
          for (var e3 in this)
            e3[0] === n2 && t3.push(e3.slice(1));
          return t3;
        }, values: function() {
          var t3 = [];
          for (var e3 in this)
            e3[0] === n2 && t3.push(this[e3]);
          return t3;
        }, entries: function() {
          var t3 = [];
          for (var e3 in this)
            e3[0] === n2 && t3.push({ key: e3.slice(1), value: this[e3] });
          return t3;
        }, size: function() {
          var t3 = 0;
          for (var e3 in this)
            e3[0] === n2 && ++t3;
          return t3;
        }, empty: function() {
          for (var t3 in this)
            if (t3[0] === n2)
              return false;
          return true;
        }, each: function(t3) {
          for (var e3 in this)
            e3[0] === n2 && t3(this[e3], e3.slice(1), this);
        } };
        var o = a;
        function s() {
          var t3, e3, r3, n3 = [], i2 = [];
          function a2(r4, i3, s3, l2) {
            if (i3 >= n3.length)
              return null != t3 && r4.sort(t3), null != e3 ? e3(r4) : r4;
            for (var u2, c2, f3, h2 = -1, p3 = r4.length, d2 = n3[i3++], v = o(), g2 = s3(); ++h2 < p3; )
              (f3 = v.get(u2 = d2(c2 = r4[h2]) + "")) ? f3.push(c2) : v.set(u2, [c2]);
            return v.each(function(t4, e4) {
              l2(g2, e4, a2(t4, i3, s3, l2));
            }), g2;
          }
          function s2(t4, r4) {
            if (++r4 > n3.length)
              return t4;
            var a3, o2 = i2[r4 - 1];
            return null != e3 && r4 >= n3.length ? a3 = t4.entries() : (a3 = [], t4.each(function(t5, e4) {
              a3.push({ key: e4, values: s2(t5, r4) });
            })), null != o2 ? a3.sort(function(t5, e4) {
              return o2(t5.key, e4.key);
            }) : a3;
          }
          return r3 = { object: function(t4) {
            return a2(t4, 0, l, u);
          }, map: function(t4) {
            return a2(t4, 0, c, f2);
          }, entries: function(t4) {
            return s2(a2(t4, 0, c, f2), 0);
          }, key: function(t4) {
            return n3.push(t4), r3;
          }, sortKeys: function(t4) {
            return i2[n3.length - 1] = t4, r3;
          }, sortValues: function(e4) {
            return t3 = e4, r3;
          }, rollup: function(t4) {
            return e3 = t4, r3;
          } };
        }
        function l() {
          return {};
        }
        function u(t3, e3, r3) {
          t3[e3] = r3;
        }
        function c() {
          return o();
        }
        function f2(t3, e3, r3) {
          t3.set(e3, r3);
        }
        function h() {
        }
        var p2 = o.prototype;
        h.prototype = { constructor: h, has: p2.has, add: function(t3) {
          return this[n2 + (t3 += "")] = t3, this;
        }, remove: p2.remove, clear: p2.clear, values: p2.keys, size: p2.size, empty: p2.empty, each: p2.each };
      }, 49887: function(t2, e2, r2) {
        function n2(t3, e3) {
          var r3;
          function n3() {
            var n4, i2, a2 = r3.length, o2 = 0, s2 = 0;
            for (n4 = 0; n4 < a2; ++n4)
              o2 += (i2 = r3[n4]).x, s2 += i2.y;
            for (o2 = o2 / a2 - t3, s2 = s2 / a2 - e3, n4 = 0; n4 < a2; ++n4)
              (i2 = r3[n4]).x -= o2, i2.y -= s2;
          }
          return null == t3 && (t3 = 0), null == e3 && (e3 = 0), n3.initialize = function(t4) {
            r3 = t4;
          }, n3.x = function(e4) {
            return arguments.length ? (t3 = +e4, n3) : t3;
          }, n3.y = function(t4) {
            return arguments.length ? (e3 = +t4, n3) : e3;
          }, n3;
        }
        function i(t3) {
          return function() {
            return t3;
          };
        }
        function a() {
          return 1e-6 * (Math.random() - 0.5);
        }
        function o(t3, e3, r3, n3) {
          if (isNaN(e3) || isNaN(r3))
            return t3;
          var i2, a2, o2, s2, l2, u2, c2, f3, h2, p3 = t3._root, d3 = { data: n3 }, v2 = t3._x0, g3 = t3._y0, y2 = t3._x1, m3 = t3._y1;
          if (!p3)
            return t3._root = d3, t3;
          for (; p3.length; )
            if ((u2 = e3 >= (a2 = (v2 + y2) / 2)) ? v2 = a2 : y2 = a2, (c2 = r3 >= (o2 = (g3 + m3) / 2)) ? g3 = o2 : m3 = o2, i2 = p3, !(p3 = p3[f3 = c2 << 1 | u2]))
              return i2[f3] = d3, t3;
          if (s2 = +t3._x.call(null, p3.data), l2 = +t3._y.call(null, p3.data), e3 === s2 && r3 === l2)
            return d3.next = p3, i2 ? i2[f3] = d3 : t3._root = d3, t3;
          do {
            i2 = i2 ? i2[f3] = new Array(4) : t3._root = new Array(4), (u2 = e3 >= (a2 = (v2 + y2) / 2)) ? v2 = a2 : y2 = a2, (c2 = r3 >= (o2 = (g3 + m3) / 2)) ? g3 = o2 : m3 = o2;
          } while ((f3 = c2 << 1 | u2) == (h2 = (l2 >= o2) << 1 | s2 >= a2));
          return i2[h2] = p3, i2[f3] = d3, t3;
        }
        function s(t3, e3, r3, n3, i2) {
          this.node = t3, this.x0 = e3, this.y0 = r3, this.x1 = n3, this.y1 = i2;
        }
        function l(t3) {
          return t3[0];
        }
        function u(t3) {
          return t3[1];
        }
        function c(t3, e3, r3) {
          var n3 = new f2(null == e3 ? l : e3, null == r3 ? u : r3, NaN, NaN, NaN, NaN);
          return null == t3 ? n3 : n3.addAll(t3);
        }
        function f2(t3, e3, r3, n3, i2, a2) {
          this._x = t3, this._y = e3, this._x0 = r3, this._y0 = n3, this._x1 = i2, this._y1 = a2, this._root = void 0;
        }
        function h(t3) {
          for (var e3 = { data: t3.data }, r3 = e3; t3 = t3.next; )
            r3 = r3.next = { data: t3.data };
          return e3;
        }
        r2.r(e2), r2.d(e2, { forceCenter: function() {
          return n2;
        }, forceCollide: function() {
          return g2;
        }, forceLink: function() {
          return b;
        }, forceManyBody: function() {
          return X;
        }, forceRadial: function() {
          return J;
        }, forceSimulation: function() {
          return W;
        }, forceX: function() {
          return K;
        }, forceY: function() {
          return $;
        } });
        var p2 = c.prototype = f2.prototype;
        function d2(t3) {
          return t3.x + t3.vx;
        }
        function v(t3) {
          return t3.y + t3.vy;
        }
        function g2(t3) {
          var e3, r3, n3 = 1, o2 = 1;
          function s2() {
            for (var t4, i2, s3, u3, f3, h2, p3, g3 = e3.length, y2 = 0; y2 < o2; ++y2)
              for (i2 = c(e3, d2, v).visitAfter(l2), t4 = 0; t4 < g3; ++t4)
                s3 = e3[t4], h2 = r3[s3.index], p3 = h2 * h2, u3 = s3.x + s3.vx, f3 = s3.y + s3.vy, i2.visit(m3);
            function m3(t5, e4, r4, i3, o3) {
              var l3 = t5.data, c2 = t5.r, d3 = h2 + c2;
              if (!l3)
                return e4 > u3 + d3 || i3 < u3 - d3 || r4 > f3 + d3 || o3 < f3 - d3;
              if (l3.index > s3.index) {
                var v2 = u3 - l3.x - l3.vx, g4 = f3 - l3.y - l3.vy, y3 = v2 * v2 + g4 * g4;
                y3 < d3 * d3 && (0 === v2 && (y3 += (v2 = a()) * v2), 0 === g4 && (y3 += (g4 = a()) * g4), y3 = (d3 - (y3 = Math.sqrt(y3))) / y3 * n3, s3.vx += (v2 *= y3) * (d3 = (c2 *= c2) / (p3 + c2)), s3.vy += (g4 *= y3) * d3, l3.vx -= v2 * (d3 = 1 - d3), l3.vy -= g4 * d3);
              }
            }
          }
          function l2(t4) {
            if (t4.data)
              return t4.r = r3[t4.data.index];
            for (var e4 = t4.r = 0; e4 < 4; ++e4)
              t4[e4] && t4[e4].r > t4.r && (t4.r = t4[e4].r);
          }
          function u2() {
            if (e3) {
              var n4, i2, a2 = e3.length;
              for (r3 = new Array(a2), n4 = 0; n4 < a2; ++n4)
                i2 = e3[n4], r3[i2.index] = +t3(i2, n4, e3);
            }
          }
          return "function" != typeof t3 && (t3 = i(null == t3 ? 1 : +t3)), s2.initialize = function(t4) {
            e3 = t4, u2();
          }, s2.iterations = function(t4) {
            return arguments.length ? (o2 = +t4, s2) : o2;
          }, s2.strength = function(t4) {
            return arguments.length ? (n3 = +t4, s2) : n3;
          }, s2.radius = function(e4) {
            return arguments.length ? (t3 = "function" == typeof e4 ? e4 : i(+e4), u2(), s2) : t3;
          }, s2;
        }
        p2.copy = function() {
          var t3, e3, r3 = new f2(this._x, this._y, this._x0, this._y0, this._x1, this._y1), n3 = this._root;
          if (!n3)
            return r3;
          if (!n3.length)
            return r3._root = h(n3), r3;
          for (t3 = [{ source: n3, target: r3._root = new Array(4) }]; n3 = t3.pop(); )
            for (var i2 = 0; i2 < 4; ++i2)
              (e3 = n3.source[i2]) && (e3.length ? t3.push({ source: e3, target: n3.target[i2] = new Array(4) }) : n3.target[i2] = h(e3));
          return r3;
        }, p2.add = function(t3) {
          var e3 = +this._x.call(null, t3), r3 = +this._y.call(null, t3);
          return o(this.cover(e3, r3), e3, r3, t3);
        }, p2.addAll = function(t3) {
          var e3, r3, n3, i2, a2 = t3.length, s2 = new Array(a2), l2 = new Array(a2), u2 = 1 / 0, c2 = 1 / 0, f3 = -1 / 0, h2 = -1 / 0;
          for (r3 = 0; r3 < a2; ++r3)
            isNaN(n3 = +this._x.call(null, e3 = t3[r3])) || isNaN(i2 = +this._y.call(null, e3)) || (s2[r3] = n3, l2[r3] = i2, n3 < u2 && (u2 = n3), n3 > f3 && (f3 = n3), i2 < c2 && (c2 = i2), i2 > h2 && (h2 = i2));
          if (u2 > f3 || c2 > h2)
            return this;
          for (this.cover(u2, c2).cover(f3, h2), r3 = 0; r3 < a2; ++r3)
            o(this, s2[r3], l2[r3], t3[r3]);
          return this;
        }, p2.cover = function(t3, e3) {
          if (isNaN(t3 = +t3) || isNaN(e3 = +e3))
            return this;
          var r3 = this._x0, n3 = this._y0, i2 = this._x1, a2 = this._y1;
          if (isNaN(r3))
            i2 = (r3 = Math.floor(t3)) + 1, a2 = (n3 = Math.floor(e3)) + 1;
          else {
            for (var o2, s2, l2 = i2 - r3, u2 = this._root; r3 > t3 || t3 >= i2 || n3 > e3 || e3 >= a2; )
              switch (s2 = (e3 < n3) << 1 | t3 < r3, (o2 = new Array(4))[s2] = u2, u2 = o2, l2 *= 2, s2) {
                case 0:
                  i2 = r3 + l2, a2 = n3 + l2;
                  break;
                case 1:
                  r3 = i2 - l2, a2 = n3 + l2;
                  break;
                case 2:
                  i2 = r3 + l2, n3 = a2 - l2;
                  break;
                case 3:
                  r3 = i2 - l2, n3 = a2 - l2;
              }
            this._root && this._root.length && (this._root = u2);
          }
          return this._x0 = r3, this._y0 = n3, this._x1 = i2, this._y1 = a2, this;
        }, p2.data = function() {
          var t3 = [];
          return this.visit(function(e3) {
            if (!e3.length)
              do {
                t3.push(e3.data);
              } while (e3 = e3.next);
          }), t3;
        }, p2.extent = function(t3) {
          return arguments.length ? this.cover(+t3[0][0], +t3[0][1]).cover(+t3[1][0], +t3[1][1]) : isNaN(this._x0) ? void 0 : [[this._x0, this._y0], [this._x1, this._y1]];
        }, p2.find = function(t3, e3, r3) {
          var n3, i2, a2, o2, l2, u2, c2, f3 = this._x0, h2 = this._y0, p3 = this._x1, d3 = this._y1, v2 = [], g3 = this._root;
          for (g3 && v2.push(new s(g3, f3, h2, p3, d3)), null == r3 ? r3 = 1 / 0 : (f3 = t3 - r3, h2 = e3 - r3, p3 = t3 + r3, d3 = e3 + r3, r3 *= r3); u2 = v2.pop(); )
            if (!(!(g3 = u2.node) || (i2 = u2.x0) > p3 || (a2 = u2.y0) > d3 || (o2 = u2.x1) < f3 || (l2 = u2.y1) < h2))
              if (g3.length) {
                var y2 = (i2 + o2) / 2, m3 = (a2 + l2) / 2;
                v2.push(new s(g3[3], y2, m3, o2, l2), new s(g3[2], i2, m3, y2, l2), new s(g3[1], y2, a2, o2, m3), new s(g3[0], i2, a2, y2, m3)), (c2 = (e3 >= m3) << 1 | t3 >= y2) && (u2 = v2[v2.length - 1], v2[v2.length - 1] = v2[v2.length - 1 - c2], v2[v2.length - 1 - c2] = u2);
              } else {
                var x2 = t3 - +this._x.call(null, g3.data), b2 = e3 - +this._y.call(null, g3.data), _2 = x2 * x2 + b2 * b2;
                if (_2 < r3) {
                  var w3 = Math.sqrt(r3 = _2);
                  f3 = t3 - w3, h2 = e3 - w3, p3 = t3 + w3, d3 = e3 + w3, n3 = g3.data;
                }
              }
          return n3;
        }, p2.remove = function(t3) {
          if (isNaN(a2 = +this._x.call(null, t3)) || isNaN(o2 = +this._y.call(null, t3)))
            return this;
          var e3, r3, n3, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3 = this._root, d3 = this._x0, v2 = this._y0, g3 = this._x1, y2 = this._y1;
          if (!p3)
            return this;
          if (p3.length)
            for (; ; ) {
              if ((u2 = a2 >= (s2 = (d3 + g3) / 2)) ? d3 = s2 : g3 = s2, (c2 = o2 >= (l2 = (v2 + y2) / 2)) ? v2 = l2 : y2 = l2, e3 = p3, !(p3 = p3[f3 = c2 << 1 | u2]))
                return this;
              if (!p3.length)
                break;
              (e3[f3 + 1 & 3] || e3[f3 + 2 & 3] || e3[f3 + 3 & 3]) && (r3 = e3, h2 = f3);
            }
          for (; p3.data !== t3; )
            if (n3 = p3, !(p3 = p3.next))
              return this;
          return (i2 = p3.next) && delete p3.next, n3 ? (i2 ? n3.next = i2 : delete n3.next, this) : e3 ? (i2 ? e3[f3] = i2 : delete e3[f3], (p3 = e3[0] || e3[1] || e3[2] || e3[3]) && p3 === (e3[3] || e3[2] || e3[1] || e3[0]) && !p3.length && (r3 ? r3[h2] = p3 : this._root = p3), this) : (this._root = i2, this);
        }, p2.removeAll = function(t3) {
          for (var e3 = 0, r3 = t3.length; e3 < r3; ++e3)
            this.remove(t3[e3]);
          return this;
        }, p2.root = function() {
          return this._root;
        }, p2.size = function() {
          var t3 = 0;
          return this.visit(function(e3) {
            if (!e3.length)
              do {
                ++t3;
              } while (e3 = e3.next);
          }), t3;
        }, p2.visit = function(t3) {
          var e3, r3, n3, i2, a2, o2, l2 = [], u2 = this._root;
          for (u2 && l2.push(new s(u2, this._x0, this._y0, this._x1, this._y1)); e3 = l2.pop(); )
            if (!t3(u2 = e3.node, n3 = e3.x0, i2 = e3.y0, a2 = e3.x1, o2 = e3.y1) && u2.length) {
              var c2 = (n3 + a2) / 2, f3 = (i2 + o2) / 2;
              (r3 = u2[3]) && l2.push(new s(r3, c2, f3, a2, o2)), (r3 = u2[2]) && l2.push(new s(r3, n3, f3, c2, o2)), (r3 = u2[1]) && l2.push(new s(r3, c2, i2, a2, f3)), (r3 = u2[0]) && l2.push(new s(r3, n3, i2, c2, f3));
            }
          return this;
        }, p2.visitAfter = function(t3) {
          var e3, r3 = [], n3 = [];
          for (this._root && r3.push(new s(this._root, this._x0, this._y0, this._x1, this._y1)); e3 = r3.pop(); ) {
            var i2 = e3.node;
            if (i2.length) {
              var a2, o2 = e3.x0, l2 = e3.y0, u2 = e3.x1, c2 = e3.y1, f3 = (o2 + u2) / 2, h2 = (l2 + c2) / 2;
              (a2 = i2[0]) && r3.push(new s(a2, o2, l2, f3, h2)), (a2 = i2[1]) && r3.push(new s(a2, f3, l2, u2, h2)), (a2 = i2[2]) && r3.push(new s(a2, o2, h2, f3, c2)), (a2 = i2[3]) && r3.push(new s(a2, f3, h2, u2, c2));
            }
            n3.push(e3);
          }
          for (; e3 = n3.pop(); )
            t3(e3.node, e3.x0, e3.y0, e3.x1, e3.y1);
          return this;
        }, p2.x = function(t3) {
          return arguments.length ? (this._x = t3, this) : this._x;
        }, p2.y = function(t3) {
          return arguments.length ? (this._y = t3, this) : this._y;
        };
        var y = r2(15140);
        function m2(t3) {
          return t3.index;
        }
        function x(t3, e3) {
          var r3 = t3.get(e3);
          if (!r3)
            throw new Error("missing: " + e3);
          return r3;
        }
        function b(t3) {
          var e3, r3, n3, o2, s2, l2 = m2, u2 = function(t4) {
            return 1 / Math.min(o2[t4.source.index], o2[t4.target.index]);
          }, c2 = i(30), f3 = 1;
          function h2(n4) {
            for (var i2 = 0, o3 = t3.length; i2 < f3; ++i2)
              for (var l3, u3, c3, h3, p4, d4, v3, g3 = 0; g3 < o3; ++g3)
                u3 = (l3 = t3[g3]).source, h3 = (c3 = l3.target).x + c3.vx - u3.x - u3.vx || a(), p4 = c3.y + c3.vy - u3.y - u3.vy || a(), h3 *= d4 = ((d4 = Math.sqrt(h3 * h3 + p4 * p4)) - r3[g3]) / d4 * n4 * e3[g3], p4 *= d4, c3.vx -= h3 * (v3 = s2[g3]), c3.vy -= p4 * v3, u3.vx += h3 * (v3 = 1 - v3), u3.vy += p4 * v3;
          }
          function p3() {
            if (n3) {
              var i2, a2, u3 = n3.length, c3 = t3.length, f4 = (0, y.UI)(n3, l2);
              for (i2 = 0, o2 = new Array(u3); i2 < c3; ++i2)
                (a2 = t3[i2]).index = i2, "object" != typeof a2.source && (a2.source = x(f4, a2.source)), "object" != typeof a2.target && (a2.target = x(f4, a2.target)), o2[a2.source.index] = (o2[a2.source.index] || 0) + 1, o2[a2.target.index] = (o2[a2.target.index] || 0) + 1;
              for (i2 = 0, s2 = new Array(c3); i2 < c3; ++i2)
                a2 = t3[i2], s2[i2] = o2[a2.source.index] / (o2[a2.source.index] + o2[a2.target.index]);
              e3 = new Array(c3), d3(), r3 = new Array(c3), v2();
            }
          }
          function d3() {
            if (n3)
              for (var r4 = 0, i2 = t3.length; r4 < i2; ++r4)
                e3[r4] = +u2(t3[r4], r4, t3);
          }
          function v2() {
            if (n3)
              for (var e4 = 0, i2 = t3.length; e4 < i2; ++e4)
                r3[e4] = +c2(t3[e4], e4, t3);
          }
          return null == t3 && (t3 = []), h2.initialize = function(t4) {
            n3 = t4, p3();
          }, h2.links = function(e4) {
            return arguments.length ? (t3 = e4, p3(), h2) : t3;
          }, h2.id = function(t4) {
            return arguments.length ? (l2 = t4, h2) : l2;
          }, h2.iterations = function(t4) {
            return arguments.length ? (f3 = +t4, h2) : f3;
          }, h2.strength = function(t4) {
            return arguments.length ? (u2 = "function" == typeof t4 ? t4 : i(+t4), d3(), h2) : u2;
          }, h2.distance = function(t4) {
            return arguments.length ? (c2 = "function" == typeof t4 ? t4 : i(+t4), v2(), h2) : c2;
          }, h2;
        }
        var _ = { value: function() {
        } };
        function w2() {
          for (var t3, e3 = 0, r3 = arguments.length, n3 = {}; e3 < r3; ++e3) {
            if (!(t3 = arguments[e3] + "") || t3 in n3 || /[\s.]/.test(t3))
              throw new Error("illegal type: " + t3);
            n3[t3] = [];
          }
          return new T(n3);
        }
        function T(t3) {
          this._ = t3;
        }
        function k(t3, e3) {
          return t3.trim().split(/^|\s+/).map(function(t4) {
            var r3 = "", n3 = t4.indexOf(".");
            if (n3 >= 0 && (r3 = t4.slice(n3 + 1), t4 = t4.slice(0, n3)), t4 && !e3.hasOwnProperty(t4))
              throw new Error("unknown type: " + t4);
            return { type: t4, name: r3 };
          });
        }
        function A(t3, e3) {
          for (var r3, n3 = 0, i2 = t3.length; n3 < i2; ++n3)
            if ((r3 = t3[n3]).name === e3)
              return r3.value;
        }
        function M(t3, e3, r3) {
          for (var n3 = 0, i2 = t3.length; n3 < i2; ++n3)
            if (t3[n3].name === e3) {
              t3[n3] = _, t3 = t3.slice(0, n3).concat(t3.slice(n3 + 1));
              break;
            }
          return null != r3 && t3.push({ name: e3, value: r3 }), t3;
        }
        T.prototype = w2.prototype = { constructor: T, on: function(t3, e3) {
          var r3, n3 = this._, i2 = k(t3 + "", n3), a2 = -1, o2 = i2.length;
          if (!(arguments.length < 2)) {
            if (null != e3 && "function" != typeof e3)
              throw new Error("invalid callback: " + e3);
            for (; ++a2 < o2; )
              if (r3 = (t3 = i2[a2]).type)
                n3[r3] = M(n3[r3], t3.name, e3);
              else if (null == e3)
                for (r3 in n3)
                  n3[r3] = M(n3[r3], t3.name, null);
            return this;
          }
          for (; ++a2 < o2; )
            if ((r3 = (t3 = i2[a2]).type) && (r3 = A(n3[r3], t3.name)))
              return r3;
        }, copy: function() {
          var t3 = {}, e3 = this._;
          for (var r3 in e3)
            t3[r3] = e3[r3].slice();
          return new T(t3);
        }, call: function(t3, e3) {
          if ((r3 = arguments.length - 2) > 0)
            for (var r3, n3, i2 = new Array(r3), a2 = 0; a2 < r3; ++a2)
              i2[a2] = arguments[a2 + 2];
          if (!this._.hasOwnProperty(t3))
            throw new Error("unknown type: " + t3);
          for (a2 = 0, r3 = (n3 = this._[t3]).length; a2 < r3; ++a2)
            n3[a2].value.apply(e3, i2);
        }, apply: function(t3, e3, r3) {
          if (!this._.hasOwnProperty(t3))
            throw new Error("unknown type: " + t3);
          for (var n3 = this._[t3], i2 = 0, a2 = n3.length; i2 < a2; ++i2)
            n3[i2].value.apply(e3, r3);
        } };
        var S, E, L = w2, C = 0, P = 0, O = 0, I = 0, D = 0, z = 0, R = "object" == typeof performance && performance.now ? performance : Date, F = "object" == typeof window && window.requestAnimationFrame ? window.requestAnimationFrame.bind(window) : function(t3) {
          setTimeout(t3, 17);
        };
        function B() {
          return D || (F(N), D = R.now() + z);
        }
        function N() {
          D = 0;
        }
        function j() {
          this._call = this._time = this._next = null;
        }
        function U(t3, e3, r3) {
          var n3 = new j();
          return n3.restart(t3, e3, r3), n3;
        }
        function V() {
          D = (I = R.now()) + z, C = P = 0;
          try {
            !function() {
              B(), ++C;
              for (var t3, e3 = S; e3; )
                (t3 = D - e3._time) >= 0 && e3._call.call(null, t3), e3 = e3._next;
              --C;
            }();
          } finally {
            C = 0, function() {
              for (var t3, e3, r3 = S, n3 = 1 / 0; r3; )
                r3._call ? (n3 > r3._time && (n3 = r3._time), t3 = r3, r3 = r3._next) : (e3 = r3._next, r3._next = null, r3 = t3 ? t3._next = e3 : S = e3);
              E = t3, q2(n3);
            }(), D = 0;
          }
        }
        function H() {
          var t3 = R.now(), e3 = t3 - I;
          e3 > 1e3 && (z -= e3, I = t3);
        }
        function q2(t3) {
          C || (P && (P = clearTimeout(P)), t3 - D > 24 ? (t3 < 1 / 0 && (P = setTimeout(V, t3 - R.now() - z)), O && (O = clearInterval(O))) : (O || (I = R.now(), O = setInterval(H, 1e3)), C = 1, F(V)));
        }
        function G(t3) {
          return t3.x;
        }
        function Z(t3) {
          return t3.y;
        }
        j.prototype = U.prototype = { constructor: j, restart: function(t3, e3, r3) {
          if ("function" != typeof t3)
            throw new TypeError("callback is not a function");
          r3 = (null == r3 ? B() : +r3) + (null == e3 ? 0 : +e3), this._next || E === this || (E ? E._next = this : S = this, E = this), this._call = t3, this._time = r3, q2();
        }, stop: function() {
          this._call && (this._call = null, this._time = 1 / 0, q2());
        } };
        var Y = Math.PI * (3 - Math.sqrt(5));
        function W(t3) {
          var e3, r3 = 1, n3 = 1e-3, i2 = 1 - Math.pow(n3, 1 / 300), a2 = 0, o2 = 0.6, s2 = (0, y.UI)(), l2 = U(c2), u2 = L("tick", "end");
          function c2() {
            f3(), u2.call("tick", e3), r3 < n3 && (l2.stop(), u2.call("end", e3));
          }
          function f3(n4) {
            var l3, u3, c3 = t3.length;
            void 0 === n4 && (n4 = 1);
            for (var f4 = 0; f4 < n4; ++f4)
              for (r3 += (a2 - r3) * i2, s2.each(function(t4) {
                t4(r3);
              }), l3 = 0; l3 < c3; ++l3)
                null == (u3 = t3[l3]).fx ? u3.x += u3.vx *= o2 : (u3.x = u3.fx, u3.vx = 0), null == u3.fy ? u3.y += u3.vy *= o2 : (u3.y = u3.fy, u3.vy = 0);
            return e3;
          }
          function h2() {
            for (var e4, r4 = 0, n4 = t3.length; r4 < n4; ++r4) {
              if ((e4 = t3[r4]).index = r4, null != e4.fx && (e4.x = e4.fx), null != e4.fy && (e4.y = e4.fy), isNaN(e4.x) || isNaN(e4.y)) {
                var i3 = 10 * Math.sqrt(r4), a3 = r4 * Y;
                e4.x = i3 * Math.cos(a3), e4.y = i3 * Math.sin(a3);
              }
              (isNaN(e4.vx) || isNaN(e4.vy)) && (e4.vx = e4.vy = 0);
            }
          }
          function p3(e4) {
            return e4.initialize && e4.initialize(t3), e4;
          }
          return null == t3 && (t3 = []), h2(), e3 = { tick: f3, restart: function() {
            return l2.restart(c2), e3;
          }, stop: function() {
            return l2.stop(), e3;
          }, nodes: function(r4) {
            return arguments.length ? (t3 = r4, h2(), s2.each(p3), e3) : t3;
          }, alpha: function(t4) {
            return arguments.length ? (r3 = +t4, e3) : r3;
          }, alphaMin: function(t4) {
            return arguments.length ? (n3 = +t4, e3) : n3;
          }, alphaDecay: function(t4) {
            return arguments.length ? (i2 = +t4, e3) : +i2;
          }, alphaTarget: function(t4) {
            return arguments.length ? (a2 = +t4, e3) : a2;
          }, velocityDecay: function(t4) {
            return arguments.length ? (o2 = 1 - t4, e3) : 1 - o2;
          }, force: function(t4, r4) {
            return arguments.length > 1 ? (null == r4 ? s2.remove(t4) : s2.set(t4, p3(r4)), e3) : s2.get(t4);
          }, find: function(e4, r4, n4) {
            var i3, a3, o3, s3, l3, u3 = 0, c3 = t3.length;
            for (null == n4 ? n4 = 1 / 0 : n4 *= n4, u3 = 0; u3 < c3; ++u3)
              (o3 = (i3 = e4 - (s3 = t3[u3]).x) * i3 + (a3 = r4 - s3.y) * a3) < n4 && (l3 = s3, n4 = o3);
            return l3;
          }, on: function(t4, r4) {
            return arguments.length > 1 ? (u2.on(t4, r4), e3) : u2.on(t4);
          } };
        }
        function X() {
          var t3, e3, r3, n3, o2 = i(-30), s2 = 1, l2 = 1 / 0, u2 = 0.81;
          function f3(n4) {
            var i2, a2 = t3.length, o3 = c(t3, G, Z).visitAfter(p3);
            for (r3 = n4, i2 = 0; i2 < a2; ++i2)
              e3 = t3[i2], o3.visit(d3);
          }
          function h2() {
            if (t3) {
              var e4, r4, i2 = t3.length;
              for (n3 = new Array(i2), e4 = 0; e4 < i2; ++e4)
                r4 = t3[e4], n3[r4.index] = +o2(r4, e4, t3);
            }
          }
          function p3(t4) {
            var e4, r4, i2, a2, o3, s3 = 0, l3 = 0;
            if (t4.length) {
              for (i2 = a2 = o3 = 0; o3 < 4; ++o3)
                (e4 = t4[o3]) && (r4 = Math.abs(e4.value)) && (s3 += e4.value, l3 += r4, i2 += r4 * e4.x, a2 += r4 * e4.y);
              t4.x = i2 / l3, t4.y = a2 / l3;
            } else {
              (e4 = t4).x = e4.data.x, e4.y = e4.data.y;
              do {
                s3 += n3[e4.data.index];
              } while (e4 = e4.next);
            }
            t4.value = s3;
          }
          function d3(t4, i2, o3, c2) {
            if (!t4.value)
              return true;
            var f4 = t4.x - e3.x, h3 = t4.y - e3.y, p4 = c2 - i2, d4 = f4 * f4 + h3 * h3;
            if (p4 * p4 / u2 < d4)
              return d4 < l2 && (0 === f4 && (d4 += (f4 = a()) * f4), 0 === h3 && (d4 += (h3 = a()) * h3), d4 < s2 && (d4 = Math.sqrt(s2 * d4)), e3.vx += f4 * t4.value * r3 / d4, e3.vy += h3 * t4.value * r3 / d4), true;
            if (!(t4.length || d4 >= l2)) {
              (t4.data !== e3 || t4.next) && (0 === f4 && (d4 += (f4 = a()) * f4), 0 === h3 && (d4 += (h3 = a()) * h3), d4 < s2 && (d4 = Math.sqrt(s2 * d4)));
              do {
                t4.data !== e3 && (p4 = n3[t4.data.index] * r3 / d4, e3.vx += f4 * p4, e3.vy += h3 * p4);
              } while (t4 = t4.next);
            }
          }
          return f3.initialize = function(e4) {
            t3 = e4, h2();
          }, f3.strength = function(t4) {
            return arguments.length ? (o2 = "function" == typeof t4 ? t4 : i(+t4), h2(), f3) : o2;
          }, f3.distanceMin = function(t4) {
            return arguments.length ? (s2 = t4 * t4, f3) : Math.sqrt(s2);
          }, f3.distanceMax = function(t4) {
            return arguments.length ? (l2 = t4 * t4, f3) : Math.sqrt(l2);
          }, f3.theta = function(t4) {
            return arguments.length ? (u2 = t4 * t4, f3) : Math.sqrt(u2);
          }, f3;
        }
        function J(t3, e3, r3) {
          var n3, a2, o2, s2 = i(0.1);
          function l2(t4) {
            for (var i2 = 0, s3 = n3.length; i2 < s3; ++i2) {
              var l3 = n3[i2], u3 = l3.x - e3 || 1e-6, c2 = l3.y - r3 || 1e-6, f3 = Math.sqrt(u3 * u3 + c2 * c2), h2 = (o2[i2] - f3) * a2[i2] * t4 / f3;
              l3.vx += u3 * h2, l3.vy += c2 * h2;
            }
          }
          function u2() {
            if (n3) {
              var e4, r4 = n3.length;
              for (a2 = new Array(r4), o2 = new Array(r4), e4 = 0; e4 < r4; ++e4)
                o2[e4] = +t3(n3[e4], e4, n3), a2[e4] = isNaN(o2[e4]) ? 0 : +s2(n3[e4], e4, n3);
            }
          }
          return "function" != typeof t3 && (t3 = i(+t3)), null == e3 && (e3 = 0), null == r3 && (r3 = 0), l2.initialize = function(t4) {
            n3 = t4, u2();
          }, l2.strength = function(t4) {
            return arguments.length ? (s2 = "function" == typeof t4 ? t4 : i(+t4), u2(), l2) : s2;
          }, l2.radius = function(e4) {
            return arguments.length ? (t3 = "function" == typeof e4 ? e4 : i(+e4), u2(), l2) : t3;
          }, l2.x = function(t4) {
            return arguments.length ? (e3 = +t4, l2) : e3;
          }, l2.y = function(t4) {
            return arguments.length ? (r3 = +t4, l2) : r3;
          }, l2;
        }
        function K(t3) {
          var e3, r3, n3, a2 = i(0.1);
          function o2(t4) {
            for (var i2, a3 = 0, o3 = e3.length; a3 < o3; ++a3)
              (i2 = e3[a3]).vx += (n3[a3] - i2.x) * r3[a3] * t4;
          }
          function s2() {
            if (e3) {
              var i2, o3 = e3.length;
              for (r3 = new Array(o3), n3 = new Array(o3), i2 = 0; i2 < o3; ++i2)
                r3[i2] = isNaN(n3[i2] = +t3(e3[i2], i2, e3)) ? 0 : +a2(e3[i2], i2, e3);
            }
          }
          return "function" != typeof t3 && (t3 = i(null == t3 ? 0 : +t3)), o2.initialize = function(t4) {
            e3 = t4, s2();
          }, o2.strength = function(t4) {
            return arguments.length ? (a2 = "function" == typeof t4 ? t4 : i(+t4), s2(), o2) : a2;
          }, o2.x = function(e4) {
            return arguments.length ? (t3 = "function" == typeof e4 ? e4 : i(+e4), s2(), o2) : t3;
          }, o2;
        }
        function $(t3) {
          var e3, r3, n3, a2 = i(0.1);
          function o2(t4) {
            for (var i2, a3 = 0, o3 = e3.length; a3 < o3; ++a3)
              (i2 = e3[a3]).vy += (n3[a3] - i2.y) * r3[a3] * t4;
          }
          function s2() {
            if (e3) {
              var i2, o3 = e3.length;
              for (r3 = new Array(o3), n3 = new Array(o3), i2 = 0; i2 < o3; ++i2)
                r3[i2] = isNaN(n3[i2] = +t3(e3[i2], i2, e3)) ? 0 : +a2(e3[i2], i2, e3);
            }
          }
          return "function" != typeof t3 && (t3 = i(null == t3 ? 0 : +t3)), o2.initialize = function(t4) {
            e3 = t4, s2();
          }, o2.strength = function(t4) {
            return arguments.length ? (a2 = "function" == typeof t4 ? t4 : i(+t4), s2(), o2) : a2;
          }, o2.y = function(e4) {
            return arguments.length ? (t3 = "function" == typeof e4 ? e4 : i(+e4), s2(), o2) : t3;
          }, o2;
        }
      }, 60721: function(t2, e2, r2) {
        function n2(t3, e3) {
          if ((r3 = (t3 = e3 ? t3.toExponential(e3 - 1) : t3.toExponential()).indexOf("e")) < 0)
            return null;
          var r3, n3 = t3.slice(0, r3);
          return [n3.length > 1 ? n3[0] + n3.slice(2) : n3, +t3.slice(r3 + 1)];
        }
        r2.d(e2, { WU: function() {
          return h;
        }, FF: function() {
          return v;
        } });
        var i, a = /^(?:(.)?([<>=^]))?([+\-( ])?([$#])?(0)?(\d+)?(,)?(\.\d+)?(~)?([a-z%])?$/i;
        function o(t3) {
          if (!(e3 = a.exec(t3)))
            throw new Error("invalid format: " + t3);
          var e3;
          return new s({ fill: e3[1], align: e3[2], sign: e3[3], symbol: e3[4], zero: e3[5], width: e3[6], comma: e3[7], precision: e3[8] && e3[8].slice(1), trim: e3[9], type: e3[10] });
        }
        function s(t3) {
          this.fill = void 0 === t3.fill ? " " : t3.fill + "", this.align = void 0 === t3.align ? ">" : t3.align + "", this.sign = void 0 === t3.sign ? "-" : t3.sign + "", this.symbol = void 0 === t3.symbol ? "" : t3.symbol + "", this.zero = !!t3.zero, this.width = void 0 === t3.width ? void 0 : +t3.width, this.comma = !!t3.comma, this.precision = void 0 === t3.precision ? void 0 : +t3.precision, this.trim = !!t3.trim, this.type = void 0 === t3.type ? "" : t3.type + "";
        }
        function l(t3, e3) {
          var r3 = n2(t3, e3);
          if (!r3)
            return t3 + "";
          var i2 = r3[0], a2 = r3[1];
          return a2 < 0 ? "0." + new Array(-a2).join("0") + i2 : i2.length > a2 + 1 ? i2.slice(0, a2 + 1) + "." + i2.slice(a2 + 1) : i2 + new Array(a2 - i2.length + 2).join("0");
        }
        o.prototype = s.prototype, s.prototype.toString = function() {
          return this.fill + this.align + this.sign + this.symbol + (this.zero ? "0" : "") + (void 0 === this.width ? "" : Math.max(1, 0 | this.width)) + (this.comma ? "," : "") + (void 0 === this.precision ? "" : "." + Math.max(0, 0 | this.precision)) + (this.trim ? "~" : "") + this.type;
        };
        var u = { "%": function(t3, e3) {
          return (100 * t3).toFixed(e3);
        }, b: function(t3) {
          return Math.round(t3).toString(2);
        }, c: function(t3) {
          return t3 + "";
        }, d: function(t3) {
          return Math.abs(t3 = Math.round(t3)) >= 1e21 ? t3.toLocaleString("en").replace(/,/g, "") : t3.toString(10);
        }, e: function(t3, e3) {
          return t3.toExponential(e3);
        }, f: function(t3, e3) {
          return t3.toFixed(e3);
        }, g: function(t3, e3) {
          return t3.toPrecision(e3);
        }, o: function(t3) {
          return Math.round(t3).toString(8);
        }, p: function(t3, e3) {
          return l(100 * t3, e3);
        }, r: l, s: function(t3, e3) {
          var r3 = n2(t3, e3);
          if (!r3)
            return t3 + "";
          var a2 = r3[0], o2 = r3[1], s2 = o2 - (i = 3 * Math.max(-8, Math.min(8, Math.floor(o2 / 3)))) + 1, l2 = a2.length;
          return s2 === l2 ? a2 : s2 > l2 ? a2 + new Array(s2 - l2 + 1).join("0") : s2 > 0 ? a2.slice(0, s2) + "." + a2.slice(s2) : "0." + new Array(1 - s2).join("0") + n2(t3, Math.max(0, e3 + s2 - 1))[0];
        }, X: function(t3) {
          return Math.round(t3).toString(16).toUpperCase();
        }, x: function(t3) {
          return Math.round(t3).toString(16);
        } };
        function c(t3) {
          return t3;
        }
        var f2, h, p2 = Array.prototype.map, d2 = ["y", "z", "a", "f", "p", "n", "µ", "m", "", "k", "M", "G", "T", "P", "E", "Z", "Y"];
        function v(t3) {
          var e3, r3, a2 = void 0 === t3.grouping || void 0 === t3.thousands ? c : (e3 = p2.call(t3.grouping, Number), r3 = t3.thousands + "", function(t4, n3) {
            for (var i2 = t4.length, a3 = [], o2 = 0, s3 = e3[0], l3 = 0; i2 > 0 && s3 > 0 && (l3 + s3 + 1 > n3 && (s3 = Math.max(1, n3 - l3)), a3.push(t4.substring(i2 -= s3, i2 + s3)), !((l3 += s3 + 1) > n3)); )
              s3 = e3[o2 = (o2 + 1) % e3.length];
            return a3.reverse().join(r3);
          }), s2 = void 0 === t3.currency ? "" : t3.currency[0] + "", l2 = void 0 === t3.currency ? "" : t3.currency[1] + "", f3 = void 0 === t3.decimal ? "." : t3.decimal + "", h2 = void 0 === t3.numerals ? c : function(t4) {
            return function(e4) {
              return e4.replace(/[0-9]/g, function(e5) {
                return t4[+e5];
              });
            };
          }(p2.call(t3.numerals, String)), v2 = void 0 === t3.percent ? "%" : t3.percent + "", g2 = void 0 === t3.minus ? "-" : t3.minus + "", y = void 0 === t3.nan ? "NaN" : t3.nan + "";
          function m2(t4) {
            var e4 = (t4 = o(t4)).fill, r4 = t4.align, n3 = t4.sign, c2 = t4.symbol, p3 = t4.zero, m3 = t4.width, x = t4.comma, b = t4.precision, _ = t4.trim, w2 = t4.type;
            "n" === w2 ? (x = true, w2 = "g") : u[w2] || (void 0 === b && (b = 12), _ = true, w2 = "g"), (p3 || "0" === e4 && "=" === r4) && (p3 = true, e4 = "0", r4 = "=");
            var T = "$" === c2 ? s2 : "#" === c2 && /[boxX]/.test(w2) ? "0" + w2.toLowerCase() : "", k = "$" === c2 ? l2 : /[%p]/.test(w2) ? v2 : "", A = u[w2], M = /[defgprs%]/.test(w2);
            function S(t5) {
              var o2, s3, l3, u2 = T, c3 = k;
              if ("c" === w2)
                c3 = A(t5) + c3, t5 = "";
              else {
                var v3 = (t5 = +t5) < 0 || 1 / t5 < 0;
                if (t5 = isNaN(t5) ? y : A(Math.abs(t5), b), _ && (t5 = function(t6) {
                  t:
                    for (var e5, r5 = t6.length, n4 = 1, i2 = -1; n4 < r5; ++n4)
                      switch (t6[n4]) {
                        case ".":
                          i2 = e5 = n4;
                          break;
                        case "0":
                          0 === i2 && (i2 = n4), e5 = n4;
                          break;
                        default:
                          if (!+t6[n4])
                            break t;
                          i2 > 0 && (i2 = 0);
                      }
                  return i2 > 0 ? t6.slice(0, i2) + t6.slice(e5 + 1) : t6;
                }(t5)), v3 && 0 == +t5 && "+" !== n3 && (v3 = false), u2 = (v3 ? "(" === n3 ? n3 : g2 : "-" === n3 || "(" === n3 ? "" : n3) + u2, c3 = ("s" === w2 ? d2[8 + i / 3] : "") + c3 + (v3 && "(" === n3 ? ")" : ""), M) {
                  for (o2 = -1, s3 = t5.length; ++o2 < s3; )
                    if (48 > (l3 = t5.charCodeAt(o2)) || l3 > 57) {
                      c3 = (46 === l3 ? f3 + t5.slice(o2 + 1) : t5.slice(o2)) + c3, t5 = t5.slice(0, o2);
                      break;
                    }
                }
              }
              x && !p3 && (t5 = a2(t5, 1 / 0));
              var S2 = u2.length + t5.length + c3.length, E = S2 < m3 ? new Array(m3 - S2 + 1).join(e4) : "";
              switch (x && p3 && (t5 = a2(E + t5, E.length ? m3 - c3.length : 1 / 0), E = ""), r4) {
                case "<":
                  t5 = u2 + t5 + c3 + E;
                  break;
                case "=":
                  t5 = u2 + E + t5 + c3;
                  break;
                case "^":
                  t5 = E.slice(0, S2 = E.length >> 1) + u2 + t5 + c3 + E.slice(S2);
                  break;
                default:
                  t5 = E + u2 + t5 + c3;
              }
              return h2(t5);
            }
            return b = void 0 === b ? 6 : /[gprs]/.test(w2) ? Math.max(1, Math.min(21, b)) : Math.max(0, Math.min(20, b)), S.toString = function() {
              return t4 + "";
            }, S;
          }
          return { format: m2, formatPrefix: function(t4, e4) {
            var r4, i2 = m2(((t4 = o(t4)).type = "f", t4)), a3 = 3 * Math.max(-8, Math.min(8, Math.floor((r4 = e4, ((r4 = n2(Math.abs(r4))) ? r4[1] : NaN) / 3)))), s3 = Math.pow(10, -a3), l3 = d2[8 + a3 / 3];
            return function(t5) {
              return i2(s3 * t5) + l3;
            };
          } };
        }
        f2 = v({ decimal: ".", thousands: ",", grouping: [3], currency: ["$", ""], minus: "-" }), h = f2.format, f2.formatPrefix;
      }, 65704: function(t2, e2, r2) {
        r2.r(e2), r2.d(e2, { geoAiry: function() {
          return z;
        }, geoAiryRaw: function() {
          return D;
        }, geoAitoff: function() {
          return F;
        }, geoAitoffRaw: function() {
          return R;
        }, geoArmadillo: function() {
          return N;
        }, geoArmadilloRaw: function() {
          return B;
        }, geoAugust: function() {
          return U;
        }, geoAugustRaw: function() {
          return j;
        }, geoBaker: function() {
          return G;
        }, geoBakerRaw: function() {
          return q2;
        }, geoBerghaus: function() {
          return W;
        }, geoBerghausRaw: function() {
          return Y;
        }, geoBertin1953: function() {
          return rt;
        }, geoBertin1953Raw: function() {
          return et;
        }, geoBoggs: function() {
          return ct;
        }, geoBoggsRaw: function() {
          return ut;
        }, geoBonne: function() {
          return vt;
        }, geoBonneRaw: function() {
          return dt;
        }, geoBottomley: function() {
          return yt;
        }, geoBottomleyRaw: function() {
          return gt;
        }, geoBromley: function() {
          return xt;
        }, geoBromleyRaw: function() {
          return mt;
        }, geoChamberlin: function() {
          return Et;
        }, geoChamberlinAfrica: function() {
          return St;
        }, geoChamberlinRaw: function() {
          return At;
        }, geoCollignon: function() {
          return Ct;
        }, geoCollignonRaw: function() {
          return Lt;
        }, geoCraig: function() {
          return Ot;
        }, geoCraigRaw: function() {
          return Pt;
        }, geoCraster: function() {
          return zt;
        }, geoCrasterRaw: function() {
          return Dt;
        }, geoCylindricalEqualArea: function() {
          return Ft;
        }, geoCylindricalEqualAreaRaw: function() {
          return Rt;
        }, geoCylindricalStereographic: function() {
          return Nt;
        }, geoCylindricalStereographicRaw: function() {
          return Bt;
        }, geoEckert1: function() {
          return Ut;
        }, geoEckert1Raw: function() {
          return jt;
        }, geoEckert2: function() {
          return Ht;
        }, geoEckert2Raw: function() {
          return Vt;
        }, geoEckert3: function() {
          return Gt;
        }, geoEckert3Raw: function() {
          return qt;
        }, geoEckert4: function() {
          return Yt;
        }, geoEckert4Raw: function() {
          return Zt;
        }, geoEckert5: function() {
          return Xt;
        }, geoEckert5Raw: function() {
          return Wt;
        }, geoEckert6: function() {
          return Kt;
        }, geoEckert6Raw: function() {
          return Jt;
        }, geoEisenlohr: function() {
          return te;
        }, geoEisenlohrRaw: function() {
          return Qt;
        }, geoFahey: function() {
          return ne;
        }, geoFaheyRaw: function() {
          return re;
        }, geoFoucaut: function() {
          return ae;
        }, geoFoucautRaw: function() {
          return ie;
        }, geoFoucautSinusoidal: function() {
          return se;
        }, geoFoucautSinusoidalRaw: function() {
          return oe;
        }, geoGilbert: function() {
          return he;
        }, geoGingery: function() {
          return ge;
        }, geoGingeryRaw: function() {
          return pe;
        }, geoGinzburg4: function() {
          return xe;
        }, geoGinzburg4Raw: function() {
          return me;
        }, geoGinzburg5: function() {
          return _e;
        }, geoGinzburg5Raw: function() {
          return be;
        }, geoGinzburg6: function() {
          return Te;
        }, geoGinzburg6Raw: function() {
          return we;
        }, geoGinzburg8: function() {
          return Ae;
        }, geoGinzburg8Raw: function() {
          return ke;
        }, geoGinzburg9: function() {
          return Se;
        }, geoGinzburg9Raw: function() {
          return Me;
        }, geoGringorten: function() {
          return Ce;
        }, geoGringortenQuincuncial: function() {
          return ei;
        }, geoGringortenRaw: function() {
          return Le;
        }, geoGuyou: function() {
          return De;
        }, geoGuyouRaw: function() {
          return Ie;
        }, geoHammer: function() {
          return $;
        }, geoHammerRaw: function() {
          return J;
        }, geoHammerRetroazimuthal: function() {
          return Be;
        }, geoHammerRetroazimuthalRaw: function() {
          return Re;
        }, geoHealpix: function() {
          return Ye;
        }, geoHealpixRaw: function() {
          return He;
        }, geoHill: function() {
          return Xe;
        }, geoHillRaw: function() {
          return We;
        }, geoHomolosine: function() {
          return er;
        }, geoHomolosineRaw: function() {
          return tr;
        }, geoHufnagel: function() {
          return nr;
        }, geoHufnagelRaw: function() {
          return rr;
        }, geoHyperelliptical: function() {
          return sr;
        }, geoHyperellipticalRaw: function() {
          return or;
        }, geoInterrupt: function() {
          return fr;
        }, geoInterruptedBoggs: function() {
          return pr;
        }, geoInterruptedHomolosine: function() {
          return vr;
        }, geoInterruptedMollweide: function() {
          return yr;
        }, geoInterruptedMollweideHemispheres: function() {
          return xr;
        }, geoInterruptedQuarticAuthalic: function() {
          return hn;
        }, geoInterruptedSinuMollweide: function() {
          return _r;
        }, geoInterruptedSinusoidal: function() {
          return Tr;
        }, geoKavrayskiy7: function() {
          return Ar;
        }, geoKavrayskiy7Raw: function() {
          return kr;
        }, geoLagrange: function() {
          return Sr;
        }, geoLagrangeRaw: function() {
          return Mr;
        }, geoLarrivee: function() {
          return Cr;
        }, geoLarriveeRaw: function() {
          return Lr;
        }, geoLaskowski: function() {
          return Or;
        }, geoLaskowskiRaw: function() {
          return Pr;
        }, geoLittrow: function() {
          return Dr;
        }, geoLittrowRaw: function() {
          return Ir;
        }, geoLoximuthal: function() {
          return Rr;
        }, geoLoximuthalRaw: function() {
          return zr;
        }, geoMiller: function() {
          return Br;
        }, geoMillerRaw: function() {
          return Fr;
        }, geoModifiedStereographic: function() {
          return Jr;
        }, geoModifiedStereographicAlaska: function() {
          return Gr;
        }, geoModifiedStereographicGs48: function() {
          return Zr;
        }, geoModifiedStereographicGs50: function() {
          return Yr;
        }, geoModifiedStereographicLee: function() {
          return Xr;
        }, geoModifiedStereographicMiller: function() {
          return Wr;
        }, geoModifiedStereographicRaw: function() {
          return Nr;
        }, geoMollweide: function() {
          return ot;
        }, geoMollweideRaw: function() {
          return at;
        }, geoMtFlatPolarParabolic: function() {
          return tn;
        }, geoMtFlatPolarParabolicRaw: function() {
          return Qr;
        }, geoMtFlatPolarQuartic: function() {
          return rn;
        }, geoMtFlatPolarQuarticRaw: function() {
          return en;
        }, geoMtFlatPolarSinusoidal: function() {
          return an;
        }, geoMtFlatPolarSinusoidalRaw: function() {
          return nn;
        }, geoNaturalEarth: function() {
          return on.Z;
        }, geoNaturalEarth2: function() {
          return ln;
        }, geoNaturalEarth2Raw: function() {
          return sn;
        }, geoNaturalEarthRaw: function() {
          return on.K;
        }, geoNellHammer: function() {
          return cn;
        }, geoNellHammerRaw: function() {
          return un;
        }, geoNicolosi: function() {
          return dn;
        }, geoNicolosiRaw: function() {
          return pn;
        }, geoPatterson: function() {
          return _n;
        }, geoPattersonRaw: function() {
          return bn;
        }, geoPeirceQuincuncial: function() {
          return ri;
        }, geoPierceQuincuncial: function() {
          return ri;
        }, geoPolyconic: function() {
          return Tn;
        }, geoPolyconicRaw: function() {
          return wn;
        }, geoPolyhedral: function() {
          return Ln;
        }, geoPolyhedralButterfly: function() {
          return Rn;
        }, geoPolyhedralCollignon: function() {
          return Nn;
        }, geoPolyhedralWaterman: function() {
          return jn;
        }, geoProject: function() {
          return Gn;
        }, geoQuantize: function() {
          return ni;
        }, geoQuincuncial: function() {
          return ti;
        }, geoRectangularPolyconic: function() {
          return ai;
        }, geoRectangularPolyconicRaw: function() {
          return ii;
        }, geoRobinson: function() {
          return li;
        }, geoRobinsonRaw: function() {
          return si;
        }, geoSatellite: function() {
          return ci;
        }, geoSatelliteRaw: function() {
          return ui;
        }, geoSinuMollweide: function() {
          return Qe;
        }, geoSinuMollweideRaw: function() {
          return $e;
        }, geoSinusoidal: function() {
          return pt;
        }, geoSinusoidalRaw: function() {
          return ht;
        }, geoStitch: function() {
          return Ti;
        }, geoTimes: function() {
          return Ai;
        }, geoTimesRaw: function() {
          return ki;
        }, geoTwoPointAzimuthal: function() {
          return Li;
        }, geoTwoPointAzimuthalRaw: function() {
          return Si;
        }, geoTwoPointAzimuthalUsa: function() {
          return Ei;
        }, geoTwoPointEquidistant: function() {
          return Oi;
        }, geoTwoPointEquidistantRaw: function() {
          return Ci;
        }, geoTwoPointEquidistantUsa: function() {
          return Pi;
        }, geoVanDerGrinten: function() {
          return Di;
        }, geoVanDerGrinten2: function() {
          return Ri;
        }, geoVanDerGrinten2Raw: function() {
          return zi;
        }, geoVanDerGrinten3: function() {
          return Bi;
        }, geoVanDerGrinten3Raw: function() {
          return Fi;
        }, geoVanDerGrinten4: function() {
          return ji;
        }, geoVanDerGrinten4Raw: function() {
          return Ni;
        }, geoVanDerGrintenRaw: function() {
          return Ii;
        }, geoWagner: function() {
          return Vi;
        }, geoWagner4: function() {
          return Yi;
        }, geoWagner4Raw: function() {
          return Zi;
        }, geoWagner6: function() {
          return Xi;
        }, geoWagner6Raw: function() {
          return Wi;
        }, geoWagner7: function() {
          return Hi;
        }, geoWagnerRaw: function() {
          return Ui;
        }, geoWiechel: function() {
          return Ki;
        }, geoWiechelRaw: function() {
          return Ji;
        }, geoWinkel3: function() {
          return Qi;
        }, geoWinkel3Raw: function() {
          return $i;
        } });
        var n2 = r2(15002), i = Math.abs, a = Math.atan, o = Math.atan2, s = Math.cos, l = Math.exp, u = Math.floor, c = Math.log, f2 = Math.max, h = Math.min, p2 = Math.pow, d2 = Math.round, v = Math.sign || function(t3) {
          return t3 > 0 ? 1 : t3 < 0 ? -1 : 0;
        }, g2 = Math.sin, y = Math.tan, m2 = 1e-6, x = 1e-12, b = Math.PI, _ = b / 2, w2 = b / 4, T = Math.SQRT1_2, k = P(2), A = P(b), M = 2 * b, S = 180 / b, E = b / 180;
        function L(t3) {
          return t3 > 1 ? _ : t3 < -1 ? -_ : Math.asin(t3);
        }
        function C(t3) {
          return t3 > 1 ? 0 : t3 < -1 ? b : Math.acos(t3);
        }
        function P(t3) {
          return t3 > 0 ? Math.sqrt(t3) : 0;
        }
        function O(t3) {
          return (l(t3) - l(-t3)) / 2;
        }
        function I(t3) {
          return (l(t3) + l(-t3)) / 2;
        }
        function D(t3) {
          var e3 = y(t3 / 2), r3 = 2 * c(s(t3 / 2)) / (e3 * e3);
          function n3(t4, e4) {
            var n4 = s(t4), i2 = s(e4), a2 = g2(e4), o2 = i2 * n4, l2 = -((1 - o2 ? c((1 + o2) / 2) / (1 - o2) : -0.5) + r3 / (1 + o2));
            return [l2 * i2 * g2(t4), l2 * a2];
          }
          return n3.invert = function(e4, n4) {
            var a2, l2 = P(e4 * e4 + n4 * n4), u2 = -t3 / 2, f3 = 50;
            if (!l2)
              return [0, 0];
            do {
              var h2 = u2 / 2, p3 = s(h2), d3 = g2(h2), v2 = d3 / p3, y2 = -c(i(p3));
              u2 -= a2 = (2 / v2 * y2 - r3 * v2 - l2) / (-y2 / (d3 * d3) + 1 - r3 / (2 * p3 * p3)) * (p3 < 0 ? 0.7 : 1);
            } while (i(a2) > m2 && --f3 > 0);
            var x2 = g2(u2);
            return [o(e4 * x2, l2 * s(u2)), L(n4 * x2 / l2)];
          }, n3;
        }
        function z() {
          var t3 = _, e3 = (0, n2.r)(D), r3 = e3(t3);
          return r3.radius = function(r4) {
            return arguments.length ? e3(t3 = r4 * E) : t3 * S;
          }, r3.scale(179.976).clipAngle(147);
        }
        function R(t3, e3) {
          var r3 = s(e3), n3 = function(t4) {
            return t4 ? t4 / Math.sin(t4) : 1;
          }(C(r3 * s(t3 /= 2)));
          return [2 * r3 * g2(t3) * n3, g2(e3) * n3];
        }
        function F() {
          return (0, n2.Z)(R).scale(152.63);
        }
        function B(t3) {
          var e3 = g2(t3), r3 = s(t3), n3 = t3 >= 0 ? 1 : -1, a2 = y(n3 * t3), l2 = (1 + e3 - r3) / 2;
          function u2(t4, i2) {
            var u3 = s(i2), c2 = s(t4 /= 2);
            return [(1 + u3) * g2(t4), (n3 * i2 > -o(c2, a2) - 1e-3 ? 0 : 10 * -n3) + l2 + g2(i2) * r3 - (1 + u3) * e3 * c2];
          }
          return u2.invert = function(t4, u3) {
            var c2 = 0, f3 = 0, h2 = 50;
            do {
              var p3 = s(c2), d3 = g2(c2), v2 = s(f3), y2 = g2(f3), x2 = 1 + v2, b2 = x2 * d3 - t4, _2 = l2 + y2 * r3 - x2 * e3 * p3 - u3, w3 = x2 * p3 / 2, T2 = -d3 * y2, k2 = e3 * x2 * d3 / 2, A2 = r3 * v2 + e3 * p3 * y2, M2 = T2 * k2 - A2 * w3, S2 = (_2 * T2 - b2 * A2) / M2 / 2, E2 = (b2 * k2 - _2 * w3) / M2;
              i(E2) > 2 && (E2 /= 2), c2 -= S2, f3 -= E2;
            } while ((i(S2) > m2 || i(E2) > m2) && --h2 > 0);
            return n3 * f3 > -o(s(c2), a2) - 1e-3 ? [2 * c2, f3] : null;
          }, u2;
        }
        function N() {
          var t3 = 20 * E, e3 = t3 >= 0 ? 1 : -1, r3 = y(e3 * t3), i2 = (0, n2.r)(B), a2 = i2(t3), l2 = a2.stream;
          return a2.parallel = function(n3) {
            return arguments.length ? (r3 = y((e3 = (t3 = n3 * E) >= 0 ? 1 : -1) * t3), i2(t3)) : t3 * S;
          }, a2.stream = function(n3) {
            var i3 = a2.rotate(), u2 = l2(n3), c2 = (a2.rotate([0, 0]), l2(n3)), f3 = a2.precision();
            return a2.rotate(i3), u2.sphere = function() {
              c2.polygonStart(), c2.lineStart();
              for (var n4 = -180 * e3; e3 * n4 < 180; n4 += 90 * e3)
                c2.point(n4, 90 * e3);
              if (t3)
                for (; e3 * (n4 -= 3 * e3 * f3) >= -180; )
                  c2.point(n4, e3 * -o(s(n4 * E / 2), r3) * S);
              c2.lineEnd(), c2.polygonEnd();
            }, u2;
          }, a2.scale(218.695).center([0, 28.0974]);
        }
        function j(t3, e3) {
          var r3 = y(e3 / 2), n3 = P(1 - r3 * r3), i2 = 1 + n3 * s(t3 /= 2), a2 = g2(t3) * n3 / i2, o2 = r3 / i2, l2 = a2 * a2, u2 = o2 * o2;
          return [4 / 3 * a2 * (3 + l2 - 3 * u2), 4 / 3 * o2 * (3 + 3 * l2 - u2)];
        }
        function U() {
          return (0, n2.Z)(j).scale(66.1603);
        }
        R.invert = function(t3, e3) {
          if (!(t3 * t3 + 4 * e3 * e3 > b * b + m2)) {
            var r3 = t3, n3 = e3, a2 = 25;
            do {
              var o2, l2 = g2(r3), u2 = g2(r3 / 2), c2 = s(r3 / 2), f3 = g2(n3), h2 = s(n3), p3 = g2(2 * n3), d3 = f3 * f3, v2 = h2 * h2, y2 = u2 * u2, x2 = 1 - v2 * c2 * c2, _2 = x2 ? C(h2 * c2) * P(o2 = 1 / x2) : o2 = 0, w3 = 2 * _2 * h2 * u2 - t3, T2 = _2 * f3 - e3, k2 = o2 * (v2 * y2 + _2 * h2 * c2 * d3), A2 = o2 * (0.5 * l2 * p3 - 2 * _2 * f3 * u2), M2 = 0.25 * o2 * (p3 * u2 - _2 * f3 * v2 * l2), S2 = o2 * (d3 * c2 + _2 * y2 * h2), E2 = A2 * M2 - S2 * k2;
              if (!E2)
                break;
              var L2 = (T2 * A2 - w3 * S2) / E2, O2 = (w3 * M2 - T2 * k2) / E2;
              r3 -= L2, n3 -= O2;
            } while ((i(L2) > m2 || i(O2) > m2) && --a2 > 0);
            return [r3, n3];
          }
        }, j.invert = function(t3, e3) {
          if (e3 *= 3 / 8, !(t3 *= 3 / 8) && i(e3) > 1)
            return null;
          var r3 = 1 + t3 * t3 + e3 * e3, n3 = P((r3 - P(r3 * r3 - 4 * e3 * e3)) / 2), a2 = L(n3) / 3, l2 = n3 ? function(t4) {
            return c(t4 + P(t4 * t4 - 1));
          }(i(e3 / n3)) / 3 : function(t4) {
            return c(t4 + P(t4 * t4 + 1));
          }(i(t3)) / 3, u2 = s(a2), f3 = I(l2), h2 = f3 * f3 - u2 * u2;
          return [2 * v(t3) * o(O(l2) * u2, 0.25 - h2), 2 * v(e3) * o(f3 * g2(a2), 0.25 + h2)];
        };
        var V = P(8), H = c(1 + k);
        function q2(t3, e3) {
          var r3 = i(e3);
          return r3 < w2 ? [t3, c(y(w2 + e3 / 2))] : [t3 * s(r3) * (2 * k - 1 / g2(r3)), v(e3) * (2 * k * (r3 - w2) - c(y(r3 / 2)))];
        }
        function G() {
          return (0, n2.Z)(q2).scale(112.314);
        }
        q2.invert = function(t3, e3) {
          if ((n3 = i(e3)) < H)
            return [t3, 2 * a(l(e3)) - _];
          var r3, n3, o2 = w2, u2 = 25;
          do {
            var f3 = s(o2 / 2), h2 = y(o2 / 2);
            o2 -= r3 = (V * (o2 - w2) - c(h2) - n3) / (V - f3 * f3 / (2 * h2));
          } while (i(r3) > x && --u2 > 0);
          return [t3 / (s(o2) * (V - 1 / g2(o2))), v(e3) * o2];
        };
        var Z = r2(17889);
        function Y(t3) {
          var e3 = 2 * b / t3;
          function r3(t4, r4) {
            var n3 = (0, Z.N)(t4, r4);
            if (i(t4) > _) {
              var a2 = o(n3[1], n3[0]), l2 = P(n3[0] * n3[0] + n3[1] * n3[1]), u2 = e3 * d2((a2 - _) / e3) + _, c2 = o(g2(a2 -= u2), 2 - s(a2));
              a2 = u2 + L(b / l2 * g2(c2)) - c2, n3[0] = l2 * s(a2), n3[1] = l2 * g2(a2);
            }
            return n3;
          }
          return r3.invert = function(t4, r4) {
            var n3 = P(t4 * t4 + r4 * r4);
            if (n3 > _) {
              var i2 = o(r4, t4), l2 = e3 * d2((i2 - _) / e3) + _, u2 = i2 > l2 ? -1 : 1, c2 = n3 * s(l2 - i2), f3 = 1 / y(u2 * C((c2 - b) / P(b * (b - 2 * c2) + n3 * n3)));
              i2 = l2 + 2 * a((f3 + u2 * P(f3 * f3 - 3)) / 3), t4 = n3 * s(i2), r4 = n3 * g2(i2);
            }
            return Z.N.invert(t4, r4);
          }, r3;
        }
        function W() {
          var t3 = 5, e3 = (0, n2.r)(Y), r3 = e3(t3), i2 = r3.stream, a2 = 0.01, l2 = -s(a2 * E), u2 = g2(a2 * E);
          return r3.lobes = function(r4) {
            return arguments.length ? e3(t3 = +r4) : t3;
          }, r3.stream = function(e4) {
            var n3 = r3.rotate(), c2 = i2(e4), f3 = (r3.rotate([0, 0]), i2(e4));
            return r3.rotate(n3), c2.sphere = function() {
              f3.polygonStart(), f3.lineStart();
              for (var e5 = 0, r4 = 360 / t3, n4 = 2 * b / t3, i3 = 90 - 180 / t3, c3 = _; e5 < t3; ++e5, i3 -= r4, c3 -= n4)
                f3.point(o(u2 * s(c3), l2) * S, L(u2 * g2(c3)) * S), i3 < -90 ? (f3.point(-90, -180 - i3 - a2), f3.point(-90, -180 - i3 + a2)) : (f3.point(90, i3 + a2), f3.point(90, i3 - a2));
              f3.lineEnd(), f3.polygonEnd();
            }, c2;
          }, r3.scale(87.8076).center([0, 17.1875]).clipAngle(179.999);
        }
        var X = r2(12956);
        function J(t3, e3) {
          if (arguments.length < 2 && (e3 = t3), 1 === e3)
            return X.l;
          if (e3 === 1 / 0)
            return K;
          function r3(r4, n3) {
            var i2 = (0, X.l)(r4 / e3, n3);
            return i2[0] *= t3, i2;
          }
          return r3.invert = function(r4, n3) {
            var i2 = X.l.invert(r4 / t3, n3);
            return i2[0] *= e3, i2;
          }, r3;
        }
        function K(t3, e3) {
          return [t3 * s(e3) / s(e3 /= 2), 2 * g2(e3)];
        }
        function $() {
          var t3 = 2, e3 = (0, n2.r)(J), r3 = e3(t3);
          return r3.coefficient = function(r4) {
            return arguments.length ? e3(t3 = +r4) : t3;
          }, r3.scale(169.529);
        }
        function Q(t3, e3, r3) {
          var n3, a2, o2, s2 = 100;
          r3 = void 0 === r3 ? 0 : +r3, e3 = +e3;
          do {
            (a2 = t3(r3)) === (o2 = t3(r3 + m2)) && (o2 = a2 + m2), r3 -= n3 = -1e-6 * (a2 - e3) / (a2 - o2);
          } while (s2-- > 0 && i(n3) > m2);
          return s2 < 0 ? NaN : r3;
        }
        function tt(t3, e3, r3) {
          return void 0 === e3 && (e3 = 40), void 0 === r3 && (r3 = x), function(n3, a2, o2, s2) {
            var l2, u2, c2;
            o2 = void 0 === o2 ? 0 : +o2, s2 = void 0 === s2 ? 0 : +s2;
            for (var f3 = 0; f3 < e3; f3++) {
              var h2 = t3(o2, s2), p3 = h2[0] - n3, d3 = h2[1] - a2;
              if (i(p3) < r3 && i(d3) < r3)
                break;
              var v2 = p3 * p3 + d3 * d3;
              if (v2 > l2)
                o2 -= u2 /= 2, s2 -= c2 /= 2;
              else {
                l2 = v2;
                var g3 = (o2 > 0 ? -1 : 1) * r3, y2 = (s2 > 0 ? -1 : 1) * r3, m3 = t3(o2 + g3, s2), x2 = t3(o2, s2 + y2), b2 = (m3[0] - h2[0]) / g3, _2 = (m3[1] - h2[1]) / g3, w3 = (x2[0] - h2[0]) / y2, T2 = (x2[1] - h2[1]) / y2, k2 = T2 * b2 - _2 * w3, A2 = (i(k2) < 0.5 ? 0.5 : 1) / k2;
                if (o2 += u2 = (d3 * w3 - p3 * T2) * A2, s2 += c2 = (p3 * _2 - d3 * b2) * A2, i(u2) < r3 && i(c2) < r3)
                  break;
              }
            }
            return [o2, s2];
          };
        }
        function et() {
          var t3 = J(1.68, 2);
          function e3(e4, r3) {
            if (e4 + r3 < -1.4) {
              var n3 = (e4 - r3 + 1.6) * (e4 + r3 + 1.4) / 8;
              e4 += n3, r3 -= 0.8 * n3 * g2(r3 + b / 2);
            }
            var i2 = t3(e4, r3), a2 = (1 - s(e4 * r3)) / 12;
            return i2[1] < 0 && (i2[0] *= 1 + a2), i2[1] > 0 && (i2[1] *= 1 + a2 / 1.5 * i2[0] * i2[0]), i2;
          }
          return e3.invert = tt(e3), e3;
        }
        function rt() {
          return (0, n2.Z)(et()).rotate([-16.5, -42]).scale(176.57).center([7.93, 0.09]);
        }
        function nt(t3, e3) {
          var r3, n3 = t3 * g2(e3), a2 = 30;
          do {
            e3 -= r3 = (e3 + g2(e3) - n3) / (1 + s(e3));
          } while (i(r3) > m2 && --a2 > 0);
          return e3 / 2;
        }
        function it(t3, e3, r3) {
          function n3(n4, i2) {
            return [t3 * n4 * s(i2 = nt(r3, i2)), e3 * g2(i2)];
          }
          return n3.invert = function(n4, i2) {
            return i2 = L(i2 / e3), [n4 / (t3 * s(i2)), L((2 * i2 + g2(2 * i2)) / r3)];
          }, n3;
        }
        K.invert = function(t3, e3) {
          var r3 = 2 * L(e3 / 2);
          return [t3 * s(r3 / 2) / s(r3), r3];
        };
        var at = it(k / _, k, b);
        function ot() {
          return (0, n2.Z)(at).scale(169.529);
        }
        var st = 2.00276, lt = 1.11072;
        function ut(t3, e3) {
          var r3 = nt(b, e3);
          return [st * t3 / (1 / s(e3) + lt / s(r3)), (e3 + k * g2(r3)) / st];
        }
        function ct() {
          return (0, n2.Z)(ut).scale(160.857);
        }
        function ft(t3) {
          var e3 = 0, r3 = (0, n2.r)(t3), i2 = r3(e3);
          return i2.parallel = function(t4) {
            return arguments.length ? r3(e3 = t4 * E) : e3 * S;
          }, i2;
        }
        function ht(t3, e3) {
          return [t3 * s(e3), e3];
        }
        function pt() {
          return (0, n2.Z)(ht).scale(152.63);
        }
        function dt(t3) {
          if (!t3)
            return ht;
          var e3 = 1 / y(t3);
          function r3(r4, n3) {
            var i2 = e3 + t3 - n3, a2 = i2 ? r4 * s(n3) / i2 : i2;
            return [i2 * g2(a2), e3 - i2 * s(a2)];
          }
          return r3.invert = function(r4, n3) {
            var i2 = P(r4 * r4 + (n3 = e3 - n3) * n3), a2 = e3 + t3 - i2;
            return [i2 / s(a2) * o(r4, n3), a2];
          }, r3;
        }
        function vt() {
          return ft(dt).scale(123.082).center([0, 26.1441]).parallel(45);
        }
        function gt(t3) {
          function e3(e4, r3) {
            var n3 = _ - r3, i2 = n3 ? e4 * t3 * g2(n3) / n3 : n3;
            return [n3 * g2(i2) / t3, _ - n3 * s(i2)];
          }
          return e3.invert = function(e4, r3) {
            var n3 = e4 * t3, i2 = _ - r3, a2 = P(n3 * n3 + i2 * i2), s2 = o(n3, i2);
            return [(a2 ? a2 / g2(a2) : 1) * s2 / t3, _ - a2];
          }, e3;
        }
        function yt() {
          var t3 = 0.5, e3 = (0, n2.r)(gt), r3 = e3(t3);
          return r3.fraction = function(r4) {
            return arguments.length ? e3(t3 = +r4) : t3;
          }, r3.scale(158.837);
        }
        ut.invert = function(t3, e3) {
          var r3, n3, a2 = st * e3, o2 = e3 < 0 ? -w2 : w2, l2 = 25;
          do {
            n3 = a2 - k * g2(o2), o2 -= r3 = (g2(2 * o2) + 2 * o2 - b * g2(n3)) / (2 * s(2 * o2) + 2 + b * s(n3) * k * s(o2));
          } while (i(r3) > m2 && --l2 > 0);
          return n3 = a2 - k * g2(o2), [t3 * (1 / s(n3) + lt / s(o2)) / st, n3];
        }, ht.invert = function(t3, e3) {
          return [t3 / s(e3), e3];
        };
        var mt = it(1, 4 / b, b);
        function xt() {
          return (0, n2.Z)(mt).scale(152.63);
        }
        var bt = r2(66624), _t = r2(49386);
        function wt(t3, e3, r3, n3, a2, l2) {
          var u2, c2 = s(l2);
          if (i(t3) > 1 || i(l2) > 1)
            u2 = C(r3 * a2 + e3 * n3 * c2);
          else {
            var f3 = g2(t3 / 2), h2 = g2(l2 / 2);
            u2 = 2 * L(P(f3 * f3 + e3 * n3 * h2 * h2));
          }
          return i(u2) > m2 ? [u2, o(n3 * g2(l2), e3 * a2 - r3 * n3 * c2)] : [0, 0];
        }
        function Tt(t3, e3, r3) {
          return C((t3 * t3 + e3 * e3 - r3 * r3) / (2 * t3 * e3));
        }
        function kt(t3) {
          return t3 - 2 * b * u((t3 + b) / (2 * b));
        }
        function At(t3, e3, r3) {
          for (var n3, i2 = [[t3[0], t3[1], g2(t3[1]), s(t3[1])], [e3[0], e3[1], g2(e3[1]), s(e3[1])], [r3[0], r3[1], g2(r3[1]), s(r3[1])]], a2 = i2[2], o2 = 0; o2 < 3; ++o2, a2 = n3)
            n3 = i2[o2], a2.v = wt(n3[1] - a2[1], a2[3], a2[2], n3[3], n3[2], n3[0] - a2[0]), a2.point = [0, 0];
          var l2 = Tt(i2[0].v[0], i2[2].v[0], i2[1].v[0]), u2 = Tt(i2[0].v[0], i2[1].v[0], i2[2].v[0]), c2 = b - l2;
          i2[2].point[1] = 0, i2[0].point[0] = -(i2[1].point[0] = i2[0].v[0] / 2);
          var f3 = [i2[2].point[0] = i2[0].point[0] + i2[2].v[0] * s(l2), 2 * (i2[0].point[1] = i2[1].point[1] = i2[2].v[0] * g2(l2))];
          return function(t4, e4) {
            var r4, n4 = g2(e4), a3 = s(e4), o3 = new Array(3);
            for (r4 = 0; r4 < 3; ++r4) {
              var l3 = i2[r4];
              if (o3[r4] = wt(e4 - l3[1], l3[3], l3[2], a3, n4, t4 - l3[0]), !o3[r4][0])
                return l3.point;
              o3[r4][1] = kt(o3[r4][1] - l3.v[1]);
            }
            var h2 = f3.slice();
            for (r4 = 0; r4 < 3; ++r4) {
              var p3 = 2 == r4 ? 0 : r4 + 1, d3 = Tt(i2[r4].v[0], o3[r4][0], o3[p3][0]);
              o3[r4][1] < 0 && (d3 = -d3), r4 ? 1 == r4 ? (d3 = u2 - d3, h2[0] -= o3[r4][0] * s(d3), h2[1] -= o3[r4][0] * g2(d3)) : (d3 = c2 - d3, h2[0] += o3[r4][0] * s(d3), h2[1] += o3[r4][0] * g2(d3)) : (h2[0] += o3[r4][0] * s(d3), h2[1] -= o3[r4][0] * g2(d3));
            }
            return h2[0] /= 3, h2[1] /= 3, h2;
          };
        }
        function Mt(t3) {
          return t3[0] *= E, t3[1] *= E, t3;
        }
        function St() {
          return Et([0, 22], [45, 22], [22.5, -22]).scale(380).center([22.5, 2]);
        }
        function Et(t3, e3, r3) {
          var i2 = (0, bt.Z)({ type: "MultiPoint", coordinates: [t3, e3, r3] }), a2 = [-i2[0], -i2[1]], o2 = (0, _t.Z)(a2), s2 = At(Mt(o2(t3)), Mt(o2(e3)), Mt(o2(r3)));
          s2.invert = tt(s2);
          var l2 = (0, n2.Z)(s2).rotate(a2), u2 = l2.center;
          return delete l2.rotate, l2.center = function(t4) {
            return arguments.length ? u2(o2(t4)) : o2.invert(u2());
          }, l2.clipAngle(90);
        }
        function Lt(t3, e3) {
          var r3 = P(1 - g2(e3));
          return [2 / A * t3 * r3, A * (1 - r3)];
        }
        function Ct() {
          return (0, n2.Z)(Lt).scale(95.6464).center([0, 30]);
        }
        function Pt(t3) {
          var e3 = y(t3);
          function r3(t4, r4) {
            return [t4, (t4 ? t4 / g2(t4) : 1) * (g2(r4) * s(t4) - e3 * s(r4))];
          }
          return r3.invert = e3 ? function(t4, r4) {
            t4 && (r4 *= g2(t4) / t4);
            var n3 = s(t4);
            return [t4, 2 * o(P(n3 * n3 + e3 * e3 - r4 * r4) - n3, e3 - r4)];
          } : function(t4, e4) {
            return [t4, L(t4 ? e4 * y(t4) / t4 : e4)];
          }, r3;
        }
        function Ot() {
          return ft(Pt).scale(249.828).clipAngle(90);
        }
        Lt.invert = function(t3, e3) {
          var r3 = (r3 = e3 / A - 1) * r3;
          return [r3 > 0 ? t3 * P(b / r3) / 2 : 0, L(1 - r3)];
        };
        var It = P(3);
        function Dt(t3, e3) {
          return [It * t3 * (2 * s(2 * e3 / 3) - 1) / A, It * A * g2(e3 / 3)];
        }
        function zt() {
          return (0, n2.Z)(Dt).scale(156.19);
        }
        function Rt(t3) {
          var e3 = s(t3);
          function r3(t4, r4) {
            return [t4 * e3, g2(r4) / e3];
          }
          return r3.invert = function(t4, r4) {
            return [t4 / e3, L(r4 * e3)];
          }, r3;
        }
        function Ft() {
          return ft(Rt).parallel(38.58).scale(195.044);
        }
        function Bt(t3) {
          var e3 = s(t3);
          function r3(t4, r4) {
            return [t4 * e3, (1 + e3) * y(r4 / 2)];
          }
          return r3.invert = function(t4, r4) {
            return [t4 / e3, 2 * a(r4 / (1 + e3))];
          }, r3;
        }
        function Nt() {
          return ft(Bt).scale(124.75);
        }
        function jt(t3, e3) {
          var r3 = P(8 / (3 * b));
          return [r3 * t3 * (1 - i(e3) / b), r3 * e3];
        }
        function Ut() {
          return (0, n2.Z)(jt).scale(165.664);
        }
        function Vt(t3, e3) {
          var r3 = P(4 - 3 * g2(i(e3)));
          return [2 / P(6 * b) * t3 * r3, v(e3) * P(2 * b / 3) * (2 - r3)];
        }
        function Ht() {
          return (0, n2.Z)(Vt).scale(165.664);
        }
        function qt(t3, e3) {
          var r3 = P(b * (4 + b));
          return [2 / r3 * t3 * (1 + P(1 - 4 * e3 * e3 / (b * b))), 4 / r3 * e3];
        }
        function Gt() {
          return (0, n2.Z)(qt).scale(180.739);
        }
        function Zt(t3, e3) {
          var r3 = (2 + _) * g2(e3);
          e3 /= 2;
          for (var n3 = 0, a2 = 1 / 0; n3 < 10 && i(a2) > m2; n3++) {
            var o2 = s(e3);
            e3 -= a2 = (e3 + g2(e3) * (o2 + 2) - r3) / (2 * o2 * (1 + o2));
          }
          return [2 / P(b * (4 + b)) * t3 * (1 + s(e3)), 2 * P(b / (4 + b)) * g2(e3)];
        }
        function Yt() {
          return (0, n2.Z)(Zt).scale(180.739);
        }
        function Wt(t3, e3) {
          return [t3 * (1 + s(e3)) / P(2 + b), 2 * e3 / P(2 + b)];
        }
        function Xt() {
          return (0, n2.Z)(Wt).scale(173.044);
        }
        function Jt(t3, e3) {
          for (var r3 = (1 + _) * g2(e3), n3 = 0, a2 = 1 / 0; n3 < 10 && i(a2) > m2; n3++)
            e3 -= a2 = (e3 + g2(e3) - r3) / (1 + s(e3));
          return r3 = P(2 + b), [t3 * (1 + s(e3)) / r3, 2 * e3 / r3];
        }
        function Kt() {
          return (0, n2.Z)(Jt).scale(173.044);
        }
        Dt.invert = function(t3, e3) {
          var r3 = 3 * L(e3 / (It * A));
          return [A * t3 / (It * (2 * s(2 * r3 / 3) - 1)), r3];
        }, jt.invert = function(t3, e3) {
          var r3 = P(8 / (3 * b)), n3 = e3 / r3;
          return [t3 / (r3 * (1 - i(n3) / b)), n3];
        }, Vt.invert = function(t3, e3) {
          var r3 = 2 - i(e3) / P(2 * b / 3);
          return [t3 * P(6 * b) / (2 * r3), v(e3) * L((4 - r3 * r3) / 3)];
        }, qt.invert = function(t3, e3) {
          var r3 = P(b * (4 + b)) / 2;
          return [t3 * r3 / (1 + P(1 - e3 * e3 * (4 + b) / (4 * b))), e3 * r3 / 2];
        }, Zt.invert = function(t3, e3) {
          var r3 = e3 * P((4 + b) / b) / 2, n3 = L(r3), i2 = s(n3);
          return [t3 / (2 / P(b * (4 + b)) * (1 + i2)), L((n3 + r3 * (i2 + 2)) / (2 + _))];
        }, Wt.invert = function(t3, e3) {
          var r3 = P(2 + b), n3 = e3 * r3 / 2;
          return [r3 * t3 / (1 + s(n3)), n3];
        }, Jt.invert = function(t3, e3) {
          var r3 = 1 + _, n3 = P(r3 / 2);
          return [2 * t3 * n3 / (1 + s(e3 *= n3)), L((e3 + g2(e3)) / r3)];
        };
        var $t = 3 + 2 * k;
        function Qt(t3, e3) {
          var r3 = g2(t3 /= 2), n3 = s(t3), i2 = P(s(e3)), o2 = s(e3 /= 2), l2 = g2(e3) / (o2 + k * n3 * i2), u2 = P(2 / (1 + l2 * l2)), f3 = P((k * o2 + (n3 + r3) * i2) / (k * o2 + (n3 - r3) * i2));
          return [$t * (u2 * (f3 - 1 / f3) - 2 * c(f3)), $t * (u2 * l2 * (f3 + 1 / f3) - 2 * a(l2))];
        }
        function te() {
          return (0, n2.Z)(Qt).scale(62.5271);
        }
        Qt.invert = function(t3, e3) {
          if (!(r3 = j.invert(t3 / 1.2, 1.065 * e3)))
            return null;
          var r3, n3 = r3[0], o2 = r3[1], l2 = 20;
          t3 /= $t, e3 /= $t;
          do {
            var u2 = n3 / 2, p3 = o2 / 2, d3 = g2(u2), v2 = s(u2), y2 = g2(p3), x2 = s(p3), b2 = s(o2), w3 = P(b2), A2 = y2 / (x2 + k * v2 * w3), M2 = A2 * A2, S2 = P(2 / (1 + M2)), E2 = (k * x2 + (v2 + d3) * w3) / (k * x2 + (v2 - d3) * w3), L2 = P(E2), C2 = L2 - 1 / L2, O2 = L2 + 1 / L2, I2 = S2 * C2 - 2 * c(L2) - t3, D2 = S2 * A2 * O2 - 2 * a(A2) - e3, z2 = y2 && T * w3 * d3 * M2 / y2, R2 = (k * v2 * x2 + w3) / (2 * (x2 + k * v2 * w3) * (x2 + k * v2 * w3) * w3), F2 = -0.5 * A2 * S2 * S2 * S2, B2 = F2 * z2, N2 = F2 * R2, U2 = (U2 = 2 * x2 + k * w3 * (v2 - d3)) * U2 * L2, V2 = (k * v2 * x2 * w3 + b2) / U2, H2 = -k * d3 * y2 / (w3 * U2), q3 = C2 * B2 - 2 * V2 / L2 + S2 * (V2 + V2 / E2), G2 = C2 * N2 - 2 * H2 / L2 + S2 * (H2 + H2 / E2), Z2 = A2 * O2 * B2 - 2 * z2 / (1 + M2) + S2 * O2 * z2 + S2 * A2 * (V2 - V2 / E2), Y2 = A2 * O2 * N2 - 2 * R2 / (1 + M2) + S2 * O2 * R2 + S2 * A2 * (H2 - H2 / E2), W2 = G2 * Z2 - Y2 * q3;
            if (!W2)
              break;
            var X2 = (D2 * G2 - I2 * Y2) / W2, J2 = (I2 * Z2 - D2 * q3) / W2;
            n3 -= X2, o2 = f2(-_, h(_, o2 - J2));
          } while ((i(X2) > m2 || i(J2) > m2) && --l2 > 0);
          return i(i(o2) - _) < m2 ? [0, o2] : l2 && [n3, o2];
        };
        var ee = s(35 * E);
        function re(t3, e3) {
          var r3 = y(e3 / 2);
          return [t3 * ee * P(1 - r3 * r3), (1 + ee) * r3];
        }
        function ne() {
          return (0, n2.Z)(re).scale(137.152);
        }
        function ie(t3, e3) {
          var r3 = e3 / 2, n3 = s(r3);
          return [2 * t3 / A * s(e3) * n3 * n3, A * y(r3)];
        }
        function ae() {
          return (0, n2.Z)(ie).scale(135.264);
        }
        function oe(t3) {
          var e3 = 1 - t3, r3 = i2(b, 0)[0] - i2(-b, 0)[0], n3 = P(2 * (i2(0, _)[1] - i2(0, -_)[1]) / r3);
          function i2(r4, n4) {
            var i3 = s(n4), a3 = g2(n4);
            return [i3 / (e3 + t3 * i3) * r4, e3 * n4 + t3 * a3];
          }
          function a2(t4, e4) {
            var r4 = i2(t4, e4);
            return [r4[0] * n3, r4[1] / n3];
          }
          function o2(t4) {
            return a2(0, t4)[1];
          }
          return a2.invert = function(r4, i3) {
            var a3 = Q(o2, i3);
            return [r4 / n3 * (t3 + e3 / s(a3)), a3];
          }, a2;
        }
        function se() {
          var t3 = 0.5, e3 = (0, n2.r)(oe), r3 = e3(t3);
          return r3.alpha = function(r4) {
            return arguments.length ? e3(t3 = +r4) : t3;
          }, r3.scale(168.725);
        }
        re.invert = function(t3, e3) {
          var r3 = e3 / (1 + ee);
          return [t3 && t3 / (ee * P(1 - r3 * r3)), 2 * a(r3)];
        }, ie.invert = function(t3, e3) {
          var r3 = a(e3 / A), n3 = s(r3), i2 = 2 * r3;
          return [t3 * A / 2 / (s(i2) * n3 * n3), i2];
        };
        var le = r2(57962), ue = r2(97492);
        function ce(t3) {
          return [t3[0] / 2, L(y(t3[1] / 2 * E)) * S];
        }
        function fe(t3) {
          return [2 * t3[0], 2 * a(g2(t3[1] * E)) * S];
        }
        function he(t3) {
          null == t3 && (t3 = le.Z);
          var e3 = t3(), r3 = (0, ue.Z)().scale(S).precision(0).clipAngle(null).translate([0, 0]);
          function n3(t4) {
            return e3(ce(t4));
          }
          function i2(t4) {
            n3[t4] = function() {
              return arguments.length ? (e3[t4].apply(e3, arguments), n3) : e3[t4]();
            };
          }
          return e3.invert && (n3.invert = function(t4) {
            return fe(e3.invert(t4));
          }), n3.stream = function(t4) {
            var n4 = e3.stream(t4), i3 = r3.stream({ point: function(t5, e4) {
              n4.point(t5 / 2, L(y(-e4 / 2 * E)) * S);
            }, lineStart: function() {
              n4.lineStart();
            }, lineEnd: function() {
              n4.lineEnd();
            }, polygonStart: function() {
              n4.polygonStart();
            }, polygonEnd: function() {
              n4.polygonEnd();
            } });
            return i3.sphere = n4.sphere, i3;
          }, n3.rotate = function(t4) {
            return arguments.length ? (r3.rotate(t4), n3) : r3.rotate();
          }, n3.center = function(t4) {
            return arguments.length ? (e3.center(ce(t4)), n3) : fe(e3.center());
          }, i2("angle"), i2("clipAngle"), i2("clipExtent"), i2("fitExtent"), i2("fitHeight"), i2("fitSize"), i2("fitWidth"), i2("scale"), i2("translate"), i2("precision"), n3.scale(249.5);
        }
        function pe(t3, e3) {
          var r3 = 2 * b / e3, n3 = t3 * t3;
          function a2(e4, a3) {
            var l2 = (0, Z.N)(e4, a3), u2 = l2[0], c2 = l2[1], f3 = u2 * u2 + c2 * c2;
            if (f3 > n3) {
              var h2 = P(f3), p3 = o(c2, u2), v2 = r3 * d2(p3 / r3), y2 = p3 - v2, x2 = t3 * s(y2), w3 = (t3 * g2(y2) - y2 * g2(x2)) / (_ - x2), T2 = de(y2, w3), k2 = (b - t3) / ve(T2, x2, b);
              u2 = h2;
              var A2, M2 = 50;
              do {
                u2 -= A2 = (t3 + ve(T2, x2, u2) * k2 - h2) / (T2(u2) * k2);
              } while (i(A2) > m2 && --M2 > 0);
              c2 = y2 * g2(u2), u2 < _ && (c2 -= w3 * (u2 - _));
              var S2 = g2(v2), E2 = s(v2);
              l2[0] = u2 * E2 - c2 * S2, l2[1] = u2 * S2 + c2 * E2;
            }
            return l2;
          }
          return a2.invert = function(e4, a3) {
            var l2 = e4 * e4 + a3 * a3;
            if (l2 > n3) {
              var u2 = P(l2), c2 = o(a3, e4), f3 = r3 * d2(c2 / r3), h2 = c2 - f3;
              e4 = u2 * s(h2), a3 = u2 * g2(h2);
              for (var p3 = e4 - _, v2 = g2(e4), y2 = a3 / v2, m3 = e4 < _ ? 1 / 0 : 0, w3 = 10; ; ) {
                var T2 = t3 * g2(y2), k2 = t3 * s(y2), A2 = g2(k2), M2 = _ - k2, S2 = (T2 - y2 * A2) / M2, E2 = de(y2, S2);
                if (i(m3) < x || !--w3)
                  break;
                y2 -= m3 = (y2 * v2 - S2 * p3 - a3) / (v2 - 2 * p3 * (M2 * (k2 + y2 * T2 * s(k2) - A2) - T2 * (T2 - y2 * A2)) / (M2 * M2));
              }
              e4 = (u2 = t3 + ve(E2, k2, e4) * (b - t3) / ve(E2, k2, b)) * s(c2 = f3 + y2), a3 = u2 * g2(c2);
            }
            return Z.N.invert(e4, a3);
          }, a2;
        }
        function de(t3, e3) {
          return function(r3) {
            var n3 = t3 * s(r3);
            return r3 < _ && (n3 -= e3), P(1 + n3 * n3);
          };
        }
        function ve(t3, e3, r3) {
          for (var n3 = (r3 - e3) / 50, i2 = t3(e3) + t3(r3), a2 = 1, o2 = e3; a2 < 50; ++a2)
            i2 += 2 * t3(o2 += n3);
          return 0.5 * i2 * n3;
        }
        function ge() {
          var t3 = 6, e3 = 30 * E, r3 = s(e3), i2 = g2(e3), a2 = (0, n2.r)(pe), l2 = a2(e3, t3), u2 = l2.stream, c2 = -s(0.01 * E), f3 = g2(0.01 * E);
          return l2.radius = function(n3) {
            return arguments.length ? (r3 = s(e3 = n3 * E), i2 = g2(e3), a2(e3, t3)) : e3 * S;
          }, l2.lobes = function(r4) {
            return arguments.length ? a2(e3, t3 = +r4) : t3;
          }, l2.stream = function(e4) {
            var n3 = l2.rotate(), a3 = u2(e4), h2 = (l2.rotate([0, 0]), u2(e4));
            return l2.rotate(n3), a3.sphere = function() {
              h2.polygonStart(), h2.lineStart();
              for (var e5 = 0, n4 = 2 * b / t3, a4 = 0; e5 < t3; ++e5, a4 -= n4)
                h2.point(o(f3 * s(a4), c2) * S, L(f3 * g2(a4)) * S), h2.point(o(i2 * s(a4 - n4 / 2), r3) * S, L(i2 * g2(a4 - n4 / 2)) * S);
              h2.lineEnd(), h2.polygonEnd();
            }, a3;
          }, l2.rotate([90, -40]).scale(91.7095).clipAngle(179.999);
        }
        function ye(t3, e3, r3, n3, a2, o2, l2, u2) {
          function c2(i2, c3) {
            if (!c3)
              return [t3 * i2 / b, 0];
            var f3 = c3 * c3, h2 = t3 + f3 * (e3 + f3 * (r3 + f3 * n3)), p3 = c3 * (a2 - 1 + f3 * (o2 - u2 + f3 * l2)), d3 = (h2 * h2 + p3 * p3) / (2 * p3), v2 = i2 * L(h2 / d3) / b;
            return [d3 * g2(v2), c3 * (1 + f3 * u2) + d3 * (1 - s(v2))];
          }
          return arguments.length < 8 && (u2 = 0), c2.invert = function(c3, f3) {
            var h2, p3, d3 = b * c3 / t3, v2 = f3, y2 = 50;
            do {
              var x2 = v2 * v2, _2 = t3 + x2 * (e3 + x2 * (r3 + x2 * n3)), w3 = v2 * (a2 - 1 + x2 * (o2 - u2 + x2 * l2)), T2 = _2 * _2 + w3 * w3, k2 = 2 * w3, A2 = T2 / k2, M2 = A2 * A2, S2 = L(_2 / A2) / b, E2 = d3 * S2, C2 = _2 * _2, O2 = (2 * e3 + x2 * (4 * r3 + 6 * x2 * n3)) * v2, I2 = a2 + x2 * (3 * o2 + 5 * x2 * l2), D2 = (2 * (_2 * O2 + w3 * (I2 - 1)) * k2 - T2 * (2 * (I2 - 1))) / (k2 * k2), z2 = s(E2), R2 = g2(E2), F2 = A2 * z2, B2 = A2 * R2, N2 = d3 / b * (1 / P(1 - C2 / M2)) * (O2 * A2 - _2 * D2) / M2, j2 = B2 - c3, U2 = v2 * (1 + x2 * u2) + A2 - F2 - f3, V2 = D2 * R2 + F2 * N2, H2 = F2 * S2, q3 = 1 + D2 - (D2 * z2 - B2 * N2), G2 = B2 * S2, Z2 = V2 * G2 - q3 * H2;
              if (!Z2)
                break;
              d3 -= h2 = (U2 * V2 - j2 * q3) / Z2, v2 -= p3 = (j2 * G2 - U2 * H2) / Z2;
            } while ((i(h2) > m2 || i(p3) > m2) && --y2 > 0);
            return [d3, v2];
          }, c2;
        }
        var me = ye(2.8284, -1.6988, 0.75432, -0.18071, 1.76003, -0.38914, 0.042555);
        function xe() {
          return (0, n2.Z)(me).scale(149.995);
        }
        var be = ye(2.583819, -0.835827, 0.170354, -0.038094, 1.543313, -0.411435, 0.082742);
        function _e() {
          return (0, n2.Z)(be).scale(153.93);
        }
        var we = ye(5 / 6 * b, -0.62636, -0.0344, 0, 1.3493, -0.05524, 0, 0.045);
        function Te() {
          return (0, n2.Z)(we).scale(130.945);
        }
        function ke(t3, e3) {
          var r3 = t3 * t3, n3 = e3 * e3;
          return [t3 * (1 - 0.162388 * n3) * (0.87 - 952426e-9 * r3 * r3), e3 * (1 + n3 / 12)];
        }
        function Ae() {
          return (0, n2.Z)(ke).scale(131.747);
        }
        ke.invert = function(t3, e3) {
          var r3, n3 = t3, a2 = e3, o2 = 50;
          do {
            var s2 = a2 * a2;
            a2 -= r3 = (a2 * (1 + s2 / 12) - e3) / (1 + s2 / 4);
          } while (i(r3) > m2 && --o2 > 0);
          o2 = 50, t3 /= 1 - 0.162388 * s2;
          do {
            var l2 = (l2 = n3 * n3) * l2;
            n3 -= r3 = (n3 * (0.87 - 952426e-9 * l2) - t3) / (0.87 - 476213e-8 * l2);
          } while (i(r3) > m2 && --o2 > 0);
          return [n3, a2];
        };
        var Me = ye(2.6516, -0.76534, 0.19123, -0.047094, 1.36289, -0.13965, 0.031762);
        function Se() {
          return (0, n2.Z)(Me).scale(131.087);
        }
        function Ee(t3) {
          var e3 = t3(_, 0)[0] - t3(-_, 0)[0];
          function r3(r4, n3) {
            var i2 = r4 > 0 ? -0.5 : 0.5, a2 = t3(r4 + i2 * b, n3);
            return a2[0] -= i2 * e3, a2;
          }
          return t3.invert && (r3.invert = function(r4, n3) {
            var i2 = r4 > 0 ? -0.5 : 0.5, a2 = t3.invert(r4 + i2 * e3, n3), o2 = a2[0] - i2 * b;
            return o2 < -b ? o2 += 2 * b : o2 > b && (o2 -= 2 * b), a2[0] = o2, a2;
          }), r3;
        }
        function Le(t3, e3) {
          var r3 = v(t3), n3 = v(e3), a2 = s(e3), l2 = s(t3) * a2, u2 = g2(t3) * a2, c2 = g2(n3 * e3);
          t3 = i(o(u2, c2)), e3 = L(l2), i(t3 - _) > m2 && (t3 %= _);
          var f3 = function(t4, e4) {
            if (e4 === _)
              return [0, 0];
            var r4, n4, a3 = g2(e4), o2 = a3 * a3, l3 = o2 * o2, u3 = 1 + l3, c3 = 1 + 3 * l3, f4 = 1 - l3, h2 = L(1 / P(u3)), p3 = f4 + o2 * u3 * h2, d3 = (1 - a3) / p3, v2 = P(d3), y2 = d3 * u3, x2 = P(y2), w3 = v2 * f4;
            if (0 === t4)
              return [0, -(w3 + o2 * x2)];
            var T2, k2 = s(e4), A2 = 1 / k2, M2 = 2 * a3 * k2, S2 = (-p3 * k2 - (-3 * o2 + h2 * c3) * M2 * (1 - a3)) / (p3 * p3), E2 = -A2 * M2, C2 = -A2 * (o2 * u3 * S2 + d3 * c3 * M2), O2 = -2 * A2 * (f4 * (0.5 * S2 / v2) - 2 * o2 * v2 * M2), I2 = 4 * t4 / b;
            if (t4 > 0.222 * b || e4 < b / 4 && t4 > 0.175 * b) {
              if (r4 = (w3 + o2 * P(y2 * (1 + l3) - w3 * w3)) / (1 + l3), t4 > b / 4)
                return [r4, r4];
              var D2 = r4, z2 = 0.5 * r4;
              r4 = 0.5 * (z2 + D2), n4 = 50;
              do {
                var R2 = r4 * (O2 + E2 * P(y2 - r4 * r4)) + C2 * L(r4 / x2) - I2;
                if (!R2)
                  break;
                R2 < 0 ? z2 = r4 : D2 = r4, r4 = 0.5 * (z2 + D2);
              } while (i(D2 - z2) > m2 && --n4 > 0);
            } else {
              r4 = m2, n4 = 25;
              do {
                var F2 = r4 * r4, B2 = P(y2 - F2), N2 = O2 + E2 * B2, j2 = r4 * N2 + C2 * L(r4 / x2) - I2;
                r4 -= T2 = B2 ? j2 / (N2 + (C2 - E2 * F2) / B2) : 0;
              } while (i(T2) > m2 && --n4 > 0);
            }
            return [r4, -w3 - o2 * P(y2 - r4 * r4)];
          }(t3 > b / 4 ? _ - t3 : t3, e3);
          return t3 > b / 4 && (c2 = f3[0], f3[0] = -f3[1], f3[1] = -c2), f3[0] *= r3, f3[1] *= -n3, f3;
        }
        function Ce() {
          return (0, n2.Z)(Ee(Le)).scale(239.75);
        }
        function Pe(t3, e3) {
          var r3, n3, o2, u2, c2, f3;
          if (e3 < m2)
            return [(u2 = g2(t3)) - (r3 = e3 * (t3 - u2 * (n3 = s(t3))) / 4) * n3, n3 + r3 * u2, 1 - e3 * u2 * u2 / 2, t3 - r3];
          if (e3 >= 0.999999)
            return r3 = (1 - e3) / 4, o2 = 1 / (n3 = I(t3)), [(u2 = ((f3 = l(2 * (f3 = t3))) - 1) / (f3 + 1)) + r3 * ((c2 = n3 * O(t3)) - t3) / (n3 * n3), o2 - r3 * u2 * o2 * (c2 - t3), o2 + r3 * u2 * o2 * (c2 + t3), 2 * a(l(t3)) - _ + r3 * (c2 - t3) / n3];
          var h2 = [1, 0, 0, 0, 0, 0, 0, 0, 0], p3 = [P(e3), 0, 0, 0, 0, 0, 0, 0, 0], d3 = 0;
          for (n3 = P(1 - e3), c2 = 1; i(p3[d3] / h2[d3]) > m2 && d3 < 8; )
            r3 = h2[d3++], p3[d3] = (r3 - n3) / 2, h2[d3] = (r3 + n3) / 2, n3 = P(r3 * n3), c2 *= 2;
          o2 = c2 * h2[d3] * t3;
          do {
            o2 = (L(u2 = p3[d3] * g2(n3 = o2) / h2[d3]) + o2) / 2;
          } while (--d3);
          return [g2(o2), u2 = s(o2), u2 / s(o2 - n3), o2];
        }
        function Oe(t3, e3) {
          if (!e3)
            return t3;
          if (1 === e3)
            return c(y(t3 / 2 + w2));
          for (var r3 = 1, n3 = P(1 - e3), o2 = P(e3), s2 = 0; i(o2) > m2; s2++) {
            if (t3 % b) {
              var l2 = a(n3 * y(t3) / r3);
              l2 < 0 && (l2 += b), t3 += l2 + ~~(t3 / b) * b;
            } else
              t3 += t3;
            o2 = (r3 + n3) / 2, n3 = P(r3 * n3), o2 = ((r3 = o2) - n3) / 2;
          }
          return t3 / (p2(2, s2) * r3);
        }
        function Ie(t3, e3) {
          var r3 = (k - 1) / (k + 1), n3 = P(1 - r3 * r3), u2 = Oe(_, n3 * n3), f3 = c(y(b / 4 + i(e3) / 2)), h2 = l(-1 * f3) / P(r3), p3 = function(t4, e4) {
            var r4 = t4 * t4, n4 = e4 + 1, i2 = 1 - r4 - e4 * e4;
            return [0.5 * ((t4 >= 0 ? _ : -_) - o(i2, 2 * t4)), -0.25 * c(i2 * i2 + 4 * r4) + 0.5 * c(n4 * n4 + r4)];
          }(h2 * s(-1 * t3), h2 * g2(-1 * t3)), d3 = function(t4, e4, r4) {
            var n4 = i(t4), o2 = O(i(e4));
            if (n4) {
              var s2 = 1 / g2(n4), l2 = 1 / (y(n4) * y(n4)), u3 = -(l2 + r4 * (o2 * o2 * s2 * s2) - 1 + r4), c2 = (-u3 + P(u3 * u3 - (r4 - 1) * l2 * 4)) / 2;
              return [Oe(a(1 / P(c2)), r4) * v(t4), Oe(a(P((c2 / l2 - 1) / r4)), 1 - r4) * v(e4)];
            }
            return [0, Oe(a(o2), 1 - r4) * v(e4)];
          }(p3[0], p3[1], n3 * n3);
          return [-d3[1], (e3 >= 0 ? 1 : -1) * (0.5 * u2 - d3[0])];
        }
        function De() {
          return (0, n2.Z)(Ee(Ie)).scale(151.496);
        }
        Le.invert = function(t3, e3) {
          i(t3) > 1 && (t3 = 2 * v(t3) - t3), i(e3) > 1 && (e3 = 2 * v(e3) - e3);
          var r3 = v(t3), n3 = v(e3), a2 = -r3 * t3, l2 = -n3 * e3, u2 = l2 / a2 < 1, c2 = function(t4, e4) {
            for (var r4 = 0, n4 = 1, a3 = 0.5, o2 = 50; ; ) {
              var l3 = a3 * a3, u3 = P(a3), c3 = L(1 / P(1 + l3)), f4 = 1 - l3 + a3 * (1 + l3) * c3, h3 = (1 - u3) / f4, p4 = P(h3), d3 = h3 * (1 + l3), v2 = p4 * (1 - l3), g3 = P(d3 - t4 * t4), y2 = e4 + v2 + a3 * g3;
              if (i(n4 - r4) < x || 0 == --o2 || 0 === y2)
                break;
              y2 > 0 ? r4 = a3 : n4 = a3, a3 = 0.5 * (r4 + n4);
            }
            if (!o2)
              return null;
            var m3 = L(u3), _2 = s(m3), w3 = 1 / _2, T2 = 2 * u3 * _2, k2 = (-f4 * _2 - (-3 * a3 + c3 * (1 + 3 * l3)) * T2 * (1 - u3)) / (f4 * f4);
            return [b / 4 * (t4 * (-2 * w3 * (0.5 * k2 / p4 * (1 - l3) - 2 * a3 * p4 * T2) + -w3 * T2 * g3) + -w3 * (a3 * (1 + l3) * k2 + h3 * (1 + 3 * l3) * T2) * L(t4 / P(d3))), m3];
          }(u2 ? l2 : a2, u2 ? a2 : l2), f3 = c2[0], h2 = c2[1], p3 = s(h2);
          return u2 && (f3 = -_ - f3), [r3 * (o(g2(f3) * p3, -g2(h2)) + b), n3 * L(s(f3) * p3)];
        }, Ie.invert = function(t3, e3) {
          var r3, n3, i2, s2, u2, f3, h2 = (k - 1) / (k + 1), p3 = P(1 - h2 * h2), d3 = (n3 = -t3, i2 = p3 * p3, (r3 = 0.5 * Oe(_, p3 * p3) - e3) ? (s2 = Pe(r3, i2), n3 ? (f3 = (u2 = Pe(n3, 1 - i2))[1] * u2[1] + i2 * s2[0] * s2[0] * u2[0] * u2[0], [[s2[0] * u2[2] / f3, s2[1] * s2[2] * u2[0] * u2[1] / f3], [s2[1] * u2[1] / f3, -s2[0] * s2[2] * u2[0] * u2[2] / f3], [s2[2] * u2[1] * u2[2] / f3, -i2 * s2[0] * s2[1] * u2[0] / f3]]) : [[s2[0], 0], [s2[1], 0], [s2[2], 0]]) : [[0, (u2 = Pe(n3, 1 - i2))[0] / u2[1]], [1 / u2[1], 0], [u2[2] / u2[1], 0]]), v2 = function(t4, e4) {
            var r4 = e4[0] * e4[0] + e4[1] * e4[1];
            return [(t4[0] * e4[0] + t4[1] * e4[1]) / r4, (t4[1] * e4[0] - t4[0] * e4[1]) / r4];
          }(d3[0], d3[1]);
          return [o(v2[1], v2[0]) / -1, 2 * a(l(-0.5 * c(h2 * v2[0] * v2[0] + h2 * v2[1] * v2[1]))) - _];
        };
        var ze = r2(7613);
        function Re(t3) {
          var e3 = g2(t3), r3 = s(t3), n3 = Fe(t3);
          function a2(t4, a3) {
            var o2 = n3(t4, a3);
            t4 = o2[0], a3 = o2[1];
            var l2 = g2(a3), u2 = s(a3), c2 = s(t4), f3 = C(e3 * l2 + r3 * u2 * c2), h2 = g2(f3), p3 = i(h2) > m2 ? f3 / h2 : 1;
            return [p3 * r3 * g2(t4), (i(t4) > _ ? p3 : -p3) * (e3 * u2 - r3 * l2 * c2)];
          }
          return n3.invert = Fe(-t3), a2.invert = function(t4, r4) {
            var i2 = P(t4 * t4 + r4 * r4), a3 = -g2(i2), l2 = s(i2), u2 = i2 * l2, c2 = -r4 * a3, f3 = i2 * e3, h2 = P(u2 * u2 + c2 * c2 - f3 * f3), p3 = o(u2 * f3 + c2 * h2, c2 * f3 - u2 * h2), d3 = (i2 > _ ? -1 : 1) * o(t4 * a3, i2 * s(p3) * l2 + r4 * g2(p3) * a3);
            return n3.invert(d3, p3);
          }, a2;
        }
        function Fe(t3) {
          var e3 = g2(t3), r3 = s(t3);
          return function(t4, n3) {
            var i2 = s(n3), a2 = s(t4) * i2, l2 = g2(t4) * i2, u2 = g2(n3);
            return [o(l2, a2 * r3 - u2 * e3), L(u2 * r3 + a2 * e3)];
          };
        }
        function Be() {
          var t3 = 0, e3 = (0, n2.r)(Re), r3 = e3(t3), i2 = r3.rotate, a2 = r3.stream, o2 = (0, ze.Z)();
          return r3.parallel = function(n3) {
            if (!arguments.length)
              return t3 * S;
            var i3 = r3.rotate();
            return e3(t3 = n3 * E).rotate(i3);
          }, r3.rotate = function(e4) {
            return arguments.length ? (i2.call(r3, [e4[0], e4[1] - t3 * S]), o2.center([-e4[0], -e4[1]]), r3) : ((e4 = i2.call(r3))[1] += t3 * S, e4);
          }, r3.stream = function(t4) {
            return (t4 = a2(t4)).sphere = function() {
              t4.polygonStart();
              var e4, r4 = o2.radius(89.99)().coordinates[0], n3 = r4.length - 1, i3 = -1;
              for (t4.lineStart(); ++i3 < n3; )
                t4.point((e4 = r4[i3])[0], e4[1]);
              for (t4.lineEnd(), n3 = (r4 = o2.radius(90.01)().coordinates[0]).length - 1, t4.lineStart(); --i3 >= 0; )
                t4.point((e4 = r4[i3])[0], e4[1]);
              t4.lineEnd(), t4.polygonEnd();
            }, t4;
          }, r3.scale(79.4187).parallel(45).clipAngle(179.999);
        }
        var Ne = r2(33064), je = r2(72736), Ue = L(1 - 1 / 3) * S, Ve = Rt(0);
        function He(t3) {
          var e3 = Ue * E, r3 = Lt(b, e3)[0] - Lt(-b, e3)[0], n3 = Ve(0, e3)[1], a2 = Lt(0, e3)[1], o2 = A - a2, s2 = M / t3, l2 = 4 / M, c2 = n3 + o2 * o2 * 4 / M;
          function p3(p4, d3) {
            var v2, g3 = i(d3);
            if (g3 > e3) {
              var y2 = h(t3 - 1, f2(0, u((p4 + b) / s2)));
              (v2 = Lt(p4 += b * (t3 - 1) / t3 - y2 * s2, g3))[0] = v2[0] * M / r3 - M * (t3 - 1) / (2 * t3) + y2 * M / t3, v2[1] = n3 + 4 * (v2[1] - a2) * o2 / M, d3 < 0 && (v2[1] = -v2[1]);
            } else
              v2 = Ve(p4, d3);
            return v2[0] *= l2, v2[1] /= c2, v2;
          }
          return p3.invert = function(e4, p4) {
            e4 /= l2;
            var d3 = i(p4 *= c2);
            if (d3 > n3) {
              var v2 = h(t3 - 1, f2(0, u((e4 + b) / s2)));
              e4 = (e4 + b * (t3 - 1) / t3 - v2 * s2) * r3 / M;
              var g3 = Lt.invert(e4, 0.25 * (d3 - n3) * M / o2 + a2);
              return g3[0] -= b * (t3 - 1) / t3 - v2 * s2, p4 < 0 && (g3[1] = -g3[1]), g3;
            }
            return Ve.invert(e4, p4);
          }, p3;
        }
        function qe(t3, e3) {
          return [t3, 1 & e3 ? 89.999999 : Ue];
        }
        function Ge(t3, e3) {
          return [t3, 1 & e3 ? -89.999999 : -Ue];
        }
        function Ze(t3) {
          return [0.999999 * t3[0], t3[1]];
        }
        function Ye() {
          var t3 = 4, e3 = (0, n2.r)(He), r3 = e3(t3), i2 = r3.stream;
          return r3.lobes = function(r4) {
            return arguments.length ? e3(t3 = +r4) : t3;
          }, r3.stream = function(e4) {
            var n3 = r3.rotate(), a2 = i2(e4), o2 = (r3.rotate([0, 0]), i2(e4));
            return r3.rotate(n3), a2.sphere = function() {
              var e5, r4;
              (0, je.Z)((e5 = 180 / t3, r4 = [].concat((0, Ne.w6)(-180, 180 + e5 / 2, e5).map(qe), (0, Ne.w6)(180, -180 - e5 / 2, -e5).map(Ge)), { type: "Polygon", coordinates: [180 === e5 ? r4.map(Ze) : r4] }), o2);
            }, a2;
          }, r3.scale(239.75);
        }
        function We(t3) {
          var e3, r3 = 1 + t3, n3 = L(g2(1 / r3)), a2 = 2 * P(b / (e3 = b + 4 * n3 * r3)), l2 = 0.5 * a2 * (r3 + P(t3 * (2 + t3))), u2 = t3 * t3, c2 = r3 * r3;
          function f3(f4, h2) {
            var p3, d3, v2 = 1 - g2(h2);
            if (v2 && v2 < 2) {
              var y2, m3 = _ - h2, w3 = 25;
              do {
                var T2 = g2(m3), k2 = s(m3), A2 = n3 + o(T2, r3 - k2), M2 = 1 + c2 - 2 * r3 * k2;
                m3 -= y2 = (m3 - u2 * n3 - r3 * T2 + M2 * A2 - 0.5 * v2 * e3) / (2 * r3 * T2 * A2);
              } while (i(y2) > x && --w3 > 0);
              p3 = a2 * P(M2), d3 = f4 * A2 / b;
            } else
              p3 = a2 * (t3 + v2), d3 = f4 * n3 / b;
            return [p3 * g2(d3), l2 - p3 * s(d3)];
          }
          return f3.invert = function(t4, i2) {
            var s2 = t4 * t4 + (i2 -= l2) * i2, f4 = (1 + c2 - s2 / (a2 * a2)) / (2 * r3), h2 = C(f4), p3 = g2(h2), d3 = n3 + o(p3, r3 - f4);
            return [L(t4 / P(s2)) * b / d3, L(1 - 2 * (h2 - u2 * n3 - r3 * p3 + (1 + c2 - 2 * r3 * f4) * d3) / e3)];
          }, f3;
        }
        function Xe() {
          var t3 = 1, e3 = (0, n2.r)(We), r3 = e3(t3);
          return r3.ratio = function(r4) {
            return arguments.length ? e3(t3 = +r4) : t3;
          }, r3.scale(167.774).center([0, 18.67]);
        }
        var Je = 0.7109889596207567, Ke = 0.0528035274542;
        function $e(t3, e3) {
          return e3 > -Je ? ((t3 = at(t3, e3))[1] += Ke, t3) : ht(t3, e3);
        }
        function Qe() {
          return (0, n2.Z)($e).rotate([-20, -55]).scale(164.263).center([0, -5.4036]);
        }
        function tr(t3, e3) {
          return i(e3) > Je ? ((t3 = at(t3, e3))[1] -= e3 > 0 ? Ke : -Ke, t3) : ht(t3, e3);
        }
        function er() {
          return (0, n2.Z)(tr).scale(152.63);
        }
        function rr(t3, e3, r3, n3) {
          var i2 = P(4 * b / (2 * r3 + (1 + t3 - e3 / 2) * g2(2 * r3) + (t3 + e3) / 2 * g2(4 * r3) + e3 / 2 * g2(6 * r3))), a2 = P(n3 * g2(r3) * P((1 + t3 * s(2 * r3) + e3 * s(4 * r3)) / (1 + t3 + e3))), o2 = r3 * u2(1);
          function l2(r4) {
            return P(1 + t3 * s(2 * r4) + e3 * s(4 * r4));
          }
          function u2(n4) {
            var i3 = n4 * r3;
            return (2 * i3 + (1 + t3 - e3 / 2) * g2(2 * i3) + (t3 + e3) / 2 * g2(4 * i3) + e3 / 2 * g2(6 * i3)) / r3;
          }
          function c2(t4) {
            return l2(t4) * g2(t4);
          }
          var f3 = function(t4, e4) {
            var n4 = r3 * Q(u2, o2 * g2(e4) / r3, e4 / b);
            isNaN(n4) && (n4 = r3 * v(e4));
            var c3 = i2 * l2(n4);
            return [c3 * a2 * t4 / b * s(n4), c3 / a2 * g2(n4)];
          };
          return f3.invert = function(t4, e4) {
            var n4 = Q(c2, e4 * a2 / i2);
            return [t4 * b / (s(n4) * i2 * a2 * l2(n4)), L(r3 * u2(n4 / r3) / o2)];
          }, 0 === r3 && (i2 = P(n3 / b), (f3 = function(t4, e4) {
            return [t4 * i2, g2(e4) / i2];
          }).invert = function(t4, e4) {
            return [t4 / i2, L(e4 * i2)];
          }), f3;
        }
        function nr() {
          var t3 = 1, e3 = 0, r3 = 45 * E, i2 = 2, a2 = (0, n2.r)(rr), o2 = a2(t3, e3, r3, i2);
          return o2.a = function(n3) {
            return arguments.length ? a2(t3 = +n3, e3, r3, i2) : t3;
          }, o2.b = function(n3) {
            return arguments.length ? a2(t3, e3 = +n3, r3, i2) : e3;
          }, o2.psiMax = function(n3) {
            return arguments.length ? a2(t3, e3, r3 = +n3 * E, i2) : r3 * S;
          }, o2.ratio = function(n3) {
            return arguments.length ? a2(t3, e3, r3, i2 = +n3) : i2;
          }, o2.scale(180.739);
        }
        function ir(t3, e3, r3, n3, i2, a2, o2, s2, l2, u2, c2) {
          if (c2.nanEncountered)
            return NaN;
          var f3, h2, p3, d3, v2, g3, y2, m3, x2, b2;
          if (h2 = t3(e3 + 0.25 * (f3 = r3 - e3)), p3 = t3(r3 - 0.25 * f3), isNaN(h2))
            c2.nanEncountered = true;
          else {
            if (!isNaN(p3))
              return b2 = ((g3 = (d3 = f3 * (n3 + 4 * h2 + i2) / 12) + (v2 = f3 * (i2 + 4 * p3 + a2) / 12)) - o2) / 15, u2 > l2 ? (c2.maxDepthCount++, g3 + b2) : Math.abs(b2) < s2 ? g3 + b2 : (m3 = ir(t3, e3, y2 = e3 + 0.5 * f3, n3, h2, i2, d3, 0.5 * s2, l2, u2 + 1, c2), isNaN(m3) ? (c2.nanEncountered = true, NaN) : (x2 = ir(t3, y2, r3, i2, p3, a2, v2, 0.5 * s2, l2, u2 + 1, c2), isNaN(x2) ? (c2.nanEncountered = true, NaN) : m3 + x2));
            c2.nanEncountered = true;
          }
        }
        function ar(t3, e3, r3, n3, i2) {
          void 0 === n3 && (n3 = 1e-8), void 0 === i2 && (i2 = 20);
          var a2 = t3(e3), o2 = t3(0.5 * (e3 + r3)), s2 = t3(r3);
          return ir(t3, e3, r3, a2, o2, s2, (a2 + 4 * o2 + s2) * (r3 - e3) / 6, n3, i2, 1, { maxDepthCount: 0, nanEncountered: false });
        }
        function or(t3, e3, r3) {
          function n3(r4) {
            return t3 + (1 - t3) * p2(1 - p2(r4, e3), 1 / e3);
          }
          function a2(t4) {
            return ar(n3, 0, t4, 1e-4);
          }
          for (var o2 = 1 / a2(1), s2 = 1e3, l2 = (1 + 1e-8) * o2, u2 = [], c2 = 0; c2 <= s2; c2++)
            u2.push(a2(c2 / s2) * l2);
          function f3(t4) {
            var e4 = 0, r4 = s2, n4 = 500;
            do {
              u2[n4] > t4 ? r4 = n4 : e4 = n4, n4 = e4 + r4 >> 1;
            } while (n4 > e4);
            var i2 = u2[n4 + 1] - u2[n4];
            return i2 && (i2 = (t4 - u2[n4 + 1]) / i2), (n4 + 1 + i2) / s2;
          }
          var h2 = 2 * f3(1) / b * o2 / r3, d3 = function(t4, e4) {
            var r4 = f3(i(g2(e4))), a3 = n3(r4) * t4;
            return r4 /= h2, [a3, e4 >= 0 ? r4 : -r4];
          };
          return d3.invert = function(t4, e4) {
            var r4;
            return i(e4 *= h2) < 1 && (r4 = v(e4) * L(a2(i(e4)) * o2)), [t4 / n3(i(e4)), r4];
          }, d3;
        }
        function sr() {
          var t3 = 0, e3 = 2.5, r3 = 1.183136, i2 = (0, n2.r)(or), a2 = i2(t3, e3, r3);
          return a2.alpha = function(n3) {
            return arguments.length ? i2(t3 = +n3, e3, r3) : t3;
          }, a2.k = function(n3) {
            return arguments.length ? i2(t3, e3 = +n3, r3) : e3;
          }, a2.gamma = function(n3) {
            return arguments.length ? i2(t3, e3, r3 = +n3) : r3;
          }, a2.scale(152.63);
        }
        function lr(t3, e3) {
          return i(t3[0] - e3[0]) < m2 && i(t3[1] - e3[1]) < m2;
        }
        function ur(t3, e3) {
          for (var r3, n3, i2, a2 = -1, o2 = t3.length, s2 = t3[0], l2 = []; ++a2 < o2; ) {
            n3 = ((r3 = t3[a2])[0] - s2[0]) / e3, i2 = (r3[1] - s2[1]) / e3;
            for (var u2 = 0; u2 < e3; ++u2)
              l2.push([s2[0] + u2 * n3, s2[1] + u2 * i2]);
            s2 = r3;
          }
          return l2.push(r3), l2;
        }
        function cr(t3) {
          var e3, r3, n3, i2, a2, o2, s2, l2 = [], u2 = t3[0].length;
          for (s2 = 0; s2 < u2; ++s2)
            r3 = (e3 = t3[0][s2])[0][0], n3 = e3[0][1], i2 = e3[1][1], a2 = e3[2][0], o2 = e3[2][1], l2.push(ur([[r3 + m2, n3 + m2], [r3 + m2, i2 - m2], [a2 - m2, i2 - m2], [a2 - m2, o2 + m2]], 30));
          for (s2 = t3[1].length - 1; s2 >= 0; --s2)
            r3 = (e3 = t3[1][s2])[0][0], n3 = e3[0][1], i2 = e3[1][1], a2 = e3[2][0], o2 = e3[2][1], l2.push(ur([[a2 - m2, o2 - m2], [a2 - m2, i2 + m2], [r3 + m2, i2 + m2], [r3 + m2, n3 - m2]], 30));
          return { type: "Polygon", coordinates: [(0, Ne.TS)(l2)] };
        }
        function fr(t3, e3, r3) {
          var i2, a2;
          function o2(r4, n3) {
            for (var i3 = n3 < 0 ? -1 : 1, a3 = e3[+(n3 < 0)], o3 = 0, s3 = a3.length - 1; o3 < s3 && r4 > a3[o3][2][0]; ++o3)
              ;
            var l3 = t3(r4 - a3[o3][1][0], n3);
            return l3[0] += t3(a3[o3][1][0], i3 * n3 > i3 * a3[o3][0][1] ? a3[o3][0][1] : n3)[0], l3;
          }
          r3 ? o2.invert = r3(o2) : t3.invert && (o2.invert = function(r4, n3) {
            for (var i3 = a2[+(n3 < 0)], s3 = e3[+(n3 < 0)], l3 = 0, u2 = i3.length; l3 < u2; ++l3) {
              var c2 = i3[l3];
              if (c2[0][0] <= r4 && r4 < c2[1][0] && c2[0][1] <= n3 && n3 < c2[1][1]) {
                var f3 = t3.invert(r4 - t3(s3[l3][1][0], 0)[0], n3);
                return f3[0] += s3[l3][1][0], lr(o2(f3[0], f3[1]), [r4, n3]) ? f3 : null;
              }
            }
          });
          var s2 = (0, n2.Z)(o2), l2 = s2.stream;
          return s2.stream = function(t4) {
            var e4 = s2.rotate(), r4 = l2(t4), n3 = (s2.rotate([0, 0]), l2(t4));
            return s2.rotate(e4), r4.sphere = function() {
              (0, je.Z)(i2, n3);
            }, r4;
          }, s2.lobes = function(r4) {
            return arguments.length ? (i2 = cr(r4), e3 = r4.map(function(t4) {
              return t4.map(function(t5) {
                return [[t5[0][0] * E, t5[0][1] * E], [t5[1][0] * E, t5[1][1] * E], [t5[2][0] * E, t5[2][1] * E]];
              });
            }), a2 = e3.map(function(e4) {
              return e4.map(function(e5) {
                var r5, n3 = t3(e5[0][0], e5[0][1])[0], i3 = t3(e5[2][0], e5[2][1])[0], a3 = t3(e5[1][0], e5[0][1])[1], o3 = t3(e5[1][0], e5[1][1])[1];
                return a3 > o3 && (r5 = a3, a3 = o3, o3 = r5), [[n3, a3], [i3, o3]];
              });
            }), s2) : e3.map(function(t4) {
              return t4.map(function(t5) {
                return [[t5[0][0] * S, t5[0][1] * S], [t5[1][0] * S, t5[1][1] * S], [t5[2][0] * S, t5[2][1] * S]];
              });
            });
          }, null != e3 && s2.lobes(e3), s2;
        }
        $e.invert = function(t3, e3) {
          return e3 > -Je ? at.invert(t3, e3 - Ke) : ht.invert(t3, e3);
        }, tr.invert = function(t3, e3) {
          return i(e3) > Je ? at.invert(t3, e3 + (e3 > 0 ? Ke : -Ke)) : ht.invert(t3, e3);
        };
        var hr = [[[[-180, 0], [-100, 90], [-40, 0]], [[-40, 0], [30, 90], [180, 0]]], [[[-180, 0], [-160, -90], [-100, 0]], [[-100, 0], [-60, -90], [-20, 0]], [[-20, 0], [20, -90], [80, 0]], [[80, 0], [140, -90], [180, 0]]]];
        function pr() {
          return fr(ut, hr).scale(160.857);
        }
        var dr = [[[[-180, 0], [-100, 90], [-40, 0]], [[-40, 0], [30, 90], [180, 0]]], [[[-180, 0], [-160, -90], [-100, 0]], [[-100, 0], [-60, -90], [-20, 0]], [[-20, 0], [20, -90], [80, 0]], [[80, 0], [140, -90], [180, 0]]]];
        function vr() {
          return fr(tr, dr).scale(152.63);
        }
        var gr = [[[[-180, 0], [-100, 90], [-40, 0]], [[-40, 0], [30, 90], [180, 0]]], [[[-180, 0], [-160, -90], [-100, 0]], [[-100, 0], [-60, -90], [-20, 0]], [[-20, 0], [20, -90], [80, 0]], [[80, 0], [140, -90], [180, 0]]]];
        function yr() {
          return fr(at, gr).scale(169.529);
        }
        var mr = [[[[-180, 0], [-90, 90], [0, 0]], [[0, 0], [90, 90], [180, 0]]], [[[-180, 0], [-90, -90], [0, 0]], [[0, 0], [90, -90], [180, 0]]]];
        function xr() {
          return fr(at, mr).scale(169.529).rotate([20, 0]);
        }
        var br = [[[[-180, 35], [-30, 90], [0, 35]], [[0, 35], [30, 90], [180, 35]]], [[[-180, -10], [-102, -90], [-65, -10]], [[-65, -10], [5, -90], [77, -10]], [[77, -10], [103, -90], [180, -10]]]];
        function _r() {
          return fr($e, br, tt).rotate([-20, -55]).scale(164.263).center([0, -5.4036]);
        }
        var wr = [[[[-180, 0], [-110, 90], [-40, 0]], [[-40, 0], [0, 90], [40, 0]], [[40, 0], [110, 90], [180, 0]]], [[[-180, 0], [-110, -90], [-40, 0]], [[-40, 0], [0, -90], [40, 0]], [[40, 0], [110, -90], [180, 0]]]];
        function Tr() {
          return fr(ht, wr).scale(152.63).rotate([-20, 0]);
        }
        function kr(t3, e3) {
          return [3 / M * t3 * P(b * b / 3 - e3 * e3), e3];
        }
        function Ar() {
          return (0, n2.Z)(kr).scale(158.837);
        }
        function Mr(t3) {
          function e3(e4, r3) {
            if (i(i(r3) - _) < m2)
              return [0, r3 < 0 ? -2 : 2];
            var n3 = g2(r3), a2 = p2((1 + n3) / (1 - n3), t3 / 2), o2 = 0.5 * (a2 + 1 / a2) + s(e4 *= t3);
            return [2 * g2(e4) / o2, (a2 - 1 / a2) / o2];
          }
          return e3.invert = function(e4, r3) {
            var n3 = i(r3);
            if (i(n3 - 2) < m2)
              return e4 ? null : [0, v(r3) * _];
            if (n3 > 2)
              return null;
            var a2 = (e4 /= 2) * e4, s2 = (r3 /= 2) * r3, l2 = 2 * r3 / (1 + a2 + s2);
            return l2 = p2((1 + l2) / (1 - l2), 1 / t3), [o(2 * e4, 1 - a2 - s2) / t3, L((l2 - 1) / (l2 + 1))];
          }, e3;
        }
        function Sr() {
          var t3 = 0.5, e3 = (0, n2.r)(Mr), r3 = e3(t3);
          return r3.spacing = function(r4) {
            return arguments.length ? e3(t3 = +r4) : t3;
          }, r3.scale(124.75);
        }
        kr.invert = function(t3, e3) {
          return [M / 3 * t3 / P(b * b / 3 - e3 * e3), e3];
        };
        var Er = b / k;
        function Lr(t3, e3) {
          return [t3 * (1 + P(s(e3))) / 2, e3 / (s(e3 / 2) * s(t3 / 6))];
        }
        function Cr() {
          return (0, n2.Z)(Lr).scale(97.2672);
        }
        function Pr(t3, e3) {
          var r3 = t3 * t3, n3 = e3 * e3;
          return [t3 * (0.975534 + n3 * (-0.0143059 * r3 - 0.119161 + -0.0547009 * n3)), e3 * (1.00384 + r3 * (0.0802894 + -0.02855 * n3 + 199025e-9 * r3) + n3 * (0.0998909 + -0.0491032 * n3))];
        }
        function Or() {
          return (0, n2.Z)(Pr).scale(139.98);
        }
        function Ir(t3, e3) {
          return [g2(t3) / s(e3), y(e3) * s(t3)];
        }
        function Dr() {
          return (0, n2.Z)(Ir).scale(144.049).clipAngle(89.999);
        }
        function zr(t3) {
          var e3 = s(t3), r3 = y(w2 + t3 / 2);
          function n3(n4, a2) {
            var o2 = a2 - t3, s2 = i(o2) < m2 ? n4 * e3 : i(s2 = w2 + a2 / 2) < m2 || i(i(s2) - _) < m2 ? 0 : n4 * o2 / c(y(s2) / r3);
            return [s2, o2];
          }
          return n3.invert = function(n4, a2) {
            var o2, s2 = a2 + t3;
            return [i(a2) < m2 ? n4 / e3 : i(o2 = w2 + s2 / 2) < m2 || i(i(o2) - _) < m2 ? 0 : n4 * c(y(o2) / r3) / a2, s2];
          }, n3;
        }
        function Rr() {
          return ft(zr).parallel(40).scale(158.837);
        }
        function Fr(t3, e3) {
          return [t3, 1.25 * c(y(w2 + 0.4 * e3))];
        }
        function Br() {
          return (0, n2.Z)(Fr).scale(108.318);
        }
        function Nr(t3) {
          var e3 = t3.length - 1;
          function r3(r4, n3) {
            for (var i2, a2 = s(n3), o2 = 2 / (1 + a2 * s(r4)), l2 = o2 * a2 * g2(r4), u2 = o2 * g2(n3), c2 = e3, f3 = t3[c2], h2 = f3[0], p3 = f3[1]; --c2 >= 0; )
              h2 = (f3 = t3[c2])[0] + l2 * (i2 = h2) - u2 * p3, p3 = f3[1] + l2 * p3 + u2 * i2;
            return [h2 = l2 * (i2 = h2) - u2 * p3, p3 = l2 * p3 + u2 * i2];
          }
          return r3.invert = function(r4, n3) {
            var l2 = 20, u2 = r4, c2 = n3;
            do {
              for (var f3, h2 = e3, p3 = t3[h2], d3 = p3[0], v2 = p3[1], y2 = 0, m3 = 0; --h2 >= 0; )
                y2 = d3 + u2 * (f3 = y2) - c2 * m3, m3 = v2 + u2 * m3 + c2 * f3, d3 = (p3 = t3[h2])[0] + u2 * (f3 = d3) - c2 * v2, v2 = p3[1] + u2 * v2 + c2 * f3;
              var x2, b2, _2 = (y2 = d3 + u2 * (f3 = y2) - c2 * m3) * y2 + (m3 = v2 + u2 * m3 + c2 * f3) * m3;
              u2 -= x2 = ((d3 = u2 * (f3 = d3) - c2 * v2 - r4) * y2 + (v2 = u2 * v2 + c2 * f3 - n3) * m3) / _2, c2 -= b2 = (v2 * y2 - d3 * m3) / _2;
            } while (i(x2) + i(b2) > 1e-12 && --l2 > 0);
            if (l2) {
              var w3 = P(u2 * u2 + c2 * c2), T2 = 2 * a(0.5 * w3), k2 = g2(T2);
              return [o(u2 * k2, w3 * s(T2)), w3 ? L(c2 * k2 / w3) : 0];
            }
          }, r3;
        }
        Lr.invert = function(t3, e3) {
          var r3 = i(t3), n3 = i(e3), a2 = m2, o2 = _;
          n3 < Er ? o2 *= n3 / Er : a2 += 6 * C(Er / n3);
          for (var l2 = 0; l2 < 25; l2++) {
            var u2 = g2(o2), c2 = P(s(o2)), f3 = g2(o2 / 2), h2 = s(o2 / 2), p3 = g2(a2 / 6), d3 = s(a2 / 6), v2 = 0.5 * a2 * (1 + c2) - r3, y2 = o2 / (h2 * d3) - n3, x2 = c2 ? -0.25 * a2 * u2 / c2 : 0, b2 = 0.5 * (1 + c2), w3 = (1 + 0.5 * o2 * f3 / h2) / (h2 * d3), T2 = o2 / h2 * (p3 / 6) / (d3 * d3), k2 = x2 * T2 - w3 * b2, A2 = (v2 * T2 - y2 * b2) / k2, M2 = (y2 * x2 - v2 * w3) / k2;
            if (o2 -= A2, a2 -= M2, i(A2) < m2 && i(M2) < m2)
              break;
          }
          return [t3 < 0 ? -a2 : a2, e3 < 0 ? -o2 : o2];
        }, Pr.invert = function(t3, e3) {
          var r3 = v(t3) * b, n3 = e3 / 2, a2 = 50;
          do {
            var o2 = r3 * r3, s2 = n3 * n3, l2 = r3 * n3, u2 = r3 * (0.975534 + s2 * (-0.0143059 * o2 - 0.119161 + -0.0547009 * s2)) - t3, c2 = n3 * (1.00384 + o2 * (0.0802894 + -0.02855 * s2 + 199025e-9 * o2) + s2 * (0.0998909 + -0.0491032 * s2)) - e3, f3 = 0.975534 - s2 * (0.119161 + 3 * o2 * 0.0143059 + 0.0547009 * s2), h2 = -l2 * (0.238322 + 0.2188036 * s2 + 0.0286118 * o2), p3 = l2 * (0.1605788 + 7961e-7 * o2 + -0.0571 * s2), d3 = 1.00384 + o2 * (0.0802894 + 199025e-9 * o2) + s2 * (3 * (0.0998909 - 0.02855 * o2) - 0.245516 * s2), g3 = h2 * p3 - d3 * f3, y2 = (c2 * h2 - u2 * d3) / g3, x2 = (u2 * p3 - c2 * f3) / g3;
            r3 -= y2, n3 -= x2;
          } while ((i(y2) > m2 || i(x2) > m2) && --a2 > 0);
          return a2 && [r3, n3];
        }, Ir.invert = function(t3, e3) {
          var r3 = t3 * t3, n3 = e3 * e3 + 1, i2 = r3 + n3, a2 = t3 ? T * P((i2 - P(i2 * i2 - 4 * r3)) / r3) : 1 / P(n3);
          return [L(t3 * a2), v(e3) * C(a2)];
        }, Fr.invert = function(t3, e3) {
          return [t3, 2.5 * a(l(0.8 * e3)) - 0.625 * b];
        };
        var jr = [[0.9972523, 0], [52513e-7, -41175e-7], [74606e-7, 48125e-7], [-0.0153783, -0.1968253], [0.0636871, -0.1408027], [0.3660976, -0.2937382]], Ur = [[0.98879, 0], [0, 0], [-0.050909, 0], [0, 0], [0.075528, 0]], Vr = [[0.984299, 0], [0.0211642, 37608e-7], [-0.1036018, -0.0575102], [-0.0329095, -0.0320119], [0.0499471, 0.1223335], [0.026046, 0.0899805], [7388e-7, -0.1435792], [75848e-7, -0.1334108], [-0.0216473, 0.0776645], [-0.0225161, 0.0853673]], Hr = [[0.9245, 0], [0, 0], [0.01943, 0]], qr = [[0.721316, 0], [0, 0], [-881625e-8, -617325e-8]];
        function Gr() {
          return Jr(jr, [152, -64]).scale(1400).center([-160.908, 62.4864]).clipAngle(30).angle(7.8);
        }
        function Zr() {
          return Jr(Ur, [95, -38]).scale(1e3).clipAngle(55).center([-96.5563, 38.8675]);
        }
        function Yr() {
          return Jr(Vr, [120, -45]).scale(359.513).clipAngle(55).center([-117.474, 53.0628]);
        }
        function Wr() {
          return Jr(Hr, [-20, -18]).scale(209.091).center([20, 16.7214]).clipAngle(82);
        }
        function Xr() {
          return Jr(qr, [165, 10]).scale(250).clipAngle(130).center([-165, -10]);
        }
        function Jr(t3, e3) {
          var r3 = (0, n2.Z)(Nr(t3)).rotate(e3).clipAngle(90), i2 = (0, _t.Z)(e3), a2 = r3.center;
          return delete r3.rotate, r3.center = function(t4) {
            return arguments.length ? a2(i2(t4)) : i2.invert(a2());
          }, r3;
        }
        var Kr = P(6), $r = P(7);
        function Qr(t3, e3) {
          var r3 = L(7 * g2(e3) / (3 * Kr));
          return [Kr * t3 * (2 * s(2 * r3 / 3) - 1) / $r, 9 * g2(r3 / 3) / $r];
        }
        function tn() {
          return (0, n2.Z)(Qr).scale(164.859);
        }
        function en(t3, e3) {
          for (var r3, n3 = (1 + T) * g2(e3), a2 = e3, o2 = 0; o2 < 25 && (a2 -= r3 = (g2(a2 / 2) + g2(a2) - n3) / (0.5 * s(a2 / 2) + s(a2)), !(i(r3) < m2)); o2++)
            ;
          return [t3 * (1 + 2 * s(a2) / s(a2 / 2)) / (3 * k), 2 * P(3) * g2(a2 / 2) / P(2 + k)];
        }
        function rn() {
          return (0, n2.Z)(en).scale(188.209);
        }
        function nn(t3, e3) {
          for (var r3, n3 = P(6 / (4 + b)), a2 = (1 + b / 4) * g2(e3), o2 = e3 / 2, l2 = 0; l2 < 25 && (o2 -= r3 = (o2 / 2 + g2(o2) - a2) / (0.5 + s(o2)), !(i(r3) < m2)); l2++)
            ;
          return [n3 * (0.5 + s(o2)) * t3 / 1.5, n3 * o2];
        }
        function an() {
          return (0, n2.Z)(nn).scale(166.518);
        }
        Qr.invert = function(t3, e3) {
          var r3 = 3 * L(e3 * $r / 9);
          return [t3 * $r / (Kr * (2 * s(2 * r3 / 3) - 1)), L(3 * g2(r3) * Kr / 7)];
        }, en.invert = function(t3, e3) {
          var r3 = e3 * P(2 + k) / (2 * P(3)), n3 = 2 * L(r3);
          return [3 * k * t3 / (1 + 2 * s(n3) / s(n3 / 2)), L((r3 + g2(n3)) / (1 + T))];
        }, nn.invert = function(t3, e3) {
          var r3 = P(6 / (4 + b)), n3 = e3 / r3;
          return i(i(n3) - _) < m2 && (n3 = n3 < 0 ? -_ : _), [1.5 * t3 / (r3 * (0.5 + s(n3))), L((n3 / 2 + g2(n3)) / (1 + b / 4))];
        };
        var on = r2(26867);
        function sn(t3, e3) {
          var r3 = e3 * e3, n3 = r3 * r3, i2 = r3 * n3;
          return [t3 * (0.84719 - 0.13063 * r3 + i2 * i2 * (0.05494 * r3 - 0.04515 - 0.02326 * n3 + 331e-5 * i2)), e3 * (1.01183 + n3 * n3 * (0.01926 * r3 - 0.02625 - 396e-5 * n3))];
        }
        function ln() {
          return (0, n2.Z)(sn).scale(175.295);
        }
        function un(t3, e3) {
          return [t3 * (1 + s(e3)) / 2, 2 * (e3 - y(e3 / 2))];
        }
        function cn() {
          return (0, n2.Z)(un).scale(152.63);
        }
        sn.invert = function(t3, e3) {
          var r3, n3, a2, o2, s2 = e3, l2 = 25;
          do {
            s2 -= r3 = (s2 * (1.01183 + (a2 = (n3 = s2 * s2) * n3) * a2 * (0.01926 * n3 - 0.02625 - 396e-5 * a2)) - e3) / (1.01183 + a2 * a2 * (0.21186 * n3 - 0.23625 + -0.05148 * a2));
          } while (i(r3) > x && --l2 > 0);
          return [t3 / (0.84719 - 0.13063 * (n3 = s2 * s2) + (o2 = n3 * (a2 = n3 * n3)) * o2 * (0.05494 * n3 - 0.04515 - 0.02326 * a2 + 331e-5 * o2)), s2];
        }, un.invert = function(t3, e3) {
          for (var r3 = e3 / 2, n3 = 0, a2 = 1 / 0; n3 < 10 && i(a2) > m2; ++n3) {
            var o2 = s(e3 / 2);
            e3 -= a2 = (e3 - y(e3 / 2) - r3) / (1 - 0.5 / (o2 * o2));
          }
          return [2 * t3 / (1 + s(e3)), e3];
        };
        var fn = [[[[-180, 0], [-90, 90], [0, 0]], [[0, 0], [90, 90], [180, 0]]], [[[-180, 0], [-90, -90], [0, 0]], [[0, 0], [90, -90], [180, 0]]]];
        function hn() {
          return fr(J(1 / 0), fn).rotate([20, 0]).scale(152.63);
        }
        function pn(t3, e3) {
          var r3 = g2(e3), n3 = s(e3), a2 = v(t3);
          if (0 === t3 || i(e3) === _)
            return [0, e3];
          if (0 === e3)
            return [t3, 0];
          if (i(t3) === _)
            return [t3 * n3, _ * r3];
          var o2 = b / (2 * t3) - 2 * t3 / b, l2 = 2 * e3 / b, u2 = (1 - l2 * l2) / (r3 - l2), c2 = o2 * o2, f3 = u2 * u2, h2 = 1 + c2 / f3, p3 = 1 + f3 / c2, d3 = (o2 * r3 / u2 - o2 / 2) / h2, y2 = (f3 * r3 / c2 + u2 / 2) / p3, m3 = y2 * y2 - (f3 * r3 * r3 / c2 + u2 * r3 - 1) / p3;
          return [_ * (d3 + P(d3 * d3 + n3 * n3 / h2) * a2), _ * (y2 + P(m3 < 0 ? 0 : m3) * v(-e3 * o2) * a2)];
        }
        function dn() {
          return (0, n2.Z)(pn).scale(127.267);
        }
        pn.invert = function(t3, e3) {
          var r3 = (t3 /= _) * t3, n3 = r3 + (e3 /= _) * e3, i2 = b * b;
          return [t3 ? (n3 - 1 + P((1 - n3) * (1 - n3) + 4 * r3)) / (2 * t3) * _ : 0, Q(function(t4) {
            return n3 * (b * g2(t4) - 2 * t4) * b + 4 * t4 * t4 * (e3 - g2(t4)) + 2 * b * t4 - i2 * e3;
          }, 0)];
        };
        var vn = 1.0148, gn = 0.23185, yn = -0.14499, mn = 0.02406, xn = 1.790857183;
        function bn(t3, e3) {
          var r3 = e3 * e3;
          return [t3, e3 * (vn + r3 * r3 * (gn + r3 * (yn + mn * r3)))];
        }
        function _n() {
          return (0, n2.Z)(bn).scale(139.319);
        }
        function wn(t3, e3) {
          if (i(e3) < m2)
            return [t3, 0];
          var r3 = y(e3), n3 = t3 * g2(e3);
          return [g2(n3) / r3, e3 + (1 - s(n3)) / r3];
        }
        function Tn() {
          return (0, n2.Z)(wn).scale(103.74);
        }
        bn.invert = function(t3, e3) {
          e3 > xn ? e3 = xn : e3 < -1.790857183 && (e3 = -1.790857183);
          var r3, n3 = e3;
          do {
            var a2 = n3 * n3;
            n3 -= r3 = (n3 * (vn + a2 * a2 * (gn + a2 * (yn + mn * a2))) - e3) / (1.0148 + a2 * a2 * (1.1592500000000001 + a2 * (0.21654 * a2 - 1.01493)));
          } while (i(r3) > m2);
          return [t3, n3];
        }, wn.invert = function(t3, e3) {
          if (i(e3) < m2)
            return [t3, 0];
          var r3, n3 = t3 * t3 + e3 * e3, a2 = 0.5 * e3, o2 = 10;
          do {
            var l2 = y(a2), u2 = 1 / s(a2), c2 = n3 - 2 * e3 * a2 + a2 * a2;
            a2 -= r3 = (l2 * c2 + 2 * (a2 - e3)) / (2 + c2 * u2 * u2 + 2 * (a2 - e3) * l2);
          } while (i(r3) > m2 && --o2 > 0);
          return l2 = y(a2), [(i(e3) < i(a2 + 1 / l2) ? L(t3 * l2) : v(e3) * v(t3) * (C(i(t3 * l2)) + _)) / g2(a2), a2];
        };
        var kn = r2(77338), An = r2(83074);
        function Mn(t3, e3) {
          return [t3[0] * e3[0] + t3[1] * e3[3], t3[0] * e3[1] + t3[1] * e3[4], t3[0] * e3[2] + t3[1] * e3[5] + t3[2], t3[3] * e3[0] + t3[4] * e3[3], t3[3] * e3[1] + t3[4] * e3[4], t3[3] * e3[2] + t3[4] * e3[5] + t3[5]];
        }
        function Sn(t3, e3) {
          return [t3[0] - e3[0], t3[1] - e3[1]];
        }
        function En(t3) {
          return P(t3[0] * t3[0] + t3[1] * t3[1]);
        }
        function Ln(t3, e3, r3) {
          function i2(t4, r4) {
            var n3, i3 = e3(t4, r4), a3 = i3.project([t4 * S, r4 * S]);
            return (n3 = i3.transform) ? [n3[0] * a3[0] + n3[1] * a3[1] + n3[2], -(n3[3] * a3[0] + n3[4] * a3[1] + n3[5])] : (a3[1] = -a3[1], a3);
          }
          function a2(t4, r4) {
            var n3 = t4.project.invert, i3 = t4.transform, o2 = r4;
            if (i3 && (i3 = function(t5) {
              var e4 = 1 / (t5[0] * t5[4] - t5[1] * t5[3]);
              return [e4 * t5[4], -e4 * t5[1], e4 * (t5[1] * t5[5] - t5[2] * t5[4]), -e4 * t5[3], e4 * t5[0], e4 * (t5[2] * t5[3] - t5[0] * t5[5])];
            }(i3), o2 = [i3[0] * o2[0] + i3[1] * o2[1] + i3[2], i3[3] * o2[0] + i3[4] * o2[1] + i3[5]]), n3 && t4 === function(t5) {
              return e3(t5[0] * E, t5[1] * E);
            }(s2 = n3(o2)))
              return s2;
            for (var s2, l3 = t4.children, u3 = 0, c2 = l3 && l3.length; u3 < c2; ++u3)
              if (s2 = a2(l3[u3], r4))
                return s2;
          }
          !function t4(e4, r4) {
            if (e4.edges = function(t5) {
              for (var e5 = t5.length, r5 = [], n4 = t5[e5 - 1], i4 = 0; i4 < e5; ++i4)
                r5.push([n4, n4 = t5[i4]]);
              return r5;
            }(e4.face), r4.face) {
              var n3 = e4.shared = function(t5, e5) {
                for (var r5, n4, i4 = t5.length, a4 = null, o2 = 0; o2 < i4; ++o2) {
                  r5 = t5[o2];
                  for (var s2 = e5.length; --s2 >= 0; )
                    if (n4 = e5[s2], r5[0] === n4[0] && r5[1] === n4[1]) {
                      if (a4)
                        return [a4, r5];
                      a4 = r5;
                    }
                }
              }(e4.face, r4.face), i3 = (c2 = n3.map(r4.project), f3 = n3.map(e4.project), h2 = Sn(c2[1], c2[0]), p3 = Sn(f3[1], f3[0]), d3 = function(t5, e5) {
                return o(t5[0] * e5[1] - t5[1] * e5[0], t5[0] * e5[0] + t5[1] * e5[1]);
              }(h2, p3), v2 = En(h2) / En(p3), Mn([1, 0, c2[0][0], 0, 1, c2[0][1]], Mn([v2, 0, 0, 0, v2, 0], Mn([s(d3), g2(d3), 0, -g2(d3), s(d3), 0], [1, 0, -f3[0][0], 0, 1, -f3[0][1]]))));
              e4.transform = r4.transform ? Mn(r4.transform, i3) : i3;
              for (var a3 = r4.edges, l3 = 0, u3 = a3.length; l3 < u3; ++l3)
                Pn(n3[0], a3[l3][1]) && Pn(n3[1], a3[l3][0]) && (a3[l3] = e4), Pn(n3[0], a3[l3][0]) && Pn(n3[1], a3[l3][1]) && (a3[l3] = e4);
              for (l3 = 0, u3 = (a3 = e4.edges).length; l3 < u3; ++l3)
                Pn(n3[0], a3[l3][0]) && Pn(n3[1], a3[l3][1]) && (a3[l3] = r4), Pn(n3[0], a3[l3][1]) && Pn(n3[1], a3[l3][0]) && (a3[l3] = r4);
            } else
              e4.transform = r4.transform;
            var c2, f3, h2, p3, d3, v2;
            return e4.children && e4.children.forEach(function(r5) {
              t4(r5, e4);
            }), e4;
          }(t3, { transform: null }), On(t3) && (i2.invert = function(e4, r4) {
            var n3 = a2(t3, [e4, -r4]);
            return n3 && (n3[0] *= E, n3[1] *= E, n3);
          });
          var l2 = (0, n2.Z)(i2), u2 = l2.stream;
          return l2.stream = function(e4) {
            var r4 = l2.rotate(), n3 = u2(e4), i3 = (l2.rotate([0, 0]), u2(e4));
            return l2.rotate(r4), n3.sphere = function() {
              i3.polygonStart(), i3.lineStart(), Cn(i3, t3), i3.lineEnd(), i3.polygonEnd();
            }, n3;
          }, l2.angle(null == r3 ? -30 : r3 * S);
        }
        function Cn(t3, e3, r3) {
          var n3, a2, o2 = e3.edges, s2 = o2.length, l2 = { type: "MultiPoint", coordinates: e3.face }, u2 = e3.face.filter(function(t4) {
            return 90 !== i(t4[1]);
          }), c2 = (0, kn.Z)({ type: "MultiPoint", coordinates: u2 }), f3 = false, h2 = -1, p3 = c2[1][0] - c2[0][0], d3 = 180 === p3 || 360 === p3 ? [(c2[0][0] + c2[1][0]) / 2, (c2[0][1] + c2[1][1]) / 2] : (0, bt.Z)(l2);
          if (r3)
            for (; ++h2 < s2 && o2[h2] !== r3; )
              ;
          ++h2;
          for (var v2 = 0; v2 < s2; ++v2)
            a2 = o2[(v2 + h2) % s2], Array.isArray(a2) ? (f3 || (t3.point((n3 = (0, An.Z)(a2[0], d3)(m2))[0], n3[1]), f3 = true), t3.point((n3 = (0, An.Z)(a2[1], d3)(m2))[0], n3[1])) : (f3 = false, a2 !== r3 && Cn(t3, a2, e3));
        }
        function Pn(t3, e3) {
          return t3 && e3 && t3[0] === e3[0] && t3[1] === e3[1];
        }
        function On(t3) {
          return t3.project.invert || t3.children && t3.children.some(On);
        }
        var In = r2(98936), Dn = [[0, 90], [-90, 0], [0, 0], [90, 0], [180, 0], [0, -90]], zn = [[0, 2, 1], [0, 3, 2], [5, 1, 2], [5, 2, 3], [0, 1, 4], [0, 4, 3], [5, 4, 1], [5, 3, 4]].map(function(t3) {
          return t3.map(function(t4) {
            return Dn[t4];
          });
        });
        function Rn(t3) {
          t3 = t3 || function(t4) {
            var e4 = (0, bt.Z)({ type: "MultiPoint", coordinates: t4 });
            return (0, In.Z)().scale(1).translate([0, 0]).rotate([-e4[0], -e4[1]]);
          };
          var e3 = zn.map(function(e4) {
            return { face: e4, project: t3(e4) };
          });
          return [-1, 0, 0, 1, 0, 1, 4, 5].forEach(function(t4, r3) {
            var n3 = e3[t4];
            n3 && (n3.children || (n3.children = [])).push(e3[r3]);
          }), Ln(e3[0], function(t4, r3) {
            return e3[t4 < -b / 2 ? r3 < 0 ? 6 : 4 : t4 < 0 ? r3 < 0 ? 2 : 0 : t4 < b / 2 ? r3 < 0 ? 3 : 1 : r3 < 0 ? 7 : 5];
          }).angle(-30).scale(101.858).center([0, 45]);
        }
        var Fn = 2 / P(3);
        function Bn(t3, e3) {
          var r3 = Lt(t3, e3);
          return [r3[0] * Fn, r3[1]];
        }
        function Nn(t3) {
          t3 = t3 || function(t4) {
            var e4 = (0, bt.Z)({ type: "MultiPoint", coordinates: t4 });
            return (0, n2.Z)(Bn).translate([0, 0]).scale(1).rotate(e4[1] > 0 ? [-e4[0], 0] : [180 - e4[0], 180]);
          };
          var e3 = zn.map(function(e4) {
            return { face: e4, project: t3(e4) };
          });
          return [-1, 0, 0, 1, 0, 1, 4, 5].forEach(function(t4, r3) {
            var n3 = e3[t4];
            n3 && (n3.children || (n3.children = [])).push(e3[r3]);
          }), Ln(e3[0], function(t4, r3) {
            return e3[t4 < -b / 2 ? r3 < 0 ? 6 : 4 : t4 < 0 ? r3 < 0 ? 2 : 0 : t4 < b / 2 ? r3 < 0 ? 3 : 1 : r3 < 0 ? 7 : 5];
          }).angle(-30).scale(121.906).center([0, 48.5904]);
        }
        function jn(t3) {
          t3 = t3 || function(t4) {
            var e4 = 6 === t4.length ? (0, bt.Z)({ type: "MultiPoint", coordinates: t4 }) : t4[0];
            return (0, In.Z)().scale(1).translate([0, 0]).rotate([-e4[0], -e4[1]]);
          };
          var e3 = zn.map(function(t4) {
            for (var e4, r4 = t4.map(Hn), n4 = r4.length, i3 = r4[n4 - 1], a2 = [], o2 = 0; o2 < n4; ++o2)
              e4 = r4[o2], a2.push(Vn([0.9486832980505138 * i3[0] + 0.31622776601683794 * e4[0], 0.9486832980505138 * i3[1] + 0.31622776601683794 * e4[1], 0.9486832980505138 * i3[2] + 0.31622776601683794 * e4[2]]), Vn([0.9486832980505138 * e4[0] + 0.31622776601683794 * i3[0], 0.9486832980505138 * e4[1] + 0.31622776601683794 * i3[1], 0.9486832980505138 * e4[2] + 0.31622776601683794 * i3[2]])), i3 = e4;
            return a2;
          }), r3 = [], n3 = [-1, 0, 0, 1, 0, 1, 4, 5];
          e3.forEach(function(t4, i3) {
            for (var a2, o2, s2 = zn[i3], l2 = s2.length, u2 = r3[i3] = [], c2 = 0; c2 < l2; ++c2)
              e3.push([s2[c2], t4[(2 * c2 + 2) % (2 * l2)], t4[(2 * c2 + 1) % (2 * l2)]]), n3.push(i3), u2.push((a2 = Hn(t4[(2 * c2 + 2) % (2 * l2)]), o2 = Hn(t4[(2 * c2 + 1) % (2 * l2)]), [a2[1] * o2[2] - a2[2] * o2[1], a2[2] * o2[0] - a2[0] * o2[2], a2[0] * o2[1] - a2[1] * o2[0]]));
          });
          var i2 = e3.map(function(e4) {
            return { project: t3(e4), face: e4 };
          });
          return n3.forEach(function(t4, e4) {
            var r4 = i2[t4];
            r4 && (r4.children || (r4.children = [])).push(i2[e4]);
          }), Ln(i2[0], function(t4, e4) {
            var n4 = s(e4), a2 = [n4 * s(t4), n4 * g2(t4), g2(e4)], o2 = t4 < -b / 2 ? e4 < 0 ? 6 : 4 : t4 < 0 ? e4 < 0 ? 2 : 0 : t4 < b / 2 ? e4 < 0 ? 3 : 1 : e4 < 0 ? 7 : 5, l2 = r3[o2];
            return i2[Un(l2[0], a2) < 0 ? 8 + 3 * o2 : Un(l2[1], a2) < 0 ? 8 + 3 * o2 + 1 : Un(l2[2], a2) < 0 ? 8 + 3 * o2 + 2 : o2];
          }).angle(-30).scale(110.625).center([0, 45]);
        }
        function Un(t3, e3) {
          for (var r3 = 0, n3 = t3.length, i2 = 0; r3 < n3; ++r3)
            i2 += t3[r3] * e3[r3];
          return i2;
        }
        function Vn(t3) {
          return [o(t3[1], t3[0]) * S, L(f2(-1, h(1, t3[2]))) * S];
        }
        function Hn(t3) {
          var e3 = t3[0] * E, r3 = t3[1] * E, n3 = s(r3);
          return [n3 * s(e3), n3 * g2(e3), g2(r3)];
        }
        function qn() {
        }
        function Gn(t3, e3) {
          var r3, n3 = e3.stream;
          if (!n3)
            throw new Error("invalid projection");
          switch (t3 && t3.type) {
            case "Feature":
              r3 = Yn;
              break;
            case "FeatureCollection":
              r3 = Zn;
              break;
            default:
              r3 = Wn;
          }
          return r3(t3, n3);
        }
        function Zn(t3, e3) {
          return { type: "FeatureCollection", features: t3.features.map(function(t4) {
            return Yn(t4, e3);
          }) };
        }
        function Yn(t3, e3) {
          return { type: "Feature", id: t3.id, properties: t3.properties, geometry: Wn(t3.geometry, e3) };
        }
        function Wn(t3, e3) {
          if (!t3)
            return null;
          if ("GeometryCollection" === t3.type)
            return function(t4, e4) {
              return { type: "GeometryCollection", geometries: t4.geometries.map(function(t5) {
                return Wn(t5, e4);
              }) };
            }(t3, e3);
          var r3;
          switch (t3.type) {
            case "Point":
            case "MultiPoint":
              r3 = Kn;
              break;
            case "LineString":
            case "MultiLineString":
              r3 = $n;
              break;
            case "Polygon":
            case "MultiPolygon":
            case "Sphere":
              r3 = Qn;
              break;
            default:
              return null;
          }
          return (0, je.Z)(t3, e3(r3)), r3.result();
        }
        Bn.invert = function(t3, e3) {
          return Lt.invert(t3 / Fn, e3);
        };
        var Xn = [], Jn = [], Kn = { point: function(t3, e3) {
          Xn.push([t3, e3]);
        }, result: function() {
          var t3 = Xn.length ? Xn.length < 2 ? { type: "Point", coordinates: Xn[0] } : { type: "MultiPoint", coordinates: Xn } : null;
          return Xn = [], t3;
        } }, $n = { lineStart: qn, point: function(t3, e3) {
          Xn.push([t3, e3]);
        }, lineEnd: function() {
          Xn.length && (Jn.push(Xn), Xn = []);
        }, result: function() {
          var t3 = Jn.length ? Jn.length < 2 ? { type: "LineString", coordinates: Jn[0] } : { type: "MultiLineString", coordinates: Jn } : null;
          return Jn = [], t3;
        } }, Qn = { polygonStart: qn, lineStart: qn, point: function(t3, e3) {
          Xn.push([t3, e3]);
        }, lineEnd: function() {
          var t3 = Xn.length;
          if (t3) {
            do {
              Xn.push(Xn[0].slice());
            } while (++t3 < 4);
            Jn.push(Xn), Xn = [];
          }
        }, polygonEnd: qn, result: function() {
          if (!Jn.length)
            return null;
          var t3 = [], e3 = [];
          return Jn.forEach(function(r3) {
            !function(t4) {
              if ((e4 = t4.length) < 4)
                return false;
              for (var e4, r4 = 0, n3 = t4[e4 - 1][1] * t4[0][0] - t4[e4 - 1][0] * t4[0][1]; ++r4 < e4; )
                n3 += t4[r4 - 1][1] * t4[r4][0] - t4[r4 - 1][0] * t4[r4][1];
              return n3 <= 0;
            }(r3) ? e3.push(r3) : t3.push([r3]);
          }), e3.forEach(function(e4) {
            var r3 = e4[0];
            t3.some(function(t4) {
              if (function(t5, e5) {
                for (var r4 = e5[0], n3 = e5[1], i2 = false, a2 = 0, o2 = t5.length, s2 = o2 - 1; a2 < o2; s2 = a2++) {
                  var l2 = t5[a2], u2 = l2[0], c2 = l2[1], f3 = t5[s2], h2 = f3[0], p3 = f3[1];
                  c2 > n3 ^ p3 > n3 && r4 < (h2 - u2) * (n3 - c2) / (p3 - c2) + u2 && (i2 = !i2);
                }
                return i2;
              }(t4[0], r3))
                return t4.push(e4), true;
            }) || t3.push([e4]);
          }), Jn = [], t3.length ? t3.length > 1 ? { type: "MultiPolygon", coordinates: t3 } : { type: "Polygon", coordinates: t3[0] } : null;
        } };
        function ti(t3) {
          var e3 = t3(_, 0)[0] - t3(-_, 0)[0];
          function r3(r4, n3) {
            var a2 = i(r4) < _, o2 = t3(a2 ? r4 : r4 > 0 ? r4 - b : r4 + b, n3), s2 = (o2[0] - o2[1]) * T, l2 = (o2[0] + o2[1]) * T;
            if (a2)
              return [s2, l2];
            var u2 = e3 * T, c2 = s2 > 0 ^ l2 > 0 ? -1 : 1;
            return [c2 * s2 - v(l2) * u2, c2 * l2 - v(s2) * u2];
          }
          return t3.invert && (r3.invert = function(r4, n3) {
            var a2 = (r4 + n3) * T, o2 = (n3 - r4) * T, s2 = i(a2) < 0.5 * e3 && i(o2) < 0.5 * e3;
            if (!s2) {
              var l2 = e3 * T, u2 = a2 > 0 ^ o2 > 0 ? -1 : 1, c2 = -u2 * r4 + (o2 > 0 ? 1 : -1) * l2, f3 = -u2 * n3 + (a2 > 0 ? 1 : -1) * l2;
              a2 = (-c2 - f3) * T, o2 = (c2 - f3) * T;
            }
            var h2 = t3.invert(a2, o2);
            return s2 || (h2[0] += a2 > 0 ? b : -b), h2;
          }), (0, n2.Z)(r3).rotate([-90, -90, 45]).clipAngle(179.999);
        }
        function ei() {
          return ti(Le).scale(176.423);
        }
        function ri() {
          return ti(Ie).scale(111.48);
        }
        function ni(t3, e3) {
          if (!(0 <= (e3 = +e3) && e3 <= 20))
            throw new Error("invalid digits");
          function r3(t4) {
            var r4 = t4.length, n4 = 2, i3 = new Array(r4);
            for (i3[0] = +t4[0].toFixed(e3), i3[1] = +t4[1].toFixed(e3); n4 < r4; )
              i3[n4] = t4[n4], ++n4;
            return i3;
          }
          function n3(t4) {
            return t4.map(r3);
          }
          function i2(t4) {
            for (var e4 = r3(t4[0]), n4 = [e4], i3 = 1; i3 < t4.length; i3++) {
              var a3 = r3(t4[i3]);
              (a3.length > 2 || a3[0] != e4[0] || a3[1] != e4[1]) && (n4.push(a3), e4 = a3);
            }
            return 1 === n4.length && t4.length > 1 && n4.push(r3(t4[t4.length - 1])), n4;
          }
          function a2(t4) {
            return t4.map(i2);
          }
          function o2(t4) {
            if (null == t4)
              return t4;
            var e4;
            switch (t4.type) {
              case "GeometryCollection":
                e4 = { type: "GeometryCollection", geometries: t4.geometries.map(o2) };
                break;
              case "Point":
                e4 = { type: "Point", coordinates: r3(t4.coordinates) };
                break;
              case "MultiPoint":
                e4 = { type: t4.type, coordinates: n3(t4.coordinates) };
                break;
              case "LineString":
                e4 = { type: t4.type, coordinates: i2(t4.coordinates) };
                break;
              case "MultiLineString":
              case "Polygon":
                e4 = { type: t4.type, coordinates: a2(t4.coordinates) };
                break;
              case "MultiPolygon":
                e4 = { type: "MultiPolygon", coordinates: t4.coordinates.map(a2) };
                break;
              default:
                return t4;
            }
            return null != t4.bbox && (e4.bbox = t4.bbox), e4;
          }
          function s2(t4) {
            var e4 = { type: "Feature", properties: t4.properties, geometry: o2(t4.geometry) };
            return null != t4.id && (e4.id = t4.id), null != t4.bbox && (e4.bbox = t4.bbox), e4;
          }
          if (null != t3)
            switch (t3.type) {
              case "Feature":
                return s2(t3);
              case "FeatureCollection":
                var l2 = { type: "FeatureCollection", features: t3.features.map(s2) };
                return null != t3.bbox && (l2.bbox = t3.bbox), l2;
              default:
                return o2(t3);
            }
          return t3;
        }
        function ii(t3) {
          var e3 = g2(t3);
          function r3(r4, n3) {
            var i2 = e3 ? y(r4 * e3 / 2) / e3 : r4 / 2;
            if (!n3)
              return [2 * i2, -t3];
            var o2 = 2 * a(i2 * g2(n3)), l2 = 1 / y(n3);
            return [g2(o2) * l2, n3 + (1 - s(o2)) * l2 - t3];
          }
          return r3.invert = function(r4, n3) {
            if (i(n3 += t3) < m2)
              return [e3 ? 2 * a(e3 * r4 / 2) / e3 : r4, 0];
            var o2, l2 = r4 * r4 + n3 * n3, u2 = 0, c2 = 10;
            do {
              var f3 = y(u2), h2 = 1 / s(u2), p3 = l2 - 2 * n3 * u2 + u2 * u2;
              u2 -= o2 = (f3 * p3 + 2 * (u2 - n3)) / (2 + p3 * h2 * h2 + 2 * (u2 - n3) * f3);
            } while (i(o2) > m2 && --c2 > 0);
            var d3 = r4 * (f3 = y(u2)), v2 = y(i(n3) < i(u2 + 1 / f3) ? 0.5 * L(d3) : 0.5 * C(d3) + b / 4) / g2(u2);
            return [e3 ? 2 * a(e3 * v2) / e3 : 2 * v2, u2];
          }, r3;
        }
        function ai() {
          return ft(ii).scale(131.215);
        }
        var oi = [[0.9986, -0.062], [1, 0], [0.9986, 0.062], [0.9954, 0.124], [0.99, 0.186], [0.9822, 0.248], [0.973, 0.31], [0.96, 0.372], [0.9427, 0.434], [0.9216, 0.4958], [0.8962, 0.5571], [0.8679, 0.6176], [0.835, 0.6769], [0.7986, 0.7346], [0.7597, 0.7903], [0.7186, 0.8435], [0.6732, 0.8936], [0.6213, 0.9394], [0.5722, 0.9761], [0.5322, 1]];
        function si(t3, e3) {
          var r3, n3 = h(18, 36 * i(e3) / b), a2 = u(n3), o2 = n3 - a2, s2 = (r3 = oi[a2])[0], l2 = r3[1], c2 = (r3 = oi[++a2])[0], f3 = r3[1], p3 = (r3 = oi[h(19, ++a2)])[0], d3 = r3[1];
          return [t3 * (c2 + o2 * (p3 - s2) / 2 + o2 * o2 * (p3 - 2 * c2 + s2) / 2), (e3 > 0 ? _ : -_) * (f3 + o2 * (d3 - l2) / 2 + o2 * o2 * (d3 - 2 * f3 + l2) / 2)];
        }
        function li() {
          return (0, n2.Z)(si).scale(152.63);
        }
        function ui(t3, e3) {
          var r3 = function(t4) {
            function e4(e5, r4) {
              var n4 = s(r4), i3 = (t4 - 1) / (t4 - n4 * s(e5));
              return [i3 * n4 * g2(e5), i3 * g2(r4)];
            }
            return e4.invert = function(e5, r4) {
              var n4 = e5 * e5 + r4 * r4, i3 = P(n4), a3 = (t4 - P(1 - n4 * (t4 + 1) / (t4 - 1))) / ((t4 - 1) / i3 + i3 / (t4 - 1));
              return [o(e5 * a3, i3 * P(1 - a3 * a3)), i3 ? L(r4 * a3 / i3) : 0];
            }, e4;
          }(t3);
          if (!e3)
            return r3;
          var n3 = s(e3), i2 = g2(e3);
          function a2(e4, a3) {
            var o2 = r3(e4, a3), s2 = o2[1], l2 = s2 * i2 / (t3 - 1) + n3;
            return [o2[0] * n3 / l2, s2 / l2];
          }
          return a2.invert = function(e4, a3) {
            var o2 = (t3 - 1) / (t3 - 1 - a3 * i2);
            return r3.invert(o2 * e4, o2 * a3 * n3);
          }, a2;
        }
        function ci() {
          var t3 = 2, e3 = 0, r3 = (0, n2.r)(ui), i2 = r3(t3, e3);
          return i2.distance = function(n3) {
            return arguments.length ? r3(t3 = +n3, e3) : t3;
          }, i2.tilt = function(n3) {
            return arguments.length ? r3(t3, e3 = n3 * E) : e3 * S;
          }, i2.scale(432.147).clipAngle(C(1 / t3) * S - 1e-6);
        }
        oi.forEach(function(t3) {
          t3[1] *= 1.0144;
        }), si.invert = function(t3, e3) {
          var r3 = e3 / _, n3 = 90 * r3, a2 = h(18, i(n3 / 5)), o2 = f2(0, u(a2));
          do {
            var s2 = oi[o2][1], l2 = oi[o2 + 1][1], c2 = oi[h(19, o2 + 2)][1], p3 = c2 - s2, d3 = c2 - 2 * l2 + s2, v2 = 2 * (i(r3) - l2) / p3, g3 = d3 / p3, y2 = v2 * (1 - g3 * v2 * (1 - 2 * g3 * v2));
            if (y2 >= 0 || 1 === o2) {
              n3 = (e3 >= 0 ? 5 : -5) * (y2 + a2);
              var m3, b2 = 50;
              do {
                y2 = (a2 = h(18, i(n3) / 5)) - (o2 = u(a2)), s2 = oi[o2][1], l2 = oi[o2 + 1][1], c2 = oi[h(19, o2 + 2)][1], n3 -= (m3 = (e3 >= 0 ? _ : -_) * (l2 + y2 * (c2 - s2) / 2 + y2 * y2 * (c2 - 2 * l2 + s2) / 2) - e3) * S;
              } while (i(m3) > x && --b2 > 0);
              break;
            }
          } while (--o2 >= 0);
          var w3 = oi[o2][0], T2 = oi[o2 + 1][0], k2 = oi[h(19, o2 + 2)][0];
          return [t3 / (T2 + y2 * (k2 - w3) / 2 + y2 * y2 * (k2 - 2 * T2 + w3) / 2), n3 * E];
        };
        var fi = -179.9999, hi = 179.9999, pi = -89.9999, di = 89.9999;
        function vi(t3) {
          return t3.length > 0;
        }
        function gi(t3) {
          return -90 === t3 || 90 === t3 ? [0, t3] : [-180, (e3 = t3, Math.floor(1e4 * e3) / 1e4)];
          var e3;
        }
        function yi(t3) {
          var e3 = t3[0], r3 = t3[1], n3 = false;
          return e3 <= fi ? (e3 = -180, n3 = true) : e3 >= hi && (e3 = 180, n3 = true), r3 <= pi ? (r3 = -90, n3 = true) : r3 >= di && (r3 = 90, n3 = true), n3 ? [e3, r3] : t3;
        }
        function mi(t3) {
          return t3.map(yi);
        }
        function xi(t3, e3, r3) {
          for (var n3 = 0, i2 = t3.length; n3 < i2; ++n3) {
            var a2 = t3[n3].slice();
            r3.push({ index: -1, polygon: e3, ring: a2 });
            for (var o2 = 0, s2 = a2.length; o2 < s2; ++o2) {
              var l2 = a2[o2], u2 = l2[0], c2 = l2[1];
              if (u2 <= fi || u2 >= hi || c2 <= pi || c2 >= di) {
                a2[o2] = yi(l2);
                for (var f3 = o2 + 1; f3 < s2; ++f3) {
                  var h2 = a2[f3], p3 = h2[0], d3 = h2[1];
                  if (p3 > fi && p3 < hi && d3 > pi && d3 < di)
                    break;
                }
                if (f3 === o2 + 1)
                  continue;
                if (o2) {
                  var v2 = { index: -1, polygon: e3, ring: a2.slice(0, o2 + 1) };
                  v2.ring[v2.ring.length - 1] = gi(c2), r3[r3.length - 1] = v2;
                } else
                  r3.pop();
                if (f3 >= s2)
                  break;
                r3.push({ index: -1, polygon: e3, ring: a2 = a2.slice(f3 - 1) }), a2[0] = gi(a2[0][1]), o2 = -1, s2 = a2.length;
              }
            }
          }
        }
        function bi(t3) {
          var e3, r3, n3, i2, a2, o2, s2 = t3.length, l2 = {}, u2 = {};
          for (e3 = 0; e3 < s2; ++e3)
            n3 = (r3 = t3[e3]).ring[0], a2 = r3.ring[r3.ring.length - 1], n3[0] !== a2[0] || n3[1] !== a2[1] ? (r3.index = e3, l2[n3] = u2[a2] = r3) : (r3.polygon.push(r3.ring), t3[e3] = null);
          for (e3 = 0; e3 < s2; ++e3)
            if (r3 = t3[e3]) {
              if (n3 = r3.ring[0], a2 = r3.ring[r3.ring.length - 1], i2 = u2[n3], o2 = l2[a2], delete l2[n3], delete u2[a2], n3[0] === a2[0] && n3[1] === a2[1]) {
                r3.polygon.push(r3.ring);
                continue;
              }
              i2 ? (delete u2[n3], delete l2[i2.ring[0]], i2.ring.pop(), t3[i2.index] = null, r3 = { index: -1, polygon: i2.polygon, ring: i2.ring.concat(r3.ring) }, i2 === o2 ? r3.polygon.push(r3.ring) : (r3.index = s2++, t3.push(l2[r3.ring[0]] = u2[r3.ring[r3.ring.length - 1]] = r3))) : o2 ? (delete l2[a2], delete u2[o2.ring[o2.ring.length - 1]], r3.ring.pop(), r3 = { index: s2++, polygon: o2.polygon, ring: r3.ring.concat(o2.ring) }, t3[o2.index] = null, t3.push(l2[r3.ring[0]] = u2[r3.ring[r3.ring.length - 1]] = r3)) : (r3.ring.push(r3.ring[0]), r3.polygon.push(r3.ring));
            }
        }
        function _i(t3) {
          var e3 = { type: "Feature", geometry: wi(t3.geometry) };
          return null != t3.id && (e3.id = t3.id), null != t3.bbox && (e3.bbox = t3.bbox), null != t3.properties && (e3.properties = t3.properties), e3;
        }
        function wi(t3) {
          if (null == t3)
            return t3;
          var e3, r3, n3, i2;
          switch (t3.type) {
            case "GeometryCollection":
              e3 = { type: "GeometryCollection", geometries: t3.geometries.map(wi) };
              break;
            case "Point":
              e3 = { type: "Point", coordinates: yi(t3.coordinates) };
              break;
            case "MultiPoint":
            case "LineString":
              e3 = { type: t3.type, coordinates: mi(t3.coordinates) };
              break;
            case "MultiLineString":
              e3 = { type: "MultiLineString", coordinates: t3.coordinates.map(mi) };
              break;
            case "Polygon":
              var a2 = [];
              xi(t3.coordinates, a2, r3 = []), bi(r3), e3 = { type: "Polygon", coordinates: a2 };
              break;
            case "MultiPolygon":
              r3 = [], n3 = -1, i2 = t3.coordinates.length;
              for (var o2 = new Array(i2); ++n3 < i2; )
                xi(t3.coordinates[n3], o2[n3] = [], r3);
              bi(r3), e3 = { type: "MultiPolygon", coordinates: o2.filter(vi) };
              break;
            default:
              return t3;
          }
          return null != t3.bbox && (e3.bbox = t3.bbox), e3;
        }
        function Ti(t3) {
          if (null == t3)
            return t3;
          switch (t3.type) {
            case "Feature":
              return _i(t3);
            case "FeatureCollection":
              var e3 = { type: "FeatureCollection", features: t3.features.map(_i) };
              return null != t3.bbox && (e3.bbox = t3.bbox), e3;
            default:
              return wi(t3);
          }
        }
        function ki(t3, e3) {
          var r3 = y(e3 / 2), n3 = g2(w2 * r3);
          return [t3 * (0.74482 - 0.34588 * n3 * n3), 1.70711 * r3];
        }
        function Ai() {
          return (0, n2.Z)(ki).scale(146.153);
        }
        function Mi(t3, e3, r3) {
          var i2 = (0, An.Z)(e3, r3), a2 = i2(0.5), o2 = (0, _t.Z)([-a2[0], -a2[1]])(e3), s2 = i2.distance / 2, l2 = -L(g2(o2[1] * E) / g2(s2)), u2 = [-a2[0], -a2[1], -(o2[0] > 0 ? b - l2 : l2) * S], c2 = (0, n2.Z)(t3(s2)).rotate(u2), f3 = (0, _t.Z)(u2), h2 = c2.center;
          return delete c2.rotate, c2.center = function(t4) {
            return arguments.length ? h2(f3(t4)) : f3.invert(h2());
          }, c2.clipAngle(90);
        }
        function Si(t3) {
          var e3 = s(t3);
          function r3(t4, r4) {
            var n3 = (0, In.M)(t4, r4);
            return n3[0] *= e3, n3;
          }
          return r3.invert = function(t4, r4) {
            return In.M.invert(t4 / e3, r4);
          }, r3;
        }
        function Ei() {
          return Li([-158, 21.5], [-77, 39]).clipAngle(60).scale(400);
        }
        function Li(t3, e3) {
          return Mi(Si, t3, e3);
        }
        function Ci(t3) {
          if (!(t3 *= 2))
            return Z.N;
          var e3 = -t3 / 2, r3 = -e3, n3 = t3 * t3, i2 = y(r3), a2 = 0.5 / g2(r3);
          function l2(i3, a3) {
            var o2 = C(s(a3) * s(i3 - e3)), l3 = C(s(a3) * s(i3 - r3));
            return [((o2 *= o2) - (l3 *= l3)) / (2 * t3), (a3 < 0 ? -1 : 1) * P(4 * n3 * l3 - (n3 - o2 + l3) * (n3 - o2 + l3)) / (2 * t3)];
          }
          return l2.invert = function(t4, n4) {
            var l3, u2, c2 = n4 * n4, f3 = s(P(c2 + (l3 = t4 + e3) * l3)), h2 = s(P(c2 + (l3 = t4 + r3) * l3));
            return [o(u2 = f3 - h2, l3 = (f3 + h2) * i2), (n4 < 0 ? -1 : 1) * C(P(l3 * l3 + u2 * u2) * a2)];
          }, l2;
        }
        function Pi() {
          return Oi([-158, 21.5], [-77, 39]).clipAngle(130).scale(122.571);
        }
        function Oi(t3, e3) {
          return Mi(Ci, t3, e3);
        }
        function Ii(t3, e3) {
          if (i(e3) < m2)
            return [t3, 0];
          var r3 = i(e3 / _), n3 = L(r3);
          if (i(t3) < m2 || i(i(e3) - _) < m2)
            return [0, v(e3) * b * y(n3 / 2)];
          var a2 = s(n3), o2 = i(b / t3 - t3 / b) / 2, l2 = o2 * o2, u2 = a2 / (r3 + a2 - 1), c2 = u2 * (2 / r3 - 1), f3 = c2 * c2, h2 = f3 + l2, p3 = u2 - f3, d3 = l2 + u2;
          return [v(t3) * b * (o2 * p3 + P(l2 * p3 * p3 - h2 * (u2 * u2 - f3))) / h2, v(e3) * b * (c2 * d3 - o2 * P((l2 + 1) * h2 - d3 * d3)) / h2];
        }
        function Di() {
          return (0, n2.Z)(Ii).scale(79.4183);
        }
        function zi(t3, e3) {
          if (i(e3) < m2)
            return [t3, 0];
          var r3 = i(e3 / _), n3 = L(r3);
          if (i(t3) < m2 || i(i(e3) - _) < m2)
            return [0, v(e3) * b * y(n3 / 2)];
          var a2 = s(n3), o2 = i(b / t3 - t3 / b) / 2, l2 = o2 * o2, u2 = a2 * (P(1 + l2) - o2 * a2) / (1 + l2 * r3 * r3);
          return [v(t3) * b * u2, v(e3) * b * P(1 - u2 * (2 * o2 + u2))];
        }
        function Ri() {
          return (0, n2.Z)(zi).scale(79.4183);
        }
        function Fi(t3, e3) {
          if (i(e3) < m2)
            return [t3, 0];
          var r3 = e3 / _, n3 = L(r3);
          if (i(t3) < m2 || i(i(e3) - _) < m2)
            return [0, b * y(n3 / 2)];
          var a2 = (b / t3 - t3 / b) / 2, o2 = r3 / (1 + s(n3));
          return [b * (v(t3) * P(a2 * a2 + 1 - o2 * o2) - a2), b * o2];
        }
        function Bi() {
          return (0, n2.Z)(Fi).scale(79.4183);
        }
        function Ni(t3, e3) {
          if (!e3)
            return [t3, 0];
          var r3 = i(e3);
          if (!t3 || r3 === _)
            return [0, e3];
          var n3 = r3 / _, a2 = n3 * n3, o2 = (8 * n3 - a2 * (a2 + 2) - 5) / (2 * a2 * (n3 - 1)), s2 = o2 * o2, l2 = n3 * o2, u2 = a2 + s2 + 2 * l2, c2 = n3 + 3 * o2, f3 = t3 / _, h2 = f3 + 1 / f3, p3 = v(i(t3) - _) * P(h2 * h2 - 4), d3 = p3 * p3, g3 = (p3 * (u2 + s2 - 1) + 2 * P(u2 * (a2 + s2 * d3 - 1) + (1 - a2) * (a2 * (c2 * c2 + 4 * s2) + 12 * l2 * s2 + 4 * s2 * s2))) / (4 * u2 + d3);
          return [v(t3) * _ * g3, v(e3) * _ * P(1 + p3 * i(g3) - g3 * g3)];
        }
        function ji() {
          return (0, n2.Z)(Ni).scale(127.16);
        }
        function Ui(t3, e3, r3, n3) {
          var i2 = b / 3;
          t3 = f2(t3, m2), e3 = f2(e3, m2), t3 = h(t3, _), e3 = h(e3, b - m2), r3 = f2(r3, 0), r3 = h(r3, 99.999999);
          var a2 = (n3 = f2(n3, m2)) / 100, l2 = C((r3 / 100 + 1) * s(i2)) / i2, u2 = g2(t3) / g2(l2 * _), c2 = e3 / b, p3 = P(a2 * g2(t3 / 2) / g2(e3 / 2));
          return function(t4, e4, r4, n4, i3) {
            function a3(a4, o2) {
              var l3 = r4 * g2(n4 * o2), u3 = P(1 - l3 * l3), c3 = P(2 / (1 + u3 * s(a4 *= i3)));
              return [t4 * u3 * c3 * g2(a4), e4 * l3 * c3];
            }
            return a3.invert = function(a4, s2) {
              var l3 = a4 / t4, u3 = s2 / e4, c3 = P(l3 * l3 + u3 * u3), f3 = 2 * L(c3 / 2);
              return [o(a4 * y(f3), t4 * c3) / i3, c3 && L(s2 * g2(f3) / (e4 * r4 * c3)) / n4];
            }, a3;
          }(p3 / P(c2 * u2 * l2), 1 / (p3 * P(c2 * u2 * l2)), u2, l2, c2);
        }
        function Vi() {
          var t3 = 65 * E, e3 = 60 * E, r3 = 20, i2 = 200, a2 = (0, n2.r)(Ui), o2 = a2(t3, e3, r3, i2);
          return o2.poleline = function(n3) {
            return arguments.length ? a2(t3 = +n3 * E, e3, r3, i2) : t3 * S;
          }, o2.parallels = function(n3) {
            return arguments.length ? a2(t3, e3 = +n3 * E, r3, i2) : e3 * S;
          }, o2.inflation = function(n3) {
            return arguments.length ? a2(t3, e3, r3 = +n3, i2) : r3;
          }, o2.ratio = function(n3) {
            return arguments.length ? a2(t3, e3, r3, i2 = +n3) : i2;
          }, o2.scale(163.775);
        }
        function Hi() {
          return Vi().poleline(65).parallels(60).inflation(0).ratio(200).scale(172.633);
        }
        ki.invert = function(t3, e3) {
          var r3 = e3 / 1.70711, n3 = g2(w2 * r3);
          return [t3 / (0.74482 - 0.34588 * n3 * n3), 2 * a(r3)];
        }, Ii.invert = function(t3, e3) {
          if (i(e3) < m2)
            return [t3, 0];
          if (i(t3) < m2)
            return [0, _ * g2(2 * a(e3 / b))];
          var r3 = (t3 /= b) * t3, n3 = (e3 /= b) * e3, o2 = r3 + n3, l2 = o2 * o2, u2 = -i(e3) * (1 + o2), c2 = u2 - 2 * n3 + r3, f3 = -2 * u2 + 1 + 2 * n3 + l2, h2 = n3 / f3 + (2 * c2 * c2 * c2 / (f3 * f3 * f3) - 9 * u2 * c2 / (f3 * f3)) / 27, p3 = (u2 - c2 * c2 / (3 * f3)) / f3, d3 = 2 * P(-p3 / 3), y2 = C(3 * h2 / (p3 * d3)) / 3;
          return [b * (o2 - 1 + P(1 + 2 * (r3 - n3) + l2)) / (2 * t3), v(e3) * b * (-d3 * s(y2 + b / 3) - c2 / (3 * f3))];
        }, zi.invert = function(t3, e3) {
          if (!t3)
            return [0, _ * g2(2 * a(e3 / b))];
          var r3 = i(t3 / b), n3 = (1 - r3 * r3 - (e3 /= b) * e3) / (2 * r3), s2 = P(n3 * n3 + 1);
          return [v(t3) * b * (s2 - n3), v(e3) * _ * g2(2 * o(P((1 - 2 * n3 * r3) * (n3 + s2) - r3), P(s2 + n3 + r3)))];
        }, Fi.invert = function(t3, e3) {
          if (!e3)
            return [t3, 0];
          var r3 = e3 / b, n3 = (b * b * (1 - r3 * r3) - t3 * t3) / (2 * b * t3);
          return [t3 ? b * (v(t3) * P(n3 * n3 + 1) - n3) : 0, _ * g2(2 * a(r3))];
        }, Ni.invert = function(t3, e3) {
          var r3;
          if (!t3 || !e3)
            return [t3, e3];
          e3 /= b;
          var n3 = v(t3) * t3 / _, a2 = (n3 * n3 - 1 + 4 * e3 * e3) / i(n3), o2 = a2 * a2, s2 = 2 * e3, l2 = 50;
          do {
            var u2 = s2 * s2, c2 = (8 * s2 - u2 * (u2 + 2) - 5) / (2 * u2 * (s2 - 1)), f3 = (3 * s2 - u2 * s2 - 10) / (2 * u2 * s2), h2 = c2 * c2, p3 = s2 * c2, d3 = s2 + c2, g3 = d3 * d3, y2 = s2 + 3 * c2, x2 = -2 * d3 * (4 * p3 * h2 + (1 - 4 * u2 + 3 * u2 * u2) * (1 + f3) + h2 * (14 * u2 - 6 - o2 + (8 * u2 - 8 - 2 * o2) * f3) + p3 * (12 * u2 - 8 + (10 * u2 - 10 - o2) * f3)), w3 = P(g3 * (u2 + h2 * o2 - 1) + (1 - u2) * (u2 * (y2 * y2 + 4 * h2) + h2 * (12 * p3 + 4 * h2)));
            s2 -= r3 = (a2 * (g3 + h2 - 1) + 2 * w3 - n3 * (4 * g3 + o2)) / (a2 * (2 * c2 * f3 + 2 * d3 * (1 + f3)) + x2 / w3 - 8 * d3 * (a2 * (-1 + h2 + g3) + 2 * w3) * (1 + f3) / (o2 + 4 * g3));
          } while (r3 > m2 && --l2 > 0);
          return [v(t3) * (P(a2 * a2 + 4) + a2) * b / 4, _ * s2];
        };
        var qi = 4 * b + 3 * P(3), Gi = 2 * P(2 * b * P(3) / qi), Zi = it(Gi * P(3) / b, Gi, qi / 6);
        function Yi() {
          return (0, n2.Z)(Zi).scale(176.84);
        }
        function Wi(t3, e3) {
          return [t3 * P(1 - 3 * e3 * e3 / (b * b)), e3];
        }
        function Xi() {
          return (0, n2.Z)(Wi).scale(152.63);
        }
        function Ji(t3, e3) {
          var r3 = s(e3), n3 = s(t3) * r3, i2 = 1 - n3, a2 = s(t3 = o(g2(t3) * r3, -g2(e3))), l2 = g2(t3);
          return [l2 * (r3 = P(1 - n3 * n3)) - a2 * i2, -a2 * r3 - l2 * i2];
        }
        function Ki() {
          return (0, n2.Z)(Ji).rotate([0, -90, 45]).scale(124.75).clipAngle(179.999);
        }
        function $i(t3, e3) {
          var r3 = R(t3, e3);
          return [(r3[0] + t3 / _) / 2, (r3[1] + e3) / 2];
        }
        function Qi() {
          return (0, n2.Z)($i).scale(158.837);
        }
        Wi.invert = function(t3, e3) {
          return [t3 / P(1 - 3 * e3 * e3 / (b * b)), e3];
        }, Ji.invert = function(t3, e3) {
          var r3 = (t3 * t3 + e3 * e3) / -2, n3 = P(-r3 * (2 + r3)), i2 = e3 * r3 + t3 * n3, a2 = t3 * r3 - e3 * n3, s2 = P(a2 * a2 + i2 * i2);
          return [o(n3 * i2, s2 * (1 + r3)), s2 ? -L(n3 * a2 / s2) : 0];
        }, $i.invert = function(t3, e3) {
          var r3 = t3, n3 = e3, a2 = 25;
          do {
            var o2, l2 = s(n3), u2 = g2(n3), c2 = g2(2 * n3), f3 = u2 * u2, h2 = l2 * l2, p3 = g2(r3), d3 = s(r3 / 2), v2 = g2(r3 / 2), y2 = v2 * v2, x2 = 1 - h2 * d3 * d3, b2 = x2 ? C(l2 * d3) * P(o2 = 1 / x2) : o2 = 0, w3 = 0.5 * (2 * b2 * l2 * v2 + r3 / _) - t3, T2 = 0.5 * (b2 * u2 + n3) - e3, k2 = 0.5 * o2 * (h2 * y2 + b2 * l2 * d3 * f3) + 0.5 / _, A2 = o2 * (p3 * c2 / 4 - b2 * u2 * v2), M2 = 0.125 * o2 * (c2 * v2 - b2 * u2 * h2 * p3), S2 = 0.5 * o2 * (f3 * d3 + b2 * y2 * l2) + 0.5, E2 = A2 * M2 - S2 * k2, L2 = (T2 * A2 - w3 * S2) / E2, O2 = (w3 * M2 - T2 * k2) / E2;
            r3 -= L2, n3 -= O2;
          } while ((i(L2) > m2 || i(O2) > m2) && --a2 > 0);
          return [r3, n3];
        };
      }, 33940: function(t2, e2, r2) {
        function n2() {
          return new i();
        }
        function i() {
          this.reset();
        }
        r2.d(e2, { Z: function() {
          return n2;
        } }), i.prototype = { constructor: i, reset: function() {
          this.s = this.t = 0;
        }, add: function(t3) {
          o(a, t3, this.t), o(this, a.s, this.s), this.s ? this.t += a.t : this.s = a.t;
        }, valueOf: function() {
          return this.s;
        } };
        var a = new i();
        function o(t3, e3, r3) {
          var n3 = t3.s = e3 + r3, i2 = n3 - e3, a2 = n3 - i2;
          t3.t = e3 - a2 + (r3 - i2);
        }
      }, 97860: function(t2, e2, r2) {
        r2.d(e2, { L9: function() {
          return h;
        }, ZP: function() {
          return x;
        }, gL: function() {
          return d2;
        } });
        var n2, i, a, o, s, l = r2(33940), u = r2(39695), c = r2(73182), f2 = r2(72736), h = (0, l.Z)(), p2 = (0, l.Z)(), d2 = { point: c.Z, lineStart: c.Z, lineEnd: c.Z, polygonStart: function() {
          h.reset(), d2.lineStart = v, d2.lineEnd = g2;
        }, polygonEnd: function() {
          var t3 = +h;
          p2.add(t3 < 0 ? u.BZ + t3 : t3), this.lineStart = this.lineEnd = this.point = c.Z;
        }, sphere: function() {
          p2.add(u.BZ);
        } };
        function v() {
          d2.point = y;
        }
        function g2() {
          m2(n2, i);
        }
        function y(t3, e3) {
          d2.point = m2, n2 = t3, i = e3, t3 *= u.uR, e3 *= u.uR, a = t3, o = (0, u.mC)(e3 = e3 / 2 + u.pu), s = (0, u.O$)(e3);
        }
        function m2(t3, e3) {
          t3 *= u.uR, e3 = (e3 *= u.uR) / 2 + u.pu;
          var r3 = t3 - a, n3 = r3 >= 0 ? 1 : -1, i2 = n3 * r3, l2 = (0, u.mC)(e3), c2 = (0, u.O$)(e3), f3 = s * c2, p3 = o * l2 + f3 * (0, u.mC)(i2), d3 = f3 * n3 * (0, u.O$)(i2);
          h.add((0, u.fv)(d3, p3)), a = t3, o = l2, s = c2;
        }
        function x(t3) {
          return p2.reset(), (0, f2.Z)(t3, d2), 2 * p2;
        }
      }, 77338: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return C;
        } });
        var n2, i, a, o, s, l, u, c, f2, h, p2 = r2(33940), d2 = r2(97860), v = r2(7620), g2 = r2(39695), y = r2(72736), m2 = (0, p2.Z)(), x = { point: b, lineStart: w2, lineEnd: T, polygonStart: function() {
          x.point = k, x.lineStart = A, x.lineEnd = M, m2.reset(), d2.gL.polygonStart();
        }, polygonEnd: function() {
          d2.gL.polygonEnd(), x.point = b, x.lineStart = w2, x.lineEnd = T, d2.L9 < 0 ? (n2 = -(a = 180), i = -(o = 90)) : m2 > g2.Ho ? o = 90 : m2 < -g2.Ho && (i = -90), h[0] = n2, h[1] = a;
        }, sphere: function() {
          n2 = -(a = 180), i = -(o = 90);
        } };
        function b(t3, e3) {
          f2.push(h = [n2 = t3, a = t3]), e3 < i && (i = e3), e3 > o && (o = e3);
        }
        function _(t3, e3) {
          var r3 = (0, v.Og)([t3 * g2.uR, e3 * g2.uR]);
          if (c) {
            var l2 = (0, v.T5)(c, r3), u2 = [l2[1], -l2[0], 0], p3 = (0, v.T5)(u2, l2);
            (0, v.iJ)(p3), p3 = (0, v.Y1)(p3);
            var d3, y2 = t3 - s, m3 = y2 > 0 ? 1 : -1, x2 = p3[0] * g2.RW * m3, b2 = (0, g2.Wn)(y2) > 180;
            b2 ^ (m3 * s < x2 && x2 < m3 * t3) ? (d3 = p3[1] * g2.RW) > o && (o = d3) : b2 ^ (m3 * s < (x2 = (x2 + 360) % 360 - 180) && x2 < m3 * t3) ? (d3 = -p3[1] * g2.RW) < i && (i = d3) : (e3 < i && (i = e3), e3 > o && (o = e3)), b2 ? t3 < s ? S(n2, t3) > S(n2, a) && (a = t3) : S(t3, a) > S(n2, a) && (n2 = t3) : a >= n2 ? (t3 < n2 && (n2 = t3), t3 > a && (a = t3)) : t3 > s ? S(n2, t3) > S(n2, a) && (a = t3) : S(t3, a) > S(n2, a) && (n2 = t3);
          } else
            f2.push(h = [n2 = t3, a = t3]);
          e3 < i && (i = e3), e3 > o && (o = e3), c = r3, s = t3;
        }
        function w2() {
          x.point = _;
        }
        function T() {
          h[0] = n2, h[1] = a, x.point = b, c = null;
        }
        function k(t3, e3) {
          if (c) {
            var r3 = t3 - s;
            m2.add((0, g2.Wn)(r3) > 180 ? r3 + (r3 > 0 ? 360 : -360) : r3);
          } else
            l = t3, u = e3;
          d2.gL.point(t3, e3), _(t3, e3);
        }
        function A() {
          d2.gL.lineStart();
        }
        function M() {
          k(l, u), d2.gL.lineEnd(), (0, g2.Wn)(m2) > g2.Ho && (n2 = -(a = 180)), h[0] = n2, h[1] = a, c = null;
        }
        function S(t3, e3) {
          return (e3 -= t3) < 0 ? e3 + 360 : e3;
        }
        function E(t3, e3) {
          return t3[0] - e3[0];
        }
        function L(t3, e3) {
          return t3[0] <= t3[1] ? t3[0] <= e3 && e3 <= t3[1] : e3 < t3[0] || t3[1] < e3;
        }
        function C(t3) {
          var e3, r3, s2, l2, u2, c2, p3;
          if (o = a = -(n2 = i = 1 / 0), f2 = [], (0, y.Z)(t3, x), r3 = f2.length) {
            for (f2.sort(E), e3 = 1, u2 = [s2 = f2[0]]; e3 < r3; ++e3)
              L(s2, (l2 = f2[e3])[0]) || L(s2, l2[1]) ? (S(s2[0], l2[1]) > S(s2[0], s2[1]) && (s2[1] = l2[1]), S(l2[0], s2[1]) > S(s2[0], s2[1]) && (s2[0] = l2[0])) : u2.push(s2 = l2);
            for (c2 = -1 / 0, e3 = 0, s2 = u2[r3 = u2.length - 1]; e3 <= r3; s2 = l2, ++e3)
              l2 = u2[e3], (p3 = S(s2[1], l2[0])) > c2 && (c2 = p3, n2 = l2[0], a = s2[1]);
          }
          return f2 = h = null, n2 === 1 / 0 || i === 1 / 0 ? [[NaN, NaN], [NaN, NaN]] : [[n2, i], [a, o]];
        }
      }, 7620: function(t2, e2, r2) {
        r2.d(e2, { Og: function() {
          return a;
        }, T: function() {
          return u;
        }, T5: function() {
          return s;
        }, Y1: function() {
          return i;
        }, iJ: function() {
          return c;
        }, j9: function() {
          return o;
        }, s0: function() {
          return l;
        } });
        var n2 = r2(39695);
        function i(t3) {
          return [(0, n2.fv)(t3[1], t3[0]), (0, n2.ZR)(t3[2])];
        }
        function a(t3) {
          var e3 = t3[0], r3 = t3[1], i2 = (0, n2.mC)(r3);
          return [i2 * (0, n2.mC)(e3), i2 * (0, n2.O$)(e3), (0, n2.O$)(r3)];
        }
        function o(t3, e3) {
          return t3[0] * e3[0] + t3[1] * e3[1] + t3[2] * e3[2];
        }
        function s(t3, e3) {
          return [t3[1] * e3[2] - t3[2] * e3[1], t3[2] * e3[0] - t3[0] * e3[2], t3[0] * e3[1] - t3[1] * e3[0]];
        }
        function l(t3, e3) {
          t3[0] += e3[0], t3[1] += e3[1], t3[2] += e3[2];
        }
        function u(t3, e3) {
          return [t3[0] * e3, t3[1] * e3, t3[2] * e3];
        }
        function c(t3) {
          var e3 = (0, n2._b)(t3[0] * t3[0] + t3[1] * t3[1] + t3[2] * t3[2]);
          t3[0] /= e3, t3[1] /= e3, t3[2] /= e3;
        }
      }, 66624: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return I;
        } });
        var n2, i, a, o, s, l, u, c, f2, h, p2, d2, v, g2, y, m2, x = r2(39695), b = r2(73182), _ = r2(72736), w2 = { sphere: b.Z, point: T, lineStart: A, lineEnd: E, polygonStart: function() {
          w2.lineStart = L, w2.lineEnd = C;
        }, polygonEnd: function() {
          w2.lineStart = A, w2.lineEnd = E;
        } };
        function T(t3, e3) {
          t3 *= x.uR, e3 *= x.uR;
          var r3 = (0, x.mC)(e3);
          k(r3 * (0, x.mC)(t3), r3 * (0, x.O$)(t3), (0, x.O$)(e3));
        }
        function k(t3, e3, r3) {
          ++n2, a += (t3 - a) / n2, o += (e3 - o) / n2, s += (r3 - s) / n2;
        }
        function A() {
          w2.point = M;
        }
        function M(t3, e3) {
          t3 *= x.uR, e3 *= x.uR;
          var r3 = (0, x.mC)(e3);
          g2 = r3 * (0, x.mC)(t3), y = r3 * (0, x.O$)(t3), m2 = (0, x.O$)(e3), w2.point = S, k(g2, y, m2);
        }
        function S(t3, e3) {
          t3 *= x.uR, e3 *= x.uR;
          var r3 = (0, x.mC)(e3), n3 = r3 * (0, x.mC)(t3), a2 = r3 * (0, x.O$)(t3), o2 = (0, x.O$)(e3), s2 = (0, x.fv)((0, x._b)((s2 = y * o2 - m2 * a2) * s2 + (s2 = m2 * n3 - g2 * o2) * s2 + (s2 = g2 * a2 - y * n3) * s2), g2 * n3 + y * a2 + m2 * o2);
          i += s2, l += s2 * (g2 + (g2 = n3)), u += s2 * (y + (y = a2)), c += s2 * (m2 + (m2 = o2)), k(g2, y, m2);
        }
        function E() {
          w2.point = T;
        }
        function L() {
          w2.point = P;
        }
        function C() {
          O(d2, v), w2.point = T;
        }
        function P(t3, e3) {
          d2 = t3, v = e3, t3 *= x.uR, e3 *= x.uR, w2.point = O;
          var r3 = (0, x.mC)(e3);
          g2 = r3 * (0, x.mC)(t3), y = r3 * (0, x.O$)(t3), m2 = (0, x.O$)(e3), k(g2, y, m2);
        }
        function O(t3, e3) {
          t3 *= x.uR, e3 *= x.uR;
          var r3 = (0, x.mC)(e3), n3 = r3 * (0, x.mC)(t3), a2 = r3 * (0, x.O$)(t3), o2 = (0, x.O$)(e3), s2 = y * o2 - m2 * a2, d3 = m2 * n3 - g2 * o2, v2 = g2 * a2 - y * n3, b2 = (0, x._b)(s2 * s2 + d3 * d3 + v2 * v2), _2 = (0, x.ZR)(b2), w3 = b2 && -_2 / b2;
          f2 += w3 * s2, h += w3 * d3, p2 += w3 * v2, i += _2, l += _2 * (g2 + (g2 = n3)), u += _2 * (y + (y = a2)), c += _2 * (m2 + (m2 = o2)), k(g2, y, m2);
        }
        function I(t3) {
          n2 = i = a = o = s = l = u = c = f2 = h = p2 = 0, (0, _.Z)(t3, w2);
          var e3 = f2, r3 = h, d3 = p2, v2 = e3 * e3 + r3 * r3 + d3 * d3;
          return v2 < x.aW && (e3 = l, r3 = u, d3 = c, i < x.Ho && (e3 = a, r3 = o, d3 = s), (v2 = e3 * e3 + r3 * r3 + d3 * d3) < x.aW) ? [NaN, NaN] : [(0, x.fv)(r3, e3) * x.RW, (0, x.ZR)(d3 / (0, x._b)(v2)) * x.RW];
        }
      }, 7613: function(t2, e2, r2) {
        r2.d(e2, { m: function() {
          return s;
        }, Z: function() {
          return u;
        } });
        var n2 = r2(7620);
        function i(t3) {
          return function() {
            return t3;
          };
        }
        var a = r2(39695), o = r2(49386);
        function s(t3, e3, r3, i2, o2, s2) {
          if (r3) {
            var u2 = (0, a.mC)(e3), c = (0, a.O$)(e3), f2 = i2 * r3;
            null == o2 ? (o2 = e3 + i2 * a.BZ, s2 = e3 - f2 / 2) : (o2 = l(u2, o2), s2 = l(u2, s2), (i2 > 0 ? o2 < s2 : o2 > s2) && (o2 += i2 * a.BZ));
            for (var h, p2 = o2; i2 > 0 ? p2 > s2 : p2 < s2; p2 -= f2)
              h = (0, n2.Y1)([u2, -c * (0, a.mC)(p2), -c * (0, a.O$)(p2)]), t3.point(h[0], h[1]);
          }
        }
        function l(t3, e3) {
          (e3 = (0, n2.Og)(e3))[0] -= t3, (0, n2.iJ)(e3);
          var r3 = (0, a.Kh)(-e3[1]);
          return ((-e3[2] < 0 ? -r3 : r3) + a.BZ - a.Ho) % a.BZ;
        }
        function u() {
          var t3, e3, r3 = i([0, 0]), n3 = i(90), l2 = i(6), u2 = { point: function(r4, n4) {
            t3.push(r4 = e3(r4, n4)), r4[0] *= a.RW, r4[1] *= a.RW;
          } };
          function c() {
            var i2 = r3.apply(this, arguments), c2 = n3.apply(this, arguments) * a.uR, f2 = l2.apply(this, arguments) * a.uR;
            return t3 = [], e3 = (0, o.I)(-i2[0] * a.uR, -i2[1] * a.uR, 0).invert, s(u2, c2, f2, 1), i2 = { type: "Polygon", coordinates: [t3] }, t3 = e3 = null, i2;
          }
          return c.center = function(t4) {
            return arguments.length ? (r3 = "function" == typeof t4 ? t4 : i([+t4[0], +t4[1]]), c) : r3;
          }, c.radius = function(t4) {
            return arguments.length ? (n3 = "function" == typeof t4 ? t4 : i(+t4), c) : n3;
          }, c.precision = function(t4) {
            return arguments.length ? (l2 = "function" == typeof t4 ? t4 : i(+t4), c) : l2;
          }, c;
        }
      }, 87070: function(t2, e2, r2) {
        var n2 = r2(97023), i = r2(39695);
        e2.Z = (0, n2.Z)(function() {
          return true;
        }, function(t3) {
          var e3, r3 = NaN, n3 = NaN, a = NaN;
          return { lineStart: function() {
            t3.lineStart(), e3 = 1;
          }, point: function(o, s) {
            var l = o > 0 ? i.pi : -i.pi, u = (0, i.Wn)(o - r3);
            (0, i.Wn)(u - i.pi) < i.Ho ? (t3.point(r3, n3 = (n3 + s) / 2 > 0 ? i.ou : -i.ou), t3.point(a, n3), t3.lineEnd(), t3.lineStart(), t3.point(l, n3), t3.point(o, n3), e3 = 0) : a !== l && u >= i.pi && ((0, i.Wn)(r3 - a) < i.Ho && (r3 -= a * i.Ho), (0, i.Wn)(o - l) < i.Ho && (o -= l * i.Ho), n3 = function(t4, e4, r4, n4) {
              var a2, o2, s2 = (0, i.O$)(t4 - r4);
              return (0, i.Wn)(s2) > i.Ho ? (0, i.z4)(((0, i.O$)(e4) * (o2 = (0, i.mC)(n4)) * (0, i.O$)(r4) - (0, i.O$)(n4) * (a2 = (0, i.mC)(e4)) * (0, i.O$)(t4)) / (a2 * o2 * s2)) : (e4 + n4) / 2;
            }(r3, n3, o, s), t3.point(a, n3), t3.lineEnd(), t3.lineStart(), t3.point(l, n3), e3 = 0), t3.point(r3 = o, n3 = s), a = l;
          }, lineEnd: function() {
            t3.lineEnd(), r3 = n3 = NaN;
          }, clean: function() {
            return 2 - e3;
          } };
        }, function(t3, e3, r3, n3) {
          var a;
          if (null == t3)
            a = r3 * i.ou, n3.point(-i.pi, a), n3.point(0, a), n3.point(i.pi, a), n3.point(i.pi, 0), n3.point(i.pi, -a), n3.point(0, -a), n3.point(-i.pi, -a), n3.point(-i.pi, 0), n3.point(-i.pi, a);
          else if ((0, i.Wn)(t3[0] - e3[0]) > i.Ho) {
            var o = t3[0] < e3[0] ? i.pi : -i.pi;
            a = r3 * o / 2, n3.point(-o, a), n3.point(0, a), n3.point(o, a);
          } else
            n3.point(e3[0], e3[1]);
        }, [-i.pi, -i.ou]);
      }, 85272: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return i;
        } });
        var n2 = r2(73182);
        function i() {
          var t3, e3 = [];
          return { point: function(e4, r3, n3) {
            t3.push([e4, r3, n3]);
          }, lineStart: function() {
            e3.push(t3 = []);
          }, lineEnd: n2.Z, rejoin: function() {
            e3.length > 1 && e3.push(e3.pop().concat(e3.shift()));
          }, result: function() {
            var r3 = e3;
            return e3 = [], t3 = null, r3;
          } };
        }
      }, 1457: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return l;
        } });
        var n2 = r2(7620), i = r2(7613), a = r2(39695), o = r2(67108), s = r2(97023);
        function l(t3) {
          var e3 = (0, a.mC)(t3), r3 = 6 * a.uR, l2 = e3 > 0, u = (0, a.Wn)(e3) > a.Ho;
          function c(t4, r4) {
            return (0, a.mC)(t4) * (0, a.mC)(r4) > e3;
          }
          function f2(t4, r4, i2) {
            var o2 = (0, n2.Og)(t4), s2 = (0, n2.Og)(r4), l3 = [1, 0, 0], u2 = (0, n2.T5)(o2, s2), c2 = (0, n2.j9)(u2, u2), f3 = u2[0], h2 = c2 - f3 * f3;
            if (!h2)
              return !i2 && t4;
            var p2 = e3 * c2 / h2, d2 = -e3 * f3 / h2, v = (0, n2.T5)(l3, u2), g2 = (0, n2.T)(l3, p2), y = (0, n2.T)(u2, d2);
            (0, n2.s0)(g2, y);
            var m2 = v, x = (0, n2.j9)(g2, m2), b = (0, n2.j9)(m2, m2), _ = x * x - b * ((0, n2.j9)(g2, g2) - 1);
            if (!(_ < 0)) {
              var w2 = (0, a._b)(_), T = (0, n2.T)(m2, (-x - w2) / b);
              if ((0, n2.s0)(T, g2), T = (0, n2.Y1)(T), !i2)
                return T;
              var k, A = t4[0], M = r4[0], S = t4[1], E = r4[1];
              M < A && (k = A, A = M, M = k);
              var L = M - A, C = (0, a.Wn)(L - a.pi) < a.Ho;
              if (!C && E < S && (k = S, S = E, E = k), C || L < a.Ho ? C ? S + E > 0 ^ T[1] < ((0, a.Wn)(T[0] - A) < a.Ho ? S : E) : S <= T[1] && T[1] <= E : L > a.pi ^ (A <= T[0] && T[0] <= M)) {
                var P = (0, n2.T)(m2, (-x + w2) / b);
                return (0, n2.s0)(P, g2), [T, (0, n2.Y1)(P)];
              }
            }
          }
          function h(e4, r4) {
            var n3 = l2 ? t3 : a.pi - t3, i2 = 0;
            return e4 < -n3 ? i2 |= 1 : e4 > n3 && (i2 |= 2), r4 < -n3 ? i2 |= 4 : r4 > n3 && (i2 |= 8), i2;
          }
          return (0, s.Z)(c, function(t4) {
            var e4, r4, n3, i2, s2;
            return { lineStart: function() {
              i2 = n3 = false, s2 = 1;
            }, point: function(p2, d2) {
              var v, g2 = [p2, d2], y = c(p2, d2), m2 = l2 ? y ? 0 : h(p2, d2) : y ? h(p2 + (p2 < 0 ? a.pi : -a.pi), d2) : 0;
              if (!e4 && (i2 = n3 = y) && t4.lineStart(), y !== n3 && (!(v = f2(e4, g2)) || (0, o.Z)(e4, v) || (0, o.Z)(g2, v)) && (g2[2] = 1), y !== n3)
                s2 = 0, y ? (t4.lineStart(), v = f2(g2, e4), t4.point(v[0], v[1])) : (v = f2(e4, g2), t4.point(v[0], v[1], 2), t4.lineEnd()), e4 = v;
              else if (u && e4 && l2 ^ y) {
                var x;
                m2 & r4 || !(x = f2(g2, e4, true)) || (s2 = 0, l2 ? (t4.lineStart(), t4.point(x[0][0], x[0][1]), t4.point(x[1][0], x[1][1]), t4.lineEnd()) : (t4.point(x[1][0], x[1][1]), t4.lineEnd(), t4.lineStart(), t4.point(x[0][0], x[0][1], 3)));
              }
              !y || e4 && (0, o.Z)(e4, g2) || t4.point(g2[0], g2[1]), e4 = g2, n3 = y, r4 = m2;
            }, lineEnd: function() {
              n3 && t4.lineEnd(), e4 = null;
            }, clean: function() {
              return s2 | (i2 && n3) << 1;
            } };
          }, function(e4, n3, a2, o2) {
            (0, i.m)(o2, t3, r3, a2, e4, n3);
          }, l2 ? [0, -t3] : [-a.pi, t3 - a.pi]);
        }
      }, 97023: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return l;
        } });
        var n2 = r2(85272), i = r2(46225), a = r2(39695), o = r2(23071), s = r2(33064);
        function l(t3, e3, r3, a2) {
          return function(l2) {
            var f2, h, p2, d2 = e3(l2), v = (0, n2.Z)(), g2 = e3(v), y = false, m2 = { point: x, lineStart: _, lineEnd: w2, polygonStart: function() {
              m2.point = T, m2.lineStart = k, m2.lineEnd = A, h = [], f2 = [];
            }, polygonEnd: function() {
              m2.point = x, m2.lineStart = _, m2.lineEnd = w2, h = (0, s.TS)(h);
              var t4 = (0, o.Z)(f2, a2);
              h.length ? (y || (l2.polygonStart(), y = true), (0, i.Z)(h, c, t4, r3, l2)) : t4 && (y || (l2.polygonStart(), y = true), l2.lineStart(), r3(null, null, 1, l2), l2.lineEnd()), y && (l2.polygonEnd(), y = false), h = f2 = null;
            }, sphere: function() {
              l2.polygonStart(), l2.lineStart(), r3(null, null, 1, l2), l2.lineEnd(), l2.polygonEnd();
            } };
            function x(e4, r4) {
              t3(e4, r4) && l2.point(e4, r4);
            }
            function b(t4, e4) {
              d2.point(t4, e4);
            }
            function _() {
              m2.point = b, d2.lineStart();
            }
            function w2() {
              m2.point = x, d2.lineEnd();
            }
            function T(t4, e4) {
              p2.push([t4, e4]), g2.point(t4, e4);
            }
            function k() {
              g2.lineStart(), p2 = [];
            }
            function A() {
              T(p2[0][0], p2[0][1]), g2.lineEnd();
              var t4, e4, r4, n3, i2 = g2.clean(), a3 = v.result(), o2 = a3.length;
              if (p2.pop(), f2.push(p2), p2 = null, o2)
                if (1 & i2) {
                  if ((e4 = (r4 = a3[0]).length - 1) > 0) {
                    for (y || (l2.polygonStart(), y = true), l2.lineStart(), t4 = 0; t4 < e4; ++t4)
                      l2.point((n3 = r4[t4])[0], n3[1]);
                    l2.lineEnd();
                  }
                } else
                  o2 > 1 && 2 & i2 && a3.push(a3.pop().concat(a3.shift())), h.push(a3.filter(u));
            }
            return m2;
          };
        }
        function u(t3) {
          return t3.length > 1;
        }
        function c(t3, e3) {
          return ((t3 = t3.x)[0] < 0 ? t3[1] - a.ou - a.Ho : a.ou - t3[1]) - ((e3 = e3.x)[0] < 0 ? e3[1] - a.ou - a.Ho : a.ou - e3[1]);
        }
      }, 87605: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return u;
        } });
        var n2 = r2(39695), i = r2(85272), a = r2(46225), o = r2(33064), s = 1e9, l = -s;
        function u(t3, e3, r3, u2) {
          function c(n3, i2) {
            return t3 <= n3 && n3 <= r3 && e3 <= i2 && i2 <= u2;
          }
          function f2(n3, i2, a2, o2) {
            var s2 = 0, l2 = 0;
            if (null == n3 || (s2 = h(n3, a2)) !== (l2 = h(i2, a2)) || d2(n3, i2) < 0 ^ a2 > 0)
              do {
                o2.point(0 === s2 || 3 === s2 ? t3 : r3, s2 > 1 ? u2 : e3);
              } while ((s2 = (s2 + a2 + 4) % 4) !== l2);
            else
              o2.point(i2[0], i2[1]);
          }
          function h(i2, a2) {
            return (0, n2.Wn)(i2[0] - t3) < n2.Ho ? a2 > 0 ? 0 : 3 : (0, n2.Wn)(i2[0] - r3) < n2.Ho ? a2 > 0 ? 2 : 1 : (0, n2.Wn)(i2[1] - e3) < n2.Ho ? a2 > 0 ? 1 : 0 : a2 > 0 ? 3 : 2;
          }
          function p2(t4, e4) {
            return d2(t4.x, e4.x);
          }
          function d2(t4, e4) {
            var r4 = h(t4, 1), n3 = h(e4, 1);
            return r4 !== n3 ? r4 - n3 : 0 === r4 ? e4[1] - t4[1] : 1 === r4 ? t4[0] - e4[0] : 2 === r4 ? t4[1] - e4[1] : e4[0] - t4[0];
          }
          return function(n3) {
            var h2, d3, v, g2, y, m2, x, b, _, w2, T, k = n3, A = (0, i.Z)(), M = { point: S, lineStart: function() {
              M.point = E, d3 && d3.push(v = []), w2 = true, _ = false, x = b = NaN;
            }, lineEnd: function() {
              h2 && (E(g2, y), m2 && _ && A.rejoin(), h2.push(A.result())), M.point = S, _ && k.lineEnd();
            }, polygonStart: function() {
              k = A, h2 = [], d3 = [], T = true;
            }, polygonEnd: function() {
              var e4 = function() {
                for (var e5 = 0, r5 = 0, n4 = d3.length; r5 < n4; ++r5)
                  for (var i3, a2, o2 = d3[r5], s2 = 1, l2 = o2.length, c2 = o2[0], f3 = c2[0], h3 = c2[1]; s2 < l2; ++s2)
                    i3 = f3, a2 = h3, f3 = (c2 = o2[s2])[0], h3 = c2[1], a2 <= u2 ? h3 > u2 && (f3 - i3) * (u2 - a2) > (h3 - a2) * (t3 - i3) && ++e5 : h3 <= u2 && (f3 - i3) * (u2 - a2) < (h3 - a2) * (t3 - i3) && --e5;
                return e5;
              }(), r4 = T && e4, i2 = (h2 = (0, o.TS)(h2)).length;
              (r4 || i2) && (n3.polygonStart(), r4 && (n3.lineStart(), f2(null, null, 1, n3), n3.lineEnd()), i2 && (0, a.Z)(h2, p2, e4, f2, n3), n3.polygonEnd()), k = n3, h2 = d3 = v = null;
            } };
            function S(t4, e4) {
              c(t4, e4) && k.point(t4, e4);
            }
            function E(n4, i2) {
              var a2 = c(n4, i2);
              if (d3 && v.push([n4, i2]), w2)
                g2 = n4, y = i2, m2 = a2, w2 = false, a2 && (k.lineStart(), k.point(n4, i2));
              else if (a2 && _)
                k.point(n4, i2);
              else {
                var o2 = [x = Math.max(l, Math.min(s, x)), b = Math.max(l, Math.min(s, b))], f3 = [n4 = Math.max(l, Math.min(s, n4)), i2 = Math.max(l, Math.min(s, i2))];
                !function(t4, e4, r4, n5, i3, a3) {
                  var o3, s2 = t4[0], l2 = t4[1], u3 = 0, c2 = 1, f4 = e4[0] - s2, h3 = e4[1] - l2;
                  if (o3 = r4 - s2, f4 || !(o3 > 0)) {
                    if (o3 /= f4, f4 < 0) {
                      if (o3 < u3)
                        return;
                      o3 < c2 && (c2 = o3);
                    } else if (f4 > 0) {
                      if (o3 > c2)
                        return;
                      o3 > u3 && (u3 = o3);
                    }
                    if (o3 = i3 - s2, f4 || !(o3 < 0)) {
                      if (o3 /= f4, f4 < 0) {
                        if (o3 > c2)
                          return;
                        o3 > u3 && (u3 = o3);
                      } else if (f4 > 0) {
                        if (o3 < u3)
                          return;
                        o3 < c2 && (c2 = o3);
                      }
                      if (o3 = n5 - l2, h3 || !(o3 > 0)) {
                        if (o3 /= h3, h3 < 0) {
                          if (o3 < u3)
                            return;
                          o3 < c2 && (c2 = o3);
                        } else if (h3 > 0) {
                          if (o3 > c2)
                            return;
                          o3 > u3 && (u3 = o3);
                        }
                        if (o3 = a3 - l2, h3 || !(o3 < 0)) {
                          if (o3 /= h3, h3 < 0) {
                            if (o3 > c2)
                              return;
                            o3 > u3 && (u3 = o3);
                          } else if (h3 > 0) {
                            if (o3 < u3)
                              return;
                            o3 < c2 && (c2 = o3);
                          }
                          return u3 > 0 && (t4[0] = s2 + u3 * f4, t4[1] = l2 + u3 * h3), c2 < 1 && (e4[0] = s2 + c2 * f4, e4[1] = l2 + c2 * h3), true;
                        }
                      }
                    }
                  }
                }(o2, f3, t3, e3, r3, u2) ? a2 && (k.lineStart(), k.point(n4, i2), T = false) : (_ || (k.lineStart(), k.point(o2[0], o2[1])), k.point(f3[0], f3[1]), a2 || k.lineEnd(), T = false);
              }
              x = n4, b = i2, _ = a2;
            }
            return M;
          };
        }
      }, 46225: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return o;
        } });
        var n2 = r2(67108), i = r2(39695);
        function a(t3, e3, r3, n3) {
          this.x = t3, this.z = e3, this.o = r3, this.e = n3, this.v = false, this.n = this.p = null;
        }
        function o(t3, e3, r3, o2, l) {
          var u, c, f2 = [], h = [];
          if (t3.forEach(function(t4) {
            if (!((e4 = t4.length - 1) <= 0)) {
              var e4, r4, o3 = t4[0], s2 = t4[e4];
              if ((0, n2.Z)(o3, s2)) {
                if (!o3[2] && !s2[2]) {
                  for (l.lineStart(), u = 0; u < e4; ++u)
                    l.point((o3 = t4[u])[0], o3[1]);
                  return void l.lineEnd();
                }
                s2[0] += 2 * i.Ho;
              }
              f2.push(r4 = new a(o3, t4, null, true)), h.push(r4.o = new a(o3, null, r4, false)), f2.push(r4 = new a(s2, t4, null, false)), h.push(r4.o = new a(s2, null, r4, true));
            }
          }), f2.length) {
            for (h.sort(e3), s(f2), s(h), u = 0, c = h.length; u < c; ++u)
              h[u].e = r3 = !r3;
            for (var p2, d2, v = f2[0]; ; ) {
              for (var g2 = v, y = true; g2.v; )
                if ((g2 = g2.n) === v)
                  return;
              p2 = g2.z, l.lineStart();
              do {
                if (g2.v = g2.o.v = true, g2.e) {
                  if (y)
                    for (u = 0, c = p2.length; u < c; ++u)
                      l.point((d2 = p2[u])[0], d2[1]);
                  else
                    o2(g2.x, g2.n.x, 1, l);
                  g2 = g2.n;
                } else {
                  if (y)
                    for (p2 = g2.p.z, u = p2.length - 1; u >= 0; --u)
                      l.point((d2 = p2[u])[0], d2[1]);
                  else
                    o2(g2.x, g2.p.x, -1, l);
                  g2 = g2.p;
                }
                p2 = (g2 = g2.o).z, y = !y;
              } while (!g2.v);
              l.lineEnd();
            }
          }
        }
        function s(t3) {
          if (e3 = t3.length) {
            for (var e3, r3, n3 = 0, i2 = t3[0]; ++n3 < e3; )
              i2.n = r3 = t3[n3], r3.p = i2, i2 = r3;
            i2.n = r3 = t3[0], r3.p = i2;
          }
        }
      }, 96059: function(t2, e2, r2) {
        function n2(t3, e3) {
          function r3(r4, n3) {
            return r4 = t3(r4, n3), e3(r4[0], r4[1]);
          }
          return t3.invert && e3.invert && (r3.invert = function(r4, n3) {
            return (r4 = e3.invert(r4, n3)) && t3.invert(r4[0], r4[1]);
          }), r3;
        }
        r2.d(e2, { Z: function() {
          return n2;
        } });
      }, 8593: function(t2, e2, r2) {
        function n2(t3) {
          return t3;
        }
        r2.d(e2, { Z: function() {
          return n2;
        } });
      }, 27362: function(t2, e2, r2) {
        r2.r(e2), r2.d(e2, { geoAlbers: function() {
          return Gt;
        }, geoAlbersUsa: function() {
          return Yt;
        }, geoArea: function() {
          return n2.ZP;
        }, geoAzimuthalEqualArea: function() {
          return Wt.Z;
        }, geoAzimuthalEqualAreaRaw: function() {
          return Wt.l;
        }, geoAzimuthalEquidistant: function() {
          return Xt.Z;
        }, geoAzimuthalEquidistantRaw: function() {
          return Xt.N;
        }, geoBounds: function() {
          return i.Z;
        }, geoCentroid: function() {
          return a.Z;
        }, geoCircle: function() {
          return o.Z;
        }, geoClipAntimeridian: function() {
          return s.Z;
        }, geoClipCircle: function() {
          return l.Z;
        }, geoClipExtent: function() {
          return c;
        }, geoClipRectangle: function() {
          return u.Z;
        }, geoConicConformal: function() {
          return re;
        }, geoConicConformalRaw: function() {
          return ee;
        }, geoConicEqualArea: function() {
          return qt;
        }, geoConicEqualAreaRaw: function() {
          return Ht;
        }, geoConicEquidistant: function() {
          return ae;
        }, geoConicEquidistantRaw: function() {
          return ie;
        }, geoContains: function() {
          return R;
        }, geoDistance: function() {
          return S;
        }, geoEqualEarth: function() {
          return he;
        }, geoEqualEarthRaw: function() {
          return fe;
        }, geoEquirectangular: function() {
          return ne.Z;
        }, geoEquirectangularRaw: function() {
          return ne.k;
        }, geoGnomonic: function() {
          return pe.Z;
        }, geoGnomonicRaw: function() {
          return pe.M;
        }, geoGraticule: function() {
          return j;
        }, geoGraticule10: function() {
          return U;
        }, geoIdentity: function() {
          return ve;
        }, geoInterpolate: function() {
          return Z.Z;
        }, geoLength: function() {
          return k;
        }, geoMercator: function() {
          return $t;
        }, geoMercatorRaw: function() {
          return Kt;
        }, geoNaturalEarth1: function() {
          return ge.Z;
        }, geoNaturalEarth1Raw: function() {
          return ge.K;
        }, geoOrthographic: function() {
          return ye.Z;
        }, geoOrthographicRaw: function() {
          return ye.I;
        }, geoPath: function() {
          return jt;
        }, geoProjection: function() {
          return Ut.Z;
        }, geoProjectionMutator: function() {
          return Ut.r;
        }, geoRotation: function() {
          return Jt.Z;
        }, geoStereographic: function() {
          return be;
        }, geoStereographicRaw: function() {
          return xe;
        }, geoStream: function() {
          return m2.Z;
        }, geoTransform: function() {
          return de.Z;
        }, geoTransverseMercator: function() {
          return we;
        }, geoTransverseMercatorRaw: function() {
          return _e;
        } });
        var n2 = r2(97860), i = r2(77338), a = r2(66624), o = r2(7613), s = r2(87070), l = r2(1457), u = r2(87605);
        function c() {
          var t3, e3, r3, n3 = 0, i2 = 0, a2 = 960, o2 = 500;
          return r3 = { stream: function(r4) {
            return t3 && e3 === r4 ? t3 : t3 = (0, u.Z)(n3, i2, a2, o2)(e3 = r4);
          }, extent: function(s2) {
            return arguments.length ? (n3 = +s2[0][0], i2 = +s2[0][1], a2 = +s2[1][0], o2 = +s2[1][1], t3 = e3 = null, r3) : [[n3, i2], [a2, o2]];
          } };
        }
        var f2, h, p2, d2 = r2(23071), v = r2(33940), g2 = r2(39695), y = r2(73182), m2 = r2(72736), x = (0, v.Z)(), b = { sphere: y.Z, point: y.Z, lineStart: function() {
          b.point = w2, b.lineEnd = _;
        }, lineEnd: y.Z, polygonStart: y.Z, polygonEnd: y.Z };
        function _() {
          b.point = b.lineEnd = y.Z;
        }
        function w2(t3, e3) {
          t3 *= g2.uR, e3 *= g2.uR, f2 = t3, h = (0, g2.O$)(e3), p2 = (0, g2.mC)(e3), b.point = T;
        }
        function T(t3, e3) {
          t3 *= g2.uR, e3 *= g2.uR;
          var r3 = (0, g2.O$)(e3), n3 = (0, g2.mC)(e3), i2 = (0, g2.Wn)(t3 - f2), a2 = (0, g2.mC)(i2), o2 = n3 * (0, g2.O$)(i2), s2 = p2 * r3 - h * n3 * a2, l2 = h * r3 + p2 * n3 * a2;
          x.add((0, g2.fv)((0, g2._b)(o2 * o2 + s2 * s2), l2)), f2 = t3, h = r3, p2 = n3;
        }
        function k(t3) {
          return x.reset(), (0, m2.Z)(t3, b), +x;
        }
        var A = [null, null], M = { type: "LineString", coordinates: A };
        function S(t3, e3) {
          return A[0] = t3, A[1] = e3, k(M);
        }
        var E = { Feature: function(t3, e3) {
          return C(t3.geometry, e3);
        }, FeatureCollection: function(t3, e3) {
          for (var r3 = t3.features, n3 = -1, i2 = r3.length; ++n3 < i2; )
            if (C(r3[n3].geometry, e3))
              return true;
          return false;
        } }, L = { Sphere: function() {
          return true;
        }, Point: function(t3, e3) {
          return P(t3.coordinates, e3);
        }, MultiPoint: function(t3, e3) {
          for (var r3 = t3.coordinates, n3 = -1, i2 = r3.length; ++n3 < i2; )
            if (P(r3[n3], e3))
              return true;
          return false;
        }, LineString: function(t3, e3) {
          return O(t3.coordinates, e3);
        }, MultiLineString: function(t3, e3) {
          for (var r3 = t3.coordinates, n3 = -1, i2 = r3.length; ++n3 < i2; )
            if (O(r3[n3], e3))
              return true;
          return false;
        }, Polygon: function(t3, e3) {
          return I(t3.coordinates, e3);
        }, MultiPolygon: function(t3, e3) {
          for (var r3 = t3.coordinates, n3 = -1, i2 = r3.length; ++n3 < i2; )
            if (I(r3[n3], e3))
              return true;
          return false;
        }, GeometryCollection: function(t3, e3) {
          for (var r3 = t3.geometries, n3 = -1, i2 = r3.length; ++n3 < i2; )
            if (C(r3[n3], e3))
              return true;
          return false;
        } };
        function C(t3, e3) {
          return !(!t3 || !L.hasOwnProperty(t3.type)) && L[t3.type](t3, e3);
        }
        function P(t3, e3) {
          return 0 === S(t3, e3);
        }
        function O(t3, e3) {
          for (var r3, n3, i2, a2 = 0, o2 = t3.length; a2 < o2; a2++) {
            if (0 === (n3 = S(t3[a2], e3)))
              return true;
            if (a2 > 0 && (i2 = S(t3[a2], t3[a2 - 1])) > 0 && r3 <= i2 && n3 <= i2 && (r3 + n3 - i2) * (1 - Math.pow((r3 - n3) / i2, 2)) < g2.aW * i2)
              return true;
            r3 = n3;
          }
          return false;
        }
        function I(t3, e3) {
          return !!(0, d2.Z)(t3.map(D), z(e3));
        }
        function D(t3) {
          return (t3 = t3.map(z)).pop(), t3;
        }
        function z(t3) {
          return [t3[0] * g2.uR, t3[1] * g2.uR];
        }
        function R(t3, e3) {
          return (t3 && E.hasOwnProperty(t3.type) ? E[t3.type] : C)(t3, e3);
        }
        var F = r2(33064);
        function B(t3, e3, r3) {
          var n3 = (0, F.w6)(t3, e3 - g2.Ho, r3).concat(e3);
          return function(t4) {
            return n3.map(function(e4) {
              return [t4, e4];
            });
          };
        }
        function N(t3, e3, r3) {
          var n3 = (0, F.w6)(t3, e3 - g2.Ho, r3).concat(e3);
          return function(t4) {
            return n3.map(function(e4) {
              return [e4, t4];
            });
          };
        }
        function j() {
          var t3, e3, r3, n3, i2, a2, o2, s2, l2, u2, c2, f3, h2 = 10, p3 = h2, d3 = 90, v2 = 360, y2 = 2.5;
          function m3() {
            return { type: "MultiLineString", coordinates: x2() };
          }
          function x2() {
            return (0, F.w6)((0, g2.mD)(n3 / d3) * d3, r3, d3).map(c2).concat((0, F.w6)((0, g2.mD)(s2 / v2) * v2, o2, v2).map(f3)).concat((0, F.w6)((0, g2.mD)(e3 / h2) * h2, t3, h2).filter(function(t4) {
              return (0, g2.Wn)(t4 % d3) > g2.Ho;
            }).map(l2)).concat((0, F.w6)((0, g2.mD)(a2 / p3) * p3, i2, p3).filter(function(t4) {
              return (0, g2.Wn)(t4 % v2) > g2.Ho;
            }).map(u2));
          }
          return m3.lines = function() {
            return x2().map(function(t4) {
              return { type: "LineString", coordinates: t4 };
            });
          }, m3.outline = function() {
            return { type: "Polygon", coordinates: [c2(n3).concat(f3(o2).slice(1), c2(r3).reverse().slice(1), f3(s2).reverse().slice(1))] };
          }, m3.extent = function(t4) {
            return arguments.length ? m3.extentMajor(t4).extentMinor(t4) : m3.extentMinor();
          }, m3.extentMajor = function(t4) {
            return arguments.length ? (n3 = +t4[0][0], r3 = +t4[1][0], s2 = +t4[0][1], o2 = +t4[1][1], n3 > r3 && (t4 = n3, n3 = r3, r3 = t4), s2 > o2 && (t4 = s2, s2 = o2, o2 = t4), m3.precision(y2)) : [[n3, s2], [r3, o2]];
          }, m3.extentMinor = function(r4) {
            return arguments.length ? (e3 = +r4[0][0], t3 = +r4[1][0], a2 = +r4[0][1], i2 = +r4[1][1], e3 > t3 && (r4 = e3, e3 = t3, t3 = r4), a2 > i2 && (r4 = a2, a2 = i2, i2 = r4), m3.precision(y2)) : [[e3, a2], [t3, i2]];
          }, m3.step = function(t4) {
            return arguments.length ? m3.stepMajor(t4).stepMinor(t4) : m3.stepMinor();
          }, m3.stepMajor = function(t4) {
            return arguments.length ? (d3 = +t4[0], v2 = +t4[1], m3) : [d3, v2];
          }, m3.stepMinor = function(t4) {
            return arguments.length ? (h2 = +t4[0], p3 = +t4[1], m3) : [h2, p3];
          }, m3.precision = function(h3) {
            return arguments.length ? (y2 = +h3, l2 = B(a2, i2, 90), u2 = N(e3, t3, y2), c2 = B(s2, o2, 90), f3 = N(n3, r3, y2), m3) : y2;
          }, m3.extentMajor([[-180, -90 + g2.Ho], [180, 90 - g2.Ho]]).extentMinor([[-180, -80 - g2.Ho], [180, 80 + g2.Ho]]);
        }
        function U() {
          return j()();
        }
        var V, H, q2, G, Z = r2(83074), Y = r2(8593), W = (0, v.Z)(), X = (0, v.Z)(), J = { point: y.Z, lineStart: y.Z, lineEnd: y.Z, polygonStart: function() {
          J.lineStart = K, J.lineEnd = tt;
        }, polygonEnd: function() {
          J.lineStart = J.lineEnd = J.point = y.Z, W.add((0, g2.Wn)(X)), X.reset();
        }, result: function() {
          var t3 = W / 2;
          return W.reset(), t3;
        } };
        function K() {
          J.point = $;
        }
        function $(t3, e3) {
          J.point = Q, V = q2 = t3, H = G = e3;
        }
        function Q(t3, e3) {
          X.add(G * t3 - q2 * e3), q2 = t3, G = e3;
        }
        function tt() {
          Q(V, H);
        }
        var et, rt, nt, it, at = J, ot = r2(3559), st = 0, lt = 0, ut = 0, ct = 0, ft = 0, ht = 0, pt = 0, dt = 0, vt = 0, gt = { point: yt, lineStart: mt, lineEnd: _t, polygonStart: function() {
          gt.lineStart = wt, gt.lineEnd = Tt;
        }, polygonEnd: function() {
          gt.point = yt, gt.lineStart = mt, gt.lineEnd = _t;
        }, result: function() {
          var t3 = vt ? [pt / vt, dt / vt] : ht ? [ct / ht, ft / ht] : ut ? [st / ut, lt / ut] : [NaN, NaN];
          return st = lt = ut = ct = ft = ht = pt = dt = vt = 0, t3;
        } };
        function yt(t3, e3) {
          st += t3, lt += e3, ++ut;
        }
        function mt() {
          gt.point = xt;
        }
        function xt(t3, e3) {
          gt.point = bt, yt(nt = t3, it = e3);
        }
        function bt(t3, e3) {
          var r3 = t3 - nt, n3 = e3 - it, i2 = (0, g2._b)(r3 * r3 + n3 * n3);
          ct += i2 * (nt + t3) / 2, ft += i2 * (it + e3) / 2, ht += i2, yt(nt = t3, it = e3);
        }
        function _t() {
          gt.point = yt;
        }
        function wt() {
          gt.point = kt;
        }
        function Tt() {
          At(et, rt);
        }
        function kt(t3, e3) {
          gt.point = At, yt(et = nt = t3, rt = it = e3);
        }
        function At(t3, e3) {
          var r3 = t3 - nt, n3 = e3 - it, i2 = (0, g2._b)(r3 * r3 + n3 * n3);
          ct += i2 * (nt + t3) / 2, ft += i2 * (it + e3) / 2, ht += i2, pt += (i2 = it * t3 - nt * e3) * (nt + t3), dt += i2 * (it + e3), vt += 3 * i2, yt(nt = t3, it = e3);
        }
        var Mt = gt;
        function St(t3) {
          this._context = t3;
        }
        St.prototype = { _radius: 4.5, pointRadius: function(t3) {
          return this._radius = t3, this;
        }, polygonStart: function() {
          this._line = 0;
        }, polygonEnd: function() {
          this._line = NaN;
        }, lineStart: function() {
          this._point = 0;
        }, lineEnd: function() {
          0 === this._line && this._context.closePath(), this._point = NaN;
        }, point: function(t3, e3) {
          switch (this._point) {
            case 0:
              this._context.moveTo(t3, e3), this._point = 1;
              break;
            case 1:
              this._context.lineTo(t3, e3);
              break;
            default:
              this._context.moveTo(t3 + this._radius, e3), this._context.arc(t3, e3, this._radius, 0, g2.BZ);
          }
        }, result: y.Z };
        var Et, Lt, Ct, Pt, Ot, It = (0, v.Z)(), Dt = { point: y.Z, lineStart: function() {
          Dt.point = zt;
        }, lineEnd: function() {
          Et && Rt(Lt, Ct), Dt.point = y.Z;
        }, polygonStart: function() {
          Et = true;
        }, polygonEnd: function() {
          Et = null;
        }, result: function() {
          var t3 = +It;
          return It.reset(), t3;
        } };
        function zt(t3, e3) {
          Dt.point = Rt, Lt = Pt = t3, Ct = Ot = e3;
        }
        function Rt(t3, e3) {
          Pt -= t3, Ot -= e3, It.add((0, g2._b)(Pt * Pt + Ot * Ot)), Pt = t3, Ot = e3;
        }
        var Ft = Dt;
        function Bt() {
          this._string = [];
        }
        function Nt(t3) {
          return "m0," + t3 + "a" + t3 + "," + t3 + " 0 1,1 0," + -2 * t3 + "a" + t3 + "," + t3 + " 0 1,1 0," + 2 * t3 + "z";
        }
        function jt(t3, e3) {
          var r3, n3, i2 = 4.5;
          function a2(t4) {
            return t4 && ("function" == typeof i2 && n3.pointRadius(+i2.apply(this, arguments)), (0, m2.Z)(t4, r3(n3))), n3.result();
          }
          return a2.area = function(t4) {
            return (0, m2.Z)(t4, r3(at)), at.result();
          }, a2.measure = function(t4) {
            return (0, m2.Z)(t4, r3(Ft)), Ft.result();
          }, a2.bounds = function(t4) {
            return (0, m2.Z)(t4, r3(ot.Z)), ot.Z.result();
          }, a2.centroid = function(t4) {
            return (0, m2.Z)(t4, r3(Mt)), Mt.result();
          }, a2.projection = function(e4) {
            return arguments.length ? (r3 = null == e4 ? (t3 = null, Y.Z) : (t3 = e4).stream, a2) : t3;
          }, a2.context = function(t4) {
            return arguments.length ? (n3 = null == t4 ? (e3 = null, new Bt()) : new St(e3 = t4), "function" != typeof i2 && n3.pointRadius(i2), a2) : e3;
          }, a2.pointRadius = function(t4) {
            return arguments.length ? (i2 = "function" == typeof t4 ? t4 : (n3.pointRadius(+t4), +t4), a2) : i2;
          }, a2.projection(t3).context(e3);
        }
        Bt.prototype = { _radius: 4.5, _circle: Nt(4.5), pointRadius: function(t3) {
          return (t3 = +t3) !== this._radius && (this._radius = t3, this._circle = null), this;
        }, polygonStart: function() {
          this._line = 0;
        }, polygonEnd: function() {
          this._line = NaN;
        }, lineStart: function() {
          this._point = 0;
        }, lineEnd: function() {
          0 === this._line && this._string.push("Z"), this._point = NaN;
        }, point: function(t3, e3) {
          switch (this._point) {
            case 0:
              this._string.push("M", t3, ",", e3), this._point = 1;
              break;
            case 1:
              this._string.push("L", t3, ",", e3);
              break;
            default:
              null == this._circle && (this._circle = Nt(this._radius)), this._string.push("M", t3, ",", e3, this._circle);
          }
        }, result: function() {
          if (this._string.length) {
            var t3 = this._string.join("");
            return this._string = [], t3;
          }
          return null;
        } };
        var Ut = r2(15002);
        function Vt(t3) {
          var e3 = 0, r3 = g2.pi / 3, n3 = (0, Ut.r)(t3), i2 = n3(e3, r3);
          return i2.parallels = function(t4) {
            return arguments.length ? n3(e3 = t4[0] * g2.uR, r3 = t4[1] * g2.uR) : [e3 * g2.RW, r3 * g2.RW];
          }, i2;
        }
        function Ht(t3, e3) {
          var r3 = (0, g2.O$)(t3), n3 = (r3 + (0, g2.O$)(e3)) / 2;
          if ((0, g2.Wn)(n3) < g2.Ho)
            return function(t4) {
              var e4 = (0, g2.mC)(t4);
              function r4(t5, r5) {
                return [t5 * e4, (0, g2.O$)(r5) / e4];
              }
              return r4.invert = function(t5, r5) {
                return [t5 / e4, (0, g2.ZR)(r5 * e4)];
              }, r4;
            }(t3);
          var i2 = 1 + r3 * (2 * n3 - r3), a2 = (0, g2._b)(i2) / n3;
          function o2(t4, e4) {
            var r4 = (0, g2._b)(i2 - 2 * n3 * (0, g2.O$)(e4)) / n3;
            return [r4 * (0, g2.O$)(t4 *= n3), a2 - r4 * (0, g2.mC)(t4)];
          }
          return o2.invert = function(t4, e4) {
            var r4 = a2 - e4, o3 = (0, g2.fv)(t4, (0, g2.Wn)(r4)) * (0, g2.Xx)(r4);
            return r4 * n3 < 0 && (o3 -= g2.pi * (0, g2.Xx)(t4) * (0, g2.Xx)(r4)), [o3 / n3, (0, g2.ZR)((i2 - (t4 * t4 + r4 * r4) * n3 * n3) / (2 * n3))];
          }, o2;
        }
        function qt() {
          return Vt(Ht).scale(155.424).center([0, 33.6442]);
        }
        function Gt() {
          return qt().parallels([29.5, 45.5]).scale(1070).translate([480, 250]).rotate([96, 0]).center([-0.6, 38.7]);
        }
        var Zt = r2(47589);
        function Yt() {
          var t3, e3, r3, n3, i2, a2, o2 = Gt(), s2 = qt().rotate([154, 0]).center([-2, 58.5]).parallels([55, 65]), l2 = qt().rotate([157, 0]).center([-3, 19.9]).parallels([8, 18]), u2 = { point: function(t4, e4) {
            a2 = [t4, e4];
          } };
          function c2(t4) {
            var e4 = t4[0], o3 = t4[1];
            return a2 = null, r3.point(e4, o3), a2 || (n3.point(e4, o3), a2) || (i2.point(e4, o3), a2);
          }
          function f3() {
            return t3 = e3 = null, c2;
          }
          return c2.invert = function(t4) {
            var e4 = o2.scale(), r4 = o2.translate(), n4 = (t4[0] - r4[0]) / e4, i3 = (t4[1] - r4[1]) / e4;
            return (i3 >= 0.12 && i3 < 0.234 && n4 >= -0.425 && n4 < -0.214 ? s2 : i3 >= 0.166 && i3 < 0.234 && n4 >= -0.214 && n4 < -0.115 ? l2 : o2).invert(t4);
          }, c2.stream = function(r4) {
            return t3 && e3 === r4 ? t3 : (n4 = [o2.stream(e3 = r4), s2.stream(r4), l2.stream(r4)], i3 = n4.length, t3 = { point: function(t4, e4) {
              for (var r5 = -1; ++r5 < i3; )
                n4[r5].point(t4, e4);
            }, sphere: function() {
              for (var t4 = -1; ++t4 < i3; )
                n4[t4].sphere();
            }, lineStart: function() {
              for (var t4 = -1; ++t4 < i3; )
                n4[t4].lineStart();
            }, lineEnd: function() {
              for (var t4 = -1; ++t4 < i3; )
                n4[t4].lineEnd();
            }, polygonStart: function() {
              for (var t4 = -1; ++t4 < i3; )
                n4[t4].polygonStart();
            }, polygonEnd: function() {
              for (var t4 = -1; ++t4 < i3; )
                n4[t4].polygonEnd();
            } });
            var n4, i3;
          }, c2.precision = function(t4) {
            return arguments.length ? (o2.precision(t4), s2.precision(t4), l2.precision(t4), f3()) : o2.precision();
          }, c2.scale = function(t4) {
            return arguments.length ? (o2.scale(t4), s2.scale(0.35 * t4), l2.scale(t4), c2.translate(o2.translate())) : o2.scale();
          }, c2.translate = function(t4) {
            if (!arguments.length)
              return o2.translate();
            var e4 = o2.scale(), a3 = +t4[0], c3 = +t4[1];
            return r3 = o2.translate(t4).clipExtent([[a3 - 0.455 * e4, c3 - 0.238 * e4], [a3 + 0.455 * e4, c3 + 0.238 * e4]]).stream(u2), n3 = s2.translate([a3 - 0.307 * e4, c3 + 0.201 * e4]).clipExtent([[a3 - 0.425 * e4 + g2.Ho, c3 + 0.12 * e4 + g2.Ho], [a3 - 0.214 * e4 - g2.Ho, c3 + 0.234 * e4 - g2.Ho]]).stream(u2), i2 = l2.translate([a3 - 0.205 * e4, c3 + 0.212 * e4]).clipExtent([[a3 - 0.214 * e4 + g2.Ho, c3 + 0.166 * e4 + g2.Ho], [a3 - 0.115 * e4 - g2.Ho, c3 + 0.234 * e4 - g2.Ho]]).stream(u2), f3();
          }, c2.fitExtent = function(t4, e4) {
            return (0, Zt.qg)(c2, t4, e4);
          }, c2.fitSize = function(t4, e4) {
            return (0, Zt.mF)(c2, t4, e4);
          }, c2.fitWidth = function(t4, e4) {
            return (0, Zt.V6)(c2, t4, e4);
          }, c2.fitHeight = function(t4, e4) {
            return (0, Zt.rf)(c2, t4, e4);
          }, c2.scale(1070);
        }
        var Wt = r2(12956), Xt = r2(17889), Jt = r2(49386);
        function Kt(t3, e3) {
          return [t3, (0, g2.cM)((0, g2.OR)((g2.ou + e3) / 2))];
        }
        function $t() {
          return Qt(Kt).scale(961 / g2.BZ);
        }
        function Qt(t3) {
          var e3, r3, n3, i2 = (0, Ut.Z)(t3), a2 = i2.center, o2 = i2.scale, s2 = i2.translate, l2 = i2.clipExtent, u2 = null;
          function c2() {
            var a3 = g2.pi * o2(), s3 = i2((0, Jt.Z)(i2.rotate()).invert([0, 0]));
            return l2(null == u2 ? [[s3[0] - a3, s3[1] - a3], [s3[0] + a3, s3[1] + a3]] : t3 === Kt ? [[Math.max(s3[0] - a3, u2), e3], [Math.min(s3[0] + a3, r3), n3]] : [[u2, Math.max(s3[1] - a3, e3)], [r3, Math.min(s3[1] + a3, n3)]]);
          }
          return i2.scale = function(t4) {
            return arguments.length ? (o2(t4), c2()) : o2();
          }, i2.translate = function(t4) {
            return arguments.length ? (s2(t4), c2()) : s2();
          }, i2.center = function(t4) {
            return arguments.length ? (a2(t4), c2()) : a2();
          }, i2.clipExtent = function(t4) {
            return arguments.length ? (null == t4 ? u2 = e3 = r3 = n3 = null : (u2 = +t4[0][0], e3 = +t4[0][1], r3 = +t4[1][0], n3 = +t4[1][1]), c2()) : null == u2 ? null : [[u2, e3], [r3, n3]];
          }, c2();
        }
        function te(t3) {
          return (0, g2.OR)((g2.ou + t3) / 2);
        }
        function ee(t3, e3) {
          var r3 = (0, g2.mC)(t3), n3 = t3 === e3 ? (0, g2.O$)(t3) : (0, g2.cM)(r3 / (0, g2.mC)(e3)) / (0, g2.cM)(te(e3) / te(t3)), i2 = r3 * (0, g2.sQ)(te(t3), n3) / n3;
          if (!n3)
            return Kt;
          function a2(t4, e4) {
            i2 > 0 ? e4 < -g2.ou + g2.Ho && (e4 = -g2.ou + g2.Ho) : e4 > g2.ou - g2.Ho && (e4 = g2.ou - g2.Ho);
            var r4 = i2 / (0, g2.sQ)(te(e4), n3);
            return [r4 * (0, g2.O$)(n3 * t4), i2 - r4 * (0, g2.mC)(n3 * t4)];
          }
          return a2.invert = function(t4, e4) {
            var r4 = i2 - e4, a3 = (0, g2.Xx)(n3) * (0, g2._b)(t4 * t4 + r4 * r4), o2 = (0, g2.fv)(t4, (0, g2.Wn)(r4)) * (0, g2.Xx)(r4);
            return r4 * n3 < 0 && (o2 -= g2.pi * (0, g2.Xx)(t4) * (0, g2.Xx)(r4)), [o2 / n3, 2 * (0, g2.z4)((0, g2.sQ)(i2 / a3, 1 / n3)) - g2.ou];
          }, a2;
        }
        function re() {
          return Vt(ee).scale(109.5).parallels([30, 30]);
        }
        Kt.invert = function(t3, e3) {
          return [t3, 2 * (0, g2.z4)((0, g2.Qq)(e3)) - g2.ou];
        };
        var ne = r2(97492);
        function ie(t3, e3) {
          var r3 = (0, g2.mC)(t3), n3 = t3 === e3 ? (0, g2.O$)(t3) : (r3 - (0, g2.mC)(e3)) / (e3 - t3), i2 = r3 / n3 + t3;
          if ((0, g2.Wn)(n3) < g2.Ho)
            return ne.k;
          function a2(t4, e4) {
            var r4 = i2 - e4, a3 = n3 * t4;
            return [r4 * (0, g2.O$)(a3), i2 - r4 * (0, g2.mC)(a3)];
          }
          return a2.invert = function(t4, e4) {
            var r4 = i2 - e4, a3 = (0, g2.fv)(t4, (0, g2.Wn)(r4)) * (0, g2.Xx)(r4);
            return r4 * n3 < 0 && (a3 -= g2.pi * (0, g2.Xx)(t4) * (0, g2.Xx)(r4)), [a3 / n3, i2 - (0, g2.Xx)(n3) * (0, g2._b)(t4 * t4 + r4 * r4)];
          }, a2;
        }
        function ae() {
          return Vt(ie).scale(131.154).center([0, 13.9389]);
        }
        var oe = 1.340264, se = -0.081106, le = 893e-6, ue = 3796e-6, ce = (0, g2._b)(3) / 2;
        function fe(t3, e3) {
          var r3 = (0, g2.ZR)(ce * (0, g2.O$)(e3)), n3 = r3 * r3, i2 = n3 * n3 * n3;
          return [t3 * (0, g2.mC)(r3) / (ce * (oe + 3 * se * n3 + i2 * (7 * le + 9 * ue * n3))), r3 * (oe + se * n3 + i2 * (le + ue * n3))];
        }
        function he() {
          return (0, Ut.Z)(fe).scale(177.158);
        }
        fe.invert = function(t3, e3) {
          for (var r3, n3 = e3, i2 = n3 * n3, a2 = i2 * i2 * i2, o2 = 0; o2 < 12 && (a2 = (i2 = (n3 -= r3 = (n3 * (oe + se * i2 + a2 * (le + ue * i2)) - e3) / (oe + 3 * se * i2 + a2 * (7 * le + 9 * ue * i2))) * n3) * i2 * i2, !((0, g2.Wn)(r3) < g2.aW)); ++o2)
            ;
          return [ce * t3 * (oe + 3 * se * i2 + a2 * (7 * le + 9 * ue * i2)) / (0, g2.mC)(n3), (0, g2.ZR)((0, g2.O$)(n3) / ce)];
        };
        var pe = r2(98936), de = r2(64684);
        function ve() {
          var t3, e3, r3, n3, i2, a2, o2, s2 = 1, l2 = 0, c2 = 0, f3 = 1, h2 = 1, p3 = 0, d3 = null, v2 = 1, y2 = 1, m3 = (0, de.l)({ point: function(t4, e4) {
            var r4 = _2([t4, e4]);
            this.stream.point(r4[0], r4[1]);
          } }), x2 = Y.Z;
          function b2() {
            return v2 = s2 * f3, y2 = s2 * h2, a2 = o2 = null, _2;
          }
          function _2(r4) {
            var n4 = r4[0] * v2, i3 = r4[1] * y2;
            if (p3) {
              var a3 = i3 * t3 - n4 * e3;
              n4 = n4 * t3 + i3 * e3, i3 = a3;
            }
            return [n4 + l2, i3 + c2];
          }
          return _2.invert = function(r4) {
            var n4 = r4[0] - l2, i3 = r4[1] - c2;
            if (p3) {
              var a3 = i3 * t3 + n4 * e3;
              n4 = n4 * t3 - i3 * e3, i3 = a3;
            }
            return [n4 / v2, i3 / y2];
          }, _2.stream = function(t4) {
            return a2 && o2 === t4 ? a2 : a2 = m3(x2(o2 = t4));
          }, _2.postclip = function(t4) {
            return arguments.length ? (x2 = t4, d3 = r3 = n3 = i2 = null, b2()) : x2;
          }, _2.clipExtent = function(t4) {
            return arguments.length ? (x2 = null == t4 ? (d3 = r3 = n3 = i2 = null, Y.Z) : (0, u.Z)(d3 = +t4[0][0], r3 = +t4[0][1], n3 = +t4[1][0], i2 = +t4[1][1]), b2()) : null == d3 ? null : [[d3, r3], [n3, i2]];
          }, _2.scale = function(t4) {
            return arguments.length ? (s2 = +t4, b2()) : s2;
          }, _2.translate = function(t4) {
            return arguments.length ? (l2 = +t4[0], c2 = +t4[1], b2()) : [l2, c2];
          }, _2.angle = function(r4) {
            return arguments.length ? (p3 = r4 % 360 * g2.uR, e3 = (0, g2.O$)(p3), t3 = (0, g2.mC)(p3), b2()) : p3 * g2.RW;
          }, _2.reflectX = function(t4) {
            return arguments.length ? (f3 = t4 ? -1 : 1, b2()) : f3 < 0;
          }, _2.reflectY = function(t4) {
            return arguments.length ? (h2 = t4 ? -1 : 1, b2()) : h2 < 0;
          }, _2.fitExtent = function(t4, e4) {
            return (0, Zt.qg)(_2, t4, e4);
          }, _2.fitSize = function(t4, e4) {
            return (0, Zt.mF)(_2, t4, e4);
          }, _2.fitWidth = function(t4, e4) {
            return (0, Zt.V6)(_2, t4, e4);
          }, _2.fitHeight = function(t4, e4) {
            return (0, Zt.rf)(_2, t4, e4);
          }, _2;
        }
        var ge = r2(26867), ye = r2(57962), me = r2(25382);
        function xe(t3, e3) {
          var r3 = (0, g2.mC)(e3), n3 = 1 + (0, g2.mC)(t3) * r3;
          return [r3 * (0, g2.O$)(t3) / n3, (0, g2.O$)(e3) / n3];
        }
        function be() {
          return (0, Ut.Z)(xe).scale(250).clipAngle(142);
        }
        function _e(t3, e3) {
          return [(0, g2.cM)((0, g2.OR)((g2.ou + e3) / 2)), -t3];
        }
        function we() {
          var t3 = Qt(_e), e3 = t3.center, r3 = t3.rotate;
          return t3.center = function(t4) {
            return arguments.length ? e3([-t4[1], t4[0]]) : [(t4 = e3())[1], -t4[0]];
          }, t3.rotate = function(t4) {
            return arguments.length ? r3([t4[0], t4[1], t4.length > 2 ? t4[2] + 90 : 90]) : [(t4 = r3())[0], t4[1], t4[2] - 90];
          }, r3([0, 0, 90]).scale(159.155);
        }
        xe.invert = (0, me.O)(function(t3) {
          return 2 * (0, g2.z4)(t3);
        }), _e.invert = function(t3, e3) {
          return [-e3, 2 * (0, g2.z4)((0, g2.Qq)(t3)) - g2.ou];
        };
      }, 83074: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return i;
        } });
        var n2 = r2(39695);
        function i(t3, e3) {
          var r3 = t3[0] * n2.uR, i2 = t3[1] * n2.uR, a = e3[0] * n2.uR, o = e3[1] * n2.uR, s = (0, n2.mC)(i2), l = (0, n2.O$)(i2), u = (0, n2.mC)(o), c = (0, n2.O$)(o), f2 = s * (0, n2.mC)(r3), h = s * (0, n2.O$)(r3), p2 = u * (0, n2.mC)(a), d2 = u * (0, n2.O$)(a), v = 2 * (0, n2.ZR)((0, n2._b)((0, n2.Jy)(o - i2) + s * u * (0, n2.Jy)(a - r3))), g2 = (0, n2.O$)(v), y = v ? function(t4) {
            var e4 = (0, n2.O$)(t4 *= v) / g2, r4 = (0, n2.O$)(v - t4) / g2, i3 = r4 * f2 + e4 * p2, a2 = r4 * h + e4 * d2, o2 = r4 * l + e4 * c;
            return [(0, n2.fv)(a2, i3) * n2.RW, (0, n2.fv)(o2, (0, n2._b)(i3 * i3 + a2 * a2)) * n2.RW];
          } : function() {
            return [r3 * n2.RW, i2 * n2.RW];
          };
          return y.distance = v, y;
        }
      }, 39695: function(t2, e2, r2) {
        r2.d(e2, { BZ: function() {
          return l;
        }, Ho: function() {
          return n2;
        }, Jy: function() {
          return A;
        }, Kh: function() {
          return T;
        }, O$: function() {
          return x;
        }, OR: function() {
          return w2;
        }, Qq: function() {
          return g2;
        }, RW: function() {
          return u;
        }, Wn: function() {
          return f2;
        }, Xx: function() {
          return b;
        }, ZR: function() {
          return k;
        }, _b: function() {
          return _;
        }, aW: function() {
          return i;
        }, cM: function() {
          return y;
        }, fv: function() {
          return p2;
        }, mC: function() {
          return d2;
        }, mD: function() {
          return v;
        }, ou: function() {
          return o;
        }, pi: function() {
          return a;
        }, pu: function() {
          return s;
        }, sQ: function() {
          return m2;
        }, uR: function() {
          return c;
        }, z4: function() {
          return h;
        } });
        var n2 = 1e-6, i = 1e-12, a = Math.PI, o = a / 2, s = a / 4, l = 2 * a, u = 180 / a, c = a / 180, f2 = Math.abs, h = Math.atan, p2 = Math.atan2, d2 = Math.cos, v = Math.ceil, g2 = Math.exp, y = Math.log, m2 = Math.pow, x = Math.sin, b = Math.sign || function(t3) {
          return t3 > 0 ? 1 : t3 < 0 ? -1 : 0;
        }, _ = Math.sqrt, w2 = Math.tan;
        function T(t3) {
          return t3 > 1 ? 0 : t3 < -1 ? a : Math.acos(t3);
        }
        function k(t3) {
          return t3 > 1 ? o : t3 < -1 ? -o : Math.asin(t3);
        }
        function A(t3) {
          return (t3 = x(t3 / 2)) * t3;
        }
      }, 73182: function(t2, e2, r2) {
        function n2() {
        }
        r2.d(e2, { Z: function() {
          return n2;
        } });
      }, 3559: function(t2, e2, r2) {
        var n2 = r2(73182), i = 1 / 0, a = i, o = -i, s = o, l = { point: function(t3, e3) {
          t3 < i && (i = t3), t3 > o && (o = t3), e3 < a && (a = e3), e3 > s && (s = e3);
        }, lineStart: n2.Z, lineEnd: n2.Z, polygonStart: n2.Z, polygonEnd: n2.Z, result: function() {
          var t3 = [[i, a], [o, s]];
          return o = s = -(a = i = 1 / 0), t3;
        } };
        e2.Z = l;
      }, 67108: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return i;
        } });
        var n2 = r2(39695);
        function i(t3, e3) {
          return (0, n2.Wn)(t3[0] - e3[0]) < n2.Ho && (0, n2.Wn)(t3[1] - e3[1]) < n2.Ho;
        }
      }, 23071: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return l;
        } });
        var n2 = r2(33940), i = r2(7620), a = r2(39695), o = (0, n2.Z)();
        function s(t3) {
          return (0, a.Wn)(t3[0]) <= a.pi ? t3[0] : (0, a.Xx)(t3[0]) * (((0, a.Wn)(t3[0]) + a.pi) % a.BZ - a.pi);
        }
        function l(t3, e3) {
          var r3 = s(e3), n3 = e3[1], l2 = (0, a.O$)(n3), u = [(0, a.O$)(r3), -(0, a.mC)(r3), 0], c = 0, f2 = 0;
          o.reset(), 1 === l2 ? n3 = a.ou + a.Ho : -1 === l2 && (n3 = -a.ou - a.Ho);
          for (var h = 0, p2 = t3.length; h < p2; ++h)
            if (v = (d2 = t3[h]).length)
              for (var d2, v, g2 = d2[v - 1], y = s(g2), m2 = g2[1] / 2 + a.pu, x = (0, a.O$)(m2), b = (0, a.mC)(m2), _ = 0; _ < v; ++_, y = T, x = A, b = M, g2 = w2) {
                var w2 = d2[_], T = s(w2), k = w2[1] / 2 + a.pu, A = (0, a.O$)(k), M = (0, a.mC)(k), S = T - y, E = S >= 0 ? 1 : -1, L = E * S, C = L > a.pi, P = x * A;
                if (o.add((0, a.fv)(P * E * (0, a.O$)(L), b * M + P * (0, a.mC)(L))), c += C ? S + E * a.BZ : S, C ^ y >= r3 ^ T >= r3) {
                  var O = (0, i.T5)((0, i.Og)(g2), (0, i.Og)(w2));
                  (0, i.iJ)(O);
                  var I = (0, i.T5)(u, O);
                  (0, i.iJ)(I);
                  var D = (C ^ S >= 0 ? -1 : 1) * (0, a.ZR)(I[2]);
                  (n3 > D || n3 === D && (O[0] || O[1])) && (f2 += C ^ S >= 0 ? 1 : -1);
                }
              }
          return (c < -a.Ho || c < a.Ho && o < -a.Ho) ^ 1 & f2;
        }
      }, 25382: function(t2, e2, r2) {
        r2.d(e2, { O: function() {
          return a;
        }, W: function() {
          return i;
        } });
        var n2 = r2(39695);
        function i(t3) {
          return function(e3, r3) {
            var i2 = (0, n2.mC)(e3), a2 = (0, n2.mC)(r3), o = t3(i2 * a2);
            return [o * a2 * (0, n2.O$)(e3), o * (0, n2.O$)(r3)];
          };
        }
        function a(t3) {
          return function(e3, r3) {
            var i2 = (0, n2._b)(e3 * e3 + r3 * r3), a2 = t3(i2), o = (0, n2.O$)(a2), s = (0, n2.mC)(a2);
            return [(0, n2.fv)(e3 * o, i2 * s), (0, n2.ZR)(i2 && r3 * o / i2)];
          };
        }
      }, 12956: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return s;
        }, l: function() {
          return o;
        } });
        var n2 = r2(39695), i = r2(25382), a = r2(15002), o = (0, i.W)(function(t3) {
          return (0, n2._b)(2 / (1 + t3));
        });
        function s() {
          return (0, a.Z)(o).scale(124.75).clipAngle(179.999);
        }
        o.invert = (0, i.O)(function(t3) {
          return 2 * (0, n2.ZR)(t3 / 2);
        });
      }, 17889: function(t2, e2, r2) {
        r2.d(e2, { N: function() {
          return o;
        }, Z: function() {
          return s;
        } });
        var n2 = r2(39695), i = r2(25382), a = r2(15002), o = (0, i.W)(function(t3) {
          return (t3 = (0, n2.Kh)(t3)) && t3 / (0, n2.O$)(t3);
        });
        function s() {
          return (0, a.Z)(o).scale(79.4188).clipAngle(179.999);
        }
        o.invert = (0, i.O)(function(t3) {
          return t3;
        });
      }, 97492: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return a;
        }, k: function() {
          return i;
        } });
        var n2 = r2(15002);
        function i(t3, e3) {
          return [t3, e3];
        }
        function a() {
          return (0, n2.Z)(i).scale(152.63);
        }
        i.invert = i;
      }, 47589: function(t2, e2, r2) {
        r2.d(e2, { V6: function() {
          return l;
        }, mF: function() {
          return s;
        }, qg: function() {
          return o;
        }, rf: function() {
          return u;
        } });
        var n2 = r2(72736), i = r2(3559);
        function a(t3, e3, r3) {
          var a2 = t3.clipExtent && t3.clipExtent();
          return t3.scale(150).translate([0, 0]), null != a2 && t3.clipExtent(null), (0, n2.Z)(r3, t3.stream(i.Z)), e3(i.Z.result()), null != a2 && t3.clipExtent(a2), t3;
        }
        function o(t3, e3, r3) {
          return a(t3, function(r4) {
            var n3 = e3[1][0] - e3[0][0], i2 = e3[1][1] - e3[0][1], a2 = Math.min(n3 / (r4[1][0] - r4[0][0]), i2 / (r4[1][1] - r4[0][1])), o2 = +e3[0][0] + (n3 - a2 * (r4[1][0] + r4[0][0])) / 2, s2 = +e3[0][1] + (i2 - a2 * (r4[1][1] + r4[0][1])) / 2;
            t3.scale(150 * a2).translate([o2, s2]);
          }, r3);
        }
        function s(t3, e3, r3) {
          return o(t3, [[0, 0], e3], r3);
        }
        function l(t3, e3, r3) {
          return a(t3, function(r4) {
            var n3 = +e3, i2 = n3 / (r4[1][0] - r4[0][0]), a2 = (n3 - i2 * (r4[1][0] + r4[0][0])) / 2, o2 = -i2 * r4[0][1];
            t3.scale(150 * i2).translate([a2, o2]);
          }, r3);
        }
        function u(t3, e3, r3) {
          return a(t3, function(r4) {
            var n3 = +e3, i2 = n3 / (r4[1][1] - r4[0][1]), a2 = -i2 * r4[0][0], o2 = (n3 - i2 * (r4[1][1] + r4[0][1])) / 2;
            t3.scale(150 * i2).translate([a2, o2]);
          }, r3);
        }
      }, 98936: function(t2, e2, r2) {
        r2.d(e2, { M: function() {
          return o;
        }, Z: function() {
          return s;
        } });
        var n2 = r2(39695), i = r2(25382), a = r2(15002);
        function o(t3, e3) {
          var r3 = (0, n2.mC)(e3), i2 = (0, n2.mC)(t3) * r3;
          return [r3 * (0, n2.O$)(t3) / i2, (0, n2.O$)(e3) / i2];
        }
        function s() {
          return (0, a.Z)(o).scale(144.049).clipAngle(60);
        }
        o.invert = (0, i.O)(n2.z4);
      }, 15002: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return m2;
        }, r: function() {
          return x;
        } });
        var n2 = r2(87070), i = r2(1457), a = r2(87605), o = r2(96059), s = r2(8593), l = r2(39695), u = r2(49386), c = r2(64684), f2 = r2(47589), h = r2(7620), p2 = (0, l.mC)(30 * l.uR);
        function d2(t3, e3) {
          return +e3 ? function(t4, e4) {
            function r3(n3, i2, a2, o2, s2, u2, c2, f3, h2, d3, v2, g3, y2, m3) {
              var x2 = c2 - n3, b = f3 - i2, _ = x2 * x2 + b * b;
              if (_ > 4 * e4 && y2--) {
                var w2 = o2 + d3, T = s2 + v2, k = u2 + g3, A = (0, l._b)(w2 * w2 + T * T + k * k), M = (0, l.ZR)(k /= A), S = (0, l.Wn)((0, l.Wn)(k) - 1) < l.Ho || (0, l.Wn)(a2 - h2) < l.Ho ? (a2 + h2) / 2 : (0, l.fv)(T, w2), E = t4(S, M), L = E[0], C = E[1], P = L - n3, O = C - i2, I = b * P - x2 * O;
                (I * I / _ > e4 || (0, l.Wn)((x2 * P + b * O) / _ - 0.5) > 0.3 || o2 * d3 + s2 * v2 + u2 * g3 < p2) && (r3(n3, i2, a2, o2, s2, u2, L, C, S, w2 /= A, T /= A, k, y2, m3), m3.point(L, C), r3(L, C, S, w2, T, k, c2, f3, h2, d3, v2, g3, y2, m3));
              }
            }
            return function(e5) {
              var n3, i2, a2, o2, s2, l2, u2, c2, f3, p3, d3, v2, g3 = { point: y2, lineStart: m3, lineEnd: b, polygonStart: function() {
                e5.polygonStart(), g3.lineStart = _;
              }, polygonEnd: function() {
                e5.polygonEnd(), g3.lineStart = m3;
              } };
              function y2(r4, n4) {
                r4 = t4(r4, n4), e5.point(r4[0], r4[1]);
              }
              function m3() {
                c2 = NaN, g3.point = x2, e5.lineStart();
              }
              function x2(n4, i3) {
                var a3 = (0, h.Og)([n4, i3]), o3 = t4(n4, i3);
                r3(c2, f3, u2, p3, d3, v2, c2 = o3[0], f3 = o3[1], u2 = n4, p3 = a3[0], d3 = a3[1], v2 = a3[2], 16, e5), e5.point(c2, f3);
              }
              function b() {
                g3.point = y2, e5.lineEnd();
              }
              function _() {
                m3(), g3.point = w2, g3.lineEnd = T;
              }
              function w2(t5, e6) {
                x2(n3 = t5, e6), i2 = c2, a2 = f3, o2 = p3, s2 = d3, l2 = v2, g3.point = x2;
              }
              function T() {
                r3(c2, f3, u2, p3, d3, v2, i2, a2, n3, o2, s2, l2, 16, e5), g3.lineEnd = b, b();
              }
              return g3;
            };
          }(t3, e3) : function(t4) {
            return (0, c.l)({ point: function(e4, r3) {
              e4 = t4(e4, r3), this.stream.point(e4[0], e4[1]);
            } });
          }(t3);
        }
        var v = (0, c.l)({ point: function(t3, e3) {
          this.stream.point(t3 * l.uR, e3 * l.uR);
        } });
        function g2(t3, e3, r3, n3, i2) {
          function a2(a3, o2) {
            return [e3 + t3 * (a3 *= n3), r3 - t3 * (o2 *= i2)];
          }
          return a2.invert = function(a3, o2) {
            return [(a3 - e3) / t3 * n3, (r3 - o2) / t3 * i2];
          }, a2;
        }
        function y(t3, e3, r3, n3, i2, a2) {
          var o2 = (0, l.mC)(a2), s2 = (0, l.O$)(a2), u2 = o2 * t3, c2 = s2 * t3, f3 = o2 / t3, h2 = s2 / t3, p3 = (s2 * r3 - o2 * e3) / t3, d3 = (s2 * e3 + o2 * r3) / t3;
          function v2(t4, a3) {
            return [u2 * (t4 *= n3) - c2 * (a3 *= i2) + e3, r3 - c2 * t4 - u2 * a3];
          }
          return v2.invert = function(t4, e4) {
            return [n3 * (f3 * t4 - h2 * e4 + p3), i2 * (d3 - h2 * t4 - f3 * e4)];
          }, v2;
        }
        function m2(t3) {
          return x(function() {
            return t3;
          })();
        }
        function x(t3) {
          var e3, r3, h2, p3, m3, x2, b, _, w2, T, k = 150, A = 480, M = 250, S = 0, E = 0, L = 0, C = 0, P = 0, O = 0, I = 1, D = 1, z = null, R = n2.Z, F = null, B = s.Z, N = 0.5;
          function j(t4) {
            return _(t4[0] * l.uR, t4[1] * l.uR);
          }
          function U(t4) {
            return (t4 = _.invert(t4[0], t4[1])) && [t4[0] * l.RW, t4[1] * l.RW];
          }
          function V() {
            var t4 = y(k, 0, 0, I, D, O).apply(null, e3(S, E)), n3 = (O ? y : g2)(k, A - t4[0], M - t4[1], I, D, O);
            return r3 = (0, u.I)(L, C, P), b = (0, o.Z)(e3, n3), _ = (0, o.Z)(r3, b), x2 = d2(b, N), H();
          }
          function H() {
            return w2 = T = null, j;
          }
          return j.stream = function(t4) {
            return w2 && T === t4 ? w2 : w2 = v(function(t5) {
              return (0, c.l)({ point: function(e4, r4) {
                var n3 = t5(e4, r4);
                return this.stream.point(n3[0], n3[1]);
              } });
            }(r3)(R(x2(B(T = t4)))));
          }, j.preclip = function(t4) {
            return arguments.length ? (R = t4, z = void 0, H()) : R;
          }, j.postclip = function(t4) {
            return arguments.length ? (B = t4, F = h2 = p3 = m3 = null, H()) : B;
          }, j.clipAngle = function(t4) {
            return arguments.length ? (R = +t4 ? (0, i.Z)(z = t4 * l.uR) : (z = null, n2.Z), H()) : z * l.RW;
          }, j.clipExtent = function(t4) {
            return arguments.length ? (B = null == t4 ? (F = h2 = p3 = m3 = null, s.Z) : (0, a.Z)(F = +t4[0][0], h2 = +t4[0][1], p3 = +t4[1][0], m3 = +t4[1][1]), H()) : null == F ? null : [[F, h2], [p3, m3]];
          }, j.scale = function(t4) {
            return arguments.length ? (k = +t4, V()) : k;
          }, j.translate = function(t4) {
            return arguments.length ? (A = +t4[0], M = +t4[1], V()) : [A, M];
          }, j.center = function(t4) {
            return arguments.length ? (S = t4[0] % 360 * l.uR, E = t4[1] % 360 * l.uR, V()) : [S * l.RW, E * l.RW];
          }, j.rotate = function(t4) {
            return arguments.length ? (L = t4[0] % 360 * l.uR, C = t4[1] % 360 * l.uR, P = t4.length > 2 ? t4[2] % 360 * l.uR : 0, V()) : [L * l.RW, C * l.RW, P * l.RW];
          }, j.angle = function(t4) {
            return arguments.length ? (O = t4 % 360 * l.uR, V()) : O * l.RW;
          }, j.reflectX = function(t4) {
            return arguments.length ? (I = t4 ? -1 : 1, V()) : I < 0;
          }, j.reflectY = function(t4) {
            return arguments.length ? (D = t4 ? -1 : 1, V()) : D < 0;
          }, j.precision = function(t4) {
            return arguments.length ? (x2 = d2(b, N = t4 * t4), H()) : (0, l._b)(N);
          }, j.fitExtent = function(t4, e4) {
            return (0, f2.qg)(j, t4, e4);
          }, j.fitSize = function(t4, e4) {
            return (0, f2.mF)(j, t4, e4);
          }, j.fitWidth = function(t4, e4) {
            return (0, f2.V6)(j, t4, e4);
          }, j.fitHeight = function(t4, e4) {
            return (0, f2.rf)(j, t4, e4);
          }, function() {
            return e3 = t3.apply(this, arguments), j.invert = e3.invert && U, V();
          };
        }
      }, 26867: function(t2, e2, r2) {
        r2.d(e2, { K: function() {
          return a;
        }, Z: function() {
          return o;
        } });
        var n2 = r2(15002), i = r2(39695);
        function a(t3, e3) {
          var r3 = e3 * e3, n3 = r3 * r3;
          return [t3 * (0.8707 - 0.131979 * r3 + n3 * (n3 * (3971e-6 * r3 - 1529e-6 * n3) - 0.013791)), e3 * (1.007226 + r3 * (0.015085 + n3 * (0.028874 * r3 - 0.044475 - 5916e-6 * n3)))];
        }
        function o() {
          return (0, n2.Z)(a).scale(175.295);
        }
        a.invert = function(t3, e3) {
          var r3, n3 = e3, a2 = 25;
          do {
            var o2 = n3 * n3, s = o2 * o2;
            n3 -= r3 = (n3 * (1.007226 + o2 * (0.015085 + s * (0.028874 * o2 - 0.044475 - 5916e-6 * s))) - e3) / (1.007226 + o2 * (0.045255 + s * (0.259866 * o2 - 0.311325 - 5916e-6 * 11 * s)));
          } while ((0, i.Wn)(r3) > i.Ho && --a2 > 0);
          return [t3 / (0.8707 + (o2 = n3 * n3) * (o2 * (o2 * o2 * o2 * (3971e-6 - 1529e-6 * o2) - 0.013791) - 0.131979)), n3];
        };
      }, 57962: function(t2, e2, r2) {
        r2.d(e2, { I: function() {
          return o;
        }, Z: function() {
          return s;
        } });
        var n2 = r2(39695), i = r2(25382), a = r2(15002);
        function o(t3, e3) {
          return [(0, n2.mC)(e3) * (0, n2.O$)(t3), (0, n2.O$)(e3)];
        }
        function s() {
          return (0, a.Z)(o).scale(249.5).clipAngle(90 + n2.Ho);
        }
        o.invert = (0, i.O)(n2.ZR);
      }, 49386: function(t2, e2, r2) {
        r2.d(e2, { I: function() {
          return o;
        }, Z: function() {
          return c;
        } });
        var n2 = r2(96059), i = r2(39695);
        function a(t3, e3) {
          return [(0, i.Wn)(t3) > i.pi ? t3 + Math.round(-t3 / i.BZ) * i.BZ : t3, e3];
        }
        function o(t3, e3, r3) {
          return (t3 %= i.BZ) ? e3 || r3 ? (0, n2.Z)(l(t3), u(e3, r3)) : l(t3) : e3 || r3 ? u(e3, r3) : a;
        }
        function s(t3) {
          return function(e3, r3) {
            return [(e3 += t3) > i.pi ? e3 - i.BZ : e3 < -i.pi ? e3 + i.BZ : e3, r3];
          };
        }
        function l(t3) {
          var e3 = s(t3);
          return e3.invert = s(-t3), e3;
        }
        function u(t3, e3) {
          var r3 = (0, i.mC)(t3), n3 = (0, i.O$)(t3), a2 = (0, i.mC)(e3), o2 = (0, i.O$)(e3);
          function s2(t4, e4) {
            var s3 = (0, i.mC)(e4), l2 = (0, i.mC)(t4) * s3, u2 = (0, i.O$)(t4) * s3, c2 = (0, i.O$)(e4), f2 = c2 * r3 + l2 * n3;
            return [(0, i.fv)(u2 * a2 - f2 * o2, l2 * r3 - c2 * n3), (0, i.ZR)(f2 * a2 + u2 * o2)];
          }
          return s2.invert = function(t4, e4) {
            var s3 = (0, i.mC)(e4), l2 = (0, i.mC)(t4) * s3, u2 = (0, i.O$)(t4) * s3, c2 = (0, i.O$)(e4), f2 = c2 * a2 - u2 * o2;
            return [(0, i.fv)(u2 * a2 + c2 * o2, l2 * r3 + f2 * n3), (0, i.ZR)(f2 * r3 - l2 * n3)];
          }, s2;
        }
        function c(t3) {
          function e3(e4) {
            return (e4 = t3(e4[0] * i.uR, e4[1] * i.uR))[0] *= i.RW, e4[1] *= i.RW, e4;
          }
          return t3 = o(t3[0] * i.uR, t3[1] * i.uR, t3.length > 2 ? t3[2] * i.uR : 0), e3.invert = function(e4) {
            return (e4 = t3.invert(e4[0] * i.uR, e4[1] * i.uR))[0] *= i.RW, e4[1] *= i.RW, e4;
          }, e3;
        }
        a.invert = a;
      }, 72736: function(t2, e2, r2) {
        function n2(t3, e3) {
          t3 && a.hasOwnProperty(t3.type) && a[t3.type](t3, e3);
        }
        r2.d(e2, { Z: function() {
          return l;
        } });
        var i = { Feature: function(t3, e3) {
          n2(t3.geometry, e3);
        }, FeatureCollection: function(t3, e3) {
          for (var r3 = t3.features, i2 = -1, a2 = r3.length; ++i2 < a2; )
            n2(r3[i2].geometry, e3);
        } }, a = { Sphere: function(t3, e3) {
          e3.sphere();
        }, Point: function(t3, e3) {
          t3 = t3.coordinates, e3.point(t3[0], t3[1], t3[2]);
        }, MultiPoint: function(t3, e3) {
          for (var r3 = t3.coordinates, n3 = -1, i2 = r3.length; ++n3 < i2; )
            t3 = r3[n3], e3.point(t3[0], t3[1], t3[2]);
        }, LineString: function(t3, e3) {
          o(t3.coordinates, e3, 0);
        }, MultiLineString: function(t3, e3) {
          for (var r3 = t3.coordinates, n3 = -1, i2 = r3.length; ++n3 < i2; )
            o(r3[n3], e3, 0);
        }, Polygon: function(t3, e3) {
          s(t3.coordinates, e3);
        }, MultiPolygon: function(t3, e3) {
          for (var r3 = t3.coordinates, n3 = -1, i2 = r3.length; ++n3 < i2; )
            s(r3[n3], e3);
        }, GeometryCollection: function(t3, e3) {
          for (var r3 = t3.geometries, i2 = -1, a2 = r3.length; ++i2 < a2; )
            n2(r3[i2], e3);
        } };
        function o(t3, e3, r3) {
          var n3, i2 = -1, a2 = t3.length - r3;
          for (e3.lineStart(); ++i2 < a2; )
            n3 = t3[i2], e3.point(n3[0], n3[1], n3[2]);
          e3.lineEnd();
        }
        function s(t3, e3) {
          var r3 = -1, n3 = t3.length;
          for (e3.polygonStart(); ++r3 < n3; )
            o(t3[r3], e3, 1);
          e3.polygonEnd();
        }
        function l(t3, e3) {
          t3 && i.hasOwnProperty(t3.type) ? i[t3.type](t3, e3) : n2(t3, e3);
        }
      }, 64684: function(t2, e2, r2) {
        function n2(t3) {
          return { stream: i(t3) };
        }
        function i(t3) {
          return function(e3) {
            var r3 = new a();
            for (var n3 in t3)
              r3[n3] = t3[n3];
            return r3.stream = e3, r3;
          };
        }
        function a() {
        }
        r2.d(e2, { Z: function() {
          return n2;
        }, l: function() {
          return i;
        } }), a.prototype = { constructor: a, point: function(t3, e3) {
          this.stream.point(t3, e3);
        }, sphere: function() {
          this.stream.sphere();
        }, lineStart: function() {
          this.stream.lineStart();
        }, lineEnd: function() {
          this.stream.lineEnd();
        }, polygonStart: function() {
          this.stream.polygonStart();
        }, polygonEnd: function() {
          this.stream.polygonEnd();
        } };
      }, 674: function(t2, e2, r2) {
        function n2(t3, e3) {
          return t3.parent === e3.parent ? 1 : 2;
        }
        function i(t3, e3) {
          return t3 + e3.x;
        }
        function a(t3, e3) {
          return Math.max(t3, e3.y);
        }
        function o() {
          var t3 = n2, e3 = 1, r3 = 1, o2 = false;
          function s2(n3) {
            var s3, l2 = 0;
            n3.eachAfter(function(e4) {
              var r4 = e4.children;
              r4 ? (e4.x = function(t4) {
                return t4.reduce(i, 0) / t4.length;
              }(r4), e4.y = function(t4) {
                return 1 + t4.reduce(a, 0);
              }(r4)) : (e4.x = s3 ? l2 += t3(e4, s3) : 0, e4.y = 0, s3 = e4);
            });
            var u2 = function(t4) {
              for (var e4; e4 = t4.children; )
                t4 = e4[0];
              return t4;
            }(n3), c2 = function(t4) {
              for (var e4; e4 = t4.children; )
                t4 = e4[e4.length - 1];
              return t4;
            }(n3), f3 = u2.x - t3(u2, c2) / 2, h2 = c2.x + t3(c2, u2) / 2;
            return n3.eachAfter(o2 ? function(t4) {
              t4.x = (t4.x - n3.x) * e3, t4.y = (n3.y - t4.y) * r3;
            } : function(t4) {
              t4.x = (t4.x - f3) / (h2 - f3) * e3, t4.y = (1 - (n3.y ? t4.y / n3.y : 1)) * r3;
            });
          }
          return s2.separation = function(e4) {
            return arguments.length ? (t3 = e4, s2) : t3;
          }, s2.size = function(t4) {
            return arguments.length ? (o2 = false, e3 = +t4[0], r3 = +t4[1], s2) : o2 ? null : [e3, r3];
          }, s2.nodeSize = function(t4) {
            return arguments.length ? (o2 = true, e3 = +t4[0], r3 = +t4[1], s2) : o2 ? [e3, r3] : null;
          }, s2;
        }
        function s(t3) {
          var e3 = 0, r3 = t3.children, n3 = r3 && r3.length;
          if (n3)
            for (; --n3 >= 0; )
              e3 += r3[n3].value;
          else
            e3 = 1;
          t3.value = e3;
        }
        function l(t3, e3) {
          var r3, n3, i2, a2, o2, s2 = new h(t3), l2 = +t3.value && (s2.value = t3.value), c2 = [s2];
          for (null == e3 && (e3 = u); r3 = c2.pop(); )
            if (l2 && (r3.value = +r3.data.value), (i2 = e3(r3.data)) && (o2 = i2.length))
              for (r3.children = new Array(o2), a2 = o2 - 1; a2 >= 0; --a2)
                c2.push(n3 = r3.children[a2] = new h(i2[a2])), n3.parent = r3, n3.depth = r3.depth + 1;
          return s2.eachBefore(f2);
        }
        function u(t3) {
          return t3.children;
        }
        function c(t3) {
          t3.data = t3.data.data;
        }
        function f2(t3) {
          var e3 = 0;
          do {
            t3.height = e3;
          } while ((t3 = t3.parent) && t3.height < ++e3);
        }
        function h(t3) {
          this.data = t3, this.depth = this.height = 0, this.parent = null;
        }
        r2.r(e2), r2.d(e2, { cluster: function() {
          return o;
        }, hierarchy: function() {
          return l;
        }, pack: function() {
          return I;
        }, packEnclose: function() {
          return d2;
        }, packSiblings: function() {
          return S;
        }, partition: function() {
          return N;
        }, stratify: function() {
          return q2;
        }, tree: function() {
          return K;
        }, treemap: function() {
          return rt;
        }, treemapBinary: function() {
          return nt;
        }, treemapDice: function() {
          return B;
        }, treemapResquarify: function() {
          return at;
        }, treemapSlice: function() {
          return $;
        }, treemapSliceDice: function() {
          return it;
        }, treemapSquarify: function() {
          return et;
        } }), h.prototype = l.prototype = { constructor: h, count: function() {
          return this.eachAfter(s);
        }, each: function(t3) {
          var e3, r3, n3, i2, a2 = this, o2 = [a2];
          do {
            for (e3 = o2.reverse(), o2 = []; a2 = e3.pop(); )
              if (t3(a2), r3 = a2.children)
                for (n3 = 0, i2 = r3.length; n3 < i2; ++n3)
                  o2.push(r3[n3]);
          } while (o2.length);
          return this;
        }, eachAfter: function(t3) {
          for (var e3, r3, n3, i2 = this, a2 = [i2], o2 = []; i2 = a2.pop(); )
            if (o2.push(i2), e3 = i2.children)
              for (r3 = 0, n3 = e3.length; r3 < n3; ++r3)
                a2.push(e3[r3]);
          for (; i2 = o2.pop(); )
            t3(i2);
          return this;
        }, eachBefore: function(t3) {
          for (var e3, r3, n3 = this, i2 = [n3]; n3 = i2.pop(); )
            if (t3(n3), e3 = n3.children)
              for (r3 = e3.length - 1; r3 >= 0; --r3)
                i2.push(e3[r3]);
          return this;
        }, sum: function(t3) {
          return this.eachAfter(function(e3) {
            for (var r3 = +t3(e3.data) || 0, n3 = e3.children, i2 = n3 && n3.length; --i2 >= 0; )
              r3 += n3[i2].value;
            e3.value = r3;
          });
        }, sort: function(t3) {
          return this.eachBefore(function(e3) {
            e3.children && e3.children.sort(t3);
          });
        }, path: function(t3) {
          for (var e3 = this, r3 = function(t4, e4) {
            if (t4 === e4)
              return t4;
            var r4 = t4.ancestors(), n4 = e4.ancestors(), i3 = null;
            for (t4 = r4.pop(), e4 = n4.pop(); t4 === e4; )
              i3 = t4, t4 = r4.pop(), e4 = n4.pop();
            return i3;
          }(e3, t3), n3 = [e3]; e3 !== r3; )
            e3 = e3.parent, n3.push(e3);
          for (var i2 = n3.length; t3 !== r3; )
            n3.splice(i2, 0, t3), t3 = t3.parent;
          return n3;
        }, ancestors: function() {
          for (var t3 = this, e3 = [t3]; t3 = t3.parent; )
            e3.push(t3);
          return e3;
        }, descendants: function() {
          var t3 = [];
          return this.each(function(e3) {
            t3.push(e3);
          }), t3;
        }, leaves: function() {
          var t3 = [];
          return this.eachBefore(function(e3) {
            e3.children || t3.push(e3);
          }), t3;
        }, links: function() {
          var t3 = this, e3 = [];
          return t3.each(function(r3) {
            r3 !== t3 && e3.push({ source: r3.parent, target: r3 });
          }), e3;
        }, copy: function() {
          return l(this).eachBefore(c);
        } };
        var p2 = Array.prototype.slice;
        function d2(t3) {
          for (var e3, r3, n3 = 0, i2 = (t3 = function(t4) {
            for (var e4, r4, n4 = t4.length; n4; )
              r4 = Math.random() * n4-- | 0, e4 = t4[n4], t4[n4] = t4[r4], t4[r4] = e4;
            return t4;
          }(p2.call(t3))).length, a2 = []; n3 < i2; )
            e3 = t3[n3], r3 && y(r3, e3) ? ++n3 : (r3 = x(a2 = v(a2, e3)), n3 = 0);
          return r3;
        }
        function v(t3, e3) {
          var r3, n3;
          if (m2(e3, t3))
            return [e3];
          for (r3 = 0; r3 < t3.length; ++r3)
            if (g2(e3, t3[r3]) && m2(b(t3[r3], e3), t3))
              return [t3[r3], e3];
          for (r3 = 0; r3 < t3.length - 1; ++r3)
            for (n3 = r3 + 1; n3 < t3.length; ++n3)
              if (g2(b(t3[r3], t3[n3]), e3) && g2(b(t3[r3], e3), t3[n3]) && g2(b(t3[n3], e3), t3[r3]) && m2(_(t3[r3], t3[n3], e3), t3))
                return [t3[r3], t3[n3], e3];
          throw new Error();
        }
        function g2(t3, e3) {
          var r3 = t3.r - e3.r, n3 = e3.x - t3.x, i2 = e3.y - t3.y;
          return r3 < 0 || r3 * r3 < n3 * n3 + i2 * i2;
        }
        function y(t3, e3) {
          var r3 = t3.r - e3.r + 1e-6, n3 = e3.x - t3.x, i2 = e3.y - t3.y;
          return r3 > 0 && r3 * r3 > n3 * n3 + i2 * i2;
        }
        function m2(t3, e3) {
          for (var r3 = 0; r3 < e3.length; ++r3)
            if (!y(t3, e3[r3]))
              return false;
          return true;
        }
        function x(t3) {
          switch (t3.length) {
            case 1:
              return { x: (e3 = t3[0]).x, y: e3.y, r: e3.r };
            case 2:
              return b(t3[0], t3[1]);
            case 3:
              return _(t3[0], t3[1], t3[2]);
          }
          var e3;
        }
        function b(t3, e3) {
          var r3 = t3.x, n3 = t3.y, i2 = t3.r, a2 = e3.x, o2 = e3.y, s2 = e3.r, l2 = a2 - r3, u2 = o2 - n3, c2 = s2 - i2, f3 = Math.sqrt(l2 * l2 + u2 * u2);
          return { x: (r3 + a2 + l2 / f3 * c2) / 2, y: (n3 + o2 + u2 / f3 * c2) / 2, r: (f3 + i2 + s2) / 2 };
        }
        function _(t3, e3, r3) {
          var n3 = t3.x, i2 = t3.y, a2 = t3.r, o2 = e3.x, s2 = e3.y, l2 = e3.r, u2 = r3.x, c2 = r3.y, f3 = r3.r, h2 = n3 - o2, p3 = n3 - u2, d3 = i2 - s2, v2 = i2 - c2, g3 = l2 - a2, y2 = f3 - a2, m3 = n3 * n3 + i2 * i2 - a2 * a2, x2 = m3 - o2 * o2 - s2 * s2 + l2 * l2, b2 = m3 - u2 * u2 - c2 * c2 + f3 * f3, _2 = p3 * d3 - h2 * v2, w3 = (d3 * b2 - v2 * x2) / (2 * _2) - n3, T2 = (v2 * g3 - d3 * y2) / _2, k2 = (p3 * x2 - h2 * b2) / (2 * _2) - i2, A2 = (h2 * y2 - p3 * g3) / _2, M2 = T2 * T2 + A2 * A2 - 1, S2 = 2 * (a2 + w3 * T2 + k2 * A2), E2 = w3 * w3 + k2 * k2 - a2 * a2, L2 = -(M2 ? (S2 + Math.sqrt(S2 * S2 - 4 * M2 * E2)) / (2 * M2) : E2 / S2);
          return { x: n3 + w3 + T2 * L2, y: i2 + k2 + A2 * L2, r: L2 };
        }
        function w2(t3, e3, r3) {
          var n3, i2, a2, o2, s2 = t3.x - e3.x, l2 = t3.y - e3.y, u2 = s2 * s2 + l2 * l2;
          u2 ? (i2 = e3.r + r3.r, i2 *= i2, o2 = t3.r + r3.r, i2 > (o2 *= o2) ? (n3 = (u2 + o2 - i2) / (2 * u2), a2 = Math.sqrt(Math.max(0, o2 / u2 - n3 * n3)), r3.x = t3.x - n3 * s2 - a2 * l2, r3.y = t3.y - n3 * l2 + a2 * s2) : (n3 = (u2 + i2 - o2) / (2 * u2), a2 = Math.sqrt(Math.max(0, i2 / u2 - n3 * n3)), r3.x = e3.x + n3 * s2 - a2 * l2, r3.y = e3.y + n3 * l2 + a2 * s2)) : (r3.x = e3.x + r3.r, r3.y = e3.y);
        }
        function T(t3, e3) {
          var r3 = t3.r + e3.r - 1e-6, n3 = e3.x - t3.x, i2 = e3.y - t3.y;
          return r3 > 0 && r3 * r3 > n3 * n3 + i2 * i2;
        }
        function k(t3) {
          var e3 = t3._, r3 = t3.next._, n3 = e3.r + r3.r, i2 = (e3.x * r3.r + r3.x * e3.r) / n3, a2 = (e3.y * r3.r + r3.y * e3.r) / n3;
          return i2 * i2 + a2 * a2;
        }
        function A(t3) {
          this._ = t3, this.next = null, this.previous = null;
        }
        function M(t3) {
          if (!(i2 = t3.length))
            return 0;
          var e3, r3, n3, i2, a2, o2, s2, l2, u2, c2, f3;
          if ((e3 = t3[0]).x = 0, e3.y = 0, !(i2 > 1))
            return e3.r;
          if (r3 = t3[1], e3.x = -r3.r, r3.x = e3.r, r3.y = 0, !(i2 > 2))
            return e3.r + r3.r;
          w2(r3, e3, n3 = t3[2]), e3 = new A(e3), r3 = new A(r3), n3 = new A(n3), e3.next = n3.previous = r3, r3.next = e3.previous = n3, n3.next = r3.previous = e3;
          t:
            for (s2 = 3; s2 < i2; ++s2) {
              w2(e3._, r3._, n3 = t3[s2]), n3 = new A(n3), l2 = r3.next, u2 = e3.previous, c2 = r3._.r, f3 = e3._.r;
              do {
                if (c2 <= f3) {
                  if (T(l2._, n3._)) {
                    r3 = l2, e3.next = r3, r3.previous = e3, --s2;
                    continue t;
                  }
                  c2 += l2._.r, l2 = l2.next;
                } else {
                  if (T(u2._, n3._)) {
                    (e3 = u2).next = r3, r3.previous = e3, --s2;
                    continue t;
                  }
                  f3 += u2._.r, u2 = u2.previous;
                }
              } while (l2 !== u2.next);
              for (n3.previous = e3, n3.next = r3, e3.next = r3.previous = r3 = n3, a2 = k(e3); (n3 = n3.next) !== r3; )
                (o2 = k(n3)) < a2 && (e3 = n3, a2 = o2);
              r3 = e3.next;
            }
          for (e3 = [r3._], n3 = r3; (n3 = n3.next) !== r3; )
            e3.push(n3._);
          for (n3 = d2(e3), s2 = 0; s2 < i2; ++s2)
            (e3 = t3[s2]).x -= n3.x, e3.y -= n3.y;
          return n3.r;
        }
        function S(t3) {
          return M(t3), t3;
        }
        function E(t3) {
          return null == t3 ? null : L(t3);
        }
        function L(t3) {
          if ("function" != typeof t3)
            throw new Error();
          return t3;
        }
        function C() {
          return 0;
        }
        function P(t3) {
          return function() {
            return t3;
          };
        }
        function O(t3) {
          return Math.sqrt(t3.value);
        }
        function I() {
          var t3 = null, e3 = 1, r3 = 1, n3 = C;
          function i2(i3) {
            return i3.x = e3 / 2, i3.y = r3 / 2, t3 ? i3.eachBefore(D(t3)).eachAfter(z(n3, 0.5)).eachBefore(R(1)) : i3.eachBefore(D(O)).eachAfter(z(C, 1)).eachAfter(z(n3, i3.r / Math.min(e3, r3))).eachBefore(R(Math.min(e3, r3) / (2 * i3.r))), i3;
          }
          return i2.radius = function(e4) {
            return arguments.length ? (t3 = E(e4), i2) : t3;
          }, i2.size = function(t4) {
            return arguments.length ? (e3 = +t4[0], r3 = +t4[1], i2) : [e3, r3];
          }, i2.padding = function(t4) {
            return arguments.length ? (n3 = "function" == typeof t4 ? t4 : P(+t4), i2) : n3;
          }, i2;
        }
        function D(t3) {
          return function(e3) {
            e3.children || (e3.r = Math.max(0, +t3(e3) || 0));
          };
        }
        function z(t3, e3) {
          return function(r3) {
            if (n3 = r3.children) {
              var n3, i2, a2, o2 = n3.length, s2 = t3(r3) * e3 || 0;
              if (s2)
                for (i2 = 0; i2 < o2; ++i2)
                  n3[i2].r += s2;
              if (a2 = M(n3), s2)
                for (i2 = 0; i2 < o2; ++i2)
                  n3[i2].r -= s2;
              r3.r = a2 + s2;
            }
          };
        }
        function R(t3) {
          return function(e3) {
            var r3 = e3.parent;
            e3.r *= t3, r3 && (e3.x = r3.x + t3 * e3.x, e3.y = r3.y + t3 * e3.y);
          };
        }
        function F(t3) {
          t3.x0 = Math.round(t3.x0), t3.y0 = Math.round(t3.y0), t3.x1 = Math.round(t3.x1), t3.y1 = Math.round(t3.y1);
        }
        function B(t3, e3, r3, n3, i2) {
          for (var a2, o2 = t3.children, s2 = -1, l2 = o2.length, u2 = t3.value && (n3 - e3) / t3.value; ++s2 < l2; )
            (a2 = o2[s2]).y0 = r3, a2.y1 = i2, a2.x0 = e3, a2.x1 = e3 += a2.value * u2;
        }
        function N() {
          var t3 = 1, e3 = 1, r3 = 0, n3 = false;
          function i2(i3) {
            var a2 = i3.height + 1;
            return i3.x0 = i3.y0 = r3, i3.x1 = t3, i3.y1 = e3 / a2, i3.eachBefore(function(t4, e4) {
              return function(n4) {
                n4.children && B(n4, n4.x0, t4 * (n4.depth + 1) / e4, n4.x1, t4 * (n4.depth + 2) / e4);
                var i4 = n4.x0, a3 = n4.y0, o2 = n4.x1 - r3, s2 = n4.y1 - r3;
                o2 < i4 && (i4 = o2 = (i4 + o2) / 2), s2 < a3 && (a3 = s2 = (a3 + s2) / 2), n4.x0 = i4, n4.y0 = a3, n4.x1 = o2, n4.y1 = s2;
              };
            }(e3, a2)), n3 && i3.eachBefore(F), i3;
          }
          return i2.round = function(t4) {
            return arguments.length ? (n3 = !!t4, i2) : n3;
          }, i2.size = function(r4) {
            return arguments.length ? (t3 = +r4[0], e3 = +r4[1], i2) : [t3, e3];
          }, i2.padding = function(t4) {
            return arguments.length ? (r3 = +t4, i2) : r3;
          }, i2;
        }
        var j = { depth: -1 }, U = {};
        function V(t3) {
          return t3.id;
        }
        function H(t3) {
          return t3.parentId;
        }
        function q2() {
          var t3 = V, e3 = H;
          function r3(r4) {
            var n3, i2, a2, o2, s2, l2, u2, c2 = r4.length, p3 = new Array(c2), d3 = {};
            for (i2 = 0; i2 < c2; ++i2)
              n3 = r4[i2], s2 = p3[i2] = new h(n3), null != (l2 = t3(n3, i2, r4)) && (l2 += "") && (d3[u2 = "$" + (s2.id = l2)] = u2 in d3 ? U : s2);
            for (i2 = 0; i2 < c2; ++i2)
              if (s2 = p3[i2], null != (l2 = e3(r4[i2], i2, r4)) && (l2 += "")) {
                if (!(o2 = d3["$" + l2]))
                  throw new Error("missing: " + l2);
                if (o2 === U)
                  throw new Error("ambiguous: " + l2);
                o2.children ? o2.children.push(s2) : o2.children = [s2], s2.parent = o2;
              } else {
                if (a2)
                  throw new Error("multiple roots");
                a2 = s2;
              }
            if (!a2)
              throw new Error("no root");
            if (a2.parent = j, a2.eachBefore(function(t4) {
              t4.depth = t4.parent.depth + 1, --c2;
            }).eachBefore(f2), a2.parent = null, c2 > 0)
              throw new Error("cycle");
            return a2;
          }
          return r3.id = function(e4) {
            return arguments.length ? (t3 = L(e4), r3) : t3;
          }, r3.parentId = function(t4) {
            return arguments.length ? (e3 = L(t4), r3) : e3;
          }, r3;
        }
        function G(t3, e3) {
          return t3.parent === e3.parent ? 1 : 2;
        }
        function Z(t3) {
          var e3 = t3.children;
          return e3 ? e3[0] : t3.t;
        }
        function Y(t3) {
          var e3 = t3.children;
          return e3 ? e3[e3.length - 1] : t3.t;
        }
        function W(t3, e3, r3) {
          var n3 = r3 / (e3.i - t3.i);
          e3.c -= n3, e3.s += r3, t3.c += n3, e3.z += r3, e3.m += r3;
        }
        function X(t3, e3, r3) {
          return t3.a.parent === e3.parent ? t3.a : r3;
        }
        function J(t3, e3) {
          this._ = t3, this.parent = null, this.children = null, this.A = null, this.a = this, this.z = 0, this.m = 0, this.c = 0, this.s = 0, this.t = null, this.i = e3;
        }
        function K() {
          var t3 = G, e3 = 1, r3 = 1, n3 = null;
          function i2(i3) {
            var l2 = function(t4) {
              for (var e4, r4, n4, i4, a3, o3 = new J(t4, 0), s3 = [o3]; e4 = s3.pop(); )
                if (n4 = e4._.children)
                  for (e4.children = new Array(a3 = n4.length), i4 = a3 - 1; i4 >= 0; --i4)
                    s3.push(r4 = e4.children[i4] = new J(n4[i4], i4)), r4.parent = e4;
              return (o3.parent = new J(null, 0)).children = [o3], o3;
            }(i3);
            if (l2.eachAfter(a2), l2.parent.m = -l2.z, l2.eachBefore(o2), n3)
              i3.eachBefore(s2);
            else {
              var u2 = i3, c2 = i3, f3 = i3;
              i3.eachBefore(function(t4) {
                t4.x < u2.x && (u2 = t4), t4.x > c2.x && (c2 = t4), t4.depth > f3.depth && (f3 = t4);
              });
              var h2 = u2 === c2 ? 1 : t3(u2, c2) / 2, p3 = h2 - u2.x, d3 = e3 / (c2.x + h2 + p3), v2 = r3 / (f3.depth || 1);
              i3.eachBefore(function(t4) {
                t4.x = (t4.x + p3) * d3, t4.y = t4.depth * v2;
              });
            }
            return i3;
          }
          function a2(e4) {
            var r4 = e4.children, n4 = e4.parent.children, i3 = e4.i ? n4[e4.i - 1] : null;
            if (r4) {
              !function(t4) {
                for (var e5, r5 = 0, n5 = 0, i4 = t4.children, a4 = i4.length; --a4 >= 0; )
                  (e5 = i4[a4]).z += r5, e5.m += r5, r5 += e5.s + (n5 += e5.c);
              }(e4);
              var a3 = (r4[0].z + r4[r4.length - 1].z) / 2;
              i3 ? (e4.z = i3.z + t3(e4._, i3._), e4.m = e4.z - a3) : e4.z = a3;
            } else
              i3 && (e4.z = i3.z + t3(e4._, i3._));
            e4.parent.A = function(e5, r5, n5) {
              if (r5) {
                for (var i4, a4 = e5, o3 = e5, s3 = r5, l2 = a4.parent.children[0], u2 = a4.m, c2 = o3.m, f3 = s3.m, h2 = l2.m; s3 = Y(s3), a4 = Z(a4), s3 && a4; )
                  l2 = Z(l2), (o3 = Y(o3)).a = e5, (i4 = s3.z + f3 - a4.z - u2 + t3(s3._, a4._)) > 0 && (W(X(s3, e5, n5), e5, i4), u2 += i4, c2 += i4), f3 += s3.m, u2 += a4.m, h2 += l2.m, c2 += o3.m;
                s3 && !Y(o3) && (o3.t = s3, o3.m += f3 - c2), a4 && !Z(l2) && (l2.t = a4, l2.m += u2 - h2, n5 = e5);
              }
              return n5;
            }(e4, i3, e4.parent.A || n4[0]);
          }
          function o2(t4) {
            t4._.x = t4.z + t4.parent.m, t4.m += t4.parent.m;
          }
          function s2(t4) {
            t4.x *= e3, t4.y = t4.depth * r3;
          }
          return i2.separation = function(e4) {
            return arguments.length ? (t3 = e4, i2) : t3;
          }, i2.size = function(t4) {
            return arguments.length ? (n3 = false, e3 = +t4[0], r3 = +t4[1], i2) : n3 ? null : [e3, r3];
          }, i2.nodeSize = function(t4) {
            return arguments.length ? (n3 = true, e3 = +t4[0], r3 = +t4[1], i2) : n3 ? [e3, r3] : null;
          }, i2;
        }
        function $(t3, e3, r3, n3, i2) {
          for (var a2, o2 = t3.children, s2 = -1, l2 = o2.length, u2 = t3.value && (i2 - r3) / t3.value; ++s2 < l2; )
            (a2 = o2[s2]).x0 = e3, a2.x1 = n3, a2.y0 = r3, a2.y1 = r3 += a2.value * u2;
        }
        J.prototype = Object.create(h.prototype);
        var Q = (1 + Math.sqrt(5)) / 2;
        function tt(t3, e3, r3, n3, i2, a2) {
          for (var o2, s2, l2, u2, c2, f3, h2, p3, d3, v2, g3, y2 = [], m3 = e3.children, x2 = 0, b2 = 0, _2 = m3.length, w3 = e3.value; x2 < _2; ) {
            l2 = i2 - r3, u2 = a2 - n3;
            do {
              c2 = m3[b2++].value;
            } while (!c2 && b2 < _2);
            for (f3 = h2 = c2, g3 = c2 * c2 * (v2 = Math.max(u2 / l2, l2 / u2) / (w3 * t3)), d3 = Math.max(h2 / g3, g3 / f3); b2 < _2; ++b2) {
              if (c2 += s2 = m3[b2].value, s2 < f3 && (f3 = s2), s2 > h2 && (h2 = s2), g3 = c2 * c2 * v2, (p3 = Math.max(h2 / g3, g3 / f3)) > d3) {
                c2 -= s2;
                break;
              }
              d3 = p3;
            }
            y2.push(o2 = { value: c2, dice: l2 < u2, children: m3.slice(x2, b2) }), o2.dice ? B(o2, r3, n3, i2, w3 ? n3 += u2 * c2 / w3 : a2) : $(o2, r3, n3, w3 ? r3 += l2 * c2 / w3 : i2, a2), w3 -= c2, x2 = b2;
          }
          return y2;
        }
        var et = function t3(e3) {
          function r3(t4, r4, n3, i2, a2) {
            tt(e3, t4, r4, n3, i2, a2);
          }
          return r3.ratio = function(e4) {
            return t3((e4 = +e4) > 1 ? e4 : 1);
          }, r3;
        }(Q);
        function rt() {
          var t3 = et, e3 = false, r3 = 1, n3 = 1, i2 = [0], a2 = C, o2 = C, s2 = C, l2 = C, u2 = C;
          function c2(t4) {
            return t4.x0 = t4.y0 = 0, t4.x1 = r3, t4.y1 = n3, t4.eachBefore(f3), i2 = [0], e3 && t4.eachBefore(F), t4;
          }
          function f3(e4) {
            var r4 = i2[e4.depth], n4 = e4.x0 + r4, c3 = e4.y0 + r4, f4 = e4.x1 - r4, h2 = e4.y1 - r4;
            f4 < n4 && (n4 = f4 = (n4 + f4) / 2), h2 < c3 && (c3 = h2 = (c3 + h2) / 2), e4.x0 = n4, e4.y0 = c3, e4.x1 = f4, e4.y1 = h2, e4.children && (r4 = i2[e4.depth + 1] = a2(e4) / 2, n4 += u2(e4) - r4, c3 += o2(e4) - r4, (f4 -= s2(e4) - r4) < n4 && (n4 = f4 = (n4 + f4) / 2), (h2 -= l2(e4) - r4) < c3 && (c3 = h2 = (c3 + h2) / 2), t3(e4, n4, c3, f4, h2));
          }
          return c2.round = function(t4) {
            return arguments.length ? (e3 = !!t4, c2) : e3;
          }, c2.size = function(t4) {
            return arguments.length ? (r3 = +t4[0], n3 = +t4[1], c2) : [r3, n3];
          }, c2.tile = function(e4) {
            return arguments.length ? (t3 = L(e4), c2) : t3;
          }, c2.padding = function(t4) {
            return arguments.length ? c2.paddingInner(t4).paddingOuter(t4) : c2.paddingInner();
          }, c2.paddingInner = function(t4) {
            return arguments.length ? (a2 = "function" == typeof t4 ? t4 : P(+t4), c2) : a2;
          }, c2.paddingOuter = function(t4) {
            return arguments.length ? c2.paddingTop(t4).paddingRight(t4).paddingBottom(t4).paddingLeft(t4) : c2.paddingTop();
          }, c2.paddingTop = function(t4) {
            return arguments.length ? (o2 = "function" == typeof t4 ? t4 : P(+t4), c2) : o2;
          }, c2.paddingRight = function(t4) {
            return arguments.length ? (s2 = "function" == typeof t4 ? t4 : P(+t4), c2) : s2;
          }, c2.paddingBottom = function(t4) {
            return arguments.length ? (l2 = "function" == typeof t4 ? t4 : P(+t4), c2) : l2;
          }, c2.paddingLeft = function(t4) {
            return arguments.length ? (u2 = "function" == typeof t4 ? t4 : P(+t4), c2) : u2;
          }, c2;
        }
        function nt(t3, e3, r3, n3, i2) {
          var a2, o2, s2 = t3.children, l2 = s2.length, u2 = new Array(l2 + 1);
          for (u2[0] = o2 = a2 = 0; a2 < l2; ++a2)
            u2[a2 + 1] = o2 += s2[a2].value;
          !function t4(e4, r4, n4, i3, a3, o3, l3) {
            if (e4 >= r4 - 1) {
              var c2 = s2[e4];
              return c2.x0 = i3, c2.y0 = a3, c2.x1 = o3, void (c2.y1 = l3);
            }
            for (var f3 = u2[e4], h2 = n4 / 2 + f3, p3 = e4 + 1, d3 = r4 - 1; p3 < d3; ) {
              var v2 = p3 + d3 >>> 1;
              u2[v2] < h2 ? p3 = v2 + 1 : d3 = v2;
            }
            h2 - u2[p3 - 1] < u2[p3] - h2 && e4 + 1 < p3 && --p3;
            var g3 = u2[p3] - f3, y2 = n4 - g3;
            if (o3 - i3 > l3 - a3) {
              var m3 = (i3 * y2 + o3 * g3) / n4;
              t4(e4, p3, g3, i3, a3, m3, l3), t4(p3, r4, y2, m3, a3, o3, l3);
            } else {
              var x2 = (a3 * y2 + l3 * g3) / n4;
              t4(e4, p3, g3, i3, a3, o3, x2), t4(p3, r4, y2, i3, x2, o3, l3);
            }
          }(0, l2, t3.value, e3, r3, n3, i2);
        }
        function it(t3, e3, r3, n3, i2) {
          (1 & t3.depth ? $ : B)(t3, e3, r3, n3, i2);
        }
        var at = function t3(e3) {
          function r3(t4, r4, n3, i2, a2) {
            if ((o2 = t4._squarify) && o2.ratio === e3)
              for (var o2, s2, l2, u2, c2, f3 = -1, h2 = o2.length, p3 = t4.value; ++f3 < h2; ) {
                for (l2 = (s2 = o2[f3]).children, u2 = s2.value = 0, c2 = l2.length; u2 < c2; ++u2)
                  s2.value += l2[u2].value;
                s2.dice ? B(s2, r4, n3, i2, n3 += (a2 - n3) * s2.value / p3) : $(s2, r4, n3, r4 += (i2 - r4) * s2.value / p3, a2), p3 -= s2.value;
              }
            else
              t4._squarify = o2 = tt(e3, t4, r4, n3, i2, a2), o2.ratio = e3;
          }
          return r3.ratio = function(e4) {
            return t3((e4 = +e4) > 1 ? e4 : 1);
          }, r3;
        }(Q);
      }, 45879: function(t2, e2, r2) {
        r2.d(e2, { h5: function() {
          return y;
        } });
        var n2 = Math.PI, i = 2 * n2, a = 1e-6, o = i - a;
        function s() {
          this._x0 = this._y0 = this._x1 = this._y1 = null, this._ = "";
        }
        function l() {
          return new s();
        }
        s.prototype = l.prototype = { constructor: s, moveTo: function(t3, e3) {
          this._ += "M" + (this._x0 = this._x1 = +t3) + "," + (this._y0 = this._y1 = +e3);
        }, closePath: function() {
          null !== this._x1 && (this._x1 = this._x0, this._y1 = this._y0, this._ += "Z");
        }, lineTo: function(t3, e3) {
          this._ += "L" + (this._x1 = +t3) + "," + (this._y1 = +e3);
        }, quadraticCurveTo: function(t3, e3, r3, n3) {
          this._ += "Q" + +t3 + "," + +e3 + "," + (this._x1 = +r3) + "," + (this._y1 = +n3);
        }, bezierCurveTo: function(t3, e3, r3, n3, i2, a2) {
          this._ += "C" + +t3 + "," + +e3 + "," + +r3 + "," + +n3 + "," + (this._x1 = +i2) + "," + (this._y1 = +a2);
        }, arcTo: function(t3, e3, r3, i2, o2) {
          t3 = +t3, e3 = +e3, r3 = +r3, i2 = +i2, o2 = +o2;
          var s2 = this._x1, l2 = this._y1, u2 = r3 - t3, c2 = i2 - e3, f3 = s2 - t3, h2 = l2 - e3, p3 = f3 * f3 + h2 * h2;
          if (o2 < 0)
            throw new Error("negative radius: " + o2);
          if (null === this._x1)
            this._ += "M" + (this._x1 = t3) + "," + (this._y1 = e3);
          else if (p3 > a)
            if (Math.abs(h2 * u2 - c2 * f3) > a && o2) {
              var d3 = r3 - s2, v2 = i2 - l2, g3 = u2 * u2 + c2 * c2, y2 = d3 * d3 + v2 * v2, m2 = Math.sqrt(g3), x = Math.sqrt(p3), b = o2 * Math.tan((n2 - Math.acos((g3 + p3 - y2) / (2 * m2 * x))) / 2), _ = b / x, w2 = b / m2;
              Math.abs(_ - 1) > a && (this._ += "L" + (t3 + _ * f3) + "," + (e3 + _ * h2)), this._ += "A" + o2 + "," + o2 + ",0,0," + +(h2 * d3 > f3 * v2) + "," + (this._x1 = t3 + w2 * u2) + "," + (this._y1 = e3 + w2 * c2);
            } else
              this._ += "L" + (this._x1 = t3) + "," + (this._y1 = e3);
        }, arc: function(t3, e3, r3, s2, l2, u2) {
          t3 = +t3, e3 = +e3, u2 = !!u2;
          var c2 = (r3 = +r3) * Math.cos(s2), f3 = r3 * Math.sin(s2), h2 = t3 + c2, p3 = e3 + f3, d3 = 1 ^ u2, v2 = u2 ? s2 - l2 : l2 - s2;
          if (r3 < 0)
            throw new Error("negative radius: " + r3);
          null === this._x1 ? this._ += "M" + h2 + "," + p3 : (Math.abs(this._x1 - h2) > a || Math.abs(this._y1 - p3) > a) && (this._ += "L" + h2 + "," + p3), r3 && (v2 < 0 && (v2 = v2 % i + i), v2 > o ? this._ += "A" + r3 + "," + r3 + ",0,1," + d3 + "," + (t3 - c2) + "," + (e3 - f3) + "A" + r3 + "," + r3 + ",0,1," + d3 + "," + (this._x1 = h2) + "," + (this._y1 = p3) : v2 > a && (this._ += "A" + r3 + "," + r3 + ",0," + +(v2 >= n2) + "," + d3 + "," + (this._x1 = t3 + r3 * Math.cos(l2)) + "," + (this._y1 = e3 + r3 * Math.sin(l2))));
        }, rect: function(t3, e3, r3, n3) {
          this._ += "M" + (this._x0 = this._x1 = +t3) + "," + (this._y0 = this._y1 = +e3) + "h" + +r3 + "v" + +n3 + "h" + -r3 + "Z";
        }, toString: function() {
          return this._;
        } };
        var u = l, c = Array.prototype.slice;
        function f2(t3) {
          return function() {
            return t3;
          };
        }
        function h(t3) {
          return t3[0];
        }
        function p2(t3) {
          return t3[1];
        }
        function d2(t3) {
          return t3.source;
        }
        function v(t3) {
          return t3.target;
        }
        function g2(t3, e3, r3, n3, i2) {
          t3.moveTo(e3, r3), t3.bezierCurveTo(e3 = (e3 + n3) / 2, r3, e3, i2, n3, i2);
        }
        function y() {
          return function(t3) {
            var e3 = d2, r3 = v, n3 = h, i2 = p2, a2 = null;
            function o2() {
              var o3, s2 = c.call(arguments), l2 = e3.apply(this, s2), f3 = r3.apply(this, s2);
              if (a2 || (a2 = o3 = u()), t3(a2, +n3.apply(this, (s2[0] = l2, s2)), +i2.apply(this, s2), +n3.apply(this, (s2[0] = f3, s2)), +i2.apply(this, s2)), o3)
                return a2 = null, o3 + "" || null;
            }
            return o2.source = function(t4) {
              return arguments.length ? (e3 = t4, o2) : e3;
            }, o2.target = function(t4) {
              return arguments.length ? (r3 = t4, o2) : r3;
            }, o2.x = function(t4) {
              return arguments.length ? (n3 = "function" == typeof t4 ? t4 : f2(+t4), o2) : n3;
            }, o2.y = function(t4) {
              return arguments.length ? (i2 = "function" == typeof t4 ? t4 : f2(+t4), o2) : i2;
            }, o2.context = function(t4) {
              return arguments.length ? (a2 = null == t4 ? null : t4, o2) : a2;
            }, o2;
          }(g2);
        }
      }, 84096: function(t2, e2, r2) {
        r2.d(e2, { i$: function() {
          return d2;
        }, Dq: function() {
          return h;
        }, g0: function() {
          return v;
        } });
        var n2 = r2(58176), i = r2(48480), a = r2(59879), o = r2(82301), s = r2(34823), l = r2(79791);
        function u(t3) {
          if (0 <= t3.y && t3.y < 100) {
            var e3 = new Date(-1, t3.m, t3.d, t3.H, t3.M, t3.S, t3.L);
            return e3.setFullYear(t3.y), e3;
          }
          return new Date(t3.y, t3.m, t3.d, t3.H, t3.M, t3.S, t3.L);
        }
        function c(t3) {
          if (0 <= t3.y && t3.y < 100) {
            var e3 = new Date(Date.UTC(-1, t3.m, t3.d, t3.H, t3.M, t3.S, t3.L));
            return e3.setUTCFullYear(t3.y), e3;
          }
          return new Date(Date.UTC(t3.y, t3.m, t3.d, t3.H, t3.M, t3.S, t3.L));
        }
        function f2(t3, e3, r3) {
          return { y: t3, m: e3, d: r3, H: 0, M: 0, S: 0, L: 0 };
        }
        function h(t3) {
          var e3 = t3.dateTime, r3 = t3.date, s2 = t3.time, l2 = t3.periods, h2 = t3.days, p3 = t3.shortDays, d3 = t3.months, v2 = t3.shortMonths, y2 = w2(l2), m3 = T(l2), x2 = w2(h2), b2 = T(h2), _2 = w2(p3), St = T(p3), Et = w2(d3), Lt = T(d3), Ct = w2(v2), Pt = T(v2), Ot = { a: function(t4) {
            return p3[t4.getDay()];
          }, A: function(t4) {
            return h2[t4.getDay()];
          }, b: function(t4) {
            return v2[t4.getMonth()];
          }, B: function(t4) {
            return d3[t4.getMonth()];
          }, c: null, d: q2, e: q2, f: X, H: G, I: Z, j: Y, L: W, m: J, M: K, p: function(t4) {
            return l2[+(t4.getHours() >= 12)];
          }, q: function(t4) {
            return 1 + ~~(t4.getMonth() / 3);
          }, Q: At, s: Mt, S: $, u: Q, U: tt, V: et, w: rt, W: nt, x: null, X: null, y: it, Y: at, Z: ot, "%": kt }, It = { a: function(t4) {
            return p3[t4.getUTCDay()];
          }, A: function(t4) {
            return h2[t4.getUTCDay()];
          }, b: function(t4) {
            return v2[t4.getUTCMonth()];
          }, B: function(t4) {
            return d3[t4.getUTCMonth()];
          }, c: null, d: st, e: st, f: ht, H: lt, I: ut, j: ct, L: ft, m: pt, M: dt, p: function(t4) {
            return l2[+(t4.getUTCHours() >= 12)];
          }, q: function(t4) {
            return 1 + ~~(t4.getUTCMonth() / 3);
          }, Q: At, s: Mt, S: vt, u: gt, U: yt, V: mt, w: xt, W: bt, x: null, X: null, y: _t, Y: wt, Z: Tt, "%": kt }, Dt = { a: function(t4, e4, r4) {
            var n3 = _2.exec(e4.slice(r4));
            return n3 ? (t4.w = St[n3[0].toLowerCase()], r4 + n3[0].length) : -1;
          }, A: function(t4, e4, r4) {
            var n3 = x2.exec(e4.slice(r4));
            return n3 ? (t4.w = b2[n3[0].toLowerCase()], r4 + n3[0].length) : -1;
          }, b: function(t4, e4, r4) {
            var n3 = Ct.exec(e4.slice(r4));
            return n3 ? (t4.m = Pt[n3[0].toLowerCase()], r4 + n3[0].length) : -1;
          }, B: function(t4, e4, r4) {
            var n3 = Et.exec(e4.slice(r4));
            return n3 ? (t4.m = Lt[n3[0].toLowerCase()], r4 + n3[0].length) : -1;
          }, c: function(t4, r4, n3) {
            return Ft(t4, e3, r4, n3);
          }, d: D, e: D, f: j, H: R, I: R, j: z, L: N, m: I, M: F, p: function(t4, e4, r4) {
            var n3 = y2.exec(e4.slice(r4));
            return n3 ? (t4.p = m3[n3[0].toLowerCase()], r4 + n3[0].length) : -1;
          }, q: O, Q: V, s: H, S: B, u: A, U: M, V: S, w: k, W: E, x: function(t4, e4, n3) {
            return Ft(t4, r3, e4, n3);
          }, X: function(t4, e4, r4) {
            return Ft(t4, s2, e4, r4);
          }, y: C, Y: L, Z: P, "%": U };
          function zt(t4, e4) {
            return function(r4) {
              var n3, i2, a2, o2 = [], s3 = -1, l3 = 0, u2 = t4.length;
              for (r4 instanceof Date || (r4 = new Date(+r4)); ++s3 < u2; )
                37 === t4.charCodeAt(s3) && (o2.push(t4.slice(l3, s3)), null != (i2 = g2[n3 = t4.charAt(++s3)]) ? n3 = t4.charAt(++s3) : i2 = "e" === n3 ? " " : "0", (a2 = e4[n3]) && (n3 = a2(r4, i2)), o2.push(n3), l3 = s3 + 1);
              return o2.push(t4.slice(l3, s3)), o2.join("");
            };
          }
          function Rt(t4, e4) {
            return function(r4) {
              var s3, l3, h3 = f2(1900, void 0, 1);
              if (Ft(h3, t4, r4 += "", 0) != r4.length)
                return null;
              if ("Q" in h3)
                return new Date(h3.Q);
              if ("s" in h3)
                return new Date(1e3 * h3.s + ("L" in h3 ? h3.L : 0));
              if (e4 && !("Z" in h3) && (h3.Z = 0), "p" in h3 && (h3.H = h3.H % 12 + 12 * h3.p), void 0 === h3.m && (h3.m = "q" in h3 ? h3.q : 0), "V" in h3) {
                if (h3.V < 1 || h3.V > 53)
                  return null;
                "w" in h3 || (h3.w = 1), "Z" in h3 ? (l3 = (s3 = c(f2(h3.y, 0, 1))).getUTCDay(), s3 = l3 > 4 || 0 === l3 ? n2.l6.ceil(s3) : (0, n2.l6)(s3), s3 = i.Z.offset(s3, 7 * (h3.V - 1)), h3.y = s3.getUTCFullYear(), h3.m = s3.getUTCMonth(), h3.d = s3.getUTCDate() + (h3.w + 6) % 7) : (l3 = (s3 = u(f2(h3.y, 0, 1))).getDay(), s3 = l3 > 4 || 0 === l3 ? a.wA.ceil(s3) : (0, a.wA)(s3), s3 = o.Z.offset(s3, 7 * (h3.V - 1)), h3.y = s3.getFullYear(), h3.m = s3.getMonth(), h3.d = s3.getDate() + (h3.w + 6) % 7);
              } else
                ("W" in h3 || "U" in h3) && ("w" in h3 || (h3.w = "u" in h3 ? h3.u % 7 : "W" in h3 ? 1 : 0), l3 = "Z" in h3 ? c(f2(h3.y, 0, 1)).getUTCDay() : u(f2(h3.y, 0, 1)).getDay(), h3.m = 0, h3.d = "W" in h3 ? (h3.w + 6) % 7 + 7 * h3.W - (l3 + 5) % 7 : h3.w + 7 * h3.U - (l3 + 6) % 7);
              return "Z" in h3 ? (h3.H += h3.Z / 100 | 0, h3.M += h3.Z % 100, c(h3)) : u(h3);
            };
          }
          function Ft(t4, e4, r4, n3) {
            for (var i2, a2, o2 = 0, s3 = e4.length, l3 = r4.length; o2 < s3; ) {
              if (n3 >= l3)
                return -1;
              if (37 === (i2 = e4.charCodeAt(o2++))) {
                if (i2 = e4.charAt(o2++), !(a2 = Dt[i2 in g2 ? e4.charAt(o2++) : i2]) || (n3 = a2(t4, r4, n3)) < 0)
                  return -1;
              } else if (i2 != r4.charCodeAt(n3++))
                return -1;
            }
            return n3;
          }
          return Ot.x = zt(r3, Ot), Ot.X = zt(s2, Ot), Ot.c = zt(e3, Ot), It.x = zt(r3, It), It.X = zt(s2, It), It.c = zt(e3, It), { format: function(t4) {
            var e4 = zt(t4 += "", Ot);
            return e4.toString = function() {
              return t4;
            }, e4;
          }, parse: function(t4) {
            var e4 = Rt(t4 += "", false);
            return e4.toString = function() {
              return t4;
            }, e4;
          }, utcFormat: function(t4) {
            var e4 = zt(t4 += "", It);
            return e4.toString = function() {
              return t4;
            }, e4;
          }, utcParse: function(t4) {
            var e4 = Rt(t4 += "", true);
            return e4.toString = function() {
              return t4;
            }, e4;
          } };
        }
        var p2, d2, v, g2 = { "-": "", _: " ", 0: "0" }, y = /^\s*\d+/, m2 = /^%/, x = /[\\^$*+?|[\]().{}]/g;
        function b(t3, e3, r3) {
          var n3 = t3 < 0 ? "-" : "", i2 = (n3 ? -t3 : t3) + "", a2 = i2.length;
          return n3 + (a2 < r3 ? new Array(r3 - a2 + 1).join(e3) + i2 : i2);
        }
        function _(t3) {
          return t3.replace(x, "\\$&");
        }
        function w2(t3) {
          return new RegExp("^(?:" + t3.map(_).join("|") + ")", "i");
        }
        function T(t3) {
          for (var e3 = {}, r3 = -1, n3 = t3.length; ++r3 < n3; )
            e3[t3[r3].toLowerCase()] = r3;
          return e3;
        }
        function k(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 1));
          return n3 ? (t3.w = +n3[0], r3 + n3[0].length) : -1;
        }
        function A(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 1));
          return n3 ? (t3.u = +n3[0], r3 + n3[0].length) : -1;
        }
        function M(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 2));
          return n3 ? (t3.U = +n3[0], r3 + n3[0].length) : -1;
        }
        function S(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 2));
          return n3 ? (t3.V = +n3[0], r3 + n3[0].length) : -1;
        }
        function E(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 2));
          return n3 ? (t3.W = +n3[0], r3 + n3[0].length) : -1;
        }
        function L(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 4));
          return n3 ? (t3.y = +n3[0], r3 + n3[0].length) : -1;
        }
        function C(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 2));
          return n3 ? (t3.y = +n3[0] + (+n3[0] > 68 ? 1900 : 2e3), r3 + n3[0].length) : -1;
        }
        function P(t3, e3, r3) {
          var n3 = /^(Z)|([+-]\d\d)(?::?(\d\d))?/.exec(e3.slice(r3, r3 + 6));
          return n3 ? (t3.Z = n3[1] ? 0 : -(n3[2] + (n3[3] || "00")), r3 + n3[0].length) : -1;
        }
        function O(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 1));
          return n3 ? (t3.q = 3 * n3[0] - 3, r3 + n3[0].length) : -1;
        }
        function I(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 2));
          return n3 ? (t3.m = n3[0] - 1, r3 + n3[0].length) : -1;
        }
        function D(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 2));
          return n3 ? (t3.d = +n3[0], r3 + n3[0].length) : -1;
        }
        function z(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 3));
          return n3 ? (t3.m = 0, t3.d = +n3[0], r3 + n3[0].length) : -1;
        }
        function R(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 2));
          return n3 ? (t3.H = +n3[0], r3 + n3[0].length) : -1;
        }
        function F(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 2));
          return n3 ? (t3.M = +n3[0], r3 + n3[0].length) : -1;
        }
        function B(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 2));
          return n3 ? (t3.S = +n3[0], r3 + n3[0].length) : -1;
        }
        function N(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 3));
          return n3 ? (t3.L = +n3[0], r3 + n3[0].length) : -1;
        }
        function j(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3, r3 + 6));
          return n3 ? (t3.L = Math.floor(n3[0] / 1e3), r3 + n3[0].length) : -1;
        }
        function U(t3, e3, r3) {
          var n3 = m2.exec(e3.slice(r3, r3 + 1));
          return n3 ? r3 + n3[0].length : -1;
        }
        function V(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3));
          return n3 ? (t3.Q = +n3[0], r3 + n3[0].length) : -1;
        }
        function H(t3, e3, r3) {
          var n3 = y.exec(e3.slice(r3));
          return n3 ? (t3.s = +n3[0], r3 + n3[0].length) : -1;
        }
        function q2(t3, e3) {
          return b(t3.getDate(), e3, 2);
        }
        function G(t3, e3) {
          return b(t3.getHours(), e3, 2);
        }
        function Z(t3, e3) {
          return b(t3.getHours() % 12 || 12, e3, 2);
        }
        function Y(t3, e3) {
          return b(1 + o.Z.count((0, s.Z)(t3), t3), e3, 3);
        }
        function W(t3, e3) {
          return b(t3.getMilliseconds(), e3, 3);
        }
        function X(t3, e3) {
          return W(t3, e3) + "000";
        }
        function J(t3, e3) {
          return b(t3.getMonth() + 1, e3, 2);
        }
        function K(t3, e3) {
          return b(t3.getMinutes(), e3, 2);
        }
        function $(t3, e3) {
          return b(t3.getSeconds(), e3, 2);
        }
        function Q(t3) {
          var e3 = t3.getDay();
          return 0 === e3 ? 7 : e3;
        }
        function tt(t3, e3) {
          return b(a.OM.count((0, s.Z)(t3) - 1, t3), e3, 2);
        }
        function et(t3, e3) {
          var r3 = t3.getDay();
          return t3 = r3 >= 4 || 0 === r3 ? (0, a.bL)(t3) : a.bL.ceil(t3), b(a.bL.count((0, s.Z)(t3), t3) + (4 === (0, s.Z)(t3).getDay()), e3, 2);
        }
        function rt(t3) {
          return t3.getDay();
        }
        function nt(t3, e3) {
          return b(a.wA.count((0, s.Z)(t3) - 1, t3), e3, 2);
        }
        function it(t3, e3) {
          return b(t3.getFullYear() % 100, e3, 2);
        }
        function at(t3, e3) {
          return b(t3.getFullYear() % 1e4, e3, 4);
        }
        function ot(t3) {
          var e3 = t3.getTimezoneOffset();
          return (e3 > 0 ? "-" : (e3 *= -1, "+")) + b(e3 / 60 | 0, "0", 2) + b(e3 % 60, "0", 2);
        }
        function st(t3, e3) {
          return b(t3.getUTCDate(), e3, 2);
        }
        function lt(t3, e3) {
          return b(t3.getUTCHours(), e3, 2);
        }
        function ut(t3, e3) {
          return b(t3.getUTCHours() % 12 || 12, e3, 2);
        }
        function ct(t3, e3) {
          return b(1 + i.Z.count((0, l.Z)(t3), t3), e3, 3);
        }
        function ft(t3, e3) {
          return b(t3.getUTCMilliseconds(), e3, 3);
        }
        function ht(t3, e3) {
          return ft(t3, e3) + "000";
        }
        function pt(t3, e3) {
          return b(t3.getUTCMonth() + 1, e3, 2);
        }
        function dt(t3, e3) {
          return b(t3.getUTCMinutes(), e3, 2);
        }
        function vt(t3, e3) {
          return b(t3.getUTCSeconds(), e3, 2);
        }
        function gt(t3) {
          var e3 = t3.getUTCDay();
          return 0 === e3 ? 7 : e3;
        }
        function yt(t3, e3) {
          return b(n2.Ox.count((0, l.Z)(t3) - 1, t3), e3, 2);
        }
        function mt(t3, e3) {
          var r3 = t3.getUTCDay();
          return t3 = r3 >= 4 || 0 === r3 ? (0, n2.hB)(t3) : n2.hB.ceil(t3), b(n2.hB.count((0, l.Z)(t3), t3) + (4 === (0, l.Z)(t3).getUTCDay()), e3, 2);
        }
        function xt(t3) {
          return t3.getUTCDay();
        }
        function bt(t3, e3) {
          return b(n2.l6.count((0, l.Z)(t3) - 1, t3), e3, 2);
        }
        function _t(t3, e3) {
          return b(t3.getUTCFullYear() % 100, e3, 2);
        }
        function wt(t3, e3) {
          return b(t3.getUTCFullYear() % 1e4, e3, 4);
        }
        function Tt() {
          return "+0000";
        }
        function kt() {
          return "%";
        }
        function At(t3) {
          return +t3;
        }
        function Mt(t3) {
          return Math.floor(+t3 / 1e3);
        }
        p2 = h({ dateTime: "%x, %X", date: "%-m/%-d/%Y", time: "%-I:%M:%S %p", periods: ["AM", "PM"], days: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], shortDays: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], months: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], shortMonths: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"] }), d2 = p2.format, p2.parse, v = p2.utcFormat, p2.utcParse;
      }, 82301: function(t2, e2, r2) {
        r2.d(e2, { a: function() {
          return o;
        } });
        var n2 = r2(30052), i = r2(54263), a = (0, n2.Z)(function(t3) {
          t3.setHours(0, 0, 0, 0);
        }, function(t3, e3) {
          t3.setDate(t3.getDate() + e3);
        }, function(t3, e3) {
          return (e3 - t3 - (e3.getTimezoneOffset() - t3.getTimezoneOffset()) * i.yB) / i.UD;
        }, function(t3) {
          return t3.getDate() - 1;
        });
        e2.Z = a;
        var o = a.range;
      }, 54263: function(t2, e2, r2) {
        r2.d(e2, { UD: function() {
          return o;
        }, Y2: function() {
          return a;
        }, Ym: function() {
          return n2;
        }, iM: function() {
          return s;
        }, yB: function() {
          return i;
        } });
        var n2 = 1e3, i = 6e4, a = 36e5, o = 864e5, s = 6048e5;
      }, 81041: function(t2, e2, r2) {
        r2.r(e2), r2.d(e2, { timeDay: function() {
          return y.Z;
        }, timeDays: function() {
          return y.a;
        }, timeFriday: function() {
          return m2.mC;
        }, timeFridays: function() {
          return m2.b$;
        }, timeHour: function() {
          return v;
        }, timeHours: function() {
          return g2;
        }, timeInterval: function() {
          return n2.Z;
        }, timeMillisecond: function() {
          return a;
        }, timeMilliseconds: function() {
          return o;
        }, timeMinute: function() {
          return h;
        }, timeMinutes: function() {
          return p2;
        }, timeMonday: function() {
          return m2.wA;
        }, timeMondays: function() {
          return m2.bJ;
        }, timeMonth: function() {
          return b;
        }, timeMonths: function() {
          return _;
        }, timeSaturday: function() {
          return m2.EY;
        }, timeSaturdays: function() {
          return m2.Ff;
        }, timeSecond: function() {
          return u;
        }, timeSeconds: function() {
          return c;
        }, timeSunday: function() {
          return m2.OM;
        }, timeSundays: function() {
          return m2.vm;
        }, timeThursday: function() {
          return m2.bL;
        }, timeThursdays: function() {
          return m2.$t;
        }, timeTuesday: function() {
          return m2.sy;
        }, timeTuesdays: function() {
          return m2.aU;
        }, timeWednesday: function() {
          return m2.zg;
        }, timeWednesdays: function() {
          return m2.Ld;
        }, timeWeek: function() {
          return m2.OM;
        }, timeWeeks: function() {
          return m2.vm;
        }, timeYear: function() {
          return w2.Z;
        }, timeYears: function() {
          return w2.g;
        }, utcDay: function() {
          return L.Z;
        }, utcDays: function() {
          return L.y;
        }, utcFriday: function() {
          return C.QQ;
        }, utcFridays: function() {
          return C.fz;
        }, utcHour: function() {
          return S;
        }, utcHours: function() {
          return E;
        }, utcMillisecond: function() {
          return a;
        }, utcMilliseconds: function() {
          return o;
        }, utcMinute: function() {
          return k;
        }, utcMinutes: function() {
          return A;
        }, utcMonday: function() {
          return C.l6;
        }, utcMondays: function() {
          return C.$3;
        }, utcMonth: function() {
          return O;
        }, utcMonths: function() {
          return I;
        }, utcSaturday: function() {
          return C.g4;
        }, utcSaturdays: function() {
          return C.Q_;
        }, utcSecond: function() {
          return u;
        }, utcSeconds: function() {
          return c;
        }, utcSunday: function() {
          return C.Ox;
        }, utcSundays: function() {
          return C.SU;
        }, utcThursday: function() {
          return C.hB;
        }, utcThursdays: function() {
          return C.xj;
        }, utcTuesday: function() {
          return C.J1;
        }, utcTuesdays: function() {
          return C.DK;
        }, utcWednesday: function() {
          return C.b3;
        }, utcWednesdays: function() {
          return C.uy;
        }, utcWeek: function() {
          return C.Ox;
        }, utcWeeks: function() {
          return C.SU;
        }, utcYear: function() {
          return D.Z;
        }, utcYears: function() {
          return D.D;
        } });
        var n2 = r2(30052), i = (0, n2.Z)(function() {
        }, function(t3, e3) {
          t3.setTime(+t3 + e3);
        }, function(t3, e3) {
          return e3 - t3;
        });
        i.every = function(t3) {
          return t3 = Math.floor(t3), isFinite(t3) && t3 > 0 ? t3 > 1 ? (0, n2.Z)(function(e3) {
            e3.setTime(Math.floor(e3 / t3) * t3);
          }, function(e3, r3) {
            e3.setTime(+e3 + r3 * t3);
          }, function(e3, r3) {
            return (r3 - e3) / t3;
          }) : i : null;
        };
        var a = i, o = i.range, s = r2(54263), l = (0, n2.Z)(function(t3) {
          t3.setTime(t3 - t3.getMilliseconds());
        }, function(t3, e3) {
          t3.setTime(+t3 + e3 * s.Ym);
        }, function(t3, e3) {
          return (e3 - t3) / s.Ym;
        }, function(t3) {
          return t3.getUTCSeconds();
        }), u = l, c = l.range, f2 = (0, n2.Z)(function(t3) {
          t3.setTime(t3 - t3.getMilliseconds() - t3.getSeconds() * s.Ym);
        }, function(t3, e3) {
          t3.setTime(+t3 + e3 * s.yB);
        }, function(t3, e3) {
          return (e3 - t3) / s.yB;
        }, function(t3) {
          return t3.getMinutes();
        }), h = f2, p2 = f2.range, d2 = (0, n2.Z)(function(t3) {
          t3.setTime(t3 - t3.getMilliseconds() - t3.getSeconds() * s.Ym - t3.getMinutes() * s.yB);
        }, function(t3, e3) {
          t3.setTime(+t3 + e3 * s.Y2);
        }, function(t3, e3) {
          return (e3 - t3) / s.Y2;
        }, function(t3) {
          return t3.getHours();
        }), v = d2, g2 = d2.range, y = r2(82301), m2 = r2(59879), x = (0, n2.Z)(function(t3) {
          t3.setDate(1), t3.setHours(0, 0, 0, 0);
        }, function(t3, e3) {
          t3.setMonth(t3.getMonth() + e3);
        }, function(t3, e3) {
          return e3.getMonth() - t3.getMonth() + 12 * (e3.getFullYear() - t3.getFullYear());
        }, function(t3) {
          return t3.getMonth();
        }), b = x, _ = x.range, w2 = r2(34823), T = (0, n2.Z)(function(t3) {
          t3.setUTCSeconds(0, 0);
        }, function(t3, e3) {
          t3.setTime(+t3 + e3 * s.yB);
        }, function(t3, e3) {
          return (e3 - t3) / s.yB;
        }, function(t3) {
          return t3.getUTCMinutes();
        }), k = T, A = T.range, M = (0, n2.Z)(function(t3) {
          t3.setUTCMinutes(0, 0, 0);
        }, function(t3, e3) {
          t3.setTime(+t3 + e3 * s.Y2);
        }, function(t3, e3) {
          return (e3 - t3) / s.Y2;
        }, function(t3) {
          return t3.getUTCHours();
        }), S = M, E = M.range, L = r2(48480), C = r2(58176), P = (0, n2.Z)(function(t3) {
          t3.setUTCDate(1), t3.setUTCHours(0, 0, 0, 0);
        }, function(t3, e3) {
          t3.setUTCMonth(t3.getUTCMonth() + e3);
        }, function(t3, e3) {
          return e3.getUTCMonth() - t3.getUTCMonth() + 12 * (e3.getUTCFullYear() - t3.getUTCFullYear());
        }, function(t3) {
          return t3.getUTCMonth();
        }), O = P, I = P.range, D = r2(79791);
      }, 30052: function(t2, e2, r2) {
        r2.d(e2, { Z: function() {
          return a;
        } });
        var n2 = new Date(), i = new Date();
        function a(t3, e3, r3, o) {
          function s(e4) {
            return t3(e4 = 0 === arguments.length ? new Date() : new Date(+e4)), e4;
          }
          return s.floor = function(e4) {
            return t3(e4 = new Date(+e4)), e4;
          }, s.ceil = function(r4) {
            return t3(r4 = new Date(r4 - 1)), e3(r4, 1), t3(r4), r4;
          }, s.round = function(t4) {
            var e4 = s(t4), r4 = s.ceil(t4);
            return t4 - e4 < r4 - t4 ? e4 : r4;
          }, s.offset = function(t4, r4) {
            return e3(t4 = new Date(+t4), null == r4 ? 1 : Math.floor(r4)), t4;
          }, s.range = function(r4, n3, i2) {
            var a2, o2 = [];
            if (r4 = s.ceil(r4), i2 = null == i2 ? 1 : Math.floor(i2), !(r4 < n3 && i2 > 0))
              return o2;
            do {
              o2.push(a2 = new Date(+r4)), e3(r4, i2), t3(r4);
            } while (a2 < r4 && r4 < n3);
            return o2;
          }, s.filter = function(r4) {
            return a(function(e4) {
              if (e4 >= e4)
                for (; t3(e4), !r4(e4); )
                  e4.setTime(e4 - 1);
            }, function(t4, n3) {
              if (t4 >= t4)
                if (n3 < 0)
                  for (; ++n3 <= 0; )
                    for (; e3(t4, -1), !r4(t4); )
                      ;
                else
                  for (; --n3 >= 0; )
                    for (; e3(t4, 1), !r4(t4); )
                      ;
            });
          }, r3 && (s.count = function(e4, a2) {
            return n2.setTime(+e4), i.setTime(+a2), t3(n2), t3(i), Math.floor(r3(n2, i));
          }, s.every = function(t4) {
            return t4 = Math.floor(t4), isFinite(t4) && t4 > 0 ? t4 > 1 ? s.filter(o ? function(e4) {
              return o(e4) % t4 == 0;
            } : function(e4) {
              return s.count(0, e4) % t4 == 0;
            }) : s : null;
          }), s;
        }
      }, 48480: function(t2, e2, r2) {
        r2.d(e2, { y: function() {
          return o;
        } });
        var n2 = r2(30052), i = r2(54263), a = (0, n2.Z)(function(t3) {
          t3.setUTCHours(0, 0, 0, 0);
        }, function(t3, e3) {
          t3.setUTCDate(t3.getUTCDate() + e3);
        }, function(t3, e3) {
          return (e3 - t3) / i.UD;
        }, function(t3) {
          return t3.getUTCDate() - 1;
        });
        e2.Z = a;
        var o = a.range;
      }, 58176: function(t2, e2, r2) {
        r2.d(e2, { $3: function() {
          return d2;
        }, DK: function() {
          return v;
        }, J1: function() {
          return l;
        }, Ox: function() {
          return o;
        }, QQ: function() {
          return f2;
        }, Q_: function() {
          return x;
        }, SU: function() {
          return p2;
        }, b3: function() {
          return u;
        }, fz: function() {
          return m2;
        }, g4: function() {
          return h;
        }, hB: function() {
          return c;
        }, l6: function() {
          return s;
        }, uy: function() {
          return g2;
        }, xj: function() {
          return y;
        } });
        var n2 = r2(30052), i = r2(54263);
        function a(t3) {
          return (0, n2.Z)(function(e3) {
            e3.setUTCDate(e3.getUTCDate() - (e3.getUTCDay() + 7 - t3) % 7), e3.setUTCHours(0, 0, 0, 0);
          }, function(t4, e3) {
            t4.setUTCDate(t4.getUTCDate() + 7 * e3);
          }, function(t4, e3) {
            return (e3 - t4) / i.iM;
          });
        }
        var o = a(0), s = a(1), l = a(2), u = a(3), c = a(4), f2 = a(5), h = a(6), p2 = o.range, d2 = s.range, v = l.range, g2 = u.range, y = c.range, m2 = f2.range, x = h.range;
      }, 79791: function(t2, e2, r2) {
        r2.d(e2, { D: function() {
          return a;
        } });
        var n2 = r2(30052), i = (0, n2.Z)(function(t3) {
          t3.setUTCMonth(0, 1), t3.setUTCHours(0, 0, 0, 0);
        }, function(t3, e3) {
          t3.setUTCFullYear(t3.getUTCFullYear() + e3);
        }, function(t3, e3) {
          return e3.getUTCFullYear() - t3.getUTCFullYear();
        }, function(t3) {
          return t3.getUTCFullYear();
        });
        i.every = function(t3) {
          return isFinite(t3 = Math.floor(t3)) && t3 > 0 ? (0, n2.Z)(function(e3) {
            e3.setUTCFullYear(Math.floor(e3.getUTCFullYear() / t3) * t3), e3.setUTCMonth(0, 1), e3.setUTCHours(0, 0, 0, 0);
          }, function(e3, r3) {
            e3.setUTCFullYear(e3.getUTCFullYear() + r3 * t3);
          }) : null;
        }, e2.Z = i;
        var a = i.range;
      }, 59879: function(t2, e2, r2) {
        r2.d(e2, { $t: function() {
          return y;
        }, EY: function() {
          return h;
        }, Ff: function() {
          return x;
        }, Ld: function() {
          return g2;
        }, OM: function() {
          return o;
        }, aU: function() {
          return v;
        }, b$: function() {
          return m2;
        }, bJ: function() {
          return d2;
        }, bL: function() {
          return c;
        }, mC: function() {
          return f2;
        }, sy: function() {
          return l;
        }, vm: function() {
          return p2;
        }, wA: function() {
          return s;
        }, zg: function() {
          return u;
        } });
        var n2 = r2(30052), i = r2(54263);
        function a(t3) {
          return (0, n2.Z)(function(e3) {
            e3.setDate(e3.getDate() - (e3.getDay() + 7 - t3) % 7), e3.setHours(0, 0, 0, 0);
          }, function(t4, e3) {
            t4.setDate(t4.getDate() + 7 * e3);
          }, function(t4, e3) {
            return (e3 - t4 - (e3.getTimezoneOffset() - t4.getTimezoneOffset()) * i.yB) / i.iM;
          });
        }
        var o = a(0), s = a(1), l = a(2), u = a(3), c = a(4), f2 = a(5), h = a(6), p2 = o.range, d2 = s.range, v = l.range, g2 = u.range, y = c.range, m2 = f2.range, x = h.range;
      }, 34823: function(t2, e2, r2) {
        r2.d(e2, { g: function() {
          return a;
        } });
        var n2 = r2(30052), i = (0, n2.Z)(function(t3) {
          t3.setMonth(0, 1), t3.setHours(0, 0, 0, 0);
        }, function(t3, e3) {
          t3.setFullYear(t3.getFullYear() + e3);
        }, function(t3, e3) {
          return e3.getFullYear() - t3.getFullYear();
        }, function(t3) {
          return t3.getFullYear();
        });
        i.every = function(t3) {
          return isFinite(t3 = Math.floor(t3)) && t3 > 0 ? (0, n2.Z)(function(e3) {
            e3.setFullYear(Math.floor(e3.getFullYear() / t3) * t3), e3.setMonth(0, 1), e3.setHours(0, 0, 0, 0);
          }, function(e3, r3) {
            e3.setFullYear(e3.getFullYear() + r3 * t3);
          }) : null;
        }, e2.Z = i;
        var a = i.range;
      }, 17045: function(t2, e2, r2) {
        var n2 = r2(8709), i = "function" == typeof Symbol && "symbol" == typeof Symbol("foo"), a = Object.prototype.toString, o = Array.prototype.concat, s = Object.defineProperty, l = r2(55622)(), u = s && l, c = function(t3, e3, r3, n3) {
          if (e3 in t3) {
            if (true === n3) {
              if (t3[e3] === r3)
                return;
            } else if ("function" != typeof (i2 = n3) || "[object Function]" !== a.call(i2) || !n3())
              return;
          }
          var i2;
          u ? s(t3, e3, { configurable: true, enumerable: false, value: r3, writable: true }) : t3[e3] = r3;
        }, f2 = function(t3, e3) {
          var r3 = arguments.length > 2 ? arguments[2] : {}, a2 = n2(e3);
          i && (a2 = o.call(a2, Object.getOwnPropertySymbols(e3)));
          for (var s2 = 0; s2 < a2.length; s2 += 1)
            c(t3, a2[s2], e3[a2[s2]], r3[a2[s2]]);
        };
        f2.supportsDescriptors = !!u, t2.exports = f2;
      }, 46775: function(t2) {
        t2.exports = function() {
          for (var t3 = 0; t3 < arguments.length; t3++)
            if (void 0 !== arguments[t3])
              return arguments[t3];
        };
      }, 53545: function(t2) {
        t2.exports = n2;
        var e2 = (n2.canvas = document.createElement("canvas")).getContext("2d"), r2 = i([32, 126]);
        function n2(t3, n3) {
          Array.isArray(t3) && (t3 = t3.join(", "));
          var a, o = {}, s = 16, l = 0.05;
          n3 && (2 === n3.length && "number" == typeof n3[0] ? a = i(n3) : Array.isArray(n3) ? a = n3 : (n3.o ? a = i(n3.o) : n3.pairs && (a = n3.pairs), n3.fontSize && (s = n3.fontSize), null != n3.threshold && (l = n3.threshold))), a || (a = r2), e2.font = s + "px " + t3;
          for (var u = 0; u < a.length; u++) {
            var c = a[u], f2 = e2.measureText(c[0]).width + e2.measureText(c[1]).width, h = e2.measureText(c).width;
            if (Math.abs(f2 - h) > s * l) {
              var p2 = (h - f2) / s;
              o[c] = 1e3 * p2;
            }
          }
          return o;
        }
        function i(t3) {
          for (var e3 = [], r3 = t3[0]; r3 <= t3[1]; r3++)
            for (var n3 = String.fromCharCode(r3), i2 = t3[0]; i2 < t3[1]; i2++) {
              var a = n3 + String.fromCharCode(i2);
              e3.push(a);
            }
          return e3;
        }
        n2.createPairs = i, n2.ascii = r2;
      }, 31457: function(t2, e2, r2) {
        var n2 = r2(65185), i = r2(18625), a = { M: "moveTo", C: "bezierCurveTo" };
        t2.exports = function(t3, e3) {
          t3.beginPath(), i(n2(e3)).forEach(function(e4) {
            var r3 = e4[0], n3 = e4.slice(1);
            t3[a[r3]].apply(t3, n3);
          }), t3.closePath();
        };
      }, 90660: function(t2) {
        t2.exports = function(t3) {
          switch (t3) {
            case "int8":
              return Int8Array;
            case "int16":
              return Int16Array;
            case "int32":
              return Int32Array;
            case "uint8":
              return Uint8Array;
            case "uint16":
              return Uint16Array;
            case "uint32":
              return Uint32Array;
            case "float32":
              return Float32Array;
            case "float64":
              return Float64Array;
            case "array":
              return Array;
            case "uint8_clamped":
              return Uint8ClampedArray;
          }
        };
      }, 12129: function(t2) {
        function e2(t3, r2, n2) {
          var i = 0 | t3[n2];
          if (i <= 0)
            return [];
          var a, o = new Array(i);
          if (n2 === t3.length - 1)
            for (a = 0; a < i; ++a)
              o[a] = r2;
          else
            for (a = 0; a < i; ++a)
              o[a] = e2(t3, r2, n2 + 1);
          return o;
        }
        t2.exports = function(t3, r2) {
          switch (void 0 === r2 && (r2 = 0), typeof t3) {
            case "number":
              if (t3 > 0)
                return function(t4, e3) {
                  var r3, n2;
                  for (r3 = new Array(t4), n2 = 0; n2 < t4; ++n2)
                    r3[n2] = e3;
                  return r3;
                }(0 | t3, r2);
              break;
            case "object":
              if ("number" == typeof t3.length)
                return e2(t3, r2, 0);
          }
          return [];
        };
      }, 11474: function(t2) {
        function e2(t3, e3, a2) {
          a2 = a2 || 2;
          var o2, s2, l2, f3, h2, d3, v2, g3 = e3 && e3.length, y2 = g3 ? e3[0] * a2 : t3.length, m3 = r2(t3, 0, y2, a2, true), x2 = [];
          if (!m3 || m3.next === m3.prev)
            return x2;
          if (g3 && (m3 = function(t4, e4, i2, a3) {
            var o3, s3, l3, f4 = [];
            for (o3 = 0, s3 = e4.length; o3 < s3; o3++)
              (l3 = r2(t4, e4[o3] * a3, o3 < s3 - 1 ? e4[o3 + 1] * a3 : t4.length, a3, false)) === l3.next && (l3.steiner = true), f4.push(p2(l3));
            for (f4.sort(u), o3 = 0; o3 < f4.length; o3++)
              c(f4[o3], i2), i2 = n2(i2, i2.next);
            return i2;
          }(t3, e3, m3, a2)), t3.length > 80 * a2) {
            o2 = l2 = t3[0], s2 = f3 = t3[1];
            for (var b2 = a2; b2 < y2; b2 += a2)
              (h2 = t3[b2]) < o2 && (o2 = h2), (d3 = t3[b2 + 1]) < s2 && (s2 = d3), h2 > l2 && (l2 = h2), d3 > f3 && (f3 = d3);
            v2 = 0 !== (v2 = Math.max(l2 - o2, f3 - s2)) ? 1 / v2 : 0;
          }
          return i(m3, x2, a2, o2, s2, v2), x2;
        }
        function r2(t3, e3, r3, n3, i2) {
          var a2, o2;
          if (i2 === M(t3, e3, r3, n3) > 0)
            for (a2 = e3; a2 < r3; a2 += n3)
              o2 = T(a2, t3[a2], t3[a2 + 1], o2);
          else
            for (a2 = r3 - n3; a2 >= e3; a2 -= n3)
              o2 = T(a2, t3[a2], t3[a2 + 1], o2);
          return o2 && y(o2, o2.next) && (k(o2), o2 = o2.next), o2;
        }
        function n2(t3, e3) {
          if (!t3)
            return t3;
          e3 || (e3 = t3);
          var r3, n3 = t3;
          do {
            if (r3 = false, n3.steiner || !y(n3, n3.next) && 0 !== g2(n3.prev, n3, n3.next))
              n3 = n3.next;
            else {
              if (k(n3), (n3 = e3 = n3.prev) === n3.next)
                break;
              r3 = true;
            }
          } while (r3 || n3 !== e3);
          return e3;
        }
        function i(t3, e3, r3, u2, c2, f3, p3) {
          if (t3) {
            !p3 && f3 && function(t4, e4, r4, n3) {
              var i2 = t4;
              do {
                null === i2.z && (i2.z = h(i2.x, i2.y, e4, r4, n3)), i2.prevZ = i2.prev, i2.nextZ = i2.next, i2 = i2.next;
              } while (i2 !== t4);
              i2.prevZ.nextZ = null, i2.prevZ = null, function(t5) {
                var e5, r5, n4, i3, a2, o2, s2, l2, u3 = 1;
                do {
                  for (r5 = t5, t5 = null, a2 = null, o2 = 0; r5; ) {
                    for (o2++, n4 = r5, s2 = 0, e5 = 0; e5 < u3 && (s2++, n4 = n4.nextZ); e5++)
                      ;
                    for (l2 = u3; s2 > 0 || l2 > 0 && n4; )
                      0 !== s2 && (0 === l2 || !n4 || r5.z <= n4.z) ? (i3 = r5, r5 = r5.nextZ, s2--) : (i3 = n4, n4 = n4.nextZ, l2--), a2 ? a2.nextZ = i3 : t5 = i3, i3.prevZ = a2, a2 = i3;
                    r5 = n4;
                  }
                  a2.nextZ = null, u3 *= 2;
                } while (o2 > 1);
              }(i2);
            }(t3, u2, c2, f3);
            for (var d3, v2, g3 = t3; t3.prev !== t3.next; )
              if (d3 = t3.prev, v2 = t3.next, f3 ? o(t3, u2, c2, f3) : a(t3))
                e3.push(d3.i / r3), e3.push(t3.i / r3), e3.push(v2.i / r3), k(t3), t3 = v2.next, g3 = v2.next;
              else if ((t3 = v2) === g3) {
                p3 ? 1 === p3 ? i(t3 = s(n2(t3), e3, r3), e3, r3, u2, c2, f3, 2) : 2 === p3 && l(t3, e3, r3, u2, c2, f3) : i(n2(t3), e3, r3, u2, c2, f3, 1);
                break;
              }
          }
        }
        function a(t3) {
          var e3 = t3.prev, r3 = t3, n3 = t3.next;
          if (g2(e3, r3, n3) >= 0)
            return false;
          for (var i2 = t3.next.next; i2 !== t3.prev; ) {
            if (d2(e3.x, e3.y, r3.x, r3.y, n3.x, n3.y, i2.x, i2.y) && g2(i2.prev, i2, i2.next) >= 0)
              return false;
            i2 = i2.next;
          }
          return true;
        }
        function o(t3, e3, r3, n3) {
          var i2 = t3.prev, a2 = t3, o2 = t3.next;
          if (g2(i2, a2, o2) >= 0)
            return false;
          for (var s2 = i2.x < a2.x ? i2.x < o2.x ? i2.x : o2.x : a2.x < o2.x ? a2.x : o2.x, l2 = i2.y < a2.y ? i2.y < o2.y ? i2.y : o2.y : a2.y < o2.y ? a2.y : o2.y, u2 = i2.x > a2.x ? i2.x > o2.x ? i2.x : o2.x : a2.x > o2.x ? a2.x : o2.x, c2 = i2.y > a2.y ? i2.y > o2.y ? i2.y : o2.y : a2.y > o2.y ? a2.y : o2.y, f3 = h(s2, l2, e3, r3, n3), p3 = h(u2, c2, e3, r3, n3), v2 = t3.prevZ, y2 = t3.nextZ; v2 && v2.z >= f3 && y2 && y2.z <= p3; ) {
            if (v2 !== t3.prev && v2 !== t3.next && d2(i2.x, i2.y, a2.x, a2.y, o2.x, o2.y, v2.x, v2.y) && g2(v2.prev, v2, v2.next) >= 0)
              return false;
            if (v2 = v2.prevZ, y2 !== t3.prev && y2 !== t3.next && d2(i2.x, i2.y, a2.x, a2.y, o2.x, o2.y, y2.x, y2.y) && g2(y2.prev, y2, y2.next) >= 0)
              return false;
            y2 = y2.nextZ;
          }
          for (; v2 && v2.z >= f3; ) {
            if (v2 !== t3.prev && v2 !== t3.next && d2(i2.x, i2.y, a2.x, a2.y, o2.x, o2.y, v2.x, v2.y) && g2(v2.prev, v2, v2.next) >= 0)
              return false;
            v2 = v2.prevZ;
          }
          for (; y2 && y2.z <= p3; ) {
            if (y2 !== t3.prev && y2 !== t3.next && d2(i2.x, i2.y, a2.x, a2.y, o2.x, o2.y, y2.x, y2.y) && g2(y2.prev, y2, y2.next) >= 0)
              return false;
            y2 = y2.nextZ;
          }
          return true;
        }
        function s(t3, e3, r3) {
          var i2 = t3;
          do {
            var a2 = i2.prev, o2 = i2.next.next;
            !y(a2, o2) && m2(a2, i2, i2.next, o2) && _(a2, o2) && _(o2, a2) && (e3.push(a2.i / r3), e3.push(i2.i / r3), e3.push(o2.i / r3), k(i2), k(i2.next), i2 = t3 = o2), i2 = i2.next;
          } while (i2 !== t3);
          return n2(i2);
        }
        function l(t3, e3, r3, a2, o2, s2) {
          var l2 = t3;
          do {
            for (var u2 = l2.next.next; u2 !== l2.prev; ) {
              if (l2.i !== u2.i && v(l2, u2)) {
                var c2 = w2(l2, u2);
                return l2 = n2(l2, l2.next), c2 = n2(c2, c2.next), i(l2, e3, r3, a2, o2, s2), void i(c2, e3, r3, a2, o2, s2);
              }
              u2 = u2.next;
            }
            l2 = l2.next;
          } while (l2 !== t3);
        }
        function u(t3, e3) {
          return t3.x - e3.x;
        }
        function c(t3, e3) {
          if (e3 = function(t4, e4) {
            var r4, n3 = e4, i2 = t4.x, a2 = t4.y, o2 = -1 / 0;
            do {
              if (a2 <= n3.y && a2 >= n3.next.y && n3.next.y !== n3.y) {
                var s2 = n3.x + (a2 - n3.y) * (n3.next.x - n3.x) / (n3.next.y - n3.y);
                if (s2 <= i2 && s2 > o2) {
                  if (o2 = s2, s2 === i2) {
                    if (a2 === n3.y)
                      return n3;
                    if (a2 === n3.next.y)
                      return n3.next;
                  }
                  r4 = n3.x < n3.next.x ? n3 : n3.next;
                }
              }
              n3 = n3.next;
            } while (n3 !== e4);
            if (!r4)
              return null;
            if (i2 === o2)
              return r4;
            var l2, u2 = r4, c2 = r4.x, h2 = r4.y, p3 = 1 / 0;
            n3 = r4;
            do {
              i2 >= n3.x && n3.x >= c2 && i2 !== n3.x && d2(a2 < h2 ? i2 : o2, a2, c2, h2, a2 < h2 ? o2 : i2, a2, n3.x, n3.y) && (l2 = Math.abs(a2 - n3.y) / (i2 - n3.x), _(n3, t4) && (l2 < p3 || l2 === p3 && (n3.x > r4.x || n3.x === r4.x && f2(r4, n3))) && (r4 = n3, p3 = l2)), n3 = n3.next;
            } while (n3 !== u2);
            return r4;
          }(t3, e3), e3) {
            var r3 = w2(e3, t3);
            n2(e3, e3.next), n2(r3, r3.next);
          }
        }
        function f2(t3, e3) {
          return g2(t3.prev, t3, e3.prev) < 0 && g2(e3.next, t3, t3.next) < 0;
        }
        function h(t3, e3, r3, n3, i2) {
          return (t3 = 1431655765 & ((t3 = 858993459 & ((t3 = 252645135 & ((t3 = 16711935 & ((t3 = 32767 * (t3 - r3) * i2) | t3 << 8)) | t3 << 4)) | t3 << 2)) | t3 << 1)) | (e3 = 1431655765 & ((e3 = 858993459 & ((e3 = 252645135 & ((e3 = 16711935 & ((e3 = 32767 * (e3 - n3) * i2) | e3 << 8)) | e3 << 4)) | e3 << 2)) | e3 << 1)) << 1;
        }
        function p2(t3) {
          var e3 = t3, r3 = t3;
          do {
            (e3.x < r3.x || e3.x === r3.x && e3.y < r3.y) && (r3 = e3), e3 = e3.next;
          } while (e3 !== t3);
          return r3;
        }
        function d2(t3, e3, r3, n3, i2, a2, o2, s2) {
          return (i2 - o2) * (e3 - s2) - (t3 - o2) * (a2 - s2) >= 0 && (t3 - o2) * (n3 - s2) - (r3 - o2) * (e3 - s2) >= 0 && (r3 - o2) * (a2 - s2) - (i2 - o2) * (n3 - s2) >= 0;
        }
        function v(t3, e3) {
          return t3.next.i !== e3.i && t3.prev.i !== e3.i && !function(t4, e4) {
            var r3 = t4;
            do {
              if (r3.i !== t4.i && r3.next.i !== t4.i && r3.i !== e4.i && r3.next.i !== e4.i && m2(r3, r3.next, t4, e4))
                return true;
              r3 = r3.next;
            } while (r3 !== t4);
            return false;
          }(t3, e3) && (_(t3, e3) && _(e3, t3) && function(t4, e4) {
            var r3 = t4, n3 = false, i2 = (t4.x + e4.x) / 2, a2 = (t4.y + e4.y) / 2;
            do {
              r3.y > a2 != r3.next.y > a2 && r3.next.y !== r3.y && i2 < (r3.next.x - r3.x) * (a2 - r3.y) / (r3.next.y - r3.y) + r3.x && (n3 = !n3), r3 = r3.next;
            } while (r3 !== t4);
            return n3;
          }(t3, e3) && (g2(t3.prev, t3, e3.prev) || g2(t3, e3.prev, e3)) || y(t3, e3) && g2(t3.prev, t3, t3.next) > 0 && g2(e3.prev, e3, e3.next) > 0);
        }
        function g2(t3, e3, r3) {
          return (e3.y - t3.y) * (r3.x - e3.x) - (e3.x - t3.x) * (r3.y - e3.y);
        }
        function y(t3, e3) {
          return t3.x === e3.x && t3.y === e3.y;
        }
        function m2(t3, e3, r3, n3) {
          var i2 = b(g2(t3, e3, r3)), a2 = b(g2(t3, e3, n3)), o2 = b(g2(r3, n3, t3)), s2 = b(g2(r3, n3, e3));
          return i2 !== a2 && o2 !== s2 || !(0 !== i2 || !x(t3, r3, e3)) || !(0 !== a2 || !x(t3, n3, e3)) || !(0 !== o2 || !x(r3, t3, n3)) || !(0 !== s2 || !x(r3, e3, n3));
        }
        function x(t3, e3, r3) {
          return e3.x <= Math.max(t3.x, r3.x) && e3.x >= Math.min(t3.x, r3.x) && e3.y <= Math.max(t3.y, r3.y) && e3.y >= Math.min(t3.y, r3.y);
        }
        function b(t3) {
          return t3 > 0 ? 1 : t3 < 0 ? -1 : 0;
        }
        function _(t3, e3) {
          return g2(t3.prev, t3, t3.next) < 0 ? g2(t3, e3, t3.next) >= 0 && g2(t3, t3.prev, e3) >= 0 : g2(t3, e3, t3.prev) < 0 || g2(t3, t3.next, e3) < 0;
        }
        function w2(t3, e3) {
          var r3 = new A(t3.i, t3.x, t3.y), n3 = new A(e3.i, e3.x, e3.y), i2 = t3.next, a2 = e3.prev;
          return t3.next = e3, e3.prev = t3, r3.next = i2, i2.prev = r3, n3.next = r3, r3.prev = n3, a2.next = n3, n3.prev = a2, n3;
        }
        function T(t3, e3, r3, n3) {
          var i2 = new A(t3, e3, r3);
          return n3 ? (i2.next = n3.next, i2.prev = n3, n3.next.prev = i2, n3.next = i2) : (i2.prev = i2, i2.next = i2), i2;
        }
        function k(t3) {
          t3.next.prev = t3.prev, t3.prev.next = t3.next, t3.prevZ && (t3.prevZ.nextZ = t3.nextZ), t3.nextZ && (t3.nextZ.prevZ = t3.prevZ);
        }
        function A(t3, e3, r3) {
          this.i = t3, this.x = e3, this.y = r3, this.prev = null, this.next = null, this.z = null, this.prevZ = null, this.nextZ = null, this.steiner = false;
        }
        function M(t3, e3, r3, n3) {
          for (var i2 = 0, a2 = e3, o2 = r3 - n3; a2 < r3; a2 += n3)
            i2 += (t3[o2] - t3[a2]) * (t3[a2 + 1] + t3[o2 + 1]), o2 = a2;
          return i2;
        }
        t2.exports = e2, t2.exports.default = e2, e2.deviation = function(t3, e3, r3, n3) {
          var i2 = e3 && e3.length, a2 = i2 ? e3[0] * r3 : t3.length, o2 = Math.abs(M(t3, 0, a2, r3));
          if (i2)
            for (var s2 = 0, l2 = e3.length; s2 < l2; s2++) {
              var u2 = e3[s2] * r3, c2 = s2 < l2 - 1 ? e3[s2 + 1] * r3 : t3.length;
              o2 -= Math.abs(M(t3, u2, c2, r3));
            }
          var f3 = 0;
          for (s2 = 0; s2 < n3.length; s2 += 3) {
            var h2 = n3[s2] * r3, p3 = n3[s2 + 1] * r3, d3 = n3[s2 + 2] * r3;
            f3 += Math.abs((t3[h2] - t3[d3]) * (t3[p3 + 1] - t3[h2 + 1]) - (t3[h2] - t3[p3]) * (t3[d3 + 1] - t3[h2 + 1]));
          }
          return 0 === o2 && 0 === f3 ? 0 : Math.abs((f3 - o2) / o2);
        }, e2.flatten = function(t3) {
          for (var e3 = t3[0][0].length, r3 = { vertices: [], holes: [], dimensions: e3 }, n3 = 0, i2 = 0; i2 < t3.length; i2++) {
            for (var a2 = 0; a2 < t3[i2].length; a2++)
              for (var o2 = 0; o2 < e3; o2++)
                r3.vertices.push(t3[i2][a2][o2]);
            i2 > 0 && (n3 += t3[i2 - 1].length, r3.holes.push(n3));
          }
          return r3;
        };
      }, 2502: function(t2, e2, r2) {
        var n2 = r2(68664);
        t2.exports = function(t3, e3) {
          var r3, i = [], a = [], o = [], s = {}, l = [];
          function u(t4) {
            o[t4] = false, s.hasOwnProperty(t4) && Object.keys(s[t4]).forEach(function(e4) {
              delete s[t4][e4], o[e4] && u(e4);
            });
          }
          function c(t4) {
            var e4, n3, i2 = false;
            for (a.push(t4), o[t4] = true, e4 = 0; e4 < l[t4].length; e4++)
              (n3 = l[t4][e4]) === r3 ? (f2(r3, a), i2 = true) : o[n3] || (i2 = c(n3));
            if (i2)
              u(t4);
            else
              for (e4 = 0; e4 < l[t4].length; e4++) {
                n3 = l[t4][e4];
                var h2 = s[n3];
                h2 || (h2 = {}, s[n3] = h2), h2[n3] = true;
              }
            return a.pop(), i2;
          }
          function f2(t4, r4) {
            var n3 = [].concat(r4).concat(t4);
            e3 ? e3(c) : i.push(n3);
          }
          function h(e4) {
            !function(e5) {
              for (var r5 = 0; r5 < t3.length; r5++)
                r5 < e5 && (t3[r5] = []), t3[r5] = t3[r5].filter(function(t4) {
                  return t4 >= e5;
                });
            }(e4);
            for (var r4, i2 = n2(t3).components.filter(function(t4) {
              return t4.length > 1;
            }), a2 = 1 / 0, o2 = 0; o2 < i2.length; o2++)
              for (var s2 = 0; s2 < i2[o2].length; s2++)
                i2[o2][s2] < a2 && (a2 = i2[o2][s2], r4 = o2);
            var l2 = i2[r4];
            if (!l2)
              return false;
            var u2 = t3.map(function(t4, e5) {
              return -1 === l2.indexOf(e5) ? [] : t4.filter(function(t5) {
                return -1 !== l2.indexOf(t5);
              });
            });
            return { leastVertex: a2, adjList: u2 };
          }
          r3 = 0;
          for (var p2 = t3.length; r3 < p2; ) {
            var d2 = h(r3);
            if (r3 = d2.leastVertex, l = d2.adjList) {
              for (var v = 0; v < l.length; v++)
                for (var g2 = 0; g2 < l[v].length; g2++) {
                  var y = l[v][g2];
                  o[+y] = false, s[y] = {};
                }
              c(r3), r3 += 1;
            } else
              r3 = p2;
          }
          return e3 ? void 0 : i;
        };
      }, 16134: function(t2, e2, r2) {
        var n2 = r2(36672);
        t2.exports = function() {
          return n2(this).length = 0, this;
        };
      }, 4892: function(t2, e2, r2) {
        t2.exports = r2(64404)() ? Array.from : r2(49441);
      }, 64404: function(t2) {
        t2.exports = function() {
          var t3, e2, r2 = Array.from;
          return "function" == typeof r2 && (e2 = r2(t3 = ["raz", "dwa"]), Boolean(e2 && e2 !== t3 && "dwa" === e2[1]));
        };
      }, 49441: function(t2, e2, r2) {
        var n2 = r2(8260).iterator, i = r2(73051), a = r2(33717), o = r2(35976), s = r2(78513), l = r2(36672), u = r2(95296), c = r2(87963), f2 = Array.isArray, h = Function.prototype.call, p2 = { configurable: true, enumerable: true, writable: true, value: null }, d2 = Object.defineProperty;
        t2.exports = function(t3) {
          var e3, r3, v, g2, y, m2, x, b, _, w2, T = arguments[1], k = arguments[2];
          if (t3 = Object(l(t3)), u(T) && s(T), this && this !== Array && a(this))
            e3 = this;
          else {
            if (!T) {
              if (i(t3))
                return 1 !== (y = t3.length) ? Array.apply(null, t3) : ((g2 = new Array(1))[0] = t3[0], g2);
              if (f2(t3)) {
                for (g2 = new Array(y = t3.length), r3 = 0; r3 < y; ++r3)
                  g2[r3] = t3[r3];
                return g2;
              }
            }
            g2 = [];
          }
          if (!f2(t3)) {
            if (void 0 !== (_ = t3[n2])) {
              for (x = s(_).call(t3), e3 && (g2 = new e3()), b = x.next(), r3 = 0; !b.done; )
                w2 = T ? h.call(T, k, b.value, r3) : b.value, e3 ? (p2.value = w2, d2(g2, r3, p2)) : g2[r3] = w2, b = x.next(), ++r3;
              y = r3;
            } else if (c(t3)) {
              for (y = t3.length, e3 && (g2 = new e3()), r3 = 0, v = 0; r3 < y; ++r3)
                w2 = t3[r3], r3 + 1 < y && (m2 = w2.charCodeAt(0)) >= 55296 && m2 <= 56319 && (w2 += t3[++r3]), w2 = T ? h.call(T, k, w2, v) : w2, e3 ? (p2.value = w2, d2(g2, v, p2)) : g2[v] = w2, ++v;
              y = v;
            }
          }
          if (void 0 === y)
            for (y = o(t3.length), e3 && (g2 = new e3(y)), r3 = 0; r3 < y; ++r3)
              w2 = T ? h.call(T, k, t3[r3], r3) : t3[r3], e3 ? (p2.value = w2, d2(g2, r3, p2)) : g2[r3] = w2;
          return e3 && (p2.value = null, g2.length = y), g2;
        };
      }, 73051: function(t2) {
        var e2 = Object.prototype.toString, r2 = e2.call(function() {
          return arguments;
        }());
        t2.exports = function(t3) {
          return e2.call(t3) === r2;
        };
      }, 33717: function(t2) {
        var e2 = Object.prototype.toString, r2 = RegExp.prototype.test.bind(/^[object [A-Za-z0-9]*Function]$/);
        t2.exports = function(t3) {
          return "function" == typeof t3 && r2(e2.call(t3));
        };
      }, 52345: function(t2) {
        t2.exports = function() {
        };
      }, 9953: function(t2, e2, r2) {
        t2.exports = r2(90436)() ? Math.sign : r2(6069);
      }, 90436: function(t2) {
        t2.exports = function() {
          var t3 = Math.sign;
          return "function" == typeof t3 && 1 === t3(10) && -1 === t3(-20);
        };
      }, 6069: function(t2) {
        t2.exports = function(t3) {
          return t3 = Number(t3), isNaN(t3) || 0 === t3 ? t3 : t3 > 0 ? 1 : -1;
        };
      }, 56247: function(t2, e2, r2) {
        var n2 = r2(9953), i = Math.abs, a = Math.floor;
        t2.exports = function(t3) {
          return isNaN(t3) ? 0 : 0 !== (t3 = Number(t3)) && isFinite(t3) ? n2(t3) * a(i(t3)) : t3;
        };
      }, 35976: function(t2, e2, r2) {
        var n2 = r2(56247), i = Math.max;
        t2.exports = function(t3) {
          return i(0, n2(t3));
        };
      }, 67260: function(t2, e2, r2) {
        var n2 = r2(78513), i = r2(36672), a = Function.prototype.bind, o = Function.prototype.call, s = Object.keys, l = Object.prototype.propertyIsEnumerable;
        t2.exports = function(t3, e3) {
          return function(r3, u) {
            var c, f2 = arguments[2], h = arguments[3];
            return r3 = Object(i(r3)), n2(u), c = s(r3), h && c.sort("function" == typeof h ? a.call(h, r3) : void 0), "function" != typeof t3 && (t3 = c[t3]), o.call(t3, c, function(t4, n3) {
              return l.call(r3, t4) ? o.call(u, f2, r3[t4], t4, r3, n3) : e3;
            });
          };
        };
      }, 95879: function(t2, e2, r2) {
        t2.exports = r2(73583)() ? Object.assign : r2(34205);
      }, 73583: function(t2) {
        t2.exports = function() {
          var t3, e2 = Object.assign;
          return "function" == typeof e2 && (e2(t3 = { foo: "raz" }, { bar: "dwa" }, { trzy: "trzy" }), t3.foo + t3.bar + t3.trzy === "razdwatrzy");
        };
      }, 34205: function(t2, e2, r2) {
        var n2 = r2(68700), i = r2(36672), a = Math.max;
        t2.exports = function(t3, e3) {
          var r3, o, s, l = a(arguments.length, 2);
          for (t3 = Object(i(t3)), s = function(n3) {
            try {
              t3[n3] = e3[n3];
            } catch (t4) {
              r3 || (r3 = t4);
            }
          }, o = 1; o < l; ++o)
            n2(e3 = arguments[o]).forEach(s);
          if (void 0 !== r3)
            throw r3;
          return t3;
        };
      }, 19012: function(t2, e2, r2) {
        var n2 = r2(4892), i = r2(95879), a = r2(36672);
        t2.exports = function(t3) {
          var e3 = Object(a(t3)), r3 = arguments[1], o = Object(arguments[2]);
          if (e3 !== t3 && !r3)
            return e3;
          var s = {};
          return r3 ? n2(r3, function(e4) {
            (o.ensure || e4 in t3) && (s[e4] = t3[e4]);
          }) : i(s, t3), s;
        };
      }, 52818: function(t2, e2, r2) {
        var n2, i, a, o, s = Object.create;
        r2(33247)() || (n2 = r2(51882)), t2.exports = n2 ? 1 !== n2.level ? s : (i = {}, a = {}, o = { configurable: false, enumerable: false, writable: true, value: void 0 }, Object.getOwnPropertyNames(Object.prototype).forEach(function(t3) {
          a[t3] = "__proto__" !== t3 ? o : { configurable: true, enumerable: false, writable: true, value: void 0 };
        }), Object.defineProperties(i, a), Object.defineProperty(n2, "nullPolyfill", { configurable: false, enumerable: false, writable: false, value: i }), function(t3, e3) {
          return s(null === t3 ? i : t3, e3);
        }) : s;
      }, 96437: function(t2, e2, r2) {
        t2.exports = r2(67260)("forEach");
      }, 99611: function(t2, e2, r2) {
        var n2 = r2(95296), i = { function: true, object: true };
        t2.exports = function(t3) {
          return n2(t3) && i[typeof t3] || false;
        };
      }, 95296: function(t2, e2, r2) {
        var n2 = r2(52345)();
        t2.exports = function(t3) {
          return t3 !== n2 && null !== t3;
        };
      }, 68700: function(t2, e2, r2) {
        t2.exports = r2(13895)() ? Object.keys : r2(25217);
      }, 13895: function(t2) {
        t2.exports = function() {
          try {
            return Object.keys("primitive"), true;
          } catch (t3) {
            return false;
          }
        };
      }, 25217: function(t2, e2, r2) {
        var n2 = r2(95296), i = Object.keys;
        t2.exports = function(t3) {
          return i(n2(t3) ? Object(t3) : t3);
        };
      }, 16906: function(t2, e2, r2) {
        var n2 = r2(78513), i = r2(96437), a = Function.prototype.call;
        t2.exports = function(t3, e3) {
          var r3 = {}, o = arguments[2];
          return n2(e3), i(t3, function(t4, n3, i2, s) {
            r3[n3] = a.call(e3, o, t4, n3, i2, s);
          }), r3;
        };
      }, 21780: function(t2, e2, r2) {
        var n2 = r2(95296), i = Array.prototype.forEach, a = Object.create, o = function(t3, e3) {
          var r3;
          for (r3 in t3)
            e3[r3] = t3[r3];
        };
        t2.exports = function(t3) {
          var e3 = a(null);
          return i.call(arguments, function(t4) {
            n2(t4) && o(Object(t4), e3);
          }), e3;
        };
      }, 1496: function(t2, e2, r2) {
        t2.exports = r2(33247)() ? Object.setPrototypeOf : r2(51882);
      }, 33247: function(t2) {
        var e2 = Object.create, r2 = Object.getPrototypeOf, n2 = {};
        t2.exports = function() {
          var t3 = Object.setPrototypeOf, i = arguments[0] || e2;
          return "function" == typeof t3 && r2(t3(i(null), n2)) === n2;
        };
      }, 51882: function(t2, e2, r2) {
        var n2, i, a, o, s = r2(99611), l = r2(36672), u = Object.prototype.isPrototypeOf, c = Object.defineProperty, f2 = { configurable: true, enumerable: false, writable: true, value: void 0 };
        n2 = function(t3, e3) {
          if (l(t3), null === e3 || s(e3))
            return t3;
          throw new TypeError("Prototype must be null or an object");
        }, t2.exports = (i = function() {
          var t3, e3 = /* @__PURE__ */ Object.create(null), r3 = {}, n3 = Object.getOwnPropertyDescriptor(Object.prototype, "__proto__");
          if (n3) {
            try {
              (t3 = n3.set).call(e3, r3);
            } catch (t4) {
            }
            if (Object.getPrototypeOf(e3) === r3)
              return { set: t3, level: 2 };
          }
          return e3.__proto__ = r3, Object.getPrototypeOf(e3) === r3 ? { level: 2 } : ((e3 = {}).__proto__ = r3, Object.getPrototypeOf(e3) === r3 && { level: 1 });
        }(), i ? (2 === i.level ? i.set ? (o = i.set, a = function(t3, e3) {
          return o.call(n2(t3, e3), e3), t3;
        }) : a = function(t3, e3) {
          return n2(t3, e3).__proto__ = e3, t3;
        } : a = function t3(e3, r3) {
          var i2;
          return n2(e3, r3), (i2 = u.call(t3.nullPolyfill, e3)) && delete t3.nullPolyfill.__proto__, null === r3 && (r3 = t3.nullPolyfill), e3.__proto__ = r3, i2 && c(t3.nullPolyfill, "__proto__", f2), e3;
        }, Object.defineProperty(a, "level", { configurable: false, enumerable: false, writable: false, value: i.level })) : null), r2(52818);
      }, 78513: function(t2) {
        t2.exports = function(t3) {
          if ("function" != typeof t3)
            throw new TypeError(t3 + " is not a function");
          return t3;
        };
      }, 98976: function(t2, e2, r2) {
        var n2 = r2(99611);
        t2.exports = function(t3) {
          if (!n2(t3))
            throw new TypeError(t3 + " is not an Object");
          return t3;
        };
      }, 36672: function(t2, e2, r2) {
        var n2 = r2(95296);
        t2.exports = function(t3) {
          if (!n2(t3))
            throw new TypeError("Cannot use null or undefined");
          return t3;
        };
      }, 66741: function(t2, e2, r2) {
        t2.exports = r2(17557)() ? String.prototype.contains : r2(60381);
      }, 17557: function(t2) {
        var e2 = "razdwatrzy";
        t2.exports = function() {
          return "function" == typeof e2.contains && true === e2.contains("dwa") && false === e2.contains("foo");
        };
      }, 60381: function(t2) {
        var e2 = String.prototype.indexOf;
        t2.exports = function(t3) {
          return e2.call(this, t3, arguments[1]) > -1;
        };
      }, 87963: function(t2) {
        var e2 = Object.prototype.toString, r2 = e2.call("");
        t2.exports = function(t3) {
          return "string" == typeof t3 || t3 && "object" == typeof t3 && (t3 instanceof String || e2.call(t3) === r2) || false;
        };
      }, 43043: function(t2) {
        var e2 = /* @__PURE__ */ Object.create(null), r2 = Math.random;
        t2.exports = function() {
          var t3;
          do {
            t3 = r2().toString(36).slice(2);
          } while (e2[t3]);
          return t3;
        };
      }, 32411: function(t2, e2, r2) {
        var n2, i = r2(1496), a = r2(66741), o = r2(62072), s = r2(8260), l = r2(95426), u = Object.defineProperty;
        n2 = t2.exports = function(t3, e3) {
          if (!(this instanceof n2))
            throw new TypeError("Constructor requires 'new'");
          l.call(this, t3), e3 = e3 ? a.call(e3, "key+value") ? "key+value" : a.call(e3, "key") ? "key" : "value" : "value", u(this, "__kind__", o("", e3));
        }, i && i(n2, l), delete n2.prototype.constructor, n2.prototype = Object.create(l.prototype, { _resolve: o(function(t3) {
          return "value" === this.__kind__ ? this.__list__[t3] : "key+value" === this.__kind__ ? [t3, this.__list__[t3]] : t3;
        }) }), u(n2.prototype, s.toStringTag, o("c", "Array Iterator"));
      }, 27515: function(t2, e2, r2) {
        var n2 = r2(73051), i = r2(78513), a = r2(87963), o = r2(66661), s = Array.isArray, l = Function.prototype.call, u = Array.prototype.some;
        t2.exports = function(t3, e3) {
          var r3, c, f2, h, p2, d2, v, g2, y = arguments[2];
          if (s(t3) || n2(t3) ? r3 = "array" : a(t3) ? r3 = "string" : t3 = o(t3), i(e3), f2 = function() {
            h = true;
          }, "array" !== r3)
            if ("string" !== r3)
              for (c = t3.next(); !c.done; ) {
                if (l.call(e3, y, c.value, f2), h)
                  return;
                c = t3.next();
              }
            else
              for (d2 = t3.length, p2 = 0; p2 < d2 && (v = t3[p2], p2 + 1 < d2 && (g2 = v.charCodeAt(0)) >= 55296 && g2 <= 56319 && (v += t3[++p2]), l.call(e3, y, v, f2), !h); ++p2)
                ;
          else
            u.call(t3, function(t4) {
              return l.call(e3, y, t4, f2), h;
            });
        };
      }, 66661: function(t2, e2, r2) {
        var n2 = r2(73051), i = r2(87963), a = r2(32411), o = r2(259), s = r2(58095), l = r2(8260).iterator;
        t2.exports = function(t3) {
          return "function" == typeof s(t3)[l] ? t3[l]() : n2(t3) ? new a(t3) : i(t3) ? new o(t3) : new a(t3);
        };
      }, 95426: function(t2, e2, r2) {
        var n2, i = r2(16134), a = r2(95879), o = r2(78513), s = r2(36672), l = r2(62072), u = r2(55174), c = r2(8260), f2 = Object.defineProperty, h = Object.defineProperties;
        t2.exports = n2 = function(t3, e3) {
          if (!(this instanceof n2))
            throw new TypeError("Constructor requires 'new'");
          h(this, { __list__: l("w", s(t3)), __context__: l("w", e3), __nextIndex__: l("w", 0) }), e3 && (o(e3.on), e3.on("_add", this._onAdd), e3.on("_delete", this._onDelete), e3.on("_clear", this._onClear));
        }, delete n2.prototype.constructor, h(n2.prototype, a({ _next: l(function() {
          var t3;
          if (this.__list__)
            return this.__redo__ && void 0 !== (t3 = this.__redo__.shift()) ? t3 : this.__nextIndex__ < this.__list__.length ? this.__nextIndex__++ : void this._unBind();
        }), next: l(function() {
          return this._createResult(this._next());
        }), _createResult: l(function(t3) {
          return void 0 === t3 ? { done: true, value: void 0 } : { done: false, value: this._resolve(t3) };
        }), _resolve: l(function(t3) {
          return this.__list__[t3];
        }), _unBind: l(function() {
          this.__list__ = null, delete this.__redo__, this.__context__ && (this.__context__.off("_add", this._onAdd), this.__context__.off("_delete", this._onDelete), this.__context__.off("_clear", this._onClear), this.__context__ = null);
        }), toString: l(function() {
          return "[object " + (this[c.toStringTag] || "Object") + "]";
        }) }, u({ _onAdd: l(function(t3) {
          t3 >= this.__nextIndex__ || (++this.__nextIndex__, this.__redo__ ? (this.__redo__.forEach(function(e3, r3) {
            e3 >= t3 && (this.__redo__[r3] = ++e3);
          }, this), this.__redo__.push(t3)) : f2(this, "__redo__", l("c", [t3])));
        }), _onDelete: l(function(t3) {
          var e3;
          t3 >= this.__nextIndex__ || (--this.__nextIndex__, this.__redo__ && (-1 !== (e3 = this.__redo__.indexOf(t3)) && this.__redo__.splice(e3, 1), this.__redo__.forEach(function(e4, r3) {
            e4 > t3 && (this.__redo__[r3] = --e4);
          }, this)));
        }), _onClear: l(function() {
          this.__redo__ && i.call(this.__redo__), this.__nextIndex__ = 0;
        }) }))), f2(n2.prototype, c.iterator, l(function() {
          return this;
        }));
      }, 35940: function(t2, e2, r2) {
        var n2 = r2(73051), i = r2(95296), a = r2(87963), o = r2(8260).iterator, s = Array.isArray;
        t2.exports = function(t3) {
          return !(!i(t3) || !s(t3) && !a(t3) && !n2(t3) && "function" != typeof t3[o]);
        };
      }, 259: function(t2, e2, r2) {
        var n2, i = r2(1496), a = r2(62072), o = r2(8260), s = r2(95426), l = Object.defineProperty;
        n2 = t2.exports = function(t3) {
          if (!(this instanceof n2))
            throw new TypeError("Constructor requires 'new'");
          t3 = String(t3), s.call(this, t3), l(this, "__length__", a("", t3.length));
        }, i && i(n2, s), delete n2.prototype.constructor, n2.prototype = Object.create(s.prototype, { _next: a(function() {
          if (this.__list__)
            return this.__nextIndex__ < this.__length__ ? this.__nextIndex__++ : void this._unBind();
        }), _resolve: a(function(t3) {
          var e3, r3 = this.__list__[t3];
          return this.__nextIndex__ === this.__length__ ? r3 : (e3 = r3.charCodeAt(0)) >= 55296 && e3 <= 56319 ? r3 + this.__list__[this.__nextIndex__++] : r3;
        }) }), l(n2.prototype, o.toStringTag, a("c", "String Iterator"));
      }, 58095: function(t2, e2, r2) {
        var n2 = r2(35940);
        t2.exports = function(t3) {
          if (!n2(t3))
            throw new TypeError(t3 + " is not iterable");
          return t3;
        };
      }, 73523: function(t2) {
        function e2(t3, e3) {
          if (null == t3)
            throw new TypeError("Cannot convert first argument to object");
          for (var r2 = Object(t3), n2 = 1; n2 < arguments.length; n2++) {
            var i = arguments[n2];
            if (null != i)
              for (var a = Object.keys(Object(i)), o = 0, s = a.length; o < s; o++) {
                var l = a[o], u = Object.getOwnPropertyDescriptor(i, l);
                void 0 !== u && u.enumerable && (r2[l] = i[l]);
              }
          }
          return r2;
        }
        t2.exports = { assign: e2, polyfill: function() {
          Object.assign || Object.defineProperty(Object, "assign", { enumerable: false, configurable: true, writable: true, value: e2 });
        } };
      }, 8260: function(t2, e2, r2) {
        t2.exports = r2(69711)() ? r2(94908).Symbol : r2(18415);
      }, 69711: function(t2, e2, r2) {
        var n2 = r2(94908), i = { object: true, symbol: true };
        t2.exports = function() {
          var t3, e3 = n2.Symbol;
          if ("function" != typeof e3)
            return false;
          t3 = e3("test symbol");
          try {
            String(t3);
          } catch (t4) {
            return false;
          }
          return !!i[typeof e3.iterator] && !!i[typeof e3.toPrimitive] && !!i[typeof e3.toStringTag];
        };
      }, 82276: function(t2) {
        t2.exports = function(t3) {
          return !!t3 && ("symbol" == typeof t3 || !!t3.constructor && "Symbol" === t3.constructor.name && "Symbol" === t3[t3.constructor.toStringTag]);
        };
      }, 29366: function(t2, e2, r2) {
        var n2 = r2(62072), i = Object.create, a = Object.defineProperty, o = Object.prototype, s = i(null);
        t2.exports = function(t3) {
          for (var e3, r3, i2 = 0; s[t3 + (i2 || "")]; )
            ++i2;
          return s[t3 += i2 || ""] = true, a(o, e3 = "@@" + t3, n2.gs(null, function(t4) {
            r3 || (r3 = true, a(this, e3, n2(t4)), r3 = false);
          })), e3;
        };
      }, 92842: function(t2, e2, r2) {
        var n2 = r2(62072), i = r2(94908).Symbol;
        t2.exports = function(t3) {
          return Object.defineProperties(t3, { hasInstance: n2("", i && i.hasInstance || t3("hasInstance")), isConcatSpreadable: n2("", i && i.isConcatSpreadable || t3("isConcatSpreadable")), iterator: n2("", i && i.iterator || t3("iterator")), match: n2("", i && i.match || t3("match")), replace: n2("", i && i.replace || t3("replace")), search: n2("", i && i.search || t3("search")), species: n2("", i && i.species || t3("species")), split: n2("", i && i.split || t3("split")), toPrimitive: n2("", i && i.toPrimitive || t3("toPrimitive")), toStringTag: n2("", i && i.toStringTag || t3("toStringTag")), unscopables: n2("", i && i.unscopables || t3("unscopables")) });
        };
      }, 13304: function(t2, e2, r2) {
        var n2 = r2(62072), i = r2(53308), a = /* @__PURE__ */ Object.create(null);
        t2.exports = function(t3) {
          return Object.defineProperties(t3, { for: n2(function(e3) {
            return a[e3] ? a[e3] : a[e3] = t3(String(e3));
          }), keyFor: n2(function(t4) {
            var e3;
            for (e3 in i(t4), a)
              if (a[e3] === t4)
                return e3;
          }) });
        };
      }, 18415: function(t2, e2, r2) {
        var n2, i, a, o = r2(62072), s = r2(53308), l = r2(94908).Symbol, u = r2(29366), c = r2(92842), f2 = r2(13304), h = Object.create, p2 = Object.defineProperties, d2 = Object.defineProperty;
        if ("function" == typeof l)
          try {
            String(l()), a = true;
          } catch (t3) {
          }
        else
          l = null;
        i = function(t3) {
          if (this instanceof i)
            throw new TypeError("Symbol is not a constructor");
          return n2(t3);
        }, t2.exports = n2 = function t3(e3) {
          var r3;
          if (this instanceof t3)
            throw new TypeError("Symbol is not a constructor");
          return a ? l(e3) : (r3 = h(i.prototype), e3 = void 0 === e3 ? "" : String(e3), p2(r3, { __description__: o("", e3), __name__: o("", u(e3)) }));
        }, c(n2), f2(n2), p2(i.prototype, { constructor: o(n2), toString: o("", function() {
          return this.__name__;
        }) }), p2(n2.prototype, { toString: o(function() {
          return "Symbol (" + s(this).__description__ + ")";
        }), valueOf: o(function() {
          return s(this);
        }) }), d2(n2.prototype, n2.toPrimitive, o("", function() {
          var t3 = s(this);
          return "symbol" == typeof t3 ? t3 : t3.toString();
        })), d2(n2.prototype, n2.toStringTag, o("c", "Symbol")), d2(i.prototype, n2.toStringTag, o("c", n2.prototype[n2.toStringTag])), d2(i.prototype, n2.toPrimitive, o("c", n2.prototype[n2.toPrimitive]));
      }, 53308: function(t2, e2, r2) {
        var n2 = r2(82276);
        t2.exports = function(t3) {
          if (!n2(t3))
            throw new TypeError(t3 + " is not a symbol");
          return t3;
        };
      }, 83522: function(t2, e2, r2) {
        t2.exports = r2(96402)() ? WeakMap : r2(329);
      }, 96402: function(t2) {
        t2.exports = function() {
          var t3, e2;
          if ("function" != typeof WeakMap)
            return false;
          try {
            t3 = new WeakMap([[e2 = {}, "one"], [{}, "two"], [{}, "three"]]);
          } catch (t4) {
            return false;
          }
          return "[object WeakMap]" === String(t3) && "function" == typeof t3.set && t3.set({}, 1) === t3 && "function" == typeof t3.delete && "function" == typeof t3.has && "one" === t3.get(e2);
        };
      }, 96416: function(t2) {
        t2.exports = "function" == typeof WeakMap && "[object WeakMap]" === Object.prototype.toString.call(/* @__PURE__ */ new WeakMap());
      }, 329: function(t2, e2, r2) {
        var n2, i = r2(95296), a = r2(1496), o = r2(98976), s = r2(36672), l = r2(43043), u = r2(62072), c = r2(66661), f2 = r2(27515), h = r2(8260).toStringTag, p2 = r2(96416), d2 = Array.isArray, v = Object.defineProperty, g2 = Object.prototype.hasOwnProperty, y = Object.getPrototypeOf;
        t2.exports = n2 = function() {
          var t3, e3 = arguments[0];
          if (!(this instanceof n2))
            throw new TypeError("Constructor requires 'new'");
          return t3 = p2 && a && WeakMap !== n2 ? a(/* @__PURE__ */ new WeakMap(), y(this)) : this, i(e3) && (d2(e3) || (e3 = c(e3))), v(t3, "__weakMapData__", u("c", "$weakMap$" + l())), e3 ? (f2(e3, function(e4) {
            s(e4), t3.set(e4[0], e4[1]);
          }), t3) : t3;
        }, p2 && (a && a(n2, WeakMap), n2.prototype = Object.create(WeakMap.prototype, { constructor: u(n2) })), Object.defineProperties(n2.prototype, { delete: u(function(t3) {
          return !!g2.call(o(t3), this.__weakMapData__) && (delete t3[this.__weakMapData__], true);
        }), get: u(function(t3) {
          if (g2.call(o(t3), this.__weakMapData__))
            return t3[this.__weakMapData__];
        }), has: u(function(t3) {
          return g2.call(o(t3), this.__weakMapData__);
        }), set: u(function(t3, e3) {
          return v(o(t3), this.__weakMapData__, u("c", e3)), this;
        }), toString: u(function() {
          return "[object WeakMap]";
        }) }), v(n2.prototype, h, u("c", "WeakMap"));
      }, 15398: function(t2) {
        var e2, r2 = "object" == typeof Reflect ? Reflect : null, n2 = r2 && "function" == typeof r2.apply ? r2.apply : function(t3, e3, r3) {
          return Function.prototype.apply.call(t3, e3, r3);
        };
        e2 = r2 && "function" == typeof r2.ownKeys ? r2.ownKeys : Object.getOwnPropertySymbols ? function(t3) {
          return Object.getOwnPropertyNames(t3).concat(Object.getOwnPropertySymbols(t3));
        } : function(t3) {
          return Object.getOwnPropertyNames(t3);
        };
        var i = Number.isNaN || function(t3) {
          return t3 != t3;
        };
        function a() {
          a.init.call(this);
        }
        t2.exports = a, t2.exports.once = function(t3, e3) {
          return new Promise(function(r3, n3) {
            function i2(r4) {
              t3.removeListener(e3, a2), n3(r4);
            }
            function a2() {
              "function" == typeof t3.removeListener && t3.removeListener("error", i2), r3([].slice.call(arguments));
            }
            v(t3, e3, a2, { once: true }), "error" !== e3 && function(t4, e4, r4) {
              "function" == typeof t4.on && v(t4, "error", e4, { once: true });
            }(t3, i2);
          });
        }, a.EventEmitter = a, a.prototype._events = void 0, a.prototype._eventsCount = 0, a.prototype._maxListeners = void 0;
        var o = 10;
        function s(t3) {
          if ("function" != typeof t3)
            throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof t3);
        }
        function l(t3) {
          return void 0 === t3._maxListeners ? a.defaultMaxListeners : t3._maxListeners;
        }
        function u(t3, e3, r3, n3) {
          var i2, a2, o2, u2;
          if (s(r3), void 0 === (a2 = t3._events) ? (a2 = t3._events = /* @__PURE__ */ Object.create(null), t3._eventsCount = 0) : (void 0 !== a2.newListener && (t3.emit("newListener", e3, r3.listener ? r3.listener : r3), a2 = t3._events), o2 = a2[e3]), void 0 === o2)
            o2 = a2[e3] = r3, ++t3._eventsCount;
          else if ("function" == typeof o2 ? o2 = a2[e3] = n3 ? [r3, o2] : [o2, r3] : n3 ? o2.unshift(r3) : o2.push(r3), (i2 = l(t3)) > 0 && o2.length > i2 && !o2.warned) {
            o2.warned = true;
            var c2 = new Error("Possible EventEmitter memory leak detected. " + o2.length + " " + String(e3) + " listeners added. Use emitter.setMaxListeners() to increase limit");
            c2.name = "MaxListenersExceededWarning", c2.emitter = t3, c2.type = e3, c2.count = o2.length, u2 = c2, console && console.warn && console.warn(u2);
          }
          return t3;
        }
        function c() {
          if (!this.fired)
            return this.target.removeListener(this.type, this.wrapFn), this.fired = true, 0 === arguments.length ? this.listener.call(this.target) : this.listener.apply(this.target, arguments);
        }
        function f2(t3, e3, r3) {
          var n3 = { fired: false, wrapFn: void 0, target: t3, type: e3, listener: r3 }, i2 = c.bind(n3);
          return i2.listener = r3, n3.wrapFn = i2, i2;
        }
        function h(t3, e3, r3) {
          var n3 = t3._events;
          if (void 0 === n3)
            return [];
          var i2 = n3[e3];
          return void 0 === i2 ? [] : "function" == typeof i2 ? r3 ? [i2.listener || i2] : [i2] : r3 ? function(t4) {
            for (var e4 = new Array(t4.length), r4 = 0; r4 < e4.length; ++r4)
              e4[r4] = t4[r4].listener || t4[r4];
            return e4;
          }(i2) : d2(i2, i2.length);
        }
        function p2(t3) {
          var e3 = this._events;
          if (void 0 !== e3) {
            var r3 = e3[t3];
            if ("function" == typeof r3)
              return 1;
            if (void 0 !== r3)
              return r3.length;
          }
          return 0;
        }
        function d2(t3, e3) {
          for (var r3 = new Array(e3), n3 = 0; n3 < e3; ++n3)
            r3[n3] = t3[n3];
          return r3;
        }
        function v(t3, e3, r3, n3) {
          if ("function" == typeof t3.on)
            n3.once ? t3.once(e3, r3) : t3.on(e3, r3);
          else {
            if ("function" != typeof t3.addEventListener)
              throw new TypeError('The "emitter" argument must be of type EventEmitter. Received type ' + typeof t3);
            t3.addEventListener(e3, function i2(a2) {
              n3.once && t3.removeEventListener(e3, i2), r3(a2);
            });
          }
        }
        Object.defineProperty(a, "defaultMaxListeners", { enumerable: true, get: function() {
          return o;
        }, set: function(t3) {
          if ("number" != typeof t3 || t3 < 0 || i(t3))
            throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + t3 + ".");
          o = t3;
        } }), a.init = function() {
          void 0 !== this._events && this._events !== Object.getPrototypeOf(this)._events || (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0), this._maxListeners = this._maxListeners || void 0;
        }, a.prototype.setMaxListeners = function(t3) {
          if ("number" != typeof t3 || t3 < 0 || i(t3))
            throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + t3 + ".");
          return this._maxListeners = t3, this;
        }, a.prototype.getMaxListeners = function() {
          return l(this);
        }, a.prototype.emit = function(t3) {
          for (var e3 = [], r3 = 1; r3 < arguments.length; r3++)
            e3.push(arguments[r3]);
          var i2 = "error" === t3, a2 = this._events;
          if (void 0 !== a2)
            i2 = i2 && void 0 === a2.error;
          else if (!i2)
            return false;
          if (i2) {
            var o2;
            if (e3.length > 0 && (o2 = e3[0]), o2 instanceof Error)
              throw o2;
            var s2 = new Error("Unhandled error." + (o2 ? " (" + o2.message + ")" : ""));
            throw s2.context = o2, s2;
          }
          var l2 = a2[t3];
          if (void 0 === l2)
            return false;
          if ("function" == typeof l2)
            n2(l2, this, e3);
          else {
            var u2 = l2.length, c2 = d2(l2, u2);
            for (r3 = 0; r3 < u2; ++r3)
              n2(c2[r3], this, e3);
          }
          return true;
        }, a.prototype.addListener = function(t3, e3) {
          return u(this, t3, e3, false);
        }, a.prototype.on = a.prototype.addListener, a.prototype.prependListener = function(t3, e3) {
          return u(this, t3, e3, true);
        }, a.prototype.once = function(t3, e3) {
          return s(e3), this.on(t3, f2(this, t3, e3)), this;
        }, a.prototype.prependOnceListener = function(t3, e3) {
          return s(e3), this.prependListener(t3, f2(this, t3, e3)), this;
        }, a.prototype.removeListener = function(t3, e3) {
          var r3, n3, i2, a2, o2;
          if (s(e3), void 0 === (n3 = this._events))
            return this;
          if (void 0 === (r3 = n3[t3]))
            return this;
          if (r3 === e3 || r3.listener === e3)
            0 == --this._eventsCount ? this._events = /* @__PURE__ */ Object.create(null) : (delete n3[t3], n3.removeListener && this.emit("removeListener", t3, r3.listener || e3));
          else if ("function" != typeof r3) {
            for (i2 = -1, a2 = r3.length - 1; a2 >= 0; a2--)
              if (r3[a2] === e3 || r3[a2].listener === e3) {
                o2 = r3[a2].listener, i2 = a2;
                break;
              }
            if (i2 < 0)
              return this;
            0 === i2 ? r3.shift() : function(t4, e4) {
              for (; e4 + 1 < t4.length; e4++)
                t4[e4] = t4[e4 + 1];
              t4.pop();
            }(r3, i2), 1 === r3.length && (n3[t3] = r3[0]), void 0 !== n3.removeListener && this.emit("removeListener", t3, o2 || e3);
          }
          return this;
        }, a.prototype.off = a.prototype.removeListener, a.prototype.removeAllListeners = function(t3) {
          var e3, r3, n3;
          if (void 0 === (r3 = this._events))
            return this;
          if (void 0 === r3.removeListener)
            return 0 === arguments.length ? (this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0) : void 0 !== r3[t3] && (0 == --this._eventsCount ? this._events = /* @__PURE__ */ Object.create(null) : delete r3[t3]), this;
          if (0 === arguments.length) {
            var i2, a2 = Object.keys(r3);
            for (n3 = 0; n3 < a2.length; ++n3)
              "removeListener" !== (i2 = a2[n3]) && this.removeAllListeners(i2);
            return this.removeAllListeners("removeListener"), this._events = /* @__PURE__ */ Object.create(null), this._eventsCount = 0, this;
          }
          if ("function" == typeof (e3 = r3[t3]))
            this.removeListener(t3, e3);
          else if (void 0 !== e3)
            for (n3 = e3.length - 1; n3 >= 0; n3--)
              this.removeListener(t3, e3[n3]);
          return this;
        }, a.prototype.listeners = function(t3) {
          return h(this, t3, true);
        }, a.prototype.rawListeners = function(t3) {
          return h(this, t3, false);
        }, a.listenerCount = function(t3, e3) {
          return "function" == typeof t3.listenerCount ? t3.listenerCount(e3) : p2.call(t3, e3);
        }, a.prototype.listenerCount = p2, a.prototype.eventNames = function() {
          return this._eventsCount > 0 ? e2(this._events) : [];
        };
      }, 60774: function(t2) {
        var e2 = function() {
          if ("object" == typeof self && self)
            return self;
          if ("object" == typeof window && window)
            return window;
          throw new Error("Unable to resolve global `this`");
        };
        t2.exports = function() {
          if (this)
            return this;
          try {
            Object.defineProperty(Object.prototype, "__global__", { get: function() {
              return this;
            }, configurable: true });
          } catch (t3) {
            return e2();
          }
          try {
            return __global__ || e2();
          } finally {
            delete Object.prototype.__global__;
          }
        }();
      }, 94908: function(t2, e2, r2) {
        t2.exports = r2(51152)() ? globalThis : r2(60774);
      }, 51152: function(t2) {
        t2.exports = function() {
          return "object" == typeof globalThis && !!globalThis && globalThis.Array === Array;
        };
      }, 92770: function(t2, e2, r2) {
        var n2 = r2(18546);
        t2.exports = function(t3) {
          var e3 = typeof t3;
          if ("string" === e3) {
            var r3 = t3;
            if (0 == (t3 = +t3) && n2(r3))
              return false;
          } else if ("number" !== e3)
            return false;
          return t3 - t3 < 1;
        };
      }, 30120: function(t2, e2, r2) {
        var n2 = r2(90660);
        t2.exports = function(t3, e3, r3) {
          if (!t3)
            throw new TypeError("must specify data as first parameter");
          if (r3 = 0 | +(r3 || 0), Array.isArray(t3) && t3[0] && "number" == typeof t3[0][0]) {
            var i, a, o, s, l = t3[0].length, u = t3.length * l;
            e3 && "string" != typeof e3 || (e3 = new (n2(e3 || "float32"))(u + r3));
            var c = e3.length - r3;
            if (u !== c)
              throw new Error("source length " + u + " (" + l + "x" + t3.length + ") does not match destination length " + c);
            for (i = 0, o = r3; i < t3.length; i++)
              for (a = 0; a < l; a++)
                e3[o++] = null === t3[i][a] ? NaN : t3[i][a];
          } else if (e3 && "string" != typeof e3)
            e3.set(t3, r3);
          else {
            var f2 = n2(e3 || "float32");
            if (Array.isArray(t3) || "array" === e3)
              for (i = 0, o = r3, s = (e3 = new f2(t3.length + r3)).length; o < s; o++, i++)
                e3[o] = null === t3[i] ? NaN : t3[i];
            else
              0 === r3 ? e3 = new f2(t3) : (e3 = new f2(t3.length + r3)).set(t3, r3);
          }
          return e3;
        };
      }, 68016: function(t2, e2, r2) {
        var n2 = r2(53313), i = [32, 126];
        t2.exports = function(t3) {
          var e3 = (t3 = t3 || {}).shape ? t3.shape : t3.canvas ? [t3.canvas.width, t3.canvas.height] : [512, 512], r3 = t3.canvas || document.createElement("canvas"), a = t3.font, o = "number" == typeof t3.step ? [t3.step, t3.step] : t3.step || [32, 32], s = t3.chars || i;
          if (a && "string" != typeof a && (a = n2(a)), Array.isArray(s)) {
            if (2 === s.length && "number" == typeof s[0] && "number" == typeof s[1]) {
              for (var l = [], u = s[0], c = 0; u <= s[1]; u++)
                l[c++] = String.fromCharCode(u);
              s = l;
            }
          } else
            s = String(s).split("");
          e3 = e3.slice(), r3.width = e3[0], r3.height = e3[1];
          var f2 = r3.getContext("2d");
          f2.fillStyle = "#000", f2.fillRect(0, 0, r3.width, r3.height), f2.font = a, f2.textAlign = "center", f2.textBaseline = "middle", f2.fillStyle = "#fff";
          var h = o[0] / 2, p2 = o[1] / 2;
          for (u = 0; u < s.length; u++)
            f2.fillText(s[u], h, p2), (h += o[0]) > e3[0] - o[0] / 2 && (h = o[0] / 2, p2 += o[1]);
          return r3;
        };
      }, 32879: function(t2) {
        function e2(t3, a) {
          a || (a = {}), ("string" == typeof t3 || Array.isArray(t3)) && (a.family = t3);
          var o = Array.isArray(a.family) ? a.family.join(", ") : a.family;
          if (!o)
            throw Error("`family` must be defined");
          var s = a.size || a.fontSize || a.em || 48, l = a.weight || a.fontWeight || "", u = (t3 = [a.style || a.fontStyle || "", l, s].join(" ") + "px " + o, a.origin || "top");
          if (e2.cache[o] && s <= e2.cache[o].em)
            return r2(e2.cache[o], u);
          var c = a.canvas || e2.canvas, f2 = c.getContext("2d"), h = { upper: void 0 !== a.upper ? a.upper : "H", lower: void 0 !== a.lower ? a.lower : "x", descent: void 0 !== a.descent ? a.descent : "p", ascent: void 0 !== a.ascent ? a.ascent : "h", tittle: void 0 !== a.tittle ? a.tittle : "i", overshoot: void 0 !== a.overshoot ? a.overshoot : "O" }, p2 = Math.ceil(1.5 * s);
          c.height = p2, c.width = 0.5 * p2, f2.font = t3;
          var d2 = "H", v = { top: 0 };
          f2.clearRect(0, 0, p2, p2), f2.textBaseline = "top", f2.fillStyle = "black", f2.fillText(d2, 0, 0);
          var g2 = n2(f2.getImageData(0, 0, p2, p2));
          f2.clearRect(0, 0, p2, p2), f2.textBaseline = "bottom", f2.fillText(d2, 0, p2);
          var y = n2(f2.getImageData(0, 0, p2, p2));
          v.lineHeight = v.bottom = p2 - y + g2, f2.clearRect(0, 0, p2, p2), f2.textBaseline = "alphabetic", f2.fillText(d2, 0, p2);
          var m2 = p2 - n2(f2.getImageData(0, 0, p2, p2)) - 1 + g2;
          v.baseline = v.alphabetic = m2, f2.clearRect(0, 0, p2, p2), f2.textBaseline = "middle", f2.fillText(d2, 0, 0.5 * p2);
          var x = n2(f2.getImageData(0, 0, p2, p2));
          v.median = v.middle = p2 - x - 1 + g2 - 0.5 * p2, f2.clearRect(0, 0, p2, p2), f2.textBaseline = "hanging", f2.fillText(d2, 0, 0.5 * p2);
          var b = n2(f2.getImageData(0, 0, p2, p2));
          v.hanging = p2 - b - 1 + g2 - 0.5 * p2, f2.clearRect(0, 0, p2, p2), f2.textBaseline = "ideographic", f2.fillText(d2, 0, p2);
          var _ = n2(f2.getImageData(0, 0, p2, p2));
          if (v.ideographic = p2 - _ - 1 + g2, h.upper && (f2.clearRect(0, 0, p2, p2), f2.textBaseline = "top", f2.fillText(h.upper, 0, 0), v.upper = n2(f2.getImageData(0, 0, p2, p2)), v.capHeight = v.baseline - v.upper), h.lower && (f2.clearRect(0, 0, p2, p2), f2.textBaseline = "top", f2.fillText(h.lower, 0, 0), v.lower = n2(f2.getImageData(0, 0, p2, p2)), v.xHeight = v.baseline - v.lower), h.tittle && (f2.clearRect(0, 0, p2, p2), f2.textBaseline = "top", f2.fillText(h.tittle, 0, 0), v.tittle = n2(f2.getImageData(0, 0, p2, p2))), h.ascent && (f2.clearRect(0, 0, p2, p2), f2.textBaseline = "top", f2.fillText(h.ascent, 0, 0), v.ascent = n2(f2.getImageData(0, 0, p2, p2))), h.descent && (f2.clearRect(0, 0, p2, p2), f2.textBaseline = "top", f2.fillText(h.descent, 0, 0), v.descent = i(f2.getImageData(0, 0, p2, p2))), h.overshoot) {
            f2.clearRect(0, 0, p2, p2), f2.textBaseline = "top", f2.fillText(h.overshoot, 0, 0);
            var w2 = i(f2.getImageData(0, 0, p2, p2));
            v.overshoot = w2 - m2;
          }
          for (var T in v)
            v[T] /= s;
          return v.em = s, e2.cache[o] = v, r2(v, u);
        }
        function r2(t3, e3) {
          var r3 = {};
          for (var n3 in "string" == typeof e3 && (e3 = t3[e3]), t3)
            "em" !== n3 && (r3[n3] = t3[n3] - e3);
          return r3;
        }
        function n2(t3) {
          for (var e3 = t3.height, r3 = t3.data, n3 = 3; n3 < r3.length; n3 += 4)
            if (0 !== r3[n3])
              return Math.floor(0.25 * (n3 - 3) / e3);
        }
        function i(t3) {
          for (var e3 = t3.height, r3 = t3.data, n3 = r3.length - 1; n3 > 0; n3 -= 4)
            if (0 !== r3[n3])
              return Math.floor(0.25 * (n3 - 3) / e3);
        }
        t2.exports = e2, e2.canvas = document.createElement("canvas"), e2.cache = {};
      }, 31353: function(t2, e2, r2) {
        var n2 = r2(85395), i = Object.prototype.toString, a = Object.prototype.hasOwnProperty, o = function(t3, e3, r3) {
          for (var n3 = 0, i2 = t3.length; n3 < i2; n3++)
            a.call(t3, n3) && (null == r3 ? e3(t3[n3], n3, t3) : e3.call(r3, t3[n3], n3, t3));
        }, s = function(t3, e3, r3) {
          for (var n3 = 0, i2 = t3.length; n3 < i2; n3++)
            null == r3 ? e3(t3.charAt(n3), n3, t3) : e3.call(r3, t3.charAt(n3), n3, t3);
        }, l = function(t3, e3, r3) {
          for (var n3 in t3)
            a.call(t3, n3) && (null == r3 ? e3(t3[n3], n3, t3) : e3.call(r3, t3[n3], n3, t3));
        };
        t2.exports = function(t3, e3, r3) {
          if (!n2(e3))
            throw new TypeError("iterator must be a function");
          var a2;
          arguments.length >= 3 && (a2 = r3), "[object Array]" === i.call(t3) ? o(t3, e3, a2) : "string" == typeof t3 ? s(t3, e3, a2) : l(t3, e3, a2);
        };
      }, 73047: function(t2) {
        var e2 = "Function.prototype.bind called on incompatible ", r2 = Array.prototype.slice, n2 = Object.prototype.toString, i = "[object Function]";
        t2.exports = function(t3) {
          var a = this;
          if ("function" != typeof a || n2.call(a) !== i)
            throw new TypeError(e2 + a);
          for (var o, s = r2.call(arguments, 1), l = function() {
            if (this instanceof o) {
              var e3 = a.apply(this, s.concat(r2.call(arguments)));
              return Object(e3) === e3 ? e3 : this;
            }
            return a.apply(t3, s.concat(r2.call(arguments)));
          }, u = Math.max(0, a.length - s.length), c = [], f2 = 0; f2 < u; f2++)
            c.push("$" + f2);
          if (o = Function("binder", "return function (" + c.join(",") + "){ return binder.apply(this,arguments); }")(l), a.prototype) {
            var h = function() {
            };
            h.prototype = a.prototype, o.prototype = new h(), h.prototype = null;
          }
          return o;
        };
      }, 77575: function(t2, e2, r2) {
        var n2 = r2(73047);
        t2.exports = Function.prototype.bind || n2;
      }, 86249: function(t2) {
        t2.exports = function(t3, e2) {
          if ("string" != typeof t3)
            throw new TypeError("must specify type string");
          if (e2 = e2 || {}, "undefined" == typeof document && !e2.canvas)
            return null;
          var r2 = e2.canvas || document.createElement("canvas");
          "number" == typeof e2.width && (r2.width = e2.width), "number" == typeof e2.height && (r2.height = e2.height);
          var n2, i = e2;
          try {
            var a = [t3];
            0 === t3.indexOf("webgl") && a.push("experimental-" + t3);
            for (var o = 0; o < a.length; o++)
              if (n2 = r2.getContext(a[o], i))
                return n2;
          } catch (t4) {
            n2 = null;
          }
          return n2 || null;
        };
      }, 68318: function(t2, e2, r2) {
        var n2, i = SyntaxError, a = Function, o = TypeError, s = function(t3) {
          try {
            return a('"use strict"; return (' + t3 + ").constructor;")();
          } catch (t4) {
          }
        }, l = Object.getOwnPropertyDescriptor;
        if (l)
          try {
            l({}, "");
          } catch (t3) {
            l = null;
          }
        var u = function() {
          throw new o();
        }, c = l ? function() {
          try {
            return u;
          } catch (t3) {
            try {
              return l(arguments, "callee").get;
            } catch (t4) {
              return u;
            }
          }
        }() : u, f2 = r2(57877)(), h = Object.getPrototypeOf || function(t3) {
          return t3.__proto__;
        }, p2 = {}, d2 = "undefined" == typeof Uint8Array ? n2 : h(Uint8Array), v = { "%AggregateError%": "undefined" == typeof AggregateError ? n2 : AggregateError, "%Array%": Array, "%ArrayBuffer%": "undefined" == typeof ArrayBuffer ? n2 : ArrayBuffer, "%ArrayIteratorPrototype%": f2 ? h([][Symbol.iterator]()) : n2, "%AsyncFromSyncIteratorPrototype%": n2, "%AsyncFunction%": p2, "%AsyncGenerator%": p2, "%AsyncGeneratorFunction%": p2, "%AsyncIteratorPrototype%": p2, "%Atomics%": "undefined" == typeof Atomics ? n2 : Atomics, "%BigInt%": "undefined" == typeof BigInt ? n2 : BigInt, "%BigInt64Array%": "undefined" == typeof BigInt64Array ? n2 : BigInt64Array, "%BigUint64Array%": "undefined" == typeof BigUint64Array ? n2 : BigUint64Array, "%Boolean%": Boolean, "%DataView%": "undefined" == typeof DataView ? n2 : DataView, "%Date%": Date, "%decodeURI%": decodeURI, "%decodeURIComponent%": decodeURIComponent, "%encodeURI%": encodeURI, "%encodeURIComponent%": encodeURIComponent, "%Error%": Error, "%eval%": eval, "%EvalError%": EvalError, "%Float32Array%": "undefined" == typeof Float32Array ? n2 : Float32Array, "%Float64Array%": "undefined" == typeof Float64Array ? n2 : Float64Array, "%FinalizationRegistry%": "undefined" == typeof FinalizationRegistry ? n2 : FinalizationRegistry, "%Function%": a, "%GeneratorFunction%": p2, "%Int8Array%": "undefined" == typeof Int8Array ? n2 : Int8Array, "%Int16Array%": "undefined" == typeof Int16Array ? n2 : Int16Array, "%Int32Array%": "undefined" == typeof Int32Array ? n2 : Int32Array, "%isFinite%": isFinite, "%isNaN%": isNaN, "%IteratorPrototype%": f2 ? h(h([][Symbol.iterator]())) : n2, "%JSON%": "object" == typeof JSON ? JSON : n2, "%Map%": "undefined" == typeof Map ? n2 : Map, "%MapIteratorPrototype%": "undefined" != typeof Map && f2 ? h((/* @__PURE__ */ new Map())[Symbol.iterator]()) : n2, "%Math%": Math, "%Number%": Number, "%Object%": Object, "%parseFloat%": parseFloat, "%parseInt%": parseInt, "%Promise%": "undefined" == typeof Promise ? n2 : Promise, "%Proxy%": "undefined" == typeof Proxy ? n2 : Proxy, "%RangeError%": RangeError, "%ReferenceError%": ReferenceError, "%Reflect%": "undefined" == typeof Reflect ? n2 : Reflect, "%RegExp%": RegExp, "%Set%": "undefined" == typeof Set ? n2 : Set, "%SetIteratorPrototype%": "undefined" != typeof Set && f2 ? h((/* @__PURE__ */ new Set())[Symbol.iterator]()) : n2, "%SharedArrayBuffer%": "undefined" == typeof SharedArrayBuffer ? n2 : SharedArrayBuffer, "%String%": String, "%StringIteratorPrototype%": f2 ? h(""[Symbol.iterator]()) : n2, "%Symbol%": f2 ? Symbol : n2, "%SyntaxError%": i, "%ThrowTypeError%": c, "%TypedArray%": d2, "%TypeError%": o, "%Uint8Array%": "undefined" == typeof Uint8Array ? n2 : Uint8Array, "%Uint8ClampedArray%": "undefined" == typeof Uint8ClampedArray ? n2 : Uint8ClampedArray, "%Uint16Array%": "undefined" == typeof Uint16Array ? n2 : Uint16Array, "%Uint32Array%": "undefined" == typeof Uint32Array ? n2 : Uint32Array, "%URIError%": URIError, "%WeakMap%": "undefined" == typeof WeakMap ? n2 : WeakMap, "%WeakRef%": "undefined" == typeof WeakRef ? n2 : WeakRef, "%WeakSet%": "undefined" == typeof WeakSet ? n2 : WeakSet };
        try {
          null.error;
        } catch (t3) {
          var g2 = h(h(t3));
          v["%Error.prototype%"] = g2;
        }
        var y = function t3(e3) {
          var r3;
          if ("%AsyncFunction%" === e3)
            r3 = s("async function () {}");
          else if ("%GeneratorFunction%" === e3)
            r3 = s("function* () {}");
          else if ("%AsyncGeneratorFunction%" === e3)
            r3 = s("async function* () {}");
          else if ("%AsyncGenerator%" === e3) {
            var n3 = t3("%AsyncGeneratorFunction%");
            n3 && (r3 = n3.prototype);
          } else if ("%AsyncIteratorPrototype%" === e3) {
            var i2 = t3("%AsyncGenerator%");
            i2 && (r3 = h(i2.prototype));
          }
          return v[e3] = r3, r3;
        }, m2 = { "%ArrayBufferPrototype%": ["ArrayBuffer", "prototype"], "%ArrayPrototype%": ["Array", "prototype"], "%ArrayProto_entries%": ["Array", "prototype", "entries"], "%ArrayProto_forEach%": ["Array", "prototype", "forEach"], "%ArrayProto_keys%": ["Array", "prototype", "keys"], "%ArrayProto_values%": ["Array", "prototype", "values"], "%AsyncFunctionPrototype%": ["AsyncFunction", "prototype"], "%AsyncGenerator%": ["AsyncGeneratorFunction", "prototype"], "%AsyncGeneratorPrototype%": ["AsyncGeneratorFunction", "prototype", "prototype"], "%BooleanPrototype%": ["Boolean", "prototype"], "%DataViewPrototype%": ["DataView", "prototype"], "%DatePrototype%": ["Date", "prototype"], "%ErrorPrototype%": ["Error", "prototype"], "%EvalErrorPrototype%": ["EvalError", "prototype"], "%Float32ArrayPrototype%": ["Float32Array", "prototype"], "%Float64ArrayPrototype%": ["Float64Array", "prototype"], "%FunctionPrototype%": ["Function", "prototype"], "%Generator%": ["GeneratorFunction", "prototype"], "%GeneratorPrototype%": ["GeneratorFunction", "prototype", "prototype"], "%Int8ArrayPrototype%": ["Int8Array", "prototype"], "%Int16ArrayPrototype%": ["Int16Array", "prototype"], "%Int32ArrayPrototype%": ["Int32Array", "prototype"], "%JSONParse%": ["JSON", "parse"], "%JSONStringify%": ["JSON", "stringify"], "%MapPrototype%": ["Map", "prototype"], "%NumberPrototype%": ["Number", "prototype"], "%ObjectPrototype%": ["Object", "prototype"], "%ObjProto_toString%": ["Object", "prototype", "toString"], "%ObjProto_valueOf%": ["Object", "prototype", "valueOf"], "%PromisePrototype%": ["Promise", "prototype"], "%PromiseProto_then%": ["Promise", "prototype", "then"], "%Promise_all%": ["Promise", "all"], "%Promise_reject%": ["Promise", "reject"], "%Promise_resolve%": ["Promise", "resolve"], "%RangeErrorPrototype%": ["RangeError", "prototype"], "%ReferenceErrorPrototype%": ["ReferenceError", "prototype"], "%RegExpPrototype%": ["RegExp", "prototype"], "%SetPrototype%": ["Set", "prototype"], "%SharedArrayBufferPrototype%": ["SharedArrayBuffer", "prototype"], "%StringPrototype%": ["String", "prototype"], "%SymbolPrototype%": ["Symbol", "prototype"], "%SyntaxErrorPrototype%": ["SyntaxError", "prototype"], "%TypedArrayPrototype%": ["TypedArray", "prototype"], "%TypeErrorPrototype%": ["TypeError", "prototype"], "%Uint8ArrayPrototype%": ["Uint8Array", "prototype"], "%Uint8ClampedArrayPrototype%": ["Uint8ClampedArray", "prototype"], "%Uint16ArrayPrototype%": ["Uint16Array", "prototype"], "%Uint32ArrayPrototype%": ["Uint32Array", "prototype"], "%URIErrorPrototype%": ["URIError", "prototype"], "%WeakMapPrototype%": ["WeakMap", "prototype"], "%WeakSetPrototype%": ["WeakSet", "prototype"] }, x = r2(77575), b = r2(35065), _ = x.call(Function.call, Array.prototype.concat), w2 = x.call(Function.apply, Array.prototype.splice), T = x.call(Function.call, String.prototype.replace), k = x.call(Function.call, String.prototype.slice), A = x.call(Function.call, RegExp.prototype.exec), M = /[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g, S = /\\(\\)?/g, E = function(t3) {
          var e3 = k(t3, 0, 1), r3 = k(t3, -1);
          if ("%" === e3 && "%" !== r3)
            throw new i("invalid intrinsic syntax, expected closing `%`");
          if ("%" === r3 && "%" !== e3)
            throw new i("invalid intrinsic syntax, expected opening `%`");
          var n3 = [];
          return T(t3, M, function(t4, e4, r4, i2) {
            n3[n3.length] = r4 ? T(i2, S, "$1") : e4 || t4;
          }), n3;
        }, L = function(t3, e3) {
          var r3, n3 = t3;
          if (b(m2, n3) && (n3 = "%" + (r3 = m2[n3])[0] + "%"), b(v, n3)) {
            var a2 = v[n3];
            if (a2 === p2 && (a2 = y(n3)), void 0 === a2 && !e3)
              throw new o("intrinsic " + t3 + " exists, but is not available. Please file an issue!");
            return { alias: r3, name: n3, value: a2 };
          }
          throw new i("intrinsic " + t3 + " does not exist!");
        };
        t2.exports = function(t3, e3) {
          if ("string" != typeof t3 || 0 === t3.length)
            throw new o("intrinsic name must be a non-empty string");
          if (arguments.length > 1 && "boolean" != typeof e3)
            throw new o('"allowMissing" argument must be a boolean');
          if (null === A(/^%?[^%]*%?$/, t3))
            throw new i("`%` may not be present anywhere but at the beginning and end of the intrinsic name");
          var r3 = E(t3), n3 = r3.length > 0 ? r3[0] : "", a2 = L("%" + n3 + "%", e3), s2 = a2.name, u2 = a2.value, c2 = false, f3 = a2.alias;
          f3 && (n3 = f3[0], w2(r3, _([0, 1], f3)));
          for (var h2 = 1, p3 = true; h2 < r3.length; h2 += 1) {
            var d3 = r3[h2], g3 = k(d3, 0, 1), y2 = k(d3, -1);
            if (('"' === g3 || "'" === g3 || "`" === g3 || '"' === y2 || "'" === y2 || "`" === y2) && g3 !== y2)
              throw new i("property names with quotes must have matching quotes");
            if ("constructor" !== d3 && p3 || (c2 = true), b(v, s2 = "%" + (n3 += "." + d3) + "%"))
              u2 = v[s2];
            else if (null != u2) {
              if (!(d3 in u2)) {
                if (!e3)
                  throw new o("base intrinsic for " + t3 + " exists, but the property is not available.");
                return;
              }
              if (l && h2 + 1 >= r3.length) {
                var m3 = l(u2, d3);
                u2 = (p3 = !!m3) && "get" in m3 && !("originalValue" in m3.get) ? m3.get : u2[d3];
              } else
                p3 = b(u2, d3), u2 = u2[d3];
              p3 && !c2 && (v[s2] = u2);
            }
          }
          return u2;
        };
      }, 85400: function(t2) {
        t2.exports = function(t3, e2) {
          var r2 = e2[0], n2 = e2[1], i = e2[2], a = e2[3], o = e2[4], s = e2[5], l = e2[6], u = e2[7], c = e2[8], f2 = e2[9], h = e2[10], p2 = e2[11], d2 = e2[12], v = e2[13], g2 = e2[14], y = e2[15];
          return t3[0] = s * (h * y - p2 * g2) - f2 * (l * y - u * g2) + v * (l * p2 - u * h), t3[1] = -(n2 * (h * y - p2 * g2) - f2 * (i * y - a * g2) + v * (i * p2 - a * h)), t3[2] = n2 * (l * y - u * g2) - s * (i * y - a * g2) + v * (i * u - a * l), t3[3] = -(n2 * (l * p2 - u * h) - s * (i * p2 - a * h) + f2 * (i * u - a * l)), t3[4] = -(o * (h * y - p2 * g2) - c * (l * y - u * g2) + d2 * (l * p2 - u * h)), t3[5] = r2 * (h * y - p2 * g2) - c * (i * y - a * g2) + d2 * (i * p2 - a * h), t3[6] = -(r2 * (l * y - u * g2) - o * (i * y - a * g2) + d2 * (i * u - a * l)), t3[7] = r2 * (l * p2 - u * h) - o * (i * p2 - a * h) + c * (i * u - a * l), t3[8] = o * (f2 * y - p2 * v) - c * (s * y - u * v) + d2 * (s * p2 - u * f2), t3[9] = -(r2 * (f2 * y - p2 * v) - c * (n2 * y - a * v) + d2 * (n2 * p2 - a * f2)), t3[10] = r2 * (s * y - u * v) - o * (n2 * y - a * v) + d2 * (n2 * u - a * s), t3[11] = -(r2 * (s * p2 - u * f2) - o * (n2 * p2 - a * f2) + c * (n2 * u - a * s)), t3[12] = -(o * (f2 * g2 - h * v) - c * (s * g2 - l * v) + d2 * (s * h - l * f2)), t3[13] = r2 * (f2 * g2 - h * v) - c * (n2 * g2 - i * v) + d2 * (n2 * h - i * f2), t3[14] = -(r2 * (s * g2 - l * v) - o * (n2 * g2 - i * v) + d2 * (n2 * l - i * s)), t3[15] = r2 * (s * h - l * f2) - o * (n2 * h - i * f2) + c * (n2 * l - i * s), t3;
        };
      }, 42331: function(t2) {
        t2.exports = function(t3) {
          var e2 = new Float32Array(16);
          return e2[0] = t3[0], e2[1] = t3[1], e2[2] = t3[2], e2[3] = t3[3], e2[4] = t3[4], e2[5] = t3[5], e2[6] = t3[6], e2[7] = t3[7], e2[8] = t3[8], e2[9] = t3[9], e2[10] = t3[10], e2[11] = t3[11], e2[12] = t3[12], e2[13] = t3[13], e2[14] = t3[14], e2[15] = t3[15], e2;
        };
      }, 31042: function(t2) {
        t2.exports = function(t3, e2) {
          return t3[0] = e2[0], t3[1] = e2[1], t3[2] = e2[2], t3[3] = e2[3], t3[4] = e2[4], t3[5] = e2[5], t3[6] = e2[6], t3[7] = e2[7], t3[8] = e2[8], t3[9] = e2[9], t3[10] = e2[10], t3[11] = e2[11], t3[12] = e2[12], t3[13] = e2[13], t3[14] = e2[14], t3[15] = e2[15], t3;
        };
      }, 11902: function(t2) {
        t2.exports = function() {
          var t3 = new Float32Array(16);
          return t3[0] = 1, t3[1] = 0, t3[2] = 0, t3[3] = 0, t3[4] = 0, t3[5] = 1, t3[6] = 0, t3[7] = 0, t3[8] = 0, t3[9] = 0, t3[10] = 1, t3[11] = 0, t3[12] = 0, t3[13] = 0, t3[14] = 0, t3[15] = 1, t3;
        };
      }, 89887: function(t2) {
        t2.exports = function(t3) {
          var e2 = t3[0], r2 = t3[1], n2 = t3[2], i = t3[3], a = t3[4], o = t3[5], s = t3[6], l = t3[7], u = t3[8], c = t3[9], f2 = t3[10], h = t3[11], p2 = t3[12], d2 = t3[13], v = t3[14], g2 = t3[15];
          return (e2 * o - r2 * a) * (f2 * g2 - h * v) - (e2 * s - n2 * a) * (c * g2 - h * d2) + (e2 * l - i * a) * (c * v - f2 * d2) + (r2 * s - n2 * o) * (u * g2 - h * p2) - (r2 * l - i * o) * (u * v - f2 * p2) + (n2 * l - i * s) * (u * d2 - c * p2);
        };
      }, 27812: function(t2) {
        t2.exports = function(t3, e2) {
          var r2 = e2[0], n2 = e2[1], i = e2[2], a = e2[3], o = r2 + r2, s = n2 + n2, l = i + i, u = r2 * o, c = n2 * o, f2 = n2 * s, h = i * o, p2 = i * s, d2 = i * l, v = a * o, g2 = a * s, y = a * l;
          return t3[0] = 1 - f2 - d2, t3[1] = c + y, t3[2] = h - g2, t3[3] = 0, t3[4] = c - y, t3[5] = 1 - u - d2, t3[6] = p2 + v, t3[7] = 0, t3[8] = h + g2, t3[9] = p2 - v, t3[10] = 1 - u - f2, t3[11] = 0, t3[12] = 0, t3[13] = 0, t3[14] = 0, t3[15] = 1, t3;
        };
      }, 34045: function(t2) {
        t2.exports = function(t3, e2, r2) {
          var n2, i, a, o = r2[0], s = r2[1], l = r2[2], u = Math.sqrt(o * o + s * s + l * l);
          return Math.abs(u) < 1e-6 ? null : (o *= u = 1 / u, s *= u, l *= u, n2 = Math.sin(e2), a = 1 - (i = Math.cos(e2)), t3[0] = o * o * a + i, t3[1] = s * o * a + l * n2, t3[2] = l * o * a - s * n2, t3[3] = 0, t3[4] = o * s * a - l * n2, t3[5] = s * s * a + i, t3[6] = l * s * a + o * n2, t3[7] = 0, t3[8] = o * l * a + s * n2, t3[9] = s * l * a - o * n2, t3[10] = l * l * a + i, t3[11] = 0, t3[12] = 0, t3[13] = 0, t3[14] = 0, t3[15] = 1, t3);
        };
      }, 45973: function(t2) {
        t2.exports = function(t3, e2, r2) {
          var n2 = e2[0], i = e2[1], a = e2[2], o = e2[3], s = n2 + n2, l = i + i, u = a + a, c = n2 * s, f2 = n2 * l, h = n2 * u, p2 = i * l, d2 = i * u, v = a * u, g2 = o * s, y = o * l, m2 = o * u;
          return t3[0] = 1 - (p2 + v), t3[1] = f2 + m2, t3[2] = h - y, t3[3] = 0, t3[4] = f2 - m2, t3[5] = 1 - (c + v), t3[6] = d2 + g2, t3[7] = 0, t3[8] = h + y, t3[9] = d2 - g2, t3[10] = 1 - (c + p2), t3[11] = 0, t3[12] = r2[0], t3[13] = r2[1], t3[14] = r2[2], t3[15] = 1, t3;
        };
      }, 81472: function(t2) {
        t2.exports = function(t3, e2) {
          return t3[0] = e2[0], t3[1] = 0, t3[2] = 0, t3[3] = 0, t3[4] = 0, t3[5] = e2[1], t3[6] = 0, t3[7] = 0, t3[8] = 0, t3[9] = 0, t3[10] = e2[2], t3[11] = 0, t3[12] = 0, t3[13] = 0, t3[14] = 0, t3[15] = 1, t3;
        };
      }, 14669: function(t2) {
        t2.exports = function(t3, e2) {
          return t3[0] = 1, t3[1] = 0, t3[2] = 0, t3[3] = 0, t3[4] = 0, t3[5] = 1, t3[6] = 0, t3[7] = 0, t3[8] = 0, t3[9] = 0, t3[10] = 1, t3[11] = 0, t3[12] = e2[0], t3[13] = e2[1], t3[14] = e2[2], t3[15] = 1, t3;
        };
      }, 75262: function(t2) {
        t2.exports = function(t3, e2) {
          var r2 = Math.sin(e2), n2 = Math.cos(e2);
          return t3[0] = 1, t3[1] = 0, t3[2] = 0, t3[3] = 0, t3[4] = 0, t3[5] = n2, t3[6] = r2, t3[7] = 0, t3[8] = 0, t3[9] = -r2, t3[10] = n2, t3[11] = 0, t3[12] = 0, t3[13] = 0, t3[14] = 0, t3[15] = 1, t3;
        };
      }, 331: function(t2) {
        t2.exports = function(t3, e2) {
          var r2 = Math.sin(e2), n2 = Math.cos(e2);
          return t3[0] = n2, t3[1] = 0, t3[2] = -r2, t3[3] = 0, t3[4] = 0, t3[5] = 1, t3[6] = 0, t3[7] = 0, t3[8] = r2, t3[9] = 0, t3[10] = n2, t3[11] = 0, t3[12] = 0, t3[13] = 0, t3[14] = 0, t3[15] = 1, t3;
        };
      }, 11049: function(t2) {
        t2.exports = function(t3, e2) {
          var r2 = Math.sin(e2), n2 = Math.cos(e2);
          return t3[0] = n2, t3[1] = r2, t3[2] = 0, t3[3] = 0, t3[4] = -r2, t3[5] = n2, t3[6] = 0, t3[7] = 0, t3[8] = 0, t3[9] = 0, t3[10] = 1, t3[11] = 0, t3[12] = 0, t3[13] = 0, t3[14] = 0, t3[15] = 1, t3;
        };
      }, 75195: function(t2) {
        t2.exports = function(t3, e2, r2, n2, i, a, o) {
          var s = 1 / (r2 - e2), l = 1 / (i - n2), u = 1 / (a - o);
          return t3[0] = 2 * a * s, t3[1] = 0, t3[2] = 0, t3[3] = 0, t3[4] = 0, t3[5] = 2 * a * l, t3[6] = 0, t3[7] = 0, t3[8] = (r2 + e2) * s, t3[9] = (i + n2) * l, t3[10] = (o + a) * u, t3[11] = -1, t3[12] = 0, t3[13] = 0, t3[14] = o * a * 2 * u, t3[15] = 0, t3;
        };
      }, 71551: function(t2) {
        t2.exports = function(t3) {
          return t3[0] = 1, t3[1] = 0, t3[2] = 0, t3[3] = 0, t3[4] = 0, t3[5] = 1, t3[6] = 0, t3[7] = 0, t3[8] = 0, t3[9] = 0, t3[10] = 1, t3[11] = 0, t3[12] = 0, t3[13] = 0, t3[14] = 0, t3[15] = 1, t3;
        };
      }, 79576: function(t2, e2, r2) {
        t2.exports = { create: r2(11902), clone: r2(42331), copy: r2(31042), identity: r2(71551), transpose: r2(88654), invert: r2(95874), adjoint: r2(85400), determinant: r2(89887), multiply: r2(91362), translate: r2(31283), scale: r2(10789), rotate: r2(65074), rotateX: r2(35545), rotateY: r2(94918), rotateZ: r2(15692), fromRotation: r2(34045), fromRotationTranslation: r2(45973), fromScaling: r2(81472), fromTranslation: r2(14669), fromXRotation: r2(75262), fromYRotation: r2(331), fromZRotation: r2(11049), fromQuat: r2(27812), frustum: r2(75195), perspective: r2(7864), perspectiveFromFieldOfView: r2(35279), ortho: r2(60378), lookAt: r2(65551), str: r2(6726) };
      }, 95874: function(t2) {
        t2.exports = function(t3, e2) {
          var r2 = e2[0], n2 = e2[1], i = e2[2], a = e2[3], o = e2[4], s = e2[5], l = e2[6], u = e2[7], c = e2[8], f2 = e2[9], h = e2[10], p2 = e2[11], d2 = e2[12], v = e2[13], g2 = e2[14], y = e2[15], m2 = r2 * s - n2 * o, x = r2 * l - i * o, b = r2 * u - a * o, _ = n2 * l - i * s, w2 = n2 * u - a * s, T = i * u - a * l, k = c * v - f2 * d2, A = c * g2 - h * d2, M = c * y - p2 * d2, S = f2 * g2 - h * v, E = f2 * y - p2 * v, L = h * y - p2 * g2, C = m2 * L - x * E + b * S + _ * M - w2 * A + T * k;
          return C ? (C = 1 / C, t3[0] = (s * L - l * E + u * S) * C, t3[1] = (i * E - n2 * L - a * S) * C, t3[2] = (v * T - g2 * w2 + y * _) * C, t3[3] = (h * w2 - f2 * T - p2 * _) * C, t3[4] = (l * M - o * L - u * A) * C, t3[5] = (r2 * L - i * M + a * A) * C, t3[6] = (g2 * b - d2 * T - y * x) * C, t3[7] = (c * T - h * b + p2 * x) * C, t3[8] = (o * E - s * M + u * k) * C, t3[9] = (n2 * M - r2 * E - a * k) * C, t3[10] = (d2 * w2 - v * b + y * m2) * C, t3[11] = (f2 * b - c * w2 - p2 * m2) * C, t3[12] = (s * A - o * S - l * k) * C, t3[13] = (r2 * S - n2 * A + i * k) * C, t3[14] = (v * x - d2 * _ - g2 * m2) * C, t3[15] = (c * _ - f2 * x + h * m2) * C, t3) : null;
        };
      }, 65551: function(t2, e2, r2) {
        var n2 = r2(71551);
        t2.exports = function(t3, e3, r3, i) {
          var a, o, s, l, u, c, f2, h, p2, d2, v = e3[0], g2 = e3[1], y = e3[2], m2 = i[0], x = i[1], b = i[2], _ = r3[0], w2 = r3[1], T = r3[2];
          return Math.abs(v - _) < 1e-6 && Math.abs(g2 - w2) < 1e-6 && Math.abs(y - T) < 1e-6 ? n2(t3) : (f2 = v - _, h = g2 - w2, p2 = y - T, a = x * (p2 *= d2 = 1 / Math.sqrt(f2 * f2 + h * h + p2 * p2)) - b * (h *= d2), o = b * (f2 *= d2) - m2 * p2, s = m2 * h - x * f2, (d2 = Math.sqrt(a * a + o * o + s * s)) ? (a *= d2 = 1 / d2, o *= d2, s *= d2) : (a = 0, o = 0, s = 0), l = h * s - p2 * o, u = p2 * a - f2 * s, c = f2 * o - h * a, (d2 = Math.sqrt(l * l + u * u + c * c)) ? (l *= d2 = 1 / d2, u *= d2, c *= d2) : (l = 0, u = 0, c = 0), t3[0] = a, t3[1] = l, t3[2] = f2, t3[3] = 0, t3[4] = o, t3[5] = u, t3[6] = h, t3[7] = 0, t3[8] = s, t3[9] = c, t3[10] = p2, t3[11] = 0, t3[12] = -(a * v + o * g2 + s * y), t3[13] = -(l * v + u * g2 + c * y), t3[14] = -(f2 * v + h * g2 + p2 * y), t3[15] = 1, t3);
        };
      }, 91362: function(t2) {
        t2.exports = function(t3, e2, r2) {
          var n2 = e2[0], i = e2[1], a = e2[2], o = e2[3], s = e2[4], l = e2[5], u = e2[6], c = e2[7], f2 = e2[8], h = e2[9], p2 = e2[10], d2 = e2[11], v = e2[12], g2 = e2[13], y = e2[14], m2 = e2[15], x = r2[0], b = r2[1], _ = r2[2], w2 = r2[3];
          return t3[0] = x * n2 + b * s + _ * f2 + w2 * v, t3[1] = x * i + b * l + _ * h + w2 * g2, t3[2] = x * a + b * u + _ * p2 + w2 * y, t3[3] = x * o + b * c + _ * d2 + w2 * m2, x = r2[4], b = r2[5], _ = r2[6], w2 = r2[7], t3[4] = x * n2 + b * s + _ * f2 + w2 * v, t3[5] = x * i + b * l + _ * h + w2 * g2, t3[6] = x * a + b * u + _ * p2 + w2 * y, t3[7] = x * o + b * c + _ * d2 + w2 * m2, x = r2[8], b = r2[9], _ = r2[10], w2 = r2[11], t3[8] = x * n2 + b * s + _ * f2 + w2 * v, t3[9] = x * i + b * l + _ * h + w2 * g2, t3[10] = x * a + b * u + _ * p2 + w2 * y, t3[11] = x * o + b * c + _ * d2 + w2 * m2, x = r2[12], b = r2[13], _ = r2[14], w2 = r2[15], t3[12] = x * n2 + b * s + _ * f2 + w2 * v, t3[13] = x * i + b * l + _ * h + w2 * g2, t3[14] = x * a + b * u + _ * p2 + w2 * y, t3[15] = x * o + b * c + _ * d2 + w2 * m2, t3;
        };
      }, 60378: function(t2) {
        t2.exports = function(t3, e2, r2, n2, i, a, o) {
          var s = 1 / (e2 - r2), l = 1 / (n2 - i), u = 1 / (a - o);
          return t3[0] = -2 * s, t3[1] = 0, t3[2] = 0, t3[3] = 0, t3[4] = 0, t3[5] = -2 * l, t3[6] = 0, t3[7] = 0, t3[8] = 0, t3[9] = 0, t3[10] = 2 * u, t3[11] = 0, t3[12] = (e2 + r2) * s, t3[13] = (i + n2) * l, t3[14] = (o + a) * u, t3[15] = 1, t3;
        };
      }, 7864: function(t2) {
        t2.exports = function(t3, e2, r2, n2, i) {
          var a = 1 / Math.tan(e2 / 2), o = 1 / (n2 - i);
          return t3[0] = a / r2, t3[1] = 0, t3[2] = 0, t3[3] = 0, t3[4] = 0, t3[5] = a, t3[6] = 0, t3[7] = 0, t3[8] = 0, t3[9] = 0, t3[10] = (i + n2) * o, t3[11] = -1, t3[12] = 0, t3[13] = 0, t3[14] = 2 * i * n2 * o, t3[15] = 0, t3;
        };
      }, 35279: function(t2) {
        t2.exports = function(t3, e2, r2, n2) {
          var i = Math.tan(e2.upDegrees * Math.PI / 180), a = Math.tan(e2.downDegrees * Math.PI / 180), o = Math.tan(e2.leftDegrees * Math.PI / 180), s = Math.tan(e2.rightDegrees * Math.PI / 180), l = 2 / (o + s), u = 2 / (i + a);
          return t3[0] = l, t3[1] = 0, t3[2] = 0, t3[3] = 0, t3[4] = 0, t3[5] = u, t3[6] = 0, t3[7] = 0, t3[8] = -(o - s) * l * 0.5, t3[9] = (i - a) * u * 0.5, t3[10] = n2 / (r2 - n2), t3[11] = -1, t3[12] = 0, t3[13] = 0, t3[14] = n2 * r2 / (r2 - n2), t3[15] = 0, t3;
        };
      }, 65074: function(t2) {
        t2.exports = function(t3, e2, r2, n2) {
          var i, a, o, s, l, u, c, f2, h, p2, d2, v, g2, y, m2, x, b, _, w2, T, k, A, M, S, E = n2[0], L = n2[1], C = n2[2], P = Math.sqrt(E * E + L * L + C * C);
          return Math.abs(P) < 1e-6 ? null : (E *= P = 1 / P, L *= P, C *= P, i = Math.sin(r2), o = 1 - (a = Math.cos(r2)), s = e2[0], l = e2[1], u = e2[2], c = e2[3], f2 = e2[4], h = e2[5], p2 = e2[6], d2 = e2[7], v = e2[8], g2 = e2[9], y = e2[10], m2 = e2[11], x = E * E * o + a, b = L * E * o + C * i, _ = C * E * o - L * i, w2 = E * L * o - C * i, T = L * L * o + a, k = C * L * o + E * i, A = E * C * o + L * i, M = L * C * o - E * i, S = C * C * o + a, t3[0] = s * x + f2 * b + v * _, t3[1] = l * x + h * b + g2 * _, t3[2] = u * x + p2 * b + y * _, t3[3] = c * x + d2 * b + m2 * _, t3[4] = s * w2 + f2 * T + v * k, t3[5] = l * w2 + h * T + g2 * k, t3[6] = u * w2 + p2 * T + y * k, t3[7] = c * w2 + d2 * T + m2 * k, t3[8] = s * A + f2 * M + v * S, t3[9] = l * A + h * M + g2 * S, t3[10] = u * A + p2 * M + y * S, t3[11] = c * A + d2 * M + m2 * S, e2 !== t3 && (t3[12] = e2[12], t3[13] = e2[13], t3[14] = e2[14], t3[15] = e2[15]), t3);
        };
      }, 35545: function(t2) {
        t2.exports = function(t3, e2, r2) {
          var n2 = Math.sin(r2), i = Math.cos(r2), a = e2[4], o = e2[5], s = e2[6], l = e2[7], u = e2[8], c = e2[9], f2 = e2[10], h = e2[11];
          return e2 !== t3 && (t3[0] = e2[0], t3[1] = e2[1], t3[2] = e2[2], t3[3] = e2[3], t3[12] = e2[12], t3[13] = e2[13], t3[14] = e2[14], t3[15] = e2[15]), t3[4] = a * i + u * n2, t3[5] = o * i + c * n2, t3[6] = s * i + f2 * n2, t3[7] = l * i + h * n2, t3[8] = u * i - a * n2, t3[9] = c * i - o * n2, t3[10] = f2 * i - s * n2, t3[11] = h * i - l * n2, t3;
        };
      }, 94918: function(t2) {
        t2.exports = function(t3, e2, r2) {
          var n2 = Math.sin(r2), i = Math.cos(r2), a = e2[0], o = e2[1], s = e2[2], l = e2[3], u = e2[8], c = e2[9], f2 = e2[10], h = e2[11];
          return e2 !== t3 && (t3[4] = e2[4], t3[5] = e2[5], t3[6] = e2[6], t3[7] = e2[7], t3[12] = e2[12], t3[13] = e2[13], t3[14] = e2[14], t3[15] = e2[15]), t3[0] = a * i - u * n2, t3[1] = o * i - c * n2, t3[2] = s * i - f2 * n2, t3[3] = l * i - h * n2, t3[8] = a * n2 + u * i, t3[9] = o * n2 + c * i, t3[10] = s * n2 + f2 * i, t3[11] = l * n2 + h * i, t3;
        };
      }, 15692: function(t2) {
        t2.exports = function(t3, e2, r2) {
          var n2 = Math.sin(r2), i = Math.cos(r2), a = e2[0], o = e2[1], s = e2[2], l = e2[3], u = e2[4], c = e2[5], f2 = e2[6], h = e2[7];
          return e2 !== t3 && (t3[8] = e2[8], t3[9] = e2[9], t3[10] = e2[10], t3[11] = e2[11], t3[12] = e2[12], t3[13] = e2[13], t3[14] = e2[14], t3[15] = e2[15]), t3[0] = a * i + u * n2, t3[1] = o * i + c * n2, t3[2] = s * i + f2 * n2, t3[3] = l * i + h * n2, t3[4] = u * i - a * n2, t3[5] = c * i - o * n2, t3[6] = f2 * i - s * n2, t3[7] = h * i - l * n2, t3;
        };
      }, 10789: function(t2) {
        t2.exports = function(t3, e2, r2) {
          var n2 = r2[0], i = r2[1], a = r2[2];
          return t3[0] = e2[0] * n2, t3[1] = e2[1] * n2, t3[2] = e2[2] * n2, t3[3] = e2[3] * n2, t3[4] = e2[4] * i, t3[5] = e2[5] * i, t3[6] = e2[6] * i, t3[7] = e2[7] * i, t3[8] = e2[8] * a, t3[9] = e2[9] * a, t3[10] = e2[10] * a, t3[11] = e2[11] * a, t3[12] = e2[12], t3[13] = e2[13], t3[14] = e2[14], t3[15] = e2[15], t3;
        };
      }, 6726: function(t2) {
        t2.exports = function(t3) {
          return "mat4(" + t3[0] + ", " + t3[1] + ", " + t3[2] + ", " + t3[3] + ", " + t3[4] + ", " + t3[5] + ", " + t3[6] + ", " + t3[7] + ", " + t3[8] + ", " + t3[9] + ", " + t3[10] + ", " + t3[11] + ", " + t3[12] + ", " + t3[13] + ", " + t3[14] + ", " + t3[15] + ")";
        };
      }, 31283: function(t2) {
        t2.exports = function(t3, e2, r2) {
          var n2, i, a, o, s, l, u, c, f2, h, p2, d2, v = r2[0], g2 = r2[1], y = r2[2];
          return e2 === t3 ? (t3[12] = e2[0] * v + e2[4] * g2 + e2[8] * y + e2[12], t3[13] = e2[1] * v + e2[5] * g2 + e2[9] * y + e2[13], t3[14] = e2[2] * v + e2[6] * g2 + e2[10] * y + e2[14], t3[15] = e2[3] * v + e2[7] * g2 + e2[11] * y + e2[15]) : (n2 = e2[0], i = e2[1], a = e2[2], o = e2[3], s = e2[4], l = e2[5], u = e2[6], c = e2[7], f2 = e2[8], h = e2[9], p2 = e2[10], d2 = e2[11], t3[0] = n2, t3[1] = i, t3[2] = a, t3[3] = o, t3[4] = s, t3[5] = l, t3[6] = u, t3[7] = c, t3[8] = f2, t3[9] = h, t3[10] = p2, t3[11] = d2, t3[12] = n2 * v + s * g2 + f2 * y + e2[12], t3[13] = i * v + l * g2 + h * y + e2[13], t3[14] = a * v + u * g2 + p2 * y + e2[14], t3[15] = o * v + c * g2 + d2 * y + e2[15]), t3;
        };
      }, 88654: function(t2) {
        t2.exports = function(t3, e2) {
          if (t3 === e2) {
            var r2 = e2[1], n2 = e2[2], i = e2[3], a = e2[6], o = e2[7], s = e2[11];
            t3[1] = e2[4], t3[2] = e2[8], t3[3] = e2[12], t3[4] = r2, t3[6] = e2[9], t3[7] = e2[13], t3[8] = n2, t3[9] = a, t3[11] = e2[14], t3[12] = i, t3[13] = o, t3[14] = s;
          } else
            t3[0] = e2[0], t3[1] = e2[4], t3[2] = e2[8], t3[3] = e2[12], t3[4] = e2[1], t3[5] = e2[5], t3[6] = e2[9], t3[7] = e2[13], t3[8] = e2[2], t3[9] = e2[6], t3[10] = e2[10], t3[11] = e2[14], t3[12] = e2[3], t3[13] = e2[7], t3[14] = e2[11], t3[15] = e2[15];
          return t3;
        };
      }, 42505: function(t2, e2, r2) {
        var n2 = r2(72791), i = r2(71299), a = r2(98580), o = r2(12018), s = r2(83522), l = r2(25075), u = r2(68016), c = r2(58404), f2 = r2(18863), h = r2(10973), p2 = r2(25677), d2 = r2(75686), v = r2(53545), g2 = r2(56131), y = r2(32879), m2 = r2(30120), x = r2(13547).nextPow2, b = new s(), _ = false;
        if (document.body) {
          var w2 = document.body.appendChild(document.createElement("div"));
          w2.style.font = "italic small-caps bold condensed 16px/2 cursive", getComputedStyle(w2).fontStretch && (_ = true), document.body.removeChild(w2);
        }
        var T = function(t3) {
          !function(t4) {
            return "function" == typeof t4 && t4._gl && t4.prop && t4.texture && t4.buffer;
          }(t3) ? this.gl = o(t3) : (t3 = { regl: t3 }, this.gl = t3.regl._gl), this.shader = b.get(this.gl), this.shader ? this.regl = this.shader.regl : this.regl = t3.regl || a({ gl: this.gl }), this.charBuffer = this.regl.buffer({ type: "uint8", usage: "stream" }), this.sizeBuffer = this.regl.buffer({ type: "float", usage: "stream" }), this.shader || (this.shader = this.createShader(), b.set(this.gl, this.shader)), this.batch = [], this.fontSize = [], this.font = [], this.fontAtlas = [], this.draw = this.shader.draw.bind(this), this.render = function() {
            this.regl._refresh(), this.draw(this.batch);
          }, this.canvas = this.gl.canvas, this.update(h(t3) ? t3 : {});
        };
        T.prototype.createShader = function() {
          var t3 = this.regl, e3 = t3({ blend: { enable: true, color: [0, 0, 0, 1], func: { srcRGB: "src alpha", dstRGB: "one minus src alpha", srcAlpha: "one minus dst alpha", dstAlpha: "one" } }, stencil: { enable: false }, depth: { enable: false }, count: t3.prop("count"), offset: t3.prop("offset"), attributes: { charOffset: { offset: 4, stride: 8, buffer: t3.this("sizeBuffer") }, width: { offset: 0, stride: 8, buffer: t3.this("sizeBuffer") }, char: t3.this("charBuffer"), position: t3.this("position") }, uniforms: { atlasSize: function(t4, e4) {
            return [e4.atlas.width, e4.atlas.height];
          }, atlasDim: function(t4, e4) {
            return [e4.atlas.cols, e4.atlas.rows];
          }, atlas: function(t4, e4) {
            return e4.atlas.texture;
          }, charStep: function(t4, e4) {
            return e4.atlas.step;
          }, em: function(t4, e4) {
            return e4.atlas.em;
          }, color: t3.prop("color"), opacity: t3.prop("opacity"), viewport: t3.this("viewportArray"), scale: t3.this("scale"), align: t3.prop("align"), baseline: t3.prop("baseline"), translate: t3.this("translate"), positionOffset: t3.prop("positionOffset") }, primitive: "points", viewport: t3.this("viewport"), vert: "\n			precision highp float;\n			attribute float width, charOffset, char;\n			attribute vec2 position;\n			uniform float fontSize, charStep, em, align, baseline;\n			uniform vec4 viewport;\n			uniform vec4 color;\n			uniform vec2 atlasSize, atlasDim, scale, translate, positionOffset;\n			varying vec2 charCoord, charId;\n			varying float charWidth;\n			varying vec4 fontColor;\n			void main () {\n				vec2 offset = floor(em * (vec2(align + charOffset, baseline)\n					+ vec2(positionOffset.x, -positionOffset.y)))\n					/ (viewport.zw * scale.xy);\n\n				vec2 position = (position + translate) * scale;\n				position += offset * scale;\n\n				charCoord = position * viewport.zw + viewport.xy;\n\n				gl_Position = vec4(position * 2. - 1., 0, 1);\n\n				gl_PointSize = charStep;\n\n				charId.x = mod(char, atlasDim.x);\n				charId.y = floor(char / atlasDim.x);\n\n				charWidth = width * em;\n\n				fontColor = color / 255.;\n			}", frag: "\n			precision highp float;\n			uniform float fontSize, charStep, opacity;\n			uniform vec2 atlasSize;\n			uniform vec4 viewport;\n			uniform sampler2D atlas;\n			varying vec4 fontColor;\n			varying vec2 charCoord, charId;\n			varying float charWidth;\n\n			float lightness(vec4 color) {\n				return color.r * 0.299 + color.g * 0.587 + color.b * 0.114;\n			}\n\n			void main () {\n				vec2 uv = gl_FragCoord.xy - charCoord + charStep * .5;\n				float halfCharStep = floor(charStep * .5 + .5);\n\n				// invert y and shift by 1px (FF expecially needs that)\n				uv.y = charStep - uv.y;\n\n				// ignore points outside of character bounding box\n				float halfCharWidth = ceil(charWidth * .5);\n				if (floor(uv.x) > halfCharStep + halfCharWidth ||\n					floor(uv.x) < halfCharStep - halfCharWidth) return;\n\n				uv += charId * charStep;\n				uv = uv / atlasSize;\n\n				vec4 color = fontColor;\n				vec4 mask = texture2D(atlas, uv);\n\n				float maskY = lightness(mask);\n				// float colorY = lightness(color);\n				color.a *= maskY;\n				color.a *= opacity;\n\n				// color.a += .1;\n\n				// antialiasing, see yiq color space y-channel formula\n				// color.rgb += (1. - color.rgb) * (1. - mask.rgb);\n\n				gl_FragColor = color;\n			}" });
          return { regl: t3, draw: e3, atlas: {} };
        }, T.prototype.update = function(t3) {
          var e3 = this;
          if ("string" == typeof t3)
            t3 = { text: t3 };
          else if (!t3)
            return;
          null != (t3 = i(t3, { position: "position positions coord coords coordinates", font: "font fontFace fontface typeface cssFont css-font family fontFamily", fontSize: "fontSize fontsize size font-size", text: "text texts chars characters value values symbols", align: "align alignment textAlign textbaseline", baseline: "baseline textBaseline textbaseline", direction: "dir direction textDirection", color: "color colour fill fill-color fillColor textColor textcolor", kerning: "kerning kern", range: "range dataBox", viewport: "vp viewport viewBox viewbox viewPort", opacity: "opacity alpha transparency visible visibility opaque", offset: "offset positionOffset padding shift indent indentation" }, true)).opacity && (Array.isArray(t3.opacity) ? this.opacity = t3.opacity.map(function(t4) {
            return parseFloat(t4);
          }) : this.opacity = parseFloat(t3.opacity)), null != t3.viewport && (this.viewport = f2(t3.viewport), this.viewportArray = [this.viewport.x, this.viewport.y, this.viewport.width, this.viewport.height]), null == this.viewport && (this.viewport = { x: 0, y: 0, width: this.gl.drawingBufferWidth, height: this.gl.drawingBufferHeight }, this.viewportArray = [this.viewport.x, this.viewport.y, this.viewport.width, this.viewport.height]), null != t3.kerning && (this.kerning = t3.kerning), null != t3.offset && ("number" == typeof t3.offset && (t3.offset = [t3.offset, 0]), this.positionOffset = m2(t3.offset)), t3.direction && (this.direction = t3.direction), t3.range && (this.range = t3.range, this.scale = [1 / (t3.range[2] - t3.range[0]), 1 / (t3.range[3] - t3.range[1])], this.translate = [-t3.range[0], -t3.range[1]]), t3.scale && (this.scale = t3.scale), t3.translate && (this.translate = t3.translate), this.scale || (this.scale = [1 / this.viewport.width, 1 / this.viewport.height]), this.translate || (this.translate = [0, 0]), this.font.length || t3.font || (t3.font = T.baseFontSize + "px sans-serif");
          var r3, a2 = false, o2 = false;
          if (t3.font && (Array.isArray(t3.font) ? t3.font : [t3.font]).forEach(function(t4, r4) {
            if ("string" == typeof t4)
              try {
                t4 = n2.parse(t4);
              } catch (e4) {
                t4 = n2.parse(T.baseFontSize + "px " + t4);
              }
            else
              t4 = n2.parse(n2.stringify(t4));
            var i2 = n2.stringify({ size: T.baseFontSize, family: t4.family, stretch: _ ? t4.stretch : void 0, variant: t4.variant, weight: t4.weight, style: t4.style }), s3 = p2(t4.size), l2 = Math.round(s3[0] * d2(s3[1]));
            if (l2 !== e3.fontSize[r4] && (o2 = true, e3.fontSize[r4] = l2), !(e3.font[r4] && i2 == e3.font[r4].baseString || (a2 = true, e3.font[r4] = T.fonts[i2], e3.font[r4]))) {
              var u2 = t4.family.join(", "), c2 = [t4.style];
              t4.style != t4.variant && c2.push(t4.variant), t4.variant != t4.weight && c2.push(t4.weight), _ && t4.weight != t4.stretch && c2.push(t4.stretch), e3.font[r4] = { baseString: i2, family: u2, weight: t4.weight, stretch: t4.stretch, style: t4.style, variant: t4.variant, width: {}, kerning: {}, metrics: y(u2, { origin: "top", fontSize: T.baseFontSize, fontStyle: c2.join(" ") }) }, T.fonts[i2] = e3.font[r4];
            }
          }), (a2 || o2) && this.font.forEach(function(r4, i2) {
            var a3 = n2.stringify({ size: e3.fontSize[i2], family: r4.family, stretch: _ ? r4.stretch : void 0, variant: r4.variant, weight: r4.weight, style: r4.style });
            if (e3.fontAtlas[i2] = e3.shader.atlas[a3], !e3.fontAtlas[i2]) {
              var o3 = r4.metrics;
              e3.shader.atlas[a3] = e3.fontAtlas[i2] = { fontString: a3, step: 2 * Math.ceil(e3.fontSize[i2] * o3.bottom * 0.5), em: e3.fontSize[i2], cols: 0, rows: 0, height: 0, width: 0, chars: [], ids: {}, texture: e3.regl.texture() };
            }
            null == t3.text && (t3.text = e3.text);
          }), "string" == typeof t3.text && t3.position && t3.position.length > 2) {
            for (var s2 = Array(0.5 * t3.position.length), h2 = 0; h2 < s2.length; h2++)
              s2[h2] = t3.text;
            t3.text = s2;
          }
          if (null != t3.text || a2) {
            if (this.textOffsets = [0], Array.isArray(t3.text)) {
              this.count = t3.text[0].length, this.counts = [this.count];
              for (var b2 = 1; b2 < t3.text.length; b2++)
                this.textOffsets[b2] = this.textOffsets[b2 - 1] + t3.text[b2 - 1].length, this.count += t3.text[b2].length, this.counts.push(t3.text[b2].length);
              this.text = t3.text.join("");
            } else
              this.text = t3.text, this.count = this.text.length, this.counts = [this.count];
            r3 = [], this.font.forEach(function(t4, n3) {
              T.atlasContext.font = t4.baseString;
              for (var i2 = e3.fontAtlas[n3], a3 = 0; a3 < e3.text.length; a3++) {
                var o3 = e3.text.charAt(a3);
                if (null == i2.ids[o3] && (i2.ids[o3] = i2.chars.length, i2.chars.push(o3), r3.push(o3)), null == t4.width[o3] && (t4.width[o3] = T.atlasContext.measureText(o3).width / T.baseFontSize, e3.kerning)) {
                  var s3 = [];
                  for (var l2 in t4.width)
                    s3.push(l2 + o3, o3 + l2);
                  g2(t4.kerning, v(t4.family, { pairs: s3 }));
                }
              }
            });
          }
          if (t3.position)
            if (t3.position.length > 2) {
              for (var w3 = !t3.position[0].length, k = c.mallocFloat(2 * this.count), A = 0, M = 0; A < this.counts.length; A++) {
                var S = this.counts[A];
                if (w3)
                  for (var E = 0; E < S; E++)
                    k[M++] = t3.position[2 * A], k[M++] = t3.position[2 * A + 1];
                else
                  for (var L = 0; L < S; L++)
                    k[M++] = t3.position[A][0], k[M++] = t3.position[A][1];
              }
              this.position.call ? this.position({ type: "float", data: k }) : this.position = this.regl.buffer({ type: "float", data: k }), c.freeFloat(k);
            } else
              this.position.destroy && this.position.destroy(), this.position = { constant: t3.position };
          if (t3.text || a2) {
            var C = c.mallocUint8(this.count), P = c.mallocFloat(2 * this.count);
            this.textWidth = [];
            for (var O = 0, I = 0; O < this.counts.length; O++) {
              for (var D = this.counts[O], z = this.font[O] || this.font[0], R = this.fontAtlas[O] || this.fontAtlas[0], F = 0; F < D; F++) {
                var B = this.text.charAt(I), N = this.text.charAt(I - 1);
                if (C[I] = R.ids[B], P[2 * I] = z.width[B], F) {
                  var j = P[2 * I - 2], U = P[2 * I], V = P[2 * I - 1] + 0.5 * j + 0.5 * U;
                  if (this.kerning) {
                    var H = z.kerning[N + B];
                    H && (V += 1e-3 * H);
                  }
                  P[2 * I + 1] = V;
                } else
                  P[2 * I + 1] = 0.5 * P[2 * I];
                I++;
              }
              this.textWidth.push(P.length ? 0.5 * P[2 * I - 2] + P[2 * I - 1] : 0);
            }
            t3.align || (t3.align = this.align), this.charBuffer({ data: C, type: "uint8", usage: "stream" }), this.sizeBuffer({ data: P, type: "float", usage: "stream" }), c.freeUint8(C), c.freeFloat(P), r3.length && this.font.forEach(function(t4, r4) {
              var n3 = e3.fontAtlas[r4], i2 = n3.step, a3 = Math.floor(T.maxAtlasSize / i2), o3 = Math.min(a3, n3.chars.length), s3 = Math.ceil(n3.chars.length / o3), l2 = x(o3 * i2), c2 = x(s3 * i2);
              n3.width = l2, n3.height = c2, n3.rows = s3, n3.cols = o3, n3.em && n3.texture({ data: u({ canvas: T.atlasCanvas, font: n3.fontString, chars: n3.chars, shape: [l2, c2], step: [i2, i2] }) });
            });
          }
          if (t3.align && (this.align = t3.align, this.alignOffset = this.textWidth.map(function(t4, r4) {
            var n3 = Array.isArray(e3.align) ? e3.align.length > 1 ? e3.align[r4] : e3.align[0] : e3.align;
            if ("number" == typeof n3)
              return n3;
            switch (n3) {
              case "right":
              case "end":
                return -t4;
              case "center":
              case "centre":
              case "middle":
                return 0.5 * -t4;
            }
            return 0;
          })), null == this.baseline && null == t3.baseline && (t3.baseline = 0), null != t3.baseline && (this.baseline = t3.baseline, Array.isArray(this.baseline) || (this.baseline = [this.baseline]), this.baselineOffset = this.baseline.map(function(t4, r4) {
            var n3 = (e3.font[r4] || e3.font[0]).metrics, i2 = 0;
            return i2 += 0.5 * n3.bottom, -1 * (i2 += "number" == typeof t4 ? t4 - n3.baseline : -n3[t4]);
          })), null != t3.color)
            if (t3.color || (t3.color = "transparent"), "string" != typeof t3.color && isNaN(t3.color)) {
              var q2;
              if ("number" == typeof t3.color[0] && t3.color.length > this.counts.length) {
                var G = t3.color.length;
                q2 = c.mallocUint8(G);
                for (var Z = (t3.color.subarray || t3.color.slice).bind(t3.color), Y = 0; Y < G; Y += 4)
                  q2.set(l(Z(Y, Y + 4), "uint8"), Y);
              } else {
                var W = t3.color.length;
                q2 = c.mallocUint8(4 * W);
                for (var X = 0; X < W; X++)
                  q2.set(l(t3.color[X] || 0, "uint8"), 4 * X);
              }
              this.color = q2;
            } else
              this.color = l(t3.color, "uint8");
          if (t3.position || t3.text || t3.color || t3.baseline || t3.align || t3.font || t3.offset || t3.opacity)
            if (this.color.length > 4 || this.baselineOffset.length > 1 || this.align && this.align.length > 1 || this.fontAtlas.length > 1 || this.positionOffset.length > 2) {
              var J = Math.max(0.5 * this.position.length || 0, 0.25 * this.color.length || 0, this.baselineOffset.length || 0, this.alignOffset.length || 0, this.font.length || 0, this.opacity.length || 0, 0.5 * this.positionOffset.length || 0);
              this.batch = Array(J);
              for (var K = 0; K < this.batch.length; K++)
                this.batch[K] = { count: this.counts.length > 1 ? this.counts[K] : this.counts[0], offset: this.textOffsets.length > 1 ? this.textOffsets[K] : this.textOffsets[0], color: this.color ? this.color.length <= 4 ? this.color : this.color.subarray(4 * K, 4 * K + 4) : [0, 0, 0, 255], opacity: Array.isArray(this.opacity) ? this.opacity[K] : this.opacity, baseline: null != this.baselineOffset[K] ? this.baselineOffset[K] : this.baselineOffset[0], align: this.align ? null != this.alignOffset[K] ? this.alignOffset[K] : this.alignOffset[0] : 0, atlas: this.fontAtlas[K] || this.fontAtlas[0], positionOffset: this.positionOffset.length > 2 ? this.positionOffset.subarray(2 * K, 2 * K + 2) : this.positionOffset };
            } else
              this.count ? this.batch = [{ count: this.count, offset: 0, color: this.color || [0, 0, 0, 255], opacity: Array.isArray(this.opacity) ? this.opacity[0] : this.opacity, baseline: this.baselineOffset[0], align: this.alignOffset ? this.alignOffset[0] : 0, atlas: this.fontAtlas[0], positionOffset: this.positionOffset }] : this.batch = [];
        }, T.prototype.destroy = function() {
        }, T.prototype.kerning = true, T.prototype.position = { constant: new Float32Array(2) }, T.prototype.translate = null, T.prototype.scale = null, T.prototype.font = null, T.prototype.text = "", T.prototype.positionOffset = [0, 0], T.prototype.opacity = 1, T.prototype.color = new Uint8Array([0, 0, 0, 255]), T.prototype.alignOffset = [0, 0], T.maxAtlasSize = 1024, T.atlasCanvas = document.createElement("canvas"), T.atlasContext = T.atlasCanvas.getContext("2d", { alpha: false }), T.baseFontSize = 64, T.fonts = {}, t2.exports = T;
      }, 12018: function(t2, e2, r2) {
        var n2 = r2(71299);
        function i(t3) {
          if (t3.container)
            if (t3.container == document.body)
              document.body.style.width || (t3.canvas.width = t3.width || t3.pixelRatio * r2.g.innerWidth), document.body.style.height || (t3.canvas.height = t3.height || t3.pixelRatio * r2.g.innerHeight);
            else {
              var e3 = t3.container.getBoundingClientRect();
              t3.canvas.width = t3.width || e3.right - e3.left, t3.canvas.height = t3.height || e3.bottom - e3.top;
            }
        }
        function a(t3) {
          return "function" == typeof t3.getContext && "width" in t3 && "height" in t3;
        }
        function o() {
          var t3 = document.createElement("canvas");
          return t3.style.position = "absolute", t3.style.top = 0, t3.style.left = 0, t3;
        }
        t2.exports = function(t3) {
          var e3;
          if (t3 ? "string" == typeof t3 && (t3 = { container: t3 }) : t3 = {}, (t3 = a(t3) || "string" == typeof (e3 = t3).nodeName && "function" == typeof e3.appendChild && "function" == typeof e3.getBoundingClientRect ? { container: t3 } : function(t4) {
            return "function" == typeof t4.drawArrays || "function" == typeof t4.drawElements;
          }(t3) ? { gl: t3 } : n2(t3, { container: "container target element el canvas holder parent parentNode wrapper use ref root node", gl: "gl context webgl glContext", attrs: "attributes attrs contextAttributes", pixelRatio: "pixelRatio pxRatio px ratio pxratio pixelratio", width: "w width", height: "h height" }, true)).pixelRatio || (t3.pixelRatio = r2.g.pixelRatio || 1), t3.gl)
            return t3.gl;
          if (t3.canvas && (t3.container = t3.canvas.parentNode), t3.container) {
            if ("string" == typeof t3.container) {
              var s = document.querySelector(t3.container);
              if (!s)
                throw Error("Element " + t3.container + " is not found");
              t3.container = s;
            }
            a(t3.container) ? (t3.canvas = t3.container, t3.container = t3.canvas.parentNode) : t3.canvas || (t3.canvas = o(), t3.container.appendChild(t3.canvas), i(t3));
          } else if (!t3.canvas) {
            if ("undefined" == typeof document)
              throw Error("Not DOM environment. Use headless-gl.");
            t3.container = document.body || document.documentElement, t3.canvas = o(), t3.container.appendChild(t3.canvas), i(t3);
          }
          return t3.gl || ["webgl", "experimental-webgl", "webgl-experimental"].some(function(e4) {
            try {
              t3.gl = t3.canvas.getContext(e4, t3.attrs);
            } catch (t4) {
            }
            return t3.gl;
          }), t3.gl;
        };
      }, 56068: function(t2) {
        t2.exports = function(t3) {
          "string" == typeof t3 && (t3 = [t3]);
          for (var e2 = [].slice.call(arguments, 1), r2 = [], n2 = 0; n2 < t3.length - 1; n2++)
            r2.push(t3[n2], e2[n2] || "");
          return r2.push(t3[n2]), r2.join("");
        };
      }, 40383: function(t2, e2, r2) {
        var n2 = r2(68318)("%Object.getOwnPropertyDescriptor%", true);
        if (n2)
          try {
            n2([], "length");
          } catch (t3) {
            n2 = null;
          }
        t2.exports = n2;
      }, 57035: function(t2, e2, r2) {
        var n2, i = r2(54404);
        n2 = "function" == typeof r2.g.matchMedia ? !r2.g.matchMedia("(hover: none)").matches : i, t2.exports = n2;
      }, 38520: function(t2, e2, r2) {
        var n2 = r2(54404);
        t2.exports = n2 && function() {
          var t3 = false;
          try {
            var e3 = Object.defineProperty({}, "passive", { get: function() {
              t3 = true;
            } });
            window.addEventListener("test", null, e3), window.removeEventListener("test", null, e3);
          } catch (e4) {
            t3 = false;
          }
          return t3;
        }();
      }, 55622: function(t2, e2, r2) {
        var n2 = r2(68318)("%Object.defineProperty%", true), i = function() {
          if (n2)
            try {
              return n2({}, "a", { value: 1 }), true;
            } catch (t3) {
              return false;
            }
          return false;
        };
        i.hasArrayLengthDefineBug = function() {
          if (!i())
            return null;
          try {
            return 1 !== n2([], "length", { value: 1 }).length;
          } catch (t3) {
            return true;
          }
        }, t2.exports = i;
      }, 57877: function(t2, e2, r2) {
        var n2 = "undefined" != typeof Symbol && Symbol, i = r2(35638);
        t2.exports = function() {
          return "function" == typeof n2 && "function" == typeof Symbol && "symbol" == typeof n2("foo") && "symbol" == typeof Symbol("bar") && i();
        };
      }, 35638: function(t2) {
        t2.exports = function() {
          if ("function" != typeof Symbol || "function" != typeof Object.getOwnPropertySymbols)
            return false;
          if ("symbol" == typeof Symbol.iterator)
            return true;
          var t3 = {}, e2 = Symbol("test"), r2 = Object(e2);
          if ("string" == typeof e2)
            return false;
          if ("[object Symbol]" !== Object.prototype.toString.call(e2))
            return false;
          if ("[object Symbol]" !== Object.prototype.toString.call(r2))
            return false;
          for (e2 in t3[e2] = 42, t3)
            return false;
          if ("function" == typeof Object.keys && 0 !== Object.keys(t3).length)
            return false;
          if ("function" == typeof Object.getOwnPropertyNames && 0 !== Object.getOwnPropertyNames(t3).length)
            return false;
          var n2 = Object.getOwnPropertySymbols(t3);
          if (1 !== n2.length || n2[0] !== e2)
            return false;
          if (!Object.prototype.propertyIsEnumerable.call(t3, e2))
            return false;
          if ("function" == typeof Object.getOwnPropertyDescriptor) {
            var i = Object.getOwnPropertyDescriptor(t3, e2);
            if (42 !== i.value || true !== i.enumerable)
              return false;
          }
          return true;
        };
      }, 84543: function(t2, e2, r2) {
        var n2 = r2(35638);
        t2.exports = function() {
          return n2() && !!Symbol.toStringTag;
        };
      }, 35065: function(t2, e2, r2) {
        var n2 = r2(77575);
        t2.exports = n2.call(Function.call, Object.prototype.hasOwnProperty);
      }, 95280: function(t2, e2) {
        e2.read = function(t3, e3, r2, n2, i) {
          var a, o, s = 8 * i - n2 - 1, l = (1 << s) - 1, u = l >> 1, c = -7, f2 = r2 ? i - 1 : 0, h = r2 ? -1 : 1, p2 = t3[e3 + f2];
          for (f2 += h, a = p2 & (1 << -c) - 1, p2 >>= -c, c += s; c > 0; a = 256 * a + t3[e3 + f2], f2 += h, c -= 8)
            ;
          for (o = a & (1 << -c) - 1, a >>= -c, c += n2; c > 0; o = 256 * o + t3[e3 + f2], f2 += h, c -= 8)
            ;
          if (0 === a)
            a = 1 - u;
          else {
            if (a === l)
              return o ? NaN : 1 / 0 * (p2 ? -1 : 1);
            o += Math.pow(2, n2), a -= u;
          }
          return (p2 ? -1 : 1) * o * Math.pow(2, a - n2);
        }, e2.write = function(t3, e3, r2, n2, i, a) {
          var o, s, l, u = 8 * a - i - 1, c = (1 << u) - 1, f2 = c >> 1, h = 23 === i ? Math.pow(2, -24) - Math.pow(2, -77) : 0, p2 = n2 ? 0 : a - 1, d2 = n2 ? 1 : -1, v = e3 < 0 || 0 === e3 && 1 / e3 < 0 ? 1 : 0;
          for (e3 = Math.abs(e3), isNaN(e3) || e3 === 1 / 0 ? (s = isNaN(e3) ? 1 : 0, o = c) : (o = Math.floor(Math.log(e3) / Math.LN2), e3 * (l = Math.pow(2, -o)) < 1 && (o--, l *= 2), (e3 += o + f2 >= 1 ? h / l : h * Math.pow(2, 1 - f2)) * l >= 2 && (o++, l /= 2), o + f2 >= c ? (s = 0, o = c) : o + f2 >= 1 ? (s = (e3 * l - 1) * Math.pow(2, i), o += f2) : (s = e3 * Math.pow(2, f2 - 1) * Math.pow(2, i), o = 0)); i >= 8; t3[r2 + p2] = 255 & s, p2 += d2, s /= 256, i -= 8)
            ;
          for (o = o << i | s, u += i; u > 0; t3[r2 + p2] = 255 & o, p2 += d2, o /= 256, u -= 8)
            ;
          t3[r2 + p2 - d2] |= 128 * v;
        };
      }, 42018: function(t2) {
        "function" == typeof Object.create ? t2.exports = function(t3, e2) {
          e2 && (t3.super_ = e2, t3.prototype = Object.create(e2.prototype, { constructor: { value: t3, enumerable: false, writable: true, configurable: true } }));
        } : t2.exports = function(t3, e2) {
          if (e2) {
            t3.super_ = e2;
            var r2 = function() {
            };
            r2.prototype = e2.prototype, t3.prototype = new r2(), t3.prototype.constructor = t3;
          }
        };
      }, 47216: function(t2, e2, r2) {
        var n2 = r2(84543)(), i = r2(6614)("Object.prototype.toString"), a = function(t3) {
          return !(n2 && t3 && "object" == typeof t3 && Symbol.toStringTag in t3) && "[object Arguments]" === i(t3);
        }, o = function(t3) {
          return !!a(t3) || null !== t3 && "object" == typeof t3 && "number" == typeof t3.length && t3.length >= 0 && "[object Array]" !== i(t3) && "[object Function]" === i(t3.callee);
        }, s = function() {
          return a(arguments);
        }();
        a.isLegacyArguments = o, t2.exports = s ? a : o;
      }, 54404: function(t2) {
        t2.exports = true;
      }, 85395: function(t2) {
        var e2, r2, n2 = Function.prototype.toString, i = "object" == typeof Reflect && null !== Reflect && Reflect.apply;
        if ("function" == typeof i && "function" == typeof Object.defineProperty)
          try {
            e2 = Object.defineProperty({}, "length", { get: function() {
              throw r2;
            } }), r2 = {}, i(function() {
              throw 42;
            }, null, e2);
          } catch (t3) {
            t3 !== r2 && (i = null);
          }
        else
          i = null;
        var a = /^\s*class\b/, o = function(t3) {
          try {
            var e3 = n2.call(t3);
            return a.test(e3);
          } catch (t4) {
            return false;
          }
        }, s = function(t3) {
          try {
            return !o(t3) && (n2.call(t3), true);
          } catch (t4) {
            return false;
          }
        }, l = Object.prototype.toString, u = "function" == typeof Symbol && !!Symbol.toStringTag, c = !(0 in [,]), f2 = function() {
          return false;
        };
        if ("object" == typeof document) {
          var h = document.all;
          l.call(h) === l.call(document.all) && (f2 = function(t3) {
            if ((c || !t3) && (void 0 === t3 || "object" == typeof t3))
              try {
                var e3 = l.call(t3);
                return ("[object HTMLAllCollection]" === e3 || "[object HTML document.all class]" === e3 || "[object HTMLCollection]" === e3 || "[object Object]" === e3) && null == t3("");
              } catch (t4) {
              }
            return false;
          });
        }
        t2.exports = i ? function(t3) {
          if (f2(t3))
            return true;
          if (!t3)
            return false;
          if ("function" != typeof t3 && "object" != typeof t3)
            return false;
          try {
            i(t3, null, e2);
          } catch (t4) {
            if (t4 !== r2)
              return false;
          }
          return !o(t3) && s(t3);
        } : function(t3) {
          if (f2(t3))
            return true;
          if (!t3)
            return false;
          if ("function" != typeof t3 && "object" != typeof t3)
            return false;
          if (u)
            return s(t3);
          if (o(t3))
            return false;
          var e3 = l.call(t3);
          return !("[object Function]" !== e3 && "[object GeneratorFunction]" !== e3 && !/^\[object HTML/.test(e3)) && s(t3);
        };
      }, 65481: function(t2, e2, r2) {
        var n2, i = Object.prototype.toString, a = Function.prototype.toString, o = /^\s*(?:function)?\*/, s = r2(84543)(), l = Object.getPrototypeOf;
        t2.exports = function(t3) {
          if ("function" != typeof t3)
            return false;
          if (o.test(a.call(t3)))
            return true;
          if (!s)
            return "[object GeneratorFunction]" === i.call(t3);
          if (!l)
            return false;
          if (void 0 === n2) {
            var e3 = function() {
              if (!s)
                return false;
              try {
                return Function("return function*() {}")();
              } catch (t4) {
              }
            }();
            n2 = !!e3 && l(e3);
          }
          return l(t3) === n2;
        };
      }, 62683: function(t2) {
        t2.exports = "undefined" != typeof navigator && (/MSIE/.test(navigator.userAgent) || /Trident\//.test(navigator.appVersion));
      }, 64274: function(t2) {
        t2.exports = function(t3) {
          return t3 != t3;
        };
      }, 15567: function(t2, e2, r2) {
        var n2 = r2(68222), i = r2(17045), a = r2(64274), o = r2(14922), s = r2(22442), l = n2(o(), Number);
        i(l, { getPolyfill: o, implementation: a, shim: s }), t2.exports = l;
      }, 14922: function(t2, e2, r2) {
        var n2 = r2(64274);
        t2.exports = function() {
          return Number.isNaN && Number.isNaN(NaN) && !Number.isNaN("a") ? Number.isNaN : n2;
        };
      }, 22442: function(t2, e2, r2) {
        var n2 = r2(17045), i = r2(14922);
        t2.exports = function() {
          var t3 = i();
          return n2(Number, { isNaN: t3 }, { isNaN: function() {
            return Number.isNaN !== t3;
          } }), t3;
        };
      }, 64941: function(t2) {
        t2.exports = function(t3) {
          var e2 = typeof t3;
          return null !== t3 && ("object" === e2 || "function" === e2);
        };
      }, 10973: function(t2) {
        var e2 = Object.prototype.toString;
        t2.exports = function(t3) {
          var r2;
          return "[object Object]" === e2.call(t3) && (null === (r2 = Object.getPrototypeOf(t3)) || r2 === Object.getPrototypeOf({}));
        };
      }, 18546: function(t2) {
        t2.exports = function(t3) {
          for (var e2, r2 = t3.length, n2 = 0; n2 < r2; n2++)
            if (((e2 = t3.charCodeAt(n2)) < 9 || e2 > 13) && 32 !== e2 && 133 !== e2 && 160 !== e2 && 5760 !== e2 && 6158 !== e2 && (e2 < 8192 || e2 > 8205) && 8232 !== e2 && 8233 !== e2 && 8239 !== e2 && 8287 !== e2 && 8288 !== e2 && 12288 !== e2 && 65279 !== e2)
              return false;
          return true;
        };
      }, 89546: function(t2) {
        t2.exports = function(t3) {
          return "string" == typeof t3 && (t3 = t3.trim(), !!(/^[mzlhvcsqta]\s*[-+.0-9][^mlhvzcsqta]+/i.test(t3) && /[\dz]$/i.test(t3) && t3.length > 4));
        };
      }, 9187: function(t2, e2, r2) {
        var n2 = r2(31353), i = r2(72077), a = r2(6614), o = a("Object.prototype.toString"), s = r2(84543)(), l = r2(40383), u = "undefined" == typeof globalThis ? r2.g : globalThis, c = i(), f2 = a("Array.prototype.indexOf", true) || function(t3, e3) {
          for (var r3 = 0; r3 < t3.length; r3 += 1)
            if (t3[r3] === e3)
              return r3;
          return -1;
        }, h = a("String.prototype.slice"), p2 = {}, d2 = Object.getPrototypeOf;
        s && l && d2 && n2(c, function(t3) {
          var e3 = new u[t3]();
          if (Symbol.toStringTag in e3) {
            var r3 = d2(e3), n3 = l(r3, Symbol.toStringTag);
            if (!n3) {
              var i2 = d2(r3);
              n3 = l(i2, Symbol.toStringTag);
            }
            p2[t3] = n3.get;
          }
        }), t2.exports = function(t3) {
          if (!t3 || "object" != typeof t3)
            return false;
          if (!s || !(Symbol.toStringTag in t3)) {
            var e3 = h(o(t3), 8, -1);
            return f2(c, e3) > -1;
          }
          return !!l && function(t4) {
            var e4 = false;
            return n2(p2, function(r3, n3) {
              if (!e4)
                try {
                  e4 = r3.call(t4) === n3;
                } catch (t5) {
                }
            }), e4;
          }(t3);
        };
      }, 44517: function(t2) {
        t2.exports = function() {
          var t3, e2, r2;
          function n2(n3, i) {
            if (t3)
              if (e2) {
                var a = "var sharedChunk = {}; (" + t3 + ")(sharedChunk); (" + e2 + ")(sharedChunk);", o = {};
                t3(o), (r2 = i(o)).workerUrl = window.URL.createObjectURL(new Blob([a], { type: "text/javascript" }));
              } else
                e2 = i;
            else
              t3 = i;
          }
          return n2(0, function(t4) {
            function e3(t5, e4) {
              return t5(e4 = { exports: {} }, e4.exports), e4.exports;
            }
            var r3 = "1.10.1", n3 = i;
            function i(t5, e4, r4, n4) {
              this.cx = 3 * t5, this.bx = 3 * (r4 - t5) - this.cx, this.ax = 1 - this.cx - this.bx, this.cy = 3 * e4, this.by = 3 * (n4 - e4) - this.cy, this.ay = 1 - this.cy - this.by, this.p1x = t5, this.p1y = n4, this.p2x = r4, this.p2y = n4;
            }
            i.prototype.sampleCurveX = function(t5) {
              return ((this.ax * t5 + this.bx) * t5 + this.cx) * t5;
            }, i.prototype.sampleCurveY = function(t5) {
              return ((this.ay * t5 + this.by) * t5 + this.cy) * t5;
            }, i.prototype.sampleCurveDerivativeX = function(t5) {
              return (3 * this.ax * t5 + 2 * this.bx) * t5 + this.cx;
            }, i.prototype.solveCurveX = function(t5, e4) {
              var r4, n4, i2, a2, o2;
              for (void 0 === e4 && (e4 = 1e-6), i2 = t5, o2 = 0; o2 < 8; o2++) {
                if (a2 = this.sampleCurveX(i2) - t5, Math.abs(a2) < e4)
                  return i2;
                var s2 = this.sampleCurveDerivativeX(i2);
                if (Math.abs(s2) < 1e-6)
                  break;
                i2 -= a2 / s2;
              }
              if ((i2 = t5) < (r4 = 0))
                return r4;
              if (i2 > (n4 = 1))
                return n4;
              for (; r4 < n4; ) {
                if (a2 = this.sampleCurveX(i2), Math.abs(a2 - t5) < e4)
                  return i2;
                t5 > a2 ? r4 = i2 : n4 = i2, i2 = 0.5 * (n4 - r4) + r4;
              }
              return i2;
            }, i.prototype.solve = function(t5, e4) {
              return this.sampleCurveY(this.solveCurveX(t5, e4));
            };
            var a = o;
            function o(t5, e4) {
              this.x = t5, this.y = e4;
            }
            function s(t5, e4, r4, i2) {
              var a2 = new n3(t5, e4, r4, i2);
              return function(t6) {
                return a2.solve(t6);
              };
            }
            o.prototype = { clone: function() {
              return new o(this.x, this.y);
            }, add: function(t5) {
              return this.clone()._add(t5);
            }, sub: function(t5) {
              return this.clone()._sub(t5);
            }, multByPoint: function(t5) {
              return this.clone()._multByPoint(t5);
            }, divByPoint: function(t5) {
              return this.clone()._divByPoint(t5);
            }, mult: function(t5) {
              return this.clone()._mult(t5);
            }, div: function(t5) {
              return this.clone()._div(t5);
            }, rotate: function(t5) {
              return this.clone()._rotate(t5);
            }, rotateAround: function(t5, e4) {
              return this.clone()._rotateAround(t5, e4);
            }, matMult: function(t5) {
              return this.clone()._matMult(t5);
            }, unit: function() {
              return this.clone()._unit();
            }, perp: function() {
              return this.clone()._perp();
            }, round: function() {
              return this.clone()._round();
            }, mag: function() {
              return Math.sqrt(this.x * this.x + this.y * this.y);
            }, equals: function(t5) {
              return this.x === t5.x && this.y === t5.y;
            }, dist: function(t5) {
              return Math.sqrt(this.distSqr(t5));
            }, distSqr: function(t5) {
              var e4 = t5.x - this.x, r4 = t5.y - this.y;
              return e4 * e4 + r4 * r4;
            }, angle: function() {
              return Math.atan2(this.y, this.x);
            }, angleTo: function(t5) {
              return Math.atan2(this.y - t5.y, this.x - t5.x);
            }, angleWith: function(t5) {
              return this.angleWithSep(t5.x, t5.y);
            }, angleWithSep: function(t5, e4) {
              return Math.atan2(this.x * e4 - this.y * t5, this.x * t5 + this.y * e4);
            }, _matMult: function(t5) {
              var e4 = t5[0] * this.x + t5[1] * this.y, r4 = t5[2] * this.x + t5[3] * this.y;
              return this.x = e4, this.y = r4, this;
            }, _add: function(t5) {
              return this.x += t5.x, this.y += t5.y, this;
            }, _sub: function(t5) {
              return this.x -= t5.x, this.y -= t5.y, this;
            }, _mult: function(t5) {
              return this.x *= t5, this.y *= t5, this;
            }, _div: function(t5) {
              return this.x /= t5, this.y /= t5, this;
            }, _multByPoint: function(t5) {
              return this.x *= t5.x, this.y *= t5.y, this;
            }, _divByPoint: function(t5) {
              return this.x /= t5.x, this.y /= t5.y, this;
            }, _unit: function() {
              return this._div(this.mag()), this;
            }, _perp: function() {
              var t5 = this.y;
              return this.y = this.x, this.x = -t5, this;
            }, _rotate: function(t5) {
              var e4 = Math.cos(t5), r4 = Math.sin(t5), n4 = e4 * this.x - r4 * this.y, i2 = r4 * this.x + e4 * this.y;
              return this.x = n4, this.y = i2, this;
            }, _rotateAround: function(t5, e4) {
              var r4 = Math.cos(t5), n4 = Math.sin(t5), i2 = e4.x + r4 * (this.x - e4.x) - n4 * (this.y - e4.y), a2 = e4.y + n4 * (this.x - e4.x) + r4 * (this.y - e4.y);
              return this.x = i2, this.y = a2, this;
            }, _round: function() {
              return this.x = Math.round(this.x), this.y = Math.round(this.y), this;
            } }, o.convert = function(t5) {
              return t5 instanceof o ? t5 : Array.isArray(t5) ? new o(t5[0], t5[1]) : t5;
            };
            var l = s(0.25, 0.1, 0.25, 1);
            function u(t5, e4, r4) {
              return Math.min(r4, Math.max(e4, t5));
            }
            function c(t5, e4, r4) {
              var n4 = r4 - e4, i2 = ((t5 - e4) % n4 + n4) % n4 + e4;
              return i2 === e4 ? r4 : i2;
            }
            function f2(t5) {
              for (var e4 = [], r4 = arguments.length - 1; r4-- > 0; )
                e4[r4] = arguments[r4 + 1];
              for (var n4 = 0, i2 = e4; n4 < i2.length; n4 += 1) {
                var a2 = i2[n4];
                for (var o2 in a2)
                  t5[o2] = a2[o2];
              }
              return t5;
            }
            var h = 1;
            function p2() {
              return h++;
            }
            function d2() {
              return function t5(e4) {
                return e4 ? (e4 ^ 16 * Math.random() >> e4 / 4).toString(16) : ([1e7] + -[1e3] + -4e3 + -8e3 + -1e11).replace(/[018]/g, t5);
              }();
            }
            function v(t5) {
              return !!t5 && /^[0-9a-f]{8}-[0-9a-f]{4}-[4][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(t5);
            }
            function g2(t5, e4) {
              t5.forEach(function(t6) {
                e4[t6] && (e4[t6] = e4[t6].bind(e4));
              });
            }
            function y(t5, e4) {
              return -1 !== t5.indexOf(e4, t5.length - e4.length);
            }
            function m2(t5, e4, r4) {
              var n4 = {};
              for (var i2 in t5)
                n4[i2] = e4.call(r4 || this, t5[i2], i2, t5);
              return n4;
            }
            function x(t5, e4, r4) {
              var n4 = {};
              for (var i2 in t5)
                e4.call(r4 || this, t5[i2], i2, t5) && (n4[i2] = t5[i2]);
              return n4;
            }
            function b(t5) {
              return Array.isArray(t5) ? t5.map(b) : "object" == typeof t5 && t5 ? m2(t5, b) : t5;
            }
            var _ = {};
            function w2(t5) {
              _[t5] || ("undefined" != typeof console && console.warn(t5), _[t5] = true);
            }
            function T(t5, e4, r4) {
              return (r4.y - t5.y) * (e4.x - t5.x) > (e4.y - t5.y) * (r4.x - t5.x);
            }
            function k(t5) {
              for (var e4 = 0, r4 = 0, n4 = t5.length, i2 = n4 - 1, a2 = void 0, o2 = void 0; r4 < n4; i2 = r4++)
                a2 = t5[r4], e4 += ((o2 = t5[i2]).x - a2.x) * (a2.y + o2.y);
              return e4;
            }
            function A() {
              return "undefined" != typeof WorkerGlobalScope && "undefined" != typeof self && self instanceof WorkerGlobalScope;
            }
            function M(t5) {
              var e4 = {};
              if (t5.replace(/(?:^|(?:\s*\,\s*))([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)(?:\=(?:([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)|(?:\"((?:[^"\\]|\\.)*)\")))?/g, function(t6, r5, n4, i2) {
                var a2 = n4 || i2;
                return e4[r5] = !a2 || a2.toLowerCase(), "";
              }), e4["max-age"]) {
                var r4 = parseInt(e4["max-age"], 10);
                isNaN(r4) ? delete e4["max-age"] : e4["max-age"] = r4;
              }
              return e4;
            }
            var S = null;
            function E(t5) {
              if (null == S) {
                var e4 = t5.navigator ? t5.navigator.userAgent : null;
                S = !!t5.safari || !(!e4 || !(/\b(iPad|iPhone|iPod)\b/.test(e4) || e4.match("Safari") && !e4.match("Chrome")));
              }
              return S;
            }
            function L(t5) {
              try {
                var e4 = self[t5];
                return e4.setItem("_mapbox_test_", 1), e4.removeItem("_mapbox_test_"), true;
              } catch (t6) {
                return false;
              }
            }
            var C, P, O, I, D = self.performance && self.performance.now ? self.performance.now.bind(self.performance) : Date.now.bind(Date), z = self.requestAnimationFrame || self.mozRequestAnimationFrame || self.webkitRequestAnimationFrame || self.msRequestAnimationFrame, R = self.cancelAnimationFrame || self.mozCancelAnimationFrame || self.webkitCancelAnimationFrame || self.msCancelAnimationFrame, F = { now: D, frame: function(t5) {
              var e4 = z(t5);
              return { cancel: function() {
                return R(e4);
              } };
            }, getImageData: function(t5, e4) {
              void 0 === e4 && (e4 = 0);
              var r4 = self.document.createElement("canvas"), n4 = r4.getContext("2d");
              if (!n4)
                throw new Error("failed to create canvas 2d context");
              return r4.width = t5.width, r4.height = t5.height, n4.drawImage(t5, 0, 0, t5.width, t5.height), n4.getImageData(-e4, -e4, t5.width + 2 * e4, t5.height + 2 * e4);
            }, resolveURL: function(t5) {
              return C || (C = self.document.createElement("a")), C.href = t5, C.href;
            }, hardwareConcurrency: self.navigator.hardwareConcurrency || 4, get devicePixelRatio() {
              return self.devicePixelRatio;
            }, get prefersReducedMotion() {
              return !!self.matchMedia && (null == P && (P = self.matchMedia("(prefers-reduced-motion: reduce)")), P.matches);
            } }, B = { API_URL: "https://api.mapbox.com", get EVENTS_URL() {
              return this.API_URL ? 0 === this.API_URL.indexOf("https://api.mapbox.cn") ? "https://events.mapbox.cn/events/v2" : 0 === this.API_URL.indexOf("https://api.mapbox.com") ? "https://events.mapbox.com/events/v2" : null : null;
            }, FEEDBACK_URL: "https://apps.mapbox.com/feedback", REQUIRE_ACCESS_TOKEN: true, ACCESS_TOKEN: null, MAX_PARALLEL_IMAGE_REQUESTS: 16 }, N = { supported: false, testSupport: function(t5) {
              !j && I && (U ? V(t5) : O = t5);
            } }, j = false, U = false;
            function V(t5) {
              var e4 = t5.createTexture();
              t5.bindTexture(t5.TEXTURE_2D, e4);
              try {
                if (t5.texImage2D(t5.TEXTURE_2D, 0, t5.RGBA, t5.RGBA, t5.UNSIGNED_BYTE, I), t5.isContextLost())
                  return;
                N.supported = true;
              } catch (t6) {
              }
              t5.deleteTexture(e4), j = true;
            }
            self.document && ((I = self.document.createElement("img")).onload = function() {
              O && V(O), O = null, U = true;
            }, I.onerror = function() {
              j = true, O = null;
            }, I.src = "data:image/webp;base64,UklGRh4AAABXRUJQVlA4TBEAAAAvAQAAAAfQ//73v/+BiOh/AAA=");
            var H = "01";
            var q2 = function(t5, e4) {
              this._transformRequestFn = t5, this._customAccessToken = e4, this._createSkuToken();
            };
            function G(t5) {
              return 0 === t5.indexOf("mapbox:");
            }
            q2.prototype._createSkuToken = function() {
              var t5 = function() {
                for (var t6 = "", e4 = 0; e4 < 10; e4++)
                  t6 += "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"[Math.floor(62 * Math.random())];
                return { token: ["1", H, t6].join(""), tokenExpiresAt: Date.now() + 432e5 };
              }();
              this._skuToken = t5.token, this._skuTokenExpiresAt = t5.tokenExpiresAt;
            }, q2.prototype._isSkuTokenExpired = function() {
              return Date.now() > this._skuTokenExpiresAt;
            }, q2.prototype.transformRequest = function(t5, e4) {
              return this._transformRequestFn && this._transformRequestFn(t5, e4) || { url: t5 };
            }, q2.prototype.normalizeStyleURL = function(t5, e4) {
              if (!G(t5))
                return t5;
              var r4 = X(t5);
              return r4.path = "/styles/v1" + r4.path, this._makeAPIURL(r4, this._customAccessToken || e4);
            }, q2.prototype.normalizeGlyphsURL = function(t5, e4) {
              if (!G(t5))
                return t5;
              var r4 = X(t5);
              return r4.path = "/fonts/v1" + r4.path, this._makeAPIURL(r4, this._customAccessToken || e4);
            }, q2.prototype.normalizeSourceURL = function(t5, e4) {
              if (!G(t5))
                return t5;
              var r4 = X(t5);
              return r4.path = "/v4/" + r4.authority + ".json", r4.params.push("secure"), this._makeAPIURL(r4, this._customAccessToken || e4);
            }, q2.prototype.normalizeSpriteURL = function(t5, e4, r4, n4) {
              var i2 = X(t5);
              return G(t5) ? (i2.path = "/styles/v1" + i2.path + "/sprite" + e4 + r4, this._makeAPIURL(i2, this._customAccessToken || n4)) : (i2.path += "" + e4 + r4, J(i2));
            }, q2.prototype.normalizeTileURL = function(t5, e4) {
              if (this._isSkuTokenExpired() && this._createSkuToken(), t5 && !G(t5))
                return t5;
              var r4 = X(t5), n4 = F.devicePixelRatio >= 2 || 512 === e4 ? "@2x" : "", i2 = N.supported ? ".webp" : "$1";
              r4.path = r4.path.replace(/(\.(png|jpg)\d*)(?=$)/, "" + n4 + i2), r4.path = r4.path.replace(/^.+\/v4\//, "/"), r4.path = "/v4" + r4.path;
              var a2 = this._customAccessToken || function(t6) {
                for (var e5 = 0, r5 = t6; e5 < r5.length; e5 += 1) {
                  var n5 = r5[e5].match(/^access_token=(.*)$/);
                  if (n5)
                    return n5[1];
                }
                return null;
              }(r4.params) || B.ACCESS_TOKEN;
              return B.REQUIRE_ACCESS_TOKEN && a2 && this._skuToken && r4.params.push("sku=" + this._skuToken), this._makeAPIURL(r4, a2);
            }, q2.prototype.canonicalizeTileURL = function(t5, e4) {
              var r4 = X(t5);
              if (!r4.path.match(/(^\/v4\/)/) || !r4.path.match(/\.[\w]+$/))
                return t5;
              var n4 = "mapbox://tiles/";
              n4 += r4.path.replace("/v4/", "");
              var i2 = r4.params;
              return e4 && (i2 = i2.filter(function(t6) {
                return !t6.match(/^access_token=/);
              })), i2.length && (n4 += "?" + i2.join("&")), n4;
            }, q2.prototype.canonicalizeTileset = function(t5, e4) {
              for (var r4 = !!e4 && G(e4), n4 = [], i2 = 0, a2 = t5.tiles || []; i2 < a2.length; i2 += 1) {
                var o2 = a2[i2];
                Y(o2) ? n4.push(this.canonicalizeTileURL(o2, r4)) : n4.push(o2);
              }
              return n4;
            }, q2.prototype._makeAPIURL = function(t5, e4) {
              var r4 = "See https://www.mapbox.com/api-documentation/#access-tokens-and-token-scopes", n4 = X(B.API_URL);
              if (t5.protocol = n4.protocol, t5.authority = n4.authority, "/" !== n4.path && (t5.path = "" + n4.path + t5.path), !B.REQUIRE_ACCESS_TOKEN)
                return J(t5);
              if (!(e4 = e4 || B.ACCESS_TOKEN))
                throw new Error("An API access token is required to use Mapbox GL. " + r4);
              if ("s" === e4[0])
                throw new Error("Use a public access token (pk.*) with Mapbox GL, not a secret access token (sk.*). " + r4);
              return t5.params = t5.params.filter(function(t6) {
                return -1 === t6.indexOf("access_token");
              }), t5.params.push("access_token=" + e4), J(t5);
            };
            var Z = /^((https?:)?\/\/)?([^\/]+\.)?mapbox\.c(n|om)(\/|\?|$)/i;
            function Y(t5) {
              return Z.test(t5);
            }
            var W = /^(\w+):\/\/([^/?]*)(\/[^?]+)?\??(.+)?/;
            function X(t5) {
              var e4 = t5.match(W);
              if (!e4)
                throw new Error("Unable to parse URL object");
              return { protocol: e4[1], authority: e4[2], path: e4[3] || "/", params: e4[4] ? e4[4].split("&") : [] };
            }
            function J(t5) {
              var e4 = t5.params.length ? "?" + t5.params.join("&") : "";
              return t5.protocol + "://" + t5.authority + t5.path + e4;
            }
            var K = "mapbox.eventData";
            function $(t5) {
              if (!t5)
                return null;
              var e4, r4 = t5.split(".");
              if (!r4 || 3 !== r4.length)
                return null;
              try {
                return JSON.parse((e4 = r4[1], decodeURIComponent(self.atob(e4).split("").map(function(t6) {
                  return "%" + ("00" + t6.charCodeAt(0).toString(16)).slice(-2);
                }).join(""))));
              } catch (t6) {
                return null;
              }
            }
            var Q = function(t5) {
              this.type = t5, this.anonId = null, this.eventData = {}, this.queue = [], this.pendingRequest = null;
            };
            Q.prototype.getStorageKey = function(t5) {
              var e4, r4, n4 = $(B.ACCESS_TOKEN);
              return e4 = n4 && n4.u ? (r4 = n4.u, self.btoa(encodeURIComponent(r4).replace(/%([0-9A-F]{2})/g, function(t6, e5) {
                return String.fromCharCode(Number("0x" + e5));
              }))) : B.ACCESS_TOKEN || "", t5 ? K + "." + t5 + ":" + e4 : K + ":" + e4;
            }, Q.prototype.fetchEventData = function() {
              var t5 = L("localStorage"), e4 = this.getStorageKey(), r4 = this.getStorageKey("uuid");
              if (t5)
                try {
                  var n4 = self.localStorage.getItem(e4);
                  n4 && (this.eventData = JSON.parse(n4));
                  var i2 = self.localStorage.getItem(r4);
                  i2 && (this.anonId = i2);
                } catch (t6) {
                  w2("Unable to read from LocalStorage");
                }
            }, Q.prototype.saveEventData = function() {
              var t5 = L("localStorage"), e4 = this.getStorageKey(), r4 = this.getStorageKey("uuid");
              if (t5)
                try {
                  self.localStorage.setItem(r4, this.anonId), Object.keys(this.eventData).length >= 1 && self.localStorage.setItem(e4, JSON.stringify(this.eventData));
                } catch (t6) {
                  w2("Unable to write to LocalStorage");
                }
            }, Q.prototype.processRequests = function(t5) {
            }, Q.prototype.postEvent = function(t5, e4, n4, i2) {
              var a2 = this;
              if (B.EVENTS_URL) {
                var o2 = X(B.EVENTS_URL);
                o2.params.push("access_token=" + (i2 || B.ACCESS_TOKEN || ""));
                var s2 = { event: this.type, created: new Date(t5).toISOString(), sdkIdentifier: "mapbox-gl-js", sdkVersion: r3, skuId: H, userId: this.anonId }, l2 = e4 ? f2(s2, e4) : s2, u2 = { url: J(o2), headers: { "Content-Type": "text/plain" }, body: JSON.stringify([l2]) };
                this.pendingRequest = kt(u2, function(t6) {
                  a2.pendingRequest = null, n4(t6), a2.saveEventData(), a2.processRequests(i2);
                });
              }
            }, Q.prototype.queueRequest = function(t5, e4) {
              this.queue.push(t5), this.processRequests(e4);
            };
            var tt, et, rt = function(t5) {
              function e4() {
                t5.call(this, "map.load"), this.success = {}, this.skuToken = "";
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.postMapLoadEvent = function(t6, e5, r4, n4) {
                this.skuToken = r4, (B.EVENTS_URL && n4 || B.ACCESS_TOKEN && Array.isArray(t6) && t6.some(function(t7) {
                  return G(t7) || Y(t7);
                })) && this.queueRequest({ id: e5, timestamp: Date.now() }, n4);
              }, e4.prototype.processRequests = function(t6) {
                var e5 = this;
                if (!this.pendingRequest && 0 !== this.queue.length) {
                  var r4 = this.queue.shift(), n4 = r4.id, i2 = r4.timestamp;
                  n4 && this.success[n4] || (this.anonId || this.fetchEventData(), v(this.anonId) || (this.anonId = d2()), this.postEvent(i2, { skuToken: this.skuToken }, function(t7) {
                    t7 || n4 && (e5.success[n4] = true);
                  }, t6));
                }
              }, e4;
            }(Q), nt = function(t5) {
              function e4(e5) {
                t5.call(this, "appUserTurnstile"), this._customAccessToken = e5;
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.postTurnstileEvent = function(t6, e5) {
                B.EVENTS_URL && B.ACCESS_TOKEN && Array.isArray(t6) && t6.some(function(t7) {
                  return G(t7) || Y(t7);
                }) && this.queueRequest(Date.now(), e5);
              }, e4.prototype.processRequests = function(t6) {
                var e5 = this;
                if (!this.pendingRequest && 0 !== this.queue.length) {
                  this.anonId && this.eventData.lastSuccess && this.eventData.tokenU || this.fetchEventData();
                  var r4 = $(B.ACCESS_TOKEN), n4 = r4 ? r4.u : B.ACCESS_TOKEN, i2 = n4 !== this.eventData.tokenU;
                  v(this.anonId) || (this.anonId = d2(), i2 = true);
                  var a2 = this.queue.shift();
                  if (this.eventData.lastSuccess) {
                    var o2 = new Date(this.eventData.lastSuccess), s2 = new Date(a2), l2 = (a2 - this.eventData.lastSuccess) / 864e5;
                    i2 = i2 || l2 >= 1 || l2 < -1 || o2.getDate() !== s2.getDate();
                  } else
                    i2 = true;
                  if (!i2)
                    return this.processRequests();
                  this.postEvent(a2, { "enabled.telemetry": false }, function(t7) {
                    t7 || (e5.eventData.lastSuccess = a2, e5.eventData.tokenU = n4);
                  }, t6);
                }
              }, e4;
            }(Q), it = new nt(), at = it.postTurnstileEvent.bind(it), ot = new rt(), st = ot.postMapLoadEvent.bind(ot), lt = "mapbox-tiles", ut = 500, ct = 50;
            function ft() {
              self.caches && !tt && (tt = self.caches.open(lt));
            }
            function ht(t5, e4, r4) {
              if (ft(), tt) {
                var n4 = { status: e4.status, statusText: e4.statusText, headers: new self.Headers() };
                e4.headers.forEach(function(t6, e5) {
                  return n4.headers.set(e5, t6);
                });
                var i2 = M(e4.headers.get("Cache-Control") || "");
                i2["no-store"] || (i2["max-age"] && n4.headers.set("Expires", new Date(r4 + 1e3 * i2["max-age"]).toUTCString()), new Date(n4.headers.get("Expires")).getTime() - r4 < 42e4 || function(t6, e5) {
                  if (void 0 === et)
                    try {
                      new Response(new ReadableStream()), et = true;
                    } catch (t7) {
                      et = false;
                    }
                  et ? e5(t6.body) : t6.blob().then(e5);
                }(e4, function(e5) {
                  var r5 = new self.Response(e5, n4);
                  ft(), tt && tt.then(function(e6) {
                    return e6.put(pt(t5.url), r5);
                  }).catch(function(t6) {
                    return w2(t6.message);
                  });
                }));
              }
            }
            function pt(t5) {
              var e4 = t5.indexOf("?");
              return e4 < 0 ? t5 : t5.slice(0, e4);
            }
            function dt(t5, e4) {
              if (ft(), !tt)
                return e4(null);
              var r4 = pt(t5.url);
              tt.then(function(t6) {
                t6.match(r4).then(function(n4) {
                  var i2 = function(t7) {
                    if (!t7)
                      return false;
                    var e5 = new Date(t7.headers.get("Expires") || 0), r5 = M(t7.headers.get("Cache-Control") || "");
                    return e5 > Date.now() && !r5["no-cache"];
                  }(n4);
                  t6.delete(r4), i2 && t6.put(r4, n4.clone()), e4(null, n4, i2);
                }).catch(e4);
              }).catch(e4);
            }
            var vt, gt = 1 / 0;
            function yt() {
              return null == vt && (vt = self.OffscreenCanvas && new self.OffscreenCanvas(1, 1).getContext("2d") && "function" == typeof self.createImageBitmap), vt;
            }
            var mt = { Unknown: "Unknown", Style: "Style", Source: "Source", Tile: "Tile", Glyphs: "Glyphs", SpriteImage: "SpriteImage", SpriteJSON: "SpriteJSON", Image: "Image" };
            "function" == typeof Object.freeze && Object.freeze(mt);
            var xt = function(t5) {
              function e4(e5, r4, n4) {
                401 === r4 && Y(n4) && (e5 += ": you may have provided an invalid Mapbox access token. See https://www.mapbox.com/api-documentation/#access-tokens-and-token-scopes"), t5.call(this, e5), this.status = r4, this.url = n4, this.name = this.constructor.name, this.message = e5;
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.toString = function() {
                return this.name + ": " + this.message + " (" + this.status + "): " + this.url;
              }, e4;
            }(Error), bt = A() ? function() {
              return self.worker && self.worker.referrer;
            } : function() {
              return ("blob:" === self.location.protocol ? self.parent : self).location.href;
            };
            function _t(t5, e4) {
              var r4, n4 = new self.AbortController(), i2 = new self.Request(t5.url, { method: t5.method || "GET", body: t5.body, credentials: t5.credentials, headers: t5.headers, referrer: bt(), signal: n4.signal }), a2 = false, o2 = false, s2 = (r4 = i2.url).indexOf("sku=") > 0 && Y(r4);
              "json" === t5.type && i2.headers.set("Accept", "application/json");
              var l2 = function(r5, n5, a3) {
                if (!o2) {
                  if (r5 && "SecurityError" !== r5.message && w2(r5), n5 && a3)
                    return u2(n5);
                  var l3 = Date.now();
                  self.fetch(i2).then(function(r6) {
                    if (r6.ok) {
                      var n6 = s2 ? r6.clone() : null;
                      return u2(r6, n6, l3);
                    }
                    return e4(new xt(r6.statusText, r6.status, t5.url));
                  }).catch(function(t6) {
                    20 !== t6.code && e4(new Error(t6.message));
                  });
                }
              }, u2 = function(r5, n5, s3) {
                ("arrayBuffer" === t5.type ? r5.arrayBuffer() : "json" === t5.type ? r5.json() : r5.text()).then(function(t6) {
                  o2 || (n5 && s3 && ht(i2, n5, s3), a2 = true, e4(null, t6, r5.headers.get("Cache-Control"), r5.headers.get("Expires")));
                }).catch(function(t6) {
                  o2 || e4(new Error(t6.message));
                });
              };
              return s2 ? dt(i2, l2) : l2(null, null), { cancel: function() {
                o2 = true, a2 || n4.abort();
              } };
            }
            var wt = function(t5, e4) {
              if (r4 = t5.url, !(/^file:/.test(r4) || /^file:/.test(bt()) && !/^\w+:/.test(r4))) {
                if (self.fetch && self.Request && self.AbortController && self.Request.prototype.hasOwnProperty("signal"))
                  return _t(t5, e4);
                if (A() && self.worker && self.worker.actor) {
                  return self.worker.actor.send("getResource", t5, e4, void 0, true);
                }
              }
              var r4;
              return function(t6, e5) {
                var r5 = new self.XMLHttpRequest();
                for (var n4 in r5.open(t6.method || "GET", t6.url, true), "arrayBuffer" === t6.type && (r5.responseType = "arraybuffer"), t6.headers)
                  r5.setRequestHeader(n4, t6.headers[n4]);
                return "json" === t6.type && (r5.responseType = "text", r5.setRequestHeader("Accept", "application/json")), r5.withCredentials = "include" === t6.credentials, r5.onerror = function() {
                  e5(new Error(r5.statusText));
                }, r5.onload = function() {
                  if ((r5.status >= 200 && r5.status < 300 || 0 === r5.status) && null !== r5.response) {
                    var n5 = r5.response;
                    if ("json" === t6.type)
                      try {
                        n5 = JSON.parse(r5.response);
                      } catch (t7) {
                        return e5(t7);
                      }
                    e5(null, n5, r5.getResponseHeader("Cache-Control"), r5.getResponseHeader("Expires"));
                  } else
                    e5(new xt(r5.statusText, r5.status, t6.url));
                }, r5.send(t6.body), { cancel: function() {
                  return r5.abort();
                } };
              }(t5, e4);
            }, Tt = function(t5, e4) {
              return wt(f2(t5, { type: "arrayBuffer" }), e4);
            }, kt = function(t5, e4) {
              return wt(f2(t5, { method: "POST" }), e4);
            };
            var At, Mt;
            At = [], Mt = 0;
            var St = function(t5, e4) {
              if (N.supported && (t5.headers || (t5.headers = {}), t5.headers.accept = "image/webp,*/*"), Mt >= B.MAX_PARALLEL_IMAGE_REQUESTS) {
                var r4 = { requestParameters: t5, callback: e4, cancelled: false, cancel: function() {
                  this.cancelled = true;
                } };
                return At.push(r4), r4;
              }
              Mt++;
              var n4 = false, i2 = function() {
                if (!n4)
                  for (n4 = true, Mt--; At.length && Mt < B.MAX_PARALLEL_IMAGE_REQUESTS; ) {
                    var t6 = At.shift(), e5 = t6.requestParameters, r5 = t6.callback;
                    t6.cancelled || (t6.cancel = St(e5, r5).cancel);
                  }
              }, a2 = Tt(t5, function(t6, r5, n5, a3) {
                i2(), t6 ? e4(t6) : r5 && (yt() ? function(t7, e5) {
                  var r6 = new self.Blob([new Uint8Array(t7)], { type: "image/png" });
                  self.createImageBitmap(r6).then(function(t8) {
                    e5(null, t8);
                  }).catch(function(t8) {
                    e5(new Error("Could not load image because of " + t8.message + ". Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported."));
                  });
                }(r5, e4) : function(t7, e5, r6, n6) {
                  var i3 = new self.Image(), a4 = self.URL;
                  i3.onload = function() {
                    e5(null, i3), a4.revokeObjectURL(i3.src);
                  }, i3.onerror = function() {
                    return e5(new Error("Could not load image. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported."));
                  };
                  var o2 = new self.Blob([new Uint8Array(t7)], { type: "image/png" });
                  i3.cacheControl = r6, i3.expires = n6, i3.src = t7.byteLength ? a4.createObjectURL(o2) : "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAC0lEQVQYV2NgAAIAAAUAAarVyFEAAAAASUVORK5CYII=";
                }(r5, e4, n5, a3));
              });
              return { cancel: function() {
                a2.cancel(), i2();
              } };
            };
            function Et(t5, e4, r4) {
              r4[t5] && -1 !== r4[t5].indexOf(e4) || (r4[t5] = r4[t5] || [], r4[t5].push(e4));
            }
            function Lt(t5, e4, r4) {
              if (r4 && r4[t5]) {
                var n4 = r4[t5].indexOf(e4);
                -1 !== n4 && r4[t5].splice(n4, 1);
              }
            }
            var Ct = function(t5, e4) {
              void 0 === e4 && (e4 = {}), f2(this, e4), this.type = t5;
            }, Pt = function(t5) {
              function e4(e5, r4) {
                void 0 === r4 && (r4 = {}), t5.call(this, "error", f2({ error: e5 }, r4));
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4;
            }(Ct), Ot = function() {
            };
            Ot.prototype.on = function(t5, e4) {
              return this._listeners = this._listeners || {}, Et(t5, e4, this._listeners), this;
            }, Ot.prototype.off = function(t5, e4) {
              return Lt(t5, e4, this._listeners), Lt(t5, e4, this._oneTimeListeners), this;
            }, Ot.prototype.once = function(t5, e4) {
              return this._oneTimeListeners = this._oneTimeListeners || {}, Et(t5, e4, this._oneTimeListeners), this;
            }, Ot.prototype.fire = function(t5, e4) {
              "string" == typeof t5 && (t5 = new Ct(t5, e4 || {}));
              var r4 = t5.type;
              if (this.listens(r4)) {
                t5.target = this;
                for (var n4 = 0, i2 = this._listeners && this._listeners[r4] ? this._listeners[r4].slice() : []; n4 < i2.length; n4 += 1)
                  i2[n4].call(this, t5);
                for (var a2 = 0, o2 = this._oneTimeListeners && this._oneTimeListeners[r4] ? this._oneTimeListeners[r4].slice() : []; a2 < o2.length; a2 += 1) {
                  var s2 = o2[a2];
                  Lt(r4, s2, this._oneTimeListeners), s2.call(this, t5);
                }
                var l2 = this._eventedParent;
                l2 && (f2(t5, "function" == typeof this._eventedParentData ? this._eventedParentData() : this._eventedParentData), l2.fire(t5));
              } else
                t5 instanceof Pt && console.error(t5.error);
              return this;
            }, Ot.prototype.listens = function(t5) {
              return this._listeners && this._listeners[t5] && this._listeners[t5].length > 0 || this._oneTimeListeners && this._oneTimeListeners[t5] && this._oneTimeListeners[t5].length > 0 || this._eventedParent && this._eventedParent.listens(t5);
            }, Ot.prototype.setEventedParent = function(t5, e4) {
              return this._eventedParent = t5, this._eventedParentData = e4, this;
            };
            var It = { $version: 8, $root: { version: { required: true, type: "enum", values: [8] }, name: { type: "string" }, metadata: { type: "*" }, center: { type: "array", value: "number" }, zoom: { type: "number" }, bearing: { type: "number", default: 0, period: 360, units: "degrees" }, pitch: { type: "number", default: 0, units: "degrees" }, light: { type: "light" }, sources: { required: true, type: "sources" }, sprite: { type: "string" }, glyphs: { type: "string" }, transition: { type: "transition" }, layers: { required: true, type: "array", value: "layer" } }, sources: { "*": { type: "source" } }, source: ["source_vector", "source_raster", "source_raster_dem", "source_geojson", "source_video", "source_image"], source_vector: { type: { required: true, type: "enum", values: { vector: {} } }, url: { type: "string" }, tiles: { type: "array", value: "string" }, bounds: { type: "array", value: "number", length: 4, default: [-180, -85.051129, 180, 85.051129] }, scheme: { type: "enum", values: { xyz: {}, tms: {} }, default: "xyz" }, minzoom: { type: "number", default: 0 }, maxzoom: { type: "number", default: 22 }, attribution: { type: "string" }, promoteId: { type: "promoteId" }, "*": { type: "*" } }, source_raster: { type: { required: true, type: "enum", values: { raster: {} } }, url: { type: "string" }, tiles: { type: "array", value: "string" }, bounds: { type: "array", value: "number", length: 4, default: [-180, -85.051129, 180, 85.051129] }, minzoom: { type: "number", default: 0 }, maxzoom: { type: "number", default: 22 }, tileSize: { type: "number", default: 512, units: "pixels" }, scheme: { type: "enum", values: { xyz: {}, tms: {} }, default: "xyz" }, attribution: { type: "string" }, "*": { type: "*" } }, source_raster_dem: { type: { required: true, type: "enum", values: { "raster-dem": {} } }, url: { type: "string" }, tiles: { type: "array", value: "string" }, bounds: { type: "array", value: "number", length: 4, default: [-180, -85.051129, 180, 85.051129] }, minzoom: { type: "number", default: 0 }, maxzoom: { type: "number", default: 22 }, tileSize: { type: "number", default: 512, units: "pixels" }, attribution: { type: "string" }, encoding: { type: "enum", values: { terrarium: {}, mapbox: {} }, default: "mapbox" }, "*": { type: "*" } }, source_geojson: { type: { required: true, type: "enum", values: { geojson: {} } }, data: { type: "*" }, maxzoom: { type: "number", default: 18 }, attribution: { type: "string" }, buffer: { type: "number", default: 128, maximum: 512, minimum: 0 }, tolerance: { type: "number", default: 0.375 }, cluster: { type: "boolean", default: false }, clusterRadius: { type: "number", default: 50, minimum: 0 }, clusterMaxZoom: { type: "number" }, clusterProperties: { type: "*" }, lineMetrics: { type: "boolean", default: false }, generateId: { type: "boolean", default: false }, promoteId: { type: "promoteId" } }, source_video: { type: { required: true, type: "enum", values: { video: {} } }, urls: { required: true, type: "array", value: "string" }, coordinates: { required: true, type: "array", length: 4, value: { type: "array", length: 2, value: "number" } } }, source_image: { type: { required: true, type: "enum", values: { image: {} } }, url: { required: true, type: "string" }, coordinates: { required: true, type: "array", length: 4, value: { type: "array", length: 2, value: "number" } } }, layer: { id: { type: "string", required: true }, type: { type: "enum", values: { fill: {}, line: {}, symbol: {}, circle: {}, heatmap: {}, "fill-extrusion": {}, raster: {}, hillshade: {}, background: {} }, required: true }, metadata: { type: "*" }, source: { type: "string" }, "source-layer": { type: "string" }, minzoom: { type: "number", minimum: 0, maximum: 24 }, maxzoom: { type: "number", minimum: 0, maximum: 24 }, filter: { type: "filter" }, layout: { type: "layout" }, paint: { type: "paint" } }, layout: ["layout_fill", "layout_line", "layout_circle", "layout_heatmap", "layout_fill-extrusion", "layout_symbol", "layout_raster", "layout_hillshade", "layout_background"], layout_background: { visibility: { type: "enum", values: { visible: {}, none: {} }, default: "visible", "property-type": "constant" } }, layout_fill: { "fill-sort-key": { type: "number", expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, visibility: { type: "enum", values: { visible: {}, none: {} }, default: "visible", "property-type": "constant" } }, layout_circle: { "circle-sort-key": { type: "number", expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, visibility: { type: "enum", values: { visible: {}, none: {} }, default: "visible", "property-type": "constant" } }, layout_heatmap: { visibility: { type: "enum", values: { visible: {}, none: {} }, default: "visible", "property-type": "constant" } }, "layout_fill-extrusion": { visibility: { type: "enum", values: { visible: {}, none: {} }, default: "visible", "property-type": "constant" } }, layout_line: { "line-cap": { type: "enum", values: { butt: {}, round: {}, square: {} }, default: "butt", expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "line-join": { type: "enum", values: { bevel: {}, round: {}, miter: {} }, default: "miter", expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "line-miter-limit": { type: "number", default: 2, requires: [{ "line-join": "miter" }], expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "line-round-limit": { type: "number", default: 1.05, requires: [{ "line-join": "round" }], expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "line-sort-key": { type: "number", expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, visibility: { type: "enum", values: { visible: {}, none: {} }, default: "visible", "property-type": "constant" } }, layout_symbol: { "symbol-placement": { type: "enum", values: { point: {}, line: {}, "line-center": {} }, default: "point", expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "symbol-spacing": { type: "number", default: 250, minimum: 1, units: "pixels", requires: [{ "symbol-placement": "line" }], expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "symbol-avoid-edges": { type: "boolean", default: false, expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "symbol-sort-key": { type: "number", expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "symbol-z-order": { type: "enum", values: { auto: {}, "viewport-y": {}, source: {} }, default: "auto", expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "icon-allow-overlap": { type: "boolean", default: false, requires: ["icon-image"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "icon-ignore-placement": { type: "boolean", default: false, requires: ["icon-image"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "icon-optional": { type: "boolean", default: false, requires: ["icon-image", "text-field"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "icon-rotation-alignment": { type: "enum", values: { map: {}, viewport: {}, auto: {} }, default: "auto", requires: ["icon-image"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "icon-size": { type: "number", default: 1, minimum: 0, units: "factor of the original icon size", requires: ["icon-image"], expression: { interpolated: true, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "icon-text-fit": { type: "enum", values: { none: {}, width: {}, height: {}, both: {} }, default: "none", requires: ["icon-image", "text-field"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "icon-text-fit-padding": { type: "array", value: "number", length: 4, default: [0, 0, 0, 0], units: "pixels", requires: ["icon-image", "text-field", { "icon-text-fit": ["both", "width", "height"] }], expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "icon-image": { type: "resolvedImage", tokens: true, expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "icon-rotate": { type: "number", default: 0, period: 360, units: "degrees", requires: ["icon-image"], expression: { interpolated: true, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "icon-padding": { type: "number", default: 2, minimum: 0, units: "pixels", requires: ["icon-image"], expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "icon-keep-upright": { type: "boolean", default: false, requires: ["icon-image", { "icon-rotation-alignment": "map" }, { "symbol-placement": ["line", "line-center"] }], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "icon-offset": { type: "array", value: "number", length: 2, default: [0, 0], requires: ["icon-image"], expression: { interpolated: true, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "icon-anchor": { type: "enum", values: { center: {}, left: {}, right: {}, top: {}, bottom: {}, "top-left": {}, "top-right": {}, "bottom-left": {}, "bottom-right": {} }, default: "center", requires: ["icon-image"], expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "icon-pitch-alignment": { type: "enum", values: { map: {}, viewport: {}, auto: {} }, default: "auto", requires: ["icon-image"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-pitch-alignment": { type: "enum", values: { map: {}, viewport: {}, auto: {} }, default: "auto", requires: ["text-field"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-rotation-alignment": { type: "enum", values: { map: {}, viewport: {}, auto: {} }, default: "auto", requires: ["text-field"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-field": { type: "formatted", default: "", tokens: true, expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "text-font": { type: "array", value: "string", default: ["Open Sans Regular", "Arial Unicode MS Regular"], requires: ["text-field"], expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "text-size": { type: "number", default: 16, minimum: 0, units: "pixels", requires: ["text-field"], expression: { interpolated: true, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "text-max-width": { type: "number", default: 10, minimum: 0, units: "ems", requires: ["text-field"], expression: { interpolated: true, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "text-line-height": { type: "number", default: 1.2, units: "ems", requires: ["text-field"], expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-letter-spacing": { type: "number", default: 0, units: "ems", requires: ["text-field"], expression: { interpolated: true, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "text-justify": { type: "enum", values: { auto: {}, left: {}, center: {}, right: {} }, default: "center", requires: ["text-field"], expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "text-radial-offset": { type: "number", units: "ems", default: 0, requires: ["text-field"], "property-type": "data-driven", expression: { interpolated: true, parameters: ["zoom", "feature"] } }, "text-variable-anchor": { type: "array", value: "enum", values: { center: {}, left: {}, right: {}, top: {}, bottom: {}, "top-left": {}, "top-right": {}, "bottom-left": {}, "bottom-right": {} }, requires: ["text-field", { "symbol-placement": ["point"] }], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-anchor": { type: "enum", values: { center: {}, left: {}, right: {}, top: {}, bottom: {}, "top-left": {}, "top-right": {}, "bottom-left": {}, "bottom-right": {} }, default: "center", requires: ["text-field", { "!": "text-variable-anchor" }], expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "text-max-angle": { type: "number", default: 45, units: "degrees", requires: ["text-field", { "symbol-placement": ["line", "line-center"] }], expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-writing-mode": { type: "array", value: "enum", values: { horizontal: {}, vertical: {} }, requires: ["text-field", { "symbol-placement": ["point"] }], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-rotate": { type: "number", default: 0, period: 360, units: "degrees", requires: ["text-field"], expression: { interpolated: true, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "text-padding": { type: "number", default: 2, minimum: 0, units: "pixels", requires: ["text-field"], expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-keep-upright": { type: "boolean", default: true, requires: ["text-field", { "text-rotation-alignment": "map" }, { "symbol-placement": ["line", "line-center"] }], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-transform": { type: "enum", values: { none: {}, uppercase: {}, lowercase: {} }, default: "none", requires: ["text-field"], expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "text-offset": { type: "array", value: "number", units: "ems", length: 2, default: [0, 0], requires: ["text-field", { "!": "text-radial-offset" }], expression: { interpolated: true, parameters: ["zoom", "feature"] }, "property-type": "data-driven" }, "text-allow-overlap": { type: "boolean", default: false, requires: ["text-field"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-ignore-placement": { type: "boolean", default: false, requires: ["text-field"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-optional": { type: "boolean", default: false, requires: ["text-field", "icon-image"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, visibility: { type: "enum", values: { visible: {}, none: {} }, default: "visible", "property-type": "constant" } }, layout_raster: { visibility: { type: "enum", values: { visible: {}, none: {} }, default: "visible", "property-type": "constant" } }, layout_hillshade: { visibility: { type: "enum", values: { visible: {}, none: {} }, default: "visible", "property-type": "constant" } }, filter: { type: "array", value: "*" }, filter_operator: { type: "enum", values: { "==": {}, "!=": {}, ">": {}, ">=": {}, "<": {}, "<=": {}, in: {}, "!in": {}, all: {}, any: {}, none: {}, has: {}, "!has": {}, within: {} } }, geometry_type: { type: "enum", values: { Point: {}, LineString: {}, Polygon: {} } }, function: { expression: { type: "expression" }, stops: { type: "array", value: "function_stop" }, base: { type: "number", default: 1, minimum: 0 }, property: { type: "string", default: "$zoom" }, type: { type: "enum", values: { identity: {}, exponential: {}, interval: {}, categorical: {} }, default: "exponential" }, colorSpace: { type: "enum", values: { rgb: {}, lab: {}, hcl: {} }, default: "rgb" }, default: { type: "*", required: false } }, function_stop: { type: "array", minimum: 0, maximum: 24, value: ["number", "color"], length: 2 }, expression: { type: "array", value: "*", minimum: 1 }, expression_name: { type: "enum", values: { let: { group: "Variable binding" }, var: { group: "Variable binding" }, literal: { group: "Types" }, array: { group: "Types" }, at: { group: "Lookup" }, in: { group: "Lookup" }, "index-of": { group: "Lookup" }, slice: { group: "Lookup" }, case: { group: "Decision" }, match: { group: "Decision" }, coalesce: { group: "Decision" }, step: { group: "Ramps, scales, curves" }, interpolate: { group: "Ramps, scales, curves" }, "interpolate-hcl": { group: "Ramps, scales, curves" }, "interpolate-lab": { group: "Ramps, scales, curves" }, ln2: { group: "Math" }, pi: { group: "Math" }, e: { group: "Math" }, typeof: { group: "Types" }, string: { group: "Types" }, number: { group: "Types" }, boolean: { group: "Types" }, object: { group: "Types" }, collator: { group: "Types" }, format: { group: "Types" }, image: { group: "Types" }, "number-format": { group: "Types" }, "to-string": { group: "Types" }, "to-number": { group: "Types" }, "to-boolean": { group: "Types" }, "to-rgba": { group: "Color" }, "to-color": { group: "Types" }, rgb: { group: "Color" }, rgba: { group: "Color" }, get: { group: "Lookup" }, has: { group: "Lookup" }, length: { group: "Lookup" }, properties: { group: "Feature data" }, "feature-state": { group: "Feature data" }, "geometry-type": { group: "Feature data" }, id: { group: "Feature data" }, zoom: { group: "Zoom" }, "heatmap-density": { group: "Heatmap" }, "line-progress": { group: "Feature data" }, accumulated: { group: "Feature data" }, "+": { group: "Math" }, "*": { group: "Math" }, "-": { group: "Math" }, "/": { group: "Math" }, "%": { group: "Math" }, "^": { group: "Math" }, sqrt: { group: "Math" }, log10: { group: "Math" }, ln: { group: "Math" }, log2: { group: "Math" }, sin: { group: "Math" }, cos: { group: "Math" }, tan: { group: "Math" }, asin: { group: "Math" }, acos: { group: "Math" }, atan: { group: "Math" }, min: { group: "Math" }, max: { group: "Math" }, round: { group: "Math" }, abs: { group: "Math" }, ceil: { group: "Math" }, floor: { group: "Math" }, distance: { group: "Math" }, "==": { group: "Decision" }, "!=": { group: "Decision" }, ">": { group: "Decision" }, "<": { group: "Decision" }, ">=": { group: "Decision" }, "<=": { group: "Decision" }, all: { group: "Decision" }, any: { group: "Decision" }, "!": { group: "Decision" }, within: { group: "Decision" }, "is-supported-script": { group: "String" }, upcase: { group: "String" }, downcase: { group: "String" }, concat: { group: "String" }, "resolved-locale": { group: "String" } } }, light: { anchor: { type: "enum", default: "viewport", values: { map: {}, viewport: {} }, "property-type": "data-constant", transition: false, expression: { interpolated: false, parameters: ["zoom"] } }, position: { type: "array", default: [1.15, 210, 30], length: 3, value: "number", "property-type": "data-constant", transition: true, expression: { interpolated: true, parameters: ["zoom"] } }, color: { type: "color", "property-type": "data-constant", default: "#ffffff", expression: { interpolated: true, parameters: ["zoom"] }, transition: true }, intensity: { type: "number", "property-type": "data-constant", default: 0.5, minimum: 0, maximum: 1, expression: { interpolated: true, parameters: ["zoom"] }, transition: true } }, paint: ["paint_fill", "paint_line", "paint_circle", "paint_heatmap", "paint_fill-extrusion", "paint_symbol", "paint_raster", "paint_hillshade", "paint_background"], paint_fill: { "fill-antialias": { type: "boolean", default: true, expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "fill-opacity": { type: "number", default: 1, minimum: 0, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "fill-color": { type: "color", default: "#000000", transition: true, requires: [{ "!": "fill-pattern" }], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "fill-outline-color": { type: "color", transition: true, requires: [{ "!": "fill-pattern" }, { "fill-antialias": true }], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "fill-translate": { type: "array", value: "number", length: 2, default: [0, 0], transition: true, units: "pixels", expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "fill-translate-anchor": { type: "enum", values: { map: {}, viewport: {} }, default: "map", requires: ["fill-translate"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "fill-pattern": { type: "resolvedImage", transition: true, expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "cross-faded-data-driven" } }, "paint_fill-extrusion": { "fill-extrusion-opacity": { type: "number", default: 1, minimum: 0, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "fill-extrusion-color": { type: "color", default: "#000000", transition: true, requires: [{ "!": "fill-extrusion-pattern" }], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "fill-extrusion-translate": { type: "array", value: "number", length: 2, default: [0, 0], transition: true, units: "pixels", expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "fill-extrusion-translate-anchor": { type: "enum", values: { map: {}, viewport: {} }, default: "map", requires: ["fill-extrusion-translate"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "fill-extrusion-pattern": { type: "resolvedImage", transition: true, expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "cross-faded-data-driven" }, "fill-extrusion-height": { type: "number", default: 0, minimum: 0, units: "meters", transition: true, expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "fill-extrusion-base": { type: "number", default: 0, minimum: 0, units: "meters", transition: true, requires: ["fill-extrusion-height"], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "fill-extrusion-vertical-gradient": { type: "boolean", default: true, transition: false, expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" } }, paint_line: { "line-opacity": { type: "number", default: 1, minimum: 0, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "line-color": { type: "color", default: "#000000", transition: true, requires: [{ "!": "line-pattern" }], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "line-translate": { type: "array", value: "number", length: 2, default: [0, 0], transition: true, units: "pixels", expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "line-translate-anchor": { type: "enum", values: { map: {}, viewport: {} }, default: "map", requires: ["line-translate"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "line-width": { type: "number", default: 1, minimum: 0, transition: true, units: "pixels", expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "line-gap-width": { type: "number", default: 0, minimum: 0, transition: true, units: "pixels", expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "line-offset": { type: "number", default: 0, transition: true, units: "pixels", expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "line-blur": { type: "number", default: 0, minimum: 0, transition: true, units: "pixels", expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "line-dasharray": { type: "array", value: "number", minimum: 0, transition: true, units: "line widths", requires: [{ "!": "line-pattern" }], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "cross-faded" }, "line-pattern": { type: "resolvedImage", transition: true, expression: { interpolated: false, parameters: ["zoom", "feature"] }, "property-type": "cross-faded-data-driven" }, "line-gradient": { type: "color", transition: false, requires: [{ "!": "line-dasharray" }, { "!": "line-pattern" }, { source: "geojson", has: { lineMetrics: true } }], expression: { interpolated: true, parameters: ["line-progress"] }, "property-type": "color-ramp" } }, paint_circle: { "circle-radius": { type: "number", default: 5, minimum: 0, transition: true, units: "pixels", expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "circle-color": { type: "color", default: "#000000", transition: true, expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "circle-blur": { type: "number", default: 0, transition: true, expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "circle-opacity": { type: "number", default: 1, minimum: 0, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "circle-translate": { type: "array", value: "number", length: 2, default: [0, 0], transition: true, units: "pixels", expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "circle-translate-anchor": { type: "enum", values: { map: {}, viewport: {} }, default: "map", requires: ["circle-translate"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "circle-pitch-scale": { type: "enum", values: { map: {}, viewport: {} }, default: "map", expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "circle-pitch-alignment": { type: "enum", values: { map: {}, viewport: {} }, default: "viewport", expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "circle-stroke-width": { type: "number", default: 0, minimum: 0, transition: true, units: "pixels", expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "circle-stroke-color": { type: "color", default: "#000000", transition: true, expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "circle-stroke-opacity": { type: "number", default: 1, minimum: 0, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" } }, paint_heatmap: { "heatmap-radius": { type: "number", default: 30, minimum: 1, transition: true, units: "pixels", expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "heatmap-weight": { type: "number", default: 1, minimum: 0, transition: false, expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "heatmap-intensity": { type: "number", default: 1, minimum: 0, transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "heatmap-color": { type: "color", default: ["interpolate", ["linear"], ["heatmap-density"], 0, "rgba(0, 0, 255, 0)", 0.1, "royalblue", 0.3, "cyan", 0.5, "lime", 0.7, "yellow", 1, "red"], transition: false, expression: { interpolated: true, parameters: ["heatmap-density"] }, "property-type": "color-ramp" }, "heatmap-opacity": { type: "number", default: 1, minimum: 0, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" } }, paint_symbol: { "icon-opacity": { type: "number", default: 1, minimum: 0, maximum: 1, transition: true, requires: ["icon-image"], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "icon-color": { type: "color", default: "#000000", transition: true, requires: ["icon-image"], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "icon-halo-color": { type: "color", default: "rgba(0, 0, 0, 0)", transition: true, requires: ["icon-image"], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "icon-halo-width": { type: "number", default: 0, minimum: 0, transition: true, units: "pixels", requires: ["icon-image"], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "icon-halo-blur": { type: "number", default: 0, minimum: 0, transition: true, units: "pixels", requires: ["icon-image"], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "icon-translate": { type: "array", value: "number", length: 2, default: [0, 0], transition: true, units: "pixels", requires: ["icon-image"], expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "icon-translate-anchor": { type: "enum", values: { map: {}, viewport: {} }, default: "map", requires: ["icon-image", "icon-translate"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-opacity": { type: "number", default: 1, minimum: 0, maximum: 1, transition: true, requires: ["text-field"], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "text-color": { type: "color", default: "#000000", transition: true, overridable: true, requires: ["text-field"], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "text-halo-color": { type: "color", default: "rgba(0, 0, 0, 0)", transition: true, requires: ["text-field"], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "text-halo-width": { type: "number", default: 0, minimum: 0, transition: true, units: "pixels", requires: ["text-field"], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "text-halo-blur": { type: "number", default: 0, minimum: 0, transition: true, units: "pixels", requires: ["text-field"], expression: { interpolated: true, parameters: ["zoom", "feature", "feature-state"] }, "property-type": "data-driven" }, "text-translate": { type: "array", value: "number", length: 2, default: [0, 0], transition: true, units: "pixels", requires: ["text-field"], expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "text-translate-anchor": { type: "enum", values: { map: {}, viewport: {} }, default: "map", requires: ["text-field", "text-translate"], expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" } }, paint_raster: { "raster-opacity": { type: "number", default: 1, minimum: 0, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "raster-hue-rotate": { type: "number", default: 0, period: 360, transition: true, units: "degrees", expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "raster-brightness-min": { type: "number", default: 0, minimum: 0, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "raster-brightness-max": { type: "number", default: 1, minimum: 0, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "raster-saturation": { type: "number", default: 0, minimum: -1, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "raster-contrast": { type: "number", default: 0, minimum: -1, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "raster-resampling": { type: "enum", values: { linear: {}, nearest: {} }, default: "linear", expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "raster-fade-duration": { type: "number", default: 300, minimum: 0, transition: false, units: "milliseconds", expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" } }, paint_hillshade: { "hillshade-illumination-direction": { type: "number", default: 335, minimum: 0, maximum: 359, transition: false, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "hillshade-illumination-anchor": { type: "enum", values: { map: {}, viewport: {} }, default: "viewport", expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "data-constant" }, "hillshade-exaggeration": { type: "number", default: 0.5, minimum: 0, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "hillshade-shadow-color": { type: "color", default: "#000000", transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "hillshade-highlight-color": { type: "color", default: "#FFFFFF", transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "hillshade-accent-color": { type: "color", default: "#000000", transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" } }, paint_background: { "background-color": { type: "color", default: "#000000", transition: true, requires: [{ "!": "background-pattern" }], expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" }, "background-pattern": { type: "resolvedImage", transition: true, expression: { interpolated: false, parameters: ["zoom"] }, "property-type": "cross-faded" }, "background-opacity": { type: "number", default: 1, minimum: 0, maximum: 1, transition: true, expression: { interpolated: true, parameters: ["zoom"] }, "property-type": "data-constant" } }, transition: { duration: { type: "number", default: 300, minimum: 0, units: "milliseconds" }, delay: { type: "number", default: 0, minimum: 0, units: "milliseconds" } }, "property-type": { "data-driven": { type: "property-type" }, "cross-faded": { type: "property-type" }, "cross-faded-data-driven": { type: "property-type" }, "color-ramp": { type: "property-type" }, "data-constant": { type: "property-type" }, constant: { type: "property-type" } }, promoteId: { "*": { type: "string" } } }, Dt = function(t5, e4, r4, n4) {
              this.message = (t5 ? t5 + ": " : "") + r4, n4 && (this.identifier = n4), null != e4 && e4.__line__ && (this.line = e4.__line__);
            };
            function zt(t5) {
              var e4 = t5.key, r4 = t5.value;
              return r4 ? [new Dt(e4, r4, "constants have been deprecated as of v8")] : [];
            }
            function Rt(t5) {
              for (var e4 = [], r4 = arguments.length - 1; r4-- > 0; )
                e4[r4] = arguments[r4 + 1];
              for (var n4 = 0, i2 = e4; n4 < i2.length; n4 += 1) {
                var a2 = i2[n4];
                for (var o2 in a2)
                  t5[o2] = a2[o2];
              }
              return t5;
            }
            function Ft(t5) {
              return t5 instanceof Number || t5 instanceof String || t5 instanceof Boolean ? t5.valueOf() : t5;
            }
            function Bt(t5) {
              if (Array.isArray(t5))
                return t5.map(Bt);
              if (t5 instanceof Object && !(t5 instanceof Number || t5 instanceof String || t5 instanceof Boolean)) {
                var e4 = {};
                for (var r4 in t5)
                  e4[r4] = Bt(t5[r4]);
                return e4;
              }
              return Ft(t5);
            }
            var Nt = function(t5) {
              function e4(e5, r4) {
                t5.call(this, r4), this.message = r4, this.key = e5;
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4;
            }(Error), jt = function(t5, e4) {
              void 0 === e4 && (e4 = []), this.parent = t5, this.bindings = {};
              for (var r4 = 0, n4 = e4; r4 < n4.length; r4 += 1) {
                var i2 = n4[r4], a2 = i2[0], o2 = i2[1];
                this.bindings[a2] = o2;
              }
            };
            jt.prototype.concat = function(t5) {
              return new jt(this, t5);
            }, jt.prototype.get = function(t5) {
              if (this.bindings[t5])
                return this.bindings[t5];
              if (this.parent)
                return this.parent.get(t5);
              throw new Error(t5 + " not found in scope.");
            }, jt.prototype.has = function(t5) {
              return !!this.bindings[t5] || !!this.parent && this.parent.has(t5);
            };
            var Ut = { kind: "null" }, Vt = { kind: "number" }, Ht = { kind: "string" }, qt = { kind: "boolean" }, Gt = { kind: "color" }, Zt = { kind: "object" }, Yt = { kind: "value" }, Wt = { kind: "collator" }, Xt = { kind: "formatted" }, Jt = { kind: "resolvedImage" };
            function Kt(t5, e4) {
              return { kind: "array", itemType: t5, N: e4 };
            }
            function $t(t5) {
              if ("array" === t5.kind) {
                var e4 = $t(t5.itemType);
                return "number" == typeof t5.N ? "array<" + e4 + ", " + t5.N + ">" : "value" === t5.itemType.kind ? "array" : "array<" + e4 + ">";
              }
              return t5.kind;
            }
            var Qt = [Ut, Vt, Ht, qt, Gt, Xt, Zt, Kt(Yt), Jt];
            function te(t5, e4) {
              if ("error" === e4.kind)
                return null;
              if ("array" === t5.kind) {
                if ("array" === e4.kind && (0 === e4.N && "value" === e4.itemType.kind || !te(t5.itemType, e4.itemType)) && ("number" != typeof t5.N || t5.N === e4.N))
                  return null;
              } else {
                if (t5.kind === e4.kind)
                  return null;
                if ("value" === t5.kind) {
                  for (var r4 = 0, n4 = Qt; r4 < n4.length; r4 += 1)
                    if (!te(n4[r4], e4))
                      return null;
                }
              }
              return "Expected " + $t(t5) + " but found " + $t(e4) + " instead.";
            }
            function ee(t5, e4) {
              return e4.some(function(e5) {
                return e5.kind === t5.kind;
              });
            }
            function re(t5, e4) {
              return e4.some(function(e5) {
                return "null" === e5 ? null === t5 : "array" === e5 ? Array.isArray(t5) : "object" === e5 ? t5 && !Array.isArray(t5) && "object" == typeof t5 : e5 === typeof t5;
              });
            }
            var ne = e3(function(t5, e4) {
              var r4 = { transparent: [0, 0, 0, 0], aliceblue: [240, 248, 255, 1], antiquewhite: [250, 235, 215, 1], aqua: [0, 255, 255, 1], aquamarine: [127, 255, 212, 1], azure: [240, 255, 255, 1], beige: [245, 245, 220, 1], bisque: [255, 228, 196, 1], black: [0, 0, 0, 1], blanchedalmond: [255, 235, 205, 1], blue: [0, 0, 255, 1], blueviolet: [138, 43, 226, 1], brown: [165, 42, 42, 1], burlywood: [222, 184, 135, 1], cadetblue: [95, 158, 160, 1], chartreuse: [127, 255, 0, 1], chocolate: [210, 105, 30, 1], coral: [255, 127, 80, 1], cornflowerblue: [100, 149, 237, 1], cornsilk: [255, 248, 220, 1], crimson: [220, 20, 60, 1], cyan: [0, 255, 255, 1], darkblue: [0, 0, 139, 1], darkcyan: [0, 139, 139, 1], darkgoldenrod: [184, 134, 11, 1], darkgray: [169, 169, 169, 1], darkgreen: [0, 100, 0, 1], darkgrey: [169, 169, 169, 1], darkkhaki: [189, 183, 107, 1], darkmagenta: [139, 0, 139, 1], darkolivegreen: [85, 107, 47, 1], darkorange: [255, 140, 0, 1], darkorchid: [153, 50, 204, 1], darkred: [139, 0, 0, 1], darksalmon: [233, 150, 122, 1], darkseagreen: [143, 188, 143, 1], darkslateblue: [72, 61, 139, 1], darkslategray: [47, 79, 79, 1], darkslategrey: [47, 79, 79, 1], darkturquoise: [0, 206, 209, 1], darkviolet: [148, 0, 211, 1], deeppink: [255, 20, 147, 1], deepskyblue: [0, 191, 255, 1], dimgray: [105, 105, 105, 1], dimgrey: [105, 105, 105, 1], dodgerblue: [30, 144, 255, 1], firebrick: [178, 34, 34, 1], floralwhite: [255, 250, 240, 1], forestgreen: [34, 139, 34, 1], fuchsia: [255, 0, 255, 1], gainsboro: [220, 220, 220, 1], ghostwhite: [248, 248, 255, 1], gold: [255, 215, 0, 1], goldenrod: [218, 165, 32, 1], gray: [128, 128, 128, 1], green: [0, 128, 0, 1], greenyellow: [173, 255, 47, 1], grey: [128, 128, 128, 1], honeydew: [240, 255, 240, 1], hotpink: [255, 105, 180, 1], indianred: [205, 92, 92, 1], indigo: [75, 0, 130, 1], ivory: [255, 255, 240, 1], khaki: [240, 230, 140, 1], lavender: [230, 230, 250, 1], lavenderblush: [255, 240, 245, 1], lawngreen: [124, 252, 0, 1], lemonchiffon: [255, 250, 205, 1], lightblue: [173, 216, 230, 1], lightcoral: [240, 128, 128, 1], lightcyan: [224, 255, 255, 1], lightgoldenrodyellow: [250, 250, 210, 1], lightgray: [211, 211, 211, 1], lightgreen: [144, 238, 144, 1], lightgrey: [211, 211, 211, 1], lightpink: [255, 182, 193, 1], lightsalmon: [255, 160, 122, 1], lightseagreen: [32, 178, 170, 1], lightskyblue: [135, 206, 250, 1], lightslategray: [119, 136, 153, 1], lightslategrey: [119, 136, 153, 1], lightsteelblue: [176, 196, 222, 1], lightyellow: [255, 255, 224, 1], lime: [0, 255, 0, 1], limegreen: [50, 205, 50, 1], linen: [250, 240, 230, 1], magenta: [255, 0, 255, 1], maroon: [128, 0, 0, 1], mediumaquamarine: [102, 205, 170, 1], mediumblue: [0, 0, 205, 1], mediumorchid: [186, 85, 211, 1], mediumpurple: [147, 112, 219, 1], mediumseagreen: [60, 179, 113, 1], mediumslateblue: [123, 104, 238, 1], mediumspringgreen: [0, 250, 154, 1], mediumturquoise: [72, 209, 204, 1], mediumvioletred: [199, 21, 133, 1], midnightblue: [25, 25, 112, 1], mintcream: [245, 255, 250, 1], mistyrose: [255, 228, 225, 1], moccasin: [255, 228, 181, 1], navajowhite: [255, 222, 173, 1], navy: [0, 0, 128, 1], oldlace: [253, 245, 230, 1], olive: [128, 128, 0, 1], olivedrab: [107, 142, 35, 1], orange: [255, 165, 0, 1], orangered: [255, 69, 0, 1], orchid: [218, 112, 214, 1], palegoldenrod: [238, 232, 170, 1], palegreen: [152, 251, 152, 1], paleturquoise: [175, 238, 238, 1], palevioletred: [219, 112, 147, 1], papayawhip: [255, 239, 213, 1], peachpuff: [255, 218, 185, 1], peru: [205, 133, 63, 1], pink: [255, 192, 203, 1], plum: [221, 160, 221, 1], powderblue: [176, 224, 230, 1], purple: [128, 0, 128, 1], rebeccapurple: [102, 51, 153, 1], red: [255, 0, 0, 1], rosybrown: [188, 143, 143, 1], royalblue: [65, 105, 225, 1], saddlebrown: [139, 69, 19, 1], salmon: [250, 128, 114, 1], sandybrown: [244, 164, 96, 1], seagreen: [46, 139, 87, 1], seashell: [255, 245, 238, 1], sienna: [160, 82, 45, 1], silver: [192, 192, 192, 1], skyblue: [135, 206, 235, 1], slateblue: [106, 90, 205, 1], slategray: [112, 128, 144, 1], slategrey: [112, 128, 144, 1], snow: [255, 250, 250, 1], springgreen: [0, 255, 127, 1], steelblue: [70, 130, 180, 1], tan: [210, 180, 140, 1], teal: [0, 128, 128, 1], thistle: [216, 191, 216, 1], tomato: [255, 99, 71, 1], turquoise: [64, 224, 208, 1], violet: [238, 130, 238, 1], wheat: [245, 222, 179, 1], white: [255, 255, 255, 1], whitesmoke: [245, 245, 245, 1], yellow: [255, 255, 0, 1], yellowgreen: [154, 205, 50, 1] };
              function n4(t6) {
                return (t6 = Math.round(t6)) < 0 ? 0 : t6 > 255 ? 255 : t6;
              }
              function i2(t6) {
                return t6 < 0 ? 0 : t6 > 1 ? 1 : t6;
              }
              function a2(t6) {
                return "%" === t6[t6.length - 1] ? n4(parseFloat(t6) / 100 * 255) : n4(parseInt(t6));
              }
              function o2(t6) {
                return "%" === t6[t6.length - 1] ? i2(parseFloat(t6) / 100) : i2(parseFloat(t6));
              }
              function s2(t6, e5, r5) {
                return r5 < 0 ? r5 += 1 : r5 > 1 && (r5 -= 1), 6 * r5 < 1 ? t6 + (e5 - t6) * r5 * 6 : 2 * r5 < 1 ? e5 : 3 * r5 < 2 ? t6 + (e5 - t6) * (2 / 3 - r5) * 6 : t6;
              }
              try {
                e4.parseCSSColor = function(t6) {
                  var e5, i3 = t6.replace(/ /g, "").toLowerCase();
                  if (i3 in r4)
                    return r4[i3].slice();
                  if ("#" === i3[0])
                    return 4 === i3.length ? (e5 = parseInt(i3.substr(1), 16)) >= 0 && e5 <= 4095 ? [(3840 & e5) >> 4 | (3840 & e5) >> 8, 240 & e5 | (240 & e5) >> 4, 15 & e5 | (15 & e5) << 4, 1] : null : 7 === i3.length && (e5 = parseInt(i3.substr(1), 16)) >= 0 && e5 <= 16777215 ? [(16711680 & e5) >> 16, (65280 & e5) >> 8, 255 & e5, 1] : null;
                  var l2 = i3.indexOf("("), u2 = i3.indexOf(")");
                  if (-1 !== l2 && u2 + 1 === i3.length) {
                    var c2 = i3.substr(0, l2), f3 = i3.substr(l2 + 1, u2 - (l2 + 1)).split(","), h2 = 1;
                    switch (c2) {
                      case "rgba":
                        if (4 !== f3.length)
                          return null;
                        h2 = o2(f3.pop());
                      case "rgb":
                        return 3 !== f3.length ? null : [a2(f3[0]), a2(f3[1]), a2(f3[2]), h2];
                      case "hsla":
                        if (4 !== f3.length)
                          return null;
                        h2 = o2(f3.pop());
                      case "hsl":
                        if (3 !== f3.length)
                          return null;
                        var p3 = (parseFloat(f3[0]) % 360 + 360) % 360 / 360, d3 = o2(f3[1]), v2 = o2(f3[2]), g3 = v2 <= 0.5 ? v2 * (d3 + 1) : v2 + d3 - v2 * d3, y2 = 2 * v2 - g3;
                        return [n4(255 * s2(y2, g3, p3 + 1 / 3)), n4(255 * s2(y2, g3, p3)), n4(255 * s2(y2, g3, p3 - 1 / 3)), h2];
                      default:
                        return null;
                    }
                  }
                  return null;
                };
              } catch (t6) {
              }
            }), ie = ne.parseCSSColor, ae = function(t5, e4, r4, n4) {
              void 0 === n4 && (n4 = 1), this.r = t5, this.g = e4, this.b = r4, this.a = n4;
            };
            ae.parse = function(t5) {
              if (t5) {
                if (t5 instanceof ae)
                  return t5;
                if ("string" == typeof t5) {
                  var e4 = ie(t5);
                  if (e4)
                    return new ae(e4[0] / 255 * e4[3], e4[1] / 255 * e4[3], e4[2] / 255 * e4[3], e4[3]);
                }
              }
            }, ae.prototype.toString = function() {
              var t5 = this.toArray(), e4 = t5[0], r4 = t5[1], n4 = t5[2], i2 = t5[3];
              return "rgba(" + Math.round(e4) + "," + Math.round(r4) + "," + Math.round(n4) + "," + i2 + ")";
            }, ae.prototype.toArray = function() {
              var t5 = this, e4 = t5.r, r4 = t5.g, n4 = t5.b, i2 = t5.a;
              return 0 === i2 ? [0, 0, 0, 0] : [255 * e4 / i2, 255 * r4 / i2, 255 * n4 / i2, i2];
            }, ae.black = new ae(0, 0, 0, 1), ae.white = new ae(1, 1, 1, 1), ae.transparent = new ae(0, 0, 0, 0), ae.red = new ae(1, 0, 0, 1);
            var oe = function(t5, e4, r4) {
              this.sensitivity = t5 ? e4 ? "variant" : "case" : e4 ? "accent" : "base", this.locale = r4, this.collator = new Intl.Collator(this.locale ? this.locale : [], { sensitivity: this.sensitivity, usage: "search" });
            };
            oe.prototype.compare = function(t5, e4) {
              return this.collator.compare(t5, e4);
            }, oe.prototype.resolvedLocale = function() {
              return new Intl.Collator(this.locale ? this.locale : []).resolvedOptions().locale;
            };
            var se = function(t5, e4, r4, n4, i2) {
              this.text = t5, this.image = e4, this.scale = r4, this.fontStack = n4, this.textColor = i2;
            }, le = function(t5) {
              this.sections = t5;
            };
            le.fromString = function(t5) {
              return new le([new se(t5, null, null, null, null)]);
            }, le.prototype.isEmpty = function() {
              return 0 === this.sections.length || !this.sections.some(function(t5) {
                return 0 !== t5.text.length || t5.image && 0 !== t5.image.name.length;
              });
            }, le.factory = function(t5) {
              return t5 instanceof le ? t5 : le.fromString(t5);
            }, le.prototype.toString = function() {
              return 0 === this.sections.length ? "" : this.sections.map(function(t5) {
                return t5.text;
              }).join("");
            }, le.prototype.serialize = function() {
              for (var t5 = ["format"], e4 = 0, r4 = this.sections; e4 < r4.length; e4 += 1) {
                var n4 = r4[e4];
                if (n4.image)
                  t5.push(["image", n4.image.name]);
                else {
                  t5.push(n4.text);
                  var i2 = {};
                  n4.fontStack && (i2["text-font"] = ["literal", n4.fontStack.split(",")]), n4.scale && (i2["font-scale"] = n4.scale), n4.textColor && (i2["text-color"] = ["rgba"].concat(n4.textColor.toArray())), t5.push(i2);
                }
              }
              return t5;
            };
            var ue = function(t5) {
              this.name = t5.name, this.available = t5.available;
            };
            function ce(t5, e4, r4, n4) {
              return "number" == typeof t5 && t5 >= 0 && t5 <= 255 && "number" == typeof e4 && e4 >= 0 && e4 <= 255 && "number" == typeof r4 && r4 >= 0 && r4 <= 255 ? void 0 === n4 || "number" == typeof n4 && n4 >= 0 && n4 <= 1 ? null : "Invalid rgba value [" + [t5, e4, r4, n4].join(", ") + "]: 'a' must be between 0 and 1." : "Invalid rgba value [" + ("number" == typeof n4 ? [t5, e4, r4, n4] : [t5, e4, r4]).join(", ") + "]: 'r', 'g', and 'b' must be between 0 and 255.";
            }
            function fe(t5) {
              if (null === t5)
                return true;
              if ("string" == typeof t5)
                return true;
              if ("boolean" == typeof t5)
                return true;
              if ("number" == typeof t5)
                return true;
              if (t5 instanceof ae)
                return true;
              if (t5 instanceof oe)
                return true;
              if (t5 instanceof le)
                return true;
              if (t5 instanceof ue)
                return true;
              if (Array.isArray(t5)) {
                for (var e4 = 0, r4 = t5; e4 < r4.length; e4 += 1)
                  if (!fe(r4[e4]))
                    return false;
                return true;
              }
              if ("object" == typeof t5) {
                for (var n4 in t5)
                  if (!fe(t5[n4]))
                    return false;
                return true;
              }
              return false;
            }
            function he(t5) {
              if (null === t5)
                return Ut;
              if ("string" == typeof t5)
                return Ht;
              if ("boolean" == typeof t5)
                return qt;
              if ("number" == typeof t5)
                return Vt;
              if (t5 instanceof ae)
                return Gt;
              if (t5 instanceof oe)
                return Wt;
              if (t5 instanceof le)
                return Xt;
              if (t5 instanceof ue)
                return Jt;
              if (Array.isArray(t5)) {
                for (var e4, r4 = t5.length, n4 = 0, i2 = t5; n4 < i2.length; n4 += 1) {
                  var a2 = he(i2[n4]);
                  if (e4) {
                    if (e4 === a2)
                      continue;
                    e4 = Yt;
                    break;
                  }
                  e4 = a2;
                }
                return Kt(e4 || Yt, r4);
              }
              return Zt;
            }
            function pe(t5) {
              var e4 = typeof t5;
              return null === t5 ? "" : "string" === e4 || "number" === e4 || "boolean" === e4 ? String(t5) : t5 instanceof ae || t5 instanceof le || t5 instanceof ue ? t5.toString() : JSON.stringify(t5);
            }
            ue.prototype.toString = function() {
              return this.name;
            }, ue.fromString = function(t5) {
              return t5 ? new ue({ name: t5, available: false }) : null;
            }, ue.prototype.serialize = function() {
              return ["image", this.name];
            };
            var de = function(t5, e4) {
              this.type = t5, this.value = e4;
            };
            de.parse = function(t5, e4) {
              if (2 !== t5.length)
                return e4.error("'literal' expression requires exactly one argument, but found " + (t5.length - 1) + " instead.");
              if (!fe(t5[1]))
                return e4.error("invalid value");
              var r4 = t5[1], n4 = he(r4), i2 = e4.expectedType;
              return "array" !== n4.kind || 0 !== n4.N || !i2 || "array" !== i2.kind || "number" == typeof i2.N && 0 !== i2.N || (n4 = i2), new de(n4, r4);
            }, de.prototype.evaluate = function() {
              return this.value;
            }, de.prototype.eachChild = function() {
            }, de.prototype.outputDefined = function() {
              return true;
            }, de.prototype.serialize = function() {
              return "array" === this.type.kind || "object" === this.type.kind ? ["literal", this.value] : this.value instanceof ae ? ["rgba"].concat(this.value.toArray()) : this.value instanceof le ? this.value.serialize() : this.value;
            };
            var ve = function(t5) {
              this.name = "ExpressionEvaluationError", this.message = t5;
            };
            ve.prototype.toJSON = function() {
              return this.message;
            };
            var ge = { string: Ht, number: Vt, boolean: qt, object: Zt }, ye = function(t5, e4) {
              this.type = t5, this.args = e4;
            };
            ye.parse = function(t5, e4) {
              if (t5.length < 2)
                return e4.error("Expected at least one argument.");
              var r4, n4 = 1, i2 = t5[0];
              if ("array" === i2) {
                var a2, o2;
                if (t5.length > 2) {
                  var s2 = t5[1];
                  if ("string" != typeof s2 || !(s2 in ge) || "object" === s2)
                    return e4.error('The item type argument of "array" must be one of string, number, boolean', 1);
                  a2 = ge[s2], n4++;
                } else
                  a2 = Yt;
                if (t5.length > 3) {
                  if (null !== t5[2] && ("number" != typeof t5[2] || t5[2] < 0 || t5[2] !== Math.floor(t5[2])))
                    return e4.error('The length argument to "array" must be a positive integer literal', 2);
                  o2 = t5[2], n4++;
                }
                r4 = Kt(a2, o2);
              } else
                r4 = ge[i2];
              for (var l2 = []; n4 < t5.length; n4++) {
                var u2 = e4.parse(t5[n4], n4, Yt);
                if (!u2)
                  return null;
                l2.push(u2);
              }
              return new ye(r4, l2);
            }, ye.prototype.evaluate = function(t5) {
              for (var e4 = 0; e4 < this.args.length; e4++) {
                var r4 = this.args[e4].evaluate(t5);
                if (!te(this.type, he(r4)))
                  return r4;
                if (e4 === this.args.length - 1)
                  throw new ve("Expected value to be of type " + $t(this.type) + ", but found " + $t(he(r4)) + " instead.");
              }
              return null;
            }, ye.prototype.eachChild = function(t5) {
              this.args.forEach(t5);
            }, ye.prototype.outputDefined = function() {
              return this.args.every(function(t5) {
                return t5.outputDefined();
              });
            }, ye.prototype.serialize = function() {
              var t5 = this.type, e4 = [t5.kind];
              if ("array" === t5.kind) {
                var r4 = t5.itemType;
                if ("string" === r4.kind || "number" === r4.kind || "boolean" === r4.kind) {
                  e4.push(r4.kind);
                  var n4 = t5.N;
                  ("number" == typeof n4 || this.args.length > 1) && e4.push(n4);
                }
              }
              return e4.concat(this.args.map(function(t6) {
                return t6.serialize();
              }));
            };
            var me = function(t5) {
              this.type = Xt, this.sections = t5;
            };
            me.parse = function(t5, e4) {
              if (t5.length < 2)
                return e4.error("Expected at least one argument.");
              var r4 = t5[1];
              if (!Array.isArray(r4) && "object" == typeof r4)
                return e4.error("First argument must be an image or text section.");
              for (var n4 = [], i2 = false, a2 = 1; a2 <= t5.length - 1; ++a2) {
                var o2 = t5[a2];
                if (i2 && "object" == typeof o2 && !Array.isArray(o2)) {
                  i2 = false;
                  var s2 = null;
                  if (o2["font-scale"] && !(s2 = e4.parse(o2["font-scale"], 1, Vt)))
                    return null;
                  var l2 = null;
                  if (o2["text-font"] && !(l2 = e4.parse(o2["text-font"], 1, Kt(Ht))))
                    return null;
                  var u2 = null;
                  if (o2["text-color"] && !(u2 = e4.parse(o2["text-color"], 1, Gt)))
                    return null;
                  var c2 = n4[n4.length - 1];
                  c2.scale = s2, c2.font = l2, c2.textColor = u2;
                } else {
                  var f3 = e4.parse(t5[a2], 1, Yt);
                  if (!f3)
                    return null;
                  var h2 = f3.type.kind;
                  if ("string" !== h2 && "value" !== h2 && "null" !== h2 && "resolvedImage" !== h2)
                    return e4.error("Formatted text type must be 'string', 'value', 'image' or 'null'.");
                  i2 = true, n4.push({ content: f3, scale: null, font: null, textColor: null });
                }
              }
              return new me(n4);
            }, me.prototype.evaluate = function(t5) {
              return new le(this.sections.map(function(e4) {
                var r4 = e4.content.evaluate(t5);
                return he(r4) === Jt ? new se("", r4, null, null, null) : new se(pe(r4), null, e4.scale ? e4.scale.evaluate(t5) : null, e4.font ? e4.font.evaluate(t5).join(",") : null, e4.textColor ? e4.textColor.evaluate(t5) : null);
              }));
            }, me.prototype.eachChild = function(t5) {
              for (var e4 = 0, r4 = this.sections; e4 < r4.length; e4 += 1) {
                var n4 = r4[e4];
                t5(n4.content), n4.scale && t5(n4.scale), n4.font && t5(n4.font), n4.textColor && t5(n4.textColor);
              }
            }, me.prototype.outputDefined = function() {
              return false;
            }, me.prototype.serialize = function() {
              for (var t5 = ["format"], e4 = 0, r4 = this.sections; e4 < r4.length; e4 += 1) {
                var n4 = r4[e4];
                t5.push(n4.content.serialize());
                var i2 = {};
                n4.scale && (i2["font-scale"] = n4.scale.serialize()), n4.font && (i2["text-font"] = n4.font.serialize()), n4.textColor && (i2["text-color"] = n4.textColor.serialize()), t5.push(i2);
              }
              return t5;
            };
            var xe = function(t5) {
              this.type = Jt, this.input = t5;
            };
            xe.parse = function(t5, e4) {
              if (2 !== t5.length)
                return e4.error("Expected two arguments.");
              var r4 = e4.parse(t5[1], 1, Ht);
              return r4 ? new xe(r4) : e4.error("No image name provided.");
            }, xe.prototype.evaluate = function(t5) {
              var e4 = this.input.evaluate(t5), r4 = ue.fromString(e4);
              return r4 && t5.availableImages && (r4.available = t5.availableImages.indexOf(e4) > -1), r4;
            }, xe.prototype.eachChild = function(t5) {
              t5(this.input);
            }, xe.prototype.outputDefined = function() {
              return false;
            }, xe.prototype.serialize = function() {
              return ["image", this.input.serialize()];
            };
            var be = { "to-boolean": qt, "to-color": Gt, "to-number": Vt, "to-string": Ht }, _e = function(t5, e4) {
              this.type = t5, this.args = e4;
            };
            _e.parse = function(t5, e4) {
              if (t5.length < 2)
                return e4.error("Expected at least one argument.");
              var r4 = t5[0];
              if (("to-boolean" === r4 || "to-string" === r4) && 2 !== t5.length)
                return e4.error("Expected one argument.");
              for (var n4 = be[r4], i2 = [], a2 = 1; a2 < t5.length; a2++) {
                var o2 = e4.parse(t5[a2], a2, Yt);
                if (!o2)
                  return null;
                i2.push(o2);
              }
              return new _e(n4, i2);
            }, _e.prototype.evaluate = function(t5) {
              if ("boolean" === this.type.kind)
                return Boolean(this.args[0].evaluate(t5));
              if ("color" === this.type.kind) {
                for (var e4, r4, n4 = 0, i2 = this.args; n4 < i2.length; n4 += 1) {
                  if (r4 = null, (e4 = i2[n4].evaluate(t5)) instanceof ae)
                    return e4;
                  if ("string" == typeof e4) {
                    var a2 = t5.parseColor(e4);
                    if (a2)
                      return a2;
                  } else if (Array.isArray(e4) && !(r4 = e4.length < 3 || e4.length > 4 ? "Invalid rbga value " + JSON.stringify(e4) + ": expected an array containing either three or four numeric values." : ce(e4[0], e4[1], e4[2], e4[3])))
                    return new ae(e4[0] / 255, e4[1] / 255, e4[2] / 255, e4[3]);
                }
                throw new ve(r4 || "Could not parse color from value '" + ("string" == typeof e4 ? e4 : String(JSON.stringify(e4))) + "'");
              }
              if ("number" === this.type.kind) {
                for (var o2 = null, s2 = 0, l2 = this.args; s2 < l2.length; s2 += 1) {
                  if (null === (o2 = l2[s2].evaluate(t5)))
                    return 0;
                  var u2 = Number(o2);
                  if (!isNaN(u2))
                    return u2;
                }
                throw new ve("Could not convert " + JSON.stringify(o2) + " to number.");
              }
              return "formatted" === this.type.kind ? le.fromString(pe(this.args[0].evaluate(t5))) : "resolvedImage" === this.type.kind ? ue.fromString(pe(this.args[0].evaluate(t5))) : pe(this.args[0].evaluate(t5));
            }, _e.prototype.eachChild = function(t5) {
              this.args.forEach(t5);
            }, _e.prototype.outputDefined = function() {
              return this.args.every(function(t5) {
                return t5.outputDefined();
              });
            }, _e.prototype.serialize = function() {
              if ("formatted" === this.type.kind)
                return new me([{ content: this.args[0], scale: null, font: null, textColor: null }]).serialize();
              if ("resolvedImage" === this.type.kind)
                return new xe(this.args[0]).serialize();
              var t5 = ["to-" + this.type.kind];
              return this.eachChild(function(e4) {
                t5.push(e4.serialize());
              }), t5;
            };
            var we = ["Unknown", "Point", "LineString", "Polygon"], Te = function() {
              this.globals = null, this.feature = null, this.featureState = null, this.formattedSection = null, this._parseColorCache = {}, this.availableImages = null, this.canonical = null;
            };
            Te.prototype.id = function() {
              return this.feature && "id" in this.feature ? this.feature.id : null;
            }, Te.prototype.geometryType = function() {
              return this.feature ? "number" == typeof this.feature.type ? we[this.feature.type] : this.feature.type : null;
            }, Te.prototype.geometry = function() {
              return this.feature && "geometry" in this.feature ? this.feature.geometry : null;
            }, Te.prototype.canonicalID = function() {
              return this.canonical;
            }, Te.prototype.properties = function() {
              return this.feature && this.feature.properties || {};
            }, Te.prototype.parseColor = function(t5) {
              var e4 = this._parseColorCache[t5];
              return e4 || (e4 = this._parseColorCache[t5] = ae.parse(t5)), e4;
            };
            var ke = function(t5, e4, r4, n4) {
              this.name = t5, this.type = e4, this._evaluate = r4, this.args = n4;
            };
            ke.prototype.evaluate = function(t5) {
              return this._evaluate(t5, this.args);
            }, ke.prototype.eachChild = function(t5) {
              this.args.forEach(t5);
            }, ke.prototype.outputDefined = function() {
              return false;
            }, ke.prototype.serialize = function() {
              return [this.name].concat(this.args.map(function(t5) {
                return t5.serialize();
              }));
            }, ke.parse = function(t5, e4) {
              var r4, n4 = t5[0], i2 = ke.definitions[n4];
              if (!i2)
                return e4.error('Unknown expression "' + n4 + '". If you wanted a literal array, use ["literal", [...]].', 0);
              for (var a2 = Array.isArray(i2) ? i2[0] : i2.type, o2 = Array.isArray(i2) ? [[i2[1], i2[2]]] : i2.overloads, s2 = o2.filter(function(e5) {
                var r5 = e5[0];
                return !Array.isArray(r5) || r5.length === t5.length - 1;
              }), l2 = null, u2 = 0, c2 = s2; u2 < c2.length; u2 += 1) {
                var f3 = c2[u2], h2 = f3[0], p3 = f3[1];
                l2 = new Ye(e4.registry, e4.path, null, e4.scope);
                for (var d3 = [], v2 = false, g3 = 1; g3 < t5.length; g3++) {
                  var y2 = t5[g3], m3 = Array.isArray(h2) ? h2[g3 - 1] : h2.type, x2 = l2.parse(y2, 1 + d3.length, m3);
                  if (!x2) {
                    v2 = true;
                    break;
                  }
                  d3.push(x2);
                }
                if (!v2)
                  if (Array.isArray(h2) && h2.length !== d3.length)
                    l2.error("Expected " + h2.length + " arguments, but found " + d3.length + " instead.");
                  else {
                    for (var b2 = 0; b2 < d3.length; b2++) {
                      var _2 = Array.isArray(h2) ? h2[b2] : h2.type, w3 = d3[b2];
                      l2.concat(b2 + 1).checkSubtype(_2, w3.type);
                    }
                    if (0 === l2.errors.length)
                      return new ke(n4, a2, p3, d3);
                  }
              }
              if (1 === s2.length)
                (r4 = e4.errors).push.apply(r4, l2.errors);
              else {
                for (var T2 = (s2.length ? s2 : o2).map(function(t6) {
                  return e5 = t6[0], Array.isArray(e5) ? "(" + e5.map($t).join(", ") + ")" : "(" + $t(e5.type) + "...)";
                  var e5;
                }).join(" | "), k2 = [], A2 = 1; A2 < t5.length; A2++) {
                  var M2 = e4.parse(t5[A2], 1 + k2.length);
                  if (!M2)
                    return null;
                  k2.push($t(M2.type));
                }
                e4.error("Expected arguments of type " + T2 + ", but found (" + k2.join(", ") + ") instead.");
              }
              return null;
            }, ke.register = function(t5, e4) {
              for (var r4 in ke.definitions = e4, e4)
                t5[r4] = ke;
            };
            var Ae = function(t5, e4, r4) {
              this.type = Wt, this.locale = r4, this.caseSensitive = t5, this.diacriticSensitive = e4;
            };
            Ae.parse = function(t5, e4) {
              if (2 !== t5.length)
                return e4.error("Expected one argument.");
              var r4 = t5[1];
              if ("object" != typeof r4 || Array.isArray(r4))
                return e4.error("Collator options argument must be an object.");
              var n4 = e4.parse(void 0 !== r4["case-sensitive"] && r4["case-sensitive"], 1, qt);
              if (!n4)
                return null;
              var i2 = e4.parse(void 0 !== r4["diacritic-sensitive"] && r4["diacritic-sensitive"], 1, qt);
              if (!i2)
                return null;
              var a2 = null;
              return r4.locale && !(a2 = e4.parse(r4.locale, 1, Ht)) ? null : new Ae(n4, i2, a2);
            }, Ae.prototype.evaluate = function(t5) {
              return new oe(this.caseSensitive.evaluate(t5), this.diacriticSensitive.evaluate(t5), this.locale ? this.locale.evaluate(t5) : null);
            }, Ae.prototype.eachChild = function(t5) {
              t5(this.caseSensitive), t5(this.diacriticSensitive), this.locale && t5(this.locale);
            }, Ae.prototype.outputDefined = function() {
              return false;
            }, Ae.prototype.serialize = function() {
              var t5 = {};
              return t5["case-sensitive"] = this.caseSensitive.serialize(), t5["diacritic-sensitive"] = this.diacriticSensitive.serialize(), this.locale && (t5.locale = this.locale.serialize()), ["collator", t5];
            };
            var Me = 8192;
            function Se(t5, e4) {
              t5[0] = Math.min(t5[0], e4[0]), t5[1] = Math.min(t5[1], e4[1]), t5[2] = Math.max(t5[2], e4[0]), t5[3] = Math.max(t5[3], e4[1]);
            }
            function Ee(t5, e4) {
              return !(t5[0] <= e4[0] || t5[2] >= e4[2] || t5[1] <= e4[1] || t5[3] >= e4[3]);
            }
            function Le(t5, e4) {
              var r4, n4 = (180 + t5[0]) / 360, i2 = (r4 = t5[1], (180 - 180 / Math.PI * Math.log(Math.tan(Math.PI / 4 + r4 * Math.PI / 360))) / 360), a2 = Math.pow(2, e4.z);
              return [Math.round(n4 * a2 * Me), Math.round(i2 * a2 * Me)];
            }
            function Ce(t5, e4, r4) {
              return e4[1] > t5[1] != r4[1] > t5[1] && t5[0] < (r4[0] - e4[0]) * (t5[1] - e4[1]) / (r4[1] - e4[1]) + e4[0];
            }
            function Pe(t5, e4) {
              for (var r4 = false, n4 = 0, i2 = e4.length; n4 < i2; n4++)
                for (var a2 = e4[n4], o2 = 0, s2 = a2.length; o2 < s2 - 1; o2++) {
                  if (l2 = t5, u2 = a2[o2], c2 = a2[o2 + 1], f3 = void 0, h2 = void 0, p3 = void 0, d3 = void 0, f3 = l2[0] - u2[0], h2 = l2[1] - u2[1], p3 = l2[0] - c2[0], d3 = l2[1] - c2[1], f3 * d3 - p3 * h2 == 0 && f3 * p3 <= 0 && h2 * d3 <= 0)
                    return false;
                  Ce(t5, a2[o2], a2[o2 + 1]) && (r4 = !r4);
                }
              var l2, u2, c2, f3, h2, p3, d3;
              return r4;
            }
            function Oe(t5, e4) {
              for (var r4 = 0; r4 < e4.length; r4++)
                if (Pe(t5, e4[r4]))
                  return true;
              return false;
            }
            function Ie(t5, e4, r4, n4) {
              var i2 = t5[0] - r4[0], a2 = t5[1] - r4[1], o2 = e4[0] - r4[0], s2 = e4[1] - r4[1], l2 = n4[0] - r4[0], u2 = n4[1] - r4[1], c2 = i2 * u2 - l2 * a2, f3 = o2 * u2 - l2 * s2;
              return c2 > 0 && f3 < 0 || c2 < 0 && f3 > 0;
            }
            function De(t5, e4, r4) {
              for (var n4 = 0, i2 = r4; n4 < i2.length; n4 += 1)
                for (var a2 = i2[n4], o2 = 0; o2 < a2.length - 1; ++o2)
                  if (s2 = t5, l2 = e4, u2 = a2[o2], c2 = a2[o2 + 1], f3 = void 0, h2 = void 0, p3 = void 0, p3 = [l2[0] - s2[0], l2[1] - s2[1]], 0 != (f3 = [c2[0] - u2[0], c2[1] - u2[1]], h2 = p3, f3[0] * h2[1] - f3[1] * h2[0]) && Ie(s2, l2, u2, c2) && Ie(u2, c2, s2, l2))
                    return true;
              var s2, l2, u2, c2, f3, h2, p3;
              return false;
            }
            function ze(t5, e4) {
              for (var r4 = 0; r4 < t5.length; ++r4)
                if (!Pe(t5[r4], e4))
                  return false;
              for (var n4 = 0; n4 < t5.length - 1; ++n4)
                if (De(t5[n4], t5[n4 + 1], e4))
                  return false;
              return true;
            }
            function Re(t5, e4) {
              for (var r4 = 0; r4 < e4.length; r4++)
                if (ze(t5, e4[r4]))
                  return true;
              return false;
            }
            function Fe(t5, e4, r4) {
              for (var n4 = [], i2 = 0; i2 < t5.length; i2++) {
                for (var a2 = [], o2 = 0; o2 < t5[i2].length; o2++) {
                  var s2 = Le(t5[i2][o2], r4);
                  Se(e4, s2), a2.push(s2);
                }
                n4.push(a2);
              }
              return n4;
            }
            function Be(t5, e4, r4) {
              for (var n4 = [], i2 = 0; i2 < t5.length; i2++) {
                var a2 = Fe(t5[i2], e4, r4);
                n4.push(a2);
              }
              return n4;
            }
            function Ne(t5, e4, r4, n4) {
              if (t5[0] < r4[0] || t5[0] > r4[2]) {
                var i2 = 0.5 * n4, a2 = t5[0] - r4[0] > i2 ? -n4 : r4[0] - t5[0] > i2 ? n4 : 0;
                0 === a2 && (a2 = t5[0] - r4[2] > i2 ? -n4 : r4[2] - t5[0] > i2 ? n4 : 0), t5[0] += a2;
              }
              Se(e4, t5);
            }
            function je(t5, e4, r4, n4) {
              for (var i2 = Math.pow(2, n4.z) * Me, a2 = [n4.x * Me, n4.y * Me], o2 = [], s2 = 0, l2 = t5; s2 < l2.length; s2 += 1)
                for (var u2 = 0, c2 = l2[s2]; u2 < c2.length; u2 += 1) {
                  var f3 = c2[u2], h2 = [f3.x + a2[0], f3.y + a2[1]];
                  Ne(h2, e4, r4, i2), o2.push(h2);
                }
              return o2;
            }
            function Ue(t5, e4, r4, n4) {
              for (var i2 = Math.pow(2, n4.z) * Me, a2 = [n4.x * Me, n4.y * Me], o2 = [], s2 = 0, l2 = t5; s2 < l2.length; s2 += 1) {
                for (var u2 = [], c2 = 0, f3 = l2[s2]; c2 < f3.length; c2 += 1) {
                  var h2 = f3[c2], p3 = [h2.x + a2[0], h2.y + a2[1]];
                  Se(e4, p3), u2.push(p3);
                }
                o2.push(u2);
              }
              if (e4[2] - e4[0] <= i2 / 2) {
                (m3 = e4)[0] = m3[1] = 1 / 0, m3[2] = m3[3] = -1 / 0;
                for (var d3 = 0, v2 = o2; d3 < v2.length; d3 += 1)
                  for (var g3 = 0, y2 = v2[d3]; g3 < y2.length; g3 += 1)
                    Ne(y2[g3], e4, r4, i2);
              }
              var m3;
              return o2;
            }
            var Ve = function(t5, e4) {
              this.type = qt, this.geojson = t5, this.geometries = e4;
            };
            function He(t5) {
              if (t5 instanceof ke) {
                if ("get" === t5.name && 1 === t5.args.length)
                  return false;
                if ("feature-state" === t5.name)
                  return false;
                if ("has" === t5.name && 1 === t5.args.length)
                  return false;
                if ("properties" === t5.name || "geometry-type" === t5.name || "id" === t5.name)
                  return false;
                if (/^filter-/.test(t5.name))
                  return false;
              }
              if (t5 instanceof Ve)
                return false;
              var e4 = true;
              return t5.eachChild(function(t6) {
                e4 && !He(t6) && (e4 = false);
              }), e4;
            }
            function qe(t5) {
              if (t5 instanceof ke && "feature-state" === t5.name)
                return false;
              var e4 = true;
              return t5.eachChild(function(t6) {
                e4 && !qe(t6) && (e4 = false);
              }), e4;
            }
            function Ge(t5, e4) {
              if (t5 instanceof ke && e4.indexOf(t5.name) >= 0)
                return false;
              var r4 = true;
              return t5.eachChild(function(t6) {
                r4 && !Ge(t6, e4) && (r4 = false);
              }), r4;
            }
            Ve.parse = function(t5, e4) {
              if (2 !== t5.length)
                return e4.error("'within' expression requires exactly one argument, but found " + (t5.length - 1) + " instead.");
              if (fe(t5[1])) {
                var r4 = t5[1];
                if ("FeatureCollection" === r4.type)
                  for (var n4 = 0; n4 < r4.features.length; ++n4) {
                    var i2 = r4.features[n4].geometry.type;
                    if ("Polygon" === i2 || "MultiPolygon" === i2)
                      return new Ve(r4, r4.features[n4].geometry);
                  }
                else if ("Feature" === r4.type) {
                  var a2 = r4.geometry.type;
                  if ("Polygon" === a2 || "MultiPolygon" === a2)
                    return new Ve(r4, r4.geometry);
                } else if ("Polygon" === r4.type || "MultiPolygon" === r4.type)
                  return new Ve(r4, r4);
              }
              return e4.error("'within' expression requires valid geojson object that contains polygon geometry type.");
            }, Ve.prototype.evaluate = function(t5) {
              if (null != t5.geometry() && null != t5.canonicalID()) {
                if ("Point" === t5.geometryType())
                  return function(t6, e4) {
                    var r4 = [1 / 0, 1 / 0, -1 / 0, -1 / 0], n4 = [1 / 0, 1 / 0, -1 / 0, -1 / 0], i2 = t6.canonicalID();
                    if ("Polygon" === e4.type) {
                      var a2 = Fe(e4.coordinates, n4, i2), o2 = je(t6.geometry(), r4, n4, i2);
                      if (!Ee(r4, n4))
                        return false;
                      for (var s2 = 0, l2 = o2; s2 < l2.length; s2 += 1)
                        if (!Pe(l2[s2], a2))
                          return false;
                    }
                    if ("MultiPolygon" === e4.type) {
                      var u2 = Be(e4.coordinates, n4, i2), c2 = je(t6.geometry(), r4, n4, i2);
                      if (!Ee(r4, n4))
                        return false;
                      for (var f3 = 0, h2 = c2; f3 < h2.length; f3 += 1)
                        if (!Oe(h2[f3], u2))
                          return false;
                    }
                    return true;
                  }(t5, this.geometries);
                if ("LineString" === t5.geometryType())
                  return function(t6, e4) {
                    var r4 = [1 / 0, 1 / 0, -1 / 0, -1 / 0], n4 = [1 / 0, 1 / 0, -1 / 0, -1 / 0], i2 = t6.canonicalID();
                    if ("Polygon" === e4.type) {
                      var a2 = Fe(e4.coordinates, n4, i2), o2 = Ue(t6.geometry(), r4, n4, i2);
                      if (!Ee(r4, n4))
                        return false;
                      for (var s2 = 0, l2 = o2; s2 < l2.length; s2 += 1)
                        if (!ze(l2[s2], a2))
                          return false;
                    }
                    if ("MultiPolygon" === e4.type) {
                      var u2 = Be(e4.coordinates, n4, i2), c2 = Ue(t6.geometry(), r4, n4, i2);
                      if (!Ee(r4, n4))
                        return false;
                      for (var f3 = 0, h2 = c2; f3 < h2.length; f3 += 1)
                        if (!Re(h2[f3], u2))
                          return false;
                    }
                    return true;
                  }(t5, this.geometries);
              }
              return false;
            }, Ve.prototype.eachChild = function() {
            }, Ve.prototype.outputDefined = function() {
              return true;
            }, Ve.prototype.serialize = function() {
              return ["within", this.geojson];
            };
            var Ze = function(t5, e4) {
              this.type = e4.type, this.name = t5, this.boundExpression = e4;
            };
            Ze.parse = function(t5, e4) {
              if (2 !== t5.length || "string" != typeof t5[1])
                return e4.error("'var' expression requires exactly one string literal argument.");
              var r4 = t5[1];
              return e4.scope.has(r4) ? new Ze(r4, e4.scope.get(r4)) : e4.error('Unknown variable "' + r4 + '". Make sure "' + r4 + '" has been bound in an enclosing "let" expression before using it.', 1);
            }, Ze.prototype.evaluate = function(t5) {
              return this.boundExpression.evaluate(t5);
            }, Ze.prototype.eachChild = function() {
            }, Ze.prototype.outputDefined = function() {
              return false;
            }, Ze.prototype.serialize = function() {
              return ["var", this.name];
            };
            var Ye = function(t5, e4, r4, n4, i2) {
              void 0 === e4 && (e4 = []), void 0 === n4 && (n4 = new jt()), void 0 === i2 && (i2 = []), this.registry = t5, this.path = e4, this.key = e4.map(function(t6) {
                return "[" + t6 + "]";
              }).join(""), this.scope = n4, this.errors = i2, this.expectedType = r4;
            };
            function We(t5) {
              if (t5 instanceof Ze)
                return We(t5.boundExpression);
              if (t5 instanceof ke && "error" === t5.name)
                return false;
              if (t5 instanceof Ae)
                return false;
              if (t5 instanceof Ve)
                return false;
              var e4 = t5 instanceof _e || t5 instanceof ye, r4 = true;
              return t5.eachChild(function(t6) {
                r4 = e4 ? r4 && We(t6) : r4 && t6 instanceof de;
              }), !!r4 && He(t5) && Ge(t5, ["zoom", "heatmap-density", "line-progress", "accumulated", "is-supported-script"]);
            }
            function Xe(t5, e4) {
              for (var r4, n4, i2 = t5.length - 1, a2 = 0, o2 = i2, s2 = 0; a2 <= o2; )
                if (r4 = t5[s2 = Math.floor((a2 + o2) / 2)], n4 = t5[s2 + 1], r4 <= e4) {
                  if (s2 === i2 || e4 < n4)
                    return s2;
                  a2 = s2 + 1;
                } else {
                  if (!(r4 > e4))
                    throw new ve("Input is not a number.");
                  o2 = s2 - 1;
                }
              return 0;
            }
            Ye.prototype.parse = function(t5, e4, r4, n4, i2) {
              return void 0 === i2 && (i2 = {}), e4 ? this.concat(e4, r4, n4)._parse(t5, i2) : this._parse(t5, i2);
            }, Ye.prototype._parse = function(t5, e4) {
              function r4(t6, e5, r5) {
                return "assert" === r5 ? new ye(e5, [t6]) : "coerce" === r5 ? new _e(e5, [t6]) : t6;
              }
              if (null !== t5 && "string" != typeof t5 && "boolean" != typeof t5 && "number" != typeof t5 || (t5 = ["literal", t5]), Array.isArray(t5)) {
                if (0 === t5.length)
                  return this.error('Expected an array with at least one element. If you wanted a literal array, use ["literal", []].');
                var n4 = t5[0];
                if ("string" != typeof n4)
                  return this.error("Expression name must be a string, but found " + typeof n4 + ' instead. If you wanted a literal array, use ["literal", [...]].', 0), null;
                var i2 = this.registry[n4];
                if (i2) {
                  var a2 = i2.parse(t5, this);
                  if (!a2)
                    return null;
                  if (this.expectedType) {
                    var o2 = this.expectedType, s2 = a2.type;
                    if ("string" !== o2.kind && "number" !== o2.kind && "boolean" !== o2.kind && "object" !== o2.kind && "array" !== o2.kind || "value" !== s2.kind)
                      if ("color" !== o2.kind && "formatted" !== o2.kind && "resolvedImage" !== o2.kind || "value" !== s2.kind && "string" !== s2.kind) {
                        if (this.checkSubtype(o2, s2))
                          return null;
                      } else
                        a2 = r4(a2, o2, e4.typeAnnotation || "coerce");
                    else
                      a2 = r4(a2, o2, e4.typeAnnotation || "assert");
                  }
                  if (!(a2 instanceof de) && "resolvedImage" !== a2.type.kind && We(a2)) {
                    var l2 = new Te();
                    try {
                      a2 = new de(a2.type, a2.evaluate(l2));
                    } catch (t6) {
                      return this.error(t6.message), null;
                    }
                  }
                  return a2;
                }
                return this.error('Unknown expression "' + n4 + '". If you wanted a literal array, use ["literal", [...]].', 0);
              }
              return void 0 === t5 ? this.error("'undefined' value invalid. Use null instead.") : "object" == typeof t5 ? this.error('Bare objects invalid. Use ["literal", {...}] instead.') : this.error("Expected an array, but found " + typeof t5 + " instead.");
            }, Ye.prototype.concat = function(t5, e4, r4) {
              var n4 = "number" == typeof t5 ? this.path.concat(t5) : this.path, i2 = r4 ? this.scope.concat(r4) : this.scope;
              return new Ye(this.registry, n4, e4 || null, i2, this.errors);
            }, Ye.prototype.error = function(t5) {
              for (var e4 = [], r4 = arguments.length - 1; r4-- > 0; )
                e4[r4] = arguments[r4 + 1];
              var n4 = "" + this.key + e4.map(function(t6) {
                return "[" + t6 + "]";
              }).join("");
              this.errors.push(new Nt(n4, t5));
            }, Ye.prototype.checkSubtype = function(t5, e4) {
              var r4 = te(t5, e4);
              return r4 && this.error(r4), r4;
            };
            var Je = function(t5, e4, r4) {
              this.type = t5, this.input = e4, this.labels = [], this.outputs = [];
              for (var n4 = 0, i2 = r4; n4 < i2.length; n4 += 1) {
                var a2 = i2[n4], o2 = a2[0], s2 = a2[1];
                this.labels.push(o2), this.outputs.push(s2);
              }
            };
            function Ke(t5, e4, r4) {
              return t5 * (1 - r4) + e4 * r4;
            }
            Je.parse = function(t5, e4) {
              if (t5.length - 1 < 4)
                return e4.error("Expected at least 4 arguments, but found only " + (t5.length - 1) + ".");
              if ((t5.length - 1) % 2 != 0)
                return e4.error("Expected an even number of arguments.");
              var r4 = e4.parse(t5[1], 1, Vt);
              if (!r4)
                return null;
              var n4 = [], i2 = null;
              e4.expectedType && "value" !== e4.expectedType.kind && (i2 = e4.expectedType);
              for (var a2 = 1; a2 < t5.length; a2 += 2) {
                var o2 = 1 === a2 ? -1 / 0 : t5[a2], s2 = t5[a2 + 1], l2 = a2, u2 = a2 + 1;
                if ("number" != typeof o2)
                  return e4.error('Input/output pairs for "step" expressions must be defined using literal numeric values (not computed expressions) for the input values.', l2);
                if (n4.length && n4[n4.length - 1][0] >= o2)
                  return e4.error('Input/output pairs for "step" expressions must be arranged with input values in strictly ascending order.', l2);
                var c2 = e4.parse(s2, u2, i2);
                if (!c2)
                  return null;
                i2 = i2 || c2.type, n4.push([o2, c2]);
              }
              return new Je(i2, r4, n4);
            }, Je.prototype.evaluate = function(t5) {
              var e4 = this.labels, r4 = this.outputs;
              if (1 === e4.length)
                return r4[0].evaluate(t5);
              var n4 = this.input.evaluate(t5);
              if (n4 <= e4[0])
                return r4[0].evaluate(t5);
              var i2 = e4.length;
              return n4 >= e4[i2 - 1] ? r4[i2 - 1].evaluate(t5) : r4[Xe(e4, n4)].evaluate(t5);
            }, Je.prototype.eachChild = function(t5) {
              t5(this.input);
              for (var e4 = 0, r4 = this.outputs; e4 < r4.length; e4 += 1)
                t5(r4[e4]);
            }, Je.prototype.outputDefined = function() {
              return this.outputs.every(function(t5) {
                return t5.outputDefined();
              });
            }, Je.prototype.serialize = function() {
              for (var t5 = ["step", this.input.serialize()], e4 = 0; e4 < this.labels.length; e4++)
                e4 > 0 && t5.push(this.labels[e4]), t5.push(this.outputs[e4].serialize());
              return t5;
            };
            var $e = Object.freeze({ __proto__: null, number: Ke, color: function(t5, e4, r4) {
              return new ae(Ke(t5.r, e4.r, r4), Ke(t5.g, e4.g, r4), Ke(t5.b, e4.b, r4), Ke(t5.a, e4.a, r4));
            }, array: function(t5, e4, r4) {
              return t5.map(function(t6, n4) {
                return Ke(t6, e4[n4], r4);
              });
            } }), Qe = 0.95047, tr = 1.08883, er = 4 / 29, rr = 6 / 29, nr = 3 * rr * rr, ir = Math.PI / 180, ar = 180 / Math.PI;
            function or(t5) {
              return t5 > 0.008856451679035631 ? Math.pow(t5, 1 / 3) : t5 / nr + er;
            }
            function sr(t5) {
              return t5 > rr ? t5 * t5 * t5 : nr * (t5 - er);
            }
            function lr(t5) {
              return 255 * (t5 <= 31308e-7 ? 12.92 * t5 : 1.055 * Math.pow(t5, 1 / 2.4) - 0.055);
            }
            function ur(t5) {
              return (t5 /= 255) <= 0.04045 ? t5 / 12.92 : Math.pow((t5 + 0.055) / 1.055, 2.4);
            }
            function cr(t5) {
              var e4 = ur(t5.r), r4 = ur(t5.g), n4 = ur(t5.b), i2 = or((0.4124564 * e4 + 0.3575761 * r4 + 0.1804375 * n4) / Qe), a2 = or((0.2126729 * e4 + 0.7151522 * r4 + 0.072175 * n4) / 1);
              return { l: 116 * a2 - 16, a: 500 * (i2 - a2), b: 200 * (a2 - or((0.0193339 * e4 + 0.119192 * r4 + 0.9503041 * n4) / tr)), alpha: t5.a };
            }
            function fr(t5) {
              var e4 = (t5.l + 16) / 116, r4 = isNaN(t5.a) ? e4 : e4 + t5.a / 500, n4 = isNaN(t5.b) ? e4 : e4 - t5.b / 200;
              return e4 = 1 * sr(e4), r4 = Qe * sr(r4), n4 = tr * sr(n4), new ae(lr(3.2404542 * r4 - 1.5371385 * e4 - 0.4985314 * n4), lr(-0.969266 * r4 + 1.8760108 * e4 + 0.041556 * n4), lr(0.0556434 * r4 - 0.2040259 * e4 + 1.0572252 * n4), t5.alpha);
            }
            function hr(t5, e4, r4) {
              var n4 = e4 - t5;
              return t5 + r4 * (n4 > 180 || n4 < -180 ? n4 - 360 * Math.round(n4 / 360) : n4);
            }
            var pr = { forward: cr, reverse: fr, interpolate: function(t5, e4, r4) {
              return { l: Ke(t5.l, e4.l, r4), a: Ke(t5.a, e4.a, r4), b: Ke(t5.b, e4.b, r4), alpha: Ke(t5.alpha, e4.alpha, r4) };
            } }, dr = { forward: function(t5) {
              var e4 = cr(t5), r4 = e4.l, n4 = e4.a, i2 = e4.b, a2 = Math.atan2(i2, n4) * ar;
              return { h: a2 < 0 ? a2 + 360 : a2, c: Math.sqrt(n4 * n4 + i2 * i2), l: r4, alpha: t5.a };
            }, reverse: function(t5) {
              var e4 = t5.h * ir, r4 = t5.c;
              return fr({ l: t5.l, a: Math.cos(e4) * r4, b: Math.sin(e4) * r4, alpha: t5.alpha });
            }, interpolate: function(t5, e4, r4) {
              return { h: hr(t5.h, e4.h, r4), c: Ke(t5.c, e4.c, r4), l: Ke(t5.l, e4.l, r4), alpha: Ke(t5.alpha, e4.alpha, r4) };
            } }, vr = Object.freeze({ __proto__: null, lab: pr, hcl: dr }), gr = function(t5, e4, r4, n4, i2) {
              this.type = t5, this.operator = e4, this.interpolation = r4, this.input = n4, this.labels = [], this.outputs = [];
              for (var a2 = 0, o2 = i2; a2 < o2.length; a2 += 1) {
                var s2 = o2[a2], l2 = s2[0], u2 = s2[1];
                this.labels.push(l2), this.outputs.push(u2);
              }
            };
            function yr(t5, e4, r4, n4) {
              var i2 = n4 - r4, a2 = t5 - r4;
              return 0 === i2 ? 0 : 1 === e4 ? a2 / i2 : (Math.pow(e4, a2) - 1) / (Math.pow(e4, i2) - 1);
            }
            gr.interpolationFactor = function(t5, e4, r4, i2) {
              var a2 = 0;
              if ("exponential" === t5.name)
                a2 = yr(e4, t5.base, r4, i2);
              else if ("linear" === t5.name)
                a2 = yr(e4, 1, r4, i2);
              else if ("cubic-bezier" === t5.name) {
                var o2 = t5.controlPoints;
                a2 = new n3(o2[0], o2[1], o2[2], o2[3]).solve(yr(e4, 1, r4, i2));
              }
              return a2;
            }, gr.parse = function(t5, e4) {
              var r4 = t5[0], n4 = t5[1], i2 = t5[2], a2 = t5.slice(3);
              if (!Array.isArray(n4) || 0 === n4.length)
                return e4.error("Expected an interpolation type expression.", 1);
              if ("linear" === n4[0])
                n4 = { name: "linear" };
              else if ("exponential" === n4[0]) {
                var o2 = n4[1];
                if ("number" != typeof o2)
                  return e4.error("Exponential interpolation requires a numeric base.", 1, 1);
                n4 = { name: "exponential", base: o2 };
              } else {
                if ("cubic-bezier" !== n4[0])
                  return e4.error("Unknown interpolation type " + String(n4[0]), 1, 0);
                var s2 = n4.slice(1);
                if (4 !== s2.length || s2.some(function(t6) {
                  return "number" != typeof t6 || t6 < 0 || t6 > 1;
                }))
                  return e4.error("Cubic bezier interpolation requires four numeric arguments with values between 0 and 1.", 1);
                n4 = { name: "cubic-bezier", controlPoints: s2 };
              }
              if (t5.length - 1 < 4)
                return e4.error("Expected at least 4 arguments, but found only " + (t5.length - 1) + ".");
              if ((t5.length - 1) % 2 != 0)
                return e4.error("Expected an even number of arguments.");
              if (!(i2 = e4.parse(i2, 2, Vt)))
                return null;
              var l2 = [], u2 = null;
              "interpolate-hcl" === r4 || "interpolate-lab" === r4 ? u2 = Gt : e4.expectedType && "value" !== e4.expectedType.kind && (u2 = e4.expectedType);
              for (var c2 = 0; c2 < a2.length; c2 += 2) {
                var f3 = a2[c2], h2 = a2[c2 + 1], p3 = c2 + 3, d3 = c2 + 4;
                if ("number" != typeof f3)
                  return e4.error('Input/output pairs for "interpolate" expressions must be defined using literal numeric values (not computed expressions) for the input values.', p3);
                if (l2.length && l2[l2.length - 1][0] >= f3)
                  return e4.error('Input/output pairs for "interpolate" expressions must be arranged with input values in strictly ascending order.', p3);
                var v2 = e4.parse(h2, d3, u2);
                if (!v2)
                  return null;
                u2 = u2 || v2.type, l2.push([f3, v2]);
              }
              return "number" === u2.kind || "color" === u2.kind || "array" === u2.kind && "number" === u2.itemType.kind && "number" == typeof u2.N ? new gr(u2, r4, n4, i2, l2) : e4.error("Type " + $t(u2) + " is not interpolatable.");
            }, gr.prototype.evaluate = function(t5) {
              var e4 = this.labels, r4 = this.outputs;
              if (1 === e4.length)
                return r4[0].evaluate(t5);
              var n4 = this.input.evaluate(t5);
              if (n4 <= e4[0])
                return r4[0].evaluate(t5);
              var i2 = e4.length;
              if (n4 >= e4[i2 - 1])
                return r4[i2 - 1].evaluate(t5);
              var a2 = Xe(e4, n4), o2 = e4[a2], s2 = e4[a2 + 1], l2 = gr.interpolationFactor(this.interpolation, n4, o2, s2), u2 = r4[a2].evaluate(t5), c2 = r4[a2 + 1].evaluate(t5);
              return "interpolate" === this.operator ? $e[this.type.kind.toLowerCase()](u2, c2, l2) : "interpolate-hcl" === this.operator ? dr.reverse(dr.interpolate(dr.forward(u2), dr.forward(c2), l2)) : pr.reverse(pr.interpolate(pr.forward(u2), pr.forward(c2), l2));
            }, gr.prototype.eachChild = function(t5) {
              t5(this.input);
              for (var e4 = 0, r4 = this.outputs; e4 < r4.length; e4 += 1)
                t5(r4[e4]);
            }, gr.prototype.outputDefined = function() {
              return this.outputs.every(function(t5) {
                return t5.outputDefined();
              });
            }, gr.prototype.serialize = function() {
              var t5;
              t5 = "linear" === this.interpolation.name ? ["linear"] : "exponential" === this.interpolation.name ? 1 === this.interpolation.base ? ["linear"] : ["exponential", this.interpolation.base] : ["cubic-bezier"].concat(this.interpolation.controlPoints);
              for (var e4 = [this.operator, t5, this.input.serialize()], r4 = 0; r4 < this.labels.length; r4++)
                e4.push(this.labels[r4], this.outputs[r4].serialize());
              return e4;
            };
            var mr = function(t5, e4) {
              this.type = t5, this.args = e4;
            };
            mr.parse = function(t5, e4) {
              if (t5.length < 2)
                return e4.error("Expectected at least one argument.");
              var r4 = null, n4 = e4.expectedType;
              n4 && "value" !== n4.kind && (r4 = n4);
              for (var i2 = [], a2 = 0, o2 = t5.slice(1); a2 < o2.length; a2 += 1) {
                var s2 = o2[a2], l2 = e4.parse(s2, 1 + i2.length, r4, void 0, { typeAnnotation: "omit" });
                if (!l2)
                  return null;
                r4 = r4 || l2.type, i2.push(l2);
              }
              var u2 = n4 && i2.some(function(t6) {
                return te(n4, t6.type);
              });
              return new mr(u2 ? Yt : r4, i2);
            }, mr.prototype.evaluate = function(t5) {
              for (var e4, r4 = null, n4 = 0, i2 = 0, a2 = this.args; i2 < a2.length && (n4++, (r4 = a2[i2].evaluate(t5)) && r4 instanceof ue && !r4.available && (e4 || (e4 = r4.name), r4 = null, n4 === this.args.length && (r4 = e4)), null === r4); i2 += 1)
                ;
              return r4;
            }, mr.prototype.eachChild = function(t5) {
              this.args.forEach(t5);
            }, mr.prototype.outputDefined = function() {
              return this.args.every(function(t5) {
                return t5.outputDefined();
              });
            }, mr.prototype.serialize = function() {
              var t5 = ["coalesce"];
              return this.eachChild(function(e4) {
                t5.push(e4.serialize());
              }), t5;
            };
            var xr = function(t5, e4) {
              this.type = e4.type, this.bindings = [].concat(t5), this.result = e4;
            };
            xr.prototype.evaluate = function(t5) {
              return this.result.evaluate(t5);
            }, xr.prototype.eachChild = function(t5) {
              for (var e4 = 0, r4 = this.bindings; e4 < r4.length; e4 += 1)
                t5(r4[e4][1]);
              t5(this.result);
            }, xr.parse = function(t5, e4) {
              if (t5.length < 4)
                return e4.error("Expected at least 3 arguments, but found " + (t5.length - 1) + " instead.");
              for (var r4 = [], n4 = 1; n4 < t5.length - 1; n4 += 2) {
                var i2 = t5[n4];
                if ("string" != typeof i2)
                  return e4.error("Expected string, but found " + typeof i2 + " instead.", n4);
                if (/[^a-zA-Z0-9_]/.test(i2))
                  return e4.error("Variable names must contain only alphanumeric characters or '_'.", n4);
                var a2 = e4.parse(t5[n4 + 1], n4 + 1);
                if (!a2)
                  return null;
                r4.push([i2, a2]);
              }
              var o2 = e4.parse(t5[t5.length - 1], t5.length - 1, e4.expectedType, r4);
              return o2 ? new xr(r4, o2) : null;
            }, xr.prototype.outputDefined = function() {
              return this.result.outputDefined();
            }, xr.prototype.serialize = function() {
              for (var t5 = ["let"], e4 = 0, r4 = this.bindings; e4 < r4.length; e4 += 1) {
                var n4 = r4[e4], i2 = n4[0], a2 = n4[1];
                t5.push(i2, a2.serialize());
              }
              return t5.push(this.result.serialize()), t5;
            };
            var br = function(t5, e4, r4) {
              this.type = t5, this.index = e4, this.input = r4;
            };
            br.parse = function(t5, e4) {
              if (3 !== t5.length)
                return e4.error("Expected 2 arguments, but found " + (t5.length - 1) + " instead.");
              var r4 = e4.parse(t5[1], 1, Vt), n4 = e4.parse(t5[2], 2, Kt(e4.expectedType || Yt));
              if (!r4 || !n4)
                return null;
              var i2 = n4.type;
              return new br(i2.itemType, r4, n4);
            }, br.prototype.evaluate = function(t5) {
              var e4 = this.index.evaluate(t5), r4 = this.input.evaluate(t5);
              if (e4 < 0)
                throw new ve("Array index out of bounds: " + e4 + " < 0.");
              if (e4 >= r4.length)
                throw new ve("Array index out of bounds: " + e4 + " > " + (r4.length - 1) + ".");
              if (e4 !== Math.floor(e4))
                throw new ve("Array index must be an integer, but found " + e4 + " instead.");
              return r4[e4];
            }, br.prototype.eachChild = function(t5) {
              t5(this.index), t5(this.input);
            }, br.prototype.outputDefined = function() {
              return false;
            }, br.prototype.serialize = function() {
              return ["at", this.index.serialize(), this.input.serialize()];
            };
            var _r = function(t5, e4) {
              this.type = qt, this.needle = t5, this.haystack = e4;
            };
            _r.parse = function(t5, e4) {
              if (3 !== t5.length)
                return e4.error("Expected 2 arguments, but found " + (t5.length - 1) + " instead.");
              var r4 = e4.parse(t5[1], 1, Yt), n4 = e4.parse(t5[2], 2, Yt);
              return r4 && n4 ? ee(r4.type, [qt, Ht, Vt, Ut, Yt]) ? new _r(r4, n4) : e4.error("Expected first argument to be of type boolean, string, number or null, but found " + $t(r4.type) + " instead") : null;
            }, _r.prototype.evaluate = function(t5) {
              var e4 = this.needle.evaluate(t5), r4 = this.haystack.evaluate(t5);
              if (!r4)
                return false;
              if (!re(e4, ["boolean", "string", "number", "null"]))
                throw new ve("Expected first argument to be of type boolean, string, number or null, but found " + $t(he(e4)) + " instead.");
              if (!re(r4, ["string", "array"]))
                throw new ve("Expected second argument to be of type array or string, but found " + $t(he(r4)) + " instead.");
              return r4.indexOf(e4) >= 0;
            }, _r.prototype.eachChild = function(t5) {
              t5(this.needle), t5(this.haystack);
            }, _r.prototype.outputDefined = function() {
              return true;
            }, _r.prototype.serialize = function() {
              return ["in", this.needle.serialize(), this.haystack.serialize()];
            };
            var wr = function(t5, e4, r4) {
              this.type = Vt, this.needle = t5, this.haystack = e4, this.fromIndex = r4;
            };
            wr.parse = function(t5, e4) {
              if (t5.length <= 2 || t5.length >= 5)
                return e4.error("Expected 3 or 4 arguments, but found " + (t5.length - 1) + " instead.");
              var r4 = e4.parse(t5[1], 1, Yt), n4 = e4.parse(t5[2], 2, Yt);
              if (!r4 || !n4)
                return null;
              if (!ee(r4.type, [qt, Ht, Vt, Ut, Yt]))
                return e4.error("Expected first argument to be of type boolean, string, number or null, but found " + $t(r4.type) + " instead");
              if (4 === t5.length) {
                var i2 = e4.parse(t5[3], 3, Vt);
                return i2 ? new wr(r4, n4, i2) : null;
              }
              return new wr(r4, n4);
            }, wr.prototype.evaluate = function(t5) {
              var e4 = this.needle.evaluate(t5), r4 = this.haystack.evaluate(t5);
              if (!re(e4, ["boolean", "string", "number", "null"]))
                throw new ve("Expected first argument to be of type boolean, string, number or null, but found " + $t(he(e4)) + " instead.");
              if (!re(r4, ["string", "array"]))
                throw new ve("Expected second argument to be of type array or string, but found " + $t(he(r4)) + " instead.");
              if (this.fromIndex) {
                var n4 = this.fromIndex.evaluate(t5);
                return r4.indexOf(e4, n4);
              }
              return r4.indexOf(e4);
            }, wr.prototype.eachChild = function(t5) {
              t5(this.needle), t5(this.haystack), this.fromIndex && t5(this.fromIndex);
            }, wr.prototype.outputDefined = function() {
              return false;
            }, wr.prototype.serialize = function() {
              if (null != this.fromIndex && void 0 !== this.fromIndex) {
                var t5 = this.fromIndex.serialize();
                return ["index-of", this.needle.serialize(), this.haystack.serialize(), t5];
              }
              return ["index-of", this.needle.serialize(), this.haystack.serialize()];
            };
            var Tr = function(t5, e4, r4, n4, i2, a2) {
              this.inputType = t5, this.type = e4, this.input = r4, this.cases = n4, this.outputs = i2, this.otherwise = a2;
            };
            Tr.parse = function(t5, e4) {
              if (t5.length < 5)
                return e4.error("Expected at least 4 arguments, but found only " + (t5.length - 1) + ".");
              if (t5.length % 2 != 1)
                return e4.error("Expected an even number of arguments.");
              var r4, n4;
              e4.expectedType && "value" !== e4.expectedType.kind && (n4 = e4.expectedType);
              for (var i2 = {}, a2 = [], o2 = 2; o2 < t5.length - 1; o2 += 2) {
                var s2 = t5[o2], l2 = t5[o2 + 1];
                Array.isArray(s2) || (s2 = [s2]);
                var u2 = e4.concat(o2);
                if (0 === s2.length)
                  return u2.error("Expected at least one branch label.");
                for (var c2 = 0, f3 = s2; c2 < f3.length; c2 += 1) {
                  var h2 = f3[c2];
                  if ("number" != typeof h2 && "string" != typeof h2)
                    return u2.error("Branch labels must be numbers or strings.");
                  if ("number" == typeof h2 && Math.abs(h2) > Number.MAX_SAFE_INTEGER)
                    return u2.error("Branch labels must be integers no larger than " + Number.MAX_SAFE_INTEGER + ".");
                  if ("number" == typeof h2 && Math.floor(h2) !== h2)
                    return u2.error("Numeric branch labels must be integer values.");
                  if (r4) {
                    if (u2.checkSubtype(r4, he(h2)))
                      return null;
                  } else
                    r4 = he(h2);
                  if (void 0 !== i2[String(h2)])
                    return u2.error("Branch labels must be unique.");
                  i2[String(h2)] = a2.length;
                }
                var p3 = e4.parse(l2, o2, n4);
                if (!p3)
                  return null;
                n4 = n4 || p3.type, a2.push(p3);
              }
              var d3 = e4.parse(t5[1], 1, Yt);
              if (!d3)
                return null;
              var v2 = e4.parse(t5[t5.length - 1], t5.length - 1, n4);
              return v2 ? "value" !== d3.type.kind && e4.concat(1).checkSubtype(r4, d3.type) ? null : new Tr(r4, n4, d3, i2, a2, v2) : null;
            }, Tr.prototype.evaluate = function(t5) {
              var e4 = this.input.evaluate(t5);
              return (he(e4) === this.inputType && this.outputs[this.cases[e4]] || this.otherwise).evaluate(t5);
            }, Tr.prototype.eachChild = function(t5) {
              t5(this.input), this.outputs.forEach(t5), t5(this.otherwise);
            }, Tr.prototype.outputDefined = function() {
              return this.outputs.every(function(t5) {
                return t5.outputDefined();
              }) && this.otherwise.outputDefined();
            }, Tr.prototype.serialize = function() {
              for (var t5 = this, e4 = ["match", this.input.serialize()], r4 = [], n4 = {}, i2 = 0, a2 = Object.keys(this.cases).sort(); i2 < a2.length; i2 += 1) {
                var o2 = a2[i2];
                void 0 === (f3 = n4[this.cases[o2]]) ? (n4[this.cases[o2]] = r4.length, r4.push([this.cases[o2], [o2]])) : r4[f3][1].push(o2);
              }
              for (var s2 = function(e5) {
                return "number" === t5.inputType.kind ? Number(e5) : e5;
              }, l2 = 0, u2 = r4; l2 < u2.length; l2 += 1) {
                var c2 = u2[l2], f3 = c2[0], h2 = c2[1];
                1 === h2.length ? e4.push(s2(h2[0])) : e4.push(h2.map(s2)), e4.push(this.outputs[outputIndex$1].serialize());
              }
              return e4.push(this.otherwise.serialize()), e4;
            };
            var kr = function(t5, e4, r4) {
              this.type = t5, this.branches = e4, this.otherwise = r4;
            };
            kr.parse = function(t5, e4) {
              if (t5.length < 4)
                return e4.error("Expected at least 3 arguments, but found only " + (t5.length - 1) + ".");
              if (t5.length % 2 != 0)
                return e4.error("Expected an odd number of arguments.");
              var r4;
              e4.expectedType && "value" !== e4.expectedType.kind && (r4 = e4.expectedType);
              for (var n4 = [], i2 = 1; i2 < t5.length - 1; i2 += 2) {
                var a2 = e4.parse(t5[i2], i2, qt);
                if (!a2)
                  return null;
                var o2 = e4.parse(t5[i2 + 1], i2 + 1, r4);
                if (!o2)
                  return null;
                n4.push([a2, o2]), r4 = r4 || o2.type;
              }
              var s2 = e4.parse(t5[t5.length - 1], t5.length - 1, r4);
              return s2 ? new kr(r4, n4, s2) : null;
            }, kr.prototype.evaluate = function(t5) {
              for (var e4 = 0, r4 = this.branches; e4 < r4.length; e4 += 1) {
                var n4 = r4[e4], i2 = n4[0], a2 = n4[1];
                if (i2.evaluate(t5))
                  return a2.evaluate(t5);
              }
              return this.otherwise.evaluate(t5);
            }, kr.prototype.eachChild = function(t5) {
              for (var e4 = 0, r4 = this.branches; e4 < r4.length; e4 += 1) {
                var n4 = r4[e4], i2 = n4[0], a2 = n4[1];
                t5(i2), t5(a2);
              }
              t5(this.otherwise);
            }, kr.prototype.outputDefined = function() {
              return this.branches.every(function(t5) {
                return t5[0], t5[1].outputDefined();
              }) && this.otherwise.outputDefined();
            }, kr.prototype.serialize = function() {
              var t5 = ["case"];
              return this.eachChild(function(e4) {
                t5.push(e4.serialize());
              }), t5;
            };
            var Ar = function(t5, e4, r4, n4) {
              this.type = t5, this.input = e4, this.beginIndex = r4, this.endIndex = n4;
            };
            function Mr(t5, e4) {
              return "==" === t5 || "!=" === t5 ? "boolean" === e4.kind || "string" === e4.kind || "number" === e4.kind || "null" === e4.kind || "value" === e4.kind : "string" === e4.kind || "number" === e4.kind || "value" === e4.kind;
            }
            function Sr(t5, e4, r4, n4) {
              return 0 === n4.compare(e4, r4);
            }
            function Er(t5, e4, r4) {
              var n4 = "==" !== t5 && "!=" !== t5;
              return function() {
                function i2(t6, e5, r5) {
                  this.type = qt, this.lhs = t6, this.rhs = e5, this.collator = r5, this.hasUntypedArgument = "value" === t6.type.kind || "value" === e5.type.kind;
                }
                return i2.parse = function(t6, e5) {
                  if (3 !== t6.length && 4 !== t6.length)
                    return e5.error("Expected two or three arguments.");
                  var r5 = t6[0], a2 = e5.parse(t6[1], 1, Yt);
                  if (!a2)
                    return null;
                  if (!Mr(r5, a2.type))
                    return e5.concat(1).error('"' + r5 + `" comparisons are not supported for type '` + $t(a2.type) + "'.");
                  var o2 = e5.parse(t6[2], 2, Yt);
                  if (!o2)
                    return null;
                  if (!Mr(r5, o2.type))
                    return e5.concat(2).error('"' + r5 + `" comparisons are not supported for type '` + $t(o2.type) + "'.");
                  if (a2.type.kind !== o2.type.kind && "value" !== a2.type.kind && "value" !== o2.type.kind)
                    return e5.error("Cannot compare types '" + $t(a2.type) + "' and '" + $t(o2.type) + "'.");
                  n4 && ("value" === a2.type.kind && "value" !== o2.type.kind ? a2 = new ye(o2.type, [a2]) : "value" !== a2.type.kind && "value" === o2.type.kind && (o2 = new ye(a2.type, [o2])));
                  var s2 = null;
                  if (4 === t6.length) {
                    if ("string" !== a2.type.kind && "string" !== o2.type.kind && "value" !== a2.type.kind && "value" !== o2.type.kind)
                      return e5.error("Cannot use collator to compare non-string types.");
                    if (!(s2 = e5.parse(t6[3], 3, Wt)))
                      return null;
                  }
                  return new i2(a2, o2, s2);
                }, i2.prototype.evaluate = function(i3) {
                  var a2 = this.lhs.evaluate(i3), o2 = this.rhs.evaluate(i3);
                  if (n4 && this.hasUntypedArgument) {
                    var s2 = he(a2), l2 = he(o2);
                    if (s2.kind !== l2.kind || "string" !== s2.kind && "number" !== s2.kind)
                      throw new ve('Expected arguments for "' + t5 + '" to be (string, string) or (number, number), but found (' + s2.kind + ", " + l2.kind + ") instead.");
                  }
                  if (this.collator && !n4 && this.hasUntypedArgument) {
                    var u2 = he(a2), c2 = he(o2);
                    if ("string" !== u2.kind || "string" !== c2.kind)
                      return e4(i3, a2, o2);
                  }
                  return this.collator ? r4(i3, a2, o2, this.collator.evaluate(i3)) : e4(i3, a2, o2);
                }, i2.prototype.eachChild = function(t6) {
                  t6(this.lhs), t6(this.rhs), this.collator && t6(this.collator);
                }, i2.prototype.outputDefined = function() {
                  return true;
                }, i2.prototype.serialize = function() {
                  var e5 = [t5];
                  return this.eachChild(function(t6) {
                    e5.push(t6.serialize());
                  }), e5;
                }, i2;
              }();
            }
            Ar.parse = function(t5, e4) {
              if (t5.length <= 2 || t5.length >= 5)
                return e4.error("Expected 3 or 4 arguments, but found " + (t5.length - 1) + " instead.");
              var r4 = e4.parse(t5[1], 1, Yt), n4 = e4.parse(t5[2], 2, Vt);
              if (!r4 || !n4)
                return null;
              if (!ee(r4.type, [Kt(Yt), Ht, Yt]))
                return e4.error("Expected first argument to be of type array or string, but found " + $t(r4.type) + " instead");
              if (4 === t5.length) {
                var i2 = e4.parse(t5[3], 3, Vt);
                return i2 ? new Ar(r4.type, r4, n4, i2) : null;
              }
              return new Ar(r4.type, r4, n4);
            }, Ar.prototype.evaluate = function(t5) {
              var e4 = this.input.evaluate(t5), r4 = this.beginIndex.evaluate(t5);
              if (!re(e4, ["string", "array"]))
                throw new ve("Expected first argument to be of type array or string, but found " + $t(he(e4)) + " instead.");
              if (this.endIndex) {
                var n4 = this.endIndex.evaluate(t5);
                return e4.slice(r4, n4);
              }
              return e4.slice(r4);
            }, Ar.prototype.eachChild = function(t5) {
              t5(this.input), t5(this.beginIndex), this.endIndex && t5(this.endIndex);
            }, Ar.prototype.outputDefined = function() {
              return false;
            }, Ar.prototype.serialize = function() {
              if (null != this.endIndex && void 0 !== this.endIndex) {
                var t5 = this.endIndex.serialize();
                return ["slice", this.input.serialize(), this.beginIndex.serialize(), t5];
              }
              return ["slice", this.input.serialize(), this.beginIndex.serialize()];
            };
            var Lr = Er("==", function(t5, e4, r4) {
              return e4 === r4;
            }, Sr), Cr = Er("!=", function(t5, e4, r4) {
              return e4 !== r4;
            }, function(t5, e4, r4, n4) {
              return !Sr(0, e4, r4, n4);
            }), Pr = Er("<", function(t5, e4, r4) {
              return e4 < r4;
            }, function(t5, e4, r4, n4) {
              return n4.compare(e4, r4) < 0;
            }), Or = Er(">", function(t5, e4, r4) {
              return e4 > r4;
            }, function(t5, e4, r4, n4) {
              return n4.compare(e4, r4) > 0;
            }), Ir = Er("<=", function(t5, e4, r4) {
              return e4 <= r4;
            }, function(t5, e4, r4, n4) {
              return n4.compare(e4, r4) <= 0;
            }), Dr = Er(">=", function(t5, e4, r4) {
              return e4 >= r4;
            }, function(t5, e4, r4, n4) {
              return n4.compare(e4, r4) >= 0;
            }), zr = function(t5, e4, r4, n4, i2) {
              this.type = Ht, this.number = t5, this.locale = e4, this.currency = r4, this.minFractionDigits = n4, this.maxFractionDigits = i2;
            };
            zr.parse = function(t5, e4) {
              if (3 !== t5.length)
                return e4.error("Expected two arguments.");
              var r4 = e4.parse(t5[1], 1, Vt);
              if (!r4)
                return null;
              var n4 = t5[2];
              if ("object" != typeof n4 || Array.isArray(n4))
                return e4.error("NumberFormat options argument must be an object.");
              var i2 = null;
              if (n4.locale && !(i2 = e4.parse(n4.locale, 1, Ht)))
                return null;
              var a2 = null;
              if (n4.currency && !(a2 = e4.parse(n4.currency, 1, Ht)))
                return null;
              var o2 = null;
              if (n4["min-fraction-digits"] && !(o2 = e4.parse(n4["min-fraction-digits"], 1, Vt)))
                return null;
              var s2 = null;
              return n4["max-fraction-digits"] && !(s2 = e4.parse(n4["max-fraction-digits"], 1, Vt)) ? null : new zr(r4, i2, a2, o2, s2);
            }, zr.prototype.evaluate = function(t5) {
              return new Intl.NumberFormat(this.locale ? this.locale.evaluate(t5) : [], { style: this.currency ? "currency" : "decimal", currency: this.currency ? this.currency.evaluate(t5) : void 0, minimumFractionDigits: this.minFractionDigits ? this.minFractionDigits.evaluate(t5) : void 0, maximumFractionDigits: this.maxFractionDigits ? this.maxFractionDigits.evaluate(t5) : void 0 }).format(this.number.evaluate(t5));
            }, zr.prototype.eachChild = function(t5) {
              t5(this.number), this.locale && t5(this.locale), this.currency && t5(this.currency), this.minFractionDigits && t5(this.minFractionDigits), this.maxFractionDigits && t5(this.maxFractionDigits);
            }, zr.prototype.outputDefined = function() {
              return false;
            }, zr.prototype.serialize = function() {
              var t5 = {};
              return this.locale && (t5.locale = this.locale.serialize()), this.currency && (t5.currency = this.currency.serialize()), this.minFractionDigits && (t5["min-fraction-digits"] = this.minFractionDigits.serialize()), this.maxFractionDigits && (t5["max-fraction-digits"] = this.maxFractionDigits.serialize()), ["number-format", this.number.serialize(), t5];
            };
            var Rr = function(t5) {
              this.type = Vt, this.input = t5;
            };
            Rr.parse = function(t5, e4) {
              if (2 !== t5.length)
                return e4.error("Expected 1 argument, but found " + (t5.length - 1) + " instead.");
              var r4 = e4.parse(t5[1], 1);
              return r4 ? "array" !== r4.type.kind && "string" !== r4.type.kind && "value" !== r4.type.kind ? e4.error("Expected argument of type string or array, but found " + $t(r4.type) + " instead.") : new Rr(r4) : null;
            }, Rr.prototype.evaluate = function(t5) {
              var e4 = this.input.evaluate(t5);
              if ("string" == typeof e4)
                return e4.length;
              if (Array.isArray(e4))
                return e4.length;
              throw new ve("Expected value to be of type string or array, but found " + $t(he(e4)) + " instead.");
            }, Rr.prototype.eachChild = function(t5) {
              t5(this.input);
            }, Rr.prototype.outputDefined = function() {
              return false;
            }, Rr.prototype.serialize = function() {
              var t5 = ["length"];
              return this.eachChild(function(e4) {
                t5.push(e4.serialize());
              }), t5;
            };
            var Fr = { "==": Lr, "!=": Cr, ">": Or, "<": Pr, ">=": Dr, "<=": Ir, array: ye, at: br, boolean: ye, case: kr, coalesce: mr, collator: Ae, format: me, image: xe, in: _r, "index-of": wr, interpolate: gr, "interpolate-hcl": gr, "interpolate-lab": gr, length: Rr, let: xr, literal: de, match: Tr, number: ye, "number-format": zr, object: ye, slice: Ar, step: Je, string: ye, "to-boolean": _e, "to-color": _e, "to-number": _e, "to-string": _e, var: Ze, within: Ve };
            function Br(t5, e4) {
              var r4 = e4[0], n4 = e4[1], i2 = e4[2], a2 = e4[3];
              r4 = r4.evaluate(t5), n4 = n4.evaluate(t5), i2 = i2.evaluate(t5);
              var o2 = a2 ? a2.evaluate(t5) : 1, s2 = ce(r4, n4, i2, o2);
              if (s2)
                throw new ve(s2);
              return new ae(r4 / 255 * o2, n4 / 255 * o2, i2 / 255 * o2, o2);
            }
            function Nr(t5, e4) {
              return t5 in e4;
            }
            function jr(t5, e4) {
              var r4 = e4[t5];
              return void 0 === r4 ? null : r4;
            }
            function Ur(t5) {
              return { type: t5 };
            }
            function Vr(t5) {
              return { result: "success", value: t5 };
            }
            function Hr(t5) {
              return { result: "error", value: t5 };
            }
            function qr(t5) {
              return "data-driven" === t5["property-type"] || "cross-faded-data-driven" === t5["property-type"];
            }
            function Gr(t5) {
              return !!t5.expression && t5.expression.parameters.indexOf("zoom") > -1;
            }
            function Zr(t5) {
              return !!t5.expression && t5.expression.interpolated;
            }
            function Yr(t5) {
              return t5 instanceof Number ? "number" : t5 instanceof String ? "string" : t5 instanceof Boolean ? "boolean" : Array.isArray(t5) ? "array" : null === t5 ? "null" : typeof t5;
            }
            function Wr(t5) {
              return "object" == typeof t5 && null !== t5 && !Array.isArray(t5);
            }
            function Xr(t5) {
              return t5;
            }
            function Jr(t5, e4) {
              var r4, n4, i2, a2 = "color" === e4.type, o2 = t5.stops && "object" == typeof t5.stops[0][0], s2 = o2 || void 0 !== t5.property, l2 = o2 || !s2, u2 = t5.type || (Zr(e4) ? "exponential" : "interval");
              if (a2 && ((t5 = Rt({}, t5)).stops && (t5.stops = t5.stops.map(function(t6) {
                return [t6[0], ae.parse(t6[1])];
              })), t5.default ? t5.default = ae.parse(t5.default) : t5.default = ae.parse(e4.default)), t5.colorSpace && "rgb" !== t5.colorSpace && !vr[t5.colorSpace])
                throw new Error("Unknown color space: " + t5.colorSpace);
              if ("exponential" === u2)
                r4 = tn;
              else if ("interval" === u2)
                r4 = Qr;
              else if ("categorical" === u2) {
                r4 = $r, n4 = /* @__PURE__ */ Object.create(null);
                for (var c2 = 0, f3 = t5.stops; c2 < f3.length; c2 += 1) {
                  var h2 = f3[c2];
                  n4[h2[0]] = h2[1];
                }
                i2 = typeof t5.stops[0][0];
              } else {
                if ("identity" !== u2)
                  throw new Error('Unknown function type "' + u2 + '"');
                r4 = en;
              }
              if (o2) {
                for (var p3 = {}, d3 = [], v2 = 0; v2 < t5.stops.length; v2++) {
                  var g3 = t5.stops[v2], y2 = g3[0].zoom;
                  void 0 === p3[y2] && (p3[y2] = { zoom: y2, type: t5.type, property: t5.property, default: t5.default, stops: [] }, d3.push(y2)), p3[y2].stops.push([g3[0].value, g3[1]]);
                }
                for (var m3 = [], x2 = 0, b2 = d3; x2 < b2.length; x2 += 1) {
                  var _2 = b2[x2];
                  m3.push([p3[_2].zoom, Jr(p3[_2], e4)]);
                }
                var w3 = { name: "linear" };
                return { kind: "composite", interpolationType: w3, interpolationFactor: gr.interpolationFactor.bind(void 0, w3), zoomStops: m3.map(function(t6) {
                  return t6[0];
                }), evaluate: function(r5, n5) {
                  var i3 = r5.zoom;
                  return tn({ stops: m3, base: t5.base }, e4, i3).evaluate(i3, n5);
                } };
              }
              if (l2) {
                var T2 = "exponential" === u2 ? { name: "exponential", base: void 0 !== t5.base ? t5.base : 1 } : null;
                return { kind: "camera", interpolationType: T2, interpolationFactor: gr.interpolationFactor.bind(void 0, T2), zoomStops: t5.stops.map(function(t6) {
                  return t6[0];
                }), evaluate: function(a3) {
                  var o3 = a3.zoom;
                  return r4(t5, e4, o3, n4, i2);
                } };
              }
              return { kind: "source", evaluate: function(a3, o3) {
                var s3 = o3 && o3.properties ? o3.properties[t5.property] : void 0;
                return void 0 === s3 ? Kr(t5.default, e4.default) : r4(t5, e4, s3, n4, i2);
              } };
            }
            function Kr(t5, e4, r4) {
              return void 0 !== t5 ? t5 : void 0 !== e4 ? e4 : void 0 !== r4 ? r4 : void 0;
            }
            function $r(t5, e4, r4, n4, i2) {
              return Kr(typeof r4 === i2 ? n4[r4] : void 0, t5.default, e4.default);
            }
            function Qr(t5, e4, r4) {
              if ("number" !== Yr(r4))
                return Kr(t5.default, e4.default);
              var n4 = t5.stops.length;
              if (1 === n4)
                return t5.stops[0][1];
              if (r4 <= t5.stops[0][0])
                return t5.stops[0][1];
              if (r4 >= t5.stops[n4 - 1][0])
                return t5.stops[n4 - 1][1];
              var i2 = Xe(t5.stops.map(function(t6) {
                return t6[0];
              }), r4);
              return t5.stops[i2][1];
            }
            function tn(t5, e4, r4) {
              var n4 = void 0 !== t5.base ? t5.base : 1;
              if ("number" !== Yr(r4))
                return Kr(t5.default, e4.default);
              var i2 = t5.stops.length;
              if (1 === i2)
                return t5.stops[0][1];
              if (r4 <= t5.stops[0][0])
                return t5.stops[0][1];
              if (r4 >= t5.stops[i2 - 1][0])
                return t5.stops[i2 - 1][1];
              var a2 = Xe(t5.stops.map(function(t6) {
                return t6[0];
              }), r4), o2 = function(t6, e5, r5, n5) {
                var i3 = n5 - r5, a3 = t6 - r5;
                return 0 === i3 ? 0 : 1 === e5 ? a3 / i3 : (Math.pow(e5, a3) - 1) / (Math.pow(e5, i3) - 1);
              }(r4, n4, t5.stops[a2][0], t5.stops[a2 + 1][0]), s2 = t5.stops[a2][1], l2 = t5.stops[a2 + 1][1], u2 = $e[e4.type] || Xr;
              if (t5.colorSpace && "rgb" !== t5.colorSpace) {
                var c2 = vr[t5.colorSpace];
                u2 = function(t6, e5) {
                  return c2.reverse(c2.interpolate(c2.forward(t6), c2.forward(e5), o2));
                };
              }
              return "function" == typeof s2.evaluate ? { evaluate: function() {
                for (var t6 = [], e5 = arguments.length; e5--; )
                  t6[e5] = arguments[e5];
                var r5 = s2.evaluate.apply(void 0, t6), n5 = l2.evaluate.apply(void 0, t6);
                if (void 0 !== r5 && void 0 !== n5)
                  return u2(r5, n5, o2);
              } } : u2(s2, l2, o2);
            }
            function en(t5, e4, r4) {
              return "color" === e4.type ? r4 = ae.parse(r4) : "formatted" === e4.type ? r4 = le.fromString(r4.toString()) : "resolvedImage" === e4.type ? r4 = ue.fromString(r4.toString()) : Yr(r4) === e4.type || "enum" === e4.type && e4.values[r4] || (r4 = void 0), Kr(r4, t5.default, e4.default);
            }
            ke.register(Fr, { error: [{ kind: "error" }, [Ht], function(t5, e4) {
              var r4 = e4[0];
              throw new ve(r4.evaluate(t5));
            }], typeof: [Ht, [Yt], function(t5, e4) {
              return $t(he(e4[0].evaluate(t5)));
            }], "to-rgba": [Kt(Vt, 4), [Gt], function(t5, e4) {
              return e4[0].evaluate(t5).toArray();
            }], rgb: [Gt, [Vt, Vt, Vt], Br], rgba: [Gt, [Vt, Vt, Vt, Vt], Br], has: { type: qt, overloads: [[[Ht], function(t5, e4) {
              return Nr(e4[0].evaluate(t5), t5.properties());
            }], [[Ht, Zt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1];
              return Nr(r4.evaluate(t5), n4.evaluate(t5));
            }]] }, get: { type: Yt, overloads: [[[Ht], function(t5, e4) {
              return jr(e4[0].evaluate(t5), t5.properties());
            }], [[Ht, Zt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1];
              return jr(r4.evaluate(t5), n4.evaluate(t5));
            }]] }, "feature-state": [Yt, [Ht], function(t5, e4) {
              return jr(e4[0].evaluate(t5), t5.featureState || {});
            }], properties: [Zt, [], function(t5) {
              return t5.properties();
            }], "geometry-type": [Ht, [], function(t5) {
              return t5.geometryType();
            }], id: [Yt, [], function(t5) {
              return t5.id();
            }], zoom: [Vt, [], function(t5) {
              return t5.globals.zoom;
            }], "heatmap-density": [Vt, [], function(t5) {
              return t5.globals.heatmapDensity || 0;
            }], "line-progress": [Vt, [], function(t5) {
              return t5.globals.lineProgress || 0;
            }], accumulated: [Yt, [], function(t5) {
              return void 0 === t5.globals.accumulated ? null : t5.globals.accumulated;
            }], "+": [Vt, Ur(Vt), function(t5, e4) {
              for (var r4 = 0, n4 = 0, i2 = e4; n4 < i2.length; n4 += 1)
                r4 += i2[n4].evaluate(t5);
              return r4;
            }], "*": [Vt, Ur(Vt), function(t5, e4) {
              for (var r4 = 1, n4 = 0, i2 = e4; n4 < i2.length; n4 += 1)
                r4 *= i2[n4].evaluate(t5);
              return r4;
            }], "-": { type: Vt, overloads: [[[Vt, Vt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1];
              return r4.evaluate(t5) - n4.evaluate(t5);
            }], [[Vt], function(t5, e4) {
              return -e4[0].evaluate(t5);
            }]] }, "/": [Vt, [Vt, Vt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1];
              return r4.evaluate(t5) / n4.evaluate(t5);
            }], "%": [Vt, [Vt, Vt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1];
              return r4.evaluate(t5) % n4.evaluate(t5);
            }], ln2: [Vt, [], function() {
              return Math.LN2;
            }], pi: [Vt, [], function() {
              return Math.PI;
            }], e: [Vt, [], function() {
              return Math.E;
            }], "^": [Vt, [Vt, Vt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1];
              return Math.pow(r4.evaluate(t5), n4.evaluate(t5));
            }], sqrt: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.sqrt(r4.evaluate(t5));
            }], log10: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.log(r4.evaluate(t5)) / Math.LN10;
            }], ln: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.log(r4.evaluate(t5));
            }], log2: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.log(r4.evaluate(t5)) / Math.LN2;
            }], sin: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.sin(r4.evaluate(t5));
            }], cos: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.cos(r4.evaluate(t5));
            }], tan: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.tan(r4.evaluate(t5));
            }], asin: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.asin(r4.evaluate(t5));
            }], acos: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.acos(r4.evaluate(t5));
            }], atan: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.atan(r4.evaluate(t5));
            }], min: [Vt, Ur(Vt), function(t5, e4) {
              return Math.min.apply(Math, e4.map(function(e5) {
                return e5.evaluate(t5);
              }));
            }], max: [Vt, Ur(Vt), function(t5, e4) {
              return Math.max.apply(Math, e4.map(function(e5) {
                return e5.evaluate(t5);
              }));
            }], abs: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.abs(r4.evaluate(t5));
            }], round: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0].evaluate(t5);
              return r4 < 0 ? -Math.round(-r4) : Math.round(r4);
            }], floor: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.floor(r4.evaluate(t5));
            }], ceil: [Vt, [Vt], function(t5, e4) {
              var r4 = e4[0];
              return Math.ceil(r4.evaluate(t5));
            }], "filter-==": [qt, [Ht, Yt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1];
              return t5.properties()[r4.value] === n4.value;
            }], "filter-id-==": [qt, [Yt], function(t5, e4) {
              var r4 = e4[0];
              return t5.id() === r4.value;
            }], "filter-type-==": [qt, [Ht], function(t5, e4) {
              var r4 = e4[0];
              return t5.geometryType() === r4.value;
            }], "filter-<": [qt, [Ht, Yt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1], i2 = t5.properties()[r4.value], a2 = n4.value;
              return typeof i2 == typeof a2 && i2 < a2;
            }], "filter-id-<": [qt, [Yt], function(t5, e4) {
              var r4 = e4[0], n4 = t5.id(), i2 = r4.value;
              return typeof n4 == typeof i2 && n4 < i2;
            }], "filter->": [qt, [Ht, Yt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1], i2 = t5.properties()[r4.value], a2 = n4.value;
              return typeof i2 == typeof a2 && i2 > a2;
            }], "filter-id->": [qt, [Yt], function(t5, e4) {
              var r4 = e4[0], n4 = t5.id(), i2 = r4.value;
              return typeof n4 == typeof i2 && n4 > i2;
            }], "filter-<=": [qt, [Ht, Yt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1], i2 = t5.properties()[r4.value], a2 = n4.value;
              return typeof i2 == typeof a2 && i2 <= a2;
            }], "filter-id-<=": [qt, [Yt], function(t5, e4) {
              var r4 = e4[0], n4 = t5.id(), i2 = r4.value;
              return typeof n4 == typeof i2 && n4 <= i2;
            }], "filter->=": [qt, [Ht, Yt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1], i2 = t5.properties()[r4.value], a2 = n4.value;
              return typeof i2 == typeof a2 && i2 >= a2;
            }], "filter-id->=": [qt, [Yt], function(t5, e4) {
              var r4 = e4[0], n4 = t5.id(), i2 = r4.value;
              return typeof n4 == typeof i2 && n4 >= i2;
            }], "filter-has": [qt, [Yt], function(t5, e4) {
              return e4[0].value in t5.properties();
            }], "filter-has-id": [qt, [], function(t5) {
              return null !== t5.id() && void 0 !== t5.id();
            }], "filter-type-in": [qt, [Kt(Ht)], function(t5, e4) {
              return e4[0].value.indexOf(t5.geometryType()) >= 0;
            }], "filter-id-in": [qt, [Kt(Yt)], function(t5, e4) {
              return e4[0].value.indexOf(t5.id()) >= 0;
            }], "filter-in-small": [qt, [Ht, Kt(Yt)], function(t5, e4) {
              var r4 = e4[0];
              return e4[1].value.indexOf(t5.properties()[r4.value]) >= 0;
            }], "filter-in-large": [qt, [Ht, Kt(Yt)], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1];
              return function(t6, e5, r5, n5) {
                for (; r5 <= n5; ) {
                  var i2 = r5 + n5 >> 1;
                  if (e5[i2] === t6)
                    return true;
                  e5[i2] > t6 ? n5 = i2 - 1 : r5 = i2 + 1;
                }
                return false;
              }(t5.properties()[r4.value], n4.value, 0, n4.value.length - 1);
            }], all: { type: qt, overloads: [[[qt, qt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1];
              return r4.evaluate(t5) && n4.evaluate(t5);
            }], [Ur(qt), function(t5, e4) {
              for (var r4 = 0, n4 = e4; r4 < n4.length; r4 += 1)
                if (!n4[r4].evaluate(t5))
                  return false;
              return true;
            }]] }, any: { type: qt, overloads: [[[qt, qt], function(t5, e4) {
              var r4 = e4[0], n4 = e4[1];
              return r4.evaluate(t5) || n4.evaluate(t5);
            }], [Ur(qt), function(t5, e4) {
              for (var r4 = 0, n4 = e4; r4 < n4.length; r4 += 1)
                if (n4[r4].evaluate(t5))
                  return true;
              return false;
            }]] }, "!": [qt, [qt], function(t5, e4) {
              return !e4[0].evaluate(t5);
            }], "is-supported-script": [qt, [Ht], function(t5, e4) {
              var r4 = e4[0], n4 = t5.globals && t5.globals.isSupportedScript;
              return !n4 || n4(r4.evaluate(t5));
            }], upcase: [Ht, [Ht], function(t5, e4) {
              return e4[0].evaluate(t5).toUpperCase();
            }], downcase: [Ht, [Ht], function(t5, e4) {
              return e4[0].evaluate(t5).toLowerCase();
            }], concat: [Ht, Ur(Yt), function(t5, e4) {
              return e4.map(function(e5) {
                return pe(e5.evaluate(t5));
              }).join("");
            }], "resolved-locale": [Ht, [Wt], function(t5, e4) {
              return e4[0].evaluate(t5).resolvedLocale();
            }] });
            var rn = function(t5, e4) {
              this.expression = t5, this._warningHistory = {}, this._evaluator = new Te(), this._defaultValue = e4 ? function(t6) {
                return "color" === t6.type && Wr(t6.default) ? new ae(0, 0, 0, 0) : "color" === t6.type ? ae.parse(t6.default) || null : void 0 === t6.default ? null : t6.default;
              }(e4) : null, this._enumValues = e4 && "enum" === e4.type ? e4.values : null;
            };
            function nn(t5) {
              return Array.isArray(t5) && t5.length > 0 && "string" == typeof t5[0] && t5[0] in Fr;
            }
            function an(t5, e4) {
              var r4 = new Ye(Fr, [], e4 ? function(t6) {
                var e5 = { color: Gt, string: Ht, number: Vt, enum: Ht, boolean: qt, formatted: Xt, resolvedImage: Jt };
                return "array" === t6.type ? Kt(e5[t6.value] || Yt, t6.length) : e5[t6.type];
              }(e4) : void 0), n4 = r4.parse(t5, void 0, void 0, void 0, e4 && "string" === e4.type ? { typeAnnotation: "coerce" } : void 0);
              return n4 ? Vr(new rn(n4, e4)) : Hr(r4.errors);
            }
            rn.prototype.evaluateWithoutErrorHandling = function(t5, e4, r4, n4, i2, a2) {
              return this._evaluator.globals = t5, this._evaluator.feature = e4, this._evaluator.featureState = r4, this._evaluator.canonical = n4, this._evaluator.availableImages = i2 || null, this._evaluator.formattedSection = a2, this.expression.evaluate(this._evaluator);
            }, rn.prototype.evaluate = function(t5, e4, r4, n4, i2, a2) {
              this._evaluator.globals = t5, this._evaluator.feature = e4 || null, this._evaluator.featureState = r4 || null, this._evaluator.canonical = n4, this._evaluator.availableImages = i2 || null, this._evaluator.formattedSection = a2 || null;
              try {
                var o2 = this.expression.evaluate(this._evaluator);
                if (null == o2 || "number" == typeof o2 && o2 != o2)
                  return this._defaultValue;
                if (this._enumValues && !(o2 in this._enumValues))
                  throw new ve("Expected value to be one of " + Object.keys(this._enumValues).map(function(t6) {
                    return JSON.stringify(t6);
                  }).join(", ") + ", but found " + JSON.stringify(o2) + " instead.");
                return o2;
              } catch (t6) {
                return this._warningHistory[t6.message] || (this._warningHistory[t6.message] = true, "undefined" != typeof console && console.warn(t6.message)), this._defaultValue;
              }
            };
            var on = function(t5, e4) {
              this.kind = t5, this._styleExpression = e4, this.isStateDependent = "constant" !== t5 && !qe(e4.expression);
            };
            on.prototype.evaluateWithoutErrorHandling = function(t5, e4, r4, n4, i2, a2) {
              return this._styleExpression.evaluateWithoutErrorHandling(t5, e4, r4, n4, i2, a2);
            }, on.prototype.evaluate = function(t5, e4, r4, n4, i2, a2) {
              return this._styleExpression.evaluate(t5, e4, r4, n4, i2, a2);
            };
            var sn = function(t5, e4, r4, n4) {
              this.kind = t5, this.zoomStops = r4, this._styleExpression = e4, this.isStateDependent = "camera" !== t5 && !qe(e4.expression), this.interpolationType = n4;
            };
            function ln(t5, e4) {
              if ("error" === (t5 = an(t5, e4)).result)
                return t5;
              var r4 = t5.value.expression, n4 = He(r4);
              if (!n4 && !qr(e4))
                return Hr([new Nt("", "data expressions not supported")]);
              var i2 = Ge(r4, ["zoom"]);
              if (!i2 && !Gr(e4))
                return Hr([new Nt("", "zoom expressions not supported")]);
              var a2 = cn(r4);
              if (!a2 && !i2)
                return Hr([new Nt("", '"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.')]);
              if (a2 instanceof Nt)
                return Hr([a2]);
              if (a2 instanceof gr && !Zr(e4))
                return Hr([new Nt("", '"interpolate" expressions cannot be used with this property')]);
              if (!a2)
                return Vr(new on(n4 ? "constant" : "source", t5.value));
              var o2 = a2 instanceof gr ? a2.interpolation : void 0;
              return Vr(new sn(n4 ? "camera" : "composite", t5.value, a2.labels, o2));
            }
            sn.prototype.evaluateWithoutErrorHandling = function(t5, e4, r4, n4, i2, a2) {
              return this._styleExpression.evaluateWithoutErrorHandling(t5, e4, r4, n4, i2, a2);
            }, sn.prototype.evaluate = function(t5, e4, r4, n4, i2, a2) {
              return this._styleExpression.evaluate(t5, e4, r4, n4, i2, a2);
            }, sn.prototype.interpolationFactor = function(t5, e4, r4) {
              return this.interpolationType ? gr.interpolationFactor(this.interpolationType, t5, e4, r4) : 0;
            };
            var un = function(t5, e4) {
              this._parameters = t5, this._specification = e4, Rt(this, Jr(this._parameters, this._specification));
            };
            function cn(t5) {
              var e4 = null;
              if (t5 instanceof xr)
                e4 = cn(t5.result);
              else if (t5 instanceof mr)
                for (var r4 = 0, n4 = t5.args; r4 < n4.length; r4 += 1) {
                  var i2 = n4[r4];
                  if (e4 = cn(i2))
                    break;
                }
              else
                (t5 instanceof Je || t5 instanceof gr) && t5.input instanceof ke && "zoom" === t5.input.name && (e4 = t5);
              return e4 instanceof Nt || t5.eachChild(function(t6) {
                var r5 = cn(t6);
                r5 instanceof Nt ? e4 = r5 : !e4 && r5 ? e4 = new Nt("", '"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.') : e4 && r5 && e4 !== r5 && (e4 = new Nt("", 'Only one zoom-based "step" or "interpolate" subexpression may be used in an expression.'));
              }), e4;
            }
            function fn(t5) {
              var e4 = t5.key, r4 = t5.value, n4 = t5.valueSpec || {}, i2 = t5.objectElementValidators || {}, a2 = t5.style, o2 = t5.styleSpec, s2 = [], l2 = Yr(r4);
              if ("object" !== l2)
                return [new Dt(e4, r4, "object expected, " + l2 + " found")];
              for (var u2 in r4) {
                var c2 = u2.split(".")[0], f3 = n4[c2] || n4["*"], h2 = void 0;
                if (i2[c2])
                  h2 = i2[c2];
                else if (n4[c2])
                  h2 = Bn;
                else if (i2["*"])
                  h2 = i2["*"];
                else {
                  if (!n4["*"]) {
                    s2.push(new Dt(e4, r4[u2], 'unknown property "' + u2 + '"'));
                    continue;
                  }
                  h2 = Bn;
                }
                s2 = s2.concat(h2({ key: (e4 ? e4 + "." : e4) + u2, value: r4[u2], valueSpec: f3, style: a2, styleSpec: o2, object: r4, objectKey: u2 }, r4));
              }
              for (var p3 in n4)
                i2[p3] || n4[p3].required && void 0 === n4[p3].default && void 0 === r4[p3] && s2.push(new Dt(e4, r4, 'missing required property "' + p3 + '"'));
              return s2;
            }
            function hn(t5) {
              var e4 = t5.value, r4 = t5.valueSpec, n4 = t5.style, i2 = t5.styleSpec, a2 = t5.key, o2 = t5.arrayElementValidator || Bn;
              if ("array" !== Yr(e4))
                return [new Dt(a2, e4, "array expected, " + Yr(e4) + " found")];
              if (r4.length && e4.length !== r4.length)
                return [new Dt(a2, e4, "array length " + r4.length + " expected, length " + e4.length + " found")];
              if (r4["min-length"] && e4.length < r4["min-length"])
                return [new Dt(a2, e4, "array length at least " + r4["min-length"] + " expected, length " + e4.length + " found")];
              var s2 = { type: r4.value, values: r4.values };
              i2.$version < 7 && (s2.function = r4.function), "object" === Yr(r4.value) && (s2 = r4.value);
              for (var l2 = [], u2 = 0; u2 < e4.length; u2++)
                l2 = l2.concat(o2({ array: e4, arrayIndex: u2, value: e4[u2], valueSpec: s2, style: n4, styleSpec: i2, key: a2 + "[" + u2 + "]" }));
              return l2;
            }
            function pn(t5) {
              var e4 = t5.key, r4 = t5.value, n4 = t5.valueSpec, i2 = Yr(r4);
              return "number" === i2 && r4 != r4 && (i2 = "NaN"), "number" !== i2 ? [new Dt(e4, r4, "number expected, " + i2 + " found")] : "minimum" in n4 && r4 < n4.minimum ? [new Dt(e4, r4, r4 + " is less than the minimum value " + n4.minimum)] : "maximum" in n4 && r4 > n4.maximum ? [new Dt(e4, r4, r4 + " is greater than the maximum value " + n4.maximum)] : [];
            }
            function dn(t5) {
              var e4, r4, n4, i2 = t5.valueSpec, a2 = Ft(t5.value.type), o2 = {}, s2 = "categorical" !== a2 && void 0 === t5.value.property, l2 = !s2, u2 = "array" === Yr(t5.value.stops) && "array" === Yr(t5.value.stops[0]) && "object" === Yr(t5.value.stops[0][0]), c2 = fn({ key: t5.key, value: t5.value, valueSpec: t5.styleSpec.function, style: t5.style, styleSpec: t5.styleSpec, objectElementValidators: { stops: function(t6) {
                if ("identity" === a2)
                  return [new Dt(t6.key, t6.value, 'identity function may not have a "stops" property')];
                var e5 = [], r5 = t6.value;
                return e5 = e5.concat(hn({ key: t6.key, value: r5, valueSpec: t6.valueSpec, style: t6.style, styleSpec: t6.styleSpec, arrayElementValidator: f3 })), "array" === Yr(r5) && 0 === r5.length && e5.push(new Dt(t6.key, r5, "array must have at least one stop")), e5;
              }, default: function(t6) {
                return Bn({ key: t6.key, value: t6.value, valueSpec: i2, style: t6.style, styleSpec: t6.styleSpec });
              } } });
              return "identity" === a2 && s2 && c2.push(new Dt(t5.key, t5.value, 'missing required property "property"')), "identity" === a2 || t5.value.stops || c2.push(new Dt(t5.key, t5.value, 'missing required property "stops"')), "exponential" === a2 && t5.valueSpec.expression && !Zr(t5.valueSpec) && c2.push(new Dt(t5.key, t5.value, "exponential functions not supported")), t5.styleSpec.$version >= 8 && (l2 && !qr(t5.valueSpec) ? c2.push(new Dt(t5.key, t5.value, "property functions not supported")) : s2 && !Gr(t5.valueSpec) && c2.push(new Dt(t5.key, t5.value, "zoom functions not supported"))), "categorical" !== a2 && !u2 || void 0 !== t5.value.property || c2.push(new Dt(t5.key, t5.value, '"property" property is required')), c2;
              function f3(t6) {
                var e5 = [], a3 = t6.value, s3 = t6.key;
                if ("array" !== Yr(a3))
                  return [new Dt(s3, a3, "array expected, " + Yr(a3) + " found")];
                if (2 !== a3.length)
                  return [new Dt(s3, a3, "array length 2 expected, length " + a3.length + " found")];
                if (u2) {
                  if ("object" !== Yr(a3[0]))
                    return [new Dt(s3, a3, "object expected, " + Yr(a3[0]) + " found")];
                  if (void 0 === a3[0].zoom)
                    return [new Dt(s3, a3, "object stop key must have zoom")];
                  if (void 0 === a3[0].value)
                    return [new Dt(s3, a3, "object stop key must have value")];
                  if (n4 && n4 > Ft(a3[0].zoom))
                    return [new Dt(s3, a3[0].zoom, "stop zoom values must appear in ascending order")];
                  Ft(a3[0].zoom) !== n4 && (n4 = Ft(a3[0].zoom), r4 = void 0, o2 = {}), e5 = e5.concat(fn({ key: s3 + "[0]", value: a3[0], valueSpec: { zoom: {} }, style: t6.style, styleSpec: t6.styleSpec, objectElementValidators: { zoom: pn, value: h2 } }));
                } else
                  e5 = e5.concat(h2({ key: s3 + "[0]", value: a3[0], valueSpec: {}, style: t6.style, styleSpec: t6.styleSpec }, a3));
                return nn(Bt(a3[1])) ? e5.concat([new Dt(s3 + "[1]", a3[1], "expressions are not allowed in function stops.")]) : e5.concat(Bn({ key: s3 + "[1]", value: a3[1], valueSpec: i2, style: t6.style, styleSpec: t6.styleSpec }));
              }
              function h2(t6, n5) {
                var s3 = Yr(t6.value), l3 = Ft(t6.value), u3 = null !== t6.value ? t6.value : n5;
                if (e4) {
                  if (s3 !== e4)
                    return [new Dt(t6.key, u3, s3 + " stop domain type must match previous stop domain type " + e4)];
                } else
                  e4 = s3;
                if ("number" !== s3 && "string" !== s3 && "boolean" !== s3)
                  return [new Dt(t6.key, u3, "stop domain value must be a number, string, or boolean")];
                if ("number" !== s3 && "categorical" !== a2) {
                  var c3 = "number expected, " + s3 + " found";
                  return qr(i2) && void 0 === a2 && (c3 += '\nIf you intended to use a categorical function, specify `"type": "categorical"`.'), [new Dt(t6.key, u3, c3)];
                }
                return "categorical" !== a2 || "number" !== s3 || isFinite(l3) && Math.floor(l3) === l3 ? "categorical" !== a2 && "number" === s3 && void 0 !== r4 && l3 < r4 ? [new Dt(t6.key, u3, "stop domain values must appear in ascending order")] : (r4 = l3, "categorical" === a2 && l3 in o2 ? [new Dt(t6.key, u3, "stop domain values must be unique")] : (o2[l3] = true, [])) : [new Dt(t6.key, u3, "integer expected, found " + l3)];
              }
            }
            function vn(t5) {
              var e4 = ("property" === t5.expressionContext ? ln : an)(Bt(t5.value), t5.valueSpec);
              if ("error" === e4.result)
                return e4.value.map(function(e5) {
                  return new Dt("" + t5.key + e5.key, t5.value, e5.message);
                });
              var r4 = e4.value.expression || e4.value._styleExpression.expression;
              if ("property" === t5.expressionContext && "text-font" === t5.propertyKey && !r4.outputDefined())
                return [new Dt(t5.key, t5.value, 'Invalid data expression for "' + t5.propertyKey + '". Output values must be contained as literals within the expression.')];
              if ("property" === t5.expressionContext && "layout" === t5.propertyType && !qe(r4))
                return [new Dt(t5.key, t5.value, '"feature-state" data expressions are not supported with layout properties.')];
              if ("filter" === t5.expressionContext && !qe(r4))
                return [new Dt(t5.key, t5.value, '"feature-state" data expressions are not supported with filters.')];
              if (t5.expressionContext && 0 === t5.expressionContext.indexOf("cluster")) {
                if (!Ge(r4, ["zoom", "feature-state"]))
                  return [new Dt(t5.key, t5.value, '"zoom" and "feature-state" expressions are not supported with cluster properties.')];
                if ("cluster-initial" === t5.expressionContext && !He(r4))
                  return [new Dt(t5.key, t5.value, "Feature data expressions are not supported with initial expression part of cluster properties.")];
              }
              return [];
            }
            function gn(t5) {
              var e4 = t5.key, r4 = t5.value, n4 = t5.valueSpec, i2 = [];
              return Array.isArray(n4.values) ? -1 === n4.values.indexOf(Ft(r4)) && i2.push(new Dt(e4, r4, "expected one of [" + n4.values.join(", ") + "], " + JSON.stringify(r4) + " found")) : -1 === Object.keys(n4.values).indexOf(Ft(r4)) && i2.push(new Dt(e4, r4, "expected one of [" + Object.keys(n4.values).join(", ") + "], " + JSON.stringify(r4) + " found")), i2;
            }
            function yn(t5) {
              if (true === t5 || false === t5)
                return true;
              if (!Array.isArray(t5) || 0 === t5.length)
                return false;
              switch (t5[0]) {
                case "has":
                  return t5.length >= 2 && "$id" !== t5[1] && "$type" !== t5[1];
                case "in":
                  return t5.length >= 3 && ("string" != typeof t5[1] || Array.isArray(t5[2]));
                case "!in":
                case "!has":
                case "none":
                  return false;
                case "==":
                case "!=":
                case ">":
                case ">=":
                case "<":
                case "<=":
                  return 3 !== t5.length || Array.isArray(t5[1]) || Array.isArray(t5[2]);
                case "any":
                case "all":
                  for (var e4 = 0, r4 = t5.slice(1); e4 < r4.length; e4 += 1) {
                    var n4 = r4[e4];
                    if (!yn(n4) && "boolean" != typeof n4)
                      return false;
                  }
                  return true;
                default:
                  return true;
              }
            }
            un.deserialize = function(t5) {
              return new un(t5._parameters, t5._specification);
            }, un.serialize = function(t5) {
              return { _parameters: t5._parameters, _specification: t5._specification };
            };
            var mn = { type: "boolean", default: false, transition: false, "property-type": "data-driven", expression: { interpolated: false, parameters: ["zoom", "feature"] } };
            function xn(t5) {
              if (null == t5)
                return { filter: function() {
                  return true;
                }, needGeometry: false };
              yn(t5) || (t5 = wn(t5));
              var e4 = an(t5, mn);
              if ("error" === e4.result)
                throw new Error(e4.value.map(function(t6) {
                  return t6.key + ": " + t6.message;
                }).join(", "));
              return { filter: function(t6, r4, n4) {
                return e4.value.evaluate(t6, r4, {}, n4);
              }, needGeometry: _n(t5) };
            }
            function bn(t5, e4) {
              return t5 < e4 ? -1 : t5 > e4 ? 1 : 0;
            }
            function _n(t5) {
              if (!Array.isArray(t5))
                return false;
              if ("within" === t5[0])
                return true;
              for (var e4 = 1; e4 < t5.length; e4++)
                if (_n(t5[e4]))
                  return true;
              return false;
            }
            function wn(t5) {
              if (!t5)
                return true;
              var e4, r4 = t5[0];
              return t5.length <= 1 ? "any" !== r4 : "==" === r4 ? Tn(t5[1], t5[2], "==") : "!=" === r4 ? Mn(Tn(t5[1], t5[2], "==")) : "<" === r4 || ">" === r4 || "<=" === r4 || ">=" === r4 ? Tn(t5[1], t5[2], r4) : "any" === r4 ? (e4 = t5.slice(1), ["any"].concat(e4.map(wn))) : "all" === r4 ? ["all"].concat(t5.slice(1).map(wn)) : "none" === r4 ? ["all"].concat(t5.slice(1).map(wn).map(Mn)) : "in" === r4 ? kn(t5[1], t5.slice(2)) : "!in" === r4 ? Mn(kn(t5[1], t5.slice(2))) : "has" === r4 ? An(t5[1]) : "!has" === r4 ? Mn(An(t5[1])) : "within" !== r4 || t5;
            }
            function Tn(t5, e4, r4) {
              switch (t5) {
                case "$type":
                  return ["filter-type-" + r4, e4];
                case "$id":
                  return ["filter-id-" + r4, e4];
                default:
                  return ["filter-" + r4, t5, e4];
              }
            }
            function kn(t5, e4) {
              if (0 === e4.length)
                return false;
              switch (t5) {
                case "$type":
                  return ["filter-type-in", ["literal", e4]];
                case "$id":
                  return ["filter-id-in", ["literal", e4]];
                default:
                  return e4.length > 200 && !e4.some(function(t6) {
                    return typeof t6 != typeof e4[0];
                  }) ? ["filter-in-large", t5, ["literal", e4.sort(bn)]] : ["filter-in-small", t5, ["literal", e4]];
              }
            }
            function An(t5) {
              switch (t5) {
                case "$type":
                  return true;
                case "$id":
                  return ["filter-has-id"];
                default:
                  return ["filter-has", t5];
              }
            }
            function Mn(t5) {
              return ["!", t5];
            }
            function Sn(t5) {
              return yn(Bt(t5.value)) ? vn(Rt({}, t5, { expressionContext: "filter", valueSpec: { value: "boolean" } })) : En(t5);
            }
            function En(t5) {
              var e4 = t5.value, r4 = t5.key;
              if ("array" !== Yr(e4))
                return [new Dt(r4, e4, "array expected, " + Yr(e4) + " found")];
              var n4, i2 = t5.styleSpec, a2 = [];
              if (e4.length < 1)
                return [new Dt(r4, e4, "filter array must have at least 1 element")];
              switch (a2 = a2.concat(gn({ key: r4 + "[0]", value: e4[0], valueSpec: i2.filter_operator, style: t5.style, styleSpec: t5.styleSpec })), Ft(e4[0])) {
                case "<":
                case "<=":
                case ">":
                case ">=":
                  e4.length >= 2 && "$type" === Ft(e4[1]) && a2.push(new Dt(r4, e4, '"$type" cannot be use with operator "' + e4[0] + '"'));
                case "==":
                case "!=":
                  3 !== e4.length && a2.push(new Dt(r4, e4, 'filter array for operator "' + e4[0] + '" must have 3 elements'));
                case "in":
                case "!in":
                  e4.length >= 2 && "string" !== (n4 = Yr(e4[1])) && a2.push(new Dt(r4 + "[1]", e4[1], "string expected, " + n4 + " found"));
                  for (var o2 = 2; o2 < e4.length; o2++)
                    n4 = Yr(e4[o2]), "$type" === Ft(e4[1]) ? a2 = a2.concat(gn({ key: r4 + "[" + o2 + "]", value: e4[o2], valueSpec: i2.geometry_type, style: t5.style, styleSpec: t5.styleSpec })) : "string" !== n4 && "number" !== n4 && "boolean" !== n4 && a2.push(new Dt(r4 + "[" + o2 + "]", e4[o2], "string, number, or boolean expected, " + n4 + " found"));
                  break;
                case "any":
                case "all":
                case "none":
                  for (var s2 = 1; s2 < e4.length; s2++)
                    a2 = a2.concat(En({ key: r4 + "[" + s2 + "]", value: e4[s2], style: t5.style, styleSpec: t5.styleSpec }));
                  break;
                case "has":
                case "!has":
                  n4 = Yr(e4[1]), 2 !== e4.length ? a2.push(new Dt(r4, e4, 'filter array for "' + e4[0] + '" operator must have 2 elements')) : "string" !== n4 && a2.push(new Dt(r4 + "[1]", e4[1], "string expected, " + n4 + " found"));
                  break;
                case "within":
                  n4 = Yr(e4[1]), 2 !== e4.length ? a2.push(new Dt(r4, e4, 'filter array for "' + e4[0] + '" operator must have 2 elements')) : "object" !== n4 && a2.push(new Dt(r4 + "[1]", e4[1], "object expected, " + n4 + " found"));
              }
              return a2;
            }
            function Ln(t5, e4) {
              var r4 = t5.key, n4 = t5.style, i2 = t5.styleSpec, a2 = t5.value, o2 = t5.objectKey, s2 = i2[e4 + "_" + t5.layerType];
              if (!s2)
                return [];
              var l2 = o2.match(/^(.*)-transition$/);
              if ("paint" === e4 && l2 && s2[l2[1]] && s2[l2[1]].transition)
                return Bn({ key: r4, value: a2, valueSpec: i2.transition, style: n4, styleSpec: i2 });
              var u2, c2 = t5.valueSpec || s2[o2];
              if (!c2)
                return [new Dt(r4, a2, 'unknown property "' + o2 + '"')];
              if ("string" === Yr(a2) && qr(c2) && !c2.tokens && (u2 = /^{([^}]+)}$/.exec(a2)))
                return [new Dt(r4, a2, '"' + o2 + '" does not support interpolation syntax\nUse an identity property function instead: `{ "type": "identity", "property": ' + JSON.stringify(u2[1]) + " }`.")];
              var f3 = [];
              return "symbol" === t5.layerType && ("text-field" === o2 && n4 && !n4.glyphs && f3.push(new Dt(r4, a2, 'use of "text-field" requires a style "glyphs" property')), "text-font" === o2 && Wr(Bt(a2)) && "identity" === Ft(a2.type) && f3.push(new Dt(r4, a2, '"text-font" does not support identity functions'))), f3.concat(Bn({ key: t5.key, value: a2, valueSpec: c2, style: n4, styleSpec: i2, expressionContext: "property", propertyType: e4, propertyKey: o2 }));
            }
            function Cn(t5) {
              return Ln(t5, "paint");
            }
            function Pn(t5) {
              return Ln(t5, "layout");
            }
            function On(t5) {
              var e4 = [], r4 = t5.value, n4 = t5.key, i2 = t5.style, a2 = t5.styleSpec;
              r4.type || r4.ref || e4.push(new Dt(n4, r4, 'either "type" or "ref" is required'));
              var o2, s2 = Ft(r4.type), l2 = Ft(r4.ref);
              if (r4.id)
                for (var u2 = Ft(r4.id), c2 = 0; c2 < t5.arrayIndex; c2++) {
                  var f3 = i2.layers[c2];
                  Ft(f3.id) === u2 && e4.push(new Dt(n4, r4.id, 'duplicate layer id "' + r4.id + '", previously used at line ' + f3.id.__line__));
                }
              if ("ref" in r4)
                ["type", "source", "source-layer", "filter", "layout"].forEach(function(t6) {
                  t6 in r4 && e4.push(new Dt(n4, r4[t6], '"' + t6 + '" is prohibited for ref layers'));
                }), i2.layers.forEach(function(t6) {
                  Ft(t6.id) === l2 && (o2 = t6);
                }), o2 ? o2.ref ? e4.push(new Dt(n4, r4.ref, "ref cannot reference another ref layer")) : s2 = Ft(o2.type) : e4.push(new Dt(n4, r4.ref, 'ref layer "' + l2 + '" not found'));
              else if ("background" !== s2)
                if (r4.source) {
                  var h2 = i2.sources && i2.sources[r4.source], p3 = h2 && Ft(h2.type);
                  h2 ? "vector" === p3 && "raster" === s2 ? e4.push(new Dt(n4, r4.source, 'layer "' + r4.id + '" requires a raster source')) : "raster" === p3 && "raster" !== s2 ? e4.push(new Dt(n4, r4.source, 'layer "' + r4.id + '" requires a vector source')) : "vector" !== p3 || r4["source-layer"] ? "raster-dem" === p3 && "hillshade" !== s2 ? e4.push(new Dt(n4, r4.source, "raster-dem source can only be used with layer type 'hillshade'.")) : "line" !== s2 || !r4.paint || !r4.paint["line-gradient"] || "geojson" === p3 && h2.lineMetrics || e4.push(new Dt(n4, r4, 'layer "' + r4.id + '" specifies a line-gradient, which requires a GeoJSON source with `lineMetrics` enabled.')) : e4.push(new Dt(n4, r4, 'layer "' + r4.id + '" must specify a "source-layer"')) : e4.push(new Dt(n4, r4.source, 'source "' + r4.source + '" not found'));
                } else
                  e4.push(new Dt(n4, r4, 'missing required property "source"'));
              return e4 = e4.concat(fn({ key: n4, value: r4, valueSpec: a2.layer, style: t5.style, styleSpec: t5.styleSpec, objectElementValidators: { "*": function() {
                return [];
              }, type: function() {
                return Bn({ key: n4 + ".type", value: r4.type, valueSpec: a2.layer.type, style: t5.style, styleSpec: t5.styleSpec, object: r4, objectKey: "type" });
              }, filter: Sn, layout: function(t6) {
                return fn({ layer: r4, key: t6.key, value: t6.value, style: t6.style, styleSpec: t6.styleSpec, objectElementValidators: { "*": function(t7) {
                  return Pn(Rt({ layerType: s2 }, t7));
                } } });
              }, paint: function(t6) {
                return fn({ layer: r4, key: t6.key, value: t6.value, style: t6.style, styleSpec: t6.styleSpec, objectElementValidators: { "*": function(t7) {
                  return Cn(Rt({ layerType: s2 }, t7));
                } } });
              } } })), e4;
            }
            function In(t5) {
              var e4 = t5.value, r4 = t5.key, n4 = Yr(e4);
              return "string" !== n4 ? [new Dt(r4, e4, "string expected, " + n4 + " found")] : [];
            }
            var Dn = { promoteId: function(t5) {
              var e4 = t5.key, r4 = t5.value;
              if ("string" === Yr(r4))
                return In({ key: e4, value: r4 });
              var n4 = [];
              for (var i2 in r4)
                n4.push.apply(n4, In({ key: e4 + "." + i2, value: r4[i2] }));
              return n4;
            } };
            function zn(t5) {
              var e4 = t5.value, r4 = t5.key, n4 = t5.styleSpec, i2 = t5.style;
              if (!e4.type)
                return [new Dt(r4, e4, '"type" is required')];
              var a2, o2 = Ft(e4.type);
              switch (o2) {
                case "vector":
                case "raster":
                case "raster-dem":
                  return fn({ key: r4, value: e4, valueSpec: n4["source_" + o2.replace("-", "_")], style: t5.style, styleSpec: n4, objectElementValidators: Dn });
                case "geojson":
                  if (a2 = fn({ key: r4, value: e4, valueSpec: n4.source_geojson, style: i2, styleSpec: n4, objectElementValidators: Dn }), e4.cluster)
                    for (var s2 in e4.clusterProperties) {
                      var l2 = e4.clusterProperties[s2], u2 = l2[0], c2 = l2[1], f3 = "string" == typeof u2 ? [u2, ["accumulated"], ["get", s2]] : u2;
                      a2.push.apply(a2, vn({ key: r4 + "." + s2 + ".map", value: c2, expressionContext: "cluster-map" })), a2.push.apply(a2, vn({ key: r4 + "." + s2 + ".reduce", value: f3, expressionContext: "cluster-reduce" }));
                    }
                  return a2;
                case "video":
                  return fn({ key: r4, value: e4, valueSpec: n4.source_video, style: i2, styleSpec: n4 });
                case "image":
                  return fn({ key: r4, value: e4, valueSpec: n4.source_image, style: i2, styleSpec: n4 });
                case "canvas":
                  return [new Dt(r4, null, "Please use runtime APIs to add canvas sources, rather than including them in stylesheets.", "source.canvas")];
                default:
                  return gn({ key: r4 + ".type", value: e4.type, valueSpec: { values: ["vector", "raster", "raster-dem", "geojson", "video", "image"] }, style: i2, styleSpec: n4 });
              }
            }
            function Rn(t5) {
              var e4 = t5.value, r4 = t5.styleSpec, n4 = r4.light, i2 = t5.style, a2 = [], o2 = Yr(e4);
              if (void 0 === e4)
                return a2;
              if ("object" !== o2)
                return a2.concat([new Dt("light", e4, "object expected, " + o2 + " found")]);
              for (var s2 in e4) {
                var l2 = s2.match(/^(.*)-transition$/);
                a2 = l2 && n4[l2[1]] && n4[l2[1]].transition ? a2.concat(Bn({ key: s2, value: e4[s2], valueSpec: r4.transition, style: i2, styleSpec: r4 })) : n4[s2] ? a2.concat(Bn({ key: s2, value: e4[s2], valueSpec: n4[s2], style: i2, styleSpec: r4 })) : a2.concat([new Dt(s2, e4[s2], 'unknown property "' + s2 + '"')]);
              }
              return a2;
            }
            var Fn = { "*": function() {
              return [];
            }, array: hn, boolean: function(t5) {
              var e4 = t5.value, r4 = t5.key, n4 = Yr(e4);
              return "boolean" !== n4 ? [new Dt(r4, e4, "boolean expected, " + n4 + " found")] : [];
            }, number: pn, color: function(t5) {
              var e4 = t5.key, r4 = t5.value, n4 = Yr(r4);
              return "string" !== n4 ? [new Dt(e4, r4, "color expected, " + n4 + " found")] : null === ie(r4) ? [new Dt(e4, r4, 'color expected, "' + r4 + '" found')] : [];
            }, constants: zt, enum: gn, filter: Sn, function: dn, layer: On, object: fn, source: zn, light: Rn, string: In, formatted: function(t5) {
              return 0 === In(t5).length ? [] : vn(t5);
            }, resolvedImage: function(t5) {
              return 0 === In(t5).length ? [] : vn(t5);
            } };
            function Bn(t5) {
              var e4 = t5.value, r4 = t5.valueSpec, n4 = t5.styleSpec;
              return r4.expression && Wr(Ft(e4)) ? dn(t5) : r4.expression && nn(Bt(e4)) ? vn(t5) : r4.type && Fn[r4.type] ? Fn[r4.type](t5) : fn(Rt({}, t5, { valueSpec: r4.type ? n4[r4.type] : r4 }));
            }
            function Nn(t5) {
              var e4 = t5.value, r4 = t5.key, n4 = In(t5);
              return n4.length || (-1 === e4.indexOf("{fontstack}") && n4.push(new Dt(r4, e4, '"glyphs" url must include a "{fontstack}" token')), -1 === e4.indexOf("{range}") && n4.push(new Dt(r4, e4, '"glyphs" url must include a "{range}" token'))), n4;
            }
            function jn(t5, e4) {
              void 0 === e4 && (e4 = It);
              var r4 = [];
              return r4 = r4.concat(Bn({ key: "", value: t5, valueSpec: e4.$root, styleSpec: e4, style: t5, objectElementValidators: { glyphs: Nn, "*": function() {
                return [];
              } } })), t5.constants && (r4 = r4.concat(zt({ key: "constants", value: t5.constants, style: t5, styleSpec: e4 }))), Un(r4);
            }
            function Un(t5) {
              return [].concat(t5).sort(function(t6, e4) {
                return t6.line - e4.line;
              });
            }
            function Vn(t5) {
              return function() {
                for (var e4 = [], r4 = arguments.length; r4--; )
                  e4[r4] = arguments[r4];
                return Un(t5.apply(this, e4));
              };
            }
            jn.source = Vn(zn), jn.light = Vn(Rn), jn.layer = Vn(On), jn.filter = Vn(Sn), jn.paintProperty = Vn(Cn), jn.layoutProperty = Vn(Pn);
            var Hn = jn, qn = Hn.light, Gn = Hn.paintProperty, Zn = Hn.layoutProperty;
            function Yn(t5, e4) {
              var r4 = false;
              if (e4 && e4.length)
                for (var n4 = 0, i2 = e4; n4 < i2.length; n4 += 1) {
                  var a2 = i2[n4];
                  t5.fire(new Pt(new Error(a2.message))), r4 = true;
                }
              return r4;
            }
            var Wn = Xn;
            function Xn(t5, e4, r4) {
              var n4 = this.cells = [];
              if (t5 instanceof ArrayBuffer) {
                this.arrayBuffer = t5;
                var i2 = new Int32Array(this.arrayBuffer);
                t5 = i2[0], e4 = i2[1], r4 = i2[2], this.d = e4 + 2 * r4;
                for (var a2 = 0; a2 < this.d * this.d; a2++) {
                  var o2 = i2[3 + a2], s2 = i2[3 + a2 + 1];
                  n4.push(o2 === s2 ? null : i2.subarray(o2, s2));
                }
                var l2 = i2[3 + n4.length], u2 = i2[3 + n4.length + 1];
                this.keys = i2.subarray(l2, u2), this.bboxes = i2.subarray(u2), this.insert = this._insertReadonly;
              } else {
                this.d = e4 + 2 * r4;
                for (var c2 = 0; c2 < this.d * this.d; c2++)
                  n4.push([]);
                this.keys = [], this.bboxes = [];
              }
              this.n = e4, this.extent = t5, this.padding = r4, this.scale = e4 / t5, this.uid = 0;
              var f3 = r4 / e4 * t5;
              this.min = -f3, this.max = t5 + f3;
            }
            Xn.prototype.insert = function(t5, e4, r4, n4, i2) {
              this._forEachCell(e4, r4, n4, i2, this._insertCell, this.uid++), this.keys.push(t5), this.bboxes.push(e4), this.bboxes.push(r4), this.bboxes.push(n4), this.bboxes.push(i2);
            }, Xn.prototype._insertReadonly = function() {
              throw "Cannot insert into a GridIndex created from an ArrayBuffer.";
            }, Xn.prototype._insertCell = function(t5, e4, r4, n4, i2, a2) {
              this.cells[i2].push(a2);
            }, Xn.prototype.query = function(t5, e4, r4, n4, i2) {
              var a2 = this.min, o2 = this.max;
              if (t5 <= a2 && e4 <= a2 && o2 <= r4 && o2 <= n4 && !i2)
                return Array.prototype.slice.call(this.keys);
              var s2 = [];
              return this._forEachCell(t5, e4, r4, n4, this._queryCell, s2, {}, i2), s2;
            }, Xn.prototype._queryCell = function(t5, e4, r4, n4, i2, a2, o2, s2) {
              var l2 = this.cells[i2];
              if (null !== l2)
                for (var u2 = this.keys, c2 = this.bboxes, f3 = 0; f3 < l2.length; f3++) {
                  var h2 = l2[f3];
                  if (void 0 === o2[h2]) {
                    var p3 = 4 * h2;
                    (s2 ? s2(c2[p3 + 0], c2[p3 + 1], c2[p3 + 2], c2[p3 + 3]) : t5 <= c2[p3 + 2] && e4 <= c2[p3 + 3] && r4 >= c2[p3 + 0] && n4 >= c2[p3 + 1]) ? (o2[h2] = true, a2.push(u2[h2])) : o2[h2] = false;
                  }
                }
            }, Xn.prototype._forEachCell = function(t5, e4, r4, n4, i2, a2, o2, s2) {
              for (var l2 = this._convertToCellCoord(t5), u2 = this._convertToCellCoord(e4), c2 = this._convertToCellCoord(r4), f3 = this._convertToCellCoord(n4), h2 = l2; h2 <= c2; h2++)
                for (var p3 = u2; p3 <= f3; p3++) {
                  var d3 = this.d * p3 + h2;
                  if ((!s2 || s2(this._convertFromCellCoord(h2), this._convertFromCellCoord(p3), this._convertFromCellCoord(h2 + 1), this._convertFromCellCoord(p3 + 1))) && i2.call(this, t5, e4, r4, n4, d3, a2, o2, s2))
                    return;
                }
            }, Xn.prototype._convertFromCellCoord = function(t5) {
              return (t5 - this.padding) / this.scale;
            }, Xn.prototype._convertToCellCoord = function(t5) {
              return Math.max(0, Math.min(this.d - 1, Math.floor(t5 * this.scale) + this.padding));
            }, Xn.prototype.toArrayBuffer = function() {
              if (this.arrayBuffer)
                return this.arrayBuffer;
              for (var t5 = this.cells, e4 = 3 + this.cells.length + 1 + 1, r4 = 0, n4 = 0; n4 < this.cells.length; n4++)
                r4 += this.cells[n4].length;
              var i2 = new Int32Array(e4 + r4 + this.keys.length + this.bboxes.length);
              i2[0] = this.extent, i2[1] = this.n, i2[2] = this.padding;
              for (var a2 = e4, o2 = 0; o2 < t5.length; o2++) {
                var s2 = t5[o2];
                i2[3 + o2] = a2, i2.set(s2, a2), a2 += s2.length;
              }
              return i2[3 + t5.length] = a2, i2.set(this.keys, a2), a2 += this.keys.length, i2[3 + t5.length + 1] = a2, i2.set(this.bboxes, a2), a2 += this.bboxes.length, i2.buffer;
            };
            var Jn = self.ImageData, Kn = self.ImageBitmap, $n = {};
            function Qn(t5, e4, r4) {
              void 0 === r4 && (r4 = {}), Object.defineProperty(e4, "_classRegistryKey", { value: t5, writeable: false }), $n[t5] = { klass: e4, omit: r4.omit || [], shallow: r4.shallow || [] };
            }
            for (var ti in Qn("Object", Object), Wn.serialize = function(t5, e4) {
              var r4 = t5.toArrayBuffer();
              return e4 && e4.push(r4), { buffer: r4 };
            }, Wn.deserialize = function(t5) {
              return new Wn(t5.buffer);
            }, Qn("Grid", Wn), Qn("Color", ae), Qn("Error", Error), Qn("ResolvedImage", ue), Qn("StylePropertyFunction", un), Qn("StyleExpression", rn, { omit: ["_evaluator"] }), Qn("ZoomDependentExpression", sn), Qn("ZoomConstantExpression", on), Qn("CompoundExpression", ke, { omit: ["_evaluate"] }), Fr)
              Fr[ti]._classRegistryKey || Qn("Expression_" + ti, Fr[ti]);
            function ei(t5) {
              return t5 && "undefined" != typeof ArrayBuffer && (t5 instanceof ArrayBuffer || t5.constructor && "ArrayBuffer" === t5.constructor.name);
            }
            function ri(t5) {
              return Kn && t5 instanceof Kn;
            }
            function ni(t5, e4) {
              if (null == t5 || "boolean" == typeof t5 || "number" == typeof t5 || "string" == typeof t5 || t5 instanceof Boolean || t5 instanceof Number || t5 instanceof String || t5 instanceof Date || t5 instanceof RegExp)
                return t5;
              if (ei(t5) || ri(t5))
                return e4 && e4.push(t5), t5;
              if (ArrayBuffer.isView(t5)) {
                var r4 = t5;
                return e4 && e4.push(r4.buffer), r4;
              }
              if (t5 instanceof Jn)
                return e4 && e4.push(t5.data.buffer), t5;
              if (Array.isArray(t5)) {
                for (var n4 = [], i2 = 0, a2 = t5; i2 < a2.length; i2 += 1) {
                  var o2 = a2[i2];
                  n4.push(ni(o2, e4));
                }
                return n4;
              }
              if ("object" == typeof t5) {
                var s2 = t5.constructor, l2 = s2._classRegistryKey;
                if (!l2)
                  throw new Error("can't serialize object of unregistered class");
                var u2 = s2.serialize ? s2.serialize(t5, e4) : {};
                if (!s2.serialize) {
                  for (var c2 in t5)
                    if (t5.hasOwnProperty(c2) && !($n[l2].omit.indexOf(c2) >= 0)) {
                      var f3 = t5[c2];
                      u2[c2] = $n[l2].shallow.indexOf(c2) >= 0 ? f3 : ni(f3, e4);
                    }
                  t5 instanceof Error && (u2.message = t5.message);
                }
                if (u2.$name)
                  throw new Error("$name property is reserved for worker serialization logic.");
                return "Object" !== l2 && (u2.$name = l2), u2;
              }
              throw new Error("can't serialize object of type " + typeof t5);
            }
            function ii(t5) {
              if (null == t5 || "boolean" == typeof t5 || "number" == typeof t5 || "string" == typeof t5 || t5 instanceof Boolean || t5 instanceof Number || t5 instanceof String || t5 instanceof Date || t5 instanceof RegExp || ei(t5) || ri(t5) || ArrayBuffer.isView(t5) || t5 instanceof Jn)
                return t5;
              if (Array.isArray(t5))
                return t5.map(ii);
              if ("object" == typeof t5) {
                var e4 = t5.$name || "Object", r4 = $n[e4].klass;
                if (!r4)
                  throw new Error("can't deserialize unregistered class " + e4);
                if (r4.deserialize)
                  return r4.deserialize(t5);
                for (var n4 = Object.create(r4.prototype), i2 = 0, a2 = Object.keys(t5); i2 < a2.length; i2 += 1) {
                  var o2 = a2[i2];
                  if ("$name" !== o2) {
                    var s2 = t5[o2];
                    n4[o2] = $n[e4].shallow.indexOf(o2) >= 0 ? s2 : ii(s2);
                  }
                }
                return n4;
              }
              throw new Error("can't deserialize object of type " + typeof t5);
            }
            var ai = function() {
              this.first = true;
            };
            ai.prototype.update = function(t5, e4) {
              var r4 = Math.floor(t5);
              return this.first ? (this.first = false, this.lastIntegerZoom = r4, this.lastIntegerZoomTime = 0, this.lastZoom = t5, this.lastFloorZoom = r4, true) : (this.lastFloorZoom > r4 ? (this.lastIntegerZoom = r4 + 1, this.lastIntegerZoomTime = e4) : this.lastFloorZoom < r4 && (this.lastIntegerZoom = r4, this.lastIntegerZoomTime = e4), t5 !== this.lastZoom && (this.lastZoom = t5, this.lastFloorZoom = r4, true));
            };
            var oi = { "Latin-1 Supplement": function(t5) {
              return t5 >= 128 && t5 <= 255;
            }, Arabic: function(t5) {
              return t5 >= 1536 && t5 <= 1791;
            }, "Arabic Supplement": function(t5) {
              return t5 >= 1872 && t5 <= 1919;
            }, "Arabic Extended-A": function(t5) {
              return t5 >= 2208 && t5 <= 2303;
            }, "Hangul Jamo": function(t5) {
              return t5 >= 4352 && t5 <= 4607;
            }, "Unified Canadian Aboriginal Syllabics": function(t5) {
              return t5 >= 5120 && t5 <= 5759;
            }, Khmer: function(t5) {
              return t5 >= 6016 && t5 <= 6143;
            }, "Unified Canadian Aboriginal Syllabics Extended": function(t5) {
              return t5 >= 6320 && t5 <= 6399;
            }, "General Punctuation": function(t5) {
              return t5 >= 8192 && t5 <= 8303;
            }, "Letterlike Symbols": function(t5) {
              return t5 >= 8448 && t5 <= 8527;
            }, "Number Forms": function(t5) {
              return t5 >= 8528 && t5 <= 8591;
            }, "Miscellaneous Technical": function(t5) {
              return t5 >= 8960 && t5 <= 9215;
            }, "Control Pictures": function(t5) {
              return t5 >= 9216 && t5 <= 9279;
            }, "Optical Character Recognition": function(t5) {
              return t5 >= 9280 && t5 <= 9311;
            }, "Enclosed Alphanumerics": function(t5) {
              return t5 >= 9312 && t5 <= 9471;
            }, "Geometric Shapes": function(t5) {
              return t5 >= 9632 && t5 <= 9727;
            }, "Miscellaneous Symbols": function(t5) {
              return t5 >= 9728 && t5 <= 9983;
            }, "Miscellaneous Symbols and Arrows": function(t5) {
              return t5 >= 11008 && t5 <= 11263;
            }, "CJK Radicals Supplement": function(t5) {
              return t5 >= 11904 && t5 <= 12031;
            }, "Kangxi Radicals": function(t5) {
              return t5 >= 12032 && t5 <= 12255;
            }, "Ideographic Description Characters": function(t5) {
              return t5 >= 12272 && t5 <= 12287;
            }, "CJK Symbols and Punctuation": function(t5) {
              return t5 >= 12288 && t5 <= 12351;
            }, Hiragana: function(t5) {
              return t5 >= 12352 && t5 <= 12447;
            }, Katakana: function(t5) {
              return t5 >= 12448 && t5 <= 12543;
            }, Bopomofo: function(t5) {
              return t5 >= 12544 && t5 <= 12591;
            }, "Hangul Compatibility Jamo": function(t5) {
              return t5 >= 12592 && t5 <= 12687;
            }, Kanbun: function(t5) {
              return t5 >= 12688 && t5 <= 12703;
            }, "Bopomofo Extended": function(t5) {
              return t5 >= 12704 && t5 <= 12735;
            }, "CJK Strokes": function(t5) {
              return t5 >= 12736 && t5 <= 12783;
            }, "Katakana Phonetic Extensions": function(t5) {
              return t5 >= 12784 && t5 <= 12799;
            }, "Enclosed CJK Letters and Months": function(t5) {
              return t5 >= 12800 && t5 <= 13055;
            }, "CJK Compatibility": function(t5) {
              return t5 >= 13056 && t5 <= 13311;
            }, "CJK Unified Ideographs Extension A": function(t5) {
              return t5 >= 13312 && t5 <= 19903;
            }, "Yijing Hexagram Symbols": function(t5) {
              return t5 >= 19904 && t5 <= 19967;
            }, "CJK Unified Ideographs": function(t5) {
              return t5 >= 19968 && t5 <= 40959;
            }, "Yi Syllables": function(t5) {
              return t5 >= 40960 && t5 <= 42127;
            }, "Yi Radicals": function(t5) {
              return t5 >= 42128 && t5 <= 42191;
            }, "Hangul Jamo Extended-A": function(t5) {
              return t5 >= 43360 && t5 <= 43391;
            }, "Hangul Syllables": function(t5) {
              return t5 >= 44032 && t5 <= 55215;
            }, "Hangul Jamo Extended-B": function(t5) {
              return t5 >= 55216 && t5 <= 55295;
            }, "Private Use Area": function(t5) {
              return t5 >= 57344 && t5 <= 63743;
            }, "CJK Compatibility Ideographs": function(t5) {
              return t5 >= 63744 && t5 <= 64255;
            }, "Arabic Presentation Forms-A": function(t5) {
              return t5 >= 64336 && t5 <= 65023;
            }, "Vertical Forms": function(t5) {
              return t5 >= 65040 && t5 <= 65055;
            }, "CJK Compatibility Forms": function(t5) {
              return t5 >= 65072 && t5 <= 65103;
            }, "Small Form Variants": function(t5) {
              return t5 >= 65104 && t5 <= 65135;
            }, "Arabic Presentation Forms-B": function(t5) {
              return t5 >= 65136 && t5 <= 65279;
            }, "Halfwidth and Fullwidth Forms": function(t5) {
              return t5 >= 65280 && t5 <= 65519;
            } };
            function si(t5) {
              for (var e4 = 0, r4 = t5; e4 < r4.length; e4 += 1)
                if (li(r4[e4].charCodeAt(0)))
                  return true;
              return false;
            }
            function li(t5) {
              return !(746 !== t5 && 747 !== t5 && (t5 < 4352 || !(oi["Bopomofo Extended"](t5) || oi.Bopomofo(t5) || oi["CJK Compatibility Forms"](t5) && !(t5 >= 65097 && t5 <= 65103) || oi["CJK Compatibility Ideographs"](t5) || oi["CJK Compatibility"](t5) || oi["CJK Radicals Supplement"](t5) || oi["CJK Strokes"](t5) || !(!oi["CJK Symbols and Punctuation"](t5) || t5 >= 12296 && t5 <= 12305 || t5 >= 12308 && t5 <= 12319 || 12336 === t5) || oi["CJK Unified Ideographs Extension A"](t5) || oi["CJK Unified Ideographs"](t5) || oi["Enclosed CJK Letters and Months"](t5) || oi["Hangul Compatibility Jamo"](t5) || oi["Hangul Jamo Extended-A"](t5) || oi["Hangul Jamo Extended-B"](t5) || oi["Hangul Jamo"](t5) || oi["Hangul Syllables"](t5) || oi.Hiragana(t5) || oi["Ideographic Description Characters"](t5) || oi.Kanbun(t5) || oi["Kangxi Radicals"](t5) || oi["Katakana Phonetic Extensions"](t5) || oi.Katakana(t5) && 12540 !== t5 || !(!oi["Halfwidth and Fullwidth Forms"](t5) || 65288 === t5 || 65289 === t5 || 65293 === t5 || t5 >= 65306 && t5 <= 65310 || 65339 === t5 || 65341 === t5 || 65343 === t5 || t5 >= 65371 && t5 <= 65503 || 65507 === t5 || t5 >= 65512 && t5 <= 65519) || !(!oi["Small Form Variants"](t5) || t5 >= 65112 && t5 <= 65118 || t5 >= 65123 && t5 <= 65126) || oi["Unified Canadian Aboriginal Syllabics"](t5) || oi["Unified Canadian Aboriginal Syllabics Extended"](t5) || oi["Vertical Forms"](t5) || oi["Yijing Hexagram Symbols"](t5) || oi["Yi Syllables"](t5) || oi["Yi Radicals"](t5))));
            }
            function ui(t5) {
              return !(li(t5) || function(t6) {
                return !!(oi["Latin-1 Supplement"](t6) && (167 === t6 || 169 === t6 || 174 === t6 || 177 === t6 || 188 === t6 || 189 === t6 || 190 === t6 || 215 === t6 || 247 === t6) || oi["General Punctuation"](t6) && (8214 === t6 || 8224 === t6 || 8225 === t6 || 8240 === t6 || 8241 === t6 || 8251 === t6 || 8252 === t6 || 8258 === t6 || 8263 === t6 || 8264 === t6 || 8265 === t6 || 8273 === t6) || oi["Letterlike Symbols"](t6) || oi["Number Forms"](t6) || oi["Miscellaneous Technical"](t6) && (t6 >= 8960 && t6 <= 8967 || t6 >= 8972 && t6 <= 8991 || t6 >= 8996 && t6 <= 9e3 || 9003 === t6 || t6 >= 9085 && t6 <= 9114 || t6 >= 9150 && t6 <= 9165 || 9167 === t6 || t6 >= 9169 && t6 <= 9179 || t6 >= 9186 && t6 <= 9215) || oi["Control Pictures"](t6) && 9251 !== t6 || oi["Optical Character Recognition"](t6) || oi["Enclosed Alphanumerics"](t6) || oi["Geometric Shapes"](t6) || oi["Miscellaneous Symbols"](t6) && !(t6 >= 9754 && t6 <= 9759) || oi["Miscellaneous Symbols and Arrows"](t6) && (t6 >= 11026 && t6 <= 11055 || t6 >= 11088 && t6 <= 11097 || t6 >= 11192 && t6 <= 11243) || oi["CJK Symbols and Punctuation"](t6) || oi.Katakana(t6) || oi["Private Use Area"](t6) || oi["CJK Compatibility Forms"](t6) || oi["Small Form Variants"](t6) || oi["Halfwidth and Fullwidth Forms"](t6) || 8734 === t6 || 8756 === t6 || 8757 === t6 || t6 >= 9984 && t6 <= 10087 || t6 >= 10102 && t6 <= 10131 || 65532 === t6 || 65533 === t6);
              }(t5));
            }
            function ci(t5) {
              return oi.Arabic(t5) || oi["Arabic Supplement"](t5) || oi["Arabic Extended-A"](t5) || oi["Arabic Presentation Forms-A"](t5) || oi["Arabic Presentation Forms-B"](t5);
            }
            function fi(t5) {
              return t5 >= 1424 && t5 <= 2303 || oi["Arabic Presentation Forms-A"](t5) || oi["Arabic Presentation Forms-B"](t5);
            }
            function hi(t5, e4) {
              return !(!e4 && fi(t5) || t5 >= 2304 && t5 <= 3583 || t5 >= 3840 && t5 <= 4255 || oi.Khmer(t5));
            }
            function pi(t5) {
              for (var e4 = 0, r4 = t5; e4 < r4.length; e4 += 1)
                if (fi(r4[e4].charCodeAt(0)))
                  return true;
              return false;
            }
            var di = "deferred", vi = "loading", gi = "loaded", yi = "error", mi = null, xi = "unavailable", bi = null, _i = function(t5) {
              t5 && "string" == typeof t5 && t5.indexOf("NetworkError") > -1 && (xi = yi), mi && mi(t5);
            };
            function wi() {
              Ti.fire(new Ct("pluginStateChange", { pluginStatus: xi, pluginURL: bi }));
            }
            var Ti = new Ot(), ki = function() {
              return xi;
            }, Ai = function() {
              if (xi !== di || !bi)
                throw new Error("rtl-text-plugin cannot be downloaded unless a pluginURL is specified");
              xi = vi, wi(), bi && Tt({ url: bi }, function(t5) {
                t5 ? _i(t5) : (xi = gi, wi());
              });
            }, Mi = { applyArabicShaping: null, processBidirectionalText: null, processStyledBidirectionalText: null, isLoaded: function() {
              return xi === gi || null != Mi.applyArabicShaping;
            }, isLoading: function() {
              return xi === vi;
            }, setState: function(t5) {
              xi = t5.pluginStatus, bi = t5.pluginURL;
            }, isParsed: function() {
              return null != Mi.applyArabicShaping && null != Mi.processBidirectionalText && null != Mi.processStyledBidirectionalText;
            }, getPluginURL: function() {
              return bi;
            } }, Si = function(t5, e4) {
              this.zoom = t5, e4 ? (this.now = e4.now, this.fadeDuration = e4.fadeDuration, this.zoomHistory = e4.zoomHistory, this.transition = e4.transition) : (this.now = 0, this.fadeDuration = 0, this.zoomHistory = new ai(), this.transition = {});
            };
            Si.prototype.isSupportedScript = function(t5) {
              return function(t6, e4) {
                for (var r4 = 0, n4 = t6; r4 < n4.length; r4 += 1)
                  if (!hi(n4[r4].charCodeAt(0), e4))
                    return false;
                return true;
              }(t5, Mi.isLoaded());
            }, Si.prototype.crossFadingFactor = function() {
              return 0 === this.fadeDuration ? 1 : Math.min((this.now - this.zoomHistory.lastIntegerZoomTime) / this.fadeDuration, 1);
            }, Si.prototype.getCrossfadeParameters = function() {
              var t5 = this.zoom, e4 = t5 - Math.floor(t5), r4 = this.crossFadingFactor();
              return t5 > this.zoomHistory.lastIntegerZoom ? { fromScale: 2, toScale: 1, t: e4 + (1 - e4) * r4 } : { fromScale: 0.5, toScale: 1, t: 1 - (1 - r4) * e4 };
            };
            var Ei = function(t5, e4) {
              this.property = t5, this.value = e4, this.expression = function(t6, e5) {
                if (Wr(t6))
                  return new un(t6, e5);
                if (nn(t6)) {
                  var r4 = ln(t6, e5);
                  if ("error" === r4.result)
                    throw new Error(r4.value.map(function(t7) {
                      return t7.key + ": " + t7.message;
                    }).join(", "));
                  return r4.value;
                }
                var n4 = t6;
                return "string" == typeof t6 && "color" === e5.type && (n4 = ae.parse(t6)), { kind: "constant", evaluate: function() {
                  return n4;
                } };
              }(void 0 === e4 ? t5.specification.default : e4, t5.specification);
            };
            Ei.prototype.isDataDriven = function() {
              return "source" === this.expression.kind || "composite" === this.expression.kind;
            }, Ei.prototype.possiblyEvaluate = function(t5, e4, r4) {
              return this.property.possiblyEvaluate(this, t5, e4, r4);
            };
            var Li = function(t5) {
              this.property = t5, this.value = new Ei(t5, void 0);
            };
            Li.prototype.transitioned = function(t5, e4) {
              return new Pi(this.property, this.value, e4, f2({}, t5.transition, this.transition), t5.now);
            }, Li.prototype.untransitioned = function() {
              return new Pi(this.property, this.value, null, {}, 0);
            };
            var Ci = function(t5) {
              this._properties = t5, this._values = Object.create(t5.defaultTransitionablePropertyValues);
            };
            Ci.prototype.getValue = function(t5) {
              return b(this._values[t5].value.value);
            }, Ci.prototype.setValue = function(t5, e4) {
              this._values.hasOwnProperty(t5) || (this._values[t5] = new Li(this._values[t5].property)), this._values[t5].value = new Ei(this._values[t5].property, null === e4 ? void 0 : b(e4));
            }, Ci.prototype.getTransition = function(t5) {
              return b(this._values[t5].transition);
            }, Ci.prototype.setTransition = function(t5, e4) {
              this._values.hasOwnProperty(t5) || (this._values[t5] = new Li(this._values[t5].property)), this._values[t5].transition = b(e4) || void 0;
            }, Ci.prototype.serialize = function() {
              for (var t5 = {}, e4 = 0, r4 = Object.keys(this._values); e4 < r4.length; e4 += 1) {
                var n4 = r4[e4], i2 = this.getValue(n4);
                void 0 !== i2 && (t5[n4] = i2);
                var a2 = this.getTransition(n4);
                void 0 !== a2 && (t5[n4 + "-transition"] = a2);
              }
              return t5;
            }, Ci.prototype.transitioned = function(t5, e4) {
              for (var r4 = new Oi(this._properties), n4 = 0, i2 = Object.keys(this._values); n4 < i2.length; n4 += 1) {
                var a2 = i2[n4];
                r4._values[a2] = this._values[a2].transitioned(t5, e4._values[a2]);
              }
              return r4;
            }, Ci.prototype.untransitioned = function() {
              for (var t5 = new Oi(this._properties), e4 = 0, r4 = Object.keys(this._values); e4 < r4.length; e4 += 1) {
                var n4 = r4[e4];
                t5._values[n4] = this._values[n4].untransitioned();
              }
              return t5;
            };
            var Pi = function(t5, e4, r4, n4, i2) {
              this.property = t5, this.value = e4, this.begin = i2 + n4.delay || 0, this.end = this.begin + n4.duration || 0, t5.specification.transition && (n4.delay || n4.duration) && (this.prior = r4);
            };
            Pi.prototype.possiblyEvaluate = function(t5, e4, r4) {
              var n4 = t5.now || 0, i2 = this.value.possiblyEvaluate(t5, e4, r4), a2 = this.prior;
              if (a2) {
                if (n4 > this.end)
                  return this.prior = null, i2;
                if (this.value.isDataDriven())
                  return this.prior = null, i2;
                if (n4 < this.begin)
                  return a2.possiblyEvaluate(t5, e4, r4);
                var o2 = (n4 - this.begin) / (this.end - this.begin);
                return this.property.interpolate(a2.possiblyEvaluate(t5, e4, r4), i2, function(t6) {
                  if (t6 <= 0)
                    return 0;
                  if (t6 >= 1)
                    return 1;
                  var e5 = t6 * t6, r5 = e5 * t6;
                  return 4 * (t6 < 0.5 ? r5 : 3 * (t6 - e5) + r5 - 0.75);
                }(o2));
              }
              return i2;
            };
            var Oi = function(t5) {
              this._properties = t5, this._values = Object.create(t5.defaultTransitioningPropertyValues);
            };
            Oi.prototype.possiblyEvaluate = function(t5, e4, r4) {
              for (var n4 = new zi(this._properties), i2 = 0, a2 = Object.keys(this._values); i2 < a2.length; i2 += 1) {
                var o2 = a2[i2];
                n4._values[o2] = this._values[o2].possiblyEvaluate(t5, e4, r4);
              }
              return n4;
            }, Oi.prototype.hasTransition = function() {
              for (var t5 = 0, e4 = Object.keys(this._values); t5 < e4.length; t5 += 1) {
                var r4 = e4[t5];
                if (this._values[r4].prior)
                  return true;
              }
              return false;
            };
            var Ii = function(t5) {
              this._properties = t5, this._values = Object.create(t5.defaultPropertyValues);
            };
            Ii.prototype.getValue = function(t5) {
              return b(this._values[t5].value);
            }, Ii.prototype.setValue = function(t5, e4) {
              this._values[t5] = new Ei(this._values[t5].property, null === e4 ? void 0 : b(e4));
            }, Ii.prototype.serialize = function() {
              for (var t5 = {}, e4 = 0, r4 = Object.keys(this._values); e4 < r4.length; e4 += 1) {
                var n4 = r4[e4], i2 = this.getValue(n4);
                void 0 !== i2 && (t5[n4] = i2);
              }
              return t5;
            }, Ii.prototype.possiblyEvaluate = function(t5, e4, r4) {
              for (var n4 = new zi(this._properties), i2 = 0, a2 = Object.keys(this._values); i2 < a2.length; i2 += 1) {
                var o2 = a2[i2];
                n4._values[o2] = this._values[o2].possiblyEvaluate(t5, e4, r4);
              }
              return n4;
            };
            var Di = function(t5, e4, r4) {
              this.property = t5, this.value = e4, this.parameters = r4;
            };
            Di.prototype.isConstant = function() {
              return "constant" === this.value.kind;
            }, Di.prototype.constantOr = function(t5) {
              return "constant" === this.value.kind ? this.value.value : t5;
            }, Di.prototype.evaluate = function(t5, e4, r4, n4) {
              return this.property.evaluate(this.value, this.parameters, t5, e4, r4, n4);
            };
            var zi = function(t5) {
              this._properties = t5, this._values = Object.create(t5.defaultPossiblyEvaluatedValues);
            };
            zi.prototype.get = function(t5) {
              return this._values[t5];
            };
            var Ri = function(t5) {
              this.specification = t5;
            };
            Ri.prototype.possiblyEvaluate = function(t5, e4) {
              return t5.expression.evaluate(e4);
            }, Ri.prototype.interpolate = function(t5, e4, r4) {
              var n4 = $e[this.specification.type];
              return n4 ? n4(t5, e4, r4) : t5;
            };
            var Fi = function(t5, e4) {
              this.specification = t5, this.overrides = e4;
            };
            Fi.prototype.possiblyEvaluate = function(t5, e4, r4, n4) {
              return "constant" === t5.expression.kind || "camera" === t5.expression.kind ? new Di(this, { kind: "constant", value: t5.expression.evaluate(e4, null, {}, r4, n4) }, e4) : new Di(this, t5.expression, e4);
            }, Fi.prototype.interpolate = function(t5, e4, r4) {
              if ("constant" !== t5.value.kind || "constant" !== e4.value.kind)
                return t5;
              if (void 0 === t5.value.value || void 0 === e4.value.value)
                return new Di(this, { kind: "constant", value: void 0 }, t5.parameters);
              var n4 = $e[this.specification.type];
              return n4 ? new Di(this, { kind: "constant", value: n4(t5.value.value, e4.value.value, r4) }, t5.parameters) : t5;
            }, Fi.prototype.evaluate = function(t5, e4, r4, n4, i2, a2) {
              return "constant" === t5.kind ? t5.value : t5.evaluate(e4, r4, n4, i2, a2);
            };
            var Bi = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.possiblyEvaluate = function(t6, e5, r4, n4) {
                if (void 0 === t6.value)
                  return new Di(this, { kind: "constant", value: void 0 }, e5);
                if ("constant" === t6.expression.kind) {
                  var i2 = t6.expression.evaluate(e5, null, {}, r4, n4), a2 = "resolvedImage" === t6.property.specification.type && "string" != typeof i2 ? i2.name : i2, o2 = this._calculate(a2, a2, a2, e5);
                  return new Di(this, { kind: "constant", value: o2 }, e5);
                }
                if ("camera" === t6.expression.kind) {
                  var s2 = this._calculate(t6.expression.evaluate({ zoom: e5.zoom - 1 }), t6.expression.evaluate({ zoom: e5.zoom }), t6.expression.evaluate({ zoom: e5.zoom + 1 }), e5);
                  return new Di(this, { kind: "constant", value: s2 }, e5);
                }
                return new Di(this, t6.expression, e5);
              }, e4.prototype.evaluate = function(t6, e5, r4, n4, i2, a2) {
                if ("source" === t6.kind) {
                  var o2 = t6.evaluate(e5, r4, n4, i2, a2);
                  return this._calculate(o2, o2, o2, e5);
                }
                return "composite" === t6.kind ? this._calculate(t6.evaluate({ zoom: Math.floor(e5.zoom) - 1 }, r4, n4), t6.evaluate({ zoom: Math.floor(e5.zoom) }, r4, n4), t6.evaluate({ zoom: Math.floor(e5.zoom) + 1 }, r4, n4), e5) : t6.value;
              }, e4.prototype._calculate = function(t6, e5, r4, n4) {
                return n4.zoom > n4.zoomHistory.lastIntegerZoom ? { from: t6, to: e5 } : { from: r4, to: e5 };
              }, e4.prototype.interpolate = function(t6) {
                return t6;
              }, e4;
            }(Fi), Ni = function(t5) {
              this.specification = t5;
            };
            Ni.prototype.possiblyEvaluate = function(t5, e4, r4, n4) {
              if (void 0 !== t5.value) {
                if ("constant" === t5.expression.kind) {
                  var i2 = t5.expression.evaluate(e4, null, {}, r4, n4);
                  return this._calculate(i2, i2, i2, e4);
                }
                return this._calculate(t5.expression.evaluate(new Si(Math.floor(e4.zoom - 1), e4)), t5.expression.evaluate(new Si(Math.floor(e4.zoom), e4)), t5.expression.evaluate(new Si(Math.floor(e4.zoom + 1), e4)), e4);
              }
            }, Ni.prototype._calculate = function(t5, e4, r4, n4) {
              return n4.zoom > n4.zoomHistory.lastIntegerZoom ? { from: t5, to: e4 } : { from: r4, to: e4 };
            }, Ni.prototype.interpolate = function(t5) {
              return t5;
            };
            var ji = function(t5) {
              this.specification = t5;
            };
            ji.prototype.possiblyEvaluate = function(t5, e4, r4, n4) {
              return !!t5.expression.evaluate(e4, null, {}, r4, n4);
            }, ji.prototype.interpolate = function() {
              return false;
            };
            var Ui = function(t5) {
              for (var e4 in this.properties = t5, this.defaultPropertyValues = {}, this.defaultTransitionablePropertyValues = {}, this.defaultTransitioningPropertyValues = {}, this.defaultPossiblyEvaluatedValues = {}, this.overridableProperties = [], t5) {
                var r4 = t5[e4];
                r4.specification.overridable && this.overridableProperties.push(e4);
                var n4 = this.defaultPropertyValues[e4] = new Ei(r4, void 0), i2 = this.defaultTransitionablePropertyValues[e4] = new Li(r4);
                this.defaultTransitioningPropertyValues[e4] = i2.untransitioned(), this.defaultPossiblyEvaluatedValues[e4] = n4.possiblyEvaluate({});
              }
            };
            Qn("DataDrivenProperty", Fi), Qn("DataConstantProperty", Ri), Qn("CrossFadedDataDrivenProperty", Bi), Qn("CrossFadedProperty", Ni), Qn("ColorRampProperty", ji);
            var Vi = "-transition", Hi = function(t5) {
              function e4(e5, r4) {
                if (t5.call(this), this.id = e5.id, this.type = e5.type, this._featureFilter = { filter: function() {
                  return true;
                }, needGeometry: false }, "custom" !== e5.type && (this.metadata = e5.metadata, this.minzoom = e5.minzoom, this.maxzoom = e5.maxzoom, "background" !== e5.type && (this.source = e5.source, this.sourceLayer = e5["source-layer"], this.filter = e5.filter), r4.layout && (this._unevaluatedLayout = new Ii(r4.layout)), r4.paint)) {
                  for (var n4 in this._transitionablePaint = new Ci(r4.paint), e5.paint)
                    this.setPaintProperty(n4, e5.paint[n4], { validate: false });
                  for (var i2 in e5.layout)
                    this.setLayoutProperty(i2, e5.layout[i2], { validate: false });
                  this._transitioningPaint = this._transitionablePaint.untransitioned(), this.paint = new zi(r4.paint);
                }
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getCrossfadeParameters = function() {
                return this._crossfadeParameters;
              }, e4.prototype.getLayoutProperty = function(t6) {
                return "visibility" === t6 ? this.visibility : this._unevaluatedLayout.getValue(t6);
              }, e4.prototype.setLayoutProperty = function(t6, e5, r4) {
                if (void 0 === r4 && (r4 = {}), null != e5) {
                  var n4 = "layers." + this.id + ".layout." + t6;
                  if (this._validate(Zn, n4, t6, e5, r4))
                    return;
                }
                "visibility" !== t6 ? this._unevaluatedLayout.setValue(t6, e5) : this.visibility = e5;
              }, e4.prototype.getPaintProperty = function(t6) {
                return y(t6, Vi) ? this._transitionablePaint.getTransition(t6.slice(0, -Vi.length)) : this._transitionablePaint.getValue(t6);
              }, e4.prototype.setPaintProperty = function(t6, e5, r4) {
                if (void 0 === r4 && (r4 = {}), null != e5) {
                  var n4 = "layers." + this.id + ".paint." + t6;
                  if (this._validate(Gn, n4, t6, e5, r4))
                    return false;
                }
                if (y(t6, Vi))
                  return this._transitionablePaint.setTransition(t6.slice(0, -Vi.length), e5 || void 0), false;
                var i2 = this._transitionablePaint._values[t6], a2 = "cross-faded-data-driven" === i2.property.specification["property-type"], o2 = i2.value.isDataDriven(), s2 = i2.value;
                this._transitionablePaint.setValue(t6, e5), this._handleSpecialPaintPropertyUpdate(t6);
                var l2 = this._transitionablePaint._values[t6].value;
                return l2.isDataDriven() || o2 || a2 || this._handleOverridablePaintPropertyUpdate(t6, s2, l2);
              }, e4.prototype._handleSpecialPaintPropertyUpdate = function(t6) {
              }, e4.prototype._handleOverridablePaintPropertyUpdate = function(t6, e5, r4) {
                return false;
              }, e4.prototype.isHidden = function(t6) {
                return !!(this.minzoom && t6 < this.minzoom) || !!(this.maxzoom && t6 >= this.maxzoom) || "none" === this.visibility;
              }, e4.prototype.updateTransitions = function(t6) {
                this._transitioningPaint = this._transitionablePaint.transitioned(t6, this._transitioningPaint);
              }, e4.prototype.hasTransition = function() {
                return this._transitioningPaint.hasTransition();
              }, e4.prototype.recalculate = function(t6, e5) {
                t6.getCrossfadeParameters && (this._crossfadeParameters = t6.getCrossfadeParameters()), this._unevaluatedLayout && (this.layout = this._unevaluatedLayout.possiblyEvaluate(t6, void 0, e5)), this.paint = this._transitioningPaint.possiblyEvaluate(t6, void 0, e5);
              }, e4.prototype.serialize = function() {
                var t6 = { id: this.id, type: this.type, source: this.source, "source-layer": this.sourceLayer, metadata: this.metadata, minzoom: this.minzoom, maxzoom: this.maxzoom, filter: this.filter, layout: this._unevaluatedLayout && this._unevaluatedLayout.serialize(), paint: this._transitionablePaint && this._transitionablePaint.serialize() };
                return this.visibility && (t6.layout = t6.layout || {}, t6.layout.visibility = this.visibility), x(t6, function(t7, e5) {
                  return !(void 0 === t7 || "layout" === e5 && !Object.keys(t7).length || "paint" === e5 && !Object.keys(t7).length);
                });
              }, e4.prototype._validate = function(t6, e5, r4, n4, i2) {
                return void 0 === i2 && (i2 = {}), (!i2 || false !== i2.validate) && Yn(this, t6.call(Hn, { key: e5, layerType: this.type, objectKey: r4, value: n4, styleSpec: It, style: { glyphs: true, sprite: true } }));
              }, e4.prototype.is3D = function() {
                return false;
              }, e4.prototype.isTileClipped = function() {
                return false;
              }, e4.prototype.hasOffscreenPass = function() {
                return false;
              }, e4.prototype.resize = function() {
              }, e4.prototype.isStateDependent = function() {
                for (var t6 in this.paint._values) {
                  var e5 = this.paint.get(t6);
                  if (e5 instanceof Di && qr(e5.property.specification) && ("source" === e5.value.kind || "composite" === e5.value.kind) && e5.value.isStateDependent)
                    return true;
                }
                return false;
              }, e4;
            }(Ot), qi = { Int8: Int8Array, Uint8: Uint8Array, Int16: Int16Array, Uint16: Uint16Array, Int32: Int32Array, Uint32: Uint32Array, Float32: Float32Array }, Gi = function(t5, e4) {
              this._structArray = t5, this._pos1 = e4 * this.size, this._pos2 = this._pos1 / 2, this._pos4 = this._pos1 / 4, this._pos8 = this._pos1 / 8;
            }, Zi = function() {
              this.isTransferred = false, this.capacity = -1, this.resize(0);
            };
            function Yi(t5, e4) {
              void 0 === e4 && (e4 = 1);
              var r4 = 0, n4 = 0;
              return { members: t5.map(function(t6) {
                var i2, a2 = (i2 = t6.type, qi[i2].BYTES_PER_ELEMENT), o2 = r4 = Wi(r4, Math.max(e4, a2)), s2 = t6.components || 1;
                return n4 = Math.max(n4, a2), r4 += a2 * s2, { name: t6.name, type: t6.type, components: s2, offset: o2 };
              }), size: Wi(r4, Math.max(n4, e4)), alignment: e4 };
            }
            function Wi(t5, e4) {
              return Math.ceil(t5 / e4) * e4;
            }
            Zi.serialize = function(t5, e4) {
              return t5._trim(), e4 && (t5.isTransferred = true, e4.push(t5.arrayBuffer)), { length: t5.length, arrayBuffer: t5.arrayBuffer };
            }, Zi.deserialize = function(t5) {
              var e4 = Object.create(this.prototype);
              return e4.arrayBuffer = t5.arrayBuffer, e4.length = t5.length, e4.capacity = t5.arrayBuffer.byteLength / e4.bytesPerElement, e4._refreshViews(), e4;
            }, Zi.prototype._trim = function() {
              this.length !== this.capacity && (this.capacity = this.length, this.arrayBuffer = this.arrayBuffer.slice(0, this.length * this.bytesPerElement), this._refreshViews());
            }, Zi.prototype.clear = function() {
              this.length = 0;
            }, Zi.prototype.resize = function(t5) {
              this.reserve(t5), this.length = t5;
            }, Zi.prototype.reserve = function(t5) {
              if (t5 > this.capacity) {
                this.capacity = Math.max(t5, Math.floor(5 * this.capacity), 128), this.arrayBuffer = new ArrayBuffer(this.capacity * this.bytesPerElement);
                var e4 = this.uint8;
                this._refreshViews(), e4 && this.uint8.set(e4);
              }
            }, Zi.prototype._refreshViews = function() {
              throw new Error("_refreshViews() must be implemented by each concrete StructArray layout");
            };
            var Xi = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5) {
                var r4 = this.length;
                return this.resize(r4 + 1), this.emplace(r4, t6, e5);
              }, e4.prototype.emplace = function(t6, e5, r4) {
                var n4 = 2 * t6;
                return this.int16[n4 + 0] = e5, this.int16[n4 + 1] = r4, t6;
              }, e4;
            }(Zi);
            Xi.prototype.bytesPerElement = 4, Qn("StructArrayLayout2i4", Xi);
            var Ji = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4, n4) {
                var i2 = this.length;
                return this.resize(i2 + 1), this.emplace(i2, t6, e5, r4, n4);
              }, e4.prototype.emplace = function(t6, e5, r4, n4, i2) {
                var a2 = 4 * t6;
                return this.int16[a2 + 0] = e5, this.int16[a2 + 1] = r4, this.int16[a2 + 2] = n4, this.int16[a2 + 3] = i2, t6;
              }, e4;
            }(Zi);
            Ji.prototype.bytesPerElement = 8, Qn("StructArrayLayout4i8", Ji);
            var Ki = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4, n4, i2, a2) {
                var o2 = this.length;
                return this.resize(o2 + 1), this.emplace(o2, t6, e5, r4, n4, i2, a2);
              }, e4.prototype.emplace = function(t6, e5, r4, n4, i2, a2, o2) {
                var s2 = 6 * t6;
                return this.int16[s2 + 0] = e5, this.int16[s2 + 1] = r4, this.int16[s2 + 2] = n4, this.int16[s2 + 3] = i2, this.int16[s2 + 4] = a2, this.int16[s2 + 5] = o2, t6;
              }, e4;
            }(Zi);
            Ki.prototype.bytesPerElement = 12, Qn("StructArrayLayout2i4i12", Ki);
            var $i = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4, n4, i2, a2) {
                var o2 = this.length;
                return this.resize(o2 + 1), this.emplace(o2, t6, e5, r4, n4, i2, a2);
              }, e4.prototype.emplace = function(t6, e5, r4, n4, i2, a2, o2) {
                var s2 = 4 * t6, l2 = 8 * t6;
                return this.int16[s2 + 0] = e5, this.int16[s2 + 1] = r4, this.uint8[l2 + 4] = n4, this.uint8[l2 + 5] = i2, this.uint8[l2 + 6] = a2, this.uint8[l2 + 7] = o2, t6;
              }, e4;
            }(Zi);
            $i.prototype.bytesPerElement = 8, Qn("StructArrayLayout2i4ub8", $i);
            var Qi = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4, n4, i2, a2, o2, s2, l2, u2) {
                var c2 = this.length;
                return this.resize(c2 + 1), this.emplace(c2, t6, e5, r4, n4, i2, a2, o2, s2, l2, u2);
              }, e4.prototype.emplace = function(t6, e5, r4, n4, i2, a2, o2, s2, l2, u2, c2) {
                var f3 = 9 * t6, h2 = 18 * t6;
                return this.uint16[f3 + 0] = e5, this.uint16[f3 + 1] = r4, this.uint16[f3 + 2] = n4, this.uint16[f3 + 3] = i2, this.uint16[f3 + 4] = a2, this.uint16[f3 + 5] = o2, this.uint16[f3 + 6] = s2, this.uint16[f3 + 7] = l2, this.uint8[h2 + 16] = u2, this.uint8[h2 + 17] = c2, t6;
              }, e4;
            }(Zi);
            Qi.prototype.bytesPerElement = 18, Qn("StructArrayLayout8ui2ub18", Qi);
            var ta = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3) {
                var h2 = this.length;
                return this.resize(h2 + 1), this.emplace(h2, t6, e5, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3);
              }, e4.prototype.emplace = function(t6, e5, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2) {
                var p3 = 12 * t6;
                return this.int16[p3 + 0] = e5, this.int16[p3 + 1] = r4, this.int16[p3 + 2] = n4, this.int16[p3 + 3] = i2, this.uint16[p3 + 4] = a2, this.uint16[p3 + 5] = o2, this.uint16[p3 + 6] = s2, this.uint16[p3 + 7] = l2, this.int16[p3 + 8] = u2, this.int16[p3 + 9] = c2, this.int16[p3 + 10] = f3, this.int16[p3 + 11] = h2, t6;
              }, e4;
            }(Zi);
            ta.prototype.bytesPerElement = 24, Qn("StructArrayLayout4i4ui4i24", ta);
            var ea = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4) {
                var n4 = this.length;
                return this.resize(n4 + 1), this.emplace(n4, t6, e5, r4);
              }, e4.prototype.emplace = function(t6, e5, r4, n4) {
                var i2 = 3 * t6;
                return this.float32[i2 + 0] = e5, this.float32[i2 + 1] = r4, this.float32[i2 + 2] = n4, t6;
              }, e4;
            }(Zi);
            ea.prototype.bytesPerElement = 12, Qn("StructArrayLayout3f12", ea);
            var ra = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6) {
                var e5 = this.length;
                return this.resize(e5 + 1), this.emplace(e5, t6);
              }, e4.prototype.emplace = function(t6, e5) {
                var r4 = 1 * t6;
                return this.uint32[r4 + 0] = e5, t6;
              }, e4;
            }(Zi);
            ra.prototype.bytesPerElement = 4, Qn("StructArrayLayout1ul4", ra);
            var na = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4, n4, i2, a2, o2, s2, l2) {
                var u2 = this.length;
                return this.resize(u2 + 1), this.emplace(u2, t6, e5, r4, n4, i2, a2, o2, s2, l2);
              }, e4.prototype.emplace = function(t6, e5, r4, n4, i2, a2, o2, s2, l2, u2) {
                var c2 = 10 * t6, f3 = 5 * t6;
                return this.int16[c2 + 0] = e5, this.int16[c2 + 1] = r4, this.int16[c2 + 2] = n4, this.int16[c2 + 3] = i2, this.int16[c2 + 4] = a2, this.int16[c2 + 5] = o2, this.uint32[f3 + 3] = s2, this.uint16[c2 + 8] = l2, this.uint16[c2 + 9] = u2, t6;
              }, e4;
            }(Zi);
            na.prototype.bytesPerElement = 20, Qn("StructArrayLayout6i1ul2ui20", na);
            var ia = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4, n4, i2, a2) {
                var o2 = this.length;
                return this.resize(o2 + 1), this.emplace(o2, t6, e5, r4, n4, i2, a2);
              }, e4.prototype.emplace = function(t6, e5, r4, n4, i2, a2, o2) {
                var s2 = 6 * t6;
                return this.int16[s2 + 0] = e5, this.int16[s2 + 1] = r4, this.int16[s2 + 2] = n4, this.int16[s2 + 3] = i2, this.int16[s2 + 4] = a2, this.int16[s2 + 5] = o2, t6;
              }, e4;
            }(Zi);
            ia.prototype.bytesPerElement = 12, Qn("StructArrayLayout2i2i2i12", ia);
            var aa = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4, n4, i2) {
                var a2 = this.length;
                return this.resize(a2 + 1), this.emplace(a2, t6, e5, r4, n4, i2);
              }, e4.prototype.emplace = function(t6, e5, r4, n4, i2, a2) {
                var o2 = 4 * t6, s2 = 8 * t6;
                return this.float32[o2 + 0] = e5, this.float32[o2 + 1] = r4, this.float32[o2 + 2] = n4, this.int16[s2 + 6] = i2, this.int16[s2 + 7] = a2, t6;
              }, e4;
            }(Zi);
            aa.prototype.bytesPerElement = 16, Qn("StructArrayLayout2f1f2i16", aa);
            var oa = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4, n4) {
                var i2 = this.length;
                return this.resize(i2 + 1), this.emplace(i2, t6, e5, r4, n4);
              }, e4.prototype.emplace = function(t6, e5, r4, n4, i2) {
                var a2 = 12 * t6, o2 = 3 * t6;
                return this.uint8[a2 + 0] = e5, this.uint8[a2 + 1] = r4, this.float32[o2 + 1] = n4, this.float32[o2 + 2] = i2, t6;
              }, e4;
            }(Zi);
            oa.prototype.bytesPerElement = 12, Qn("StructArrayLayout2ub2f12", oa);
            var sa = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4) {
                var n4 = this.length;
                return this.resize(n4 + 1), this.emplace(n4, t6, e5, r4);
              }, e4.prototype.emplace = function(t6, e5, r4, n4) {
                var i2 = 3 * t6;
                return this.uint16[i2 + 0] = e5, this.uint16[i2 + 1] = r4, this.uint16[i2 + 2] = n4, t6;
              }, e4;
            }(Zi);
            sa.prototype.bytesPerElement = 6, Qn("StructArrayLayout3ui6", sa);
            var la = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3, d3, v2, g3) {
                var y2 = this.length;
                return this.resize(y2 + 1), this.emplace(y2, t6, e5, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3, d3, v2, g3);
              }, e4.prototype.emplace = function(t6, e5, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3, d3, v2, g3, y2) {
                var m3 = 24 * t6, x2 = 12 * t6, b2 = 48 * t6;
                return this.int16[m3 + 0] = e5, this.int16[m3 + 1] = r4, this.uint16[m3 + 2] = n4, this.uint16[m3 + 3] = i2, this.uint32[x2 + 2] = a2, this.uint32[x2 + 3] = o2, this.uint32[x2 + 4] = s2, this.uint16[m3 + 10] = l2, this.uint16[m3 + 11] = u2, this.uint16[m3 + 12] = c2, this.float32[x2 + 7] = f3, this.float32[x2 + 8] = h2, this.uint8[b2 + 36] = p3, this.uint8[b2 + 37] = d3, this.uint8[b2 + 38] = v2, this.uint32[x2 + 10] = g3, this.int16[m3 + 22] = y2, t6;
              }, e4;
            }(Zi);
            la.prototype.bytesPerElement = 48, Qn("StructArrayLayout2i2ui3ul3ui2f3ub1ul1i48", la);
            var ua = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3, d3, v2, g3, y2, m3, x2, b2, _2, w3, T2, k2, A2, M2, S2) {
                var E2 = this.length;
                return this.resize(E2 + 1), this.emplace(E2, t6, e5, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3, d3, v2, g3, y2, m3, x2, b2, _2, w3, T2, k2, A2, M2, S2);
              }, e4.prototype.emplace = function(t6, e5, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3, d3, v2, g3, y2, m3, x2, b2, _2, w3, T2, k2, A2, M2, S2, E2) {
                var L2 = 34 * t6, C2 = 17 * t6;
                return this.int16[L2 + 0] = e5, this.int16[L2 + 1] = r4, this.int16[L2 + 2] = n4, this.int16[L2 + 3] = i2, this.int16[L2 + 4] = a2, this.int16[L2 + 5] = o2, this.int16[L2 + 6] = s2, this.int16[L2 + 7] = l2, this.uint16[L2 + 8] = u2, this.uint16[L2 + 9] = c2, this.uint16[L2 + 10] = f3, this.uint16[L2 + 11] = h2, this.uint16[L2 + 12] = p3, this.uint16[L2 + 13] = d3, this.uint16[L2 + 14] = v2, this.uint16[L2 + 15] = g3, this.uint16[L2 + 16] = y2, this.uint16[L2 + 17] = m3, this.uint16[L2 + 18] = x2, this.uint16[L2 + 19] = b2, this.uint16[L2 + 20] = _2, this.uint16[L2 + 21] = w3, this.uint16[L2 + 22] = T2, this.uint32[C2 + 12] = k2, this.float32[C2 + 13] = A2, this.float32[C2 + 14] = M2, this.float32[C2 + 15] = S2, this.float32[C2 + 16] = E2, t6;
              }, e4;
            }(Zi);
            ua.prototype.bytesPerElement = 68, Qn("StructArrayLayout8i15ui1ul4f68", ua);
            var ca = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6) {
                var e5 = this.length;
                return this.resize(e5 + 1), this.emplace(e5, t6);
              }, e4.prototype.emplace = function(t6, e5) {
                var r4 = 1 * t6;
                return this.float32[r4 + 0] = e5, t6;
              }, e4;
            }(Zi);
            ca.prototype.bytesPerElement = 4, Qn("StructArrayLayout1f4", ca);
            var fa = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4) {
                var n4 = this.length;
                return this.resize(n4 + 1), this.emplace(n4, t6, e5, r4);
              }, e4.prototype.emplace = function(t6, e5, r4, n4) {
                var i2 = 3 * t6;
                return this.int16[i2 + 0] = e5, this.int16[i2 + 1] = r4, this.int16[i2 + 2] = n4, t6;
              }, e4;
            }(Zi);
            fa.prototype.bytesPerElement = 6, Qn("StructArrayLayout3i6", fa);
            var ha = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4) {
                var n4 = this.length;
                return this.resize(n4 + 1), this.emplace(n4, t6, e5, r4);
              }, e4.prototype.emplace = function(t6, e5, r4, n4) {
                var i2 = 2 * t6, a2 = 4 * t6;
                return this.uint32[i2 + 0] = e5, this.uint16[a2 + 2] = r4, this.uint16[a2 + 3] = n4, t6;
              }, e4;
            }(Zi);
            ha.prototype.bytesPerElement = 8, Qn("StructArrayLayout1ul2ui8", ha);
            var pa = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5) {
                var r4 = this.length;
                return this.resize(r4 + 1), this.emplace(r4, t6, e5);
              }, e4.prototype.emplace = function(t6, e5, r4) {
                var n4 = 2 * t6;
                return this.uint16[n4 + 0] = e5, this.uint16[n4 + 1] = r4, t6;
              }, e4;
            }(Zi);
            pa.prototype.bytesPerElement = 4, Qn("StructArrayLayout2ui4", pa);
            var da = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6) {
                var e5 = this.length;
                return this.resize(e5 + 1), this.emplace(e5, t6);
              }, e4.prototype.emplace = function(t6, e5) {
                var r4 = 1 * t6;
                return this.uint16[r4 + 0] = e5, t6;
              }, e4;
            }(Zi);
            da.prototype.bytesPerElement = 2, Qn("StructArrayLayout1ui2", da);
            var va = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5) {
                var r4 = this.length;
                return this.resize(r4 + 1), this.emplace(r4, t6, e5);
              }, e4.prototype.emplace = function(t6, e5, r4) {
                var n4 = 2 * t6;
                return this.float32[n4 + 0] = e5, this.float32[n4 + 1] = r4, t6;
              }, e4;
            }(Zi);
            va.prototype.bytesPerElement = 8, Qn("StructArrayLayout2f8", va);
            var ga = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._refreshViews = function() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
              }, e4.prototype.emplaceBack = function(t6, e5, r4, n4) {
                var i2 = this.length;
                return this.resize(i2 + 1), this.emplace(i2, t6, e5, r4, n4);
              }, e4.prototype.emplace = function(t6, e5, r4, n4, i2) {
                var a2 = 4 * t6;
                return this.float32[a2 + 0] = e5, this.float32[a2 + 1] = r4, this.float32[a2 + 2] = n4, this.float32[a2 + 3] = i2, t6;
              }, e4;
            }(Zi);
            ga.prototype.bytesPerElement = 16, Qn("StructArrayLayout4f16", ga);
            var ya = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4;
              var r4 = { anchorPointX: { configurable: true }, anchorPointY: { configurable: true }, x1: { configurable: true }, y1: { configurable: true }, x2: { configurable: true }, y2: { configurable: true }, featureIndex: { configurable: true }, sourceLayerIndex: { configurable: true }, bucketIndex: { configurable: true }, anchorPoint: { configurable: true } };
              return r4.anchorPointX.get = function() {
                return this._structArray.int16[this._pos2 + 0];
              }, r4.anchorPointY.get = function() {
                return this._structArray.int16[this._pos2 + 1];
              }, r4.x1.get = function() {
                return this._structArray.int16[this._pos2 + 2];
              }, r4.y1.get = function() {
                return this._structArray.int16[this._pos2 + 3];
              }, r4.x2.get = function() {
                return this._structArray.int16[this._pos2 + 4];
              }, r4.y2.get = function() {
                return this._structArray.int16[this._pos2 + 5];
              }, r4.featureIndex.get = function() {
                return this._structArray.uint32[this._pos4 + 3];
              }, r4.sourceLayerIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 8];
              }, r4.bucketIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 9];
              }, r4.anchorPoint.get = function() {
                return new a(this.anchorPointX, this.anchorPointY);
              }, Object.defineProperties(e4.prototype, r4), e4;
            }(Gi);
            ya.prototype.size = 20;
            var ma = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.get = function(t6) {
                return new ya(this, t6);
              }, e4;
            }(na);
            Qn("CollisionBoxArray", ma);
            var xa = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4;
              var r4 = { anchorX: { configurable: true }, anchorY: { configurable: true }, glyphStartIndex: { configurable: true }, numGlyphs: { configurable: true }, vertexStartIndex: { configurable: true }, lineStartIndex: { configurable: true }, lineLength: { configurable: true }, segment: { configurable: true }, lowerSize: { configurable: true }, upperSize: { configurable: true }, lineOffsetX: { configurable: true }, lineOffsetY: { configurable: true }, writingMode: { configurable: true }, placedOrientation: { configurable: true }, hidden: { configurable: true }, crossTileID: { configurable: true }, associatedIconIndex: { configurable: true } };
              return r4.anchorX.get = function() {
                return this._structArray.int16[this._pos2 + 0];
              }, r4.anchorY.get = function() {
                return this._structArray.int16[this._pos2 + 1];
              }, r4.glyphStartIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 2];
              }, r4.numGlyphs.get = function() {
                return this._structArray.uint16[this._pos2 + 3];
              }, r4.vertexStartIndex.get = function() {
                return this._structArray.uint32[this._pos4 + 2];
              }, r4.lineStartIndex.get = function() {
                return this._structArray.uint32[this._pos4 + 3];
              }, r4.lineLength.get = function() {
                return this._structArray.uint32[this._pos4 + 4];
              }, r4.segment.get = function() {
                return this._structArray.uint16[this._pos2 + 10];
              }, r4.lowerSize.get = function() {
                return this._structArray.uint16[this._pos2 + 11];
              }, r4.upperSize.get = function() {
                return this._structArray.uint16[this._pos2 + 12];
              }, r4.lineOffsetX.get = function() {
                return this._structArray.float32[this._pos4 + 7];
              }, r4.lineOffsetY.get = function() {
                return this._structArray.float32[this._pos4 + 8];
              }, r4.writingMode.get = function() {
                return this._structArray.uint8[this._pos1 + 36];
              }, r4.placedOrientation.get = function() {
                return this._structArray.uint8[this._pos1 + 37];
              }, r4.placedOrientation.set = function(t6) {
                this._structArray.uint8[this._pos1 + 37] = t6;
              }, r4.hidden.get = function() {
                return this._structArray.uint8[this._pos1 + 38];
              }, r4.hidden.set = function(t6) {
                this._structArray.uint8[this._pos1 + 38] = t6;
              }, r4.crossTileID.get = function() {
                return this._structArray.uint32[this._pos4 + 10];
              }, r4.crossTileID.set = function(t6) {
                this._structArray.uint32[this._pos4 + 10] = t6;
              }, r4.associatedIconIndex.get = function() {
                return this._structArray.int16[this._pos2 + 22];
              }, Object.defineProperties(e4.prototype, r4), e4;
            }(Gi);
            xa.prototype.size = 48;
            var ba = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.get = function(t6) {
                return new xa(this, t6);
              }, e4;
            }(la);
            Qn("PlacedSymbolArray", ba);
            var _a = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4;
              var r4 = { anchorX: { configurable: true }, anchorY: { configurable: true }, rightJustifiedTextSymbolIndex: { configurable: true }, centerJustifiedTextSymbolIndex: { configurable: true }, leftJustifiedTextSymbolIndex: { configurable: true }, verticalPlacedTextSymbolIndex: { configurable: true }, placedIconSymbolIndex: { configurable: true }, verticalPlacedIconSymbolIndex: { configurable: true }, key: { configurable: true }, textBoxStartIndex: { configurable: true }, textBoxEndIndex: { configurable: true }, verticalTextBoxStartIndex: { configurable: true }, verticalTextBoxEndIndex: { configurable: true }, iconBoxStartIndex: { configurable: true }, iconBoxEndIndex: { configurable: true }, verticalIconBoxStartIndex: { configurable: true }, verticalIconBoxEndIndex: { configurable: true }, featureIndex: { configurable: true }, numHorizontalGlyphVertices: { configurable: true }, numVerticalGlyphVertices: { configurable: true }, numIconVertices: { configurable: true }, numVerticalIconVertices: { configurable: true }, useRuntimeCollisionCircles: { configurable: true }, crossTileID: { configurable: true }, textBoxScale: { configurable: true }, textOffset0: { configurable: true }, textOffset1: { configurable: true }, collisionCircleDiameter: { configurable: true } };
              return r4.anchorX.get = function() {
                return this._structArray.int16[this._pos2 + 0];
              }, r4.anchorY.get = function() {
                return this._structArray.int16[this._pos2 + 1];
              }, r4.rightJustifiedTextSymbolIndex.get = function() {
                return this._structArray.int16[this._pos2 + 2];
              }, r4.centerJustifiedTextSymbolIndex.get = function() {
                return this._structArray.int16[this._pos2 + 3];
              }, r4.leftJustifiedTextSymbolIndex.get = function() {
                return this._structArray.int16[this._pos2 + 4];
              }, r4.verticalPlacedTextSymbolIndex.get = function() {
                return this._structArray.int16[this._pos2 + 5];
              }, r4.placedIconSymbolIndex.get = function() {
                return this._structArray.int16[this._pos2 + 6];
              }, r4.verticalPlacedIconSymbolIndex.get = function() {
                return this._structArray.int16[this._pos2 + 7];
              }, r4.key.get = function() {
                return this._structArray.uint16[this._pos2 + 8];
              }, r4.textBoxStartIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 9];
              }, r4.textBoxEndIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 10];
              }, r4.verticalTextBoxStartIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 11];
              }, r4.verticalTextBoxEndIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 12];
              }, r4.iconBoxStartIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 13];
              }, r4.iconBoxEndIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 14];
              }, r4.verticalIconBoxStartIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 15];
              }, r4.verticalIconBoxEndIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 16];
              }, r4.featureIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 17];
              }, r4.numHorizontalGlyphVertices.get = function() {
                return this._structArray.uint16[this._pos2 + 18];
              }, r4.numVerticalGlyphVertices.get = function() {
                return this._structArray.uint16[this._pos2 + 19];
              }, r4.numIconVertices.get = function() {
                return this._structArray.uint16[this._pos2 + 20];
              }, r4.numVerticalIconVertices.get = function() {
                return this._structArray.uint16[this._pos2 + 21];
              }, r4.useRuntimeCollisionCircles.get = function() {
                return this._structArray.uint16[this._pos2 + 22];
              }, r4.crossTileID.get = function() {
                return this._structArray.uint32[this._pos4 + 12];
              }, r4.crossTileID.set = function(t6) {
                this._structArray.uint32[this._pos4 + 12] = t6;
              }, r4.textBoxScale.get = function() {
                return this._structArray.float32[this._pos4 + 13];
              }, r4.textOffset0.get = function() {
                return this._structArray.float32[this._pos4 + 14];
              }, r4.textOffset1.get = function() {
                return this._structArray.float32[this._pos4 + 15];
              }, r4.collisionCircleDiameter.get = function() {
                return this._structArray.float32[this._pos4 + 16];
              }, Object.defineProperties(e4.prototype, r4), e4;
            }(Gi);
            _a.prototype.size = 68;
            var wa = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.get = function(t6) {
                return new _a(this, t6);
              }, e4;
            }(ua);
            Qn("SymbolInstanceArray", wa);
            var Ta = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getoffsetX = function(t6) {
                return this.float32[1 * t6 + 0];
              }, e4;
            }(ca);
            Qn("GlyphOffsetArray", Ta);
            var ka = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getx = function(t6) {
                return this.int16[3 * t6 + 0];
              }, e4.prototype.gety = function(t6) {
                return this.int16[3 * t6 + 1];
              }, e4.prototype.gettileUnitDistanceFromAnchor = function(t6) {
                return this.int16[3 * t6 + 2];
              }, e4;
            }(fa);
            Qn("SymbolLineVertexArray", ka);
            var Aa = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4;
              var r4 = { featureIndex: { configurable: true }, sourceLayerIndex: { configurable: true }, bucketIndex: { configurable: true } };
              return r4.featureIndex.get = function() {
                return this._structArray.uint32[this._pos4 + 0];
              }, r4.sourceLayerIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 2];
              }, r4.bucketIndex.get = function() {
                return this._structArray.uint16[this._pos2 + 3];
              }, Object.defineProperties(e4.prototype, r4), e4;
            }(Gi);
            Aa.prototype.size = 8;
            var Ma = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.get = function(t6) {
                return new Aa(this, t6);
              }, e4;
            }(ha);
            Qn("FeatureIndexArray", Ma);
            var Sa = Yi([{ name: "a_pos", components: 2, type: "Int16" }], 4).members, Ea = function(t5) {
              void 0 === t5 && (t5 = []), this.segments = t5;
            };
            function La(t5, e4) {
              return 256 * (t5 = u(Math.floor(t5), 0, 255)) + u(Math.floor(e4), 0, 255);
            }
            Ea.prototype.prepareSegment = function(t5, e4, r4, n4) {
              var i2 = this.segments[this.segments.length - 1];
              return t5 > Ea.MAX_VERTEX_ARRAY_LENGTH && w2("Max vertices per segment is " + Ea.MAX_VERTEX_ARRAY_LENGTH + ": bucket requested " + t5), (!i2 || i2.vertexLength + t5 > Ea.MAX_VERTEX_ARRAY_LENGTH || i2.sortKey !== n4) && (i2 = { vertexOffset: e4.length, primitiveOffset: r4.length, vertexLength: 0, primitiveLength: 0 }, void 0 !== n4 && (i2.sortKey = n4), this.segments.push(i2)), i2;
            }, Ea.prototype.get = function() {
              return this.segments;
            }, Ea.prototype.destroy = function() {
              for (var t5 = 0, e4 = this.segments; t5 < e4.length; t5 += 1) {
                var r4 = e4[t5];
                for (var n4 in r4.vaos)
                  r4.vaos[n4].destroy();
              }
            }, Ea.simpleSegment = function(t5, e4, r4, n4) {
              return new Ea([{ vertexOffset: t5, primitiveOffset: e4, vertexLength: r4, primitiveLength: n4, vaos: {}, sortKey: 0 }]);
            }, Ea.MAX_VERTEX_ARRAY_LENGTH = Math.pow(2, 16) - 1, Qn("SegmentVector", Ea);
            var Ca = Yi([{ name: "a_pattern_from", components: 4, type: "Uint16" }, { name: "a_pattern_to", components: 4, type: "Uint16" }, { name: "a_pixel_ratio_from", components: 1, type: "Uint8" }, { name: "a_pixel_ratio_to", components: 1, type: "Uint8" }]), Pa = e3(function(t5) {
              t5.exports = function(t6, e4) {
                var r4, n4, i2, a2, o2, s2, l2, u2;
                for (r4 = 3 & t6.length, n4 = t6.length - r4, i2 = e4, o2 = 3432918353, s2 = 461845907, u2 = 0; u2 < n4; )
                  l2 = 255 & t6.charCodeAt(u2) | (255 & t6.charCodeAt(++u2)) << 8 | (255 & t6.charCodeAt(++u2)) << 16 | (255 & t6.charCodeAt(++u2)) << 24, ++u2, i2 = 27492 + (65535 & (a2 = 5 * (65535 & (i2 = (i2 ^= l2 = (65535 & (l2 = (l2 = (65535 & l2) * o2 + (((l2 >>> 16) * o2 & 65535) << 16) & 4294967295) << 15 | l2 >>> 17)) * s2 + (((l2 >>> 16) * s2 & 65535) << 16) & 4294967295) << 13 | i2 >>> 19)) + ((5 * (i2 >>> 16) & 65535) << 16) & 4294967295)) + ((58964 + (a2 >>> 16) & 65535) << 16);
                switch (l2 = 0, r4) {
                  case 3:
                    l2 ^= (255 & t6.charCodeAt(u2 + 2)) << 16;
                  case 2:
                    l2 ^= (255 & t6.charCodeAt(u2 + 1)) << 8;
                  case 1:
                    i2 ^= l2 = (65535 & (l2 = (l2 = (65535 & (l2 ^= 255 & t6.charCodeAt(u2))) * o2 + (((l2 >>> 16) * o2 & 65535) << 16) & 4294967295) << 15 | l2 >>> 17)) * s2 + (((l2 >>> 16) * s2 & 65535) << 16) & 4294967295;
                }
                return i2 ^= t6.length, i2 = 2246822507 * (65535 & (i2 ^= i2 >>> 16)) + ((2246822507 * (i2 >>> 16) & 65535) << 16) & 4294967295, i2 = 3266489909 * (65535 & (i2 ^= i2 >>> 13)) + ((3266489909 * (i2 >>> 16) & 65535) << 16) & 4294967295, (i2 ^= i2 >>> 16) >>> 0;
              };
            }), Oa = e3(function(t5) {
              t5.exports = function(t6, e4) {
                for (var r4, n4 = t6.length, i2 = e4 ^ n4, a2 = 0; n4 >= 4; )
                  r4 = 1540483477 * (65535 & (r4 = 255 & t6.charCodeAt(a2) | (255 & t6.charCodeAt(++a2)) << 8 | (255 & t6.charCodeAt(++a2)) << 16 | (255 & t6.charCodeAt(++a2)) << 24)) + ((1540483477 * (r4 >>> 16) & 65535) << 16), i2 = 1540483477 * (65535 & i2) + ((1540483477 * (i2 >>> 16) & 65535) << 16) ^ (r4 = 1540483477 * (65535 & (r4 ^= r4 >>> 24)) + ((1540483477 * (r4 >>> 16) & 65535) << 16)), n4 -= 4, ++a2;
                switch (n4) {
                  case 3:
                    i2 ^= (255 & t6.charCodeAt(a2 + 2)) << 16;
                  case 2:
                    i2 ^= (255 & t6.charCodeAt(a2 + 1)) << 8;
                  case 1:
                    i2 = 1540483477 * (65535 & (i2 ^= 255 & t6.charCodeAt(a2))) + ((1540483477 * (i2 >>> 16) & 65535) << 16);
                }
                return i2 = 1540483477 * (65535 & (i2 ^= i2 >>> 13)) + ((1540483477 * (i2 >>> 16) & 65535) << 16), (i2 ^= i2 >>> 15) >>> 0;
              };
            }), Ia = Pa, Da = Pa, za = Oa;
            Ia.murmur3 = Da, Ia.murmur2 = za;
            var Ra = function() {
              this.ids = [], this.positions = [], this.indexed = false;
            };
            Ra.prototype.add = function(t5, e4, r4, n4) {
              this.ids.push(Ba(t5)), this.positions.push(e4, r4, n4);
            }, Ra.prototype.getPositions = function(t5) {
              for (var e4 = Ba(t5), r4 = 0, n4 = this.ids.length - 1; r4 < n4; ) {
                var i2 = r4 + n4 >> 1;
                this.ids[i2] >= e4 ? n4 = i2 : r4 = i2 + 1;
              }
              for (var a2 = []; this.ids[r4] === e4; ) {
                var o2 = this.positions[3 * r4], s2 = this.positions[3 * r4 + 1], l2 = this.positions[3 * r4 + 2];
                a2.push({ index: o2, start: s2, end: l2 }), r4++;
              }
              return a2;
            }, Ra.serialize = function(t5, e4) {
              var r4 = new Float64Array(t5.ids), n4 = new Uint32Array(t5.positions);
              return Na(r4, n4, 0, r4.length - 1), e4 && e4.push(r4.buffer, n4.buffer), { ids: r4, positions: n4 };
            }, Ra.deserialize = function(t5) {
              var e4 = new Ra();
              return e4.ids = t5.ids, e4.positions = t5.positions, e4.indexed = true, e4;
            };
            var Fa = Math.pow(2, 53) - 1;
            function Ba(t5) {
              var e4 = +t5;
              return !isNaN(e4) && e4 <= Fa ? e4 : Ia(String(t5));
            }
            function Na(t5, e4, r4, n4) {
              for (; r4 < n4; ) {
                for (var i2 = t5[r4 + n4 >> 1], a2 = r4 - 1, o2 = n4 + 1; ; ) {
                  do {
                    a2++;
                  } while (t5[a2] < i2);
                  do {
                    o2--;
                  } while (t5[o2] > i2);
                  if (a2 >= o2)
                    break;
                  ja(t5, a2, o2), ja(e4, 3 * a2, 3 * o2), ja(e4, 3 * a2 + 1, 3 * o2 + 1), ja(e4, 3 * a2 + 2, 3 * o2 + 2);
                }
                o2 - r4 < n4 - o2 ? (Na(t5, e4, r4, o2), r4 = o2 + 1) : (Na(t5, e4, o2 + 1, n4), n4 = o2);
              }
            }
            function ja(t5, e4, r4) {
              var n4 = t5[e4];
              t5[e4] = t5[r4], t5[r4] = n4;
            }
            Qn("FeaturePositionMap", Ra);
            var Ua = function(t5, e4) {
              this.gl = t5.gl, this.location = e4;
            }, Va = function(t5) {
              function e4(e5, r4) {
                t5.call(this, e5, r4), this.current = 0;
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.set = function(t6) {
                this.current !== t6 && (this.current = t6, this.gl.uniform1i(this.location, t6));
              }, e4;
            }(Ua), Ha = function(t5) {
              function e4(e5, r4) {
                t5.call(this, e5, r4), this.current = 0;
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.set = function(t6) {
                this.current !== t6 && (this.current = t6, this.gl.uniform1f(this.location, t6));
              }, e4;
            }(Ua), qa = function(t5) {
              function e4(e5, r4) {
                t5.call(this, e5, r4), this.current = [0, 0];
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.set = function(t6) {
                t6[0] === this.current[0] && t6[1] === this.current[1] || (this.current = t6, this.gl.uniform2f(this.location, t6[0], t6[1]));
              }, e4;
            }(Ua), Ga = function(t5) {
              function e4(e5, r4) {
                t5.call(this, e5, r4), this.current = [0, 0, 0];
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.set = function(t6) {
                t6[0] === this.current[0] && t6[1] === this.current[1] && t6[2] === this.current[2] || (this.current = t6, this.gl.uniform3f(this.location, t6[0], t6[1], t6[2]));
              }, e4;
            }(Ua), Za = function(t5) {
              function e4(e5, r4) {
                t5.call(this, e5, r4), this.current = [0, 0, 0, 0];
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.set = function(t6) {
                t6[0] === this.current[0] && t6[1] === this.current[1] && t6[2] === this.current[2] && t6[3] === this.current[3] || (this.current = t6, this.gl.uniform4f(this.location, t6[0], t6[1], t6[2], t6[3]));
              }, e4;
            }(Ua), Ya = function(t5) {
              function e4(e5, r4) {
                t5.call(this, e5, r4), this.current = ae.transparent;
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.set = function(t6) {
                t6.r === this.current.r && t6.g === this.current.g && t6.b === this.current.b && t6.a === this.current.a || (this.current = t6, this.gl.uniform4f(this.location, t6.r, t6.g, t6.b, t6.a));
              }, e4;
            }(Ua), Wa = new Float32Array(16), Xa = function(t5) {
              function e4(e5, r4) {
                t5.call(this, e5, r4), this.current = Wa;
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.set = function(t6) {
                if (t6[12] !== this.current[12] || t6[0] !== this.current[0])
                  return this.current = t6, void this.gl.uniformMatrix4fv(this.location, false, t6);
                for (var e5 = 1; e5 < 16; e5++)
                  if (t6[e5] !== this.current[e5]) {
                    this.current = t6, this.gl.uniformMatrix4fv(this.location, false, t6);
                    break;
                  }
              }, e4;
            }(Ua);
            function Ja(t5) {
              return [La(255 * t5.r, 255 * t5.g), La(255 * t5.b, 255 * t5.a)];
            }
            var Ka = function(t5, e4, r4) {
              this.value = t5, this.uniformNames = e4.map(function(t6) {
                return "u_" + t6;
              }), this.type = r4;
            };
            Ka.prototype.setUniform = function(t5, e4, r4) {
              t5.set(r4.constantOr(this.value));
            }, Ka.prototype.getBinding = function(t5, e4, r4) {
              return "color" === this.type ? new Ya(t5, e4) : new Ha(t5, e4);
            };
            var $a = function(t5, e4) {
              this.uniformNames = e4.map(function(t6) {
                return "u_" + t6;
              }), this.patternFrom = null, this.patternTo = null, this.pixelRatioFrom = 1, this.pixelRatioTo = 1;
            };
            $a.prototype.setConstantPatternPositions = function(t5, e4) {
              this.pixelRatioFrom = e4.pixelRatio, this.pixelRatioTo = t5.pixelRatio, this.patternFrom = e4.tlbr, this.patternTo = t5.tlbr;
            }, $a.prototype.setUniform = function(t5, e4, r4, n4) {
              var i2 = "u_pattern_to" === n4 ? this.patternTo : "u_pattern_from" === n4 ? this.patternFrom : "u_pixel_ratio_to" === n4 ? this.pixelRatioTo : "u_pixel_ratio_from" === n4 ? this.pixelRatioFrom : null;
              i2 && t5.set(i2);
            }, $a.prototype.getBinding = function(t5, e4, r4) {
              return "u_pattern" === r4.substr(0, 9) ? new Za(t5, e4) : new Ha(t5, e4);
            };
            var Qa = function(t5, e4, r4, n4) {
              this.expression = t5, this.type = r4, this.maxValue = 0, this.paintVertexAttributes = e4.map(function(t6) {
                return { name: "a_" + t6, type: "Float32", components: "color" === r4 ? 2 : 1, offset: 0 };
              }), this.paintVertexArray = new n4();
            };
            Qa.prototype.populatePaintArray = function(t5, e4, r4, n4, i2) {
              var a2 = this.paintVertexArray.length, o2 = this.expression.evaluate(new Si(0), e4, {}, n4, [], i2);
              this.paintVertexArray.resize(t5), this._setPaintValue(a2, t5, o2);
            }, Qa.prototype.updatePaintArray = function(t5, e4, r4, n4) {
              var i2 = this.expression.evaluate({ zoom: 0 }, r4, n4);
              this._setPaintValue(t5, e4, i2);
            }, Qa.prototype._setPaintValue = function(t5, e4, r4) {
              if ("color" === this.type)
                for (var n4 = Ja(r4), i2 = t5; i2 < e4; i2++)
                  this.paintVertexArray.emplace(i2, n4[0], n4[1]);
              else {
                for (var a2 = t5; a2 < e4; a2++)
                  this.paintVertexArray.emplace(a2, r4);
                this.maxValue = Math.max(this.maxValue, Math.abs(r4));
              }
            }, Qa.prototype.upload = function(t5) {
              this.paintVertexArray && this.paintVertexArray.arrayBuffer && (this.paintVertexBuffer && this.paintVertexBuffer.buffer ? this.paintVertexBuffer.updateData(this.paintVertexArray) : this.paintVertexBuffer = t5.createVertexBuffer(this.paintVertexArray, this.paintVertexAttributes, this.expression.isStateDependent));
            }, Qa.prototype.destroy = function() {
              this.paintVertexBuffer && this.paintVertexBuffer.destroy();
            };
            var to = function(t5, e4, r4, n4, i2, a2) {
              this.expression = t5, this.uniformNames = e4.map(function(t6) {
                return "u_" + t6 + "_t";
              }), this.type = r4, this.useIntegerZoom = n4, this.zoom = i2, this.maxValue = 0, this.paintVertexAttributes = e4.map(function(t6) {
                return { name: "a_" + t6, type: "Float32", components: "color" === r4 ? 4 : 2, offset: 0 };
              }), this.paintVertexArray = new a2();
            };
            to.prototype.populatePaintArray = function(t5, e4, r4, n4, i2) {
              var a2 = this.expression.evaluate(new Si(this.zoom), e4, {}, n4, [], i2), o2 = this.expression.evaluate(new Si(this.zoom + 1), e4, {}, n4, [], i2), s2 = this.paintVertexArray.length;
              this.paintVertexArray.resize(t5), this._setPaintValue(s2, t5, a2, o2);
            }, to.prototype.updatePaintArray = function(t5, e4, r4, n4) {
              var i2 = this.expression.evaluate({ zoom: this.zoom }, r4, n4), a2 = this.expression.evaluate({ zoom: this.zoom + 1 }, r4, n4);
              this._setPaintValue(t5, e4, i2, a2);
            }, to.prototype._setPaintValue = function(t5, e4, r4, n4) {
              if ("color" === this.type)
                for (var i2 = Ja(r4), a2 = Ja(n4), o2 = t5; o2 < e4; o2++)
                  this.paintVertexArray.emplace(o2, i2[0], i2[1], a2[0], a2[1]);
              else {
                for (var s2 = t5; s2 < e4; s2++)
                  this.paintVertexArray.emplace(s2, r4, n4);
                this.maxValue = Math.max(this.maxValue, Math.abs(r4), Math.abs(n4));
              }
            }, to.prototype.upload = function(t5) {
              this.paintVertexArray && this.paintVertexArray.arrayBuffer && (this.paintVertexBuffer && this.paintVertexBuffer.buffer ? this.paintVertexBuffer.updateData(this.paintVertexArray) : this.paintVertexBuffer = t5.createVertexBuffer(this.paintVertexArray, this.paintVertexAttributes, this.expression.isStateDependent));
            }, to.prototype.destroy = function() {
              this.paintVertexBuffer && this.paintVertexBuffer.destroy();
            }, to.prototype.setUniform = function(t5, e4) {
              var r4 = this.useIntegerZoom ? Math.floor(e4.zoom) : e4.zoom, n4 = u(this.expression.interpolationFactor(r4, this.zoom, this.zoom + 1), 0, 1);
              t5.set(n4);
            }, to.prototype.getBinding = function(t5, e4, r4) {
              return new Ha(t5, e4);
            };
            var eo = function(t5, e4, r4, n4, i2, a2) {
              this.expression = t5, this.type = e4, this.useIntegerZoom = r4, this.zoom = n4, this.layerId = a2, this.zoomInPaintVertexArray = new i2(), this.zoomOutPaintVertexArray = new i2();
            };
            eo.prototype.populatePaintArray = function(t5, e4, r4) {
              var n4 = this.zoomInPaintVertexArray.length;
              this.zoomInPaintVertexArray.resize(t5), this.zoomOutPaintVertexArray.resize(t5), this._setPaintValues(n4, t5, e4.patterns && e4.patterns[this.layerId], r4);
            }, eo.prototype.updatePaintArray = function(t5, e4, r4, n4, i2) {
              this._setPaintValues(t5, e4, r4.patterns && r4.patterns[this.layerId], i2);
            }, eo.prototype._setPaintValues = function(t5, e4, r4, n4) {
              if (n4 && r4) {
                var i2 = r4.min, a2 = r4.mid, o2 = r4.max, s2 = n4[i2], l2 = n4[a2], u2 = n4[o2];
                if (s2 && l2 && u2)
                  for (var c2 = t5; c2 < e4; c2++)
                    this.zoomInPaintVertexArray.emplace(c2, l2.tl[0], l2.tl[1], l2.br[0], l2.br[1], s2.tl[0], s2.tl[1], s2.br[0], s2.br[1], l2.pixelRatio, s2.pixelRatio), this.zoomOutPaintVertexArray.emplace(c2, l2.tl[0], l2.tl[1], l2.br[0], l2.br[1], u2.tl[0], u2.tl[1], u2.br[0], u2.br[1], l2.pixelRatio, u2.pixelRatio);
              }
            }, eo.prototype.upload = function(t5) {
              this.zoomInPaintVertexArray && this.zoomInPaintVertexArray.arrayBuffer && this.zoomOutPaintVertexArray && this.zoomOutPaintVertexArray.arrayBuffer && (this.zoomInPaintVertexBuffer = t5.createVertexBuffer(this.zoomInPaintVertexArray, Ca.members, this.expression.isStateDependent), this.zoomOutPaintVertexBuffer = t5.createVertexBuffer(this.zoomOutPaintVertexArray, Ca.members, this.expression.isStateDependent));
            }, eo.prototype.destroy = function() {
              this.zoomOutPaintVertexBuffer && this.zoomOutPaintVertexBuffer.destroy(), this.zoomInPaintVertexBuffer && this.zoomInPaintVertexBuffer.destroy();
            };
            var ro = function(t5, e4, r4, n4) {
              this.binders = {}, this.layoutAttributes = n4, this._buffers = [];
              var i2 = [];
              for (var a2 in t5.paint._values)
                if (r4(a2)) {
                  var o2 = t5.paint.get(a2);
                  if (o2 instanceof Di && qr(o2.property.specification)) {
                    var s2 = io(a2, t5.type), l2 = o2.value, u2 = o2.property.specification.type, c2 = o2.property.useIntegerZoom, f3 = o2.property.specification["property-type"], h2 = "cross-faded" === f3 || "cross-faded-data-driven" === f3;
                    if ("constant" === l2.kind)
                      this.binders[a2] = h2 ? new $a(l2.value, s2) : new Ka(l2.value, s2, u2), i2.push("/u_" + a2);
                    else if ("source" === l2.kind || h2) {
                      var p3 = ao(a2, u2, "source");
                      this.binders[a2] = h2 ? new eo(l2, u2, c2, e4, p3, t5.id) : new Qa(l2, s2, u2, p3), i2.push("/a_" + a2);
                    } else {
                      var d3 = ao(a2, u2, "composite");
                      this.binders[a2] = new to(l2, s2, u2, c2, e4, d3), i2.push("/z_" + a2);
                    }
                  }
                }
              this.cacheKey = i2.sort().join("");
            };
            ro.prototype.getMaxValue = function(t5) {
              var e4 = this.binders[t5];
              return e4 instanceof Qa || e4 instanceof to ? e4.maxValue : 0;
            }, ro.prototype.populatePaintArrays = function(t5, e4, r4, n4, i2) {
              for (var a2 in this.binders) {
                var o2 = this.binders[a2];
                (o2 instanceof Qa || o2 instanceof to || o2 instanceof eo) && o2.populatePaintArray(t5, e4, r4, n4, i2);
              }
            }, ro.prototype.setConstantPatternPositions = function(t5, e4) {
              for (var r4 in this.binders) {
                var n4 = this.binders[r4];
                n4 instanceof $a && n4.setConstantPatternPositions(t5, e4);
              }
            }, ro.prototype.updatePaintArrays = function(t5, e4, r4, n4, i2) {
              var a2 = false;
              for (var o2 in t5)
                for (var s2 = 0, l2 = e4.getPositions(o2); s2 < l2.length; s2 += 1) {
                  var u2 = l2[s2], c2 = r4.feature(u2.index);
                  for (var f3 in this.binders) {
                    var h2 = this.binders[f3];
                    if ((h2 instanceof Qa || h2 instanceof to || h2 instanceof eo) && true === h2.expression.isStateDependent) {
                      var p3 = n4.paint.get(f3);
                      h2.expression = p3.value, h2.updatePaintArray(u2.start, u2.end, c2, t5[o2], i2), a2 = true;
                    }
                  }
                }
              return a2;
            }, ro.prototype.defines = function() {
              var t5 = [];
              for (var e4 in this.binders) {
                var r4 = this.binders[e4];
                (r4 instanceof Ka || r4 instanceof $a) && t5.push.apply(t5, r4.uniformNames.map(function(t6) {
                  return "#define HAS_UNIFORM_" + t6;
                }));
              }
              return t5;
            }, ro.prototype.getPaintVertexBuffers = function() {
              return this._buffers;
            }, ro.prototype.getUniforms = function(t5, e4) {
              var r4 = [];
              for (var n4 in this.binders) {
                var i2 = this.binders[n4];
                if (i2 instanceof Ka || i2 instanceof $a || i2 instanceof to)
                  for (var a2 = 0, o2 = i2.uniformNames; a2 < o2.length; a2 += 1) {
                    var s2 = o2[a2];
                    if (e4[s2]) {
                      var l2 = i2.getBinding(t5, e4[s2], s2);
                      r4.push({ name: s2, property: n4, binding: l2 });
                    }
                  }
              }
              return r4;
            }, ro.prototype.setUniforms = function(t5, e4, r4, n4) {
              for (var i2 = 0, a2 = e4; i2 < a2.length; i2 += 1) {
                var o2 = a2[i2], s2 = o2.name, l2 = o2.property, u2 = o2.binding;
                this.binders[l2].setUniform(u2, n4, r4.get(l2), s2);
              }
            }, ro.prototype.updatePaintBuffers = function(t5) {
              for (var e4 in this._buffers = [], this.binders) {
                var r4 = this.binders[e4];
                if (t5 && r4 instanceof eo) {
                  var n4 = 2 === t5.fromScale ? r4.zoomInPaintVertexBuffer : r4.zoomOutPaintVertexBuffer;
                  n4 && this._buffers.push(n4);
                } else
                  (r4 instanceof Qa || r4 instanceof to) && r4.paintVertexBuffer && this._buffers.push(r4.paintVertexBuffer);
              }
            }, ro.prototype.upload = function(t5) {
              for (var e4 in this.binders) {
                var r4 = this.binders[e4];
                (r4 instanceof Qa || r4 instanceof to || r4 instanceof eo) && r4.upload(t5);
              }
              this.updatePaintBuffers();
            }, ro.prototype.destroy = function() {
              for (var t5 in this.binders) {
                var e4 = this.binders[t5];
                (e4 instanceof Qa || e4 instanceof to || e4 instanceof eo) && e4.destroy();
              }
            };
            var no = function(t5, e4, r4, n4) {
              void 0 === n4 && (n4 = function() {
                return true;
              }), this.programConfigurations = {};
              for (var i2 = 0, a2 = e4; i2 < a2.length; i2 += 1) {
                var o2 = a2[i2];
                this.programConfigurations[o2.id] = new ro(o2, r4, n4, t5);
              }
              this.needsUpload = false, this._featureMap = new Ra(), this._bufferOffset = 0;
            };
            function io(t5, e4) {
              return { "text-opacity": ["opacity"], "icon-opacity": ["opacity"], "text-color": ["fill_color"], "icon-color": ["fill_color"], "text-halo-color": ["halo_color"], "icon-halo-color": ["halo_color"], "text-halo-blur": ["halo_blur"], "icon-halo-blur": ["halo_blur"], "text-halo-width": ["halo_width"], "icon-halo-width": ["halo_width"], "line-gap-width": ["gapwidth"], "line-pattern": ["pattern_to", "pattern_from", "pixel_ratio_to", "pixel_ratio_from"], "fill-pattern": ["pattern_to", "pattern_from", "pixel_ratio_to", "pixel_ratio_from"], "fill-extrusion-pattern": ["pattern_to", "pattern_from", "pixel_ratio_to", "pixel_ratio_from"] }[t5] || [t5.replace(e4 + "-", "").replace(/-/g, "_")];
            }
            function ao(t5, e4, r4) {
              var n4 = { color: { source: va, composite: ga }, number: { source: ca, composite: va } }, i2 = function(t6) {
                return { "line-pattern": { source: Qi, composite: Qi }, "fill-pattern": { source: Qi, composite: Qi }, "fill-extrusion-pattern": { source: Qi, composite: Qi } }[t6];
              }(t5);
              return i2 && i2[r4] || n4[e4][r4];
            }
            no.prototype.populatePaintArrays = function(t5, e4, r4, n4, i2, a2) {
              for (var o2 in this.programConfigurations)
                this.programConfigurations[o2].populatePaintArrays(t5, e4, n4, i2, a2);
              void 0 !== e4.id && this._featureMap.add(e4.id, r4, this._bufferOffset, t5), this._bufferOffset = t5, this.needsUpload = true;
            }, no.prototype.updatePaintArrays = function(t5, e4, r4, n4) {
              for (var i2 = 0, a2 = r4; i2 < a2.length; i2 += 1) {
                var o2 = a2[i2];
                this.needsUpload = this.programConfigurations[o2.id].updatePaintArrays(t5, this._featureMap, e4, o2, n4) || this.needsUpload;
              }
            }, no.prototype.get = function(t5) {
              return this.programConfigurations[t5];
            }, no.prototype.upload = function(t5) {
              if (this.needsUpload) {
                for (var e4 in this.programConfigurations)
                  this.programConfigurations[e4].upload(t5);
                this.needsUpload = false;
              }
            }, no.prototype.destroy = function() {
              for (var t5 in this.programConfigurations)
                this.programConfigurations[t5].destroy();
            }, Qn("ConstantBinder", Ka), Qn("CrossFadedConstantBinder", $a), Qn("SourceExpressionBinder", Qa), Qn("CrossFadedCompositeBinder", eo), Qn("CompositeExpressionBinder", to), Qn("ProgramConfiguration", ro, { omit: ["_buffers"] }), Qn("ProgramConfigurationSet", no);
            var oo = 8192;
            var so, lo = (so = 15, { min: -1 * Math.pow(2, so - 1), max: Math.pow(2, so - 1) - 1 });
            function uo(t5) {
              for (var e4 = oo / t5.extent, r4 = t5.loadGeometry(), n4 = 0; n4 < r4.length; n4++)
                for (var i2 = r4[n4], a2 = 0; a2 < i2.length; a2++) {
                  var o2 = i2[a2];
                  o2.x = Math.round(o2.x * e4), o2.y = Math.round(o2.y * e4), (o2.x < lo.min || o2.x > lo.max || o2.y < lo.min || o2.y > lo.max) && (w2("Geometry exceeds allowed extent, reduce your vector tile buffer size"), o2.x = u(o2.x, lo.min, lo.max), o2.y = u(o2.y, lo.min, lo.max));
                }
              return r4;
            }
            function co(t5, e4, r4, n4, i2) {
              t5.emplaceBack(2 * e4 + (n4 + 1) / 2, 2 * r4 + (i2 + 1) / 2);
            }
            var fo = function(t5) {
              this.zoom = t5.zoom, this.overscaling = t5.overscaling, this.layers = t5.layers, this.layerIds = this.layers.map(function(t6) {
                return t6.id;
              }), this.index = t5.index, this.hasPattern = false, this.layoutVertexArray = new Xi(), this.indexArray = new sa(), this.segments = new Ea(), this.programConfigurations = new no(Sa, t5.layers, t5.zoom), this.stateDependentLayerIds = this.layers.filter(function(t6) {
                return t6.isStateDependent();
              }).map(function(t6) {
                return t6.id;
              });
            };
            function ho(t5, e4) {
              for (var r4 = 0; r4 < t5.length; r4++)
                if (wo(e4, t5[r4]))
                  return true;
              for (var n4 = 0; n4 < e4.length; n4++)
                if (wo(t5, e4[n4]))
                  return true;
              return !!yo(t5, e4);
            }
            function po(t5, e4, r4) {
              return !!wo(t5, e4) || !!xo(e4, t5, r4);
            }
            function vo(t5, e4) {
              if (1 === t5.length)
                return _o(e4, t5[0]);
              for (var r4 = 0; r4 < e4.length; r4++)
                for (var n4 = e4[r4], i2 = 0; i2 < n4.length; i2++)
                  if (wo(t5, n4[i2]))
                    return true;
              for (var a2 = 0; a2 < t5.length; a2++)
                if (_o(e4, t5[a2]))
                  return true;
              for (var o2 = 0; o2 < e4.length; o2++)
                if (yo(t5, e4[o2]))
                  return true;
              return false;
            }
            function go(t5, e4, r4) {
              if (t5.length > 1) {
                if (yo(t5, e4))
                  return true;
                for (var n4 = 0; n4 < e4.length; n4++)
                  if (xo(e4[n4], t5, r4))
                    return true;
              }
              for (var i2 = 0; i2 < t5.length; i2++)
                if (xo(t5[i2], e4, r4))
                  return true;
              return false;
            }
            function yo(t5, e4) {
              if (0 === t5.length || 0 === e4.length)
                return false;
              for (var r4 = 0; r4 < t5.length - 1; r4++)
                for (var n4 = t5[r4], i2 = t5[r4 + 1], a2 = 0; a2 < e4.length - 1; a2++)
                  if (mo2(n4, i2, e4[a2], e4[a2 + 1]))
                    return true;
              return false;
            }
            function mo2(t5, e4, r4, n4) {
              return T(t5, r4, n4) !== T(e4, r4, n4) && T(t5, e4, r4) !== T(t5, e4, n4);
            }
            function xo(t5, e4, r4) {
              var n4 = r4 * r4;
              if (1 === e4.length)
                return t5.distSqr(e4[0]) < n4;
              for (var i2 = 1; i2 < e4.length; i2++)
                if (bo(t5, e4[i2 - 1], e4[i2]) < n4)
                  return true;
              return false;
            }
            function bo(t5, e4, r4) {
              var n4 = e4.distSqr(r4);
              if (0 === n4)
                return t5.distSqr(e4);
              var i2 = ((t5.x - e4.x) * (r4.x - e4.x) + (t5.y - e4.y) * (r4.y - e4.y)) / n4;
              return i2 < 0 ? t5.distSqr(e4) : i2 > 1 ? t5.distSqr(r4) : t5.distSqr(r4.sub(e4)._mult(i2)._add(e4));
            }
            function _o(t5, e4) {
              for (var r4, n4, i2, a2 = false, o2 = 0; o2 < t5.length; o2++)
                for (var s2 = 0, l2 = (r4 = t5[o2]).length - 1; s2 < r4.length; l2 = s2++)
                  n4 = r4[s2], i2 = r4[l2], n4.y > e4.y != i2.y > e4.y && e4.x < (i2.x - n4.x) * (e4.y - n4.y) / (i2.y - n4.y) + n4.x && (a2 = !a2);
              return a2;
            }
            function wo(t5, e4) {
              for (var r4 = false, n4 = 0, i2 = t5.length - 1; n4 < t5.length; i2 = n4++) {
                var a2 = t5[n4], o2 = t5[i2];
                a2.y > e4.y != o2.y > e4.y && e4.x < (o2.x - a2.x) * (e4.y - a2.y) / (o2.y - a2.y) + a2.x && (r4 = !r4);
              }
              return r4;
            }
            function To(t5, e4, r4) {
              var n4 = r4[0], i2 = r4[2];
              if (t5.x < n4.x && e4.x < n4.x || t5.x > i2.x && e4.x > i2.x || t5.y < n4.y && e4.y < n4.y || t5.y > i2.y && e4.y > i2.y)
                return false;
              var a2 = T(t5, e4, r4[0]);
              return a2 !== T(t5, e4, r4[1]) || a2 !== T(t5, e4, r4[2]) || a2 !== T(t5, e4, r4[3]);
            }
            function ko(t5, e4, r4) {
              var n4 = e4.paint.get(t5).value;
              return "constant" === n4.kind ? n4.value : r4.programConfigurations.get(e4.id).getMaxValue(t5);
            }
            function Ao(t5) {
              return Math.sqrt(t5[0] * t5[0] + t5[1] * t5[1]);
            }
            function Mo(t5, e4, r4, n4, i2) {
              if (!e4[0] && !e4[1])
                return t5;
              var o2 = a.convert(e4)._mult(i2);
              "viewport" === r4 && o2._rotate(-n4);
              for (var s2 = [], l2 = 0; l2 < t5.length; l2++) {
                var u2 = t5[l2];
                s2.push(u2.sub(o2));
              }
              return s2;
            }
            fo.prototype.populate = function(t5, e4, r4) {
              var n4 = this.layers[0], i2 = [], a2 = null;
              "circle" === n4.type && (a2 = n4.layout.get("circle-sort-key"));
              for (var o2 = 0, s2 = t5; o2 < s2.length; o2 += 1) {
                var l2 = s2[o2], u2 = l2.feature, c2 = l2.id, f3 = l2.index, h2 = l2.sourceLayerIndex, p3 = this.layers[0]._featureFilter.needGeometry, d3 = { type: u2.type, id: c2, properties: u2.properties, geometry: p3 ? uo(u2) : [] };
                if (this.layers[0]._featureFilter.filter(new Si(this.zoom), d3, r4)) {
                  p3 || (d3.geometry = uo(u2));
                  var v2 = a2 ? a2.evaluate(d3, {}, r4) : void 0, g3 = { id: c2, properties: u2.properties, type: u2.type, sourceLayerIndex: h2, index: f3, geometry: d3.geometry, patterns: {}, sortKey: v2 };
                  i2.push(g3);
                }
              }
              a2 && i2.sort(function(t6, e5) {
                return t6.sortKey - e5.sortKey;
              });
              for (var y2 = 0, m3 = i2; y2 < m3.length; y2 += 1) {
                var x2 = m3[y2], b2 = x2, _2 = b2.geometry, w3 = b2.index, T2 = b2.sourceLayerIndex, k2 = t5[w3].feature;
                this.addFeature(x2, _2, w3, r4), e4.featureIndex.insert(k2, _2, w3, T2, this.index);
              }
            }, fo.prototype.update = function(t5, e4, r4) {
              this.stateDependentLayers.length && this.programConfigurations.updatePaintArrays(t5, e4, this.stateDependentLayers, r4);
            }, fo.prototype.isEmpty = function() {
              return 0 === this.layoutVertexArray.length;
            }, fo.prototype.uploadPending = function() {
              return !this.uploaded || this.programConfigurations.needsUpload;
            }, fo.prototype.upload = function(t5) {
              this.uploaded || (this.layoutVertexBuffer = t5.createVertexBuffer(this.layoutVertexArray, Sa), this.indexBuffer = t5.createIndexBuffer(this.indexArray)), this.programConfigurations.upload(t5), this.uploaded = true;
            }, fo.prototype.destroy = function() {
              this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.programConfigurations.destroy(), this.segments.destroy());
            }, fo.prototype.addFeature = function(t5, e4, r4, n4) {
              for (var i2 = 0, a2 = e4; i2 < a2.length; i2 += 1)
                for (var o2 = 0, s2 = a2[i2]; o2 < s2.length; o2 += 1) {
                  var l2 = s2[o2], u2 = l2.x, c2 = l2.y;
                  if (!(u2 < 0 || u2 >= oo || c2 < 0 || c2 >= oo)) {
                    var f3 = this.segments.prepareSegment(4, this.layoutVertexArray, this.indexArray, t5.sortKey), h2 = f3.vertexLength;
                    co(this.layoutVertexArray, u2, c2, -1, -1), co(this.layoutVertexArray, u2, c2, 1, -1), co(this.layoutVertexArray, u2, c2, 1, 1), co(this.layoutVertexArray, u2, c2, -1, 1), this.indexArray.emplaceBack(h2, h2 + 1, h2 + 2), this.indexArray.emplaceBack(h2, h2 + 3, h2 + 2), f3.vertexLength += 4, f3.primitiveLength += 2;
                  }
                }
              this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, t5, r4, {}, n4);
            }, Qn("CircleBucket", fo, { omit: ["layers"] });
            var So = new Ui({ "circle-sort-key": new Fi(It.layout_circle["circle-sort-key"]) }), Eo = { paint: new Ui({ "circle-radius": new Fi(It.paint_circle["circle-radius"]), "circle-color": new Fi(It.paint_circle["circle-color"]), "circle-blur": new Fi(It.paint_circle["circle-blur"]), "circle-opacity": new Fi(It.paint_circle["circle-opacity"]), "circle-translate": new Ri(It.paint_circle["circle-translate"]), "circle-translate-anchor": new Ri(It.paint_circle["circle-translate-anchor"]), "circle-pitch-scale": new Ri(It.paint_circle["circle-pitch-scale"]), "circle-pitch-alignment": new Ri(It.paint_circle["circle-pitch-alignment"]), "circle-stroke-width": new Fi(It.paint_circle["circle-stroke-width"]), "circle-stroke-color": new Fi(It.paint_circle["circle-stroke-color"]), "circle-stroke-opacity": new Fi(It.paint_circle["circle-stroke-opacity"]) }), layout: So }, Lo = "undefined" != typeof Float32Array ? Float32Array : Array;
            function Co(t5) {
              return t5[0] = 1, t5[1] = 0, t5[2] = 0, t5[3] = 0, t5[4] = 0, t5[5] = 1, t5[6] = 0, t5[7] = 0, t5[8] = 0, t5[9] = 0, t5[10] = 1, t5[11] = 0, t5[12] = 0, t5[13] = 0, t5[14] = 0, t5[15] = 1, t5;
            }
            function Po(t5, e4, r4) {
              var n4 = e4[0], i2 = e4[1], a2 = e4[2], o2 = e4[3], s2 = e4[4], l2 = e4[5], u2 = e4[6], c2 = e4[7], f3 = e4[8], h2 = e4[9], p3 = e4[10], d3 = e4[11], v2 = e4[12], g3 = e4[13], y2 = e4[14], m3 = e4[15], x2 = r4[0], b2 = r4[1], _2 = r4[2], w3 = r4[3];
              return t5[0] = x2 * n4 + b2 * s2 + _2 * f3 + w3 * v2, t5[1] = x2 * i2 + b2 * l2 + _2 * h2 + w3 * g3, t5[2] = x2 * a2 + b2 * u2 + _2 * p3 + w3 * y2, t5[3] = x2 * o2 + b2 * c2 + _2 * d3 + w3 * m3, x2 = r4[4], b2 = r4[5], _2 = r4[6], w3 = r4[7], t5[4] = x2 * n4 + b2 * s2 + _2 * f3 + w3 * v2, t5[5] = x2 * i2 + b2 * l2 + _2 * h2 + w3 * g3, t5[6] = x2 * a2 + b2 * u2 + _2 * p3 + w3 * y2, t5[7] = x2 * o2 + b2 * c2 + _2 * d3 + w3 * m3, x2 = r4[8], b2 = r4[9], _2 = r4[10], w3 = r4[11], t5[8] = x2 * n4 + b2 * s2 + _2 * f3 + w3 * v2, t5[9] = x2 * i2 + b2 * l2 + _2 * h2 + w3 * g3, t5[10] = x2 * a2 + b2 * u2 + _2 * p3 + w3 * y2, t5[11] = x2 * o2 + b2 * c2 + _2 * d3 + w3 * m3, x2 = r4[12], b2 = r4[13], _2 = r4[14], w3 = r4[15], t5[12] = x2 * n4 + b2 * s2 + _2 * f3 + w3 * v2, t5[13] = x2 * i2 + b2 * l2 + _2 * h2 + w3 * g3, t5[14] = x2 * a2 + b2 * u2 + _2 * p3 + w3 * y2, t5[15] = x2 * o2 + b2 * c2 + _2 * d3 + w3 * m3, t5;
            }
            Math.hypot || (Math.hypot = function() {
              for (var t5 = arguments, e4 = 0, r4 = arguments.length; r4--; )
                e4 += t5[r4] * t5[r4];
              return Math.sqrt(e4);
            });
            var Oo = Po;
            var Io, Do = function(t5, e4, r4) {
              return t5[0] = e4[0] - r4[0], t5[1] = e4[1] - r4[1], t5[2] = e4[2] - r4[2], t5;
            };
            function zo(t5, e4, r4) {
              var n4 = e4[0], i2 = e4[1], a2 = e4[2], o2 = e4[3];
              return t5[0] = r4[0] * n4 + r4[4] * i2 + r4[8] * a2 + r4[12] * o2, t5[1] = r4[1] * n4 + r4[5] * i2 + r4[9] * a2 + r4[13] * o2, t5[2] = r4[2] * n4 + r4[6] * i2 + r4[10] * a2 + r4[14] * o2, t5[3] = r4[3] * n4 + r4[7] * i2 + r4[11] * a2 + r4[15] * o2, t5;
            }
            Io = new Lo(3), Lo != Float32Array && (Io[0] = 0, Io[1] = 0, Io[2] = 0), function() {
              var t5 = new Lo(4);
              Lo != Float32Array && (t5[0] = 0, t5[1] = 0, t5[2] = 0, t5[3] = 0);
            }();
            var Ro = function(t5) {
              var e4 = t5[0], r4 = t5[1];
              return e4 * e4 + r4 * r4;
            }, Fo = (function() {
              var t5 = new Lo(2);
              Lo != Float32Array && (t5[0] = 0, t5[1] = 0);
            }(), function(t5) {
              function e4(e5) {
                t5.call(this, e5, Eo);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.createBucket = function(t6) {
                return new fo(t6);
              }, e4.prototype.queryRadius = function(t6) {
                var e5 = t6;
                return ko("circle-radius", this, e5) + ko("circle-stroke-width", this, e5) + Ao(this.paint.get("circle-translate"));
              }, e4.prototype.queryIntersectsFeature = function(t6, e5, r4, n4, i2, a2, o2, s2) {
                for (var l2 = Mo(t6, this.paint.get("circle-translate"), this.paint.get("circle-translate-anchor"), a2.angle, o2), u2 = this.paint.get("circle-radius").evaluate(e5, r4) + this.paint.get("circle-stroke-width").evaluate(e5, r4), c2 = "map" === this.paint.get("circle-pitch-alignment"), f3 = c2 ? l2 : function(t7, e6) {
                  return t7.map(function(t8) {
                    return Bo(t8, e6);
                  });
                }(l2, s2), h2 = c2 ? u2 * o2 : u2, p3 = 0, d3 = n4; p3 < d3.length; p3 += 1)
                  for (var v2 = 0, g3 = d3[p3]; v2 < g3.length; v2 += 1) {
                    var y2 = g3[v2], m3 = c2 ? y2 : Bo(y2, s2), x2 = h2, b2 = zo([], [y2.x, y2.y, 0, 1], s2);
                    if ("viewport" === this.paint.get("circle-pitch-scale") && "map" === this.paint.get("circle-pitch-alignment") ? x2 *= b2[3] / a2.cameraToCenterDistance : "map" === this.paint.get("circle-pitch-scale") && "viewport" === this.paint.get("circle-pitch-alignment") && (x2 *= a2.cameraToCenterDistance / b2[3]), po(f3, m3, x2))
                      return true;
                  }
                return false;
              }, e4;
            }(Hi));
            function Bo(t5, e4) {
              var r4 = zo([], [t5.x, t5.y, 0, 1], e4);
              return new a(r4[0] / r4[3], r4[1] / r4[3]);
            }
            var No = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4;
            }(fo);
            function jo(t5, e4, r4, n4) {
              var i2 = e4.width, a2 = e4.height;
              if (n4) {
                if (n4 instanceof Uint8ClampedArray)
                  n4 = new Uint8Array(n4.buffer);
                else if (n4.length !== i2 * a2 * r4)
                  throw new RangeError("mismatched image size");
              } else
                n4 = new Uint8Array(i2 * a2 * r4);
              return t5.width = i2, t5.height = a2, t5.data = n4, t5;
            }
            function Uo(t5, e4, r4) {
              var n4 = e4.width, i2 = e4.height;
              if (n4 !== t5.width || i2 !== t5.height) {
                var a2 = jo({}, { width: n4, height: i2 }, r4);
                Vo(t5, a2, { x: 0, y: 0 }, { x: 0, y: 0 }, { width: Math.min(t5.width, n4), height: Math.min(t5.height, i2) }, r4), t5.width = n4, t5.height = i2, t5.data = a2.data;
              }
            }
            function Vo(t5, e4, r4, n4, i2, a2) {
              if (0 === i2.width || 0 === i2.height)
                return e4;
              if (i2.width > t5.width || i2.height > t5.height || r4.x > t5.width - i2.width || r4.y > t5.height - i2.height)
                throw new RangeError("out of range source coordinates for image copy");
              if (i2.width > e4.width || i2.height > e4.height || n4.x > e4.width - i2.width || n4.y > e4.height - i2.height)
                throw new RangeError("out of range destination coordinates for image copy");
              for (var o2 = t5.data, s2 = e4.data, l2 = 0; l2 < i2.height; l2++)
                for (var u2 = ((r4.y + l2) * t5.width + r4.x) * a2, c2 = ((n4.y + l2) * e4.width + n4.x) * a2, f3 = 0; f3 < i2.width * a2; f3++)
                  s2[c2 + f3] = o2[u2 + f3];
              return e4;
            }
            Qn("HeatmapBucket", No, { omit: ["layers"] });
            var Ho = function(t5, e4) {
              jo(this, t5, 1, e4);
            };
            Ho.prototype.resize = function(t5) {
              Uo(this, t5, 1);
            }, Ho.prototype.clone = function() {
              return new Ho({ width: this.width, height: this.height }, new Uint8Array(this.data));
            }, Ho.copy = function(t5, e4, r4, n4, i2) {
              Vo(t5, e4, r4, n4, i2, 1);
            };
            var qo = function(t5, e4) {
              jo(this, t5, 4, e4);
            };
            qo.prototype.resize = function(t5) {
              Uo(this, t5, 4);
            }, qo.prototype.replace = function(t5, e4) {
              e4 ? this.data.set(t5) : t5 instanceof Uint8ClampedArray ? this.data = new Uint8Array(t5.buffer) : this.data = t5;
            }, qo.prototype.clone = function() {
              return new qo({ width: this.width, height: this.height }, new Uint8Array(this.data));
            }, qo.copy = function(t5, e4, r4, n4, i2) {
              Vo(t5, e4, r4, n4, i2, 4);
            }, Qn("AlphaImage", Ho), Qn("RGBAImage", qo);
            var Go = { paint: new Ui({ "heatmap-radius": new Fi(It.paint_heatmap["heatmap-radius"]), "heatmap-weight": new Fi(It.paint_heatmap["heatmap-weight"]), "heatmap-intensity": new Ri(It.paint_heatmap["heatmap-intensity"]), "heatmap-color": new ji(It.paint_heatmap["heatmap-color"]), "heatmap-opacity": new Ri(It.paint_heatmap["heatmap-opacity"]) }) };
            function Zo(t5, e4) {
              for (var r4 = new Uint8Array(1024), n4 = {}, i2 = 0, a2 = 0; i2 < 256; i2++, a2 += 4) {
                n4[e4] = i2 / 255;
                var o2 = t5.evaluate(n4);
                r4[a2 + 0] = Math.floor(255 * o2.r / o2.a), r4[a2 + 1] = Math.floor(255 * o2.g / o2.a), r4[a2 + 2] = Math.floor(255 * o2.b / o2.a), r4[a2 + 3] = Math.floor(255 * o2.a);
              }
              return new qo({ width: 256, height: 1 }, r4);
            }
            var Yo = function(t5) {
              function e4(e5) {
                t5.call(this, e5, Go), this._updateColorRamp();
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.createBucket = function(t6) {
                return new No(t6);
              }, e4.prototype._handleSpecialPaintPropertyUpdate = function(t6) {
                "heatmap-color" === t6 && this._updateColorRamp();
              }, e4.prototype._updateColorRamp = function() {
                var t6 = this._transitionablePaint._values["heatmap-color"].value.expression;
                this.colorRamp = Zo(t6, "heatmapDensity"), this.colorRampTexture = null;
              }, e4.prototype.resize = function() {
                this.heatmapFbo && (this.heatmapFbo.destroy(), this.heatmapFbo = null);
              }, e4.prototype.queryRadius = function() {
                return 0;
              }, e4.prototype.queryIntersectsFeature = function() {
                return false;
              }, e4.prototype.hasOffscreenPass = function() {
                return 0 !== this.paint.get("heatmap-opacity") && "none" !== this.visibility;
              }, e4;
            }(Hi), Wo = { paint: new Ui({ "hillshade-illumination-direction": new Ri(It.paint_hillshade["hillshade-illumination-direction"]), "hillshade-illumination-anchor": new Ri(It.paint_hillshade["hillshade-illumination-anchor"]), "hillshade-exaggeration": new Ri(It.paint_hillshade["hillshade-exaggeration"]), "hillshade-shadow-color": new Ri(It.paint_hillshade["hillshade-shadow-color"]), "hillshade-highlight-color": new Ri(It.paint_hillshade["hillshade-highlight-color"]), "hillshade-accent-color": new Ri(It.paint_hillshade["hillshade-accent-color"]) }) }, Xo = function(t5) {
              function e4(e5) {
                t5.call(this, e5, Wo);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.hasOffscreenPass = function() {
                return 0 !== this.paint.get("hillshade-exaggeration") && "none" !== this.visibility;
              }, e4;
            }(Hi), Jo = Yi([{ name: "a_pos", components: 2, type: "Int16" }], 4).members, Ko = Qo, $o = Qo;
            function Qo(t5, e4, r4) {
              r4 = r4 || 2;
              var n4, i2, a2, o2, s2, l2, u2, c2 = e4 && e4.length, f3 = c2 ? e4[0] * r4 : t5.length, h2 = ts(t5, 0, f3, r4, true), p3 = [];
              if (!h2 || h2.next === h2.prev)
                return p3;
              if (c2 && (h2 = function(t6, e5, r5, n5) {
                var i3, a3, o3, s3 = [];
                for (i3 = 0, a3 = e5.length; i3 < a3; i3++)
                  (o3 = ts(t6, e5[i3] * n5, i3 < a3 - 1 ? e5[i3 + 1] * n5 : t6.length, n5, false)) === o3.next && (o3.steiner = true), s3.push(fs(o3));
                for (s3.sort(ss), i3 = 0; i3 < s3.length; i3++)
                  ls(s3[i3], r5), r5 = es(r5, r5.next);
                return r5;
              }(t5, e4, h2, r4)), t5.length > 80 * r4) {
                n4 = a2 = t5[0], i2 = o2 = t5[1];
                for (var d3 = r4; d3 < f3; d3 += r4)
                  (s2 = t5[d3]) < n4 && (n4 = s2), (l2 = t5[d3 + 1]) < i2 && (i2 = l2), s2 > a2 && (a2 = s2), l2 > o2 && (o2 = l2);
                u2 = 0 !== (u2 = Math.max(a2 - n4, o2 - i2)) ? 1 / u2 : 0;
              }
              return rs(h2, p3, r4, n4, i2, u2), p3;
            }
            function ts(t5, e4, r4, n4, i2) {
              var a2, o2;
              if (i2 === ks(t5, e4, r4, n4) > 0)
                for (a2 = e4; a2 < r4; a2 += n4)
                  o2 = _s(a2, t5[a2], t5[a2 + 1], o2);
              else
                for (a2 = r4 - n4; a2 >= e4; a2 -= n4)
                  o2 = _s(a2, t5[a2], t5[a2 + 1], o2);
              return o2 && vs(o2, o2.next) && (ws(o2), o2 = o2.next), o2;
            }
            function es(t5, e4) {
              if (!t5)
                return t5;
              e4 || (e4 = t5);
              var r4, n4 = t5;
              do {
                if (r4 = false, n4.steiner || !vs(n4, n4.next) && 0 !== ds(n4.prev, n4, n4.next))
                  n4 = n4.next;
                else {
                  if (ws(n4), (n4 = e4 = n4.prev) === n4.next)
                    break;
                  r4 = true;
                }
              } while (r4 || n4 !== e4);
              return e4;
            }
            function rs(t5, e4, r4, n4, i2, a2, o2) {
              if (t5) {
                !o2 && a2 && function(t6, e5, r5, n5) {
                  var i3 = t6;
                  do {
                    null === i3.z && (i3.z = cs(i3.x, i3.y, e5, r5, n5)), i3.prevZ = i3.prev, i3.nextZ = i3.next, i3 = i3.next;
                  } while (i3 !== t6);
                  i3.prevZ.nextZ = null, i3.prevZ = null, function(t7) {
                    var e6, r6, n6, i4, a3, o3, s3, l3, u3 = 1;
                    do {
                      for (r6 = t7, t7 = null, a3 = null, o3 = 0; r6; ) {
                        for (o3++, n6 = r6, s3 = 0, e6 = 0; e6 < u3 && (s3++, n6 = n6.nextZ); e6++)
                          ;
                        for (l3 = u3; s3 > 0 || l3 > 0 && n6; )
                          0 !== s3 && (0 === l3 || !n6 || r6.z <= n6.z) ? (i4 = r6, r6 = r6.nextZ, s3--) : (i4 = n6, n6 = n6.nextZ, l3--), a3 ? a3.nextZ = i4 : t7 = i4, i4.prevZ = a3, a3 = i4;
                        r6 = n6;
                      }
                      a3.nextZ = null, u3 *= 2;
                    } while (o3 > 1);
                  }(i3);
                }(t5, n4, i2, a2);
                for (var s2, l2, u2 = t5; t5.prev !== t5.next; )
                  if (s2 = t5.prev, l2 = t5.next, a2 ? is3(t5, n4, i2, a2) : ns(t5))
                    e4.push(s2.i / r4), e4.push(t5.i / r4), e4.push(l2.i / r4), ws(t5), t5 = l2.next, u2 = l2.next;
                  else if ((t5 = l2) === u2) {
                    o2 ? 1 === o2 ? rs(t5 = as(es(t5), e4, r4), e4, r4, n4, i2, a2, 2) : 2 === o2 && os(t5, e4, r4, n4, i2, a2) : rs(es(t5), e4, r4, n4, i2, a2, 1);
                    break;
                  }
              }
            }
            function ns(t5) {
              var e4 = t5.prev, r4 = t5, n4 = t5.next;
              if (ds(e4, r4, n4) >= 0)
                return false;
              for (var i2 = t5.next.next; i2 !== t5.prev; ) {
                if (hs(e4.x, e4.y, r4.x, r4.y, n4.x, n4.y, i2.x, i2.y) && ds(i2.prev, i2, i2.next) >= 0)
                  return false;
                i2 = i2.next;
              }
              return true;
            }
            function is3(t5, e4, r4, n4) {
              var i2 = t5.prev, a2 = t5, o2 = t5.next;
              if (ds(i2, a2, o2) >= 0)
                return false;
              for (var s2 = i2.x < a2.x ? i2.x < o2.x ? i2.x : o2.x : a2.x < o2.x ? a2.x : o2.x, l2 = i2.y < a2.y ? i2.y < o2.y ? i2.y : o2.y : a2.y < o2.y ? a2.y : o2.y, u2 = i2.x > a2.x ? i2.x > o2.x ? i2.x : o2.x : a2.x > o2.x ? a2.x : o2.x, c2 = i2.y > a2.y ? i2.y > o2.y ? i2.y : o2.y : a2.y > o2.y ? a2.y : o2.y, f3 = cs(s2, l2, e4, r4, n4), h2 = cs(u2, c2, e4, r4, n4), p3 = t5.prevZ, d3 = t5.nextZ; p3 && p3.z >= f3 && d3 && d3.z <= h2; ) {
                if (p3 !== t5.prev && p3 !== t5.next && hs(i2.x, i2.y, a2.x, a2.y, o2.x, o2.y, p3.x, p3.y) && ds(p3.prev, p3, p3.next) >= 0)
                  return false;
                if (p3 = p3.prevZ, d3 !== t5.prev && d3 !== t5.next && hs(i2.x, i2.y, a2.x, a2.y, o2.x, o2.y, d3.x, d3.y) && ds(d3.prev, d3, d3.next) >= 0)
                  return false;
                d3 = d3.nextZ;
              }
              for (; p3 && p3.z >= f3; ) {
                if (p3 !== t5.prev && p3 !== t5.next && hs(i2.x, i2.y, a2.x, a2.y, o2.x, o2.y, p3.x, p3.y) && ds(p3.prev, p3, p3.next) >= 0)
                  return false;
                p3 = p3.prevZ;
              }
              for (; d3 && d3.z <= h2; ) {
                if (d3 !== t5.prev && d3 !== t5.next && hs(i2.x, i2.y, a2.x, a2.y, o2.x, o2.y, d3.x, d3.y) && ds(d3.prev, d3, d3.next) >= 0)
                  return false;
                d3 = d3.nextZ;
              }
              return true;
            }
            function as(t5, e4, r4) {
              var n4 = t5;
              do {
                var i2 = n4.prev, a2 = n4.next.next;
                !vs(i2, a2) && gs(i2, n4, n4.next, a2) && xs(i2, a2) && xs(a2, i2) && (e4.push(i2.i / r4), e4.push(n4.i / r4), e4.push(a2.i / r4), ws(n4), ws(n4.next), n4 = t5 = a2), n4 = n4.next;
              } while (n4 !== t5);
              return es(n4);
            }
            function os(t5, e4, r4, n4, i2, a2) {
              var o2 = t5;
              do {
                for (var s2 = o2.next.next; s2 !== o2.prev; ) {
                  if (o2.i !== s2.i && ps(o2, s2)) {
                    var l2 = bs(o2, s2);
                    return o2 = es(o2, o2.next), l2 = es(l2, l2.next), rs(o2, e4, r4, n4, i2, a2), void rs(l2, e4, r4, n4, i2, a2);
                  }
                  s2 = s2.next;
                }
                o2 = o2.next;
              } while (o2 !== t5);
            }
            function ss(t5, e4) {
              return t5.x - e4.x;
            }
            function ls(t5, e4) {
              if (e4 = function(t6, e5) {
                var r5, n4 = e5, i2 = t6.x, a2 = t6.y, o2 = -1 / 0;
                do {
                  if (a2 <= n4.y && a2 >= n4.next.y && n4.next.y !== n4.y) {
                    var s2 = n4.x + (a2 - n4.y) * (n4.next.x - n4.x) / (n4.next.y - n4.y);
                    if (s2 <= i2 && s2 > o2) {
                      if (o2 = s2, s2 === i2) {
                        if (a2 === n4.y)
                          return n4;
                        if (a2 === n4.next.y)
                          return n4.next;
                      }
                      r5 = n4.x < n4.next.x ? n4 : n4.next;
                    }
                  }
                  n4 = n4.next;
                } while (n4 !== e5);
                if (!r5)
                  return null;
                if (i2 === o2)
                  return r5;
                var l2, u2 = r5, c2 = r5.x, f3 = r5.y, h2 = 1 / 0;
                n4 = r5;
                do {
                  i2 >= n4.x && n4.x >= c2 && i2 !== n4.x && hs(a2 < f3 ? i2 : o2, a2, c2, f3, a2 < f3 ? o2 : i2, a2, n4.x, n4.y) && (l2 = Math.abs(a2 - n4.y) / (i2 - n4.x), xs(n4, t6) && (l2 < h2 || l2 === h2 && (n4.x > r5.x || n4.x === r5.x && us(r5, n4))) && (r5 = n4, h2 = l2)), n4 = n4.next;
                } while (n4 !== u2);
                return r5;
              }(t5, e4)) {
                var r4 = bs(e4, t5);
                es(e4, e4.next), es(r4, r4.next);
              }
            }
            function us(t5, e4) {
              return ds(t5.prev, t5, e4.prev) < 0 && ds(e4.next, t5, t5.next) < 0;
            }
            function cs(t5, e4, r4, n4, i2) {
              return (t5 = 1431655765 & ((t5 = 858993459 & ((t5 = 252645135 & ((t5 = 16711935 & ((t5 = 32767 * (t5 - r4) * i2) | t5 << 8)) | t5 << 4)) | t5 << 2)) | t5 << 1)) | (e4 = 1431655765 & ((e4 = 858993459 & ((e4 = 252645135 & ((e4 = 16711935 & ((e4 = 32767 * (e4 - n4) * i2) | e4 << 8)) | e4 << 4)) | e4 << 2)) | e4 << 1)) << 1;
            }
            function fs(t5) {
              var e4 = t5, r4 = t5;
              do {
                (e4.x < r4.x || e4.x === r4.x && e4.y < r4.y) && (r4 = e4), e4 = e4.next;
              } while (e4 !== t5);
              return r4;
            }
            function hs(t5, e4, r4, n4, i2, a2, o2, s2) {
              return (i2 - o2) * (e4 - s2) - (t5 - o2) * (a2 - s2) >= 0 && (t5 - o2) * (n4 - s2) - (r4 - o2) * (e4 - s2) >= 0 && (r4 - o2) * (a2 - s2) - (i2 - o2) * (n4 - s2) >= 0;
            }
            function ps(t5, e4) {
              return t5.next.i !== e4.i && t5.prev.i !== e4.i && !function(t6, e5) {
                var r4 = t6;
                do {
                  if (r4.i !== t6.i && r4.next.i !== t6.i && r4.i !== e5.i && r4.next.i !== e5.i && gs(r4, r4.next, t6, e5))
                    return true;
                  r4 = r4.next;
                } while (r4 !== t6);
                return false;
              }(t5, e4) && (xs(t5, e4) && xs(e4, t5) && function(t6, e5) {
                var r4 = t6, n4 = false, i2 = (t6.x + e5.x) / 2, a2 = (t6.y + e5.y) / 2;
                do {
                  r4.y > a2 != r4.next.y > a2 && r4.next.y !== r4.y && i2 < (r4.next.x - r4.x) * (a2 - r4.y) / (r4.next.y - r4.y) + r4.x && (n4 = !n4), r4 = r4.next;
                } while (r4 !== t6);
                return n4;
              }(t5, e4) && (ds(t5.prev, t5, e4.prev) || ds(t5, e4.prev, e4)) || vs(t5, e4) && ds(t5.prev, t5, t5.next) > 0 && ds(e4.prev, e4, e4.next) > 0);
            }
            function ds(t5, e4, r4) {
              return (e4.y - t5.y) * (r4.x - e4.x) - (e4.x - t5.x) * (r4.y - e4.y);
            }
            function vs(t5, e4) {
              return t5.x === e4.x && t5.y === e4.y;
            }
            function gs(t5, e4, r4, n4) {
              var i2 = ms(ds(t5, e4, r4)), a2 = ms(ds(t5, e4, n4)), o2 = ms(ds(r4, n4, t5)), s2 = ms(ds(r4, n4, e4));
              return i2 !== a2 && o2 !== s2 || !(0 !== i2 || !ys(t5, r4, e4)) || !(0 !== a2 || !ys(t5, n4, e4)) || !(0 !== o2 || !ys(r4, t5, n4)) || !(0 !== s2 || !ys(r4, e4, n4));
            }
            function ys(t5, e4, r4) {
              return e4.x <= Math.max(t5.x, r4.x) && e4.x >= Math.min(t5.x, r4.x) && e4.y <= Math.max(t5.y, r4.y) && e4.y >= Math.min(t5.y, r4.y);
            }
            function ms(t5) {
              return t5 > 0 ? 1 : t5 < 0 ? -1 : 0;
            }
            function xs(t5, e4) {
              return ds(t5.prev, t5, t5.next) < 0 ? ds(t5, e4, t5.next) >= 0 && ds(t5, t5.prev, e4) >= 0 : ds(t5, e4, t5.prev) < 0 || ds(t5, t5.next, e4) < 0;
            }
            function bs(t5, e4) {
              var r4 = new Ts(t5.i, t5.x, t5.y), n4 = new Ts(e4.i, e4.x, e4.y), i2 = t5.next, a2 = e4.prev;
              return t5.next = e4, e4.prev = t5, r4.next = i2, i2.prev = r4, n4.next = r4, r4.prev = n4, a2.next = n4, n4.prev = a2, n4;
            }
            function _s(t5, e4, r4, n4) {
              var i2 = new Ts(t5, e4, r4);
              return n4 ? (i2.next = n4.next, i2.prev = n4, n4.next.prev = i2, n4.next = i2) : (i2.prev = i2, i2.next = i2), i2;
            }
            function ws(t5) {
              t5.next.prev = t5.prev, t5.prev.next = t5.next, t5.prevZ && (t5.prevZ.nextZ = t5.nextZ), t5.nextZ && (t5.nextZ.prevZ = t5.prevZ);
            }
            function Ts(t5, e4, r4) {
              this.i = t5, this.x = e4, this.y = r4, this.prev = null, this.next = null, this.z = null, this.prevZ = null, this.nextZ = null, this.steiner = false;
            }
            function ks(t5, e4, r4, n4) {
              for (var i2 = 0, a2 = e4, o2 = r4 - n4; a2 < r4; a2 += n4)
                i2 += (t5[o2] - t5[a2]) * (t5[a2 + 1] + t5[o2 + 1]), o2 = a2;
              return i2;
            }
            function As(t5, e4, r4, n4, i2) {
              Ms(t5, e4, r4 || 0, n4 || t5.length - 1, i2 || Es);
            }
            function Ms(t5, e4, r4, n4, i2) {
              for (; n4 > r4; ) {
                if (n4 - r4 > 600) {
                  var a2 = n4 - r4 + 1, o2 = e4 - r4 + 1, s2 = Math.log(a2), l2 = 0.5 * Math.exp(2 * s2 / 3), u2 = 0.5 * Math.sqrt(s2 * l2 * (a2 - l2) / a2) * (o2 - a2 / 2 < 0 ? -1 : 1);
                  Ms(t5, e4, Math.max(r4, Math.floor(e4 - o2 * l2 / a2 + u2)), Math.min(n4, Math.floor(e4 + (a2 - o2) * l2 / a2 + u2)), i2);
                }
                var c2 = t5[e4], f3 = r4, h2 = n4;
                for (Ss(t5, r4, e4), i2(t5[n4], c2) > 0 && Ss(t5, r4, n4); f3 < h2; ) {
                  for (Ss(t5, f3, h2), f3++, h2--; i2(t5[f3], c2) < 0; )
                    f3++;
                  for (; i2(t5[h2], c2) > 0; )
                    h2--;
                }
                0 === i2(t5[r4], c2) ? Ss(t5, r4, h2) : Ss(t5, ++h2, n4), h2 <= e4 && (r4 = h2 + 1), e4 <= h2 && (n4 = h2 - 1);
              }
            }
            function Ss(t5, e4, r4) {
              var n4 = t5[e4];
              t5[e4] = t5[r4], t5[r4] = n4;
            }
            function Es(t5, e4) {
              return t5 < e4 ? -1 : t5 > e4 ? 1 : 0;
            }
            function Ls(t5, e4) {
              var r4 = t5.length;
              if (r4 <= 1)
                return [t5];
              for (var n4, i2, a2 = [], o2 = 0; o2 < r4; o2++) {
                var s2 = k(t5[o2]);
                0 !== s2 && (t5[o2].area = Math.abs(s2), void 0 === i2 && (i2 = s2 < 0), i2 === s2 < 0 ? (n4 && a2.push(n4), n4 = [t5[o2]]) : n4.push(t5[o2]));
              }
              if (n4 && a2.push(n4), e4 > 1)
                for (var l2 = 0; l2 < a2.length; l2++)
                  a2[l2].length <= e4 || (As(a2[l2], e4, 1, a2[l2].length - 1, Cs), a2[l2] = a2[l2].slice(0, e4));
              return a2;
            }
            function Cs(t5, e4) {
              return e4.area - t5.area;
            }
            function Ps(t5, e4, r4) {
              for (var n4 = r4.patternDependencies, i2 = false, a2 = 0, o2 = e4; a2 < o2.length; a2 += 1) {
                var s2 = o2[a2].paint.get(t5 + "-pattern");
                s2.isConstant() || (i2 = true);
                var l2 = s2.constantOr(null);
                l2 && (i2 = true, n4[l2.to] = true, n4[l2.from] = true);
              }
              return i2;
            }
            function Os(t5, e4, r4, n4, i2) {
              for (var a2 = i2.patternDependencies, o2 = 0, s2 = e4; o2 < s2.length; o2 += 1) {
                var l2 = s2[o2], u2 = l2.paint.get(t5 + "-pattern").value;
                if ("constant" !== u2.kind) {
                  var c2 = u2.evaluate({ zoom: n4 - 1 }, r4, {}, i2.availableImages), f3 = u2.evaluate({ zoom: n4 }, r4, {}, i2.availableImages), h2 = u2.evaluate({ zoom: n4 + 1 }, r4, {}, i2.availableImages);
                  c2 = c2 && c2.name ? c2.name : c2, f3 = f3 && f3.name ? f3.name : f3, h2 = h2 && h2.name ? h2.name : h2, a2[c2] = true, a2[f3] = true, a2[h2] = true, r4.patterns[l2.id] = { min: c2, mid: f3, max: h2 };
                }
              }
              return r4;
            }
            Qo.deviation = function(t5, e4, r4, n4) {
              var i2 = e4 && e4.length, a2 = i2 ? e4[0] * r4 : t5.length, o2 = Math.abs(ks(t5, 0, a2, r4));
              if (i2)
                for (var s2 = 0, l2 = e4.length; s2 < l2; s2++) {
                  var u2 = e4[s2] * r4, c2 = s2 < l2 - 1 ? e4[s2 + 1] * r4 : t5.length;
                  o2 -= Math.abs(ks(t5, u2, c2, r4));
                }
              var f3 = 0;
              for (s2 = 0; s2 < n4.length; s2 += 3) {
                var h2 = n4[s2] * r4, p3 = n4[s2 + 1] * r4, d3 = n4[s2 + 2] * r4;
                f3 += Math.abs((t5[h2] - t5[d3]) * (t5[p3 + 1] - t5[h2 + 1]) - (t5[h2] - t5[p3]) * (t5[d3 + 1] - t5[h2 + 1]));
              }
              return 0 === o2 && 0 === f3 ? 0 : Math.abs((f3 - o2) / o2);
            }, Qo.flatten = function(t5) {
              for (var e4 = t5[0][0].length, r4 = { vertices: [], holes: [], dimensions: e4 }, n4 = 0, i2 = 0; i2 < t5.length; i2++) {
                for (var a2 = 0; a2 < t5[i2].length; a2++)
                  for (var o2 = 0; o2 < e4; o2++)
                    r4.vertices.push(t5[i2][a2][o2]);
                i2 > 0 && (n4 += t5[i2 - 1].length, r4.holes.push(n4));
              }
              return r4;
            }, Ko.default = $o;
            var Is = function(t5) {
              this.zoom = t5.zoom, this.overscaling = t5.overscaling, this.layers = t5.layers, this.layerIds = this.layers.map(function(t6) {
                return t6.id;
              }), this.index = t5.index, this.hasPattern = false, this.patternFeatures = [], this.layoutVertexArray = new Xi(), this.indexArray = new sa(), this.indexArray2 = new pa(), this.programConfigurations = new no(Jo, t5.layers, t5.zoom), this.segments = new Ea(), this.segments2 = new Ea(), this.stateDependentLayerIds = this.layers.filter(function(t6) {
                return t6.isStateDependent();
              }).map(function(t6) {
                return t6.id;
              });
            };
            Is.prototype.populate = function(t5, e4, r4) {
              this.hasPattern = Ps("fill", this.layers, e4);
              for (var n4 = this.layers[0].layout.get("fill-sort-key"), i2 = [], a2 = 0, o2 = t5; a2 < o2.length; a2 += 1) {
                var s2 = o2[a2], l2 = s2.feature, u2 = s2.id, c2 = s2.index, f3 = s2.sourceLayerIndex, h2 = this.layers[0]._featureFilter.needGeometry, p3 = { type: l2.type, id: u2, properties: l2.properties, geometry: h2 ? uo(l2) : [] };
                if (this.layers[0]._featureFilter.filter(new Si(this.zoom), p3, r4)) {
                  h2 || (p3.geometry = uo(l2));
                  var d3 = n4 ? n4.evaluate(p3, {}, r4, e4.availableImages) : void 0, v2 = { id: u2, properties: l2.properties, type: l2.type, sourceLayerIndex: f3, index: c2, geometry: p3.geometry, patterns: {}, sortKey: d3 };
                  i2.push(v2);
                }
              }
              n4 && i2.sort(function(t6, e5) {
                return t6.sortKey - e5.sortKey;
              });
              for (var g3 = 0, y2 = i2; g3 < y2.length; g3 += 1) {
                var m3 = y2[g3], x2 = m3, b2 = x2.geometry, _2 = x2.index, w3 = x2.sourceLayerIndex;
                if (this.hasPattern) {
                  var T2 = Os("fill", this.layers, m3, this.zoom, e4);
                  this.patternFeatures.push(T2);
                } else
                  this.addFeature(m3, b2, _2, r4, {});
                var k2 = t5[_2].feature;
                e4.featureIndex.insert(k2, b2, _2, w3, this.index);
              }
            }, Is.prototype.update = function(t5, e4, r4) {
              this.stateDependentLayers.length && this.programConfigurations.updatePaintArrays(t5, e4, this.stateDependentLayers, r4);
            }, Is.prototype.addFeatures = function(t5, e4, r4) {
              for (var n4 = 0, i2 = this.patternFeatures; n4 < i2.length; n4 += 1) {
                var a2 = i2[n4];
                this.addFeature(a2, a2.geometry, a2.index, e4, r4);
              }
            }, Is.prototype.isEmpty = function() {
              return 0 === this.layoutVertexArray.length;
            }, Is.prototype.uploadPending = function() {
              return !this.uploaded || this.programConfigurations.needsUpload;
            }, Is.prototype.upload = function(t5) {
              this.uploaded || (this.layoutVertexBuffer = t5.createVertexBuffer(this.layoutVertexArray, Jo), this.indexBuffer = t5.createIndexBuffer(this.indexArray), this.indexBuffer2 = t5.createIndexBuffer(this.indexArray2)), this.programConfigurations.upload(t5), this.uploaded = true;
            }, Is.prototype.destroy = function() {
              this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.indexBuffer2.destroy(), this.programConfigurations.destroy(), this.segments.destroy(), this.segments2.destroy());
            }, Is.prototype.addFeature = function(t5, e4, r4, n4, i2) {
              for (var a2 = 0, o2 = Ls(e4, 500); a2 < o2.length; a2 += 1) {
                for (var s2 = o2[a2], l2 = 0, u2 = 0, c2 = s2; u2 < c2.length; u2 += 1)
                  l2 += c2[u2].length;
                for (var f3 = this.segments.prepareSegment(l2, this.layoutVertexArray, this.indexArray), h2 = f3.vertexLength, p3 = [], d3 = [], v2 = 0, g3 = s2; v2 < g3.length; v2 += 1) {
                  var y2 = g3[v2];
                  if (0 !== y2.length) {
                    y2 !== s2[0] && d3.push(p3.length / 2);
                    var m3 = this.segments2.prepareSegment(y2.length, this.layoutVertexArray, this.indexArray2), x2 = m3.vertexLength;
                    this.layoutVertexArray.emplaceBack(y2[0].x, y2[0].y), this.indexArray2.emplaceBack(x2 + y2.length - 1, x2), p3.push(y2[0].x), p3.push(y2[0].y);
                    for (var b2 = 1; b2 < y2.length; b2++)
                      this.layoutVertexArray.emplaceBack(y2[b2].x, y2[b2].y), this.indexArray2.emplaceBack(x2 + b2 - 1, x2 + b2), p3.push(y2[b2].x), p3.push(y2[b2].y);
                    m3.vertexLength += y2.length, m3.primitiveLength += y2.length;
                  }
                }
                for (var _2 = Ko(p3, d3), w3 = 0; w3 < _2.length; w3 += 3)
                  this.indexArray.emplaceBack(h2 + _2[w3], h2 + _2[w3 + 1], h2 + _2[w3 + 2]);
                f3.vertexLength += l2, f3.primitiveLength += _2.length / 3;
              }
              this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, t5, r4, i2, n4);
            }, Qn("FillBucket", Is, { omit: ["layers", "patternFeatures"] });
            var Ds = new Ui({ "fill-sort-key": new Fi(It.layout_fill["fill-sort-key"]) }), zs = { paint: new Ui({ "fill-antialias": new Ri(It.paint_fill["fill-antialias"]), "fill-opacity": new Fi(It.paint_fill["fill-opacity"]), "fill-color": new Fi(It.paint_fill["fill-color"]), "fill-outline-color": new Fi(It.paint_fill["fill-outline-color"]), "fill-translate": new Ri(It.paint_fill["fill-translate"]), "fill-translate-anchor": new Ri(It.paint_fill["fill-translate-anchor"]), "fill-pattern": new Bi(It.paint_fill["fill-pattern"]) }), layout: Ds }, Rs = function(t5) {
              function e4(e5) {
                t5.call(this, e5, zs);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.recalculate = function(e5, r4) {
                t5.prototype.recalculate.call(this, e5, r4);
                var n4 = this.paint._values["fill-outline-color"];
                "constant" === n4.value.kind && void 0 === n4.value.value && (this.paint._values["fill-outline-color"] = this.paint._values["fill-color"]);
              }, e4.prototype.createBucket = function(t6) {
                return new Is(t6);
              }, e4.prototype.queryRadius = function() {
                return Ao(this.paint.get("fill-translate"));
              }, e4.prototype.queryIntersectsFeature = function(t6, e5, r4, n4, i2, a2, o2) {
                return vo(Mo(t6, this.paint.get("fill-translate"), this.paint.get("fill-translate-anchor"), a2.angle, o2), n4);
              }, e4.prototype.isTileClipped = function() {
                return true;
              }, e4;
            }(Hi), Fs = Yi([{ name: "a_pos", components: 2, type: "Int16" }, { name: "a_normal_ed", components: 4, type: "Int16" }], 4).members, Bs = Ns;
            function Ns(t5, e4, r4, n4, i2) {
              this.properties = {}, this.extent = r4, this.type = 0, this._pbf = t5, this._geometry = -1, this._keys = n4, this._values = i2, t5.readFields(js, this, e4);
            }
            function js(t5, e4, r4) {
              1 == t5 ? e4.id = r4.readVarint() : 2 == t5 ? function(t6, e5) {
                for (var r5 = t6.readVarint() + t6.pos; t6.pos < r5; ) {
                  var n4 = e5._keys[t6.readVarint()], i2 = e5._values[t6.readVarint()];
                  e5.properties[n4] = i2;
                }
              }(r4, e4) : 3 == t5 ? e4.type = r4.readVarint() : 4 == t5 && (e4._geometry = r4.pos);
            }
            function Us(t5) {
              for (var e4, r4, n4 = 0, i2 = 0, a2 = t5.length, o2 = a2 - 1; i2 < a2; o2 = i2++)
                e4 = t5[i2], n4 += ((r4 = t5[o2]).x - e4.x) * (e4.y + r4.y);
              return n4;
            }
            Ns.types = ["Unknown", "Point", "LineString", "Polygon"], Ns.prototype.loadGeometry = function() {
              var t5 = this._pbf;
              t5.pos = this._geometry;
              for (var e4, r4 = t5.readVarint() + t5.pos, n4 = 1, i2 = 0, o2 = 0, s2 = 0, l2 = []; t5.pos < r4; ) {
                if (i2 <= 0) {
                  var u2 = t5.readVarint();
                  n4 = 7 & u2, i2 = u2 >> 3;
                }
                if (i2--, 1 === n4 || 2 === n4)
                  o2 += t5.readSVarint(), s2 += t5.readSVarint(), 1 === n4 && (e4 && l2.push(e4), e4 = []), e4.push(new a(o2, s2));
                else {
                  if (7 !== n4)
                    throw new Error("unknown command " + n4);
                  e4 && e4.push(e4[0].clone());
                }
              }
              return e4 && l2.push(e4), l2;
            }, Ns.prototype.bbox = function() {
              var t5 = this._pbf;
              t5.pos = this._geometry;
              for (var e4 = t5.readVarint() + t5.pos, r4 = 1, n4 = 0, i2 = 0, a2 = 0, o2 = 1 / 0, s2 = -1 / 0, l2 = 1 / 0, u2 = -1 / 0; t5.pos < e4; ) {
                if (n4 <= 0) {
                  var c2 = t5.readVarint();
                  r4 = 7 & c2, n4 = c2 >> 3;
                }
                if (n4--, 1 === r4 || 2 === r4)
                  (i2 += t5.readSVarint()) < o2 && (o2 = i2), i2 > s2 && (s2 = i2), (a2 += t5.readSVarint()) < l2 && (l2 = a2), a2 > u2 && (u2 = a2);
                else if (7 !== r4)
                  throw new Error("unknown command " + r4);
              }
              return [o2, l2, s2, u2];
            }, Ns.prototype.toGeoJSON = function(t5, e4, r4) {
              var n4, i2, a2 = this.extent * Math.pow(2, r4), o2 = this.extent * t5, s2 = this.extent * e4, l2 = this.loadGeometry(), u2 = Ns.types[this.type];
              function c2(t6) {
                for (var e5 = 0; e5 < t6.length; e5++) {
                  var r5 = t6[e5], n5 = 180 - 360 * (r5.y + s2) / a2;
                  t6[e5] = [360 * (r5.x + o2) / a2 - 180, 360 / Math.PI * Math.atan(Math.exp(n5 * Math.PI / 180)) - 90];
                }
              }
              switch (this.type) {
                case 1:
                  var f3 = [];
                  for (n4 = 0; n4 < l2.length; n4++)
                    f3[n4] = l2[n4][0];
                  c2(l2 = f3);
                  break;
                case 2:
                  for (n4 = 0; n4 < l2.length; n4++)
                    c2(l2[n4]);
                  break;
                case 3:
                  for (l2 = function(t6) {
                    var e5 = t6.length;
                    if (e5 <= 1)
                      return [t6];
                    for (var r5, n5, i3 = [], a3 = 0; a3 < e5; a3++) {
                      var o3 = Us(t6[a3]);
                      0 !== o3 && (void 0 === n5 && (n5 = o3 < 0), n5 === o3 < 0 ? (r5 && i3.push(r5), r5 = [t6[a3]]) : r5.push(t6[a3]));
                    }
                    return r5 && i3.push(r5), i3;
                  }(l2), n4 = 0; n4 < l2.length; n4++)
                    for (i2 = 0; i2 < l2[n4].length; i2++)
                      c2(l2[n4][i2]);
              }
              1 === l2.length ? l2 = l2[0] : u2 = "Multi" + u2;
              var h2 = { type: "Feature", geometry: { type: u2, coordinates: l2 }, properties: this.properties };
              return "id" in this && (h2.id = this.id), h2;
            };
            var Vs = Hs;
            function Hs(t5, e4) {
              this.version = 1, this.name = null, this.extent = 4096, this.length = 0, this._pbf = t5, this._keys = [], this._values = [], this._features = [], t5.readFields(qs, this, e4), this.length = this._features.length;
            }
            function qs(t5, e4, r4) {
              15 === t5 ? e4.version = r4.readVarint() : 1 === t5 ? e4.name = r4.readString() : 5 === t5 ? e4.extent = r4.readVarint() : 2 === t5 ? e4._features.push(r4.pos) : 3 === t5 ? e4._keys.push(r4.readString()) : 4 === t5 && e4._values.push(function(t6) {
                for (var e5 = null, r5 = t6.readVarint() + t6.pos; t6.pos < r5; ) {
                  var n4 = t6.readVarint() >> 3;
                  e5 = 1 === n4 ? t6.readString() : 2 === n4 ? t6.readFloat() : 3 === n4 ? t6.readDouble() : 4 === n4 ? t6.readVarint64() : 5 === n4 ? t6.readVarint() : 6 === n4 ? t6.readSVarint() : 7 === n4 ? t6.readBoolean() : null;
                }
                return e5;
              }(r4));
            }
            function Gs(t5, e4, r4) {
              if (3 === t5) {
                var n4 = new Vs(r4, r4.readVarint() + r4.pos);
                n4.length && (e4[n4.name] = n4);
              }
            }
            Hs.prototype.feature = function(t5) {
              if (t5 < 0 || t5 >= this._features.length)
                throw new Error("feature index out of bounds");
              this._pbf.pos = this._features[t5];
              var e4 = this._pbf.readVarint() + this._pbf.pos;
              return new Bs(this._pbf, e4, this.extent, this._keys, this._values);
            };
            var Zs = { VectorTile: function(t5, e4) {
              this.layers = t5.readFields(Gs, {}, e4);
            }, VectorTileFeature: Bs, VectorTileLayer: Vs }, Ys = Zs.VectorTileFeature.types, Ws = Math.pow(2, 13);
            function Xs(t5, e4, r4, n4, i2, a2, o2, s2) {
              t5.emplaceBack(e4, r4, 2 * Math.floor(n4 * Ws) + o2, i2 * Ws * 2, a2 * Ws * 2, Math.round(s2));
            }
            var Js = function(t5) {
              this.zoom = t5.zoom, this.overscaling = t5.overscaling, this.layers = t5.layers, this.layerIds = this.layers.map(function(t6) {
                return t6.id;
              }), this.index = t5.index, this.hasPattern = false, this.layoutVertexArray = new Ki(), this.indexArray = new sa(), this.programConfigurations = new no(Fs, t5.layers, t5.zoom), this.segments = new Ea(), this.stateDependentLayerIds = this.layers.filter(function(t6) {
                return t6.isStateDependent();
              }).map(function(t6) {
                return t6.id;
              });
            };
            function Ks(t5, e4) {
              return t5.x === e4.x && (t5.x < 0 || t5.x > oo) || t5.y === e4.y && (t5.y < 0 || t5.y > oo);
            }
            Js.prototype.populate = function(t5, e4, r4) {
              this.features = [], this.hasPattern = Ps("fill-extrusion", this.layers, e4);
              for (var n4 = 0, i2 = t5; n4 < i2.length; n4 += 1) {
                var a2 = i2[n4], o2 = a2.feature, s2 = a2.id, l2 = a2.index, u2 = a2.sourceLayerIndex, c2 = this.layers[0]._featureFilter.needGeometry, f3 = { type: o2.type, id: s2, properties: o2.properties, geometry: c2 ? uo(o2) : [] };
                if (this.layers[0]._featureFilter.filter(new Si(this.zoom), f3, r4)) {
                  var h2 = { id: s2, sourceLayerIndex: u2, index: l2, geometry: c2 ? f3.geometry : uo(o2), properties: o2.properties, type: o2.type, patterns: {} };
                  void 0 !== o2.id && (h2.id = o2.id), this.hasPattern ? this.features.push(Os("fill-extrusion", this.layers, h2, this.zoom, e4)) : this.addFeature(h2, h2.geometry, l2, r4, {}), e4.featureIndex.insert(o2, h2.geometry, l2, u2, this.index, true);
                }
              }
            }, Js.prototype.addFeatures = function(t5, e4, r4) {
              for (var n4 = 0, i2 = this.features; n4 < i2.length; n4 += 1) {
                var a2 = i2[n4], o2 = a2.geometry;
                this.addFeature(a2, o2, a2.index, e4, r4);
              }
            }, Js.prototype.update = function(t5, e4, r4) {
              this.stateDependentLayers.length && this.programConfigurations.updatePaintArrays(t5, e4, this.stateDependentLayers, r4);
            }, Js.prototype.isEmpty = function() {
              return 0 === this.layoutVertexArray.length;
            }, Js.prototype.uploadPending = function() {
              return !this.uploaded || this.programConfigurations.needsUpload;
            }, Js.prototype.upload = function(t5) {
              this.uploaded || (this.layoutVertexBuffer = t5.createVertexBuffer(this.layoutVertexArray, Fs), this.indexBuffer = t5.createIndexBuffer(this.indexArray)), this.programConfigurations.upload(t5), this.uploaded = true;
            }, Js.prototype.destroy = function() {
              this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.programConfigurations.destroy(), this.segments.destroy());
            }, Js.prototype.addFeature = function(t5, e4, r4, n4, i2) {
              for (var a2 = 0, o2 = Ls(e4, 500); a2 < o2.length; a2 += 1) {
                for (var s2 = o2[a2], l2 = 0, u2 = 0, c2 = s2; u2 < c2.length; u2 += 1)
                  l2 += c2[u2].length;
                for (var f3 = this.segments.prepareSegment(4, this.layoutVertexArray, this.indexArray), h2 = 0, p3 = s2; h2 < p3.length; h2 += 1) {
                  var d3 = p3[h2];
                  if (0 !== d3.length && !((O2 = d3).every(function(t6) {
                    return t6.x < 0;
                  }) || O2.every(function(t6) {
                    return t6.x > oo;
                  }) || O2.every(function(t6) {
                    return t6.y < 0;
                  }) || O2.every(function(t6) {
                    return t6.y > oo;
                  })))
                    for (var v2 = 0, g3 = 0; g3 < d3.length; g3++) {
                      var y2 = d3[g3];
                      if (g3 >= 1) {
                        var m3 = d3[g3 - 1];
                        if (!Ks(y2, m3)) {
                          f3.vertexLength + 4 > Ea.MAX_VERTEX_ARRAY_LENGTH && (f3 = this.segments.prepareSegment(4, this.layoutVertexArray, this.indexArray));
                          var x2 = y2.sub(m3)._perp()._unit(), b2 = m3.dist(y2);
                          v2 + b2 > 32768 && (v2 = 0), Xs(this.layoutVertexArray, y2.x, y2.y, x2.x, x2.y, 0, 0, v2), Xs(this.layoutVertexArray, y2.x, y2.y, x2.x, x2.y, 0, 1, v2), v2 += b2, Xs(this.layoutVertexArray, m3.x, m3.y, x2.x, x2.y, 0, 0, v2), Xs(this.layoutVertexArray, m3.x, m3.y, x2.x, x2.y, 0, 1, v2);
                          var _2 = f3.vertexLength;
                          this.indexArray.emplaceBack(_2, _2 + 2, _2 + 1), this.indexArray.emplaceBack(_2 + 1, _2 + 2, _2 + 3), f3.vertexLength += 4, f3.primitiveLength += 2;
                        }
                      }
                    }
                }
                if (f3.vertexLength + l2 > Ea.MAX_VERTEX_ARRAY_LENGTH && (f3 = this.segments.prepareSegment(l2, this.layoutVertexArray, this.indexArray)), "Polygon" === Ys[t5.type]) {
                  for (var w3 = [], T2 = [], k2 = f3.vertexLength, A2 = 0, M2 = s2; A2 < M2.length; A2 += 1) {
                    var S2 = M2[A2];
                    if (0 !== S2.length) {
                      S2 !== s2[0] && T2.push(w3.length / 2);
                      for (var E2 = 0; E2 < S2.length; E2++) {
                        var L2 = S2[E2];
                        Xs(this.layoutVertexArray, L2.x, L2.y, 0, 0, 1, 1, 0), w3.push(L2.x), w3.push(L2.y);
                      }
                    }
                  }
                  for (var C2 = Ko(w3, T2), P2 = 0; P2 < C2.length; P2 += 3)
                    this.indexArray.emplaceBack(k2 + C2[P2], k2 + C2[P2 + 2], k2 + C2[P2 + 1]);
                  f3.primitiveLength += C2.length / 3, f3.vertexLength += l2;
                }
              }
              var O2;
              this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, t5, r4, i2, n4);
            }, Qn("FillExtrusionBucket", Js, { omit: ["layers", "features"] });
            var $s = { paint: new Ui({ "fill-extrusion-opacity": new Ri(It["paint_fill-extrusion"]["fill-extrusion-opacity"]), "fill-extrusion-color": new Fi(It["paint_fill-extrusion"]["fill-extrusion-color"]), "fill-extrusion-translate": new Ri(It["paint_fill-extrusion"]["fill-extrusion-translate"]), "fill-extrusion-translate-anchor": new Ri(It["paint_fill-extrusion"]["fill-extrusion-translate-anchor"]), "fill-extrusion-pattern": new Bi(It["paint_fill-extrusion"]["fill-extrusion-pattern"]), "fill-extrusion-height": new Fi(It["paint_fill-extrusion"]["fill-extrusion-height"]), "fill-extrusion-base": new Fi(It["paint_fill-extrusion"]["fill-extrusion-base"]), "fill-extrusion-vertical-gradient": new Ri(It["paint_fill-extrusion"]["fill-extrusion-vertical-gradient"]) }) }, Qs = function(t5) {
              function e4(e5) {
                t5.call(this, e5, $s);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.createBucket = function(t6) {
                return new Js(t6);
              }, e4.prototype.queryRadius = function() {
                return Ao(this.paint.get("fill-extrusion-translate"));
              }, e4.prototype.is3D = function() {
                return true;
              }, e4.prototype.queryIntersectsFeature = function(t6, e5, r4, n4, i2, o2, s2, l2) {
                var u2 = Mo(t6, this.paint.get("fill-extrusion-translate"), this.paint.get("fill-extrusion-translate-anchor"), o2.angle, s2), c2 = this.paint.get("fill-extrusion-height").evaluate(e5, r4), f3 = this.paint.get("fill-extrusion-base").evaluate(e5, r4), h2 = function(t7, e6, r5, n5) {
                  for (var i3 = [], o3 = 0, s3 = t7; o3 < s3.length; o3 += 1) {
                    var l3 = s3[o3], u3 = [l3.x, l3.y, n5, 1];
                    zo(u3, u3, e6), i3.push(new a(u3[0] / u3[3], u3[1] / u3[3]));
                  }
                  return i3;
                }(u2, l2, 0, 0), p3 = function(t7, e6, r5, n5) {
                  for (var i3 = [], o3 = [], s3 = n5[8] * e6, l3 = n5[9] * e6, u3 = n5[10] * e6, c3 = n5[11] * e6, f4 = n5[8] * r5, h3 = n5[9] * r5, p4 = n5[10] * r5, d3 = n5[11] * r5, v2 = 0, g3 = t7; v2 < g3.length; v2 += 1) {
                    for (var y2 = [], m3 = [], x2 = 0, b2 = g3[v2]; x2 < b2.length; x2 += 1) {
                      var _2 = b2[x2], w3 = _2.x, T2 = _2.y, k2 = n5[0] * w3 + n5[4] * T2 + n5[12], A2 = n5[1] * w3 + n5[5] * T2 + n5[13], M2 = n5[2] * w3 + n5[6] * T2 + n5[14], S2 = n5[3] * w3 + n5[7] * T2 + n5[15], E2 = M2 + u3, L2 = S2 + c3, C2 = k2 + f4, P2 = A2 + h3, O2 = M2 + p4, I2 = S2 + d3, D2 = new a((k2 + s3) / L2, (A2 + l3) / L2);
                      D2.z = E2 / L2, y2.push(D2);
                      var z2 = new a(C2 / I2, P2 / I2);
                      z2.z = O2 / I2, m3.push(z2);
                    }
                    i3.push(y2), o3.push(m3);
                  }
                  return [i3, o3];
                }(n4, f3, c2, l2);
                return function(t7, e6, r5) {
                  var n5 = 1 / 0;
                  vo(r5, e6) && (n5 = el(r5, e6[0]));
                  for (var i3 = 0; i3 < e6.length; i3++)
                    for (var a2 = e6[i3], o3 = t7[i3], s3 = 0; s3 < a2.length - 1; s3++) {
                      var l3 = a2[s3], u3 = a2[s3 + 1], c3 = o3[s3], f4 = [l3, u3, o3[s3 + 1], c3, l3];
                      ho(r5, f4) && (n5 = Math.min(n5, el(r5, f4)));
                    }
                  return n5 !== 1 / 0 && n5;
                }(p3[0], p3[1], h2);
              }, e4;
            }(Hi);
            function tl(t5, e4) {
              return t5.x * e4.x + t5.y * e4.y;
            }
            function el(t5, e4) {
              if (1 === t5.length) {
                for (var r4, n4 = 0, i2 = e4[n4++]; !r4 || i2.equals(r4); )
                  if (!(r4 = e4[n4++]))
                    return 1 / 0;
                for (; n4 < e4.length; n4++) {
                  var a2 = e4[n4], o2 = t5[0], s2 = r4.sub(i2), l2 = a2.sub(i2), u2 = o2.sub(i2), c2 = tl(s2, s2), f3 = tl(s2, l2), h2 = tl(l2, l2), p3 = tl(u2, s2), d3 = tl(u2, l2), v2 = c2 * h2 - f3 * f3, g3 = (h2 * p3 - f3 * d3) / v2, y2 = (c2 * d3 - f3 * p3) / v2, m3 = 1 - g3 - y2, x2 = i2.z * m3 + r4.z * g3 + a2.z * y2;
                  if (isFinite(x2))
                    return x2;
                }
                return 1 / 0;
              }
              for (var b2 = 1 / 0, _2 = 0, w3 = e4; _2 < w3.length; _2 += 1) {
                var T2 = w3[_2];
                b2 = Math.min(b2, T2.z);
              }
              return b2;
            }
            var rl = Yi([{ name: "a_pos_normal", components: 2, type: "Int16" }, { name: "a_data", components: 4, type: "Uint8" }], 4).members, nl = Zs.VectorTileFeature.types, il = Math.cos(Math.PI / 180 * 37.5), al = Math.pow(2, 14) / 0.5, ol = function(t5) {
              this.zoom = t5.zoom, this.overscaling = t5.overscaling, this.layers = t5.layers, this.layerIds = this.layers.map(function(t6) {
                return t6.id;
              }), this.index = t5.index, this.hasPattern = false, this.patternFeatures = [], this.layoutVertexArray = new $i(), this.indexArray = new sa(), this.programConfigurations = new no(rl, t5.layers, t5.zoom), this.segments = new Ea(), this.stateDependentLayerIds = this.layers.filter(function(t6) {
                return t6.isStateDependent();
              }).map(function(t6) {
                return t6.id;
              });
            };
            ol.prototype.populate = function(t5, e4, r4) {
              this.hasPattern = Ps("line", this.layers, e4);
              for (var n4 = this.layers[0].layout.get("line-sort-key"), i2 = [], a2 = 0, o2 = t5; a2 < o2.length; a2 += 1) {
                var s2 = o2[a2], l2 = s2.feature, u2 = s2.id, c2 = s2.index, f3 = s2.sourceLayerIndex, h2 = this.layers[0]._featureFilter.needGeometry, p3 = { type: l2.type, id: u2, properties: l2.properties, geometry: h2 ? uo(l2) : [] };
                if (this.layers[0]._featureFilter.filter(new Si(this.zoom), p3, r4)) {
                  h2 || (p3.geometry = uo(l2));
                  var d3 = n4 ? n4.evaluate(p3, {}, r4) : void 0, v2 = { id: u2, properties: l2.properties, type: l2.type, sourceLayerIndex: f3, index: c2, geometry: p3.geometry, patterns: {}, sortKey: d3 };
                  i2.push(v2);
                }
              }
              n4 && i2.sort(function(t6, e5) {
                return t6.sortKey - e5.sortKey;
              });
              for (var g3 = 0, y2 = i2; g3 < y2.length; g3 += 1) {
                var m3 = y2[g3], x2 = m3, b2 = x2.geometry, _2 = x2.index, w3 = x2.sourceLayerIndex;
                if (this.hasPattern) {
                  var T2 = Os("line", this.layers, m3, this.zoom, e4);
                  this.patternFeatures.push(T2);
                } else
                  this.addFeature(m3, b2, _2, r4, {});
                var k2 = t5[_2].feature;
                e4.featureIndex.insert(k2, b2, _2, w3, this.index);
              }
            }, ol.prototype.update = function(t5, e4, r4) {
              this.stateDependentLayers.length && this.programConfigurations.updatePaintArrays(t5, e4, this.stateDependentLayers, r4);
            }, ol.prototype.addFeatures = function(t5, e4, r4) {
              for (var n4 = 0, i2 = this.patternFeatures; n4 < i2.length; n4 += 1) {
                var a2 = i2[n4];
                this.addFeature(a2, a2.geometry, a2.index, e4, r4);
              }
            }, ol.prototype.isEmpty = function() {
              return 0 === this.layoutVertexArray.length;
            }, ol.prototype.uploadPending = function() {
              return !this.uploaded || this.programConfigurations.needsUpload;
            }, ol.prototype.upload = function(t5) {
              this.uploaded || (this.layoutVertexBuffer = t5.createVertexBuffer(this.layoutVertexArray, rl), this.indexBuffer = t5.createIndexBuffer(this.indexArray)), this.programConfigurations.upload(t5), this.uploaded = true;
            }, ol.prototype.destroy = function() {
              this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.programConfigurations.destroy(), this.segments.destroy());
            }, ol.prototype.addFeature = function(t5, e4, r4, n4, i2) {
              for (var a2 = this.layers[0].layout, o2 = a2.get("line-join").evaluate(t5, {}), s2 = a2.get("line-cap"), l2 = a2.get("line-miter-limit"), u2 = a2.get("line-round-limit"), c2 = 0, f3 = e4; c2 < f3.length; c2 += 1) {
                var h2 = f3[c2];
                this.addLine(h2, t5, o2, s2, l2, u2);
              }
              this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, t5, r4, i2, n4);
            }, ol.prototype.addLine = function(t5, e4, r4, n4, i2, a2) {
              if (this.distance = 0, this.scaledDistance = 0, this.totalDistance = 0, e4.properties && e4.properties.hasOwnProperty("mapbox_clip_start") && e4.properties.hasOwnProperty("mapbox_clip_end")) {
                this.clipStart = +e4.properties.mapbox_clip_start, this.clipEnd = +e4.properties.mapbox_clip_end;
                for (var o2 = 0; o2 < t5.length - 1; o2++)
                  this.totalDistance += t5[o2].dist(t5[o2 + 1]);
                this.updateScaledDistance();
              }
              for (var s2 = "Polygon" === nl[e4.type], l2 = t5.length; l2 >= 2 && t5[l2 - 1].equals(t5[l2 - 2]); )
                l2--;
              for (var u2 = 0; u2 < l2 - 1 && t5[u2].equals(t5[u2 + 1]); )
                u2++;
              if (!(l2 < (s2 ? 3 : 2))) {
                "bevel" === r4 && (i2 = 1.05);
                var c2, f3 = this.overscaling <= 16 ? 122880 / (512 * this.overscaling) : 0, h2 = this.segments.prepareSegment(10 * l2, this.layoutVertexArray, this.indexArray), p3 = void 0, d3 = void 0, v2 = void 0, g3 = void 0;
                this.e1 = this.e2 = -1, s2 && (c2 = t5[l2 - 2], g3 = t5[u2].sub(c2)._unit()._perp());
                for (var y2 = u2; y2 < l2; y2++)
                  if (!(d3 = y2 === l2 - 1 ? s2 ? t5[u2 + 1] : void 0 : t5[y2 + 1]) || !t5[y2].equals(d3)) {
                    g3 && (v2 = g3), c2 && (p3 = c2), c2 = t5[y2], g3 = d3 ? d3.sub(c2)._unit()._perp() : v2;
                    var m3 = (v2 = v2 || g3).add(g3);
                    0 === m3.x && 0 === m3.y || m3._unit();
                    var x2 = v2.x * g3.x + v2.y * g3.y, b2 = m3.x * g3.x + m3.y * g3.y, _2 = 0 !== b2 ? 1 / b2 : 1 / 0, w3 = 2 * Math.sqrt(2 - 2 * b2), T2 = b2 < il && p3 && d3, k2 = v2.x * g3.y - v2.y * g3.x > 0;
                    if (T2 && y2 > u2) {
                      var A2 = c2.dist(p3);
                      if (A2 > 2 * f3) {
                        var M2 = c2.sub(c2.sub(p3)._mult(f3 / A2)._round());
                        this.updateDistance(p3, M2), this.addCurrentVertex(M2, v2, 0, 0, h2), p3 = M2;
                      }
                    }
                    var S2 = p3 && d3, E2 = S2 ? r4 : s2 ? "butt" : n4;
                    if (S2 && "round" === E2 && (_2 < a2 ? E2 = "miter" : _2 <= 2 && (E2 = "fakeround")), "miter" === E2 && _2 > i2 && (E2 = "bevel"), "bevel" === E2 && (_2 > 2 && (E2 = "flipbevel"), _2 < i2 && (E2 = "miter")), p3 && this.updateDistance(p3, c2), "miter" === E2)
                      m3._mult(_2), this.addCurrentVertex(c2, m3, 0, 0, h2);
                    else if ("flipbevel" === E2) {
                      if (_2 > 100)
                        m3 = g3.mult(-1);
                      else {
                        var L2 = _2 * v2.add(g3).mag() / v2.sub(g3).mag();
                        m3._perp()._mult(L2 * (k2 ? -1 : 1));
                      }
                      this.addCurrentVertex(c2, m3, 0, 0, h2), this.addCurrentVertex(c2, m3.mult(-1), 0, 0, h2);
                    } else if ("bevel" === E2 || "fakeround" === E2) {
                      var C2 = -Math.sqrt(_2 * _2 - 1), P2 = k2 ? C2 : 0, O2 = k2 ? 0 : C2;
                      if (p3 && this.addCurrentVertex(c2, v2, P2, O2, h2), "fakeround" === E2)
                        for (var I2 = Math.round(180 * w3 / Math.PI / 20), D2 = 1; D2 < I2; D2++) {
                          var z2 = D2 / I2;
                          if (0.5 !== z2) {
                            var R2 = z2 - 0.5;
                            z2 += z2 * R2 * (z2 - 1) * ((1.0904 + x2 * (x2 * (3.55645 - 1.43519 * x2) - 3.2452)) * R2 * R2 + (0.848013 + x2 * (0.215638 * x2 - 1.06021)));
                          }
                          var F2 = g3.sub(v2)._mult(z2)._add(v2)._unit()._mult(k2 ? -1 : 1);
                          this.addHalfVertex(c2, F2.x, F2.y, false, k2, 0, h2);
                        }
                      d3 && this.addCurrentVertex(c2, g3, -P2, -O2, h2);
                    } else if ("butt" === E2)
                      this.addCurrentVertex(c2, m3, 0, 0, h2);
                    else if ("square" === E2) {
                      var B2 = p3 ? 1 : -1;
                      this.addCurrentVertex(c2, m3, B2, B2, h2);
                    } else
                      "round" === E2 && (p3 && (this.addCurrentVertex(c2, v2, 0, 0, h2), this.addCurrentVertex(c2, v2, 1, 1, h2, true)), d3 && (this.addCurrentVertex(c2, g3, -1, -1, h2, true), this.addCurrentVertex(c2, g3, 0, 0, h2)));
                    if (T2 && y2 < l2 - 1) {
                      var N2 = c2.dist(d3);
                      if (N2 > 2 * f3) {
                        var j2 = c2.add(d3.sub(c2)._mult(f3 / N2)._round());
                        this.updateDistance(c2, j2), this.addCurrentVertex(j2, g3, 0, 0, h2), c2 = j2;
                      }
                    }
                  }
              }
            }, ol.prototype.addCurrentVertex = function(t5, e4, r4, n4, i2, a2) {
              void 0 === a2 && (a2 = false);
              var o2 = e4.x + e4.y * r4, s2 = e4.y - e4.x * r4, l2 = -e4.x + e4.y * n4, u2 = -e4.y - e4.x * n4;
              this.addHalfVertex(t5, o2, s2, a2, false, r4, i2), this.addHalfVertex(t5, l2, u2, a2, true, -n4, i2), this.distance > al / 2 && 0 === this.totalDistance && (this.distance = 0, this.addCurrentVertex(t5, e4, r4, n4, i2, a2));
            }, ol.prototype.addHalfVertex = function(t5, e4, r4, n4, i2, a2, o2) {
              var s2 = t5.x, l2 = t5.y, u2 = 0.5 * this.scaledDistance;
              this.layoutVertexArray.emplaceBack((s2 << 1) + (n4 ? 1 : 0), (l2 << 1) + (i2 ? 1 : 0), Math.round(63 * e4) + 128, Math.round(63 * r4) + 128, 1 + (0 === a2 ? 0 : a2 < 0 ? -1 : 1) | (63 & u2) << 2, u2 >> 6);
              var c2 = o2.vertexLength++;
              this.e1 >= 0 && this.e2 >= 0 && (this.indexArray.emplaceBack(this.e1, this.e2, c2), o2.primitiveLength++), i2 ? this.e2 = c2 : this.e1 = c2;
            }, ol.prototype.updateScaledDistance = function() {
              this.scaledDistance = this.totalDistance > 0 ? (this.clipStart + (this.clipEnd - this.clipStart) * this.distance / this.totalDistance) * (al - 1) : this.distance;
            }, ol.prototype.updateDistance = function(t5, e4) {
              this.distance += t5.dist(e4), this.updateScaledDistance();
            }, Qn("LineBucket", ol, { omit: ["layers", "patternFeatures"] });
            var sl = new Ui({ "line-cap": new Ri(It.layout_line["line-cap"]), "line-join": new Fi(It.layout_line["line-join"]), "line-miter-limit": new Ri(It.layout_line["line-miter-limit"]), "line-round-limit": new Ri(It.layout_line["line-round-limit"]), "line-sort-key": new Fi(It.layout_line["line-sort-key"]) }), ll = { paint: new Ui({ "line-opacity": new Fi(It.paint_line["line-opacity"]), "line-color": new Fi(It.paint_line["line-color"]), "line-translate": new Ri(It.paint_line["line-translate"]), "line-translate-anchor": new Ri(It.paint_line["line-translate-anchor"]), "line-width": new Fi(It.paint_line["line-width"]), "line-gap-width": new Fi(It.paint_line["line-gap-width"]), "line-offset": new Fi(It.paint_line["line-offset"]), "line-blur": new Fi(It.paint_line["line-blur"]), "line-dasharray": new Ni(It.paint_line["line-dasharray"]), "line-pattern": new Bi(It.paint_line["line-pattern"]), "line-gradient": new ji(It.paint_line["line-gradient"]) }), layout: sl }, ul = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.possiblyEvaluate = function(e5, r4) {
                return r4 = new Si(Math.floor(r4.zoom), { now: r4.now, fadeDuration: r4.fadeDuration, zoomHistory: r4.zoomHistory, transition: r4.transition }), t5.prototype.possiblyEvaluate.call(this, e5, r4);
              }, e4.prototype.evaluate = function(e5, r4, n4, i2) {
                return r4 = f2({}, r4, { zoom: Math.floor(r4.zoom) }), t5.prototype.evaluate.call(this, e5, r4, n4, i2);
              }, e4;
            }(Fi), cl = new ul(ll.paint.properties["line-width"].specification);
            cl.useIntegerZoom = true;
            var fl = function(t5) {
              function e4(e5) {
                t5.call(this, e5, ll);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._handleSpecialPaintPropertyUpdate = function(t6) {
                "line-gradient" === t6 && this._updateGradient();
              }, e4.prototype._updateGradient = function() {
                var t6 = this._transitionablePaint._values["line-gradient"].value.expression;
                this.gradient = Zo(t6, "lineProgress"), this.gradientTexture = null;
              }, e4.prototype.recalculate = function(e5, r4) {
                t5.prototype.recalculate.call(this, e5, r4), this.paint._values["line-floorwidth"] = cl.possiblyEvaluate(this._transitioningPaint._values["line-width"].value, e5);
              }, e4.prototype.createBucket = function(t6) {
                return new ol(t6);
              }, e4.prototype.queryRadius = function(t6) {
                var e5 = t6, r4 = hl(ko("line-width", this, e5), ko("line-gap-width", this, e5)), n4 = ko("line-offset", this, e5);
                return r4 / 2 + Math.abs(n4) + Ao(this.paint.get("line-translate"));
              }, e4.prototype.queryIntersectsFeature = function(t6, e5, r4, n4, i2, o2, s2) {
                var l2 = Mo(t6, this.paint.get("line-translate"), this.paint.get("line-translate-anchor"), o2.angle, s2), u2 = s2 / 2 * hl(this.paint.get("line-width").evaluate(e5, r4), this.paint.get("line-gap-width").evaluate(e5, r4)), c2 = this.paint.get("line-offset").evaluate(e5, r4);
                return c2 && (n4 = function(t7, e6) {
                  for (var r5 = [], n5 = new a(0, 0), i3 = 0; i3 < t7.length; i3++) {
                    for (var o3 = t7[i3], s3 = [], l3 = 0; l3 < o3.length; l3++) {
                      var u3 = o3[l3 - 1], c3 = o3[l3], f3 = o3[l3 + 1], h2 = 0 === l3 ? n5 : c3.sub(u3)._unit()._perp(), p3 = l3 === o3.length - 1 ? n5 : f3.sub(c3)._unit()._perp(), d3 = h2._add(p3)._unit(), v2 = d3.x * p3.x + d3.y * p3.y;
                      d3._mult(1 / v2), s3.push(d3._mult(e6)._add(c3));
                    }
                    r5.push(s3);
                  }
                  return r5;
                }(n4, c2 * s2)), function(t7, e6, r5) {
                  for (var n5 = 0; n5 < e6.length; n5++) {
                    var i3 = e6[n5];
                    if (t7.length >= 3) {
                      for (var a2 = 0; a2 < i3.length; a2++)
                        if (wo(t7, i3[a2]))
                          return true;
                    }
                    if (go(t7, i3, r5))
                      return true;
                  }
                  return false;
                }(l2, n4, u2);
              }, e4.prototype.isTileClipped = function() {
                return true;
              }, e4;
            }(Hi);
            function hl(t5, e4) {
              return e4 > 0 ? e4 + 2 * t5 : t5;
            }
            var pl = Yi([{ name: "a_pos_offset", components: 4, type: "Int16" }, { name: "a_data", components: 4, type: "Uint16" }, { name: "a_pixeloffset", components: 4, type: "Int16" }], 4), dl = Yi([{ name: "a_projected_pos", components: 3, type: "Float32" }], 4), vl = (Yi([{ name: "a_fade_opacity", components: 1, type: "Uint32" }], 4), Yi([{ name: "a_placed", components: 2, type: "Uint8" }, { name: "a_shift", components: 2, type: "Float32" }])), gl2 = (Yi([{ type: "Int16", name: "anchorPointX" }, { type: "Int16", name: "anchorPointY" }, { type: "Int16", name: "x1" }, { type: "Int16", name: "y1" }, { type: "Int16", name: "x2" }, { type: "Int16", name: "y2" }, { type: "Uint32", name: "featureIndex" }, { type: "Uint16", name: "sourceLayerIndex" }, { type: "Uint16", name: "bucketIndex" }]), Yi([{ name: "a_pos", components: 2, type: "Int16" }, { name: "a_anchor_pos", components: 2, type: "Int16" }, { name: "a_extrude", components: 2, type: "Int16" }], 4)), yl = Yi([{ name: "a_pos", components: 2, type: "Float32" }, { name: "a_radius", components: 1, type: "Float32" }, { name: "a_flags", components: 2, type: "Int16" }], 4);
            function ml(t5, e4, r4) {
              return t5.sections.forEach(function(t6) {
                t6.text = function(t7, e5, r5) {
                  var n4 = e5.layout.get("text-transform").evaluate(r5, {});
                  return "uppercase" === n4 ? t7 = t7.toLocaleUpperCase() : "lowercase" === n4 && (t7 = t7.toLocaleLowerCase()), Mi.applyArabicShaping && (t7 = Mi.applyArabicShaping(t7)), t7;
                }(t6.text, e4, r4);
              }), t5;
            }
            Yi([{ name: "triangle", components: 3, type: "Uint16" }]), Yi([{ type: "Int16", name: "anchorX" }, { type: "Int16", name: "anchorY" }, { type: "Uint16", name: "glyphStartIndex" }, { type: "Uint16", name: "numGlyphs" }, { type: "Uint32", name: "vertexStartIndex" }, { type: "Uint32", name: "lineStartIndex" }, { type: "Uint32", name: "lineLength" }, { type: "Uint16", name: "segment" }, { type: "Uint16", name: "lowerSize" }, { type: "Uint16", name: "upperSize" }, { type: "Float32", name: "lineOffsetX" }, { type: "Float32", name: "lineOffsetY" }, { type: "Uint8", name: "writingMode" }, { type: "Uint8", name: "placedOrientation" }, { type: "Uint8", name: "hidden" }, { type: "Uint32", name: "crossTileID" }, { type: "Int16", name: "associatedIconIndex" }]), Yi([{ type: "Int16", name: "anchorX" }, { type: "Int16", name: "anchorY" }, { type: "Int16", name: "rightJustifiedTextSymbolIndex" }, { type: "Int16", name: "centerJustifiedTextSymbolIndex" }, { type: "Int16", name: "leftJustifiedTextSymbolIndex" }, { type: "Int16", name: "verticalPlacedTextSymbolIndex" }, { type: "Int16", name: "placedIconSymbolIndex" }, { type: "Int16", name: "verticalPlacedIconSymbolIndex" }, { type: "Uint16", name: "key" }, { type: "Uint16", name: "textBoxStartIndex" }, { type: "Uint16", name: "textBoxEndIndex" }, { type: "Uint16", name: "verticalTextBoxStartIndex" }, { type: "Uint16", name: "verticalTextBoxEndIndex" }, { type: "Uint16", name: "iconBoxStartIndex" }, { type: "Uint16", name: "iconBoxEndIndex" }, { type: "Uint16", name: "verticalIconBoxStartIndex" }, { type: "Uint16", name: "verticalIconBoxEndIndex" }, { type: "Uint16", name: "featureIndex" }, { type: "Uint16", name: "numHorizontalGlyphVertices" }, { type: "Uint16", name: "numVerticalGlyphVertices" }, { type: "Uint16", name: "numIconVertices" }, { type: "Uint16", name: "numVerticalIconVertices" }, { type: "Uint16", name: "useRuntimeCollisionCircles" }, { type: "Uint32", name: "crossTileID" }, { type: "Float32", name: "textBoxScale" }, { type: "Float32", components: 2, name: "textOffset" }, { type: "Float32", name: "collisionCircleDiameter" }]), Yi([{ type: "Float32", name: "offsetX" }]), Yi([{ type: "Int16", name: "x" }, { type: "Int16", name: "y" }, { type: "Int16", name: "tileUnitDistanceFromAnchor" }]);
            var xl = { "!": "︕", "#": "＃", $: "＄", "%": "％", "&": "＆", "(": "︵", ")": "︶", "*": "＊", "+": "＋", ",": "︐", "-": "︲", ".": "・", "/": "／", ":": "︓", ";": "︔", "<": "︿", "=": "＝", ">": "﹀", "?": "︖", "@": "＠", "[": "﹇", "\\": "＼", "]": "﹈", "^": "＾", _: "︳", "`": "｀", "{": "︷", "|": "―", "}": "︸", "~": "～", "¢": "￠", "£": "￡", "¥": "￥", "¦": "￤", "¬": "￢", "¯": "￣", "–": "︲", "—": "︱", "‘": "﹃", "’": "﹄", "“": "﹁", "”": "﹂", "…": "︙", "‧": "・", "₩": "￦", "、": "︑", "。": "︒", "〈": "︿", "〉": "﹀", "《": "︽", "》": "︾", "「": "﹁", "」": "﹂", "『": "﹃", "』": "﹄", "【": "︻", "】": "︼", "〔": "︹", "〕": "︺", "〖": "︗", "〗": "︘", "！": "︕", "（": "︵", "）": "︶", "，": "︐", "－": "︲", "．": "・", "：": "︓", "；": "︔", "＜": "︿", "＞": "﹀", "？": "︖", "［": "﹇", "］": "﹈", "＿": "︳", "｛": "︷", "｜": "―", "｝": "︸", "｟": "︵", "｠": "︶", "｡": "︒", "｢": "﹁", "｣": "﹂" };
            var bl = 24, _l = function(t5, e4, r4, n4, i2) {
              var a2, o2, s2 = 8 * i2 - n4 - 1, l2 = (1 << s2) - 1, u2 = l2 >> 1, c2 = -7, f3 = r4 ? i2 - 1 : 0, h2 = r4 ? -1 : 1, p3 = t5[e4 + f3];
              for (f3 += h2, a2 = p3 & (1 << -c2) - 1, p3 >>= -c2, c2 += s2; c2 > 0; a2 = 256 * a2 + t5[e4 + f3], f3 += h2, c2 -= 8)
                ;
              for (o2 = a2 & (1 << -c2) - 1, a2 >>= -c2, c2 += n4; c2 > 0; o2 = 256 * o2 + t5[e4 + f3], f3 += h2, c2 -= 8)
                ;
              if (0 === a2)
                a2 = 1 - u2;
              else {
                if (a2 === l2)
                  return o2 ? NaN : 1 / 0 * (p3 ? -1 : 1);
                o2 += Math.pow(2, n4), a2 -= u2;
              }
              return (p3 ? -1 : 1) * o2 * Math.pow(2, a2 - n4);
            }, wl = function(t5, e4, r4, n4, i2, a2) {
              var o2, s2, l2, u2 = 8 * a2 - i2 - 1, c2 = (1 << u2) - 1, f3 = c2 >> 1, h2 = 23 === i2 ? Math.pow(2, -24) - Math.pow(2, -77) : 0, p3 = n4 ? 0 : a2 - 1, d3 = n4 ? 1 : -1, v2 = e4 < 0 || 0 === e4 && 1 / e4 < 0 ? 1 : 0;
              for (e4 = Math.abs(e4), isNaN(e4) || e4 === 1 / 0 ? (s2 = isNaN(e4) ? 1 : 0, o2 = c2) : (o2 = Math.floor(Math.log(e4) / Math.LN2), e4 * (l2 = Math.pow(2, -o2)) < 1 && (o2--, l2 *= 2), (e4 += o2 + f3 >= 1 ? h2 / l2 : h2 * Math.pow(2, 1 - f3)) * l2 >= 2 && (o2++, l2 /= 2), o2 + f3 >= c2 ? (s2 = 0, o2 = c2) : o2 + f3 >= 1 ? (s2 = (e4 * l2 - 1) * Math.pow(2, i2), o2 += f3) : (s2 = e4 * Math.pow(2, f3 - 1) * Math.pow(2, i2), o2 = 0)); i2 >= 8; t5[r4 + p3] = 255 & s2, p3 += d3, s2 /= 256, i2 -= 8)
                ;
              for (o2 = o2 << i2 | s2, u2 += i2; u2 > 0; t5[r4 + p3] = 255 & o2, p3 += d3, o2 /= 256, u2 -= 8)
                ;
              t5[r4 + p3 - d3] |= 128 * v2;
            }, Tl = kl;
            function kl(t5) {
              this.buf = ArrayBuffer.isView && ArrayBuffer.isView(t5) ? t5 : new Uint8Array(t5 || 0), this.pos = 0, this.type = 0, this.length = this.buf.length;
            }
            kl.Varint = 0, kl.Fixed64 = 1, kl.Bytes = 2, kl.Fixed32 = 5;
            var Al = 4294967296, Ml = 1 / Al, Sl = "undefined" == typeof TextDecoder ? null : new TextDecoder("utf8");
            function El(t5) {
              return t5.type === kl.Bytes ? t5.readVarint() + t5.pos : t5.pos + 1;
            }
            function Ll(t5, e4, r4) {
              return r4 ? 4294967296 * e4 + (t5 >>> 0) : 4294967296 * (e4 >>> 0) + (t5 >>> 0);
            }
            function Cl(t5, e4, r4) {
              var n4 = e4 <= 16383 ? 1 : e4 <= 2097151 ? 2 : e4 <= 268435455 ? 3 : Math.floor(Math.log(e4) / (7 * Math.LN2));
              r4.realloc(n4);
              for (var i2 = r4.pos - 1; i2 >= t5; i2--)
                r4.buf[i2 + n4] = r4.buf[i2];
            }
            function Pl(t5, e4) {
              for (var r4 = 0; r4 < t5.length; r4++)
                e4.writeVarint(t5[r4]);
            }
            function Ol(t5, e4) {
              for (var r4 = 0; r4 < t5.length; r4++)
                e4.writeSVarint(t5[r4]);
            }
            function Il(t5, e4) {
              for (var r4 = 0; r4 < t5.length; r4++)
                e4.writeFloat(t5[r4]);
            }
            function Dl(t5, e4) {
              for (var r4 = 0; r4 < t5.length; r4++)
                e4.writeDouble(t5[r4]);
            }
            function zl(t5, e4) {
              for (var r4 = 0; r4 < t5.length; r4++)
                e4.writeBoolean(t5[r4]);
            }
            function Rl(t5, e4) {
              for (var r4 = 0; r4 < t5.length; r4++)
                e4.writeFixed32(t5[r4]);
            }
            function Fl(t5, e4) {
              for (var r4 = 0; r4 < t5.length; r4++)
                e4.writeSFixed32(t5[r4]);
            }
            function Bl(t5, e4) {
              for (var r4 = 0; r4 < t5.length; r4++)
                e4.writeFixed64(t5[r4]);
            }
            function Nl(t5, e4) {
              for (var r4 = 0; r4 < t5.length; r4++)
                e4.writeSFixed64(t5[r4]);
            }
            function jl(t5, e4) {
              return (t5[e4] | t5[e4 + 1] << 8 | t5[e4 + 2] << 16) + 16777216 * t5[e4 + 3];
            }
            function Ul(t5, e4, r4) {
              t5[r4] = e4, t5[r4 + 1] = e4 >>> 8, t5[r4 + 2] = e4 >>> 16, t5[r4 + 3] = e4 >>> 24;
            }
            function Vl(t5, e4) {
              return (t5[e4] | t5[e4 + 1] << 8 | t5[e4 + 2] << 16) + (t5[e4 + 3] << 24);
            }
            kl.prototype = { destroy: function() {
              this.buf = null;
            }, readFields: function(t5, e4, r4) {
              for (r4 = r4 || this.length; this.pos < r4; ) {
                var n4 = this.readVarint(), i2 = n4 >> 3, a2 = this.pos;
                this.type = 7 & n4, t5(i2, e4, this), this.pos === a2 && this.skip(n4);
              }
              return e4;
            }, readMessage: function(t5, e4) {
              return this.readFields(t5, e4, this.readVarint() + this.pos);
            }, readFixed32: function() {
              var t5 = jl(this.buf, this.pos);
              return this.pos += 4, t5;
            }, readSFixed32: function() {
              var t5 = Vl(this.buf, this.pos);
              return this.pos += 4, t5;
            }, readFixed64: function() {
              var t5 = jl(this.buf, this.pos) + jl(this.buf, this.pos + 4) * Al;
              return this.pos += 8, t5;
            }, readSFixed64: function() {
              var t5 = jl(this.buf, this.pos) + Vl(this.buf, this.pos + 4) * Al;
              return this.pos += 8, t5;
            }, readFloat: function() {
              var t5 = _l(this.buf, this.pos, true, 23, 4);
              return this.pos += 4, t5;
            }, readDouble: function() {
              var t5 = _l(this.buf, this.pos, true, 52, 8);
              return this.pos += 8, t5;
            }, readVarint: function(t5) {
              var e4, r4, n4 = this.buf;
              return e4 = 127 & (r4 = n4[this.pos++]), r4 < 128 ? e4 : (e4 |= (127 & (r4 = n4[this.pos++])) << 7, r4 < 128 ? e4 : (e4 |= (127 & (r4 = n4[this.pos++])) << 14, r4 < 128 ? e4 : (e4 |= (127 & (r4 = n4[this.pos++])) << 21, r4 < 128 ? e4 : function(t6, e5, r5) {
                var n5, i2, a2 = r5.buf;
                if (n5 = (112 & (i2 = a2[r5.pos++])) >> 4, i2 < 128)
                  return Ll(t6, n5, e5);
                if (n5 |= (127 & (i2 = a2[r5.pos++])) << 3, i2 < 128)
                  return Ll(t6, n5, e5);
                if (n5 |= (127 & (i2 = a2[r5.pos++])) << 10, i2 < 128)
                  return Ll(t6, n5, e5);
                if (n5 |= (127 & (i2 = a2[r5.pos++])) << 17, i2 < 128)
                  return Ll(t6, n5, e5);
                if (n5 |= (127 & (i2 = a2[r5.pos++])) << 24, i2 < 128)
                  return Ll(t6, n5, e5);
                if (n5 |= (1 & (i2 = a2[r5.pos++])) << 31, i2 < 128)
                  return Ll(t6, n5, e5);
                throw new Error("Expected varint not more than 10 bytes");
              }(e4 |= (15 & (r4 = n4[this.pos])) << 28, t5, this))));
            }, readVarint64: function() {
              return this.readVarint(true);
            }, readSVarint: function() {
              var t5 = this.readVarint();
              return t5 % 2 == 1 ? (t5 + 1) / -2 : t5 / 2;
            }, readBoolean: function() {
              return Boolean(this.readVarint());
            }, readString: function() {
              var t5 = this.readVarint() + this.pos, e4 = this.pos;
              return this.pos = t5, t5 - e4 >= 12 && Sl ? function(t6, e5, r4) {
                return Sl.decode(t6.subarray(e5, r4));
              }(this.buf, e4, t5) : function(t6, e5, r4) {
                for (var n4 = "", i2 = e5; i2 < r4; ) {
                  var a2, o2, s2, l2 = t6[i2], u2 = null, c2 = l2 > 239 ? 4 : l2 > 223 ? 3 : l2 > 191 ? 2 : 1;
                  if (i2 + c2 > r4)
                    break;
                  1 === c2 ? l2 < 128 && (u2 = l2) : 2 === c2 ? 128 == (192 & (a2 = t6[i2 + 1])) && (u2 = (31 & l2) << 6 | 63 & a2) <= 127 && (u2 = null) : 3 === c2 ? (a2 = t6[i2 + 1], o2 = t6[i2 + 2], 128 == (192 & a2) && 128 == (192 & o2) && ((u2 = (15 & l2) << 12 | (63 & a2) << 6 | 63 & o2) <= 2047 || u2 >= 55296 && u2 <= 57343) && (u2 = null)) : 4 === c2 && (a2 = t6[i2 + 1], o2 = t6[i2 + 2], s2 = t6[i2 + 3], 128 == (192 & a2) && 128 == (192 & o2) && 128 == (192 & s2) && ((u2 = (15 & l2) << 18 | (63 & a2) << 12 | (63 & o2) << 6 | 63 & s2) <= 65535 || u2 >= 1114112) && (u2 = null)), null === u2 ? (u2 = 65533, c2 = 1) : u2 > 65535 && (u2 -= 65536, n4 += String.fromCharCode(u2 >>> 10 & 1023 | 55296), u2 = 56320 | 1023 & u2), n4 += String.fromCharCode(u2), i2 += c2;
                }
                return n4;
              }(this.buf, e4, t5);
            }, readBytes: function() {
              var t5 = this.readVarint() + this.pos, e4 = this.buf.subarray(this.pos, t5);
              return this.pos = t5, e4;
            }, readPackedVarint: function(t5, e4) {
              if (this.type !== kl.Bytes)
                return t5.push(this.readVarint(e4));
              var r4 = El(this);
              for (t5 = t5 || []; this.pos < r4; )
                t5.push(this.readVarint(e4));
              return t5;
            }, readPackedSVarint: function(t5) {
              if (this.type !== kl.Bytes)
                return t5.push(this.readSVarint());
              var e4 = El(this);
              for (t5 = t5 || []; this.pos < e4; )
                t5.push(this.readSVarint());
              return t5;
            }, readPackedBoolean: function(t5) {
              if (this.type !== kl.Bytes)
                return t5.push(this.readBoolean());
              var e4 = El(this);
              for (t5 = t5 || []; this.pos < e4; )
                t5.push(this.readBoolean());
              return t5;
            }, readPackedFloat: function(t5) {
              if (this.type !== kl.Bytes)
                return t5.push(this.readFloat());
              var e4 = El(this);
              for (t5 = t5 || []; this.pos < e4; )
                t5.push(this.readFloat());
              return t5;
            }, readPackedDouble: function(t5) {
              if (this.type !== kl.Bytes)
                return t5.push(this.readDouble());
              var e4 = El(this);
              for (t5 = t5 || []; this.pos < e4; )
                t5.push(this.readDouble());
              return t5;
            }, readPackedFixed32: function(t5) {
              if (this.type !== kl.Bytes)
                return t5.push(this.readFixed32());
              var e4 = El(this);
              for (t5 = t5 || []; this.pos < e4; )
                t5.push(this.readFixed32());
              return t5;
            }, readPackedSFixed32: function(t5) {
              if (this.type !== kl.Bytes)
                return t5.push(this.readSFixed32());
              var e4 = El(this);
              for (t5 = t5 || []; this.pos < e4; )
                t5.push(this.readSFixed32());
              return t5;
            }, readPackedFixed64: function(t5) {
              if (this.type !== kl.Bytes)
                return t5.push(this.readFixed64());
              var e4 = El(this);
              for (t5 = t5 || []; this.pos < e4; )
                t5.push(this.readFixed64());
              return t5;
            }, readPackedSFixed64: function(t5) {
              if (this.type !== kl.Bytes)
                return t5.push(this.readSFixed64());
              var e4 = El(this);
              for (t5 = t5 || []; this.pos < e4; )
                t5.push(this.readSFixed64());
              return t5;
            }, skip: function(t5) {
              var e4 = 7 & t5;
              if (e4 === kl.Varint)
                for (; this.buf[this.pos++] > 127; )
                  ;
              else if (e4 === kl.Bytes)
                this.pos = this.readVarint() + this.pos;
              else if (e4 === kl.Fixed32)
                this.pos += 4;
              else {
                if (e4 !== kl.Fixed64)
                  throw new Error("Unimplemented type: " + e4);
                this.pos += 8;
              }
            }, writeTag: function(t5, e4) {
              this.writeVarint(t5 << 3 | e4);
            }, realloc: function(t5) {
              for (var e4 = this.length || 16; e4 < this.pos + t5; )
                e4 *= 2;
              if (e4 !== this.length) {
                var r4 = new Uint8Array(e4);
                r4.set(this.buf), this.buf = r4, this.length = e4;
              }
            }, finish: function() {
              return this.length = this.pos, this.pos = 0, this.buf.subarray(0, this.length);
            }, writeFixed32: function(t5) {
              this.realloc(4), Ul(this.buf, t5, this.pos), this.pos += 4;
            }, writeSFixed32: function(t5) {
              this.realloc(4), Ul(this.buf, t5, this.pos), this.pos += 4;
            }, writeFixed64: function(t5) {
              this.realloc(8), Ul(this.buf, -1 & t5, this.pos), Ul(this.buf, Math.floor(t5 * Ml), this.pos + 4), this.pos += 8;
            }, writeSFixed64: function(t5) {
              this.realloc(8), Ul(this.buf, -1 & t5, this.pos), Ul(this.buf, Math.floor(t5 * Ml), this.pos + 4), this.pos += 8;
            }, writeVarint: function(t5) {
              (t5 = +t5 || 0) > 268435455 || t5 < 0 ? function(t6, e4) {
                var r4, n4;
                if (t6 >= 0 ? (r4 = t6 % 4294967296 | 0, n4 = t6 / 4294967296 | 0) : (n4 = ~(-t6 / 4294967296), 4294967295 ^ (r4 = ~(-t6 % 4294967296)) ? r4 = r4 + 1 | 0 : (r4 = 0, n4 = n4 + 1 | 0)), t6 >= 18446744073709552e3 || t6 < -18446744073709552e3)
                  throw new Error("Given varint doesn't fit into 10 bytes");
                e4.realloc(10), function(t7, e5, r5) {
                  r5.buf[r5.pos++] = 127 & t7 | 128, t7 >>>= 7, r5.buf[r5.pos++] = 127 & t7 | 128, t7 >>>= 7, r5.buf[r5.pos++] = 127 & t7 | 128, t7 >>>= 7, r5.buf[r5.pos++] = 127 & t7 | 128, t7 >>>= 7, r5.buf[r5.pos] = 127 & t7;
                }(r4, 0, e4), function(t7, e5) {
                  var r5 = (7 & t7) << 4;
                  e5.buf[e5.pos++] |= r5 | ((t7 >>>= 3) ? 128 : 0), t7 && (e5.buf[e5.pos++] = 127 & t7 | ((t7 >>>= 7) ? 128 : 0), t7 && (e5.buf[e5.pos++] = 127 & t7 | ((t7 >>>= 7) ? 128 : 0), t7 && (e5.buf[e5.pos++] = 127 & t7 | ((t7 >>>= 7) ? 128 : 0), t7 && (e5.buf[e5.pos++] = 127 & t7 | ((t7 >>>= 7) ? 128 : 0), t7 && (e5.buf[e5.pos++] = 127 & t7)))));
                }(n4, e4);
              }(t5, this) : (this.realloc(4), this.buf[this.pos++] = 127 & t5 | (t5 > 127 ? 128 : 0), t5 <= 127 || (this.buf[this.pos++] = 127 & (t5 >>>= 7) | (t5 > 127 ? 128 : 0), t5 <= 127 || (this.buf[this.pos++] = 127 & (t5 >>>= 7) | (t5 > 127 ? 128 : 0), t5 <= 127 || (this.buf[this.pos++] = t5 >>> 7 & 127))));
            }, writeSVarint: function(t5) {
              this.writeVarint(t5 < 0 ? 2 * -t5 - 1 : 2 * t5);
            }, writeBoolean: function(t5) {
              this.writeVarint(Boolean(t5));
            }, writeString: function(t5) {
              t5 = String(t5), this.realloc(4 * t5.length), this.pos++;
              var e4 = this.pos;
              this.pos = function(t6, e5, r5) {
                for (var n4, i2, a2 = 0; a2 < e5.length; a2++) {
                  if ((n4 = e5.charCodeAt(a2)) > 55295 && n4 < 57344) {
                    if (!i2) {
                      n4 > 56319 || a2 + 1 === e5.length ? (t6[r5++] = 239, t6[r5++] = 191, t6[r5++] = 189) : i2 = n4;
                      continue;
                    }
                    if (n4 < 56320) {
                      t6[r5++] = 239, t6[r5++] = 191, t6[r5++] = 189, i2 = n4;
                      continue;
                    }
                    n4 = i2 - 55296 << 10 | n4 - 56320 | 65536, i2 = null;
                  } else
                    i2 && (t6[r5++] = 239, t6[r5++] = 191, t6[r5++] = 189, i2 = null);
                  n4 < 128 ? t6[r5++] = n4 : (n4 < 2048 ? t6[r5++] = n4 >> 6 | 192 : (n4 < 65536 ? t6[r5++] = n4 >> 12 | 224 : (t6[r5++] = n4 >> 18 | 240, t6[r5++] = n4 >> 12 & 63 | 128), t6[r5++] = n4 >> 6 & 63 | 128), t6[r5++] = 63 & n4 | 128);
                }
                return r5;
              }(this.buf, t5, this.pos);
              var r4 = this.pos - e4;
              r4 >= 128 && Cl(e4, r4, this), this.pos = e4 - 1, this.writeVarint(r4), this.pos += r4;
            }, writeFloat: function(t5) {
              this.realloc(4), wl(this.buf, t5, this.pos, true, 23, 4), this.pos += 4;
            }, writeDouble: function(t5) {
              this.realloc(8), wl(this.buf, t5, this.pos, true, 52, 8), this.pos += 8;
            }, writeBytes: function(t5) {
              var e4 = t5.length;
              this.writeVarint(e4), this.realloc(e4);
              for (var r4 = 0; r4 < e4; r4++)
                this.buf[this.pos++] = t5[r4];
            }, writeRawMessage: function(t5, e4) {
              this.pos++;
              var r4 = this.pos;
              t5(e4, this);
              var n4 = this.pos - r4;
              n4 >= 128 && Cl(r4, n4, this), this.pos = r4 - 1, this.writeVarint(n4), this.pos += n4;
            }, writeMessage: function(t5, e4, r4) {
              this.writeTag(t5, kl.Bytes), this.writeRawMessage(e4, r4);
            }, writePackedVarint: function(t5, e4) {
              e4.length && this.writeMessage(t5, Pl, e4);
            }, writePackedSVarint: function(t5, e4) {
              e4.length && this.writeMessage(t5, Ol, e4);
            }, writePackedBoolean: function(t5, e4) {
              e4.length && this.writeMessage(t5, zl, e4);
            }, writePackedFloat: function(t5, e4) {
              e4.length && this.writeMessage(t5, Il, e4);
            }, writePackedDouble: function(t5, e4) {
              e4.length && this.writeMessage(t5, Dl, e4);
            }, writePackedFixed32: function(t5, e4) {
              e4.length && this.writeMessage(t5, Rl, e4);
            }, writePackedSFixed32: function(t5, e4) {
              e4.length && this.writeMessage(t5, Fl, e4);
            }, writePackedFixed64: function(t5, e4) {
              e4.length && this.writeMessage(t5, Bl, e4);
            }, writePackedSFixed64: function(t5, e4) {
              e4.length && this.writeMessage(t5, Nl, e4);
            }, writeBytesField: function(t5, e4) {
              this.writeTag(t5, kl.Bytes), this.writeBytes(e4);
            }, writeFixed32Field: function(t5, e4) {
              this.writeTag(t5, kl.Fixed32), this.writeFixed32(e4);
            }, writeSFixed32Field: function(t5, e4) {
              this.writeTag(t5, kl.Fixed32), this.writeSFixed32(e4);
            }, writeFixed64Field: function(t5, e4) {
              this.writeTag(t5, kl.Fixed64), this.writeFixed64(e4);
            }, writeSFixed64Field: function(t5, e4) {
              this.writeTag(t5, kl.Fixed64), this.writeSFixed64(e4);
            }, writeVarintField: function(t5, e4) {
              this.writeTag(t5, kl.Varint), this.writeVarint(e4);
            }, writeSVarintField: function(t5, e4) {
              this.writeTag(t5, kl.Varint), this.writeSVarint(e4);
            }, writeStringField: function(t5, e4) {
              this.writeTag(t5, kl.Bytes), this.writeString(e4);
            }, writeFloatField: function(t5, e4) {
              this.writeTag(t5, kl.Fixed32), this.writeFloat(e4);
            }, writeDoubleField: function(t5, e4) {
              this.writeTag(t5, kl.Fixed64), this.writeDouble(e4);
            }, writeBooleanField: function(t5, e4) {
              this.writeVarintField(t5, Boolean(e4));
            } };
            function Hl(t5, e4, r4) {
              1 === t5 && r4.readMessage(ql, e4);
            }
            function ql(t5, e4, r4) {
              if (3 === t5) {
                var n4 = r4.readMessage(Gl, {}), i2 = n4.id, a2 = n4.bitmap, o2 = n4.width, s2 = n4.height, l2 = n4.left, u2 = n4.top, c2 = n4.advance;
                e4.push({ id: i2, bitmap: new Ho({ width: o2 + 6, height: s2 + 6 }, a2), metrics: { width: o2, height: s2, left: l2, top: u2, advance: c2 } });
              }
            }
            function Gl(t5, e4, r4) {
              1 === t5 ? e4.id = r4.readVarint() : 2 === t5 ? e4.bitmap = r4.readBytes() : 3 === t5 ? e4.width = r4.readVarint() : 4 === t5 ? e4.height = r4.readVarint() : 5 === t5 ? e4.left = r4.readSVarint() : 6 === t5 ? e4.top = r4.readSVarint() : 7 === t5 && (e4.advance = r4.readVarint());
            }
            function Zl(t5) {
              for (var e4 = 0, r4 = 0, n4 = 0, i2 = t5; n4 < i2.length; n4 += 1) {
                var a2 = i2[n4];
                e4 += a2.w * a2.h, r4 = Math.max(r4, a2.w);
              }
              t5.sort(function(t6, e5) {
                return e5.h - t6.h;
              });
              for (var o2 = [{ x: 0, y: 0, w: Math.max(Math.ceil(Math.sqrt(e4 / 0.95)), r4), h: 1 / 0 }], s2 = 0, l2 = 0, u2 = 0, c2 = t5; u2 < c2.length; u2 += 1)
                for (var f3 = c2[u2], h2 = o2.length - 1; h2 >= 0; h2--) {
                  var p3 = o2[h2];
                  if (!(f3.w > p3.w || f3.h > p3.h)) {
                    if (f3.x = p3.x, f3.y = p3.y, l2 = Math.max(l2, f3.y + f3.h), s2 = Math.max(s2, f3.x + f3.w), f3.w === p3.w && f3.h === p3.h) {
                      var d3 = o2.pop();
                      h2 < o2.length && (o2[h2] = d3);
                    } else
                      f3.h === p3.h ? (p3.x += f3.w, p3.w -= f3.w) : f3.w === p3.w ? (p3.y += f3.h, p3.h -= f3.h) : (o2.push({ x: p3.x + f3.w, y: p3.y, w: p3.w - f3.w, h: f3.h }), p3.y += f3.h, p3.h -= f3.h);
                    break;
                  }
                }
              return { w: s2, h: l2, fill: e4 / (s2 * l2) || 0 };
            }
            var Yl = function(t5, e4) {
              var r4 = e4.pixelRatio, n4 = e4.version, i2 = e4.stretchX, a2 = e4.stretchY, o2 = e4.content;
              this.paddedRect = t5, this.pixelRatio = r4, this.stretchX = i2, this.stretchY = a2, this.content = o2, this.version = n4;
            }, Wl = { tl: { configurable: true }, br: { configurable: true }, tlbr: { configurable: true }, displaySize: { configurable: true } };
            Wl.tl.get = function() {
              return [this.paddedRect.x + 1, this.paddedRect.y + 1];
            }, Wl.br.get = function() {
              return [this.paddedRect.x + this.paddedRect.w - 1, this.paddedRect.y + this.paddedRect.h - 1];
            }, Wl.tlbr.get = function() {
              return this.tl.concat(this.br);
            }, Wl.displaySize.get = function() {
              return [(this.paddedRect.w - 2) / this.pixelRatio, (this.paddedRect.h - 2) / this.pixelRatio];
            }, Object.defineProperties(Yl.prototype, Wl);
            var Xl = function(t5, e4) {
              var r4 = {}, n4 = {};
              this.haveRenderCallbacks = [];
              var i2 = [];
              this.addImages(t5, r4, i2), this.addImages(e4, n4, i2);
              var a2 = Zl(i2), o2 = a2.w, s2 = a2.h, l2 = new qo({ width: o2 || 1, height: s2 || 1 });
              for (var u2 in t5) {
                var c2 = t5[u2], f3 = r4[u2].paddedRect;
                qo.copy(c2.data, l2, { x: 0, y: 0 }, { x: f3.x + 1, y: f3.y + 1 }, c2.data);
              }
              for (var h2 in e4) {
                var p3 = e4[h2], d3 = n4[h2].paddedRect, v2 = d3.x + 1, g3 = d3.y + 1, y2 = p3.data.width, m3 = p3.data.height;
                qo.copy(p3.data, l2, { x: 0, y: 0 }, { x: v2, y: g3 }, p3.data), qo.copy(p3.data, l2, { x: 0, y: m3 - 1 }, { x: v2, y: g3 - 1 }, { width: y2, height: 1 }), qo.copy(p3.data, l2, { x: 0, y: 0 }, { x: v2, y: g3 + m3 }, { width: y2, height: 1 }), qo.copy(p3.data, l2, { x: y2 - 1, y: 0 }, { x: v2 - 1, y: g3 }, { width: 1, height: m3 }), qo.copy(p3.data, l2, { x: 0, y: 0 }, { x: v2 + y2, y: g3 }, { width: 1, height: m3 });
              }
              this.image = l2, this.iconPositions = r4, this.patternPositions = n4;
            };
            Xl.prototype.addImages = function(t5, e4, r4) {
              for (var n4 in t5) {
                var i2 = t5[n4], a2 = { x: 0, y: 0, w: i2.data.width + 2, h: i2.data.height + 2 };
                r4.push(a2), e4[n4] = new Yl(a2, i2), i2.hasRenderCallback && this.haveRenderCallbacks.push(n4);
              }
            }, Xl.prototype.patchUpdatedImages = function(t5, e4) {
              for (var r4 in t5.dispatchRenderCallbacks(this.haveRenderCallbacks), t5.updatedImages)
                this.patchUpdatedImage(this.iconPositions[r4], t5.getImage(r4), e4), this.patchUpdatedImage(this.patternPositions[r4], t5.getImage(r4), e4);
            }, Xl.prototype.patchUpdatedImage = function(t5, e4, r4) {
              if (t5 && e4 && t5.version !== e4.version) {
                t5.version = e4.version;
                var n4 = t5.tl, i2 = n4[0], a2 = n4[1];
                r4.update(e4.data, void 0, { x: i2, y: a2 });
              }
            }, Qn("ImagePosition", Yl), Qn("ImageAtlas", Xl);
            var Jl = { horizontal: 1, vertical: 2, horizontalOnly: 3 }, Kl = -17;
            var $l = function() {
              this.scale = 1, this.fontStack = "", this.imageName = null;
            };
            $l.forText = function(t5, e4) {
              var r4 = new $l();
              return r4.scale = t5 || 1, r4.fontStack = e4, r4;
            }, $l.forImage = function(t5) {
              var e4 = new $l();
              return e4.imageName = t5, e4;
            };
            var Ql = function() {
              this.text = "", this.sectionIndex = [], this.sections = [], this.imageSectionID = null;
            };
            function tu(t5, e4, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3, d3, v2) {
              var g3, y2 = Ql.fromFeature(t5, i2);
              f3 === Jl.vertical && y2.verticalizePunctuation();
              var m3 = Mi.processBidirectionalText, x2 = Mi.processStyledBidirectionalText;
              if (m3 && 1 === y2.sections.length) {
                g3 = [];
                for (var b2 = 0, _2 = m3(y2.toString(), lu(y2, u2, a2, e4, n4, p3, d3)); b2 < _2.length; b2 += 1) {
                  var w3 = _2[b2], T2 = new Ql();
                  T2.text = w3, T2.sections = y2.sections;
                  for (var k2 = 0; k2 < w3.length; k2++)
                    T2.sectionIndex.push(0);
                  g3.push(T2);
                }
              } else if (x2) {
                g3 = [];
                for (var A2 = 0, M2 = x2(y2.text, y2.sectionIndex, lu(y2, u2, a2, e4, n4, p3, d3)); A2 < M2.length; A2 += 1) {
                  var S2 = M2[A2], E2 = new Ql();
                  E2.text = S2[0], E2.sectionIndex = S2[1], E2.sections = y2.sections, g3.push(E2);
                }
              } else
                g3 = function(t6, e5) {
                  for (var r5 = [], n5 = t6.text, i3 = 0, a3 = 0, o3 = e5; a3 < o3.length; a3 += 1) {
                    var s3 = o3[a3];
                    r5.push(t6.substring(i3, s3)), i3 = s3;
                  }
                  return i3 < n5.length && r5.push(t6.substring(i3, n5.length)), r5;
                }(y2, lu(y2, u2, a2, e4, n4, p3, d3));
              var L2 = [], C2 = { positionedLines: L2, text: y2.toString(), top: c2[1], bottom: c2[1], left: c2[0], right: c2[0], writingMode: f3, iconsInText: false, verticalizable: false };
              return function(t6, e5, r5, n5, i3, a3, o3, s3, l3, u3, c3, f4) {
                for (var h3 = 0, p4 = Kl, d4 = 0, v3 = 0, g4 = "right" === s3 ? 1 : "left" === s3 ? 0 : 0.5, y3 = 0, m4 = 0, x3 = i3; m4 < x3.length; m4 += 1) {
                  var b3 = x3[m4];
                  b3.trim();
                  var _3 = b3.getMaxScale(), w4 = (_3 - 1) * bl, T3 = { positionedGlyphs: [], lineOffset: 0 };
                  t6.positionedLines[y3] = T3;
                  var k3 = T3.positionedGlyphs, A3 = 0;
                  if (b3.length()) {
                    for (var M3 = 0; M3 < b3.length(); M3++) {
                      var S3 = b3.getSection(M3), E3 = b3.getSectionIndex(M3), L3 = b3.getCharCode(M3), C3 = 0, P2 = null, O2 = null, I2 = null, D2 = bl, z2 = !(l3 === Jl.horizontal || !c3 && !li(L3) || c3 && (eu[L3] || ci(L3)));
                      if (S3.imageName) {
                        var R2 = n5[S3.imageName];
                        if (!R2)
                          continue;
                        I2 = S3.imageName, t6.iconsInText = t6.iconsInText || true, O2 = R2.paddedRect;
                        var F2 = R2.displaySize;
                        S3.scale = S3.scale * bl / f4, P2 = { width: F2[0], height: F2[1], left: 1, top: -3, advance: z2 ? F2[1] : F2[0] }, C3 = w4 + (bl - F2[1] * S3.scale), D2 = P2.advance;
                        var B2 = z2 ? F2[0] * S3.scale - bl * _3 : F2[1] * S3.scale - bl * _3;
                        B2 > 0 && B2 > A3 && (A3 = B2);
                      } else {
                        var N2 = r5[S3.fontStack], j2 = N2 && N2[L3];
                        if (j2 && j2.rect)
                          O2 = j2.rect, P2 = j2.metrics;
                        else {
                          var U2 = e5[S3.fontStack], V2 = U2 && U2[L3];
                          if (!V2)
                            continue;
                          P2 = V2.metrics;
                        }
                        C3 = (_3 - S3.scale) * bl;
                      }
                      z2 ? (t6.verticalizable = true, k3.push({ glyph: L3, imageName: I2, x: h3, y: p4 + C3, vertical: z2, scale: S3.scale, fontStack: S3.fontStack, sectionIndex: E3, metrics: P2, rect: O2 }), h3 += D2 * S3.scale + u3) : (k3.push({ glyph: L3, imageName: I2, x: h3, y: p4 + C3, vertical: z2, scale: S3.scale, fontStack: S3.fontStack, sectionIndex: E3, metrics: P2, rect: O2 }), h3 += P2.advance * S3.scale + u3);
                    }
                    if (0 !== k3.length) {
                      var H2 = h3 - u3;
                      d4 = Math.max(H2, d4), cu(k3, 0, k3.length - 1, g4, A3);
                    }
                    h3 = 0;
                    var q3 = a3 * _3 + A3;
                    T3.lineOffset = Math.max(A3, w4), p4 += q3, v3 = Math.max(q3, v3), ++y3;
                  } else
                    p4 += a3, ++y3;
                }
                var G2 = p4 - Kl, Z2 = uu(o3), Y2 = Z2.horizontalAlign, W2 = Z2.verticalAlign;
                (function(t7, e6, r6, n6, i4, a4, o4, s4, l4) {
                  var u4 = (e6 - r6) * i4, c4 = 0;
                  c4 = a4 !== o4 ? -s4 * n6 - Kl : (-n6 * l4 + 0.5) * o4;
                  for (var f5 = 0, h4 = t7; f5 < h4.length; f5 += 1)
                    for (var p5 = 0, d5 = h4[f5].positionedGlyphs; p5 < d5.length; p5 += 1) {
                      var v4 = d5[p5];
                      v4.x += u4, v4.y += c4;
                    }
                })(t6.positionedLines, g4, Y2, W2, d4, v3, a3, G2, i3.length), t6.top += -W2 * G2, t6.bottom = t6.top + G2, t6.left += -Y2 * d4, t6.right = t6.left + d4;
              }(C2, e4, r4, n4, g3, o2, s2, l2, f3, u2, h2, v2), !function(t6) {
                for (var e5 = 0, r5 = t6; e5 < r5.length; e5 += 1)
                  if (0 !== r5[e5].positionedGlyphs.length)
                    return false;
                return true;
              }(L2) && C2;
            }
            Ql.fromFeature = function(t5, e4) {
              for (var r4 = new Ql(), n4 = 0; n4 < t5.sections.length; n4++) {
                var i2 = t5.sections[n4];
                i2.image ? r4.addImageSection(i2) : r4.addTextSection(i2, e4);
              }
              return r4;
            }, Ql.prototype.length = function() {
              return this.text.length;
            }, Ql.prototype.getSection = function(t5) {
              return this.sections[this.sectionIndex[t5]];
            }, Ql.prototype.getSectionIndex = function(t5) {
              return this.sectionIndex[t5];
            }, Ql.prototype.getCharCode = function(t5) {
              return this.text.charCodeAt(t5);
            }, Ql.prototype.verticalizePunctuation = function() {
              this.text = function(t5) {
                for (var e4 = "", r4 = 0; r4 < t5.length; r4++) {
                  var n4 = t5.charCodeAt(r4 + 1) || null, i2 = t5.charCodeAt(r4 - 1) || null;
                  n4 && ui(n4) && !xl[t5[r4 + 1]] || i2 && ui(i2) && !xl[t5[r4 - 1]] || !xl[t5[r4]] ? e4 += t5[r4] : e4 += xl[t5[r4]];
                }
                return e4;
              }(this.text);
            }, Ql.prototype.trim = function() {
              for (var t5 = 0, e4 = 0; e4 < this.text.length && eu[this.text.charCodeAt(e4)]; e4++)
                t5++;
              for (var r4 = this.text.length, n4 = this.text.length - 1; n4 >= 0 && n4 >= t5 && eu[this.text.charCodeAt(n4)]; n4--)
                r4--;
              this.text = this.text.substring(t5, r4), this.sectionIndex = this.sectionIndex.slice(t5, r4);
            }, Ql.prototype.substring = function(t5, e4) {
              var r4 = new Ql();
              return r4.text = this.text.substring(t5, e4), r4.sectionIndex = this.sectionIndex.slice(t5, e4), r4.sections = this.sections, r4;
            }, Ql.prototype.toString = function() {
              return this.text;
            }, Ql.prototype.getMaxScale = function() {
              var t5 = this;
              return this.sectionIndex.reduce(function(e4, r4) {
                return Math.max(e4, t5.sections[r4].scale);
              }, 0);
            }, Ql.prototype.addTextSection = function(t5, e4) {
              this.text += t5.text, this.sections.push($l.forText(t5.scale, t5.fontStack || e4));
              for (var r4 = this.sections.length - 1, n4 = 0; n4 < t5.text.length; ++n4)
                this.sectionIndex.push(r4);
            }, Ql.prototype.addImageSection = function(t5) {
              var e4 = t5.image ? t5.image.name : "";
              if (0 !== e4.length) {
                var r4 = this.getNextImageSectionCharCode();
                r4 ? (this.text += String.fromCharCode(r4), this.sections.push($l.forImage(e4)), this.sectionIndex.push(this.sections.length - 1)) : w2("Reached maximum number of images 6401");
              } else
                w2("Can't add FormattedSection with an empty image.");
            }, Ql.prototype.getNextImageSectionCharCode = function() {
              return this.imageSectionID ? this.imageSectionID >= 63743 ? null : ++this.imageSectionID : (this.imageSectionID = 57344, this.imageSectionID);
            };
            var eu = { 9: true, 10: true, 11: true, 12: true, 13: true, 32: true }, ru = {};
            function nu(t5, e4, r4, n4, i2, a2) {
              if (e4.imageName) {
                var o2 = n4[e4.imageName];
                return o2 ? o2.displaySize[0] * e4.scale * bl / a2 + i2 : 0;
              }
              var s2 = r4[e4.fontStack], l2 = s2 && s2[t5];
              return l2 ? l2.metrics.advance * e4.scale + i2 : 0;
            }
            function iu(t5, e4, r4, n4) {
              var i2 = Math.pow(t5 - e4, 2);
              return n4 ? t5 < e4 ? i2 / 2 : 2 * i2 : i2 + Math.abs(r4) * r4;
            }
            function au(t5, e4, r4) {
              var n4 = 0;
              return 10 === t5 && (n4 -= 1e4), r4 && (n4 += 150), 40 !== t5 && 65288 !== t5 || (n4 += 50), 41 !== e4 && 65289 !== e4 || (n4 += 50), n4;
            }
            function ou(t5, e4, r4, n4, i2, a2) {
              for (var o2 = null, s2 = iu(e4, r4, i2, a2), l2 = 0, u2 = n4; l2 < u2.length; l2 += 1) {
                var c2 = u2[l2], f3 = iu(e4 - c2.x, r4, i2, a2) + c2.badness;
                f3 <= s2 && (o2 = c2, s2 = f3);
              }
              return { index: t5, x: e4, priorBreak: o2, badness: s2 };
            }
            function su(t5) {
              return t5 ? su(t5.priorBreak).concat(t5.index) : [];
            }
            function lu(t5, e4, r4, n4, i2, a2, o2) {
              if ("point" !== a2)
                return [];
              if (!t5)
                return [];
              for (var s2 = [], l2 = function(t6, e5, r5, n5, i3, a3) {
                for (var o3 = 0, s3 = 0; s3 < t6.length(); s3++) {
                  var l3 = t6.getSection(s3);
                  o3 += nu(t6.getCharCode(s3), l3, n5, i3, e5, a3);
                }
                return o3 / Math.max(1, Math.ceil(o3 / r5));
              }(t5, e4, r4, n4, i2, o2), u2 = t5.text.indexOf("​") >= 0, c2 = 0, f3 = 0; f3 < t5.length(); f3++) {
                var h2 = t5.getSection(f3), p3 = t5.getCharCode(f3);
                if (eu[p3] || (c2 += nu(p3, h2, n4, i2, e4, o2)), f3 < t5.length() - 1) {
                  var d3 = !((v2 = p3) < 11904 || !(oi["Bopomofo Extended"](v2) || oi.Bopomofo(v2) || oi["CJK Compatibility Forms"](v2) || oi["CJK Compatibility Ideographs"](v2) || oi["CJK Compatibility"](v2) || oi["CJK Radicals Supplement"](v2) || oi["CJK Strokes"](v2) || oi["CJK Symbols and Punctuation"](v2) || oi["CJK Unified Ideographs Extension A"](v2) || oi["CJK Unified Ideographs"](v2) || oi["Enclosed CJK Letters and Months"](v2) || oi["Halfwidth and Fullwidth Forms"](v2) || oi.Hiragana(v2) || oi["Ideographic Description Characters"](v2) || oi["Kangxi Radicals"](v2) || oi["Katakana Phonetic Extensions"](v2) || oi.Katakana(v2) || oi["Vertical Forms"](v2) || oi["Yi Radicals"](v2) || oi["Yi Syllables"](v2)));
                  (ru[p3] || d3 || h2.imageName) && s2.push(ou(f3 + 1, c2, l2, s2, au(p3, t5.getCharCode(f3 + 1), d3 && u2), false));
                }
              }
              var v2;
              return su(ou(t5.length(), c2, l2, s2, 0, true));
            }
            function uu(t5) {
              var e4 = 0.5, r4 = 0.5;
              switch (t5) {
                case "right":
                case "top-right":
                case "bottom-right":
                  e4 = 1;
                  break;
                case "left":
                case "top-left":
                case "bottom-left":
                  e4 = 0;
              }
              switch (t5) {
                case "bottom":
                case "bottom-right":
                case "bottom-left":
                  r4 = 1;
                  break;
                case "top":
                case "top-right":
                case "top-left":
                  r4 = 0;
              }
              return { horizontalAlign: e4, verticalAlign: r4 };
            }
            function cu(t5, e4, r4, n4, i2) {
              if (n4 || i2)
                for (var a2 = t5[r4], o2 = a2.metrics.advance * a2.scale, s2 = (t5[r4].x + o2) * n4, l2 = e4; l2 <= r4; l2++)
                  t5[l2].x -= s2, t5[l2].y += i2;
            }
            function fu(t5, e4, r4, n4, i2, a2) {
              var o2, s2 = t5.image;
              if (s2.content) {
                var l2 = s2.content, u2 = s2.pixelRatio || 1;
                o2 = [l2[0] / u2, l2[1] / u2, s2.displaySize[0] - l2[2] / u2, s2.displaySize[1] - l2[3] / u2];
              }
              var c2, f3, h2, p3, d3 = e4.left * a2, v2 = e4.right * a2;
              "width" === r4 || "both" === r4 ? (p3 = i2[0] + d3 - n4[3], f3 = i2[0] + v2 + n4[1]) : f3 = (p3 = i2[0] + (d3 + v2 - s2.displaySize[0]) / 2) + s2.displaySize[0];
              var g3 = e4.top * a2, y2 = e4.bottom * a2;
              return "height" === r4 || "both" === r4 ? (c2 = i2[1] + g3 - n4[0], h2 = i2[1] + y2 + n4[2]) : h2 = (c2 = i2[1] + (g3 + y2 - s2.displaySize[1]) / 2) + s2.displaySize[1], { image: s2, top: c2, right: f3, bottom: h2, left: p3, collisionPadding: o2 };
            }
            ru[10] = true, ru[32] = true, ru[38] = true, ru[40] = true, ru[41] = true, ru[43] = true, ru[45] = true, ru[47] = true, ru[173] = true, ru[183] = true, ru[8203] = true, ru[8208] = true, ru[8211] = true, ru[8231] = true;
            var hu = function(t5) {
              function e4(e5, r4, n4, i2) {
                t5.call(this, e5, r4), this.angle = n4, void 0 !== i2 && (this.segment = i2);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.clone = function() {
                return new e4(this.x, this.y, this.angle, this.segment);
              }, e4;
            }(a);
            Qn("Anchor", hu);
            var pu = 128;
            function du(t5, e4) {
              var r4 = e4.expression;
              if ("constant" === r4.kind)
                return { kind: "constant", layoutSize: r4.evaluate(new Si(t5 + 1)) };
              if ("source" === r4.kind)
                return { kind: "source" };
              for (var n4 = r4.zoomStops, i2 = r4.interpolationType, a2 = 0; a2 < n4.length && n4[a2] <= t5; )
                a2++;
              for (var o2 = a2 = Math.max(0, a2 - 1); o2 < n4.length && n4[o2] < t5 + 1; )
                o2++;
              o2 = Math.min(n4.length - 1, o2);
              var s2 = n4[a2], l2 = n4[o2];
              return "composite" === r4.kind ? { kind: "composite", minZoom: s2, maxZoom: l2, interpolationType: i2 } : { kind: "camera", minZoom: s2, maxZoom: l2, minSize: r4.evaluate(new Si(s2)), maxSize: r4.evaluate(new Si(l2)), interpolationType: i2 };
            }
            function vu(t5, e4, r4) {
              var n4 = e4.uSize, i2 = e4.uSizeT, a2 = r4.lowerSize, o2 = r4.upperSize;
              return "source" === t5.kind ? a2 / pu : "composite" === t5.kind ? Ke(a2 / pu, o2 / pu, i2) : n4;
            }
            function gu(t5, e4) {
              var r4 = 0, n4 = 0;
              if ("constant" === t5.kind)
                n4 = t5.layoutSize;
              else if ("source" !== t5.kind) {
                var i2 = t5.interpolationType, a2 = t5.minZoom, o2 = t5.maxZoom, s2 = i2 ? u(gr.interpolationFactor(i2, e4, a2, o2), 0, 1) : 0;
                "camera" === t5.kind ? n4 = Ke(t5.minSize, t5.maxSize, s2) : r4 = s2;
              }
              return { uSizeT: r4, uSize: n4 };
            }
            var yu = Object.freeze({ __proto__: null, getSizeData: du, evaluateSizeForFeature: vu, evaluateSizeForZoom: gu, SIZE_PACK_FACTOR: pu });
            function mu(t5, e4, r4, n4, i2) {
              if (void 0 === e4.segment)
                return true;
              for (var a2 = e4, o2 = e4.segment + 1, s2 = 0; s2 > -r4 / 2; ) {
                if (--o2 < 0)
                  return false;
                s2 -= t5[o2].dist(a2), a2 = t5[o2];
              }
              s2 += t5[o2].dist(t5[o2 + 1]), o2++;
              for (var l2 = [], u2 = 0; s2 < r4 / 2; ) {
                var c2 = t5[o2 - 1], f3 = t5[o2], h2 = t5[o2 + 1];
                if (!h2)
                  return false;
                var p3 = c2.angleTo(f3) - f3.angleTo(h2);
                for (p3 = Math.abs((p3 + 3 * Math.PI) % (2 * Math.PI) - Math.PI), l2.push({ distance: s2, angleDelta: p3 }), u2 += p3; s2 - l2[0].distance > n4; )
                  u2 -= l2.shift().angleDelta;
                if (u2 > i2)
                  return false;
                o2++, s2 += f3.dist(h2);
              }
              return true;
            }
            function xu(t5) {
              for (var e4 = 0, r4 = 0; r4 < t5.length - 1; r4++)
                e4 += t5[r4].dist(t5[r4 + 1]);
              return e4;
            }
            function bu(t5, e4, r4) {
              return t5 ? 0.6 * e4 * r4 : 0;
            }
            function _u(t5, e4) {
              return Math.max(t5 ? t5.right - t5.left : 0, e4 ? e4.right - e4.left : 0);
            }
            function wu(t5, e4, r4, n4, i2, a2) {
              for (var o2 = bu(r4, i2, a2), s2 = _u(r4, n4) * a2, l2 = 0, u2 = xu(t5) / 2, c2 = 0; c2 < t5.length - 1; c2++) {
                var f3 = t5[c2], h2 = t5[c2 + 1], p3 = f3.dist(h2);
                if (l2 + p3 > u2) {
                  var d3 = (u2 - l2) / p3, v2 = Ke(f3.x, h2.x, d3), g3 = Ke(f3.y, h2.y, d3), y2 = new hu(v2, g3, h2.angleTo(f3), c2);
                  return y2._round(), !o2 || mu(t5, y2, s2, o2, e4) ? y2 : void 0;
                }
                l2 += p3;
              }
            }
            function Tu(t5, e4, r4, n4, i2, a2, o2, s2, l2) {
              var u2 = bu(n4, a2, o2), c2 = _u(n4, i2), f3 = c2 * o2, h2 = 0 === t5[0].x || t5[0].x === l2 || 0 === t5[0].y || t5[0].y === l2;
              return e4 - f3 < e4 / 4 && (e4 = f3 + e4 / 4), ku(t5, h2 ? e4 / 2 * s2 % e4 : (c2 / 2 + 2 * a2) * o2 * s2 % e4, e4, u2, r4, f3, h2, false, l2);
            }
            function ku(t5, e4, r4, n4, i2, a2, o2, s2, l2) {
              for (var u2 = a2 / 2, c2 = xu(t5), f3 = 0, h2 = e4 - r4, p3 = [], d3 = 0; d3 < t5.length - 1; d3++) {
                for (var v2 = t5[d3], g3 = t5[d3 + 1], y2 = v2.dist(g3), m3 = g3.angleTo(v2); h2 + r4 < f3 + y2; ) {
                  var x2 = ((h2 += r4) - f3) / y2, b2 = Ke(v2.x, g3.x, x2), _2 = Ke(v2.y, g3.y, x2);
                  if (b2 >= 0 && b2 < l2 && _2 >= 0 && _2 < l2 && h2 - u2 >= 0 && h2 + u2 <= c2) {
                    var w3 = new hu(b2, _2, m3, d3);
                    w3._round(), n4 && !mu(t5, w3, a2, n4, i2) || p3.push(w3);
                  }
                }
                f3 += y2;
              }
              return s2 || p3.length || o2 || (p3 = ku(t5, f3 / 2, r4, n4, i2, a2, o2, true, l2)), p3;
            }
            function Au(t5, e4, r4, n4, i2) {
              for (var o2 = [], s2 = 0; s2 < t5.length; s2++)
                for (var l2 = t5[s2], u2 = void 0, c2 = 0; c2 < l2.length - 1; c2++) {
                  var f3 = l2[c2], h2 = l2[c2 + 1];
                  f3.x < e4 && h2.x < e4 || (f3.x < e4 ? f3 = new a(e4, f3.y + (h2.y - f3.y) * ((e4 - f3.x) / (h2.x - f3.x)))._round() : h2.x < e4 && (h2 = new a(e4, f3.y + (h2.y - f3.y) * ((e4 - f3.x) / (h2.x - f3.x)))._round()), f3.y < r4 && h2.y < r4 || (f3.y < r4 ? f3 = new a(f3.x + (h2.x - f3.x) * ((r4 - f3.y) / (h2.y - f3.y)), r4)._round() : h2.y < r4 && (h2 = new a(f3.x + (h2.x - f3.x) * ((r4 - f3.y) / (h2.y - f3.y)), r4)._round()), f3.x >= n4 && h2.x >= n4 || (f3.x >= n4 ? f3 = new a(n4, f3.y + (h2.y - f3.y) * ((n4 - f3.x) / (h2.x - f3.x)))._round() : h2.x >= n4 && (h2 = new a(n4, f3.y + (h2.y - f3.y) * ((n4 - f3.x) / (h2.x - f3.x)))._round()), f3.y >= i2 && h2.y >= i2 || (f3.y >= i2 ? f3 = new a(f3.x + (h2.x - f3.x) * ((i2 - f3.y) / (h2.y - f3.y)), i2)._round() : h2.y >= i2 && (h2 = new a(f3.x + (h2.x - f3.x) * ((i2 - f3.y) / (h2.y - f3.y)), i2)._round()), u2 && f3.equals(u2[u2.length - 1]) || (u2 = [f3], o2.push(u2)), u2.push(h2)))));
                }
              return o2;
            }
            function Mu(t5, e4, r4, n4) {
              var i2 = [], o2 = t5.image, s2 = o2.pixelRatio, l2 = o2.paddedRect.w - 2, u2 = o2.paddedRect.h - 2, c2 = t5.right - t5.left, f3 = t5.bottom - t5.top, h2 = o2.stretchX || [[0, l2]], p3 = o2.stretchY || [[0, u2]], d3 = function(t6, e5) {
                return t6 + e5[1] - e5[0];
              }, v2 = h2.reduce(d3, 0), g3 = p3.reduce(d3, 0), y2 = l2 - v2, m3 = u2 - g3, x2 = 0, b2 = v2, _2 = 0, w3 = g3, T2 = 0, k2 = y2, A2 = 0, M2 = m3;
              if (o2.content && n4) {
                var S2 = o2.content;
                x2 = Su(h2, 0, S2[0]), _2 = Su(p3, 0, S2[1]), b2 = Su(h2, S2[0], S2[2]), w3 = Su(p3, S2[1], S2[3]), T2 = S2[0] - x2, A2 = S2[1] - _2, k2 = S2[2] - S2[0] - b2, M2 = S2[3] - S2[1] - w3;
              }
              var E2 = function(n5, i3, l3, u3) {
                var h3 = Lu(n5.stretch - x2, b2, c2, t5.left), p4 = Cu(n5.fixed - T2, k2, n5.stretch, v2), d4 = Lu(i3.stretch - _2, w3, f3, t5.top), y3 = Cu(i3.fixed - A2, M2, i3.stretch, g3), m4 = Lu(l3.stretch - x2, b2, c2, t5.left), S3 = Cu(l3.fixed - T2, k2, l3.stretch, v2), E3 = Lu(u3.stretch - _2, w3, f3, t5.top), L3 = Cu(u3.fixed - A2, M2, u3.stretch, g3), C3 = new a(h3, d4), P3 = new a(m4, d4), O3 = new a(m4, E3), I3 = new a(h3, E3), D3 = new a(p4 / s2, y3 / s2), z3 = new a(S3 / s2, L3 / s2), R3 = e4 * Math.PI / 180;
                if (R3) {
                  var F2 = Math.sin(R3), B2 = Math.cos(R3), N2 = [B2, -F2, F2, B2];
                  C3._matMult(N2), P3._matMult(N2), I3._matMult(N2), O3._matMult(N2);
                }
                var j2 = n5.stretch + n5.fixed, U2 = l3.stretch + l3.fixed, V2 = i3.stretch + i3.fixed, H2 = u3.stretch + u3.fixed;
                return { tl: C3, tr: P3, bl: I3, br: O3, tex: { x: o2.paddedRect.x + 1 + j2, y: o2.paddedRect.y + 1 + V2, w: U2 - j2, h: H2 - V2 }, writingMode: void 0, glyphOffset: [0, 0], sectionIndex: 0, pixelOffsetTL: D3, pixelOffsetBR: z3, minFontScaleX: k2 / s2 / c2, minFontScaleY: M2 / s2 / f3, isSDF: r4 };
              };
              if (n4 && (o2.stretchX || o2.stretchY))
                for (var L2 = Eu(h2, y2, v2), C2 = Eu(p3, m3, g3), P2 = 0; P2 < L2.length - 1; P2++)
                  for (var O2 = L2[P2], I2 = L2[P2 + 1], D2 = 0; D2 < C2.length - 1; D2++) {
                    var z2 = C2[D2], R2 = C2[D2 + 1];
                    i2.push(E2(O2, z2, I2, R2));
                  }
              else
                i2.push(E2({ fixed: 0, stretch: -1 }, { fixed: 0, stretch: -1 }, { fixed: 0, stretch: l2 + 1 }, { fixed: 0, stretch: u2 + 1 }));
              return i2;
            }
            function Su(t5, e4, r4) {
              for (var n4 = 0, i2 = 0, a2 = t5; i2 < a2.length; i2 += 1) {
                var o2 = a2[i2];
                n4 += Math.max(e4, Math.min(r4, o2[1])) - Math.max(e4, Math.min(r4, o2[0]));
              }
              return n4;
            }
            function Eu(t5, e4, r4) {
              for (var n4 = [{ fixed: -1, stretch: 0 }], i2 = 0, a2 = t5; i2 < a2.length; i2 += 1) {
                var o2 = a2[i2], s2 = o2[0], l2 = o2[1], u2 = n4[n4.length - 1];
                n4.push({ fixed: s2 - u2.stretch, stretch: u2.stretch }), n4.push({ fixed: s2 - u2.stretch, stretch: u2.stretch + (l2 - s2) });
              }
              return n4.push({ fixed: e4 + 1, stretch: r4 }), n4;
            }
            function Lu(t5, e4, r4, n4) {
              return t5 / e4 * r4 + n4;
            }
            function Cu(t5, e4, r4, n4) {
              return t5 - e4 * r4 / n4;
            }
            var Pu = function(t5, e4, r4, n4, i2, o2, s2, l2, u2, c2) {
              if (this.boxStartIndex = t5.length, u2) {
                var f3 = o2.top, h2 = o2.bottom, p3 = o2.collisionPadding;
                p3 && (f3 -= p3[1], h2 += p3[3]);
                var d3 = h2 - f3;
                d3 > 0 && (d3 = Math.max(10, d3), this.circleDiameter = d3);
              } else {
                var v2 = o2.top * s2 - l2, g3 = o2.bottom * s2 + l2, y2 = o2.left * s2 - l2, m3 = o2.right * s2 + l2, x2 = o2.collisionPadding;
                if (x2 && (y2 -= x2[0] * s2, v2 -= x2[1] * s2, m3 += x2[2] * s2, g3 += x2[3] * s2), c2) {
                  var b2 = new a(y2, v2), _2 = new a(m3, v2), w3 = new a(y2, g3), T2 = new a(m3, g3), k2 = c2 * Math.PI / 180;
                  b2._rotate(k2), _2._rotate(k2), w3._rotate(k2), T2._rotate(k2), y2 = Math.min(b2.x, _2.x, w3.x, T2.x), m3 = Math.max(b2.x, _2.x, w3.x, T2.x), v2 = Math.min(b2.y, _2.y, w3.y, T2.y), g3 = Math.max(b2.y, _2.y, w3.y, T2.y);
                }
                t5.emplaceBack(e4.x, e4.y, y2, v2, m3, g3, r4, n4, i2);
              }
              this.boxEndIndex = t5.length;
            }, Ou = function(t5, e4) {
              if (void 0 === t5 && (t5 = []), void 0 === e4 && (e4 = Iu), this.data = t5, this.length = this.data.length, this.compare = e4, this.length > 0)
                for (var r4 = (this.length >> 1) - 1; r4 >= 0; r4--)
                  this._down(r4);
            };
            function Iu(t5, e4) {
              return t5 < e4 ? -1 : t5 > e4 ? 1 : 0;
            }
            function Du(t5, e4, r4) {
              void 0 === e4 && (e4 = 1), void 0 === r4 && (r4 = false);
              for (var n4 = 1 / 0, i2 = 1 / 0, o2 = -1 / 0, s2 = -1 / 0, l2 = t5[0], u2 = 0; u2 < l2.length; u2++) {
                var c2 = l2[u2];
                (!u2 || c2.x < n4) && (n4 = c2.x), (!u2 || c2.y < i2) && (i2 = c2.y), (!u2 || c2.x > o2) && (o2 = c2.x), (!u2 || c2.y > s2) && (s2 = c2.y);
              }
              var f3 = o2 - n4, h2 = s2 - i2, p3 = Math.min(f3, h2), d3 = p3 / 2, v2 = new Ou([], zu);
              if (0 === p3)
                return new a(n4, i2);
              for (var g3 = n4; g3 < o2; g3 += p3)
                for (var y2 = i2; y2 < s2; y2 += p3)
                  v2.push(new Ru(g3 + d3, y2 + d3, d3, t5));
              for (var m3 = function(t6) {
                for (var e5 = 0, r5 = 0, n5 = 0, i3 = t6[0], a2 = 0, o3 = i3.length, s3 = o3 - 1; a2 < o3; s3 = a2++) {
                  var l3 = i3[a2], u3 = i3[s3], c3 = l3.x * u3.y - u3.x * l3.y;
                  r5 += (l3.x + u3.x) * c3, n5 += (l3.y + u3.y) * c3, e5 += 3 * c3;
                }
                return new Ru(r5 / e5, n5 / e5, 0, t6);
              }(t5), x2 = v2.length; v2.length; ) {
                var b2 = v2.pop();
                (b2.d > m3.d || !m3.d) && (m3 = b2, r4 && console.log("found best %d after %d probes", Math.round(1e4 * b2.d) / 1e4, x2)), b2.max - m3.d <= e4 || (d3 = b2.h / 2, v2.push(new Ru(b2.p.x - d3, b2.p.y - d3, d3, t5)), v2.push(new Ru(b2.p.x + d3, b2.p.y - d3, d3, t5)), v2.push(new Ru(b2.p.x - d3, b2.p.y + d3, d3, t5)), v2.push(new Ru(b2.p.x + d3, b2.p.y + d3, d3, t5)), x2 += 4);
              }
              return r4 && (console.log("num probes: " + x2), console.log("best distance: " + m3.d)), m3.p;
            }
            function zu(t5, e4) {
              return e4.max - t5.max;
            }
            function Ru(t5, e4, r4, n4) {
              this.p = new a(t5, e4), this.h = r4, this.d = function(t6, e5) {
                for (var r5 = false, n5 = 1 / 0, i2 = 0; i2 < e5.length; i2++)
                  for (var a2 = e5[i2], o2 = 0, s2 = a2.length, l2 = s2 - 1; o2 < s2; l2 = o2++) {
                    var u2 = a2[o2], c2 = a2[l2];
                    u2.y > t6.y != c2.y > t6.y && t6.x < (c2.x - u2.x) * (t6.y - u2.y) / (c2.y - u2.y) + u2.x && (r5 = !r5), n5 = Math.min(n5, bo(t6, u2, c2));
                  }
                return (r5 ? 1 : -1) * Math.sqrt(n5);
              }(this.p, n4), this.max = this.d + this.h * Math.SQRT2;
            }
            Ou.prototype.push = function(t5) {
              this.data.push(t5), this.length++, this._up(this.length - 1);
            }, Ou.prototype.pop = function() {
              if (0 !== this.length) {
                var t5 = this.data[0], e4 = this.data.pop();
                return this.length--, this.length > 0 && (this.data[0] = e4, this._down(0)), t5;
              }
            }, Ou.prototype.peek = function() {
              return this.data[0];
            }, Ou.prototype._up = function(t5) {
              for (var e4 = this.data, r4 = this.compare, n4 = e4[t5]; t5 > 0; ) {
                var i2 = t5 - 1 >> 1, a2 = e4[i2];
                if (r4(n4, a2) >= 0)
                  break;
                e4[t5] = a2, t5 = i2;
              }
              e4[t5] = n4;
            }, Ou.prototype._down = function(t5) {
              for (var e4 = this.data, r4 = this.compare, n4 = this.length >> 1, i2 = e4[t5]; t5 < n4; ) {
                var a2 = 1 + (t5 << 1), o2 = e4[a2], s2 = a2 + 1;
                if (s2 < this.length && r4(e4[s2], o2) < 0 && (a2 = s2, o2 = e4[s2]), r4(o2, i2) >= 0)
                  break;
                e4[t5] = o2, t5 = a2;
              }
              e4[t5] = i2;
            };
            var Fu = Number.POSITIVE_INFINITY;
            function Bu(t5, e4) {
              return e4[1] !== Fu ? function(t6, e5, r4) {
                var n4 = 0, i2 = 0;
                switch (e5 = Math.abs(e5), r4 = Math.abs(r4), t6) {
                  case "top-right":
                  case "top-left":
                  case "top":
                    i2 = r4 - 7;
                    break;
                  case "bottom-right":
                  case "bottom-left":
                  case "bottom":
                    i2 = 7 - r4;
                }
                switch (t6) {
                  case "top-right":
                  case "bottom-right":
                  case "right":
                    n4 = -e5;
                    break;
                  case "top-left":
                  case "bottom-left":
                  case "left":
                    n4 = e5;
                }
                return [n4, i2];
              }(t5, e4[0], e4[1]) : function(t6, e5) {
                var r4 = 0, n4 = 0;
                e5 < 0 && (e5 = 0);
                var i2 = e5 / Math.sqrt(2);
                switch (t6) {
                  case "top-right":
                  case "top-left":
                    n4 = i2 - 7;
                    break;
                  case "bottom-right":
                  case "bottom-left":
                    n4 = 7 - i2;
                    break;
                  case "bottom":
                    n4 = 7 - e5;
                    break;
                  case "top":
                    n4 = e5 - 7;
                }
                switch (t6) {
                  case "top-right":
                  case "bottom-right":
                    r4 = -i2;
                    break;
                  case "top-left":
                  case "bottom-left":
                    r4 = i2;
                    break;
                  case "left":
                    r4 = e5;
                    break;
                  case "right":
                    r4 = -e5;
                }
                return [r4, n4];
              }(t5, e4[0]);
            }
            function Nu(t5) {
              switch (t5) {
                case "right":
                case "top-right":
                case "bottom-right":
                  return "right";
                case "left":
                case "top-left":
                case "bottom-left":
                  return "left";
              }
              return "center";
            }
            var ju = 32640;
            function Uu(t5, e4, r4, n4, i2, o2, s2, l2, u2, c2, f3, h2, p3, d3, v2) {
              var g3 = function(t6, e5, r5, n5, i3, o3, s3, l3) {
                for (var u3 = n5.layout.get("text-rotate").evaluate(o3, {}) * Math.PI / 180, c3 = [], f4 = 0, h3 = e5.positionedLines; f4 < h3.length; f4 += 1)
                  for (var p4 = h3[f4], d4 = 0, v3 = p4.positionedGlyphs; d4 < v3.length; d4 += 1) {
                    var g4 = v3[d4];
                    if (g4.rect) {
                      var y3 = g4.rect || {}, m4 = 4, x3 = true, b3 = 1, _2 = 0, w3 = (i3 || l3) && g4.vertical, T2 = g4.metrics.advance * g4.scale / 2;
                      if (l3 && e5.verticalizable) {
                        var k2 = (g4.scale - 1) * bl, A2 = (bl - g4.metrics.width * g4.scale) / 2;
                        _2 = p4.lineOffset / 2 - (g4.imageName ? -A2 : k2);
                      }
                      if (g4.imageName) {
                        var M2 = s3[g4.imageName];
                        x3 = M2.sdf, m4 = 1 / (b3 = M2.pixelRatio);
                      }
                      var S2 = i3 ? [g4.x + T2, g4.y] : [0, 0], E2 = i3 ? [0, 0] : [g4.x + T2 + r5[0], g4.y + r5[1] - _2], L2 = [0, 0];
                      w3 && (L2 = E2, E2 = [0, 0]);
                      var C2 = (g4.metrics.left - m4) * g4.scale - T2 + E2[0], P2 = (-g4.metrics.top - m4) * g4.scale + E2[1], O2 = C2 + y3.w * g4.scale / b3, I2 = P2 + y3.h * g4.scale / b3, D2 = new a(C2, P2), z2 = new a(O2, P2), R2 = new a(C2, I2), F2 = new a(O2, I2);
                      if (w3) {
                        var B2 = new a(-T2, T2 - Kl), N2 = -Math.PI / 2, j2 = 12 - T2, U2 = g4.imageName ? j2 : 0, V2 = new a(22 - j2, -U2), H2 = new (Function.prototype.bind.apply(a, [null].concat(L2)))();
                        D2._rotateAround(N2, B2)._add(V2)._add(H2), z2._rotateAround(N2, B2)._add(V2)._add(H2), R2._rotateAround(N2, B2)._add(V2)._add(H2), F2._rotateAround(N2, B2)._add(V2)._add(H2);
                      }
                      if (u3) {
                        var q3 = Math.sin(u3), G2 = Math.cos(u3), Z2 = [G2, -q3, q3, G2];
                        D2._matMult(Z2), z2._matMult(Z2), R2._matMult(Z2), F2._matMult(Z2);
                      }
                      var Y2 = new a(0, 0), W2 = new a(0, 0);
                      c3.push({ tl: D2, tr: z2, bl: R2, br: F2, tex: y3, writingMode: e5.writingMode, glyphOffset: S2, sectionIndex: g4.sectionIndex, isSDF: x3, pixelOffsetTL: Y2, pixelOffsetBR: W2, minFontScaleX: 0, minFontScaleY: 0 });
                    }
                  }
                return c3;
              }(0, r4, l2, i2, o2, s2, n4, t5.allowVerticalPlacement), y2 = t5.textSizeData, m3 = null;
              "source" === y2.kind ? (m3 = [pu * i2.layout.get("text-size").evaluate(s2, {})])[0] > ju && w2(t5.layerIds[0] + ': Value for "text-size" is >= 255. Reduce your "text-size".') : "composite" === y2.kind && ((m3 = [pu * d3.compositeTextSizes[0].evaluate(s2, {}, v2), pu * d3.compositeTextSizes[1].evaluate(s2, {}, v2)])[0] > ju || m3[1] > ju) && w2(t5.layerIds[0] + ': Value for "text-size" is >= 255. Reduce your "text-size".'), t5.addSymbols(t5.text, g3, m3, l2, o2, s2, c2, e4, u2.lineStartIndex, u2.lineLength, p3, v2);
              for (var x2 = 0, b2 = f3; x2 < b2.length; x2 += 1)
                h2[b2[x2]] = t5.text.placedSymbolArray.length - 1;
              return 4 * g3.length;
            }
            function Vu(t5) {
              for (var e4 in t5)
                return t5[e4];
              return null;
            }
            function Hu(t5, e4, r4, n4) {
              var i2 = t5.compareText;
              if (e4 in i2) {
                for (var a2 = i2[e4], o2 = a2.length - 1; o2 >= 0; o2--)
                  if (n4.dist(a2[o2]) < r4)
                    return true;
              } else
                i2[e4] = [];
              return i2[e4].push(n4), false;
            }
            var qu = Zs.VectorTileFeature.types, Gu = [{ name: "a_fade_opacity", components: 1, type: "Uint8", offset: 0 }];
            function Zu(t5, e4, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2) {
              var p3 = s2 ? Math.min(ju, Math.round(s2[0])) : 0, d3 = s2 ? Math.min(ju, Math.round(s2[1])) : 0;
              t5.emplaceBack(e4, r4, Math.round(32 * n4), Math.round(32 * i2), a2, o2, (p3 << 1) + (l2 ? 1 : 0), d3, 16 * u2, 16 * c2, 256 * f3, 256 * h2);
            }
            function Yu(t5, e4, r4) {
              t5.emplaceBack(e4.x, e4.y, r4), t5.emplaceBack(e4.x, e4.y, r4), t5.emplaceBack(e4.x, e4.y, r4), t5.emplaceBack(e4.x, e4.y, r4);
            }
            function Wu(t5) {
              for (var e4 = 0, r4 = t5.sections; e4 < r4.length; e4 += 1)
                if (pi(r4[e4].text))
                  return true;
              return false;
            }
            var Xu = function(t5) {
              this.layoutVertexArray = new ta(), this.indexArray = new sa(), this.programConfigurations = t5, this.segments = new Ea(), this.dynamicLayoutVertexArray = new ea(), this.opacityVertexArray = new ra(), this.placedSymbolArray = new ba();
            };
            Xu.prototype.isEmpty = function() {
              return 0 === this.layoutVertexArray.length && 0 === this.indexArray.length && 0 === this.dynamicLayoutVertexArray.length && 0 === this.opacityVertexArray.length;
            }, Xu.prototype.upload = function(t5, e4, r4, n4) {
              this.isEmpty() || (r4 && (this.layoutVertexBuffer = t5.createVertexBuffer(this.layoutVertexArray, pl.members), this.indexBuffer = t5.createIndexBuffer(this.indexArray, e4), this.dynamicLayoutVertexBuffer = t5.createVertexBuffer(this.dynamicLayoutVertexArray, dl.members, true), this.opacityVertexBuffer = t5.createVertexBuffer(this.opacityVertexArray, Gu, true), this.opacityVertexBuffer.itemSize = 1), (r4 || n4) && this.programConfigurations.upload(t5));
            }, Xu.prototype.destroy = function() {
              this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.programConfigurations.destroy(), this.segments.destroy(), this.dynamicLayoutVertexBuffer.destroy(), this.opacityVertexBuffer.destroy());
            }, Qn("SymbolBuffers", Xu);
            var Ju = function(t5, e4, r4) {
              this.layoutVertexArray = new t5(), this.layoutAttributes = e4, this.indexArray = new r4(), this.segments = new Ea(), this.collisionVertexArray = new oa();
            };
            Ju.prototype.upload = function(t5) {
              this.layoutVertexBuffer = t5.createVertexBuffer(this.layoutVertexArray, this.layoutAttributes), this.indexBuffer = t5.createIndexBuffer(this.indexArray), this.collisionVertexBuffer = t5.createVertexBuffer(this.collisionVertexArray, vl.members, true);
            }, Ju.prototype.destroy = function() {
              this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.segments.destroy(), this.collisionVertexBuffer.destroy());
            }, Qn("CollisionBuffers", Ju);
            var Ku = function(t5) {
              this.collisionBoxArray = t5.collisionBoxArray, this.zoom = t5.zoom, this.overscaling = t5.overscaling, this.layers = t5.layers, this.layerIds = this.layers.map(function(t6) {
                return t6.id;
              }), this.index = t5.index, this.pixelRatio = t5.pixelRatio, this.sourceLayerIndex = t5.sourceLayerIndex, this.hasPattern = false, this.hasRTLText = false, this.sortKeyRanges = [], this.collisionCircleArray = [], this.placementInvProjMatrix = Co([]), this.placementViewportMatrix = Co([]);
              var e4 = this.layers[0]._unevaluatedLayout._values;
              this.textSizeData = du(this.zoom, e4["text-size"]), this.iconSizeData = du(this.zoom, e4["icon-size"]);
              var r4 = this.layers[0].layout, n4 = r4.get("symbol-sort-key"), i2 = r4.get("symbol-z-order");
              this.sortFeaturesByKey = "viewport-y" !== i2 && void 0 !== n4.constantOr(1);
              var a2 = "viewport-y" === i2 || "auto" === i2 && !this.sortFeaturesByKey;
              this.sortFeaturesByY = a2 && (r4.get("text-allow-overlap") || r4.get("icon-allow-overlap") || r4.get("text-ignore-placement") || r4.get("icon-ignore-placement")), "point" === r4.get("symbol-placement") && (this.writingModes = r4.get("text-writing-mode").map(function(t6) {
                return Jl[t6];
              })), this.stateDependentLayerIds = this.layers.filter(function(t6) {
                return t6.isStateDependent();
              }).map(function(t6) {
                return t6.id;
              }), this.sourceID = t5.sourceID;
            };
            Ku.prototype.createArrays = function() {
              this.text = new Xu(new no(pl.members, this.layers, this.zoom, function(t5) {
                return /^text/.test(t5);
              })), this.icon = new Xu(new no(pl.members, this.layers, this.zoom, function(t5) {
                return /^icon/.test(t5);
              })), this.glyphOffsetArray = new Ta(), this.lineVertexArray = new ka(), this.symbolInstances = new wa();
            }, Ku.prototype.calculateGlyphDependencies = function(t5, e4, r4, n4, i2) {
              for (var a2 = 0; a2 < t5.length; a2++)
                if (e4[t5.charCodeAt(a2)] = true, (r4 || n4) && i2) {
                  var o2 = xl[t5.charAt(a2)];
                  o2 && (e4[o2.charCodeAt(0)] = true);
                }
            }, Ku.prototype.populate = function(t5, e4, r4) {
              var n4 = this.layers[0], i2 = n4.layout, a2 = i2.get("text-font"), o2 = i2.get("text-field"), s2 = i2.get("icon-image"), l2 = ("constant" !== o2.value.kind || o2.value.value instanceof le && !o2.value.value.isEmpty() || o2.value.value.toString().length > 0) && ("constant" !== a2.value.kind || a2.value.value.length > 0), u2 = "constant" !== s2.value.kind || !!s2.value.value || Object.keys(s2.parameters).length > 0, c2 = i2.get("symbol-sort-key");
              if (this.features = [], l2 || u2) {
                for (var f3 = e4.iconDependencies, h2 = e4.glyphDependencies, p3 = e4.availableImages, d3 = new Si(this.zoom), v2 = 0, g3 = t5; v2 < g3.length; v2 += 1) {
                  var y2 = g3[v2], m3 = y2.feature, x2 = y2.id, b2 = y2.index, _2 = y2.sourceLayerIndex, w3 = n4._featureFilter.needGeometry, T2 = { type: m3.type, id: x2, properties: m3.properties, geometry: w3 ? uo(m3) : [] };
                  if (n4._featureFilter.filter(d3, T2, r4)) {
                    w3 || (T2.geometry = uo(m3));
                    var k2 = void 0;
                    if (l2) {
                      var A2 = n4.getValueAndResolveTokens("text-field", T2, r4, p3), M2 = le.factory(A2);
                      Wu(M2) && (this.hasRTLText = true), (!this.hasRTLText || "unavailable" === ki() || this.hasRTLText && Mi.isParsed()) && (k2 = ml(M2, n4, T2));
                    }
                    var S2 = void 0;
                    if (u2) {
                      var E2 = n4.getValueAndResolveTokens("icon-image", T2, r4, p3);
                      S2 = E2 instanceof ue ? E2 : ue.fromString(E2);
                    }
                    if (k2 || S2) {
                      var L2 = this.sortFeaturesByKey ? c2.evaluate(T2, {}, r4) : void 0, C2 = { id: x2, text: k2, icon: S2, index: b2, sourceLayerIndex: _2, geometry: uo(m3), properties: m3.properties, type: qu[m3.type], sortKey: L2 };
                      if (this.features.push(C2), S2 && (f3[S2.name] = true), k2) {
                        var P2 = a2.evaluate(T2, {}, r4).join(","), O2 = "map" === i2.get("text-rotation-alignment") && "point" !== i2.get("symbol-placement");
                        this.allowVerticalPlacement = this.writingModes && this.writingModes.indexOf(Jl.vertical) >= 0;
                        for (var I2 = 0, D2 = k2.sections; I2 < D2.length; I2 += 1) {
                          var z2 = D2[I2];
                          if (z2.image)
                            f3[z2.image.name] = true;
                          else {
                            var R2 = si(k2.toString()), F2 = z2.fontStack || P2, B2 = h2[F2] = h2[F2] || {};
                            this.calculateGlyphDependencies(z2.text, B2, O2, this.allowVerticalPlacement, R2);
                          }
                        }
                      }
                    }
                  }
                }
                "line" === i2.get("symbol-placement") && (this.features = function(t6) {
                  var e5 = {}, r5 = {}, n5 = [], i3 = 0;
                  function a3(e6) {
                    n5.push(t6[e6]), i3++;
                  }
                  function o3(t7, e6, i4) {
                    var a4 = r5[t7];
                    return delete r5[t7], r5[e6] = a4, n5[a4].geometry[0].pop(), n5[a4].geometry[0] = n5[a4].geometry[0].concat(i4[0]), a4;
                  }
                  function s3(t7, r6, i4) {
                    var a4 = e5[r6];
                    return delete e5[r6], e5[t7] = a4, n5[a4].geometry[0].shift(), n5[a4].geometry[0] = i4[0].concat(n5[a4].geometry[0]), a4;
                  }
                  function l3(t7, e6, r6) {
                    var n6 = r6 ? e6[0][e6[0].length - 1] : e6[0][0];
                    return t7 + ":" + n6.x + ":" + n6.y;
                  }
                  for (var u3 = 0; u3 < t6.length; u3++) {
                    var c3 = t6[u3], f4 = c3.geometry, h3 = c3.text ? c3.text.toString() : null;
                    if (h3) {
                      var p4 = l3(h3, f4), d4 = l3(h3, f4, true);
                      if (p4 in r5 && d4 in e5 && r5[p4] !== e5[d4]) {
                        var v3 = s3(p4, d4, f4), g4 = o3(p4, d4, n5[v3].geometry);
                        delete e5[p4], delete r5[d4], r5[l3(h3, n5[g4].geometry, true)] = g4, n5[v3].geometry = null;
                      } else
                        p4 in r5 ? o3(p4, d4, f4) : d4 in e5 ? s3(p4, d4, f4) : (a3(u3), e5[p4] = i3 - 1, r5[d4] = i3 - 1);
                    } else
                      a3(u3);
                  }
                  return n5.filter(function(t7) {
                    return t7.geometry;
                  });
                }(this.features)), this.sortFeaturesByKey && this.features.sort(function(t6, e5) {
                  return t6.sortKey - e5.sortKey;
                });
              }
            }, Ku.prototype.update = function(t5, e4, r4) {
              this.stateDependentLayers.length && (this.text.programConfigurations.updatePaintArrays(t5, e4, this.layers, r4), this.icon.programConfigurations.updatePaintArrays(t5, e4, this.layers, r4));
            }, Ku.prototype.isEmpty = function() {
              return 0 === this.symbolInstances.length && !this.hasRTLText;
            }, Ku.prototype.uploadPending = function() {
              return !this.uploaded || this.text.programConfigurations.needsUpload || this.icon.programConfigurations.needsUpload;
            }, Ku.prototype.upload = function(t5) {
              !this.uploaded && this.hasDebugData() && (this.textCollisionBox.upload(t5), this.iconCollisionBox.upload(t5)), this.text.upload(t5, this.sortFeaturesByY, !this.uploaded, this.text.programConfigurations.needsUpload), this.icon.upload(t5, this.sortFeaturesByY, !this.uploaded, this.icon.programConfigurations.needsUpload), this.uploaded = true;
            }, Ku.prototype.destroyDebugData = function() {
              this.textCollisionBox.destroy(), this.iconCollisionBox.destroy();
            }, Ku.prototype.destroy = function() {
              this.text.destroy(), this.icon.destroy(), this.hasDebugData() && this.destroyDebugData();
            }, Ku.prototype.addToLineVertexArray = function(t5, e4) {
              var r4 = this.lineVertexArray.length;
              if (void 0 !== t5.segment) {
                for (var n4 = t5.dist(e4[t5.segment + 1]), i2 = t5.dist(e4[t5.segment]), a2 = {}, o2 = t5.segment + 1; o2 < e4.length; o2++)
                  a2[o2] = { x: e4[o2].x, y: e4[o2].y, tileUnitDistanceFromAnchor: n4 }, o2 < e4.length - 1 && (n4 += e4[o2 + 1].dist(e4[o2]));
                for (var s2 = t5.segment || 0; s2 >= 0; s2--)
                  a2[s2] = { x: e4[s2].x, y: e4[s2].y, tileUnitDistanceFromAnchor: i2 }, s2 > 0 && (i2 += e4[s2 - 1].dist(e4[s2]));
                for (var l2 = 0; l2 < e4.length; l2++) {
                  var u2 = a2[l2];
                  this.lineVertexArray.emplaceBack(u2.x, u2.y, u2.tileUnitDistanceFromAnchor);
                }
              }
              return { lineStartIndex: r4, lineLength: this.lineVertexArray.length - r4 };
            }, Ku.prototype.addSymbols = function(t5, e4, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3) {
              for (var h2 = t5.indexArray, p3 = t5.layoutVertexArray, d3 = t5.segments.prepareSegment(4 * e4.length, p3, h2, a2.sortKey), v2 = this.glyphOffsetArray.length, g3 = d3.vertexLength, y2 = this.allowVerticalPlacement && o2 === Jl.vertical ? Math.PI / 2 : 0, m3 = a2.text && a2.text.sections, x2 = 0; x2 < e4.length; x2++) {
                var b2 = e4[x2], _2 = b2.tl, w3 = b2.tr, T2 = b2.bl, k2 = b2.br, A2 = b2.tex, M2 = b2.pixelOffsetTL, S2 = b2.pixelOffsetBR, E2 = b2.minFontScaleX, L2 = b2.minFontScaleY, C2 = b2.glyphOffset, P2 = b2.isSDF, O2 = b2.sectionIndex, I2 = d3.vertexLength, D2 = C2[1];
                Zu(p3, s2.x, s2.y, _2.x, D2 + _2.y, A2.x, A2.y, r4, P2, M2.x, M2.y, E2, L2), Zu(p3, s2.x, s2.y, w3.x, D2 + w3.y, A2.x + A2.w, A2.y, r4, P2, S2.x, M2.y, E2, L2), Zu(p3, s2.x, s2.y, T2.x, D2 + T2.y, A2.x, A2.y + A2.h, r4, P2, M2.x, S2.y, E2, L2), Zu(p3, s2.x, s2.y, k2.x, D2 + k2.y, A2.x + A2.w, A2.y + A2.h, r4, P2, S2.x, S2.y, E2, L2), Yu(t5.dynamicLayoutVertexArray, s2, y2), h2.emplaceBack(I2, I2 + 1, I2 + 2), h2.emplaceBack(I2 + 1, I2 + 2, I2 + 3), d3.vertexLength += 4, d3.primitiveLength += 2, this.glyphOffsetArray.emplaceBack(C2[0]), x2 !== e4.length - 1 && O2 === e4[x2 + 1].sectionIndex || t5.programConfigurations.populatePaintArrays(p3.length, a2, a2.index, {}, f3, m3 && m3[O2]);
              }
              t5.placedSymbolArray.emplaceBack(s2.x, s2.y, v2, this.glyphOffsetArray.length - v2, g3, l2, u2, s2.segment, r4 ? r4[0] : 0, r4 ? r4[1] : 0, n4[0], n4[1], o2, 0, false, 0, c2);
            }, Ku.prototype._addCollisionDebugVertex = function(t5, e4, r4, n4, i2, a2) {
              return e4.emplaceBack(0, 0), t5.emplaceBack(r4.x, r4.y, n4, i2, Math.round(a2.x), Math.round(a2.y));
            }, Ku.prototype.addCollisionDebugVertices = function(t5, e4, r4, n4, i2, o2, s2) {
              var l2 = i2.segments.prepareSegment(4, i2.layoutVertexArray, i2.indexArray), u2 = l2.vertexLength, c2 = i2.layoutVertexArray, f3 = i2.collisionVertexArray, h2 = s2.anchorX, p3 = s2.anchorY;
              this._addCollisionDebugVertex(c2, f3, o2, h2, p3, new a(t5, e4)), this._addCollisionDebugVertex(c2, f3, o2, h2, p3, new a(r4, e4)), this._addCollisionDebugVertex(c2, f3, o2, h2, p3, new a(r4, n4)), this._addCollisionDebugVertex(c2, f3, o2, h2, p3, new a(t5, n4)), l2.vertexLength += 4;
              var d3 = i2.indexArray;
              d3.emplaceBack(u2, u2 + 1), d3.emplaceBack(u2 + 1, u2 + 2), d3.emplaceBack(u2 + 2, u2 + 3), d3.emplaceBack(u2 + 3, u2), l2.primitiveLength += 4;
            }, Ku.prototype.addDebugCollisionBoxes = function(t5, e4, r4, n4) {
              for (var i2 = t5; i2 < e4; i2++) {
                var a2 = this.collisionBoxArray.get(i2), o2 = a2.x1, s2 = a2.y1, l2 = a2.x2, u2 = a2.y2;
                this.addCollisionDebugVertices(o2, s2, l2, u2, n4 ? this.textCollisionBox : this.iconCollisionBox, a2.anchorPoint, r4);
              }
            }, Ku.prototype.generateCollisionDebugBuffers = function() {
              this.hasDebugData() && this.destroyDebugData(), this.textCollisionBox = new Ju(ia, gl2.members, pa), this.iconCollisionBox = new Ju(ia, gl2.members, pa);
              for (var t5 = 0; t5 < this.symbolInstances.length; t5++) {
                var e4 = this.symbolInstances.get(t5);
                this.addDebugCollisionBoxes(e4.textBoxStartIndex, e4.textBoxEndIndex, e4, true), this.addDebugCollisionBoxes(e4.verticalTextBoxStartIndex, e4.verticalTextBoxEndIndex, e4, true), this.addDebugCollisionBoxes(e4.iconBoxStartIndex, e4.iconBoxEndIndex, e4, false), this.addDebugCollisionBoxes(e4.verticalIconBoxStartIndex, e4.verticalIconBoxEndIndex, e4, false);
              }
            }, Ku.prototype._deserializeCollisionBoxesForSymbol = function(t5, e4, r4, n4, i2, a2, o2, s2, l2) {
              for (var u2 = {}, c2 = e4; c2 < r4; c2++) {
                var f3 = t5.get(c2);
                u2.textBox = { x1: f3.x1, y1: f3.y1, x2: f3.x2, y2: f3.y2, anchorPointX: f3.anchorPointX, anchorPointY: f3.anchorPointY }, u2.textFeatureIndex = f3.featureIndex;
                break;
              }
              for (var h2 = n4; h2 < i2; h2++) {
                var p3 = t5.get(h2);
                u2.verticalTextBox = { x1: p3.x1, y1: p3.y1, x2: p3.x2, y2: p3.y2, anchorPointX: p3.anchorPointX, anchorPointY: p3.anchorPointY }, u2.verticalTextFeatureIndex = p3.featureIndex;
                break;
              }
              for (var d3 = a2; d3 < o2; d3++) {
                var v2 = t5.get(d3);
                u2.iconBox = { x1: v2.x1, y1: v2.y1, x2: v2.x2, y2: v2.y2, anchorPointX: v2.anchorPointX, anchorPointY: v2.anchorPointY }, u2.iconFeatureIndex = v2.featureIndex;
                break;
              }
              for (var g3 = s2; g3 < l2; g3++) {
                var y2 = t5.get(g3);
                u2.verticalIconBox = { x1: y2.x1, y1: y2.y1, x2: y2.x2, y2: y2.y2, anchorPointX: y2.anchorPointX, anchorPointY: y2.anchorPointY }, u2.verticalIconFeatureIndex = y2.featureIndex;
                break;
              }
              return u2;
            }, Ku.prototype.deserializeCollisionBoxes = function(t5) {
              this.collisionArrays = [];
              for (var e4 = 0; e4 < this.symbolInstances.length; e4++) {
                var r4 = this.symbolInstances.get(e4);
                this.collisionArrays.push(this._deserializeCollisionBoxesForSymbol(t5, r4.textBoxStartIndex, r4.textBoxEndIndex, r4.verticalTextBoxStartIndex, r4.verticalTextBoxEndIndex, r4.iconBoxStartIndex, r4.iconBoxEndIndex, r4.verticalIconBoxStartIndex, r4.verticalIconBoxEndIndex));
              }
            }, Ku.prototype.hasTextData = function() {
              return this.text.segments.get().length > 0;
            }, Ku.prototype.hasIconData = function() {
              return this.icon.segments.get().length > 0;
            }, Ku.prototype.hasDebugData = function() {
              return this.textCollisionBox && this.iconCollisionBox;
            }, Ku.prototype.hasTextCollisionBoxData = function() {
              return this.hasDebugData() && this.textCollisionBox.segments.get().length > 0;
            }, Ku.prototype.hasIconCollisionBoxData = function() {
              return this.hasDebugData() && this.iconCollisionBox.segments.get().length > 0;
            }, Ku.prototype.addIndicesForPlacedSymbol = function(t5, e4) {
              for (var r4 = t5.placedSymbolArray.get(e4), n4 = r4.vertexStartIndex + 4 * r4.numGlyphs, i2 = r4.vertexStartIndex; i2 < n4; i2 += 4)
                t5.indexArray.emplaceBack(i2, i2 + 1, i2 + 2), t5.indexArray.emplaceBack(i2 + 1, i2 + 2, i2 + 3);
            }, Ku.prototype.getSortedSymbolIndexes = function(t5) {
              if (this.sortedAngle === t5 && void 0 !== this.symbolInstanceIndexes)
                return this.symbolInstanceIndexes;
              for (var e4 = Math.sin(t5), r4 = Math.cos(t5), n4 = [], i2 = [], a2 = [], o2 = 0; o2 < this.symbolInstances.length; ++o2) {
                a2.push(o2);
                var s2 = this.symbolInstances.get(o2);
                n4.push(0 | Math.round(e4 * s2.anchorX + r4 * s2.anchorY)), i2.push(s2.featureIndex);
              }
              return a2.sort(function(t6, e5) {
                return n4[t6] - n4[e5] || i2[e5] - i2[t6];
              }), a2;
            }, Ku.prototype.addToSortKeyRanges = function(t5, e4) {
              var r4 = this.sortKeyRanges[this.sortKeyRanges.length - 1];
              r4 && r4.sortKey === e4 ? r4.symbolInstanceEnd = t5 + 1 : this.sortKeyRanges.push({ sortKey: e4, symbolInstanceStart: t5, symbolInstanceEnd: t5 + 1 });
            }, Ku.prototype.sortFeatures = function(t5) {
              var e4 = this;
              if (this.sortFeaturesByY && this.sortedAngle !== t5 && !(this.text.segments.get().length > 1 || this.icon.segments.get().length > 1)) {
                this.symbolInstanceIndexes = this.getSortedSymbolIndexes(t5), this.sortedAngle = t5, this.text.indexArray.clear(), this.icon.indexArray.clear(), this.featureSortOrder = [];
                for (var r4 = 0, n4 = this.symbolInstanceIndexes; r4 < n4.length; r4 += 1) {
                  var i2 = n4[r4], a2 = this.symbolInstances.get(i2);
                  this.featureSortOrder.push(a2.featureIndex), [a2.rightJustifiedTextSymbolIndex, a2.centerJustifiedTextSymbolIndex, a2.leftJustifiedTextSymbolIndex].forEach(function(t6, r5, n5) {
                    t6 >= 0 && n5.indexOf(t6) === r5 && e4.addIndicesForPlacedSymbol(e4.text, t6);
                  }), a2.verticalPlacedTextSymbolIndex >= 0 && this.addIndicesForPlacedSymbol(this.text, a2.verticalPlacedTextSymbolIndex), a2.placedIconSymbolIndex >= 0 && this.addIndicesForPlacedSymbol(this.icon, a2.placedIconSymbolIndex), a2.verticalPlacedIconSymbolIndex >= 0 && this.addIndicesForPlacedSymbol(this.icon, a2.verticalPlacedIconSymbolIndex);
                }
                this.text.indexBuffer && this.text.indexBuffer.updateData(this.text.indexArray), this.icon.indexBuffer && this.icon.indexBuffer.updateData(this.icon.indexArray);
              }
            }, Qn("SymbolBucket", Ku, { omit: ["layers", "collisionBoxArray", "features", "compareText"] }), Ku.MAX_GLYPHS = 65535, Ku.addDynamicAttributes = Yu;
            var $u = new Ui({ "symbol-placement": new Ri(It.layout_symbol["symbol-placement"]), "symbol-spacing": new Ri(It.layout_symbol["symbol-spacing"]), "symbol-avoid-edges": new Ri(It.layout_symbol["symbol-avoid-edges"]), "symbol-sort-key": new Fi(It.layout_symbol["symbol-sort-key"]), "symbol-z-order": new Ri(It.layout_symbol["symbol-z-order"]), "icon-allow-overlap": new Ri(It.layout_symbol["icon-allow-overlap"]), "icon-ignore-placement": new Ri(It.layout_symbol["icon-ignore-placement"]), "icon-optional": new Ri(It.layout_symbol["icon-optional"]), "icon-rotation-alignment": new Ri(It.layout_symbol["icon-rotation-alignment"]), "icon-size": new Fi(It.layout_symbol["icon-size"]), "icon-text-fit": new Ri(It.layout_symbol["icon-text-fit"]), "icon-text-fit-padding": new Ri(It.layout_symbol["icon-text-fit-padding"]), "icon-image": new Fi(It.layout_symbol["icon-image"]), "icon-rotate": new Fi(It.layout_symbol["icon-rotate"]), "icon-padding": new Ri(It.layout_symbol["icon-padding"]), "icon-keep-upright": new Ri(It.layout_symbol["icon-keep-upright"]), "icon-offset": new Fi(It.layout_symbol["icon-offset"]), "icon-anchor": new Fi(It.layout_symbol["icon-anchor"]), "icon-pitch-alignment": new Ri(It.layout_symbol["icon-pitch-alignment"]), "text-pitch-alignment": new Ri(It.layout_symbol["text-pitch-alignment"]), "text-rotation-alignment": new Ri(It.layout_symbol["text-rotation-alignment"]), "text-field": new Fi(It.layout_symbol["text-field"]), "text-font": new Fi(It.layout_symbol["text-font"]), "text-size": new Fi(It.layout_symbol["text-size"]), "text-max-width": new Fi(It.layout_symbol["text-max-width"]), "text-line-height": new Ri(It.layout_symbol["text-line-height"]), "text-letter-spacing": new Fi(It.layout_symbol["text-letter-spacing"]), "text-justify": new Fi(It.layout_symbol["text-justify"]), "text-radial-offset": new Fi(It.layout_symbol["text-radial-offset"]), "text-variable-anchor": new Ri(It.layout_symbol["text-variable-anchor"]), "text-anchor": new Fi(It.layout_symbol["text-anchor"]), "text-max-angle": new Ri(It.layout_symbol["text-max-angle"]), "text-writing-mode": new Ri(It.layout_symbol["text-writing-mode"]), "text-rotate": new Fi(It.layout_symbol["text-rotate"]), "text-padding": new Ri(It.layout_symbol["text-padding"]), "text-keep-upright": new Ri(It.layout_symbol["text-keep-upright"]), "text-transform": new Fi(It.layout_symbol["text-transform"]), "text-offset": new Fi(It.layout_symbol["text-offset"]), "text-allow-overlap": new Ri(It.layout_symbol["text-allow-overlap"]), "text-ignore-placement": new Ri(It.layout_symbol["text-ignore-placement"]), "text-optional": new Ri(It.layout_symbol["text-optional"]) }), Qu = { paint: new Ui({ "icon-opacity": new Fi(It.paint_symbol["icon-opacity"]), "icon-color": new Fi(It.paint_symbol["icon-color"]), "icon-halo-color": new Fi(It.paint_symbol["icon-halo-color"]), "icon-halo-width": new Fi(It.paint_symbol["icon-halo-width"]), "icon-halo-blur": new Fi(It.paint_symbol["icon-halo-blur"]), "icon-translate": new Ri(It.paint_symbol["icon-translate"]), "icon-translate-anchor": new Ri(It.paint_symbol["icon-translate-anchor"]), "text-opacity": new Fi(It.paint_symbol["text-opacity"]), "text-color": new Fi(It.paint_symbol["text-color"], { runtimeType: Gt, getOverride: function(t5) {
              return t5.textColor;
            }, hasOverride: function(t5) {
              return !!t5.textColor;
            } }), "text-halo-color": new Fi(It.paint_symbol["text-halo-color"]), "text-halo-width": new Fi(It.paint_symbol["text-halo-width"]), "text-halo-blur": new Fi(It.paint_symbol["text-halo-blur"]), "text-translate": new Ri(It.paint_symbol["text-translate"]), "text-translate-anchor": new Ri(It.paint_symbol["text-translate-anchor"]) }), layout: $u }, tc = function(t5) {
              this.type = t5.property.overrides ? t5.property.overrides.runtimeType : Ut, this.defaultValue = t5;
            };
            tc.prototype.evaluate = function(t5) {
              if (t5.formattedSection) {
                var e4 = this.defaultValue.property.overrides;
                if (e4 && e4.hasOverride(t5.formattedSection))
                  return e4.getOverride(t5.formattedSection);
              }
              return t5.feature && t5.featureState ? this.defaultValue.evaluate(t5.feature, t5.featureState) : this.defaultValue.property.specification.default;
            }, tc.prototype.eachChild = function(t5) {
              this.defaultValue.isConstant() || t5(this.defaultValue.value._styleExpression.expression);
            }, tc.prototype.outputDefined = function() {
              return false;
            }, tc.prototype.serialize = function() {
              return null;
            }, Qn("FormatSectionOverride", tc, { omit: ["defaultValue"] });
            var ec = function(t5) {
              function e4(e5) {
                t5.call(this, e5, Qu);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.recalculate = function(e5, r4) {
                if (t5.prototype.recalculate.call(this, e5, r4), "auto" === this.layout.get("icon-rotation-alignment") && ("point" !== this.layout.get("symbol-placement") ? this.layout._values["icon-rotation-alignment"] = "map" : this.layout._values["icon-rotation-alignment"] = "viewport"), "auto" === this.layout.get("text-rotation-alignment") && ("point" !== this.layout.get("symbol-placement") ? this.layout._values["text-rotation-alignment"] = "map" : this.layout._values["text-rotation-alignment"] = "viewport"), "auto" === this.layout.get("text-pitch-alignment") && (this.layout._values["text-pitch-alignment"] = this.layout.get("text-rotation-alignment")), "auto" === this.layout.get("icon-pitch-alignment") && (this.layout._values["icon-pitch-alignment"] = this.layout.get("icon-rotation-alignment")), "point" === this.layout.get("symbol-placement")) {
                  var n4 = this.layout.get("text-writing-mode");
                  if (n4) {
                    for (var i2 = [], a2 = 0, o2 = n4; a2 < o2.length; a2 += 1) {
                      var s2 = o2[a2];
                      i2.indexOf(s2) < 0 && i2.push(s2);
                    }
                    this.layout._values["text-writing-mode"] = i2;
                  } else
                    this.layout._values["text-writing-mode"] = ["horizontal"];
                }
                this._setPaintOverrides();
              }, e4.prototype.getValueAndResolveTokens = function(t6, e5, r4, n4) {
                var i2 = this.layout.get(t6).evaluate(e5, {}, r4, n4), a2 = this._unevaluatedLayout._values[t6];
                return a2.isDataDriven() || nn(a2.value) || !i2 ? i2 : function(t7, e6) {
                  return e6.replace(/{([^{}]+)}/g, function(e7, r5) {
                    return r5 in t7 ? String(t7[r5]) : "";
                  });
                }(e5.properties, i2);
              }, e4.prototype.createBucket = function(t6) {
                return new Ku(t6);
              }, e4.prototype.queryRadius = function() {
                return 0;
              }, e4.prototype.queryIntersectsFeature = function() {
                return false;
              }, e4.prototype._setPaintOverrides = function() {
                for (var t6 = 0, r4 = Qu.paint.overridableProperties; t6 < r4.length; t6 += 1) {
                  var n4 = r4[t6];
                  if (e4.hasPaintOverride(this.layout, n4)) {
                    var i2, a2 = this.paint.get(n4), o2 = new tc(a2), s2 = new rn(o2, a2.property.specification);
                    i2 = "constant" === a2.value.kind || "source" === a2.value.kind ? new on("source", s2) : new sn("composite", s2, a2.value.zoomStops, a2.value._interpolationType), this.paint._values[n4] = new Di(a2.property, i2, a2.parameters);
                  }
                }
              }, e4.prototype._handleOverridablePaintPropertyUpdate = function(t6, r4, n4) {
                return !(!this.layout || r4.isDataDriven() || n4.isDataDriven()) && e4.hasPaintOverride(this.layout, t6);
              }, e4.hasPaintOverride = function(t6, e5) {
                var r4 = t6.get("text-field"), n4 = Qu.paint.properties[e5], i2 = false, a2 = function(t7) {
                  for (var e6 = 0, r5 = t7; e6 < r5.length; e6 += 1) {
                    var a3 = r5[e6];
                    if (n4.overrides && n4.overrides.hasOverride(a3))
                      return void (i2 = true);
                  }
                };
                if ("constant" === r4.value.kind && r4.value.value instanceof le)
                  a2(r4.value.value.sections);
                else if ("source" === r4.value.kind) {
                  var o2 = function(t7) {
                    if (!i2)
                      if (t7 instanceof de && he(t7.value) === Xt) {
                        var e6 = t7.value;
                        a2(e6.sections);
                      } else
                        t7 instanceof me ? a2(t7.sections) : t7.eachChild(o2);
                  }, s2 = r4.value;
                  s2._styleExpression && o2(s2._styleExpression.expression);
                }
                return i2;
              }, e4;
            }(Hi), rc = { paint: new Ui({ "background-color": new Ri(It.paint_background["background-color"]), "background-pattern": new Ni(It.paint_background["background-pattern"]), "background-opacity": new Ri(It.paint_background["background-opacity"]) }) }, nc = function(t5) {
              function e4(e5) {
                t5.call(this, e5, rc);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4;
            }(Hi), ic = { paint: new Ui({ "raster-opacity": new Ri(It.paint_raster["raster-opacity"]), "raster-hue-rotate": new Ri(It.paint_raster["raster-hue-rotate"]), "raster-brightness-min": new Ri(It.paint_raster["raster-brightness-min"]), "raster-brightness-max": new Ri(It.paint_raster["raster-brightness-max"]), "raster-saturation": new Ri(It.paint_raster["raster-saturation"]), "raster-contrast": new Ri(It.paint_raster["raster-contrast"]), "raster-resampling": new Ri(It.paint_raster["raster-resampling"]), "raster-fade-duration": new Ri(It.paint_raster["raster-fade-duration"]) }) }, ac = function(t5) {
              function e4(e5) {
                t5.call(this, e5, ic);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4;
            }(Hi);
            var oc = function(t5) {
              function e4(e5) {
                t5.call(this, e5, {}), this.implementation = e5;
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.is3D = function() {
                return "3d" === this.implementation.renderingMode;
              }, e4.prototype.hasOffscreenPass = function() {
                return void 0 !== this.implementation.prerender;
              }, e4.prototype.recalculate = function() {
              }, e4.prototype.updateTransitions = function() {
              }, e4.prototype.hasTransition = function() {
              }, e4.prototype.serialize = function() {
              }, e4.prototype.onAdd = function(t6) {
                this.implementation.onAdd && this.implementation.onAdd(t6, t6.painter.context.gl);
              }, e4.prototype.onRemove = function(t6) {
                this.implementation.onRemove && this.implementation.onRemove(t6, t6.painter.context.gl);
              }, e4;
            }(Hi), sc = { circle: Fo, heatmap: Yo, hillshade: Xo, fill: Rs, "fill-extrusion": Qs, line: fl, symbol: ec, background: nc, raster: ac };
            var lc = self.HTMLImageElement, uc = self.HTMLCanvasElement, cc = self.HTMLVideoElement, fc = self.ImageData, hc = self.ImageBitmap, pc = function(t5, e4, r4, n4) {
              this.context = t5, this.format = r4, this.texture = t5.gl.createTexture(), this.update(e4, n4);
            };
            pc.prototype.update = function(t5, e4, r4) {
              var n4 = t5.width, i2 = t5.height, a2 = !(this.size && this.size[0] === n4 && this.size[1] === i2 || r4), o2 = this.context, s2 = o2.gl;
              if (this.useMipmap = Boolean(e4 && e4.useMipmap), s2.bindTexture(s2.TEXTURE_2D, this.texture), o2.pixelStoreUnpackFlipY.set(false), o2.pixelStoreUnpack.set(1), o2.pixelStoreUnpackPremultiplyAlpha.set(this.format === s2.RGBA && (!e4 || false !== e4.premultiply)), a2)
                this.size = [n4, i2], t5 instanceof lc || t5 instanceof uc || t5 instanceof cc || t5 instanceof fc || hc && t5 instanceof hc ? s2.texImage2D(s2.TEXTURE_2D, 0, this.format, this.format, s2.UNSIGNED_BYTE, t5) : s2.texImage2D(s2.TEXTURE_2D, 0, this.format, n4, i2, 0, this.format, s2.UNSIGNED_BYTE, t5.data);
              else {
                var l2 = r4 || { x: 0, y: 0 }, u2 = l2.x, c2 = l2.y;
                t5 instanceof lc || t5 instanceof uc || t5 instanceof cc || t5 instanceof fc || hc && t5 instanceof hc ? s2.texSubImage2D(s2.TEXTURE_2D, 0, u2, c2, s2.RGBA, s2.UNSIGNED_BYTE, t5) : s2.texSubImage2D(s2.TEXTURE_2D, 0, u2, c2, n4, i2, s2.RGBA, s2.UNSIGNED_BYTE, t5.data);
              }
              this.useMipmap && this.isSizePowerOfTwo() && s2.generateMipmap(s2.TEXTURE_2D);
            }, pc.prototype.bind = function(t5, e4, r4) {
              var n4 = this.context.gl;
              n4.bindTexture(n4.TEXTURE_2D, this.texture), r4 !== n4.LINEAR_MIPMAP_NEAREST || this.isSizePowerOfTwo() || (r4 = n4.LINEAR), t5 !== this.filter && (n4.texParameteri(n4.TEXTURE_2D, n4.TEXTURE_MAG_FILTER, t5), n4.texParameteri(n4.TEXTURE_2D, n4.TEXTURE_MIN_FILTER, r4 || t5), this.filter = t5), e4 !== this.wrap && (n4.texParameteri(n4.TEXTURE_2D, n4.TEXTURE_WRAP_S, e4), n4.texParameteri(n4.TEXTURE_2D, n4.TEXTURE_WRAP_T, e4), this.wrap = e4);
            }, pc.prototype.isSizePowerOfTwo = function() {
              return this.size[0] === this.size[1] && Math.log(this.size[0]) / Math.LN2 % 1 == 0;
            }, pc.prototype.destroy = function() {
              this.context.gl.deleteTexture(this.texture), this.texture = null;
            };
            var dc = function(t5) {
              var e4 = this;
              this._callback = t5, this._triggered = false, "undefined" != typeof MessageChannel && (this._channel = new MessageChannel(), this._channel.port2.onmessage = function() {
                e4._triggered = false, e4._callback();
              });
            };
            dc.prototype.trigger = function() {
              var t5 = this;
              this._triggered || (this._triggered = true, this._channel ? this._channel.port1.postMessage(true) : setTimeout(function() {
                t5._triggered = false, t5._callback();
              }, 0));
            }, dc.prototype.remove = function() {
              delete this._channel, this._callback = function() {
              };
            };
            var vc = function(t5, e4, r4) {
              this.target = t5, this.parent = e4, this.mapId = r4, this.callbacks = {}, this.tasks = {}, this.taskQueue = [], this.cancelCallbacks = {}, g2(["receive", "process"], this), this.invoker = new dc(this.process), this.target.addEventListener("message", this.receive, false), this.globalScope = A() ? t5 : self;
            };
            function gc(t5, e4, r4) {
              var n4 = 2 * Math.PI * 6378137 / 256 / Math.pow(2, r4);
              return [t5 * n4 - 2 * Math.PI * 6378137 / 2, e4 * n4 - 2 * Math.PI * 6378137 / 2];
            }
            vc.prototype.send = function(t5, e4, r4, n4, i2) {
              var a2 = this;
              void 0 === i2 && (i2 = false);
              var o2 = Math.round(1e18 * Math.random()).toString(36).substring(0, 10);
              r4 && (this.callbacks[o2] = r4);
              var s2 = E(this.globalScope) ? void 0 : [];
              return this.target.postMessage({ id: o2, type: t5, hasCallback: !!r4, targetMapId: n4, mustQueue: i2, sourceMapId: this.mapId, data: ni(e4, s2) }, s2), { cancel: function() {
                r4 && delete a2.callbacks[o2], a2.target.postMessage({ id: o2, type: "<cancel>", targetMapId: n4, sourceMapId: a2.mapId });
              } };
            }, vc.prototype.receive = function(t5) {
              var e4 = t5.data, r4 = e4.id;
              if (r4 && (!e4.targetMapId || this.mapId === e4.targetMapId))
                if ("<cancel>" === e4.type) {
                  delete this.tasks[r4];
                  var n4 = this.cancelCallbacks[r4];
                  delete this.cancelCallbacks[r4], n4 && n4();
                } else
                  A() || e4.mustQueue ? (this.tasks[r4] = e4, this.taskQueue.push(r4), this.invoker.trigger()) : this.processTask(r4, e4);
            }, vc.prototype.process = function() {
              if (this.taskQueue.length) {
                var t5 = this.taskQueue.shift(), e4 = this.tasks[t5];
                delete this.tasks[t5], this.taskQueue.length && this.invoker.trigger(), e4 && this.processTask(t5, e4);
              }
            }, vc.prototype.processTask = function(t5, e4) {
              var r4 = this;
              if ("<response>" === e4.type) {
                var n4 = this.callbacks[t5];
                delete this.callbacks[t5], n4 && (e4.error ? n4(ii(e4.error)) : n4(null, ii(e4.data)));
              } else {
                var i2 = false, a2 = E(this.globalScope) ? void 0 : [], o2 = e4.hasCallback ? function(e5, n5) {
                  i2 = true, delete r4.cancelCallbacks[t5], r4.target.postMessage({ id: t5, type: "<response>", sourceMapId: r4.mapId, error: e5 ? ni(e5) : null, data: ni(n5, a2) }, a2);
                } : function(t6) {
                  i2 = true;
                }, s2 = null, l2 = ii(e4.data);
                if (this.parent[e4.type])
                  s2 = this.parent[e4.type](e4.sourceMapId, l2, o2);
                else if (this.parent.getWorkerSource) {
                  var u2 = e4.type.split(".");
                  s2 = this.parent.getWorkerSource(e4.sourceMapId, u2[0], l2.source)[u2[1]](l2, o2);
                } else
                  o2(new Error("Could not find function " + e4.type));
                !i2 && s2 && s2.cancel && (this.cancelCallbacks[t5] = s2.cancel);
              }
            }, vc.prototype.remove = function() {
              this.invoker.remove(), this.target.removeEventListener("message", this.receive, false);
            };
            var yc = function(t5, e4) {
              t5 && (e4 ? this.setSouthWest(t5).setNorthEast(e4) : 4 === t5.length ? this.setSouthWest([t5[0], t5[1]]).setNorthEast([t5[2], t5[3]]) : this.setSouthWest(t5[0]).setNorthEast(t5[1]));
            };
            yc.prototype.setNorthEast = function(t5) {
              return this._ne = t5 instanceof xc ? new xc(t5.lng, t5.lat) : xc.convert(t5), this;
            }, yc.prototype.setSouthWest = function(t5) {
              return this._sw = t5 instanceof xc ? new xc(t5.lng, t5.lat) : xc.convert(t5), this;
            }, yc.prototype.extend = function(t5) {
              var e4, r4, n4 = this._sw, i2 = this._ne;
              if (t5 instanceof xc)
                e4 = t5, r4 = t5;
              else {
                if (!(t5 instanceof yc)) {
                  if (Array.isArray(t5)) {
                    if (4 === t5.length || t5.every(Array.isArray)) {
                      var a2 = t5;
                      return this.extend(yc.convert(a2));
                    }
                    var o2 = t5;
                    return this.extend(xc.convert(o2));
                  }
                  return this;
                }
                if (e4 = t5._sw, r4 = t5._ne, !e4 || !r4)
                  return this;
              }
              return n4 || i2 ? (n4.lng = Math.min(e4.lng, n4.lng), n4.lat = Math.min(e4.lat, n4.lat), i2.lng = Math.max(r4.lng, i2.lng), i2.lat = Math.max(r4.lat, i2.lat)) : (this._sw = new xc(e4.lng, e4.lat), this._ne = new xc(r4.lng, r4.lat)), this;
            }, yc.prototype.getCenter = function() {
              return new xc((this._sw.lng + this._ne.lng) / 2, (this._sw.lat + this._ne.lat) / 2);
            }, yc.prototype.getSouthWest = function() {
              return this._sw;
            }, yc.prototype.getNorthEast = function() {
              return this._ne;
            }, yc.prototype.getNorthWest = function() {
              return new xc(this.getWest(), this.getNorth());
            }, yc.prototype.getSouthEast = function() {
              return new xc(this.getEast(), this.getSouth());
            }, yc.prototype.getWest = function() {
              return this._sw.lng;
            }, yc.prototype.getSouth = function() {
              return this._sw.lat;
            }, yc.prototype.getEast = function() {
              return this._ne.lng;
            }, yc.prototype.getNorth = function() {
              return this._ne.lat;
            }, yc.prototype.toArray = function() {
              return [this._sw.toArray(), this._ne.toArray()];
            }, yc.prototype.toString = function() {
              return "LngLatBounds(" + this._sw.toString() + ", " + this._ne.toString() + ")";
            }, yc.prototype.isEmpty = function() {
              return !(this._sw && this._ne);
            }, yc.prototype.contains = function(t5) {
              var e4 = xc.convert(t5), r4 = e4.lng, n4 = e4.lat, i2 = this._sw.lat <= n4 && n4 <= this._ne.lat, a2 = this._sw.lng <= r4 && r4 <= this._ne.lng;
              return this._sw.lng > this._ne.lng && (a2 = this._sw.lng >= r4 && r4 >= this._ne.lng), i2 && a2;
            }, yc.convert = function(t5) {
              return !t5 || t5 instanceof yc ? t5 : new yc(t5);
            };
            var mc = 63710088e-1, xc = function(t5, e4) {
              if (isNaN(t5) || isNaN(e4))
                throw new Error("Invalid LngLat object: (" + t5 + ", " + e4 + ")");
              if (this.lng = +t5, this.lat = +e4, this.lat > 90 || this.lat < -90)
                throw new Error("Invalid LngLat latitude value: must be between -90 and 90");
            };
            xc.prototype.wrap = function() {
              return new xc(c(this.lng, -180, 180), this.lat);
            }, xc.prototype.toArray = function() {
              return [this.lng, this.lat];
            }, xc.prototype.toString = function() {
              return "LngLat(" + this.lng + ", " + this.lat + ")";
            }, xc.prototype.distanceTo = function(t5) {
              var e4 = Math.PI / 180, r4 = this.lat * e4, n4 = t5.lat * e4, i2 = Math.sin(r4) * Math.sin(n4) + Math.cos(r4) * Math.cos(n4) * Math.cos((t5.lng - this.lng) * e4);
              return mc * Math.acos(Math.min(i2, 1));
            }, xc.prototype.toBounds = function(t5) {
              void 0 === t5 && (t5 = 0);
              var e4 = 360 * t5 / 40075017, r4 = e4 / Math.cos(Math.PI / 180 * this.lat);
              return new yc(new xc(this.lng - r4, this.lat - e4), new xc(this.lng + r4, this.lat + e4));
            }, xc.convert = function(t5) {
              if (t5 instanceof xc)
                return t5;
              if (Array.isArray(t5) && (2 === t5.length || 3 === t5.length))
                return new xc(Number(t5[0]), Number(t5[1]));
              if (!Array.isArray(t5) && "object" == typeof t5 && null !== t5)
                return new xc(Number("lng" in t5 ? t5.lng : t5.lon), Number(t5.lat));
              throw new Error("`LngLatLike` argument must be specified as a LngLat instance, an object {lng: <lng>, lat: <lat>}, an object {lon: <lng>, lat: <lat>}, or an array of [<lng>, <lat>]");
            };
            var bc = 2 * Math.PI * mc;
            function _c(t5) {
              return bc * Math.cos(t5 * Math.PI / 180);
            }
            function wc(t5) {
              return (180 + t5) / 360;
            }
            function Tc(t5) {
              return (180 - 180 / Math.PI * Math.log(Math.tan(Math.PI / 4 + t5 * Math.PI / 360))) / 360;
            }
            function kc(t5, e4) {
              return t5 / _c(e4);
            }
            function Ac(t5) {
              var e4 = 180 - 360 * t5;
              return 360 / Math.PI * Math.atan(Math.exp(e4 * Math.PI / 180)) - 90;
            }
            var Mc = function(t5, e4, r4) {
              void 0 === r4 && (r4 = 0), this.x = +t5, this.y = +e4, this.z = +r4;
            };
            Mc.fromLngLat = function(t5, e4) {
              void 0 === e4 && (e4 = 0);
              var r4 = xc.convert(t5);
              return new Mc(wc(r4.lng), Tc(r4.lat), kc(e4, r4.lat));
            }, Mc.prototype.toLngLat = function() {
              return new xc(360 * this.x - 180, Ac(this.y));
            }, Mc.prototype.toAltitude = function() {
              return t5 = this.z, e4 = this.y, t5 * _c(Ac(e4));
              var t5, e4;
            }, Mc.prototype.meterInMercatorCoordinateUnits = function() {
              return 1 / bc * (t5 = Ac(this.y), 1 / Math.cos(t5 * Math.PI / 180));
              var t5;
            };
            var Sc = function(t5, e4, r4) {
              this.z = t5, this.x = e4, this.y = r4, this.key = Cc(0, t5, t5, e4, r4);
            };
            Sc.prototype.equals = function(t5) {
              return this.z === t5.z && this.x === t5.x && this.y === t5.y;
            }, Sc.prototype.url = function(t5, e4) {
              var r4, n4, i2, a2, o2, s2 = (r4 = this.x, n4 = this.y, i2 = this.z, a2 = gc(256 * r4, 256 * (n4 = Math.pow(2, i2) - n4 - 1), i2), o2 = gc(256 * (r4 + 1), 256 * (n4 + 1), i2), a2[0] + "," + a2[1] + "," + o2[0] + "," + o2[1]), l2 = function(t6, e5, r5) {
                for (var n5, i3 = "", a3 = t6; a3 > 0; a3--)
                  i3 += (e5 & (n5 = 1 << a3 - 1) ? 1 : 0) + (r5 & n5 ? 2 : 0);
                return i3;
              }(this.z, this.x, this.y);
              return t5[(this.x + this.y) % t5.length].replace("{prefix}", (this.x % 16).toString(16) + (this.y % 16).toString(16)).replace("{z}", String(this.z)).replace("{x}", String(this.x)).replace("{y}", String("tms" === e4 ? Math.pow(2, this.z) - this.y - 1 : this.y)).replace("{quadkey}", l2).replace("{bbox-epsg-3857}", s2);
            }, Sc.prototype.getTilePoint = function(t5) {
              var e4 = Math.pow(2, this.z);
              return new a((t5.x * e4 - this.x) * oo, (t5.y * e4 - this.y) * oo);
            }, Sc.prototype.toString = function() {
              return this.z + "/" + this.x + "/" + this.y;
            };
            var Ec = function(t5, e4) {
              this.wrap = t5, this.canonical = e4, this.key = Cc(t5, e4.z, e4.z, e4.x, e4.y);
            }, Lc = function(t5, e4, r4, n4, i2) {
              this.overscaledZ = t5, this.wrap = e4, this.canonical = new Sc(r4, +n4, +i2), this.key = Cc(e4, t5, r4, n4, i2);
            };
            function Cc(t5, e4, r4, n4, i2) {
              (t5 *= 2) < 0 && (t5 = -1 * t5 - 1);
              var a2 = 1 << r4;
              return (a2 * a2 * t5 + a2 * i2 + n4).toString(36) + r4.toString(36) + e4.toString(36);
            }
            Lc.prototype.equals = function(t5) {
              return this.overscaledZ === t5.overscaledZ && this.wrap === t5.wrap && this.canonical.equals(t5.canonical);
            }, Lc.prototype.scaledTo = function(t5) {
              var e4 = this.canonical.z - t5;
              return t5 > this.canonical.z ? new Lc(t5, this.wrap, this.canonical.z, this.canonical.x, this.canonical.y) : new Lc(t5, this.wrap, t5, this.canonical.x >> e4, this.canonical.y >> e4);
            }, Lc.prototype.calculateScaledKey = function(t5, e4) {
              var r4 = this.canonical.z - t5;
              return t5 > this.canonical.z ? Cc(this.wrap * +e4, t5, this.canonical.z, this.canonical.x, this.canonical.y) : Cc(this.wrap * +e4, t5, t5, this.canonical.x >> r4, this.canonical.y >> r4);
            }, Lc.prototype.isChildOf = function(t5) {
              if (t5.wrap !== this.wrap)
                return false;
              var e4 = this.canonical.z - t5.canonical.z;
              return 0 === t5.overscaledZ || t5.overscaledZ < this.overscaledZ && t5.canonical.x === this.canonical.x >> e4 && t5.canonical.y === this.canonical.y >> e4;
            }, Lc.prototype.children = function(t5) {
              if (this.overscaledZ >= t5)
                return [new Lc(this.overscaledZ + 1, this.wrap, this.canonical.z, this.canonical.x, this.canonical.y)];
              var e4 = this.canonical.z + 1, r4 = 2 * this.canonical.x, n4 = 2 * this.canonical.y;
              return [new Lc(e4, this.wrap, e4, r4, n4), new Lc(e4, this.wrap, e4, r4 + 1, n4), new Lc(e4, this.wrap, e4, r4, n4 + 1), new Lc(e4, this.wrap, e4, r4 + 1, n4 + 1)];
            }, Lc.prototype.isLessThan = function(t5) {
              return this.wrap < t5.wrap || !(this.wrap > t5.wrap) && (this.overscaledZ < t5.overscaledZ || !(this.overscaledZ > t5.overscaledZ) && (this.canonical.x < t5.canonical.x || !(this.canonical.x > t5.canonical.x) && this.canonical.y < t5.canonical.y));
            }, Lc.prototype.wrapped = function() {
              return new Lc(this.overscaledZ, 0, this.canonical.z, this.canonical.x, this.canonical.y);
            }, Lc.prototype.unwrapTo = function(t5) {
              return new Lc(this.overscaledZ, t5, this.canonical.z, this.canonical.x, this.canonical.y);
            }, Lc.prototype.overscaleFactor = function() {
              return Math.pow(2, this.overscaledZ - this.canonical.z);
            }, Lc.prototype.toUnwrapped = function() {
              return new Ec(this.wrap, this.canonical);
            }, Lc.prototype.toString = function() {
              return this.overscaledZ + "/" + this.canonical.x + "/" + this.canonical.y;
            }, Lc.prototype.getTilePoint = function(t5) {
              return this.canonical.getTilePoint(new Mc(t5.x - this.wrap, t5.y));
            }, Qn("CanonicalTileID", Sc), Qn("OverscaledTileID", Lc, { omit: ["posMatrix"] });
            var Pc = function(t5, e4, r4) {
              if (this.uid = t5, e4.height !== e4.width)
                throw new RangeError("DEM tiles must be square");
              if (r4 && "mapbox" !== r4 && "terrarium" !== r4)
                return w2('"' + r4 + '" is not a valid encoding type. Valid types include "mapbox" and "terrarium".');
              this.stride = e4.height;
              var n4 = this.dim = e4.height - 2;
              this.data = new Uint32Array(e4.data.buffer), this.encoding = r4 || "mapbox";
              for (var i2 = 0; i2 < n4; i2++)
                this.data[this._idx(-1, i2)] = this.data[this._idx(0, i2)], this.data[this._idx(n4, i2)] = this.data[this._idx(n4 - 1, i2)], this.data[this._idx(i2, -1)] = this.data[this._idx(i2, 0)], this.data[this._idx(i2, n4)] = this.data[this._idx(i2, n4 - 1)];
              this.data[this._idx(-1, -1)] = this.data[this._idx(0, 0)], this.data[this._idx(n4, -1)] = this.data[this._idx(n4 - 1, 0)], this.data[this._idx(-1, n4)] = this.data[this._idx(0, n4 - 1)], this.data[this._idx(n4, n4)] = this.data[this._idx(n4 - 1, n4 - 1)];
            };
            Pc.prototype.get = function(t5, e4) {
              var r4 = new Uint8Array(this.data.buffer), n4 = 4 * this._idx(t5, e4);
              return ("terrarium" === this.encoding ? this._unpackTerrarium : this._unpackMapbox)(r4[n4], r4[n4 + 1], r4[n4 + 2]);
            }, Pc.prototype.getUnpackVector = function() {
              return "terrarium" === this.encoding ? [256, 1, 1 / 256, 32768] : [6553.6, 25.6, 0.1, 1e4];
            }, Pc.prototype._idx = function(t5, e4) {
              if (t5 < -1 || t5 >= this.dim + 1 || e4 < -1 || e4 >= this.dim + 1)
                throw new RangeError("out of range source coordinates for DEM data");
              return (e4 + 1) * this.stride + (t5 + 1);
            }, Pc.prototype._unpackMapbox = function(t5, e4, r4) {
              return (256 * t5 * 256 + 256 * e4 + r4) / 10 - 1e4;
            }, Pc.prototype._unpackTerrarium = function(t5, e4, r4) {
              return 256 * t5 + e4 + r4 / 256 - 32768;
            }, Pc.prototype.getPixels = function() {
              return new qo({ width: this.stride, height: this.stride }, new Uint8Array(this.data.buffer));
            }, Pc.prototype.backfillBorder = function(t5, e4, r4) {
              if (this.dim !== t5.dim)
                throw new Error("dem dimension mismatch");
              var n4 = e4 * this.dim, i2 = e4 * this.dim + this.dim, a2 = r4 * this.dim, o2 = r4 * this.dim + this.dim;
              switch (e4) {
                case -1:
                  n4 = i2 - 1;
                  break;
                case 1:
                  i2 = n4 + 1;
              }
              switch (r4) {
                case -1:
                  a2 = o2 - 1;
                  break;
                case 1:
                  o2 = a2 + 1;
              }
              for (var s2 = -e4 * this.dim, l2 = -r4 * this.dim, u2 = a2; u2 < o2; u2++)
                for (var c2 = n4; c2 < i2; c2++)
                  this.data[this._idx(c2, u2)] = t5.data[this._idx(c2 + s2, u2 + l2)];
            }, Qn("DEMData", Pc);
            var Oc = function(t5) {
              this._stringToNumber = {}, this._numberToString = [];
              for (var e4 = 0; e4 < t5.length; e4++) {
                var r4 = t5[e4];
                this._stringToNumber[r4] = e4, this._numberToString[e4] = r4;
              }
            };
            Oc.prototype.encode = function(t5) {
              return this._stringToNumber[t5];
            }, Oc.prototype.decode = function(t5) {
              return this._numberToString[t5];
            };
            var Ic = function(t5, e4, r4, n4, i2) {
              this.type = "Feature", this._vectorTileFeature = t5, t5._z = e4, t5._x = r4, t5._y = n4, this.properties = t5.properties, this.id = i2;
            }, Dc = { geometry: { configurable: true } };
            Dc.geometry.get = function() {
              return void 0 === this._geometry && (this._geometry = this._vectorTileFeature.toGeoJSON(this._vectorTileFeature._x, this._vectorTileFeature._y, this._vectorTileFeature._z).geometry), this._geometry;
            }, Dc.geometry.set = function(t5) {
              this._geometry = t5;
            }, Ic.prototype.toJSON = function() {
              var t5 = { geometry: this.geometry };
              for (var e4 in this)
                "_geometry" !== e4 && "_vectorTileFeature" !== e4 && (t5[e4] = this[e4]);
              return t5;
            }, Object.defineProperties(Ic.prototype, Dc);
            var zc = function() {
              this.state = {}, this.stateChanges = {}, this.deletedStates = {};
            };
            zc.prototype.updateState = function(t5, e4, r4) {
              var n4 = String(e4);
              if (this.stateChanges[t5] = this.stateChanges[t5] || {}, this.stateChanges[t5][n4] = this.stateChanges[t5][n4] || {}, f2(this.stateChanges[t5][n4], r4), null === this.deletedStates[t5])
                for (var i2 in this.deletedStates[t5] = {}, this.state[t5])
                  i2 !== n4 && (this.deletedStates[t5][i2] = null);
              else if (this.deletedStates[t5] && null === this.deletedStates[t5][n4])
                for (var a2 in this.deletedStates[t5][n4] = {}, this.state[t5][n4])
                  r4[a2] || (this.deletedStates[t5][n4][a2] = null);
              else
                for (var o2 in r4)
                  this.deletedStates[t5] && this.deletedStates[t5][n4] && null === this.deletedStates[t5][n4][o2] && delete this.deletedStates[t5][n4][o2];
            }, zc.prototype.removeFeatureState = function(t5, e4, r4) {
              if (null !== this.deletedStates[t5]) {
                var n4 = String(e4);
                if (this.deletedStates[t5] = this.deletedStates[t5] || {}, r4 && void 0 !== e4)
                  null !== this.deletedStates[t5][n4] && (this.deletedStates[t5][n4] = this.deletedStates[t5][n4] || {}, this.deletedStates[t5][n4][r4] = null);
                else if (void 0 !== e4)
                  if (this.stateChanges[t5] && this.stateChanges[t5][n4])
                    for (r4 in this.deletedStates[t5][n4] = {}, this.stateChanges[t5][n4])
                      this.deletedStates[t5][n4][r4] = null;
                  else
                    this.deletedStates[t5][n4] = null;
                else
                  this.deletedStates[t5] = null;
              }
            }, zc.prototype.getState = function(t5, e4) {
              var r4 = String(e4), n4 = this.state[t5] || {}, i2 = this.stateChanges[t5] || {}, a2 = f2({}, n4[r4], i2[r4]);
              if (null === this.deletedStates[t5])
                return {};
              if (this.deletedStates[t5]) {
                var o2 = this.deletedStates[t5][e4];
                if (null === o2)
                  return {};
                for (var s2 in o2)
                  delete a2[s2];
              }
              return a2;
            }, zc.prototype.initializeTileState = function(t5, e4) {
              t5.setFeatureState(this.state, e4);
            }, zc.prototype.coalesceChanges = function(t5, e4) {
              var r4 = {};
              for (var n4 in this.stateChanges) {
                this.state[n4] = this.state[n4] || {};
                var i2 = {};
                for (var a2 in this.stateChanges[n4])
                  this.state[n4][a2] || (this.state[n4][a2] = {}), f2(this.state[n4][a2], this.stateChanges[n4][a2]), i2[a2] = this.state[n4][a2];
                r4[n4] = i2;
              }
              for (var o2 in this.deletedStates) {
                this.state[o2] = this.state[o2] || {};
                var s2 = {};
                if (null === this.deletedStates[o2])
                  for (var l2 in this.state[o2])
                    s2[l2] = {}, this.state[o2][l2] = {};
                else
                  for (var u2 in this.deletedStates[o2]) {
                    if (null === this.deletedStates[o2][u2])
                      this.state[o2][u2] = {};
                    else
                      for (var c2 = 0, h2 = Object.keys(this.deletedStates[o2][u2]); c2 < h2.length; c2 += 1) {
                        var p3 = h2[c2];
                        delete this.state[o2][u2][p3];
                      }
                    s2[u2] = this.state[o2][u2];
                  }
                r4[o2] = r4[o2] || {}, f2(r4[o2], s2);
              }
              if (this.stateChanges = {}, this.deletedStates = {}, 0 !== Object.keys(r4).length)
                for (var d3 in t5)
                  t5[d3].setFeatureState(r4, e4);
            };
            var Rc = function(t5, e4) {
              this.tileID = t5, this.x = t5.canonical.x, this.y = t5.canonical.y, this.z = t5.canonical.z, this.grid = new Wn(oo, 16, 0), this.grid3D = new Wn(oo, 16, 0), this.featureIndexArray = new Ma(), this.promoteId = e4;
            };
            function Fc(t5, e4, r4, n4, i2) {
              return m2(t5, function(t6, a2) {
                var o2 = e4 instanceof zi ? e4.get(a2) : null;
                return o2 && o2.evaluate ? o2.evaluate(r4, n4, i2) : o2;
              });
            }
            function Bc(t5) {
              for (var e4 = 1 / 0, r4 = 1 / 0, n4 = -1 / 0, i2 = -1 / 0, a2 = 0, o2 = t5; a2 < o2.length; a2 += 1) {
                var s2 = o2[a2];
                e4 = Math.min(e4, s2.x), r4 = Math.min(r4, s2.y), n4 = Math.max(n4, s2.x), i2 = Math.max(i2, s2.y);
              }
              return { minX: e4, minY: r4, maxX: n4, maxY: i2 };
            }
            function Nc(t5, e4) {
              return e4 - t5;
            }
            Rc.prototype.insert = function(t5, e4, r4, n4, i2, a2) {
              var o2 = this.featureIndexArray.length;
              this.featureIndexArray.emplaceBack(r4, n4, i2);
              for (var s2 = a2 ? this.grid3D : this.grid, l2 = 0; l2 < e4.length; l2++) {
                for (var u2 = e4[l2], c2 = [1 / 0, 1 / 0, -1 / 0, -1 / 0], f3 = 0; f3 < u2.length; f3++) {
                  var h2 = u2[f3];
                  c2[0] = Math.min(c2[0], h2.x), c2[1] = Math.min(c2[1], h2.y), c2[2] = Math.max(c2[2], h2.x), c2[3] = Math.max(c2[3], h2.y);
                }
                c2[0] < oo && c2[1] < oo && c2[2] >= 0 && c2[3] >= 0 && s2.insert(o2, c2[0], c2[1], c2[2], c2[3]);
              }
            }, Rc.prototype.loadVTLayers = function() {
              return this.vtLayers || (this.vtLayers = new Zs.VectorTile(new Tl(this.rawTileData)).layers, this.sourceLayerCoder = new Oc(this.vtLayers ? Object.keys(this.vtLayers).sort() : ["_geojsonTileLayer"])), this.vtLayers;
            }, Rc.prototype.query = function(t5, e4, r4, n4) {
              var i2 = this;
              this.loadVTLayers();
              for (var o2 = t5.params || {}, s2 = oo / t5.tileSize / t5.scale, l2 = xn(o2.filter), u2 = t5.queryGeometry, c2 = t5.queryPadding * s2, f3 = Bc(u2), h2 = this.grid.query(f3.minX - c2, f3.minY - c2, f3.maxX + c2, f3.maxY + c2), p3 = Bc(t5.cameraQueryGeometry), d3 = 0, v2 = this.grid3D.query(p3.minX - c2, p3.minY - c2, p3.maxX + c2, p3.maxY + c2, function(e5, r5, n5, i3) {
                return function(t6, e6, r6, n6, i4) {
                  for (var o3 = 0, s3 = t6; o3 < s3.length; o3 += 1) {
                    var l3 = s3[o3];
                    if (e6 <= l3.x && r6 <= l3.y && n6 >= l3.x && i4 >= l3.y)
                      return true;
                  }
                  var u3 = [new a(e6, r6), new a(e6, i4), new a(n6, i4), new a(n6, r6)];
                  if (t6.length > 2) {
                    for (var c3 = 0, f4 = u3; c3 < f4.length; c3 += 1)
                      if (wo(t6, f4[c3]))
                        return true;
                  }
                  for (var h3 = 0; h3 < t6.length - 1; h3++)
                    if (To(t6[h3], t6[h3 + 1], u3))
                      return true;
                  return false;
                }(t5.cameraQueryGeometry, e5 - c2, r5 - c2, n5 + c2, i3 + c2);
              }); d3 < v2.length; d3 += 1) {
                var g3 = v2[d3];
                h2.push(g3);
              }
              h2.sort(Nc);
              for (var y2, m3 = {}, x2 = function(a2) {
                var c3 = h2[a2];
                if (c3 !== y2) {
                  y2 = c3;
                  var f4 = i2.featureIndexArray.get(c3), p4 = null;
                  i2.loadMatchingFeature(m3, f4.bucketIndex, f4.sourceLayerIndex, f4.featureIndex, l2, o2.layers, o2.availableImages, e4, r4, n4, function(e5, r5, n5) {
                    return p4 || (p4 = uo(e5)), r5.queryIntersectsFeature(u2, e5, n5, p4, i2.z, t5.transform, s2, t5.pixelPosMatrix);
                  });
                }
              }, b2 = 0; b2 < h2.length; b2++)
                x2(b2);
              return m3;
            }, Rc.prototype.loadMatchingFeature = function(t5, e4, r4, n4, i2, a2, o2, s2, l2, u2, c2) {
              var f3 = this.bucketLayerIDs[e4];
              if (!a2 || function(t6, e5) {
                for (var r5 = 0; r5 < t6.length; r5++)
                  if (e5.indexOf(t6[r5]) >= 0)
                    return true;
                return false;
              }(a2, f3)) {
                var h2 = this.sourceLayerCoder.decode(r4), p3 = this.vtLayers[h2].feature(n4);
                if (i2.filter(new Si(this.tileID.overscaledZ), p3))
                  for (var d3 = this.getId(p3, h2), v2 = 0; v2 < f3.length; v2++) {
                    var g3 = f3[v2];
                    if (!(a2 && a2.indexOf(g3) < 0)) {
                      var y2 = s2[g3];
                      if (y2) {
                        var m3 = {};
                        void 0 !== d3 && u2 && (m3 = u2.getState(y2.sourceLayer || "_geojsonTileLayer", d3));
                        var x2 = l2[g3];
                        x2.paint = Fc(x2.paint, y2.paint, p3, m3, o2), x2.layout = Fc(x2.layout, y2.layout, p3, m3, o2);
                        var b2 = !c2 || c2(p3, y2, m3);
                        if (b2) {
                          var _2 = new Ic(p3, this.z, this.x, this.y, d3);
                          _2.layer = x2;
                          var w3 = t5[g3];
                          void 0 === w3 && (w3 = t5[g3] = []), w3.push({ featureIndex: n4, feature: _2, intersectionZ: b2 });
                        }
                      }
                    }
                  }
              }
            }, Rc.prototype.lookupSymbolFeatures = function(t5, e4, r4, n4, i2, a2, o2, s2) {
              var l2 = {};
              this.loadVTLayers();
              for (var u2 = xn(i2), c2 = 0, f3 = t5; c2 < f3.length; c2 += 1) {
                var h2 = f3[c2];
                this.loadMatchingFeature(l2, r4, n4, h2, u2, a2, o2, s2, e4);
              }
              return l2;
            }, Rc.prototype.hasLayer = function(t5) {
              for (var e4 = 0, r4 = this.bucketLayerIDs; e4 < r4.length; e4 += 1)
                for (var n4 = 0, i2 = r4[e4]; n4 < i2.length; n4 += 1)
                  if (t5 === i2[n4])
                    return true;
              return false;
            }, Rc.prototype.getId = function(t5, e4) {
              var r4 = t5.id;
              if (this.promoteId) {
                var n4 = "string" == typeof this.promoteId ? this.promoteId : this.promoteId[e4];
                "boolean" == typeof (r4 = t5.properties[n4]) && (r4 = Number(r4));
              }
              return r4;
            }, Qn("FeatureIndex", Rc, { omit: ["rawTileData", "sourceLayerCoder"] });
            var jc = function(t5, e4) {
              this.tileID = t5, this.uid = p2(), this.uses = 0, this.tileSize = e4, this.buckets = {}, this.expirationTime = null, this.queryPadding = 0, this.hasSymbolBuckets = false, this.hasRTLText = false, this.dependencies = {}, this.expiredRequestCount = 0, this.state = "loading";
            };
            jc.prototype.registerFadeDuration = function(t5) {
              var e4 = t5 + this.timeAdded;
              e4 < F.now() || this.fadeEndTime && e4 < this.fadeEndTime || (this.fadeEndTime = e4);
            }, jc.prototype.wasRequested = function() {
              return "errored" === this.state || "loaded" === this.state || "reloading" === this.state;
            }, jc.prototype.loadVectorData = function(t5, e4, r4) {
              if (this.hasData() && this.unloadVectorData(), this.state = "loaded", t5) {
                for (var n4 in t5.featureIndex && (this.latestFeatureIndex = t5.featureIndex, t5.rawTileData ? (this.latestRawTileData = t5.rawTileData, this.latestFeatureIndex.rawTileData = t5.rawTileData) : this.latestRawTileData && (this.latestFeatureIndex.rawTileData = this.latestRawTileData)), this.collisionBoxArray = t5.collisionBoxArray, this.buckets = function(t6, e5) {
                  var r5 = {};
                  if (!e5)
                    return r5;
                  for (var n5 = function() {
                    var t7 = a3[i3], n6 = t7.layerIds.map(function(t8) {
                      return e5.getLayer(t8);
                    }).filter(Boolean);
                    if (0 !== n6.length) {
                      t7.layers = n6, t7.stateDependentLayerIds && (t7.stateDependentLayers = t7.stateDependentLayerIds.map(function(t8) {
                        return n6.filter(function(e6) {
                          return e6.id === t8;
                        })[0];
                      }));
                      for (var o3 = 0, s3 = n6; o3 < s3.length; o3 += 1) {
                        var l3 = s3[o3];
                        r5[l3.id] = t7;
                      }
                    }
                  }, i3 = 0, a3 = t6; i3 < a3.length; i3 += 1)
                    n5();
                  return r5;
                }(t5.buckets, e4.style), this.hasSymbolBuckets = false, this.buckets) {
                  var i2 = this.buckets[n4];
                  if (i2 instanceof Ku) {
                    if (this.hasSymbolBuckets = true, !r4)
                      break;
                    i2.justReloaded = true;
                  }
                }
                if (this.hasRTLText = false, this.hasSymbolBuckets)
                  for (var a2 in this.buckets) {
                    var o2 = this.buckets[a2];
                    if (o2 instanceof Ku && o2.hasRTLText) {
                      this.hasRTLText = true, Mi.isLoading() || Mi.isLoaded() || "deferred" !== ki() || Ai();
                      break;
                    }
                  }
                for (var s2 in this.queryPadding = 0, this.buckets) {
                  var l2 = this.buckets[s2];
                  this.queryPadding = Math.max(this.queryPadding, e4.style.getLayer(s2).queryRadius(l2));
                }
                t5.imageAtlas && (this.imageAtlas = t5.imageAtlas), t5.glyphAtlasImage && (this.glyphAtlasImage = t5.glyphAtlasImage);
              } else
                this.collisionBoxArray = new ma();
            }, jc.prototype.unloadVectorData = function() {
              for (var t5 in this.buckets)
                this.buckets[t5].destroy();
              this.buckets = {}, this.imageAtlasTexture && this.imageAtlasTexture.destroy(), this.imageAtlas && (this.imageAtlas = null), this.glyphAtlasTexture && this.glyphAtlasTexture.destroy(), this.latestFeatureIndex = null, this.state = "unloaded";
            }, jc.prototype.getBucket = function(t5) {
              return this.buckets[t5.id];
            }, jc.prototype.upload = function(t5) {
              for (var e4 in this.buckets) {
                var r4 = this.buckets[e4];
                r4.uploadPending() && r4.upload(t5);
              }
              var n4 = t5.gl;
              this.imageAtlas && !this.imageAtlas.uploaded && (this.imageAtlasTexture = new pc(t5, this.imageAtlas.image, n4.RGBA), this.imageAtlas.uploaded = true), this.glyphAtlasImage && (this.glyphAtlasTexture = new pc(t5, this.glyphAtlasImage, n4.ALPHA), this.glyphAtlasImage = null);
            }, jc.prototype.prepare = function(t5) {
              this.imageAtlas && this.imageAtlas.patchUpdatedImages(t5, this.imageAtlasTexture);
            }, jc.prototype.queryRenderedFeatures = function(t5, e4, r4, n4, i2, a2, o2, s2, l2, u2) {
              return this.latestFeatureIndex && this.latestFeatureIndex.rawTileData ? this.latestFeatureIndex.query({ queryGeometry: n4, cameraQueryGeometry: i2, scale: a2, tileSize: this.tileSize, pixelPosMatrix: u2, transform: s2, params: o2, queryPadding: this.queryPadding * l2 }, t5, e4, r4) : {};
            }, jc.prototype.querySourceFeatures = function(t5, e4) {
              var r4 = this.latestFeatureIndex;
              if (r4 && r4.rawTileData) {
                var n4 = r4.loadVTLayers(), i2 = e4 ? e4.sourceLayer : "", a2 = n4._geojsonTileLayer || n4[i2];
                if (a2)
                  for (var o2 = xn(e4 && e4.filter), s2 = this.tileID.canonical, l2 = s2.z, u2 = s2.x, c2 = s2.y, f3 = { z: l2, x: u2, y: c2 }, h2 = 0; h2 < a2.length; h2++) {
                    var p3 = a2.feature(h2);
                    if (o2.filter(new Si(this.tileID.overscaledZ), p3)) {
                      var d3 = r4.getId(p3, i2), v2 = new Ic(p3, l2, u2, c2, d3);
                      v2.tile = f3, t5.push(v2);
                    }
                  }
              }
            }, jc.prototype.hasData = function() {
              return "loaded" === this.state || "reloading" === this.state || "expired" === this.state;
            }, jc.prototype.patternsLoaded = function() {
              return this.imageAtlas && !!Object.keys(this.imageAtlas.patternPositions).length;
            }, jc.prototype.setExpiryData = function(t5) {
              var e4 = this.expirationTime;
              if (t5.cacheControl) {
                var r4 = M(t5.cacheControl);
                r4["max-age"] && (this.expirationTime = Date.now() + 1e3 * r4["max-age"]);
              } else
                t5.expires && (this.expirationTime = new Date(t5.expires).getTime());
              if (this.expirationTime) {
                var n4 = Date.now(), i2 = false;
                if (this.expirationTime > n4)
                  i2 = false;
                else if (e4)
                  if (this.expirationTime < e4)
                    i2 = true;
                  else {
                    var a2 = this.expirationTime - e4;
                    a2 ? this.expirationTime = n4 + Math.max(a2, 3e4) : i2 = true;
                  }
                else
                  i2 = true;
                i2 ? (this.expiredRequestCount++, this.state = "expired") : this.expiredRequestCount = 0;
              }
            }, jc.prototype.getExpiryTimeout = function() {
              if (this.expirationTime)
                return this.expiredRequestCount ? 1e3 * (1 << Math.min(this.expiredRequestCount - 1, 31)) : Math.min(this.expirationTime - new Date().getTime(), Math.pow(2, 31) - 1);
            }, jc.prototype.setFeatureState = function(t5, e4) {
              if (this.latestFeatureIndex && this.latestFeatureIndex.rawTileData && 0 !== Object.keys(t5).length) {
                var r4 = this.latestFeatureIndex.loadVTLayers();
                for (var n4 in this.buckets)
                  if (e4.style.hasLayer(n4)) {
                    var i2 = this.buckets[n4], a2 = i2.layers[0].sourceLayer || "_geojsonTileLayer", o2 = r4[a2], s2 = t5[a2];
                    if (o2 && s2 && 0 !== Object.keys(s2).length) {
                      i2.update(s2, o2, this.imageAtlas && this.imageAtlas.patternPositions || {});
                      var l2 = e4 && e4.style && e4.style.getLayer(n4);
                      l2 && (this.queryPadding = Math.max(this.queryPadding, l2.queryRadius(i2)));
                    }
                  }
              }
            }, jc.prototype.holdingForFade = function() {
              return void 0 !== this.symbolFadeHoldUntil;
            }, jc.prototype.symbolFadeFinished = function() {
              return !this.symbolFadeHoldUntil || this.symbolFadeHoldUntil < F.now();
            }, jc.prototype.clearFadeHold = function() {
              this.symbolFadeHoldUntil = void 0;
            }, jc.prototype.setHoldDuration = function(t5) {
              this.symbolFadeHoldUntil = F.now() + t5;
            }, jc.prototype.setDependencies = function(t5, e4) {
              for (var r4 = {}, n4 = 0, i2 = e4; n4 < i2.length; n4 += 1)
                r4[i2[n4]] = true;
              this.dependencies[t5] = r4;
            }, jc.prototype.hasDependency = function(t5, e4) {
              for (var r4 = 0, n4 = t5; r4 < n4.length; r4 += 1) {
                var i2 = n4[r4], a2 = this.dependencies[i2];
                if (a2) {
                  for (var o2 = 0, s2 = e4; o2 < s2.length; o2 += 1)
                    if (a2[s2[o2]])
                      return true;
                }
              }
              return false;
            };
            var Uc = self.performance, Vc = function(t5) {
              this._marks = { start: [t5.url, "start"].join("#"), end: [t5.url, "end"].join("#"), measure: t5.url.toString() }, Uc.mark(this._marks.start);
            };
            Vc.prototype.finish = function() {
              Uc.mark(this._marks.end);
              var t5 = Uc.getEntriesByName(this._marks.measure);
              return 0 === t5.length && (Uc.measure(this._marks.measure, this._marks.start, this._marks.end), t5 = Uc.getEntriesByName(this._marks.measure), Uc.clearMarks(this._marks.start), Uc.clearMarks(this._marks.end), Uc.clearMeasures(this._marks.measure)), t5;
            }, t4.Actor = vc, t4.AlphaImage = Ho, t4.CanonicalTileID = Sc, t4.CollisionBoxArray = ma, t4.Color = ae, t4.DEMData = Pc, t4.DataConstantProperty = Ri, t4.DictionaryCoder = Oc, t4.EXTENT = oo, t4.ErrorEvent = Pt, t4.EvaluationParameters = Si, t4.Event = Ct, t4.Evented = Ot, t4.FeatureIndex = Rc, t4.FillBucket = Is, t4.FillExtrusionBucket = Js, t4.ImageAtlas = Xl, t4.ImagePosition = Yl, t4.LineBucket = ol, t4.LngLat = xc, t4.LngLatBounds = yc, t4.MercatorCoordinate = Mc, t4.ONE_EM = bl, t4.OverscaledTileID = Lc, t4.Point = a, t4.Point$1 = a, t4.Properties = Ui, t4.Protobuf = Tl, t4.RGBAImage = qo, t4.RequestManager = q2, t4.RequestPerformance = Vc, t4.ResourceType = mt, t4.SegmentVector = Ea, t4.SourceFeatureState = zc, t4.StructArrayLayout1ui2 = da, t4.StructArrayLayout2f1f2i16 = aa, t4.StructArrayLayout2i4 = Xi, t4.StructArrayLayout3ui6 = sa, t4.StructArrayLayout4i8 = Ji, t4.SymbolBucket = Ku, t4.Texture = pc, t4.Tile = jc, t4.Transitionable = Ci, t4.Uniform1f = Ha, t4.Uniform1i = Va, t4.Uniform2f = qa, t4.Uniform3f = Ga, t4.Uniform4f = Za, t4.UniformColor = Ya, t4.UniformMatrix4f = Xa, t4.UnwrappedTileID = Ec, t4.ValidationError = Dt, t4.WritingMode = Jl, t4.ZoomHistory = ai, t4.add = function(t5, e4, r4) {
              return t5[0] = e4[0] + r4[0], t5[1] = e4[1] + r4[1], t5[2] = e4[2] + r4[2], t5;
            }, t4.addDynamicAttributes = Yu, t4.asyncAll = function(t5, e4, r4) {
              if (!t5.length)
                return r4(null, []);
              var n4 = t5.length, i2 = new Array(t5.length), a2 = null;
              t5.forEach(function(t6, o2) {
                e4(t6, function(t7, e5) {
                  t7 && (a2 = t7), i2[o2] = e5, 0 == --n4 && r4(a2, i2);
                });
              });
            }, t4.bezier = s, t4.bindAll = g2, t4.browser = F, t4.cacheEntryPossiblyAdded = function(t5) {
              ++gt > ct && (t5.getActor().send("enforceCacheSizeLimit", ut), gt = 0);
            }, t4.clamp = u, t4.clearTileCache = function(t5) {
              var e4 = self.caches.delete(lt);
              t5 && e4.catch(t5).then(function() {
                return t5();
              });
            }, t4.clipLine = Au, t4.clone = function(t5) {
              var e4 = new Lo(16);
              return e4[0] = t5[0], e4[1] = t5[1], e4[2] = t5[2], e4[3] = t5[3], e4[4] = t5[4], e4[5] = t5[5], e4[6] = t5[6], e4[7] = t5[7], e4[8] = t5[8], e4[9] = t5[9], e4[10] = t5[10], e4[11] = t5[11], e4[12] = t5[12], e4[13] = t5[13], e4[14] = t5[14], e4[15] = t5[15], e4;
            }, t4.clone$1 = b, t4.clone$2 = function(t5) {
              var e4 = new Lo(3);
              return e4[0] = t5[0], e4[1] = t5[1], e4[2] = t5[2], e4;
            }, t4.collisionCircleLayout = yl, t4.config = B, t4.create = function() {
              var t5 = new Lo(16);
              return Lo != Float32Array && (t5[1] = 0, t5[2] = 0, t5[3] = 0, t5[4] = 0, t5[6] = 0, t5[7] = 0, t5[8] = 0, t5[9] = 0, t5[11] = 0, t5[12] = 0, t5[13] = 0, t5[14] = 0), t5[0] = 1, t5[5] = 1, t5[10] = 1, t5[15] = 1, t5;
            }, t4.create$1 = function() {
              var t5 = new Lo(9);
              return Lo != Float32Array && (t5[1] = 0, t5[2] = 0, t5[3] = 0, t5[5] = 0, t5[6] = 0, t5[7] = 0), t5[0] = 1, t5[4] = 1, t5[8] = 1, t5;
            }, t4.create$2 = function() {
              var t5 = new Lo(4);
              return Lo != Float32Array && (t5[1] = 0, t5[2] = 0), t5[0] = 1, t5[3] = 1, t5;
            }, t4.createCommonjsModule = e3, t4.createExpression = an, t4.createLayout = Yi, t4.createStyleLayer = function(t5) {
              return "custom" === t5.type ? new oc(t5) : new sc[t5.type](t5);
            }, t4.cross = function(t5, e4, r4) {
              var n4 = e4[0], i2 = e4[1], a2 = e4[2], o2 = r4[0], s2 = r4[1], l2 = r4[2];
              return t5[0] = i2 * l2 - a2 * s2, t5[1] = a2 * o2 - n4 * l2, t5[2] = n4 * s2 - i2 * o2, t5;
            }, t4.deepEqual = function t5(e4, r4) {
              if (Array.isArray(e4)) {
                if (!Array.isArray(r4) || e4.length !== r4.length)
                  return false;
                for (var n4 = 0; n4 < e4.length; n4++)
                  if (!t5(e4[n4], r4[n4]))
                    return false;
                return true;
              }
              if ("object" == typeof e4 && null !== e4 && null !== r4) {
                if ("object" != typeof r4)
                  return false;
                if (Object.keys(e4).length !== Object.keys(r4).length)
                  return false;
                for (var i2 in e4)
                  if (!t5(e4[i2], r4[i2]))
                    return false;
                return true;
              }
              return e4 === r4;
            }, t4.dot = function(t5, e4) {
              return t5[0] * e4[0] + t5[1] * e4[1] + t5[2] * e4[2];
            }, t4.dot$1 = function(t5, e4) {
              return t5[0] * e4[0] + t5[1] * e4[1] + t5[2] * e4[2] + t5[3] * e4[3];
            }, t4.ease = l, t4.emitValidationErrors = Yn, t4.endsWith = y, t4.enforceCacheSizeLimit = function(t5) {
              ft(), tt && tt.then(function(e4) {
                e4.keys().then(function(r4) {
                  for (var n4 = 0; n4 < r4.length - t5; n4++)
                    e4.delete(r4[n4]);
                });
              });
            }, t4.evaluateSizeForFeature = vu, t4.evaluateSizeForZoom = gu, t4.evaluateVariableOffset = Bu, t4.evented = Ti, t4.extend = f2, t4.featureFilter = xn, t4.filterObject = x, t4.fromRotation = function(t5, e4) {
              var r4 = Math.sin(e4), n4 = Math.cos(e4);
              return t5[0] = n4, t5[1] = r4, t5[2] = 0, t5[3] = -r4, t5[4] = n4, t5[5] = 0, t5[6] = 0, t5[7] = 0, t5[8] = 1, t5;
            }, t4.getAnchorAlignment = uu, t4.getAnchorJustification = Nu, t4.getArrayBuffer = Tt, t4.getImage = St, t4.getJSON = function(t5, e4) {
              return wt(f2(t5, { type: "json" }), e4);
            }, t4.getRTLTextPluginStatus = ki, t4.getReferrer = bt, t4.getVideo = function(t5, e4) {
              var r4, n4, i2 = self.document.createElement("video");
              i2.muted = true, i2.onloadstart = function() {
                e4(null, i2);
              };
              for (var a2 = 0; a2 < t5.length; a2++) {
                var o2 = self.document.createElement("source");
                r4 = t5[a2], n4 = void 0, (n4 = self.document.createElement("a")).href = r4, n4.protocol === self.document.location.protocol && n4.host === self.document.location.host || (i2.crossOrigin = "Anonymous"), o2.src = t5[a2], i2.appendChild(o2);
              }
              return { cancel: function() {
              } };
            }, t4.identity = Co, t4.invert = function(t5, e4) {
              var r4 = e4[0], n4 = e4[1], i2 = e4[2], a2 = e4[3], o2 = e4[4], s2 = e4[5], l2 = e4[6], u2 = e4[7], c2 = e4[8], f3 = e4[9], h2 = e4[10], p3 = e4[11], d3 = e4[12], v2 = e4[13], g3 = e4[14], y2 = e4[15], m3 = r4 * s2 - n4 * o2, x2 = r4 * l2 - i2 * o2, b2 = r4 * u2 - a2 * o2, _2 = n4 * l2 - i2 * s2, w3 = n4 * u2 - a2 * s2, T2 = i2 * u2 - a2 * l2, k2 = c2 * v2 - f3 * d3, A2 = c2 * g3 - h2 * d3, M2 = c2 * y2 - p3 * d3, S2 = f3 * g3 - h2 * v2, E2 = f3 * y2 - p3 * v2, L2 = h2 * y2 - p3 * g3, C2 = m3 * L2 - x2 * E2 + b2 * S2 + _2 * M2 - w3 * A2 + T2 * k2;
              return C2 ? (C2 = 1 / C2, t5[0] = (s2 * L2 - l2 * E2 + u2 * S2) * C2, t5[1] = (i2 * E2 - n4 * L2 - a2 * S2) * C2, t5[2] = (v2 * T2 - g3 * w3 + y2 * _2) * C2, t5[3] = (h2 * w3 - f3 * T2 - p3 * _2) * C2, t5[4] = (l2 * M2 - o2 * L2 - u2 * A2) * C2, t5[5] = (r4 * L2 - i2 * M2 + a2 * A2) * C2, t5[6] = (g3 * b2 - d3 * T2 - y2 * x2) * C2, t5[7] = (c2 * T2 - h2 * b2 + p3 * x2) * C2, t5[8] = (o2 * E2 - s2 * M2 + u2 * k2) * C2, t5[9] = (n4 * M2 - r4 * E2 - a2 * k2) * C2, t5[10] = (d3 * w3 - v2 * b2 + y2 * m3) * C2, t5[11] = (f3 * b2 - c2 * w3 - p3 * m3) * C2, t5[12] = (s2 * A2 - o2 * S2 - l2 * k2) * C2, t5[13] = (r4 * S2 - n4 * A2 + i2 * k2) * C2, t5[14] = (v2 * x2 - d3 * _2 - g3 * m3) * C2, t5[15] = (c2 * _2 - f3 * x2 + h2 * m3) * C2, t5) : null;
            }, t4.isChar = oi, t4.isMapboxURL = G, t4.keysDifference = function(t5, e4) {
              var r4 = [];
              for (var n4 in t5)
                n4 in e4 || r4.push(n4);
              return r4;
            }, t4.makeRequest = wt, t4.mapObject = m2, t4.mercatorXfromLng = wc, t4.mercatorYfromLat = Tc, t4.mercatorZfromAltitude = kc, t4.mul = Oo, t4.multiply = Po, t4.mvt = Zs, t4.normalize = function(t5, e4) {
              var r4 = e4[0], n4 = e4[1], i2 = e4[2], a2 = r4 * r4 + n4 * n4 + i2 * i2;
              return a2 > 0 && (a2 = 1 / Math.sqrt(a2)), t5[0] = e4[0] * a2, t5[1] = e4[1] * a2, t5[2] = e4[2] * a2, t5;
            }, t4.number = Ke, t4.offscreenCanvasSupported = yt, t4.ortho = function(t5, e4, r4, n4, i2, a2, o2) {
              var s2 = 1 / (e4 - r4), l2 = 1 / (n4 - i2), u2 = 1 / (a2 - o2);
              return t5[0] = -2 * s2, t5[1] = 0, t5[2] = 0, t5[3] = 0, t5[4] = 0, t5[5] = -2 * l2, t5[6] = 0, t5[7] = 0, t5[8] = 0, t5[9] = 0, t5[10] = 2 * u2, t5[11] = 0, t5[12] = (e4 + r4) * s2, t5[13] = (i2 + n4) * l2, t5[14] = (o2 + a2) * u2, t5[15] = 1, t5;
            }, t4.parseGlyphPBF = function(t5) {
              return new Tl(t5).readFields(Hl, []);
            }, t4.pbf = Tl, t4.performSymbolLayout = function(t5, e4, r4, n4, i2, a2, o2) {
              t5.createArrays();
              var s2 = 512 * t5.overscaling;
              t5.tilePixelRatio = oo / s2, t5.compareText = {}, t5.iconsNeedLinear = false;
              var l2 = t5.layers[0].layout, u2 = t5.layers[0]._unevaluatedLayout._values, c2 = {};
              if ("composite" === t5.textSizeData.kind) {
                var f3 = t5.textSizeData, h2 = f3.minZoom, p3 = f3.maxZoom;
                c2.compositeTextSizes = [u2["text-size"].possiblyEvaluate(new Si(h2), o2), u2["text-size"].possiblyEvaluate(new Si(p3), o2)];
              }
              if ("composite" === t5.iconSizeData.kind) {
                var d3 = t5.iconSizeData, v2 = d3.minZoom, g3 = d3.maxZoom;
                c2.compositeIconSizes = [u2["icon-size"].possiblyEvaluate(new Si(v2), o2), u2["icon-size"].possiblyEvaluate(new Si(g3), o2)];
              }
              c2.layoutTextSize = u2["text-size"].possiblyEvaluate(new Si(t5.zoom + 1), o2), c2.layoutIconSize = u2["icon-size"].possiblyEvaluate(new Si(t5.zoom + 1), o2), c2.textMaxSize = u2["text-size"].possiblyEvaluate(new Si(18));
              for (var y2 = l2.get("text-line-height") * bl, m3 = "map" === l2.get("text-rotation-alignment") && "point" !== l2.get("symbol-placement"), x2 = l2.get("text-keep-upright"), b2 = l2.get("text-size"), _2 = function() {
                var a3 = k2[T2], s3 = l2.get("text-font").evaluate(a3, {}, o2).join(","), u3 = b2.evaluate(a3, {}, o2), f4 = c2.layoutTextSize.evaluate(a3, {}, o2), h3 = c2.layoutIconSize.evaluate(a3, {}, o2), p4 = { horizontal: {}, vertical: void 0 }, d4 = a3.text, v3 = [0, 0];
                if (d4) {
                  var g4 = d4.toString(), _3 = l2.get("text-letter-spacing").evaluate(a3, {}, o2) * bl, A2 = function(t6) {
                    for (var e5 = 0, r5 = t6; e5 < r5.length; e5 += 1)
                      if (n5 = r5[e5].charCodeAt(0), oi.Arabic(n5) || oi["Arabic Supplement"](n5) || oi["Arabic Extended-A"](n5) || oi["Arabic Presentation Forms-A"](n5) || oi["Arabic Presentation Forms-B"](n5))
                        return false;
                    var n5;
                    return true;
                  }(g4) ? _3 : 0, M2 = l2.get("text-anchor").evaluate(a3, {}, o2), S2 = l2.get("text-variable-anchor");
                  if (!S2) {
                    var E2 = l2.get("text-radial-offset").evaluate(a3, {}, o2);
                    v3 = E2 ? Bu(M2, [E2 * bl, Fu]) : l2.get("text-offset").evaluate(a3, {}, o2).map(function(t6) {
                      return t6 * bl;
                    });
                  }
                  var L2 = m3 ? "center" : l2.get("text-justify").evaluate(a3, {}, o2), C2 = l2.get("symbol-placement"), P2 = "point" === C2 ? l2.get("text-max-width").evaluate(a3, {}, o2) * bl : 0, O2 = function() {
                    t5.allowVerticalPlacement && si(g4) && (p4.vertical = tu(d4, e4, r4, i2, s3, P2, y2, M2, "left", A2, v3, Jl.vertical, true, C2, f4, u3));
                  };
                  if (!m3 && S2) {
                    for (var I2 = "auto" === L2 ? S2.map(function(t6) {
                      return Nu(t6);
                    }) : [L2], D2 = false, z2 = 0; z2 < I2.length; z2++) {
                      var R2 = I2[z2];
                      if (!p4.horizontal[R2])
                        if (D2)
                          p4.horizontal[R2] = p4.horizontal[0];
                        else {
                          var F2 = tu(d4, e4, r4, i2, s3, P2, y2, "center", R2, A2, v3, Jl.horizontal, false, C2, f4, u3);
                          F2 && (p4.horizontal[R2] = F2, D2 = 1 === F2.positionedLines.length);
                        }
                    }
                    O2();
                  } else {
                    "auto" === L2 && (L2 = Nu(M2));
                    var B2 = tu(d4, e4, r4, i2, s3, P2, y2, M2, L2, A2, v3, Jl.horizontal, false, C2, f4, u3);
                    B2 && (p4.horizontal[L2] = B2), O2(), si(g4) && m3 && x2 && (p4.vertical = tu(d4, e4, r4, i2, s3, P2, y2, M2, L2, A2, v3, Jl.vertical, false, C2, f4, u3));
                  }
                }
                var N2 = void 0, j2 = false;
                if (a3.icon && a3.icon.name) {
                  var U2 = n4[a3.icon.name];
                  U2 && (N2 = function(t6, e5, r5) {
                    var n5 = uu(r5), i3 = n5.horizontalAlign, a4 = n5.verticalAlign, o3 = e5[0], s4 = e5[1], l3 = o3 - t6.displaySize[0] * i3, u4 = l3 + t6.displaySize[0], c3 = s4 - t6.displaySize[1] * a4;
                    return { image: t6, top: c3, bottom: c3 + t6.displaySize[1], left: l3, right: u4 };
                  }(i2[a3.icon.name], l2.get("icon-offset").evaluate(a3, {}, o2), l2.get("icon-anchor").evaluate(a3, {}, o2)), j2 = U2.sdf, void 0 === t5.sdfIcons ? t5.sdfIcons = U2.sdf : t5.sdfIcons !== U2.sdf && w2("Style sheet warning: Cannot mix SDF and non-SDF icons in one buffer"), (U2.pixelRatio !== t5.pixelRatio || 0 !== l2.get("icon-rotate").constantOr(1)) && (t5.iconsNeedLinear = true));
                }
                var V2 = Vu(p4.horizontal) || p4.vertical;
                t5.iconsInText = !!V2 && V2.iconsInText, (V2 || N2) && function(t6, e5, r5, n5, i3, a4, o3, s4, l3, u4, c3) {
                  var f5 = a4.textMaxSize.evaluate(e5, {});
                  void 0 === f5 && (f5 = o3);
                  var h4, p5 = t6.layers[0].layout, d5 = p5.get("icon-offset").evaluate(e5, {}, c3), v4 = Vu(r5.horizontal), g5 = 24, y3 = o3 / g5, m4 = t6.tilePixelRatio * y3, x3 = t6.tilePixelRatio * f5 / g5, b3 = t6.tilePixelRatio * s4, _4 = t6.tilePixelRatio * p5.get("symbol-spacing"), T3 = p5.get("text-padding") * t6.tilePixelRatio, k3 = p5.get("icon-padding") * t6.tilePixelRatio, A3 = p5.get("text-max-angle") / 180 * Math.PI, M3 = "map" === p5.get("text-rotation-alignment") && "point" !== p5.get("symbol-placement"), S3 = "map" === p5.get("icon-rotation-alignment") && "point" !== p5.get("symbol-placement"), E3 = p5.get("symbol-placement"), L3 = _4 / 2, C3 = p5.get("icon-text-fit");
                  n5 && "none" !== C3 && (t6.allowVerticalPlacement && r5.vertical && (h4 = fu(n5, r5.vertical, C3, p5.get("icon-text-fit-padding"), d5, y3)), v4 && (n5 = fu(n5, v4, C3, p5.get("icon-text-fit-padding"), d5, y3)));
                  var P3 = function(s5, f6) {
                    f6.x < 0 || f6.x >= oo || f6.y < 0 || f6.y >= oo || function(t7, e6, r6, n6, i4, a5, o4, s6, l4, u5, c4, f7, h5, p6, d6, v5, g6, y4, m5, x4, b4, _5, T4, k4, A4) {
                      var M4, S4, E4, L4, C4, P4 = t7.addToLineVertexArray(e6, r6), O4 = 0, I4 = 0, D4 = 0, z4 = 0, R4 = -1, F4 = -1, B4 = {}, N4 = Ia(""), j4 = 0, U4 = 0;
                      if (void 0 === s6._unevaluatedLayout.getValue("text-radial-offset") ? (j4 = (M4 = s6.layout.get("text-offset").evaluate(b4, {}, k4).map(function(t8) {
                        return t8 * bl;
                      }))[0], U4 = M4[1]) : (j4 = s6.layout.get("text-radial-offset").evaluate(b4, {}, k4) * bl, U4 = Fu), t7.allowVerticalPlacement && n6.vertical) {
                        var V4 = s6.layout.get("text-rotate").evaluate(b4, {}, k4) + 90, H3 = n6.vertical;
                        L4 = new Pu(l4, e6, u5, c4, f7, H3, h5, p6, d6, V4), o4 && (C4 = new Pu(l4, e6, u5, c4, f7, o4, g6, y4, d6, V4));
                      }
                      if (i4) {
                        var q4 = s6.layout.get("icon-rotate").evaluate(b4, {}), G3 = "none" !== s6.layout.get("icon-text-fit"), Z3 = Mu(i4, q4, T4, G3), Y3 = o4 ? Mu(o4, q4, T4, G3) : void 0;
                        E4 = new Pu(l4, e6, u5, c4, f7, i4, g6, y4, false, q4), O4 = 4 * Z3.length;
                        var W3 = t7.iconSizeData, X3 = null;
                        "source" === W3.kind ? (X3 = [pu * s6.layout.get("icon-size").evaluate(b4, {})])[0] > ju && w2(t7.layerIds[0] + ': Value for "icon-size" is >= 255. Reduce your "icon-size".') : "composite" === W3.kind && ((X3 = [pu * _5.compositeIconSizes[0].evaluate(b4, {}, k4), pu * _5.compositeIconSizes[1].evaluate(b4, {}, k4)])[0] > ju || X3[1] > ju) && w2(t7.layerIds[0] + ': Value for "icon-size" is >= 255. Reduce your "icon-size".'), t7.addSymbols(t7.icon, Z3, X3, x4, m5, b4, false, e6, P4.lineStartIndex, P4.lineLength, -1, k4), R4 = t7.icon.placedSymbolArray.length - 1, Y3 && (I4 = 4 * Y3.length, t7.addSymbols(t7.icon, Y3, X3, x4, m5, b4, Jl.vertical, e6, P4.lineStartIndex, P4.lineLength, -1, k4), F4 = t7.icon.placedSymbolArray.length - 1);
                      }
                      for (var J3 in n6.horizontal) {
                        var K3 = n6.horizontal[J3];
                        if (!S4) {
                          N4 = Ia(K3.text);
                          var $3 = s6.layout.get("text-rotate").evaluate(b4, {}, k4);
                          S4 = new Pu(l4, e6, u5, c4, f7, K3, h5, p6, d6, $3);
                        }
                        var Q3 = 1 === K3.positionedLines.length;
                        if (D4 += Uu(t7, e6, K3, a5, s6, d6, b4, v5, P4, n6.vertical ? Jl.horizontal : Jl.horizontalOnly, Q3 ? Object.keys(n6.horizontal) : [J3], B4, R4, _5, k4), Q3)
                          break;
                      }
                      n6.vertical && (z4 += Uu(t7, e6, n6.vertical, a5, s6, d6, b4, v5, P4, Jl.vertical, ["vertical"], B4, F4, _5, k4));
                      var tt2 = S4 ? S4.boxStartIndex : t7.collisionBoxArray.length, et2 = S4 ? S4.boxEndIndex : t7.collisionBoxArray.length, rt2 = L4 ? L4.boxStartIndex : t7.collisionBoxArray.length, nt2 = L4 ? L4.boxEndIndex : t7.collisionBoxArray.length, it2 = E4 ? E4.boxStartIndex : t7.collisionBoxArray.length, at2 = E4 ? E4.boxEndIndex : t7.collisionBoxArray.length, ot2 = C4 ? C4.boxStartIndex : t7.collisionBoxArray.length, st2 = C4 ? C4.boxEndIndex : t7.collisionBoxArray.length, lt2 = -1, ut2 = function(t8, e7) {
                        return t8 && t8.circleDiameter ? Math.max(t8.circleDiameter, e7) : e7;
                      };
                      lt2 = ut2(S4, lt2), lt2 = ut2(L4, lt2), lt2 = ut2(E4, lt2);
                      var ct2 = (lt2 = ut2(C4, lt2)) > -1 ? 1 : 0;
                      ct2 && (lt2 *= A4 / bl), t7.glyphOffsetArray.length >= Ku.MAX_GLYPHS && w2("Too many glyphs being rendered in a tile. See https://github.com/mapbox/mapbox-gl-js/issues/2907"), void 0 !== b4.sortKey && t7.addToSortKeyRanges(t7.symbolInstances.length, b4.sortKey), t7.symbolInstances.emplaceBack(e6.x, e6.y, B4.right >= 0 ? B4.right : -1, B4.center >= 0 ? B4.center : -1, B4.left >= 0 ? B4.left : -1, B4.vertical || -1, R4, F4, N4, tt2, et2, rt2, nt2, it2, at2, ot2, st2, u5, D4, z4, O4, I4, ct2, 0, h5, j4, U4, lt2);
                    }(t6, f6, s5, r5, n5, i3, h4, t6.layers[0], t6.collisionBoxArray, e5.index, e5.sourceLayerIndex, t6.index, m4, T3, M3, l3, b3, k3, S3, d5, e5, a4, u4, c3, o3);
                  };
                  if ("line" === E3)
                    for (var O3 = 0, I3 = Au(e5.geometry, 0, 0, oo, oo); O3 < I3.length; O3 += 1)
                      for (var D3 = I3[O3], z3 = 0, R3 = Tu(D3, _4, A3, r5.vertical || v4, n5, g5, x3, t6.overscaling, oo); z3 < R3.length; z3 += 1) {
                        var F3 = R3[z3];
                        v4 && Hu(t6, v4.text, L3, F3) || P3(D3, F3);
                      }
                  else if ("line-center" === E3)
                    for (var B3 = 0, N3 = e5.geometry; B3 < N3.length; B3 += 1) {
                      var j3 = N3[B3];
                      if (j3.length > 1) {
                        var U3 = wu(j3, A3, r5.vertical || v4, n5, g5, x3);
                        U3 && P3(j3, U3);
                      }
                    }
                  else if ("Polygon" === e5.type)
                    for (var V3 = 0, H2 = Ls(e5.geometry, 0); V3 < H2.length; V3 += 1) {
                      var q3 = H2[V3], G2 = Du(q3, 16);
                      P3(q3[0], new hu(G2.x, G2.y, 0));
                    }
                  else if ("LineString" === e5.type)
                    for (var Z2 = 0, Y2 = e5.geometry; Z2 < Y2.length; Z2 += 1) {
                      var W2 = Y2[Z2];
                      P3(W2, new hu(W2[0].x, W2[0].y, 0));
                    }
                  else if ("Point" === e5.type)
                    for (var X2 = 0, J2 = e5.geometry; X2 < J2.length; X2 += 1)
                      for (var K2 = 0, $2 = J2[X2]; K2 < $2.length; K2 += 1) {
                        var Q2 = $2[K2];
                        P3([Q2], new hu(Q2.x, Q2.y, 0));
                      }
                }(t5, a3, p4, N2, n4, c2, f4, h3, v3, j2, o2);
              }, T2 = 0, k2 = t5.features; T2 < k2.length; T2 += 1)
                _2();
              a2 && t5.generateCollisionDebugBuffers();
            }, t4.perspective = function(t5, e4, r4, n4, i2) {
              var a2, o2 = 1 / Math.tan(e4 / 2);
              return t5[0] = o2 / r4, t5[1] = 0, t5[2] = 0, t5[3] = 0, t5[4] = 0, t5[5] = o2, t5[6] = 0, t5[7] = 0, t5[8] = 0, t5[9] = 0, t5[11] = -1, t5[12] = 0, t5[13] = 0, t5[15] = 0, null != i2 && i2 !== 1 / 0 ? (a2 = 1 / (n4 - i2), t5[10] = (i2 + n4) * a2, t5[14] = 2 * i2 * n4 * a2) : (t5[10] = -1, t5[14] = -2 * n4), t5;
            }, t4.pick = function(t5, e4) {
              for (var r4 = {}, n4 = 0; n4 < e4.length; n4++) {
                var i2 = e4[n4];
                i2 in t5 && (r4[i2] = t5[i2]);
              }
              return r4;
            }, t4.plugin = Mi, t4.polygonIntersectsPolygon = ho, t4.postMapLoadEvent = st, t4.postTurnstileEvent = at, t4.potpack = Zl, t4.refProperties = ["type", "source", "source-layer", "minzoom", "maxzoom", "filter", "layout"], t4.register = Qn, t4.registerForPluginStateChange = function(t5) {
              return t5({ pluginStatus: xi, pluginURL: bi }), Ti.on("pluginStateChange", t5), t5;
            }, t4.rotate = function(t5, e4, r4) {
              var n4 = e4[0], i2 = e4[1], a2 = e4[2], o2 = e4[3], s2 = Math.sin(r4), l2 = Math.cos(r4);
              return t5[0] = n4 * l2 + a2 * s2, t5[1] = i2 * l2 + o2 * s2, t5[2] = n4 * -s2 + a2 * l2, t5[3] = i2 * -s2 + o2 * l2, t5;
            }, t4.rotateX = function(t5, e4, r4) {
              var n4 = Math.sin(r4), i2 = Math.cos(r4), a2 = e4[4], o2 = e4[5], s2 = e4[6], l2 = e4[7], u2 = e4[8], c2 = e4[9], f3 = e4[10], h2 = e4[11];
              return e4 !== t5 && (t5[0] = e4[0], t5[1] = e4[1], t5[2] = e4[2], t5[3] = e4[3], t5[12] = e4[12], t5[13] = e4[13], t5[14] = e4[14], t5[15] = e4[15]), t5[4] = a2 * i2 + u2 * n4, t5[5] = o2 * i2 + c2 * n4, t5[6] = s2 * i2 + f3 * n4, t5[7] = l2 * i2 + h2 * n4, t5[8] = u2 * i2 - a2 * n4, t5[9] = c2 * i2 - o2 * n4, t5[10] = f3 * i2 - s2 * n4, t5[11] = h2 * i2 - l2 * n4, t5;
            }, t4.rotateZ = function(t5, e4, r4) {
              var n4 = Math.sin(r4), i2 = Math.cos(r4), a2 = e4[0], o2 = e4[1], s2 = e4[2], l2 = e4[3], u2 = e4[4], c2 = e4[5], f3 = e4[6], h2 = e4[7];
              return e4 !== t5 && (t5[8] = e4[8], t5[9] = e4[9], t5[10] = e4[10], t5[11] = e4[11], t5[12] = e4[12], t5[13] = e4[13], t5[14] = e4[14], t5[15] = e4[15]), t5[0] = a2 * i2 + u2 * n4, t5[1] = o2 * i2 + c2 * n4, t5[2] = s2 * i2 + f3 * n4, t5[3] = l2 * i2 + h2 * n4, t5[4] = u2 * i2 - a2 * n4, t5[5] = c2 * i2 - o2 * n4, t5[6] = f3 * i2 - s2 * n4, t5[7] = h2 * i2 - l2 * n4, t5;
            }, t4.scale = function(t5, e4, r4) {
              var n4 = r4[0], i2 = r4[1], a2 = r4[2];
              return t5[0] = e4[0] * n4, t5[1] = e4[1] * n4, t5[2] = e4[2] * n4, t5[3] = e4[3] * n4, t5[4] = e4[4] * i2, t5[5] = e4[5] * i2, t5[6] = e4[6] * i2, t5[7] = e4[7] * i2, t5[8] = e4[8] * a2, t5[9] = e4[9] * a2, t5[10] = e4[10] * a2, t5[11] = e4[11] * a2, t5[12] = e4[12], t5[13] = e4[13], t5[14] = e4[14], t5[15] = e4[15], t5;
            }, t4.scale$1 = function(t5, e4, r4) {
              return t5[0] = e4[0] * r4, t5[1] = e4[1] * r4, t5[2] = e4[2] * r4, t5[3] = e4[3] * r4, t5;
            }, t4.scale$2 = function(t5, e4, r4) {
              return t5[0] = e4[0] * r4, t5[1] = e4[1] * r4, t5[2] = e4[2] * r4, t5;
            }, t4.setCacheLimits = function(t5, e4) {
              ut = t5, ct = e4;
            }, t4.setRTLTextPlugin = function(t5, e4, r4) {
              if (void 0 === r4 && (r4 = false), xi === di || xi === vi || xi === gi)
                throw new Error("setRTLTextPlugin cannot be called multiple times.");
              bi = F.resolveURL(t5), xi = di, mi = e4, wi(), r4 || Ai();
            }, t4.sphericalToCartesian = function(t5) {
              var e4 = t5[0], r4 = t5[1], n4 = t5[2];
              return r4 += 90, r4 *= Math.PI / 180, n4 *= Math.PI / 180, { x: e4 * Math.cos(r4) * Math.sin(n4), y: e4 * Math.sin(r4) * Math.sin(n4), z: e4 * Math.cos(n4) };
            }, t4.sqrLen = Ro, t4.styleSpec = It, t4.sub = Do, t4.symbolSize = yu, t4.transformMat3 = function(t5, e4, r4) {
              var n4 = e4[0], i2 = e4[1], a2 = e4[2];
              return t5[0] = n4 * r4[0] + i2 * r4[3] + a2 * r4[6], t5[1] = n4 * r4[1] + i2 * r4[4] + a2 * r4[7], t5[2] = n4 * r4[2] + i2 * r4[5] + a2 * r4[8], t5;
            }, t4.transformMat4 = zo, t4.translate = function(t5, e4, r4) {
              var n4, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3, d3, v2 = r4[0], g3 = r4[1], y2 = r4[2];
              return e4 === t5 ? (t5[12] = e4[0] * v2 + e4[4] * g3 + e4[8] * y2 + e4[12], t5[13] = e4[1] * v2 + e4[5] * g3 + e4[9] * y2 + e4[13], t5[14] = e4[2] * v2 + e4[6] * g3 + e4[10] * y2 + e4[14], t5[15] = e4[3] * v2 + e4[7] * g3 + e4[11] * y2 + e4[15]) : (n4 = e4[0], i2 = e4[1], a2 = e4[2], o2 = e4[3], s2 = e4[4], l2 = e4[5], u2 = e4[6], c2 = e4[7], f3 = e4[8], h2 = e4[9], p3 = e4[10], d3 = e4[11], t5[0] = n4, t5[1] = i2, t5[2] = a2, t5[3] = o2, t5[4] = s2, t5[5] = l2, t5[6] = u2, t5[7] = c2, t5[8] = f3, t5[9] = h2, t5[10] = p3, t5[11] = d3, t5[12] = n4 * v2 + s2 * g3 + f3 * y2 + e4[12], t5[13] = i2 * v2 + l2 * g3 + h2 * y2 + e4[13], t5[14] = a2 * v2 + u2 * g3 + p3 * y2 + e4[14], t5[15] = o2 * v2 + c2 * g3 + d3 * y2 + e4[15]), t5;
            }, t4.triggerPluginCompletionEvent = _i, t4.uniqueId = p2, t4.validateCustomStyleLayer = function(t5) {
              var e4 = [], r4 = t5.id;
              return void 0 === r4 && e4.push({ message: "layers." + r4 + ': missing required property "id"' }), void 0 === t5.render && e4.push({ message: "layers." + r4 + ': missing required method "render"' }), t5.renderingMode && "2d" !== t5.renderingMode && "3d" !== t5.renderingMode && e4.push({ message: "layers." + r4 + ': property "renderingMode" must be either "2d" or "3d"' }), e4;
            }, t4.validateLight = qn, t4.validateStyle = Hn, t4.values = function(t5) {
              var e4 = [];
              for (var r4 in t5)
                e4.push(t5[r4]);
              return e4;
            }, t4.vectorTile = Zs, t4.version = r3, t4.warnOnce = w2, t4.webpSupported = N, t4.window = self, t4.wrap = c;
          }), n2(0, function(t4) {
            function e3(t5) {
              var r4 = typeof t5;
              if ("number" === r4 || "boolean" === r4 || "string" === r4 || null == t5)
                return JSON.stringify(t5);
              if (Array.isArray(t5)) {
                for (var n4 = "[", i2 = 0, a2 = t5; i2 < a2.length; i2 += 1)
                  n4 += e3(a2[i2]) + ",";
                return n4 + "]";
              }
              for (var o2 = Object.keys(t5).sort(), s2 = "{", l2 = 0; l2 < o2.length; l2++)
                s2 += JSON.stringify(o2[l2]) + ":" + e3(t5[o2[l2]]) + ",";
              return s2 + "}";
            }
            function r3(r4) {
              for (var n4 = "", i2 = 0, a2 = t4.refProperties; i2 < a2.length; i2 += 1)
                n4 += "/" + e3(r4[a2[i2]]);
              return n4;
            }
            var n3 = function(t5) {
              this.keyCache = {}, t5 && this.replace(t5);
            };
            n3.prototype.replace = function(t5) {
              this._layerConfigs = {}, this._layers = {}, this.update(t5, []);
            }, n3.prototype.update = function(e4, n4) {
              for (var i2 = this, a2 = 0, o2 = e4; a2 < o2.length; a2 += 1) {
                var s2 = o2[a2];
                this._layerConfigs[s2.id] = s2;
                var l2 = this._layers[s2.id] = t4.createStyleLayer(s2);
                l2._featureFilter = t4.featureFilter(l2.filter), this.keyCache[s2.id] && delete this.keyCache[s2.id];
              }
              for (var u2 = 0, c2 = n4; u2 < c2.length; u2 += 1) {
                var f3 = c2[u2];
                delete this.keyCache[f3], delete this._layerConfigs[f3], delete this._layers[f3];
              }
              this.familiesBySource = {};
              for (var h2 = 0, p3 = function(t5, e5) {
                for (var n5 = {}, i3 = 0; i3 < t5.length; i3++) {
                  var a3 = e5 && e5[t5[i3].id] || r3(t5[i3]);
                  e5 && (e5[t5[i3].id] = a3);
                  var o3 = n5[a3];
                  o3 || (o3 = n5[a3] = []), o3.push(t5[i3]);
                }
                var s3 = [];
                for (var l3 in n5)
                  s3.push(n5[l3]);
                return s3;
              }(t4.values(this._layerConfigs), this.keyCache); h2 < p3.length; h2 += 1) {
                var d3 = p3[h2].map(function(t5) {
                  return i2._layers[t5.id];
                }), v2 = d3[0];
                if ("none" !== v2.visibility) {
                  var g3 = v2.source || "", y2 = this.familiesBySource[g3];
                  y2 || (y2 = this.familiesBySource[g3] = {});
                  var m3 = v2.sourceLayer || "_geojsonTileLayer", x2 = y2[m3];
                  x2 || (x2 = y2[m3] = []), x2.push(d3);
                }
              }
            };
            var i = function(e4) {
              var r4 = {}, n4 = [];
              for (var i2 in e4) {
                var a2 = e4[i2], o2 = r4[i2] = {};
                for (var s2 in a2) {
                  var l2 = a2[+s2];
                  if (l2 && 0 !== l2.bitmap.width && 0 !== l2.bitmap.height) {
                    var u2 = { x: 0, y: 0, w: l2.bitmap.width + 2, h: l2.bitmap.height + 2 };
                    n4.push(u2), o2[s2] = { rect: u2, metrics: l2.metrics };
                  }
                }
              }
              var c2 = t4.potpack(n4), f3 = c2.w, h2 = c2.h, p3 = new t4.AlphaImage({ width: f3 || 1, height: h2 || 1 });
              for (var d3 in e4) {
                var v2 = e4[d3];
                for (var g3 in v2) {
                  var y2 = v2[+g3];
                  if (y2 && 0 !== y2.bitmap.width && 0 !== y2.bitmap.height) {
                    var m3 = r4[d3][g3].rect;
                    t4.AlphaImage.copy(y2.bitmap, p3, { x: 0, y: 0 }, { x: m3.x + 1, y: m3.y + 1 }, y2.bitmap);
                  }
                }
              }
              this.image = p3, this.positions = r4;
            };
            t4.register("GlyphAtlas", i);
            var a = function(e4) {
              this.tileID = new t4.OverscaledTileID(e4.tileID.overscaledZ, e4.tileID.wrap, e4.tileID.canonical.z, e4.tileID.canonical.x, e4.tileID.canonical.y), this.uid = e4.uid, this.zoom = e4.zoom, this.pixelRatio = e4.pixelRatio, this.tileSize = e4.tileSize, this.source = e4.source, this.overscaling = this.tileID.overscaleFactor(), this.showCollisionBoxes = e4.showCollisionBoxes, this.collectResourceTiming = !!e4.collectResourceTiming, this.returnDependencies = !!e4.returnDependencies, this.promoteId = e4.promoteId;
            };
            function o(e4, r4, n4) {
              for (var i2 = new t4.EvaluationParameters(r4), a2 = 0, o2 = e4; a2 < o2.length; a2 += 1)
                o2[a2].recalculate(i2, n4);
            }
            function s(e4, r4) {
              var n4 = t4.getArrayBuffer(e4.request, function(e5, n5, i2, a2) {
                e5 ? r4(e5) : n5 && r4(null, { vectorTile: new t4.vectorTile.VectorTile(new t4.pbf(n5)), rawData: n5, cacheControl: i2, expires: a2 });
              });
              return function() {
                n4.cancel(), r4();
              };
            }
            a.prototype.parse = function(e4, r4, n4, a2, s2) {
              var l2 = this;
              this.status = "parsing", this.data = e4, this.collisionBoxArray = new t4.CollisionBoxArray();
              var u2 = new t4.DictionaryCoder(Object.keys(e4.layers).sort()), c2 = new t4.FeatureIndex(this.tileID, this.promoteId);
              c2.bucketLayerIDs = [];
              var f3, h2, p3, d3, v2 = {}, g3 = { featureIndex: c2, iconDependencies: {}, patternDependencies: {}, glyphDependencies: {}, availableImages: n4 }, y2 = r4.familiesBySource[this.source];
              for (var m3 in y2) {
                var x2 = e4.layers[m3];
                if (x2) {
                  1 === x2.version && t4.warnOnce('Vector tile source "' + this.source + '" layer "' + m3 + '" does not use vector tile spec v2 and therefore may have some rendering errors.');
                  for (var b2 = u2.encode(m3), _2 = [], w3 = 0; w3 < x2.length; w3++) {
                    var T2 = x2.feature(w3), k2 = c2.getId(T2, m3);
                    _2.push({ feature: T2, id: k2, index: w3, sourceLayerIndex: b2 });
                  }
                  for (var A2 = 0, M2 = y2[m3]; A2 < M2.length; A2 += 1) {
                    var S2 = M2[A2], E2 = S2[0];
                    E2.minzoom && this.zoom < Math.floor(E2.minzoom) || E2.maxzoom && this.zoom >= E2.maxzoom || "none" !== E2.visibility && (o(S2, this.zoom, n4), (v2[E2.id] = E2.createBucket({ index: c2.bucketLayerIDs.length, layers: S2, zoom: this.zoom, pixelRatio: this.pixelRatio, overscaling: this.overscaling, collisionBoxArray: this.collisionBoxArray, sourceLayerIndex: b2, sourceID: this.source })).populate(_2, g3, this.tileID.canonical), c2.bucketLayerIDs.push(S2.map(function(t5) {
                      return t5.id;
                    })));
                  }
                }
              }
              var L2 = t4.mapObject(g3.glyphDependencies, function(t5) {
                return Object.keys(t5).map(Number);
              });
              Object.keys(L2).length ? a2.send("getGlyphs", { uid: this.uid, stacks: L2 }, function(t5, e5) {
                f3 || (f3 = t5, h2 = e5, O2.call(l2));
              }) : h2 = {};
              var C2 = Object.keys(g3.iconDependencies);
              C2.length ? a2.send("getImages", { icons: C2, source: this.source, tileID: this.tileID, type: "icons" }, function(t5, e5) {
                f3 || (f3 = t5, p3 = e5, O2.call(l2));
              }) : p3 = {};
              var P2 = Object.keys(g3.patternDependencies);
              function O2() {
                if (f3)
                  return s2(f3);
                if (h2 && p3 && d3) {
                  var e5 = new i(h2), r5 = new t4.ImageAtlas(p3, d3);
                  for (var a3 in v2) {
                    var l3 = v2[a3];
                    l3 instanceof t4.SymbolBucket ? (o(l3.layers, this.zoom, n4), t4.performSymbolLayout(l3, h2, e5.positions, p3, r5.iconPositions, this.showCollisionBoxes, this.tileID.canonical)) : l3.hasPattern && (l3 instanceof t4.LineBucket || l3 instanceof t4.FillBucket || l3 instanceof t4.FillExtrusionBucket) && (o(l3.layers, this.zoom, n4), l3.addFeatures(g3, this.tileID.canonical, r5.patternPositions));
                  }
                  this.status = "done", s2(null, { buckets: t4.values(v2).filter(function(t5) {
                    return !t5.isEmpty();
                  }), featureIndex: c2, collisionBoxArray: this.collisionBoxArray, glyphAtlasImage: e5.image, imageAtlas: r5, glyphMap: this.returnDependencies ? h2 : null, iconMap: this.returnDependencies ? p3 : null, glyphPositions: this.returnDependencies ? e5.positions : null });
                }
              }
              P2.length ? a2.send("getImages", { icons: P2, source: this.source, tileID: this.tileID, type: "patterns" }, function(t5, e5) {
                f3 || (f3 = t5, d3 = e5, O2.call(l2));
              }) : d3 = {}, O2.call(this);
            };
            var l = function(t5, e4, r4, n4) {
              this.actor = t5, this.layerIndex = e4, this.availableImages = r4, this.loadVectorData = n4 || s, this.loading = {}, this.loaded = {};
            };
            l.prototype.loadTile = function(e4, r4) {
              var n4 = this, i2 = e4.uid;
              this.loading || (this.loading = {});
              var o2 = !!(e4 && e4.request && e4.request.collectResourceTiming) && new t4.RequestPerformance(e4.request), s2 = this.loading[i2] = new a(e4);
              s2.abort = this.loadVectorData(e4, function(e5, a2) {
                if (delete n4.loading[i2], e5 || !a2)
                  return s2.status = "done", n4.loaded[i2] = s2, r4(e5);
                var l2 = a2.rawData, u2 = {};
                a2.expires && (u2.expires = a2.expires), a2.cacheControl && (u2.cacheControl = a2.cacheControl);
                var c2 = {};
                if (o2) {
                  var f3 = o2.finish();
                  f3 && (c2.resourceTiming = JSON.parse(JSON.stringify(f3)));
                }
                s2.vectorTile = a2.vectorTile, s2.parse(a2.vectorTile, n4.layerIndex, n4.availableImages, n4.actor, function(e6, n5) {
                  if (e6 || !n5)
                    return r4(e6);
                  r4(null, t4.extend({ rawTileData: l2.slice(0) }, n5, u2, c2));
                }), n4.loaded = n4.loaded || {}, n4.loaded[i2] = s2;
              });
            }, l.prototype.reloadTile = function(t5, e4) {
              var r4 = this, n4 = this.loaded, i2 = t5.uid, a2 = this;
              if (n4 && n4[i2]) {
                var o2 = n4[i2];
                o2.showCollisionBoxes = t5.showCollisionBoxes;
                var s2 = function(t6, n5) {
                  var i3 = o2.reloadCallback;
                  i3 && (delete o2.reloadCallback, o2.parse(o2.vectorTile, a2.layerIndex, r4.availableImages, a2.actor, i3)), e4(t6, n5);
                };
                "parsing" === o2.status ? o2.reloadCallback = s2 : "done" === o2.status && (o2.vectorTile ? o2.parse(o2.vectorTile, this.layerIndex, this.availableImages, this.actor, s2) : s2());
              }
            }, l.prototype.abortTile = function(t5, e4) {
              var r4 = this.loading, n4 = t5.uid;
              r4 && r4[n4] && r4[n4].abort && (r4[n4].abort(), delete r4[n4]), e4();
            }, l.prototype.removeTile = function(t5, e4) {
              var r4 = this.loaded, n4 = t5.uid;
              r4 && r4[n4] && delete r4[n4], e4();
            };
            var u = t4.window.ImageBitmap, c = function() {
              this.loaded = {};
            };
            c.prototype.loadTile = function(e4, r4) {
              var n4 = e4.uid, i2 = e4.encoding, a2 = e4.rawImageData, o2 = u && a2 instanceof u ? this.getImageData(a2) : a2, s2 = new t4.DEMData(n4, o2, i2);
              this.loaded = this.loaded || {}, this.loaded[n4] = s2, r4(null, s2);
            }, c.prototype.getImageData = function(e4) {
              this.offscreenCanvas && this.offscreenCanvasContext || (this.offscreenCanvas = new OffscreenCanvas(e4.width, e4.height), this.offscreenCanvasContext = this.offscreenCanvas.getContext("2d")), this.offscreenCanvas.width = e4.width, this.offscreenCanvas.height = e4.height, this.offscreenCanvasContext.drawImage(e4, 0, 0, e4.width, e4.height);
              var r4 = this.offscreenCanvasContext.getImageData(-1, -1, e4.width + 2, e4.height + 2);
              return this.offscreenCanvasContext.clearRect(0, 0, this.offscreenCanvas.width, this.offscreenCanvas.height), new t4.RGBAImage({ width: r4.width, height: r4.height }, r4.data);
            }, c.prototype.removeTile = function(t5) {
              var e4 = this.loaded, r4 = t5.uid;
              e4 && e4[r4] && delete e4[r4];
            };
            var f2 = function t5(e4, r4) {
              var n4, i2 = e4 && e4.type;
              if ("FeatureCollection" === i2)
                for (n4 = 0; n4 < e4.features.length; n4++)
                  t5(e4.features[n4], r4);
              else if ("GeometryCollection" === i2)
                for (n4 = 0; n4 < e4.geometries.length; n4++)
                  t5(e4.geometries[n4], r4);
              else if ("Feature" === i2)
                t5(e4.geometry, r4);
              else if ("Polygon" === i2)
                h(e4.coordinates, r4);
              else if ("MultiPolygon" === i2)
                for (n4 = 0; n4 < e4.coordinates.length; n4++)
                  h(e4.coordinates[n4], r4);
              return e4;
            };
            function h(t5, e4) {
              if (0 !== t5.length) {
                p2(t5[0], e4);
                for (var r4 = 1; r4 < t5.length; r4++)
                  p2(t5[r4], !e4);
              }
            }
            function p2(t5, e4) {
              for (var r4 = 0, n4 = 0, i2 = t5.length, a2 = i2 - 1; n4 < i2; a2 = n4++)
                r4 += (t5[n4][0] - t5[a2][0]) * (t5[a2][1] + t5[n4][1]);
              r4 >= 0 != !!e4 && t5.reverse();
            }
            var d2 = t4.vectorTile.VectorTileFeature.prototype.toGeoJSON, v = function(e4) {
              this._feature = e4, this.extent = t4.EXTENT, this.type = e4.type, this.properties = e4.tags, "id" in e4 && !isNaN(e4.id) && (this.id = parseInt(e4.id, 10));
            };
            v.prototype.loadGeometry = function() {
              if (1 === this._feature.type) {
                for (var e4 = [], r4 = 0, n4 = this._feature.geometry; r4 < n4.length; r4 += 1) {
                  var i2 = n4[r4];
                  e4.push([new t4.Point$1(i2[0], i2[1])]);
                }
                return e4;
              }
              for (var a2 = [], o2 = 0, s2 = this._feature.geometry; o2 < s2.length; o2 += 1) {
                for (var l2 = [], u2 = 0, c2 = s2[o2]; u2 < c2.length; u2 += 1) {
                  var f3 = c2[u2];
                  l2.push(new t4.Point$1(f3[0], f3[1]));
                }
                a2.push(l2);
              }
              return a2;
            }, v.prototype.toGeoJSON = function(t5, e4, r4) {
              return d2.call(this, t5, e4, r4);
            };
            var g2 = function(e4) {
              this.layers = { _geojsonTileLayer: this }, this.name = "_geojsonTileLayer", this.extent = t4.EXTENT, this.length = e4.length, this._features = e4;
            };
            g2.prototype.feature = function(t5) {
              return new v(this._features[t5]);
            };
            var y = t4.vectorTile.VectorTileFeature, m2 = x;
            function x(t5, e4) {
              this.options = e4 || {}, this.features = t5, this.length = t5.length;
            }
            function b(t5, e4) {
              this.id = "number" == typeof t5.id ? t5.id : void 0, this.type = t5.type, this.rawGeometry = 1 === t5.type ? [t5.geometry] : t5.geometry, this.properties = t5.tags, this.extent = e4 || 4096;
            }
            x.prototype.feature = function(t5) {
              return new b(this.features[t5], this.options.extent);
            }, b.prototype.loadGeometry = function() {
              var e4 = this.rawGeometry;
              this.geometry = [];
              for (var r4 = 0; r4 < e4.length; r4++) {
                for (var n4 = e4[r4], i2 = [], a2 = 0; a2 < n4.length; a2++)
                  i2.push(new t4.Point$1(n4[a2][0], n4[a2][1]));
                this.geometry.push(i2);
              }
              return this.geometry;
            }, b.prototype.bbox = function() {
              this.geometry || this.loadGeometry();
              for (var t5 = this.geometry, e4 = 1 / 0, r4 = -1 / 0, n4 = 1 / 0, i2 = -1 / 0, a2 = 0; a2 < t5.length; a2++)
                for (var o2 = t5[a2], s2 = 0; s2 < o2.length; s2++) {
                  var l2 = o2[s2];
                  e4 = Math.min(e4, l2.x), r4 = Math.max(r4, l2.x), n4 = Math.min(n4, l2.y), i2 = Math.max(i2, l2.y);
                }
              return [e4, n4, r4, i2];
            }, b.prototype.toGeoJSON = y.prototype.toGeoJSON;
            var _ = A, w2 = A, T = function(t5, e4) {
              e4 = e4 || {};
              var r4 = {};
              for (var n4 in t5)
                r4[n4] = new m2(t5[n4].features, e4), r4[n4].name = n4, r4[n4].version = e4.version, r4[n4].extent = e4.extent;
              return A({ layers: r4 });
            }, k = m2;
            function A(e4) {
              var r4 = new t4.pbf();
              return function(t5, e5) {
                for (var r5 in t5.layers)
                  e5.writeMessage(3, M, t5.layers[r5]);
              }(e4, r4), r4.finish();
            }
            function M(t5, e4) {
              var r4;
              e4.writeVarintField(15, t5.version || 1), e4.writeStringField(1, t5.name || ""), e4.writeVarintField(5, t5.extent || 4096);
              var n4 = { keys: [], values: [], keycache: {}, valuecache: {} };
              for (r4 = 0; r4 < t5.length; r4++)
                n4.feature = t5.feature(r4), e4.writeMessage(2, S, n4);
              var i2 = n4.keys;
              for (r4 = 0; r4 < i2.length; r4++)
                e4.writeStringField(3, i2[r4]);
              var a2 = n4.values;
              for (r4 = 0; r4 < a2.length; r4++)
                e4.writeMessage(4, O, a2[r4]);
            }
            function S(t5, e4) {
              var r4 = t5.feature;
              void 0 !== r4.id && e4.writeVarintField(1, r4.id), e4.writeMessage(2, E, t5), e4.writeVarintField(3, r4.type), e4.writeMessage(4, P, r4);
            }
            function E(t5, e4) {
              var r4 = t5.feature, n4 = t5.keys, i2 = t5.values, a2 = t5.keycache, o2 = t5.valuecache;
              for (var s2 in r4.properties) {
                var l2 = a2[s2];
                void 0 === l2 && (n4.push(s2), l2 = n4.length - 1, a2[s2] = l2), e4.writeVarint(l2);
                var u2 = r4.properties[s2], c2 = typeof u2;
                "string" !== c2 && "boolean" !== c2 && "number" !== c2 && (u2 = JSON.stringify(u2));
                var f3 = c2 + ":" + u2, h2 = o2[f3];
                void 0 === h2 && (i2.push(u2), h2 = i2.length - 1, o2[f3] = h2), e4.writeVarint(h2);
              }
            }
            function L(t5, e4) {
              return (e4 << 3) + (7 & t5);
            }
            function C(t5) {
              return t5 << 1 ^ t5 >> 31;
            }
            function P(t5, e4) {
              for (var r4 = t5.loadGeometry(), n4 = t5.type, i2 = 0, a2 = 0, o2 = r4.length, s2 = 0; s2 < o2; s2++) {
                var l2 = r4[s2], u2 = 1;
                1 === n4 && (u2 = l2.length), e4.writeVarint(L(1, u2));
                for (var c2 = 3 === n4 ? l2.length - 1 : l2.length, f3 = 0; f3 < c2; f3++) {
                  1 === f3 && 1 !== n4 && e4.writeVarint(L(2, c2 - 1));
                  var h2 = l2[f3].x - i2, p3 = l2[f3].y - a2;
                  e4.writeVarint(C(h2)), e4.writeVarint(C(p3)), i2 += h2, a2 += p3;
                }
                3 === n4 && e4.writeVarint(L(7, 1));
              }
            }
            function O(t5, e4) {
              var r4 = typeof t5;
              "string" === r4 ? e4.writeStringField(1, t5) : "boolean" === r4 ? e4.writeBooleanField(7, t5) : "number" === r4 && (t5 % 1 != 0 ? e4.writeDoubleField(3, t5) : t5 < 0 ? e4.writeSVarintField(6, t5) : e4.writeVarintField(5, t5));
            }
            function I(t5, e4, r4, n4, i2, a2) {
              if (!(i2 - n4 <= r4)) {
                var o2 = n4 + i2 >> 1;
                D(t5, e4, o2, n4, i2, a2 % 2), I(t5, e4, r4, n4, o2 - 1, a2 + 1), I(t5, e4, r4, o2 + 1, i2, a2 + 1);
              }
            }
            function D(t5, e4, r4, n4, i2, a2) {
              for (; i2 > n4; ) {
                if (i2 - n4 > 600) {
                  var o2 = i2 - n4 + 1, s2 = r4 - n4 + 1, l2 = Math.log(o2), u2 = 0.5 * Math.exp(2 * l2 / 3), c2 = 0.5 * Math.sqrt(l2 * u2 * (o2 - u2) / o2) * (s2 - o2 / 2 < 0 ? -1 : 1);
                  D(t5, e4, r4, Math.max(n4, Math.floor(r4 - s2 * u2 / o2 + c2)), Math.min(i2, Math.floor(r4 + (o2 - s2) * u2 / o2 + c2)), a2);
                }
                var f3 = e4[2 * r4 + a2], h2 = n4, p3 = i2;
                for (z(t5, e4, n4, r4), e4[2 * i2 + a2] > f3 && z(t5, e4, n4, i2); h2 < p3; ) {
                  for (z(t5, e4, h2, p3), h2++, p3--; e4[2 * h2 + a2] < f3; )
                    h2++;
                  for (; e4[2 * p3 + a2] > f3; )
                    p3--;
                }
                e4[2 * n4 + a2] === f3 ? z(t5, e4, n4, p3) : z(t5, e4, ++p3, i2), p3 <= r4 && (n4 = p3 + 1), r4 <= p3 && (i2 = p3 - 1);
              }
            }
            function z(t5, e4, r4, n4) {
              R(t5, r4, n4), R(e4, 2 * r4, 2 * n4), R(e4, 2 * r4 + 1, 2 * n4 + 1);
            }
            function R(t5, e4, r4) {
              var n4 = t5[e4];
              t5[e4] = t5[r4], t5[r4] = n4;
            }
            function F(t5, e4, r4, n4) {
              var i2 = t5 - r4, a2 = e4 - n4;
              return i2 * i2 + a2 * a2;
            }
            _.fromVectorTileJs = w2, _.fromGeojsonVt = T, _.GeoJSONWrapper = k;
            var B = function(t5) {
              return t5[0];
            }, N = function(t5) {
              return t5[1];
            }, j = function(t5, e4, r4, n4, i2) {
              void 0 === e4 && (e4 = B), void 0 === r4 && (r4 = N), void 0 === n4 && (n4 = 64), void 0 === i2 && (i2 = Float64Array), this.nodeSize = n4, this.points = t5;
              for (var a2 = t5.length < 65536 ? Uint16Array : Uint32Array, o2 = this.ids = new a2(t5.length), s2 = this.coords = new i2(2 * t5.length), l2 = 0; l2 < t5.length; l2++)
                o2[l2] = l2, s2[2 * l2] = e4(t5[l2]), s2[2 * l2 + 1] = r4(t5[l2]);
              I(o2, s2, n4, 0, o2.length - 1, 0);
            };
            j.prototype.range = function(t5, e4, r4, n4) {
              return function(t6, e5, r5, n5, i2, a2, o2) {
                for (var s2, l2, u2 = [0, t6.length - 1, 0], c2 = []; u2.length; ) {
                  var f3 = u2.pop(), h2 = u2.pop(), p3 = u2.pop();
                  if (h2 - p3 <= o2)
                    for (var d3 = p3; d3 <= h2; d3++)
                      s2 = e5[2 * d3], l2 = e5[2 * d3 + 1], s2 >= r5 && s2 <= i2 && l2 >= n5 && l2 <= a2 && c2.push(t6[d3]);
                  else {
                    var v2 = Math.floor((p3 + h2) / 2);
                    s2 = e5[2 * v2], l2 = e5[2 * v2 + 1], s2 >= r5 && s2 <= i2 && l2 >= n5 && l2 <= a2 && c2.push(t6[v2]);
                    var g3 = (f3 + 1) % 2;
                    (0 === f3 ? r5 <= s2 : n5 <= l2) && (u2.push(p3), u2.push(v2 - 1), u2.push(g3)), (0 === f3 ? i2 >= s2 : a2 >= l2) && (u2.push(v2 + 1), u2.push(h2), u2.push(g3));
                  }
                }
                return c2;
              }(this.ids, this.coords, t5, e4, r4, n4, this.nodeSize);
            }, j.prototype.within = function(t5, e4, r4) {
              return function(t6, e5, r5, n4, i2, a2) {
                for (var o2 = [0, t6.length - 1, 0], s2 = [], l2 = i2 * i2; o2.length; ) {
                  var u2 = o2.pop(), c2 = o2.pop(), f3 = o2.pop();
                  if (c2 - f3 <= a2)
                    for (var h2 = f3; h2 <= c2; h2++)
                      F(e5[2 * h2], e5[2 * h2 + 1], r5, n4) <= l2 && s2.push(t6[h2]);
                  else {
                    var p3 = Math.floor((f3 + c2) / 2), d3 = e5[2 * p3], v2 = e5[2 * p3 + 1];
                    F(d3, v2, r5, n4) <= l2 && s2.push(t6[p3]);
                    var g3 = (u2 + 1) % 2;
                    (0 === u2 ? r5 - i2 <= d3 : n4 - i2 <= v2) && (o2.push(f3), o2.push(p3 - 1), o2.push(g3)), (0 === u2 ? r5 + i2 >= d3 : n4 + i2 >= v2) && (o2.push(p3 + 1), o2.push(c2), o2.push(g3));
                  }
                }
                return s2;
              }(this.ids, this.coords, t5, e4, r4, this.nodeSize);
            };
            var U = { minZoom: 0, maxZoom: 16, radius: 40, extent: 512, nodeSize: 64, log: false, generateId: false, reduce: null, map: function(t5) {
              return t5;
            } }, V = function(t5) {
              this.options = X(Object.create(U), t5), this.trees = new Array(this.options.maxZoom + 1);
            };
            function H(t5, e4, r4, n4, i2) {
              return { x: t5, y: e4, zoom: 1 / 0, id: r4, parentId: -1, numPoints: n4, properties: i2 };
            }
            function q2(t5, e4) {
              var r4 = t5.geometry.coordinates, n4 = r4[0], i2 = r4[1];
              return { x: Y(n4), y: W(i2), zoom: 1 / 0, index: e4, parentId: -1 };
            }
            function G(t5) {
              return { type: "Feature", id: t5.id, properties: Z(t5), geometry: { type: "Point", coordinates: [(n4 = t5.x, 360 * (n4 - 0.5)), (e4 = t5.y, r4 = (180 - 360 * e4) * Math.PI / 180, 360 * Math.atan(Math.exp(r4)) / Math.PI - 90)] } };
              var e4, r4, n4;
            }
            function Z(t5) {
              var e4 = t5.numPoints, r4 = e4 >= 1e4 ? Math.round(e4 / 1e3) + "k" : e4 >= 1e3 ? Math.round(e4 / 100) / 10 + "k" : e4;
              return X(X({}, t5.properties), { cluster: true, cluster_id: t5.id, point_count: e4, point_count_abbreviated: r4 });
            }
            function Y(t5) {
              return t5 / 360 + 0.5;
            }
            function W(t5) {
              var e4 = Math.sin(t5 * Math.PI / 180), r4 = 0.5 - 0.25 * Math.log((1 + e4) / (1 - e4)) / Math.PI;
              return r4 < 0 ? 0 : r4 > 1 ? 1 : r4;
            }
            function X(t5, e4) {
              for (var r4 in e4)
                t5[r4] = e4[r4];
              return t5;
            }
            function J(t5) {
              return t5.x;
            }
            function K(t5) {
              return t5.y;
            }
            function $(t5, e4, r4, n4) {
              for (var i2, a2 = n4, o2 = r4 - e4 >> 1, s2 = r4 - e4, l2 = t5[e4], u2 = t5[e4 + 1], c2 = t5[r4], f3 = t5[r4 + 1], h2 = e4 + 3; h2 < r4; h2 += 3) {
                var p3 = Q(t5[h2], t5[h2 + 1], l2, u2, c2, f3);
                if (p3 > a2)
                  i2 = h2, a2 = p3;
                else if (p3 === a2) {
                  var d3 = Math.abs(h2 - o2);
                  d3 < s2 && (i2 = h2, s2 = d3);
                }
              }
              a2 > n4 && (i2 - e4 > 3 && $(t5, e4, i2, n4), t5[i2 + 2] = a2, r4 - i2 > 3 && $(t5, i2, r4, n4));
            }
            function Q(t5, e4, r4, n4, i2, a2) {
              var o2 = i2 - r4, s2 = a2 - n4;
              if (0 !== o2 || 0 !== s2) {
                var l2 = ((t5 - r4) * o2 + (e4 - n4) * s2) / (o2 * o2 + s2 * s2);
                l2 > 1 ? (r4 = i2, n4 = a2) : l2 > 0 && (r4 += o2 * l2, n4 += s2 * l2);
              }
              return (o2 = t5 - r4) * o2 + (s2 = e4 - n4) * s2;
            }
            function tt(t5, e4, r4, n4) {
              var i2 = { id: void 0 === t5 ? null : t5, type: e4, geometry: r4, tags: n4, minX: 1 / 0, minY: 1 / 0, maxX: -1 / 0, maxY: -1 / 0 };
              return function(t6) {
                var e5 = t6.geometry, r5 = t6.type;
                if ("Point" === r5 || "MultiPoint" === r5 || "LineString" === r5)
                  et(t6, e5);
                else if ("Polygon" === r5 || "MultiLineString" === r5)
                  for (var n5 = 0; n5 < e5.length; n5++)
                    et(t6, e5[n5]);
                else if ("MultiPolygon" === r5)
                  for (n5 = 0; n5 < e5.length; n5++)
                    for (var i3 = 0; i3 < e5[n5].length; i3++)
                      et(t6, e5[n5][i3]);
              }(i2), i2;
            }
            function et(t5, e4) {
              for (var r4 = 0; r4 < e4.length; r4 += 3)
                t5.minX = Math.min(t5.minX, e4[r4]), t5.minY = Math.min(t5.minY, e4[r4 + 1]), t5.maxX = Math.max(t5.maxX, e4[r4]), t5.maxY = Math.max(t5.maxY, e4[r4 + 1]);
            }
            function rt(t5, e4, r4, n4) {
              if (e4.geometry) {
                var i2 = e4.geometry.coordinates, a2 = e4.geometry.type, o2 = Math.pow(r4.tolerance / ((1 << r4.maxZoom) * r4.extent), 2), s2 = [], l2 = e4.id;
                if (r4.promoteId ? l2 = e4.properties[r4.promoteId] : r4.generateId && (l2 = n4 || 0), "Point" === a2)
                  nt(i2, s2);
                else if ("MultiPoint" === a2)
                  for (var u2 = 0; u2 < i2.length; u2++)
                    nt(i2[u2], s2);
                else if ("LineString" === a2)
                  it(i2, s2, o2, false);
                else if ("MultiLineString" === a2) {
                  if (r4.lineMetrics) {
                    for (u2 = 0; u2 < i2.length; u2++)
                      s2 = [], it(i2[u2], s2, o2, false), t5.push(tt(l2, "LineString", s2, e4.properties));
                    return;
                  }
                  at(i2, s2, o2, false);
                } else if ("Polygon" === a2)
                  at(i2, s2, o2, true);
                else {
                  if ("MultiPolygon" !== a2) {
                    if ("GeometryCollection" === a2) {
                      for (u2 = 0; u2 < e4.geometry.geometries.length; u2++)
                        rt(t5, { id: l2, geometry: e4.geometry.geometries[u2], properties: e4.properties }, r4, n4);
                      return;
                    }
                    throw new Error("Input data is not a valid GeoJSON object.");
                  }
                  for (u2 = 0; u2 < i2.length; u2++) {
                    var c2 = [];
                    at(i2[u2], c2, o2, true), s2.push(c2);
                  }
                }
                t5.push(tt(l2, a2, s2, e4.properties));
              }
            }
            function nt(t5, e4) {
              e4.push(ot(t5[0])), e4.push(st(t5[1])), e4.push(0);
            }
            function it(t5, e4, r4, n4) {
              for (var i2, a2, o2 = 0, s2 = 0; s2 < t5.length; s2++) {
                var l2 = ot(t5[s2][0]), u2 = st(t5[s2][1]);
                e4.push(l2), e4.push(u2), e4.push(0), s2 > 0 && (o2 += n4 ? (i2 * u2 - l2 * a2) / 2 : Math.sqrt(Math.pow(l2 - i2, 2) + Math.pow(u2 - a2, 2))), i2 = l2, a2 = u2;
              }
              var c2 = e4.length - 3;
              e4[2] = 1, $(e4, 0, c2, r4), e4[c2 + 2] = 1, e4.size = Math.abs(o2), e4.start = 0, e4.end = e4.size;
            }
            function at(t5, e4, r4, n4) {
              for (var i2 = 0; i2 < t5.length; i2++) {
                var a2 = [];
                it(t5[i2], a2, r4, n4), e4.push(a2);
              }
            }
            function ot(t5) {
              return t5 / 360 + 0.5;
            }
            function st(t5) {
              var e4 = Math.sin(t5 * Math.PI / 180), r4 = 0.5 - 0.25 * Math.log((1 + e4) / (1 - e4)) / Math.PI;
              return r4 < 0 ? 0 : r4 > 1 ? 1 : r4;
            }
            function lt(t5, e4, r4, n4, i2, a2, o2, s2) {
              if (n4 /= e4, a2 >= (r4 /= e4) && o2 < n4)
                return t5;
              if (o2 < r4 || a2 >= n4)
                return null;
              for (var l2 = [], u2 = 0; u2 < t5.length; u2++) {
                var c2 = t5[u2], f3 = c2.geometry, h2 = c2.type, p3 = 0 === i2 ? c2.minX : c2.minY, d3 = 0 === i2 ? c2.maxX : c2.maxY;
                if (p3 >= r4 && d3 < n4)
                  l2.push(c2);
                else if (!(d3 < r4 || p3 >= n4)) {
                  var v2 = [];
                  if ("Point" === h2 || "MultiPoint" === h2)
                    ut(f3, v2, r4, n4, i2);
                  else if ("LineString" === h2)
                    ct(f3, v2, r4, n4, i2, false, s2.lineMetrics);
                  else if ("MultiLineString" === h2)
                    ht(f3, v2, r4, n4, i2, false);
                  else if ("Polygon" === h2)
                    ht(f3, v2, r4, n4, i2, true);
                  else if ("MultiPolygon" === h2)
                    for (var g3 = 0; g3 < f3.length; g3++) {
                      var y2 = [];
                      ht(f3[g3], y2, r4, n4, i2, true), y2.length && v2.push(y2);
                    }
                  if (v2.length) {
                    if (s2.lineMetrics && "LineString" === h2) {
                      for (g3 = 0; g3 < v2.length; g3++)
                        l2.push(tt(c2.id, h2, v2[g3], c2.tags));
                      continue;
                    }
                    "LineString" !== h2 && "MultiLineString" !== h2 || (1 === v2.length ? (h2 = "LineString", v2 = v2[0]) : h2 = "MultiLineString"), "Point" !== h2 && "MultiPoint" !== h2 || (h2 = 3 === v2.length ? "Point" : "MultiPoint"), l2.push(tt(c2.id, h2, v2, c2.tags));
                  }
                }
              }
              return l2.length ? l2 : null;
            }
            function ut(t5, e4, r4, n4, i2) {
              for (var a2 = 0; a2 < t5.length; a2 += 3) {
                var o2 = t5[a2 + i2];
                o2 >= r4 && o2 <= n4 && (e4.push(t5[a2]), e4.push(t5[a2 + 1]), e4.push(t5[a2 + 2]));
              }
            }
            function ct(t5, e4, r4, n4, i2, a2, o2) {
              for (var s2, l2, u2 = ft(t5), c2 = 0 === i2 ? dt : vt, f3 = t5.start, h2 = 0; h2 < t5.length - 3; h2 += 3) {
                var p3 = t5[h2], d3 = t5[h2 + 1], v2 = t5[h2 + 2], g3 = t5[h2 + 3], y2 = t5[h2 + 4], m3 = 0 === i2 ? p3 : d3, x2 = 0 === i2 ? g3 : y2, b2 = false;
                o2 && (s2 = Math.sqrt(Math.pow(p3 - g3, 2) + Math.pow(d3 - y2, 2))), m3 < r4 ? x2 > r4 && (l2 = c2(u2, p3, d3, g3, y2, r4), o2 && (u2.start = f3 + s2 * l2)) : m3 > n4 ? x2 < n4 && (l2 = c2(u2, p3, d3, g3, y2, n4), o2 && (u2.start = f3 + s2 * l2)) : pt(u2, p3, d3, v2), x2 < r4 && m3 >= r4 && (l2 = c2(u2, p3, d3, g3, y2, r4), b2 = true), x2 > n4 && m3 <= n4 && (l2 = c2(u2, p3, d3, g3, y2, n4), b2 = true), !a2 && b2 && (o2 && (u2.end = f3 + s2 * l2), e4.push(u2), u2 = ft(t5)), o2 && (f3 += s2);
              }
              var _2 = t5.length - 3;
              p3 = t5[_2], d3 = t5[_2 + 1], v2 = t5[_2 + 2], (m3 = 0 === i2 ? p3 : d3) >= r4 && m3 <= n4 && pt(u2, p3, d3, v2), _2 = u2.length - 3, a2 && _2 >= 3 && (u2[_2] !== u2[0] || u2[_2 + 1] !== u2[1]) && pt(u2, u2[0], u2[1], u2[2]), u2.length && e4.push(u2);
            }
            function ft(t5) {
              var e4 = [];
              return e4.size = t5.size, e4.start = t5.start, e4.end = t5.end, e4;
            }
            function ht(t5, e4, r4, n4, i2, a2) {
              for (var o2 = 0; o2 < t5.length; o2++)
                ct(t5[o2], e4, r4, n4, i2, a2, false);
            }
            function pt(t5, e4, r4, n4) {
              t5.push(e4), t5.push(r4), t5.push(n4);
            }
            function dt(t5, e4, r4, n4, i2, a2) {
              var o2 = (a2 - e4) / (n4 - e4);
              return t5.push(a2), t5.push(r4 + (i2 - r4) * o2), t5.push(1), o2;
            }
            function vt(t5, e4, r4, n4, i2, a2) {
              var o2 = (a2 - r4) / (i2 - r4);
              return t5.push(e4 + (n4 - e4) * o2), t5.push(a2), t5.push(1), o2;
            }
            function gt(t5, e4) {
              for (var r4 = [], n4 = 0; n4 < t5.length; n4++) {
                var i2, a2 = t5[n4], o2 = a2.type;
                if ("Point" === o2 || "MultiPoint" === o2 || "LineString" === o2)
                  i2 = yt(a2.geometry, e4);
                else if ("MultiLineString" === o2 || "Polygon" === o2) {
                  i2 = [];
                  for (var s2 = 0; s2 < a2.geometry.length; s2++)
                    i2.push(yt(a2.geometry[s2], e4));
                } else if ("MultiPolygon" === o2)
                  for (i2 = [], s2 = 0; s2 < a2.geometry.length; s2++) {
                    for (var l2 = [], u2 = 0; u2 < a2.geometry[s2].length; u2++)
                      l2.push(yt(a2.geometry[s2][u2], e4));
                    i2.push(l2);
                  }
                r4.push(tt(a2.id, o2, i2, a2.tags));
              }
              return r4;
            }
            function yt(t5, e4) {
              var r4 = [];
              r4.size = t5.size, void 0 !== t5.start && (r4.start = t5.start, r4.end = t5.end);
              for (var n4 = 0; n4 < t5.length; n4 += 3)
                r4.push(t5[n4] + e4, t5[n4 + 1], t5[n4 + 2]);
              return r4;
            }
            function mt(t5, e4) {
              if (t5.transformed)
                return t5;
              var r4, n4, i2, a2 = 1 << t5.z, o2 = t5.x, s2 = t5.y;
              for (r4 = 0; r4 < t5.features.length; r4++) {
                var l2 = t5.features[r4], u2 = l2.geometry, c2 = l2.type;
                if (l2.geometry = [], 1 === c2)
                  for (n4 = 0; n4 < u2.length; n4 += 2)
                    l2.geometry.push(xt(u2[n4], u2[n4 + 1], e4, a2, o2, s2));
                else
                  for (n4 = 0; n4 < u2.length; n4++) {
                    var f3 = [];
                    for (i2 = 0; i2 < u2[n4].length; i2 += 2)
                      f3.push(xt(u2[n4][i2], u2[n4][i2 + 1], e4, a2, o2, s2));
                    l2.geometry.push(f3);
                  }
              }
              return t5.transformed = true, t5;
            }
            function xt(t5, e4, r4, n4, i2, a2) {
              return [Math.round(r4 * (t5 * n4 - i2)), Math.round(r4 * (e4 * n4 - a2))];
            }
            function bt(t5, e4, r4, n4, i2) {
              for (var a2 = e4 === i2.maxZoom ? 0 : i2.tolerance / ((1 << e4) * i2.extent), o2 = { features: [], numPoints: 0, numSimplified: 0, numFeatures: 0, source: null, x: r4, y: n4, z: e4, transformed: false, minX: 2, minY: 1, maxX: -1, maxY: 0 }, s2 = 0; s2 < t5.length; s2++) {
                o2.numFeatures++, _t(o2, t5[s2], a2, i2);
                var l2 = t5[s2].minX, u2 = t5[s2].minY, c2 = t5[s2].maxX, f3 = t5[s2].maxY;
                l2 < o2.minX && (o2.minX = l2), u2 < o2.minY && (o2.minY = u2), c2 > o2.maxX && (o2.maxX = c2), f3 > o2.maxY && (o2.maxY = f3);
              }
              return o2;
            }
            function _t(t5, e4, r4, n4) {
              var i2 = e4.geometry, a2 = e4.type, o2 = [];
              if ("Point" === a2 || "MultiPoint" === a2)
                for (var s2 = 0; s2 < i2.length; s2 += 3)
                  o2.push(i2[s2]), o2.push(i2[s2 + 1]), t5.numPoints++, t5.numSimplified++;
              else if ("LineString" === a2)
                wt(o2, i2, t5, r4, false, false);
              else if ("MultiLineString" === a2 || "Polygon" === a2)
                for (s2 = 0; s2 < i2.length; s2++)
                  wt(o2, i2[s2], t5, r4, "Polygon" === a2, 0 === s2);
              else if ("MultiPolygon" === a2)
                for (var l2 = 0; l2 < i2.length; l2++) {
                  var u2 = i2[l2];
                  for (s2 = 0; s2 < u2.length; s2++)
                    wt(o2, u2[s2], t5, r4, true, 0 === s2);
                }
              if (o2.length) {
                var c2 = e4.tags || null;
                if ("LineString" === a2 && n4.lineMetrics) {
                  for (var f3 in c2 = {}, e4.tags)
                    c2[f3] = e4.tags[f3];
                  c2.mapbox_clip_start = i2.start / i2.size, c2.mapbox_clip_end = i2.end / i2.size;
                }
                var h2 = { geometry: o2, type: "Polygon" === a2 || "MultiPolygon" === a2 ? 3 : "LineString" === a2 || "MultiLineString" === a2 ? 2 : 1, tags: c2 };
                null !== e4.id && (h2.id = e4.id), t5.features.push(h2);
              }
            }
            function wt(t5, e4, r4, n4, i2, a2) {
              var o2 = n4 * n4;
              if (n4 > 0 && e4.size < (i2 ? o2 : n4))
                r4.numPoints += e4.length / 3;
              else {
                for (var s2 = [], l2 = 0; l2 < e4.length; l2 += 3)
                  (0 === n4 || e4[l2 + 2] > o2) && (r4.numSimplified++, s2.push(e4[l2]), s2.push(e4[l2 + 1])), r4.numPoints++;
                i2 && function(t6, e5) {
                  for (var r5 = 0, n5 = 0, i3 = t6.length, a3 = i3 - 2; n5 < i3; a3 = n5, n5 += 2)
                    r5 += (t6[n5] - t6[a3]) * (t6[n5 + 1] + t6[a3 + 1]);
                  if (r5 > 0 === e5)
                    for (n5 = 0, i3 = t6.length; n5 < i3 / 2; n5 += 2) {
                      var o3 = t6[n5], s3 = t6[n5 + 1];
                      t6[n5] = t6[i3 - 2 - n5], t6[n5 + 1] = t6[i3 - 1 - n5], t6[i3 - 2 - n5] = o3, t6[i3 - 1 - n5] = s3;
                    }
                }(s2, a2), t5.push(s2);
              }
            }
            function Tt(t5, e4) {
              var r4 = (e4 = this.options = function(t6, e5) {
                for (var r5 in e5)
                  t6[r5] = e5[r5];
                return t6;
              }(Object.create(this.options), e4)).debug;
              if (r4 && console.time("preprocess data"), e4.maxZoom < 0 || e4.maxZoom > 24)
                throw new Error("maxZoom should be in the 0-24 range");
              if (e4.promoteId && e4.generateId)
                throw new Error("promoteId and generateId cannot be used together.");
              var n4 = function(t6, e5) {
                var r5 = [];
                if ("FeatureCollection" === t6.type)
                  for (var n5 = 0; n5 < t6.features.length; n5++)
                    rt(r5, t6.features[n5], e5, n5);
                else
                  "Feature" === t6.type ? rt(r5, t6, e5) : rt(r5, { geometry: t6 }, e5);
                return r5;
              }(t5, e4);
              this.tiles = {}, this.tileCoords = [], r4 && (console.timeEnd("preprocess data"), console.log("index: maxZoom: %d, maxPoints: %d", e4.indexMaxZoom, e4.indexMaxPoints), console.time("generate tiles"), this.stats = {}, this.total = 0), (n4 = function(t6, e5) {
                var r5 = e5.buffer / e5.extent, n5 = t6, i2 = lt(t6, 1, -1 - r5, r5, 0, -1, 2, e5), a2 = lt(t6, 1, 1 - r5, 2 + r5, 0, -1, 2, e5);
                return (i2 || a2) && (n5 = lt(t6, 1, -r5, 1 + r5, 0, -1, 2, e5) || [], i2 && (n5 = gt(i2, 1).concat(n5)), a2 && (n5 = n5.concat(gt(a2, -1)))), n5;
              }(n4, e4)).length && this.splitTile(n4, 0, 0, 0), r4 && (n4.length && console.log("features: %d, points: %d", this.tiles[0].numFeatures, this.tiles[0].numPoints), console.timeEnd("generate tiles"), console.log("tiles generated:", this.total, JSON.stringify(this.stats)));
            }
            function kt(t5, e4, r4) {
              return 32 * ((1 << t5) * r4 + e4) + t5;
            }
            function At(t5, e4) {
              var r4 = t5.tileID.canonical;
              if (!this._geoJSONIndex)
                return e4(null, null);
              var n4 = this._geoJSONIndex.getTile(r4.z, r4.x, r4.y);
              if (!n4)
                return e4(null, null);
              var i2 = new g2(n4.features), a2 = _(i2);
              0 === a2.byteOffset && a2.byteLength === a2.buffer.byteLength || (a2 = new Uint8Array(a2)), e4(null, { vectorTile: i2, rawData: a2.buffer });
            }
            V.prototype.load = function(t5) {
              var e4 = this.options, r4 = e4.log, n4 = e4.minZoom, i2 = e4.maxZoom, a2 = e4.nodeSize;
              r4 && console.time("total time");
              var o2 = "prepare " + t5.length + " points";
              r4 && console.time(o2), this.points = t5;
              for (var s2 = [], l2 = 0; l2 < t5.length; l2++)
                t5[l2].geometry && s2.push(q2(t5[l2], l2));
              this.trees[i2 + 1] = new j(s2, J, K, a2, Float32Array), r4 && console.timeEnd(o2);
              for (var u2 = i2; u2 >= n4; u2--) {
                var c2 = +Date.now();
                s2 = this._cluster(s2, u2), this.trees[u2] = new j(s2, J, K, a2, Float32Array), r4 && console.log("z%d: %d clusters in %dms", u2, s2.length, +Date.now() - c2);
              }
              return r4 && console.timeEnd("total time"), this;
            }, V.prototype.getClusters = function(t5, e4) {
              var r4 = ((t5[0] + 180) % 360 + 360) % 360 - 180, n4 = Math.max(-90, Math.min(90, t5[1])), i2 = 180 === t5[2] ? 180 : ((t5[2] + 180) % 360 + 360) % 360 - 180, a2 = Math.max(-90, Math.min(90, t5[3]));
              if (t5[2] - t5[0] >= 360)
                r4 = -180, i2 = 180;
              else if (r4 > i2) {
                var o2 = this.getClusters([r4, n4, 180, a2], e4), s2 = this.getClusters([-180, n4, i2, a2], e4);
                return o2.concat(s2);
              }
              for (var l2 = this.trees[this._limitZoom(e4)], u2 = [], c2 = 0, f3 = l2.range(Y(r4), W(a2), Y(i2), W(n4)); c2 < f3.length; c2 += 1) {
                var h2 = f3[c2], p3 = l2.points[h2];
                u2.push(p3.numPoints ? G(p3) : this.points[p3.index]);
              }
              return u2;
            }, V.prototype.getChildren = function(t5) {
              var e4 = this._getOriginId(t5), r4 = this._getOriginZoom(t5), n4 = "No cluster with the specified id.", i2 = this.trees[r4];
              if (!i2)
                throw new Error(n4);
              var a2 = i2.points[e4];
              if (!a2)
                throw new Error(n4);
              for (var o2 = this.options.radius / (this.options.extent * Math.pow(2, r4 - 1)), s2 = [], l2 = 0, u2 = i2.within(a2.x, a2.y, o2); l2 < u2.length; l2 += 1) {
                var c2 = u2[l2], f3 = i2.points[c2];
                f3.parentId === t5 && s2.push(f3.numPoints ? G(f3) : this.points[f3.index]);
              }
              if (0 === s2.length)
                throw new Error(n4);
              return s2;
            }, V.prototype.getLeaves = function(t5, e4, r4) {
              e4 = e4 || 10, r4 = r4 || 0;
              var n4 = [];
              return this._appendLeaves(n4, t5, e4, r4, 0), n4;
            }, V.prototype.getTile = function(t5, e4, r4) {
              var n4 = this.trees[this._limitZoom(t5)], i2 = Math.pow(2, t5), a2 = this.options, o2 = a2.extent, s2 = a2.radius / o2, l2 = (r4 - s2) / i2, u2 = (r4 + 1 + s2) / i2, c2 = { features: [] };
              return this._addTileFeatures(n4.range((e4 - s2) / i2, l2, (e4 + 1 + s2) / i2, u2), n4.points, e4, r4, i2, c2), 0 === e4 && this._addTileFeatures(n4.range(1 - s2 / i2, l2, 1, u2), n4.points, i2, r4, i2, c2), e4 === i2 - 1 && this._addTileFeatures(n4.range(0, l2, s2 / i2, u2), n4.points, -1, r4, i2, c2), c2.features.length ? c2 : null;
            }, V.prototype.getClusterExpansionZoom = function(t5) {
              for (var e4 = this._getOriginZoom(t5) - 1; e4 <= this.options.maxZoom; ) {
                var r4 = this.getChildren(t5);
                if (e4++, 1 !== r4.length)
                  break;
                t5 = r4[0].properties.cluster_id;
              }
              return e4;
            }, V.prototype._appendLeaves = function(t5, e4, r4, n4, i2) {
              for (var a2 = 0, o2 = this.getChildren(e4); a2 < o2.length; a2 += 1) {
                var s2 = o2[a2], l2 = s2.properties;
                if (l2 && l2.cluster ? i2 + l2.point_count <= n4 ? i2 += l2.point_count : i2 = this._appendLeaves(t5, l2.cluster_id, r4, n4, i2) : i2 < n4 ? i2++ : t5.push(s2), t5.length === r4)
                  break;
              }
              return i2;
            }, V.prototype._addTileFeatures = function(t5, e4, r4, n4, i2, a2) {
              for (var o2 = 0, s2 = t5; o2 < s2.length; o2 += 1) {
                var l2 = e4[s2[o2]], u2 = l2.numPoints, c2 = { type: 1, geometry: [[Math.round(this.options.extent * (l2.x * i2 - r4)), Math.round(this.options.extent * (l2.y * i2 - n4))]], tags: u2 ? Z(l2) : this.points[l2.index].properties }, f3 = void 0;
                u2 ? f3 = l2.id : this.options.generateId ? f3 = l2.index : this.points[l2.index].id && (f3 = this.points[l2.index].id), void 0 !== f3 && (c2.id = f3), a2.features.push(c2);
              }
            }, V.prototype._limitZoom = function(t5) {
              return Math.max(this.options.minZoom, Math.min(t5, this.options.maxZoom + 1));
            }, V.prototype._cluster = function(t5, e4) {
              for (var r4 = [], n4 = this.options, i2 = n4.radius, a2 = n4.extent, o2 = n4.reduce, s2 = i2 / (a2 * Math.pow(2, e4)), l2 = 0; l2 < t5.length; l2++) {
                var u2 = t5[l2];
                if (!(u2.zoom <= e4)) {
                  u2.zoom = e4;
                  for (var c2 = this.trees[e4 + 1], f3 = c2.within(u2.x, u2.y, s2), h2 = u2.numPoints || 1, p3 = u2.x * h2, d3 = u2.y * h2, v2 = o2 && h2 > 1 ? this._map(u2, true) : null, g3 = (l2 << 5) + (e4 + 1) + this.points.length, y2 = 0, m3 = f3; y2 < m3.length; y2 += 1) {
                    var x2 = m3[y2], b2 = c2.points[x2];
                    if (!(b2.zoom <= e4)) {
                      b2.zoom = e4;
                      var _2 = b2.numPoints || 1;
                      p3 += b2.x * _2, d3 += b2.y * _2, h2 += _2, b2.parentId = g3, o2 && (v2 || (v2 = this._map(u2, true)), o2(v2, this._map(b2)));
                    }
                  }
                  1 === h2 ? r4.push(u2) : (u2.parentId = g3, r4.push(H(p3 / h2, d3 / h2, g3, h2, v2)));
                }
              }
              return r4;
            }, V.prototype._getOriginId = function(t5) {
              return t5 - this.points.length >> 5;
            }, V.prototype._getOriginZoom = function(t5) {
              return (t5 - this.points.length) % 32;
            }, V.prototype._map = function(t5, e4) {
              if (t5.numPoints)
                return e4 ? X({}, t5.properties) : t5.properties;
              var r4 = this.points[t5.index].properties, n4 = this.options.map(r4);
              return e4 && n4 === r4 ? X({}, n4) : n4;
            }, Tt.prototype.options = { maxZoom: 14, indexMaxZoom: 5, indexMaxPoints: 1e5, tolerance: 3, extent: 4096, buffer: 64, lineMetrics: false, promoteId: null, generateId: false, debug: 0 }, Tt.prototype.splitTile = function(t5, e4, r4, n4, i2, a2, o2) {
              for (var s2 = [t5, e4, r4, n4], l2 = this.options, u2 = l2.debug; s2.length; ) {
                n4 = s2.pop(), r4 = s2.pop(), e4 = s2.pop(), t5 = s2.pop();
                var c2 = 1 << e4, f3 = kt(e4, r4, n4), h2 = this.tiles[f3];
                if (!h2 && (u2 > 1 && console.time("creation"), h2 = this.tiles[f3] = bt(t5, e4, r4, n4, l2), this.tileCoords.push({ z: e4, x: r4, y: n4 }), u2)) {
                  u2 > 1 && (console.log("tile z%d-%d-%d (features: %d, points: %d, simplified: %d)", e4, r4, n4, h2.numFeatures, h2.numPoints, h2.numSimplified), console.timeEnd("creation"));
                  var p3 = "z" + e4;
                  this.stats[p3] = (this.stats[p3] || 0) + 1, this.total++;
                }
                if (h2.source = t5, i2) {
                  if (e4 === l2.maxZoom || e4 === i2)
                    continue;
                  var d3 = 1 << i2 - e4;
                  if (r4 !== Math.floor(a2 / d3) || n4 !== Math.floor(o2 / d3))
                    continue;
                } else if (e4 === l2.indexMaxZoom || h2.numPoints <= l2.indexMaxPoints)
                  continue;
                if (h2.source = null, 0 !== t5.length) {
                  u2 > 1 && console.time("clipping");
                  var v2, g3, y2, m3, x2, b2, _2 = 0.5 * l2.buffer / l2.extent, w3 = 0.5 - _2, T2 = 0.5 + _2, k2 = 1 + _2;
                  v2 = g3 = y2 = m3 = null, x2 = lt(t5, c2, r4 - _2, r4 + T2, 0, h2.minX, h2.maxX, l2), b2 = lt(t5, c2, r4 + w3, r4 + k2, 0, h2.minX, h2.maxX, l2), t5 = null, x2 && (v2 = lt(x2, c2, n4 - _2, n4 + T2, 1, h2.minY, h2.maxY, l2), g3 = lt(x2, c2, n4 + w3, n4 + k2, 1, h2.minY, h2.maxY, l2), x2 = null), b2 && (y2 = lt(b2, c2, n4 - _2, n4 + T2, 1, h2.minY, h2.maxY, l2), m3 = lt(b2, c2, n4 + w3, n4 + k2, 1, h2.minY, h2.maxY, l2), b2 = null), u2 > 1 && console.timeEnd("clipping"), s2.push(v2 || [], e4 + 1, 2 * r4, 2 * n4), s2.push(g3 || [], e4 + 1, 2 * r4, 2 * n4 + 1), s2.push(y2 || [], e4 + 1, 2 * r4 + 1, 2 * n4), s2.push(m3 || [], e4 + 1, 2 * r4 + 1, 2 * n4 + 1);
                }
              }
            }, Tt.prototype.getTile = function(t5, e4, r4) {
              var n4 = this.options, i2 = n4.extent, a2 = n4.debug;
              if (t5 < 0 || t5 > 24)
                return null;
              var o2 = 1 << t5, s2 = kt(t5, e4 = (e4 % o2 + o2) % o2, r4);
              if (this.tiles[s2])
                return mt(this.tiles[s2], i2);
              a2 > 1 && console.log("drilling down to z%d-%d-%d", t5, e4, r4);
              for (var l2, u2 = t5, c2 = e4, f3 = r4; !l2 && u2 > 0; )
                u2--, c2 = Math.floor(c2 / 2), f3 = Math.floor(f3 / 2), l2 = this.tiles[kt(u2, c2, f3)];
              return l2 && l2.source ? (a2 > 1 && console.log("found parent tile z%d-%d-%d", u2, c2, f3), a2 > 1 && console.time("drilling down"), this.splitTile(l2.source, u2, c2, f3, t5, e4, r4), a2 > 1 && console.timeEnd("drilling down"), this.tiles[s2] ? mt(this.tiles[s2], i2) : null) : null;
            };
            var Mt = function(e4) {
              function r4(t5, r5, n4, i2) {
                e4.call(this, t5, r5, n4, At), i2 && (this.loadGeoJSON = i2);
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.loadData = function(t5, e5) {
                this._pendingCallback && this._pendingCallback(null, { abandoned: true }), this._pendingCallback = e5, this._pendingLoadDataParams = t5, this._state && "Idle" !== this._state ? this._state = "NeedsLoadData" : (this._state = "Coalescing", this._loadData());
              }, r4.prototype._loadData = function() {
                var e5 = this;
                if (this._pendingCallback && this._pendingLoadDataParams) {
                  var r5 = this._pendingCallback, n4 = this._pendingLoadDataParams;
                  delete this._pendingCallback, delete this._pendingLoadDataParams;
                  var i2 = !!(n4 && n4.request && n4.request.collectResourceTiming) && new t4.RequestPerformance(n4.request);
                  this.loadGeoJSON(n4, function(a2, o2) {
                    if (a2 || !o2)
                      return r5(a2);
                    if ("object" != typeof o2)
                      return r5(new Error("Input data given to '" + n4.source + "' is not a valid GeoJSON object."));
                    f2(o2, true);
                    try {
                      e5._geoJSONIndex = n4.cluster ? new V(function(e6) {
                        var r6 = e6.superclusterOptions, n5 = e6.clusterProperties;
                        if (!n5 || !r6)
                          return r6;
                        for (var i3 = {}, a3 = {}, o3 = { accumulated: null, zoom: 0 }, s3 = { properties: null }, l3 = Object.keys(n5), u2 = 0, c2 = l3; u2 < c2.length; u2 += 1) {
                          var f3 = c2[u2], h2 = n5[f3], p3 = h2[0], d3 = h2[1], v2 = t4.createExpression(d3), g3 = t4.createExpression("string" == typeof p3 ? [p3, ["accumulated"], ["get", f3]] : p3);
                          i3[f3] = v2.value, a3[f3] = g3.value;
                        }
                        return r6.map = function(t5) {
                          s3.properties = t5;
                          for (var e7 = {}, r7 = 0, n6 = l3; r7 < n6.length; r7 += 1) {
                            var a4 = n6[r7];
                            e7[a4] = i3[a4].evaluate(o3, s3);
                          }
                          return e7;
                        }, r6.reduce = function(t5, e7) {
                          s3.properties = e7;
                          for (var r7 = 0, n6 = l3; r7 < n6.length; r7 += 1) {
                            var i4 = n6[r7];
                            o3.accumulated = t5[i4], t5[i4] = a3[i4].evaluate(o3, s3);
                          }
                        }, r6;
                      }(n4)).load(o2.features) : function(t5, e6) {
                        return new Tt(t5, e6);
                      }(o2, n4.geojsonVtOptions);
                    } catch (a3) {
                      return r5(a3);
                    }
                    e5.loaded = {};
                    var s2 = {};
                    if (i2) {
                      var l2 = i2.finish();
                      l2 && (s2.resourceTiming = {}, s2.resourceTiming[n4.source] = JSON.parse(JSON.stringify(l2)));
                    }
                    r5(null, s2);
                  });
                }
              }, r4.prototype.coalesce = function() {
                "Coalescing" === this._state ? this._state = "Idle" : "NeedsLoadData" === this._state && (this._state = "Coalescing", this._loadData());
              }, r4.prototype.reloadTile = function(t5, r5) {
                var n4 = this.loaded, i2 = t5.uid;
                return n4 && n4[i2] ? e4.prototype.reloadTile.call(this, t5, r5) : this.loadTile(t5, r5);
              }, r4.prototype.loadGeoJSON = function(e5, r5) {
                if (e5.request)
                  t4.getJSON(e5.request, r5);
                else {
                  if ("string" != typeof e5.data)
                    return r5(new Error("Input data given to '" + e5.source + "' is not a valid GeoJSON object."));
                  try {
                    return r5(null, JSON.parse(e5.data));
                  } catch (t5) {
                    return r5(new Error("Input data given to '" + e5.source + "' is not a valid GeoJSON object."));
                  }
                }
              }, r4.prototype.removeSource = function(t5, e5) {
                this._pendingCallback && this._pendingCallback(null, { abandoned: true }), e5();
              }, r4.prototype.getClusterExpansionZoom = function(t5, e5) {
                try {
                  e5(null, this._geoJSONIndex.getClusterExpansionZoom(t5.clusterId));
                } catch (t6) {
                  e5(t6);
                }
              }, r4.prototype.getClusterChildren = function(t5, e5) {
                try {
                  e5(null, this._geoJSONIndex.getChildren(t5.clusterId));
                } catch (t6) {
                  e5(t6);
                }
              }, r4.prototype.getClusterLeaves = function(t5, e5) {
                try {
                  e5(null, this._geoJSONIndex.getLeaves(t5.clusterId, t5.limit, t5.offset));
                } catch (t6) {
                  e5(t6);
                }
              }, r4;
            }(l);
            var St = function(e4) {
              var r4 = this;
              this.self = e4, this.actor = new t4.Actor(e4, this), this.layerIndexes = {}, this.availableImages = {}, this.workerSourceTypes = { vector: l, geojson: Mt }, this.workerSources = {}, this.demWorkerSources = {}, this.self.registerWorkerSource = function(t5, e5) {
                if (r4.workerSourceTypes[t5])
                  throw new Error('Worker source with name "' + t5 + '" already registered.');
                r4.workerSourceTypes[t5] = e5;
              }, this.self.registerRTLTextPlugin = function(e5) {
                if (t4.plugin.isParsed())
                  throw new Error("RTL text plugin already registered.");
                t4.plugin.applyArabicShaping = e5.applyArabicShaping, t4.plugin.processBidirectionalText = e5.processBidirectionalText, t4.plugin.processStyledBidirectionalText = e5.processStyledBidirectionalText;
              };
            };
            return St.prototype.setReferrer = function(t5, e4) {
              this.referrer = e4;
            }, St.prototype.setImages = function(t5, e4, r4) {
              for (var n4 in this.availableImages[t5] = e4, this.workerSources[t5]) {
                var i2 = this.workerSources[t5][n4];
                for (var a2 in i2)
                  i2[a2].availableImages = e4;
              }
              r4();
            }, St.prototype.setLayers = function(t5, e4, r4) {
              this.getLayerIndex(t5).replace(e4), r4();
            }, St.prototype.updateLayers = function(t5, e4, r4) {
              this.getLayerIndex(t5).update(e4.layers, e4.removedIds), r4();
            }, St.prototype.loadTile = function(t5, e4, r4) {
              this.getWorkerSource(t5, e4.type, e4.source).loadTile(e4, r4);
            }, St.prototype.loadDEMTile = function(t5, e4, r4) {
              this.getDEMWorkerSource(t5, e4.source).loadTile(e4, r4);
            }, St.prototype.reloadTile = function(t5, e4, r4) {
              this.getWorkerSource(t5, e4.type, e4.source).reloadTile(e4, r4);
            }, St.prototype.abortTile = function(t5, e4, r4) {
              this.getWorkerSource(t5, e4.type, e4.source).abortTile(e4, r4);
            }, St.prototype.removeTile = function(t5, e4, r4) {
              this.getWorkerSource(t5, e4.type, e4.source).removeTile(e4, r4);
            }, St.prototype.removeDEMTile = function(t5, e4) {
              this.getDEMWorkerSource(t5, e4.source).removeTile(e4);
            }, St.prototype.removeSource = function(t5, e4, r4) {
              if (this.workerSources[t5] && this.workerSources[t5][e4.type] && this.workerSources[t5][e4.type][e4.source]) {
                var n4 = this.workerSources[t5][e4.type][e4.source];
                delete this.workerSources[t5][e4.type][e4.source], void 0 !== n4.removeSource ? n4.removeSource(e4, r4) : r4();
              }
            }, St.prototype.loadWorkerSource = function(t5, e4, r4) {
              try {
                this.self.importScripts(e4.url), r4();
              } catch (t6) {
                r4(t6.toString());
              }
            }, St.prototype.syncRTLPluginState = function(e4, r4, n4) {
              try {
                t4.plugin.setState(r4);
                var i2 = t4.plugin.getPluginURL();
                if (t4.plugin.isLoaded() && !t4.plugin.isParsed() && null != i2) {
                  this.self.importScripts(i2);
                  var a2 = t4.plugin.isParsed();
                  n4(a2 ? void 0 : new Error("RTL Text Plugin failed to import scripts from " + i2), a2);
                }
              } catch (t5) {
                n4(t5.toString());
              }
            }, St.prototype.getAvailableImages = function(t5) {
              var e4 = this.availableImages[t5];
              return e4 || (e4 = []), e4;
            }, St.prototype.getLayerIndex = function(t5) {
              var e4 = this.layerIndexes[t5];
              return e4 || (e4 = this.layerIndexes[t5] = new n3()), e4;
            }, St.prototype.getWorkerSource = function(t5, e4, r4) {
              var n4 = this;
              if (this.workerSources[t5] || (this.workerSources[t5] = {}), this.workerSources[t5][e4] || (this.workerSources[t5][e4] = {}), !this.workerSources[t5][e4][r4]) {
                var i2 = { send: function(e5, r5, i3) {
                  n4.actor.send(e5, r5, i3, t5);
                } };
                this.workerSources[t5][e4][r4] = new this.workerSourceTypes[e4](i2, this.getLayerIndex(t5), this.getAvailableImages(t5));
              }
              return this.workerSources[t5][e4][r4];
            }, St.prototype.getDEMWorkerSource = function(t5, e4) {
              return this.demWorkerSources[t5] || (this.demWorkerSources[t5] = {}), this.demWorkerSources[t5][e4] || (this.demWorkerSources[t5][e4] = new c()), this.demWorkerSources[t5][e4];
            }, St.prototype.enforceCacheSizeLimit = function(e4, r4) {
              t4.enforceCacheSizeLimit(r4);
            }, "undefined" != typeof WorkerGlobalScope && void 0 !== t4.window && t4.window instanceof WorkerGlobalScope && (t4.window.worker = new St(t4.window)), St;
          }), n2(0, function(t4) {
            var e3 = t4.createCommonjsModule(function(t5) {
              function e4(t6) {
                return !r4(t6);
              }
              function r4(t6) {
                return "undefined" != typeof window && "undefined" != typeof document ? Array.prototype && Array.prototype.every && Array.prototype.filter && Array.prototype.forEach && Array.prototype.indexOf && Array.prototype.lastIndexOf && Array.prototype.map && Array.prototype.some && Array.prototype.reduce && Array.prototype.reduceRight && Array.isArray ? Function.prototype && Function.prototype.bind ? Object.keys && Object.create && Object.getPrototypeOf && Object.getOwnPropertyNames && Object.isSealed && Object.isFrozen && Object.isExtensible && Object.getOwnPropertyDescriptor && Object.defineProperty && Object.defineProperties && Object.seal && Object.freeze && Object.preventExtensions ? "JSON" in window && "parse" in JSON && "stringify" in JSON ? function() {
                  if (!("Worker" in window && "Blob" in window && "URL" in window))
                    return false;
                  var t7, e5, r6 = new Blob([""], { type: "text/javascript" }), n5 = URL.createObjectURL(r6);
                  try {
                    e5 = new Worker(n5), t7 = true;
                  } catch (e6) {
                    t7 = false;
                  }
                  return e5 && e5.terminate(), URL.revokeObjectURL(n5), t7;
                }() ? "Uint8ClampedArray" in window ? ArrayBuffer.isView ? function() {
                  var t7 = document.createElement("canvas");
                  t7.width = t7.height = 1;
                  var e5 = t7.getContext("2d");
                  if (!e5)
                    return false;
                  var r6 = e5.getImageData(0, 0, 1, 1);
                  return r6 && r6.width === t7.width;
                }() ? (r5 = t6 && t6.failIfMajorPerformanceCaveat, void 0 === n4[r5] && (n4[r5] = function(t7) {
                  var r6 = function(t8) {
                    var r7 = document.createElement("canvas"), n6 = Object.create(e4.webGLContextAttributes);
                    return n6.failIfMajorPerformanceCaveat = t8, r7.probablySupportsContext ? r7.probablySupportsContext("webgl", n6) || r7.probablySupportsContext("experimental-webgl", n6) : r7.supportsContext ? r7.supportsContext("webgl", n6) || r7.supportsContext("experimental-webgl", n6) : r7.getContext("webgl", n6) || r7.getContext("experimental-webgl", n6);
                  }(t7);
                  if (!r6)
                    return false;
                  var n5 = r6.createShader(r6.VERTEX_SHADER);
                  return !(!n5 || r6.isContextLost()) && (r6.shaderSource(n5, "void main() {}"), r6.compileShader(n5), true === r6.getShaderParameter(n5, r6.COMPILE_STATUS));
                }(r5)), n4[r5] ? void 0 : "insufficient WebGL support") : "insufficient Canvas/getImageData support" : "insufficient ArrayBuffer support" : "insufficient Uint8ClampedArray support" : "insufficient worker support" : "insufficient JSON support" : "insufficient Object support" : "insufficient Function support" : "insufficent Array support" : "not a browser";
                var r5;
              }
              t5.exports ? t5.exports = e4 : window && (window.mapboxgl = window.mapboxgl || {}, window.mapboxgl.supported = e4, window.mapboxgl.notSupportedReason = r4);
              var n4 = {};
              e4.webGLContextAttributes = { antialias: false, alpha: true, stencil: true, depth: true };
            }), r3 = { create: function(e4, r4, n4) {
              var i2 = t4.window.document.createElement(e4);
              return void 0 !== r4 && (i2.className = r4), n4 && n4.appendChild(i2), i2;
            }, createNS: function(e4, r4) {
              return t4.window.document.createElementNS(e4, r4);
            } }, n3 = t4.window.document.documentElement.style;
            function i(t5) {
              if (!n3)
                return t5[0];
              for (var e4 = 0; e4 < t5.length; e4++)
                if (t5[e4] in n3)
                  return t5[e4];
              return t5[0];
            }
            var a, o = i(["userSelect", "MozUserSelect", "WebkitUserSelect", "msUserSelect"]);
            r3.disableDrag = function() {
              n3 && o && (a = n3[o], n3[o] = "none");
            }, r3.enableDrag = function() {
              n3 && o && (n3[o] = a);
            };
            var s = i(["transform", "WebkitTransform"]);
            r3.setTransform = function(t5, e4) {
              t5.style[s] = e4;
            };
            var l = false;
            try {
              var u = Object.defineProperty({}, "passive", { get: function() {
                l = true;
              } });
              t4.window.addEventListener("test", u, u), t4.window.removeEventListener("test", u, u);
            } catch (t5) {
              l = false;
            }
            r3.addEventListener = function(t5, e4, r4, n4) {
              void 0 === n4 && (n4 = {}), "passive" in n4 && l ? t5.addEventListener(e4, r4, n4) : t5.addEventListener(e4, r4, n4.capture);
            }, r3.removeEventListener = function(t5, e4, r4, n4) {
              void 0 === n4 && (n4 = {}), "passive" in n4 && l ? t5.removeEventListener(e4, r4, n4) : t5.removeEventListener(e4, r4, n4.capture);
            };
            var c = function(e4) {
              e4.preventDefault(), e4.stopPropagation(), t4.window.removeEventListener("click", c, true);
            };
            function f2(t5) {
              var e4 = t5.userImage;
              return !!(e4 && e4.render && e4.render()) && (t5.data.replace(new Uint8Array(e4.data.buffer)), true);
            }
            r3.suppressClick = function() {
              t4.window.addEventListener("click", c, true), t4.window.setTimeout(function() {
                t4.window.removeEventListener("click", c, true);
              }, 0);
            }, r3.mousePos = function(e4, r4) {
              var n4 = e4.getBoundingClientRect();
              return new t4.Point(r4.clientX - n4.left - e4.clientLeft, r4.clientY - n4.top - e4.clientTop);
            }, r3.touchPos = function(e4, r4) {
              for (var n4 = e4.getBoundingClientRect(), i2 = [], a2 = 0; a2 < r4.length; a2++)
                i2.push(new t4.Point(r4[a2].clientX - n4.left - e4.clientLeft, r4[a2].clientY - n4.top - e4.clientTop));
              return i2;
            }, r3.mouseButton = function(e4) {
              return void 0 !== t4.window.InstallTrigger && 2 === e4.button && e4.ctrlKey && t4.window.navigator.platform.toUpperCase().indexOf("MAC") >= 0 ? 0 : e4.button;
            }, r3.remove = function(t5) {
              t5.parentNode && t5.parentNode.removeChild(t5);
            };
            var h = function(e4) {
              function r4() {
                e4.call(this), this.images = {}, this.updatedImages = {}, this.callbackDispatchedThisFrame = {}, this.loaded = false, this.requestors = [], this.patterns = {}, this.atlasImage = new t4.RGBAImage({ width: 1, height: 1 }), this.dirty = true;
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.isLoaded = function() {
                return this.loaded;
              }, r4.prototype.setLoaded = function(t5) {
                if (this.loaded !== t5 && (this.loaded = t5, t5)) {
                  for (var e5 = 0, r5 = this.requestors; e5 < r5.length; e5 += 1) {
                    var n4 = r5[e5], i2 = n4.ids, a2 = n4.callback;
                    this._notify(i2, a2);
                  }
                  this.requestors = [];
                }
              }, r4.prototype.getImage = function(t5) {
                return this.images[t5];
              }, r4.prototype.addImage = function(t5, e5) {
                this._validate(t5, e5) && (this.images[t5] = e5);
              }, r4.prototype._validate = function(e5, r5) {
                var n4 = true;
                return this._validateStretch(r5.stretchX, r5.data && r5.data.width) || (this.fire(new t4.ErrorEvent(new Error('Image "' + e5 + '" has invalid "stretchX" value'))), n4 = false), this._validateStretch(r5.stretchY, r5.data && r5.data.height) || (this.fire(new t4.ErrorEvent(new Error('Image "' + e5 + '" has invalid "stretchY" value'))), n4 = false), this._validateContent(r5.content, r5) || (this.fire(new t4.ErrorEvent(new Error('Image "' + e5 + '" has invalid "content" value'))), n4 = false), n4;
              }, r4.prototype._validateStretch = function(t5, e5) {
                if (!t5)
                  return true;
                for (var r5 = 0, n4 = 0, i2 = t5; n4 < i2.length; n4 += 1) {
                  var a2 = i2[n4];
                  if (a2[0] < r5 || a2[1] < a2[0] || e5 < a2[1])
                    return false;
                  r5 = a2[1];
                }
                return true;
              }, r4.prototype._validateContent = function(t5, e5) {
                return !(t5 && (4 !== t5.length || t5[0] < 0 || e5.data.width < t5[0] || t5[1] < 0 || e5.data.height < t5[1] || t5[2] < 0 || e5.data.width < t5[2] || t5[3] < 0 || e5.data.height < t5[3] || t5[2] < t5[0] || t5[3] < t5[1]));
              }, r4.prototype.updateImage = function(t5, e5) {
                var r5 = this.images[t5];
                e5.version = r5.version + 1, this.images[t5] = e5, this.updatedImages[t5] = true;
              }, r4.prototype.removeImage = function(t5) {
                var e5 = this.images[t5];
                delete this.images[t5], delete this.patterns[t5], e5.userImage && e5.userImage.onRemove && e5.userImage.onRemove();
              }, r4.prototype.listImages = function() {
                return Object.keys(this.images);
              }, r4.prototype.getImages = function(t5, e5) {
                var r5 = true;
                if (!this.isLoaded())
                  for (var n4 = 0, i2 = t5; n4 < i2.length; n4 += 1) {
                    var a2 = i2[n4];
                    this.images[a2] || (r5 = false);
                  }
                this.isLoaded() || r5 ? this._notify(t5, e5) : this.requestors.push({ ids: t5, callback: e5 });
              }, r4.prototype._notify = function(e5, r5) {
                for (var n4 = {}, i2 = 0, a2 = e5; i2 < a2.length; i2 += 1) {
                  var o2 = a2[i2];
                  this.images[o2] || this.fire(new t4.Event("styleimagemissing", { id: o2 }));
                  var s2 = this.images[o2];
                  s2 ? n4[o2] = { data: s2.data.clone(), pixelRatio: s2.pixelRatio, sdf: s2.sdf, version: s2.version, stretchX: s2.stretchX, stretchY: s2.stretchY, content: s2.content, hasRenderCallback: Boolean(s2.userImage && s2.userImage.render) } : t4.warnOnce('Image "' + o2 + '" could not be loaded. Please make sure you have added the image with map.addImage() or a "sprite" property in your style. You can provide missing images by listening for the "styleimagemissing" map event.');
                }
                r5(null, n4);
              }, r4.prototype.getPixelSize = function() {
                var t5 = this.atlasImage;
                return { width: t5.width, height: t5.height };
              }, r4.prototype.getPattern = function(e5) {
                var r5 = this.patterns[e5], n4 = this.getImage(e5);
                if (!n4)
                  return null;
                if (r5 && r5.position.version === n4.version)
                  return r5.position;
                if (r5)
                  r5.position.version = n4.version;
                else {
                  var i2 = { w: n4.data.width + 2, h: n4.data.height + 2, x: 0, y: 0 }, a2 = new t4.ImagePosition(i2, n4);
                  this.patterns[e5] = { bin: i2, position: a2 };
                }
                return this._updatePatternAtlas(), this.patterns[e5].position;
              }, r4.prototype.bind = function(e5) {
                var r5 = e5.gl;
                this.atlasTexture ? this.dirty && (this.atlasTexture.update(this.atlasImage), this.dirty = false) : this.atlasTexture = new t4.Texture(e5, this.atlasImage, r5.RGBA), this.atlasTexture.bind(r5.LINEAR, r5.CLAMP_TO_EDGE);
              }, r4.prototype._updatePatternAtlas = function() {
                var e5 = [];
                for (var r5 in this.patterns)
                  e5.push(this.patterns[r5].bin);
                var n4 = t4.potpack(e5), i2 = n4.w, a2 = n4.h, o2 = this.atlasImage;
                for (var s2 in o2.resize({ width: i2 || 1, height: a2 || 1 }), this.patterns) {
                  var l2 = this.patterns[s2].bin, u2 = l2.x + 1, c2 = l2.y + 1, f3 = this.images[s2].data, h2 = f3.width, p3 = f3.height;
                  t4.RGBAImage.copy(f3, o2, { x: 0, y: 0 }, { x: u2, y: c2 }, { width: h2, height: p3 }), t4.RGBAImage.copy(f3, o2, { x: 0, y: p3 - 1 }, { x: u2, y: c2 - 1 }, { width: h2, height: 1 }), t4.RGBAImage.copy(f3, o2, { x: 0, y: 0 }, { x: u2, y: c2 + p3 }, { width: h2, height: 1 }), t4.RGBAImage.copy(f3, o2, { x: h2 - 1, y: 0 }, { x: u2 - 1, y: c2 }, { width: 1, height: p3 }), t4.RGBAImage.copy(f3, o2, { x: 0, y: 0 }, { x: u2 + h2, y: c2 }, { width: 1, height: p3 });
                }
                this.dirty = true;
              }, r4.prototype.beginFrame = function() {
                this.callbackDispatchedThisFrame = {};
              }, r4.prototype.dispatchRenderCallbacks = function(t5) {
                for (var e5 = 0, r5 = t5; e5 < r5.length; e5 += 1) {
                  var n4 = r5[e5];
                  if (!this.callbackDispatchedThisFrame[n4]) {
                    this.callbackDispatchedThisFrame[n4] = true;
                    var i2 = this.images[n4];
                    f2(i2) && this.updateImage(n4, i2);
                  }
                }
              }, r4;
            }(t4.Evented);
            var p2 = g2, d2 = g2, v = 1e20;
            function g2(t5, e4, r4, n4, i2, a2) {
              this.fontSize = t5 || 24, this.buffer = void 0 === e4 ? 3 : e4, this.cutoff = n4 || 0.25, this.fontFamily = i2 || "sans-serif", this.fontWeight = a2 || "normal", this.radius = r4 || 8;
              var o2 = this.size = this.fontSize + 2 * this.buffer;
              this.canvas = document.createElement("canvas"), this.canvas.width = this.canvas.height = o2, this.ctx = this.canvas.getContext("2d"), this.ctx.font = this.fontWeight + " " + this.fontSize + "px " + this.fontFamily, this.ctx.textBaseline = "middle", this.ctx.fillStyle = "black", this.gridOuter = new Float64Array(o2 * o2), this.gridInner = new Float64Array(o2 * o2), this.f = new Float64Array(o2), this.d = new Float64Array(o2), this.z = new Float64Array(o2 + 1), this.v = new Int16Array(o2), this.middle = Math.round(o2 / 2 * (navigator.userAgent.indexOf("Gecko/") >= 0 ? 1.2 : 1));
            }
            function y(t5, e4, r4, n4, i2, a2, o2) {
              for (var s2 = 0; s2 < e4; s2++) {
                for (var l2 = 0; l2 < r4; l2++)
                  n4[l2] = t5[l2 * e4 + s2];
                for (m2(n4, i2, a2, o2, r4), l2 = 0; l2 < r4; l2++)
                  t5[l2 * e4 + s2] = i2[l2];
              }
              for (l2 = 0; l2 < r4; l2++) {
                for (s2 = 0; s2 < e4; s2++)
                  n4[s2] = t5[l2 * e4 + s2];
                for (m2(n4, i2, a2, o2, e4), s2 = 0; s2 < e4; s2++)
                  t5[l2 * e4 + s2] = Math.sqrt(i2[s2]);
              }
            }
            function m2(t5, e4, r4, n4, i2) {
              r4[0] = 0, n4[0] = -v, n4[1] = +v;
              for (var a2 = 1, o2 = 0; a2 < i2; a2++) {
                for (var s2 = (t5[a2] + a2 * a2 - (t5[r4[o2]] + r4[o2] * r4[o2])) / (2 * a2 - 2 * r4[o2]); s2 <= n4[o2]; )
                  o2--, s2 = (t5[a2] + a2 * a2 - (t5[r4[o2]] + r4[o2] * r4[o2])) / (2 * a2 - 2 * r4[o2]);
                r4[++o2] = a2, n4[o2] = s2, n4[o2 + 1] = +v;
              }
              for (a2 = 0, o2 = 0; a2 < i2; a2++) {
                for (; n4[o2 + 1] < a2; )
                  o2++;
                e4[a2] = (a2 - r4[o2]) * (a2 - r4[o2]) + t5[r4[o2]];
              }
            }
            g2.prototype.draw = function(t5) {
              this.ctx.clearRect(0, 0, this.size, this.size), this.ctx.fillText(t5, this.buffer, this.middle);
              for (var e4 = this.ctx.getImageData(0, 0, this.size, this.size), r4 = new Uint8ClampedArray(this.size * this.size), n4 = 0; n4 < this.size * this.size; n4++) {
                var i2 = e4.data[4 * n4 + 3] / 255;
                this.gridOuter[n4] = 1 === i2 ? 0 : 0 === i2 ? v : Math.pow(Math.max(0, 0.5 - i2), 2), this.gridInner[n4] = 1 === i2 ? v : 0 === i2 ? 0 : Math.pow(Math.max(0, i2 - 0.5), 2);
              }
              for (y(this.gridOuter, this.size, this.size, this.f, this.d, this.v, this.z), y(this.gridInner, this.size, this.size, this.f, this.d, this.v, this.z), n4 = 0; n4 < this.size * this.size; n4++) {
                var a2 = this.gridOuter[n4] - this.gridInner[n4];
                r4[n4] = Math.max(0, Math.min(255, Math.round(255 - 255 * (a2 / this.radius + this.cutoff))));
              }
              return r4;
            }, p2.default = d2;
            var x = function(t5, e4) {
              this.requestManager = t5, this.localIdeographFontFamily = e4, this.entries = {};
            };
            x.prototype.setURL = function(t5) {
              this.url = t5;
            }, x.prototype.getGlyphs = function(e4, r4) {
              var n4 = this, i2 = [];
              for (var a2 in e4)
                for (var o2 = 0, s2 = e4[a2]; o2 < s2.length; o2 += 1) {
                  var l2 = s2[o2];
                  i2.push({ stack: a2, id: l2 });
                }
              t4.asyncAll(i2, function(t5, e5) {
                var r5 = t5.stack, i3 = t5.id, a3 = n4.entries[r5];
                a3 || (a3 = n4.entries[r5] = { glyphs: {}, requests: {}, ranges: {} });
                var o3 = a3.glyphs[i3];
                if (void 0 === o3) {
                  if (o3 = n4._tinySDF(a3, r5, i3))
                    return a3.glyphs[i3] = o3, void e5(null, { stack: r5, id: i3, glyph: o3 });
                  var s3 = Math.floor(i3 / 256);
                  if (256 * s3 > 65535)
                    e5(new Error("glyphs > 65535 not supported"));
                  else if (a3.ranges[s3])
                    e5(null, { stack: r5, id: i3, glyph: o3 });
                  else {
                    var l3 = a3.requests[s3];
                    l3 || (l3 = a3.requests[s3] = [], x.loadGlyphRange(r5, s3, n4.url, n4.requestManager, function(t6, e6) {
                      if (e6) {
                        for (var r6 in e6)
                          n4._doesCharSupportLocalGlyph(+r6) || (a3.glyphs[+r6] = e6[+r6]);
                        a3.ranges[s3] = true;
                      }
                      for (var i4 = 0, o4 = l3; i4 < o4.length; i4 += 1)
                        (0, o4[i4])(t6, e6);
                      delete a3.requests[s3];
                    })), l3.push(function(t6, n5) {
                      t6 ? e5(t6) : n5 && e5(null, { stack: r5, id: i3, glyph: n5[i3] || null });
                    });
                  }
                } else
                  e5(null, { stack: r5, id: i3, glyph: o3 });
              }, function(t5, e5) {
                if (t5)
                  r4(t5);
                else if (e5) {
                  for (var n5 = {}, i3 = 0, a3 = e5; i3 < a3.length; i3 += 1) {
                    var o3 = a3[i3], s3 = o3.stack, l3 = o3.id, u2 = o3.glyph;
                    (n5[s3] || (n5[s3] = {}))[l3] = u2 && { id: u2.id, bitmap: u2.bitmap.clone(), metrics: u2.metrics };
                  }
                  r4(null, n5);
                }
              });
            }, x.prototype._doesCharSupportLocalGlyph = function(e4) {
              return !!this.localIdeographFontFamily && (t4.isChar["CJK Unified Ideographs"](e4) || t4.isChar["Hangul Syllables"](e4) || t4.isChar.Hiragana(e4) || t4.isChar.Katakana(e4));
            }, x.prototype._tinySDF = function(e4, r4, n4) {
              var i2 = this.localIdeographFontFamily;
              if (i2 && this._doesCharSupportLocalGlyph(n4)) {
                var a2 = e4.tinySDF;
                if (!a2) {
                  var o2 = "400";
                  /bold/i.test(r4) ? o2 = "900" : /medium/i.test(r4) ? o2 = "500" : /light/i.test(r4) && (o2 = "200"), a2 = e4.tinySDF = new x.TinySDF(24, 3, 8, 0.25, i2, o2);
                }
                return { id: n4, bitmap: new t4.AlphaImage({ width: 30, height: 30 }, a2.draw(String.fromCharCode(n4))), metrics: { width: 24, height: 24, left: 0, top: -8, advance: 24 } };
              }
            }, x.loadGlyphRange = function(e4, r4, n4, i2, a2) {
              var o2 = 256 * r4, s2 = o2 + 255, l2 = i2.transformRequest(i2.normalizeGlyphsURL(n4).replace("{fontstack}", e4).replace("{range}", o2 + "-" + s2), t4.ResourceType.Glyphs);
              t4.getArrayBuffer(l2, function(e5, r5) {
                if (e5)
                  a2(e5);
                else if (r5) {
                  for (var n5 = {}, i3 = 0, o3 = t4.parseGlyphPBF(r5); i3 < o3.length; i3 += 1) {
                    var s3 = o3[i3];
                    n5[s3.id] = s3;
                  }
                  a2(null, n5);
                }
              });
            }, x.TinySDF = p2;
            var b = function() {
              this.specification = t4.styleSpec.light.position;
            };
            b.prototype.possiblyEvaluate = function(e4, r4) {
              return t4.sphericalToCartesian(e4.expression.evaluate(r4));
            }, b.prototype.interpolate = function(e4, r4, n4) {
              return { x: t4.number(e4.x, r4.x, n4), y: t4.number(e4.y, r4.y, n4), z: t4.number(e4.z, r4.z, n4) };
            };
            var _ = new t4.Properties({ anchor: new t4.DataConstantProperty(t4.styleSpec.light.anchor), position: new b(), color: new t4.DataConstantProperty(t4.styleSpec.light.color), intensity: new t4.DataConstantProperty(t4.styleSpec.light.intensity) }), w2 = "-transition", T = function(e4) {
              function r4(r5) {
                e4.call(this), this._transitionable = new t4.Transitionable(_), this.setLight(r5), this._transitioning = this._transitionable.untransitioned();
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.getLight = function() {
                return this._transitionable.serialize();
              }, r4.prototype.setLight = function(e5, r5) {
                if (void 0 === r5 && (r5 = {}), !this._validate(t4.validateLight, e5, r5))
                  for (var n4 in e5) {
                    var i2 = e5[n4];
                    t4.endsWith(n4, w2) ? this._transitionable.setTransition(n4.slice(0, -w2.length), i2) : this._transitionable.setValue(n4, i2);
                  }
              }, r4.prototype.updateTransitions = function(t5) {
                this._transitioning = this._transitionable.transitioned(t5, this._transitioning);
              }, r4.prototype.hasTransition = function() {
                return this._transitioning.hasTransition();
              }, r4.prototype.recalculate = function(t5) {
                this.properties = this._transitioning.possiblyEvaluate(t5);
              }, r4.prototype._validate = function(e5, r5, n4) {
                return (!n4 || false !== n4.validate) && t4.emitValidationErrors(this, e5.call(t4.validateStyle, t4.extend({ value: r5, style: { glyphs: true, sprite: true }, styleSpec: t4.styleSpec })));
              }, r4;
            }(t4.Evented), k = function(t5, e4) {
              this.width = t5, this.height = e4, this.nextRow = 0, this.data = new Uint8Array(this.width * this.height), this.dashEntry = {};
            };
            k.prototype.getDash = function(t5, e4) {
              var r4 = t5.join(",") + String(e4);
              return this.dashEntry[r4] || (this.dashEntry[r4] = this.addDash(t5, e4)), this.dashEntry[r4];
            }, k.prototype.getDashRanges = function(t5, e4, r4) {
              var n4 = [], i2 = t5.length % 2 == 1 ? -t5[t5.length - 1] * r4 : 0, a2 = t5[0] * r4, o2 = true;
              n4.push({ left: i2, right: a2, isDash: o2, zeroLength: 0 === t5[0] });
              for (var s2 = t5[0], l2 = 1; l2 < t5.length; l2++) {
                o2 = !o2;
                var u2 = t5[l2];
                i2 = s2 * r4, a2 = (s2 += u2) * r4, n4.push({ left: i2, right: a2, isDash: o2, zeroLength: 0 === u2 });
              }
              return n4;
            }, k.prototype.addRoundDash = function(t5, e4, r4) {
              for (var n4 = e4 / 2, i2 = -r4; i2 <= r4; i2++)
                for (var a2 = this.nextRow + r4 + i2, o2 = this.width * a2, s2 = 0, l2 = t5[s2], u2 = 0; u2 < this.width; u2++) {
                  u2 / l2.right > 1 && (l2 = t5[++s2]);
                  var c2 = Math.abs(u2 - l2.left), f3 = Math.abs(u2 - l2.right), h2 = Math.min(c2, f3), p3 = void 0, d3 = i2 / r4 * (n4 + 1);
                  if (l2.isDash) {
                    var v2 = n4 - Math.abs(d3);
                    p3 = Math.sqrt(h2 * h2 + v2 * v2);
                  } else
                    p3 = n4 - Math.sqrt(h2 * h2 + d3 * d3);
                  this.data[o2 + u2] = Math.max(0, Math.min(255, p3 + 128));
                }
            }, k.prototype.addRegularDash = function(t5) {
              for (var e4 = t5.length - 1; e4 >= 0; --e4) {
                var r4 = t5[e4], n4 = t5[e4 + 1];
                r4.zeroLength ? t5.splice(e4, 1) : n4 && n4.isDash === r4.isDash && (n4.left = r4.left, t5.splice(e4, 1));
              }
              var i2 = t5[0], a2 = t5[t5.length - 1];
              i2.isDash === a2.isDash && (i2.left = a2.left - this.width, a2.right = i2.right + this.width);
              for (var o2 = this.width * this.nextRow, s2 = 0, l2 = t5[s2], u2 = 0; u2 < this.width; u2++) {
                u2 / l2.right > 1 && (l2 = t5[++s2]);
                var c2 = Math.abs(u2 - l2.left), f3 = Math.abs(u2 - l2.right), h2 = Math.min(c2, f3), p3 = l2.isDash ? h2 : -h2;
                this.data[o2 + u2] = Math.max(0, Math.min(255, p3 + 128));
              }
            }, k.prototype.addDash = function(e4, r4) {
              var n4 = r4 ? 7 : 0, i2 = 2 * n4 + 1;
              if (this.nextRow + i2 > this.height)
                return t4.warnOnce("LineAtlas out of space"), null;
              for (var a2 = 0, o2 = 0; o2 < e4.length; o2++)
                a2 += e4[o2];
              if (0 !== a2) {
                var s2 = this.width / a2, l2 = this.getDashRanges(e4, this.width, s2);
                r4 ? this.addRoundDash(l2, s2, n4) : this.addRegularDash(l2);
              }
              var u2 = { y: (this.nextRow + n4 + 0.5) / this.height, height: 2 * n4 / this.height, width: a2 };
              return this.nextRow += i2, this.dirty = true, u2;
            }, k.prototype.bind = function(t5) {
              var e4 = t5.gl;
              this.texture ? (e4.bindTexture(e4.TEXTURE_2D, this.texture), this.dirty && (this.dirty = false, e4.texSubImage2D(e4.TEXTURE_2D, 0, 0, 0, this.width, this.height, e4.ALPHA, e4.UNSIGNED_BYTE, this.data))) : (this.texture = e4.createTexture(), e4.bindTexture(e4.TEXTURE_2D, this.texture), e4.texParameteri(e4.TEXTURE_2D, e4.TEXTURE_WRAP_S, e4.REPEAT), e4.texParameteri(e4.TEXTURE_2D, e4.TEXTURE_WRAP_T, e4.REPEAT), e4.texParameteri(e4.TEXTURE_2D, e4.TEXTURE_MIN_FILTER, e4.LINEAR), e4.texParameteri(e4.TEXTURE_2D, e4.TEXTURE_MAG_FILTER, e4.LINEAR), e4.texImage2D(e4.TEXTURE_2D, 0, e4.ALPHA, this.width, this.height, 0, e4.ALPHA, e4.UNSIGNED_BYTE, this.data));
            };
            var A = function e4(r4, n4) {
              this.workerPool = r4, this.actors = [], this.currentActor = 0, this.id = t4.uniqueId();
              for (var i2 = this.workerPool.acquire(this.id), a2 = 0; a2 < i2.length; a2++) {
                var o2 = i2[a2], s2 = new e4.Actor(o2, n4, this.id);
                s2.name = "Worker " + a2, this.actors.push(s2);
              }
            };
            function M(e4, r4, n4) {
              var i2 = function(i3, a2) {
                if (i3)
                  return n4(i3);
                if (a2) {
                  var o2 = t4.pick(t4.extend(a2, e4), ["tiles", "minzoom", "maxzoom", "attribution", "mapbox_logo", "bounds", "scheme", "tileSize", "encoding"]);
                  a2.vector_layers && (o2.vectorLayers = a2.vector_layers, o2.vectorLayerIds = o2.vectorLayers.map(function(t5) {
                    return t5.id;
                  })), o2.tiles = r4.canonicalizeTileset(o2, e4.url), n4(null, o2);
                }
              };
              return e4.url ? t4.getJSON(r4.transformRequest(r4.normalizeSourceURL(e4.url), t4.ResourceType.Source), i2) : t4.browser.frame(function() {
                return i2(null, e4);
              });
            }
            A.prototype.broadcast = function(e4, r4, n4) {
              n4 = n4 || function() {
              }, t4.asyncAll(this.actors, function(t5, n5) {
                t5.send(e4, r4, n5);
              }, n4);
            }, A.prototype.getActor = function() {
              return this.currentActor = (this.currentActor + 1) % this.actors.length, this.actors[this.currentActor];
            }, A.prototype.remove = function() {
              this.actors.forEach(function(t5) {
                t5.remove();
              }), this.actors = [], this.workerPool.release(this.id);
            }, A.Actor = t4.Actor;
            var S = function(e4, r4, n4) {
              this.bounds = t4.LngLatBounds.convert(this.validateBounds(e4)), this.minzoom = r4 || 0, this.maxzoom = n4 || 24;
            };
            S.prototype.validateBounds = function(t5) {
              return Array.isArray(t5) && 4 === t5.length ? [Math.max(-180, t5[0]), Math.max(-90, t5[1]), Math.min(180, t5[2]), Math.min(90, t5[3])] : [-180, -90, 180, 90];
            }, S.prototype.contains = function(e4) {
              var r4 = Math.pow(2, e4.z), n4 = Math.floor(t4.mercatorXfromLng(this.bounds.getWest()) * r4), i2 = Math.floor(t4.mercatorYfromLat(this.bounds.getNorth()) * r4), a2 = Math.ceil(t4.mercatorXfromLng(this.bounds.getEast()) * r4), o2 = Math.ceil(t4.mercatorYfromLat(this.bounds.getSouth()) * r4);
              return e4.x >= n4 && e4.x < a2 && e4.y >= i2 && e4.y < o2;
            };
            var E = function(e4) {
              function r4(r5, n4, i2, a2) {
                if (e4.call(this), this.id = r5, this.dispatcher = i2, this.type = "vector", this.minzoom = 0, this.maxzoom = 22, this.scheme = "xyz", this.tileSize = 512, this.reparseOverscaled = true, this.isTileClipped = true, this._loaded = false, t4.extend(this, t4.pick(n4, ["url", "scheme", "tileSize", "promoteId"])), this._options = t4.extend({ type: "vector" }, n4), this._collectResourceTiming = n4.collectResourceTiming, 512 !== this.tileSize)
                  throw new Error("vector tile sources must have a tileSize of 512");
                this.setEventedParent(a2);
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.load = function() {
                var e5 = this;
                this._loaded = false, this.fire(new t4.Event("dataloading", { dataType: "source" })), this._tileJSONRequest = M(this._options, this.map._requestManager, function(r5, n4) {
                  e5._tileJSONRequest = null, e5._loaded = true, r5 ? e5.fire(new t4.ErrorEvent(r5)) : n4 && (t4.extend(e5, n4), n4.bounds && (e5.tileBounds = new S(n4.bounds, e5.minzoom, e5.maxzoom)), t4.postTurnstileEvent(n4.tiles, e5.map._requestManager._customAccessToken), t4.postMapLoadEvent(n4.tiles, e5.map._getMapId(), e5.map._requestManager._skuToken, e5.map._requestManager._customAccessToken), e5.fire(new t4.Event("data", { dataType: "source", sourceDataType: "metadata" })), e5.fire(new t4.Event("data", { dataType: "source", sourceDataType: "content" })));
                });
              }, r4.prototype.loaded = function() {
                return this._loaded;
              }, r4.prototype.hasTile = function(t5) {
                return !this.tileBounds || this.tileBounds.contains(t5.canonical);
              }, r4.prototype.onAdd = function(t5) {
                this.map = t5, this.load();
              }, r4.prototype.onRemove = function() {
                this._tileJSONRequest && (this._tileJSONRequest.cancel(), this._tileJSONRequest = null);
              }, r4.prototype.serialize = function() {
                return t4.extend({}, this._options);
              }, r4.prototype.loadTile = function(e5, r5) {
                var n4 = this.map._requestManager.normalizeTileURL(e5.tileID.canonical.url(this.tiles, this.scheme)), i2 = { request: this.map._requestManager.transformRequest(n4, t4.ResourceType.Tile), uid: e5.uid, tileID: e5.tileID, zoom: e5.tileID.overscaledZ, tileSize: this.tileSize * e5.tileID.overscaleFactor(), type: this.type, source: this.id, pixelRatio: t4.browser.devicePixelRatio, showCollisionBoxes: this.map.showCollisionBoxes, promoteId: this.promoteId };
                function a2(n5, i3) {
                  return delete e5.request, e5.aborted ? r5(null) : n5 && 404 !== n5.status ? r5(n5) : (i3 && i3.resourceTiming && (e5.resourceTiming = i3.resourceTiming), this.map._refreshExpiredTiles && i3 && e5.setExpiryData(i3), e5.loadVectorData(i3, this.map.painter), t4.cacheEntryPossiblyAdded(this.dispatcher), r5(null), void (e5.reloadCallback && (this.loadTile(e5, e5.reloadCallback), e5.reloadCallback = null)));
                }
                i2.request.collectResourceTiming = this._collectResourceTiming, e5.actor && "expired" !== e5.state ? "loading" === e5.state ? e5.reloadCallback = r5 : e5.request = e5.actor.send("reloadTile", i2, a2.bind(this)) : (e5.actor = this.dispatcher.getActor(), e5.request = e5.actor.send("loadTile", i2, a2.bind(this)));
              }, r4.prototype.abortTile = function(t5) {
                t5.request && (t5.request.cancel(), delete t5.request), t5.actor && t5.actor.send("abortTile", { uid: t5.uid, type: this.type, source: this.id }, void 0);
              }, r4.prototype.unloadTile = function(t5) {
                t5.unloadVectorData(), t5.actor && t5.actor.send("removeTile", { uid: t5.uid, type: this.type, source: this.id }, void 0);
              }, r4.prototype.hasTransition = function() {
                return false;
              }, r4;
            }(t4.Evented), L = function(e4) {
              function r4(r5, n4, i2, a2) {
                e4.call(this), this.id = r5, this.dispatcher = i2, this.setEventedParent(a2), this.type = "raster", this.minzoom = 0, this.maxzoom = 22, this.roundZoom = true, this.scheme = "xyz", this.tileSize = 512, this._loaded = false, this._options = t4.extend({ type: "raster" }, n4), t4.extend(this, t4.pick(n4, ["url", "scheme", "tileSize"]));
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.load = function() {
                var e5 = this;
                this._loaded = false, this.fire(new t4.Event("dataloading", { dataType: "source" })), this._tileJSONRequest = M(this._options, this.map._requestManager, function(r5, n4) {
                  e5._tileJSONRequest = null, e5._loaded = true, r5 ? e5.fire(new t4.ErrorEvent(r5)) : n4 && (t4.extend(e5, n4), n4.bounds && (e5.tileBounds = new S(n4.bounds, e5.minzoom, e5.maxzoom)), t4.postTurnstileEvent(n4.tiles), t4.postMapLoadEvent(n4.tiles, e5.map._getMapId(), e5.map._requestManager._skuToken), e5.fire(new t4.Event("data", { dataType: "source", sourceDataType: "metadata" })), e5.fire(new t4.Event("data", { dataType: "source", sourceDataType: "content" })));
                });
              }, r4.prototype.loaded = function() {
                return this._loaded;
              }, r4.prototype.onAdd = function(t5) {
                this.map = t5, this.load();
              }, r4.prototype.onRemove = function() {
                this._tileJSONRequest && (this._tileJSONRequest.cancel(), this._tileJSONRequest = null);
              }, r4.prototype.serialize = function() {
                return t4.extend({}, this._options);
              }, r4.prototype.hasTile = function(t5) {
                return !this.tileBounds || this.tileBounds.contains(t5.canonical);
              }, r4.prototype.loadTile = function(e5, r5) {
                var n4 = this, i2 = this.map._requestManager.normalizeTileURL(e5.tileID.canonical.url(this.tiles, this.scheme), this.tileSize);
                e5.request = t4.getImage(this.map._requestManager.transformRequest(i2, t4.ResourceType.Tile), function(i3, a2) {
                  if (delete e5.request, e5.aborted)
                    e5.state = "unloaded", r5(null);
                  else if (i3)
                    e5.state = "errored", r5(i3);
                  else if (a2) {
                    n4.map._refreshExpiredTiles && e5.setExpiryData(a2), delete a2.cacheControl, delete a2.expires;
                    var o2 = n4.map.painter.context, s2 = o2.gl;
                    e5.texture = n4.map.painter.getTileTexture(a2.width), e5.texture ? e5.texture.update(a2, { useMipmap: true }) : (e5.texture = new t4.Texture(o2, a2, s2.RGBA, { useMipmap: true }), e5.texture.bind(s2.LINEAR, s2.CLAMP_TO_EDGE, s2.LINEAR_MIPMAP_NEAREST), o2.extTextureFilterAnisotropic && s2.texParameterf(s2.TEXTURE_2D, o2.extTextureFilterAnisotropic.TEXTURE_MAX_ANISOTROPY_EXT, o2.extTextureFilterAnisotropicMax)), e5.state = "loaded", t4.cacheEntryPossiblyAdded(n4.dispatcher), r5(null);
                  }
                });
              }, r4.prototype.abortTile = function(t5, e5) {
                t5.request && (t5.request.cancel(), delete t5.request), e5();
              }, r4.prototype.unloadTile = function(t5, e5) {
                t5.texture && this.map.painter.saveTileTexture(t5.texture), e5();
              }, r4.prototype.hasTransition = function() {
                return false;
              }, r4;
            }(t4.Evented), C = function(e4) {
              function r4(r5, n4, i2, a2) {
                e4.call(this, r5, n4, i2, a2), this.type = "raster-dem", this.maxzoom = 22, this._options = t4.extend({ type: "raster-dem" }, n4), this.encoding = n4.encoding || "mapbox";
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.serialize = function() {
                return { type: "raster-dem", url: this.url, tileSize: this.tileSize, tiles: this.tiles, bounds: this.bounds, encoding: this.encoding };
              }, r4.prototype.loadTile = function(e5, r5) {
                var n4 = this.map._requestManager.normalizeTileURL(e5.tileID.canonical.url(this.tiles, this.scheme), this.tileSize);
                function i2(t5, n5) {
                  t5 && (e5.state = "errored", r5(t5)), n5 && (e5.dem = n5, e5.needsHillshadePrepare = true, e5.state = "loaded", r5(null));
                }
                e5.request = t4.getImage(this.map._requestManager.transformRequest(n4, t4.ResourceType.Tile), function(n5, a2) {
                  if (delete e5.request, e5.aborted)
                    e5.state = "unloaded", r5(null);
                  else if (n5)
                    e5.state = "errored", r5(n5);
                  else if (a2) {
                    this.map._refreshExpiredTiles && e5.setExpiryData(a2), delete a2.cacheControl, delete a2.expires;
                    var o2 = t4.window.ImageBitmap && a2 instanceof t4.window.ImageBitmap && t4.offscreenCanvasSupported() ? a2 : t4.browser.getImageData(a2, 1), s2 = { uid: e5.uid, coord: e5.tileID, source: this.id, rawImageData: o2, encoding: this.encoding };
                    e5.actor && "expired" !== e5.state || (e5.actor = this.dispatcher.getActor(), e5.actor.send("loadDEMTile", s2, i2.bind(this)));
                  }
                }.bind(this)), e5.neighboringTiles = this._getNeighboringTiles(e5.tileID);
              }, r4.prototype._getNeighboringTiles = function(e5) {
                var r5 = e5.canonical, n4 = Math.pow(2, r5.z), i2 = (r5.x - 1 + n4) % n4, a2 = 0 === r5.x ? e5.wrap - 1 : e5.wrap, o2 = (r5.x + 1 + n4) % n4, s2 = r5.x + 1 === n4 ? e5.wrap + 1 : e5.wrap, l2 = {};
                return l2[new t4.OverscaledTileID(e5.overscaledZ, a2, r5.z, i2, r5.y).key] = { backfilled: false }, l2[new t4.OverscaledTileID(e5.overscaledZ, s2, r5.z, o2, r5.y).key] = { backfilled: false }, r5.y > 0 && (l2[new t4.OverscaledTileID(e5.overscaledZ, a2, r5.z, i2, r5.y - 1).key] = { backfilled: false }, l2[new t4.OverscaledTileID(e5.overscaledZ, e5.wrap, r5.z, r5.x, r5.y - 1).key] = { backfilled: false }, l2[new t4.OverscaledTileID(e5.overscaledZ, s2, r5.z, o2, r5.y - 1).key] = { backfilled: false }), r5.y + 1 < n4 && (l2[new t4.OverscaledTileID(e5.overscaledZ, a2, r5.z, i2, r5.y + 1).key] = { backfilled: false }, l2[new t4.OverscaledTileID(e5.overscaledZ, e5.wrap, r5.z, r5.x, r5.y + 1).key] = { backfilled: false }, l2[new t4.OverscaledTileID(e5.overscaledZ, s2, r5.z, o2, r5.y + 1).key] = { backfilled: false }), l2;
              }, r4.prototype.unloadTile = function(t5) {
                t5.demTexture && this.map.painter.saveTileTexture(t5.demTexture), t5.fbo && (t5.fbo.destroy(), delete t5.fbo), t5.dem && delete t5.dem, delete t5.neighboringTiles, t5.state = "unloaded", t5.actor && t5.actor.send("removeDEMTile", { uid: t5.uid, source: this.id });
              }, r4;
            }(L), P = function(e4) {
              function r4(r5, n4, i2, a2) {
                e4.call(this), this.id = r5, this.type = "geojson", this.minzoom = 0, this.maxzoom = 18, this.tileSize = 512, this.isTileClipped = true, this.reparseOverscaled = true, this._removed = false, this._loaded = false, this.actor = i2.getActor(), this.setEventedParent(a2), this._data = n4.data, this._options = t4.extend({}, n4), this._collectResourceTiming = n4.collectResourceTiming, this._resourceTiming = [], void 0 !== n4.maxzoom && (this.maxzoom = n4.maxzoom), n4.type && (this.type = n4.type), n4.attribution && (this.attribution = n4.attribution), this.promoteId = n4.promoteId;
                var o2 = t4.EXTENT / this.tileSize;
                this.workerOptions = t4.extend({ source: this.id, cluster: n4.cluster || false, geojsonVtOptions: { buffer: (void 0 !== n4.buffer ? n4.buffer : 128) * o2, tolerance: (void 0 !== n4.tolerance ? n4.tolerance : 0.375) * o2, extent: t4.EXTENT, maxZoom: this.maxzoom, lineMetrics: n4.lineMetrics || false, generateId: n4.generateId || false }, superclusterOptions: { maxZoom: void 0 !== n4.clusterMaxZoom ? Math.min(n4.clusterMaxZoom, this.maxzoom - 1) : this.maxzoom - 1, extent: t4.EXTENT, radius: (n4.clusterRadius || 50) * o2, log: false, generateId: n4.generateId || false }, clusterProperties: n4.clusterProperties }, n4.workerOptions);
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.load = function() {
                var e5 = this;
                this.fire(new t4.Event("dataloading", { dataType: "source" })), this._updateWorkerData(function(r5) {
                  if (r5)
                    e5.fire(new t4.ErrorEvent(r5));
                  else {
                    var n4 = { dataType: "source", sourceDataType: "metadata" };
                    e5._collectResourceTiming && e5._resourceTiming && e5._resourceTiming.length > 0 && (n4.resourceTiming = e5._resourceTiming, e5._resourceTiming = []), e5.fire(new t4.Event("data", n4));
                  }
                });
              }, r4.prototype.onAdd = function(t5) {
                this.map = t5, this.load();
              }, r4.prototype.setData = function(e5) {
                var r5 = this;
                return this._data = e5, this.fire(new t4.Event("dataloading", { dataType: "source" })), this._updateWorkerData(function(e6) {
                  if (e6)
                    r5.fire(new t4.ErrorEvent(e6));
                  else {
                    var n4 = { dataType: "source", sourceDataType: "content" };
                    r5._collectResourceTiming && r5._resourceTiming && r5._resourceTiming.length > 0 && (n4.resourceTiming = r5._resourceTiming, r5._resourceTiming = []), r5.fire(new t4.Event("data", n4));
                  }
                }), this;
              }, r4.prototype.getClusterExpansionZoom = function(t5, e5) {
                return this.actor.send("geojson.getClusterExpansionZoom", { clusterId: t5, source: this.id }, e5), this;
              }, r4.prototype.getClusterChildren = function(t5, e5) {
                return this.actor.send("geojson.getClusterChildren", { clusterId: t5, source: this.id }, e5), this;
              }, r4.prototype.getClusterLeaves = function(t5, e5, r5, n4) {
                return this.actor.send("geojson.getClusterLeaves", { source: this.id, clusterId: t5, limit: e5, offset: r5 }, n4), this;
              }, r4.prototype._updateWorkerData = function(e5) {
                var r5 = this;
                this._loaded = false;
                var n4 = t4.extend({}, this.workerOptions), i2 = this._data;
                "string" == typeof i2 ? (n4.request = this.map._requestManager.transformRequest(t4.browser.resolveURL(i2), t4.ResourceType.Source), n4.request.collectResourceTiming = this._collectResourceTiming) : n4.data = JSON.stringify(i2), this.actor.send(this.type + ".loadData", n4, function(t5, i3) {
                  r5._removed || i3 && i3.abandoned || (r5._loaded = true, i3 && i3.resourceTiming && i3.resourceTiming[r5.id] && (r5._resourceTiming = i3.resourceTiming[r5.id].slice(0)), r5.actor.send(r5.type + ".coalesce", { source: n4.source }, null), e5(t5));
                });
              }, r4.prototype.loaded = function() {
                return this._loaded;
              }, r4.prototype.loadTile = function(e5, r5) {
                var n4 = this, i2 = e5.actor ? "reloadTile" : "loadTile";
                e5.actor = this.actor;
                var a2 = { type: this.type, uid: e5.uid, tileID: e5.tileID, zoom: e5.tileID.overscaledZ, maxZoom: this.maxzoom, tileSize: this.tileSize, source: this.id, pixelRatio: t4.browser.devicePixelRatio, showCollisionBoxes: this.map.showCollisionBoxes, promoteId: this.promoteId };
                e5.request = this.actor.send(i2, a2, function(t5, a3) {
                  return delete e5.request, e5.unloadVectorData(), e5.aborted ? r5(null) : t5 ? r5(t5) : (e5.loadVectorData(a3, n4.map.painter, "reloadTile" === i2), r5(null));
                });
              }, r4.prototype.abortTile = function(t5) {
                t5.request && (t5.request.cancel(), delete t5.request), t5.aborted = true;
              }, r4.prototype.unloadTile = function(t5) {
                t5.unloadVectorData(), this.actor.send("removeTile", { uid: t5.uid, type: this.type, source: this.id });
              }, r4.prototype.onRemove = function() {
                this._removed = true, this.actor.send("removeSource", { type: this.type, source: this.id });
              }, r4.prototype.serialize = function() {
                return t4.extend({}, this._options, { type: this.type, data: this._data });
              }, r4.prototype.hasTransition = function() {
                return false;
              }, r4;
            }(t4.Evented), O = t4.createLayout([{ name: "a_pos", type: "Int16", components: 2 }, { name: "a_texture_pos", type: "Int16", components: 2 }]), I = function(e4) {
              function r4(t5, r5, n4, i2) {
                e4.call(this), this.id = t5, this.dispatcher = n4, this.coordinates = r5.coordinates, this.type = "image", this.minzoom = 0, this.maxzoom = 22, this.tileSize = 512, this.tiles = {}, this._loaded = false, this.setEventedParent(i2), this.options = r5;
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.load = function(e5, r5) {
                var n4 = this;
                this._loaded = false, this.fire(new t4.Event("dataloading", { dataType: "source" })), this.url = this.options.url, t4.getImage(this.map._requestManager.transformRequest(this.url, t4.ResourceType.Image), function(i2, a2) {
                  n4._loaded = true, i2 ? n4.fire(new t4.ErrorEvent(i2)) : a2 && (n4.image = a2, e5 && (n4.coordinates = e5), r5 && r5(), n4._finishLoading());
                });
              }, r4.prototype.loaded = function() {
                return this._loaded;
              }, r4.prototype.updateImage = function(t5) {
                var e5 = this;
                return this.image && t5.url ? (this.options.url = t5.url, this.load(t5.coordinates, function() {
                  e5.texture = null;
                }), this) : this;
              }, r4.prototype._finishLoading = function() {
                this.map && (this.setCoordinates(this.coordinates), this.fire(new t4.Event("data", { dataType: "source", sourceDataType: "metadata" })));
              }, r4.prototype.onAdd = function(t5) {
                this.map = t5, this.load();
              }, r4.prototype.setCoordinates = function(e5) {
                var r5 = this;
                this.coordinates = e5;
                var n4 = e5.map(t4.MercatorCoordinate.fromLngLat);
                this.tileID = function(e6) {
                  for (var r6 = 1 / 0, n5 = 1 / 0, i3 = -1 / 0, a2 = -1 / 0, o2 = 0, s2 = e6; o2 < s2.length; o2 += 1) {
                    var l2 = s2[o2];
                    r6 = Math.min(r6, l2.x), n5 = Math.min(n5, l2.y), i3 = Math.max(i3, l2.x), a2 = Math.max(a2, l2.y);
                  }
                  var u2 = i3 - r6, c2 = a2 - n5, f3 = Math.max(u2, c2), h2 = Math.max(0, Math.floor(-Math.log(f3) / Math.LN2)), p3 = Math.pow(2, h2);
                  return new t4.CanonicalTileID(h2, Math.floor((r6 + i3) / 2 * p3), Math.floor((n5 + a2) / 2 * p3));
                }(n4), this.minzoom = this.maxzoom = this.tileID.z;
                var i2 = n4.map(function(t5) {
                  return r5.tileID.getTilePoint(t5)._round();
                });
                return this._boundsArray = new t4.StructArrayLayout4i8(), this._boundsArray.emplaceBack(i2[0].x, i2[0].y, 0, 0), this._boundsArray.emplaceBack(i2[1].x, i2[1].y, t4.EXTENT, 0), this._boundsArray.emplaceBack(i2[3].x, i2[3].y, 0, t4.EXTENT), this._boundsArray.emplaceBack(i2[2].x, i2[2].y, t4.EXTENT, t4.EXTENT), this.boundsBuffer && (this.boundsBuffer.destroy(), delete this.boundsBuffer), this.fire(new t4.Event("data", { dataType: "source", sourceDataType: "content" })), this;
              }, r4.prototype.prepare = function() {
                if (0 !== Object.keys(this.tiles).length && this.image) {
                  var e5 = this.map.painter.context, r5 = e5.gl;
                  for (var n4 in this.boundsBuffer || (this.boundsBuffer = e5.createVertexBuffer(this._boundsArray, O.members)), this.boundsSegments || (this.boundsSegments = t4.SegmentVector.simpleSegment(0, 0, 4, 2)), this.texture || (this.texture = new t4.Texture(e5, this.image, r5.RGBA), this.texture.bind(r5.LINEAR, r5.CLAMP_TO_EDGE)), this.tiles) {
                    var i2 = this.tiles[n4];
                    "loaded" !== i2.state && (i2.state = "loaded", i2.texture = this.texture);
                  }
                }
              }, r4.prototype.loadTile = function(t5, e5) {
                this.tileID && this.tileID.equals(t5.tileID.canonical) ? (this.tiles[String(t5.tileID.wrap)] = t5, t5.buckets = {}, e5(null)) : (t5.state = "errored", e5(null));
              }, r4.prototype.serialize = function() {
                return { type: "image", url: this.options.url, coordinates: this.coordinates };
              }, r4.prototype.hasTransition = function() {
                return false;
              }, r4;
            }(t4.Evented);
            var D = function(e4) {
              function r4(t5, r5, n4, i2) {
                e4.call(this, t5, r5, n4, i2), this.roundZoom = true, this.type = "video", this.options = r5;
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.load = function() {
                var e5 = this;
                this._loaded = false;
                var r5 = this.options;
                this.urls = [];
                for (var n4 = 0, i2 = r5.urls; n4 < i2.length; n4 += 1) {
                  var a2 = i2[n4];
                  this.urls.push(this.map._requestManager.transformRequest(a2, t4.ResourceType.Source).url);
                }
                t4.getVideo(this.urls, function(r6, n5) {
                  e5._loaded = true, r6 ? e5.fire(new t4.ErrorEvent(r6)) : n5 && (e5.video = n5, e5.video.loop = true, e5.video.addEventListener("playing", function() {
                    e5.map.triggerRepaint();
                  }), e5.map && e5.video.play(), e5._finishLoading());
                });
              }, r4.prototype.pause = function() {
                this.video && this.video.pause();
              }, r4.prototype.play = function() {
                this.video && this.video.play();
              }, r4.prototype.seek = function(e5) {
                if (this.video) {
                  var r5 = this.video.seekable;
                  e5 < r5.start(0) || e5 > r5.end(0) ? this.fire(new t4.ErrorEvent(new t4.ValidationError("sources." + this.id, null, "Playback for this video can be set only between the " + r5.start(0) + " and " + r5.end(0) + "-second mark."))) : this.video.currentTime = e5;
                }
              }, r4.prototype.getVideo = function() {
                return this.video;
              }, r4.prototype.onAdd = function(t5) {
                this.map || (this.map = t5, this.load(), this.video && (this.video.play(), this.setCoordinates(this.coordinates)));
              }, r4.prototype.prepare = function() {
                if (!(0 === Object.keys(this.tiles).length || this.video.readyState < 2)) {
                  var e5 = this.map.painter.context, r5 = e5.gl;
                  for (var n4 in this.boundsBuffer || (this.boundsBuffer = e5.createVertexBuffer(this._boundsArray, O.members)), this.boundsSegments || (this.boundsSegments = t4.SegmentVector.simpleSegment(0, 0, 4, 2)), this.texture ? this.video.paused || (this.texture.bind(r5.LINEAR, r5.CLAMP_TO_EDGE), r5.texSubImage2D(r5.TEXTURE_2D, 0, 0, 0, r5.RGBA, r5.UNSIGNED_BYTE, this.video)) : (this.texture = new t4.Texture(e5, this.video, r5.RGBA), this.texture.bind(r5.LINEAR, r5.CLAMP_TO_EDGE)), this.tiles) {
                    var i2 = this.tiles[n4];
                    "loaded" !== i2.state && (i2.state = "loaded", i2.texture = this.texture);
                  }
                }
              }, r4.prototype.serialize = function() {
                return { type: "video", urls: this.urls, coordinates: this.coordinates };
              }, r4.prototype.hasTransition = function() {
                return this.video && !this.video.paused;
              }, r4;
            }(I), z = function(e4) {
              function r4(r5, n4, i2, a2) {
                e4.call(this, r5, n4, i2, a2), n4.coordinates ? Array.isArray(n4.coordinates) && 4 === n4.coordinates.length && !n4.coordinates.some(function(t5) {
                  return !Array.isArray(t5) || 2 !== t5.length || t5.some(function(t6) {
                    return "number" != typeof t6;
                  });
                }) || this.fire(new t4.ErrorEvent(new t4.ValidationError("sources." + r5, null, '"coordinates" property must be an array of 4 longitude/latitude array pairs'))) : this.fire(new t4.ErrorEvent(new t4.ValidationError("sources." + r5, null, 'missing required property "coordinates"'))), n4.animate && "boolean" != typeof n4.animate && this.fire(new t4.ErrorEvent(new t4.ValidationError("sources." + r5, null, 'optional "animate" property must be a boolean value'))), n4.canvas ? "string" == typeof n4.canvas || n4.canvas instanceof t4.window.HTMLCanvasElement || this.fire(new t4.ErrorEvent(new t4.ValidationError("sources." + r5, null, '"canvas" must be either a string representing the ID of the canvas element from which to read, or an HTMLCanvasElement instance'))) : this.fire(new t4.ErrorEvent(new t4.ValidationError("sources." + r5, null, 'missing required property "canvas"'))), this.options = n4, this.animate = void 0 === n4.animate || n4.animate;
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.load = function() {
                this._loaded = true, this.canvas || (this.canvas = this.options.canvas instanceof t4.window.HTMLCanvasElement ? this.options.canvas : t4.window.document.getElementById(this.options.canvas)), this.width = this.canvas.width, this.height = this.canvas.height, this._hasInvalidDimensions() ? this.fire(new t4.ErrorEvent(new Error("Canvas dimensions cannot be less than or equal to zero."))) : (this.play = function() {
                  this._playing = true, this.map.triggerRepaint();
                }, this.pause = function() {
                  this._playing && (this.prepare(), this._playing = false);
                }, this._finishLoading());
              }, r4.prototype.getCanvas = function() {
                return this.canvas;
              }, r4.prototype.onAdd = function(t5) {
                this.map = t5, this.load(), this.canvas && this.animate && this.play();
              }, r4.prototype.onRemove = function() {
                this.pause();
              }, r4.prototype.prepare = function() {
                var e5 = false;
                if (this.canvas.width !== this.width && (this.width = this.canvas.width, e5 = true), this.canvas.height !== this.height && (this.height = this.canvas.height, e5 = true), !this._hasInvalidDimensions() && 0 !== Object.keys(this.tiles).length) {
                  var r5 = this.map.painter.context, n4 = r5.gl;
                  for (var i2 in this.boundsBuffer || (this.boundsBuffer = r5.createVertexBuffer(this._boundsArray, O.members)), this.boundsSegments || (this.boundsSegments = t4.SegmentVector.simpleSegment(0, 0, 4, 2)), this.texture ? (e5 || this._playing) && this.texture.update(this.canvas, { premultiply: true }) : this.texture = new t4.Texture(r5, this.canvas, n4.RGBA, { premultiply: true }), this.tiles) {
                    var a2 = this.tiles[i2];
                    "loaded" !== a2.state && (a2.state = "loaded", a2.texture = this.texture);
                  }
                }
              }, r4.prototype.serialize = function() {
                return { type: "canvas", coordinates: this.coordinates };
              }, r4.prototype.hasTransition = function() {
                return this._playing;
              }, r4.prototype._hasInvalidDimensions = function() {
                for (var t5 = 0, e5 = [this.canvas.width, this.canvas.height]; t5 < e5.length; t5 += 1) {
                  var r5 = e5[t5];
                  if (isNaN(r5) || r5 <= 0)
                    return true;
                }
                return false;
              }, r4;
            }(I), R = { vector: E, raster: L, "raster-dem": C, geojson: P, video: D, image: I, canvas: z };
            function F(e4, r4) {
              var n4 = t4.identity([]);
              return t4.translate(n4, n4, [1, 1, 0]), t4.scale(n4, n4, [0.5 * e4.width, 0.5 * e4.height, 1]), t4.multiply(n4, n4, e4.calculatePosMatrix(r4.toUnwrapped()));
            }
            function B(t5, e4, r4, n4, i2, a2) {
              var o2 = function(t6, e5, r5) {
                if (t6)
                  for (var n5 = 0, i3 = t6; n5 < i3.length; n5 += 1) {
                    var a3 = e5[i3[n5]];
                    if (a3 && a3.source === r5 && "fill-extrusion" === a3.type)
                      return true;
                  }
                else
                  for (var o3 in e5) {
                    var s3 = e5[o3];
                    if (s3.source === r5 && "fill-extrusion" === s3.type)
                      return true;
                  }
                return false;
              }(i2 && i2.layers, e4, t5.id), s2 = a2.maxPitchScaleFactor(), l2 = t5.tilesIn(n4, s2, o2);
              l2.sort(N);
              for (var u2 = [], c2 = 0, f3 = l2; c2 < f3.length; c2 += 1) {
                var h2 = f3[c2];
                u2.push({ wrappedTileID: h2.tileID.wrapped().key, queryResults: h2.tile.queryRenderedFeatures(e4, r4, t5._state, h2.queryGeometry, h2.cameraQueryGeometry, h2.scale, i2, a2, s2, F(t5.transform, h2.tileID)) });
              }
              var p3 = function(t6) {
                for (var e5 = {}, r5 = {}, n5 = 0, i3 = t6; n5 < i3.length; n5 += 1) {
                  var a3 = i3[n5], o3 = a3.queryResults, s3 = a3.wrappedTileID, l3 = r5[s3] = r5[s3] || {};
                  for (var u3 in o3)
                    for (var c3 = o3[u3], f4 = l3[u3] = l3[u3] || {}, h3 = e5[u3] = e5[u3] || [], p4 = 0, d4 = c3; p4 < d4.length; p4 += 1) {
                      var v2 = d4[p4];
                      f4[v2.featureIndex] || (f4[v2.featureIndex] = true, h3.push(v2));
                    }
                }
                return e5;
              }(u2);
              for (var d3 in p3)
                p3[d3].forEach(function(e5) {
                  var r5 = e5.feature, n5 = t5.getFeatureState(r5.layer["source-layer"], r5.id);
                  r5.source = r5.layer.source, r5.layer["source-layer"] && (r5.sourceLayer = r5.layer["source-layer"]), r5.state = n5;
                });
              return p3;
            }
            function N(t5, e4) {
              var r4 = t5.tileID, n4 = e4.tileID;
              return r4.overscaledZ - n4.overscaledZ || r4.canonical.y - n4.canonical.y || r4.wrap - n4.wrap || r4.canonical.x - n4.canonical.x;
            }
            var j = function(t5, e4) {
              this.max = t5, this.onRemove = e4, this.reset();
            };
            j.prototype.reset = function() {
              for (var t5 in this.data)
                for (var e4 = 0, r4 = this.data[t5]; e4 < r4.length; e4 += 1) {
                  var n4 = r4[e4];
                  n4.timeout && clearTimeout(n4.timeout), this.onRemove(n4.value);
                }
              return this.data = {}, this.order = [], this;
            }, j.prototype.add = function(t5, e4, r4) {
              var n4 = this, i2 = t5.wrapped().key;
              void 0 === this.data[i2] && (this.data[i2] = []);
              var a2 = { value: e4, timeout: void 0 };
              if (void 0 !== r4 && (a2.timeout = setTimeout(function() {
                n4.remove(t5, a2);
              }, r4)), this.data[i2].push(a2), this.order.push(i2), this.order.length > this.max) {
                var o2 = this._getAndRemoveByKey(this.order[0]);
                o2 && this.onRemove(o2);
              }
              return this;
            }, j.prototype.has = function(t5) {
              return t5.wrapped().key in this.data;
            }, j.prototype.getAndRemove = function(t5) {
              return this.has(t5) ? this._getAndRemoveByKey(t5.wrapped().key) : null;
            }, j.prototype._getAndRemoveByKey = function(t5) {
              var e4 = this.data[t5].shift();
              return e4.timeout && clearTimeout(e4.timeout), 0 === this.data[t5].length && delete this.data[t5], this.order.splice(this.order.indexOf(t5), 1), e4.value;
            }, j.prototype.getByKey = function(t5) {
              var e4 = this.data[t5];
              return e4 ? e4[0].value : null;
            }, j.prototype.get = function(t5) {
              return this.has(t5) ? this.data[t5.wrapped().key][0].value : null;
            }, j.prototype.remove = function(t5, e4) {
              if (!this.has(t5))
                return this;
              var r4 = t5.wrapped().key, n4 = void 0 === e4 ? 0 : this.data[r4].indexOf(e4), i2 = this.data[r4][n4];
              return this.data[r4].splice(n4, 1), i2.timeout && clearTimeout(i2.timeout), 0 === this.data[r4].length && delete this.data[r4], this.onRemove(i2.value), this.order.splice(this.order.indexOf(r4), 1), this;
            }, j.prototype.setMaxSize = function(t5) {
              for (this.max = t5; this.order.length > this.max; ) {
                var e4 = this._getAndRemoveByKey(this.order[0]);
                e4 && this.onRemove(e4);
              }
              return this;
            }, j.prototype.filter = function(t5) {
              var e4 = [];
              for (var r4 in this.data)
                for (var n4 = 0, i2 = this.data[r4]; n4 < i2.length; n4 += 1) {
                  var a2 = i2[n4];
                  t5(a2.value) || e4.push(a2);
                }
              for (var o2 = 0, s2 = e4; o2 < s2.length; o2 += 1) {
                var l2 = s2[o2];
                this.remove(l2.value.tileID, l2);
              }
            };
            var U = function(t5, e4, r4) {
              this.context = t5;
              var n4 = t5.gl;
              this.buffer = n4.createBuffer(), this.dynamicDraw = Boolean(r4), this.context.unbindVAO(), t5.bindElementBuffer.set(this.buffer), n4.bufferData(n4.ELEMENT_ARRAY_BUFFER, e4.arrayBuffer, this.dynamicDraw ? n4.DYNAMIC_DRAW : n4.STATIC_DRAW), this.dynamicDraw || delete e4.arrayBuffer;
            };
            U.prototype.bind = function() {
              this.context.bindElementBuffer.set(this.buffer);
            }, U.prototype.updateData = function(t5) {
              var e4 = this.context.gl;
              this.context.unbindVAO(), this.bind(), e4.bufferSubData(e4.ELEMENT_ARRAY_BUFFER, 0, t5.arrayBuffer);
            }, U.prototype.destroy = function() {
              var t5 = this.context.gl;
              this.buffer && (t5.deleteBuffer(this.buffer), delete this.buffer);
            };
            var V = { Int8: "BYTE", Uint8: "UNSIGNED_BYTE", Int16: "SHORT", Uint16: "UNSIGNED_SHORT", Int32: "INT", Uint32: "UNSIGNED_INT", Float32: "FLOAT" }, H = function(t5, e4, r4, n4) {
              this.length = e4.length, this.attributes = r4, this.itemSize = e4.bytesPerElement, this.dynamicDraw = n4, this.context = t5;
              var i2 = t5.gl;
              this.buffer = i2.createBuffer(), t5.bindVertexBuffer.set(this.buffer), i2.bufferData(i2.ARRAY_BUFFER, e4.arrayBuffer, this.dynamicDraw ? i2.DYNAMIC_DRAW : i2.STATIC_DRAW), this.dynamicDraw || delete e4.arrayBuffer;
            };
            H.prototype.bind = function() {
              this.context.bindVertexBuffer.set(this.buffer);
            }, H.prototype.updateData = function(t5) {
              var e4 = this.context.gl;
              this.bind(), e4.bufferSubData(e4.ARRAY_BUFFER, 0, t5.arrayBuffer);
            }, H.prototype.enableAttributes = function(t5, e4) {
              for (var r4 = 0; r4 < this.attributes.length; r4++) {
                var n4 = this.attributes[r4], i2 = e4.attributes[n4.name];
                void 0 !== i2 && t5.enableVertexAttribArray(i2);
              }
            }, H.prototype.setVertexAttribPointers = function(t5, e4, r4) {
              for (var n4 = 0; n4 < this.attributes.length; n4++) {
                var i2 = this.attributes[n4], a2 = e4.attributes[i2.name];
                void 0 !== a2 && t5.vertexAttribPointer(a2, i2.components, t5[V[i2.type]], false, this.itemSize, i2.offset + this.itemSize * (r4 || 0));
              }
            }, H.prototype.destroy = function() {
              var t5 = this.context.gl;
              this.buffer && (t5.deleteBuffer(this.buffer), delete this.buffer);
            };
            var q2 = function(t5) {
              this.gl = t5.gl, this.default = this.getDefault(), this.current = this.default, this.dirty = false;
            };
            q2.prototype.get = function() {
              return this.current;
            }, q2.prototype.set = function(t5) {
            }, q2.prototype.getDefault = function() {
              return this.default;
            }, q2.prototype.setDefault = function() {
              this.set(this.default);
            };
            var G = function(e4) {
              function r4() {
                e4.apply(this, arguments);
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.getDefault = function() {
                return t4.Color.transparent;
              }, r4.prototype.set = function(t5) {
                var e5 = this.current;
                (t5.r !== e5.r || t5.g !== e5.g || t5.b !== e5.b || t5.a !== e5.a || this.dirty) && (this.gl.clearColor(t5.r, t5.g, t5.b, t5.a), this.current = t5, this.dirty = false);
              }, r4;
            }(q2), Z = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return 1;
              }, e4.prototype.set = function(t6) {
                (t6 !== this.current || this.dirty) && (this.gl.clearDepth(t6), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), Y = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return 0;
              }, e4.prototype.set = function(t6) {
                (t6 !== this.current || this.dirty) && (this.gl.clearStencil(t6), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), W = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return [true, true, true, true];
              }, e4.prototype.set = function(t6) {
                var e5 = this.current;
                (t6[0] !== e5[0] || t6[1] !== e5[1] || t6[2] !== e5[2] || t6[3] !== e5[3] || this.dirty) && (this.gl.colorMask(t6[0], t6[1], t6[2], t6[3]), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), X = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return true;
              }, e4.prototype.set = function(t6) {
                (t6 !== this.current || this.dirty) && (this.gl.depthMask(t6), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), J = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return 255;
              }, e4.prototype.set = function(t6) {
                (t6 !== this.current || this.dirty) && (this.gl.stencilMask(t6), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), K = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return { func: this.gl.ALWAYS, ref: 0, mask: 255 };
              }, e4.prototype.set = function(t6) {
                var e5 = this.current;
                (t6.func !== e5.func || t6.ref !== e5.ref || t6.mask !== e5.mask || this.dirty) && (this.gl.stencilFunc(t6.func, t6.ref, t6.mask), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), $ = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                var t6 = this.gl;
                return [t6.KEEP, t6.KEEP, t6.KEEP];
              }, e4.prototype.set = function(t6) {
                var e5 = this.current;
                (t6[0] !== e5[0] || t6[1] !== e5[1] || t6[2] !== e5[2] || this.dirty) && (this.gl.stencilOp(t6[0], t6[1], t6[2]), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), Q = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return false;
              }, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  var e5 = this.gl;
                  t6 ? e5.enable(e5.STENCIL_TEST) : e5.disable(e5.STENCIL_TEST), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(q2), tt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return [0, 1];
              }, e4.prototype.set = function(t6) {
                var e5 = this.current;
                (t6[0] !== e5[0] || t6[1] !== e5[1] || this.dirty) && (this.gl.depthRange(t6[0], t6[1]), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), et = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return false;
              }, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  var e5 = this.gl;
                  t6 ? e5.enable(e5.DEPTH_TEST) : e5.disable(e5.DEPTH_TEST), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(q2), rt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return this.gl.LESS;
              }, e4.prototype.set = function(t6) {
                (t6 !== this.current || this.dirty) && (this.gl.depthFunc(t6), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), nt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return false;
              }, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  var e5 = this.gl;
                  t6 ? e5.enable(e5.BLEND) : e5.disable(e5.BLEND), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(q2), it = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                var t6 = this.gl;
                return [t6.ONE, t6.ZERO];
              }, e4.prototype.set = function(t6) {
                var e5 = this.current;
                (t6[0] !== e5[0] || t6[1] !== e5[1] || this.dirty) && (this.gl.blendFunc(t6[0], t6[1]), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), at = function(e4) {
              function r4() {
                e4.apply(this, arguments);
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.getDefault = function() {
                return t4.Color.transparent;
              }, r4.prototype.set = function(t5) {
                var e5 = this.current;
                (t5.r !== e5.r || t5.g !== e5.g || t5.b !== e5.b || t5.a !== e5.a || this.dirty) && (this.gl.blendColor(t5.r, t5.g, t5.b, t5.a), this.current = t5, this.dirty = false);
              }, r4;
            }(q2), ot = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return this.gl.FUNC_ADD;
              }, e4.prototype.set = function(t6) {
                (t6 !== this.current || this.dirty) && (this.gl.blendEquation(t6), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), st = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return false;
              }, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  var e5 = this.gl;
                  t6 ? e5.enable(e5.CULL_FACE) : e5.disable(e5.CULL_FACE), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(q2), lt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return this.gl.BACK;
              }, e4.prototype.set = function(t6) {
                (t6 !== this.current || this.dirty) && (this.gl.cullFace(t6), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), ut = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return this.gl.CCW;
              }, e4.prototype.set = function(t6) {
                (t6 !== this.current || this.dirty) && (this.gl.frontFace(t6), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), ct = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return null;
              }, e4.prototype.set = function(t6) {
                (t6 !== this.current || this.dirty) && (this.gl.useProgram(t6), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), ft = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return this.gl.TEXTURE0;
              }, e4.prototype.set = function(t6) {
                (t6 !== this.current || this.dirty) && (this.gl.activeTexture(t6), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), ht = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                var t6 = this.gl;
                return [0, 0, t6.drawingBufferWidth, t6.drawingBufferHeight];
              }, e4.prototype.set = function(t6) {
                var e5 = this.current;
                (t6[0] !== e5[0] || t6[1] !== e5[1] || t6[2] !== e5[2] || t6[3] !== e5[3] || this.dirty) && (this.gl.viewport(t6[0], t6[1], t6[2], t6[3]), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), pt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return null;
              }, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  var e5 = this.gl;
                  e5.bindFramebuffer(e5.FRAMEBUFFER, t6), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(q2), dt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return null;
              }, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  var e5 = this.gl;
                  e5.bindRenderbuffer(e5.RENDERBUFFER, t6), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(q2), vt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return null;
              }, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  var e5 = this.gl;
                  e5.bindTexture(e5.TEXTURE_2D, t6), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(q2), gt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return null;
              }, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  var e5 = this.gl;
                  e5.bindBuffer(e5.ARRAY_BUFFER, t6), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(q2), yt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return null;
              }, e4.prototype.set = function(t6) {
                var e5 = this.gl;
                e5.bindBuffer(e5.ELEMENT_ARRAY_BUFFER, t6), this.current = t6, this.dirty = false;
              }, e4;
            }(q2), mt = function(t5) {
              function e4(e5) {
                t5.call(this, e5), this.vao = e5.extVertexArrayObject;
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return null;
              }, e4.prototype.set = function(t6) {
                this.vao && (t6 !== this.current || this.dirty) && (this.vao.bindVertexArrayOES(t6), this.current = t6, this.dirty = false);
              }, e4;
            }(q2), xt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return 4;
              }, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  var e5 = this.gl;
                  e5.pixelStorei(e5.UNPACK_ALIGNMENT, t6), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(q2), bt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return false;
              }, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  var e5 = this.gl;
                  e5.pixelStorei(e5.UNPACK_PREMULTIPLY_ALPHA_WEBGL, t6), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(q2), _t = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return false;
              }, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  var e5 = this.gl;
                  e5.pixelStorei(e5.UNPACK_FLIP_Y_WEBGL, t6), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(q2), wt = function(t5) {
              function e4(e5, r4) {
                t5.call(this, e5), this.context = e5, this.parent = r4;
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.getDefault = function() {
                return null;
              }, e4;
            }(q2), Tt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.setDirty = function() {
                this.dirty = true;
              }, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  this.context.bindFramebuffer.set(this.parent);
                  var e5 = this.gl;
                  e5.framebufferTexture2D(e5.FRAMEBUFFER, e5.COLOR_ATTACHMENT0, e5.TEXTURE_2D, t6, 0), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(wt), kt = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.set = function(t6) {
                if (t6 !== this.current || this.dirty) {
                  this.context.bindFramebuffer.set(this.parent);
                  var e5 = this.gl;
                  e5.framebufferRenderbuffer(e5.FRAMEBUFFER, e5.DEPTH_ATTACHMENT, e5.RENDERBUFFER, t6), this.current = t6, this.dirty = false;
                }
              }, e4;
            }(wt), At = function(t5, e4, r4, n4) {
              this.context = t5, this.width = e4, this.height = r4;
              var i2 = t5.gl, a2 = this.framebuffer = i2.createFramebuffer();
              this.colorAttachment = new Tt(t5, a2), n4 && (this.depthAttachment = new kt(t5, a2));
            };
            At.prototype.destroy = function() {
              var t5 = this.context.gl, e4 = this.colorAttachment.get();
              if (e4 && t5.deleteTexture(e4), this.depthAttachment) {
                var r4 = this.depthAttachment.get();
                r4 && t5.deleteRenderbuffer(r4);
              }
              t5.deleteFramebuffer(this.framebuffer);
            };
            var Mt = function(t5, e4, r4) {
              this.func = t5, this.mask = e4, this.range = r4;
            };
            Mt.ReadOnly = false, Mt.ReadWrite = true, Mt.disabled = new Mt(519, Mt.ReadOnly, [0, 1]);
            var St = 7680, Et = function(t5, e4, r4, n4, i2, a2) {
              this.test = t5, this.ref = e4, this.mask = r4, this.fail = n4, this.depthFail = i2, this.pass = a2;
            };
            Et.disabled = new Et({ func: 519, mask: 0 }, 0, 0, St, St, St);
            var Lt = function(t5, e4, r4) {
              this.blendFunction = t5, this.blendColor = e4, this.mask = r4;
            };
            Lt.disabled = new Lt(Lt.Replace = [1, 0], t4.Color.transparent, [false, false, false, false]), Lt.unblended = new Lt(Lt.Replace, t4.Color.transparent, [true, true, true, true]), Lt.alphaBlended = new Lt([1, 771], t4.Color.transparent, [true, true, true, true]);
            var Ct = function(t5, e4, r4) {
              this.enable = t5, this.mode = e4, this.frontFace = r4;
            };
            Ct.disabled = new Ct(false, 1029, 2305), Ct.backCCW = new Ct(true, 1029, 2305);
            var Pt = function(t5) {
              this.gl = t5, this.extVertexArrayObject = this.gl.getExtension("OES_vertex_array_object"), this.clearColor = new G(this), this.clearDepth = new Z(this), this.clearStencil = new Y(this), this.colorMask = new W(this), this.depthMask = new X(this), this.stencilMask = new J(this), this.stencilFunc = new K(this), this.stencilOp = new $(this), this.stencilTest = new Q(this), this.depthRange = new tt(this), this.depthTest = new et(this), this.depthFunc = new rt(this), this.blend = new nt(this), this.blendFunc = new it(this), this.blendColor = new at(this), this.blendEquation = new ot(this), this.cullFace = new st(this), this.cullFaceSide = new lt(this), this.frontFace = new ut(this), this.program = new ct(this), this.activeTexture = new ft(this), this.viewport = new ht(this), this.bindFramebuffer = new pt(this), this.bindRenderbuffer = new dt(this), this.bindTexture = new vt(this), this.bindVertexBuffer = new gt(this), this.bindElementBuffer = new yt(this), this.bindVertexArrayOES = this.extVertexArrayObject && new mt(this), this.pixelStoreUnpack = new xt(this), this.pixelStoreUnpackPremultiplyAlpha = new bt(this), this.pixelStoreUnpackFlipY = new _t(this), this.extTextureFilterAnisotropic = t5.getExtension("EXT_texture_filter_anisotropic") || t5.getExtension("MOZ_EXT_texture_filter_anisotropic") || t5.getExtension("WEBKIT_EXT_texture_filter_anisotropic"), this.extTextureFilterAnisotropic && (this.extTextureFilterAnisotropicMax = t5.getParameter(this.extTextureFilterAnisotropic.MAX_TEXTURE_MAX_ANISOTROPY_EXT)), this.extTextureHalfFloat = t5.getExtension("OES_texture_half_float"), this.extTextureHalfFloat && (t5.getExtension("OES_texture_half_float_linear"), this.extRenderToTextureHalfFloat = t5.getExtension("EXT_color_buffer_half_float")), this.extTimerQuery = t5.getExtension("EXT_disjoint_timer_query");
            };
            Pt.prototype.setDefault = function() {
              this.unbindVAO(), this.clearColor.setDefault(), this.clearDepth.setDefault(), this.clearStencil.setDefault(), this.colorMask.setDefault(), this.depthMask.setDefault(), this.stencilMask.setDefault(), this.stencilFunc.setDefault(), this.stencilOp.setDefault(), this.stencilTest.setDefault(), this.depthRange.setDefault(), this.depthTest.setDefault(), this.depthFunc.setDefault(), this.blend.setDefault(), this.blendFunc.setDefault(), this.blendColor.setDefault(), this.blendEquation.setDefault(), this.cullFace.setDefault(), this.cullFaceSide.setDefault(), this.frontFace.setDefault(), this.program.setDefault(), this.activeTexture.setDefault(), this.bindFramebuffer.setDefault(), this.pixelStoreUnpack.setDefault(), this.pixelStoreUnpackPremultiplyAlpha.setDefault(), this.pixelStoreUnpackFlipY.setDefault();
            }, Pt.prototype.setDirty = function() {
              this.clearColor.dirty = true, this.clearDepth.dirty = true, this.clearStencil.dirty = true, this.colorMask.dirty = true, this.depthMask.dirty = true, this.stencilMask.dirty = true, this.stencilFunc.dirty = true, this.stencilOp.dirty = true, this.stencilTest.dirty = true, this.depthRange.dirty = true, this.depthTest.dirty = true, this.depthFunc.dirty = true, this.blend.dirty = true, this.blendFunc.dirty = true, this.blendColor.dirty = true, this.blendEquation.dirty = true, this.cullFace.dirty = true, this.cullFaceSide.dirty = true, this.frontFace.dirty = true, this.program.dirty = true, this.activeTexture.dirty = true, this.viewport.dirty = true, this.bindFramebuffer.dirty = true, this.bindRenderbuffer.dirty = true, this.bindTexture.dirty = true, this.bindVertexBuffer.dirty = true, this.bindElementBuffer.dirty = true, this.extVertexArrayObject && (this.bindVertexArrayOES.dirty = true), this.pixelStoreUnpack.dirty = true, this.pixelStoreUnpackPremultiplyAlpha.dirty = true, this.pixelStoreUnpackFlipY.dirty = true;
            }, Pt.prototype.createIndexBuffer = function(t5, e4) {
              return new U(this, t5, e4);
            }, Pt.prototype.createVertexBuffer = function(t5, e4, r4) {
              return new H(this, t5, e4, r4);
            }, Pt.prototype.createRenderbuffer = function(t5, e4, r4) {
              var n4 = this.gl, i2 = n4.createRenderbuffer();
              return this.bindRenderbuffer.set(i2), n4.renderbufferStorage(n4.RENDERBUFFER, t5, e4, r4), this.bindRenderbuffer.set(null), i2;
            }, Pt.prototype.createFramebuffer = function(t5, e4, r4) {
              return new At(this, t5, e4, r4);
            }, Pt.prototype.clear = function(t5) {
              var e4 = t5.color, r4 = t5.depth, n4 = this.gl, i2 = 0;
              e4 && (i2 |= n4.COLOR_BUFFER_BIT, this.clearColor.set(e4), this.colorMask.set([true, true, true, true])), void 0 !== r4 && (i2 |= n4.DEPTH_BUFFER_BIT, this.depthRange.set([0, 1]), this.clearDepth.set(r4), this.depthMask.set(true)), n4.clear(i2);
            }, Pt.prototype.setCullFace = function(t5) {
              false === t5.enable ? this.cullFace.set(false) : (this.cullFace.set(true), this.cullFaceSide.set(t5.mode), this.frontFace.set(t5.frontFace));
            }, Pt.prototype.setDepthMode = function(t5) {
              t5.func !== this.gl.ALWAYS || t5.mask ? (this.depthTest.set(true), this.depthFunc.set(t5.func), this.depthMask.set(t5.mask), this.depthRange.set(t5.range)) : this.depthTest.set(false);
            }, Pt.prototype.setStencilMode = function(t5) {
              t5.test.func !== this.gl.ALWAYS || t5.mask ? (this.stencilTest.set(true), this.stencilMask.set(t5.mask), this.stencilOp.set([t5.fail, t5.depthFail, t5.pass]), this.stencilFunc.set({ func: t5.test.func, ref: t5.ref, mask: t5.test.mask })) : this.stencilTest.set(false);
            }, Pt.prototype.setColorMode = function(e4) {
              t4.deepEqual(e4.blendFunction, Lt.Replace) ? this.blend.set(false) : (this.blend.set(true), this.blendFunc.set(e4.blendFunction), this.blendColor.set(e4.blendColor)), this.colorMask.set(e4.mask);
            }, Pt.prototype.unbindVAO = function() {
              this.extVertexArrayObject && this.bindVertexArrayOES.set(null);
            };
            var Ot = function(e4) {
              function r4(r5, n4, i2) {
                var a2 = this;
                e4.call(this), this.id = r5, this.dispatcher = i2, this.on("data", function(t5) {
                  "source" === t5.dataType && "metadata" === t5.sourceDataType && (a2._sourceLoaded = true), a2._sourceLoaded && !a2._paused && "source" === t5.dataType && "content" === t5.sourceDataType && (a2.reload(), a2.transform && a2.update(a2.transform));
                }), this.on("error", function() {
                  a2._sourceErrored = true;
                }), this._source = function(e5, r6, n5, i3) {
                  var a3 = new R[r6.type](e5, r6, n5, i3);
                  if (a3.id !== e5)
                    throw new Error("Expected Source id to be " + e5 + " instead of " + a3.id);
                  return t4.bindAll(["load", "abort", "unload", "serialize", "prepare"], a3), a3;
                }(r5, n4, i2, this), this._tiles = {}, this._cache = new j(0, this._unloadTile.bind(this)), this._timers = {}, this._cacheTimers = {}, this._maxTileCacheSize = null, this._loadedParentTiles = {}, this._coveredTiles = {}, this._state = new t4.SourceFeatureState();
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.onAdd = function(t5) {
                this.map = t5, this._maxTileCacheSize = t5 ? t5._maxTileCacheSize : null, this._source && this._source.onAdd && this._source.onAdd(t5);
              }, r4.prototype.onRemove = function(t5) {
                this._source && this._source.onRemove && this._source.onRemove(t5);
              }, r4.prototype.loaded = function() {
                if (this._sourceErrored)
                  return true;
                if (!this._sourceLoaded)
                  return false;
                if (!this._source.loaded())
                  return false;
                for (var t5 in this._tiles) {
                  var e5 = this._tiles[t5];
                  if ("loaded" !== e5.state && "errored" !== e5.state)
                    return false;
                }
                return true;
              }, r4.prototype.getSource = function() {
                return this._source;
              }, r4.prototype.pause = function() {
                this._paused = true;
              }, r4.prototype.resume = function() {
                if (this._paused) {
                  var t5 = this._shouldReloadOnResume;
                  this._paused = false, this._shouldReloadOnResume = false, t5 && this.reload(), this.transform && this.update(this.transform);
                }
              }, r4.prototype._loadTile = function(t5, e5) {
                return this._source.loadTile(t5, e5);
              }, r4.prototype._unloadTile = function(t5) {
                if (this._source.unloadTile)
                  return this._source.unloadTile(t5, function() {
                  });
              }, r4.prototype._abortTile = function(t5) {
                if (this._source.abortTile)
                  return this._source.abortTile(t5, function() {
                  });
              }, r4.prototype.serialize = function() {
                return this._source.serialize();
              }, r4.prototype.prepare = function(t5) {
                for (var e5 in this._source.prepare && this._source.prepare(), this._state.coalesceChanges(this._tiles, this.map ? this.map.painter : null), this._tiles) {
                  var r5 = this._tiles[e5];
                  r5.upload(t5), r5.prepare(this.map.style.imageManager);
                }
              }, r4.prototype.getIds = function() {
                return t4.values(this._tiles).map(function(t5) {
                  return t5.tileID;
                }).sort(It).map(function(t5) {
                  return t5.key;
                });
              }, r4.prototype.getRenderableIds = function(e5) {
                var r5 = this, n4 = [];
                for (var i2 in this._tiles)
                  this._isIdRenderable(i2, e5) && n4.push(this._tiles[i2]);
                return e5 ? n4.sort(function(e6, n5) {
                  var i3 = e6.tileID, a2 = n5.tileID, o2 = new t4.Point(i3.canonical.x, i3.canonical.y)._rotate(r5.transform.angle), s2 = new t4.Point(a2.canonical.x, a2.canonical.y)._rotate(r5.transform.angle);
                  return i3.overscaledZ - a2.overscaledZ || s2.y - o2.y || s2.x - o2.x;
                }).map(function(t5) {
                  return t5.tileID.key;
                }) : n4.map(function(t5) {
                  return t5.tileID;
                }).sort(It).map(function(t5) {
                  return t5.key;
                });
              }, r4.prototype.hasRenderableParent = function(t5) {
                var e5 = this.findLoadedParent(t5, 0);
                return !!e5 && this._isIdRenderable(e5.tileID.key);
              }, r4.prototype._isIdRenderable = function(t5, e5) {
                return this._tiles[t5] && this._tiles[t5].hasData() && !this._coveredTiles[t5] && (e5 || !this._tiles[t5].holdingForFade());
              }, r4.prototype.reload = function() {
                if (this._paused)
                  this._shouldReloadOnResume = true;
                else
                  for (var t5 in this._cache.reset(), this._tiles)
                    "errored" !== this._tiles[t5].state && this._reloadTile(t5, "reloading");
              }, r4.prototype._reloadTile = function(t5, e5) {
                var r5 = this._tiles[t5];
                r5 && ("loading" !== r5.state && (r5.state = e5), this._loadTile(r5, this._tileLoaded.bind(this, r5, t5, e5)));
              }, r4.prototype._tileLoaded = function(e5, r5, n4, i2) {
                if (i2)
                  return e5.state = "errored", void (404 !== i2.status ? this._source.fire(new t4.ErrorEvent(i2, { tile: e5 })) : this.update(this.transform));
                e5.timeAdded = t4.browser.now(), "expired" === n4 && (e5.refreshedUponExpiration = true), this._setTileReloadTimer(r5, e5), "raster-dem" === this.getSource().type && e5.dem && this._backfillDEM(e5), this._state.initializeTileState(e5, this.map ? this.map.painter : null), this._source.fire(new t4.Event("data", { dataType: "source", tile: e5, coord: e5.tileID }));
              }, r4.prototype._backfillDEM = function(t5) {
                for (var e5 = this.getRenderableIds(), r5 = 0; r5 < e5.length; r5++) {
                  var n4 = e5[r5];
                  if (t5.neighboringTiles && t5.neighboringTiles[n4]) {
                    var i2 = this.getTileByID(n4);
                    a2(t5, i2), a2(i2, t5);
                  }
                }
                function a2(t6, e6) {
                  t6.needsHillshadePrepare = true;
                  var r6 = e6.tileID.canonical.x - t6.tileID.canonical.x, n5 = e6.tileID.canonical.y - t6.tileID.canonical.y, i3 = Math.pow(2, t6.tileID.canonical.z), a3 = e6.tileID.key;
                  0 === r6 && 0 === n5 || Math.abs(n5) > 1 || (Math.abs(r6) > 1 && (1 === Math.abs(r6 + i3) ? r6 += i3 : 1 === Math.abs(r6 - i3) && (r6 -= i3)), e6.dem && t6.dem && (t6.dem.backfillBorder(e6.dem, r6, n5), t6.neighboringTiles && t6.neighboringTiles[a3] && (t6.neighboringTiles[a3].backfilled = true)));
                }
              }, r4.prototype.getTile = function(t5) {
                return this.getTileByID(t5.key);
              }, r4.prototype.getTileByID = function(t5) {
                return this._tiles[t5];
              }, r4.prototype._retainLoadedChildren = function(t5, e5, r5, n4) {
                for (var i2 in this._tiles) {
                  var a2 = this._tiles[i2];
                  if (!(n4[i2] || !a2.hasData() || a2.tileID.overscaledZ <= e5 || a2.tileID.overscaledZ > r5)) {
                    for (var o2 = a2.tileID; a2 && a2.tileID.overscaledZ > e5 + 1; ) {
                      var s2 = a2.tileID.scaledTo(a2.tileID.overscaledZ - 1);
                      (a2 = this._tiles[s2.key]) && a2.hasData() && (o2 = s2);
                    }
                    for (var l2 = o2; l2.overscaledZ > e5; )
                      if (t5[(l2 = l2.scaledTo(l2.overscaledZ - 1)).key]) {
                        n4[o2.key] = o2;
                        break;
                      }
                  }
                }
              }, r4.prototype.findLoadedParent = function(t5, e5) {
                if (t5.key in this._loadedParentTiles) {
                  var r5 = this._loadedParentTiles[t5.key];
                  return r5 && r5.tileID.overscaledZ >= e5 ? r5 : null;
                }
                for (var n4 = t5.overscaledZ - 1; n4 >= e5; n4--) {
                  var i2 = t5.scaledTo(n4), a2 = this._getLoadedTile(i2);
                  if (a2)
                    return a2;
                }
              }, r4.prototype._getLoadedTile = function(t5) {
                var e5 = this._tiles[t5.key];
                return e5 && e5.hasData() ? e5 : this._cache.getByKey(t5.wrapped().key);
              }, r4.prototype.updateCacheSize = function(t5) {
                var e5 = (Math.ceil(t5.width / this._source.tileSize) + 1) * (Math.ceil(t5.height / this._source.tileSize) + 1), r5 = Math.floor(5 * e5), n4 = "number" == typeof this._maxTileCacheSize ? Math.min(this._maxTileCacheSize, r5) : r5;
                this._cache.setMaxSize(n4);
              }, r4.prototype.handleWrapJump = function(t5) {
                var e5 = (t5 - (void 0 === this._prevLng ? t5 : this._prevLng)) / 360, r5 = Math.round(e5);
                if (this._prevLng = t5, r5) {
                  var n4 = {};
                  for (var i2 in this._tiles) {
                    var a2 = this._tiles[i2];
                    a2.tileID = a2.tileID.unwrapTo(a2.tileID.wrap + r5), n4[a2.tileID.key] = a2;
                  }
                  for (var o2 in this._tiles = n4, this._timers)
                    clearTimeout(this._timers[o2]), delete this._timers[o2];
                  for (var s2 in this._tiles) {
                    var l2 = this._tiles[s2];
                    this._setTileReloadTimer(s2, l2);
                  }
                }
              }, r4.prototype.update = function(e5) {
                var n4 = this;
                if (this.transform = e5, this._sourceLoaded && !this._paused) {
                  var i2;
                  this.updateCacheSize(e5), this.handleWrapJump(this.transform.center.lng), this._coveredTiles = {}, this.used ? this._source.tileID ? i2 = e5.getVisibleUnwrappedCoordinates(this._source.tileID).map(function(e6) {
                    return new t4.OverscaledTileID(e6.canonical.z, e6.wrap, e6.canonical.z, e6.canonical.x, e6.canonical.y);
                  }) : (i2 = e5.coveringTiles({ tileSize: this._source.tileSize, minzoom: this._source.minzoom, maxzoom: this._source.maxzoom, roundZoom: this._source.roundZoom, reparseOverscaled: this._source.reparseOverscaled }), this._source.hasTile && (i2 = i2.filter(function(t5) {
                    return n4._source.hasTile(t5);
                  }))) : i2 = [];
                  var a2 = e5.coveringZoomLevel(this._source), o2 = Math.max(a2 - r4.maxOverzooming, this._source.minzoom), s2 = Math.max(a2 + r4.maxUnderzooming, this._source.minzoom), l2 = this._updateRetainedTiles(i2, a2);
                  if (Dt(this._source.type)) {
                    for (var u2 = {}, c2 = {}, f3 = 0, h2 = Object.keys(l2); f3 < h2.length; f3 += 1) {
                      var p3 = h2[f3], d3 = l2[p3], v2 = this._tiles[p3];
                      if (v2 && !(v2.fadeEndTime && v2.fadeEndTime <= t4.browser.now())) {
                        var g3 = this.findLoadedParent(d3, o2);
                        g3 && (this._addTile(g3.tileID), u2[g3.tileID.key] = g3.tileID), c2[p3] = d3;
                      }
                    }
                    for (var y2 in this._retainLoadedChildren(c2, a2, s2, l2), u2)
                      l2[y2] || (this._coveredTiles[y2] = true, l2[y2] = u2[y2]);
                  }
                  for (var m3 in l2)
                    this._tiles[m3].clearFadeHold();
                  for (var x2 = 0, b2 = t4.keysDifference(this._tiles, l2); x2 < b2.length; x2 += 1) {
                    var _2 = b2[x2], w3 = this._tiles[_2];
                    w3.hasSymbolBuckets && !w3.holdingForFade() ? w3.setHoldDuration(this.map._fadeDuration) : w3.hasSymbolBuckets && !w3.symbolFadeFinished() || this._removeTile(_2);
                  }
                  this._updateLoadedParentTileCache();
                }
              }, r4.prototype.releaseSymbolFadeTiles = function() {
                for (var t5 in this._tiles)
                  this._tiles[t5].holdingForFade() && this._removeTile(t5);
              }, r4.prototype._updateRetainedTiles = function(t5, e5) {
                for (var n4 = {}, i2 = {}, a2 = Math.max(e5 - r4.maxOverzooming, this._source.minzoom), o2 = Math.max(e5 + r4.maxUnderzooming, this._source.minzoom), s2 = {}, l2 = 0, u2 = t5; l2 < u2.length; l2 += 1) {
                  var c2 = u2[l2], f3 = this._addTile(c2);
                  n4[c2.key] = c2, f3.hasData() || e5 < this._source.maxzoom && (s2[c2.key] = c2);
                }
                this._retainLoadedChildren(s2, e5, o2, n4);
                for (var h2 = 0, p3 = t5; h2 < p3.length; h2 += 1) {
                  var d3 = p3[h2], v2 = this._tiles[d3.key];
                  if (!v2.hasData()) {
                    if (e5 + 1 > this._source.maxzoom) {
                      var g3 = d3.children(this._source.maxzoom)[0], y2 = this.getTile(g3);
                      if (y2 && y2.hasData()) {
                        n4[g3.key] = g3;
                        continue;
                      }
                    } else {
                      var m3 = d3.children(this._source.maxzoom);
                      if (n4[m3[0].key] && n4[m3[1].key] && n4[m3[2].key] && n4[m3[3].key])
                        continue;
                    }
                    for (var x2 = v2.wasRequested(), b2 = d3.overscaledZ - 1; b2 >= a2; --b2) {
                      var _2 = d3.scaledTo(b2);
                      if (i2[_2.key])
                        break;
                      if (i2[_2.key] = true, !(v2 = this.getTile(_2)) && x2 && (v2 = this._addTile(_2)), v2 && (n4[_2.key] = _2, x2 = v2.wasRequested(), v2.hasData()))
                        break;
                    }
                  }
                }
                return n4;
              }, r4.prototype._updateLoadedParentTileCache = function() {
                for (var t5 in this._loadedParentTiles = {}, this._tiles) {
                  for (var e5 = [], r5 = void 0, n4 = this._tiles[t5].tileID; n4.overscaledZ > 0; ) {
                    if (n4.key in this._loadedParentTiles) {
                      r5 = this._loadedParentTiles[n4.key];
                      break;
                    }
                    e5.push(n4.key);
                    var i2 = n4.scaledTo(n4.overscaledZ - 1);
                    if (r5 = this._getLoadedTile(i2))
                      break;
                    n4 = i2;
                  }
                  for (var a2 = 0, o2 = e5; a2 < o2.length; a2 += 1) {
                    var s2 = o2[a2];
                    this._loadedParentTiles[s2] = r5;
                  }
                }
              }, r4.prototype._addTile = function(e5) {
                var r5 = this._tiles[e5.key];
                if (r5)
                  return r5;
                (r5 = this._cache.getAndRemove(e5)) && (this._setTileReloadTimer(e5.key, r5), r5.tileID = e5, this._state.initializeTileState(r5, this.map ? this.map.painter : null), this._cacheTimers[e5.key] && (clearTimeout(this._cacheTimers[e5.key]), delete this._cacheTimers[e5.key], this._setTileReloadTimer(e5.key, r5)));
                var n4 = Boolean(r5);
                return n4 || (r5 = new t4.Tile(e5, this._source.tileSize * e5.overscaleFactor()), this._loadTile(r5, this._tileLoaded.bind(this, r5, e5.key, r5.state))), r5 ? (r5.uses++, this._tiles[e5.key] = r5, n4 || this._source.fire(new t4.Event("dataloading", { tile: r5, coord: r5.tileID, dataType: "source" })), r5) : null;
              }, r4.prototype._setTileReloadTimer = function(t5, e5) {
                var r5 = this;
                t5 in this._timers && (clearTimeout(this._timers[t5]), delete this._timers[t5]);
                var n4 = e5.getExpiryTimeout();
                n4 && (this._timers[t5] = setTimeout(function() {
                  r5._reloadTile(t5, "expired"), delete r5._timers[t5];
                }, n4));
              }, r4.prototype._removeTile = function(t5) {
                var e5 = this._tiles[t5];
                e5 && (e5.uses--, delete this._tiles[t5], this._timers[t5] && (clearTimeout(this._timers[t5]), delete this._timers[t5]), e5.uses > 0 || (e5.hasData() && "reloading" !== e5.state ? this._cache.add(e5.tileID, e5, e5.getExpiryTimeout()) : (e5.aborted = true, this._abortTile(e5), this._unloadTile(e5))));
              }, r4.prototype.clearTiles = function() {
                for (var t5 in this._shouldReloadOnResume = false, this._paused = false, this._tiles)
                  this._removeTile(t5);
                this._cache.reset();
              }, r4.prototype.tilesIn = function(e5, r5, n4) {
                var i2 = this, a2 = [], o2 = this.transform;
                if (!o2)
                  return a2;
                for (var s2 = n4 ? o2.getCameraQueryGeometry(e5) : e5, l2 = e5.map(function(t5) {
                  return o2.pointCoordinate(t5);
                }), u2 = s2.map(function(t5) {
                  return o2.pointCoordinate(t5);
                }), c2 = this.getIds(), f3 = 1 / 0, h2 = 1 / 0, p3 = -1 / 0, d3 = -1 / 0, v2 = 0, g3 = u2; v2 < g3.length; v2 += 1) {
                  var y2 = g3[v2];
                  f3 = Math.min(f3, y2.x), h2 = Math.min(h2, y2.y), p3 = Math.max(p3, y2.x), d3 = Math.max(d3, y2.y);
                }
                for (var m3 = function(e6) {
                  var n5 = i2._tiles[c2[e6]];
                  if (!n5.holdingForFade()) {
                    var s3 = n5.tileID, v3 = Math.pow(2, o2.zoom - n5.tileID.overscaledZ), g4 = r5 * n5.queryPadding * t4.EXTENT / n5.tileSize / v3, y3 = [s3.getTilePoint(new t4.MercatorCoordinate(f3, h2)), s3.getTilePoint(new t4.MercatorCoordinate(p3, d3))];
                    if (y3[0].x - g4 < t4.EXTENT && y3[0].y - g4 < t4.EXTENT && y3[1].x + g4 >= 0 && y3[1].y + g4 >= 0) {
                      var m4 = l2.map(function(t5) {
                        return s3.getTilePoint(t5);
                      }), x3 = u2.map(function(t5) {
                        return s3.getTilePoint(t5);
                      });
                      a2.push({ tile: n5, tileID: s3, queryGeometry: m4, cameraQueryGeometry: x3, scale: v3 });
                    }
                  }
                }, x2 = 0; x2 < c2.length; x2++)
                  m3(x2);
                return a2;
              }, r4.prototype.getVisibleCoordinates = function(t5) {
                for (var e5 = this, r5 = this.getRenderableIds(t5).map(function(t6) {
                  return e5._tiles[t6].tileID;
                }), n4 = 0, i2 = r5; n4 < i2.length; n4 += 1) {
                  var a2 = i2[n4];
                  a2.posMatrix = this.transform.calculatePosMatrix(a2.toUnwrapped());
                }
                return r5;
              }, r4.prototype.hasTransition = function() {
                if (this._source.hasTransition())
                  return true;
                if (Dt(this._source.type))
                  for (var e5 in this._tiles) {
                    var r5 = this._tiles[e5];
                    if (void 0 !== r5.fadeEndTime && r5.fadeEndTime >= t4.browser.now())
                      return true;
                  }
                return false;
              }, r4.prototype.setFeatureState = function(t5, e5, r5) {
                t5 = t5 || "_geojsonTileLayer", this._state.updateState(t5, e5, r5);
              }, r4.prototype.removeFeatureState = function(t5, e5, r5) {
                t5 = t5 || "_geojsonTileLayer", this._state.removeFeatureState(t5, e5, r5);
              }, r4.prototype.getFeatureState = function(t5, e5) {
                return t5 = t5 || "_geojsonTileLayer", this._state.getState(t5, e5);
              }, r4.prototype.setDependencies = function(t5, e5, r5) {
                var n4 = this._tiles[t5];
                n4 && n4.setDependencies(e5, r5);
              }, r4.prototype.reloadTilesForDependencies = function(t5, e5) {
                for (var r5 in this._tiles)
                  this._tiles[r5].hasDependency(t5, e5) && this._reloadTile(r5, "reloading");
                this._cache.filter(function(r6) {
                  return !r6.hasDependency(t5, e5);
                });
              }, r4;
            }(t4.Evented);
            function It(t5, e4) {
              var r4 = Math.abs(2 * t5.wrap) - +(t5.wrap < 0), n4 = Math.abs(2 * e4.wrap) - +(e4.wrap < 0);
              return t5.overscaledZ - e4.overscaledZ || n4 - r4 || e4.canonical.y - t5.canonical.y || e4.canonical.x - t5.canonical.x;
            }
            function Dt(t5) {
              return "raster" === t5 || "image" === t5 || "video" === t5;
            }
            function zt() {
              return new t4.window.Worker(ta.workerUrl);
            }
            Ot.maxOverzooming = 10, Ot.maxUnderzooming = 3;
            var Rt = "mapboxgl_preloaded_worker_pool", Ft = function() {
              this.active = {};
            };
            Ft.prototype.acquire = function(t5) {
              if (!this.workers)
                for (this.workers = []; this.workers.length < Ft.workerCount; )
                  this.workers.push(new zt());
              return this.active[t5] = true, this.workers.slice();
            }, Ft.prototype.release = function(t5) {
              delete this.active[t5], 0 === this.numActive() && (this.workers.forEach(function(t6) {
                t6.terminate();
              }), this.workers = null);
            }, Ft.prototype.isPreloaded = function() {
              return !!this.active[Rt];
            }, Ft.prototype.numActive = function() {
              return Object.keys(this.active).length;
            };
            var Bt, Nt = Math.floor(t4.browser.hardwareConcurrency / 2);
            function jt() {
              return Bt || (Bt = new Ft()), Bt;
            }
            function Ut(e4, r4) {
              var n4 = {};
              for (var i2 in e4)
                "ref" !== i2 && (n4[i2] = e4[i2]);
              return t4.refProperties.forEach(function(t5) {
                t5 in r4 && (n4[t5] = r4[t5]);
              }), n4;
            }
            function Vt(t5) {
              t5 = t5.slice();
              for (var e4 = /* @__PURE__ */ Object.create(null), r4 = 0; r4 < t5.length; r4++)
                e4[t5[r4].id] = t5[r4];
              for (var n4 = 0; n4 < t5.length; n4++)
                "ref" in t5[n4] && (t5[n4] = Ut(t5[n4], e4[t5[n4].ref]));
              return t5;
            }
            Ft.workerCount = Math.max(Math.min(Nt, 6), 1);
            var Ht = { setStyle: "setStyle", addLayer: "addLayer", removeLayer: "removeLayer", setPaintProperty: "setPaintProperty", setLayoutProperty: "setLayoutProperty", setFilter: "setFilter", addSource: "addSource", removeSource: "removeSource", setGeoJSONSourceData: "setGeoJSONSourceData", setLayerZoomRange: "setLayerZoomRange", setLayerProperty: "setLayerProperty", setCenter: "setCenter", setZoom: "setZoom", setBearing: "setBearing", setPitch: "setPitch", setSprite: "setSprite", setGlyphs: "setGlyphs", setTransition: "setTransition", setLight: "setLight" };
            function qt(t5, e4, r4) {
              r4.push({ command: Ht.addSource, args: [t5, e4[t5]] });
            }
            function Gt(t5, e4, r4) {
              e4.push({ command: Ht.removeSource, args: [t5] }), r4[t5] = true;
            }
            function Zt(t5, e4, r4, n4) {
              Gt(t5, r4, n4), qt(t5, e4, r4);
            }
            function Yt(e4, r4, n4) {
              var i2;
              for (i2 in e4[n4])
                if (e4[n4].hasOwnProperty(i2) && "data" !== i2 && !t4.deepEqual(e4[n4][i2], r4[n4][i2]))
                  return false;
              for (i2 in r4[n4])
                if (r4[n4].hasOwnProperty(i2) && "data" !== i2 && !t4.deepEqual(e4[n4][i2], r4[n4][i2]))
                  return false;
              return true;
            }
            function Wt(e4, r4, n4, i2, a2, o2) {
              var s2;
              for (s2 in r4 = r4 || {}, e4 = e4 || {})
                e4.hasOwnProperty(s2) && (t4.deepEqual(e4[s2], r4[s2]) || n4.push({ command: o2, args: [i2, s2, r4[s2], a2] }));
              for (s2 in r4)
                r4.hasOwnProperty(s2) && !e4.hasOwnProperty(s2) && (t4.deepEqual(e4[s2], r4[s2]) || n4.push({ command: o2, args: [i2, s2, r4[s2], a2] }));
            }
            function Xt(t5) {
              return t5.id;
            }
            function Jt(t5, e4) {
              return t5[e4.id] = e4, t5;
            }
            function Kt(e4, r4) {
              if (!e4)
                return [{ command: Ht.setStyle, args: [r4] }];
              var n4 = [];
              try {
                if (!t4.deepEqual(e4.version, r4.version))
                  return [{ command: Ht.setStyle, args: [r4] }];
                t4.deepEqual(e4.center, r4.center) || n4.push({ command: Ht.setCenter, args: [r4.center] }), t4.deepEqual(e4.zoom, r4.zoom) || n4.push({ command: Ht.setZoom, args: [r4.zoom] }), t4.deepEqual(e4.bearing, r4.bearing) || n4.push({ command: Ht.setBearing, args: [r4.bearing] }), t4.deepEqual(e4.pitch, r4.pitch) || n4.push({ command: Ht.setPitch, args: [r4.pitch] }), t4.deepEqual(e4.sprite, r4.sprite) || n4.push({ command: Ht.setSprite, args: [r4.sprite] }), t4.deepEqual(e4.glyphs, r4.glyphs) || n4.push({ command: Ht.setGlyphs, args: [r4.glyphs] }), t4.deepEqual(e4.transition, r4.transition) || n4.push({ command: Ht.setTransition, args: [r4.transition] }), t4.deepEqual(e4.light, r4.light) || n4.push({ command: Ht.setLight, args: [r4.light] });
                var i2 = {}, a2 = [];
                !function(e5, r5, n5, i3) {
                  var a3;
                  for (a3 in r5 = r5 || {}, e5 = e5 || {})
                    e5.hasOwnProperty(a3) && (r5.hasOwnProperty(a3) || Gt(a3, n5, i3));
                  for (a3 in r5)
                    r5.hasOwnProperty(a3) && (e5.hasOwnProperty(a3) ? t4.deepEqual(e5[a3], r5[a3]) || ("geojson" === e5[a3].type && "geojson" === r5[a3].type && Yt(e5, r5, a3) ? n5.push({ command: Ht.setGeoJSONSourceData, args: [a3, r5[a3].data] }) : Zt(a3, r5, n5, i3)) : qt(a3, r5, n5));
                }(e4.sources, r4.sources, a2, i2);
                var o2 = [];
                e4.layers && e4.layers.forEach(function(t5) {
                  i2[t5.source] ? n4.push({ command: Ht.removeLayer, args: [t5.id] }) : o2.push(t5);
                }), n4 = n4.concat(a2), function(e5, r5, n5) {
                  r5 = r5 || [];
                  var i3, a3, o3, s2, l2, u2, c2, f3 = (e5 = e5 || []).map(Xt), h2 = r5.map(Xt), p3 = e5.reduce(Jt, {}), d3 = r5.reduce(Jt, {}), v2 = f3.slice(), g3 = /* @__PURE__ */ Object.create(null);
                  for (i3 = 0, a3 = 0; i3 < f3.length; i3++)
                    o3 = f3[i3], d3.hasOwnProperty(o3) ? a3++ : (n5.push({ command: Ht.removeLayer, args: [o3] }), v2.splice(v2.indexOf(o3, a3), 1));
                  for (i3 = 0, a3 = 0; i3 < h2.length; i3++)
                    o3 = h2[h2.length - 1 - i3], v2[v2.length - 1 - i3] !== o3 && (p3.hasOwnProperty(o3) ? (n5.push({ command: Ht.removeLayer, args: [o3] }), v2.splice(v2.lastIndexOf(o3, v2.length - a3), 1)) : a3++, u2 = v2[v2.length - i3], n5.push({ command: Ht.addLayer, args: [d3[o3], u2] }), v2.splice(v2.length - i3, 0, o3), g3[o3] = true);
                  for (i3 = 0; i3 < h2.length; i3++)
                    if (s2 = p3[o3 = h2[i3]], l2 = d3[o3], !g3[o3] && !t4.deepEqual(s2, l2))
                      if (t4.deepEqual(s2.source, l2.source) && t4.deepEqual(s2["source-layer"], l2["source-layer"]) && t4.deepEqual(s2.type, l2.type)) {
                        for (c2 in Wt(s2.layout, l2.layout, n5, o3, null, Ht.setLayoutProperty), Wt(s2.paint, l2.paint, n5, o3, null, Ht.setPaintProperty), t4.deepEqual(s2.filter, l2.filter) || n5.push({ command: Ht.setFilter, args: [o3, l2.filter] }), t4.deepEqual(s2.minzoom, l2.minzoom) && t4.deepEqual(s2.maxzoom, l2.maxzoom) || n5.push({ command: Ht.setLayerZoomRange, args: [o3, l2.minzoom, l2.maxzoom] }), s2)
                          s2.hasOwnProperty(c2) && "layout" !== c2 && "paint" !== c2 && "filter" !== c2 && "metadata" !== c2 && "minzoom" !== c2 && "maxzoom" !== c2 && (0 === c2.indexOf("paint.") ? Wt(s2[c2], l2[c2], n5, o3, c2.slice(6), Ht.setPaintProperty) : t4.deepEqual(s2[c2], l2[c2]) || n5.push({ command: Ht.setLayerProperty, args: [o3, c2, l2[c2]] }));
                        for (c2 in l2)
                          l2.hasOwnProperty(c2) && !s2.hasOwnProperty(c2) && "layout" !== c2 && "paint" !== c2 && "filter" !== c2 && "metadata" !== c2 && "minzoom" !== c2 && "maxzoom" !== c2 && (0 === c2.indexOf("paint.") ? Wt(s2[c2], l2[c2], n5, o3, c2.slice(6), Ht.setPaintProperty) : t4.deepEqual(s2[c2], l2[c2]) || n5.push({ command: Ht.setLayerProperty, args: [o3, c2, l2[c2]] }));
                      } else
                        n5.push({ command: Ht.removeLayer, args: [o3] }), u2 = v2[v2.lastIndexOf(o3) + 1], n5.push({ command: Ht.addLayer, args: [l2, u2] });
                }(o2, r4.layers, n4);
              } catch (t5) {
                console.warn("Unable to compute style diff:", t5), n4 = [{ command: Ht.setStyle, args: [r4] }];
              }
              return n4;
            }
            var $t = function(t5, e4) {
              this.reset(t5, e4);
            };
            $t.prototype.reset = function(t5, e4) {
              this.points = t5 || [], this._distances = [0];
              for (var r4 = 1; r4 < this.points.length; r4++)
                this._distances[r4] = this._distances[r4 - 1] + this.points[r4].dist(this.points[r4 - 1]);
              this.length = this._distances[this._distances.length - 1], this.padding = Math.min(e4 || 0, 0.5 * this.length), this.paddedLength = this.length - 2 * this.padding;
            }, $t.prototype.lerp = function(e4) {
              if (1 === this.points.length)
                return this.points[0];
              e4 = t4.clamp(e4, 0, 1);
              for (var r4 = 1, n4 = this._distances[r4], i2 = e4 * this.paddedLength + this.padding; n4 < i2 && r4 < this._distances.length; )
                n4 = this._distances[++r4];
              var a2 = r4 - 1, o2 = this._distances[a2], s2 = n4 - o2, l2 = s2 > 0 ? (i2 - o2) / s2 : 0;
              return this.points[a2].mult(1 - l2).add(this.points[r4].mult(l2));
            };
            var Qt = function(t5, e4, r4) {
              var n4 = this.boxCells = [], i2 = this.circleCells = [];
              this.xCellCount = Math.ceil(t5 / r4), this.yCellCount = Math.ceil(e4 / r4);
              for (var a2 = 0; a2 < this.xCellCount * this.yCellCount; a2++)
                n4.push([]), i2.push([]);
              this.circleKeys = [], this.boxKeys = [], this.bboxes = [], this.circles = [], this.width = t5, this.height = e4, this.xScale = this.xCellCount / t5, this.yScale = this.yCellCount / e4, this.boxUid = 0, this.circleUid = 0;
            };
            function te(e4, r4, n4, i2, a2) {
              var o2 = t4.create();
              return r4 ? (t4.scale(o2, o2, [1 / a2, 1 / a2, 1]), n4 || t4.rotateZ(o2, o2, i2.angle)) : t4.multiply(o2, i2.labelPlaneMatrix, e4), o2;
            }
            function ee(e4, r4, n4, i2, a2) {
              if (r4) {
                var o2 = t4.clone(e4);
                return t4.scale(o2, o2, [a2, a2, 1]), n4 || t4.rotateZ(o2, o2, -i2.angle), o2;
              }
              return i2.glCoordMatrix;
            }
            function re(e4, r4) {
              var n4 = [e4.x, e4.y, 0, 1];
              pe(n4, n4, r4);
              var i2 = n4[3];
              return { point: new t4.Point(n4[0] / i2, n4[1] / i2), signedDistanceFromCamera: i2 };
            }
            function ne(t5, e4) {
              return 0.5 + t5 / e4 * 0.5;
            }
            function ie(t5, e4) {
              var r4 = t5[0] / t5[3], n4 = t5[1] / t5[3];
              return r4 >= -e4[0] && r4 <= e4[0] && n4 >= -e4[1] && n4 <= e4[1];
            }
            function ae(e4, r4, n4, i2, a2, o2, s2, l2) {
              var u2 = i2 ? e4.textSizeData : e4.iconSizeData, c2 = t4.evaluateSizeForZoom(u2, n4.transform.zoom), f3 = [256 / n4.width * 2 + 1, 256 / n4.height * 2 + 1], h2 = i2 ? e4.text.dynamicLayoutVertexArray : e4.icon.dynamicLayoutVertexArray;
              h2.clear();
              for (var p3 = e4.lineVertexArray, d3 = i2 ? e4.text.placedSymbolArray : e4.icon.placedSymbolArray, v2 = n4.transform.width / n4.transform.height, g3 = false, y2 = 0; y2 < d3.length; y2++) {
                var m3 = d3.get(y2);
                if (m3.hidden || m3.writingMode === t4.WritingMode.vertical && !g3)
                  he(m3.numGlyphs, h2);
                else {
                  g3 = false;
                  var x2 = [m3.anchorX, m3.anchorY, 0, 1];
                  if (t4.transformMat4(x2, x2, r4), ie(x2, f3)) {
                    var b2 = x2[3], _2 = ne(n4.transform.cameraToCenterDistance, b2), w3 = t4.evaluateSizeForFeature(u2, c2, m3), T2 = s2 ? w3 / _2 : w3 * _2, k2 = new t4.Point(m3.anchorX, m3.anchorY), A2 = re(k2, a2).point, M2 = {}, S2 = le(m3, T2, false, l2, r4, a2, o2, e4.glyphOffsetArray, p3, h2, A2, k2, M2, v2);
                    g3 = S2.useVertical, (S2.notEnoughRoom || g3 || S2.needsFlipping && le(m3, T2, true, l2, r4, a2, o2, e4.glyphOffsetArray, p3, h2, A2, k2, M2, v2).notEnoughRoom) && he(m3.numGlyphs, h2);
                  } else
                    he(m3.numGlyphs, h2);
                }
              }
              i2 ? e4.text.dynamicLayoutVertexBuffer.updateData(h2) : e4.icon.dynamicLayoutVertexBuffer.updateData(h2);
            }
            function oe(t5, e4, r4, n4, i2, a2, o2, s2, l2, u2, c2) {
              var f3 = s2.glyphStartIndex + s2.numGlyphs, h2 = s2.lineStartIndex, p3 = s2.lineStartIndex + s2.lineLength, d3 = e4.getoffsetX(s2.glyphStartIndex), v2 = e4.getoffsetX(f3 - 1), g3 = ce(t5 * d3, r4, n4, i2, a2, o2, s2.segment, h2, p3, l2, u2, c2);
              if (!g3)
                return null;
              var y2 = ce(t5 * v2, r4, n4, i2, a2, o2, s2.segment, h2, p3, l2, u2, c2);
              return y2 ? { first: g3, last: y2 } : null;
            }
            function se(e4, r4, n4, i2) {
              return e4 === t4.WritingMode.horizontal && Math.abs(n4.y - r4.y) > Math.abs(n4.x - r4.x) * i2 ? { useVertical: true } : (e4 === t4.WritingMode.vertical ? r4.y < n4.y : r4.x > n4.x) ? { needsFlipping: true } : null;
            }
            function le(e4, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3, d3) {
              var v2, g3 = r4 / 24, y2 = e4.lineOffsetX * g3, m3 = e4.lineOffsetY * g3;
              if (e4.numGlyphs > 1) {
                var x2 = e4.glyphStartIndex + e4.numGlyphs, b2 = e4.lineStartIndex, _2 = e4.lineStartIndex + e4.lineLength, w3 = oe(g3, l2, y2, m3, n4, f3, h2, e4, u2, o2, p3);
                if (!w3)
                  return { notEnoughRoom: true };
                var T2 = re(w3.first.point, s2).point, k2 = re(w3.last.point, s2).point;
                if (i2 && !n4) {
                  var A2 = se(e4.writingMode, T2, k2, d3);
                  if (A2)
                    return A2;
                }
                v2 = [w3.first];
                for (var M2 = e4.glyphStartIndex + 1; M2 < x2 - 1; M2++)
                  v2.push(ce(g3 * l2.getoffsetX(M2), y2, m3, n4, f3, h2, e4.segment, b2, _2, u2, o2, p3));
                v2.push(w3.last);
              } else {
                if (i2 && !n4) {
                  var S2 = re(h2, a2).point, E2 = e4.lineStartIndex + e4.segment + 1, L2 = new t4.Point(u2.getx(E2), u2.gety(E2)), C2 = re(L2, a2), P2 = C2.signedDistanceFromCamera > 0 ? C2.point : ue(h2, L2, S2, 1, a2), O2 = se(e4.writingMode, S2, P2, d3);
                  if (O2)
                    return O2;
                }
                var I2 = ce(g3 * l2.getoffsetX(e4.glyphStartIndex), y2, m3, n4, f3, h2, e4.segment, e4.lineStartIndex, e4.lineStartIndex + e4.lineLength, u2, o2, p3);
                if (!I2)
                  return { notEnoughRoom: true };
                v2 = [I2];
              }
              for (var D2 = 0, z2 = v2; D2 < z2.length; D2 += 1) {
                var R2 = z2[D2];
                t4.addDynamicAttributes(c2, R2.point, R2.angle);
              }
              return {};
            }
            function ue(t5, e4, r4, n4, i2) {
              var a2 = re(t5.add(t5.sub(e4)._unit()), i2).point, o2 = r4.sub(a2);
              return r4.add(o2._mult(n4 / o2.mag()));
            }
            function ce(e4, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2) {
              var p3 = i2 ? e4 - r4 : e4 + r4, d3 = p3 > 0 ? 1 : -1, v2 = 0;
              i2 && (d3 *= -1, v2 = Math.PI), d3 < 0 && (v2 += Math.PI);
              for (var g3 = d3 > 0 ? l2 + s2 : l2 + s2 + 1, y2 = a2, m3 = a2, x2 = 0, b2 = 0, _2 = Math.abs(p3), w3 = []; x2 + b2 <= _2; ) {
                if ((g3 += d3) < l2 || g3 >= u2)
                  return null;
                if (m3 = y2, w3.push(y2), void 0 === (y2 = h2[g3])) {
                  var T2 = new t4.Point(c2.getx(g3), c2.gety(g3)), k2 = re(T2, f3);
                  if (k2.signedDistanceFromCamera > 0)
                    y2 = h2[g3] = k2.point;
                  else {
                    var A2 = g3 - d3;
                    y2 = ue(0 === x2 ? o2 : new t4.Point(c2.getx(A2), c2.gety(A2)), T2, m3, _2 - x2 + 1, f3);
                  }
                }
                x2 += b2, b2 = m3.dist(y2);
              }
              var M2 = (_2 - x2) / b2, S2 = y2.sub(m3), E2 = S2.mult(M2)._add(m3);
              E2._add(S2._unit()._perp()._mult(n4 * d3));
              var L2 = v2 + Math.atan2(y2.y - m3.y, y2.x - m3.x);
              return w3.push(E2), { point: E2, angle: L2, path: w3 };
            }
            Qt.prototype.keysLength = function() {
              return this.boxKeys.length + this.circleKeys.length;
            }, Qt.prototype.insert = function(t5, e4, r4, n4, i2) {
              this._forEachCell(e4, r4, n4, i2, this._insertBoxCell, this.boxUid++), this.boxKeys.push(t5), this.bboxes.push(e4), this.bboxes.push(r4), this.bboxes.push(n4), this.bboxes.push(i2);
            }, Qt.prototype.insertCircle = function(t5, e4, r4, n4) {
              this._forEachCell(e4 - n4, r4 - n4, e4 + n4, r4 + n4, this._insertCircleCell, this.circleUid++), this.circleKeys.push(t5), this.circles.push(e4), this.circles.push(r4), this.circles.push(n4);
            }, Qt.prototype._insertBoxCell = function(t5, e4, r4, n4, i2, a2) {
              this.boxCells[i2].push(a2);
            }, Qt.prototype._insertCircleCell = function(t5, e4, r4, n4, i2, a2) {
              this.circleCells[i2].push(a2);
            }, Qt.prototype._query = function(t5, e4, r4, n4, i2, a2) {
              if (r4 < 0 || t5 > this.width || n4 < 0 || e4 > this.height)
                return !i2 && [];
              var o2 = [];
              if (t5 <= 0 && e4 <= 0 && this.width <= r4 && this.height <= n4) {
                if (i2)
                  return true;
                for (var s2 = 0; s2 < this.boxKeys.length; s2++)
                  o2.push({ key: this.boxKeys[s2], x1: this.bboxes[4 * s2], y1: this.bboxes[4 * s2 + 1], x2: this.bboxes[4 * s2 + 2], y2: this.bboxes[4 * s2 + 3] });
                for (var l2 = 0; l2 < this.circleKeys.length; l2++) {
                  var u2 = this.circles[3 * l2], c2 = this.circles[3 * l2 + 1], f3 = this.circles[3 * l2 + 2];
                  o2.push({ key: this.circleKeys[l2], x1: u2 - f3, y1: c2 - f3, x2: u2 + f3, y2: c2 + f3 });
                }
                return a2 ? o2.filter(a2) : o2;
              }
              var h2 = { hitTest: i2, seenUids: { box: {}, circle: {} } };
              return this._forEachCell(t5, e4, r4, n4, this._queryCell, o2, h2, a2), i2 ? o2.length > 0 : o2;
            }, Qt.prototype._queryCircle = function(t5, e4, r4, n4, i2) {
              var a2 = t5 - r4, o2 = t5 + r4, s2 = e4 - r4, l2 = e4 + r4;
              if (o2 < 0 || a2 > this.width || l2 < 0 || s2 > this.height)
                return !n4 && [];
              var u2 = [], c2 = { hitTest: n4, circle: { x: t5, y: e4, radius: r4 }, seenUids: { box: {}, circle: {} } };
              return this._forEachCell(a2, s2, o2, l2, this._queryCellCircle, u2, c2, i2), n4 ? u2.length > 0 : u2;
            }, Qt.prototype.query = function(t5, e4, r4, n4, i2) {
              return this._query(t5, e4, r4, n4, false, i2);
            }, Qt.prototype.hitTest = function(t5, e4, r4, n4, i2) {
              return this._query(t5, e4, r4, n4, true, i2);
            }, Qt.prototype.hitTestCircle = function(t5, e4, r4, n4) {
              return this._queryCircle(t5, e4, r4, true, n4);
            }, Qt.prototype._queryCell = function(t5, e4, r4, n4, i2, a2, o2, s2) {
              var l2 = o2.seenUids, u2 = this.boxCells[i2];
              if (null !== u2)
                for (var c2 = this.bboxes, f3 = 0, h2 = u2; f3 < h2.length; f3 += 1) {
                  var p3 = h2[f3];
                  if (!l2.box[p3]) {
                    l2.box[p3] = true;
                    var d3 = 4 * p3;
                    if (t5 <= c2[d3 + 2] && e4 <= c2[d3 + 3] && r4 >= c2[d3 + 0] && n4 >= c2[d3 + 1] && (!s2 || s2(this.boxKeys[p3]))) {
                      if (o2.hitTest)
                        return a2.push(true), true;
                      a2.push({ key: this.boxKeys[p3], x1: c2[d3], y1: c2[d3 + 1], x2: c2[d3 + 2], y2: c2[d3 + 3] });
                    }
                  }
                }
              var v2 = this.circleCells[i2];
              if (null !== v2)
                for (var g3 = this.circles, y2 = 0, m3 = v2; y2 < m3.length; y2 += 1) {
                  var x2 = m3[y2];
                  if (!l2.circle[x2]) {
                    l2.circle[x2] = true;
                    var b2 = 3 * x2;
                    if (this._circleAndRectCollide(g3[b2], g3[b2 + 1], g3[b2 + 2], t5, e4, r4, n4) && (!s2 || s2(this.circleKeys[x2]))) {
                      if (o2.hitTest)
                        return a2.push(true), true;
                      var _2 = g3[b2], w3 = g3[b2 + 1], T2 = g3[b2 + 2];
                      a2.push({ key: this.circleKeys[x2], x1: _2 - T2, y1: w3 - T2, x2: _2 + T2, y2: w3 + T2 });
                    }
                  }
                }
            }, Qt.prototype._queryCellCircle = function(t5, e4, r4, n4, i2, a2, o2, s2) {
              var l2 = o2.circle, u2 = o2.seenUids, c2 = this.boxCells[i2];
              if (null !== c2)
                for (var f3 = this.bboxes, h2 = 0, p3 = c2; h2 < p3.length; h2 += 1) {
                  var d3 = p3[h2];
                  if (!u2.box[d3]) {
                    u2.box[d3] = true;
                    var v2 = 4 * d3;
                    if (this._circleAndRectCollide(l2.x, l2.y, l2.radius, f3[v2 + 0], f3[v2 + 1], f3[v2 + 2], f3[v2 + 3]) && (!s2 || s2(this.boxKeys[d3])))
                      return a2.push(true), true;
                  }
                }
              var g3 = this.circleCells[i2];
              if (null !== g3)
                for (var y2 = this.circles, m3 = 0, x2 = g3; m3 < x2.length; m3 += 1) {
                  var b2 = x2[m3];
                  if (!u2.circle[b2]) {
                    u2.circle[b2] = true;
                    var _2 = 3 * b2;
                    if (this._circlesCollide(y2[_2], y2[_2 + 1], y2[_2 + 2], l2.x, l2.y, l2.radius) && (!s2 || s2(this.circleKeys[b2])))
                      return a2.push(true), true;
                  }
                }
            }, Qt.prototype._forEachCell = function(t5, e4, r4, n4, i2, a2, o2, s2) {
              for (var l2 = this._convertToXCellCoord(t5), u2 = this._convertToYCellCoord(e4), c2 = this._convertToXCellCoord(r4), f3 = this._convertToYCellCoord(n4), h2 = l2; h2 <= c2; h2++)
                for (var p3 = u2; p3 <= f3; p3++) {
                  var d3 = this.xCellCount * p3 + h2;
                  if (i2.call(this, t5, e4, r4, n4, d3, a2, o2, s2))
                    return;
                }
            }, Qt.prototype._convertToXCellCoord = function(t5) {
              return Math.max(0, Math.min(this.xCellCount - 1, Math.floor(t5 * this.xScale)));
            }, Qt.prototype._convertToYCellCoord = function(t5) {
              return Math.max(0, Math.min(this.yCellCount - 1, Math.floor(t5 * this.yScale)));
            }, Qt.prototype._circlesCollide = function(t5, e4, r4, n4, i2, a2) {
              var o2 = n4 - t5, s2 = i2 - e4, l2 = r4 + a2;
              return l2 * l2 > o2 * o2 + s2 * s2;
            }, Qt.prototype._circleAndRectCollide = function(t5, e4, r4, n4, i2, a2, o2) {
              var s2 = (a2 - n4) / 2, l2 = Math.abs(t5 - (n4 + s2));
              if (l2 > s2 + r4)
                return false;
              var u2 = (o2 - i2) / 2, c2 = Math.abs(e4 - (i2 + u2));
              if (c2 > u2 + r4)
                return false;
              if (l2 <= s2 || c2 <= u2)
                return true;
              var f3 = l2 - s2, h2 = c2 - u2;
              return f3 * f3 + h2 * h2 <= r4 * r4;
            };
            var fe = new Float32Array([-1 / 0, -1 / 0, 0, -1 / 0, -1 / 0, 0, -1 / 0, -1 / 0, 0, -1 / 0, -1 / 0, 0]);
            function he(t5, e4) {
              for (var r4 = 0; r4 < t5; r4++) {
                var n4 = e4.length;
                e4.resize(n4 + 4), e4.float32.set(fe, 3 * n4);
              }
            }
            function pe(t5, e4, r4) {
              var n4 = e4[0], i2 = e4[1];
              return t5[0] = r4[0] * n4 + r4[4] * i2 + r4[12], t5[1] = r4[1] * n4 + r4[5] * i2 + r4[13], t5[3] = r4[3] * n4 + r4[7] * i2 + r4[15], t5;
            }
            var de = 100, ve = function(t5, e4, r4) {
              void 0 === e4 && (e4 = new Qt(t5.width + 200, t5.height + 200, 25)), void 0 === r4 && (r4 = new Qt(t5.width + 200, t5.height + 200, 25)), this.transform = t5, this.grid = e4, this.ignoredGrid = r4, this.pitchfactor = Math.cos(t5._pitch) * t5.cameraToCenterDistance, this.screenRightBoundary = t5.width + de, this.screenBottomBoundary = t5.height + de, this.gridRightBoundary = t5.width + 200, this.gridBottomBoundary = t5.height + 200;
            };
            function ge(e4, r4, n4) {
              return r4 * (t4.EXTENT / (e4.tileSize * Math.pow(2, n4 - e4.tileID.overscaledZ)));
            }
            ve.prototype.placeCollisionBox = function(t5, e4, r4, n4, i2) {
              var a2 = this.projectAndGetPerspectiveRatio(n4, t5.anchorPointX, t5.anchorPointY), o2 = r4 * a2.perspectiveRatio, s2 = t5.x1 * o2 + a2.point.x, l2 = t5.y1 * o2 + a2.point.y, u2 = t5.x2 * o2 + a2.point.x, c2 = t5.y2 * o2 + a2.point.y;
              return !this.isInsideGrid(s2, l2, u2, c2) || !e4 && this.grid.hitTest(s2, l2, u2, c2, i2) ? { box: [], offscreen: false } : { box: [s2, l2, u2, c2], offscreen: this.isOffscreen(s2, l2, u2, c2) };
            }, ve.prototype.placeCollisionCircles = function(e4, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3) {
              var d3 = [], v2 = new t4.Point(r4.anchorX, r4.anchorY), g3 = re(v2, o2), y2 = ne(this.transform.cameraToCenterDistance, g3.signedDistanceFromCamera), m3 = (c2 ? a2 / y2 : a2 * y2) / t4.ONE_EM, x2 = re(v2, s2).point, b2 = oe(m3, i2, r4.lineOffsetX * m3, r4.lineOffsetY * m3, false, x2, v2, r4, n4, s2, {}), _2 = false, w3 = false, T2 = true;
              if (b2) {
                for (var k2 = 0.5 * h2 * y2 + p3, A2 = new t4.Point(-100, -100), M2 = new t4.Point(this.screenRightBoundary, this.screenBottomBoundary), S2 = new $t(), E2 = b2.first, L2 = b2.last, C2 = [], P2 = E2.path.length - 1; P2 >= 1; P2--)
                  C2.push(E2.path[P2]);
                for (var O2 = 1; O2 < L2.path.length; O2++)
                  C2.push(L2.path[O2]);
                var I2 = 2.5 * k2;
                if (l2) {
                  var D2 = C2.map(function(t5) {
                    return re(t5, l2);
                  });
                  C2 = D2.some(function(t5) {
                    return t5.signedDistanceFromCamera <= 0;
                  }) ? [] : D2.map(function(t5) {
                    return t5.point;
                  });
                }
                var z2 = [];
                if (C2.length > 0) {
                  for (var R2 = C2[0].clone(), F2 = C2[0].clone(), B2 = 1; B2 < C2.length; B2++)
                    R2.x = Math.min(R2.x, C2[B2].x), R2.y = Math.min(R2.y, C2[B2].y), F2.x = Math.max(F2.x, C2[B2].x), F2.y = Math.max(F2.y, C2[B2].y);
                  z2 = R2.x >= A2.x && F2.x <= M2.x && R2.y >= A2.y && F2.y <= M2.y ? [C2] : F2.x < A2.x || R2.x > M2.x || F2.y < A2.y || R2.y > M2.y ? [] : t4.clipLine([C2], A2.x, A2.y, M2.x, M2.y);
                }
                for (var N2 = 0, j2 = z2; N2 < j2.length; N2 += 1) {
                  var U2 = j2[N2];
                  S2.reset(U2, 0.25 * k2);
                  var V2;
                  V2 = S2.length <= 0.5 * k2 ? 1 : Math.ceil(S2.paddedLength / I2) + 1;
                  for (var H2 = 0; H2 < V2; H2++) {
                    var q3 = H2 / Math.max(V2 - 1, 1), G2 = S2.lerp(q3), Z2 = G2.x + de, Y2 = G2.y + de;
                    d3.push(Z2, Y2, k2, 0);
                    var W2 = Z2 - k2, X2 = Y2 - k2, J2 = Z2 + k2, K2 = Y2 + k2;
                    if (T2 = T2 && this.isOffscreen(W2, X2, J2, K2), w3 = w3 || this.isInsideGrid(W2, X2, J2, K2), !e4 && this.grid.hitTestCircle(Z2, Y2, k2, f3) && (_2 = true, !u2))
                      return { circles: [], offscreen: false, collisionDetected: _2 };
                  }
                }
              }
              return { circles: !u2 && _2 || !w3 ? [] : d3, offscreen: T2, collisionDetected: _2 };
            }, ve.prototype.queryRenderedSymbols = function(e4) {
              if (0 === e4.length || 0 === this.grid.keysLength() && 0 === this.ignoredGrid.keysLength())
                return {};
              for (var r4 = [], n4 = 1 / 0, i2 = 1 / 0, a2 = -1 / 0, o2 = -1 / 0, s2 = 0, l2 = e4; s2 < l2.length; s2 += 1) {
                var u2 = l2[s2], c2 = new t4.Point(u2.x + de, u2.y + de);
                n4 = Math.min(n4, c2.x), i2 = Math.min(i2, c2.y), a2 = Math.max(a2, c2.x), o2 = Math.max(o2, c2.y), r4.push(c2);
              }
              for (var f3 = {}, h2 = {}, p3 = 0, d3 = this.grid.query(n4, i2, a2, o2).concat(this.ignoredGrid.query(n4, i2, a2, o2)); p3 < d3.length; p3 += 1) {
                var v2 = d3[p3], g3 = v2.key;
                if (void 0 === f3[g3.bucketInstanceId] && (f3[g3.bucketInstanceId] = {}), !f3[g3.bucketInstanceId][g3.featureIndex]) {
                  var y2 = [new t4.Point(v2.x1, v2.y1), new t4.Point(v2.x2, v2.y1), new t4.Point(v2.x2, v2.y2), new t4.Point(v2.x1, v2.y2)];
                  t4.polygonIntersectsPolygon(r4, y2) && (f3[g3.bucketInstanceId][g3.featureIndex] = true, void 0 === h2[g3.bucketInstanceId] && (h2[g3.bucketInstanceId] = []), h2[g3.bucketInstanceId].push(g3.featureIndex));
                }
              }
              return h2;
            }, ve.prototype.insertCollisionBox = function(t5, e4, r4, n4, i2) {
              var a2 = { bucketInstanceId: r4, featureIndex: n4, collisionGroupID: i2 };
              (e4 ? this.ignoredGrid : this.grid).insert(a2, t5[0], t5[1], t5[2], t5[3]);
            }, ve.prototype.insertCollisionCircles = function(t5, e4, r4, n4, i2) {
              for (var a2 = e4 ? this.ignoredGrid : this.grid, o2 = { bucketInstanceId: r4, featureIndex: n4, collisionGroupID: i2 }, s2 = 0; s2 < t5.length; s2 += 4)
                a2.insertCircle(o2, t5[s2], t5[s2 + 1], t5[s2 + 2]);
            }, ve.prototype.projectAndGetPerspectiveRatio = function(e4, r4, n4) {
              var i2 = [r4, n4, 0, 1];
              return pe(i2, i2, e4), { point: new t4.Point((i2[0] / i2[3] + 1) / 2 * this.transform.width + de, (-i2[1] / i2[3] + 1) / 2 * this.transform.height + de), perspectiveRatio: 0.5 + this.transform.cameraToCenterDistance / i2[3] * 0.5 };
            }, ve.prototype.isOffscreen = function(t5, e4, r4, n4) {
              return r4 < de || t5 >= this.screenRightBoundary || n4 < de || e4 > this.screenBottomBoundary;
            }, ve.prototype.isInsideGrid = function(t5, e4, r4, n4) {
              return r4 >= 0 && t5 < this.gridRightBoundary && n4 >= 0 && e4 < this.gridBottomBoundary;
            }, ve.prototype.getViewportMatrix = function() {
              var e4 = t4.identity([]);
              return t4.translate(e4, e4, [-100, -100, 0]), e4;
            };
            var ye = function(t5, e4, r4, n4) {
              this.opacity = t5 ? Math.max(0, Math.min(1, t5.opacity + (t5.placed ? e4 : -e4))) : n4 && r4 ? 1 : 0, this.placed = r4;
            };
            ye.prototype.isHidden = function() {
              return 0 === this.opacity && !this.placed;
            };
            var me = function(t5, e4, r4, n4, i2) {
              this.text = new ye(t5 ? t5.text : null, e4, r4, i2), this.icon = new ye(t5 ? t5.icon : null, e4, n4, i2);
            };
            me.prototype.isHidden = function() {
              return this.text.isHidden() && this.icon.isHidden();
            };
            var xe = function(t5, e4, r4) {
              this.text = t5, this.icon = e4, this.skipFade = r4;
            }, be = function() {
              this.invProjMatrix = t4.create(), this.viewportMatrix = t4.create(), this.circles = [];
            }, _e = function(t5, e4, r4, n4, i2) {
              this.bucketInstanceId = t5, this.featureIndex = e4, this.sourceLayerIndex = r4, this.bucketIndex = n4, this.tileID = i2;
            }, we = function(t5) {
              this.crossSourceCollisions = t5, this.maxGroupID = 0, this.collisionGroups = {};
            };
            function Te(e4, r4, n4, i2, a2) {
              var o2 = t4.getAnchorAlignment(e4), s2 = -(o2.horizontalAlign - 0.5) * r4, l2 = -(o2.verticalAlign - 0.5) * n4, u2 = t4.evaluateVariableOffset(e4, i2);
              return new t4.Point(s2 + u2[0] * a2, l2 + u2[1] * a2);
            }
            function ke(e4, r4, n4, i2, a2, o2) {
              var s2 = e4.x1, l2 = e4.x2, u2 = e4.y1, c2 = e4.y2, f3 = e4.anchorPointX, h2 = e4.anchorPointY, p3 = new t4.Point(r4, n4);
              return i2 && p3._rotate(a2 ? o2 : -o2), { x1: s2 + p3.x, y1: u2 + p3.y, x2: l2 + p3.x, y2: c2 + p3.y, anchorPointX: f3, anchorPointY: h2 };
            }
            we.prototype.get = function(t5) {
              if (this.crossSourceCollisions)
                return { ID: 0, predicate: null };
              if (!this.collisionGroups[t5]) {
                var e4 = ++this.maxGroupID;
                this.collisionGroups[t5] = { ID: e4, predicate: function(t6) {
                  return t6.collisionGroupID === e4;
                } };
              }
              return this.collisionGroups[t5];
            };
            var Ae = function(t5, e4, r4, n4) {
              this.transform = t5.clone(), this.collisionIndex = new ve(this.transform), this.placements = {}, this.opacities = {}, this.variableOffsets = {}, this.stale = false, this.commitTime = 0, this.fadeDuration = e4, this.retainedQueryData = {}, this.collisionGroups = new we(r4), this.collisionCircleArrays = {}, this.prevPlacement = n4, n4 && (n4.prevPlacement = void 0), this.placedOrientations = {};
            };
            function Me(t5, e4, r4, n4, i2) {
              t5.emplaceBack(e4 ? 1 : 0, r4 ? 1 : 0, n4 || 0, i2 || 0), t5.emplaceBack(e4 ? 1 : 0, r4 ? 1 : 0, n4 || 0, i2 || 0), t5.emplaceBack(e4 ? 1 : 0, r4 ? 1 : 0, n4 || 0, i2 || 0), t5.emplaceBack(e4 ? 1 : 0, r4 ? 1 : 0, n4 || 0, i2 || 0);
            }
            Ae.prototype.getBucketParts = function(e4, r4, n4, i2) {
              var a2 = n4.getBucket(r4), o2 = n4.latestFeatureIndex;
              if (a2 && o2 && r4.id === a2.layerIds[0]) {
                var s2 = n4.collisionBoxArray, l2 = a2.layers[0].layout, u2 = Math.pow(2, this.transform.zoom - n4.tileID.overscaledZ), c2 = n4.tileSize / t4.EXTENT, f3 = this.transform.calculatePosMatrix(n4.tileID.toUnwrapped()), h2 = "map" === l2.get("text-pitch-alignment"), p3 = "map" === l2.get("text-rotation-alignment"), d3 = ge(n4, 1, this.transform.zoom), v2 = te(f3, h2, p3, this.transform, d3), g3 = null;
                if (h2) {
                  var y2 = ee(f3, h2, p3, this.transform, d3);
                  g3 = t4.multiply([], this.transform.labelPlaneMatrix, y2);
                }
                this.retainedQueryData[a2.bucketInstanceId] = new _e(a2.bucketInstanceId, o2, a2.sourceLayerIndex, a2.index, n4.tileID);
                var m3 = { bucket: a2, layout: l2, posMatrix: f3, textLabelPlaneMatrix: v2, labelToScreenMatrix: g3, scale: u2, textPixelRatio: c2, holdingForFade: n4.holdingForFade(), collisionBoxArray: s2, partiallyEvaluatedTextSize: t4.evaluateSizeForZoom(a2.textSizeData, this.transform.zoom), collisionGroup: this.collisionGroups.get(a2.sourceID) };
                if (i2)
                  for (var x2 = 0, b2 = a2.sortKeyRanges; x2 < b2.length; x2 += 1) {
                    var _2 = b2[x2], w3 = _2.sortKey, T2 = _2.symbolInstanceStart, k2 = _2.symbolInstanceEnd;
                    e4.push({ sortKey: w3, symbolInstanceStart: T2, symbolInstanceEnd: k2, parameters: m3 });
                  }
                else
                  e4.push({ symbolInstanceStart: 0, symbolInstanceEnd: a2.symbolInstances.length, parameters: m3 });
              }
            }, Ae.prototype.attemptAnchorPlacement = function(t5, e4, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3, d3) {
              var v2, g3 = [f3.textOffset0, f3.textOffset1], y2 = Te(t5, r4, n4, g3, i2), m3 = this.collisionIndex.placeCollisionBox(ke(e4, y2.x, y2.y, a2, o2, this.transform.angle), c2, s2, l2, u2.predicate);
              if (!d3 || 0 !== this.collisionIndex.placeCollisionBox(ke(d3, y2.x, y2.y, a2, o2, this.transform.angle), c2, s2, l2, u2.predicate).box.length)
                return m3.box.length > 0 ? (this.prevPlacement && this.prevPlacement.variableOffsets[f3.crossTileID] && this.prevPlacement.placements[f3.crossTileID] && this.prevPlacement.placements[f3.crossTileID].text && (v2 = this.prevPlacement.variableOffsets[f3.crossTileID].anchor), this.variableOffsets[f3.crossTileID] = { textOffset: g3, width: r4, height: n4, anchor: t5, textBoxScale: i2, prevAnchor: v2 }, this.markUsedJustification(h2, t5, f3, p3), h2.allowVerticalPlacement && (this.markUsedOrientation(h2, p3, f3), this.placedOrientations[f3.crossTileID] = p3), { shift: y2, placedGlyphBoxes: m3 }) : void 0;
            }, Ae.prototype.placeLayerBucketPart = function(e4, r4, n4) {
              var i2 = this, a2 = e4.parameters, o2 = a2.bucket, s2 = a2.layout, l2 = a2.posMatrix, u2 = a2.textLabelPlaneMatrix, c2 = a2.labelToScreenMatrix, f3 = a2.textPixelRatio, h2 = a2.holdingForFade, p3 = a2.collisionBoxArray, d3 = a2.partiallyEvaluatedTextSize, v2 = a2.collisionGroup, g3 = s2.get("text-optional"), y2 = s2.get("icon-optional"), m3 = s2.get("text-allow-overlap"), x2 = s2.get("icon-allow-overlap"), b2 = "map" === s2.get("text-rotation-alignment"), _2 = "map" === s2.get("text-pitch-alignment"), w3 = "none" !== s2.get("icon-text-fit"), T2 = "viewport-y" === s2.get("symbol-z-order"), k2 = m3 && (x2 || !o2.hasIconData() || y2), A2 = x2 && (m3 || !o2.hasTextData() || g3);
              !o2.collisionArrays && p3 && o2.deserializeCollisionBoxes(p3);
              var M2 = function(e5, a3) {
                if (!r4[e5.crossTileID])
                  if (h2)
                    i2.placements[e5.crossTileID] = new xe(false, false, false);
                  else {
                    var p4, T3 = false, M3 = false, S3 = true, E3 = null, L3 = { box: null, offscreen: null }, C3 = { box: null, offscreen: null }, P3 = null, O2 = null, I2 = 0, D2 = 0, z2 = 0;
                    a3.textFeatureIndex ? I2 = a3.textFeatureIndex : e5.useRuntimeCollisionCircles && (I2 = e5.featureIndex), a3.verticalTextFeatureIndex && (D2 = a3.verticalTextFeatureIndex);
                    var R2 = a3.textBox;
                    if (R2) {
                      var F2 = function(r5) {
                        var n5 = t4.WritingMode.horizontal;
                        if (o2.allowVerticalPlacement && !r5 && i2.prevPlacement) {
                          var a4 = i2.prevPlacement.placedOrientations[e5.crossTileID];
                          a4 && (i2.placedOrientations[e5.crossTileID] = a4, n5 = a4, i2.markUsedOrientation(o2, n5, e5));
                        }
                        return n5;
                      }, B2 = function(r5, n5) {
                        if (o2.allowVerticalPlacement && e5.numVerticalGlyphVertices > 0 && a3.verticalTextBox)
                          for (var i3 = 0, s3 = o2.writingModes; i3 < s3.length && (s3[i3] === t4.WritingMode.vertical ? (L3 = n5(), C3 = L3) : L3 = r5(), !(L3 && L3.box && L3.box.length)); i3 += 1)
                            ;
                        else
                          L3 = r5();
                      };
                      if (s2.get("text-variable-anchor")) {
                        var N2 = s2.get("text-variable-anchor");
                        if (i2.prevPlacement && i2.prevPlacement.variableOffsets[e5.crossTileID]) {
                          var j2 = i2.prevPlacement.variableOffsets[e5.crossTileID];
                          N2.indexOf(j2.anchor) > 0 && (N2 = N2.filter(function(t5) {
                            return t5 !== j2.anchor;
                          })).unshift(j2.anchor);
                        }
                        var U2 = function(t5, r5, n5) {
                          for (var a4 = t5.x2 - t5.x1, s3 = t5.y2 - t5.y1, u3 = e5.textBoxScale, c3 = w3 && !x2 ? r5 : null, h3 = { box: [], offscreen: false }, p5 = m3 ? 2 * N2.length : N2.length, d4 = 0; d4 < p5; ++d4) {
                            var g4 = N2[d4 % N2.length], y3 = d4 >= N2.length, k3 = i2.attemptAnchorPlacement(g4, t5, a4, s3, u3, b2, _2, f3, l2, v2, y3, e5, o2, n5, c3);
                            if (k3 && (h3 = k3.placedGlyphBoxes) && h3.box && h3.box.length) {
                              T3 = true, E3 = k3.shift;
                              break;
                            }
                          }
                          return h3;
                        };
                        B2(function() {
                          return U2(R2, a3.iconBox, t4.WritingMode.horizontal);
                        }, function() {
                          var r5 = a3.verticalTextBox, n5 = L3 && L3.box && L3.box.length;
                          return o2.allowVerticalPlacement && !n5 && e5.numVerticalGlyphVertices > 0 && r5 ? U2(r5, a3.verticalIconBox, t4.WritingMode.vertical) : { box: null, offscreen: null };
                        }), L3 && (T3 = L3.box, S3 = L3.offscreen);
                        var V2 = F2(L3 && L3.box);
                        if (!T3 && i2.prevPlacement) {
                          var H2 = i2.prevPlacement.variableOffsets[e5.crossTileID];
                          H2 && (i2.variableOffsets[e5.crossTileID] = H2, i2.markUsedJustification(o2, H2.anchor, e5, V2));
                        }
                      } else {
                        var q3 = function(t5, r5) {
                          var n5 = i2.collisionIndex.placeCollisionBox(t5, m3, f3, l2, v2.predicate);
                          return n5 && n5.box && n5.box.length && (i2.markUsedOrientation(o2, r5, e5), i2.placedOrientations[e5.crossTileID] = r5), n5;
                        };
                        B2(function() {
                          return q3(R2, t4.WritingMode.horizontal);
                        }, function() {
                          var r5 = a3.verticalTextBox;
                          return o2.allowVerticalPlacement && e5.numVerticalGlyphVertices > 0 && r5 ? q3(r5, t4.WritingMode.vertical) : { box: null, offscreen: null };
                        }), F2(L3 && L3.box && L3.box.length);
                      }
                    }
                    if (T3 = (p4 = L3) && p4.box && p4.box.length > 0, S3 = p4 && p4.offscreen, e5.useRuntimeCollisionCircles) {
                      var G2 = o2.text.placedSymbolArray.get(e5.centerJustifiedTextSymbolIndex), Z2 = t4.evaluateSizeForFeature(o2.textSizeData, d3, G2), Y2 = s2.get("text-padding"), W2 = e5.collisionCircleDiameter;
                      P3 = i2.collisionIndex.placeCollisionCircles(m3, G2, o2.lineVertexArray, o2.glyphOffsetArray, Z2, l2, u2, c2, n4, _2, v2.predicate, W2, Y2), T3 = m3 || P3.circles.length > 0 && !P3.collisionDetected, S3 = S3 && P3.offscreen;
                    }
                    if (a3.iconFeatureIndex && (z2 = a3.iconFeatureIndex), a3.iconBox) {
                      var X2 = function(t5) {
                        var e6 = w3 && E3 ? ke(t5, E3.x, E3.y, b2, _2, i2.transform.angle) : t5;
                        return i2.collisionIndex.placeCollisionBox(e6, x2, f3, l2, v2.predicate);
                      };
                      M3 = C3 && C3.box && C3.box.length && a3.verticalIconBox ? (O2 = X2(a3.verticalIconBox)).box.length > 0 : (O2 = X2(a3.iconBox)).box.length > 0, S3 = S3 && O2.offscreen;
                    }
                    var J2 = g3 || 0 === e5.numHorizontalGlyphVertices && 0 === e5.numVerticalGlyphVertices, K2 = y2 || 0 === e5.numIconVertices;
                    if (J2 || K2 ? K2 ? J2 || (M3 = M3 && T3) : T3 = M3 && T3 : M3 = T3 = M3 && T3, T3 && p4 && p4.box && (C3 && C3.box && D2 ? i2.collisionIndex.insertCollisionBox(p4.box, s2.get("text-ignore-placement"), o2.bucketInstanceId, D2, v2.ID) : i2.collisionIndex.insertCollisionBox(p4.box, s2.get("text-ignore-placement"), o2.bucketInstanceId, I2, v2.ID)), M3 && O2 && i2.collisionIndex.insertCollisionBox(O2.box, s2.get("icon-ignore-placement"), o2.bucketInstanceId, z2, v2.ID), P3 && (T3 && i2.collisionIndex.insertCollisionCircles(P3.circles, s2.get("text-ignore-placement"), o2.bucketInstanceId, I2, v2.ID), n4)) {
                      var $2 = o2.bucketInstanceId, Q2 = i2.collisionCircleArrays[$2];
                      void 0 === Q2 && (Q2 = i2.collisionCircleArrays[$2] = new be());
                      for (var tt2 = 0; tt2 < P3.circles.length; tt2 += 4)
                        Q2.circles.push(P3.circles[tt2 + 0]), Q2.circles.push(P3.circles[tt2 + 1]), Q2.circles.push(P3.circles[tt2 + 2]), Q2.circles.push(P3.collisionDetected ? 1 : 0);
                    }
                    i2.placements[e5.crossTileID] = new xe(T3 || k2, M3 || A2, S3 || o2.justReloaded), r4[e5.crossTileID] = true;
                  }
              };
              if (T2)
                for (var S2 = o2.getSortedSymbolIndexes(this.transform.angle), E2 = S2.length - 1; E2 >= 0; --E2) {
                  var L2 = S2[E2];
                  M2(o2.symbolInstances.get(L2), o2.collisionArrays[L2]);
                }
              else
                for (var C2 = e4.symbolInstanceStart; C2 < e4.symbolInstanceEnd; C2++)
                  M2(o2.symbolInstances.get(C2), o2.collisionArrays[C2]);
              if (n4 && o2.bucketInstanceId in this.collisionCircleArrays) {
                var P2 = this.collisionCircleArrays[o2.bucketInstanceId];
                t4.invert(P2.invProjMatrix, l2), P2.viewportMatrix = this.collisionIndex.getViewportMatrix();
              }
              o2.justReloaded = false;
            }, Ae.prototype.markUsedJustification = function(e4, r4, n4, i2) {
              var a2, o2 = { left: n4.leftJustifiedTextSymbolIndex, center: n4.centerJustifiedTextSymbolIndex, right: n4.rightJustifiedTextSymbolIndex };
              a2 = i2 === t4.WritingMode.vertical ? n4.verticalPlacedTextSymbolIndex : o2[t4.getAnchorJustification(r4)];
              for (var s2 = 0, l2 = [n4.leftJustifiedTextSymbolIndex, n4.centerJustifiedTextSymbolIndex, n4.rightJustifiedTextSymbolIndex, n4.verticalPlacedTextSymbolIndex]; s2 < l2.length; s2 += 1) {
                var u2 = l2[s2];
                u2 >= 0 && (e4.text.placedSymbolArray.get(u2).crossTileID = a2 >= 0 && u2 !== a2 ? 0 : n4.crossTileID);
              }
            }, Ae.prototype.markUsedOrientation = function(e4, r4, n4) {
              for (var i2 = r4 === t4.WritingMode.horizontal || r4 === t4.WritingMode.horizontalOnly ? r4 : 0, a2 = r4 === t4.WritingMode.vertical ? r4 : 0, o2 = 0, s2 = [n4.leftJustifiedTextSymbolIndex, n4.centerJustifiedTextSymbolIndex, n4.rightJustifiedTextSymbolIndex]; o2 < s2.length; o2 += 1) {
                var l2 = s2[o2];
                e4.text.placedSymbolArray.get(l2).placedOrientation = i2;
              }
              n4.verticalPlacedTextSymbolIndex && (e4.text.placedSymbolArray.get(n4.verticalPlacedTextSymbolIndex).placedOrientation = a2);
            }, Ae.prototype.commit = function(t5) {
              this.commitTime = t5, this.zoomAtLastRecencyCheck = this.transform.zoom;
              var e4 = this.prevPlacement, r4 = false;
              this.prevZoomAdjustment = e4 ? e4.zoomAdjustment(this.transform.zoom) : 0;
              var n4 = e4 ? e4.symbolFadeChange(t5) : 1, i2 = e4 ? e4.opacities : {}, a2 = e4 ? e4.variableOffsets : {}, o2 = e4 ? e4.placedOrientations : {};
              for (var s2 in this.placements) {
                var l2 = this.placements[s2], u2 = i2[s2];
                u2 ? (this.opacities[s2] = new me(u2, n4, l2.text, l2.icon), r4 = r4 || l2.text !== u2.text.placed || l2.icon !== u2.icon.placed) : (this.opacities[s2] = new me(null, n4, l2.text, l2.icon, l2.skipFade), r4 = r4 || l2.text || l2.icon);
              }
              for (var c2 in i2) {
                var f3 = i2[c2];
                if (!this.opacities[c2]) {
                  var h2 = new me(f3, n4, false, false);
                  h2.isHidden() || (this.opacities[c2] = h2, r4 = r4 || f3.text.placed || f3.icon.placed);
                }
              }
              for (var p3 in a2)
                this.variableOffsets[p3] || !this.opacities[p3] || this.opacities[p3].isHidden() || (this.variableOffsets[p3] = a2[p3]);
              for (var d3 in o2)
                this.placedOrientations[d3] || !this.opacities[d3] || this.opacities[d3].isHidden() || (this.placedOrientations[d3] = o2[d3]);
              r4 ? this.lastPlacementChangeTime = t5 : "number" != typeof this.lastPlacementChangeTime && (this.lastPlacementChangeTime = e4 ? e4.lastPlacementChangeTime : t5);
            }, Ae.prototype.updateLayerOpacities = function(t5, e4) {
              for (var r4 = {}, n4 = 0, i2 = e4; n4 < i2.length; n4 += 1) {
                var a2 = i2[n4], o2 = a2.getBucket(t5);
                o2 && a2.latestFeatureIndex && t5.id === o2.layerIds[0] && this.updateBucketOpacities(o2, r4, a2.collisionBoxArray);
              }
            }, Ae.prototype.updateBucketOpacities = function(e4, r4, n4) {
              var i2 = this;
              e4.hasTextData() && e4.text.opacityVertexArray.clear(), e4.hasIconData() && e4.icon.opacityVertexArray.clear(), e4.hasIconCollisionBoxData() && e4.iconCollisionBox.collisionVertexArray.clear(), e4.hasTextCollisionBoxData() && e4.textCollisionBox.collisionVertexArray.clear();
              var a2 = e4.layers[0].layout, o2 = new me(null, 0, false, false, true), s2 = a2.get("text-allow-overlap"), l2 = a2.get("icon-allow-overlap"), u2 = a2.get("text-variable-anchor"), c2 = "map" === a2.get("text-rotation-alignment"), f3 = "map" === a2.get("text-pitch-alignment"), h2 = "none" !== a2.get("icon-text-fit"), p3 = new me(null, 0, s2 && (l2 || !e4.hasIconData() || a2.get("icon-optional")), l2 && (s2 || !e4.hasTextData() || a2.get("text-optional")), true);
              !e4.collisionArrays && n4 && (e4.hasIconCollisionBoxData() || e4.hasTextCollisionBoxData()) && e4.deserializeCollisionBoxes(n4);
              for (var d3 = function(t5, e5, r5) {
                for (var n5 = 0; n5 < e5 / 4; n5++)
                  t5.opacityVertexArray.emplaceBack(r5);
              }, v2 = function(n5) {
                var a3 = e4.symbolInstances.get(n5), s3 = a3.numHorizontalGlyphVertices, l3 = a3.numVerticalGlyphVertices, v3 = a3.crossTileID, g4 = r4[v3], y3 = i2.opacities[v3];
                g4 ? y3 = o2 : y3 || (y3 = p3, i2.opacities[v3] = y3), r4[v3] = true;
                var m3 = s3 > 0 || l3 > 0, x2 = a3.numIconVertices > 0, b2 = i2.placedOrientations[a3.crossTileID], _2 = b2 === t4.WritingMode.vertical, w3 = b2 === t4.WritingMode.horizontal || b2 === t4.WritingMode.horizontalOnly;
                if (m3) {
                  var T2 = De(y3.text), k2 = _2 ? ze : T2;
                  d3(e4.text, s3, k2);
                  var A2 = w3 ? ze : T2;
                  d3(e4.text, l3, A2);
                  var M2 = y3.text.isHidden();
                  [a3.rightJustifiedTextSymbolIndex, a3.centerJustifiedTextSymbolIndex, a3.leftJustifiedTextSymbolIndex].forEach(function(t5) {
                    t5 >= 0 && (e4.text.placedSymbolArray.get(t5).hidden = M2 || _2 ? 1 : 0);
                  }), a3.verticalPlacedTextSymbolIndex >= 0 && (e4.text.placedSymbolArray.get(a3.verticalPlacedTextSymbolIndex).hidden = M2 || w3 ? 1 : 0);
                  var S2 = i2.variableOffsets[a3.crossTileID];
                  S2 && i2.markUsedJustification(e4, S2.anchor, a3, b2);
                  var E2 = i2.placedOrientations[a3.crossTileID];
                  E2 && (i2.markUsedJustification(e4, "left", a3, E2), i2.markUsedOrientation(e4, E2, a3));
                }
                if (x2) {
                  var L2 = De(y3.icon), C2 = !(h2 && a3.verticalPlacedIconSymbolIndex && _2);
                  if (a3.placedIconSymbolIndex >= 0) {
                    var P2 = C2 ? L2 : ze;
                    d3(e4.icon, a3.numIconVertices, P2), e4.icon.placedSymbolArray.get(a3.placedIconSymbolIndex).hidden = y3.icon.isHidden();
                  }
                  if (a3.verticalPlacedIconSymbolIndex >= 0) {
                    var O2 = C2 ? ze : L2;
                    d3(e4.icon, a3.numVerticalIconVertices, O2), e4.icon.placedSymbolArray.get(a3.verticalPlacedIconSymbolIndex).hidden = y3.icon.isHidden();
                  }
                }
                if (e4.hasIconCollisionBoxData() || e4.hasTextCollisionBoxData()) {
                  var I2 = e4.collisionArrays[n5];
                  if (I2) {
                    var D2 = new t4.Point(0, 0);
                    if (I2.textBox || I2.verticalTextBox) {
                      var z2 = true;
                      if (u2) {
                        var R2 = i2.variableOffsets[v3];
                        R2 ? (D2 = Te(R2.anchor, R2.width, R2.height, R2.textOffset, R2.textBoxScale), c2 && D2._rotate(f3 ? i2.transform.angle : -i2.transform.angle)) : z2 = false;
                      }
                      I2.textBox && Me(e4.textCollisionBox.collisionVertexArray, y3.text.placed, !z2 || _2, D2.x, D2.y), I2.verticalTextBox && Me(e4.textCollisionBox.collisionVertexArray, y3.text.placed, !z2 || w3, D2.x, D2.y);
                    }
                    var F2 = Boolean(!w3 && I2.verticalIconBox);
                    I2.iconBox && Me(e4.iconCollisionBox.collisionVertexArray, y3.icon.placed, F2, h2 ? D2.x : 0, h2 ? D2.y : 0), I2.verticalIconBox && Me(e4.iconCollisionBox.collisionVertexArray, y3.icon.placed, !F2, h2 ? D2.x : 0, h2 ? D2.y : 0);
                  }
                }
              }, g3 = 0; g3 < e4.symbolInstances.length; g3++)
                v2(g3);
              if (e4.sortFeatures(this.transform.angle), this.retainedQueryData[e4.bucketInstanceId] && (this.retainedQueryData[e4.bucketInstanceId].featureSortOrder = e4.featureSortOrder), e4.hasTextData() && e4.text.opacityVertexBuffer && e4.text.opacityVertexBuffer.updateData(e4.text.opacityVertexArray), e4.hasIconData() && e4.icon.opacityVertexBuffer && e4.icon.opacityVertexBuffer.updateData(e4.icon.opacityVertexArray), e4.hasIconCollisionBoxData() && e4.iconCollisionBox.collisionVertexBuffer && e4.iconCollisionBox.collisionVertexBuffer.updateData(e4.iconCollisionBox.collisionVertexArray), e4.hasTextCollisionBoxData() && e4.textCollisionBox.collisionVertexBuffer && e4.textCollisionBox.collisionVertexBuffer.updateData(e4.textCollisionBox.collisionVertexArray), e4.bucketInstanceId in this.collisionCircleArrays) {
                var y2 = this.collisionCircleArrays[e4.bucketInstanceId];
                e4.placementInvProjMatrix = y2.invProjMatrix, e4.placementViewportMatrix = y2.viewportMatrix, e4.collisionCircleArray = y2.circles, delete this.collisionCircleArrays[e4.bucketInstanceId];
              }
            }, Ae.prototype.symbolFadeChange = function(t5) {
              return 0 === this.fadeDuration ? 1 : (t5 - this.commitTime) / this.fadeDuration + this.prevZoomAdjustment;
            }, Ae.prototype.zoomAdjustment = function(t5) {
              return Math.max(0, (this.transform.zoom - t5) / 1.5);
            }, Ae.prototype.hasTransitions = function(t5) {
              return this.stale || t5 - this.lastPlacementChangeTime < this.fadeDuration;
            }, Ae.prototype.stillRecent = function(t5, e4) {
              var r4 = this.zoomAtLastRecencyCheck === e4 ? 1 - this.zoomAdjustment(e4) : 1;
              return this.zoomAtLastRecencyCheck = e4, this.commitTime + this.fadeDuration * r4 > t5;
            }, Ae.prototype.setStale = function() {
              this.stale = true;
            };
            var Se = Math.pow(2, 25), Ee = Math.pow(2, 24), Le = Math.pow(2, 17), Ce = Math.pow(2, 16), Pe = Math.pow(2, 9), Oe = Math.pow(2, 8), Ie = Math.pow(2, 1);
            function De(t5) {
              if (0 === t5.opacity && !t5.placed)
                return 0;
              if (1 === t5.opacity && t5.placed)
                return 4294967295;
              var e4 = t5.placed ? 1 : 0, r4 = Math.floor(127 * t5.opacity);
              return r4 * Se + e4 * Ee + r4 * Le + e4 * Ce + r4 * Pe + e4 * Oe + r4 * Ie + e4;
            }
            var ze = 0, Re = function(t5) {
              this._sortAcrossTiles = "viewport-y" !== t5.layout.get("symbol-z-order") && void 0 !== t5.layout.get("symbol-sort-key").constantOr(1), this._currentTileIndex = 0, this._currentPartIndex = 0, this._seenCrossTileIDs = {}, this._bucketParts = [];
            };
            Re.prototype.continuePlacement = function(t5, e4, r4, n4, i2) {
              for (var a2 = this._bucketParts; this._currentTileIndex < t5.length; ) {
                var o2 = t5[this._currentTileIndex];
                if (e4.getBucketParts(a2, n4, o2, this._sortAcrossTiles), this._currentTileIndex++, i2())
                  return true;
              }
              for (this._sortAcrossTiles && (this._sortAcrossTiles = false, a2.sort(function(t6, e5) {
                return t6.sortKey - e5.sortKey;
              })); this._currentPartIndex < a2.length; ) {
                var s2 = a2[this._currentPartIndex];
                if (e4.placeLayerBucketPart(s2, this._seenCrossTileIDs, r4), this._currentPartIndex++, i2())
                  return true;
              }
              return false;
            };
            var Fe = function(t5, e4, r4, n4, i2, a2, o2) {
              this.placement = new Ae(t5, i2, a2, o2), this._currentPlacementIndex = e4.length - 1, this._forceFullPlacement = r4, this._showCollisionBoxes = n4, this._done = false;
            };
            Fe.prototype.isDone = function() {
              return this._done;
            }, Fe.prototype.continuePlacement = function(e4, r4, n4) {
              for (var i2 = this, a2 = t4.browser.now(), o2 = function() {
                var e5 = t4.browser.now() - a2;
                return !i2._forceFullPlacement && e5 > 2;
              }; this._currentPlacementIndex >= 0; ) {
                var s2 = r4[e4[this._currentPlacementIndex]], l2 = this.placement.collisionIndex.transform.zoom;
                if ("symbol" === s2.type && (!s2.minzoom || s2.minzoom <= l2) && (!s2.maxzoom || s2.maxzoom > l2)) {
                  if (this._inProgressLayer || (this._inProgressLayer = new Re(s2)), this._inProgressLayer.continuePlacement(n4[s2.source], this.placement, this._showCollisionBoxes, s2, o2))
                    return;
                  delete this._inProgressLayer;
                }
                this._currentPlacementIndex--;
              }
              this._done = true;
            }, Fe.prototype.commit = function(t5) {
              return this.placement.commit(t5), this.placement;
            };
            var Be = 512 / t4.EXTENT / 2, Ne = function(t5, e4, r4) {
              this.tileID = t5, this.indexedSymbolInstances = {}, this.bucketInstanceId = r4;
              for (var n4 = 0; n4 < e4.length; n4++) {
                var i2 = e4.get(n4), a2 = i2.key;
                this.indexedSymbolInstances[a2] || (this.indexedSymbolInstances[a2] = []), this.indexedSymbolInstances[a2].push({ crossTileID: i2.crossTileID, coord: this.getScaledCoordinates(i2, t5) });
              }
            };
            Ne.prototype.getScaledCoordinates = function(e4, r4) {
              var n4 = r4.canonical.z - this.tileID.canonical.z, i2 = Be / Math.pow(2, n4);
              return { x: Math.floor((r4.canonical.x * t4.EXTENT + e4.anchorX) * i2), y: Math.floor((r4.canonical.y * t4.EXTENT + e4.anchorY) * i2) };
            }, Ne.prototype.findMatches = function(t5, e4, r4) {
              for (var n4 = this.tileID.canonical.z < e4.canonical.z ? 1 : Math.pow(2, this.tileID.canonical.z - e4.canonical.z), i2 = 0; i2 < t5.length; i2++) {
                var a2 = t5.get(i2);
                if (!a2.crossTileID) {
                  var o2 = this.indexedSymbolInstances[a2.key];
                  if (o2)
                    for (var s2 = this.getScaledCoordinates(a2, e4), l2 = 0, u2 = o2; l2 < u2.length; l2 += 1) {
                      var c2 = u2[l2];
                      if (Math.abs(c2.coord.x - s2.x) <= n4 && Math.abs(c2.coord.y - s2.y) <= n4 && !r4[c2.crossTileID]) {
                        r4[c2.crossTileID] = true, a2.crossTileID = c2.crossTileID;
                        break;
                      }
                    }
                }
              }
            };
            var je = function() {
              this.maxCrossTileID = 0;
            };
            je.prototype.generate = function() {
              return ++this.maxCrossTileID;
            };
            var Ue = function() {
              this.indexes = {}, this.usedCrossTileIDs = {}, this.lng = 0;
            };
            Ue.prototype.handleWrapJump = function(t5) {
              var e4 = Math.round((t5 - this.lng) / 360);
              if (0 !== e4)
                for (var r4 in this.indexes) {
                  var n4 = this.indexes[r4], i2 = {};
                  for (var a2 in n4) {
                    var o2 = n4[a2];
                    o2.tileID = o2.tileID.unwrapTo(o2.tileID.wrap + e4), i2[o2.tileID.key] = o2;
                  }
                  this.indexes[r4] = i2;
                }
              this.lng = t5;
            }, Ue.prototype.addBucket = function(t5, e4, r4) {
              if (this.indexes[t5.overscaledZ] && this.indexes[t5.overscaledZ][t5.key]) {
                if (this.indexes[t5.overscaledZ][t5.key].bucketInstanceId === e4.bucketInstanceId)
                  return false;
                this.removeBucketCrossTileIDs(t5.overscaledZ, this.indexes[t5.overscaledZ][t5.key]);
              }
              for (var n4 = 0; n4 < e4.symbolInstances.length; n4++)
                e4.symbolInstances.get(n4).crossTileID = 0;
              this.usedCrossTileIDs[t5.overscaledZ] || (this.usedCrossTileIDs[t5.overscaledZ] = {});
              var i2 = this.usedCrossTileIDs[t5.overscaledZ];
              for (var a2 in this.indexes) {
                var o2 = this.indexes[a2];
                if (Number(a2) > t5.overscaledZ)
                  for (var s2 in o2) {
                    var l2 = o2[s2];
                    l2.tileID.isChildOf(t5) && l2.findMatches(e4.symbolInstances, t5, i2);
                  }
                else {
                  var u2 = o2[t5.scaledTo(Number(a2)).key];
                  u2 && u2.findMatches(e4.symbolInstances, t5, i2);
                }
              }
              for (var c2 = 0; c2 < e4.symbolInstances.length; c2++) {
                var f3 = e4.symbolInstances.get(c2);
                f3.crossTileID || (f3.crossTileID = r4.generate(), i2[f3.crossTileID] = true);
              }
              return void 0 === this.indexes[t5.overscaledZ] && (this.indexes[t5.overscaledZ] = {}), this.indexes[t5.overscaledZ][t5.key] = new Ne(t5, e4.symbolInstances, e4.bucketInstanceId), true;
            }, Ue.prototype.removeBucketCrossTileIDs = function(t5, e4) {
              for (var r4 in e4.indexedSymbolInstances)
                for (var n4 = 0, i2 = e4.indexedSymbolInstances[r4]; n4 < i2.length; n4 += 1) {
                  var a2 = i2[n4];
                  delete this.usedCrossTileIDs[t5][a2.crossTileID];
                }
            }, Ue.prototype.removeStaleBuckets = function(t5) {
              var e4 = false;
              for (var r4 in this.indexes) {
                var n4 = this.indexes[r4];
                for (var i2 in n4)
                  t5[n4[i2].bucketInstanceId] || (this.removeBucketCrossTileIDs(r4, n4[i2]), delete n4[i2], e4 = true);
              }
              return e4;
            };
            var Ve = function() {
              this.layerIndexes = {}, this.crossTileIDs = new je(), this.maxBucketInstanceId = 0, this.bucketsInCurrentPlacement = {};
            };
            Ve.prototype.addLayer = function(t5, e4, r4) {
              var n4 = this.layerIndexes[t5.id];
              void 0 === n4 && (n4 = this.layerIndexes[t5.id] = new Ue());
              var i2 = false, a2 = {};
              n4.handleWrapJump(r4);
              for (var o2 = 0, s2 = e4; o2 < s2.length; o2 += 1) {
                var l2 = s2[o2], u2 = l2.getBucket(t5);
                u2 && t5.id === u2.layerIds[0] && (u2.bucketInstanceId || (u2.bucketInstanceId = ++this.maxBucketInstanceId), n4.addBucket(l2.tileID, u2, this.crossTileIDs) && (i2 = true), a2[u2.bucketInstanceId] = true);
              }
              return n4.removeStaleBuckets(a2) && (i2 = true), i2;
            }, Ve.prototype.pruneUnusedLayers = function(t5) {
              var e4 = {};
              for (var r4 in t5.forEach(function(t6) {
                e4[t6] = true;
              }), this.layerIndexes)
                e4[r4] || delete this.layerIndexes[r4];
            };
            var He = function(e4, r4) {
              return t4.emitValidationErrors(e4, r4 && r4.filter(function(t5) {
                return "source.canvas" !== t5.identifier;
              }));
            }, qe = t4.pick(Ht, ["addLayer", "removeLayer", "setPaintProperty", "setLayoutProperty", "setFilter", "addSource", "removeSource", "setLayerZoomRange", "setLight", "setTransition", "setGeoJSONSourceData"]), Ge = t4.pick(Ht, ["setCenter", "setZoom", "setBearing", "setPitch"]), Ze = function() {
              var e4 = {}, r4 = t4.styleSpec.$version;
              for (var n4 in t4.styleSpec.$root) {
                var i2 = t4.styleSpec.$root[n4];
                if (i2.required) {
                  var a2;
                  null != (a2 = "version" === n4 ? r4 : "array" === i2.type ? [] : {}) && (e4[n4] = a2);
                }
              }
              return e4;
            }(), Ye = function(e4) {
              function r4(n4, i2) {
                var a2 = this;
                void 0 === i2 && (i2 = {}), e4.call(this), this.map = n4, this.dispatcher = new A(jt(), this), this.imageManager = new h(), this.imageManager.setEventedParent(this), this.glyphManager = new x(n4._requestManager, i2.localIdeographFontFamily), this.lineAtlas = new k(256, 512), this.crossTileSymbolIndex = new Ve(), this._layers = {}, this._serializedLayers = {}, this._order = [], this.sourceCaches = {}, this.zoomHistory = new t4.ZoomHistory(), this._loaded = false, this._availableImages = [], this._resetUpdates(), this.dispatcher.broadcast("setReferrer", t4.getReferrer());
                var o2 = this;
                this._rtlTextPluginCallback = r4.registerForPluginStateChange(function(e5) {
                  var r5 = { pluginStatus: e5.pluginStatus, pluginURL: e5.pluginURL };
                  o2.dispatcher.broadcast("syncRTLPluginState", r5, function(e6, r6) {
                    if (t4.triggerPluginCompletionEvent(e6), r6 && r6.every(function(t5) {
                      return t5;
                    }))
                      for (var n5 in o2.sourceCaches)
                        o2.sourceCaches[n5].reload();
                  });
                }), this.on("data", function(t5) {
                  if ("source" === t5.dataType && "metadata" === t5.sourceDataType) {
                    var e5 = a2.sourceCaches[t5.sourceId];
                    if (e5) {
                      var r5 = e5.getSource();
                      if (r5 && r5.vectorLayerIds)
                        for (var n5 in a2._layers) {
                          var i3 = a2._layers[n5];
                          i3.source === r5.id && a2._validateLayer(i3);
                        }
                    }
                  }
                });
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.loadURL = function(e5, r5) {
                var n4 = this;
                void 0 === r5 && (r5 = {}), this.fire(new t4.Event("dataloading", { dataType: "style" }));
                var i2 = "boolean" == typeof r5.validate ? r5.validate : !t4.isMapboxURL(e5);
                e5 = this.map._requestManager.normalizeStyleURL(e5, r5.accessToken);
                var a2 = this.map._requestManager.transformRequest(e5, t4.ResourceType.Style);
                this._request = t4.getJSON(a2, function(e6, r6) {
                  n4._request = null, e6 ? n4.fire(new t4.ErrorEvent(e6)) : r6 && n4._load(r6, i2);
                });
              }, r4.prototype.loadJSON = function(e5, r5) {
                var n4 = this;
                void 0 === r5 && (r5 = {}), this.fire(new t4.Event("dataloading", { dataType: "style" })), this._request = t4.browser.frame(function() {
                  n4._request = null, n4._load(e5, false !== r5.validate);
                });
              }, r4.prototype.loadEmpty = function() {
                this.fire(new t4.Event("dataloading", { dataType: "style" })), this._load(Ze, false);
              }, r4.prototype._load = function(e5, r5) {
                if (!r5 || !He(this, t4.validateStyle(e5))) {
                  for (var n4 in this._loaded = true, this.stylesheet = e5, e5.sources)
                    this.addSource(n4, e5.sources[n4], { validate: false });
                  e5.sprite ? this._loadSprite(e5.sprite) : this.imageManager.setLoaded(true), this.glyphManager.setURL(e5.glyphs);
                  var i2 = Vt(this.stylesheet.layers);
                  this._order = i2.map(function(t5) {
                    return t5.id;
                  }), this._layers = {}, this._serializedLayers = {};
                  for (var a2 = 0, o2 = i2; a2 < o2.length; a2 += 1) {
                    var s2 = o2[a2];
                    (s2 = t4.createStyleLayer(s2)).setEventedParent(this, { layer: { id: s2.id } }), this._layers[s2.id] = s2, this._serializedLayers[s2.id] = s2.serialize();
                  }
                  this.dispatcher.broadcast("setLayers", this._serializeLayers(this._order)), this.light = new T(this.stylesheet.light), this.fire(new t4.Event("data", { dataType: "style" })), this.fire(new t4.Event("style.load"));
                }
              }, r4.prototype._loadSprite = function(e5) {
                var r5 = this;
                this._spriteRequest = function(e6, r6, n4) {
                  var i2, a2, o2, s2 = t4.browser.devicePixelRatio > 1 ? "@2x" : "", l2 = t4.getJSON(r6.transformRequest(r6.normalizeSpriteURL(e6, s2, ".json"), t4.ResourceType.SpriteJSON), function(t5, e7) {
                    l2 = null, o2 || (o2 = t5, i2 = e7, c2());
                  }), u2 = t4.getImage(r6.transformRequest(r6.normalizeSpriteURL(e6, s2, ".png"), t4.ResourceType.SpriteImage), function(t5, e7) {
                    u2 = null, o2 || (o2 = t5, a2 = e7, c2());
                  });
                  function c2() {
                    if (o2)
                      n4(o2);
                    else if (i2 && a2) {
                      var e7 = t4.browser.getImageData(a2), r7 = {};
                      for (var s3 in i2) {
                        var l3 = i2[s3], u3 = l3.width, c3 = l3.height, f3 = l3.x, h2 = l3.y, p3 = l3.sdf, d3 = l3.pixelRatio, v2 = l3.stretchX, g3 = l3.stretchY, y2 = l3.content, m3 = new t4.RGBAImage({ width: u3, height: c3 });
                        t4.RGBAImage.copy(e7, m3, { x: f3, y: h2 }, { x: 0, y: 0 }, { width: u3, height: c3 }), r7[s3] = { data: m3, pixelRatio: d3, sdf: p3, stretchX: v2, stretchY: g3, content: y2 };
                      }
                      n4(null, r7);
                    }
                  }
                  return { cancel: function() {
                    l2 && (l2.cancel(), l2 = null), u2 && (u2.cancel(), u2 = null);
                  } };
                }(e5, this.map._requestManager, function(e6, n4) {
                  if (r5._spriteRequest = null, e6)
                    r5.fire(new t4.ErrorEvent(e6));
                  else if (n4)
                    for (var i2 in n4)
                      r5.imageManager.addImage(i2, n4[i2]);
                  r5.imageManager.setLoaded(true), r5._availableImages = r5.imageManager.listImages(), r5.dispatcher.broadcast("setImages", r5._availableImages), r5.fire(new t4.Event("data", { dataType: "style" }));
                });
              }, r4.prototype._validateLayer = function(e5) {
                var r5 = this.sourceCaches[e5.source];
                if (r5) {
                  var n4 = e5.sourceLayer;
                  if (n4) {
                    var i2 = r5.getSource();
                    ("geojson" === i2.type || i2.vectorLayerIds && -1 === i2.vectorLayerIds.indexOf(n4)) && this.fire(new t4.ErrorEvent(new Error('Source layer "' + n4 + '" does not exist on source "' + i2.id + '" as specified by style layer "' + e5.id + '"')));
                  }
                }
              }, r4.prototype.loaded = function() {
                if (!this._loaded)
                  return false;
                if (Object.keys(this._updatedSources).length)
                  return false;
                for (var t5 in this.sourceCaches)
                  if (!this.sourceCaches[t5].loaded())
                    return false;
                return !!this.imageManager.isLoaded();
              }, r4.prototype._serializeLayers = function(t5) {
                for (var e5 = [], r5 = 0, n4 = t5; r5 < n4.length; r5 += 1) {
                  var i2 = n4[r5], a2 = this._layers[i2];
                  "custom" !== a2.type && e5.push(a2.serialize());
                }
                return e5;
              }, r4.prototype.hasTransitions = function() {
                if (this.light && this.light.hasTransition())
                  return true;
                for (var t5 in this.sourceCaches)
                  if (this.sourceCaches[t5].hasTransition())
                    return true;
                for (var e5 in this._layers)
                  if (this._layers[e5].hasTransition())
                    return true;
                return false;
              }, r4.prototype._checkLoaded = function() {
                if (!this._loaded)
                  throw new Error("Style is not done loading");
              }, r4.prototype.update = function(e5) {
                if (this._loaded) {
                  var r5 = this._changed;
                  if (this._changed) {
                    var n4 = Object.keys(this._updatedLayers), i2 = Object.keys(this._removedLayers);
                    for (var a2 in (n4.length || i2.length) && this._updateWorkerLayers(n4, i2), this._updatedSources) {
                      var o2 = this._updatedSources[a2];
                      "reload" === o2 ? this._reloadSource(a2) : "clear" === o2 && this._clearSource(a2);
                    }
                    for (var s2 in this._updateTilesForChangedImages(), this._updatedPaintProps)
                      this._layers[s2].updateTransitions(e5);
                    this.light.updateTransitions(e5), this._resetUpdates();
                  }
                  for (var l2 in this.sourceCaches)
                    this.sourceCaches[l2].used = false;
                  for (var u2 = 0, c2 = this._order; u2 < c2.length; u2 += 1) {
                    var f3 = c2[u2], h2 = this._layers[f3];
                    h2.recalculate(e5, this._availableImages), !h2.isHidden(e5.zoom) && h2.source && (this.sourceCaches[h2.source].used = true);
                  }
                  this.light.recalculate(e5), this.z = e5.zoom, r5 && this.fire(new t4.Event("data", { dataType: "style" }));
                }
              }, r4.prototype._updateTilesForChangedImages = function() {
                var t5 = Object.keys(this._changedImages);
                if (t5.length) {
                  for (var e5 in this.sourceCaches)
                    this.sourceCaches[e5].reloadTilesForDependencies(["icons", "patterns"], t5);
                  this._changedImages = {};
                }
              }, r4.prototype._updateWorkerLayers = function(t5, e5) {
                this.dispatcher.broadcast("updateLayers", { layers: this._serializeLayers(t5), removedIds: e5 });
              }, r4.prototype._resetUpdates = function() {
                this._changed = false, this._updatedLayers = {}, this._removedLayers = {}, this._updatedSources = {}, this._updatedPaintProps = {}, this._changedImages = {};
              }, r4.prototype.setState = function(e5) {
                var r5 = this;
                if (this._checkLoaded(), He(this, t4.validateStyle(e5)))
                  return false;
                (e5 = t4.clone$1(e5)).layers = Vt(e5.layers);
                var n4 = Kt(this.serialize(), e5).filter(function(t5) {
                  return !(t5.command in Ge);
                });
                if (0 === n4.length)
                  return false;
                var i2 = n4.filter(function(t5) {
                  return !(t5.command in qe);
                });
                if (i2.length > 0)
                  throw new Error("Unimplemented: " + i2.map(function(t5) {
                    return t5.command;
                  }).join(", ") + ".");
                return n4.forEach(function(t5) {
                  "setTransition" !== t5.command && r5[t5.command].apply(r5, t5.args);
                }), this.stylesheet = e5, true;
              }, r4.prototype.addImage = function(e5, r5) {
                if (this.getImage(e5))
                  return this.fire(new t4.ErrorEvent(new Error("An image with this name already exists.")));
                this.imageManager.addImage(e5, r5), this._availableImages = this.imageManager.listImages(), this._changedImages[e5] = true, this._changed = true, this.fire(new t4.Event("data", { dataType: "style" }));
              }, r4.prototype.updateImage = function(t5, e5) {
                this.imageManager.updateImage(t5, e5);
              }, r4.prototype.getImage = function(t5) {
                return this.imageManager.getImage(t5);
              }, r4.prototype.removeImage = function(e5) {
                if (!this.getImage(e5))
                  return this.fire(new t4.ErrorEvent(new Error("No image with this name exists.")));
                this.imageManager.removeImage(e5), this._availableImages = this.imageManager.listImages(), this._changedImages[e5] = true, this._changed = true, this.fire(new t4.Event("data", { dataType: "style" }));
              }, r4.prototype.listImages = function() {
                return this._checkLoaded(), this.imageManager.listImages();
              }, r4.prototype.addSource = function(e5, r5, n4) {
                var i2 = this;
                if (void 0 === n4 && (n4 = {}), this._checkLoaded(), void 0 !== this.sourceCaches[e5])
                  throw new Error("There is already a source with this ID");
                if (!r5.type)
                  throw new Error("The type property must be defined, but the only the following properties were given: " + Object.keys(r5).join(", ") + ".");
                if (!(["vector", "raster", "geojson", "video", "image"].indexOf(r5.type) >= 0 && this._validate(t4.validateStyle.source, "sources." + e5, r5, null, n4))) {
                  this.map && this.map._collectResourceTiming && (r5.collectResourceTiming = true);
                  var a2 = this.sourceCaches[e5] = new Ot(e5, r5, this.dispatcher);
                  a2.style = this, a2.setEventedParent(this, function() {
                    return { isSourceLoaded: i2.loaded(), source: a2.serialize(), sourceId: e5 };
                  }), a2.onAdd(this.map), this._changed = true;
                }
              }, r4.prototype.removeSource = function(e5) {
                if (this._checkLoaded(), void 0 === this.sourceCaches[e5])
                  throw new Error("There is no source with this ID");
                for (var r5 in this._layers)
                  if (this._layers[r5].source === e5)
                    return this.fire(new t4.ErrorEvent(new Error('Source "' + e5 + '" cannot be removed while layer "' + r5 + '" is using it.')));
                var n4 = this.sourceCaches[e5];
                delete this.sourceCaches[e5], delete this._updatedSources[e5], n4.fire(new t4.Event("data", { sourceDataType: "metadata", dataType: "source", sourceId: e5 })), n4.setEventedParent(null), n4.clearTiles(), n4.onRemove && n4.onRemove(this.map), this._changed = true;
              }, r4.prototype.setGeoJSONSourceData = function(t5, e5) {
                this._checkLoaded(), this.sourceCaches[t5].getSource().setData(e5), this._changed = true;
              }, r4.prototype.getSource = function(t5) {
                return this.sourceCaches[t5] && this.sourceCaches[t5].getSource();
              }, r4.prototype.addLayer = function(e5, r5, n4) {
                void 0 === n4 && (n4 = {}), this._checkLoaded();
                var i2 = e5.id;
                if (this.getLayer(i2))
                  this.fire(new t4.ErrorEvent(new Error('Layer with id "' + i2 + '" already exists on this map')));
                else {
                  var a2;
                  if ("custom" === e5.type) {
                    if (He(this, t4.validateCustomStyleLayer(e5)))
                      return;
                    a2 = t4.createStyleLayer(e5);
                  } else {
                    if ("object" == typeof e5.source && (this.addSource(i2, e5.source), e5 = t4.clone$1(e5), e5 = t4.extend(e5, { source: i2 })), this._validate(t4.validateStyle.layer, "layers." + i2, e5, { arrayIndex: -1 }, n4))
                      return;
                    a2 = t4.createStyleLayer(e5), this._validateLayer(a2), a2.setEventedParent(this, { layer: { id: i2 } }), this._serializedLayers[a2.id] = a2.serialize();
                  }
                  var o2 = r5 ? this._order.indexOf(r5) : this._order.length;
                  if (r5 && -1 === o2)
                    this.fire(new t4.ErrorEvent(new Error('Layer with id "' + r5 + '" does not exist on this map.')));
                  else {
                    if (this._order.splice(o2, 0, i2), this._layerOrderChanged = true, this._layers[i2] = a2, this._removedLayers[i2] && a2.source && "custom" !== a2.type) {
                      var s2 = this._removedLayers[i2];
                      delete this._removedLayers[i2], s2.type !== a2.type ? this._updatedSources[a2.source] = "clear" : (this._updatedSources[a2.source] = "reload", this.sourceCaches[a2.source].pause());
                    }
                    this._updateLayer(a2), a2.onAdd && a2.onAdd(this.map);
                  }
                }
              }, r4.prototype.moveLayer = function(e5, r5) {
                if (this._checkLoaded(), this._changed = true, this._layers[e5]) {
                  if (e5 !== r5) {
                    var n4 = this._order.indexOf(e5);
                    this._order.splice(n4, 1);
                    var i2 = r5 ? this._order.indexOf(r5) : this._order.length;
                    r5 && -1 === i2 ? this.fire(new t4.ErrorEvent(new Error('Layer with id "' + r5 + '" does not exist on this map.'))) : (this._order.splice(i2, 0, e5), this._layerOrderChanged = true);
                  }
                } else
                  this.fire(new t4.ErrorEvent(new Error("The layer '" + e5 + "' does not exist in the map's style and cannot be moved.")));
              }, r4.prototype.removeLayer = function(e5) {
                this._checkLoaded();
                var r5 = this._layers[e5];
                if (r5) {
                  r5.setEventedParent(null);
                  var n4 = this._order.indexOf(e5);
                  this._order.splice(n4, 1), this._layerOrderChanged = true, this._changed = true, this._removedLayers[e5] = r5, delete this._layers[e5], delete this._serializedLayers[e5], delete this._updatedLayers[e5], delete this._updatedPaintProps[e5], r5.onRemove && r5.onRemove(this.map);
                } else
                  this.fire(new t4.ErrorEvent(new Error("The layer '" + e5 + "' does not exist in the map's style and cannot be removed.")));
              }, r4.prototype.getLayer = function(t5) {
                return this._layers[t5];
              }, r4.prototype.hasLayer = function(t5) {
                return t5 in this._layers;
              }, r4.prototype.setLayerZoomRange = function(e5, r5, n4) {
                this._checkLoaded();
                var i2 = this.getLayer(e5);
                i2 ? i2.minzoom === r5 && i2.maxzoom === n4 || (null != r5 && (i2.minzoom = r5), null != n4 && (i2.maxzoom = n4), this._updateLayer(i2)) : this.fire(new t4.ErrorEvent(new Error("The layer '" + e5 + "' does not exist in the map's style and cannot have zoom extent.")));
              }, r4.prototype.setFilter = function(e5, r5, n4) {
                void 0 === n4 && (n4 = {}), this._checkLoaded();
                var i2 = this.getLayer(e5);
                if (i2) {
                  if (!t4.deepEqual(i2.filter, r5))
                    return null == r5 ? (i2.filter = void 0, void this._updateLayer(i2)) : void (this._validate(t4.validateStyle.filter, "layers." + i2.id + ".filter", r5, null, n4) || (i2.filter = t4.clone$1(r5), this._updateLayer(i2)));
                } else
                  this.fire(new t4.ErrorEvent(new Error("The layer '" + e5 + "' does not exist in the map's style and cannot be filtered.")));
              }, r4.prototype.getFilter = function(e5) {
                return t4.clone$1(this.getLayer(e5).filter);
              }, r4.prototype.setLayoutProperty = function(e5, r5, n4, i2) {
                void 0 === i2 && (i2 = {}), this._checkLoaded();
                var a2 = this.getLayer(e5);
                a2 ? t4.deepEqual(a2.getLayoutProperty(r5), n4) || (a2.setLayoutProperty(r5, n4, i2), this._updateLayer(a2)) : this.fire(new t4.ErrorEvent(new Error("The layer '" + e5 + "' does not exist in the map's style and cannot be styled.")));
              }, r4.prototype.getLayoutProperty = function(e5, r5) {
                var n4 = this.getLayer(e5);
                if (n4)
                  return n4.getLayoutProperty(r5);
                this.fire(new t4.ErrorEvent(new Error("The layer '" + e5 + "' does not exist in the map's style.")));
              }, r4.prototype.setPaintProperty = function(e5, r5, n4, i2) {
                void 0 === i2 && (i2 = {}), this._checkLoaded();
                var a2 = this.getLayer(e5);
                a2 ? t4.deepEqual(a2.getPaintProperty(r5), n4) || (a2.setPaintProperty(r5, n4, i2) && this._updateLayer(a2), this._changed = true, this._updatedPaintProps[e5] = true) : this.fire(new t4.ErrorEvent(new Error("The layer '" + e5 + "' does not exist in the map's style and cannot be styled.")));
              }, r4.prototype.getPaintProperty = function(t5, e5) {
                return this.getLayer(t5).getPaintProperty(e5);
              }, r4.prototype.setFeatureState = function(e5, r5) {
                this._checkLoaded();
                var n4 = e5.source, i2 = e5.sourceLayer, a2 = this.sourceCaches[n4];
                if (void 0 !== a2) {
                  var o2 = a2.getSource().type;
                  "geojson" === o2 && i2 ? this.fire(new t4.ErrorEvent(new Error("GeoJSON sources cannot have a sourceLayer parameter."))) : "vector" !== o2 || i2 ? (void 0 === e5.id && this.fire(new t4.ErrorEvent(new Error("The feature id parameter must be provided."))), a2.setFeatureState(i2, e5.id, r5)) : this.fire(new t4.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")));
                } else
                  this.fire(new t4.ErrorEvent(new Error("The source '" + n4 + "' does not exist in the map's style.")));
              }, r4.prototype.removeFeatureState = function(e5, r5) {
                this._checkLoaded();
                var n4 = e5.source, i2 = this.sourceCaches[n4];
                if (void 0 !== i2) {
                  var a2 = i2.getSource().type, o2 = "vector" === a2 ? e5.sourceLayer : void 0;
                  "vector" !== a2 || o2 ? r5 && "string" != typeof e5.id && "number" != typeof e5.id ? this.fire(new t4.ErrorEvent(new Error("A feature id is requred to remove its specific state property."))) : i2.removeFeatureState(o2, e5.id, r5) : this.fire(new t4.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")));
                } else
                  this.fire(new t4.ErrorEvent(new Error("The source '" + n4 + "' does not exist in the map's style.")));
              }, r4.prototype.getFeatureState = function(e5) {
                this._checkLoaded();
                var r5 = e5.source, n4 = e5.sourceLayer, i2 = this.sourceCaches[r5];
                if (void 0 !== i2) {
                  if ("vector" !== i2.getSource().type || n4)
                    return void 0 === e5.id && this.fire(new t4.ErrorEvent(new Error("The feature id parameter must be provided."))), i2.getFeatureState(n4, e5.id);
                  this.fire(new t4.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")));
                } else
                  this.fire(new t4.ErrorEvent(new Error("The source '" + r5 + "' does not exist in the map's style.")));
              }, r4.prototype.getTransition = function() {
                return t4.extend({ duration: 300, delay: 0 }, this.stylesheet && this.stylesheet.transition);
              }, r4.prototype.serialize = function() {
                return t4.filterObject({ version: this.stylesheet.version, name: this.stylesheet.name, metadata: this.stylesheet.metadata, light: this.stylesheet.light, center: this.stylesheet.center, zoom: this.stylesheet.zoom, bearing: this.stylesheet.bearing, pitch: this.stylesheet.pitch, sprite: this.stylesheet.sprite, glyphs: this.stylesheet.glyphs, transition: this.stylesheet.transition, sources: t4.mapObject(this.sourceCaches, function(t5) {
                  return t5.serialize();
                }), layers: this._serializeLayers(this._order) }, function(t5) {
                  return void 0 !== t5;
                });
              }, r4.prototype._updateLayer = function(t5) {
                this._updatedLayers[t5.id] = true, t5.source && !this._updatedSources[t5.source] && "raster" !== this.sourceCaches[t5.source].getSource().type && (this._updatedSources[t5.source] = "reload", this.sourceCaches[t5.source].pause()), this._changed = true;
              }, r4.prototype._flattenAndSortRenderedFeatures = function(t5) {
                for (var e5 = this, r5 = function(t6) {
                  return "fill-extrusion" === e5._layers[t6].type;
                }, n4 = {}, i2 = [], a2 = this._order.length - 1; a2 >= 0; a2--) {
                  var o2 = this._order[a2];
                  if (r5(o2)) {
                    n4[o2] = a2;
                    for (var s2 = 0, l2 = t5; s2 < l2.length; s2 += 1) {
                      var u2 = l2[s2][o2];
                      if (u2)
                        for (var c2 = 0, f3 = u2; c2 < f3.length; c2 += 1) {
                          var h2 = f3[c2];
                          i2.push(h2);
                        }
                    }
                  }
                }
                i2.sort(function(t6, e6) {
                  return e6.intersectionZ - t6.intersectionZ;
                });
                for (var p3 = [], d3 = this._order.length - 1; d3 >= 0; d3--) {
                  var v2 = this._order[d3];
                  if (r5(v2))
                    for (var g3 = i2.length - 1; g3 >= 0; g3--) {
                      var y2 = i2[g3].feature;
                      if (n4[y2.layer.id] < d3)
                        break;
                      p3.push(y2), i2.pop();
                    }
                  else
                    for (var m3 = 0, x2 = t5; m3 < x2.length; m3 += 1) {
                      var b2 = x2[m3][v2];
                      if (b2)
                        for (var _2 = 0, w3 = b2; _2 < w3.length; _2 += 1) {
                          var T2 = w3[_2];
                          p3.push(T2.feature);
                        }
                    }
                }
                return p3;
              }, r4.prototype.queryRenderedFeatures = function(e5, r5, n4) {
                r5 && r5.filter && this._validate(t4.validateStyle.filter, "queryRenderedFeatures.filter", r5.filter, null, r5);
                var i2 = {};
                if (r5 && r5.layers) {
                  if (!Array.isArray(r5.layers))
                    return this.fire(new t4.ErrorEvent(new Error("parameters.layers must be an Array."))), [];
                  for (var a2 = 0, o2 = r5.layers; a2 < o2.length; a2 += 1) {
                    var s2 = o2[a2], l2 = this._layers[s2];
                    if (!l2)
                      return this.fire(new t4.ErrorEvent(new Error("The layer '" + s2 + "' does not exist in the map's style and cannot be queried for features."))), [];
                    i2[l2.source] = true;
                  }
                }
                var u2 = [];
                for (var c2 in r5.availableImages = this._availableImages, this.sourceCaches)
                  r5.layers && !i2[c2] || u2.push(B(this.sourceCaches[c2], this._layers, this._serializedLayers, e5, r5, n4));
                return this.placement && u2.push(function(t5, e6, r6, n5, i3, a3, o3) {
                  for (var s3 = {}, l3 = a3.queryRenderedSymbols(n5), u3 = [], c3 = 0, f3 = Object.keys(l3).map(Number); c3 < f3.length; c3 += 1) {
                    var h2 = f3[c3];
                    u3.push(o3[h2]);
                  }
                  u3.sort(N);
                  for (var p3 = function() {
                    var r7 = v2[d3], n6 = r7.featureIndex.lookupSymbolFeatures(l3[r7.bucketInstanceId], e6, r7.bucketIndex, r7.sourceLayerIndex, i3.filter, i3.layers, i3.availableImages, t5);
                    for (var a4 in n6) {
                      var o4 = s3[a4] = s3[a4] || [], u4 = n6[a4];
                      u4.sort(function(t6, e7) {
                        var n7 = r7.featureSortOrder;
                        if (n7) {
                          var i4 = n7.indexOf(t6.featureIndex);
                          return n7.indexOf(e7.featureIndex) - i4;
                        }
                        return e7.featureIndex - t6.featureIndex;
                      });
                      for (var c4 = 0, f4 = u4; c4 < f4.length; c4 += 1) {
                        var h3 = f4[c4];
                        o4.push(h3);
                      }
                    }
                  }, d3 = 0, v2 = u3; d3 < v2.length; d3 += 1)
                    p3();
                  var g3 = function(e7) {
                    s3[e7].forEach(function(n6) {
                      var i4 = n6.feature, a4 = t5[e7], o4 = r6[a4.source].getFeatureState(i4.layer["source-layer"], i4.id);
                      i4.source = i4.layer.source, i4.layer["source-layer"] && (i4.sourceLayer = i4.layer["source-layer"]), i4.state = o4;
                    });
                  };
                  for (var y2 in s3)
                    g3(y2);
                  return s3;
                }(this._layers, this._serializedLayers, this.sourceCaches, e5, r5, this.placement.collisionIndex, this.placement.retainedQueryData)), this._flattenAndSortRenderedFeatures(u2);
              }, r4.prototype.querySourceFeatures = function(e5, r5) {
                r5 && r5.filter && this._validate(t4.validateStyle.filter, "querySourceFeatures.filter", r5.filter, null, r5);
                var n4 = this.sourceCaches[e5];
                return n4 ? function(t5, e6) {
                  for (var r6 = t5.getRenderableIds().map(function(e7) {
                    return t5.getTileByID(e7);
                  }), n5 = [], i2 = {}, a2 = 0; a2 < r6.length; a2++) {
                    var o2 = r6[a2], s2 = o2.tileID.canonical.key;
                    i2[s2] || (i2[s2] = true, o2.querySourceFeatures(n5, e6));
                  }
                  return n5;
                }(n4, r5) : [];
              }, r4.prototype.addSourceType = function(t5, e5, n4) {
                return r4.getSourceType(t5) ? n4(new Error('A source type called "' + t5 + '" already exists.')) : (r4.setSourceType(t5, e5), e5.workerSourceURL ? void this.dispatcher.broadcast("loadWorkerSource", { name: t5, url: e5.workerSourceURL }, n4) : n4(null, null));
              }, r4.prototype.getLight = function() {
                return this.light.getLight();
              }, r4.prototype.setLight = function(e5, r5) {
                void 0 === r5 && (r5 = {}), this._checkLoaded();
                var n4 = this.light.getLight(), i2 = false;
                for (var a2 in e5)
                  if (!t4.deepEqual(e5[a2], n4[a2])) {
                    i2 = true;
                    break;
                  }
                if (i2) {
                  var o2 = { now: t4.browser.now(), transition: t4.extend({ duration: 300, delay: 0 }, this.stylesheet.transition) };
                  this.light.setLight(e5, r5), this.light.updateTransitions(o2);
                }
              }, r4.prototype._validate = function(e5, r5, n4, i2, a2) {
                return void 0 === a2 && (a2 = {}), (!a2 || false !== a2.validate) && He(this, e5.call(t4.validateStyle, t4.extend({ key: r5, style: this.serialize(), value: n4, styleSpec: t4.styleSpec }, i2)));
              }, r4.prototype._remove = function() {
                for (var e5 in this._request && (this._request.cancel(), this._request = null), this._spriteRequest && (this._spriteRequest.cancel(), this._spriteRequest = null), t4.evented.off("pluginStateChange", this._rtlTextPluginCallback), this._layers)
                  this._layers[e5].setEventedParent(null);
                for (var r5 in this.sourceCaches)
                  this.sourceCaches[r5].clearTiles(), this.sourceCaches[r5].setEventedParent(null);
                this.imageManager.setEventedParent(null), this.setEventedParent(null), this.dispatcher.remove();
              }, r4.prototype._clearSource = function(t5) {
                this.sourceCaches[t5].clearTiles();
              }, r4.prototype._reloadSource = function(t5) {
                this.sourceCaches[t5].resume(), this.sourceCaches[t5].reload();
              }, r4.prototype._updateSources = function(t5) {
                for (var e5 in this.sourceCaches)
                  this.sourceCaches[e5].update(t5);
              }, r4.prototype._generateCollisionBoxes = function() {
                for (var t5 in this.sourceCaches)
                  this._reloadSource(t5);
              }, r4.prototype._updatePlacement = function(e5, r5, n4, i2, a2) {
                void 0 === a2 && (a2 = false);
                for (var o2 = false, s2 = false, l2 = {}, u2 = 0, c2 = this._order; u2 < c2.length; u2 += 1) {
                  var f3 = c2[u2], h2 = this._layers[f3];
                  if ("symbol" === h2.type) {
                    if (!l2[h2.source]) {
                      var p3 = this.sourceCaches[h2.source];
                      l2[h2.source] = p3.getRenderableIds(true).map(function(t5) {
                        return p3.getTileByID(t5);
                      }).sort(function(t5, e6) {
                        return e6.tileID.overscaledZ - t5.tileID.overscaledZ || (t5.tileID.isLessThan(e6.tileID) ? -1 : 1);
                      });
                    }
                    var d3 = this.crossTileSymbolIndex.addLayer(h2, l2[h2.source], e5.center.lng);
                    o2 = o2 || d3;
                  }
                }
                if (this.crossTileSymbolIndex.pruneUnusedLayers(this._order), ((a2 = a2 || this._layerOrderChanged || 0 === n4) || !this.pauseablePlacement || this.pauseablePlacement.isDone() && !this.placement.stillRecent(t4.browser.now(), e5.zoom)) && (this.pauseablePlacement = new Fe(e5, this._order, a2, r5, n4, i2, this.placement), this._layerOrderChanged = false), this.pauseablePlacement.isDone() ? this.placement.setStale() : (this.pauseablePlacement.continuePlacement(this._order, this._layers, l2), this.pauseablePlacement.isDone() && (this.placement = this.pauseablePlacement.commit(t4.browser.now()), s2 = true), o2 && this.pauseablePlacement.placement.setStale()), s2 || o2)
                  for (var v2 = 0, g3 = this._order; v2 < g3.length; v2 += 1) {
                    var y2 = g3[v2], m3 = this._layers[y2];
                    "symbol" === m3.type && this.placement.updateLayerOpacities(m3, l2[m3.source]);
                  }
                return !this.pauseablePlacement.isDone() || this.placement.hasTransitions(t4.browser.now());
              }, r4.prototype._releaseSymbolFadeTiles = function() {
                for (var t5 in this.sourceCaches)
                  this.sourceCaches[t5].releaseSymbolFadeTiles();
              }, r4.prototype.getImages = function(t5, e5, r5) {
                this.imageManager.getImages(e5.icons, r5), this._updateTilesForChangedImages();
                var n4 = this.sourceCaches[e5.source];
                n4 && n4.setDependencies(e5.tileID.key, e5.type, e5.icons);
              }, r4.prototype.getGlyphs = function(t5, e5, r5) {
                this.glyphManager.getGlyphs(e5.stacks, r5);
              }, r4.prototype.getResource = function(e5, r5, n4) {
                return t4.makeRequest(r5, n4);
              }, r4;
            }(t4.Evented);
            Ye.getSourceType = function(t5) {
              return R[t5];
            }, Ye.setSourceType = function(t5, e4) {
              R[t5] = e4;
            }, Ye.registerForPluginStateChange = t4.registerForPluginStateChange;
            var We = t4.createLayout([{ name: "a_pos", type: "Int16", components: 2 }]), Xe = _r("#ifdef GL_ES\nprecision mediump float;\n#else\n#if !defined(lowp)\n#define lowp\n#endif\n#if !defined(mediump)\n#define mediump\n#endif\n#if !defined(highp)\n#define highp\n#endif\n#endif", "#ifdef GL_ES\nprecision highp float;\n#else\n#if !defined(lowp)\n#define lowp\n#endif\n#if !defined(mediump)\n#define mediump\n#endif\n#if !defined(highp)\n#define highp\n#endif\n#endif\nvec2 unpack_float(const float packedValue) {int packedIntValue=int(packedValue);int v0=packedIntValue/256;return vec2(v0,packedIntValue-v0*256);}vec2 unpack_opacity(const float packedOpacity) {int intOpacity=int(packedOpacity)/2;return vec2(float(intOpacity)/127.0,mod(packedOpacity,2.0));}vec4 decode_color(const vec2 encodedColor) {return vec4(unpack_float(encodedColor[0])/255.0,unpack_float(encodedColor[1])/255.0\n);}float unpack_mix_vec2(const vec2 packedValue,const float t) {return mix(packedValue[0],packedValue[1],t);}vec4 unpack_mix_color(const vec4 packedColors,const float t) {vec4 minColor=decode_color(vec2(packedColors[0],packedColors[1]));vec4 maxColor=decode_color(vec2(packedColors[2],packedColors[3]));return mix(minColor,maxColor,t);}vec2 get_pattern_pos(const vec2 pixel_coord_upper,const vec2 pixel_coord_lower,const vec2 pattern_size,const float tile_units_to_pixels,const vec2 pos) {vec2 offset=mod(mod(mod(pixel_coord_upper,pattern_size)*256.0,pattern_size)*256.0+pixel_coord_lower,pattern_size);return (tile_units_to_pixels*pos+offset)/pattern_size;}"), Je = _r("uniform vec4 u_color;uniform float u_opacity;void main() {gl_FragColor=u_color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);}"), Ke = _r("uniform vec2 u_pattern_tl_a;uniform vec2 u_pattern_br_a;uniform vec2 u_pattern_tl_b;uniform vec2 u_pattern_br_b;uniform vec2 u_texsize;uniform float u_mix;uniform float u_opacity;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;void main() {vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(u_pattern_tl_a/u_texsize,u_pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(u_pattern_tl_b/u_texsize,u_pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);gl_FragColor=mix(color1,color2,u_mix)*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_pattern_size_a;uniform vec2 u_pattern_size_b;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_scale_a;uniform float u_scale_b;uniform float u_tile_units_to_pixels;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_scale_a*u_pattern_size_a,u_tile_units_to_pixels,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_scale_b*u_pattern_size_b,u_tile_units_to_pixels,a_pos);}"), $e = _r("varying vec3 v_data;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=v_data.xy;float extrude_length=length(extrude);lowp float antialiasblur=v_data.z;float antialiased_blur=-max(blur,antialiasblur);float opacity_t=smoothstep(0.0,antialiased_blur,extrude_length-1.0);float color_t=stroke_width < 0.01 ? 0.0 : smoothstep(antialiased_blur,0.0,extrude_length-radius/(radius+stroke_width));gl_FragColor=opacity_t*mix(color*opacity,stroke_color*stroke_opacity,color_t);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform bool u_scale_with_map;uniform bool u_pitch_with_map;uniform vec2 u_extrude_scale;uniform lowp float u_device_pixel_ratio;uniform highp float u_camera_to_center_distance;attribute vec2 a_pos;varying vec3 v_data;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvoid main(void) {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=vec2(mod(a_pos,2.0)*2.0-1.0);vec2 circle_center=floor(a_pos*0.5);if (u_pitch_with_map) {vec2 corner_position=circle_center;if (u_scale_with_map) {corner_position+=extrude*(radius+stroke_width)*u_extrude_scale;} else {vec4 projected_center=u_matrix*vec4(circle_center,0,1);corner_position+=extrude*(radius+stroke_width)*u_extrude_scale*(projected_center.w/u_camera_to_center_distance);}gl_Position=u_matrix*vec4(corner_position,0,1);} else {gl_Position=u_matrix*vec4(circle_center,0,1);if (u_scale_with_map) {gl_Position.xy+=extrude*(radius+stroke_width)*u_extrude_scale*u_camera_to_center_distance;} else {gl_Position.xy+=extrude*(radius+stroke_width)*u_extrude_scale*gl_Position.w;}}lowp float antialiasblur=1.0/u_device_pixel_ratio/(radius+stroke_width);v_data=vec3(extrude.x,extrude.y,antialiasblur);}"), Qe = _r("void main() {gl_FragColor=vec4(1.0);}", "attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);}"), tr = _r("uniform highp float u_intensity;varying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#define GAUSS_COEF 0.3989422804014327\nvoid main() {\n#pragma mapbox: initialize highp float weight\nfloat d=-0.5*3.0*3.0*dot(v_extrude,v_extrude);float val=weight*u_intensity*GAUSS_COEF*exp(d);gl_FragColor=vec4(val,1.0,1.0,1.0);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform float u_extrude_scale;uniform float u_opacity;uniform float u_intensity;attribute vec2 a_pos;varying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#pragma mapbox: define mediump float radius\nconst highp float ZERO=1.0/255.0/16.0;\n#define GAUSS_COEF 0.3989422804014327\nvoid main(void) {\n#pragma mapbox: initialize highp float weight\n#pragma mapbox: initialize mediump float radius\nvec2 unscaled_extrude=vec2(mod(a_pos,2.0)*2.0-1.0);float S=sqrt(-2.0*log(ZERO/weight/u_intensity/GAUSS_COEF))/3.0;v_extrude=S*unscaled_extrude;vec2 extrude=v_extrude*radius*u_extrude_scale;vec4 pos=vec4(floor(a_pos*0.5)+extrude,0,1);gl_Position=u_matrix*pos;}"), er = _r("uniform sampler2D u_image;uniform sampler2D u_color_ramp;uniform float u_opacity;varying vec2 v_pos;void main() {float t=texture2D(u_image,v_pos).r;vec4 color=texture2D(u_color_ramp,vec2(t,0.5));gl_FragColor=color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(0.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_world;attribute vec2 a_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos*u_world,0,1);v_pos.x=a_pos.x;v_pos.y=1.0-a_pos.y;}"), rr = _r("varying float v_placed;varying float v_notUsed;void main() {float alpha=0.5;gl_FragColor=vec4(1.0,0.0,0.0,1.0)*alpha;if (v_placed > 0.5) {gl_FragColor=vec4(0.0,0.0,1.0,0.5)*alpha;}if (v_notUsed > 0.5) {gl_FragColor*=.1;}}", "attribute vec2 a_pos;attribute vec2 a_anchor_pos;attribute vec2 a_extrude;attribute vec2 a_placed;attribute vec2 a_shift;uniform mat4 u_matrix;uniform vec2 u_extrude_scale;uniform float u_camera_to_center_distance;varying float v_placed;varying float v_notUsed;void main() {vec4 projectedPoint=u_matrix*vec4(a_anchor_pos,0,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float collision_perspective_ratio=clamp(0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,4.0);gl_Position=u_matrix*vec4(a_pos,0.0,1.0);gl_Position.xy+=(a_extrude+a_shift)*u_extrude_scale*gl_Position.w*collision_perspective_ratio;v_placed=a_placed.x;v_notUsed=a_placed.y;}"), nr = _r("varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;void main() {float alpha=0.5*min(v_perspective_ratio,1.0);float stroke_radius=0.9*max(v_perspective_ratio,1.0);float distance_to_center=length(v_extrude);float distance_to_edge=abs(distance_to_center-v_radius);float opacity_t=smoothstep(-stroke_radius,0.0,-distance_to_edge);vec4 color=mix(vec4(0.0,0.0,1.0,0.5),vec4(1.0,0.0,0.0,1.0),v_collision);gl_FragColor=color*alpha*opacity_t;}", "attribute vec2 a_pos;attribute float a_radius;attribute vec2 a_flags;uniform mat4 u_matrix;uniform mat4 u_inv_matrix;uniform vec2 u_viewport_size;uniform float u_camera_to_center_distance;varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;vec3 toTilePosition(vec2 screenPos) {vec4 rayStart=u_inv_matrix*vec4(screenPos,-1.0,1.0);vec4 rayEnd  =u_inv_matrix*vec4(screenPos, 1.0,1.0);rayStart.xyz/=rayStart.w;rayEnd.xyz  /=rayEnd.w;highp float t=(0.0-rayStart.z)/(rayEnd.z-rayStart.z);return mix(rayStart.xyz,rayEnd.xyz,t);}void main() {vec2 quadCenterPos=a_pos;float radius=a_radius;float collision=a_flags.x;float vertexIdx=a_flags.y;vec2 quadVertexOffset=vec2(mix(-1.0,1.0,float(vertexIdx >=2.0)),mix(-1.0,1.0,float(vertexIdx >=1.0 && vertexIdx <=2.0)));vec2 quadVertexExtent=quadVertexOffset*radius;vec3 tilePos=toTilePosition(quadCenterPos);vec4 clipPos=u_matrix*vec4(tilePos,1.0);highp float camera_to_anchor_distance=clipPos.w;highp float collision_perspective_ratio=clamp(0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,4.0);float padding_factor=1.2;v_radius=radius;v_extrude=quadVertexExtent*padding_factor;v_perspective_ratio=collision_perspective_ratio;v_collision=collision;gl_Position=vec4(clipPos.xyz/clipPos.w,1.0)+vec4(quadVertexExtent*padding_factor/u_viewport_size*2.0,0.0,0.0);}"), ir = _r("uniform highp vec4 u_color;uniform sampler2D u_overlay;varying vec2 v_uv;void main() {vec4 overlay_color=texture2D(u_overlay,v_uv);gl_FragColor=mix(u_color,overlay_color,overlay_color.a);}", "attribute vec2 a_pos;varying vec2 v_uv;uniform mat4 u_matrix;uniform float u_overlay_scale;void main() {v_uv=a_pos/8192.0;gl_Position=u_matrix*vec4(a_pos*u_overlay_scale,0,1);}"), ar = _r("#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\ngl_FragColor=color*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "attribute vec2 a_pos;uniform mat4 u_matrix;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);}"), or = _r("varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);gl_FragColor=outline_color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "attribute vec2 a_pos;uniform mat4 u_matrix;uniform vec2 u_world;varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;}"), sr = _r("uniform vec2 u_texsize;uniform sampler2D u_image;uniform float u_fade;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);float dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);gl_FragColor=mix(color1,color2,u_fade)*alpha*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_world;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform vec3 u_scale;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;gl_Position=u_matrix*vec4(a_pos,0,1);vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileRatio,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileRatio,a_pos);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;}"), lr = _r("uniform vec2 u_texsize;uniform float u_fade;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);gl_FragColor=mix(color1,color2,u_fade)*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform vec3 u_scale;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileZoomRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;gl_Position=u_matrix*vec4(a_pos,0,1);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileZoomRatio,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileZoomRatio,a_pos);}"), ur = _r("varying vec4 v_color;void main() {gl_FragColor=v_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;uniform float u_vertical_gradient;uniform lowp float u_opacity;attribute vec2 a_pos;attribute vec4 a_normal_ed;varying vec4 v_color;\n#pragma mapbox: define highp float base\n#pragma mapbox: define highp float height\n#pragma mapbox: define highp vec4 color\nvoid main() {\n#pragma mapbox: initialize highp float base\n#pragma mapbox: initialize highp float height\n#pragma mapbox: initialize highp vec4 color\nvec3 normal=a_normal_ed.xyz;base=max(0.0,base);height=max(0.0,height);float t=mod(normal.x,2.0);gl_Position=u_matrix*vec4(a_pos,t > 0.0 ? height : base,1);float colorvalue=color.r*0.2126+color.g*0.7152+color.b*0.0722;v_color=vec4(0.0,0.0,0.0,1.0);vec4 ambientlight=vec4(0.03,0.03,0.03,1.0);color+=ambientlight;float directional=clamp(dot(normal/16384.0,u_lightpos),0.0,1.0);directional=mix((1.0-u_lightintensity),max((1.0-colorvalue+u_lightintensity),1.0),directional);if (normal.y !=0.0) {directional*=((1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),mix(0.7,0.98,1.0-u_lightintensity),1.0)));}v_color.r+=clamp(color.r*directional*u_lightcolor.r,mix(0.0,0.3,1.0-u_lightcolor.r),1.0);v_color.g+=clamp(color.g*directional*u_lightcolor.g,mix(0.0,0.3,1.0-u_lightcolor.g),1.0);v_color.b+=clamp(color.b*directional*u_lightcolor.b,mix(0.0,0.3,1.0-u_lightcolor.b),1.0);v_color*=u_opacity;}"), cr = _r("uniform vec2 u_texsize;uniform float u_fade;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec4 v_lighting;\n#pragma mapbox: define lowp float base\n#pragma mapbox: define lowp float height\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float base\n#pragma mapbox: initialize lowp float height\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);vec4 mixedColor=mix(color1,color2,u_fade);gl_FragColor=mixedColor*v_lighting;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_height_factor;uniform vec3 u_scale;uniform float u_vertical_gradient;uniform lowp float u_opacity;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;attribute vec2 a_pos;attribute vec4 a_normal_ed;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec4 v_lighting;\n#pragma mapbox: define lowp float base\n#pragma mapbox: define lowp float height\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float base\n#pragma mapbox: initialize lowp float height\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec3 normal=a_normal_ed.xyz;float edgedistance=a_normal_ed.w;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;base=max(0.0,base);height=max(0.0,height);float t=mod(normal.x,2.0);float z=t > 0.0 ? height : base;gl_Position=u_matrix*vec4(a_pos,z,1);vec2 pos=normal.x==1.0 && normal.y==0.0 && normal.z==16384.0\n? a_pos\n: vec2(edgedistance,z*u_height_factor);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileRatio,pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileRatio,pos);v_lighting=vec4(0.0,0.0,0.0,1.0);float directional=clamp(dot(normal/16383.0,u_lightpos),0.0,1.0);directional=mix((1.0-u_lightintensity),max((0.5+u_lightintensity),1.0),directional);if (normal.y !=0.0) {directional*=((1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),mix(0.7,0.98,1.0-u_lightintensity),1.0)));}v_lighting.rgb+=clamp(directional*u_lightcolor,mix(vec3(0.0),vec3(0.3),1.0-u_lightcolor),vec3(1.0));v_lighting*=u_opacity;}"), fr = _r("#ifdef GL_ES\nprecision highp float;\n#endif\nuniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_dimension;uniform float u_zoom;uniform float u_maxzoom;uniform vec4 u_unpack;float getElevation(vec2 coord,float bias) {vec4 data=texture2D(u_image,coord)*255.0;data.a=-1.0;return dot(data,u_unpack)/4.0;}void main() {vec2 epsilon=1.0/u_dimension;float a=getElevation(v_pos+vec2(-epsilon.x,-epsilon.y),0.0);float b=getElevation(v_pos+vec2(0,-epsilon.y),0.0);float c=getElevation(v_pos+vec2(epsilon.x,-epsilon.y),0.0);float d=getElevation(v_pos+vec2(-epsilon.x,0),0.0);float e=getElevation(v_pos,0.0);float f=getElevation(v_pos+vec2(epsilon.x,0),0.0);float g=getElevation(v_pos+vec2(-epsilon.x,epsilon.y),0.0);float h=getElevation(v_pos+vec2(0,epsilon.y),0.0);float i=getElevation(v_pos+vec2(epsilon.x,epsilon.y),0.0);float exaggeration=u_zoom < 2.0 ? 0.4 : u_zoom < 4.5 ? 0.35 : 0.3;vec2 deriv=vec2((c+f+f+i)-(a+d+d+g),(g+h+h+i)-(a+b+b+c))/ pow(2.0,(u_zoom-u_maxzoom)*exaggeration+19.2562-u_zoom);gl_FragColor=clamp(vec4(deriv.x/2.0+0.5,deriv.y/2.0+0.5,1.0,1.0),0.0,1.0);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_dimension;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);highp vec2 epsilon=1.0/u_dimension;float scale=(u_dimension.x-2.0)/u_dimension.x;v_pos=(a_texture_pos/8192.0)*scale+epsilon;}"), hr = _r("uniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_latrange;uniform vec2 u_light;uniform vec4 u_shadow;uniform vec4 u_highlight;uniform vec4 u_accent;\n#define PI 3.141592653589793\nvoid main() {vec4 pixel=texture2D(u_image,v_pos);vec2 deriv=((pixel.rg*2.0)-1.0);float scaleFactor=cos(radians((u_latrange[0]-u_latrange[1])*(1.0-v_pos.y)+u_latrange[1]));float slope=atan(1.25*length(deriv)/scaleFactor);float aspect=deriv.x !=0.0 ? atan(deriv.y,-deriv.x) : PI/2.0*(deriv.y > 0.0 ? 1.0 :-1.0);float intensity=u_light.x;float azimuth=u_light.y+PI;float base=1.875-intensity*1.75;float maxValue=0.5*PI;float scaledSlope=intensity !=0.5 ? ((pow(base,slope)-1.0)/(pow(base,maxValue)-1.0))*maxValue : slope;float accent=cos(scaledSlope);vec4 accent_color=(1.0-accent)*u_accent*clamp(intensity*2.0,0.0,1.0);float shade=abs(mod((aspect+azimuth)/PI+0.5,2.0)-1.0);vec4 shade_color=mix(u_shadow,u_highlight,shade)*sin(scaledSlope)*clamp(intensity*2.0,0.0,1.0);gl_FragColor=accent_color*(1.0-shade_color.a)+shade_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos=a_texture_pos/8192.0;}"), pr = _r("uniform lowp float u_device_pixel_ratio;varying vec2 v_width2;varying vec2 v_normal;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "\n#define scale 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform vec2 u_units_to_pixels;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_gamma_scale;varying highp float v_linesofar;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;v_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*2.0;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;float extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;v_width2=vec2(outset,inset);}"), dr = _r("uniform lowp float u_device_pixel_ratio;uniform sampler2D u_image;varying vec2 v_width2;varying vec2 v_normal;varying float v_gamma_scale;varying highp float v_lineprogress;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);vec4 color=texture2D(u_image,vec2(v_lineprogress,0.5));gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "\n#define MAX_LINE_DISTANCE 32767.0\n#define scale 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;uniform vec2 u_units_to_pixels;varying vec2 v_normal;varying vec2 v_width2;varying float v_gamma_scale;varying highp float v_lineprogress;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;v_lineprogress=(floor(a_data.z/4.0)+a_data.w*64.0)*2.0/MAX_LINE_DISTANCE;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;float extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;v_width2=vec2(outset,inset);}"), vr = _r("uniform lowp float u_device_pixel_ratio;uniform vec2 u_texsize;uniform float u_fade;uniform mediump vec3 u_scale;uniform sampler2D u_image;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileZoomRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;vec2 pattern_size_a=vec2(display_size_a.x*fromScale/tileZoomRatio,display_size_a.y);vec2 pattern_size_b=vec2(display_size_b.x*toScale/tileZoomRatio,display_size_b.y);float aspect_a=display_size_a.y/v_width;float aspect_b=display_size_b.y/v_width;float dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);float x_a=mod(v_linesofar/pattern_size_a.x*aspect_a,1.0);float x_b=mod(v_linesofar/pattern_size_b.x*aspect_b,1.0);float y=0.5*v_normal.y+0.5;vec2 texel_size=1.0/u_texsize;vec2 pos_a=mix(pattern_tl_a*texel_size-texel_size,pattern_br_a*texel_size+texel_size,vec2(x_a,y));vec2 pos_b=mix(pattern_tl_b*texel_size-texel_size,pattern_br_b*texel_size+texel_size,vec2(x_b,y));vec4 color=mix(texture2D(u_image,pos_a),texture2D(u_image,pos_b),u_fade);gl_FragColor=color*alpha*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "\n#define scale 0.015873016\n#define LINE_DISTANCE_SCALE 2.0\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform vec2 u_units_to_pixels;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;float a_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*LINE_DISTANCE_SCALE;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;float extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;v_linesofar=a_linesofar;v_width2=vec2(outset,inset);v_width=floorwidth;}"), gr = _r("uniform lowp float u_device_pixel_ratio;uniform sampler2D u_image;uniform float u_sdfgamma;uniform float u_mix;varying vec2 v_normal;varying vec2 v_width2;varying vec2 v_tex_a;varying vec2 v_tex_b;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);float sdfdist_a=texture2D(u_image,v_tex_a).a;float sdfdist_b=texture2D(u_image,v_tex_b).a;float sdfdist=mix(sdfdist_a,sdfdist_b,u_mix);alpha*=smoothstep(0.5-u_sdfgamma/floorwidth,0.5+u_sdfgamma/floorwidth,sdfdist);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "\n#define scale 0.015873016\n#define LINE_DISTANCE_SCALE 2.0\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;uniform vec2 u_patternscale_a;uniform float u_tex_y_a;uniform vec2 u_patternscale_b;uniform float u_tex_y_b;uniform vec2 u_units_to_pixels;varying vec2 v_normal;varying vec2 v_width2;varying vec2 v_tex_a;varying vec2 v_tex_b;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;float a_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*LINE_DISTANCE_SCALE;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;float extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;v_tex_a=vec2(a_linesofar*u_patternscale_a.x/floorwidth,normal.y*u_patternscale_a.y+u_tex_y_a);v_tex_b=vec2(a_linesofar*u_patternscale_b.x/floorwidth,normal.y*u_patternscale_b.y+u_tex_y_b);v_width2=vec2(outset,inset);}"), yr = _r("uniform float u_fade_t;uniform float u_opacity;uniform sampler2D u_image0;uniform sampler2D u_image1;varying vec2 v_pos0;varying vec2 v_pos1;uniform float u_brightness_low;uniform float u_brightness_high;uniform float u_saturation_factor;uniform float u_contrast_factor;uniform vec3 u_spin_weights;void main() {vec4 color0=texture2D(u_image0,v_pos0);vec4 color1=texture2D(u_image1,v_pos1);if (color0.a > 0.0) {color0.rgb=color0.rgb/color0.a;}if (color1.a > 0.0) {color1.rgb=color1.rgb/color1.a;}vec4 color=mix(color0,color1,u_fade_t);color.a*=u_opacity;vec3 rgb=color.rgb;rgb=vec3(dot(rgb,u_spin_weights.xyz),dot(rgb,u_spin_weights.zxy),dot(rgb,u_spin_weights.yzx));float average=(color.r+color.g+color.b)/3.0;rgb+=(average-rgb)*u_saturation_factor;rgb=(rgb-0.5)*u_contrast_factor+0.5;vec3 u_high_vec=vec3(u_brightness_low,u_brightness_low,u_brightness_low);vec3 u_low_vec=vec3(u_brightness_high,u_brightness_high,u_brightness_high);gl_FragColor=vec4(mix(u_high_vec,u_low_vec,rgb)*color.a,color.a);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_tl_parent;uniform float u_scale_parent;uniform float u_buffer_scale;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos0;varying vec2 v_pos1;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos0=(((a_texture_pos/8192.0)-0.5)/u_buffer_scale )+0.5;v_pos1=(v_pos0*u_scale_parent)+u_tl_parent;}"), mr = _r("uniform sampler2D u_texture;varying vec2 v_tex;varying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\nlowp float alpha=opacity*v_fade_opacity;gl_FragColor=texture2D(u_texture,v_tex)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec4 a_pixeloffset;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform highp float u_camera_to_center_distance;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform float u_fade_change;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform vec2 u_texsize;varying vec2 v_tex;varying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;vec2 a_minFontScale=a_pixeloffset.zw/256.0;highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,0,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),0,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,0.0,1.0);gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*max(a_minFontScale,fontScale)+a_pxoffset/16.0),0.0,1.0);v_tex=a_tex/u_texsize;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;v_fade_opacity=max(0.0,min(1.0,fade_opacity[0]+fade_change));}"), xr = _r("#define SDF_PX 8.0\nuniform bool u_is_halo;uniform sampler2D u_texture;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;uniform bool u_is_text;varying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nfloat EDGE_GAMMA=0.105/u_device_pixel_ratio;vec2 tex=v_data0.xy;float gamma_scale=v_data1.x;float size=v_data1.y;float fade_opacity=v_data1[2];float fontScale=u_is_text ? size/24.0 : size;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float buff=(256.0-64.0)/256.0;if (u_is_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);buff=(6.0-halo_width/fontScale)/SDF_PX;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);gl_FragColor=color*(alpha*opacity*fade_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec4 a_pixeloffset;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;varying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,0,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),0,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,0.0,1.0);gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*fontScale+a_pxoffset),0.0,1.0);float gamma_scale=gl_Position.w;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(1.0,fade_opacity[0]+fade_change));v_data0=a_tex/u_texsize;v_data1=vec3(gamma_scale,size,interpolated_fade_opacity);}"), br = _r("#define SDF_PX 8.0\n#define SDF 1.0\n#define ICON 0.0\nuniform bool u_is_halo;uniform sampler2D u_texture;uniform sampler2D u_texture_icon;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;varying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nfloat fade_opacity=v_data1[2];if (v_data1.w==ICON) {vec2 tex_icon=v_data0.zw;lowp float alpha=opacity*fade_opacity;gl_FragColor=texture2D(u_texture_icon,tex_icon)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nreturn;}vec2 tex=v_data0.xy;float EDGE_GAMMA=0.105/u_device_pixel_ratio;float gamma_scale=v_data1.x;float size=v_data1.y;float fontScale=size/24.0;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float buff=(256.0-64.0)/256.0;if (u_is_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);buff=(6.0-halo_width/fontScale)/SDF_PX;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);gl_FragColor=color*(alpha*opacity*fade_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;uniform vec2 u_texsize_icon;varying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);float is_sdf=a_size[0]-2.0*a_size_min;highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,0,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=size/24.0;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),0,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,0.0,1.0);gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*fontScale),0.0,1.0);float gamma_scale=gl_Position.w;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(1.0,fade_opacity[0]+fade_change));v_data0.xy=a_tex/u_texsize;v_data0.zw=a_tex/u_texsize_icon;v_data1=vec4(gamma_scale,size,interpolated_fade_opacity,is_sdf);}");
            function _r(t5, e4) {
              var r4 = /#pragma mapbox: ([\w]+) ([\w]+) ([\w]+) ([\w]+)/g, n4 = {};
              return { fragmentSource: t5 = t5.replace(r4, function(t6, e5, r5, i2, a2) {
                return n4[a2] = true, "define" === e5 ? "\n#ifndef HAS_UNIFORM_u_" + a2 + "\nvarying " + r5 + " " + i2 + " " + a2 + ";\n#else\nuniform " + r5 + " " + i2 + " u_" + a2 + ";\n#endif\n" : "\n#ifdef HAS_UNIFORM_u_" + a2 + "\n    " + r5 + " " + i2 + " " + a2 + " = u_" + a2 + ";\n#endif\n";
              }), vertexSource: e4 = e4.replace(r4, function(t6, e5, r5, i2, a2) {
                var o2 = "float" === i2 ? "vec2" : "vec4", s2 = a2.match(/color/) ? "color" : o2;
                return n4[a2] ? "define" === e5 ? "\n#ifndef HAS_UNIFORM_u_" + a2 + "\nuniform lowp float u_" + a2 + "_t;\nattribute " + r5 + " " + o2 + " a_" + a2 + ";\nvarying " + r5 + " " + i2 + " " + a2 + ";\n#else\nuniform " + r5 + " " + i2 + " u_" + a2 + ";\n#endif\n" : "vec4" === s2 ? "\n#ifndef HAS_UNIFORM_u_" + a2 + "\n    " + a2 + " = a_" + a2 + ";\n#else\n    " + r5 + " " + i2 + " " + a2 + " = u_" + a2 + ";\n#endif\n" : "\n#ifndef HAS_UNIFORM_u_" + a2 + "\n    " + a2 + " = unpack_mix_" + s2 + "(a_" + a2 + ", u_" + a2 + "_t);\n#else\n    " + r5 + " " + i2 + " " + a2 + " = u_" + a2 + ";\n#endif\n" : "define" === e5 ? "\n#ifndef HAS_UNIFORM_u_" + a2 + "\nuniform lowp float u_" + a2 + "_t;\nattribute " + r5 + " " + o2 + " a_" + a2 + ";\n#else\nuniform " + r5 + " " + i2 + " u_" + a2 + ";\n#endif\n" : "vec4" === s2 ? "\n#ifndef HAS_UNIFORM_u_" + a2 + "\n    " + r5 + " " + i2 + " " + a2 + " = a_" + a2 + ";\n#else\n    " + r5 + " " + i2 + " " + a2 + " = u_" + a2 + ";\n#endif\n" : "\n#ifndef HAS_UNIFORM_u_" + a2 + "\n    " + r5 + " " + i2 + " " + a2 + " = unpack_mix_" + s2 + "(a_" + a2 + ", u_" + a2 + "_t);\n#else\n    " + r5 + " " + i2 + " " + a2 + " = u_" + a2 + ";\n#endif\n";
              }) };
            }
            var wr = Object.freeze({ __proto__: null, prelude: Xe, background: Je, backgroundPattern: Ke, circle: $e, clippingMask: Qe, heatmap: tr, heatmapTexture: er, collisionBox: rr, collisionCircle: nr, debug: ir, fill: ar, fillOutline: or, fillOutlinePattern: sr, fillPattern: lr, fillExtrusion: ur, fillExtrusionPattern: cr, hillshadePrepare: fr, hillshade: hr, line: pr, lineGradient: dr, linePattern: vr, lineSDF: gr, raster: yr, symbolIcon: mr, symbolSDF: xr, symbolTextAndIcon: br }), Tr = function() {
              this.boundProgram = null, this.boundLayoutVertexBuffer = null, this.boundPaintVertexBuffers = [], this.boundIndexBuffer = null, this.boundVertexOffset = null, this.boundDynamicVertexBuffer = null, this.vao = null;
            };
            Tr.prototype.bind = function(t5, e4, r4, n4, i2, a2, o2, s2) {
              this.context = t5;
              for (var l2 = this.boundPaintVertexBuffers.length !== n4.length, u2 = 0; !l2 && u2 < n4.length; u2++)
                this.boundPaintVertexBuffers[u2] !== n4[u2] && (l2 = true);
              var c2 = !this.vao || this.boundProgram !== e4 || this.boundLayoutVertexBuffer !== r4 || l2 || this.boundIndexBuffer !== i2 || this.boundVertexOffset !== a2 || this.boundDynamicVertexBuffer !== o2 || this.boundDynamicVertexBuffer2 !== s2;
              !t5.extVertexArrayObject || c2 ? this.freshBind(e4, r4, n4, i2, a2, o2, s2) : (t5.bindVertexArrayOES.set(this.vao), o2 && o2.bind(), i2 && i2.dynamicDraw && i2.bind(), s2 && s2.bind());
            }, Tr.prototype.freshBind = function(t5, e4, r4, n4, i2, a2, o2) {
              var s2, l2 = t5.numAttributes, u2 = this.context, c2 = u2.gl;
              if (u2.extVertexArrayObject)
                this.vao && this.destroy(), this.vao = u2.extVertexArrayObject.createVertexArrayOES(), u2.bindVertexArrayOES.set(this.vao), s2 = 0, this.boundProgram = t5, this.boundLayoutVertexBuffer = e4, this.boundPaintVertexBuffers = r4, this.boundIndexBuffer = n4, this.boundVertexOffset = i2, this.boundDynamicVertexBuffer = a2, this.boundDynamicVertexBuffer2 = o2;
              else {
                s2 = u2.currentNumAttributes || 0;
                for (var f3 = l2; f3 < s2; f3++)
                  c2.disableVertexAttribArray(f3);
              }
              e4.enableAttributes(c2, t5);
              for (var h2 = 0, p3 = r4; h2 < p3.length; h2 += 1)
                p3[h2].enableAttributes(c2, t5);
              a2 && a2.enableAttributes(c2, t5), o2 && o2.enableAttributes(c2, t5), e4.bind(), e4.setVertexAttribPointers(c2, t5, i2);
              for (var d3 = 0, v2 = r4; d3 < v2.length; d3 += 1) {
                var g3 = v2[d3];
                g3.bind(), g3.setVertexAttribPointers(c2, t5, i2);
              }
              a2 && (a2.bind(), a2.setVertexAttribPointers(c2, t5, i2)), n4 && n4.bind(), o2 && (o2.bind(), o2.setVertexAttribPointers(c2, t5, i2)), u2.currentNumAttributes = l2;
            }, Tr.prototype.destroy = function() {
              this.vao && (this.context.extVertexArrayObject.deleteVertexArrayOES(this.vao), this.vao = null);
            };
            var kr = function(t5, e4, r4, n4, i2) {
              var a2 = t5.gl;
              this.program = a2.createProgram();
              var o2 = r4 ? r4.defines() : [];
              i2 && o2.push("#define OVERDRAW_INSPECTOR;");
              var s2 = o2.concat(Xe.fragmentSource, e4.fragmentSource).join("\n"), l2 = o2.concat(Xe.vertexSource, e4.vertexSource).join("\n"), u2 = a2.createShader(a2.FRAGMENT_SHADER);
              if (a2.isContextLost())
                this.failedToCreate = true;
              else {
                a2.shaderSource(u2, s2), a2.compileShader(u2), a2.attachShader(this.program, u2);
                var c2 = a2.createShader(a2.VERTEX_SHADER);
                if (a2.isContextLost())
                  this.failedToCreate = true;
                else {
                  a2.shaderSource(c2, l2), a2.compileShader(c2), a2.attachShader(this.program, c2);
                  for (var f3 = r4 ? r4.layoutAttributes : [], h2 = 0; h2 < f3.length; h2++)
                    a2.bindAttribLocation(this.program, h2, f3[h2].name);
                  a2.linkProgram(this.program), a2.deleteShader(c2), a2.deleteShader(u2), this.numAttributes = a2.getProgramParameter(this.program, a2.ACTIVE_ATTRIBUTES), this.attributes = {};
                  for (var p3 = {}, d3 = 0; d3 < this.numAttributes; d3++) {
                    var v2 = a2.getActiveAttrib(this.program, d3);
                    v2 && (this.attributes[v2.name] = a2.getAttribLocation(this.program, v2.name));
                  }
                  for (var g3 = a2.getProgramParameter(this.program, a2.ACTIVE_UNIFORMS), y2 = 0; y2 < g3; y2++) {
                    var m3 = a2.getActiveUniform(this.program, y2);
                    m3 && (p3[m3.name] = a2.getUniformLocation(this.program, m3.name));
                  }
                  this.fixedUniforms = n4(t5, p3), this.binderUniforms = r4 ? r4.getUniforms(t5, p3) : [];
                }
              }
            };
            function Ar(t5, e4, r4) {
              var n4 = 1 / ge(r4, 1, e4.transform.tileZoom), i2 = Math.pow(2, r4.tileID.overscaledZ), a2 = r4.tileSize * Math.pow(2, e4.transform.tileZoom) / i2, o2 = a2 * (r4.tileID.canonical.x + r4.tileID.wrap * i2), s2 = a2 * r4.tileID.canonical.y;
              return { u_image: 0, u_texsize: r4.imageAtlasTexture.size, u_scale: [n4, t5.fromScale, t5.toScale], u_fade: t5.t, u_pixel_coord_upper: [o2 >> 16, s2 >> 16], u_pixel_coord_lower: [65535 & o2, 65535 & s2] };
            }
            kr.prototype.draw = function(t5, e4, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2, p3, d3, v2) {
              var g3, y2 = t5.gl;
              if (!this.failedToCreate) {
                for (var m3 in t5.program.set(this.program), t5.setDepthMode(r4), t5.setStencilMode(n4), t5.setColorMode(i2), t5.setCullFace(a2), this.fixedUniforms)
                  this.fixedUniforms[m3].set(o2[m3]);
                p3 && p3.setUniforms(t5, this.binderUniforms, f3, { zoom: h2 });
                for (var x2 = (g3 = {}, g3[y2.LINES] = 2, g3[y2.TRIANGLES] = 3, g3[y2.LINE_STRIP] = 1, g3)[e4], b2 = 0, _2 = c2.get(); b2 < _2.length; b2 += 1) {
                  var w3 = _2[b2], T2 = w3.vaos || (w3.vaos = {});
                  (T2[s2] || (T2[s2] = new Tr())).bind(t5, this, l2, p3 ? p3.getPaintVertexBuffers() : [], u2, w3.vertexOffset, d3, v2), y2.drawElements(e4, w3.primitiveLength * x2, y2.UNSIGNED_SHORT, w3.primitiveOffset * x2 * 2);
                }
              }
            };
            var Mr = function(e4, r4, n4, i2) {
              var a2 = r4.style.light, o2 = a2.properties.get("position"), s2 = [o2.x, o2.y, o2.z], l2 = t4.create$1();
              "viewport" === a2.properties.get("anchor") && t4.fromRotation(l2, -r4.transform.angle), t4.transformMat3(s2, s2, l2);
              var u2 = a2.properties.get("color");
              return { u_matrix: e4, u_lightpos: s2, u_lightintensity: a2.properties.get("intensity"), u_lightcolor: [u2.r, u2.g, u2.b], u_vertical_gradient: +n4, u_opacity: i2 };
            }, Sr = function(e4, r4, n4, i2, a2, o2, s2) {
              return t4.extend(Mr(e4, r4, n4, i2), Ar(o2, r4, s2), { u_height_factor: -Math.pow(2, a2.overscaledZ) / s2.tileSize / 8 });
            }, Er = function(t5) {
              return { u_matrix: t5 };
            }, Lr = function(e4, r4, n4, i2) {
              return t4.extend(Er(e4), Ar(n4, r4, i2));
            }, Cr = function(t5, e4) {
              return { u_matrix: t5, u_world: e4 };
            }, Pr = function(e4, r4, n4, i2, a2) {
              return t4.extend(Lr(e4, r4, n4, i2), { u_world: a2 });
            }, Or = function(e4, r4, n4, i2) {
              var a2, o2, s2 = e4.transform;
              if ("map" === i2.paint.get("circle-pitch-alignment")) {
                var l2 = ge(n4, 1, s2.zoom);
                a2 = true, o2 = [l2, l2];
              } else
                a2 = false, o2 = s2.pixelsToGLUnits;
              return { u_camera_to_center_distance: s2.cameraToCenterDistance, u_scale_with_map: +("map" === i2.paint.get("circle-pitch-scale")), u_matrix: e4.translatePosMatrix(r4.posMatrix, n4, i2.paint.get("circle-translate"), i2.paint.get("circle-translate-anchor")), u_pitch_with_map: +a2, u_device_pixel_ratio: t4.browser.devicePixelRatio, u_extrude_scale: o2 };
            }, Ir = function(t5, e4, r4) {
              var n4 = ge(r4, 1, e4.zoom), i2 = Math.pow(2, e4.zoom - r4.tileID.overscaledZ), a2 = r4.tileID.overscaleFactor();
              return { u_matrix: t5, u_camera_to_center_distance: e4.cameraToCenterDistance, u_pixels_to_tile_units: n4, u_extrude_scale: [e4.pixelsToGLUnits[0] / (n4 * i2), e4.pixelsToGLUnits[1] / (n4 * i2)], u_overscale_factor: a2 };
            }, Dr = function(t5, e4, r4) {
              return { u_matrix: t5, u_inv_matrix: e4, u_camera_to_center_distance: r4.cameraToCenterDistance, u_viewport_size: [r4.width, r4.height] };
            }, zr = function(t5, e4, r4) {
              return void 0 === r4 && (r4 = 1), { u_matrix: t5, u_color: e4, u_overlay: 0, u_overlay_scale: r4 };
            }, Rr = function(t5) {
              return { u_matrix: t5 };
            }, Fr = function(t5, e4, r4, n4) {
              return { u_matrix: t5, u_extrude_scale: ge(e4, 1, r4), u_intensity: n4 };
            };
            var Br = function(e4, r4, n4) {
              var i2 = e4.transform;
              return { u_matrix: Hr(e4, r4, n4), u_ratio: 1 / ge(r4, 1, i2.zoom), u_device_pixel_ratio: t4.browser.devicePixelRatio, u_units_to_pixels: [1 / i2.pixelsToGLUnits[0], 1 / i2.pixelsToGLUnits[1]] };
            }, Nr = function(e4, r4, n4) {
              return t4.extend(Br(e4, r4, n4), { u_image: 0 });
            }, jr = function(e4, r4, n4, i2) {
              var a2 = e4.transform, o2 = Vr(r4, a2);
              return { u_matrix: Hr(e4, r4, n4), u_texsize: r4.imageAtlasTexture.size, u_ratio: 1 / ge(r4, 1, a2.zoom), u_device_pixel_ratio: t4.browser.devicePixelRatio, u_image: 0, u_scale: [o2, i2.fromScale, i2.toScale], u_fade: i2.t, u_units_to_pixels: [1 / a2.pixelsToGLUnits[0], 1 / a2.pixelsToGLUnits[1]] };
            }, Ur = function(e4, r4, n4, i2, a2) {
              var o2 = e4.transform, s2 = e4.lineAtlas, l2 = Vr(r4, o2), u2 = "round" === n4.layout.get("line-cap"), c2 = s2.getDash(i2.from, u2), f3 = s2.getDash(i2.to, u2), h2 = c2.width * a2.fromScale, p3 = f3.width * a2.toScale;
              return t4.extend(Br(e4, r4, n4), { u_patternscale_a: [l2 / h2, -c2.height / 2], u_patternscale_b: [l2 / p3, -f3.height / 2], u_sdfgamma: s2.width / (256 * Math.min(h2, p3) * t4.browser.devicePixelRatio) / 2, u_image: 0, u_tex_y_a: c2.y, u_tex_y_b: f3.y, u_mix: a2.t });
            };
            function Vr(t5, e4) {
              return 1 / ge(t5, 1, e4.tileZoom);
            }
            function Hr(t5, e4, r4) {
              return t5.translatePosMatrix(e4.tileID.posMatrix, e4, r4.paint.get("line-translate"), r4.paint.get("line-translate-anchor"));
            }
            var qr = function(t5, e4, r4, n4, i2) {
              return { u_matrix: t5, u_tl_parent: e4, u_scale_parent: r4, u_buffer_scale: 1, u_fade_t: n4.mix, u_opacity: n4.opacity * i2.paint.get("raster-opacity"), u_image0: 0, u_image1: 1, u_brightness_low: i2.paint.get("raster-brightness-min"), u_brightness_high: i2.paint.get("raster-brightness-max"), u_saturation_factor: (o2 = i2.paint.get("raster-saturation"), o2 > 0 ? 1 - 1 / (1.001 - o2) : -o2), u_contrast_factor: (a2 = i2.paint.get("raster-contrast"), a2 > 0 ? 1 / (1 - a2) : 1 + a2), u_spin_weights: Gr(i2.paint.get("raster-hue-rotate")) };
              var a2, o2;
            };
            function Gr(t5) {
              t5 *= Math.PI / 180;
              var e4 = Math.sin(t5), r4 = Math.cos(t5);
              return [(2 * r4 + 1) / 3, (-Math.sqrt(3) * e4 - r4 + 1) / 3, (Math.sqrt(3) * e4 - r4 + 1) / 3];
            }
            var Zr, Yr = function(t5, e4, r4, n4, i2, a2, o2, s2, l2, u2) {
              var c2 = i2.transform;
              return { u_is_size_zoom_constant: +("constant" === t5 || "source" === t5), u_is_size_feature_constant: +("constant" === t5 || "camera" === t5), u_size_t: e4 ? e4.uSizeT : 0, u_size: e4 ? e4.uSize : 0, u_camera_to_center_distance: c2.cameraToCenterDistance, u_pitch: c2.pitch / 360 * 2 * Math.PI, u_rotate_symbol: +r4, u_aspect_ratio: c2.width / c2.height, u_fade_change: i2.options.fadeDuration ? i2.symbolFadeChange : 1, u_matrix: a2, u_label_plane_matrix: o2, u_coord_matrix: s2, u_is_text: +l2, u_pitch_with_map: +n4, u_texsize: u2, u_texture: 0 };
            }, Wr = function(e4, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3) {
              var h2 = a2.transform;
              return t4.extend(Yr(e4, r4, n4, i2, a2, o2, s2, l2, u2, c2), { u_gamma_scale: i2 ? Math.cos(h2._pitch) * h2.cameraToCenterDistance : 1, u_device_pixel_ratio: t4.browser.devicePixelRatio, u_is_halo: +f3 });
            }, Xr = function(e4, r4, n4, i2, a2, o2, s2, l2, u2, c2) {
              return t4.extend(Wr(e4, r4, n4, i2, a2, o2, s2, l2, true, u2, true), { u_texsize_icon: c2, u_texture_icon: 1 });
            }, Jr = function(t5, e4, r4) {
              return { u_matrix: t5, u_opacity: e4, u_color: r4 };
            }, Kr = function(e4, r4, n4, i2, a2, o2) {
              return t4.extend(function(t5, e5, r5, n5) {
                var i3 = r5.imageManager.getPattern(t5.from.toString()), a3 = r5.imageManager.getPattern(t5.to.toString()), o3 = r5.imageManager.getPixelSize(), s2 = o3.width, l2 = o3.height, u2 = Math.pow(2, n5.tileID.overscaledZ), c2 = n5.tileSize * Math.pow(2, r5.transform.tileZoom) / u2, f3 = c2 * (n5.tileID.canonical.x + n5.tileID.wrap * u2), h2 = c2 * n5.tileID.canonical.y;
                return { u_image: 0, u_pattern_tl_a: i3.tl, u_pattern_br_a: i3.br, u_pattern_tl_b: a3.tl, u_pattern_br_b: a3.br, u_texsize: [s2, l2], u_mix: e5.t, u_pattern_size_a: i3.displaySize, u_pattern_size_b: a3.displaySize, u_scale_a: e5.fromScale, u_scale_b: e5.toScale, u_tile_units_to_pixels: 1 / ge(n5, 1, r5.transform.tileZoom), u_pixel_coord_upper: [f3 >> 16, h2 >> 16], u_pixel_coord_lower: [65535 & f3, 65535 & h2] };
              }(i2, o2, n4, a2), { u_matrix: e4, u_opacity: r4 });
            }, $r = { fillExtrusion: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_lightpos: new t4.Uniform3f(e4, r4.u_lightpos), u_lightintensity: new t4.Uniform1f(e4, r4.u_lightintensity), u_lightcolor: new t4.Uniform3f(e4, r4.u_lightcolor), u_vertical_gradient: new t4.Uniform1f(e4, r4.u_vertical_gradient), u_opacity: new t4.Uniform1f(e4, r4.u_opacity) };
            }, fillExtrusionPattern: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_lightpos: new t4.Uniform3f(e4, r4.u_lightpos), u_lightintensity: new t4.Uniform1f(e4, r4.u_lightintensity), u_lightcolor: new t4.Uniform3f(e4, r4.u_lightcolor), u_vertical_gradient: new t4.Uniform1f(e4, r4.u_vertical_gradient), u_height_factor: new t4.Uniform1f(e4, r4.u_height_factor), u_image: new t4.Uniform1i(e4, r4.u_image), u_texsize: new t4.Uniform2f(e4, r4.u_texsize), u_pixel_coord_upper: new t4.Uniform2f(e4, r4.u_pixel_coord_upper), u_pixel_coord_lower: new t4.Uniform2f(e4, r4.u_pixel_coord_lower), u_scale: new t4.Uniform3f(e4, r4.u_scale), u_fade: new t4.Uniform1f(e4, r4.u_fade), u_opacity: new t4.Uniform1f(e4, r4.u_opacity) };
            }, fill: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix) };
            }, fillPattern: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_image: new t4.Uniform1i(e4, r4.u_image), u_texsize: new t4.Uniform2f(e4, r4.u_texsize), u_pixel_coord_upper: new t4.Uniform2f(e4, r4.u_pixel_coord_upper), u_pixel_coord_lower: new t4.Uniform2f(e4, r4.u_pixel_coord_lower), u_scale: new t4.Uniform3f(e4, r4.u_scale), u_fade: new t4.Uniform1f(e4, r4.u_fade) };
            }, fillOutline: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_world: new t4.Uniform2f(e4, r4.u_world) };
            }, fillOutlinePattern: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_world: new t4.Uniform2f(e4, r4.u_world), u_image: new t4.Uniform1i(e4, r4.u_image), u_texsize: new t4.Uniform2f(e4, r4.u_texsize), u_pixel_coord_upper: new t4.Uniform2f(e4, r4.u_pixel_coord_upper), u_pixel_coord_lower: new t4.Uniform2f(e4, r4.u_pixel_coord_lower), u_scale: new t4.Uniform3f(e4, r4.u_scale), u_fade: new t4.Uniform1f(e4, r4.u_fade) };
            }, circle: function(e4, r4) {
              return { u_camera_to_center_distance: new t4.Uniform1f(e4, r4.u_camera_to_center_distance), u_scale_with_map: new t4.Uniform1i(e4, r4.u_scale_with_map), u_pitch_with_map: new t4.Uniform1i(e4, r4.u_pitch_with_map), u_extrude_scale: new t4.Uniform2f(e4, r4.u_extrude_scale), u_device_pixel_ratio: new t4.Uniform1f(e4, r4.u_device_pixel_ratio), u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix) };
            }, collisionBox: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_camera_to_center_distance: new t4.Uniform1f(e4, r4.u_camera_to_center_distance), u_pixels_to_tile_units: new t4.Uniform1f(e4, r4.u_pixels_to_tile_units), u_extrude_scale: new t4.Uniform2f(e4, r4.u_extrude_scale), u_overscale_factor: new t4.Uniform1f(e4, r4.u_overscale_factor) };
            }, collisionCircle: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_inv_matrix: new t4.UniformMatrix4f(e4, r4.u_inv_matrix), u_camera_to_center_distance: new t4.Uniform1f(e4, r4.u_camera_to_center_distance), u_viewport_size: new t4.Uniform2f(e4, r4.u_viewport_size) };
            }, debug: function(e4, r4) {
              return { u_color: new t4.UniformColor(e4, r4.u_color), u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_overlay: new t4.Uniform1i(e4, r4.u_overlay), u_overlay_scale: new t4.Uniform1f(e4, r4.u_overlay_scale) };
            }, clippingMask: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix) };
            }, heatmap: function(e4, r4) {
              return { u_extrude_scale: new t4.Uniform1f(e4, r4.u_extrude_scale), u_intensity: new t4.Uniform1f(e4, r4.u_intensity), u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix) };
            }, heatmapTexture: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_world: new t4.Uniform2f(e4, r4.u_world), u_image: new t4.Uniform1i(e4, r4.u_image), u_color_ramp: new t4.Uniform1i(e4, r4.u_color_ramp), u_opacity: new t4.Uniform1f(e4, r4.u_opacity) };
            }, hillshade: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_image: new t4.Uniform1i(e4, r4.u_image), u_latrange: new t4.Uniform2f(e4, r4.u_latrange), u_light: new t4.Uniform2f(e4, r4.u_light), u_shadow: new t4.UniformColor(e4, r4.u_shadow), u_highlight: new t4.UniformColor(e4, r4.u_highlight), u_accent: new t4.UniformColor(e4, r4.u_accent) };
            }, hillshadePrepare: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_image: new t4.Uniform1i(e4, r4.u_image), u_dimension: new t4.Uniform2f(e4, r4.u_dimension), u_zoom: new t4.Uniform1f(e4, r4.u_zoom), u_maxzoom: new t4.Uniform1f(e4, r4.u_maxzoom), u_unpack: new t4.Uniform4f(e4, r4.u_unpack) };
            }, line: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_ratio: new t4.Uniform1f(e4, r4.u_ratio), u_device_pixel_ratio: new t4.Uniform1f(e4, r4.u_device_pixel_ratio), u_units_to_pixels: new t4.Uniform2f(e4, r4.u_units_to_pixels) };
            }, lineGradient: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_ratio: new t4.Uniform1f(e4, r4.u_ratio), u_device_pixel_ratio: new t4.Uniform1f(e4, r4.u_device_pixel_ratio), u_units_to_pixels: new t4.Uniform2f(e4, r4.u_units_to_pixels), u_image: new t4.Uniform1i(e4, r4.u_image) };
            }, linePattern: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_texsize: new t4.Uniform2f(e4, r4.u_texsize), u_ratio: new t4.Uniform1f(e4, r4.u_ratio), u_device_pixel_ratio: new t4.Uniform1f(e4, r4.u_device_pixel_ratio), u_image: new t4.Uniform1i(e4, r4.u_image), u_units_to_pixels: new t4.Uniform2f(e4, r4.u_units_to_pixels), u_scale: new t4.Uniform3f(e4, r4.u_scale), u_fade: new t4.Uniform1f(e4, r4.u_fade) };
            }, lineSDF: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_ratio: new t4.Uniform1f(e4, r4.u_ratio), u_device_pixel_ratio: new t4.Uniform1f(e4, r4.u_device_pixel_ratio), u_units_to_pixels: new t4.Uniform2f(e4, r4.u_units_to_pixels), u_patternscale_a: new t4.Uniform2f(e4, r4.u_patternscale_a), u_patternscale_b: new t4.Uniform2f(e4, r4.u_patternscale_b), u_sdfgamma: new t4.Uniform1f(e4, r4.u_sdfgamma), u_image: new t4.Uniform1i(e4, r4.u_image), u_tex_y_a: new t4.Uniform1f(e4, r4.u_tex_y_a), u_tex_y_b: new t4.Uniform1f(e4, r4.u_tex_y_b), u_mix: new t4.Uniform1f(e4, r4.u_mix) };
            }, raster: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_tl_parent: new t4.Uniform2f(e4, r4.u_tl_parent), u_scale_parent: new t4.Uniform1f(e4, r4.u_scale_parent), u_buffer_scale: new t4.Uniform1f(e4, r4.u_buffer_scale), u_fade_t: new t4.Uniform1f(e4, r4.u_fade_t), u_opacity: new t4.Uniform1f(e4, r4.u_opacity), u_image0: new t4.Uniform1i(e4, r4.u_image0), u_image1: new t4.Uniform1i(e4, r4.u_image1), u_brightness_low: new t4.Uniform1f(e4, r4.u_brightness_low), u_brightness_high: new t4.Uniform1f(e4, r4.u_brightness_high), u_saturation_factor: new t4.Uniform1f(e4, r4.u_saturation_factor), u_contrast_factor: new t4.Uniform1f(e4, r4.u_contrast_factor), u_spin_weights: new t4.Uniform3f(e4, r4.u_spin_weights) };
            }, symbolIcon: function(e4, r4) {
              return { u_is_size_zoom_constant: new t4.Uniform1i(e4, r4.u_is_size_zoom_constant), u_is_size_feature_constant: new t4.Uniform1i(e4, r4.u_is_size_feature_constant), u_size_t: new t4.Uniform1f(e4, r4.u_size_t), u_size: new t4.Uniform1f(e4, r4.u_size), u_camera_to_center_distance: new t4.Uniform1f(e4, r4.u_camera_to_center_distance), u_pitch: new t4.Uniform1f(e4, r4.u_pitch), u_rotate_symbol: new t4.Uniform1i(e4, r4.u_rotate_symbol), u_aspect_ratio: new t4.Uniform1f(e4, r4.u_aspect_ratio), u_fade_change: new t4.Uniform1f(e4, r4.u_fade_change), u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_label_plane_matrix: new t4.UniformMatrix4f(e4, r4.u_label_plane_matrix), u_coord_matrix: new t4.UniformMatrix4f(e4, r4.u_coord_matrix), u_is_text: new t4.Uniform1i(e4, r4.u_is_text), u_pitch_with_map: new t4.Uniform1i(e4, r4.u_pitch_with_map), u_texsize: new t4.Uniform2f(e4, r4.u_texsize), u_texture: new t4.Uniform1i(e4, r4.u_texture) };
            }, symbolSDF: function(e4, r4) {
              return { u_is_size_zoom_constant: new t4.Uniform1i(e4, r4.u_is_size_zoom_constant), u_is_size_feature_constant: new t4.Uniform1i(e4, r4.u_is_size_feature_constant), u_size_t: new t4.Uniform1f(e4, r4.u_size_t), u_size: new t4.Uniform1f(e4, r4.u_size), u_camera_to_center_distance: new t4.Uniform1f(e4, r4.u_camera_to_center_distance), u_pitch: new t4.Uniform1f(e4, r4.u_pitch), u_rotate_symbol: new t4.Uniform1i(e4, r4.u_rotate_symbol), u_aspect_ratio: new t4.Uniform1f(e4, r4.u_aspect_ratio), u_fade_change: new t4.Uniform1f(e4, r4.u_fade_change), u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_label_plane_matrix: new t4.UniformMatrix4f(e4, r4.u_label_plane_matrix), u_coord_matrix: new t4.UniformMatrix4f(e4, r4.u_coord_matrix), u_is_text: new t4.Uniform1i(e4, r4.u_is_text), u_pitch_with_map: new t4.Uniform1i(e4, r4.u_pitch_with_map), u_texsize: new t4.Uniform2f(e4, r4.u_texsize), u_texture: new t4.Uniform1i(e4, r4.u_texture), u_gamma_scale: new t4.Uniform1f(e4, r4.u_gamma_scale), u_device_pixel_ratio: new t4.Uniform1f(e4, r4.u_device_pixel_ratio), u_is_halo: new t4.Uniform1i(e4, r4.u_is_halo) };
            }, symbolTextAndIcon: function(e4, r4) {
              return { u_is_size_zoom_constant: new t4.Uniform1i(e4, r4.u_is_size_zoom_constant), u_is_size_feature_constant: new t4.Uniform1i(e4, r4.u_is_size_feature_constant), u_size_t: new t4.Uniform1f(e4, r4.u_size_t), u_size: new t4.Uniform1f(e4, r4.u_size), u_camera_to_center_distance: new t4.Uniform1f(e4, r4.u_camera_to_center_distance), u_pitch: new t4.Uniform1f(e4, r4.u_pitch), u_rotate_symbol: new t4.Uniform1i(e4, r4.u_rotate_symbol), u_aspect_ratio: new t4.Uniform1f(e4, r4.u_aspect_ratio), u_fade_change: new t4.Uniform1f(e4, r4.u_fade_change), u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_label_plane_matrix: new t4.UniformMatrix4f(e4, r4.u_label_plane_matrix), u_coord_matrix: new t4.UniformMatrix4f(e4, r4.u_coord_matrix), u_is_text: new t4.Uniform1i(e4, r4.u_is_text), u_pitch_with_map: new t4.Uniform1i(e4, r4.u_pitch_with_map), u_texsize: new t4.Uniform2f(e4, r4.u_texsize), u_texsize_icon: new t4.Uniform2f(e4, r4.u_texsize_icon), u_texture: new t4.Uniform1i(e4, r4.u_texture), u_texture_icon: new t4.Uniform1i(e4, r4.u_texture_icon), u_gamma_scale: new t4.Uniform1f(e4, r4.u_gamma_scale), u_device_pixel_ratio: new t4.Uniform1f(e4, r4.u_device_pixel_ratio), u_is_halo: new t4.Uniform1i(e4, r4.u_is_halo) };
            }, background: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_opacity: new t4.Uniform1f(e4, r4.u_opacity), u_color: new t4.UniformColor(e4, r4.u_color) };
            }, backgroundPattern: function(e4, r4) {
              return { u_matrix: new t4.UniformMatrix4f(e4, r4.u_matrix), u_opacity: new t4.Uniform1f(e4, r4.u_opacity), u_image: new t4.Uniform1i(e4, r4.u_image), u_pattern_tl_a: new t4.Uniform2f(e4, r4.u_pattern_tl_a), u_pattern_br_a: new t4.Uniform2f(e4, r4.u_pattern_br_a), u_pattern_tl_b: new t4.Uniform2f(e4, r4.u_pattern_tl_b), u_pattern_br_b: new t4.Uniform2f(e4, r4.u_pattern_br_b), u_texsize: new t4.Uniform2f(e4, r4.u_texsize), u_mix: new t4.Uniform1f(e4, r4.u_mix), u_pattern_size_a: new t4.Uniform2f(e4, r4.u_pattern_size_a), u_pattern_size_b: new t4.Uniform2f(e4, r4.u_pattern_size_b), u_scale_a: new t4.Uniform1f(e4, r4.u_scale_a), u_scale_b: new t4.Uniform1f(e4, r4.u_scale_b), u_pixel_coord_upper: new t4.Uniform2f(e4, r4.u_pixel_coord_upper), u_pixel_coord_lower: new t4.Uniform2f(e4, r4.u_pixel_coord_lower), u_tile_units_to_pixels: new t4.Uniform1f(e4, r4.u_tile_units_to_pixels) };
            } };
            function Qr(e4, r4, n4, i2, a2, o2, s2) {
              for (var l2 = e4.context, u2 = l2.gl, c2 = e4.useProgram("collisionBox"), f3 = [], h2 = 0, p3 = 0, d3 = 0; d3 < i2.length; d3++) {
                var v2 = i2[d3], g3 = r4.getTile(v2), y2 = g3.getBucket(n4);
                if (y2) {
                  var m3 = v2.posMatrix;
                  0 === a2[0] && 0 === a2[1] || (m3 = e4.translatePosMatrix(v2.posMatrix, g3, a2, o2));
                  var x2 = s2 ? y2.textCollisionBox : y2.iconCollisionBox, b2 = y2.collisionCircleArray;
                  if (b2.length > 0) {
                    var _2 = t4.create(), w3 = m3;
                    t4.mul(_2, y2.placementInvProjMatrix, e4.transform.glCoordMatrix), t4.mul(_2, _2, y2.placementViewportMatrix), f3.push({ circleArray: b2, circleOffset: p3, transform: w3, invTransform: _2 }), p3 = h2 += b2.length / 4;
                  }
                  x2 && c2.draw(l2, u2.LINES, Mt.disabled, Et.disabled, e4.colorModeForRenderPass(), Ct.disabled, Ir(m3, e4.transform, g3), n4.id, x2.layoutVertexBuffer, x2.indexBuffer, x2.segments, null, e4.transform.zoom, null, null, x2.collisionVertexBuffer);
                }
              }
              if (s2 && f3.length) {
                var T2 = e4.useProgram("collisionCircle"), k2 = new t4.StructArrayLayout2f1f2i16();
                k2.resize(4 * h2), k2._trim();
                for (var A2 = 0, M2 = 0, S2 = f3; M2 < S2.length; M2 += 1)
                  for (var E2 = S2[M2], L2 = 0; L2 < E2.circleArray.length / 4; L2++) {
                    var C2 = 4 * L2, P2 = E2.circleArray[C2 + 0], O2 = E2.circleArray[C2 + 1], I2 = E2.circleArray[C2 + 2], D2 = E2.circleArray[C2 + 3];
                    k2.emplace(A2++, P2, O2, I2, D2, 0), k2.emplace(A2++, P2, O2, I2, D2, 1), k2.emplace(A2++, P2, O2, I2, D2, 2), k2.emplace(A2++, P2, O2, I2, D2, 3);
                  }
                (!Zr || Zr.length < 2 * h2) && (Zr = function(e5) {
                  var r5 = 2 * e5, n5 = new t4.StructArrayLayout3ui6();
                  n5.resize(r5), n5._trim();
                  for (var i3 = 0; i3 < r5; i3++) {
                    var a3 = 6 * i3;
                    n5.uint16[a3 + 0] = 4 * i3 + 0, n5.uint16[a3 + 1] = 4 * i3 + 1, n5.uint16[a3 + 2] = 4 * i3 + 2, n5.uint16[a3 + 3] = 4 * i3 + 2, n5.uint16[a3 + 4] = 4 * i3 + 3, n5.uint16[a3 + 5] = 4 * i3 + 0;
                  }
                  return n5;
                }(h2));
                for (var z2 = l2.createIndexBuffer(Zr, true), R2 = l2.createVertexBuffer(k2, t4.collisionCircleLayout.members, true), F2 = 0, B2 = f3; F2 < B2.length; F2 += 1) {
                  var N2 = B2[F2], j2 = Dr(N2.transform, N2.invTransform, e4.transform);
                  T2.draw(l2, u2.TRIANGLES, Mt.disabled, Et.disabled, e4.colorModeForRenderPass(), Ct.disabled, j2, n4.id, R2, z2, t4.SegmentVector.simpleSegment(0, 2 * N2.circleOffset, N2.circleArray.length, N2.circleArray.length / 2), null, e4.transform.zoom, null, null, null);
                }
                R2.destroy(), z2.destroy();
              }
            }
            var tn = t4.identity(new Float32Array(16));
            function en(e4, r4, n4, i2, a2, o2) {
              var s2 = t4.getAnchorAlignment(e4), l2 = -(s2.horizontalAlign - 0.5) * r4, u2 = -(s2.verticalAlign - 0.5) * n4, c2 = t4.evaluateVariableOffset(e4, i2);
              return new t4.Point((l2 / a2 + c2[0]) * o2, (u2 / a2 + c2[1]) * o2);
            }
            function rn(e4, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3) {
              var h2 = e4.text.placedSymbolArray, p3 = e4.text.dynamicLayoutVertexArray, d3 = e4.icon.dynamicLayoutVertexArray, v2 = {};
              p3.clear();
              for (var g3 = 0; g3 < h2.length; g3++) {
                var y2 = h2.get(g3), m3 = e4.allowVerticalPlacement && !y2.placedOrientation, x2 = y2.hidden || !y2.crossTileID || m3 ? null : i2[y2.crossTileID];
                if (x2) {
                  var b2 = new t4.Point(y2.anchorX, y2.anchorY), _2 = re(b2, n4 ? l2 : s2), w3 = ne(o2.cameraToCenterDistance, _2.signedDistanceFromCamera), T2 = a2.evaluateSizeForFeature(e4.textSizeData, c2, y2) * w3 / t4.ONE_EM;
                  n4 && (T2 *= e4.tilePixelRatio / u2);
                  for (var k2 = x2.width, A2 = x2.height, M2 = en(x2.anchor, k2, A2, x2.textOffset, x2.textBoxScale, T2), S2 = n4 ? re(b2.add(M2), s2).point : _2.point.add(r4 ? M2.rotate(-o2.angle) : M2), E2 = e4.allowVerticalPlacement && y2.placedOrientation === t4.WritingMode.vertical ? Math.PI / 2 : 0, L2 = 0; L2 < y2.numGlyphs; L2++)
                    t4.addDynamicAttributes(p3, S2, E2);
                  f3 && y2.associatedIconIndex >= 0 && (v2[y2.associatedIconIndex] = { shiftedAnchor: S2, angle: E2 });
                } else
                  he(y2.numGlyphs, p3);
              }
              if (f3) {
                d3.clear();
                for (var C2 = e4.icon.placedSymbolArray, P2 = 0; P2 < C2.length; P2++) {
                  var O2 = C2.get(P2);
                  if (O2.hidden)
                    he(O2.numGlyphs, d3);
                  else {
                    var I2 = v2[P2];
                    if (I2)
                      for (var D2 = 0; D2 < O2.numGlyphs; D2++)
                        t4.addDynamicAttributes(d3, I2.shiftedAnchor, I2.angle);
                    else
                      he(O2.numGlyphs, d3);
                  }
                }
                e4.icon.dynamicLayoutVertexBuffer.updateData(d3);
              }
              e4.text.dynamicLayoutVertexBuffer.updateData(p3);
            }
            function nn(t5, e4, r4) {
              return r4.iconsInText && e4 ? "symbolTextAndIcon" : t5 ? "symbolSDF" : "symbolIcon";
            }
            function an(e4, r4, n4, i2, a2, o2, s2, l2, u2, c2, f3, h2) {
              for (var p3 = e4.context, d3 = p3.gl, v2 = e4.transform, g3 = "map" === l2, y2 = "map" === u2, m3 = g3 && "point" !== n4.layout.get("symbol-placement"), x2 = g3 && !y2 && !m3, b2 = void 0 !== n4.layout.get("symbol-sort-key").constantOr(1), _2 = e4.depthModeForSublayer(0, Mt.ReadOnly), w3 = n4.layout.get("text-variable-anchor"), T2 = [], k2 = 0, A2 = i2; k2 < A2.length; k2 += 1) {
                var M2 = A2[k2], S2 = r4.getTile(M2), E2 = S2.getBucket(n4);
                if (E2) {
                  var L2 = a2 ? E2.text : E2.icon;
                  if (L2 && L2.segments.get().length) {
                    var C2 = L2.programConfigurations.get(n4.id), P2 = a2 || E2.sdfIcons, O2 = a2 ? E2.textSizeData : E2.iconSizeData, I2 = y2 || 0 !== v2.pitch, D2 = e4.useProgram(nn(P2, a2, E2), C2), z2 = t4.evaluateSizeForZoom(O2, v2.zoom), R2 = void 0, F2 = [0, 0], B2 = void 0, N2 = void 0, j2 = null, U2 = void 0;
                    if (a2) {
                      if (B2 = S2.glyphAtlasTexture, N2 = d3.LINEAR, R2 = S2.glyphAtlasTexture.size, E2.iconsInText) {
                        F2 = S2.imageAtlasTexture.size, j2 = S2.imageAtlasTexture;
                        var V2 = "composite" === O2.kind || "camera" === O2.kind;
                        U2 = I2 || e4.options.rotating || e4.options.zooming || V2 ? d3.LINEAR : d3.NEAREST;
                      }
                    } else {
                      var H2 = 1 !== n4.layout.get("icon-size").constantOr(0) || E2.iconsNeedLinear;
                      B2 = S2.imageAtlasTexture, N2 = P2 || e4.options.rotating || e4.options.zooming || H2 || I2 ? d3.LINEAR : d3.NEAREST, R2 = S2.imageAtlasTexture.size;
                    }
                    var q3 = ge(S2, 1, e4.transform.zoom), G2 = te(M2.posMatrix, y2, g3, e4.transform, q3), Z2 = ee(M2.posMatrix, y2, g3, e4.transform, q3), Y2 = w3 && E2.hasTextData(), W2 = "none" !== n4.layout.get("icon-text-fit") && Y2 && E2.hasIconData();
                    m3 && ae(E2, M2.posMatrix, e4, a2, G2, Z2, y2, c2);
                    var X2 = e4.translatePosMatrix(M2.posMatrix, S2, o2, s2), J2 = m3 || a2 && w3 || W2 ? tn : G2, K2 = e4.translatePosMatrix(Z2, S2, o2, s2, true), $2 = P2 && 0 !== n4.paint.get(a2 ? "text-halo-width" : "icon-halo-width").constantOr(1), Q2 = { program: D2, buffers: L2, uniformValues: P2 ? E2.iconsInText ? Xr(O2.kind, z2, x2, y2, e4, X2, J2, K2, R2, F2) : Wr(O2.kind, z2, x2, y2, e4, X2, J2, K2, a2, R2, true) : Yr(O2.kind, z2, x2, y2, e4, X2, J2, K2, a2, R2), atlasTexture: B2, atlasTextureIcon: j2, atlasInterpolation: N2, atlasInterpolationIcon: U2, isSDF: P2, hasHalo: $2 };
                    if (b2)
                      for (var tt2 = 0, et2 = L2.segments.get(); tt2 < et2.length; tt2 += 1) {
                        var rt2 = et2[tt2];
                        T2.push({ segments: new t4.SegmentVector([rt2]), sortKey: rt2.sortKey, state: Q2 });
                      }
                    else
                      T2.push({ segments: L2.segments, sortKey: 0, state: Q2 });
                  }
                }
              }
              b2 && T2.sort(function(t5, e5) {
                return t5.sortKey - e5.sortKey;
              });
              for (var nt2 = 0, it2 = T2; nt2 < it2.length; nt2 += 1) {
                var at2 = it2[nt2], ot2 = at2.state;
                if (p3.activeTexture.set(d3.TEXTURE0), ot2.atlasTexture.bind(ot2.atlasInterpolation, d3.CLAMP_TO_EDGE), ot2.atlasTextureIcon && (p3.activeTexture.set(d3.TEXTURE1), ot2.atlasTextureIcon && ot2.atlasTextureIcon.bind(ot2.atlasInterpolationIcon, d3.CLAMP_TO_EDGE)), ot2.isSDF) {
                  var st2 = ot2.uniformValues;
                  ot2.hasHalo && (st2.u_is_halo = 1, on(ot2.buffers, at2.segments, n4, e4, ot2.program, _2, f3, h2, st2)), st2.u_is_halo = 0;
                }
                on(ot2.buffers, at2.segments, n4, e4, ot2.program, _2, f3, h2, ot2.uniformValues);
              }
            }
            function on(t5, e4, r4, n4, i2, a2, o2, s2, l2) {
              var u2 = n4.context, c2 = u2.gl;
              i2.draw(u2, c2.TRIANGLES, a2, o2, s2, Ct.disabled, l2, r4.id, t5.layoutVertexBuffer, t5.indexBuffer, e4, r4.paint, n4.transform.zoom, t5.programConfigurations.get(r4.id), t5.dynamicLayoutVertexBuffer, t5.opacityVertexBuffer);
            }
            function sn(t5, e4, r4, n4, i2, a2, o2) {
              var s2, l2, u2, c2, f3, h2 = t5.context.gl, p3 = r4.paint.get("fill-pattern"), d3 = p3 && p3.constantOr(1), v2 = r4.getCrossfadeParameters();
              o2 ? (l2 = d3 && !r4.getPaintProperty("fill-outline-color") ? "fillOutlinePattern" : "fillOutline", s2 = h2.LINES) : (l2 = d3 ? "fillPattern" : "fill", s2 = h2.TRIANGLES);
              for (var g3 = 0, y2 = n4; g3 < y2.length; g3 += 1) {
                var m3 = y2[g3], x2 = e4.getTile(m3);
                if (!d3 || x2.patternsLoaded()) {
                  var b2 = x2.getBucket(r4);
                  if (b2) {
                    var _2 = b2.programConfigurations.get(r4.id), w3 = t5.useProgram(l2, _2);
                    d3 && (t5.context.activeTexture.set(h2.TEXTURE0), x2.imageAtlasTexture.bind(h2.LINEAR, h2.CLAMP_TO_EDGE), _2.updatePaintBuffers(v2));
                    var T2 = p3.constantOr(null);
                    if (T2 && x2.imageAtlas) {
                      var k2 = x2.imageAtlas, A2 = k2.patternPositions[T2.to.toString()], M2 = k2.patternPositions[T2.from.toString()];
                      A2 && M2 && _2.setConstantPatternPositions(A2, M2);
                    }
                    var S2 = t5.translatePosMatrix(m3.posMatrix, x2, r4.paint.get("fill-translate"), r4.paint.get("fill-translate-anchor"));
                    if (o2) {
                      c2 = b2.indexBuffer2, f3 = b2.segments2;
                      var E2 = [h2.drawingBufferWidth, h2.drawingBufferHeight];
                      u2 = "fillOutlinePattern" === l2 && d3 ? Pr(S2, t5, v2, x2, E2) : Cr(S2, E2);
                    } else
                      c2 = b2.indexBuffer, f3 = b2.segments, u2 = d3 ? Lr(S2, t5, v2, x2) : Er(S2);
                    w3.draw(t5.context, s2, i2, t5.stencilModeForClipping(m3), a2, Ct.disabled, u2, r4.id, b2.layoutVertexBuffer, c2, f3, r4.paint, t5.transform.zoom, _2);
                  }
                }
              }
            }
            function ln(t5, e4, r4, n4, i2, a2, o2) {
              for (var s2 = t5.context, l2 = s2.gl, u2 = r4.paint.get("fill-extrusion-pattern"), c2 = u2.constantOr(1), f3 = r4.getCrossfadeParameters(), h2 = r4.paint.get("fill-extrusion-opacity"), p3 = 0, d3 = n4; p3 < d3.length; p3 += 1) {
                var v2 = d3[p3], g3 = e4.getTile(v2), y2 = g3.getBucket(r4);
                if (y2) {
                  var m3 = y2.programConfigurations.get(r4.id), x2 = t5.useProgram(c2 ? "fillExtrusionPattern" : "fillExtrusion", m3);
                  c2 && (t5.context.activeTexture.set(l2.TEXTURE0), g3.imageAtlasTexture.bind(l2.LINEAR, l2.CLAMP_TO_EDGE), m3.updatePaintBuffers(f3));
                  var b2 = u2.constantOr(null);
                  if (b2 && g3.imageAtlas) {
                    var _2 = g3.imageAtlas, w3 = _2.patternPositions[b2.to.toString()], T2 = _2.patternPositions[b2.from.toString()];
                    w3 && T2 && m3.setConstantPatternPositions(w3, T2);
                  }
                  var k2 = t5.translatePosMatrix(v2.posMatrix, g3, r4.paint.get("fill-extrusion-translate"), r4.paint.get("fill-extrusion-translate-anchor")), A2 = r4.paint.get("fill-extrusion-vertical-gradient"), M2 = c2 ? Sr(k2, t5, A2, h2, v2, f3, g3) : Mr(k2, t5, A2, h2);
                  x2.draw(s2, s2.gl.TRIANGLES, i2, a2, o2, Ct.backCCW, M2, r4.id, y2.layoutVertexBuffer, y2.indexBuffer, y2.segments, r4.paint, t5.transform.zoom, m3);
                }
              }
            }
            function un(e4, r4, n4, i2, a2, o2) {
              var s2 = e4.context, l2 = s2.gl, u2 = r4.fbo;
              if (u2) {
                var c2 = e4.useProgram("hillshade");
                s2.activeTexture.set(l2.TEXTURE0), l2.bindTexture(l2.TEXTURE_2D, u2.colorAttachment.get());
                var f3 = function(e5, r5, n5) {
                  var i3 = n5.paint.get("hillshade-shadow-color"), a3 = n5.paint.get("hillshade-highlight-color"), o3 = n5.paint.get("hillshade-accent-color"), s3 = n5.paint.get("hillshade-illumination-direction") * (Math.PI / 180);
                  "viewport" === n5.paint.get("hillshade-illumination-anchor") && (s3 -= e5.transform.angle);
                  var l3, u3, c3, f4 = !e5.options.moving;
                  return { u_matrix: e5.transform.calculatePosMatrix(r5.tileID.toUnwrapped(), f4), u_image: 0, u_latrange: (l3 = r5.tileID, u3 = Math.pow(2, l3.canonical.z), c3 = l3.canonical.y, [new t4.MercatorCoordinate(0, c3 / u3).toLngLat().lat, new t4.MercatorCoordinate(0, (c3 + 1) / u3).toLngLat().lat]), u_light: [n5.paint.get("hillshade-exaggeration"), s3], u_shadow: i3, u_highlight: a3, u_accent: o3 };
                }(e4, r4, n4);
                c2.draw(s2, l2.TRIANGLES, i2, a2, o2, Ct.disabled, f3, n4.id, e4.rasterBoundsBuffer, e4.quadTriangleIndexBuffer, e4.rasterBoundsSegments);
              }
            }
            function cn(e4, r4, n4, i2, a2, o2, s2) {
              var l2 = e4.context, u2 = l2.gl, c2 = r4.dem;
              if (c2 && c2.data) {
                var f3 = c2.dim, h2 = c2.stride, p3 = c2.getPixels();
                if (l2.activeTexture.set(u2.TEXTURE1), l2.pixelStoreUnpackPremultiplyAlpha.set(false), r4.demTexture = r4.demTexture || e4.getTileTexture(h2), r4.demTexture) {
                  var d3 = r4.demTexture;
                  d3.update(p3, { premultiply: false }), d3.bind(u2.NEAREST, u2.CLAMP_TO_EDGE);
                } else
                  r4.demTexture = new t4.Texture(l2, p3, u2.RGBA, { premultiply: false }), r4.demTexture.bind(u2.NEAREST, u2.CLAMP_TO_EDGE);
                l2.activeTexture.set(u2.TEXTURE0);
                var v2 = r4.fbo;
                if (!v2) {
                  var g3 = new t4.Texture(l2, { width: f3, height: f3, data: null }, u2.RGBA);
                  g3.bind(u2.LINEAR, u2.CLAMP_TO_EDGE), (v2 = r4.fbo = l2.createFramebuffer(f3, f3, true)).colorAttachment.set(g3.texture);
                }
                l2.bindFramebuffer.set(v2.framebuffer), l2.viewport.set([0, 0, f3, f3]), e4.useProgram("hillshadePrepare").draw(l2, u2.TRIANGLES, a2, o2, s2, Ct.disabled, function(e5, r5, n5) {
                  var i3 = r5.stride, a3 = t4.create();
                  return t4.ortho(a3, 0, t4.EXTENT, -t4.EXTENT, 0, 0, 1), t4.translate(a3, a3, [0, -t4.EXTENT, 0]), { u_matrix: a3, u_image: 1, u_dimension: [i3, i3], u_zoom: e5.overscaledZ, u_maxzoom: n5, u_unpack: r5.getUnpackVector() };
                }(r4.tileID, c2, i2), n4.id, e4.rasterBoundsBuffer, e4.quadTriangleIndexBuffer, e4.rasterBoundsSegments), r4.needsHillshadePrepare = false;
              }
            }
            function fn(e4, r4, n4, i2, a2) {
              var o2 = i2.paint.get("raster-fade-duration");
              if (o2 > 0) {
                var s2 = t4.browser.now(), l2 = (s2 - e4.timeAdded) / o2, u2 = r4 ? (s2 - r4.timeAdded) / o2 : -1, c2 = n4.getSource(), f3 = a2.coveringZoomLevel({ tileSize: c2.tileSize, roundZoom: c2.roundZoom }), h2 = !r4 || Math.abs(r4.tileID.overscaledZ - f3) > Math.abs(e4.tileID.overscaledZ - f3), p3 = h2 && e4.refreshedUponExpiration ? 1 : t4.clamp(h2 ? l2 : 1 - u2, 0, 1);
                return e4.refreshedUponExpiration && l2 >= 1 && (e4.refreshedUponExpiration = false), r4 ? { opacity: 1, mix: 1 - p3 } : { opacity: p3, mix: 0 };
              }
              return { opacity: 1, mix: 0 };
            }
            var hn = new t4.Color(1, 0, 0, 1), pn = new t4.Color(0, 1, 0, 1), dn = new t4.Color(0, 0, 1, 1), vn = new t4.Color(1, 0, 1, 1), gn = new t4.Color(0, 1, 1, 1);
            function yn(t5) {
              var e4 = t5.transform.padding;
              mn(t5, t5.transform.height - (e4.top || 0), 3, hn), mn(t5, e4.bottom || 0, 3, pn), xn(t5, e4.left || 0, 3, dn), xn(t5, t5.transform.width - (e4.right || 0), 3, vn);
              var r4 = t5.transform.centerPoint;
              !function(t6, e5, r5, n4) {
                var i2 = 20, a2 = 2;
                bn(t6, e5 - a2 / 2, r5 - i2 / 2, a2, i2, n4), bn(t6, e5 - i2 / 2, r5 - a2 / 2, i2, a2, n4);
              }(t5, r4.x, t5.transform.height - r4.y, gn);
            }
            function mn(t5, e4, r4, n4) {
              bn(t5, 0, e4 + r4 / 2, t5.transform.width, r4, n4);
            }
            function xn(t5, e4, r4, n4) {
              bn(t5, e4 - r4 / 2, 0, r4, t5.transform.height, n4);
            }
            function bn(e4, r4, n4, i2, a2, o2) {
              var s2 = e4.context, l2 = s2.gl;
              l2.enable(l2.SCISSOR_TEST), l2.scissor(r4 * t4.browser.devicePixelRatio, n4 * t4.browser.devicePixelRatio, i2 * t4.browser.devicePixelRatio, a2 * t4.browser.devicePixelRatio), s2.clear({ color: o2 }), l2.disable(l2.SCISSOR_TEST);
            }
            function _n(e4, r4, n4) {
              var i2 = e4.context, a2 = i2.gl, o2 = n4.posMatrix, s2 = e4.useProgram("debug"), l2 = Mt.disabled, u2 = Et.disabled, c2 = e4.colorModeForRenderPass(), f3 = "$debug";
              i2.activeTexture.set(a2.TEXTURE0), e4.emptyTexture.bind(a2.LINEAR, a2.CLAMP_TO_EDGE), s2.draw(i2, a2.LINE_STRIP, l2, u2, c2, Ct.disabled, zr(o2, t4.Color.red), f3, e4.debugBuffer, e4.tileBorderIndexBuffer, e4.debugSegments);
              var h2 = r4.getTileByID(n4.key).latestRawTileData, p3 = h2 && h2.byteLength || 0, d3 = Math.floor(p3 / 1024), v2 = r4.getTile(n4).tileSize, g3 = 512 / Math.min(v2, 512) * (n4.overscaledZ / e4.transform.zoom) * 0.5, y2 = n4.canonical.toString();
              n4.overscaledZ !== n4.canonical.z && (y2 += " => " + n4.overscaledZ), function(t5, e5) {
                t5.initDebugOverlayCanvas();
                var r5 = t5.debugOverlayCanvas, n5 = t5.context.gl, i3 = t5.debugOverlayCanvas.getContext("2d");
                i3.clearRect(0, 0, r5.width, r5.height), i3.shadowColor = "white", i3.shadowBlur = 2, i3.lineWidth = 1.5, i3.strokeStyle = "white", i3.textBaseline = "top", i3.font = "bold 36px Open Sans, sans-serif", i3.fillText(e5, 5, 5), i3.strokeText(e5, 5, 5), t5.debugOverlayTexture.update(r5), t5.debugOverlayTexture.bind(n5.LINEAR, n5.CLAMP_TO_EDGE);
              }(e4, y2 + " " + d3 + "kb"), s2.draw(i2, a2.TRIANGLES, l2, u2, Lt.alphaBlended, Ct.disabled, zr(o2, t4.Color.transparent, g3), f3, e4.debugBuffer, e4.quadTriangleIndexBuffer, e4.debugSegments);
            }
            var wn = { symbol: function(e4, r4, n4, i2, a2) {
              if ("translucent" === e4.renderPass) {
                var o2 = Et.disabled, s2 = e4.colorModeForRenderPass();
                n4.layout.get("text-variable-anchor") && function(e5, r5, n5, i3, a3, o3, s3) {
                  for (var l2 = r5.transform, u2 = "map" === a3, c2 = "map" === o3, f3 = 0, h2 = e5; f3 < h2.length; f3 += 1) {
                    var p3 = h2[f3], d3 = i3.getTile(p3), v2 = d3.getBucket(n5);
                    if (v2 && v2.text && v2.text.segments.get().length) {
                      var g3 = v2.textSizeData, y2 = t4.evaluateSizeForZoom(g3, l2.zoom), m3 = ge(d3, 1, r5.transform.zoom), x2 = te(p3.posMatrix, c2, u2, r5.transform, m3), b2 = "none" !== n5.layout.get("icon-text-fit") && v2.hasIconData();
                      if (y2) {
                        var _2 = Math.pow(2, l2.zoom - d3.tileID.overscaledZ);
                        rn(v2, u2, c2, s3, t4.symbolSize, l2, x2, p3.posMatrix, _2, y2, b2);
                      }
                    }
                  }
                }(i2, e4, n4, r4, n4.layout.get("text-rotation-alignment"), n4.layout.get("text-pitch-alignment"), a2), 0 !== n4.paint.get("icon-opacity").constantOr(1) && an(e4, r4, n4, i2, false, n4.paint.get("icon-translate"), n4.paint.get("icon-translate-anchor"), n4.layout.get("icon-rotation-alignment"), n4.layout.get("icon-pitch-alignment"), n4.layout.get("icon-keep-upright"), o2, s2), 0 !== n4.paint.get("text-opacity").constantOr(1) && an(e4, r4, n4, i2, true, n4.paint.get("text-translate"), n4.paint.get("text-translate-anchor"), n4.layout.get("text-rotation-alignment"), n4.layout.get("text-pitch-alignment"), n4.layout.get("text-keep-upright"), o2, s2), r4.map.showCollisionBoxes && (Qr(e4, r4, n4, i2, n4.paint.get("text-translate"), n4.paint.get("text-translate-anchor"), true), Qr(e4, r4, n4, i2, n4.paint.get("icon-translate"), n4.paint.get("icon-translate-anchor"), false));
              }
            }, circle: function(e4, r4, n4, i2) {
              if ("translucent" === e4.renderPass) {
                var a2 = n4.paint.get("circle-opacity"), o2 = n4.paint.get("circle-stroke-width"), s2 = n4.paint.get("circle-stroke-opacity"), l2 = void 0 !== n4.layout.get("circle-sort-key").constantOr(1);
                if (0 !== a2.constantOr(1) || 0 !== o2.constantOr(1) && 0 !== s2.constantOr(1)) {
                  for (var u2 = e4.context, c2 = u2.gl, f3 = e4.depthModeForSublayer(0, Mt.ReadOnly), h2 = Et.disabled, p3 = e4.colorModeForRenderPass(), d3 = [], v2 = 0; v2 < i2.length; v2++) {
                    var g3 = i2[v2], y2 = r4.getTile(g3), m3 = y2.getBucket(n4);
                    if (m3) {
                      var x2 = m3.programConfigurations.get(n4.id), b2 = { programConfiguration: x2, program: e4.useProgram("circle", x2), layoutVertexBuffer: m3.layoutVertexBuffer, indexBuffer: m3.indexBuffer, uniformValues: Or(e4, g3, y2, n4) };
                      if (l2)
                        for (var _2 = 0, w3 = m3.segments.get(); _2 < w3.length; _2 += 1) {
                          var T2 = w3[_2];
                          d3.push({ segments: new t4.SegmentVector([T2]), sortKey: T2.sortKey, state: b2 });
                        }
                      else
                        d3.push({ segments: m3.segments, sortKey: 0, state: b2 });
                    }
                  }
                  l2 && d3.sort(function(t5, e5) {
                    return t5.sortKey - e5.sortKey;
                  });
                  for (var k2 = 0, A2 = d3; k2 < A2.length; k2 += 1) {
                    var M2 = A2[k2], S2 = M2.state, E2 = S2.programConfiguration, L2 = S2.program, C2 = S2.layoutVertexBuffer, P2 = S2.indexBuffer, O2 = S2.uniformValues, I2 = M2.segments;
                    L2.draw(u2, c2.TRIANGLES, f3, h2, p3, Ct.disabled, O2, n4.id, C2, P2, I2, n4.paint, e4.transform.zoom, E2);
                  }
                }
              }
            }, heatmap: function(e4, r4, n4, i2) {
              if (0 !== n4.paint.get("heatmap-opacity"))
                if ("offscreen" === e4.renderPass) {
                  var a2 = e4.context, o2 = a2.gl, s2 = Et.disabled, l2 = new Lt([o2.ONE, o2.ONE], t4.Color.transparent, [true, true, true, true]);
                  (function(t5, e5, r5) {
                    var n5 = t5.gl;
                    t5.activeTexture.set(n5.TEXTURE1), t5.viewport.set([0, 0, e5.width / 4, e5.height / 4]);
                    var i3 = r5.heatmapFbo;
                    if (i3)
                      n5.bindTexture(n5.TEXTURE_2D, i3.colorAttachment.get()), t5.bindFramebuffer.set(i3.framebuffer);
                    else {
                      var a3 = n5.createTexture();
                      n5.bindTexture(n5.TEXTURE_2D, a3), n5.texParameteri(n5.TEXTURE_2D, n5.TEXTURE_WRAP_S, n5.CLAMP_TO_EDGE), n5.texParameteri(n5.TEXTURE_2D, n5.TEXTURE_WRAP_T, n5.CLAMP_TO_EDGE), n5.texParameteri(n5.TEXTURE_2D, n5.TEXTURE_MIN_FILTER, n5.LINEAR), n5.texParameteri(n5.TEXTURE_2D, n5.TEXTURE_MAG_FILTER, n5.LINEAR), i3 = r5.heatmapFbo = t5.createFramebuffer(e5.width / 4, e5.height / 4, false), function(t6, e6, r6, n6) {
                        var i4 = t6.gl, a4 = t6.extRenderToTextureHalfFloat ? t6.extTextureHalfFloat.HALF_FLOAT_OES : i4.UNSIGNED_BYTE;
                        i4.texImage2D(i4.TEXTURE_2D, 0, i4.RGBA, e6.width / 4, e6.height / 4, 0, i4.RGBA, a4, null), n6.colorAttachment.set(r6);
                      }(t5, e5, a3, i3);
                    }
                  })(a2, e4, n4), a2.clear({ color: t4.Color.transparent });
                  for (var u2 = 0; u2 < i2.length; u2++) {
                    var c2 = i2[u2];
                    if (!r4.hasRenderableParent(c2)) {
                      var f3 = r4.getTile(c2), h2 = f3.getBucket(n4);
                      if (h2) {
                        var p3 = h2.programConfigurations.get(n4.id), d3 = e4.useProgram("heatmap", p3), v2 = e4.transform.zoom;
                        d3.draw(a2, o2.TRIANGLES, Mt.disabled, s2, l2, Ct.disabled, Fr(c2.posMatrix, f3, v2, n4.paint.get("heatmap-intensity")), n4.id, h2.layoutVertexBuffer, h2.indexBuffer, h2.segments, n4.paint, e4.transform.zoom, p3);
                      }
                    }
                  }
                  a2.viewport.set([0, 0, e4.width, e4.height]);
                } else
                  "translucent" === e4.renderPass && (e4.context.setColorMode(e4.colorModeForRenderPass()), function(e5, r5) {
                    var n5 = e5.context, i3 = n5.gl, a3 = r5.heatmapFbo;
                    if (a3) {
                      n5.activeTexture.set(i3.TEXTURE0), i3.bindTexture(i3.TEXTURE_2D, a3.colorAttachment.get()), n5.activeTexture.set(i3.TEXTURE1);
                      var o3 = r5.colorRampTexture;
                      o3 || (o3 = r5.colorRampTexture = new t4.Texture(n5, r5.colorRamp, i3.RGBA)), o3.bind(i3.LINEAR, i3.CLAMP_TO_EDGE), e5.useProgram("heatmapTexture").draw(n5, i3.TRIANGLES, Mt.disabled, Et.disabled, e5.colorModeForRenderPass(), Ct.disabled, function(e6, r6, n6, i4) {
                        var a4 = t4.create();
                        t4.ortho(a4, 0, e6.width, e6.height, 0, 0, 1);
                        var o4 = e6.context.gl;
                        return { u_matrix: a4, u_world: [o4.drawingBufferWidth, o4.drawingBufferHeight], u_image: n6, u_color_ramp: i4, u_opacity: r6.paint.get("heatmap-opacity") };
                      }(e5, r5, 0, 1), r5.id, e5.viewportBuffer, e5.quadTriangleIndexBuffer, e5.viewportSegments, r5.paint, e5.transform.zoom);
                    }
                  }(e4, n4));
            }, line: function(e4, r4, n4, i2) {
              if ("translucent" === e4.renderPass) {
                var a2 = n4.paint.get("line-opacity"), o2 = n4.paint.get("line-width");
                if (0 !== a2.constantOr(1) && 0 !== o2.constantOr(1)) {
                  var s2 = e4.depthModeForSublayer(0, Mt.ReadOnly), l2 = e4.colorModeForRenderPass(), u2 = n4.paint.get("line-dasharray"), c2 = n4.paint.get("line-pattern"), f3 = c2.constantOr(1), h2 = n4.paint.get("line-gradient"), p3 = n4.getCrossfadeParameters(), d3 = f3 ? "linePattern" : u2 ? "lineSDF" : h2 ? "lineGradient" : "line", v2 = e4.context, g3 = v2.gl, y2 = true;
                  if (h2) {
                    v2.activeTexture.set(g3.TEXTURE0);
                    var m3 = n4.gradientTexture;
                    if (!n4.gradient)
                      return;
                    m3 || (m3 = n4.gradientTexture = new t4.Texture(v2, n4.gradient, g3.RGBA)), m3.bind(g3.LINEAR, g3.CLAMP_TO_EDGE);
                  }
                  for (var x2 = 0, b2 = i2; x2 < b2.length; x2 += 1) {
                    var _2 = b2[x2], w3 = r4.getTile(_2);
                    if (!f3 || w3.patternsLoaded()) {
                      var T2 = w3.getBucket(n4);
                      if (T2) {
                        var k2 = T2.programConfigurations.get(n4.id), A2 = e4.context.program.get(), M2 = e4.useProgram(d3, k2), S2 = y2 || M2.program !== A2, E2 = c2.constantOr(null);
                        if (E2 && w3.imageAtlas) {
                          var L2 = w3.imageAtlas, C2 = L2.patternPositions[E2.to.toString()], P2 = L2.patternPositions[E2.from.toString()];
                          C2 && P2 && k2.setConstantPatternPositions(C2, P2);
                        }
                        var O2 = f3 ? jr(e4, w3, n4, p3) : u2 ? Ur(e4, w3, n4, u2, p3) : h2 ? Nr(e4, w3, n4) : Br(e4, w3, n4);
                        f3 ? (v2.activeTexture.set(g3.TEXTURE0), w3.imageAtlasTexture.bind(g3.LINEAR, g3.CLAMP_TO_EDGE), k2.updatePaintBuffers(p3)) : u2 && (S2 || e4.lineAtlas.dirty) && (v2.activeTexture.set(g3.TEXTURE0), e4.lineAtlas.bind(v2)), M2.draw(v2, g3.TRIANGLES, s2, e4.stencilModeForClipping(_2), l2, Ct.disabled, O2, n4.id, T2.layoutVertexBuffer, T2.indexBuffer, T2.segments, n4.paint, e4.transform.zoom, k2), y2 = false;
                      }
                    }
                  }
                }
              }
            }, fill: function(e4, r4, n4, i2) {
              var a2 = n4.paint.get("fill-color"), o2 = n4.paint.get("fill-opacity");
              if (0 !== o2.constantOr(1)) {
                var s2 = e4.colorModeForRenderPass(), l2 = n4.paint.get("fill-pattern"), u2 = e4.opaquePassEnabledForLayer() && !l2.constantOr(1) && 1 === a2.constantOr(t4.Color.transparent).a && 1 === o2.constantOr(0) ? "opaque" : "translucent";
                if (e4.renderPass === u2) {
                  var c2 = e4.depthModeForSublayer(1, "opaque" === e4.renderPass ? Mt.ReadWrite : Mt.ReadOnly);
                  sn(e4, r4, n4, i2, c2, s2, false);
                }
                if ("translucent" === e4.renderPass && n4.paint.get("fill-antialias")) {
                  var f3 = e4.depthModeForSublayer(n4.getPaintProperty("fill-outline-color") ? 2 : 0, Mt.ReadOnly);
                  sn(e4, r4, n4, i2, f3, s2, true);
                }
              }
            }, "fill-extrusion": function(t5, e4, r4, n4) {
              var i2 = r4.paint.get("fill-extrusion-opacity");
              if (0 !== i2 && "translucent" === t5.renderPass) {
                var a2 = new Mt(t5.context.gl.LEQUAL, Mt.ReadWrite, t5.depthRangeFor3D);
                if (1 !== i2 || r4.paint.get("fill-extrusion-pattern").constantOr(1))
                  ln(t5, e4, r4, n4, a2, Et.disabled, Lt.disabled), ln(t5, e4, r4, n4, a2, t5.stencilModeFor3D(), t5.colorModeForRenderPass());
                else {
                  var o2 = t5.colorModeForRenderPass();
                  ln(t5, e4, r4, n4, a2, Et.disabled, o2);
                }
              }
            }, hillshade: function(t5, e4, r4, n4) {
              if ("offscreen" === t5.renderPass || "translucent" === t5.renderPass) {
                for (var i2 = t5.context, a2 = e4.getSource().maxzoom, o2 = t5.depthModeForSublayer(0, Mt.ReadOnly), s2 = t5.colorModeForRenderPass(), l2 = "translucent" === t5.renderPass ? t5.stencilConfigForOverlap(n4) : [{}, n4], u2 = l2[0], c2 = 0, f3 = l2[1]; c2 < f3.length; c2 += 1) {
                  var h2 = f3[c2], p3 = e4.getTile(h2);
                  p3.needsHillshadePrepare && "offscreen" === t5.renderPass ? cn(t5, p3, r4, a2, o2, Et.disabled, s2) : "translucent" === t5.renderPass && un(t5, p3, r4, o2, u2[h2.overscaledZ], s2);
                }
                i2.viewport.set([0, 0, t5.width, t5.height]);
              }
            }, raster: function(t5, e4, r4, n4) {
              if ("translucent" === t5.renderPass && 0 !== r4.paint.get("raster-opacity") && n4.length)
                for (var i2 = t5.context, a2 = i2.gl, o2 = e4.getSource(), s2 = t5.useProgram("raster"), l2 = t5.colorModeForRenderPass(), u2 = o2 instanceof I ? [{}, n4] : t5.stencilConfigForOverlap(n4), c2 = u2[0], f3 = u2[1], h2 = f3[f3.length - 1].overscaledZ, p3 = !t5.options.moving, d3 = 0, v2 = f3; d3 < v2.length; d3 += 1) {
                  var g3 = v2[d3], y2 = t5.depthModeForSublayer(g3.overscaledZ - h2, 1 === r4.paint.get("raster-opacity") ? Mt.ReadWrite : Mt.ReadOnly, a2.LESS), m3 = e4.getTile(g3), x2 = t5.transform.calculatePosMatrix(g3.toUnwrapped(), p3);
                  m3.registerFadeDuration(r4.paint.get("raster-fade-duration"));
                  var b2 = e4.findLoadedParent(g3, 0), _2 = fn(m3, b2, e4, r4, t5.transform), w3 = void 0, T2 = void 0, k2 = "nearest" === r4.paint.get("raster-resampling") ? a2.NEAREST : a2.LINEAR;
                  i2.activeTexture.set(a2.TEXTURE0), m3.texture.bind(k2, a2.CLAMP_TO_EDGE, a2.LINEAR_MIPMAP_NEAREST), i2.activeTexture.set(a2.TEXTURE1), b2 ? (b2.texture.bind(k2, a2.CLAMP_TO_EDGE, a2.LINEAR_MIPMAP_NEAREST), w3 = Math.pow(2, b2.tileID.overscaledZ - m3.tileID.overscaledZ), T2 = [m3.tileID.canonical.x * w3 % 1, m3.tileID.canonical.y * w3 % 1]) : m3.texture.bind(k2, a2.CLAMP_TO_EDGE, a2.LINEAR_MIPMAP_NEAREST);
                  var A2 = qr(x2, T2 || [0, 0], w3 || 1, _2, r4);
                  o2 instanceof I ? s2.draw(i2, a2.TRIANGLES, y2, Et.disabled, l2, Ct.disabled, A2, r4.id, o2.boundsBuffer, t5.quadTriangleIndexBuffer, o2.boundsSegments) : s2.draw(i2, a2.TRIANGLES, y2, c2[g3.overscaledZ], l2, Ct.disabled, A2, r4.id, t5.rasterBoundsBuffer, t5.quadTriangleIndexBuffer, t5.rasterBoundsSegments);
                }
            }, background: function(t5, e4, r4) {
              var n4 = r4.paint.get("background-color"), i2 = r4.paint.get("background-opacity");
              if (0 !== i2) {
                var a2 = t5.context, o2 = a2.gl, s2 = t5.transform, l2 = s2.tileSize, u2 = r4.paint.get("background-pattern");
                if (!t5.isPatternMissing(u2)) {
                  var c2 = !u2 && 1 === n4.a && 1 === i2 && t5.opaquePassEnabledForLayer() ? "opaque" : "translucent";
                  if (t5.renderPass === c2) {
                    var f3 = Et.disabled, h2 = t5.depthModeForSublayer(0, "opaque" === c2 ? Mt.ReadWrite : Mt.ReadOnly), p3 = t5.colorModeForRenderPass(), d3 = t5.useProgram(u2 ? "backgroundPattern" : "background"), v2 = s2.coveringTiles({ tileSize: l2 });
                    u2 && (a2.activeTexture.set(o2.TEXTURE0), t5.imageManager.bind(t5.context));
                    for (var g3 = r4.getCrossfadeParameters(), y2 = 0, m3 = v2; y2 < m3.length; y2 += 1) {
                      var x2 = m3[y2], b2 = t5.transform.calculatePosMatrix(x2.toUnwrapped()), _2 = u2 ? Kr(b2, i2, t5, u2, { tileID: x2, tileSize: l2 }, g3) : Jr(b2, i2, n4);
                      d3.draw(a2, o2.TRIANGLES, h2, f3, p3, Ct.disabled, _2, r4.id, t5.tileExtentBuffer, t5.quadTriangleIndexBuffer, t5.tileExtentSegments);
                    }
                  }
                }
              }
            }, debug: function(t5, e4, r4) {
              for (var n4 = 0; n4 < r4.length; n4++)
                _n(t5, e4, r4[n4]);
            }, custom: function(t5, e4, r4) {
              var n4 = t5.context, i2 = r4.implementation;
              if ("offscreen" === t5.renderPass) {
                var a2 = i2.prerender;
                a2 && (t5.setCustomLayerDefaults(), n4.setColorMode(t5.colorModeForRenderPass()), a2.call(i2, n4.gl, t5.transform.customLayerMatrix()), n4.setDirty(), t5.setBaseState());
              } else if ("translucent" === t5.renderPass) {
                t5.setCustomLayerDefaults(), n4.setColorMode(t5.colorModeForRenderPass()), n4.setStencilMode(Et.disabled);
                var o2 = "3d" === i2.renderingMode ? new Mt(t5.context.gl.LEQUAL, Mt.ReadWrite, t5.depthRangeFor3D) : t5.depthModeForSublayer(0, Mt.ReadOnly);
                n4.setDepthMode(o2), i2.render(n4.gl, t5.transform.customLayerMatrix()), n4.setDirty(), t5.setBaseState(), n4.bindFramebuffer.set(null);
              }
            } }, Tn = function(t5, e4) {
              this.context = new Pt(t5), this.transform = e4, this._tileTextures = {}, this.setup(), this.numSublayers = Ot.maxUnderzooming + Ot.maxOverzooming + 1, this.depthEpsilon = 1 / Math.pow(2, 16), this.crossTileSymbolIndex = new Ve(), this.gpuTimers = {};
            };
            Tn.prototype.resize = function(e4, r4) {
              if (this.width = e4 * t4.browser.devicePixelRatio, this.height = r4 * t4.browser.devicePixelRatio, this.context.viewport.set([0, 0, this.width, this.height]), this.style)
                for (var n4 = 0, i2 = this.style._order; n4 < i2.length; n4 += 1) {
                  var a2 = i2[n4];
                  this.style._layers[a2].resize();
                }
            }, Tn.prototype.setup = function() {
              var e4 = this.context, r4 = new t4.StructArrayLayout2i4();
              r4.emplaceBack(0, 0), r4.emplaceBack(t4.EXTENT, 0), r4.emplaceBack(0, t4.EXTENT), r4.emplaceBack(t4.EXTENT, t4.EXTENT), this.tileExtentBuffer = e4.createVertexBuffer(r4, We.members), this.tileExtentSegments = t4.SegmentVector.simpleSegment(0, 0, 4, 2);
              var n4 = new t4.StructArrayLayout2i4();
              n4.emplaceBack(0, 0), n4.emplaceBack(t4.EXTENT, 0), n4.emplaceBack(0, t4.EXTENT), n4.emplaceBack(t4.EXTENT, t4.EXTENT), this.debugBuffer = e4.createVertexBuffer(n4, We.members), this.debugSegments = t4.SegmentVector.simpleSegment(0, 0, 4, 5);
              var i2 = new t4.StructArrayLayout4i8();
              i2.emplaceBack(0, 0, 0, 0), i2.emplaceBack(t4.EXTENT, 0, t4.EXTENT, 0), i2.emplaceBack(0, t4.EXTENT, 0, t4.EXTENT), i2.emplaceBack(t4.EXTENT, t4.EXTENT, t4.EXTENT, t4.EXTENT), this.rasterBoundsBuffer = e4.createVertexBuffer(i2, O.members), this.rasterBoundsSegments = t4.SegmentVector.simpleSegment(0, 0, 4, 2);
              var a2 = new t4.StructArrayLayout2i4();
              a2.emplaceBack(0, 0), a2.emplaceBack(1, 0), a2.emplaceBack(0, 1), a2.emplaceBack(1, 1), this.viewportBuffer = e4.createVertexBuffer(a2, We.members), this.viewportSegments = t4.SegmentVector.simpleSegment(0, 0, 4, 2);
              var o2 = new t4.StructArrayLayout1ui2();
              o2.emplaceBack(0), o2.emplaceBack(1), o2.emplaceBack(3), o2.emplaceBack(2), o2.emplaceBack(0), this.tileBorderIndexBuffer = e4.createIndexBuffer(o2);
              var s2 = new t4.StructArrayLayout3ui6();
              s2.emplaceBack(0, 1, 2), s2.emplaceBack(2, 1, 3), this.quadTriangleIndexBuffer = e4.createIndexBuffer(s2), this.emptyTexture = new t4.Texture(e4, { width: 1, height: 1, data: new Uint8Array([0, 0, 0, 0]) }, e4.gl.RGBA);
              var l2 = this.context.gl;
              this.stencilClearMode = new Et({ func: l2.ALWAYS, mask: 0 }, 0, 255, l2.ZERO, l2.ZERO, l2.ZERO);
            }, Tn.prototype.clearStencil = function() {
              var e4 = this.context, r4 = e4.gl;
              this.nextStencilID = 1, this.currentStencilSource = void 0;
              var n4 = t4.create();
              t4.ortho(n4, 0, this.width, this.height, 0, 0, 1), t4.scale(n4, n4, [r4.drawingBufferWidth, r4.drawingBufferHeight, 0]), this.useProgram("clippingMask").draw(e4, r4.TRIANGLES, Mt.disabled, this.stencilClearMode, Lt.disabled, Ct.disabled, Rr(n4), "$clipping", this.viewportBuffer, this.quadTriangleIndexBuffer, this.viewportSegments);
            }, Tn.prototype._renderTileClippingMasks = function(t5, e4) {
              if (this.currentStencilSource !== t5.source && t5.isTileClipped() && e4 && e4.length) {
                this.currentStencilSource = t5.source;
                var r4 = this.context, n4 = r4.gl;
                this.nextStencilID + e4.length > 256 && this.clearStencil(), r4.setColorMode(Lt.disabled), r4.setDepthMode(Mt.disabled);
                var i2 = this.useProgram("clippingMask");
                this._tileClippingMaskIDs = {};
                for (var a2 = 0, o2 = e4; a2 < o2.length; a2 += 1) {
                  var s2 = o2[a2], l2 = this._tileClippingMaskIDs[s2.key] = this.nextStencilID++;
                  i2.draw(r4, n4.TRIANGLES, Mt.disabled, new Et({ func: n4.ALWAYS, mask: 0 }, l2, 255, n4.KEEP, n4.KEEP, n4.REPLACE), Lt.disabled, Ct.disabled, Rr(s2.posMatrix), "$clipping", this.tileExtentBuffer, this.quadTriangleIndexBuffer, this.tileExtentSegments);
                }
              }
            }, Tn.prototype.stencilModeFor3D = function() {
              this.currentStencilSource = void 0, this.nextStencilID + 1 > 256 && this.clearStencil();
              var t5 = this.nextStencilID++, e4 = this.context.gl;
              return new Et({ func: e4.NOTEQUAL, mask: 255 }, t5, 255, e4.KEEP, e4.KEEP, e4.REPLACE);
            }, Tn.prototype.stencilModeForClipping = function(t5) {
              var e4 = this.context.gl;
              return new Et({ func: e4.EQUAL, mask: 255 }, this._tileClippingMaskIDs[t5.key], 0, e4.KEEP, e4.KEEP, e4.REPLACE);
            }, Tn.prototype.stencilConfigForOverlap = function(t5) {
              var e4, r4 = this.context.gl, n4 = t5.sort(function(t6, e5) {
                return e5.overscaledZ - t6.overscaledZ;
              }), i2 = n4[n4.length - 1].overscaledZ, a2 = n4[0].overscaledZ - i2 + 1;
              if (a2 > 1) {
                this.currentStencilSource = void 0, this.nextStencilID + a2 > 256 && this.clearStencil();
                for (var o2 = {}, s2 = 0; s2 < a2; s2++)
                  o2[s2 + i2] = new Et({ func: r4.GEQUAL, mask: 255 }, s2 + this.nextStencilID, 255, r4.KEEP, r4.KEEP, r4.REPLACE);
                return this.nextStencilID += a2, [o2, n4];
              }
              return [(e4 = {}, e4[i2] = Et.disabled, e4), n4];
            }, Tn.prototype.colorModeForRenderPass = function() {
              var e4 = this.context.gl;
              if (this._showOverdrawInspector) {
                var r4 = 1 / 8;
                return new Lt([e4.CONSTANT_COLOR, e4.ONE], new t4.Color(r4, r4, r4, 0), [true, true, true, true]);
              }
              return "opaque" === this.renderPass ? Lt.unblended : Lt.alphaBlended;
            }, Tn.prototype.depthModeForSublayer = function(t5, e4, r4) {
              if (!this.opaquePassEnabledForLayer())
                return Mt.disabled;
              var n4 = 1 - ((1 + this.currentLayer) * this.numSublayers + t5) * this.depthEpsilon;
              return new Mt(r4 || this.context.gl.LEQUAL, e4, [n4, n4]);
            }, Tn.prototype.opaquePassEnabledForLayer = function() {
              return this.currentLayer < this.opaquePassCutoff;
            }, Tn.prototype.render = function(e4, r4) {
              var n4 = this;
              this.style = e4, this.options = r4, this.lineAtlas = e4.lineAtlas, this.imageManager = e4.imageManager, this.glyphManager = e4.glyphManager, this.symbolFadeChange = e4.placement.symbolFadeChange(t4.browser.now()), this.imageManager.beginFrame();
              var i2 = this.style._order, a2 = this.style.sourceCaches;
              for (var o2 in a2) {
                var s2 = a2[o2];
                s2.used && s2.prepare(this.context);
              }
              var l2, u2, c2 = {}, f3 = {}, h2 = {};
              for (var p3 in a2) {
                var d3 = a2[p3];
                c2[p3] = d3.getVisibleCoordinates(), f3[p3] = c2[p3].slice().reverse(), h2[p3] = d3.getVisibleCoordinates(true).reverse();
              }
              this.opaquePassCutoff = 1 / 0;
              for (var v2 = 0; v2 < i2.length; v2++) {
                var g3 = i2[v2];
                if (this.style._layers[g3].is3D()) {
                  this.opaquePassCutoff = v2;
                  break;
                }
              }
              this.renderPass = "offscreen";
              for (var y2 = 0, m3 = i2; y2 < m3.length; y2 += 1) {
                var x2 = m3[y2], b2 = this.style._layers[x2];
                if (b2.hasOffscreenPass() && !b2.isHidden(this.transform.zoom)) {
                  var _2 = f3[b2.source];
                  ("custom" === b2.type || _2.length) && this.renderLayer(this, a2[b2.source], b2, _2);
                }
              }
              for (this.context.bindFramebuffer.set(null), this.context.clear({ color: r4.showOverdrawInspector ? t4.Color.black : t4.Color.transparent, depth: 1 }), this.clearStencil(), this._showOverdrawInspector = r4.showOverdrawInspector, this.depthRangeFor3D = [0, 1 - (e4._order.length + 2) * this.numSublayers * this.depthEpsilon], this.renderPass = "opaque", this.currentLayer = i2.length - 1; this.currentLayer >= 0; this.currentLayer--) {
                var w3 = this.style._layers[i2[this.currentLayer]], T2 = a2[w3.source], k2 = c2[w3.source];
                this._renderTileClippingMasks(w3, k2), this.renderLayer(this, T2, w3, k2);
              }
              for (this.renderPass = "translucent", this.currentLayer = 0; this.currentLayer < i2.length; this.currentLayer++) {
                var A2 = this.style._layers[i2[this.currentLayer]], M2 = a2[A2.source], S2 = ("symbol" === A2.type ? h2 : f3)[A2.source];
                this._renderTileClippingMasks(A2, c2[A2.source]), this.renderLayer(this, M2, A2, S2);
              }
              this.options.showTileBoundaries && (t4.values(this.style._layers).forEach(function(t5) {
                t5.source && !t5.isHidden(n4.transform.zoom) && (t5.source !== (u2 && u2.id) && (u2 = n4.style.sourceCaches[t5.source]), (!l2 || l2.getSource().maxzoom < u2.getSource().maxzoom) && (l2 = u2));
              }), l2 && wn.debug(this, l2, l2.getVisibleCoordinates())), this.options.showPadding && yn(this), this.context.setDefault();
            }, Tn.prototype.renderLayer = function(t5, e4, r4, n4) {
              r4.isHidden(this.transform.zoom) || ("background" === r4.type || "custom" === r4.type || n4.length) && (this.id = r4.id, this.gpuTimingStart(r4), wn[r4.type](t5, e4, r4, n4, this.style.placement.variableOffsets), this.gpuTimingEnd());
            }, Tn.prototype.gpuTimingStart = function(t5) {
              if (this.options.gpuTiming) {
                var e4 = this.context.extTimerQuery, r4 = this.gpuTimers[t5.id];
                r4 || (r4 = this.gpuTimers[t5.id] = { calls: 0, cpuTime: 0, query: e4.createQueryEXT() }), r4.calls++, e4.beginQueryEXT(e4.TIME_ELAPSED_EXT, r4.query);
              }
            }, Tn.prototype.gpuTimingEnd = function() {
              if (this.options.gpuTiming) {
                var t5 = this.context.extTimerQuery;
                t5.endQueryEXT(t5.TIME_ELAPSED_EXT);
              }
            }, Tn.prototype.collectGpuTimers = function() {
              var t5 = this.gpuTimers;
              return this.gpuTimers = {}, t5;
            }, Tn.prototype.queryGpuTimers = function(t5) {
              var e4 = {};
              for (var r4 in t5) {
                var n4 = t5[r4], i2 = this.context.extTimerQuery, a2 = i2.getQueryObjectEXT(n4.query, i2.QUERY_RESULT_EXT) / 1e6;
                i2.deleteQueryEXT(n4.query), e4[r4] = a2;
              }
              return e4;
            }, Tn.prototype.translatePosMatrix = function(e4, r4, n4, i2, a2) {
              if (!n4[0] && !n4[1])
                return e4;
              var o2 = a2 ? "map" === i2 ? this.transform.angle : 0 : "viewport" === i2 ? -this.transform.angle : 0;
              if (o2) {
                var s2 = Math.sin(o2), l2 = Math.cos(o2);
                n4 = [n4[0] * l2 - n4[1] * s2, n4[0] * s2 + n4[1] * l2];
              }
              var u2 = [a2 ? n4[0] : ge(r4, n4[0], this.transform.zoom), a2 ? n4[1] : ge(r4, n4[1], this.transform.zoom), 0], c2 = new Float32Array(16);
              return t4.translate(c2, e4, u2), c2;
            }, Tn.prototype.saveTileTexture = function(t5) {
              var e4 = this._tileTextures[t5.size[0]];
              e4 ? e4.push(t5) : this._tileTextures[t5.size[0]] = [t5];
            }, Tn.prototype.getTileTexture = function(t5) {
              var e4 = this._tileTextures[t5];
              return e4 && e4.length > 0 ? e4.pop() : null;
            }, Tn.prototype.isPatternMissing = function(t5) {
              if (!t5)
                return false;
              if (!t5.from || !t5.to)
                return true;
              var e4 = this.imageManager.getPattern(t5.from.toString()), r4 = this.imageManager.getPattern(t5.to.toString());
              return !e4 || !r4;
            }, Tn.prototype.useProgram = function(t5, e4) {
              this.cache = this.cache || {};
              var r4 = "" + t5 + (e4 ? e4.cacheKey : "") + (this._showOverdrawInspector ? "/overdraw" : "");
              return this.cache[r4] || (this.cache[r4] = new kr(this.context, wr[t5], e4, $r[t5], this._showOverdrawInspector)), this.cache[r4];
            }, Tn.prototype.setCustomLayerDefaults = function() {
              this.context.unbindVAO(), this.context.cullFace.setDefault(), this.context.activeTexture.setDefault(), this.context.pixelStoreUnpack.setDefault(), this.context.pixelStoreUnpackPremultiplyAlpha.setDefault(), this.context.pixelStoreUnpackFlipY.setDefault();
            }, Tn.prototype.setBaseState = function() {
              var t5 = this.context.gl;
              this.context.cullFace.set(false), this.context.viewport.set([0, 0, this.width, this.height]), this.context.blendEquation.set(t5.FUNC_ADD);
            }, Tn.prototype.initDebugOverlayCanvas = function() {
              if (null == this.debugOverlayCanvas) {
                this.debugOverlayCanvas = t4.window.document.createElement("canvas"), this.debugOverlayCanvas.width = 512, this.debugOverlayCanvas.height = 512;
                var e4 = this.context.gl;
                this.debugOverlayTexture = new t4.Texture(this.context, this.debugOverlayCanvas, e4.RGBA);
              }
            }, Tn.prototype.destroy = function() {
              this.emptyTexture.destroy(), this.debugOverlayTexture && this.debugOverlayTexture.destroy();
            };
            var kn = function(t5, e4) {
              this.points = t5, this.planes = e4;
            };
            kn.fromInvProjectionMatrix = function(e4, r4, n4) {
              var i2 = Math.pow(2, n4), a2 = [[-1, 1, -1, 1], [1, 1, -1, 1], [1, -1, -1, 1], [-1, -1, -1, 1], [-1, 1, 1, 1], [1, 1, 1, 1], [1, -1, 1, 1], [-1, -1, 1, 1]].map(function(r5) {
                return t4.transformMat4([], r5, e4);
              }).map(function(e5) {
                return t4.scale$1([], e5, 1 / e5[3] / r4 * i2);
              }), o2 = [[0, 1, 2], [6, 5, 4], [0, 3, 7], [2, 1, 5], [3, 2, 6], [0, 4, 5]].map(function(e5) {
                var r5 = t4.sub([], a2[e5[0]], a2[e5[1]]), n5 = t4.sub([], a2[e5[2]], a2[e5[1]]), i3 = t4.normalize([], t4.cross([], r5, n5)), o3 = -t4.dot(i3, a2[e5[1]]);
                return i3.concat(o3);
              });
              return new kn(a2, o2);
            };
            var An = function(e4, r4) {
              this.min = e4, this.max = r4, this.center = t4.scale$2([], t4.add([], this.min, this.max), 0.5);
            };
            An.prototype.quadrant = function(e4) {
              for (var r4 = [e4 % 2 == 0, e4 < 2], n4 = t4.clone$2(this.min), i2 = t4.clone$2(this.max), a2 = 0; a2 < r4.length; a2++)
                n4[a2] = r4[a2] ? this.min[a2] : this.center[a2], i2[a2] = r4[a2] ? this.center[a2] : this.max[a2];
              return i2[2] = this.max[2], new An(n4, i2);
            }, An.prototype.distanceX = function(t5) {
              return Math.max(Math.min(this.max[0], t5[0]), this.min[0]) - t5[0];
            }, An.prototype.distanceY = function(t5) {
              return Math.max(Math.min(this.max[1], t5[1]), this.min[1]) - t5[1];
            }, An.prototype.intersects = function(e4) {
              for (var r4 = [[this.min[0], this.min[1], 0, 1], [this.max[0], this.min[1], 0, 1], [this.max[0], this.max[1], 0, 1], [this.min[0], this.max[1], 0, 1]], n4 = true, i2 = 0; i2 < e4.planes.length; i2++) {
                for (var a2 = e4.planes[i2], o2 = 0, s2 = 0; s2 < r4.length; s2++)
                  o2 += t4.dot$1(a2, r4[s2]) >= 0;
                if (0 === o2)
                  return 0;
                o2 !== r4.length && (n4 = false);
              }
              if (n4)
                return 2;
              for (var l2 = 0; l2 < 3; l2++) {
                for (var u2 = Number.MAX_VALUE, c2 = -Number.MAX_VALUE, f3 = 0; f3 < e4.points.length; f3++) {
                  var h2 = e4.points[f3][l2] - this.min[l2];
                  u2 = Math.min(u2, h2), c2 = Math.max(c2, h2);
                }
                if (c2 < 0 || u2 > this.max[l2] - this.min[l2])
                  return 0;
              }
              return 1;
            };
            var Mn = function(t5, e4, r4, n4) {
              if (void 0 === t5 && (t5 = 0), void 0 === e4 && (e4 = 0), void 0 === r4 && (r4 = 0), void 0 === n4 && (n4 = 0), isNaN(t5) || t5 < 0 || isNaN(e4) || e4 < 0 || isNaN(r4) || r4 < 0 || isNaN(n4) || n4 < 0)
                throw new Error("Invalid value for edge-insets, top, bottom, left and right must all be numbers");
              this.top = t5, this.bottom = e4, this.left = r4, this.right = n4;
            };
            Mn.prototype.interpolate = function(e4, r4, n4) {
              return null != r4.top && null != e4.top && (this.top = t4.number(e4.top, r4.top, n4)), null != r4.bottom && null != e4.bottom && (this.bottom = t4.number(e4.bottom, r4.bottom, n4)), null != r4.left && null != e4.left && (this.left = t4.number(e4.left, r4.left, n4)), null != r4.right && null != e4.right && (this.right = t4.number(e4.right, r4.right, n4)), this;
            }, Mn.prototype.getCenter = function(e4, r4) {
              var n4 = t4.clamp((this.left + e4 - this.right) / 2, 0, e4), i2 = t4.clamp((this.top + r4 - this.bottom) / 2, 0, r4);
              return new t4.Point(n4, i2);
            }, Mn.prototype.equals = function(t5) {
              return this.top === t5.top && this.bottom === t5.bottom && this.left === t5.left && this.right === t5.right;
            }, Mn.prototype.clone = function() {
              return new Mn(this.top, this.bottom, this.left, this.right);
            }, Mn.prototype.toJSON = function() {
              return { top: this.top, bottom: this.bottom, left: this.left, right: this.right };
            };
            var Sn = function(e4, r4, n4, i2, a2) {
              this.tileSize = 512, this.maxValidLatitude = 85.051129, this._renderWorldCopies = void 0 === a2 || a2, this._minZoom = e4 || 0, this._maxZoom = r4 || 22, this._minPitch = null == n4 ? 0 : n4, this._maxPitch = null == i2 ? 60 : i2, this.setMaxBounds(), this.width = 0, this.height = 0, this._center = new t4.LngLat(0, 0), this.zoom = 0, this.angle = 0, this._fov = 0.6435011087932844, this._pitch = 0, this._unmodified = true, this._edgeInsets = new Mn(), this._posMatrixCache = {}, this._alignedPosMatrixCache = {};
            }, En = { minZoom: { configurable: true }, maxZoom: { configurable: true }, minPitch: { configurable: true }, maxPitch: { configurable: true }, renderWorldCopies: { configurable: true }, worldSize: { configurable: true }, centerOffset: { configurable: true }, size: { configurable: true }, bearing: { configurable: true }, pitch: { configurable: true }, fov: { configurable: true }, zoom: { configurable: true }, center: { configurable: true }, padding: { configurable: true }, centerPoint: { configurable: true }, unmodified: { configurable: true }, point: { configurable: true } };
            Sn.prototype.clone = function() {
              var t5 = new Sn(this._minZoom, this._maxZoom, this._minPitch, this.maxPitch, this._renderWorldCopies);
              return t5.tileSize = this.tileSize, t5.latRange = this.latRange, t5.width = this.width, t5.height = this.height, t5._center = this._center, t5.zoom = this.zoom, t5.angle = this.angle, t5._fov = this._fov, t5._pitch = this._pitch, t5._unmodified = this._unmodified, t5._edgeInsets = this._edgeInsets.clone(), t5._calcMatrices(), t5;
            }, En.minZoom.get = function() {
              return this._minZoom;
            }, En.minZoom.set = function(t5) {
              this._minZoom !== t5 && (this._minZoom = t5, this.zoom = Math.max(this.zoom, t5));
            }, En.maxZoom.get = function() {
              return this._maxZoom;
            }, En.maxZoom.set = function(t5) {
              this._maxZoom !== t5 && (this._maxZoom = t5, this.zoom = Math.min(this.zoom, t5));
            }, En.minPitch.get = function() {
              return this._minPitch;
            }, En.minPitch.set = function(t5) {
              this._minPitch !== t5 && (this._minPitch = t5, this.pitch = Math.max(this.pitch, t5));
            }, En.maxPitch.get = function() {
              return this._maxPitch;
            }, En.maxPitch.set = function(t5) {
              this._maxPitch !== t5 && (this._maxPitch = t5, this.pitch = Math.min(this.pitch, t5));
            }, En.renderWorldCopies.get = function() {
              return this._renderWorldCopies;
            }, En.renderWorldCopies.set = function(t5) {
              void 0 === t5 ? t5 = true : null === t5 && (t5 = false), this._renderWorldCopies = t5;
            }, En.worldSize.get = function() {
              return this.tileSize * this.scale;
            }, En.centerOffset.get = function() {
              return this.centerPoint._sub(this.size._div(2));
            }, En.size.get = function() {
              return new t4.Point(this.width, this.height);
            }, En.bearing.get = function() {
              return -this.angle / Math.PI * 180;
            }, En.bearing.set = function(e4) {
              var r4 = -t4.wrap(e4, -180, 180) * Math.PI / 180;
              this.angle !== r4 && (this._unmodified = false, this.angle = r4, this._calcMatrices(), this.rotationMatrix = t4.create$2(), t4.rotate(this.rotationMatrix, this.rotationMatrix, this.angle));
            }, En.pitch.get = function() {
              return this._pitch / Math.PI * 180;
            }, En.pitch.set = function(e4) {
              var r4 = t4.clamp(e4, this.minPitch, this.maxPitch) / 180 * Math.PI;
              this._pitch !== r4 && (this._unmodified = false, this._pitch = r4, this._calcMatrices());
            }, En.fov.get = function() {
              return this._fov / Math.PI * 180;
            }, En.fov.set = function(t5) {
              t5 = Math.max(0.01, Math.min(60, t5)), this._fov !== t5 && (this._unmodified = false, this._fov = t5 / 180 * Math.PI, this._calcMatrices());
            }, En.zoom.get = function() {
              return this._zoom;
            }, En.zoom.set = function(t5) {
              var e4 = Math.min(Math.max(t5, this.minZoom), this.maxZoom);
              this._zoom !== e4 && (this._unmodified = false, this._zoom = e4, this.scale = this.zoomScale(e4), this.tileZoom = Math.floor(e4), this.zoomFraction = e4 - this.tileZoom, this._constrain(), this._calcMatrices());
            }, En.center.get = function() {
              return this._center;
            }, En.center.set = function(t5) {
              t5.lat === this._center.lat && t5.lng === this._center.lng || (this._unmodified = false, this._center = t5, this._constrain(), this._calcMatrices());
            }, En.padding.get = function() {
              return this._edgeInsets.toJSON();
            }, En.padding.set = function(t5) {
              this._edgeInsets.equals(t5) || (this._unmodified = false, this._edgeInsets.interpolate(this._edgeInsets, t5, 1), this._calcMatrices());
            }, En.centerPoint.get = function() {
              return this._edgeInsets.getCenter(this.width, this.height);
            }, Sn.prototype.isPaddingEqual = function(t5) {
              return this._edgeInsets.equals(t5);
            }, Sn.prototype.interpolatePadding = function(t5, e4, r4) {
              this._unmodified = false, this._edgeInsets.interpolate(t5, e4, r4), this._constrain(), this._calcMatrices();
            }, Sn.prototype.coveringZoomLevel = function(t5) {
              var e4 = (t5.roundZoom ? Math.round : Math.floor)(this.zoom + this.scaleZoom(this.tileSize / t5.tileSize));
              return Math.max(0, e4);
            }, Sn.prototype.getVisibleUnwrappedCoordinates = function(e4) {
              var r4 = [new t4.UnwrappedTileID(0, e4)];
              if (this._renderWorldCopies)
                for (var n4 = this.pointCoordinate(new t4.Point(0, 0)), i2 = this.pointCoordinate(new t4.Point(this.width, 0)), a2 = this.pointCoordinate(new t4.Point(this.width, this.height)), o2 = this.pointCoordinate(new t4.Point(0, this.height)), s2 = Math.floor(Math.min(n4.x, i2.x, a2.x, o2.x)), l2 = Math.floor(Math.max(n4.x, i2.x, a2.x, o2.x)), u2 = s2 - 1; u2 <= l2 + 1; u2++)
                  0 !== u2 && r4.push(new t4.UnwrappedTileID(u2, e4));
              return r4;
            }, Sn.prototype.coveringTiles = function(e4) {
              var r4 = this.coveringZoomLevel(e4), n4 = r4;
              if (void 0 !== e4.minzoom && r4 < e4.minzoom)
                return [];
              void 0 !== e4.maxzoom && r4 > e4.maxzoom && (r4 = e4.maxzoom);
              var i2 = t4.MercatorCoordinate.fromLngLat(this.center), a2 = Math.pow(2, r4), o2 = [a2 * i2.x, a2 * i2.y, 0], s2 = kn.fromInvProjectionMatrix(this.invProjMatrix, this.worldSize, r4), l2 = e4.minzoom || 0;
              this.pitch <= 60 && this._edgeInsets.top < 0.1 && (l2 = r4);
              var u2 = function(t5) {
                return { aabb: new An([t5 * a2, 0, 0], [(t5 + 1) * a2, a2, 0]), zoom: 0, x: 0, y: 0, wrap: t5, fullyVisible: false };
              }, c2 = [], f3 = [], h2 = r4, p3 = e4.reparseOverscaled ? n4 : r4;
              if (this._renderWorldCopies)
                for (var d3 = 1; d3 <= 3; d3++)
                  c2.push(u2(-d3)), c2.push(u2(d3));
              for (c2.push(u2(0)); c2.length > 0; ) {
                var v2 = c2.pop(), g3 = v2.x, y2 = v2.y, m3 = v2.fullyVisible;
                if (!m3) {
                  var x2 = v2.aabb.intersects(s2);
                  if (0 === x2)
                    continue;
                  m3 = 2 === x2;
                }
                var b2 = v2.aabb.distanceX(o2), _2 = v2.aabb.distanceY(o2), w3 = Math.max(Math.abs(b2), Math.abs(_2)), T2 = 3 + (1 << h2 - v2.zoom) - 2;
                if (v2.zoom === h2 || w3 > T2 && v2.zoom >= l2)
                  f3.push({ tileID: new t4.OverscaledTileID(v2.zoom === h2 ? p3 : v2.zoom, v2.wrap, v2.zoom, g3, y2), distanceSq: t4.sqrLen([o2[0] - 0.5 - g3, o2[1] - 0.5 - y2]) });
                else
                  for (var k2 = 0; k2 < 4; k2++) {
                    var A2 = (g3 << 1) + k2 % 2, M2 = (y2 << 1) + (k2 >> 1);
                    c2.push({ aabb: v2.aabb.quadrant(k2), zoom: v2.zoom + 1, x: A2, y: M2, wrap: v2.wrap, fullyVisible: m3 });
                  }
              }
              return f3.sort(function(t5, e5) {
                return t5.distanceSq - e5.distanceSq;
              }).map(function(t5) {
                return t5.tileID;
              });
            }, Sn.prototype.resize = function(t5, e4) {
              this.width = t5, this.height = e4, this.pixelsToGLUnits = [2 / t5, -2 / e4], this._constrain(), this._calcMatrices();
            }, En.unmodified.get = function() {
              return this._unmodified;
            }, Sn.prototype.zoomScale = function(t5) {
              return Math.pow(2, t5);
            }, Sn.prototype.scaleZoom = function(t5) {
              return Math.log(t5) / Math.LN2;
            }, Sn.prototype.project = function(e4) {
              var r4 = t4.clamp(e4.lat, -this.maxValidLatitude, this.maxValidLatitude);
              return new t4.Point(t4.mercatorXfromLng(e4.lng) * this.worldSize, t4.mercatorYfromLat(r4) * this.worldSize);
            }, Sn.prototype.unproject = function(e4) {
              return new t4.MercatorCoordinate(e4.x / this.worldSize, e4.y / this.worldSize).toLngLat();
            }, En.point.get = function() {
              return this.project(this.center);
            }, Sn.prototype.setLocationAtPoint = function(e4, r4) {
              var n4 = this.pointCoordinate(r4), i2 = this.pointCoordinate(this.centerPoint), a2 = this.locationCoordinate(e4), o2 = new t4.MercatorCoordinate(a2.x - (n4.x - i2.x), a2.y - (n4.y - i2.y));
              this.center = this.coordinateLocation(o2), this._renderWorldCopies && (this.center = this.center.wrap());
            }, Sn.prototype.locationPoint = function(t5) {
              return this.coordinatePoint(this.locationCoordinate(t5));
            }, Sn.prototype.pointLocation = function(t5) {
              return this.coordinateLocation(this.pointCoordinate(t5));
            }, Sn.prototype.locationCoordinate = function(e4) {
              return t4.MercatorCoordinate.fromLngLat(e4);
            }, Sn.prototype.coordinateLocation = function(t5) {
              return t5.toLngLat();
            }, Sn.prototype.pointCoordinate = function(e4) {
              var r4 = [e4.x, e4.y, 0, 1], n4 = [e4.x, e4.y, 1, 1];
              t4.transformMat4(r4, r4, this.pixelMatrixInverse), t4.transformMat4(n4, n4, this.pixelMatrixInverse);
              var i2 = r4[3], a2 = n4[3], o2 = r4[0] / i2, s2 = n4[0] / a2, l2 = r4[1] / i2, u2 = n4[1] / a2, c2 = r4[2] / i2, f3 = n4[2] / a2, h2 = c2 === f3 ? 0 : (0 - c2) / (f3 - c2);
              return new t4.MercatorCoordinate(t4.number(o2, s2, h2) / this.worldSize, t4.number(l2, u2, h2) / this.worldSize);
            }, Sn.prototype.coordinatePoint = function(e4) {
              var r4 = [e4.x * this.worldSize, e4.y * this.worldSize, 0, 1];
              return t4.transformMat4(r4, r4, this.pixelMatrix), new t4.Point(r4[0] / r4[3], r4[1] / r4[3]);
            }, Sn.prototype.getBounds = function() {
              return new t4.LngLatBounds().extend(this.pointLocation(new t4.Point(0, 0))).extend(this.pointLocation(new t4.Point(this.width, 0))).extend(this.pointLocation(new t4.Point(this.width, this.height))).extend(this.pointLocation(new t4.Point(0, this.height)));
            }, Sn.prototype.getMaxBounds = function() {
              return this.latRange && 2 === this.latRange.length && this.lngRange && 2 === this.lngRange.length ? new t4.LngLatBounds([this.lngRange[0], this.latRange[0]], [this.lngRange[1], this.latRange[1]]) : null;
            }, Sn.prototype.setMaxBounds = function(t5) {
              t5 ? (this.lngRange = [t5.getWest(), t5.getEast()], this.latRange = [t5.getSouth(), t5.getNorth()], this._constrain()) : (this.lngRange = null, this.latRange = [-this.maxValidLatitude, this.maxValidLatitude]);
            }, Sn.prototype.calculatePosMatrix = function(e4, r4) {
              void 0 === r4 && (r4 = false);
              var n4 = e4.key, i2 = r4 ? this._alignedPosMatrixCache : this._posMatrixCache;
              if (i2[n4])
                return i2[n4];
              var a2 = e4.canonical, o2 = this.worldSize / this.zoomScale(a2.z), s2 = a2.x + Math.pow(2, a2.z) * e4.wrap, l2 = t4.identity(new Float64Array(16));
              return t4.translate(l2, l2, [s2 * o2, a2.y * o2, 0]), t4.scale(l2, l2, [o2 / t4.EXTENT, o2 / t4.EXTENT, 1]), t4.multiply(l2, r4 ? this.alignedProjMatrix : this.projMatrix, l2), i2[n4] = new Float32Array(l2), i2[n4];
            }, Sn.prototype.customLayerMatrix = function() {
              return this.mercatorMatrix.slice();
            }, Sn.prototype._constrain = function() {
              if (this.center && this.width && this.height && !this._constraining) {
                this._constraining = true;
                var e4, r4, n4, i2, a2 = -90, o2 = 90, s2 = -180, l2 = 180, u2 = this.size, c2 = this._unmodified;
                if (this.latRange) {
                  var f3 = this.latRange;
                  a2 = t4.mercatorYfromLat(f3[1]) * this.worldSize, e4 = (o2 = t4.mercatorYfromLat(f3[0]) * this.worldSize) - a2 < u2.y ? u2.y / (o2 - a2) : 0;
                }
                if (this.lngRange) {
                  var h2 = this.lngRange;
                  s2 = t4.mercatorXfromLng(h2[0]) * this.worldSize, r4 = (l2 = t4.mercatorXfromLng(h2[1]) * this.worldSize) - s2 < u2.x ? u2.x / (l2 - s2) : 0;
                }
                var p3 = this.point, d3 = Math.max(r4 || 0, e4 || 0);
                if (d3)
                  return this.center = this.unproject(new t4.Point(r4 ? (l2 + s2) / 2 : p3.x, e4 ? (o2 + a2) / 2 : p3.y)), this.zoom += this.scaleZoom(d3), this._unmodified = c2, void (this._constraining = false);
                if (this.latRange) {
                  var v2 = p3.y, g3 = u2.y / 2;
                  v2 - g3 < a2 && (i2 = a2 + g3), v2 + g3 > o2 && (i2 = o2 - g3);
                }
                if (this.lngRange) {
                  var y2 = p3.x, m3 = u2.x / 2;
                  y2 - m3 < s2 && (n4 = s2 + m3), y2 + m3 > l2 && (n4 = l2 - m3);
                }
                void 0 === n4 && void 0 === i2 || (this.center = this.unproject(new t4.Point(void 0 !== n4 ? n4 : p3.x, void 0 !== i2 ? i2 : p3.y))), this._unmodified = c2, this._constraining = false;
              }
            }, Sn.prototype._calcMatrices = function() {
              if (this.height) {
                var e4 = this._fov / 2, r4 = this.centerOffset;
                this.cameraToCenterDistance = 0.5 / Math.tan(e4) * this.height;
                var n4 = Math.PI / 2 + this._pitch, i2 = this._fov * (0.5 + r4.y / this.height), a2 = Math.sin(i2) * this.cameraToCenterDistance / Math.sin(t4.clamp(Math.PI - n4 - i2, 0.01, Math.PI - 0.01)), o2 = this.point, s2 = o2.x, l2 = o2.y, u2 = 1.01 * (Math.cos(Math.PI / 2 - this._pitch) * a2 + this.cameraToCenterDistance), c2 = this.height / 50, f3 = new Float64Array(16);
                t4.perspective(f3, this._fov, this.width / this.height, c2, u2), f3[8] = 2 * -r4.x / this.width, f3[9] = 2 * r4.y / this.height, t4.scale(f3, f3, [1, -1, 1]), t4.translate(f3, f3, [0, 0, -this.cameraToCenterDistance]), t4.rotateX(f3, f3, this._pitch), t4.rotateZ(f3, f3, this.angle), t4.translate(f3, f3, [-s2, -l2, 0]), this.mercatorMatrix = t4.scale([], f3, [this.worldSize, this.worldSize, this.worldSize]), t4.scale(f3, f3, [1, 1, t4.mercatorZfromAltitude(1, this.center.lat) * this.worldSize, 1]), this.projMatrix = f3, this.invProjMatrix = t4.invert([], this.projMatrix);
                var h2 = this.width % 2 / 2, p3 = this.height % 2 / 2, d3 = Math.cos(this.angle), v2 = Math.sin(this.angle), g3 = s2 - Math.round(s2) + d3 * h2 + v2 * p3, y2 = l2 - Math.round(l2) + d3 * p3 + v2 * h2, m3 = new Float64Array(f3);
                if (t4.translate(m3, m3, [g3 > 0.5 ? g3 - 1 : g3, y2 > 0.5 ? y2 - 1 : y2, 0]), this.alignedProjMatrix = m3, f3 = t4.create(), t4.scale(f3, f3, [this.width / 2, -this.height / 2, 1]), t4.translate(f3, f3, [1, -1, 0]), this.labelPlaneMatrix = f3, f3 = t4.create(), t4.scale(f3, f3, [1, -1, 1]), t4.translate(f3, f3, [-1, -1, 0]), t4.scale(f3, f3, [2 / this.width, 2 / this.height, 1]), this.glCoordMatrix = f3, this.pixelMatrix = t4.multiply(new Float64Array(16), this.labelPlaneMatrix, this.projMatrix), !(f3 = t4.invert(new Float64Array(16), this.pixelMatrix)))
                  throw new Error("failed to invert matrix");
                this.pixelMatrixInverse = f3, this._posMatrixCache = {}, this._alignedPosMatrixCache = {};
              }
            }, Sn.prototype.maxPitchScaleFactor = function() {
              if (!this.pixelMatrixInverse)
                return 1;
              var e4 = this.pointCoordinate(new t4.Point(0, 0)), r4 = [e4.x * this.worldSize, e4.y * this.worldSize, 0, 1];
              return t4.transformMat4(r4, r4, this.pixelMatrix)[3] / this.cameraToCenterDistance;
            }, Sn.prototype.getCameraPoint = function() {
              var e4 = this._pitch, r4 = Math.tan(e4) * (this.cameraToCenterDistance || 1);
              return this.centerPoint.add(new t4.Point(0, r4));
            }, Sn.prototype.getCameraQueryGeometry = function(e4) {
              var r4 = this.getCameraPoint();
              if (1 === e4.length)
                return [e4[0], r4];
              for (var n4 = r4.x, i2 = r4.y, a2 = r4.x, o2 = r4.y, s2 = 0, l2 = e4; s2 < l2.length; s2 += 1) {
                var u2 = l2[s2];
                n4 = Math.min(n4, u2.x), i2 = Math.min(i2, u2.y), a2 = Math.max(a2, u2.x), o2 = Math.max(o2, u2.y);
              }
              return [new t4.Point(n4, i2), new t4.Point(a2, i2), new t4.Point(a2, o2), new t4.Point(n4, o2), new t4.Point(n4, i2)];
            }, Object.defineProperties(Sn.prototype, En);
            var Ln = function(e4) {
              var r4, n4, i2, a2, o2;
              this._hashName = e4 && encodeURIComponent(e4), t4.bindAll(["_getCurrentHash", "_onHashChange", "_updateHash"], this), this._updateHash = (r4 = this._updateHashUnthrottled.bind(this), n4 = 300, i2 = false, a2 = null, o2 = function() {
                a2 = null, i2 && (r4(), a2 = setTimeout(o2, n4), i2 = false);
              }, function() {
                return i2 = true, a2 || o2(), a2;
              });
            };
            Ln.prototype.addTo = function(e4) {
              return this._map = e4, t4.window.addEventListener("hashchange", this._onHashChange, false), this._map.on("moveend", this._updateHash), this;
            }, Ln.prototype.remove = function() {
              return t4.window.removeEventListener("hashchange", this._onHashChange, false), this._map.off("moveend", this._updateHash), clearTimeout(this._updateHash()), delete this._map, this;
            }, Ln.prototype.getHashString = function(e4) {
              var r4 = this._map.getCenter(), n4 = Math.round(100 * this._map.getZoom()) / 100, i2 = Math.ceil((n4 * Math.LN2 + Math.log(512 / 360 / 0.5)) / Math.LN10), a2 = Math.pow(10, i2), o2 = Math.round(r4.lng * a2) / a2, s2 = Math.round(r4.lat * a2) / a2, l2 = this._map.getBearing(), u2 = this._map.getPitch(), c2 = "";
              if (c2 += e4 ? "/" + o2 + "/" + s2 + "/" + n4 : n4 + "/" + s2 + "/" + o2, (l2 || u2) && (c2 += "/" + Math.round(10 * l2) / 10), u2 && (c2 += "/" + Math.round(u2)), this._hashName) {
                var f3 = this._hashName, h2 = false, p3 = t4.window.location.hash.slice(1).split("&").map(function(t5) {
                  var e5 = t5.split("=")[0];
                  return e5 === f3 ? (h2 = true, e5 + "=" + c2) : t5;
                }).filter(function(t5) {
                  return t5;
                });
                return h2 || p3.push(f3 + "=" + c2), "#" + p3.join("&");
              }
              return "#" + c2;
            }, Ln.prototype._getCurrentHash = function() {
              var e4, r4 = this, n4 = t4.window.location.hash.replace("#", "");
              return this._hashName ? (n4.split("&").map(function(t5) {
                return t5.split("=");
              }).forEach(function(t5) {
                t5[0] === r4._hashName && (e4 = t5);
              }), (e4 && e4[1] || "").split("/")) : n4.split("/");
            }, Ln.prototype._onHashChange = function() {
              var t5 = this._getCurrentHash();
              if (t5.length >= 3 && !t5.some(function(t6) {
                return isNaN(t6);
              })) {
                var e4 = this._map.dragRotate.isEnabled() && this._map.touchZoomRotate.isEnabled() ? +(t5[3] || 0) : this._map.getBearing();
                return this._map.jumpTo({ center: [+t5[2], +t5[1]], zoom: +t5[0], bearing: e4, pitch: +(t5[4] || 0) }), true;
              }
              return false;
            }, Ln.prototype._updateHashUnthrottled = function() {
              var e4 = this.getHashString();
              try {
                t4.window.history.replaceState(t4.window.history.state, "", e4);
              } catch (t5) {
              }
            };
            var Cn = { linearity: 0.3, easing: t4.bezier(0, 0, 0.3, 1) }, Pn = t4.extend({ deceleration: 2500, maxSpeed: 1400 }, Cn), On = t4.extend({ deceleration: 20, maxSpeed: 1400 }, Cn), In = t4.extend({ deceleration: 1e3, maxSpeed: 360 }, Cn), Dn = t4.extend({ deceleration: 1e3, maxSpeed: 90 }, Cn), zn = function(t5) {
              this._map = t5, this.clear();
            };
            function Rn(t5, e4) {
              (!t5.duration || t5.duration < e4.duration) && (t5.duration = e4.duration, t5.easing = e4.easing);
            }
            function Fn(e4, r4, n4) {
              var i2 = n4.maxSpeed, a2 = n4.linearity, o2 = n4.deceleration, s2 = t4.clamp(e4 * a2 / (r4 / 1e3), -i2, i2), l2 = Math.abs(s2) / (o2 * a2);
              return { easing: n4.easing, duration: 1e3 * l2, amount: s2 * (l2 / 2) };
            }
            zn.prototype.clear = function() {
              this._inertiaBuffer = [];
            }, zn.prototype.record = function(e4) {
              this._drainInertiaBuffer(), this._inertiaBuffer.push({ time: t4.browser.now(), settings: e4 });
            }, zn.prototype._drainInertiaBuffer = function() {
              for (var e4 = this._inertiaBuffer, r4 = t4.browser.now(); e4.length > 0 && r4 - e4[0].time > 160; )
                e4.shift();
            }, zn.prototype._onMoveEnd = function(e4) {
              if (this._drainInertiaBuffer(), !(this._inertiaBuffer.length < 2)) {
                for (var r4 = { zoom: 0, bearing: 0, pitch: 0, pan: new t4.Point(0, 0), pinchAround: void 0, around: void 0 }, n4 = 0, i2 = this._inertiaBuffer; n4 < i2.length; n4 += 1) {
                  var a2 = i2[n4].settings;
                  r4.zoom += a2.zoomDelta || 0, r4.bearing += a2.bearingDelta || 0, r4.pitch += a2.pitchDelta || 0, a2.panDelta && r4.pan._add(a2.panDelta), a2.around && (r4.around = a2.around), a2.pinchAround && (r4.pinchAround = a2.pinchAround);
                }
                var o2 = this._inertiaBuffer[this._inertiaBuffer.length - 1].time - this._inertiaBuffer[0].time, s2 = {};
                if (r4.pan.mag()) {
                  var l2 = Fn(r4.pan.mag(), o2, t4.extend({}, Pn, e4 || {}));
                  s2.offset = r4.pan.mult(l2.amount / r4.pan.mag()), s2.center = this._map.transform.center, Rn(s2, l2);
                }
                if (r4.zoom) {
                  var u2 = Fn(r4.zoom, o2, On);
                  s2.zoom = this._map.transform.zoom + u2.amount, Rn(s2, u2);
                }
                if (r4.bearing) {
                  var c2 = Fn(r4.bearing, o2, In);
                  s2.bearing = this._map.transform.bearing + t4.clamp(c2.amount, -179, 179), Rn(s2, c2);
                }
                if (r4.pitch) {
                  var f3 = Fn(r4.pitch, o2, Dn);
                  s2.pitch = this._map.transform.pitch + f3.amount, Rn(s2, f3);
                }
                if (s2.zoom || s2.bearing) {
                  var h2 = void 0 === r4.pinchAround ? r4.around : r4.pinchAround;
                  s2.around = h2 ? this._map.unproject(h2) : this._map.getCenter();
                }
                return this.clear(), t4.extend(s2, { noMoveStart: true });
              }
            };
            var Bn = function(e4) {
              function n4(n5, i3, a2, o2) {
                void 0 === o2 && (o2 = {});
                var s2 = r3.mousePos(i3.getCanvasContainer(), a2), l2 = i3.unproject(s2);
                e4.call(this, n5, t4.extend({ point: s2, lngLat: l2, originalEvent: a2 }, o2)), this._defaultPrevented = false, this.target = i3;
              }
              e4 && (n4.__proto__ = e4), n4.prototype = Object.create(e4 && e4.prototype), n4.prototype.constructor = n4;
              var i2 = { defaultPrevented: { configurable: true } };
              return n4.prototype.preventDefault = function() {
                this._defaultPrevented = true;
              }, i2.defaultPrevented.get = function() {
                return this._defaultPrevented;
              }, Object.defineProperties(n4.prototype, i2), n4;
            }(t4.Event), Nn = function(e4) {
              function n4(n5, i3, a2) {
                var o2 = "touchend" === n5 ? a2.changedTouches : a2.touches, s2 = r3.touchPos(i3.getCanvasContainer(), o2), l2 = s2.map(function(t5) {
                  return i3.unproject(t5);
                }), u2 = s2.reduce(function(t5, e5, r4, n6) {
                  return t5.add(e5.div(n6.length));
                }, new t4.Point(0, 0)), c2 = i3.unproject(u2);
                e4.call(this, n5, { points: s2, point: u2, lngLats: l2, lngLat: c2, originalEvent: a2 }), this._defaultPrevented = false;
              }
              e4 && (n4.__proto__ = e4), n4.prototype = Object.create(e4 && e4.prototype), n4.prototype.constructor = n4;
              var i2 = { defaultPrevented: { configurable: true } };
              return n4.prototype.preventDefault = function() {
                this._defaultPrevented = true;
              }, i2.defaultPrevented.get = function() {
                return this._defaultPrevented;
              }, Object.defineProperties(n4.prototype, i2), n4;
            }(t4.Event), jn = function(t5) {
              function e4(e5, r5, n4) {
                t5.call(this, e5, { originalEvent: n4 }), this._defaultPrevented = false;
              }
              t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4;
              var r4 = { defaultPrevented: { configurable: true } };
              return e4.prototype.preventDefault = function() {
                this._defaultPrevented = true;
              }, r4.defaultPrevented.get = function() {
                return this._defaultPrevented;
              }, Object.defineProperties(e4.prototype, r4), e4;
            }(t4.Event), Un = function(t5, e4) {
              this._map = t5, this._clickTolerance = e4.clickTolerance;
            };
            Un.prototype.reset = function() {
              delete this._mousedownPos;
            }, Un.prototype.wheel = function(t5) {
              return this._firePreventable(new jn(t5.type, this._map, t5));
            }, Un.prototype.mousedown = function(t5, e4) {
              return this._mousedownPos = e4, this._firePreventable(new Bn(t5.type, this._map, t5));
            }, Un.prototype.mouseup = function(t5) {
              this._map.fire(new Bn(t5.type, this._map, t5));
            }, Un.prototype.click = function(t5, e4) {
              this._mousedownPos && this._mousedownPos.dist(e4) >= this._clickTolerance || this._map.fire(new Bn(t5.type, this._map, t5));
            }, Un.prototype.dblclick = function(t5) {
              return this._firePreventable(new Bn(t5.type, this._map, t5));
            }, Un.prototype.mouseover = function(t5) {
              this._map.fire(new Bn(t5.type, this._map, t5));
            }, Un.prototype.mouseout = function(t5) {
              this._map.fire(new Bn(t5.type, this._map, t5));
            }, Un.prototype.touchstart = function(t5) {
              return this._firePreventable(new Nn(t5.type, this._map, t5));
            }, Un.prototype.touchmove = function(t5) {
              this._map.fire(new Nn(t5.type, this._map, t5));
            }, Un.prototype.touchend = function(t5) {
              this._map.fire(new Nn(t5.type, this._map, t5));
            }, Un.prototype.touchcancel = function(t5) {
              this._map.fire(new Nn(t5.type, this._map, t5));
            }, Un.prototype._firePreventable = function(t5) {
              if (this._map.fire(t5), t5.defaultPrevented)
                return {};
            }, Un.prototype.isEnabled = function() {
              return true;
            }, Un.prototype.isActive = function() {
              return false;
            }, Un.prototype.enable = function() {
            }, Un.prototype.disable = function() {
            };
            var Vn = function(t5) {
              this._map = t5;
            };
            Vn.prototype.reset = function() {
              this._delayContextMenu = false, delete this._contextMenuEvent;
            }, Vn.prototype.mousemove = function(t5) {
              this._map.fire(new Bn(t5.type, this._map, t5));
            }, Vn.prototype.mousedown = function() {
              this._delayContextMenu = true;
            }, Vn.prototype.mouseup = function() {
              this._delayContextMenu = false, this._contextMenuEvent && (this._map.fire(new Bn("contextmenu", this._map, this._contextMenuEvent)), delete this._contextMenuEvent);
            }, Vn.prototype.contextmenu = function(t5) {
              this._delayContextMenu ? this._contextMenuEvent = t5 : this._map.fire(new Bn(t5.type, this._map, t5)), this._map.listens("contextmenu") && t5.preventDefault();
            }, Vn.prototype.isEnabled = function() {
              return true;
            }, Vn.prototype.isActive = function() {
              return false;
            }, Vn.prototype.enable = function() {
            }, Vn.prototype.disable = function() {
            };
            var Hn = function(t5, e4) {
              this._map = t5, this._el = t5.getCanvasContainer(), this._container = t5.getContainer(), this._clickTolerance = e4.clickTolerance || 1;
            };
            function qn(t5, e4) {
              for (var r4 = {}, n4 = 0; n4 < t5.length; n4++)
                r4[t5[n4].identifier] = e4[n4];
              return r4;
            }
            Hn.prototype.isEnabled = function() {
              return !!this._enabled;
            }, Hn.prototype.isActive = function() {
              return !!this._active;
            }, Hn.prototype.enable = function() {
              this.isEnabled() || (this._enabled = true);
            }, Hn.prototype.disable = function() {
              this.isEnabled() && (this._enabled = false);
            }, Hn.prototype.mousedown = function(t5, e4) {
              this.isEnabled() && t5.shiftKey && 0 === t5.button && (r3.disableDrag(), this._startPos = this._lastPos = e4, this._active = true);
            }, Hn.prototype.mousemoveWindow = function(t5, e4) {
              if (this._active) {
                var n4 = e4;
                if (!(this._lastPos.equals(n4) || !this._box && n4.dist(this._startPos) < this._clickTolerance)) {
                  var i2 = this._startPos;
                  this._lastPos = n4, this._box || (this._box = r3.create("div", "mapboxgl-boxzoom", this._container), this._container.classList.add("mapboxgl-crosshair"), this._fireEvent("boxzoomstart", t5));
                  var a2 = Math.min(i2.x, n4.x), o2 = Math.max(i2.x, n4.x), s2 = Math.min(i2.y, n4.y), l2 = Math.max(i2.y, n4.y);
                  r3.setTransform(this._box, "translate(" + a2 + "px," + s2 + "px)"), this._box.style.width = o2 - a2 + "px", this._box.style.height = l2 - s2 + "px";
                }
              }
            }, Hn.prototype.mouseupWindow = function(e4, n4) {
              var i2 = this;
              if (this._active && 0 === e4.button) {
                var a2 = this._startPos, o2 = n4;
                if (this.reset(), r3.suppressClick(), a2.x !== o2.x || a2.y !== o2.y)
                  return this._map.fire(new t4.Event("boxzoomend", { originalEvent: e4 })), { cameraAnimation: function(t5) {
                    return t5.fitScreenCoordinates(a2, o2, i2._map.getBearing(), { linear: true });
                  } };
                this._fireEvent("boxzoomcancel", e4);
              }
            }, Hn.prototype.keydown = function(t5) {
              this._active && 27 === t5.keyCode && (this.reset(), this._fireEvent("boxzoomcancel", t5));
            }, Hn.prototype.reset = function() {
              this._active = false, this._container.classList.remove("mapboxgl-crosshair"), this._box && (r3.remove(this._box), this._box = null), r3.enableDrag(), delete this._startPos, delete this._lastPos;
            }, Hn.prototype._fireEvent = function(e4, r4) {
              return this._map.fire(new t4.Event(e4, { originalEvent: r4 }));
            };
            var Gn = function(t5) {
              this.reset(), this.numTouches = t5.numTouches;
            };
            Gn.prototype.reset = function() {
              delete this.centroid, delete this.startTime, delete this.touches, this.aborted = false;
            }, Gn.prototype.touchstart = function(e4, r4, n4) {
              (this.centroid || n4.length > this.numTouches) && (this.aborted = true), this.aborted || (void 0 === this.startTime && (this.startTime = e4.timeStamp), n4.length === this.numTouches && (this.centroid = function(e5) {
                for (var r5 = new t4.Point(0, 0), n5 = 0, i2 = e5; n5 < i2.length; n5 += 1) {
                  var a2 = i2[n5];
                  r5._add(a2);
                }
                return r5.div(e5.length);
              }(r4), this.touches = qn(n4, r4)));
            }, Gn.prototype.touchmove = function(t5, e4, r4) {
              if (!this.aborted && this.centroid) {
                var n4 = qn(r4, e4);
                for (var i2 in this.touches) {
                  var a2 = this.touches[i2], o2 = n4[i2];
                  (!o2 || o2.dist(a2) > 30) && (this.aborted = true);
                }
              }
            }, Gn.prototype.touchend = function(t5, e4, r4) {
              if ((!this.centroid || t5.timeStamp - this.startTime > 500) && (this.aborted = true), 0 === r4.length) {
                var n4 = !this.aborted && this.centroid;
                if (this.reset(), n4)
                  return n4;
              }
            };
            var Zn = function(t5) {
              this.singleTap = new Gn(t5), this.numTaps = t5.numTaps, this.reset();
            };
            Zn.prototype.reset = function() {
              this.lastTime = 1 / 0, delete this.lastTap, this.count = 0, this.singleTap.reset();
            }, Zn.prototype.touchstart = function(t5, e4, r4) {
              this.singleTap.touchstart(t5, e4, r4);
            }, Zn.prototype.touchmove = function(t5, e4, r4) {
              this.singleTap.touchmove(t5, e4, r4);
            }, Zn.prototype.touchend = function(t5, e4, r4) {
              var n4 = this.singleTap.touchend(t5, e4, r4);
              if (n4) {
                var i2 = t5.timeStamp - this.lastTime < 500, a2 = !this.lastTap || this.lastTap.dist(n4) < 30;
                if (i2 && a2 || this.reset(), this.count++, this.lastTime = t5.timeStamp, this.lastTap = n4, this.count === this.numTaps)
                  return this.reset(), n4;
              }
            };
            var Yn = function() {
              this._zoomIn = new Zn({ numTouches: 1, numTaps: 2 }), this._zoomOut = new Zn({ numTouches: 2, numTaps: 1 }), this.reset();
            };
            Yn.prototype.reset = function() {
              this._active = false, this._zoomIn.reset(), this._zoomOut.reset();
            }, Yn.prototype.touchstart = function(t5, e4, r4) {
              this._zoomIn.touchstart(t5, e4, r4), this._zoomOut.touchstart(t5, e4, r4);
            }, Yn.prototype.touchmove = function(t5, e4, r4) {
              this._zoomIn.touchmove(t5, e4, r4), this._zoomOut.touchmove(t5, e4, r4);
            }, Yn.prototype.touchend = function(t5, e4, r4) {
              var n4 = this, i2 = this._zoomIn.touchend(t5, e4, r4), a2 = this._zoomOut.touchend(t5, e4, r4);
              return i2 ? (this._active = true, t5.preventDefault(), setTimeout(function() {
                return n4.reset();
              }, 0), { cameraAnimation: function(e5) {
                return e5.easeTo({ duration: 300, zoom: e5.getZoom() + 1, around: e5.unproject(i2) }, { originalEvent: t5 });
              } }) : a2 ? (this._active = true, t5.preventDefault(), setTimeout(function() {
                return n4.reset();
              }, 0), { cameraAnimation: function(e5) {
                return e5.easeTo({ duration: 300, zoom: e5.getZoom() - 1, around: e5.unproject(a2) }, { originalEvent: t5 });
              } }) : void 0;
            }, Yn.prototype.touchcancel = function() {
              this.reset();
            }, Yn.prototype.enable = function() {
              this._enabled = true;
            }, Yn.prototype.disable = function() {
              this._enabled = false, this.reset();
            }, Yn.prototype.isEnabled = function() {
              return this._enabled;
            }, Yn.prototype.isActive = function() {
              return this._active;
            };
            var Wn = function(t5) {
              this.reset(), this._clickTolerance = t5.clickTolerance || 1;
            };
            Wn.prototype.reset = function() {
              this._active = false, this._moved = false, delete this._lastPoint, delete this._eventButton;
            }, Wn.prototype._correctButton = function(t5, e4) {
              return false;
            }, Wn.prototype._move = function(t5, e4) {
              return {};
            }, Wn.prototype.mousedown = function(t5, e4) {
              if (!this._lastPoint) {
                var n4 = r3.mouseButton(t5);
                this._correctButton(t5, n4) && (this._lastPoint = e4, this._eventButton = n4);
              }
            }, Wn.prototype.mousemoveWindow = function(t5, e4) {
              var r4 = this._lastPoint;
              if (r4 && (t5.preventDefault(), this._moved || !(e4.dist(r4) < this._clickTolerance)))
                return this._moved = true, this._lastPoint = e4, this._move(r4, e4);
            }, Wn.prototype.mouseupWindow = function(t5) {
              r3.mouseButton(t5) === this._eventButton && (this._moved && r3.suppressClick(), this.reset());
            }, Wn.prototype.enable = function() {
              this._enabled = true;
            }, Wn.prototype.disable = function() {
              this._enabled = false, this.reset();
            }, Wn.prototype.isEnabled = function() {
              return this._enabled;
            }, Wn.prototype.isActive = function() {
              return this._active;
            };
            var Xn = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.mousedown = function(e5, r4) {
                t5.prototype.mousedown.call(this, e5, r4), this._lastPoint && (this._active = true);
              }, e4.prototype._correctButton = function(t6, e5) {
                return 0 === e5 && !t6.ctrlKey;
              }, e4.prototype._move = function(t6, e5) {
                return { around: e5, panDelta: e5.sub(t6) };
              }, e4;
            }(Wn), Jn = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._correctButton = function(t6, e5) {
                return 0 === e5 && t6.ctrlKey || 2 === e5;
              }, e4.prototype._move = function(t6, e5) {
                var r4 = 0.8 * (e5.x - t6.x);
                if (r4)
                  return this._active = true, { bearingDelta: r4 };
              }, e4.prototype.contextmenu = function(t6) {
                t6.preventDefault();
              }, e4;
            }(Wn), Kn = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype._correctButton = function(t6, e5) {
                return 0 === e5 && t6.ctrlKey || 2 === e5;
              }, e4.prototype._move = function(t6, e5) {
                var r4 = -0.5 * (e5.y - t6.y);
                if (r4)
                  return this._active = true, { pitchDelta: r4 };
              }, e4.prototype.contextmenu = function(t6) {
                t6.preventDefault();
              }, e4;
            }(Wn), $n = function(t5) {
              this._minTouches = 1, this._clickTolerance = t5.clickTolerance || 1, this.reset();
            };
            $n.prototype.reset = function() {
              this._active = false, this._touches = {}, this._sum = new t4.Point(0, 0);
            }, $n.prototype.touchstart = function(t5, e4, r4) {
              return this._calculateTransform(t5, e4, r4);
            }, $n.prototype.touchmove = function(t5, e4, r4) {
              if (this._active)
                return t5.preventDefault(), this._calculateTransform(t5, e4, r4);
            }, $n.prototype.touchend = function(t5, e4, r4) {
              this._calculateTransform(t5, e4, r4), this._active && r4.length < this._minTouches && this.reset();
            }, $n.prototype.touchcancel = function() {
              this.reset();
            }, $n.prototype._calculateTransform = function(e4, r4, n4) {
              n4.length > 0 && (this._active = true);
              var i2 = qn(n4, r4), a2 = new t4.Point(0, 0), o2 = new t4.Point(0, 0), s2 = 0;
              for (var l2 in i2) {
                var u2 = i2[l2], c2 = this._touches[l2];
                c2 && (a2._add(u2), o2._add(u2.sub(c2)), s2++, i2[l2] = u2);
              }
              if (this._touches = i2, !(s2 < this._minTouches) && o2.mag()) {
                var f3 = o2.div(s2);
                if (this._sum._add(f3), !(this._sum.mag() < this._clickTolerance))
                  return { around: a2.div(s2), panDelta: f3 };
              }
            }, $n.prototype.enable = function() {
              this._enabled = true;
            }, $n.prototype.disable = function() {
              this._enabled = false, this.reset();
            }, $n.prototype.isEnabled = function() {
              return this._enabled;
            }, $n.prototype.isActive = function() {
              return this._active;
            };
            var Qn = function() {
              this.reset();
            };
            function ti(t5, e4, r4) {
              for (var n4 = 0; n4 < t5.length; n4++)
                if (t5[n4].identifier === r4)
                  return e4[n4];
            }
            Qn.prototype.reset = function() {
              this._active = false, delete this._firstTwoTouches;
            }, Qn.prototype._start = function(t5) {
            }, Qn.prototype._move = function(t5, e4, r4) {
              return {};
            }, Qn.prototype.touchstart = function(t5, e4, r4) {
              this._firstTwoTouches || r4.length < 2 || (this._firstTwoTouches = [r4[0].identifier, r4[1].identifier], this._start([e4[0], e4[1]]));
            }, Qn.prototype.touchmove = function(t5, e4, r4) {
              if (this._firstTwoTouches) {
                t5.preventDefault();
                var n4 = this._firstTwoTouches, i2 = n4[0], a2 = n4[1], o2 = ti(r4, e4, i2), s2 = ti(r4, e4, a2);
                if (o2 && s2) {
                  var l2 = this._aroundCenter ? null : o2.add(s2).div(2);
                  return this._move([o2, s2], l2, t5);
                }
              }
            }, Qn.prototype.touchend = function(t5, e4, n4) {
              if (this._firstTwoTouches) {
                var i2 = this._firstTwoTouches, a2 = i2[0], o2 = i2[1], s2 = ti(n4, e4, a2), l2 = ti(n4, e4, o2);
                s2 && l2 || (this._active && r3.suppressClick(), this.reset());
              }
            }, Qn.prototype.touchcancel = function() {
              this.reset();
            }, Qn.prototype.enable = function(t5) {
              this._enabled = true, this._aroundCenter = !!t5 && "center" === t5.around;
            }, Qn.prototype.disable = function() {
              this._enabled = false, this.reset();
            }, Qn.prototype.isEnabled = function() {
              return this._enabled;
            }, Qn.prototype.isActive = function() {
              return this._active;
            };
            function ei(t5, e4) {
              return Math.log(t5 / e4) / Math.LN2;
            }
            var ri = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.reset = function() {
                t5.prototype.reset.call(this), delete this._distance, delete this._startDistance;
              }, e4.prototype._start = function(t6) {
                this._startDistance = this._distance = t6[0].dist(t6[1]);
              }, e4.prototype._move = function(t6, e5) {
                var r4 = this._distance;
                if (this._distance = t6[0].dist(t6[1]), this._active || !(Math.abs(ei(this._distance, this._startDistance)) < 0.1))
                  return this._active = true, { zoomDelta: ei(this._distance, r4), pinchAround: e5 };
              }, e4;
            }(Qn);
            function ni(t5, e4) {
              return 180 * t5.angleWith(e4) / Math.PI;
            }
            var ii = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.reset = function() {
                t5.prototype.reset.call(this), delete this._minDiameter, delete this._startVector, delete this._vector;
              }, e4.prototype._start = function(t6) {
                this._startVector = this._vector = t6[0].sub(t6[1]), this._minDiameter = t6[0].dist(t6[1]);
              }, e4.prototype._move = function(t6, e5) {
                var r4 = this._vector;
                if (this._vector = t6[0].sub(t6[1]), this._active || !this._isBelowThreshold(this._vector))
                  return this._active = true, { bearingDelta: ni(this._vector, r4), pinchAround: e5 };
              }, e4.prototype._isBelowThreshold = function(t6) {
                this._minDiameter = Math.min(this._minDiameter, t6.mag());
                var e5 = 25 / (Math.PI * this._minDiameter) * 360, r4 = ni(t6, this._startVector);
                return Math.abs(r4) < e5;
              }, e4;
            }(Qn);
            function ai(t5) {
              return Math.abs(t5.y) > Math.abs(t5.x);
            }
            var oi = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4.prototype.reset = function() {
                t5.prototype.reset.call(this), this._valid = void 0, delete this._firstMove, delete this._lastPoints;
              }, e4.prototype._start = function(t6) {
                this._lastPoints = t6, ai(t6[0].sub(t6[1])) && (this._valid = false);
              }, e4.prototype._move = function(t6, e5, r4) {
                var n4 = t6[0].sub(this._lastPoints[0]), i2 = t6[1].sub(this._lastPoints[1]);
                if (this._valid = this.gestureBeginsVertically(n4, i2, r4.timeStamp), this._valid)
                  return this._lastPoints = t6, this._active = true, { pitchDelta: (n4.y + i2.y) / 2 * -0.5 };
              }, e4.prototype.gestureBeginsVertically = function(t6, e5, r4) {
                if (void 0 !== this._valid)
                  return this._valid;
                var n4 = t6.mag() >= 2, i2 = e5.mag() >= 2;
                if (n4 || i2) {
                  if (!n4 || !i2)
                    return void 0 === this._firstMove && (this._firstMove = r4), r4 - this._firstMove < 100 && void 0;
                  var a2 = t6.y > 0 == e5.y > 0;
                  return ai(t6) && ai(e5) && a2;
                }
              }, e4;
            }(Qn), si = { panStep: 100, bearingStep: 15, pitchStep: 10 }, li = function() {
              var t5 = si;
              this._panStep = t5.panStep, this._bearingStep = t5.bearingStep, this._pitchStep = t5.pitchStep;
            };
            function ui(t5) {
              return t5 * (2 - t5);
            }
            li.prototype.reset = function() {
              this._active = false;
            }, li.prototype.keydown = function(t5) {
              var e4 = this;
              if (!(t5.altKey || t5.ctrlKey || t5.metaKey)) {
                var r4 = 0, n4 = 0, i2 = 0, a2 = 0, o2 = 0;
                switch (t5.keyCode) {
                  case 61:
                  case 107:
                  case 171:
                  case 187:
                    r4 = 1;
                    break;
                  case 189:
                  case 109:
                  case 173:
                    r4 = -1;
                    break;
                  case 37:
                    t5.shiftKey ? n4 = -1 : (t5.preventDefault(), a2 = -1);
                    break;
                  case 39:
                    t5.shiftKey ? n4 = 1 : (t5.preventDefault(), a2 = 1);
                    break;
                  case 38:
                    t5.shiftKey ? i2 = 1 : (t5.preventDefault(), o2 = -1);
                    break;
                  case 40:
                    t5.shiftKey ? i2 = -1 : (t5.preventDefault(), o2 = 1);
                    break;
                  default:
                    return;
                }
                return { cameraAnimation: function(s2) {
                  var l2 = s2.getZoom();
                  s2.easeTo({ duration: 300, easeId: "keyboardHandler", easing: ui, zoom: r4 ? Math.round(l2) + r4 * (t5.shiftKey ? 2 : 1) : l2, bearing: s2.getBearing() + n4 * e4._bearingStep, pitch: s2.getPitch() + i2 * e4._pitchStep, offset: [-a2 * e4._panStep, -o2 * e4._panStep], center: s2.getCenter() }, { originalEvent: t5 });
                } };
              }
            }, li.prototype.enable = function() {
              this._enabled = true;
            }, li.prototype.disable = function() {
              this._enabled = false, this.reset();
            }, li.prototype.isEnabled = function() {
              return this._enabled;
            }, li.prototype.isActive = function() {
              return this._active;
            };
            var ci = 4.000244140625, fi = function(e4, r4) {
              this._map = e4, this._el = e4.getCanvasContainer(), this._handler = r4, this._delta = 0, this._defaultZoomRate = 0.01, this._wheelZoomRate = 0.0022222222222222222, t4.bindAll(["_onWheel", "_onTimeout", "_onScrollFrame", "_onScrollFinished"], this);
            };
            fi.prototype.setZoomRate = function(t5) {
              this._defaultZoomRate = t5;
            }, fi.prototype.setWheelZoomRate = function(t5) {
              this._wheelZoomRate = t5;
            }, fi.prototype.isEnabled = function() {
              return !!this._enabled;
            }, fi.prototype.isActive = function() {
              return !!this._active || void 0 !== this._finishTimeout;
            }, fi.prototype.isZooming = function() {
              return !!this._zooming;
            }, fi.prototype.enable = function(t5) {
              this.isEnabled() || (this._enabled = true, this._aroundCenter = t5 && "center" === t5.around);
            }, fi.prototype.disable = function() {
              this.isEnabled() && (this._enabled = false);
            }, fi.prototype.wheel = function(e4) {
              if (this.isEnabled()) {
                var r4 = e4.deltaMode === t4.window.WheelEvent.DOM_DELTA_LINE ? 40 * e4.deltaY : e4.deltaY, n4 = t4.browser.now(), i2 = n4 - (this._lastWheelEventTime || 0);
                this._lastWheelEventTime = n4, 0 !== r4 && r4 % ci == 0 ? this._type = "wheel" : 0 !== r4 && Math.abs(r4) < 4 ? this._type = "trackpad" : i2 > 400 ? (this._type = null, this._lastValue = r4, this._timeout = setTimeout(this._onTimeout, 40, e4)) : this._type || (this._type = Math.abs(i2 * r4) < 200 ? "trackpad" : "wheel", this._timeout && (clearTimeout(this._timeout), this._timeout = null, r4 += this._lastValue)), e4.shiftKey && r4 && (r4 /= 4), this._type && (this._lastWheelEvent = e4, this._delta -= r4, this._active || this._start(e4)), e4.preventDefault();
              }
            }, fi.prototype._onTimeout = function(t5) {
              this._type = "wheel", this._delta -= this._lastValue, this._active || this._start(t5);
            }, fi.prototype._start = function(e4) {
              if (this._delta) {
                this._frameId && (this._frameId = null), this._active = true, this.isZooming() || (this._zooming = true), this._finishTimeout && (clearTimeout(this._finishTimeout), delete this._finishTimeout);
                var n4 = r3.mousePos(this._el, e4);
                this._around = t4.LngLat.convert(this._aroundCenter ? this._map.getCenter() : this._map.unproject(n4)), this._aroundPoint = this._map.transform.locationPoint(this._around), this._frameId || (this._frameId = true, this._handler._triggerRenderFrame());
              }
            }, fi.prototype.renderFrame = function() {
              return this._onScrollFrame();
            }, fi.prototype._onScrollFrame = function() {
              var e4 = this;
              if (this._frameId && (this._frameId = null, this.isActive())) {
                var r4 = this._map.transform;
                if (0 !== this._delta) {
                  var n4 = "wheel" === this._type && Math.abs(this._delta) > ci ? this._wheelZoomRate : this._defaultZoomRate, i2 = 2 / (1 + Math.exp(-Math.abs(this._delta * n4)));
                  this._delta < 0 && 0 !== i2 && (i2 = 1 / i2);
                  var a2 = "number" == typeof this._targetZoom ? r4.zoomScale(this._targetZoom) : r4.scale;
                  this._targetZoom = Math.min(r4.maxZoom, Math.max(r4.minZoom, r4.scaleZoom(a2 * i2))), "wheel" === this._type && (this._startZoom = r4.zoom, this._easing = this._smoothOutEasing(200)), this._delta = 0;
                }
                var o2, s2 = "number" == typeof this._targetZoom ? this._targetZoom : r4.zoom, l2 = this._startZoom, u2 = this._easing, c2 = false;
                if ("wheel" === this._type && l2 && u2) {
                  var f3 = Math.min((t4.browser.now() - this._lastWheelEventTime) / 200, 1), h2 = u2(f3);
                  o2 = t4.number(l2, s2, h2), f3 < 1 ? this._frameId || (this._frameId = true) : c2 = true;
                } else
                  o2 = s2, c2 = true;
                return this._active = true, c2 && (this._active = false, this._finishTimeout = setTimeout(function() {
                  e4._zooming = false, e4._handler._triggerRenderFrame(), delete e4._targetZoom, delete e4._finishTimeout;
                }, 200)), { noInertia: true, needsRenderFrame: !c2, zoomDelta: o2 - r4.zoom, around: this._aroundPoint, originalEvent: this._lastWheelEvent };
              }
            }, fi.prototype._smoothOutEasing = function(e4) {
              var r4 = t4.ease;
              if (this._prevEase) {
                var n4 = this._prevEase, i2 = (t4.browser.now() - n4.start) / n4.duration, a2 = n4.easing(i2 + 0.01) - n4.easing(i2), o2 = 0.27 / Math.sqrt(a2 * a2 + 1e-4) * 0.01, s2 = Math.sqrt(0.0729 - o2 * o2);
                r4 = t4.bezier(o2, s2, 0.25, 1);
              }
              return this._prevEase = { start: t4.browser.now(), duration: e4, easing: r4 }, r4;
            }, fi.prototype.reset = function() {
              this._active = false;
            };
            var hi = function(t5, e4) {
              this._clickZoom = t5, this._tapZoom = e4;
            };
            hi.prototype.enable = function() {
              this._clickZoom.enable(), this._tapZoom.enable();
            }, hi.prototype.disable = function() {
              this._clickZoom.disable(), this._tapZoom.disable();
            }, hi.prototype.isEnabled = function() {
              return this._clickZoom.isEnabled() && this._tapZoom.isEnabled();
            }, hi.prototype.isActive = function() {
              return this._clickZoom.isActive() || this._tapZoom.isActive();
            };
            var pi = function() {
              this.reset();
            };
            pi.prototype.reset = function() {
              this._active = false;
            }, pi.prototype.dblclick = function(t5, e4) {
              return t5.preventDefault(), { cameraAnimation: function(r4) {
                r4.easeTo({ duration: 300, zoom: r4.getZoom() + (t5.shiftKey ? -1 : 1), around: r4.unproject(e4) }, { originalEvent: t5 });
              } };
            }, pi.prototype.enable = function() {
              this._enabled = true;
            }, pi.prototype.disable = function() {
              this._enabled = false, this.reset();
            }, pi.prototype.isEnabled = function() {
              return this._enabled;
            }, pi.prototype.isActive = function() {
              return this._active;
            };
            var di = function() {
              this._tap = new Zn({ numTouches: 1, numTaps: 1 }), this.reset();
            };
            di.prototype.reset = function() {
              this._active = false, delete this._swipePoint, delete this._swipeTouch, delete this._tapTime, this._tap.reset();
            }, di.prototype.touchstart = function(t5, e4, r4) {
              this._swipePoint || (this._tapTime && t5.timeStamp - this._tapTime > 500 && this.reset(), this._tapTime ? r4.length > 0 && (this._swipePoint = e4[0], this._swipeTouch = r4[0].identifier) : this._tap.touchstart(t5, e4, r4));
            }, di.prototype.touchmove = function(t5, e4, r4) {
              if (this._tapTime) {
                if (this._swipePoint) {
                  if (r4[0].identifier !== this._swipeTouch)
                    return;
                  var n4 = e4[0], i2 = n4.y - this._swipePoint.y;
                  return this._swipePoint = n4, t5.preventDefault(), this._active = true, { zoomDelta: i2 / 128 };
                }
              } else
                this._tap.touchmove(t5, e4, r4);
            }, di.prototype.touchend = function(t5, e4, r4) {
              this._tapTime ? this._swipePoint && 0 === r4.length && this.reset() : this._tap.touchend(t5, e4, r4) && (this._tapTime = t5.timeStamp);
            }, di.prototype.touchcancel = function() {
              this.reset();
            }, di.prototype.enable = function() {
              this._enabled = true;
            }, di.prototype.disable = function() {
              this._enabled = false, this.reset();
            }, di.prototype.isEnabled = function() {
              return this._enabled;
            }, di.prototype.isActive = function() {
              return this._active;
            };
            var vi = function(t5, e4, r4) {
              this._el = t5, this._mousePan = e4, this._touchPan = r4;
            };
            vi.prototype.enable = function(t5) {
              this._inertiaOptions = t5 || {}, this._mousePan.enable(), this._touchPan.enable(), this._el.classList.add("mapboxgl-touch-drag-pan");
            }, vi.prototype.disable = function() {
              this._mousePan.disable(), this._touchPan.disable(), this._el.classList.remove("mapboxgl-touch-drag-pan");
            }, vi.prototype.isEnabled = function() {
              return this._mousePan.isEnabled() && this._touchPan.isEnabled();
            }, vi.prototype.isActive = function() {
              return this._mousePan.isActive() || this._touchPan.isActive();
            };
            var gi = function(t5, e4, r4) {
              this._pitchWithRotate = t5.pitchWithRotate, this._mouseRotate = e4, this._mousePitch = r4;
            };
            gi.prototype.enable = function() {
              this._mouseRotate.enable(), this._pitchWithRotate && this._mousePitch.enable();
            }, gi.prototype.disable = function() {
              this._mouseRotate.disable(), this._mousePitch.disable();
            }, gi.prototype.isEnabled = function() {
              return this._mouseRotate.isEnabled() && (!this._pitchWithRotate || this._mousePitch.isEnabled());
            }, gi.prototype.isActive = function() {
              return this._mouseRotate.isActive() || this._mousePitch.isActive();
            };
            var yi = function(t5, e4, r4, n4) {
              this._el = t5, this._touchZoom = e4, this._touchRotate = r4, this._tapDragZoom = n4, this._rotationDisabled = false, this._enabled = true;
            };
            yi.prototype.enable = function(t5) {
              this._touchZoom.enable(t5), this._rotationDisabled || this._touchRotate.enable(t5), this._tapDragZoom.enable(), this._el.classList.add("mapboxgl-touch-zoom-rotate");
            }, yi.prototype.disable = function() {
              this._touchZoom.disable(), this._touchRotate.disable(), this._tapDragZoom.disable(), this._el.classList.remove("mapboxgl-touch-zoom-rotate");
            }, yi.prototype.isEnabled = function() {
              return this._touchZoom.isEnabled() && (this._rotationDisabled || this._touchRotate.isEnabled()) && this._tapDragZoom.isEnabled();
            }, yi.prototype.isActive = function() {
              return this._touchZoom.isActive() || this._touchRotate.isActive() || this._tapDragZoom.isActive();
            }, yi.prototype.disableRotation = function() {
              this._rotationDisabled = true, this._touchRotate.disable();
            }, yi.prototype.enableRotation = function() {
              this._rotationDisabled = false, this._touchZoom.isEnabled() && this._touchRotate.enable();
            };
            var mi = function(t5) {
              return t5.zoom || t5.drag || t5.pitch || t5.rotate;
            }, xi = function(t5) {
              function e4() {
                t5.apply(this, arguments);
              }
              return t5 && (e4.__proto__ = t5), e4.prototype = Object.create(t5 && t5.prototype), e4.prototype.constructor = e4, e4;
            }(t4.Event);
            function bi(t5) {
              return t5.panDelta && t5.panDelta.mag() || t5.zoomDelta || t5.bearingDelta || t5.pitchDelta;
            }
            var _i = function(e4, n4) {
              this._map = e4, this._el = this._map.getCanvasContainer(), this._handlers = [], this._handlersById = {}, this._changes = [], this._inertia = new zn(e4), this._bearingSnap = n4.bearingSnap, this._previousActiveHandlers = {}, this._eventsInProgress = {}, this._addDefaultHandlers(n4), t4.bindAll(["handleEvent", "handleWindowEvent"], this);
              var i2 = this._el;
              this._listeners = [[i2, "touchstart", { passive: false }], [i2, "touchmove", { passive: false }], [i2, "touchend", void 0], [i2, "touchcancel", void 0], [i2, "mousedown", void 0], [i2, "mousemove", void 0], [i2, "mouseup", void 0], [t4.window.document, "mousemove", { capture: true }], [t4.window.document, "mouseup", void 0], [i2, "mouseover", void 0], [i2, "mouseout", void 0], [i2, "dblclick", void 0], [i2, "click", void 0], [i2, "keydown", { capture: false }], [i2, "keyup", void 0], [i2, "wheel", { passive: false }], [i2, "contextmenu", void 0], [t4.window, "blur", void 0]];
              for (var a2 = 0, o2 = this._listeners; a2 < o2.length; a2 += 1) {
                var s2 = o2[a2], l2 = s2[0], u2 = s2[1], c2 = s2[2];
                r3.addEventListener(l2, u2, l2 === t4.window.document ? this.handleWindowEvent : this.handleEvent, c2);
              }
            };
            _i.prototype.destroy = function() {
              for (var e4 = 0, n4 = this._listeners; e4 < n4.length; e4 += 1) {
                var i2 = n4[e4], a2 = i2[0], o2 = i2[1], s2 = i2[2];
                r3.removeEventListener(a2, o2, a2 === t4.window.document ? this.handleWindowEvent : this.handleEvent, s2);
              }
            }, _i.prototype._addDefaultHandlers = function(t5) {
              var e4 = this._map, r4 = e4.getCanvasContainer();
              this._add("mapEvent", new Un(e4, t5));
              var n4 = e4.boxZoom = new Hn(e4, t5);
              this._add("boxZoom", n4);
              var i2 = new Yn(), a2 = new pi();
              e4.doubleClickZoom = new hi(a2, i2), this._add("tapZoom", i2), this._add("clickZoom", a2);
              var o2 = new di();
              this._add("tapDragZoom", o2);
              var s2 = e4.touchPitch = new oi();
              this._add("touchPitch", s2);
              var l2 = new Jn(t5), u2 = new Kn(t5);
              e4.dragRotate = new gi(t5, l2, u2), this._add("mouseRotate", l2, ["mousePitch"]), this._add("mousePitch", u2, ["mouseRotate"]);
              var c2 = new Xn(t5), f3 = new $n(t5);
              e4.dragPan = new vi(r4, c2, f3), this._add("mousePan", c2), this._add("touchPan", f3, ["touchZoom", "touchRotate"]);
              var h2 = new ii(), p3 = new ri();
              e4.touchZoomRotate = new yi(r4, p3, h2, o2), this._add("touchRotate", h2, ["touchPan", "touchZoom"]), this._add("touchZoom", p3, ["touchPan", "touchRotate"]);
              var d3 = e4.scrollZoom = new fi(e4, this);
              this._add("scrollZoom", d3, ["mousePan"]);
              var v2 = e4.keyboard = new li();
              this._add("keyboard", v2), this._add("blockableMapEvent", new Vn(e4));
              for (var g3 = 0, y2 = ["boxZoom", "doubleClickZoom", "tapDragZoom", "touchPitch", "dragRotate", "dragPan", "touchZoomRotate", "scrollZoom", "keyboard"]; g3 < y2.length; g3 += 1) {
                var m3 = y2[g3];
                t5.interactive && t5[m3] && e4[m3].enable(t5[m3]);
              }
            }, _i.prototype._add = function(t5, e4, r4) {
              this._handlers.push({ handlerName: t5, handler: e4, allowed: r4 }), this._handlersById[t5] = e4;
            }, _i.prototype.stop = function() {
              if (!this._updatingCamera) {
                for (var t5 = 0, e4 = this._handlers; t5 < e4.length; t5 += 1)
                  e4[t5].handler.reset();
                this._inertia.clear(), this._fireEvents({}, {}), this._changes = [];
              }
            }, _i.prototype.isActive = function() {
              for (var t5 = 0, e4 = this._handlers; t5 < e4.length; t5 += 1)
                if (e4[t5].handler.isActive())
                  return true;
              return false;
            }, _i.prototype.isZooming = function() {
              return !!this._eventsInProgress.zoom || this._map.scrollZoom.isZooming();
            }, _i.prototype.isRotating = function() {
              return !!this._eventsInProgress.rotate;
            }, _i.prototype.isMoving = function() {
              return Boolean(mi(this._eventsInProgress)) || this.isZooming();
            }, _i.prototype._blockedByActive = function(t5, e4, r4) {
              for (var n4 in t5)
                if (n4 !== r4 && (!e4 || e4.indexOf(n4) < 0))
                  return true;
              return false;
            }, _i.prototype.handleWindowEvent = function(t5) {
              this.handleEvent(t5, t5.type + "Window");
            }, _i.prototype._getMapTouches = function(t5) {
              for (var e4 = [], r4 = 0, n4 = t5; r4 < n4.length; r4 += 1) {
                var i2 = n4[r4], a2 = i2.target;
                this._el.contains(a2) && e4.push(i2);
              }
              return e4;
            }, _i.prototype.handleEvent = function(t5, e4) {
              if ("blur" !== t5.type) {
                this._updatingCamera = true;
                for (var n4 = "renderFrame" === t5.type ? void 0 : t5, i2 = { needsRenderFrame: false }, a2 = {}, o2 = {}, s2 = t5.touches ? this._getMapTouches(t5.touches) : void 0, l2 = s2 ? r3.touchPos(this._el, s2) : r3.mousePos(this._el, t5), u2 = 0, c2 = this._handlers; u2 < c2.length; u2 += 1) {
                  var f3 = c2[u2], h2 = f3.handlerName, p3 = f3.handler, d3 = f3.allowed;
                  if (p3.isEnabled()) {
                    var v2 = void 0;
                    this._blockedByActive(o2, d3, h2) ? p3.reset() : p3[e4 || t5.type] && (v2 = p3[e4 || t5.type](t5, l2, s2), this.mergeHandlerResult(i2, a2, v2, h2, n4), v2 && v2.needsRenderFrame && this._triggerRenderFrame()), (v2 || p3.isActive()) && (o2[h2] = p3);
                  }
                }
                var g3 = {};
                for (var y2 in this._previousActiveHandlers)
                  o2[y2] || (g3[y2] = n4);
                this._previousActiveHandlers = o2, (Object.keys(g3).length || bi(i2)) && (this._changes.push([i2, a2, g3]), this._triggerRenderFrame()), (Object.keys(o2).length || bi(i2)) && this._map._stop(true), this._updatingCamera = false;
                var m3 = i2.cameraAnimation;
                m3 && (this._inertia.clear(), this._fireEvents({}, {}), this._changes = [], m3(this._map));
              } else
                this.stop();
            }, _i.prototype.mergeHandlerResult = function(e4, r4, n4, i2, a2) {
              if (n4) {
                t4.extend(e4, n4);
                var o2 = { handlerName: i2, originalEvent: n4.originalEvent || a2 };
                void 0 !== n4.zoomDelta && (r4.zoom = o2), void 0 !== n4.panDelta && (r4.drag = o2), void 0 !== n4.pitchDelta && (r4.pitch = o2), void 0 !== n4.bearingDelta && (r4.rotate = o2);
              }
            }, _i.prototype._applyChanges = function() {
              for (var e4 = {}, r4 = {}, n4 = {}, i2 = 0, a2 = this._changes; i2 < a2.length; i2 += 1) {
                var o2 = a2[i2], s2 = o2[0], l2 = o2[1], u2 = o2[2];
                s2.panDelta && (e4.panDelta = (e4.panDelta || new t4.Point(0, 0))._add(s2.panDelta)), s2.zoomDelta && (e4.zoomDelta = (e4.zoomDelta || 0) + s2.zoomDelta), s2.bearingDelta && (e4.bearingDelta = (e4.bearingDelta || 0) + s2.bearingDelta), s2.pitchDelta && (e4.pitchDelta = (e4.pitchDelta || 0) + s2.pitchDelta), void 0 !== s2.around && (e4.around = s2.around), void 0 !== s2.pinchAround && (e4.pinchAround = s2.pinchAround), s2.noInertia && (e4.noInertia = s2.noInertia), t4.extend(r4, l2), t4.extend(n4, u2);
              }
              this._updateMapTransform(e4, r4, n4), this._changes = [];
            }, _i.prototype._updateMapTransform = function(t5, e4, r4) {
              var n4 = this._map, i2 = n4.transform;
              if (!bi(t5))
                return this._fireEvents(e4, r4);
              var a2 = t5.panDelta, o2 = t5.zoomDelta, s2 = t5.bearingDelta, l2 = t5.pitchDelta, u2 = t5.around, c2 = t5.pinchAround;
              void 0 !== c2 && (u2 = c2), n4._stop(true), u2 = u2 || n4.transform.centerPoint;
              var f3 = i2.pointLocation(a2 ? u2.sub(a2) : u2);
              s2 && (i2.bearing += s2), l2 && (i2.pitch += l2), o2 && (i2.zoom += o2), i2.setLocationAtPoint(f3, u2), this._map._update(), t5.noInertia || this._inertia.record(t5), this._fireEvents(e4, r4);
            }, _i.prototype._fireEvents = function(e4, r4) {
              var n4 = this, i2 = mi(this._eventsInProgress), a2 = mi(e4), o2 = {};
              for (var s2 in e4) {
                var l2 = e4[s2].originalEvent;
                this._eventsInProgress[s2] || (o2[s2 + "start"] = l2), this._eventsInProgress[s2] = e4[s2];
              }
              for (var u2 in !i2 && a2 && this._fireEvent("movestart", a2.originalEvent), o2)
                this._fireEvent(u2, o2[u2]);
              for (var c2 in e4.rotate && (this._bearingChanged = true), a2 && this._fireEvent("move", a2.originalEvent), e4) {
                var f3 = e4[c2].originalEvent;
                this._fireEvent(c2, f3);
              }
              var h2, p3 = {};
              for (var d3 in this._eventsInProgress) {
                var v2 = this._eventsInProgress[d3], g3 = v2.handlerName, y2 = v2.originalEvent;
                this._handlersById[g3].isActive() || (delete this._eventsInProgress[d3], h2 = r4[g3] || y2, p3[d3 + "end"] = h2);
              }
              for (var m3 in p3)
                this._fireEvent(m3, p3[m3]);
              var x2 = mi(this._eventsInProgress);
              if ((i2 || a2) && !x2) {
                this._updatingCamera = true;
                var b2 = this._inertia._onMoveEnd(this._map.dragPan._inertiaOptions), _2 = function(t5) {
                  return 0 !== t5 && -n4._bearingSnap < t5 && t5 < n4._bearingSnap;
                };
                b2 ? (_2(b2.bearing || this._map.getBearing()) && (b2.bearing = 0), this._map.easeTo(b2, { originalEvent: h2 })) : (this._map.fire(new t4.Event("moveend", { originalEvent: h2 })), _2(this._map.getBearing()) && this._map.resetNorth()), this._bearingChanged = false, this._updatingCamera = false;
              }
            }, _i.prototype._fireEvent = function(e4, r4) {
              this._map.fire(new t4.Event(e4, r4 ? { originalEvent: r4 } : {}));
            }, _i.prototype._triggerRenderFrame = function() {
              var t5 = this;
              void 0 === this._frameId && (this._frameId = this._map._requestRenderFrame(function(e4) {
                delete t5._frameId, t5.handleEvent(new xi("renderFrame", { timeStamp: e4 })), t5._applyChanges();
              }));
            };
            var wi = function(e4) {
              function r4(r5, n4) {
                e4.call(this), this._moving = false, this._zooming = false, this.transform = r5, this._bearingSnap = n4.bearingSnap, t4.bindAll(["_renderFrameCallback"], this);
              }
              return e4 && (r4.__proto__ = e4), r4.prototype = Object.create(e4 && e4.prototype), r4.prototype.constructor = r4, r4.prototype.getCenter = function() {
                return new t4.LngLat(this.transform.center.lng, this.transform.center.lat);
              }, r4.prototype.setCenter = function(t5, e5) {
                return this.jumpTo({ center: t5 }, e5);
              }, r4.prototype.panBy = function(e5, r5, n4) {
                return e5 = t4.Point.convert(e5).mult(-1), this.panTo(this.transform.center, t4.extend({ offset: e5 }, r5), n4);
              }, r4.prototype.panTo = function(e5, r5, n4) {
                return this.easeTo(t4.extend({ center: e5 }, r5), n4);
              }, r4.prototype.getZoom = function() {
                return this.transform.zoom;
              }, r4.prototype.setZoom = function(t5, e5) {
                return this.jumpTo({ zoom: t5 }, e5), this;
              }, r4.prototype.zoomTo = function(e5, r5, n4) {
                return this.easeTo(t4.extend({ zoom: e5 }, r5), n4);
              }, r4.prototype.zoomIn = function(t5, e5) {
                return this.zoomTo(this.getZoom() + 1, t5, e5), this;
              }, r4.prototype.zoomOut = function(t5, e5) {
                return this.zoomTo(this.getZoom() - 1, t5, e5), this;
              }, r4.prototype.getBearing = function() {
                return this.transform.bearing;
              }, r4.prototype.setBearing = function(t5, e5) {
                return this.jumpTo({ bearing: t5 }, e5), this;
              }, r4.prototype.getPadding = function() {
                return this.transform.padding;
              }, r4.prototype.setPadding = function(t5, e5) {
                return this.jumpTo({ padding: t5 }, e5), this;
              }, r4.prototype.rotateTo = function(e5, r5, n4) {
                return this.easeTo(t4.extend({ bearing: e5 }, r5), n4);
              }, r4.prototype.resetNorth = function(e5, r5) {
                return this.rotateTo(0, t4.extend({ duration: 1e3 }, e5), r5), this;
              }, r4.prototype.resetNorthPitch = function(e5, r5) {
                return this.easeTo(t4.extend({ bearing: 0, pitch: 0, duration: 1e3 }, e5), r5), this;
              }, r4.prototype.snapToNorth = function(t5, e5) {
                return Math.abs(this.getBearing()) < this._bearingSnap ? this.resetNorth(t5, e5) : this;
              }, r4.prototype.getPitch = function() {
                return this.transform.pitch;
              }, r4.prototype.setPitch = function(t5, e5) {
                return this.jumpTo({ pitch: t5 }, e5), this;
              }, r4.prototype.cameraForBounds = function(e5, r5) {
                return e5 = t4.LngLatBounds.convert(e5), this._cameraForBoxAndBearing(e5.getNorthWest(), e5.getSouthEast(), 0, r5);
              }, r4.prototype._cameraForBoxAndBearing = function(e5, r5, n4, i2) {
                var a2 = { top: 0, bottom: 0, right: 0, left: 0 };
                if ("number" == typeof (i2 = t4.extend({ padding: a2, offset: [0, 0], maxZoom: this.transform.maxZoom }, i2)).padding) {
                  var o2 = i2.padding;
                  i2.padding = { top: o2, bottom: o2, right: o2, left: o2 };
                }
                i2.padding = t4.extend(a2, i2.padding);
                var s2 = this.transform, l2 = s2.padding, u2 = s2.project(t4.LngLat.convert(e5)), c2 = s2.project(t4.LngLat.convert(r5)), f3 = u2.rotate(-n4 * Math.PI / 180), h2 = c2.rotate(-n4 * Math.PI / 180), p3 = new t4.Point(Math.max(f3.x, h2.x), Math.max(f3.y, h2.y)), d3 = new t4.Point(Math.min(f3.x, h2.x), Math.min(f3.y, h2.y)), v2 = p3.sub(d3), g3 = (s2.width - (l2.left + l2.right + i2.padding.left + i2.padding.right)) / v2.x, y2 = (s2.height - (l2.top + l2.bottom + i2.padding.top + i2.padding.bottom)) / v2.y;
                if (!(y2 < 0 || g3 < 0)) {
                  var m3 = Math.min(s2.scaleZoom(s2.scale * Math.min(g3, y2)), i2.maxZoom), x2 = t4.Point.convert(i2.offset), b2 = (i2.padding.left - i2.padding.right) / 2, _2 = (i2.padding.top - i2.padding.bottom) / 2, w3 = new t4.Point(x2.x + b2, x2.y + _2).mult(s2.scale / s2.zoomScale(m3));
                  return { center: s2.unproject(u2.add(c2).div(2).sub(w3)), zoom: m3, bearing: n4 };
                }
                t4.warnOnce("Map cannot fit within canvas with the given bounds, padding, and/or offset.");
              }, r4.prototype.fitBounds = function(t5, e5, r5) {
                return this._fitInternal(this.cameraForBounds(t5, e5), e5, r5);
              }, r4.prototype.fitScreenCoordinates = function(e5, r5, n4, i2, a2) {
                return this._fitInternal(this._cameraForBoxAndBearing(this.transform.pointLocation(t4.Point.convert(e5)), this.transform.pointLocation(t4.Point.convert(r5)), n4, i2), i2, a2);
              }, r4.prototype._fitInternal = function(e5, r5, n4) {
                return e5 ? (delete (r5 = t4.extend(e5, r5)).padding, r5.linear ? this.easeTo(r5, n4) : this.flyTo(r5, n4)) : this;
              }, r4.prototype.jumpTo = function(e5, r5) {
                this.stop();
                var n4 = this.transform, i2 = false, a2 = false, o2 = false;
                return "zoom" in e5 && n4.zoom !== +e5.zoom && (i2 = true, n4.zoom = +e5.zoom), void 0 !== e5.center && (n4.center = t4.LngLat.convert(e5.center)), "bearing" in e5 && n4.bearing !== +e5.bearing && (a2 = true, n4.bearing = +e5.bearing), "pitch" in e5 && n4.pitch !== +e5.pitch && (o2 = true, n4.pitch = +e5.pitch), null == e5.padding || n4.isPaddingEqual(e5.padding) || (n4.padding = e5.padding), this.fire(new t4.Event("movestart", r5)).fire(new t4.Event("move", r5)), i2 && this.fire(new t4.Event("zoomstart", r5)).fire(new t4.Event("zoom", r5)).fire(new t4.Event("zoomend", r5)), a2 && this.fire(new t4.Event("rotatestart", r5)).fire(new t4.Event("rotate", r5)).fire(new t4.Event("rotateend", r5)), o2 && this.fire(new t4.Event("pitchstart", r5)).fire(new t4.Event("pitch", r5)).fire(new t4.Event("pitchend", r5)), this.fire(new t4.Event("moveend", r5));
              }, r4.prototype.easeTo = function(e5, r5) {
                var n4 = this;
                this._stop(false, e5.easeId), (false === (e5 = t4.extend({ offset: [0, 0], duration: 500, easing: t4.ease }, e5)).animate || !e5.essential && t4.browser.prefersReducedMotion) && (e5.duration = 0);
                var i2 = this.transform, a2 = this.getZoom(), o2 = this.getBearing(), s2 = this.getPitch(), l2 = this.getPadding(), u2 = "zoom" in e5 ? +e5.zoom : a2, c2 = "bearing" in e5 ? this._normalizeBearing(e5.bearing, o2) : o2, f3 = "pitch" in e5 ? +e5.pitch : s2, h2 = "padding" in e5 ? e5.padding : i2.padding, p3 = t4.Point.convert(e5.offset), d3 = i2.centerPoint.add(p3), v2 = i2.pointLocation(d3), g3 = t4.LngLat.convert(e5.center || v2);
                this._normalizeCenter(g3);
                var y2, m3, x2 = i2.project(v2), b2 = i2.project(g3).sub(x2), _2 = i2.zoomScale(u2 - a2);
                e5.around && (y2 = t4.LngLat.convert(e5.around), m3 = i2.locationPoint(y2));
                var w3 = { moving: this._moving, zooming: this._zooming, rotating: this._rotating, pitching: this._pitching };
                return this._zooming = this._zooming || u2 !== a2, this._rotating = this._rotating || o2 !== c2, this._pitching = this._pitching || f3 !== s2, this._padding = !i2.isPaddingEqual(h2), this._easeId = e5.easeId, this._prepareEase(r5, e5.noMoveStart, w3), clearTimeout(this._easeEndTimeoutID), this._ease(function(e6) {
                  if (n4._zooming && (i2.zoom = t4.number(a2, u2, e6)), n4._rotating && (i2.bearing = t4.number(o2, c2, e6)), n4._pitching && (i2.pitch = t4.number(s2, f3, e6)), n4._padding && (i2.interpolatePadding(l2, h2, e6), d3 = i2.centerPoint.add(p3)), y2)
                    i2.setLocationAtPoint(y2, m3);
                  else {
                    var v3 = i2.zoomScale(i2.zoom - a2), g4 = u2 > a2 ? Math.min(2, _2) : Math.max(0.5, _2), w4 = Math.pow(g4, 1 - e6), T2 = i2.unproject(x2.add(b2.mult(e6 * w4)).mult(v3));
                    i2.setLocationAtPoint(i2.renderWorldCopies ? T2.wrap() : T2, d3);
                  }
                  n4._fireMoveEvents(r5);
                }, function(t5) {
                  n4._afterEase(r5, t5);
                }, e5), this;
              }, r4.prototype._prepareEase = function(e5, r5, n4) {
                void 0 === n4 && (n4 = {}), this._moving = true, r5 || n4.moving || this.fire(new t4.Event("movestart", e5)), this._zooming && !n4.zooming && this.fire(new t4.Event("zoomstart", e5)), this._rotating && !n4.rotating && this.fire(new t4.Event("rotatestart", e5)), this._pitching && !n4.pitching && this.fire(new t4.Event("pitchstart", e5));
              }, r4.prototype._fireMoveEvents = function(e5) {
                this.fire(new t4.Event("move", e5)), this._zooming && this.fire(new t4.Event("zoom", e5)), this._rotating && this.fire(new t4.Event("rotate", e5)), this._pitching && this.fire(new t4.Event("pitch", e5));
              }, r4.prototype._afterEase = function(e5, r5) {
                if (!this._easeId || !r5 || this._easeId !== r5) {
                  delete this._easeId;
                  var n4 = this._zooming, i2 = this._rotating, a2 = this._pitching;
                  this._moving = false, this._zooming = false, this._rotating = false, this._pitching = false, this._padding = false, n4 && this.fire(new t4.Event("zoomend", e5)), i2 && this.fire(new t4.Event("rotateend", e5)), a2 && this.fire(new t4.Event("pitchend", e5)), this.fire(new t4.Event("moveend", e5));
                }
              }, r4.prototype.flyTo = function(e5, r5) {
                var n4 = this;
                if (!e5.essential && t4.browser.prefersReducedMotion) {
                  var i2 = t4.pick(e5, ["center", "zoom", "bearing", "pitch", "around"]);
                  return this.jumpTo(i2, r5);
                }
                this.stop(), e5 = t4.extend({ offset: [0, 0], speed: 1.2, curve: 1.42, easing: t4.ease }, e5);
                var a2 = this.transform, o2 = this.getZoom(), s2 = this.getBearing(), l2 = this.getPitch(), u2 = this.getPadding(), c2 = "zoom" in e5 ? t4.clamp(+e5.zoom, a2.minZoom, a2.maxZoom) : o2, f3 = "bearing" in e5 ? this._normalizeBearing(e5.bearing, s2) : s2, h2 = "pitch" in e5 ? +e5.pitch : l2, p3 = "padding" in e5 ? e5.padding : a2.padding, d3 = a2.zoomScale(c2 - o2), v2 = t4.Point.convert(e5.offset), g3 = a2.centerPoint.add(v2), y2 = a2.pointLocation(g3), m3 = t4.LngLat.convert(e5.center || y2);
                this._normalizeCenter(m3);
                var x2 = a2.project(y2), b2 = a2.project(m3).sub(x2), _2 = e5.curve, w3 = Math.max(a2.width, a2.height), T2 = w3 / d3, k2 = b2.mag();
                if ("minZoom" in e5) {
                  var A2 = t4.clamp(Math.min(e5.minZoom, o2, c2), a2.minZoom, a2.maxZoom), M2 = w3 / a2.zoomScale(A2 - o2);
                  _2 = Math.sqrt(M2 / k2 * 2);
                }
                var S2 = _2 * _2;
                function E2(t5) {
                  var e6 = (T2 * T2 - w3 * w3 + (t5 ? -1 : 1) * S2 * S2 * k2 * k2) / (2 * (t5 ? T2 : w3) * S2 * k2);
                  return Math.log(Math.sqrt(e6 * e6 + 1) - e6);
                }
                function L2(t5) {
                  return (Math.exp(t5) - Math.exp(-t5)) / 2;
                }
                function C2(t5) {
                  return (Math.exp(t5) + Math.exp(-t5)) / 2;
                }
                var P2 = E2(0), O2 = function(t5) {
                  return C2(P2) / C2(P2 + _2 * t5);
                }, I2 = function(t5) {
                  return w3 * ((C2(P2) * (L2(e6 = P2 + _2 * t5) / C2(e6)) - L2(P2)) / S2) / k2;
                  var e6;
                }, D2 = (E2(1) - P2) / _2;
                if (Math.abs(k2) < 1e-6 || !isFinite(D2)) {
                  if (Math.abs(w3 - T2) < 1e-6)
                    return this.easeTo(e5, r5);
                  var z2 = T2 < w3 ? -1 : 1;
                  D2 = Math.abs(Math.log(T2 / w3)) / _2, I2 = function() {
                    return 0;
                  }, O2 = function(t5) {
                    return Math.exp(z2 * _2 * t5);
                  };
                }
                if ("duration" in e5)
                  e5.duration = +e5.duration;
                else {
                  var R2 = "screenSpeed" in e5 ? +e5.screenSpeed / _2 : +e5.speed;
                  e5.duration = 1e3 * D2 / R2;
                }
                return e5.maxDuration && e5.duration > e5.maxDuration && (e5.duration = 0), this._zooming = true, this._rotating = s2 !== f3, this._pitching = h2 !== l2, this._padding = !a2.isPaddingEqual(p3), this._prepareEase(r5, false), this._ease(function(e6) {
                  var i3 = e6 * D2, d4 = 1 / O2(i3);
                  a2.zoom = 1 === e6 ? c2 : o2 + a2.scaleZoom(d4), n4._rotating && (a2.bearing = t4.number(s2, f3, e6)), n4._pitching && (a2.pitch = t4.number(l2, h2, e6)), n4._padding && (a2.interpolatePadding(u2, p3, e6), g3 = a2.centerPoint.add(v2));
                  var y3 = 1 === e6 ? m3 : a2.unproject(x2.add(b2.mult(I2(i3))).mult(d4));
                  a2.setLocationAtPoint(a2.renderWorldCopies ? y3.wrap() : y3, g3), n4._fireMoveEvents(r5);
                }, function() {
                  return n4._afterEase(r5);
                }, e5), this;
              }, r4.prototype.isEasing = function() {
                return !!this._easeFrameId;
              }, r4.prototype.stop = function() {
                return this._stop();
              }, r4.prototype._stop = function(t5, e5) {
                if (this._easeFrameId && (this._cancelRenderFrame(this._easeFrameId), delete this._easeFrameId, delete this._onEaseFrame), this._onEaseEnd) {
                  var r5 = this._onEaseEnd;
                  delete this._onEaseEnd, r5.call(this, e5);
                }
                if (!t5) {
                  var n4 = this.handlers;
                  n4 && n4.stop();
                }
                return this;
              }, r4.prototype._ease = function(e5, r5, n4) {
                false === n4.animate || 0 === n4.duration ? (e5(1), r5()) : (this._easeStart = t4.browser.now(), this._easeOptions = n4, this._onEaseFrame = e5, this._onEaseEnd = r5, this._easeFrameId = this._requestRenderFrame(this._renderFrameCallback));
              }, r4.prototype._renderFrameCallback = function() {
                var e5 = Math.min((t4.browser.now() - this._easeStart) / this._easeOptions.duration, 1);
                this._onEaseFrame(this._easeOptions.easing(e5)), e5 < 1 ? this._easeFrameId = this._requestRenderFrame(this._renderFrameCallback) : this.stop();
              }, r4.prototype._normalizeBearing = function(e5, r5) {
                e5 = t4.wrap(e5, -180, 180);
                var n4 = Math.abs(e5 - r5);
                return Math.abs(e5 - 360 - r5) < n4 && (e5 -= 360), Math.abs(e5 + 360 - r5) < n4 && (e5 += 360), e5;
              }, r4.prototype._normalizeCenter = function(t5) {
                var e5 = this.transform;
                if (e5.renderWorldCopies && !e5.lngRange) {
                  var r5 = t5.lng - e5.center.lng;
                  t5.lng += r5 > 180 ? -360 : r5 < -180 ? 360 : 0;
                }
              }, r4;
            }(t4.Evented), Ti = function(e4) {
              void 0 === e4 && (e4 = {}), this.options = e4, t4.bindAll(["_updateEditLink", "_updateData", "_updateCompact"], this);
            };
            Ti.prototype.getDefaultPosition = function() {
              return "bottom-right";
            }, Ti.prototype.onAdd = function(t5) {
              var e4 = this.options && this.options.compact;
              return this._map = t5, this._container = r3.create("div", "mapboxgl-ctrl mapboxgl-ctrl-attrib"), this._innerContainer = r3.create("div", "mapboxgl-ctrl-attrib-inner", this._container), e4 && this._container.classList.add("mapboxgl-compact"), this._updateAttributions(), this._updateEditLink(), this._map.on("styledata", this._updateData), this._map.on("sourcedata", this._updateData), this._map.on("moveend", this._updateEditLink), void 0 === e4 && (this._map.on("resize", this._updateCompact), this._updateCompact()), this._container;
            }, Ti.prototype.onRemove = function() {
              r3.remove(this._container), this._map.off("styledata", this._updateData), this._map.off("sourcedata", this._updateData), this._map.off("moveend", this._updateEditLink), this._map.off("resize", this._updateCompact), this._map = void 0, this._attribHTML = void 0;
            }, Ti.prototype._updateEditLink = function() {
              var e4 = this._editLink;
              e4 || (e4 = this._editLink = this._container.querySelector(".mapbox-improve-map"));
              var r4 = [{ key: "owner", value: this.styleOwner }, { key: "id", value: this.styleId }, { key: "access_token", value: this._map._requestManager._customAccessToken || t4.config.ACCESS_TOKEN }];
              if (e4) {
                var n4 = r4.reduce(function(t5, e5, n5) {
                  return e5.value && (t5 += e5.key + "=" + e5.value + (n5 < r4.length - 1 ? "&" : "")), t5;
                }, "?");
                e4.href = t4.config.FEEDBACK_URL + "/" + n4 + (this._map._hash ? this._map._hash.getHashString(true) : ""), e4.rel = "noopener nofollow";
              }
            }, Ti.prototype._updateData = function(t5) {
              !t5 || "metadata" !== t5.sourceDataType && "style" !== t5.dataType || (this._updateAttributions(), this._updateEditLink());
            }, Ti.prototype._updateAttributions = function() {
              if (this._map.style) {
                var t5 = [];
                if (this.options.customAttribution && (Array.isArray(this.options.customAttribution) ? t5 = t5.concat(this.options.customAttribution.map(function(t6) {
                  return "string" != typeof t6 ? "" : t6;
                })) : "string" == typeof this.options.customAttribution && t5.push(this.options.customAttribution)), this._map.style.stylesheet) {
                  var e4 = this._map.style.stylesheet;
                  this.styleOwner = e4.owner, this.styleId = e4.id;
                }
                var r4 = this._map.style.sourceCaches;
                for (var n4 in r4) {
                  var i2 = r4[n4];
                  if (i2.used) {
                    var a2 = i2.getSource();
                    a2.attribution && t5.indexOf(a2.attribution) < 0 && t5.push(a2.attribution);
                  }
                }
                t5.sort(function(t6, e5) {
                  return t6.length - e5.length;
                });
                var o2 = (t5 = t5.filter(function(e5, r5) {
                  for (var n5 = r5 + 1; n5 < t5.length; n5++)
                    if (t5[n5].indexOf(e5) >= 0)
                      return false;
                  return true;
                })).join(" | ");
                o2 !== this._attribHTML && (this._attribHTML = o2, t5.length ? (this._innerContainer.innerHTML = o2, this._container.classList.remove("mapboxgl-attrib-empty")) : this._container.classList.add("mapboxgl-attrib-empty"), this._editLink = null);
              }
            }, Ti.prototype._updateCompact = function() {
              this._map.getCanvasContainer().offsetWidth <= 640 ? this._container.classList.add("mapboxgl-compact") : this._container.classList.remove("mapboxgl-compact");
            };
            var ki = function() {
              t4.bindAll(["_updateLogo"], this), t4.bindAll(["_updateCompact"], this);
            };
            ki.prototype.onAdd = function(t5) {
              this._map = t5, this._container = r3.create("div", "mapboxgl-ctrl");
              var e4 = r3.create("a", "mapboxgl-ctrl-logo");
              return e4.target = "_blank", e4.rel = "noopener nofollow", e4.href = "https://www.mapbox.com/", e4.setAttribute("aria-label", this._map._getUIString("LogoControl.Title")), e4.setAttribute("rel", "noopener nofollow"), this._container.appendChild(e4), this._container.style.display = "none", this._map.on("sourcedata", this._updateLogo), this._updateLogo(), this._map.on("resize", this._updateCompact), this._updateCompact(), this._container;
            }, ki.prototype.onRemove = function() {
              r3.remove(this._container), this._map.off("sourcedata", this._updateLogo), this._map.off("resize", this._updateCompact);
            }, ki.prototype.getDefaultPosition = function() {
              return "bottom-left";
            }, ki.prototype._updateLogo = function(t5) {
              t5 && "metadata" !== t5.sourceDataType || (this._container.style.display = this._logoRequired() ? "block" : "none");
            }, ki.prototype._logoRequired = function() {
              if (this._map.style) {
                var t5 = this._map.style.sourceCaches;
                for (var e4 in t5)
                  if (t5[e4].getSource().mapbox_logo)
                    return true;
                return false;
              }
            }, ki.prototype._updateCompact = function() {
              var t5 = this._container.children;
              if (t5.length) {
                var e4 = t5[0];
                this._map.getCanvasContainer().offsetWidth < 250 ? e4.classList.add("mapboxgl-compact") : e4.classList.remove("mapboxgl-compact");
              }
            };
            var Ai = function() {
              this._queue = [], this._id = 0, this._cleared = false, this._currentlyRunning = false;
            };
            Ai.prototype.add = function(t5) {
              var e4 = ++this._id;
              return this._queue.push({ callback: t5, id: e4, cancelled: false }), e4;
            }, Ai.prototype.remove = function(t5) {
              for (var e4 = this._currentlyRunning, r4 = 0, n4 = e4 ? this._queue.concat(e4) : this._queue; r4 < n4.length; r4 += 1) {
                var i2 = n4[r4];
                if (i2.id === t5)
                  return void (i2.cancelled = true);
              }
            }, Ai.prototype.run = function(t5) {
              void 0 === t5 && (t5 = 0);
              var e4 = this._currentlyRunning = this._queue;
              this._queue = [];
              for (var r4 = 0, n4 = e4; r4 < n4.length; r4 += 1) {
                var i2 = n4[r4];
                if (!i2.cancelled && (i2.callback(t5), this._cleared))
                  break;
              }
              this._cleared = false, this._currentlyRunning = false;
            }, Ai.prototype.clear = function() {
              this._currentlyRunning && (this._cleared = true), this._queue = [];
            };
            var Mi = { "FullscreenControl.Enter": "Enter fullscreen", "FullscreenControl.Exit": "Exit fullscreen", "GeolocateControl.FindMyLocation": "Find my location", "GeolocateControl.LocationNotAvailable": "Location not available", "LogoControl.Title": "Mapbox logo", "NavigationControl.ResetBearing": "Reset bearing to north", "NavigationControl.ZoomIn": "Zoom in", "NavigationControl.ZoomOut": "Zoom out", "ScaleControl.Feet": "ft", "ScaleControl.Meters": "m", "ScaleControl.Kilometers": "km", "ScaleControl.Miles": "mi", "ScaleControl.NauticalMiles": "nm" }, Si = t4.window.HTMLImageElement, Ei = t4.window.HTMLElement, Li = t4.window.ImageBitmap, Ci = 60, Pi = { center: [0, 0], zoom: 0, bearing: 0, pitch: 0, minZoom: -2, maxZoom: 22, minPitch: 0, maxPitch: Ci, interactive: true, scrollZoom: true, boxZoom: true, dragRotate: true, dragPan: true, keyboard: true, doubleClickZoom: true, touchZoomRotate: true, touchPitch: true, bearingSnap: 7, clickTolerance: 3, pitchWithRotate: true, hash: false, attributionControl: true, failIfMajorPerformanceCaveat: false, preserveDrawingBuffer: false, trackResize: true, renderWorldCopies: true, refreshExpiredTiles: true, maxTileCacheSize: null, localIdeographFontFamily: "sans-serif", transformRequest: null, accessToken: null, fadeDuration: 300, crossSourceCollisions: true }, Oi = function(n4) {
              function i2(e4) {
                var r4 = this;
                if (null != (e4 = t4.extend({}, Pi, e4)).minZoom && null != e4.maxZoom && e4.minZoom > e4.maxZoom)
                  throw new Error("maxZoom must be greater than or equal to minZoom");
                if (null != e4.minPitch && null != e4.maxPitch && e4.minPitch > e4.maxPitch)
                  throw new Error("maxPitch must be greater than or equal to minPitch");
                if (null != e4.minPitch && e4.minPitch < 0)
                  throw new Error("minPitch must be greater than or equal to 0");
                if (null != e4.maxPitch && e4.maxPitch > Ci)
                  throw new Error("maxPitch must be less than or equal to 60");
                var i3 = new Sn(e4.minZoom, e4.maxZoom, e4.minPitch, e4.maxPitch, e4.renderWorldCopies);
                if (n4.call(this, i3, e4), this._interactive = e4.interactive, this._maxTileCacheSize = e4.maxTileCacheSize, this._failIfMajorPerformanceCaveat = e4.failIfMajorPerformanceCaveat, this._preserveDrawingBuffer = e4.preserveDrawingBuffer, this._antialias = e4.antialias, this._trackResize = e4.trackResize, this._bearingSnap = e4.bearingSnap, this._refreshExpiredTiles = e4.refreshExpiredTiles, this._fadeDuration = e4.fadeDuration, this._crossSourceCollisions = e4.crossSourceCollisions, this._crossFadingFactor = 1, this._collectResourceTiming = e4.collectResourceTiming, this._renderTaskQueue = new Ai(), this._controls = [], this._mapId = t4.uniqueId(), this._locale = t4.extend({}, Mi, e4.locale), this._requestManager = new t4.RequestManager(e4.transformRequest, e4.accessToken), "string" == typeof e4.container) {
                  if (this._container = t4.window.document.getElementById(e4.container), !this._container)
                    throw new Error("Container '" + e4.container + "' not found.");
                } else {
                  if (!(e4.container instanceof Ei))
                    throw new Error("Invalid type: 'container' must be a String or HTMLElement.");
                  this._container = e4.container;
                }
                if (e4.maxBounds && this.setMaxBounds(e4.maxBounds), t4.bindAll(["_onWindowOnline", "_onWindowResize", "_contextLost", "_contextRestored"], this), this._setupContainer(), this._setupPainter(), void 0 === this.painter)
                  throw new Error("Failed to initialize WebGL.");
                this.on("move", function() {
                  return r4._update(false);
                }), this.on("moveend", function() {
                  return r4._update(false);
                }), this.on("zoom", function() {
                  return r4._update(true);
                }), void 0 !== t4.window && (t4.window.addEventListener("online", this._onWindowOnline, false), t4.window.addEventListener("resize", this._onWindowResize, false)), this.handlers = new _i(this, e4);
                var a3 = "string" == typeof e4.hash && e4.hash || void 0;
                this._hash = e4.hash && new Ln(a3).addTo(this), this._hash && this._hash._onHashChange() || (this.jumpTo({ center: e4.center, zoom: e4.zoom, bearing: e4.bearing, pitch: e4.pitch }), e4.bounds && (this.resize(), this.fitBounds(e4.bounds, t4.extend({}, e4.fitBoundsOptions, { duration: 0 })))), this.resize(), this._localIdeographFontFamily = e4.localIdeographFontFamily, e4.style && this.setStyle(e4.style, { localIdeographFontFamily: e4.localIdeographFontFamily }), e4.attributionControl && this.addControl(new Ti({ customAttribution: e4.customAttribution })), this.addControl(new ki(), e4.logoPosition), this.on("style.load", function() {
                  r4.transform.unmodified && r4.jumpTo(r4.style.stylesheet);
                }), this.on("data", function(e5) {
                  r4._update("style" === e5.dataType), r4.fire(new t4.Event(e5.dataType + "data", e5));
                }), this.on("dataloading", function(e5) {
                  r4.fire(new t4.Event(e5.dataType + "dataloading", e5));
                });
              }
              n4 && (i2.__proto__ = n4), i2.prototype = Object.create(n4 && n4.prototype), i2.prototype.constructor = i2;
              var a2 = { showTileBoundaries: { configurable: true }, showPadding: { configurable: true }, showCollisionBoxes: { configurable: true }, showOverdrawInspector: { configurable: true }, repaint: { configurable: true }, vertices: { configurable: true }, version: { configurable: true } };
              return i2.prototype._getMapId = function() {
                return this._mapId;
              }, i2.prototype.addControl = function(e4, r4) {
                if (void 0 === r4 && e4.getDefaultPosition && (r4 = e4.getDefaultPosition()), void 0 === r4 && (r4 = "top-right"), !e4 || !e4.onAdd)
                  return this.fire(new t4.ErrorEvent(new Error("Invalid argument to map.addControl(). Argument must be a control with onAdd and onRemove methods.")));
                var n5 = e4.onAdd(this);
                this._controls.push(e4);
                var i3 = this._controlPositions[r4];
                return -1 !== r4.indexOf("bottom") ? i3.insertBefore(n5, i3.firstChild) : i3.appendChild(n5), this;
              }, i2.prototype.removeControl = function(e4) {
                if (!e4 || !e4.onRemove)
                  return this.fire(new t4.ErrorEvent(new Error("Invalid argument to map.removeControl(). Argument must be a control with onAdd and onRemove methods.")));
                var r4 = this._controls.indexOf(e4);
                return r4 > -1 && this._controls.splice(r4, 1), e4.onRemove(this), this;
              }, i2.prototype.resize = function(e4) {
                var r4 = this._containerDimensions(), n5 = r4[0], i3 = r4[1];
                this._resizeCanvas(n5, i3), this.transform.resize(n5, i3), this.painter.resize(n5, i3);
                var a3 = !this._moving;
                return a3 && (this.stop(), this.fire(new t4.Event("movestart", e4)).fire(new t4.Event("move", e4))), this.fire(new t4.Event("resize", e4)), a3 && this.fire(new t4.Event("moveend", e4)), this;
              }, i2.prototype.getBounds = function() {
                return this.transform.getBounds();
              }, i2.prototype.getMaxBounds = function() {
                return this.transform.getMaxBounds();
              }, i2.prototype.setMaxBounds = function(e4) {
                return this.transform.setMaxBounds(t4.LngLatBounds.convert(e4)), this._update();
              }, i2.prototype.setMinZoom = function(t5) {
                if ((t5 = null == t5 ? -2 : t5) >= -2 && t5 <= this.transform.maxZoom)
                  return this.transform.minZoom = t5, this._update(), this.getZoom() < t5 && this.setZoom(t5), this;
                throw new Error("minZoom must be between -2 and the current maxZoom, inclusive");
              }, i2.prototype.getMinZoom = function() {
                return this.transform.minZoom;
              }, i2.prototype.setMaxZoom = function(t5) {
                if ((t5 = null == t5 ? 22 : t5) >= this.transform.minZoom)
                  return this.transform.maxZoom = t5, this._update(), this.getZoom() > t5 && this.setZoom(t5), this;
                throw new Error("maxZoom must be greater than the current minZoom");
              }, i2.prototype.getMaxZoom = function() {
                return this.transform.maxZoom;
              }, i2.prototype.setMinPitch = function(t5) {
                if ((t5 = null == t5 ? 0 : t5) < 0)
                  throw new Error("minPitch must be greater than or equal to 0");
                if (t5 >= 0 && t5 <= this.transform.maxPitch)
                  return this.transform.minPitch = t5, this._update(), this.getPitch() < t5 && this.setPitch(t5), this;
                throw new Error("minPitch must be between 0 and the current maxPitch, inclusive");
              }, i2.prototype.getMinPitch = function() {
                return this.transform.minPitch;
              }, i2.prototype.setMaxPitch = function(t5) {
                if ((t5 = null == t5 ? Ci : t5) > Ci)
                  throw new Error("maxPitch must be less than or equal to 60");
                if (t5 >= this.transform.minPitch)
                  return this.transform.maxPitch = t5, this._update(), this.getPitch() > t5 && this.setPitch(t5), this;
                throw new Error("maxPitch must be greater than the current minPitch");
              }, i2.prototype.getMaxPitch = function() {
                return this.transform.maxPitch;
              }, i2.prototype.getRenderWorldCopies = function() {
                return this.transform.renderWorldCopies;
              }, i2.prototype.setRenderWorldCopies = function(t5) {
                return this.transform.renderWorldCopies = t5, this._update();
              }, i2.prototype.project = function(e4) {
                return this.transform.locationPoint(t4.LngLat.convert(e4));
              }, i2.prototype.unproject = function(e4) {
                return this.transform.pointLocation(t4.Point.convert(e4));
              }, i2.prototype.isMoving = function() {
                return this._moving || this.handlers.isMoving();
              }, i2.prototype.isZooming = function() {
                return this._zooming || this.handlers.isZooming();
              }, i2.prototype.isRotating = function() {
                return this._rotating || this.handlers.isRotating();
              }, i2.prototype._createDelegatedListener = function(t5, e4, r4) {
                var n5, i3 = this;
                if ("mouseenter" === t5 || "mouseover" === t5) {
                  var a3 = false;
                  return { layer: e4, listener: r4, delegates: { mousemove: function(n6) {
                    var o3 = i3.getLayer(e4) ? i3.queryRenderedFeatures(n6.point, { layers: [e4] }) : [];
                    o3.length ? a3 || (a3 = true, r4.call(i3, new Bn(t5, i3, n6.originalEvent, { features: o3 }))) : a3 = false;
                  }, mouseout: function() {
                    a3 = false;
                  } } };
                }
                if ("mouseleave" === t5 || "mouseout" === t5) {
                  var o2 = false;
                  return { layer: e4, listener: r4, delegates: { mousemove: function(n6) {
                    (i3.getLayer(e4) ? i3.queryRenderedFeatures(n6.point, { layers: [e4] }) : []).length ? o2 = true : o2 && (o2 = false, r4.call(i3, new Bn(t5, i3, n6.originalEvent)));
                  }, mouseout: function(e5) {
                    o2 && (o2 = false, r4.call(i3, new Bn(t5, i3, e5.originalEvent)));
                  } } };
                }
                return { layer: e4, listener: r4, delegates: (n5 = {}, n5[t5] = function(t6) {
                  var n6 = i3.getLayer(e4) ? i3.queryRenderedFeatures(t6.point, { layers: [e4] }) : [];
                  n6.length && (t6.features = n6, r4.call(i3, t6), delete t6.features);
                }, n5) };
              }, i2.prototype.on = function(t5, e4, r4) {
                if (void 0 === r4)
                  return n4.prototype.on.call(this, t5, e4);
                var i3 = this._createDelegatedListener(t5, e4, r4);
                for (var a3 in this._delegatedListeners = this._delegatedListeners || {}, this._delegatedListeners[t5] = this._delegatedListeners[t5] || [], this._delegatedListeners[t5].push(i3), i3.delegates)
                  this.on(a3, i3.delegates[a3]);
                return this;
              }, i2.prototype.once = function(t5, e4, r4) {
                if (void 0 === r4)
                  return n4.prototype.once.call(this, t5, e4);
                var i3 = this._createDelegatedListener(t5, e4, r4);
                for (var a3 in i3.delegates)
                  this.once(a3, i3.delegates[a3]);
                return this;
              }, i2.prototype.off = function(t5, e4, r4) {
                var i3 = this;
                if (void 0 === r4)
                  return n4.prototype.off.call(this, t5, e4);
                return this._delegatedListeners && this._delegatedListeners[t5] && function(n5) {
                  for (var a3 = n5[t5], o2 = 0; o2 < a3.length; o2++) {
                    var s2 = a3[o2];
                    if (s2.layer === e4 && s2.listener === r4) {
                      for (var l2 in s2.delegates)
                        i3.off(l2, s2.delegates[l2]);
                      return a3.splice(o2, 1), i3;
                    }
                  }
                }(this._delegatedListeners), this;
              }, i2.prototype.queryRenderedFeatures = function(e4, r4) {
                if (!this.style)
                  return [];
                var n5;
                if (void 0 !== r4 || void 0 === e4 || e4 instanceof t4.Point || Array.isArray(e4) || (r4 = e4, e4 = void 0), r4 = r4 || {}, (e4 = e4 || [[0, 0], [this.transform.width, this.transform.height]]) instanceof t4.Point || "number" == typeof e4[0])
                  n5 = [t4.Point.convert(e4)];
                else {
                  var i3 = t4.Point.convert(e4[0]), a3 = t4.Point.convert(e4[1]);
                  n5 = [i3, new t4.Point(a3.x, i3.y), a3, new t4.Point(i3.x, a3.y), i3];
                }
                return this.style.queryRenderedFeatures(n5, r4, this.transform);
              }, i2.prototype.querySourceFeatures = function(t5, e4) {
                return this.style.querySourceFeatures(t5, e4);
              }, i2.prototype.setStyle = function(e4, r4) {
                return false !== (r4 = t4.extend({}, { localIdeographFontFamily: this._localIdeographFontFamily }, r4)).diff && r4.localIdeographFontFamily === this._localIdeographFontFamily && this.style && e4 ? (this._diffStyle(e4, r4), this) : (this._localIdeographFontFamily = r4.localIdeographFontFamily, this._updateStyle(e4, r4));
              }, i2.prototype._getUIString = function(t5) {
                var e4 = this._locale[t5];
                if (null == e4)
                  throw new Error("Missing UI string '" + t5 + "'");
                return e4;
              }, i2.prototype._updateStyle = function(t5, e4) {
                return this.style && (this.style.setEventedParent(null), this.style._remove()), t5 ? (this.style = new Ye(this, e4 || {}), this.style.setEventedParent(this, { style: this.style }), "string" == typeof t5 ? this.style.loadURL(t5) : this.style.loadJSON(t5), this) : (delete this.style, this);
              }, i2.prototype._lazyInitEmptyStyle = function() {
                this.style || (this.style = new Ye(this, {}), this.style.setEventedParent(this, { style: this.style }), this.style.loadEmpty());
              }, i2.prototype._diffStyle = function(e4, r4) {
                var n5 = this;
                if ("string" == typeof e4) {
                  var i3 = this._requestManager.normalizeStyleURL(e4), a3 = this._requestManager.transformRequest(i3, t4.ResourceType.Style);
                  t4.getJSON(a3, function(e5, i4) {
                    e5 ? n5.fire(new t4.ErrorEvent(e5)) : i4 && n5._updateDiff(i4, r4);
                  });
                } else
                  "object" == typeof e4 && this._updateDiff(e4, r4);
              }, i2.prototype._updateDiff = function(e4, r4) {
                try {
                  this.style.setState(e4) && this._update(true);
                } catch (n5) {
                  t4.warnOnce("Unable to perform style diff: " + (n5.message || n5.error || n5) + ".  Rebuilding the style from scratch."), this._updateStyle(e4, r4);
                }
              }, i2.prototype.getStyle = function() {
                if (this.style)
                  return this.style.serialize();
              }, i2.prototype.isStyleLoaded = function() {
                return this.style ? this.style.loaded() : t4.warnOnce("There is no style added to the map.");
              }, i2.prototype.addSource = function(t5, e4) {
                return this._lazyInitEmptyStyle(), this.style.addSource(t5, e4), this._update(true);
              }, i2.prototype.isSourceLoaded = function(e4) {
                var r4 = this.style && this.style.sourceCaches[e4];
                if (void 0 !== r4)
                  return r4.loaded();
                this.fire(new t4.ErrorEvent(new Error("There is no source with ID '" + e4 + "'")));
              }, i2.prototype.areTilesLoaded = function() {
                var t5 = this.style && this.style.sourceCaches;
                for (var e4 in t5) {
                  var r4 = t5[e4]._tiles;
                  for (var n5 in r4) {
                    var i3 = r4[n5];
                    if ("loaded" !== i3.state && "errored" !== i3.state)
                      return false;
                  }
                }
                return true;
              }, i2.prototype.addSourceType = function(t5, e4, r4) {
                return this._lazyInitEmptyStyle(), this.style.addSourceType(t5, e4, r4);
              }, i2.prototype.removeSource = function(t5) {
                return this.style.removeSource(t5), this._update(true);
              }, i2.prototype.getSource = function(t5) {
                return this.style.getSource(t5);
              }, i2.prototype.addImage = function(e4, r4, n5) {
                void 0 === n5 && (n5 = {});
                var i3 = n5.pixelRatio;
                void 0 === i3 && (i3 = 1);
                var a3 = n5.sdf;
                void 0 === a3 && (a3 = false);
                var o2 = n5.stretchX, s2 = n5.stretchY, l2 = n5.content;
                this._lazyInitEmptyStyle();
                if (r4 instanceof Si || Li && r4 instanceof Li) {
                  var u2 = t4.browser.getImageData(r4), c2 = u2.width, f3 = u2.height, h2 = u2.data;
                  this.style.addImage(e4, { data: new t4.RGBAImage({ width: c2, height: f3 }, h2), pixelRatio: i3, stretchX: o2, stretchY: s2, content: l2, sdf: a3, version: 0 });
                } else {
                  if (void 0 === r4.width || void 0 === r4.height)
                    return this.fire(new t4.ErrorEvent(new Error("Invalid arguments to map.addImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, or object with `width`, `height`, and `data` properties with the same format as `ImageData`")));
                  var p3 = r4.width, d3 = r4.height, v2 = r4.data, g3 = r4;
                  this.style.addImage(e4, { data: new t4.RGBAImage({ width: p3, height: d3 }, new Uint8Array(v2)), pixelRatio: i3, stretchX: o2, stretchY: s2, content: l2, sdf: a3, version: 0, userImage: g3 }), g3.onAdd && g3.onAdd(this, e4);
                }
              }, i2.prototype.updateImage = function(e4, r4) {
                var n5 = this.style.getImage(e4);
                if (!n5)
                  return this.fire(new t4.ErrorEvent(new Error("The map has no image with that id. If you are adding a new image use `map.addImage(...)` instead.")));
                var i3 = r4 instanceof Si || Li && r4 instanceof Li ? t4.browser.getImageData(r4) : r4, a3 = i3.width, o2 = i3.height, s2 = i3.data;
                if (void 0 === a3 || void 0 === o2)
                  return this.fire(new t4.ErrorEvent(new Error("Invalid arguments to map.updateImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, or object with `width`, `height`, and `data` properties with the same format as `ImageData`")));
                if (a3 !== n5.data.width || o2 !== n5.data.height)
                  return this.fire(new t4.ErrorEvent(new Error("The width and height of the updated image must be that same as the previous version of the image")));
                var l2 = !(r4 instanceof Si || Li && r4 instanceof Li);
                n5.data.replace(s2, l2), this.style.updateImage(e4, n5);
              }, i2.prototype.hasImage = function(e4) {
                return e4 ? !!this.style.getImage(e4) : (this.fire(new t4.ErrorEvent(new Error("Missing required image id"))), false);
              }, i2.prototype.removeImage = function(t5) {
                this.style.removeImage(t5);
              }, i2.prototype.loadImage = function(e4, r4) {
                t4.getImage(this._requestManager.transformRequest(e4, t4.ResourceType.Image), r4);
              }, i2.prototype.listImages = function() {
                return this.style.listImages();
              }, i2.prototype.addLayer = function(t5, e4) {
                return this._lazyInitEmptyStyle(), this.style.addLayer(t5, e4), this._update(true);
              }, i2.prototype.moveLayer = function(t5, e4) {
                return this.style.moveLayer(t5, e4), this._update(true);
              }, i2.prototype.removeLayer = function(t5) {
                return this.style.removeLayer(t5), this._update(true);
              }, i2.prototype.getLayer = function(t5) {
                return this.style.getLayer(t5);
              }, i2.prototype.setLayerZoomRange = function(t5, e4, r4) {
                return this.style.setLayerZoomRange(t5, e4, r4), this._update(true);
              }, i2.prototype.setFilter = function(t5, e4, r4) {
                return void 0 === r4 && (r4 = {}), this.style.setFilter(t5, e4, r4), this._update(true);
              }, i2.prototype.getFilter = function(t5) {
                return this.style.getFilter(t5);
              }, i2.prototype.setPaintProperty = function(t5, e4, r4, n5) {
                return void 0 === n5 && (n5 = {}), this.style.setPaintProperty(t5, e4, r4, n5), this._update(true);
              }, i2.prototype.getPaintProperty = function(t5, e4) {
                return this.style.getPaintProperty(t5, e4);
              }, i2.prototype.setLayoutProperty = function(t5, e4, r4, n5) {
                return void 0 === n5 && (n5 = {}), this.style.setLayoutProperty(t5, e4, r4, n5), this._update(true);
              }, i2.prototype.getLayoutProperty = function(t5, e4) {
                return this.style.getLayoutProperty(t5, e4);
              }, i2.prototype.setLight = function(t5, e4) {
                return void 0 === e4 && (e4 = {}), this._lazyInitEmptyStyle(), this.style.setLight(t5, e4), this._update(true);
              }, i2.prototype.getLight = function() {
                return this.style.getLight();
              }, i2.prototype.setFeatureState = function(t5, e4) {
                return this.style.setFeatureState(t5, e4), this._update();
              }, i2.prototype.removeFeatureState = function(t5, e4) {
                return this.style.removeFeatureState(t5, e4), this._update();
              }, i2.prototype.getFeatureState = function(t5) {
                return this.style.getFeatureState(t5);
              }, i2.prototype.getContainer = function() {
                return this._container;
              }, i2.prototype.getCanvasContainer = function() {
                return this._canvasContainer;
              }, i2.prototype.getCanvas = function() {
                return this._canvas;
              }, i2.prototype._containerDimensions = function() {
                var t5 = 0, e4 = 0;
                return this._container && (t5 = this._container.clientWidth || 400, e4 = this._container.clientHeight || 300), [t5, e4];
              }, i2.prototype._detectMissingCSS = function() {
                "rgb(250, 128, 114)" !== t4.window.getComputedStyle(this._missingCSSCanary).getPropertyValue("background-color") && t4.warnOnce("This page appears to be missing CSS declarations for Mapbox GL JS, which may cause the map to display incorrectly. Please ensure your page includes mapbox-gl.css, as described in https://www.mapbox.com/mapbox-gl-js/api/.");
              }, i2.prototype._setupContainer = function() {
                var t5 = this._container;
                t5.classList.add("mapboxgl-map"), (this._missingCSSCanary = r3.create("div", "mapboxgl-canary", t5)).style.visibility = "hidden", this._detectMissingCSS();
                var e4 = this._canvasContainer = r3.create("div", "mapboxgl-canvas-container", t5);
                this._interactive && e4.classList.add("mapboxgl-interactive"), this._canvas = r3.create("canvas", "mapboxgl-canvas", e4), this._canvas.addEventListener("webglcontextlost", this._contextLost, false), this._canvas.addEventListener("webglcontextrestored", this._contextRestored, false), this._canvas.setAttribute("tabindex", "0"), this._canvas.setAttribute("aria-label", "Map");
                var n5 = this._containerDimensions();
                this._resizeCanvas(n5[0], n5[1]);
                var i3 = this._controlContainer = r3.create("div", "mapboxgl-control-container", t5), a3 = this._controlPositions = {};
                ["top-left", "top-right", "bottom-left", "bottom-right"].forEach(function(t6) {
                  a3[t6] = r3.create("div", "mapboxgl-ctrl-" + t6, i3);
                });
              }, i2.prototype._resizeCanvas = function(e4, r4) {
                var n5 = t4.browser.devicePixelRatio || 1;
                this._canvas.width = n5 * e4, this._canvas.height = n5 * r4, this._canvas.style.width = e4 + "px", this._canvas.style.height = r4 + "px";
              }, i2.prototype._setupPainter = function() {
                var r4 = t4.extend({}, e3.webGLContextAttributes, { failIfMajorPerformanceCaveat: this._failIfMajorPerformanceCaveat, preserveDrawingBuffer: this._preserveDrawingBuffer, antialias: this._antialias || false }), n5 = this._canvas.getContext("webgl", r4) || this._canvas.getContext("experimental-webgl", r4);
                n5 ? (this.painter = new Tn(n5, this.transform), t4.webpSupported.testSupport(n5)) : this.fire(new t4.ErrorEvent(new Error("Failed to initialize WebGL")));
              }, i2.prototype._contextLost = function(e4) {
                e4.preventDefault(), this._frame && (this._frame.cancel(), this._frame = null), this.fire(new t4.Event("webglcontextlost", { originalEvent: e4 }));
              }, i2.prototype._contextRestored = function(e4) {
                this._setupPainter(), this.resize(), this._update(), this.fire(new t4.Event("webglcontextrestored", { originalEvent: e4 }));
              }, i2.prototype.loaded = function() {
                return !this._styleDirty && !this._sourcesDirty && !!this.style && this.style.loaded();
              }, i2.prototype._update = function(t5) {
                return this.style ? (this._styleDirty = this._styleDirty || t5, this._sourcesDirty = true, this.triggerRepaint(), this) : this;
              }, i2.prototype._requestRenderFrame = function(t5) {
                return this._update(), this._renderTaskQueue.add(t5);
              }, i2.prototype._cancelRenderFrame = function(t5) {
                this._renderTaskQueue.remove(t5);
              }, i2.prototype._render = function(e4) {
                var r4, n5 = this, i3 = 0, a3 = this.painter.context.extTimerQuery;
                if (this.listens("gpu-timing-frame") && (r4 = a3.createQueryEXT(), a3.beginQueryEXT(a3.TIME_ELAPSED_EXT, r4), i3 = t4.browser.now()), this.painter.context.setDirty(), this.painter.setBaseState(), this._renderTaskQueue.run(e4), !this._removed) {
                  var o2 = false;
                  if (this.style && this._styleDirty) {
                    this._styleDirty = false;
                    var s2 = this.transform.zoom, l2 = t4.browser.now();
                    this.style.zoomHistory.update(s2, l2);
                    var u2 = new t4.EvaluationParameters(s2, { now: l2, fadeDuration: this._fadeDuration, zoomHistory: this.style.zoomHistory, transition: this.style.getTransition() }), c2 = u2.crossFadingFactor();
                    1 === c2 && c2 === this._crossFadingFactor || (o2 = true, this._crossFadingFactor = c2), this.style.update(u2);
                  }
                  if (this.style && this._sourcesDirty && (this._sourcesDirty = false, this.style._updateSources(this.transform)), this._placementDirty = this.style && this.style._updatePlacement(this.painter.transform, this.showCollisionBoxes, this._fadeDuration, this._crossSourceCollisions), this.painter.render(this.style, { showTileBoundaries: this.showTileBoundaries, showOverdrawInspector: this._showOverdrawInspector, rotating: this.isRotating(), zooming: this.isZooming(), moving: this.isMoving(), fadeDuration: this._fadeDuration, showPadding: this.showPadding, gpuTiming: !!this.listens("gpu-timing-layer") }), this.fire(new t4.Event("render")), this.loaded() && !this._loaded && (this._loaded = true, this.fire(new t4.Event("load"))), this.style && (this.style.hasTransitions() || o2) && (this._styleDirty = true), this.style && !this._placementDirty && this.style._releaseSymbolFadeTiles(), this.listens("gpu-timing-frame")) {
                    var f3 = t4.browser.now() - i3;
                    a3.endQueryEXT(a3.TIME_ELAPSED_EXT, r4), setTimeout(function() {
                      var e5 = a3.getQueryObjectEXT(r4, a3.QUERY_RESULT_EXT) / 1e6;
                      a3.deleteQueryEXT(r4), n5.fire(new t4.Event("gpu-timing-frame", { cpuTime: f3, gpuTime: e5 }));
                    }, 50);
                  }
                  if (this.listens("gpu-timing-layer")) {
                    var h2 = this.painter.collectGpuTimers();
                    setTimeout(function() {
                      var e5 = n5.painter.queryGpuTimers(h2);
                      n5.fire(new t4.Event("gpu-timing-layer", { layerTimes: e5 }));
                    }, 50);
                  }
                  return this._sourcesDirty || this._styleDirty || this._placementDirty || this._repaint ? this.triggerRepaint() : !this.isMoving() && this.loaded() && (this._fullyLoaded || (this._fullyLoaded = true), this.fire(new t4.Event("idle"))), this;
                }
              }, i2.prototype.remove = function() {
                this._hash && this._hash.remove();
                for (var e4 = 0, r4 = this._controls; e4 < r4.length; e4 += 1)
                  r4[e4].onRemove(this);
                this._controls = [], this._frame && (this._frame.cancel(), this._frame = null), this._renderTaskQueue.clear(), this.painter.destroy(), this.handlers.destroy(), delete this.handlers, this.setStyle(null), void 0 !== t4.window && (t4.window.removeEventListener("resize", this._onWindowResize, false), t4.window.removeEventListener("online", this._onWindowOnline, false));
                var n5 = this.painter.context.gl.getExtension("WEBGL_lose_context");
                n5 && n5.loseContext(), Ii(this._canvasContainer), Ii(this._controlContainer), Ii(this._missingCSSCanary), this._container.classList.remove("mapboxgl-map"), this._removed = true, this.fire(new t4.Event("remove"));
              }, i2.prototype.triggerRepaint = function() {
                var e4 = this;
                this.style && !this._frame && (this._frame = t4.browser.frame(function(t5) {
                  e4._frame = null, e4._render(t5);
                }));
              }, i2.prototype._onWindowOnline = function() {
                this._update();
              }, i2.prototype._onWindowResize = function(t5) {
                this._trackResize && this.resize({ originalEvent: t5 })._update();
              }, a2.showTileBoundaries.get = function() {
                return !!this._showTileBoundaries;
              }, a2.showTileBoundaries.set = function(t5) {
                this._showTileBoundaries !== t5 && (this._showTileBoundaries = t5, this._update());
              }, a2.showPadding.get = function() {
                return !!this._showPadding;
              }, a2.showPadding.set = function(t5) {
                this._showPadding !== t5 && (this._showPadding = t5, this._update());
              }, a2.showCollisionBoxes.get = function() {
                return !!this._showCollisionBoxes;
              }, a2.showCollisionBoxes.set = function(t5) {
                this._showCollisionBoxes !== t5 && (this._showCollisionBoxes = t5, t5 ? this.style._generateCollisionBoxes() : this._update());
              }, a2.showOverdrawInspector.get = function() {
                return !!this._showOverdrawInspector;
              }, a2.showOverdrawInspector.set = function(t5) {
                this._showOverdrawInspector !== t5 && (this._showOverdrawInspector = t5, this._update());
              }, a2.repaint.get = function() {
                return !!this._repaint;
              }, a2.repaint.set = function(t5) {
                this._repaint !== t5 && (this._repaint = t5, this.triggerRepaint());
              }, a2.vertices.get = function() {
                return !!this._vertices;
              }, a2.vertices.set = function(t5) {
                this._vertices = t5, this._update();
              }, i2.prototype._setCacheLimits = function(e4, r4) {
                t4.setCacheLimits(e4, r4);
              }, a2.version.get = function() {
                return t4.version;
              }, Object.defineProperties(i2.prototype, a2), i2;
            }(wi);
            function Ii(t5) {
              t5.parentNode && t5.parentNode.removeChild(t5);
            }
            var Di = { showCompass: true, showZoom: true, visualizePitch: false }, zi = function(e4) {
              var n4 = this;
              this.options = t4.extend({}, Di, e4), this._container = r3.create("div", "mapboxgl-ctrl mapboxgl-ctrl-group"), this._container.addEventListener("contextmenu", function(t5) {
                return t5.preventDefault();
              }), this.options.showZoom && (t4.bindAll(["_setButtonTitle", "_updateZoomButtons"], this), this._zoomInButton = this._createButton("mapboxgl-ctrl-zoom-in", function(t5) {
                return n4._map.zoomIn({}, { originalEvent: t5 });
              }), r3.create("span", "mapboxgl-ctrl-icon", this._zoomInButton).setAttribute("aria-hidden", true), this._zoomOutButton = this._createButton("mapboxgl-ctrl-zoom-out", function(t5) {
                return n4._map.zoomOut({}, { originalEvent: t5 });
              }), r3.create("span", "mapboxgl-ctrl-icon", this._zoomOutButton).setAttribute("aria-hidden", true)), this.options.showCompass && (t4.bindAll(["_rotateCompassArrow"], this), this._compass = this._createButton("mapboxgl-ctrl-compass", function(t5) {
                n4.options.visualizePitch ? n4._map.resetNorthPitch({}, { originalEvent: t5 }) : n4._map.resetNorth({}, { originalEvent: t5 });
              }), this._compassIcon = r3.create("span", "mapboxgl-ctrl-icon", this._compass), this._compassIcon.setAttribute("aria-hidden", true));
            };
            zi.prototype._updateZoomButtons = function() {
              var t5 = this._map.getZoom();
              this._zoomInButton.disabled = t5 === this._map.getMaxZoom(), this._zoomOutButton.disabled = t5 === this._map.getMinZoom();
            }, zi.prototype._rotateCompassArrow = function() {
              var t5 = this.options.visualizePitch ? "scale(" + 1 / Math.pow(Math.cos(this._map.transform.pitch * (Math.PI / 180)), 0.5) + ") rotateX(" + this._map.transform.pitch + "deg) rotateZ(" + this._map.transform.angle * (180 / Math.PI) + "deg)" : "rotate(" + this._map.transform.angle * (180 / Math.PI) + "deg)";
              this._compassIcon.style.transform = t5;
            }, zi.prototype.onAdd = function(t5) {
              return this._map = t5, this.options.showZoom && (this._setButtonTitle(this._zoomInButton, "ZoomIn"), this._setButtonTitle(this._zoomOutButton, "ZoomOut"), this._map.on("zoom", this._updateZoomButtons), this._updateZoomButtons()), this.options.showCompass && (this._setButtonTitle(this._compass, "ResetBearing"), this.options.visualizePitch && this._map.on("pitch", this._rotateCompassArrow), this._map.on("rotate", this._rotateCompassArrow), this._rotateCompassArrow(), this._handler = new Ri(this._map, this._compass, this.options.visualizePitch)), this._container;
            }, zi.prototype.onRemove = function() {
              r3.remove(this._container), this.options.showZoom && this._map.off("zoom", this._updateZoomButtons), this.options.showCompass && (this.options.visualizePitch && this._map.off("pitch", this._rotateCompassArrow), this._map.off("rotate", this._rotateCompassArrow), this._handler.off(), delete this._handler), delete this._map;
            }, zi.prototype._createButton = function(t5, e4) {
              var n4 = r3.create("button", t5, this._container);
              return n4.type = "button", n4.addEventListener("click", e4), n4;
            }, zi.prototype._setButtonTitle = function(t5, e4) {
              var r4 = this._map._getUIString("NavigationControl." + e4);
              t5.title = r4, t5.setAttribute("aria-label", r4);
            };
            var Ri = function(e4, n4, i2) {
              void 0 === i2 && (i2 = false), this._clickTolerance = 10, this.element = n4, this.mouseRotate = new Jn({ clickTolerance: e4.dragRotate._mouseRotate._clickTolerance }), this.map = e4, i2 && (this.mousePitch = new Kn({ clickTolerance: e4.dragRotate._mousePitch._clickTolerance })), t4.bindAll(["mousedown", "mousemove", "mouseup", "touchstart", "touchmove", "touchend", "reset"], this), r3.addEventListener(n4, "mousedown", this.mousedown), r3.addEventListener(n4, "touchstart", this.touchstart, { passive: false }), r3.addEventListener(n4, "touchmove", this.touchmove), r3.addEventListener(n4, "touchend", this.touchend), r3.addEventListener(n4, "touchcancel", this.reset);
            };
            function Fi(e4, r4, n4) {
              if (e4 = new t4.LngLat(e4.lng, e4.lat), r4) {
                var i2 = new t4.LngLat(e4.lng - 360, e4.lat), a2 = new t4.LngLat(e4.lng + 360, e4.lat), o2 = n4.locationPoint(e4).distSqr(r4);
                n4.locationPoint(i2).distSqr(r4) < o2 ? e4 = i2 : n4.locationPoint(a2).distSqr(r4) < o2 && (e4 = a2);
              }
              for (; Math.abs(e4.lng - n4.center.lng) > 180; ) {
                var s2 = n4.locationPoint(e4);
                if (s2.x >= 0 && s2.y >= 0 && s2.x <= n4.width && s2.y <= n4.height)
                  break;
                e4.lng > n4.center.lng ? e4.lng -= 360 : e4.lng += 360;
              }
              return e4;
            }
            Ri.prototype.down = function(t5, e4) {
              this.mouseRotate.mousedown(t5, e4), this.mousePitch && this.mousePitch.mousedown(t5, e4), r3.disableDrag();
            }, Ri.prototype.move = function(t5, e4) {
              var r4 = this.map, n4 = this.mouseRotate.mousemoveWindow(t5, e4);
              if (n4 && n4.bearingDelta && r4.setBearing(r4.getBearing() + n4.bearingDelta), this.mousePitch) {
                var i2 = this.mousePitch.mousemoveWindow(t5, e4);
                i2 && i2.pitchDelta && r4.setPitch(r4.getPitch() + i2.pitchDelta);
              }
            }, Ri.prototype.off = function() {
              var t5 = this.element;
              r3.removeEventListener(t5, "mousedown", this.mousedown), r3.removeEventListener(t5, "touchstart", this.touchstart, { passive: false }), r3.removeEventListener(t5, "touchmove", this.touchmove), r3.removeEventListener(t5, "touchend", this.touchend), r3.removeEventListener(t5, "touchcancel", this.reset), this.offTemp();
            }, Ri.prototype.offTemp = function() {
              r3.enableDrag(), r3.removeEventListener(t4.window, "mousemove", this.mousemove), r3.removeEventListener(t4.window, "mouseup", this.mouseup);
            }, Ri.prototype.mousedown = function(e4) {
              this.down(t4.extend({}, e4, { ctrlKey: true, preventDefault: function() {
                return e4.preventDefault();
              } }), r3.mousePos(this.element, e4)), r3.addEventListener(t4.window, "mousemove", this.mousemove), r3.addEventListener(t4.window, "mouseup", this.mouseup);
            }, Ri.prototype.mousemove = function(t5) {
              this.move(t5, r3.mousePos(this.element, t5));
            }, Ri.prototype.mouseup = function(t5) {
              this.mouseRotate.mouseupWindow(t5), this.mousePitch && this.mousePitch.mouseupWindow(t5), this.offTemp();
            }, Ri.prototype.touchstart = function(t5) {
              1 !== t5.targetTouches.length ? this.reset() : (this._startPos = this._lastPos = r3.touchPos(this.element, t5.targetTouches)[0], this.down({ type: "mousedown", button: 0, ctrlKey: true, preventDefault: function() {
                return t5.preventDefault();
              } }, this._startPos));
            }, Ri.prototype.touchmove = function(t5) {
              1 !== t5.targetTouches.length ? this.reset() : (this._lastPos = r3.touchPos(this.element, t5.targetTouches)[0], this.move({ preventDefault: function() {
                return t5.preventDefault();
              } }, this._lastPos));
            }, Ri.prototype.touchend = function(t5) {
              0 === t5.targetTouches.length && this._startPos && this._lastPos && this._startPos.dist(this._lastPos) < this._clickTolerance && this.element.click(), this.reset();
            }, Ri.prototype.reset = function() {
              this.mouseRotate.reset(), this.mousePitch && this.mousePitch.reset(), delete this._startPos, delete this._lastPos, this.offTemp();
            };
            var Bi = { center: "translate(-50%,-50%)", top: "translate(-50%,0)", "top-left": "translate(0,0)", "top-right": "translate(-100%,0)", bottom: "translate(-50%,-100%)", "bottom-left": "translate(0,-100%)", "bottom-right": "translate(-100%,-100%)", left: "translate(0,-50%)", right: "translate(-100%,-50%)" };
            function Ni(t5, e4, r4) {
              var n4 = t5.classList;
              for (var i2 in Bi)
                n4.remove("mapboxgl-" + r4 + "-anchor-" + i2);
              n4.add("mapboxgl-" + r4 + "-anchor-" + e4);
            }
            var ji, Ui = function(e4) {
              function n4(n5, i2) {
                var a2 = this;
                if (e4.call(this), (n5 instanceof t4.window.HTMLElement || i2) && (n5 = t4.extend({ element: n5 }, i2)), t4.bindAll(["_update", "_onMove", "_onUp", "_addDragHandler", "_onMapClick", "_onKeyPress"], this), this._anchor = n5 && n5.anchor || "center", this._color = n5 && n5.color || "#3FB1CE", this._draggable = n5 && n5.draggable || false, this._state = "inactive", this._rotation = n5 && n5.rotation || 0, this._rotationAlignment = n5 && n5.rotationAlignment || "auto", this._pitchAlignment = n5 && n5.pitchAlignment && "auto" !== n5.pitchAlignment ? n5.pitchAlignment : this._rotationAlignment, n5 && n5.element)
                  this._element = n5.element, this._offset = t4.Point.convert(n5 && n5.offset || [0, 0]);
                else {
                  this._defaultMarker = true, this._element = r3.create("div"), this._element.setAttribute("aria-label", "Map marker");
                  var o2 = r3.createNS("http://www.w3.org/2000/svg", "svg");
                  o2.setAttributeNS(null, "display", "block"), o2.setAttributeNS(null, "height", "41px"), o2.setAttributeNS(null, "width", "27px"), o2.setAttributeNS(null, "viewBox", "0 0 27 41");
                  var s2 = r3.createNS("http://www.w3.org/2000/svg", "g");
                  s2.setAttributeNS(null, "stroke", "none"), s2.setAttributeNS(null, "stroke-width", "1"), s2.setAttributeNS(null, "fill", "none"), s2.setAttributeNS(null, "fill-rule", "evenodd");
                  var l2 = r3.createNS("http://www.w3.org/2000/svg", "g");
                  l2.setAttributeNS(null, "fill-rule", "nonzero");
                  var u2 = r3.createNS("http://www.w3.org/2000/svg", "g");
                  u2.setAttributeNS(null, "transform", "translate(3.0, 29.0)"), u2.setAttributeNS(null, "fill", "#000000");
                  for (var c2 = 0, f3 = [{ rx: "10.5", ry: "5.25002273" }, { rx: "10.5", ry: "5.25002273" }, { rx: "9.5", ry: "4.77275007" }, { rx: "8.5", ry: "4.29549936" }, { rx: "7.5", ry: "3.81822308" }, { rx: "6.5", ry: "3.34094679" }, { rx: "5.5", ry: "2.86367051" }, { rx: "4.5", ry: "2.38636864" }]; c2 < f3.length; c2 += 1) {
                    var h2 = f3[c2], p3 = r3.createNS("http://www.w3.org/2000/svg", "ellipse");
                    p3.setAttributeNS(null, "opacity", "0.04"), p3.setAttributeNS(null, "cx", "10.5"), p3.setAttributeNS(null, "cy", "5.80029008"), p3.setAttributeNS(null, "rx", h2.rx), p3.setAttributeNS(null, "ry", h2.ry), u2.appendChild(p3);
                  }
                  var d3 = r3.createNS("http://www.w3.org/2000/svg", "g");
                  d3.setAttributeNS(null, "fill", this._color);
                  var v2 = r3.createNS("http://www.w3.org/2000/svg", "path");
                  v2.setAttributeNS(null, "d", "M27,13.5 C27,19.074644 20.250001,27.000002 14.75,34.500002 C14.016665,35.500004 12.983335,35.500004 12.25,34.500002 C6.7499993,27.000002 0,19.222562 0,13.5 C0,6.0441559 6.0441559,0 13.5,0 C20.955844,0 27,6.0441559 27,13.5 Z"), d3.appendChild(v2);
                  var g3 = r3.createNS("http://www.w3.org/2000/svg", "g");
                  g3.setAttributeNS(null, "opacity", "0.25"), g3.setAttributeNS(null, "fill", "#000000");
                  var y2 = r3.createNS("http://www.w3.org/2000/svg", "path");
                  y2.setAttributeNS(null, "d", "M13.5,0 C6.0441559,0 0,6.0441559 0,13.5 C0,19.222562 6.7499993,27 12.25,34.5 C13,35.522727 14.016664,35.500004 14.75,34.5 C20.250001,27 27,19.074644 27,13.5 C27,6.0441559 20.955844,0 13.5,0 Z M13.5,1 C20.415404,1 26,6.584596 26,13.5 C26,15.898657 24.495584,19.181431 22.220703,22.738281 C19.945823,26.295132 16.705119,30.142167 13.943359,33.908203 C13.743445,34.180814 13.612715,34.322738 13.5,34.441406 C13.387285,34.322738 13.256555,34.180814 13.056641,33.908203 C10.284481,30.127985 7.4148684,26.314159 5.015625,22.773438 C2.6163816,19.232715 1,15.953538 1,13.5 C1,6.584596 6.584596,1 13.5,1 Z"), g3.appendChild(y2);
                  var m3 = r3.createNS("http://www.w3.org/2000/svg", "g");
                  m3.setAttributeNS(null, "transform", "translate(6.0, 7.0)"), m3.setAttributeNS(null, "fill", "#FFFFFF");
                  var x2 = r3.createNS("http://www.w3.org/2000/svg", "g");
                  x2.setAttributeNS(null, "transform", "translate(8.0, 8.0)");
                  var b2 = r3.createNS("http://www.w3.org/2000/svg", "circle");
                  b2.setAttributeNS(null, "fill", "#000000"), b2.setAttributeNS(null, "opacity", "0.25"), b2.setAttributeNS(null, "cx", "5.5"), b2.setAttributeNS(null, "cy", "5.5"), b2.setAttributeNS(null, "r", "5.4999962");
                  var _2 = r3.createNS("http://www.w3.org/2000/svg", "circle");
                  _2.setAttributeNS(null, "fill", "#FFFFFF"), _2.setAttributeNS(null, "cx", "5.5"), _2.setAttributeNS(null, "cy", "5.5"), _2.setAttributeNS(null, "r", "5.4999962"), x2.appendChild(b2), x2.appendChild(_2), l2.appendChild(u2), l2.appendChild(d3), l2.appendChild(g3), l2.appendChild(m3), l2.appendChild(x2), o2.appendChild(l2), this._element.appendChild(o2), this._offset = t4.Point.convert(n5 && n5.offset || [0, -14]);
                }
                this._element.classList.add("mapboxgl-marker"), this._element.addEventListener("dragstart", function(t5) {
                  t5.preventDefault();
                }), this._element.addEventListener("mousedown", function(t5) {
                  t5.preventDefault();
                }), this._element.addEventListener("focus", function() {
                  var t5 = a2._map.getContainer();
                  t5.scrollTop = 0, t5.scrollLeft = 0;
                }), Ni(this._element, this._anchor, "marker"), this._popup = null;
              }
              return e4 && (n4.__proto__ = e4), n4.prototype = Object.create(e4 && e4.prototype), n4.prototype.constructor = n4, n4.prototype.addTo = function(t5) {
                return this.remove(), this._map = t5, t5.getCanvasContainer().appendChild(this._element), t5.on("move", this._update), t5.on("moveend", this._update), this.setDraggable(this._draggable), this._update(), this._map.on("click", this._onMapClick), this;
              }, n4.prototype.remove = function() {
                return this._map && (this._map.off("click", this._onMapClick), this._map.off("move", this._update), this._map.off("moveend", this._update), this._map.off("mousedown", this._addDragHandler), this._map.off("touchstart", this._addDragHandler), this._map.off("mouseup", this._onUp), this._map.off("touchend", this._onUp), this._map.off("mousemove", this._onMove), this._map.off("touchmove", this._onMove), delete this._map), r3.remove(this._element), this._popup && this._popup.remove(), this;
              }, n4.prototype.getLngLat = function() {
                return this._lngLat;
              }, n4.prototype.setLngLat = function(e5) {
                return this._lngLat = t4.LngLat.convert(e5), this._pos = null, this._popup && this._popup.setLngLat(this._lngLat), this._update(), this;
              }, n4.prototype.getElement = function() {
                return this._element;
              }, n4.prototype.setPopup = function(t5) {
                if (this._popup && (this._popup.remove(), this._popup = null, this._element.removeEventListener("keypress", this._onKeyPress), this._originalTabIndex || this._element.removeAttribute("tabindex")), t5) {
                  if (!("offset" in t5.options)) {
                    var e5 = 13.5, r4 = Math.sqrt(Math.pow(e5, 2) / 2);
                    t5.options.offset = this._defaultMarker ? { top: [0, 0], "top-left": [0, 0], "top-right": [0, 0], bottom: [0, -38.1], "bottom-left": [r4, -1 * (24.6 + r4)], "bottom-right": [-r4, -1 * (24.6 + r4)], left: [e5, -24.6], right: [-13.5, -24.6] } : this._offset;
                  }
                  this._popup = t5, this._lngLat && this._popup.setLngLat(this._lngLat), this._originalTabIndex = this._element.getAttribute("tabindex"), this._originalTabIndex || this._element.setAttribute("tabindex", "0"), this._element.addEventListener("keypress", this._onKeyPress);
                }
                return this;
              }, n4.prototype._onKeyPress = function(t5) {
                var e5 = t5.code, r4 = t5.charCode || t5.keyCode;
                "Space" !== e5 && "Enter" !== e5 && 32 !== r4 && 13 !== r4 || this.togglePopup();
              }, n4.prototype._onMapClick = function(t5) {
                var e5 = t5.originalEvent.target, r4 = this._element;
                this._popup && (e5 === r4 || r4.contains(e5)) && this.togglePopup();
              }, n4.prototype.getPopup = function() {
                return this._popup;
              }, n4.prototype.togglePopup = function() {
                var t5 = this._popup;
                return t5 ? (t5.isOpen() ? t5.remove() : t5.addTo(this._map), this) : this;
              }, n4.prototype._update = function(t5) {
                if (this._map) {
                  this._map.transform.renderWorldCopies && (this._lngLat = Fi(this._lngLat, this._pos, this._map.transform)), this._pos = this._map.project(this._lngLat)._add(this._offset);
                  var e5 = "";
                  "viewport" === this._rotationAlignment || "auto" === this._rotationAlignment ? e5 = "rotateZ(" + this._rotation + "deg)" : "map" === this._rotationAlignment && (e5 = "rotateZ(" + (this._rotation - this._map.getBearing()) + "deg)");
                  var n5 = "";
                  "viewport" === this._pitchAlignment || "auto" === this._pitchAlignment ? n5 = "rotateX(0deg)" : "map" === this._pitchAlignment && (n5 = "rotateX(" + this._map.getPitch() + "deg)"), t5 && "moveend" !== t5.type || (this._pos = this._pos.round()), r3.setTransform(this._element, Bi[this._anchor] + " translate(" + this._pos.x + "px, " + this._pos.y + "px) " + n5 + " " + e5);
                }
              }, n4.prototype.getOffset = function() {
                return this._offset;
              }, n4.prototype.setOffset = function(e5) {
                return this._offset = t4.Point.convert(e5), this._update(), this;
              }, n4.prototype._onMove = function(e5) {
                this._pos = e5.point.sub(this._positionDelta), this._lngLat = this._map.unproject(this._pos), this.setLngLat(this._lngLat), this._element.style.pointerEvents = "none", "pending" === this._state && (this._state = "active", this.fire(new t4.Event("dragstart"))), this.fire(new t4.Event("drag"));
              }, n4.prototype._onUp = function() {
                this._element.style.pointerEvents = "auto", this._positionDelta = null, this._map.off("mousemove", this._onMove), this._map.off("touchmove", this._onMove), "active" === this._state && this.fire(new t4.Event("dragend")), this._state = "inactive";
              }, n4.prototype._addDragHandler = function(t5) {
                this._element.contains(t5.originalEvent.target) && (t5.preventDefault(), this._positionDelta = t5.point.sub(this._pos).add(this._offset), this._state = "pending", this._map.on("mousemove", this._onMove), this._map.on("touchmove", this._onMove), this._map.once("mouseup", this._onUp), this._map.once("touchend", this._onUp));
              }, n4.prototype.setDraggable = function(t5) {
                return this._draggable = !!t5, this._map && (t5 ? (this._map.on("mousedown", this._addDragHandler), this._map.on("touchstart", this._addDragHandler)) : (this._map.off("mousedown", this._addDragHandler), this._map.off("touchstart", this._addDragHandler))), this;
              }, n4.prototype.isDraggable = function() {
                return this._draggable;
              }, n4.prototype.setRotation = function(t5) {
                return this._rotation = t5 || 0, this._update(), this;
              }, n4.prototype.getRotation = function() {
                return this._rotation;
              }, n4.prototype.setRotationAlignment = function(t5) {
                return this._rotationAlignment = t5 || "auto", this._update(), this;
              }, n4.prototype.getRotationAlignment = function() {
                return this._rotationAlignment;
              }, n4.prototype.setPitchAlignment = function(t5) {
                return this._pitchAlignment = t5 && "auto" !== t5 ? t5 : this._rotationAlignment, this._update(), this;
              }, n4.prototype.getPitchAlignment = function() {
                return this._pitchAlignment;
              }, n4;
            }(t4.Evented), Vi = { positionOptions: { enableHighAccuracy: false, maximumAge: 0, timeout: 6e3 }, fitBoundsOptions: { maxZoom: 15 }, trackUserLocation: false, showAccuracyCircle: true, showUserLocation: true };
            var Hi = 0, qi = false, Gi = function(e4) {
              function n4(r4) {
                e4.call(this), this.options = t4.extend({}, Vi, r4), t4.bindAll(["_onSuccess", "_onError", "_onZoom", "_finish", "_setupUI", "_updateCamera", "_updateMarker"], this);
              }
              return e4 && (n4.__proto__ = e4), n4.prototype = Object.create(e4 && e4.prototype), n4.prototype.constructor = n4, n4.prototype.onAdd = function(e5) {
                return this._map = e5, this._container = r3.create("div", "mapboxgl-ctrl mapboxgl-ctrl-group"), n5 = this._setupUI, void 0 !== ji ? n5(ji) : void 0 !== t4.window.navigator.permissions ? t4.window.navigator.permissions.query({ name: "geolocation" }).then(function(t5) {
                  ji = "denied" !== t5.state, n5(ji);
                }) : (ji = !!t4.window.navigator.geolocation, n5(ji)), this._container;
                var n5;
              }, n4.prototype.onRemove = function() {
                void 0 !== this._geolocationWatchID && (t4.window.navigator.geolocation.clearWatch(this._geolocationWatchID), this._geolocationWatchID = void 0), this.options.showUserLocation && this._userLocationDotMarker && this._userLocationDotMarker.remove(), this.options.showAccuracyCircle && this._accuracyCircleMarker && this._accuracyCircleMarker.remove(), r3.remove(this._container), this._map.off("zoom", this._onZoom), this._map = void 0, Hi = 0, qi = false;
              }, n4.prototype._isOutOfMapMaxBounds = function(t5) {
                var e5 = this._map.getMaxBounds(), r4 = t5.coords;
                return e5 && (r4.longitude < e5.getWest() || r4.longitude > e5.getEast() || r4.latitude < e5.getSouth() || r4.latitude > e5.getNorth());
              }, n4.prototype._setErrorState = function() {
                switch (this._watchState) {
                  case "WAITING_ACTIVE":
                    this._watchState = "ACTIVE_ERROR", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active-error");
                    break;
                  case "ACTIVE_LOCK":
                    this._watchState = "ACTIVE_ERROR", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active-error"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting");
                    break;
                  case "BACKGROUND":
                    this._watchState = "BACKGROUND_ERROR", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background-error"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting");
                }
              }, n4.prototype._onSuccess = function(e5) {
                if (this._map) {
                  if (this._isOutOfMapMaxBounds(e5))
                    return this._setErrorState(), this.fire(new t4.Event("outofmaxbounds", e5)), this._updateMarker(), void this._finish();
                  if (this.options.trackUserLocation)
                    switch (this._lastKnownPosition = e5, this._watchState) {
                      case "WAITING_ACTIVE":
                      case "ACTIVE_LOCK":
                      case "ACTIVE_ERROR":
                        this._watchState = "ACTIVE_LOCK", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active-error"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active");
                        break;
                      case "BACKGROUND":
                      case "BACKGROUND_ERROR":
                        this._watchState = "BACKGROUND", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background-error"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background");
                    }
                  this.options.showUserLocation && "OFF" !== this._watchState && this._updateMarker(e5), this.options.trackUserLocation && "ACTIVE_LOCK" !== this._watchState || this._updateCamera(e5), this.options.showUserLocation && this._dotElement.classList.remove("mapboxgl-user-location-dot-stale"), this.fire(new t4.Event("geolocate", e5)), this._finish();
                }
              }, n4.prototype._updateCamera = function(e5) {
                var r4 = new t4.LngLat(e5.coords.longitude, e5.coords.latitude), n5 = e5.coords.accuracy, i2 = this._map.getBearing(), a2 = t4.extend({ bearing: i2 }, this.options.fitBoundsOptions);
                this._map.fitBounds(r4.toBounds(n5), a2, { geolocateSource: true });
              }, n4.prototype._updateMarker = function(e5) {
                if (e5) {
                  var r4 = new t4.LngLat(e5.coords.longitude, e5.coords.latitude);
                  this._accuracyCircleMarker.setLngLat(r4).addTo(this._map), this._userLocationDotMarker.setLngLat(r4).addTo(this._map), this._accuracy = e5.coords.accuracy, this.options.showUserLocation && this.options.showAccuracyCircle && this._updateCircleRadius();
                } else
                  this._userLocationDotMarker.remove(), this._accuracyCircleMarker.remove();
              }, n4.prototype._updateCircleRadius = function() {
                var t5 = this._map._container.clientHeight / 2, e5 = this._map.unproject([0, t5]), r4 = this._map.unproject([1, t5]), n5 = e5.distanceTo(r4), i2 = Math.ceil(2 * this._accuracy / n5);
                this._circleElement.style.width = i2 + "px", this._circleElement.style.height = i2 + "px";
              }, n4.prototype._onZoom = function() {
                this.options.showUserLocation && this.options.showAccuracyCircle && this._updateCircleRadius();
              }, n4.prototype._onError = function(e5) {
                if (this._map) {
                  if (this.options.trackUserLocation)
                    if (1 === e5.code) {
                      this._watchState = "OFF", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active-error"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background-error"), this._geolocateButton.disabled = true;
                      var r4 = this._map._getUIString("GeolocateControl.LocationNotAvailable");
                      this._geolocateButton.title = r4, this._geolocateButton.setAttribute("aria-label", r4), void 0 !== this._geolocationWatchID && this._clearWatch();
                    } else {
                      if (3 === e5.code && qi)
                        return;
                      this._setErrorState();
                    }
                  "OFF" !== this._watchState && this.options.showUserLocation && this._dotElement.classList.add("mapboxgl-user-location-dot-stale"), this.fire(new t4.Event("error", e5)), this._finish();
                }
              }, n4.prototype._finish = function() {
                this._timeoutId && clearTimeout(this._timeoutId), this._timeoutId = void 0;
              }, n4.prototype._setupUI = function(e5) {
                var n5 = this;
                if (this._container.addEventListener("contextmenu", function(t5) {
                  return t5.preventDefault();
                }), this._geolocateButton = r3.create("button", "mapboxgl-ctrl-geolocate", this._container), r3.create("span", "mapboxgl-ctrl-icon", this._geolocateButton).setAttribute("aria-hidden", true), this._geolocateButton.type = "button", false === e5) {
                  t4.warnOnce("Geolocation support is not available so the GeolocateControl will be disabled.");
                  var i2 = this._map._getUIString("GeolocateControl.LocationNotAvailable");
                  this._geolocateButton.disabled = true, this._geolocateButton.title = i2, this._geolocateButton.setAttribute("aria-label", i2);
                } else {
                  var a2 = this._map._getUIString("GeolocateControl.FindMyLocation");
                  this._geolocateButton.title = a2, this._geolocateButton.setAttribute("aria-label", a2);
                }
                this.options.trackUserLocation && (this._geolocateButton.setAttribute("aria-pressed", "false"), this._watchState = "OFF"), this.options.showUserLocation && (this._dotElement = r3.create("div", "mapboxgl-user-location-dot"), this._userLocationDotMarker = new Ui(this._dotElement), this._circleElement = r3.create("div", "mapboxgl-user-location-accuracy-circle"), this._accuracyCircleMarker = new Ui({ element: this._circleElement, pitchAlignment: "map" }), this.options.trackUserLocation && (this._watchState = "OFF"), this._map.on("zoom", this._onZoom)), this._geolocateButton.addEventListener("click", this.trigger.bind(this)), this._setup = true, this.options.trackUserLocation && this._map.on("movestart", function(e6) {
                  var r4 = e6.originalEvent && "resize" === e6.originalEvent.type;
                  e6.geolocateSource || "ACTIVE_LOCK" !== n5._watchState || r4 || (n5._watchState = "BACKGROUND", n5._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background"), n5._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"), n5.fire(new t4.Event("trackuserlocationend")));
                });
              }, n4.prototype.trigger = function() {
                if (!this._setup)
                  return t4.warnOnce("Geolocate control triggered before added to a map"), false;
                if (this.options.trackUserLocation) {
                  switch (this._watchState) {
                    case "OFF":
                      this._watchState = "WAITING_ACTIVE", this.fire(new t4.Event("trackuserlocationstart"));
                      break;
                    case "WAITING_ACTIVE":
                    case "ACTIVE_LOCK":
                    case "ACTIVE_ERROR":
                    case "BACKGROUND_ERROR":
                      Hi--, qi = false, this._watchState = "OFF", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active-error"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background-error"), this.fire(new t4.Event("trackuserlocationend"));
                      break;
                    case "BACKGROUND":
                      this._watchState = "ACTIVE_LOCK", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"), this._lastKnownPosition && this._updateCamera(this._lastKnownPosition), this.fire(new t4.Event("trackuserlocationstart"));
                  }
                  switch (this._watchState) {
                    case "WAITING_ACTIVE":
                      this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active");
                      break;
                    case "ACTIVE_LOCK":
                      this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active");
                      break;
                    case "ACTIVE_ERROR":
                      this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active-error");
                      break;
                    case "BACKGROUND":
                      this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background");
                      break;
                    case "BACKGROUND_ERROR":
                      this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background-error");
                  }
                  if ("OFF" === this._watchState && void 0 !== this._geolocationWatchID)
                    this._clearWatch();
                  else if (void 0 === this._geolocationWatchID) {
                    var e5;
                    this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.setAttribute("aria-pressed", "true"), ++Hi > 1 ? (e5 = { maximumAge: 6e5, timeout: 0 }, qi = true) : (e5 = this.options.positionOptions, qi = false), this._geolocationWatchID = t4.window.navigator.geolocation.watchPosition(this._onSuccess, this._onError, e5);
                  }
                } else
                  t4.window.navigator.geolocation.getCurrentPosition(this._onSuccess, this._onError, this.options.positionOptions), this._timeoutId = setTimeout(this._finish, 1e4);
                return true;
              }, n4.prototype._clearWatch = function() {
                t4.window.navigator.geolocation.clearWatch(this._geolocationWatchID), this._geolocationWatchID = void 0, this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.setAttribute("aria-pressed", "false"), this.options.showUserLocation && this._updateMarker(null);
              }, n4;
            }(t4.Evented), Zi = { maxWidth: 100, unit: "metric" }, Yi = function(e4) {
              this.options = t4.extend({}, Zi, e4), t4.bindAll(["_onMove", "setUnit"], this);
            };
            function Wi(t5, e4, r4) {
              var n4 = r4 && r4.maxWidth || 100, i2 = t5._container.clientHeight / 2, a2 = t5.unproject([0, i2]), o2 = t5.unproject([n4, i2]), s2 = a2.distanceTo(o2);
              if (r4 && "imperial" === r4.unit) {
                var l2 = 3.2808 * s2;
                l2 > 5280 ? Xi(e4, n4, l2 / 5280, t5._getUIString("ScaleControl.Miles")) : Xi(e4, n4, l2, t5._getUIString("ScaleControl.Feet"));
              } else
                r4 && "nautical" === r4.unit ? Xi(e4, n4, s2 / 1852, t5._getUIString("ScaleControl.NauticalMiles")) : s2 >= 1e3 ? Xi(e4, n4, s2 / 1e3, t5._getUIString("ScaleControl.Kilometers")) : Xi(e4, n4, s2, t5._getUIString("ScaleControl.Meters"));
            }
            function Xi(t5, e4, r4, n4) {
              var i2, a2, o2, s2 = (i2 = r4, (a2 = Math.pow(10, ("" + Math.floor(i2)).length - 1)) * ((o2 = i2 / a2) >= 10 ? 10 : o2 >= 5 ? 5 : o2 >= 3 ? 3 : o2 >= 2 ? 2 : o2 >= 1 ? 1 : function(t6) {
                var e5 = Math.pow(10, Math.ceil(-Math.log(t6) / Math.LN10));
                return Math.round(t6 * e5) / e5;
              }(o2))), l2 = s2 / r4;
              t5.style.width = e4 * l2 + "px", t5.innerHTML = s2 + "&nbsp;" + n4;
            }
            Yi.prototype.getDefaultPosition = function() {
              return "bottom-left";
            }, Yi.prototype._onMove = function() {
              Wi(this._map, this._container, this.options);
            }, Yi.prototype.onAdd = function(t5) {
              return this._map = t5, this._container = r3.create("div", "mapboxgl-ctrl mapboxgl-ctrl-scale", t5.getContainer()), this._map.on("move", this._onMove), this._onMove(), this._container;
            }, Yi.prototype.onRemove = function() {
              r3.remove(this._container), this._map.off("move", this._onMove), this._map = void 0;
            }, Yi.prototype.setUnit = function(t5) {
              this.options.unit = t5, Wi(this._map, this._container, this.options);
            };
            var Ji = function(e4) {
              this._fullscreen = false, e4 && e4.container && (e4.container instanceof t4.window.HTMLElement ? this._container = e4.container : t4.warnOnce("Full screen control 'container' must be a DOM element.")), t4.bindAll(["_onClickFullscreen", "_changeIcon"], this), "onfullscreenchange" in t4.window.document ? this._fullscreenchange = "fullscreenchange" : "onmozfullscreenchange" in t4.window.document ? this._fullscreenchange = "mozfullscreenchange" : "onwebkitfullscreenchange" in t4.window.document ? this._fullscreenchange = "webkitfullscreenchange" : "onmsfullscreenchange" in t4.window.document && (this._fullscreenchange = "MSFullscreenChange");
            };
            Ji.prototype.onAdd = function(e4) {
              return this._map = e4, this._container || (this._container = this._map.getContainer()), this._controlContainer = r3.create("div", "mapboxgl-ctrl mapboxgl-ctrl-group"), this._checkFullscreenSupport() ? this._setupUI() : (this._controlContainer.style.display = "none", t4.warnOnce("This device does not support fullscreen mode.")), this._controlContainer;
            }, Ji.prototype.onRemove = function() {
              r3.remove(this._controlContainer), this._map = null, t4.window.document.removeEventListener(this._fullscreenchange, this._changeIcon);
            }, Ji.prototype._checkFullscreenSupport = function() {
              return !!(t4.window.document.fullscreenEnabled || t4.window.document.mozFullScreenEnabled || t4.window.document.msFullscreenEnabled || t4.window.document.webkitFullscreenEnabled);
            }, Ji.prototype._setupUI = function() {
              var e4 = this._fullscreenButton = r3.create("button", "mapboxgl-ctrl-fullscreen", this._controlContainer);
              r3.create("span", "mapboxgl-ctrl-icon", e4).setAttribute("aria-hidden", true), e4.type = "button", this._updateTitle(), this._fullscreenButton.addEventListener("click", this._onClickFullscreen), t4.window.document.addEventListener(this._fullscreenchange, this._changeIcon);
            }, Ji.prototype._updateTitle = function() {
              var t5 = this._getTitle();
              this._fullscreenButton.setAttribute("aria-label", t5), this._fullscreenButton.title = t5;
            }, Ji.prototype._getTitle = function() {
              return this._map._getUIString(this._isFullscreen() ? "FullscreenControl.Exit" : "FullscreenControl.Enter");
            }, Ji.prototype._isFullscreen = function() {
              return this._fullscreen;
            }, Ji.prototype._changeIcon = function() {
              (t4.window.document.fullscreenElement || t4.window.document.mozFullScreenElement || t4.window.document.webkitFullscreenElement || t4.window.document.msFullscreenElement) === this._container !== this._fullscreen && (this._fullscreen = !this._fullscreen, this._fullscreenButton.classList.toggle("mapboxgl-ctrl-shrink"), this._fullscreenButton.classList.toggle("mapboxgl-ctrl-fullscreen"), this._updateTitle());
            }, Ji.prototype._onClickFullscreen = function() {
              this._isFullscreen() ? t4.window.document.exitFullscreen ? t4.window.document.exitFullscreen() : t4.window.document.mozCancelFullScreen ? t4.window.document.mozCancelFullScreen() : t4.window.document.msExitFullscreen ? t4.window.document.msExitFullscreen() : t4.window.document.webkitCancelFullScreen && t4.window.document.webkitCancelFullScreen() : this._container.requestFullscreen ? this._container.requestFullscreen() : this._container.mozRequestFullScreen ? this._container.mozRequestFullScreen() : this._container.msRequestFullscreen ? this._container.msRequestFullscreen() : this._container.webkitRequestFullscreen && this._container.webkitRequestFullscreen();
            };
            var Ki = { closeButton: true, closeOnClick: true, className: "", maxWidth: "240px" }, $i = function(e4) {
              function n4(r4) {
                e4.call(this), this.options = t4.extend(Object.create(Ki), r4), t4.bindAll(["_update", "_onClose", "remove", "_onMouseMove", "_onMouseUp", "_onDrag"], this);
              }
              return e4 && (n4.__proto__ = e4), n4.prototype = Object.create(e4 && e4.prototype), n4.prototype.constructor = n4, n4.prototype.addTo = function(e5) {
                return this._map && this.remove(), this._map = e5, this.options.closeOnClick && this._map.on("click", this._onClose), this.options.closeOnMove && this._map.on("move", this._onClose), this._map.on("remove", this.remove), this._update(), this._trackPointer ? (this._map.on("mousemove", this._onMouseMove), this._map.on("mouseup", this._onMouseUp), this._container && this._container.classList.add("mapboxgl-popup-track-pointer"), this._map._canvasContainer.classList.add("mapboxgl-track-pointer")) : this._map.on("move", this._update), this.fire(new t4.Event("open")), this;
              }, n4.prototype.isOpen = function() {
                return !!this._map;
              }, n4.prototype.remove = function() {
                return this._content && r3.remove(this._content), this._container && (r3.remove(this._container), delete this._container), this._map && (this._map.off("move", this._update), this._map.off("move", this._onClose), this._map.off("click", this._onClose), this._map.off("remove", this.remove), this._map.off("mousemove", this._onMouseMove), this._map.off("mouseup", this._onMouseUp), this._map.off("drag", this._onDrag), delete this._map), this.fire(new t4.Event("close")), this;
              }, n4.prototype.getLngLat = function() {
                return this._lngLat;
              }, n4.prototype.setLngLat = function(e5) {
                return this._lngLat = t4.LngLat.convert(e5), this._pos = null, this._trackPointer = false, this._update(), this._map && (this._map.on("move", this._update), this._map.off("mousemove", this._onMouseMove), this._container && this._container.classList.remove("mapboxgl-popup-track-pointer"), this._map._canvasContainer.classList.remove("mapboxgl-track-pointer")), this;
              }, n4.prototype.trackPointer = function() {
                return this._trackPointer = true, this._pos = null, this._update(), this._map && (this._map.off("move", this._update), this._map.on("mousemove", this._onMouseMove), this._map.on("drag", this._onDrag), this._container && this._container.classList.add("mapboxgl-popup-track-pointer"), this._map._canvasContainer.classList.add("mapboxgl-track-pointer")), this;
              }, n4.prototype.getElement = function() {
                return this._container;
              }, n4.prototype.setText = function(e5) {
                return this.setDOMContent(t4.window.document.createTextNode(e5));
              }, n4.prototype.setHTML = function(e5) {
                var r4, n5 = t4.window.document.createDocumentFragment(), i2 = t4.window.document.createElement("body");
                for (i2.innerHTML = e5; r4 = i2.firstChild; )
                  n5.appendChild(r4);
                return this.setDOMContent(n5);
              }, n4.prototype.getMaxWidth = function() {
                return this._container && this._container.style.maxWidth;
              }, n4.prototype.setMaxWidth = function(t5) {
                return this.options.maxWidth = t5, this._update(), this;
              }, n4.prototype.setDOMContent = function(t5) {
                return this._createContent(), this._content.appendChild(t5), this._update(), this;
              }, n4.prototype.addClassName = function(t5) {
                this._container && this._container.classList.add(t5);
              }, n4.prototype.removeClassName = function(t5) {
                this._container && this._container.classList.remove(t5);
              }, n4.prototype.toggleClassName = function(t5) {
                if (this._container)
                  return this._container.classList.toggle(t5);
              }, n4.prototype._createContent = function() {
                this._content && r3.remove(this._content), this._content = r3.create("div", "mapboxgl-popup-content", this._container), this.options.closeButton && (this._closeButton = r3.create("button", "mapboxgl-popup-close-button", this._content), this._closeButton.type = "button", this._closeButton.setAttribute("aria-label", "Close popup"), this._closeButton.innerHTML = "&#215;", this._closeButton.addEventListener("click", this._onClose));
              }, n4.prototype._onMouseUp = function(t5) {
                this._update(t5.point);
              }, n4.prototype._onMouseMove = function(t5) {
                this._update(t5.point);
              }, n4.prototype._onDrag = function(t5) {
                this._update(t5.point);
              }, n4.prototype._update = function(t5) {
                var e5 = this, n5 = this._lngLat || this._trackPointer;
                if (this._map && n5 && this._content && (this._container || (this._container = r3.create("div", "mapboxgl-popup", this._map.getContainer()), this._tip = r3.create("div", "mapboxgl-popup-tip", this._container), this._container.appendChild(this._content), this.options.className && this.options.className.split(" ").forEach(function(t6) {
                  return e5._container.classList.add(t6);
                }), this._trackPointer && this._container.classList.add("mapboxgl-popup-track-pointer")), this.options.maxWidth && this._container.style.maxWidth !== this.options.maxWidth && (this._container.style.maxWidth = this.options.maxWidth), this._map.transform.renderWorldCopies && !this._trackPointer && (this._lngLat = Fi(this._lngLat, this._pos, this._map.transform)), !this._trackPointer || t5)) {
                  var i2 = this._pos = this._trackPointer && t5 ? t5 : this._map.project(this._lngLat), a2 = this.options.anchor, o2 = Qi(this.options.offset);
                  if (!a2) {
                    var s2, l2 = this._container.offsetWidth, u2 = this._container.offsetHeight;
                    s2 = i2.y + o2.bottom.y < u2 ? ["top"] : i2.y > this._map.transform.height - u2 ? ["bottom"] : [], i2.x < l2 / 2 ? s2.push("left") : i2.x > this._map.transform.width - l2 / 2 && s2.push("right"), a2 = 0 === s2.length ? "bottom" : s2.join("-");
                  }
                  var c2 = i2.add(o2[a2]).round();
                  r3.setTransform(this._container, Bi[a2] + " translate(" + c2.x + "px," + c2.y + "px)"), Ni(this._container, a2, "popup");
                }
              }, n4.prototype._onClose = function() {
                this.remove();
              }, n4;
            }(t4.Evented);
            function Qi(e4) {
              if (e4) {
                if ("number" == typeof e4) {
                  var r4 = Math.round(Math.sqrt(0.5 * Math.pow(e4, 2)));
                  return { center: new t4.Point(0, 0), top: new t4.Point(0, e4), "top-left": new t4.Point(r4, r4), "top-right": new t4.Point(-r4, r4), bottom: new t4.Point(0, -e4), "bottom-left": new t4.Point(r4, -r4), "bottom-right": new t4.Point(-r4, -r4), left: new t4.Point(e4, 0), right: new t4.Point(-e4, 0) };
                }
                if (e4 instanceof t4.Point || Array.isArray(e4)) {
                  var n4 = t4.Point.convert(e4);
                  return { center: n4, top: n4, "top-left": n4, "top-right": n4, bottom: n4, "bottom-left": n4, "bottom-right": n4, left: n4, right: n4 };
                }
                return { center: t4.Point.convert(e4.center || [0, 0]), top: t4.Point.convert(e4.top || [0, 0]), "top-left": t4.Point.convert(e4["top-left"] || [0, 0]), "top-right": t4.Point.convert(e4["top-right"] || [0, 0]), bottom: t4.Point.convert(e4.bottom || [0, 0]), "bottom-left": t4.Point.convert(e4["bottom-left"] || [0, 0]), "bottom-right": t4.Point.convert(e4["bottom-right"] || [0, 0]), left: t4.Point.convert(e4.left || [0, 0]), right: t4.Point.convert(e4.right || [0, 0]) };
              }
              return Qi(new t4.Point(0, 0));
            }
            var ta = { version: t4.version, supported: e3, setRTLTextPlugin: t4.setRTLTextPlugin, getRTLTextPluginStatus: t4.getRTLTextPluginStatus, Map: Oi, NavigationControl: zi, GeolocateControl: Gi, AttributionControl: Ti, ScaleControl: Yi, FullscreenControl: Ji, Popup: $i, Marker: Ui, Style: Ye, LngLat: t4.LngLat, LngLatBounds: t4.LngLatBounds, Point: t4.Point, MercatorCoordinate: t4.MercatorCoordinate, Evented: t4.Evented, config: t4.config, prewarm: function() {
              jt().acquire(Rt);
            }, clearPrewarmedResources: function() {
              var t5 = Bt;
              t5 && (t5.isPreloaded() && 1 === t5.numActive() ? (t5.release(Rt), Bt = null) : console.warn("Could not clear WebWorkers since there are active Map instances that still reference it. The pre-warmed WebWorker pool can only be cleared when all map instances have been removed with map.remove()"));
            }, get accessToken() {
              return t4.config.ACCESS_TOKEN;
            }, set accessToken(e4) {
              t4.config.ACCESS_TOKEN = e4;
            }, get baseApiUrl() {
              return t4.config.API_URL;
            }, set baseApiUrl(e4) {
              t4.config.API_URL = e4;
            }, get workerCount() {
              return Ft.workerCount;
            }, set workerCount(t5) {
              Ft.workerCount = t5;
            }, get maxParallelImageRequests() {
              return t4.config.MAX_PARALLEL_IMAGE_REQUESTS;
            }, set maxParallelImageRequests(e4) {
              t4.config.MAX_PARALLEL_IMAGE_REQUESTS = e4;
            }, clearStorage: function(e4) {
              t4.clearTileCache(e4);
            }, workerUrl: "" };
            return ta;
          }), r2;
        }();
      }, 27084: function(t2) {
        t2.exports = Math.log2 || function(t3) {
          return Math.log(t3) * Math.LOG2E;
        };
      }, 16825: function(t2, e2, r2) {
        t2.exports = function(t3, e3) {
          e3 || (e3 = t3, t3 = window);
          var r3 = 0, i = 0, a = 0, o = { shift: false, alt: false, control: false, meta: false }, s = false;
          function l(t4) {
            var e4 = false;
            return "altKey" in t4 && (e4 = e4 || t4.altKey !== o.alt, o.alt = !!t4.altKey), "shiftKey" in t4 && (e4 = e4 || t4.shiftKey !== o.shift, o.shift = !!t4.shiftKey), "ctrlKey" in t4 && (e4 = e4 || t4.ctrlKey !== o.control, o.control = !!t4.ctrlKey), "metaKey" in t4 && (e4 = e4 || t4.metaKey !== o.meta, o.meta = !!t4.metaKey), e4;
          }
          function u(t4, s2) {
            var u2 = n2.x(s2), c2 = n2.y(s2);
            "buttons" in s2 && (t4 = 0 | s2.buttons), (t4 !== r3 || u2 !== i || c2 !== a || l(s2)) && (r3 = 0 | t4, i = u2 || 0, a = c2 || 0, e3 && e3(r3, i, a, o));
          }
          function c(t4) {
            u(0, t4);
          }
          function f2() {
            (r3 || i || a || o.shift || o.alt || o.meta || o.control) && (i = a = 0, r3 = 0, o.shift = o.alt = o.control = o.meta = false, e3 && e3(0, 0, 0, o));
          }
          function h(t4) {
            l(t4) && e3 && e3(r3, i, a, o);
          }
          function p2(t4) {
            0 === n2.buttons(t4) ? u(0, t4) : u(r3, t4);
          }
          function d2(t4) {
            u(r3 | n2.buttons(t4), t4);
          }
          function v(t4) {
            u(r3 & ~n2.buttons(t4), t4);
          }
          function g2() {
            s || (s = true, t3.addEventListener("mousemove", p2), t3.addEventListener("mousedown", d2), t3.addEventListener("mouseup", v), t3.addEventListener("mouseleave", c), t3.addEventListener("mouseenter", c), t3.addEventListener("mouseout", c), t3.addEventListener("mouseover", c), t3.addEventListener("blur", f2), t3.addEventListener("keyup", h), t3.addEventListener("keydown", h), t3.addEventListener("keypress", h), t3 !== window && (window.addEventListener("blur", f2), window.addEventListener("keyup", h), window.addEventListener("keydown", h), window.addEventListener("keypress", h)));
          }
          g2();
          var y = { element: t3 };
          return Object.defineProperties(y, { enabled: { get: function() {
            return s;
          }, set: function(e4) {
            e4 ? g2() : s && (s = false, t3.removeEventListener("mousemove", p2), t3.removeEventListener("mousedown", d2), t3.removeEventListener("mouseup", v), t3.removeEventListener("mouseleave", c), t3.removeEventListener("mouseenter", c), t3.removeEventListener("mouseout", c), t3.removeEventListener("mouseover", c), t3.removeEventListener("blur", f2), t3.removeEventListener("keyup", h), t3.removeEventListener("keydown", h), t3.removeEventListener("keypress", h), t3 !== window && (window.removeEventListener("blur", f2), window.removeEventListener("keyup", h), window.removeEventListener("keydown", h), window.removeEventListener("keypress", h)));
          }, enumerable: true }, buttons: { get: function() {
            return r3;
          }, enumerable: true }, x: { get: function() {
            return i;
          }, enumerable: true }, y: { get: function() {
            return a;
          }, enumerable: true }, mods: { get: function() {
            return o;
          }, enumerable: true } }), y;
        };
        var n2 = r2(74311);
      }, 48956: function(t2) {
        var e2 = { left: 0, top: 0 };
        t2.exports = function(t3, r2, n2) {
          r2 = r2 || t3.currentTarget || t3.srcElement, Array.isArray(n2) || (n2 = [0, 0]);
          var i, a = t3.clientX || 0, o = t3.clientY || 0, s = (i = r2) === window || i === document || i === document.body ? e2 : i.getBoundingClientRect();
          return n2[0] = a - s.left, n2[1] = o - s.top, n2;
        };
      }, 74311: function(t2, e2) {
        function r2(t3) {
          return t3.target || t3.srcElement || window;
        }
        e2.buttons = function(t3) {
          if ("object" == typeof t3) {
            if ("buttons" in t3)
              return t3.buttons;
            if ("which" in t3) {
              if (2 === (e3 = t3.which))
                return 4;
              if (3 === e3)
                return 2;
              if (e3 > 0)
                return 1 << e3 - 1;
            } else if ("button" in t3) {
              var e3;
              if (1 === (e3 = t3.button))
                return 4;
              if (2 === e3)
                return 2;
              if (e3 >= 0)
                return 1 << e3;
            }
          }
          return 0;
        }, e2.element = r2, e2.x = function(t3) {
          if ("object" == typeof t3) {
            if ("offsetX" in t3)
              return t3.offsetX;
            var e3 = r2(t3).getBoundingClientRect();
            return t3.clientX - e3.left;
          }
          return 0;
        }, e2.y = function(t3) {
          if ("object" == typeof t3) {
            if ("offsetY" in t3)
              return t3.offsetY;
            var e3 = r2(t3).getBoundingClientRect();
            return t3.clientY - e3.top;
          }
          return 0;
        };
      }, 1195: function(t2, e2, r2) {
        var n2 = r2(75686);
        t2.exports = function(t3, e3, r3) {
          "function" == typeof t3 && (r3 = !!e3, e3 = t3, t3 = window);
          var i = n2("ex", t3), a = function(t4) {
            r3 && t4.preventDefault();
            var n3 = t4.deltaX || 0, a2 = t4.deltaY || 0, o = t4.deltaZ || 0, s = 1;
            switch (t4.deltaMode) {
              case 1:
                s = i;
                break;
              case 2:
                s = window.innerHeight;
            }
            if (a2 *= s, o *= s, (n3 *= s) || a2 || o)
              return e3(n3, a2, o, t4);
          };
          return t3.addEventListener("wheel", a), a;
        };
      }, 7417: function(t2, e2, r2) {
        var n2;
        !function(i, a, o) {
          a[i] = a[i] || function() {
            var t3, e3, r3, n3 = Object.prototype.toString, i2 = "undefined" != typeof setImmediate ? function(t4) {
              return setImmediate(t4);
            } : setTimeout;
            try {
              Object.defineProperty({}, "x", {}), t3 = function(t4, e4, r4, n4) {
                return Object.defineProperty(t4, e4, { value: r4, writable: true, configurable: false !== n4 });
              };
            } catch (e4) {
              t3 = function(t4, e5, r4) {
                return t4[e5] = r4, t4;
              };
            }
            function a2(t4, n4) {
              r3.add(t4, n4), e3 || (e3 = i2(r3.drain));
            }
            function o2(t4) {
              var e4, r4 = typeof t4;
              return null == t4 || "object" != r4 && "function" != r4 || (e4 = t4.then), "function" == typeof e4 && e4;
            }
            function s() {
              for (var t4 = 0; t4 < this.chain.length; t4++)
                l(this, 1 === this.state ? this.chain[t4].success : this.chain[t4].failure, this.chain[t4]);
              this.chain.length = 0;
            }
            function l(t4, e4, r4) {
              var n4, i3;
              try {
                false === e4 ? r4.reject(t4.msg) : (n4 = true === e4 ? t4.msg : e4.call(void 0, t4.msg)) === r4.promise ? r4.reject(TypeError("Promise-chain cycle")) : (i3 = o2(n4)) ? i3.call(n4, r4.resolve, r4.reject) : r4.resolve(n4);
              } catch (t5) {
                r4.reject(t5);
              }
            }
            function u(t4) {
              var e4, r4 = this;
              if (!r4.triggered) {
                r4.triggered = true, r4.def && (r4 = r4.def);
                try {
                  (e4 = o2(t4)) ? a2(function() {
                    var n4 = new h(r4);
                    try {
                      e4.call(t4, function() {
                        u.apply(n4, arguments);
                      }, function() {
                        c.apply(n4, arguments);
                      });
                    } catch (t5) {
                      c.call(n4, t5);
                    }
                  }) : (r4.msg = t4, r4.state = 1, r4.chain.length > 0 && a2(s, r4));
                } catch (t5) {
                  c.call(new h(r4), t5);
                }
              }
            }
            function c(t4) {
              var e4 = this;
              e4.triggered || (e4.triggered = true, e4.def && (e4 = e4.def), e4.msg = t4, e4.state = 2, e4.chain.length > 0 && a2(s, e4));
            }
            function f2(t4, e4, r4, n4) {
              for (var i3 = 0; i3 < e4.length; i3++)
                !function(i4) {
                  t4.resolve(e4[i4]).then(function(t5) {
                    r4(i4, t5);
                  }, n4);
                }(i3);
            }
            function h(t4) {
              this.def = t4, this.triggered = false;
            }
            function p2(t4) {
              this.promise = t4, this.state = 0, this.triggered = false, this.chain = [], this.msg = void 0;
            }
            function d2(t4) {
              if ("function" != typeof t4)
                throw TypeError("Not a function");
              if (0 !== this.__NPO__)
                throw TypeError("Not a promise");
              this.__NPO__ = 1;
              var e4 = new p2(this);
              this.then = function(t5, r4) {
                var n4 = { success: "function" != typeof t5 || t5, failure: "function" == typeof r4 && r4 };
                return n4.promise = new this.constructor(function(t6, e5) {
                  if ("function" != typeof t6 || "function" != typeof e5)
                    throw TypeError("Not a function");
                  n4.resolve = t6, n4.reject = e5;
                }), e4.chain.push(n4), 0 !== e4.state && a2(s, e4), n4.promise;
              }, this.catch = function(t5) {
                return this.then(void 0, t5);
              };
              try {
                t4.call(void 0, function(t5) {
                  u.call(e4, t5);
                }, function(t5) {
                  c.call(e4, t5);
                });
              } catch (t5) {
                c.call(e4, t5);
              }
            }
            r3 = function() {
              var t4, r4, n4;
              function i3(t5, e4) {
                this.fn = t5, this.self = e4, this.next = void 0;
              }
              return { add: function(e4, a3) {
                n4 = new i3(e4, a3), r4 ? r4.next = n4 : t4 = n4, r4 = n4, n4 = void 0;
              }, drain: function() {
                var n5 = t4;
                for (t4 = r4 = e3 = void 0; n5; )
                  n5.fn.call(n5.self), n5 = n5.next;
              } };
            }();
            var v = t3({}, "constructor", d2, false);
            return d2.prototype = v, t3(v, "__NPO__", 0, false), t3(d2, "resolve", function(t4) {
              return t4 && "object" == typeof t4 && 1 === t4.__NPO__ ? t4 : new this(function(e4, r4) {
                if ("function" != typeof e4 || "function" != typeof r4)
                  throw TypeError("Not a function");
                e4(t4);
              });
            }), t3(d2, "reject", function(t4) {
              return new this(function(e4, r4) {
                if ("function" != typeof e4 || "function" != typeof r4)
                  throw TypeError("Not a function");
                r4(t4);
              });
            }), t3(d2, "all", function(t4) {
              var e4 = this;
              return "[object Array]" != n3.call(t4) ? e4.reject(TypeError("Not an array")) : 0 === t4.length ? e4.resolve([]) : new e4(function(r4, n4) {
                if ("function" != typeof r4 || "function" != typeof n4)
                  throw TypeError("Not a function");
                var i3 = t4.length, a3 = Array(i3), o3 = 0;
                f2(e4, t4, function(t5, e5) {
                  a3[t5] = e5, ++o3 === i3 && r4(a3);
                }, n4);
              });
            }), t3(d2, "race", function(t4) {
              var e4 = this;
              return "[object Array]" != n3.call(t4) ? e4.reject(TypeError("Not an array")) : new e4(function(r4, n4) {
                if ("function" != typeof r4 || "function" != typeof n4)
                  throw TypeError("Not a function");
                f2(e4, t4, function(t5, e5) {
                  r4(e5);
                }, n4);
              });
            }), d2;
          }(), t2.exports ? t2.exports = a[i] : void 0 === (n2 = function() {
            return a[i];
          }.call(e2, r2, e2, t2)) || (t2.exports = n2);
        }("Promise", void 0 !== r2.g ? r2.g : this);
      }, 18625: function(t2) {
        var e2 = Math.PI, r2 = s(120);
        function n2(t3, e3, r3, n3) {
          return ["C", t3, e3, r3, n3, r3, n3];
        }
        function i(t3, e3, r3, n3, i2, a2) {
          return ["C", t3 / 3 + 2 / 3 * r3, e3 / 3 + 2 / 3 * n3, i2 / 3 + 2 / 3 * r3, a2 / 3 + 2 / 3 * n3, i2, a2];
        }
        function a(t3, n3, i2, s2, l, u, c, f2, h, p2) {
          if (p2)
            T = p2[0], k = p2[1], _ = p2[2], w2 = p2[3];
          else {
            var d2 = o(t3, n3, -l);
            t3 = d2.x, n3 = d2.y;
            var v = (t3 - (f2 = (d2 = o(f2, h, -l)).x)) / 2, g2 = (n3 - (h = d2.y)) / 2, y = v * v / (i2 * i2) + g2 * g2 / (s2 * s2);
            y > 1 && (i2 *= y = Math.sqrt(y), s2 *= y);
            var m2 = i2 * i2, x = s2 * s2, b = (u == c ? -1 : 1) * Math.sqrt(Math.abs((m2 * x - m2 * g2 * g2 - x * v * v) / (m2 * g2 * g2 + x * v * v)));
            b == 1 / 0 && (b = 1);
            var _ = b * i2 * g2 / s2 + (t3 + f2) / 2, w2 = b * -s2 * v / i2 + (n3 + h) / 2, T = Math.asin(((n3 - w2) / s2).toFixed(9)), k = Math.asin(((h - w2) / s2).toFixed(9));
            (T = t3 < _ ? e2 - T : T) < 0 && (T = 2 * e2 + T), (k = f2 < _ ? e2 - k : k) < 0 && (k = 2 * e2 + k), c && T > k && (T -= 2 * e2), !c && k > T && (k -= 2 * e2);
          }
          if (Math.abs(k - T) > r2) {
            var A = k, M = f2, S = h;
            k = T + r2 * (c && k > T ? 1 : -1);
            var E = a(f2 = _ + i2 * Math.cos(k), h = w2 + s2 * Math.sin(k), i2, s2, l, 0, c, M, S, [k, A, _, w2]);
          }
          var L = Math.tan((k - T) / 4), C = 4 / 3 * i2 * L, P = 4 / 3 * s2 * L, O = [2 * t3 - (t3 + C * Math.sin(T)), 2 * n3 - (n3 - P * Math.cos(T)), f2 + C * Math.sin(k), h - P * Math.cos(k), f2, h];
          if (p2)
            return O;
          E && (O = O.concat(E));
          for (var I = 0; I < O.length; ) {
            var D = o(O[I], O[I + 1], l);
            O[I++] = D.x, O[I++] = D.y;
          }
          return O;
        }
        function o(t3, e3, r3) {
          return { x: t3 * Math.cos(r3) - e3 * Math.sin(r3), y: t3 * Math.sin(r3) + e3 * Math.cos(r3) };
        }
        function s(t3) {
          return t3 * (e2 / 180);
        }
        t2.exports = function(t3) {
          for (var e3, r3 = [], o2 = 0, l = 0, u = 0, c = 0, f2 = null, h = null, p2 = 0, d2 = 0, v = 0, g2 = t3.length; v < g2; v++) {
            var y = t3[v], m2 = y[0];
            switch (m2) {
              case "M":
                u = y[1], c = y[2];
                break;
              case "A":
                (y = a(p2, d2, y[1], y[2], s(y[3]), y[4], y[5], y[6], y[7])).unshift("C"), y.length > 7 && (r3.push(y.splice(0, 7)), y.unshift("C"));
                break;
              case "S":
                var x = p2, b = d2;
                "C" != e3 && "S" != e3 || (x += x - o2, b += b - l), y = ["C", x, b, y[1], y[2], y[3], y[4]];
                break;
              case "T":
                "Q" == e3 || "T" == e3 ? (f2 = 2 * p2 - f2, h = 2 * d2 - h) : (f2 = p2, h = d2), y = i(p2, d2, f2, h, y[1], y[2]);
                break;
              case "Q":
                f2 = y[1], h = y[2], y = i(p2, d2, y[1], y[2], y[3], y[4]);
                break;
              case "L":
                y = n2(p2, d2, y[1], y[2]);
                break;
              case "H":
                y = n2(p2, d2, y[1], d2);
                break;
              case "V":
                y = n2(p2, d2, p2, y[1]);
                break;
              case "Z":
                y = n2(p2, d2, u, c);
            }
            e3 = m2, p2 = y[y.length - 2], d2 = y[y.length - 1], y.length > 4 ? (o2 = y[y.length - 4], l = y[y.length - 3]) : (o2 = p2, l = d2), r3.push(y);
          }
          return r3;
        };
      }, 56131: function(t2) {
        var e2 = Object.getOwnPropertySymbols, r2 = Object.prototype.hasOwnProperty, n2 = Object.prototype.propertyIsEnumerable;
        function i(t3) {
          if (null == t3)
            throw new TypeError("Object.assign cannot be called with null or undefined");
          return Object(t3);
        }
        t2.exports = function() {
          try {
            if (!Object.assign)
              return false;
            var t3 = new String("abc");
            if (t3[5] = "de", "5" === Object.getOwnPropertyNames(t3)[0])
              return false;
            for (var e3 = {}, r3 = 0; r3 < 10; r3++)
              e3["_" + String.fromCharCode(r3)] = r3;
            if ("0123456789" !== Object.getOwnPropertyNames(e3).map(function(t4) {
              return e3[t4];
            }).join(""))
              return false;
            var n3 = {};
            return "abcdefghijklmnopqrst".split("").forEach(function(t4) {
              n3[t4] = t4;
            }), "abcdefghijklmnopqrst" === Object.keys(Object.assign({}, n3)).join("");
          } catch (t4) {
            return false;
          }
        }() ? Object.assign : function(t3, a) {
          for (var o, s, l = i(t3), u = 1; u < arguments.length; u++) {
            for (var c in o = Object(arguments[u]))
              r2.call(o, c) && (l[c] = o[c]);
            if (e2) {
              s = e2(o);
              for (var f2 = 0; f2 < s.length; f2++)
                n2.call(o, s[f2]) && (l[s[f2]] = o[s[f2]]);
            }
          }
          return l;
        };
      }, 65848: function(t2) {
        var e2 = function(t3) {
          return t3 != t3;
        };
        t2.exports = function(t3, r2) {
          return 0 === t3 && 0 === r2 ? 1 / t3 == 1 / r2 : t3 === r2 || !(!e2(t3) || !e2(r2));
        };
      }, 64003: function(t2, e2, r2) {
        var n2 = r2(17045), i = r2(68222), a = r2(65848), o = r2(27015), s = r2(55572), l = i(o(), Object);
        n2(l, { getPolyfill: o, implementation: a, shim: s }), t2.exports = l;
      }, 27015: function(t2, e2, r2) {
        var n2 = r2(65848);
        t2.exports = function() {
          return "function" == typeof Object.is ? Object.is : n2;
        };
      }, 55572: function(t2, e2, r2) {
        var n2 = r2(27015), i = r2(17045);
        t2.exports = function() {
          var t3 = n2();
          return i(Object, { is: t3 }, { is: function() {
            return Object.is !== t3;
          } }), t3;
        };
      }, 99019: function(t2, e2, r2) {
        var n2;
        if (!Object.keys) {
          var i = Object.prototype.hasOwnProperty, a = Object.prototype.toString, o = r2(64178), s = Object.prototype.propertyIsEnumerable, l = !s.call({ toString: null }, "toString"), u = s.call(function() {
          }, "prototype"), c = ["toString", "toLocaleString", "valueOf", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "constructor"], f2 = function(t3) {
            var e3 = t3.constructor;
            return e3 && e3.prototype === t3;
          }, h = { $applicationCache: true, $console: true, $external: true, $frame: true, $frameElement: true, $frames: true, $innerHeight: true, $innerWidth: true, $onmozfullscreenchange: true, $onmozfullscreenerror: true, $outerHeight: true, $outerWidth: true, $pageXOffset: true, $pageYOffset: true, $parent: true, $scrollLeft: true, $scrollTop: true, $scrollX: true, $scrollY: true, $self: true, $webkitIndexedDB: true, $webkitStorageInfo: true, $window: true }, p2 = function() {
            if ("undefined" == typeof window)
              return false;
            for (var t3 in window)
              try {
                if (!h["$" + t3] && i.call(window, t3) && null !== window[t3] && "object" == typeof window[t3])
                  try {
                    f2(window[t3]);
                  } catch (t4) {
                    return true;
                  }
              } catch (t4) {
                return true;
              }
            return false;
          }();
          n2 = function(t3) {
            var e3 = null !== t3 && "object" == typeof t3, r3 = "[object Function]" === a.call(t3), n3 = o(t3), s2 = e3 && "[object String]" === a.call(t3), h2 = [];
            if (!e3 && !r3 && !n3)
              throw new TypeError("Object.keys called on a non-object");
            var d2 = u && r3;
            if (s2 && t3.length > 0 && !i.call(t3, 0))
              for (var v = 0; v < t3.length; ++v)
                h2.push(String(v));
            if (n3 && t3.length > 0)
              for (var g2 = 0; g2 < t3.length; ++g2)
                h2.push(String(g2));
            else
              for (var y in t3)
                d2 && "prototype" === y || !i.call(t3, y) || h2.push(String(y));
            if (l)
              for (var m2 = function(t4) {
                if ("undefined" == typeof window || !p2)
                  return f2(t4);
                try {
                  return f2(t4);
                } catch (t5) {
                  return false;
                }
              }(t3), x = 0; x < c.length; ++x)
                m2 && "constructor" === c[x] || !i.call(t3, c[x]) || h2.push(c[x]);
            return h2;
          };
        }
        t2.exports = n2;
      }, 8709: function(t2, e2, r2) {
        var n2 = Array.prototype.slice, i = r2(64178), a = Object.keys, o = a ? function(t3) {
          return a(t3);
        } : r2(99019), s = Object.keys;
        o.shim = function() {
          if (Object.keys) {
            var t3 = function() {
              var t4 = Object.keys(arguments);
              return t4 && t4.length === arguments.length;
            }(1, 2);
            t3 || (Object.keys = function(t4) {
              return i(t4) ? s(n2.call(t4)) : s(t4);
            });
          } else
            Object.keys = o;
          return Object.keys || o;
        }, t2.exports = o;
      }, 64178: function(t2) {
        var e2 = Object.prototype.toString;
        t2.exports = function(t3) {
          var r2 = e2.call(t3), n2 = "[object Arguments]" === r2;
          return n2 || (n2 = "[object Array]" !== r2 && null !== t3 && "object" == typeof t3 && "number" == typeof t3.length && t3.length >= 0 && "[object Function]" === e2.call(t3.callee)), n2;
        };
      }, 88641: function(t2) {
        function e2(t3, e3) {
          if ("string" != typeof t3)
            return [t3];
          var r3 = [t3];
          "string" == typeof e3 || Array.isArray(e3) ? e3 = { brackets: e3 } : e3 || (e3 = {});
          var n3 = e3.brackets ? Array.isArray(e3.brackets) ? e3.brackets : [e3.brackets] : ["{}", "[]", "()"], i = e3.escape || "___", a = !!e3.flat;
          n3.forEach(function(t4) {
            var e4 = new RegExp(["\\", t4[0], "[^\\", t4[0], "\\", t4[1], "]*\\", t4[1]].join("")), n4 = [];
            function a2(e5, a3, o2) {
              var s = r3.push(e5.slice(t4[0].length, -t4[1].length)) - 1;
              return n4.push(s), i + s + i;
            }
            r3.forEach(function(t5, n5) {
              for (var i2, o2 = 0; t5 != i2; )
                if (i2 = t5, t5 = t5.replace(e4, a2), o2++ > 1e4)
                  throw Error("References have circular dependency. Please, check them.");
              r3[n5] = t5;
            }), n4 = n4.reverse(), r3 = r3.map(function(e5) {
              return n4.forEach(function(r4) {
                e5 = e5.replace(new RegExp("(\\" + i + r4 + "\\" + i + ")", "g"), t4[0] + "$1" + t4[1]);
              }), e5;
            });
          });
          var o = new RegExp("\\" + i + "([0-9]+)\\" + i);
          return a ? r3 : function t4(e4, r4, n4) {
            for (var i2, a2 = [], s = 0; i2 = o.exec(e4); ) {
              if (s++ > 1e4)
                throw Error("Circular references in parenthesis");
              a2.push(e4.slice(0, i2.index)), a2.push(t4(r4[i2[1]], r4)), e4 = e4.slice(i2.index + i2[0].length);
            }
            return a2.push(e4), a2;
          }(r3[0], r3);
        }
        function r2(t3, e3) {
          if (e3 && e3.flat) {
            var r3, n3 = e3 && e3.escape || "___", i = t3[0];
            if (!i)
              return "";
            for (var a = new RegExp("\\" + n3 + "([0-9]+)\\" + n3), o = 0; i != r3; ) {
              if (o++ > 1e4)
                throw Error("Circular references in " + t3);
              r3 = i, i = i.replace(a, s);
            }
            return i;
          }
          return t3.reduce(function t4(e4, r4) {
            return Array.isArray(r4) && (r4 = r4.reduce(t4, "")), e4 + r4;
          }, "");
          function s(e4, r4) {
            if (null == t3[r4])
              throw Error("Reference " + r4 + "is undefined");
            return t3[r4];
          }
        }
        function n2(t3, n3) {
          return Array.isArray(t3) ? r2(t3, n3) : e2(t3, n3);
        }
        n2.parse = e2, n2.stringify = r2, t2.exports = n2;
      }, 18863: function(t2, e2, r2) {
        var n2 = r2(71299);
        t2.exports = function(t3) {
          var e3;
          return arguments.length > 1 && (t3 = arguments), "string" == typeof t3 ? t3 = t3.split(/\s/).map(parseFloat) : "number" == typeof t3 && (t3 = [t3]), t3.length && "number" == typeof t3[0] ? e3 = 1 === t3.length ? { width: t3[0], height: t3[0], x: 0, y: 0 } : 2 === t3.length ? { width: t3[0], height: t3[1], x: 0, y: 0 } : { x: t3[0], y: t3[1], width: t3[2] - t3[0] || 0, height: t3[3] - t3[1] || 0 } : t3 && (e3 = { x: (t3 = n2(t3, { left: "x l left Left", top: "y t top Top", width: "w width W Width", height: "h height W Width", bottom: "b bottom Bottom", right: "r right Right" })).left || 0, y: t3.top || 0 }, null == t3.width ? t3.right ? e3.width = t3.right - e3.x : e3.width = 0 : e3.width = t3.width, null == t3.height ? t3.bottom ? e3.height = t3.bottom - e3.y : e3.height = 0 : e3.height = t3.height), e3;
        };
      }, 95616: function(t2) {
        t2.exports = function(t3) {
          var i = [];
          return t3.replace(r2, function(t4, r3, a) {
            var o = r3.toLowerCase();
            for (a = function(t5) {
              var e3 = t5.match(n2);
              return e3 ? e3.map(Number) : [];
            }(a), "m" == o && a.length > 2 && (i.push([r3].concat(a.splice(0, 2))), o = "l", r3 = "m" == r3 ? "l" : "L"); ; ) {
              if (a.length == e2[o])
                return a.unshift(r3), i.push(a);
              if (a.length < e2[o])
                throw new Error("malformed path data");
              i.push([r3].concat(a.splice(0, e2[o])));
            }
          }), i;
        };
        var e2 = { a: 7, c: 6, h: 1, l: 2, m: 2, q: 4, s: 4, t: 2, v: 1, z: 0 }, r2 = /([astvzqmhlc])([^astvzqmhlc]*)/gi, n2 = /-?[0-9]*\.?[0-9]+(?:e[-+]?\d+)?/gi;
      }, 25677: function(t2) {
        t2.exports = function(t3, e2) {
          e2 || (e2 = [0, ""]), t3 = String(t3);
          var r2 = parseFloat(t3, 10);
          return e2[0] = r2, e2[1] = t3.match(/[\d.\-\+]*\s*(.*)/)[1] || "", e2;
        };
      }, 9748: function(t2, e2, r2) {
        var n2 = r2(90386);
        (function() {
          var e3, r3, i, a, o, s;
          "undefined" != typeof performance && null !== performance && performance.now ? t2.exports = function() {
            return performance.now();
          } : null != n2 && n2.hrtime ? (t2.exports = function() {
            return (e3() - o) / 1e6;
          }, r3 = n2.hrtime, a = (e3 = function() {
            var t3;
            return 1e9 * (t3 = r3())[0] + t3[1];
          })(), s = 1e9 * n2.uptime(), o = a - s) : Date.now ? (t2.exports = function() {
            return Date.now() - i;
          }, i = Date.now()) : (t2.exports = function() {
            return new Date().getTime() - i;
          }, i = new Date().getTime());
        }).call(this);
      }, 71299: function(t2) {
        t2.exports = function(t3, e3, n2) {
          var i, a, o = {};
          if ("string" == typeof e3 && (e3 = r2(e3)), Array.isArray(e3)) {
            var s = {};
            for (a = 0; a < e3.length; a++)
              s[e3[a]] = true;
            e3 = s;
          }
          for (i in e3)
            e3[i] = r2(e3[i]);
          var l = {};
          for (i in e3) {
            var u = e3[i];
            if (Array.isArray(u))
              for (a = 0; a < u.length; a++) {
                var c = u[a];
                if (n2 && (l[c] = true), c in t3) {
                  if (o[i] = t3[c], n2)
                    for (var f2 = a; f2 < u.length; f2++)
                      l[u[f2]] = true;
                  break;
                }
              }
            else
              i in t3 && (e3[i] && (o[i] = t3[i]), n2 && (l[i] = true));
          }
          if (n2)
            for (i in t3)
              l[i] || (o[i] = t3[i]);
          return o;
        };
        var e2 = {};
        function r2(t3) {
          return e2[t3] ? e2[t3] : ("string" == typeof t3 && (t3 = e2[t3] = t3.split(/\s*,\s*|\s+/)), t3);
        }
      }, 38258: function(t2) {
        t2.exports = function(t3, e2, r2, n2) {
          var i = t3[0], a = t3[1], o = false;
          void 0 === r2 && (r2 = 0), void 0 === n2 && (n2 = e2.length);
          for (var s = n2 - r2, l = 0, u = s - 1; l < s; u = l++) {
            var c = e2[l + r2][0], f2 = e2[l + r2][1], h = e2[u + r2][0], p2 = e2[u + r2][1];
            f2 > a != p2 > a && i < (h - c) * (a - f2) / (p2 - f2) + c && (o = !o);
          }
          return o;
        };
      }, 52142: function(t2, e2, r2) {
        var n2, i = r2(69444), a = r2(29023), o = r2(87263), s = r2(11328), l = r2(55968), u = r2(10670), c = false, f2 = a();
        function h(t3, e3, r3) {
          var i2 = n2.segments(t3), a2 = n2.segments(e3), o2 = r3(n2.combine(i2, a2));
          return n2.polygon(o2);
        }
        n2 = { buildLog: function(t3) {
          return true === t3 ? c = i() : false === t3 && (c = false), false !== c && c.list;
        }, epsilon: function(t3) {
          return f2.epsilon(t3);
        }, segments: function(t3) {
          var e3 = o(true, f2, c);
          return t3.regions.forEach(e3.addRegion), { segments: e3.calculate(t3.inverted), inverted: t3.inverted };
        }, combine: function(t3, e3) {
          return { combined: o(false, f2, c).calculate(t3.segments, t3.inverted, e3.segments, e3.inverted), inverted1: t3.inverted, inverted2: e3.inverted };
        }, selectUnion: function(t3) {
          return { segments: l.union(t3.combined, c), inverted: t3.inverted1 || t3.inverted2 };
        }, selectIntersect: function(t3) {
          return { segments: l.intersect(t3.combined, c), inverted: t3.inverted1 && t3.inverted2 };
        }, selectDifference: function(t3) {
          return { segments: l.difference(t3.combined, c), inverted: t3.inverted1 && !t3.inverted2 };
        }, selectDifferenceRev: function(t3) {
          return { segments: l.differenceRev(t3.combined, c), inverted: !t3.inverted1 && t3.inverted2 };
        }, selectXor: function(t3) {
          return { segments: l.xor(t3.combined, c), inverted: t3.inverted1 !== t3.inverted2 };
        }, polygon: function(t3) {
          return { regions: s(t3.segments, f2, c), inverted: t3.inverted };
        }, polygonFromGeoJSON: function(t3) {
          return u.toPolygon(n2, t3);
        }, polygonToGeoJSON: function(t3) {
          return u.fromPolygon(n2, f2, t3);
        }, union: function(t3, e3) {
          return h(t3, e3, n2.selectUnion);
        }, intersect: function(t3, e3) {
          return h(t3, e3, n2.selectIntersect);
        }, difference: function(t3, e3) {
          return h(t3, e3, n2.selectDifference);
        }, differenceRev: function(t3, e3) {
          return h(t3, e3, n2.selectDifferenceRev);
        }, xor: function(t3, e3) {
          return h(t3, e3, n2.selectXor);
        } }, "object" == typeof window && (window.PolyBool = n2), t2.exports = n2;
      }, 69444: function(t2) {
        t2.exports = function() {
          var t3, e2 = 0, r2 = false;
          function n2(e3, r3) {
            return t3.list.push({ type: e3, data: r3 ? JSON.parse(JSON.stringify(r3)) : void 0 }), t3;
          }
          return t3 = { list: [], segmentId: function() {
            return e2++;
          }, checkIntersection: function(t4, e3) {
            return n2("check", { seg1: t4, seg2: e3 });
          }, segmentChop: function(t4, e3) {
            return n2("div_seg", { seg: t4, pt: e3 }), n2("chop", { seg: t4, pt: e3 });
          }, statusRemove: function(t4) {
            return n2("pop_seg", { seg: t4 });
          }, segmentUpdate: function(t4) {
            return n2("seg_update", { seg: t4 });
          }, segmentNew: function(t4, e3) {
            return n2("new_seg", { seg: t4, primary: e3 });
          }, segmentRemove: function(t4) {
            return n2("rem_seg", { seg: t4 });
          }, tempStatus: function(t4, e3, r3) {
            return n2("temp_status", { seg: t4, above: e3, below: r3 });
          }, rewind: function(t4) {
            return n2("rewind", { seg: t4 });
          }, status: function(t4, e3, r3) {
            return n2("status", { seg: t4, above: e3, below: r3 });
          }, vert: function(e3) {
            return e3 === r2 ? t3 : (r2 = e3, n2("vert", { x: e3 }));
          }, log: function(t4) {
            return "string" != typeof t4 && (t4 = JSON.stringify(t4, false, "  ")), n2("log", { txt: t4 });
          }, reset: function() {
            return n2("reset");
          }, selected: function(t4) {
            return n2("selected", { segs: t4 });
          }, chainStart: function(t4) {
            return n2("chain_start", { seg: t4 });
          }, chainRemoveHead: function(t4, e3) {
            return n2("chain_rem_head", { index: t4, pt: e3 });
          }, chainRemoveTail: function(t4, e3) {
            return n2("chain_rem_tail", { index: t4, pt: e3 });
          }, chainNew: function(t4, e3) {
            return n2("chain_new", { pt1: t4, pt2: e3 });
          }, chainMatch: function(t4) {
            return n2("chain_match", { index: t4 });
          }, chainClose: function(t4) {
            return n2("chain_close", { index: t4 });
          }, chainAddHead: function(t4, e3) {
            return n2("chain_add_head", { index: t4, pt: e3 });
          }, chainAddTail: function(t4, e3) {
            return n2("chain_add_tail", { index: t4, pt: e3 });
          }, chainConnect: function(t4, e3) {
            return n2("chain_con", { index1: t4, index2: e3 });
          }, chainReverse: function(t4) {
            return n2("chain_rev", { index: t4 });
          }, chainJoin: function(t4, e3) {
            return n2("chain_join", { index1: t4, index2: e3 });
          }, done: function() {
            return n2("done");
          } };
        };
      }, 29023: function(t2) {
        t2.exports = function(t3) {
          "number" != typeof t3 && (t3 = 1e-10);
          var e2 = { epsilon: function(e3) {
            return "number" == typeof e3 && (t3 = e3), t3;
          }, pointAboveOrOnLine: function(e3, r2, n2) {
            var i = r2[0], a = r2[1], o = n2[0], s = n2[1], l = e3[0];
            return (o - i) * (e3[1] - a) - (s - a) * (l - i) >= -t3;
          }, pointBetween: function(e3, r2, n2) {
            var i = e3[1] - r2[1], a = n2[0] - r2[0], o = e3[0] - r2[0], s = n2[1] - r2[1], l = o * a + i * s;
            return !(l < t3 || l - (a * a + s * s) > -t3);
          }, pointsSameX: function(e3, r2) {
            return Math.abs(e3[0] - r2[0]) < t3;
          }, pointsSameY: function(e3, r2) {
            return Math.abs(e3[1] - r2[1]) < t3;
          }, pointsSame: function(t4, r2) {
            return e2.pointsSameX(t4, r2) && e2.pointsSameY(t4, r2);
          }, pointsCompare: function(t4, r2) {
            return e2.pointsSameX(t4, r2) ? e2.pointsSameY(t4, r2) ? 0 : t4[1] < r2[1] ? -1 : 1 : t4[0] < r2[0] ? -1 : 1;
          }, pointsCollinear: function(e3, r2, n2) {
            var i = e3[0] - r2[0], a = e3[1] - r2[1], o = r2[0] - n2[0], s = r2[1] - n2[1];
            return Math.abs(i * s - o * a) < t3;
          }, linesIntersect: function(e3, r2, n2, i) {
            var a = r2[0] - e3[0], o = r2[1] - e3[1], s = i[0] - n2[0], l = i[1] - n2[1], u = a * l - o * s;
            if (Math.abs(u) < t3)
              return false;
            var c = e3[0] - n2[0], f2 = e3[1] - n2[1], h = (s * f2 - l * c) / u, p2 = (a * f2 - o * c) / u, d2 = { alongA: 0, alongB: 0, pt: [e3[0] + h * a, e3[1] + h * o] };
            return d2.alongA = h <= -t3 ? -2 : h < t3 ? -1 : h - 1 <= -t3 ? 0 : h - 1 < t3 ? 1 : 2, d2.alongB = p2 <= -t3 ? -2 : p2 < t3 ? -1 : p2 - 1 <= -t3 ? 0 : p2 - 1 < t3 ? 1 : 2, d2;
          }, pointInsideRegion: function(e3, r2) {
            for (var n2 = e3[0], i = e3[1], a = r2[r2.length - 1][0], o = r2[r2.length - 1][1], s = false, l = 0; l < r2.length; l++) {
              var u = r2[l][0], c = r2[l][1];
              c - i > t3 != o - i > t3 && (a - u) * (i - c) / (o - c) + u - n2 > t3 && (s = !s), a = u, o = c;
            }
            return s;
          } };
          return e2;
        };
      }, 10670: function(t2) {
        var e2 = { toPolygon: function(t3, e3) {
          function r2(e4) {
            if (e4.length <= 0)
              return t3.segments({ inverted: false, regions: [] });
            function r3(e5) {
              var r4 = e5.slice(0, e5.length - 1);
              return t3.segments({ inverted: false, regions: [r4] });
            }
            for (var n3 = r3(e4[0]), i2 = 1; i2 < e4.length; i2++)
              n3 = t3.selectDifference(t3.combine(n3, r3(e4[i2])));
            return n3;
          }
          if ("Polygon" === e3.type)
            return t3.polygon(r2(e3.coordinates));
          if ("MultiPolygon" === e3.type) {
            for (var n2 = t3.segments({ inverted: false, regions: [] }), i = 0; i < e3.coordinates.length; i++)
              n2 = t3.selectUnion(t3.combine(n2, r2(e3.coordinates[i])));
            return t3.polygon(n2);
          }
          throw new Error("PolyBool: Cannot convert GeoJSON object to PolyBool polygon");
        }, fromPolygon: function(t3, e3, r2) {
          function n2(t4, r3) {
            return e3.pointInsideRegion([0.5 * (t4[0][0] + t4[1][0]), 0.5 * (t4[0][1] + t4[1][1])], r3);
          }
          function i(t4) {
            return { region: t4, children: [] };
          }
          r2 = t3.polygon(t3.segments(r2));
          var a = i(null);
          function o(t4, e4) {
            for (var r3 = 0; r3 < t4.children.length; r3++)
              if (n2(e4, (s2 = t4.children[r3]).region))
                return void o(s2, e4);
            var a2 = i(e4);
            for (r3 = 0; r3 < t4.children.length; r3++) {
              var s2;
              n2((s2 = t4.children[r3]).region, e4) && (a2.children.push(s2), t4.children.splice(r3, 1), r3--);
            }
            t4.children.push(a2);
          }
          for (var s = 0; s < r2.regions.length; s++) {
            var l = r2.regions[s];
            l.length < 3 || o(a, l);
          }
          function u(t4, e4) {
            for (var r3 = 0, n3 = t4[t4.length - 1][0], i2 = t4[t4.length - 1][1], a2 = [], o2 = 0; o2 < t4.length; o2++) {
              var s2 = t4[o2][0], l2 = t4[o2][1];
              a2.push([s2, l2]), r3 += l2 * n3 - s2 * i2, n3 = s2, i2 = l2;
            }
            return r3 < 0 !== e4 && a2.reverse(), a2.push([a2[0][0], a2[0][1]]), a2;
          }
          var c = [];
          function f2(t4) {
            var e4 = [u(t4.region, false)];
            c.push(e4);
            for (var r3 = 0; r3 < t4.children.length; r3++)
              e4.push(h(t4.children[r3]));
          }
          function h(t4) {
            for (var e4 = 0; e4 < t4.children.length; e4++)
              f2(t4.children[e4]);
            return u(t4.region, true);
          }
          for (s = 0; s < a.children.length; s++)
            f2(a.children[s]);
          return c.length <= 0 ? { type: "Polygon", coordinates: [] } : 1 == c.length ? { type: "Polygon", coordinates: c[0] } : { type: "MultiPolygon", coordinates: c };
        } };
        t2.exports = e2;
      }, 87263: function(t2, e2, r2) {
        var n2 = r2(26859);
        t2.exports = function(t3, e3, r3) {
          function i(t4, e4, n3) {
            return { id: r3 ? r3.segmentId() : -1, start: t4, end: e4, myFill: { above: n3.myFill.above, below: n3.myFill.below }, otherFill: null };
          }
          var a = n2.create();
          function o(t4, r4) {
            a.insertBefore(t4, function(n3) {
              return i2 = t4.isStart, a2 = t4.pt, o2 = r4, s2 = n3.isStart, l2 = n3.pt, u2 = n3.other.pt, (0 !== (c = e3.pointsCompare(a2, l2)) ? c : e3.pointsSame(o2, u2) ? 0 : i2 !== s2 ? i2 ? 1 : -1 : e3.pointAboveOrOnLine(o2, s2 ? l2 : u2, s2 ? u2 : l2) ? 1 : -1) < 0;
              var i2, a2, o2, s2, l2, u2, c;
            });
          }
          function s(t4, e4) {
            var r4 = function(t5, e5) {
              var r5 = n2.node({ isStart: true, pt: t5.start, seg: t5, primary: e5, other: null, status: null });
              return o(r5, t5.end), r5;
            }(t4, e4);
            return function(t5, e5, r5) {
              var i2 = n2.node({ isStart: false, pt: e5.end, seg: e5, primary: r5, other: t5, status: null });
              t5.other = i2, o(i2, t5.pt);
            }(r4, t4, e4), r4;
          }
          function l(t4, e4) {
            var n3 = i(e4, t4.seg.end, t4.seg);
            return function(t5, e5) {
              r3 && r3.segmentChop(t5.seg, e5), t5.other.remove(), t5.seg.end = e5, t5.other.pt = e5, o(t5.other, t5.pt);
            }(t4, e4), s(n3, t4.primary);
          }
          function u(i2, o2) {
            var s2 = n2.create();
            function u2(t4) {
              return s2.findTransition(function(r4) {
                var n3, i3, a2, o3, s3, l2;
                return n3 = t4, i3 = r4.ev, a2 = n3.seg.start, o3 = n3.seg.end, s3 = i3.seg.start, l2 = i3.seg.end, (e3.pointsCollinear(a2, s3, l2) ? e3.pointsCollinear(o3, s3, l2) || e3.pointAboveOrOnLine(o3, s3, l2) ? 1 : -1 : e3.pointAboveOrOnLine(a2, s3, l2) ? 1 : -1) > 0;
              });
            }
            function c(t4, n3) {
              var i3 = t4.seg, a2 = n3.seg, o3 = i3.start, s3 = i3.end, u3 = a2.start, c2 = a2.end;
              r3 && r3.checkIntersection(i3, a2);
              var f3 = e3.linesIntersect(o3, s3, u3, c2);
              if (false === f3) {
                if (!e3.pointsCollinear(o3, s3, u3))
                  return false;
                if (e3.pointsSame(o3, c2) || e3.pointsSame(s3, u3))
                  return false;
                var h2 = e3.pointsSame(o3, u3), p3 = e3.pointsSame(s3, c2);
                if (h2 && p3)
                  return n3;
                var d3 = !h2 && e3.pointBetween(o3, u3, c2), v2 = !p3 && e3.pointBetween(s3, u3, c2);
                if (h2)
                  return v2 ? l(n3, s3) : l(t4, c2), n3;
                d3 && (p3 || (v2 ? l(n3, s3) : l(t4, c2)), l(n3, o3));
              } else
                0 === f3.alongA && (-1 === f3.alongB ? l(t4, u3) : 0 === f3.alongB ? l(t4, f3.pt) : 1 === f3.alongB && l(t4, c2)), 0 === f3.alongB && (-1 === f3.alongA ? l(n3, o3) : 0 === f3.alongA ? l(n3, f3.pt) : 1 === f3.alongA && l(n3, s3));
              return false;
            }
            for (var f2 = []; !a.isEmpty(); ) {
              var h = a.getHead();
              if (r3 && r3.vert(h.pt[0]), h.isStart) {
                let g2 = function() {
                  if (d2) {
                    var t4 = c(h, d2);
                    if (t4)
                      return t4;
                  }
                  return !!v && c(h, v);
                };
                r3 && r3.segmentNew(h.seg, h.primary);
                var p2 = u2(h), d2 = p2.before ? p2.before.ev : null, v = p2.after ? p2.after.ev : null;
                r3 && r3.tempStatus(h.seg, !!d2 && d2.seg, !!v && v.seg);
                var y, m2, x = g2();
                if (x)
                  t3 ? (m2 = null === h.seg.myFill.below || h.seg.myFill.above !== h.seg.myFill.below) && (x.seg.myFill.above = !x.seg.myFill.above) : x.seg.otherFill = h.seg.myFill, r3 && r3.segmentUpdate(x.seg), h.other.remove(), h.remove();
                if (a.getHead() !== h) {
                  r3 && r3.rewind(h.seg);
                  continue;
                }
                t3 ? (m2 = null === h.seg.myFill.below || h.seg.myFill.above !== h.seg.myFill.below, h.seg.myFill.below = v ? v.seg.myFill.above : i2, h.seg.myFill.above = m2 ? !h.seg.myFill.below : h.seg.myFill.below) : null === h.seg.otherFill && (y = v ? h.primary === v.primary ? v.seg.otherFill.above : v.seg.myFill.above : h.primary ? o2 : i2, h.seg.otherFill = { above: y, below: y }), r3 && r3.status(h.seg, !!d2 && d2.seg, !!v && v.seg), h.other.status = p2.insert(n2.node({ ev: h }));
              } else {
                var b = h.status;
                if (null === b)
                  throw new Error("PolyBool: Zero-length segment detected; your epsilon is probably too small or too large");
                if (s2.exists(b.prev) && s2.exists(b.next) && c(b.prev.ev, b.next.ev), r3 && r3.statusRemove(b.ev.seg), b.remove(), !h.primary) {
                  var _ = h.seg.myFill;
                  h.seg.myFill = h.seg.otherFill, h.seg.otherFill = _;
                }
                f2.push(h.seg);
              }
              a.getHead().remove();
            }
            return r3 && r3.done(), f2;
          }
          return t3 ? { addRegion: function(t4) {
            for (var n3, i2, a2, o2 = t4[t4.length - 1], l2 = 0; l2 < t4.length; l2++) {
              n3 = o2, o2 = t4[l2];
              var u2 = e3.pointsCompare(n3, o2);
              0 !== u2 && s((i2 = u2 < 0 ? n3 : o2, a2 = u2 < 0 ? o2 : n3, { id: r3 ? r3.segmentId() : -1, start: i2, end: a2, myFill: { above: null, below: null }, otherFill: null }), true);
            }
          }, calculate: function(t4) {
            return u(t4, false);
          } } : { calculate: function(t4, e4, r4, n3) {
            return t4.forEach(function(t5) {
              s(i(t5.start, t5.end, t5), true);
            }), r4.forEach(function(t5) {
              s(i(t5.start, t5.end, t5), false);
            }), u(e4, n3);
          } };
        };
      }, 26859: function(t2) {
        t2.exports = { create: function() {
          var t3 = { root: { root: true, next: null }, exists: function(e2) {
            return null !== e2 && e2 !== t3.root;
          }, isEmpty: function() {
            return null === t3.root.next;
          }, getHead: function() {
            return t3.root.next;
          }, insertBefore: function(e2, r2) {
            for (var n2 = t3.root, i = t3.root.next; null !== i; ) {
              if (r2(i))
                return e2.prev = i.prev, e2.next = i, i.prev.next = e2, void (i.prev = e2);
              n2 = i, i = i.next;
            }
            n2.next = e2, e2.prev = n2, e2.next = null;
          }, findTransition: function(e2) {
            for (var r2 = t3.root, n2 = t3.root.next; null !== n2 && !e2(n2); )
              r2 = n2, n2 = n2.next;
            return { before: r2 === t3.root ? null : r2, after: n2, insert: function(t4) {
              return t4.prev = r2, t4.next = n2, r2.next = t4, null !== n2 && (n2.prev = t4), t4;
            } };
          } };
          return t3;
        }, node: function(t3) {
          return t3.prev = null, t3.next = null, t3.remove = function() {
            t3.prev.next = t3.next, t3.next && (t3.next.prev = t3.prev), t3.prev = null, t3.next = null;
          }, t3;
        } };
      }, 11328: function(t2) {
        t2.exports = function(t3, e2, r2) {
          var n2 = [], i = [];
          return t3.forEach(function(t4) {
            var a = t4.start, o = t4.end;
            if (e2.pointsSame(a, o))
              console.warn("PolyBool: Warning: Zero-length segment detected; your epsilon is probably too small or too large");
            else {
              r2 && r2.chainStart(t4);
              for (var s = { index: 0, matches_head: false, matches_pt1: false }, l = { index: 0, matches_head: false, matches_pt1: false }, u = s, c = 0; c < n2.length; c++) {
                var f2 = (g2 = n2[c])[0], h = (g2[1], g2[g2.length - 1]);
                if (g2[g2.length - 2], e2.pointsSame(f2, a)) {
                  if (k(c, true, true))
                    break;
                } else if (e2.pointsSame(f2, o)) {
                  if (k(c, true, false))
                    break;
                } else if (e2.pointsSame(h, a)) {
                  if (k(c, false, true))
                    break;
                } else if (e2.pointsSame(h, o) && k(c, false, false))
                  break;
              }
              if (u === s)
                return n2.push([a, o]), void (r2 && r2.chainNew(a, o));
              if (u === l) {
                r2 && r2.chainMatch(s.index);
                var p2 = s.index, d2 = s.matches_pt1 ? o : a, v = s.matches_head, g2 = n2[p2], y = v ? g2[0] : g2[g2.length - 1], m2 = v ? g2[1] : g2[g2.length - 2], x = v ? g2[g2.length - 1] : g2[0], b = v ? g2[g2.length - 2] : g2[1];
                return e2.pointsCollinear(m2, y, d2) && (v ? (r2 && r2.chainRemoveHead(s.index, d2), g2.shift()) : (r2 && r2.chainRemoveTail(s.index, d2), g2.pop()), y = m2), e2.pointsSame(x, d2) ? (n2.splice(p2, 1), e2.pointsCollinear(b, x, y) && (v ? (r2 && r2.chainRemoveTail(s.index, y), g2.pop()) : (r2 && r2.chainRemoveHead(s.index, y), g2.shift())), r2 && r2.chainClose(s.index), void i.push(g2)) : void (v ? (r2 && r2.chainAddHead(s.index, d2), g2.unshift(d2)) : (r2 && r2.chainAddTail(s.index, d2), g2.push(d2)));
              }
              var _ = s.index, w2 = l.index;
              r2 && r2.chainConnect(_, w2);
              var T = n2[_].length < n2[w2].length;
              s.matches_head ? l.matches_head ? T ? (A(_), M(_, w2)) : (A(w2), M(w2, _)) : M(w2, _) : l.matches_head ? M(_, w2) : T ? (A(_), M(w2, _)) : (A(w2), M(_, w2));
            }
            function k(t5, e3, r3) {
              return u.index = t5, u.matches_head = e3, u.matches_pt1 = r3, u === s ? (u = l, false) : (u = null, true);
            }
            function A(t5) {
              r2 && r2.chainReverse(t5), n2[t5].reverse();
            }
            function M(t5, i2) {
              var a2 = n2[t5], o2 = n2[i2], s2 = a2[a2.length - 1], l2 = a2[a2.length - 2], u2 = o2[0], c2 = o2[1];
              e2.pointsCollinear(l2, s2, u2) && (r2 && r2.chainRemoveTail(t5, s2), a2.pop(), s2 = l2), e2.pointsCollinear(s2, u2, c2) && (r2 && r2.chainRemoveHead(i2, u2), o2.shift()), r2 && r2.chainJoin(t5, i2), n2[t5] = a2.concat(o2), n2.splice(i2, 1);
            }
          }), i;
        };
      }, 55968: function(t2) {
        function e2(t3, e3, r3) {
          var n2 = [];
          return t3.forEach(function(t4) {
            var i = (t4.myFill.above ? 8 : 0) + (t4.myFill.below ? 4 : 0) + (t4.otherFill && t4.otherFill.above ? 2 : 0) + (t4.otherFill && t4.otherFill.below ? 1 : 0);
            0 !== e3[i] && n2.push({ id: r3 ? r3.segmentId() : -1, start: t4.start, end: t4.end, myFill: { above: 1 === e3[i], below: 2 === e3[i] }, otherFill: null });
          }), r3 && r3.selected(n2), n2;
        }
        var r2 = { union: function(t3, r3) {
          return e2(t3, [0, 2, 1, 0, 2, 2, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0], r3);
        }, intersect: function(t3, r3) {
          return e2(t3, [0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 1, 1, 0, 2, 1, 0], r3);
        }, difference: function(t3, r3) {
          return e2(t3, [0, 0, 0, 0, 2, 0, 2, 0, 1, 1, 0, 0, 0, 1, 2, 0], r3);
        }, differenceRev: function(t3, r3) {
          return e2(t3, [0, 2, 1, 0, 0, 0, 1, 1, 0, 2, 0, 2, 0, 0, 0, 0], r3);
        }, xor: function(t3, r3) {
          return e2(t3, [0, 2, 1, 0, 2, 0, 0, 1, 1, 0, 0, 2, 0, 1, 2, 0], r3);
        } };
        t2.exports = r2;
      }, 14847: function(t2, e2, r2) {
        var n2 = r2(21630).Transform, i = r2(90715);
        function a() {
          n2.call(this, { readableObjectMode: true });
        }
        function o(t3, e3, r3) {
          Error.call(this), Error.captureStackTrace ? Error.captureStackTrace(this, this.constructor) : this.stack = new Error().stack || "", this.name = this.constructor.name, this.message = t3, e3 && (this.code = e3), r3 && (this.statusCode = r3);
        }
        a.prototype = Object.create(n2.prototype), a.prototype.constructor = a, i(a.prototype), e2.OF = function(t3, e3, r3) {
          for (var n3 = e3, i2 = 0; i2 < r3.length; )
            if (t3[n3++] !== r3[i2++])
              return false;
          return true;
        }, e2.eG = function(t3, e3) {
          var r3 = [], n3 = 0;
          if (e3 && "hex" === e3)
            for (; n3 < t3.length; )
              r3.push(parseInt(t3.slice(n3, n3 + 2), 16)), n3 += 2;
          else
            for (; n3 < t3.length; n3++)
              r3.push(255 & t3.charCodeAt(n3));
          return r3;
        }, e2.mP = function(t3, e3) {
          return t3[e3] | t3[e3 + 1] << 8;
        }, e2.n8 = function(t3, e3) {
          return t3[e3 + 1] | t3[e3] << 8;
        }, e2.nm = function(t3, e3) {
          return t3[e3] | t3[e3 + 1] << 8 | t3[e3 + 2] << 16 | 16777216 * t3[e3 + 3];
        }, e2.Ag = function(t3, e3) {
          return t3[e3 + 3] | t3[e3 + 2] << 8 | t3[e3 + 1] << 16 | 16777216 * t3[e3];
        }, o.prototype = Object.create(Error.prototype), o.prototype.constructor = o;
      }, 71371: function(t2) {
        function e2(t3, e3) {
          var r3 = new Error(t3);
          return r3.code = e3, r3;
        }
        function r2(t3) {
          try {
            return decodeURIComponent(escape(t3));
          } catch (e3) {
            return t3;
          }
        }
        function n2(t3, r3, n3) {
          this.input = t3.subarray(r3, n3), this.start = r3;
          var i = String.fromCharCode.apply(null, this.input.subarray(0, 4));
          if ("II*\0" !== i && "MM\0*" !== i)
            throw e2("invalid TIFF signature", "EBADDATA");
          this.big_endian = "M" === i[0];
        }
        n2.prototype.each = function(t3) {
          this.aborted = false;
          var e3 = this.read_uint32(4);
          for (this.ifds_to_read = [{ id: 0, offset: e3 }]; this.ifds_to_read.length > 0 && !this.aborted; ) {
            var r3 = this.ifds_to_read.shift();
            r3.offset && this.scan_ifd(r3.id, r3.offset, t3);
          }
        }, n2.prototype.read_uint16 = function(t3) {
          var r3 = this.input;
          if (t3 + 2 > r3.length)
            throw e2("unexpected EOF", "EBADDATA");
          return this.big_endian ? 256 * r3[t3] + r3[t3 + 1] : r3[t3] + 256 * r3[t3 + 1];
        }, n2.prototype.read_uint32 = function(t3) {
          var r3 = this.input;
          if (t3 + 4 > r3.length)
            throw e2("unexpected EOF", "EBADDATA");
          return this.big_endian ? 16777216 * r3[t3] + 65536 * r3[t3 + 1] + 256 * r3[t3 + 2] + r3[t3 + 3] : r3[t3] + 256 * r3[t3 + 1] + 65536 * r3[t3 + 2] + 16777216 * r3[t3 + 3];
        }, n2.prototype.is_subifd_link = function(t3, e3) {
          return 0 === t3 && 34665 === e3 || 0 === t3 && 34853 === e3 || 34665 === t3 && 40965 === e3;
        }, n2.prototype.exif_format_length = function(t3) {
          switch (t3) {
            case 1:
            case 2:
            case 6:
            case 7:
              return 1;
            case 3:
            case 8:
              return 2;
            case 4:
            case 9:
            case 11:
              return 4;
            case 5:
            case 10:
            case 12:
              return 8;
            default:
              return 0;
          }
        }, n2.prototype.exif_format_read = function(t3, e3) {
          var r3;
          switch (t3) {
            case 1:
            case 2:
              return this.input[e3];
            case 6:
              return (r3 = this.input[e3]) | 33554430 * (128 & r3);
            case 3:
              return this.read_uint16(e3);
            case 8:
              return (r3 = this.read_uint16(e3)) | 131070 * (32768 & r3);
            case 4:
              return this.read_uint32(e3);
            case 9:
              return 0 | this.read_uint32(e3);
            default:
              return null;
          }
        }, n2.prototype.scan_ifd = function(t3, n3, i) {
          var a = this.read_uint16(n3);
          n3 += 2;
          for (var o = 0; o < a; o++) {
            var s = this.read_uint16(n3), l = this.read_uint16(n3 + 2), u = this.read_uint32(n3 + 4), c = this.exif_format_length(l), f2 = u * c, h = f2 <= 4 ? n3 + 8 : this.read_uint32(n3 + 8), p2 = false;
            if (h + f2 > this.input.length)
              throw e2("unexpected EOF", "EBADDATA");
            for (var d2 = [], v = h, g2 = 0; g2 < u; g2++, v += c) {
              var y = this.exif_format_read(l, v);
              if (null === y) {
                d2 = null;
                break;
              }
              d2.push(y);
            }
            if (Array.isArray(d2) && 2 === l && (d2 = r2(String.fromCharCode.apply(null, d2))) && "\0" === d2[d2.length - 1] && (d2 = d2.slice(0, -1)), this.is_subifd_link(t3, s) && Array.isArray(d2) && Number.isInteger(d2[0]) && d2[0] > 0 && (this.ifds_to_read.push({ id: s, offset: d2[0] }), p2 = true), false === i({ is_big_endian: this.big_endian, ifd: t3, tag: s, format: l, count: u, entry_offset: n3 + this.start, data_length: f2, data_offset: h + this.start, value: d2, is_subifd_link: p2 }))
              return void (this.aborted = true);
            n3 += 12;
          }
          0 === t3 && this.ifds_to_read.push({ id: 1, offset: this.read_uint32(n3) });
        }, t2.exports.ExifParser = n2, t2.exports.get_orientation = function(t3) {
          var e3 = 0;
          try {
            return new n2(t3, 0, t3.length).each(function(t4) {
              if (0 === t4.ifd && 274 === t4.tag && Array.isArray(t4.value))
                return e3 = t4.value[0], false;
            }), e3;
          } catch (t4) {
            return -1;
          }
        };
      }, 76767: function(t2, e2, r2) {
        var n2 = r2(14847).n8, i = r2(14847).Ag;
        function a(t3, e3) {
          if (t3.length < 4 + e3)
            return null;
          var r3 = i(t3, e3);
          return t3.length < r3 + e3 || r3 < 8 ? null : { boxtype: String.fromCharCode.apply(null, t3.slice(e3 + 4, e3 + 8)), data: t3.slice(e3 + 8, e3 + r3), end: e3 + r3 };
        }
        function o(t3, e3) {
          for (var r3 = 0; ; ) {
            var n3 = a(t3, r3);
            if (!n3)
              break;
            switch (n3.boxtype) {
              case "ispe":
                e3.sizes.push({ width: i(n3.data, 4), height: i(n3.data, 8) });
                break;
              case "irot":
                e3.transforms.push({ type: "irot", value: 3 & n3.data[0] });
                break;
              case "imir":
                e3.transforms.push({ type: "imir", value: 1 & n3.data[0] });
            }
            r3 = n3.end;
          }
        }
        function s(t3, e3, r3) {
          for (var n3 = 0, i2 = 0; i2 < r3; i2++)
            n3 = 256 * n3 + (t3[e3 + i2] || 0);
          return n3;
        }
        function l(t3, e3) {
          for (var r3 = t3[4] >> 4 & 15, i2 = 15 & t3[4], a2 = t3[5] >> 4 & 15, o2 = n2(t3, 6), l2 = 8, u2 = 0; u2 < o2; u2++) {
            var c2 = n2(t3, l2), f2 = n2(t3, l2 += 2), h = s(t3, l2 += 2, a2), p2 = n2(t3, l2 += a2);
            if (l2 += 2, 0 === f2 && 1 === p2) {
              var d2 = s(t3, l2, r3), v = s(t3, l2 + r3, i2);
              e3.item_loc[c2] = { length: v, offset: d2 + h };
            }
            l2 += p2 * (r3 + i2);
          }
        }
        function u(t3, e3) {
          for (var r3 = n2(t3, 4), i2 = 6, o2 = 0; o2 < r3; o2++) {
            var s2 = a(t3, i2);
            if (!s2)
              break;
            if ("infe" === s2.boxtype) {
              for (var l2 = n2(s2.data, 4), u2 = "", c2 = 8; c2 < s2.data.length && s2.data[c2]; c2++)
                u2 += String.fromCharCode(s2.data[c2]);
              e3.item_inf[u2] = l2;
            }
            i2 = s2.end;
          }
        }
        function c(t3, e3) {
          for (var r3 = 0; ; ) {
            var n3 = a(t3, r3);
            if (!n3)
              break;
            "ipco" === n3.boxtype && o(n3.data, e3), r3 = n3.end;
          }
        }
        t2.exports.unbox = a, t2.exports.readSizeFromMeta = function(t3) {
          var e3 = { sizes: [], transforms: [], item_inf: {}, item_loc: {} };
          if (function(t4, e4) {
            for (var r4 = 4; ; ) {
              var n4 = a(t4, r4);
              if (!n4)
                break;
              "iprp" === n4.boxtype && c(n4.data, e4), "iloc" === n4.boxtype && l(n4.data, e4), "iinf" === n4.boxtype && u(n4.data, e4), r4 = n4.end;
            }
          }(t3, e3), e3.sizes.length) {
            var r3, n3, i2, o2 = (n3 = (r3 = e3.sizes).reduce(function(t4, e4) {
              return t4.width > e4.width || t4.width === e4.width && t4.height > e4.height ? t4 : e4;
            }), i2 = r3.reduce(function(t4, e4) {
              return t4.height > e4.height || t4.height === e4.height && t4.width > e4.width ? t4 : e4;
            }), n3.width > i2.height || n3.width === i2.height && n3.height > i2.width ? n3 : i2), s2 = 1;
            e3.transforms.forEach(function(t4) {
              var e4 = { 1: 6, 2: 5, 3: 8, 4: 7, 5: 4, 6: 3, 7: 2, 8: 1 }, r4 = { 1: 4, 2: 3, 3: 2, 4: 1, 5: 6, 6: 5, 7: 8, 8: 7 };
              if ("imir" === t4.type && (s2 = 0 === t4.value ? r4[s2] : e4[s2 = e4[s2 = r4[s2]]]), "irot" === t4.type)
                for (var n4 = 0; n4 < t4.value; n4++)
                  s2 = e4[s2];
            });
            var f2 = null;
            return e3.item_inf.Exif && (f2 = e3.item_loc[e3.item_inf.Exif]), { width: o2.width, height: o2.height, orientation: e3.transforms.length ? s2 : null, variants: e3.sizes, exif_location: f2 };
          }
        }, t2.exports.getMimeType = function(t3) {
          var e3 = String.fromCharCode.apply(null, t3.slice(0, 4)), r3 = {};
          r3[e3] = true;
          for (var n3 = 8; n3 < t3.length; n3 += 4)
            r3[String.fromCharCode.apply(null, t3.slice(n3, n3 + 4))] = true;
          if (r3.mif1 || r3.msf1 || r3.miaf)
            return "avif" === e3 || "avis" === e3 || "avio" === e3 ? { type: "avif", mime: "image/avif" } : "heic" === e3 || "heix" === e3 ? { type: "heic", mime: "image/heic" } : "hevc" === e3 || "hevx" === e3 ? { type: "heic", mime: "image/heic-sequence" } : r3.avif || r3.avis ? { type: "avif", mime: "image/avif" } : r3.heic || r3.heix || r3.hevc || r3.hevx || r3.heis ? r3.msf1 ? { type: "heif", mime: "image/heif-sequence" } : { type: "heif", mime: "image/heif" } : { type: "avif", mime: "image/avif" };
        };
      }, 24461: function(t2, e2, r2) {
        var n2 = r2(14847).eG, i = r2(14847).OF, a = r2(14847).Ag, o = r2(76767), s = r2(71371), l = n2("ftyp");
        t2.exports = function(t3) {
          if (i(t3, 4, l)) {
            var e3 = o.unbox(t3, 0);
            if (e3) {
              var r3 = o.getMimeType(e3.data);
              if (r3) {
                for (var n3, u = e3.end; ; ) {
                  var c = o.unbox(t3, u);
                  if (!c)
                    break;
                  if (u = c.end, "mdat" === c.boxtype)
                    return;
                  if ("meta" === c.boxtype) {
                    n3 = c.data;
                    break;
                  }
                }
                if (n3) {
                  var f2 = o.readSizeFromMeta(n3);
                  if (f2) {
                    var h = { width: f2.width, height: f2.height, type: r3.type, mime: r3.mime, wUnits: "px", hUnits: "px" };
                    if (f2.variants.length > 1 && (h.variants = f2.variants), f2.orientation && (h.orientation = f2.orientation), f2.exif_location && f2.exif_location.offset + f2.exif_location.length <= t3.length) {
                      var p2 = a(t3, f2.exif_location.offset), d2 = t3.slice(f2.exif_location.offset + p2 + 4, f2.exif_location.offset + f2.exif_location.length), v = s.get_orientation(d2);
                      v > 0 && (h.orientation = v);
                    }
                    return h;
                  }
                }
              }
            }
          }
        };
      }, 2504: function(t2, e2, r2) {
        var n2 = r2(14847).eG, i = r2(14847).OF, a = r2(14847).mP, o = n2("BM");
        t2.exports = function(t3) {
          if (!(t3.length < 26) && i(t3, 0, o))
            return { width: a(t3, 18), height: a(t3, 22), type: "bmp", mime: "image/bmp", wUnits: "px", hUnits: "px" };
        };
      }, 47342: function(t2, e2, r2) {
        var n2 = r2(14847).eG, i = r2(14847).OF, a = r2(14847).mP, o = n2("GIF87a"), s = n2("GIF89a");
        t2.exports = function(t3) {
          if (!(t3.length < 10) && (i(t3, 0, o) || i(t3, 0, s)))
            return { width: a(t3, 6), height: a(t3, 8), type: "gif", mime: "image/gif", wUnits: "px", hUnits: "px" };
        };
      }, 31355: function(t2, e2, r2) {
        var n2 = r2(14847).mP;
        t2.exports = function(t3) {
          var e3 = n2(t3, 0), r3 = n2(t3, 2), i = n2(t3, 4);
          if (0 === e3 && 1 === r3 && i) {
            for (var a = [], o = { width: 0, height: 0 }, s = 0; s < i; s++) {
              var l = t3[6 + 16 * s] || 256, u = t3[6 + 16 * s + 1] || 256, c = { width: l, height: u };
              a.push(c), (l > o.width || u > o.height) && (o = c);
            }
            return { width: o.width, height: o.height, variants: a, type: "ico", mime: "image/x-icon", wUnits: "px", hUnits: "px" };
          }
        };
      }, 54261: function(t2, e2, r2) {
        var n2 = r2(14847).n8, i = r2(14847).eG, a = r2(14847).OF, o = r2(71371), s = i("Exif\0\0");
        t2.exports = function(t3) {
          if (!(t3.length < 2) && 255 === t3[0] && 216 === t3[1] && 255 === t3[2])
            for (var e3 = 2; ; ) {
              for (; ; ) {
                if (t3.length - e3 < 2)
                  return;
                if (255 === t3[e3++])
                  break;
              }
              for (var r3, i2, l = t3[e3++]; 255 === l; )
                l = t3[e3++];
              if (208 <= l && l <= 217 || 1 === l)
                r3 = 0;
              else {
                if (!(192 <= l && l <= 254))
                  return;
                if (t3.length - e3 < 2)
                  return;
                r3 = n2(t3, e3) - 2, e3 += 2;
              }
              if (217 === l || 218 === l)
                return;
              if (225 === l && r3 >= 10 && a(t3, e3, s) && (i2 = o.get_orientation(t3.slice(e3 + 6, e3 + r3))), r3 >= 5 && 192 <= l && l <= 207 && 196 !== l && 200 !== l && 204 !== l) {
                if (t3.length - e3 < r3)
                  return;
                var u = { width: n2(t3, e3 + 3), height: n2(t3, e3 + 1), type: "jpg", mime: "image/jpeg", wUnits: "px", hUnits: "px" };
                return i2 > 0 && (u.orientation = i2), u;
              }
              e3 += r3;
            }
        };
      }, 6303: function(t2, e2, r2) {
        var n2 = r2(14847).eG, i = r2(14847).OF, a = r2(14847).Ag, o = n2("PNG\r\n\n"), s = n2("IHDR");
        t2.exports = function(t3) {
          if (!(t3.length < 24) && i(t3, 0, o) && i(t3, 12, s))
            return { width: a(t3, 16), height: a(t3, 20), type: "png", mime: "image/png", wUnits: "px", hUnits: "px" };
        };
      }, 38689: function(t2, e2, r2) {
        var n2 = r2(14847).eG, i = r2(14847).OF, a = r2(14847).Ag, o = n2("8BPS\0");
        t2.exports = function(t3) {
          if (!(t3.length < 22) && i(t3, 0, o))
            return { width: a(t3, 18), height: a(t3, 14), type: "psd", mime: "image/vnd.adobe.photoshop", wUnits: "px", hUnits: "px" };
        };
      }, 6881: function(t2) {
        function e2(t3) {
          return "number" == typeof t3 && isFinite(t3) && t3 > 0;
        }
        var r2 = /<[-_.:a-zA-Z0-9][^>]*>/, n2 = /^<([-_.:a-zA-Z0-9]+:)?svg\s/, i = /[^-]\bwidth="([^%]+?)"|[^-]\bwidth='([^%]+?)'/, a = /\bheight="([^%]+?)"|\bheight='([^%]+?)'/, o = /\bview[bB]ox="(.+?)"|\bview[bB]ox='(.+?)'/, s = /in$|mm$|cm$|pt$|pc$|px$|em$|ex$/;
        function l(t3) {
          return s.test(t3) ? t3.match(s)[0] : "px";
        }
        t2.exports = function(t3) {
          if (function(t4) {
            var e3, r3 = 0, n3 = t4.length;
            for (239 === t4[0] && 187 === t4[1] && 191 === t4[2] && (r3 = 3); r3 < n3 && (32 === (e3 = t4[r3]) || 9 === e3 || 13 === e3 || 10 === e3); )
              r3++;
            return r3 !== n3 && 60 === t4[r3];
          }(t3)) {
            for (var s2 = "", u = 0; u < t3.length; u++)
              s2 += String.fromCharCode(t3[u]);
            var c = (s2.match(r2) || [""])[0];
            if (n2.test(c)) {
              var f2 = function(t4) {
                var e3 = t4.match(i), r3 = t4.match(a), n3 = t4.match(o);
                return { width: e3 && (e3[1] || e3[2]), height: r3 && (r3[1] || r3[2]), viewbox: n3 && (n3[1] || n3[2]) };
              }(c), h = parseFloat(f2.width), p2 = parseFloat(f2.height);
              if (f2.width && f2.height) {
                if (!e2(h) || !e2(p2))
                  return;
                return { width: h, height: p2, type: "svg", mime: "image/svg+xml", wUnits: l(f2.width), hUnits: l(f2.height) };
              }
              var d2 = (f2.viewbox || "").split(" "), v = { width: d2[2], height: d2[3] }, g2 = parseFloat(v.width), y = parseFloat(v.height);
              if (e2(g2) && e2(y) && l(v.width) === l(v.height)) {
                var m2 = g2 / y;
                if (f2.width) {
                  if (!e2(h))
                    return;
                  return { width: h, height: h / m2, type: "svg", mime: "image/svg+xml", wUnits: l(f2.width), hUnits: l(f2.width) };
                }
                if (f2.height) {
                  if (!e2(p2))
                    return;
                  return { width: p2 * m2, height: p2, type: "svg", mime: "image/svg+xml", wUnits: l(f2.height), hUnits: l(f2.height) };
                }
                return { width: g2, height: y, type: "svg", mime: "image/svg+xml", wUnits: l(v.width), hUnits: l(v.height) };
              }
            }
          }
        };
      }, 66278: function(t2, e2, r2) {
        var n2 = r2(14847).eG, i = r2(14847).OF, a = r2(14847).mP, o = r2(14847).n8, s = r2(14847).nm, l = r2(14847).Ag, u = n2("II*\0"), c = n2("MM\0*");
        function f2(t3, e3, r3) {
          return r3 ? o(t3, e3) : a(t3, e3);
        }
        function h(t3, e3, r3) {
          return r3 ? l(t3, e3) : s(t3, e3);
        }
        function p2(t3, e3, r3) {
          var n3 = f2(t3, e3 + 2, r3);
          return 1 !== h(t3, e3 + 4, r3) || 3 !== n3 && 4 !== n3 ? null : 3 === n3 ? f2(t3, e3 + 8, r3) : h(t3, e3 + 8, r3);
        }
        t2.exports = function(t3) {
          if (!(t3.length < 8) && (i(t3, 0, u) || i(t3, 0, c))) {
            var e3 = 77 === t3[0], r3 = h(t3, 4, e3) - 8;
            if (!(r3 < 0)) {
              var n3 = r3 + 8;
              if (!(t3.length - n3 < 2)) {
                var a2 = 12 * f2(t3, n3 + 0, e3);
                if (!(a2 <= 0 || (n3 += 2, t3.length - n3 < a2))) {
                  var o2, s2, l2, d2;
                  for (o2 = 0; o2 < a2; o2 += 12)
                    256 === (d2 = f2(t3, n3 + o2, e3)) ? s2 = p2(t3, n3 + o2, e3) : 257 === d2 && (l2 = p2(t3, n3 + o2, e3));
                  return s2 && l2 ? { width: s2, height: l2, type: "tiff", mime: "image/tiff", wUnits: "px", hUnits: "px" } : void 0;
                }
              }
            }
          }
        };
      }, 90784: function(t2, e2, r2) {
        var n2 = r2(14847).eG, i = r2(14847).OF, a = r2(14847).mP, o = r2(14847).nm, s = r2(71371), l = n2("RIFF"), u = n2("WEBP");
        function c(t3, e3) {
          if (157 === t3[e3 + 3] && 1 === t3[e3 + 4] && 42 === t3[e3 + 5])
            return { width: 16383 & a(t3, e3 + 6), height: 16383 & a(t3, e3 + 8), type: "webp", mime: "image/webp", wUnits: "px", hUnits: "px" };
        }
        function f2(t3, e3) {
          if (47 === t3[e3]) {
            var r3 = o(t3, e3 + 1);
            return { width: 1 + (16383 & r3), height: 1 + (r3 >> 14 & 16383), type: "webp", mime: "image/webp", wUnits: "px", hUnits: "px" };
          }
        }
        function h(t3, e3) {
          return { width: 1 + (t3[e3 + 6] << 16 | t3[e3 + 5] << 8 | t3[e3 + 4]), height: 1 + (t3[e3 + 9] << e3 | t3[e3 + 8] << 8 | t3[e3 + 7]), type: "webp", mime: "image/webp", wUnits: "px", hUnits: "px" };
        }
        t2.exports = function(t3) {
          if (!(t3.length < 16) && (i(t3, 0, l) || i(t3, 8, u))) {
            var e3 = 12, r3 = null, n3 = 0, a2 = o(t3, 4) + 8;
            if (!(a2 > t3.length)) {
              for (; e3 + 8 < a2; )
                if (0 !== t3[e3]) {
                  var p2 = String.fromCharCode.apply(null, t3.slice(e3, e3 + 4)), d2 = o(t3, e3 + 4);
                  "VP8 " === p2 && d2 >= 10 ? r3 = r3 || c(t3, e3 + 8) : "VP8L" === p2 && d2 >= 9 ? r3 = r3 || f2(t3, e3 + 8) : "VP8X" === p2 && d2 >= 10 ? r3 = r3 || h(t3, e3 + 8) : "EXIF" === p2 && (n3 = s.get_orientation(t3.slice(e3 + 8, e3 + 8 + d2)), e3 = 1 / 0), e3 += 8 + d2;
                } else
                  e3++;
              if (r3)
                return n3 > 0 && (r3.orientation = n3), r3;
            }
          }
        };
      }, 91497: function(t2, e2, r2) {
        t2.exports = { avif: r2(24461), bmp: r2(2504), gif: r2(47342), ico: r2(31355), jpeg: r2(54261), png: r2(6303), psd: r2(38689), svg: r2(6881), tiff: r2(66278), webp: r2(90784) };
      }, 33575: function(t2, e2, r2) {
        var n2 = r2(91497);
        t2.exports = function(t3) {
          return function(t4) {
            for (var e3 = Object.keys(n2), r3 = 0; r3 < e3.length; r3++) {
              var i = n2[e3[r3]](t4);
              if (i)
                return i;
            }
            return null;
          }(t3);
        }, t2.exports.parsers = n2;
      }, 90386: function(t2) {
        var e2, r2, n2 = t2.exports = {};
        function i() {
          throw new Error("setTimeout has not been defined");
        }
        function a() {
          throw new Error("clearTimeout has not been defined");
        }
        function o(t3) {
          if (e2 === setTimeout)
            return setTimeout(t3, 0);
          if ((e2 === i || !e2) && setTimeout)
            return e2 = setTimeout, setTimeout(t3, 0);
          try {
            return e2(t3, 0);
          } catch (r3) {
            try {
              return e2.call(null, t3, 0);
            } catch (r4) {
              return e2.call(this, t3, 0);
            }
          }
        }
        !function() {
          try {
            e2 = "function" == typeof setTimeout ? setTimeout : i;
          } catch (t3) {
            e2 = i;
          }
          try {
            r2 = "function" == typeof clearTimeout ? clearTimeout : a;
          } catch (t3) {
            r2 = a;
          }
        }();
        var s, l = [], u = false, c = -1;
        function f2() {
          u && s && (u = false, s.length ? l = s.concat(l) : c = -1, l.length && h());
        }
        function h() {
          if (!u) {
            var t3 = o(f2);
            u = true;
            for (var e3 = l.length; e3; ) {
              for (s = l, l = []; ++c < e3; )
                s && s[c].run();
              c = -1, e3 = l.length;
            }
            s = null, u = false, function(t4) {
              if (r2 === clearTimeout)
                return clearTimeout(t4);
              if ((r2 === a || !r2) && clearTimeout)
                return r2 = clearTimeout, clearTimeout(t4);
              try {
                r2(t4);
              } catch (e4) {
                try {
                  return r2.call(null, t4);
                } catch (e5) {
                  return r2.call(this, t4);
                }
              }
            }(t3);
          }
        }
        function p2(t3, e3) {
          this.fun = t3, this.array = e3;
        }
        function d2() {
        }
        n2.nextTick = function(t3) {
          var e3 = new Array(arguments.length - 1);
          if (arguments.length > 1)
            for (var r3 = 1; r3 < arguments.length; r3++)
              e3[r3 - 1] = arguments[r3];
          l.push(new p2(t3, e3)), 1 !== l.length || u || o(h);
        }, p2.prototype.run = function() {
          this.fun.apply(null, this.array);
        }, n2.title = "browser", n2.browser = true, n2.env = {}, n2.argv = [], n2.version = "", n2.versions = {}, n2.on = d2, n2.addListener = d2, n2.once = d2, n2.off = d2, n2.removeListener = d2, n2.removeAllListeners = d2, n2.emit = d2, n2.prependListener = d2, n2.prependOnceListener = d2, n2.listeners = function(t3) {
          return [];
        }, n2.binding = function(t3) {
          throw new Error("process.binding is not supported");
        }, n2.cwd = function() {
          return "/";
        }, n2.chdir = function(t3) {
          throw new Error("process.chdir is not supported");
        }, n2.umask = function() {
          return 0;
        };
      }, 5877: function(t2, e2, r2) {
        for (var n2 = r2(9748), i = "undefined" == typeof window ? r2.g : window, a = ["moz", "webkit"], o = "AnimationFrame", s = i["request" + o], l = i["cancel" + o] || i["cancelRequest" + o], u = 0; !s && u < a.length; u++)
          s = i[a[u] + "Request" + o], l = i[a[u] + "Cancel" + o] || i[a[u] + "CancelRequest" + o];
        if (!s || !l) {
          var c = 0, f2 = 0, h = [];
          s = function(t3) {
            if (0 === h.length) {
              var e3 = n2(), r3 = Math.max(0, 16.666666666666668 - (e3 - c));
              c = r3 + e3, setTimeout(function() {
                var t4 = h.slice(0);
                h.length = 0;
                for (var e4 = 0; e4 < t4.length; e4++)
                  if (!t4[e4].cancelled)
                    try {
                      t4[e4].callback(c);
                    } catch (t5) {
                      setTimeout(function() {
                        throw t5;
                      }, 0);
                    }
              }, Math.round(r3));
            }
            return h.push({ handle: ++f2, callback: t3, cancelled: false }), f2;
          }, l = function(t3) {
            for (var e3 = 0; e3 < h.length; e3++)
              h[e3].handle === t3 && (h[e3].cancelled = true);
          };
        }
        t2.exports = function(t3) {
          return s.call(i, t3);
        }, t2.exports.cancel = function() {
          l.apply(i, arguments);
        }, t2.exports.polyfill = function(t3) {
          t3 || (t3 = i), t3.requestAnimationFrame = s, t3.cancelAnimationFrame = l;
        };
      }, 3593: function(t2, e2, r2) {
        var n2 = r2(21527), i = r2(25075), a = r2(93447), o = r2(71299), s = r2(56131), l = r2(30120), u = r2(57060), c = u.float32, f2 = u.fract32;
        t2.exports = function(t3, e3) {
          if ("function" == typeof t3 ? (e3 || (e3 = {}), e3.regl = t3) : e3 = t3, e3.length && (e3.positions = e3), !(t3 = e3.regl).hasExtension("ANGLE_instanced_arrays"))
            throw Error("regl-error2d: `ANGLE_instanced_arrays` extension should be enabled");
          var r3, u2, p2, d2, v, g2, y = t3._gl, m2 = { color: "black", capSize: 5, lineWidth: 1, opacity: 1, viewport: null, range: null, offset: 0, count: 0, bounds: null, positions: [], errors: [] }, x = [];
          return d2 = t3.buffer({ usage: "dynamic", type: "uint8", data: new Uint8Array(0) }), u2 = t3.buffer({ usage: "dynamic", type: "float", data: new Uint8Array(0) }), p2 = t3.buffer({ usage: "dynamic", type: "float", data: new Uint8Array(0) }), v = t3.buffer({ usage: "dynamic", type: "float", data: new Uint8Array(0) }), g2 = t3.buffer({ usage: "static", type: "float", data: h }), T(e3), r3 = t3({ vert: "\n		precision highp float;\n\n		attribute vec2 position, positionFract;\n		attribute vec4 error;\n		attribute vec4 color;\n\n		attribute vec2 direction, lineOffset, capOffset;\n\n		uniform vec4 viewport;\n		uniform float lineWidth, capSize;\n		uniform vec2 scale, scaleFract, translate, translateFract;\n\n		varying vec4 fragColor;\n\n		void main() {\n			fragColor = color / 255.;\n\n			vec2 pixelOffset = lineWidth * lineOffset + (capSize + lineWidth) * capOffset;\n\n			vec2 dxy = -step(.5, direction.xy) * error.xz + step(direction.xy, vec2(-.5)) * error.yw;\n\n			vec2 position = position + dxy;\n\n			vec2 pos = (position + translate) * scale\n				+ (positionFract + translateFract) * scale\n				+ (position + translate) * scaleFract\n				+ (positionFract + translateFract) * scaleFract;\n\n			pos += pixelOffset / viewport.zw;\n\n			gl_Position = vec4(pos * 2. - 1., 0, 1);\n		}\n		", frag: "\n		precision highp float;\n\n		varying vec4 fragColor;\n\n		uniform float opacity;\n\n		void main() {\n			gl_FragColor = fragColor;\n			gl_FragColor.a *= opacity;\n		}\n		", uniforms: { range: t3.prop("range"), lineWidth: t3.prop("lineWidth"), capSize: t3.prop("capSize"), opacity: t3.prop("opacity"), scale: t3.prop("scale"), translate: t3.prop("translate"), scaleFract: t3.prop("scaleFract"), translateFract: t3.prop("translateFract"), viewport: function(t4, e4) {
            return [e4.viewport.x, e4.viewport.y, t4.viewportWidth, t4.viewportHeight];
          } }, attributes: { color: { buffer: d2, offset: function(t4, e4) {
            return 4 * e4.offset;
          }, divisor: 1 }, position: { buffer: u2, offset: function(t4, e4) {
            return 8 * e4.offset;
          }, divisor: 1 }, positionFract: { buffer: p2, offset: function(t4, e4) {
            return 8 * e4.offset;
          }, divisor: 1 }, error: { buffer: v, offset: function(t4, e4) {
            return 16 * e4.offset;
          }, divisor: 1 }, direction: { buffer: g2, stride: 24, offset: 0 }, lineOffset: { buffer: g2, stride: 24, offset: 8 }, capOffset: { buffer: g2, stride: 24, offset: 16 } }, primitive: "triangles", blend: { enable: true, color: [0, 0, 0, 0], equation: { rgb: "add", alpha: "add" }, func: { srcRGB: "src alpha", dstRGB: "one minus src alpha", srcAlpha: "one minus dst alpha", dstAlpha: "one" } }, depth: { enable: false }, scissor: { enable: true, box: t3.prop("viewport") }, viewport: t3.prop("viewport"), stencil: false, instances: t3.prop("count"), count: h.length }), s(b, { update: T, draw: _, destroy: k, regl: t3, gl: y, canvas: y.canvas, groups: x }), b;
          function b(t4) {
            t4 ? T(t4) : null === t4 && k(), _();
          }
          function _(e4) {
            if ("number" == typeof e4)
              return w2(e4);
            e4 && !Array.isArray(e4) && (e4 = [e4]), t3._refresh(), x.forEach(function(t4, r4) {
              t4 && (e4 && (e4[r4] ? t4.draw = true : t4.draw = false), t4.draw ? w2(r4) : t4.draw = true);
            });
          }
          function w2(t4) {
            "number" == typeof t4 && (t4 = x[t4]), null != t4 && t4 && t4.count && t4.color && t4.opacity && t4.positions && t4.positions.length > 1 && (t4.scaleRatio = [t4.scale[0] * t4.viewport.width, t4.scale[1] * t4.viewport.height], r3(t4), t4.after && t4.after(t4));
          }
          function T(t4) {
            if (t4) {
              null != t4.length ? "number" == typeof t4[0] && (t4 = [{ positions: t4 }]) : Array.isArray(t4) || (t4 = [t4]);
              var e4 = 0, r4 = 0;
              if (b.groups = x = t4.map(function(t5, u3) {
                var c2 = x[u3];
                return t5 ? ("function" == typeof t5 ? t5 = { after: t5 } : "number" == typeof t5[0] && (t5 = { positions: t5 }), t5 = o(t5, { color: "color colors fill", capSize: "capSize cap capsize cap-size", lineWidth: "lineWidth line-width width line thickness", opacity: "opacity alpha", range: "range dataBox", viewport: "viewport viewBox", errors: "errors error", positions: "positions position data points" }), c2 || (x[u3] = c2 = { id: u3, scale: null, translate: null, scaleFract: null, translateFract: null, draw: true }, t5 = s({}, m2, t5)), a(c2, t5, [{ lineWidth: function(t6) {
                  return 0.5 * +t6;
                }, capSize: function(t6) {
                  return 0.5 * +t6;
                }, opacity: parseFloat, errors: function(t6) {
                  return t6 = l(t6), r4 += t6.length, t6;
                }, positions: function(t6, r5) {
                  return t6 = l(t6, "float64"), r5.count = Math.floor(t6.length / 2), r5.bounds = n2(t6, 2), r5.offset = e4, e4 += r5.count, t6;
                } }, { color: function(t6, e5) {
                  var r5 = e5.count;
                  if (t6 || (t6 = "transparent"), !Array.isArray(t6) || "number" == typeof t6[0]) {
                    var n3 = t6;
                    t6 = Array(r5);
                    for (var a2 = 0; a2 < r5; a2++)
                      t6[a2] = n3;
                  }
                  if (t6.length < r5)
                    throw Error("Not enough colors");
                  for (var o2 = new Uint8Array(4 * r5), s2 = 0; s2 < r5; s2++) {
                    var l2 = i(t6[s2], "uint8");
                    o2.set(l2, 4 * s2);
                  }
                  return o2;
                }, range: function(t6, e5, r5) {
                  var n3 = e5.bounds;
                  return t6 || (t6 = n3), e5.scale = [1 / (t6[2] - t6[0]), 1 / (t6[3] - t6[1])], e5.translate = [-t6[0], -t6[1]], e5.scaleFract = f2(e5.scale), e5.translateFract = f2(e5.translate), t6;
                }, viewport: function(t6) {
                  var e5;
                  return Array.isArray(t6) ? e5 = { x: t6[0], y: t6[1], width: t6[2] - t6[0], height: t6[3] - t6[1] } : t6 ? (e5 = { x: t6.x || t6.left || 0, y: t6.y || t6.top || 0 }, t6.right ? e5.width = t6.right - e5.x : e5.width = t6.w || t6.width || 0, t6.bottom ? e5.height = t6.bottom - e5.y : e5.height = t6.h || t6.height || 0) : e5 = { x: 0, y: 0, width: y.drawingBufferWidth, height: y.drawingBufferHeight }, e5;
                } }]), c2) : c2;
              }), e4 || r4) {
                var h2 = x.reduce(function(t5, e5, r5) {
                  return t5 + (e5 ? e5.count : 0);
                }, 0), g3 = new Float64Array(2 * h2), _2 = new Uint8Array(4 * h2), w3 = new Float32Array(4 * h2);
                x.forEach(function(t5, e5) {
                  if (t5) {
                    var r5 = t5.positions, n3 = t5.count, i2 = t5.offset, a2 = t5.color, o2 = t5.errors;
                    n3 && (_2.set(a2, 4 * i2), w3.set(o2, 4 * i2), g3.set(r5, 2 * i2));
                  }
                });
                var T2 = c(g3);
                u2(T2);
                var k2 = f2(g3, T2);
                p2(k2), d2(_2), v(w3);
              }
            }
          }
          function k() {
            u2.destroy(), p2.destroy(), d2.destroy(), v.destroy(), g2.destroy();
          }
        };
        var h = [[1, 0, 0, 1, 0, 0], [1, 0, 0, -1, 0, 0], [-1, 0, 0, -1, 0, 0], [-1, 0, 0, -1, 0, 0], [-1, 0, 0, 1, 0, 0], [1, 0, 0, 1, 0, 0], [1, 0, -1, 0, 0, 1], [1, 0, -1, 0, 0, -1], [1, 0, 1, 0, 0, -1], [1, 0, 1, 0, 0, -1], [1, 0, 1, 0, 0, 1], [1, 0, -1, 0, 0, 1], [-1, 0, -1, 0, 0, 1], [-1, 0, -1, 0, 0, -1], [-1, 0, 1, 0, 0, -1], [-1, 0, 1, 0, 0, -1], [-1, 0, 1, 0, 0, 1], [-1, 0, -1, 0, 0, 1], [0, 1, 1, 0, 0, 0], [0, 1, -1, 0, 0, 0], [0, -1, -1, 0, 0, 0], [0, -1, -1, 0, 0, 0], [0, 1, 1, 0, 0, 0], [0, -1, 1, 0, 0, 0], [0, 1, 0, -1, 1, 0], [0, 1, 0, -1, -1, 0], [0, 1, 0, 1, -1, 0], [0, 1, 0, 1, 1, 0], [0, 1, 0, -1, 1, 0], [0, 1, 0, 1, -1, 0], [0, -1, 0, -1, 1, 0], [0, -1, 0, -1, -1, 0], [0, -1, 0, 1, -1, 0], [0, -1, 0, 1, 1, 0], [0, -1, 0, -1, 1, 0], [0, -1, 0, 1, -1, 0]];
      }, 46075: function(t2, e2, r2) {
        var n2 = r2(25075), i = r2(21527), a = r2(56131), o = r2(56068), s = r2(71299), l = r2(30120), u = r2(11474), c = r2(54), f2 = r2(57060), h = f2.float32, p2 = f2.fract32, d2 = r2(83522), v = r2(18863), g2 = r2(6851);
        function y(t3, e3) {
          if (!(this instanceof y))
            return new y(t3, e3);
          if ("function" == typeof t3 ? (e3 || (e3 = {}), e3.regl = t3) : e3 = t3, e3.length && (e3.positions = e3), !(t3 = e3.regl).hasExtension("ANGLE_instanced_arrays"))
            throw Error("regl-error2d: `ANGLE_instanced_arrays` extension should be enabled");
          this.gl = t3._gl, this.regl = t3, this.passes = [], this.shaders = y.shaders.has(t3) ? y.shaders.get(t3) : y.shaders.set(t3, y.createShaders(t3)).get(t3), this.update(e3);
        }
        t2.exports = y, y.dashMult = 2, y.maxPatternLength = 256, y.precisionThreshold = 3e6, y.maxPoints = 1e4, y.maxLines = 2048, y.shaders = new d2(), y.createShaders = function(t3) {
          var e3, r3 = t3.buffer({ usage: "static", type: "float", data: [0, 1, 0, 0, 1, 1, 1, 0] }), n3 = { primitive: "triangle strip", instances: t3.prop("count"), count: 4, offset: 0, uniforms: { miterMode: function(t4, e4) {
            return "round" === e4.join ? 2 : 1;
          }, miterLimit: t3.prop("miterLimit"), scale: t3.prop("scale"), scaleFract: t3.prop("scaleFract"), translateFract: t3.prop("translateFract"), translate: t3.prop("translate"), thickness: t3.prop("thickness"), dashTexture: t3.prop("dashTexture"), opacity: t3.prop("opacity"), pixelRatio: t3.context("pixelRatio"), id: t3.prop("id"), dashLength: t3.prop("dashLength"), viewport: function(t4, e4) {
            return [e4.viewport.x, e4.viewport.y, t4.viewportWidth, t4.viewportHeight];
          }, depth: t3.prop("depth") }, blend: { enable: true, color: [0, 0, 0, 0], equation: { rgb: "add", alpha: "add" }, func: { srcRGB: "src alpha", dstRGB: "one minus src alpha", srcAlpha: "one minus dst alpha", dstAlpha: "one" } }, depth: { enable: function(t4, e4) {
            return !e4.overlay;
          } }, stencil: { enable: false }, scissor: { enable: true, box: t3.prop("viewport") }, viewport: t3.prop("viewport") }, i2 = t3(a({ vert: o(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec2 aCoord, bCoord, aCoordFract, bCoordFract;\nattribute vec4 color;\nattribute float lineEnd, lineTop;\n\nuniform vec2 scale, scaleFract, translate, translateFract;\nuniform float thickness, pixelRatio, id, depth;\nuniform vec4 viewport;\n\nvarying vec4 fragColor;\nvarying vec2 tangent;\n\nvec2 project(vec2 position, vec2 positionFract, vec2 scale, vec2 scaleFract, vec2 translate, vec2 translateFract) {\n	// the order is important\n	return position * scale + translate\n       + positionFract * scale + translateFract\n       + position * scaleFract\n       + positionFract * scaleFract;\n}\n\nvoid main() {\n	float lineStart = 1. - lineEnd;\n	float lineOffset = lineTop * 2. - 1.;\n\n	vec2 diff = (bCoord + bCoordFract - aCoord - aCoordFract);\n	tangent = normalize(diff * scale * viewport.zw);\n	vec2 normal = vec2(-tangent.y, tangent.x);\n\n	vec2 position = project(aCoord, aCoordFract, scale, scaleFract, translate, translateFract) * lineStart\n		+ project(bCoord, bCoordFract, scale, scaleFract, translate, translateFract) * lineEnd\n\n		+ thickness * normal * .5 * lineOffset / viewport.zw;\n\n	gl_Position = vec4(position * 2.0 - 1.0, depth, 1);\n\n	fragColor = color / 255.;\n}\n"]), frag: o(["precision highp float;\n#define GLSLIFY 1\n\nuniform float dashLength, pixelRatio, thickness, opacity, id;\nuniform sampler2D dashTexture;\n\nvarying vec4 fragColor;\nvarying vec2 tangent;\n\nvoid main() {\n	float alpha = 1.;\n\n	float t = fract(dot(tangent, gl_FragCoord.xy) / dashLength) * .5 + .25;\n	float dash = texture2D(dashTexture, vec2(t, .5)).r;\n\n	gl_FragColor = fragColor;\n	gl_FragColor.a *= alpha * opacity * dash;\n}\n"]), attributes: { lineEnd: { buffer: r3, divisor: 0, stride: 8, offset: 0 }, lineTop: { buffer: r3, divisor: 0, stride: 8, offset: 4 }, aCoord: { buffer: t3.prop("positionBuffer"), stride: 8, offset: 8, divisor: 1 }, bCoord: { buffer: t3.prop("positionBuffer"), stride: 8, offset: 16, divisor: 1 }, aCoordFract: { buffer: t3.prop("positionFractBuffer"), stride: 8, offset: 8, divisor: 1 }, bCoordFract: { buffer: t3.prop("positionFractBuffer"), stride: 8, offset: 16, divisor: 1 }, color: { buffer: t3.prop("colorBuffer"), stride: 4, offset: 0, divisor: 1 } } }, n3));
          try {
            e3 = t3(a({ cull: { enable: true, face: "back" }, vert: o(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec2 aCoord, bCoord, nextCoord, prevCoord;\nattribute vec4 aColor, bColor;\nattribute float lineEnd, lineTop;\n\nuniform vec2 scale, translate;\nuniform float thickness, pixelRatio, id, depth;\nuniform vec4 viewport;\nuniform float miterLimit, miterMode;\n\nvarying vec4 fragColor;\nvarying vec4 startCutoff, endCutoff;\nvarying vec2 tangent;\nvarying vec2 startCoord, endCoord;\nvarying float enableStartMiter, enableEndMiter;\n\nconst float REVERSE_THRESHOLD = -.875;\nconst float MIN_DIFF = 1e-6;\n\n// TODO: possible optimizations: avoid overcalculating all for vertices and calc just one instead\n// TODO: precalculate dot products, normalize things beforehead etc.\n// TODO: refactor to rectangular algorithm\n\nfloat distToLine(vec2 p, vec2 a, vec2 b) {\n	vec2 diff = b - a;\n	vec2 perp = normalize(vec2(-diff.y, diff.x));\n	return dot(p - a, perp);\n}\n\nbool isNaN( float val ){\n  return ( val < 0.0 || 0.0 < val || val == 0.0 ) ? false : true;\n}\n\nvoid main() {\n	vec2 aCoord = aCoord, bCoord = bCoord, prevCoord = prevCoord, nextCoord = nextCoord;\n\n  vec2 adjustedScale;\n  adjustedScale.x = (abs(scale.x) < MIN_DIFF) ? MIN_DIFF : scale.x;\n  adjustedScale.y = (abs(scale.y) < MIN_DIFF) ? MIN_DIFF : scale.y;\n\n  vec2 scaleRatio = adjustedScale * viewport.zw;\n	vec2 normalWidth = thickness / scaleRatio;\n\n	float lineStart = 1. - lineEnd;\n	float lineBot = 1. - lineTop;\n\n	fragColor = (lineStart * aColor + lineEnd * bColor) / 255.;\n\n	if (isNaN(aCoord.x) || isNaN(aCoord.y) || isNaN(bCoord.x) || isNaN(bCoord.y)) return;\n\n	if (aCoord == prevCoord) prevCoord = aCoord + normalize(bCoord - aCoord);\n	if (bCoord == nextCoord) nextCoord = bCoord - normalize(bCoord - aCoord);\n\n	vec2 prevDiff = aCoord - prevCoord;\n	vec2 currDiff = bCoord - aCoord;\n	vec2 nextDiff = nextCoord - bCoord;\n\n	vec2 prevTangent = normalize(prevDiff * scaleRatio);\n	vec2 currTangent = normalize(currDiff * scaleRatio);\n	vec2 nextTangent = normalize(nextDiff * scaleRatio);\n\n	vec2 prevNormal = vec2(-prevTangent.y, prevTangent.x);\n	vec2 currNormal = vec2(-currTangent.y, currTangent.x);\n	vec2 nextNormal = vec2(-nextTangent.y, nextTangent.x);\n\n	vec2 startJoinDirection = normalize(prevTangent - currTangent);\n	vec2 endJoinDirection = normalize(currTangent - nextTangent);\n\n	// collapsed/unidirectional segment cases\n	// FIXME: there should be more elegant solution\n	vec2 prevTanDiff = abs(prevTangent - currTangent);\n	vec2 nextTanDiff = abs(nextTangent - currTangent);\n	if (max(prevTanDiff.x, prevTanDiff.y) < MIN_DIFF) {\n		startJoinDirection = currNormal;\n	}\n	if (max(nextTanDiff.x, nextTanDiff.y) < MIN_DIFF) {\n		endJoinDirection = currNormal;\n	}\n	if (aCoord == bCoord) {\n		endJoinDirection = startJoinDirection;\n		currNormal = prevNormal;\n		currTangent = prevTangent;\n	}\n\n	tangent = currTangent;\n\n	//calculate join shifts relative to normals\n	float startJoinShift = dot(currNormal, startJoinDirection);\n	float endJoinShift = dot(currNormal, endJoinDirection);\n\n	float startMiterRatio = abs(1. / startJoinShift);\n	float endMiterRatio = abs(1. / endJoinShift);\n\n	vec2 startJoin = startJoinDirection * startMiterRatio;\n	vec2 endJoin = endJoinDirection * endMiterRatio;\n\n	vec2 startTopJoin, startBotJoin, endTopJoin, endBotJoin;\n	startTopJoin = sign(startJoinShift) * startJoin * .5;\n	startBotJoin = -startTopJoin;\n\n	endTopJoin = sign(endJoinShift) * endJoin * .5;\n	endBotJoin = -endTopJoin;\n\n	vec2 aTopCoord = aCoord + normalWidth * startTopJoin;\n	vec2 bTopCoord = bCoord + normalWidth * endTopJoin;\n	vec2 aBotCoord = aCoord + normalWidth * startBotJoin;\n	vec2 bBotCoord = bCoord + normalWidth * endBotJoin;\n\n	//miter anti-clipping\n	float baClipping = distToLine(bCoord, aCoord, aBotCoord) / dot(normalize(normalWidth * endBotJoin), normalize(normalWidth.yx * vec2(-startBotJoin.y, startBotJoin.x)));\n	float abClipping = distToLine(aCoord, bCoord, bTopCoord) / dot(normalize(normalWidth * startBotJoin), normalize(normalWidth.yx * vec2(-endBotJoin.y, endBotJoin.x)));\n\n	//prevent close to reverse direction switch\n	bool prevReverse = dot(currTangent, prevTangent) <= REVERSE_THRESHOLD && abs(dot(currTangent, prevNormal)) * min(length(prevDiff), length(currDiff)) <  length(normalWidth * currNormal);\n	bool nextReverse = dot(currTangent, nextTangent) <= REVERSE_THRESHOLD && abs(dot(currTangent, nextNormal)) * min(length(nextDiff), length(currDiff)) <  length(normalWidth * currNormal);\n\n	if (prevReverse) {\n		//make join rectangular\n		vec2 miterShift = normalWidth * startJoinDirection * miterLimit * .5;\n		float normalAdjust = 1. - min(miterLimit / startMiterRatio, 1.);\n		aBotCoord = aCoord + miterShift - normalAdjust * normalWidth * currNormal * .5;\n		aTopCoord = aCoord + miterShift + normalAdjust * normalWidth * currNormal * .5;\n	}\n	else if (!nextReverse && baClipping > 0. && baClipping < length(normalWidth * endBotJoin)) {\n		//handle miter clipping\n		bTopCoord -= normalWidth * endTopJoin;\n		bTopCoord += normalize(endTopJoin * normalWidth) * baClipping;\n	}\n\n	if (nextReverse) {\n		//make join rectangular\n		vec2 miterShift = normalWidth * endJoinDirection * miterLimit * .5;\n		float normalAdjust = 1. - min(miterLimit / endMiterRatio, 1.);\n		bBotCoord = bCoord + miterShift - normalAdjust * normalWidth * currNormal * .5;\n		bTopCoord = bCoord + miterShift + normalAdjust * normalWidth * currNormal * .5;\n	}\n	else if (!prevReverse && abClipping > 0. && abClipping < length(normalWidth * startBotJoin)) {\n		//handle miter clipping\n		aBotCoord -= normalWidth * startBotJoin;\n		aBotCoord += normalize(startBotJoin * normalWidth) * abClipping;\n	}\n\n	vec2 aTopPosition = (aTopCoord) * adjustedScale + translate;\n	vec2 aBotPosition = (aBotCoord) * adjustedScale + translate;\n\n	vec2 bTopPosition = (bTopCoord) * adjustedScale + translate;\n	vec2 bBotPosition = (bBotCoord) * adjustedScale + translate;\n\n	//position is normalized 0..1 coord on the screen\n	vec2 position = (aTopPosition * lineTop + aBotPosition * lineBot) * lineStart + (bTopPosition * lineTop + bBotPosition * lineBot) * lineEnd;\n\n	startCoord = aCoord * scaleRatio + translate * viewport.zw + viewport.xy;\n	endCoord = bCoord * scaleRatio + translate * viewport.zw + viewport.xy;\n\n	gl_Position = vec4(position  * 2.0 - 1.0, depth, 1);\n\n	enableStartMiter = step(dot(currTangent, prevTangent), .5);\n	enableEndMiter = step(dot(currTangent, nextTangent), .5);\n\n	//bevel miter cutoffs\n	if (miterMode == 1.) {\n		if (enableStartMiter == 1.) {\n			vec2 startMiterWidth = vec2(startJoinDirection) * thickness * miterLimit * .5;\n			startCutoff = vec4(aCoord, aCoord);\n			startCutoff.zw += vec2(-startJoinDirection.y, startJoinDirection.x) / scaleRatio;\n			startCutoff = startCutoff * scaleRatio.xyxy + translate.xyxy * viewport.zwzw;\n			startCutoff += viewport.xyxy;\n			startCutoff += startMiterWidth.xyxy;\n		}\n\n		if (enableEndMiter == 1.) {\n			vec2 endMiterWidth = vec2(endJoinDirection) * thickness * miterLimit * .5;\n			endCutoff = vec4(bCoord, bCoord);\n			endCutoff.zw += vec2(-endJoinDirection.y, endJoinDirection.x)  / scaleRatio;\n			endCutoff = endCutoff * scaleRatio.xyxy + translate.xyxy * viewport.zwzw;\n			endCutoff += viewport.xyxy;\n			endCutoff += endMiterWidth.xyxy;\n		}\n	}\n\n	//round miter cutoffs\n	else if (miterMode == 2.) {\n		if (enableStartMiter == 1.) {\n			vec2 startMiterWidth = vec2(startJoinDirection) * thickness * abs(dot(startJoinDirection, currNormal)) * .5;\n			startCutoff = vec4(aCoord, aCoord);\n			startCutoff.zw += vec2(-startJoinDirection.y, startJoinDirection.x) / scaleRatio;\n			startCutoff = startCutoff * scaleRatio.xyxy + translate.xyxy * viewport.zwzw;\n			startCutoff += viewport.xyxy;\n			startCutoff += startMiterWidth.xyxy;\n		}\n\n		if (enableEndMiter == 1.) {\n			vec2 endMiterWidth = vec2(endJoinDirection) * thickness * abs(dot(endJoinDirection, currNormal)) * .5;\n			endCutoff = vec4(bCoord, bCoord);\n			endCutoff.zw += vec2(-endJoinDirection.y, endJoinDirection.x)  / scaleRatio;\n			endCutoff = endCutoff * scaleRatio.xyxy + translate.xyxy * viewport.zwzw;\n			endCutoff += viewport.xyxy;\n			endCutoff += endMiterWidth.xyxy;\n		}\n	}\n}\n"]), frag: o(["precision highp float;\n#define GLSLIFY 1\n\nuniform float dashLength, pixelRatio, thickness, opacity, id, miterMode;\nuniform sampler2D dashTexture;\n\nvarying vec4 fragColor;\nvarying vec2 tangent;\nvarying vec4 startCutoff, endCutoff;\nvarying vec2 startCoord, endCoord;\nvarying float enableStartMiter, enableEndMiter;\n\nfloat distToLine(vec2 p, vec2 a, vec2 b) {\n	vec2 diff = b - a;\n	vec2 perp = normalize(vec2(-diff.y, diff.x));\n	return dot(p - a, perp);\n}\n\nvoid main() {\n	float alpha = 1., distToStart, distToEnd;\n	float cutoff = thickness * .5;\n\n	//bevel miter\n	if (miterMode == 1.) {\n		if (enableStartMiter == 1.) {\n			distToStart = distToLine(gl_FragCoord.xy, startCutoff.xy, startCutoff.zw);\n			if (distToStart < -1.) {\n				discard;\n				return;\n			}\n			alpha *= min(max(distToStart + 1., 0.), 1.);\n		}\n\n		if (enableEndMiter == 1.) {\n			distToEnd = distToLine(gl_FragCoord.xy, endCutoff.xy, endCutoff.zw);\n			if (distToEnd < -1.) {\n				discard;\n				return;\n			}\n			alpha *= min(max(distToEnd + 1., 0.), 1.);\n		}\n	}\n\n	// round miter\n	else if (miterMode == 2.) {\n		if (enableStartMiter == 1.) {\n			distToStart = distToLine(gl_FragCoord.xy, startCutoff.xy, startCutoff.zw);\n			if (distToStart < 0.) {\n				float radius = length(gl_FragCoord.xy - startCoord);\n\n				if(radius > cutoff + .5) {\n					discard;\n					return;\n				}\n\n				alpha -= smoothstep(cutoff - .5, cutoff + .5, radius);\n			}\n		}\n\n		if (enableEndMiter == 1.) {\n			distToEnd = distToLine(gl_FragCoord.xy, endCutoff.xy, endCutoff.zw);\n			if (distToEnd < 0.) {\n				float radius = length(gl_FragCoord.xy - endCoord);\n\n				if(radius > cutoff + .5) {\n					discard;\n					return;\n				}\n\n				alpha -= smoothstep(cutoff - .5, cutoff + .5, radius);\n			}\n		}\n	}\n\n	float t = fract(dot(tangent, gl_FragCoord.xy) / dashLength) * .5 + .25;\n	float dash = texture2D(dashTexture, vec2(t, .5)).r;\n\n	gl_FragColor = fragColor;\n	gl_FragColor.a *= alpha * opacity * dash;\n}\n"]), attributes: { lineEnd: { buffer: r3, divisor: 0, stride: 8, offset: 0 }, lineTop: { buffer: r3, divisor: 0, stride: 8, offset: 4 }, aColor: { buffer: t3.prop("colorBuffer"), stride: 4, offset: 0, divisor: 1 }, bColor: { buffer: t3.prop("colorBuffer"), stride: 4, offset: 4, divisor: 1 }, prevCoord: { buffer: t3.prop("positionBuffer"), stride: 8, offset: 0, divisor: 1 }, aCoord: { buffer: t3.prop("positionBuffer"), stride: 8, offset: 8, divisor: 1 }, bCoord: { buffer: t3.prop("positionBuffer"), stride: 8, offset: 16, divisor: 1 }, nextCoord: { buffer: t3.prop("positionBuffer"), stride: 8, offset: 24, divisor: 1 } } }, n3));
          } catch (t4) {
            e3 = i2;
          }
          return { fill: t3({ primitive: "triangle", elements: function(t4, e4) {
            return e4.triangles;
          }, offset: 0, vert: o(["precision highp float;\n#define GLSLIFY 1\n\nattribute vec2 position, positionFract;\n\nuniform vec4 color;\nuniform vec2 scale, scaleFract, translate, translateFract;\nuniform float pixelRatio, id;\nuniform vec4 viewport;\nuniform float opacity;\n\nvarying vec4 fragColor;\n\nconst float MAX_LINES = 256.;\n\nvoid main() {\n	float depth = (MAX_LINES - 4. - id) / (MAX_LINES);\n\n	vec2 position = position * scale + translate\n       + positionFract * scale + translateFract\n       + position * scaleFract\n       + positionFract * scaleFract;\n\n	gl_Position = vec4(position * 2.0 - 1.0, depth, 1);\n\n	fragColor = color / 255.;\n	fragColor.a *= opacity;\n}\n"]), frag: o(["precision highp float;\n#define GLSLIFY 1\n\nvarying vec4 fragColor;\n\nvoid main() {\n	gl_FragColor = fragColor;\n}\n"]), uniforms: { scale: t3.prop("scale"), color: t3.prop("fill"), scaleFract: t3.prop("scaleFract"), translateFract: t3.prop("translateFract"), translate: t3.prop("translate"), opacity: t3.prop("opacity"), pixelRatio: t3.context("pixelRatio"), id: t3.prop("id"), viewport: function(t4, e4) {
            return [e4.viewport.x, e4.viewport.y, t4.viewportWidth, t4.viewportHeight];
          } }, attributes: { position: { buffer: t3.prop("positionBuffer"), stride: 8, offset: 8 }, positionFract: { buffer: t3.prop("positionFractBuffer"), stride: 8, offset: 8 } }, blend: n3.blend, depth: { enable: false }, scissor: n3.scissor, stencil: n3.stencil, viewport: n3.viewport }), rect: i2, miter: e3 };
        }, y.defaults = { dashes: null, join: "miter", miterLimit: 1, thickness: 10, cap: "square", color: "black", opacity: 1, overlay: false, viewport: null, range: null, close: false, fill: null }, y.prototype.render = function() {
          for (var t3, e3 = [], r3 = arguments.length; r3--; )
            e3[r3] = arguments[r3];
          e3.length && (t3 = this).update.apply(t3, e3), this.draw();
        }, y.prototype.draw = function() {
          for (var t3 = this, e3 = [], r3 = arguments.length; r3--; )
            e3[r3] = arguments[r3];
          return (e3.length ? e3 : this.passes).forEach(function(e4, r4) {
            var n3;
            if (e4 && Array.isArray(e4))
              return (n3 = t3).draw.apply(n3, e4);
            "number" == typeof e4 && (e4 = t3.passes[e4]), e4 && e4.count > 1 && e4.opacity && (t3.regl._refresh(), e4.fill && e4.triangles && e4.triangles.length > 2 && t3.shaders.fill(e4), e4.thickness && (e4.scale[0] * e4.viewport.width > y.precisionThreshold || e4.scale[1] * e4.viewport.height > y.precisionThreshold || "rect" === e4.join || !e4.join && (e4.thickness <= 2 || e4.count >= y.maxPoints) ? t3.shaders.rect(e4) : t3.shaders.miter(e4)));
          }), this;
        }, y.prototype.update = function(t3) {
          var e3 = this;
          if (t3) {
            null != t3.length ? "number" == typeof t3[0] && (t3 = [{ positions: t3 }]) : Array.isArray(t3) || (t3 = [t3]);
            var r3 = this.regl, o2 = this.gl;
            if (t3.forEach(function(t4, f4) {
              var d4 = e3.passes[f4];
              if (void 0 !== t4)
                if (null !== t4) {
                  if ("number" == typeof t4[0] && (t4 = { positions: t4 }), t4 = s(t4, { positions: "positions points data coords", thickness: "thickness lineWidth lineWidths line-width linewidth width stroke-width strokewidth strokeWidth", join: "lineJoin linejoin join type mode", miterLimit: "miterlimit miterLimit", dashes: "dash dashes dasharray dash-array dashArray", color: "color colour stroke colors colours stroke-color strokeColor", fill: "fill fill-color fillColor", opacity: "alpha opacity", overlay: "overlay crease overlap intersect", close: "closed close closed-path closePath", range: "range dataBox", viewport: "viewport viewBox", hole: "holes hole hollow", splitNull: "splitNull" }), d4 || (e3.passes[f4] = d4 = { id: f4, scale: null, scaleFract: null, translate: null, translateFract: null, count: 0, hole: [], depth: 0, dashLength: 1, dashTexture: r3.texture({ channels: 1, data: new Uint8Array([255]), width: 1, height: 1, mag: "linear", min: "linear" }), colorBuffer: r3.buffer({ usage: "dynamic", type: "uint8", data: new Uint8Array() }), positionBuffer: r3.buffer({ usage: "dynamic", type: "float", data: new Uint8Array() }), positionFractBuffer: r3.buffer({ usage: "dynamic", type: "float", data: new Uint8Array() }) }, t4 = a({}, y.defaults, t4)), null != t4.thickness && (d4.thickness = parseFloat(t4.thickness)), null != t4.opacity && (d4.opacity = parseFloat(t4.opacity)), null != t4.miterLimit && (d4.miterLimit = parseFloat(t4.miterLimit)), null != t4.overlay && (d4.overlay = !!t4.overlay, f4 < y.maxLines && (d4.depth = 2 * (y.maxLines - 1 - f4 % y.maxLines) / y.maxLines - 1)), null != t4.join && (d4.join = t4.join), null != t4.hole && (d4.hole = t4.hole), null != t4.fill && (d4.fill = t4.fill ? n2(t4.fill, "uint8") : null), null != t4.viewport && (d4.viewport = v(t4.viewport)), d4.viewport || (d4.viewport = v([o2.drawingBufferWidth, o2.drawingBufferHeight])), null != t4.close && (d4.close = t4.close), null === t4.positions && (t4.positions = []), t4.positions) {
                    var m3, x2;
                    if (t4.positions.x && t4.positions.y) {
                      var b = t4.positions.x, _ = t4.positions.y;
                      x2 = d4.count = Math.max(b.length, _.length), m3 = new Float64Array(2 * x2);
                      for (var w2 = 0; w2 < x2; w2++)
                        m3[2 * w2] = b[w2], m3[2 * w2 + 1] = _[w2];
                    } else
                      m3 = l(t4.positions, "float64"), x2 = d4.count = Math.floor(m3.length / 2);
                    var T = d4.bounds = i(m3, 2);
                    if (d4.fill) {
                      for (var k = [], A = {}, M = 0, S = 0, E = 0, L = d4.count; S < L; S++) {
                        var C = m3[2 * S], P = m3[2 * S + 1];
                        isNaN(C) || isNaN(P) || null == C || null == P ? (C = m3[2 * M], P = m3[2 * M + 1], A[S] = M) : M = S, k[E++] = C, k[E++] = P;
                      }
                      if (t4.splitNull) {
                        d4.count - 1 in A || (A[d4.count] = d4.count - 1);
                        var O = Object.keys(A).map(Number).sort(function(t5, e4) {
                          return t5 - e4;
                        }), I = [], D = 0, z = null != d4.hole ? d4.hole[0] : null;
                        if (null != z) {
                          var R = g2(O, function(t5) {
                            return t5 >= z;
                          });
                          (O = O.slice(0, R)).push(z);
                        }
                        for (var F = function(t5) {
                          var e4 = k.slice(2 * D, 2 * O[t5]).concat(z ? k.slice(2 * z) : []), r4 = (d4.hole || []).map(function(e5) {
                            return e5 - z + (O[t5] - D);
                          }), n3 = u(e4, r4);
                          n3 = n3.map(function(e5) {
                            return e5 + D + (e5 + D < O[t5] ? 0 : z - O[t5]);
                          }), I.push.apply(I, n3), D = O[t5] + 1;
                        }, B = 0; B < O.length; B++)
                          F(B);
                        for (var N = 0, j = I.length; N < j; N++)
                          null != A[I[N]] && (I[N] = A[I[N]]);
                        d4.triangles = I;
                      } else {
                        for (var U = u(k, d4.hole || []), V = 0, H = U.length; V < H; V++)
                          null != A[U[V]] && (U[V] = A[U[V]]);
                        d4.triangles = U;
                      }
                    }
                    var q2 = new Float64Array(m3);
                    c(q2, 2, T);
                    var G = new Float64Array(2 * x2 + 6);
                    d4.close ? m3[0] === m3[2 * x2 - 2] && m3[1] === m3[2 * x2 - 1] ? (G[0] = q2[2 * x2 - 4], G[1] = q2[2 * x2 - 3]) : (G[0] = q2[2 * x2 - 2], G[1] = q2[2 * x2 - 1]) : (G[0] = q2[0], G[1] = q2[1]), G.set(q2, 2), d4.close ? m3[0] === m3[2 * x2 - 2] && m3[1] === m3[2 * x2 - 1] ? (G[2 * x2 + 2] = q2[2], G[2 * x2 + 3] = q2[3], d4.count -= 1) : (G[2 * x2 + 2] = q2[0], G[2 * x2 + 3] = q2[1], G[2 * x2 + 4] = q2[2], G[2 * x2 + 5] = q2[3]) : (G[2 * x2 + 2] = q2[2 * x2 - 2], G[2 * x2 + 3] = q2[2 * x2 - 1], G[2 * x2 + 4] = q2[2 * x2 - 2], G[2 * x2 + 5] = q2[2 * x2 - 1]);
                    var Z = h(G);
                    d4.positionBuffer(Z);
                    var Y = p2(G, Z);
                    d4.positionFractBuffer(Y);
                  }
                  if (t4.range ? d4.range = t4.range : d4.range || (d4.range = d4.bounds), (t4.range || t4.positions) && d4.count) {
                    var W = d4.bounds, X = W[2] - W[0], J = W[3] - W[1], K = d4.range[2] - d4.range[0], $ = d4.range[3] - d4.range[1];
                    d4.scale = [X / K, J / $], d4.translate = [-d4.range[0] / K + W[0] / K || 0, -d4.range[1] / $ + W[1] / $ || 0], d4.scaleFract = p2(d4.scale), d4.translateFract = p2(d4.translate);
                  }
                  if (t4.dashes) {
                    var Q, tt = 0;
                    if (!t4.dashes || t4.dashes.length < 2)
                      tt = 1, Q = new Uint8Array([255, 255, 255, 255, 255, 255, 255, 255]);
                    else {
                      tt = 0;
                      for (var et = 0; et < t4.dashes.length; ++et)
                        tt += t4.dashes[et];
                      Q = new Uint8Array(tt * y.dashMult);
                      for (var rt = 0, nt = 255, it = 0; it < 2; it++)
                        for (var at = 0; at < t4.dashes.length; ++at) {
                          for (var ot = 0, st = t4.dashes[at] * y.dashMult * 0.5; ot < st; ++ot)
                            Q[rt++] = nt;
                          nt ^= 255;
                        }
                    }
                    d4.dashLength = tt, d4.dashTexture({ channels: 1, data: Q, width: Q.length, height: 1, mag: "linear", min: "linear" }, 0, 0);
                  }
                  if (t4.color) {
                    var lt = d4.count, ut = t4.color;
                    ut || (ut = "transparent");
                    var ct = new Uint8Array(4 * lt + 4);
                    if (Array.isArray(ut) && "number" != typeof ut[0]) {
                      for (var ft = 0; ft < lt; ft++) {
                        var ht = n2(ut[ft], "uint8");
                        ct.set(ht, 4 * ft);
                      }
                      ct.set(n2(ut[0], "uint8"), 4 * lt);
                    } else
                      for (var pt = n2(ut, "uint8"), dt = 0; dt < lt + 1; dt++)
                        ct.set(pt, 4 * dt);
                    d4.colorBuffer({ usage: "dynamic", type: "uint8", data: ct });
                  }
                } else
                  e3.passes[f4] = null;
            }), t3.length < this.passes.length) {
              for (var f3 = t3.length; f3 < this.passes.length; f3++) {
                var d3 = this.passes[f3];
                d3 && (d3.colorBuffer.destroy(), d3.positionBuffer.destroy(), d3.dashTexture.destroy());
              }
              this.passes.length = t3.length;
            }
            for (var m2 = [], x = 0; x < this.passes.length; x++)
              null !== this.passes[x] && m2.push(this.passes[x]);
            return this.passes = m2, this;
          }
        }, y.prototype.destroy = function() {
          return this.passes.forEach(function(t3) {
            t3.colorBuffer.destroy(), t3.positionBuffer.destroy(), t3.dashTexture.destroy();
          }), this.passes.length = 0, this;
        };
      }, 11870: function(t2, e2, r2) {
        function n2(t3, e3) {
          return function(t4) {
            if (Array.isArray(t4))
              return t4;
          }(t3) || function(t4, e4) {
            var r3 = null == t4 ? null : "undefined" != typeof Symbol && t4[Symbol.iterator] || t4["@@iterator"];
            if (null != r3) {
              var n3, i2, a2 = [], o2 = true, s2 = false;
              try {
                for (r3 = r3.call(t4); !(o2 = (n3 = r3.next()).done) && (a2.push(n3.value), !e4 || a2.length !== e4); o2 = true)
                  ;
              } catch (t5) {
                s2 = true, i2 = t5;
              } finally {
                try {
                  o2 || null == r3.return || r3.return();
                } finally {
                  if (s2)
                    throw i2;
                }
              }
              return a2;
            }
          }(t3, e3) || i(t3, e3) || function() {
            throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
          }();
        }
        function i(t3, e3) {
          if (t3) {
            if ("string" == typeof t3)
              return a(t3, e3);
            var r3 = Object.prototype.toString.call(t3).slice(8, -1);
            return "Object" === r3 && t3.constructor && (r3 = t3.constructor.name), "Map" === r3 || "Set" === r3 ? Array.from(t3) : "Arguments" === r3 || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r3) ? a(t3, e3) : void 0;
          }
        }
        function a(t3, e3) {
          (null == e3 || e3 > t3.length) && (e3 = t3.length);
          for (var r3 = 0, n3 = new Array(e3); r3 < e3; r3++)
            n3[r3] = t3[r3];
          return n3;
        }
        var o = r2(25075), s = r2(21527), l = r2(6475), u = r2(88294), c = r2(56131), f2 = r2(56068), h = r2(71299), p2 = r2(93447), d2 = r2(30120), v = r2(62683), g2 = r2(57060), y = r2(18863), m2 = x;
        function x(t3, e3) {
          var r3 = this;
          if (!(this instanceof x))
            return new x(t3, e3);
          "function" == typeof t3 ? (e3 || (e3 = {}), e3.regl = t3) : (e3 = t3, t3 = null), e3 && e3.length && (e3.positions = e3);
          var n3, i2 = (t3 = e3.regl)._gl, a2 = [];
          this.tooManyColors = v, n3 = t3.texture({ data: new Uint8Array(1020), width: 255, height: 1, type: "uint8", format: "rgba", wrapS: "clamp", wrapT: "clamp", mag: "nearest", min: "nearest" }), c(this, { regl: t3, gl: i2, groups: [], markerCache: [null], markerTextures: [null], palette: a2, paletteIds: {}, paletteTexture: n3, maxColors: 255, maxSize: 100, canvas: i2.canvas }), this.update(e3);
          var o2 = { uniforms: { constPointSize: !!e3.constPointSize, opacity: t3.prop("opacity"), paletteSize: function(t4, e4) {
            return [r3.tooManyColors ? 0 : 255, n3.height];
          }, pixelRatio: t3.context("pixelRatio"), scale: t3.prop("scale"), scaleFract: t3.prop("scaleFract"), translate: t3.prop("translate"), translateFract: t3.prop("translateFract"), markerTexture: t3.prop("markerTexture"), paletteTexture: n3 }, attributes: { x: function(t4, e4) {
            return e4.xAttr || { buffer: e4.positionBuffer, stride: 8, offset: 0 };
          }, y: function(t4, e4) {
            return e4.yAttr || { buffer: e4.positionBuffer, stride: 8, offset: 4 };
          }, xFract: function(t4, e4) {
            return e4.xAttr ? { constant: [0, 0] } : { buffer: e4.positionFractBuffer, stride: 8, offset: 0 };
          }, yFract: function(t4, e4) {
            return e4.yAttr ? { constant: [0, 0] } : { buffer: e4.positionFractBuffer, stride: 8, offset: 4 };
          }, size: function(t4, e4) {
            return e4.size.length ? { buffer: e4.sizeBuffer, stride: 2, offset: 0 } : { constant: [Math.round(255 * e4.size / r3.maxSize)] };
          }, borderSize: function(t4, e4) {
            return e4.borderSize.length ? { buffer: e4.sizeBuffer, stride: 2, offset: 1 } : { constant: [Math.round(255 * e4.borderSize / r3.maxSize)] };
          }, colorId: function(t4, e4) {
            return e4.color.length ? { buffer: e4.colorBuffer, stride: r3.tooManyColors ? 8 : 4, offset: 0 } : { constant: r3.tooManyColors ? a2.slice(4 * e4.color, 4 * e4.color + 4) : [e4.color] };
          }, borderColorId: function(t4, e4) {
            return e4.borderColor.length ? { buffer: e4.colorBuffer, stride: r3.tooManyColors ? 8 : 4, offset: r3.tooManyColors ? 4 : 2 } : { constant: r3.tooManyColors ? a2.slice(4 * e4.borderColor, 4 * e4.borderColor + 4) : [e4.borderColor] };
          }, isActive: function(t4, e4) {
            return true === e4.activation ? { constant: [1] } : e4.activation ? e4.activation : { constant: [0] };
          } }, blend: { enable: true, color: [0, 0, 0, 1], func: { srcRGB: "src alpha", dstRGB: "one minus src alpha", srcAlpha: "one minus dst alpha", dstAlpha: "one" } }, scissor: { enable: true, box: t3.prop("viewport") }, viewport: t3.prop("viewport"), stencil: { enable: false }, depth: { enable: false }, elements: t3.prop("elements"), count: t3.prop("count"), offset: t3.prop("offset"), primitive: "points" }, s2 = c({}, o2);
          s2.frag = f2(["precision highp float;\n#define GLSLIFY 1\n\nuniform float opacity;\nuniform sampler2D markerTexture;\n\nvarying vec4 fragColor, fragBorderColor;\nvarying float fragWidth, fragBorderColorLevel, fragColorLevel;\n\nfloat smoothStep(float x, float y) {\n  return 1.0 / (1.0 + exp(50.0*(x - y)));\n}\n\nvoid main() {\n  float dist = texture2D(markerTexture, gl_PointCoord).r, delta = fragWidth;\n\n  // max-distance alpha\n  if (dist < 0.003) discard;\n\n  // null-border case\n  if (fragBorderColorLevel == fragColorLevel || fragBorderColor.a == 0.) {\n    float colorAmt = smoothstep(.5 - delta, .5 + delta, dist);\n    gl_FragColor = vec4(fragColor.rgb, colorAmt * fragColor.a * opacity);\n  }\n  else {\n    float borderColorAmt = smoothstep(fragBorderColorLevel - delta, fragBorderColorLevel + delta, dist);\n    float colorAmt = smoothstep(fragColorLevel - delta, fragColorLevel + delta, dist);\n\n    vec4 color = fragBorderColor;\n    color.a *= borderColorAmt;\n    color = mix(color, fragColor, colorAmt);\n    color.a *= opacity;\n\n    gl_FragColor = color;\n  }\n\n}\n"]), s2.vert = f2(["precision highp float;\n#define GLSLIFY 1\n\nattribute float x, y, xFract, yFract;\nattribute float size, borderSize;\nattribute vec4 colorId, borderColorId;\nattribute float isActive;\n\nuniform bool constPointSize;\nuniform float pixelRatio;\nuniform vec2 scale, scaleFract, translate, translateFract, paletteSize;\nuniform sampler2D paletteTexture;\n\nconst float maxSize = 100.;\nconst float borderLevel = .5;\n\nvarying vec4 fragColor, fragBorderColor;\nvarying float fragPointSize, fragBorderRadius, fragWidth, fragBorderColorLevel, fragColorLevel;\n\nfloat pointSizeScale = (constPointSize) ? 2. : pixelRatio;\n\nbool isDirect = (paletteSize.x < 1.);\n\nvec4 getColor(vec4 id) {\n  return isDirect ? id / 255. : texture2D(paletteTexture,\n    vec2(\n      (id.x + .5) / paletteSize.x,\n      (id.y + .5) / paletteSize.y\n    )\n  );\n}\n\nvoid main() {\n  // ignore inactive points\n  if (isActive == 0.) return;\n\n  vec2 position = vec2(x, y);\n  vec2 positionFract = vec2(xFract, yFract);\n\n  vec4 color = getColor(colorId);\n  vec4 borderColor = getColor(borderColorId);\n\n  float size = size * maxSize / 255.;\n  float borderSize = borderSize * maxSize / 255.;\n\n  gl_PointSize = 2. * size * pointSizeScale;\n  fragPointSize = size * pixelRatio;\n\n  vec2 pos = (position + translate) * scale\n      + (positionFract + translateFract) * scale\n      + (position + translate) * scaleFract\n      + (positionFract + translateFract) * scaleFract;\n\n  gl_Position = vec4(pos * 2. - 1., 0., 1.);\n\n  fragColor = color;\n  fragBorderColor = borderColor;\n  fragWidth = 1. / gl_PointSize;\n\n  fragBorderColorLevel = clamp(borderLevel - borderLevel * borderSize / size, 0., 1.);\n  fragColorLevel = clamp(borderLevel + (1. - borderLevel) * borderSize / size, 0., 1.);\n}"]), this.drawMarker = t3(s2);
          var l2 = c({}, o2);
          l2.frag = f2(["precision highp float;\n#define GLSLIFY 1\n\nvarying vec4 fragColor, fragBorderColor;\nvarying float fragBorderRadius, fragWidth;\n\nuniform float opacity;\n\nfloat smoothStep(float edge0, float edge1, float x) {\n	float t;\n	t = clamp((x - edge0) / (edge1 - edge0), 0.0, 1.0);\n	return t * t * (3.0 - 2.0 * t);\n}\n\nvoid main() {\n	float radius, alpha = 1.0, delta = fragWidth;\n\n	radius = length(2.0 * gl_PointCoord.xy - 1.0);\n\n	if (radius > 1.0 + delta) {\n		discard;\n	}\n\n	alpha -= smoothstep(1.0 - delta, 1.0 + delta, radius);\n\n	float borderRadius = fragBorderRadius;\n	float ratio = smoothstep(borderRadius - delta, borderRadius + delta, radius);\n	vec4 color = mix(fragColor, fragBorderColor, ratio);\n	color.a *= alpha * opacity;\n	gl_FragColor = color;\n}\n"]), l2.vert = f2(["precision highp float;\n#define GLSLIFY 1\n\nattribute float x, y, xFract, yFract;\nattribute float size, borderSize;\nattribute vec4 colorId, borderColorId;\nattribute float isActive;\n\nuniform bool constPointSize;\nuniform float pixelRatio;\nuniform vec2 paletteSize, scale, scaleFract, translate, translateFract;\nuniform sampler2D paletteTexture;\n\nconst float maxSize = 100.;\n\nvarying vec4 fragColor, fragBorderColor;\nvarying float fragBorderRadius, fragWidth;\n\nfloat pointSizeScale = (constPointSize) ? 2. : pixelRatio;\n\nbool isDirect = (paletteSize.x < 1.);\n\nvec4 getColor(vec4 id) {\n  return isDirect ? id / 255. : texture2D(paletteTexture,\n    vec2(\n      (id.x + .5) / paletteSize.x,\n      (id.y + .5) / paletteSize.y\n    )\n  );\n}\n\nvoid main() {\n  // ignore inactive points\n  if (isActive == 0.) return;\n\n  vec2 position = vec2(x, y);\n  vec2 positionFract = vec2(xFract, yFract);\n\n  vec4 color = getColor(colorId);\n  vec4 borderColor = getColor(borderColorId);\n\n  float size = size * maxSize / 255.;\n  float borderSize = borderSize * maxSize / 255.;\n\n  gl_PointSize = (size + borderSize) * pointSizeScale;\n\n  vec2 pos = (position + translate) * scale\n      + (positionFract + translateFract) * scale\n      + (position + translate) * scaleFract\n      + (positionFract + translateFract) * scaleFract;\n\n  gl_Position = vec4(pos * 2. - 1., 0., 1.);\n\n  fragBorderRadius = 1. - 2. * borderSize / (size + borderSize);\n  fragColor = color;\n  fragBorderColor = borderColor.a == 0. || borderSize == 0. ? vec4(color.rgb, 0.) : borderColor;\n  fragWidth = 1. / gl_PointSize;\n}\n"]), v && (l2.frag = l2.frag.replace("smoothstep", "smoothStep"), s2.frag = s2.frag.replace("smoothstep", "smoothStep")), this.drawCircle = t3(l2);
        }
        x.defaults = { color: "black", borderColor: "transparent", borderSize: 0, size: 12, opacity: 1, marker: void 0, viewport: null, range: null, pixelSize: null, count: 0, offset: 0, bounds: null, positions: [], snap: 1e4 }, x.prototype.render = function() {
          return arguments.length && this.update.apply(this, arguments), this.draw(), this;
        }, x.prototype.draw = function() {
          for (var t3 = this, e3 = arguments.length, r3 = new Array(e3), n3 = 0; n3 < e3; n3++)
            r3[n3] = arguments[n3];
          var i2 = this.groups;
          if (1 === r3.length && Array.isArray(r3[0]) && (null === r3[0][0] || Array.isArray(r3[0][0])) && (r3 = r3[0]), this.regl._refresh(), r3.length)
            for (var a2 = 0; a2 < r3.length; a2++)
              this.drawItem(a2, r3[a2]);
          else
            i2.forEach(function(e4, r4) {
              t3.drawItem(r4);
            });
          return this;
        }, x.prototype.drawItem = function(t3, e3) {
          var r3, n3 = this.groups, o2 = n3[t3];
          if ("number" == typeof e3 && (t3 = e3, o2 = n3[e3], e3 = null), o2 && o2.count && o2.opacity) {
            o2.activation[0] && this.drawCircle(this.getMarkerDrawOptions(0, o2, e3));
            for (var s2 = [], l2 = 1; l2 < o2.activation.length; l2++)
              o2.activation[l2] && (true === o2.activation[l2] || o2.activation[l2].data.length) && s2.push.apply(s2, function(t4) {
                if (Array.isArray(t4))
                  return a(t4);
              }(r3 = this.getMarkerDrawOptions(l2, o2, e3)) || function(t4) {
                if ("undefined" != typeof Symbol && null != t4[Symbol.iterator] || null != t4["@@iterator"])
                  return Array.from(t4);
              }(r3) || i(r3) || function() {
                throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
              }());
            s2.length && this.drawMarker(s2);
          }
        }, x.prototype.getMarkerDrawOptions = function(t3, e3, r3) {
          var i2 = e3.range, a2 = e3.tree, o2 = e3.viewport, s2 = e3.activation, l2 = e3.selectionBuffer, u2 = e3.count;
          if (this.regl, !a2)
            return r3 ? [c({}, e3, { markerTexture: this.markerTextures[t3], activation: s2[t3], count: r3.length, elements: r3, offset: 0 })] : [c({}, e3, { markerTexture: this.markerTextures[t3], activation: s2[t3], offset: 0 })];
          var f3 = [], h2 = a2.range(i2, { lod: true, px: [(i2[2] - i2[0]) / o2.width, (i2[3] - i2[1]) / o2.height] });
          if (r3) {
            for (var p3 = s2[t3].data, d3 = new Uint8Array(u2), v2 = 0; v2 < r3.length; v2++) {
              var g3 = r3[v2];
              d3[g3] = p3 ? p3[g3] : 1;
            }
            l2.subdata(d3);
          }
          for (var y2 = h2.length; y2--; ) {
            var m3 = n2(h2[y2], 2), x2 = m3[0], b2 = m3[1];
            f3.push(c({}, e3, { markerTexture: this.markerTextures[t3], activation: r3 ? l2 : s2[t3], offset: x2, count: b2 - x2 }));
          }
          return f3;
        }, x.prototype.update = function() {
          for (var t3 = this, e3 = arguments.length, r3 = new Array(e3), n3 = 0; n3 < e3; n3++)
            r3[n3] = arguments[n3];
          if (r3.length) {
            1 === r3.length && Array.isArray(r3[0]) && (r3 = r3[0]);
            var i2 = this.groups, a2 = this.gl, o2 = this.regl, l2 = this.maxSize, f3 = this.maxColors, v2 = this.palette;
            this.groups = i2 = r3.map(function(e4, r4) {
              var n4 = i2[r4];
              if (void 0 === e4)
                return n4;
              null === e4 ? e4 = { positions: null } : "function" == typeof e4 ? e4 = { ondraw: e4 } : "number" == typeof e4[0] && (e4 = { positions: e4 }), null === (e4 = h(e4, { positions: "positions data points", snap: "snap cluster lod tree", size: "sizes size radius", borderSize: "borderSizes borderSize border-size bordersize borderWidth borderWidths border-width borderwidth stroke-width strokeWidth strokewidth outline", color: "colors color fill fill-color fillColor", borderColor: "borderColors borderColor stroke stroke-color strokeColor", marker: "markers marker shape", range: "range dataBox databox", viewport: "viewport viewPort viewBox viewbox", opacity: "opacity alpha transparency", bounds: "bound bounds boundaries limits", tooManyColors: "tooManyColors palette paletteMode optimizePalette enablePalette" })).positions && (e4.positions = []), null != e4.tooManyColors && (t3.tooManyColors = e4.tooManyColors), n4 || (i2[r4] = n4 = { id: r4, scale: null, translate: null, scaleFract: null, translateFract: null, activation: [], selectionBuffer: o2.buffer({ data: new Uint8Array(0), usage: "stream", type: "uint8" }), sizeBuffer: o2.buffer({ data: new Uint8Array(0), usage: "dynamic", type: "uint8" }), colorBuffer: o2.buffer({ data: new Uint8Array(0), usage: "dynamic", type: "uint8" }), positionBuffer: o2.buffer({ data: new Uint8Array(0), usage: "dynamic", type: "float" }), positionFractBuffer: o2.buffer({ data: new Uint8Array(0), usage: "dynamic", type: "float" }) }, e4 = c({}, x.defaults, e4)), e4.positions && !("marker" in e4) && (e4.marker = n4.marker, delete n4.marker), e4.marker && !("positions" in e4) && (e4.positions = n4.positions, delete n4.positions);
              var m3 = 0, b2 = 0;
              if (p2(n4, e4, [{ snap: true, size: function(t4, e5) {
                return null == t4 && (t4 = x.defaults.size), m3 += t4 && t4.length ? 1 : 0, t4;
              }, borderSize: function(t4, e5) {
                return null == t4 && (t4 = x.defaults.borderSize), m3 += t4 && t4.length ? 1 : 0, t4;
              }, opacity: parseFloat, color: function(e5, r5) {
                return null == e5 && (e5 = x.defaults.color), e5 = t3.updateColor(e5), b2++, e5;
              }, borderColor: function(e5, r5) {
                return null == e5 && (e5 = x.defaults.borderColor), e5 = t3.updateColor(e5), b2++, e5;
              }, bounds: function(t4, e5, r5) {
                return "range" in r5 || (r5.range = null), t4;
              }, positions: function(t4, e5, r5) {
                var n5 = e5.snap, i3 = e5.positionBuffer, a3 = e5.positionFractBuffer, l3 = e5.selectionBuffer;
                if (t4.x || t4.y)
                  return t4.x.length ? e5.xAttr = { buffer: o2.buffer(t4.x), offset: 0, stride: 4, count: t4.x.length } : e5.xAttr = { buffer: t4.x.buffer, offset: 4 * t4.x.offset || 0, stride: 4 * (t4.x.stride || 1), count: t4.x.count }, t4.y.length ? e5.yAttr = { buffer: o2.buffer(t4.y), offset: 0, stride: 4, count: t4.y.length } : e5.yAttr = { buffer: t4.y.buffer, offset: 4 * t4.y.offset || 0, stride: 4 * (t4.y.stride || 1), count: t4.y.count }, e5.count = Math.max(e5.xAttr.count, e5.yAttr.count), t4;
                t4 = d2(t4, "float64");
                var c2 = e5.count = Math.floor(t4.length / 2), f4 = e5.bounds = c2 ? s(t4, 2) : null;
                if (r5.range || e5.range || (delete e5.range, r5.range = f4), r5.marker || e5.marker || (delete e5.marker, r5.marker = null), n5 && (true === n5 || c2 > n5) ? e5.tree = u(t4, { bounds: f4 }) : n5 && n5.length && (e5.tree = n5), e5.tree) {
                  var h2 = { primitive: "points", usage: "static", data: e5.tree, type: "uint32" };
                  e5.elements ? e5.elements(h2) : e5.elements = o2.elements(h2);
                }
                var p3 = g2.float32(t4);
                return i3({ data: p3, usage: "dynamic" }), a3({ data: g2.fract32(t4, p3), usage: "dynamic" }), l3({ data: new Uint8Array(c2), type: "uint8", usage: "stream" }), t4;
              } }, { marker: function(e5, r5, n5) {
                var i3 = r5.activation;
                if (i3.forEach(function(t4) {
                  return t4 && t4.destroy && t4.destroy();
                }), i3.length = 0, e5 && "number" != typeof e5[0]) {
                  for (var a3 = [], s2 = 0, l3 = Math.min(e5.length, r5.count); s2 < l3; s2++) {
                    var u2 = t3.addMarker(e5[s2]);
                    a3[u2] || (a3[u2] = new Uint8Array(r5.count)), a3[u2][s2] = 1;
                  }
                  for (var c2 = 0; c2 < a3.length; c2++)
                    if (a3[c2]) {
                      var f4 = { data: a3[c2], type: "uint8", usage: "static" };
                      i3[c2] ? i3[c2](f4) : i3[c2] = o2.buffer(f4), i3[c2].data = a3[c2];
                    }
                } else
                  i3[t3.addMarker(e5)] = true;
                return e5;
              }, range: function(t4, e5, r5) {
                var n5 = e5.bounds;
                if (n5)
                  return t4 || (t4 = n5), e5.scale = [1 / (t4[2] - t4[0]), 1 / (t4[3] - t4[1])], e5.translate = [-t4[0], -t4[1]], e5.scaleFract = g2.fract(e5.scale), e5.translateFract = g2.fract(e5.translate), t4;
              }, viewport: function(t4) {
                return y(t4 || [a2.drawingBufferWidth, a2.drawingBufferHeight]);
              } }]), m3) {
                var _ = n4, w2 = _.count, T = _.size, k = _.borderSize, A = _.sizeBuffer, M = new Uint8Array(2 * w2);
                if (T.length || k.length)
                  for (var S = 0; S < w2; S++)
                    M[2 * S] = Math.round(255 * (null == T[S] ? T : T[S]) / l2), M[2 * S + 1] = Math.round(255 * (null == k[S] ? k : k[S]) / l2);
                A({ data: M, usage: "dynamic" });
              }
              if (b2) {
                var E, L = n4, C = L.count, P = L.color, O = L.borderColor, I = L.colorBuffer;
                if (t3.tooManyColors) {
                  if (P.length || O.length) {
                    E = new Uint8Array(8 * C);
                    for (var D = 0; D < C; D++) {
                      var z = P[D];
                      E[8 * D] = v2[4 * z], E[8 * D + 1] = v2[4 * z + 1], E[8 * D + 2] = v2[4 * z + 2], E[8 * D + 3] = v2[4 * z + 3];
                      var R = O[D];
                      E[8 * D + 4] = v2[4 * R], E[8 * D + 5] = v2[4 * R + 1], E[8 * D + 6] = v2[4 * R + 2], E[8 * D + 7] = v2[4 * R + 3];
                    }
                  }
                } else if (P.length || O.length) {
                  E = new Uint8Array(4 * C + 2);
                  for (var F = 0; F < C; F++)
                    null != P[F] && (E[4 * F] = P[F] % f3, E[4 * F + 1] = Math.floor(P[F] / f3)), null != O[F] && (E[4 * F + 2] = O[F] % f3, E[4 * F + 3] = Math.floor(O[F] / f3));
                }
                I({ data: E || new Uint8Array(0), type: "uint8", usage: "dynamic" });
              }
              return n4;
            });
          }
        }, x.prototype.addMarker = function(t3) {
          var e3, r3 = this.markerTextures, n3 = this.regl, i2 = this.markerCache, a2 = null == t3 ? 0 : i2.indexOf(t3);
          if (a2 >= 0)
            return a2;
          if (t3 instanceof Uint8Array || t3 instanceof Uint8ClampedArray)
            e3 = t3;
          else {
            e3 = new Uint8Array(t3.length);
            for (var o2 = 0, s2 = t3.length; o2 < s2; o2++)
              e3[o2] = 255 * t3[o2];
          }
          var l2 = Math.floor(Math.sqrt(e3.length));
          return a2 = r3.length, i2.push(t3), r3.push(n3.texture({ channels: 1, data: e3, radius: l2, mag: "linear", min: "linear" })), a2;
        }, x.prototype.updateColor = function(t3) {
          var e3 = this.paletteIds, r3 = this.palette, n3 = this.maxColors;
          Array.isArray(t3) || (t3 = [t3]);
          var i2 = [];
          if ("number" == typeof t3[0]) {
            var a2 = [];
            if (Array.isArray(t3))
              for (var s2 = 0; s2 < t3.length; s2 += 4)
                a2.push(t3.slice(s2, s2 + 4));
            else
              for (var u2 = 0; u2 < t3.length; u2 += 4)
                a2.push(t3.subarray(u2, u2 + 4));
            t3 = a2;
          }
          for (var c2 = 0; c2 < t3.length; c2++) {
            var f3 = t3[c2];
            f3 = o(f3, "uint8");
            var h2 = l(f3, false);
            if (null == e3[h2]) {
              var p3 = r3.length;
              e3[h2] = Math.floor(p3 / 4), r3[p3] = f3[0], r3[p3 + 1] = f3[1], r3[p3 + 2] = f3[2], r3[p3 + 3] = f3[3];
            }
            i2[c2] = e3[h2];
          }
          return !this.tooManyColors && r3.length > 4 * n3 && (this.tooManyColors = true), this.updatePalette(r3), 1 === i2.length ? i2[0] : i2;
        }, x.prototype.updatePalette = function(t3) {
          if (!this.tooManyColors) {
            var e3 = this.maxColors, r3 = this.paletteTexture, n3 = Math.ceil(0.25 * t3.length / e3);
            if (n3 > 1)
              for (var i2 = 0.25 * (t3 = t3.slice()).length % e3; i2 < n3 * e3; i2++)
                t3.push(0, 0, 0, 0);
            r3.height < n3 && r3.resize(e3, n3), r3.subimage({ width: Math.min(0.25 * t3.length, e3), height: n3, data: t3 }, 0, 0);
          }
        }, x.prototype.destroy = function() {
          return this.groups.forEach(function(t3) {
            t3.sizeBuffer.destroy(), t3.positionBuffer.destroy(), t3.positionFractBuffer.destroy(), t3.colorBuffer.destroy(), t3.activation.forEach(function(t4) {
              return t4 && t4.destroy && t4.destroy();
            }), t3.selectionBuffer.destroy(), t3.elements && t3.elements.destroy();
          }), this.groups.length = 0, this.paletteTexture.destroy(), this.markerTextures.forEach(function(t3) {
            return t3 && t3.destroy && t3.destroy();
          }), this;
        };
        var b = r2(56131);
        t2.exports = function(t3, e3) {
          var r3 = new m2(t3, e3), n3 = r3.render.bind(r3);
          return b(n3, { render: n3, update: r3.update.bind(r3), draw: r3.draw.bind(r3), destroy: r3.destroy.bind(r3), regl: r3.regl, gl: r3.gl, canvas: r3.gl.canvas, groups: r3.groups, markers: r3.markerCache, palette: r3.palette }), n3;
        };
      }, 60487: function(t2, e2, r2) {
        var n2 = r2(11870), i = r2(71299), a = r2(21527), o = r2(5877), s = r2(57471), l = r2(18863), u = r2(30120);
        function c(t3, e3) {
          if (!(this instanceof c))
            return new c(t3);
          this.traces = [], this.passes = {}, this.regl = t3, this.scatter = n2(t3), this.canvas = this.scatter.canvas;
        }
        function f2(t3, e3, r3) {
          return (null != t3.id ? t3.id : t3) << 16 | (255 & e3) << 8 | 255 & r3;
        }
        function h(t3, e3, r3) {
          var n3, i2, a2, o2, s2 = t3[e3], l2 = t3[r3];
          return s2.length > 2 ? (s2[0], s2[2], n3 = s2[1], i2 = s2[3]) : s2.length ? (n3 = s2[0], i2 = s2[1]) : (s2.x, n3 = s2.y, s2.x, s2.width, i2 = s2.y + s2.height), l2.length > 2 ? (a2 = l2[0], o2 = l2[2], l2[1], l2[3]) : l2.length ? (a2 = l2[0], o2 = l2[1]) : (a2 = l2.x, l2.y, o2 = l2.x + l2.width, l2.y, l2.height), [a2, n3, o2, i2];
        }
        function p2(t3) {
          if ("number" == typeof t3)
            return [t3, t3, t3, t3];
          if (2 === t3.length)
            return [t3[0], t3[1], t3[0], t3[1]];
          var e3 = l(t3);
          return [e3.x, e3.y, e3.x + e3.width, e3.y + e3.height];
        }
        t2.exports = c, c.prototype.render = function() {
          for (var t3, e3 = this, r3 = [], n3 = arguments.length; n3--; )
            r3[n3] = arguments[n3];
          return r3.length && (t3 = this).update.apply(t3, r3), this.regl.attributes.preserveDrawingBuffer ? this.draw() : (this.dirty ? null == this.planned && (this.planned = o(function() {
            e3.draw(), e3.dirty = true, e3.planned = null;
          })) : (this.draw(), this.dirty = true, o(function() {
            e3.dirty = false;
          })), this);
        }, c.prototype.update = function() {
          for (var t3, e3 = [], r3 = arguments.length; r3--; )
            e3[r3] = arguments[r3];
          if (e3.length) {
            for (var n3 = 0; n3 < e3.length; n3++)
              this.updateItem(n3, e3[n3]);
            this.traces = this.traces.filter(Boolean);
            for (var i2 = [], a2 = 0, o2 = 0; o2 < this.traces.length; o2++) {
              for (var s2 = this.traces[o2], l2 = this.traces[o2].passes, u2 = 0; u2 < l2.length; u2++)
                i2.push(this.passes[l2[u2]]);
              s2.passOffset = a2, a2 += s2.passes.length;
            }
            return (t3 = this.scatter).update.apply(t3, i2), this;
          }
        }, c.prototype.updateItem = function(t3, e3) {
          var r3 = this.regl;
          if (null === e3)
            return this.traces[t3] = null, this;
          if (!e3)
            return this;
          var n3, o2 = i(e3, { data: "data items columns rows values dimensions samples x", snap: "snap cluster", size: "sizes size radius", color: "colors color fill fill-color fillColor", opacity: "opacity alpha transparency opaque", borderSize: "borderSizes borderSize border-size bordersize borderWidth borderWidths border-width borderwidth stroke-width strokeWidth strokewidth outline", borderColor: "borderColors borderColor bordercolor stroke stroke-color strokeColor", marker: "markers marker shape", range: "range ranges databox dataBox", viewport: "viewport viewBox viewbox", domain: "domain domains area areas", padding: "pad padding paddings pads margin margins", transpose: "transpose transposed", diagonal: "diagonal diag showDiagonal", upper: "upper up top upperhalf upperHalf showupperhalf showUpper showUpperHalf", lower: "lower low bottom lowerhalf lowerHalf showlowerhalf showLowerHalf showLower" }), s2 = this.traces[t3] || (this.traces[t3] = { id: t3, buffer: r3.buffer({ usage: "dynamic", type: "float", data: new Uint8Array() }), color: "black", marker: null, size: 12, borderColor: "transparent", borderSize: 1, viewport: l([r3._gl.drawingBufferWidth, r3._gl.drawingBufferHeight]), padding: [0, 0, 0, 0], opacity: 1, diagonal: true, upper: true, lower: true });
          if (null != o2.color && (s2.color = o2.color), null != o2.size && (s2.size = o2.size), null != o2.marker && (s2.marker = o2.marker), null != o2.borderColor && (s2.borderColor = o2.borderColor), null != o2.borderSize && (s2.borderSize = o2.borderSize), null != o2.opacity && (s2.opacity = o2.opacity), o2.viewport && (s2.viewport = l(o2.viewport)), null != o2.diagonal && (s2.diagonal = o2.diagonal), null != o2.upper && (s2.upper = o2.upper), null != o2.lower && (s2.lower = o2.lower), o2.data) {
            s2.buffer(u(o2.data)), s2.columns = o2.data.length, s2.count = o2.data[0].length, s2.bounds = [];
            for (var c2 = 0; c2 < s2.columns; c2++)
              s2.bounds[c2] = a(o2.data[c2], 1);
          }
          o2.range && (s2.range = o2.range, n3 = s2.range && "number" != typeof s2.range[0]), o2.domain && (s2.domain = o2.domain);
          var d2 = false;
          null != o2.padding && (Array.isArray(o2.padding) && o2.padding.length === s2.columns && "number" == typeof o2.padding[o2.padding.length - 1] ? (s2.padding = o2.padding.map(p2), d2 = true) : s2.padding = p2(o2.padding));
          var v = s2.columns, g2 = s2.count, y = s2.viewport.width, m2 = s2.viewport.height, x = s2.viewport.x, b = s2.viewport.y, _ = y / v, w2 = m2 / v;
          s2.passes = [];
          for (var T = 0; T < v; T++)
            for (var k = 0; k < v; k++)
              if ((s2.diagonal || k !== T) && (s2.upper || !(T > k)) && (s2.lower || !(T < k))) {
                var A = f2(s2.id, T, k), M = this.passes[A] || (this.passes[A] = {});
                if (o2.data && (o2.transpose ? M.positions = { x: { buffer: s2.buffer, offset: k, count: g2, stride: v }, y: { buffer: s2.buffer, offset: T, count: g2, stride: v } } : M.positions = { x: { buffer: s2.buffer, offset: k * g2, count: g2 }, y: { buffer: s2.buffer, offset: T * g2, count: g2 } }, M.bounds = h(s2.bounds, T, k)), o2.domain || o2.viewport || o2.data) {
                  var S = d2 ? h(s2.padding, T, k) : s2.padding;
                  if (s2.domain) {
                    var E = h(s2.domain, T, k), L = E[0], C = E[1], P = E[2], O = E[3];
                    M.viewport = [x + L * y + S[0], b + C * m2 + S[1], x + P * y - S[2], b + O * m2 - S[3]];
                  } else
                    M.viewport = [x + k * _ + _ * S[0], b + T * w2 + w2 * S[1], x + (k + 1) * _ - _ * S[2], b + (T + 1) * w2 - w2 * S[3]];
                }
                o2.color && (M.color = s2.color), o2.size && (M.size = s2.size), o2.marker && (M.marker = s2.marker), o2.borderSize && (M.borderSize = s2.borderSize), o2.borderColor && (M.borderColor = s2.borderColor), o2.opacity && (M.opacity = s2.opacity), o2.range && (M.range = n3 ? h(s2.range, T, k) : s2.range || M.bounds), s2.passes.push(A);
              }
          return this;
        }, c.prototype.draw = function() {
          for (var t3, e3 = [], r3 = arguments.length; r3--; )
            e3[r3] = arguments[r3];
          if (e3.length) {
            for (var n3 = [], i2 = 0; i2 < e3.length; i2++)
              if ("number" == typeof e3[i2]) {
                var a2 = this.traces[e3[i2]], o2 = a2.passes, l2 = a2.passOffset;
                n3.push.apply(n3, s(l2, l2 + o2.length));
              } else if (e3[i2].length) {
                var u2 = e3[i2], c2 = this.traces[i2], f3 = c2.passes, h2 = c2.passOffset;
                f3 = f3.map(function(t4, e4) {
                  n3[h2 + e4] = u2;
                });
              }
            (t3 = this.scatter).draw.apply(t3, n3);
          } else
            this.scatter.draw();
          return this;
        }, c.prototype.destroy = function() {
          return this.traces.forEach(function(t3) {
            t3.buffer && t3.buffer.destroy && t3.buffer.destroy();
          }), this.traces = null, this.passes = null, this.scatter.destroy(), this;
        };
      }, 98580: function(t2) {
        t2.exports = function() {
          function t3(t4, e3) {
            this.id = Z++, this.type = t4, this.data = e3;
          }
          function e2(t4) {
            if (0 === t4.length)
              return [];
            var r3 = t4.charAt(0), n3 = t4.charAt(t4.length - 1);
            if (1 < t4.length && r3 === n3 && ('"' === r3 || "'" === r3))
              return ['"' + t4.substr(1, t4.length - 2).replace(/\\/g, "\\\\").replace(/"/g, '\\"') + '"'];
            if (r3 = /\[(false|true|null|\d+|'[^']*'|"[^"]*")\]/.exec(t4))
              return e2(t4.substr(0, r3.index)).concat(e2(r3[1])).concat(e2(t4.substr(r3.index + r3[0].length)));
            if (1 === (r3 = t4.split(".")).length)
              return ['"' + t4.replace(/\\/g, "\\\\").replace(/"/g, '\\"') + '"'];
            for (t4 = [], n3 = 0; n3 < r3.length; ++n3)
              t4 = t4.concat(e2(r3[n3]));
            return t4;
          }
          function r2(t4) {
            return "[" + e2(t4).join("][") + "]";
          }
          function n2(t4) {
            return "string" == typeof t4 ? t4.split() : t4;
          }
          function i(t4) {
            return "string" == typeof t4 ? document.querySelector(t4) : t4;
          }
          function a(t4) {
            var e3, r3, a2, o2, s2 = t4 || {};
            t4 = {};
            var l2 = [], u2 = [], c2 = "undefined" == typeof window ? 1 : window.devicePixelRatio, f3 = false, h2 = {}, p3 = function(t5) {
            }, d3 = function() {
            };
            if ("string" == typeof s2 ? e3 = document.querySelector(s2) : "object" == typeof s2 && ("string" == typeof s2.nodeName && "function" == typeof s2.appendChild && "function" == typeof s2.getBoundingClientRect ? e3 = s2 : "function" == typeof s2.drawArrays || "function" == typeof s2.drawElements ? a2 = (o2 = s2).canvas : ("gl" in s2 ? o2 = s2.gl : "canvas" in s2 ? a2 = i(s2.canvas) : "container" in s2 && (r3 = i(s2.container)), "attributes" in s2 && (t4 = s2.attributes), "extensions" in s2 && (l2 = n2(s2.extensions)), "optionalExtensions" in s2 && (u2 = n2(s2.optionalExtensions)), "onDone" in s2 && (p3 = s2.onDone), "profile" in s2 && (f3 = !!s2.profile), "pixelRatio" in s2 && (c2 = +s2.pixelRatio), "cachedCode" in s2 && (h2 = s2.cachedCode))), e3 && ("canvas" === e3.nodeName.toLowerCase() ? a2 = e3 : r3 = e3), !o2) {
              if (!a2) {
                if (!(e3 = function(t5, e4, r4) {
                  function n3() {
                    var e5 = window.innerWidth, n4 = window.innerHeight;
                    t5 !== document.body && (e5 = (n4 = a3.getBoundingClientRect()).right - n4.left, n4 = n4.bottom - n4.top), a3.width = r4 * e5, a3.height = r4 * n4;
                  }
                  var i2, a3 = document.createElement("canvas");
                  return G(a3.style, { border: 0, margin: 0, padding: 0, top: 0, left: 0, width: "100%", height: "100%" }), t5.appendChild(a3), t5 === document.body && (a3.style.position = "absolute", G(t5.style, { margin: 0, padding: 0 })), t5 !== document.body && "function" == typeof ResizeObserver ? (i2 = new ResizeObserver(function() {
                    setTimeout(n3);
                  })).observe(t5) : window.addEventListener("resize", n3, false), n3(), { canvas: a3, onDestroy: function() {
                    i2 ? i2.disconnect() : window.removeEventListener("resize", n3), t5.removeChild(a3);
                  } };
                }(r3 || document.body, 0, c2)))
                  return null;
                a2 = e3.canvas, d3 = e3.onDestroy;
              }
              void 0 === t4.premultipliedAlpha && (t4.premultipliedAlpha = true), o2 = function(t5, e4) {
                function r4(r5) {
                  try {
                    return t5.getContext(r5, e4);
                  } catch (t6) {
                    return null;
                  }
                }
                return r4("webgl") || r4("experimental-webgl") || r4("webgl-experimental");
              }(a2, t4);
            }
            return o2 ? { gl: o2, canvas: a2, container: r3, extensions: l2, optionalExtensions: u2, pixelRatio: c2, profile: f3, cachedCode: h2, onDone: p3, onDestroy: d3 } : (d3(), p3("webgl not supported, try upgrading your browser or graphics drivers http://get.webgl.org"), null);
          }
          function o(t4, e3) {
            for (var r3 = Array(t4), n3 = 0; n3 < t4; ++n3)
              r3[n3] = e3(n3);
            return r3;
          }
          function s(t4) {
            var e3, r3;
            return e3 = (65535 < t4) << 4, e3 |= r3 = (255 < (t4 >>>= e3)) << 3, (e3 |= r3 = (15 < (t4 >>>= r3)) << 2) | (r3 = (3 < (t4 >>>= r3)) << 1) | t4 >>> r3 >> 1;
          }
          function l() {
            function t4(t5) {
              t: {
                for (var e4 = 16; 268435456 >= e4; e4 *= 16)
                  if (t5 <= e4) {
                    t5 = e4;
                    break t;
                  }
                t5 = 0;
              }
              return 0 < (e4 = r3[s(t5) >> 2]).length ? e4.pop() : new ArrayBuffer(t5);
            }
            function e3(t5) {
              r3[s(t5.byteLength) >> 2].push(t5);
            }
            var r3 = o(8, function() {
              return [];
            });
            return { alloc: t4, free: e3, allocType: function(e4, r4) {
              var n3 = null;
              switch (e4) {
                case 5120:
                  n3 = new Int8Array(t4(r4), 0, r4);
                  break;
                case 5121:
                  n3 = new Uint8Array(t4(r4), 0, r4);
                  break;
                case 5122:
                  n3 = new Int16Array(t4(2 * r4), 0, r4);
                  break;
                case 5123:
                  n3 = new Uint16Array(t4(2 * r4), 0, r4);
                  break;
                case 5124:
                  n3 = new Int32Array(t4(4 * r4), 0, r4);
                  break;
                case 5125:
                  n3 = new Uint32Array(t4(4 * r4), 0, r4);
                  break;
                case 5126:
                  n3 = new Float32Array(t4(4 * r4), 0, r4);
                  break;
                default:
                  return null;
              }
              return n3.length !== r4 ? n3.subarray(0, r4) : n3;
            }, freeType: function(t5) {
              e3(t5.buffer);
            } };
          }
          function u(t4) {
            return !!t4 && "object" == typeof t4 && Array.isArray(t4.shape) && Array.isArray(t4.stride) && "number" == typeof t4.offset && t4.shape.length === t4.stride.length && (Array.isArray(t4.data) || $(t4.data));
          }
          function c(t4, e3, r3, n3, i2, a2) {
            for (var o2 = 0; o2 < e3; ++o2)
              for (var s2 = t4[o2], l2 = 0; l2 < r3; ++l2)
                for (var u2 = s2[l2], c2 = 0; c2 < n3; ++c2)
                  i2[a2++] = u2[c2];
          }
          function f2(t4, e3, r3, n3, i2) {
            for (var a2 = 1, o2 = r3 + 1; o2 < e3.length; ++o2)
              a2 *= e3[o2];
            var s2 = e3[r3];
            if (4 == e3.length - r3) {
              var l2 = e3[r3 + 1], u2 = e3[r3 + 2];
              for (e3 = e3[r3 + 3], o2 = 0; o2 < s2; ++o2)
                c(t4[o2], l2, u2, e3, n3, i2), i2 += a2;
            } else
              for (o2 = 0; o2 < s2; ++o2)
                f2(t4[o2], e3, r3 + 1, n3, i2), i2 += a2;
          }
          function h(t4) {
            return 0 | et[Object.prototype.toString.call(t4)];
          }
          function p2(t4, e3) {
            for (var r3 = 0; r3 < e3.length; ++r3)
              t4[r3] = e3[r3];
          }
          function d2(t4, e3, r3, n3, i2, a2, o2) {
            for (var s2 = 0, l2 = 0; l2 < r3; ++l2)
              for (var u2 = 0; u2 < n3; ++u2)
                t4[s2++] = e3[i2 * l2 + a2 * u2 + o2];
          }
          function v(t4, e3, r3, n3) {
            function i2(e4) {
              this.id = l2++, this.buffer = t4.createBuffer(), this.type = e4, this.usage = 35044, this.byteLength = 0, this.dimension = 1, this.dtype = 5121, this.persistentData = null, r3.profile && (this.stats = { size: 0 });
            }
            function a2(e4, r4, n4) {
              e4.byteLength = r4.byteLength, t4.bufferData(e4.type, r4, n4);
            }
            function o2(t5, e4, r4, n4, i3, o3) {
              if (t5.usage = r4, Array.isArray(e4)) {
                if (t5.dtype = n4 || 5126, 0 < e4.length)
                  if (Array.isArray(e4[0])) {
                    i3 = at(e4);
                    for (var s3 = n4 = 1; s3 < i3.length; ++s3)
                      n4 *= i3[s3];
                    t5.dimension = n4, a2(t5, e4 = it(e4, i3, t5.dtype), r4), o3 ? t5.persistentData = e4 : J.freeType(e4);
                  } else
                    "number" == typeof e4[0] ? (t5.dimension = i3, p2(i3 = J.allocType(t5.dtype, e4.length), e4), a2(t5, i3, r4), o3 ? t5.persistentData = i3 : J.freeType(i3)) : $(e4[0]) && (t5.dimension = e4[0].length, t5.dtype = n4 || h(e4[0]) || 5126, a2(t5, e4 = it(e4, [e4.length, e4[0].length], t5.dtype), r4), o3 ? t5.persistentData = e4 : J.freeType(e4));
              } else if ($(e4))
                t5.dtype = n4 || h(e4), t5.dimension = i3, a2(t5, e4, r4), o3 && (t5.persistentData = new Uint8Array(new Uint8Array(e4.buffer)));
              else if (u(e4)) {
                i3 = e4.shape;
                var l3 = e4.stride, c3 = (s3 = e4.offset, 0), f4 = 0, v2 = 0, g3 = 0;
                1 === i3.length ? (c3 = i3[0], f4 = 1, v2 = l3[0], g3 = 0) : 2 === i3.length && (c3 = i3[0], f4 = i3[1], v2 = l3[0], g3 = l3[1]), t5.dtype = n4 || h(e4.data) || 5126, t5.dimension = f4, d2(i3 = J.allocType(t5.dtype, c3 * f4), e4.data, c3, f4, v2, g3, s3), a2(t5, i3, r4), o3 ? t5.persistentData = i3 : J.freeType(i3);
              } else
                e4 instanceof ArrayBuffer && (t5.dtype = 5121, t5.dimension = i3, a2(t5, e4, r4), o3 && (t5.persistentData = new Uint8Array(new Uint8Array(e4))));
            }
            function s2(r4) {
              e3.bufferCount--, n3(r4), t4.deleteBuffer(r4.buffer), r4.buffer = null, delete c2[r4.id];
            }
            var l2 = 0, c2 = {};
            i2.prototype.bind = function() {
              t4.bindBuffer(this.type, this.buffer);
            }, i2.prototype.destroy = function() {
              s2(this);
            };
            var f3 = [];
            return r3.profile && (e3.getTotalBufferSize = function() {
              var t5 = 0;
              return Object.keys(c2).forEach(function(e4) {
                t5 += c2[e4].stats.size;
              }), t5;
            }), { create: function(n4, a3, l3, f4) {
              function v2(e4) {
                var n5 = 35044, i3 = null, a4 = 0, s3 = 0, l4 = 1;
                return Array.isArray(e4) || $(e4) || u(e4) || e4 instanceof ArrayBuffer ? i3 = e4 : "number" == typeof e4 ? a4 = 0 | e4 : e4 && ("data" in e4 && (i3 = e4.data), "usage" in e4 && (n5 = nt[e4.usage]), "type" in e4 && (s3 = rt[e4.type]), "dimension" in e4 && (l4 = 0 | e4.dimension), "length" in e4 && (a4 = 0 | e4.length)), g3.bind(), i3 ? o2(g3, i3, n5, s3, l4, f4) : (a4 && t4.bufferData(g3.type, a4, n5), g3.dtype = s3 || 5121, g3.usage = n5, g3.dimension = l4, g3.byteLength = a4), r3.profile && (g3.stats.size = g3.byteLength * ot[g3.dtype]), v2;
              }
              e3.bufferCount++;
              var g3 = new i2(a3);
              return c2[g3.id] = g3, l3 || v2(n4), v2._reglType = "buffer", v2._buffer = g3, v2.subdata = function(e4, r4) {
                var n5, i3 = 0 | (r4 || 0);
                if (g3.bind(), $(e4) || e4 instanceof ArrayBuffer)
                  t4.bufferSubData(g3.type, i3, e4);
                else if (Array.isArray(e4)) {
                  if (0 < e4.length)
                    if ("number" == typeof e4[0]) {
                      var a4 = J.allocType(g3.dtype, e4.length);
                      p2(a4, e4), t4.bufferSubData(g3.type, i3, a4), J.freeType(a4);
                    } else
                      (Array.isArray(e4[0]) || $(e4[0])) && (n5 = at(e4), a4 = it(e4, n5, g3.dtype), t4.bufferSubData(g3.type, i3, a4), J.freeType(a4));
                } else if (u(e4)) {
                  n5 = e4.shape;
                  var o3 = e4.stride, s3 = a4 = 0, l4 = 0, c3 = 0;
                  1 === n5.length ? (a4 = n5[0], s3 = 1, l4 = o3[0], c3 = 0) : 2 === n5.length && (a4 = n5[0], s3 = n5[1], l4 = o3[0], c3 = o3[1]), n5 = Array.isArray(e4.data) ? g3.dtype : h(e4.data), d2(n5 = J.allocType(n5, a4 * s3), e4.data, a4, s3, l4, c3, e4.offset), t4.bufferSubData(g3.type, i3, n5), J.freeType(n5);
                }
                return v2;
              }, r3.profile && (v2.stats = g3.stats), v2.destroy = function() {
                s2(g3);
              }, v2;
            }, createStream: function(t5, e4) {
              var r4 = f3.pop();
              return r4 || (r4 = new i2(t5)), r4.bind(), o2(r4, e4, 35040, 0, 1, false), r4;
            }, destroyStream: function(t5) {
              f3.push(t5);
            }, clear: function() {
              Q(c2).forEach(s2), f3.forEach(s2);
            }, getBuffer: function(t5) {
              return t5 && t5._buffer instanceof i2 ? t5._buffer : null;
            }, restore: function() {
              Q(c2).forEach(function(e4) {
                e4.buffer = t4.createBuffer(), t4.bindBuffer(e4.type, e4.buffer), t4.bufferData(e4.type, e4.persistentData || e4.byteLength, e4.usage);
              });
            }, _initBuffer: o2 };
          }
          function g2(t4, e3, r3, n3) {
            function i2(t5) {
              this.id = l2++, s2[this.id] = this, this.buffer = t5, this.primType = 4, this.type = this.vertCount = 0;
            }
            function a2(n4, i3, a3, o3, s3, l3, c3) {
              var f4;
              if (n4.buffer.bind(), i3 ? ((f4 = c3) || $(i3) && (!u(i3) || $(i3.data)) || (f4 = e3.oes_element_index_uint ? 5125 : 5123), r3._initBuffer(n4.buffer, i3, a3, f4, 3)) : (t4.bufferData(34963, l3, a3), n4.buffer.dtype = f4 || 5121, n4.buffer.usage = a3, n4.buffer.dimension = 3, n4.buffer.byteLength = l3), f4 = c3, !c3) {
                switch (n4.buffer.dtype) {
                  case 5121:
                  case 5120:
                    f4 = 5121;
                    break;
                  case 5123:
                  case 5122:
                    f4 = 5123;
                    break;
                  case 5125:
                  case 5124:
                    f4 = 5125;
                }
                n4.buffer.dtype = f4;
              }
              n4.type = f4, 0 > (i3 = s3) && (i3 = n4.buffer.byteLength, 5123 === f4 ? i3 >>= 1 : 5125 === f4 && (i3 >>= 2)), n4.vertCount = i3, i3 = o3, 0 > o3 && (i3 = 4, 1 === (o3 = n4.buffer.dimension) && (i3 = 0), 2 === o3 && (i3 = 1), 3 === o3 && (i3 = 4)), n4.primType = i3;
            }
            function o2(t5) {
              n3.elementsCount--, delete s2[t5.id], t5.buffer.destroy(), t5.buffer = null;
            }
            var s2 = {}, l2 = 0, c2 = { uint8: 5121, uint16: 5123 };
            e3.oes_element_index_uint && (c2.uint32 = 5125), i2.prototype.bind = function() {
              this.buffer.bind();
            };
            var f3 = [];
            return { create: function(t5, e4) {
              function s3(t6) {
                if (t6)
                  if ("number" == typeof t6)
                    l3(t6), f4.primType = 4, f4.vertCount = 0 | t6, f4.type = 5121;
                  else {
                    var e5 = null, r4 = 35044, n4 = -1, i3 = -1, o3 = 0, h2 = 0;
                    Array.isArray(t6) || $(t6) || u(t6) ? e5 = t6 : ("data" in t6 && (e5 = t6.data), "usage" in t6 && (r4 = nt[t6.usage]), "primitive" in t6 && (n4 = st[t6.primitive]), "count" in t6 && (i3 = 0 | t6.count), "type" in t6 && (h2 = c2[t6.type]), "length" in t6 ? o3 = 0 | t6.length : (o3 = i3, 5123 === h2 || 5122 === h2 ? o3 *= 2 : 5125 !== h2 && 5124 !== h2 || (o3 *= 4))), a2(f4, e5, r4, n4, i3, o3, h2);
                  }
                else
                  l3(), f4.primType = 4, f4.vertCount = 0, f4.type = 5121;
                return s3;
              }
              var l3 = r3.create(null, 34963, true), f4 = new i2(l3._buffer);
              return n3.elementsCount++, s3(t5), s3._reglType = "elements", s3._elements = f4, s3.subdata = function(t6, e5) {
                return l3.subdata(t6, e5), s3;
              }, s3.destroy = function() {
                o2(f4);
              }, s3;
            }, createStream: function(t5) {
              var e4 = f3.pop();
              return e4 || (e4 = new i2(r3.create(null, 34963, true, false)._buffer)), a2(e4, t5, 35040, -1, -1, 0, 0), e4;
            }, destroyStream: function(t5) {
              f3.push(t5);
            }, getElements: function(t5) {
              return "function" == typeof t5 && t5._elements instanceof i2 ? t5._elements : null;
            }, clear: function() {
              Q(s2).forEach(o2);
            } };
          }
          function y(t4) {
            for (var e3 = J.allocType(5123, t4.length), r3 = 0; r3 < t4.length; ++r3)
              if (isNaN(t4[r3]))
                e3[r3] = 65535;
              else if (1 / 0 === t4[r3])
                e3[r3] = 31744;
              else if (-1 / 0 === t4[r3])
                e3[r3] = 64512;
              else {
                lt[0] = t4[r3];
                var n3 = (a2 = ut[0]) >>> 31 << 15, i2 = (a2 << 1 >>> 24) - 127, a2 = a2 >> 13 & 1023;
                e3[r3] = -24 > i2 ? n3 : -14 > i2 ? n3 + (a2 + 1024 >> -14 - i2) : 15 < i2 ? n3 + 31744 : n3 + (i2 + 15 << 10) + a2;
              }
            return e3;
          }
          function m2(t4) {
            return Array.isArray(t4) || $(t4);
          }
          function x(t4) {
            return "[object " + t4 + "]";
          }
          function b(t4) {
            return Array.isArray(t4) && (0 === t4.length || "number" == typeof t4[0]);
          }
          function _(t4) {
            return !(!Array.isArray(t4) || 0 === t4.length || !m2(t4[0]));
          }
          function w2(t4) {
            return Object.prototype.toString.call(t4);
          }
          function T(t4) {
            if (!t4)
              return false;
            var e3 = w2(t4);
            return 0 <= xt.indexOf(e3) || b(t4) || _(t4) || u(t4);
          }
          function k(t4, e3) {
            36193 === t4.type ? (t4.data = y(e3), J.freeType(e3)) : t4.data = e3;
          }
          function A(t4, e3, r3, n3, i2, a2) {
            if (t4 = void 0 !== _t[t4] ? _t[t4] : ht[t4] * bt[e3], a2 && (t4 *= 6), i2) {
              for (n3 = 0; 1 <= r3; )
                n3 += t4 * r3 * r3, r3 /= 2;
              return n3;
            }
            return t4 * r3 * n3;
          }
          function M(t4, e3, r3, n3, i2, a2, o2) {
            function s2() {
              this.format = this.internalformat = 6408, this.type = 5121, this.flipY = this.premultiplyAlpha = this.compressed = false, this.unpackAlignment = 1, this.colorSpace = 37444, this.channels = this.height = this.width = 0;
            }
            function l2(t5, e4) {
              t5.internalformat = e4.internalformat, t5.format = e4.format, t5.type = e4.type, t5.compressed = e4.compressed, t5.premultiplyAlpha = e4.premultiplyAlpha, t5.flipY = e4.flipY, t5.unpackAlignment = e4.unpackAlignment, t5.colorSpace = e4.colorSpace, t5.width = e4.width, t5.height = e4.height, t5.channels = e4.channels;
            }
            function c2(t5, e4) {
              if ("object" == typeof e4 && e4) {
                "premultiplyAlpha" in e4 && (t5.premultiplyAlpha = e4.premultiplyAlpha), "flipY" in e4 && (t5.flipY = e4.flipY), "alignment" in e4 && (t5.unpackAlignment = e4.alignment), "colorSpace" in e4 && (t5.colorSpace = V2[e4.colorSpace]), "type" in e4 && (t5.type = H2[e4.type]);
                var r4 = t5.width, n4 = t5.height, i3 = t5.channels, a3 = false;
                "shape" in e4 ? (r4 = e4.shape[0], n4 = e4.shape[1], 3 === e4.shape.length && (i3 = e4.shape[2], a3 = true)) : ("radius" in e4 && (r4 = n4 = e4.radius), "width" in e4 && (r4 = e4.width), "height" in e4 && (n4 = e4.height), "channels" in e4 && (i3 = e4.channels, a3 = true)), t5.width = 0 | r4, t5.height = 0 | n4, t5.channels = 0 | i3, r4 = false, "format" in e4 && (r4 = e4.format, n4 = t5.internalformat = q3[r4], t5.format = at2[n4], r4 in H2 && !("type" in e4) && (t5.type = H2[r4]), r4 in Z2 && (t5.compressed = true), r4 = true), !a3 && r4 ? t5.channels = ht[t5.format] : a3 && !r4 && t5.channels !== ft[t5.format] && (t5.format = t5.internalformat = ft[t5.channels]);
              }
            }
            function f3(e4) {
              t4.pixelStorei(37440, e4.flipY), t4.pixelStorei(37441, e4.premultiplyAlpha), t4.pixelStorei(37443, e4.colorSpace), t4.pixelStorei(3317, e4.unpackAlignment);
            }
            function h2() {
              s2.call(this), this.yOffset = this.xOffset = 0, this.data = null, this.needsFree = false, this.element = null, this.needsCopy = false;
            }
            function p3(t5, e4) {
              var r4 = null;
              if (T(e4) ? r4 = e4 : e4 && (c2(t5, e4), "x" in e4 && (t5.xOffset = 0 | e4.x), "y" in e4 && (t5.yOffset = 0 | e4.y), T(e4.data) && (r4 = e4.data)), e4.copy) {
                var n4 = i2.viewportWidth, a3 = i2.viewportHeight;
                t5.width = t5.width || n4 - t5.xOffset, t5.height = t5.height || a3 - t5.yOffset, t5.needsCopy = true;
              } else if (r4) {
                if ($(r4))
                  t5.channels = t5.channels || 4, t5.data = r4, "type" in e4 || 5121 !== t5.type || (t5.type = 0 | et[Object.prototype.toString.call(r4)]);
                else if (b(r4)) {
                  switch (t5.channels = t5.channels || 4, a3 = (n4 = r4).length, t5.type) {
                    case 5121:
                    case 5123:
                    case 5125:
                    case 5126:
                      (a3 = J.allocType(t5.type, a3)).set(n4), t5.data = a3;
                      break;
                    case 36193:
                      t5.data = y(n4);
                  }
                  t5.alignment = 1, t5.needsFree = true;
                } else if (u(r4)) {
                  n4 = r4.data, Array.isArray(n4) || 5121 !== t5.type || (t5.type = 0 | et[Object.prototype.toString.call(n4)]), a3 = r4.shape;
                  var o3, s3, l3, f4, h3 = r4.stride;
                  3 === a3.length ? (l3 = a3[2], f4 = h3[2]) : f4 = l3 = 1, o3 = a3[0], s3 = a3[1], a3 = h3[0], h3 = h3[1], t5.alignment = 1, t5.width = o3, t5.height = s3, t5.channels = l3, t5.format = t5.internalformat = ft[l3], t5.needsFree = true, o3 = f4, r4 = r4.offset, l3 = t5.width, f4 = t5.height, s3 = t5.channels;
                  for (var p4 = J.allocType(36193 === t5.type ? 5126 : t5.type, l3 * f4 * s3), d4 = 0, v3 = 0; v3 < f4; ++v3)
                    for (var g4 = 0; g4 < l3; ++g4)
                      for (var x3 = 0; x3 < s3; ++x3)
                        p4[d4++] = n4[a3 * g4 + h3 * v3 + o3 * x3 + r4];
                  k(t5, p4);
                } else if (w2(r4) === pt || w2(r4) === dt || w2(r4) === vt)
                  w2(r4) === pt || w2(r4) === dt ? t5.element = r4 : t5.element = r4.canvas, t5.width = t5.element.width, t5.height = t5.element.height, t5.channels = 4;
                else if (w2(r4) === gt)
                  t5.element = r4, t5.width = r4.width, t5.height = r4.height, t5.channels = 4;
                else if (w2(r4) === yt)
                  t5.element = r4, t5.width = r4.naturalWidth, t5.height = r4.naturalHeight, t5.channels = 4;
                else if (w2(r4) === mt)
                  t5.element = r4, t5.width = r4.videoWidth, t5.height = r4.videoHeight, t5.channels = 4;
                else if (_(r4)) {
                  for (n4 = t5.width || r4[0].length, a3 = t5.height || r4.length, h3 = t5.channels, h3 = m2(r4[0][0]) ? h3 || r4[0][0].length : h3 || 1, o3 = tt.shape(r4), l3 = 1, f4 = 0; f4 < o3.length; ++f4)
                    l3 *= o3[f4];
                  l3 = J.allocType(36193 === t5.type ? 5126 : t5.type, l3), tt.flatten(r4, o3, "", l3), k(t5, l3), t5.alignment = 1, t5.width = n4, t5.height = a3, t5.channels = h3, t5.format = t5.internalformat = ft[h3], t5.needsFree = true;
                }
              } else
                t5.width = t5.width || 1, t5.height = t5.height || 1, t5.channels = t5.channels || 4;
            }
            function d3(e4, r4, i3, a3, o3) {
              var s3 = e4.element, l3 = e4.data, u2 = e4.internalformat, c3 = e4.format, h3 = e4.type, p4 = e4.width, d4 = e4.height;
              f3(e4), s3 ? t4.texSubImage2D(r4, o3, i3, a3, c3, h3, s3) : e4.compressed ? t4.compressedTexSubImage2D(r4, o3, i3, a3, u2, p4, d4, l3) : e4.needsCopy ? (n3(), t4.copyTexSubImage2D(r4, o3, i3, a3, e4.xOffset, e4.yOffset, p4, d4)) : t4.texSubImage2D(r4, o3, i3, a3, p4, d4, c3, h3, l3);
            }
            function v2() {
              return ot2.pop() || new h2();
            }
            function g3(t5) {
              t5.needsFree && J.freeType(t5.data), h2.call(t5), ot2.push(t5);
            }
            function x2() {
              s2.call(this), this.genMipmaps = false, this.mipmapHint = 4352, this.mipmask = 0, this.images = Array(16);
            }
            function M2(t5, e4, r4) {
              var n4 = t5.images[0] = v2();
              t5.mipmask = 1, n4.width = t5.width = e4, n4.height = t5.height = r4, n4.channels = t5.channels = 4;
            }
            function S2(t5, e4) {
              var r4 = null;
              if (T(e4))
                l2(r4 = t5.images[0] = v2(), t5), p3(r4, e4), t5.mipmask = 1;
              else if (c2(t5, e4), Array.isArray(e4.mipmap))
                for (var n4 = e4.mipmap, i3 = 0; i3 < n4.length; ++i3)
                  l2(r4 = t5.images[i3] = v2(), t5), r4.width >>= i3, r4.height >>= i3, p3(r4, n4[i3]), t5.mipmask |= 1 << i3;
              else
                l2(r4 = t5.images[0] = v2(), t5), p3(r4, e4), t5.mipmask = 1;
              l2(t5, t5.images[0]);
            }
            function E2(e4, r4) {
              for (var i3 = e4.images, a3 = 0; a3 < i3.length && i3[a3]; ++a3) {
                var o3 = i3[a3], s3 = r4, l3 = a3, u2 = o3.element, c3 = o3.data, h3 = o3.internalformat, p4 = o3.format, d4 = o3.type, v3 = o3.width, g4 = o3.height;
                f3(o3), u2 ? t4.texImage2D(s3, l3, p4, p4, d4, u2) : o3.compressed ? t4.compressedTexImage2D(s3, l3, h3, v3, g4, 0, c3) : o3.needsCopy ? (n3(), t4.copyTexImage2D(s3, l3, p4, o3.xOffset, o3.yOffset, v3, g4, 0)) : t4.texImage2D(s3, l3, p4, v3, g4, 0, p4, d4, c3 || null);
              }
            }
            function L2() {
              var t5 = st2.pop() || new x2();
              s2.call(t5);
              for (var e4 = t5.mipmask = 0; 16 > e4; ++e4)
                t5.images[e4] = null;
              return t5;
            }
            function C2(t5) {
              for (var e4 = t5.images, r4 = 0; r4 < e4.length; ++r4)
                e4[r4] && g3(e4[r4]), e4[r4] = null;
              st2.push(t5);
            }
            function P2() {
              this.magFilter = this.minFilter = 9728, this.wrapT = this.wrapS = 33071, this.anisotropic = 1, this.genMipmaps = false, this.mipmapHint = 4352;
            }
            function O2(t5, e4) {
              "min" in e4 && (t5.minFilter = U2[e4.min], 0 <= ct.indexOf(t5.minFilter) && !("faces" in e4) && (t5.genMipmaps = true)), "mag" in e4 && (t5.magFilter = j2[e4.mag]);
              var r4 = t5.wrapS, n4 = t5.wrapT;
              if ("wrap" in e4) {
                var i3 = e4.wrap;
                "string" == typeof i3 ? r4 = n4 = N2[i3] : Array.isArray(i3) && (r4 = N2[i3[0]], n4 = N2[i3[1]]);
              } else
                "wrapS" in e4 && (r4 = N2[e4.wrapS]), "wrapT" in e4 && (n4 = N2[e4.wrapT]);
              if (t5.wrapS = r4, t5.wrapT = n4, "anisotropic" in e4 && (t5.anisotropic = e4.anisotropic), "mipmap" in e4) {
                switch (r4 = false, typeof e4.mipmap) {
                  case "string":
                    t5.mipmapHint = B2[e4.mipmap], r4 = t5.genMipmaps = true;
                    break;
                  case "boolean":
                    r4 = t5.genMipmaps = e4.mipmap;
                    break;
                  case "object":
                    t5.genMipmaps = false, r4 = true;
                }
                !r4 || "min" in e4 || (t5.minFilter = 9984);
              }
            }
            function I2(r4, n4) {
              t4.texParameteri(n4, 10241, r4.minFilter), t4.texParameteri(n4, 10240, r4.magFilter), t4.texParameteri(n4, 10242, r4.wrapS), t4.texParameteri(n4, 10243, r4.wrapT), e3.ext_texture_filter_anisotropic && t4.texParameteri(n4, 34046, r4.anisotropic), r4.genMipmaps && (t4.hint(33170, r4.mipmapHint), t4.generateMipmap(n4));
            }
            function D2(e4) {
              s2.call(this), this.mipmask = 0, this.internalformat = 6408, this.id = lt2++, this.refCount = 1, this.target = e4, this.texture = t4.createTexture(), this.unit = -1, this.bindCount = 0, this.texInfo = new P2(), o2.profile && (this.stats = { size: 0 });
            }
            function z2(e4) {
              t4.activeTexture(33984), t4.bindTexture(e4.target, e4.texture);
            }
            function R2() {
              var e4 = bt2[0];
              e4 ? t4.bindTexture(e4.target, e4.texture) : t4.bindTexture(3553, null);
            }
            function F2(e4) {
              var r4 = e4.texture, n4 = e4.unit, i3 = e4.target;
              0 <= n4 && (t4.activeTexture(33984 + n4), t4.bindTexture(i3, null), bt2[n4] = null), t4.deleteTexture(r4), e4.texture = null, e4.params = null, e4.pixels = null, e4.refCount = 0, delete ut2[e4.id], a2.textureCount--;
            }
            var B2 = { "don't care": 4352, "dont care": 4352, nice: 4354, fast: 4353 }, N2 = { repeat: 10497, clamp: 33071, mirror: 33648 }, j2 = { nearest: 9728, linear: 9729 }, U2 = G({ mipmap: 9987, "nearest mipmap nearest": 9984, "linear mipmap nearest": 9985, "nearest mipmap linear": 9986, "linear mipmap linear": 9987 }, j2), V2 = { none: 0, browser: 37444 }, H2 = { uint8: 5121, rgba4: 32819, rgb565: 33635, "rgb5 a1": 32820 }, q3 = { alpha: 6406, luminance: 6409, "luminance alpha": 6410, rgb: 6407, rgba: 6408, rgba4: 32854, "rgb5 a1": 32855, rgb565: 36194 }, Z2 = {};
            e3.ext_srgb && (q3.srgb = 35904, q3.srgba = 35906), e3.oes_texture_float && (H2.float32 = H2.float = 5126), e3.oes_texture_half_float && (H2.float16 = H2["half float"] = 36193), e3.webgl_depth_texture && (G(q3, { depth: 6402, "depth stencil": 34041 }), G(H2, { uint16: 5123, uint32: 5125, "depth stencil": 34042 })), e3.webgl_compressed_texture_s3tc && G(Z2, { "rgb s3tc dxt1": 33776, "rgba s3tc dxt1": 33777, "rgba s3tc dxt3": 33778, "rgba s3tc dxt5": 33779 }), e3.webgl_compressed_texture_atc && G(Z2, { "rgb atc": 35986, "rgba atc explicit alpha": 35987, "rgba atc interpolated alpha": 34798 }), e3.webgl_compressed_texture_pvrtc && G(Z2, { "rgb pvrtc 4bppv1": 35840, "rgb pvrtc 2bppv1": 35841, "rgba pvrtc 4bppv1": 35842, "rgba pvrtc 2bppv1": 35843 }), e3.webgl_compressed_texture_etc1 && (Z2["rgb etc1"] = 36196);
            var Y2 = Array.prototype.slice.call(t4.getParameter(34467));
            Object.keys(Z2).forEach(function(t5) {
              var e4 = Z2[t5];
              0 <= Y2.indexOf(e4) && (q3[t5] = e4);
            });
            var W2 = Object.keys(q3);
            r3.textureFormats = W2;
            var X2 = [];
            Object.keys(q3).forEach(function(t5) {
              X2[q3[t5]] = t5;
            });
            var K2 = [];
            Object.keys(H2).forEach(function(t5) {
              K2[H2[t5]] = t5;
            });
            var rt2 = [];
            Object.keys(j2).forEach(function(t5) {
              rt2[j2[t5]] = t5;
            });
            var nt2 = [];
            Object.keys(U2).forEach(function(t5) {
              nt2[U2[t5]] = t5;
            });
            var it2 = [];
            Object.keys(N2).forEach(function(t5) {
              it2[N2[t5]] = t5;
            });
            var at2 = W2.reduce(function(t5, r4) {
              var n4 = q3[r4];
              return 6409 === n4 || 6406 === n4 || 6409 === n4 || 6410 === n4 || 6402 === n4 || 34041 === n4 || e3.ext_srgb && (35904 === n4 || 35906 === n4) ? t5[n4] = n4 : 32855 === n4 || 0 <= r4.indexOf("rgba") ? t5[n4] = 6408 : t5[n4] = 6407, t5;
            }, {}), ot2 = [], st2 = [], lt2 = 0, ut2 = {}, xt2 = r3.maxTextureUnits, bt2 = Array(xt2).map(function() {
              return null;
            });
            return G(D2.prototype, { bind: function() {
              this.bindCount += 1;
              var e4 = this.unit;
              if (0 > e4) {
                for (var r4 = 0; r4 < xt2; ++r4) {
                  var n4 = bt2[r4];
                  if (n4) {
                    if (0 < n4.bindCount)
                      continue;
                    n4.unit = -1;
                  }
                  bt2[r4] = this, e4 = r4;
                  break;
                }
                o2.profile && a2.maxTextureUnits < e4 + 1 && (a2.maxTextureUnits = e4 + 1), this.unit = e4, t4.activeTexture(33984 + e4), t4.bindTexture(this.target, this.texture);
              }
              return e4;
            }, unbind: function() {
              --this.bindCount;
            }, decRef: function() {
              0 >= --this.refCount && F2(this);
            } }), o2.profile && (a2.getTotalTextureSize = function() {
              var t5 = 0;
              return Object.keys(ut2).forEach(function(e4) {
                t5 += ut2[e4].stats.size;
              }), t5;
            }), { create2D: function(e4, r4) {
              function n4(t5, e5) {
                var r5 = i3.texInfo;
                P2.call(r5);
                var a3 = L2();
                return "number" == typeof t5 ? M2(a3, 0 | t5, "number" == typeof e5 ? 0 | e5 : 0 | t5) : t5 ? (O2(r5, t5), S2(a3, t5)) : M2(a3, 1, 1), r5.genMipmaps && (a3.mipmask = (a3.width << 1) - 1), i3.mipmask = a3.mipmask, l2(i3, a3), i3.internalformat = a3.internalformat, n4.width = a3.width, n4.height = a3.height, z2(i3), E2(a3, 3553), I2(r5, 3553), R2(), C2(a3), o2.profile && (i3.stats.size = A(i3.internalformat, i3.type, a3.width, a3.height, r5.genMipmaps, false)), n4.format = X2[i3.internalformat], n4.type = K2[i3.type], n4.mag = rt2[r5.magFilter], n4.min = nt2[r5.minFilter], n4.wrapS = it2[r5.wrapS], n4.wrapT = it2[r5.wrapT], n4;
              }
              var i3 = new D2(3553);
              return ut2[i3.id] = i3, a2.textureCount++, n4(e4, r4), n4.subimage = function(t5, e5, r5, a3) {
                e5 |= 0, r5 |= 0, a3 |= 0;
                var o3 = v2();
                return l2(o3, i3), o3.width = 0, o3.height = 0, p3(o3, t5), o3.width = o3.width || (i3.width >> a3) - e5, o3.height = o3.height || (i3.height >> a3) - r5, z2(i3), d3(o3, 3553, e5, r5, a3), R2(), g3(o3), n4;
              }, n4.resize = function(e5, r5) {
                var a3 = 0 | e5, s3 = 0 | r5 || a3;
                if (a3 === i3.width && s3 === i3.height)
                  return n4;
                n4.width = i3.width = a3, n4.height = i3.height = s3, z2(i3);
                for (var l3 = 0; i3.mipmask >> l3; ++l3) {
                  var u2 = a3 >> l3, c3 = s3 >> l3;
                  if (!u2 || !c3)
                    break;
                  t4.texImage2D(3553, l3, i3.format, u2, c3, 0, i3.format, i3.type, null);
                }
                return R2(), o2.profile && (i3.stats.size = A(i3.internalformat, i3.type, a3, s3, false, false)), n4;
              }, n4._reglType = "texture2d", n4._texture = i3, o2.profile && (n4.stats = i3.stats), n4.destroy = function() {
                i3.decRef();
              }, n4;
            }, createCube: function(e4, r4, n4, i3, s3, u2) {
              function f4(t5, e5, r5, n5, i4, a3) {
                var s4, u3 = h3.texInfo;
                for (P2.call(u3), s4 = 0; 6 > s4; ++s4)
                  y2[s4] = L2();
                if ("number" != typeof t5 && t5) {
                  if ("object" == typeof t5)
                    if (e5)
                      S2(y2[0], t5), S2(y2[1], e5), S2(y2[2], r5), S2(y2[3], n5), S2(y2[4], i4), S2(y2[5], a3);
                    else if (O2(u3, t5), c2(h3, t5), "faces" in t5)
                      for (t5 = t5.faces, s4 = 0; 6 > s4; ++s4)
                        l2(y2[s4], h3), S2(y2[s4], t5[s4]);
                    else
                      for (s4 = 0; 6 > s4; ++s4)
                        S2(y2[s4], t5);
                } else
                  for (t5 = 0 | t5 || 1, s4 = 0; 6 > s4; ++s4)
                    M2(y2[s4], t5, t5);
                for (l2(h3, y2[0]), h3.mipmask = u3.genMipmaps ? (y2[0].width << 1) - 1 : y2[0].mipmask, h3.internalformat = y2[0].internalformat, f4.width = y2[0].width, f4.height = y2[0].height, z2(h3), s4 = 0; 6 > s4; ++s4)
                  E2(y2[s4], 34069 + s4);
                for (I2(u3, 34067), R2(), o2.profile && (h3.stats.size = A(h3.internalformat, h3.type, f4.width, f4.height, u3.genMipmaps, true)), f4.format = X2[h3.internalformat], f4.type = K2[h3.type], f4.mag = rt2[u3.magFilter], f4.min = nt2[u3.minFilter], f4.wrapS = it2[u3.wrapS], f4.wrapT = it2[u3.wrapT], s4 = 0; 6 > s4; ++s4)
                  C2(y2[s4]);
                return f4;
              }
              var h3 = new D2(34067);
              ut2[h3.id] = h3, a2.cubeCount++;
              var y2 = Array(6);
              return f4(e4, r4, n4, i3, s3, u2), f4.subimage = function(t5, e5, r5, n5, i4) {
                r5 |= 0, n5 |= 0, i4 |= 0;
                var a3 = v2();
                return l2(a3, h3), a3.width = 0, a3.height = 0, p3(a3, e5), a3.width = a3.width || (h3.width >> i4) - r5, a3.height = a3.height || (h3.height >> i4) - n5, z2(h3), d3(a3, 34069 + t5, r5, n5, i4), R2(), g3(a3), f4;
              }, f4.resize = function(e5) {
                if ((e5 |= 0) !== h3.width) {
                  f4.width = h3.width = e5, f4.height = h3.height = e5, z2(h3);
                  for (var r5 = 0; 6 > r5; ++r5)
                    for (var n5 = 0; h3.mipmask >> n5; ++n5)
                      t4.texImage2D(34069 + r5, n5, h3.format, e5 >> n5, e5 >> n5, 0, h3.format, h3.type, null);
                  return R2(), o2.profile && (h3.stats.size = A(h3.internalformat, h3.type, f4.width, f4.height, false, true)), f4;
                }
              }, f4._reglType = "textureCube", f4._texture = h3, o2.profile && (f4.stats = h3.stats), f4.destroy = function() {
                h3.decRef();
              }, f4;
            }, clear: function() {
              for (var e4 = 0; e4 < xt2; ++e4)
                t4.activeTexture(33984 + e4), t4.bindTexture(3553, null), bt2[e4] = null;
              Q(ut2).forEach(F2), a2.cubeCount = 0, a2.textureCount = 0;
            }, getTexture: function(t5) {
              return null;
            }, restore: function() {
              for (var e4 = 0; e4 < xt2; ++e4) {
                var r4 = bt2[e4];
                r4 && (r4.bindCount = 0, r4.unit = -1, bt2[e4] = null);
              }
              Q(ut2).forEach(function(e5) {
                e5.texture = t4.createTexture(), t4.bindTexture(e5.target, e5.texture);
                for (var r5 = 0; 32 > r5; ++r5)
                  if (0 != (e5.mipmask & 1 << r5))
                    if (3553 === e5.target)
                      t4.texImage2D(3553, r5, e5.internalformat, e5.width >> r5, e5.height >> r5, 0, e5.internalformat, e5.type, null);
                    else
                      for (var n4 = 0; 6 > n4; ++n4)
                        t4.texImage2D(34069 + n4, r5, e5.internalformat, e5.width >> r5, e5.height >> r5, 0, e5.internalformat, e5.type, null);
                I2(e5.texInfo, e5.target);
              });
            }, refresh: function() {
              for (var e4 = 0; e4 < xt2; ++e4) {
                var r4 = bt2[e4];
                r4 && (r4.bindCount = 0, r4.unit = -1, bt2[e4] = null), t4.activeTexture(33984 + e4), t4.bindTexture(3553, null), t4.bindTexture(34067, null);
              }
            } };
          }
          function S(t4, e3, r3, n3, i2, a2) {
            function o2(t5, e4, r4) {
              this.target = t5, this.texture = e4, this.renderbuffer = r4;
              var n4 = t5 = 0;
              e4 ? (t5 = e4.width, n4 = e4.height) : r4 && (t5 = r4.width, n4 = r4.height), this.width = t5, this.height = n4;
            }
            function s2(t5) {
              t5 && (t5.texture && t5.texture._texture.decRef(), t5.renderbuffer && t5.renderbuffer._renderbuffer.decRef());
            }
            function l2(t5, e4, r4) {
              t5 && (t5.texture ? t5.texture._texture.refCount += 1 : t5.renderbuffer._renderbuffer.refCount += 1);
            }
            function u2(e4, r4) {
              r4 && (r4.texture ? t4.framebufferTexture2D(36160, e4, r4.target, r4.texture._texture.texture, 0) : t4.framebufferRenderbuffer(36160, e4, 36161, r4.renderbuffer._renderbuffer.renderbuffer));
            }
            function c2(t5) {
              var e4 = 3553, r4 = null, n4 = null, i3 = t5;
              return "object" == typeof t5 && (i3 = t5.data, "target" in t5 && (e4 = 0 | t5.target)), "texture2d" === (t5 = i3._reglType) || "textureCube" === t5 ? r4 = i3 : "renderbuffer" === t5 && (n4 = i3, e4 = 36161), new o2(e4, r4, n4);
            }
            function f3(t5, e4, r4, a3, s3) {
              return r4 ? ((t5 = n3.create2D({ width: t5, height: e4, format: a3, type: s3 }))._texture.refCount = 0, new o2(3553, t5, null)) : ((t5 = i2.create({ width: t5, height: e4, format: a3 }))._renderbuffer.refCount = 0, new o2(36161, null, t5));
            }
            function h2(t5) {
              return t5 && (t5.texture || t5.renderbuffer);
            }
            function p3(t5, e4, r4) {
              t5 && (t5.texture ? t5.texture.resize(e4, r4) : t5.renderbuffer && t5.renderbuffer.resize(e4, r4), t5.width = e4, t5.height = r4);
            }
            function d3() {
              this.id = T2++, k2[this.id] = this, this.framebuffer = t4.createFramebuffer(), this.height = this.width = 0, this.colorAttachments = [], this.depthStencilAttachment = this.stencilAttachment = this.depthAttachment = null;
            }
            function v2(t5) {
              t5.colorAttachments.forEach(s2), s2(t5.depthAttachment), s2(t5.stencilAttachment), s2(t5.depthStencilAttachment);
            }
            function g3(e4) {
              t4.deleteFramebuffer(e4.framebuffer), e4.framebuffer = null, a2.framebufferCount--, delete k2[e4.id];
            }
            function y2(e4) {
              var n4;
              t4.bindFramebuffer(36160, e4.framebuffer);
              var i3 = e4.colorAttachments;
              for (n4 = 0; n4 < i3.length; ++n4)
                u2(36064 + n4, i3[n4]);
              for (n4 = i3.length; n4 < r3.maxColorAttachments; ++n4)
                t4.framebufferTexture2D(36160, 36064 + n4, 3553, null, 0);
              t4.framebufferTexture2D(36160, 33306, 3553, null, 0), t4.framebufferTexture2D(36160, 36096, 3553, null, 0), t4.framebufferTexture2D(36160, 36128, 3553, null, 0), u2(36096, e4.depthAttachment), u2(36128, e4.stencilAttachment), u2(33306, e4.depthStencilAttachment), t4.checkFramebufferStatus(36160), t4.isContextLost(), t4.bindFramebuffer(36160, x2.next ? x2.next.framebuffer : null), x2.cur = x2.next, t4.getError();
            }
            function m3(t5, e4) {
              function r4(t6, e5) {
                var i3, a3 = 0, o3 = 0, s3 = true, u3 = true;
                i3 = null;
                var p4 = true, d4 = "rgba", g4 = "uint8", m4 = 1, x3 = null, w4 = null, T3 = null, k3 = false;
                "number" == typeof t6 ? (a3 = 0 | t6, o3 = 0 | e5 || a3) : t6 ? ("shape" in t6 ? (a3 = (o3 = t6.shape)[0], o3 = o3[1]) : ("radius" in t6 && (a3 = o3 = t6.radius), "width" in t6 && (a3 = t6.width), "height" in t6 && (o3 = t6.height)), ("color" in t6 || "colors" in t6) && (i3 = t6.color || t6.colors, Array.isArray(i3)), i3 || ("colorCount" in t6 && (m4 = 0 | t6.colorCount), "colorTexture" in t6 && (p4 = !!t6.colorTexture, d4 = "rgba4"), "colorType" in t6 && (g4 = t6.colorType, !p4) && ("half float" === g4 || "float16" === g4 ? d4 = "rgba16f" : "float" !== g4 && "float32" !== g4 || (d4 = "rgba32f")), "colorFormat" in t6 && (d4 = t6.colorFormat, 0 <= b2.indexOf(d4) ? p4 = true : 0 <= _2.indexOf(d4) && (p4 = false))), ("depthTexture" in t6 || "depthStencilTexture" in t6) && (k3 = !(!t6.depthTexture && !t6.depthStencilTexture)), "depth" in t6 && ("boolean" == typeof t6.depth ? s3 = t6.depth : (x3 = t6.depth, u3 = false)), "stencil" in t6 && ("boolean" == typeof t6.stencil ? u3 = t6.stencil : (w4 = t6.stencil, s3 = false)), "depthStencil" in t6 && ("boolean" == typeof t6.depthStencil ? s3 = u3 = t6.depthStencil : (T3 = t6.depthStencil, u3 = s3 = false))) : a3 = o3 = 1;
                var A2 = null, M2 = null, S2 = null, E2 = null;
                if (Array.isArray(i3))
                  A2 = i3.map(c2);
                else if (i3)
                  A2 = [c2(i3)];
                else
                  for (A2 = Array(m4), i3 = 0; i3 < m4; ++i3)
                    A2[i3] = f3(a3, o3, p4, d4, g4);
                for (a3 = a3 || A2[0].width, o3 = o3 || A2[0].height, x3 ? M2 = c2(x3) : s3 && !u3 && (M2 = f3(a3, o3, k3, "depth", "uint32")), w4 ? S2 = c2(w4) : u3 && !s3 && (S2 = f3(a3, o3, false, "stencil", "uint8")), T3 ? E2 = c2(T3) : !x3 && !w4 && u3 && s3 && (E2 = f3(a3, o3, k3, "depth stencil", "depth stencil")), s3 = null, i3 = 0; i3 < A2.length; ++i3)
                  l2(A2[i3]), A2[i3] && A2[i3].texture && (u3 = kt[A2[i3].texture._texture.format] * At[A2[i3].texture._texture.type], null === s3 && (s3 = u3));
                return l2(M2), l2(S2), l2(E2), v2(n4), n4.width = a3, n4.height = o3, n4.colorAttachments = A2, n4.depthAttachment = M2, n4.stencilAttachment = S2, n4.depthStencilAttachment = E2, r4.color = A2.map(h2), r4.depth = h2(M2), r4.stencil = h2(S2), r4.depthStencil = h2(E2), r4.width = n4.width, r4.height = n4.height, y2(n4), r4;
              }
              var n4 = new d3();
              return a2.framebufferCount++, r4(t5, e4), G(r4, { resize: function(t6, e5) {
                var i3 = Math.max(0 | t6, 1), a3 = Math.max(0 | e5 || i3, 1);
                if (i3 === n4.width && a3 === n4.height)
                  return r4;
                for (var o3 = n4.colorAttachments, s3 = 0; s3 < o3.length; ++s3)
                  p3(o3[s3], i3, a3);
                return p3(n4.depthAttachment, i3, a3), p3(n4.stencilAttachment, i3, a3), p3(n4.depthStencilAttachment, i3, a3), n4.width = r4.width = i3, n4.height = r4.height = a3, y2(n4), r4;
              }, _reglType: "framebuffer", _framebuffer: n4, destroy: function() {
                g3(n4), v2(n4);
              }, use: function(t6) {
                x2.setFBO({ framebuffer: r4 }, t6);
              } });
            }
            var x2 = { cur: null, next: null, dirty: false, setFBO: null }, b2 = ["rgba"], _2 = ["rgba4", "rgb565", "rgb5 a1"];
            e3.ext_srgb && _2.push("srgba"), e3.ext_color_buffer_half_float && _2.push("rgba16f", "rgb16f"), e3.webgl_color_buffer_float && _2.push("rgba32f");
            var w3 = ["uint8"];
            e3.oes_texture_half_float && w3.push("half float", "float16"), e3.oes_texture_float && w3.push("float", "float32");
            var T2 = 0, k2 = {};
            return G(x2, { getFramebuffer: function(t5) {
              return "function" == typeof t5 && "framebuffer" === t5._reglType && (t5 = t5._framebuffer) instanceof d3 ? t5 : null;
            }, create: m3, createCube: function(t5) {
              function e4(t6) {
                var i3, a3 = { color: null }, o3 = 0, s3 = null;
                i3 = "rgba";
                var l3 = "uint8", u3 = 1;
                if ("number" == typeof t6 ? o3 = 0 | t6 : t6 ? ("shape" in t6 ? o3 = t6.shape[0] : ("radius" in t6 && (o3 = 0 | t6.radius), "width" in t6 ? o3 = 0 | t6.width : "height" in t6 && (o3 = 0 | t6.height)), ("color" in t6 || "colors" in t6) && (s3 = t6.color || t6.colors, Array.isArray(s3)), s3 || ("colorCount" in t6 && (u3 = 0 | t6.colorCount), "colorType" in t6 && (l3 = t6.colorType), "colorFormat" in t6 && (i3 = t6.colorFormat)), "depth" in t6 && (a3.depth = t6.depth), "stencil" in t6 && (a3.stencil = t6.stencil), "depthStencil" in t6 && (a3.depthStencil = t6.depthStencil)) : o3 = 1, s3)
                  if (Array.isArray(s3))
                    for (t6 = [], i3 = 0; i3 < s3.length; ++i3)
                      t6[i3] = s3[i3];
                  else
                    t6 = [s3];
                else
                  for (t6 = Array(u3), s3 = { radius: o3, format: i3, type: l3 }, i3 = 0; i3 < u3; ++i3)
                    t6[i3] = n3.createCube(s3);
                for (a3.color = Array(t6.length), i3 = 0; i3 < t6.length; ++i3)
                  u3 = t6[i3], o3 = o3 || u3.width, a3.color[i3] = { target: 34069, data: t6[i3] };
                for (i3 = 0; 6 > i3; ++i3) {
                  for (u3 = 0; u3 < t6.length; ++u3)
                    a3.color[u3].target = 34069 + i3;
                  0 < i3 && (a3.depth = r4[0].depth, a3.stencil = r4[0].stencil, a3.depthStencil = r4[0].depthStencil), r4[i3] ? r4[i3](a3) : r4[i3] = m3(a3);
                }
                return G(e4, { width: o3, height: o3, color: t6 });
              }
              var r4 = Array(6);
              return e4(t5), G(e4, { faces: r4, resize: function(t6) {
                var n4 = 0 | t6;
                if (n4 === e4.width)
                  return e4;
                var i3 = e4.color;
                for (t6 = 0; t6 < i3.length; ++t6)
                  i3[t6].resize(n4);
                for (t6 = 0; 6 > t6; ++t6)
                  r4[t6].resize(n4);
                return e4.width = e4.height = n4, e4;
              }, _reglType: "framebufferCube", destroy: function() {
                r4.forEach(function(t6) {
                  t6.destroy();
                });
              } });
            }, clear: function() {
              Q(k2).forEach(g3);
            }, restore: function() {
              x2.cur = null, x2.next = null, x2.dirty = true, Q(k2).forEach(function(e4) {
                e4.framebuffer = t4.createFramebuffer(), y2(e4);
              });
            } });
          }
          function E() {
            this.w = this.z = this.y = this.x = this.state = 0, this.buffer = null, this.size = 0, this.normalized = false, this.type = 5126, this.divisor = this.stride = this.offset = 0;
          }
          function L(t4, e3, r3, n3, i2, a2, o2) {
            function s2() {
              this.id = ++f3, this.attributes = [], this.elements = null, this.ownsElements = false, this.offset = this.count = 0, this.instances = -1, this.primitive = 4;
              var t5 = e3.oes_vertex_array_object;
              this.vao = t5 ? t5.createVertexArrayOES() : null, h2[this.id] = this, this.buffers = [];
            }
            var l2 = r3.maxAttributes, c2 = Array(l2);
            for (r3 = 0; r3 < l2; ++r3)
              c2[r3] = new E();
            var f3 = 0, h2 = {}, p3 = { Record: E, scope: {}, state: c2, currentVAO: null, targetVAO: null, restore: e3.oes_vertex_array_object ? function() {
              e3.oes_vertex_array_object && Q(h2).forEach(function(t5) {
                t5.refresh();
              });
            } : function() {
            }, createVAO: function(t5) {
              function e4(t6) {
                var n4;
                Array.isArray(t6) ? (n4 = t6, r4.elements && r4.ownsElements && r4.elements.destroy(), r4.elements = null, r4.ownsElements = false, r4.offset = 0, r4.count = 0, r4.instances = -1, r4.primitive = 4) : (t6.elements ? (n4 = t6.elements, r4.ownsElements ? ("function" == typeof n4 && "elements" === n4._reglType ? r4.elements.destroy() : r4.elements(n4), r4.ownsElements = false) : a2.getElements(t6.elements) ? (r4.elements = t6.elements, r4.ownsElements = false) : (r4.elements = a2.create(t6.elements), r4.ownsElements = true)) : (r4.elements = null, r4.ownsElements = false), n4 = t6.attributes, r4.offset = 0, r4.count = -1, r4.instances = -1, r4.primitive = 4, r4.elements && (r4.count = r4.elements._elements.vertCount, r4.primitive = r4.elements._elements.primType), "offset" in t6 && (r4.offset = 0 | t6.offset), "count" in t6 && (r4.count = 0 | t6.count), "instances" in t6 && (r4.instances = 0 | t6.instances), "primitive" in t6 && (r4.primitive = st[t6.primitive])), t6 = {};
                var o3 = r4.attributes;
                o3.length = n4.length;
                for (var s3 = 0; s3 < n4.length; ++s3) {
                  var l3, c3 = n4[s3], f4 = o3[s3] = new E(), h3 = c3.data || c3;
                  Array.isArray(h3) || $(h3) || u(h3) ? (r4.buffers[s3] && (l3 = r4.buffers[s3], $(h3) && l3._buffer.byteLength >= h3.byteLength ? l3.subdata(h3) : (l3.destroy(), r4.buffers[s3] = null)), r4.buffers[s3] || (l3 = r4.buffers[s3] = i2.create(c3, 34962, false, true)), f4.buffer = i2.getBuffer(l3), f4.size = 0 | f4.buffer.dimension, f4.normalized = false, f4.type = f4.buffer.dtype, f4.offset = 0, f4.stride = 0, f4.divisor = 0, f4.state = 1, t6[s3] = 1) : i2.getBuffer(c3) ? (f4.buffer = i2.getBuffer(c3), f4.size = 0 | f4.buffer.dimension, f4.normalized = false, f4.type = f4.buffer.dtype, f4.offset = 0, f4.stride = 0, f4.divisor = 0, f4.state = 1) : i2.getBuffer(c3.buffer) ? (f4.buffer = i2.getBuffer(c3.buffer), f4.size = 0 | (+c3.size || f4.buffer.dimension), f4.normalized = !!c3.normalized || false, f4.type = "type" in c3 ? rt[c3.type] : f4.buffer.dtype, f4.offset = 0 | (c3.offset || 0), f4.stride = 0 | (c3.stride || 0), f4.divisor = 0 | (c3.divisor || 0), f4.state = 1) : "x" in c3 && (f4.x = +c3.x || 0, f4.y = +c3.y || 0, f4.z = +c3.z || 0, f4.w = +c3.w || 0, f4.state = 2);
                }
                for (l3 = 0; l3 < r4.buffers.length; ++l3)
                  !t6[l3] && r4.buffers[l3] && (r4.buffers[l3].destroy(), r4.buffers[l3] = null);
                return r4.refresh(), e4;
              }
              var r4 = new s2();
              return n3.vaoCount += 1, e4.destroy = function() {
                for (var t6 = 0; t6 < r4.buffers.length; ++t6)
                  r4.buffers[t6] && r4.buffers[t6].destroy();
                r4.buffers.length = 0, r4.ownsElements && (r4.elements.destroy(), r4.elements = null, r4.ownsElements = false), r4.destroy();
              }, e4._vao = r4, e4._reglType = "vao", e4(t5);
            }, getVAO: function(t5) {
              return "function" == typeof t5 && t5._vao ? t5._vao : null;
            }, destroyBuffer: function(e4) {
              for (var r4 = 0; r4 < c2.length; ++r4) {
                var n4 = c2[r4];
                n4.buffer === e4 && (t4.disableVertexAttribArray(r4), n4.buffer = null);
              }
            }, setVAO: e3.oes_vertex_array_object ? function(t5) {
              if (t5 !== p3.currentVAO) {
                var r4 = e3.oes_vertex_array_object;
                t5 ? r4.bindVertexArrayOES(t5.vao) : r4.bindVertexArrayOES(null), p3.currentVAO = t5;
              }
            } : function(r4) {
              if (r4 !== p3.currentVAO) {
                if (r4)
                  r4.bindAttrs();
                else {
                  for (var n4 = e3.angle_instanced_arrays, i3 = 0; i3 < c2.length; ++i3) {
                    var a3 = c2[i3];
                    a3.buffer ? (t4.enableVertexAttribArray(i3), a3.buffer.bind(), t4.vertexAttribPointer(i3, a3.size, a3.type, a3.normalized, a3.stride, a3.offfset), n4 && a3.divisor && n4.vertexAttribDivisorANGLE(i3, a3.divisor)) : (t4.disableVertexAttribArray(i3), t4.vertexAttrib4f(i3, a3.x, a3.y, a3.z, a3.w));
                  }
                  o2.elements ? t4.bindBuffer(34963, o2.elements.buffer.buffer) : t4.bindBuffer(34963, null);
                }
                p3.currentVAO = r4;
              }
            }, clear: e3.oes_vertex_array_object ? function() {
              Q(h2).forEach(function(t5) {
                t5.destroy();
              });
            } : function() {
            } };
            return s2.prototype.bindAttrs = function() {
              for (var r4 = e3.angle_instanced_arrays, n4 = this.attributes, i3 = 0; i3 < n4.length; ++i3) {
                var o3 = n4[i3];
                o3.buffer ? (t4.enableVertexAttribArray(i3), t4.bindBuffer(34962, o3.buffer.buffer), t4.vertexAttribPointer(i3, o3.size, o3.type, o3.normalized, o3.stride, o3.offset), r4 && o3.divisor && r4.vertexAttribDivisorANGLE(i3, o3.divisor)) : (t4.disableVertexAttribArray(i3), t4.vertexAttrib4f(i3, o3.x, o3.y, o3.z, o3.w));
              }
              for (r4 = n4.length; r4 < l2; ++r4)
                t4.disableVertexAttribArray(r4);
              (r4 = a2.getElements(this.elements)) ? t4.bindBuffer(34963, r4.buffer.buffer) : t4.bindBuffer(34963, null);
            }, s2.prototype.refresh = function() {
              var t5 = e3.oes_vertex_array_object;
              t5 && (t5.bindVertexArrayOES(this.vao), this.bindAttrs(), p3.currentVAO = null, t5.bindVertexArrayOES(null));
            }, s2.prototype.destroy = function() {
              if (this.vao) {
                var t5 = e3.oes_vertex_array_object;
                this === p3.currentVAO && (p3.currentVAO = null, t5.bindVertexArrayOES(null)), t5.deleteVertexArrayOES(this.vao), this.vao = null;
              }
              this.ownsElements && (this.elements.destroy(), this.elements = null, this.ownsElements = false), h2[this.id] && (delete h2[this.id], --n3.vaoCount);
            }, p3;
          }
          function C(t4, e3, r3, n3) {
            function i2(t5, e4, r4, n4) {
              this.name = t5, this.id = e4, this.location = r4, this.info = n4;
            }
            function a2(t5, e4) {
              for (var r4 = 0; r4 < t5.length; ++r4)
                if (t5[r4].id === e4.id)
                  return void (t5[r4].location = e4.location);
              t5.push(e4);
            }
            function o2(r4, n4, i3) {
              if (!(o3 = (i3 = 35632 === r4 ? u2 : c2)[n4])) {
                var a3 = e3.str(n4), o3 = t4.createShader(r4);
                t4.shaderSource(o3, a3), t4.compileShader(o3), i3[n4] = o3;
              }
              return o3;
            }
            function s2(t5, e4) {
              this.id = p3++, this.fragId = t5, this.vertId = e4, this.program = null, this.uniforms = [], this.attributes = [], this.refCount = 1, n3.profile && (this.stats = { uniformsCount: 0, attributesCount: 0 });
            }
            function l2(r4, s3, l3) {
              var u3;
              u3 = o2(35632, r4.fragId);
              var c3 = o2(35633, r4.vertId);
              if (s3 = r4.program = t4.createProgram(), t4.attachShader(s3, u3), t4.attachShader(s3, c3), l3)
                for (u3 = 0; u3 < l3.length; ++u3)
                  c3 = l3[u3], t4.bindAttribLocation(s3, c3[0], c3[1]);
              t4.linkProgram(s3), c3 = t4.getProgramParameter(s3, 35718), n3.profile && (r4.stats.uniformsCount = c3);
              var f4 = r4.uniforms;
              for (u3 = 0; u3 < c3; ++u3)
                if (l3 = t4.getActiveUniform(s3, u3))
                  if (1 < l3.size)
                    for (var h3 = 0; h3 < l3.size; ++h3) {
                      var p4 = l3.name.replace("[0]", "[" + h3 + "]");
                      a2(f4, new i2(p4, e3.id(p4), t4.getUniformLocation(s3, p4), l3));
                    }
                  else
                    a2(f4, new i2(l3.name, e3.id(l3.name), t4.getUniformLocation(s3, l3.name), l3));
              for (c3 = t4.getProgramParameter(s3, 35721), n3.profile && (r4.stats.attributesCount = c3), r4 = r4.attributes, u3 = 0; u3 < c3; ++u3)
                (l3 = t4.getActiveAttrib(s3, u3)) && a2(r4, new i2(l3.name, e3.id(l3.name), t4.getAttribLocation(s3, l3.name), l3));
            }
            var u2 = {}, c2 = {}, f3 = {}, h2 = [], p3 = 0;
            return n3.profile && (r3.getMaxUniformsCount = function() {
              var t5 = 0;
              return h2.forEach(function(e4) {
                e4.stats.uniformsCount > t5 && (t5 = e4.stats.uniformsCount);
              }), t5;
            }, r3.getMaxAttributesCount = function() {
              var t5 = 0;
              return h2.forEach(function(e4) {
                e4.stats.attributesCount > t5 && (t5 = e4.stats.attributesCount);
              }), t5;
            }), { clear: function() {
              var e4 = t4.deleteShader.bind(t4);
              Q(u2).forEach(e4), u2 = {}, Q(c2).forEach(e4), c2 = {}, h2.forEach(function(e5) {
                t4.deleteProgram(e5.program);
              }), h2.length = 0, f3 = {}, r3.shaderCount = 0;
            }, program: function(e4, n4, i3, a3) {
              var o3 = f3[n4];
              o3 || (o3 = f3[n4] = {});
              var p4 = o3[e4];
              if (p4 && (p4.refCount++, !a3))
                return p4;
              var d3 = new s2(n4, e4);
              return r3.shaderCount++, l2(d3, i3, a3), p4 || (o3[e4] = d3), h2.push(d3), G(d3, { destroy: function() {
                if (d3.refCount--, 0 >= d3.refCount) {
                  t4.deleteProgram(d3.program);
                  var e5 = h2.indexOf(d3);
                  h2.splice(e5, 1), r3.shaderCount--;
                }
                0 >= o3[d3.vertId].refCount && (t4.deleteShader(c2[d3.vertId]), delete c2[d3.vertId], delete f3[d3.fragId][d3.vertId]), Object.keys(f3[d3.fragId]).length || (t4.deleteShader(u2[d3.fragId]), delete u2[d3.fragId], delete f3[d3.fragId]);
              } });
            }, restore: function() {
              u2 = {}, c2 = {};
              for (var t5 = 0; t5 < h2.length; ++t5)
                l2(h2[t5], null, h2[t5].attributes.map(function(t6) {
                  return [t6.location, t6.name];
                }));
            }, shader: o2, frag: -1, vert: -1 };
          }
          function P(t4, e3, r3, n3, i2, a2, o2) {
            function s2(i3) {
              var a3;
              a3 = null === e3.next ? 5121 : e3.next.colorAttachments[0].texture._texture.type;
              var o3 = 0, s3 = 0, l2 = n3.framebufferWidth, u2 = n3.framebufferHeight, c2 = null;
              return $(i3) ? c2 = i3 : i3 && (o3 = 0 | i3.x, s3 = 0 | i3.y, l2 = 0 | (i3.width || n3.framebufferWidth - o3), u2 = 0 | (i3.height || n3.framebufferHeight - s3), c2 = i3.data || null), r3(), i3 = l2 * u2 * 4, c2 || (5121 === a3 ? c2 = new Uint8Array(i3) : 5126 === a3 && (c2 = c2 || new Float32Array(i3))), t4.pixelStorei(3333, 4), t4.readPixels(o3, s3, l2, u2, 6408, a3, c2), c2;
            }
            return function(t5) {
              return t5 && "framebuffer" in t5 ? function(t6) {
                var r4;
                return e3.setFBO({ framebuffer: t6.framebuffer }, function() {
                  r4 = s2(t6);
                }), r4;
              }(t5) : s2(t5);
            };
          }
          function O(t4, e3) {
            return t4 >>> e3 | t4 << 32 - e3;
          }
          function I(t4, e3) {
            var r3 = (65535 & t4) + (65535 & e3);
            return (t4 >> 16) + (e3 >> 16) + (r3 >> 16) << 16 | 65535 & r3;
          }
          function D(t4) {
            return Array.prototype.slice.call(t4);
          }
          function z(t4) {
            return D(t4).join("");
          }
          function R(t4) {
            function e3() {
              var t5 = [], e4 = [];
              return G(function() {
                t5.push.apply(t5, D(arguments));
              }, { def: function() {
                var r4 = "v" + i2++;
                return e4.push(r4), 0 < arguments.length && (t5.push(r4, "="), t5.push.apply(t5, D(arguments)), t5.push(";")), r4;
              }, toString: function() {
                return z([0 < e4.length ? "var " + e4.join(",") + ";" : "", z(t5)]);
              } });
            }
            function r3() {
              function t5(t6, e4) {
                n4(t6, e4, "=", r4.def(t6, e4), ";");
              }
              var r4 = e3(), n4 = e3(), i3 = r4.toString, a3 = n4.toString;
              return G(function() {
                r4.apply(r4, D(arguments));
              }, { def: r4.def, entry: r4, exit: n4, save: t5, set: function(e4, n5, i4) {
                t5(e4, n5), r4(e4, n5, "=", i4, ";");
              }, toString: function() {
                return i3() + a3();
              } });
            }
            var n3 = t4 && t4.cache, i2 = 0, a2 = [], o2 = [], s2 = [], l2 = e3(), u2 = {};
            return { global: l2, link: function(t5, e4) {
              var r4 = e4 && e4.stable;
              if (!r4) {
                for (var n4 = 0; n4 < o2.length; ++n4)
                  if (o2[n4] === t5 && !s2[n4])
                    return a2[n4];
              }
              return n4 = "g" + i2++, a2.push(n4), o2.push(t5), s2.push(r4), n4;
            }, block: e3, proc: function(t5, e4) {
              function n4() {
                var t6 = "a" + i3.length;
                return i3.push(t6), t6;
              }
              var i3 = [];
              e4 = e4 || 0;
              for (var a3 = 0; a3 < e4; ++a3)
                n4();
              var o3 = (a3 = r3()).toString;
              return u2[t5] = G(a3, { arg: n4, toString: function() {
                return z(["function(", i3.join(), "){", o3(), "}"]);
              } });
            }, scope: r3, cond: function() {
              var t5 = z(arguments), e4 = r3(), n4 = r3(), i3 = e4.toString, a3 = n4.toString;
              return G(e4, { then: function() {
                return e4.apply(e4, D(arguments)), this;
              }, else: function() {
                return n4.apply(n4, D(arguments)), this;
              }, toString: function() {
                var e5 = a3();
                return e5 && (e5 = "else{" + e5 + "}"), z(["if(", t5, "){", i3(), "}", e5]);
              } });
            }, compile: function() {
              var t5 = ['"use strict";', l2, "return {"];
              Object.keys(u2).forEach(function(e5) {
                t5.push('"', e5, '":', u2[e5].toString(), ",");
              }), t5.push("}");
              var e4, r4 = z(t5).replace(/;/g, ";\n").replace(/}/g, "}\n").replace(/{/g, "{\n");
              return n3 && (e4 = function(t6) {
                for (var e5, r5 = "", n4 = 0; n4 < t6.length; n4++)
                  e5 = t6.charCodeAt(n4), r5 += "0123456789abcdef".charAt(e5 >>> 4 & 15) + "0123456789abcdef".charAt(15 & e5);
                return r5;
              }(function(t6) {
                for (var e5 = Array(t6.length >> 2), r5 = 0; r5 < e5.length; r5++)
                  e5[r5] = 0;
                for (r5 = 0; r5 < 8 * t6.length; r5 += 8)
                  e5[r5 >> 5] |= (255 & t6.charCodeAt(r5 / 8)) << 24 - r5 % 32;
                var n4, i3, a3, o3, s3, l3, u3, c2, f3, h2, p3, d3 = 8 * t6.length;
                for (t6 = [1779033703, -1150833019, 1013904242, -1521486534, 1359893119, -1694144372, 528734635, 1541459225], r5 = Array(64), e5[d3 >> 5] |= 128 << 24 - d3 % 32, e5[15 + (d3 + 64 >> 9 << 4)] = d3, c2 = 0; c2 < e5.length; c2 += 16) {
                  for (d3 = t6[0], n4 = t6[1], i3 = t6[2], a3 = t6[3], o3 = t6[4], s3 = t6[5], l3 = t6[6], u3 = t6[7], f3 = 0; 64 > f3; f3++) {
                    var v2;
                    16 > f3 ? r5[f3] = e5[f3 + c2] : (h2 = f3, p3 = I(p3 = O(p3 = r5[f3 - 2], 17) ^ O(p3, 19) ^ p3 >>> 10, r5[f3 - 7]), v2 = O(v2 = r5[f3 - 15], 7) ^ O(v2, 18) ^ v2 >>> 3, r5[h2] = I(I(p3, v2), r5[f3 - 16])), h2 = I(I(I(I(u3, h2 = O(h2 = o3, 6) ^ O(h2, 11) ^ O(h2, 25)), o3 & s3 ^ ~o3 & l3), Mt[f3]), r5[f3]), p3 = I(u3 = O(u3 = d3, 2) ^ O(u3, 13) ^ O(u3, 22), d3 & n4 ^ d3 & i3 ^ n4 & i3), u3 = l3, l3 = s3, s3 = o3, o3 = I(a3, h2), a3 = i3, i3 = n4, n4 = d3, d3 = I(h2, p3);
                  }
                  t6[0] = I(d3, t6[0]), t6[1] = I(n4, t6[1]), t6[2] = I(i3, t6[2]), t6[3] = I(a3, t6[3]), t6[4] = I(o3, t6[4]), t6[5] = I(s3, t6[5]), t6[6] = I(l3, t6[6]), t6[7] = I(u3, t6[7]);
                }
                for (e5 = "", r5 = 0; r5 < 32 * t6.length; r5 += 8)
                  e5 += String.fromCharCode(t6[r5 >> 5] >>> 24 - r5 % 32 & 255);
                return e5;
              }(function(t6) {
                for (var e5, r5, n4 = "", i3 = -1; ++i3 < t6.length; )
                  e5 = t6.charCodeAt(i3), r5 = i3 + 1 < t6.length ? t6.charCodeAt(i3 + 1) : 0, 55296 <= e5 && 56319 >= e5 && 56320 <= r5 && 57343 >= r5 && (e5 = 65536 + ((1023 & e5) << 10) + (1023 & r5), i3++), 127 >= e5 ? n4 += String.fromCharCode(e5) : 2047 >= e5 ? n4 += String.fromCharCode(192 | e5 >>> 6 & 31, 128 | 63 & e5) : 65535 >= e5 ? n4 += String.fromCharCode(224 | e5 >>> 12 & 15, 128 | e5 >>> 6 & 63, 128 | 63 & e5) : 2097151 >= e5 && (n4 += String.fromCharCode(240 | e5 >>> 18 & 7, 128 | e5 >>> 12 & 63, 128 | e5 >>> 6 & 63, 128 | 63 & e5));
                return n4;
              }(r4))), n3[e4]) ? n3[e4].apply(null, o2) : (r4 = Function.apply(null, a2.concat(r4)), n3 && (n3[e4] = r4), r4.apply(null, o2));
            } };
          }
          function F(t4) {
            return Array.isArray(t4) || $(t4) || u(t4);
          }
          function B(t4) {
            return t4.sort(function(t5, e3) {
              return "viewport" === t5 ? -1 : "viewport" === e3 ? 1 : t5 < e3 ? -1 : 1;
            });
          }
          function N(t4, e3, r3, n3) {
            this.thisDep = t4, this.contextDep = e3, this.propDep = r3, this.append = n3;
          }
          function j(t4) {
            return t4 && !(t4.thisDep || t4.contextDep || t4.propDep);
          }
          function U(t4) {
            return new N(false, false, false, t4);
          }
          function V(t4, e3) {
            var r3 = t4.type;
            if (0 === r3)
              return new N(true, 1 <= (r3 = t4.data.length), 2 <= r3, e3);
            if (4 === r3)
              return new N((r3 = t4.data).thisDep, r3.contextDep, r3.propDep, e3);
            if (5 === r3)
              return new N(false, false, false, e3);
            if (6 === r3) {
              for (var n3 = r3 = false, i2 = false, a2 = 0; a2 < t4.data.length; ++a2) {
                var o2 = t4.data[a2];
                1 === o2.type ? i2 = true : 2 === o2.type ? n3 = true : 3 === o2.type ? r3 = true : 0 === o2.type ? (r3 = true, 1 <= (o2 = o2.data) && (n3 = true), 2 <= o2 && (i2 = true)) : 4 === o2.type && (r3 = r3 || o2.data.thisDep, n3 = n3 || o2.data.contextDep, i2 = i2 || o2.data.propDep);
              }
              return new N(r3, n3, i2, e3);
            }
            return new N(3 === r3, 2 === r3, 1 === r3, e3);
          }
          function H(t4, e3, r3, n3, i2, a2, s2, l2, u2, c2, f3, h2, p3, d3, v2, g3) {
            function y2(t5) {
              return t5.replace(".", "_");
            }
            function x2(t5, e4, r4) {
              var n4 = y2(t5);
              at2.push(t5), it2[n4] = nt2[n4] = !!r4, ot2[n4] = e4;
            }
            function b2(t5, e4, r4) {
              var n4 = y2(t5);
              at2.push(t5), Array.isArray(r4) ? (nt2[n4] = r4.slice(), it2[n4] = r4.slice()) : nt2[n4] = it2[n4] = r4, lt2[n4] = e4;
            }
            function _2() {
              var t5 = R({ cache: v2 }), r4 = t5.link, n4 = t5.global;
              t5.id = ft2++, t5.batchId = "0";
              var i3 = r4(ut2), a3 = t5.shared = { props: "a0" };
              Object.keys(ut2).forEach(function(t6) {
                a3[t6] = n4.def(i3, ".", t6);
              });
              var o2 = t5.next = {}, s3 = t5.current = {};
              Object.keys(lt2).forEach(function(t6) {
                Array.isArray(nt2[t6]) && (o2[t6] = n4.def(a3.next, ".", t6), s3[t6] = n4.def(a3.current, ".", t6));
              });
              var l3 = t5.constants = {};
              Object.keys(ct2).forEach(function(t6) {
                l3[t6] = n4.def(JSON.stringify(ct2[t6]));
              }), t5.invoke = function(e4, n5) {
                switch (n5.type) {
                  case 0:
                    var i4 = ["this", a3.context, a3.props, t5.batchId];
                    return e4.def(r4(n5.data), ".call(", i4.slice(0, Math.max(n5.data.length + 1, 4)), ")");
                  case 1:
                    return e4.def(a3.props, n5.data);
                  case 2:
                    return e4.def(a3.context, n5.data);
                  case 3:
                    return e4.def("this", n5.data);
                  case 4:
                    return n5.data.append(t5, e4), n5.data.ref;
                  case 5:
                    return n5.data.toString();
                  case 6:
                    return n5.data.map(function(r5) {
                      return t5.invoke(e4, r5);
                    });
                }
              }, t5.attribCache = {};
              var u3 = {};
              return t5.scopeAttrib = function(t6) {
                if ((t6 = e3.id(t6)) in u3)
                  return u3[t6];
                var n5 = c2.scope[t6];
                return n5 || (n5 = c2.scope[t6] = new K2()), u3[t6] = r4(n5);
              }, t5;
            }
            function w3(t5, e4) {
              var r4 = t5.static, n4 = t5.dynamic;
              if ("framebuffer" in r4) {
                var i3 = r4.framebuffer;
                return i3 ? (i3 = l2.getFramebuffer(i3), U(function(t6, e5) {
                  var r5 = t6.link(i3), n5 = t6.shared;
                  return e5.set(n5.framebuffer, ".next", r5), n5 = n5.context, e5.set(n5, ".framebufferWidth", r5 + ".width"), e5.set(n5, ".framebufferHeight", r5 + ".height"), r5;
                })) : U(function(t6, e5) {
                  var r5 = t6.shared;
                  return e5.set(r5.framebuffer, ".next", "null"), r5 = r5.context, e5.set(r5, ".framebufferWidth", r5 + ".drawingBufferWidth"), e5.set(r5, ".framebufferHeight", r5 + ".drawingBufferHeight"), "null";
                });
              }
              if ("framebuffer" in n4) {
                var a3 = n4.framebuffer;
                return V(a3, function(t6, e5) {
                  var r5 = t6.invoke(e5, a3), n5 = t6.shared, i4 = n5.framebuffer;
                  return r5 = e5.def(i4, ".getFramebuffer(", r5, ")"), e5.set(i4, ".next", r5), n5 = n5.context, e5.set(n5, ".framebufferWidth", r5 + "?" + r5 + ".width:" + n5 + ".drawingBufferWidth"), e5.set(n5, ".framebufferHeight", r5 + "?" + r5 + ".height:" + n5 + ".drawingBufferHeight"), r5;
                });
              }
              return null;
            }
            function T2(t5, r4, n4) {
              function i3(t6) {
                if (t6 in a3) {
                  var r5 = e3.id(a3[t6]);
                  return (t6 = U(function() {
                    return r5;
                  })).id = r5, t6;
                }
                if (t6 in o2) {
                  var n5 = o2[t6];
                  return V(n5, function(t7, e4) {
                    var r6 = t7.invoke(e4, n5);
                    return e4.def(t7.shared.strings, ".id(", r6, ")");
                  });
                }
                return null;
              }
              var a3 = t5.static, o2 = t5.dynamic, s3 = i3("frag"), l3 = i3("vert"), u3 = null;
              return j(s3) && j(l3) ? (u3 = f3.program(l3.id, s3.id, null, n4), t5 = U(function(t6, e4) {
                return t6.link(u3);
              })) : t5 = new N(s3 && s3.thisDep || l3 && l3.thisDep, s3 && s3.contextDep || l3 && l3.contextDep, s3 && s3.propDep || l3 && l3.propDep, function(t6, e4) {
                var r5, n5, i4 = t6.shared.shader;
                return r5 = s3 ? s3.append(t6, e4) : e4.def(i4, ".", "frag"), n5 = l3 ? l3.append(t6, e4) : e4.def(i4, ".", "vert"), e4.def(i4 + ".program(" + n5 + "," + r5 + ")");
              }), { frag: s3, vert: l3, progVar: t5, program: u3 };
            }
            function k2(t5, e4) {
              function r4(t6, e5) {
                if (t6 in n4) {
                  var r5 = 0 | n4[t6];
                  return e5 ? o2.offset = r5 : o2.instances = r5, U(function(t7, n5) {
                    return e5 && (t7.OFFSET = r5), r5;
                  });
                }
                if (t6 in i3) {
                  var a3 = i3[t6];
                  return V(a3, function(t7, r6) {
                    var n5 = t7.invoke(r6, a3);
                    return e5 && (t7.OFFSET = n5), n5;
                  });
                }
                if (e5) {
                  if (u3)
                    return U(function(t7, e6) {
                      return t7.OFFSET = 0;
                    });
                  if (s3)
                    return new N(l3.thisDep, l3.contextDep, l3.propDep, function(t7, e6) {
                      return e6.def(t7.shared.vao + ".currentVAO?" + t7.shared.vao + ".currentVAO.offset:0");
                    });
                } else if (s3)
                  return new N(l3.thisDep, l3.contextDep, l3.propDep, function(t7, e6) {
                    return e6.def(t7.shared.vao + ".currentVAO?" + t7.shared.vao + ".currentVAO.instances:-1");
                  });
                return null;
              }
              var n4 = t5.static, i3 = t5.dynamic, o2 = {}, s3 = false, l3 = function() {
                if ("vao" in n4) {
                  var t6 = n4.vao;
                  return null !== t6 && null === c2.getVAO(t6) && (t6 = c2.createVAO(t6)), s3 = true, o2.vao = t6, U(function(e6) {
                    var r5 = c2.getVAO(t6);
                    return r5 ? e6.link(r5) : "null";
                  });
                }
                if ("vao" in i3) {
                  s3 = true;
                  var e5 = i3.vao;
                  return V(e5, function(t7, r5) {
                    var n5 = t7.invoke(r5, e5);
                    return r5.def(t7.shared.vao + ".getVAO(" + n5 + ")");
                  });
                }
                return null;
              }(), u3 = false, f4 = function() {
                if ("elements" in n4) {
                  var t6 = n4.elements;
                  if (o2.elements = t6, F(t6)) {
                    var e5 = o2.elements = a2.create(t6, true);
                    t6 = a2.getElements(e5), u3 = true;
                  } else
                    t6 && (t6 = a2.getElements(t6), u3 = true);
                  return e5 = U(function(e6, r6) {
                    if (t6) {
                      var n5 = e6.link(t6);
                      return e6.ELEMENTS = n5;
                    }
                    return e6.ELEMENTS = null;
                  }), e5.value = t6, e5;
                }
                if ("elements" in i3) {
                  u3 = true;
                  var r5 = i3.elements;
                  return V(r5, function(t7, e6) {
                    var n5 = (i4 = t7.shared).isBufferArgs, i4 = i4.elements, a3 = t7.invoke(e6, r5), o3 = e6.def("null");
                    return n5 = e6.def(n5, "(", a3, ")"), a3 = t7.cond(n5).then(o3, "=", i4, ".createStream(", a3, ");").else(o3, "=", i4, ".getElements(", a3, ");"), e6.entry(a3), e6.exit(t7.cond(n5).then(i4, ".destroyStream(", o3, ");")), t7.ELEMENTS = o3;
                  });
                }
                return s3 ? new N(l3.thisDep, l3.contextDep, l3.propDep, function(t7, e6) {
                  return e6.def(t7.shared.vao + ".currentVAO?" + t7.shared.elements + ".getElements(" + t7.shared.vao + ".currentVAO.elements):null");
                }) : null;
              }(), h3 = r4("offset", true), p4 = function() {
                if ("primitive" in n4) {
                  var t6 = n4.primitive;
                  return o2.primitive = t6, U(function(e6, r5) {
                    return st[t6];
                  });
                }
                if ("primitive" in i3) {
                  var e5 = i3.primitive;
                  return V(e5, function(t7, r5) {
                    var n5 = t7.constants.primTypes, i4 = t7.invoke(r5, e5);
                    return r5.def(n5, "[", i4, "]");
                  });
                }
                return u3 ? j(f4) ? f4.value ? U(function(t7, e6) {
                  return e6.def(t7.ELEMENTS, ".primType");
                }) : U(function() {
                  return 4;
                }) : new N(f4.thisDep, f4.contextDep, f4.propDep, function(t7, e6) {
                  var r5 = t7.ELEMENTS;
                  return e6.def(r5, "?", r5, ".primType:", 4);
                }) : s3 ? new N(l3.thisDep, l3.contextDep, l3.propDep, function(t7, e6) {
                  return e6.def(t7.shared.vao + ".currentVAO?" + t7.shared.vao + ".currentVAO.primitive:4");
                }) : null;
              }(), d4 = function() {
                if ("count" in n4) {
                  var t6 = 0 | n4.count;
                  return o2.count = t6, U(function() {
                    return t6;
                  });
                }
                if ("count" in i3) {
                  var e5 = i3.count;
                  return V(e5, function(t7, r5) {
                    return t7.invoke(r5, e5);
                  });
                }
                return u3 ? j(f4) ? f4 ? h3 ? new N(h3.thisDep, h3.contextDep, h3.propDep, function(t7, e6) {
                  return e6.def(t7.ELEMENTS, ".vertCount-", t7.OFFSET);
                }) : U(function(t7, e6) {
                  return e6.def(t7.ELEMENTS, ".vertCount");
                }) : U(function() {
                  return -1;
                }) : new N(f4.thisDep || h3.thisDep, f4.contextDep || h3.contextDep, f4.propDep || h3.propDep, function(t7, e6) {
                  var r5 = t7.ELEMENTS;
                  return t7.OFFSET ? e6.def(r5, "?", r5, ".vertCount-", t7.OFFSET, ":-1") : e6.def(r5, "?", r5, ".vertCount:-1");
                }) : s3 ? new N(l3.thisDep, l3.contextDep, l3.propDep, function(t7, e6) {
                  return e6.def(t7.shared.vao, ".currentVAO?", t7.shared.vao, ".currentVAO.count:-1");
                }) : null;
              }(), v3 = r4("instances", false);
              return { elements: f4, primitive: p4, count: d4, instances: v3, offset: h3, vao: l3, vaoActive: s3, elementsActive: u3, static: o2 };
            }
            function A2(t5, r4) {
              var n4 = t5.static, a3 = t5.dynamic, o2 = {};
              return Object.keys(n4).forEach(function(t6) {
                var r5 = n4[t6], a4 = e3.id(t6), s3 = new K2();
                if (F(r5))
                  s3.state = 1, s3.buffer = i2.getBuffer(i2.create(r5, 34962, false, true)), s3.type = 0;
                else if (u3 = i2.getBuffer(r5))
                  s3.state = 1, s3.buffer = u3, s3.type = 0;
                else if ("constant" in r5) {
                  var l3 = r5.constant;
                  s3.buffer = "null", s3.state = 2, "number" == typeof l3 ? s3.x = l3 : St.forEach(function(t7, e4) {
                    e4 < l3.length && (s3[t7] = l3[e4]);
                  });
                } else {
                  var u3 = F(r5.buffer) ? i2.getBuffer(i2.create(r5.buffer, 34962, false, true)) : i2.getBuffer(r5.buffer), c3 = 0 | r5.offset, f4 = 0 | r5.stride, h3 = 0 | r5.size, p4 = !!r5.normalized, d4 = 0;
                  "type" in r5 && (d4 = rt[r5.type]), r5 = 0 | r5.divisor, s3.buffer = u3, s3.state = 1, s3.size = h3, s3.normalized = p4, s3.type = d4 || u3.dtype, s3.offset = c3, s3.stride = f4, s3.divisor = r5;
                }
                o2[t6] = U(function(t7, e4) {
                  var r6 = t7.attribCache;
                  if (a4 in r6)
                    return r6[a4];
                  var n5 = { isStream: false };
                  return Object.keys(s3).forEach(function(t8) {
                    n5[t8] = s3[t8];
                  }), s3.buffer && (n5.buffer = t7.link(s3.buffer), n5.type = n5.type || n5.buffer + ".dtype"), r6[a4] = n5;
                });
              }), Object.keys(a3).forEach(function(t6) {
                var e4 = a3[t6];
                o2[t6] = V(e4, function(t7, r5) {
                  function n5(t8) {
                    r5(l3[t8], "=", i3, ".", t8, "|0;");
                  }
                  var i3 = t7.invoke(r5, e4), a4 = t7.shared, o3 = t7.constants, s3 = a4.isBufferArgs, l3 = (a4 = a4.buffer, { isStream: r5.def(false) }), u3 = new K2();
                  u3.state = 1, Object.keys(u3).forEach(function(t8) {
                    l3[t8] = r5.def("" + u3[t8]);
                  });
                  var c3 = l3.buffer, f4 = l3.type;
                  return r5("if(", s3, "(", i3, ")){", l3.isStream, "=true;", c3, "=", a4, ".createStream(", 34962, ",", i3, ");", f4, "=", c3, ".dtype;", "}else{", c3, "=", a4, ".getBuffer(", i3, ");", "if(", c3, "){", f4, "=", c3, ".dtype;", '}else if("constant" in ', i3, "){", l3.state, "=", 2, ";", "if(typeof " + i3 + '.constant === "number"){', l3[St[0]], "=", i3, ".constant;", St.slice(1).map(function(t8) {
                    return l3[t8];
                  }).join("="), "=0;", "}else{", St.map(function(t8, e5) {
                    return l3[t8] + "=" + i3 + ".constant.length>" + e5 + "?" + i3 + ".constant[" + e5 + "]:0;";
                  }).join(""), "}}else{", "if(", s3, "(", i3, ".buffer)){", c3, "=", a4, ".createStream(", 34962, ",", i3, ".buffer);", "}else{", c3, "=", a4, ".getBuffer(", i3, ".buffer);", "}", f4, '="type" in ', i3, "?", o3.glTypes, "[", i3, ".type]:", c3, ".dtype;", l3.normalized, "=!!", i3, ".normalized;"), n5("size"), n5("offset"), n5("stride"), n5("divisor"), r5("}}"), r5.exit("if(", l3.isStream, "){", a4, ".destroyStream(", c3, ");", "}"), l3;
                });
              }), o2;
            }
            function M2(t5, e4, n4, i3, a3) {
              function s3(t6) {
                var e5 = u3[t6];
                e5 && (h3[t6] = e5);
              }
              var l3 = function(t6, e5) {
                if ("string" == typeof (r4 = t6.static).frag && "string" == typeof r4.vert) {
                  if (0 < Object.keys(e5.dynamic).length)
                    return null;
                  var r4 = e5.static, n5 = Object.keys(r4);
                  if (0 < n5.length && "number" == typeof r4[n5[0]]) {
                    for (var i4 = [], a4 = 0; a4 < n5.length; ++a4)
                      i4.push([0 | r4[n5[a4]], n5[a4]]);
                    return i4;
                  }
                }
                return null;
              }(t5, e4), u3 = function(t6, e5, r4) {
                function n5(t7) {
                  if (t7 in i4) {
                    var r5 = i4[t7];
                    t7 = true;
                    var n6, o3, s4 = 0 | r5.x, l4 = 0 | r5.y;
                    return "width" in r5 ? n6 = 0 | r5.width : t7 = false, "height" in r5 ? o3 = 0 | r5.height : t7 = false, new N(!t7 && e5 && e5.thisDep, !t7 && e5 && e5.contextDep, !t7 && e5 && e5.propDep, function(t8, e6) {
                      var i5 = t8.shared.context, a5 = n6;
                      "width" in r5 || (a5 = e6.def(i5, ".", "framebufferWidth", "-", s4));
                      var u5 = o3;
                      return "height" in r5 || (u5 = e6.def(i5, ".", "framebufferHeight", "-", l4)), [s4, l4, a5, u5];
                    });
                  }
                  if (t7 in a4) {
                    var u4 = a4[t7];
                    return t7 = V(u4, function(t8, e6) {
                      var r6 = t8.invoke(e6, u4), n7 = t8.shared.context, i5 = e6.def(r6, ".x|0"), a5 = e6.def(r6, ".y|0");
                      return [i5, a5, e6.def('"width" in ', r6, "?", r6, ".width|0:", "(", n7, ".", "framebufferWidth", "-", i5, ")"), r6 = e6.def('"height" in ', r6, "?", r6, ".height|0:", "(", n7, ".", "framebufferHeight", "-", a5, ")")];
                    }), e5 && (t7.thisDep = t7.thisDep || e5.thisDep, t7.contextDep = t7.contextDep || e5.contextDep, t7.propDep = t7.propDep || e5.propDep), t7;
                  }
                  return e5 ? new N(e5.thisDep, e5.contextDep, e5.propDep, function(t8, e6) {
                    var r6 = t8.shared.context;
                    return [0, 0, e6.def(r6, ".", "framebufferWidth"), e6.def(r6, ".", "framebufferHeight")];
                  }) : null;
                }
                var i4 = t6.static, a4 = t6.dynamic;
                if (t6 = n5("viewport")) {
                  var o2 = t6;
                  t6 = new N(t6.thisDep, t6.contextDep, t6.propDep, function(t7, e6) {
                    var r5 = o2.append(t7, e6), n6 = t7.shared.context;
                    return e6.set(n6, ".viewportWidth", r5[2]), e6.set(n6, ".viewportHeight", r5[3]), r5;
                  });
                }
                return { viewport: t6, scissor_box: n5("scissor.box") };
              }(t5, d4 = w3(t5)), f4 = k2(t5), h3 = function(t6, e5) {
                var r4 = t6.static, n5 = t6.dynamic, i4 = {};
                return at2.forEach(function(t7) {
                  function e6(e7, o2) {
                    if (t7 in r4) {
                      var s4 = e7(r4[t7]);
                      i4[a4] = U(function() {
                        return s4;
                      });
                    } else if (t7 in n5) {
                      var l4 = n5[t7];
                      i4[a4] = V(l4, function(t8, e8) {
                        return o2(t8, e8, t8.invoke(e8, l4));
                      });
                    }
                  }
                  var a4 = y2(t7);
                  switch (t7) {
                    case "cull.enable":
                    case "blend.enable":
                    case "dither":
                    case "stencil.enable":
                    case "depth.enable":
                    case "scissor.enable":
                    case "polygonOffset.enable":
                    case "sample.alpha":
                    case "sample.enable":
                    case "depth.mask":
                    case "lineWidth":
                      return e6(function(t8) {
                        return t8;
                      }, function(t8, e7, r5) {
                        return r5;
                      });
                    case "depth.func":
                      return e6(function(t8) {
                        return Ct[t8];
                      }, function(t8, e7, r5) {
                        return e7.def(t8.constants.compareFuncs, "[", r5, "]");
                      });
                    case "depth.range":
                      return e6(function(t8) {
                        return t8;
                      }, function(t8, e7, r5) {
                        return [e7.def("+", r5, "[0]"), e7 = e7.def("+", r5, "[1]")];
                      });
                    case "blend.func":
                      return e6(function(t8) {
                        return [Lt["srcRGB" in t8 ? t8.srcRGB : t8.src], Lt["dstRGB" in t8 ? t8.dstRGB : t8.dst], Lt["srcAlpha" in t8 ? t8.srcAlpha : t8.src], Lt["dstAlpha" in t8 ? t8.dstAlpha : t8.dst]];
                      }, function(t8, e7, r5) {
                        function n6(t9, n7) {
                          return e7.def('"', t9, n7, '" in ', r5, "?", r5, ".", t9, n7, ":", r5, ".", t9);
                        }
                        t8 = t8.constants.blendFuncs;
                        var i5 = n6("src", "RGB"), a5 = n6("dst", "RGB"), o2 = (i5 = e7.def(t8, "[", i5, "]"), e7.def(t8, "[", n6("src", "Alpha"), "]"));
                        return [i5, a5 = e7.def(t8, "[", a5, "]"), o2, t8 = e7.def(t8, "[", n6("dst", "Alpha"), "]")];
                      });
                    case "blend.equation":
                      return e6(function(t8) {
                        return "string" == typeof t8 ? [$2[t8], $2[t8]] : "object" == typeof t8 ? [$2[t8.rgb], $2[t8.alpha]] : void 0;
                      }, function(t8, e7, r5) {
                        var n6 = t8.constants.blendEquations, i5 = e7.def(), a5 = e7.def();
                        return (t8 = t8.cond("typeof ", r5, '==="string"')).then(i5, "=", a5, "=", n6, "[", r5, "];"), t8.else(i5, "=", n6, "[", r5, ".rgb];", a5, "=", n6, "[", r5, ".alpha];"), e7(t8), [i5, a5];
                      });
                    case "blend.color":
                      return e6(function(t8) {
                        return o(4, function(e7) {
                          return +t8[e7];
                        });
                      }, function(t8, e7, r5) {
                        return o(4, function(t9) {
                          return e7.def("+", r5, "[", t9, "]");
                        });
                      });
                    case "stencil.mask":
                      return e6(function(t8) {
                        return 0 | t8;
                      }, function(t8, e7, r5) {
                        return e7.def(r5, "|0");
                      });
                    case "stencil.func":
                      return e6(function(t8) {
                        return [Ct[t8.cmp || "keep"], t8.ref || 0, "mask" in t8 ? t8.mask : -1];
                      }, function(t8, e7, r5) {
                        return [t8 = e7.def('"cmp" in ', r5, "?", t8.constants.compareFuncs, "[", r5, ".cmp]", ":", 7680), e7.def(r5, ".ref|0"), e7 = e7.def('"mask" in ', r5, "?", r5, ".mask|0:-1")];
                      });
                    case "stencil.opFront":
                    case "stencil.opBack":
                      return e6(function(e7) {
                        return ["stencil.opBack" === t7 ? 1029 : 1028, Pt[e7.fail || "keep"], Pt[e7.zfail || "keep"], Pt[e7.zpass || "keep"]];
                      }, function(e7, r5, n6) {
                        function i5(t8) {
                          return r5.def('"', t8, '" in ', n6, "?", a5, "[", n6, ".", t8, "]:", 7680);
                        }
                        var a5 = e7.constants.stencilOps;
                        return ["stencil.opBack" === t7 ? 1029 : 1028, i5("fail"), i5("zfail"), i5("zpass")];
                      });
                    case "polygonOffset.offset":
                      return e6(function(t8) {
                        return [0 | t8.factor, 0 | t8.units];
                      }, function(t8, e7, r5) {
                        return [e7.def(r5, ".factor|0"), e7 = e7.def(r5, ".units|0")];
                      });
                    case "cull.face":
                      return e6(function(t8) {
                        var e7 = 0;
                        return "front" === t8 ? e7 = 1028 : "back" === t8 && (e7 = 1029), e7;
                      }, function(t8, e7, r5) {
                        return e7.def(r5, '==="front"?', 1028, ":", 1029);
                      });
                    case "frontFace":
                      return e6(function(t8) {
                        return Ot[t8];
                      }, function(t8, e7, r5) {
                        return e7.def(r5 + '==="cw"?2304:2305');
                      });
                    case "colorMask":
                      return e6(function(t8) {
                        return t8.map(function(t9) {
                          return !!t9;
                        });
                      }, function(t8, e7, r5) {
                        return o(4, function(t9) {
                          return "!!" + r5 + "[" + t9 + "]";
                        });
                      });
                    case "sample.coverage":
                      return e6(function(t8) {
                        return ["value" in t8 ? t8.value : 1, !!t8.invert];
                      }, function(t8, e7, r5) {
                        return [e7.def('"value" in ', r5, "?+", r5, ".value:1"), e7 = e7.def("!!", r5, ".invert")];
                      });
                  }
                }), i4;
              }(t5), p4 = T2(t5, 0, l3);
              s3("viewport"), s3(y2("scissor.box"));
              var d4, v3 = 0 < Object.keys(h3).length;
              if ((d4 = { framebuffer: d4, draw: f4, shader: p4, state: h3, dirty: v3, scopeVAO: null, drawVAO: null, useVAO: false, attributes: {} }).profile = function(t6) {
                var e5, r4 = t6.static;
                if (t6 = t6.dynamic, "profile" in r4) {
                  var n5 = !!r4.profile;
                  (e5 = U(function(t7, e6) {
                    return n5;
                  })).enable = n5;
                } else if ("profile" in t6) {
                  var i4 = t6.profile;
                  e5 = V(i4, function(t7, e6) {
                    return t7.invoke(e6, i4);
                  });
                }
                return e5;
              }(t5), d4.uniforms = function(t6, e5) {
                var r4 = t6.static, n5 = t6.dynamic, i4 = {};
                return Object.keys(r4).forEach(function(t7) {
                  var e6, n6 = r4[t7];
                  if ("number" == typeof n6 || "boolean" == typeof n6)
                    e6 = U(function() {
                      return n6;
                    });
                  else if ("function" == typeof n6) {
                    var a4 = n6._reglType;
                    "texture2d" === a4 || "textureCube" === a4 ? e6 = U(function(t8) {
                      return t8.link(n6);
                    }) : "framebuffer" !== a4 && "framebufferCube" !== a4 || (e6 = U(function(t8) {
                      return t8.link(n6.color[0]);
                    }));
                  } else
                    m2(n6) && (e6 = U(function(t8) {
                      return t8.global.def("[", o(n6.length, function(t9) {
                        return n6[t9];
                      }), "]");
                    }));
                  e6.value = n6, i4[t7] = e6;
                }), Object.keys(n5).forEach(function(t7) {
                  var e6 = n5[t7];
                  i4[t7] = V(e6, function(t8, r5) {
                    return t8.invoke(r5, e6);
                  });
                }), i4;
              }(n4), d4.drawVAO = d4.scopeVAO = f4.vao, !d4.drawVAO && p4.program && !l3 && r3.angle_instanced_arrays && f4.static.elements) {
                var g4 = true;
                if (t5 = p4.program.attributes.map(function(t6) {
                  return t6 = e4.static[t6], g4 = g4 && !!t6, t6;
                }), g4 && 0 < t5.length) {
                  var x3 = c2.getVAO(c2.createVAO({ attributes: t5, elements: f4.static.elements }));
                  d4.drawVAO = new N(null, null, null, function(t6, e5) {
                    return t6.link(x3);
                  }), d4.useVAO = true;
                }
              }
              return l3 ? d4.useVAO = true : d4.attributes = A2(e4), d4.context = function(t6) {
                var e5 = t6.static, r4 = t6.dynamic, n5 = {};
                return Object.keys(e5).forEach(function(t7) {
                  var r5 = e5[t7];
                  n5[t7] = U(function(t8, e6) {
                    return "number" == typeof r5 || "boolean" == typeof r5 ? "" + r5 : t8.link(r5);
                  });
                }), Object.keys(r4).forEach(function(t7) {
                  var e6 = r4[t7];
                  n5[t7] = V(e6, function(t8, r5) {
                    return t8.invoke(r5, e6);
                  });
                }), n5;
              }(i3), d4;
            }
            function S2(t5, e4, r4) {
              var n4 = t5.shared.context, i3 = t5.scope();
              Object.keys(r4).forEach(function(a3) {
                e4.save(n4, "." + a3);
                var o2 = r4[a3].append(t5, e4);
                Array.isArray(o2) ? i3(n4, ".", a3, "=[", o2.join(), "];") : i3(n4, ".", a3, "=", o2, ";");
              }), e4(i3);
            }
            function E2(t5, e4, r4, n4) {
              var i3, a3 = (s3 = t5.shared).gl, o2 = s3.framebuffer;
              tt2 && (i3 = e4.def(s3.extensions, ".webgl_draw_buffers"));
              var s3 = (l3 = t5.constants).drawBuffer, l3 = l3.backBuffer;
              t5 = r4 ? r4.append(t5, e4) : e4.def(o2, ".next"), n4 || e4("if(", t5, "!==", o2, ".cur){"), e4("if(", t5, "){", a3, ".bindFramebuffer(", 36160, ",", t5, ".framebuffer);"), tt2 && e4(i3, ".drawBuffersWEBGL(", s3, "[", t5, ".colorAttachments.length]);"), e4("}else{", a3, ".bindFramebuffer(", 36160, ",null);"), tt2 && e4(i3, ".drawBuffersWEBGL(", l3, ");"), e4("}", o2, ".cur=", t5, ";"), n4 || e4("}");
            }
            function L2(t5, e4, r4) {
              var n4 = t5.shared, i3 = n4.gl, a3 = t5.current, s3 = t5.next, l3 = n4.current, u3 = n4.next, c3 = t5.cond(l3, ".dirty");
              at2.forEach(function(e5) {
                var n5, f4;
                if (!((e5 = y2(e5)) in r4.state))
                  if (e5 in s3) {
                    n5 = s3[e5], f4 = a3[e5];
                    var h3 = o(nt2[e5].length, function(t6) {
                      return c3.def(n5, "[", t6, "]");
                    });
                    c3(t5.cond(h3.map(function(t6, e6) {
                      return t6 + "!==" + f4 + "[" + e6 + "]";
                    }).join("||")).then(i3, ".", lt2[e5], "(", h3, ");", h3.map(function(t6, e6) {
                      return f4 + "[" + e6 + "]=" + t6;
                    }).join(";"), ";"));
                  } else
                    n5 = c3.def(u3, ".", e5), h3 = t5.cond(n5, "!==", l3, ".", e5), c3(h3), e5 in ot2 ? h3(t5.cond(n5).then(i3, ".enable(", ot2[e5], ");").else(i3, ".disable(", ot2[e5], ");"), l3, ".", e5, "=", n5, ";") : h3(i3, ".", lt2[e5], "(", n5, ");", l3, ".", e5, "=", n5, ";");
              }), 0 === Object.keys(r4.state).length && c3(l3, ".dirty=false;"), e4(c3);
            }
            function C2(t5, e4, r4, n4) {
              var i3, a3 = t5.shared, o2 = t5.current, s3 = a3.current, l3 = a3.gl;
              B(Object.keys(r4)).forEach(function(a4) {
                var u3 = r4[a4];
                if (!n4 || n4(u3)) {
                  var c3 = u3.append(t5, e4);
                  if (ot2[a4]) {
                    var f4 = ot2[a4];
                    j(u3) ? (i3 = t5.link(c3, { stable: true }), e4(t5.cond(i3).then(l3, ".enable(", f4, ");").else(l3, ".disable(", f4, ");")), e4(s3, ".", a4, "=", i3, ";")) : (e4(t5.cond(c3).then(l3, ".enable(", f4, ");").else(l3, ".disable(", f4, ");")), e4(s3, ".", a4, "=", c3, ";"));
                  } else if (m2(c3)) {
                    var h3 = o2[a4];
                    e4(l3, ".", lt2[a4], "(", c3, ");", c3.map(function(t6, e5) {
                      return h3 + "[" + e5 + "]=" + t6;
                    }).join(";"), ";");
                  } else
                    j(u3) ? (i3 = t5.link(c3, { stable: true }), e4(l3, ".", lt2[a4], "(", i3, ");", s3, ".", a4, "=", i3, ";")) : e4(l3, ".", lt2[a4], "(", c3, ");", s3, ".", a4, "=", c3, ";");
                }
              });
            }
            function P2(t5, e4) {
              Q2 && (t5.instancing = e4.def(t5.shared.extensions, ".angle_instanced_arrays"));
            }
            function O2(t5, e4, r4, n4, i3) {
              function a3() {
                return "undefined" == typeof performance ? "Date.now()" : "performance.now()";
              }
              function o2(t6) {
                t6(u3 = e4.def(), "=", a3(), ";"), "string" == typeof i3 ? t6(h3, ".count+=", i3, ";") : t6(h3, ".count++;"), d3 && (n4 ? t6(c3 = e4.def(), "=", v3, ".getNumPendingQueries();") : t6(v3, ".beginQuery(", h3, ");"));
              }
              function s3(t6) {
                t6(h3, ".cpuTime+=", a3(), "-", u3, ";"), d3 && (n4 ? t6(v3, ".pushScopeStats(", c3, ",", v3, ".getNumPendingQueries(),", h3, ");") : t6(v3, ".endQuery();"));
              }
              function l3(t6) {
                var r5 = e4.def(p4, ".profile");
                e4(p4, ".profile=", t6, ";"), e4.exit(p4, ".profile=", r5, ";");
              }
              var u3, c3, f4 = t5.shared, h3 = t5.stats, p4 = f4.current, v3 = f4.timer;
              if (r4 = r4.profile) {
                if (j(r4))
                  return void (r4.enable ? (o2(e4), s3(e4.exit), l3("true")) : l3("false"));
                l3(r4 = r4.append(t5, e4));
              } else
                r4 = e4.def(p4, ".profile");
              o2(f4 = t5.block()), e4("if(", r4, "){", f4, "}"), s3(t5 = t5.block()), e4.exit("if(", r4, "){", t5, "}");
            }
            function I2(t5, e4, r4, n4, i3) {
              function a3(r5, n5, i4) {
                function a4() {
                  e4("if(!", c3, ".buffer){", l3, ".enableVertexAttribArray(", u3, ");}");
                  var r6, a5 = i4.type;
                  r6 = i4.size ? e4.def(i4.size, "||", n5) : n5, e4("if(", c3, ".type!==", a5, "||", c3, ".size!==", r6, "||", p4.map(function(t6) {
                    return c3 + "." + t6 + "!==" + i4[t6];
                  }).join("||"), "){", l3, ".bindBuffer(", 34962, ",", f4, ".buffer);", l3, ".vertexAttribPointer(", [u3, r6, a5, i4.normalized, i4.stride, i4.offset], ");", c3, ".type=", a5, ";", c3, ".size=", r6, ";", p4.map(function(t6) {
                    return c3 + "." + t6 + "=" + i4[t6] + ";";
                  }).join(""), "}"), Q2 && (a5 = i4.divisor, e4("if(", c3, ".divisor!==", a5, "){", t5.instancing, ".vertexAttribDivisorANGLE(", [u3, a5], ");", c3, ".divisor=", a5, ";}"));
                }
                function s3() {
                  e4("if(", c3, ".buffer){", l3, ".disableVertexAttribArray(", u3, ");", c3, ".buffer=null;", "}if(", St.map(function(t6, e5) {
                    return c3 + "." + t6 + "!==" + h3[e5];
                  }).join("||"), "){", l3, ".vertexAttrib4f(", u3, ",", h3, ");", St.map(function(t6, e5) {
                    return c3 + "." + t6 + "=" + h3[e5] + ";";
                  }).join(""), "}");
                }
                var l3 = o2.gl, u3 = e4.def(r5, ".location"), c3 = e4.def(o2.attributes, "[", u3, "]");
                r5 = i4.state;
                var f4 = i4.buffer, h3 = [i4.x, i4.y, i4.z, i4.w], p4 = ["buffer", "normalized", "offset", "stride"];
                1 === r5 ? a4() : 2 === r5 ? s3() : (e4("if(", r5, "===", 1, "){"), a4(), e4("}else{"), s3(), e4("}"));
              }
              var o2 = t5.shared;
              n4.forEach(function(n5) {
                var o3, s3 = n5.name, l3 = r4.attributes[s3];
                if (l3) {
                  if (!i3(l3))
                    return;
                  o3 = l3.append(t5, e4);
                } else {
                  if (!i3(It))
                    return;
                  var u3 = t5.scopeAttrib(s3);
                  o3 = {}, Object.keys(new K2()).forEach(function(t6) {
                    o3[t6] = e4.def(u3, ".", t6);
                  });
                }
                a3(t5.link(n5), function(t6) {
                  switch (t6) {
                    case 35664:
                    case 35667:
                    case 35671:
                      return 2;
                    case 35665:
                    case 35668:
                    case 35672:
                      return 3;
                    case 35666:
                    case 35669:
                    case 35673:
                      return 4;
                    default:
                      return 1;
                  }
                }(n5.info.type), o3);
              });
            }
            function D2(t5, r4, n4, i3, a3, s3) {
              for (var l3, u3 = t5.shared, c3 = u3.gl, f4 = 0; f4 < i3.length; ++f4) {
                var h3, p4 = (g4 = i3[f4]).name, d4 = g4.info.type, v3 = n4.uniforms[p4], g4 = t5.link(g4) + ".location";
                if (v3) {
                  if (!a3(v3))
                    continue;
                  if (j(v3)) {
                    if (p4 = v3.value, 35678 === d4 || 35680 === d4)
                      r4(c3, ".uniform1i(", g4, ",", (d4 = t5.link(p4._texture || p4.color[0]._texture)) + ".bind());"), r4.exit(d4, ".unbind();");
                    else if (35674 === d4 || 35675 === d4 || 35676 === d4)
                      v3 = 2, 35675 === d4 ? v3 = 3 : 35676 === d4 && (v3 = 4), r4(c3, ".uniformMatrix", v3, "fv(", g4, ",false,", p4 = t5.global.def("new Float32Array([" + Array.prototype.slice.call(p4) + "])"), ");");
                    else {
                      switch (d4) {
                        case 5126:
                          l3 = "1f";
                          break;
                        case 35664:
                          l3 = "2f";
                          break;
                        case 35665:
                          l3 = "3f";
                          break;
                        case 35666:
                          l3 = "4f";
                          break;
                        case 35670:
                        case 5124:
                          l3 = "1i";
                          break;
                        case 35671:
                        case 35667:
                          l3 = "2i";
                          break;
                        case 35672:
                        case 35668:
                          l3 = "3i";
                          break;
                        case 35673:
                        case 35669:
                          l3 = "4i";
                      }
                      r4(c3, ".uniform", l3, "(", g4, ",", m2(p4) ? Array.prototype.slice.call(p4) : p4, ");");
                    }
                    continue;
                  }
                  h3 = v3.append(t5, r4);
                } else {
                  if (!a3(It))
                    continue;
                  h3 = r4.def(u3.uniforms, "[", e3.id(p4), "]");
                }
                switch (35678 === d4 ? r4("if(", h3, "&&", h3, '._reglType==="framebuffer"){', h3, "=", h3, ".color[0];", "}") : 35680 === d4 && r4("if(", h3, "&&", h3, '._reglType==="framebufferCube"){', h3, "=", h3, ".color[0];", "}"), p4 = 1, d4) {
                  case 35678:
                  case 35680:
                    d4 = r4.def(h3, "._texture"), r4(c3, ".uniform1i(", g4, ",", d4, ".bind());"), r4.exit(d4, ".unbind();");
                    continue;
                  case 5124:
                  case 35670:
                    l3 = "1i";
                    break;
                  case 35667:
                  case 35671:
                    l3 = "2i", p4 = 2;
                    break;
                  case 35668:
                  case 35672:
                    l3 = "3i", p4 = 3;
                    break;
                  case 35669:
                  case 35673:
                    l3 = "4i", p4 = 4;
                    break;
                  case 5126:
                    l3 = "1f";
                    break;
                  case 35664:
                    l3 = "2f", p4 = 2;
                    break;
                  case 35665:
                    l3 = "3f", p4 = 3;
                    break;
                  case 35666:
                    l3 = "4f", p4 = 4;
                    break;
                  case 35674:
                    l3 = "Matrix2fv";
                    break;
                  case 35675:
                    l3 = "Matrix3fv";
                    break;
                  case 35676:
                    l3 = "Matrix4fv";
                }
                if ("M" === l3.charAt(0)) {
                  r4(c3, ".uniform", l3, "(", g4, ","), g4 = Math.pow(d4 - 35674 + 2, 2);
                  var y3 = t5.global.def("new Float32Array(", g4, ")");
                  Array.isArray(h3) ? r4("false,(", o(g4, function(t6) {
                    return y3 + "[" + t6 + "]=" + h3[t6];
                  }), ",", y3, ")") : r4("false,(Array.isArray(", h3, ")||", h3, " instanceof Float32Array)?", h3, ":(", o(g4, function(t6) {
                    return y3 + "[" + t6 + "]=" + h3 + "[" + t6 + "]";
                  }), ",", y3, ")"), r4(");");
                } else {
                  if (1 < p4) {
                    d4 = [];
                    var x3 = [];
                    for (v3 = 0; v3 < p4; ++v3)
                      Array.isArray(h3) ? x3.push(h3[v3]) : x3.push(r4.def(h3 + "[" + v3 + "]")), s3 && d4.push(r4.def());
                    s3 && r4("if(!", t5.batchId, "||", d4.map(function(t6, e4) {
                      return t6 + "!==" + x3[e4];
                    }).join("||"), "){", d4.map(function(t6, e4) {
                      return t6 + "=" + x3[e4] + ";";
                    }).join("")), r4(c3, ".uniform", l3, "(", g4, ",", x3.join(","), ");");
                  } else
                    s3 && (d4 = r4.def(), r4("if(!", t5.batchId, "||", d4, "!==", h3, "){", d4, "=", h3, ";")), r4(c3, ".uniform", l3, "(", g4, ",", h3, ");");
                  s3 && r4("}");
                }
              }
            }
            function z2(t5, e4, r4, n4) {
              function i3(i4) {
                var a4 = h3[i4];
                return a4 ? a4.contextDep && n4.contextDynamic || a4.propDep ? a4.append(t5, r4) : a4.append(t5, e4) : e4.def(f4, ".", i4);
              }
              function a3() {
                function t6() {
                  r4(l3, ".drawElementsInstancedANGLE(", [d4, g4, y3, v3 + "<<((" + y3 + "-5121)>>1)", s3], ");");
                }
                function e5() {
                  r4(l3, ".drawArraysInstancedANGLE(", [d4, v3, g4, s3], ");");
                }
                p4 && "null" !== p4 ? m3 ? t6() : (r4("if(", p4, "){"), t6(), r4("}else{"), e5(), r4("}")) : e5();
              }
              function o2() {
                function t6() {
                  r4(c3 + ".drawElements(" + [d4, g4, y3, v3 + "<<((" + y3 + "-5121)>>1)"] + ");");
                }
                function e5() {
                  r4(c3 + ".drawArrays(" + [d4, v3, g4] + ");");
                }
                p4 && "null" !== p4 ? m3 ? t6() : (r4("if(", p4, "){"), t6(), r4("}else{"), e5(), r4("}")) : e5();
              }
              var s3, l3, u3 = t5.shared, c3 = u3.gl, f4 = u3.draw, h3 = n4.draw, p4 = function() {
                var i4 = h3.elements, a4 = e4;
                return i4 ? ((i4.contextDep && n4.contextDynamic || i4.propDep) && (a4 = r4), i4 = i4.append(t5, a4), h3.elementsActive && a4("if(" + i4 + ")" + c3 + ".bindBuffer(34963," + i4 + ".buffer.buffer);")) : (i4 = a4.def(), a4(i4, "=", f4, ".", "elements", ";", "if(", i4, "){", c3, ".bindBuffer(", 34963, ",", i4, ".buffer.buffer);}", "else if(", u3.vao, ".currentVAO){", i4, "=", t5.shared.elements + ".getElements(" + u3.vao, ".currentVAO.elements);", et2 ? "" : "if(" + i4 + ")" + c3 + ".bindBuffer(34963," + i4 + ".buffer.buffer);", "}")), i4;
              }(), d4 = i3("primitive"), v3 = i3("offset"), g4 = function() {
                var i4 = h3.count, a4 = e4;
                return i4 ? ((i4.contextDep && n4.contextDynamic || i4.propDep) && (a4 = r4), i4 = i4.append(t5, a4)) : i4 = a4.def(f4, ".", "count"), i4;
              }();
              if ("number" == typeof g4) {
                if (0 === g4)
                  return;
              } else
                r4("if(", g4, "){"), r4.exit("}");
              Q2 && (s3 = i3("instances"), l3 = t5.instancing);
              var y3 = p4 + ".type", m3 = h3.elements && j(h3.elements) && !h3.vaoActive;
              Q2 && ("number" != typeof s3 || 0 <= s3) ? "string" == typeof s3 ? (r4("if(", s3, ">0){"), a3(), r4("}else if(", s3, "<0){"), o2(), r4("}")) : a3() : o2();
            }
            function H2(t5, e4, r4, n4, i3) {
              return i3 = (e4 = _2()).proc("body", i3), Q2 && (e4.instancing = i3.def(e4.shared.extensions, ".angle_instanced_arrays")), t5(e4, i3, r4, n4), e4.compile().body;
            }
            function q3(t5, e4, r4, n4) {
              P2(t5, e4), r4.useVAO ? r4.drawVAO ? e4(t5.shared.vao, ".setVAO(", r4.drawVAO.append(t5, e4), ");") : e4(t5.shared.vao, ".setVAO(", t5.shared.vao, ".targetVAO);") : (e4(t5.shared.vao, ".setVAO(null);"), I2(t5, e4, r4, n4.attributes, function() {
                return true;
              })), D2(t5, e4, r4, n4.uniforms, function() {
                return true;
              }, false), z2(t5, e4, e4, r4);
            }
            function Z2(t5, e4, r4, n4) {
              function i3() {
                return true;
              }
              t5.batchId = "a1", P2(t5, e4), I2(t5, e4, r4, n4.attributes, i3), D2(t5, e4, r4, n4.uniforms, i3, false), z2(t5, e4, e4, r4);
            }
            function W2(t5, e4, r4, n4) {
              function i3(t6) {
                return t6.contextDep && o2 || t6.propDep;
              }
              function a3(t6) {
                return !i3(t6);
              }
              P2(t5, e4);
              var o2 = r4.contextDep, s3 = e4.def(), l3 = e4.def();
              t5.shared.props = l3, t5.batchId = s3;
              var u3 = t5.scope(), c3 = t5.scope();
              e4(u3.entry, "for(", s3, "=0;", s3, "<", "a1", ";++", s3, "){", l3, "=", "a0", "[", s3, "];", c3, "}", u3.exit), r4.needsContext && S2(t5, c3, r4.context), r4.needsFramebuffer && E2(t5, c3, r4.framebuffer), C2(t5, c3, r4.state, i3), r4.profile && i3(r4.profile) && O2(t5, c3, r4, false, true), n4 ? (r4.useVAO ? r4.drawVAO ? i3(r4.drawVAO) ? c3(t5.shared.vao, ".setVAO(", r4.drawVAO.append(t5, c3), ");") : u3(t5.shared.vao, ".setVAO(", r4.drawVAO.append(t5, u3), ");") : u3(t5.shared.vao, ".setVAO(", t5.shared.vao, ".targetVAO);") : (u3(t5.shared.vao, ".setVAO(null);"), I2(t5, u3, r4, n4.attributes, a3), I2(t5, c3, r4, n4.attributes, i3)), D2(t5, u3, r4, n4.uniforms, a3, false), D2(t5, c3, r4, n4.uniforms, i3, true), z2(t5, u3, c3, r4)) : (e4 = t5.global.def("{}"), n4 = r4.shader.progVar.append(t5, c3), l3 = c3.def(n4, ".id"), u3 = c3.def(e4, "[", l3, "]"), c3(t5.shared.gl, ".useProgram(", n4, ".program);", "if(!", u3, "){", u3, "=", e4, "[", l3, "]=", t5.link(function(e5) {
                return H2(Z2, t5, r4, e5, 2);
              }), "(", n4, ");}", u3, ".call(this,a0[", s3, "],", s3, ");"));
            }
            function X2(t5, r4) {
              function n4(e4) {
                var n5 = r4.shader[e4];
                n5 && (n5 = n5.append(t5, i3), isNaN(n5) ? i3.set(a3.shader, "." + e4, n5) : i3.set(a3.shader, "." + e4, t5.link(n5, { stable: true })));
              }
              var i3 = t5.proc("scope", 3);
              t5.batchId = "a2";
              var a3 = t5.shared, o2 = a3.current;
              if (S2(t5, i3, r4.context), r4.framebuffer && r4.framebuffer.append(t5, i3), B(Object.keys(r4.state)).forEach(function(e4) {
                var n5 = r4.state[e4], o3 = n5.append(t5, i3);
                m2(o3) ? o3.forEach(function(r5, n6) {
                  isNaN(r5) ? i3.set(t5.next[e4], "[" + n6 + "]", r5) : i3.set(t5.next[e4], "[" + n6 + "]", t5.link(r5, { stable: true }));
                }) : j(n5) ? i3.set(a3.next, "." + e4, t5.link(o3, { stable: true })) : i3.set(a3.next, "." + e4, o3);
              }), O2(t5, i3, r4, true, true), ["elements", "offset", "count", "instances", "primitive"].forEach(function(e4) {
                var n5 = r4.draw[e4];
                n5 && (n5 = n5.append(t5, i3), isNaN(n5) ? i3.set(a3.draw, "." + e4, n5) : i3.set(a3.draw, "." + e4, t5.link(n5), { stable: true }));
              }), Object.keys(r4.uniforms).forEach(function(n5) {
                var o3 = r4.uniforms[n5].append(t5, i3);
                Array.isArray(o3) && (o3 = "[" + o3.map(function(e4) {
                  return isNaN(e4) ? e4 : t5.link(e4, { stable: true });
                }) + "]"), i3.set(a3.uniforms, "[" + t5.link(e3.id(n5), { stable: true }) + "]", o3);
              }), Object.keys(r4.attributes).forEach(function(e4) {
                var n5 = r4.attributes[e4].append(t5, i3), a4 = t5.scopeAttrib(e4);
                Object.keys(new K2()).forEach(function(t6) {
                  i3.set(a4, "." + t6, n5[t6]);
                });
              }), r4.scopeVAO) {
                var s3 = r4.scopeVAO.append(t5, i3);
                isNaN(s3) ? i3.set(a3.vao, ".targetVAO", s3) : i3.set(a3.vao, ".targetVAO", t5.link(s3, { stable: true }));
              }
              n4("vert"), n4("frag"), 0 < Object.keys(r4.state).length && (i3(o2, ".dirty=true;"), i3.exit(o2, ".dirty=true;")), i3("a1(", t5.shared.context, ",a0,", t5.batchId, ");");
            }
            function J2(t5, e4, r4) {
              var n4 = e4.static[r4];
              if (n4 && function(t6) {
                if ("object" == typeof t6 && !m2(t6)) {
                  for (var e5 = Object.keys(t6), r5 = 0; r5 < e5.length; ++r5)
                    if (Y.isDynamic(t6[e5[r5]]))
                      return true;
                  return false;
                }
              }(n4)) {
                var i3 = t5.global, a3 = Object.keys(n4), o2 = false, s3 = false, l3 = false, u3 = t5.global.def("{}");
                a3.forEach(function(e5) {
                  var r5 = n4[e5];
                  if (Y.isDynamic(r5))
                    "function" == typeof r5 && (r5 = n4[e5] = Y.unbox(r5)), e5 = V(r5, null), o2 = o2 || e5.thisDep, l3 = l3 || e5.propDep, s3 = s3 || e5.contextDep;
                  else {
                    switch (i3(u3, ".", e5, "="), typeof r5) {
                      case "number":
                        i3(r5);
                        break;
                      case "string":
                        i3('"', r5, '"');
                        break;
                      case "object":
                        Array.isArray(r5) && i3("[", r5.join(), "]");
                        break;
                      default:
                        i3(t5.link(r5));
                    }
                    i3(";");
                  }
                }), e4.dynamic[r4] = new Y.DynamicVariable(4, { thisDep: o2, contextDep: s3, propDep: l3, ref: u3, append: function(t6, e5) {
                  a3.forEach(function(r5) {
                    var i4 = n4[r5];
                    Y.isDynamic(i4) && (i4 = t6.invoke(e5, i4), e5(u3, ".", r5, "=", i4, ";"));
                  });
                } }), delete e4.static[r4];
              }
            }
            var K2 = c2.Record, $2 = { add: 32774, subtract: 32778, "reverse subtract": 32779 };
            r3.ext_blend_minmax && ($2.min = 32775, $2.max = 32776);
            var Q2 = r3.angle_instanced_arrays, tt2 = r3.webgl_draw_buffers, et2 = r3.oes_vertex_array_object, nt2 = { dirty: true, profile: g3.profile }, it2 = {}, at2 = [], ot2 = {}, lt2 = {};
            x2("dither", 3024), x2("blend.enable", 3042), b2("blend.color", "blendColor", [0, 0, 0, 0]), b2("blend.equation", "blendEquationSeparate", [32774, 32774]), b2("blend.func", "blendFuncSeparate", [1, 0, 1, 0]), x2("depth.enable", 2929, true), b2("depth.func", "depthFunc", 513), b2("depth.range", "depthRange", [0, 1]), b2("depth.mask", "depthMask", true), b2("colorMask", "colorMask", [true, true, true, true]), x2("cull.enable", 2884), b2("cull.face", "cullFace", 1029), b2("frontFace", "frontFace", 2305), b2("lineWidth", "lineWidth", 1), x2("polygonOffset.enable", 32823), b2("polygonOffset.offset", "polygonOffset", [0, 0]), x2("sample.alpha", 32926), x2("sample.enable", 32928), b2("sample.coverage", "sampleCoverage", [1, false]), x2("stencil.enable", 2960), b2("stencil.mask", "stencilMask", -1), b2("stencil.func", "stencilFunc", [519, 0, -1]), b2("stencil.opFront", "stencilOpSeparate", [1028, 7680, 7680, 7680]), b2("stencil.opBack", "stencilOpSeparate", [1029, 7680, 7680, 7680]), x2("scissor.enable", 3089), b2("scissor.box", "scissor", [0, 0, t4.drawingBufferWidth, t4.drawingBufferHeight]), b2("viewport", "viewport", [0, 0, t4.drawingBufferWidth, t4.drawingBufferHeight]);
            var ut2 = { gl: t4, context: p3, strings: e3, next: it2, current: nt2, draw: h2, elements: a2, buffer: i2, shader: f3, attributes: c2.state, vao: c2, uniforms: u2, framebuffer: l2, extensions: r3, timer: d3, isBufferArgs: F }, ct2 = { primTypes: st, compareFuncs: Ct, blendFuncs: Lt, blendEquations: $2, stencilOps: Pt, glTypes: rt, orientationType: Ot };
            tt2 && (ct2.backBuffer = [1029], ct2.drawBuffer = o(n3.maxDrawbuffers, function(t5) {
              return 0 === t5 ? [0] : o(t5, function(t6) {
                return 36064 + t6;
              });
            }));
            var ft2 = 0;
            return { next: it2, current: nt2, procs: function() {
              var t5 = _2(), e4 = t5.proc("poll"), i3 = t5.proc("refresh"), a3 = t5.block();
              e4(a3), i3(a3);
              var s3, l3 = (f4 = t5.shared).gl, u3 = f4.next, c3 = f4.current;
              a3(c3, ".dirty=false;"), E2(t5, e4), E2(t5, i3, null, true), Q2 && (s3 = t5.link(Q2)), r3.oes_vertex_array_object && i3(t5.link(r3.oes_vertex_array_object), ".bindVertexArrayOES(null);");
              var f4 = i3.def(f4.attributes), h3 = i3.def(0), p4 = t5.cond(h3, ".buffer");
              p4.then(l3, ".enableVertexAttribArray(i);", l3, ".bindBuffer(", 34962, ",", h3, ".buffer.buffer);", l3, ".vertexAttribPointer(i,", h3, ".size,", h3, ".type,", h3, ".normalized,", h3, ".stride,", h3, ".offset);").else(l3, ".disableVertexAttribArray(i);", l3, ".vertexAttrib4f(i,", h3, ".x,", h3, ".y,", h3, ".z,", h3, ".w);", h3, ".buffer=null;");
              var d4 = t5.link(n3.maxAttributes, { stable: true });
              return i3("for(var i=0;i<", d4, ";++i){", h3, "=", f4, "[i];", p4, "}"), Q2 && i3("for(var i=0;i<", d4, ";++i){", s3, ".vertexAttribDivisorANGLE(i,", f4, "[i].divisor);", "}"), i3(t5.shared.vao, ".currentVAO=null;", t5.shared.vao, ".setVAO(", t5.shared.vao, ".targetVAO);"), Object.keys(ot2).forEach(function(r4) {
                var n4 = ot2[r4], o2 = a3.def(u3, ".", r4), s4 = t5.block();
                s4("if(", o2, "){", l3, ".enable(", n4, ")}else{", l3, ".disable(", n4, ")}", c3, ".", r4, "=", o2, ";"), i3(s4), e4("if(", o2, "!==", c3, ".", r4, "){", s4, "}");
              }), Object.keys(lt2).forEach(function(r4) {
                var n4, s4, f5 = lt2[r4], h4 = nt2[r4], p5 = t5.block();
                p5(l3, ".", f5, "("), m2(h4) ? (f5 = h4.length, n4 = t5.global.def(u3, ".", r4), s4 = t5.global.def(c3, ".", r4), p5(o(f5, function(t6) {
                  return n4 + "[" + t6 + "]";
                }), ");", o(f5, function(t6) {
                  return s4 + "[" + t6 + "]=" + n4 + "[" + t6 + "];";
                }).join("")), e4("if(", o(f5, function(t6) {
                  return n4 + "[" + t6 + "]!==" + s4 + "[" + t6 + "]";
                }).join("||"), "){", p5, "}")) : (n4 = a3.def(u3, ".", r4), s4 = a3.def(c3, ".", r4), p5(n4, ");", c3, ".", r4, "=", n4, ";"), e4("if(", n4, "!==", s4, "){", p5, "}")), i3(p5);
              }), t5.compile();
            }(), compile: function(t5, e4, r4, n4, i3) {
              var a3 = _2();
              a3.stats = a3.link(i3), Object.keys(e4.static).forEach(function(t6) {
                J2(a3, e4, t6);
              }), Et.forEach(function(e5) {
                J2(a3, t5, e5);
              });
              var o2 = M2(t5, e4, r4, n4);
              return o2.shader.program && (o2.shader.program.attributes.sort(function(t6, e5) {
                return t6.name < e5.name ? -1 : 1;
              }), o2.shader.program.uniforms.sort(function(t6, e5) {
                return t6.name < e5.name ? -1 : 1;
              })), function(t6, e5) {
                var r5 = t6.proc("draw", 1);
                P2(t6, r5), S2(t6, r5, e5.context), E2(t6, r5, e5.framebuffer), L2(t6, r5, e5), C2(t6, r5, e5.state), O2(t6, r5, e5, false, true);
                var n5 = e5.shader.progVar.append(t6, r5);
                if (r5(t6.shared.gl, ".useProgram(", n5, ".program);"), e5.shader.program)
                  q3(t6, r5, e5, e5.shader.program);
                else {
                  r5(t6.shared.vao, ".setVAO(null);");
                  var i4 = t6.global.def("{}"), a4 = r5.def(n5, ".id"), o3 = r5.def(i4, "[", a4, "]");
                  r5(t6.cond(o3).then(o3, ".call(this,a0);").else(o3, "=", i4, "[", a4, "]=", t6.link(function(r6) {
                    return H2(q3, t6, e5, r6, 1);
                  }), "(", n5, ");", o3, ".call(this,a0);"));
                }
                0 < Object.keys(e5.state).length && r5(t6.shared.current, ".dirty=true;"), t6.shared.vao && r5(t6.shared.vao, ".setVAO(null);");
              }(a3, o2), X2(a3, o2), function(t6, e5) {
                function r5(t7) {
                  return t7.contextDep && i4 || t7.propDep;
                }
                var n5 = t6.proc("batch", 2);
                t6.batchId = "0", P2(t6, n5);
                var i4 = false, a4 = true;
                Object.keys(e5.context).forEach(function(t7) {
                  i4 = i4 || e5.context[t7].propDep;
                }), i4 || (S2(t6, n5, e5.context), a4 = false);
                var o3 = false;
                if ((s3 = e5.framebuffer) ? (s3.propDep ? i4 = o3 = true : s3.contextDep && i4 && (o3 = true), o3 || E2(t6, n5, s3)) : E2(t6, n5, null), e5.state.viewport && e5.state.viewport.propDep && (i4 = true), L2(t6, n5, e5), C2(t6, n5, e5.state, function(t7) {
                  return !r5(t7);
                }), e5.profile && r5(e5.profile) || O2(t6, n5, e5, false, "a1"), e5.contextDep = i4, e5.needsContext = a4, e5.needsFramebuffer = o3, (a4 = e5.shader.progVar).contextDep && i4 || a4.propDep)
                  W2(t6, n5, e5, null);
                else if (a4 = a4.append(t6, n5), n5(t6.shared.gl, ".useProgram(", a4, ".program);"), e5.shader.program)
                  W2(t6, n5, e5, e5.shader.program);
                else {
                  n5(t6.shared.vao, ".setVAO(null);");
                  var s3 = t6.global.def("{}"), l3 = (o3 = n5.def(a4, ".id"), n5.def(s3, "[", o3, "]"));
                  n5(t6.cond(l3).then(l3, ".call(this,a0,a1);").else(l3, "=", s3, "[", o3, "]=", t6.link(function(r6) {
                    return H2(W2, t6, e5, r6, 2);
                  }), "(", a4, ");", l3, ".call(this,a0,a1);"));
                }
                0 < Object.keys(e5.state).length && n5(t6.shared.current, ".dirty=true;"), t6.shared.vao && n5(t6.shared.vao, ".setVAO(null);");
              }(a3, o2), G(a3.compile(), { destroy: function() {
                o2.shader.program.destroy();
              } });
            } };
          }
          function q2(t4, e3) {
            for (var r3 = 0; r3 < t4.length; ++r3)
              if (t4[r3] === e3)
                return r3;
            return -1;
          }
          var G = function(t4, e3) {
            for (var r3 = Object.keys(e3), n3 = 0; n3 < r3.length; ++n3)
              t4[r3[n3]] = e3[r3[n3]];
            return t4;
          }, Z = 0, Y = { DynamicVariable: t3, define: function(e3, n3) {
            return new t3(e3, r2(n3 + ""));
          }, isDynamic: function(e3) {
            return "function" == typeof e3 && !e3._reglType || e3 instanceof t3;
          }, unbox: function e3(r3, n3) {
            return "function" == typeof r3 ? new t3(0, r3) : "number" == typeof r3 || "boolean" == typeof r3 ? new t3(5, r3) : Array.isArray(r3) ? new t3(6, r3.map(function(t4, r4) {
              return e3(t4);
            })) : r3 instanceof t3 ? r3 : void 0;
          }, accessor: r2 }, W = { next: "function" == typeof requestAnimationFrame ? function(t4) {
            return requestAnimationFrame(t4);
          } : function(t4) {
            return setTimeout(t4, 16);
          }, cancel: "function" == typeof cancelAnimationFrame ? function(t4) {
            return cancelAnimationFrame(t4);
          } : clearTimeout }, X = "undefined" != typeof performance && performance.now ? function() {
            return performance.now();
          } : function() {
            return +new Date();
          }, J = l();
          J.zero = l();
          var K = function(t4, e3) {
            var r3 = 1;
            e3.ext_texture_filter_anisotropic && (r3 = t4.getParameter(34047));
            var n3 = 1, i2 = 1;
            e3.webgl_draw_buffers && (n3 = t4.getParameter(34852), i2 = t4.getParameter(36063));
            var a2 = !!e3.oes_texture_float;
            if (a2) {
              a2 = t4.createTexture(), t4.bindTexture(3553, a2), t4.texImage2D(3553, 0, 6408, 1, 1, 0, 6408, 5126, null);
              var o2 = t4.createFramebuffer();
              if (t4.bindFramebuffer(36160, o2), t4.framebufferTexture2D(36160, 36064, 3553, a2, 0), t4.bindTexture(3553, null), 36053 !== t4.checkFramebufferStatus(36160))
                a2 = false;
              else {
                t4.viewport(0, 0, 1, 1), t4.clearColor(1, 0, 0, 1), t4.clear(16384);
                var s2 = J.allocType(5126, 4);
                t4.readPixels(0, 0, 1, 1, 6408, 5126, s2), t4.getError() ? a2 = false : (t4.deleteFramebuffer(o2), t4.deleteTexture(a2), a2 = 1 === s2[0]), J.freeType(s2);
              }
            }
            return s2 = true, "undefined" != typeof navigator && (/MSIE/.test(navigator.userAgent) || /Trident\//.test(navigator.appVersion) || /Edge/.test(navigator.userAgent)) || (s2 = t4.createTexture(), o2 = J.allocType(5121, 36), t4.activeTexture(33984), t4.bindTexture(34067, s2), t4.texImage2D(34069, 0, 6408, 3, 3, 0, 6408, 5121, o2), J.freeType(o2), t4.bindTexture(34067, null), t4.deleteTexture(s2), s2 = !t4.getError()), { colorBits: [t4.getParameter(3410), t4.getParameter(3411), t4.getParameter(3412), t4.getParameter(3413)], depthBits: t4.getParameter(3414), stencilBits: t4.getParameter(3415), subpixelBits: t4.getParameter(3408), extensions: Object.keys(e3).filter(function(t5) {
              return !!e3[t5];
            }), maxAnisotropic: r3, maxDrawbuffers: n3, maxColorAttachments: i2, pointSizeDims: t4.getParameter(33901), lineWidthDims: t4.getParameter(33902), maxViewportDims: t4.getParameter(3386), maxCombinedTextureUnits: t4.getParameter(35661), maxCubeMapSize: t4.getParameter(34076), maxRenderbufferSize: t4.getParameter(34024), maxTextureUnits: t4.getParameter(34930), maxTextureSize: t4.getParameter(3379), maxAttributes: t4.getParameter(34921), maxVertexUniforms: t4.getParameter(36347), maxVertexTextureUnits: t4.getParameter(35660), maxVaryingVectors: t4.getParameter(36348), maxFragmentUniforms: t4.getParameter(36349), glsl: t4.getParameter(35724), renderer: t4.getParameter(7937), vendor: t4.getParameter(7936), version: t4.getParameter(7938), readFloat: a2, npotTextureCube: s2 };
          }, $ = function(t4) {
            return t4 instanceof Uint8Array || t4 instanceof Uint16Array || t4 instanceof Uint32Array || t4 instanceof Int8Array || t4 instanceof Int16Array || t4 instanceof Int32Array || t4 instanceof Float32Array || t4 instanceof Float64Array || t4 instanceof Uint8ClampedArray;
          }, Q = function(t4) {
            return Object.keys(t4).map(function(e3) {
              return t4[e3];
            });
          }, tt = { shape: function(t4) {
            for (var e3 = []; t4.length; t4 = t4[0])
              e3.push(t4.length);
            return e3;
          }, flatten: function(t4, e3, r3, n3) {
            var i2 = 1;
            if (e3.length)
              for (var a2 = 0; a2 < e3.length; ++a2)
                i2 *= e3[a2];
            else
              i2 = 0;
            switch (r3 = n3 || J.allocType(r3, i2), e3.length) {
              case 0:
                break;
              case 1:
                for (n3 = e3[0], e3 = 0; e3 < n3; ++e3)
                  r3[e3] = t4[e3];
                break;
              case 2:
                for (n3 = e3[0], e3 = e3[1], a2 = i2 = 0; a2 < n3; ++a2)
                  for (var o2 = t4[a2], s2 = 0; s2 < e3; ++s2)
                    r3[i2++] = o2[s2];
                break;
              case 3:
                c(t4, e3[0], e3[1], e3[2], r3, 0);
                break;
              default:
                f2(t4, e3, 0, r3, 0);
            }
            return r3;
          } }, et = { "[object Int8Array]": 5120, "[object Int16Array]": 5122, "[object Int32Array]": 5124, "[object Uint8Array]": 5121, "[object Uint8ClampedArray]": 5121, "[object Uint16Array]": 5123, "[object Uint32Array]": 5125, "[object Float32Array]": 5126, "[object Float64Array]": 5121, "[object ArrayBuffer]": 5121 }, rt = { int8: 5120, int16: 5122, int32: 5124, uint8: 5121, uint16: 5123, uint32: 5125, float: 5126, float32: 5126 }, nt = { dynamic: 35048, stream: 35040, static: 35044 }, it = tt.flatten, at = tt.shape, ot = [];
          ot[5120] = 1, ot[5122] = 2, ot[5124] = 4, ot[5121] = 1, ot[5123] = 2, ot[5125] = 4, ot[5126] = 4;
          var st = { points: 0, point: 0, lines: 1, line: 1, triangles: 4, triangle: 4, "line loop": 2, "line strip": 3, "triangle strip": 5, "triangle fan": 6 }, lt = new Float32Array(1), ut = new Uint32Array(lt.buffer), ct = [9984, 9986, 9985, 9987], ft = [0, 6409, 6410, 6407, 6408], ht = {};
          ht[6409] = ht[6406] = ht[6402] = 1, ht[34041] = ht[6410] = 2, ht[6407] = ht[35904] = 3, ht[6408] = ht[35906] = 4;
          var pt = x("HTMLCanvasElement"), dt = x("OffscreenCanvas"), vt = x("CanvasRenderingContext2D"), gt = x("ImageBitmap"), yt = x("HTMLImageElement"), mt = x("HTMLVideoElement"), xt = Object.keys(et).concat([pt, dt, vt, gt, yt, mt]), bt = [];
          bt[5121] = 1, bt[5126] = 4, bt[36193] = 2, bt[5123] = 2, bt[5125] = 4;
          var _t = [];
          _t[32854] = 2, _t[32855] = 2, _t[36194] = 2, _t[34041] = 4, _t[33776] = 0.5, _t[33777] = 0.5, _t[33778] = 1, _t[33779] = 1, _t[35986] = 0.5, _t[35987] = 1, _t[34798] = 1, _t[35840] = 0.5, _t[35841] = 0.25, _t[35842] = 0.5, _t[35843] = 0.25, _t[36196] = 0.5;
          var wt = [];
          wt[32854] = 2, wt[32855] = 2, wt[36194] = 2, wt[33189] = 2, wt[36168] = 1, wt[34041] = 4, wt[35907] = 4, wt[34836] = 16, wt[34842] = 8, wt[34843] = 6;
          var Tt = function(t4, e3, r3, n3, i2) {
            function a2(t5) {
              this.id = u2++, this.refCount = 1, this.renderbuffer = t5, this.format = 32854, this.height = this.width = 0, i2.profile && (this.stats = { size: 0 });
            }
            function o2(e4) {
              var r4 = e4.renderbuffer;
              t4.bindRenderbuffer(36161, null), t4.deleteRenderbuffer(r4), e4.renderbuffer = null, e4.refCount = 0, delete c2[e4.id], n3.renderbufferCount--;
            }
            var s2 = { rgba4: 32854, rgb565: 36194, "rgb5 a1": 32855, depth: 33189, stencil: 36168, "depth stencil": 34041 };
            e3.ext_srgb && (s2.srgba = 35907), e3.ext_color_buffer_half_float && (s2.rgba16f = 34842, s2.rgb16f = 34843), e3.webgl_color_buffer_float && (s2.rgba32f = 34836);
            var l2 = [];
            Object.keys(s2).forEach(function(t5) {
              l2[s2[t5]] = t5;
            });
            var u2 = 0, c2 = {};
            return a2.prototype.decRef = function() {
              0 >= --this.refCount && o2(this);
            }, i2.profile && (n3.getTotalRenderbufferSize = function() {
              var t5 = 0;
              return Object.keys(c2).forEach(function(e4) {
                t5 += c2[e4].stats.size;
              }), t5;
            }), { create: function(e4, r4) {
              function o3(e5, r5) {
                var n4 = 0, a3 = 0, c3 = 32854;
                if ("object" == typeof e5 && e5 ? ("shape" in e5 ? (n4 = 0 | (a3 = e5.shape)[0], a3 = 0 | a3[1]) : ("radius" in e5 && (n4 = a3 = 0 | e5.radius), "width" in e5 && (n4 = 0 | e5.width), "height" in e5 && (a3 = 0 | e5.height)), "format" in e5 && (c3 = s2[e5.format])) : "number" == typeof e5 ? (n4 = 0 | e5, a3 = "number" == typeof r5 ? 0 | r5 : n4) : e5 || (n4 = a3 = 1), n4 !== u3.width || a3 !== u3.height || c3 !== u3.format)
                  return o3.width = u3.width = n4, o3.height = u3.height = a3, u3.format = c3, t4.bindRenderbuffer(36161, u3.renderbuffer), t4.renderbufferStorage(36161, c3, n4, a3), i2.profile && (u3.stats.size = wt[u3.format] * u3.width * u3.height), o3.format = l2[u3.format], o3;
              }
              var u3 = new a2(t4.createRenderbuffer());
              return c2[u3.id] = u3, n3.renderbufferCount++, o3(e4, r4), o3.resize = function(e5, r5) {
                var n4 = 0 | e5, a3 = 0 | r5 || n4;
                return n4 === u3.width && a3 === u3.height || (o3.width = u3.width = n4, o3.height = u3.height = a3, t4.bindRenderbuffer(36161, u3.renderbuffer), t4.renderbufferStorage(36161, u3.format, n4, a3), i2.profile && (u3.stats.size = wt[u3.format] * u3.width * u3.height)), o3;
              }, o3._reglType = "renderbuffer", o3._renderbuffer = u3, i2.profile && (o3.stats = u3.stats), o3.destroy = function() {
                u3.decRef();
              }, o3;
            }, clear: function() {
              Q(c2).forEach(o2);
            }, restore: function() {
              Q(c2).forEach(function(e4) {
                e4.renderbuffer = t4.createRenderbuffer(), t4.bindRenderbuffer(36161, e4.renderbuffer), t4.renderbufferStorage(36161, e4.format, e4.width, e4.height);
              }), t4.bindRenderbuffer(36161, null);
            } };
          }, kt = [];
          kt[6408] = 4, kt[6407] = 3;
          var At = [];
          At[5121] = 1, At[5126] = 4, At[36193] = 2;
          var Mt = [1116352408, 1899447441, -1245643825, -373957723, 961987163, 1508970993, -1841331548, -1424204075, -670586216, 310598401, 607225278, 1426881987, 1925078388, -2132889090, -1680079193, -1046744716, -459576895, -272742522, 264347078, 604807628, 770255983, 1249150122, 1555081692, 1996064986, -1740746414, -1473132947, -1341970488, -1084653625, -958395405, -710438585, 113926993, 338241895, 666307205, 773529912, 1294757372, 1396182291, 1695183700, 1986661051, -2117940946, -1838011259, -1564481375, -1474664885, -1035236496, -949202525, -778901479, -694614492, -200395387, 275423344, 430227734, 506948616, 659060556, 883997877, 958139571, 1322822218, 1537002063, 1747873779, 1955562222, 2024104815, -2067236844, -1933114872, -1866530822, -1538233109, -1090935817, -965641998], St = ["x", "y", "z", "w"], Et = "blend.func blend.equation stencil.func stencil.opFront stencil.opBack sample.coverage viewport scissor.box polygonOffset.offset".split(" "), Lt = { 0: 0, 1: 1, zero: 0, one: 1, "src color": 768, "one minus src color": 769, "src alpha": 770, "one minus src alpha": 771, "dst color": 774, "one minus dst color": 775, "dst alpha": 772, "one minus dst alpha": 773, "constant color": 32769, "one minus constant color": 32770, "constant alpha": 32771, "one minus constant alpha": 32772, "src alpha saturate": 776 }, Ct = { never: 512, less: 513, "<": 513, equal: 514, "=": 514, "==": 514, "===": 514, lequal: 515, "<=": 515, greater: 516, ">": 516, notequal: 517, "!=": 517, "!==": 517, gequal: 518, ">=": 518, always: 519 }, Pt = { 0: 0, zero: 0, keep: 7680, replace: 7681, increment: 7682, decrement: 7683, "increment wrap": 34055, "decrement wrap": 34056, invert: 5386 }, Ot = { cw: 2304, ccw: 2305 }, It = new N(false, false, false, function() {
          });
          return function(t4) {
            function e3() {
              if (0 === J2.length)
                T2 && T2.update(), et2 = null;
              else {
                et2 = W.next(e3), f3();
                for (var t5 = J2.length - 1; 0 <= t5; --t5) {
                  var r4 = J2[t5];
                  r4 && r4(O2, null, 0);
                }
                d3.flush(), T2 && T2.update();
              }
            }
            function r3() {
              !et2 && 0 < J2.length && (et2 = W.next(e3));
            }
            function n3() {
              et2 && (W.cancel(e3), et2 = null);
            }
            function i2(t5) {
              t5.preventDefault(), n3(), $2.forEach(function(t6) {
                t6();
              });
            }
            function o2(t5) {
              d3.getError(), m3.restore(), F2.restore(), D2.restore(), B2.restore(), N2.restore(), j2.restore(), R2.restore(), T2 && T2.restore(), U2.procs.refresh(), r3(), Q2.forEach(function(t6) {
                t6();
              });
            }
            function s2(t5) {
              function e4(t6, e5) {
                var r5 = {}, n5 = {};
                return Object.keys(t6).forEach(function(i4) {
                  var a3 = t6[i4];
                  if (Y.isDynamic(a3))
                    n5[i4] = Y.unbox(a3, i4);
                  else {
                    if (e5 && Array.isArray(a3)) {
                      for (var o4 = 0; o4 < a3.length; ++o4)
                        if (Y.isDynamic(a3[o4]))
                          return void (n5[i4] = Y.unbox(a3, i4));
                    }
                    r5[i4] = a3;
                  }
                }), { dynamic: n5, static: r5 };
              }
              var r4 = e4(t5.context || {}, true), n4 = e4(t5.uniforms || {}, true), i3 = e4(t5.attributes || {}, false);
              t5 = e4(function(t6) {
                function e5(t7) {
                  if (t7 in r5) {
                    var e6 = r5[t7];
                    delete r5[t7], Object.keys(e6).forEach(function(n5) {
                      r5[t7 + "." + n5] = e6[n5];
                    });
                  }
                }
                var r5 = G({}, t6);
                return delete r5.uniforms, delete r5.attributes, delete r5.context, delete r5.vao, "stencil" in r5 && r5.stencil.op && (r5.stencil.opBack = r5.stencil.opFront = r5.stencil.op, delete r5.stencil.op), e5("blend"), e5("depth"), e5("cull"), e5("stencil"), e5("polygonOffset"), e5("scissor"), e5("sample"), "vao" in t6 && (r5.vao = t6.vao), r5;
              }(t5), false);
              var a2 = { gpuTime: 0, cpuTime: 0, count: 0 }, o3 = U2.compile(t5, i3, n4, r4, a2), s3 = o3.draw, l3 = o3.batch, u3 = o3.scope, c3 = [];
              return G(function(t6, e5) {
                var r5;
                if ("function" == typeof t6)
                  return u3.call(this, null, t6, 0);
                if ("function" == typeof e5)
                  if ("number" == typeof t6)
                    for (r5 = 0; r5 < t6; ++r5)
                      u3.call(this, null, e5, r5);
                  else {
                    if (!Array.isArray(t6))
                      return u3.call(this, t6, e5, 0);
                    for (r5 = 0; r5 < t6.length; ++r5)
                      u3.call(this, t6[r5], e5, r5);
                  }
                else if ("number" == typeof t6) {
                  if (0 < t6)
                    return l3.call(this, function(t7) {
                      for (; c3.length < t7; )
                        c3.push(null);
                      return c3;
                    }(0 | t6), 0 | t6);
                } else {
                  if (!Array.isArray(t6))
                    return s3.call(this, t6);
                  if (t6.length)
                    return l3.call(this, t6, t6.length);
                }
              }, { stats: a2, destroy: function() {
                o3.destroy();
              } });
            }
            function l2(t5, e4) {
              var r4 = 0;
              U2.procs.poll();
              var n4 = e4.color;
              n4 && (d3.clearColor(+n4[0] || 0, +n4[1] || 0, +n4[2] || 0, +n4[3] || 0), r4 |= 16384), "depth" in e4 && (d3.clearDepth(+e4.depth), r4 |= 256), "stencil" in e4 && (d3.clearStencil(0 | e4.stencil), r4 |= 1024), d3.clear(r4);
            }
            function u2(t5) {
              return J2.push(t5), r3(), { cancel: function() {
                var e4 = q2(J2, t5);
                J2[e4] = function t6() {
                  var e5 = q2(J2, t6);
                  J2[e5] = J2[J2.length - 1], --J2.length, 0 >= J2.length && n3();
                };
              } };
            }
            function c2() {
              var t5 = V2.viewport, e4 = V2.scissor_box;
              t5[0] = t5[1] = e4[0] = e4[1] = 0, O2.viewportWidth = O2.framebufferWidth = O2.drawingBufferWidth = t5[2] = e4[2] = d3.drawingBufferWidth, O2.viewportHeight = O2.framebufferHeight = O2.drawingBufferHeight = t5[3] = e4[3] = d3.drawingBufferHeight;
            }
            function f3() {
              O2.tick += 1, O2.time = p3(), c2(), U2.procs.poll();
            }
            function h2() {
              B2.refresh(), c2(), U2.procs.refresh(), T2 && T2.update();
            }
            function p3() {
              return (X() - k2) / 1e3;
            }
            if (!(t4 = a(t4)))
              return null;
            var d3 = t4.gl, y2 = d3.getContextAttributes();
            d3.isContextLost();
            var m3 = function(t5, e4) {
              function r4(e5) {
                var r5;
                e5 = e5.toLowerCase();
                try {
                  r5 = n4[e5] = t5.getExtension(e5);
                } catch (t6) {
                }
                return !!r5;
              }
              for (var n4 = {}, i3 = 0; i3 < e4.extensions.length; ++i3) {
                var a2 = e4.extensions[i3];
                if (!r4(a2))
                  return e4.onDestroy(), e4.onDone('"' + a2 + '" extension is not supported by the current WebGL context, try upgrading your system or a different browser'), null;
              }
              return e4.optionalExtensions.forEach(r4), { extensions: n4, restore: function() {
                Object.keys(n4).forEach(function(t6) {
                  if (n4[t6] && !r4(t6))
                    throw Error("(regl): error restoring extension " + t6);
                });
              } };
            }(d3, t4);
            if (!m3)
              return null;
            var x2 = function() {
              var t5 = { "": 0 }, e4 = [""];
              return { id: function(r4) {
                var n4 = t5[r4];
                return n4 || (n4 = t5[r4] = e4.length, e4.push(r4), n4);
              }, str: function(t6) {
                return e4[t6];
              } };
            }(), b2 = { vaoCount: 0, bufferCount: 0, elementsCount: 0, framebufferCount: 0, shaderCount: 0, textureCount: 0, cubeCount: 0, renderbufferCount: 0, maxTextureUnits: 0 }, _2 = t4.cachedCode || {}, w3 = m3.extensions, T2 = function(t5, e4) {
              function r4() {
                this.endQueryIndex = this.startQueryIndex = -1, this.sum = 0, this.stats = null;
              }
              function n4(t6, e5, n5) {
                var i4 = o3.pop() || new r4();
                i4.startQueryIndex = t6, i4.endQueryIndex = e5, i4.sum = 0, i4.stats = n5, s3.push(i4);
              }
              if (!e4.ext_disjoint_timer_query)
                return null;
              var i3 = [], a2 = [], o3 = [], s3 = [], l3 = [], u3 = [];
              return { beginQuery: function(t6) {
                var r5 = i3.pop() || e4.ext_disjoint_timer_query.createQueryEXT();
                e4.ext_disjoint_timer_query.beginQueryEXT(35007, r5), a2.push(r5), n4(a2.length - 1, a2.length, t6);
              }, endQuery: function() {
                e4.ext_disjoint_timer_query.endQueryEXT(35007);
              }, pushScopeStats: n4, update: function() {
                var t6, r5;
                if (0 !== (t6 = a2.length)) {
                  u3.length = Math.max(u3.length, t6 + 1), l3.length = Math.max(l3.length, t6 + 1), l3[0] = 0;
                  var n5 = u3[0] = 0;
                  for (r5 = t6 = 0; r5 < a2.length; ++r5) {
                    var c3 = a2[r5];
                    e4.ext_disjoint_timer_query.getQueryObjectEXT(c3, 34919) ? (n5 += e4.ext_disjoint_timer_query.getQueryObjectEXT(c3, 34918), i3.push(c3)) : a2[t6++] = c3, l3[r5 + 1] = n5, u3[r5 + 1] = t6;
                  }
                  for (a2.length = t6, r5 = t6 = 0; r5 < s3.length; ++r5) {
                    var f4 = (n5 = s3[r5]).startQueryIndex;
                    c3 = n5.endQueryIndex, n5.sum += l3[c3] - l3[f4], f4 = u3[f4], (c3 = u3[c3]) === f4 ? (n5.stats.gpuTime += n5.sum / 1e6, o3.push(n5)) : (n5.startQueryIndex = f4, n5.endQueryIndex = c3, s3[t6++] = n5);
                  }
                  s3.length = t6;
                }
              }, getNumPendingQueries: function() {
                return a2.length;
              }, clear: function() {
                i3.push.apply(i3, a2);
                for (var t6 = 0; t6 < i3.length; t6++)
                  e4.ext_disjoint_timer_query.deleteQueryEXT(i3[t6]);
                a2.length = 0, i3.length = 0;
              }, restore: function() {
                a2.length = 0, i3.length = 0;
              } };
            }(0, w3), k2 = X(), A2 = d3.drawingBufferWidth, E2 = d3.drawingBufferHeight, O2 = { tick: 0, time: 0, viewportWidth: A2, viewportHeight: E2, framebufferWidth: A2, framebufferHeight: E2, drawingBufferWidth: A2, drawingBufferHeight: E2, pixelRatio: t4.pixelRatio }, I2 = (A2 = { elements: null, primitive: 4, count: -1, offset: 0, instances: -1 }, K(d3, w3)), D2 = v(d3, b2, t4, function(t5) {
              return R2.destroyBuffer(t5);
            }), z2 = g2(d3, w3, D2, b2), R2 = L(d3, w3, I2, b2, D2, z2, A2), F2 = C(d3, x2, b2, t4), B2 = M(d3, w3, I2, function() {
              U2.procs.poll();
            }, O2, b2, t4), N2 = Tt(d3, w3, 0, b2, t4), j2 = S(d3, w3, I2, B2, N2, b2), U2 = H(d3, x2, w3, I2, D2, z2, 0, j2, {}, R2, F2, A2, O2, T2, _2, t4), V2 = (x2 = P(d3, j2, U2.procs.poll, O2), U2.next), Z2 = d3.canvas, J2 = [], $2 = [], Q2 = [], tt2 = [t4.onDestroy], et2 = null;
            Z2 && (Z2.addEventListener("webglcontextlost", i2, false), Z2.addEventListener("webglcontextrestored", o2, false));
            var rt2 = j2.setFBO = s2({ framebuffer: Y.define.call(null, 1, "framebuffer") });
            return h2(), y2 = G(s2, { clear: function(t5) {
              if ("framebuffer" in t5)
                if (t5.framebuffer && "framebufferCube" === t5.framebuffer_reglType)
                  for (var e4 = 0; 6 > e4; ++e4)
                    rt2(G({ framebuffer: t5.framebuffer.faces[e4] }, t5), l2);
                else
                  rt2(t5, l2);
              else
                l2(0, t5);
            }, prop: Y.define.bind(null, 1), context: Y.define.bind(null, 2), this: Y.define.bind(null, 3), draw: s2({}), buffer: function(t5) {
              return D2.create(t5, 34962, false, false);
            }, elements: function(t5) {
              return z2.create(t5, false);
            }, texture: B2.create2D, cube: B2.createCube, renderbuffer: N2.create, framebuffer: j2.create, framebufferCube: j2.createCube, vao: R2.createVAO, attributes: y2, frame: u2, on: function(t5, e4) {
              var r4;
              switch (t5) {
                case "frame":
                  return u2(e4);
                case "lost":
                  r4 = $2;
                  break;
                case "restore":
                  r4 = Q2;
                  break;
                case "destroy":
                  r4 = tt2;
              }
              return r4.push(e4), { cancel: function() {
                for (var t6 = 0; t6 < r4.length; ++t6)
                  if (r4[t6] === e4) {
                    r4[t6] = r4[r4.length - 1], r4.pop();
                    break;
                  }
              } };
            }, limits: I2, hasExtension: function(t5) {
              return 0 <= I2.extensions.indexOf(t5.toLowerCase());
            }, read: x2, destroy: function() {
              J2.length = 0, n3(), Z2 && (Z2.removeEventListener("webglcontextlost", i2), Z2.removeEventListener("webglcontextrestored", o2)), F2.clear(), j2.clear(), N2.clear(), R2.clear(), B2.clear(), z2.clear(), D2.clear(), T2 && T2.clear(), tt2.forEach(function(t5) {
                t5();
              });
            }, _gl: d3, _refresh: h2, poll: function() {
              f3(), T2 && T2.update();
            }, now: p3, stats: b2, getCachedCode: function() {
              return _2;
            }, preloadCachedCode: function(t5) {
              Object.entries(t5).forEach(function(t6) {
                _2[t6[0]] = t6[1];
              });
            } }), t4.onDone(null, y2), y2;
          };
        }();
      }, 71665: function(t2, e2, r2) {
        var n2 = r2(12856), i = n2.Buffer;
        function a(t3, e3) {
          for (var r3 in t3)
            e3[r3] = t3[r3];
        }
        function o(t3, e3, r3) {
          return i(t3, e3, r3);
        }
        i.from && i.alloc && i.allocUnsafe && i.allocUnsafeSlow ? t2.exports = n2 : (a(n2, e2), e2.Buffer = o), o.prototype = Object.create(i.prototype), a(i, o), o.from = function(t3, e3, r3) {
          if ("number" == typeof t3)
            throw new TypeError("Argument must not be a number");
          return i(t3, e3, r3);
        }, o.alloc = function(t3, e3, r3) {
          if ("number" != typeof t3)
            throw new TypeError("Argument must be a number");
          var n3 = i(t3);
          return void 0 !== e3 ? "string" == typeof r3 ? n3.fill(e3, r3) : n3.fill(e3) : n3.fill(0), n3;
        }, o.allocUnsafe = function(t3) {
          if ("number" != typeof t3)
            throw new TypeError("Argument must be a number");
          return i(t3);
        }, o.allocUnsafeSlow = function(t3) {
          if ("number" != typeof t3)
            throw new TypeError("Argument must be a number");
          return n2.SlowBuffer(t3);
        };
      }, 21630: function(t2, e2, r2) {
        t2.exports = i;
        var n2 = r2(15398).EventEmitter;
        function i() {
          n2.call(this);
        }
        r2(42018)(i, n2), i.Readable = r2(40410), i.Writable = r2(37493), i.Duplex = r2(37865), i.Transform = r2(74308), i.PassThrough = r2(66897), i.finished = r2(12726), i.pipeline = r2(10168), i.Stream = i, i.prototype.pipe = function(t3, e3) {
          var r3 = this;
          function i2(e4) {
            t3.writable && false === t3.write(e4) && r3.pause && r3.pause();
          }
          function a() {
            r3.readable && r3.resume && r3.resume();
          }
          r3.on("data", i2), t3.on("drain", a), t3._isStdio || e3 && false === e3.end || (r3.on("end", s), r3.on("close", l));
          var o = false;
          function s() {
            o || (o = true, t3.end());
          }
          function l() {
            o || (o = true, "function" == typeof t3.destroy && t3.destroy());
          }
          function u(t4) {
            if (c(), 0 === n2.listenerCount(this, "error"))
              throw t4;
          }
          function c() {
            r3.removeListener("data", i2), t3.removeListener("drain", a), r3.removeListener("end", s), r3.removeListener("close", l), r3.removeListener("error", u), t3.removeListener("error", u), r3.removeListener("end", c), r3.removeListener("close", c), t3.removeListener("close", c);
          }
          return r3.on("error", u), t3.on("error", u), r3.on("end", c), r3.on("close", c), t3.on("close", c), t3.emit("pipe", r3), t3;
        };
      }, 74322: function(t2) {
        var e2 = {};
        function r2(t3, r3, n3) {
          n3 || (n3 = Error);
          var i = function(t4) {
            var e3, n4;
            function i2(e4, n5, i3) {
              return t4.call(this, function(t5, e5, n6) {
                return "string" == typeof r3 ? r3 : r3(t5, e5, n6);
              }(e4, n5, i3)) || this;
            }
            return n4 = t4, (e3 = i2).prototype = Object.create(n4.prototype), e3.prototype.constructor = e3, e3.__proto__ = n4, i2;
          }(n3);
          i.prototype.name = n3.name, i.prototype.code = t3, e2[t3] = i;
        }
        function n2(t3, e3) {
          if (Array.isArray(t3)) {
            var r3 = t3.length;
            return t3 = t3.map(function(t4) {
              return String(t4);
            }), r3 > 2 ? "one of ".concat(e3, " ").concat(t3.slice(0, r3 - 1).join(", "), ", or ") + t3[r3 - 1] : 2 === r3 ? "one of ".concat(e3, " ").concat(t3[0], " or ").concat(t3[1]) : "of ".concat(e3, " ").concat(t3[0]);
          }
          return "of ".concat(e3, " ").concat(String(t3));
        }
        r2("ERR_INVALID_OPT_VALUE", function(t3, e3) {
          return 'The value "' + e3 + '" is invalid for option "' + t3 + '"';
        }, TypeError), r2("ERR_INVALID_ARG_TYPE", function(t3, e3, r3) {
          var i, a, o, s, l;
          if ("string" == typeof e3 && (a = "not ", e3.substr(0, a.length) === a) ? (i = "must not be", e3 = e3.replace(/^not /, "")) : i = "must be", function(t4, e4, r4) {
            return (void 0 === r4 || r4 > t4.length) && (r4 = t4.length), t4.substring(r4 - e4.length, r4) === e4;
          }(t3, " argument"))
            o = "The ".concat(t3, " ").concat(i, " ").concat(n2(e3, "type"));
          else {
            var u = ("number" != typeof l && (l = 0), l + ".".length > (s = t3).length || -1 === s.indexOf(".", l) ? "argument" : "property");
            o = 'The "'.concat(t3, '" ').concat(u, " ").concat(i, " ").concat(n2(e3, "type"));
          }
          return o + ". Received type ".concat(typeof r3);
        }, TypeError), r2("ERR_STREAM_PUSH_AFTER_EOF", "stream.push() after EOF"), r2("ERR_METHOD_NOT_IMPLEMENTED", function(t3) {
          return "The " + t3 + " method is not implemented";
        }), r2("ERR_STREAM_PREMATURE_CLOSE", "Premature close"), r2("ERR_STREAM_DESTROYED", function(t3) {
          return "Cannot call " + t3 + " after a stream was destroyed";
        }), r2("ERR_MULTIPLE_CALLBACK", "Callback called multiple times"), r2("ERR_STREAM_CANNOT_PIPE", "Cannot pipe, not readable"), r2("ERR_STREAM_WRITE_AFTER_END", "write after end"), r2("ERR_STREAM_NULL_VALUES", "May not write null values to stream", TypeError), r2("ERR_UNKNOWN_ENCODING", function(t3) {
          return "Unknown encoding: " + t3;
        }, TypeError), r2("ERR_STREAM_UNSHIFT_AFTER_END_EVENT", "stream.unshift() after end event"), t2.exports.q = e2;
      }, 37865: function(t2, e2, r2) {
        var n2 = r2(90386), i = Object.keys || function(t3) {
          var e3 = [];
          for (var r3 in t3)
            e3.push(r3);
          return e3;
        };
        t2.exports = c;
        var a = r2(40410), o = r2(37493);
        r2(42018)(c, a);
        for (var s = i(o.prototype), l = 0; l < s.length; l++) {
          var u = s[l];
          c.prototype[u] || (c.prototype[u] = o.prototype[u]);
        }
        function c(t3) {
          if (!(this instanceof c))
            return new c(t3);
          a.call(this, t3), o.call(this, t3), this.allowHalfOpen = true, t3 && (false === t3.readable && (this.readable = false), false === t3.writable && (this.writable = false), false === t3.allowHalfOpen && (this.allowHalfOpen = false, this.once("end", f2)));
        }
        function f2() {
          this._writableState.ended || n2.nextTick(h, this);
        }
        function h(t3) {
          t3.end();
        }
        Object.defineProperty(c.prototype, "writableHighWaterMark", { enumerable: false, get: function() {
          return this._writableState.highWaterMark;
        } }), Object.defineProperty(c.prototype, "writableBuffer", { enumerable: false, get: function() {
          return this._writableState && this._writableState.getBuffer();
        } }), Object.defineProperty(c.prototype, "writableLength", { enumerable: false, get: function() {
          return this._writableState.length;
        } }), Object.defineProperty(c.prototype, "destroyed", { enumerable: false, get: function() {
          return void 0 !== this._readableState && void 0 !== this._writableState && this._readableState.destroyed && this._writableState.destroyed;
        }, set: function(t3) {
          void 0 !== this._readableState && void 0 !== this._writableState && (this._readableState.destroyed = t3, this._writableState.destroyed = t3);
        } });
      }, 66897: function(t2, e2, r2) {
        t2.exports = i;
        var n2 = r2(74308);
        function i(t3) {
          if (!(this instanceof i))
            return new i(t3);
          n2.call(this, t3);
        }
        r2(42018)(i, n2), i.prototype._transform = function(t3, e3, r3) {
          r3(null, t3);
        };
      }, 40410: function(t2, e2, r2) {
        var n2, i = r2(90386);
        t2.exports = A, A.ReadableState = k, r2(15398).EventEmitter;
        var a, o = function(t3, e3) {
          return t3.listeners(e3).length;
        }, s = r2(71405), l = r2(12856).Buffer, u = r2.g.Uint8Array || function() {
        }, c = r2(40964);
        a = c && c.debuglog ? c.debuglog("stream") : function() {
        };
        var f2, h, p2, d2 = r2(31125), v = r2(65756), g2 = r2(56306).getHighWaterMark, y = r2(74322).q, m2 = y.ERR_INVALID_ARG_TYPE, x = y.ERR_STREAM_PUSH_AFTER_EOF, b = y.ERR_METHOD_NOT_IMPLEMENTED, _ = y.ERR_STREAM_UNSHIFT_AFTER_END_EVENT;
        r2(42018)(A, s);
        var w2 = v.errorOrDestroy, T = ["error", "close", "destroy", "pause", "resume"];
        function k(t3, e3, i2) {
          n2 = n2 || r2(37865), t3 = t3 || {}, "boolean" != typeof i2 && (i2 = e3 instanceof n2), this.objectMode = !!t3.objectMode, i2 && (this.objectMode = this.objectMode || !!t3.readableObjectMode), this.highWaterMark = g2(this, t3, "readableHighWaterMark", i2), this.buffer = new d2(), this.length = 0, this.pipes = null, this.pipesCount = 0, this.flowing = null, this.ended = false, this.endEmitted = false, this.reading = false, this.sync = true, this.needReadable = false, this.emittedReadable = false, this.readableListening = false, this.resumeScheduled = false, this.paused = true, this.emitClose = false !== t3.emitClose, this.autoDestroy = !!t3.autoDestroy, this.destroyed = false, this.defaultEncoding = t3.defaultEncoding || "utf8", this.awaitDrain = 0, this.readingMore = false, this.decoder = null, this.encoding = null, t3.encoding && (f2 || (f2 = r2(68019).s), this.decoder = new f2(t3.encoding), this.encoding = t3.encoding);
        }
        function A(t3) {
          if (n2 = n2 || r2(37865), !(this instanceof A))
            return new A(t3);
          var e3 = this instanceof n2;
          this._readableState = new k(t3, this, e3), this.readable = true, t3 && ("function" == typeof t3.read && (this._read = t3.read), "function" == typeof t3.destroy && (this._destroy = t3.destroy)), s.call(this);
        }
        function M(t3, e3, r3, n3, i2) {
          a("readableAddChunk", e3);
          var o2, s2 = t3._readableState;
          if (null === e3)
            s2.reading = false, function(t4, e4) {
              if (a("onEofChunk"), !e4.ended) {
                if (e4.decoder) {
                  var r4 = e4.decoder.end();
                  r4 && r4.length && (e4.buffer.push(r4), e4.length += e4.objectMode ? 1 : r4.length);
                }
                e4.ended = true, e4.sync ? C(t4) : (e4.needReadable = false, e4.emittedReadable || (e4.emittedReadable = true, P(t4)));
              }
            }(t3, s2);
          else if (i2 || (o2 = function(t4, e4) {
            var r4, n4;
            return n4 = e4, l.isBuffer(n4) || n4 instanceof u || "string" == typeof e4 || void 0 === e4 || t4.objectMode || (r4 = new m2("chunk", ["string", "Buffer", "Uint8Array"], e4)), r4;
          }(s2, e3)), o2)
            w2(t3, o2);
          else if (s2.objectMode || e3 && e3.length > 0)
            if ("string" == typeof e3 || s2.objectMode || Object.getPrototypeOf(e3) === l.prototype || (e3 = function(t4) {
              return l.from(t4);
            }(e3)), n3)
              s2.endEmitted ? w2(t3, new _()) : S(t3, s2, e3, true);
            else if (s2.ended)
              w2(t3, new x());
            else {
              if (s2.destroyed)
                return false;
              s2.reading = false, s2.decoder && !r3 ? (e3 = s2.decoder.write(e3), s2.objectMode || 0 !== e3.length ? S(t3, s2, e3, false) : O(t3, s2)) : S(t3, s2, e3, false);
            }
          else
            n3 || (s2.reading = false, O(t3, s2));
          return !s2.ended && (s2.length < s2.highWaterMark || 0 === s2.length);
        }
        function S(t3, e3, r3, n3) {
          e3.flowing && 0 === e3.length && !e3.sync ? (e3.awaitDrain = 0, t3.emit("data", r3)) : (e3.length += e3.objectMode ? 1 : r3.length, n3 ? e3.buffer.unshift(r3) : e3.buffer.push(r3), e3.needReadable && C(t3)), O(t3, e3);
        }
        Object.defineProperty(A.prototype, "destroyed", { enumerable: false, get: function() {
          return void 0 !== this._readableState && this._readableState.destroyed;
        }, set: function(t3) {
          this._readableState && (this._readableState.destroyed = t3);
        } }), A.prototype.destroy = v.destroy, A.prototype._undestroy = v.undestroy, A.prototype._destroy = function(t3, e3) {
          e3(t3);
        }, A.prototype.push = function(t3, e3) {
          var r3, n3 = this._readableState;
          return n3.objectMode ? r3 = true : "string" == typeof t3 && ((e3 = e3 || n3.defaultEncoding) !== n3.encoding && (t3 = l.from(t3, e3), e3 = ""), r3 = true), M(this, t3, e3, false, r3);
        }, A.prototype.unshift = function(t3) {
          return M(this, t3, null, true, false);
        }, A.prototype.isPaused = function() {
          return false === this._readableState.flowing;
        }, A.prototype.setEncoding = function(t3) {
          f2 || (f2 = r2(68019).s);
          var e3 = new f2(t3);
          this._readableState.decoder = e3, this._readableState.encoding = this._readableState.decoder.encoding;
          for (var n3 = this._readableState.buffer.head, i2 = ""; null !== n3; )
            i2 += e3.write(n3.data), n3 = n3.next;
          return this._readableState.buffer.clear(), "" !== i2 && this._readableState.buffer.push(i2), this._readableState.length = i2.length, this;
        };
        var E = 1073741824;
        function L(t3, e3) {
          return t3 <= 0 || 0 === e3.length && e3.ended ? 0 : e3.objectMode ? 1 : t3 != t3 ? e3.flowing && e3.length ? e3.buffer.head.data.length : e3.length : (t3 > e3.highWaterMark && (e3.highWaterMark = function(t4) {
            return t4 >= E ? t4 = E : (t4--, t4 |= t4 >>> 1, t4 |= t4 >>> 2, t4 |= t4 >>> 4, t4 |= t4 >>> 8, t4 |= t4 >>> 16, t4++), t4;
          }(t3)), t3 <= e3.length ? t3 : e3.ended ? e3.length : (e3.needReadable = true, 0));
        }
        function C(t3) {
          var e3 = t3._readableState;
          a("emitReadable", e3.needReadable, e3.emittedReadable), e3.needReadable = false, e3.emittedReadable || (a("emitReadable", e3.flowing), e3.emittedReadable = true, i.nextTick(P, t3));
        }
        function P(t3) {
          var e3 = t3._readableState;
          a("emitReadable_", e3.destroyed, e3.length, e3.ended), e3.destroyed || !e3.length && !e3.ended || (t3.emit("readable"), e3.emittedReadable = false), e3.needReadable = !e3.flowing && !e3.ended && e3.length <= e3.highWaterMark, F(t3);
        }
        function O(t3, e3) {
          e3.readingMore || (e3.readingMore = true, i.nextTick(I, t3, e3));
        }
        function I(t3, e3) {
          for (; !e3.reading && !e3.ended && (e3.length < e3.highWaterMark || e3.flowing && 0 === e3.length); ) {
            var r3 = e3.length;
            if (a("maybeReadMore read 0"), t3.read(0), r3 === e3.length)
              break;
          }
          e3.readingMore = false;
        }
        function D(t3) {
          var e3 = t3._readableState;
          e3.readableListening = t3.listenerCount("readable") > 0, e3.resumeScheduled && !e3.paused ? e3.flowing = true : t3.listenerCount("data") > 0 && t3.resume();
        }
        function z(t3) {
          a("readable nexttick read 0"), t3.read(0);
        }
        function R(t3, e3) {
          a("resume", e3.reading), e3.reading || t3.read(0), e3.resumeScheduled = false, t3.emit("resume"), F(t3), e3.flowing && !e3.reading && t3.read(0);
        }
        function F(t3) {
          var e3 = t3._readableState;
          for (a("flow", e3.flowing); e3.flowing && null !== t3.read(); )
            ;
        }
        function B(t3, e3) {
          return 0 === e3.length ? null : (e3.objectMode ? r3 = e3.buffer.shift() : !t3 || t3 >= e3.length ? (r3 = e3.decoder ? e3.buffer.join("") : 1 === e3.buffer.length ? e3.buffer.first() : e3.buffer.concat(e3.length), e3.buffer.clear()) : r3 = e3.buffer.consume(t3, e3.decoder), r3);
          var r3;
        }
        function N(t3) {
          var e3 = t3._readableState;
          a("endReadable", e3.endEmitted), e3.endEmitted || (e3.ended = true, i.nextTick(j, e3, t3));
        }
        function j(t3, e3) {
          if (a("endReadableNT", t3.endEmitted, t3.length), !t3.endEmitted && 0 === t3.length && (t3.endEmitted = true, e3.readable = false, e3.emit("end"), t3.autoDestroy)) {
            var r3 = e3._writableState;
            (!r3 || r3.autoDestroy && r3.finished) && e3.destroy();
          }
        }
        function U(t3, e3) {
          for (var r3 = 0, n3 = t3.length; r3 < n3; r3++)
            if (t3[r3] === e3)
              return r3;
          return -1;
        }
        A.prototype.read = function(t3) {
          a("read", t3), t3 = parseInt(t3, 10);
          var e3 = this._readableState, r3 = t3;
          if (0 !== t3 && (e3.emittedReadable = false), 0 === t3 && e3.needReadable && ((0 !== e3.highWaterMark ? e3.length >= e3.highWaterMark : e3.length > 0) || e3.ended))
            return a("read: emitReadable", e3.length, e3.ended), 0 === e3.length && e3.ended ? N(this) : C(this), null;
          if (0 === (t3 = L(t3, e3)) && e3.ended)
            return 0 === e3.length && N(this), null;
          var n3, i2 = e3.needReadable;
          return a("need readable", i2), (0 === e3.length || e3.length - t3 < e3.highWaterMark) && a("length less than watermark", i2 = true), e3.ended || e3.reading ? a("reading or ended", i2 = false) : i2 && (a("do read"), e3.reading = true, e3.sync = true, 0 === e3.length && (e3.needReadable = true), this._read(e3.highWaterMark), e3.sync = false, e3.reading || (t3 = L(r3, e3))), null === (n3 = t3 > 0 ? B(t3, e3) : null) ? (e3.needReadable = e3.length <= e3.highWaterMark, t3 = 0) : (e3.length -= t3, e3.awaitDrain = 0), 0 === e3.length && (e3.ended || (e3.needReadable = true), r3 !== t3 && e3.ended && N(this)), null !== n3 && this.emit("data", n3), n3;
        }, A.prototype._read = function(t3) {
          w2(this, new b("_read()"));
        }, A.prototype.pipe = function(t3, e3) {
          var r3 = this, n3 = this._readableState;
          switch (n3.pipesCount) {
            case 0:
              n3.pipes = t3;
              break;
            case 1:
              n3.pipes = [n3.pipes, t3];
              break;
            default:
              n3.pipes.push(t3);
          }
          n3.pipesCount += 1, a("pipe count=%d opts=%j", n3.pipesCount, e3);
          var s2 = e3 && false === e3.end || t3 === i.stdout || t3 === i.stderr ? v2 : l2;
          function l2() {
            a("onend"), t3.end();
          }
          n3.endEmitted ? i.nextTick(s2) : r3.once("end", s2), t3.on("unpipe", function e4(i2, o2) {
            a("onunpipe"), i2 === r3 && o2 && false === o2.hasUnpiped && (o2.hasUnpiped = true, a("cleanup"), t3.removeListener("close", p3), t3.removeListener("finish", d3), t3.removeListener("drain", u2), t3.removeListener("error", h2), t3.removeListener("unpipe", e4), r3.removeListener("end", l2), r3.removeListener("end", v2), r3.removeListener("data", f3), c2 = true, !n3.awaitDrain || t3._writableState && !t3._writableState.needDrain || u2());
          });
          var u2 = function(t4) {
            return function() {
              var e4 = t4._readableState;
              a("pipeOnDrain", e4.awaitDrain), e4.awaitDrain && e4.awaitDrain--, 0 === e4.awaitDrain && o(t4, "data") && (e4.flowing = true, F(t4));
            };
          }(r3);
          t3.on("drain", u2);
          var c2 = false;
          function f3(e4) {
            a("ondata");
            var i2 = t3.write(e4);
            a("dest.write", i2), false === i2 && ((1 === n3.pipesCount && n3.pipes === t3 || n3.pipesCount > 1 && -1 !== U(n3.pipes, t3)) && !c2 && (a("false write response, pause", n3.awaitDrain), n3.awaitDrain++), r3.pause());
          }
          function h2(e4) {
            a("onerror", e4), v2(), t3.removeListener("error", h2), 0 === o(t3, "error") && w2(t3, e4);
          }
          function p3() {
            t3.removeListener("finish", d3), v2();
          }
          function d3() {
            a("onfinish"), t3.removeListener("close", p3), v2();
          }
          function v2() {
            a("unpipe"), r3.unpipe(t3);
          }
          return r3.on("data", f3), function(t4, e4, r4) {
            if ("function" == typeof t4.prependListener)
              return t4.prependListener(e4, r4);
            t4._events && t4._events.error ? Array.isArray(t4._events.error) ? t4._events.error.unshift(r4) : t4._events.error = [r4, t4._events.error] : t4.on(e4, r4);
          }(t3, "error", h2), t3.once("close", p3), t3.once("finish", d3), t3.emit("pipe", r3), n3.flowing || (a("pipe resume"), r3.resume()), t3;
        }, A.prototype.unpipe = function(t3) {
          var e3 = this._readableState, r3 = { hasUnpiped: false };
          if (0 === e3.pipesCount)
            return this;
          if (1 === e3.pipesCount)
            return t3 && t3 !== e3.pipes || (t3 || (t3 = e3.pipes), e3.pipes = null, e3.pipesCount = 0, e3.flowing = false, t3 && t3.emit("unpipe", this, r3)), this;
          if (!t3) {
            var n3 = e3.pipes, i2 = e3.pipesCount;
            e3.pipes = null, e3.pipesCount = 0, e3.flowing = false;
            for (var a2 = 0; a2 < i2; a2++)
              n3[a2].emit("unpipe", this, { hasUnpiped: false });
            return this;
          }
          var o2 = U(e3.pipes, t3);
          return -1 === o2 || (e3.pipes.splice(o2, 1), e3.pipesCount -= 1, 1 === e3.pipesCount && (e3.pipes = e3.pipes[0]), t3.emit("unpipe", this, r3)), this;
        }, A.prototype.on = function(t3, e3) {
          var r3 = s.prototype.on.call(this, t3, e3), n3 = this._readableState;
          return "data" === t3 ? (n3.readableListening = this.listenerCount("readable") > 0, false !== n3.flowing && this.resume()) : "readable" === t3 && (n3.endEmitted || n3.readableListening || (n3.readableListening = n3.needReadable = true, n3.flowing = false, n3.emittedReadable = false, a("on readable", n3.length, n3.reading), n3.length ? C(this) : n3.reading || i.nextTick(z, this))), r3;
        }, A.prototype.addListener = A.prototype.on, A.prototype.removeListener = function(t3, e3) {
          var r3 = s.prototype.removeListener.call(this, t3, e3);
          return "readable" === t3 && i.nextTick(D, this), r3;
        }, A.prototype.removeAllListeners = function(t3) {
          var e3 = s.prototype.removeAllListeners.apply(this, arguments);
          return "readable" !== t3 && void 0 !== t3 || i.nextTick(D, this), e3;
        }, A.prototype.resume = function() {
          var t3 = this._readableState;
          return t3.flowing || (a("resume"), t3.flowing = !t3.readableListening, function(t4, e3) {
            e3.resumeScheduled || (e3.resumeScheduled = true, i.nextTick(R, t4, e3));
          }(this, t3)), t3.paused = false, this;
        }, A.prototype.pause = function() {
          return a("call pause flowing=%j", this._readableState.flowing), false !== this._readableState.flowing && (a("pause"), this._readableState.flowing = false, this.emit("pause")), this._readableState.paused = true, this;
        }, A.prototype.wrap = function(t3) {
          var e3 = this, r3 = this._readableState, n3 = false;
          for (var i2 in t3.on("end", function() {
            if (a("wrapped end"), r3.decoder && !r3.ended) {
              var t4 = r3.decoder.end();
              t4 && t4.length && e3.push(t4);
            }
            e3.push(null);
          }), t3.on("data", function(i3) {
            a("wrapped data"), r3.decoder && (i3 = r3.decoder.write(i3)), r3.objectMode && null == i3 || (r3.objectMode || i3 && i3.length) && (e3.push(i3) || (n3 = true, t3.pause()));
          }), t3)
            void 0 === this[i2] && "function" == typeof t3[i2] && (this[i2] = function(e4) {
              return function() {
                return t3[e4].apply(t3, arguments);
              };
            }(i2));
          for (var o2 = 0; o2 < T.length; o2++)
            t3.on(T[o2], this.emit.bind(this, T[o2]));
          return this._read = function(e4) {
            a("wrapped _read", e4), n3 && (n3 = false, t3.resume());
          }, this;
        }, "function" == typeof Symbol && (A.prototype[Symbol.asyncIterator] = function() {
          return void 0 === h && (h = r2(68221)), h(this);
        }), Object.defineProperty(A.prototype, "readableHighWaterMark", { enumerable: false, get: function() {
          return this._readableState.highWaterMark;
        } }), Object.defineProperty(A.prototype, "readableBuffer", { enumerable: false, get: function() {
          return this._readableState && this._readableState.buffer;
        } }), Object.defineProperty(A.prototype, "readableFlowing", { enumerable: false, get: function() {
          return this._readableState.flowing;
        }, set: function(t3) {
          this._readableState && (this._readableState.flowing = t3);
        } }), A._fromList = B, Object.defineProperty(A.prototype, "readableLength", { enumerable: false, get: function() {
          return this._readableState.length;
        } }), "function" == typeof Symbol && (A.from = function(t3, e3) {
          return void 0 === p2 && (p2 = r2(31748)), p2(A, t3, e3);
        });
      }, 74308: function(t2, e2, r2) {
        t2.exports = c;
        var n2 = r2(74322).q, i = n2.ERR_METHOD_NOT_IMPLEMENTED, a = n2.ERR_MULTIPLE_CALLBACK, o = n2.ERR_TRANSFORM_ALREADY_TRANSFORMING, s = n2.ERR_TRANSFORM_WITH_LENGTH_0, l = r2(37865);
        function u(t3, e3) {
          var r3 = this._transformState;
          r3.transforming = false;
          var n3 = r3.writecb;
          if (null === n3)
            return this.emit("error", new a());
          r3.writechunk = null, r3.writecb = null, null != e3 && this.push(e3), n3(t3);
          var i2 = this._readableState;
          i2.reading = false, (i2.needReadable || i2.length < i2.highWaterMark) && this._read(i2.highWaterMark);
        }
        function c(t3) {
          if (!(this instanceof c))
            return new c(t3);
          l.call(this, t3), this._transformState = { afterTransform: u.bind(this), needTransform: false, transforming: false, writecb: null, writechunk: null, writeencoding: null }, this._readableState.needReadable = true, this._readableState.sync = false, t3 && ("function" == typeof t3.transform && (this._transform = t3.transform), "function" == typeof t3.flush && (this._flush = t3.flush)), this.on("prefinish", f2);
        }
        function f2() {
          var t3 = this;
          "function" != typeof this._flush || this._readableState.destroyed ? h(this, null, null) : this._flush(function(e3, r3) {
            h(t3, e3, r3);
          });
        }
        function h(t3, e3, r3) {
          if (e3)
            return t3.emit("error", e3);
          if (null != r3 && t3.push(r3), t3._writableState.length)
            throw new s();
          if (t3._transformState.transforming)
            throw new o();
          return t3.push(null);
        }
        r2(42018)(c, l), c.prototype.push = function(t3, e3) {
          return this._transformState.needTransform = false, l.prototype.push.call(this, t3, e3);
        }, c.prototype._transform = function(t3, e3, r3) {
          r3(new i("_transform()"));
        }, c.prototype._write = function(t3, e3, r3) {
          var n3 = this._transformState;
          if (n3.writecb = r3, n3.writechunk = t3, n3.writeencoding = e3, !n3.transforming) {
            var i2 = this._readableState;
            (n3.needTransform || i2.needReadable || i2.length < i2.highWaterMark) && this._read(i2.highWaterMark);
          }
        }, c.prototype._read = function(t3) {
          var e3 = this._transformState;
          null === e3.writechunk || e3.transforming ? e3.needTransform = true : (e3.transforming = true, this._transform(e3.writechunk, e3.writeencoding, e3.afterTransform));
        }, c.prototype._destroy = function(t3, e3) {
          l.prototype._destroy.call(this, t3, function(t4) {
            e3(t4);
          });
        };
      }, 37493: function(t2, e2, r2) {
        var n2, i = r2(90386);
        function a(t3) {
          var e3 = this;
          this.next = null, this.entry = null, this.finish = function() {
            !function(t4, e4, r3) {
              var n3 = t4.entry;
              for (t4.entry = null; n3; ) {
                var i2 = n3.callback;
                e4.pendingcb--, i2(void 0), n3 = n3.next;
              }
              e4.corkedRequestsFree.next = t4;
            }(e3, t3);
          };
        }
        t2.exports = A, A.WritableState = k;
        var o, s = { deprecate: r2(20588) }, l = r2(71405), u = r2(12856).Buffer, c = r2.g.Uint8Array || function() {
        }, f2 = r2(65756), h = r2(56306).getHighWaterMark, p2 = r2(74322).q, d2 = p2.ERR_INVALID_ARG_TYPE, v = p2.ERR_METHOD_NOT_IMPLEMENTED, g2 = p2.ERR_MULTIPLE_CALLBACK, y = p2.ERR_STREAM_CANNOT_PIPE, m2 = p2.ERR_STREAM_DESTROYED, x = p2.ERR_STREAM_NULL_VALUES, b = p2.ERR_STREAM_WRITE_AFTER_END, _ = p2.ERR_UNKNOWN_ENCODING, w2 = f2.errorOrDestroy;
        function T() {
        }
        function k(t3, e3, o2) {
          n2 = n2 || r2(37865), t3 = t3 || {}, "boolean" != typeof o2 && (o2 = e3 instanceof n2), this.objectMode = !!t3.objectMode, o2 && (this.objectMode = this.objectMode || !!t3.writableObjectMode), this.highWaterMark = h(this, t3, "writableHighWaterMark", o2), this.finalCalled = false, this.needDrain = false, this.ending = false, this.ended = false, this.finished = false, this.destroyed = false;
          var s2 = false === t3.decodeStrings;
          this.decodeStrings = !s2, this.defaultEncoding = t3.defaultEncoding || "utf8", this.length = 0, this.writing = false, this.corked = 0, this.sync = true, this.bufferProcessing = false, this.onwrite = function(t4) {
            !function(t5, e4) {
              var r3 = t5._writableState, n3 = r3.sync, a2 = r3.writecb;
              if ("function" != typeof a2)
                throw new g2();
              if (function(t6) {
                t6.writing = false, t6.writecb = null, t6.length -= t6.writelen, t6.writelen = 0;
              }(r3), e4)
                !function(t6, e5, r4, n4, a3) {
                  --e5.pendingcb, r4 ? (i.nextTick(a3, n4), i.nextTick(P, t6, e5), t6._writableState.errorEmitted = true, w2(t6, n4)) : (a3(n4), t6._writableState.errorEmitted = true, w2(t6, n4), P(t6, e5));
                }(t5, r3, n3, e4, a2);
              else {
                var o3 = L(r3) || t5.destroyed;
                o3 || r3.corked || r3.bufferProcessing || !r3.bufferedRequest || E(t5, r3), n3 ? i.nextTick(S, t5, r3, o3, a2) : S(t5, r3, o3, a2);
              }
            }(e3, t4);
          }, this.writecb = null, this.writelen = 0, this.bufferedRequest = null, this.lastBufferedRequest = null, this.pendingcb = 0, this.prefinished = false, this.errorEmitted = false, this.emitClose = false !== t3.emitClose, this.autoDestroy = !!t3.autoDestroy, this.bufferedRequestCount = 0, this.corkedRequestsFree = new a(this);
        }
        function A(t3) {
          var e3 = this instanceof (n2 = n2 || r2(37865));
          if (!e3 && !o.call(A, this))
            return new A(t3);
          this._writableState = new k(t3, this, e3), this.writable = true, t3 && ("function" == typeof t3.write && (this._write = t3.write), "function" == typeof t3.writev && (this._writev = t3.writev), "function" == typeof t3.destroy && (this._destroy = t3.destroy), "function" == typeof t3.final && (this._final = t3.final)), l.call(this);
        }
        function M(t3, e3, r3, n3, i2, a2, o2) {
          e3.writelen = n3, e3.writecb = o2, e3.writing = true, e3.sync = true, e3.destroyed ? e3.onwrite(new m2("write")) : r3 ? t3._writev(i2, e3.onwrite) : t3._write(i2, a2, e3.onwrite), e3.sync = false;
        }
        function S(t3, e3, r3, n3) {
          r3 || function(t4, e4) {
            0 === e4.length && e4.needDrain && (e4.needDrain = false, t4.emit("drain"));
          }(t3, e3), e3.pendingcb--, n3(), P(t3, e3);
        }
        function E(t3, e3) {
          e3.bufferProcessing = true;
          var r3 = e3.bufferedRequest;
          if (t3._writev && r3 && r3.next) {
            var n3 = e3.bufferedRequestCount, i2 = new Array(n3), o2 = e3.corkedRequestsFree;
            o2.entry = r3;
            for (var s2 = 0, l2 = true; r3; )
              i2[s2] = r3, r3.isBuf || (l2 = false), r3 = r3.next, s2 += 1;
            i2.allBuffers = l2, M(t3, e3, true, e3.length, i2, "", o2.finish), e3.pendingcb++, e3.lastBufferedRequest = null, o2.next ? (e3.corkedRequestsFree = o2.next, o2.next = null) : e3.corkedRequestsFree = new a(e3), e3.bufferedRequestCount = 0;
          } else {
            for (; r3; ) {
              var u2 = r3.chunk, c2 = r3.encoding, f3 = r3.callback;
              if (M(t3, e3, false, e3.objectMode ? 1 : u2.length, u2, c2, f3), r3 = r3.next, e3.bufferedRequestCount--, e3.writing)
                break;
            }
            null === r3 && (e3.lastBufferedRequest = null);
          }
          e3.bufferedRequest = r3, e3.bufferProcessing = false;
        }
        function L(t3) {
          return t3.ending && 0 === t3.length && null === t3.bufferedRequest && !t3.finished && !t3.writing;
        }
        function C(t3, e3) {
          t3._final(function(r3) {
            e3.pendingcb--, r3 && w2(t3, r3), e3.prefinished = true, t3.emit("prefinish"), P(t3, e3);
          });
        }
        function P(t3, e3) {
          var r3 = L(e3);
          if (r3 && (function(t4, e4) {
            e4.prefinished || e4.finalCalled || ("function" != typeof t4._final || e4.destroyed ? (e4.prefinished = true, t4.emit("prefinish")) : (e4.pendingcb++, e4.finalCalled = true, i.nextTick(C, t4, e4)));
          }(t3, e3), 0 === e3.pendingcb && (e3.finished = true, t3.emit("finish"), e3.autoDestroy))) {
            var n3 = t3._readableState;
            (!n3 || n3.autoDestroy && n3.endEmitted) && t3.destroy();
          }
          return r3;
        }
        r2(42018)(A, l), k.prototype.getBuffer = function() {
          for (var t3 = this.bufferedRequest, e3 = []; t3; )
            e3.push(t3), t3 = t3.next;
          return e3;
        }, function() {
          try {
            Object.defineProperty(k.prototype, "buffer", { get: s.deprecate(function() {
              return this.getBuffer();
            }, "_writableState.buffer is deprecated. Use _writableState.getBuffer instead.", "DEP0003") });
          } catch (t3) {
          }
        }(), "function" == typeof Symbol && Symbol.hasInstance && "function" == typeof Function.prototype[Symbol.hasInstance] ? (o = Function.prototype[Symbol.hasInstance], Object.defineProperty(A, Symbol.hasInstance, { value: function(t3) {
          return !!o.call(this, t3) || this === A && t3 && t3._writableState instanceof k;
        } })) : o = function(t3) {
          return t3 instanceof this;
        }, A.prototype.pipe = function() {
          w2(this, new y());
        }, A.prototype.write = function(t3, e3, r3) {
          var n3, a2 = this._writableState, o2 = false, s2 = !a2.objectMode && (n3 = t3, u.isBuffer(n3) || n3 instanceof c);
          return s2 && !u.isBuffer(t3) && (t3 = function(t4) {
            return u.from(t4);
          }(t3)), "function" == typeof e3 && (r3 = e3, e3 = null), s2 ? e3 = "buffer" : e3 || (e3 = a2.defaultEncoding), "function" != typeof r3 && (r3 = T), a2.ending ? function(t4, e4) {
            var r4 = new b();
            w2(t4, r4), i.nextTick(e4, r4);
          }(this, r3) : (s2 || function(t4, e4, r4, n4) {
            var a3;
            return null === r4 ? a3 = new x() : "string" == typeof r4 || e4.objectMode || (a3 = new d2("chunk", ["string", "Buffer"], r4)), !a3 || (w2(t4, a3), i.nextTick(n4, a3), false);
          }(this, a2, t3, r3)) && (a2.pendingcb++, o2 = function(t4, e4, r4, n4, i2, a3) {
            if (!r4) {
              var o3 = function(t5, e5, r5) {
                return t5.objectMode || false === t5.decodeStrings || "string" != typeof e5 || (e5 = u.from(e5, r5)), e5;
              }(e4, n4, i2);
              n4 !== o3 && (r4 = true, i2 = "buffer", n4 = o3);
            }
            var s3 = e4.objectMode ? 1 : n4.length;
            e4.length += s3;
            var l2 = e4.length < e4.highWaterMark;
            if (l2 || (e4.needDrain = true), e4.writing || e4.corked) {
              var c2 = e4.lastBufferedRequest;
              e4.lastBufferedRequest = { chunk: n4, encoding: i2, isBuf: r4, callback: a3, next: null }, c2 ? c2.next = e4.lastBufferedRequest : e4.bufferedRequest = e4.lastBufferedRequest, e4.bufferedRequestCount += 1;
            } else
              M(t4, e4, false, s3, n4, i2, a3);
            return l2;
          }(this, a2, s2, t3, e3, r3)), o2;
        }, A.prototype.cork = function() {
          this._writableState.corked++;
        }, A.prototype.uncork = function() {
          var t3 = this._writableState;
          t3.corked && (t3.corked--, t3.writing || t3.corked || t3.bufferProcessing || !t3.bufferedRequest || E(this, t3));
        }, A.prototype.setDefaultEncoding = function(t3) {
          if ("string" == typeof t3 && (t3 = t3.toLowerCase()), !(["hex", "utf8", "utf-8", "ascii", "binary", "base64", "ucs2", "ucs-2", "utf16le", "utf-16le", "raw"].indexOf((t3 + "").toLowerCase()) > -1))
            throw new _(t3);
          return this._writableState.defaultEncoding = t3, this;
        }, Object.defineProperty(A.prototype, "writableBuffer", { enumerable: false, get: function() {
          return this._writableState && this._writableState.getBuffer();
        } }), Object.defineProperty(A.prototype, "writableHighWaterMark", { enumerable: false, get: function() {
          return this._writableState.highWaterMark;
        } }), A.prototype._write = function(t3, e3, r3) {
          r3(new v("_write()"));
        }, A.prototype._writev = null, A.prototype.end = function(t3, e3, r3) {
          var n3 = this._writableState;
          return "function" == typeof t3 ? (r3 = t3, t3 = null, e3 = null) : "function" == typeof e3 && (r3 = e3, e3 = null), null != t3 && this.write(t3, e3), n3.corked && (n3.corked = 1, this.uncork()), n3.ending || function(t4, e4, r4) {
            e4.ending = true, P(t4, e4), r4 && (e4.finished ? i.nextTick(r4) : t4.once("finish", r4)), e4.ended = true, t4.writable = false;
          }(this, n3, r3), this;
        }, Object.defineProperty(A.prototype, "writableLength", { enumerable: false, get: function() {
          return this._writableState.length;
        } }), Object.defineProperty(A.prototype, "destroyed", { enumerable: false, get: function() {
          return void 0 !== this._writableState && this._writableState.destroyed;
        }, set: function(t3) {
          this._writableState && (this._writableState.destroyed = t3);
        } }), A.prototype.destroy = f2.destroy, A.prototype._undestroy = f2.undestroy, A.prototype._destroy = function(t3, e3) {
          e3(t3);
        };
      }, 68221: function(t2, e2, r2) {
        var n2, i = r2(90386);
        function a(t3, e3, r3) {
          return e3 in t3 ? Object.defineProperty(t3, e3, { value: r3, enumerable: true, configurable: true, writable: true }) : t3[e3] = r3, t3;
        }
        var o = r2(12726), s = Symbol("lastResolve"), l = Symbol("lastReject"), u = Symbol("error"), c = Symbol("ended"), f2 = Symbol("lastPromise"), h = Symbol("handlePromise"), p2 = Symbol("stream");
        function d2(t3, e3) {
          return { value: t3, done: e3 };
        }
        function v(t3) {
          var e3 = t3[s];
          if (null !== e3) {
            var r3 = t3[p2].read();
            null !== r3 && (t3[f2] = null, t3[s] = null, t3[l] = null, e3(d2(r3, false)));
          }
        }
        function g2(t3) {
          i.nextTick(v, t3);
        }
        var y = Object.getPrototypeOf(function() {
        }), m2 = Object.setPrototypeOf((a(n2 = { get stream() {
          return this[p2];
        }, next: function() {
          var t3 = this, e3 = this[u];
          if (null !== e3)
            return Promise.reject(e3);
          if (this[c])
            return Promise.resolve(d2(void 0, true));
          if (this[p2].destroyed)
            return new Promise(function(e4, r4) {
              i.nextTick(function() {
                t3[u] ? r4(t3[u]) : e4(d2(void 0, true));
              });
            });
          var r3, n3 = this[f2];
          if (n3)
            r3 = new Promise(function(t4, e4) {
              return function(r4, n4) {
                t4.then(function() {
                  e4[c] ? r4(d2(void 0, true)) : e4[h](r4, n4);
                }, n4);
              };
            }(n3, this));
          else {
            var a2 = this[p2].read();
            if (null !== a2)
              return Promise.resolve(d2(a2, false));
            r3 = new Promise(this[h]);
          }
          return this[f2] = r3, r3;
        } }, Symbol.asyncIterator, function() {
          return this;
        }), a(n2, "return", function() {
          var t3 = this;
          return new Promise(function(e3, r3) {
            t3[p2].destroy(null, function(t4) {
              t4 ? r3(t4) : e3(d2(void 0, true));
            });
          });
        }), n2), y);
        t2.exports = function(t3) {
          var e3, r3 = Object.create(m2, (a(e3 = {}, p2, { value: t3, writable: true }), a(e3, s, { value: null, writable: true }), a(e3, l, { value: null, writable: true }), a(e3, u, { value: null, writable: true }), a(e3, c, { value: t3._readableState.endEmitted, writable: true }), a(e3, h, { value: function(t4, e4) {
            var n3 = r3[p2].read();
            n3 ? (r3[f2] = null, r3[s] = null, r3[l] = null, t4(d2(n3, false))) : (r3[s] = t4, r3[l] = e4);
          }, writable: true }), e3));
          return r3[f2] = null, o(t3, function(t4) {
            if (t4 && "ERR_STREAM_PREMATURE_CLOSE" !== t4.code) {
              var e4 = r3[l];
              return null !== e4 && (r3[f2] = null, r3[s] = null, r3[l] = null, e4(t4)), void (r3[u] = t4);
            }
            var n3 = r3[s];
            null !== n3 && (r3[f2] = null, r3[s] = null, r3[l] = null, n3(d2(void 0, true))), r3[c] = true;
          }), t3.on("readable", g2.bind(null, r3)), r3;
        };
      }, 31125: function(t2, e2, r2) {
        function n2(t3, e3) {
          var r3 = Object.keys(t3);
          if (Object.getOwnPropertySymbols) {
            var n3 = Object.getOwnPropertySymbols(t3);
            e3 && (n3 = n3.filter(function(e4) {
              return Object.getOwnPropertyDescriptor(t3, e4).enumerable;
            })), r3.push.apply(r3, n3);
          }
          return r3;
        }
        function i(t3, e3, r3) {
          return e3 in t3 ? Object.defineProperty(t3, e3, { value: r3, enumerable: true, configurable: true, writable: true }) : t3[e3] = r3, t3;
        }
        function a(t3, e3) {
          for (var r3 = 0; r3 < e3.length; r3++) {
            var n3 = e3[r3];
            n3.enumerable = n3.enumerable || false, n3.configurable = true, "value" in n3 && (n3.writable = true), Object.defineProperty(t3, n3.key, n3);
          }
        }
        var o = r2(12856).Buffer, s = r2(69862).inspect, l = s && s.custom || "inspect";
        t2.exports = function() {
          function t3() {
            !function(t4, e4) {
              if (!(t4 instanceof e4))
                throw new TypeError("Cannot call a class as a function");
            }(this, t3), this.head = null, this.tail = null, this.length = 0;
          }
          var e3, r3;
          return e3 = t3, r3 = [{ key: "push", value: function(t4) {
            var e4 = { data: t4, next: null };
            this.length > 0 ? this.tail.next = e4 : this.head = e4, this.tail = e4, ++this.length;
          } }, { key: "unshift", value: function(t4) {
            var e4 = { data: t4, next: this.head };
            0 === this.length && (this.tail = e4), this.head = e4, ++this.length;
          } }, { key: "shift", value: function() {
            if (0 !== this.length) {
              var t4 = this.head.data;
              return 1 === this.length ? this.head = this.tail = null : this.head = this.head.next, --this.length, t4;
            }
          } }, { key: "clear", value: function() {
            this.head = this.tail = null, this.length = 0;
          } }, { key: "join", value: function(t4) {
            if (0 === this.length)
              return "";
            for (var e4 = this.head, r4 = "" + e4.data; e4 = e4.next; )
              r4 += t4 + e4.data;
            return r4;
          } }, { key: "concat", value: function(t4) {
            if (0 === this.length)
              return o.alloc(0);
            for (var e4, r4, n3, i2 = o.allocUnsafe(t4 >>> 0), a2 = this.head, s2 = 0; a2; )
              e4 = a2.data, r4 = i2, n3 = s2, o.prototype.copy.call(e4, r4, n3), s2 += a2.data.length, a2 = a2.next;
            return i2;
          } }, { key: "consume", value: function(t4, e4) {
            var r4;
            return t4 < this.head.data.length ? (r4 = this.head.data.slice(0, t4), this.head.data = this.head.data.slice(t4)) : r4 = t4 === this.head.data.length ? this.shift() : e4 ? this._getString(t4) : this._getBuffer(t4), r4;
          } }, { key: "first", value: function() {
            return this.head.data;
          } }, { key: "_getString", value: function(t4) {
            var e4 = this.head, r4 = 1, n3 = e4.data;
            for (t4 -= n3.length; e4 = e4.next; ) {
              var i2 = e4.data, a2 = t4 > i2.length ? i2.length : t4;
              if (a2 === i2.length ? n3 += i2 : n3 += i2.slice(0, t4), 0 == (t4 -= a2)) {
                a2 === i2.length ? (++r4, e4.next ? this.head = e4.next : this.head = this.tail = null) : (this.head = e4, e4.data = i2.slice(a2));
                break;
              }
              ++r4;
            }
            return this.length -= r4, n3;
          } }, { key: "_getBuffer", value: function(t4) {
            var e4 = o.allocUnsafe(t4), r4 = this.head, n3 = 1;
            for (r4.data.copy(e4), t4 -= r4.data.length; r4 = r4.next; ) {
              var i2 = r4.data, a2 = t4 > i2.length ? i2.length : t4;
              if (i2.copy(e4, e4.length - t4, 0, a2), 0 == (t4 -= a2)) {
                a2 === i2.length ? (++n3, r4.next ? this.head = r4.next : this.head = this.tail = null) : (this.head = r4, r4.data = i2.slice(a2));
                break;
              }
              ++n3;
            }
            return this.length -= n3, e4;
          } }, { key: l, value: function(t4, e4) {
            return s(this, function(t5) {
              for (var e5 = 1; e5 < arguments.length; e5++) {
                var r4 = null != arguments[e5] ? arguments[e5] : {};
                e5 % 2 ? n2(Object(r4), true).forEach(function(e6) {
                  i(t5, e6, r4[e6]);
                }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(t5, Object.getOwnPropertyDescriptors(r4)) : n2(Object(r4)).forEach(function(e6) {
                  Object.defineProperty(t5, e6, Object.getOwnPropertyDescriptor(r4, e6));
                });
              }
              return t5;
            }({}, e4, { depth: 0, customInspect: false }));
          } }], r3 && a(e3.prototype, r3), t3;
        }();
      }, 65756: function(t2, e2, r2) {
        var n2 = r2(90386);
        function i(t3, e3) {
          o(t3, e3), a(t3);
        }
        function a(t3) {
          t3._writableState && !t3._writableState.emitClose || t3._readableState && !t3._readableState.emitClose || t3.emit("close");
        }
        function o(t3, e3) {
          t3.emit("error", e3);
        }
        t2.exports = { destroy: function(t3, e3) {
          var r3 = this, s = this._readableState && this._readableState.destroyed, l = this._writableState && this._writableState.destroyed;
          return s || l ? (e3 ? e3(t3) : t3 && (this._writableState ? this._writableState.errorEmitted || (this._writableState.errorEmitted = true, n2.nextTick(o, this, t3)) : n2.nextTick(o, this, t3)), this) : (this._readableState && (this._readableState.destroyed = true), this._writableState && (this._writableState.destroyed = true), this._destroy(t3 || null, function(t4) {
            !e3 && t4 ? r3._writableState ? r3._writableState.errorEmitted ? n2.nextTick(a, r3) : (r3._writableState.errorEmitted = true, n2.nextTick(i, r3, t4)) : n2.nextTick(i, r3, t4) : e3 ? (n2.nextTick(a, r3), e3(t4)) : n2.nextTick(a, r3);
          }), this);
        }, undestroy: function() {
          this._readableState && (this._readableState.destroyed = false, this._readableState.reading = false, this._readableState.ended = false, this._readableState.endEmitted = false), this._writableState && (this._writableState.destroyed = false, this._writableState.ended = false, this._writableState.ending = false, this._writableState.finalCalled = false, this._writableState.prefinished = false, this._writableState.finished = false, this._writableState.errorEmitted = false);
        }, errorOrDestroy: function(t3, e3) {
          var r3 = t3._readableState, n3 = t3._writableState;
          r3 && r3.autoDestroy || n3 && n3.autoDestroy ? t3.destroy(e3) : t3.emit("error", e3);
        } };
      }, 12726: function(t2, e2, r2) {
        var n2 = r2(74322).q.ERR_STREAM_PREMATURE_CLOSE;
        function i() {
        }
        t2.exports = function t3(e3, r3, a) {
          if ("function" == typeof r3)
            return t3(e3, null, r3);
          r3 || (r3 = {}), a = function(t4) {
            var e4 = false;
            return function() {
              if (!e4) {
                e4 = true;
                for (var r4 = arguments.length, n3 = new Array(r4), i2 = 0; i2 < r4; i2++)
                  n3[i2] = arguments[i2];
                t4.apply(this, n3);
              }
            };
          }(a || i);
          var o = r3.readable || false !== r3.readable && e3.readable, s = r3.writable || false !== r3.writable && e3.writable, l = function() {
            e3.writable || c();
          }, u = e3._writableState && e3._writableState.finished, c = function() {
            s = false, u = true, o || a.call(e3);
          }, f2 = e3._readableState && e3._readableState.endEmitted, h = function() {
            o = false, f2 = true, s || a.call(e3);
          }, p2 = function(t4) {
            a.call(e3, t4);
          }, d2 = function() {
            var t4;
            return o && !f2 ? (e3._readableState && e3._readableState.ended || (t4 = new n2()), a.call(e3, t4)) : s && !u ? (e3._writableState && e3._writableState.ended || (t4 = new n2()), a.call(e3, t4)) : void 0;
          }, v = function() {
            e3.req.on("finish", c);
          };
          return function(t4) {
            return t4.setHeader && "function" == typeof t4.abort;
          }(e3) ? (e3.on("complete", c), e3.on("abort", d2), e3.req ? v() : e3.on("request", v)) : s && !e3._writableState && (e3.on("end", l), e3.on("close", l)), e3.on("end", h), e3.on("finish", c), false !== r3.error && e3.on("error", p2), e3.on("close", d2), function() {
            e3.removeListener("complete", c), e3.removeListener("abort", d2), e3.removeListener("request", v), e3.req && e3.req.removeListener("finish", c), e3.removeListener("end", l), e3.removeListener("close", l), e3.removeListener("finish", c), e3.removeListener("end", h), e3.removeListener("error", p2), e3.removeListener("close", d2);
          };
        };
      }, 31748: function(t2) {
        t2.exports = function() {
          throw new Error("Readable.from is not available in the browser");
        };
      }, 10168: function(t2, e2, r2) {
        var n2, i = r2(74322).q, a = i.ERR_MISSING_ARGS, o = i.ERR_STREAM_DESTROYED;
        function s(t3) {
          if (t3)
            throw t3;
        }
        function l(t3, e3, i2, a2) {
          a2 = function(t4) {
            var e4 = false;
            return function() {
              e4 || (e4 = true, t4.apply(void 0, arguments));
            };
          }(a2);
          var s2 = false;
          t3.on("close", function() {
            s2 = true;
          }), void 0 === n2 && (n2 = r2(12726)), n2(t3, { readable: e3, writable: i2 }, function(t4) {
            if (t4)
              return a2(t4);
            s2 = true, a2();
          });
          var l2 = false;
          return function(e4) {
            if (!s2 && !l2)
              return l2 = true, function(t4) {
                return t4.setHeader && "function" == typeof t4.abort;
              }(t3) ? t3.abort() : "function" == typeof t3.destroy ? t3.destroy() : void a2(e4 || new o("pipe"));
          };
        }
        function u(t3) {
          t3();
        }
        function c(t3, e3) {
          return t3.pipe(e3);
        }
        function f2(t3) {
          return t3.length ? "function" != typeof t3[t3.length - 1] ? s : t3.pop() : s;
        }
        t2.exports = function() {
          for (var t3 = arguments.length, e3 = new Array(t3), r3 = 0; r3 < t3; r3++)
            e3[r3] = arguments[r3];
          var n3, i2 = f2(e3);
          if (Array.isArray(e3[0]) && (e3 = e3[0]), e3.length < 2)
            throw new a("streams");
          var o2 = e3.map(function(t4, r4) {
            var a2 = r4 < e3.length - 1;
            return l(t4, a2, r4 > 0, function(t5) {
              n3 || (n3 = t5), t5 && o2.forEach(u), a2 || (o2.forEach(u), i2(n3));
            });
          });
          return e3.reduce(c);
        };
      }, 56306: function(t2, e2, r2) {
        var n2 = r2(74322).q.ERR_INVALID_OPT_VALUE;
        t2.exports = { getHighWaterMark: function(t3, e3, r3, i) {
          var a = function(t4, e4, r4) {
            return null != t4.highWaterMark ? t4.highWaterMark : e4 ? t4[r4] : null;
          }(e3, i, r3);
          if (null != a) {
            if (!isFinite(a) || Math.floor(a) !== a || a < 0)
              throw new n2(i ? r3 : "highWaterMark", a);
            return Math.floor(a);
          }
          return t3.objectMode ? 16 : 16384;
        } };
      }, 71405: function(t2, e2, r2) {
        t2.exports = r2(15398).EventEmitter;
      }, 68019: function(t2, e2, r2) {
        var n2 = r2(71665).Buffer, i = n2.isEncoding || function(t3) {
          switch ((t3 = "" + t3) && t3.toLowerCase()) {
            case "hex":
            case "utf8":
            case "utf-8":
            case "ascii":
            case "binary":
            case "base64":
            case "ucs2":
            case "ucs-2":
            case "utf16le":
            case "utf-16le":
            case "raw":
              return true;
            default:
              return false;
          }
        };
        function a(t3) {
          var e3;
          switch (this.encoding = function(t4) {
            var e4 = function(t5) {
              if (!t5)
                return "utf8";
              for (var e5; ; )
                switch (t5) {
                  case "utf8":
                  case "utf-8":
                    return "utf8";
                  case "ucs2":
                  case "ucs-2":
                  case "utf16le":
                  case "utf-16le":
                    return "utf16le";
                  case "latin1":
                  case "binary":
                    return "latin1";
                  case "base64":
                  case "ascii":
                  case "hex":
                    return t5;
                  default:
                    if (e5)
                      return;
                    t5 = ("" + t5).toLowerCase(), e5 = true;
                }
            }(t4);
            if ("string" != typeof e4 && (n2.isEncoding === i || !i(t4)))
              throw new Error("Unknown encoding: " + t4);
            return e4 || t4;
          }(t3), this.encoding) {
            case "utf16le":
              this.text = l, this.end = u, e3 = 4;
              break;
            case "utf8":
              this.fillLast = s, e3 = 4;
              break;
            case "base64":
              this.text = c, this.end = f2, e3 = 3;
              break;
            default:
              return this.write = h, void (this.end = p2);
          }
          this.lastNeed = 0, this.lastTotal = 0, this.lastChar = n2.allocUnsafe(e3);
        }
        function o(t3) {
          return t3 <= 127 ? 0 : t3 >> 5 == 6 ? 2 : t3 >> 4 == 14 ? 3 : t3 >> 3 == 30 ? 4 : t3 >> 6 == 2 ? -1 : -2;
        }
        function s(t3) {
          var e3 = this.lastTotal - this.lastNeed, r3 = function(t4, e4, r4) {
            if (128 != (192 & e4[0]))
              return t4.lastNeed = 0, "�";
            if (t4.lastNeed > 1 && e4.length > 1) {
              if (128 != (192 & e4[1]))
                return t4.lastNeed = 1, "�";
              if (t4.lastNeed > 2 && e4.length > 2 && 128 != (192 & e4[2]))
                return t4.lastNeed = 2, "�";
            }
          }(this, t3);
          return void 0 !== r3 ? r3 : this.lastNeed <= t3.length ? (t3.copy(this.lastChar, e3, 0, this.lastNeed), this.lastChar.toString(this.encoding, 0, this.lastTotal)) : (t3.copy(this.lastChar, e3, 0, t3.length), void (this.lastNeed -= t3.length));
        }
        function l(t3, e3) {
          if ((t3.length - e3) % 2 == 0) {
            var r3 = t3.toString("utf16le", e3);
            if (r3) {
              var n3 = r3.charCodeAt(r3.length - 1);
              if (n3 >= 55296 && n3 <= 56319)
                return this.lastNeed = 2, this.lastTotal = 4, this.lastChar[0] = t3[t3.length - 2], this.lastChar[1] = t3[t3.length - 1], r3.slice(0, -1);
            }
            return r3;
          }
          return this.lastNeed = 1, this.lastTotal = 2, this.lastChar[0] = t3[t3.length - 1], t3.toString("utf16le", e3, t3.length - 1);
        }
        function u(t3) {
          var e3 = t3 && t3.length ? this.write(t3) : "";
          if (this.lastNeed) {
            var r3 = this.lastTotal - this.lastNeed;
            return e3 + this.lastChar.toString("utf16le", 0, r3);
          }
          return e3;
        }
        function c(t3, e3) {
          var r3 = (t3.length - e3) % 3;
          return 0 === r3 ? t3.toString("base64", e3) : (this.lastNeed = 3 - r3, this.lastTotal = 3, 1 === r3 ? this.lastChar[0] = t3[t3.length - 1] : (this.lastChar[0] = t3[t3.length - 2], this.lastChar[1] = t3[t3.length - 1]), t3.toString("base64", e3, t3.length - r3));
        }
        function f2(t3) {
          var e3 = t3 && t3.length ? this.write(t3) : "";
          return this.lastNeed ? e3 + this.lastChar.toString("base64", 0, 3 - this.lastNeed) : e3;
        }
        function h(t3) {
          return t3.toString(this.encoding);
        }
        function p2(t3) {
          return t3 && t3.length ? this.write(t3) : "";
        }
        e2.s = a, a.prototype.write = function(t3) {
          if (0 === t3.length)
            return "";
          var e3, r3;
          if (this.lastNeed) {
            if (void 0 === (e3 = this.fillLast(t3)))
              return "";
            r3 = this.lastNeed, this.lastNeed = 0;
          } else
            r3 = 0;
          return r3 < t3.length ? e3 ? e3 + this.text(t3, r3) : this.text(t3, r3) : e3 || "";
        }, a.prototype.end = function(t3) {
          var e3 = t3 && t3.length ? this.write(t3) : "";
          return this.lastNeed ? e3 + "�" : e3;
        }, a.prototype.text = function(t3, e3) {
          var r3 = function(t4, e4, r4) {
            var n4 = e4.length - 1;
            if (n4 < r4)
              return 0;
            var i2 = o(e4[n4]);
            return i2 >= 0 ? (i2 > 0 && (t4.lastNeed = i2 - 1), i2) : --n4 < r4 || -2 === i2 ? 0 : (i2 = o(e4[n4])) >= 0 ? (i2 > 0 && (t4.lastNeed = i2 - 2), i2) : --n4 < r4 || -2 === i2 ? 0 : (i2 = o(e4[n4])) >= 0 ? (i2 > 0 && (2 === i2 ? i2 = 0 : t4.lastNeed = i2 - 3), i2) : 0;
          }(this, t3, e3);
          if (!this.lastNeed)
            return t3.toString("utf8", e3);
          this.lastTotal = r3;
          var n3 = t3.length - (r3 - this.lastNeed);
          return t3.copy(this.lastChar, 0, n3), t3.toString("utf8", e3, n3);
        }, a.prototype.fillLast = function(t3) {
          if (this.lastNeed <= t3.length)
            return t3.copy(this.lastChar, this.lastTotal - this.lastNeed, 0, this.lastNeed), this.lastChar.toString(this.encoding, 0, this.lastTotal);
          t3.copy(this.lastChar, this.lastTotal - this.lastNeed, 0, t3.length), this.lastNeed -= t3.length;
        };
      }, 90715: function(t2, e2, r2) {
        var n2 = r2(32791), i = r2(41633)("stream-parser");
        function a(t3) {
          i("initializing parser stream"), t3._parserBytesLeft = 0, t3._parserBuffers = [], t3._parserBuffered = 0, t3._parserState = -1, t3._parserCallback = null, "function" == typeof t3.push && (t3._parserOutput = t3.push.bind(t3)), t3._parserInit = true;
        }
        function o(t3, e3) {
          n2(!this._parserCallback, 'there is already a "callback" set!'), n2(isFinite(t3) && t3 > 0, 'can only buffer a finite number of bytes > 0, got "' + t3 + '"'), this._parserInit || a(this), i("buffering %o bytes", t3), this._parserBytesLeft = t3, this._parserCallback = e3, this._parserState = 0;
        }
        function s(t3, e3) {
          n2(!this._parserCallback, 'there is already a "callback" set!'), n2(t3 > 0, 'can only skip > 0 bytes, got "' + t3 + '"'), this._parserInit || a(this), i("skipping %o bytes", t3), this._parserBytesLeft = t3, this._parserCallback = e3, this._parserState = 1;
        }
        function l(t3, e3) {
          n2(!this._parserCallback, 'There is already a "callback" set!'), n2(t3 > 0, 'can only pass through > 0 bytes, got "' + t3 + '"'), this._parserInit || a(this), i("passing through %o bytes", t3), this._parserBytesLeft = t3, this._parserCallback = e3, this._parserState = 2;
        }
        function u(t3, e3, r3) {
          this._parserInit || a(this), i("write(%o bytes)", t3.length), "function" == typeof e3 && (r3 = e3), h(this, t3, null, r3);
        }
        function c(t3, e3, r3) {
          this._parserInit || a(this), i("transform(%o bytes)", t3.length), "function" != typeof e3 && (e3 = this._parserOutput), h(this, t3, e3, r3);
        }
        function f2(t3, e3, r3, n3) {
          if (t3._parserBytesLeft -= e3.length, i("%o bytes left for stream piece", t3._parserBytesLeft), 0 === t3._parserState ? (t3._parserBuffers.push(e3), t3._parserBuffered += e3.length) : 2 === t3._parserState && r3(e3), 0 !== t3._parserBytesLeft)
            return n3;
          var a2 = t3._parserCallback;
          if (a2 && 0 === t3._parserState && t3._parserBuffers.length > 1 && (e3 = Buffer.concat(t3._parserBuffers, t3._parserBuffered)), 0 !== t3._parserState && (e3 = null), t3._parserCallback = null, t3._parserBuffered = 0, t3._parserState = -1, t3._parserBuffers.splice(0), a2) {
            var o2 = [];
            e3 && o2.push(e3), r3 && o2.push(r3);
            var s2 = a2.length > o2.length;
            s2 && o2.push(p2(n3));
            var l2 = a2.apply(t3, o2);
            if (!s2 || n3 === l2)
              return n3;
          }
        }
        t2.exports = function(t3) {
          var e3 = t3 && "function" == typeof t3._transform, r3 = t3 && "function" == typeof t3._write;
          if (!e3 && !r3)
            throw new Error("must pass a Writable or Transform stream in");
          i("extending Parser into stream"), t3._bytes = o, t3._skipBytes = s, e3 && (t3._passthrough = l), e3 ? t3._transform = c : t3._write = u;
        };
        var h = p2(function t3(e3, r3, n3, i2) {
          return e3._parserBytesLeft <= 0 ? i2(new Error("got data but not currently parsing anything")) : r3.length <= e3._parserBytesLeft ? function() {
            return f2(e3, r3, n3, i2);
          } : function() {
            var a2 = r3.slice(0, e3._parserBytesLeft);
            return f2(e3, a2, n3, function(o2) {
              return o2 ? i2(o2) : r3.length > a2.length ? function() {
                return t3(e3, r3.slice(a2.length), n3, i2);
              } : void 0;
            });
          };
        });
        function p2(t3) {
          return function() {
            for (var e3 = t3.apply(this, arguments); "function" == typeof e3; )
              e3 = e3();
            return e3;
          };
        }
      }, 41633: function(t2, e2, r2) {
        var n2 = r2(90386);
        function i() {
          var t3;
          try {
            t3 = e2.storage.debug;
          } catch (t4) {
          }
          return !t3 && void 0 !== n2 && "env" in n2 && (t3 = n2.env.DEBUG), t3;
        }
        (e2 = t2.exports = r2(74469)).log = function() {
          return "object" == typeof console && console.log && Function.prototype.apply.call(console.log, console, arguments);
        }, e2.formatArgs = function(t3) {
          var r3 = this.useColors;
          if (t3[0] = (r3 ? "%c" : "") + this.namespace + (r3 ? " %c" : " ") + t3[0] + (r3 ? "%c " : " ") + "+" + e2.humanize(this.diff), r3) {
            var n3 = "color: " + this.color;
            t3.splice(1, 0, n3, "color: inherit");
            var i2 = 0, a = 0;
            t3[0].replace(/%[a-zA-Z%]/g, function(t4) {
              "%%" !== t4 && (i2++, "%c" === t4 && (a = i2));
            }), t3.splice(a, 0, n3);
          }
        }, e2.save = function(t3) {
          try {
            null == t3 ? e2.storage.removeItem("debug") : e2.storage.debug = t3;
          } catch (t4) {
          }
        }, e2.load = i, e2.useColors = function() {
          return !("undefined" == typeof window || !window.process || "renderer" !== window.process.type) || ("undefined" != typeof document && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || "undefined" != typeof window && window.console && (window.console.firebug || window.console.exception && window.console.table) || "undefined" != typeof navigator && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || "undefined" != typeof navigator && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/));
        }, e2.storage = "undefined" != typeof chrome && void 0 !== chrome.storage ? chrome.storage.local : function() {
          try {
            return window.localStorage;
          } catch (t3) {
          }
        }(), e2.colors = ["lightseagreen", "forestgreen", "goldenrod", "dodgerblue", "darkorchid", "crimson"], e2.formatters.j = function(t3) {
          try {
            return JSON.stringify(t3);
          } catch (t4) {
            return "[UnexpectedJSONParseError]: " + t4.message;
          }
        }, e2.enable(i());
      }, 74469: function(t2, e2, r2) {
        var n2;
        function i(t3) {
          function r3() {
            if (r3.enabled) {
              var t4 = r3, i2 = +new Date(), a = i2 - (n2 || i2);
              t4.diff = a, t4.prev = n2, t4.curr = i2, n2 = i2;
              for (var o = new Array(arguments.length), s = 0; s < o.length; s++)
                o[s] = arguments[s];
              o[0] = e2.coerce(o[0]), "string" != typeof o[0] && o.unshift("%O");
              var l = 0;
              o[0] = o[0].replace(/%([a-zA-Z%])/g, function(r4, n3) {
                if ("%%" === r4)
                  return r4;
                l++;
                var i3 = e2.formatters[n3];
                if ("function" == typeof i3) {
                  var a2 = o[l];
                  r4 = i3.call(t4, a2), o.splice(l, 1), l--;
                }
                return r4;
              }), e2.formatArgs.call(t4, o);
              var u = r3.log || e2.log || console.log.bind(console);
              u.apply(t4, o);
            }
          }
          return r3.namespace = t3, r3.enabled = e2.enabled(t3), r3.useColors = e2.useColors(), r3.color = function(t4) {
            var r4, n3 = 0;
            for (r4 in t4)
              n3 = (n3 << 5) - n3 + t4.charCodeAt(r4), n3 |= 0;
            return e2.colors[Math.abs(n3) % e2.colors.length];
          }(t3), "function" == typeof e2.init && e2.init(r3), r3;
        }
        (e2 = t2.exports = i.debug = i.default = i).coerce = function(t3) {
          return t3 instanceof Error ? t3.stack || t3.message : t3;
        }, e2.disable = function() {
          e2.enable("");
        }, e2.enable = function(t3) {
          e2.save(t3), e2.names = [], e2.skips = [];
          for (var r3 = ("string" == typeof t3 ? t3 : "").split(/[\s,]+/), n3 = r3.length, i2 = 0; i2 < n3; i2++)
            r3[i2] && ("-" === (t3 = r3[i2].replace(/\*/g, ".*?"))[0] ? e2.skips.push(new RegExp("^" + t3.substr(1) + "$")) : e2.names.push(new RegExp("^" + t3 + "$")));
        }, e2.enabled = function(t3) {
          var r3, n3;
          for (r3 = 0, n3 = e2.skips.length; r3 < n3; r3++)
            if (e2.skips[r3].test(t3))
              return false;
          for (r3 = 0, n3 = e2.names.length; r3 < n3; r3++)
            if (e2.names[r3].test(t3))
              return true;
          return false;
        }, e2.humanize = r2(11375), e2.names = [], e2.skips = [], e2.formatters = {};
      }, 11375: function(t2) {
        var e2 = 1e3, r2 = 60 * e2, n2 = 60 * r2, i = 24 * n2;
        function a(t3, e3, r3) {
          if (!(t3 < e3))
            return t3 < 1.5 * e3 ? Math.floor(t3 / e3) + " " + r3 : Math.ceil(t3 / e3) + " " + r3 + "s";
        }
        t2.exports = function(t3, o) {
          o = o || {};
          var s, l = typeof t3;
          if ("string" === l && t3.length > 0)
            return function(t4) {
              if (!((t4 = String(t4)).length > 100)) {
                var a2 = /^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(t4);
                if (a2) {
                  var o2 = parseFloat(a2[1]);
                  switch ((a2[2] || "ms").toLowerCase()) {
                    case "years":
                    case "year":
                    case "yrs":
                    case "yr":
                    case "y":
                      return 315576e5 * o2;
                    case "days":
                    case "day":
                    case "d":
                      return o2 * i;
                    case "hours":
                    case "hour":
                    case "hrs":
                    case "hr":
                    case "h":
                      return o2 * n2;
                    case "minutes":
                    case "minute":
                    case "mins":
                    case "min":
                    case "m":
                      return o2 * r2;
                    case "seconds":
                    case "second":
                    case "secs":
                    case "sec":
                    case "s":
                      return o2 * e2;
                    case "milliseconds":
                    case "millisecond":
                    case "msecs":
                    case "msec":
                    case "ms":
                      return o2;
                    default:
                      return;
                  }
                }
              }
            }(t3);
          if ("number" === l && false === isNaN(t3))
            return o.long ? a(s = t3, i, "day") || a(s, n2, "hour") || a(s, r2, "minute") || a(s, e2, "second") || s + " ms" : function(t4) {
              return t4 >= i ? Math.round(t4 / i) + "d" : t4 >= n2 ? Math.round(t4 / n2) + "h" : t4 >= r2 ? Math.round(t4 / r2) + "m" : t4 >= e2 ? Math.round(t4 / e2) + "s" : t4 + "ms";
            }(t3);
          throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(t3));
        };
      }, 99011: function(t2, e2, r2) {
        var n2 = r2(88641);
        t2.exports = function(t3, e3, r3) {
          if (null == t3)
            throw Error("First argument should be a string");
          if (null == e3)
            throw Error("Separator should be a string or a RegExp");
          r3 ? ("string" == typeof r3 || Array.isArray(r3)) && (r3 = { ignore: r3 }) : r3 = {}, null == r3.escape && (r3.escape = true), null == r3.ignore ? r3.ignore = ["[]", "()", "{}", "<>", '""', "''", "``", "“”", "«»"] : ("string" == typeof r3.ignore && (r3.ignore = [r3.ignore]), r3.ignore = r3.ignore.map(function(t4) {
            return 1 === t4.length && (t4 += t4), t4;
          }));
          var i = n2.parse(t3, { flat: true, brackets: r3.ignore }), a = i[0].split(e3);
          if (r3.escape) {
            for (var o = [], s = 0; s < a.length; s++) {
              var l = a[s], u = a[s + 1];
              "\\" === l[l.length - 1] && "\\" !== l[l.length - 2] ? (o.push(l + e3 + u), s++) : o.push(l);
            }
            a = o;
          }
          for (s = 0; s < a.length; s++)
            i[0] = a[s], a[s] = n2.stringify(i, { flat: true });
          return a;
        };
      }, 68664: function(t2) {
        t2.exports = function(t3) {
          for (var e2 = t3.length, r2 = new Array(e2), n2 = new Array(e2), i = new Array(e2), a = new Array(e2), o = new Array(e2), s = new Array(e2), l = 0; l < e2; ++l)
            r2[l] = -1, n2[l] = 0, i[l] = false, a[l] = 0, o[l] = -1, s[l] = [];
          var u, c = 0, f2 = [], h = [];
          function p2(e3) {
            var l2 = [e3], u2 = [e3];
            for (r2[e3] = n2[e3] = c, i[e3] = true, c += 1; u2.length > 0; ) {
              e3 = u2[u2.length - 1];
              var p3 = t3[e3];
              if (a[e3] < p3.length) {
                for (var d3 = a[e3]; d3 < p3.length; ++d3) {
                  var v2 = p3[d3];
                  if (r2[v2] < 0) {
                    r2[v2] = n2[v2] = c, i[v2] = true, c += 1, l2.push(v2), u2.push(v2);
                    break;
                  }
                  i[v2] && (n2[e3] = 0 | Math.min(n2[e3], n2[v2])), o[v2] >= 0 && s[e3].push(o[v2]);
                }
                a[e3] = d3;
              } else {
                if (n2[e3] === r2[e3]) {
                  var g2 = [], y = [], m2 = 0;
                  for (d3 = l2.length - 1; d3 >= 0; --d3) {
                    var x = l2[d3];
                    if (i[x] = false, g2.push(x), y.push(s[x]), m2 += s[x].length, o[x] = f2.length, x === e3) {
                      l2.length = d3;
                      break;
                    }
                  }
                  f2.push(g2);
                  var b = new Array(m2);
                  for (d3 = 0; d3 < y.length; d3++)
                    for (var _ = 0; _ < y[d3].length; _++)
                      b[--m2] = y[d3][_];
                  h.push(b);
                }
                u2.pop();
              }
            }
          }
          for (l = 0; l < e2; ++l)
            r2[l] < 0 && p2(l);
          for (l = 0; l < h.length; l++) {
            var d2 = h[l];
            if (0 !== d2.length) {
              d2.sort(function(t4, e3) {
                return t4 - e3;
              }), u = [d2[0]];
              for (var v = 1; v < d2.length; v++)
                d2[v] !== d2[v - 1] && u.push(d2[v]);
              h[l] = u;
            }
          }
          return { components: f2, adjacencyList: h };
        };
      }, 7095: function(t2, e2, r2) {
        r2.r(e2);
        var n2 = 2 * Math.PI, i = function(t3, e3, r3, n3, i2, a2, o2) {
          var s = t3.x, l = t3.y;
          return { x: n3 * (s *= e3) - i2 * (l *= r3) + a2, y: i2 * s + n3 * l + o2 };
        }, a = function(t3, e3) {
          var r3 = 1.5707963267948966 === e3 ? 0.551915024494 : -1.5707963267948966 === e3 ? -0.551915024494 : 4 / 3 * Math.tan(e3 / 4), n3 = Math.cos(t3), i2 = Math.sin(t3), a2 = Math.cos(t3 + e3), o2 = Math.sin(t3 + e3);
          return [{ x: n3 - i2 * r3, y: i2 + n3 * r3 }, { x: a2 + o2 * r3, y: o2 - a2 * r3 }, { x: a2, y: o2 }];
        }, o = function(t3, e3, r3, n3) {
          var i2 = t3 * r3 + e3 * n3;
          return i2 > 1 && (i2 = 1), i2 < -1 && (i2 = -1), (t3 * n3 - e3 * r3 < 0 ? -1 : 1) * Math.acos(i2);
        };
        e2.default = function(t3) {
          var e3 = t3.px, r3 = t3.py, s = t3.cx, l = t3.cy, u = t3.rx, c = t3.ry, f2 = t3.xAxisRotation, h = void 0 === f2 ? 0 : f2, p2 = t3.largeArcFlag, d2 = void 0 === p2 ? 0 : p2, v = t3.sweepFlag, g2 = void 0 === v ? 0 : v, y = [];
          if (0 === u || 0 === c)
            return [];
          var m2 = Math.sin(h * n2 / 360), x = Math.cos(h * n2 / 360), b = x * (e3 - s) / 2 + m2 * (r3 - l) / 2, _ = -m2 * (e3 - s) / 2 + x * (r3 - l) / 2;
          if (0 === b && 0 === _)
            return [];
          u = Math.abs(u), c = Math.abs(c);
          var w2 = Math.pow(b, 2) / Math.pow(u, 2) + Math.pow(_, 2) / Math.pow(c, 2);
          w2 > 1 && (u *= Math.sqrt(w2), c *= Math.sqrt(w2));
          var T = function(t4, e4, r4, i2, a2, s2, l2, u2, c2, f3, h2, p3) {
            var d3 = Math.pow(a2, 2), v2 = Math.pow(s2, 2), g3 = Math.pow(h2, 2), y2 = Math.pow(p3, 2), m3 = d3 * v2 - d3 * y2 - v2 * g3;
            m3 < 0 && (m3 = 0), m3 /= d3 * y2 + v2 * g3;
            var x2 = (m3 = Math.sqrt(m3) * (l2 === u2 ? -1 : 1)) * a2 / s2 * p3, b2 = m3 * -s2 / a2 * h2, _2 = f3 * x2 - c2 * b2 + (t4 + r4) / 2, w3 = c2 * x2 + f3 * b2 + (e4 + i2) / 2, T2 = (h2 - x2) / a2, k2 = (p3 - b2) / s2, A2 = (-h2 - x2) / a2, M2 = (-p3 - b2) / s2, S2 = o(1, 0, T2, k2), E2 = o(T2, k2, A2, M2);
            return 0 === u2 && E2 > 0 && (E2 -= n2), 1 === u2 && E2 < 0 && (E2 += n2), [_2, w3, S2, E2];
          }(e3, r3, s, l, u, c, d2, g2, m2, x, b, _), k = function(t4, e4) {
            if (Array.isArray(t4))
              return t4;
            if (Symbol.iterator in Object(t4))
              return function(t5, e5) {
                var r4 = [], n3 = true, i2 = false, a2 = void 0;
                try {
                  for (var o2, s2 = t5[Symbol.iterator](); !(n3 = (o2 = s2.next()).done) && (r4.push(o2.value), !e5 || r4.length !== e5); n3 = true)
                    ;
                } catch (t6) {
                  i2 = true, a2 = t6;
                } finally {
                  try {
                    !n3 && s2.return && s2.return();
                  } finally {
                    if (i2)
                      throw a2;
                  }
                }
                return r4;
              }(t4, e4);
            throw new TypeError("Invalid attempt to destructure non-iterable instance");
          }(T, 4), A = k[0], M = k[1], S = k[2], E = k[3], L = Math.abs(E) / (n2 / 4);
          Math.abs(1 - L) < 1e-7 && (L = 1);
          var C = Math.max(Math.ceil(L), 1);
          E /= C;
          for (var P = 0; P < C; P++)
            y.push(a(S, E)), S += E;
          return y.map(function(t4) {
            var e4 = i(t4[0], u, c, x, m2, A, M), r4 = e4.x, n3 = e4.y, a2 = i(t4[1], u, c, x, m2, A, M), o2 = a2.x, s2 = a2.y, l2 = i(t4[2], u, c, x, m2, A, M);
            return { x1: r4, y1: n3, x2: o2, y2: s2, x: l2.x, y: l2.y };
          });
        };
      }, 1750: function(t2, e2, r2) {
        var n2 = r2(95616), i = r2(65185), a = r2(29988), o = r2(89546), s = r2(32791);
        t2.exports = function(t3) {
          if (Array.isArray(t3) && 1 === t3.length && "string" == typeof t3[0] && (t3 = t3[0]), "string" == typeof t3 && (s(o(t3), "String is not an SVG path."), t3 = n2(t3)), s(Array.isArray(t3), "Argument should be a string or an array of path segments."), t3 = i(t3), !(t3 = a(t3)).length)
            return [0, 0, 0, 0];
          for (var e3 = [1 / 0, 1 / 0, -1 / 0, -1 / 0], r3 = 0, l = t3.length; r3 < l; r3++)
            for (var u = t3[r3].slice(1), c = 0; c < u.length; c += 2)
              u[c + 0] < e3[0] && (e3[0] = u[c + 0]), u[c + 1] < e3[1] && (e3[1] = u[c + 1]), u[c + 0] > e3[2] && (e3[2] = u[c + 0]), u[c + 1] > e3[3] && (e3[3] = u[c + 1]);
          return e3;
        };
      }, 29988: function(t2, e2, r2) {
        t2.exports = function(t3) {
          for (var e3, r3 = [], o = 0, s = 0, l = 0, u = 0, c = null, f2 = null, h = 0, p2 = 0, d2 = 0, v = t3.length; d2 < v; d2++) {
            var g2 = t3[d2], y = g2[0];
            switch (y) {
              case "M":
                l = g2[1], u = g2[2];
                break;
              case "A":
                var m2 = n2({ px: h, py: p2, cx: g2[6], cy: g2[7], rx: g2[1], ry: g2[2], xAxisRotation: g2[3], largeArcFlag: g2[4], sweepFlag: g2[5] });
                if (!m2.length)
                  continue;
                for (var x, b = 0; b < m2.length; b++)
                  g2 = ["C", (x = m2[b]).x1, x.y1, x.x2, x.y2, x.x, x.y], b < m2.length - 1 && r3.push(g2);
                break;
              case "S":
                var _ = h, w2 = p2;
                "C" != e3 && "S" != e3 || (_ += _ - o, w2 += w2 - s), g2 = ["C", _, w2, g2[1], g2[2], g2[3], g2[4]];
                break;
              case "T":
                "Q" == e3 || "T" == e3 ? (c = 2 * h - c, f2 = 2 * p2 - f2) : (c = h, f2 = p2), g2 = a(h, p2, c, f2, g2[1], g2[2]);
                break;
              case "Q":
                c = g2[1], f2 = g2[2], g2 = a(h, p2, g2[1], g2[2], g2[3], g2[4]);
                break;
              case "L":
                g2 = i(h, p2, g2[1], g2[2]);
                break;
              case "H":
                g2 = i(h, p2, g2[1], p2);
                break;
              case "V":
                g2 = i(h, p2, h, g2[1]);
                break;
              case "Z":
                g2 = i(h, p2, l, u);
            }
            e3 = y, h = g2[g2.length - 2], p2 = g2[g2.length - 1], g2.length > 4 ? (o = g2[g2.length - 4], s = g2[g2.length - 3]) : (o = h, s = p2), r3.push(g2);
          }
          return r3;
        };
        var n2 = r2(7095);
        function i(t3, e3, r3, n3) {
          return ["C", t3, e3, r3, n3, r3, n3];
        }
        function a(t3, e3, r3, n3, i2, a2) {
          return ["C", t3 / 3 + 2 / 3 * r3, e3 / 3 + 2 / 3 * n3, i2 / 3 + 2 / 3 * r3, a2 / 3 + 2 / 3 * n3, i2, a2];
        }
      }, 82019: function(t2, e2, r2) {
        var n2, i = r2(1750), a = r2(95616), o = r2(31457), s = r2(89546), l = r2(44781), u = document.createElement("canvas"), c = u.getContext("2d");
        t2.exports = function(t3, e3) {
          if (!s(t3))
            throw Error("Argument should be valid svg path string");
          var r3, f2;
          e3 || (e3 = {}), e3.shape ? (r3 = e3.shape[0], f2 = e3.shape[1]) : (r3 = u.width = e3.w || e3.width || 200, f2 = u.height = e3.h || e3.height || 200);
          var h = Math.min(r3, f2), p2 = e3.stroke || 0, d2 = e3.viewbox || e3.viewBox || i(t3), v = [r3 / (d2[2] - d2[0]), f2 / (d2[3] - d2[1])], g2 = Math.min(v[0] || 0, v[1] || 0) / 2;
          if (c.fillStyle = "black", c.fillRect(0, 0, r3, f2), c.fillStyle = "white", p2 && ("number" != typeof p2 && (p2 = 1), c.strokeStyle = p2 > 0 ? "white" : "black", c.lineWidth = Math.abs(p2)), c.translate(0.5 * r3, 0.5 * f2), c.scale(g2, g2), function() {
            if (null != n2)
              return n2;
            var t4 = document.createElement("canvas").getContext("2d");
            if (t4.canvas.width = t4.canvas.height = 1, !window.Path2D)
              return n2 = false;
            var e4 = new Path2D("M0,0h1v1h-1v-1Z");
            t4.fillStyle = "black", t4.fill(e4);
            var r4 = t4.getImageData(0, 0, 1, 1);
            return n2 = r4 && r4.data && 255 === r4.data[3];
          }()) {
            var y = new Path2D(t3);
            c.fill(y), p2 && c.stroke(y);
          } else {
            var m2 = a(t3);
            o(c, m2), c.fill(), p2 && c.stroke();
          }
          return c.setTransform(1, 0, 0, 1, 0, 0), l(c, { cutoff: null != e3.cutoff ? e3.cutoff : 0.5, radius: null != e3.radius ? e3.radius : 0.5 * h });
        };
      }, 84267: function(t2, e2, r2) {
        var n2;
        !function(i) {
          var a = /^\s+/, o = /\s+$/, s = 0, l = i.round, u = i.min, c = i.max, f2 = i.random;
          function h(t3, e3) {
            if (e3 = e3 || {}, (t3 = t3 || "") instanceof h)
              return t3;
            if (!(this instanceof h))
              return new h(t3, e3);
            var r3 = function(t4) {
              var e4, r4, n3, s2 = { r: 0, g: 0, b: 0 }, l2 = 1, f3 = null, h2 = null, p3 = null, d3 = false, v2 = false;
              return "string" == typeof t4 && (t4 = function(t5) {
                t5 = t5.replace(a, "").replace(o, "").toLowerCase();
                var e5, r5 = false;
                if (C[t5])
                  t5 = C[t5], r5 = true;
                else if ("transparent" == t5)
                  return { r: 0, g: 0, b: 0, a: 0, format: "name" };
                return (e5 = H.rgb.exec(t5)) ? { r: e5[1], g: e5[2], b: e5[3] } : (e5 = H.rgba.exec(t5)) ? { r: e5[1], g: e5[2], b: e5[3], a: e5[4] } : (e5 = H.hsl.exec(t5)) ? { h: e5[1], s: e5[2], l: e5[3] } : (e5 = H.hsla.exec(t5)) ? { h: e5[1], s: e5[2], l: e5[3], a: e5[4] } : (e5 = H.hsv.exec(t5)) ? { h: e5[1], s: e5[2], v: e5[3] } : (e5 = H.hsva.exec(t5)) ? { h: e5[1], s: e5[2], v: e5[3], a: e5[4] } : (e5 = H.hex8.exec(t5)) ? { r: z(e5[1]), g: z(e5[2]), b: z(e5[3]), a: N(e5[4]), format: r5 ? "name" : "hex8" } : (e5 = H.hex6.exec(t5)) ? { r: z(e5[1]), g: z(e5[2]), b: z(e5[3]), format: r5 ? "name" : "hex" } : (e5 = H.hex4.exec(t5)) ? { r: z(e5[1] + "" + e5[1]), g: z(e5[2] + "" + e5[2]), b: z(e5[3] + "" + e5[3]), a: N(e5[4] + "" + e5[4]), format: r5 ? "name" : "hex8" } : !!(e5 = H.hex3.exec(t5)) && { r: z(e5[1] + "" + e5[1]), g: z(e5[2] + "" + e5[2]), b: z(e5[3] + "" + e5[3]), format: r5 ? "name" : "hex" };
              }(t4)), "object" == typeof t4 && (q2(t4.r) && q2(t4.g) && q2(t4.b) ? (e4 = t4.r, r4 = t4.g, n3 = t4.b, s2 = { r: 255 * I(e4, 255), g: 255 * I(r4, 255), b: 255 * I(n3, 255) }, d3 = true, v2 = "%" === String(t4.r).substr(-1) ? "prgb" : "rgb") : q2(t4.h) && q2(t4.s) && q2(t4.v) ? (f3 = F(t4.s), h2 = F(t4.v), s2 = function(t5, e5, r5) {
                t5 = 6 * I(t5, 360), e5 = I(e5, 100), r5 = I(r5, 100);
                var n4 = i.floor(t5), a2 = t5 - n4, o2 = r5 * (1 - e5), s3 = r5 * (1 - a2 * e5), l3 = r5 * (1 - (1 - a2) * e5), u2 = n4 % 6;
                return { r: 255 * [r5, s3, o2, o2, l3, r5][u2], g: 255 * [l3, r5, r5, s3, o2, o2][u2], b: 255 * [o2, o2, l3, r5, r5, s3][u2] };
              }(t4.h, f3, h2), d3 = true, v2 = "hsv") : q2(t4.h) && q2(t4.s) && q2(t4.l) && (f3 = F(t4.s), p3 = F(t4.l), s2 = function(t5, e5, r5) {
                var n4, i2, a2;
                function o2(t6, e6, r6) {
                  return r6 < 0 && (r6 += 1), r6 > 1 && (r6 -= 1), r6 < 1 / 6 ? t6 + 6 * (e6 - t6) * r6 : r6 < 0.5 ? e6 : r6 < 2 / 3 ? t6 + (e6 - t6) * (2 / 3 - r6) * 6 : t6;
                }
                if (t5 = I(t5, 360), e5 = I(e5, 100), r5 = I(r5, 100), 0 === e5)
                  n4 = i2 = a2 = r5;
                else {
                  var s3 = r5 < 0.5 ? r5 * (1 + e5) : r5 + e5 - r5 * e5, l3 = 2 * r5 - s3;
                  n4 = o2(l3, s3, t5 + 1 / 3), i2 = o2(l3, s3, t5), a2 = o2(l3, s3, t5 - 1 / 3);
                }
                return { r: 255 * n4, g: 255 * i2, b: 255 * a2 };
              }(t4.h, f3, p3), d3 = true, v2 = "hsl"), t4.hasOwnProperty("a") && (l2 = t4.a)), l2 = O(l2), { ok: d3, format: t4.format || v2, r: u(255, c(s2.r, 0)), g: u(255, c(s2.g, 0)), b: u(255, c(s2.b, 0)), a: l2 };
            }(t3);
            this._originalInput = t3, this._r = r3.r, this._g = r3.g, this._b = r3.b, this._a = r3.a, this._roundA = l(100 * this._a) / 100, this._format = e3.format || r3.format, this._gradientType = e3.gradientType, this._r < 1 && (this._r = l(this._r)), this._g < 1 && (this._g = l(this._g)), this._b < 1 && (this._b = l(this._b)), this._ok = r3.ok, this._tc_id = s++;
          }
          function p2(t3, e3, r3) {
            t3 = I(t3, 255), e3 = I(e3, 255), r3 = I(r3, 255);
            var n3, i2, a2 = c(t3, e3, r3), o2 = u(t3, e3, r3), s2 = (a2 + o2) / 2;
            if (a2 == o2)
              n3 = i2 = 0;
            else {
              var l2 = a2 - o2;
              switch (i2 = s2 > 0.5 ? l2 / (2 - a2 - o2) : l2 / (a2 + o2), a2) {
                case t3:
                  n3 = (e3 - r3) / l2 + (e3 < r3 ? 6 : 0);
                  break;
                case e3:
                  n3 = (r3 - t3) / l2 + 2;
                  break;
                case r3:
                  n3 = (t3 - e3) / l2 + 4;
              }
              n3 /= 6;
            }
            return { h: n3, s: i2, l: s2 };
          }
          function d2(t3, e3, r3) {
            t3 = I(t3, 255), e3 = I(e3, 255), r3 = I(r3, 255);
            var n3, i2, a2 = c(t3, e3, r3), o2 = u(t3, e3, r3), s2 = a2, l2 = a2 - o2;
            if (i2 = 0 === a2 ? 0 : l2 / a2, a2 == o2)
              n3 = 0;
            else {
              switch (a2) {
                case t3:
                  n3 = (e3 - r3) / l2 + (e3 < r3 ? 6 : 0);
                  break;
                case e3:
                  n3 = (r3 - t3) / l2 + 2;
                  break;
                case r3:
                  n3 = (t3 - e3) / l2 + 4;
              }
              n3 /= 6;
            }
            return { h: n3, s: i2, v: s2 };
          }
          function v(t3, e3, r3, n3) {
            var i2 = [R(l(t3).toString(16)), R(l(e3).toString(16)), R(l(r3).toString(16))];
            return n3 && i2[0].charAt(0) == i2[0].charAt(1) && i2[1].charAt(0) == i2[1].charAt(1) && i2[2].charAt(0) == i2[2].charAt(1) ? i2[0].charAt(0) + i2[1].charAt(0) + i2[2].charAt(0) : i2.join("");
          }
          function g2(t3, e3, r3, n3) {
            return [R(B(n3)), R(l(t3).toString(16)), R(l(e3).toString(16)), R(l(r3).toString(16))].join("");
          }
          function y(t3, e3) {
            e3 = 0 === e3 ? 0 : e3 || 10;
            var r3 = h(t3).toHsl();
            return r3.s -= e3 / 100, r3.s = D(r3.s), h(r3);
          }
          function m2(t3, e3) {
            e3 = 0 === e3 ? 0 : e3 || 10;
            var r3 = h(t3).toHsl();
            return r3.s += e3 / 100, r3.s = D(r3.s), h(r3);
          }
          function x(t3) {
            return h(t3).desaturate(100);
          }
          function b(t3, e3) {
            e3 = 0 === e3 ? 0 : e3 || 10;
            var r3 = h(t3).toHsl();
            return r3.l += e3 / 100, r3.l = D(r3.l), h(r3);
          }
          function _(t3, e3) {
            e3 = 0 === e3 ? 0 : e3 || 10;
            var r3 = h(t3).toRgb();
            return r3.r = c(0, u(255, r3.r - l(-e3 / 100 * 255))), r3.g = c(0, u(255, r3.g - l(-e3 / 100 * 255))), r3.b = c(0, u(255, r3.b - l(-e3 / 100 * 255))), h(r3);
          }
          function w2(t3, e3) {
            e3 = 0 === e3 ? 0 : e3 || 10;
            var r3 = h(t3).toHsl();
            return r3.l -= e3 / 100, r3.l = D(r3.l), h(r3);
          }
          function T(t3, e3) {
            var r3 = h(t3).toHsl(), n3 = (r3.h + e3) % 360;
            return r3.h = n3 < 0 ? 360 + n3 : n3, h(r3);
          }
          function k(t3) {
            var e3 = h(t3).toHsl();
            return e3.h = (e3.h + 180) % 360, h(e3);
          }
          function A(t3) {
            var e3 = h(t3).toHsl(), r3 = e3.h;
            return [h(t3), h({ h: (r3 + 120) % 360, s: e3.s, l: e3.l }), h({ h: (r3 + 240) % 360, s: e3.s, l: e3.l })];
          }
          function M(t3) {
            var e3 = h(t3).toHsl(), r3 = e3.h;
            return [h(t3), h({ h: (r3 + 90) % 360, s: e3.s, l: e3.l }), h({ h: (r3 + 180) % 360, s: e3.s, l: e3.l }), h({ h: (r3 + 270) % 360, s: e3.s, l: e3.l })];
          }
          function S(t3) {
            var e3 = h(t3).toHsl(), r3 = e3.h;
            return [h(t3), h({ h: (r3 + 72) % 360, s: e3.s, l: e3.l }), h({ h: (r3 + 216) % 360, s: e3.s, l: e3.l })];
          }
          function E(t3, e3, r3) {
            e3 = e3 || 6, r3 = r3 || 30;
            var n3 = h(t3).toHsl(), i2 = 360 / r3, a2 = [h(t3)];
            for (n3.h = (n3.h - (i2 * e3 >> 1) + 720) % 360; --e3; )
              n3.h = (n3.h + i2) % 360, a2.push(h(n3));
            return a2;
          }
          function L(t3, e3) {
            e3 = e3 || 6;
            for (var r3 = h(t3).toHsv(), n3 = r3.h, i2 = r3.s, a2 = r3.v, o2 = [], s2 = 1 / e3; e3--; )
              o2.push(h({ h: n3, s: i2, v: a2 })), a2 = (a2 + s2) % 1;
            return o2;
          }
          h.prototype = { isDark: function() {
            return this.getBrightness() < 128;
          }, isLight: function() {
            return !this.isDark();
          }, isValid: function() {
            return this._ok;
          }, getOriginalInput: function() {
            return this._originalInput;
          }, getFormat: function() {
            return this._format;
          }, getAlpha: function() {
            return this._a;
          }, getBrightness: function() {
            var t3 = this.toRgb();
            return (299 * t3.r + 587 * t3.g + 114 * t3.b) / 1e3;
          }, getLuminance: function() {
            var t3, e3, r3, n3 = this.toRgb();
            return t3 = n3.r / 255, e3 = n3.g / 255, r3 = n3.b / 255, 0.2126 * (t3 <= 0.03928 ? t3 / 12.92 : i.pow((t3 + 0.055) / 1.055, 2.4)) + 0.7152 * (e3 <= 0.03928 ? e3 / 12.92 : i.pow((e3 + 0.055) / 1.055, 2.4)) + 0.0722 * (r3 <= 0.03928 ? r3 / 12.92 : i.pow((r3 + 0.055) / 1.055, 2.4));
          }, setAlpha: function(t3) {
            return this._a = O(t3), this._roundA = l(100 * this._a) / 100, this;
          }, toHsv: function() {
            var t3 = d2(this._r, this._g, this._b);
            return { h: 360 * t3.h, s: t3.s, v: t3.v, a: this._a };
          }, toHsvString: function() {
            var t3 = d2(this._r, this._g, this._b), e3 = l(360 * t3.h), r3 = l(100 * t3.s), n3 = l(100 * t3.v);
            return 1 == this._a ? "hsv(" + e3 + ", " + r3 + "%, " + n3 + "%)" : "hsva(" + e3 + ", " + r3 + "%, " + n3 + "%, " + this._roundA + ")";
          }, toHsl: function() {
            var t3 = p2(this._r, this._g, this._b);
            return { h: 360 * t3.h, s: t3.s, l: t3.l, a: this._a };
          }, toHslString: function() {
            var t3 = p2(this._r, this._g, this._b), e3 = l(360 * t3.h), r3 = l(100 * t3.s), n3 = l(100 * t3.l);
            return 1 == this._a ? "hsl(" + e3 + ", " + r3 + "%, " + n3 + "%)" : "hsla(" + e3 + ", " + r3 + "%, " + n3 + "%, " + this._roundA + ")";
          }, toHex: function(t3) {
            return v(this._r, this._g, this._b, t3);
          }, toHexString: function(t3) {
            return "#" + this.toHex(t3);
          }, toHex8: function(t3) {
            return function(t4, e3, r3, n3, i2) {
              var a2 = [R(l(t4).toString(16)), R(l(e3).toString(16)), R(l(r3).toString(16)), R(B(n3))];
              return i2 && a2[0].charAt(0) == a2[0].charAt(1) && a2[1].charAt(0) == a2[1].charAt(1) && a2[2].charAt(0) == a2[2].charAt(1) && a2[3].charAt(0) == a2[3].charAt(1) ? a2[0].charAt(0) + a2[1].charAt(0) + a2[2].charAt(0) + a2[3].charAt(0) : a2.join("");
            }(this._r, this._g, this._b, this._a, t3);
          }, toHex8String: function(t3) {
            return "#" + this.toHex8(t3);
          }, toRgb: function() {
            return { r: l(this._r), g: l(this._g), b: l(this._b), a: this._a };
          }, toRgbString: function() {
            return 1 == this._a ? "rgb(" + l(this._r) + ", " + l(this._g) + ", " + l(this._b) + ")" : "rgba(" + l(this._r) + ", " + l(this._g) + ", " + l(this._b) + ", " + this._roundA + ")";
          }, toPercentageRgb: function() {
            return { r: l(100 * I(this._r, 255)) + "%", g: l(100 * I(this._g, 255)) + "%", b: l(100 * I(this._b, 255)) + "%", a: this._a };
          }, toPercentageRgbString: function() {
            return 1 == this._a ? "rgb(" + l(100 * I(this._r, 255)) + "%, " + l(100 * I(this._g, 255)) + "%, " + l(100 * I(this._b, 255)) + "%)" : "rgba(" + l(100 * I(this._r, 255)) + "%, " + l(100 * I(this._g, 255)) + "%, " + l(100 * I(this._b, 255)) + "%, " + this._roundA + ")";
          }, toName: function() {
            return 0 === this._a ? "transparent" : !(this._a < 1) && (P[v(this._r, this._g, this._b, true)] || false);
          }, toFilter: function(t3) {
            var e3 = "#" + g2(this._r, this._g, this._b, this._a), r3 = e3, n3 = this._gradientType ? "GradientType = 1, " : "";
            if (t3) {
              var i2 = h(t3);
              r3 = "#" + g2(i2._r, i2._g, i2._b, i2._a);
            }
            return "progid:DXImageTransform.Microsoft.gradient(" + n3 + "startColorstr=" + e3 + ",endColorstr=" + r3 + ")";
          }, toString: function(t3) {
            var e3 = !!t3;
            t3 = t3 || this._format;
            var r3 = false, n3 = this._a < 1 && this._a >= 0;
            return e3 || !n3 || "hex" !== t3 && "hex6" !== t3 && "hex3" !== t3 && "hex4" !== t3 && "hex8" !== t3 && "name" !== t3 ? ("rgb" === t3 && (r3 = this.toRgbString()), "prgb" === t3 && (r3 = this.toPercentageRgbString()), "hex" !== t3 && "hex6" !== t3 || (r3 = this.toHexString()), "hex3" === t3 && (r3 = this.toHexString(true)), "hex4" === t3 && (r3 = this.toHex8String(true)), "hex8" === t3 && (r3 = this.toHex8String()), "name" === t3 && (r3 = this.toName()), "hsl" === t3 && (r3 = this.toHslString()), "hsv" === t3 && (r3 = this.toHsvString()), r3 || this.toHexString()) : "name" === t3 && 0 === this._a ? this.toName() : this.toRgbString();
          }, clone: function() {
            return h(this.toString());
          }, _applyModification: function(t3, e3) {
            var r3 = t3.apply(null, [this].concat([].slice.call(e3)));
            return this._r = r3._r, this._g = r3._g, this._b = r3._b, this.setAlpha(r3._a), this;
          }, lighten: function() {
            return this._applyModification(b, arguments);
          }, brighten: function() {
            return this._applyModification(_, arguments);
          }, darken: function() {
            return this._applyModification(w2, arguments);
          }, desaturate: function() {
            return this._applyModification(y, arguments);
          }, saturate: function() {
            return this._applyModification(m2, arguments);
          }, greyscale: function() {
            return this._applyModification(x, arguments);
          }, spin: function() {
            return this._applyModification(T, arguments);
          }, _applyCombination: function(t3, e3) {
            return t3.apply(null, [this].concat([].slice.call(e3)));
          }, analogous: function() {
            return this._applyCombination(E, arguments);
          }, complement: function() {
            return this._applyCombination(k, arguments);
          }, monochromatic: function() {
            return this._applyCombination(L, arguments);
          }, splitcomplement: function() {
            return this._applyCombination(S, arguments);
          }, triad: function() {
            return this._applyCombination(A, arguments);
          }, tetrad: function() {
            return this._applyCombination(M, arguments);
          } }, h.fromRatio = function(t3, e3) {
            if ("object" == typeof t3) {
              var r3 = {};
              for (var n3 in t3)
                t3.hasOwnProperty(n3) && (r3[n3] = "a" === n3 ? t3[n3] : F(t3[n3]));
              t3 = r3;
            }
            return h(t3, e3);
          }, h.equals = function(t3, e3) {
            return !(!t3 || !e3) && h(t3).toRgbString() == h(e3).toRgbString();
          }, h.random = function() {
            return h.fromRatio({ r: f2(), g: f2(), b: f2() });
          }, h.mix = function(t3, e3, r3) {
            r3 = 0 === r3 ? 0 : r3 || 50;
            var n3 = h(t3).toRgb(), i2 = h(e3).toRgb(), a2 = r3 / 100;
            return h({ r: (i2.r - n3.r) * a2 + n3.r, g: (i2.g - n3.g) * a2 + n3.g, b: (i2.b - n3.b) * a2 + n3.b, a: (i2.a - n3.a) * a2 + n3.a });
          }, h.readability = function(t3, e3) {
            var r3 = h(t3), n3 = h(e3);
            return (i.max(r3.getLuminance(), n3.getLuminance()) + 0.05) / (i.min(r3.getLuminance(), n3.getLuminance()) + 0.05);
          }, h.isReadable = function(t3, e3, r3) {
            var n3, i2, a2, o2, s2, l2 = h.readability(t3, e3);
            switch (i2 = false, (a2 = r3, "AA" !== (o2 = ((a2 = a2 || { level: "AA", size: "small" }).level || "AA").toUpperCase()) && "AAA" !== o2 && (o2 = "AA"), "small" !== (s2 = (a2.size || "small").toLowerCase()) && "large" !== s2 && (s2 = "small"), n3 = { level: o2, size: s2 }).level + n3.size) {
              case "AAsmall":
              case "AAAlarge":
                i2 = l2 >= 4.5;
                break;
              case "AAlarge":
                i2 = l2 >= 3;
                break;
              case "AAAsmall":
                i2 = l2 >= 7;
            }
            return i2;
          }, h.mostReadable = function(t3, e3, r3) {
            var n3, i2, a2, o2, s2 = null, l2 = 0;
            i2 = (r3 = r3 || {}).includeFallbackColors, a2 = r3.level, o2 = r3.size;
            for (var u2 = 0; u2 < e3.length; u2++)
              (n3 = h.readability(t3, e3[u2])) > l2 && (l2 = n3, s2 = h(e3[u2]));
            return h.isReadable(t3, s2, { level: a2, size: o2 }) || !i2 ? s2 : (r3.includeFallbackColors = false, h.mostReadable(t3, ["#fff", "#000"], r3));
          };
          var C = h.names = { aliceblue: "f0f8ff", antiquewhite: "faebd7", aqua: "0ff", aquamarine: "7fffd4", azure: "f0ffff", beige: "f5f5dc", bisque: "ffe4c4", black: "000", blanchedalmond: "ffebcd", blue: "00f", blueviolet: "8a2be2", brown: "a52a2a", burlywood: "deb887", burntsienna: "ea7e5d", cadetblue: "5f9ea0", chartreuse: "7fff00", chocolate: "d2691e", coral: "ff7f50", cornflowerblue: "6495ed", cornsilk: "fff8dc", crimson: "dc143c", cyan: "0ff", darkblue: "00008b", darkcyan: "008b8b", darkgoldenrod: "b8860b", darkgray: "a9a9a9", darkgreen: "006400", darkgrey: "a9a9a9", darkkhaki: "bdb76b", darkmagenta: "8b008b", darkolivegreen: "556b2f", darkorange: "ff8c00", darkorchid: "9932cc", darkred: "8b0000", darksalmon: "e9967a", darkseagreen: "8fbc8f", darkslateblue: "483d8b", darkslategray: "2f4f4f", darkslategrey: "2f4f4f", darkturquoise: "00ced1", darkviolet: "9400d3", deeppink: "ff1493", deepskyblue: "00bfff", dimgray: "696969", dimgrey: "696969", dodgerblue: "1e90ff", firebrick: "b22222", floralwhite: "fffaf0", forestgreen: "228b22", fuchsia: "f0f", gainsboro: "dcdcdc", ghostwhite: "f8f8ff", gold: "ffd700", goldenrod: "daa520", gray: "808080", green: "008000", greenyellow: "adff2f", grey: "808080", honeydew: "f0fff0", hotpink: "ff69b4", indianred: "cd5c5c", indigo: "4b0082", ivory: "fffff0", khaki: "f0e68c", lavender: "e6e6fa", lavenderblush: "fff0f5", lawngreen: "7cfc00", lemonchiffon: "fffacd", lightblue: "add8e6", lightcoral: "f08080", lightcyan: "e0ffff", lightgoldenrodyellow: "fafad2", lightgray: "d3d3d3", lightgreen: "90ee90", lightgrey: "d3d3d3", lightpink: "ffb6c1", lightsalmon: "ffa07a", lightseagreen: "20b2aa", lightskyblue: "87cefa", lightslategray: "789", lightslategrey: "789", lightsteelblue: "b0c4de", lightyellow: "ffffe0", lime: "0f0", limegreen: "32cd32", linen: "faf0e6", magenta: "f0f", maroon: "800000", mediumaquamarine: "66cdaa", mediumblue: "0000cd", mediumorchid: "ba55d3", mediumpurple: "9370db", mediumseagreen: "3cb371", mediumslateblue: "7b68ee", mediumspringgreen: "00fa9a", mediumturquoise: "48d1cc", mediumvioletred: "c71585", midnightblue: "191970", mintcream: "f5fffa", mistyrose: "ffe4e1", moccasin: "ffe4b5", navajowhite: "ffdead", navy: "000080", oldlace: "fdf5e6", olive: "808000", olivedrab: "6b8e23", orange: "ffa500", orangered: "ff4500", orchid: "da70d6", palegoldenrod: "eee8aa", palegreen: "98fb98", paleturquoise: "afeeee", palevioletred: "db7093", papayawhip: "ffefd5", peachpuff: "ffdab9", peru: "cd853f", pink: "ffc0cb", plum: "dda0dd", powderblue: "b0e0e6", purple: "800080", rebeccapurple: "663399", red: "f00", rosybrown: "bc8f8f", royalblue: "4169e1", saddlebrown: "8b4513", salmon: "fa8072", sandybrown: "f4a460", seagreen: "2e8b57", seashell: "fff5ee", sienna: "a0522d", silver: "c0c0c0", skyblue: "87ceeb", slateblue: "6a5acd", slategray: "708090", slategrey: "708090", snow: "fffafa", springgreen: "00ff7f", steelblue: "4682b4", tan: "d2b48c", teal: "008080", thistle: "d8bfd8", tomato: "ff6347", turquoise: "40e0d0", violet: "ee82ee", wheat: "f5deb3", white: "fff", whitesmoke: "f5f5f5", yellow: "ff0", yellowgreen: "9acd32" }, P = h.hexNames = function(t3) {
            var e3 = {};
            for (var r3 in t3)
              t3.hasOwnProperty(r3) && (e3[t3[r3]] = r3);
            return e3;
          }(C);
          function O(t3) {
            return t3 = parseFloat(t3), (isNaN(t3) || t3 < 0 || t3 > 1) && (t3 = 1), t3;
          }
          function I(t3, e3) {
            (function(t4) {
              return "string" == typeof t4 && -1 != t4.indexOf(".") && 1 === parseFloat(t4);
            })(t3) && (t3 = "100%");
            var r3 = function(t4) {
              return "string" == typeof t4 && -1 != t4.indexOf("%");
            }(t3);
            return t3 = u(e3, c(0, parseFloat(t3))), r3 && (t3 = parseInt(t3 * e3, 10) / 100), i.abs(t3 - e3) < 1e-6 ? 1 : t3 % e3 / parseFloat(e3);
          }
          function D(t3) {
            return u(1, c(0, t3));
          }
          function z(t3) {
            return parseInt(t3, 16);
          }
          function R(t3) {
            return 1 == t3.length ? "0" + t3 : "" + t3;
          }
          function F(t3) {
            return t3 <= 1 && (t3 = 100 * t3 + "%"), t3;
          }
          function B(t3) {
            return i.round(255 * parseFloat(t3)).toString(16);
          }
          function N(t3) {
            return z(t3) / 255;
          }
          var j, U, V, H = (U = "[\\s|\\(]+(" + (j = "(?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?)") + ")[,|\\s]+(" + j + ")[,|\\s]+(" + j + ")\\s*\\)?", V = "[\\s|\\(]+(" + j + ")[,|\\s]+(" + j + ")[,|\\s]+(" + j + ")[,|\\s]+(" + j + ")\\s*\\)?", { CSS_UNIT: new RegExp(j), rgb: new RegExp("rgb" + U), rgba: new RegExp("rgba" + V), hsl: new RegExp("hsl" + U), hsla: new RegExp("hsla" + V), hsv: new RegExp("hsv" + U), hsva: new RegExp("hsva" + V), hex3: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex6: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/, hex4: /^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/, hex8: /^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/ });
          function q2(t3) {
            return !!H.CSS_UNIT.exec(t3);
          }
          t2.exports ? t2.exports = h : void 0 === (n2 = function() {
            return h;
          }.call(e2, r2, e2, t2)) || (t2.exports = n2);
        }(Math);
      }, 57060: function(t2) {
        t2.exports = r2, t2.exports.float32 = t2.exports.float = r2, t2.exports.fract32 = t2.exports.fract = function(t3, e3) {
          if (t3.length) {
            if (t3 instanceof Float32Array)
              return new Float32Array(t3.length);
            e3 instanceof Float32Array || (e3 = r2(t3));
            for (var n2 = 0, i = e3.length; n2 < i; n2++)
              e3[n2] = t3[n2] - e3[n2];
            return e3;
          }
          return r2(t3 - r2(t3));
        };
        var e2 = new Float32Array(1);
        function r2(t3) {
          return t3.length ? t3 instanceof Float32Array ? t3 : new Float32Array(t3) : (e2[0] = t3, e2[0]);
        }
      }, 75686: function(t2, e2, r2) {
        var n2 = r2(25677);
        function i(t3, e3) {
          var r3 = n2(getComputedStyle(t3).getPropertyValue(e3));
          return r3[0] * a(r3[1], t3);
        }
        function a(t3, e3) {
          switch (e3 = e3 || document.body, t3 = (t3 || "px").trim().toLowerCase(), e3 !== window && e3 !== document || (e3 = document.body), t3) {
            case "%":
              return e3.clientHeight / 100;
            case "ch":
            case "ex":
              return function(t4, e4) {
                var r3 = document.createElement("div");
                r3.style["font-size"] = "128" + t4, e4.appendChild(r3);
                var n3 = i(r3, "font-size") / 128;
                return e4.removeChild(r3), n3;
              }(t3, e3);
            case "em":
              return i(e3, "font-size");
            case "rem":
              return i(document.body, "font-size");
            case "vw":
              return window.innerWidth / 100;
            case "vh":
              return window.innerHeight / 100;
            case "vmin":
              return Math.min(window.innerWidth, window.innerHeight) / 100;
            case "vmax":
              return Math.max(window.innerWidth, window.innerHeight) / 100;
            case "in":
              return 96;
            case "cm":
              return 96 / 2.54;
            case "mm":
              return 96 / 25.4;
            case "pt":
              return 96 / 72;
            case "pc":
              return 16;
          }
          return 1;
        }
        t2.exports = a;
      }, 96892: function(t2, e2, r2) {
        function n2(t3) {
          return t3;
        }
        function i(t3, e3) {
          return "string" == typeof e3 && (e3 = t3.objects[e3]), "GeometryCollection" === e3.type ? { type: "FeatureCollection", features: e3.geometries.map(function(e4) {
            return a(t3, e4);
          }) } : a(t3, e3);
        }
        function a(t3, e3) {
          var r3 = e3.id, i2 = e3.bbox, a2 = null == e3.properties ? {} : e3.properties, o = function(t4, e4) {
            var r4 = function(t5) {
              if (null == t5)
                return n2;
              var e5, r5, i4 = t5.scale[0], a4 = t5.scale[1], o3 = t5.translate[0], s2 = t5.translate[1];
              return function(t6, n3) {
                n3 || (e5 = r5 = 0);
                var l2 = 2, u2 = t6.length, c = new Array(u2);
                for (c[0] = (e5 += t6[0]) * i4 + o3, c[1] = (r5 += t6[1]) * a4 + s2; l2 < u2; )
                  c[l2] = t6[l2], ++l2;
                return c;
              };
            }(t4.transform), i3 = t4.arcs;
            function a3(t5, e5) {
              e5.length && e5.pop();
              for (var n3 = i3[t5 < 0 ? ~t5 : t5], a4 = 0, o3 = n3.length; a4 < o3; ++a4)
                e5.push(r4(n3[a4], a4));
              t5 < 0 && function(t6, e6) {
                for (var r5, n4 = t6.length, i4 = n4 - e6; i4 < --n4; )
                  r5 = t6[i4], t6[i4++] = t6[n4], t6[n4] = r5;
              }(e5, o3);
            }
            function o2(t5) {
              return r4(t5);
            }
            function s(t5) {
              for (var e5 = [], r5 = 0, n3 = t5.length; r5 < n3; ++r5)
                a3(t5[r5], e5);
              return e5.length < 2 && e5.push(e5[0]), e5;
            }
            function l(t5) {
              for (var e5 = s(t5); e5.length < 4; )
                e5.push(e5[0]);
              return e5;
            }
            function u(t5) {
              return t5.map(l);
            }
            return function t5(e5) {
              var r5, n3 = e5.type;
              switch (n3) {
                case "GeometryCollection":
                  return { type: n3, geometries: e5.geometries.map(t5) };
                case "Point":
                  r5 = o2(e5.coordinates);
                  break;
                case "MultiPoint":
                  r5 = e5.coordinates.map(o2);
                  break;
                case "LineString":
                  r5 = s(e5.arcs);
                  break;
                case "MultiLineString":
                  r5 = e5.arcs.map(s);
                  break;
                case "Polygon":
                  r5 = u(e5.arcs);
                  break;
                case "MultiPolygon":
                  r5 = e5.arcs.map(u);
                  break;
                default:
                  return null;
              }
              return { type: n3, coordinates: r5 };
            }(e4);
          }(t3, e3);
          return null == r3 && null == i2 ? { type: "Feature", properties: a2, geometry: o } : null == i2 ? { type: "Feature", id: r3, properties: a2, geometry: o } : { type: "Feature", id: r3, bbox: i2, properties: a2, geometry: o };
        }
        r2.d(e2, { zL: function() {
          return i;
        } });
      }, 73116: function(t2, e2, r2) {
        var n2 = r2(24511);
        t2.exports = function(t3) {
          if ("function" != typeof t3)
            return false;
          if (!hasOwnProperty.call(t3, "length"))
            return false;
          try {
            if ("number" != typeof t3.length)
              return false;
            if ("function" != typeof t3.call)
              return false;
            if ("function" != typeof t3.apply)
              return false;
          } catch (t4) {
            return false;
          }
          return !n2(t3);
        };
      }, 69190: function(t2, e2, r2) {
        var n2 = r2(24582), i = r2(47403), a = r2(9234), o = r2(6048), s = function(t3, e3) {
          return t3.replace("%v", o(e3));
        };
        t2.exports = function(t3, e3, r3) {
          if (!i(r3))
            throw new TypeError(s(e3, t3));
          if (!n2(t3)) {
            if ("default" in r3)
              return r3.default;
            if (r3.isOptional)
              return null;
          }
          var o2 = a(r3.errorMessage);
          throw n2(o2) || (o2 = e3), new TypeError(s(o2, t3));
        };
      }, 18497: function(t2) {
        t2.exports = function(t3) {
          try {
            return t3.toString();
          } catch (e2) {
            try {
              return String(t3);
            } catch (t4) {
              return null;
            }
          }
        };
      }, 6048: function(t2, e2, r2) {
        var n2 = r2(18497), i = /[\n\r\u2028\u2029]/g;
        t2.exports = function(t3) {
          var e3 = n2(t3);
          return null === e3 ? "<Non-coercible to string value>" : (e3.length > 100 && (e3 = e3.slice(0, 99) + "…"), e3 = e3.replace(i, function(t4) {
            switch (t4) {
              case "\n":
                return "\\n";
              case "\r":
                return "\\r";
              case "\u2028":
                return "\\u2028";
              case "\u2029":
                return "\\u2029";
              default:
                throw new Error("Unexpected character");
            }
          }));
        };
      }, 47403: function(t2, e2, r2) {
        var n2 = r2(24582), i = { object: true, function: true, undefined: true };
        t2.exports = function(t3) {
          return !!n2(t3) && hasOwnProperty.call(i, typeof t3);
        };
      }, 82527: function(t2, e2, r2) {
        var n2 = r2(69190), i = r2(84985);
        t2.exports = function(t3) {
          return i(t3) ? t3 : n2(t3, "%v is not a plain function", arguments[1]);
        };
      }, 84985: function(t2, e2, r2) {
        var n2 = r2(73116), i = /^\s*class[\s{/}]/, a = Function.prototype.toString;
        t2.exports = function(t3) {
          return !!n2(t3) && !i.test(a.call(t3));
        };
      }, 24511: function(t2, e2, r2) {
        var n2 = r2(47403);
        t2.exports = function(t3) {
          if (!n2(t3))
            return false;
          try {
            return !!t3.constructor && t3.constructor.prototype === t3;
          } catch (t4) {
            return false;
          }
        };
      }, 9234: function(t2, e2, r2) {
        var n2 = r2(24582), i = r2(47403), a = Object.prototype.toString;
        t2.exports = function(t3) {
          if (!n2(t3))
            return null;
          if (i(t3)) {
            var e3 = t3.toString;
            if ("function" != typeof e3)
              return null;
            if (e3 === a)
              return null;
          }
          try {
            return "" + t3;
          } catch (t4) {
            return null;
          }
        };
      }, 10424: function(t2, e2, r2) {
        var n2 = r2(69190), i = r2(24582);
        t2.exports = function(t3) {
          return i(t3) ? t3 : n2(t3, "Cannot use %v", arguments[1]);
        };
      }, 24582: function(t2) {
        t2.exports = function(t3) {
          return null != t3;
        };
      }, 58404: function(t2, e2, r2) {
        var n2 = r2(13547), i = r2(12129), a = r2(12856).Buffer;
        r2.g.__TYPEDARRAY_POOL || (r2.g.__TYPEDARRAY_POOL = { UINT8: i([32, 0]), UINT16: i([32, 0]), UINT32: i([32, 0]), BIGUINT64: i([32, 0]), INT8: i([32, 0]), INT16: i([32, 0]), INT32: i([32, 0]), BIGINT64: i([32, 0]), FLOAT: i([32, 0]), DOUBLE: i([32, 0]), DATA: i([32, 0]), UINT8C: i([32, 0]), BUFFER: i([32, 0]) });
        var o = "undefined" != typeof Uint8ClampedArray, s = "undefined" != typeof BigUint64Array, l = "undefined" != typeof BigInt64Array, u = r2.g.__TYPEDARRAY_POOL;
        u.UINT8C || (u.UINT8C = i([32, 0])), u.BIGUINT64 || (u.BIGUINT64 = i([32, 0])), u.BIGINT64 || (u.BIGINT64 = i([32, 0])), u.BUFFER || (u.BUFFER = i([32, 0]));
        var c = u.DATA, f2 = u.BUFFER;
        function h(t3) {
          if (t3) {
            var e3 = t3.length || t3.byteLength, r3 = n2.log2(e3);
            c[r3].push(t3);
          }
        }
        function p2(t3) {
          t3 = n2.nextPow2(t3);
          var e3 = n2.log2(t3), r3 = c[e3];
          return r3.length > 0 ? r3.pop() : new ArrayBuffer(t3);
        }
        function d2(t3) {
          return new Uint8Array(p2(t3), 0, t3);
        }
        function v(t3) {
          return new Uint16Array(p2(2 * t3), 0, t3);
        }
        function g2(t3) {
          return new Uint32Array(p2(4 * t3), 0, t3);
        }
        function y(t3) {
          return new Int8Array(p2(t3), 0, t3);
        }
        function m2(t3) {
          return new Int16Array(p2(2 * t3), 0, t3);
        }
        function x(t3) {
          return new Int32Array(p2(4 * t3), 0, t3);
        }
        function b(t3) {
          return new Float32Array(p2(4 * t3), 0, t3);
        }
        function _(t3) {
          return new Float64Array(p2(8 * t3), 0, t3);
        }
        function w2(t3) {
          return o ? new Uint8ClampedArray(p2(t3), 0, t3) : d2(t3);
        }
        function T(t3) {
          return s ? new BigUint64Array(p2(8 * t3), 0, t3) : null;
        }
        function k(t3) {
          return l ? new BigInt64Array(p2(8 * t3), 0, t3) : null;
        }
        function A(t3) {
          return new DataView(p2(t3), 0, t3);
        }
        function M(t3) {
          t3 = n2.nextPow2(t3);
          var e3 = n2.log2(t3), r3 = f2[e3];
          return r3.length > 0 ? r3.pop() : new a(t3);
        }
        e2.free = function(t3) {
          if (a.isBuffer(t3))
            f2[n2.log2(t3.length)].push(t3);
          else {
            if ("[object ArrayBuffer]" !== Object.prototype.toString.call(t3) && (t3 = t3.buffer), !t3)
              return;
            var e3 = t3.length || t3.byteLength, r3 = 0 | n2.log2(e3);
            c[r3].push(t3);
          }
        }, e2.freeUint8 = e2.freeUint16 = e2.freeUint32 = e2.freeBigUint64 = e2.freeInt8 = e2.freeInt16 = e2.freeInt32 = e2.freeBigInt64 = e2.freeFloat32 = e2.freeFloat = e2.freeFloat64 = e2.freeDouble = e2.freeUint8Clamped = e2.freeDataView = function(t3) {
          h(t3.buffer);
        }, e2.freeArrayBuffer = h, e2.freeBuffer = function(t3) {
          f2[n2.log2(t3.length)].push(t3);
        }, e2.malloc = function(t3, e3) {
          if (void 0 === e3 || "arraybuffer" === e3)
            return p2(t3);
          switch (e3) {
            case "uint8":
              return d2(t3);
            case "uint16":
              return v(t3);
            case "uint32":
              return g2(t3);
            case "int8":
              return y(t3);
            case "int16":
              return m2(t3);
            case "int32":
              return x(t3);
            case "float":
            case "float32":
              return b(t3);
            case "double":
            case "float64":
              return _(t3);
            case "uint8_clamped":
              return w2(t3);
            case "bigint64":
              return k(t3);
            case "biguint64":
              return T(t3);
            case "buffer":
              return M(t3);
            case "data":
            case "dataview":
              return A(t3);
            default:
              return null;
          }
          return null;
        }, e2.mallocArrayBuffer = p2, e2.mallocUint8 = d2, e2.mallocUint16 = v, e2.mallocUint32 = g2, e2.mallocInt8 = y, e2.mallocInt16 = m2, e2.mallocInt32 = x, e2.mallocFloat32 = e2.mallocFloat = b, e2.mallocFloat64 = e2.mallocDouble = _, e2.mallocUint8Clamped = w2, e2.mallocBigUint64 = T, e2.mallocBigInt64 = k, e2.mallocDataView = A, e2.mallocBuffer = M, e2.clearCache = function() {
          for (var t3 = 0; t3 < 32; ++t3)
            u.UINT8[t3].length = 0, u.UINT16[t3].length = 0, u.UINT32[t3].length = 0, u.INT8[t3].length = 0, u.INT16[t3].length = 0, u.INT32[t3].length = 0, u.FLOAT[t3].length = 0, u.DOUBLE[t3].length = 0, u.BIGUINT64[t3].length = 0, u.BIGINT64[t3].length = 0, u.UINT8C[t3].length = 0, c[t3].length = 0, f2[t3].length = 0;
        };
      }, 90448: function(t2) {
        var e2 = /[\'\"]/;
        t2.exports = function(t3) {
          return t3 ? (e2.test(t3.charAt(0)) && (t3 = t3.substr(1)), e2.test(t3.charAt(t3.length - 1)) && (t3 = t3.substr(0, t3.length - 1)), t3) : "";
        };
      }, 93447: function(t2) {
        t2.exports = function(t3, e2, r2) {
          Array.isArray(r2) || (r2 = [].slice.call(arguments, 2));
          for (var n2 = 0, i = r2.length; n2 < i; n2++) {
            var a = r2[n2];
            for (var o in a)
              if ((void 0 === e2[o] || Array.isArray(e2[o]) || t3[o] !== e2[o]) && o in e2) {
                var s;
                if (true === a[o])
                  s = e2[o];
                else {
                  if (false === a[o])
                    continue;
                  if ("function" == typeof a[o] && void 0 === (s = a[o](e2[o], t3, e2)))
                    continue;
                }
                t3[o] = s;
              }
          }
          return t3;
        };
      }, 20588: function(t2, e2, r2) {
        function n2(t3) {
          try {
            if (!r2.g.localStorage)
              return false;
          } catch (t4) {
            return false;
          }
          var e3 = r2.g.localStorage[t3];
          return null != e3 && "true" === String(e3).toLowerCase();
        }
        t2.exports = function(t3, e3) {
          if (n2("noDeprecation"))
            return t3;
          var r3 = false;
          return function() {
            if (!r3) {
              if (n2("throwDeprecation"))
                throw new Error(e3);
              n2("traceDeprecation") ? console.trace(e3) : console.warn(e3), r3 = true;
            }
            return t3.apply(this, arguments);
          };
        };
      }, 45920: function(t2) {
        t2.exports = function(t3) {
          return t3 && "object" == typeof t3 && "function" == typeof t3.copy && "function" == typeof t3.fill && "function" == typeof t3.readUInt8;
        };
      }, 4936: function(t2, e2, r2) {
        var n2 = r2(47216), i = r2(65481), a = r2(21099), o = r2(9187);
        function s(t3) {
          return t3.call.bind(t3);
        }
        var l = "undefined" != typeof BigInt, u = "undefined" != typeof Symbol, c = s(Object.prototype.toString), f2 = s(Number.prototype.valueOf), h = s(String.prototype.valueOf), p2 = s(Boolean.prototype.valueOf);
        if (l)
          var d2 = s(BigInt.prototype.valueOf);
        if (u)
          var v = s(Symbol.prototype.valueOf);
        function g2(t3, e3) {
          if ("object" != typeof t3)
            return false;
          try {
            return e3(t3), true;
          } catch (t4) {
            return false;
          }
        }
        function y(t3) {
          return "[object Map]" === c(t3);
        }
        function m2(t3) {
          return "[object Set]" === c(t3);
        }
        function x(t3) {
          return "[object WeakMap]" === c(t3);
        }
        function b(t3) {
          return "[object WeakSet]" === c(t3);
        }
        function _(t3) {
          return "[object ArrayBuffer]" === c(t3);
        }
        function w2(t3) {
          return "undefined" != typeof ArrayBuffer && (_.working ? _(t3) : t3 instanceof ArrayBuffer);
        }
        function T(t3) {
          return "[object DataView]" === c(t3);
        }
        function k(t3) {
          return "undefined" != typeof DataView && (T.working ? T(t3) : t3 instanceof DataView);
        }
        e2.isArgumentsObject = n2, e2.isGeneratorFunction = i, e2.isTypedArray = o, e2.isPromise = function(t3) {
          return "undefined" != typeof Promise && t3 instanceof Promise || null !== t3 && "object" == typeof t3 && "function" == typeof t3.then && "function" == typeof t3.catch;
        }, e2.isArrayBufferView = function(t3) {
          return "undefined" != typeof ArrayBuffer && ArrayBuffer.isView ? ArrayBuffer.isView(t3) : o(t3) || k(t3);
        }, e2.isUint8Array = function(t3) {
          return "Uint8Array" === a(t3);
        }, e2.isUint8ClampedArray = function(t3) {
          return "Uint8ClampedArray" === a(t3);
        }, e2.isUint16Array = function(t3) {
          return "Uint16Array" === a(t3);
        }, e2.isUint32Array = function(t3) {
          return "Uint32Array" === a(t3);
        }, e2.isInt8Array = function(t3) {
          return "Int8Array" === a(t3);
        }, e2.isInt16Array = function(t3) {
          return "Int16Array" === a(t3);
        }, e2.isInt32Array = function(t3) {
          return "Int32Array" === a(t3);
        }, e2.isFloat32Array = function(t3) {
          return "Float32Array" === a(t3);
        }, e2.isFloat64Array = function(t3) {
          return "Float64Array" === a(t3);
        }, e2.isBigInt64Array = function(t3) {
          return "BigInt64Array" === a(t3);
        }, e2.isBigUint64Array = function(t3) {
          return "BigUint64Array" === a(t3);
        }, y.working = "undefined" != typeof Map && y(/* @__PURE__ */ new Map()), e2.isMap = function(t3) {
          return "undefined" != typeof Map && (y.working ? y(t3) : t3 instanceof Map);
        }, m2.working = "undefined" != typeof Set && m2(/* @__PURE__ */ new Set()), e2.isSet = function(t3) {
          return "undefined" != typeof Set && (m2.working ? m2(t3) : t3 instanceof Set);
        }, x.working = "undefined" != typeof WeakMap && x(/* @__PURE__ */ new WeakMap()), e2.isWeakMap = function(t3) {
          return "undefined" != typeof WeakMap && (x.working ? x(t3) : t3 instanceof WeakMap);
        }, b.working = "undefined" != typeof WeakSet && b(/* @__PURE__ */ new WeakSet()), e2.isWeakSet = function(t3) {
          return b(t3);
        }, _.working = "undefined" != typeof ArrayBuffer && _(new ArrayBuffer()), e2.isArrayBuffer = w2, T.working = "undefined" != typeof ArrayBuffer && "undefined" != typeof DataView && T(new DataView(new ArrayBuffer(1), 0, 1)), e2.isDataView = k;
        var A = "undefined" != typeof SharedArrayBuffer ? SharedArrayBuffer : void 0;
        function M(t3) {
          return "[object SharedArrayBuffer]" === c(t3);
        }
        function S(t3) {
          return void 0 !== A && (void 0 === M.working && (M.working = M(new A())), M.working ? M(t3) : t3 instanceof A);
        }
        function E(t3) {
          return g2(t3, f2);
        }
        function L(t3) {
          return g2(t3, h);
        }
        function C(t3) {
          return g2(t3, p2);
        }
        function P(t3) {
          return l && g2(t3, d2);
        }
        function O(t3) {
          return u && g2(t3, v);
        }
        e2.isSharedArrayBuffer = S, e2.isAsyncFunction = function(t3) {
          return "[object AsyncFunction]" === c(t3);
        }, e2.isMapIterator = function(t3) {
          return "[object Map Iterator]" === c(t3);
        }, e2.isSetIterator = function(t3) {
          return "[object Set Iterator]" === c(t3);
        }, e2.isGeneratorObject = function(t3) {
          return "[object Generator]" === c(t3);
        }, e2.isWebAssemblyCompiledModule = function(t3) {
          return "[object WebAssembly.Module]" === c(t3);
        }, e2.isNumberObject = E, e2.isStringObject = L, e2.isBooleanObject = C, e2.isBigIntObject = P, e2.isSymbolObject = O, e2.isBoxedPrimitive = function(t3) {
          return E(t3) || L(t3) || C(t3) || P(t3) || O(t3);
        }, e2.isAnyArrayBuffer = function(t3) {
          return "undefined" != typeof Uint8Array && (w2(t3) || S(t3));
        }, ["isProxy", "isExternal", "isModuleNamespaceObject"].forEach(function(t3) {
          Object.defineProperty(e2, t3, { enumerable: false, value: function() {
            throw new Error(t3 + " is not supported in userland");
          } });
        });
      }, 43827: function(t2, e2, r2) {
        var n2 = r2(90386), i = Object.getOwnPropertyDescriptors || function(t3) {
          for (var e3 = Object.keys(t3), r3 = {}, n3 = 0; n3 < e3.length; n3++)
            r3[e3[n3]] = Object.getOwnPropertyDescriptor(t3, e3[n3]);
          return r3;
        }, a = /%[sdj%]/g;
        e2.format = function(t3) {
          if (!x(t3)) {
            for (var e3 = [], r3 = 0; r3 < arguments.length; r3++)
              e3.push(u(arguments[r3]));
            return e3.join(" ");
          }
          r3 = 1;
          for (var n3 = arguments, i2 = n3.length, o2 = String(t3).replace(a, function(t4) {
            if ("%%" === t4)
              return "%";
            if (r3 >= i2)
              return t4;
            switch (t4) {
              case "%s":
                return String(n3[r3++]);
              case "%d":
                return Number(n3[r3++]);
              case "%j":
                try {
                  return JSON.stringify(n3[r3++]);
                } catch (t5) {
                  return "[Circular]";
                }
              default:
                return t4;
            }
          }), s2 = n3[r3]; r3 < i2; s2 = n3[++r3])
            y(s2) || !w2(s2) ? o2 += " " + s2 : o2 += " " + u(s2);
          return o2;
        }, e2.deprecate = function(t3, r3) {
          if (void 0 !== n2 && true === n2.noDeprecation)
            return t3;
          if (void 0 === n2)
            return function() {
              return e2.deprecate(t3, r3).apply(this, arguments);
            };
          var i2 = false;
          return function() {
            if (!i2) {
              if (n2.throwDeprecation)
                throw new Error(r3);
              n2.traceDeprecation ? console.trace(r3) : console.error(r3), i2 = true;
            }
            return t3.apply(this, arguments);
          };
        };
        var o = {}, s = /^$/;
        if (n2.env.NODE_DEBUG) {
          var l = n2.env.NODE_DEBUG;
          l = l.replace(/[|\\{}()[\]^$+?.]/g, "\\$&").replace(/\*/g, ".*").replace(/,/g, "$|^").toUpperCase(), s = new RegExp("^" + l + "$", "i");
        }
        function u(t3, r3) {
          var n3 = { seen: [], stylize: f2 };
          return arguments.length >= 3 && (n3.depth = arguments[2]), arguments.length >= 4 && (n3.colors = arguments[3]), g2(r3) ? n3.showHidden = r3 : r3 && e2._extend(n3, r3), b(n3.showHidden) && (n3.showHidden = false), b(n3.depth) && (n3.depth = 2), b(n3.colors) && (n3.colors = false), b(n3.customInspect) && (n3.customInspect = true), n3.colors && (n3.stylize = c), h(n3, t3, n3.depth);
        }
        function c(t3, e3) {
          var r3 = u.styles[e3];
          return r3 ? "\x1B[" + u.colors[r3][0] + "m" + t3 + "\x1B[" + u.colors[r3][1] + "m" : t3;
        }
        function f2(t3, e3) {
          return t3;
        }
        function h(t3, r3, n3) {
          if (t3.customInspect && r3 && A(r3.inspect) && r3.inspect !== e2.inspect && (!r3.constructor || r3.constructor.prototype !== r3)) {
            var i2 = r3.inspect(n3, t3);
            return x(i2) || (i2 = h(t3, i2, n3)), i2;
          }
          var a2 = function(t4, e3) {
            if (b(e3))
              return t4.stylize("undefined", "undefined");
            if (x(e3)) {
              var r4 = "'" + JSON.stringify(e3).replace(/^"|"$/g, "").replace(/'/g, "\\'").replace(/\\"/g, '"') + "'";
              return t4.stylize(r4, "string");
            }
            return m2(e3) ? t4.stylize("" + e3, "number") : g2(e3) ? t4.stylize("" + e3, "boolean") : y(e3) ? t4.stylize("null", "null") : void 0;
          }(t3, r3);
          if (a2)
            return a2;
          var o2 = Object.keys(r3), s2 = function(t4) {
            var e3 = {};
            return t4.forEach(function(t5, r4) {
              e3[t5] = true;
            }), e3;
          }(o2);
          if (t3.showHidden && (o2 = Object.getOwnPropertyNames(r3)), k(r3) && (o2.indexOf("message") >= 0 || o2.indexOf("description") >= 0))
            return p2(r3);
          if (0 === o2.length) {
            if (A(r3)) {
              var l2 = r3.name ? ": " + r3.name : "";
              return t3.stylize("[Function" + l2 + "]", "special");
            }
            if (_(r3))
              return t3.stylize(RegExp.prototype.toString.call(r3), "regexp");
            if (T(r3))
              return t3.stylize(Date.prototype.toString.call(r3), "date");
            if (k(r3))
              return p2(r3);
          }
          var u2, c2 = "", f3 = false, w3 = ["{", "}"];
          return v(r3) && (f3 = true, w3 = ["[", "]"]), A(r3) && (c2 = " [Function" + (r3.name ? ": " + r3.name : "") + "]"), _(r3) && (c2 = " " + RegExp.prototype.toString.call(r3)), T(r3) && (c2 = " " + Date.prototype.toUTCString.call(r3)), k(r3) && (c2 = " " + p2(r3)), 0 !== o2.length || f3 && 0 != r3.length ? n3 < 0 ? _(r3) ? t3.stylize(RegExp.prototype.toString.call(r3), "regexp") : t3.stylize("[Object]", "special") : (t3.seen.push(r3), u2 = f3 ? function(t4, e3, r4, n4, i3) {
            for (var a3 = [], o3 = 0, s3 = e3.length; o3 < s3; ++o3)
              C(e3, String(o3)) ? a3.push(d2(t4, e3, r4, n4, String(o3), true)) : a3.push("");
            return i3.forEach(function(i4) {
              i4.match(/^\d+$/) || a3.push(d2(t4, e3, r4, n4, i4, true));
            }), a3;
          }(t3, r3, n3, s2, o2) : o2.map(function(e3) {
            return d2(t3, r3, n3, s2, e3, f3);
          }), t3.seen.pop(), function(t4, e3, r4) {
            return t4.reduce(function(t5, e4) {
              return e4.indexOf("\n"), t5 + e4.replace(/\u001b\[\d\d?m/g, "").length + 1;
            }, 0) > 60 ? r4[0] + ("" === e3 ? "" : e3 + "\n ") + " " + t4.join(",\n  ") + " " + r4[1] : r4[0] + e3 + " " + t4.join(", ") + " " + r4[1];
          }(u2, c2, w3)) : w3[0] + c2 + w3[1];
        }
        function p2(t3) {
          return "[" + Error.prototype.toString.call(t3) + "]";
        }
        function d2(t3, e3, r3, n3, i2, a2) {
          var o2, s2, l2;
          if ((l2 = Object.getOwnPropertyDescriptor(e3, i2) || { value: e3[i2] }).get ? s2 = l2.set ? t3.stylize("[Getter/Setter]", "special") : t3.stylize("[Getter]", "special") : l2.set && (s2 = t3.stylize("[Setter]", "special")), C(n3, i2) || (o2 = "[" + i2 + "]"), s2 || (t3.seen.indexOf(l2.value) < 0 ? (s2 = y(r3) ? h(t3, l2.value, null) : h(t3, l2.value, r3 - 1)).indexOf("\n") > -1 && (s2 = a2 ? s2.split("\n").map(function(t4) {
            return "  " + t4;
          }).join("\n").slice(2) : "\n" + s2.split("\n").map(function(t4) {
            return "   " + t4;
          }).join("\n")) : s2 = t3.stylize("[Circular]", "special")), b(o2)) {
            if (a2 && i2.match(/^\d+$/))
              return s2;
            (o2 = JSON.stringify("" + i2)).match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/) ? (o2 = o2.slice(1, -1), o2 = t3.stylize(o2, "name")) : (o2 = o2.replace(/'/g, "\\'").replace(/\\"/g, '"').replace(/(^"|"$)/g, "'"), o2 = t3.stylize(o2, "string"));
          }
          return o2 + ": " + s2;
        }
        function v(t3) {
          return Array.isArray(t3);
        }
        function g2(t3) {
          return "boolean" == typeof t3;
        }
        function y(t3) {
          return null === t3;
        }
        function m2(t3) {
          return "number" == typeof t3;
        }
        function x(t3) {
          return "string" == typeof t3;
        }
        function b(t3) {
          return void 0 === t3;
        }
        function _(t3) {
          return w2(t3) && "[object RegExp]" === M(t3);
        }
        function w2(t3) {
          return "object" == typeof t3 && null !== t3;
        }
        function T(t3) {
          return w2(t3) && "[object Date]" === M(t3);
        }
        function k(t3) {
          return w2(t3) && ("[object Error]" === M(t3) || t3 instanceof Error);
        }
        function A(t3) {
          return "function" == typeof t3;
        }
        function M(t3) {
          return Object.prototype.toString.call(t3);
        }
        function S(t3) {
          return t3 < 10 ? "0" + t3.toString(10) : t3.toString(10);
        }
        e2.debuglog = function(t3) {
          if (t3 = t3.toUpperCase(), !o[t3])
            if (s.test(t3)) {
              var r3 = n2.pid;
              o[t3] = function() {
                var n3 = e2.format.apply(e2, arguments);
                console.error("%s %d: %s", t3, r3, n3);
              };
            } else
              o[t3] = function() {
              };
          return o[t3];
        }, e2.inspect = u, u.colors = { bold: [1, 22], italic: [3, 23], underline: [4, 24], inverse: [7, 27], white: [37, 39], grey: [90, 39], black: [30, 39], blue: [34, 39], cyan: [36, 39], green: [32, 39], magenta: [35, 39], red: [31, 39], yellow: [33, 39] }, u.styles = { special: "cyan", number: "yellow", boolean: "yellow", undefined: "grey", null: "bold", string: "green", date: "magenta", regexp: "red" }, e2.types = r2(4936), e2.isArray = v, e2.isBoolean = g2, e2.isNull = y, e2.isNullOrUndefined = function(t3) {
          return null == t3;
        }, e2.isNumber = m2, e2.isString = x, e2.isSymbol = function(t3) {
          return "symbol" == typeof t3;
        }, e2.isUndefined = b, e2.isRegExp = _, e2.types.isRegExp = _, e2.isObject = w2, e2.isDate = T, e2.types.isDate = T, e2.isError = k, e2.types.isNativeError = k, e2.isFunction = A, e2.isPrimitive = function(t3) {
          return null === t3 || "boolean" == typeof t3 || "number" == typeof t3 || "string" == typeof t3 || "symbol" == typeof t3 || void 0 === t3;
        }, e2.isBuffer = r2(45920);
        var E = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
        function L() {
          var t3 = new Date(), e3 = [S(t3.getHours()), S(t3.getMinutes()), S(t3.getSeconds())].join(":");
          return [t3.getDate(), E[t3.getMonth()], e3].join(" ");
        }
        function C(t3, e3) {
          return Object.prototype.hasOwnProperty.call(t3, e3);
        }
        e2.log = function() {
          console.log("%s - %s", L(), e2.format.apply(e2, arguments));
        }, e2.inherits = r2(42018), e2._extend = function(t3, e3) {
          if (!e3 || !w2(e3))
            return t3;
          for (var r3 = Object.keys(e3), n3 = r3.length; n3--; )
            t3[r3[n3]] = e3[r3[n3]];
          return t3;
        };
        var P = "undefined" != typeof Symbol ? Symbol("util.promisify.custom") : void 0;
        function O(t3, e3) {
          if (!t3) {
            var r3 = new Error("Promise was rejected with a falsy value");
            r3.reason = t3, t3 = r3;
          }
          return e3(t3);
        }
        e2.promisify = function(t3) {
          if ("function" != typeof t3)
            throw new TypeError('The "original" argument must be of type Function');
          if (P && t3[P]) {
            var e3;
            if ("function" != typeof (e3 = t3[P]))
              throw new TypeError('The "util.promisify.custom" argument must be of type Function');
            return Object.defineProperty(e3, P, { value: e3, enumerable: false, writable: false, configurable: true }), e3;
          }
          function e3() {
            for (var e4, r3, n3 = new Promise(function(t4, n4) {
              e4 = t4, r3 = n4;
            }), i2 = [], a2 = 0; a2 < arguments.length; a2++)
              i2.push(arguments[a2]);
            i2.push(function(t4, n4) {
              t4 ? r3(t4) : e4(n4);
            });
            try {
              t3.apply(this, i2);
            } catch (t4) {
              r3(t4);
            }
            return n3;
          }
          return Object.setPrototypeOf(e3, Object.getPrototypeOf(t3)), P && Object.defineProperty(e3, P, { value: e3, enumerable: false, writable: false, configurable: true }), Object.defineProperties(e3, i(t3));
        }, e2.promisify.custom = P, e2.callbackify = function(t3) {
          if ("function" != typeof t3)
            throw new TypeError('The "original" argument must be of type Function');
          function e3() {
            for (var e4 = [], r3 = 0; r3 < arguments.length; r3++)
              e4.push(arguments[r3]);
            var i2 = e4.pop();
            if ("function" != typeof i2)
              throw new TypeError("The last argument must be of type Function");
            var a2 = this, o2 = function() {
              return i2.apply(a2, arguments);
            };
            t3.apply(this, e4).then(function(t4) {
              n2.nextTick(o2.bind(null, null, t4));
            }, function(t4) {
              n2.nextTick(O.bind(null, t4, o2));
            });
          }
          return Object.setPrototypeOf(e3, Object.getPrototypeOf(t3)), Object.defineProperties(e3, i(t3)), e3;
        };
      }, 40372: function(t2, e2, r2) {
        var n2 = r2(86249);
        t2.exports = function(t3) {
          return n2("webgl", t3);
        };
      }, 21099: function(t2, e2, r2) {
        var n2 = r2(31353), i = r2(72077), a = r2(6614), o = r2(40383), s = a("Object.prototype.toString"), l = r2(84543)(), u = "undefined" == typeof globalThis ? r2.g : globalThis, c = i(), f2 = a("String.prototype.slice"), h = {}, p2 = Object.getPrototypeOf;
        l && o && p2 && n2(c, function(t3) {
          if ("function" == typeof u[t3]) {
            var e3 = new u[t3]();
            if (Symbol.toStringTag in e3) {
              var r3 = p2(e3), n3 = o(r3, Symbol.toStringTag);
              if (!n3) {
                var i2 = p2(r3);
                n3 = o(i2, Symbol.toStringTag);
              }
              h[t3] = n3.get;
            }
          }
        });
        var d2 = r2(9187);
        t2.exports = function(t3) {
          return !!d2(t3) && (l && Symbol.toStringTag in t3 ? function(t4) {
            var e3 = false;
            return n2(h, function(r3, n3) {
              if (!e3)
                try {
                  var i2 = r3.call(t4);
                  i2 === n3 && (e3 = i2);
                } catch (t5) {
                }
            }), e3;
          }(t3) : f2(s(t3), 8, -1));
        };
      }, 3961: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131), a = n2.instance();
        function o(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        o.prototype = new n2.baseCalendar(), i(o.prototype, { name: "Chinese", jdEpoch: 17214255e-1, hasYearZero: false, minMonth: 0, firstMonth: 0, minDay: 1, regionalOptions: { "": { name: "Chinese", epochs: ["BEC", "EC"], monthNumbers: function(t3, e3) {
          if ("string" == typeof t3) {
            var r3 = t3.match(l);
            return r3 ? r3[0] : "";
          }
          var n3 = this._validateYear(t3), i2 = t3.month(), a2 = "" + this.toChineseMonth(n3, i2);
          return e3 && a2.length < 2 && (a2 = "0" + a2), this.isIntercalaryMonth(n3, i2) && (a2 += "i"), a2;
        }, monthNames: function(t3) {
          if ("string" == typeof t3) {
            var e3 = t3.match(u);
            return e3 ? e3[0] : "";
          }
          var r3 = this._validateYear(t3), n3 = t3.month(), i2 = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"][this.toChineseMonth(r3, n3) - 1];
          return this.isIntercalaryMonth(r3, n3) && (i2 = "闰" + i2), i2;
        }, monthNamesShort: function(t3) {
          if ("string" == typeof t3) {
            var e3 = t3.match(c);
            return e3 ? e3[0] : "";
          }
          var r3 = this._validateYear(t3), n3 = t3.month(), i2 = ["一", "二", "三", "四", "五", "六", "七", "八", "九", "十", "十一", "十二"][this.toChineseMonth(r3, n3) - 1];
          return this.isIntercalaryMonth(r3, n3) && (i2 = "闰" + i2), i2;
        }, parseMonth: function(t3, e3) {
          t3 = this._validateYear(t3);
          var r3, n3 = parseInt(e3);
          if (isNaN(n3))
            "闰" === e3[0] && (r3 = true, e3 = e3.substring(1)), "月" === e3[e3.length - 1] && (e3 = e3.substring(0, e3.length - 1)), n3 = 1 + ["一", "二", "三", "四", "五", "六", "七", "八", "九", "十", "十一", "十二"].indexOf(e3);
          else {
            var i2 = e3[e3.length - 1];
            r3 = "i" === i2 || "I" === i2;
          }
          return this.toMonthIndex(t3, n3, r3);
        }, dayNames: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayNamesShort: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], dayNamesMin: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"], digits: null, dateFormat: "yyyy/mm/dd", firstDay: 1, isRTL: false } }, _validateYear: function(t3, e3) {
          if (t3.year && (t3 = t3.year()), "number" != typeof t3 || t3 < 1888 || t3 > 2111)
            throw e3.replace(/\{0\}/, this.local.name);
          return t3;
        }, toMonthIndex: function(t3, e3, r3) {
          var i2 = this.intercalaryMonth(t3);
          if (r3 && e3 !== i2 || e3 < 1 || e3 > 12)
            throw n2.local.invalidMonth.replace(/\{0\}/, this.local.name);
          return i2 ? !r3 && e3 <= i2 ? e3 - 1 : e3 : e3 - 1;
        }, toChineseMonth: function(t3, e3) {
          t3.year && (e3 = (t3 = t3.year()).month());
          var r3 = this.intercalaryMonth(t3);
          if (e3 < 0 || e3 > (r3 ? 12 : 11))
            throw n2.local.invalidMonth.replace(/\{0\}/, this.local.name);
          return r3 ? e3 < r3 ? e3 + 1 : e3 : e3 + 1;
        }, intercalaryMonth: function(t3) {
          return t3 = this._validateYear(t3), f2[t3 - f2[0]] >> 13;
        }, isIntercalaryMonth: function(t3, e3) {
          t3.year && (e3 = (t3 = t3.year()).month());
          var r3 = this.intercalaryMonth(t3);
          return !!r3 && r3 === e3;
        }, leapYear: function(t3) {
          return 0 !== this.intercalaryMonth(t3);
        }, weekOfYear: function(t3, e3, r3) {
          var i2, o2 = this._validateYear(t3, n2.local.invalidyear), s2 = h[o2 - h[0]], l2 = s2 >> 9 & 4095, u2 = s2 >> 5 & 15, c2 = 31 & s2;
          (i2 = a.newDate(l2, u2, c2)).add(4 - (i2.dayOfWeek() || 7), "d");
          var f3 = this.toJD(t3, e3, r3) - i2.toJD();
          return 1 + Math.floor(f3 / 7);
        }, monthsInYear: function(t3) {
          return this.leapYear(t3) ? 13 : 12;
        }, daysInMonth: function(t3, e3) {
          t3.year && (e3 = t3.month(), t3 = t3.year()), t3 = this._validateYear(t3);
          var r3 = f2[t3 - f2[0]];
          if (e3 > (r3 >> 13 ? 12 : 11))
            throw n2.local.invalidMonth.replace(/\{0\}/, this.local.name);
          return r3 & 1 << 12 - e3 ? 30 : 29;
        }, weekDay: function(t3, e3, r3) {
          return (this.dayOfWeek(t3, e3, r3) || 7) < 6;
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, s2, r3, n2.local.invalidDate);
          t3 = this._validateYear(i2.year()), e3 = i2.month(), r3 = i2.day();
          var o2 = this.isIntercalaryMonth(t3, e3), s2 = this.toChineseMonth(t3, e3), l2 = function(t4, e4, r4, n3, i3) {
            var a2, o3, s3;
            if ("object" == typeof t4)
              o3 = t4, a2 = e4 || {};
            else {
              var l3;
              if (!("number" == typeof t4 && t4 >= 1888 && t4 <= 2111))
                throw new Error("Lunar year outside range 1888-2111");
              if (!("number" == typeof e4 && e4 >= 1 && e4 <= 12))
                throw new Error("Lunar month outside range 1 - 12");
              if (!("number" == typeof r4 && r4 >= 1 && r4 <= 30))
                throw new Error("Lunar day outside range 1 - 30");
              "object" == typeof n3 ? (l3 = false, a2 = n3) : (l3 = !!n3, a2 = {}), o3 = { year: t4, month: e4, day: r4, isIntercalary: l3 };
            }
            s3 = o3.day - 1;
            var u2, c2 = f2[o3.year - f2[0]], p2 = c2 >> 13;
            u2 = p2 && (o3.month > p2 || o3.isIntercalary) ? o3.month : o3.month - 1;
            for (var d2 = 0; d2 < u2; d2++)
              s3 += c2 & 1 << 12 - d2 ? 30 : 29;
            var v = h[o3.year - h[0]], g2 = new Date(v >> 9 & 4095, (v >> 5 & 15) - 1, (31 & v) + s3);
            return a2.year = g2.getFullYear(), a2.month = 1 + g2.getMonth(), a2.day = g2.getDate(), a2;
          }(t3, s2, r3, o2);
          return a.toJD(l2.year, l2.month, l2.day);
        }, fromJD: function(t3) {
          var e3 = a.fromJD(t3), r3 = function(t4, e4, r4, n4) {
            var i2, a2;
            if ("object" == typeof t4)
              i2 = t4, a2 = e4 || {};
            else {
              if (!("number" == typeof t4 && t4 >= 1888 && t4 <= 2111))
                throw new Error("Solar year outside range 1888-2111");
              if (!("number" == typeof e4 && e4 >= 1 && e4 <= 12))
                throw new Error("Solar month outside range 1 - 12");
              if (!("number" == typeof r4 && r4 >= 1 && r4 <= 31))
                throw new Error("Solar day outside range 1 - 31");
              i2 = { year: t4, month: e4, day: r4 }, a2 = {};
            }
            var o2 = h[i2.year - h[0]], s2 = i2.year << 9 | i2.month << 5 | i2.day;
            a2.year = s2 >= o2 ? i2.year : i2.year - 1, o2 = h[a2.year - h[0]];
            var l2, u2 = new Date(o2 >> 9 & 4095, (o2 >> 5 & 15) - 1, 31 & o2), c2 = new Date(i2.year, i2.month - 1, i2.day);
            l2 = Math.round((c2 - u2) / 864e5);
            var p2, d2 = f2[a2.year - f2[0]];
            for (p2 = 0; p2 < 13; p2++) {
              var v = d2 & 1 << 12 - p2 ? 30 : 29;
              if (l2 < v)
                break;
              l2 -= v;
            }
            var g2 = d2 >> 13;
            return !g2 || p2 < g2 ? (a2.isIntercalary = false, a2.month = 1 + p2) : p2 === g2 ? (a2.isIntercalary = true, a2.month = p2) : (a2.isIntercalary = false, a2.month = p2), a2.day = 1 + l2, a2;
          }(e3.year(), e3.month(), e3.day()), n3 = this.toMonthIndex(r3.year, r3.month, r3.isIntercalary);
          return this.newDate(r3.year, n3, r3.day);
        }, fromString: function(t3) {
          var e3 = t3.match(s), r3 = this._validateYear(+e3[1]), n3 = +e3[2], i2 = !!e3[3], a2 = this.toMonthIndex(r3, n3, i2), o2 = +e3[4];
          return this.newDate(r3, a2, o2);
        }, add: function(t3, e3, r3) {
          var n3 = t3.year(), i2 = t3.month(), a2 = this.isIntercalaryMonth(n3, i2), s2 = this.toChineseMonth(n3, i2), l2 = Object.getPrototypeOf(o.prototype).add.call(this, t3, e3, r3);
          if ("y" === r3) {
            var u2 = l2.year(), c2 = l2.month(), f3 = this.isIntercalaryMonth(u2, s2), h2 = a2 && f3 ? this.toMonthIndex(u2, s2, true) : this.toMonthIndex(u2, s2, false);
            h2 !== c2 && l2.month(h2);
          }
          return l2;
        } });
        var s = /^\s*(-?\d\d\d\d|\d\d)[-/](\d?\d)([iI]?)[-/](\d?\d)/m, l = /^\d?\d[iI]?/m, u = /^闰?十?[一二三四五六七八九]?月/m, c = /^闰?十?[一二三四五六七八九]?/m;
        n2.calendars.chinese = o;
        var f2 = [1887, 5780, 5802, 19157, 2742, 50359, 1198, 2646, 46378, 7466, 3412, 30122, 5482, 67949, 2396, 5294, 43597, 6732, 6954, 36181, 2772, 4954, 18781, 2396, 54427, 5274, 6730, 47781, 5800, 6868, 21210, 4790, 59703, 2350, 5270, 46667, 3402, 3496, 38325, 1388, 4782, 18735, 2350, 52374, 6804, 7498, 44457, 2906, 1388, 29294, 4700, 63789, 6442, 6804, 56138, 5802, 2772, 38235, 1210, 4698, 22827, 5418, 63125, 3476, 5802, 43701, 2484, 5302, 27223, 2646, 70954, 7466, 3412, 54698, 5482, 2412, 38062, 5294, 2636, 32038, 6954, 60245, 2772, 4826, 43357, 2394, 5274, 39501, 6730, 72357, 5800, 5844, 53978, 4790, 2358, 38039, 5270, 87627, 3402, 3496, 54708, 5484, 4782, 43311, 2350, 3222, 27978, 7498, 68965, 2904, 5484, 45677, 4700, 6444, 39573, 6804, 6986, 19285, 2772, 62811, 1210, 4698, 47403, 5418, 5780, 38570, 5546, 76469, 2420, 5302, 51799, 2646, 5414, 36501, 3412, 5546, 18869, 2412, 54446, 5276, 6732, 48422, 6822, 2900, 28010, 4826, 92509, 2394, 5274, 55883, 6730, 6820, 47956, 5812, 2778, 18779, 2358, 62615, 5270, 5450, 46757, 3492, 5556, 27318, 4718, 67887, 2350, 3222, 52554, 7498, 3428, 38252, 5468, 4700, 31022, 6444, 64149, 6804, 6986, 43861, 2772, 5338, 35421, 2650, 70955, 5418, 5780, 54954, 5546, 2740, 38074, 5302, 2646, 29991, 3366, 61011, 3412, 5546, 43445, 2412, 5294, 35406, 6732, 72998, 6820, 6996, 52586, 2778, 2396, 38045, 5274, 6698, 23333, 6820, 64338, 5812, 2746, 43355, 2358, 5270, 39499, 5450, 79525, 3492, 5548], h = [1887, 966732, 967231, 967733, 968265, 968766, 969297, 969798, 970298, 970829, 971330, 971830, 972362, 972863, 973395, 973896, 974397, 974928, 975428, 975929, 976461, 976962, 977462, 977994, 978494, 979026, 979526, 980026, 980558, 981059, 981559, 982091, 982593, 983124, 983624, 984124, 984656, 985157, 985656, 986189, 986690, 987191, 987722, 988222, 988753, 989254, 989754, 990286, 990788, 991288, 991819, 992319, 992851, 993352, 993851, 994383, 994885, 995385, 995917, 996418, 996918, 997450, 997949, 998481, 998982, 999483, 1000014, 1000515, 1001016, 1001548, 1002047, 1002578, 1003080, 1003580, 1004111, 1004613, 1005113, 1005645, 1006146, 1006645, 1007177, 1007678, 1008209, 1008710, 1009211, 1009743, 1010243, 1010743, 1011275, 1011775, 1012306, 1012807, 1013308, 1013840, 1014341, 1014841, 1015373, 1015874, 1016404, 1016905, 1017405, 1017937, 1018438, 1018939, 1019471, 1019972, 1020471, 1021002, 1021503, 1022035, 1022535, 1023036, 1023568, 1024069, 1024568, 1025100, 1025601, 1026102, 1026633, 1027133, 1027666, 1028167, 1028666, 1029198, 1029699, 1030199, 1030730, 1031231, 1031763, 1032264, 1032764, 1033296, 1033797, 1034297, 1034828, 1035329, 1035830, 1036362, 1036861, 1037393, 1037894, 1038394, 1038925, 1039427, 1039927, 1040459, 1040959, 1041491, 1041992, 1042492, 1043023, 1043524, 1044024, 1044556, 1045057, 1045558, 1046090, 1046590, 1047121, 1047622, 1048122, 1048654, 1049154, 1049655, 1050187, 1050689, 1051219, 1051720, 1052220, 1052751, 1053252, 1053752, 1054284, 1054786, 1055285, 1055817, 1056317, 1056849, 1057349, 1057850, 1058382, 1058883, 1059383, 1059915, 1060415, 1060947, 1061447, 1061947, 1062479, 1062981, 1063480, 1064012, 1064514, 1065014, 1065545, 1066045, 1066577, 1067078, 1067578, 1068110, 1068611, 1069112, 1069642, 1070142, 1070674, 1071175, 1071675, 1072207, 1072709, 1073209, 1073740, 1074241, 1074741, 1075273, 1075773, 1076305, 1076807, 1077308, 1077839, 1078340, 1078840, 1079372, 1079871, 1080403, 1080904];
      }, 38751: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131);
        function a(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        a.prototype = new n2.baseCalendar(), i(a.prototype, { name: "Coptic", jdEpoch: 18250295e-1, daysPerMonth: [30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 5], hasYearZero: false, minMonth: 1, firstMonth: 1, minDay: 1, regionalOptions: { "": { name: "Coptic", epochs: ["BAM", "AM"], monthNames: ["Thout", "Paopi", "Hathor", "Koiak", "Tobi", "Meshir", "Paremhat", "Paremoude", "Pashons", "Paoni", "Epip", "Mesori", "Pi Kogi Enavot"], monthNamesShort: ["Tho", "Pao", "Hath", "Koi", "Tob", "Mesh", "Pat", "Pad", "Pash", "Pao", "Epi", "Meso", "PiK"], dayNames: ["Tkyriaka", "Pesnau", "Pshoment", "Peftoou", "Ptiou", "Psoou", "Psabbaton"], dayNamesShort: ["Tky", "Pes", "Psh", "Pef", "Pti", "Pso", "Psa"], dayNamesMin: ["Tk", "Pes", "Psh", "Pef", "Pt", "Pso", "Psa"], digits: null, dateFormat: "dd/mm/yyyy", firstDay: 0, isRTL: false } }, leapYear: function(t3) {
          var e3 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear);
          return (t3 = e3.year() + (e3.year() < 0 ? 1 : 0)) % 4 == 3 || t3 % 4 == -1;
        }, monthsInYear: function(t3) {
          return this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear || n2.regionalOptions[""].invalidYear), 13;
        }, weekOfYear: function(t3, e3, r3) {
          var n3 = this.newDate(t3, e3, r3);
          return n3.add(-n3.dayOfWeek(), "d"), Math.floor((n3.dayOfYear() - 1) / 7) + 1;
        }, daysInMonth: function(t3, e3) {
          var r3 = this._validate(t3, e3, this.minDay, n2.local.invalidMonth);
          return this.daysPerMonth[r3.month() - 1] + (13 === r3.month() && this.leapYear(r3.year()) ? 1 : 0);
        }, weekDay: function(t3, e3, r3) {
          return (this.dayOfWeek(t3, e3, r3) || 7) < 6;
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          return (t3 = i2.year()) < 0 && t3++, i2.day() + 30 * (i2.month() - 1) + 365 * (t3 - 1) + Math.floor(t3 / 4) + this.jdEpoch - 1;
        }, fromJD: function(t3) {
          var e3 = Math.floor(t3) + 0.5 - this.jdEpoch, r3 = Math.floor((e3 - Math.floor((e3 + 366) / 1461)) / 365) + 1;
          r3 <= 0 && r3--, e3 = Math.floor(t3) + 0.5 - this.newDate(r3, 1, 1).toJD();
          var n3 = Math.floor(e3 / 30) + 1, i2 = e3 - 30 * (n3 - 1) + 1;
          return this.newDate(r3, n3, i2);
        } }), n2.calendars.coptic = a;
      }, 86825: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131);
        function a(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        a.prototype = new n2.baseCalendar(), i(a.prototype, { name: "Discworld", jdEpoch: 17214255e-1, daysPerMonth: [16, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32], hasYearZero: false, minMonth: 1, firstMonth: 1, minDay: 1, regionalOptions: { "": { name: "Discworld", epochs: ["BUC", "UC"], monthNames: ["Ick", "Offle", "February", "March", "April", "May", "June", "Grune", "August", "Spune", "Sektober", "Ember", "December"], monthNamesShort: ["Ick", "Off", "Feb", "Mar", "Apr", "May", "Jun", "Gru", "Aug", "Spu", "Sek", "Emb", "Dec"], dayNames: ["Sunday", "Octeday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayNamesShort: ["Sun", "Oct", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], dayNamesMin: ["Su", "Oc", "Mo", "Tu", "We", "Th", "Fr", "Sa"], digits: null, dateFormat: "yyyy/mm/dd", firstDay: 2, isRTL: false } }, leapYear: function(t3) {
          return this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear), false;
        }, monthsInYear: function(t3) {
          return this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear), 13;
        }, daysInYear: function(t3) {
          return this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear), 400;
        }, weekOfYear: function(t3, e3, r3) {
          var n3 = this.newDate(t3, e3, r3);
          return n3.add(-n3.dayOfWeek(), "d"), Math.floor((n3.dayOfYear() - 1) / 8) + 1;
        }, daysInMonth: function(t3, e3) {
          var r3 = this._validate(t3, e3, this.minDay, n2.local.invalidMonth);
          return this.daysPerMonth[r3.month() - 1];
        }, daysInWeek: function() {
          return 8;
        }, dayOfWeek: function(t3, e3, r3) {
          return (this._validate(t3, e3, r3, n2.local.invalidDate).day() + 1) % 8;
        }, weekDay: function(t3, e3, r3) {
          var n3 = this.dayOfWeek(t3, e3, r3);
          return n3 >= 2 && n3 <= 6;
        }, extraInfo: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          return { century: o[Math.floor((i2.year() - 1) / 100) + 1] || "" };
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          return t3 = i2.year() + (i2.year() < 0 ? 1 : 0), e3 = i2.month(), (r3 = i2.day()) + (e3 > 1 ? 16 : 0) + (e3 > 2 ? 32 * (e3 - 2) : 0) + 400 * (t3 - 1) + this.jdEpoch - 1;
        }, fromJD: function(t3) {
          t3 = Math.floor(t3 + 0.5) - Math.floor(this.jdEpoch) - 1;
          var e3 = Math.floor(t3 / 400) + 1;
          t3 -= 400 * (e3 - 1), t3 += t3 > 15 ? 16 : 0;
          var r3 = Math.floor(t3 / 32) + 1, n3 = t3 - 32 * (r3 - 1) + 1;
          return this.newDate(e3 <= 0 ? e3 - 1 : e3, r3, n3);
        } });
        var o = { 20: "Fruitbat", 21: "Anchovy" };
        n2.calendars.discworld = a;
      }, 37715: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131);
        function a(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        a.prototype = new n2.baseCalendar(), i(a.prototype, { name: "Ethiopian", jdEpoch: 17242205e-1, daysPerMonth: [30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 5], hasYearZero: false, minMonth: 1, firstMonth: 1, minDay: 1, regionalOptions: { "": { name: "Ethiopian", epochs: ["BEE", "EE"], monthNames: ["Meskerem", "Tikemet", "Hidar", "Tahesas", "Tir", "Yekatit", "Megabit", "Miazia", "Genbot", "Sene", "Hamle", "Nehase", "Pagume"], monthNamesShort: ["Mes", "Tik", "Hid", "Tah", "Tir", "Yek", "Meg", "Mia", "Gen", "Sen", "Ham", "Neh", "Pag"], dayNames: ["Ehud", "Segno", "Maksegno", "Irob", "Hamus", "Arb", "Kidame"], dayNamesShort: ["Ehu", "Seg", "Mak", "Iro", "Ham", "Arb", "Kid"], dayNamesMin: ["Eh", "Se", "Ma", "Ir", "Ha", "Ar", "Ki"], digits: null, dateFormat: "dd/mm/yyyy", firstDay: 0, isRTL: false } }, leapYear: function(t3) {
          var e3 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear);
          return (t3 = e3.year() + (e3.year() < 0 ? 1 : 0)) % 4 == 3 || t3 % 4 == -1;
        }, monthsInYear: function(t3) {
          return this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear || n2.regionalOptions[""].invalidYear), 13;
        }, weekOfYear: function(t3, e3, r3) {
          var n3 = this.newDate(t3, e3, r3);
          return n3.add(-n3.dayOfWeek(), "d"), Math.floor((n3.dayOfYear() - 1) / 7) + 1;
        }, daysInMonth: function(t3, e3) {
          var r3 = this._validate(t3, e3, this.minDay, n2.local.invalidMonth);
          return this.daysPerMonth[r3.month() - 1] + (13 === r3.month() && this.leapYear(r3.year()) ? 1 : 0);
        }, weekDay: function(t3, e3, r3) {
          return (this.dayOfWeek(t3, e3, r3) || 7) < 6;
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          return (t3 = i2.year()) < 0 && t3++, i2.day() + 30 * (i2.month() - 1) + 365 * (t3 - 1) + Math.floor(t3 / 4) + this.jdEpoch - 1;
        }, fromJD: function(t3) {
          var e3 = Math.floor(t3) + 0.5 - this.jdEpoch, r3 = Math.floor((e3 - Math.floor((e3 + 366) / 1461)) / 365) + 1;
          r3 <= 0 && r3--, e3 = Math.floor(t3) + 0.5 - this.newDate(r3, 1, 1).toJD();
          var n3 = Math.floor(e3 / 30) + 1, i2 = e3 - 30 * (n3 - 1) + 1;
          return this.newDate(r3, n3, i2);
        } }), n2.calendars.ethiopian = a;
      }, 99384: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131);
        function a(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        function o(t3, e3) {
          return t3 - e3 * Math.floor(t3 / e3);
        }
        a.prototype = new n2.baseCalendar(), i(a.prototype, { name: "Hebrew", jdEpoch: 347995.5, daysPerMonth: [30, 29, 30, 29, 30, 29, 30, 29, 30, 29, 30, 29, 29], hasYearZero: false, minMonth: 1, firstMonth: 7, minDay: 1, regionalOptions: { "": { name: "Hebrew", epochs: ["BAM", "AM"], monthNames: ["Nisan", "Iyar", "Sivan", "Tammuz", "Av", "Elul", "Tishrei", "Cheshvan", "Kislev", "Tevet", "Shevat", "Adar", "Adar II"], monthNamesShort: ["Nis", "Iya", "Siv", "Tam", "Av", "Elu", "Tis", "Che", "Kis", "Tev", "She", "Ada", "Ad2"], dayNames: ["Yom Rishon", "Yom Sheni", "Yom Shlishi", "Yom Revi'i", "Yom Chamishi", "Yom Shishi", "Yom Shabbat"], dayNamesShort: ["Ris", "She", "Shl", "Rev", "Cha", "Shi", "Sha"], dayNamesMin: ["Ri", "She", "Shl", "Re", "Ch", "Shi", "Sha"], digits: null, dateFormat: "dd/mm/yyyy", firstDay: 0, isRTL: false } }, leapYear: function(t3) {
          var e3 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear);
          return this._leapYear(e3.year());
        }, _leapYear: function(t3) {
          return o(7 * (t3 = t3 < 0 ? t3 + 1 : t3) + 1, 19) < 7;
        }, monthsInYear: function(t3) {
          return this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear), this._leapYear(t3.year ? t3.year() : t3) ? 13 : 12;
        }, weekOfYear: function(t3, e3, r3) {
          var n3 = this.newDate(t3, e3, r3);
          return n3.add(-n3.dayOfWeek(), "d"), Math.floor((n3.dayOfYear() - 1) / 7) + 1;
        }, daysInYear: function(t3) {
          return t3 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear).year(), this.toJD(-1 === t3 ? 1 : t3 + 1, 7, 1) - this.toJD(t3, 7, 1);
        }, daysInMonth: function(t3, e3) {
          return t3.year && (e3 = t3.month(), t3 = t3.year()), this._validate(t3, e3, this.minDay, n2.local.invalidMonth), 12 === e3 && this.leapYear(t3) || 8 === e3 && 5 === o(this.daysInYear(t3), 10) ? 30 : 9 === e3 && 3 === o(this.daysInYear(t3), 10) ? 29 : this.daysPerMonth[e3 - 1];
        }, weekDay: function(t3, e3, r3) {
          return 6 !== this.dayOfWeek(t3, e3, r3);
        }, extraInfo: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          return { yearType: (this.leapYear(i2) ? "embolismic" : "common") + " " + ["deficient", "regular", "complete"][this.daysInYear(i2) % 10 - 3] };
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          t3 = i2.year(), e3 = i2.month(), r3 = i2.day();
          var a2 = t3 <= 0 ? t3 + 1 : t3, o2 = this.jdEpoch + this._delay1(a2) + this._delay2(a2) + r3 + 1;
          if (e3 < 7) {
            for (var s = 7; s <= this.monthsInYear(t3); s++)
              o2 += this.daysInMonth(t3, s);
            for (s = 1; s < e3; s++)
              o2 += this.daysInMonth(t3, s);
          } else
            for (s = 7; s < e3; s++)
              o2 += this.daysInMonth(t3, s);
          return o2;
        }, _delay1: function(t3) {
          var e3 = Math.floor((235 * t3 - 234) / 19), r3 = 12084 + 13753 * e3, n3 = 29 * e3 + Math.floor(r3 / 25920);
          return o(3 * (n3 + 1), 7) < 3 && n3++, n3;
        }, _delay2: function(t3) {
          var e3 = this._delay1(t3 - 1), r3 = this._delay1(t3);
          return this._delay1(t3 + 1) - r3 == 356 ? 2 : r3 - e3 == 382 ? 1 : 0;
        }, fromJD: function(t3) {
          t3 = Math.floor(t3) + 0.5;
          for (var e3 = Math.floor(98496 * (t3 - this.jdEpoch) / 35975351) - 1; t3 >= this.toJD(-1 === e3 ? 1 : e3 + 1, 7, 1); )
            e3++;
          for (var r3 = t3 < this.toJD(e3, 1, 1) ? 7 : 1; t3 > this.toJD(e3, r3, this.daysInMonth(e3, r3)); )
            r3++;
          var n3 = t3 - this.toJD(e3, r3, 1) + 1;
          return this.newDate(e3, r3, n3);
        } }), n2.calendars.hebrew = a;
      }, 43805: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131);
        function a(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        a.prototype = new n2.baseCalendar(), i(a.prototype, { name: "Islamic", jdEpoch: 19484395e-1, daysPerMonth: [30, 29, 30, 29, 30, 29, 30, 29, 30, 29, 30, 29], hasYearZero: false, minMonth: 1, firstMonth: 1, minDay: 1, regionalOptions: { "": { name: "Islamic", epochs: ["BH", "AH"], monthNames: ["Muharram", "Safar", "Rabi' al-awwal", "Rabi' al-thani", "Jumada al-awwal", "Jumada al-thani", "Rajab", "Sha'aban", "Ramadan", "Shawwal", "Dhu al-Qi'dah", "Dhu al-Hijjah"], monthNamesShort: ["Muh", "Saf", "Rab1", "Rab2", "Jum1", "Jum2", "Raj", "Sha'", "Ram", "Shaw", "DhuQ", "DhuH"], dayNames: ["Yawm al-ahad", "Yawm al-ithnayn", "Yawm ath-thulaathaa'", "Yawm al-arbi'aa'", "Yawm al-khamīs", "Yawm al-jum'a", "Yawm as-sabt"], dayNamesShort: ["Aha", "Ith", "Thu", "Arb", "Kha", "Jum", "Sab"], dayNamesMin: ["Ah", "It", "Th", "Ar", "Kh", "Ju", "Sa"], digits: null, dateFormat: "yyyy/mm/dd", firstDay: 6, isRTL: false } }, leapYear: function(t3) {
          return (11 * this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear).year() + 14) % 30 < 11;
        }, weekOfYear: function(t3, e3, r3) {
          var n3 = this.newDate(t3, e3, r3);
          return n3.add(-n3.dayOfWeek(), "d"), Math.floor((n3.dayOfYear() - 1) / 7) + 1;
        }, daysInYear: function(t3) {
          return this.leapYear(t3) ? 355 : 354;
        }, daysInMonth: function(t3, e3) {
          var r3 = this._validate(t3, e3, this.minDay, n2.local.invalidMonth);
          return this.daysPerMonth[r3.month() - 1] + (12 === r3.month() && this.leapYear(r3.year()) ? 1 : 0);
        }, weekDay: function(t3, e3, r3) {
          return 5 !== this.dayOfWeek(t3, e3, r3);
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          return t3 = i2.year(), e3 = i2.month(), t3 = t3 <= 0 ? t3 + 1 : t3, (r3 = i2.day()) + Math.ceil(29.5 * (e3 - 1)) + 354 * (t3 - 1) + Math.floor((3 + 11 * t3) / 30) + this.jdEpoch - 1;
        }, fromJD: function(t3) {
          t3 = Math.floor(t3) + 0.5;
          var e3 = Math.floor((30 * (t3 - this.jdEpoch) + 10646) / 10631);
          e3 = e3 <= 0 ? e3 - 1 : e3;
          var r3 = Math.min(12, Math.ceil((t3 - 29 - this.toJD(e3, 1, 1)) / 29.5) + 1), n3 = t3 - this.toJD(e3, r3, 1) + 1;
          return this.newDate(e3, r3, n3);
        } }), n2.calendars.islamic = a;
      }, 88874: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131);
        function a(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        a.prototype = new n2.baseCalendar(), i(a.prototype, { name: "Julian", jdEpoch: 17214235e-1, daysPerMonth: [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], hasYearZero: false, minMonth: 1, firstMonth: 1, minDay: 1, regionalOptions: { "": { name: "Julian", epochs: ["BC", "AD"], monthNames: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthNamesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayNames: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayNamesShort: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], dayNamesMin: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"], digits: null, dateFormat: "mm/dd/yyyy", firstDay: 0, isRTL: false } }, leapYear: function(t3) {
          var e3 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear);
          return (t3 = e3.year() < 0 ? e3.year() + 1 : e3.year()) % 4 == 0;
        }, weekOfYear: function(t3, e3, r3) {
          var n3 = this.newDate(t3, e3, r3);
          return n3.add(4 - (n3.dayOfWeek() || 7), "d"), Math.floor((n3.dayOfYear() - 1) / 7) + 1;
        }, daysInMonth: function(t3, e3) {
          var r3 = this._validate(t3, e3, this.minDay, n2.local.invalidMonth);
          return this.daysPerMonth[r3.month() - 1] + (2 === r3.month() && this.leapYear(r3.year()) ? 1 : 0);
        }, weekDay: function(t3, e3, r3) {
          return (this.dayOfWeek(t3, e3, r3) || 7) < 6;
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          return t3 = i2.year(), e3 = i2.month(), r3 = i2.day(), t3 < 0 && t3++, e3 <= 2 && (t3--, e3 += 12), Math.floor(365.25 * (t3 + 4716)) + Math.floor(30.6001 * (e3 + 1)) + r3 - 1524.5;
        }, fromJD: function(t3) {
          var e3 = Math.floor(t3 + 0.5) + 1524, r3 = Math.floor((e3 - 122.1) / 365.25), n3 = Math.floor(365.25 * r3), i2 = Math.floor((e3 - n3) / 30.6001), a2 = i2 - Math.floor(i2 < 14 ? 1 : 13), o = r3 - Math.floor(a2 > 2 ? 4716 : 4715), s = e3 - n3 - Math.floor(30.6001 * i2);
          return o <= 0 && o--, this.newDate(o, a2, s);
        } }), n2.calendars.julian = a;
      }, 83290: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131);
        function a(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        function o(t3, e3) {
          return t3 - e3 * Math.floor(t3 / e3);
        }
        function s(t3, e3) {
          return o(t3 - 1, e3) + 1;
        }
        a.prototype = new n2.baseCalendar(), i(a.prototype, { name: "Mayan", jdEpoch: 584282.5, hasYearZero: true, minMonth: 0, firstMonth: 0, minDay: 0, regionalOptions: { "": { name: "Mayan", epochs: ["", ""], monthNames: ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17"], monthNamesShort: ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17"], dayNames: ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19"], dayNamesShort: ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19"], dayNamesMin: ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19"], digits: null, dateFormat: "YYYY.m.d", firstDay: 0, isRTL: false, haabMonths: ["Pop", "Uo", "Zip", "Zotz", "Tzec", "Xul", "Yaxkin", "Mol", "Chen", "Yax", "Zac", "Ceh", "Mac", "Kankin", "Muan", "Pax", "Kayab", "Cumku", "Uayeb"], tzolkinMonths: ["Imix", "Ik", "Akbal", "Kan", "Chicchan", "Cimi", "Manik", "Lamat", "Muluc", "Oc", "Chuen", "Eb", "Ben", "Ix", "Men", "Cib", "Caban", "Etznab", "Cauac", "Ahau"] } }, leapYear: function(t3) {
          return this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear), false;
        }, formatYear: function(t3) {
          t3 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear).year();
          var e3 = Math.floor(t3 / 400);
          return t3 %= 400, t3 += t3 < 0 ? 400 : 0, e3 + "." + Math.floor(t3 / 20) + "." + t3 % 20;
        }, forYear: function(t3) {
          if ((t3 = t3.split(".")).length < 3)
            throw "Invalid Mayan year";
          for (var e3 = 0, r3 = 0; r3 < t3.length; r3++) {
            var n3 = parseInt(t3[r3], 10);
            if (Math.abs(n3) > 19 || r3 > 0 && n3 < 0)
              throw "Invalid Mayan year";
            e3 = 20 * e3 + n3;
          }
          return e3;
        }, monthsInYear: function(t3) {
          return this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear), 18;
        }, weekOfYear: function(t3, e3, r3) {
          return this._validate(t3, e3, r3, n2.local.invalidDate), 0;
        }, daysInYear: function(t3) {
          return this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear), 360;
        }, daysInMonth: function(t3, e3) {
          return this._validate(t3, e3, this.minDay, n2.local.invalidMonth), 20;
        }, daysInWeek: function() {
          return 5;
        }, dayOfWeek: function(t3, e3, r3) {
          return this._validate(t3, e3, r3, n2.local.invalidDate).day();
        }, weekDay: function(t3, e3, r3) {
          return this._validate(t3, e3, r3, n2.local.invalidDate), true;
        }, extraInfo: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate).toJD(), a2 = this._toHaab(i2), o2 = this._toTzolkin(i2);
          return { haabMonthName: this.local.haabMonths[a2[0] - 1], haabMonth: a2[0], haabDay: a2[1], tzolkinDayName: this.local.tzolkinMonths[o2[0] - 1], tzolkinDay: o2[0], tzolkinTrecena: o2[1] };
        }, _toHaab: function(t3) {
          var e3 = o(8 + (t3 -= this.jdEpoch) + 340, 365);
          return [Math.floor(e3 / 20) + 1, o(e3, 20)];
        }, _toTzolkin: function(t3) {
          return [s(20 + (t3 -= this.jdEpoch), 20), s(t3 + 4, 13)];
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          return i2.day() + 20 * i2.month() + 360 * i2.year() + this.jdEpoch;
        }, fromJD: function(t3) {
          t3 = Math.floor(t3) + 0.5 - this.jdEpoch;
          var e3 = Math.floor(t3 / 360);
          t3 %= 360, t3 += t3 < 0 ? 360 : 0;
          var r3 = Math.floor(t3 / 20), n3 = t3 % 20;
          return this.newDate(e3, r3, n3);
        } }), n2.calendars.mayan = a;
      }, 29108: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131);
        function a(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        a.prototype = new n2.baseCalendar();
        var o = n2.instance("gregorian");
        i(a.prototype, { name: "Nanakshahi", jdEpoch: 22576735e-1, daysPerMonth: [31, 31, 31, 31, 31, 30, 30, 30, 30, 30, 30, 30], hasYearZero: false, minMonth: 1, firstMonth: 1, minDay: 1, regionalOptions: { "": { name: "Nanakshahi", epochs: ["BN", "AN"], monthNames: ["Chet", "Vaisakh", "Jeth", "Harh", "Sawan", "Bhadon", "Assu", "Katak", "Maghar", "Poh", "Magh", "Phagun"], monthNamesShort: ["Che", "Vai", "Jet", "Har", "Saw", "Bha", "Ass", "Kat", "Mgr", "Poh", "Mgh", "Pha"], dayNames: ["Somvaar", "Mangalvar", "Budhvaar", "Veervaar", "Shukarvaar", "Sanicharvaar", "Etvaar"], dayNamesShort: ["Som", "Mangal", "Budh", "Veer", "Shukar", "Sanichar", "Et"], dayNamesMin: ["So", "Ma", "Bu", "Ve", "Sh", "Sa", "Et"], digits: null, dateFormat: "dd-mm-yyyy", firstDay: 0, isRTL: false } }, leapYear: function(t3) {
          var e3 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear || n2.regionalOptions[""].invalidYear);
          return o.leapYear(e3.year() + (e3.year() < 1 ? 1 : 0) + 1469);
        }, weekOfYear: function(t3, e3, r3) {
          var n3 = this.newDate(t3, e3, r3);
          return n3.add(1 - (n3.dayOfWeek() || 7), "d"), Math.floor((n3.dayOfYear() - 1) / 7) + 1;
        }, daysInMonth: function(t3, e3) {
          var r3 = this._validate(t3, e3, this.minDay, n2.local.invalidMonth);
          return this.daysPerMonth[r3.month() - 1] + (12 === r3.month() && this.leapYear(r3.year()) ? 1 : 0);
        }, weekDay: function(t3, e3, r3) {
          return (this.dayOfWeek(t3, e3, r3) || 7) < 6;
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidMonth);
          (t3 = i2.year()) < 0 && t3++;
          for (var a2 = i2.day(), s = 1; s < i2.month(); s++)
            a2 += this.daysPerMonth[s - 1];
          return a2 + o.toJD(t3 + 1468, 3, 13);
        }, fromJD: function(t3) {
          t3 = Math.floor(t3 + 0.5);
          for (var e3 = Math.floor((t3 - (this.jdEpoch - 1)) / 366); t3 >= this.toJD(e3 + 1, 1, 1); )
            e3++;
          for (var r3 = t3 - Math.floor(this.toJD(e3, 1, 1) + 0.5) + 1, n3 = 1; r3 > this.daysInMonth(e3, n3); )
            r3 -= this.daysInMonth(e3, n3), n3++;
          return this.newDate(e3, n3, r3);
        } }), n2.calendars.nanakshahi = a;
      }, 55422: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131);
        function a(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        a.prototype = new n2.baseCalendar(), i(a.prototype, { name: "Nepali", jdEpoch: 17007095e-1, daysPerMonth: [31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], hasYearZero: false, minMonth: 1, firstMonth: 1, minDay: 1, daysPerYear: 365, regionalOptions: { "": { name: "Nepali", epochs: ["BBS", "ABS"], monthNames: ["Baisakh", "Jestha", "Ashadh", "Shrawan", "Bhadra", "Ashwin", "Kartik", "Mangsir", "Paush", "Mangh", "Falgun", "Chaitra"], monthNamesShort: ["Bai", "Je", "As", "Shra", "Bha", "Ash", "Kar", "Mang", "Pau", "Ma", "Fal", "Chai"], dayNames: ["Aaitabaar", "Sombaar", "Manglbaar", "Budhabaar", "Bihibaar", "Shukrabaar", "Shanibaar"], dayNamesShort: ["Aaita", "Som", "Mangl", "Budha", "Bihi", "Shukra", "Shani"], dayNamesMin: ["Aai", "So", "Man", "Bu", "Bi", "Shu", "Sha"], digits: null, dateFormat: "dd/mm/yyyy", firstDay: 1, isRTL: false } }, leapYear: function(t3) {
          return this.daysInYear(t3) !== this.daysPerYear;
        }, weekOfYear: function(t3, e3, r3) {
          var n3 = this.newDate(t3, e3, r3);
          return n3.add(-n3.dayOfWeek(), "d"), Math.floor((n3.dayOfYear() - 1) / 7) + 1;
        }, daysInYear: function(t3) {
          if (t3 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear).year(), void 0 === this.NEPALI_CALENDAR_DATA[t3])
            return this.daysPerYear;
          for (var e3 = 0, r3 = this.minMonth; r3 <= 12; r3++)
            e3 += this.NEPALI_CALENDAR_DATA[t3][r3];
          return e3;
        }, daysInMonth: function(t3, e3) {
          return t3.year && (e3 = t3.month(), t3 = t3.year()), this._validate(t3, e3, this.minDay, n2.local.invalidMonth), void 0 === this.NEPALI_CALENDAR_DATA[t3] ? this.daysPerMonth[e3 - 1] : this.NEPALI_CALENDAR_DATA[t3][e3];
        }, weekDay: function(t3, e3, r3) {
          return 6 !== this.dayOfWeek(t3, e3, r3);
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          t3 = i2.year(), e3 = i2.month(), r3 = i2.day();
          var a2 = n2.instance(), o = 0, s = e3, l = t3;
          this._createMissingCalendarData(t3);
          var u = t3 - (s > 9 || 9 === s && r3 >= this.NEPALI_CALENDAR_DATA[l][0] ? 56 : 57);
          for (9 !== e3 && (o = r3, s--); 9 !== s; )
            s <= 0 && (s = 12, l--), o += this.NEPALI_CALENDAR_DATA[l][s], s--;
          return 9 === e3 ? (o += r3 - this.NEPALI_CALENDAR_DATA[l][0]) < 0 && (o += a2.daysInYear(u)) : o += this.NEPALI_CALENDAR_DATA[l][9] - this.NEPALI_CALENDAR_DATA[l][0], a2.newDate(u, 1, 1).add(o, "d").toJD();
        }, fromJD: function(t3) {
          var e3 = n2.instance().fromJD(t3), r3 = e3.year(), i2 = e3.dayOfYear(), a2 = r3 + 56;
          this._createMissingCalendarData(a2);
          for (var o = 9, s = this.NEPALI_CALENDAR_DATA[a2][0], l = this.NEPALI_CALENDAR_DATA[a2][o] - s + 1; i2 > l; )
            ++o > 12 && (o = 1, a2++), l += this.NEPALI_CALENDAR_DATA[a2][o];
          var u = this.NEPALI_CALENDAR_DATA[a2][o] - (l - i2);
          return this.newDate(a2, o, u);
        }, _createMissingCalendarData: function(t3) {
          var e3 = this.daysPerMonth.slice(0);
          e3.unshift(17);
          for (var r3 = t3 - 1; r3 < t3 + 2; r3++)
            void 0 === this.NEPALI_CALENDAR_DATA[r3] && (this.NEPALI_CALENDAR_DATA[r3] = e3);
        }, NEPALI_CALENDAR_DATA: { 1970: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 1971: [18, 31, 31, 32, 31, 32, 30, 30, 29, 30, 29, 30, 30], 1972: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 30], 1973: [19, 30, 32, 31, 32, 31, 30, 30, 30, 29, 30, 29, 31], 1974: [19, 31, 31, 32, 30, 31, 31, 30, 29, 30, 29, 30, 30], 1975: [18, 31, 31, 32, 32, 30, 31, 30, 29, 30, 29, 30, 30], 1976: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 1977: [18, 31, 32, 31, 32, 31, 31, 29, 30, 29, 30, 29, 31], 1978: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 1979: [18, 31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 1980: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 1981: [18, 31, 31, 31, 32, 31, 31, 29, 30, 30, 29, 30, 30], 1982: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 1983: [18, 31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 1984: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 1985: [18, 31, 31, 31, 32, 31, 31, 29, 30, 30, 29, 30, 30], 1986: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 1987: [18, 31, 32, 31, 32, 31, 30, 30, 29, 30, 29, 30, 30], 1988: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 1989: [18, 31, 31, 31, 32, 31, 31, 30, 29, 30, 29, 30, 30], 1990: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 1991: [18, 31, 32, 31, 32, 31, 30, 30, 29, 30, 29, 30, 30], 1992: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 29, 31], 1993: [18, 31, 31, 31, 32, 31, 31, 30, 29, 30, 29, 30, 30], 1994: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 1995: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 30], 1996: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 29, 31], 1997: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 1998: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 1999: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2e3: [17, 30, 32, 31, 32, 31, 30, 30, 30, 29, 30, 29, 31], 2001: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2002: [18, 31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2003: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2004: [17, 30, 32, 31, 32, 31, 30, 30, 30, 29, 30, 29, 31], 2005: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2006: [18, 31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2007: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2008: [17, 31, 31, 31, 32, 31, 31, 29, 30, 30, 29, 29, 31], 2009: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2010: [18, 31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2011: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2012: [17, 31, 31, 31, 32, 31, 31, 29, 30, 30, 29, 30, 30], 2013: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2014: [18, 31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2015: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2016: [17, 31, 31, 31, 32, 31, 31, 29, 30, 30, 29, 30, 30], 2017: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2018: [18, 31, 32, 31, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2019: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 29, 31], 2020: [17, 31, 31, 31, 32, 31, 31, 30, 29, 30, 29, 30, 30], 2021: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2022: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 30], 2023: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 29, 31], 2024: [17, 31, 31, 31, 32, 31, 31, 30, 29, 30, 29, 30, 30], 2025: [18, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2026: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2027: [17, 30, 32, 31, 32, 31, 30, 30, 30, 29, 30, 29, 31], 2028: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2029: [18, 31, 31, 32, 31, 32, 30, 30, 29, 30, 29, 30, 30], 2030: [17, 31, 32, 31, 32, 31, 30, 30, 30, 30, 30, 30, 31], 2031: [17, 31, 32, 31, 32, 31, 31, 31, 31, 31, 31, 31, 31], 2032: [17, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32, 32], 2033: [18, 31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2034: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2035: [17, 30, 32, 31, 32, 31, 31, 29, 30, 30, 29, 29, 31], 2036: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2037: [18, 31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2038: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2039: [17, 31, 31, 31, 32, 31, 31, 29, 30, 30, 29, 30, 30], 2040: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2041: [18, 31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2042: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2043: [17, 31, 31, 31, 32, 31, 31, 29, 30, 30, 29, 30, 30], 2044: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2045: [18, 31, 32, 31, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2046: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2047: [17, 31, 31, 31, 32, 31, 31, 30, 29, 30, 29, 30, 30], 2048: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2049: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 30], 2050: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 29, 31], 2051: [17, 31, 31, 31, 32, 31, 31, 30, 29, 30, 29, 30, 30], 2052: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2053: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 30], 2054: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 29, 31], 2055: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 30, 29, 30], 2056: [17, 31, 31, 32, 31, 32, 30, 30, 29, 30, 29, 30, 30], 2057: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2058: [17, 30, 32, 31, 32, 31, 30, 30, 30, 29, 30, 29, 31], 2059: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2060: [17, 31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2061: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2062: [17, 30, 32, 31, 32, 31, 31, 29, 30, 29, 30, 29, 31], 2063: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2064: [17, 31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2065: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2066: [17, 31, 31, 31, 32, 31, 31, 29, 30, 30, 29, 29, 31], 2067: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2068: [17, 31, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2069: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2070: [17, 31, 31, 31, 32, 31, 31, 29, 30, 30, 29, 30, 30], 2071: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2072: [17, 31, 32, 31, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2073: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 31], 2074: [17, 31, 31, 31, 32, 31, 31, 30, 29, 30, 29, 30, 30], 2075: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2076: [16, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 30], 2077: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 29, 31], 2078: [17, 31, 31, 31, 32, 31, 31, 30, 29, 30, 29, 30, 30], 2079: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 29, 30, 30], 2080: [16, 31, 32, 31, 32, 31, 30, 30, 30, 29, 29, 30, 30], 2081: [17, 31, 31, 32, 32, 31, 30, 30, 30, 29, 30, 30, 30], 2082: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 30, 30], 2083: [17, 31, 31, 32, 31, 31, 30, 30, 30, 29, 30, 30, 30], 2084: [17, 31, 31, 32, 31, 31, 30, 30, 30, 29, 30, 30, 30], 2085: [17, 31, 32, 31, 32, 31, 31, 30, 30, 29, 30, 30, 30], 2086: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 30, 30], 2087: [16, 31, 31, 32, 31, 31, 31, 30, 30, 29, 30, 30, 30], 2088: [16, 30, 31, 32, 32, 30, 31, 30, 30, 29, 30, 30, 30], 2089: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 30, 30], 2090: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 30, 30], 2091: [16, 31, 31, 32, 31, 31, 31, 30, 30, 29, 30, 30, 30], 2092: [16, 31, 31, 32, 32, 31, 30, 30, 30, 29, 30, 30, 30], 2093: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 30, 30], 2094: [17, 31, 31, 32, 31, 31, 30, 30, 30, 29, 30, 30, 30], 2095: [17, 31, 31, 32, 31, 31, 31, 30, 29, 30, 30, 30, 30], 2096: [17, 30, 31, 32, 32, 31, 30, 30, 29, 30, 29, 30, 30], 2097: [17, 31, 32, 31, 32, 31, 30, 30, 30, 29, 30, 30, 30], 2098: [17, 31, 31, 32, 31, 31, 31, 29, 30, 29, 30, 30, 31], 2099: [17, 31, 31, 32, 31, 31, 31, 30, 29, 29, 30, 30, 30], 2100: [17, 31, 32, 31, 32, 30, 31, 30, 29, 30, 29, 30, 30] } }), n2.calendars.nepali = a;
      }, 94320: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131);
        function a(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        function o(t3, e3) {
          return t3 - e3 * Math.floor(t3 / e3);
        }
        a.prototype = new n2.baseCalendar(), i(a.prototype, { name: "Persian", jdEpoch: 19483205e-1, daysPerMonth: [31, 31, 31, 31, 31, 31, 30, 30, 30, 30, 30, 29], hasYearZero: false, minMonth: 1, firstMonth: 1, minDay: 1, regionalOptions: { "": { name: "Persian", epochs: ["BP", "AP"], monthNames: ["Farvardin", "Ordibehesht", "Khordad", "Tir", "Mordad", "Shahrivar", "Mehr", "Aban", "Azar", "Day", "Bahman", "Esfand"], monthNamesShort: ["Far", "Ord", "Kho", "Tir", "Mor", "Sha", "Meh", "Aba", "Aza", "Day", "Bah", "Esf"], dayNames: ["Yekshambe", "Doshambe", "Seshambe", "Chæharshambe", "Panjshambe", "Jom'e", "Shambe"], dayNamesShort: ["Yek", "Do", "Se", "Chæ", "Panj", "Jom", "Sha"], dayNamesMin: ["Ye", "Do", "Se", "Ch", "Pa", "Jo", "Sh"], digits: null, dateFormat: "yyyy/mm/dd", firstDay: 6, isRTL: false } }, leapYear: function(t3) {
          var e3 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear);
          return 682 * ((e3.year() - (e3.year() > 0 ? 474 : 473)) % 2820 + 474 + 38) % 2816 < 682;
        }, weekOfYear: function(t3, e3, r3) {
          var n3 = this.newDate(t3, e3, r3);
          return n3.add(-(n3.dayOfWeek() + 1) % 7, "d"), Math.floor((n3.dayOfYear() - 1) / 7) + 1;
        }, daysInMonth: function(t3, e3) {
          var r3 = this._validate(t3, e3, this.minDay, n2.local.invalidMonth);
          return this.daysPerMonth[r3.month() - 1] + (12 === r3.month() && this.leapYear(r3.year()) ? 1 : 0);
        }, weekDay: function(t3, e3, r3) {
          return 5 !== this.dayOfWeek(t3, e3, r3);
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          t3 = i2.year(), e3 = i2.month(), r3 = i2.day();
          var a2 = t3 - (t3 >= 0 ? 474 : 473), s = 474 + o(a2, 2820);
          return r3 + (e3 <= 7 ? 31 * (e3 - 1) : 30 * (e3 - 1) + 6) + Math.floor((682 * s - 110) / 2816) + 365 * (s - 1) + 1029983 * Math.floor(a2 / 2820) + this.jdEpoch - 1;
        }, fromJD: function(t3) {
          var e3 = (t3 = Math.floor(t3) + 0.5) - this.toJD(475, 1, 1), r3 = Math.floor(e3 / 1029983), n3 = o(e3, 1029983), i2 = 2820;
          if (1029982 !== n3) {
            var a2 = Math.floor(n3 / 366), s = o(n3, 366);
            i2 = Math.floor((2134 * a2 + 2816 * s + 2815) / 1028522) + a2 + 1;
          }
          var l = i2 + 2820 * r3 + 474;
          l = l <= 0 ? l - 1 : l;
          var u = t3 - this.toJD(l, 1, 1) + 1, c = u <= 186 ? Math.ceil(u / 31) : Math.ceil((u - 6) / 30), f2 = t3 - this.toJD(l, c, 1) + 1;
          return this.newDate(l, c, f2);
        } }), n2.calendars.persian = a, n2.calendars.jalali = a;
      }, 31320: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131), a = n2.instance();
        function o(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        o.prototype = new n2.baseCalendar(), i(o.prototype, { name: "Taiwan", jdEpoch: 24194025e-1, yearsOffset: 1911, daysPerMonth: [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], hasYearZero: false, minMonth: 1, firstMonth: 1, minDay: 1, regionalOptions: { "": { name: "Taiwan", epochs: ["BROC", "ROC"], monthNames: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthNamesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayNames: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayNamesShort: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], dayNamesMin: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"], digits: null, dateFormat: "yyyy/mm/dd", firstDay: 1, isRTL: false } }, leapYear: function(t3) {
          var e3 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear);
          return t3 = this._t2gYear(e3.year()), a.leapYear(t3);
        }, weekOfYear: function(t3, e3, r3) {
          var i2 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear);
          return t3 = this._t2gYear(i2.year()), a.weekOfYear(t3, i2.month(), i2.day());
        }, daysInMonth: function(t3, e3) {
          var r3 = this._validate(t3, e3, this.minDay, n2.local.invalidMonth);
          return this.daysPerMonth[r3.month() - 1] + (2 === r3.month() && this.leapYear(r3.year()) ? 1 : 0);
        }, weekDay: function(t3, e3, r3) {
          return (this.dayOfWeek(t3, e3, r3) || 7) < 6;
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          return t3 = this._t2gYear(i2.year()), a.toJD(t3, i2.month(), i2.day());
        }, fromJD: function(t3) {
          var e3 = a.fromJD(t3), r3 = this._g2tYear(e3.year());
          return this.newDate(r3, e3.month(), e3.day());
        }, _t2gYear: function(t3) {
          return t3 + this.yearsOffset + (t3 >= -this.yearsOffset && t3 <= -1 ? 1 : 0);
        }, _g2tYear: function(t3) {
          return t3 - this.yearsOffset - (t3 >= 1 && t3 <= this.yearsOffset ? 1 : 0);
        } }), n2.calendars.taiwan = o;
      }, 51367: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131), a = n2.instance();
        function o(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        o.prototype = new n2.baseCalendar(), i(o.prototype, { name: "Thai", jdEpoch: 15230985e-1, yearsOffset: 543, daysPerMonth: [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], hasYearZero: false, minMonth: 1, firstMonth: 1, minDay: 1, regionalOptions: { "": { name: "Thai", epochs: ["BBE", "BE"], monthNames: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthNamesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayNames: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayNamesShort: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], dayNamesMin: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"], digits: null, dateFormat: "dd/mm/yyyy", firstDay: 0, isRTL: false } }, leapYear: function(t3) {
          var e3 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear);
          return t3 = this._t2gYear(e3.year()), a.leapYear(t3);
        }, weekOfYear: function(t3, e3, r3) {
          var i2 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear);
          return t3 = this._t2gYear(i2.year()), a.weekOfYear(t3, i2.month(), i2.day());
        }, daysInMonth: function(t3, e3) {
          var r3 = this._validate(t3, e3, this.minDay, n2.local.invalidMonth);
          return this.daysPerMonth[r3.month() - 1] + (2 === r3.month() && this.leapYear(r3.year()) ? 1 : 0);
        }, weekDay: function(t3, e3, r3) {
          return (this.dayOfWeek(t3, e3, r3) || 7) < 6;
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate);
          return t3 = this._t2gYear(i2.year()), a.toJD(t3, i2.month(), i2.day());
        }, fromJD: function(t3) {
          var e3 = a.fromJD(t3), r3 = this._g2tYear(e3.year());
          return this.newDate(r3, e3.month(), e3.day());
        }, _t2gYear: function(t3) {
          return t3 - this.yearsOffset - (t3 >= 1 && t3 <= this.yearsOffset ? 1 : 0);
        }, _g2tYear: function(t3) {
          return t3 + this.yearsOffset + (t3 >= -this.yearsOffset && t3 <= -1 ? 1 : 0);
        } }), n2.calendars.thai = o;
      }, 21457: function(t2, e2, r2) {
        var n2 = r2(63489), i = r2(56131);
        function a(t3) {
          this.local = this.regionalOptions[t3 || ""] || this.regionalOptions[""];
        }
        a.prototype = new n2.baseCalendar(), i(a.prototype, { name: "UmmAlQura", hasYearZero: false, minMonth: 1, firstMonth: 1, minDay: 1, regionalOptions: { "": { name: "Umm al-Qura", epochs: ["BH", "AH"], monthNames: ["Al-Muharram", "Safar", "Rabi' al-awwal", "Rabi' Al-Thani", "Jumada Al-Awwal", "Jumada Al-Thani", "Rajab", "Sha'aban", "Ramadan", "Shawwal", "Dhu al-Qi'dah", "Dhu al-Hijjah"], monthNamesShort: ["Muh", "Saf", "Rab1", "Rab2", "Jum1", "Jum2", "Raj", "Sha'", "Ram", "Shaw", "DhuQ", "DhuH"], dayNames: ["Yawm al-Ahad", "Yawm al-Ithnain", "Yawm al-Thalāthā’", "Yawm al-Arba‘ā’", "Yawm al-Khamīs", "Yawm al-Jum‘a", "Yawm al-Sabt"], dayNamesMin: ["Ah", "Ith", "Th", "Ar", "Kh", "Ju", "Sa"], digits: null, dateFormat: "yyyy/mm/dd", firstDay: 6, isRTL: true } }, leapYear: function(t3) {
          var e3 = this._validate(t3, this.minMonth, this.minDay, n2.local.invalidYear);
          return 355 === this.daysInYear(e3.year());
        }, weekOfYear: function(t3, e3, r3) {
          var n3 = this.newDate(t3, e3, r3);
          return n3.add(-n3.dayOfWeek(), "d"), Math.floor((n3.dayOfYear() - 1) / 7) + 1;
        }, daysInYear: function(t3) {
          for (var e3 = 0, r3 = 1; r3 <= 12; r3++)
            e3 += this.daysInMonth(t3, r3);
          return e3;
        }, daysInMonth: function(t3, e3) {
          for (var r3 = this._validate(t3, e3, this.minDay, n2.local.invalidMonth).toJD() - 24e5 + 0.5, i2 = 0, a2 = 0; a2 < o.length; a2++) {
            if (o[a2] > r3)
              return o[i2] - o[i2 - 1];
            i2++;
          }
          return 30;
        }, weekDay: function(t3, e3, r3) {
          return 5 !== this.dayOfWeek(t3, e3, r3);
        }, toJD: function(t3, e3, r3) {
          var i2 = this._validate(t3, e3, r3, n2.local.invalidDate), a2 = 12 * (i2.year() - 1) + i2.month() - 15292;
          return i2.day() + o[a2 - 1] - 1 + 24e5 - 0.5;
        }, fromJD: function(t3) {
          for (var e3 = t3 - 24e5 + 0.5, r3 = 0, n3 = 0; n3 < o.length && !(o[n3] > e3); n3++)
            r3++;
          var i2 = r3 + 15292, a2 = Math.floor((i2 - 1) / 12), s = a2 + 1, l = i2 - 12 * a2, u = e3 - o[r3 - 1] + 1;
          return this.newDate(s, l, u);
        }, isValid: function(t3, e3, r3) {
          var i2 = n2.baseCalendar.prototype.isValid.apply(this, arguments);
          return i2 && (i2 = (t3 = null != t3.year ? t3.year : t3) >= 1276 && t3 <= 1500), i2;
        }, _validate: function(t3, e3, r3, i2) {
          var a2 = n2.baseCalendar.prototype._validate.apply(this, arguments);
          if (a2.year < 1276 || a2.year > 1500)
            throw i2.replace(/\{0\}/, this.local.name);
          return a2;
        } }), n2.calendars.ummalqura = a;
        var o = [20, 50, 79, 109, 138, 168, 197, 227, 256, 286, 315, 345, 374, 404, 433, 463, 492, 522, 551, 581, 611, 641, 670, 700, 729, 759, 788, 818, 847, 877, 906, 936, 965, 995, 1024, 1054, 1083, 1113, 1142, 1172, 1201, 1231, 1260, 1290, 1320, 1350, 1379, 1409, 1438, 1468, 1497, 1527, 1556, 1586, 1615, 1645, 1674, 1704, 1733, 1763, 1792, 1822, 1851, 1881, 1910, 1940, 1969, 1999, 2028, 2058, 2087, 2117, 2146, 2176, 2205, 2235, 2264, 2294, 2323, 2353, 2383, 2413, 2442, 2472, 2501, 2531, 2560, 2590, 2619, 2649, 2678, 2708, 2737, 2767, 2796, 2826, 2855, 2885, 2914, 2944, 2973, 3003, 3032, 3062, 3091, 3121, 3150, 3180, 3209, 3239, 3268, 3298, 3327, 3357, 3386, 3416, 3446, 3476, 3505, 3535, 3564, 3594, 3623, 3653, 3682, 3712, 3741, 3771, 3800, 3830, 3859, 3889, 3918, 3948, 3977, 4007, 4036, 4066, 4095, 4125, 4155, 4185, 4214, 4244, 4273, 4303, 4332, 4362, 4391, 4421, 4450, 4480, 4509, 4539, 4568, 4598, 4627, 4657, 4686, 4716, 4745, 4775, 4804, 4834, 4863, 4893, 4922, 4952, 4981, 5011, 5040, 5070, 5099, 5129, 5158, 5188, 5218, 5248, 5277, 5307, 5336, 5366, 5395, 5425, 5454, 5484, 5513, 5543, 5572, 5602, 5631, 5661, 5690, 5720, 5749, 5779, 5808, 5838, 5867, 5897, 5926, 5956, 5985, 6015, 6044, 6074, 6103, 6133, 6162, 6192, 6221, 6251, 6281, 6311, 6340, 6370, 6399, 6429, 6458, 6488, 6517, 6547, 6576, 6606, 6635, 6665, 6694, 6724, 6753, 6783, 6812, 6842, 6871, 6901, 6930, 6960, 6989, 7019, 7048, 7078, 7107, 7137, 7166, 7196, 7225, 7255, 7284, 7314, 7344, 7374, 7403, 7433, 7462, 7492, 7521, 7551, 7580, 7610, 7639, 7669, 7698, 7728, 7757, 7787, 7816, 7846, 7875, 7905, 7934, 7964, 7993, 8023, 8053, 8083, 8112, 8142, 8171, 8201, 8230, 8260, 8289, 8319, 8348, 8378, 8407, 8437, 8466, 8496, 8525, 8555, 8584, 8614, 8643, 8673, 8702, 8732, 8761, 8791, 8821, 8850, 8880, 8909, 8938, 8968, 8997, 9027, 9056, 9086, 9115, 9145, 9175, 9205, 9234, 9264, 9293, 9322, 9352, 9381, 9410, 9440, 9470, 9499, 9529, 9559, 9589, 9618, 9648, 9677, 9706, 9736, 9765, 9794, 9824, 9853, 9883, 9913, 9943, 9972, 10002, 10032, 10061, 10090, 10120, 10149, 10178, 10208, 10237, 10267, 10297, 10326, 10356, 10386, 10415, 10445, 10474, 10504, 10533, 10562, 10592, 10621, 10651, 10680, 10710, 10740, 10770, 10799, 10829, 10858, 10888, 10917, 10947, 10976, 11005, 11035, 11064, 11094, 11124, 11153, 11183, 11213, 11242, 11272, 11301, 11331, 11360, 11389, 11419, 11448, 11478, 11507, 11537, 11567, 11596, 11626, 11655, 11685, 11715, 11744, 11774, 11803, 11832, 11862, 11891, 11921, 11950, 11980, 12010, 12039, 12069, 12099, 12128, 12158, 12187, 12216, 12246, 12275, 12304, 12334, 12364, 12393, 12423, 12453, 12483, 12512, 12542, 12571, 12600, 12630, 12659, 12688, 12718, 12747, 12777, 12807, 12837, 12866, 12896, 12926, 12955, 12984, 13014, 13043, 13072, 13102, 13131, 13161, 13191, 13220, 13250, 13280, 13310, 13339, 13368, 13398, 13427, 13456, 13486, 13515, 13545, 13574, 13604, 13634, 13664, 13693, 13723, 13752, 13782, 13811, 13840, 13870, 13899, 13929, 13958, 13988, 14018, 14047, 14077, 14107, 14136, 14166, 14195, 14224, 14254, 14283, 14313, 14342, 14372, 14401, 14431, 14461, 14490, 14520, 14550, 14579, 14609, 14638, 14667, 14697, 14726, 14756, 14785, 14815, 14844, 14874, 14904, 14933, 14963, 14993, 15021, 15051, 15081, 15110, 15140, 15169, 15199, 15228, 15258, 15287, 15317, 15347, 15377, 15406, 15436, 15465, 15494, 15524, 15553, 15582, 15612, 15641, 15671, 15701, 15731, 15760, 15790, 15820, 15849, 15878, 15908, 15937, 15966, 15996, 16025, 16055, 16085, 16114, 16144, 16174, 16204, 16233, 16262, 16292, 16321, 16350, 16380, 16409, 16439, 16468, 16498, 16528, 16558, 16587, 16617, 16646, 16676, 16705, 16734, 16764, 16793, 16823, 16852, 16882, 16912, 16941, 16971, 17001, 17030, 17060, 17089, 17118, 17148, 17177, 17207, 17236, 17266, 17295, 17325, 17355, 17384, 17414, 17444, 17473, 17502, 17532, 17561, 17591, 17620, 17650, 17679, 17709, 17738, 17768, 17798, 17827, 17857, 17886, 17916, 17945, 17975, 18004, 18034, 18063, 18093, 18122, 18152, 18181, 18211, 18241, 18270, 18300, 18330, 18359, 18388, 18418, 18447, 18476, 18506, 18535, 18565, 18595, 18625, 18654, 18684, 18714, 18743, 18772, 18802, 18831, 18860, 18890, 18919, 18949, 18979, 19008, 19038, 19068, 19098, 19127, 19156, 19186, 19215, 19244, 19274, 19303, 19333, 19362, 19392, 19422, 19452, 19481, 19511, 19540, 19570, 19599, 19628, 19658, 19687, 19717, 19746, 19776, 19806, 19836, 19865, 19895, 19924, 19954, 19983, 20012, 20042, 20071, 20101, 20130, 20160, 20190, 20219, 20249, 20279, 20308, 20338, 20367, 20396, 20426, 20455, 20485, 20514, 20544, 20573, 20603, 20633, 20662, 20692, 20721, 20751, 20780, 20810, 20839, 20869, 20898, 20928, 20957, 20987, 21016, 21046, 21076, 21105, 21135, 21164, 21194, 21223, 21253, 21282, 21312, 21341, 21371, 21400, 21430, 21459, 21489, 21519, 21548, 21578, 21607, 21637, 21666, 21696, 21725, 21754, 21784, 21813, 21843, 21873, 21902, 21932, 21962, 21991, 22021, 22050, 22080, 22109, 22138, 22168, 22197, 22227, 22256, 22286, 22316, 22346, 22375, 22405, 22434, 22464, 22493, 22522, 22552, 22581, 22611, 22640, 22670, 22700, 22730, 22759, 22789, 22818, 22848, 22877, 22906, 22936, 22965, 22994, 23024, 23054, 23083, 23113, 23143, 23173, 23202, 23232, 23261, 23290, 23320, 23349, 23379, 23408, 23438, 23467, 23497, 23527, 23556, 23586, 23616, 23645, 23674, 23704, 23733, 23763, 23792, 23822, 23851, 23881, 23910, 23940, 23970, 23999, 24029, 24058, 24088, 24117, 24147, 24176, 24206, 24235, 24265, 24294, 24324, 24353, 24383, 24413, 24442, 24472, 24501, 24531, 24560, 24590, 24619, 24648, 24678, 24707, 24737, 24767, 24796, 24826, 24856, 24885, 24915, 24944, 24974, 25003, 25032, 25062, 25091, 25121, 25150, 25180, 25210, 25240, 25269, 25299, 25328, 25358, 25387, 25416, 25446, 25475, 25505, 25534, 25564, 25594, 25624, 25653, 25683, 25712, 25742, 25771, 25800, 25830, 25859, 25888, 25918, 25948, 25977, 26007, 26037, 26067, 26096, 26126, 26155, 26184, 26214, 26243, 26272, 26302, 26332, 26361, 26391, 26421, 26451, 26480, 26510, 26539, 26568, 26598, 26627, 26656, 26686, 26715, 26745, 26775, 26805, 26834, 26864, 26893, 26923, 26952, 26982, 27011, 27041, 27070, 27099, 27129, 27159, 27188, 27218, 27248, 27277, 27307, 27336, 27366, 27395, 27425, 27454, 27484, 27513, 27542, 27572, 27602, 27631, 27661, 27691, 27720, 27750, 27779, 27809, 27838, 27868, 27897, 27926, 27956, 27985, 28015, 28045, 28074, 28104, 28134, 28163, 28193, 28222, 28252, 28281, 28310, 28340, 28369, 28399, 28428, 28458, 28488, 28517, 28547, 28577, 28607, 28636, 28665, 28695, 28724, 28754, 28783, 28813, 28843, 28872, 28901, 28931, 28960, 28990, 29019, 29049, 29078, 29108, 29137, 29167, 29196, 29226, 29255, 29285, 29315, 29345, 29375, 29404, 29434, 29463, 29492, 29522, 29551, 29580, 29610, 29640, 29669, 29699, 29729, 29759, 29788, 29818, 29847, 29876, 29906, 29935, 29964, 29994, 30023, 30053, 30082, 30112, 30141, 30171, 30200, 30230, 30259, 30289, 30318, 30348, 30378, 30408, 30437, 30467, 30496, 30526, 30555, 30585, 30614, 30644, 30673, 30703, 30732, 30762, 30791, 30821, 30850, 30880, 30909, 30939, 30968, 30998, 31027, 31057, 31086, 31116, 31145, 31175, 31204, 31234, 31263, 31293, 31322, 31352, 31381, 31411, 31441, 31471, 31500, 31530, 31559, 31589, 31618, 31648, 31676, 31706, 31736, 31766, 31795, 31825, 31854, 31884, 31913, 31943, 31972, 32002, 32031, 32061, 32090, 32120, 32150, 32180, 32209, 32239, 32268, 32298, 32327, 32357, 32386, 32416, 32445, 32475, 32504, 32534, 32563, 32593, 32622, 32652, 32681, 32711, 32740, 32770, 32799, 32829, 32858, 32888, 32917, 32947, 32976, 33006, 33035, 33065, 33094, 33124, 33153, 33183, 33213, 33243, 33272, 33302, 33331, 33361, 33390, 33420, 33450, 33479, 33509, 33539, 33568, 33598, 33627, 33657, 33686, 33716, 33745, 33775, 33804, 33834, 33863, 33893, 33922, 33952, 33981, 34011, 34040, 34069, 34099, 34128, 34158, 34187, 34217, 34247, 34277, 34306, 34336, 34365, 34395, 34424, 34454, 34483, 34512, 34542, 34571, 34601, 34631, 34660, 34690, 34719, 34749, 34778, 34808, 34837, 34867, 34896, 34926, 34955, 34985, 35015, 35044, 35074, 35103, 35133, 35162, 35192, 35222, 35251, 35280, 35310, 35340, 35370, 35399, 35429, 35458, 35488, 35517, 35547, 35576, 35605, 35635, 35665, 35694, 35723, 35753, 35782, 35811, 35841, 35871, 35901, 35930, 35960, 35989, 36019, 36048, 36078, 36107, 36136, 36166, 36195, 36225, 36254, 36284, 36314, 36343, 36373, 36403, 36433, 36462, 36492, 36521, 36551, 36580, 36610, 36639, 36669, 36698, 36728, 36757, 36786, 36816, 36845, 36875, 36904, 36934, 36963, 36993, 37022, 37052, 37081, 37111, 37141, 37170, 37200, 37229, 37259, 37288, 37318, 37347, 37377, 37406, 37436, 37465, 37495, 37524, 37554, 37584, 37613, 37643, 37672, 37701, 37731, 37760, 37790, 37819, 37849, 37878, 37908, 37938, 37967, 37997, 38027, 38056, 38085, 38115, 38144, 38174, 38203, 38233, 38262, 38292, 38322, 38351, 38381, 38410, 38440, 38469, 38499, 38528, 38558, 38587, 38617, 38646, 38676, 38705, 38735, 38764, 38794, 38823, 38853, 38882, 38912, 38941, 38971, 39001, 39030, 39059, 39089, 39118, 39148, 39178, 39208, 39237, 39267, 39297, 39326, 39355, 39385, 39414, 39444, 39473, 39503, 39532, 39562, 39592, 39621, 39650, 39680, 39709, 39739, 39768, 39798, 39827, 39857, 39886, 39916, 39946, 39975, 40005, 40035, 40064, 40094, 40123, 40153, 40182, 40212, 40241, 40271, 40300, 40330, 40359, 40389, 40418, 40448, 40477, 40507, 40536, 40566, 40595, 40625, 40655, 40685, 40714, 40744, 40773, 40803, 40832, 40862, 40892, 40921, 40951, 40980, 41009, 41039, 41068, 41098, 41127, 41157, 41186, 41216, 41245, 41275, 41304, 41334, 41364, 41393, 41422, 41452, 41481, 41511, 41540, 41570, 41599, 41629, 41658, 41688, 41718, 41748, 41777, 41807, 41836, 41865, 41894, 41924, 41953, 41983, 42012, 42042, 42072, 42102, 42131, 42161, 42190, 42220, 42249, 42279, 42308, 42337, 42367, 42397, 42426, 42456, 42485, 42515, 42545, 42574, 42604, 42633, 42662, 42692, 42721, 42751, 42780, 42810, 42839, 42869, 42899, 42929, 42958, 42988, 43017, 43046, 43076, 43105, 43135, 43164, 43194, 43223, 43253, 43283, 43312, 43342, 43371, 43401, 43430, 43460, 43489, 43519, 43548, 43578, 43607, 43637, 43666, 43696, 43726, 43755, 43785, 43814, 43844, 43873, 43903, 43932, 43962, 43991, 44021, 44050, 44080, 44109, 44139, 44169, 44198, 44228, 44258, 44287, 44317, 44346, 44375, 44405, 44434, 44464, 44493, 44523, 44553, 44582, 44612, 44641, 44671, 44700, 44730, 44759, 44788, 44818, 44847, 44877, 44906, 44936, 44966, 44996, 45025, 45055, 45084, 45114, 45143, 45172, 45202, 45231, 45261, 45290, 45320, 45350, 45380, 45409, 45439, 45468, 45498, 45527, 45556, 45586, 45615, 45644, 45674, 45704, 45733, 45763, 45793, 45823, 45852, 45882, 45911, 45940, 45970, 45999, 46028, 46058, 46088, 46117, 46147, 46177, 46206, 46236, 46265, 46295, 46324, 46354, 46383, 46413, 46442, 46472, 46501, 46531, 46560, 46590, 46620, 46649, 46679, 46708, 46738, 46767, 46797, 46826, 46856, 46885, 46915, 46944, 46974, 47003, 47033, 47063, 47092, 47122, 47151, 47181, 47210, 47240, 47269, 47298, 47328, 47357, 47387, 47417, 47446, 47476, 47506, 47535, 47565, 47594, 47624, 47653, 47682, 47712, 47741, 47771, 47800, 47830, 47860, 47890, 47919, 47949, 47978, 48008, 48037, 48066, 48096, 48125, 48155, 48184, 48214, 48244, 48273, 48303, 48333, 48362, 48392, 48421, 48450, 48480, 48509, 48538, 48568, 48598, 48627, 48657, 48687, 48717, 48746, 48776, 48805, 48834, 48864, 48893, 48922, 48952, 48982, 49011, 49041, 49071, 49100, 49130, 49160, 49189, 49218, 49248, 49277, 49306, 49336, 49365, 49395, 49425, 49455, 49484, 49514, 49543, 49573, 49602, 49632, 49661, 49690, 49720, 49749, 49779, 49809, 49838, 49868, 49898, 49927, 49957, 49986, 50016, 50045, 50075, 50104, 50133, 50163, 50192, 50222, 50252, 50281, 50311, 50340, 50370, 50400, 50429, 50459, 50488, 50518, 50547, 50576, 50606, 50635, 50665, 50694, 50724, 50754, 50784, 50813, 50843, 50872, 50902, 50931, 50960, 50990, 51019, 51049, 51078, 51108, 51138, 51167, 51197, 51227, 51256, 51286, 51315, 51345, 51374, 51403, 51433, 51462, 51492, 51522, 51552, 51582, 51611, 51641, 51670, 51699, 51729, 51758, 51787, 51816, 51846, 51876, 51906, 51936, 51965, 51995, 52025, 52054, 52083, 52113, 52142, 52171, 52200, 52230, 52260, 52290, 52319, 52349, 52379, 52408, 52438, 52467, 52497, 52526, 52555, 52585, 52614, 52644, 52673, 52703, 52733, 52762, 52792, 52822, 52851, 52881, 52910, 52939, 52969, 52998, 53028, 53057, 53087, 53116, 53146, 53176, 53205, 53235, 53264, 53294, 53324, 53353, 53383, 53412, 53441, 53471, 53500, 53530, 53559, 53589, 53619, 53648, 53678, 53708, 53737, 53767, 53796, 53825, 53855, 53884, 53913, 53943, 53973, 54003, 54032, 54062, 54092, 54121, 54151, 54180, 54209, 54239, 54268, 54297, 54327, 54357, 54387, 54416, 54446, 54476, 54505, 54535, 54564, 54593, 54623, 54652, 54681, 54711, 54741, 54770, 54800, 54830, 54859, 54889, 54919, 54948, 54977, 55007, 55036, 55066, 55095, 55125, 55154, 55184, 55213, 55243, 55273, 55302, 55332, 55361, 55391, 55420, 55450, 55479, 55508, 55538, 55567, 55597, 55627, 55657, 55686, 55716, 55745, 55775, 55804, 55834, 55863, 55892, 55922, 55951, 55981, 56011, 56040, 56070, 56100, 56129, 56159, 56188, 56218, 56247, 56276, 56306, 56335, 56365, 56394, 56424, 56454, 56483, 56513, 56543, 56572, 56601, 56631, 56660, 56690, 56719, 56749, 56778, 56808, 56837, 56867, 56897, 56926, 56956, 56985, 57015, 57044, 57074, 57103, 57133, 57162, 57192, 57221, 57251, 57280, 57310, 57340, 57369, 57399, 57429, 57458, 57487, 57517, 57546, 57576, 57605, 57634, 57664, 57694, 57723, 57753, 57783, 57813, 57842, 57871, 57901, 57930, 57959, 57989, 58018, 58048, 58077, 58107, 58137, 58167, 58196, 58226, 58255, 58285, 58314, 58343, 58373, 58402, 58432, 58461, 58491, 58521, 58551, 58580, 58610, 58639, 58669, 58698, 58727, 58757, 58786, 58816, 58845, 58875, 58905, 58934, 58964, 58994, 59023, 59053, 59082, 59111, 59141, 59170, 59200, 59229, 59259, 59288, 59318, 59348, 59377, 59407, 59436, 59466, 59495, 59525, 59554, 59584, 59613, 59643, 59672, 59702, 59731, 59761, 59791, 59820, 59850, 59879, 59909, 59939, 59968, 59997, 60027, 60056, 60086, 60115, 60145, 60174, 60204, 60234, 60264, 60293, 60323, 60352, 60381, 60411, 60440, 60469, 60499, 60528, 60558, 60588, 60618, 60648, 60677, 60707, 60736, 60765, 60795, 60824, 60853, 60883, 60912, 60942, 60972, 61002, 61031, 61061, 61090, 61120, 61149, 61179, 61208, 61237, 61267, 61296, 61326, 61356, 61385, 61415, 61445, 61474, 61504, 61533, 61563, 61592, 61621, 61651, 61680, 61710, 61739, 61769, 61799, 61828, 61858, 61888, 61917, 61947, 61976, 62006, 62035, 62064, 62094, 62123, 62153, 62182, 62212, 62242, 62271, 62301, 62331, 62360, 62390, 62419, 62448, 62478, 62507, 62537, 62566, 62596, 62625, 62655, 62685, 62715, 62744, 62774, 62803, 62832, 62862, 62891, 62921, 62950, 62980, 63009, 63039, 63069, 63099, 63128, 63157, 63187, 63216, 63246, 63275, 63305, 63334, 63363, 63393, 63423, 63453, 63482, 63512, 63541, 63571, 63600, 63630, 63659, 63689, 63718, 63747, 63777, 63807, 63836, 63866, 63895, 63925, 63955, 63984, 64014, 64043, 64073, 64102, 64131, 64161, 64190, 64220, 64249, 64279, 64309, 64339, 64368, 64398, 64427, 64457, 64486, 64515, 64545, 64574, 64603, 64633, 64663, 64692, 64722, 64752, 64782, 64811, 64841, 64870, 64899, 64929, 64958, 64987, 65017, 65047, 65076, 65106, 65136, 65166, 65195, 65225, 65254, 65283, 65313, 65342, 65371, 65401, 65431, 65460, 65490, 65520, 65549, 65579, 65608, 65638, 65667, 65697, 65726, 65755, 65785, 65815, 65844, 65874, 65903, 65933, 65963, 65992, 66022, 66051, 66081, 66110, 66140, 66169, 66199, 66228, 66258, 66287, 66317, 66346, 66376, 66405, 66435, 66465, 66494, 66524, 66553, 66583, 66612, 66641, 66671, 66700, 66730, 66760, 66789, 66819, 66849, 66878, 66908, 66937, 66967, 66996, 67025, 67055, 67084, 67114, 67143, 67173, 67203, 67233, 67262, 67292, 67321, 67351, 67380, 67409, 67439, 67468, 67497, 67527, 67557, 67587, 67617, 67646, 67676, 67705, 67735, 67764, 67793, 67823, 67852, 67882, 67911, 67941, 67971, 68e3, 68030, 68060, 68089, 68119, 68148, 68177, 68207, 68236, 68266, 68295, 68325, 68354, 68384, 68414, 68443, 68473, 68502, 68532, 68561, 68591, 68620, 68650, 68679, 68708, 68738, 68768, 68797, 68827, 68857, 68886, 68916, 68946, 68975, 69004, 69034, 69063, 69092, 69122, 69152, 69181, 69211, 69240, 69270, 69300, 69330, 69359, 69388, 69418, 69447, 69476, 69506, 69535, 69565, 69595, 69624, 69654, 69684, 69713, 69743, 69772, 69802, 69831, 69861, 69890, 69919, 69949, 69978, 70008, 70038, 70067, 70097, 70126, 70156, 70186, 70215, 70245, 70274, 70303, 70333, 70362, 70392, 70421, 70451, 70481, 70510, 70540, 70570, 70599, 70629, 70658, 70687, 70717, 70746, 70776, 70805, 70835, 70864, 70894, 70924, 70954, 70983, 71013, 71042, 71071, 71101, 71130, 71159, 71189, 71218, 71248, 71278, 71308, 71337, 71367, 71397, 71426, 71455, 71485, 71514, 71543, 71573, 71602, 71632, 71662, 71691, 71721, 71751, 71781, 71810, 71839, 71869, 71898, 71927, 71957, 71986, 72016, 72046, 72075, 72105, 72135, 72164, 72194, 72223, 72253, 72282, 72311, 72341, 72370, 72400, 72429, 72459, 72489, 72518, 72548, 72577, 72607, 72637, 72666, 72695, 72725, 72754, 72784, 72813, 72843, 72872, 72902, 72931, 72961, 72991, 73020, 73050, 73080, 73109, 73139, 73168, 73197, 73227, 73256, 73286, 73315, 73345, 73375, 73404, 73434, 73464, 73493, 73523, 73552, 73581, 73611, 73640, 73669, 73699, 73729, 73758, 73788, 73818, 73848, 73877, 73907, 73936, 73965, 73995, 74024, 74053, 74083, 74113, 74142, 74172, 74202, 74231, 74261, 74291, 74320, 74349, 74379, 74408, 74437, 74467, 74497, 74526, 74556, 74586, 74615, 74645, 74675, 74704, 74733, 74763, 74792, 74822, 74851, 74881, 74910, 74940, 74969, 74999, 75029, 75058, 75088, 75117, 75147, 75176, 75206, 75235, 75264, 75294, 75323, 75353, 75383, 75412, 75442, 75472, 75501, 75531, 75560, 75590, 75619, 75648, 75678, 75707, 75737, 75766, 75796, 75826, 75856, 75885, 75915, 75944, 75974, 76003, 76032, 76062, 76091, 76121, 76150, 76180, 76210, 76239, 76269, 76299, 76328, 76358, 76387, 76416, 76446, 76475, 76505, 76534, 76564, 76593, 76623, 76653, 76682, 76712, 76741, 76771, 76801, 76830, 76859, 76889, 76918, 76948, 76977, 77007, 77036, 77066, 77096, 77125, 77155, 77185, 77214, 77243, 77273, 77302, 77332, 77361, 77390, 77420, 77450, 77479, 77509, 77539, 77569, 77598, 77627, 77657, 77686, 77715, 77745, 77774, 77804, 77833, 77863, 77893, 77923, 77952, 77982, 78011, 78041, 78070, 78099, 78129, 78158, 78188, 78217, 78247, 78277, 78307, 78336, 78366, 78395, 78425, 78454, 78483, 78513, 78542, 78572, 78601, 78631, 78661, 78690, 78720, 78750, 78779, 78808, 78838, 78867, 78897, 78926, 78956, 78985, 79015, 79044, 79074, 79104, 79133, 79163, 79192, 79222, 79251, 79281, 79310, 79340, 79369, 79399, 79428, 79458, 79487, 79517, 79546, 79576, 79606, 79635, 79665, 79695, 79724, 79753, 79783, 79812, 79841, 79871, 79900, 79930, 79960, 79990];
      }, 63489: function(t2, e2, r2) {
        var n2 = r2(56131);
        function i() {
          this.regionalOptions = [], this.regionalOptions[""] = { invalidCalendar: "Calendar {0} not found", invalidDate: "Invalid {0} date", invalidMonth: "Invalid {0} month", invalidYear: "Invalid {0} year", differentCalendars: "Cannot mix {0} and {1} dates" }, this.local = this.regionalOptions[""], this.calendars = {}, this._localCals = {};
        }
        function a(t3, e3, r3, n3) {
          if (this._calendar = t3, this._year = e3, this._month = r3, this._day = n3, 0 === this._calendar._validateLevel && !this._calendar.isValid(this._year, this._month, this._day))
            throw (u.local.invalidDate || u.regionalOptions[""].invalidDate).replace(/\{0\}/, this._calendar.local.name);
        }
        function o(t3, e3) {
          return "000000".substring(0, e3 - (t3 = "" + t3).length) + t3;
        }
        function s() {
          this.shortYearCutoff = "+10";
        }
        function l(t3) {
          this.local = this.regionalOptions[t3] || this.regionalOptions[""];
        }
        n2(i.prototype, { instance: function(t3, e3) {
          t3 = (t3 || "gregorian").toLowerCase(), e3 = e3 || "";
          var r3 = this._localCals[t3 + "-" + e3];
          if (!r3 && this.calendars[t3] && (r3 = new this.calendars[t3](e3), this._localCals[t3 + "-" + e3] = r3), !r3)
            throw (this.local.invalidCalendar || this.regionalOptions[""].invalidCalendar).replace(/\{0\}/, t3);
          return r3;
        }, newDate: function(t3, e3, r3, n3, i2) {
          return (n3 = (null != t3 && t3.year ? t3.calendar() : "string" == typeof n3 ? this.instance(n3, i2) : n3) || this.instance()).newDate(t3, e3, r3);
        }, substituteDigits: function(t3) {
          return function(e3) {
            return (e3 + "").replace(/[0-9]/g, function(e4) {
              return t3[e4];
            });
          };
        }, substituteChineseDigits: function(t3, e3) {
          return function(r3) {
            for (var n3 = "", i2 = 0; r3 > 0; ) {
              var a2 = r3 % 10;
              n3 = (0 === a2 ? "" : t3[a2] + e3[i2]) + n3, i2++, r3 = Math.floor(r3 / 10);
            }
            return 0 === n3.indexOf(t3[1] + e3[1]) && (n3 = n3.substr(1)), n3 || t3[0];
          };
        } }), n2(a.prototype, { newDate: function(t3, e3, r3) {
          return this._calendar.newDate(null == t3 ? this : t3, e3, r3);
        }, year: function(t3) {
          return 0 === arguments.length ? this._year : this.set(t3, "y");
        }, month: function(t3) {
          return 0 === arguments.length ? this._month : this.set(t3, "m");
        }, day: function(t3) {
          return 0 === arguments.length ? this._day : this.set(t3, "d");
        }, date: function(t3, e3, r3) {
          if (!this._calendar.isValid(t3, e3, r3))
            throw (u.local.invalidDate || u.regionalOptions[""].invalidDate).replace(/\{0\}/, this._calendar.local.name);
          return this._year = t3, this._month = e3, this._day = r3, this;
        }, leapYear: function() {
          return this._calendar.leapYear(this);
        }, epoch: function() {
          return this._calendar.epoch(this);
        }, formatYear: function() {
          return this._calendar.formatYear(this);
        }, monthOfYear: function() {
          return this._calendar.monthOfYear(this);
        }, weekOfYear: function() {
          return this._calendar.weekOfYear(this);
        }, daysInYear: function() {
          return this._calendar.daysInYear(this);
        }, dayOfYear: function() {
          return this._calendar.dayOfYear(this);
        }, daysInMonth: function() {
          return this._calendar.daysInMonth(this);
        }, dayOfWeek: function() {
          return this._calendar.dayOfWeek(this);
        }, weekDay: function() {
          return this._calendar.weekDay(this);
        }, extraInfo: function() {
          return this._calendar.extraInfo(this);
        }, add: function(t3, e3) {
          return this._calendar.add(this, t3, e3);
        }, set: function(t3, e3) {
          return this._calendar.set(this, t3, e3);
        }, compareTo: function(t3) {
          if (this._calendar.name !== t3._calendar.name)
            throw (u.local.differentCalendars || u.regionalOptions[""].differentCalendars).replace(/\{0\}/, this._calendar.local.name).replace(/\{1\}/, t3._calendar.local.name);
          var e3 = this._year !== t3._year ? this._year - t3._year : this._month !== t3._month ? this.monthOfYear() - t3.monthOfYear() : this._day - t3._day;
          return 0 === e3 ? 0 : e3 < 0 ? -1 : 1;
        }, calendar: function() {
          return this._calendar;
        }, toJD: function() {
          return this._calendar.toJD(this);
        }, fromJD: function(t3) {
          return this._calendar.fromJD(t3);
        }, toJSDate: function() {
          return this._calendar.toJSDate(this);
        }, fromJSDate: function(t3) {
          return this._calendar.fromJSDate(t3);
        }, toString: function() {
          return (this.year() < 0 ? "-" : "") + o(Math.abs(this.year()), 4) + "-" + o(this.month(), 2) + "-" + o(this.day(), 2);
        } }), n2(s.prototype, { _validateLevel: 0, newDate: function(t3, e3, r3) {
          return null == t3 ? this.today() : (t3.year && (this._validate(t3, e3, r3, u.local.invalidDate || u.regionalOptions[""].invalidDate), r3 = t3.day(), e3 = t3.month(), t3 = t3.year()), new a(this, t3, e3, r3));
        }, today: function() {
          return this.fromJSDate(new Date());
        }, epoch: function(t3) {
          return this._validate(t3, this.minMonth, this.minDay, u.local.invalidYear || u.regionalOptions[""].invalidYear).year() < 0 ? this.local.epochs[0] : this.local.epochs[1];
        }, formatYear: function(t3) {
          var e3 = this._validate(t3, this.minMonth, this.minDay, u.local.invalidYear || u.regionalOptions[""].invalidYear);
          return (e3.year() < 0 ? "-" : "") + o(Math.abs(e3.year()), 4);
        }, monthsInYear: function(t3) {
          return this._validate(t3, this.minMonth, this.minDay, u.local.invalidYear || u.regionalOptions[""].invalidYear), 12;
        }, monthOfYear: function(t3, e3) {
          var r3 = this._validate(t3, e3, this.minDay, u.local.invalidMonth || u.regionalOptions[""].invalidMonth);
          return (r3.month() + this.monthsInYear(r3) - this.firstMonth) % this.monthsInYear(r3) + this.minMonth;
        }, fromMonthOfYear: function(t3, e3) {
          var r3 = (e3 + this.firstMonth - 2 * this.minMonth) % this.monthsInYear(t3) + this.minMonth;
          return this._validate(t3, r3, this.minDay, u.local.invalidMonth || u.regionalOptions[""].invalidMonth), r3;
        }, daysInYear: function(t3) {
          var e3 = this._validate(t3, this.minMonth, this.minDay, u.local.invalidYear || u.regionalOptions[""].invalidYear);
          return this.leapYear(e3) ? 366 : 365;
        }, dayOfYear: function(t3, e3, r3) {
          var n3 = this._validate(t3, e3, r3, u.local.invalidDate || u.regionalOptions[""].invalidDate);
          return n3.toJD() - this.newDate(n3.year(), this.fromMonthOfYear(n3.year(), this.minMonth), this.minDay).toJD() + 1;
        }, daysInWeek: function() {
          return 7;
        }, dayOfWeek: function(t3, e3, r3) {
          var n3 = this._validate(t3, e3, r3, u.local.invalidDate || u.regionalOptions[""].invalidDate);
          return (Math.floor(this.toJD(n3)) + 2) % this.daysInWeek();
        }, extraInfo: function(t3, e3, r3) {
          return this._validate(t3, e3, r3, u.local.invalidDate || u.regionalOptions[""].invalidDate), {};
        }, add: function(t3, e3, r3) {
          return this._validate(t3, this.minMonth, this.minDay, u.local.invalidDate || u.regionalOptions[""].invalidDate), this._correctAdd(t3, this._add(t3, e3, r3), e3, r3);
        }, _add: function(t3, e3, r3) {
          if (this._validateLevel++, "d" === r3 || "w" === r3) {
            var n3 = t3.toJD() + e3 * ("w" === r3 ? this.daysInWeek() : 1), i2 = t3.calendar().fromJD(n3);
            return this._validateLevel--, [i2.year(), i2.month(), i2.day()];
          }
          try {
            var a2 = t3.year() + ("y" === r3 ? e3 : 0), o2 = t3.monthOfYear() + ("m" === r3 ? e3 : 0);
            i2 = t3.day(), "y" === r3 ? (t3.month() !== this.fromMonthOfYear(a2, o2) && (o2 = this.newDate(a2, t3.month(), this.minDay).monthOfYear()), o2 = Math.min(o2, this.monthsInYear(a2)), i2 = Math.min(i2, this.daysInMonth(a2, this.fromMonthOfYear(a2, o2)))) : "m" === r3 && (function(t4) {
              for (; o2 < t4.minMonth; )
                a2--, o2 += t4.monthsInYear(a2);
              for (var e4 = t4.monthsInYear(a2); o2 > e4 - 1 + t4.minMonth; )
                a2++, o2 -= e4, e4 = t4.monthsInYear(a2);
            }(this), i2 = Math.min(i2, this.daysInMonth(a2, this.fromMonthOfYear(a2, o2))));
            var s2 = [a2, this.fromMonthOfYear(a2, o2), i2];
            return this._validateLevel--, s2;
          } catch (t4) {
            throw this._validateLevel--, t4;
          }
        }, _correctAdd: function(t3, e3, r3, n3) {
          if (!(this.hasYearZero || "y" !== n3 && "m" !== n3 || 0 !== e3[0] && t3.year() > 0 == e3[0] > 0)) {
            var i2 = { y: [1, 1, "y"], m: [1, this.monthsInYear(-1), "m"], w: [this.daysInWeek(), this.daysInYear(-1), "d"], d: [1, this.daysInYear(-1), "d"] }[n3], a2 = r3 < 0 ? -1 : 1;
            e3 = this._add(t3, r3 * i2[0] + a2 * i2[1], i2[2]);
          }
          return t3.date(e3[0], e3[1], e3[2]);
        }, set: function(t3, e3, r3) {
          this._validate(t3, this.minMonth, this.minDay, u.local.invalidDate || u.regionalOptions[""].invalidDate);
          var n3 = "y" === r3 ? e3 : t3.year(), i2 = "m" === r3 ? e3 : t3.month(), a2 = "d" === r3 ? e3 : t3.day();
          return "y" !== r3 && "m" !== r3 || (a2 = Math.min(a2, this.daysInMonth(n3, i2))), t3.date(n3, i2, a2);
        }, isValid: function(t3, e3, r3) {
          this._validateLevel++;
          var n3 = this.hasYearZero || 0 !== t3;
          if (n3) {
            var i2 = this.newDate(t3, e3, this.minDay);
            n3 = e3 >= this.minMonth && e3 - this.minMonth < this.monthsInYear(i2) && r3 >= this.minDay && r3 - this.minDay < this.daysInMonth(i2);
          }
          return this._validateLevel--, n3;
        }, toJSDate: function(t3, e3, r3) {
          var n3 = this._validate(t3, e3, r3, u.local.invalidDate || u.regionalOptions[""].invalidDate);
          return u.instance().fromJD(this.toJD(n3)).toJSDate();
        }, fromJSDate: function(t3) {
          return this.fromJD(u.instance().fromJSDate(t3).toJD());
        }, _validate: function(t3, e3, r3, n3) {
          if (t3.year) {
            if (0 === this._validateLevel && this.name !== t3.calendar().name)
              throw (u.local.differentCalendars || u.regionalOptions[""].differentCalendars).replace(/\{0\}/, this.local.name).replace(/\{1\}/, t3.calendar().local.name);
            return t3;
          }
          try {
            if (this._validateLevel++, 1 === this._validateLevel && !this.isValid(t3, e3, r3))
              throw n3.replace(/\{0\}/, this.local.name);
            var i2 = this.newDate(t3, e3, r3);
            return this._validateLevel--, i2;
          } catch (t4) {
            throw this._validateLevel--, t4;
          }
        } }), l.prototype = new s(), n2(l.prototype, { name: "Gregorian", jdEpoch: 17214255e-1, daysPerMonth: [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], hasYearZero: false, minMonth: 1, firstMonth: 1, minDay: 1, regionalOptions: { "": { name: "Gregorian", epochs: ["BCE", "CE"], monthNames: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"], monthNamesShort: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], dayNames: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], dayNamesShort: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], dayNamesMin: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"], digits: null, dateFormat: "mm/dd/yyyy", firstDay: 0, isRTL: false } }, leapYear: function(t3) {
          var e3 = this._validate(t3, this.minMonth, this.minDay, u.local.invalidYear || u.regionalOptions[""].invalidYear);
          return (t3 = e3.year() + (e3.year() < 0 ? 1 : 0)) % 4 == 0 && (t3 % 100 != 0 || t3 % 400 == 0);
        }, weekOfYear: function(t3, e3, r3) {
          var n3 = this.newDate(t3, e3, r3);
          return n3.add(4 - (n3.dayOfWeek() || 7), "d"), Math.floor((n3.dayOfYear() - 1) / 7) + 1;
        }, daysInMonth: function(t3, e3) {
          var r3 = this._validate(t3, e3, this.minDay, u.local.invalidMonth || u.regionalOptions[""].invalidMonth);
          return this.daysPerMonth[r3.month() - 1] + (2 === r3.month() && this.leapYear(r3.year()) ? 1 : 0);
        }, weekDay: function(t3, e3, r3) {
          return (this.dayOfWeek(t3, e3, r3) || 7) < 6;
        }, toJD: function(t3, e3, r3) {
          var n3 = this._validate(t3, e3, r3, u.local.invalidDate || u.regionalOptions[""].invalidDate);
          t3 = n3.year(), e3 = n3.month(), r3 = n3.day(), t3 < 0 && t3++, e3 < 3 && (e3 += 12, t3--);
          var i2 = Math.floor(t3 / 100), a2 = 2 - i2 + Math.floor(i2 / 4);
          return Math.floor(365.25 * (t3 + 4716)) + Math.floor(30.6001 * (e3 + 1)) + r3 + a2 - 1524.5;
        }, fromJD: function(t3) {
          var e3 = Math.floor(t3 + 0.5), r3 = Math.floor((e3 - 186721625e-2) / 36524.25), n3 = 1524 + (r3 = e3 + 1 + r3 - Math.floor(r3 / 4)), i2 = Math.floor((n3 - 122.1) / 365.25), a2 = Math.floor(365.25 * i2), o2 = Math.floor((n3 - a2) / 30.6001), s2 = n3 - a2 - Math.floor(30.6001 * o2), l2 = o2 - (o2 > 13.5 ? 13 : 1), u2 = i2 - (l2 > 2.5 ? 4716 : 4715);
          return u2 <= 0 && u2--, this.newDate(u2, l2, s2);
        }, toJSDate: function(t3, e3, r3) {
          var n3 = this._validate(t3, e3, r3, u.local.invalidDate || u.regionalOptions[""].invalidDate), i2 = new Date(n3.year(), n3.month() - 1, n3.day());
          return i2.setHours(0), i2.setMinutes(0), i2.setSeconds(0), i2.setMilliseconds(0), i2.setHours(i2.getHours() > 12 ? i2.getHours() + 2 : 0), i2;
        }, fromJSDate: function(t3) {
          return this.newDate(t3.getFullYear(), t3.getMonth() + 1, t3.getDate());
        } });
        var u = t2.exports = new i();
        u.cdate = a, u.baseCalendar = s, u.calendars.gregorian = l;
      }, 94338: function(t2, e2, r2) {
        var n2 = r2(56131), i = r2(63489);
        n2(i.regionalOptions[""], { invalidArguments: "Invalid arguments", invalidFormat: "Cannot format a date from another calendar", missingNumberAt: "Missing number at position {0}", unknownNameAt: "Unknown name at position {0}", unexpectedLiteralAt: "Unexpected literal at position {0}", unexpectedText: "Additional text found at end" }), i.local = i.regionalOptions[""], n2(i.cdate.prototype, { formatDate: function(t3, e3) {
          return "string" != typeof t3 && (e3 = t3, t3 = ""), this._calendar.formatDate(t3 || "", this, e3);
        } }), n2(i.baseCalendar.prototype, { UNIX_EPOCH: i.instance().newDate(1970, 1, 1).toJD(), SECS_PER_DAY: 86400, TICKS_EPOCH: i.instance().jdEpoch, TICKS_PER_DAY: 864e9, ATOM: "yyyy-mm-dd", COOKIE: "D, dd M yyyy", FULL: "DD, MM d, yyyy", ISO_8601: "yyyy-mm-dd", JULIAN: "J", RFC_822: "D, d M yy", RFC_850: "DD, dd-M-yy", RFC_1036: "D, d M yy", RFC_1123: "D, d M yyyy", RFC_2822: "D, d M yyyy", RSS: "D, d M yy", TICKS: "!", TIMESTAMP: "@", W3C: "yyyy-mm-dd", formatDate: function(t3, e3, r3) {
          if ("string" != typeof t3 && (r3 = e3, e3 = t3, t3 = ""), !e3)
            return "";
          if (e3.calendar() !== this)
            throw i.local.invalidFormat || i.regionalOptions[""].invalidFormat;
          t3 = t3 || this.local.dateFormat;
          for (var n3, a, o, s = (r3 = r3 || {}).dayNamesShort || this.local.dayNamesShort, l = r3.dayNames || this.local.dayNames, u = r3.monthNumbers || this.local.monthNumbers, c = r3.monthNamesShort || this.local.monthNamesShort, f2 = r3.monthNames || this.local.monthNames, h = (r3.calculateWeek || this.local.calculateWeek, function(e4, r4) {
            for (var n4 = 1; _ + n4 < t3.length && t3.charAt(_ + n4) === e4; )
              n4++;
            return _ += n4 - 1, Math.floor(n4 / (r4 || 1)) > 1;
          }), p2 = function(t4, e4, r4, n4) {
            var i2 = "" + e4;
            if (h(t4, n4))
              for (; i2.length < r4; )
                i2 = "0" + i2;
            return i2;
          }, d2 = this, v = function(t4) {
            return "function" == typeof u ? u.call(d2, t4, h("m")) : m2(p2("m", t4.month(), 2));
          }, g2 = function(t4, e4) {
            return e4 ? "function" == typeof f2 ? f2.call(d2, t4) : f2[t4.month() - d2.minMonth] : "function" == typeof c ? c.call(d2, t4) : c[t4.month() - d2.minMonth];
          }, y = this.local.digits, m2 = function(t4) {
            return r3.localNumbers && y ? y(t4) : t4;
          }, x = "", b = false, _ = 0; _ < t3.length; _++)
            if (b)
              "'" !== t3.charAt(_) || h("'") ? x += t3.charAt(_) : b = false;
            else
              switch (t3.charAt(_)) {
                case "d":
                  x += m2(p2("d", e3.day(), 2));
                  break;
                case "D":
                  x += (n3 = e3.dayOfWeek(), a = s, o = l, h("D") ? o[n3] : a[n3]);
                  break;
                case "o":
                  x += p2("o", e3.dayOfYear(), 3);
                  break;
                case "w":
                  x += p2("w", e3.weekOfYear(), 2);
                  break;
                case "m":
                  x += v(e3);
                  break;
                case "M":
                  x += g2(e3, h("M"));
                  break;
                case "y":
                  x += h("y", 2) ? e3.year() : (e3.year() % 100 < 10 ? "0" : "") + e3.year() % 100;
                  break;
                case "Y":
                  h("Y", 2), x += e3.formatYear();
                  break;
                case "J":
                  x += e3.toJD();
                  break;
                case "@":
                  x += (e3.toJD() - this.UNIX_EPOCH) * this.SECS_PER_DAY;
                  break;
                case "!":
                  x += (e3.toJD() - this.TICKS_EPOCH) * this.TICKS_PER_DAY;
                  break;
                case "'":
                  h("'") ? x += "'" : b = true;
                  break;
                default:
                  x += t3.charAt(_);
              }
          return x;
        }, parseDate: function(t3, e3, r3) {
          if (null == e3)
            throw i.local.invalidArguments || i.regionalOptions[""].invalidArguments;
          if ("" === (e3 = "object" == typeof e3 ? e3.toString() : e3 + ""))
            return null;
          t3 = t3 || this.local.dateFormat;
          var n3 = (r3 = r3 || {}).shortYearCutoff || this.shortYearCutoff;
          n3 = "string" != typeof n3 ? n3 : this.today().year() % 100 + parseInt(n3, 10);
          for (var a = r3.dayNamesShort || this.local.dayNamesShort, o = r3.dayNames || this.local.dayNames, s = r3.parseMonth || this.local.parseMonth, l = r3.monthNumbers || this.local.monthNumbers, u = r3.monthNamesShort || this.local.monthNamesShort, c = r3.monthNames || this.local.monthNames, f2 = -1, h = -1, p2 = -1, d2 = -1, v = -1, g2 = false, y = false, m2 = function(e4, r4) {
            for (var n4 = 1; M + n4 < t3.length && t3.charAt(M + n4) === e4; )
              n4++;
            return M += n4 - 1, Math.floor(n4 / (r4 || 1)) > 1;
          }, x = function(t4, r4) {
            var n4 = m2(t4, r4), a2 = [2, 3, n4 ? 4 : 2, n4 ? 4 : 2, 10, 11, 20]["oyYJ@!".indexOf(t4) + 1], o2 = new RegExp("^-?\\d{1," + a2 + "}"), s2 = e3.substring(A).match(o2);
            if (!s2)
              throw (i.local.missingNumberAt || i.regionalOptions[""].missingNumberAt).replace(/\{0\}/, A);
            return A += s2[0].length, parseInt(s2[0], 10);
          }, b = this, _ = function() {
            if ("function" == typeof l) {
              m2("m");
              var t4 = l.call(b, e3.substring(A));
              return A += t4.length, t4;
            }
            return x("m");
          }, w2 = function(t4, r4, n4, a2) {
            for (var o2 = m2(t4, a2) ? n4 : r4, s2 = 0; s2 < o2.length; s2++)
              if (e3.substr(A, o2[s2].length).toLowerCase() === o2[s2].toLowerCase())
                return A += o2[s2].length, s2 + b.minMonth;
            throw (i.local.unknownNameAt || i.regionalOptions[""].unknownNameAt).replace(/\{0\}/, A);
          }, T = function() {
            if ("function" == typeof c) {
              var t4 = m2("M") ? c.call(b, e3.substring(A)) : u.call(b, e3.substring(A));
              return A += t4.length, t4;
            }
            return w2("M", u, c);
          }, k = function() {
            if (e3.charAt(A) !== t3.charAt(M))
              throw (i.local.unexpectedLiteralAt || i.regionalOptions[""].unexpectedLiteralAt).replace(/\{0\}/, A);
            A++;
          }, A = 0, M = 0; M < t3.length; M++)
            if (y)
              "'" !== t3.charAt(M) || m2("'") ? k() : y = false;
            else
              switch (t3.charAt(M)) {
                case "d":
                  d2 = x("d");
                  break;
                case "D":
                  w2("D", a, o);
                  break;
                case "o":
                  v = x("o");
                  break;
                case "w":
                  x("w");
                  break;
                case "m":
                  p2 = _();
                  break;
                case "M":
                  p2 = T();
                  break;
                case "y":
                  var S = M;
                  g2 = !m2("y", 2), M = S, h = x("y", 2);
                  break;
                case "Y":
                  h = x("Y", 2);
                  break;
                case "J":
                  f2 = x("J") + 0.5, "." === e3.charAt(A) && (A++, x("J"));
                  break;
                case "@":
                  f2 = x("@") / this.SECS_PER_DAY + this.UNIX_EPOCH;
                  break;
                case "!":
                  f2 = x("!") / this.TICKS_PER_DAY + this.TICKS_EPOCH;
                  break;
                case "*":
                  A = e3.length;
                  break;
                case "'":
                  m2("'") ? k() : y = true;
                  break;
                default:
                  k();
              }
          if (A < e3.length)
            throw i.local.unexpectedText || i.regionalOptions[""].unexpectedText;
          if (-1 === h ? h = this.today().year() : h < 100 && g2 && (h += -1 === n3 ? 1900 : this.today().year() - this.today().year() % 100 - (h <= n3 ? 0 : 100)), "string" == typeof p2 && (p2 = s.call(this, h, p2)), v > -1) {
            p2 = 1, d2 = v;
            for (var E = this.daysInMonth(h, p2); d2 > E; E = this.daysInMonth(h, p2))
              p2++, d2 -= E;
          }
          return f2 > -1 ? this.fromJD(f2) : this.newDate(h, p2, d2);
        }, determineDate: function(t3, e3, r3, n3, i2) {
          r3 && "object" != typeof r3 && (i2 = n3, n3 = r3, r3 = null), "string" != typeof n3 && (i2 = n3, n3 = "");
          var a = this;
          return e3 = e3 ? e3.newDate() : null, null == t3 ? e3 : "string" == typeof t3 ? function(t4) {
            try {
              return a.parseDate(n3, t4, i2);
            } catch (t5) {
            }
            for (var e4 = ((t4 = t4.toLowerCase()).match(/^c/) && r3 ? r3.newDate() : null) || a.today(), o = /([+-]?[0-9]+)\s*(d|w|m|y)?/g, s = o.exec(t4); s; )
              e4.add(parseInt(s[1], 10), s[2] || "d"), s = o.exec(t4);
            return e4;
          }(t3) : "number" == typeof t3 ? isNaN(t3) || t3 === 1 / 0 || t3 === -1 / 0 ? e3 : a.today().add(t3, "d") : a.newDate(t3);
        } });
      }, 69862: function() {
      }, 40964: function() {
      }, 72077: function(t2, e2, r2) {
        var n2 = ["BigInt64Array", "BigUint64Array", "Float32Array", "Float64Array", "Int16Array", "Int32Array", "Int8Array", "Uint16Array", "Uint32Array", "Uint8Array", "Uint8ClampedArray"], i = "undefined" == typeof globalThis ? r2.g : globalThis;
        t2.exports = function() {
          for (var t3 = [], e3 = 0; e3 < n2.length; e3++)
            "function" == typeof i[n2[e3]] && (t3[t3.length] = n2[e3]);
          return t3;
        };
      }, 81684: function(t2, e2, r2) {
        function n2(t3, e3, r3) {
          t3.prototype = e3.prototype = r3, r3.constructor = t3;
        }
        function i(t3, e3) {
          var r3 = Object.create(t3.prototype);
          for (var n3 in e3)
            r3[n3] = e3[n3];
          return r3;
        }
        function a() {
        }
        r2.d(e2, { sX: function() {
          return Q;
        }, k4: function() {
          return G;
        } });
        var o = 0.7, s = 1 / o, l = "\\s*([+-]?\\d+)\\s*", u = "\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)\\s*", c = "\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)%\\s*", f2 = /^#([0-9a-f]{3,8})$/, h = new RegExp("^rgb\\(".concat(l, ",").concat(l, ",").concat(l, "\\)$")), p2 = new RegExp("^rgb\\(".concat(c, ",").concat(c, ",").concat(c, "\\)$")), d2 = new RegExp("^rgba\\(".concat(l, ",").concat(l, ",").concat(l, ",").concat(u, "\\)$")), v = new RegExp("^rgba\\(".concat(c, ",").concat(c, ",").concat(c, ",").concat(u, "\\)$")), g2 = new RegExp("^hsl\\(".concat(u, ",").concat(c, ",").concat(c, "\\)$")), y = new RegExp("^hsla\\(".concat(u, ",").concat(c, ",").concat(c, ",").concat(u, "\\)$")), m2 = { aliceblue: 15792383, antiquewhite: 16444375, aqua: 65535, aquamarine: 8388564, azure: 15794175, beige: 16119260, bisque: 16770244, black: 0, blanchedalmond: 16772045, blue: 255, blueviolet: 9055202, brown: 10824234, burlywood: 14596231, cadetblue: 6266528, chartreuse: 8388352, chocolate: 13789470, coral: 16744272, cornflowerblue: 6591981, cornsilk: 16775388, crimson: 14423100, cyan: 65535, darkblue: 139, darkcyan: 35723, darkgoldenrod: 12092939, darkgray: 11119017, darkgreen: 25600, darkgrey: 11119017, darkkhaki: 12433259, darkmagenta: 9109643, darkolivegreen: 5597999, darkorange: 16747520, darkorchid: 10040012, darkred: 9109504, darksalmon: 15308410, darkseagreen: 9419919, darkslateblue: 4734347, darkslategray: 3100495, darkslategrey: 3100495, darkturquoise: 52945, darkviolet: 9699539, deeppink: 16716947, deepskyblue: 49151, dimgray: 6908265, dimgrey: 6908265, dodgerblue: 2003199, firebrick: 11674146, floralwhite: 16775920, forestgreen: 2263842, fuchsia: 16711935, gainsboro: 14474460, ghostwhite: 16316671, gold: 16766720, goldenrod: 14329120, gray: 8421504, green: 32768, greenyellow: 11403055, grey: 8421504, honeydew: 15794160, hotpink: 16738740, indianred: 13458524, indigo: 4915330, ivory: 16777200, khaki: 15787660, lavender: 15132410, lavenderblush: 16773365, lawngreen: 8190976, lemonchiffon: 16775885, lightblue: 11393254, lightcoral: 15761536, lightcyan: 14745599, lightgoldenrodyellow: 16448210, lightgray: 13882323, lightgreen: 9498256, lightgrey: 13882323, lightpink: 16758465, lightsalmon: 16752762, lightseagreen: 2142890, lightskyblue: 8900346, lightslategray: 7833753, lightslategrey: 7833753, lightsteelblue: 11584734, lightyellow: 16777184, lime: 65280, limegreen: 3329330, linen: 16445670, magenta: 16711935, maroon: 8388608, mediumaquamarine: 6737322, mediumblue: 205, mediumorchid: 12211667, mediumpurple: 9662683, mediumseagreen: 3978097, mediumslateblue: 8087790, mediumspringgreen: 64154, mediumturquoise: 4772300, mediumvioletred: 13047173, midnightblue: 1644912, mintcream: 16121850, mistyrose: 16770273, moccasin: 16770229, navajowhite: 16768685, navy: 128, oldlace: 16643558, olive: 8421376, olivedrab: 7048739, orange: 16753920, orangered: 16729344, orchid: 14315734, palegoldenrod: 15657130, palegreen: 10025880, paleturquoise: 11529966, palevioletred: 14381203, papayawhip: 16773077, peachpuff: 16767673, peru: 13468991, pink: 16761035, plum: 14524637, powderblue: 11591910, purple: 8388736, rebeccapurple: 6697881, red: 16711680, rosybrown: 12357519, royalblue: 4286945, saddlebrown: 9127187, salmon: 16416882, sandybrown: 16032864, seagreen: 3050327, seashell: 16774638, sienna: 10506797, silver: 12632256, skyblue: 8900331, slateblue: 6970061, slategray: 7372944, slategrey: 7372944, snow: 16775930, springgreen: 65407, steelblue: 4620980, tan: 13808780, teal: 32896, thistle: 14204888, tomato: 16737095, turquoise: 4251856, violet: 15631086, wheat: 16113331, white: 16777215, whitesmoke: 16119285, yellow: 16776960, yellowgreen: 10145074 };
        function x() {
          return this.rgb().formatHex();
        }
        function b() {
          return this.rgb().formatRgb();
        }
        function _(t3) {
          var e3, r3;
          return t3 = (t3 + "").trim().toLowerCase(), (e3 = f2.exec(t3)) ? (r3 = e3[1].length, e3 = parseInt(e3[1], 16), 6 === r3 ? w2(e3) : 3 === r3 ? new M(e3 >> 8 & 15 | e3 >> 4 & 240, e3 >> 4 & 15 | 240 & e3, (15 & e3) << 4 | 15 & e3, 1) : 8 === r3 ? T(e3 >> 24 & 255, e3 >> 16 & 255, e3 >> 8 & 255, (255 & e3) / 255) : 4 === r3 ? T(e3 >> 12 & 15 | e3 >> 8 & 240, e3 >> 8 & 15 | e3 >> 4 & 240, e3 >> 4 & 15 | 240 & e3, ((15 & e3) << 4 | 15 & e3) / 255) : null) : (e3 = h.exec(t3)) ? new M(e3[1], e3[2], e3[3], 1) : (e3 = p2.exec(t3)) ? new M(255 * e3[1] / 100, 255 * e3[2] / 100, 255 * e3[3] / 100, 1) : (e3 = d2.exec(t3)) ? T(e3[1], e3[2], e3[3], e3[4]) : (e3 = v.exec(t3)) ? T(255 * e3[1] / 100, 255 * e3[2] / 100, 255 * e3[3] / 100, e3[4]) : (e3 = g2.exec(t3)) ? O(e3[1], e3[2] / 100, e3[3] / 100, 1) : (e3 = y.exec(t3)) ? O(e3[1], e3[2] / 100, e3[3] / 100, e3[4]) : m2.hasOwnProperty(t3) ? w2(m2[t3]) : "transparent" === t3 ? new M(NaN, NaN, NaN, 0) : null;
        }
        function w2(t3) {
          return new M(t3 >> 16 & 255, t3 >> 8 & 255, 255 & t3, 1);
        }
        function T(t3, e3, r3, n3) {
          return n3 <= 0 && (t3 = e3 = r3 = NaN), new M(t3, e3, r3, n3);
        }
        function k(t3) {
          return t3 instanceof a || (t3 = _(t3)), t3 ? new M((t3 = t3.rgb()).r, t3.g, t3.b, t3.opacity) : new M();
        }
        function A(t3, e3, r3, n3) {
          return 1 === arguments.length ? k(t3) : new M(t3, e3, r3, null == n3 ? 1 : n3);
        }
        function M(t3, e3, r3, n3) {
          this.r = +t3, this.g = +e3, this.b = +r3, this.opacity = +n3;
        }
        function S() {
          return "#".concat(P(this.r)).concat(P(this.g)).concat(P(this.b));
        }
        function E() {
          var t3 = L(this.opacity);
          return "".concat(1 === t3 ? "rgb(" : "rgba(").concat(C(this.r), ", ").concat(C(this.g), ", ").concat(C(this.b)).concat(1 === t3 ? ")" : ", ".concat(t3, ")"));
        }
        function L(t3) {
          return isNaN(t3) ? 1 : Math.max(0, Math.min(1, t3));
        }
        function C(t3) {
          return Math.max(0, Math.min(255, Math.round(t3) || 0));
        }
        function P(t3) {
          return ((t3 = C(t3)) < 16 ? "0" : "") + t3.toString(16);
        }
        function O(t3, e3, r3, n3) {
          return n3 <= 0 ? t3 = e3 = r3 = NaN : r3 <= 0 || r3 >= 1 ? t3 = e3 = NaN : e3 <= 0 && (t3 = NaN), new D(t3, e3, r3, n3);
        }
        function I(t3) {
          if (t3 instanceof D)
            return new D(t3.h, t3.s, t3.l, t3.opacity);
          if (t3 instanceof a || (t3 = _(t3)), !t3)
            return new D();
          if (t3 instanceof D)
            return t3;
          var e3 = (t3 = t3.rgb()).r / 255, r3 = t3.g / 255, n3 = t3.b / 255, i2 = Math.min(e3, r3, n3), o2 = Math.max(e3, r3, n3), s2 = NaN, l2 = o2 - i2, u2 = (o2 + i2) / 2;
          return l2 ? (s2 = e3 === o2 ? (r3 - n3) / l2 + 6 * (r3 < n3) : r3 === o2 ? (n3 - e3) / l2 + 2 : (e3 - r3) / l2 + 4, l2 /= u2 < 0.5 ? o2 + i2 : 2 - o2 - i2, s2 *= 60) : l2 = u2 > 0 && u2 < 1 ? 0 : s2, new D(s2, l2, u2, t3.opacity);
        }
        function D(t3, e3, r3, n3) {
          this.h = +t3, this.s = +e3, this.l = +r3, this.opacity = +n3;
        }
        function z(t3) {
          return (t3 = (t3 || 0) % 360) < 0 ? t3 + 360 : t3;
        }
        function R(t3) {
          return Math.max(0, Math.min(1, t3 || 0));
        }
        function F(t3, e3, r3) {
          return 255 * (t3 < 60 ? e3 + (r3 - e3) * t3 / 60 : t3 < 180 ? r3 : t3 < 240 ? e3 + (r3 - e3) * (240 - t3) / 60 : e3);
        }
        n2(a, _, { copy: function(t3) {
          return Object.assign(new this.constructor(), this, t3);
        }, displayable: function() {
          return this.rgb().displayable();
        }, hex: x, formatHex: x, formatHex8: function() {
          return this.rgb().formatHex8();
        }, formatHsl: function() {
          return I(this).formatHsl();
        }, formatRgb: b, toString: b }), n2(M, A, i(a, { brighter: function(t3) {
          return t3 = null == t3 ? s : Math.pow(s, t3), new M(this.r * t3, this.g * t3, this.b * t3, this.opacity);
        }, darker: function(t3) {
          return t3 = null == t3 ? o : Math.pow(o, t3), new M(this.r * t3, this.g * t3, this.b * t3, this.opacity);
        }, rgb: function() {
          return this;
        }, clamp: function() {
          return new M(C(this.r), C(this.g), C(this.b), L(this.opacity));
        }, displayable: function() {
          return -0.5 <= this.r && this.r < 255.5 && -0.5 <= this.g && this.g < 255.5 && -0.5 <= this.b && this.b < 255.5 && 0 <= this.opacity && this.opacity <= 1;
        }, hex: S, formatHex: S, formatHex8: function() {
          return "#".concat(P(this.r)).concat(P(this.g)).concat(P(this.b)).concat(P(255 * (isNaN(this.opacity) ? 1 : this.opacity)));
        }, formatRgb: E, toString: E })), n2(D, function(t3, e3, r3, n3) {
          return 1 === arguments.length ? I(t3) : new D(t3, e3, r3, null == n3 ? 1 : n3);
        }, i(a, { brighter: function(t3) {
          return t3 = null == t3 ? s : Math.pow(s, t3), new D(this.h, this.s, this.l * t3, this.opacity);
        }, darker: function(t3) {
          return t3 = null == t3 ? o : Math.pow(o, t3), new D(this.h, this.s, this.l * t3, this.opacity);
        }, rgb: function() {
          var t3 = this.h % 360 + 360 * (this.h < 0), e3 = isNaN(t3) || isNaN(this.s) ? 0 : this.s, r3 = this.l, n3 = r3 + (r3 < 0.5 ? r3 : 1 - r3) * e3, i2 = 2 * r3 - n3;
          return new M(F(t3 >= 240 ? t3 - 240 : t3 + 120, i2, n3), F(t3, i2, n3), F(t3 < 120 ? t3 + 240 : t3 - 120, i2, n3), this.opacity);
        }, clamp: function() {
          return new D(z(this.h), R(this.s), R(this.l), L(this.opacity));
        }, displayable: function() {
          return (0 <= this.s && this.s <= 1 || isNaN(this.s)) && 0 <= this.l && this.l <= 1 && 0 <= this.opacity && this.opacity <= 1;
        }, formatHsl: function() {
          var t3 = L(this.opacity);
          return "".concat(1 === t3 ? "hsl(" : "hsla(").concat(z(this.h), ", ").concat(100 * R(this.s), "%, ").concat(100 * R(this.l), "%").concat(1 === t3 ? ")" : ", ".concat(t3, ")"));
        } }));
        var N = function(t3) {
          return function() {
            return t3;
          };
        };
        function j(t3, e3) {
          var r3 = e3 - t3;
          return r3 ? function(t4, e4) {
            return function(r4) {
              return t4 + r4 * e4;
            };
          }(t3, r3) : N(isNaN(t3) ? e3 : t3);
        }
        var U = function t3(e3) {
          var r3 = function(t4) {
            return 1 == (t4 = +t4) ? j : function(e4, r4) {
              return r4 - e4 ? function(t5, e5, r5) {
                return t5 = Math.pow(t5, r5), e5 = Math.pow(e5, r5) - t5, r5 = 1 / r5, function(n4) {
                  return Math.pow(t5 + n4 * e5, r5);
                };
              }(e4, r4, t4) : N(isNaN(e4) ? r4 : e4);
            };
          }(e3);
          function n3(t4, e4) {
            var n4 = r3((t4 = A(t4)).r, (e4 = A(e4)).r), i2 = r3(t4.g, e4.g), a2 = r3(t4.b, e4.b), o2 = j(t4.opacity, e4.opacity);
            return function(e5) {
              return t4.r = n4(e5), t4.g = i2(e5), t4.b = a2(e5), t4.opacity = o2(e5), t4 + "";
            };
          }
          return n3.gamma = t3, n3;
        }(1);
        function H(t3, e3) {
          var r3, n3 = e3 ? e3.length : 0, i2 = t3 ? Math.min(n3, t3.length) : 0, a2 = new Array(i2), o2 = new Array(n3);
          for (r3 = 0; r3 < i2; ++r3)
            a2[r3] = Q(t3[r3], e3[r3]);
          for (; r3 < n3; ++r3)
            o2[r3] = e3[r3];
          return function(t4) {
            for (r3 = 0; r3 < i2; ++r3)
              o2[r3] = a2[r3](t4);
            return o2;
          };
        }
        function q2(t3, e3) {
          var r3 = new Date();
          return t3 = +t3, e3 = +e3, function(n3) {
            return r3.setTime(t3 * (1 - n3) + e3 * n3), r3;
          };
        }
        function G(t3, e3) {
          return t3 = +t3, e3 = +e3, function(r3) {
            return t3 * (1 - r3) + e3 * r3;
          };
        }
        function Z(t3) {
          return Z = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(t4) {
            return typeof t4;
          } : function(t4) {
            return t4 && "function" == typeof Symbol && t4.constructor === Symbol && t4 !== Symbol.prototype ? "symbol" : typeof t4;
          }, Z(t3);
        }
        function Y(t3, e3) {
          var r3, n3 = {}, i2 = {};
          for (r3 in null !== t3 && "object" === Z(t3) || (t3 = {}), null !== e3 && "object" === Z(e3) || (e3 = {}), e3)
            r3 in t3 ? n3[r3] = Q(t3[r3], e3[r3]) : i2[r3] = e3[r3];
          return function(t4) {
            for (r3 in n3)
              i2[r3] = n3[r3](t4);
            return i2;
          };
        }
        var W = /[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g, X = new RegExp(W.source, "g");
        function J(t3, e3) {
          var r3, n3, i2, a2 = W.lastIndex = X.lastIndex = 0, o2 = -1, s2 = [], l2 = [];
          for (t3 += "", e3 += ""; (r3 = W.exec(t3)) && (n3 = X.exec(e3)); )
            (i2 = n3.index) > a2 && (i2 = e3.slice(a2, i2), s2[o2] ? s2[o2] += i2 : s2[++o2] = i2), (r3 = r3[0]) === (n3 = n3[0]) ? s2[o2] ? s2[o2] += n3 : s2[++o2] = n3 : (s2[++o2] = null, l2.push({ i: o2, x: G(r3, n3) })), a2 = X.lastIndex;
          return a2 < e3.length && (i2 = e3.slice(a2), s2[o2] ? s2[o2] += i2 : s2[++o2] = i2), s2.length < 2 ? l2[0] ? function(t4) {
            return function(e4) {
              return t4(e4) + "";
            };
          }(l2[0].x) : function(t4) {
            return function() {
              return t4;
            };
          }(e3) : (e3 = l2.length, function(t4) {
            for (var r4, n4 = 0; n4 < e3; ++n4)
              s2[(r4 = l2[n4]).i] = r4.x(t4);
            return s2.join("");
          });
        }
        function K(t3, e3) {
          e3 || (e3 = []);
          var r3, n3 = t3 ? Math.min(e3.length, t3.length) : 0, i2 = e3.slice();
          return function(a2) {
            for (r3 = 0; r3 < n3; ++r3)
              i2[r3] = t3[r3] * (1 - a2) + e3[r3] * a2;
            return i2;
          };
        }
        function $(t3) {
          return $ = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(t4) {
            return typeof t4;
          } : function(t4) {
            return t4 && "function" == typeof Symbol && t4.constructor === Symbol && t4 !== Symbol.prototype ? "symbol" : typeof t4;
          }, $(t3);
        }
        function Q(t3, e3) {
          var r3, n3, i2 = $(e3);
          return null == e3 || "boolean" === i2 ? N(e3) : ("number" === i2 ? G : "string" === i2 ? (r3 = _(e3)) ? (e3 = r3, U) : J : e3 instanceof _ ? U : e3 instanceof Date ? q2 : (n3 = e3, !ArrayBuffer.isView(n3) || n3 instanceof DataView ? Array.isArray(e3) ? H : "function" != typeof e3.valueOf && "function" != typeof e3.toString || isNaN(e3) ? Y : G : K))(t3, e3);
        }
      }, 40402: function(t2) {
        t2.exports = JSON.parse('["xx-small","x-small","small","medium","large","x-large","xx-large","larger","smaller"]');
      }, 83794: function(t2) {
        t2.exports = JSON.parse('["normal","condensed","semi-condensed","extra-condensed","ultra-condensed","expanded","semi-expanded","extra-expanded","ultra-expanded"]');
      }, 96209: function(t2) {
        t2.exports = JSON.parse('["normal","italic","oblique"]');
      }, 15659: function(t2) {
        t2.exports = JSON.parse('["normal","bold","bolder","lighter","100","200","300","400","500","600","700","800","900"]');
      }, 38732: function(t2) {
        t2.exports = JSON.parse('["inherit","initial","unset"]');
      }, 41901: function(t2) {
        t2.exports = JSON.parse('["caption","icon","menu","message-box","small-caption","status-bar"]');
      } }, e = {};
      function r(n2) {
        var i = e[n2];
        if (void 0 !== i)
          return i.exports;
        var a = e[n2] = { exports: {} };
        return t[n2].call(a.exports, a, a.exports, r), a.exports;
      }
      return r.n = function(t2) {
        var e2 = t2 && t2.__esModule ? function() {
          return t2.default;
        } : function() {
          return t2;
        };
        return r.d(e2, { a: e2 }), e2;
      }, r.d = function(t2, e2) {
        for (var n2 in e2)
          r.o(e2, n2) && !r.o(t2, n2) && Object.defineProperty(t2, n2, { enumerable: true, get: e2[n2] });
      }, r.g = function() {
        if ("object" == typeof globalThis)
          return globalThis;
        try {
          return this || new Function("return this")();
        } catch (t2) {
          if ("object" == typeof window)
            return window;
        }
      }(), r.o = function(t2, e2) {
        return Object.prototype.hasOwnProperty.call(t2, e2);
      }, r.r = function(t2) {
        "undefined" != typeof Symbol && Symbol.toStringTag && Object.defineProperty(t2, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(t2, "__esModule", { value: true });
      }, r(27909);
    }();
  });
})(plotly_min);
const Plotly = /* @__PURE__ */ getDefaultExportFromCjs(plotly_minExports);
const Plot = createPlotlyComponent(Plotly);
const log$1 = Log$7.module("@deephaven/js-plugin-plotly-express.Chart");
class Chart extends React.Component {
  constructor(props) {
    super(props);
    __publicField(this, "plot");
    __publicField(this, "plotWrapper");
    __publicField(this, "rect");
    __publicField(this, "isSubscribed");
    __publicField(this, "isLoadedFired");
    __publicField(this, "getCachedConfig", memoizeOne((is3d) => {
      return {
        displaylogo: false,
        displayModeBar: "hover",
        // Each array gets grouped together in the mode bar
        modeBarButtons: [
          ["toImage"],
          is3d ? ["zoom3d", "pan3d"] : ["zoom2d", "pan2d"],
          is3d ? ["orbitRotation", "tableRotation", "resetCameraDefault3d"] : ["zoomIn2d", "zoomOut2d", "autoScale2d", "resetScale2d"]
        ]
      };
    }));
    this.handleModelEvent = this.handleModelEvent.bind(this);
    this.plot = React.createRef();
    this.plotWrapper = React.createRef();
    this.isSubscribed = false;
    this.isLoadedFired = false;
    this.state = {
      data: null,
      layout: {
        datarevision: 0
      },
      revision: 0
    };
  }
  /**
   * Convert a font awesome icon definition to a plotly icon definition
   * @param faIcon The icon to convert
   */
  static convertIcon(faIcon) {
    const [width, , , , path] = faIcon.icon;
    const stringPath = `${path}`;
    return {
      width,
      path: stringPath,
      ascent: width,
      descent: 0,
      transform: `matrix(1, 0, 0, 1, 0, 0)`
    };
  }
  componentDidMount() {
    this.updateDimensions();
    this.initData();
    const { isActive } = this.props;
    if (isActive) {
      this.subscribe();
    }
  }
  componentDidUpdate(prevProps) {
    const { isActive } = this.props;
    if (isActive !== prevProps.isActive) {
      if (isActive) {
        this.subscribe();
      } else {
        this.unsubscribe();
      }
    }
  }
  componentWillUnmount() {
    this.unsubscribe();
  }
  getPlotRect() {
    var _a;
    return ((_a = this.plotWrapper.current) == null ? void 0 : _a.getBoundingClientRect()) ?? null;
  }
  initData() {
    const { model } = this.props;
    const { layout } = this.state;
    this.setState({
      data: model.getData(),
      layout: {
        ...layout,
        ...model.getLayout()
      }
    });
  }
  subscribe() {
    if (this.isSubscribed || !this.props.isActive) {
      return;
    }
    const { model } = this.props;
    const rect = this.getPlotRect();
    if (!rect || rect.width === 0 || rect.height === 0) {
      log$1.debug2("Delaying subscription until model dimensions are set");
      return;
    }
    model.subscribe(this.handleModelEvent);
    this.isSubscribed = true;
  }
  unsubscribe() {
    if (!this.isSubscribed) {
      return;
    }
    const { model } = this.props;
    model.unsubscribe(this.handleModelEvent);
    this.isSubscribed = false;
  }
  handleModelEvent(event) {
    const { type, detail } = event;
    log$1.debug2("Received data update", type, detail);
    switch (type) {
      case PlotlyExpressChartModel.EVENT_UPDATED: {
        this.setState((state) => {
          const { layout, revision } = state;
          if (typeof layout.datarevision === "number") {
            layout.datarevision += 1;
          }
          return {
            data: detail,
            layout,
            revision: revision + 1
          };
        });
        const { onUpdate: onUpdate2 } = this.props;
        onUpdate2({ isLoading: !this.isLoadedFired });
        break;
      }
      case PlotlyExpressChartModel.EVENT_LOADFINISHED: {
        const { onUpdate: onUpdate2 } = this.props;
        this.isLoadedFired = true;
        onUpdate2({ isLoading: false });
        break;
      }
      case PlotlyExpressChartModel.EVENT_DISCONNECT: {
        const { onDisconnect } = this.props;
        onDisconnect();
        break;
      }
      case PlotlyExpressChartModel.EVENT_RECONNECT: {
        const { onReconnect } = this.props;
        onReconnect();
        break;
      }
      default:
        log$1.debug("Unknown event type", type, event);
    }
  }
  updateDimensions() {
    const rect = this.getPlotRect();
    if (this.plot.current != null && rect != null && rect.width > 0 && rect.height > 0) {
      this.subscribe();
      Plotly.relayout(this.plot.current.el, { autosize: true }).catch(
        (e) => {
          log$1.debug("Unable to resize, promise rejected", e);
        }
      );
    }
  }
  render() {
    var _a;
    const { data, layout, revision } = this.state;
    const config2 = this.getCachedConfig(
      ((_a = data == null ? void 0 : data[0].type) == null ? void 0 : _a.includes("3d")) ?? false
    );
    const isPlotShown = data != null;
    return /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: "h-100 w-100 chart-wrapper", ref: this.plotWrapper, children: isPlotShown && /* @__PURE__ */ jsxRuntimeExports.jsx(
      Plot,
      {
        ref: this.plot,
        data,
        layout,
        revision,
        config: config2,
        onError: log$1.error,
        useResizeHandler: true,
        style: { height: "100%", width: "100%" }
      }
    ) });
  }
}
__publicField(Chart, "defaultProps", {
  isActive: true,
  onDisconnect: () => void 0,
  onReconnect: () => void 0,
  onUpdate: () => void 0,
  onError: () => void 0
});
const log = Log$7.module("@deephaven/js-plugin-plotly-express.ChartPanel");
class ChartPanel extends React.Component {
  constructor(props) {
    super(props);
    __publicField(this, "panelContainer");
    __publicField(this, "chart");
    __publicField(this, "pending");
    this.handleDisconnect = this.handleDisconnect.bind(this);
    this.handleReconnect = this.handleReconnect.bind(this);
    this.handleError = this.handleError.bind(this);
    this.handleLoadError = this.handleLoadError.bind(this);
    this.handleLoadSuccess = this.handleLoadSuccess.bind(this);
    this.handleUpdate = this.handleUpdate.bind(this);
    this.handleHide = this.handleHide.bind(this);
    this.handleShow = this.handleShow.bind(this);
    this.handleResize = this.handleResize.bind(this);
    this.panelContainer = React.createRef();
    this.chart = React.createRef();
    this.pending = new Pending$1();
    this.state = {
      error: void 0,
      isActive: false,
      isDisconnected: false,
      isLoading: false,
      isLoaded: false,
      model: void 0
    };
  }
  componentDidMount() {
    if (!this.isHidden()) {
      this.setState({ isActive: true });
      this.initModel();
    }
  }
  componentWillUnmount() {
    this.pending.cancel();
  }
  initModel() {
    this.setState({ isLoading: true, isLoaded: false, error: void 0 });
    const { makeModel } = this.props;
    this.pending.add(makeModel(), (resolved) => {
      resolved.close();
    }).then(this.handleLoadSuccess, this.handleLoadError);
  }
  loadModelIfNecessary() {
    const { isActive, isLoaded, isLoading } = this.state;
    if (isActive && !isLoaded && !isLoading) {
      this.initModel();
    }
  }
  isHidden() {
    const { glContainer } = this.props;
    const { isHidden } = glContainer;
    return isHidden;
  }
  handleDisconnect() {
    this.setState({
      error: new Error("Figure disconnected"),
      isDisconnected: true
    });
  }
  handleReconnect() {
    this.setState({ isDisconnected: false, error: void 0 });
  }
  handleLoadSuccess(model) {
    log.debug("handleLoadSuccess");
    this.setState({
      model,
      isLoaded: true
    });
  }
  handleLoadError(error) {
    if (PromiseUtils$1.isCanceled(error)) {
      return;
    }
    log.error("handleLoadError", error);
    this.setState({ error, isLoading: false });
  }
  handleError() {
    this.setState({ isLoading: false });
  }
  handleUpdate() {
    this.setState({ isLoading: false });
  }
  handleHide() {
    this.setActive(false);
  }
  handleShow() {
    this.setActive(true);
  }
  handleResize() {
    this.updateChart();
  }
  setActive(isActive) {
    if (isActive === this.state.isActive) {
      return;
    }
    this.setState({ isActive }, () => {
      if (isActive) {
        this.loadModelIfNecessary();
        this.updateChart();
      }
    });
  }
  updateChart() {
    if (this.chart.current) {
      this.chart.current.updateDimensions();
    }
  }
  render() {
    const { glContainer, glEventHub, metadata } = this.props;
    const { model, isActive, isLoading, isLoaded, isDisconnected, error } = this.state;
    const { name: name2 } = metadata;
    const errorMessage = error != null ? `Unable to open chart. ${error}` : void 0;
    return /* @__PURE__ */ jsxRuntimeExports.jsx(
      WidgetPanel$1,
      {
        className: "iris-chart-panel",
        componentPanel: this,
        glContainer,
        glEventHub,
        onHide: this.handleHide,
        onResize: this.handleResize,
        onShow: this.handleShow,
        onTabBlur: this.handleHide,
        onTabFocus: this.handleShow,
        errorMessage,
        isDisconnected,
        isLoading,
        isLoaded,
        widgetName: name2,
        widgetType: "Chart",
        children: /* @__PURE__ */ jsxRuntimeExports.jsx(
          "div",
          {
            ref: this.panelContainer,
            className: "chart-panel-container h-100 w-100",
            children: /* @__PURE__ */ jsxRuntimeExports.jsx("div", { className: "chart-container h-100 w-100", children: isLoaded && model && /* @__PURE__ */ jsxRuntimeExports.jsx(
              Chart,
              {
                isActive,
                model,
                ref: this.chart,
                onDisconnect: this.handleDisconnect,
                onReconnect: this.handleReconnect,
                onUpdate: this.handleUpdate,
                onError: this.handleError
              }
            ) })
          }
        )
      }
    );
  }
}
__publicField(ChartPanel, "displayName", "PlotlyExpressChartPanel");
__publicField(ChartPanel, "COMPONENT", "@deephaven/js-plugin-plotly-express.ChartPanel");
function getWidgetData(widgetInfo) {
  return JSON.parse(atob(widgetInfo.getDataAsBase64()));
}
async function getDataMappings(widgetInfo) {
  const data = getWidgetData(widgetInfo);
  const tables = await Promise.all(
    widgetInfo.exportedObjects.map((obj) => obj.fetch())
  );
  const tableColumnReplacementMap = /* @__PURE__ */ new Map();
  tables.forEach((table) => tableColumnReplacementMap.set(table, /* @__PURE__ */ new Map()));
  data.deephaven.mappings.forEach(
    ({ table: tableIndex, data_columns: dataColumns }) => {
      const table = tables[tableIndex];
      const existingColumnMap = tableColumnReplacementMap.get(table);
      assertNotNull$2(existingColumnMap);
      Object.entries(dataColumns).forEach(([columnName, paths]) => {
        const existingPaths = existingColumnMap.get(columnName);
        if (existingPaths !== void 0) {
          existingPaths.push(...paths);
        } else {
          existingColumnMap.set(columnName, [...paths]);
        }
      });
    }
  );
  return tableColumnReplacementMap;
}
async function makePlotlyModelFromSettings(tableColumnReplacementMap, plotlyConfig, isDefaultTemplate = true, theme = ChartTheme) {
  return new PlotlyExpressChartModel(
    tableColumnReplacementMap,
    plotlyConfig.data,
    plotlyConfig.layout ?? {},
    isDefaultTemplate,
    theme
  );
}
const PlotlyExpressChartPanel = React.forwardRef((props, forwardedRef) => {
  const { fetch, ...rest } = props;
  const makeModel = React.useCallback(async () => {
    const widgetInfo = await fetch();
    const data = getWidgetData(widgetInfo);
    const tableColumnReplacementMap = await getDataMappings(widgetInfo);
    return makePlotlyModelFromSettings(
      tableColumnReplacementMap,
      data.plotly,
      !data.deephaven.is_user_set_template
    );
  }, [fetch]);
  return /* @__PURE__ */ jsxRuntimeExports.jsx(ChartPanel, { ref: forwardedRef, ...rest, makeModel });
});
function DashboardPlugin(props) {
  const { id, layout, registerComponent } = props;
  const handlePanelOpen = React.useCallback(
    async ({
      dragEvent,
      fetch,
      panelId = shortid.generate(),
      widget
    }) => {
      const { type, title } = widget;
      if (type !== "deephaven.plot.express.DeephavenFigure") {
        return;
      }
      const metadata = { name: title, figure: title, type };
      const config2 = {
        type: "react-component",
        component: "PlotlyPanel",
        props: {
          localDashboardId: id,
          id: panelId,
          metadata,
          fetch
        },
        title,
        id: panelId
      };
      const { root: root2 } = layout;
      LayoutUtils$1.openComponent({ root: root2, config: config2, dragEvent });
    },
    [id, layout]
  );
  React.useEffect(
    function registerComponentsAndReturnCleanup() {
      const cleanups = [
        registerComponent("PlotlyPanel", PlotlyExpressChartPanel)
      ];
      return () => {
        cleanups.forEach((cleanup) => cleanup());
      };
    },
    [registerComponent]
  );
  useListener(layout.eventHub, PanelEvent$1.OPEN, handlePanelOpen);
  return null;
}
exports.DashboardPlugin = DashboardPlugin;
